<?php
// (c) Copyright by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// The original strings (English) are case-sensitive.

/* Note for translators about translation of text ending with punctuation
 *
 * The current list of concerned punctuation can be found in 'lib/init/tra.php'
 * On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
 * For clarity, we explain here only for colons: ':' but it is the same for the rest
 *
 * Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
 *
 * Technical justification:
 * If a string ending with colon needs translating (like "{tr}Login:{/tr}")
 * then Tiki tries to translate 'Login' and ':' separately.
 * This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
 * and it still allows to translate ":" as " :" for languages that
 * need it (like French)
 * Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
 * This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.
 */
$lang = array(
"Welsh" => "Gal·lès",
"Slovene" => "Eslovè",
"Arabic" => "Àrab",
"Bulgarian" => "Búlgar",
"Catalan" => "Català",
"Simplified Chinese" => "Xinès Simplificat",
"Czech" => "Txec",
"Danish" => "Danès",
"German" => "Alemany",
"English" => "Anglès",
"English British" => "Anglès Britànic",
"Spanish" => "Castellà",
"Greek" => "Grec",
"Farsi" => "Farsi",
"Finnish" => "Finès",
"Fijian" => "Fijià",
"French" => "Francès",
"Frisian Netherlands" => "Frisia Holanda",
"Galician" => "Gallec",
"Hebrew" => "Hebreu",
"Croatian" => "Croat",
"Indonesian" => "Indonesi",
"Icelandic" => "Islandès",
"Italian" => "Italià",
"Inuktitut" => "Inuktitut",
"Inuktitut (Roman)" => "Inuktitut (Novel·la)",
"Iniunnaqtun" => "Iniunnaqtun",
"Japanese" => "Japonès",
"Korean" => "Coreà",
"Hungarian" => "Hongarès",
"Lithuanian" => "Lituà",
"Low German" => "Baix alemany",
"Dutch" => "Dels Països Baixos",
"Norwegian" => "Noruec",
"Polish" => "Polonès",
"Portuguese" => "Portuguès",
"Brazilian Portuguese" => "Portuguès-Brasiler",
"Romanian" => "Romanès",
"Romansh" => "Romanxe",
"Russian" => "Rus",
"Pijin Solomon" => "Pidgin de les illes Salomó",
"Sinhala" => "Singalès",
"Slovak" => "Eslovac",
"Albanian" => "Albanès",
"Serbian Latin" => "Serbi Llatí",
"Swedish" => "Suec",
// "Swahili" => "Swahili",
// "Thai" => "Thai",
"Tuvaluan" => "Tuvaluà",
"Turkish" => "Turc",
"Traditional Chinese" => "Xinés traditional",
"Ukrainian" => "Ukranià",
// "Urdu" => "Urdu",
"Vietnamese" => "Vietnamita",
"Afghanistan" => "Afganistan",
"Aland Islands" => "Illes_Aland",
"Aland_Islands" => "Aland_Islands",
"Albania" => "Albània",
"Algeria" => "Algèria",
"American Samoa" => "Samoa_Americana",
"American_Samoa" => "American_Samoa",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Armenia" => "Armènia",
"Aruba" => "Aruba",
"Australia" => "Austràlia",
"Austria" => "Àustria",
"Azerbaijan" => "Azerbaitjan",
"Bahamas" => "Bahames",
"Bahrain" => "Bahrain",
"Bangladesh" => "Bangla_Desh",
"Barbados" => "Barbados",
"Belarus" => "Bielorússia",
"Belgium" => "Bèlgica",
"Belize" => "Belize",
"Benin" => "Benín",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Bolivia" => "Bolívia",
"Bosnia and Herzegovina" => "Bosnia_i_Herzegovina",
"Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
"Botswana" => "Botswana",
"Bouvet Island" => "Illa_Bouvet",
"Bouvet_Island" => "Bouvet_Island",
"Brazil" => "Brasil",
"British Indian Ocean Territory" => "Territori_Britànic_de_l'Oceà_Índic",
"British Virgin Islands" => "Illes_Verge_Britàniques",
"British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
"British_Virgin_Islands" => "British_Virgin_Islands",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgària",
"Burkina Faso" => "Burkina_Faso",
"Burkina_Faso" => "Burkina_Faso",
"Burundi" => "Burundi",
"Cambodia" => "Cambodja",
"Cameroon" => "Camerun",
"Canada" => "Canadà",
"Cape Verde" => "Cap_Verd",
"Cape_Verde" => "Cape_Verde",
"Catalan Countries" => "Països_Catalans",
"Catalan_Countries" => "Països Catalans",
"Cayman Islands" => "Illes_Caiman",
"Cayman_Islands" => "Cayman_Islands",
"Central African Republic" => "República_Centreafricana",
"Central_African_Republic" => "Central_African_Republic",
"Chad" => "Txad",
"Chile" => "Xile",
"China" => "Xina",
"Christmas Island" => "Illa_Christmas",
"Christmas_Island" => "Christmas_Island",
"Cocos Islands" => "Illes_Cocos",
"Cocos_Islands" => "Cocos_Islands",
"Colombia" => "Colòmbia",
"Comoros" => "Comores",
"Democratic Republic of the Congo" => "Congo,_Repúlica_Democràtica",
"Democratic_Republic_of_the_Congo" => "Democratic_Republic_of_the_Congo",
"Congo" => "Congo",
"Cook Islands" => "Illes_Cook",
"Cook_Islands" => "Cook_Islands",
"Costa Rica" => "Costa_Rica",
"Costa_Rica" => "Costa_Rica",
"Croatia" => "Croàcia",
"Cuba" => "Cuba",
"Cyprus" => "Xipre",
"Czech Republic" => "República_Txeca",
"Czech_Republic" => "Czech_Republic",
"Denmark" => "Dinamarca",
"Djibouti" => "Djibouti",
"Dominica" => "Dominica",
"Dominican Republic" => "República_Dominicana",
"Dominican_Republic" => "República_Dominicana",
"Ecuador" => "Equador",
"Egypt" => "Egipte",
"El Salvador" => "El_Salvador",
"El_Salvador" => "El_Salvador",
// "England" => "England",
"Equatorial Guinea" => "Guinea_Equatorial",
"Equatorial_Guinea" => "Guinea_Equatorial",
"Eritrea" => "Eritrea",
"Estonia" => "Estònia",
"Ethiopia" => "Etiòpia",
"Europe" => "Europa",
"Falkland Islands" => "Illes_Malvines_(Falkland)",
"Falkland_Islands" => "Falkland_Islands",
"Faroe Islands" => "Illes_Fèroe",
"Faroe_Islands" => "Islas_Feroe",
"Federated States of Micronesia" => "Micronèsia,_Estats_Federats_de",
"Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
"Fiji" => "Fiji",
"Finland" => "Finlàndia",
"France" => "França",
"French Guiana" => "Guaiana_Francesa",
"French Polynesia" => "Polinèsia_Francesa",
"French Southern Territories" => "Territoris_Francesos_del_Sud",
"French_Guiana" => "French_Guiana",
"French_Polynesia" => "Polinesia_Francesa",
"French_Southern_Territories" => "French_Southern_Territories",
"Gabon" => "Gabon",
"Gambia" => "Gàmbia",
"Georgia" => "Geòrgia",
"Germany" => "Alemanya",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Greece" => "Grècia",
"Greenland" => "Groenlàndia",
"Grenada" => "Grenada",
"Guadeloupe" => "Guadalupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea Bissau" => "Guinea_Bissau",
"Guinea" => "Guinea",
"Guinea_Bissau" => "Guinea_Bissau",
"Guyana" => "Guyana",
"Haiti" => "Haití",
"Heard Island and McDonald Islands" => "Illa_Heard_i_Illes_McDonald",
"Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
"Honduras" => "Hondures",
"Hong Kong" => "Hong_Kong",
"Hong_Kong" => "Hong_Kong",
"Hungary" => "Hongria",
"Iceland" => "Islàndia",
"India" => "Índia",
"Indonesia" => "Indonèsia",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Ireland" => "Irlanda",
"Isle of Man" => "Illa de Man",
"Israel" => "Israel",
"Italy" => "Itàlia",
"Ivory Coast" => "Costa d'Ivori",
"Ivory_Coast" => "Ivory_Coast",
"Jamaica" => "Jamaica",
"Japan" => "Japó",
"Jersey" => "Jersei",
"Jordan" => "Jordània",
"Kazakstan" => "Kazakhstan",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Kyrgyzstan" => "Kirguizistan",
"Laos" => "Laos",
"Latvia" => "Letònia",
"Lebanon" => "Líban",
"Lesotho" => "Lesotho",
"Liberia" => "Libèria",
"Libya" => "Líbia",
"Liechtenstein" => "Liechtenstein",
"Lithuania" => "Lituània",
"Luxemburg" => "Luxemburg",
"Macao" => "Macau",
"Macedonia" => "Macedònia",
"Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Maldives" => "Maldives",
"Mali" => "Mali",
"Malta" => "Malta",
"Marshall Islands" => "Illes_Marshall",
"Marshall_Islands" => "Marshall_Islands",
"Martinique" => "Martinica",
"Mauritania" => "Mauritània",
"Mauritius" => "Maurici",
"Mayotte" => "Mayotte",
"Mexico" => "Mèxic",
"Moldova" => "Moldàvia",
"Monaco" => "Mònaco",
"Mongolia" => "Mongòlia",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Morocco" => "Marroc",
"Mozambique" => "Moçambic",
"Myanmar" => "Myanmar",
"Namibia" => "Namíbia",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Netherlands Antilles" => "Antilles_Holandeses",
"Netherlands" => "Països_Baixos",
"Netherlands_Antilles" => "Netherlands_Antilles",
"New Caledonia" => "Nova_Caledònia",
"New Zealand" => "Nova_Zelanda",
"New_Caledonia" => "Nueva_Caledonia",
"New_Zealand" => "New_Zealand",
"Nicaragua" => "Nicaragua",
"Niger" => "Níger",
"Nigeria" => "Nigèria",
"Niue" => "Niue",
"None" => "Cap",
"Norfolk Island" => "Illa_Norfolk",
"Norfolk_Island" => "Norfolk_Island",
"North Korea" => "Corea_del_Nord",
"North_Korea" => "North_Korea",
"Northern Mariana Islands" => "Illes_Marianes_del_Nord",
"Northern_Mariana_Islands" => "Northern_Mariana_Islands",
"Norway" => "Noruega",
"Oman" => "Oman",
"Other" => "Altre/a",
"Pakistan" => "Pakistan",
"Palau" => "Palau",
"Palestine" => "Palestina",
"Panama" => "Panamà",
"Papua New Guinea" => "Papua_Nova_Guinea",
"Papua_New_Guinea" => "Papua_New_Guinea",
"Paraguay" => "Paraguai",
"Peru" => "Perú",
"Philippines" => "Filipines",
"Pitcairn" => "Pitcairn",
"Poland" => "Polònia",
"Portugal" => "Portugal",
"Puerto Rico" => "Puerto_Rico",
"Puerto_Rico" => "Puerto_Rico",
"Quatar" => "Qatar",
"Republic of Macedonia" => "Macedònia",
"Republic_of_Macedonia" => "Republic_of_Macedonia",
"Reunion" => "Reunion",
"Romania" => "Romania",
"Russia" => "Rússia",
"Russian Federation" => "Rússia",
"Russian_Federation" => "Russian_Federation",
"Rwanda" => "Rwanda",
"Saint Helena" => "Saint_Helena",
"Saint Kitts and Nevis" => "Saint_Christopher_i_Nevis",
"Saint Lucia" => "Saint_Lucia",
"Saint Pierre and Miquelon" => "Saint_Pierre_i_Miquelon",
"Saint_Helena" => "Saint_Helena",
"Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
"Saint_Lucia" => "Saint_Lucia",
"Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
"Samoa" => "Samoa",
"San Marino" => "San_Marino",
"San_Marino" => "San_Marino",
"Sao Tome and Principe" => "Sao_Tome_i_Príncipe",
"Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
"Saudi Arabia" => "Aràbia_Saudita",
"Saudi_Arabia" => "Saudi_Arabia",
"Senegal" => "Senegal",
"Serbia" => "Sèrbia",
"Seychelles" => "Seychelles",
"Sierra Leone" => "Sierra_Leone",
"Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapur",
"Slovakia" => "Eslovàquia",
"Slovenia" => "Eslovènia",
"Solomon Islands" => "Illes_Solomó",
"Solomon_Islands" => "Solomon_Islands",
"Somalia" => "Somàlia",
"South Africa" => "Sud-àfrica",
"South Georgia and South Sandwich Islands" => "Illes_Geòrgia_del_Sud_i_Sandwich_del_Sud",
"South Korea" => "Corea_del_Sud",
"South_Africa" => "South_Africa",
"South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
"South_Korea" => "South_Korea",
"Spain" => "Espanya",
"Sri Lanka" => "Sri_Lanka",
"Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St._Vincent_i_les_Grenadines",
"St_Vincent_Grenadines" => "St_Vincent_Grenadines",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Svalbard and Jan Mayen" => "Svalbard_i_Jan_Mayen",
"Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
"Swaziland" => "Swazilàndia",
"Sweden" => "Suècia",
"Switzerland" => "Suïssa",
"Syria" => "Síria",
"Taiwan" => "Taiwan",
"Tajikistan" => "Tadjikistan",
"Tanzania" => "Tanzània",
"Thailand" => "Tailàndia",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinitat_i_Tobago",
"Trinidad_Tobago" => "Trinidad_tobago",
"Tunisia" => "Tunísia",
"Turkey" => "Turquia",
"Turkmenistan" => "Turkmenistan",
"Turks and Caicos Islands" => "Illes_Turks_i_Caicos",
"Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
"Tuvalu" => "Tuvalu",
"US Virgin Islands" => "Illes_Verge_Americanes",
"US_Virgin_Islands" => "US_Virgin_Islands",
"Uganda" => "Uganda",
"Ukraine" => "Ucraïna",
"United Arab Emirates" => "Unió_dels_Emirats_Àrabs",
"United Kingdom" => "Regne_Unit",
"United Nations Organization" => "Organització de les Nacions Unides",
"United States Minor Outlying Islands" => "Illes_Perifèriques_Menors_dels_EUA",
"United States" => "Estats_Units_(EUA)",
"United_Arab_Emirates" => "United_Arab_Emirates",
"United_Kingdom" => "United_Kingdom",
"United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
"United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
"United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
"United_Nations_Organization" => "Organització_de_les_Nacions_Unides",
"United_States" => "Estats_Units",
"United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
"Uruguay" => "Uruguai",
"Uzbekistan" => "Uzbekistan",
"Vanuatu" => "Vanuatu",
"Vatican" => "Vaticà",
"Venezuela" => "Veneçuela",
"Viet Nam" => "Vietnam",
"Viet_Nam" => "Viet_Nam",
"Wales" => "Wales",
"Wallis and Futuna" => "Wallis_i_Futuna",
"Wallis_and_Futuna" => "Wallis_and_Futuna",
"Western Sahara" => "Sàhara_Occidental",
"Western_Sahara" => "Western_Sahara",
"World" => "Món",
"Yemen" => "Iemen",
"Yugoslavia" => "Iugoslàvia",
"Zambia" => "Zàmbia",
"Zimbabwe" => "Zimbabwe",
"the former Yugoslav Republic of Macedonia" => "l'ex República Iugoslava de Macedònia",
"the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "File %0 succesfully imported" => "File %0 succesfully imported",
// "category defaults" => "category defaults",
"You must specify a directory" => "Has d'especificar un directori",
// "ViewerJS URI not set" => "ViewerJS URI not set",
// "ViewerJS URI not found (local file not readable)" => "ViewerJS URI not found (local file not readable)",
// "ViewerJS URI not found (%0)" => "ViewerJS URI not found (%0)",
// "Tags successfully cleaned up" => "Tags successfully cleaned up",
// "Tag cleanup failed" => "Tag cleanup failed",
// "Remove orphan images" => "Remove orphan images",
// "Orphan images successfully removed" => "Orphan images successfully removed",
"moved %d images, %d errors occurred." => "mogudes: %d imatges; han ocorregut %d errors.",
"a timeout occurred. Hit the reload button to move the rest" => "ha ocorregut una desconnexió. Prem el botó Actualitza per moure la resta",
"Tiki Email Test" => "Correu electrònic de prova de Tiki",
"Tiki Test email from" => "Correu-e de prova de Tiki enviat des de",
"Unable to send mail" => "No es pot enviar correu",
"Test mail sent to" => "Correu-e de prova de Tiki enviat a",
// "Remove this server" => "Remove this server",
// "Remove this host" => "Remove this host",
// "registration choices" => "registration choices",
// "Assign users to groups based on email patterns" => "Assign users to groups based on email patterns",
// "This method of captcha is not supported by your server, please select another or upgrade" => "This method of captcha is not supported by your server, please select another or upgrade",
// "You need to select a file to upload" => "You need to select a file to upload",
// "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists" => "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists",
// "Unable to Write Password File to Disk" => "Unable to Write Password File to Disk",
// "Delete temporary index" => "Delete temporary index",
// "%d users were assigned to groups based on user emails matching the patterns defined for the groups" => "%d users were assigned to groups based on user emails matching the patterns defined for the groups",
// "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups" => "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups",
// "composer.lock file was removed" => "composer.lock file was removed",
// "composer.lock file is not writable, so it can not be removed" => "composer.lock file is not writable, so it can not be removed",
// "composer.lock file do not exists" => "composer.lock file do not exists",
// "Vendor folder contents was removed" => "Vendor folder contents was removed",
// "Vendor folder is not writable" => "Vendor folder is not writable",
// "Vendor folder do not exists" => "Vendor folder do not exists",
"Used" => "Utilitzat",
"Available" => "Disponible",
"Hit" => "Cop",
"Miss" => "Perdre",
"An error occurred: " => "S'ha produït un error:",
// "profile applied" => "profile applied",
"The following list of changes has been applied" => "S'ha aplicat la següent llista de canvis",
// "Profile forgotten" => "Profile forgotten",
// "New rating configuration %0 created" => "New rating configuration %0 created",
// "Rating configuration updated for %0" => "Rating configuration updated for %0",
// "Scoring events replaced with form data" => "Scoring events replaced with form data",
// "Unable to get info from log file" => "Unable to get info from log file",
"You must set a home file gallery" => "Has de configurar una galeria d'arxius d'inici",
"Tag already exists" => "El marcador ja existeix",
// "Tag %0 created" => "Tag %0 created",
// "Tag %0 not found" => "Tag %0 not found",
// "Tag %0 restored" => "Tag %0 restored",
// "Tag %0 not restored" => "Tag %0 not restored",
// "Tag %0 removed" => "Tag %0 removed",
// "Tag %0 not removed" => "Tag %0 not removed",
// "Process to remove pictures has completed" => "Process to remove pictures has completed",
// "Dump created at %0" => "Dump created at %0",
// "Dump was not created. Please check permissions for the storage/ directory" => "Dump was not created. Please check permissions for the storage/ directory",
// "Dump file %0 removed" => "Dump file %0 removed",
// "Dump file %0 was not removed" => "Dump file %0 was not removed",
// "No update was made" => "No update was made",
// "Areas were updated" => "Areas were updated",
// "Are you sure you want to remove that post" => "Are you sure you want to remove that post",
"Re:" => "Re:",
"This forum is flat and doesn't allow replies to other replies" => "Aquest fòrum és pla i no permet respostes a altres respostes",
"Copyright management" => "Gestió de Copyright",
"No page indicated" => "No s'ha indicat cap pàgina",
"You must supply all the information, including title and year." => "Has de facilitar tota la informació, incloent títol i any.",
// "Sorry, that mail has been taken by another operator" => "Sorry, that mail has been taken by another operator",
"Wiki Page" => "Wiki Pàgina",
// "Tracker item not found" => "Tracker item not found",
// "Put this item back" => "Put this item back",
// "Taken by %0" => "Taken by %0",
// "Take this email" => "Take this email",
"TAKE" => "PRENDRE",
"View contact" => "Veure contacte",
"ID" => "ID",
"Type" => "Tipus",
"Name" => "Nom",
"Description" => "Descripció",
"Size" => "Mida",
"Created" => "Creat/da",
"Uploaded" => "Carregat",
"Last modified" => "Darrers canvis",
"Uploaded by" => "Pujar per",
"Creator" => "Creador/a",
"Last modified by" => "Darrera modificació per",
"Comment" => "Comentari",
"Files" => "Arxius",
"Hits" => "Cops",
"Last download" => "Darrera descàrrega",
"Locked by" => "Bloquejat per",
"Backlinks" => "Retroenllaços",
// "Delete after" => "Delete after",
"Share" => "Compartir",
"Source" => "Codi font",
"Explorer" => "Explorer",
"Path" => "Ruta",
"Slideshow" => "Passi de diapositives",
"Gallery icon" => "Icona de la Galleria",
"Register" => "Registre",
"Group" => "Grup",
"Tiki Installer" => "Instal·lador de Tiki",
"MySQL Improved (mysqli)" => "MySQL Millorat (mysqli)",
"MySQL classic (mysql)" => "MySQL clàssic (mysql)",
// "Invalid database user" => "Invalid database user",
"No database name specified" => "No s'ha especificat cap nom de base de dades",
// "Automatic" => "Automatic",
// "Make a symlink" => "Make a symlink",
// "Make a copy" => "Make a copy",
// "Do nothing" => "Do nothing",
// "symlink created" => "symlink created",
// "copy created" => "copy created",
"Email address not valid, test mail not sent" => "Adreça de correu-e no vàlida, no s'ha pogut enviar el correu-e de prova",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Adreça de correu-e buida i la casella de verificació de \"copia\" no ha estat seleccionada, no s'ha enviat el correu-e de prova",
"Test mail from Tiki installer %0" => "Correu electrònic de prova de l'instal·lador Tiki %0",
"Tiki version" => "Versió de Tiki",
"PHP version" => "Versió de PHP",
"Server" => "Servidor",
"Sent" => "Enviat",
"Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Es van detectar alguns caràcters no vàlids en el nom de base de dades. Utilitzeu caràcters alfanumèrics o _ o -",
"Database `%0` was created" => "S'ha creat la base de dades '%0'",
"Database `%0` creation failed. You need to create the database" => "Ha fallat la creació de la Base de dades '%0'. Cal crear la base de dades",
"Database `%0`. Unable to connect to database" => "Base de dades `%0`. No es possible connectar-se a la base de dades",
// "User `%0` was created" => "User `%0` was created",
// "User `%0` creation failed" => "User `%0` creation failed",
"Congratulations!\n\nYour server can send emails.\n\n" => "Felicitats!\n\nEl teu servidor pot enviar correus-e.\n\n",
// "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Failed to convert document into image" => "Failed to convert document into image",
// "Please check Tiki Action Log for more information" => "Please check Tiki Action Log for more information",
"No automated tax" => "Cap impost automatitzat",
"Account name must not be empty" => "Nom del compte no pot estar buit",
"Budget is not a valid amount: " => "Pressupost no és una quantitat vàlida:",
"Locked must be either 0 or 1" => "Bloquejades han de ser 0 o 1",
"Error creating account" => "Error en crear compte",
"AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "I'Id del compte %0 ja està en ús i no s'ha de canviar. Si us plau, desactiva-ho si ja no és necessari",
"Error updating account" => "Error en actualitzar el compte",
"Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "El compte ja està en ús i no s'han d'esborrar. Si us plau, desactiva-ho, si ja no cal",
"Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Rollback va fallar, base de dades inconsistents: neteja necessària per journalId %0 en el llibre %1",
"successfully rolled back #" => "Rollback implementat amb èxit #",
"Booking error creating journal entry" => "Error Reserva crear seients de diari",
"Booking error creating debit entry" => "Error Reserva crear càrrec en compte",
"Booking error creating credit entry" => "Error Reserva crear abonament",
"The number of debit entries differs: " => "Nombre d'entrades de dèbit difereix:",
"The number of credit entries differs: " => "Nombre d'entrades de crèdit difereixen:",
"Splitting is only allowed on one side" => "La divisió només es permet per una banda",
"Invalid debit amount " => "Invalid import de dèbit",
"Invalid debit account number " => "No vàlid el número de compte de dèbit",
"Invalid credit amount " => "Import del crèdit no vàlid",
"Invalid credit account number " => "Número de compte de crèdit no vàlid",
"Difference between debit and credit amounts " => "Diferència entre les sumes de dèbit i crèdit",
"Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Rollback va fallar, base de dades inconsistents: neteja necessària per stackId %0 en el llibre %1",
"Booking error creating stack entry" => "Error Reserva crear entrada de la pila",
"Booking error creating stack debit entry" => "Error Reserva crear deute pila",
"Booking error creating stack credit entry" => "Error Reserva crear abonament pila",
"Error deleting entry from stack" => "Error d'entrada eliminació de la pila",
"Booking error confirming stack entry" => "Error reserva confirmant entrada de la pila",
"Error while updating statement" => "Error en actualitzar la declaració",
"is not a number" => "es no és un nombre",
"must be greater than 0" => "ha de ser > 0",
"Invalid transaction - please contact administrator" => "Transacció invàlida - si us plau, contacta a la persona administradora",
"Error checking" => "La comprovació d'errors",
"does not exist" => "no existeix",
"already exists" => "ja existeix",
"This book has been closed. You can't create new accounts" => "Aquest llibre s'ha tancat. No es poden crear nous comptes",
"This book has been closed. You can't modify the account" => "Aquest llibre s'ha tancat. No es pot modificar el compte",
"This book has been closed. You can't delete the account" => "Aquest llibre s'ha tancat. No es pot eliminar el compte",
"The date of the transaction is before the start date of this book" => "La data de la transacció abans que aquest llibre la data d'inici",
"The date of the transaction is after the end date of this book" => "La data de la transacció després d'aquesta data d'acabament llibres",
"This book has been closed. Bookings can no longer be made in it" => "Aquest llibre s'ha tancat. No es poden fer reserves en ella més",
"Invalid booking date" => "Data de la reserva no vàlid",
"This book has been closed. Transactions can no longer be cancelled in it" => "Aquest llibre s'ha tancat. No pots cancel·lar-hi ja les operacions",
// "APC system, user and opcode caches cleared" => "APC system, user and opcode caches cleared",
// "APC %0 cache cleared" => "APC %0 cache cleared",
// "APC %0 cache not cleared" => "APC %0 cache not cleared",
"New article post" => "Nova publicació d'article",
"Edited article post" => "Publicació d'article editada",
"Deleted article post" => "Publicació d'article esborrada",
"The file has incorrect syntax or is not a CSV file" => "El fitxer no és del tipus CSV file o no té una sintaxi correcta",
"Error line: %d" => "Línia amb error: %d",
// "Import failed due to data format. Make sure the file has Unix-style line breaks" => "Import failed due to data format. Make sure the file has Unix-style line breaks",
"Spam is not welcome here" => "L'spam no és benvingut aquí",
"anonymous" => "anònim",
"Blog cannot be found" => "No es pot trobar el bloc",
"Locked by %0" => "Bloquejat per %0",
"refresh" => "refresc",
"go back to this crumb" => "tornar a aquest molla",
"Administration:" => "Administració:",
// "Cache file %0 is not writable" => "Cache file %0 is not writable",
"All day" => "Tot el dia",
"First day of week: Sunday (its ID is 0) - Translators, you need to localize this string!" => "1",
"Sunday" => "Diumenge",
"Su" => "Du",
"Monday" => "dilluns",
"Tuesday" => "Dimarts",
"Wednesday" => "Dimecres",
"Thursday" => "Dijous",
"Friday" => "divendres",
"Saturday" => "Dissabte",
"Mo" => "Dl",
"Tu" => "Dt",
"We" => "Dc",
"Th" => "Dj",
"Fr" => "Dv",
"Sa" => "Ds",
"in" => "a",
"continued" => "continuat",
"New Image Uploaded by" => "Nova imatge pujada per",
"New Subscriptions" => "Subscripcions noves",
"New Item in Tracker" => "Nova entrada al formulari-bd",
"tracker" => "formulari-bd",
"by" => "per",
"Wiki" => "Wiki",
"Image Gallery" => "Galeria d'imatges",
"Articles" => "Articles",
"Blogs" => "Blocs",
"Forums" => "Fòrums",
"Directory" => "Directori",
"File Gallery" => "Galeria d'arxius",
"FAQs" => "Pufs (faqs)",
"Quizzes" => "Qüestionaris",
"Trackers" => "Formularis-bd",
"Survey" => "Enquesta",
"Newsletter" => "Butlletins",
"Please type this word backwards" => "Si us plau escriviu la paraula al revés",
"Empty CAPTCHA value" => "Valor buit anti-robots",
"You have mistyped the anti-bot verification code. Please try again" => "Has comès alguna errada en el codi de verificació anti-robots. Prova-ho de nou, si us plau",
"Failed to validate CAPTCHA" => "Error en intentar validar el codi antirobots",
"CAPTCHA ID field is missing" => "Manca el camp ID antirobots (captcha)",
"Get a visual challenge" => "Demana un desafiament visual",
"Get an audio challenge" => "Demana un desafiament auditiu",
"Get a new challenge" => "Demana un nou desafiament",
"Type the two words" => "Escriu les dues paraules",
"Type what you hear" => "Escriu el que et dirà la web",
"Help" => "Ajuda",
"Play sound again" => "Reprodueix el so de nou",
"Download audio as an MP3 file" => "Descarrega el so com a MP3",
"Incorrect. Try again" => "No és correcte, Prova de nou",
// "Invalid category identifier: \"%0\"" => "Invalid category identifier: \"%0\"",
"Top" => "Dalt",
"A category named %0 already exists in %1" => "Ja existeix una categoria anomenada %0 a %1",
"article" => "article",
"blog" => "bloc",
"directory" => "directori",
"faq" => "pmf",
"FAQ" => "PUF",
"file gallery" => "galeria d'arxius",
"forum" => "fòrum",
"image gallery" => "galeria d'imatges",
"newsletter" => "butlletí",
"poll" => "sondeig",
"quiz" => "qüestionari",
"survey" => "enquesta",
"wiki page" => "pàgina wiki",
"image" => "imatge",
"calendar" => "calendari",
"template" => "plantilla",
"Permission denied" => "Permís denegat",
"Invalid filename (using filters for filenames)" => "Nom d'arxiu Invàlid (usant filtres per a noms d'arxius)",
"Cannot upload this file - maximum upload size exceeded" => "No es pot pujar aquest arxiu , supera el límit màxim de mida",
"Cannot write to this file" => "No es pot escriure a aquest arxiu",
"(not registered)" => "(no registrat)",
"Anonymous" => "Anònim/a",
"Your comment was rejected" => "El teu comentari ha estat rebutjat",
"Cannot perform spam check: %0" => "No es pot realitzar la comprovació de spam: %0",
"Please wait %0 seconds between posts" => "Si us plau, espera %0 segons entre publicacions",
"Wrong password. Cannot post comment" => "Contrasenya errònia. No pots publicar el comentari",
"A contribution is mandatory" => "És necessari especificar algun tipus de contribució",
// "Please enter a Title and Message for your new forum topic" => "Please enter a Title and Message for your new forum topic",
// "Please enter a Title and Message for your forum reply" => "Please enter a Title and Message for your forum reply",
// "Please enter a Message for your forum reply" => "Please enter a Message for your forum reply",
"Invalid Email" => "Correu-e invàlid",
"Your message has been queued for approval and will be posted after a moderator approves it." => "El teu missatge ha estat posat a la qua de moderació per ser aprovat; es publicarà el missatge quan un moderador l'aprovi.",
// "Use this thread to discuss the %s page" => "Use this thread to discuss the %s page",
"This forum is locked" => "Aquest fòrum està bloquejat",
"This thread is locked" => "Aquest fil de discussió està bloquejat",
// "An error occurred; please contact the administrator" => "An error occurred; please contact the administrator",
// "Route was updated" => "Route was updated",
// "Route was created" => "Route was created",
"Page cannot be found" => "No s'ha pogut trobar la pàgina",
// "From is required" => "From is required",
// "There is a route with the same From path already defined" => "There is a route with the same From path already defined",
// "Type is required" => "Type is required",
// "Selected type is not supported" => "Selected type is not supported",
"To" => "A",
"Article" => "Article",
"Blog" => "Bloc",
"Forum" => "Fòrum",
"Object" => "Objecte",
"Tracker" => "Formulari-bd",
"Field" => "Camp",
"Tracker Item Id" => "Id de l'Item del Formulari-bd",
// "%s is required" => "%s is required",
"Error" => "Error",
"Note" => "Nota",
"Success" => "Èxit",
"Warning" => "Avís",
// "Feedback class called with no feedback provided" => "Feedback class called with no feedback provided",
// "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator" => "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator",
// "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Invalid request" => "Invalid request",
// "Failed to convert document %0 to pdf" => "Failed to convert document %0 to pdf",
// "Please check Action Log for more information" => "Please check Action Log for more information",
// "Please contact the administrator" => "Please contact the administrator",
// "H5P requires the CURL extension to be installed in PHP" => "H5P requires the CURL extension to be installed in PHP",
// "Failed to write to temp file %0" => "Failed to write to temp file %0",
// " (code=%0)" => " (code=%0)",
// "Exporting H5P content %0 failed" => "Exporting H5P content %0 failed",
// "Saving H5P content %0 (fileId %1) failed" => "Saving H5P content %0 (fileId %1) failed",
// "H5P directory is not writable: %0" => "H5P directory is not writable: %0",
// "Too many arguments on ceil" => "Too many arguments on ceil",
// "Too many arguments on date" => "Too many arguments on date",
// "Divide by zero on \"%0\"" => "Divide by zero on \"%0\"",
// "Too many arguments on floor" => "Too many arguments on floor",
"Unexpected values: %0" => "Valors inesperats: %0",
// "Field must be provided and contain one argument: list" => "Field must be provided and contain one argument: list",
// "Field must be provided and contain a function" => "Field must be provided and contain a function",
// "Too many arguments on less than" => "Too many arguments on less than",
// "Too many arguments on more than" => "Too many arguments on more than",
// "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]" => "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]",
// "Too many arguments for pad" => "Too many arguments for pad",
// "Too few arguments for pad" => "Too few arguments for pad",
// "Too many arguments on round" => "Too many arguments on round",
// "Content required" => "Content required",
// "Field must be provided and contain one argument: separator" => "Field must be provided and contain one argument: separator",
// "Field must be provided and contain one or more values: key or keys" => "Field must be provided and contain one or more values: key or keys",
// "Str-replace needs exactly 3 arguments: search, replace and subject" => "Str-replace needs exactly 3 arguments: search, replace and subject",
// "Too many arguments on strtotime" => "Too many arguments on strtotime",
// "Too few arguments on strtotime" => "Too few arguments on strtotime",
// "Field must be provided and contain one argument: group" => "Field must be provided and contain one argument: group",
// "Field must be provided and contain at least one argument: aggregate" => "Field must be provided and contain at least one argument: aggregate",
"%0 near \"%1\"" => "%0 a prop de \"%1\"",
"Expecting \"(\"" => "Esperant \"(\"",
"Unexpected \"%0\"" => "No esperat \"%0\"",
"Expecting \")\"" => "Esperant \")\"",
"No formula provided" => "No hi ha una fórmula proporcionada",
"Variable not found \"%0\"" => "Variable not found \"%0\"",
"Unknown operation \"%0\"" => "Operació Desconegut \" %0 \"",
"Articles deleted" => "Articles esborrats",
"removed the article" => "ha eliminat l'article",
"Edited articles" => "Articles editats",
"edited the article" => "ha editat l'article",
"New articles submitted" => "Nous articles proposats",
"created the article" => "ha creat l'article",
"New blog posts" => "Noves publicacions de bloc",
"replied to the blog" => "ha respost al bloc",
"New calendar events" => "Nous esdeveniments a l'agenda",
"%0 added or updated event %1" => "%0 ha afegit o actualitzat %1",
"Changes in categories" => "Canvis a categories",
"added the %0 %1 to the category %2" => "ha afegit el/la %0 %1 a %2",
"created the subcategory" => "ha creat la subcategoria",
"removed the subcategory" => "ha eliminat la subcategoria",
"from" => "des de",
"edited the category" => "ha editat la categoria",
"removed the %0 %1 from the category %2" => "ha eliminat el/la %0 %1 de %2",
"File galleries changed" => "Han canviat algunes galeries d'arxius",
"%0 edited the file gallery %1" => "%0 ha editat la galeria d'arxius %1",
"%0 uploaded the file %1" => "%0 ha pujat l'arxiu %1",
"onto" => "sobre",
"%0 removed the file %1 from %2" => "%0 ha eliminat l'arxiu %1 de %2",
"New replies in forum topics" => "Noves respostes a temes de fòrums",
"%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>ha contestat</a> al tema %2",
"New posts in forums" => "Noves publicacions en fòrums",
"%0 created the topic %1 at forum %2" => "%0 ha creat el tema %1 a %2",
"Image galleries changed" => "Galeries d'imatges canviar",
"changed the picture gallery" => "ha canviat la galeria de fotos",
"uploaded the picture" => "ha pujat la foto",
"removed the picture" => "ha eliminat la foto",
"Wiki pages added to a structure" => "Hi ha hagut pàgines wiki afegides a l'estructura",
"%0 added %1 wiki page to a structure" => "%0 ha afegit %1 pàgines wiki a l'estructura",
"Wiki pages moved down in a structure tree" => "Hi ha hagut pàgines wiki mogudes avall en l'arbre de l'estructura",
"%0 moved a wiki page down in a structure tree" => "%0 ha mogut una página wiki cap avall a l'arbre de l'estructura",
"Wiki pages moved up in a structure tree" => "Hi ha hagut pàgines wiki mogudes cap amunt a l'arbre de l'estructura",
"%0 moved a wiki page up in a structure tree" => "%0 ha mogut una página wiki cap amunt a l'arbre de l'estructura",
"Wiki pages removed from structure" => "Hi ha hagut pàgines wiki eliminades de l'estructura",
"%0 removed %1 wiki page from a structure" => "%0 ha eliminat %1 págines wiki de l'estructura",
"File attached to tracker" => "Arxiu adjunt al formulari-bd",
"%0 attached a file (%1) to tracker item %2" => "%0 ha adjuntat un arxiu (%1) a l'ítem del formulari-bd %2",
"Comments in tracker items" => "Comentaris a ítems dels formularis-bd",
"%0 added a new comment to %1 on tracker %2" => "%0 n'ha afegit un a %1 en %2",
"%0 added a new comment to item id %1 on tracker %2" => "%0 n'ha afegit un a l'item %1 en %2",
"Tracker items modified" => "S'han modificat ítems de formularis-bd",
"%0 added or updated tracker item %1 on tracker %2" => "%0 ha afegit o actualitzat %1 de %2",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 ha afegit o actualitzat l'ítem %1 de %2",
"New attachments in wiki pages" => "Nous adjunts a pàgines wiki",
"%0 uploaded the file %1 onto %2" => "%0 ha adjuntat l'arxiu %1 a %2",
"Wiki pages updated" => "Pàgines wiki actualitzades",
"%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 ha editat %1 (<a href=%2>aquests canvis</a>, <a href=%3>tot l'històric</a>)",
// "Wiki pages created" => "Wiki pages created",
// "%0 created the wikipage %1" => "%0 created the wikipage %1",
// "Wiki pages deleted" => "Wiki pages deleted",
// "%0 deleted the wikipage %1" => "%0 deleted the wikipage %1",
"and %0 more changes of the same type" => "i %0 canvis més del mateix tipus",
"Nothing has happened" => "No ha succeït res",
"Report on %0 from %1 " => "Informe sobre %0 des de %1 ",
"(no changes)" => "(sense canvis)",
"(1 change)" => "(1 canvi)",
"(%0 changes)" => "(%0 canvis)",
// "Scheduler task is stalled" => "Scheduler task is stalled",
// "Scheduler task is already running" => "Scheduler task is already running",
// "Unable to decode task params" => "Unable to decode task params",
// "***** Running scheduler %s *****" => "***** Running scheduler %s *****",
// "Scheduler %0 (id: %1) is stalled" => "Scheduler %0 (id: %1) is stalled",
// "Skip scheduler %s - %s" => "Skip scheduler %s - %s",
// "***** Scheduler %s - FAILED *****\n%s" => "***** Scheduler %s - FAILED *****\n%s",
// "***** Scheduler %s - OK *****" => "***** Scheduler %s - OK *****",
// "Scheduler with id %0 does not exist or is not active" => "Scheduler with id %0 does not exist or is not active",
// "Scheduler `%0` (id: %1) is stalled" => "Scheduler `%0` (id: %1) is stalled",
// "Scheduler `%0` (id: %1) was healed" => "Scheduler `%0` (id: %1) was healed",
// "Scheduler `%0` (id: %1) was not healed" => "Scheduler `%0` (id: %1) was not healed",
// "Scheduler %0 (id: %1) is not stalled, no need to heal" => "Scheduler %0 (id: %1) is not stalled, no need to heal",
// "Missing parameters to run the command" => "Missing parameters to run the command",
// "Executing console command: %s" => "Executing console command: %s",
// "Console command" => "Console command",
// "Missing the URL to call" => "Missing the URL to call",
// "Missing the file path to where the output should be saved" => "Missing the file path to where the output should be saved",
// "URL to invoke: %s" => "URL to invoke: %s",
// "Save output to: %s" => "Save output to: %s",
// "Using basic authentication" => "Using basic authentication",
// "Including additional headers" => "Including additional headers",
// "Sending request" => "Sending request",
// "Request was successful" => "Request was successful",
// "Failed to open file %s to write" => "Failed to open file %s to write",
// "Request failed" => "Request failed",
"URL" => "URL",
// "Output File" => "Output File",
// "File path to save the output" => "File path to save the output",
// "Additional HTTP Headers" => "Additional HTTP Headers",
// "One HTTP Header per line" => "One HTTP Header per line",
// "Auth Username" => "Auth Username",
// "Auth Password" => "Auth Password",
// "Missing shell command to execute" => "Missing shell command to execute",
// "Executing shell command: %s" => "Executing shell command: %s",
// "Shell command" => "Shell command",
// "Run timeout" => "Run timeout",
// "in seconds" => "in seconds",
// "Checking tiki version" => "Checking tiki version",
// "Sending emails" => "Sending emails",
// "Tiki version email sent to" => "Tiki version email sent to",
// "Tiki Version Updated" => "Tiki Version Updated",
// "Tiki Updates: " => "Tiki Updates: ",
// "Tiki Updates" => "Tiki Updates",
// "Invalid cron time format" => "Invalid cron time format",
// "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1" => "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1",
// "Missing required action parameter or value: %0" => "Missing required action parameter or value: %0",
// "Cannot apply change_status action to an object type %0" => "Cannot apply change_status action to an object type %0",
// "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Tracker item %0 not found" => "Tracker item %0 not found",
// "Tracker item %0 status %1 is different than the \"from\" status %2" => "Tracker item %0 status %1 is different than the \"from\" status %2",
// "Cannot apply delete action to an aggregation type %0" => "Cannot apply delete action to an aggregation type %0",
// "Cannot apply delete action to an object type %0" => "Cannot apply delete action to an object type %0",
// "Tracker field %0 not found" => "Tracker field %0 not found",
// "Cannot find file to delete: %0" => "Cannot find file to delete: %0",
// "Are you sure you want to permanently delete this object" => "Are you sure you want to permanently delete this object",
// "EmailAction - send to %0, subject - %1" => "EmailAction - send to %0, subject - %1",
// "Error sending email: %0" => "Error sending email: %0",
// "Page %s cannot be found" => "Page %s cannot be found",
// "EmailAction - can't send new message" => "EmailAction - can't send new message",
// "Cannot apply filegal_change_filename action to an object type %0" => "Cannot apply filegal_change_filename action to an object type %0",
// "Tracker field %0 not found for tracker %1" => "Tracker field %0 not found for tracker %1",
// "Tracker field %0 is not a Files field type" => "Tracker field %0 is not a Files field type",
// "filegal_change_filename action missing value parameter" => "filegal_change_filename action missing value parameter",
// "Cannot apply filegal_image_overlay action to an object type %0" => "Cannot apply filegal_image_overlay action to an object type %0",
// "filegal_image_overlay action missing value parameter" => "filegal_image_overlay action missing value parameter",
// "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1" => "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1",
// "Cannot apply tracker_item_modify action to an aggregation type %0" => "Cannot apply tracker_item_modify action to an aggregation type %0",
// "Cannot apply tracker_item_modify action to an object type %0" => "Cannot apply tracker_item_modify action to an object type %0",
// "tracker_item_modify action missing value, calc, add or remove parameter" => "tracker_item_modify action missing value, calc, add or remove parameter",
// "Field %0 not found on Action TrackerItemModify" => "Field %0 not found on Action TrackerItemModify",
// "Error applying tracker_item_modify calc formula to item %0: %1" => "Error applying tracker_item_modify calc formula to item %0: %1",
// "Unknown search action step: %0" => "Unknown search action step: %0",
// "Cannot apply wiki_approval action to an object type %0" => "Cannot apply wiki_approval action to an object type %0",
// "Wiki page %0 is not in pending state" => "Wiki page %0 is not in pending state",
// "Wiki page %0 does not require approval" => "Wiki page %0 does not require approval",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmat",
"Cancelled" => "Cancel·lat",
"unknown" => "desconegut",
"Unknown" => "Desconegut/da",
// "Tracker Status" => "Tracker Status",
// "Webservice %0 field \"%1\" not found" => "Webservice %0 field \"%1\" not found",
"%0 (latest)" => "%0 (el darrer)",
// "Elasticsearch does not support optimize" => "Elasticsearch does not support optimize",
// "Federated index %0 not found" => "Federated index %0 not found",
// "Unknown mapping type \"%0\" for field \"%1\"" => "Unknown mapping type \"%0\" for field \"%1\"",
"Document not found in index %1 (%0)" => "No s'ha trobat el document a l'índex %1 (%0)",
// "String \"%0\" cannot be formatted as a number for field \"%1\"" => "String \"%0\" cannot be formatted as a number for field \"%1\"",
// "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker" => "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker",
// "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0" => "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0",
"Feature not supported" => "Funcionalitat no suportada",
// "Parsing search query failed: \"%0\"" => "Parsing search query failed: \"%0\"",
// "Sort field %0 not found in index" => "Sort field %0 not found in index",
"No results for query" => "No hi ha resultats per a la cerca",
"Missing template \"%0\"" => "Plantilla Missing \"%0\"",
// "Template tplwiki page \"%0\" not found" => "Template tplwiki page \"%0\" not found",
// "Template wiki page \"%0\" not found" => "Template wiki page \"%0\" not found",
// "Error evaluating formula %0: %1" => "Error evaluating formula %0: %1",
"No value for '%0'" => "Cap valor per a '%0'",
"Unknown formatting rule '%0' for '%1'" => "Desconegut regla de format ' %0' per a ' %1'",
"Category Tree" => "Arbre de Categories",
"Categories" => "Categories",
"%0 (Tree)" => "%0 (Arbre)",
"Tags" => "Etiquetes lliures",
"Letter" => "Lletra",
// "First word" => "First word",
"Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexació no en processar \"%0\" (tipus%1) amb l'error \"%2\"",
// "Object %0 type %1 returned null from getDocument function" => "Object %0 type %1 returned null from getDocument function",
// "Could not perform index modification: %0" => "Could not perform index modification: %0",
// "Feature not supported: %0" => "Feature not supported: %0",
"Missing objectype or qualifier for relation filter" => "Falta objectype o qualificador per al filtre de relació",
// "Range filter \"from\" parameter not valid: \"%0\"" => "Range filter \"from\" parameter not valid: \"%0\"",
// "Range filter \"to\" parameter not valid: \"%0\"" => "Range filter \"to\" parameter not valid: \"%0\"",
// "Range filter \"gap\" parameter not valid: \"%0\"" => "Range filter \"gap\" parameter not valid: \"%0\"",
// "The range filter is missing \\\"from\\\" or \\\"to\\\"" => "The range filter is missing \\\"from\\\" or \\\"to\\\"",
// "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"" => "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"",
// "Distance sort: Missing lat or lon arguments" => "Distance sort: Missing lat or lon arguments",
// "Script sort: Missing source argument" => "Script sort: Missing source argument",
// "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled" => "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled",
"filterRange: \"from\" value not parsed" => "filterRange: valor \"de\" no analitzat",
"filterRange: \"to\" value not parsed" => "filterRange: valor \"a\" no analitzat",
// "Malformed search query" => "Malformed search query",
// "%0 (%1)" => "%0 (%1)",
// "Please confirm" => "Please confirm",
"OK" => "D'acord",
// "Are you sure you want to %0 the following %1" => "Are you sure you want to %0 the following %1",
// "Please confirm your action for the following item" => "Please confirm your action for the following item",
// "Please confirm your action for the following items" => "Please confirm your action for the following items",
// "Activity stream currently unavailable" => "Activity stream currently unavailable",
"Permission Denied" => "Permís denegat",
// "Activity rule deleted" => "Activity rule deleted",
// "%0 activity rules deleted" => "%0 activity rules deleted",
// "No activity rules deleted" => "No activity rules deleted",
// "Delete Rule" => "Delete Rule",
// "Activity (id:' . (string) \$id . " => "Activity (id:' . (string) \$id . ",
// "No activities deleted" => "No activities deleted",
// "Delete Activity" => "Delete Activity",
// "Sample activity rule %0 updated" => "Sample activity rule %0 updated",
// "Sample activity rule %0 created" => "Sample activity rule %0 created",
// "Sample activity rule %0 unchanged" => "Sample activity rule %0 unchanged",
// "Edit Rule %0" => "Edit Rule %0",
// "Create Sample Rule" => "Create Sample Rule",
// "Basic activity rule %0 updated" => "Basic activity rule %0 updated",
// "Basic activity rule %0 created" => "Basic activity rule %0 created",
// "Basic activity rule %0 unchanged" => "Basic activity rule %0 unchanged",
// "Create Record Rule" => "Create Record Rule",
// "Tracker activity rule %0 updated" => "Tracker activity rule %0 updated",
// "Tracker activity rule %0 created" => "Tracker activity rule %0 created",
// "Tracker activity rule %0 unchanged" => "Tracker activity rule %0 unchanged",
// "Create Tracker Rule" => "Create Tracker Rule",
// "Advanced activity rule %0 updated" => "Advanced activity rule %0 updated",
// "Advanced activity rule %0 created" => "Advanced activity rule %0 created",
// "Advanced activity rule %0 unchanged" => "Advanced activity rule %0 unchanged",
// "Create Advanced Rule" => "Create Advanced Rule",
"Sample" => "Mostra",
"Basic" => "Bàsic",
"Advanced" => "Avançat",
// "Invalid rule type" => "Invalid rule type",
// "Type changed for activity rule %0" => "Type changed for activity rule %0",
// "Change Rule Type" => "Change Rule Type",
// "Status changed for activity rule %0" => "Status changed for activity rule %0",
// "Change Rule Status" => "Change Rule Status",
// "Content could not be loaded" => "Content could not be loaded",
// "Create article from URL" => "Create article from URL",
"Invalid input" => "Entrada no vàlida",
"Invalid data" => "Dades no vàlides",
// "Authentication added or modified" => "Authentication added or modified",
// "Authentication not added or modified" => "Authentication not added or modified",
// "Authentication deleted" => "Authentication deleted",
// "Authentication not deleted" => "Authentication not deleted",
"Oops" => "Vagi",
"Action not found (%0 in %1)" => "Acció no trobada (0 %a %1)",
"Controller not found (%0)" => "El controlador no trobat (%0)",
// "No change made for one object already in the category" => "No change made for one object already in the category",
// "No change made for %0 objects already in the category" => "No change made for %0 objects already in the category",
// "One object added to category" => "One object added to category",
// "%0 objects added to category" => "%0 objects added to category",
// "No objects added to category" => "No objects added to category",
// "No change made for one object not in the category" => "No change made for one object not in the category",
// "No change made for %0 objects not in the category" => "No change made for %0 objects not in the category",
// "One object removed from category" => "One object removed from category",
// "%0 objects removed from category" => "%0 objects removed from category",
// "No objects removed from category" => "No objects removed from category",
// "Invalid %0 ID: %1" => "Invalid %0 ID: %1",
"Comments not allowed on this page" => "No es permeten comentaris en aquesta pàgina",
"Loading..." => "Carregant...",
"Comments" => "Comentaris",
"Parent is locked" => "Pares està bloquejat",
"Pseudonym must be specified" => "S'ha d'especificar Pseudonym",
"Email must be specified" => "S'ha d'indicar el correu-e",
"Title is empty" => "Cal posar un títol (és buit ara)",
"Content is empty" => "Cal posar algun contingut (és buit ara)",
// "Duplicated comment, there is already another comment with the same text" => "Duplicated comment, there is already another comment with the same text",
"Your comment was posted" => "S'ha publicat el teu comentari",
"Permissions denied" => "Permisos negats",
// "Lock comments" => "Lock comments",
// "Unlock comments" => "Unlock comments",
"Comment not found" => "El comentari no trobat",
"Comment already approved" => "Comentaris ja aprovats",
"Invalid argument" => "Argument no vàlid",
"Thread not specified" => "No especificat Tema",
// "Comment permissions: %0 object %1 not found" => "Comment permissions: %0 object %1 not found",
"Feature disabled" => "Característica deshabilitada",
"Reserved for administrators during development" => "Reservat als administradors durant el desenvolupament",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
"There was an error (Tiki Connect is still experimental). Please try again" => "Quelcom ha fallat. Tiki Connect és encara experimental. Si us plau, torna a intentar",
"registration" => "registre",
"confirmation" => "confirmació",
"Connect Feature disabled" => "Connecteu Feature deshabilitat",
"Connect server mode disabled" => "Connecteu el mode de servidor deshabilitat",
"Please confirm that you want to participate in Tiki Connect" => "Confirma que desitges participar en Tiki Connect",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
"There was a problem at the server (Tiki Connect is still experimental)" => "Quelcom ha fallat al servidor. Tiki Connect és encara experimental",
"CAPTCHA code problem" => "Problema de codi Captcha",
"Connect data received, thanks" => "Connecteu les dades rebudes, gràcies",
"Your Tiki site is not registered here yet. Please try again" => "La seva Tiki no està registrat aquí encara, per favor intenta-ho de nou",
// "Remove custom route" => "Remove custom route",
// "Inline editor update" => "Inline editor update",
"Preview" => "Vista prèvia",
// "Syntax Help" => "Syntax Help",
"WYSIWYG Help" => "Ajuda Wysiwyg (editor visual)",
"Plugin Help" => "Ajuda de Plugins",
// "Spreadsheet Help" => "Spreadsheet Help",
// "Edit Help" => "Edit Help",
"Edit" => "Editar",
// "Tracker %0 not found" => "Tracker %0 not found",
// "The following parameters could not be converted to plugin list at this stage:\n" => "The following parameters could not be converted to plugin list at this stage:\n",
// "Plugins found containing: %0" => "Plugins found containing: %0",
// "No plugins found containing: %0" => "No plugins found containing: %0",
// "You do not have permission to edit \"%0\"" => "You do not have permission to edit \"%0\"",
// "Undefined parameter" => "Undefined parameter",
"Missing parameters" => "Falten paràmetres",
// "%0 Plugin modified by editor" => "%0 Plugin modified by editor",
// "Page \"%0\" not found" => "Page \"%0\" not found",
// "%0 Plugin converted to list" => "%0 Plugin converted to list",
// "Plugin %0 on page %1 converted" => "Plugin %0 on page %1 converted",
"Authentication required" => "Es requereix autenticació",
"Feature disabled: %0" => "Discapacitats de funcions: %0",
// "Edit conflict" => "Edit conflict",
// "Edit conflict: %0 \"%1\" is being edited already by %2" => "Edit conflict: %0 \"%1\" is being edited already by %2",
"Field Required" => "Informació requerida",
"Not found" => "No s'ha trobat",
// "File Upload" => "File Upload",
// "File could not be uploaded" => "File could not be uploaded",
// "No file arrived" => "No file arrived",
// "File too large" => "File too large",
// "Unknown errors" => "Unknown errors",
// "File empty" => "File empty",
// "Batch file processed: \"%0\"" => "Batch file processed: \"%0\"",
"You don't have permission to upload zipped file packages" => "No hi ha permisos per baixar-se paquets de fitxers enzipats",
"Browse" => "Visitar",
// "Gallery List" => "Gallery List",
"Upload from source disabled" => "Pujar des de la discapacitat d'origen",
// "Unable to retrieve file from remote site. Please try a different URL" => "Unable to retrieve file from remote site. Please try a different URL",
"File could not be uploaded. Restrictions apply" => "L'arxiu no es va poder carregar. Apliquen restriccions",
"Manual refresh disabled" => "L'actualització manual desactivat",
"Gallery ID %0 not found" => "No existeix l'ID de Galeria %0",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help" => "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help",
"Requested gallery does not exist" => "No existeix la Galeria sol·licitada",
// "Vimeo not authenticated" => "Vimeo not authenticated",
// "Upload Video" => "Upload Video",
"Unknown error" => "Error no conegut",
// "No action was selected. Please select an action before clicking OK" => "No action was selected. Please select an action before clicking OK",
// "Merge selected posts with another topic" => "Merge selected posts with another topic",
// "Merge this post" => "Merge this post",
// "Merge these posts" => "Merge these posts",
// "Merge selected topics with another topic" => "Merge selected topics with another topic",
// "Merge this topic" => "Merge this topic",
// "Merge these topics" => "Merge these topics",
"Merge" => "Escapçar",
// "With this topic" => "With this topic",
// "All topics or posts were selected, leaving none to merge with. Please make your selection again" => "All topics or posts were selected, leaving none to merge with. Please make your selection again",
// "No topics were selected. Please select the topics you wish to merge before clicking the merge button" => "No topics were selected. Please select the topics you wish to merge before clicking the merge button",
// "The following post has been merged with the %0 topic" => "The following post has been merged with the %0 topic",
// "The following posts have been merged with the %0 topic" => "The following posts have been merged with the %0 topic",
// "Move this topic" => "Move this topic",
// "Move these topics" => "Move these topics",
// "From the %0 forum to the below forum" => "From the %0 forum to the below forum",
// "Move selected topics to another forum" => "Move selected topics to another forum",
"Move" => "Moure",
// "No topics were selected. Please select the topics you wish to move before clicking the move button" => "No topics were selected. Please select the topics you wish to move before clicking the move button",
// "The following topic has been moved to the %0 forum" => "The following topic has been moved to the %0 forum",
// "The following topics have been moved to the %0 forum" => "The following topics have been moved to the %0 forum",
// "Delete the following forum %0" => "Delete the following forum %0",
"Delete" => "Esborra",
// "No topics were selected. Please select the topics you wish to delete before clicking the delete button" => "No topics were selected. Please select the topics you wish to delete before clicking the delete button",
// "The following topic has been deleted" => "The following topic has been deleted",
// "The following topics have been deleted" => "The following topics have been deleted",
// "Delete the following attachment" => "Delete the following attachment",
// "No attachments were selected. Please select an attachment to delete" => "No attachments were selected. Please select an attachment to delete",
// "The following attachment has been deleted" => "The following attachment has been deleted",
// "The following attachments have been deleted" => "The following attachments have been deleted",
// "Reserved for forum administrators" => "Reserved for forum administrators",
// "Delete the following forum" => "Delete the following forum",
// "Delete the following forums" => "Delete the following forums",
// "No forums were selected. Please select a forum to delete" => "No forums were selected. Please select a forum to delete",
// "The following forum has been deleted" => "The following forum has been deleted",
// "The following forums have been deleted" => "The following forums have been deleted",
// "Reserved for forum administrators and moderators" => "Reserved for forum administrators and moderators",
// "%0 the following topic" => "%0 the following topic",
// "%0 the following topics" => "%0 the following topics",
// "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button" => "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button",
"locked" => "bloquejat",
"unlocked" => "desbloquejat/da",
// "The following topic has been %0" => "The following topic has been %0",
// "The following topics have been %0" => "The following topics have been %0",
// "%0 the following thread" => "%0 the following thread",
// "thread" => "thread",
// "No threads were selected. Please select the threads you wish to %0" => "No threads were selected. Please select the threads you wish to %0",
// "archived" => "archived",
// "unarchived" => "unarchived",
// "The following thread has been %0" => "The following thread has been %0",
// "The following thread have been %0" => "The following thread have been %0",
// "The goal is currently disabled" => "The goal is currently disabled",
// "This goal is not enabled" => "This goal is not enabled",
// "Not eligible for this goal" => "Not eligible for this goal",
// "The goal has not been evaluated, administrator view" => "The goal has not been evaluated, administrator view",
"Reserved for administrators" => "Reservat per als administradors",
// "Manage Goals" => "Manage Goals",
// "Create Goal" => "Create Goal",
// "Edit Goal" => "Edit Goal",
// "Remove Goal" => "Remove Goal",
// "Conditions" => "Conditions",
// "Pages created" => "Pages created",
// "Condition" => "Condition",
// "Rewards" => "Rewards",
// "No available rewards" => "No available rewards",
// "Reward" => "Reward",
// "Restricted access" => "Restricted access",
// "Modify Eligibility for %0" => "Modify Eligibility for %0",
// "Delete the following group" => "Delete the following group",
// "Delete the following groups" => "Delete the following groups",
// "No groups were selected. Please select one or more groups" => "No groups were selected. Please select one or more groups",
// "The following group cannot be deleted" => "The following group cannot be deleted",
// "The following groups cannot be deleted" => "The following groups cannot be deleted",
// "The following group has been deleted" => "The following group has been deleted",
// "The following groups have been deleted" => "The following groups have been deleted",
"Group already exists" => "Aquest grup ja existeix",
// "Create the group %0" => "Create the group %0",
"Create" => "Crear",
// "Group name cannot be empty" => "Group name cannot be empty",
// "Group %0 (ID %1) successfully created" => "Group %0 (ID %1) successfully created",
// "Group %0 not created" => "Group %0 not created",
// "Modify the group %0" => "Modify the group %0",
// "Modify" => "Modify",
// "Group %0 successfully modified" => "Group %0 successfully modified",
// "Group %0 not modified" => "Group %0 not modified",
// "Add the following user to group %0" => "Add the following user to group %0",
// "Add the following users to group %0" => "Add the following users to group %0",
"Add" => "Afegeix",
// "One or more users must be selected" => "One or more users must be selected",
// "The following user was added to group %0" => "The following user was added to group %0",
// "The following users were added to group %0" => "The following users were added to group %0",
// "Ban the following user from group %0" => "Ban the following user from group %0",
// "Ban the following users from group %0" => "Ban the following users from group %0",
"Ban" => "Ban",
// "The following user was banned from group %0" => "The following user was banned from group %0",
// "The following users were banned from group %0" => "The following users were banned from group %0",
// "Unban the following user from group %0" => "Unban the following user from group %0",
// "Unban the following users from group %0" => "Unban the following users from group %0",
// "Unban" => "Unban",
// "The following user was unbanned from group %0" => "The following user was unbanned from group %0",
// "The following users were unbanned from group %0" => "The following users were unbanned from group %0",
// "h5p_enabled" => "h5p_enabled",
// "Create H5P Content" => "Create H5P Content",
// "Create H5P content" => "Create H5P content",
// "H5P Embed" => "H5P Embed",
// "No fileID provided" => "No fileID provided",
// "H5P Plugin" => "H5P Plugin",
// "Cannot find H5P content with fileId: %0" => "Cannot find H5P content with fileId: %0",
// "Edit H5P Content" => "Edit H5P Content",
// "H5P Edit" => "H5P Edit",
// "Waiting for javascript.." => "Waiting for javascript..",
// "H5P Content Libraries" => "H5P Content Libraries",
// "File not found on server. Check file upload settings" => "File not found on server. Check file upload settings",
// "H5P Results" => "H5P Results",
// "No contentId provided" => "No contentId provided",
// "H5P User Data" => "H5P User Data",
// "H5P User Results" => "H5P User Results",
"You have successfully added %0 new media items" => "Ha afegit %0 nous elements multimèdia",
"You have successfully added one new media item" => "Ha afegit un nou element multimèdia",
// "No language provided" => "No language provided",
// "lang/\$language directory is not writable" => "lang/\$language directory is not writable",
"Wrote %d new strings and updated %d to lang/%s/language.php" => "Va escriure %d noves cadenes i actualitzada %d per lang/%s/language.php",
"Write to language.php" => "Escriu a language.php",
// "Custom Translations" => "Custom Translations",
// "Invalid file type" => "Invalid file type",
// "File does not exist" => "File does not exist",
// "Invalid file type: php not allowed" => "Invalid file type: php not allowed",
// "Upload Translations" => "Upload Translations",
"Feature Disabled" => "Característica Desactivat",
// "Invalid file parameter supplied" => "Invalid file parameter supplied",
"Translation not supported for the specified object type" => "La traducció no és compatible amb el tipus d'objecte especificat",
"No source provided" => "Cap font proporcionada",
"Manage translations" => "Gestioni traduccions",
"No source or target provided" => "No d'origen o destí previst",
// "You do not have permission to attach the selected translations" => "You do not have permission to attach the selected translations",
"Could not attach the translations" => "No s'ha pogut adjuntar la traducció",
// "You do not have permission to detach the selected translations" => "You do not have permission to detach the selected translations",
"The object has no language indicated and cannot be translated" => "Objecte no té idioma i no pot ser traduït",
// "The language directory is not readable" => "The language directory is not readable",
// "The language directory is not writeable" => "The language directory is not writeable",
// "String translation set is not an array" => "String translation set is not an array",
// "Can not fopen custom.php" => "Can not fopen custom.php",
// "Can not fwrite custom.php" => "Can not fwrite custom.php",
// "Source string translation set is not an array" => "Source string translation set is not an array",
// "Target string translation set is not an array" => "Target string translation set is not an array",
// "Invalid process type" => "Invalid process type",
// "Add new and update existing" => "Add new and update existing",
// "Add new only" => "Add new only",
// "Update existing only" => "Update existing only",
// "Replace all" => "Replace all",
// "Failed to connect or authenticate with remote host" => "Failed to connect or authenticate with remote host",
// "Account created or modified" => "Account created or modified",
// "Account not created or modified" => "Account not created or modified",
// "Modify Account" => "Modify Account",
// "Create Account" => "Create Account",
// "Account removed" => "Account removed",
// "Account not removed" => "Account not removed",
// "Remove Account" => "Remove Account",
// "Menu %0 not found" => "Menu %0 not found",
// "The %0 menu has been edited" => "The %0 menu has been edited",
// "The %0 menu has been created" => "The %0 menu has been created",
// "An error occurred - the %0 menu may not have been edited" => "An error occurred - the %0 menu may not have been edited",
// "An error occurred - the %0 menu may not have been created" => "An error occurred - the %0 menu may not have been created",
// "Edit Menu" => "Edit Menu",
// "Create Menu" => "Create Menu",
// "Menu %0 cloned as menu %1" => "Menu %0 cloned as menu %1",
"Clone this menu and its options" => "Clonar aquest menú i les seves opcions",
// "Menu option %0 not found" => "Menu option %0 not found",
// "Menu Option %0" => "Menu Option %0",
// "Create Menu Option" => "Create Menu Option",
// "Your menu options have been imported" => "Your menu options have been imported",
// "Import Menu Options" => "Import Menu Options",
// "Menu Preview" => "Menu Preview",
// "The %0 menu has been removed" => "The %0 menu has been removed",
// "The %0 menu has not been removed" => "The %0 menu has not been removed",
// "Delete the %0 menu" => "Delete the %0 menu",
// "You don't have permission to edit menus (tiki_p_edit_menu)" => "You don't have permission to edit menus (tiki_p_edit_menu)",
// "You don't have permission to edit menu options (tiki_p_edit_menu_option)" => "You don't have permission to edit menu options (tiki_p_edit_menu_option)",
// "You don't have permission to edit menu options (edit_menu_option)" => "You don't have permission to edit menu options (edit_menu_option)",
// "Must Read" => "Must Read",
// "Invalid request method" => "Invalid request method",
// "Cannot circulate" => "Cannot circulate",
// "Circulate" => "Circulate",
// "Group does not exist" => "Group does not exist",
// "Misconfigured feature" => "Misconfigured feature",
// "Target field not found" => "Target field not found",
// "Object not found" => "Object not found",
// "Must Read for %0" => "Must Read for %0",
// "Must Read Item not found" => "Must Read Item not found",
"Read" => "Llegeix",
// "Respond Privately" => "Respond Privately",
"Completed" => "Completada",
"Missing %0 parameter" => "Missing %0 paràmetres",
// "Not Found" => "Not Found",
"No box available for %0" => "No hi ha caixa disponible per %0",
// "Invalid attribute name \"%0\"" => "Invalid attribute name \"%0\"",
// "Cannot lock \"%0\"" => "Cannot lock \"%0\"",
// "Reserved for payment administrators" => "Reserved for payment administrators",
// "Recommendations for %0" => "Recommendations for %0",
"Remote service inaccessible (%0)" => "Inaccessible servei remot (%0)",
// "Execution output" => "Execution output",
// "Scheduler %0 - FAILED" => "Scheduler %0 - FAILED",
// "Scheduler %0 - OK" => "Scheduler %0 - OK",
// "Running %0" => "Running %0",
// "Reset scheduler run" => "Reset scheduler run",
"Rebuild Index" => "Rebuild Index",
// "Process Update Queue" => "Process Update Queue",
"empty" => "buit",
// "Lookup Result" => "Lookup Result",
// "ManifoldCF Configuration Check" => "ManifoldCF Configuration Check",
// "Create ManifoldCF Index" => "Create ManifoldCF Index",
// "A query could not be created because the name is already in use" => "A query could not be created because the name is already in use",
// "Could not obtain the query" => "Could not obtain the query",
// "Save Search" => "Save Search",
// "Saved Searches" => "Saved Searches",
// "Delete Saved Search" => "Delete Saved Search",
// "Edit Saved Search" => "Edit Saved Search",
// "Search functionality currently unavailable" => "Search functionality currently unavailable",
// "Theme Customizer" => "Theme Customizer",
// "Item not found" => "Item not found",
"Reserved for tracker administrators" => "Reservat als administradors del formulari-bd",
"Type does not exist" => "Tipus no existeix",
"Add Field" => "Afegeix un camp",
// "Warning: There is a conflict in permanent names, which can cause indexing errors" => "Warning: There is a conflict in permanent names, which can cause indexing errors",
// "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4" => "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4",
// "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen" => "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen",
"Warning: Required field types not enabled: %0" => "Advertència: els tipus de camp requerits no habilitats: %0",
"Tracker contains no listed field, no meaningful information will be provided in the default list" => "Formulari-bd conté cap camp en la llista, sense informació significativa es proporcionarà en la llista per omissió",
"The tracker contains no field in the title, so no link will be generated" => "Formulari-bd conté cap camp en el títol, no es generarà cap vincle",
// "Field handler not found" => "Field handler not found",
// "%0" => "%0",
"CAPTCHA" => "CAPTCHA",
"Distinct" => "Diferent",
"Page Name" => "Nom de pàgina",
"Password" => "Contrasenya",
"Regular Expression (Pattern)" => "Regular Expression (Pattern)",
"Username" => "Nom d'usuari",
// "Export Fields" => "Export Fields",
"Invalid data provided" => "Dades no vàlides sempre",
"Import Tracker Fields" => "Importa Camps del Formulari-bd",
"No item to clone" => "Cap element de clonar",
// "Duplicate Item" => "Duplicate Item",
// "Item could not be created. Only one item per user is allowed" => "Item could not be created. Only one item per user is allowed",
// "Item created" => "Item created",
// "New \"%0\" item successfully created" => "New \"%0\" item successfully created",
// "New tracker item %0 successfully created" => "New tracker item %0 successfully created",
// "Tracker item could not be created" => "Tracker item could not be created",
"Create Item" => "Crear article",
// "Tracker item %0 has been updated" => "Tracker item %0 has been updated",
// "%0: Updated \"%1\"" => "%0: Updated \"%1\"",
// "Comment for edit #%0" => "Comment for edit #%0",
// "Update Item" => "Update Item",
// "Are you sure you would like to update this item" => "Are you sure you would like to update this item",
"Save" => "Guardar",
// "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0" => "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0",
// "Tracker item %0 has been successfully deleted" => "Tracker item %0 has been successfully deleted",
"Remove" => "Elimina",
"Validation error" => "Error de validació",
// "Create Tracker" => "Create Tracker",
"Duplicate Tracker" => "Duplica el formulari-bd",
// "Export Items" => "Export Items",
// "Import Tracker Structure" => "Import Tracker Structure",
"File upload failed" => "Càrrega d'arxius fallat",
"Uploaded file could not be read" => "L'arxiu carregat no es pot llegir",
// "Import Items" => "Import Items",
// "Import Tracker From Profile/YAML" => "Import Tracker From Profile/YAML",
"Last Modification" => "Última modificació",
"Creation Date" => "Data de creació",
"Item ID" => "ID de l'article",
"Filename" => "Nom d'arxiu",
"Creation date" => "Data de creació",
"Views" => "Vistes",
"File size" => "Mida del fitxer",
"Version" => "Versió",
"File type" => "Tipus d'arxiu",
"Long description" => "Descripció llarga",
"User" => "Usuari",
// "Select Tracker" => "Select Tracker",
"You don't have permission to view the tracker" => "No se'ls permet veure el tracker",
"The item to clone isn't visible" => "Article clonar no visible",
"You don't have permission to create new items" => "No es permet crear nous elements",
// "Cannot remove item %0 from this tracker" => "Cannot remove item %0 from this tracker",
"You don't have permission to export" => "No es permet l'exportació",
"Remote Source" => "Font remot",
"Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Camp generat automàticament per formularis-bd sincronitzats. Conté el Itemid de l'element remot",
// "Clone Remote Tracker" => "Clone Remote Tracker",
"Tracker does not exist" => "Formulari-bd no existeix",
"Tracker is not synchronized with a remote source" => "Formulari-bd no està sincronitzat amb una font remota",
// "Tabular Formats" => "Tabular Formats",
// "Remove Format" => "Remove Format",
// "Create Tabular Format" => "Create Tabular Format",
// "Edit Format: %0" => "Edit Format: %0",
// "Format %0 not found" => "Format %0 not found",
// "Duplicate Format: %0" => "Duplicate Format: %0",
// "%0 copy" => "%0 copy",
// "Fields in %0" => "Fields in %0",
// "No formats available" => "No formats available",
// "Select Format" => "Select Format",
// "Primary Key required" => "Primary Key required",
// "Your import was completed successfully" => "Your import was completed successfully",
"Import" => "Importa",
// "Filter %0" => "Filter %0",
"Filter" => "Filtra",
"Export %0" => "Exporta %0",
"Export" => "Exporta",
// "Create tabular format and tracker from file" => "Create tabular format and tracker from file",
"Operation reserved for tracker administrators" => "Operació reservada per als administradors del formulari-bd",
"Events" => "Events",
"The following mandatory fields are missing: %0" => "Seguint camps obligatoris estan perdent: %0",
"Invalid value in %0: %1" => "Valor no vàlid en %0: %1",
"Invalid value in %0" => "Valor no vàlid en el %0",
// "Field %0 does not exist in tracker" => "Field %0 does not exist in tracker",
"The terms and conditions were modified while you were reading them" => "Els termes i condicions han estat modificats mentre els estaves llegint",
"You are required to approve the terms of use to continue" => "Cal que aprovis els termes d'ús per poder continuar",
"Terms and Conditions" => "Termes i condicions",
"You must enter your date of birth to continue" => "Cal que introdueixis teva data de naixement per continuar",
"Age Validation" => "Validació d'edat",
// "We were unable to create your account because this email is already in use" => "We were unable to create your account because this email is already in use",
"Friend" => "Amic/ga",
"Remove Friend" => "Treu a un/a amic/ga",
"Add Friend" => "Afegeix un/a amic/ga",
"Following you" => "Seguint-te",
"Remove Follower" => "Treu seguidor/a",
"You are following" => "Estàs seguint a",
"Stop Following" => "Deixa de seguir a",
"Follow" => "Segueix-lo",
"Awaiting your approval" => "Esperant la teva aprovació",
"Refuse Request" => "Rebutja la petició",
"Accept &amp; Add" => "Accepta'l/la i Afegeix-lo/la",
"Accept Request" => "Accepta la Petició",
"Waiting for approval" => "Esperant l'aprovació",
"Cancel Request" => "Cancel·la la Petició",
"Hidden" => "Ocult",
"km" => "km",
"You need to set \"Show my information on mouseover\"" => "Has de posar la teva informació per a que surti en passar el ratolí per sobre",
"Click here" => "Clic aquí",
"You need to log in" => "T'has de connectar",
// "Delete the following user" => "Delete the following user",
// "Delete the following users" => "Delete the following users",
// "No users were selected. Please select one or more users" => "No users were selected. Please select one or more users",
// "The following user has been deleted" => "The following user has been deleted",
// "Submit form below to ban this user" => "Submit form below to ban this user",
// "The following users have been deleted" => "The following users have been deleted",
// "Submit form below to ban these users" => "Submit form below to ban these users",
// "Ban the following user's IP" => "Ban the following user's IP",
// "Clicking Ban will redirect you to a form where this user's is preselected for IP banning" => "Clicking Ban will redirect you to a form where this user's is preselected for IP banning",
// "Ban the following users' IPs" => "Ban the following users' IPs",
// "Clicking Ban will redirect you to a form where these users' are preselected for IP banning" => "Clicking Ban will redirect you to a form where these users' are preselected for IP banning",
// "See highlighted section in the form below for users you have selected for banning" => "See highlighted section in the form below for users you have selected for banning",
// "Remove the following user from group %0" => "Remove the following user from group %0",
// "For this user" => "For this user",
// "For these selected users" => "For these selected users",
// "Change group assignments for selected users" => "Change group assignments for selected users",
"%s %s assigned to %s %s" => " %s %s assignat a %s %s",
"user" => "usuari",
"group" => "grup",
// "An error occurred. The group assignment failed" => "An error occurred. The group assignment failed",
"%s %s removed from %s %s." => "S'ha eliminat %s %s de %s %s.",
// "The following user" => "The following user",
// "The following users" => "The following users",
// "%0 had the following group set as default" => "%0 had the following group set as default",
// "%0 been %1 the following %2" => "%0 been %1 the following %2",
// "Set default group for selected users" => "Set default group for selected users",
// "Make this the default group" => "Make this the default group",
// "group %s set as the default group for user %s" => "group %s set as the default group for user %s",
// "For the following user" => "For the following user",
// "For the following users" => "For the following users",
// "The following group has been set as the default group" => "The following group has been set as the default group",
// "Send wiki page content by email to selected users" => "Send wiki page content by email to selected users",
"Page not found" => "No s'ha trobat la pàgina",
// "The page does not have a description, which is mandatory to perform this action" => "The page does not have a description, which is mandatory to perform this action",
// "Invalid bcc email address" => "Invalid bcc email address",
// "and blind copied (bcc) to %0" => "and blind copied (bcc) to %0",
// "The template page has no text or the text cannot be extracted" => "The template page has no text or the text cannot be extracted",
// "Mail sent to user %s" => "Mail sent to user %s",
// "The page %0 has been emailed to the following user" => "The page %0 has been emailed to the following user",
// "The page %0 has been emailed to the following users" => "The page %0 has been emailed to the following users",
// "And blind copied to %0" => "And blind copied to %0",
// "No user was selected" => "No user was selected",
// "Message not sent - no subject or body" => "Message not sent - no subject or body",
// "Your message was successfully sent to %0" => "Your message was successfully sent to %0",
"An error occurred, please check your mail settings and try again" => "S'ha produït un error, comproveu la configuració del correu per favor i torna a intentar",
// "Please specify validity period" => "Please specify validity period",
// "The group %0 does not exist" => "The group %0 does not exist",
// "Your invite has been sent" => "Your invite has been sent",
// "You must set a user for whom to set an avatar" => "You must set a user for whom to set an avatar",
// "You do not have the permission to change the avatar" => "You do not have the permission to change the avatar",
// "You must select an avatar to upload" => "You must select an avatar to upload",
// "An error occurred. User page for %0 could not be deleted" => "An error occurred. User page for %0 could not be deleted",
"Deleted account %s" => "Compte eliminat %s",
// "An error occurred. User %0 could not be deleted" => "An error occurred. User %0 could not be deleted",
"secure connection required" => "connexió segura requerida",
"You cannot see this user's data" => "No pots veure les dades d'aquest/a usuari/a",
// "Send Me a Message" => "Send Me a Message",
// "Upload Avatar" => "Upload Avatar",
"Must be authenticated" => "Ha d'estar autenticat",
// "Notifications for %0" => "Notifications for %0",
// "No notifications" => "No notifications",
"Notifications" => "Notificacions",
// "Unread Notifications" => "Unread Notifications",
// "Mark all notifications as read" => "Mark all notifications as read",
"Must be registered" => "Ha d'estar registrat",
// "Friend List" => "Friend List",
"User not found" => "No es troba l'usuari",
"Approve Friend" => "Aprova a un/a amic/ga",
// "Regenerate Wiki URLs" => "Regenerate Wiki URLs",
// "the only version of" => "the only version of",
// "all versions of" => "all versions of",
// "the last version of" => "the last version of",
// "Delete %0 the following %1" => "Delete %0 the following %1",
// "You do not have permission to remove the selected page(s)" => "You do not have permission to remove the selected page(s)",
// "No pages were selected. Please select one or more pages" => "No pages were selected. Please select one or more pages",
// "An error occurred. %0%1 could not be deleted" => "An error occurred. %0%1 could not be deleted",
"All versions" => "Totes les versions",
// "The last version" => "The last version",
// "Version %0" => "Version %0",
// "%0 of the following page %1 been deleted" => "%0 of the following page %1 been deleted",
// "%0 of the following pages %1 been deleted" => "%0 of the following pages %1 been deleted",
// "Redirection page not specified. 301 redirect not created" => "Redirection page not specified. 301 redirect not created",
// "Semantic aliases (301 Redirects) to this page were created when other pages were deleted" => "Semantic aliases (301 Redirects) to this page were created when other pages were deleted",
// "A semantic alias (301 Redirect) to this page was created when page %0 was deleted" => "A semantic alias (301 Redirect) to this page was created when page %0 was deleted",
// "301 Redirects to the following page were created" => "301 Redirects to the following page were created",
// "A 301 Redirect to the following page was created" => "A 301 Redirect to the following page was created",
// "The following page and 301 Redirects to it were created" => "The following page and 301 Redirects to it were created",
// "The following page and a 301 Redirect to it were created" => "The following page and a 301 Redirect to it were created",
// "Delete the following %0 of %1" => "Delete the following %0 of %1",
// "No version were selected. Please select one or more versions" => "No version were selected. Please select one or more versions",
// "An error occurred. Version %0 could not be deleted" => "An error occurred. Version %0 could not be deleted",
// "The following version of %0 has been deleted" => "The following version of %0 has been deleted",
// "The following versions of %0 have been deleted" => "The following versions of %0 have been deleted",
// "Print the following page" => "Print the following page",
// "Print the following pages" => "Print the following pages",
"Print" => "Imprimir",
// "No page specified" => "No page specified",
// "Export the following page to PDF" => "Export the following page to PDF",
// "Export the following pages to PDF" => "Export the following pages to PDF",
"PDF" => "PDF",
// "Lock the following page" => "Lock the following page",
// "Lock the following pages" => "Lock the following pages",
"Lock" => "Bloquejar",
// "Excludes selected pages already locked or for which you lack permission to lock" => "Excludes selected pages already locked or for which you lack permission to lock",
// "You do not have permission to lock the selected pages or they have already been locked" => "You do not have permission to lock the selected pages or they have already been locked",
// "The following page was not locked due to an error" => "The following page was not locked due to an error",
// "The following pages were not locked due to an error" => "The following pages were not locked due to an error",
// "The following page has been locked" => "The following page has been locked",
// "The following pages have been locked" => "The following pages have been locked",
// "Unlock the following page" => "Unlock the following page",
// "Unlock the following pages" => "Unlock the following pages",
"Unlock" => "Desbloquejar",
// "Excludes selected pages already unlocked or for which you lack permission to unlock" => "Excludes selected pages already unlocked or for which you lack permission to unlock",
// "You do not have permission to unlock the selected pages or they have already been unlocked" => "You do not have permission to unlock the selected pages or they have already been unlocked",
// "The following page was not unlocked due to an error" => "The following page was not unlocked due to an error",
// "The following pages were not unlocked due to an error" => "The following pages were not unlocked due to an error",
// "The following page has been unlocked" => "The following page has been unlocked",
// "The following pages have been unlocked" => "The following pages have been unlocked",
// "Download a zipped file of the following page" => "Download a zipped file of the following page",
// "Download a zipped file of the following pages" => "Download a zipped file of the following pages",
// "Zip" => "Zip",
// "Add page name as header of the following page" => "Add page name as header of the following page",
// "Add page name as header of the following pages" => "Add page name as header of the following pages",
// "The following page was not found" => "The following page was not found",
// "The following pages were not found" => "The following pages were not found",
// "The page name was added as header to the following page" => "The page name was added as header to the following page",
// "The page name was added as header to the following pages" => "The page name was added as header to the following pages",
// "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents",
// "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents",
// "Create Workspace" => "Create Workspace",
// "Workspace Templates" => "Workspace Templates",
// "Create Workspace Template" => "Create Workspace Template",
"Edit template %0" => "Edita la plantilla %0",
"Workspaces" => "Espais de treball",
"Could not create workspace root" => "No s'ha pogut crear l'arrel espai de treball",
"Invalid user" => "Invàlid usuari",
// "Invalid token" => "Invalid token",
// "Empty authorization" => "Empty authorization",
// "Wrong authorization format" => "Wrong authorization format",
// "You don't have enough privileges" => "You don't have enough privileges",
// "Select a filter" => "Select a filter",
"n/a" => "n/a",
// "Server-side Processing" => "Server-side Processing",
// "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort" => "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort",
"Overall Sort Settings" => "Paràmetres d'ordenació Globals",
// "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts" => "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts",
"Pre-sorted Columns" => "Columnes pre-ordenades",
// "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns" => "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns",
"Sort Settings by Column" => "Paràmetres d'ordenació per Columna",
// "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5" => "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5",
// "Set %0 to one of the following" => "Set %0 to one of the following",
// "Also handle strings in numeric columns with" => "Also handle strings in numeric columns with",
// "Handle empty cells with" => "Handle empty cells with",
// "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)" => "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)",
// "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5" => "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5",
"Column Filters" => "Filtres de columna",
// "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters" => "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters",
// "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)" => "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)",
// "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>" => "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>",
// "Options generated automatically if not set and the %0server%1 parameter is not %0y%1" => "Options generated automatically if not set and the %0server%1 parameter is not %0y%1",
// "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown" => "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown",
// "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually" => "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually",
"Date range - " => "Rang de dates -",
"(from and to values set defaults for these fields when user clicks on the input field)" => "(Des i cap als valors establerts per omissió per a aquests camps quan l'usuari fa clic al camp d'entrada)",
// "Beware that items with empty date values will not be shown when default date range filters are applied" => "Beware that items with empty date values will not be shown when default date range filters are applied",
"Numeric range - " => "Rang numèric -",
"No filter - " => "No filter -",
// "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list" => "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list",
"Filter Options" => "Opcions de filtre",
// "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1" => "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1",
"Paginate" => "Paginar",
// "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: " => "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: ",
// "Column Select" => "Column Select",
// "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns" => "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns",
// "Totals" => "Totals",
// "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1" => "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1",
// "Setting to %0 will add one column total row set as follows: %1" => "Setting to %0 will add one column total row set as follows: %1",
// "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations" => "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations",
// "Instructions for each total option follows" => "Instructions for each total option follows",
// "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total" => "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total",
// "set what the calculation is. Choices are" => "set what the calculation is. Choices are",
// "Click %0 for a description of these options" => "Click %0 for a description of these options",
// "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)" => "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)",
// "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals" => "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals",
// "Total Format" => "Total Format",
// "Format for table totals (click %0 for patterns). Example" => "Format for table totals (click %0 for patterns). Example",
// "Total Options" => "Total Options",
// "Pipe-separated options for totals for each column which are set in the %0 parameter" => "Pipe-separated options for totals for each column which are set in the %0 parameter",
// "overrides the default number format set in %0" => "overrides the default number format set in %0",
// "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter" => "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter",
"Example" => "Ex.",
// "Page totals" => "Page totals",
// "Please install Faker package" => "Please install Faker package",
// "Object \"%0\" of type \"%1\" not found" => "Object \"%0\" of type \"%1\" not found",
// "The value of items is not a number" => "The value of items is not a number",
"Tracker not found" => "Formulari-bd no trobat",
// "Invalid field definition: %0" => "Invalid field definition: %0",
// "Checking for image gallery files skipped" => "Checking for image gallery files skipped",
// "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter" => "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter",
// "Tracker Attachments" => "Tracker Attachments",
"Wiki Attachments" => "Adjunts a pàgines Wiki",
// "Forum Attachments" => "Forum Attachments",
// "Configured to stores files in Database" => "Configured to stores files in Database",
// "Configured to stores files on Disk: %0" => "Configured to stores files on Disk: %0",
// "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files" => "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files",
// "Files in DB: %0" => "Files in DB: %0",
// "Files on Disk: %0" => "Files on Disk: %0",
// "No Issues found" => "No Issues found",
// "Found %0 Issues, details below" => "Found %0 Issues, details below",
// "The following files are missing" => "The following files are missing",
"Id" => "Id",
// "The following files have different size that expected" => "The following files have different size that expected",
// "The following files are unknown, exists in the folder, but not in the database" => "The following files are unknown, exists in the folder, but not in the database",
// "Copy files from file galleries to a regular directory on the file system" => "Copy files from file galleries to a regular directory on the file system",
// "Feature Galleries not set up" => "Feature Galleries not set up",
// "File Copy: Gallery #%0 not found" => "File Copy: Gallery #%0 not found",
// "File Copy: Destination path required" => "File Copy: Destination path required",
// "No files to copy" => "No files to copy",
// "File Copy starting.." => "File Copy starting..",
// "File Copy complete" => "File Copy complete",
// "Move files from file galleries to a regular directory on the file system" => "Move files from file galleries to a regular directory on the file system",
// "File Move: Gallery #%0 not found" => "File Move: Gallery #%0 not found",
// "File Move: Destination path required" => "File Move: Destination path required",
// "No files to move" => "No files to move",
// "Use the --confirm option to proceed with the move operation" => "Use the --confirm option to proceed with the move operation",
// "File Move starting.." => "File Move starting..",
// "File Move complete" => "File Move complete",
// "Migrate images from the Image Gallery to the File Gallery" => "Migrate images from the Image Gallery to the File Gallery",
// "All files migrated" => "All files migrated",
// "No files migrated, default file gallery path is not writable" => "No files migrated, default file gallery path is not writable",
// "%0 reached for %1 (%2)" => "%0 reached for %1 (%2)",
"Search index could not be updated: %0" => "Índex de cerca no es va poder actualitzar: %0",
// "Clean Tiki install" => "Clean Tiki install",
// "Force installation. Overwrite any current database" => "Force installation. Overwrite any current database",
// "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM" => "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM",
// "Installation completed" => "Installation completed",
// "Queries executed successfully: %0" => "Queries executed successfully: %0",
// "Error %0 in" => "Error %0 in",
// "Database already exists" => "Database already exists",
// "Dependencies not satisfied. Exiting" => "Dependencies not satisfied. Exiting",
// "Composer could not be executed" => "Composer could not be executed",
// "Extension %0 is now disabled" => "Extension %0 is now disabled",
// "Extension %0 was not disabled" => "Extension %0 was not disabled",
// "Extension %0 was updated" => "Extension %0 was updated",
// "Extension %0 is now enabled" => "Extension %0 is now enabled",
// "Extension %0 was not enabled" => "Extension %0 was not enabled",
// "Installing package: " => "Installing package: ",
// "Invalid Package: " => "Invalid Package: ",
// "No packages available to be installed" => "No packages available to be installed",
// "No packages found in composer.json in the root of the project" => "No packages found in composer.json in the root of the project",
// "No packages installed" => "No packages installed",
// "Packages Installed" => "Packages Installed",
// "Packages Available to Install" => "Packages Available to Install",
// "No packages available to be removed" => "No packages available to be removed",
// "Removing package: " => "Removing package: ",
// "Packages that can be removed" => "Packages that can be removed",
// "No packages available to be updated" => "No packages available to be updated",
// "Updating package: " => "Updating package: ",
// "Packages that can be updated" => "Packages that can be updated",
// "Approve a list of plugin invocations/calls" => "Approve a list of plugin invocations/calls",
// "List fingerprints of the plugin invocations/calls to approve separated by commas" => "List fingerprints of the plugin invocations/calls to approve separated by commas",
// "Approve all plugin invocations/calls" => "Approve all plugin invocations/calls",
// "You must either use the option --all or provide a list of fingerprints to approve" => "You must either use the option --all or provide a list of fingerprints to approve",
// "Approving all pending plugins" => "Approving all pending plugins",
// "Approving a list of plugins" => "Approving a list of plugins",
// "Approving plugin %0" => "Approving plugin %0",
// "Plugins approved with success" => "Plugins approved with success",
// "List all plugin invocations/calls" => "List all plugin invocations/calls",
// "Shows only invocations/calls pending approval" => "Shows only invocations/calls pending approval",
// "Listing plugins in status: %0" => "Listing plugins in status: %0",
// "Found %0 plugins" => "Found %0 plugins",
// "No plugins found" => "No plugins found",
// "Parses all the pages to refresh the list of plugin invocations/calls" => "Parses all the pages to refresh the list of plugin invocations/calls",
// "Plugin list refreshed with success" => "Plugin list refreshed with success",
// "Not enough arguments (missing: \"article\" or \"--all\" options)" => "Not enough arguments (missing: \"article\" or \"--all\" options)",
// "Not enough arguments (missing: \"calendar\" or \"--all\" option)" => "Not enough arguments (missing: \"calendar\" or \"--all\" option)",
// "Not enough arguments (missing: \"category\" or \"--all\" options)" => "Not enough arguments (missing: \"category\" or \"--all\" options)",
// "Not enough arguments (missing: \"forum\" or \"--all\" option)" => "Not enough arguments (missing: \"forum\" or \"--all\" option)",
// "Not enough arguments (missing: \"menu\" or \"--all\" option)" => "Not enough arguments (missing: \"menu\" or \"--all\" option)",
// "Not enough arguments (missing: \"name\" or \"--all\" options)" => "Not enough arguments (missing: \"name\" or \"--all\" options)",
// "Not enough arguments (missing: \"tracker\" or \"--all\" option)" => "Not enough arguments (missing: \"tracker\" or \"--all\" option)",
// "No Items found to export" => "No Items found to export",
// "Tracker item %0 exported" => "Tracker item %0 exported",
// "Tracker item %0 failed to exported" => "Tracker item %0 failed to exported",
// "Tracker items for tracker %0 exported" => "Tracker items for tracker %0 exported",
// "Not enough arguments (missing: \"page\" or \"--all\" option)" => "Not enough arguments (missing: \"page\" or \"--all\" option)",
"Profile name" => "Nom del perfil",
// "profiles.tiki.org" => "profiles.tiki.org",
// "Re-apply profiles when already applied" => "Re-apply profiles when already applied",
// "Return to the user information about what is going to be applied" => "Return to the user information about what is going to be applied",
// "Some of the named object references in the profile are invalid" => "Some of the named object references in the profile are invalid",
// "Profile applied" => "Profile applied",
// "Installation failed" => "Installation failed",
// "Dry-run for profile: " => "Dry-run for profile: ",
// "Permission removed: " => "Permission removed: ",
// "Permission added: " => "Permission added: ",
// "User modified: " => "User modified: ",
// "User added: " => "User added: ",
// "Group modified: " => "Group modified: ",
// "Group added: " => "Group added: ",
// "Preference set: %0= %1 old value= %2" => "Preference set: %0= %1 old value= %2",
// "Installer added: " => "Installer added: ",
// "Profile was already applied. Nothing happened" => "Profile was already applied. Nothing happened",
// "SCSS Parse Error" => "SCSS Parse Error",
// "SCSS Compiler Error" => "SCSS Compiler Error",
// "SCSS Range Error" => "SCSS Range Error",
// "SCSS Server Error" => "SCSS Server Error",
// "SCSS Error" => "SCSS Error",
// "Preference \"sitemap_enable\" is not enabled" => "Preference \"sitemap_enable\" is not enabled",
// "New sitemap created" => "New sitemap created",
"File not found" => "No s'ha trobat el fitxer",
// "File is not a .zip file" => "File is not a .zip file",
// "Theme installed" => "Theme installed",
// "Theme not found" => "Theme not found",
// "Theme removed successfully" => "Theme removed successfully",
// "An error occurred while deleting theme" => "An error occurred while deleting theme",
// "CSS folder not found" => "CSS folder not found",
// "Configuration file added" => "Configuration file added",
// "Preference inserted or updated" => "Preference inserted or updated",
// "Menu inserted or update" => "Menu inserted or update",
// "Module inserted or update" => "Module inserted or update",
// "Theme updated" => "Theme updated",
// "Could not open file" => "Could not open file",
// "Displays the Tiki (tiki) or PHP version (php), empty to display both" => "Displays the Tiki (tiki) or PHP version (php), empty to display both",
"Internal error: mandatory parameter field_fetch_url is missing" => "Error intern: paràmetre obligatori field_fetch_url falta",
"Internal error: mandatory parameter object_store_url is missing" => "Error intern: paràmetre obligatori object_store_url falta",
// "Problem finding the associated user. %0 is not recognized. See EventNotify.php" => "Problem finding the associated user. %0 is not recognized. See EventNotify.php",
// "Event name may be empty or invalid" => "Event name may be empty or invalid",
// "Arguments are expected to be a value map" => "Arguments are expected to be a value map",
"New File" => "Nou arxiu",
// "Unable to write to destination path: %0" => "Unable to write to destination path: %0",
"Cannot resize the file" => "No s'ha pogut redimensionar l'arxiu",
"Cannot write the file" => "No s'ha pogut escriure l'arxiu",
"Image was reduced: %s x %s -> %s x %s" => "La imatge ha estat reduïda: %s x %s -> %s x %s",
"`%0` does not match acceptable naming patterns" => "'%0' no coincideix amb els patrons de noms acceptables",
// "Duplicate file found as `%0`. Upload rejected" => "Duplicate file found as `%0`. Upload rejected",
// "Mail-in auto-reply" => "Mail-in auto-reply",
"Sorry, you can't use this feature." => "Disculpa, no pots fer servir aquesta funcionalitat.",
// "The functionality you are trying to access is currently disabled" => "The functionality you are trying to access is currently disabled",
// "No required action found" => "No required action found",
// "Rejected message, user globally denied" => "Rejected message, user globally denied",
// "Rejected message, associated action disabled (%0)" => "Rejected message, associated action disabled (%0)",
// "Performing action (%0)" => "Performing action (%0)",
// "Rejected message, user locally denied (%0)" => "Rejected message, user locally denied (%0)",
// "Rejected message, no associated action" => "Rejected message, no associated action",
"Submit Article" => "Envia un Article",
// "Unable to find suitable action" => "Unable to find suitable action",
// "Wiki Append" => "Wiki Append",
// "Wiki Get" => "Wiki Get",
// "Wiki Prepend" => "Wiki Prepend",
// "Wiki Create/Update" => "Wiki Create/Update",
"created from mail-in" => "creat des de correu-dins",
// "Create or update article" => "Create or update article",
// "Reply Handler" => "Reply Handler",
// "Wiki (multiple actions)" => "Wiki (multiple actions)",
// "Login failed for IMAP account on %0:%1 for user %2" => "Login failed for IMAP account on %0:%1 for user %2",
// "Login failed for POP3 account on %0:%1 for user %2" => "Login failed for POP3 account on %0:%1 for user %2",
// "= New composer.json file content" => "= New composer.json file content",
// "= Composer execution output" => "= Composer execution output",
"Errors:" => "Errors:",
// "Unable to download composer installer from %0" => "Unable to download composer installer from %0",
// "Invalid composer installer signature" => "Invalid composer installer signature",
// "composer.phar installed in temp folder" => "composer.phar installed in temp folder",
// "There was a problem when installing Composer" => "There was a problem when installing Composer",
// "Tiki root directory is not writable, so file \"%0\" can not be created" => "Tiki root directory is not writable, so file \"%0\" can not be created",
// "Tiki root directory is not writable, so directory \"%0\" can not be created" => "Tiki root directory is not writable, so directory \"%0\" can not be created",
// "Tiki can not write to file \"%0\"" => "Tiki can not write to file \"%0\"",
// "Tiki can not write to directory \"%0\"" => "Tiki can not write to directory \"%0\"",
// "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping.." => "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping..",
// "Warning: Profile %0 already installed. Skipping.." => "Warning: Profile %0 already installed. Skipping..",
// "Profile %0 applied" => "Profile %0 applied",
// "Warning: Profile %0 is not installed. Skipping.." => "Warning: Profile %0 is not installed. Skipping..",
// "Profile %0 removed" => "Profile %0 removed",
// "%0 library not found. This may be due to a typo or caused by a recent update" => "%0 library not found. This may be due to a typo or caused by a recent update",
// "Package %0 is not a Tiki Extension" => "Package %0 is not a Tiki Extension",
// "Package %0 is already enabled" => "Package %0 is already enabled",
// "Package %0 is not enabled" => "Package %0 is not enabled",
"Calendar does not exist" => "No existeix el Calendari",
"Calendar already exists" => "Ja existeix el Calendari",
"File gallery does not exist" => "No existeix la Galeria d'Arxius",
"File gallery already exists" => "Ja existeix la Galeria d'Arxius",
// "Untitled - From Profile Import" => "Untitled - From Profile Import",
// "Field \"%0\" in Tracker %1 has no value for itemId %2" => "Field \"%0\" in Tracker %1 has no value for itemId %2",
"Created by profile installer" => "Creat per l'instal·lador de perfils",
"Page updated by profile installer" => "Pàgina actualitzada per l'instal·lador de perfils",
// "Tiki (%0) is not satisfiable by profile required Tiki version (%1)" => "Tiki (%0) is not satisfiable by profile required Tiki version (%1)",
"Nothing was changed. Please check the profile for errors" => "Res havia canviat, revisi el perfil dels errors si us plau",
"Applying profile" => "Aplicant el perfil",
"Added (or modified)" => "Afegit/s (o modificat/s)",
"Group changed (or modified)" => "Grup canviar (o modificat)",
// "Installer reverted" => "Installer reverted",
// "Installer removed" => "Installer removed",
// "Group removed" => "Group removed",
// "Group modified" => "Group modified",
// "Permission removed" => "Permission removed",
// "Permission assign" => "Permission assign",
"Preference set" => "Posa Preferència",
// "<error>Package %0:  No folder was found. Did you forgot to install?</error>" => "<error>Package %0:  No folder was found. Did you forgot to install?</error>",
// "Package set" => "Package set",
"Modified permission %s for %s" => "Modificat el permís %s per a %s",
"Modified permission %s on %s/%s for %s" => "Modificat el permís %s en %s / %s per a %s",
"User %0 was added to %1" => "Usuari %0 està en 1%",
"No name" => "Sense nom",
"Bad object" => "Objecte dolent",
// "Could not parse YAML in profile: \"%0\"" => "Could not parse YAML in profile: \"%0\"",
// "Profile Path cannot be found" => "Profile Path cannot be found",
"Syntax error: " => "Error de sintaxi:",
"Circular reference" => "Referència circular",
"Permissions' object must have a field 'type' and 'id'" => "Els permisos d'objecte ha de tenir un camp 'type' i 'id'",
"Needs a 'type' and 'data' field" => "Necessita un 'tipus' i el camp 'data'",
// "Source: %0:%1 (%2)" => "Source: %0:%1 (%2)",
// "Recommendation: %0:%1 (%2)" => "Recommendation: %0:%1 (%2)",
// "The directory with path: ' . \$path_or_id . ' could not be found" => "The directory with path: ' . \$path_or_id . ' could not be found",
// "The file with path: ' . \$path_or_id . ' could not be found" => "The file with path: ' . \$path_or_id . ' could not be found",
// "The wiki page with name: ' . \$name . ' could not be found" => "The wiki page with name: ' . \$name . ' could not be found",
// "Theme already installed" => "Theme already installed",
"Version %0 is no longer supported" => "Versió %0 ja no és compatible",
"A minor upgrade to %0 is strongly recommended" => "Es requereix una actualització menor a %0",
"A major upgrade to %0 is strongly recommended" => "Es requereix una important actualització de %0",
// "Version %0 is still supported. However, an upgrade to %1 is available" => "Version %0 is still supported. However, an upgrade to %1 is available",
"Version %0 is still supported. However, a major upgrade to %1 is available" => "La versió %0 encara està mantinguda. Tot i això, tens disponible una actualització major a %1",
// "Replace spaces with dashes" => "Replace spaces with dashes",
// "Replace spaces with underscores" => "Replace spaces with underscores",
// "URL Encode (Tiki Classic)" => "URL Encode (Tiki Classic)",
// "Duplicate entry found (%0)" => "Duplicate entry found (%0)",
// "Filter error: \"%0\"" => "Filter error: \"%0\"",
"Action" => "Acció",
"Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site" => "Crear un formulari que serà publicat en algun lloc, no necessàriament formularis-bd o fins i tot Tiki",
"The title of the button" => "El títol del botó",
"Post" => "Publicar",
"The protocol to use in the form: either get or post" => "El protocol que s'utilitzarà en la forma: GET o POST",
"Script" => "Guió",
"The URL of the destination of the form" => "L'URL arbitrària de la destinació de la forma",
"Parameters" => "Paràmetres",
"Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form" => "Aquí pàgina:nomdecamp es pot repetir diverses vegades, especifica els noms de les variables per passar en forma, així com el valor pres l'element actual del camp anomenat nom de camp. highlight = prova també es pot repetir i és útil per a valors fixos com params per passar a la forma",
// "Attach articles to the tracker item" => "Attach articles to the tracker item",
"Topic" => "Tema",
// "Default article topic" => "Default article topic",
"Article Type" => "Tipus de l'article",
// "Default article type" => "Default article type",
"Auto-Increment" => "Increment automàtic",
"Enable an incrementing value field, or itemId field" => "Permet a un camp de valor incremental, o camp itemId",
"Start" => "Inici",
"The starting value for the field" => "El valor de partida per al camp",
"Prepend" => "Anteposar",
"Text that will be displayed before the field" => "Text que es mostrarà abans que el camp",
"Append" => "Afegir",
"Text that will be displayed after the field" => "Text que apareixerà després del camp",
"If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "Si es defineix com \"itemId\", s'establirà aquest camp perquè coincideixi amb el valor de la base de dades de valor de camp Itemid real",
// "Update Empty" => "Update Empty",
"No" => "No",
"Yes" => "Si",
// "Note: %0 auto-increment item values updated" => "Note: %0 auto-increment item values updated",
// "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********" => "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********",
// "Date and Time (Calendar Item)" => "Date and Time (Calendar Item)",
// "Associate calendar items with tracker items" => "Associate calendar items with tracker items",
// "Experimental: (work in progress, use with care)" => "Experimental: (work in progress, use with care)",
// "Calendar Id" => "Calendar Id",
// "Calendar to use for associated events" => "Calendar to use for associated events",
// "Show Event Id" => "Show Event Id",
// "Show an input for the event id when editing the field, allow lost events to be reattached" => "Show an input for the event id when editing the field, allow lost events to be reattached",
// "Calendar Item %0 not found" => "Calendar Item %0 not found",
// "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2" => "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2",
"Category" => "Categoria",
"Enable the tracker item to be categorized in one or more categories under the specified main category" => "Permet una o diverses categories en la categoria principal especificat a ser afectats amb l'element del registre",
"Parent Category" => "Categoria Pares",
"Child categories will be provided as options for the field" => "Categories infantils s'ofereixen com a opcions per al camp",
"Input Type" => "Tipus d'entrada",
"User interface control to be used" => "Control de la interfície d'usuari que s'utilitzarà",
"Dropdown" => "Desplegable",
"Radio buttons" => "Els botons de ràdio",
"List box" => "Quadre de llista",
"Multiple-selection checkboxes" => "De selecció múltiple caselles",
"Select All" => "Selecciona-ho tot",
"Includes a control to select all available options for multi-selection controls" => "Inclou un comandament per seleccionar totes les opcions disponibles per als controls de selecció múltiple",
"No controls" => "No hi ha controls",
"Include controls" => "Incloure controls",
"All descendants" => "Tots els descendents",
"Display all descendants instead of only first-level descendants" => "Mostrar els descendents en lloc d'únics de primer nivell",
"First level only" => "Primer nivell només",
"All descendants and display full path" => "Tots els descendents i la ruta completa visualització",
"Displays the field description in a help tooltip" => "Mostra la descripció del camp en una informació sobre eines d'ajuda",
"No help" => "No hi ha ajuda",
"Tooltip" => "Tooltip",
// "Output Type" => "Output Type",
// "Plain list with items separated by line breaks (default)" => "Plain list with items separated by line breaks (default)",
// "Links separated by line breaks" => "Links separated by line breaks",
// "Unordered list of labels" => "Unordered list of labels",
// "Unordered list of links" => "Unordered list of links",
// "Do not Inherit Categories" => "Do not Inherit Categories",
// "Inherit (default)" => "Inherit (default)",
// "Do not inherit" => "Do not inherit",
// "Recategorization event" => "Recategorization event",
// "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving" => "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving",
// "Indexing" => "Indexing",
// "-Blank (no data)-" => "-Blank (no data)-",
// "%0 (any of)" => "%0 (any of)",
// "%0 (all of)" => "%0 (all of)",
// "Tracker items will inherit their tracker's categories unless this option is set" => "Tracker items will inherit their tracker's categories unless this option is set",
"Checkbox" => "Casella de verificació",
"Provide a checkbox field for yes/no, on/off input" => "Proporciona un camp de casella de verificació si / no, encès / apagat d'entrada",
"Computed Field" => "Camp calculat",
"Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type" => "Proporciona un valor calculat sobre la base dels valors de camps numèrics. Penseu en l'ús de serveis web o JavaScript per a realitzar la tasca en lloc d'utilitzar aquest tipus",
"This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field" => "Aquesta característica es troba encara en el seu lloc per a la compatibilitat cap enrere. Mentre que no hi ha defectes associats a la mateixa, que podria ser utilitzat com a vector d'atacs que causen molt de mal. Es recomana camp Webservice o costum JavaScript al lloc d'aquest camp",
"Formula" => "Fórmula",
"The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "La fórmula per calcular el suport a diversos operadors (+ - * / i parèntesis), les referències a un altre camp realitzades amb l'ID de camp precedit per #",
"Decimal Places" => "Decimals",
"Number of decimal places to round to" => "Nombre de decimals per preservar abans de l'arrodoniment",
"Decimal separator when displaying data" => "Separador decimal quan es mostren les dades",
"Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details" => "Caràcter individual. Utilitzeu c per el coma, d per al punt o s per l'espai. El separador decimal vàlid quan el nombre d'inserció poden dependre d'idioma del lloc i el navegador web. Vegeu la documentació per a més detalls",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
"Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed" => "Caràcter individual, utilitzeu c per el coma, d per al punt o s per l'espai. En introduir les dades no es necessita el separador de milers",
"Country Selector" => "Selecció del país",
"Enable a selection from a specified list of countries" => "Permet una selecció d'una llista especificada dels països",
"Display" => "Mostra",
"Specify the rendering type for the field" => "Especifiqueu el tipus de representació per al camp",
"Name and flag" => "Nom i bandera",
"Name only" => "Només nom",
"Flag only" => "Flag només",
"Sort order" => "Ordenació",
"Determines whether the ordering should be based on the translated name or the English name" => "Determina si l'ordre s'ha de basar en la traducció del nom o el nom d'Anglès",
"Translated name" => "Nom Traducció",
"English name" => "Nom Anglès",
"Currency Field" => "Camp de moneda",
"Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric" => "Proporciona un camp d'una línia de només entrada numèrica. Valors de Prefix o Sufix, poden ser alfanumèrics",
"Same Row" => "Mateixa fila",
"Displays the next field on the same line" => "Mostra el camp en la mateixa línia",
"Display Size" => "Mida mostrada per al camp",
"Visible size of the field, in characters. Does not affect the numeric length" => "Mida visible del camp en caràcters. No afecta la longitud numèrica",
"Text to be displayed in front of the currency amount" => "Text que es mostrarà abans de la quantitat de moneda",
"Text to be displayed after the numeric value" => "Text que es mostrarà després del valor numèric",
"Locale" => "Lloc",
"Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Establir configuració regional de format de moneda, per exemple en_US o en_US.UTF-8 o en_US.ISO-8559-1. Per defecte és en_US",
"Currency" => "Moneda",
"A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "Un codi de moneda alfanumèrica personalitzada. No és necessari si està definit una llengua i es desitja un codi estàndard. Per omissió és USD",
"Symbol" => "Símbol",
"Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Establir si el codi de moneda (per exemple USD) o símbol (per exemple, \\ \$) mostrarà. Per omissió és símbol",
"Currency code" => "Codi de moneda",
"Currency symbol" => "Símbol de moneda",
"First or all" => "En primer lloc o la totalitat",
"Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Establir si el codi de moneda o el símbol es mostra en contra de totes les quantitats o només la primera quantitat",
"First item only" => "Primer element únic",
"All" => "Tots",
// "Currency Tracker" => "Currency Tracker",
// "Tracker containing available currencies and exchange rates" => "Tracker containing available currencies and exchange rates",
"Date and Time" => "Data i Hora",
"Provide drop-down options to accurately select a date and/or time" => "Proporciona desplegable d'opcions per seleccionar amb precisió la data i / o hora",
"Components to be included" => "Els components que s'inclouran",
"Date only" => "Només data",
"Start year" => "Any d'inici",
"Year to allow selecting from" => "Any de permetre seleccionar",
"End year" => "Cap d'Any",
"Year to allow selecting to" => "Any de permetre seleccionar",
"Default selection" => "Selecció per omissió",
"Indicates if blank dates should be allowed" => "Indica si les dates en blanc s'ha de permetre",
"Current Date" => "Data actual",
"Blank" => "Blanc",
// "Time Ago" => "Time Ago",
// "Use timeago.js if the feature is enabled" => "Use timeago.js if the feature is enabled",
// "Item Date Field" => "Item Date Field",
// "Use this date as the item's global date in the search index" => "Use this date as the item's global date in the search index",
"Allow users to select only from a specified set of options" => "Permet als usuaris seleccionar només a partir d'un conjunt específic d'opcions",
"Option" => "Opció",
"If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label" => "Una opció, si conté un signe igual, la part prèvia s'utilitza com el valor, mentre que el més tard com l'etiqueta",
"Dropdown selector with \"Other\" field" => "Desplegable amb un altre camp",
"Allow users to select from a specified set of options or to enter an alternate option" => "Permet als usuaris seleccionar entre un conjunt específic d'opcions o per entrar en una opció alternativa",
// "To change the label of the \"Other\" option, use \"other=Label\"" => "To change the label of the \"Other\" option, use \"other=Label\"",
"Radio Buttons" => "Botons d'opció",
"Multiselect" => "Selecció múltiple",
"Allow a user to select multiple values from a specified set of options" => "Permet a l'usuari seleccionar diversos valors d'un conjunt específic d'opcions",
"Dynamic Items List" => "Llista dinàmica d'ítems",
"Dynamically update a selection list based on linked data from another tracker" => "Actualitza dinàmicament una llista de selecció en base a dades vinculades d'un altre formulari-bd",
"Tracker ID" => "Formulari-bd Aneu",
"Tracker to link with" => "Formulari-bd amb el que vincular-se",
"Field ID (Other tracker)" => "ID de camp (a l'altre formulari-bd)",
"Field ID to link with in the other tracker" => "Identificador de camp amb el què enllaçar en l'altre formulari-bd",
"Field ID (This tracker)" => "ID de camp (en aquest formulari-bd)",
"Field ID to link with in the current tracker" => "Identificador de camp amb el que enllaçar en el formulari-bd actual",
"Listed Field" => "Camp Llistat",
"Field ID to be displayed in the dropdown list" => "Identificador de camp que es mostrarà a la llista desplegable",
"Status Filter" => "Filter Status",
"Restrict listed items to specific statuses" => "Restringir els ítmes llistats a estats específics",
"all" => "tots",
"open" => "obert",
"pending" => "pendent",
"closed" => "tancat",
"open, pending" => "obert, pendent",
"pending, closed" => "pendent, tancat",
// "Hide blank" => "Hide blank",
// "Hide first blank option, thus preselecting the first available option" => "Hide first blank option, thus preselecting the first available option",
"Select multiple values" => "Seleccionar diversos valors",
"Allow the user to select multiple values" => "Permetre a l'usuari seleccionar diversos valors",
// "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***" => "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***",
"*** ERROR: Field %0 not found ***" => "*** ERROR: Camp %0 no trobat ***",
// "*** ERROR: No remote tracker selected for DynamicList Field %0 ***" => "*** ERROR: No remote tracker selected for DynamicList Field %0 ***",
// "DynamicList field: Field \"%0\" not found" => "DynamicList field: Field \"%0\" not found",
"Email" => "Correu-e",
"Enable an email address to be input with the option of making it active" => "Permet introduir una adreça de correu electrònic amb les opcions per a fer-ho actiu",
"Link Type" => "Tipus d'enllaç",
"How the email address will be rendered" => "Com es representa l'adreça de correu electrònic",
"Plain text" => "Correu-e en text senzill",
"Encoded mailto link" => "Enllaç codificat al mailto",
"Simple mailto link" => "Enllaç simple al mailto",
"Watch Open" => "Segueix els Oberts",
"Notify this address every time the status changes to open" => "Notificar aquesta adreça cada cop que canvia l'estat a obert",
"Watch Pending" => "Segueix els Pendents",
"Notify this address every time the status changes to pending" => "Notificar aquesta adreça cada cop que canvia l'estat a pendent",
"Watch Closed" => "Segueix els Tancats",
"Notify this address every time the status changes to closed" => "Notificar aquesta adreça cada cop que canvia l'estat a tancat",
"Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Error de la factoria de camps de Formulari-bd: Es requreix la Preferència \"%0\"  per al tipus de camp \"%1\"",
"Attachment" => "Adjunt",
// "Deprecated in favor of the Files field" => "Deprecated in favor of the Files field",
"List View" => "Vista de Llista",
"Defines how attachments will be displayed within the field" => "Defineix com es visualitzen en el camp els arxius adjunts",
"name" => "nom",
"type" => "tipus",
"name, size" => "nom, mida",
"name, type, size" => "nom, tipus, mida",
"uploader" => "carregador",
"mediaplayer" => "mediaplayer",
"Download" => "Descarregar",
"Attached and upload files stored in the file galleries to the tracker item" => "Arxius adjunts i pujats emmagatzemats en galeries d'arxius associats a l'ítem del formulari-bd",
"Gallery ID" => "ID de la Galleria",
"File gallery to upload new files into" => "Galeria d'arxius a on pujar nous arxius",
"MIME Type Filter" => "MIME Tipus de filtre",
"Mask for accepted MIME types in the field" => "Màscara de tipus MIME acceptats al camp",
"File Count" => "Quantitat d'arxius",
"Maximum number of files to be attached on the field" => "Màxim nombre d'arxius que es poden adjuntar al camp",
"Display Mode" => "Mode de visualització",
// "Show files as object links or via a wiki plugin (img so far)" => "Show files as object links or via a wiki plugin (img so far)",
"Links" => "Enllaços",
// "Bare Links" => "Bare Links",
"Table" => "Taula",
"Images" => "Fotos",
"Vimeo" => "Vimeo",
"Google Viewer" => "Visualitzador de Google",
"Moodle Scorm Viewer" => "Visualitzador Scorm de Moodle",
"Display parameters" => "Paràmetres de visaulització",
"URL-encoded parameters used such as in the {img} plugin, for example,." => "URL params codificats utilitzats com en el {img} plugin. v.g.",
"Display parameters for lists" => "Paràmetres de visualització per a llistes",
// "Display Order" => "Display Order",
// "Sort order for the files" => "Sort order for the files",
// "Default (order added to tracker item)" => "Default (order added to tracker item)",
// "Name (A - Z)" => "Name (A - Z)",
// "Name (Z - A)" => "Name (Z - A)",
// "Filename (A - Z)" => "Filename (A - Z)",
// "Filename (Z - A)" => "Filename (Z - A)",
// "Created date (old - new)" => "Created date (old - new)",
// "Created date (new - old)" => "Created date (new - old)",
// "Last modified date (old - new)" => "Last modified date (old - new)",
// "Last modified date (new - old)" => "Last modified date (new - old)",
// "File size (small - large)" => "File size (small - large)",
// "File size (large - small)" => "File size (large - small)",
// "Hits (low - high)" => "Hits (low - high)",
// "Hits (high - low)" => "Hits (high - low)",
"Include Child Galleries" => "Inclou Galeries Filles",
"Use files from child galleries as well" => "Utilitza també els arxius de les galeries filles",
"Replace Existing File" => "Substituir el fitxer existent",
"Replace the existing file, if any, instead of uploading a new one" => "Reemplaçar arxiu existent si existeix, en comptes de pujar-ne un de nou",
"Browse Gallery ID" => "Examina l'ID de Galeria",
"File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)" => "Navega pels arxius de la galeria. Utilitza 0 per veure la galeria de fitxers arrel. (Requereix funció elFinder - experimental)",
// "Restrict permissions to view the file gallery to hide the button" => "Restrict permissions to view the file gallery to hide the button",
"Duplicate Gallery ID" => "ID de Galeria de Duplicats",
"File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)" => "Galeria d'arxius per als arxius duplicats quan es copia un ítem de formulari-bd. 0 ó buit vol dir sense duplicats (valor per omissió)",
// "Index As Map Layer" => "Index As Map Layer",
// "Index the files in a specific format for use in map searchlayers to display trails and features" => "Index the files in a specific format for use in map searchlayers to display trails and features",
// "GeoJSON" => "GeoJSON",
// "GPX" => "GPX",
// "Upload In Modal" => "Upload In Modal",
// "Upload files in a new modal window" => "Upload files in a new modal window",
// "Maximum image width" => "Maximum image width",
// "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings",
// "Maximum image height" => "Maximum image height",
// "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings",
// "Add Descriptions" => "Add Descriptions",
// "Add descriptions on uploaded files" => "Add descriptions on uploaded files",
// "Show files as object links or via a wiki plugin (img, Vimeo)" => "Show files as object links or via a wiki plugin (img, Vimeo)",
// "Files field: Gallery #%0 not found" => "Files field: Gallery #%0 not found",
// "Token access needs to be enabled for Google viewer to be used" => "Token access needs to be enabled for Google viewer to be used",
// "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")" => "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")",
"Problem with uploaded file: \"%0\"" => "Problema amb el fitxer enviat: \" %0 \"",
"No gallery for uploaded file, galleryId=%0" => "No hi ha galeria per fitxer enviat, galleryId=%0",
"You don't have permission to upload a file to gallery \"%0\"" => "No hi ha permisos de càrrega a la galeria \"%0\"",
"Allow tags to be shown or added for tracker items" => "Permet que es mostrin o s'afegeixin marques lliures a ítems del formulari-bd",
"Visible size of the input field" => "Mida visible del camp d'entrada",
"Hide or show the input help" => "Ocultar o mostrar l'ajuda a les entrades",
"Show" => "Mostra",
"Hide" => "Oculta",
"Suggest" => "Suggereix",
"Hide or show the tag suggestions" => "Ocultar o mostrar els suggeriments de marques lliures",
"Geographic Feature" => "Característica geogràfica",
// "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved" => "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved",
"Feature cannot be set or modified through this interface" => "Aquesta funció no es pot ajustar o modificar a través d'aquesta interfície",
"Feature cannot be viewed" => "Aquesta funció no es pot veure",
"Group Selector" => "Selector de grups",
"Allow a selection from a specified list of user groups" => "Permet una selecció d'una llista especificada de grups d'usuaris",
"Auto-Assign" => "Auto-Assignar",
"Determines if any group should be automatically assigned to the field" => "Determina si algun grup ha d'assignar automàticament al camp",
"Modifier" => "Modificador",
"Group Filter" => "Filtre de grup",
"Limit listed groups to those including the specified group" => "Límit dels grups que cotitzen en borsa a les que inclouen el grup especificat",
"User Groups" => "Grups d'usuaris",
// "Show groups user belongs to instead of the ones user has permission to see" => "Show groups user belongs to instead of the ones user has permission to see",
"Assign to the group" => "Assigneu al grup",
"For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated" => "En cap camp autoaassigned, l'usuari (selector usuari si exsits o usuari) seran assignats al grup i serà el grup predeterminat. El grup ha de tenir la configuració d'opcions d'usuari en",
"Assign" => "Assigna",
// "Unassign from previous selection" => "Unassign from previous selection",
// "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated" => "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated",
"Unassign" => "Desassigna",
"Email Notification" => "Notificació per correu electrònic",
// "Add selected group to group monitor the item. Group watches feature must be enabled" => "Add selected group to group monitor the item. Group watches feature must be enabled",
"Header" => "Encapçalament",
"Display a heading between fields to delimit a section and allow visual folding of the fields" => "Mostra un encapçalat d'un camp per a delimitar una secció i permeten doblar els camps",
"Heading Level" => "Nivell de capçalera",
"Level of the heading to use for complex tracker structures needing multiple heading levels" => "Durada de la capçalera que s'utilitzarà per a les estructures del formulari-bd complexos que necessiten múltiples nivells de títol",
// "Section Toggle" => "Section Toggle",
"Default State" => "Estat predeterminat",
// "No toggle" => "No toggle",
"Open" => "Obert",
"Closed" => "Tancat",
"Icon" => "Icona",
"Provide the ability to select an image as an icon attached to the tracker item from the file galleries" => "Permet seleccionar una imatge com una icona unit a l'element del registre de les galeries d'arxius",
"Default image" => "Imatge  per omissió",
"Path to the default icon used" => "Ruta a la icona per omissió que s'utilitza",
"Maximum Icons" => "Icones Màx",
"Number of icons to display in each gallery (default 120)" => "Nombre d'icones per mostrar a cada galeria (per omissió 120)",
// "Update icon event" => "Update icon event",
// "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items" => "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items",
"Image" => "Imatge",
"List image width" => "Ample de la imatge de llista",
"Display size in pixels" => "Mostra la mida en píxels",
"List image height" => "Llista d'altura de la imatge",
"Detail image width" => "Ample de la imatge Detall",
"Detail image height" => "Detall alçada de la imatge",
"Maximum image size" => "Mida màxima d'imatge",
"Maximum image width or height in pixels" => "Ample d'imatge màxima o alçada en píxels",
"Shadowbox" => "Shadowbox (permet efectes gràfics moderns en imatges)",
"Shadowbox usage on this field" => "Shadowbox ús en aquest camp",
"Do not use" => "No utilitzeu",
"One box per item" => "Una caixa per article",
"Use the same box for all images" => "Utilitza el mateix quadre per a totes les imatges",
"Missing Icon" => "Falta Icona",
"Icon to use when no images have been uploaded" => "Icona per a usar quan no han pujat imatges",
"Invalid imagename (using filters for filenames)" => "Invàlid nom d'imatge (usant filtres per a noms d'arxius)",
"In Group" => "Al Grup",
"Indicate if the user associated with the item is a member of a specified group" => "Si l'usuari associat a l'element és membre d'un grup especificat",
"Group Name" => "Nom del grup",
"Name of the group to verify" => "Nom del grup per verificar",
"How to display the result" => "Com mostrar el resultat",
"Yes/No" => "Sí/No",
"Join date" => "Data d'inscripció",
"Expiration date" => "Data de caducitat",
"IP Selector" => "Selector IP",
"IP address input field" => "Camp d'entrada de l'adreça IP",
"Auto-assign" => "Auto-assignar",
"Automatically assign the value on creation or edit" => "Assignar automàticament el valor en la creació o edició",
"Item Link" => "Enllaç a l'Ítem",
"Link to another item, similar to a foreign key" => "Enllaç a un altre ítem, similar a una clau externa",
"Tracker to link to" => "Formulari-bd al què enllaçar-hi",
"Field ID" => "ID del Camp",
"Default field to display" => "Camp a mostrar per omissió",
"How the link to the item should be rendered" => "Com s'ha de representar l'enllaç a l'ítem",
"Value" => "Valor",
"Link" => "Enllaç",
"Multiple Fields" => "Camps múltiples",
// "Display the values from multiple fields instead of a single one" => "Display the values from multiple fields instead of a single one",
// "Format for Customising Multiple Fields" => "Format for Customising Multiple Fields",
// "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"" => "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"",
// "Multiple Fields display type" => "Multiple Fields display type",
// "Display multiple fields as concatenated list in a dropdown or as a table" => "Display multiple fields as concatenated list in a dropdown or as a table",
// "Plugin TrackerList options" => "Plugin TrackerList options",
// "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)" => "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)",
"Limit the available items to a selected set" => "Límit els ítems disponibles per a un conjunt seleccionat",
"Link Page" => "Enllaç pàgina",
"Link to a wiki page instead of directly to the item" => "Enllaç a una pàgina wiki i no directament a l'ítem",
"Add Items" => "Afegeix Ítems",
"Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Text a mostrar per permetre afegir nous ítems - per exemple, \"Afegeix...\" (requereix jQuery-UI)",
"Add Item Template Page" => "Afegeix Pàgina de plantilla d'Ítem",
"Wiki page to use as a Pretty Tracker template" => "Pàgina Wiki per utilitzar com a plantilla per Formulari-bd Maco",
"Preselect item based on value in this field" => "Preselecciona ítems segons el valor en aquest camp",
"Preselect item based on value in specified field ID of item being edited" => "Preselecciona ítems segons el valor d'ID de camp especificat de l'element que s'està editant",
"Preselect based on the value in this remote field" => "Preselecció basada en el valor en aquest camp remot",
"Match preselect item to this field ID in the tracker that is being linked to" => "Casa ítem preseleccionat amb aquest ID de camp al formulari-bd al que s'hi està vinculant",
"Preselection matching method" => "Mètode de correspondència de preselecció",
"Method to use to match fields for preselection purposes" => "Mètode a emprar de cara a que coincideixin els camps per als propòsits de preselecció",
"Exact Match" => "Troballa exacta",
"Field here is part of field there" => "El camp aquí és part del camp allà",
"Match domain, used for URL fields" => "Identifica domini, s'utilitza per als camps d'URL",
"Cross select. Load all matching items in the remote tracker" => "Selecció Creuada. Carrega tots els ítems que encaixin al formulari-bd remot",
// "Cross select. Load all matching items in the remote tracker plus wildcards" => "Cross select. Load all matching items in the remote tracker plus wildcards",
"One item per value" => "Un ítem per cada valor",
// "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items" => "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items",
"Displays all the items for a same label with a notation value (itemId)" => "Mostra tots els elements per a una mateixa etiqueta amb un valor de notació (itemId)",
// "Display only one item for each label" => "Display only one item for each label",
"Index remote fields" => "Indexa camps remots",
"Index one or multiple fields from the master tracker along with the child, separated by |" => "Indexa un o diversos camps del formulari-bd principal, juntament amb el fill, separats per |",
"Cascade actions" => "Accions en cascada",
"Status" => "estat",
"Categories and status" => "Categories i estat",
"Categories and delete" => "Categories i eliminar",
"Delete and status" => "Eliminar i estat",
// "ItemLink: Tracker %0 not found for field \"%1\"" => "ItemLink: Tracker %0 not found for field \"%1\"",
// "ItemLink: Field %0 not found for field \"%1\"" => "ItemLink: Field %0 not found for field \"%1\"",
// "ItemLink field \"%0\": Tracker ID #%1 not found" => "ItemLink field \"%0\": Tracker ID #%1 not found",
"Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status" => "Elements a cascada quan el mestre s'actualitza o és eliminat. Les categories poden entrar en conflicte si diversos enllaços d'elements s'utilitzen per a diferents articles que tracten de manejar les mateixes categories. El mateix per a l'estat",
// "Unsupported field conversion type: from %0 to %1" => "Unsupported field conversion type: from %0 to %1",
"Items List" => "Llista d'Ítems",
"Display a list of field values from another tracker that has a relation with this tracker" => "Mostra una llista dels valors dels camps d'un altre formulari-bd que té una relació amb aquest formulari-bd",
"Tracker from which to list items" => "Formulari-bd des del qual mostrar ítems",
"Link Field ID" => "ID del camp d'enllaç",
"Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "ID Camp de l'altre formulari-bd que conté un item d'enllaç assenyalant l'ítem en aquest formulari-bd o algun altre valor a trobar",
"Value Field ID" => "ID del camp del Valor",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty",
"Fields to display" => "Els camps a visualitzar",
"Display alternate fields from the other tracker instead of the item title" => "Mostra els camps alternatius de l'altre formulari-bd en lloc del títol de l'ítem",
// "Format for customising fields to display" => "Format for customising fields to display",
// "Sort Fields" => "Sort Fields",
// "Order results by one or more fields from the other tracker" => "Order results by one or more fields from the other tracker",
"How the link to the items should be rendered" => "Com s'ha de representar la relació dels ítems",
// "Permission denied importing into linked tracker %0" => "Permission denied importing into linked tracker %0",
// "Errors occurred importing into linked tracker %0" => "Errors occurred importing into linked tracker %0",
// "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
"Date and Time (Date Picker)" => "Data i hora (Date Picker)",
"Provide a jQuery UI date picker to select a date and, optionally, a time" => "Proporciona jQuery-UI date picker seleccionar una data i, opcionalment, el temps",
"Default value" => "Valor per omissió",
"Default date and time for new items" => "Data i hora predeterminades per als nous ítems",
"None (undefined)" => "Cap (no definit)",
"Item creation date and time" => "Data i hora de creació de l'ítem",
// "Not before" => "Not before",
// "Field ID from this tracker to compare the value against and validate it is not before that timestamp" => "Field ID from this tracker to compare the value against and validate it is not before that timestamp",
// "Not after" => "Not after",
// "Field ID from this tracker to compare the value against and validate it is not after that timestamp" => "Field ID from this tracker to compare the value against and validate it is not after that timestamp",
// "Date Picker Field: \"%0\" is not a valid internal date value" => "Date Picker Field: \"%0\" is not a valid internal date value",
// "%0 cannot be before %1" => "%0 cannot be before %1",
// "%0 cannot be after %1" => "%0 cannot be after %1",
"Kaltura Video" => "Vídeo de Kaltura",
"Display a series of attached Kaltura videos" => "Mostra una sèrie de vídeos de Kaltura adjunts",
// "URL-encoded parameters used in the {kaltura} plugin, for example," => "URL-encoded parameters used in the {kaltura} plugin, for example,",
"Language" => "Llenguatge",
"Assign a language to the tracker item to enable multilingual trackers" => "Assignació d'un idioma a l'ítem del formulari-bd per a habilitar formularis-bd multilingües",
"Indicates if the language should be assigned as the item's language" => "Indica si el llenguatge ha de ser assignat com el llenguatge de l'ítem",
"LDAP" => "LDAP",
"Display a field value from a specific user in LDAP" => "Mostra un valor de camp d'un determinat usuari en LDAP",
"LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "Filtre de LDAP, pot contenir el marcador de posició %field_name% ser reemplaçat amb el nom del camp actual",
"Field name returned by LDAP" => "Nom del camp retornat per LDAP",
"DSN" => "DSN",
"Data source name registered in Tiki" => "Nom de l'origen de dades registrada a Tiki",
"Location" => "Localització",
"Enable a geographic location to be selected for the item and displayed on a map" => "Permet seleccionar una de geolocalització per a l'article i el mostra en un mapa",
"Use as item location" => "Utilitza com a ubicació de l'article",
"List View Width" => "Llista Ample",
"Width of map in pixels when tracker items are shown in list view" => "Ample del mapa en píxels quan els ítems del formulari-bd es mostren en forma de llista",
"List View Height" => "Vista de llista Alçada",
"Height of map in pixels when tracker items are shown in list view" => "Alçada del mapa en píxels quan els ítems del formulari-bd es mostren en forma de llista",
"Item View Width" => "Veure article Ample",
"Width of map in pixels when a single tracker item is shown" => "Ample del mapa en píxels quan es mostren els ítems aïllats del formulari-bd",
"Item View Height" => "Article View Alçada",
"Height of map in pixels when a single tracker item is shown" => "Alçada del mapa en píxels quan es mostren els ítems aïllats del formulari-bd",
// "Fields To Search" => "Fields To Search",
// "Fields in this tracker to use as a source to search for a location for" => "Fields in this tracker to use as a source to search for a location for",
// "When To Search" => "When To Search",
// "Event to attempt to search for a location" => "Event to attempt to search for a location",
"Never" => "Mai",
// "Save (when Location is empty)" => "Save (when Location is empty)",
// "Save (always)" => "Save (always)",
// "Indexing (when Location is empty)" => "Indexing (when Location is empty)",
// "Indexing (always)" => "Indexing (always)",
// "Location: Field %0 not found for field \"%1\"" => "Location: Field %0 not found for field \"%1\"",
// "Could not find a location for \"%0\"" => "Could not find a location for \"%0\"",
"When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps" => "Quan s'activa, registra el valor del camp com la geolocalització de l'element que es mostra en els mapes de localització",
"Mathematical Calculation" => "Càlcul Matemàtic",
"Perform a calculation upon saving the item based on other fields within the same item" => "Realitza un càlcul en desar l'ítem basant-te en altres camps dins del mateix ítem",
"Calculation" => "Càlcul",
"Calculation in the Rating Language" => "Càlcul en l'idioma del sistema de puntuació",
// "Re-calculation event" => "Re-calculation event",
// "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed" => "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed",
// "Value will be re-calculated on save. Current value: %0" => "Value will be re-calculated on save. Current value: %0",
"Numeric Field" => "Camp numèric",
"Text to be displayed in front of the numeric value" => "Text que es mostrarà abans del valor numèric",
"Thousands separator when displaying data" => "Milers separador quan es mostren les dades",
"Page Selector" => "Selector pàgina",
"Allow a selection from the list of pages" => "Permet una selecció de la llista de pàgines",
"Will auto-assign the creator of the item" => "Es auto-assignar el creador del tema",
"Visible size of the input in characters" => "Mida visible de l'entrada de caràcters",
"Create Page" => "Crear pàgina",
"Create missing pages using the page name in this file as the template" => "Crear pàgines que falten utilitzant el nom de la pàgina en aquesta imatge com a plantilla",
"Display the value as a link to the page" => "Mostra el valor com un enllaç a la pàgina",
"Rating" => "Valoració",
// "A rating of the tracker item. Permissions involved: %0" => "A rating of the tracker item. Permissions involved: %0",
"The possible options (comma-separated integers) for the rating" => "Les opcions possibles (números sencers separats per comes) per a la valoració",
"Mode" => "Mode",
"Display rating options as" => "Mostra les opcions de classificació com a",
"Stars" => "Estrelles",
"Single Option: for example, Like" => "Opció individual: per exemple, M'agrada",
"Labels" => "Etiquetes",
"The text labels (comma-separated) for the possible options" => "Les etiquetes de text (separat per comes) per a les opcions possibles",
"Stars (deprecated)" => "Estrelles (obsolet)",
"Display a star rating" => "Mostra el nombre d'estrelles",
"A possible option for the rating" => "Una possible opció per a la qualificació",
// "Stars (system - deprecated)" => "Stars (system - deprecated)",
"Average:" => "Mitjana:",
"Number of votes" => "Nombre de vots",
"Your rating" => "La teva puntuació",
"Relations" => "Relacions",
"Allow arbitrary relations to be created between the trackers and other objects in the system" => "Permet la creació de relacions arbitràries entre els formularis-bd i altres objectes en el sistema",
"Relation" => "Relació",
"Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relació qualificador. Ha de ser un partit de classificació en tres parts que contenen les lletres i separats per punts",
"URL-encoded list of filters to be applied on object selection" => "Llista d'URL-encoded dels filtres que s'aplicaran en la selecció d'objectes",
"Format" => "Format",
// "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field" => "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field",
"Read-only" => "Només lectura",
"Only display the incoming relations instead of manipulating them" => "Només mostrar les relacions d'entrada en lloc de manipular",
"Include Invert" => "Inclogui Invertir",
"Include invert relations in the list" => "Inclogui invertir les relacions de la llista",
"Control how the relations are displayed in view mode" => "Control de la visualització de les relacions en la manera de vista",
"List" => "Llista",
"Count" => "Comptar",
"Count with toggle for list" => "Compta amb palanca per a la llista",
// "Force Refresh" => "Force Refresh",
// "Re-save related tracker items" => "Re-save related tracker items",
// "On Save" => "On Save",
// "Extra Filter Field" => "Extra Filter Field",
// "Filter objects by value of another field. Use a jQuery seletor to target the element in the page" => "Filter objects by value of another field. Use a jQuery seletor to target the element in the page",
// "Extra Filter Key" => "Extra Filter Key",
// "Key to filter objects by using the value from the Extra Filter Field above" => "Key to filter objects by using the value from the Extra Filter Field above",
// "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save" => "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save",
"and" => "i",
// "show.tiki.org" => "show.tiki.org",
// "Create, display or manage show.tiki.org instances" => "Create, display or manage show.tiki.org instances",
// "Domain name of show server" => "Domain name of show server",
// "For example, show.tikiwiki.org" => "For example, show.tikiwiki.org",
// "Supported Versions" => "Supported Versions",
// "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"" => "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"",
// "Shell username on remote server" => "Shell username on remote server",
// "The shell username on the show server" => "The shell username on the show server",
// "Public key file path" => "Public key file path",
// "System path to public key on local server. Only RSA keys are supported" => "System path to public key on local server. Only RSA keys are supported",
// "Private key file path" => "Private key file path",
// "System path to private key on local server. Only RSA keys are supported" => "System path to private key on local server. Only RSA keys are supported",
// "Show debugging information" => "Show debugging information",
// "Show debugging info during testing" => "Show debugging info during testing",
// "Fixed user ID" => "Fixed user ID",
// "Set fixed user ID instead of using the user ID of the creator of the tracker item" => "Set fixed user ID instead of using the user ID of the creator of the tracker item",
"Static Text" => "Text estàtic",
"Display the field description as static text to present notes or additional instructions" => "Mostra la descripció del camp com a text estàtic que es pot utilitzar per mostrar les notes o instruccions addicionals",
"Wiki Parse" => "Analitzar Wiki",
"Indicates if the description should be parsed as wiki syntax for formatting" => "Indica si la descripció s'ha d'analitzar la sintaxi wiki per donar format",
"Handle line breaks as new lines only" => "Manegi salts de línia com noves línies només",
// "Wiki Parse with Pretty Tracker replacements" => "Wiki Parse with Pretty Tracker replacements",
"Maximum Length (List)" => "Longitud màxima (Llista)",
"Maximum number of characters to be displayed in list mode" => "La quantitat màxima de caràcters que es mostrarà en la manera de llista",
"Text Field" => "Camp de text",
"Single-line text input" => "Entrada de text d'una sola línia",
"Display the field name and input on the same row" => "Mostra el nom del camp i l'entrada a la mateixa fila",
"Visible size of the field, in characters" => "Visible mida del camp en caràcters",
"Text to prepend when displaying the value" => "Text per anteposar en mostrar el valor",
"Text to append when displaying the value" => "Text per annexar en mostrar el valor",
"Maximum Length" => "Longitud màxima",
"Maximum amount of characters to store" => "La quantitat màxima de caràcters per emmagatzemar",
"Autocomplete" => "Automàtic",
"Enable autocompletion while typing in the field" => "Activar emplenament automàtic mentre s'escriu al camp",
"Index exact value" => "Índex de valor exacte",
"In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "A més d'indexar el contingut del camp, també com a índex d'un identificador a tracker_field_{perm name}_exact. Aquesta opció no està disponible per als camps multilingües. Sobretot pels identificadors com els codis de productes o números d'ISBN",
// "Full-text search of the content of the field" => "Full-text search of the content of the field",
// "Search for a value prefix" => "Search for a value prefix",
// "Search for a precise value" => "Search for a precise value",
// "Full-text search in the current language" => "Full-text search in the current language",
// "Full-text search in a specific language (%0)" => "Full-text search in a specific language (%0)",
// "%0 (any language)" => "%0 (any language)",
// "Full-text search in any language" => "Full-text search in any language",
"Text Area" => "Àrea de Text",
"Multi-line text input" => "Entrada de text multilínia",
"Toolbars" => "Barres d'eines",
"Enable the toolbars as syntax helpers" => "Activar les barres d'eines com ajudants de sintaxi",
"Disable" => "Deshabilita",
"Enable" => "Habilita",
"Width" => "Amplada",
"Size of the text area, in characters" => "Grandària de l'àrea de text en caràcters",
"Height" => "Alçada",
"Size of the text area, in lines" => "Grandària de l'àrea de text a les línies",
"Character Limit" => "Límit de caràcters",
"Maximum number of characters to be stored" => "La quantitat màxima de caràcters a emmagatzemar",
"Display Limit (List)" => "Mostra un límit (Llista)",
"Maximum number of characters to be displayed in list mode before the value gets truncated" => "La quantitat màxima de caràcters que es mostrarà en la manera de llista abans que el valor es trunca",
"Word Count" => "Recompte de paraules",
"Limit the length of the text, in number of words" => "Límit la longitud del text amb paraules",
"Distinct Values" => "Valors Diferents",
"All values in the field must be different" => "Tots els valors en el camp han de ser diferents",
"Use WYSIWYG" => "Utilitza WYSIWYG",
"Use a rich text editor instead of inputting plain text" => "Utilitza un editor de text enriquit en lloc d'un quadre de text sense format",
"Word Limit Exceeded" => "S'ha excedit el límit de paraules",
"Character Limit Exceeded" => "S'ha excedit el límit de caracters",
"Create a link to a specified URL" => "Crea un enllaç a una URL especificada",
"How the URL should be rendered" => "Com s'ha de representar la URL",
"URL as link" => "URL d'enllaç",
"Site title as link" => "Nom del lloc d'enllaç",
"URL as link plus site title" => "URL d'enllaç més títol del lloc",
// "Text as link (see Other)" => "Text as link (see Other)",
// "Label of the link text. Requires \"Display\" to be set to \"Text as link\"" => "Label of the link text. Requires \"Display\" to be set to \"Text as link\"",
"Display the list of groups for the user associated with the tracker items" => "Mostra la llista de grups per a l'usuari associat als elements del registre",
// "Show direct groups memberships only" => "Show direct groups memberships only",
// "Do not show inherited/included groups" => "Do not show inherited/included groups",
// "Specify Fields" => "Specify Fields",
// "Get the groups for users from these fields, not the \"owner\" user fields" => "Get the groups for users from these fields, not the \"owner\" user fields",
"User Preference" => "Preferència usuari",
"Allow user preference changes from a tracker" => "Permet a les preferències de l'usuari canvia d'un formulari-bd",
"Preference Name" => "Nom de Preferència",
"Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Nom de la preferència a gestionar. password (contrasenya) i email (adreça de correu electrònic) no són preferències, però també són valors vàlids que modificaran el perfil de l'usuari",
"User Selector" => "Selector d'usuaris",
// "Allow the selection of a user or users from a list" => "Allow the selection of a user or users from a list",
"Assign the value based on the creator or modifier" => "Estableix el valor basat en el creador o modificador",
// "Item Owner" => "Item Owner",
// "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker" => "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker",
// "Send an email notification to the user(s) every time the item is modified" => "Send an email notification to the user(s) every time the item is modified",
"Only when other users modify the item" => "Només quan altres usuaris modifiquin l'article",
// "Notification Template" => "Notification Template",
// "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)" => "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)",
// "Email Format" => "Email Format",
// "Choose between values text or html, depending on the syntax in the template file that will be used" => "Choose between values text or html, depending on the syntax in the template file that will be used",
"text" => "text",
"html" => "html",
// "Multiple selection" => "Multiple selection",
// "Allow selection of multiple users from the list" => "Allow selection of multiple users from the list",
// "Yes (complete list)" => "Yes (complete list)",
// "Yes (filterable by group)" => "Yes (filterable by group)",
"Group IDs" => "ID de grup",
"Limit the list of users to members of specific groups" => "Limitar la llista d'usuaris als membres de grups específics",
// "Groups that can modify autoassigned values" => "Groups that can modify autoassigned values",
// "List of group IDs who can change this field, even without tracker_admin permission" => "List of group IDs who can change this field, even without tracker_admin permission",
// "Show real name if possible" => "Show real name if possible",
// "User \"%0\" not found" => "User \"%0\" not found",
"User Subscription" => "Subscripció d'Usuari",
"Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item" => "Permet als usuaris registrats subscriure a si mateixos a un element del registre. L'ítem ha de ser idealment només editable pel creador o els administradors. Anteposar la màxima quantitat d'abonats al valor del camp seguida per # si es desitja tal límit. Per exemple 50# significa es permetran 50 subscripcions per a aquest ítem",
"Webservice" => "Webservice",
"Display the result of a registered webservice call" => "Mostra el resultat d'una trucada de servei web registrada",
"Service Name" => "Nom del servei",
"Webservice name as registered in Tiki" => "Nom del servei web com registrat en Tiki",
"Template Name" => "Nom de la plantilla",
"Template name to use for rendering as registered with the webservice" => "Nom de la plantilla que s'utilitzarà per a la representació que ha registrat en el servei web",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name",
// "Require parameters" => "Require parameters",
// "Do not execute the request if parameters are missing or empty" => "Do not execute the request if parameters are missing or empty",
// "All required" => "All required",
// "(default)" => "(default)",
// "First only required" => "First only required",
// "No parameters required" => "No parameters required",
// "Cache time" => "Cache time",
// "Time in seconds to cache the result for before trying again" => "Time in seconds to cache the result for before trying again",
"Read only" => "Només de lectura",
// "Webservice %0 not found" => "Webservice %0 not found",
// "Webservice template %0 not found" => "Webservice template %0 not found",
// "Unknown webservice error (code: %0)" => "Unknown webservice error (code: %0)",
// "Unknown webservice error" => "Unknown webservice error",
// "Data too long for Webservice field %0 with %1" => "Data too long for Webservice field %0 with %1",
// "Error updating Webservice field %0" => "Error updating Webservice field %0",
// "Embed an associated wiki page" => "Embed an associated wiki page",
// "Field that is used for Wiki Page Name" => "Field that is used for Wiki Page Name",
// "Field to get page name to create page name with" => "Field to get page name to create page name with",
// "Namespace for Wiki Page" => "Namespace for Wiki Page",
// "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information" => "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information",
// "Default (trackerfield<fieldId>)" => "Default (trackerfield<fieldId>)",
// "No namespace" => "No namespace",
// "Custom namespace" => "Custom namespace",
// "Custom Namespace" => "Custom Namespace",
// "The custom namespace to use if the custom option is selected" => "The custom namespace to use if the custom option is selected",
// "Rename Wiki Page when changed in tracker" => "Rename Wiki Page when changed in tracker",
// "Rename associated wiki page when the field that is used for Wiki Page Name is changed" => "Rename associated wiki page when the field that is used for Wiki Page Name is changed",
// "Delete Wiki Page when tracker item is deleted" => "Delete Wiki Page when tracker item is deleted",
// "Delete associated wiki page when the tracker item is deleted" => "Delete associated wiki page when the tracker item is deleted",
// "Action Buttons" => "Action Buttons",
// "Display wiki page buttons when editing the item" => "Display wiki page buttons when editing the item",
// "Remove Bad Chars" => "Remove Bad Chars",
// "Remove bad characters from the Wiki Page name" => "Remove bad characters from the Wiki Page name",
// "The page name provided already exists. Please choose another" => "The page name provided already exists. Please choose another",
// "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1" => "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1",
// "Missing Page Name field #%0 for Wiki field #%1" => "Missing Page Name field #%0 for Wiki field #%1",
// "Page \"%0\" already exists. Not overwriting" => "Page \"%0\" already exists. Not overwriting",
// "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)" => "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)",
// "Look up a single item by ID" => "Look up a single item by ID",
"Search" => "Cercar",
// "Full-text search across all of the content" => "Full-text search across all of the content",
// "Modification Date" => "Modification Date",
// "Unknown value" => "Unknown value",
// "Modified Date" => "Modified Date",
"Actions" => "Accions",
// "Dynamic Filters" => "Dynamic Filters",
// "From %0 to %1" => "From %0 to %1",
// "Field not found: %0" => "Field not found: %0",
// "Filter mode not found: %0 for %1" => "Filter mode not found: %0 for %1",
// "Field mode not found: %0 for %1" => "Field mode not found: %0 for %1",
// "Primary Key fields cannot be read-only" => "Primary Key fields cannot be read-only",
// "Column \"%0\" cannot co-exist with \"%1\"" => "Column \"%0\" cannot co-exist with \"%1\"",
// "Column \"%0:%1\" found multiple times" => "Column \"%0:%1\" found multiple times",
// "Primary key already defined" => "Primary key already defined",
// "Not enough columns, expecting \"%0\"" => "Not enough columns, expecting \"%0\"",
// "Header \"%0\" found where \"%1\" was expected" => "Header \"%0\" found where \"%1\" was expected",
// "Header \"%0\" found where ignored column was expected" => "Header \"%0\" found where ignored column was expected",
// "new tracker(s) item(s) created" => "new tracker(s) item(s) created",
// "tracker(s) item(s) updated" => "tracker(s) item(s) updated",
// "Line %0" => "Line %0",
// "duplicate entry" => "duplicate entry",
// "duplicate entry for unique column %0" => "duplicate entry for unique column %0",
// "Import file contains errors. Please review and fix before importing" => "Import file contains errors. Please review and fix before importing",
// "Primary Key not defined" => "Primary Key not defined",
"Create page:" => "Crea pàgina:",
"Plugin execution pending approval" => "Execució del connector esperant aprovació",
// "Edit plugin" => "Edit plugin",
"Wiki page pagination has not been enabled" => "No s'ha habilitat la paginació Wiki en aquest lloc",
// "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"" => "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"",
"Internal error" => "Error intern",
"User error" => "Error de l'usuari",
"Plugin argument(s) missing" => "Manca argument(s) del connector (plugin)",
"Plugin <strong>%0</strong> cannot be executed" => "No es pot executar el Connector (Plugin) <strong>%0</strong> cannot be executed",
"Set" => "Configurar",
"Plugin disabled" => "Connector (plugin) desactivat",
"Edit Plugin" => "Edita el Connector",
// "Unable to locate cryptphrase" => "Unable to locate cryptphrase",
// "Single Container" => "Single Container",
// "Classic Tiki (3 containers - header, middle, footer)" => "Classic Tiki (3 containers - header, middle, footer)",
// "Classic Bootstrap (fixed top navbar)" => "Classic Bootstrap (fixed top navbar)",
"Line:" => "Línia:",
"Lines:" => "Línies:",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::applica: manca de coincidència del contador de línies: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: error",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: la seqüència d'edició no és óptima",
"WikiDiff Okay: LCS = %s" => "WikiDiff Ok: LCS = %s",
// "Problem setting user for \"%0\"" => "Problem setting user for \"%0\"",
// "Problem setting group for \"%0\"" => "Problem setting group for \"%0\"",
// "Problem setting mode for \"%0\"" => "Problem setting mode for \"%0\"",
// "Upload was not successful for \"%0\"" => "Upload was not successful for \"%0\"",
// "Subgallery number to galleryId error: Too many subdirs (%0)</span>" => "Subgallery number to galleryId error: Too many subdirs (%0)</span>",
// "Subgallery number to galleryId error: Not an integer (%0)</span>" => "Subgallery number to galleryId error: Not an integer (%0)</span>",
// "Subgallery number to galleryId error: Gallery with ID %0 not found</span>" => "Subgallery number to galleryId error: Gallery with ID %0 not found</span>",
// "Created by batch upload by user \"%0\" on %1" => "Created by batch upload by user \"%0\" on %1",
// "Create gallery \"%0\" failed</span>" => "Create gallery \"%0\" failed</span>",
// "No permsission to create gallery \"%0\"</span>" => "No permsission to create gallery \"%0\"</span>",
// "Gallery \"%0\" not found</span>" => "Gallery \"%0\" not found</span>",
"Upload was successful" => "Pujada amb èxit",
"File %s removed from Batch directory" => "El fitxer %s remogut de directori per lots",
"Impossible to remove file %s from Batch directory" => "Impossible suprimir el fitxer %s des del directori per lots",
"Invalid directory name" => "Nom de directori Invàlid",
// "Move was not successful for \"%0\"" => "Move was not successful for \"%0\"",
// "Copy was not successful for \"%0\"" => "Copy was not successful for \"%0\"",
// "Move was successful" => "Move was successful",
// "Copy was successful" => "Copy was successful",
// "Cannot write to this path: " => "Cannot write to this path: ",
// "Cannot read this file: " => "Cannot read this file: ",
// "Cannot remove file from gallery" => "Cannot remove file from gallery",
// "Migrated Image Galleries" => "Migrated Image Galleries",
// "Converted from image gallery" => "Converted from image gallery",
"My Files" => "Els meus arxius",
"Files of %0" => "Arxius del %0",
"Cannot open this file:" => "No puc obrir aquest arxiu:",
" copy" => " copiar",
// "Processing search text from a \"%0\" file in gallery #%1" => "Processing search text from a \"%0\" file in gallery #%1",
"User File Galleries" => "Galeries d'arxius d'usuari",
"Wiki Attachment File Galleries" => "Wiki adjunts Galeries d'arxius",
"File Galleries" => "Galeries d'arxius",
"The upload was not completed" => "La pujada no s'ha pogut efectuar",
"Reason: The global quota has been reached" => "Raó: S'ha arribat al maxim de quota permès",
"Reason: The quota has been reached in \"%s\"" => "Raó: S'ha arribat al maxim de quota permès en \"%s\"",
"File gallery quota exceeded" => "S'ha excedit la quota de la galeria d'arxius",
"Number of files transferred to the database" => "El nombre d'arxius transferits a la base de dades",
"Number of files transferred to the file system" => "El nombre d'arxius transferits al sistema d'arxius",
"Old File deleted" => "Old arxiu esborrat",
"Incorrect param" => "Paràmetre Incorrecte",
"You do not have permission to remove files from this gallery" => "Permís denegat, no podeu eliminar arxius dóaquesta galeria",
"Warning: The file is used in" => "ADVERTÈNCIA: L'arxiu s'utilitza en",
"You are trying to edit multiple files in different galleries, which is not supported yet" => "Estàs tractant d'editar múltiples arxius en diferents galeries, que no és possible encara",
"The specified file does not exist" => "L'arxiu especificat no existeix",
"Upload was not successful" => "La pujada no s'ha realitzat amb èxit",
"An exception occurred" => "Ha ocorregut una excepció",
"Batch file processed" => "S'ha processat l'arxiu per lots",
"Errors detected" => "Errors detectats",
"Check that these paths exist and are writable by the web server" => "Comprovi que existeixen aquestes vies i es pot escriure a la web",
"File added: " => "S'ha afegit l'arxiu: ",
"Cannot read the file" => "No es pot llegir l'arxiu",
"Warning: Empty file" => "Advertència: l'arxiu buit",
"Please re-upload the file" => "Per favor, torna a pujar el teu arxiu",
"The upload was not successful due to duplicate file content" => "La pujada ha fallat. Duplica el contingut de l'arxiu",
// "Files uploaded" => "Files uploaded",
// "File \"%0\" uploaded" => "File \"%0\" uploaded",
"File update was successful" => "L'actualització de l'arxiu ha tingut èxit",
"Automatic revision from source" => "Revisió automàtica de la font",
// "Images successfully moved to file gallery %0" => "Images successfully moved to file gallery %0",
// "Images could not be opened or uploaded" => "Images could not be opened or uploaded",
// "No changes were made since no images in wiki_up were found in Wiki pages" => "No changes were made since no images in wiki_up were found in Wiki pages",
// "No images found" => "No images found",
// "%0 on page %1 could not be opened" => "%0 on page %1 could not be opened",
// "%0 on page %1 could not be uploaded into the file gallery" => "%0 on page %1 could not be uploaded into the file gallery",
// "%0 used on page %1 was moved and given the file ID %2" => "%0 used on page %1 was moved and given the file ID %2",
// "Forcing a filetype of image/svg+xml is blocked for security reasons" => "Forcing a filetype of image/svg+xml is blocked for security reasons",
// "SVG files are not safe and cannot be uploaded" => "SVG files are not safe and cannot be uploaded",
// "PHP Zip extension not found, reqiuired for Feature H5P" => "PHP Zip extension not found, reqiuired for Feature H5P",
// "PHP Class \"ZipArchive\" not found" => "PHP Class \"ZipArchive\" not found",
// "Missing content parameters" => "Missing content parameters",
// "Invalid content parameters" => "Invalid content parameters",
// "Missing title" => "Missing title",
// "Title is too long. Must be 256 letters or shorter" => "Title is too long. Must be 256 letters or shorter",
// "Invalid content type" => "Invalid content type",
// "Created by H5P" => "Created by H5P",
// "The chosen content type isn't installed" => "The chosen content type isn't installed",
"This is an approximation based on your server memory limit" => "Això és una aproximació basada en el limit de memòria del teu servidor",
"This is the value of your server's PHP '%s' setting" => "Aquest és el valor de la configuració PHP '%s' del teu servidor",
// "Not a git repository" => "Not a git repository",
// "Branch \"%s\" not found" => "Branch \"%s\" not found",
// "Can't get Git object file" => "Can't get Git object file",
// "Goal achieved" => "Goal achieved",
// "Event Count" => "Event Count",
// "Event Count (Forever)" => "Event Count (Forever)",
// "Goal Reached (Periodic)" => "Goal Reached (Periodic)",
// "Goal Reached (Forever)" => "Goal Reached (Forever)",
// "Has Badge" => "Has Badge",
// "Add One-Time Badge" => "Add One-Time Badge",
// "%0 Badge" => "%0 Badge",
// "Remove One-Time Badge" => "Remove One-Time Badge",
// "%0 Badge (Remove)" => "%0 Badge (Remove)",
"Credits" => "Crèdits",
// "%0 credit(s) - %1" => "%0 credit(s) - %1",
// "Unknown credit type" => "Unknown credit type",
"You are alerted by the server " => "Estàs alertat pel servidor ",
"You can check the modifications at: " => "Pots comprovar les modificacions a : ",
"You are alerted of a change on " => "Està alertat de canvis sobre ",
// "JavaScript file \"%0\" cannot be found so will not be minified" => "JavaScript file \"%0\" cannot be found so will not be minified",
"No image yet, sorry." => "Ho sento, encara no hi ha cap imatge.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directori de destinació desconegut. Configura'l a <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "no s'ha pogut treure l'enllaç",
"The uploaded file exceeds the upload_max_filesize directive in php.ini" => "L'arxiu pujat excedeix la mida màxima fixada a la directiva upload_max_filesize al php.ini",
"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "L'arxiu pujat excedeix la mida màxima fixada a la directiva MAX_FILE_SIZE que s'ha especificat al formulari HTML",
"The uploaded file was only partially uploaded. Please try again" => "L'arxiu a pujar només s'ha pujat parcialment. Si us plau, prova-ho de nou",
"No file was uploaded" => "No s'ha pujat cap arxiu",
"Missing a temporary folder" => "Manca un directori temporal",
"Failed to write file to disk" => "No s'ha pogut desar l'arxiu al disc",
"File upload stopped by extension" => "S'ha aturat la pujada de l'arxiu a causa de l'extensió de l'arxiu (.xxx)",
"Set new blog as Tiki homepage" => "Establir nou bloc com a pàgina d'inici Tiki",
"Importation completed" => "Importació completada",
"<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Clica aquí</a> per finalitzar el procés d'importació",
"Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "S'han trobat %0 Missatges,%1 pàgines, %2 marques i %3 categories. Inserint-los en Tiki",
"Item \"%0\" NOT imported (there was already a item with the same name)" => "L'ítem \"%0\" no s'ha importat (ja hi havia un ítem amb el mateix nom)",
"Page \"%0\" sucessfully imported" => "Pàgina \"%0\" amb èxit importats",
"Post \"%0\" sucessfully imported" => "Publicar \" %0\" amb èxit importats",
"Import images and other attachments" => "Importar imatges i altres arxius adjunts",
"Update internal links (experimental)" => "Actualització d'enllaços interns (experimental)",
"Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)" => "Suggerir Regles .htaccess per redirigir a adreces URL WP vella a la nova URL Tiki (experimental)",
"Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "No es troba disponible la classe DOMDocument, comprova la teva instal·lació de PHP. Per a més informació, consulta http://php.net/manual/en/book.dom.php",
"Invalid file MIME type" => "El tipus mime de l'arxiu és invàlid",
"There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Error en carregar el fitxer XML. Probablement el fitxer XML està mal format. Algunes versions de Wordpress generar un arxiu XML amb format incorrecte. Consulteu la documentació del Importador Tiki per a més informació",
"Invalid WordPress XML file" => "Invalid fitxer XML Wordpress",
"No attachments found to import" => "No es van trobar arxius adjunts d'importar",
"Importing attachments" => "Importació d'arxius adjunts",
"Attachment %0 successfully imported" => "Adjunt %0 importat correctament",
"Unable to download attachment %0. Error message was: %1 %2" => "No es pot descarregar adjunts %0. Missatge d'error va ser: %1 %2",
"%0 attachments imported and %1 errors" => "%0 adjunts importats i %1 errors",
"Page \"%0\" successfully extracted" => "Pàgina \"%0\" extret correctament",
"Post \"%0\" successfully extracted" => "Publicar \" %0\" extret correctament",
"Extracting data from XML file" => "Extracció de les dades d'arxiu XML",
"Number of page revisions to import (0 for all revisions):" => "Nombre de revisions de pàgines a importar (0 per a totes les revisions):",
"What to do with page names that already exists in Tiki" => "Què fer amb els noms de les pàgines que ja existeixen en Tiki",
"Do not import" => "No importar",
"Override" => "Sobreescriure",
"Prepend software name as a prefix to the page name" => "Afegeix el nom del programari com a sufix del nom de la pàgina",
"Page %0 sucessfully imported" => "Pàgina %0 reeixidament importats",
"Page %0 NOT imported (there was already a page with the same name)" => "Pàgina %0 NO importada (ja hi havia una pàgina amb el mateix nom)",
"%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pàgines analitzades. Començant a inserir aquestes pàgines a Tiki",
"Import images and attachments (see documentation for more information)" => "Importa  les imatges i els adjunts (consulta la documentació per a més informació)",
"Add a maketoc at the top of each page" => "Afegir una taula de continguts (maketoc) a la part superior de cada pàgina",
"The XML file does not validate against the MediaWiki XML schema" => "L'arxiu XML no valida contra l'esquema XML de Mediawiki ",
"Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments" => "Avort: el directori de destinació per als fitxers adjunts (0%) no existeix. Soluciona el problema o tracta d'importar sense els adjunts",
"Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments" => "Avort: el directori de destinació per als fitxers adjunts (0%) no es escrivible. Soluciona el problema o tracta d'importar sense els adjunts",
"File %0 is not being imported because there is already a file with the same name in the destination directory (%1)" => "No es important el fitxer %0 ja que ja existeix un fitxer amb el mateix nom al directori de destinació (%1)",
"File %0 successfully imported" => "El fitxer %0 importat correctament",
"Unable to download file %0. File not found" => "No es pot descarregar el fitxer %0. Arxiu no trobat",
"Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer" => "Error en analitzar la revisió %0 de la pàgina \"%1\". O hi ha un problema en la sintaxi de la pàgina o en l'analitzador Text_Wiki (l'analitzador utilitzat per l'importador)",
"Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Pàgina \"%0\" analitzades amb èxit amb %1 revisions (d'un total de %2 revisions)",
"Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Pàgina \"%0\" no va a importar. No va ser possible analitzar qualsevol de les revisions pàgina",
"MediaWiki XML file version %0 is not supported" => "Mediawiki XML arxiu de la versió %0 no està suportat",
"Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "Avort: cal activar la configuració de PHP 'allow_url_fopen' per tal de poder importar arxius adjunts. Soluciona el problema o tracta d'importar sense els adjunts",
"Parsing pages" => "Analitzar pàgines",
"No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments" => "No es van trobar arxius adjunts a importar! Assegureu-vos que ha creat el fitxer XML amb el guió dumpDump.php i amb l'opció - arxius. Aquesta és l'única manera d'importar dades adjunts",
// "Invalid template name: %0" => "Invalid template name: %0",
"Unnamed file" => "Sense nom fitxer",
"string" => "cadena",
"Unknown language" => "Llenguatge desconegut",
"Error: unable to write to lang/%s/language.php" => "ERROR: no es pot escriure en lang/%s/language.php",
"The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again" => "L'arxiu lang/%0/language.php no està ben formatat. Executar get_strings.php?lang=%0 i després tractar d'exportar les traduccions nou",
"Contributions" => "Contribucions",
// "reverted" => "reverted",
"section level 0" => "secció de nivell 0",
"sorted section level 0" => "secció ordenada de nivell 0",
"section level 1" => "secció de nivell 1",
"section level 2" => "secció de nivell 2",
"section level 3" => "secció de nivell 3",
"option" => "opció",
"separator" => "separador",
"You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu." => "Només pots utilitzar optionId = 0 per crear una nova opció, o optionId igual a una id que ja pertanyi al menú per actualitzar-la.",
"menu" => "menú",
"NONE" => "CAP",
"(values not interpreted)" => "(Els valors no interpretats)",
"Unknown Field: " => "Desconegut camp:",
"duplicate fields do not match" => "camps duplicats no coincideixen",
"Description not available" => "No hi ha descripció disponible",
"Module Title" => "Títol del mòdul",
"Title to display at the top of the box" => "Títol que es vol mostrar a sobre de la caixa",
"No Box" => "Sense Requadre",
"Show only the content" => "Mostra només el contingut",
"Title, background, etcs" => "Decoracions",
"Show module decorations" => "Mostra les decoracions dels mòduls",
"No Title" => "Sense Títol",
"Hide module title" => "Amaga el títol del mòdul",
"Module displayed depending on category. Separate multiple category IDs or names by semi-colons" => "Mòdul visualitza depenent de la categoria. Múltiples identificadors de categories o noms poden ser separats per punt i coma",
"No Category" => "Sense Categoria",
"Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above" => "Mòdul oculta depenent de la categoria. Múltiples identificadors de categories o noms poden ser separats per punt i coma. Això té prioritat sobre el paràmetre de categoria superior",
"Category subtrees" => "Categoria subarbres",
"Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)" => "Penseu fills categories de les categories enumerades en la categoria i hi ha una categoria de ser part d'aquestes categories. (0 o 1)",
"Perspective" => "Perspectiva",
"Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons" => "Només mostrar el mòdul de si en un dels identificadors de perspectiva enumerats. Separats per punt i coma",
"Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons" => "Mòdul només s'aplica als idiomes especificats. Els idiomes es defineixen com dos codis lingüístics de caràcter. Diversos valors poden estar separats per punt i coma",
"Section" => "Secció",
// "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page" => "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page",
"Page Filter" => "Filtre Page",
"Module is displayed only on the specified page(s). Separate multiple page names by semi-colons" => "Mòdul aplicable únicament en els noms de les pàgines especificades. Diversos valors poden estar separats per punt i coma",
"No Page" => "Cap pàgina",
"Module is not displayed on the specified page(s). Separate multiple page names by semi-colons" => "Mòdul no és aplicable en els noms de les pàgines especificades. Diversos valors poden estar separats per punt i coma",
"Theme" => "Tema",
"Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons" => "Mòdul activada o desactivada segons el nom de fitxer de tema (per exemple, \"thenews.css\"). Temes especificats poden ser inclosos o exclosos. Noms temàtiques prefix \"!\" Estan en la llista d'exclusió. Diversos valors poden estar separats per punt i coma",
"Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Mòdul només està disponible a la base de la relació de l'usuari amb la pàgina wiki. Cap d'ells únics creadors (i) o només els no creadors (n) veuran el mòdul",
"Contributor" => "Contribuent",
"Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Mòdul només està disponible a la base de la relació de l'usuari amb la pàgina wiki. Cap d'ells únics contribuents (i) o només els no contribuents (n) veuran el mòdul",
"Flip" => "Permet amagar-lo",
"Users can open and close the module" => "Els usuaris poden amagar el mòdul",
"Style" => "Estil",
// "CSS style attribute (for example, to position the module)" => "CSS style attribute (for example, to position the module)",
"Class" => "Classe",
// "Extra class (for CSS or JavaScript)" => "Extra class (for CSS or JavaScript)",
"Containing Class" => "Amb un contingut de classe",
"Custom CSS class of div around the module" => "Classe CSS personalitzada entorn",
"Cookie Consent" => "Consentiment de Cookies",
"Show only if consent to accept cookies has been granted" => "Mostra només si ha estat atorgat el consentiment per a les cookies",
"No Numbers" => "No hi ha número de",
"If set to \"y\", the module will not number list items" => "Si es posa en \"y\", el mòdul no numerarà la llista d'ítems",
"Rows" => "Files",
"Number of rows, or items, to display" => "Nombre de files o ítems a mostrar",
"Default: 10" => "Per omissió: 10",
"Failed to execute \"%0\" module" => "No s'ha pogut executar \"%0\" mòdul",
"Missing dependencies" => "Dependències que falten",
"Contact the system administrator" => "Poseu-vos en contacte amb l'administrador del sistema",
"Module file \"%0\" not found" => "No s'ha trobat l'arxiu del Mòdul \"%0\"",
"Newsletter subscription information at" => "La informació de subscripció a butlletins es troba a",
// "Cannot add subscribers from a newsletter that includes this newsletter's subscribers" => "Cannot add subscribers from a newsletter that includes this newsletter's subscribers",
// " after sending to" => " after sending to",
// " after error in sending to" => " after error in sending to",
// " after failure to send to" => " after failure to send to",
// "Error - potential cross site request forgery detected" => "Error - potential cross site request forgery detected",
// "Potential cross site forgery request detected" => "Potential cross site forgery request detected",
"Limiting the email send rate. Resuming in %0 seconds" => "Limitar la velocitat d'enviament de correu electrònic. Represa en %0 segons",
"Newsletter successfully sent to %s users" => "Butlletí enviat amb èxit als usuaris %s",
"Number of errors: %s" => "Hi va haver %s errors",
// "End of last article" => "End of last article",
// "potential CSRF" => "potential CSRF",
"invalid email" => "correu-e invàlid",
"A user registers" => "Un usuari es registra",
"A user submits an article" => "Un usuari envia una col·laboració",
"A user edits an article" => "Un usuari edita un article",
"A user deletes an article" => "Un usuari esborra un article",
"An article is submitted, edited, deleted or commented on" => "Un article que es presenta, editar, eliminar o comentat",
"A new blog post is published" => "Un nou bloc es publica",
"A blog post comment is posted or edited" => "S'ha publicat o editat un comentari a una pàgina de bloc",
"A wiki page is created, deleted or edited, except for minor changes" => "Una pàgina wiki es crea, eliminat o editat, excepte pels canvis de menor importància",
"A wiki page is created, deleted or edited, even for minor changes" => "Una pàgina wiki es crea, eliminat o editat, fins i tot per canvis menors",
"A wiki page comment is posted or edited" => "S'ha publicat o editat un comentari a una pàgina wiki",
"An article comment is posted or edited" => "S'ha publicat o editat un comentari a un article",
"Token is called" => "S'ha cridat el Token",
"User joins a group" => "Usuari s'uneix a un grup",
// "User's comment is replied" => "User's comment is replied",
"Category change in a language" => "Canvi de categoria en un idioma",
"A new page is created in a language" => "Una nova pàgina es crea en un idioma",
// "Cannot save invalid client" => "Cannot save invalid client",
// "Name cannot be empty" => "Name cannot be empty",
// "Redirect URI cannot be empty" => "Redirect URI cannot be empty",
// "Invalid URL for redirect URI" => "Invalid URL for redirect URI",
"section edit" => "secció edició",
// "Engine \"%0\" not found" => "Engine \"%0\" not found",
// "Output converter \"%0\" not found" => "Output converter \"%0\" not found",
// "Parsed Data" => "Parsed Data",
"Data" => "Dades",
// "Mapping" => "Mapping",
"Edit Section" => "Edita la secció",
"index" => "índex",
"Table of contents" => "Taula de continguts (índex)",
"Show/Hide" => "Mostra/Amaga",
// "Processing page: %0, is_html: %1" => "Processing page: %0, is_html: %1",
"Payment was sent but verification is not currently available (this feature is a work in progress)" => "Pagament enviat però la verificació no està disponible. (Treball en curs)",
// "Cart: Product code mismatch" => "Cart: Product code mismatch",
// "Cart: Product exchange mismatch" => "Cart: Product exchange mismatch",
// "Invalid gift certificate: %0" => "Invalid gift certificate: %0",
"Please enter your shopper information first" => "Si us plau introdueix el informació de comprador primer",
// "No email found for gift certificate recipient" => "No email found for gift certificate recipient",
"Gift card is not valid for products in cart" => "Targeta de regal no és vàlida per als productes a la cistella",
"for" => "per a",
"Bundled Product" => "Producte inclòs",
"Product" => "Producte",
"Quantity" => "Quantitat",
"Unit Price" => "PReu unitari",
"There is insufficient inventory to meet your request" => "No hi ha prou inventari de l'esquerra de la seva sol.licitud",
// "Advanced Shopping Cart setup error: Orders profile missing" => "Advanced Shopping Cart setup error: Orders profile missing",
"Gift Certificate: " => "Certificat de Regal:",
"Gift Certificate Amount Used: " => "Un certificat de regal quantitat utilitzada:",
"No registries specified in admin/payment/cclite" => "No s'han especificat xarxes (registries) a admin > pagaments > cclite",
"Cclite payment initiated on %0" => "Pagament via cclite iniciat el %0",
"Connection to Cclite server %0 failed for %1<br />\"%2\"" => "La connexió al servidor de cclite %0 ha fallat per %1<br />\"%2\"",
"Tiki credits payment done on %0 for %1 (using %2)" => "Tiki pagament de crèdits fa en %0 per %1 (amb %2)",
// "PDF webkit path \"%0\" not found" => "PDF webkit path \"%0\" not found",
// "The PDF webkit path has not been set" => "The PDF webkit path has not been set",
// "PDF WeasyPrint path \"%0\" not found" => "PDF WeasyPrint path \"%0\" not found",
// "The PDF WeasyPrint path has not been set" => "The PDF WeasyPrint path has not been set",
// "PDF webservice URL \"%0\" not found" => "PDF webservice URL \"%0\" not found",
// "The PDF webservice URL has not been set" => "The PDF webservice URL has not been set",
// "The package mPDF is not installed. You can install it using packages" => "The package mPDF is not installed. You can install it using packages",
// "PDF generation failed" => "PDF generation failed",
// "This is set by the administrator (search for \"print\" in the control panels to locate the setting)" => "This is set by the administrator (search for \"print\" in the control panels to locate the setting)",
"Required function shell_exec is not enabled" => "Requerit funció shell_exec no està habilitat",
"No category jail set in any perspective" => "Cap categoria presó situada en qualsevol punt de vista",
"Areas root category ID" => "Àrees arrelen Identificació categoria",
"is invalid" => "no és vàlid",
// "Access-Control-Allow-Origin" => "Access-Control-Allow-Origin",
// "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server" => "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server",
// "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site" => "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site",
// "Record basic events" => "Record basic events",
// "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged" => "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged",
// "Record tracker item update" => "Record tracker item update",
// "Enable recording of basic internal Tiki events" => "Enable recording of basic internal Tiki events",
// "Record tracker item creation" => "Record tracker item creation",
// "Record user following users" => "Record user following users",
// "Record user being followed by users" => "Record user being followed by users",
// "Record user adding new friend" => "Record user adding new friend",
// "Custom activities" => "Custom activities",
// "Allow the defining of custom behaviors in addition to internal events" => "Allow the defining of custom behaviors in addition to internal events",
// "Enable notifications through activities" => "Enable notifications through activities",
// "Allow users to create notifications using activities" => "Allow users to create notifications using activities",
"Ajax auto-save" => "Guardat automàtic via Ajax",
"Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing." => "Guarda les modificacions sobre la marxa el que li permet recuperar el treball després d'una \"interrupció\". També permet \"Live\" vista prèvia i és necessari per wysiwyg plugin de processament",
"Inline editing" => "Edició en línia",
"Enable inline editing of certain values. Currently limited to tracker item fields" => "Permet l'edició en línia de certs valors. Actualment es limita als camps de formularis-bd",
"Tracker list inline editing" => "Edició en-línia de llistes de formularis-bd",
// "Enable inline editing of all fields on the tracker list page" => "Enable inline editing of all fields on the tracker list page",
// "ffmpeg path" => "ffmpeg path",
// "Path to the location of the ffmpeg binary" => "Path to the location of the ffmpeg binary",
// "ffprobe path" => "ffprobe path",
// "Path to the location of the ffprobe binary" => "Path to the location of the ffprobe binary",
// "Alchemy Image library" => "Alchemy Image library",
// "Select either Image Magick or GD Graphics Library" => "Select either Image Magick or GD Graphics Library",
// "Imagemagick" => "Imagemagick",
// "GD" => "GD",
// "unoconv path" => "unoconv path",
// "Path to the location of the unoconv binary" => "Path to the location of the unoconv binary",
// "ghostscript path" => "ghostscript path",
// "Path to the location of the ghostscript binary" => "Path to the location of the ghostscript binary",
// " (Extension not loaded)" => " (Extension not loaded)",
// "Search index rebuild" => "Search index rebuild",
// "Tracker item export" => "Tracker item export",
// "Tracker clear" => "Tracker clear",
// "Printing to PDF" => "Printing to PDF",
// "PHP execution" => "PHP execution",
// "for example 256M, currently is %0" => "for example 256M, currently is %0",
// "for example 30 seconds, currently is %0 seconds" => "for example 30 seconds, currently is %0 seconds",
// "%0 memory limit" => "%0 memory limit",
"Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server" => "Temporalment ajustar el límit de memòria per fer durant el %0. En funció del seu volum de dades, algunes operacions grans requereixen més memòria. L'augment a nivell local, per operació, permet mantenir un límit de memòria més baixa a nivell mundial. Tingueu en compte l'ús de memòria encara està obligat al que està disponible al servidor",
// "for example: 256M" => "for example: 256M",
// "%0 time limit" => "%0 time limit",
// "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values" => "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values",
"seconds" => "segons",
"Users accept internal messages by default" => "Els usuaris poden acceptar missatges interns per defecte",
// "Users can opt out of internal messages" => "Users can opt out of internal messages",
"ID of category whose child categories are bound to a perspective by areas" => "Aneu de la categoria els fills estan obligats a una perspectiva per àrees",
"Newest first" => "Primer els més nous",
"ascending" => "ascendent",
"descending" => "descendent",
// "Article order" => "Article order",
"Default sort mode for the articles on the list-articles page" => "La manera per omissió per als articles de la llista d'articles",
"Title of articles homepage" => "Títol de la pàgina principal d'articles",
// "Select the default title for the page that displays all articles" => "Select the default title for the page that displays all articles",
"Title" => "Títol",
"Title length" => "Longitud del Títol",
// "characters" => "characters",
"Publication date" => "Data de publicació",
"Visible" => "Visible",
"Author (owner)" => "Autor (propietari)",
"Author name (as displayed)" => "Nom de l'autor (segons es mostra)",
"Author rating" => "Valoració de l'Autor",
"Users rating" => "Valoració dels Usuaris",
"Reads" => "Lectures",
// "Is published" => "Is published",
"Trailer position" => "Posició de l'extracte",
"Between heading and body" => "Entre el títol i el cos",
"Header text position" => "Posició del text de la Capçalera",
"Requires a smaller image for list view" => "Requereix una imatge més petita a la vista de llista",
"Next to image" => "Al costat de la imatge",
"Below image" => "Sota la imatge",
"Oldest first" => "El/s més antic/s primer",
"Points" => "Punts",
"Number per page" => "Nombre predeterminat per pàgina",
"Set the number of comments per page" => "establir el nombre de comentaris per pàgina (per omissió = 10)",
"comments" => "comentaris",
"Display order" => "Predeterminat",
// "Set the display order of comments" => "Set the display order of comments",
"Paginate articles" => "Paginació d'Articles",
"Divide articles into multiple pages with pagebreak markers" => "Divideix articles en diverses pàgines amb marcadors de salt de pàgina",
// "Article creator remains article owner" => "Article creator remains article owner",
// "Last article editor does not automatically become author (owner)" => "Last article editor does not automatically become author (owner)",
"User ratings on articles" => "Qualificacions dels usuaris sobre els articles",
"Allow users to rate articles" => "Permet que els usuaris valorin els articles",
// "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set" => "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set",
"Article rating options" => "Opcions de valoració per als articles",
"List of options available for the rating of articles" => "Llista de les opcions disponibles per a la valoració dels articles",
"Default maximum width for custom article images" => "Ample màxim predeterminat per a imatges d'articles personalitzats",
"Set the default maximum width of the article image" => "estableix l'amplada màxima de les imatges de l'article",
"pixels" => "píxels",
// "\"0\" for no maximum" => "\"0\" for no maximum",
"Default maximum height for custom article images" => "Alçada màxima predeterminada per les imatges d'articles personalitzats",
"Set the default maximum height of article images" => "estableix l'altura màxima de les imatges de l'article",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
"Sets the default maximum width of custom article images in list mode (on View Articles page)" => "estableix l'ample màxim predeterminat per a imatges d'articles personalitzats en la manera de llista (a Veure Articles)",
// "\"0\" to default to the view mode maximum" => "\"0\" to default to the view mode maximum",
"Default maximum height of custom article images in list mode (on View Articles page)" => "Alçada màxima predeterminada per les imatges d'articles personalitzats en la manera llista (a Veure Articles)",
"Set the default maximum height of custom article images in list mode (on the View Articles page)" => "estableix l'altura màxima per omissió per a les imatges d'articles personalitzats en la manera llista (a Veure Articles)",
// "Article image maximum file size" => "Article image maximum file size",
// "Maximum file size for an article image. Article images are stored in the database so it should remain low" => "Maximum file size for an article image. Article images are stored in the database so it should remain low",
// "kilobytes" => "kilobytes",
"Custom attributes for article types" => "Els atributs personalitzats per als tipus d'articles",
"Enable additional custom fields for article types" => "Permetre camps personalitzats addicionals per a aquest tipus d'article",
"Your ShareThis publisher identifier (optional)" => "El seu identificador d'editor ShareThis (opcional)",
// "Set to define your ShareThis publisher identifier" => "Set to define your ShareThis publisher identifier",
"record your ShareThis publisher ID" => "registrar el seu ID d'editor ShareThis",
"Related articles" => "Articles relacionats",
"Display a list of related articles at the bottom of an article page" => "Mostra una llista dels articles relacionats en la part inferior de la pàgina de l'article",
// "Use new articles" => "Use new articles",
// "Use the new CustomSearch-based article lists rather than database information" => "Use the new CustomSearch-based article lists rather than database information",
// "Article copyright" => "Article copyright",
// "Apply copyright management preferences to this feature" => "Apply copyright management preferences to this feature",
"Authentication method" => "Mètode d'Autentificació",
"Tiki supports several authentication methods. The default method is to use the internal user database" => "Tiki suporta diversos mètodes d'autenticació. Per omissió és utilitzar la base de dades interna d'usuari",
"Tiki" => "Tiki",
"Tiki and OpenID" => "Tiki i OpenID",
"Tiki and PAM" => "Tiki i PAM",
"Tiki and LDAP" => "Tiki i LDAP",
"CAS (Central Authentication Service)" => "CAS (Servei Central d'Autenticació)",
// "SAML" => "SAML",
"Shibboleth" => "Shibboleth",
"Web Server" => "Servidor Web",
"phpBB" => "phpBB",
// "Token access" => "Token access",
"With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service" => "Permetre accedir al contingut amb drets superiors amb la presentació d'un token. El principal ús d'aquest mètode d'autenticació és concedir accés temporal al contingut a un servei extern",
// "Token access default timeout" => "Token access default timeout",
// "The default duration for which the generated tokens will be valid" => "The default duration for which the generated tokens will be valid",
// "Token access default maximum hits" => "Token access default maximum hits",
// "The default maximum number of times a token can be used before it expires" => "The default maximum number of times a token can be used before it expires",
"hits" => "accessos",
"Share access rights with friends when using Tell a friend" => "Comparteix drets d'accés amb els seus amics quan s'utilitza a un amic",
"Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site" => "Permetre als usuaris a compartir els seus drets d'accés a la pàgina actual amb un amic enviar l'enllaç per correu electrònic. Vida útil dels enllaços que es defineix pel lloc",
// "Do not delete temporary users when token is deleted/expired" => "Do not delete temporary users when token is deleted/expired",
// "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms" => "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms",
"Share access rights with friends when using Share" => "Comparteix drets d'accés amb els seus amics quan s'utilitza Share",
"Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site" => "Permetre als usuaris a compartir els seus drets d'accés a la pàgina actual amb un amic enviar l'enllaç per correu electrònic / Twitter / Facebook. Vida útil dels enllaços que es defineix pel lloc",
"Create user if not registered in Tiki" => "Crear usuari si no en Tiki",
"Automatically create a new Tiki user for the PHPbb login" => "Creació automàtica d'un nou usuari Tiki per a l'inici de sessió phpBB",
"Use Tiki authentication for Admin log-in" => "Utilitza l'autenticació de Tiki per Admin login",
// "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”" => "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”",
// "Disable Tiki users who don’t have a phpBB login as they could have been deleted" => "Disable Tiki users who don’t have a phpBB login as they could have been deleted",
"phpBB Version" => "Versió phpBB",
"3" => "3",
"phpBB Database Hostname" => "Base de dades phpBB Hostname",
"phpBB Database Username" => "phpBB nom d'usuari de base de dades",
"phpBB Database Password" => "phpBB Database Password",
"phpBB Database Name" => "phpBB Nom de base de dades",
"phpBB Table Prefix" => "Prefix de taula phpBB",
"Use Tiki authentication for users created in Tiki" => "Utilitza l'autenticació de Tiki per als usuaris creats en Tiki",
// "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP" => "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP",
"Host" => "Amfitrió",
// "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL" => "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL",
"Port" => "Port",
// "The port number your LDAP server uses (389 is the default, 636 if you check SSL)" => "The port number your LDAP server uses (389 is the default, 636 if you check SSL)",
"Write LDAP debug Information in Tiki Logs" => "Escriure informació de depuració d'LDAP en Tiki Logs",
// "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)" => "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)",
// "Do not enable this option for production sites" => "Do not enable this option for production sites",
"Use SSL (ldaps)" => "Utilitza SSL (LDAPS)",
"Use TLS" => "Utilitza TLS",
"LDAP Bind Type" => "Tipus d'LDAP Bind",
// "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>" => "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>",
"Default: Anonymous Bind" => "Per omissió: Bind Anonymous",
"Full: userattr=username,UserDN,BaseDN" => "Complet: userattr = nom d'usuari, DNUsuario, basedn",
"OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn = nom d'usuari, basedn",
"Active Directory (username@domain)" => "Active Directory (usuari@domini)",
"Plain Username" => "Nom d'usuari normal",
"Search scope" => "Àmbit de cerca",
// "Used after authentication for getting user and group information" => "Used after authentication for getting user and group information",
"Subtree" => "Subarbre",
"One level" => "Un nivell",
"Base object" => "Objecte Base",
"Base DN" => "Base DN",
"User DN" => "DN de l'usuari",
"User attribute" => "Atribut d'usuari",
"User OC" => "Usuari OC",
"Realname attribute" => "Atribut realname",
// "Synchronize Tiki user attributes with the LDAP values" => "Synchronize Tiki user attributes with the LDAP values",
"Country attribute" => "Atribut Country",
"Email attribute" => "Atribut de correu electrònic",
"Group DN" => "Grup DN",
"Group name attribute" => "Atribut Nom del grup",
"Group description attribute" => "Atribut de descripció de grup",
"Group OC" => "Grup OC",
"Member attribute" => "Atribut de membre",
"Member is DN" => "Membre DN",
"Group attribute" => "Atribut de grup",
"Group attribute in group entry" => "Atribut Grup d'entrada de grup",
"(Leave this empty if the group name is already given in the user attribute)" => "(Deixa això buit si el nom del grup ja és donat en l'atribut de l'usuari)",
"Admin user" => "Usuari Admin",
"Admin password" => "Contrasenya d'administrador",
"Use an external LDAP server for groups" => "Utilitzar un servidor LDAP extern per a grups",
"Anonymous Bind" => "Per omissió: Bind Anonymous",
"Corresponding user attribute in 1st directory" => "Atribut d'usuari corresponent a la primera guia",
// "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database" => "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database",
// "Disable Tiki users with no phpBB login" => "Disable Tiki users with no phpBB login",
// "Default Bootstrap" => "Default Bootstrap",
"Available languages" => "Idiomes disponibles",
"By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset" => "per omissió, tots els idiomes suportats per Tiki estan disponibles en els llocs multilingües. Aquesta opció permet limitar el règim lingüístic d'un subconjunt",
// "Available themes" => "Available themes",
"Restrict available themes" => "Restringeix els temes d'estètica disponibles",
// "BigBlueButton web conferencing" => "BigBlueButton web conferencing",
"Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "La integració amb el servidor de col·laboració BigBlueButton de conferència web i la pantalla compartida",
"BigBlueButton server location" => "Ubicació del servidor de BigBlueButton",
"Full URL to the BigBlueButton installation" => "URL de la instal·lació de BigBlueButton",
"http://host.example.com/" => "http://host.example.com/",
"BigBlueButton server salt" => "Salt del servidor de BigBlueButton",
"A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic" => "Una clau de sal utilitzada per generar sumes de comprovació per a que el servidor de BigBlueButton sàpiga que les peticions són autèntiques",
"BigBlueButton recording maximum duration" => "Enregistrament de durada màxima a BigBlueButton",
"A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open" => "La durada màxima de les reunions ha de ser proporcionada a BigBlueButton per evitar els enregistraments excessivament llargs si un usuari deixa la finestra oberta massa temps",
"minutes" => "minuts",
// "BigBlueButton dynamic configuration" => "BigBlueButton dynamic configuration",
"Uses the advanced options of BigBlueButton to configure the XML per room" => "Utilitza les opcions avançades de BigBlueButton per a configurar l'XML per sala",
"Default ordering" => "Ordre predeterminat",
// "Default order" => "Default order",
"Creation Date (desc)" => "Data de creació (desc)",
"Last modification date (desc)" => "Data de l'última modificació (desc)",
"Blog title (asc)" => "Títol de la bitàcola (asc)",
"Number of posts (desc)" => "Nombre de publicacions (desc)",
"Visits (desc)" => "Visites (desc)",
"Activity (desc)" => "Activitat (desc)",
"Disabled" => "Deshabilitat/s/da/des",
"Link to user information" => "Enllaç a la informació d'usuari",
"User profile picture" => "Avatar de l'usuari/a",
"Posts" => "Publicacions",
"Visits" => "Visites",
"Activity" => "Activitat",
// "Blog post copyright" => "Blog post copyright",
"Module (box) shadow start" => "Mòdul (caixa) inici ombra",
"Module (box) shadow end" => "Mòdul (caixa) end ombra",
"Days to display in the calendar" => "Dies que es mostraran al calendari",
"Default view mode" => "Mode de vista per defecte",
"Day" => "Dia",
"Week" => "Setmana",
"Month" => "Mes",
"Quarter" => "Quadrimestre",
"Semester" => "Semestre",
"Year" => "Any",
"View list begins" => "Veure llista comença",
"Focus date" => "Data Enfocament",
"Period beginning" => "Període d'inici",
"First day of the week" => "Primer dia de la setmana",
"Depends user language" => "Depèn de l'idioma de l'usuari",
"Split hours in periods of" => "Divideix hores en períodes de",
"1" => "1",
"5" => "5",
"10" => "10",
"15" => "15",
"30" => "30",
// "Minute Interval" => "Minute Interval",
"First year in the dropdown" => "Primer any en el desplegable",
"years" => "any",
// "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled" => "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled",
"Last year in the dropdown" => "L'any passat a la llista desplegable",
"Enter a year or use +/- N to specify a year relative to the current year" => "Introduïu un any o utilitzi + / - N per especificar un any en relació amb l'any en curs",
"Sticky popup" => "Sticky popup",
"Item view tab" => "Pestanya de vista d'ítem del calendari",
"Show \"Add to Google Calendar\" icon" => "Mostra icona per a afegir al Calendari de Google",
"Show \"Export Calendars\" button" => "Mostra botó Exportar Calendaris",
"Show \"Export Calendar Item\" Button" => "Mostra botó per a exportar un ítem del Calendari",
"Allow exporting a single calendar event as an iCal file" => "Permet exportar un sol event del calendari com a arxiu iCal",
"Use FullCalendar to display calendars" => "Utilitza FullCalendar per mostrar Calendaris",
"Treat calendar item descriptions as HTML" => "Tractar descripcions d'articles naturals com HTML",
"Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Utilitza aquesta opció si utilitza l'editor WYSIWYG per als calendaris. Això és per manejar les dades heretats de Tiki pre 7.0",
"Enable watch events when you are the editor" => "Permet vigilar canvis quan sóc l'editor",
"Check this to receive email notifications of events you changed yourself" => "Si no es controla no rebrà notificacions per correu electrònic per als esdeveniments ha canviat a tu mateix",
"CAPTCHA image word length" => "Longitud de paraula de la Imatge Captcha",
"Number of characters the CAPTCHA will display" => "Longitud de paraula de la Imatge Captcha",
// "CAPTCHA image width" => "CAPTCHA image width",
"Width of the CAPTCHA image in pixels" => "Ample de la Imatge Captcha en píxels",
// "CAPTCHA image noise" => "CAPTCHA image noise",
"Level of noise of the CAPTCHA image" => "Nivell de soroll de la Imatge Captcha",
"Choose a smaller number for less noise and easier reading" => "Trieu un nombre menor per reduir el soroll i facilitar la lectura",
// "CAPTCHA questions" => "CAPTCHA questions",
// "Requires anonymous visitors to enter the answer to a question" => "Requires anonymous visitors to enter the answer to a question",
// "CAPTCHA questions and answers" => "CAPTCHA questions and answers",
// "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line" => "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line",
// "One question per line with a colon separating the question and answer" => "One question per line with a colon separating the question and answer",
"Try automatically to connect SSO" => "Intenta connectar automàticament SSO",
"Force CAS log-out when the user logs out from Tiki" => "Força CAS tancar la sessió quan l'usuari surt de Tiki",
"Show alternate log-in method in header" => "Mostra Login Mètode alternatiu de Capçalera",
"CAS server version" => "versió del servidor CAS",
"none" => "cap",
"Version 1.0" => "Versió 1.0",
"Version 2.0" => "Versió 2.0",
"Hostname" => "Hostname",
"Hostname of the CAS server" => "Nom d'amfitrió del servidor CAS",
"Port of the CAS server" => "Port del servidor CAS",
"Path for the CAS server" => "Ruta d'accés per al servidor CAS",
"CAS Extra Parameter" => "CAS paràmetre",
"Extra Parameter to pass to the CAS Server" => "Paràmetre addicional per passar al servidor CAS",
"CAS Authentication Verification Timeout" => "CAS Autenticació Verificació de temps d'espera",
"Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Comproveu l'autenticació amb el servidor CAS cada N segons. Valor nul significa no tornar a verificar",
"minute" => "minut",
"hour" => "hora",
// "Provides the current categories to Smarty templates" => "Provides the current categories to Smarty templates",
// "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance" => "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance",
// "Categories to add as CSS classes to <body>" => "Categories to add as CSS classes to <body>",
// "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag" => "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag",
// "Clear cache upon category change" => "Clear cache upon category change",
// "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date" => "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date",
// "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts" => "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts",
"Category jail" => "Jail Categoria",
"Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limita la visibilitat dels objectes als quals en aquests identificadors de categories. S'utilitza principalment per a la creació d'espais de treball des de perspectives",
"This should only be set for perspectives, and not globally" => "Això només s'ha d'establir de punts de vista, i no globalment",
"Category jail root" => "Categoria presó Root",
"Always display categories outside of the jail root, which would be for normal categorization" => "Mostra sempre categories fora de l'arrel presó, que seria el normal per a la categorització",
"Category defaults" => "Categoria predeterminats",
"Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default" => "Obligar a determinades categories d'estar present. Si cap de les categories en un conjunt donat es proporcionen, assignar una categoria per omissió",
"Use *7 to specify all the categories in the subtree of 7 + category 7" => "Utilitza * 7 per a especificar totes les categories en el subarbre de 7 + categoria 7",
"Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Només pot fer això per nombreobjeto joc l'expressió regular (exemple: / ^ RND_ / = nom que comença per RND_) (Opcional)",
"Can do for wiki only (optional)" => "Es pot fer per wiki només (opcional)",
"Rename will only reassign the categories for wiki pages" => "Canviar només reassignar les categories per a les pàgines wiki",
"One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page" => "Un per línia. per exemple: 1,4,6,*7/4:/^RND_/:pàgina wiki",
"Synchronize multilingual categories" => "Sincronitzar categories multilingües",
"Make sure that the categories of the translations are synchronized when modified on any version" => "Comproveu que les categories en les traduccions es sincronitzen quan es modifica en qualsevol versió",
"Only those specified" => "Només els especificats",
"All but those specified" => "Tots, excepte els especificats",
"Synchronized categories" => "Categories sincronitzats",
"List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)" => "Llista de categories afectades per la sincronització multilingüe. Depenent de la funció dels pares, aquesta llista es pot utilitzar com una llista blanca (només les categories permet) o com una llista de negre (tots excepte those especificats)",
// "Sort categories case insensitively" => "Sort categories case insensitively",
// "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings" => "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings",
// "Automatically geocode items with this category" => "Automatically geocode items with this category",
"Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automàticament els elements de codis geogràfics basats en el nom de la categoria en classificar-se en les subcategories d'aquesta categoria ID",
// "Replace any existing geocode" => "Replace any existing geocode",
"When automatically geocoding items based on category name, replace existing geocode, if any" => "Quan automàticament els elements de geocodificació basen en nom de la categoria, canviï codificació geogràfica existent si és el cas",
"Use approximate geocode location" => "Utilitzar la ubicació aproximada de geocodificació",
"When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "Quan automàticament els elements de geocodificació basen en nom de la categoria, utilitzeu ubicació aproximada a l'atzar en lloc de la ubicació precisa",
"\"More Like This\" algorithm for categories" => "algorisme \"Més com aquest\" per categories",
"Weighted" => "Ponderat",
"Minimum number of categories in common" => "Nombre mínim de les categories en comú",
// "categories" => "categories",
"2" => "2",
"4" => "4",
"6" => "6",
"7" => "7",
"8" => "8",
"9" => "9",
// "List objects with most categories in common" => "List objects with most categories in common",
// "No minimum is applied" => "No minimum is applied",
// "Maximum number of \"more like this\" objects" => "Maximum number of \"more like this\" objects",
// "The default maximum records setting for the site is used of this is set to 0" => "The default maximum records setting for the site is used of this is set to 0",
// "objects" => "objects",
// "Generate custom facets from categories" => "Generate custom facets from categories",
// "Comma-separated list of category IDs" => "Comma-separated list of category IDs",
// "Show category object count" => "Show category object count",
// "Show object count when browsing categories, complying with search and type filters" => "Show object count when browsing categories, complying with search and type filters",
// "Can slow the loading of the categories page on large sites" => "Can slow the loading of the categories page on large sites",
"Exclude these category IDs" => "Excloure aquests identificadors de categories",
"Category path won't appear for these category IDs" => "Trajectòria Categoria no apareixerà per a aquests identificadors de categories",
"Category path format" => "Format de ruta Categoria",
"Alter how the category path will be rendered" => "Alter com es representarà la ruta de la categoria",
"Links to the category when the category is visible" => "Enllaços a la categoria quan la categoria és visible",
"Text label when the category is visible" => "Etiqueta de text quan la categoria és visible",
"Link when visible, text label otherwise" => "Enllaç al visible, text d'una altra manera",
"Always display the category path labels" => "Mostra sempre les etiquetes de ruta de la categoria",
"Center shadow start" => "Centre ombra inici",
"Center shadow end" => "Centre finals ombra",
// "Users can choose the language of their interface" => "Users can choose the language of their interface",
"Allow users to change the language of the menus and labels" => "Permetre als usuaris canviar l'idioma dels menús i etiquetes",
"Users can change theme" => " Els usuaris registrats poden canviar el tema",
// "Users can override the theme with this setting" => "Users can override the theme with this setting",
"Users can change their password" => "Els usuaris poden canviar la contrasenya",
// "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin" => "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin",
"Disable comment titles" => "Desactivar títol per a comentaris",
"Don't display the title input field on comments and their replies" => "Amaga el camp de títol en els comentaris, i les seves respostes",
"Email field" => "Camp Correu-e",
"Email field for comments (only for anonymous users)" => "Camp Correu-e per a comentaris (només per a usuaris anònims)",
"Website field" => "Camp Website",
"Website field for comments (only for anonymous users)" => "Camp Lloc Web per comentaris (només per a usuaris anònims)",
"Use vote system for comments" => "Utilitzar el sistema de votació per als comentaris",
// "Allow users with permission to vote on comments" => "Allow users with permission to vote on comments",
// "Permissions involved: %0" => "Permissions involved: %0",
"Archive comments" => "Arxivat de comentaris",
"If a comment is archived, only admins can see it" => "Si s'arxiva un comentari, només els administradors poden veure",
"Use Akismet to filter comments" => "Utilitza Akismet per filtrar comentaris",
"Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam" => "Evitar comentaris no desitjats mitjançant el servei de Akismet per determinar si el comentari és spam. Si la moderació de comentaris està activada, el Akismet indicarà si el comentari és que ser moderat o no. Si no hi ha moderació de comentaris, el comentari serà rebutjada si es considera com a correu brossa",
"Akismet API Key" => "Akismet API Clau",
"Key required for the Akismet comment spam prevention" => "Clau necessària per a la prevenció d'spam Akismet comentari per treballar",
"Obtain this key by registering your site at [%0]" => "Obtenir aquesta tecla mitjançant el registre del seu lloc en [0%]",
"Filter spam for registered users" => "Spam Filter per a usuaris registrats",
"Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening" => "Habiliteu el filtratge de correu brossa per als usuaris registrats també. Útil si el lloc permet que qualsevol pugui registrar sense molt validació",
"Allow comments to be edited by their author" => "Permetre que els comentaris siguin corregits pel seu autor",
"Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc" => "Permetre comentaris a ser modificat pel seu autor poc després de la publicació, el que permet corregir els vincles trencats o errors tipogràfics, per un període de 30 minuts,",
// "Inline comments using Apache Annotator" => "Inline comments using Apache Annotator",
// "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations" => "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations",
// "Anchor links on headings" => "Anchor links on headings",
// "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page" => "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page",
"Number of comments per page" => "quants comentaris per pàgina",
// "Sort mode for comments" => "Sort mode for comments",
"Automatically present a terms of use page to be accepted by users accessing the site" => "Presenta automàticament una pàgina de termes a ser acceptats pels usuaris que accedeixin al lloc",
"Terms of Use page name" => "Nom de la pàgina de Termes i Condicions",
"Wiki page for Terms of Use content. The page may be translated using the multilingual feature" => "Pàgina Wiki a utilitzar com a origen del contingut. La pàgina pot ser traduïda utilitzant la característica multilingüe",
"Minimum age" => "Edat Mínima",
"When presenting the terms of use, request age" => "Mentre es demana l'acceptació dels termes d'ús, demana l'edat",
"0 to ignore age validation" => "0 per ignorar la validació d'edat",
// "Tiki connect" => "Tiki connect",
"Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connecta el teu Tiki amb la comunitat a través d'enviar dades estadístiques anònimes a tiki.org",
"This feature is still under development" => "Experimental. Aquesta funcionalitat està en desenvolupament",
// "Send site information" => "Send site information",
"Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you" => "Envia addicionalment paraules clau, localització geogràfica, etc a tiki.org de manera que puguis connectar més endavant amb altres Tikis a prop del teu",
"Site title" => "Nom del lloc",
"Name of site to be listed on Tiki Connect" => "Nom del lloc 'Tiki Connect'",
// "Site title is required to send site information" => "Site title is required to send site information",
"Email contact" => "Correu-e de contacte",
"Email to register" => "Correu-e a Registrar",
"URL to register" => "URL a registrar",
"Key words" => "Paraules Clau",
"Key words or tags describing your site" => "Paraules clau o marques que descriguin el teu lloc",
"Site location" => "Localització del lloc",
"Site location expressed as longitude, latitude, and zoom" => "Localització del lloc com a longitud, latitud, zoom",
"Send anonymous information" => "Envia Informació Anònima",
"Send anonymous usage information" => "Envia informació d'ús anònima",
"Connection frequency" => "Freqüència de connexió",
// "How often to send information" => "How often to send information",
"hours" => "hores",
// "Click \"Send Info\" to connect" => "Click \"Send Info\" to connect",
"Currently not in use" => "Experimental. Actualment sense usar-se, clica a \"Envia Info\" per connectar",
// "Tiki connect server URL" => "Tiki connect server URL",
"Where to send the information" => "On enviar la informació",
"Last connection" => "Darrera connexió",
"Connect server mode" => "Mode de connexió al Servidor",
"For use by mother.tiki.org" => "Per al seu ús per mother.tiki.org",
"Connect GUID" => "GUID de Connexió",
"For use by mother.tiki.org. Do not modify" => "Per al seu ús per mother.tiki.org. No ho modifiquis",
"Allow anonymous visitors to use the \"Contact Us\" feature" => "Permetre que els visitants anònims utilitzin la funció de \"Contacte\"",
"Display contact priority" => "Mostra la Prioritat de Contacte",
"Display contact priority option" => "Mostra l'opció de Prioritat de Contacte",
"Contact user" => "Usuari de contacte",
"User to contact" => "Poseu-vos en contacte amb l'usuari",
"Cookie name" => "Nom Cookies",
"Domain" => "Domini",
// "The domain that the cookie is available to" => "The domain that the cookie is available to",
// "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically" => "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically",
"Ask permission of the user before setting any cookies, and comply with the response" => "Demana als usuaris permís abans de desar-hi qualsevol galeta, i obeeix la seva decisió",
"Complies with EU Privacy and Electronic Communications Regulations" => "Compleix amb la Unió Europea i el Reglament de Privacitat de les Comunicacions Electròniques",
"Cookie consent name" => "Nom de consentiment de Galetes",
"Name of the cookie to record the user's consent if the user agrees" => "Nom de la galeta per registrar el consentiment si estan d'acord",
"Cookie consent expiration" => "Caducitat de Consentiment de Galetes",
"Expiration date of the cookie to record consent (in days)" => "Data de caducitat de la galeta per registrar el consentiment (en dies)",
"days" => "dies",
"Cookie consent text" => "Text del Consentiment de Galetes",
"Description for the dialog" => "Descripció per al diàleg",
"Wiki-parsed" => "Analitzada sintaxi Wiki",
"This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))" => "Aquest lloc li agradaria col·locar cookies al seu ordinador per ajudar-nos a fer-ho millor. Per obtenir més informació sobre les cookies, consulteu la nostra ((política de privacitat))",
"Cookie consent question" => "Pregunta de Consentiment de Galetes",
"Specific question next to the checkbox for agreement. Leave empty to not display a checkbox" => "Qüestió específica al costat de la casella de verificació d'acord. Deixar en blanc per no mostrar una casella de verificació",
"I accept cookies from this site" => "Accepto les galetes d'aquest lloc",
"Cookie consent button" => "Botó de Consentiment de Galetes",
"Label on the agreement button" => "Etiqueta al botó acord",
"Continue" => "Continúa",
"Cookie consent alert" => "Alerta del Consentiment de Galetes",
"Alert displayed when user tries to access or use a feature requiring cookies" => "Alerta apareix quan l'usuari intenta accedir a una funció que requereix cookies",
"Sorry, cookie consent required" => "Ho sentim, es requereix consentiment per a l'ús de galetes (cookies)",
"Cookie consent mode" => "Mode de consentiment de galetes",
"Appearance of consent dialog" => "Aparença de diàleg consentiment",
"Dialog style requires feature_jquery_ui" => "Estil de diàleg requereix feature_jquery_ui",
"Plain" => "Senzill",
"Banner" => "Pancarta (Banner)",
"Dialog" => "Diàleg",
"Cookie consent dialog ID" => "Id de diàleg de Consentiment de Galetes",
"DOM id for the dialog container div" => "DOM id per el div contenidor de diàleg",
// "Cookie consent disabled" => "Cookie consent disabled",
// "Do not give the option to refuse cookies but still inform the user about cookie usage" => "Do not give the option to refuse cookies but still inform the user about cookie usage",
// "Refresh the remember-me cookie expiration" => "Refresh the remember-me cookie expiration",
// "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated" => "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated",
// "Name of the cookie to remember the user's login" => "Name of the cookie to remember the user's login",
"Count admin pageviews" => "Compta visualitzacions de pàgines per l'admin",
"Include pageviews by Admin when reporting stats" => "Inclou pàgines vistes per l'administració en mostrar les estadístiques",
"Enable daily reports for new users" => "Habilitar informes diaris per als nous usuaris",
"Determines if daily reports will be automatically enabled for new users" => "Determina si els informes diaris s'activen automàticament per als nous usuaris. Per omissió és \"no\"",
"Default character set for sending mail" => "Conjunt de caràcters per omissió per enviar correu",
"Specify the character encoding used by Tiki when sending mail notifications" => "Conjunt de caràcters per omissió per enviar correu",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "arxiudemapa per defecte",
"Default diff style" => "Estil per omissió diff",
"Only with last version" => "Només amb la darrera versió",
"HTML diff" => "Diferències en HTML",
"Side-by-side diff" => "Diferències costat-a-costat",
"Side-by-side diff by characters" => "Diferències costat a costat per caràcters",
"Inline diff" => "Diferències en línia",
"Inline diff by characters" => "Diff en línia per caràcters",
"Full side-by-side diff" => "Diferències en tot costat-a-costat",
"Full side-by-side diff by characters" => "Diff costat-a-costat sencer per caràcters",
"Full inline diff" => "Diff en línia sencer",
"Full inline diff by characters" => "Diff en línia sencer per caràcters",
"Unified diff" => "Diferències unificades",
"Side-by-side view" => "Vista costat-a-costat",
"rows" => "línies",
// "Comment box" => "Comment box",
// "Size (height) of the comment text area" => "Size (height) of the comment text area",
"Forum reply" => "Resposta Fòrum",
// "Select default calendars to display" => "Select default calendars to display",
// "Group transition sets default" => "Group transition sets default",
// "Sets the group transitioned to as the user's default group" => "Sets the group transitioned to as the user's default group",
// "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites" => "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites",
"Disable browser's autocomplete feature for username and password fields" => "Desactivar la funció d'autocompletar del navegador per als camps de nom d'usuari i contrasenya",
"Use direct pagination links" => "Empra enllaços directes de paginació",
"Maximum number of links around the current item" => "Max. nombre d'enllaços a tot l'element actual",
// "links" => "links",
"Maximum number of links after the first or before the last item" => "Max. nombre d'enllaços després de la primera o abans de l'últim element",
"Show country flag" => "Mostra la bandera del país",
"Show the country flag" => "Mostra la bandera del país",
"Enable \"popular sites\"" => "Habilitar llocs frescos",
"Validate URLs" => "Validació de URLs",
// "Should Tiki check the URL" => "Should Tiki check the URL",
// "Columns per page" => "Columns per page",
"Number of columns per page when listing directory categories" => "Nombre de columnes per pàgina per a una llista de categories de directori",
// "columns" => "columns",
"Links per page" => "Enllaços per pàgina",
// "How many links should be displayed per page" => "How many links should be displayed per page",
"Method to open Directory links" => "Mètode per obrir el directori de Links",
"The linked-to website can be opened in various ways" => "Mètode per obrir el directori d'enllaços",
"Replace the current window" => "susbtitueix la finestra actual",
"Open a new window" => "nova finestra",
"Open an iframe" => "marc en línia",
"Fields display order" => "Ordenació per mostrar els camps",
// "The order date field inputs should be listed in" => "The order date field inputs should be listed in",
// "Year to show first in dropdown lists" => "Year to show first in dropdown lists",
// "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year" => "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year",
// "year(s)" => "year(s)",
// "Year to show last on dropdown lists" => "Year to show last on dropdown lists",
// "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year" => "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year",
"Re-validate user email after" => "Torneu a validar usuari per correu electrònic després de",
"The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid" => "nombre de dies d'espera abans de tornar a validar el correu electrònic de l'usuari",
"Use \"-1\" for never" => "Empra \"-1\" per a mai",
"Email footer" => "Correu-e peu de pàgina",
"Text appended to outgoing emails" => "El text adjunt a missatges de correu electrònic sortints",
"PHP errors visible to admin only" => "Errors PHP visibles només a admins",
"During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators" => "Per a fins de desenvolupament, que és millor per mostrar els errors de tots els usuaris. No obstant això, en els entorns de producció, que només han de ser mostrades als administradors",
// "PHP Errors will be shown to only the Admin user" => "PHP Errors will be shown to only the Admin user",
"PHP Error reporting level" => "Nivell d'informes d'errors PHP",
"Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist" => "Nivell al qual s'hauria d'informar dels errors",
"No error reporting" => "Sense informes d'errors",
"Report all PHP errors except strict" => "Informa de tots els errors PHP menys els de regles estrictes",
"Report all PHP errors" => "Informar de tots els errors de PHP",
"Report all PHP errors except notices" => "Informa de tots els errors PHP menys els d'avisos",
"According to the PHP configuration" => "Segons la configuració del PHP",
"Default number of comments per page" => "Nombre per defecte de comentaris per pàgina",
// "Maximum number of comments to display on each page. Users may override this number" => "Maximum number of comments to display on each page. Users may override this number",
"Default order of comments" => "Ordre per defecte dels comentaris",
"In which order to list the comments on the page." => "Activa l'edició en línia de tots els camps que apareixen a la pàgina amb la llista d'items d'un formulari-bd",
// "Prefix for answers" => "Prefix for answers",
// "The prefix for that Tiki should display for each FAQ answer" => "The prefix for that Tiki should display for each FAQ answer",
"Q and A" => "P i R",
"Question ID" => "Identificador de pregunta",
// "FAQ copyright" => "FAQ copyright",
// "Limit blog categories to those under this category" => "Limit blog categories to those under this category",
"If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "Si reps un missatge d'error que indica que es requereix una categoria de forma obligatòria quan s'edita una publicació a un bloc, aquesta és l'opció culpable. Poseu-ho en Cap",
"Areas" => "Àrees",
"Binding categories and perspectives to each other" => "Categories d'unió i punts de vista entre si",
// "Pages and collaboratively authored documents with edit history" => "Pages and collaboratively authored documents with edit history",
"Online diaries or journals" => "Diaris o revistes en línia",
"Enable directory batch loading" => "Habilita la carrega en bloc al directori",
// "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols" => "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols",
"You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory" => "Si habilites el Directori per Pujades en Bloc, necessites configurar un directori llegible per la web (fora del teu espai web és millor). Llavors posa a punt una manera per pujar les teves imatges en aquest directori, sigui via scp, sftp, ssh, ftp, o altres protocols",
"Rankings" => "Posicions",
// "Users can see several charts or rankings about the file" => "Users can see several charts or rankings about the file",
// "Image gallery" => "Image gallery",
"Collections of images for viewing or downloading (photo albums)" => "Les col·leccions d'imatges gràfiques per a la visualització o la descàrrega (àlbum de fotos)",
"File galleries can be used instead" => "Pots utilitzar galeries d'arxius en el seu lloc",
// "Image Gallery Comments" => "Image Gallery Comments",
// "Users with permission may post threaded comments. The comments will appear at the bottom of the page" => "Users with permission may post threaded comments. The comments will appear at the bottom of the page",
// "Limit image gallery categories to those under this category" => "Limit image gallery categories to those under this category",
// "Machine translation" => "Machine translation",
"Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service" => "Utilitza traducció automàtica per traduir el contingut de la pàgina a altres idiomes. Tingueu en compte que aquesta característica es basa en paseíto serveis externs no pot ser lliure. Traductor Google és un servei de pagament",
"Database and form generator" => "Base de dades i generador de formularis",
"Threaded or flat discussions" => "Les discussions en línia sobre una varietat de temes. Roscat o apartament",
"File gallery" => "Galeria d'Arxius",
"Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability" => "Arxius informàtics, vídeos o programari per descarregar. En el check-in i check-out (tancament)",
"Save files as drafts" => "Desar arxius com esborranys",
// "Allow saving of files as drafts" => "Allow saving of files as drafts",
"File gallery configuration templates" => "Plantilles de configuració Galeries d'arxius",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Sondejos",
"Presentation of a set of votable options, typically displayed in a module" => "Breu llista d'opcions VOTable, apareix en el mòdul (columna de l'esquerra o la dreta)",
"Newsletters" => "Butlletins",
"Content mailed to registered users or other subscribers" => "Contingut enviat per correu als usuaris registrats",
"Calendar" => "Calendari",
"Events calendar with public, private and group channels" => "Calendari d'esdeveniments amb canals públics, privats i de grup",
"Banners" => "Pancartes",
"Insert, track, and manage advertising banners" => "Inserir, rastrejar i gestionar banners publicitaris",
"Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access" => "Sistema global de categories de contingut. Es poden associar els ítems de diferents tipus (pàgines wiki, articles, items de formularis-bd, etc) a una o més categories. Les categories poden tenir permisos, així que l'accés al contingut pot ser controlat, i p.e. ser mostrat només a un determinat grup",
// "Unified user details " => "Unified user details ",
// "Use User Details Page using the Unified Index" => "Use User Details Page using the Unified Index",
"Score" => "Puntuació",
"Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score és un joc per motivar els participants a augmentar la seva contribució mitjançant la comparació amb altres usuaris",
// "Score expiry" => "Score expiry",
// "Unified search index" => "Unified search index",
// "Enables searching for content at the site using a Tiki-managed index" => "Enables searching for content at the site using a Tiki-managed index",
"Enables tags to be set on pages and other items for freeform categorization" => "Permet fixar etiquetes a les pàgines i objectes diversos en el lloc web i generar patrons de navegació núvol d'etiquetes",
// "Action log" => "Action log",
"Provides the ability to track the actions of users and produce reports on a per-user or per-category basis" => "Permet fer un seguiment del que estan fent els usuaris i generar informes sobre una base per usuari o per la categoria",
"Contribution" => "Contribucions (tipus)",
"Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports" => "Permet als usuaris especificar el tipus de contribució que estan fent durant l'edició d'objectes. Les contribucions són mostrats com un codi de color a la història i altres informes",
"Multilingual" => "Multilingualitat",
"Enables internationalization features and multilingual support at the site" => "Habilita característiques d'internacionalització i suport multilingüe per llavors tot el lloc",
"Frequently asked questions and answers" => "Preguntes i respostes més freqüents",
"There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs" => "Pots utilitzar les pàgines wiki lloc",
"Surveys" => "Enquestes",
"Create questionnaires with multiple-choice or open-ended questions" => "Qüestionari amb múltiples opcions o pregunta oberta",
"User-submitted Web links" => "Enllaços Web enviats per usuaris",
// "Sets of questions that can be presented, with the sessions timed and the scores recorded" => "Sets of questions that can be presented, with the sessions timed and the scores recorded",
// "Featured links" => "Featured links",
"A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc." => "Senzill sistema de menús que es pot afegir opcionalment un pàgina web extern en un iframe",
"Copyright" => "Copyright",
"Use the Copyright Management System (or ©MS) to display the license of your content" => "El Sistema de Gestió de Drets d'Autor (o ©MS de les sigles en anglès) és una forma de llicenciar el seu contingut",
"Wiki references" => "Referències del Wiki",
"Permits using references and the reference library" => "Els permisos que utilitzen les referències i la biblioteca de referència",
// "Library references" => "Library references",
// "Enforce library reference as master" => "Enforce library reference as master",
// "Reference style" => "Reference style",
// "Default style when using references" => "Default style when using references",
// "AMA citation style (default)" => "AMA citation style (default)",
// "MLA citation style" => "MLA citation style",
// "Display reference in a popover" => "Display reference in a popover",
// "Display the details of the reference in a popover" => "Display the details of the reference in a popover",
"Shoutbox" => "Quadre d'avisos",
"Quick comment (graffiti) box. Like a group chat, but not in real time" => "(Graffitis) caixa de comentaris ràpida. Igual que un xat de grup, però no en temps real",
"Live support system" => "Sistema de suport en directe",
"One-on-one chatting with customer" => "Un-a-un al xat amb el client",
// "Tell a friend" => "Tell a friend",
"Add to each page an \"Email this page\" link" => "Afegir un enllaç \"Enviar aquesta pàgina\" en totes les pàgines",
"Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums" => "Afegir un enllaç a \"Comparteix\" a totes les pàgines per enviar-lo per correu electrònic, Twitter, Facebook, missatges o fòrums",
"Be careful when allowing anonymous users to activate the antibot feature" => "anar amb compte en permetre l'anonimat per activar la funció Antibot",
"HTML pages" => "Pàgines HTML",
"Static and dynamic HTML content" => "Contingut HTML estàtic i dinàmic",
"HTML can be used in wiki pages. This is a separate feature" => "HTML es pot utilitzar en pàgines wiki. Aquesta és una característica separada",
// "Contact us" => "Contact us",
"A basic contact form a visitor can use to contact the site admin" => "Formulari bàsic de visitant a l'administrador",
"Minichat" => "MiniChat",
"Real-time group text chatting enabled through a module" => "Text del grup en temps real al xat",
// "Comments moderation" => "Comments moderation",
"Enables the admin or other authorized group member to validate comments before they are visible" => "Un administrador ha de validar un comentari abans de que sigui visible",
// "Add author name in From email header" => "Add author name in From email header",
// "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"" => "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"",
// "Comments locking" => "Comments locking",
"Comments can be closed (no comments, or no new comments)" => "Els comentaris poden ser bloquejats (sense permetre nous comentaris)",
// "Allow logged-in users to post comments anonymously" => "Allow logged-in users to post comments anonymously",
"This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement" => "Això es pot utilitzar per fomentar la retroalimentació honesta amb l'oportunitat d'expressar la seva opinió anònima. Igual que en un fòrum on fer comentaris sobre el que es fa malament o ha de ser millorat internament",
// "Show the page description" => "Show the page description",
"Display the wiki page description between the page title and the page content" => "Mostra la descripció de la pàgina sota el títol en visualitzar la pàgina",
"Display page name as page title" => "Mostra el nom de la pàgina com a Títol de la pàgina",
"Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title" => "Mostra el nom de la pàgina en la part superior de cada pàgina com a títol de la pàgina. Si no està habilitat, el contingut de la pàgina ha de ser estructurada per contenir una capçalera",
// "Show the page ID" => "Show the page ID",
"Each wiki page has a numeric ID and this can be displayed" => "Mostra l'ID intern de la pàgina en visualitzar la pàgina",
"Individual wiki cache" => "Cache wiki Individual",
"Allow users to change the duration of the cache on a per-page basis" => "Permetre als usuaris canviar la durada de la memòria cau pàgina a pàgina",
"Date picker for date selection" => "Escullidor de data per a la selecció de la data",
"JavaScript popup date selector (uses jQuery UI DatePicker)" => "Selector de la data emergent en JavaScript. Utilitzarà DatePicker jQuery UI",
// "Output should be HTML purified" => "Output should be HTML purified",
"This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results" => "Això permet actuar al purificador d'HTML en les sortides per filtrar els possibles problemes de seguretat que quedin, com XSS",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Full screen" => "Pantalla completa",
"Allow users to activate full-screen mode" => "Permet als usuaris d'activar el mode de pantalla completa",
// "CSS menus" => "CSS menus",
"Use CSS-styled (Suckerfish) vertical and horizontal menus" => "CSS Menús (suckerfish)",
"Shadowbox / ColorBox" => "Shadowbox / Caixa de color",
// "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)" => "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)",
// "Quick permission assignment" => "Quick permission assignment",
"Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object" => "Quickperms permeten definir classes de privilegis i els concedeixi als rols dels objectes",
// "User encryption" => "User encryption",
// "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored" => "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored",
// "Enable personal, secure storage of sensitive data such as passwords" => "Enable personal, secure storage of sensitive data such as passwords",
// "This is an experimental feature. Using it may cause loss of the encrypted data" => "This is an experimental feature. Using it may cause loss of the encrypted data",
// "Password domains" => "Password domains",
// "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself" => "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself",
// "HTML purifier" => "HTML purifier",
"If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "Si estàs tractant d'usar HTML a les teves pàgines i s'elimina, el que has d'assegurar és que el teu codi HTML és vàlid o desactivar aquesta funció",
"Ajax" => "Ajax",
// "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work" => "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work",
// "This feature is required for the interface for many features to work properly" => "This feature is required for the interface for many features to work properly",
"Webmail" => "CorreuWeb",
"Intertiki" => "Intertiki",
"Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Permet que diversos llocs de Tiki (esclaus) per obtenir l'autenticació d'un lloc de Tiki màster",
"Mail-in" => "Correu-in",
"Create and publish wiki pages and articles via email" => "Omplir pàgines i articles d'email wiki",
"Mindmap" => "Mindmap",
// "Display in a graphical way the connection among wiki pages" => "Display in a graphical way the connection among wiki pages",
"Print indexed" => "Imprimir indexat",
"Generate a printable version of the whole wiki or a subset of pages, filtered by category" => "Imprimir indexat",
"Spreadsheet" => "Full de càlcul",
"Spreadsheets with calculations and charts" => "Fulls de dades amb càlculs i gràfics",
// "Slideshow (reveal.js)" => "Slideshow (reveal.js)",
"Create simple presentations via Wiki Syntax" => "Slideshow basat Web",
// "Slideshow (reveal.js) PDF export" => "Slideshow (reveal.js) PDF export",
"Wiki-page-based slideshow to pdf export" => "Slideshow basat Web a PDF d'exportació",
"Invoice" => "Factura",
"Invoice system" => "Sistema de facturació",
"Full WYSIWYG editor" => "Editor Wysiwyg Sencer",
"WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience" => "WYSIWYG és l'acrònim del que veus és el que obtens. Utilitza CKEditor",
// "Kaltura video management" => "Kaltura video management",
"Integration with the Kaltura video management platform" => "Integració amb la plataforma de gestió de vídeo Kaltura",
// "Friendship network" => "Friendship network",
"Users can identify other users as their friends" => "Els usuaris poden identificar altres usuaris com a amics",
"Banning system" => "Sistema de prohibició",
"Deny access to specific users based on username, IP, and date/time range" => "Denegar l'accés a usuaris específics en funció de nom d'usuari, IP, i la data / hora del rang",
"Stats" => "Estadístiques",
"Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Anoteu les estadístiques bàsiques sobre les característiques principals de Tiki (nombre de pàgines wiki, la mida de les galeries d'arxius, etc)",
// "Action calendar" => "Action calendar",
"Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Mostra un calendari d'esdeveniments del sistema, com ara modificacions de pàgines wiki, fòrum de missatges i publicacions d'articles. Els dies amb esdeveniments mostren enllaços a la pàgina del calendari d'acció",
"Referrer stats" => "Estadístiques de referenciadors",
"Record domain name of sites that send visitors to this Tiki" => "Registre de noms de domini dels llocs que envien visitants a aquesta Tiki",
"Redirect on error" => "Redirigeix en trobar Errors",
"On an error, refresh to the homepage as specified on the Admin General page" => "En cas d'error, veu a la pàgina d'inici com es configura en Administració-> General",
"Communications (send/receive objects)" => "Comunicacions (enviar/rebre objectes)",
"Send/receive wiki pages and articles between Tiki-powered sites" => "Enviament / recepció de les pàgines wiki i articles entre els llocs Tiki potència",
"Display \"My Account\" in the application menu" => "Mostra 'ElMeuTiki' al menú de l'aplicació",
// "Mini calendar" => "Mini calendar",
// "Displays a personal calendar for each user" => "Displays a personal calendar for each user",
// "User preferences screen" => "User preferences screen",
// "User notepad" => "User notepad",
// "My bookmarks" => "My bookmarks",
// "User contacts" => "User contacts",
// "User watches" => "User watches",
"Receive email notification of changes. Each user can choose to be notified of changes to specific items" => "Rebre notificació per correu electrònic dels canvis. Cada usuari pot escollir ser notificat dels canvis a ítems específics",
// "Group watches" => "Group watches",
// "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group" => "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group",
// "Daily reports for user watches" => "Daily reports for user watches",
// "Allows you to schedule daily reports of watches to be sent (batched) at specific times" => "Allows you to schedule daily reports of watches to be sent (batched) at specific times",
// "User watches translations" => "User watches translations",
// "User watches languages" => "User watches languages",
"Watch language-specific changes within a category" => "Segueix els canvis específics de l'idioma dins d'una categoria",
// "User menu" => "User menu",
"Unmaintained feature" => "Funció Oblidades",
// "User tasks" => "User tasks",
"User messages" => "Missatges d'Usaeuari",
// "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group)." => "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group).",
// "User files" => "User files",
"Menu user levels" => "Menú Nivells d'usuari",
"Enables control of the per-group visibility of menu options" => "Permet controlar les opcions de menú que es poden veure per un usuari",
// "Group alert" => "Group alert",
"Integrator" => "Integrador",
"XMLRPC API" => "XMLRPC API",
"Debugger console" => "Consol·la Depuradora",
// "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions" => "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions",
// "Only viewable by admins" => "Only viewable by admins",
// "Not suitable for production use" => "Not suitable for production use",
"TikiTests" => "TikiTests",
"Permits recording and playback of functional tests" => "Permet l'enregistrament i reproducció de proves funcionals",
"Check for updates automatically" => "Cercar actualitzacions automàticament",
"Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection" => "Tiki buscarà actualitzacions quan s'accedeix a la pàgina principal d'Administració",
// "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters" => "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters",
// "Require confirmation of an action if a possible CSRF is detected" => "Require confirmation of an action if a possible CSRF is detected",
// "Deprecated. Using may cause false errors" => "Deprecated. Using may cause false errors",
"Detect browser language" => "Detecta l'idioma del navegador",
"Look up the user's preferred language through browser preferences" => "Cercar l'idioma preferit de l'usuari a través de les preferències del teu navegador web",
"Show pages in user's preferred language" => "Mostra la pàgines en l'idioma preferit de l'usuari",
"When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences" => "Quan s'accedeix a una pàgina que té un equivalent en l'idioma preferit de l'usuari, afavorir la pàgina traduïda",
"Synchronize page and site language" => "Sincronitzar idioma per a la pàgina i el lloc",
"Changing the page language also changes the site language" => "Canviar l'idioma de la pàgina també canvia l'idioma del lloc",
"Translation assistant" => "Assistent Traducció",
"Track translation operations between pages" => "Seguiment de les operacions de conversió entre pàgines",
"Urgent translation notifications" => "Notificacions traducció urgent",
// "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users" => "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users",
"Incomplete translation notice" => "Avís traducció incompleta",
"When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete" => "Quan una pàgina és traduïda a un llenguatge nou, un avís s'inserirà automàticament a la pàgina per indicar que la traducció no és completa",
"Multilingual structures" => "Estructures Multilíngües",
"Structures search for equivalent pages in other languages" => "Estructures per buscar pàgines equivalents en altres idiomes. Pot causar problemes de rendiment de les estructures més grans",
// "May cause performance problems with larger structures" => "May cause performance problems with larger structures",
"Display all languages in a single page" => "Mostra totes les llengües en una sola pàgina",
"List all languages as options in the page-language dropdown list, to see them all at once" => "Llista de tots els idiomes com una opció d'idioma a la llista desplegable Idioma pàgina per veure tots els idiomes alhora",
"GZip output" => "Sortida GZip",
"Compress your pages on-the-fly, if the requesting browser supports this" => "Comprimeix les pàgines on-the-fly, si el navegador és compatible amb aquesta",
// "Help system" => "Help system",
"Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/" => "permet que el sistema d'ajuda de Tiki",
"Smileys" => "Emoticons",
"Also known as emoticons" => "També conegut com emoticones",
// "Tagging users" => "Tagging users",
// "Add support for @username mentions" => "Add support for @username mentions",
// "User mention notifications" => "User mention notifications",
// "Add support for @username mentions notifications" => "Add support for @username mentions notifications",
// "Draw (SVG edit)" => "Draw (SVG edit)",
"Draw enables creating and editing SVG images in all wiki text areas" => "Dibuixar et dóna la possibilitat d'editar imatges SVG (dibuixos vectorials lleugers però avançats) per tot Tiki",
// "Draw (SVG edit) hide buttons" => "Draw (SVG edit) hide buttons",
"Hide buttons in Draw, HTML id, comma-separated" => "Amaga els botons trobats a l'eina de Dibuixar de Tiki, HTML id, delimitats per comes.  Exemple: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"" => "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"",
"Separate base image" => "Separar la Imatge Base",
"Leaves the initially edited image as a separate file and stores the drawing separately" => "Deixa la imatge inicialment editada com un arxiu independent i emmagatzema el dibuix per separat",
"Draw in user file gallery" => "Dibuixa a la galeria d'arxius de l'usuari",
"Docs (WebODF)" => "Docs (WebODF)",
"Docs enables viewing and editing Open Document Format files" => "Docs et dóna la possibilitat de veure/editar el format Open Document",
// "Dynamic content system" => "Dynamic content system",
"Block of content which can be reused and programmed (timed)" => "Bloc de contingut que es pot reutilitzar i programat (temps)",
// "Use file galleries to store images" => "Use file galleries to store images",
"If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead" => "Si està desactivat, les imatges s'emmagatzemen en ../img/wiki_up/.. en canvi",
"External link icon" => "Icon external link",
// "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set" => "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set",
// "Add \"rel=nofollow\" to external links" => "Add \"rel=nofollow\" to external links",
"Semantic links" => "Enllaços semàntics",
"Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages" => "Més enllà d'enllaços d'entrada, permet definir algunes relacions semàntiques entre les pàgines wiki",
// "Web services" => "Web services",
"Can receive web services via JSON or YAML" => "Pot consumir serveis web en JSON o YAML",
"Use folder icons for menu section (parent) items" => "Mostra menús com a carpetes",
"When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)" => "han menús es mostren com carpetes per omissió \"i \"",
"Breadcrumbs" => "Rastre de molles de pa",
"Indicates the navigation path through parent pages to the current page" => "Els intents per mostrar on es troba",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Editors anònims hauran d'introduir el codi anti-bot (Captcha)",
"Use CAPTCHA to ensure that anonymous input is from a person" => "Empra el codi anti-robots CAPTCHA per assegurar que les entrades d'usuaris anònims són de persones",
"Protect email against spam" => "Protegeix el correu-e contra el correu brossa",
"Protect email against spam submissions." => "protegir el correu electrònic contra les presentacions d'spam",
"Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protecció del correu electrònic contra el correu brossa actualment no operen a les pàgines editades en mode WYSIWYG (Tiki 6.1)",
// "Site ads" => "Site ads",
// "Enable advertising" => "Enable advertising",
// "Activate will display content for Admin only. Select Publish to display for all users" => "Activate will display content for Admin only. Select Publish to display for all users",
"Anonymous voting" => "Vot d'Anònims",
"Allow anonymous users to participate in voting" => "permeten als usuaris anònims de participar en la votació",
// "This can be overridden by specific permissions" => "This can be overridden by specific permissions",
"Allow re-voting" => "Permetre tornar a votar",
// "Visitors can vote mulitiple times in a poll" => "Visitors can vote mulitiple times in a poll",
// "When logged in, Tiki tracks users by username or otherwise IP address" => "When logged in, Tiki tracks users by username or otherwise IP address",
"Comments for polls" => "Comentaris als sondejos",
"Comments for FAQs" => "Comentaris a les PUFs (FAQs)",
"Search engine friendly URL" => "URL amigable als motors de cerca (sefurl)",
"If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config" => "Si està utilitzant Apache, pot copiar _htaccess a .htaccess per obtenir URLs curtes. En IIS, còpia web_config de web.config",
// "SEFURL postfilter" => "SEFURL postfilter",
// "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead" => "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead",
// "Article title in SEFURL" => "Article title in SEFURL",
// "The article title rather than article number can be displayed in the search engine friendly URL" => "The article title rather than article number can be displayed in the search engine friendly URL",
// "Blog title in SEFURL" => "Blog title in SEFURL",
// "The blog title rather than blog number can be displayed in the search engine friendly URL" => "The blog title rather than blog number can be displayed in the search engine friendly URL",
// "Display forum thread or forum post title in the search engine friendly URL" => "Display forum thread or forum post title in the search engine friendly URL",
// "Tracker title in SEFURL" => "Tracker title in SEFURL",
// "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`" => "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`",
// "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)" => "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)",
// "Limit the number of characters in the tracker item or forum thread title" => "Limit the number of characters in the tracker item or forum thread title",
"Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Reescriure tiki-view_tracker.php?itemId=yyy a la pàgina Prefixyyy",
"This redirection uses the wiki prefix alias feature" => "Aquesta redirecció utilitza la característica d'àlies prefix wiki",
"Canonical URL tag" => "Tag URL canònica",
"Indicates to search engines which URL to use, to prevent duplicate listings" => "Indica que els motors de cerca que l'URL d'usar que impedeix llistats duplicats",
// "Canonical URL domain" => "Canonical URL domain",
// "Custom Routes" => "Custom Routes",
// "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL" => "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL",
"Show module controls" => "Barra de control del mòdul",
// "Enable controls in modules" => "Enable controls in modules",
"Perspectives" => "Perspectives",
"Permits overriding of preferences" => "Els permisos per anul·lar les preferències",
"Search and replace" => "Cerca i reemplaça",
"Enables finding and replacing of content in the edit box" => "Permet buscar i reemplaçar el contingut al quadre d'edició",
"Submissions" => "Col·laboracions",
"Articles can be submitted but need to be approved before they are published." => "Les contribucions seran enviades a però han de ser aprovats abans que surti a la",
"Users can see several charts or rankings about the item" => "permetre Rànquing d'articles",
"Comments on articles" => "Comentaris per als articles",
// "Users with permission can post or reply to comments. The comments will appear at the bottom of the page" => "Users with permission can post or reply to comments. The comments will appear at the bottom of the page",
"Article content templates" => "Plantilles de contingut Article",
"Predefined content for an article" => "Contingut predefinit per a un article de notícies",
"template article news" => "Article de notícies plantilla",
// "Print articles" => "Print articles",
"Specify notification emails when creating articles" => "Especifiqueu els missatges de notificació quan la creació d'articles",
// "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation" => "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation",
"ShareThis buttons" => "Botons de ShareThis",
"Enable sharing site content via ShareThis" => "permeti compartir a través d'ShareThis",
"Insert a ShareThis button from [http://www.sharethis.com]" => "Inserir un botó de ShareThis [http://www.sharethis.com]",
// "Category path" => "Category path",
"Show the category tree above the wiki page" => "Mostra Categoria d'arbre, per sobre de les pàgines wiki",
"Show category objects" => "Mostrar objectes categoria",
"Show, at the bottom of the wiki page, objects in the same category" => "Mostra els objectes que comparteixen la mateixa categoria, per sota de les pàgines wiki",
"Ignore category viewing restrictions" => "Ignora les restriccions de visualització de categories",
"Display items the user may not be entitled to view in search results" => "permetrà mostrar articles prohibits (restringida) en el resultat de la cerca",
"Will improve performance, but may show forbidden results" => "Millorarà el rendiment, però poden mostrar resultats prohibits",
"List pages" => "Llistar pàgines",
"Allow viewing the wiki page list" => "permetre la visualització de la llista de la pàgina",
// "Latest changes" => "Latest changes",
"Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display." => "mostrarà una llista dels últims articles modificats",
"Orphan pages" => "Pàgines òrfenes",
// "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)" => "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)",
"MySQL full-text search" => "Cerca MySQL a Text Complert",
"Referer search highlighting" => "Ressaltat dels referenciadors de les cerques",
// "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility" => "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility",
"Search statistics" => "Estadístiques de les cerques",
// "Enables administrators to collect and view statistics on search activity" => "Enables administrators to collect and view statistics on search activity",
"Ignore individual object permissions" => "Ignora els permisos individuals dels objectes",
"Object filter" => "Filtre d'objecte",
"Enables object type filters to be displayed above the search results to further reduce search results by object type" => "permetre el filtratge d'objectes",
"Search box" => "Cerca",
// "Shows a search box above the search results to do additional searches" => "Shows a search box above the search results to do additional searches",
// "Include the number of visits in the search results" => "Include the number of visits in the search results",
"Relevance" => "Rellevancia",
// "Display Tiki's estimate of the relevance of search matches in the search results" => "Display Tiki's estimate of the relevance of search matches in the search results",
"Object type" => "Tipus d'objecte",
// "Shows object type filters above the search results to further reduce search results by object type" => "Shows object type filters above the search results to further reduce search results by object type",
"Last-modified date" => "Darrera data de modificació",
// "Show the last-modified date in search results" => "Show the last-modified date in search results",
"Users can see several charts or rankings about the page" => "activar les classificacions per a articles del bloc",
"Custom blog headings" => "Encapçalaments blocs personalitzats",
"Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead" => "Utilitzant les partides de blocs personalitzats faràs servir molts més recursos de servidor. A menys que necessitis plantilles per-bloc, has d'utilitzar un fitxer de plantilla adaptat",
"Publish dates can be modified" => "Publiqui dates poden ser modificades",
// "Blog post Comments" => "Blog post Comments",
// "Users can view the “top” or “most” downloaded files" => "Users can view the “top” or “most” downloaded files",
// "File gallery comments" => "File gallery comments",
// "Store user files in a file gallery" => "Store user files in a file gallery",
// "Use the file gallery admin and the individual file gallery settings to manage file storage preferences" => "Use the file gallery admin and the individual file gallery settings to manage file storage preferences",
"userfiles" => "userfiles",
"Use file galleries for wiki attachments" => "Utilitza galeries d'arxius per desar adjunts al wiki",
// "Wiki attachments will be stored in the file gallery" => "Wiki attachments will be stored in the file gallery",
"Batch uploading" => "Càrrega per lots",
// "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature" => "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature",
"Accept wiki syntax" => "Aceptar sintaxi-wiki",
"Topic archiving" => "Tema arxivat",
"Quick jumps" => "DRECERES",
"Replies are empty" => "Respostes estan buides",
"If disabled, replies will quote the original post" => "Si està desactivat, les respostes van a citar l'autor original,",
// "Allows quoting in flat forums" => "Allows quoting in flat forums",
// "Allows users to reply" => "Allows users to reply",
"First post of a thread can have an empty body" => "El primer missatge d'un tema pot tenir un cos buit",
"Will be a thread title" => "Serà un títol de fil",
"Forum name search" => "Cercar pel Nom del Fòrum",
"When listing forums" => "Quan es llistin fòrums",
"Forum content search" => "Cercar al contingut del Fòrums",
"Topic content search" => "Cerca al contingut dels temes de debat",
"Tiki-indexed search" => "Cerca indexada per Tiki",
"Use database (full-text) search" => "Utilitza la base de dades de cerca (text complet)",
// "Index posts on forum section change" => "Index posts on forum section change",
// "Re-indexes forum posts to match the parent section when the section is changed" => "Re-indexes forum posts to match the parent section when the section is changed",
"Edit CSS" => "Edita CSS",
// "Edit CSS files directly in the browser" => "Edit CSS files directly in the browser",
// "May not be functional in Tiki 14+" => "May not be functional in Tiki 14+",
"Theme Control" => "Control de Temes",
"Assign different themes to various sections, categories, and objects." => "Assignar diferents temes per diferents seccions, categories i objectes",
"design themes" => "temes de disseny",
// "Tiki template viewing" => "Tiki template viewing",
"Edit templates" => "Editar plantilles",
// "Custom HTML head content" => "Custom HTML head content",
// "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here" => "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here",
// "Add base tag in the HTML head section" => "Add base tag in the HTML head section",
// "The base tag specifies a default address for all links on a page" => "The base tag specifies a default address for all links on a page",
"Site logo and title" => "Logo del Lloc i Títol",
"Display a site logo image and/or title in the page header area" => "usar un Logo del Lloc i Títol",
"This setting is expected to be moved from here to the admin-modules page" => "S'espera que es va a migrar als mòduls del tot i va fer obsoleta",
"Left column" => "Columna esquerra",
"Controls visibility of the left column of modules" => "Controls de visibilitat de la columna de l'esquerra dels mòduls",
"sidebar" => "barra lateral",
"Only if one or more modules are assigned" => "Només si hi ha algun mòdul",
"Always" => "Sempre",
"User decides" => "L'usuari/a decideix",
"Right column" => "Columna dreta",
"Controls visibility of the right column of modules" => "Controls de visibilitat de la columna de la dreta de mòduls",
"Prefix breadcrumbs with \"Location : \"" => "Rastre de molles de pa amb prefix \"Location \"",
// "Place the term \"Location:\" in the breadcrumbs" => "Place the term \"Location:\" in the breadcrumbs",
"Site location bar" => "Barra de localització del lloc",
"Use breadcrumbs module" => "Utilitza mòdul de rastre de molles de pa",
"Top of center column" => "Inici de la columna central",
// "Larger font" => "Larger font",
"Entire location" => "Tot el lloc",
"Page name" => "Nom de la pàgina",
"Use page description" => "Empra descripció de la pàgina",
"Extreme top of page, above the site logo, etc" => "Inici de la pàgina",
"Custom code just before the closing </body> tag" => "Codi personalitzat just abans del tancament </body>",
// "Enter lines here to be placed near the end of the HTML file" => "Enter lines here to be placed near the end of the HTML file",
"Webmaster report" => "Informa al Mestre de la Web",
// "Activate the feature to report a problematic page to the webmaster." => "Activate the feature to report a problematic page to the webmaster.",
"Webmaster email" => "Correu-e del Mestre de la Web",
"Leave blank to use the default sender email" => "Deixar en blanc per utilitzar el correu electrònic predeterminat del remitent",
// "A specific email address can be set for receiving the webmaster reports" => "A specific email address can be set for receiving the webmaster reports",
"Email this page" => "Envia aquesta pàgina per Correu-e",
"Adds a link at the bottom if set, otherwise adds a link at the top" => "Afegir un enllaç a la part inferior, si està configurat, o afegir un enllaç a la part superior",
// "This enables users to share a page with others, by emailing a short message and link to the page" => "This enables users to share a page with others, by emailing a short message and link to the page",
"Shadow layer" => "Capa d'ombra",
"Additional div elements for shadows, radiused corners or other decorative styling" => "Capes addicionals d'ombres, cantonades arrodonides o altre estil decoratiu",
"Tooltips" => "Tooltips",
// "Enable tooltips such as this to have a custom appearance, styled by CSS" => "Enable tooltips such as this to have a custom appearance, styled by CSS",
"Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc" => "Ofereix diversos menús desplegables en molts camps d'entrada de text per als noms de pàgina, noms d'usuari, grups, etiquetes, etc",
"Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
"Reflection" => "Reflexió",
"Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"" => "Permet que les imatges tinguin un efecte de reflexió per sota d'elles. S'utilitza a l'interior del Plugin Img amb el paràmetre class=reflect",
"JQuery UI" => "JQuery UI",
"Include jQuery UI library. Enables a number of interface features" => "Inclogui llibreria jQuery UI. Permet moltes característiques de la interfície d'usuari",
"jQuery UI theme" => "Tema de jQuery UI",
"jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc" => "Tema jQuery UI. Utilitzat en full de càlcul, per exemple",
"Validation" => "Validació",
"Provides various validation possibilities such as for trackers" => "Ofereix diverses possibilitats de validació com passa als Formularis-bd (Trackers)",
// "jQuery infinite carousel" => "jQuery infinite carousel",
"Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel." => "Proporciona un efecte de presentació (com un carrusel d'imatges) per a les galeries d'arxius. Utilitzat en el Plugin Carousel",
// "jQuery sortable tables" => "jQuery sortable tables",
// "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables" => "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables",
// "jQuery media" => "jQuery media",
"Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used." => "Proporciona un reproductor multimèdia que es pot utilitzar en les pàgines wiki, o qualsevol altre característica habilitada amb sintaxi-wiki, per a reproduir un arxiu FLV o MP3, o qualsevol altre tipus d'arxiu multimèdia, com MP4, SWF, AVI, WMV, RAM, MOV, MPEG , PDF, ... Fa una crida a un reproductor multimèdia de codi obert basat en flash per a reproduir-los. Utilitzat en el Plugin MediaPlayer",
// "TagCanvas" => "TagCanvas",
// "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud" => "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud",
// "jQuery zoom" => "jQuery zoom",
// "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"" => "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"",
// "Use tabs" => "Use tabs",
"Separates page content into tabbed panels" => "Fa pàgines més curts per la divisió del contingut en diferents pestanyes",
"Wiki content templates" => "Plantilles de contingut Wiki",
"Prewritten content (probably partial content) for a wiki page" => "Contingut predefinit per a una pàgina wiki",
"Warn on edit conflict" => "Conflicte d'avís en editar",
"When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages" => "Tiki avisarà als usuaris que intenten modificar una pàgina que un altre usuari està editant currenly",
"Undo" => "Desfès",
"Footnotes" => "Notes al peu",
"Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages." => "Crear notes privades d'una pàgina que només són visibles per l'autor",
"Allow HTML" => "Permetre HTML",
"Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "Opció per pàgina: l'HTML a pàgines Wiki és analitzat pel navegador, en lloc de mostrar les etiquetes HTML tal i com s'han escrit",
// "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus" => "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus",
"Log bytes changes (+/-) in action logs" => "Entrada bytes canvis (+ / -) en els registres d'acció",
"May impact performance" => "Pot afectar al rendiment",
"Sandbox" => "LlocdeProves",
// "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved" => "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved",
"Comments below wiki pages" => "Els comentaris a sota de les pàgines wiki",
"Allow users to upload images to a page" => "Permetre als usuaris de pujar imatges (fotos) a una pàgina",
"Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)" => "permetre l'exportació de la Wiki",
"WikiWords" => "Etiquetes wiki",
// "Automatically convert \\\"CamelCase\\\" words into wiki links" => "Automatically convert \\\"CamelCase\\\" words into wiki links",
"Link plural WikiWords to their singular forms" => "Enllaç plural a les WikiParaules als seus formularis-bd particulars",
"Accept dashes and underscores in WikiWords" => "Accepta guions normals (-) i guions baixos (_) en ParaulesWiki",
"History" => "Historial",
// "Users (with permission) can see the history of each wiki page" => "Users (with permission) can see the history of each wiki page",
"Display IP address" => "Visualitza l'adreça IP",
"Wiki full history" => "Wiki historial complet",
"Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Anoteu totes les versions, i no només quan el contingut o la descripció pàgina canvia o quan un comentari edició es dóna",
"View page contributions by author" => "Veure contribucions pàgina de l'autor",
"Visualize the contributions that different authors have made to a wiki page" => "Visualitzar les aportacions de diferents autors realitzades a una pàgina wiki",
"Discuss pages on forums" => "Pàgines de Debat als fòrums",
// "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page" => "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page",
"View source" => "Mostra la font",
// "Users (with permission) can see the wiki and/or HTML syntax of the page" => "Users (with permission) can see the wiki and/or HTML syntax of the page",
// "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”" => "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”",
// "Present a list of pages that link to the current page" => "Present a list of pages that link to the current page",
"Similar pages" => "Pàgines similars",
// "Display a list of pages named similarly to the current page" => "Display a list of pages named similarly to the current page",
"Structures" => "Estructures",
"Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document." => "Les estructures permeten agrupar moltes pàgines Wiki amb jerarquia, una barra de navegació comuna i l'opció d'imprimir totes les pàgines de l'estructura juntes com un html únic",
"Structures drill down menu" => "Menú de tipus 'Drill Down' per a Estructures",
"Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down" => "Estil Ajax de perforar cap avall el menú de les estructures",
"Open page as structure" => "Obre la pàgina com una estructura",
"Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL" => "Obre la capçalera de l'estructura per a pàgines de l'estructura, fins i tot si no es dona el paràmetre de l'estructura a la URL",
"Make structure from page" => "Fes una estructura a partir de la pàgina",
"Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure" => "Mostra un botó sota cada pàgina Wiki per a permetre convertir una pàgina wiki senzilla en la pàgina arrel d'una nova estructura",
"Categorize structure pages together" => "Categoritza les pàgines de l'estructura totes juntes",
"Place new pages of a structure in the same category as the structure's root page" => "Agrupa les pàgines noves de l'estructura sota la mateixa categoria de contingut que la pàgina arrel de l'estructura",
"Disable inherited direct object permissions" => "Desactivar permisos d'objecte heretats directament",
"Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure" => "Les pàgines normalment heredaran permisos d'objecte de la seva pàgina parental. No obstant, els permisos d'objecte manen per sobre dels permisos de categoria. Per tant, si et bases en els permisos de categoria per a estructures, pots voler considerar d'activar aquest paràmetre, de cara a deshabilitar l'herència directa de permisos d'objecte quan s'afegeixin pàgines a una estructura",
"Create webhelp from structure" => "Crea ajuda web a partir de l'estructura",
// "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format" => "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format",
"Import HTML" => "Importar HTML",
"Enable import of HTML pages." => "permetre la importació de pàgines HTML",
"Use date parameter" => "Utilitza el paràmetre data",
// "Allow wiki page version to be selected from a parameter \"date\" on the url" => "Allow wiki page version to be selected from a parameter \"date\" on the url",
"Report it in wiki links" => "Informa'n en enllaços wiki",
// "Add the date parameter to wiki links" => "Add the date parameter to wiki links",
"Import pages" => "Importa les pàgines",
"A personal wiki page for each user" => "Una pàgina personal de l'usuari per fer",
"Userpage prefix" => "Prefix per a la PlanaUsuari",
"All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required" => "Totes les pàgines d'usuari comparteixen un prefix comú. La concatenació del prefix i el nom d'usuari generarà el nom de la pàgina. El prefix no pot estar buit",
"Users can lock pages" => "Els usuaris poden bloquejar pàgines",
"Enable users to lock pages and so prevent others from editing them" => "permeten als usuaris bloquejar pàgines individuals",
"MultiPrint" => "MultiImpressió",
"Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document" => "Permet que s'imprimeixin múltiples pàgines Wiki així com estructures senceres de pàgines wiki com un llibre en un únic html",
// "Print Wiki" => "Print Wiki",
"Provide a print icon and layout of the wiki page formatted for printing" => "permetre la impressió de la Wiki",
"Pages not in structure" => "Les pàgines absents a l'estructura",
"Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display" => "Llista les pàgines que no són en l'estructura",
"Attachments" => "Adjunts",
"Allow users to upload (attach) files to a page" => "Permetre als usuaris pujar (adjuntar) arxius en una pàgina",
// "Limit wiki page categories to those under this category" => "Limit wiki page categories to those under this category",
"If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"" => "Si reps un missatge d'error que indica que es requereix una categoria de forma obligatòria quan s'edita una pàgina wiki, aquesta és l'opció responsable. Posa-ho en Cap",
"Show/hide icon before headings" => "Mostra / Amaga abans encapçalaments",
// "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below" => "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below",
"Wiki argument variables" => "Variables d'arguments Wiki",
"Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Deixi d'escriure variables requerides dins de contingut wiki utilitzant {{paramname}} o {{paramname|per omissió}} – cas especial {{page}} {{user}}",
"Users can choose to stay in SSL mode after an HTTPS login" => "Els usuaris poden optar per allotjar-se en mode SSL després d'una sessió HTTPS",
"Users can switch between secured or standard mode at login" => "Els usuaris poden canviar entre el mode segur o normal en iniciar la sessió",
"Wiki paragraph formatting" => "Format de paràgraf Wiki",
"Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Com la funcionalitat de formatació de paràgrafs Wiki està activada, tots els grups de línies que no estiguin en blanc són agrupades en paràgrafs.  Les línies poden ser de qualseovl longitud, i seran formatades juntes amb la següent línia.  Els paràgrafs es separen amb línies en blanc.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Com la funcionalitat de formatació de paràgrafs Wiki està desactivada, cada línia es mostrarà tal i com l'escriguis. Això vol dir que si vols que els paràgrafs es formatin correctament, un paràgraf ha d'estar tot ell en una sola línia.",
// "Create line breaks within paragraphs" => "Create line breaks within paragraphs",
// "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs" => "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs",
"Automonospaced text" => "Text Automonoespaiat",
// "Lines indented with spaces will automatically be converted to monospace font" => "Lines indented with spaces will automatically be converted to monospace font",
"Tables syntax" => "Sintaxi de taules",
"|| for rows" => "|| per files",
"<return> for rows" => "\n for rows",
"AutoLinks" => "Autoenllaços",
"Web (http://) and email addresses will automatically be converted to links" => "Tiki convertirà automàticament http:// i adreces de correu-e en into links",
"Hotwords" => "Paraules calentes",
"Open hotwords in new window" => "HOTWords s'obrirà en una nova finestra",
"Characters that limit a hotword" => "Personatges que limiten un hotword",
"Use Quote plugin rather than \">\" for quoting" => "Utilitza el connector Cita en lloc de \">\" per citar",
"Center text using ::: instead of :" => "Centrar el text utilitzant ::: lloc de:",
"Useful to avoid conflicts with C++ scope operators or default namespace separator" => "Útil per evitar conflictes amb C + + operadors abast o separadors d'espai de noms per omissió",
"String to use to delimit simplebox" => "Cadena d'utilitzar per delimitar SimpleBox",
"Users can choose to show their gender" => "Els usuaris poden optar per mostrar el seu gènere",
"Real name" => "Nom Real",
"Gender" => "Gènere",
// "Profile picture (avatar)" => "Profile picture (avatar)",
"Country" => "País",
"Last login" => "Última connexió",
"Distance" => "Distància",
"Manual selection of time/date" => "Selecció manual de l'hora / data",
"WebDAV access to Tiki" => "Accés WebDAV per Tiki",
"Allow file gallery access with WebDAV" => "Permetre accedir Galeries d'arxius amb WebDAV",
"use tiki-webdav.php as the URI of the WebDAV repository" => "utilitzar tiki-webdav.php com la URI del repositori WebDAV",
"Fixed width" => "Amplada fixa",
"Restrict the width of the site content area, in contrast to a liquid (full-width) layout" => "Limita l'amplada del lloc web",
"Social networks" => "Xarxes Socials",
"Integration with social applications and networks like Twitter and Facebook" => "Integració amb diferents xarxes socials com ara Twitter o Facebook",
// "Group transition" => "Group transition",
"Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Permet als usuaris transicions entre els diferents grups. Transicions crearan un flux de treball d'aprovació de l'usuari",
// "Category transition" => "Category transition",
"Enables transitions for objects between different categories. Transitions will create a document workflow" => "Permet transicions d'objectes entre diferents categories. Transicions crearan un flux de documents",
// "Tiki user credits" => "Tiki user credits",
"Invite users" => "Convida usuaris",
"Allow users to invite new users to register at this site, by sending an email." => "Permet als usuaris de convidar nous usuaris per correu-e per a registrar-se en aquest tiki",
"Alternate registration page" => "Registre Altern pàgina",
"Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page" => "Fa que qualsevol accés a tiki-register.php redirigir a una pàgina per al registre",
"Load balancer" => "Equilibrador de càrrega",
"Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server" => "Activar aquesta opció només si el servidor està darrere d'un equilibrador de càrrega (o proxy invers), aquesta permet tiki per registrar la IP de l'usuari, en lloc de la IP del servidor intermediari",
// "Tiki is behind a frontend-proxy/load-balancer that rewrites ports" => "Tiki is behind a frontend-proxy/load-balancer that rewrites ports",
// "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links" => "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links",
"Accounting" => "Comptabilitat",
"Double-entry accounting system" => "Sistema de comptabilitat per partida doble",
// "Code editor (CodeMirror)" => "Code editor (CodeMirror)",
// "CodeMirror code editor, which provides syntax highlighting" => "CodeMirror code editor, which provides syntax highlighting",
"Syntax highlighter (CodeMirror) Theme" => "Tema de Ressaltat de Sintaxi (CodeMirror)",
"CodeMirror themes (clear cache after changing)" => "Temes de Codemirror (esborrar memòria cau quan es canviï)",
"default" => "per omisió",
"Off (but switchable)" => "Desactivat (però activable)",
"Dummy preference" => "Preferència Maniquí",
"This is useful for developers to learn how to create a new preference. HTML may be used" => "Això és útil per als desenvolupadors aprenen a crear una nova preferència",
"This is the detail" => "Aquest és el detall",
"This is the warning" => "Aquesta és l'advertència",
"This is the hint. Wiki syntax may be used" => "Aquest és l'indici",
"This is the shorthint. Wiki syntax may be used" => "Aquest és el shorthint",
// "Time sheet" => "Time sheet",
"A project time manager" => "Un gestor de temps del projecte",
// "This feature will be removed after Tiki18 and before Tiki19" => "This feature will be removed after Tiki18 and before Tiki19",
// "HTML feed" => "HTML feed",
"A way to transfer HTML content from one Tiki site to another" => "A manera d'empènyer i tirar trossos html al voltant d'un lloc a un altre",
// "Send an email notification to group leaders when a user joins" => "Send an email notification to group leaders when a user joins",
// "Send an email notification to group leaders when a user leaves" => "Send an email notification to group leaders when a user leaves",
// "Inline comments" => "Inline comments",
// "Contextual comments" => "Contextual comments",
// "Enable JavaScript plugin for equal-height rows" => "Enable JavaScript plugin for equal-height rows",
// "Enable responsive rows, the contained elements of which have the same height" => "Enable responsive rows, the contained elements of which have the same height",
// "Conditional formatting" => "Conditional formatting",
// "Use different coloring for certain system objects. Only groups are supported for now" => "Use different coloring for certain system objects. Only groups are supported for now",
// "Store session variable for current theme" => "Store session variable for current theme",
// "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing" => "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing",
// "Parent category of theme control categories" => "Parent category of theme control categories",
// "Choose the parent category of categories used for theme control" => "Choose the parent category of categories used for theme control",
// "Automatically select the theme-control category of the current theme when categorizing" => "Automatically select the theme-control category of the current theme when categorizing",
// "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme" => "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme",
// "Certain pages redirect to homepage when language is changed" => "Certain pages redirect to homepage when language is changed",
// "List of pages that redirect" => "List of pages that redirect",
// "List of names of pages that always redirect to the homepage when the language is switched" => "List of names of pages that always redirect to the homepage when the language is switched",
// "Separate page names by commas" => "Separate page names by commas",
// "User wizard" => "User wizard",
"Wizard to help users set up their basic settings and account details" => "Assistent per a ajudar als usuaris a posar a punt les seves preferències i informacions personals",
"Present different input fields in the User Wizard than are in the Registration form" => "Pregunta camps diferents a 'Assistent d'Usuaris que els mostrats durant el Registre",
"Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form" => "Pregunta un conjunt diferent de camps a l'Assistent d'Usuaris que els mostrats en el formulari de Registre d'usuaris nous",
"Tracker fields presented in the User Wizard as User Details" => "Camps de Formulari-bd mostrats en l'Assistent d'Usuaris com a Detalls de l'Usuari",
"User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)" => "Camps de Formulari-bd mostrats en l'Assistent d'Usuaris com a Detalls de l'Usuari (IDs de camp separats per dos punts :)",
// "Enable Typography Features" => "Enable Typography Features",
// "Features to replace normal characters with typographic equivalents" => "Features to replace normal characters with typographic equivalents",
// "Smart “curly” quotes" => "Smart “curly” quotes",
// "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes" => "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes",
// "Convert approximative ASCII quotes" => "Convert approximative ASCII quotes",
// "Convert plain-ASCII quote substitutes `` '\\" => "Convert plain-ASCII quote substitutes `` '\\",
// "Smart em-dash and ellipsis" => "Smart em-dash and ellipsis",
// "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…" => "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…",
// "Smart no-break space" => "Smart no-break space",
// "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it" => "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it",
// "Display only select calendars by default" => "Display only select calendars by default",
// "Master Tiki server" => "Master Tiki server",
// "Master Tiki server that this client will obtain user authorizations from" => "Master Tiki server that this client will obtain user authorizations from",
// "Overrides manually registered local users" => "Overrides manually registered local users",
"Import user preferences" => "Importa les preferències d'usuari",
// "Client Tiki will copy the user preferences from the master server" => "Client Tiki will copy the user preferences from the master server",
// "This will overwrite local user preferences every time the user logs in" => "This will overwrite local user preferences every time the user logs in",
"Import user groups" => "Importa els grups d'usuari",
// "Groups the user belongs to on the master server will be imported (along with their security definitions)" => "Groups the user belongs to on the master server will be imported (along with their security definitions)",
// "This will overwrite local groups every time a user logs in" => "This will overwrite local groups every time a user logs in",
// "Limit group import" => "Limit group import",
// "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation" => "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation",
// "This list will limit the group import feature to only those groups listed here" => "This list will limit the group import feature to only those groups listed here",
// "Intertiki shared cookie" => "Intertiki shared cookie",
// "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites" => "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites",
// "This site is a master server" => "This site is a master server",
"Scheduler" => "Programador",
// "Provides the ability to run tasks at a scheduled time" => "Provides the ability to run tasks at a scheduled time",
// "Convert from absolute to relative link" => "Convert from absolute to relative link",
// "Process wiki text and convert internal links from absolute to relative links" => "Process wiki text and convert internal links from absolute to relative links",
// "It's recommended to set a cron job to periodically rebuild the search index" => "It's recommended to set a cron job to periodically rebuild the search index",
"HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "Purificador HTML és una biblioteca filtre HTML compatible amb els estàndards escrit en PHP i integrada en Tiki. Purificador HTML no només eliminarà tots els codis maliciosos (més conegut com XSS) amb una llista blanca completament auditada, segur encara permissiva, sinó que també s'ha d'assegurar que els documents compleixen les normes, cosa que només es pot aconseguir amb un ampli coneixement de les especificacions de W3C",
"Show user's contribution on the user information page" => "Mostrar la contribució de l'usuari a la pàgina d'informació de l'usuari",
"View user's contribution on the user information page." => "veure la contribució de l'usuari a la pàgina d'informació de l'usuari",
"Users' drawings are stored in their user files gallery" => "Els dibuixos d'usuari s'emmagatzemen en el seu usuari galeria arxius",
"Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index" => "nofollow és utilitzat per instruir alguns motors de cerca que els enllaços no han d'influir en els motors de cerca. Es pot reduir el correu brossa en cercadors i evitar que 'spamdexing'",
// "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised" => "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised",
"Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated" => "També coneguda com a 'Cerca bàsica'. Aquesta cerca s'utilitza la característica Full-Text Search MySQL. La indexació s'actualitza contínuament",
// "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6" => "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6",
"Require file creator's name for anonymous uploads" => "Exigir el nom d'arxiu per a la càrrega autor anònim",
"Redirect to similar wiki page" => "Redirigeix a una pàgina wiki similar",
"If a requested page doesn't exist, redirect to a similarly named page" => "Si la pàgina sol·licitada no existeix, redireccionarà a una pàgina de nom similar",
"Redirect to page alias, if any" => "Redirigeix a la pàgina de l'àlies, si escau",
"If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "Si la pàgina sol·licitada no existeix, redireccionarà a una pàgina d'àlies, si s'especifica l'ús d'un vincle semàntic àlies",
"User's information page" => "Pàgina d'usuari",
"Display a user's gender if permitted by the user." => "mostrar el sexe d'un usuari quan li permetin",
"Allow showing user's information on mouseover" => "Permet mostrar la informació de l'usuari en passar el punter del ratolí per sobre",
"Show users' information on mouseover." => "Funcionalitat de lloc per permetre mostrar la informació dels usuaris en passar el punter del ratolí per sobre",
"Requires user's information to be public" => "Es requereix que la informació de l'usuari sigui pública",
"Show the user's real name" => "mostrar el nom real de l'usuari",
// "Federated search" => "Federated search",
// "Search through alternate site indices" => "Search through alternate site indices",
// "Elasticsearch is required" => "Elasticsearch is required",
// "Elasticsearch tribe node URL" => "Elasticsearch tribe node URL",
// "URL of the tribe client node accessing multiple clusters" => "URL of the tribe client node accessing multiple clusters",
"Default feed format" => "Format d'alimentació per omissió",
"ATOM 1.0" => "ATOM 1.0",
"RSS 2.0" => "RSS 2.0",
"Feed author name" => "Introduïu el nom de l'autor",
// "Default author of each item in the feed" => "Default author of each item in the feed",
"This field is mandatory unless both feed author email and homepage are empty" => "Aquest camp és obligatori llevat que tant l'autor com correu electrònic i la pàgina principal d'alimentació estan buides",
"Feed author email" => "Alimenti autor email",
// "Email of the author of each item in the feed" => "Email of the author of each item in the feed",
"Feed author homepage" => "Alimenti homepage autor",
// "Homepage URL of the author of each item in the feed" => "Homepage URL of the author of each item in the feed",
"Feed editor email" => "Alimenti email editor",
"Email address for person responsible for editorial content" => "Adreça de correu electrònic de la persona responsable del contingut editorial",
"Feed webmaster email" => "Alimenti webmaster email",
"Email address for person responsible for technical issues relating to channel" => "Adreça de correu electrònic de la persona responsable de les qüestions tècniques relatives a canalitzar",
"Feed image path" => "Alimenti Ruta de la imatge",
"Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Especifica una imatge GIF, JPEG o PNG que es pot visualitzar amb l'alimentació",
// "Feed language" => "Feed language",
"The default language for this feed" => "l'idioma per omissió d'aquest feed",
// "RSS basic authentication" => "RSS basic authentication",
"Propose basic HTTP authentication if the user has no permission to see the feed" => "Proposar l'autenticació bàsica HTTP si l'usuari no té permís per veure els feed",
"Feed caching time" => "Alimenti el temps d'emmagatzematge en memòria cau",
// "Cache the feed for this number of seconds" => "Cache the feed for this number of seconds",
"Use 0 for no caching" => "Utilitza 0 per a l'emmagatzematge en memòria cau",
"Feed caching is done for anonymous users only" => "RSS caching es fa per als usuaris anònims només",
"RSS for articles" => "RSS dels articles",
"RSS feeds for articles" => "RSS dels articles",
"RSS for blogs" => "RSS per a blogs",
"RSS feeds for blogs" => "RSS feeds per a blogs",
"RSS for individual blogs" => "RSS per blocs individuals",
"RSS feeds for individual blogs" => "RSS feed per als blocs individuals",
"RSS for image galleries" => "RSS de galeries d'imatges",
"RSS feed for image galleries" => "RSS de galeries d'imatges",
"RSS for individual image galleries" => "RSS de galeries d'imatges individuals",
"RSS feeds for individual image galleries" => "RSS feed per galeries d'imatges individuals",
"RSS for file galleries" => "RSS per les galeries d'arxius",
"RSS feed for file galleries" => "RSS feed per les galeries d'arxius",
"RSS for individual file galleries" => "RSS per les galeries d'arxius individuals",
"RSS feeds for individual file galleries" => "RSS feed per les galeries d'arxius individuals",
"RSS for wiki pages" => "RSS de les pàgines wiki",
"RSS feed for wiki pages" => "RSS wiki",
"RSS for forums" => "RSS per fòrums",
"RSS feed for forums" => "RSS feed per els fòrums",
"RSS for individual forums" => "RSS per fòrums individuals",
"RSS feeds for individual forums" => "RSS feed per fòrums individuals",
"RSS per tracker" => "RSS per formulari-bd",
"RSS feed per tracker" => "RSS feed per formulari-bd",
"RSS for calendar events" => "RSS dels esdeveniments del calendari",
"RSS feed for calendar events" => "RSS feed per els esdeveniments en el calendari",
"RSS for directories" => "RSS dels directoris",
"RSS feed for directories" => "RSS feed per els directoris",
"RSS for shoutbox" => "RSS del quadre d'avisos",
"RSS feed for shoutbox" => "Alimentació RSS del quadre d'avisos",
"Maximum number of items to display" => "Màximu nombre d'ítems per mostrar",
// "items" => "items",
"Show author" => "Mostrar autor",
"Homepage URL" => "URL de pàgina principal",
"Tiki RSS feed for articles" => "Alimentació RSS del Tiki per a articles",
"Tiki RSS feed for blogs" => "Alimentació RSS del Tiki per a blocs web",
"Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Títol que s'anteposa al títol del bloc per a tots els blocs. Si aquest camp està buit només s'utilitzarà el títol del bloc",
"Tiki RSS feed for image galleries" => "Alimentació RSS del Tiki per a galeries d'imatges",
"Tiki RSS feed for the image gallery: " => "Alimentació RSS del Tiki per a la galeria d'imatges: ",
"Tiki RSS feed for file galleries" => "Alimentació RSS del Tiki per a galeries de fitxers",
"Tiki RSS feed for the file gallery: " => "Alimentació RSS del Tiki per a la galeria de fitxers: ",
"Tiki RSS feed for the wiki pages" => "Alimentació RSS del Tiki per a pàgines wiki",
"Tiki RSS feed for forums" => "Alimentació RSS del Tiki per a fòrums",
"Tiki RSS feed for forum: " => "Alimentació RSS del Tiki per al fòrum: ",
"Tiki RSS feed for individual trackers: " => "Alimentació RSS del Tiki per a formularis-bd individuals: ",
"Tiki RSS feed for calendars" => "Alimentacions RSS de Tiki per als calendariss",
"Tiki RSS feed for directory sites" => "Alimentació RSS del Tiki per a llocs del directori",
"Tiki RSS feed for shoutbox messages" => "Tiki RSS feed per els missatges shoutbox",
"Article RSS description" => "Article RSS Descripció",
"Description to be published as part of the RSS feed for articles" => "Descripció que es publicarà com a part de la font RSS dels articles",
"Last articles." => "Els últims articles.",
"Blogs RSS description" => "Blocs RSS Descripció",
"Description to be published as part of the RSS feed for blogs" => "Descripció que es publicarà com a part de l'alimentació de RSS per blocs",
"Last posts to weblogs." => "Darrers enviaments a les bitàcoles.",
"Blog RSS Description" => "Bloc RSS Descripció",
"Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used" => "Descripció que s'anteposa a la descripció del bloc i publicat com a part de la font RSS de blocs individuals. Si aquest camp està buit només serà utilitzada la descripció del bloc",
"Image galleries RSS description" => "Galeries d'imatges RSS Descripció",
"Description to be published as part of the RSS feed for image galleries" => "Descripció que es publicarà com a part de la font RSS de galeries d'imatges",
"Latest images uploaded to the image galleries." => "darreres imatges pujades a les galeries d'imatges.",
"Individual image galleries RSS Description" => "Imatge individual galeries RSS Descripció",
"Description to be published as part of the RSS feeds for individual image galleries" => "Descripció que es publicarà com a part de la font RSS de galeries d'imatges individuals",
"Latest images uploaded to this image gallery." => "Darreres imatges pujades a la galeria d'imatges.",
"File galleries RSS description" => "Arxiu galeries RSS Descripció",
"Description to be published as part of the RSS feed for file galleries" => "Descripció que es publicarà com a part de l'alimentació de RSS per les galeries d'arxius",
"Latest files uploaded to the file galleries." => "Darrers arxius pujats a les galeries d'arxius.",
"Individual file galleries RSS description" => "Arxiu individual galeries RSS Descripció",
"Description to be published as part of the RSS feeds for individual file galleries" => "Descripció que es publicarà com a part de l'alimentació de RSS per les galeries d'arxius individuals",
"Latest files uploaded to this file gallery." => "Darrers fitxers enviats a aquesta galeria arxiu.",
"Wiki pages RSS description" => "Wiki pàgines RSS Descripció",
"Description to be published as part of the RSS feed for wiki pages pages" => "Descripció que es publicarà com a part de la font RSS de pàgines wiki",
"Latest wiki page changes." => "Darreres modificacions al Wiki.",
"Forums RSS description" => "Fòrums RSS Descripció",
"Description to be published as part of the RSS feed for forums" => "Descripció que es publicarà com a part de l'alimentació de RSS per fòrums",
"Latest forum topics." => "Darrers Temes als fòrums.",
"Individual forums RSS description" => "Individual fòrums RSS Descripció",
"Description to be published as part of the RSS feeds for individual forums" => "Descripció que es publicarà com a part de l'alimentació de RSS per fòrums individuals",
"Latest posts to this form" => "Darreres publicacions a aquest fòrum. ",
"Individual trackers RSS description" => "Formulari-bds individuals RSS Descripció",
"Description to be published as part of the RSS feed for individual trackers" => "Descripció que es publicarà com a part de la font RSS de formularis-bd individuals",
"Latest additions to this tracker" => "Últims articles publicats en aquest un formulari-bd",
"Calendar events RSS description" => "Calendari d'esdeveniments RSS Descripció",
"Description to be published as part of the RSS feed for calendar events" => "Descripció que es publicarà com a part de la font RSS d'esdeveniments al calendari",
"Upcoming Events" => "Propers Esdeveniments",
"Directories RSS description" => "Directoris RSS Descripció",
"Description to be published as part of the RSS feed for directories" => "Descripció que es publicarà com a part del RSS feed per els directoris",
"Latest sites." => "Darreres webs.",
"Shoutbox RSS description" => "Shoutbox RSS Descripció",
"Description to be published as part of the RSS feed for shoutbox messages" => "Descripció que es publicarà com a part de l'alimentació de RSS per als missatges shoutbox",
"Latest shoutbox messages" => "Últims missatges shoutbox",
"Tracker labels" => "Etiquetes Formulari-bd",
"Include tracker field labels in the RSS output" => "Inclogui etiquetes de camp Formulari-bd (Tracker) a la sortida de RSS",
"Page" => "Pàgina",
// "Finder view" => "Finder view",
"Show as a column" => "Mostra-ho com una columna",
"Show in popup box" => "Mostra en requadre emergent",
"Both" => "Ambdues coses",
"Podcast directory" => "Directori de Podcast",
// "File system directory for storing podcast files" => "File system directory for storing podcast files",
"The server must be able to read/write the directory." => "El servidor ha de poder llegir/escriure el directori.",
"Required for podcasts" => "Necessari per podcasts",
"To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc" => "Si activeu Directori lots Carregant, cal configurar un directori web de lectura (fora del seu espai web és millor). A continuació, configurar una forma de carregar els arxius en aquest directori, ja sigui mitjançant scp, ftp, o altres protocols",
"The server must be able to read the directory" => "El servidor ha de ser capaç de llegir el directori",
"The directory can be outside the web space." => "El directori pot ser fora de l'espai web.",
"Prevent download if score becomes negative" => "Evitar descàrrega si la puntuació es converteix en negatiu",
// "If using Tiki Score system, users with a negative score cannot download files" => "If using Tiki Score system, users with a negative score cannot download files",
"Allow download limit per file" => "Permetre descarregar límit per arxiu",
// "Allow file duplicates" => "Allow file duplicates",
"Allow the same file to be uploaded more than once" => "Permet que es pugui pujar el mateix arxiu més d'un cop",
"Yes, even in the same gallery" => "Sí, fins i tot a la mateixa galeria",
"Only in different galleries" => "Només en galeries diferents",
"Display ZIP option in gallery" => "Mostra opció zip a la galeria",
"Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery." => "Visualització a la galeria de l'opció zip (en càrrega i la galeria fitxer)",
"Must match" => "Ha de coincidir amb",
// "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)" => "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)",
"Cannot match" => "No es pot igualar",
// "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted" => "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted",
"Quota for all files and archives" => "Quota per a tots els arxius i els arxius",
// "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)" => "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)",
"0 for unlimited" => "0 per ilimitades",
// "megabytes" => "megabytes",
"Quota for each file gallery" => "Quota es pot definir per cada galeria arxiu",
// "A different quota can be defined for each file gallery" => "A different quota can be defined for each file gallery",
"Default quota for each new gallery" => "Quota per omissió per a cada nova galeria",
"Show quota bar in the list page" => "Mostra la barra de quota a la pàgina de la llista",
"Yes, display bar and detail text" => "Sí, mostrar bar i del detall",
"Yes, display only bar" => "Sí, mostrar només bar",
"Yes, display only text" => "Sí, mostrar només text",
"Storage" => "Emmagatzematge",
// "Specify if uploaded files should be stored in the database or file directory" => "Specify if uploaded files should be stored in the database or file directory",
"Store in database" => "Emmagatzemar a la base de dades",
"Store in directory" => "Emmagatzemar a un directori al disc del servidor",
"Path to the directory to store file gallery files" => "Ruta per guardar arxius a la galeria d'arxius",
// "Searchable file gallery content" => "Searchable file gallery content",
"Include the search form on the current gallery page just after \"Find\"" => "Incloure el quadre de cerca en els arxius de la galeria de corrent immediatament després de la div trobar",
"Include a search form in file galleries" => "Inclogui un quadre de cerca a galeries d'arxius",
// "Display hits ratio to maximum" => "Display hits ratio to maximum",
"Display hits with a ratio of hits to maximum hits" => "Mostra resultats amb una relació entre cops / maxhits",
"Display properties in the context menu" => "Mostrar les propietats en el menú contextual",
"Display \"Replace\" in the context menu" => "Vegeu el menú reemplaçar al menú contextual",
"Automatic deletion of old files" => "Esborrat automàtic de fitxers antics",
"The user will have an option when uploading a file to specify the time after which the file is deleted" => "L'usuari tindrà l'opció al carregar un fitxer per especificar el temps després del qual s'elimina l'arxiu",
"A cron job must be set up in order to delete the files" => "S'ha de  configurar un treball de cron per tal d'eliminar els arxius",
"Allow action on multiple files or galleries" => "Permetre l'acció en diversos arxius o galeries",
"Include \"Remove\" as an option for the checkbox action in file galleries" => "El botó de verificació a la galeria arxiu es pot eliminar",
"Deletion emails notification" => "Notificació de missatges de correu electrònic esborrat",
"Email addresses (comma-separated) to receive a copy of each deleted file" => "Aquests missatges de correu electrònic rebran una còpia de cada arxiu eliminat. Els correus electrònics es separen amb comes",
"Keep the same fileId for the latest version of a file" => "Mantingui la mateixa fileId per a l'última versió d'un fitxer",
"If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file" => "Si es marca, el fileId de l'última versió d'un arxiu és el mateix. Enllaç a un arxiu sempre li donarà l'última versió. Si no es marca, el fileId s'adjunta l'arxiu per sempre, enllaç a presentar li donarà la versió exacta d'un arxiu",
"Show thumbnail actions" => "Mostrar accions miniatura",
"Show the checkbox and wrench icon for file actions menu when not displaying details" => "Mostrar la casella de verificació i la icona de clau per al menú d'accions d'arxius quan no aparegui detalls",
"Maximum thumbnail size" => "Mida màxima de miniatures",
"Maximum width or height for image thumbnails" => "Amplada màxima o altura de les miniatures d'imatges",
"Automatic indexing of file content" => "Indexació automàtica de continguts del fitxer",
"Uses command line tools to extract the information from the files based on their MIME types" => "Utilitza les eines de línia d'ordres per extreure la informació dels arxius en funció dels seus tipus MIME",
// "Asynchronous indexing" => "Asynchronous indexing",
"Upload files from remote source" => "Pujar arxius d'origen remot",
"Enable copying files to file galleries from a URL that will be polled for new revisions" => "Permetre crear arxius en galeries de fitxers utilitzant un URL que seran enquestades per a noves revisions",
"Remote source refresh frequency limit" => "Límit de freqüència d'actualització remota de codi",
"Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests" => "Import mínim de segons a esperar entre comprovacions de la font per a evitar saturar els servidors",
// "Set to zero to disable refresh" => "Set to zero to disable refresh",
"Display controls to attempt a file refresh" => "Mostra els controls per intentar refrescar",
"Let users trigger a refresh attempt from the remote host" => "Permetre que els usuaris activen un intent d'actualització del host remot",
"Allow searching for existing files in the tracker files field" => "Permetre la cerca dels arxius existents en el camp dels arxius de seguiment",
"Search files using the search index" => "Cerca de fitxers utilitzant l'índex de cerca",
"Set MIME type based on file suffix" => "Fixar els tipus MIME basat en sufix d'arxiu",
"Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream" => "Corregeix mim tipus d'arxius d'imatge en base als sufixos de fitxers quan són detectats incorrectament com application / octet-stream",
// "Clean XML Always" => "Clean XML Always",
// "Sanitize XML based files such as SVG for all users" => "Sanitize XML based files such as SVG for all users",
// "Allow SVG file upload" => "Allow SVG file upload",
// "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files." => "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files.",
"Maximum name length" => "Max Nom Llarg",
"Length to which to truncate file names in browse view" => "Longitud de truncar els noms d'arxiu en vista d'exploració",
"Maximum width of images" => "Amplada màxima de les imatges",
"Default maximum width of images in galleries" => "Ample màxim predeterminat per a les imatges en la galeria",
"Maximum height of images" => "L'alçada màxima de les imatges",
"Default maximum height of images in galleries" => "Alçada màxima predeterminada per les imatges a la galeria",
"Use elFinder UI" => "Utilitza elFinder UI",
"Alternative file manager with drag and drop capability" => "Gestor de fitxers Modern, amb capacitat per copiar i enganxar",
// "Use Viewer JS" => "Use Viewer JS",
// "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages" => "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages",
// "Viewer JS URI" => "Viewer JS URI",
// "Where ViewerJS is installed" => "Where ViewerJS is installed",
// "Use PDF.js" => "Use PDF.js",
// "Uses PDF.js to display PDF files in web pages" => "Uses PDF.js to display PDF files in web pages",
// "Default view" => "Default view",
// "Default sort field" => "Default sort field",
"Last modification date" => "Data de la darrera modificació",
"Owner" => "Propietari",
"Default sort direction" => "Direcció d'ordenació per omissió",
"Descending" => "Descendent",
"Ascending" => "Ascendent",
"Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Introdueix l'ID de qualsevol arxiu a qualsevol galeria per a emprar-lo com a icona d'aquesta galeria en vista de navegació",
// "Show explorer" => "Show explorer",
// "Show path" => "Show path",
// "Show slideshow" => "Show slideshow",
"Name-filename" => "Nom-nom del fitxer",
"Filename only" => "Només el nom del fitxer",
// "Created / Uploaded" => "Created / Uploaded",
// "Show icon in column" => "Show icon in column",
// "OCR Files" => "OCR Files",
// "Extract and index text from supported file types" => "Extract and index text from supported file types",
// "OCR Every File" => "OCR Every File",
// "Attempt to OCR every supported file" => "Attempt to OCR every supported file",
// "View or export office documents as PDF" => "View or export office documents as PDF",
// "If enabled allows to view documents without download or to export documents as PDF files" => "If enabled allows to view documents without download or to export documents as PDF files",
// "Maximum width of file preview in pixels" => "Maximum width of file preview in pixels",
// "The maximum value of width in pixels for the files preview in the popover" => "The maximum value of width in pixels for the files preview in the popover",
// "Export diagram image on save" => "Export diagram image on save",
// "If enabled, diagrams will be cached in PNG format when saved or edited" => "If enabled, diagrams will be cached in PNG format when saved or edited",
// "Use draw.io public services to export images" => "Use draw.io public services to export images",
// "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback" => "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback",
"Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory" => "Establir un directori del seu servidor. Exemple:. /var/www/ Es recomana que aquest directori no sigui web accessible. PHP ha de ser capaç de llegir / escriure al directori",
"Default order of comments." => "algoritme d'ordenació per omissió",
// "Use jQuery upload" => "Use jQuery upload",
// "Use the improved Tiki 15+ upload page" => "Use the improved Tiki 15+ upload page",
// "Redirect to file gallery" => "Redirect to file gallery",
// "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery" => "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery",
// "Revision approval" => "Revision approval",
"Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges" => "Utilitza les revisions marcades per a ocultar d'usuaris amb menors privilegis les revisions de pàgina wiki no aprovades encara",
// "Revision approval categories" => "Revision approval categories",
"List of category IDs for which revision approval is required" => "Llista dels identificadors de categories en què es requereix l'aprovació de la revisió",
"Footer shadow div start" => "Inici ombra Footer",
"Footer shadow div end" => "Finals ombra Footer",
// "Forum image file gallery" => "Forum image file gallery",
// "File gallery used to store images for forums" => "File gallery used to store images for forums",
"Uploaded filenames must match regex" => "Els arxius penjats han de coincidir amb aquesta regex ",
"Manage thread defaults per-forum" => "Gestiona les opcions per omissió dels fils de discussió per-fòrum",
"Display thread configuration bar" => "Mostra la barra de configuració dels fils de discussió",
"Allows users to override the defaults" => "Permet als usuaris modificar els valors per omissió",
"Display the thread configuration bar only when the number of posts exceeds" => "Mostra la barra de configuració dels fils de discussió només quan el nombre de publicacions supera els/les",
// "posts" => "posts",
"Keep settings for all forums during the user session" => "Manté la configuració de tots els fòrums durant la sessió d'usuari",
"Default style" => "L'estil per omissió",
"Threaded" => "Per fils de discussió",
"Headers only" => "Només capçaleres",
"Default sort mode" => "La manera per omissió",
"Title (desc)" => "Títol (desc)",
"Title (asc)" => "Títol (asc)",
"Topics" => "Temes",
"Posts per day" => "Publicacions per dia",
"Last post" => "Darrer enviament",
"Description length" => "Longitud de la descripció",
"Require reply to have a title" => "Força el títol en les respostes",
"Present an empty title input form and require it to be filled in before the forum post is submitted" => "Mostra un quadre de títol en blanc, i requereix que s'ompli abans de la presentació del missatge del fòrum",
// "Prevent Nesting of Quote wikiplugins when replying" => "Prevent Nesting of Quote wikiplugins when replying",
// "Strips quote plugin in reply in order to prevent nesting of quote plugins" => "Strips quote plugin in reply in order to prevent nesting of quote plugins",
"Forum post categories" => "Categories del Missatges al Fòrum",
"Categories available in the category picker for forum posts" => "Categories disponibles al selector de categoria de missatges en el fòrum",
"Include category selector in forum list" => "Inclou en el selector de categoria a la llista de fòrums",
// "Allow inbound email posts from anyone" => "Allow inbound email posts from anyone",
// "Allow posts from non-users in forums using inbound posts from a specified email address" => "Allow posts from non-users in forums using inbound posts from a specified email address",
// "Parse HTML in inbound email posts" => "Parse HTML in inbound email posts",
// "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG" => "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG",
"Experimental" => "Experimental",
// "Has problems with some HTML emails, especially those with table-based layouts" => "Has problems with some HTML emails, especially those with table-based layouts",
// "Strip wiki markup from outgoing forum emails" => "Strip wiki markup from outgoing forum emails",
// "Convert outgoing emails from forum posts to plain text" => "Convert outgoing emails from forum posts to plain text",
// "Send moderation email" => "Send moderation email",
// "Send email to forum moderators when post is queued" => "Send email to forum moderators when post is queued",
// "Approve link in moderation email" => "Approve link in moderation email",
// "Include a link for forum moderators to approve queue from email" => "Include a link for forum moderators to approve queue from email",
// "Do not start messages titles with 'Re:'" => "Do not start messages titles with 'Re:'",
"Don't display forum thread titles" => "Amaga títols per a fils del fòrum",
"Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display" => "La majoria dels títols es deixen sense tocar, ja que són una resposta directa a les converses dels pares. Aquesta opció oculta el títol complet de les formes i mostrar",
"Include a dropdown selector in the forum list to choose a category for the post" => "Inclou una llista desplegable a la llista de fòrums per seleccionar la categoria de la publicació",
"Creation date (asc)" => "Data de creació (asc)",
"Topics (desc)" => "Temes (desc)",
"Threads (desc)" => "Missatges (desc)",
"Latest post (desc)" => "Últim post (desc)",
"Name (desc)" => "Nom (desc)",
"Name (asc)" => "Nom (asc)",
// "Href" => "Href",
"Object ID" => "Object ID",
// "Comments locked" => "Comments locked",
"Multilingual tags" => "Etiquetes multilingües",
"Permits translation management of tags" => "Permet la gestió de la traducció de les marques",
// "Ordering of tagged objects" => "Ordering of tagged objects",
// "Default sort mode for tagged items" => "Default sort mode for tagged items",
"Show tag cloud" => "Mostra núvol de marques",
// "Show the full tag cloud in the list-tags screen" => "Show the full tag cloud in the list-tags screen",
"Maximum number of tags in cloud" => "El nombre màxim de marques en el núvol",
// "tags" => "tags",
"Show tags in middle column" => "Mostra les marques lliures a la columna central",
// "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page." => "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page.",
"Preload random tag" => "Preload marca lliure tag atzar",
// "A random tag will be selected on the tag search page (if no tag is pre-selected)." => "A random tag will be selected on the tag search page (if no tag is pre-selected).",
// "Tag Suggestions" => "Tag Suggestions",
"Number of tags to show in tag suggestions" => "Nombre d'etiquetes per mostrar a Suggeriments d'etiquetes",
"Valid characters pattern" => "Patró de caràcters vàlid",
// "Click on the links below to set or clear a pattern to limit characters accepted in tags. " => "Click on the links below to set or clear a pattern to limit characters accepted in tags. ",
"Lowercase tags only" => "Etiquetes en minúscules només",
// "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly." => "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly.",
// "GD %0 detected" => "GD %0 detected",
// "GD not detected" => "GD not detected",
// "Imagick %0 detected" => "Imagick %0 detected",
// "Imagick 0 not detected" => "Imagick 0 not detected",
"Batch loading directory" => "Directori per càrregues en bloc",
// "Needs to be a web-readable directory" => "Needs to be a web-readable directory",
"Display image information in a mouseover box" => "Mostra informació de la imatge en una caixa mouseover",
// "Yes, and don't display that information under the image" => "Yes, and don't display that information under the image",
"Parent" => "Pare",
"Uploaded image names must match regex" => "Els noms de les imatges penjades han de coincidir amb el regex",
"Uploaded image names cannot match regex" => "Els noms de les imatges penjades no han de coincidir amb el regex",
"Directory path" => "Ruta cap al directori",
// "If you change this directory, move any images to the new directory either manually or using the 'Mover' below" => "If you change this directory, move any images to the new directory either manually or using the 'Mover' below",
// "Image processing library" => "Image processing library",
// "Imagick" => "Imagick",
"Generate password" => "Generar contrasenya",
"Display a button on the registration form to automatically generate a very secure password for the user." => "Opció \"Generar contrasenya\" a la fitxa d'inscripció Inclogui",
// "The generated password may not include any restrictions (such as minimum/maximum length" => "The generated password may not include any restrictions (such as minimum/maximum length",
// "Maps & Location Enabled" => "Maps & Location Enabled",
// "Provide controls to load map and location libraries" => "Provide controls to load map and location libraries",
"Geolocate wiki pages" => "Geolocalitzar les pàgines wiki",
"Provide controls to indicate a geographic location of wiki pages in the edit form" => "Proporciona controls per geolocalitzar les pàgines del wiki des de la funcionalitat d'edició",
"Geolocate articles" => "Geolocalitzar articles",
"Provide controls to indicate a geographic location in the article edit form" => "Proporciona controls per geolocalitzar els articles des de la funcionalitat d'edició",
"Geolocate blog posts" => "Geolocalitzar entrades del bloc",
"Provide controls to indicate a geographic location in the blog post edit form" => "Proporciona controls per geolocalitzar les publicacions en bloc des de la funcionalitat d'edició",
"Available tile layers on maps" => "Capes de mosaic disponibles en els mapes",
"Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing" => "Permet canviar les teules d'OpenStreetMap per omissió per les rajoles d'altres serveis de mapes, com Google o Bing",
// "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1" => "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1",
"Google Street View" => "Google Street View",
"Open Google Street View in a new window to see the visible coordinates" => "Obre Google Street View a una finestra per veure les coordenades visible",
// "Google Street View overlay" => "Google Street View overlay",
"This is not guaranteed to work" => "No es garanteix que funcioni",
"Always load OpenLayers" => "Carregueu sempre OpenLayers",
"Load the OpenLayers library even if no map is explicitly included in the page" => "Carregar la llibreria OpenLayers fins i tot si cap mapa s'inclou explícitament en la pàgina",
// "Zoom level for the found location" => "Zoom level for the found location",
// "Zoom level when a searched-for location is found" => "Zoom level when a searched-for location is found",
// "Street" => "Street",
// "Town" => "Town",
// "Region" => "Region",
// "Continent" => "Continent",
// "OpenLayers version" => "OpenLayers version",
// "OpenLayers 2.x (for use up to at least 15.x)" => "OpenLayers 2.x (for use up to at least 15.x)",
// "OpenLayers 3+ (experimental)" => "OpenLayers 3+ (experimental)",
// "Bing Maps API Key" => "Bing Maps API Key",
// "Needed for Bing Map Layers" => "Needed for Bing Map Layers",
// "Nextzen Maps API Key" => "Nextzen Maps API Key",
// "Needed for Nextzen Map Layers" => "Needed for Nextzen Map Layers",
"Browser title" => "Títol (finestra del navegador)",
"Visible label in the browser's title bar on all pages. Also appears in search engine results" => "Etiqueta visible a la barra de títol del navegador a totes les pàgines. També apareix en els motors de cerca",
// "Fallback for tiki base URL" => "Fallback for tiki base URL",
// "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line" => "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line",
"Validate new user registrations by email" => "Validar registre de nous usuaris per correu electrònic",
// "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses" => "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses",
"Wiki homepage" => "Inici Wiki",
"The default home page of the wiki when no other page is specified. The page will be created if it does not already exist" => "La pàgina de destinació utilitza per a la wiki quan s'especifica cap pàgina. La pàgina es crearà si no existeix",
"Use group homepages" => "Empra pàgines d'inici de grup",
"Users can be directed to different pages upon logging in, depending on their default group" => "Els usuaris poden ser enviats a diferents pàgines després d'iniciar sessió, depenent del seu grup per omissió",
"Go to the group homepage only if logging in from the default homepage" => "Ves a la pàgina de grup només si la connexió es fa des de la pàgina inicial per defecte",
"Cache external pages" => "Memòria cau de pàgines externes",
"Cache external images" => "Memòria cau d'imatges externes",
"Temporary directory" => "Directori temporal",
"Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory" => "Tiki requereix accés total de lectura i escriptura a aquest directori",
"Help URL" => "URL d'Ajuda",
"The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki" => "El sistema d'ajuda per omissió pot no ser complet. Tu també pots ajudar amb la documentació de Tiki",
"Open external links in new window" => "Obrir enllaços externs en una finestra nova",
// "Open links to external sites in a new browser tab or window" => "Open links to external sites in a new browser tab or window",
// "Allow image lazy loading" => "Allow image lazy loading",
// "Allow that images are loaded in a lazy way" => "Allow that images are loaded in a lazy way",
"License page" => "Pàgina License",
// "The wiki page where the license information is written" => "The wiki page where the license information is written",
"Submit notice" => "Enviar notar",
// "Text to appear when content is being submitted" => "Text to appear when content is being submitted",
"Full path to gdaltindex" => "Ruta sencera al gdaltindex",
"Full path to ogr2ogr" => "Camí complet a ogr2ogr",
"Map Zone" => "Zona del Mapa",
"Always display modules to all groups" => "Mostra sempre els mòduls a tots els grups",
// "Any setting for the Groups parameter will be ignored and the module will be displayed to all users" => "Any setting for the Groups parameter will be ignored and the module will be displayed to all users",
"Hide anonymous-only modules from registered users" => "Amaga els mòduls per a anònims dels usuaris registrats",
// "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module" => "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module",
"Hide anonymous-only modules from Admins" => "Amaga anònim de només mòduls d'Administradors",
"Maximum number of articles on the articles homepage" => "El nombre màxim d'articles a la pàgina principal d'articles",
// "The number of articles to show on each page of the Articles homepage" => "The number of articles to show on each page of the Articles homepage",
"articles" => "articles",
"Site Ads and Banners Content" => "Anuncis del Lloc i Banners contingut",
"Test" => "Test",
"URL to go to when clicking on a username" => "URL per anar a en fer clic a un nom d'usuari",
"Default" => "Per omissió",
"Use %user% for login name and %userId% for userId)" => "Utilitza %user% per al nom d'usuari i %userId% per al userId)",
"Forgot password" => "Contrasenya oblidada",
"Users can request a password reset. They will receive a link by email" => "Els usuaris poden sol·licitar que es restableixi la contrasenya. Ells rebran un enllaç per correu electrònic",
"Group theme" => "Tema (d'estètica) per al Grup",
"Enable groups to each have their own visual theme." => "Cada grup pot tenir el seu tema",
// "The displayed title of the website" => "The displayed title of the website",
"Subtitle" => "Subtítol",
// "A short phrase that, for example, describes the site" => "A short phrase that, for example, describes the site",
"Maximum number of records in listings" => "Quantitat màxima de registres en llistats",
// "records" => "records",
"Maximum number of versions" => "Capacitat màxima de versions",
// "versions" => "versions",
"Users can register" => "Els usuaris es poden registrar",
"Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page." => "autoritzi el registre de l'usuari",
// "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option" => "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option",
// "Yes, with \"deep MX\" search" => "Yes, with \"deep MX\" search",
"Require validation by Admin" => "Requereix validació per Admin",
"The administrator will receive an email for each new user registration, and must validate the user before the user can log in" => "L'administrador rebrà un correu electrònic per a cada registre de nous usuaris, i ha de validar l'usuari abans que l'usuari pot accedir",
"Require passcode to register" => "Cal codi d'accés (paraula clau) per a registrar-se",
"Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users" => "Els usuaris han d'introduir un codi d'accés per a registrar-se. Has d'informar als usuaris d'aquest codi. S'utilitza per a restringir el registre només a usuaris convidats",
"Passcode" => "Codi d'accés",
"Alphanumeric code required to complete the registration" => "Codi alfanumèric necessari per completar el registre",
"Show passcode on registration form" => "Mostra el codi d'accés al formulari d'inscripció",
// "Registration page key" => "Registration page key",
// "Key required to be on included the URL to access the registration page (if not empty)" => "Key required to be on included the URL to access the registration page (if not empty)",
// "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue" => "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue",
"Use a tracker to collect more user information" => "Utilitza un formulari-bd per recopilar més informació dels usuaris",
"Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user" => "Mostra un formulari-bd perquè el completi l'usuari, com a part del procés de registre. Utilitza aquest formulari-bd per emmagatzemar informació addicional sobre cada usuari",
"Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display" => "Utilitza la pàgina \"Admin Grups\" per a seleccionar el formulari-bd i els camps que s'han de mostrar",
"Use tracker to collect more group information" => "Utilitza un formulari-bd per recopilar més informació sobre els grups",
"Create a new group for each user" => "Crear un nou grup per a cada usuari",
// "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level" => "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level",
"Synchronize Tiki groups with a directory" => "Sincronitzar els grups de Tiki amb un directori",
"Define the directory within the \"LDAP\" tab" => "Definir el directori dins la pestanya \"LDAP \"",
"Synchronize Tiki users with a directory" => "Sincronitzar els usuaris de Tiki amb un directori",
"Remember me" => "Recorda'm",
"Duration" => "Durada",
// "The length of time before the user will need to log in again" => "The length of time before the user will need to log in again",
"day" => "dia",
"week" => "setmana",
"month" => "mes",
"year" => "any",
// "Homepage Browser title" => "Homepage Browser title",
// "Customize Browser title for the custom homepage" => "Customize Browser title for the custom homepage",
"Use custom homepage" => "Utilitza una pàgina principal personalitzada",
"Use the top page of a Tiki feature or another homepage" => "Utilitza una funció de Tiki com a pàgina inicial o una altra pàgina d'inici",
// "This option will override the Use Tiki feature as homepage setting" => "This option will override the Use Tiki feature as homepage setting",
"Use the top page of a Tiki feature as the homepage" => "Utilitza una funció de Tiki com a pàgina d'inici",
"Select the Tiki feature to provide the site homepage. Only enabled features are listed" => "Seleccioneu la funció Tiki utilitzar com a pàgina principal del lloc. Característiques només es troben habilitades",
"Disable JavaScript" => "Desactivar JavaScript",
"Disable JavaScript for the purpose of testing even if enabled in the browser" => "Desactivar JavaScript per al propòsit de prova, fins i tot si el navegador ho permet",
// "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly" => "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly",
// "Maximum rows per page" => "Maximum rows per page",
"Images per row" => "Imatges per fila",
// "images" => "images",
// "Thumbnail width" => "Thumbnail width",
// "Thumbnail height" => "Thumbnail height",
// "Default scale size" => "Default scale size",
"Set blogs homepage first" => "Establir pàgina d'inici blocs primer",
"Set Image gal homepage first" => "Establir Image pàgina gal primer",
"Set Forum homepage first" => "Establir pàgina d'inici Fòrum primer",
"Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Atès que les contrasenyes estan encriptades, no és possible indicar a l'usuari quina és la contrasenya. Només és possible canviar",
"Validate user's email server" => "Validar servidor de correu electrònic de l'usuari",
"Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Mostra el codi d'accés requerit en el formulari de registre. Això és útil per als usuaris legítims que volen inscriure en fer que sigui difícil per als robots automatitzats perquè el codi és únic per a cada lloc i ja que es mostra en JavaScript",
"The group name will be the same as the user's username" => "El grup es dirà idèntic al nom d'usuari de l'usuari",
// "After logging in, users will automatically be logged in again when they leave and return to the site" => "After logging in, users will automatically be logged in again when they leave and return to the site",
"User's choice" => "Elecció de l'usuari",
"Google Maps API Key" => "Google Maps API Clau",
// "Needed for Street View or other advanced features" => "Needed for Street View or other advanced features",
"Default x for map center" => "Coordenada x per defecte per al centre del mapa",
"Default y for map center" => "Per omissió y per al centrat del mapa",
"Default zoom level" => "Nivell de zoom per defecte",
"whole earth" => "tota la Terra",
"country size" => "mida de país",
"city size" => "mida de ciutat",
"max zoom" => "zoom màxim",
"Show map mode buttons in articles list" => "Mostra mapa botons de manera en la llista d'articles",
"Show map mode buttons in page list" => "Mostra mapa botons de manera en la llista de la pàgina",
// "Goal, recognition and rewards" => "Goal, recognition and rewards",
"A tool to set motivational goals to increase engagement on the site" => "Una eina per a fixar objectius de motivació de cara a augmentar el compromís amb el lloc",
// "Reward badge tracker" => "Reward badge tracker",
"Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user" => "ID de Formulari-bd que conté la llista de divises a ser recompensades en acabar l'objectiu. Cada divisa només pot ser recompensada un cop per a cada usuari",
"0 to disable" => "0 per deshabilitar",
"Groups not eligible for goals" => "Grups no elegibles per als objectius",
"Groups that will not be on the eligible group list" => "Llista de grups de sistema que seran eliminats de la llista de grups potencialment elegibles",
// "H5P support" => "H5P support",
// "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content" => "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content",
// "Whitelist" => "Whitelist",
// "Allowed filetypes" => "Allowed filetypes",
// "H5P Tracker User" => "H5P Tracker User",
// "Store H5P results" => "Store H5P results",
// "H5P Developer Mode" => "H5P Developer Mode",
// "Use \"patched\" libraries" => "Use \"patched\" libraries",
// "Default Gallery" => "Default Gallery",
// "File gallery to create new H5P content in by default" => "File gallery to create new H5P content in by default",
// "Store user state" => "Store user state",
// "Allows users to resume at the point they last got to" => "Allows users to resume at the point they last got to",
// "Save Frequency" => "Save Frequency",
// "How often to update user data" => "How often to update user data",
// "Allows users to export H5P content" => "Allows users to export H5P content",
// "Hub Is Enabled" => "Hub Is Enabled",
// "Updates libraries from h5p.org" => "Updates libraries from h5p.org",
// "Site Key" => "Site Key",
// "H5P Site Key" => "H5P Site Key",
// "H5P UUID" => "H5P UUID",
// "H5P Unique ID" => "H5P Unique ID",
// "Content Type Updated" => "Content Type Updated",
"Last update" => "Última actualització",
// "Check Requirements" => "Check Requirements",
// "Unused so far" => "Unused so far",
// "Send Usage Statistics" => "Send Usage Statistics",
// "Request User Consent" => "Request User Consent",
// "LRS Content Types" => "LRS Content Types",
// "Reporting (?)" => "Reporting (?)",
"HHeader shadow div start" => "Capçalera inici ombra",
"Header shadow div end" => "Finals ombra Capçalera",
"Custom CSS" => "CSS Personalitzat",
// "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n" => "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n",
"Custom JavaScript" => "JavaScript adaptat",
"Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages" => "Inclou un bloc personalitzat de JavaScript en línia a totes les pàgines",
// "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page" => "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page",
"Do not include the < script > tags" => "No incloguis les etiquetes <script> i </script>",
// "Custom Less" => "Custom Less",
// "Compiles a new version of the currently selected theme and option using definitions declared here" => "Compiles a new version of the currently selected theme and option using definitions declared here",
// "Custom Less (CSS precompiler) - no longer used" => "Custom Less (CSS precompiler) - no longer used",
// "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon.." => "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon..",
"Highlight group" => "Assenyaleu grup",
"Home blog (main blog)" => "Bloc Inicial (principal)",
"Home forum (main forum)" => "Fòrum Inicial (principal)",
"Home file gallery (main file gallery)" => "Galeria d'arxius Inicial (galeria d'arxius principal)",
// "Select the default file gallery" => "Select the default file gallery",
"Home gallery (main gallery)" => "Galeria principal",
"No image gallery available (create one first)" => "No hi ha cap galeria d'imatges disponible (crea'n una primer)",
"No file gallery available (create one first)" => "No hi ha cap galeria d'arxius disponible (crea'n una primer)",
"No blog available (create one first)" => "No hi ha cap bloc disponible (crear'n un primer)",
"HTTP port" => "Port HTTP",
"The port used to access this server; if not specified, port 80 will be used" => "el port utilitzat per accedir a aquest servidor, si es deixa buit s'usarà el port 80",
"If not specified, port 80 will be used" => "Si es deixa buit, el port 80 s'utilitza",
"HTTP lookup: skip framesets" => "HTTP cerca Omet conjunts de marcs",
"When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "En realitzar la petició HTTP i a una font externa, verificar si el resultat és un conjunt de marcs i l'ús d'heurística per proporcionar el contingut real",
"Registration referrer check" => "Registre referrer verificació",
"Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Utilitza la referència HTTP per comprovar PAL registre s'envia des de la mateixa acollida. (Es pot no funcionar en algunes configuracions).",
// "HTTP header x-frame options" => "HTTP header x-frame options",
// "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt" => "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt",
// "Header value" => "Header value",
// "DENY" => "DENY",
// "SAMEORIGIN" => "SAMEORIGIN",
// "HTTP header x-xss-protection" => "HTTP header x-xss-protection",
// "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers" => "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers",
"0" => "0",
// "1;mode=block" => "1;mode=block",
// "HTTP header x-content-type-options" => "HTTP header x-content-type-options",
// "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed" => "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed",
// "HTTP header content-security-policy" => "HTTP header content-security-policy",
// "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page" => "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page",
// "HTTP header strict-transport-security" => "HTTP header strict-transport-security",
// "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP" => "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP",
// "HTTP header public-key-pins" => "HTTP header public-key-pins",
// "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it" => "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it",
"HTTPS for user-specific links" => "Utilitza HTTPS en la construcció de vincles específics de l'usuari",
// "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "Port HTTPS",
"the HTTPS port for this server" => "el port HTTPS per a aquest servidor, per omissió = 443",
"Use HTTPS login" => "Utilitza HTTPS sessió",
"Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Augmentar la seguretat en permetre transmetre les credencials d'autenticació a través de SSL. Els certificats s'han de configurar al servidor",
"Allow secure (HTTPS) login" => "Permet connexió segura (https)",
"Encourage secure (HTTPS) login" => "Anima a emprar connexió segura (https)",
"Consider we are always in HTTPS, but do not check" => "Considera que som sempre en HTTPS, però no comprovis",
"Require secure (HTTPS) login" => "Requereix connexió segura (https)",
"Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible" => "No requereix HTTPS fins que tingui marxa i ha comprovat la connexió, en cas contrari, farà que tot el teu lloc inaccessible",
// "Enable intrusion detection system" => "Enable intrusion detection system",
// "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations" => "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations",
// "Intrusion detection system mode" => "Intrusion detection system mode",
// "Define IDS operation mode, log only, or log and block with impact over a given threshold" => "Define IDS operation mode, log only, or log and block with impact over a given threshold",
// "Log only" => "Log only",
// "Log and block requests" => "Log and block requests",
// "Intrusion detection system threshold" => "Intrusion detection system threshold",
// "Define IDS threshold, when configured in \"Log and block requests\" more" => "Define IDS threshold, when configured in \"Log and block requests\" more",
// "Custom rules file" => "Custom rules file",
// "Log to file" => "Log to file",
// "Log to database" => "Log to database",
// "Default for img-fluid class used in the IMG plugin" => "Default for img-fluid class used in the IMG plugin",
// "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden" => "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden",
// "Errors log file" => "Errors log file",
// "location, from your tiki root dir, where you want the error log file stored" => "location, from your tiki root dir, where you want the error log file stored",
// "Access log file" => "Access log file",
// "location, from your tiki root dir, where you want the access log file stored" => "location, from your tiki root dir, where you want the access log file stored",
"IP can be checked" => "Es pot comprovar la IP",
"Check anonymous votes by user's IP" => "Comprova els vots anònims per la IP de l'usuari",
"Use CDN for JavaScript" => "Utilitza CDN JavaScript",
"Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)" => "Obtenir les biblioteques d'interfície d'usuari jQuery i jQuery través d'una xarxa de distribució de continguts",
// "Google" => "Google",
"jQuery" => "jQuery",
// "Assume JavaScript is enabled even if not supported" => "Assume JavaScript is enabled even if not supported",
// "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter" => "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter",
"Slide" => "Llisca",
"Fade" => "Esvaeix",
"Blind (UI)" => "Blind (UI)",
"Clip (UI)" => "Clip (UI)",
"Drop (UI)" => "Drop (UI)",
"Explode (UI)" => "Explotar (UI)",
"Fold (UI)" => "Fold (UI)",
"Puff (UI)" => "Puff (UI)",
"Slide (UI)" => "Slide (UI)",
"Effect for modules" => "Efecte dels mòduls",
"Effect for tabs" => "Efecte de pestanyes",
"Speed" => "Velocitat",
"Fast" => "Ràpid",
"Normal" => "Normal",
"Slow" => "Poc a poc",
"Direction" => "Direcció",
"Vertical" => "Vertical",
"Horizontal" => "Horitzontal",
"Left" => "Cap a l'esquerra",
"Right" => "Cap a la dreta",
"Up" => "Cap a dalt",
"Down" => "Cap avall",
"jQuery-UI Chosen Select Boxes" => "Menús Chosen de jQuery - ui",
"Styled replacement for dropdown select lists and multiple-select inputs" => "Reemplaçament estilitzat per als menús desplegables i entrades de selecció múltiple",
// "Sortable Chosen Multi-selects" => "Sortable Chosen Multi-selects",
// "Enable drag and drop re-ordering of Chosen multi-select options" => "Enable drag and drop re-ordering of Chosen multi-select options",
"Visual style of Colorbox (a.k.a. \"Shadowbox\")" => "CSS per utilitzar en Colorbox (àlies \"Shadowbox\")",
"One" => "Un",
"Two" => "Dues",
"Three" => "Tres",
"Four" => "Quatre",
"Five" => "Cinc",
// "FitVids.js" => "FitVids.js",
// "jQuery plugin for fluid-width (responsive) embedded videos" => "jQuery plugin for fluid-width (responsive) embedded videos",
// "jQuery Timeago" => "jQuery Timeago",
// "jQuery plugin for fuzzy timestamps" => "jQuery plugin for fuzzy timestamps",
// "SmartMenus" => "SmartMenus",
// "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more" => "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more",
// "SmartMenus Mode" => "SmartMenus Mode",
"Blue" => "Blau",
"Clean" => "Neteja",
// "Mint" => "Mint",
"Simple" => "Simple",
// "Draggable Modals" => "Draggable Modals",
// "Modal popups can be moved around" => "Modal popups can be moved around",
// "Resizable Modals" => "Resizable Modals",
// "Modal popups can be resized" => "Modal popups can be resized",
// "jQuery Double Scroll" => "jQuery Double Scroll",
// "jQuery plugin which adds an extra horizontal scroll bar at the top" => "jQuery plugin which adds an extra horizontal scroll bar at the top",
"Partner ID" => "ID de soci",
"Kaltura Partner ID" => "Kaltura Soci ID",
"User secret" => "Secreta de l'usuari",
"Kaltura partner-setting user secret" => "Secret d'usuari entorn soci Kaltura",
"Admin secret" => "Secret administració",
"Kaltura partner-setting admin secret" => "Secret administrador entorn soci Kaltura",
// "Kaltura video player ID" => "Kaltura video player ID",
"Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura dinàmic Player (KDP) interfície d'usuari ID de configuració",
// "Kaltura video player ID (in entry edit mode)" => "Kaltura video player ID (in entry edit mode)",
"Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail" => "Kaltura dinàmic Player (KDP) ID de configuració d'interfície d'usuari per al seu ús durant l'edició. Pots utilitzar un reproductor que també té l'opció de seleccionar un marc com a miniatura de vídeo",
// "KCW UI configuration ID" => "KCW UI configuration ID",
"Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Auxiliar de configuració dels Kaltura (KCW) interfície d'usuari ID de configuració",
// "Kaltura service URL" => "Kaltura service URL",
// "for example, https://www.kaltura.com/" => "for example, https://www.kaltura.com/",
"Show remixes from old versions of Kaltura" => "Mostra remixes de les versions antigues de Kaltura",
"Show remixes from old versions of Kaltura (remixing is no longer supported)" => "Mostra remixes de les versions antigues de Kaltura (remescla ja no és compatible)",
"Keep versions for" => "Mantenir versions de",
"Do not delete versions younger than this number of days" => "Mai elimini les versions menors de (?dies), per omissió=1",
"Use database for translation" => "Empra base de dades per a la traducció",
"Use the database to store the translated strings and allow using interactive translation" => "Utilitza la base de dades per emmagatzemar les cadenes traduïdes i permetre l'ús de traducció interactiva",
// "Edit, export and import languages" => "Edit, export and import languages",
// "Manage contribution of translated strings" => "Manage contribution of translated strings",
// "Offers to set whether each translated string should be contributed to the Tiki community or kept locally" => "Offers to set whether each translated string should be contributed to the Tiki community or kept locally",
"Machine translation implementation" => "Aplicació traducció automàtica",
"Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required" => "Tria entre impementations alternatius per a la traducció automàtica. Depenent de la implementació, diferents claus API poden ser necessaris",
"Google Translate" => "Traductor Google",
"Bing Translate" => "Bing Traduir",
"Enable machine translation of wiki pages" => "Habilitar la traducció automàtica de pàgines wiki",
"Makes additional languages available to the list of languages on the page" => "Fa més idiomes disponibles a la llista d'idiomes en la pàgina",
"Google Translate API Key" => "Traductor Google API Clau",
"The key must be generated from the Google console. Choose to create a server key" => "La clau ha de ser generat des de la consola de google. Trieu crear una clau de servidor",
"Bing Translate Client ID" => "Bing Translate Client ID",
"The application must be registered" => "La sol·licitud ha de ser registrat",
"Bing Translate Client Secret" => "Bing Translate Client Secret",
// "Display available translations as dropdown" => "Display available translations as dropdown",
// "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list" => "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list",
"Default language" => "Idioma per omissió",
"The site language is used when no other language is specified by the user" => "Idioma del lloc s'utilitza quan no hi ha un altre idioma està especificat per l'usuari",
// "Default admin language" => "Default admin language",
// "The site language is used in admin section when no other language is specified by the user" => "The site language is used in admin section when no other language is specified by the user",
"Language inclusion threshold" => "Llindar d'inclusió Idioma",
"When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "Quan el nombre d'idiomes està restringit en el lloc, i està per sota d'aquest nombre, s'afegiran tots els idiomes de la llista d'idiomes preferits, encara que no especificada per l'usuari. No obstant això, es donarà prioritat als idiomes especificats",
// "languages" => "languages",
"Layout width" => "Amplada de la pantalla",
"The width of the content area of the site, centered in the browser window" => "Restringeix l'ample de la pantalla del lloc (per omissió: 990px)",
"for example, 960px" => "per exemple:. 800px",
"Tabs optional" => "Tabs opcional",
"Users can choose not to have tabs. A <b>no tabs</b> button will be displayed" => "Els usuaris poden triar no tenir pestanyes",
"Add group CSS info" => "Afegir grup CSS info",
"Add CSS classes to the page BODY tag based on the user's group membership" => "Afegir classes a la pàgina etiqueta BODY per indicar la pertinença al grup",
"Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Qualsevol de grp_Admins grp_Anonymous o grp_Registered i possiblement així",
// "If this option is disabled, this user wouldn’t be able to log in" => "If this option is disabled, this user wouldn’t be able to log in",
"Create the user" => "Creu l'usuari",
"Deny access" => "Denegar l'accés",
"Create user if not in LDAP" => "Crear usuari si no en LDAP",
// "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user" => "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user",
// "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”" => "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”",
"Maximum average server load threshold in the last minute" => "Llindar de càrrega del servidor mitjana màxima en l'últim minut",
// "Lock Content Templates" => "Lock Content Templates",
// "Enable users to lock content templates and so prevent others from editing them" => "Enable users to lock content templates and so prevent others from editing them",
// "Lock Wiki Structures" => "Lock Wiki Structures",
// "Enable users to lock wiki structures and so prevent others from editing them" => "Enable users to lock wiki structures and so prevent others from editing them",
"Log mail in Tiki logs" => "Registra el correu-e en els registres de Tiki (logs)",
"A line of type mail will be included in the System Log with the destination address and subject of each email sent" => "Registra el correu-e en els registres de Tiki (logs)",
"Smarty template usage indicator" => "Indicador d'ús de Plantilles Smarty",
"Add HTML comment at start and end of each Smarty template (.tpl file)" => "Afegeix comentaris HTML a l'inici i final de cada plantilla Smarty (TPL)",
"Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source." => "Utilitza únicament per al desenvolupament, no en la producció a causa que aquestes advertències se sumen als correus electrònics, així, i visible als usuaris",
"You need to clear your Tiki template cache for this change to take effect" => "Cal esborrar la memòria cau de plantilla Tiki perquè aquest canvi tingui efecte",
"Log SQL" => "Inicia SQL",
"All SQL queries will be registered in the database in the adodb_logsql table. " => "Entrada consultes SQL",
// "Do not enable this feature all the time. It can be very resource intensive and will impact performance" => "Do not enable this feature all the time. It can be very resource intensive and will impact performance",
"Log queries using more than" => "Consultes de registre que utilitzen més d'(segons)",
"Use to log only queries that exceed a specific amount of time" => "Això pot afectar al rendiment",
"Use email as username" => "Utilitza el correu electrònic com a nom d'usuari",
"Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field" => "En lloc de crear nous noms d'usuari, utilitzeu l'adreça de correu electrònic de l'usuari per a l'autenticació",
"Obscure email when using email as username" => "Fes obscur el correu-e quan s'empri el correu-e com a nom d'usuari, si és possible (la cobertura no serà completa)",
// "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead" => "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead",
// "Coverage will not be complete" => "Coverage will not be complete",
// "User can login via username or email" => "User can login via username or email",
// "This will allow users to login using their email (as well as their username)" => "This will allow users to login using their email (as well as their username)",
// "Auto-generate 6-digit username on registration" => "Auto-generate 6-digit username on registration",
// "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)" => "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)",
"HTTP Basic Authentication" => "HTTP Basic Authentication",
"Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials" => "Comprovi les credencials d'autenticació bàsica HTTP, útil per permetre serveis web per utilitzar les credencials",
"SSL Only (Recommended)" => "Només SSL (recomanat)",
"Prevent multiple log-ins by the same user" => "Prevenir múltiples inicis de sessió del mateix usuari",
"Users (other than admin) cannot log in simultaneously with multiple browsers" => "L'usuari no pot accedir simultàniament des de diversos navegadors. Compte d'administrador encara es permet",
// "Grab session if already logged in" => "Grab session if already logged in",
// "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out" => "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out",
// "Enable autologin from remote Tiki" => "Enable autologin from remote Tiki",
// "Used with autologin_remotetiki in the redirect plugin" => "Used with autologin_remotetiki in the redirect plugin",
// "System username to use to initiate autologin from remote Tiki" => "System username to use to initiate autologin from remote Tiki",
// "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin" => "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin",
// "System groupname to use for auto login token" => "System groupname to use for auto login token",
// "For security, please create a group that has no users and no permissions and specify its name here" => "For security, please create a group that has no users and no permissions and specify its name here",
// "Create a new user account if the user that is trying to autologin does not exist on this Tiki" => "Create a new user account if the user that is trying to autologin does not exist on this Tiki",
// "Allowed groups from remote Tiki to autologin" => "Allowed groups from remote Tiki to autologin",
// "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone" => "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone",
// "Sync these groups from remote Tiki on autologin" => "Sync these groups from remote Tiki on autologin",
// "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly" => "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly",
// "Automatically logout remote Tiki after logout" => "Automatically logout remote Tiki after logout",
// "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well" => "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well",
// "Redirect direct logins to this site to remote Tiki" => "Redirect direct logins to this site to remote Tiki",
// "URL of autologin page on remote Tiki to redirect user to login" => "URL of autologin page on remote Tiki to redirect user to login",
// "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin" => "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin",
"Long date format" => "Format llarg de data",
// "Specify how Tiki displays the date (longer version)" => "Specify how Tiki displays the date (longer version)",
"Long time format" => "Format llarg d'hora",
// "Specify how Tiki displays the time (longer version)" => "Specify how Tiki displays the time (longer version)",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
"Force lowercase" => "Forçar minúscules",
// "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>" => "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>",
// "Email newline character(s)" => "Email newline character(s)",
// "End-of-line (EOL) character used in outgoing emails" => "End-of-line (EOL) character used in outgoing emails",
"CRLF (standard)" => "CRLF (estàndard)",
"LF (some Unix MTA)" => "LF (alguns MTA Unix)",
// "Text string used to customise mail templates" => "Text string used to customise mail templates",
// "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files" => "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files",
"Main shadow start" => "Inici ombra principal",
"Main shadow end" => "Fi principal ombra",
"Maximum length" => "Longitud màxima",
// "The greatest number of characters for a valid username" => "The greatest number of characters for a valid username",
"Memcache" => "Memcache",
"Enable connection to memcached servers to store temporary information" => "Activar la connexió a servidors memcached per emmagatzemar informació temporal",
"Requires the PHP memcache extension" => "Requereix l'extensió PHP Memcache",
"Memcache servers" => "Servidors Memcache",
"Server list which may be accessed. For each server, the address, port and weight must be specified" => "Llista de servidors que es pot accedir. Per a cada servidor, l'adreça, el port i el pes han de ser especificats",
"One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"" => "Un per línia. adreça: port (pes) per exemple, \"Localhost: 11211 (1)\"",
"Memcache key prefix" => "Prefix clau Memcache",
"When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts" => "Quan el grup Memcache és utilitzada per diverses aplicacions, l'ús de prefixos únics per a cada un d'ells ajuda a evitar conflictes",
"Memcache expiration" => "Venciment Memcache",
"Duration for which the data will be kept" => "Temps durant el qual es conservaran les dades",
"Cache wiki data in memcache" => "Dades wiki cau Memcache",
"Cache wiki output in memcache" => "Sortida wiki cau Memcache",
"Cache forum output in memcache" => "Sortida fòrum memòria cau en Memcache",
"Menu icons" => "Icones de menú",
// "Allows icons to be defined for menu entries" => "Allows icons to be defined for menu entries",
"Default path for the icons" => "Ruta per omissió per a les icones",
// "Edit menu icon" => "Edit menu icon",
// "Adds an icon on the navbar to edit menu entries" => "Adds an icon on the navbar to edit menu entries",
// "Maximum mailbox size" => "Maximum mailbox size",
// "Maximum number of messages allowed in the mailbox" => "Maximum number of messages allowed in the mailbox",
"messages" => "missatges",
// "Maximum mail archive size" => "Maximum mail archive size",
// "Maximum number of archive messages allowed" => "Maximum number of archive messages allowed",
// "Maximum sent box size" => "Maximum sent box size",
// "Maximum number of sent messages allowed in the mailbox" => "Maximum number of sent messages allowed in the mailbox",
// "Truncate internal message notification" => "Truncate internal message notification",
// "Number of characters to show in the message notification sent through email, with a link to read the full internal message" => "Number of characters to show in the message notification sent through email, with a link to read the full internal message",
"Keywords" => "Paraules clau",
"A list of keywords (separated by commas) that describe this website" => "Una llista de paraules clau (separats per comes) que descriuen el seu lloc",
"Include tags" => "Inclou marques lliures",
"If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags" => "Si la funció de marques lliures és activada, utilitzeu les marques lliures en les paraules clau meta per a cada pàgina amb marques lliures especificades. Això permet que les pàgines individuals del lloc puguin portar diferents Meta tags",
"Use thread title instead" => "Utilitza fil títol en lloc",
"Use the forum thread title in the meta title tag" => "Utilitza el títol del fil de debat del fòrum en l'etiqueta del títol meta",
"Use the image title instead" => "Utilitza el títol de la imatge en el seu lloc",
"Use the image title in the meta title tag" => "Utilitza el títol de la imatge, en l'etiqueta del títol meta",
"A short description of the website. Some search engines display this information with the website's listing" => "Una breu descripció del seu lloc. Alguns motors de cerca mostren aquesta informació amb el llistat del seu lloc",
"Page description" => "Descripció de la pàgina",
"Use each page description as a meta tag for that page" => "Utilitza descripció individual pàgina com una etiqueta meta per a la pàgina",
"Author" => "Autor",
"The author of this website. Typically this is the Admin or Webmaster" => "L'autor del seu lloc. Normalment aquest serà l'administrador o Webmaster",
"geo.position" => "geo.posició",
"The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "La latitud i la longitud de la ubicació física del lloc. Per exemple \"38.898748, -77.037684 \"",
"geo.region" => "geo.regió",
"The ISO-3166 country and region codes for your location. For example, \"US-NY\"" => "El ISO-3166 país i de regió de la seva ubicació. Per exemple, \"US-NY \"",
"geo.placename" => "geo.nomdellloc",
"A free-text description of your location" => "Una descripció de text lliure de la seva ubicació",
"Meta robots" => "Robots Meta",
// "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca" => "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca",
// "Should be comma separated eg. noimageindex, nocache" => "Should be comma separated eg. noimageindex, nocache",
"Revisit after" => "Torna després de",
// "Specify how often (in days) Web robots should visit your site" => "Specify how often (in days) Web robots should visit your site",
"Middle shadow div start" => "Medi ombra inici",
"Middle shadow div end" => "Finals ombra Medi",
"Minimum length" => "La longitud mínima",
// "The least possible number of characters for a valid username" => "The least possible number of characters for a valid username",
// "The least possible number of characters for a valid password" => "The least possible number of characters for a valid password",
"Mobile access" => "Mobile access",
// "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)" => "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)",
// "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)" => "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)",
"Mobile Perspectives" => "Perspectives Mòbils",
"Top module zone" => "Zona del mòduls de dalt de tot (Top)",
// "Activate zone for modules such as site logo, log-in form, etc. (page header)" => "Activate zone for modules such as site logo, log-in form, etc. (page header)",
"Topbar module zone" => "Zona del mòdul per sobre de la barra (Topbar)",
// "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc" => "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc",
"topbar" => "barra de dalt",
"Page top module zone" => "Zona de mòduls de sobre les pàgines (Page top)",
// "Activate zone for modules such as breadcrumbs, banners, share icons, etc" => "Activate zone for modules such as breadcrumbs, banners, share icons, etc",
"Bottom module zone" => "Zona del mòdul inferior",
// "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)" => "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)",
"Page bottom module zone" => "Zona de mòduls d'abaix",
// "Activate zone for modules at the bottom of the main column of each page" => "Activate zone for modules at the bottom of the main column of each page",
"Module file" => "Arxiu de mòdul",
"Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles" => "Utilitza un arxiu de definició de mòdul estàtic en lloc de dependre dels valors dinàmics generats per Tiki. Útil per als temes personalitzats. L'arxiu ha d'estar en format YAML, seguint el format utilitzat en els perfils",
"Extra module zones available" => "Zones addicionals disponibles de mòduls",
"Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones" => "Zones addicionals de mòduls per a ser manejades a través de la interfície d'administració del mòdul. Útil si el seu tema personalitzat requereix una zona especial que no siguin les predefinides",
"Comma-separated list, maximum of 20 characters per entry" => "Llista separada per comes, 20 caràcters màxim per entrada",
"Allow users to control the notifications they receive based on content changes" => "Permet als usuaris controlar les notificacions que reben basades en canvis de contingut",
// "Notification digests" => "Notification digests",
"Enable digest notifications (requires a cron job)" => "Habilita els resums de notificacions, requereix especificar un treball periòdic al servidor (cron job)",
"Clear individual notifications" => "Neteja les notificacions individuals",
// "Allow users to selectively clear notifications instead of simply having a clear-all button" => "Allow users to selectively clear notifications instead of simply having a clear-all button",
"Notification count refresh interval" => "Interval de refresc del recompte de notificacions",
"Show unread notification count and refresh every [x] seconds" => "Mostra el recompte de notificacions per llegir i refresca'l cada [x] segons",
"0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds" => "0 per deshabilitar-lo, cada refresc causa un impacte en el servidor, intenta deixar per sobre de 60 segons",
// "Notification reply-to email pattern" => "Notification reply-to email pattern",
"Email model to use for the notification email reply-to address" => "Model de correu-e a utilitzar per a la direcció de respondre-a (reply-to) del correu -e",
"noreply+PLACEHOLDER@example.com" => "noreply+PLACEHOLDER@exemple.com",
"\"More Like This\" algorithm" => "Algorisme \"Més com aquest\"",
// "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order" => "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order",
"Minimum number of tags in common" => "Nombre mínim d'etiquetes en comú",
// "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature" => "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature",
"Multi-domain" => "Multi-domini",
"Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation" => "Permet assignar noms de domini a les perspectives i simular múltiples dominis allotjats en la mateixa instància",
"Multi-domain Configuration" => "Configuració multi-domini",
"Comma-separated values mapping the domain name to the perspective ID" => "Valors separats per comes d'assignació del nom de domini amb l'ID perspectiva",
"One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1" => "Un domini per línia. Separats per comes amb l'ID perspectiva. Ex:. Tiki.org, 1",
"Switch domain when switching perspective" => "Canviar de domini quan es canvia la perspectiva",
"Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work" => "Recordeu que els diferents dominis tenen diferents sessions de connexió, i fins i tot en el cas dels subdominis es necessita tenir una comprensió de les galetes de sessió perquè funcioni",
// "Must read" => "Must read",
// "Allow assignment of mandatory readings and track progress" => "Allow assignment of mandatory readings and track progress",
// "Must read tracker" => "Must read tracker",
// "Tracker containing the individual read requests" => "Tracker containing the individual read requests",
"Namespace" => "Espai de noms",
"Enable namespaces feature for wiki pages" => "Habilitar espais de noms per a les pàgines wiki",
"Namespace separator" => "Separador de l'Espai de noms",
// "Select the character, symbol, or text to use as the namespace separator" => "Select the character, symbol, or text to use as the namespace separator",
"Default namespace" => "Espai de noms per omissió",
"Namespace to use when creating wiki pages. Should be defined within perspectives" => "Espai de noms a utilitzar en crear pàgines wiki. En cas de ser definida dins de les perspectives",
"Hide namespace indicator in structure path" => "Amagar l'indicador de l'espai de noms en la camí de l'estructura",
// "Hide namespace indicator in page title" => "Hide namespace indicator in page title",
// "Force all non-namespace page links to the same namespace" => "Force all non-namespace page links to the same namespace",
// "If the current page is in a namespace, all links without a namespace will have it added automatically" => "If the current page is in a namespace, all links without a namespace will have it added automatically",
"Throttle newsletter send rate" => "Dosifica la velocitat d'enviament de butlletins",
"Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pausa per a una determinada quantitat de segons abans de cada lot per evitar la sobrecàrrega del servidor de correu",
"Newsletter pause length" => "Durada de la pausa de l'enviament de Butlletins",
"Number of seconds delay before each batch" => "Quantitat de segon en espera abans de que cada lot",
"Newsletter batch size" => "Mida de lot de Butlletins",
// "Number of emails to send in each batch" => "Number of emails to send in each batch",
// "emails" => "emails",
"Allow sending newsletters through external clients" => "Permetre l'enviament de butlletins de notícies a través de clients externs",
"Generate mailto links using the recipients as the BCC list" => "Generar vincles mailto utilitzant els receptors que la llista BCC",
"This will expose the list if email addresses to all users allowed to send newsletters" => "Això exposarà la llista si les adreces de correu electrònic a tots els usuaris amb permís per enviar butlletins",
"Use relative (next / previous) pagination links" => "Empra enllaços relatius de paginació (següent / previ)",
// "Encryption key for OAuthServer" => "Encryption key for OAuthServer",
// "A key used to encrypt/decrypt authorization codes" => "A key used to encrypt/decrypt authorization codes",
"PGP/MIME encrypted email messaging" => "PGP / MIME missatges de correu electrònic xifrat",
"Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses" => "Utilitza OpenPGP PGP / MIME missatges de correu electrònic xifrat compatible (per omissió és 'n')",
"Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on" => "Habilitar només si gpg, clauer i tikiaccounts estan configurats correctament per PGP / MIME funcionalitat. NOTA: Es requereix que tots els comptes tenen les seves claus públiques configuren en gnupg-keyring, pel que no permeten registres no administred (o per exemple, missatges de correu electrònic no configurats per a butlletins, etc) en el lloc si aquesta funció activada",
"Path to gnupg keyring" => "Camí a GnuPG clauer",
"Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\" => "Ruta de directori completa a l'arxiu de claus GnuPG (per omissió /home/www/.gnupg/). El directori, subdirectoris relacionats (per exemple, un subdirectori 'signant\\",
"Path to gpg executable" => "Ruta al executable gpg",
"Full path to gpg executable" => "Ruta d'accés completa a l'executable gpg (per omissió / usr / bin / gpg)",
// "Read signer pass phrase from prefs or from a file" => "Read signer pass phrase from prefs or from a file",
// "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\" => "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\",
"preferences" => "preferències",
"file" => "arxiu",
// "Signer pass phrase" => "Signer pass phrase",
// "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file" => "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file",
// "leave empty if read from file" => "leave empty if read from file",
// "Path to signer pass phrase filename" => "Path to signer pass phrase filename",
// "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file" => "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file",
"Wiki buttons" => "Botons Wiki",
"Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)" => "Descripció de la pàgina, les icones, els enllaços d'entrada, ..",
"Top " => "Superior",
"Bottom" => "Fons",
"Neither" => "Ni",
"Pages can reoccur in structure" => "Les pàgines poden reaparèixer a l'estructura",
"A page can be listed multiple times in a structure" => "Una pàgina pot aparèixer diverses vegades en una estructura",
// "Fetch page content from incoming feeds" => "Fetch page content from incoming feeds",
// "Page content from the source will be fetched before sending the content to the generators" => "Page content from the source will be fetched before sending the content to the generators",
// "if set, will display 'first' and 'last' links on pages" => "if set, will display 'first' and 'last' links on pages",
"Display \"fast-forward\" links" => "Mostra vincles moviments ràpids",
"Display \"fast-forward\" links (to advance 10 percent of the total number of pages) " => "Mostra enllaços per moure's ràpid (per 10 per cent del nombre total de pàgines) ",
"Hide pagination when there is only one page" => "Amaga paginació quan només hi ha una pàgina",
"Don't display pagination on single pages." => "Ocultar la paginació en una sola pàgina",
"Use Icons" => "Empra Icones",
"Display 'First' and 'Last' links" => "Mostra Enllaços 'Primer/a' i 'Darrer/a'",
"Require characters and numerals" => "Requerir caràcters i números",
"For improved security, require users to include a mix of alphabetical characters and numerals in passwords" => "Per millorar la seguretat, requereixen que els usuaris inclouen una combinació de caràcters i números a les contrasenyes",
// "Password file used" => "Password file used",
// "The automatically selected file is recommended unless you generate your own blacklist file" => "The automatically selected file is recommended unless you generate your own blacklist file",
// "Prevent common passwords" => "Prevent common passwords",
// "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist" => "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist",
"Password expires after" => "Contrasenya expira després",
// "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in" => "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in",
"Require alphabetical characters in lower and upper case" => "Requerir caràcters alfabètics en majúscules i minúscules",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords" => "La contrasenya ha de contenir almenys un caràcter alfabètic en minúscula com una i altra en majúscules com A",
"Require special characters" => "Requerir caràcters especials",
"Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords" => "La contrasenya ha de contenir almenys un caràcter especial en minúscules com \" / \$ % ? & * ( ) _ + ..",
"Require no consecutive repetition of the same character" => "No requereixen la repetició consecutiva de la mateixa naturalesa",
"Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"" => "La contrasenya ha de contenir repetició consecutiva del mateix caràcter que 111 o aab",
"The password must be different from the user's log-in name" => "La contrasenya ha de ser diferent de la connexió de l'usuari",
"Payment" => "Pagament",
"Feature for tracking and managing payment requests" => "Funció de gestió i seguiment de les sol·licituds de pagament",
// "Payment system" => "Payment system",
"Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Actualment s'ha d'escollir entre PayPal, i Cclite (en desenvolupament), o Crèdits d'Usuari de Tiki",
"PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: consulta PayPal.com - Cclite: Monedes Comunitàries",
"PayPal" => "PayPal",
// "Israel Post Payment Module" => "Israel Post Payment Module",
"Cclite" => "Cclite",
"Tiki User Credits" => "Tiki Crèdits usuari",
// "PayPal ID" => "PayPal ID",
// "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type" => "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type",
// "Primary email of your PayPal account (Personal or Business)" => "Primary email of your PayPal account (Personal or Business)",
// "PayPal business password" => "PayPal business password",
// "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts" => "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts",
// "Primary password of your PayPal Pro business account - OPTIONAL" => "Primary password of your PayPal Pro business account - OPTIONAL",
// "Paypal business signature" => "Paypal business signature",
// "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts" => "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts",
// "Your API signature associated with your PayPal Pro business account - OPTIONAL" => "Your API signature associated with your PayPal Pro business account - OPTIONAL",
"PayPal environment" => "Medi Ambient Paypal",
"Used to switch between the PayPal sandbox, used for testing and development and the live environment" => "S'utilitza per canviar entre el sorral paypal, utilitzada per a les proves i el desenvolupament i el medi ambient en viu",
"Production" => "Producció",
// "PayPal instant payment notification (IPN)" => "PayPal instant payment notification (IPN)",
"Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server" => "Habilitar IPN per a la realització del pagament automàtic. Quan s'activa, Paypal farà ping de nou el lloc en què es confirma el pagament. A continuació, s'introdueix de forma automàtica el pagament. Això pot ser possible si el servidor no està en un servidor públic",
// "Payment data transfer (PDT)" => "Payment data transfer (PDT)",
// "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically" => "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically",
// "Payment data transfer (PDT) token" => "Payment data transfer (PDT) token",
// " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT" => " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT",
// "Redirect after PDT payment" => "Redirect after PDT payment",
// "Optionally, after receiving a successful payment, the user will be redirected to this page" => "Optionally, after receiving a successful payment, the user will be redirected to this page",
"Currency used when entering payments" => "Moneda emprada en introduir els pagaments",
"Default acceptable payment delay" => "Retard acceptable per omissió per a fer els pagaments",
"Number of days before a payment request becomes overdue. This can be changed per payment request" => "Nombre de dies abans que la petició de pagament passi de termini. Això es pot canviar a cada petició de pagament",
// "Cclite registries" => "Cclite registries",
"Registries in Cclite" => "Registres a Cclite",
"Registry names in Cclite" => "Noms de registres (xarxes d'intercanvi) a Cclite",
// "Cclite registry currencies" => "Cclite registry currencies",
"Currencies in Cclite" => "Monedes en Cclite",
"Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)." => "Cada registre (xarxa d'intercanvi) a Cclite pot tenir la seva pròpia moneda. Ha de ser una per registre (xarxa d'intercanvi). (sensible a majúscules/minúscules)",
// "Cclite server URL" => "Cclite server URL",
"Full URL of the repository" => "URL sencera del dipòsit (repositori)",
"for example, https://cclite.yourdomain.org/cclite/" => "e.g. https://cclite.elteudomini.org/cclite/",
// "Cclite merchant key" => "Cclite merchant key",
// "Corresponds with merchant key setting in Cclite" => "Corresponds with merchant key setting in Cclite",
// "Cclite merchant user" => "Cclite merchant user",
"Username in Cclite representing \"the management\"" => "Nom d'usuari a Cclite representant a \"la gestió\". Per omissió és el \"manager\" (gestor)",
// "Cclite enable payments" => "Cclite enable payments",
"Select Cclite test or live operation." => "Operació de proves o en viu",
"Live" => "En viu",
// "Hashing algorithm" => "Hashing algorithm",
"Encryption type" => "Tipus de xifratge",
"SHA1" => "SHA1",
"SHA256" => "SHA256",
"SHA512" => "SHA512",
// "Cclite payment notification" => "Cclite payment notification",
"To do" => "TOT",
// "Wiki page with manual payment instructions" => "Wiki page with manual payment instructions",
// "Enter wiki page name" => "Enter wiki page name",
// "Invoice prefix" => "Invoice prefix",
"The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice" => "Prefix ha d'establir i únic si el mateix compte paypal s'utilitza per a diferents llocs tiki com xecs paypal que la factura no es paga dues vegades",
"Types of credit to use" => "Tipus de crèdit a utilitzar",
"This is a list of the types of Tiki user credits that are acceptable for payment" => "Aquesta és una llista dels tipus de crèdits de Tiki d'acceptar pagar amb",
"Exchange rate for types of credit to use" => "Taxa de canvi dels tipus de crèdit a utilitzar",
"This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency" => "Aquesta és una llista corresponent de nombre de crèdits equivalent a 1 de la moneda de pagament",
// "User can only see own outstanding payments" => "User can only see own outstanding payments",
"Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments" => "A menys que tingui permisos d'administració de pagament, l'usuari només pot veure els seus propis pagaments pendents",
// "User can only see own past or cancelled payments" => "User can only see own past or cancelled payments",
"Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments" => "A menys que tingui permisos d'administració de pagament, l'usuari només pot veure el seu propi passat o pagaments cancel·lats",
// "Anonymous users can pay outstanding invoices" => "Anonymous users can pay outstanding invoices",
// "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)" => "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)",
"Manage product inventory" => "Gestionar l'inventari de productes",
"Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "Activar la funció d'inventari de producte, necessita d'un formulari-bd de productes correcte, l'itemId ha de ser el codi de producte",
// "Products tracker ID" => "Products tracker ID",
"ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code." => "ID del Formulari-bd que conté formulari-bd de productes, necessari per a les característiques avançades del carret, l'itemId serà el codi de producte",
// "Products tracker name" => "Products tracker name",
// "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code" => "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code",
// "Inventory type field ID" => "Inventory type field ID",
"In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"" => "ID de camp en el formulari-bd de productes per a emmagatzemar el tipus d'inventari, el valor del camp ha de ser \"none\" (cap) o \"internal\" (intern)",
// "Inventory total field ID" => "Inventory total field ID",
"In the products tracker, the ID of the field to store the total inventory of products" => "ID de camp en el formulari-bd de per a emmagatzemar l'inventari total de producte",
// "Inventory total less hold field ID" => "Inventory total less hold field ID",
"In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts" => "ID de camp en el formulari-bd de productes per emmagatzemar l'inventari total del producte menys l'import en suspens a causa del que es troba actualment en els carret",
// "Inventory hold timeout" => "Inventory hold timeout",
"Minutes to hold inventory before making it available again when there is no user cart action" => "Minuts per mantenir l'inventari abans de fer-ho disponible de nou quan no hi ha una acció de compra de l'usuari",
"Bundled products feature for cart" => "Funció de paquets de productes per al carret",
"Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "Activar la funció dels productes d'embalatge, necessita productes de seguiment que es crearà correctament, el Itemid ha de ser el codi de producte",
// "Product name field name" => "Product name field name",
"In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle" => "Nom del camp en el formulari-bd de productes del nom del producte que s'utilitzarà com a etiqueta del producte, per exemple, en un paquet",
// "Items in bundle field name" => "Items in bundle field name",
"In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)." => "Nom del camp en els productes de seguiment d'un llista separada per comes d'identificadors de producte dels productes en el paquet (és a dir, si el camp conté res, llavors aquest producte és un paquet), també es pot especificar el nombre dels sub-productes, per exemple, 23: (\"punts \") significa 2,24 punt 23 (x2) + article 24 (x1)",
// "Product price field name" => "Product price field name",
"In the products tracker, the name of the field for the product price" => "Nom del camp en el formulari-bd de productes del preu del producte",
// "Associated event ID field name" => "Associated event ID field name",
// "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with" => "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with",
// "Product class ID field name" => "Product class ID field name",
// "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature",
// "Gift certificate template field name" => "Gift certificate template field name",
// "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature",
// "Record cart orders in trackers" => "Record cart orders in trackers",
// "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording" => "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording",
// "Orders profile" => "Orders profile",
"Wiki page containing the profile for creating orders (page name must not have spaces)" => "Pàgina wiki on el perfil per crear les ordres és de (nom de la pàgina ha de ser sense espais)",
// "Order item profile" => "Order item profile",
"Wiki page containing the profile for creating order items (page name must not have spaces)" => "Pàgina wiki on el perfil per crear ordres d'articles és de (nom de la pàgina ha de ser sense espais)",
// "Allow anonymous shopping" => "Allow anonymous shopping",
// "Allow shopping by anonymous users and record the orders in trackers" => "Allow shopping by anonymous users and record the orders in trackers",
// "Anonymous orders profile" => "Anonymous orders profile",
"Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)" => "Pàgina wiki on el perfil per crear comandes d'usuaris anònims és (nom de la pàgina ha de ser sense espais)",
// "Anonymous order item profile" => "Anonymous order item profile",
"Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)" => "Pàgina wiki on el perfil per crear ordres d'articles per als usuaris anònims és (nom de la pàgina ha de ser sense espais)",
// "Anonymous shopper info profile" => "Anonymous shopper info profile",
// "Anonymous users order review page" => "Anonymous users order review page",
"Wiki page where anonymous users can review their orders" => "Pàgina Wiki on els usuaris anònims poden veure els ordres)",
// "Temporary shopper group" => "Temporary shopper group",
// "Group name of group with permission to access review page via a token" => "Group name of group with permission to access review page via a token",
// "Enable association of product orders" => "Enable association of product orders",
"Enable association of products with events (or projects, etc.)." => "Permetre l'associació dels productes als esdeveniments (o projectes, etc ..)",
// "Events tracker ID" => "Events tracker ID",
// "Tracker ID of tracker that is the events tracker" => "Tracker ID of tracker that is the events tracker",
// "Events tracker name" => "Events tracker name",
// "Name of tracker that is the events tracker" => "Name of tracker that is the events tracker",
// "Event start field name" => "Event start field name",
// "Field name in events tracker of start date/time" => "Field name in events tracker of start date/time",
// "Event end field name" => "Event end field name",
// "Field name in events tracker of end date/time" => "Field name in events tracker of end date/time",
"Allow exchange of products" => "Permetre l'intercanvi de productes",
// "Order items tracker ID" => "Order items tracker ID",
// "Tracker ID of tracker that is the order items tracker" => "Tracker ID of tracker that is the order items tracker",
"Gift certificates" => "Els certificats de regal",
// "Gift certificate tracker ID" => "Gift certificate tracker ID",
// "ID of tracker that is the gift certificate tracker" => "ID of tracker that is the gift certificate tracker",
// "Gift certificate tracker name" => "Gift certificate tracker name",
// "Name of tracker that is the gift certificate tracker" => "Name of tracker that is the gift certificate tracker",
// "Orders tracker name" => "Orders tracker name",
// "Name of tracker that is the orders tracker" => "Name of tracker that is the orders tracker",
// "Order items tracker name" => "Order items tracker name",
// "Name of tracker that is the order items tracker" => "Name of tracker that is the order items tracker",
// "Product classes tracker name" => "Product classes tracker name",
// "Name of tracker that is the product classes tracker" => "Name of tracker that is the product classes tracker",
// "Payment heading" => "Payment heading",
// "Heading displayed on payment form" => "Heading displayed on payment form",
// "Israel Post payment environment" => "Israel Post payment environment",
// "Switch between test transactions and real transactions" => "Switch between test transactions and real transactions",
// "Israel Post use pre-authorization" => "Israel Post use pre-authorization",
// "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post" => "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post",
// "Israel Post business ID" => "Israel Post business ID",
// "Provided by Israel Post, usually the business name" => "Provided by Israel Post, usually the business name",
// "Israel Post API password" => "Israel Post API password",
// "Provided by Israel Post" => "Provided by Israel Post",
"Send to URL" => "Enviar a URL",
// "URL to redirect to on \"permission denied\"" => "URL to redirect to on \"permission denied\"",
"On permission denied, display login module" => "El permís denegat, mostrarà mòdul d'inici de sessió (per Anonymous)",
// "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead" => "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead",
"PHP libxml extension" => "Extensió PHP libxml",
"This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default" => "Aquesta extensió requereix l'extensió PHP libxml \n\t\t\t\\Això vol dir que el paràmetre –enable-libxml també es requereix, encara que això és \n\t\t\t\timplicitament realitzat perque libxml està habilitat defecte",
"PHP DateTime" => "PHP DateTime",
"DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0." => "Classe DateTime (i funcions associades) estan activades \n\t\t\t \\ tby per omissió a partir de PHP 5.2.0, és possible afegir suport experimental en PHP \n\t\t\t \\ t5.1.x per utilitzant la bandera abans configuri / compili: \n\t\t\t \\ tCFLAGS =-DEXPERIMENTAL_DATE_SUPPORT = 1",
"Number of comments to show on poll pages" => "Nombre de comentaris per mostrar les pàgines de sondejos",
"The order in which order polls are displayed" => "Algorisme d'ordenament de sondejos (per omissió = punts)",
"Show categories" => "Mostra categories",
// "For polls that are categorized, the category is displayed" => "For polls that are categorized, the category is displayed",
"Show objects" => "Mostra objectes",
// "List wiki pages or other site objects that the poll is attached to" => "List wiki pages or other site objects that the poll is attached to",
"Multiple polls per object" => "Diversos sondejos per objecte",
"When used with the rating features, allow multiple polls to be attached to a single object" => "Quan s'utilitza amb les funcions de qualificació, permeten múltiples sondejos que s'adjunten a un sol objecte",
"Disable textarea toolbar" => "Desactivar la barra d'eines de l'àrea de text",
"Don't display the toolbar on text inputs in surveys." => "Oculta la barra d'eines per als camps textarea en les enquestes",
// "Precision of survey results calculation" => "Precision of survey results calculation",
// "Number of decimal places in the percentage figures" => "Number of decimal places in the percentage figures",
// "decimal places" => "decimal places",
// "Set display settings for all galleries" => "Set display settings for all galleries",
"PDF from URL" => "PDF d'URL",
"Using external tools, generate PDF documents from URLs" => "L'ús d'eines extenal, generar documents PDF a partir d'URLs web",
"WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "WeasyPrint" => "WeasyPrint",
// "mPDF" => "mPDF",
"Webservice URL" => "URL Webservice",
"URL to a service that takes a URL as the query string and returns a PDF document" => "URL a un servei que pren un URL com la cadena de consulta i retorna un document PDF",
"WebKit path" => "Ruta WebKit",
"Full path to the wkhtmltopdf executable to generate the PDF document with" => "Ruta d'accés completa a l'executable wkhtmltopdf per generar el document PDF amb",
// "WeasyPrint path" => "WeasyPrint path",
// "Full path to the weasyprint executable to generate the PDF document with" => "Full path to the weasyprint executable to generate the PDF document with",
// "Print Friendly PDF" => "Print Friendly PDF",
// "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file" => "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file",
// "PDF Orientation" => "PDF Orientation",
// "Landscape or portrait" => "Landscape or portrait",
"Portrait" => "Vertical",
"Landscape" => "Apaisat",
// "PDF page size" => "PDF page size",
// "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)" => "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)",
// "Legal" => "Legal",
// "Tabloid/Ledger" => "Tabloid/Ledger",
// "A0" => "A0",
// "A1" => "A1",
// "A2" => "A2",
// "A3" => "A3",
// "A4" => "A4",
// "A5" => "A5",
// "A6" => "A6",
// "Generate auto table of contents with PDF" => "Generate auto table of contents with PDF",
// "Link TOC with content" => "Link TOC with content",
// "Link table of contents headings with content in the PDF" => "Link table of contents headings with content in the PDF",
// "TOC heading" => "TOC heading",
// "Heading to be displayed above the table of contents" => "Heading to be displayed above the table of contents",
// "PDF TOC levels" => "PDF TOC levels",
// "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3" => "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3",
// "Show Page title" => "Show Page title",
// "Print wiki page title with pdf" => "Print wiki page title with pdf",
// "PDF header text" => "PDF header text",
// "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}" => "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}",
// "HTML / Wiki Syntax / " => "HTML / Wiki Syntax / ",
// "Left text" => "Left text",
// "Center Text" => "Center Text",
// "Right Text" => "Right Text",
// "PDF footer text" => "PDF footer text",
// "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}" => "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}",
// "Left margin" => "Left margin",
// "Numeric value.For example 10" => "Numeric value.For example 10",
// "Right margin" => "Right margin",
// "Numeric value, no need to add px. For example 10" => "Numeric value, no need to add px. For example 10",
// "Top margin" => "Top margin",
// "Bottom margin" => "Bottom margin",
// "Header margin from top of document" => "Header margin from top of document",
// "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Header can overlap text if top margin is not set properly" => "Warning: Header can overlap text if top margin is not set properly",
// "Footer margin from bottom of document" => "Footer margin from bottom of document",
// "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Footer can overlap text if bottom margin is not set properly" => "Warning: Footer can overlap text if bottom margin is not set properly",
// "Hyperlink behaviour in PDF" => "Hyperlink behaviour in PDF",
// "Off (Links will be removed)" => "Off (Links will be removed)",
// "Add as footnote (Links will be listed at end of document" => "Add as footnote (Links will be listed at end of document",
// "PDF Bookmarks" => "PDF Bookmarks",
// "Automatically generate bookmarks" => "Automatically generate bookmarks",
// "H1-H6, separated by |.For example: H1|H2|H3" => "H1-H6, separated by |.For example: H1|H2|H3",
// "Number of columns" => "Number of columns",
// "Default - 1 Column" => "Default - 1 Column",
// "2 Columns" => "2 Columns",
// "3 Columns" => "3 Columns",
// "4 Columns" => "4 Columns",
// "PDF password for viewing" => "PDF password for viewing",
// "Password-protect the generated PDF" => "Password-protect the generated PDF",
// "Watermark text" => "Watermark text",
// "PDF watermark text, if any" => "PDF watermark text, if any",
// "Watermark Image URL" => "Watermark Image URL",
// "The watermark image will appear under the text. Enter the complete image URL" => "The watermark image will appear under the text. Enter the complete image URL",
// "PDF page background color" => "PDF page background color",
// "Enter a valid CSS color code" => "Enter a valid CSS color code",
// "PDF page background image" => "PDF page background image",
// "Enter the full URL" => "Enter the full URL",
// "CoverPage text settings" => "CoverPage text settings",
// "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings" => "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings",
// "Coverpage image URL" => "Coverpage image URL",
// "Print wiki authors" => "Print wiki authors",
// "Include wiki page authors and date in print versions of wiki pages" => "Include wiki page authors and date in print versions of wiki pages",
// "Print original wiki URL" => "Print original wiki URL",
// "Include original wiki page URL in print versions of wiki pages" => "Include original wiki page URL in print versions of wiki pages",
// "Print original tracker item URL" => "Print original tracker item URL",
// "Print original forum post URL" => "Print original forum post URL",
// "Include original forum post URL in print version of forum posts" => "Include original forum post URL in print version of forum posts",
"Repository URLs" => "URL del repositori",
"List of URLs for the profile repositories that will be used" => "Llista d'adreces URL dels dipòsits de perfil que s'utilitzaran",
"Enter multiple repository URLs, one per line" => "Introduïu les URL repositori múltiple, un per línia",
"Data channels" => "Canals de dades",
"Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Els canals de dades són plantilles que es poden aplicar a partir d'una sol·licitud de missatge. Ells es poden utilitzar per automatitzar el treball en instal·lacions més complexes",
"Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Canals de dades creen una canalització amb nom per executar els perfils d'espai d'usuari. Un canal per línia. Cada línia està delimitat per comes i conté el nom __ canal, domini, perfil, grups permesos, (opcional) \\ \$ profilerequest: entrada \\ \$ coincidències amb groups__",
"There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "Hi ha consideracions de seguretat relacionades amb l'ús dels canals de dades. Assegureu-vos que la pàgina de perfil està controlat pels administradors només",
"Developer mode" => "Mode de desenvolupador",
"For profiles under an approval workflow, always use the latest version, even if not approved" => "Per als perfils sota un flux de treball d'aprovació, utilitzeu sempre la darrera versió, encara que no es va aprovar",
"Make sure you review the profiles you install" => "Assegureu-vos de revisar els perfils d'instal·lar",
// "Automatically approve wiki-plugins on pages installed by profiles" => "Automatically approve wiki-plugins on pages installed by profiles",
// "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved" => "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved",
// "Make sure your profiles are not executable or editable by untrusted users" => "Make sure your profiles are not executable or editable by untrusted users",
"Proxy host name" => "Nom de host del servidor intermediari",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
"Proxy port" => "Port del Proxy",
"Proxy username" => "Proxy nom d'usuari",
"Proxy password" => "Contrasenya del servidor intermediari",
"Quantify change size" => "Quantifica la mida del canvi",
"In addition to tracking the changes, track the change size and display approximately how up-to-date the page is" => "A més del seguiment dels canvis, el seguiment del canvi de mida i mostrar el aproximat fins al dia-tat de la pàgina",
"Advanced Rating" => "Valoració Avançada",
"In an advanced rating system, the options and calculation method can be configured" => "Sistema de valoració que permet configurar les opcions i el mètode de càlcul",
"Rating recalculation mode" => "Mode de recalcular de la valoració",
"Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent" => "Determina quan i com es tornen a calcular els agregats de valoració. Depenent de la càrrega del lloc, algunes opcions poden ser preferibles a altres. En els llocs de gran volum, s'ha de fer com un treball cron. El nou càlcul de vot pot ser inexacte si el càlcul de valoració depèn del temps",
"Recalculate on vote" => "Recalcular en votar",
"Randomly recalculate oldest ratings (on load)" => "Aleatòriament recalcular les valoracions més antigues (en carregar-se la pàgina)",
"Randomly recalculate oldest ratings (on vote)" => "Aleatòriament recalcular les valoracions més antigues (en votar)",
"Cron job (must be set manually)" => "Treball Cron (s'ha d'ajustar manualment)",
"Before any attempt to re-index the object" => "Abans que qualsevol intent de tornar a indexar l'objecte",
"Recalculation odds (1 in X)" => "Probabilitats de recàlcul (1 en X)",
"Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Es llença un dau a cada sol·licitud. Quan té èxit, tornarà a calcular un nombre de vots",
"votes" => "vots",
"Recalculation count" => "Recompte en recalcular",
"How many ratings should be recalculated when odds strike" => "Quantes notes han de ser recalculats quan colpegen probabilitats",
// "ratings" => "ratings",
"Smiley Ratings" => "Emoticons de Valoració",
"Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration" => "Mostra una cara somrient per al sistema de qualificacions simple. Només funciona amb 0-11, depenent del que hagi establert. Una interfície d'usuari més fàcil d'usar, com emoticones",
"Enabled" => "Permès",
"Detailed rating results" => "Resultats detallats de la valoració",
"Displays a table with the result count and percentage per rating option" => "Mostra una taula amb el recompte i percentatge resultants per a cada opció de valoració",
// "Reversed Rating Options" => "Reversed Rating Options",
// "Displays the ratings options in reverse" => "Displays the ratings options in reverse",
"Include percentages in the detailed rating results" => "Inclou percentatges en els resultats detallats de la valoració",
"Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown" => "Inclou percentatges en els resultats detallats de la valoració. Alternativament, mostra només els números de recompte i les barres proporcionals als percentatges, però no els valors numèrics de cada percentatge",
// "Default rating options" => "Default rating options",
// "List of options available" => "List of options available",
// "Multiple votes per user" => "Multiple votes per user",
// "Allow users to vote multiple times in the same poll" => "Allow users to vote multiple times in the same poll",
"Use reCAPTCHA" => "Utilitza reCAPTCHA",
"Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA" => "Utilitza reCAPTCHA, un servei Captcha especialitzada, en lloc de CAPTCHA per omissió",
"You will need to register at [http://www.google.com/recaptcha]" => "Hauràs de registrar-te a [http://www.google.com/recaptcha]",
// "Site key" => "Site key",
"reCAPTCHA public key obtained after registering" => "Clau pública reCAPTCHA obtingut després de registrar",
// "Secret key" => "Secret key",
"reCAPTCHA private key obtained after registering" => "Clau privada reCAPTCHA obtingut després de registrar",
"reCAPTCHA theme" => "Reconèixer el tema",
"Choose a theme for the reCAPTCHA widget" => "Triar un tema per al giny reCAPTCHA",
"Black Glass" => "Negre Cristall",
"Red" => "Vermell",
"White" => "Blanc",
// "reCAPTCHA version" => "reCAPTCHA version",
// "1.0" => "1.0",
// "2.0" => "2.0",
// "3.0" => "3.0",
"Record untranslated strings" => "Registre no traduït",
"Keep track of the unsuccessful attemps to translate strings" => "Mantingui un registre dels intents fallits de convertir cadenes",
// "Redis" => "Redis",
// "Enable connection to Redis to store cache" => "Enable connection to Redis to store cache",
// "Requires PHP Redis" => "Requires PHP Redis",
// "Redis Host" => "Redis Host",
// "IP address or domain name for Redis server" => "IP address or domain name for Redis server",
// "Redis Port" => "Redis Port",
// "Port for Redis server" => "Port for Redis server",
// "Redis connection timeout" => "Redis connection timeout",
// "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited" => "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited",
// "Redis Prefix" => "Redis Prefix",
// "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none" => "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none",
// "Redis cache expiry" => "Redis cache expiry",
// "Duration for which the cache will be kept. 0 means unlimited" => "Duration for which the cache will be kept. 0 means unlimited",
// "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern" => "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern",
"Restrict supported languages" => "Restringeix els idiomes suportats",
"Limit the languages made available on the site" => "Límit els idiomes disponibles en el lloc",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Enable SAML Auth" => "Enable SAML Auth",
// "IdP Entity Id" => "IdP Entity Id",
// "Identifier of the IdP entity (\"Issuer\")" => "Identifier of the IdP entity (\"Issuer\")",
// "Single sign-on service URL" => "Single sign-on service URL",
// "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")" => "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")",
// "Single log-out service URL" => "Single log-out service URL",
// "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")" => "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")",
// "X.509 certificate" => "X.509 certificate",
// "Public x509 certificate of the IdP.  (\"X.509 certificate\")" => "Public x509 certificate of the IdP.  (\"X.509 certificate\")",
// "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section" => "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section",
// "Sync user group with IdP data" => "Sync user group with IdP data",
// "This should be enabled to sync groups with the IdP" => "This should be enabled to sync groups with the IdP",
// "Enable Single Logout Service" => "Enable Single Logout Service",
// "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers" => "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers",
"Default group" => "Grup predeterminat",
// "When provisioning a new user and not group found, assign that group" => "When provisioning a new user and not group found, assign that group",
// "Account matcher" => "Account matcher",
// "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost" => "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost",
// "Log-in link text" => "Log-in link text",
// "The text that appears on the log-in page" => "The text that appears on the log-in page",
// "SAML attribute that will be mapped to the Tiki username" => "SAML attribute that will be mapped to the Tiki username",
// "The SAML attribute that will be mapped to the Tiki username" => "The SAML attribute that will be mapped to the Tiki username",
// "SAML attribute that will be mapped to the Tiki email" => "SAML attribute that will be mapped to the Tiki email",
// "The SAML attribute that will be mapped to the Tiki email" => "The SAML attribute that will be mapped to the Tiki email",
// "SAML attribute that will be mapped to the Tiki group" => "SAML attribute that will be mapped to the Tiki group",
// "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation" => "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation",
// "Admins" => "Admins",
// "Set here the values of the IdP related to the user group info that will be matched with the Admins group" => "Set here the values of the IdP related to the user group info that will be matched with the Admins group",
"Registered" => "Enregistrats/des",
// "Set here the values of the IdP related to the user group info that will be matched with the Registered group" => "Set here the values of the IdP related to the user group info that will be matched with the Registered group",
// "Debug Mode" => "Debug Mode",
// "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed." => "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed.",
// "Strict Mode" => "Strict Mode",
// "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated" => "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated",
// "Service Provider Entity ID" => "Service Provider Entity ID",
// "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID" => "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID",
// "Requested NameIDFormat" => "Requested NameIDFormat",
// "Specifies constraints on the name identifier to be used to represent the requested subject" => "Specifies constraints on the name identifier to be used to represent the requested subject",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified" => "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress" => "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName" => "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:entity" => "urn:oasis:names:tc:SAML:2.0:nameid-format:entity",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:transient" => "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" => "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted" => "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos" => "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos",
// "Requested AuthnContext" => "Requested AuthnContext",
// "Authentication context: unselect all to accept any type, otherwise select the valid contexts" => "Authentication context: unselect all to accept any type, otherwise select the valid contexts",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified" => "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Password" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Password",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" => "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:X509" => "urn:oasis:names:tc:SAML:2.0:ac:classes:X509",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos",
// "urn:federation:authentication:windows" => "urn:federation:authentication:windows",
// "Enable Lowercase URL encoding" => "Enable Lowercase URL encoding",
// "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues." => "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues.",
// "Encrypt nameID" => "Encrypt nameID",
// "Sign AuthnRequest" => "Sign AuthnRequest",
// "The samlp:AuthnRequest messages sent by this SP will be signed" => "The samlp:AuthnRequest messages sent by this SP will be signed",
// "Sign LogoutRequest" => "Sign LogoutRequest",
// "The samlp:logoutRequest messages sent by this SP will be signed" => "The samlp:logoutRequest messages sent by this SP will be signed",
// "Sign LogoutResponse" => "Sign LogoutResponse",
// "The samlp:logoutResponse messages sent by this SP will be signed" => "The samlp:logoutResponse messages sent by this SP will be signed",
// "Sign Metadata" => "Sign Metadata",
// "The Metadata published by this SP will be signed" => "The Metadata published by this SP will be signed",
// "Reject Unsigned Messages" => "Reject Unsigned Messages",
// "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received" => "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received",
// "Reject Unsigned Assertions" => "Reject Unsigned Assertions",
// "Reject unsigned saml:Assertion received" => "Reject unsigned saml:Assertion received",
// "Reject Unencrypted Assertions" => "Reject Unencrypted Assertions",
// "Reject unencrypted saml:Assertion received" => "Reject unencrypted saml:Assertion received",
// "Retrieve Parameters From Server" => "Retrieve Parameters From Server",
// "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters" => "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters",
// "Service Provider X.509 certificate" => "Service Provider X.509 certificate",
// "Public x509 certificate of the SP" => "Public x509 certificate of the SP",
// "Service Provider Private Key" => "Service Provider Private Key",
// "Private key of the SP" => "Private key of the SP",
// "Signature Algorithm" => "Signature Algorithm",
// "Algorithm that the toolkit will use on the signing process" => "Algorithm that the toolkit will use on the signing process",
// "http://www.w3.org/2000/09/xmldsig#rsa-sha1" => "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
// "http://www.w3.org/2000/09/xmldsig#dsa-sha1" => "http://www.w3.org/2000/09/xmldsig#dsa-sha1",
// "Scheduler stalled after (minutes)" => "Scheduler stalled after (minutes)",
// "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection" => "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection",
// "Notify on stalled schedulers" => "Notify on stalled schedulers",
// "Send an email notification when a stalled scheduler is detected" => "Send an email notification when a stalled scheduler is detected",
// "Users to notify on stalled task" => "Users to notify on stalled task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Self healing after (minutes)" => "Self healing after (minutes)",
// "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing" => "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing",
// "Notify on healed schedulers" => "Notify on healed schedulers",
// "Send an email notification when a stalled scheduler is healed" => "Send an email notification when a stalled scheduler is healed",
// "Users to notify on healed task" => "Users to notify on healed task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Number of logs to keep" => "Number of logs to keep",
// "0 will keep all logs" => "0 will keep all logs",
"SCORM support" => "Suport SCORM",
"Handle SCORM package files on upload. SCORM is a standard used in learning management systems" => "Manipular arxius del paquet SCORM en pujada. SCORM és un estàndard utilitzat en el Learning Management Systems",
"SCORM Tracker" => "SCORM Formulari-bd",
"The ID number of the tracker used to store SCORM metadata" => "Formulari-bd de ID a utilitzar per emmagatzemar les metadades SCORM",
"Parse search results" => "Analitzar els resultats",
// "When enabled search results are parsed so content formatting is visible in the search results" => "When enabled search results are parsed so content formatting is visible in the search results",
"Default where" => "A on per omissió",
"When object filter is not on, limit to search one type of object" => "Quan no és actiu el filtre d'objectes, limita la cerca a un tipus d'objecte",
"Entire site" => "Lloc complet",
"Wiki Pages" => "Pàgines del wiki",
"Wiki pages" => "Pàgines Wiki",
// "Blog posts" => "Blog posts",
// "Tracker items" => "Tracker items",
"Spreadsheets" => "Fulls de càlcul",
"Restrict search language by default" => "Restringir per omissió l'idioma de cerca",
"Only search content that is in the interface language, otherwise show the language menu" => "Si està habilitat, només cerca contingut en l'idioma de la interfície, en cas contrari mostra el menú d'idiomes",
"Autocomplete page names" => "Emplenament automàtic de noms de pàgina",
// "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc" => "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc",
"deprecated" => "obsolet",
"Category filter" => "Filtre de Categories",
"Tag filter" => "Filtre d'etiquetes",
// "Use facets for default search interface" => "Use facets for default search interface",
// "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines" => "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines",
// "Facet result count" => "Facet result count",
// "Default number of facet results to obtain" => "Default number of facet results to obtain",
// "facet results" => "facet results",
// "Search index outdated" => "Search index outdated",
// "Number of days to consider the search index outdated" => "Number of days to consider the search index outdated",
// "Show error on missing field" => "Show error on missing field",
// "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly" => "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly",
// "File thumbnail preview" => "File thumbnail preview",
// "Have a preview of attachments in search results" => "Have a preview of attachments in search results",
// "Use date histogram aggregations" => "Use date histogram aggregations",
// "Use date histogram aggregations (facets) when indexing, requires Elasticsearch" => "Use date histogram aggregations (facets) when indexing, requires Elasticsearch",
// "Date histogram aggregations interval" => "Date histogram aggregations interval",
// "Default interval for date histogram aggregations" => "Default interval for date histogram aggregations",
// "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0" => "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0",
// "Date range aggregations ranges" => "Date range aggregations ranges",
// "Default ranges for date range aggregations" => "Default ranges for date range aggregations",
// "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0" => "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0",
// "Excluded facets" => "Excluded facets",
// "List of facets (a.k.a. aggregations) to exclude from the default search results" => "List of facets (a.k.a. aggregations) to exclude from the default search results",
// "Avoid Duplicated Facets" => "Avoid Duplicated Facets",
// "Avoid Facets appearing with the same name, usually by appending the Tracker name" => "Avoid Facets appearing with the same name, usually by appending the Tracker name",
"Parse wiki syntax in comments" => "Interpreta la sintaxi wiki als comentaris",
"Parse wiki syntax in comments in all sections apart from Forums" => "Analitzar Sintaxi wiki en els comentaris en totes les seccions, a banda dels Fòrums",
"Use \"Accept wiki syntax\" for forums in admin forums page" => "Utilitza \"Accepta sintaxi wiki\" als fòrums a la pàgina d'administració de fòrums",
// "Short URL" => "Short URL",
// "Provides the ability to create a short url, easy to share" => "Provides the ability to create a short url, easy to share",
// "Short URL base URL" => "Short URL base URL",
// "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website" => "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website",
"Sender email" => "Correu-e de l'enviador",
"Email address that will be used as the sender for outgoing emails" => "Adreça de correu electrònic que s'utilitzarà com a remitent dels correus electrònics sortints",
// "Sender full name" => "Sender full name",
// "Real name that will be used as the sender for outgoing emails" => "Real name that will be used as the sender for outgoing emails",
"Time zone" => "Fus horari",
"Indicates the default time zone to use for the server" => "Indica la zona horària predeterminada per per al servidor",
"Session storage location" => "Ubicació d'emmagatzematge Sessió",
"Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Selecciona el lloc on s'ha d'emmagatzemar la informació de la sessió. Sessions de Memcache requereixen que Memcache sigui configurat",
"Default (from php.ini)" => "per omissió (de php.ini)",
"Database" => "Base de Dades",
"Session lifetime" => "Durada de la sessió",
"Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance" => "Valor proporcionat en  minuts. Serà el temps mínim en que estàs connectat. Si vols que sigui un temps exacte, cal que adjustis en l'.htaccess el session.gc_probability i session.gc_divisor a 1. Ves amb compte que el canvi de la probabilitat afectarà al rendiment del servidor",
"Silent session" => "Sessió silenciosa",
"Do not automatically start sessions" => "No comencis sessions automàticament",
// "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)" => "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)",
// "Can cause problems when combined with cookie consent and JavaScript-disabled browsers" => "Can cause problems when combined with cookie consent and JavaScript-disabled browsers",
"Session cookie name" => "Nom de la galeta de Sessió",
"Session cookie name used instead of the PHP default configuration" => "Nom galeta de sessió utilitzada en lloc de la configuració per omissió de PHP",
"Protect all sessions with HTTPS" => "Protegir totes les sessions amb HTTPS",
"Always redirect to HTTPS to prevent a session hijack through network sniffing" => "Sempre redirigeix a HTTPS per evitar segrest de la sessió a través de la xarxa sniffing",
"Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site" => "Només s'activarà si ja ha configurat SSL, en cas contrari, la teva voluntat tanca't de Tiki",
"Display links on the share page" => "Mostra els vincles de la pàgina de compartir",
"Token notification" => "Notificació de token",
"Users can subscribe to the notifications of consultation of the token." => "Els usuaris poden subscriure a les notificacions d'ús del token",
"Add contact" => "Afegir contacte",
"If not already in the list, recipients are added to the list of contacts." => "Si no existeix, els beneficiaris s'afegeixen a la llista de contactes",
"Display name and email" => "Mostra el nom i el correu electrònic",
"If the user is connected, the name and email will display in the page." => "Si l'usuari es connecta, nom i correu electrònic de visualització de la pàgina",
"Number of times accessed" => "Quantes vegades s'accedeix",
"User can choose how many times the share page can be consulted." => "L'usuari pot triar el nombre de vegades que el compartir pàgina es pot consultar",
"Maximum number of times accessed" => "Max quantes vegades accedeix",
"Maximum number of times that the shared page can be consulted" => "El nombre màxim de vegades que la pàgina compartida pot ser consultat",
// "page hits" => "page hits",
// "The name of the default group" => "The name of the default group",
"Create with default group" => "Crear amb grup predeterminat",
"Valid affiliations" => "Afiliacions vàlides",
// "A list of affiliations which will allow users to log in to this wiki" => "A list of affiliations which will allow users to log in to this wiki",
"Separate multiple affiliations with commas" => "Separa les afiliacions amb comes",
"Shipping service" => "Servei d'enviament",
"Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Exposar un servei d'estimació de cost del transport a JSON. Es poden requerir comptes dels proveïdors (FedEx, UPS, ...)",
"FedEx API" => "API FedEx",
"Enable shipping rate calculation through FedEx APIs" => "Habilitar càlcul del tipus d'enviament a través de FedEx API",
"FedEx key" => "FedEx clau",
"Developer key" => "Desenvolupador clau",
"FedEx password" => "FedEx Contrasenya",
"FedEx meter number" => "Nombre Ficar FedEx",
"FedEx account number" => "Número de Compte FedEx",
"UPS API" => "API UPS",
"Enable shipping rate calculation using the UPS carrier" => "Habilitar càlcul del tipus de vaixells que utilitzin el transportista UPS",
"UPS username" => "UPS Nom d'usuari",
"UPS credentials" => "Credencials d'UPS",
"UPS password" => "UPS Contrasenya",
"UPS access key" => "UPS clau d'accés",
"Custom shipping provider" => "Proveïdor d'enviament per encàrrec",
"Short date format" => "Format curt de data",
// "Specify how Tiki displays the date (shorter version)" => "Specify how Tiki displays the date (shorter version)",
"Short time format" => "Format curt d'hora",
// "Specify how Tiki displays the time (shorter version)" => "Specify how Tiki displays the time (shorter version)",
// "Short JavaScript date format" => "Short JavaScript date format",
// "Used in jQuery-UI date picker fields" => "Used in jQuery-UI date picker fields",
// "Short JavaScript time format" => "Short JavaScript time format",
// "Used in jQuery-UI datetime picker fields" => "Used in jQuery-UI datetime picker fields",
"%Y-%m-%d" => "%Y-%m-%d",
"%H:%M" => "%H:%M",
// "yy-mm-dd" => "yy-mm-dd",
// "HH:mm" => "HH:mm",
"%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
"Display available translations" => "Mostrar traduccions disponibles",
// "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons" => "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons",
// "Close site" => "Close site",
// "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site" => "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site",
// "Coming soon" => "Coming soon",
"Message" => "Missatge",
// "Site is closed for maintenance; please come back later" => "Site is closed for maintenance; please come back later",
// "Server is currently too busy; please come back later" => "Server is currently too busy; please come back later",
"Locations (breadcrumbs)" => "Llocs (rastre de molles de pa)",
// "Examples:  » / >  : -> →" => "Examples:  » / >  : -> →",
"Choices" => "Opcions",
// "Examples: | / ¦  " => "Examples: | / ¦  ",
"Browser title position" => "Ubicació del títol del lloc",
// "Position of the browser title in the full browser bar relative to the current page's descriptor" => "Position of the browser title in the full browser bar relative to the current page's descriptor",
// "After current page's descriptor" => "After current page's descriptor",
// "Before current page's descriptor" => "Before current page's descriptor",
// "No browser title, only current page's descriptor" => "No browser title, only current page's descriptor",
// "Only browser title, no current page's descriptor" => "Only browser title, no current page's descriptor",
"Browser title display mode" => "Mode de visualització del títol del navegador",
"When breadcrumbs are used, method to display the browser title" => "Quan s'usa el rastre de molles de pa, mètode en què ha d'aparèixer el títol del navegador",
"Most-specific first" => "Mostra primer la part més específica",
"Least-specific first (site)" => "Mostra primer la part menys específica (lloc)",
"Current only" => "Mostra només l'actual",
// "Favicons" => "Favicons",
// "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used" => "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used",
"Site terminal" => "Terminal del lloc",
"Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Permet dirigir als usuaris a una perspectiva específica en funció de l'adreça IP d'origen. Es pot utilitzar a l'interior intranets utilitzar diferents configuracions per als usuaris en funció de les seves departaments o els discriminen les persones en contextos web. IPs especificar els tornaran a comportament per omissió, incloent el maneig de diversos dominis. Perspectives seleccionats manualment tenen prioritat sobre aquest",
"Site terminal configuration" => "Configuració del terminal del Lloc",
"Provides the mapping from subnets to perspective" => "Proporciona l'assignació de subxarxes a la perspectiva",
"One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "Un per línia. Prefix de xarxa en notació CIDR (direcció / màscara de mida), separades per comes amb l'ID de perspectiva",
"Google Analytics account number" => "Número de compte Google Analytics",
"The account number for the site. The account number from Google is something like UA-XXXXXXX-YY" => "El número de compte per al lloc. El seu número de compte de Google sembla UA-XXXXXXX-YY. Tot el que necessites per participar és XXXXXXX-YY",
// "Google Analytics Groups Option" => "Google Analytics Groups Option",
// "Define option for Google Analytics groups" => "Define option for Google Analytics groups",
// "Included" => "Included",
// "Excluded" => "Excluded",
// "Google Analytics Available Groups" => "Google Analytics Available Groups",
// "User groups for which Google Analytics will be available" => "User groups for which Google Analytics will be available",
// "Google Global Site Tag Mode" => "Google Global Site Tag Mode",
// "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js" => "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js",
// "Google authentication credentials file" => "Google authentication credentials file",
// "Path to the Google Service Account credentials JSON file" => "Path to the Google Service Account credentials JSON file",
"Site layout" => "Disposició del lloc",
"Changes the template for the overall site layout" => "Canvia les plantilles generals de disposició del lloc",
// "Admin layout" => "Admin layout",
// "Specify which layout template to use for admin pages" => "Specify which layout template to use for admin pages",
"Enable layout per page, etc." => "Permet una disposició per objecte",
"Specify an alternate layout for a particular wiki page, etc" => "Permet als objectes definir una disposició alternativa per la seva presentació",
// "Piwik server URL" => "Piwik server URL",
// "The URL to the Piwik server of this site" => "The URL to the Piwik server of this site",
// "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL" => "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL",
// "Site Id" => "Site Id",
// "The ID of this website in Piwik" => "The ID of this website in Piwik",
// "Piwik JavaScript tracking code" => "Piwik JavaScript tracking code",
// "Piwik Groups Option" => "Piwik Groups Option",
// "Define option for Piwik groups" => "Define option for Piwik groups",
// "Piwik Available Groups" => "Piwik Available Groups",
// "User groups for which piwik will be available" => "User groups for which piwik will be available",
// "Security timeout" => "Security timeout",
// "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case" => "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case",
// "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting" => "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting",
// "Code to be placed on every page of this website just before the </body> tag" => "Code to be placed on every page of this website just before the </body> tag",
"Publish" => "Publica",
// "Make the banner visible to all site visitors" => "Make the banner visible to all site visitors",
// "Activate must be turned on for Publish to take effect" => "Activate must be turned on for Publish to take effect",
"Logo source (image path)" => "Font del Logo (ruta de la imatge)",
"Logo background color" => "Color de fons del Logo",
// "A legacy option to add a background color to the div that contains the logo image" => "A legacy option to add a background color to the div that contains the logo image",
"Examples" => "Exemples",
"Logo title (on mouseover)" => "Títol del Logo (el passar el punter del ratolí per sobre)",
// "This appears as tool tip text. The site logo is also a link to the site index (top page)" => "This appears as tool tip text. The site logo is also a link to the site index (top page)",
"HTML \"alt\" tag description" => "Descripció alt. (p.e. per navegadors basats en text)",
// "Normally a description of the image, such as \"Example.com logo\"" => "Normally a description of the image, such as \"Example.com logo\"",
// "Used by text browsers, screen readers, etc" => "Used by text browsers, screen readers, etc",
// "Site icon" => "Site icon",
// "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space" => "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space",
// "Recommended image height: 32 pixel" => "Recommended image height: 32 pixel",
// "Sitemap protocol" => "Sitemap protocol",
// "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines" => "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines",
"Include Smarty notices in the PHP error report" => "Inclou avisos setciències en informe d'errors PHP",
"In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur" => "En la majoria dels casos, els avisos de Smarty no poden ser ignorats. No obstant això, poden ser útils en el procés de desenvolupament quan es produeixen problemes estranys",
// "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages" => "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages",
// "Smarty security" => "Smarty security",
"Do not allow PHP code in Smarty templates" => "No permetre que el codi PHP a les plantilles Smarty",
"You should leave this on unless you know what you are doing" => "Hauries de deixar això marcat a menys que sàpigues el que estàs fent",
"Extra Smarty modifiers" => "Modificadors setciències extra",
"Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates." => "Fer funcions de PHP addicionals disponibles com a modificadors de setciències. Pot ser necessari per a plantilles personalitzades",
"There may be security implications. Make sure you know what you are doing" => "Pot haver implicacions de seguretat. Assegureu-vos que sap el que està fent",
// "Extra Smarty functions" => "Extra Smarty functions",
"Make additional PHP functions available as Smarty functions. This may be needed for custom templates" => "Fer funcions de PHP addicionals disponibles com a funcions setciències. Pot ser necessari per a plantilles personalitzades",
// "Extra Smarty directories" => "Extra Smarty directories",
// "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)" => "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)",
"Smarty compilation" => "Compilació de Smarty",
"Indicates when the template cache should be refreshed" => "Indica quan la memòria cau de les plantilles ha de ser renovada",
"Modified" => "Modificat",
"Never check (performance)" => "Mai revisar (rendiment)",
"Always (development, slow)" => "Sempre (desenvolupament lent)",
// "Smarty cache permissions" => "Smarty cache permissions",
// "Permissions that enable Smarty to write to the templates_c directory" => "Permissions that enable Smarty to write to the templates_c directory",
// "User writable (0644)" => "User writable (0644)",
// "User & group writable (0664)" => "User & group writable (0664)",
"Social network type" => "Tipus de Xarxa social",
"Select how the friendship relations within the social network should be treated" => "Selecciona com les relacions d'amistat dins la xarxa social haurien de ser tractades",
"Follow (as in Twitter)" => "Segueix-lo/la (com a Twitter)",
"Friend (as in Facebook)" => "Amic/ga (com a Facebook)",
"Followers need approval" => "Els seguidors necessiten aprovació",
"Consumer key" => "Clau del Consumidor",
"Consumer key generated by registering this Tiki site as an application at Twitter" => "Clau del Consumidor generada pel registre del seu lloc com una sol·licitud a Twitter",
"Consumer secret" => "Secret del Consumidor",
"Consumer secret generated by registering this Tiki site as an application at Twitter" => "Secret Consumidor genera mitjançant el registre del seu lloc web com una aplicació a Twitter",
// "Twitter site name" => "Twitter site name",
// "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title" => "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title",
// "Twitter site image" => "Twitter site image",
// "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL" => "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL",
"Application secret" => "Secret de l'aplicació",
"Application secret generated by registering this Tiki site as an application at Facebook" => "Secret de l'aplicació generada mitjançant el registre del seu lloc com una aplicació a Facebook",
"Application ID" => "ID d'aplicació",
"Application ID generated by registering this Tiki site as an application at Facebook" => "ID de l'aplicació generada pel registre del seu lloc com una aplicació a Facebook",
// "Facebook site name" => "Facebook site name",
// "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title" => "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title",
// "Facebook site image" => "Facebook site image",
// "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices" => "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices",
"Login using Facebook" => "Connectar-se a Facebook",
"Allow users to log in using Facebook" => "Permetre que els usuaris iniciar sessió a Facebook",
"Auto-create Tiki user" => "Creació automàtica d'usuaris Tiki",
"Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Creació automàtica d'un usuari Tiki pel nom d'usuari de fb_xxxxxxxx per als usuaris iniciar sessió en l'ús de Facebook, si encara no tenen un compte de Tiki. Si no, es demanarà vincular o registrar un compte de Tiki",
// "Require Facebook users to enter local account info on creation" => "Require Facebook users to enter local account info on creation",
"Require Facebook users to enter local account info, specifically email and local log-in name" => "Exigir als usuaris de Facebook per entrar informació de compte local, específicament de correu electrònic i el nom d'inici de sessió local",
// "Tiki can post to the Facebook wall" => "Tiki can post to the Facebook wall",
// "Tiki may post status messages, notes, photos, and videos to the Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to the Facebook Wall",
"Tiki can manage events" => "Tiki pot gestionar esdeveniments",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
"Tiki can manage pages" => "Tiki pot administrar pàgines",
"Tiki can manage user pages." => "Tiki pot administrar les pàgines d'usuari",
"Tiki can SMS" => "Tiki pugui SMS",
"Tiki can use SMS functions via Facebook." => "Tiki pot SMS a través de Facebook",
// "Set user email from Facebook on creation" => "Set user email from Facebook on creation",
// "Create a user tracker item on registration" => "Create a user tracker item on registration",
// "First and last name tracker field IDs to set on creation" => "First and last name tracker field IDs to set on creation",
// "bit.ly login" => "bit.ly login",
"Site-wide log-in name (username) for bit.ly" => "Lloc gran inici de sessió (nom d'usuari) per bit.ly",
// "bit.ly key" => "bit.ly key",
"Site-wide API key for bit.ly" => "Clau d'API gran lloc per bit.ly",
"Use site-wide account" => "Utilitza el compte de tot el lloc",
// "When set to \"yes\", only the site-wide account will be used for all users" => "When set to \"yes\", only the site-wide account will be used for all users",
// "Client ID" => "Client ID",
// "Client ID generated by registering this site as an application at LinkedIn" => "Client ID generated by registering this site as an application at LinkedIn",
// "Client secret" => "Client secret",
// "Client Secret generated by registering this site as an application at LinkedIn" => "Client Secret generated by registering this site as an application at LinkedIn",
// "Log in using LinkedIn" => "Log in using LinkedIn",
// "Allow users to log in using LinkedIn" => "Allow users to log in using LinkedIn",
// "Auto-create Tiki user from LinkedIn" => "Auto-create Tiki user from LinkedIn",
// "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Set user email from LinkedIn on creation" => "Set user email from LinkedIn on creation",
// "Tiki will set the user's email from Facebook on creation" => "Tiki will set the user's email from Facebook on creation",
// "Sets whether a tracker item should be created for the user upon registration" => "Sets whether a tracker item should be created for the user upon registration",
// "Comma-separated, with first name field followed by last name field; for example, '2,3'" => "Comma-separated, with first name field followed by last name field; for example, '2,3'",
// "Tiki will set the user's email from LinkedIn on creation" => "Tiki will set the user's email from LinkedIn on creation",
// "Stored searches" => "Stored searches",
// "Allow users to store search queries" => "Allow users to store search queries",
"Expose Jitsi provision URL" => "Exposa l'URL de provisió de Jitsi",
"Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server" => "Proporciona la informació de configuració per als usuaris de Jitsi perquè es puguin connectar a un servidor de missatgeria instantània de la comunitat/organització",
// "Jitsi configuration" => "Jitsi configuration",
"Content of a Jitsi-format Java properties file" => "Contingut del fitxer de propietats de Java seguint el format de Jitsi",
// "Location where tracker attachment files are stored" => "Location where tracker attachment files are stored",
// "Filesystem" => "Filesystem",
// "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory" => "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory",
// "Site theme" => "Site theme",
// "Icons of the displayed theme" => "Icons of the displayed theme",
// "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com" => "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com",
// "Site theme option" => "Site theme option",
// "Supplemental style sheet for the selected theme" => "Supplemental style sheet for the selected theme",
// "theme option, theme-option, style option, options, css" => "theme option, theme-option, style option, options, css",
// "Custom theme URL" => "Custom theme URL",
// "Local or external URL of the custom Bootstrap-compatible CSS file to use" => "Local or external URL of the custom Bootstrap-compatible CSS file to use",
// "Admin theme" => "Admin theme",
// "Theme for the settings panels and other administration pages" => "Theme for the settings panels and other administration pages",
// "Admin theme option" => "Admin theme option",
// "Option theme includes main theme CSS" => "Option theme includes main theme CSS",
// "Don't include the main theme stylesheet because its contents are included in the option stylesheet" => "Don't include the main theme stylesheet because its contents are included in the option stylesheet",
// "Navbar background color" => "Navbar background color",
// "Dark" => "Dark",
// "Light" => "Light",
// "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme" => "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme",
// "Fixed topbar offset" => "Fixed topbar offset",
// "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content" => "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content",
// "topbar offset, top offset, fixed topbar, top padding, offset" => "topbar offset, top offset, fixed topbar, top padding, offset",
"Icons" => "Icones",
// "Icon set used by the site" => "Icon set used by the site",
// "Theme Customizer tool" => "Theme Customizer tool",
// "Activate the theme customizer tool to enable easy theme customization" => "Activate the theme customizer tool to enable easy theme customization",
"Check frequency" => "Freqüència de comprovació",
// "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. " => "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. ",
// "Click \"Check for Updates Now\" to perform an update check" => "Click \"Check for Updates Now\" to perform an update check",
"Each day" => "Cada dia",
"Each week" => "Cada setmana",
"Each month" => "Cada mes",
"Upgrade cycle" => "Cicle d'actualitzacions",
// "Tiki upgrade frequency for this site to check against" => "Tiki upgrade frequency for this site to check against",
"Regular (8 months)" => "Regular (8 mesos)",
"Long-Term Support" => "Long-Term Support",
"Minify JavaScript" => "Minify JavaScript",
"Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Comprimir arxius de JavaScript utilitzats en la pàgina en un únic arxiu per a la seva distribució estàtica. Els canvis en els arxius JavaScript requeriran que s'esborri la memòria cau. Utilitza http://code.google.com/p/minify/",
// "Minify late JavaScript" => "Minify late JavaScript",
// "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page" => "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page",
"Minify CSS" => "Minimitza els CSS",
// "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared" => "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared",
// "Uses http://code.google.com/p/minify/" => "Uses http://code.google.com/p/minify/",
"Minify CSS into a single file" => "Minimitza els CSS en un sol arxiu",
"In addition to reducing the size of the CSS files, reduce the number of files by consolidating them" => "A més de reduir la mida de la CSS, redueix el nombre d'arxius inclosos",
"This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"" => "Aquesta configuració pot no funcionar a la primera per a tots els estils. La importació necessita emprar @import url(\"...\") i no @import \"...\"",
// "Prefix CSS" => "Prefix CSS",
// "Use -prefix-free JavaScript library to add vendor specific css prefixes" => "Use -prefix-free JavaScript library to add vendor specific css prefixes",
// "May be replaced by a server-side option soon" => "May be replaced by a server-side option soon",
"Skip date for same day" => "Evita la data per al mateix dia",
"When displaying short date and time, skip date for today. Only time will be displayed" => "Quan es mostra la data i l'hora curtes, saltat la data per a avui. Només es mostrarà el temps",
"Cache-control header" => "Capçalera Cache-Control",
"Custom HTTP header to use when a session is active" => "Capçalera HTTP personalitzada a utilitzar quan una sessió està activa",
"Example: no-cache, pre-check=0, post-check=0" => "Exemple: no-cache, pre-check=0, post-check=0",
"Cache-control header (no session)" => "Capçalera Cache-Control (sense període de sessions)",
"Custom HTTP header to use when no session is active" => "Custom capçalera HTTP a utilitzar quan no hi ha una sessió activa",
// "Content delivery networks" => "Content delivery networks",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance",
// "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com",
// "Content delivery networks in SSL" => "Content delivery networks in SSL",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode",
// "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com",
// "Check CDN files exists" => "Check CDN files exists",
// "Check that minified JS and CSS files exist before including them in the page" => "Check that minified JS and CSS files exist before including them in the page",
"Domain prefix handling" => "Maneig prefix de domini",
"Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Elimina o automàticament afegeix el prefix \"www.\" en els noms de domini d'estandarditzar URLs",
"Leave as-is" => "Deixar com està",
"Remove the www" => "Traieu la www",
"Add the www" => "Afegiu la www",
"Domain redirects" => "Redireccions de domini",
"When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "Quan s'accedeix al lloc a través dels noms de domini específics, redirigir a un domini alternatiu preservant la URL. Útil per les transicions de noms de domini, com tikiwiki.org a tiki.org",
"One entry per line, with each entry a comma-separated list: old domain, new domain" => "Una entrada per línia. Vell, nou: llista separada per comes",
"Validate uploaded file content" => "Validar el contingut del fitxer pujat",
"Do not trust user input and open the files to verify their content" => "No confiï en la entrada de l'usuari i obrir els arxius per verificar el seu contingut",
"Allow the tiki_p_trust_input permission" => "Permetre el permís tiki_p_trust_input",
"Bypass user input filtering." => "Ignora la entrada de l'usuari de filtratge",
"Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Tingueu en compte que tots els permisos es concedeixen al grup Administradors inclòs aquest, per la qual cosa si s'habilita aquesta pot exposar al seu lloc de XSS (Cross Site Scripting) els atacs d'usuaris administradors",
// "Object selector threshold" => "Object selector threshold",
// "Number of records after which the object selectors will request searching instead of selecting from a list" => "Number of records after which the object selectors will request searching instead of selecting from a list",
// "Object selector search field" => "Object selector search field",
// "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")" => "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")",
// "Client key for this site" => "Client key for this site",
// "This must match the shared key entered in the Master’s key field" => "This must match the shared key entered in the Master’s key field",
// "Synchronize remote tracker" => "Synchronize remote tracker",
"Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand" => "Permet clonar un un formulari-bd en un host remot i sincronitzar les dades de forma local a la demanda",
"Refresh item link items when the master is modified" => "Actualitzar els ítems d'enllaç a altres ítems quan es modifica el mestre",
"To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "Per ser utilitzat quan l'enllaç a l'ítem s'utilitza en formularis-bd de manera que l'índex es manté en bona forma quan es modifiquen les dades en el mestre que està indexat amb el detall i s'utilitza per a seguir cercant",
// "Refresh items list items when related items are created or modified" => "Refresh items list items when related items are created or modified",
// "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified" => "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified",
"Clone tracker items" => "Clonar ítems del formulari-bd",
"Allow copying tracker item information to a new tracker item" => "Permetre copiar informació de l'ítem del formulari-bd en un nou ítem del formulari-bd",
"Trackers available for insertion from wiki pages" => "Formularis-bd (Trackers) disponibles per a la inserció d'ítems des de pàgines wiki",
"List of tracker IDs made available when attempting to insert" => "Llista d'IDs de Formularis-bd disponibles quan hi hagi intents d'inserció",
// "Change field types" => "Change field types",
// "Allow field type to be changed after creation" => "Allow field type to be changed after creation",
"Use with care" => "Empra-ho amb cura",
"Show comments below items" => "Mostra els comentaris sota els ítems",
"Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab" => "Mostra els comentaris a un ítem de formulari-bd sota el mateix ítem, enlloc d'incloure'ls dins una pestanya a part",
// "Use legacy tracker insertion screen" => "Use legacy tracker insertion screen",
// "Use the legacy tracker insertion screen (a tab) instead of a popup dialog" => "Use the legacy tracker insertion screen (a tab) instead of a popup dialog",
// "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful" => "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful",
// "Show tracker status in objectlink" => "Show tracker status in objectlink",
// "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs" => "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs",
// "Sync wiki page name to linked tracker field" => "Sync wiki page name to linked tracker field",
// "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation" => "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation",
// "Redirect page views to the linked tracker item" => "Redirect page views to the linked tracker item",
// "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL" => "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL",
// "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL" => "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL",
// "Tracker for articles" => "Tracker for articles",
// "Have a tracker to supplement article information" => "Have a tracker to supplement article information",
// "Tracker ID of tracker for articles" => "Tracker ID of tracker for articles",
// "A tracker for articles must contain an \"Articles\" field" => "A tracker for articles must contain an \"Articles\" field",
// "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items" => "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items",
// "Tracker tabular" => "Tracker tabular",
// "Allows management of import/export tracker profiles and management of custom list formats" => "Allows management of import/export tracker profiles and management of custom list formats",
// "Always notify watchers" => "Always notify watchers",
// "Send item updated notifications to watchers even if nothing has changed" => "Send item updated notifications to watchers even if nothing has changed",
// "Require users to fill in tracker information" => "Require users to fill in tracker information",
// "Tracker ID of tracker required to be filled in" => "Tracker ID of tracker required to be filled in",
// "Mandatory tracker field to check for required filling in" => "Mandatory tracker field to check for required filling in",
// "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it" => "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it",
// "Fields that are asked for in the modal for force-filling" => "Fields that are asked for in the modal for force-filling",
// "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested" => "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested",
// "Tracker item links use prefix alias" => "Tracker item links use prefix alias",
// "Links for tracker items will use the prefix alias automatically everywhere" => "Links for tracker items will use the prefix alias automatically everywhere",
// "Tracker report resize button" => "Tracker report resize button",
// "Add a button to resize long tracker reports" => "Add a button to resize long tracker reports",
// "Tracker list order" => "Tracker list order",
// "Default order for the main tracker list" => "Default order for the main tracker list",
// "Id Ascending" => "Id Ascending",
// "Id Descending" => "Id Descending",
"Created Ascending" => "Creat Ascendent",
"Created Descending" => "Creat Descendent",
"Name Ascending" => "Nom Ascendent",
"Name Descending" => "Nom Descendent",
// "Last Modified Ascending" => "Last Modified Ascending",
// "Last Modified Descending" => "Last Modified Descending",
// "Number of Items Ascending" => "Number of Items Ascending",
// "Number of Items Descending" => "Number of Items Descending",
// "Tracker History Diff Style" => "Tracker History Diff Style",
// "Default style for tracker history" => "Default style for tracker history",
"Original" => "Original",
// "Index article info in tracker item" => "Index article info in tracker item",
// "Require users to fill in a tracker form if not done already by prompting them with a modal dialog" => "Require users to fill in a tracker form if not done already by prompting them with a modal dialog",
// "Storage settings when file galleries are not used" => "Storage settings when file galleries are not used",
"Unified search engine" => "Motor de Cerca Unificada",
"Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server" => "Motor de cerca utilitza per indexar el contingut del seu Tiki. Alguns motors són més adequats per als llocs més grans, però requereixen un programari addicional al servidor",
// "Lucene (PHP implementation) - Deprecated" => "Lucene (PHP implementation) - Deprecated",
// "Elasticsearch" => "Elasticsearch",
"Lucene index location" => "Lucene Index Ubicació",
"Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Ruta d'accés a la ubicació de l'índex de cerca de Lucene. L'índex ha d'estar en un sistema de fitxers local amb suficient espai per contenir el volum de la base de dades",
"Highlight results snippets" => "Ressaltar fragments dels resultats",
"Highlight the result snippet based on the search query to improve user experience" => "Ressalteu el fragment del resultat basat en la consulta de la cerca. Activar aquesta opció afectarà el rendiment, però també millorarà l'experiència de l'usuari",
"Lucene maximum results" => "Màxims resultats de Lucene",
"Maximum number of results to produce. Results beyond these will need a more refined query to be reached" => "Nombre màxim de resultats per exposar. Resultats més enllà que aquests necessitaran d'una consulta més refinada",
// "results" => "results",
"Lucene maximum result-set limit" => "Límit del conjunt de resultats màxim de Lucene",
"Maximum size of result set to consider" => "Mida màxima de conjunt de resultats a considerar. Defecte 1000, 0 = sense límit",
"This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "Això s'utilitza en el càlcul de les puntuacions de resultat i l'ordre de classificació que poden conduir a errors de manca de memòria en conjunts de dades grans. El valor per omissió de 1000 és segur amb el memory_limit PHP s'estableix en 128M",
// "result sets" => "result sets",
"Lucene terms per query limit" => "Termes Lucene Per Límit de la consulta",
"Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "El nombre màxim de termes que es generin. Proveu augmentar aquest valor si es produeixen errors dient \"Termes límit per consulta s'arriba\" especialment amb cerques de amb comodins, de més abast i difuses",
// "terms" => "terms",
"Lucene maximum number of buffered documents" => "Lucene Max buffer Documents",
"Number of documents required before the buffered in-memory documents are written into a new segment" => "Nombre de documents requerits abans que els documents en memòria memòria intermèdia s'escriuen en un nou segment",
// "documents" => "documents",
"Lucene maximum number of merge documents" => "Lucene Max Documents Merge",
"Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Major nombre de documents mai es van fusionar per addDocument(). Els valors petits (per exemple, menys de 10.000) són els millors per a la indexació interactiva, el que limita la durada de les pauses, mentre que la indexació a uns pocs segons. Els valors més alts són els millors per a la indexació per lots i coses ràpidament",
"Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Els valors petits (per exemple, menys de 10.000) són els millors per a la indexació interactiu. Utilitzeu 0 per al valor predeterminat Lucene, que és pràcticament infinit",
// "merge documents" => "merge documents",
// "Default Boolean Operator" => "Default Boolean Operator",
"Use OR or AND as the default search operator" => "Utilitza OR (O, per omissió) o AND (I) com a l'operador de cerca predeterminat",
"AND" => "I (AND)",
"OR" => "O (OR)",
"Lucene merge factor" => "Lucene merge factor",
"How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster" => "Amb quina freqüència els índexs de segment es fusionen per addDocument(). Amb valors més petits, menys memòria RAM s'utilitza en indexar, i les cerques en índexs no optimitzats són més ràpides, però la velocitat d'indexació és més lenta. Amb valors més grans, s'utilitza més memòria RAM durant la indexació, i mentre que les cerques sobre índexs no optimitzats són més lentes, la indexació és més ràpida. Per tant els valors més grans (> 10) són els millors per a la creació de l'índex al rerafons (en procés per lots), i els valors més petits (<10) per a índexs que es mantenen de forma interactiva",
"Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained" => "Els valors grans (> 10) són els millors per a la creació de l'índex de lot, i els valors més petits (<10) per a índexs que es mantenen interactiva",
"Incremental Index Update" => "Actualització Incremental de l'Índex",
"Update the index incrementally as the site content is modified" => "Actualitza l'índex de forma incremental a mesura que el contingut del lloc es modifica. Això pot portar a un menor rendiment i precisió que el processament de l'índex en forma periòdica",
// "This may lead to lower performance and accuracy than processing the index on a periodic basis" => "This may lead to lower performance and accuracy than processing the index on a periodic basis",
"Field weights" => "Pesos del camp",
"Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results" => "Permet establir els pesos de camp que s'apliquen al classificar les pàgines de llista de cerca. El pes només s'aplica quan el camp està a la consulta. Per anul·lar el valor d'un camp, utilitzeu una quantitat insignificant, no és 0, el que pot donar lloc a comportaments inesperats, com els resultats de desbrossament",
// "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search" => "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search",
"One field per line, field_name__:__5.3" => "Un dels camps en cada línia, field_name__: __ 5.3",
"Default content fields" => "Camps de contingut per omissió",
"All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search" => "Tot el contingut que s'agrega al camp dels continguts. Per ponderació personalitzat per aplicar, els camps han d'estar presents en la consulta. Aquesta opció permet incloure altres camps en la cerca de contingut predeterminat",
"Tokenize version numbers" => "Token-itza els números de versió",
"Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Token-itza les cadenes de nombres de versió perquè les versions principals es troben quan es pronunciaran el seu nom sub-versions. Per exemple, la cerca de 2,7 tornaria documents que continguin 2.7.4, 1.2.7, però no",
// "Cache per user and query for Tiki built-in search" => "Cache per user and query for Tiki built-in search",
// "Time in minutes a user has a same query cached applied to Tiki built-in search interface only" => "Time in minutes a user has a same query cached applied to Tiki built-in search interface only",
"Index forum replies together with initial post" => "Índex del Fòrum replica juntament amb el pal de l'arrel",
"Forum replies will be indexed together with the initial post as a single document instead of being indexed separately." => "Si està habilitat, respon fòrum seran indexats juntament amb el missatge d'arrel en un sol document en lloc de ser indexats per separat",
// "Relation types to index within object" => "Relation types to index within object",
// "Comma-separated relation types for which objects should be indexed in their related objects" => "Comma-separated relation types for which objects should be indexed in their related objects",
// "Elasticsearch needed" => "Elasticsearch needed",
// "Cache individual search formatters" => "Cache individual search formatters",
// "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache" => "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache",
"Format to use for tracker field keys" => "Format d'usar per a les claus de camp del formulari-bd",
"Choose between field IDs and permanent names for the tracker indexing" => "Trieu entre els identificadors de camp i noms permanents per al seguiment de la indexació",
"Permanent name" => "Nom Permanent",
"Field ID (backward compatibility mode with Tiki 7 and 8)" => "ID Field (mode de compatibilitat amb versions anteriors de Tiki 7 i 8)",
// "Index Tracker Category names" => "Index Tracker Category names",
// "Index the names and paths of category field values" => "Index the names and paths of category field values",
// "Requires reindexing" => "Requires reindexing",
// "Cache result-specific formatted results" => "Cache result-specific formatted results",
// "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific" => "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific",
// "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature" => "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature",
"Excluded categories" => "Categories excloses",
"List of category IDs to exclude from the search index" => "Llista dels identificadors de categoria d'excloure l'índex de cerca",
"Excluded plugins" => "Plugins exclosos",
"List of plugin names to exclude while indexing" => "Llista dels noms dels plugins per excloure l'indexar",
// "Exclude all plugins" => "Exclude all plugins",
// "Indexing will exclude all plugins" => "Indexing will exclude all plugins",
// "Except included plugins" => "Except included plugins",
// "List of plugin names that are required to be included while indexing, when excluding all" => "List of plugin names that are required to be included while indexing, when excluding all",
// "Example: fancytable,list,trackerlist,trackerfilter" => "Example: fancytable,list,trackerlist,trackerfilter",
// "Elasticsearch URL" => "Elasticsearch URL",
// "URL of any node in the cluster" => "URL of any node in the cluster",
// "Elasticsearch index prefix" => "Elasticsearch index prefix",
// "The prefix that is used for all indexes for this installation in Elasticsearch" => "The prefix that is used for all indexes for this installation in Elasticsearch",
// "Elasticsearch current index" => "Elasticsearch current index",
// "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index" => "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index",
// "Do not change this value unless you know what you are doing" => "Do not change this value unless you know what you are doing",
// "Tokenize CamelCase words" => "Tokenize CamelCase words",
// "Consider the components of camel-case words as separate tokens, allowing them to be searched individually" => "Consider the components of camel-case words as separate tokens, allowing them to be searched individually",
// "Conflicts with Tokenize Version Numbers" => "Conflicts with Tokenize Version Numbers",
// "Elasticsearch field limit per index" => "Elasticsearch field limit per index",
// "fields" => "fields",
// "The maximum number of fields per search index in Elasticsearch version 5.x and above" => "The maximum number of fields per search index in Elasticsearch version 5.x and above",
// "Use MySQL Full-Text Search (fallback)" => "Use MySQL Full-Text Search (fallback)",
// "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback" => "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback",
// "MySQL full-text search current index" => "MySQL full-text search current index",
// "Unified index identifier fields (Internal)" => "Unified index identifier fields (Internal)",
// "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding" => "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding",
// "Use unified search in category admin" => "Use unified search in category admin",
// "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index" => "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index",
// "Stop Word List" => "Stop Word List",
// "Words excluded from the search index, because they can be too frequent and produce unwanted results" => "Words excluded from the search index, because they can be too frequent and produce unwanted results",
// "MySQL full-text search has its own list of stop words configured in the server" => "MySQL full-text search has its own list of stop words configured in the server",
// "Automatically trim Elasticsearch results on date-sorted query" => "Automatically trim Elasticsearch results on date-sorted query",
// "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date" => "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date",
// "Highlight results pages" => "Highlight results pages",
// "Highlight words on the result pages based on the search query" => "Highlight words on the result pages based on the search query",
// "Plugins tab of the textarea control panel loads with an empty list" => "Plugins tab of the textarea control panel loads with an empty list",
// "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially" => "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially",
// "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")" => "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")",
// "Possessive Stemmer" => "Possessive Stemmer",
// "LIST plugin cache default on" => "LIST plugin cache default on",
// "If selected, LIST plugins will be cached by default unless turned off at plugin level" => "If selected, LIST plugins will be cached by default unless turned off at plugin level",
// "LIST plugin cache default expiry" => "LIST plugin cache default expiry",
// "Default number of minutes for LIST plugin cache expiry" => "Default number of minutes for LIST plugin cache expiry",
// "The possessive stemmer removes possessives (trailing \"'s\\" => "The possessive stemmer removes possessives (trailing \"'s\\",
"Re-validate user by email after" => "Torneu a validar usuari per correu electrònic després de",
"unsuccessful login attempts" => "intents fallits d'ingressar",
// "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password" => "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password",
// "brute force, brute-force, login failure, login-failure, failed logins" => "brute force, brute-force, login failure, login-failure, failed logins",
"Suspend account after" => "Suspendre el compte després de",
// "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again",
"URL the user is redirected to after account validation" => "URL a la que és redireccionat un usuari després de la validació del compte",
// "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"" => "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"",
"Account validated successfully." => "Compte validat satisfactòriament.",
"The URL that the anonymous user is redirected to when a page is not found" => "URL a la que es redirigeix a un usuari anònim ​​quan no es troba la pàgina",
// "Use Only ASCII in SEFURLs" => "Use Only ASCII in SEFURLs",
// "Do not use accented characters in short (search engine friendly) URLs" => "Do not use accented characters in short (search engine friendly) URLs",
// "Close site when server load is above the threshold" => "Close site when server load is above the threshold",
"Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site" => "Tancament del lloc quan la càrrega del servidor està per sobre del llindar (a excepció d'aquells amb permís)",
"Use proxy" => "Empra proxy",
"Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified" => "Empra proxy",
"Use context menus for actions (icons)" => "Utilitza els menús de context d'acció (icones)",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
"Use context menus for actions (text)" => "Utilitza els menús de context de les accions (de text)",
// "Show user's real name" => "Show user's real name",
"Show the user's real name instead of username (log-in name), when possible." => "Mostra el veritable nom d'usuari en lloc d'inici de sessió (quan sigui possible)",
// "User emails must be unique" => "User emails must be unique",
// "The email address of each user must be unique" => "The email address of each user must be unique",
"Display user tracker information on the user information page" => "Mostrar informació UserFormulari-bd (Tracker) a la pàgina d'informació de l'usuari",
"Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "L'usuari d'entrada formulari-bd ID continuació identificadors de camp que es mostra, totes separades per comes. Exemple: 1,1,2,3,4 (user ID formulari-bd 1 seguit de camp IDs 1-4)",
"Users can configure modules" => "Els usuaris poden configurar mòduls",
// "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user" => "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user",
"Users can open and close the modules" => "Els usuaris poden donar ombra als mòduls",
"Allows users to open and close modules using the icon in the module header" => "Permet als usuaris ocultar / mostrar els mòduls",
"Module decides" => "Mòdul decideix",
"Store full-size copy of profile picture in file gallery" => "Deseu còpia de mida completa d'avatar a la galeria arxiu",
// "Size of the small profile picture stored for users" => "Size of the small profile picture stored for users",
// "Crop the profile picture thumbnail to a square" => "Crop the profile picture thumbnail to a square",
"File gallery in which to store full-size profile picture" => "Fitxa Galeria per emmagatzemar còpies de mida completa d'avatar en",
"Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Introduïu l'ID d'galeria aquí. Si us plau, creeu una galeria dedicada que és admin-només per a la seguretat, o assegureu-vos que els permisos galeria s'estableixen de manera que només els administradors poden editar",
"File ID of default profile picture" => "ID de l'arxiu imatge d'avatar per omissió",
"File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries" => "Imatge ID Arxiu d'utilitzar a la galeria arxiu com l'avatar si l'usuari no té cap imatge avatar en galeries d'arxius",
"Display who has viewed \"my items\" on the user information page" => "Mostra que van veure els meus coses a la pàgina d'informació de l'usuari",
"This requires activation of tracking of views for various items in the action log" => "Hauràs d'activar el seguiment de les opinions de diversos temes en el registre de l'acció perquè això funcioni",
// "Length of \"who viewed my items\" history" => "Length of \"who viewed my items\" history",
"Number of days before the current day to consider when displaying \"who viewed my items\"" => "Nombre de dies abans de l'hora actual a considerar en mostrar que van veure els meus coses",
"Show to others \"who viewed my items\" on the user information page" => "Mostrar als altres que van veure els meus coses a la pàgina d'informació de l'usuari",
"Show to others \"who viewed my items\" on the user information page. Admins can always see this information" => "Mostrar als altres que van veure els meus coses a la pàgina d'informació de l'usuari. Administradors sempre poden veure aquesta informació",
"Use pretty trackers for registration form" => "Utilitza formularis-bd bonics per al formulari d'inscripció",
"Registration pretty tracker template" => "Registre bonica plantilla de seguiment",
"Use a wiki page name or Smarty template file with a .tpl extension." => "Utilitza el nom de la pàgina wiki o un arxiu de plantilla amb l'extensió .tpl",
// "Hide Mandatory" => "Hide Mandatory",
// "Hide mandatory fields indication with an asterisk (shown by default)" => "Hide mandatory fields indication with an asterisk (shown by default)",
"Output the registration results" => "Mostrar els resultats de registre",
"Use a wiki page as template to output the registration results to" => "Utilitza una pàgina wiki com a plantilla per a la sortida dels resultats del registre de",
"Output registration pretty tracker template" => "Registre de plantilla de seguiment bastant de sortida",
"Wiki page only" => "Pàgina Wiki només",
"Page name field ID" => "Nom de la pàgina fieldID",
"User tracker IDs to sync prefs from" => "El ID del formulari-bd dels usuaris amb el què sincronitzar-hi les preferències",
"Select one or more trackers to sync user preferences from" => "Introdueixi els ID separats per comes dels formularis-bd amb els que sincronitzar-hi les preferències d'usuaris",
"Tracker field IDs to sync the \"real name\" pref from" => "ID del camp del Formulari-bd amb el que sincronitzar-hi la preferència de Nom Real",
"Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"." => "Introdueixi els ID separats per comes en la prioritat de ser elegit, cada element pot concatenar diversos camps utilitzant +, per exemple, 2 +3,4",
// "Tracker field IDs to sync user groups" => "Tracker field IDs to sync user groups",
// "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups" => "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups",
"Synchronize long/lat/zoom to location field" => "Sincronitzar long/lat/zoom al camp d'ubicació",
"Synchronize user geolocation preferences with the main location field." => "Sincronitzar prefs geolocalització usuari de camp d'ubicació principal",
"Change user system language when changing user tracker item language" => "Canvia l'idioma del sistema de l'usuari quan es canvia l'idioma del registre de l'usuari al formulari-bd d'usuaris",
"Assign a user tracker item when registering if email equals this field" => "Assignar un element del registre d'usuari quan es registra si el correu electrònic és igual a aquest camp",
// "Maximum users in drop-down lists" => "Maximum users in drop-down lists",
// "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large" => "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large",
"users" => "usuaris",
"Use the user's real name instead of log-in name in the autocomplete selector in trackers" => "Utilitza el veritable nom d'usuari en lloc del de l'inici de sessió (login) en el selector de funció autocompletar dels formularis-bd",
"Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature." => "Utilitza el veritable nom d'usuari en lloc del de l'inici de sessió (login) al gestor d'autocompletar en funció de missatgeria",
// "User favorites" => "User favorites",
"Enable users to flag content as their favorite" => "Permet als usuaris marcar el contingut com el seu favorit",
// "User likes" => "User likes",
// "Enable users to \"like\" content" => "Enable users to \"like\" content",
"Users must choose a group at registration" => "Els usuaris han de triar un grup en el registre",
"Users cannot register without choosing one of the groups indicated above" => "Els usuaris no poden registrar-se sense triar un dels grups definits anteriorment",
"Users available in search results" => "Usuaris disponibles en els resultats de cerca",
"Users available within search results. Content related to the user will be included in the index" => "Usuaris disponibles dins dels resultats de cerca. El contingut relacionat amb l'usuari s'inclourà en l'índex",
"Public" => "Públic",
"Use Gravatar for user profile pictures" => "Utilitza Gravatar per als avatars d'usuaris",
"Always request the Gravatar image for the user profile picture" => "Sol·licitar sempre la imatge gravatar per l'avatar de l'usuari",
// "Configuration for multilike" => "Configuration for multilike",
// "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)" => "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)",
// "Force users to upload an avatar" => "Force users to upload an avatar",
"Score ascending" => "Ascendent per puntuació",
"Score descending" => "Descendent per puntuació",
"Name ascending" => "Ascendent per Nom de l'Usuari",
"Name descending" => "Descendent per Nom de l'Usuari",
"Login ascending" => "Ascendent per Nom de Connexió d'usuari",
"Login descending" => "Descendent per Nom de Connexió d'usuari",
"User the tracker's field ID whose value is used as the output page name." => "Formulari-bds d'Usuari ID camp el valor s'utilitza com a sortida de nom de la pàgina",
// "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup" => "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup",
"Quota" => "Quota",
"Private" => "Privat",
"Users cannot see each other's files or galleries" => "Els usuaris no poden veure els arxius o galeries dels altres",
"Users can see each other's files, but don't see the galleries in listings" => "Els usuaris poden veure els arxius de cada un, però no veuen les galeries d'anuncis",
"Username pattern" => "Patró de nom d'usuari",
// "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/" => "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/",
"Serve profile pictures statically" => "Servir imatges d'avatar estàticament",
"When enabled, feature checks and permission checks will be skipped" => "Quan està activat, el control de característiques i controls de permís s'ometran",
"Displayed time zone" => "Zona horària mostrada",
"Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "Utilitza la zona horària especificada a les preferències de l'usuari, o la zona horària detectada automàticament per a usuaris anònims (si el navegador ho permet). El valor per omissió del lloc web és el que s'empra com a reserva",
"Always the site default time zone" => "Sempre la zona horària per omissió del lloc",
"Number of visited pages to remember" => "Quantitat de pàgines visitades a recordar",
// "visited pages" => "visited pages",
"User information" => "Informació d'usuari/a",
// "Specify if the user's information is public or private" => "Specify if the user's information is public or private",
"Use 12-hour clock for time selectors" => "Utilitza format de 12 hores per als selectors de temps",
"Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc" => "Utilitza el rellotge de 12 hores (amb AM i PM) per als selectors de temps utilitzats en algunes finestres d'edició per ajustar l'hora de la publicació de blocs nous o editats, articles, etc",
"Use interface that shows differences in any versions" => "Utilitza el nou diff qualsevol versió",
"Tasks per page" => "Tasques per pàgina",
// "tasks" => "tasks",
"20" => "20",
"40" => "40",
"50" => "50",
"Messages per page" => "Missatge per pàgina",
"Allow messages from other users" => "Permetre missatges d'altres usuaris",
"Notify sender when reading mail" => "Notificar al remitent quan llegir el correu",
"Send me an email for messages with priority equal to or greater than" => "Envia'm un email per els missatges amb prioritat més gran o igual que",
// "priority" => "priority",
"Auto-archive read messages after" => "Auto-archive llegir missatges després",
// "The number of days after which Tiki will archive the messages that have been read by the user" => "The number of days after which Tiki will archive the messages that have been read by the user",
"60" => "60",
"My pages" => "Les meves pàgines",
// "List all wiki pages edited by the user" => "List all wiki pages edited by the user",
"My blogs" => "Els meus blocs",
// "List all blogs and blog posts edited by the user" => "List all blogs and blog posts edited by the user",
"My galleries" => "Les meves galeries",
// "List all galleries edited by the user" => "List all galleries edited by the user",
"My messages" => "Els meus missatges",
// "List all messages and replies by the user" => "List all messages and replies by the user",
"My tasks" => "Les meves tasques",
// "List all tasks by the user" => "List all tasks by the user",
"My forum topics" => "Els meus tòpics de fòrums",
// "List all forum topics by the user" => "List all forum topics by the user",
"My forum replies" => "Les meves respostes de fòrums",
// "List all forum replies by the user" => "List all forum replies by the user",
"My items" => "Els meus ítems",
// "List all tracker items by the user" => "List all tracker items by the user",
"Character set for mail" => "Joc de caràcters per al correu",
// "Keep closed remarksbox hidden" => "Keep closed remarksbox hidden",
// "XMPP account JID or username" => "XMPP account JID or username",
// "XMPP account password" => "XMPP account password",
// "XMPP http-bind URL" => "XMPP http-bind URL",
// "Full URL to the http-bind" => "Full URL to the http-bind",
// "https://xmpp.example.org/http-bind/" => "https://xmpp.example.org/http-bind/",
"Pre-set show user's info on mouseover" => "Preconfigura que es mostri la informació de l'usuari en passar el punter del ratolí per sobre",
// "Set new users' info to display in a popup when their name is hovered over" => "Set new users' info to display in a popup when their name is hovered over",
// "Remember the alert boxes that users have closed and don't display them again" => "Remember the alert boxes that users have closed and don't display them again",
"Validator emails (separated by comma) if different than the sender email" => "Correus electrònics Validator (separats per coma) si és diferent a l'adreça de correu electrònic del remitent",
// "Vimeo upload" => "Vimeo upload",
// "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API" => "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API",
// "Vimeo delete" => "Vimeo delete",
// "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted" => "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted",
// "Permanently removes videos from the registered vimeo.com account" => "Permanently removes videos from the registered vimeo.com account",
// "Vimeo consumer key" => "Vimeo consumer key",
// "API consumer key" => "API consumer key",
// "Vimeo consumer secret" => "Vimeo consumer secret",
// "API consumer secret" => "API consumer secret",
// "Vimeo access token" => "Vimeo access token",
// "The access token that is automatically generated by Vimeo when API keys are requested" => "The access token that is automatically generated by Vimeo when API keys are requested",
// "Vimeo access token secret" => "Vimeo access token secret",
// "The access token secret automatically generated by Vimeo when API keys are requested" => "The access token secret automatically generated by Vimeo when API keys are requested",
// "Vimeo Default Gallery" => "Vimeo Default Gallery",
// "The The ID of the default file gallery in which to store the Vimeo reference" => "The The ID of the default file gallery in which to store the Vimeo reference",
"Display by default" => "Mostra-ho per omissió",
"Path (if stored in directory)" => "Ruta (si s'està emmagatzemant al directori)",
"Edit idle timeout" => "edita temps de desconnexió",
// "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains" => "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains",
// "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually" => "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually",
// "How to trigger Web Cron" => "How to trigger Web Cron",
// "Calling the Web Cron URL" => "Calling the Web Cron URL",
// "Adding JavaScript that calls Web Cron" => "Adding JavaScript that calls Web Cron",
// "URL and JavaScript" => "URL and JavaScript",
// "Run interval" => "Run interval",
// "The amount of time of each run" => "The amount of time of each run",
"Token" => "Token",
// "The token to use when running the cron manually" => "The token to use when running the cron manually",
// "Default cache" => "Default cache",
// "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response" => "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response",
// "Last Modified" => "Last Modified",
"Last editor" => "Darrer editor",
"Wiki link format" => "Format d'enllaç Wiki",
"Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))" => "Quin nivell de caràcters especials s'accepten com enllaços wiki per noms de pàgines. Ex:. ((Pàgina EAI))",
"\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"" => "Estricte només hi haurà personatges bàsics com a-z i 0-9. Si tens caràcters accentuats o especials en els noms de pàgina, no s'ha d'utilitzar Estricte",
"Complete" => "Complet",
"Relaxed" => "Relaxat",
"Strict" => "Estricte",
// "Wiki URL scheme" => "Wiki URL scheme",
// "Alter the SEFURL pattern for page names" => "Alter the SEFURL pattern for page names",
// "Use the \"View\" action to regenerate your URLs after changing this setting" => "Use the \"View\" action to regenerate your URLs after changing this setting",
// "Show the page version" => "Show the page version",
"Display the page version information when viewing the page" => "Mostra la informació de versió de la pàgina quan es visualitza la pàgina",
// "Display the page name above the page area" => "Display the page name above the page area",
"Display the page name in small text at the top of each page (above the page's content)." => "Nom per mostrar la pàgina anterior pàgina en lloc de la pàgina a l'interior",
// "Display the page name inside the page content" => "Display the page name inside the page content",
"Page name display stripper" => "Separador a la Visualització del nom de pàgina",
"The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "Caràcter a emprar com a delimitador en el nom de la pàgina. La porció del nom després d'aquest caràcter no serà mostrada. Si el separador a la visualització del nom de pàgina entra en conflicte amb el separador de l'espai de noms, s'empra l'espai de noms i la visualització del nom de pàgina no es mostra separada",
"Wiki author list style" => "Estil de llista per als autors Wiki",
"Change the list format that is used to display the authors of the page." => "Canvia el format de la llista que s'utilitza per mostrar els autors de la pàgina",
"Creator and Author" => "Creador i Autor",
"Business style" => "Estil de Negocis",
"Collaborative style" => "Estil col·laboratiu",
"Page last modified on" => "Darrera modificació de la pàgina el",
"none (disabled)" => "cap (deshabilitat)",
"Specify wiki author list style per page" => "Especifica per pàgina l'estil de llista dels autors wiki",
"Enable the style in which the author list is displayed to be modified on a per-page basis" => "Permet modificar per pàgina l'estil en el qual es mostra la llista d'autors",
"Wiki page edit buttons location" => "Localització de barra d'accions Wiki",
"Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page" => "Botons: Guardar, Vista prèvia, Cancel, ..",
"Wiki navigation bar location" => "Localització de la barra de navegació Wiki",
"When using the ...page... page break wiki syntax" => "Quan s'utilitza ...page... com a sintaxi wiki de salt de pàgina",
"Wiki top line location" => "Ubicació de la línia superior al Wiki",
// "Page description, page actions, icons, backlinks..." => "Page description, page actions, icons, backlinks...",
// "Display ShareThis icon prominently" => "Display ShareThis icon prominently",
// "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)" => "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)",
"Cache wiki pages (global)" => "Posar les pàgines wiki en memòria cau (global)",
"Enable page cache globally for wiki pages" => "Habilita memòria cau de pàgines a nivell global per les pàgines wiki",
"no cache" => "Sense memòria cau",
"Allow comments per wiki page" => "Permetre comentaris per pàgina wiki",
"Enable control of comments on wiki pages on a per-page basis." => "Activeu el control dels comentaris a les pàgines wiki individuals",
"Enable (default On)" => "Activar (per omissió Activat - On)",
"Enable (default Off)" => "Activar (per omissió Desactivat - Off)",
// "Wiki copyright" => "Wiki copyright",
"Prevent special characters in page names" => "Eviteu caràcters especials en els noms de pàgina",
"Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters" => "Alguns personatges poden evitar que les pàgines de ser fàcilment accessible des de la URL o mitjançant enllaços wiki. Aquesta opció impedeix crear pàgines amb tals caràcters",
"Page ranking reload probability" => "Pàgina rànquing de probabilitat de recàrrega",
"Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking" => "Càlcul de les classificacions de la pàgina és una tasca costosa que no es pot realitzar en cada càrrega de pàgina. Es calcula a carregar la pàgina aleatoris basats en una tirada de daus. Aquesta opció indica la quantitat de cares dels daus. Els números més alts condueixen a una menor càrrega, però menys precisa classificació",
"Encourage contribution to wiki pages by anonymous" => "Fomentar la contribució de les pàgines wiki per anònim",
"When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page" => "Quan una pàgina no es pot editar i l'usuari és anònim, mostrar els enllaços editar totes maneres. El visitant es mostrarà una pantalla d'inici de sessió i ser encoratjats a registrar",
"Warn before page lock timeout" => "Avisar abans de la pàgina de temps d'espera de bloqueig",
"Provide a JavaScript alert before the user's lock on a page times out" => "Proporcionar un avís de JavaScript abans de bloqueig de l'usuari en una pàgina de temps d'espera",
"Dynamic variables" => "Variables dinàmiques",
"Global snippets of text that can be included in wiki pages and edited in place" => "Retalls globals de text que es poden incloure en les pàgines wiki i editar en el lloc",
"Single (%varname%)" => "Únic/a (%varname%)",
"Double (%%varname%%)" => "Doble (%%varname%%)",
"Multilingual dynamic variables" => "Variables dinàmiques multilingües",
"Make dynamic variable content language-specific" => "Fes que el contingut de les variables dinàmiques sigui específic per a cada idioma",
// "Allow plugin-specific edits" => "Allow plugin-specific edits",
// "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page" => "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page",
// "This feature is unavailable outside wiki pages, whether or not this preference is enabled" => "This feature is unavailable outside wiki pages, whether or not this preference is enabled",
// "Allow section-specific edits" => "Allow section-specific edits",
// "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section" => "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section",
// "Section-specific edits maximum level" => "Section-specific edits maximum level",
// "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections" => "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections",
// "Only display focused edit icons (for sections and/or plugins) on request" => "Only display focused edit icons (for sections and/or plugins) on request",
// "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page" => "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page",
"Allow minor edits of wiki pages" => "Permetre edicions menors de pàgines wiki",
"Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)" => "Les correccions menors no marquen nous continguts per a la traducció i no envien notificacions per correu-e (a menys que \"Veure edicions menors\" estigui activat)",
// "Display comment list by default" => "Display comment list by default",
// "Display Post new comment form by default" => "Display Post new comment form by default",
"Simple wiki comment ratings" => "Valoracions simples a comentaris en el wiki",
"Enable users to rate comments based on a simple numeric scale" => "Permet als usuaris de valorar els comentaris basant-se en una escala numèrica senzilla",
"Wiki rating options" => "Opcions de valoració al Wiki",
"List of options available for the rating of wiki comments" => "Llista de les opcions disponibles per a la valoració dels comentaris wiki",
"Add a slideshow button on wiki pages" => "Afegiu un botó de presentació de diapositives en les pàgines wiki",
"Page creators are administrators of their pages" => "Els creadors de pàgines en són els administradors",
"Create watch for author on page creation" => "L'autor vigila la pàgina en crear-la",
"Enable watches on comments" => "Permet vigilar comentaris",
"Watch minor edits" => "Veure edicions menors",
"Page ID" => "ID Pàgina",
// "Page name maximum displayed length" => "Page name maximum displayed length",
// "Comment of the latest edit" => "Comment of the latest edit",
// "Description maximum displayed length" => "Description maximum displayed length",
"Versions" => "Versions",
"Categories path" => "Ruta de les categories",
"Default sort order" => "Ordre d'ordenació per defecte",
"Sort Direction" => "Ordenar Direcció",
// "Visibility of discussion" => "Visibility of discussion",
// "Just a button among others (default), or special section" => "Just a button among others (default), or special section",
// "In the button bar (default)" => "In the button bar (default)",
// "Special section above button bar" => "Special section above button bar",
"Forum for discussion" => "Fòrum de debat",
"Allow management of keywords on a per-page basis" => "Deixi d'utilitzar paraules clau en una base per pàgina",
"Similar pages only listed in same language" => "Pàgines similars només figuren mateix idioma",
"When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page" => "En enumerar les pàgines similars, com a la pàgina 404 desapareguts, només mostrar les pàgines en el mateix idioma que la sol·licitud",
"Mandatory wiki page edit summary" => "Obligatori resum d'edició de pàgines wiki",
"Reject save attempts that do not include an edit summary describing the changes made" => "Rebutjar guardar intents no proporcionen un resum d'edició per descriure els canvis realitzats",
"Position of tags selection" => "Trieu la posició de la selecció de marques lliures",
"Place the tags selection more prominently than under the \"Properties\" tab" => "Si vols posar la selecció de marques lliures més prominent que a la fitxa de propietats",
"Properties tab" => "Fitxa Propietats",
"Edit tab" => "Edita pestanya",
"Tags tab" => "Fitxa Marca lliures",
"Structure navigation bar location" => "Estructura de navegació barra d'adreces",
"Display Next and Back buttons, breadcrumbs, and a form to add a new page" => "Mostrar Pròxim / Enrere botons, rastre de molles de pa, i el formulari per afegir una nova pàgina",
// "Backlink page names maximum displayed length" => "Backlink page names maximum displayed length",
// "Show blog posts" => "Show blog posts",
// "Blog posts linking to a wiki page are shown as backlinks" => "Blog posts linking to a wiki page are shown as backlinks",
// "Show forum posts" => "Show forum posts",
// "Forum posts linking to a wiki page are shown as backlinks" => "Forum posts linking to a wiki page are shown as backlinks",
// "Show comments" => "Show comments",
// "Comments linking to a wiki page are shown as backlinks" => "Comments linking to a wiki page are shown as backlinks",
// "Show articles" => "Show articles",
// "Articles linking to a wiki page are shown as backlinks" => "Articles linking to a wiki page are shown as backlinks",
// "Show tracker items" => "Show tracker items",
// "Tracker items linking to a wiki page are shown as backlinks" => "Tracker items linking to a wiki page are shown as backlinks",
"Show trackers" => "Mostra els formullaris-bd",
// "Trackers with a description linking to a wiki page are shown as backlinks" => "Trackers with a description linking to a wiki page are shown as backlinks",
// "Show tracker fields" => "Show tracker fields",
// "Tracker fields with a description linking to a wiki page are shown as backlinks" => "Tracker fields with a description linking to a wiki page are shown as backlinks",
// "Show calendar events" => "Show calendar events",
// "Calendar events with a description linking to a wiki page are shown as backlinks." => "Calendar events with a description linking to a wiki page are shown as backlinks.",
"Simple wiki ratings" => "Valoracions wiki simples",
// "Enable users to rate wiki pages based on a simple numeric scale" => "Enable users to rate wiki pages based on a simple numeric scale",
"List of options available for the rating of wiki pages" => "Llista de les opcions disponibles per a la classificació de les pàgines wiki",
"Semantic link types to use as page alias markers" => "Tipus de vincles semàntics per utilitzar com a pàgina d'àlies marcadors",
"Comma-separated list of semantic links to identify a page as an alias of another" => "Llista separada per comes dels enllaços semàntics utilitzar per identificar una pàgina com un àlies a un altre",
"Redirect pages using these prefix-alias semantic links" => "Redireccionar pàgines que utilitzen aquests prefixos d'àlies d'enllaços semàntics",
"Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link" => "Llista separada per comes dels prefixos de les pàgines que seran redirigides a la pàgina amb el vincle semàntic",
"Wiki page pagination" => "Paginació Wiki",
"Enable the separation of a wiki page's content into a set of two or more paginated pages" => "Permet separar una pàgina wiki en una pàgina paginat utilitzant un separador",
"Wiki page separator" => "Pàgina Wiki separador",
"The separator to use in wiki page content to mark the end of each page section" => "Separador utilitzat dins del contingut d'una pàgina wiki per dividir el contingut",
"Wiki auto-toc" => "Indexos automàtics (auto-toc) al Wiki",
// "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties" => "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties",
// "Inline auto-toc" => "Inline auto-toc",
// "Change the display of the table of contents for wiki pages to inline" => "Change the display of the table of contents for wiki pages to inline",
// "Table of contents position" => "Table of contents position",
// "Position of the table of contents, either top, left, right (right is the default)" => "Position of the table of contents, either top, left, right (right is the default)",
// "Table of contents offset" => "Table of contents offset",
// "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin" => "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin",
// "Table of contents default" => "Table of contents default",
// "Set the default for the table of contents (default \"on\" and can be toggled per page)" => "Set the default for the table of contents (default \"on\" and can be toggled per page)",
"On" => "Actiu",
"Off" => "Inactiu",
// "Add an option to hide the page title per wiki page" => "Add an option to hide the page title per wiki page",
"Enable the page title to not be displayed, on a per-page basis." => "Permet amagar el títol de pàgines wiki individuals",
// "Multilevel style numbering for ordered lists" => "Multilevel style numbering for ordered lists",
// "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc" => "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc",
// "Force link to included page" => "Force link to included page",
// "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used" => "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used",
// "Date Field" => "Date Field",
// "The field indexed as the global \"date\" field" => "The field indexed as the global \"date\" field",
// "You will need to rebuild the search index after changing this" => "You will need to rebuild the search index after changing this",
// "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it" => "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it",
// "Maximum displayed length of the latest edit's comment" => "Maximum displayed length of the latest edit's comment",
"Plugin %0" => "Connector %0",
// "Global cache time for the plugin snarf" => "Global cache time for the plugin snarf",
"Default cache time for the plugin snarf" => "Temps de memòria cau per omissió del connector snarf",
"0 for no cache" => "0 per no memòria cau",
// "GUI for the list plugin" => "GUI for the list plugin",
// "Experimental GUI for the list plugin in popup plugin edit forms" => "Experimental GUI for the list plugin in popup plugin edit forms",
// "(listgui)" => "(listgui)",
// "Plugin trackerlist converter" => "Plugin trackerlist converter",
// "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead" => "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead",
// "Maximum plugin parsing passes" => "Maximum plugin parsing passes",
// "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin" => "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin",
// "passes" => "passes",
// "Setting this to a higher value than the default of 500 may have performance implications" => "Setting this to a higher value than the default of 500 may have performance implications",
"Inline plugin %0" => "Programes Inline %0",
"Plugin pending approval notification" => "Notificació d'aprovació pendent de connectors (plugins)",
"Send an email alert to users with permission to approve plugins when a plugin approval is pending" => "Alerta per els usuaris de correu electrònic amb permís per aprovar complement quan un connector està pendent d'aprovació",
"Hide admin wizard on log-in when an admin user logs in" => "Amaga l'assistent d'administració quan es connecti un administrador/a",
"Workspace UI" => "Interfície d'usuari per als Espais de treball",
"Combines multiple site features to create a workspace experience for workgroups" => "Enllaça múltiples funcions de Tiki per formar una experiència d'espai de treball per a grups de treball",
"Workspace root category" => "Categoria arrel per als Espais de treball",
"ID of the root category containing all workspaces" => "Identificació de la categoria arrel que conté tots els espais de treball",
"This value is automatically managed and should not need to be modified manually" => "Aquest valor es genera automàticament i no és necessari que es modifiqui manualment",
"Full WYSIWYG editor is optional" => "L'Editor Wysiwyg Sencer és opcional",
"If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used" => "Si el wysiwyg és opcional, l'editor de text wiki també serà disponible. Alternativament només s'emprarà l'editor Wysiwyg",
"Switching between HTML and wiki formats can cause problems for some pages" => "Canviar entre els formats html i wiki pot causar problemes per a algunes pàgines",
"Full WYSIWYG editor is displayed by default" => "L'Editor Wysiwyg Sencer es mostra per omissió",
// "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages" => "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages",
"Reopen with the same editor" => "Reobre amb el mateix editor",
// "Ensures the editor last used to edit a page or item is used for the next edit as the default" => "Ensures the editor last used to edit a page or item is used for the next edit as the default",
// "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed" => "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed",
"Use Wiki syntax in WYSIWYG" => "Utilitza la sintaxi Wiki en WYSIWYG",
// "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"" => "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"",
"Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools" => "Utilitzant la sintaxi wiki en mode WYSIWYG limitarà barra d'eines per a eines Wiki",
// "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)" => "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)",
// "CKeditor offers possibilities which may not be expressible in Tiki syntax" => "CKeditor offers possibilities which may not be expressible in Tiki syntax",
"Full WYSIWYG editor skin" => "Pell de l'Editor Wysiwyg Sencer",
"Moono (Default)" => "Moono (per omissió)",
"Kama" => "Kama",
// "Bootstrap CK" => "Bootstrap CK",
// "Minimalist" => "Minimalist",
// "Office 2013" => "Office 2013",
// "Typefaces" => "Typefaces",
// "List of font names separated by semi-colons (\";\")" => "List of font names separated by semi-colons (\";\")",
"Inline WYSIWYG editor" => "Editor Wysiwyg en-línia",
"Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required" => "Edició en línia fluida. Empra CKEditor4. L'edició en-línia permet a l'usuari editar les pàgines sense un botó contextual diferent del propi text a editar. L'editor és incrustat a la pàgina wiki. Quan s'empra a pàgines en format Wiki, cal una conversió de format HTML a Wiki",
// "Extra plugins" => "Extra plugins",
// "List of plugin names (separated by,)" => "List of plugin names (separated by,)",
// "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard" => "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard",
// "Support Tiki's \"wiki syntax\" in HTML pages" => "Support Tiki's \"wiki syntax\" in HTML pages",
// "XMPP client (ConverseJS)" => "XMPP client (ConverseJS)",
// "Integration with Converse.js XMPP client" => "Integration with Converse.js XMPP client",
// "XMPP server domain" => "XMPP server domain",
// "example.org" => "example.org",
// "XMPP MUC Domain" => "XMPP MUC Domain",
// "Required for auto-joining rooms" => "Required for auto-joining rooms",
// "conference.example.org" => "conference.example.org",
// "The authentication method to be used by XMPP client" => "The authentication method to be used by XMPP client",
// "OAuth (uses Tiki as provider)" => "OAuth (uses Tiki as provider)",
// "Openfire TikiToken" => "Openfire TikiToken",
// "Allow anonymous" => "Allow anonymous",
// "Allow anonymous users on Chat" => "Allow anonymous users on Chat",
// "Openfire REST API endpoint" => "Openfire REST API endpoint",
// "Full URL to API endpoint" => "Full URL to API endpoint",
// "https://xmpp.example.org:9091/plugins/restapi/v1/" => "https://xmpp.example.org:9091/plugins/restapi/v1/",
// "Rest API username" => "Rest API username",
// "Username to allow Openfire API usage" => "Username to allow Openfire API usage",
// "Rest API password" => "Rest API password",
// "Password to allow Openfire API usage" => "Password to allow Openfire API usage",
// "ConverseJS Debug Mode" => "ConverseJS Debug Mode",
// "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console" => "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console",
// "ConverseJS Extra Settings" => "ConverseJS Extra Settings",
// "JSON format object defining extra optional settings to initialize ConverseJS" => "JSON format object defining extra optional settings to initialize ConverseJS",
"SMTP server" => "Servidor SMTP",
"Security" => "Seguretat",
"SSL" => "SSL",
"TLS" => "TLS",
"Mail sender" => "Enviador de Correu",
// "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications" => "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications",
"Sendmail" => "Sendmail",
"SMTP" => "SMTP",
"File (debug)" => "Arxiu (debug)",
"Authentication" => "Autenticació",
"Mail server authentication" => "Autenticació del servidor de correu",
"LOGIN" => "Inici de sessió",
"PLAIN" => "PLAIN",
"CRAM-MD5" => "CRAM-MD5",
"Local server name" => "Nom del servidor local",
"Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line" => "Nom del servidor local. S'informarà la retransmissió SMTP en la línia de HELO/EHLO",
// "Mail delivery" => "Mail delivery",
// "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail" => "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail",
"Send immediately" => "Enviar immediatament",
"Queue" => "Cua",
// "Verify HTTPS certificates of remote servers" => "Verify HTTPS certificates of remote servers",
// "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)" => "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)",
// "Do not enforce verification" => "Do not enforce verification",
// "Enforce verification" => "Enforce verification",
// "Use CURL for HTTP connections" => "Use CURL for HTTP connections",
// "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available" => "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available",
// "Zotero bibliography" => "Zotero bibliography",
"Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system" => "Connecteu Tiki al sistema de gestió de bibliografia en línia Zotero",
// "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style" => "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style",
// "Zotero client key" => "Zotero client key",
"Required identification key. Registration required" => "Es requereix clau d'identificació. Es requereix el seu registre",
// "Zotero client secret" => "Zotero client secret",
// "Zotero group ID" => "Zotero group ID",
"Numeric ID of the group, can be found in the URL" => "ID numèric del grup, es pot trobar a la URL",
// "Zotero reference style" => "Zotero reference style",
"Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Utilitza un estil de referència de Zotero alternatiu en donar format a les referències. Els formats de referència han d'estar instal·lats al servidor de Zotero",
"Unmatched system requirement. Missing PHP extension among %0" => "No s'han trobat els requisits del sistema. Falta php entre %0",
"Unmatched system requirement. The database you are using does not support this feature" => "No s'han trobat els requisits del sistema. La base de dades està utilitzant no és compatible amb aquesta funció",
"Missing default for preference \"%0\"" => "Falta per omissió per a la preferència \"%0\"",
"Configuration forced by host" => "Configuració forçada per l'amfitrió",
"Disabled by host" => "Discapacitats per l'amfitrió",
"Settings" => "Configuració",
"Permissions" => "Permisos",
"View" => "Visualitza",
"Modules" => "Mòduls",
"Plugins" => "Connectors (Plugins)",
"Like" => "Com",
// "Missing preference \"%0\" for \"%1\"" => "Missing preference \"%0\" for \"%1\"",
// "%0 set to minimum of %1 instead of submitted value of %2" => "%0 set to minimum of %1 instead of submitted value of %2",
// "%0 set to maximum of %1 instead of submitted value of %2" => "%0 set to maximum of %1 instead of submitted value of %2",
"Don't like" => "Si no t'agraden",
"Wiki top pages" => "Pàgines Wiki més actives",
"Most-relevant pages" => "Pàgines més rellevants",
"Wiki last pages" => "Darreres pàgines Wiki",
"Forums last topics" => "Darrers temes als Fòrums",
"Topic date" => "Data de tòpic",
"Forums last posts" => "Fòrums: darrers enviaments",
"Forums most-read topics" => "Temes més llegits dels Fòrums",
"Forums best topics" => "Fòrums: millors temes",
"Most-visited forums" => "Fòrums més visitats",
"Forums with most posts" => "Fòrums amb més escrits",
"Wiki top galleries" => "Galeries d'imatges Wiki més actives",
"Wiki top file galleries" => "Galeries de fitxers Wiki més actives",
"Wiki top images" => "Imatges Wiki més visitades",
"Wiki top files" => "Fitxers Wiki més vists",
"Downloads" => "Descàrregues",
"Wiki most-recent images" => "Darreres imatges Wiki",
"Upload date" => "Data de pujada",
"Wiki most-recent files" => "Darrers fitxers Wiki",
"Top Articles" => "Els millors articles",
"Most-visited blogs" => "Blocs més visitats",
"Most-active blogs" => "Blocs més actius",
"Blogs last posts" => "Darrers enviaments al bloc",
"Post date" => "Data de publicació",
"Wiki top authors" => "Autors Wiki més actius",
"Pages" => "Pàgines",
"Top article authors" => "Els autors d'articles més actius",
"Expecting three arguments for article-info" => "Comptar amb tres arguments per article-info",
"Unsupported property. Supported properties are: " => "Propietat no compatible. Propietats compatibles són:",
"The Articles feature is not activated" => "Articles de fons no està habilitat",
"Object must be provided and contain two arguments: type and object" => "L'objecte ha de ser proporcionada i contenen dos arguments: el tipus i l'objecte",
"Invalid property" => "Propietat no vàlida",
"Item must be provided and contain one argument: type, object-id" => "L'article ha de ser proporcionada i conté un argument: tipus, object-id",
"List must be provided and contain at least one argument: category IDs" => "Llista ha de ser proporcionada i contenir almenys un argument: ID de categoria",
"Invalid range" => "Rang vàlid",
"Invalid revote period" => "Invalid període nova votació",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Qualifier must be provided and contain one argument: type" => "Qualifier must be provided and contain one argument: type",
// "From must be provided and contain two arguments: type, object-id" => "From must be provided and contain two arguments: type, object-id",
// "To must be provided and contain two arguments: type, object-id" => "To must be provided and contain two arguments: type, object-id",
"Field must be provided and contain one argument: field permanent name" => "El camp ha de ser proporcionada i conté un argument: Camp permanent",
"Unknown variables referenced: %0" => "Variables desconegudes referència: %0",
"Username is required" => "Es requereix nom d'usuari",
"Password is required" => "Contrasenya requerida",
"User already exists" => "Aquest usuari ja existeix",
"Invalid username" => "El nom de l'usuari no és vàlid",
"Username is too long" => "El nom de l'usuari és massa llarg",
"Username cannot contain uppercase letters" => "El nom d'usuari no pot contenir majúscules",
"Wrong passcode. You need to know the passcode to register at this site" => "Codi de registre no vàlid. Necessites saber el codi de registre per donar-te d'alta en aquest lloc web",
"You must choose a group" => "Has d'escollir un grup",
"Email not valid. Should be in the format \"mailbox@example.com\"" => "Correu-e invàlid. Hauria de ser en el format \"correu-e@exemple.com\"",
"One of these groups is required" => "Es requereix un d'aquests grups",
"This field is required" => "Aquest camp és obligatori",
"The passwords don't match" => "Les contrasenyes no coincideixen",
"Username must be at least %0 characters long" => "Nom d'usuari ha de tenir almenys %0 caràcters",
"Username cannot contain more than %0 characters" => "Nom d'usuari no pot contenir més de %0 caràcters",
"This invitation does not exist or is deprecated or wrong email" => "Aquesta invitació no existeix o està en desús o de correu electrònic incorrecta",
"The title and description must be entered, to generate a feed" => "El títol i la descripció dels camps són obligatoris per generar un feed",
"To fix this error go to Admin -> Feeds" => "Per corregir aquest error vagi a Admin -> Feeds",
"Please contact the site administrator and request this error to be corrected" => "Si us plau, poseu-vos en contacte amb l'administrador del lloc i el convido a corregir aquest error",
"If you set feed author email or URL, you must set feed author name" => "Si estableix feed autora correu electrònic o URL, ha d'establir el nom de l'autor d'alimentació",
"Feed logo" => "Alimenti logo",
"Unspecified" => "No especificat",
"Log In" => "Connecta't",
"See other users' profiles" => "Mira el perfil dels altres usuaris",
"Have your profile seen" => "Tingues el teu perfil visible",
"Make friends" => "Fes amistats",
"Receive a message" => "Rep missatge",
"Send a message" => "Envia missatge",
"Read an article" => "Llegeix un article",
"Publish an article" => "Publica un article",
"Have your article read" => "Tingues el teu article llegit",
"Create new file gallery" => "Crea una Nova Galería d'Arxius",
"Upload a new file to a gallery" => "Puja un arxiu nou a la galeria",
"Download another user's file" => "Descarrega l'arxiu d'altres usuaris",
"Have your file downloaded" => "Tingues el teu arxiu descarregat",
"Create a new image gallery" => "Crea una nova galeria d'imatges",
"Upload a new image to a gallery" => "Puja una nova imatge a la galeria",
"View another user's gallery" => "Mira la galaeria d'altres usuaris",
"View another user's images" => "Mira la imatge d'altres usuaris",
"Have your gallery viewed by another user" => "Tingues la teva galeria vista per altres usuaris",
"Have your image viewed" => "Tingues la teva imatge vista",
"Create a new blog" => "Crea un nou bloc",
"Post in a blog" => "Publica en un bloc",
"Read another user's blog" => "Llegeix el bloc d'altres usuaris",
"Have your blog read" => "Fes que es llegeixi el teu bloc",
"Create a new wiki page" => "Crea una nova pàgina wiki",
"Edit an existing page" => "Edita una pàgina existent",
"Attach a file" => "Adjuntar arxiu",
"Create a new forum topic" => "Crea un nou tema al fòrum",
"Reply to a forum topic" => "Respon a un tema del fòrum",
"Read a forum post" => "Llegeix una publicació del fòrum",
"Have your forum post read" => "Fes que es llegeixi la teva publicació del fòrum",
"Create a new tracker item" => "Crea un nou ítem de formulari-bd",
"Edit a tracker item" => "Edita un ítem de formulari-bd",
"View a tracker item" => "Visualitza un ítem de formulari-bd",
"Have your tracker item viewed" => "Fes que es vegi el teu  ítem de formulari-bd",
"Tracker field content added" => "S'ha afegit contingut a un cap del formulari-bd",
"Favorite an item" => "Marca un ítem com a Favorit",
"Have your item favorited" => "Fes que el teu ítem sigui marcat com a favorit",
"Have your item rated (per rating)" => "Fes que el teu ítem sigui puntuat (per a cada puntuació)",
"Have your item unrated (per rating)" => "Fes que el teu ítem deixi de ser puntuat (per a cada puntuació)",
"Add a profile photo" => "Afegeix una foto al teu perfil",
"Try rebuilding or optimizing the index on the search admin page" => "intentar reconstruir o l'optimització de l'índex a la pàgina d'administració de cerca",
// "Invalid table name" => "Invalid table name",
// "Invalid column name" => "Invalid column name",
"Wiki Comment" => "Comentari Wiki",
"Calendar item" => "Ítem del Calendari",
"Gallery" => "Galeria",
"Blog post" => "Publicació de Bloc",
"Tracker item" => "Item del formulari",
"The search index could not be updated. The site is misconfigured. Contact an administrator" => "Índex de cerca no es va poder actualitzar. El lloc està mal configurat. Poseu-vos en contacte amb l'administrador",
"Rebuild in progress" => "Reconstruir en curs",
// "The search index could not be rebuilt" => "The search index could not be rebuilt",
"The active index could not be removed, probably due to a file permission issue" => "No s'ha pogut suprimir l'índex actiu. Probablement un problema de permisos de fitxers",
"The new index could not be made active, probably due to a file permission issue" => "No es pot transferir al nou índex actiu. Probablement un problema de permisos de fitxers",
// "Failed to delete the old index" => "Failed to delete the old index",
"blog post" => "bloc",
"forum post" => "missatge al fòrum",
"tracker item" => "ítem del formulari-bd",
// "tracker field" => "tracker field",
"sheet" => "full de càlcul",
"comment" => "comentari",
// "category" => "category",
// "webservice" => "webservice",
// "activity" => "activity",
// "calendar item" => "calendar item",
// "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate" => "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate",
// "Contact the site administrator. The index needs rebuilding" => "Contact the site administrator. The index needs rebuilding",
// "Client Node" => "Client Node",
// "Elasticsearch Version" => "Elasticsearch Version",
// "Lucene Version" => "Lucene Version",
// "Cluster Name" => "Cluster Name",
// "Cluster Status" => "Cluster Status",
// "Cluster Node Count" => "Cluster Node Count",
// "Index %0" => "Index %0",
// "%0 documents, totaling %1" => "%0 documents, totaling %1",
// "Node %0" => "Node %0",
// "Using %0, since %1" => "Using %0, since %1",
// "%0 documents, totaling %1 bytes" => "%0 documents, totaling %1 bytes",
// "Using %0 bytes, since %1" => "Using %0 bytes, since %1",
// "Field Count Tried on Last Rebuild" => "Field Count Tried on Last Rebuild",
// "Field limit setting is lower than Tiki needs to store in the index" => "Field limit setting is lower than Tiki needs to store in the index",
// "Information Missing" => "Information Missing",
"Object Type" => "Tipus de l'objecte",
// "date_histogram" => "date_histogram",
// "Date Histogram" => "Date Histogram",
// "date_range" => "date_range",
"Date Range" => "Rang de dates",
// "Local Search" => "Local Search",
// "Federated Search" => "Federated Search",
// "Index not found" => "Index not found",
"Rebuild search index" => "Reconstruir índex de cerca",
// "Click here to rebuild index" => "Click here to rebuild index",
// "On Demand" => "On Demand",
// "You can revisit the results of this saved search on demand" => "You can revisit the results of this saved search on demand",
// "Mobile mode: Permission denied, please log in" => "Mobile mode: Permission denied, please log in",
" has accessed your temporary shared content" => " ha accedit el teu contingut temporalment compartit",
"has accessed the following shared content" => "ha accedit al contingut compartit següent",
"Your access to this page has expired" => "L'accés a aquesta pàgina està acabat",
"Handling actions of plugin \"%s\" failed" => "El maneig de les accions del Plugin \"%s\" han fallat",
"You must choose an option" => "Heu de triar una opció",
"For you to vote, cookies must be allowed" => "Les galetes haurien de tenir dret al vot",
"This poll is closed." => "Aquest sondeig es troba tancat.",
// "Preference %0 failed to unserialize. Value was \"%1\"" => "Preference %0 failed to unserialize. Value was \"%1\"",
// "A tracker with id \"%0\" is required to be filled in, but it was deleted" => "A tracker with id \"%0\" is required to be filled in, but it was deleted",
// "Update the preference \"<b>%0</b>\" on admin panel" => "Update the preference \"<b>%0</b>\" on admin panel",
"Congratulations" => "Felicitats",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "Aquesta és la pàgina d'inici per al teu Tiki. Si estàs veient aquesta pàgina, la instal·lació s'ha realitzat correctament",
"You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "Pots canviar aquesta pàgina després d'iniciar sessió. Si us plau, revisa la [http://doc.tiki.org/wiki+syntax|sintaxi wiki] per als detalls d'edició",
"Get started" => " Primers passos",
"To begin configuring your site" => "Per començar a configurar el teu lloc",
"1) Log in with your newly created password" => "1) Identifica't amb la teva nova contrasenya",
"2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard" => "2) [tiki-admin.php?page=features|Habilita manualment] característiques específiques del Tiki que no hagis habilitat a través de l'Assistent d'Administració",
"3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running" => "3) Executa [tiki-admin.php?page=profiles|Perfils de Configuració de Tiki] per a començar de forma àgil",
"Need help" => "Necessites ajuda",
"For more information" => "Per obtenir més informació",
// "[https://tiki.org/Introduction|Learn more about Tiki]" => "[https://tiki.org/Introduction|Learn more about Tiki]",
// "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[https://tiki.org/Join|Join the Tiki community]" => "[https://tiki.org/Join|Join the Tiki community]",
"new" => "nou",
"Saved" => "Desat",
"Save failed" => "No s'ha pogut desar",
"Standard Shipping" => "Enviament estàndard",
"3 to 5 working days" => "de 3 a 5 dies laborables",
"Express Shipping" => "Enviament exprés",
"Next day delivery" => "Lliurament al dia següent",
"Custom Shipping Example" => "Custom Exemple enviament",
"UPS_CODE_%0" => "UPS_CODE_%0",
"Problem reading custom shipping provider \"%0\"" => "Problema llegint proveïdor d'enviaments custom \" %0 \"",
"Modified date" => "Data de modificació",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- connector smarty jq inactiu: feature_jquery desactivada -->",
"No records to display" => "No hi ha cap registre per mostrar",
// "Please specify the name of the package and the view" => "Please specify the name of the package and the view",
// "Error: Unable to locate view file for the package" => "Error: Unable to locate view file for the package",
// "Error: Unable to locate function name for the view" => "Error: Unable to locate function name for the view",
"Previous" => "Anterior",
"current" => "actual",
"Next" => "Següent",
"More results may be available. Refine criteria to access the estimated %0 results" => "Més resultats poden estar disponibles. Classificar segons accedir estimada %0 resultats",
"Tab View" => "Tab View",
"No Tabs" => "Sense pestanyes",
"This edit session will expire in" => "Aquesta sessió d'edició expirarà en",
"There is an autosaved draft of your recent edits, to use it instead " => "Hi ha un esborrany desat automàticament de les teves edicions recents, per a emprar alternativament ",
"If you want the original instead of the autosaved draft of your edits" => "Si vols el text original enlloc de l'esborrany autodesat de les teves edicions",
"click here" => "cliqueu aquí",
"AutoSave" => "AutoDesa",
"Your edit session has expired" => "Ha caducat la teva sessió d'edició",
"Your edit session will expire in" => "La teva sessió d'edició caducarà en",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Has de PREVISUALITZAR o DESAR ara el teu treball, per tal d'evitar perdre els teus canvis",
"You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page" => "Estàs a punt de sortir d'aquesta pàgina. Els canvis des de la darrera gravació es poden perdre. Està segur que desitja sortir d'aquesta pàgina",
// "Help page" => "Help page",
// "View or edit tpl" => "View or edit tpl",
// "View tpl" => "View tpl",
"itemId required" => "Itemid requereix",
// "Plugin name not specified" => "Plugin name not specified",
// "Delete file" => "Delete file",
// "File (ID %0) removed" => "File (ID %0) removed",
// "File (ID %0) not removed" => "File (ID %0) not removed",
// "File uploaded" => "File uploaded",
// "File not uploaded" => "File not uploaded",
// "Missing _id or _type params" => "Missing _id or _type params",
"Wrong attachments gallery" => "Wrong galeria arxius adjunts",
"You are attempting to display a gallery that is not a valid attachment gallery" => "Estàs intentant visualitzar una galeria que no és una galeria d'afecció vàlida",
// "Missing 'to' or 'from' parameter" => "Missing 'to' or 'from' parameter",
"at" => "a",
"to" => "a",
"Favorite" => "Favorit",
"Hour" => "Hora",
"Minute" => "Minut",
"Error:" => "Error:",
"a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "Clica aquí per anar a Editar Idiomes",
"The text is" => "El text és",
"character(s) too long - please edit it." => "caràcter(s) massa llarg - si us plau edita-ho.",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Clear filter" => "Clear filter",
// "Type not specified" => "Type not specified",
// "lock perm not found" => "lock perm not found",
// "admin perm not found" => "admin perm not found",
"Missing parameter" => "Manca algun paràmetre",
// "Multivalue configuration not found" => "Multivalue configuration not found",
"No records found." => "No s'han trobat registres.",
"No object information provided" => "No hi ha informació objecte proporcionat",
"No title specified" => "Sense títol especificat",
"Relation not found" => "Relació no trobada",
"tags disabled" => "marques lliures desactivats",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "%0 list separated with \"%1\"" => "%0 list separated with \"%1\"",
// "Object selector requires Unified Index to be enabled" => "Object selector requires Unified Index to be enabled",
"Currency in payment (%0) does not match the currency for that registry (%1)" => "La moneda del pagament (%0) no es correspon amb la moneda del registre - xarxa d'intercanvi (%1)",
// "Payment error" => "Payment error",
"This invoice does not exist or access to it is restricted" => "Aquesta factura no existeix o està en un accés limitat",
"You do not have the permission that is needed to use this feature" => "Permís denegat per accedir a aquesta secció",
"(not found in an admin panel)" => "(no trobat en un panell d'administració)",
"Preference %0 is not defined" => "Preferència %0 no està definit",
"Drag this out of the perspective and resave the perspective" => "Arrossegueu això de la perspectiva i tornar a guardar",
"No object information provided for rating" => "No hi ha informació objecte proporcionat per votar",
"An error occurred" => "S'ha produït un error",
"Configure Ratings" => "Configura Valoracions",
// "Unavailable" => "Unavailable",
"Invalid fields provided" => "Camps no vàlids proporcionats",
"Missing or invalid tracker reference" => "Falta de seguiment o referència vàlida",
// "Configured" => "Configured",
"General" => "General",
// "Tracker rendering error (section=\"%0\" mode=\"%1\")" => "Tracker rendering error (section=\"%0\" mode=\"%1\")",
"No rows found" => "No s'han trobat files",
"Toggle sections" => "Commuta les seccions",
"Show only selected" => "Mostra només els/les seleccionats/des",
"You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "És possible que vulgueu configurar també el permís tiki_p_modify_object_categories a la secció tiki",
// "You are logged in" => "You are logged in",
"Request not from this host" => "No sol·licita des d'aquest host",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Si us plau, introdueix un/a %s vàlid/a. Sense espais, més de %d caràcters i que contingui %s",
"username" => "usuari",
"password" => "contrasenya",
"Cookies must be enabled to log in to this site" => "Has d'habilitar les galetes 'cookies' per que puguis entrar en aquest lloc",
// "wikidiff: error - no object_id specified" => "wikidiff: error - no object_id specified",
// "wikidiff: error - no old version specified" => "wikidiff: error - no old version specified",
// "wikidiff: error - page \"%0\" not found" => "wikidiff: error - page \"%0\" not found",
// "wikidiff: Error - only wiki pages supported currently" => "wikidiff: Error - only wiki pages supported currently",
"second" => "segon",
"months" => "mesos",
"weeks" => "setmanes",
"done" => "fet",
"Text cut here" => "Tall del text aquí",
"Task" => "Tasca",
"Priority" => "Prioritat",
"Start date:" => "Data d'inici:",
"End date:" => "Data de fi:",
"in %s days, the %s" => "en %s dies, el/s %s",
"in %s day, the %s" => "en dia %s, el/s %s",
"Today" => "Avui",
"%0 and %1" => "%0 i %1",
"Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permís denegat: la pàgina wiki especificat no es pot utilitzar com a recurs de plantilla de Smarty",
"No WSDL found" => "No s'ha trobat WSDL",
// "Facebook feed data not retrieved" => "Facebook feed data not retrieved",
// "Facebook profile information not retrieved" => "Facebook profile information not retrieved",
// "You need to link your local account to Facebook before you can login using it" => "You need to link your local account to Facebook before you can login using it",
// "We were unable to create a new user with your Facebook account. Please contact the administrator" => "We were unable to create a new user with your Facebook account. Please contact the administrator",
// "We were unable to connect to your LinkedIn account. Please contact the administrator" => "We were unable to connect to your LinkedIn account. Please contact the administrator",
// "We were unable to log you in using your LinkedIn account. Please contact the administrator" => "We were unable to log you in using your LinkedIn account. Please contact the administrator",
// "You need to link your local account to LinkedIn before you can login using it" => "You need to link your local account to LinkedIn before you can login using it",
"pvs" => "pvs",
"Days with the most pageviews" => "Dies amb més pàgines vistes",
"Day with the most pageviews" => "Dia amb més visites",
"Days with the fewest pageviews" => "Dies amb el menor visites",
"Day with the fewest pageviews" => "Dia amb menys visites",
"No pageviews yet" => "No hi ha visites encara",
"Use this tree to copy the structure" => "Empra aquest arbre per copiar l'estructura",
"system" => "sistema",
"created from structure" => "creat des d'estructura",
"%d choice(s) must be made for the question" => "Has de fer %d elecció(ons) per a la pregunta",
"At least %d choice(s) must be made for the question" => "Has d'escollir al menys %d elecció(ons) per a la pregunta",
"Fewer than %d choice(s) must be made for the question" => "Has de fer menys de %d eleccions per a la pregunta",
"One choice" => "Una opció",
"Multiple choices" => "Múltiples opcions",
// "Thumbnails" => "Thumbnails",
"Short text" => "Text curt",
"Wiki textarea" => "Wiki textarea",
"Rate (1 to 5)" => "Valor (1..5)",
"Rate (1 to 10)" => "Valor (1..10)",
"Heading" => "Capçalera",
// "Icon not found: %0" => "Icon not found: %0",
// "Icon set: Class not defined for icon %0" => "Icon set: Class not defined for icon %0",
// "Custom theme by specifying URL" => "Custom theme by specifying URL",
"Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator" => "Característiques necessàries: <b>%0</b>. Si no tens els privilegis per activar aquestes funcions, demana-ho a l'administrador del lloc",
// "CSRF check not performed" => "CSRF check not performed",
// "Required headers are missing" => "Required headers are missing",
// "Requesting site could not be identified because %0 and %1 were empty" => "Requesting site could not be identified because %0 and %1 were empty",
// "Request needs to originate from this site" => "Request needs to originate from this site",
// "The %0 host (%1) does not match this server (%2)" => "The %0 host (%1) does not match this server (%2)",
// "Ticket has expired. Reload the page" => "Ticket has expired. Reload the page",
// "Ticket matches but is expired" => "Ticket matches but is expired",
// "Reloading the page may help" => "Reloading the page may help",
// "Ticket does not match or is missing" => "Ticket does not match or is missing",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked" => "Potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Request to %0 failed CSRF check" => "Request to %0 failed CSRF check",
// "Confirm action" => "Confirm action",
// "Please confirm action" => "Please confirm action",
"unknown error" => "error desconegut",
"You are not logged in" => "No estàs connectat",
"You do not have permission to view this section" => "Permís denegat per accedir a aquesta secció",
"For the security of your password, direct access to the feed is only available via HTTPS" => "Per la seguretat de la teva contrasenya, l'accés directe a l'alimentació només és troba disponible via https",
"Help link" => "Enllaç d'ajuda",
"You are banned from" => "Estàs exclós des de",
"wiki" => "wiki",
"img-g" => "g-img",
"file-g" => "g-arx",
"quizzes" => "qüestionaris",
"arts" => "arts",
"blogs" => "blocs",
"forums" => "fòrums",
// "Tiki links converted to relative links" => "Tiki links converted to relative links",
// "TikiLib::create_page: Cannot create page \"%0\", it already exists.)" => "TikiLib::create_page: Cannot create page \"%0\", it already exists.)",
"The file was successfully uploaded" => "S'ha pujat l'arxiu amb èxit",
"The file was only partially uploaded." => "L'arxiu que proves de penjar només s'ha carregat parcialment.",
"No file was uploaded. Was a file selected " => "No s'ha pujat cap arxiu. S'havia seleeccionat un arxiu ",
"A temporary folder is missing" => "Manca un directori temporal",
// "Alias <b>%0</b> link already present in %1 page(s)" => "Alias <b>%0</b> link already present in %1 page(s)",
"%d points" => "%d punts",
"Removed" => "Eliminat/da",
"Plugin %0 pending approval" => "El connector %0 està pendent d'aprovació",
"Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked." => "Sea Surfing (CSRF) detectat. Operació bloquejada.",
"Bold" => "Negreta",
"img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "Cursives",
"img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Subratllat",
"img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "Tatxat",
"img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Code" => "Codi",
// "img/icons/page_white_code.png" => "img/icons/page_white_code.png",
"Non-parsed (wiki syntax does not apply)" => "Sense processar (No s'aplicarà la sintaxi wiki)",
"img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Alinea al centre",
"Horizontal Bar" => "Barra horizontal",
"Page Break" => "Salt de pàgina",
"Box" => "Caixa",
"Title bar" => "Barra de títol",
// "Bullet List" => "Bullet List",
// "Numbered List" => "Numbered List",
"Special Characters" => "Caràcters especials",
"Foreground color" => "Color del davant",
"Background Color" => "Color de Fons",
"Wiki Link" => "Enllaç Wiki",
"img/icons/page_link.png" => "img/icons/page_link.png",
"Object Link" => "Objecte Enllaç",
"External Link" => "Enllaç Extern",
"img/icons/world_link.png" => "img/icons/world_link.png",
"img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Constructor de taules",
"img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Cerca Text",
"img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Cerca i reemplaça text",
"Full-screen edit" => "Edició a pantalla completa",
"Wiki Help" => "Ajuda del Wiki",
"Choose or upload images" => "Escull o puja imatges",
"img/icons/pictures.png" => "img/icons/pictures.png",
"Choose or upload files" => "Escull o puja arxius",
"Switch Editor (wiki or WYSIWYG)" => "Canvia d'Editor (wiki o WYSIWYG)",
"img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Admin Toolbars" => "Administra les barres d'eines",
// "img/icons/wrench.png" => "img/icons/wrench.png",
"Save Sheet" => "Desa el Full",
"Add row after selection or to the end if no selection" => "Afegir fila després de la selecció o per finalitzar si no hi ha selecció",
"img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
"Add multiple rows after selection or to the end if no selection" => "Afegeix diverses files després de la selecció o per finalitzar si no hi ha selecció",
"img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
"Add row before selection or to end if no selection" => "Afegir fila abans de la selecció o per finalitzar si no hi ha selecció",
"Delete selected row" => "Eliminar fila seleccionada",
"img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
"Add column after selection or to the end if no selection" => "Afegir columna a la selecció o per finalitzar si no hi ha selecció",
"img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
"Delete selected column" => "Eliminar columna seleccionada",
"img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
"Add multiple columns after selection or to the end if no selection" => "Afegeix diverses columnes Quan seleccioneu o acabar si no hi ha selecció",
"img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
"Add column before selection or to the end if no selection" => "Afegir columna abans de la selecció o per finalitzar si no hi ha selecció",
"Get Cell Range" => "Aconsegueix el rang de les cel·les",
"img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Cerca",
"Refresh calculations" => "Refresca els càlculs",
"Finish editing" => "Acaba l'edició",
"Reset Colors" => "Restablir Colors",
"Reset" => "Reespecifica",
// "Show this text" => "Show this text",
// "Link to this page" => "Link to this page",
// "Anchor" => "Anchor",
// "Semantic relation" => "Semantic relation",
"Cancel" => "Cancel·lar",
"Insert" => "Insertar",
// "Types of object" => "Types of object",
// "Link to this object" => "Link to this object",
// "link to this URL" => "link to this URL",
// "No cache" => "No cache",
// "Case Insensitivity" => "Case Insensitivity",
// "Note: Uses regular expressions" => "Note: Uses regular expressions",
"Close" => "Tanca",
"Replace" => "Reemplaçar",
// "Replace All" => "Replace All",
// "Flat" => "Flat",
"Tabs" => "Tabs",
// "No template available for %0 - %1" => "No template available for %0 - %1",
// "Tracker %0 not found for Field %1" => "Tracker %0 not found for Field %1",
"*** ERROR: Tracker ID not set ***" => "*** Error: Formulari-bd d'ID no estableix ***",
"*** ERROR: Field ID not set ***" => "*** ERROR: Camp ID no definit ***",
"*** ERROR: Tracker %0 not found ***" => "*** Error: Formulari-bd %0 no trobat ***",
// "TrackerLib::get_all_items: No item for itemId %0" => "TrackerLib::get_all_items: No item for itemId %0",
"Tracker list_items ran out of memory after %0 items" => "Formulari-bd list_items es va quedar sense memòria després de %0 productes",
"No fields found in header, not a comma-separated values file" => "No s'han trobat a la capçalera dels camps, no un arxiu de valors separats per comes",
"Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problema inserir element del registre: trackerId = %0, creada = %1, lastModif = %2, estat = %3",
"Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problema conversió camp d'enllaç element del registre: trackerId = %0, fieldId = %1, itemId = %3",
// "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"" => "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"",
"Field is not numeric" => "El camp no és numèric",
"Function" => "Funció",
"Pending" => "Pendents",
"Tracker field setup error - display field not found: " => "Formulari-bd d'errors de configuració de camp - camp de visualització no trobat:",
// "Item Creation" => "Item Creation",
"Item Modification" => "Modificació de l'ítem",
"Item" => "Ítem",
"Subject" => "Tema",
"Tracker was modified at %0 by %1" => "Formulari-bd (Tracker) va ser modificat en %0 per %1",
"View the tracker item at:" => "Visualitza l'ítem del formulari a:",
// "Missing wiki email template page \"%0\"" => "Missing wiki email template page \"%0\"",
"Tracker field not enabled: fieldId=%0 type=%1" => "Camp del formulari-bd no habilitat: fieldId=%0 type=%1",
// "Field not specified" => "Field not specified",
"No extra information for that attached file. " => "No hi ha informació extra per aquest fitxer adjunt. ",
// "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list" => "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list",
// "Could not create /storage/pass_blacklists directory" => "Could not create /storage/pass_blacklists directory",
// "Existing password blacklist file was overwritten" => "Existing password blacklist file was overwritten",
// "Existing password blacklist file could not be overwritten" => "Existing password blacklist file could not be overwritten",
// "File Error. Password file not created" => "File Error. Password file not created",
// "File Error. Password file generation interrupted" => "File Error. Password file generation interrupted",
// "Password blacklist file generated" => "Password blacklist file generated",
// "Unable to Populate Blacklist: File dose not exist or is not readable" => "Unable to Populate Blacklist: File dose not exist or is not readable",
// "Critical" => "Critical",
// "Immediate notification by email" => "Immediate notification by email",
"High" => "Alt",
// "Will be sent to you with the next periodic digest" => "Will be sent to you with the next periodic digest",
"Low" => "Baix",
// "Included in your personalized recent changes feed" => "Included in your personalized recent changes feed",
// "Anywhere" => "Anywhere",
// "translations of %0" => "translations of %0",
// "%0 in %1" => "%0 in %1",
// "%0 for %1" => "%0 for %1",
// "Any activity" => "Any activity",
// "Page modified" => "Page modified",
// "Page created" => "Page created",
// "Any forum activity" => "Any forum activity",
// "New topics" => "New topics",
// "Any item activity" => "Any item activity",
// "New items" => "New items",
// "Action Required" => "Action Required",
// "Recommendation Received" => "Recommendation Received",
// "%0 (%1 level up, entire structure)" => "%0 (%1 level up, entire structure)",
// "%0 (%1 level up)" => "%0 (%1 level up)",
// "%0 (current subtree)" => "%0 (current subtree)",
// "%0 Reply Handler" => "%0 Reply Handler",
// "The user [ %0 ] is not registered with this wiki and autocreate is disabled" => "The user [ %0 ] is not registered with this wiki and autocreate is disabled",
// "The user [ %0|%1 ] is not registered with this wiki and the creation process failed" => "The user [ %0|%1 ] is not registered with this wiki and the creation process failed",
// "unverified" => "unverified",
// "Your Information" => "Your Information",
"User Information" => "Informació de l'usuari",
"Can create/close a book" => "Es pot crear / tancar un llibre",
"Can create/edit/lock accounts" => "Es pot crear / editar / tancar comptes",
"Create a new transaction" => "Crear una nova transacció",
"Permission to view the journal" => "Permís per veure la revista",
"Can book into the stack where statements can be changed" => "Es pot reservar a la pila on es poden canviar els estats",
"Can import statements from external accounts" => "Pots importar les declaracions dels comptes externes",
"Can manage templates for recurring transactions" => "Pots administrar les plantilles per a les transaccions recurrents",
"Can admin the articles" => "Pots administració els articles",
"Can approve submissions" => "Pots aprovar trameses",
"Can admin article topics" => "Pots administrar temes d'articles",
"Can admin article types" => "Pots administrar tipus d'articles",
"Can read article headings" => "Pots llegir les partides de l'article",
"Submitted articles are automatically approved" => "Articles sotmesos aprovats automàticament",
"Can edit articles" => "Pots editar articles",
"Can edit the user (owner) of articles" => "Pot editar l'usuari (propietari) d'articles",
"Can edit submissions" => "Pots editar trameses",
// "Can read articles (applies to article or topic level)" => "Can read articles (applies to article or topic level)",
"Can remove articles" => "Pots esborrar articles",
"Can remove submissions" => "Pots esborrar trameses",
"Can submit articles" => "Pots trametre articles",
"Can rate articles" => "Pots Valorar Articles",
"Can view recordings from past meetings" => "Pots veure les gravacions de les reunions anteriors",
"Can join a meeting" => "Pots unir-se a una reunió",
"Can moderate a meeting" => "Pots moderar una reunió",
"Can create a meeting" => "Pots crear una reunió",
// "Can use XMPP chat" => "Can use XMPP chat",
"Can admin blogs" => "Pots administrar blocs",
"Can assign perms to blog" => "Pots assignar permisos a blocs",
"Can post to a blog" => "Pots publicar en un bloc",
"Can create a blog" => "Pots crear un bloc",
"Can read blogs" => "Pots llegir blocs",
"Can view in module and feed the blog posts" => "Es pot veure en el mòdul i alimentar les entrades del bloc",
"Can view in module and feed the blog" => "Es pot veure en el mòdul i alimentar el blog",
"Can create/admin calendars" => "Pots crear/administrar calendaris",
"Can add events in the calendar" => "Pots afegir esdeveniments al calendari",
"Can edit events in the calendar" => "Pots canviar esdeveniments del calendari",
"Can browse the calendar" => "Pots navegar pel calendari",
"Can view event details" => "Pots visualitzar informació dels esdeveniments",
"Can add himself or herself to the participants" => "Es pot afegir el propi usuari als participants",
"Can add guest to the participants" => "Pots afegir convidats als participants",
"Can view Tiki tools calendar" => "Pots veure el calendari d'eines de Tiki",
"Can admin categories" => "Pots administrar categories",
"Can see the category in a listing" => "Pots veure la categoria en una llista",
"Can add objects to the category (tiki_p_modify_object_categories permission required)" => "Pots afegir objectes a la categoria (tiki_p_modify_object_categories necessitats)",
"Can remove objects from the category (tiki_p_modify_object_categories permission required)" => "Pots eliminar els objectes de la categoria (tiki_p_modify_object_categories necessitats)",
"Can assign perms to category" => "Es poden assignar permisos a la categoria",
"Administrator can create channels, remove channels, etc" => "L'administrador pot crear canals, eliminar canals, etc",
"Can use the chat system" => "Pots utilitzar el sistema de xat",
"Can admin received articles" => "Pots administrar articles rebuts",
"Can admin received pages" => "Pots administrar pàgines rebudes",
"Can send articles to other sites" => "Pots enviar articles a altres llocs web",
"Can send articles to this site" => "Pots enviar articles a aquest lloc web",
"Can send pages to this site" => "Pots enviar pàgines a aquest lloc web",
"Can send pages to other sites" => "Pots enviar pàgines a altres llocs web",
"Can post new comments" => "Pots publicar nous comentaris",
"Can read comments" => "Pots llegir comentaris",
"Can admin comments" => "Pots administrar comentaris",
"Can edit all comments" => "Pots editar tots els comentaris",
"Can delete comments" => "Pots esborrar comentaris",
"Can vote on comments" => "Pots votar comentaris",
"Can admin content templates" => "Pots administrar plantilles de contingut",
"Can edit content templates" => "Pots editar plantilles de contingut",
// "Can lock content templates" => "Can lock content templates",
"Can use content templates" => "Pots utilitzar plantilles de contingut",
"Can admin contributions" => "Pots administrar contribucions",
"Can admin the directory" => "Pots administrar el directori",
"Can admin directory categories" => "Pots administrar categories de directoris",
"Can admin directory sites" => "Pots administrar enllaços",
"Submitted links are valid" => "Enllaços presentats són vàlids",
"Can submit sites to the directory" => "Pots trametre llocs web al directori",
"Can validate submitted links" => "Pots validar els enllaços tramesos",
"Can use the directory" => "Pots utilitzar el directori",
"Can execute arbitrary queries on a given DSN" => "Pots executar consultes arbitràries en un DSN donat",
"Can admin FAQs" => "Pots administrar pmf",
"Can suggest FAQ questions" => "Pots suggerir preguntes pmf",
"Can view FAQs" => "Pots visualitzar pmf",
"Can download files" => "Pots descarregar arxius",
"Can upload files" => "Pots penjar arxius",
"Can list file galleries" => "Pots llistar galeries d'arxius",
"Can view file galleries" => "Pots visualitzar galeries d'arxius",
"Can admin file galleries" => "Pots administrar galeries d'arxius",
"Can assign permissions to file galleries" => "Pots assignar permisos a galeries d'arxius",
"Can use Directory Batch Load" => "Pots utilitzar Directory Càrrega per lots",
"Can upload .zip file packages" => "Pots penjar arxius zip amb arxius",
"Can create file galleries" => "Pots crear galeries d'arxius",
"Can edit a gallery file" => "Pots editar un arxiu de la galeria",
"Can remove files" => "Pots eliminar arxius",
"Can view file galleries explorer" => "Pots visualitzar l'explorador de galeries d'arxius",
"Can view file galleries path" => "Pots visualitzar el camí de les galeries d'arxius",
// "Can upload files containing JavaScript" => "Can upload files containing JavaScript",
// "Can upload SVG files" => "Can upload SVG files",
"Can admin forums" => "Pots administrar fòrums",
"Can attach files to forum posts" => "Pots adjuntar a publicacions del fòrum",
"Auto approve forum posts" => "Auto aprova les publicacions dels fòrums",
"Can post in forums" => "Pots publicar als fòrums",
"Can start threads in forums" => "Pots iniciar fils de discussió als fòrums",
"Can read forums" => "Pots llegir fòrums",
"Can report posts to moderator" => "Pots transmetre missatges al moderador",
"Can vote on comments in forums" => "Pots votar comentaris de fòrums",
"Can browse tags" => "Pots navegar per les marques lliures",
"Can admin tags" => "Pots administrar les marques lliures",
"Can tag objects" => "Pots etiquetar objectes",
"Can unassign tags from an object" => "Pots desassignar etiquetes d'un objecte",
"Can subscribe to groups" => "Pots subscriure a grups",
"Can invite user to my groups" => "Es pot convidar usuaris als meus grups",
"Can view the group" => "Es pot veure el grup",
"Can view the group members" => "Pots veure els membres del grup",
"Can add group members" => "Pots afegir membres del grup",
"Can remove group members" => "Pots treure membres del grup",
"Can join or leave the group" => "Pots unir-se o abandonar el grup",
// "Can view H5P content" => "Can view H5P content",
// "Can edit H5P content" => "Can edit H5P content",
// "Can administer H5P content" => "Can administer H5P content",
"Can edit HTML pages" => "Pots editar pàgines HTML",
"Can view HTML pages" => "Pots visualitzar pàgines HTML",
"Can admin Image Galleries" => "Pots administrar galeries d'imatges",
"Can assign permissions to image galleries" => "Pots assignar permisos a la galeria d'imatges",
"Can upload .zip files of images" => "Pots penjar arxius zip amb imatges",
"Can create image galleries" => "Pots crear galeries d'imatges",
"Can list image galleries" => "Pots llistar galeries d'imatges",
"Can upload images" => "Pots penjar imatges",
"Can view image galleries" => "Pots visualitzar galeries d'imatges",
"Can admin Kaltura video feature" => "Can funció de vídeo administrador Kaltura",
"Can upload video or record from webcam" => "Pots pujar un vídeo o gravació de la càmera web",
"Can edit media information" => "Pots editar la informació dels mitjans de comunicació",
"Can delete media" => "Esborra suports",
"Can download media" => "Pots descarregar arxius multimèdia",
"Can list media" => "Pots enumerar els mitjans de comunicació",
"Can view media" => "Pots veure els mitjans de comunicació",
"Can broadcast messages to all users" => "Pots difondre missatges a tots els usuaris",
"Can broadcast messages to groups" => "Pots difondre missatges a grups",
"Can use the messaging system" => "Pots utilitzar el sistema de missatgeria",
"Can admin newsletters" => "Pots administrar butlletins",
"Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)" => "Pots subscriure molts correus-e alhora (requereix tiki_p_subscribe email)",
"Can send newsletters" => "Pots enviar butlletins",
"Can subscribe any email address to newsletters" => "Pots subscriure els correus-e als butlletins",
"Can subscribe to newsletters" => "Pots subscriure a butlletins",
"Can view the archive of a newsletters" => "Pots veure l'arxiu d'un butlletí",
"Can list newsletters" => "Pots enumerar butlletins",
"Can administer payments" => "Pots administrar els pagaments",
"Can view payment requests and details" => "Pots veure les sol·licituds i les dades de pagament",
"Can enter manual payments" => "Pots introduir pagaments manuals",
"Can request a payment" => "Es pot sol·licitar un pagament",
"Can view the perspective" => "Es pot veure la perspectiva",
"Can edit the perspective" => "Pots editar la perspectiva",
"Can create a perspective" => "Es pot crear una perspectiva",
"Can admin perspectives" => "Pots administrar la perspectiva",
"Can admin polls" => "Pots administrar sondejos",
"Can view poll results" => "Pots veure resultats dels sondejos",
"Can view poll user choices" => "Pots veure les opcions d'usuari en sondejos",
"Can vote in polls" => "Pots votar als sondejos",
"Can view poll voters" => "Pots veure els votants d'un sondeig",
"Can admin quizzes" => "Pots administrar concursos",
"Can take quizzes" => "Pots participar a concursos",
"Can view quiz stats" => "Pots visualitzar estadístiques dels concursos",
"Can view user quiz results" => "Pots visualitzar resultats dels usuaris en els concursos",
"Can admin spreadsheets" => "Pots administrar fulls",
"Can create and edit spreadsheets" => "Pots crear i editar fulls",
"Can view spreadsheets" => "Pots visualitzar un full",
"Can view spreadsheets history" => "Pots visualitzar l'historial de fulls",
"Can admin the shoutbox (edit/remove messages)" => "Pots administrador xerrada (Edita / suprimir missatges)",
"Can post messages in the shoutbox" => "Pots enviar missatges al quadre de xerrada",
"Can view the shoutbox" => "Pots veure el quadre de xerrada",
"Can use social network integration" => "usuari pot utilitzar integració de xarxes socials",
"Can register this site with social networks" => "usuari pot registrar aquest lloc amb les xarxes socials",
"Admin live support system" => "Sistema de suport directe administració",
"Can use live support system" => "Es pot utilitzar el sistema de suport directe",
"Can admin surveys" => "Pots administrar enquestes",
"Can take surveys" => "Pots fer enquestes",
"Can view survey stats" => "Pots visualitzar estadístiques d'enquestes",
"Can admin TikiTests" => "Pots l'administració TikiTests",
"Can edit TikiTests" => "Pots editar TikiTests",
"Can replay TikiTests" => "Pots reproduir els TikiTests",
"Can admin trackers" => "Pots administrar formularis-bd",
"Can attach files to tracker items" => "Pots adjuntar fitxers a ítems de formularis-bd",
"Can view tracker item attachments and download them" => "Pots veure adjunts a ítems de formularis-bd i descarregar-los",
"Can post tracker item comments" => "Pots inserir comentaris per a ítems de formularis-bd",
"Can view tracker item comments" => "Pots veure comentaris a ítems de formularis-bd",
"Can create new tracker items" => "Pots crear nous registres per a formularis-bd",
"Can list trackers" => "Pots llistar formularis-bd",
"Can change tracker items" => "Pots canviar ítems de formularis-bd",
"Can change pending tracker items" => "Pots canviar els ítems pendents de formularis-bd",
"Can change closed tracker items" => "Pots canviar els ítems tancats de formularis-bd",
"Can remove tracker items" => "Pots eliminar ítems de formularis-bd",
"Can remove pending tracker items" => "Pots eliminar ítems pendents de formularis-bd",
"Can remove closed tracker items" => "Pots eliminar ítems tancats de formularis-bd",
"Can view rating result for tracker items" => "Pots visualitzar el resultat de la valoració d'ítems de formularis-bd",
"Can rate tracker items" => "Pots votar per a una valoració d'ítems de formularis-bd",
"Can re-rate tracker items" => "Pots tornar a votar una qualificació d'ítems de formularis-bd",
"Can view trackers" => "Pots visualitzar formularis-bd",
"Can view closed trackers items" => "Pots veure ítems tancats de formularis-bd",
"Can view pending trackers items" => "Pots veure ítems pendents de formularis-bd",
"Can watch a tracker" => "Pots vigilar formularis-bd",
"Can export tracker items" => "Pots exportar ítems de formularis-bd",
"Can save a CSV backup of all trackers" => "Pots desar un fitxer. CSV de còpia de seguretat de formularis-bd sencers",
// "Manage tracker views" => "Manage tracker views",
// "View list view of tracker tabular data. Tracker item permissions apply" => "View list view of tracker tabular data. Tracker item permissions apply",
// "Export a tracker tabular view to CSV. Tracker permissions may not apply" => "Export a tracker tabular view to CSV. Tracker permissions may not apply",
// "Import a CSV file into a tabular tracker. Tracker permissions may not apply" => "Import a CSV file into a tabular tracker. Tracker permissions may not apply",
"Can trigger the transition between two states" => "Pots desencadenar la transició entre dos estats",
"Can admin users" => "Pots administrar usuaris",
"Can cache user bookmarks" => "Pots emmagatzemar en memòria cau punts d'un usuari",
"Can configure modules" => "Pots configurar mòduls",
"Can create user bookmarks" => "Pots crear adreces d'interès d'usuari",
"Can use the mini event calendar" => "Pots utilitzar el minicalendari d'esdeveniments",
"Can use the notepad" => "Pots utilitzar el bloc de notes",
"Can admin public tasks" => "Pots administrar tasques públiques",
"Can use tasks" => "Pots utilitzar tasques",
"Can receive tasks from other users" => "Pots rebre tasques d'altres usuaris",
"Can send tasks to other users" => "Pots enviar tasques a altres usuaris",
"Can upload personal files" => "Pots penjar arxius personals",
"Can create items in personal menu" => "Pots crear elements al menú personal",
"Can list registered users" => "Pots llistar usuaris registrats",
"Can invite users by email, and include them in groups" => "Es pot convidar els usuaris per correu electrònic, i incloure'ls en els grups",
"Can delete his/her own account" => "Pots eliminar el seu / la seva pròpia compte",
"Can use webmail" => "Pots utilitzar el correu web",
"Can use group webmail" => "Pots utilitzar grups webmail",
"Can admin group webmail accounts" => "Pots comptes de correu web al grup d'administració",
"Can use personal webmail accounts" => "Pots utilitzar els comptes de correu web personal",
"Can admin personal webmail accounts" => "Pots comptes de correu web d'administració personals",
"Can view page/pages" => "Pots visualitzar pàgina/es",
"Can edit pages" => "Pots editar pàgines",
"Can inline-edit pages" => "Pots editar pàgines en-línia",
"Can view wiki history" => "Pots visualitzar historials wiki",
"Can admin the wiki" => "Pots administrar el wiki",
"Can assign permissions to wiki pages" => "Pots assignar permisos a pàgines wiki",
"Can edit copyright notices" => "Pots editar avisos de copyright",
"Can edit dynamic variables" => "Pots editar variables dinàmiques",
"Can export wiki pages using the export feature" => "Pots exportar les pàgines wiki utilitzant la funció d'exportació",
"Can lock pages" => "Pots bloquejar pàgines",
"Can save as a minor edit" => "Pots guardar com a edició menor",
"Can remove" => "Pots esborrar",
"Can rename pages" => "Pots canviar noms de pàgines",
"Can roll back pages" => "Pots pàgines rollback",
"Can upload pictures to wiki pages" => "Pots penjar imatges en pàgines wiki",
"Can use the page as a template for a tracker or unified search" => "Pots utilitzar la pàgina com a plantilla per a seguiment o cerca unificada",
"Can view in module and feed the wiki pages reference" => "Es pot veure en el mòdul i alimentar el wiki referència pàgines",
"Can admin attachments on wiki pages" => "Pots adjunts administrador en pàgines wiki",
"Can add and change ratings on wiki pages" => "Pots afegir i canviar valoracions a les pàgines wiki",
"Can attach files to wiki pages" => "Pots adjuntar fitxers a pàgines wiki",
"Can view and download wiki page attachments" => "Pots visualitzar fitxers wiki adjunts i descarregar-los",
"Can view wiki comments" => "Pots visualitzar comentaris wiki",
"Can view rating of wiki pages" => "Pots visualitzar la valoració de pàgines wiki",
"Can view source of wiki pages" => "Pots visualitzar l'origen de les pàgines wiki",
"Can participate in rating of wiki pages" => "Poden participar a la qualificació de les pàgines wiki",
"Can view similar wiki pages" => "Pots veure les pàgines wiki similars",
"View page backlinks" => "Veure pàgina de backlinks",
"Can view unapproved revisions of pages" => "Pots veure les revisions aprovades de pàgines",
"Can approve revisions of pages" => "Pots aprovar les revisions de les pàgines",
"Can view contributions to a page" => "Pots veure les contribucions a una pàgina",
"Can use reference library items" => "Pots utilitzar els elements de la biblioteca de referència",
"Can add to, edit and remove reference library items" => "Pots afegir, editar i eliminar elements de la biblioteca de referència",
// "Can administer structures" => "Can administer structures",
"Can create and edit structures" => "Pots crear i editar estructures",
// "Can lock structures" => "Can lock structures",
"Can watch structures" => "Pots vigilar estructura",
"Administrator can manage users, groups and permissions and all features" => "L'administrador pot gestionar usuaris, grups i permisos i totes les característiques",
"Can access site when closed" => "Pots accedir al lloc web quan està tancat",
"Administrator can admin banners" => "Administrador pot banners administració",
"Can ban users or IP addresses" => "Es pot prohibir als usuaris o ips",
"Can admin the dynamic content system" => "Pots administrar el sistema de contingut dinàmic",
"Can admin integrator repositories and rules" => "Pots administració repositoris integrador i regles",
// "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n" => "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n",
"Can admin mail-in accounts" => "Pots administrar comptes de correu-dins",
"Can edit object permissions" => "Pots editar permisos d'objectes",
"Can admin external feeds" => "Poden els aliments administrador extern",
"Can clean cache" => "Pots esborrar la memòria cau",
"Can create a new CSS file (style sheet) appended with -user" => "Pots crear un nou CSS sufix d'usuari",
"Can remove the association between two pages in a translation set" => "Pots eliminar l'associació entre dues pàgines en un conjunt de traducció",
"Can admin cookies" => "Pots administrar galetes",
"Can edit translations and create new languages" => "Pots editar traduccions i crear nous llenguatges",
"Can edit menus" => "Pots editar menús",
"Can edit menu options" => "Pots editar opcions de menú",
"Can edit site templates" => "Pots editar plantilles de lloc web",
"Can search" => "Pots buscar",
"Can report a link to the webmaster" => "Pots informar d'un enllaç a l'administrador",
"Can send a link to a friend" => "Pots enviar un enllaç a un amic",
"Can share a page (email, Twitter, Facebook, message, forums)" => "Pots compartir una pàgina (correu electrònic, Twitter, Facebook, missatges, fòrums)",
"Can use HTML in pages" => "Pots utilitzar HTML a les pàgines",
"Can view action log" => "Pots veure el registre de l'acció",
"Can view the action log for users of his or her groups" => "Pots veure el registre de l'acció per als usuaris dels seus propis grups",
"Can view integrated repositories" => "Pots visualitzar repositoris integrats",
"Can view results from user ratings" => "Pots veure els resultats de les valoracions d'usuaris",
"Can view referrer stats" => "Pots veure les estadístiques referrer",
"Can view site stats" => "Pots visualitzar estadístiques",
"Can view site templates" => "Pots visualitzar plantilles de llocs web",
// "Can view results from webservice requests" => "Can view results from webservice requests",
// "Can administer webservices" => "Can administer webservices",
"Can admin toolbars" => "Poden les barres d'eines d'administració",
"Trust all user inputs including plugins (no security checks)" => "Confiar en totes les entrades de l'usuari, incloent plugins (no hi ha controls de seguretat)",
"Can view unapproved plugin details" => "Pots veure els detalls de connector no aprovats",
"Can execute unapproved plugin registered" => "Pots executar plugins no aprovat registrats",
"Can approve plugin execution" => "Es pot aprovar l'execució complement",
"Can admin mail notifications" => "L'administrador pot enviar notificacions",
"Can use the importer" => "Pots utilitzar l'importador",
"Can change the categories of an object" => "Pots canviar les categories de l'objecte",
"User can administer modules" => "L'usuari pot administrar mòduls",
"Can switch between wiki and WYSIWYG modes while editing" => "Es pot canviar entre els modes d'edició wiki i WYSIWYG",
"Can create a new workspace for a given template" => "Es pot crear un nou espai de treball de la plantilla donada",
// "Can manage all aspects of a goal" => "Can manage all aspects of a goal",
// "Can manage who is eligible for a goal" => "Can manage who is eligible for a goal",
// "Cannot add user %0 to nonexistent group %1" => "Cannot add user %0 to nonexistent group %1",
// "Cannot add nonexistent user %0 to group %1" => "Cannot add nonexistent user %0 to group %1",
"User \"%0\" is banned from the group \"%1\"" => "Usuari \" %0\" està prohibit en el grup \" %1 \"",
"Do you want to unban them and continue" => "Vols eliminar la prohibició i continuar",
// "Email cannot be set because this email is already in use by another user" => "Email cannot be set because this email is already in use by another user",
"Password should be at least %0 characters long" => "La contrasenya ha de tenir almenys %0 caràcters",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"" => "La contrasenya ha de contenir almenys un caràcter alfabètic en minúscula com una i altra en majúscules com A",
"Password must contain both letters and numbers" => "La contrasenya ha de contenir tant lletres com números",
"Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "La contrasenya ha de contenir almenys un caràcter especial en minúscules com \" / \$ % ? & * ( ) _ + ..",
// "The password is blacklisted because it is too common" => "The password is blacklisted because it is too common",
// "No user tracker found with id #%0" => "No user tracker found with id #%0",
"The administrator has not yet validated your account. Please wait." => "L'administrator no ha validat el teu compte encara. Si us plau, espera.",
"You must validate your account first. An email has been sent to you" => "Primer has de validar el teu compte. Se t'ha enviat un correu-e",
// "Email address is required" => "Email address is required",
// "Invalid email address \"%0\"" => "Invalid email address \"%0\"",
// "Unable to send mail to invite \"%0\"" => "Unable to send mail to invite \"%0\"",
// "The email could not be retrieved from the IdP and is required" => "The email could not be retrieved from the IdP and is required",
// "The username could not be retrieved from the IdP and is required" => "The username could not be retrieved from the IdP and is required",
// "SAML Login failed. User not authenticated" => "SAML Login failed. User not authenticated",
"Can edit one's own forum posts" => "Pots editar les seves publicacions del fòrum",
"The registration mail can't be sent. Contact the administrator" => "No es pot enviar el mail de registre. Contacteu amb l'administrador",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "No es pot enviar el correu-e de registre de noves altes per que no hi ha especificada cap adreça de correu-e, i la funcionalitat està desactivada",
"The user email confirmation can't be sent. Contact the administrator" => "No es pot enviar el correu-e de confirmació de l'usuari. Contacta l'administrador",
// "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)",
"Edit field: (Incorrect validation parameter)" => "Edita camp: (paràmetre de validació incorrecta)",
"Page already exists" => "la pàgina ja existeix",
"Page does not exist" => "La pàgina no existeix",
// "Email already in use" => "Email already in use",
"Invalid email" => "Correu-e invàlid",
"Invalid character combination for username" => "Combinació de caracters invàlida com a nom d'usuari",
// "Username must be all lower case" => "Username must be all lower case",
"Personal Phone" => "Telèfon personal",
"Personal Mobile" => "Mòbil personal",
"Personal Fax" => "Fax personal",
"Work Phone" => "Telèfon de la feina",
"Work Mobile" => "Mòbil de la feina",
"Work Fax" => "Fax de la feina",
"Company" => "Empresa",
"Organization" => "Organització",
"Department" => "Departament",
"Division" => "Divisió",
"Job Title" => "Càrrec",
"Street Address" => "Adreça",
"City" => "Població",
"State" => "Estat",
"Postal Code" => "Codi postal",
// "Mail to: User not found" => "Mail to: User not found",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PUNT)",
// "Webservice error on %0 request \"%1\"" => "Webservice error on %0 request \"%1\"",
// "You will need to rebuild the search index to see these changes" => "You will need to rebuild the search index to see these changes",
// "Parse To Wiki %0: preg_replace error #%1" => "Parse To Wiki %0: preg_replace error #%1",
"Cannot create aliased page" => "No es pot crear una pàgina que ja està emulada a través d'un alias",
"You attempted to create the following page" => "Has intentat crear la següent pàgina",
"That page is an alias for the following pages" => "Aquesta pàgina és un alias per a les següents pàgines",
"If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this" => "Si realment vols crear la pàgina, primer has d'editar cadascuna de les pàgines de més amunt, i eliminar l'enllaç de tipus alias que contenen. Aquest enllaç hauria de semblar quelcom com",
"Can't parse HTML data - no grammar file" => "No es pot analitzar dades HTML - no hi ha arxiu de gramàtica",
"Rollback by %0 to version %1" => "Versió rollback",
"Removed version \$version" => "Versió \$version eliminada",
"Changed actual version to \$version" => "La versió actual s'ha canviat a \$version",
"No version indicated" => "No s'ha indicat cap versió",
"Plugin " => "Connector (plugin) ",
"failed" => "sense èxit",
"Required parameters are in</em> <b>bold</b>" => "Els paràmetres requerits són en </em> <b>negreta</​​b>",
"Parameter Info" => "Informació de paràmetres",
"There are no approved versions of this page" => "No hi ha versions aprovades d'aquesta pàgina",
"Semantic token already exists" => "Ja hi ha token Semàntic",
"Invalid semantic token name" => "No vàlid nom del token semàntic",
"Semantic token not found" => "No es troba el token semàntic",
"Page locked" => "Pàgina bloquejada",
"Page unlocked" => "Pàgina desbloquejada",
// "Initial content copied from version %0 of page %1" => "Initial content copied from version %0 of page %1",
// "You don't have permission to use category '%0'" => "You don't have permission to use category '%0'",
// "You don't have permission to edit categories" => "You don't have permission to edit categories",
// "You don't have permission to edit tags" => "You don't have permission to edit tags",
"Removed last version" => "Úlitma versió eliminada",
"Activity Stream" => "Flux d'Activitat",
// "Create a social network activity stream" => "Create a social network activity stream",
"List configuration information" => "Informació de configuració de la llista",
// "Auto-Scroll" => "Auto-Scroll",
// "Automatically load next page of results when scrolling down" => "Automatically load next page of results when scrolling down",
"Add Tag" => "Afegir etiqueta",
// "Provide an input field for adding a tag to an object" => "Provide an input field for adding a tag to an object",
// "Object type and id, as in %0type:id%1, if unset, will use current object" => "Object type and id, as in %0type:id%1, if unset, will use current object",
"Add Reference" => "Afegeix referència",
// "Add a bibliography reference" => "Add a bibliography reference",
"Biblio Code" => "Codi Biblio",
"The code to be added as reference" => "El codi que s'afegeix com a referència",
// "missing bibliography definition" => "missing bibliography definition",
"Add Relation" => "Afegeix relacions",
// "Provide a button to toggle a pre-specified relation" => "Provide a button to toggle a pre-specified relation",
"Qualifier" => "Qualifier",
"Relation qualifier. Usually a three-part string separated by two periods" => "Relació qualificador. En general, una sèrie de tres parts separades per 2 períodes",
"Source Object" => "Objecte d'origen",
// "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank",
"Target Object" => "Objecte de destinació",
// "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank",
"Button Text for Add" => "Text del botó d'Afegir",
"Text to show on the button to add relation" => "Text a mostrar al botó per afegir relació",
"Button Text for Already Added State" => "Text del botó d'estat Ja s'ha afegit",
"Text to show on the button when relation is already added" => "Text a mostrar al botó quan ja s'ha afegit relació",
"Relation Added" => "Relació Alta",
"Mouseover Button Text for Remove" => "Situeu el ratolí sobre el text del botó per treure",
"Text to show on the button to remove relation" => "Text a mostrar al botó per treure relació",
"Remove Relation" => "Traieu Relació",
"Button ID" => "Botó Aneu",
"A unique ID to distinguish the button from others on the page if there is more than one" => "Un identificador únic per distingir el botó d'altres a la pàgina si hi ha més d'un",
// "Set Button Class" => "Set Button Class",
// "Class or classes for the Button" => "Class or classes for the Button",
"Source and target object cannot be the same" => "Origen i destinació objecte no pot ser la mateixa",
"Add to cart" => "Afegir a la cistella",
"PluginAddToCart" => "PluginAddToCart",
// "Add a product to the shopping cart" => "Add a product to the shopping cart",
"Product code" => "Codi del producte",
"Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Identificador únic pel producte. Dos productes amb el mateix codi serà el mateix i la informació utilitzada serà l'un dels primers a",
"Label for the product in the cart" => "Etiqueta per el producte a la cistella",
"Product Type" => "Tipus de producte",
"The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket" => "El tipus de producte que es ven, el que afectarà el compliment, per exemple, producte estàndard, certificat de regal, butlletes per a esdeveniments",
"Product Class" => "Classe de producte",
"The class the product belongs to. Can be used to limit how gift cards are used" => "La classe del producte forma part d', es pot utilitzar per limitar com s'utilitzen targetes de regal",
"Product Bundle" => "Paquet del producte",
"The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart" => "El paquet del producte forma part, es pot utilitzar per limitar com s'usen les targetes de regal, afegirà automàticament altres productes de la mateixa classe a la cistella",
"Bundle Class" => "Paquet Classe",
"The class the bundle belongs to. Can be used to limit how gift cards are used" => "La classe del paquet pertany a, es pot utilitzar per limitar com s'utilitzen targetes de regal",
"Price" => "Preu",
"The price to charge for the item" => "El preu a cobrar per l'element",
// "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)" => "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)",
"Button label" => "Etiqueta del botó",
// "Text for the submit button. default" => "Text for the submit button. default",
"Associated event code" => "Codi d'esdeveniment associat",
"Unique identifier for the event that is associated to the product" => "Identificador únic per a l'esdeveniment que està associat al producte",
"Automatically check out" => "Automàticament checkout",
"Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)" => "Caixa automàtica per a la compra i enviar l'usuari a pagar (això es desactiva quan ja hi ha alguna cosa al carro)",
// "Hide Quantity" => "Hide Quantity",
// "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)" => "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)",
"Buy on behalf of" => "Comprar a nom de",
"Allows the selection of user to make purchase on behalf of" => "Permet la selecció d'usuari per fer la seva compra en nom de",
"Shop as anonymous always" => "Compres com a anònim sempre",
"Add to cart as anonymous shopper even if logged in" => "Afegir a la cistella com a comprador anònim fins i tot si connectat",
"Forward to this URL after free purchase" => "Remetre a aquesta URL després de la compra gratis",
"Gift certificate" => "Certificat de regal",
"Allows user to add gift certificate from the product view" => "Permet a l'usuari afegir un certificat de regal de la vista de producte",
"Order Item ID to exchange product" => "Ordre ID d'article per a l'intercanvi de productes",
"Used in conjunction with exchange feature" => "S'utilitza juntament amb el canvi de funció",
"Product ID to exchange to" => "ID del producte per a l'intercanvi de",
"Amount of new product to exchange for" => "Nombre de nous productes per a l'intercanvi de",
"Should normally be set to the amount of products in the order being exchanged" => "Normalment s'ha d'ajustar a la quantitat de productes en l'ordre en què s'intercanvien",
"Ajax add to cart feature" => "Ajax afegir a la cistella funció",
"Attempts to turn on Ajax for the cart" => "Els intents de convertir ajax per al carret de",
"Weight" => "Pes",
// "The weight of the item" => "The weight of the item",
"The order was recorded and is now awaiting payment. Reference number is %0" => "L'ordre va ser gravat i ara està a l'espera del pagament. Número de referència és %0",
"Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "El seu ordre exempta de %0 (1%) ha estat processat. Un correu electrònic ha estat enviat per a arxiu",
"Your free order of %0 (%1) has been processed" => "El seu ordre exempta de %0 (1%) ha estat processat",
"%0 (%1) was added to your cart" => "%0 (%1) ha estat afegit al teu carro",
"Add to Google Calendar" => "Afegir a Google Calendar",
"Add a calendar item to a Google calendar." => "Afegir un element de calendari a un calendari Google",
"Calendar item ID" => "ID tema Calendari",
"The item ID of the calendar to add to Google calendar" => "L'identificador d'element del calendari per afegir a Google Calendar",
"A calendar item ID number" => "Un nombre d'identificació ID d'element del calendari",
"Icon Style" => "Icona d'estil",
"Choose the icon style" => "Trieu l'estil d'icona",
"Either 1, 2 or 3" => "Qualsevol de 1, 2 o 3",
"Adjust Inventory" => "Ajust de la",
"PluginAdjustInventory" => "PluginAdjustInventory",
// "Adjust the inventory level of a product" => "Adjust the inventory level of a product",
"Product ID" => "Identificació del producte",
"Product ID of item in the cart tracker" => "ID del producte del punt al carro de seguiment",
// "Show Add" => "Show Add",
// "Show option to add to inventory" => "Show option to add to inventory",
// "Show Subtract" => "Show Subtract",
// "Show option to subtract from inventory" => "Show option to subtract from inventory",
"Inventory was adjusted by %0" => "Inventari es va ajustar per %0",
"User Agent Info" => "Agent d'usuari Informació",
"Show the user's browser and server information." => "Mostra el navegador de l'usuari i la informació del servidor",
"Info" => "Info",
"Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display és l'adreça IP del visitant (IP o per omissió), informació del navegador (browser), o el programari de servidor (SVRSW)",
"IP address" => "Adreça IP",
"Server software" => "Programari del servidor",
"Browser" => "Navegador",
// "Ajax Load" => "Ajax Load",
// "Load data into an HTML div using Ajax or in an iframe" => "Load data into an HTML div using Ajax or in an iframe",
// "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML" => "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML",
// "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1" => "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1",
// "Selector" => "Selector",
// "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1" => "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1",
"Target" => "Destí",
// "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page" => "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page",
// "HTML id for the div or iframe" => "HTML id for the div or iframe",
// "Class for the div or iframe" => "Class for the div or iframe",
// "In pixels or percentage. Default value is %0" => "In pixels or percentage. Default value is %0",
// "Make Links Absolute" => "Make Links Absolute",
// "Convert relative links in the incoming data to be absolute. Default value is \"All\"" => "Convert relative links in the incoming data to be absolute. Default value is \"All\"",
// "Images Only" => "Images Only",
// "Links Only" => "Links Only",
// "Parameter URL missing" => "Parameter URL missing",
"Anchor Link" => "Enllaç àncora",
"Create a link to an anchor" => "Crear un enllaç a una àncora",
"Anchor link label" => "Etiqueta de l'àncora",
"Anchor Name" => "Nom de l'Àncora",
"The anchor name as defined in the Aname plugin" => "El nom de l'àncora tal i com es defineix en el connector ANAME",
"The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "El nom de la pàgina wiki que conté l'àncora. Si està buit, el nom de l'àncora es buscarà a la pàgina wiki on s'utilitza el connector",
"Create an anchor that can be linked to" => "Crear una àncora que pot estar vinculat a",
"The name of the anchor" => "El nom de l'àncora",
"Image Annotation" => "Annotació d`Imatges",
"Annotate an image" => "Anotar una imatge",
"Autogenerated content. Leave blank initially" => "Contingut autogenerat. Deixa inicialment en blanc",
// "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0" => "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0",
// "Absolute URL to the image or relative path from Tiki site root" => "Absolute URL to the image or relative path from Tiki site root",
"Image width in pixels" => "Ample de la imatge en píxels",
"Image height in pixels" => "Alçada de la imatge en píxels",
"Alignment" => "Alineació",
// "Image alignment" => "Image alignment",
"Center" => "Centra",
"CSS Class" => "Classe CSS",
// "Class of the containing DIV element" => "Class of the containing DIV element",
// "Show List" => "Show List",
// "Show the list of annotations below the image" => "Show the list of annotations below the image",
// "(y/n)" => "(y/n)",
"Show Link" => "Mostra Enllaç",
// "Show the link below the label in the popups" => "Show the link below the label in the popups",
"Save changes to annotations" => "Desa els canvis a les anotacions",
"Image annotations changed" => "Les anotacions de la imatge han canviat",
"Editable" => "Editable",
"Label" => "Etiqueta",
"Application Frame" => "Marc d'aplicació",
// "Create a frame in which to assemble custom applications" => "Create a frame in which to assemble custom applications",
"Application layout" => "Disseny d'aplicacions",
"Minimum height" => "Cota mínima",
"Prevent the frame from becoming any shorter than the specified size" => "Prevenir el marc esdevingui més curt que la mida especificada",
"Maximum height" => "Cota màxima",
"Prevent the frame from becoming any higher than the specified size" => "Prevenir el marc esdevingui més alt que la mida especificada",
"Hide left column" => "Amaga columna de l'esquerra",
"Hide the left column when the application frame is in use to provide more space to the application" => "Amaga la columna de l'esquerra quan la finestra de l'aplicació s'utilitza per proporcionar més espai per a l'aplicació",
"Hide right column" => "Amaga la columna dreta",
"Hide the right column when the application frame is in use to provide more space to the application" => "Amaga la columna de la dreta, si la finestra de l'aplicació s'utilitza per proporcionar més espai per a l'aplicació",
"Full page" => "Pàgina plena",
"Completely fill the content area of the page" => "Ocupar l'àrea de contingut complet de la pàgina",
"Absolute Position" => "Posició Absoluta",
"Use all available space for the application frame (by means of CSS absolute positioning)" => "Col·loqui el marc d'aplicació per utilitzar la posició absoluta i realment utilitzar tot l'espai disponible",
"When using absolute mode, leave some space for the header at the top" => "Quan s'utilitza el mode absolut, deixar una mica d'espai per a la capçalera a la part superior",
"Fill the complete page" => "Ocupar la pàgina completa",
"Template file not found: %0" => "Arxiu de plantilla no es va trobar: %0",
"Pan/Zoom" => "Pa / Zoom",
"Select" => "Seleccionar",
"Select/Modify" => "Selecciona / Modificar",
"Draw Polygon" => "Dibuixar Polígon",
"Draw Path" => "Dibuixa Camí",
"Reset Zoom" => "Restablir zoom",
"Archive Builder" => "Creador de recopilatoris",
// "Define an archive that can be downloaded" => "Define an archive that can be downloaded",
"Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Descripció del contingut de l'arxiu comprimit. Controladors múltiples estan disponibles per a aquest tipus de contingut. Un per línia. Ex: page-as-pdf: some-folder/foo.pdf: HomePage, tracker adjunts: target-carpetes /: 3435",
"Archive Name" => "Nom del fitxer",
"Upon download, the name of the file that will be provided" => "Després de la descàrrega, el nom del fitxer que es proporcionarà",
"Missing \".zip\" file name extension" => "Falta zip extensió",
"Incorrect parameter" => "Paràmetre incorrecte",
"Download archive" => "Descarregar arxiu",
"Display a field of an article" => "Mostrar un camp d'un article",
"The article field (component) to display. The default field is \"Heading\"" => "El camp de l'article a mostrar. El camp per omissió és la Capçalera",
"Article ID" => "ID de l'article",
"The article to display. If no value is provided, the most recent article will be used" => "Article a mostrar. Si no es dóna cap valor, s'emprarà l'article més recent",
"Article List" => "Llista d'Articles",
"Display multiple articles" => "Mostra diversos articles",
"Use Pagination" => "Utilitza paginació",
// "Activate pagination when the articles list is long. Default is %0" => "Activate pagination when the articles list is long. Default is %0",
"Maximum Displayed" => "Màxim visualitzat",
// "The number of articles to display in the list (use %0 to show all)" => "The number of articles to display in the list (use %0 to show all)",
"Topic Name Filter" => "Topic Name Filter",
"Filter the list of articles by topic. Example: " => "Es filtra la llista d'articles de tema. Exemple:",
"Topic ID Filter" => "Tema ID Filter",
"Filter the list of articles by topic ID. Example: " => "Es filtra la llista d'articles de tema ID. Exemple:",
// "Valid topic IDs" => "Valid topic IDs",
"Type Filter" => "Tipus de filtre",
"Filter the list of articles by types. Example: " => "Es filtra la llista d'articles de tipus. Exemple:",
// "Valid article types" => "Valid article types",
"Category ID" => "ID de categoria",
// "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted" => "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted",
"List only articles in this language" => "Enumereu només articles en aquest idioma",
// "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items" => "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items",
// "random or column names to add _asc _desc to: " => "random or column names to add _asc _desc to: ",
"Specific order" => "Ordre específic",
"List of ArticleId that must appear in this order if present" => "Llista d'articleId que han d'aparèixer en aquest ordre si està present",
"Only these articles" => "Només aquests articles",
// "List of article IDs to display, separated by \"%0\"" => "List of article IDs to display, separated by \"%0\"",
"Not these articles" => "No aquests articles",
// "List of article IDs to not display, separated by \"%0\"" => "List of article IDs to not display, separated by \"%0\"",
"Quiet" => "Silenciós",
"Whether to not report when there are no articles (no reporting by default)" => "Si cal no dir res quan no hi ha articles (per omissió, no es diu res)",
"Title Only" => "Només Títol",
"Whether to only show the title of the articles (not set to title only by default)" => "Si cal mostrar només el títol dels articles (per omissió no es mostra només el títol sinó tot el resum)",
"Show Article Body" => "Mostra Cos de l'article",
// "Whether to show the body of the articles instead of the heading (not set by default)" => "Whether to show the body of the articles instead of the heading (not set by default)",
"Starting Article" => "Article inicial",
// "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)" => "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)",
"This will not work if Pagination is used" => "Això no funcionarà si s'utilitza paginació",
"Start Date" => "Data d'inici",
"Earliest date to select articles from" => "Primera data per seleccionar-ne els articles",
// " (%0YYYY-MM-DD%1)" => " (%0YYYY-MM-DD%1)",
"End date" => "Data de finalització",
"Latest date to select articles from" => "Darrera data per seleccionar-ne els articles",
"Period quantity" => "Quantitat del període escollit",
// "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored" => "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored",
"Period unit" => "Unitat del període escollit",
"Time unit used with \"Period quantity\"" => "Unitat de temps emprat per a la \"quantitat del període\"",
"Override Dates" => "Ignorar Dates",
// "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)" => "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)",
"Containing class" => "Classe Container",
// "CSS class to add to the containing \"div.article\" (default: \"%0\")" => "CSS class to add to the containing \"div.article\" (default: \"%0\")",
// "Valid CSS class" => "Valid CSS class",
"Large First Image" => "Primera imatge en gran",
// "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article" => "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article",
"Additional URL parameter for the link to read the article" => "URL addicional Param a l'enllaç per llegir l'article",
"Show actions (buttons and links)" => "Mostra accions (botons i enllaços)",
// "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do",
"No translation" => "Sense traducció",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language",
// "Use Source URL" => "Use Source URL",
// "Use the external source URL as link for articles" => "Use the external source URL as link for articles",
// "Display an attachment or a list of them" => "Display an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment",
"File" => "Fitxer",
"Same as name" => "Igual que el nom",
// "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page",
"Show Description" => "Mostrar descripció",
"Shows the description as the link text instead of the file name (not used by default)" => "Mostra la descripció que el text de l'enllaç en lloc del nom del fitxer (no s'utilitza per omissió)",
"Bullets" => "Vinyetes",
"Makes the list of attachments a bulleted list (not set by default)" => "Fa que la llista de fitxers adjunts d'una llista amb vinyetes (no s'estableix per omissió)",
// "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)",
"Custom Label" => "Etiqueta personalitzada",
// "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed" => "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)",
"Order Number" => "Número de comanda",
// "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment",
// "Attachment name, file, id or num" => "Attachment name, file, id or num",
// "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)",
"File Type Icon" => "Icona de l'Arxiu Tipus",
// "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)" => "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)",
"Page \"%0\" does not exist" => "Pàgina \"%0\" no existeix",
"No such attachment on this page" => "Aquest fitxer adjunt no és en aquesta pàgina",
"Attributes" => "Atributs",
"Assign generic attributes to the current object" => "Assignar atributs genèrics a fi actual",
// "Add popups and color coding that identifies authors" => "Add popups and color coding that identifies authors",
"Username of the author of the text" => "Nom d'usuari de l'usuari que va escriure el text",
"Deleted by User" => "Elim usuari",
"Username of the person who deleted the text" => "Nom d'usuari de l'usuari que ha eliminat el text",
"Make Visible" => "Fer visible",
"Show popup with author/deleted by" => "Mostrar emergent amb l'autor / esborrat",
"Generate a popup with names of author(s) (default: no)" => "Generar una finestra emergent amb els noms d'autor (s) (per omissió: no)",
"deleted by" => "esborrat",
"Should this author's contribution be visible (default: no)" => "Si la contribució d'aquest autor sigui visible (per omissió: no)",
// "Auto Query Args" => "Auto Query Args",
// "Automatically propagate arguments when clicking on links" => "Automatically propagate arguments when clicking on links",
// "Arguments for auto query" => "Arguments for auto query",
// "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin" => "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin",
"Profile picture" => "Profile picture",
"Display a user's profile picture" => "Mostra avatar d'un usuari",
// "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page" => "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page",
"Float" => "Flota",
"Align the profile picture on the page" => "Alinear l'avatar a la pàgina",
// "Full Size" => "Full Size",
// "If full-size images are stored in the file gallery, show the full-size image" => "If full-size images are stored in the file gallery, show the full-size image",
"Back" => "Enrera",
// "Display a link that goes back one page in the browser history" => "Display a link that goes back one page in the browser history",
// "List all pages that link to a particular page" => "List all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "A on apuntaran els enllaços de la pàgina. El valor per omissió és a la mateixa pàgina",
"Displayed Information" => "Informació mostrada",
"Pipe separated list of fields to display. ex: hits|user" => "Lista de camps separada per barres verticalsa mostrar. exexmple: hits|user",
"Excluded pages" => "Pàgines excloses",
// "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1" => "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1",
"Include Self" => "Inclou-re's a si mateix",
"With or without self-link (default is without)" => "Amb o sense auto-link (per omissió és sense)",
"With or without header (default is with header)" => "Amb o sense capçalera (per omissió és amb el cap)",
"With header" => "Amb capçalera",
"Without header" => "Sense capçalera",
"No pages link to" => "Cap pàgina enllaça",
"One page links to" => "Una pàgina apunta a",
"pages link to" => "pàgines que apunten a",
"Add a banner" => "Afegir un banner",
"Zone" => "Zona",
"Name of the zone created in Admin > Banners" => "Nom de la zona creada en Administració> Banners",
"Determines the browser behavior when the banner is clicked" => "Determina el comportament del navegador un cop que l'anunci es fa clic",
"missing parameter" => "manca paràmetre",
// "Benchmark" => "Benchmark",
// "Performance-test wiki content (used by developers to optimize plugins)" => "Performance-test wiki content (used by developers to optimize plugins)",
// "Iteration Quantity" => "Iteration Quantity",
// "The number of iterations to process" => "The number of iterations to process",
// "Each Iteration Details" => "Each Iteration Details",
// "Provides time and memory of each iteration" => "Provides time and memory of each iteration",
"BigBlueButton" => "BigBlueButton",
// "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system" => "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system",
"Meeting" => "Trobada",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1",
// "Anonymous Prefix" => "Anonymous Prefix",
"Unregistered users will get this token prepended to their name" => "Els usuaris no registrats rebran aquest text com a prefix del nom d'usuari que escullin en entrar a la Trobada",
"Welcome Message" => "Missatge de Benvinguda",
"A message to be provided when someone enters the room" => "Missatge que es mostrarà quan algú entri a la sala de la trobada",
"Dial Number" => "Número per a trucades",
"The phone-in support number to join from traditional phones" => "El número per a rebre trucades entrants que vinguin de telèfons tradicionals",
"Voice Bridge" => "Pont de veu",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID",
"Log-out URL" => "URL post-desconnexió",
"URL to which the user will be redirected after logging out of BigBlueButton" => "URL a la que re-dirigir als usuaris un cop es desconnectin de la trobada en BigBlueButton",
"Record" => "Registre",
// "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8" => "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8",
// "Display Recordings" => "Display Recordings",
// "Enable or Disable the display of video recordings" => "Enable or Disable the display of video recordings",
// "Display Attendees" => "Display Attendees",
// "Enable or Disable the display of attendees list" => "Enable or Disable the display of attendees list",
"BigBlueButton is misconfigured or inaccessible" => "El BigBlueButton es troba malament configurat o innaccessible per alguna raó",
"Blog List" => "Llista de blocs",
"Display posts from a site blog" => "Mostrar missatges d'un lloc de blocs",
"Blog ID" => "ID del bloc",
// "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown" => "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown",
"Maximum Items" => "Màxim Articles",
"Maximum number of entries to list (no maximum set by default)" => "Nombre màxim d'entrades a la llista (hi ha un màxim establert per omissió)",
"Only display posts created by this user (all posts listed by default)" => "Mostra només els missatges creats per aquest usuari (tots els llocs assenyalats per omissió)",
"Simple List" => "Llista simple",
// "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts" => "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts",
"Character Count" => "Nombre de caràcters",
// "Number of characters to display if not a simple list (defaults to all)" => "Number of characters to display if not a simple list (defaults to all)",
// "Word Boundary" => "Word Boundary",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only",
// "Ellipsis" => "Ellipsis",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)",
"More" => "Més",
// "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)",
// "Show Icons" => "Show Icons",
// "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)" => "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)",
// "Use Excerpt" => "Use Excerpt",
// "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)" => "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)",
"Earliest date to select posts from" => "Primera data per seleccionar missatges de",
"End Date" => "Data final",
"Latest date to select posts from" => "Darrera data per seleccionar missatges de",
"Container Class" => "Classe de contenidor",
// "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)" => "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)",
"Missing blog ID for Bloglist plugin" => "falta Aneu bloc per plugins BLOGLIST",
// "Create a formatted box with a title bar" => "Create a formatted box with a title bar",
// "Box Title" => "Box Title",
"Displayed above the content" => "Mostrat sobre el contingut",
"As defined by CSS, name, or color hex code" => "Tal i com es defineix pel CSS, nom o codi Hex",
// "Valid CSS color name or code" => "Valid CSS color name or code",
// "Box Width" => "Box Width",
"Text Alignment" => "Alineació del text",
"Aligns the text within the box (left-aligned by default)" => "Alinea el text dins del quadre (esquerra alineats per omissió)",
"Float Position" => "Posició flotant",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)",
"Clear" => "Neteja",
// "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)" => "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)",
"Apply custom CSS class to the box" => "Aplica classe CSS particular a la caixa",
"CSS Style" => "CSS Style",
// "Enter CSS styling tags for the div type used e.g. padding: 5px" => "Enter CSS styling tags for the div type used e.g. padding: 5px",
"Button" => "Botó",
"Add a link formatted as a button" => "Afegir un enllaç formatat com un botó",
// "Label for the button (ignored if the text is defined)" => "Label for the button (ignored if the text is defined)",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it" => "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it",
"Label for the button" => "Etiqueta per al botó",
// "Icon Name" => "Icon Name",
// "Enter an iconset name to show an icon in the button" => "Enter an iconset name to show an icon in the button",
// "Button Type" => "Button Type",
// "Use a type to style the button. By default btn-primary will be applied" => "Use a type to style the button. By default btn-primary will be applied",
// "Danger" => "Danger",
// "Primary" => "Primary",
// "Button width" => "Button width",
// "In pixels or percentage. (e.g. 200px or 100%)" => "In pixels or percentage. (e.g. 200px or 100%)",
// "Button height" => "Button height",
// "CSS class for the button. Note that the btn class is always applied by default" => "CSS class for the button. Note that the btn class is always applied by default",
// "CSS style attributes" => "CSS style attributes",
// "Link Relation" => "Link Relation",
// "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation" => "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation",
// "Auto Arguments" => "Auto Arguments",
// "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter" => "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter",
// "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL" => "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL",
// "Flip Id" => "Flip Id",
// "HTML id attribute of the element to show/hide content" => "HTML id attribute of the element to show/hide content",
// "Flip Hide Text" => "Flip Hide Text",
// "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown" => "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown",
// "Flip Default Open" => "Flip Default Open",
// "If set to %0, the flip is open by default (if no cookie jar)" => "If set to %0, the flip is open by default (if no cookie jar)",
// "Escape Apostrophes" => "Escape Apostrophes",
// "If set to %0, will escape the apostrophes in onclick" => "If set to %0, will escape the apostrophes in onclick",
// "Disable Button" => "Disable Button",
// "Set to %0 to disable the button" => "Set to %0 to disable the button",
"lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php falta o il·legibles",
"Display a calendar and its events" => "Mostrar un calendari i els esdeveniments",
"Calendar IDs" => "Calendari ID",
// "Comma-separated list of calendar Ids to restrict the events to specified calendars" => "Comma-separated list of calendar Ids to restrict the events to specified calendars",
"Example values" => "Valors d'exemple",
"Not set by default" => "No s'estableix per omissió",
"View Type" => "Tipus de Vista",
// "Determines how events" => "Determines how events",
// "%0 (default) shows events in a calendar" => "%0 (default) shows events in a calendar",
"View Time Span" => "Veure l'interval de temps",
// "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar" => "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar",
"Default is month" => "Per omissió és mes",
"Navigation Bar" => "Navigation Bar",
// "Show or hide the navigation bar (not shown by default)" => "Show or hide the navigation bar (not shown by default)",
"Carousel" => "Carrusel",
"Display images in a self-advancing carousel" => "Mostrar les imatges en un carrusel d'auto-promoció",
// "Images Source" => "Images Source",
// "Choose where to get your images from" => "Choose where to get your images from",
"Select an option" => "Seleccioneu una opció",
"All the images in a file gallery" => "Totes les imatges en una galeria del fitxer",
// "A list of file IDs" => "A list of file IDs",
"File Gallery ID" => "Galeria Arxiu ID",
"ID number of the file gallery that contains the images to be displayed" => "Número d'identificació de la galeria arxiu que conté les imatges que es mostraran",
// "File IDs" => "File IDs",
// "List of IDs of images from the File Galleries separated by commas" => "List of IDs of images from the File Galleries separated by commas",
"Sort Mode" => "Mode d'ordenació",
// "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2" => "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2",
// "Transition Time" => "Transition Time",
"The time (in milliseconds) for the transition between two images" => "El temps (en milisegons) que es necessita per a la transició entre dues imatges",
"number" => "nombre",
// "Display Time" => "Display Time",
"The time (in milliseconds) to display each image" => "El temps (en milisegons) per mostrar cada imatge",
// "Caption Height" => "Caption Height",
"The height of the caption. This is a fraction of the height of the images" => "L'alçada de la llegenda. Aquesta és una fracció de l'altura de les imatges",
"real between 0 and 1" => "real entre 0 i 1",
// "Display Progress Bar" => "Display Progress Bar",
// "Display Thumbnails" => "Display Thumbnails",
"Display thumbnails, number, count etc" => "Miniatures de presentació, nombre, recompte, etc",
"Buttons" => "Botons",
"Numbers" => "Números",
// "Thumbnail Box Width" => "Thumbnail Box Width",
// "Width of thumbnail box in CSS units (default %0)" => "Width of thumbnail box in CSS units (default %0)",
// "Thumbnail Box Height" => "Thumbnail Box Height",
// "Height of thumbnail box in CSS units (default %0)" => "Height of thumbnail box in CSS units (default %0)",
// "Start Automatically" => "Start Automatically",
"Start the carousel automatically when the page loads (default: Yes)" => "Moveu el carro automàticament quan es carrega la pàgina per omissió (Sí)",
"Legacy v2 param" => "Llegat param v2",
"Display thumbnails" => "Mostra imatges en miniatura",
// "Thumbnail Numbers" => "Thumbnail Numbers",
"Display place numbers in the thumbnail boxes" => "Mostra els números de lloc en els quadres en miniatura",
// "Thumbnail Background" => "Thumbnail Background",
"Use corresponding image as background for a thumbnail box" => "Utilitza imatge corresponent com a fons per a una caixa de miniatures",
// "Thumbnail Font Size" => "Thumbnail Font Size",
// "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)" => "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)",
"CSS units" => "Unitats de CSS",
// "Image Size" => "Image Size",
// "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels" => "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels",
"Real between 0 and 1, or integer over 10" => "Real entre 0 i 1, o el nombre enter més de 10",
// "Makes images clickable" => "Makes images clickable",
// "In case there are URLs in the image description, the image is made clickable and links to the first URL found" => "In case there are URLs in the image description, the image is made clickable and links to the first URL found",
"Cart Missing User Info" => "Cistella Missing Informació de l'usuari",
"PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check completeness of user input for a shopping cart transaction" => "Check completeness of user input for a shopping cart transaction",
// "Information Type" => "Information Type",
"Post Purchase" => "Purchase",
"Required before purchase" => "Requerit abans de la compra",
"Product Class ID" => "Identificació de producte Classe",
// "CasperJS" => "CasperJS",
// "Enable running CasperJS scripts from this Tiki site" => "Enable running CasperJS scripts from this Tiki site",
// "CasperJS not available" => "CasperJS not available",
// "Execute CasperJS script" => "Execute CasperJS script",
"List categories and objects assigned to them" => "Categories de la Llista i els objectes que se'ls assignin",
"Category IDs" => "IDs de les Categories",
// "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page" => "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page",
"Types" => "Tipus",
// "List of object types to include in the list, separated by \"+\", for example, " => "List of object types to include in the list, separated by \"+\", for example, ",
// "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)" => "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)",
"Hits Ascending" => "Vistes Ascendent",
"Hits Descending" => "Impactes Descendent",
"Item ID Ascending" => "ID de l'ítem Ascendent",
"Item ID Descending" => "ID de l'ítem Descendent",
"Type Ascending" => "Escriu ascendent",
"Type Descending" => "Escriu Descendent",
"Random" => "Atzar",
"Split" => "Separa",
"Whether multiple categories will be listed on different lines (default is to split them)" => "Si diverses categories es mostraran en diferents línies (per omissió és la de dividir)",
"And" => "I",
// "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)" => "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)",
// "Sub-categories" => "Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)",
"Show descriptions (not shown by default)" => "Mostrar la informació (no es mostra per omissió)",
"Show object names (shown by default)" => "Mostra noms d'objecte (que es mostra per omissió)",
"Show type (shown by default)" => "Mostra tipus (que es mostra per omissió)",
"One Per Line" => "Un per línia",
"Show one object per line (multiple per line shown by default)" => "Mostrar un objecte per línia (múltiple per línia mostra per omissió)",
// "Child Links" => "Child Links",
"Show children category links (shown by default)" => "Mostra els enllaços fills de la categoria (mostrats per omissió)",
// "Top Link" => "Top Link",
"Show top category link (shown by default)" => "Mostra enllaç de la categoria superior (que apareix per omissió)",
"Maximum Records" => "Max Registres",
// "Maximum number of objects to list (default is %0)" => "Maximum number of objects to list (default is %0)",
"Show title text above category object lists (shown by default)" => "Mostra el text títol anterior llistes d'objectes de categoria (que es mostra per omissió)",
"List only objects in this language" => "Enumereu només els objectes en aquest idioma",
// "Only apply if %0" => "Only apply if %0",
"Categories are disabled" => "Les Categories han estat deshabilitades",
"PluginCategoryTransition" => "PluginCategoryTransition",
"Display controls to trigger category transitions for any object" => "Mostra els controls per activar les transicions categoria per a qualsevol objecte",
"Redirect URL" => "Redireccionar URL",
"URL the user is sent to after transition is done" => "URL s'envia a l'usuari després que es realitza la transició",
"Category Orphans" => "Orfans de categoria",
"List objects that are not categorized" => "Llista d'objectes que no estan categoritzats",
// "Determine which type of objects are shown (default is %0)" => "Determine which type of objects are shown (default is %0)",
"Calendars" => "Calendaris",
// "Max" => "Max",
// "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records" => "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records",
"Result Offset" => "Resultat Offset",
"Result number at which the listing should start (default is no offset)" => "Resultat número en què la llista ha de començar (per omissió és no compensat)",
"Category Path" => "Ruta a la categoria",
"Show the full category path for a wiki page" => "Mostra la ruta de la categoria completa d'una pàgina wiki",
"Separator" => "Separador",
// "String used to separate the categories in the path. Default character is %0" => "String used to separate the categories in the path. Default character is %0",
"Display Top Category" => "Mostrar Top Categoria",
"Show the top category as part of the path name (not shown by default)" => "Demostri la categoria superior com a part del nom de la ruta (no es mostra per omissió)",
// "Access and use a cclite social credit and alternative currency account" => "Access and use a cclite social credit and alternative currency account",
// "Mode of operation - summary or recent. Default: %0" => "Mode of operation - summary or recent. Default: %0",
"Account summary" => "Resum de compte",
"Recent transactions" => "Transaccions recents",
"Registry" => "Registre",
"Registry to query. Default: site preference (or first in list when more than one)" => "Registre consultar. Per defecte: preferència lloc (o primer a la llista quan més d'un)",
"You need to be logged in to view this information" => "Has d'estar registrat per veure aquesta informació",
"Center text" => "Centrar text",
"Chart" => "Gràfic",
"Display a chart from TikiSheet." => "Mostra un gràfic de TikiSheet",
"Chart caption" => "Títol del gràfic",
"Spreadsheet ID" => "ID del Full",
"Data sheet ID" => "ID del Full de dades",
"Chart Type" => "Tipus de gràfic",
// "Specify a valid chart type" => "Specify a valid chart type",
"Chart Width" => "Amplada de gràfic",
"Width in pixels" => "Amplada en pixels",
"Chart Height" => "Alçada del gràfic",
"Height in pixels" => "Alçada en pixels",
"Value series" => "Sèries de valors",
"Required for pie charts" => "Requerit per gràfics de formatgets",
// "Independent series" => "Independent series",
"Required for types other than pie chart" => "Requerit per a tipus diferents dels gràfics de formatgets",
// "Dependent series" => "Dependent series",
"Description needed" => "Es necessita una descripció",
"Colors" => "Colors",
"List of colors to use" => "Llistat de colors a emprar",
"Styles" => "Estils",
"List of styles to use" => "Llista d'estils a emprar",
"Labels for the series or values in the legend" => "Etiquetes per les sèries o valors a la llegenda",
"Chart as PDF" => "Sondeig (chart) com a PDF",
"Chart as PostScript" => "Sondeig (chart) com a PostScript",
// "Chart JS" => "Chart JS",
// "Create a JS Chart" => "Create a JS Chart",
// "JSON encoded array for data and options" => "JSON encoded array for data and options",
// "Chart Id" => "Chart Id",
// "A custom ID for the chart" => "A custom ID for the chart",
// "The type of chart. Currently works with pie, bar and doughnut" => "The type of chart. Currently works with pie, bar and doughnut",
// "The height of the chart in px" => "The height of the chart in px",
// "The width of the chart in px" => "The width of the chart in px",
// "Chart data values" => "Chart data values",
// "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)" => "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)",
// "Chart data labels" => "Chart data labels",
// "Colon-separated labels for the datasets in the chart. Max 10, if left empty" => "Colon-separated labels for the datasets in the chart. Max 10, if left empty",
// "Chart colors" => "Chart colors",
// "Colon-separated colors for the datasets in the chart. Max 10, if left empty" => "Colon-separated colors for the datasets in the chart. Max 10, if left empty",
// "Chart highlight" => "Chart highlight",
// "Colon-separated color of chart section when highlighted" => "Colon-separated color of chart section when highlighted",
// "Uses the non-minified version of the chart.js library for easier debugging" => "Uses the non-minified version of the chart.js library for easier debugging",
// "Values must be set for chart" => "Values must be set for chart",
// "Check Referer" => "Check Referer",
// "Display content based on the address that originated the request for the current page" => "Display content based on the address that originated the request for the current page",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met",
// "Referer List" => "Referer List",
// "Comma-separated list of domains to check" => "Comma-separated list of domains to check",
// "Display code with syntax highlighting and line numbering" => "Display code with syntax highlighting and line numbering",
"Code to be displayed" => "Codi que es mostra",
"Caption" => "Capçalera",
"Code snippet label" => "Etiqueta del tros de codi",
"Line Wrapping" => "Doblega línies llargues",
// "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends" => "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends",
// "Any supported language listed at http://codemirror.net/mode/" => "Any supported language listed at http://codemirror.net/mode/",
"Line Numbers" => "Números de línia",
// "Show line numbers for each line of code" => "Show line numbers for each line of code",
"Right to Left" => "De dreta a esquerra",
"Switch the text display from left to right, to right to left (left to right by default)" => "Canviar la visualització de text d'esquerra a dreta per dreta a esquerra (d'esquerra a dreta per omissió)",
"Code Tag" => "Tag Codi",
"Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Tanca el codi en una etiqueta de codi HTML, per exemple: <codi> <codi> entrada de l'usuari",
// "Any supported theme listed at https://codemirror.net/demo/theme.html" => "Any supported theme listed at https://codemirror.net/demo/theme.html",
"Colorbox" => "Caixa de colors",
"Display a gallery of images in a popup slideshow" => "Mostra una galeria d'imatges en una presentació popup",
"Image Gallery ID" => "Image Gallery ID",
"ID number of the image gallery that contains the images to be displayed" => "Número d'identificació de la galeria d'imatges que conté les imatges que es mostraran",
"File ID Filter" => "ID de l'arxiu Filter",
// "Colon-separated list of fileIds in a file gallery to show" => "Colon-separated list of fileIds in a file gallery to show",
"Thumb" => "Contactes",
// "Display as a thumbnail or full size" => "Display as a thumbnail or full size",
"Show File Title" => "Mostrar Títol arxiu",
"Show file title" => "Mostra el títol de l'arxiu",
"Show File Name" => "Mostrar nom de l'arxiu",
"Show file name" => "Mostra el nom de l'arxiu",
"Show All Thumbs" => "Mostra totes les polzes",
"Show thumbnails of all the images in the gallery" => "Mostra imatges en miniatura de totes les imatges a la galeria",
"Parse Descriptions" => "Descripcions Parse",
"Parse the file descriptions as wiki syntax" => "Interpreta la sintaxi wiki de les descripcions dels arxius",
"This feature is disabled" => "Aquesta característica està deshabilitada",
// "Display a comment area for a specified object" => "Display a comment area for a specified object",
// "Object type the comment is associated with" => "Object type the comment is associated with",
"Tracker Item" => "Formulari-bd de l'article",
"Submission" => "Submissió",
"Blog Post" => "Bloc",
"The current wiki page to which you have added the plugin" => "La pàgina wiki actual que ha afegit que el plugin",
"Dynamic Content" => "Contingut dinàmic",
"Display content from dynamic content repository" => "Mostrar contingut del repositori de contingut dinàmic",
"Content ID" => "ID del contingut",
"Dynamic content ID. The value can be obtained in the listing" => "ID de contingut dinàmic. El valor es pot obtenir en el llistat",
"Content Label" => "Etiqueta contingut",
"Label of the dynamic content to display" => "Etiqueta del contingut dinàmic per mostrar",
"Contributions Dashboard" => "Contribucions Dashboard",
// "List users' contributions to a page" => "List users' contributions to a page",
"Notice" => "Avís",
"Default Beginning Date" => "Data d'inici per omissió",
"Default Ending Date" => "Data de finalització per omissió",
"Dashboard Types" => "Tipus Dashboard",
// "The types of charts that will be rendered, separated by commas" => "The types of charts that will be rendered, separated by commas",
"Update" => "Actualitza",
"Convene" => "Convocatòria",
// "Suggest meeting dates and times and vote to select one" => "Suggest meeting dates and times and vote to select one",
"Convene data generated from user input" => "Dades de la convocatòria generades a partir de les eleccions dels usuaris",
// "Title for the event" => "Title for the event",
"Calendar ID" => "Calendari ID",
"ID number of the site calendar in which to store the date for the events with the most votes" => "Número d'identificació del lloc Calendari on emmagatzemar la data dels fets amb un màxim de vots",
// "Minimum Votes" => "Minimum Votes",
// "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it" => "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it",
// "Date-Time Format" => "Date-Time Format",
"Display date and time in short or long format, according to the site wide setting" => "Mostra la data i l'hora en format curt o llarg, amb els detalls que hi hagi especificats per a aquest tipus de format a nivell de lloc web sencer",
"Short" => "Curt",
"Long" => "Llarg",
// "Observe Admin Permissions" => "Observe Admin Permissions",
"Show user profile pictures" => "Mostrar avatars usuari",
"Delete Date" => "Esborra data",
// "UTC date time: %0" => "UTC date time: %0",
"Add Date" => "Afegeix data",
// "Not OK" => "Not OK",
"Unconfirmed" => "Sense confirmar",
"Add User" => "Afegeix Usuari",
"Not ok" => "No es pot",
"Ok" => "Bé",
// "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users" => "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users",
// "Show user's profile pictures next to their names" => "Show user's profile pictures next to their names",
"Edit User/Save changes" => "Edita Usuari/Desa canvis",
"Delete User" => "Esborra Usuari",
// "Username.." => "Username..",
"Selected Date" => "Data seleccionada",
"Add as Calendar Event" => "Afegeix com a entrada del Calendari",
// "This page is being edited by another user. Please reload the page and try again later" => "This page is being edited by another user. Please reload the page and try again later",
// "Delete this date" => "Delete this date",
// "Are you sure you want to remove this user's votes" => "Are you sure you want to remove this user's votes",
// "There is no undo" => "There is no undo",
"Cookie" => "Galeta",
// "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)" => "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)",
// "Display content based on whether cookie consent has been granted by the user" => "Display content based on whether cookie consent has been granted by the user",
"Wiki syntax containing the content that can be hidden or shown" => "Sintaxi Wiki que conté el contingut que es pot amagar o mostrar",
"No Cookie Message" => "Cap cookie Missatge",
"Message displayed if user has not consented to accepting cookies" => "Missatge que es mostra si l'usuari no ha donat el seu consentiment per acceptar galetes",
"Containing Element" => "Amb un contingut Element",
// "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container" => "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container",
"Element CSS Class" => "Element CSS Class",
"CSS class for above" => "Classe CSS cap amunt",
// "No Consent CSS Class" => "No Consent CSS Class",
// "CSS class for no consent message. Default: %0" => "CSS class for no consent message. Default: %0",
"Insert copyright notices" => "Insertar avisos de drets d'autor",
// "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1" => "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1",
"Countdown" => "Compte enrera",
// "Display the time until or after a date and time" => "Display the time until or after a date and time",
"Text to append to the countdown" => "Text a afegir al compte enrera",
"Target date and time. Multiple formats accepted" => "Data i hora de destinació. Múltiples formats acceptats",
"Items to Show" => "Elements de mostrar",
// "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
"Years" => "Anys",
"Years, Months" => "Anys, mesos",
"Years, Months, Days" => "Anys, mesos, dies",
"Years, Months, Days, Hours" => "Anys, mesos, dies, hores",
"Years, Months, Days, Hours, Minutes" => "Anys, mesos, dies, hores, minuts",
"Years, Months, Days, Hours, Minutes & Seconds" => "Anys, mesos, dies, hores, minuts i segons",
"Months" => "Mesos",
"Months, Days" => "Mesos, dies",
"Months, Days, Hours" => "Mesos, dies, hores",
"Months, Days, Hours, Minutes" => "Mesos, dies, hores, minuts",
"Months, Days, Hours, Minutes & Seconds" => "Mesos, dies, hores, minuts i segons",
"Days" => "Dies",
"Days & Hours" => "Dies i Horaris",
"Days, Hours & Minutes" => "Dies, Hores i Minuts",
"Days, Hours, Minutes & Seconds" => "Dies, hores, minuts i segons",
"Hours" => "Hores",
"Hours & Minutes" => "Hores i minuts",
"Hours, Minutes & Seconds" => "Hores, Minuts i Segons",
"Minutes" => "Minuts",
"Minutes & Seconds" => "Minuts i Segons",
"Seconds" => "Segons",
"Calendar Days" => "Dies Calendari",
// "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default" => "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default",
"Handle Past Events" => "Controlar els esdeveniments anteriors",
// "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text" => "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text",
"Text" => "Texte",
// "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text" => "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text",
"default, silent, custom: before event|after event|after event when time not shown" => "no, en silenci, personalitzat: abans de l'esdeveniment | després de l'esdeveniment | després de l'esdeveniment quan el temps no mostra",
"Thousands separator" => "Milers de separació",
// "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator",
"Comma" => "Coma",
"Period" => "Període",
"Space" => "Espai",
"Countdown: Missing \"enddate\" parameter for plugin" => "COMPTE REGRESSIVA: Missing paràmetre \"EndDate\" per plugins",
"will happen in less than a year" => "que passarà en menys d'un any",
"will happen in less than a month" => "que passarà en menys d'un mes",
"will happen in less than a day" => "que passarà en menys d'un dia",
// "will happen in less than an hour" => "will happen in less than an hour",
"will happen in less than a minute" => "que passarà a menys d'un minut",
"is happening this second" => "està passant aquest segon",
"happened in the last year" => "succeït en l'últim any",
"happened in the last month" => "passat en l'últim mes",
"happened in the last day" => "passat l'últim dia",
"happened in the last hour" => "ocorregut en l'última hora",
"happened in the last minute" => "passat en l'últim minut",
"until" => "fins",
"since" => "des de",
"is over" => "és més",
"Custom Search" => "Cerca personalitzada",
// "Create a custom search form for searching or listing items on the site" => "Create a custom search form for searching or listing items on the site",
"LIST plugin configuration information" => "Informació de configuració del connector LLISTA",
"Template wiki page" => "Pàgina wiki Plantilla",
"Wiki page where search user interface template is found" => "Pàgina wiki on es troba search template interfície d'usuari",
// "Template file" => "Template file",
// "Smarty template (.tpl) file where search user interface template is found" => "Smarty template (.tpl) file where search user interface template is found",
// "Search Id" => "Search Id",
// "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users",
// "Search Delay" => "Search Delay",
// "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)" => "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)",
// "Fade DIV Id" => "Fade DIV Id",
// "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner",
// "Recall Last Search" => "Recall Last Search",
// "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving" => "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving",
// "Custom JavaScript Page" => "Custom JavaScript Page",
"The wiki page on which custom JavaScript is to be executed on return of Ajax results" => "La pàgina de wiki a la que JavaScript personalitzat que ha de ser executada al lliurament de resultats d'AJAX",
"Destination Div" => "Destinació Div",
"The id of an existing div to contain the search results" => "Identificació d'un div pre-existent per contenir els resultats de la cerca",
"Search On Load" => "Cercar en càrrega",
"Execute the search when the page loads (default: Yes)" => "Executar la cerca quan es carrega la pàgina (per omissió: Si)",
// "Require Input" => "Require Input",
// "Require first input field to be filled for search to trigger" => "Require first input field to be filled for search to trigger",
// "Force Sort" => "Force Sort",
// "Force the use of specified sort mode in place of search relevance even when there is a text search query" => "Force the use of specified sort mode in place of search relevance even when there is a text search query",
// "Trim Linefeeds" => "Trim Linefeeds",
// "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs" => "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs",
// "Searchable Only Results" => "Searchable Only Results",
// "Only include results marked as searchable in the index" => "Only include results marked as searchable in the index",
// "Use custom search JavaScript file" => "Use custom search JavaScript file",
// "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size" => "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size",
// "JavaScript disabled" => "JavaScript disabled",
// "JavaScript is required for this search feature" => "JavaScript is required for this search feature",
"Template is not specified" => "No s'especifica Plantilla",
"Template page not found" => "Plantilla de pàgina no trobada",
// "Please enter a search query" => "Please enter a search query",
// "_from parameter not valid: \"%0\"" => "_from parameter not valid: \"%0\"",
// "_to parameter not valid: \"%0\"" => "_to parameter not valid: \"%0\"",
// "_gap parameter not valid: \"%0\"" => "_gap parameter not valid: \"%0\"",
"_group is needed to be set if _style is checkbox or radio" => "Es necessita _group fixar-se si _style és checkbox o ràdio",
// "Cypht webmail" => "Cypht webmail",
// "Embed Cypht webmail and news reader" => "Embed Cypht webmail and news reader",
// "Mailbox name" => "Mailbox name",
"IMAP server" => "IMAP servidor",
// "IMAP port" => "IMAP port",
// "IMAP use TLS" => "IMAP use TLS",
// "Use secure connection to IMAP server" => "Use secure connection to IMAP server",
// "IMAP username" => "IMAP username",
// "Account mailbox username" => "Account mailbox username",
// "IMAP password" => "IMAP password",
// "Account mailbox password" => "Account mailbox password",
// "SMTP connection name" => "SMTP connection name",
// "SMTP port" => "SMTP port",
// "SMTP use TLS" => "SMTP use TLS",
// "Use secure TLS/SSL connection to SMTP server" => "Use secure TLS/SSL connection to SMTP server",
// "SMTP no authentication" => "SMTP no authentication",
// "Disable SMTP authentication if your server does not support it" => "Disable SMTP authentication if your server does not support it",
// "Use global settings" => "Use global settings",
// "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages" => "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages",
// "Groupmail use" => "Groupmail use",
// "Share this mailbox for Groupmail usage or keep it private" => "Share this mailbox for Groupmail usage or keep it private",
"GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Grup (per exemple \"Equip d'Ajuda\")",
"GroupMail: Tracker ID (to store GroupMail activity)" => "GroupMail: Tipus d'Identificació (per emmagatzemar activitat GroupMail)",
"From Field ID" => "De Id del  Camp",
"GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: De Campo (Id de camp en el seguiment per emmagatzemar correu electrònic de capçalera)",
"Subject Field ID" => "Subject Field ID",
"GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id de camp en el seguiment per emmagatzemar correu electrònic capçalera Subject)",
"Message Field ID" => "Missatge Id del  Camp",
"GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Camp Missatge (Id de camp en el seguiment per emmagatzemar correu electrònic identificador de missatge)",
"Content Field ID" => "Contingut Id del  Camp",
"GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Camp Contingut (Id de camp en el seguiment de missatges de correu electrònic per emmagatzemar el contingut del cos)",
"Account Field ID" => "Id del  Camp del Compte",
"GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: El camp Account (Id de camp en el seguiment per emmagatzemar nom de compte Webmail)",
"DateTime Field Id" => "Aneu camp DateTime",
"GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Data Hora Camp (Id de camp en el seguiment d'emmagatzemar timestamp email enviat)",
"Operator Field ID" => "Operador Id del  Camp",
"GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Camp Operador (Id de camp en el seguiment per emmagatzemar el nom de l'operador (nom d'usuari))",
// "UI display presentational purposes only" => "UI display presentational purposes only",
// "E.g. imap.your-domain.com" => "E.g. imap.your-domain.com",
// "Default is 993" => "Default is 993",
// "E.g. smtp.your-domain.com" => "E.g. smtp.your-domain.com",
// "Default is 587" => "Default is 587",
// "Only one cypht plugin per page can be used" => "Only one cypht plugin per page can be used",
"Data Channel" => "Canal de dades",
"Display a form to access data channels" => "Mostrar un formulari per accedir a canals de dades",
// "List of fields to display. One field per line. Comma delimited: %0" => "List of fields to display. One field per line. Comma delimited: %0",
// "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag" => "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag",
// "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel" => "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel",
// "To use fixed hidden preset\n\t\t\tvalues use %0" => "To use fixed hidden preset\n\t\t\tvalues use %0",
"Channel Name" => "Nom del Canal",
"Name of the channel as registered by the administrator" => "Nom del canal tal com va ser registrada per l'administrador",
"Return URL" => "Tornar URL",
// "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object" => "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object",
// "Return URL on error" => "Return URL on error",
// "URL to go to after data channel has run and failed. If not specified, use the success URL" => "URL to go to after data channel has run and failed. If not specified, use the success URL",
"Do not use returnURI but instead return true quietly" => "No utilitzeu returnURI sinó que retornarà true en silenci",
// "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context" => "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context",
"Button Label" => "Button Label",
"Label for the submit button. Default: \"Go\"" => "Etiqueta per al botó d'enviament. Per defecte: \"Go\"",
"CSS class for this form" => "Classes CSS per a aquesta forma",
"Template" => "Plantilla",
// "Template to be used to render the form, instead of the default template" => "Template to be used to render the form, instead of the default template",
"Empty Caches" => "Caches buits",
"Which caches to empty. Default \"Clear all Tiki caches\"" => "Què deixa en memòria cau per buidar. DEFAULT \"Elimina totes les memòries cau Tiki \"",
"Clear all Tiki caches" => "Esborrar tots els caches Tiki",
"All user prefs sessions" => "Totes les sessions de preferències d'usuaris",
"Price to execute the data channel (%0)" => "Preu per executar el datachannel (%0)",
"Payment Label" => "Etiqueta de Pagament",
"Debug" => "Debug (Neteja d'errors)",
// "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)",
"Multiple Values" => "Diversos valors",
// "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)",
"Data channel" => "Data channel",
"DB Report" => "Informes de BD",
// "Query an ADOdb database and display results (does not work with PDO)" => "Query an ADOdb database and display results (does not work with PDO)",
"report definition" => "definició d'informe",
"Full DSN" => "DSN sencer",
// "A full DSN (Data Source Name) connection string. Example: " => "A full DSN (Data Source Name) connection string. Example: ",
"Wiki DSN Name" => "Wiki DSN Nom",
"The name of a DSN connection defined by the Wiki administrator" => "El nom d'una connexió a DSN definida per l'administrador del Wiki",
"Wiki Syntax" => "Sintaxi Wiki",
"Parse wiki syntax within the report (not parsed by default)" => "Analitzar la sintaxi wiki en l'informe (no interpretat per omissió)",
"Display the parsed report definition (not displayed by default)" => "Mostra la definició de l'informe analitzat (no es mostra per omissió)",
"Missing db or dsn parameter" => "Manca base de dades o paràmetre dsn",
"AdoDb not found" => "ADOdb no trobat",
"No DSN connection string found" => "No s'ha trobat text de connexió al DSN",
"Run a database report" => "Executa un informe sobre una base de dades",
// "Diagram" => "Diagram",
// "Display mxGraph/Draw.io diagrams" => "Display mxGraph/Draw.io diagrams",
// "fileId" => "fileId",
// "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options" => "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options",
"page" => "pàgina",
// "Page of the diagram that should be displayed" => "Page of the diagram that should be displayed",
// "annotate" => "annotate",
// "Id of the file in the file gallery. A image file to include in the diagram" => "Id of the file in the file gallery. A image file to include in the diagram",
// "Image alignment when exporting a PDF" => "Image alignment when exporting a PDF",
// "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"" => "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"",
// "Previous xorti/mxgraph-editor package has been deprecated.<br/>" => "Previous xorti/mxgraph-editor package has been deprecated.<br/>",
// "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator" => "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator",
// "Create New Diagram" => "Create New Diagram",
// "Page (inline)" => "Page (inline)",
// "Tiki wasn't able to find the file with id %0" => "Tiki wasn't able to find the file with id %0",
// "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure" => "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure",
" in " => " a",
// "Selected file to annotate must be an image" => "Selected file to annotate must be an image",
// "Can not retrieve size from file %0" => "Can not retrieve size from file %0",
// "Create a custom popup dialog box" => "Create a custom popup dialog box",
"Button labels separated by commas" => "Botó etiquetes separades per comes",
// "Button Actions" => "Button Actions",
"JavaScript to perform on first button click" => "JS per dur a terme l'1 de clic de botó",
// "Dialog Width" => "Dialog Width",
"In pixels" => "En píxels",
"HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)" => "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)",
// "Show Animation" => "Show Animation",
// "Hide Animation" => "Hide Animation",
// "Auto Open" => "Auto Open",
// "Open dialog automatically" => "Open dialog automatically",
"Modal" => "Modal",
// "Use modal form" => "Use modal form",
"Wiki page to use as dialog body" => "Pàgina Wiki per utilitzar com a òrgan de diàleg",
"Open Action" => "Acció Obert",
"JavaScript to execute when dialog opens" => "JS a executar quan s'obre el diàleg",
"Div" => "Div",
"Define and format sections of a page or text" => "Definir i donar format a seccions d'una pàgina o de text",
// "Indicate the type of HTML tag to use (default is %0)" => "Indicate the type of HTML tag to use (default is %0)",
"Span" => "Lapse",
"Pre" => "Pre",
"Teletype" => "Teletip",
"Paragraph" => "Paràgraf",
"Block quote" => "Bloc cita",
// "H1" => "H1",
// "H2" => "H2",
// "H3" => "H3",
// "H4" => "H4",
// "H5" => "H5",
// "H6" => "H6",
// "Valid CSS color name or hex code" => "Valid CSS color name or hex code",
"Box width" => "Amplada de la caixa",
"In pixels or percentage. Default is original size" => "En píxels o percentatge. Per defecte és mida original",
"Aligns the text within the element" => "Alinea el text dins de l'element",
"Justify" => "Justificar",
// "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set" => "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set",
"Content cannot wrap around this object because of what the parameter is set to" => "Els articles que no estan permesos per embolicar al voltant de la part (s), aquest paràmetre s'estableix en",
"Apply custom CSS class to the div" => "Aplicar classe CSS personalitzada a l'div",
"Title attribute" => "Atribut Títol",
"Title for the div, usually displayed as a tooltip" => "Títol per al div, en general apareix com informació sobre eines",
// "onClick attribute" => "onClick attribute",
// "Enter on onclick event" => "Enter on onclick event",
// "Style attribute" => "Style attribute",
// "Enter CSS styling tags for the div type used" => "Enter CSS styling tags for the div type used",
// "Data attributes" => "Data attributes",
// "URL encoded list or attributes and values" => "URL encoded list or attributes and values",
// "ARIA attributes" => "ARIA attributes",
// "URL encoded list or attributes and values, e.g. label, expanded etc" => "URL encoded list or attributes and values, e.g. label, expanded etc",
// "Role attribute" => "Role attribute",
// "e.g. button, heading, search etc" => "e.g. button, heading, search etc",
"Sets the id attribute of the div, as defined by HTML" => "Estableix atribut id de la div, segons la definició d'HTML",
"Definition List" => "Llista de definició",
"Create a definition list" => "Crear una llista de definicions",
// "One entry per line. Each line is in %0Term: Definition%1 format" => "One entry per line. Each line is in %0Term: Definition%1 format",
"List Type" => "Tipus de llista",
// "Type of definition list (left-aligned or horizontal)" => "Type of definition list (left-aligned or horizontal)",
// "Standard (left-aligned)" => "Standard (left-aligned)",
// "Horizontal (inline) " => "Horizontal (inline) ",
"Draw" => "Dibuixa",
// "Embed a drawing in a page" => "Embed a drawing in a page",
"Drawing ID" => "Dibuix ID",
"Internal ID of the file ID" => "ID intern de l'això arxiu",
// "Width in pixels or percentage. Default value is page width, for example, %0 or %1" => "Width in pixels or percentage. Default value is page width, for example, %0 or %1",
"Height in pixels or percentage. Default value is complete drawing height" => "Alçada en píxels o percentatge. El valor per omissió és l'altura dibuix complet",
"Force Display Archive" => "D'intensitat variable Arxiu",
// "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision",
"Draw New SVG Image" => "Dibuixa Nova fitxer SVG",
"Edit SVG Image" => "Edita fitxer SVG",
// "List of dynamic variables" => "List of dynamic variables",
// "Show dynamic variables and their values" => "Show dynamic variables and their values",
"Layout" => "Disposició",
"Set to table to show results in a table (not shown in a table by default)" => "S'estableix en la taula per mostrar els resultats en una taula (no es mostra en una taula per omissió)",
"String to use between elements of the list if table layout is not used" => "Cadena d'usar entre els elements de la llista si no s'utilitza disseny de la taula",
// "Parsed result" => "Parsed result",
"Syntax" => "Sintaxi",
// "Value per database" => "Value per database",
"Equation" => "Equació",
"Render an equation written in LaTeX syntax as an image" => "Representar una equació escrita en la sintaxi de LaTeX com una imatge",
"equation" => "equació",
// "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator" => "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator",
// "Display events from calendars" => "Display events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)" => "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)",
"Maximum Days" => "Màxim dies",
// "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0" => "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0",
"Maximum Events" => "Màxim de Successos",
// "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)" => "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)",
"Show Time" => "Show Time",
"Show the time along with the date (shown by default)" => "Mostra el temps, juntament amb la data (que es mostra per omissió)",
"Show the description of the event (shown by default)" => "Mostrar la descripció de l'esdeveniment (que es mostra per omissió)",
// "Time Span" => "Time Span",
// "Specify the time span" => "Specify the time span",
"Past" => "Passat",
// "Future" => "Future",
// "Activate pagination when Events listing are long. Default is %0" => "Activate pagination when Events listing are long. Default is %0",
"Exercise" => "Exercir",
"PluginExercise" => "PluginExercise",
// "Create an exercise/test with questions and grade" => "Create an exercise/test with questions and grade",
"Answer" => "Resposta",
"Used inline to specify the right answer to the question and propose an input field" => "Inline S'utilitza per especificar la resposta correcta a la pregunta i proposar un camp d'entrada",
"Incorrect" => "Incorrecte",
// "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")" => "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")",
"Check your score" => "Revisi el seu puntuació",
"You scored %0 out of %1" => "Vas puntuar %0 sobre %1",
"Good" => "Bé",
"Extend Cart Inventory Hold" => "Extend Cart Inventory Hold",
"PluginExtendCartHold" => "PluginExtendCartHold",
// "Extend the time that items are held in a shopping cart" => "Extend the time that items are held in a shopping cart",
"Create a link that shows/hides initially hidden content" => "Crear un enllaç que mostra el contingut / oculta inicialment oculta",
// "Content of the hideable zone (in Wiki syntax)" => "Content of the hideable zone (in Wiki syntax)",
"Label for link that shows and hides the content when clicked" => "Etiqueta per enllaç que mostra i oculta el contingut en fer clic",
"Unspecified label" => "Etiqueta no especificada",
"Arrow icon showing that content can be hidden or shown" => "Icona de fletxa que mostra que el contingut es pot amagar o mostrar",
"Show Speed" => "Mostrar velocitat",
// "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or %0 or %1" => "Integer greater than 0 and less than or equal to 1000, or %0 or %1",
"Hide Speed" => "Velocitat Amaga",
// "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Use Bootstrap" => "Use Bootstrap",
// "Use Bootstrap collapsible box" => "Use Bootstrap collapsible box",
// "Apply custom CSS class" => "Apply custom CSS class",
"Fancy List" => "Llista maca",
// "Create a formatted numbered list" => "Create a formatted numbered list",
"One item per line starting with anything followed by \")\"" => "Un ítem per línia començant per quelcom seguit de  \")\"",
"Use Div" => "Utilitza Div",
"Use the HTML div tag instead of the HTML ordered list tag (ol)" => "Utilitza la etiqueta HTML div en lloc de l'etiqueta HTML per les llistes (ol)",
"CSS class for the fancylist" => "Classe CSS de la llista maca",
"Heading Row" => "Rumb Row",
// "Header rows of the table. Use %0 to separate multiple rows" => "Header rows of the table. Use %0 to separate multiple rows",
"Heading CSS Class" => "Classe CSS Capçalera",
"CSS class to apply to the heading row" => "Classe CSS a aplicar a la fila de la capçalera",
"Header Horizontal Alignment" => "Capçalera Horitzontal Alinear",
// "Horizontal alignments for header cells, separated by %0. Choices: %1" => "Horizontal alignments for header cells, separated by %0. Choices: %1",
"Header Vertical Alignment" => "Capçalera Vertical Alinear",
// "Vertical alignments for header cells, separated by %0\". Choices: %1" => "Vertical alignments for header cells, separated by %0\". Choices: %1",
"Column Widths" => "Amplada de columna",
// "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0" => "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0",
"Cell Horizontal Align" => "Cel·lular Horitzontal Alinear",
// "Table body column horizontal alignments, separated by %0. Choices: %1" => "Table body column horizontal alignments, separated by %0. Choices: %1",
"Cell Vertical Align" => "Mòbil Vertical Alinear",
// "Table body column vertical alignments, separated by %0. Choices: %1" => "Table body column vertical alignments, separated by %0. Choices: %1",
"Fancy Table" => "Taula maca",
// "Create a formatted table that can be filtered and sorted" => "Create a formatted table that can be filtered and sorted",
// "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases" => "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases",
// "The jQuery Sortable Tables feature must be activated for the sort feature to work" => "The jQuery Sortable Tables feature must be activated for the sort feature to work",
// "JavaScript must be enabled for the sort feature to work" => "JavaScript must be enabled for the sort feature to work",
// "Unable to load the jQuery Sortable Tables feature" => "Unable to load the jQuery Sortable Tables feature",
// "Display a button for a user to click to make an object a favorite" => "Display a button for a user to click to make an object a favorite",
// "Indicate type of object" => "Indicate type of object",
// "Enter the ID of the object" => "Enter the ID of the object",
// "Link to a file that's attached or in a gallery or archive" => "Link to a file that's attached or in a gallery or archive",
"Label for the link to the file (ignored if the file is a wiki attachment)" => "Etiqueta per l'enllaç a l'arxiu (s'ignora si l'arxiu és un arxiu adjunt wiki)",
"Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indiqueu si el fitxer està en una galeria arxiu o és un accessori de la pàgina wiki",
// "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used" => "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used",
"Custom Description" => "Descripció Custom",
"Custom text that will be used for the link instead of the file name or file description" => "Text que s'utilitzarà per l'enllaç en lloc del nom de fitxer o la descripció d'arxius",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty",
"Attachment Description" => "Accessori Descripció",
"Show the attachment description as the link label instead of the attachment file name" => "Mostrar la descripció adjunt com a etiqueta enllaç en lloc del nom del fitxer adjunt",
"Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indica que l'arxiu adjunt és una imatge, i s'ha de mostrar en línia usant l'etiqueta img",
"File ID" => "ID de l'arxiu",
"File ID of a file in a file gallery or an archive" => "ID de l'arxiu d'un arxiu en una galeria d'arxius o un arxiu",
"Example value" => "Valor d'exemple",
"Date" => "Data",
// "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1" => "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1",
"Show Icon" => "Mostra icona",
"Show an icon version of the file or file type with the link to the file" => "Mostrar una versió icona del tipus de fitxer o un fitxer amb l'enllaç a l'arxiu",
// "Browser Display" => "Browser Display",
// "Display in different browser window or tab instead of downloading" => "Display in different browser window or tab instead of downloading",
"File Gallery File/Archive" => "Galeria d'Arxiu / Archive",
"Wiki Page Attachment" => "Wiki Pàgina adjunts",
"The date has not been set" => "La data no s'ha establert",
"Incorrect date format" => "Format de data incorrecta",
"No such file" => "No existeix el fitxer",
"Wiki attachments are disabled" => "Accessoris Wiki estan desactivades",
"List files by ID, gallery or category, or show a slideshow of image files." => "Llista de fitxers d'ID, galeria o categoria, o mostrar una presentació de diapositives dels arxius d'imatge",
// "Title for the file listing, or the link text when %0" => "Title for the file listing, or the link text when %0",
"File Galleries IDs" => "Galeries Arxiu ID",
// "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)" => "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)",
// "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)" => "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon",
// "Valid category IDs separated by colons" => "Valid category IDs separated by colons",
// "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty" => "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty",
// "Valid file IDs separated by colons" => "Valid file IDs separated by colons",
// "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0" => "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0",
// "Last modified Ascending" => "Last modified Ascending",
// "Last modified Descending" => "Last modified Descending",
"File Name Ascending" => "Nom del fitxer Ascendent",
"File Name Descending" => "Nom del fitxer Descendent",
"File Size Ascending" => "Mida del fitxer Ascendent",
"File Size Descending" => "Mida del fitxer Descendent",
"File Type Ascending" => "Tipus d'arxiu ascendent",
"File Type Descending" => "Tipus d'arxiu Descendent",
"Last Download Ascending" => "Darrera descàrrega ascendent",
"Last Download Descending" => "Darrera descàrrega Descendent",
"Show Action" => "Mostra Acció",
// "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)" => "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)",
"Show Find" => "Mostrar Cercar",
"Show a search box above the list (not shown by default)" => "Mostra un quadre de cerca que apareix a dalt de la llista (no es mostra per omissió)",
// "Show Find is recursive" => "Show Find is recursive",
// "The search box digs recursively in sub-galleries (by default)" => "The search box digs recursively in sub-galleries (by default)",
"Show Title" => "Mostrar Títol",
// "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used",
"Show ID" => "Mostra ID",
"Show the ID number of each file (shown by default)" => "Mostra el número d'identificació de cada arxiu (que es mostra per omissió)",
"Show the file-type icon for each file" => "Mostra una icona per a cada arxiu que representa el tipus d'arxiu",
"Show Name" => "Mostrar nom",
// "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show",
"Show Filename" => "Mostra l'arxiu",
// "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show",
"Show Size" => "Mostra la mida",
"Show the size of each file in kilobytes (shown by default except in slide show)" => "Mostra la mida de cada arxiu en kilobytes (que es mostra per omissió, excepte en presentació de diapositives)",
// "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show",
"Show Creation Date" => "Mostra Data de creació",
"Show the date each file was created (not shown by default)" => "Mostrar la data de cada arxiu va ser creat (no es mostra per omissió)",
"Show Last Modification Date" => "Mostra darrera modificació",
"Show the date each file was last modified (shown by default)" => "Mostrar la data de cada arxiu va ser modificada per última vegada (que es mostra per omissió)",
// "Show Last Modification Time as well as Date" => "Show Last Modification Time as well as Date",
// "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)" => "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)",
"Show Hits" => "Mostra Impactes",
"Show the number of hits each file has received (not shown by default)" => "Mostra el nombre de visites ha rebut cada arxiu (no es mostra per omissió)",
"Show Locked By" => "Mostrar Bloquejat per",
"For locked files, show the username of the user who locked it (not shown by default)" => "Per als arxius bloquejats, mostrar el nom d'usuari de l'usuari que va tancar (no es mostra per omissió)",
"Show the username of the user who is the author of the file (not shown by default)" => "Mostra el nom d'usuari de l'usuari que és l'autor de la imatge (no es mostra per omissió)",
"Show Creator" => "Mostrar Creador",
"Show the username of the user who is the creator of the file (not shown by default)" => "Mostra el nom d'usuari de l'usuari que és el creador del fitxer (no es mostra per omissió)",
"Show Parent Gallery Name" => "Mostra Nom de Galeria Mare",
"Show the name of the parent gallery" => "Mostra el nom de la galeria principal",
"Show File Count" => "Mostra Comte arxiu",
// "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)",
"Show Source" => "Mostrar Font",
"Show the source (shown by default)" => "Mostra la font (que es mostra per omissió)",
"Show Slideshow" => "Mostra el passi de diapositives",
"Show a link that produces a popup slideshow when clicked (not set by default)" => "Mostra un enllaç que produeix una presentació de diapositives popup en fer clic (no establert per omissió)",
"Slideshow Width" => "Presentació Ample",
"Set width of slideshow popup" => "Establir l'amplada del popup slideshow",
"Slideshow Height" => "Presentació Alçada",
"Set height of slideshow popup" => "Ajust l'altura del popup slideshow",
"Show Comments" => "Mostra els comentaris",
"Show comments for each file (not shown by default)" => "Veure els comentaris per a cada arxiu (no es mostren per omissió)",
"Show Last Editor" => "Mostrar últim Editor",
"Show the username of the user who last modified the file (shown by default)" => "Mostra el nom d'usuari de l'usuari que va modificar l'arxiu (es mostra per omissió)",
"Show image thumbnail" => "Mostra Contacte d'Imatge",
"Show Image thumb" => "Mostra Contacte d'imatge",
"Show only files created by this user" => "Mostra només els arxius creats per aquest usuari",
"Show Upload" => "Mostra Pujar",
"Show a simple form to upload files to the gallery (not shown by default)" => "Mostrar un formulari de càrrega fàcil de la galeria (no es mostra per omissió)",
"Number of rows (default: -1 = all)" => "Nombre de files (per omissió: -1 = tots)",
"Recursive" => "Recursiva",
"With subgalleries" => "Amb la sub-galeries",
// "Fitnesse Test Suite" => "Fitnesse Test Suite",
// "Create test suites for applications built using Tiki" => "Create test suites for applications built using Tiki",
// "Test execution scenario" => "Test execution scenario",
// "Fixture not found: %0" => "Fixture not found: %0",
// "Tracker Math for [%0|%1]" => "Tracker Math for [%0|%1]",
// "Tracker Field not found: %0" => "Tracker Field not found: %0",
// "Field is not a math field: %0" => "Field is not a math field: %0",
// "Tracker Data for [%0|%1]" => "Tracker Data for [%0|%1]",
// "Table must contain at least one field named itemId" => "Table must contain at least one field named itemId",
// "%0 (expect: %1)" => "%0 (expect: %1)",
"Flash Video" => "Flash Video",
"Embed a video or audio file" => "Inserir un vídeo o un arxiu d'àudio",
"Flash Type" => "Tipus de flash",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo",
"Blip.tv" => "Blip.tv",
"File Gallery Podcast" => "Fitxa Galeria Podcast",
"Movie URL" => "URL del vídeo",
"Youtube" => "Youtube",
// "URL to the movie to include, for example, %0" => "URL to the movie to include, for example, %0",
"File Gallery Podcast ID" => "Galeria del fitxer Podcast ID",
"ID of a file from a podcast gallery - will work only with podcast gallery" => "Aneu d'un fitxer d'una galeria de podcast - només funciona amb Galeria de podcast",
"YouTube URL" => "YouTube URL",
"Complete URL to the YouTube video" => "URL complet per al vídeo de YouTube",
"Vimeo URL" => "Vimeo URL",
"Complete URL to the Vimeo video" => "URL complet al vídeo Vimeo",
// "Width of movie in pixels (default is %0)" => "Width of movie in pixels (default is %0)",
// "Height of movie in pixels (default is %0)" => "Height of movie in pixels (default is %0)",
"Quality" => "Qualitat",
// "Flash video quality. Default value: %0" => "Flash video quality. Default value: %0",
"Medium" => "Mig",
"Alternative image URL" => "Alternativa URL de la imatge",
"Image to display if Flash is not available" => "Imatge per mostrar si flaix no està disponible",
"Invalid URL" => "URL no vàlida",
"Missing parameter movie to the plugin flash" => "Manca el paràmetre movie per al plugin flash",
// "Fluid Grid" => "Fluid Grid",
// "Arrange content into rows and columns using a Bootstrap fluid grid" => "Arrange content into rows and columns using a Bootstrap fluid grid",
// "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Join Columns" => "Combinar Columnes",
// "Merge empty cells into the cell to their left" => "Merge empty cells into the cell to their left",
// "Device size" => "Device size",
// "Specify the device size below which the cells will be stacked vertically" => "Specify the device size below which the cells will be stacked vertically",
"Small" => "Petit",
"Large" => "Gran",
// "Extra Large" => "Extra Large",
"Column Sizes" => "Mides de columna",
// "Specify all column widths in units which add up to 12" => "Specify all column widths in units which add up to 12",
"First" => "Primer",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Columna",
"Line" => "Línia",
"Custom Class" => "Classe d'encàrrec",
"Add a class to customize the design" => "Afegir una classe per a personalitzar el disseny",
"Font" => "Font",
// "Format the font type and size of text" => "Format the font type and size of text",
"Content" => "Contingut",
"Font Family" => "Font Family",
"Select the font family to display the content" => "Seleccioneu la família de fonts per mostrar el contingut",
"Font Size" => "Mida de la lletra",
// "Define the size of the font in pixels (enter %0 to get a font of 12px)" => "Define the size of the font in pixels (enter %0 to get a font of 12px)",
"Footnote" => "Nota al peu",
"Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Crear notes numerades automàticament (juntament amb PluginFootnoteArea)",
"The footnote" => "La nota al peu",
"Tag" => "Marcador",
// "Tag footnote with unique identifier" => "Tag footnote with unique identifier",
// "One word made of alphanumeric characters" => "One word made of alphanumeric characters",
// "Same as Tag" => "Same as Tag",
// "Tag to existing footnote by its Tag" => "Tag to existing footnote by its Tag",
// "Same as" => "Same as",
// "Tag to existing footnote number" => "Tag to existing footnote number",
// "tag name (since 17) or footnote number" => "tag name (since 17) or footnote number",
// "Add class to footnotearea" => "Add class to footnotearea",
// "Scheme" => "Scheme",
// "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)" => "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)",
// "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)" => "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)",
// "Error: Tag not found in any previous footnote" => "Error: Tag not found in any previous footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Filter footnotearea by footnote class" => "Filter footnotearea by footnote class",
// "SameAs Style" => "SameAs Style",
// "Numbering style for sameas referencing" => "Numbering style for sameas referencing",
// "Valid Tiki ((Number Style))" => "Valid Tiki ((Number Style))",
"Tagged" => "Marca lliureged",
"List similarly tagged objects" => "Una llista dels objectes etiquetats de manera similar",
"Tags to find similar to" => "Etiquetes per trobar similar a",
"Leave blank to use the object's own tags" => "Deixar en blanc per a utilitzar les mateixes etiquetes de l'objecte",
"Type of objects to extract. Set to All to find all types" => "Tipus d'objectes per extreure. Ajust a tot per trobar tot tipus",
"Same" => "Mateix",
"Blog Posts" => "Publicacions de bloc",
// "Faqs" => "Faqs",
"Offset" => "Offset",
"Start record" => "Inici de la comunicació",
"Default -1 (all)" => "Per omissió, -1 (tots)",
// "Determine sort order based on various fields (Default: %0)" => "Determine sort order based on various fields (Default: %0)",
"Comments locked Ascending" => "Comentaris Tancats Ascendents",
"Comments locked Descending" => "Comentaris Tancats Descendents",
"Description Ascending" => "Descripció Ascendent",
"Description Descending" => "Descripció Descendent",
"Href Ascending" => "Href Ascendent",
"Href Descending" => "Href Descendent",
"Object ID Ascending" => "Object ID Ascendent",
"Object ID Descending" => "Object ID Descendent",
"Show objects with names or descriptions similar to the text entered here" => "Mostra objectes amb noms o descripcions similars al text introduït aquí",
// "Choose whether to broaden" => "Choose whether to broaden",
"n|y" => "n|y",
// "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags" => "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags",
"Show Titles Only" => "Mostra només títols",
"Choose whether to show titles only (not shown by default)" => "Seleccioneu si voleu mostrar només els títols (no es mostra per omissió)",
// "Max Image Size" => "Max Image Size",
// "Height or width in pixels. Default: %0 (no maximum)" => "Height or width in pixels. Default: %0 (no maximum)",
// "Show a 'more' link that links to the full list of tagged objects (not shown by default)" => "Show a 'more' link that links to the full list of tagged objects (not shown by default)",
"More URL" => "Més URL",
// "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects" => "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects",
// "More label" => "More label",
// "Alternate text to display on the \"more\" link (default is \"more\")" => "Alternate text to display on the \"more\" link (default is \"more\")",
// "Friend and unfriend other users" => "Friend and unfriend other users",
// "Add or Remove Friend Button" => "Add or Remove Friend Button",
"Other User" => "Un altre usuari",
"Button Text" => "Text del botó",
// "The user you wish to change relations with" => "The user you wish to change relations with",
// "Button text that's displayed when friending a user" => "Button text that's displayed when friending a user",
// "Button text that's displayed when un-friending a user" => "Button text that's displayed when un-friending a user",
// "Add to Friend Network" => "Add to Friend Network",
// "Remove from Friend Network" => "Remove from Friend Network",
"FTP" => "FTP",
"Create a button for downloading a file from an FTP server" => "Crear un botó per descarregar un arxiu d'un servidor FTP",
// "File name on the server" => "File name on the server",
"Server Name" => "Nom del servidor",
"Name of the server for the FTP account. Example: " => "Nom del servidor on està allotjada el compte FTP. Exemple:",
"Username for the FTP account" => "Nom d'usuari necessari per accedir al compte FTP",
"Password for the FTP account" => "Contrasenya necessària per accedir al compte FTP",
"Download Button Label" => "Descàrrega Button Label",
"Label for the FTP download button" => "Etiqueta per al botó de descàrrega FTP",
"missing parameters" => "paràmetres que manquen",
"Connection failed" => "La connexió ha fallat",
// "Set a Full-Width Page Title" => "Set a Full-Width Page Title",
// "Display the page title the full width of the site content container. " => "Display the page title the full width of the site content container. ",
// "PluginFullWidthTitle" => "PluginFullWidthTitle",
// "Page title" => "Page title",
// "If you need to include tpl files" => "If you need to include tpl files",
// "Icon Source" => "Icon Source",
// "Source path of the icon" => "Source path of the icon",
"Galleriffic" => "Galleriffic",
// "Display a slideshow of images on a page using the Galleriffic script" => "Display a slideshow of images on a page using the Galleriffic script",
// "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual table field name in place of %2" => "%0 or %1 with actual table field name in place of %2",
// "Thumbs Width" => "Thumbs Width",
// "Width in pixels or percentage. (e.g. %0 or %1)" => "Width in pixels or percentage. (e.g. %0 or %1)",
// "Image Slideshow Width" => "Image Slideshow Width",
// "Width in pixels or percentage of the largest image. (e.g. %0 or %1)" => "Width in pixels or percentage of the largest image. (e.g. %0 or %1)",
// "Image Slideshow Height" => "Image Slideshow Height",
// "Height in pixels or percentage of the largest images. (e.g. %0 or %1)" => "Height in pixels or percentage of the largest images. (e.g. %0 or %1)",
"Start Slideshow" => "Iniciar presentació",
"Automatically start the slideshow" => "Iniciar automàticament la presentació de diapositives",
"Delay" => "Decalatge",
"Delay in milliseconds between each transition" => "Retard en mil·lisegons entre cada transició",
"Number of thumbnails" => "Nombre de Miniatures",
"The number of thumbnails to show per page" => "El nombre de miniatures per mostrar per pàgina",
// "Show Top Pager" => "Show Top Pager",
"Display thumbnail pager at top" => "Mostra la miniatura localitzador a la part superior",
// "Show Bottom Pager" => "Show Bottom Pager",
"Display thumbnail pager at bottom" => "Mostra la miniatura localitzador a la part inferior",
"Play Slideshow" => "Presentació Reproduir",
"Pause Slideshow" => "Exposició de diapositives Pausa",
"Previous Photo" => "Foto Anterior",
"Next Photo" => "Següent",
"Prev" => "Previ",
// "Gantt Chart" => "Gantt Chart",
// "Create and display a gantt graphic using tracker data" => "Create and display a gantt graphic using tracker data",
"Tracker to search from" => "Formulari-bd a emprar",
// "Order Field" => "Order Field",
// "Permanent name of the field to use for row number order" => "Permanent name of the field to use for row number order",
// "Level Field" => "Level Field",
// "Permanent name of the field to use for row level" => "Permanent name of the field to use for row level",
// "Status Field" => "Status Field",
// "Permanent name of the field to use for row status" => "Permanent name of the field to use for row status",
// "Dependency Field" => "Dependency Field",
// "Permanent name of the field to use for row dependency" => "Permanent name of the field to use for row dependency",
// "Progress Field" => "Progress Field",
// "Permanent name of the field to use for row progress, values between 0-100" => "Permanent name of the field to use for row progress, values between 0-100",
// "Name Field" => "Name Field",
// "Permanent name of the field to use for row name" => "Permanent name of the field to use for row name",
// "Description Field" => "Description Field",
// "Permanent name of the field to use for row description" => "Permanent name of the field to use for row description",
// "Code Field" => "Code Field",
// "Permanent name of the field to use for row code" => "Permanent name of the field to use for row code",
// "Begin Date Field" => "Begin Date Field",
// "Permanent name of the field to use for event beginning" => "Permanent name of the field to use for event beginning",
// "End Date Field" => "End Date Field",
"Permanent name of the field to use for event ending" => "Nom Permanent del camp a utilitzar per al final de l'esdeveniment",
// "Resources Field" => "Resources Field",
// "Permanent name of the field to use for resources ending" => "Permanent name of the field to use for resources ending",
// "Roles Field" => "Roles Field",
// "Permanent name of the field to use for roles ending" => "Permanent name of the field to use for roles ending",
// "Effort Field" => "Effort Field",
// "Permanent name of the field to use for effort ending, values in milliseconds" => "Permanent name of the field to use for effort ending, values in milliseconds",
// "Start Is Milestone" => "Start Is Milestone",
// "Flag field to start is milestone" => "Flag field to start is milestone",
// "End Is Milestone" => "End Is Milestone",
// "Flag field to end is milestone" => "Flag field to end is milestone",
// "Writable" => "Writable",
// "Flag field to write or not in tasks" => "Flag field to write or not in tasks",
// "Deletable" => "Deletable",
// "Flag field that permit to delete or not tasks" => "Flag field that permit to delete or not tasks",
// "Parent Writable" => "Parent Writable",
// "Flag field to write or not in parent tasks" => "Flag field to write or not in parent tasks",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer",
// "Tracker data source not found" => "Tracker data source not found",
// "Order tracker field parameter is mandatory" => "Order tracker field parameter is mandatory",
// "Level tracker field parameter is mandatory" => "Level tracker field parameter is mandatory",
// "Depends tracker field parameter is mandatory" => "Depends tracker field parameter is mandatory",
// "You are trying to update a tracker that is not used by this gantt chart" => "You are trying to update a tracker that is not used by this gantt chart",
// "Gantt chart updated" => "Gantt chart updated",
"Gauge" => "Barra de nivell",
"Display a horizontal bar gauge" => "Mostra un indicador barra horitzontal",
"description" => "descripció",
"Current value to be represented by the gauge" => "Valor actual de ser representat pel mesurador",
"Maximum Value" => "Valor Màxim",
// "Maximum possible value. Default: %0" => "Maximum possible value. Default: %0",
"Label displayed on the left side of the gauge" => "l'Etiqueta mostrada a l'esquerra de la barra de nivell",
"Color" => "Color",
"Main color of the gauge. Use HTML color codes or names" => "Color principal de l'indicador. Utilitzeu codis de color HTML o noms",
"Background color of the gauge. Use HTML color codes or names" => "Color de fons de l'indicador. Utilitzeu codis de color HTML o noms",
"Bar width in pixels" => "Amplada de la barra en píxels",
"Label Width" => "Amplada de l'etiqueta",
"Label width, in pixels" => "Amplada en píxels destinada a l'etiqueta",
"Display Percentage" => "Percentatge de Pantalla",
// "Set to %0 (Yes) to display a percentage of the maximum" => "Set to %0 (Yes) to display a percentage of the maximum",
"Display Value" => "Valor de Pantalla",
// "Set to %1 (No) to hide the numeric value (shown by default)" => "Set to %1 (No) to hide the numeric value (shown by default)",
"Bar height in pixels" => "Alçada de la barra en píxels",
// "GDGraph" => "GDGraph",
// "Create a simple graph from supplied data" => "Create a simple graph from supplied data",
// "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body" => "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body",
// "14, backported to 12.4" => "14, backported to 12.4",
// "Graph Type" => "Graph Type",
// "Defines what ype of graph or chart is to be generated" => "Defines what ype of graph or chart is to be generated",
// "Vertical Bar" => "Vertical Bar",
// "Graph Title" => "Graph Title",
// "Displayed above the graph" => "Displayed above the graph",
// "Alt Tag" => "Alt Tag",
// "Text for image alt tag" => "Text for image alt tag",
// "Graph Image Width" => "Graph Image Width",
// "Overall width in pixels. Default value is %0" => "Overall width in pixels. Default value is %0",
// "Graph Image Height" => "Graph Image Height",
// "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown" => "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown",
"Get Security Token" => "Obtenir token de seguretat",
"PluginGetAccessToken" => "PluginGetAccessToken",
// "Display a link on a secure page using an access token" => "Display a link on a secure page using an access token",
// "Entry Patg" => "Entry Patg",
// "The path or part of the path that the token is for" => "The path or part of the path that the token is for",
// "Query Keys" => "Query Keys",
// "Query string parameter keys that the token is for, separated by a colon (:)" => "Query string parameter keys that the token is for, separated by a colon (:)",
// "Query Values" => "Query Values",
// "Query string parameter values that the token is for, separated by a colon (:)" => "Query string parameter values that the token is for, separated by a colon (:)",
"Google Analytics" => "Analítica de Google",
"Add the tracking code for Google Analytics" => "Afegir el codi de rastreig per a l'Analítica de Google",
"Account Number" => "Número de Compte",
// "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1" => "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1",
// "Groups Option" => "Groups Option",
// "Define option for Google Analytics groups, include or exclude" => "Define option for Google Analytics groups, include or exclude",
// "Available Groups" => "Available Groups",
// "Google Analytics Chart" => "Google Analytics Chart",
// "Draw charts from Google Analytics data" => "Draw charts from Google Analytics data",
// "JSON File" => "JSON File",
// "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)" => "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)",
// "Profle IDs" => "Profle IDs",
// "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin" => "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin",
// "Query String" => "Query String",
// "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0" => "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0",
// "Metrics" => "Metrics",
// "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"" => "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"",
// "default \"30daysAgo\"" => "default \"30daysAgo\"",
// "default \"yesterday\"" => "default \"yesterday\"",
// "Dimensions" => "Dimensions",
// "default \"ga:date\"" => "default \"ga:date\"",
// "Segment" => "Segment",
// "default \"\"" => "default \"\"",
// "Max Results" => "Max Results",
// "default 50" => "default 50",
"Sort" => "Ordena",
// "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"" => "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"",
// "Container" => "Container",
// "ID of a DIV to contain the chart (optional)" => "ID of a DIV to contain the chart (optional)",
// "Type of chart, e.g. LINE, PIE etc" => "Type of chart, e.g. LINE, PIE etc",
// "Bar" => "Bar",
// "Pie" => "Pie",
// "Geo" => "Geo",
// "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "googlechart: No credentials file" => "googlechart: No credentials file",
// "googlechart: No query_ids supplied" => "googlechart: No query_ids supplied",
// "googlechart exception: %0" => "googlechart exception: %0",
"Google Doc" => "Google Doc",
"Display a Google document" => "Mostrar un document de Google",
"Leave this empty" => "Deixar això buit",
"Type of Google document" => "Tipus de document de Google",
"Document" => "Document",
// "Slides" => "Slides",
// "Forms" => "Forms",
"Key" => "Clau",
// "Google doc key - for example" => "Google doc key - for example",
"Name of iframe. Default is \"Frame\" + the key" => "Nom del iframe. Per omissió és \"Frame\" + la tecla",
// "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly",
"Width in pixels or %" => "Ample en píxels o en %",
"Height in pixels or %" => "Alçada en píxels o en %",
// "Position of frame on page" => "Position of frame on page",
"Middle" => "Centre",
"Frame Border" => "Marge del marc",
"Choose whether to show a border around the iframe" => "Seleccioneu si voleu mostrar una vora al voltant del iframe",
"Margin Height" => "Alçada de Marge",
"Margin height in pixels" => "Marge d'alçada en píxels",
"Margin Width" => "Amplada de Marge",
"Margin width in pixels" => "Ample del marge en píxels",
"Scrolling" => "Desplaçament",
"Choose whether to add a scroll bar" => "Seleccioneu si voleu afegir una barra de desplaçament",
"Auto" => "Auto",
"Edit Link" => "Edita l'enllaç",
"Choose whether to show an edit link and set its location" => "Selecciona si vols mostrar un enllaç per editar i vols configurar la seva ubicació",
"Required parameter \"type\" missing" => "Manca el paràmetre requerit \"tipus\"",
"Required parameter \"key\" missing" => "Manca el paràmetre requerit \"clau\"",
"Display content based on the user's groups or friends" => "Mostrar contingut sobre la base dels grups d'usuaris o amics",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions",
"Allowed User Friends" => "S'admeten usuari Amics",
// "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample",
"Allowed Groups" => "Grups Permesos",
// "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample",
"Denied Groups" => "Grups Denegats",
// "Pipe-separated list of groups not allowed to view the block" => "Pipe-separated list of groups not allowed to view the block",
// "Allowed Groups Pending Membership" => "Allowed Groups Pending Membership",
// "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding" => "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding",
// "Allowed Groups Full Membership" => "Allowed Groups Full Membership",
// "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending" => "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending",
"Group Expiration" => "Grup de caducitat",
// "Show the expiration date of a group the user belongs to" => "Show the expiration date of a group the user belongs to",
// "The name of an existing group on the site" => "The name of an existing group on the site",
"not in group" => "no en el grup",
"never expires" => "mai caduca",
"Group List" => "Llista de grups",
// "Create a complete or filtered list of groups" => "Create a complete or filtered list of groups",
// "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed",
"Group Homepage" => "Pàgina del Grup",
"Link the group name to the group homepage, if there is one (not linked to by default)" => "Vincular el nom del grup a la pàgina principal del grup, si és que existeix (no vinculat per omissió)",
"Recursively List Groups" => "Recursiu de Grups",
"Recursively list the included groups (the default is to not list them repeatedly)" => "Recurse dels grups inclosos (per omissió no és recursiu)",
// "List only your own" => "List only your own",
// "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)" => "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)",
"GroupMail Core" => "GroupMail Core",
// "Display GroupMail functions on a page" => "Display GroupMail functions on a page",
"From Email" => "Des del correu electrònic",
"Email address to report" => "Adreça de correu electrònic per informar",
"ID of GroupMail Logs tracker (set up in alias by profile)" => "Aneu de GroupMail registres de seguiment (creada el àlies de perfil)",
"ID of GroupMail Logs tracker field (usually set up in alias by profile)" => "Aneu de GroupMail camp de traces Logs (normalment establert en àlies de perfil)",
"Datetime Field ID" => "Aneu camp de data i hora",
"Group Stats" => "Estadístiques del grup",
"Show the distribution of users among groups" => "Mostra la distribució dels usuaris en els grups",
"Groups" => "Grups",
"Groups, separated by \":\". If empty, all groups will be listed" => "Grups separats per:. Si està buit, es mostraran tots els grups",
"Percentage of" => "Percentatge de",
// "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter" => "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter",
// "Users in groups" => "Users in groups",
"Site users" => "Els usuaris del lloc",
"Show Percentage" => "Mostrar Percentatge",
// "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)" => "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)",
"Show Bar" => "Mostra Bar",
// "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)",
// "H5P" => "H5P",
// "Enable the creation, sharing and reuse of interactive HTML5 content" => "Enable the creation, sharing and reuse of interactive HTML5 content",
// "The H5P file in a file gallery" => "The H5P file in a file gallery",
// "H5P is not compatible with the Inline comments (annotations) feature" => "H5P is not compatible with the Inline comments (annotations) feature",
"Has Bought" => "Ha comprat",
// "Check whether a user has bought an item or added it to the shopping cart" => "Check whether a user has bought an item or added it to the shopping cart",
"PluginHasBought" => "PluginHasBought",
// "Key Name" => "Key Name",
"Key name of passcode to be checked" => "Nom de la clau del codi d'accés per ser revisat",
// "Key Labels" => "Key Labels",
"Label of the key name of passcode to be checked" => "Etiqueta del nom de la clau del codi de comprovació",
"Tracker from which to get passcode to check against" => "Formulari-bd de partida per obtenir codi d'accés per verificar amb",
"Field ID from which to get passcode to check against" => "Identificador de camp des del qual obtenir codi d'accés per comparar-lo amb ell",
"Item ID from which to get passcode to check against" => "ID de l'ítem des del qual obtenir codi d'accés per comparar-lo amb el",
"Please fill in all fields" => "Per favor empleni tots els camps",
"HTML" => "HTML",
"Add HTML to a page" => "Afegeix HTML a una pàgina",
"HTML code" => "codi HTML",
// "Move to HTML head" => "Move to HTML head",
// "Insert the code in the HTML head section rather than in the body" => "Insert the code in the HTML head section rather than in the body",
"Parse wiki syntax within the HTML code" => "Sintaxi wiki Analitzar dins del codi HTML",
"HTML Feed" => "Html RSS",
// "Add an item to HTML Feed" => "Add an item to HTML Feed",
// "Name of this feed" => "Name of this feed",
"HTML Feed Link" => "HTML RSS Enllaç",
// "Receive and display content from another site sent using PluginHTMLFeed" => "Receive and display content from another site sent using PluginHTMLFeed",
"Initial Value" => "Valor Inicial",
// "Feed Location" => "Feed Location",
// "Content Name" => "Content Name",
// "Content Style" => "Content Style",
"Highlight" => "Destacar",
"Asterisk" => "Asterisc",
"HTML Feed Link Type" => "HTML RSS Enllaç Tipus",
"Backlink" => "Backlink",
"Popup" => "Finestra emergent",
"Hover" => "Surar",
// "Moderated" => "Moderated",
"Date of last accepted HTML item, not used if not moderated" => "Data de l'últim element HTML acceptada, no s'utilitza si no es modera",
// "Display an icon" => "Display an icon",
// "Name of the icon" => "Name of the icon",
// "Valid icon name" => "Valid icon name",
// "Size of the icon (greater than 0 and less than 10)" => "Size of the icon (greater than 0 and less than 10)",
// "greater than 0 and less than 10" => "greater than 0 and less than 10",
"Rotate" => "Girar",
// "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)" => "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)",
// "90, 180, 270, horizontal, vertical" => "90, 180, 270, horizontal, vertical",
// "Style supported by the current icon set" => "Style supported by the current icon set",
"Iframe" => "Iframe",
// "Include the body of another web page in a scrollable frame within a page" => "Include the body of another web page in a scrollable frame within a page",
"Frame title" => "Títol Frame",
"Pixels or %" => "Píxels o %",
"Align the iframe on the page" => "Alinear el iframe a la pàgina",
// "Responsive" => "Responsive",
// "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device" => "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device",
// "16 by 9" => "16 by 9",
// "4 by 3" => "4 by 3",
"no" => "no",
// "Display one or more custom-formatted images" => "Display one or more custom-formatted images",
"Image Source" => "Font de la imatge",
"Choose where to get the image from" => "Trieu d'on obtenir la imatge",
"An image in the file galleries" => "Una imatge de les galeries d'arxius",
"An image attached to a wiki page" => "Una imatge que s'adjunta a una pàgina wiki",
"An image anywhere on the Internet" => "Una imatge en qualsevol lloc de la Internet",
"One random image from a file gallery" => "Una imatge aleatòria d'una galeria d'arxius",
// "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)",
// "Valid file IDs separated by commas or |" => "Valid file IDs separated by commas or |",
"Image ID" => "Imatge ID",
// "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)",
// "Valid image IDs separated by commas or |" => "Valid image IDs separated by commas or |",
"Full URL to the image to display" => "URL completa de la imatge per visualitzar",
"Numeric ID of a file gallery. Displays a random image from that gallery" => "ID numèric d'una galeria d'arxius. Mostra una imatge a l'atzar d'aquesta galeria",
"Numeric ID of a file gallery. Displays all images from that gallery" => "ID numèric d'una galeria d'arxius. Mostrar totes les imatges d'aquesta galeria",
"Attachment ID" => "ID adjunts",
// "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)" => "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)",
// "Valid attachment IDs separated by commas or |" => "Valid attachment IDs separated by commas or |",
"Thumbnail" => "Miniatura",
// "Makes the image a thumbnail with various options" => "Makes the image a thumbnail with various options",
// "Simple - links to full size image on a new page" => "Simple - links to full size image on a new page",
// "\"Lightbox\" - enlarges in an overlay box when clicked" => "\"Lightbox\" - enlarges in an overlay box when clicked",
// "Mouseover - enlarges in a popup when moused over" => "Mouseover - enlarges in a popup when moused over",
// "Mouseover (sticky)" => "Mouseover (sticky)",
// "Popup - enlarges in a separate window" => "Popup - enlarges in a separate window",
// "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1" => "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1",
// "Image Height" => "Image Height",
// "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Image Width" => "Image Width",
// "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Serve retina images" => "Serve retina images",
// "Serves up retina images to high density screen displays. Width must be set to use this" => "Serves up retina images to high density screen displays. Width must be set to use this",
// "Responsive Image Widths" => "Responsive Image Widths",
// "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"" => "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"",
// "Sizes" => "Sizes",
// "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters" => "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters",
// "Maximum Size" => "Maximum Size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings",
// "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description" => "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description",
// "Alternate Text" => "Alternate Text",
"Alternate text that displays when image does not load. Set to \"Image\" by default" => "El text alternatiu que es mostra quan la imatge no es carrega. Fixar en \"imatge\" per omissió",
// "Responsive Image" => "Responsive Image",
// "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class" => "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class",
// "Featured Image" => "Featured Image",
// "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose" => "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose",
"Comment Ascending" => "Opina ascendent",
"Comment Descending" => "Opina Descendent",
"Max Hits Ascending" => "Max Impactes ascendent",
"Max Hits Descending" => "Max Impactes Descendent",
"User Ascending" => "Ascendent usuari",
"User Descending" => "Descendent usuari",
"Author Ascending" => "Autor Ascendent",
"Author Descending" => "Autor Descendent",
"Locked By Ascending" => "Tancat en Ascendent",
"Locked By Descending" => "Bloquejat Per Descendent",
"Last modified User Ascending" => "Darrera modificació usuari ascendent",
"Last modified User Descending" => "Darrera modificació usuari Descendent",
"Last modified Date Ascending" => "Darrera modificació Data ascendent",
"Last modified Date Descending" => "Darrera modificació Data Descendent",
"Delete After Ascending" => "Eliminar després d'ascendir",
"Delete After Descending" => "Eliminar després Descendent",
"Votes Ascending" => "Vots Ascendent",
"Votes Descending" => "Vots Descendent",
"Points Ascending" => "Punts Ascendent",
"Points Descending" => "Punts Descendent",
"Archive ID Ascending" => "Arxiu ID ascendent",
"Archive ID Descending" => "Arxiu ID Descendent",
// "Enlarge Button" => "Enlarge Button",
// "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1" => "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1",
"Browse Popup" => "Examinar emergent",
// "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked" => "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked",
// "Image Map" => "Image Map",
"Name of the image map to use for the image" => "Nom del mapa d'imatge a utilitzar per a la imatge",
// "Horizontal spacing" => "Horizontal spacing",
// "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Vertical spacing" => "Vertical spacing",
// "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Align image using legacy align tag" => "Align image using legacy align tag",
// "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email" => "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email",
// "Align Image" => "Align Image",
// "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page" => "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page",
// "Image Style" => "Image Style",
// "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects" => "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects",
// "Align Image Block" => "Align Image Block",
// "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1" => "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1",
// "Image Block Style" => "Image Block Style",
// "Description Style" => "Description Style",
// "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects" => "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects",
// "Wrapping" => "Wrapping",
"Control how other items wrap around the image" => "Controli com altres articles s'emboliquen al voltant de la imatge",
// "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows" => "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows",
// "Link Title" => "Link Title",
// "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties" => "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties",
"Metadata" => "Metadades",
// "Display the image metadata (IPTC, EXIF and XMP information)" => "Display the image metadata (IPTC, EXIF and XMP information)",
// "Compression Quality" => "Compression Quality",
// "0 to 100 (default is 75)" => "0 to 100 (default is 75)",
// "Default Settings" => "Default Settings",
// "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Mandatory Setting" => "Mandatory Setting",
// "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Image Gallery Image" => "Image Gallery Image",
"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "El navegador d'imatges Galeria de la imatge s'obre quan es fa clic a la imatge si la imatge està en una galeria d'imatges Tiki",
"Same as \"browse\" except that the page opens in a new window or tab" => "El mateix que \"Examinar \", excepte que la pàgina s'obre en una nova finestra o pestanya",
"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Fa que la imatge en miniatura que s'engrandeix a mida completa quan es fa clic o moused més (llevat que \"link\" \\ s'ajusta a una altra destinació). \"Examinar\" i \"browsepopup\" només funcionen amb galeria d'imatges i \"descarregar\" només funciona amb galeria arxiu o arxius adjunts",
"Hide Draw Icon" => "Amaga Dibuixa Icona",
"Do not show draw/edit icon button under image" => "No mostrar dibuixar / editar icona del botó sota de la imatge",
// "Overlay with zoom" => "Overlay with zoom",
// "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked" => "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked",
// "Zoom" => "Zoom",
// "Adds a magnifying glass icon and zooms the image when hovered over" => "Adds a magnifying glass icon and zooms the image when hovered over",
"PluginImg: User lacks permission to view image" => "PluginImg: L'usuari no té permís per veure la imatge",
"File is not an image" => "L'arxiu no és una imatge",
"Server does not support image manipulation" => "Server no admet la manipulació d'imatges",
// "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator" => "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator",
// "SVG Image replace error \"%0\"" => "SVG Image replace error \"%0\"",
"Enlarge" => "Engrandir",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''",
"''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Utilitzeu un i només un dels següents paràmetres:. fileId, randomGalleryId, fgalId, attId, id, or src.''",
"Draw on the Image" => "Dibuixeu a la imatge",
"Include" => "Inclou",
// "Include a portion of another wiki page" => "Include a portion of another wiki page",
// "Name of the source wiki page (which contains the included portion)" => "Name of the source wiki page (which contains the included portion)",
// "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start",
"Stop" => "Atura",
// "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end",
// "Read more button" => "Read more button",
// "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)" => "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)",
// "Read more button label" => "Read more button label",
// "Label of the button linking to the source page (if it is displayed)" => "Label of the button linking to the source page (if it is displayed)",
// "Text to show when the page selected to be included is not found anymore" => "Text to show when the page selected to be included is not found anymore",
// "Permission denied message" => "Permission denied message",
// "Text to show when the page exists but the user has insufficient permissions to see it" => "Text to show when the page exists but the user has insufficient permissions to see it",
// "No version approved error message" => "No version approved error message",
// "Text to show when the page exists but no version is approved" => "Text to show when the page exists but no version is approved",
// "Edit Icon" => "Edit Icon",
// "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings" => "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings",
// "Max inclusions" => "Max inclusions",
// "Maximum amount of times the same page can be included. Defaults to 5" => "Maximum amount of times the same page can be included. Defaults to 5",
// "Parse Included Page" => "Parse Included Page",
// "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents" => "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents",
// "Max characters included" => "Max characters included",
// "Limit the length of the included text" => "Limit the length of the included text",
"Read more" => "Llegeix més",
// "The text above comes from page \"%s\". Click to go to that page" => "The text above comes from page \"%s\". Click to go to that page",
"Include Plugin" => "Inclogui Programes",
"Edit the included page" => "Edita la pàgina inclosa",
// "Include Template File" => "Include Template File",
// "Include a Smarty template (.tpl) file in a page" => "Include a Smarty template (.tpl) file in a page",
// "TPL file name" => "TPL file name",
// "If you need to include Smarty template files" => "If you need to include Smarty template files",
// "Values passed to the TPL" => "Values passed to the TPL",
// "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1" => "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1",
// "Include URL" => "Include URL",
// "Include the body content from a URL" => "Include the body content from a URL",
// "URL to external file to include" => "URL to external file to include",
// "Missing parameter url for plugin %0" => "Missing parameter url for plugin %0",
"Insert Tracker Item" => "Inseriu Formulari-bd article",
"Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item" => "Crea un element del registre quan s'insereix el connector a la pàgina. El plug-in s'elimina i es substitueix per un enllaç de la nova creació",
"Item not inserted" => "L'article no inserida",
"Invite" => "Convidar",
"Invite a user to join your groups" => "Convidar un usuari a unir-se als seus grups",
"Confirmation message after posting form" => "Missatge de confirmació després formulari de missatges",
"Including Group" => "Incloent Grup",
"Will list only the groups that include this group" => "A enumerar només els grups que inclouen aquest grup",
"Default Group" => "grup per defecte",
"Dropdown list will show this group by default" => "Llista desplegable mostrarà aquest grup per omissió",
// "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default",
"The following mandatory fields are missing" => "Manquen els camps obligatoris següents",
"Email address" => "Adreça de correu-e",
// "Add jQuery JavaScript code" => "Add jQuery JavaScript code",
"JavaScript code" => "JavaScript",
"Not On Ready" => "Not On Ready",
"Do not execute on document ready (execute inline)" => "No executi el document llest (s'executa en línia)",
"No JavaScript" => "No JavaScript",
"Optional markup for when JavaScript is off" => "Marcat opcional per quan JavaScript està desactivat",
// "Language to apply JQuery to" => "Language to apply JQuery to",
"<!-- jq plugin inactive: JavaScript off -->" => "<!-- plugin jq inactiu: JavaScript off -->",
"JavaScript" => "JavaScript",
// "Add JavaScript code or files" => "Add JavaScript code or files",
"JavaScript filename" => "JavaScript nom",
"Late Load" => "Carregar Late",
"Late load, use headerlib" => "Càrrega tardana, utilitzeu headerlib",
"Display a video created through the Kaltura feature" => "Mostrar un vídeo creat a través de la funció de Kaltura",
"Kaltura Entry ID" => "Kaltura nombre ID",
// "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one" => "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one",
"Kaltura Video Player ID" => "Kaltura Video ID jugador",
// "Width of the player in pixels or percent" => "Width of the player in pixels or percent",
// "Height of the player in pixels or percent" => "Height of the player in pixels or percent",
"Align" => "Alinear",
"Alignment of the player" => "Alineació del jugador",
"Not set" => "No establert",
"Centre" => "Centre",
"Alignment of the player using CSS float" => "Alineació del reproductor mitjançant CSS float",
"Add Media Button Label" => "Afegir botó de premsa Label",
"Text to display on button for adding new media" => "Text a mostrar al botó per afegir nous mitjans",
"Add media" => "Afegir un mitjà",
// "Player Type" => "Player Type",
// "Set player type" => "Set player type",
"KDP" => "KDP",
"HTML5" => "HTML5",
"Upload Media" => "Pujar Mitjans",
"Media ID or permission to upload video is required" => "Es requereix ID de mitjans o permís per pujar un vídeo",
"Log in to upload video" => "Accedeixi a pujar un vídeo",
"Player not found" => "Jugador no trobat",
"Kaltura player: unsupported type" => "Jugador Kaltura: tipus no admès",
// "Show alternative content based on the page language" => "Show alternative content based on the page language",
// "Content to show" => "Content to show",
// "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Not Language" => "No Idioma",
// "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Show the last modification date for a page" => "Mostra l'última data de modificació d'una pàgina",
"Page name to display information of. Default value is current page" => "Nom de la pàgina per mostrar la informació de. El valor per omissió és la pàgina actual",
"Date format" => "Format de la data",
// "Set date and time format according to site settings" => "Set date and time format according to site settings",
// "Long date" => "Long date",
// "Short date" => "Short date",
// "Long datetime" => "Long datetime",
// "Short datetime" => "Short datetime",
// "ISO" => "ISO",
// "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects" => "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects",
// "Display page header" => "Display page header",
// "Set to No, to hide header on the page" => "Set to No, to hide header on the page",
// "Display Page Footer" => "Display Page Footer",
// "Display Page Left Bar" => "Display Page Left Bar",
// "Set to No, to hide left on the page" => "Set to No, to hide left on the page",
// "Display Page Right Bar" => "Display Page Right Bar",
// "Set to No, to hide right on the page" => "Set to No, to hide right on the page",
// "Page Full Width" => "Page Full Width",
// "100% Page width" => "100% Page width",
// "Page Content Width" => "Page Content Width",
// "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)" => "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)",
// "Page Background Image URL" => "Page Background Image URL",
// "Enter image url, in case of single image" => "Enter image url, in case of single image",
// "Background Repear" => "Background Repear",
// "Cover,Repeat,no-repeat" => "Cover,Repeat,no-repeat",
// "Page Background Sliding Images" => "Page Background Sliding Images",
// "Enter file gallery id for fading background" => "Enter file gallery id for fading background",
// "Page Content Top Margin" => "Page Content Top Margin",
// "Enter value in % or px for example 30%, 300px, default will be 0" => "Enter value in % or px for example 30%, 300px, default will be 0",
// "Page Header Width" => "Page Header Width",
// "Enter page header width in px or %, leave blank for same width as page body.)" => "Enter page header width in px or %, leave blank for same width as page body.)",
// "Page Footer Width" => "Page Footer Width",
// "Enter page footer width in px or %, leave blank for same width as page body.)" => "Enter page footer width in px or %, leave blank for same width as page body.)",
// "Page Background Color" => "Page Background Color",
// "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)" => "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)",
// "Content Background Color" => "Content Background Color",
// "Content Text Color" => "Content Text Color",
// "Enter a valid CSS color code, for example #000,#fff,#ccc" => "Enter a valid CSS color code, for example #000,#fff,#ccc",
// "Content Border Radius" => "Content Border Radius",
// "To make content div round cornered, for example 10px" => "To make content div round cornered, for example 10px",
// "Content Border Shadow" => "Content Border Shadow",
// "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)" => "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)",
// "Transition Delay" => "Transition Delay",
// "Time interval to pause before moving to next slide in seconds" => "Time interval to pause before moving to next slide in seconds",
// "Display Page Action Buttons" => "Display Page Action Buttons",
// "Set to No, to hide page action buttons, with and under content" => "Set to No, to hide page action buttons, with and under content",
// "Display top bar(under header)" => "Display top bar(under header)",
// "Set to No, to hide topbar on the page" => "Set to No, to hide topbar on the page",
// "Display page top bar(above page content)" => "Display page top bar(above page content)",
// "Set to No, to hide page topbar module zone" => "Set to No, to hide page topbar module zone",
// "Display page bottom bar(under page content)" => "Display page bottom bar(under page content)",
// "Set to No, to hide page bottom bar module zone" => "Set to No, to hide page bottom bar module zone",
// "Create a \"Like\" button" => "Create a \"Like\" button",
// "Count only" => "Count only",
// "Sets whether to only show the count of likes rather than give the option to vote" => "Sets whether to only show the count of likes rather than give the option to vote",
// "Search for, list, and filter all types of items and display custom-formatted results" => "Search for, list, and filter all types of items and display custom-formatted results",
// "Use List GUI" => "Use List GUI",
// "Use the graphical user interface for editing this list plugin" => "Use the graphical user interface for editing this list plugin",
// "Cache Output" => "Cache Output",
// "Cache output of this list plugin" => "Cache output of this list plugin",
// "Cache Expiry Time" => "Cache Expiry Time",
// "Time before cache is expired in minutes" => "Time before cache is expired in minutes",
// "Cache Purge Rules" => "Cache Purge Rules",
// "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches" => "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches",
// "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block" => "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block",
// "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine" => "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine",
// "Error: {MULTISEARCH(id=x)} needs an ID to be specified" => "Error: {MULTISEARCH(id=x)} needs an ID to be specified",
"List Execute" => "Executa Llista",
// "Set custom actions that can be executed on a filtered list of objects" => "Set custom actions that can be executed on a filtered list of objects",
// "Invalid action: %0" => "Invalid action: %0",
// "There are too many search result items to apply %0 action to" => "There are too many search result items to apply %0 action to",
// "Unknown error executing action %0 on item %1" => "Unknown error executing action %0 on item %1",
// "Error executing action %0 on item %1" => "Error executing action %0 on item %1",
// "Action %0 executed successfully on %1 item(s)" => "Action %0 executed successfully on %1 item(s)",
"List Pages" => "Llista pàgines",
"List pages based on various criteria" => "Llista de pàgines basades en diversos criteris",
"Result number at which the listing should start" => "Resultat número en què la llista ha de començar",
"Limit number of items displayed in the list. Default is to display all" => "Limiti el nombre d'elements que apareixen a la llista. Per omissió és mostrar tots",
"Initial" => "Inicial",
// "Initial page to show" => "Initial page to show",
"Show Name Only" => "Mostra només de nom",
"Show only the page names" => "Mostra només els noms de les pàgines",
// "Category Filter" => "Category Filter",
// "Filter categories by Id numbers. Use different separators to filter as follows" => "Filter categories by Id numbers. Use different separators to filter as follows",
// "Page is in any of the specified categories. Example" => "Page is in any of the specified categories. Example",
// "Page must be in all of the specified categories. Example" => "Page must be in all of the specified categories. Example",
// "Page is in the first specified category and not in any of the others. Example" => "Page is in the first specified category and not in any of the others. Example",
// "Valid category ID or list separated by :, + or -" => "Valid category ID or list separated by :, + or -",
"Structure Head" => "Cap Estructura",
"Filter by structure head" => "Filtrar per tipus d'estructura del cap",
"Show Page Alias" => "Mostra Àlies Pàgina",
"Show page alias in the list" => "Mostra pàgina d'àlies a la llista",
"Include Tag" => "Inclogui Marca lliure",
// "Only pages with specific tag (separate tags using %0)" => "Only pages with specific tag (separate tags using %0)",
"Exclude Tag" => "Excloure Marques lliures",
// "Only pages with specific tag excluded (separate tags using %0)" => "Only pages with specific tag excluded (separate tags using %0)",
"Show Number of Pages" => "Mostra el nombre de pàgines",
"Show the number of pages matching criteria" => "Mostra el nombre de pàgines que coincideixen amb els criteris",
"Only pages with names similar to the text entered for this parameter will be listed" => "Només pàgines amb noms similars al text introduït apareixerà a la llista d'aquest paràmetre",
"Two-letter language code to filter pages listed" => "Codi de dos lletres que figuren a les pàgines de filtre",
"Orphan Language" => "Idioma Orphan",
// "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed" => "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed",
"Load Translations" => "Traduccions de càrrega",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter",
"Page name and text entered for the filter parameter must match exactly to be listed" => "Nom de la pàgina i el text introduït per al paràmetre de filtre han de coincidir exactament per ser llistats",
"Only Orphan Pages" => "Només Pàgines òrfenes",
"Only list orphan pages" => "Només una llista de pàgines òrfenes",
"For List Pages" => "Per paquet Pàgines",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples" => "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples",
// "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start",
// "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end",
"Length" => "Longitud",
"Number of characters to display" => "Nombre de caràcters per mostrar",
// "Checkboxes" => "Checkboxes",
// "Offset Argument" => "Offset Argument",
"Pagination" => "Paginació",
// "Exclude Page(s)" => "Exclude Page(s)",
// "Wiki page names to be excluded from list" => "Wiki page names to be excluded from list",
// "Local Files" => "Local Files",
// "Show a link to local or shared files and directories" => "Show a link to local or shared files and directories",
// "Local file or directory path" => "Local file or directory path",
"List Directory" => "Directori de llista",
// "If the path above is a directory then list the contents" => "If the path above is a directory then list the contents",
// "Show MIME file-type icons" => "Show MIME file-type icons",
// "List files in a directory" => "List files in a directory",
"Full path to the server-local directory. Default is the document root" => "Ruta d'accés completa al directori del servidor local. Per omissió és l'arrel del document",
"URL Prefix" => "Prefix d'URL",
// "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example" => "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example",
"Set the sort order of the file list" => "Establir l'ordre de la llista de fitxers",
"File Name" => "Nom d'arxiu",
"File Size" => "Mida del fitxer",
"Last Access" => "Últim accés",
"Last Metadata Change" => "Últim canvi Metadades",
// "Only list files with file names that contain this filter. Example" => "Only list files with file names that contain this filter. Example",
"Limit" => "Limitar",
"Maximum amount of files to display. Default is no limit" => "Quantitat màxima d'arxius per mostrar. Per omissió és sense límit",
"could not be opened because it doesn't exist or permission was denied" => "no es pot obrir perquè no hi és o s'ha denegat el permís",
"Mail" => "Correu",
// "Mail other users or groups" => "Mail other users or groups",
"Limit the list of groups to the groups including each group" => "Limitar la llista de grups als grups, incloent cada grup",
// "Group Dropdown" => "Group Dropdown",
"Show a dropdown list of groups (not shown by default)" => "Mostra una llista desplegable de grups (no es mostra per omissió)",
// "Recurse Groups" => "Recurse Groups",
// "Show each group and each group included in this group" => "Show each group and each group included in this group",
// "Recurse Group Users" => "Recurse Group Users",
// "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times..." => "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times...",
// "User Dropdown" => "User Dropdown",
"Show a dropdown list of users (not shown by default)" => "Mostra una llista desplegable d'usuaris (no es mostra per omissió)",
// "User Emails" => "User Emails",
// "Show a box for user to enter email addresses" => "Show a box for user to enter email addresses",
"Real Name Dropdown" => "Nom real desplegable",
"Show a dropdown list of user real names (not shown by default)" => "Mostra una llista desplegable de noms reals d'usuaris (no es mostra per omissió)",
// "Show in popup instead of inline" => "Show in popup instead of inline",
// "Text to show on the button to send emails (default: %0Send mail%1)" => "Text to show on the button to send emails (default: %0Send mail%1)",
// "Send mail" => "Send mail",
// "Email Subject" => "Email Subject",
// "Present Email subject content" => "Present Email subject content",
// "Bypass Preview" => "Bypass Preview",
// "Send emails without first previewing" => "Send emails without first previewing",
// "Debug mode (admins only)" => "Debug mode (admins only)",
// "Show list of emails that are sent (admins only)" => "Show list of emails that are sent (admins only)",
// "Mail send was unsuccessful" => "Mail send was unsuccessful",
"Map" => "Mapa",
"Display a map" => "Mostra un mapa",
"Instructions to load content" => "Instruccions per carregar contingut",
"Scope" => "Abast",
// "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1" => "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1",
"Controls" => "Controls",
// "Comma-separated list of map controls will be displayed on the map and around it" => "Comma-separated list of map controls will be displayed on the map and around it",
"Width of the map in pixels" => "Ample del mapa en píxels",
"Height of the map in pixels" => "Alçada del mapa en píxels",
// "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1" => "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1",
// "Popup Style" => "Popup Style",
"Alter the way the information is displayed when objects are loaded on the map" => "Modificar la forma en què la informació es mostra quan els objectes són carregats en el mapa",
"Bubble" => "Bombolla",
"MapServer File" => "MapServer arxiu",
"MapServer file identifier. Only fill this in if you are using MapServer" => "Identificador d'arxiu MapServer. Només omplir això si utilitza MapServer",
"Extents" => "Extensió",
"Size of the map" => "Mida del full",
// "Show item name in a tooltip on hover" => "Show item name in a tooltip on hover",
// "Open Layers Version" => "Open Layers Version",
// "OL2 or OL3+ so far (default ol2)" => "OL2 or OL3+ so far (default ol2)",
// "OpenLayers 2.x" => "OpenLayers 2.x",
// "Tileset layers" => "Tileset layers",
// "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)" => "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)",
// "Cluster Distance" => "Cluster Distance",
// "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)" => "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)",
// "Cluster Hover Behavior" => "Cluster Hover Behavior",
// "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)" => "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)",
// "Show Features" => "Show Features",
// "Cluster Fill Color" => "Cluster Fill Color",
// "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)" => "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)",
// "Cluster Text Color" => "Cluster Text Color",
// "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)" => "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)",
"Color Picker" => "Selector de color",
// "Markdown" => "Markdown",
// "Parse the body of the plugin using a Markdown parser" => "Parse the body of the plugin using a Markdown parser",
// "Markdown syntax to be parsed" => "Markdown syntax to be parsed",
"Mayan Calendars" => "Calendaris Maies",
"Convert a Gregorian date to a Mayan calendar date" => "Convertir una data Gregoriana a una data del calendari maia",
"You must use the variable substitution" => "Ha d'utilitzar la substitució de variables",
"LongCount: " => "LongCount:",
"Tzolkin: " => "Tzolkin:",
"Haab: " => "Haab:",
"Misc: " => "Altra informació:",
"Example: template " => "Exemple: plantilla",
// "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
"Default template: " => "Plantilla per omissió:",
"Gregorian date" => "Data gregoriana",
// "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date" => "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date",
" is not a valid date format. should be dd.mm.yyyy" => " No és un format de data vàlid. ha de ser dd.mm.aaaa",
"Media Player" => "Media Player",
"Add a media player to a page" => "Afegir un reproductor multimèdia a una pàgina",
"Allow full-screen" => "Permetre la pantalla completa",
"Allow full-screen mode" => "Permetre el mode de pantalla completa",
"MP3 URL" => "URL MP3",
"FLV URL" => "FLV URL",
// "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled" => "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled",
"Player width in px or %" => "Amplada del mediaplayer en píxels o%",
"Player height in px or %" => "Alçada del mediaplayer en píxels o%",
// "Set the style" => "Set the style",
"Media Type" => "Tipus de media",
// "Media type for HTML5" => "Media type for HTML5",
// "Audio" => "Audio",
"Video" => "Integració d'streaming de Vídeo",
"Flash Window Mode" => "Mode de la finestra de Flash",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: ",
"Transparent" => "Transparent",
"Opaque" => "Opac",
"Window" => "Finestra",
// "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)" => "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)",
// "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)" => "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)",
// "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below" => "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below",
// "Download file" => "Download file",
"Member List" => "Membres",
"List and allow editing of group members" => "Enumerar i permetre l'edició dels membres del grup",
// "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated" => "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated",
// "Descriptions" => "Descriptions",
"Display group descriptions below list name" => "Mostrar descripcions de grup per sota de nom de la llista",
"How to show the member lists" => "Com mostrar la llista de membres",
"Maximum" => "Màxim",
// "Maximum number of users to list in each group (default %0100%1)" => "Maximum number of users to list in each group (default %0100%1)",
"Members Only" => "Només membres",
// "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user" => "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user",
"Sort mode" => "Mode de classificació",
"Sort mode for member listing" => "Ordenar la manera de llista de membres",
"Read only mode. All ability to modify membership is hidden" => "Mode de només lectura. Tota possibilitat de modificar la pertinença s'oculta",
"Set as Default Group" => "Establir com a grup per omissió",
// "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group",
"Not suggested" => "No suggerit",
"Suggested" => "Suggeriment",
"Required" => "Requerit",
"Only groups including the group that you specify will be listed" => "Només els grups, incloent-hi el grup que especifiqui es mostraran",
// "Notify Added User" => "Notify Added User",
// "Notify Removed User" => "Notify Removed User",
// "Email notification to removed user" => "Email notification to removed user",
// "Need Approval" => "Need Approval",
// "Add approve/reject user buttons for private addon groups" => "Add approve/reject user buttons for private addon groups",
"Member Payment" => "Pagament membre",
// "Receive payment from a member to extend membership to a group" => "Receive payment from a member to extend membership to a group",
"Name of the group for which the subscription should be added or extended" => "Nom del grup per al qual s'ha d'afegir o ampliar la subscripció",
"Price per period (%0)" => "Preu per període ( %0)",
"Current User Member" => "Membre actual de l'usuari",
"Membership only for the current user" => "Membres només per a l'usuari actual",
"Input Title" => "Introducció de títols",
"Title of the initial input form" => "Títol del formulari d'entrada inicial",
// "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years" => "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years",
"Supports wiki syntax" => "Suporta sintaxi wiki",
"Input Title Only" => "Ingrés de títol Només",
// "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well" => "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well",
"Initial Payment Form Title" => "Forma de Pagament Inicial Títol",
"Add a title to the payment form when initially shown after clicking \"Continue\"" => "Afegir un títol a la forma de pagament quan es mostra inicialment després de fer clic a \"Continua\"",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years",
"Payment Form Title Only" => "Forma de Pagament Només títol",
// "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well",
"Subsequent Payment Form Title" => "Després Forma de Pagament Títol",
"Title of the payment form after the initial showing" => "Títol de la forma de pagament després de la projecció inicial",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years",
"Subsequent Payment Form Title Only" => "Després Forma de Pagament Només títol",
// "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well",
"Prevent Double Request" => "Prevenir Sol·licitud Doble",
"Prevent user from extended if there is already a pending request" => "Prevenir usuari estès si ja existeix una sol·licitud pendent",
// "Free Periods" => "Free Periods",
// "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought",
"Hide Period" => "Període Amaga",
"Do not allow user to set period - use default of 1" => "No permetre a l'usuari ajustar període - l'ús per omissió d'1",
"Periods Label" => "Períodes Label",
// "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)" => "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)",
"Page that payment service returns to after processing" => "Pàgina que el servei de pagament torna després del tractament",
// "Annual, commencing %0 %1 each year" => "Annual, commencing %0 %1 each year",
// "Monthly, commencing on day %0 each month" => "Monthly, commencing on day %0 each month",
"The user " => "L'usuari",
" already has a pending extension request payment invoice " => " ja té una sol·licitud de pròrroga factura pendent de pagament",
// "%0 to %1 %2 for %3" => "%0 to %1 %2 for %3",
// "periods" => "periods",
// "period" => "period",
// "Membership to %0 for %1 users for %2 %3" => "Membership to %0 for %1 users for %2 %3",
"The group " => "El grup de",
" does not have a membership term" => " no té un període d'afiliació",
" Go to " => " Ves a ",
"Admin > Groups" => "Admin> Grups",
" to specify a term for this group by automatically unassigning users after a certain number of days" => " per especificar un termini per a aquest grup de desassignar usuaris automàticament després d'un cert nombre de dies",
" does not exist" => " no existeix",
// "MetaTag" => "MetaTag",
// "Add custom meta tags to the HTML head section of the page where the plugin is used" => "Add custom meta tags to the HTML head section of the page where the plugin is used",
// "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here" => "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here",
// "Name attribute of the meta tag" => "Name attribute of the meta tag",
// "Content attribute of the meta tag" => "Content attribute of the meta tag",
"Mini Quiz" => "Mini Examen",
"Create a quiz using a tracker" => "Creació de proves utilitzant un un formulari-bd",
"Instructions::Feedback" => "Instruccions::Escriu-nos",
"Numeric value representing the miniquiz tracker ID" => "Valor numèric que representa la miniquiz formulari-bd ID",
"Module" => "Mòdul",
"Display a module" => "Mostrar un mòdul",
"Module Name" => "Nom del mòdul",
"Module name as known in Tiki" => "Nom del mòdul com es coneix en Tiki",
// "Select Yes (%0y%1) to hide the title (default is to show the title)" => "Select Yes (%0y%1) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)" => "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)",
"Align the module to the left or right on the page allowing other elements to align against it" => "Alineeu el mòdul de l'esquerra o la dreta de la pàgina que permet a altres elements que s'alineen en contra d'ella",
// "Number of rows (default: %010%1)" => "Number of rows (default: %010%1)",
"Parse" => "Interpreta",
"Parse wiki syntax" => "Analitzar la sintaxi wiki",
"Show only the content with no title or borders, etc. around the content" => "Mostra només el contingut amb cap caixa que l'envolta",
"Title, background, etc" => "Decoració",
"Show module title (heading) background, etc. (default is to show them)" => "Mostra decoracions casella (opció per omissió és mostrar a ells)",
// "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)" => "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)",
"Title Background" => "Títol Fons",
// "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)" => "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)",
"Module Style" => "Estil Mòdul",
// "Inline CSS for the containing div element, for example, %0max-width:80%%1" => "Inline CSS for the containing div element, for example, %0max-width:80%%1",
// "Valid CSS styling" => "Valid CSS styling",
"CSS styling for the module data itself" => "Estil CSS per a les dades del mòdul en si",
"Custom CSS class" => "Classe CSS personalitzada",
// "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons",
// "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above",
// "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated" => "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated",
// "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module",
"Please choose a module" => "Si us plau, trieu un mòdul",
"to be used as argument" => "per ser emprat com a argument",
"Sorry, no such module" => "Perdó, aquest mòdul no existeix",
"Module List" => "Llista de mòduls",
// "Display the modules assigned to a zone" => "Display the modules assigned to a zone",
"Zone Name" => "Nom de la zona",
"The name of the module zone to include. Can be a custom zone name" => "El nom de la zona del mòdul d'incloure. Pot ser un nom de zona personalitzada",
// "Top bar" => "Top bar",
// "Page top" => "Page top",
// "Page bottom" => "Page bottom",
"Monospace" => "Lletra amb amplada fixa",
"Display text in a monospace font" => "Mostra el text en una font monoespaiat",
// "Text that the font will be applied to" => "Text that the font will be applied to",
"Font name as recognized by browsers" => "Nom de la font com es coneix en els navegadors",
"Mouseover" => "Situeu el ratolí",
// "Display hidden content by mousing over text" => "Display hidden content by mousing over text",
"Hidden content, unless the label parameter is undefined, in which case this is the label" => "Contingut ocult, llevat que el paràmetre de l'etiqueta no està definida, en aquest cas es tracta de l'etiqueta",
"Text displayed on the page. The body is the hidden content" => "El text apareix a la pàgina. El cos és el contingut ocult",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
"DEPRECATED" => "OBSOLET",
"Hidden content. The body contains the label" => "Contingut Ocult. El cos conté l'etiqueta",
// "Mouseover box width. Default: %0400px%1" => "Mouseover box width. Default: %0400px%1",
// "Mouseover box height. Default: %0200px%1" => "Mouseover box height. Default: %0200px%1",
"Offset X" => "Desplaçament X",
// "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1" => "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1",
"Offset Y" => "Offset I",
// "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1" => "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1",
"Parse Body" => "Analitzar Cos",
"Parse the body of the plugin as wiki content (parsed by default)" => "Analitzar el cos del connector com a contingut wiki (analitzada per omissió)",
"Parse Label" => "Etiqueta Analitzar",
"Parse the label as wiki content (parsed by default)" => "Analitzar l'etiqueta com a contingut wiki (analitzada per omissió)",
"CSS class to apply" => "Classe CSS per aplicar",
"Background color to apply to the popup" => "El color de fons per aplicar a la finestra emergent",
"Text Color" => "Color del text",
"Color to apply to the text in the popup" => "Color per aplicar al text en el menú emergent",
"Sticky" => "Enganxós",
"When enabled, popup stays visible until it is clicked" => "Quan s'activa, estades emergents visibles fins que es fa clic",
"Padding" => "Farciment",
"Padding size in pixels" => "Mida de farciment en píxels",
"Effect" => "Efecte",
"Set the type of show/hide animation that will be used" => "Ajusteu el tipus d'espectacle / hide animació que s'utilitzarà",
"Effect Speed" => "Velocitat d'Efecte",
"Set the speed of the animation" => "Ajusteu la velocitat de l'animació",
"Close Delay" => "Retard de Tancament",
"Number of seconds before popup closes" => "Nombre de segons abans que tanqui la finestra emergent",
// "HTML tag to use for the label. Default %0a%1" => "HTML tag to use for the label. Default %0a%1",
"No label specified" => "No etiqueta especificada",
"MediaWiki Table" => "MediaWiki Taula",
// "Display a table using MediaWiki syntax" => "Display a table using MediaWiki syntax",
"Fancy" => "Fantasia",
// "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter" => "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter",
"True" => "Veritable",
"False" => "Fals",
"Wiki Classes" => "Classes Wiki",
// "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)" => "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)",
"MySpace" => "MySpace",
"Display a MySpace Flash mp3 playlist" => "Mostra una llista de reproducció MySpace flash mp3",
"MySpace Page" => "Pàgina de MySpace",
"MySpace page name" => "MySpace nom de la pàgina",
"Network condition" => "Condicions Network",
// "Display content based on the user's IP address" => "Display content based on the user's IP address",
"Content to display conditionally" => "Contingut per mostrar condicionalment",
"IPv4 List" => "Llista IPv4",
"Comma-separated list of IPv4 addresses to match against the visitor's address" => "Llista separada per comes de les adreces IPv4 perquè coincideixi amb la direcció en contra dels visitants",
"Now" => "Ara",
// "Show the current date and time" => "Show the current date and time",
// "Time format using the PHP format described here: %0" => "Time format using the PHP format described here: %0",
// "Based site long date and time setting" => "Based site long date and time setting",
// "Date to display" => "Date to display",
// "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0" => "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0",
// "Allow Invalid Dates" => "Allow Invalid Dates",
// "Allow return values that are not a valid date, such as the day of the month" => "Allow return values that are not a valid date, such as the day of the month",
// "Plugin now when parameter not valid. %0" => "Plugin now when parameter not valid. %0",
"Object Hits" => "Impactes d'objectes",
"Display the number of hits for certain objects" => "Mostra el nombre de visites per a certs objectes",
// "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title" => "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1" => "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1",
// "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits" => "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits",
"Since a date" => "Des d'una data",
"Date since the hits are collected in a format supported by strtotime" => "Conèixer des dels èxits es recullen en un format compatible amb strtotime",
// "Display a link to an object" => "Display a link to an object",
"The object type" => "El tipus d'objecte",
"The item to display" => "L'element per mostrar",
// "Tiki Package View" => "Tiki Package View",
// "Display the output of a Tiki Package View" => "Display the output of a Tiki Package View",
// "Package Name" => "Package Name",
// "Name of package in the form %0vendor/name%1" => "Name of package in the form %0vendor/name%1",
// "Name of the view" => "Name of the view",
// "Name of the view file without the %0.php%1" => "Name of the view file without the %0.php%1",
"Page Tabs" => "Fitxes de pàgina",
"PluginPageTabs" => "PluginPageTabs",
// "Display the content of a wiki page in a set of tabs" => "Display the content of a wiki page in a set of tabs",
"Wiki page names" => "Noms de les pàgines Wiki",
// "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent",
"Parameter" => "Parameter",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met",
// "Names of parameters required to display text, separated by %0|%1" => "Names of parameters required to display text, separated by %0|%1",
// "Source where the parameter is checked" => "Source where the parameter is checked",
// "REQUEST" => "REQUEST",
// "GET" => "GET",
// "POST" => "POST",
// "COOKIE" => "COOKIE",
// "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"" => "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"",
"Show the details of a payment request or invoice." => "Mostra els detalls d'una sol·licitud de pagament o la factura",
"Payment Request Number" => "Nombre de sol·licitud de pagament",
"Unique identifier of the payment request" => "Identificador únic de la sol·licitud de pagament",
// "Payment List" => "Payment List",
// "Show details of payments. The payments considered may be restrained by user or date" => "Show details of payments. The payments considered may be restrained by user or date",
// "Payment type" => "Payment type",
"Outstanding" => "Excepcional",
"Overdue" => "Endarrerit",
// "Authorized" => "Authorized",
// "Output format" => "Output format",
"Total" => "Total",
// "JSON (for advanced custom usage)" => "JSON (for advanced custom usage)",
// "Payments by a particular user" => "Payments by a particular user",
// "Payer email" => "Payer email",
// "Date range start, accepts most date formats" => "Date range start, accepts most date formats",
// "Date range end" => "Date range end",
// "Advanced filter" => "Advanced filter",
// "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)" => "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)",
// "List offset" => "List offset",
// "For pagination" => "For pagination",
// "Payments per page" => "Payments per page",
// "Automatic (newest first)" => "Automatic (newest first)",
// "User A to Z" => "User A to Z",
// "User Z to A" => "User Z to A",
// "Amount low to high" => "Amount low to high",
// "Amount high to low" => "Amount high to low",
// "Payment: oldest first" => "Payment: oldest first",
// "Payment: newest first" => "Payment: newest first",
// "Request: oldest first" => "Request: oldest first",
// "Request: newest first" => "Request: newest first",
// "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter" => "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter",
// "Plugin paymentlist: Unrecognised type \"%0\"" => "Plugin paymentlist: Unrecognised type \"%0\"",
// "No payments found" => "No payments found",
// "Payments by anonymous where the payer's email is recorded" => "Payments by anonymous where the payer's email is recorded",
"PayPal Button" => "PayPal Button",
// "Embed a PayPal button" => "Embed a PayPal button",
"Type of PayPal button" => "Tipus de botó de PayPal",
"Shopping cart" => "Carro de la compra",
"Buy Now" => "Compra Ara",
"Donations" => "Donacions",
"Cart Action" => "Carro·lícules d'acció",
"Action if Shopping Cart selected for type" => "Acció si s'ha seleccionat el carret de la compra per al tipus",
"Add to Cart" => "Afegir a la cistella",
"View Cart" => "Veure Cistella",
"Item Name" => "Nom de l'article",
"Item name or description. Required for Shopping cart" => "Nom de l'article o la descripció. Necessari per a la cistella",
"Item price" => "Preu de l'article",
"Button appearance" => "Aparença Button",
"Smaller" => "Més petit",
"Custom" => "Costum",
"Custom Button" => "Botó d'encàrrec",
"Custom button image URL" => "Botó Personalitzar URL de la imatge",
"Optional item identifier, often a tracker itemId" => "Identificador d'element opcional, sovint un tracker Itemid",
"Number of items, empty or 0 to have an input the user can fill in" => "Nombre d'objectes, buit o 0 perquè una entrada de l'usuari pot omplir els",
"Shipping Cost" => "Despeses d'enviament",
"The cost of shipping this item" => "El cost de tramesa d'aquest article",
"Additional Shipping Cost" => "Addicional Cost d'enviament",
// "The cost of shipping each additional unit of this item" => "The cost of shipping each additional unit of this item",
"Weight of item" => "Pes de l'article",
"Weight Unit" => "Pes de la unitat",
"The unit of measure if weight is specified" => "La unitat de mesura si no s'especifica el pes",
"Kilos" => "Quilos",
"Pounds" => "Lliures",
"Business ID" => "Aneu Negocis",
"PayPal business name/ID" => "PayPal nom de l'empresa / ID",
"(Uses value in admin/payment if not set here)" => "(Utilitza el valor en admin / pagament si no s'estableix aquí)",
"Use MiniCart" => "Utilitza el Mini carret",
"See https://github.com/jeffharrell/MiniCart" => "Veure https://github.com/jeffharrell/MiniCart",
"Shipping Address Prompt" => "Adreça d'enviament del sistema",
// "Indicate whether to prompt for and require an address" => "Indicate whether to prompt for and require an address",
// "Prompt for address" => "Prompt for address",
// "Do not prompt for address" => "Do not prompt for address",
// "Prompt for and require address" => "Prompt for and require address",
"Completed payment return URL" => "Completat URL retorn pagament",
// "Empty for current page, %0n%1 to disable" => "Empty for current page, %0n%1 to disable",
"Continue Shopping URL" => "Continuar comprant URL",
"Cancel payment URL" => "Cancel URL pagament",
"Form title" => "Títol Form",
"Tooltip for the form and alt attribute for the image" => "Informació sobre eines per a la forma i l'atribut alt de la imatge",
"PayPal — The safer, easier way to pay online" => "PayPal - La forma més ràpida i segura de pagar a Internet",
"Button text" => "Text del botó",
"The checkout button text" => "El text del botó de pagament i enviament",
"Subtotal text" => "Text subtotal",
"The subtotal text" => "El text subtotal",
"Discount text" => "Text Descompte",
"The discount text" => "El text de descompte",
"Shipping text" => "Enviaments text",
"The shipping text" => "El text d'enviament",
"Processing text" => "Processament de textos",
"The processing text" => "El processament de textos",
"PayPal button" => "Botó de PayPal",
"Item name (item_name) required" => "Nom de l'article (item_name) requereix",
"Price (amount) required" => "Preu (quantitat) que es requereixen",
// "For customized PDF generation, to override global PDF settings" => "For customized PDF generation, to override global PDF settings",
// "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\" => "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\",
// "Generate table of contents" => "Generate table of contents",
// "Set if table of contents will be autogenerated before PDF content" => "Set if table of contents will be autogenerated before PDF content",
// "Link TOC headings with content on PDF document" => "Link TOC headings with content on PDF document",
// "Heading to be appeared before table of content is printed" => "Heading to be appeared before table of content is printed",
// "TOC levels" => "TOC levels",
// "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>" => "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>",
// "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page" => "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page",
// "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page" => "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page",
// "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly" => "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly",
// "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly" => "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly",
// "Generate PDF Bookmarks" => "Generate PDF Bookmarks",
// "Values H1-H6,separated by | <code>For example H1|H2|H3</code>" => "Values H1-H6,separated by | <code>For example H1|H2|H3</code>",
// "Secure confidential PDF with password, leave blank if password protected is not needed" => "Secure confidential PDF with password, leave blank if password protected is not needed",
// "Watermark text value, for example: Confidential, Draft etc. " => "Watermark text value, for example: Confidential, Draft etc. ",
// "Watermark image, enter full URL" => "Watermark image, enter full URL",
// "Full URL of watermark image" => "Full URL of watermark image",
// "Page background color" => "Page background color",
// "Page background image" => "Page background image",
// "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>" => "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>",
// "For pluginPDF, please select mpdf as default PDF engine from Print Settings" => "For pluginPDF, please select mpdf as default PDF engine from Print Settings",
// "Manual bookmark entry for a PDF file" => "Manual bookmark entry for a PDF file",
// "Bookmark Label" => "Bookmark Label",
// "Bookmark level" => "Bookmark level",
// "Insert page with new settings in PDF" => "Insert page with new settings in PDF",
// "Page Content" => "Page Content",
// "PDF page header text" => "PDF page header text",
// "PDF page footer text" => "PDF page footer text",
// "Watermark text for this page. Set value as \"off\", to turn off watermark of the page" => "Watermark text for this page. Set value as \"off\", to turn off watermark of the page",
// "Watermark text value, for example: Confidential, Draft etc" => "Watermark text value, for example: Confidential, Draft etc",
// "Watermark image, enter full url" => "Watermark image, enter full url",
// "To turn off watermark image on the page, set value as <code>off</code>" => "To turn off watermark image on the page, set value as <code>off</code>",
// "PluginPDF Page Break" => "PluginPDF Page Break",
// "Helpful to format PDF files created, plugin adds page break in PDF file generated" => "Helpful to format PDF files created, plugin adds page break in PDF file generated",
"Display content based on permission settings" => "Mostrar contingut en funció de la configuració de permisos",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions",
"Possible Permissions" => "Possibles Permisos",
// "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext" => "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext",
"Forbidden Permissions" => "Prohibida Permisos",
// "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show" => "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show",
"Global" => "Global",
// "Indicate whether the permissions are global or local to the object" => "Indicate whether the permissions are global or local to the object",
// "Display content based on the user's current perspective" => "Display content based on the user's current perspective",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition",
"Allowed Perspectives" => "Perspectives mascotes",
"Pipe-separated list of identifiers of perspectives in which the block is shown" => "Llista Pipe-separada dels identificadors de punts de vista en el qual es mostra el bloc",
"Denied Perspectives" => "Perspectives Denegades",
// "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown" => "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown",
// "Pivot table" => "Pivot table",
// "Create and display data in pivot table for reporting" => "Create and display data in pivot table for reporting",
// "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on" => "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on",
// "Data source" => "Data source",
// "Override item permissions" => "Override item permissions",
// "Return all tracker items ignoring permissions to view the corresponding items" => "Return all tracker items ignoring permissions to view the corresponding items",
// "Width of pivot table. Units: % or px" => "Width of pivot table. Units: % or px",
// "Height of pivot table. Units: px" => "Height of pivot table. Units: px",
// "Pivot table Rows" => "Pivot table Rows",
// "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. " => "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. ",
// "Use permanentNames in case of tracker fields" => "Use permanentNames in case of tracker fields",
// "Separated by colon (:) if more than one" => "Separated by colon (:) if more than one",
// "Pivot table Columns" => "Pivot table Columns",
// "Which field or fields to use as table columns. Leaving blank will use the first available field" => "Which field or fields to use as table columns. Leaving blank will use the first available field",
// "Values used to decide what heatmapColors to use" => "Values used to decide what heatmapColors to use",
// "Color for each heatmapDomain value" => "Color for each heatmapDomain value",
// "Renderer Name" => "Renderer Name",
// "Display format of data" => "Display format of data",
// "Table Barchart" => "Table Barchart",
// "Heatmap" => "Heatmap",
// "Row Heatmap" => "Row Heatmap",
// "Col Heatmap" => "Col Heatmap",
// "Line Chart" => "Line Chart",
// "Bar Chart" => "Bar Chart",
// "Overlay Bar Chart" => "Overlay Bar Chart",
// "Stacked Bar Chart" => "Stacked Bar Chart",
// "Relative Bar Chart" => "Relative Bar Chart",
// "Boxplot Chart" => "Boxplot Chart",
// "Horizontal Boxplot Chart" => "Horizontal Boxplot Chart",
// "Area Chart" => "Area Chart",
// "Histogram" => "Histogram",
// "Density Histogram" => "Density Histogram",
// "Percent Histogram" => "Percent Histogram",
// "Probability Histogram" => "Probability Histogram",
// "Density Histogram Horizontal" => "Density Histogram Horizontal",
// "Percent Histogram Horizontal" => "Percent Histogram Horizontal",
// "Probability Histogram Horizontal" => "Probability Histogram Horizontal",
// "Horizontal Histogram" => "Horizontal Histogram",
// "Histogram2D" => "Histogram2D",
// "Density Histogram2D" => "Density Histogram2D",
// "Percent Histogram2D" => "Percent Histogram2D",
// "Probability Histogram2D" => "Probability Histogram2D",
// "Density Histogram2D Horizontal" => "Density Histogram2D Horizontal",
// "Percent Histogram2D Horizontal" => "Percent Histogram2D Horizontal",
// "Probability Histogram2D Horizontal" => "Probability Histogram2D Horizontal",
// "Horizontal Histogram2D" => "Horizontal Histogram2D",
// "Scatter Chart" => "Scatter Chart",
// "Treemap" => "Treemap",
// "Aggregator Name" => "Aggregator Name",
// "Function to apply on the numeric values from the variables selected" => "Function to apply on the numeric values from the variables selected",
// "Count Unique Values" => "Count Unique Values",
// "List Unique Values" => "List Unique Values",
// "Sum" => "Sum",
// "Integer Sum" => "Integer Sum",
"Average" => "Mitjana",
// "Minimum" => "Minimum",
// "Sum over Sum" => "Sum over Sum",
// "80% Upper Bound" => "80% Upper Bound",
// "80% Lower Bound" => "80% Lower Bound",
// "Sum as Fraction of Total" => "Sum as Fraction of Total",
// "Sum as Fraction of Rows" => "Sum as Fraction of Rows",
// "Sum as Fraction of Columns" => "Sum as Fraction of Columns",
// "Count as Fraction of Total" => "Count as Fraction of Total",
// "Count as Fraction of Rows" => "Count as Fraction of Rows",
// "Count as Fraction of Columns" => "Count as Fraction of Columns",
"Values" => "Valors",
// "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts" => "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts",
// "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function" => "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function",
// "Inclusions" => "Inclusions",
// "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings" => "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings",
// "Filter list limit" => "Filter list limit",
// "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row" => "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row",
// "Aggregate details" => "Aggregate details",
// "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string" => "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string",
// "Highlight my items" => "Highlight my items",
// "Highlight owned items' values in Charts" => "Highlight owned items' values in Charts",
// "Highlight my group items" => "Highlight my group items",
// "Highlight items' values belonging to one of my groups in Charts" => "Highlight items' values belonging to one of my groups in Charts",
// "Color for each highlighted group items" => "Color for each highlighted group items",
// "xAxis label" => "xAxis label",
// "Override label of horizontal axis when using Chart renderers" => "Override label of horizontal axis when using Chart renderers",
// "yAxis label" => "yAxis label",
// "Override label of vertical axis when using Chart renderers" => "Override label of vertical axis when using Chart renderers",
// "Chart title" => "Chart title",
// "Override title when using Chart renderers" => "Override title when using Chart renderers",
// "Chart hover bar" => "Chart hover bar",
// "Display the Chart hover bar or not" => "Display the Chart hover bar or not",
// "Translate displayed data" => "Translate displayed data",
// "Use translated data values for calculations and display" => "Use translated data values for calculations and display",
// "Default value: No" => "Default value: No",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>",
// "Missing data parameter with format: source:ID, e.g. tracker:1" => "Missing data parameter with format: source:ID, e.g. tracker:1",
// "Error data parameter" => "Error data parameter",
// "You do not have rights to view tracker data" => "You do not have rights to view tracker data",
// "Unified search index not found" => "Unified search index not found",
// "Split wiki modifier should specify a field" => "Split wiki modifier should specify a field",
// "For example 'tracker:1' or 'activitystream'" => "For example 'tracker:1' or 'activitystream'",
// "Piwik" => "Piwik",
// "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter" => "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter",
// "Piwik server url" => "Piwik server url",
// "The url to your Piwik Server, where data for the report are collected and available" => "The url to your Piwik Server, where data for the report are collected and available",
// "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users" => "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users",
// "The ID of this website in Piwik To be improved" => "The ID of this website in Piwik To be improved",
// "Module and Action To Widgetize" => "Module and Action To Widgetize",
// "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma" => "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma",
// "Actions - Pages" => "Actions - Pages",
// "Actions - Entry pages" => "Actions - Entry pages",
// "Actions - Exit pages" => "Actions - Exit pages",
// "Actions - Outlinks" => "Actions - Outlinks",
// "Dashboard" => "Dashboard",
// "Live - Visitor in real time" => "Live - Visitor in real time",
// "Live - Simple Last Visit Count" => "Live - Simple Last Visit Count",
// "Live - Visitor Profile Popup" => "Live - Visitor Profile Popup",
// "Referrers - All referrers" => "Referrers - All referrers",
// "Referrers - Search engines" => "Referrers - Search engines",
// "Resolution - Screen Resolution" => "Resolution - Screen Resolution",
// "SEO - SEO Ranking (slow)" => "SEO - SEO Ranking (slow)",
// "User Country Map - RealTime Map" => "User Country Map - RealTime Map",
// "User Country Map - Visitor Map" => "User Country Map - Visitor Map",
// "User Country Map - Country" => "User Country Map - Country",
// "User Country Map - Continent" => "User Country Map - Continent",
// "User Language - Language" => "User Language - Language",
// "User Language - Language Code" => "User Language - Language Code",
// "Visits Time - By day of the week" => "Visits Time - By day of the week",
// "Visits Time - Visit Information Per Local Time" => "Visits Time - Visit Information Per Local Time",
// "Visits Time - Visit Information Per Server Time" => "Visits Time - Visit Information Per Server Time",
// "Visits Summary - by day of the week" => "Visits Summary - by day of the week",
// "Visits Summary - over time" => "Visits Summary - over time",
// "Visits Summary - overview with graph" => "Visits Summary - overview with graph",
// "Visitors - Visitor map" => "Visitors - Visitor map",
// "Visitors - Pages per visit" => "Visitors - Pages per visit",
// "Visitors - Frequency overview" => "Visitors - Frequency overview",
// "Visitors - Returning visits over time" => "Visitors - Returning visits over time",
// "Visitor Devices - Device type" => "Visitor Devices - Device type",
// "Visitor Devices - browser" => "Visitor Devices - browser",
// "Visitor Devices - Browser Versions" => "Visitor Devices - Browser Versions",
// "Visitor Devices - OS Families" => "Visitor Devices - OS Families",
// "Visitor Devices - OS Versions" => "Visitor Devices - OS Versions",
// "Visitor Interest - Number Of Visits Per Visit Duration" => "Visitor Interest - Number Of Visits Per Visit Duration",
// "Visitor Interest - Number Of Visits Per Page" => "Visitor Interest - Number Of Visits Per Page",
// "Visitor Interest - Number Of Visits By Visit Count" => "Visitor Interest - Number Of Visits By Visit Count",
// "Visitor Interest - Number Of Visits By Days Since Last" => "Visitor Interest - Number Of Visits By Days Since Last",
// "Visitor Setting - Screen resolution" => "Visitor Setting - Screen resolution",
// "Statistics period" => "Statistics period",
// "Data display duration. If range is selected you must enter the start and end the date" => "Data display duration. If range is selected you must enter the start and end the date",
"Range" => "Abast",
// "Date or Start date" => "Date or Start date",
// "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd" => "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd",
// "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)" => "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)",
// "Module width" => "Module width",
// "Optional, width of the module in px or % (100% by default)" => "Optional, width of the module in px or % (100% by default)",
// "Module height" => "Module height",
// "Optional, height of the module in px" => "Optional, height of the module in px",
// "Iframe Scrolling" => "Iframe Scrolling",
// "Optional, scrolling of the iframe that contain the module (no by default)" => "Optional, scrolling of the iframe that contain the module (no by default)",
// "Piwik javascript code" => "Piwik javascript code",
// "Define option for Piwik groups, include or exclude" => "Define option for Piwik groups, include or exclude",
// "Plugin Piwik error" => "Plugin Piwik error",
// "Piwik server url is required" => "Piwik server url is required",
// "Site Id is required" => "Site Id is required",
// "moduleToWidgetize is required" => "moduleToWidgetize is required",
// "Period set to range but no end date provided" => "Period set to range but no end date provided",
// "PlayScorm" => "PlayScorm",
// "Play a SCORM learning object in an iframe using Moodle" => "Play a SCORM learning object in an iframe using Moodle",
// "Numeric ID of a SCORM zip file in a File Gallery" => "Numeric ID of a SCORM zip file in a File Gallery",
// "Moodle URL" => "Moodle URL",
// "Web address of the Moodle instance" => "Web address of the Moodle instance",
// "Moodle Course ID" => "Moodle Course ID",
// "Course ID in Moodle to upload SCORM objects to" => "Course ID in Moodle to upload SCORM objects to",
// "Frame Width" => "Frame Width",
// "Frame Height" => "Frame Height",
// "Numeric ID" => "Numeric ID",
// "Numeric ID to distinguish multiple plugins of there is more than one" => "Numeric ID to distinguish multiple plugins of there is more than one",
"Either the module or plugin parameter must be set, but not both" => "S'ha d'establir el paràmetre de mòdul o plugin, però no tant",
"Plugin Manager error: %0%1 not found" => "Error de l'Administrador de Programes: %%0 1 no trobat",
"Plugin Manager error: %0%1%2%3%4 not found" => "Error de l'Administrador de Programes: %%0 1 %2 %3 %4 no trobat",
"Plugin Manager error:  %0%1 not found" => "Error de l'Administrador de Programes: %%0 1 no trobat",
"Options" => "Opcions",
"Accepted Values" => "Els valors acceptats",
"(body of plugin)" => "(Cos del plugin)",
// "%0separator:%1 " => "%0separator:%1 ",
"(blank)" => "(En blanc)",
"any string except for HTML and PHP tags" => "qualsevol cadena excepte per a les etiquetes HTML i PHP",
"Since" => "Des",
"no parameters" => "sense paràmetres",
"Preferences required" => "Preferències requereixen",
// "Introduced in %0" => "Introduced in %0",
"Required parameters are in%0 %1bold%2" => "Els paràmetres requerits són en %0 %1bold%2",
"Plugin Manager" => "Gerent de Programes",
"List wiki plugin or module information for the site" => "Llista de Programes wiki o informació de mòdul per al lloc",
"Information" => "Informació",
// "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1" => "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1",
"One or more of: description | parameters | paraminfo" => "Un o més: description | parameters | paraminfo (descripció | paràmetres | informació dels paràmetres)",
"Description and Parameters" => "Descripció i Paràmetres",
"Description & Parameter Info" => "Descripció i Paràmetres Informació",
"Parameters & Parameter Info" => "Paràmetres i dades de paràmetres",
"Plugin" => "Connector (Plugin)",
// "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter" => "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter",
// "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter" => "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter",
"Single Title" => "Títol únic",
"Set placement of plugin name and description when displaying information for only one plugin" => "Ajusteu la col·locació del nom del connector i la descripció en mostrar la informació d'un sol plugin",
"Title Heading" => "Títol Denominació",
// "Sets the heading size for the title, e.g., %0h2%1" => "Sets the heading size for the title, e.g., %0h2%1",
"Start with this plugin record number (must be an integer 1 or greater)" => "Comenceu amb el número de registre de plug-in (ha de ser un nombre enter 1 o més)",
// "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater",
// "Parameter Type" => "Parameter Type",
// "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions" => "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions",
// "Show Parameter Type" => "Show Parameter Type",
// "Show the parameter %0doctype%1 value" => "Show the parameter %0doctype%1 value",
// "Show Top Info" => "Show Top Info",
// "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default" => "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default",
"Poll" => "Sondeig",
// "Embed a poll" => "Embed a poll",
// "Title of the poll" => "Title of the poll",
"Numeric value representing the poll ID" => "Valor numèric que representa l'identificador de sondeig",
"Show poll title (shown by default)" => "Mostrar títol del sondeig (es mostra per omissió)",
"Show result" => "Mostrar resultat",
// "Set how results of the poll will be shown (default is %0link%1)" => "Set how results of the poll will be shown (default is %0link%1)",
// "Voted" => "Voted",
"Show total votes" => "Mostra el total de vots",
// "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)" => "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)",
"Preference" => "La preferència",
// "Display content based on global preference settings" => "Display content based on global preference settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions",
// "Document Preferences" => "Document Preferences",
// "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)" => "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)",
// "Preference-Tab" => "Preference-Tab",
// "The name of the preference tab to display, or a list of available tabs upon invalid" => "The name of the preference tab to display, or a list of available tabs upon invalid",
// "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2" => "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2",
"Pretty Tracker View Tracking" => "Pretty Localitzador de Seguiment",
"PluginPrettyTrackerViews" => "PluginPrettyFormulari-bd (Tracker)Views",
// "Store tiki.tracker.pretty.views attribute for a trackeritem" => "Store tiki.tracker.pretty.views attribute for a trackeritem",
// "Set to %0y%1 to record view each time this is loaded" => "Set to %0y%1 to record view each time this is loaded",
// "Set to %0n%1 to hide showing of attribute" => "Set to %0n%1 to hide showing of attribute",
"Set to ID of tracker item" => "Ajust de ID de l'element del registre",
// "Preview Files" => "Preview Files",
// "Enabled to generate preview of images or video files" => "Enabled to generate preview of images or video files",
// "Id of the file in the file gallery" => "Id of the file in the file gallery",
// "Animation" => "Animation",
// "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)" => "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)",
// "Width of the result in pixels" => "Width of the result in pixels",
// "Height of the result in pixels" => "Height of the result in pixels",
// "Show download link to the original file" => "Show download link to the original file",
"Profile Application" => "Perfil d'aplicació",
"Add a button for applying a profile" => "Afegiu un botó de l'aplicació d'un perfil",
// "Profile repository domain. Default value is %0profiles.tiki.org%1" => "Profile repository domain. Default value is %0profiles.tiki.org%1",
"Profile Name" => "Nom del Perfil",
"Name of the profile to be applied" => "Nom del perfil que s'aplicarà",
"Profile plugin only available to administrators" => "Perfil complement: només està disponible per als administradors",
"Profile %0/%1 not found" => "Profile %0 / %1 no trobat",
// "Profile Symbol Value" => "Profile Symbol Value",
// "Display the profile symbol related with profile and a reference and optionally with domain or package" => "Display the profile symbol related with profile and a reference and optionally with domain or package",
// "Reference key" => "Reference key",
// "Reference name" => "Reference name",
// "Package" => "Package",
// "Package extension name" => "Package extension name",
"Proposal" => "Proposta",
"Allow users to vote on a proposal and view the results" => "Permetre als usuaris votar sobre una proposta i veure els resultats",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "La llista de vots emesos. Un vot per línia. Ó bé 0, +1 ó -1 seguits per un nom d'usuari",
// "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable" => "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable",
"Weights" => "Pes",
// "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example" => "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example",
"Accept proposal" => "Accepta la proposta",
"Still undecided" => "Indecís encara",
"Reject proposal" => "Rebutja la proposta",
"Quote" => "Citar",
"Format text as a quote" => "Donar format al text com una cita",
"Quoted text" => "El text citat",
"Reply To" => "Respondre a",
"Name of the quoted person" => "Nom de la persona esmentada",
// "Thread Id for Forum replies" => "Thread Id for Forum replies",
// "The thread Id of the comment being replied to in forums. Overwrites replyto" => "The thread Id of the comment being replied to in forums. Overwrites replyto",
// "Source URL" => "Source URL",
// "The URL to the source quoted" => "The URL to the source quoted",
// "Date when the statement quoted was made" => "Date when the statement quoted was made",
// "YYYY-MM-DD" => "YYYY-MM-DD",
// "R syntax" => "R syntax",
// "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms" => "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms",
"Random Include" => "Incloure a l'atzar",
"Include a random page's content" => "Incloure el contingut d'una pàgina a l'atzar",
"Random Dynamic Content" => "Contingut dinàmic aleatori",
"Display pre-programmed changing content" => "Mostrar contingut canviant preprogramat",
"Numeric value representing the content ID" => "Valor numèric que representa la identificació de contingut",
"User List with Real Names" => "Llista d'usuaris amb noms reals",
"Show user real names for members of a group" => "Mostra veritables noms d'usuari per als membres d'un grup",
// "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included",
"Result limit" => "Resultat límit",
"Set to sort in ascending or descending order (unsorted by default" => "Set per ordenar en ordre ascendent o descendent (sense ordenar per omissió",
"Make the listed names links to various types of user information" => "Feu els noms enumerats enllaços a diversos tipus d'informació d'usuari",
"User Page" => "Pàgina d'usuari",
"User Preferences" => "Preferències d'usuari",
"Exclude" => "Excloure",
"Exclude certain test or admin names from the list" => "Excloure certes proves o noms d'administrador de la llista",
"admin" => "administrar",
"admin-test" => "administrador de la prova",
"test" => "prova",
"test-admin" => "prova-admin",
"Preferences" => "Preferències",
"Redirect" => "Redireccionar",
"Redirect to another page." => "Redirigir a una altra pàgina",
"Wiki page name to redirect to" => "Wiki nom de la pàgina a la qual redirigir",
"Complete URL, internal or external" => "URL completa, interna o externa",
"The ID of a perspective to switch to (requires feature_perspective)" => "La identificació de la perspectiva per canviar a (requereix feature_perspective)",
// "Auto login remote Tiki and redirect to page there" => "Auto login remote Tiki and redirect to page there",
// "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com" => "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com",
"perspective " => "perspectiva",
"nowhere" => "enlloc",
// "Remote system error" => "Remote system error",
"REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT connector: La redirecció a ' %s' està desactivada només després de salvar la pàgina",
"REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT connector: La redirecció a ' %s' està desactivat en la manera de vista prèvia.",
"REDIRECT plugin: redirect loop detected" => "REDIRECT connector: bucle de redireccionament detectat",
"Regular Expression" => "Expressió Regular",
"Perform a regular expression search and replace" => "Feu una cerca d'expressions regulars i reemplaçar",
"Each line of content is evaluated separately" => "Cada línia de contingut s'avalua per separat",
// "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page" => "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page",
"Register Member Payment" => "Fes-Pagament membre",
// "Register and make a member payment at the same time" => "Register and make a member payment at the same time",
"NA" => "NA",
"Fixed Periods" => "Períodes fixos",
// "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample" => "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample",
"Insufficient Privileges" => "Privilegis insuficients",
"Submit" => "Envia",
"You will be redirected in 5 seconds" => "Seràs redireccionat en 5 segons",
// "Display the relation of an object to the rest of the site" => "Display the relation of an object to the rest of the site",
"Qualifiers" => "Eliminatòries",
"Comma-separated list of relation qualifiers" => "Llista separada per comes dels qualificadors relació",
// "Object identifier as %0type:itemId%1" => "Object identifier as %0type:itemId%1",
"Single List" => "Llista única",
"Render all qualifiers into a single list without displaying the qualifier name" => "Render tots els classificats en una única llista sense que es mostri el nom qualificador",
// "Empty Message" => "Empty Message",
// "Message to give if result is empty and no relations are found" => "Message to give if result is empty and no relations are found",
"Remarks Box" => "Observacions Caixa",
// "Display a comment, tip, note or warning box" => "Display a comment, tip, note or warning box",
"remarks text" => "text de comentaris",
"Select type of remarksbox, which determines what icon and style will be displayed" => "Seleccioneu el tipus de remarksbox, que determina quina icona i l'estil es mostrarà",
"Confirm" => "Confirmar",
"Errors" => "Error",
"Tip" => "Pista",
"Label displayed above the remark" => "Etiqueta que es mostra per sobre de l'observació",
"Use the highlight class for formatting (not used by default)" => "Utilitza la classe més destacada per al format (no s'utilitza per omissió)",
"Custom Icon" => "Icona personal",
"Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)" => "Introduïu un nom de fitxer d'icona Tiki (amb o sense extensió) o la ruta per mostrar una icona personalitzada",
"Show a close button (not shown by default)" => "Mostrar un botó de tancament (no es mostra per omissió)",
// "Width (e.g. %0100%%1 or %0250px%1 - default \"\")" => "Width (e.g. %0100%%1 or %0250px%1 - default \"\")",
// "Remember Dismiss" => "Remember Dismiss",
// "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set" => "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set",
// "Sets an HTML id for the account" => "Sets an HTML id for the account",
// "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter" => "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter",
// "RR (R syntax also)" => "RR (R syntax also)",
// "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call" => "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call",
// "R Code" => "R Code",
// "echo" => "echo",
// "Show a code block with the R commands to be run before running them (similarly to the echo command)" => "Show a code block with the R commands to be run before running them (similarly to the echo command)",
// "echo debug" => "echo debug",
// "Show a code block with the R commands to be run even if the R program fails to execute" => "Show a code block with the R commands to be run even if the R program fails to execute",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "wikisyntax" => "wikisyntax",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
"width" => "amplada",
// "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio" => "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio",
"height" => "alçada",
// "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio" => "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio",
// "units" => "units",
// "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm" => "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm",
// "pointsize" => "pointsize",
// "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger" => "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger",
// "bg" => "bg",
// "The initial background colour (optional). Options: white, yellow, grey, ... and transparent" => "The initial background colour (optional). Options: white, yellow, grey, ... and transparent",
// "parse_body" => "parse_body",
// "parses the body content to allow data to be generated from other plugins" => "parses the body content to allow data to be generated from other plugins",
// "res" => "res",
// "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much" => "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much",
// "svg" => "svg",
// "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "pdf" => "pdf",
// "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "onefile" => "onefile",
// "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file" => "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file",
// "LoadAndSave" => "LoadAndSave",
// "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages" => "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages",
// "Caching strategy" => "Caching strategy",
// "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin" => "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin",
// "Limit cache duration" => "Limit cache duration",
// "Force cache recalculation after time limit. Default: No limit" => "Force cache recalculation after time limit. Default: No limit",
// "CacheBy" => "CacheBy",
// "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)" => "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)",
// "Page Name (pagename)" => "Page Name (pagename)",
// "Page Id (pageid)" => "Page Id (pageid)",
// "Cache age" => "Cache age",
// "Display cache last modification date below the graph (default option: do not display)" => "Display cache last modification date below the graph (default option: do not display)",
// "attId" => "attId",
// "AttId from a tracker Item attachment. ex: 1. (Optional)" => "AttId from a tracker Item attachment. ex: 1. (Optional)",
// "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required" => "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required",
// "csv" => "csv",
// "xml" => "xml",
// "x11" => "x11",
// "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()" => "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()",
// "removen" => "removen",
// "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)" => "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)",
// "Custom output" => "Custom output",
// "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file" => "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file",
// "security" => "security",
// "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)" => "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)",
// "Cache was last modified: %0" => "Cache was last modified: %0",
// "One cache per plugin" => "One cache per plugin",
// "One cache per plugin per user" => "One cache per plugin per user",
// "No caching: Ignore and replace existing cache, if any" => "No caching: Ignore and replace existing cache, if any",
// "No limit" => "No limit",
// "1 hour" => "1 hour",
// "1 day" => "1 day",
// "7 days" => "7 days",
// "30 days" => "30 days",
// "365 days" => "365 days",
// "Don't display cache creation date" => "Don't display cache creation date",
// "Display cache creation date" => "Display cache creation date",
// "Blocked commands found: " => "Blocked commands found: ",
// "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you" => "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you",
// "command unavailable" => "command unavailable",
// "The __R__ package needs to be installed on the server" => "The __R__ package needs to be installed on the server",
// "See requirements on [https://doc.tiki.org/PluginR]" => "See requirements on [https://doc.tiki.org/PluginR]",
// "The path to the __R__ command could not be found on your system" => "The path to the __R__ command could not be found on your system",
// "Maybe this file is inaccessible due to safe mode restrictions" => "Maybe this file is inaccessible due to safe mode restrictions",
// "The path to the __convert__ command could not be found on your system" => "The path to the __convert__ command could not be found on your system",
// "You need to ensure that you have __imagemagick__ installed successfully on the server" => "You need to ensure that you have __imagemagick__ installed successfully on the server",
// "Cached R output from %0. If you click, you will re-run all R scripts in this page" => "Cached R output from %0. If you click, you will re-run all R scripts in this page",
// "Save Image as SVG" => "Save Image as SVG",
// "Save Image as PDF" => "Save Image as PDF",
// "plot" => "plot",
"RSS Feed" => "RSS RSS",
// "Display items from one or more RSS feeds" => "Display items from one or more RSS feeds",
"IDs" => "ID",
// "List of feed IDs separated by colons. ex: %0" => "List of feed IDs separated by colons. ex: %0",
"Result Count" => "Resultat del recompte",
"Number of results displayed" => "Nombre de resultats que es mostren",
"Show date of each item (not shown by default)" => "Mostrar la data de cada element (no es mostra per omissió)",
"Show feed descriptions (not shown by default)" => "Mostrar descripcions d'alimentació (no es mostra per omissió)",
"Show authors (not shown by default)" => "Mostra autors (no es mostra per omissió)",
"URL to a favicon to put before each entry" => "Url a un favicon per posar abans de cada entrada",
"Show the title of the feed (shown by default)" => "Mostra el títol de l'alimentació (es mostra per omissió)",
"Ticker" => "Ticker",
"Turn static feed display into ticker news like" => "Gira pantalla feed estàtic en ticker de notícies com",
"Description Length" => "Descripció Longitud",
"Max characters/length, truncates text to fit design" => "Max caràcters / longitud, el text es trunca per ajustar-se al disseny",
"Scroll" => "Desplaceu-vos",
"Show animated text that scrolls up or down" => "Mostra el text animat que es desplaça cap amunt o cap avall",
// "Width in pixels. Example: %0" => "Width in pixels. Example: %0",
// "Number of pixels followed by \"px\"" => "Number of pixels followed by \"px\"",
// "Height in pixels. Example: %0" => "Height in pixels. Example: %0",
// "Scroll speed in number of seconds (default is %0)" => "Scroll speed in number of seconds (default is %0)",
"SourceForge" => "SourceForge",
"Creates a link to SourceForge tracker items" => "Crea un enllaç a SourceForge elements del registre",
"Group ID" => "ID de grup",
"SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge Projecte ID (mostra com group_id a la URL d'un element del registre",
"SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker Identificació (mostra com ATID a la URL d'un element del registre",
"SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge element ID (mostra com ajuda en l'adreça URL d'un element del registre",
"Link title" => "Títol de l'enllaç",
// "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)",
"ShareThis" => "ShareThis",
"Add a ShareThis button" => "Afegiu un botó de ShareThis",
"Send Services" => "Enviar Services",
// "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services" => "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services",
"AIM" => "Apuntar",
// "AIM and Email" => "AIM and Email",
// "AIM and SMS" => "AIM and SMS",
// "Email and SMS" => "Email and SMS",
"Button Style" => "Button Style",
// "Set button style" => "Set button style",
"Rotate Image" => "Girar imatge",
// "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping" => "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping",
"Multiple Icons" => "Icones múltiples",
// "Enter pipe-separated list of services, e.g., %0" => "Enter pipe-separated list of services, e.g., %0",
"First Services Shown" => "Primers serveis que es mostren",
// "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget",
"Custom link text for the button" => "Enllaços de text personalitzat per al botó",
"Header Title" => "Capçalera Títol",
"Optional header title text for the widget" => "Text del títol encapçalat opcional per al giny",
"Header Background" => "Capçalera del fons",
// "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used" => "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used",
"Header Text Color" => "Text de capçalera de color",
"HTML color code (not color name) for the header text if an optional header title is used" => "Codi de color HTML (no el nom del color) per al text de capçalera si s'utilitza un títol de capçalera opcional",
"Link text color for services" => "Enllaç color del text dels serveis",
"HTML color code (not color name) for the link text for all send and post services shown in the widget" => "Codi de color HTML (no el nom del color) per a l'enllaç de text per a tots enviar i publicar serveis que apareixen en el giny",
// "Set whether the widget will show in a popup window" => "Set whether the widget will show in a popup window",
"Embedded Elements" => "Elements incrustats",
// "Allow embedded elements (like flash) to be seen while iframe is loading" => "Allow embedded elements (like flash) to be seen while iframe is loading",
"Sheet" => "Full",
"Display data from a TikiSheet" => "Mostra dades d'un TikiSheet",
"Spreadsheet Heading" => "Capçalera del full",
// "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required" => "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required",
"Sheet Url Location" => "Full Url Ubicació",
// "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired" => "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired",
// "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)" => "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1" => "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1",
"Height in pixels or percentage. Default value is complete spreadsheet height" => "Alçada en píxels o percentatge. El valor per omissió és l'altura de full de càlcul completa",
// "Show edit button. Default is to show depending on user's permissions" => "Show edit button. Default is to show depending on user's permissions",
"Show subsheets" => "Mostra subsheets",
// "Show multi-sheets (default is to show)" => "Show multi-sheets (default is to show)",
// "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1" => "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1",
"Apply custom CSS class to the containing div" => "Aplicar classe CSS personalitzada per al div que conté",
"New sheet in page: " => "Nou full de la pàgina:",
"Create New Sheet" => "Crea un nou full",
"Error loading spreadsheet" => "Error en carregar el full de càlcul",
"Edit Sheet" => "Edita Full",
"Collect Anonymous Shopper Info" => "Recopilar informació Shopper Anonymous",
"PluginShopperinfo" => "PluginShopperinfo",
// "Collect shopper information for the shopping cart" => "Collect shopper information for the shopping cart",
"Values to be collected" => "Els valors que s'han de recollir",
"Names of values to be collected separated by : as defined in shopper profile" => "Els noms dels valors que s'han de recollir per separat: els definits en el perfil de comprador",
"Labels for the values to be collected" => "Les etiquetes dels valors que s'han de recollir",
// "Labels of the values to be collected separated by a colon" => "Labels of the values to be collected separated by a colon",
"Show even if logged in" => "Mostri encara si connectat",
"Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normalment això s'utilitza per als usuaris anònims però de vegades es pot utilitzar quan es connecti també",
// "Shorten" => "Shorten",
// "Show/hide a portion of text" => "Show/hide a portion of text",
// "Char length of always visible portion of text" => "Char length of always visible portion of text",
// "More text" => "More text",
// "A label indicating the text is expandable" => "A label indicating the text is expandable",
// "Less text" => "Less text",
// "A label for collapse text action" => "A label for collapse text action",
"Show Pages" => "Mostrar Pàgines",
"Find pages by searching within page names" => "Algunes de les pàgines de cerca dins dels noms de pàgina",
"Search criteria" => "Criteris de cerca",
"Maximum amount of results displayed" => "Import màxim de resultats que es mostren",
"Display page name and/or description. Both displayed by default" => "Mostrar el nom de la pàgina i / o la descripció. Tant la mostra per omissió",
"Name & Description" => "Nom i descripció",
// "Show Preference" => "Show Preference",
// "Display the value of public global preferences" => "Display the value of public global preferences",
// "Name of preference to be displayed" => "Name of preference to be displayed",
"Add Bibliography" => "Afegir Bibliografia",
// "Add bibliography listing in the footer of a wiki page" => "Add bibliography listing in the footer of a wiki page",
// "Title to be displayed in the bibliography listing. Default is %0Bibliography%1" => "Title to be displayed in the bibliography listing. Default is %0Bibliography%1",
"Show bibliography title. Title is shown by default" => "Mostra títol bibliografia. Títol es mostra per omissió",
"Header Tag" => "Tag Capçalera",
// "The HTML header tag level of the title. Default: %01%1" => "The HTML header tag level of the title. Default: %01%1",
// "Remove the lines around the list of references" => "Remove the lines around the list of references",
// "Remove the horizontal lines displayed above and below the list of references" => "Remove the horizontal lines displayed above and below the list of references",
// "Page identifier" => "Page identifier",
// "Provide the page id" => "Provide the page id",
"Bibliography" => "Bibliografia",
"Signature" => "Signatura",
// "Sign and date your contribution to a page" => "Sign and date your contribution to a page",
"Auto-generated, the username" => "Autogenerat, el nom d'usuari",
"Date and time" => "Data i hora",
"Auto-generated, the timestamp" => "Autogenerat, la data i hora",
"Skype" => "Skype",
// "Add a link for calling or chating with a Skype user" => "Add a link for calling or chating with a Skype user",
"Name or number to call or chat with" => "Nom o nombre per trucar o xatejar amb",
"Set whether to call or chat. Default is chat" => "Definiu si s'ha de trucar o xatejar. Per omissió és de xat",
"Call" => "Trucar",
"Chat" => "Xat",
"Show status" => "Mostra l'estat",
// "Show a status icon or not i.e. if online/offline/etc. Default is to not show status" => "Show a status icon or not i.e. if online/offline/etc. Default is to not show status",
"yes" => "si",
// "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web" => "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web",
"click to" => "fes clic per",
"Slider" => "Lliscador",
// "Embed a mini-slideshow of content on a page" => "Embed a mini-slideshow of content on a page",
"Content separated by \"/////\"" => "Contingut separades per /////",
"Slider Titles" => "Títols lliscant",
// "Pipe-separated list of slider titles. Example" => "Pipe-separated list of slider titles. Example",
// "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels" => "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels",
"The theme to use in slider" => "El tema d'usar en lliscant",
"Expand" => "Expandir",
// "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set" => "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set",
// "Resize" => "Resize",
// "Set whether solitary images/objects in the panel will be expanded to fit the viewport" => "Set whether solitary images/objects in the panel will be expanded to fit the viewport",
"Show Multiple" => "Mostra múltiple",
"Set this value to a number and it will show that many slides at once" => "Establiu aquest valor en un número i es mostrarà que moltes diapositives alhora",
// "Arrows" => "Arrows",
// "Set whether to show forward and backward buttons" => "Set whether to show forward and backward buttons",
"Navigation" => "Navegació",
// "Set whether to show a list of anchor links to link to each panel" => "Set whether to show a list of anchor links to link to each panel",
// "Start / Stop" => "Start / Stop",
// "Set whether to show a start/stop button and add slideshow functionality" => "Set whether to show a start/stop button and add slideshow functionality",
"Toggle Arrows" => "Fletxes de Palanca",
// "Set whether side navigation arrows slide out on hovering and hide at other times" => "Set whether side navigation arrows slide out on hovering and hide at other times",
"Toggle Controls" => "Controls de commutació",
// "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times" => "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times",
"Enable Arrows" => "Habilitar Fletxes",
// "Set whether arrows are clickable" => "Set whether arrows are clickable",
"Enable Navigation" => "Habilitar navegació",
// "Set whether navigation links are clickable" => "Set whether navigation links are clickable",
"Enable Start Stop" => "Active Start Stop",
// "Set whether the play/stop button is clickable. Previously %0" => "Set whether the play/stop button is clickable. Previously %0",
"Enable Keyboard" => "Habilitar teclat",
// "Set whether keyboard arrow keys will work for this slider" => "Set whether keyboard arrow keys will work for this slider",
"Auto Play" => "Reproducció automàtica",
// "Set whether the slideshow will start running automatically; replaces %0 option" => "Set whether the slideshow will start running automatically; replaces %0 option",
"Auto Play Locked" => "Reproducció automàtica Bloquejat",
// "Keep playing the slideshow even if the user changes slides" => "Keep playing the slideshow even if the user changes slides",
"Auto Play Delayed" => "Reproducció automàtica retardada",
// "Set whether there will be a delay in advancing slides" => "Set whether there will be a delay in advancing slides",
"Pause On Hover" => "Pausa En Hover",
// "Set whether the slideshow will pause on hover while the slideshow is active" => "Set whether the slideshow will pause on hover while the slideshow is active",
"Stop At End" => "Parada al final",
// "Set whether the slideshow stops on the last page" => "Set whether the slideshow stops on the last page",
"Delay between slides" => "Retard entre les diapositives",
"Time in milliseconds between slideshow transitions (in AutoPlay mode)" => "Temps en milisegons entre transicions de diapositives (en la manera de reproducció automàtica)",
// "Right To Left" => "Right To Left",
// "Set whether the slideshow moves right-to-left" => "Set whether the slideshow moves right-to-left",
"Resume On Video End" => "Resumeix On Video End",
// "Set whether auto play stops until the video is complete (for supported video types)" => "Set whether auto play stops until the video is complete (for supported video types)",
"Animation Time" => "Temps d'Animació",
"Milliseconds between slides" => "Mil·lisegons entre diapositives",
// "Panel Hashtags" => "Panel Hashtags",
// "Set whether to include a hashtag in the page URL, allowing links to specific panels" => "Set whether to include a hashtag in the page URL, allowing links to specific panels",
// "Create a slideshow from the content of a wiki page" => "Create a slideshow from the content of a wiki page",
// "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI",
// "Parallax Background Image" => "Parallax Background Image",
// "URL of the background image to use in your slideshow, overrides %0" => "URL of the background image to use in your slideshow, overrides %0",
"Valid URL" => "URL vàlid",
// "Parallax Background Size" => "Parallax Background Size",
// "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)" => "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)",
// "Parallax Background Horizontal" => "Parallax Background Horizontal",
// "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis" => "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis",
// "Parallax Background Vertical" => "Parallax Background Vertical",
// "Transition" => "Transition",
// " Transition style" => " Transition style",
// "Transition Speed" => "Transition Speed",
// "Background Transition" => "Background Transition",
// "Transition style for full page slide backgrounds" => "Transition style for full page slide backgrounds",
// "Display presentation control arrows" => "Display presentation control arrows",
// "Controls Layout" => "Controls Layout",
// "Determines where controls appear, \"edges\" or \"bottom-right\"" => "Determines where controls appear, \"edges\" or \"bottom-right\"",
// "Controls Back Arrows" => "Controls Back Arrows",
// "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"" => "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"",
// "Progress" => "Progress",
// "Display a presentation progress bar" => "Display a presentation progress bar",
// "Slide Number" => "Slide Number",
// "Display the page number of the current slide" => "Display the page number of the current slide",
// "Fragments" => "Fragments",
// "Turns fragments on and off globally" => "Turns fragments on and off globally",
// "Fragment Effects" => "Fragment Effects",
// "Fragment Highlight Color" => "Fragment Highlight Color",
// "Auto Slide" => "Auto Slide",
// "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides" => "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides",
// "Auto Slide Stoppable" => "Auto Slide Stoppable",
// "Stop auto-sliding after user input" => "Stop auto-sliding after user input",
// "Auto-align Images" => "Auto-align Images",
// "Automatically move images to left hand side of slide text, will only align images greater than 200px in width" => "Automatically move images to left hand side of slide text, will only align images greater than 200px in width",
// "Start Slideshow Presentation" => "Start Slideshow Presentation",
// "SlideshowSlide" => "SlideshowSlide",
// "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings" => "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings",
// "Enter content of slide" => "Enter content of slide",
// "Slide Background color" => "Slide Background color",
// "Set background color for slide" => "Set background color for slide",
// "Slide Text color" => "Slide Text color",
// "Set Text color for slide" => "Set Text color for slide",
// "Background Video URL" => "Background Video URL",
// "Automatically plays a full size video behind the slide" => "Automatically plays a full size video behind the slide",
// "Mute Background Video" => "Mute Background Video",
// "Flags if the audio should be muted for background video" => "Flags if the audio should be muted for background video",
// "Loop Background Video" => "Loop Background Video",
// "Flags if the background video played in loop" => "Flags if the background video played in loop",
// "Transition In" => "Transition In",
// "Select entry transition effect for slide" => "Select entry transition effect for slide",
// "Transition Out" => "Transition Out",
// "Select exit transition effect for slide" => "Select exit transition effect for slide",
"Smarty function" => "Funció de Smarty",
// "Insert a Smarty function or variable" => "Insert a Smarty function or variable",
// "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1" => "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1",
"Snarf" => "Snarf",
"Display the contents of another web page" => "Mostra el contingut d'una altra pàgina web",
"Full URL to the page to include" => "URL completa de la pàgina per a incloure",
"Regular Expression Pattern" => "Patró d'expressió regular",
"PCRE-compliant regular expression pattern to find the parts you want changed" => "Patró d'expressió regular PCRE compatible per trobar les peces que desitgi canviat",
"Regular Expression Replacement" => "Substitució d'expressions regulars",
"PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "Sintaxi reemplaçament d'expressions regulars PCRE compatible amb mostrar el que el contingut ha de ser canviat a",
"Enable/disable word wrapping of snippets of code (enabled by default)" => "Activar / desactivar l'ajust de text de fragments de codi (habilitat per omissió)",
// "Syntax highlighting to use for code snippets (Plugin Code is used for this)" => "Syntax highlighting to use for code snippets (Plugin Code is used for this)",
// "Set to Yes (%0) to add line numbers to code snippets (not shown by default)" => "Set to Yes (%0) to add line numbers to code snippets (not shown by default)",
"Parse wiki syntax within the code snippet (not parsed by default)" => "Analitzar la sintaxi wiki en el fragment de codi (no interpretat per omissió)",
"Switch the text display from left to right to right to left" => "Canviar la visualització de text d'esquerra a dreta per dreta a esquerra",
"HTML Content" => "Copiar contingut",
// "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)" => "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)",
"Cache URL" => "Url memòria cau",
// "Cache time in minutes. Default is to use site preference, Set to %0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to %0 for no cache",
"Text to click on to fetch the URL via Ajax" => "Text per fer clic a l'URL per anar a buscar a través d'ajax",
"Sort lines of text" => "Ordenar les línies de text",
"Data to sort, one entry per line" => "Dades de classificar, una entrada per línia",
"Order" => "Ordre",
"Set the sort order of lines of content (default is ascending)" => "Establir l'ordre de classificació de línies de contingut (per omissió és ascendent)",
"Reverse" => "Marxa enrere",
"Shuffle" => "Barreja",
// "Arrange content on a page into rows and columns" => "Arrange content on a page into rows and columns",
// "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Generate the colspan attribute if columns are missing" => "Generar l'atribut colspan si falten columnes",
"Fixed Size" => "Mida fix",
"Generate the width attribute for the columns" => "Generar l'atribut width de les columnes",
// "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)" => "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)",
// "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns",
// "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1" => "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1",
"SQL" => "SQL",
"Query a MySQL database and display the results" => "Consultar una base de dades MySQL i mostrar els resultats",
// "The SQL query goes in the body. Example: " => "The SQL query goes in the body. Example: ",
"DSN Name" => "DSN Nom",
// "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0" => "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0",
"Raw return" => "Retorn Raw",
// "Return with table formatting (default) or raw data with no table formatting" => "Return with table formatting (default) or raw data with no table formatting",
// "Raw" => "Raw",
"Delim" => "Delim",
// "The delimiter to be used between data elements (sets %0)" => "The delimiter to be used between data elements (sets %0)",
// "Turn wiki parsing of select results on and off (default is on)" => "Turn wiki parsing of select results on and off (default is on)",
"Missing db param" => "Falta paràmetre de la bd",
"Could not obtain valid DSN connection" => "No s'ha pogut obtenir la connexió DSN vàlid",
"Stat" => "Estadístiques",
"Show various statistics for an object" => "Mostra diverses estadístiques per a un objecte",
// "Colon-separated list of object type to show stats for" => "Colon-separated list of object type to show stats for",
"Article & Tracker Item" => "Article i formulari-bd de l'article",
"Article & Tracker Item & Wiki" => "Article i formulari-bd de l'article i Wiki",
"Article & Wiki" => "Article i Wiki",
"Article & Wiki & Tracker Item" => "Article i Wiki i formulari-bd de l'article",
"Tracker Item & Article" => "Formulari-bd de l'article i l'article",
"Tracker Item & Article & Wiki" => "Formulari-bd de l'article i l'article i Wiki",
"Tracker Item & Wiki" => "Formulari-bd de l'article i Wiki",
"Tracker Item & Wiki & Article" => "Formulari-bd del producte & Wiki i l'article",
"Wiki & Article" => "I Wiki article",
"Wiki & Article & Tracker Item" => "I Wiki article i formulari-bd de l'article",
"Wiki & Tracker Item" => "I Wiki Formulari-bd article",
"Wiki & Tracker Item & Article" => "I Wiki formulari-bd de l'article i l'article",
"Parent ID" => "ID principal",
"Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Introduïu un ID de seguiment per a restringir les estadístiques al un formulari-bd (per usar amb només trackeritems)",
"Last 24 Hours" => "Darreres 24 hores",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"" => "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"",
"Added" => "Afegit",
"Added and Viewed" => "Alt i Vista",
"Viewed" => "Visualitzat",
"Viewed & Added" => "Vist i Alta",
// "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last 7 Days" => "Últims 7 Dies",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Week" => "Aquesta setmana",
// "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Month" => "El mes passat",
// "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Month" => "Aquest mes",
// "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Year" => "Any Passat",
// "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Year" => "Aquest Any",
// "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Incorrect parameter: " => "Paràmetre incorrecte:",
"Subscript" => "Subíndex",
"Apply subscript font to text" => "Aplicar font subíndex al text",
"Subscribe Group" => "Rep Grup",
"Allow users to subscribe to a group" => "Permetre als usuaris subscriure a un grup",
"text displayed before the button" => "text que es mostra abans que el botó",
"Group name to subscribe to or unsubscribe from" => "Nom del grup de subscriure o anul·lar la subscripció",
"Subscribe Text" => "Text per a la subscripció",
// "Subscribe text, containing %0 as the placeholder for the group name" => "Subscribe text, containing %0 as the placeholder for the group name",
"Subscribe" => "Subscriu",
"Unsubscribe Text" => "Text per a desubscriure's",
// "Unsubscribe text, containing %0 as the placeholder for the group name" => "Unsubscribe text, containing %0 as the placeholder for the group name",
"Unsubscribe" => "De-subscriu-me",
"Subscribe Action" => "Acció de Subscriure's",
// "Subscribe button label, containing %0 as the placeholder for the group name" => "Subscribe button label, containing %0 as the placeholder for the group name",
"Unsubscribe Action" => "Acció de de-subscriure's",
// "Unsubscribe button label, containing %0 as the placeholder for the group name" => "Unsubscribe button label, containing %0 as the placeholder for the group name",
"Post-subscribe URL" => "Post-subscribe URL",
"URL to send the user to after subscribing, if required" => "URL per enviar a l'usuari després de subscriure, si cal",
"Post-unsubscribe URL" => "Post-unsubscribe URL",
"URL to send the user to after unsubscribing, if required" => "URL per enviar a l'usuari després de donar-se de baixa, si cal",
// "Make this the default group text, containing %0 as the placeholder for the group name" => "Make this the default group text, containing %0 as the placeholder for the group name",
"Not Default Group" => "No predeterminat Grup",
// "Stop this being default group text, containing %0 as the placeholder for the group name" => "Stop this being default group text, containing %0 as the placeholder for the group name",
"Default Group Action" => "Grup d'Acció per omissió",
"Default group button label. Will subscribe to the group first if not already a member" => "Etiqueta del botó Grup predeterminat. Subscriurà al grup primer si no està ja un membre",
"Not Default Group Action" => "No predeterminat Grup d'Acció",
"Stop this being default group button label. Does not unsubscribe from the group" => "Pare està sent etiqueta del botó de grup per omissió. No donar-se de baixa del grup",
// "Second Default" => "Second Default",
"Group name to set as default when user stops this group being it" => "Nom del grup per establir per omissió quan l'usuari deixa d'aquest grup és que",
// "Redirect to new home page after default group change. (default is to redirect)" => "Redirect to new home page after default group change. (default is to redirect)",
// "Can Always Leave" => "Can Always Leave",
// "Always allow leaving a group even if the group settings do not allow user choice" => "Always allow leaving a group even if the group settings do not allow user choice",
"Subscribe Groups" => "Subscribe Groups",
"Allow users to subscribe to a list of groups" => "Permetre als usuaris subscriure a una llista de grups",
// "Text shown in the dropdown box. Default: %0Subscribe to a group%1" => "Text shown in the dropdown box. Default: %0Subscribe to a group%1",
"Show Subscribe Box" => "Mostra Rep Caixa",
// "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for",
"Subscribe Box Style" => "Rep Caixa Estil",
// "Style to show the subscribe box" => "Style to show the subscribe box",
"Show Default" => "Mostra defecte",
// "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group" => "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group",
"Group Description" => "Descripció del Grup",
"Show the description of the group (not shown by default)" => "Mostra la descripció del grup (no es mostra per omissió)",
"Colon-separated list of groups. By default the list of groups available to the user" => "Colon llista de grups separats. per omissió, la llista de grups disponibles per a l'usuari",
"Only list groups that include the group being specified here" => "Només els grups de llistes que inclouen el grup que s'especifiquen aquí",
"Default URL" => "URL per omissió",
"Page user will be directed to after clicking on icon to change default group" => "Pàgina usuari serà dirigit a després de fer clic a la icona per canviar el grup per omissió",
"Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name" => "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name",
"Pending Users Group Name" => "Tot esperant Usuaris Nom de grup",
// "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name",
"Group Management Page Name" => "Grup de Gestió de nom de la pàgina",
// "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name" => "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name",
"Hide link for groups including" => "Amaga enllaç per grups, entre ells",
"Hide link to group home page for groups that include the group being specified here" => "Amaga enllaç a la pàgina principal del grup de grups que inclouen el grup que s'especifica aquí",
"Always allow leaving group" => "Sempre deixi grup sortint",
// "Always allow leaving group even if the group settings do not allow user choice" => "Always allow leaving group even if the group settings do not allow user choice",
"You do not have permission to subscribe to groups" => "No té permís per a subscriure a grups",
"Subscribe to newsletter" => "Subscriure al butlletí informatiu",
"Allow users to subscribe to a newsletter" => "Permetre als usuaris subscriure a un butlletí de notícies",
"Invitation message" => "Missatge d'invitació",
"Newsletter ID" => "Butlletí ID",
// "Identification number of the Newsletter that you want to allow the users to subscribe to" => "Identification number of the Newsletter that you want to allow the users to subscribe to",
"Confirmation Message" => "Missatge de confirmació",
"Confirmation message after posting form. The plugin body is then the button label" => "Missatge de confirmació després formulari de publicació. El cos plugin és llavors l'etiqueta del botó",
"Button label. The plugin body is then the confirmation message" => "Etiqueta del botó. El cos plugin és llavors el missatge de confirmació",
// "Choose whether the output should be parsed as wiki syntax" => "Choose whether the output should be parsed as wiki syntax",
// "In Module" => "In Module",
// "Display the newsletter subscription form in module view (if included in a Tiki module)" => "Display the newsletter subscription form in module view (if included in a Tiki module)",
"Already subscribed" => "Ja està subscrit",
"Superscript" => "Sobreescrit",
"Apply superscript font to text" => "Aplicar font superíndex al text",
// "Embed a survey" => "Embed a survey",
// "Id of the survey set up by the administrator" => "Id of the survey set up by the administrator",
"Wiki Page to redirect the user after his vote" => "Wiki Pàgina per redirigir a l'usuari després que el seu vot",
// "Language for the survey" => "Language for the survey",
// "Swiper" => "Swiper",
// "Embed swiper in content, support file galleries, files id and custom content" => "Embed swiper in content, support file galleries, files id and custom content",
// "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> " => "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> ",
// "Enter file gallery id for slider" => "Enter file gallery id for slider",
// "Transition Effect" => "Transition Effect",
// "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"" => "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"",
// "Slider Placement on Page" => "Slider Placement on Page",
// "Placement of slider, above topbar, below topbar, above menus and content or inside content" => "Placement of slider, above topbar, below topbar, above menus and content or inside content",
// "Inside Content" => "Inside Content",
// "Above top bar / Top of page" => "Above top bar / Top of page",
// "Above Content/Under top bar" => "Above Content/Under top bar",
// "Slider pagination, default bullets" => "Slider pagination, default bullets",
// "Fraction" => "Fraction",
// "Progress bar" => "Progress bar",
// "Display navigation arrows" => "Display navigation arrows",
// "Slider Background Color" => "Slider Background Color",
// "Slider background color, enter color code for example #000" => "Slider background color, enter color code for example #000",
// "Slider Parallax Background Image" => "Slider Parallax Background Image",
// "Enter image url for parallax background behind swiper" => "Enter image url for parallax background behind swiper",
// "Enter width of slider in px, default 100%" => "Enter width of slider in px, default 100%",
// "Enter height of slider in px, default min height 100px, max height will adjust with content" => "Enter height of slider in px, default min height 100px, max height will adjust with content",
// "Slide title color" => "Slide title color",
// "Enter text color code of slide title, for example #ccc" => "Enter text color code of slide title, for example #ccc",
// "Title font size" => "Title font size",
// "For example 42px, default 32 px" => "For example 42px, default 32 px",
// "Slide description color" => "Slide description color",
// "Enter text color code of slide description, for example #ccc" => "Enter text color code of slide description, for example #ccc",
// "Description font size" => "Description font size",
// "For example 24px, default 16 px" => "For example 24px, default 16 px",
// "Slide content background" => "Slide content background",
// "Slide content position" => "Slide content position",
// "Enter position for example top:20%;left:20% or bottom:20%;right:10%" => "Enter position for example top:20%;left:20% or bottom:20%;right:10%",
// "Autoplay slider, on by default" => "Autoplay slider, on by default",
// "Auto Play Delay" => "Auto Play Delay",
// "Show thumbnails under main slider" => "Show thumbnails under main slider",
// "Duration of transition between slides (in seconds)" => "Duration of transition between slides (in seconds)",
// "Auto Height" => "Auto Height",
// "Set to true and slider wrapper will adopt its height to the height of the currently active slide" => "Set to true and slider wrapper will adopt its height to the height of the currently active slide",
// "Space Between" => "Space Between",
// "Distance between slides in px" => "Distance between slides in px",
// "Slides Per View" => "Slides Per View",
// "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view" => "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view",
// "Slides Per View Mobile Screen" => "Slides Per View Mobile Screen",
// "Slides visible at the same time on small screens" => "Slides visible at the same time on small screens",
// "Slides Per View Tablet" => "Slides Per View Tablet",
// "Slides visible at the same time on low resolution tablets" => "Slides visible at the same time on low resolution tablets",
// "Slides Per Column" => "Slides Per Column",
// "Number of slides per column, for multirow layout" => "Number of slides per column, for multirow layout",
// "Slides Per Column Fill" => "Slides Per Column Fill",
// "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row" => "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row",
// "Centered Slides" => "Centered Slides",
// "If true, then active slide will be centered, not always on the left side" => "If true, then active slide will be centered, not always on the left side",
// "Slides Offset Before" => "Slides Offset Before",
// "Add (in px) additional slide offset in the beginning of the container (before all slides)" => "Add (in px) additional slide offset in the beginning of the container (before all slides)",
// "Slides Offset After" => "Slides Offset After",
// "Add (in px) additional slide offset in the end of the container (after all slides)" => "Add (in px) additional slide offset in the end of the container (after all slides)",
// "Slide To Clicked Slide" => "Slide To Clicked Slide",
// "Set to true and click on any slide will produce transition to this slide" => "Set to true and click on any slide will produce transition to this slide",
// "Free Mode" => "Free Mode",
// "If true then slides will not have fixed positions" => "If true then slides will not have fixed positions",
// "Preload Images" => "Preload Images",
// "When enabled Swiper will force to load all images" => "When enabled Swiper will force to load all images",
// "Update On Images Ready" => "Update On Images Ready",
// "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true" => "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true",
// "Loop Slider" => "Loop Slider",
// "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))" => "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))",
// " Please update composer to install required files" => " Please update composer to install required files",
// "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body" => "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body",
"Arrange content in tabs" => "Organitzar el contingut en pestanyes",
"Tabs content, separated by \"/////\"" => "Contingut Tabs separats per /////",
"Tabset Name" => "Nom Tabset",
// "Unique tabset name (if you want the last state to be remembered). Example" => "Unique tabset name (if you want the last state to be remembered). Example",
"Tab Titles" => "Títols Tab",
// "Pipe-separated list of tab titles. Example" => "Pipe-separated list of tab titles. Example",
"Toggle Tabs" => "Toggle Tabs",
"Allow toggling between tabs and no-tabs view" => "Permet passar d'una pestanya per no veure les pestanyes",
"Inside Pretty Tracker" => "Dins Pretty Formulari-bd",
"Parse pretty tracker variables within tabs" => "Analitzar les variables del formulari-bd boniques a les pestanyes",
"No tab title specified. At least one must be specified in order for the tabs to appear" => "Sense títol de la pestanya especificada. Almenys un ha d'estar preparat per fer que apareguin les pestanyes",
"Apply an HTML tag to content" => "Aplicar una etiqueta HTML per al contingut",
"Tag Name" => "Nom de marca",
// "Any valid HTML tag, 0% by default" => "Any valid HTML tag, 0% by default",
"Equivalent to the style attribute of an HTML tag" => "Equivalent al atribut d'estil d'una etiqueta HTML",
"Timeline" => "Cronologia",
"Display a timeline" => "Mostrar una línia de temps",
// "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)" => "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)",
// "Width of the timeline as CSS units (default: %0)" => "Width of the timeline as CSS units (default: %0)",
// "Height of the timeline as CSS units (default: %0)" => "Height of the timeline as CSS units (default: %0)",
"Primary Scale Unit" => "Unitat de l'escala principal",
// "Unit of time to use for the primary scale (default is Month)" => "Unit of time to use for the primary scale (default is Month)",
"Decade" => "Dècada",
"Century" => "Segle",
"Secondary Scale Unit" => "Unitat de l'escala secundària",
// "Unit of time to use for the secondary scale" => "Unit of time to use for the secondary scale",
"TimeSheet" => "Full de Temps",
// "Embed a timesheet into a page" => "Embed a timesheet into a page",
"Title Search" => "Cerca de títols",
// "Search page titles" => "Search page titles",
"Search Criteria" => "Criteris de Recerca",
"Portion of a page name" => "Part d'un nom de la pàgina",
"Also show page hits or user" => "Mostra també visites a la pàgina o d'usuari",
// "Hits and user" => "Hits and user",
// "User and hits" => "User and hits",
"Pipe-separated list of page names to exclude from results" => "Llista Pipe-separada dels noms de pàgina a excloure dels resultats",
"No Header" => "Sense capçalera",
// "Set to Yes (%0) to have no header for the search results" => "Set to Yes (%0) to have no header for the search results",
"No pages found for title search" => "No s'ha trobat cap pàgina per la cerca de títols",
"One page found for title search" => "Una pàgina ha estat trobada a la cerca per al títol",
"pages found for title search" => "pàgines trobades pel títol de la cerca",
"Table of Contents (Structure)" => "Índex (Estructura)",
// "Display a table of contents of pages in a structure" => "Display a table of contents of pages in a structure",
"Structure ID" => "ID de l'Estructura",
// "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided" => "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided",
// "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided" => "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided",
"Order items in ascending or descending order (default is ascending)" => "Comanda articles en ordre ascendent o descendent (per omissió és ascendent)",
// "Sort Order" => "Sort Order",
// "Order for the first Level of pages that will be displayed. Order by structure is the default" => "Order for the first Level of pages that will be displayed. Order by structure is the default",
// "Structure Order" => "Structure Order",
// "Alphabetic Order" => "Alphabetic Order",
// "Display the page description in front of the page name" => "Display the page description in front of the page name",
"Show Numbering" => "Mostra Numeració",
"Display the section numbers or not" => "Mostra els números de secció o no",
"Style to apply" => "Estil per aplicar",
"Admin" => "Administrar",
// "Start Level" => "Start Level",
// "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)" => "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)",
// "Maximum Level Depth" => "Maximum Level Depth",
// "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)" => "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)",
// "Together" => "Together",
// "Collaborate in real time" => "Collaborate in real time",
// "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience" => "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience",
// "Button Name" => "Button Name",
// "Set the button name. Default is CoWrite with TogetherJS" => "Set the button name. Default is CoWrite with TogetherJS",
// "CoWrite with TogetherJS" => "CoWrite with TogetherJS",
// "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time" => "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time",
// "Tour" => "Tour",
// "Quick and easy way to build your product tours with Bootstrap popovers" => "Quick and easy way to build your product tours with Bootstrap popovers",
// "Content of the step" => "Content of the step",
// "Element" => "Element",
// "Element to show the popup on; if empty, use the plugin location itself" => "Element to show the popup on; if empty, use the plugin location itself",
// "Title of the step" => "Title of the step",
// "Index of the step to show after this one, starting from 0, -1 for the last one" => "Index of the step to show after this one, starting from 0, -1 for the last one",
// "Index of the step to show before this one, starting from 0, -1 not to show" => "Index of the step to show before this one, starting from 0, -1 not to show",
// "Path to the page on which the step should be shown" => "Path to the page on which the step should be shown",
// "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below" => "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below",
// "Placement" => "Placement",
// "The placement of the popup" => "The placement of the popup",
// "Orphan" => "Orphan",
// "Setting to true removes the pointer on the popup and centers it on the page" => "Setting to true removes the pointer on the popup and centers it on the page",
// "Backdrop" => "Backdrop",
// "Show a dark backdrop behind the popover and its element, highlighting the current step" => "Show a dark backdrop behind the popover and its element, highlighting the current step",
// "Only Show Once" => "Only Show Once",
// "Show automatically only once. tour_id should also be set if there are multiple tours" => "Show automatically only once. tour_id should also be set if there are multiple tours",
// "Show Until Dismissed" => "Show Until Dismissed",
// "Show automatically only until dismissed. tour_id should also be set if there are multiple tours" => "Show automatically only until dismissed. tour_id should also be set if there are multiple tours",
// "Tour ID" => "Tour ID",
// "Set a tour ID to be able to only show the tour once" => "Set a tour ID to be able to only show the tour once",
// "Restart Button" => "Restart Button",
// "Display a button to restart the tour. Enter the text to appear on the button" => "Display a button to restart the tour. Enter the text to appear on the button",
"Translate" => "Tradueix",
"Translate text to the user language" => "Traduir el text a l'idioma de l'usuari",
// "Embed a form to populate a tracker" => "Embed a form to populate a tracker",
"Numeric value representing the tracker ID" => "Valor numèric que representa la identificació de seguiment",
"Fields" => "Camps",
// "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0" => "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0",
// "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters" => "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters",
// "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically" => "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically",
// "Action Style" => "Action Style",
// "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example" => "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example",
// "Display the title of the tracker at the top of the form (not shown by default)" => "Display the title of the tracker at the top of the form (not shown by default)",
"Show the tracker's description (not shown by default)" => "Mostra la descripció del formulari-bd (no es mostra per omissió)",
// "Show Fields Descriptions" => "Show Fields Descriptions",
// "Show the tracker's field descriptions (shown by default)" => "Show the tracker's field descriptions (shown by default)",
"Mark Mandatory" => "Marqueu Obligatori",
"Indicate mandatory fields with an asterisk (shown by default)" => "Indica els camps obligatoris amb un asterisc (es mostren per omissió)",
"Show Status" => "Mostrar l'estat",
"Show the status of the items (not shown by default)" => "Mostra l'estat dels ítems (no es mostra per omissió)",
"Embedded" => "Incrustat",
// "To send an email once the tracker item has been created. Format: %0from" => "To send an email once the tracker item has been created. Format: %0from",
// "template%0" => "template%0",
// "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)" => "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)",
// "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used" => "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used",
// "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)" => "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)",
// "Keep params in URL" => "Keep params in URL",
// "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL" => "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL",
"URL Target" => "URL de destinació",
// "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)" => "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)",
"Self" => "Un mateix",
"Overwrite" => "Reescriure",
// "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)" => "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)",
// "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)" => "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)",
// "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item" => "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item",
"Label for the reset button, to return all fields to their default values" => "Etiqueta per al botó de reset, que retorna tots els camps a la configuració",
"reset" => "reiniciar",
// "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)" => "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)",
// "User&field" => "User&field",
// "User field to filter" => "User field to filter",
// "User field to filter user tracker items to" => "User field to filter user tracker items to",
// "Field to filter" => "Field to filter",
// "Field to filter user tracker items to" => "Field to filter user tracker items to",
// "Field to filter Value" => "Field to filter Value",
// "Value to filter user tracker items to" => "Value to filter user tracker items to",
// "Criteria" => "Criteria",
// "If more than one item found, will choose under this criteria. Used in combination with" => "If more than one item found, will choose under this criteria. Used in combination with",
// "creationDate - Ascending" => "creationDate - Ascending",
// "creationDate - Descending" => "creationDate - Descending",
"Status of the item used in combination with" => "Estat de l'element utilitzat en combinació amb",
"or" => "o",
// "Transaction name" => "Transaction name",
// "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name" => "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name",
// "Transaction Step" => "Transaction Step",
// "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0" => "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0",
// "Final Transaction Step" => "Final Transaction Step",
// "Indicate whether this is the final transaction step" => "Indicate whether this is the final transaction step",
// "Transaction previous URL" => "Transaction previous URL",
// "The page to go back to when the \"previous\" button is clicked" => "The page to go back to when the \"previous\" button is clicked",
// "Transaction previous button label" => "Transaction previous button label",
// "Text for the \"previous\" button label" => "Text for the \"previous\" button label",
"ItemId" => "Itemid",
// "ItemId identifying the item to be edited" => "ItemId identifying the item to be edited",
"Ignore ItemId" => "Ignorar Itemid",
// "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)" => "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)",
"Template File" => "Arxiu de plantilla",
// "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template" => "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template",
// "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template" => "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template",
"New Status" => "Nou Estat",
// "Default status applied to newly created or saved items" => "Default status applied to newly created or saved items",
// "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form",
// "Autosave Fields" => "Autosave Fields",
// "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave" => "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave",
// "Autosave Values" => "Autosave Values",
// "Colon-separated values corresponding to %0. Special syntax cases" => "Colon-separated values corresponding to %0. Special syntax cases",
// "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field" => "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field",
// "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name" => "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name",
// "Increase-only Fields" => "Increase-only Fields",
// "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field" => "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field",
"Registration Fields" => "Camps de Registre",
// "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers" => "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers",
// "Register to group" => "Register to group",
// "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)" => "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)",
// "Validate users" => "Validate users",
// "Here one can overrule the default validate users by e-mail preference" => "Here one can overrule the default validate users by e-mail preference",
"Output To Wiki" => "Sortida a Wiki",
// "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId" => "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId",
"Discard After Output" => "Rebutgi després de sortida",
// "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages" => "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages",
"Template Page" => "Plantilla de Pàgina",
// "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5" => "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5",
// "Output Wiki Namespace" => "Output Wiki Namespace",
// "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page" => "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page",
// "Store Relation" => "Store Relation",
// "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)" => "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)",
"Multiple Fill Fields" => "Diversos camps de farciment",
// "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0" => "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0",
// "Fill Fields Separator" => "Fill Fields Separator",
// "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)" => "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)",
// "Fill Fields Defaults" => "Fill Fields Defaults",
"Colon-separated list of default values for Multiple Fill Fields" => "Llista separada per dos punts dels valors per omissió per a diversos camps de farciment",
"Embed the tracker in a form tag" => "Incrusta el formulari-bd dins d'una etiqueta de formulari",
// "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons" => "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons",
// "Use ajax to create/update tracker items" => "Use ajax to create/update tracker items",
// "Use ajax to create and update tracker items instead of form submission via request variables" => "Use ajax to create and update tracker items instead of form submission via request variables",
// "Transactions" => "Transactions",
// "You need to define both transaction name and transaction step, or none of the two" => "You need to define both transaction name and transaction step, or none of the two",
// "You need to choose transactionFinalStep (y/n)" => "You need to choose transactionFinalStep (y/n)",
// "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button" => "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button",
// "Tracker: Field #%0 not found in fields parameter or template" => "Tracker: Field #%0 not found in fields parameter or template",
"The page to output the results to already exists. Try another name" => "La pàgina a la què enviar la sortida de resultats ja existeix. Proveu amb un altre nom",
// "Tracker Transaction: Field #%0 not found in fields parameter or template" => "Tracker Transaction: Field #%0 not found in fields parameter or template",
"Tracker was modified at " => "El formulari va ser modificat el ",
// "Form saved successfully" => "Form saved successfully",
"Incorrect fieldId:" => "Identificador de camp incorrecte:",
"Following fields are incorrect" => "Els camps següents són incorrectes",
// "Error: Read only field \"%0\"" => "Error: Read only field \"%0\"",
// "This field is mandatory" => "This field is mandatory",
"Missing wiki template page \"%0\"" => "Falta plantilla de pàgina wiki \"%0\"",
"Each line is a list of %d field values separated with: %s" => "Cada línia és una llista de valors del camp d %separats: %s",
"You do not have permission to insert an item" => "No tens permís per insertar ítems",
"Incorrect item" => "Ítem incorrecte",
"You do not have permission to modify an item" => "No tens permisos per modificar un ítem",
"The page to output the results to contains the following prohibited characters: %0. Try another name" => "La pàgina de sortida dels resultats conté els següents caràcters prohibits: %0. Proveu amb un altre nom",
// "Please ensure you are using the correct field ID and that it is properly included in the template, if any" => "Please ensure you are using the correct field ID and that it is properly included in the template, if any",
"Passwords do not match" => "Les contrasenyes no coincideixen",
"Insert one item per line" => "Inseriu un ítem per línia",
"Fields marked with an * are mandatory." => "Els camps marcats amb un asterisc (*) són obligatoris.",
"Tracker Calendar" => "Formulari-bd com a Calendari",
// "Create and display a calendar using tracker data" => "Create and display a calendar using tracker data",
// "Resource Descriptor Field" => "Resource Descriptor Field",
"Permanent name of the field to use as the resource indicator" => "Nom Permanent del camp que s'utilitza com a indicador dels recursos",
// "Coloring Discriminator Field" => "Coloring Discriminator Field",
"Permanent name of the field to use to segment the information into color schemes" => "Nom Permanent del camp a utilitzar per segmentar la informació en esquemes de color",
// "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages" => "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages",
// "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)" => "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)",
// "Add All Fields" => "Add All Fields",
// "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId" => "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId",
// "Use Session Storage" => "Use Session Storage",
// "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript" => "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript",
// "Agenda by Months" => "Agenda by Months",
// "Display the option to change the view to agenda by months" => "Display the option to change the view to agenda by months",
// "Agenda by Weeks" => "Agenda by Weeks",
// "Display the option to change the view to agenda by weeks" => "Display the option to change the view to agenda by weeks",
// "Agenda by Days" => "Agenda by Days",
// "Display the option to change the view to agenda by days" => "Display the option to change the view to agenda by days",
// "List by Years" => "List by Years",
// "Display the option to change the view to list by years" => "Display the option to change the view to list by years",
// "List by Months" => "List by Months",
// "Display the option to change the view to list by months" => "Display the option to change the view to list by months",
// "List by Weeks" => "List by Weeks",
// "Display the option to change the view to list by weeks" => "Display the option to change the view to list by weeks",
// "List by Days" => "List by Days",
// "Display the option to change the view to list by days" => "Display the option to change the view to list by days",
// "Resources by Years" => "Resources by Years",
// "Display the option to change the view to resources by years" => "Display the option to change the view to resources by years",
// "Resources by Months" => "Resources by Months",
// "Display the option to change the view to resources by months" => "Display the option to change the view to resources by months",
// "Resources by Weeks" => "Resources by Weeks",
// "Display the option to change the view to resources by weeks" => "Display the option to change the view to resources by weeks",
// "Resources by Days" => "Resources by Days",
// "Display the option to change the view to resources by days" => "Display the option to change the view to resources by days",
"Default View" => "Visualització per omissió",
// "Choose the default view for the Tracker Calendar" => "Choose the default view for the Tracker Calendar",
// "Default Year" => "Default Year",
// "Choose the default year (yyyy) to use for the display" => "Choose the default year (yyyy) to use for the display",
// "Default Month" => "Default Month",
// "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc" => "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc",
// "Default Day" => "Default Day",
// "Choose the default day (dd) to use for the display" => "Choose the default day (dd) to use for the display",
// "Colormap for coloring" => "Colormap for coloring",
// "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0" => "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0",
// "First day of the Week" => "First day of the Week",
// "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)" => "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)",
// "Show Weekends" => "Show Weekends",
// "Display Saturdays and Sundays (shown by default)" => "Display Saturdays and Sundays (shown by default)",
// "Day Start" => "Day Start",
// "First time slot that will be displayed for each day, e.g. %0" => "First time slot that will be displayed for each day, e.g. %0",
// "Day End" => "Day End",
// "Last time slot that will be displayed for each day, e.g. %0" => "Last time slot that will be displayed for each day, e.g. %0",
// "Slot Duration" => "Slot Duration",
// "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)" => "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)",
// "Overlapping allowed" => "Overlapping allowed",
// "Allow resources to overlap in time" => "Allow resources to overlap in time",
// "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator" => "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator",
"Fields not found" => "Hi ha camps que no es troben",
"Tracker Comments" => "Comentaris de Formularis-bd",
// "Display the number of comments for a tracker" => "Display the number of comments for a tracker",
"Item Count" => "Nombre d'ítems",
"Determines whether the number of items will be shown (not shown by default)" => "Determina si es mostrarà el nombre d'ítems (no es mostra per omissió)",
"Enter a username to select the items of the current user" => "Introduïu un nom d'usuari per seleccionar els ítems de l'usuari actual",
"a user name" => "un nom d'usuari",
"Comments found" => "S'han trobat comentaris",
"Filters" => "Filtres",
// "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1" => "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1",
// "Format choices are" => "Format choices are",
// "dropdown" => "dropdown",
// "radio buttons" => "radio buttons",
// "multiple choice dropdown" => "multiple choice dropdown",
// "checkbox" => "checkbox",
// "text with wild characters" => "text with wild characters",
// "exact text match" => "exact text match",
// "initials" => "initials",
// "advanced search" => "advanced search",
// "range search (from/to)" => "range search (from/to)",
// "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal" => "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal",
// "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)" => "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)",
"Display List" => "Mostra la Llista",
"Show the full list (before filtering) initially (filtered list shown by default)" => "Veure la llista completa (abans del filtrat) inicialment (llista filtrada mostra per omissió)",
"Displays all the filters on the same line (not shown on same line by default)" => "Mostra tots els filtres de la mateixa línia (no es mostra en la mateixa línia per omissió)",
"Yes with field label in dropdown" => "Sí, amb etiqueta de camp en desplegable",
"No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)" => "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)",
"Export CSV" => "Export CSV",
"Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Etiqueta per al botó d'exportació. Deixar en blanc per mostrar el \"filtre\" botó normal \\ lloc",
// "Export Status Field" => "Export Status Field",
// "Export the status field if the Export CSV option is used" => "Export the status field if the Export CSV option is used",
// "Export Created Date Field" => "Export Created Date Field",
// "Export the created date field if the Export CSV option is used" => "Export the created date field if the Export CSV option is used",
// "Export Modified Date Field" => "Export Modified Date Field",
// "Export the modified date field if the Export CSV option is used" => "Export the modified date field if the Export CSV option is used",
// "Export Character Set" => "Export Character Set",
// "Character set to be used if the Export CSV option is used" => "Character set to be used if the Export CSV option is used",
// "Map View Buttons" => "Map View Buttons",
"Display Mapview and Listview buttons" => "Mostra botons Listview i Mapview",
// " - was %0 until 12.0" => " - was %0 until 12.0",
"Tracker Filter" => "Formulari-bd filtre",
"Create a form to filter tracker fields" => "Crear un formulari per filtrar els camps del formulari-bd",
"notice" => "notar",
// "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set" => "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set",
// "TrackerFields: Unknown tracker field used in the parameter \"filters\"" => "TrackerFields: Unknown tracker field used in the parameter \"filters\"",
"tracker field type not processed yet" => "algun tipus emprat de camp de formulari no ha estat processat encara",
"Tracker If" => "Formulari-bd Si",
"Display content based on results of a tracker field test" => "Mostrar contingut basant-se en els resultats d'una prova de camp de traces",
"Ignore" => "Passar per alt",
"Ignore test in edit mode" => "No feu cas de prova en el mode d'edició",
"Copy Tracker Item" => "Còpia l'ítem del formulari-bd",
"PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Copy a tracker item" => "Copy a tracker item",
// "Tracker from which to copy item, joined tracker ids separated by %0:%1" => "Tracker from which to copy item, joined tracker ids separated by %0:%1",
// "Link Field IDs" => "Link Field IDs",
// "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1" => "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1",
// "Copy Field IDs" => "Copy Field IDs",
// "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1" => "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1",
// "Update Field IDs" => "Update Field IDs",
// "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1" => "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1",
"New Values" => "Nous Valors",
// "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId" => "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId",
"ID of item to make copy of, otherwise input is asked for" => "ID de l'ítem per fer la còpia, en cas contrari es demana una entrada",
"Make this number of copies on load" => "Feu aquest número de còpies en la càrrega",
"Set the number of copies to make on load of plugin automatically" => "Ajusteu el nombre de còpies a realitzar en la càrrega de plug-in de forma automàtica",
"Returns array non-interactively" => "Retorna un array de forma no interactiva",
// "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode" => "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode",
"Missing mandatory parameters" => "Falten paràmetres obligatoris",
"Number of update fields do not match new values" => "El nombre de camps d'actualització no coincideix amb els nous valors",
"Tracker Item Field" => "Camp de l`ítem del Formulari-bd",
"Display or test the value of a tracker item field" => "Mostra o prova el valor d'un camp d'ítem de formulari-bd",
// "Wiki text containing an %0{ELSE}%1 marker" => "Wiki text containing an %0{ELSE}%1 marker",
// "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user" => "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user",
"Numeric value representing the field ID displayed or tested" => "Valor numèric que representa l'identificador de camp que es mostra o prova",
"Colon-separated list of field IDs. Default is all fields" => "Llista d'identificadors de camp separades per dos punts. Per omissió s'empren tots els camps",
"Status of the tracker item" => "Estat de l'ítem del formulari-bd",
"Open & Pending" => "Oberts i pendents",
"Open & Closed" => "Oberts i tancats",
"Pending & Closed" => "Pendents i tancat",
"Open, Pending & Closed" => "Oberts, Pendents i Tancats",
// "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter" => "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter",
"Value to compare against" => "Valor per comparar amb",
"You are not allowed to view this item" => "No teniu permís per veure aquest ítem",
"You don't have permission to view this field" => "No teniu permís per veure aquest camp",
// "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1" => "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1",
// "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default" => "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default",
// "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param" => "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param",
"Sticky Popup" => "Emergent enganxós",
// "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)",
"Display the title of the tracker (not shown by default)" => "Mostra el títol del formulari-bd (no es mostra per omissió)",
"Show Links" => "Mostrar Enllaços",
// "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work" => "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work",
"Row" => "Fila",
"Show Item Count" => "Mostra Nombre d'elements",
"Show the number of items found (not shown by default)" => "Mostra el nombre d'elements trobats (no es mostra per omissió)",
"Show Initials" => "Mostra Inicials",
// "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)" => "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)",
// "Creation date display is based on tracker settings unless overridden here" => "Creation date display is based on tracker settings unless overridden here",
"Last Modification Date" => "Darrera modificació",
// "Last modification date display is based on tracker settings unless overridden here" => "Last modification date display is based on tracker settings unless overridden here",
// "Last modified by user display is based on tracker settings unless overridden here" => "Last modified by user display is based on tracker settings unless overridden here",
"Show Field Name" => "Mostra el nom del camp",
"Use the field names as column titles (used by default)" => "Utilitza els noms dels camps com a títols de les columnes (usat per omissió)",
"Show Item Rank" => "Mostra Rang d'items",
"Show item ranks (not shown by default)" => "Mostra els rangs dels ítems (no es mostren per omissió)",
// "Show comments count or last comment date and user depending on tracker preferences" => "Show comments count or last comment date and user depending on tracker preferences",
"Only show items matching certain status filters (only items with open status shown by default)" => "Només mostren els ítems que coincideixin amb certs filtres d'estat (només apareixen per omissió els ítems amb estat obert)",
// "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified" => "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified",
// "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)" => "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)",
"Sort Choice" => "Eleccio d'ordenació",
// "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1" => "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1",
// "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1" => "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1",
"Offset of first item. Default is no offset" => "Desplaçament del primer element. Per omissió no hi ha desplaçament",
"Fix offset always (no pagination)" => "Fixar desplaçament sempre (sense paginació)",
// "Fix offset to that specified. This will disallow pagination" => "Fix offset to that specified. This will disallow pagination",
"Show Pagination" => "Mostrar paginació",
"Determines whether pagination will be shown (shown by default)" => "Determina si es mostrarà la paginació (mostrada per omissió)",
// "Show button to make entire width of tables visible" => "Show button to make entire width of tables visible",
// "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)" => "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)",
"Filter Field" => "Camp del filtre",
"Colon-separated list of fields to allow filtering on" => "Llista separada per dos punts dels camps per als quals permetre el filtratge",
"Filter Value" => "Valor del Filtre",
// "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match" => "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match",
// "text that ends in \"value\"" => "text that ends in \"value\"",
// "text that begins with \"value\"" => "text that begins with \"value\"",
// "the current user's login name" => "the current user's login name",
// "the current user's default group" => "the current user's default group",
// "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead" => "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead",
// "any text" => "any text",
"Exact Value" => "Valor exacte",
// "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by" => "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by",
// "tracker item is in category with ID x or one its descendants" => "tracker item is in category with ID x or one its descendants",
// "tracker item is not in category with ID x or one of its descendants" => "tracker item is not in category with ID x or one of its descendants",
// "match against the value of a Tiki preference" => "match against the value of a Tiki preference",
// "match if value does not equal a Tiki preference value" => "match if value does not equal a Tiki preference value",
// "match if the field does not equal \"value\"" => "match if the field does not equal \"value\"",
// "match for non empty values (opposite with %0exactvalue%1=\"\")" => "match for non empty values (opposite with %0exactvalue%1=\"\")",
// "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)" => "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)",
// "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )" => "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )",
// "match if less than \"value\"" => "match if less than \"value\"",
// "match if greater than \"value\"" => "match if greater than \"value\"",
// "match if less than or equal to \"value\"" => "match if less than or equal to \"value\"",
// "match if greater than or equal to \"value\"" => "match if greater than or equal to \"value\"",
// "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are" => "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are",
// "the value of this field will be posted to the action" => "the value of this field will be posted to the action",
// "the name of the post" => "the name of the post",
// "the title of the submit button" => "the title of the submit button",
// "the name of the submit button" => "the name of the submit button",
// "the file that will be called upon submit" => "the file that will be called upon submit",
// "optional template inserted before the submit button and returned" => "optional template inserted before the submit button and returned",
// "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1" => "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1",
// "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case" => "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case",
// "comma-separated list of pre-checked items" => "comma-separated list of pre-checked items",
// "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1" => "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1",
// "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1" => "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1",
"goIfOne" => "goIfOne",
// "Display the item rather than list if only one item is found" => "Display the item rather than list if only one item is found",
// "Show a 'more' button that links to the tracker item (not shown by default)" => "Show a 'more' button that links to the tracker item (not shown by default)",
"More link pointing to specified URL instead of default tracker item link" => "Més enllaç apuntant a la URL especificada en lloc d'enllaç d'element del registre per omissió",
// "Display only the items of the following" => "Display only the items of the following",
// "the current user" => "the current user",
// "the current page name" => "the current page name",
// "the current IP address" => "the current IP address",
// "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1" => "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1",
// "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins" => "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins",
// "Template Wiki Page" => "Template Wiki Page",
// "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins" => "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins",
"View User" => "Visualitza els de l'usuari/a",
"Will display the items of the specified user" => "Mostrarà els ítems de l'usuari/a especificat/da",
// "Colon-separated list of item IDs to restrict the listing to" => "Colon-separated list of item IDs to restrict the listing to",
"Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignora el paràmetre url Itemid en filtrar la llista (no ignorat per omissió)",
// "The link that will be on each main field when %0showlinks=\"y\"%1. Special values" => "The link that will be on each main field when %0showlinks=\"y\"%1. Special values",
// "will link to the item based on its item ID" => "will link to the item based on its item ID",
// "will link to the item based on its offset value" => "will link to the item based on its offset value",
// "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused" => "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused",
// "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example" => "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example",
// "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties" => "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties",
// "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1" => "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1",
// "Left Delimiter" => "Left Delimiter",
// "Smarty left delimiter for Latex generation. Example" => "Smarty left delimiter for Latex generation. Example",
// "Right Delimiter" => "Right Delimiter",
// "Smarty right delimiter for Latex generation Example" => "Smarty right delimiter for Latex generation Example",
"List Mode" => "Mode de llista",
// "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting",
"Comma Separated Values" => "Valors separats per comes",
"Export Button" => "Botó Exportar",
"Show an export button (not shown by default)" => "Mostrar un botó d'exportació (no es mostra per omissió)",
"Compute" => "Calcular",
// "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable" => "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable",
"fieldId" => "fieldId",
// "%0, separated by %1" => "%0, separated by %1",
"Silent" => "Silenciós",
// "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)",
"Show Delete" => "Mostra Eliminar",
// "Show a delete icon for each item (not shown by default)" => "Show a delete icon for each item (not shown by default)",
"Url to redirect to after delete" => "Url a on redirigir després d'eliminar",
"Show Open Item" => "Mostrar Obre Ítem",
"Show an open item  option (not shown by default)" => "Mostrar una opció per a obrir l'ítem (no es mostra per omissió)",
"Show Close Item" => "Mostra Tanca Item",
"Show a close item option (not shown by default)" => "Mostrar una opció per a tancar l'ítem (no es mostra per omissió)",
"Show Pending Item" => "Mostra Canvia Ítem a Pendent",
"Show a pending item option (not shown by default)" => "Mostrar una opció per a convertir en ítem pendent (no es mostra per omissió)",
"Show Watch Button" => "Mostra botó Veure",
"Show a watch button (not shown by default)" => "Mostra un botó de seguiment per correu-e (no es mostra per omissió)",
"Show Feed Button" => "Mostra Botó de l'Alimentació",
"Show an RSS feed button (not shown by default)" => "Mostrar un botó de RSS (no es mostra per omissió)",
// "Show Results Map" => "Show Results Map",
// "Show Map of results (not shown by default)" => "Show Map of results (not shown by default)",
"Calendar Field IDs" => "Calendari camp ID",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1",
"Calendar View Mode" => "Mode de visualització de Calendari",
"Calendar view type time span (default is month)" => "Tipus de lapse de temps a la Vista de Calendari (per omissió és el mes)",
"Two months" => "Bimestre",
"Trimester" => "Trimestre",
"Calendar Popup" => "Calendari emergent",
// "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)" => "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)",
// "Calendar item popups will stay open if set to y (Yes). Not sticky by default" => "Calendar item popups will stay open if set to y (Yes). Not sticky by default",
"Beginning of Month" => "A partir del mes",
"Set whether calendar will begin at the beginning of the month (does by default)" => "Definiu si el calendari s'iniciarà a principis del mes (ho fa per omissió)",
"Show calendar navigation bar (shown by default)" => "Mostra la barra de navegació de calendari (que es mostra per omissió)",
"Partial" => "Parcial",
"Calendar Title" => "Títol del Calendari",
"Enter a title to display a calendar title (not set by default)" => "Escriu un títol per mostrar un títol del calendari (no posat per omissió)",
"Calendar Delta" => "Calendari Delta",
"Set the calendar delta that will be shown (not set by default)" => "Ajustar el delta (decalatge) de calendari que es mostra (no s'estableix per omissió)",
"Plus Month" => "Mes més",
"Minus Month" => "Mes menys",
"Plus Two months" => "Més Bimestre",
"Minus Two months" => "Menys Bimestre",
"Display Spreadsheet" => "Mostra de full de càlcul",
"Display tracker as a spreadsheet (not used by default)" => "Mostra formulari-bd com un full de càlcul (no s'utilitza per omissió)",
"Force Compile" => "Forçar Compilació",
// "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)" => "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)",
"Period type" => "Tipus de Període",
"Time period after creation or after modification" => "El període de temps després de la creació o després de la modificació",
"Creation" => "Creació",
"Modification" => "Modificació",
"Inline edit" => "Edició en línia",
// "Colon-separated list of fields for which inline editing will be enabled" => "Colon-separated list of fields for which inline editing will be enabled",
"Inline edit All" => "Edició en línia de Tot",
"Allow all displayed fields to be editable" => "Permetre que tots els camps que es mostren siguin editables",
// "Compile Each Item" => "Compile Each Item",
// "Compile each item separately instead of compiling the entire template" => "Compile each item separately instead of compiling the entire template",
"Tracker List" => "Llista de Formulari-bd",
"List, filter and sort the items in a tracker" => "Llista, filtra i ordena els elements d'un tracker",
// "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y" => "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y",
// "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly" => "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly",
// "For best results the date filter should only be applied to date field types" => "For best results the date filter should only be applied to date field types",
// "To filter the category field type, the exact category name or id needs to be entered" => "To filter the category field type, the exact category name or id needs to be entered",
"incorrect filterfield" => "camp de filtrat (filterfield) incorrecte",
"You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field" => "Ha intentat visualitzar les dades d'un camp de formulari-bd que no és públic. Has de demanar a l'administrador de canviar a 'públic' la configuració per a aquest camp",
"Error in tracker ID" => "Error a l'ID del formulari",
"No field indicated" => "No s'ha indicat cap camp",
"Check Tracker Passcodes" => "Comprovi les claus d'accés del formulari-bd",
"PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Verify a tracker passcode" => "Verify a tracker passcode",
// "Session Key Names" => "Session Key Names",
"Tracker Prefill" => "Preompliment de Formulari-bd (Tracker)",
"Create a button to prefill tracker fields" => "Crear un botó per a preomplir camps de formulari-bd",
// "Tracker page name" => "Tracker page name",
"URL Parameters" => "Paràmetres d'URL",
// "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1" => "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1",
"Field 1" => "Camp 1",
"Field ID for the first field" => "Identificador de camp per al primer camp",
"Value 1" => "Valor 1",
"Content that should be used to prefill the field" => "El contingut que s'ha d'utilitzar per a l'ompliment previ del camp",
"Field 2" => "Camp 2",
"Field ID for the second field" => "Identificador de camp per al segon camp",
"Value 2" => "Valor 2",
"Field 3" => "Camp 3",
"Field ID for the third field" => "Identificació de camp per al tercer camp",
"Value 3" => "Valor 3",
"Field 4" => "Camp 4",
"Field ID for the fourth field" => "Identificació de camp per al quart camp",
"Value 4" => "Valor abril",
"Field 5" => "Camp 5",
"Field ID for the fifth field" => "Identificació de camp per al cinquè camp",
"Value 5" => "Valor 5",
"Field 6" => "Camp 6",
"Field ID for the sixth field" => "Identificació de camp per al sisè camp",
"Value 6" => "Valor 6",
"Field 7" => "Camp 7",
"Field ID for the seventh field" => "Identificació de camp pel setè camp",
"Value 7" => "Valor juliol",
"Field 8" => "Camp 8",
"Field ID for the eighth field" => "Identificació de camp per al vuitè camp",
"Value 8" => "Valor agost",
"Tracker Query Template" => "Plantilla de consulta Formulari-bd",
// "Generate a form from tracker data" => "Generate a form from tracker data",
"Wiki Syntax, with variables from tracker query" => "Sintaxi Wiki, amb variables d'interacció amb el gestor",
// "The name of the tracker to be queried, or if %0, the tracker ID" => "The name of the tracker to be queried, or if %0, the tracker ID",
// "Turn tracker query debug on (off by default)" => "Turn tracker query debug on (off by default)",
// "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs" => "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs",
"Render" => "Fer",
// "Render as needed for trackers (default)" => "Render as needed for trackers (default)",
"Item id of tracker item" => "Identificador de l'ítem del formulari-bd",
"Tracker Item Ids" => "Ids dels Items del Formulari-bd",
"Item id of tracker items, separated with comma" => "Identificadors dels ítems del formulari-bd, separats amb comes",
"Like Filters" => "Igual que els filtres",
// "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
"And Filters" => "I Filtres",
// "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
"Or Filters" => "O filtres",
// "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
"Get Last" => "Obtè el/la darrer/a",
// "Retrieve only the last item from the tracker" => "Retrieve only the last item from the tracker",
"Tracker Stats" => "Estadístiques del Formulari-bd",
"Display statistics about a tracker" => "Mostra estadístiques sobre un tracker",
// "Colon-separated list of field IDs to be displayed. Example" => "Colon-separated list of field IDs to be displayed. Example",
// ". " => ". ",
// "Leave it empty to display all fields from this tracker" => "Leave it empty to display all fields from this tracker",
"Show Count" => "Mostra el recompte",
"Choose whether to show the count of votes each option received (shown by default)" => "Seleccioneu si voleu mostrar el nombre de vots que cada opció va rebre (que es mostra per omissió)",
// "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)" => "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)",
// "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)" => "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)",
"Only show items matching certain status filters" => "Mostra només els elements que coincideixen amb certs filtres d'estat",
// "Add a link to the tracker" => "Add a link to the tracker",
// "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example" => "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example",
"invalid status" => "estat no vàlid",
"incorrect fieldId" => "Identificador de camp incorrecte",
"Tracker Timeline" => "Línia de temps del Formulari-bd",
"Show a timeline view of a tracker" => "Mostrar una vista cronològica d'un formulari-bd",
"Title Field" => "Camp del Títol",
"Tracker Field ID containing the item title" => "Identificador del camp del Formulari-bd que conté el títol de l'ítem",
"Summary Field" => "Camp de Resum",
// "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
"Element Group" => "Grup d'elements",
// "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row",
"Lower Bound" => "Baixa Bound",
// "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Upper Bound" => "Límit superior",
// "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unitat de temps que s'utilitzarà per a l'escala principal (per omissió d'hores - * només simile)",
"Decade *" => "Dècada *",
"Century *" => "Century *",
"Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unitat de temps que s'utilitzarà per a l'escala secundària (per omissió buit - només * simile)",
"Timeline height" => "Alçada Cronologia",
// "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)",
"Lower band height" => "Alçada de la banda inferior",
// "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)",
"Link Group Name" => "Enllaç Nom del grup",
"Convert the group name to a link" => "Convertir el nom del grup a un enllaç",
"Page Link Field" => "Enllaç de Pàgina Camp",
"Tracker Field ID containing the page name for item details" => "Formulari-bd identificador de camp que conté el nom de la pàgina de detalls del article",
"SIMILE Timeline" => "Simile Cronologia",
"Use the SIMILE Timeline Widget" => "Fer servir el Timeline Widget simile",
"Image Field" => "Camp d'Imatge",
"Tracker Field ID containing in image" => "Formulari-bd identificador de camp que conté a la imatge",
"Missing parameter: %0" => "Falta paràmetre: %0",
"Start date after end date" => "Data d'inici després de la data de finalització",
"Tracker Toggle" => "Formulari-bd Toggle",
"Numeric value representing the field ID tested" => "Valor numèric que representa l'identificador de proves de camp",
// "Element Visibility" => "Element Visibility",
// "Set whether visible when the field has the value" => "Set whether visible when the field has the value",
"HTML id of the element that is toggled" => "Html ID de l'element que es commuta",
// "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set" => "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set",
"trackertoggle: Param fieldId is required" => "trackertoggle: Es requereix fieldId Param",
"trackertoggle: Param fieldId field %0 does not exsist" => "trackertoggle: Param fieldId camp %0 no exsist",
"trackertoggle: Param value is required" => "trackertoggle: Es necessita valor Param",
"trackertoggle: Param id is required" => "trackertoggle: Es requereix Identificació Param",
// "Adjust the visibility of content based on a tracker field's value, possibly dynamically" => "Adjust the visibility of content based on a tracker field's value, possibly dynamically",
"Trade" => "Comerç",
// "Send payments between members using cclite" => "Send payments between members using cclite",
"Currency depends on the selected registry" => "Moneda depèn del registre seleccionat",
"Registry to trade in. Default: site preference (or first in list when more than one)" => "Registre per al comerç in defecte: preferència de lloc (o primer a la llista quan més d'un)",
"Currency to trade in. Default: Cclite currency preference for registry set above" => "Moneda per al comerç in defecte: la preferència per la moneda Cclite conjunt anterior de Registre",
// "Name of the user to receive or send the payment" => "Name of the user to receive or send the payment",
"Leave empty to display an input box" => "Deixar en blanc perquè aparegui un quadre d'entrada",
"Offered or wanted item" => "Article ofert o volia",
// "%0Offered%1" => "%0Offered%1",
"Offered" => "Ofert",
"Wanted" => "Desitjat",
// "%0Continue%1" => "%0Continue%1",
"Title of the input form" => "Títol del formulari d'entrada",
// "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted",
"Please log in" => "Si us plau, Connecta't",
" needs to validate their account" => " necessita validar el seu compte",
"Transclude" => "Transclusió",
"PluginTransclude" => "PluginTransclude",
"Include the content of another page with certain changes" => "Incloure el contingut d'una altra pàgina amb certs canvis",
"Name of the wiki page to use as a template for the values" => "Nom de la pàgina wiki per utilitzar com a plantilla per als valors",
"Attempt to include a page that cannot be viewed" => "Proveu incloure una pàgina que no es pot veure",
"Page named \"%0\" does not exist at this time" => "Pàgina nom \"%0\" no existeix en aquest moment",
"Translated" => "Traduït",
// "Create multilingual links" => "Create multilingual links",
"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[Url] o ((nom wiki)) o ((inter:interwiki)) (sintaxi wiki ús)",
// "Two letter language code of the language, example" => "Two letter language code of the language, example",
"Flag" => "Bandera",
// "Country name, example" => "Country name, example",
// "Translate a link from one language to another" => "Translate a link from one language to another",
// "TranslationOf" => "TranslationOf",
// "Original Page" => "Original Page",
// "Name of the page from which this link will be translated" => "Name of the page from which this link will be translated",
// "Translation Language" => "Translation Language",
// "Two letter language code of the language in which you want to translate this\n                    link. Example" => "Two letter language code of the language in which you want to translate this\n                    link. Example",
// "Translation Name" => "Translation Name",
// "Name of the page that will become the translation of the \"Original Page\"" => "Name of the page that will become the translation of the \"Original Page\"",
// "Translate this link" => "Translate this link",
"Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Twitter Path" => "Twitter Path",
// "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. " => "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. ",
// "Widget Id" => "Widget Id",
// "Numeric identifier of the widget" => "Numeric identifier of the widget",
// "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1" => "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1",
// "light" => "light",
// "dark" => "dark",
// "Link Color" => "Link Color",
// "Text color for individual tweets. Default is theme default" => "Text color for individual tweets. Default is theme default",
"Valid HTML color codes (with beginning #) or names" => "Els codis vàlids de color HTML (començant amb #) o noms",
// "Border Color" => "Border Color",
// "Change the border color used by the widget. Default is theme default" => "Change the border color used by the widget. Default is theme default",
// "Height of widget in pixels. Default is %0" => "Height of widget in pixels. Default is %0",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is %0" => "Width of widget in pixels or 'auto' to fit to width of page. Default is %0",
"Number of pixels or the word 'auto'" => "Nombre de píxels o la paraula 'auto'",
// "Default is with Header" => "Default is with Header",
// "No Footer" => "No Footer",
// "Default is with Footer" => "Default is with Footer",
// "Footer" => "Footer",
// "Layout Option: No Borders" => "Layout Option: No Borders",
// "Default is with Borders" => "Default is with Borders",
"Borders" => "Marges",
// "No Borders" => "No Borders",
// "No Scrollbar" => "No Scrollbar",
// "Default is with Scrollbar" => "Default is with Scrollbar",
// "Scrollbar" => "Scrollbar",
// "Transparent Background" => "Transparent Background",
// "Transparent Shell Background. Default is theme default" => "Transparent Shell Background. Default is theme default",
// "Theme default" => "Theme default",
"User Count" => "Quantitat d'usuaris",
// "Display number of users for a site or one or more groups" => "Display number of users for a site or one or more groups",
// "Group name. If left blank, the total number of users for the site will be shown" => "Group name. If left blank, the total number of users for the site will be shown",
// "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings" => "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings",
// "UserInGroup" => "UserInGroup",
// "checks if an individual user is in a particular Group and simply return a string set to either true or false" => "checks if an individual user is in a particular Group and simply return a string set to either true or false",
// "userId" => "userId",
// "the userId to be checked" => "the userId to be checked",
// "test group" => "test group",
// "the Group that the userId check is made against" => "the Group that the userId check is made against",
// "text for true result" => "text for true result",
// "The text that is displayed if the test result is true" => "The text that is displayed if the test result is true",
// "text for false result" => "text for false result",
// "The text that is displayed if the test result is false" => "The text that is displayed if the test result is false",
// "Last Login information" => "Last Login information",
// "PluginUserLastLogged" => "PluginUserLastLogged",
// "Show the last login information for a given or current user" => "Show the last login information for a given or current user",
// "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank" => "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank",
// "DateFormat" => "DateFormat",
// "Date format setting. Short_datetime used by default" => "Date format setting. Short_datetime used by default",
"User Link" => "Usuari Link",
"Display a link to a user's information page" => "Mostrar un enllaç a la pàgina d'informació d'un usuari",
"User account name (which can be an email address)" => "Nom de compte d'usuari (que pot ser una adreça de correu electrònic)",
"User List" => "Llistat d'usuaris",
"Display a list of registered users" => "Mostra una llista d'usuaris registrats",
"Login Filter" => "Ingressa Filter",
"Separator to use between users in the list. Default: comma" => "Separador d'usar entre els usuaris en la llista. Per defecte: comes",
// "Set to sort in ascending or descending order" => "Set to sort in ascending or descending order",
// "Set to table to display results in a table" => "Set to table to display results in a table",
// "Make the user names listed links to different types of user information" => "Make the user names listed links to different types of user information",
"User info" => "Informació de l'usuari",
"User page" => "Pàgina d'usuari",
"User pref" => "Usuari pref",
"Real Name" => "Nom real",
"Display the user's real name (when available) instead of login name" => "Mostra el nom real de l'usuari (si està disponible) en lloc del nom d'inici de sessió",
"Filter on a group" => "Filtre en un grup",
"Display contents based on user preference settings" => "Mostra el contingut en base a les preferències de l'usuari",
"Create tabs for showing alternate versions of content" => "Crear pestanyes per mostrar versions alternatives de contingut",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault",
// "Display a navigation box that allows users to select a specific version to display" => "Display a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default" => "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default",
"Default Label" => "Etiqueta per omissió",
// "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'" => "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'",
// "Embed a Vimeo video" => "Embed a Vimeo video",
// "Complete URL to the Vimeo video. Example" => "Complete URL to the Vimeo video. Example",
// "or leave blank to upload one" => "or leave blank to upload one",
"Quality of the video" => "Qualitat del vídeo",
"Expand to full screen" => "Expandir a pantalla completa",
// "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)" => "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)",
// "Numeric ID of a Tracker Files field, using Vimeo displayMode" => "Numeric ID of a Tracker Files field, using Vimeo displayMode",
// "Numeric ID of a Tracker item, using Vimeo displayMode" => "Numeric ID of a Tracker item, using Vimeo displayMode",
// "Gallery ID to upload to" => "Gallery ID to upload to",
// "Froogaloop API" => "Froogaloop API",
// "Use Vimeo Froogaloop API" => "Use Vimeo Froogaloop API",
// "Show the Video Title" => "Show the Video Title",
// "(default is to show)" => "(default is to show)",
// "Show Byline" => "Show Byline",
// "Show Portrait" => "Show Portrait",
// "Vimeo video not found for file #%0" => "Vimeo video not found for file #%0",
// "Feature required" => "Feature required",
// "Feature \"vimeo_upload\" is required to be able to add videos here" => "Feature \"vimeo_upload\" is required to be able to add videos here",
// "You do not have permsission to add files here" => "You do not have permsission to add files here",
// "You do not have permsission modify this tracker item" => "You do not have permsission modify this tracker item",
// "You do not have permsission modify this page" => "You do not have permsission modify this page",
// "Show the creator's byline" => "Show the creator's byline",
// "Show the creator's profile picture" => "Show the creator's profile picture",
"Vote" => "Votar",
"Create a tracker for voting" => "Crear un un formulari-bd per a la votació",
// "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example" => "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example",
// "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)" => "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)",
// "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)" => "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)",
"Show Stats" => "Mostrar Estadístiques",
"Choose whether to show the voting results (shown by default)" => "Seleccioneu si voleu mostrar els resultats de la votació (que es mostra per omissió)",
"Show Stats After" => "Mostrar Estadístiques Després",
// "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)",
"Show Toggle" => "Mostra Toggle",
"Show toggle or not to display the form and the results" => "Mostra alternar o no mostrar la forma i els resultats",
"Votings" => "Les votacions",
"Saves voting information in Smarty variables for display" => "Guarda informació sobre la votació en les variables de Smarty per a la seva visualització",
"Object Key" => "Objecte Clau",
"Object key that is used to record votes" => "Clau d'objecte que s'utilitza per registrar els vots",
"Return value" => "Valor de retorn",
"Value to display as output of plugin" => "Valor per mostrar com sortida del plug-in",
"Wanted Pages" => "Pàgines Comandes",
"Show location of links to pages not yet created" => "Mostrar la ubicació d'enllaços a les pàgines creades encara no",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)",
"a valid regex-expression (PCRE)" => "una expressió regular expressió vàlida (PCRE)",
"Split By" => "Divideix Per",
"The character by which ignored patterns are separated" => "El personatge pel qual se separen els patrons ignorats",
// "Skip Alias" => "Skip Alias",
// "Whether to skip wanted pages that have a defined alias (not skipped by default)" => "Whether to skip wanted pages that have a defined alias (not skipped by default)",
"Skip Extension" => "Saltar Extensió",
"Whether to include external wikis in the list (not included by default)" => "Si cal incloure wikis externa a la llista (no inclòs per omissió)",
"Collect" => "Recollir",
// "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column",
"From" => "Des de",
"Switch on debug output with details about the items (debug not on by default)" => "Enceneu el resultat de la depuració amb detalls sobre els elements (debug no per omissió)",
"Memory Saver" => "Estalviador de la memòria",
// "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell",
"Line break" => "Salt de línia",
"Separate Row" => "Fila separada",
"Level" => "Nivell",
// "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex",
"Full" => "Complet",
"non-valid custom regex" => "no vàlida personalitzada regex",
", " => ", ",
"ignored" => "ignorat",
"External Wiki" => "Wiki Extern",
"dash-WikiWord" => "guio-ParaulaWiki",
"WikiWord" => "ParaulaWiki",
"not in level" => "no al nivell",
"valid" => "vàlid",
"End of debug output." => "Final de la sortida de depuració.",
"Wanted Page" => "Pàgina buscada",
"Referenced By Page" => "Referenciat per la pàgina",
// "Web Document Viewer" => "Web Document Viewer",
// "View a document in a page" => "View a document in a page",
// "File Id" => "File Id",
// "The FileId of a file in a File Gallery of the file you wish to embed in the viewer" => "The FileId of a file in a File Gallery of the file you wish to embed in the viewer",
// "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter" => "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter",
// "No FileId or URL has been set" => "No FileId or URL has been set",
"Web Service" => "Servei Web",
// "Display remote information exposed in JSON or YAML or SOAP XML" => "Display remote information exposed in JSON or YAML or SOAP XML",
// "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter",
"Complete service URL" => "URL de servei complet",
"Registered service name" => "Nom de servei registrada",
// "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided",
"Body as Parameter" => "Cos com a paràmetre",
// "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful" => "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful",
// "Parameters formatted like a query" => "Parameters formatted like a query",
"Unknown Template" => "Desconegut Plantilla",
"Unknown Service" => "Desconegut Servei",
// "Wiki Diff" => "Wiki Diff",
// "Display the differences between two wiki objects" => "Display the differences between two wiki objects",
// "Object Id" => "Object Id",
// "Object to do a diff on (page name for wiki pages)" => "Object to do a diff on (page name for wiki pages)",
// "Object type (wiki pages only)" => "Object type (wiki pages only)",
// "Old version" => "Old version",
// "Integer for old version number, or date" => "Integer for old version number, or date",
// "New version" => "New version",
// "Leave empty for current version" => "Leave empty for current version",
// "Diff Style" => "Diff Style",
// "Defaults to \"diff style\" preference if empty" => "Defaults to \"diff style\" preference if empty",
// "Show version info" => "Show version info",
// "Show the heading \"Comparing version X with version Y\"" => "Show the heading \"Comparing version X with version Y\"",
// "Use a WYSIWYG editor to edit a section of content" => "Use a WYSIWYG editor to edit a section of content",
// "Minimum width for DIV. Default" => "Minimum width for DIV. Default",
// "Minimum height for DIV. Default" => "Minimum height for DIV. Default",
"Use HTML" => "Utilitza HTML",
// "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed" => "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed",
// "XMLupdate" => "XMLupdate",
// "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory" => "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory",
// "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file " => "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file ",
// "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory" => "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory",
// "XML node attribute name" => "XML node attribute name",
// "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space" => "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space",
// "XML node listed in output" => "XML node listed in output",
// "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set" => "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set",
// "Xmpp" => "Xmpp",
// "Chat using Xmpp" => "Chat using Xmpp",
// "Room Name" => "Room Name",
// "Room to auto-join" => "Room to auto-join",
// "View Mode" => "View Mode",
// "Fullscreen" => "Fullscreen",
// "Overlayed" => "Overlayed",
// "Chat room width in CSS units" => "Chat room width in CSS units",
// "Chat room height in CSS units" => "Chat room height in CSS units",
"Visibility" => "Visibilitat",
// "This room is visible to anyone or only for members" => "This room is visible to anyone or only for members",
// "Members only" => "Members only",
// "Show Real JIDs of Occupants to" => "Show Real JIDs of Occupants to",
// "If just moderator or anyone else can fetch information about an occupant" => "If just moderator or anyone else can fetch information about an occupant",
// "If just \"moderator\", anonymous user will not be able to change their nicknames" => "If just \"moderator\", anonymous user will not be able to change their nicknames",
// "Anyone" => "Anyone",
// "Moderator" => "Moderator",
// "Show controlbox on load" => "Show controlbox on load",
// "If controlbox should be shown after page load" => "If controlbox should be shown after page load",
// "This preference only works when view mode is overlayed" => "This preference only works when view mode is overlayed",
// "Show occupants" => "Show occupants",
// "If occupants window should be visible by default" => "If occupants window should be visible by default",
// "This preference only works when view mode is embedded" => "This preference only works when view mode is embedded",
// "Groups (comma-separated)" => "Groups (comma-separated)",
// "Allowed groups to use this resource" => "Allowed groups to use this resource",
// "Is secret" => "Is secret",
// "If the room will be listed on public chat room list" => "If the room will be listed on public chat room list",
// "Archiving" => "Archiving",
// "If room messages will be stored" => "If room messages will be stored",
// "Persistent" => "Persistent",
// "If room will continue to exist after last user leaves" => "If room will continue to exist after last user leaves",
// "If room is moderated" => "If room is moderated",
// "PluginXMPP Error: No room specified" => "PluginXMPP Error: No room specified",
// "Add a group to room" => "Add a group to room",
// "Add users to room" => "Add users to room",
"YouTube" => "YouTube",
// "Embed a YouTube video in a page" => "Embed a YouTube video in a page",
"Movie" => "Pel·lícula",
// "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)" => "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)",
// "Privacy-Enhanced" => "Privacy-Enhanced",
// "Enable privacy-enhanced mode" => "Enable privacy-enhanced mode",
// "Start time" => "Start time",
// "Start time offset in seconds" => "Start time offset in seconds",
// "Quality of the video. Default is %0high%1" => "Quality of the video. Default is %0high%1",
"Enlarge video to full screen size" => "Engrandir vídeo a mida de pantalla completa",
"Related" => "Relacionat",
"Show related videos (shown by default)" => "Mostra vídeos relacionats (que es mostra per omissió)",
"Background" => "Fons",
// "Toolbar background color. Use an HTML color code" => "Toolbar background color. Use an HTML color code",
"HTML color code, e.g. ffffff" => "Codi de color HTML, per exemple, ffffff",
// "Toolbar border colors. Use an HTML color code" => "Toolbar border colors. Use an HTML color code",
"Plugin YouTube error: the movie parameter is empty" => "Error en el connector (plugin) YouTube: el paràmetre de pel·lícula és buit",
"Invalid YouTube URL provided" => "S'ha indicat una adreça d'internet invàlida",
"Zotero Citation" => "Cita de Zotero",
"Retrieves and includes a Zotero reference in the page" => "Recupera i inclou una referència Zotero a la pàgina",
"Reference Key" => "Clau de Referència",
// "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module",
"Reference Tag" => "Referència Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references" => "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references",
"Zotero Reference List" => "Llista de referència Zotero",
// "Display the complete reference list from a Zotero server" => "Display the complete reference list from a Zotero server",
"Provide the list of references with a given tag" => "Proporcionar la llista de referències amb una etiqueta determinada",
"No results obtained. The Zotero citation server may be down" => "Resultats obtinguts. El servidor citació Zotero pot estar a baix",
"Set up some advanced options" => "Posa a punt algunes opcions avançades",
"Set up Auto TOC" => "Posa a punt l'Auto TOC",
"Define Categories" => "Defineix Categories",
"Set up User & Community features" => "Posa a punt coses d'Usuaris i Comunitat",
"Set up Date and Time" => "Posa a punt el Dia i la Hora",
"Select Editor type" => "Selecciona Tipus d'Editor",
"Set up Main features" => "Posa a punt les funcionalitats principals",
"Set up File Gallery & Attachments" => "Posa a punt les Galeries d'Arxius i els Adjunts",
"Set up File storage" => "Posa a punt l'emmagatzematge d'Arxius",
"Set up Language" => "Posa a punt l'Idioma",
"Set up Login" => "Posa a punt la connexió",
"Set up Look & Feel" => "Posa a punt l'Aparença",
"Set up Namespace" => "Posa a punt l'Espai de noms",
"Set up Search" => "Posa a punt la Cerca",
"Set up Structures" => "Posa a punt les Estructures",
"Set up Text Area" => "Posa a punt l'Àrea de Text",
"Set up Wiki environment" => "Posa a punt l'entorn del Wiki",
"Tiki Setup" => "Posa a punt Tiki",
// "Configuration Wizard Completed" => "Configuration Wizard Completed",
"Set up Wysiwyg editor" => "Posa a punt l'editor Wysiwyg",
"Related doc.tiki.org pages" => "Pàgines de doc.tiki.org relacionades",
"New in Tiki 13" => "Nou a Tiki 13",
"New in Tiki 14" => "Nou a Tiki 14",
"New in Tiki 15 (LTS)" => "Nou a Tiki 15 (LTS)",
"New in Tiki 16" => "Nou a Tiki 16",
"New in Tiki 17" => "Nou a Tiki 17",
"New in Tiki 18 (LTS)" => "Nou a Tiki 18 (LTS)",
// "New in Tiki 19" => "New in Tiki 19",
// "New in Tiki 20" => "New in Tiki 20",
"Novice Admin Assistance" => "Assistència a Administradors Novells",
"Other features and settings" => "Altres funcionalitats i opcions",
"Permissions & Logs" => "Permissos & Registres (Logs)",
"Send feedback & Connect" => "Envia retroalimentació & Connecta",
"User Interface" => "Interfície d'Usuari",
"Changes Wizard Completed" => "Assistent d'Actualització Completat",
"Configuration Profiles Wizard Completed" => "Assistent de Perfils de Configuració Finalitzat",
// "Demo of Cases in Project Management" => "Demo of Cases in Project Management",
"Demo of Commonly Used Configurations" => "Demo de Configuracions Habituals",
"Demo of Highly Specialized Configurations" => "Demo de Configuracions Molt Especialitzades",
"Demo of Interesting Use Cases" => "Demo d'Interesants Casos d'Ús",
"Demo of More Advanced Configurations" => "Demo de Configuracions Més Avançades",
// "Demo of Other Interesting Use Cases" => "Demo of Other Interesting Use Cases",
"Featured Site Configurations" => "Configuracions Destacades de Lloc Web",
"Useful Administration Configurations" => "Configuracions d'Administració Útils",
"Useful Changes in Display Mode" => "Canvis Útils en el Mode de Presentació",
"Useful Micro Configurations" => "Micro-Configuracions Útils",
"Useful New Technology Configurations" => "Configuracions Útils de Noves Tecnologies",
"Personal Information" => "Informació Personal",
"User Watches" => "Avisos d'usuari/a",
"Notification Preferences" => "Preferències de notificació",
"unicode" => "unicode",
"Report Preferences" => "Preferències dels informes",
"User Details" => "Detalls d'Usuari",
"You cannot access this page directly" => "No pots accedir a aquesta pàgina directament",
"Welcome to the User Wizard" => "Benvingut/da a l'Assistent d'Usuaris",
"User Wizard Completed" => "Assistent d'Usuaris Finalitzat",
"Invalid wizard stepNr specified" => "Número de pas invàlid de l'assistent",
"Articles Home" => "Inici dels articles",
// "Delete selected messages" => "Delete selected messages",
// "%0 archived message was deleted" => "%0 archived message was deleted",
// "%0 archived messages were deleted" => "%0 archived messages were deleted",
// "No messages were deleted" => "No messages were deleted",
// "No messages were selected to delete" => "No messages were selected to delete",
// "The message must have either a subject or a body" => "The message must have either a subject or a body",
"User %s does not have the permission" => "L'usuari %s no té el permís",
"The message has been sent to" => "S'ha enviat el missatge a",
"The message will be sent to" => "S'enviarà el missatge a",
// "See below for how the broadcast message will be handled upon confirmation" => "See below for how the broadcast message will be handled upon confirmation",
// "No valid users to send the message to" => "No valid users to send the message to",
"User %s does not want to receive messages" => "La persona usuària %s no vol rebre missatges",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La bústia Enviats és plena. Arxiveu o esborreu alguns missatges enviats si voleu enviar més missatges.",
// "See below for how message will be handled upon confirmation" => "See below for how message will be handled upon confirmation",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Heu de poder rebre missatges per tal d'enviar-ne. Aneu a preferències de l'usuari i activa 'Permetre missatges d'altres usuaris'",
"User %s can not receive messages, mailbox is full" => "L'usuari %s no pot rebre missatges, la bústia de correu és plena",
"User %s can not receive messages" => "L'usuari %s no pot rebre missatges",
"Invalid user: %s" => "Usuari no vàlid: %s",
// "%0 message was marked" => "%0 message was marked",
// "%0 messages were marked" => "%0 messages were marked",
// "No messages were marked" => "No messages were marked",
// "No messages were selected to mark" => "No messages were selected to mark",
// "%0 message was deleted" => "%0 message was deleted",
// "%0 messages were deleted" => "%0 messages were deleted",
// "%0 message was archived" => "%0 message was archived",
// "%0 messages were archived" => "%0 messages were archived",
// "No messages were archived" => "No messages were archived",
// "No messages were selected to archive" => "No messages were selected to archive",
"Archive is full. Delete some messages from archive first." => "L'arxiu és ple. Esborra primer alguns missatges de l'arxiu.",
// "Delete message" => "Delete message",
// "Message deleted" => "Message deleted",
// "Message not deleted" => "Message not deleted",
"No more messages" => "No hi ha mes missatges",
// "Delete archive message" => "Delete archive message",
// "Archive message deleted" => "Archive message deleted",
// "Archive message not deleted" => "Archive message not deleted",
// "Delete sent message" => "Delete sent message",
// "Sent message deleted" => "Sent message deleted",
// "Sent message not deleted" => "Sent message not deleted",
// "%0 sent message was deleted" => "%0 sent message was deleted",
// "%0 sent messages were deleted" => "%0 sent messages were deleted",
"Action Calendar" => "Calendari d'Accions",
"Item types filter" => "Els tipus d'elements filtrants",
"If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "Si estableix una llista de tipus d'elements, restringeix els elements que es mostren als d'un d'aquests tipus. Cada joc és una llista separada per comes dels codis de tipus d'element",
"Possible item type values" => "Els possibles valors de tipus d'element",
"Similar Content" => "Contingut similar",
"Find similar content based on tags" => "Cercar contingut similar basat en Marques Lliures",
"Similar Content Filter" => "Similar filtre de contingut",
"Display only similar content of type specified" => "Mostra només el contingut similar de tipus especificat",
"Default: \"All Content Type\"" => "Per omissió: \"Tot tipus de contingut\"",
"Options: \"article, wiki page, blog post\"" => "Opcions: \"article de la pàgina wiki, bloc\"",
"Broaden FreeTag Search" => "Ampliar Cerca de Marques Lliures",
"Find similar content that contains one of the Tags or All of the Tags" => "Cerca contingut similar que conté una de les etiquetes o de totes les etiquetes",
"Default: \"n - needs to contain all of the Tags\"" => "Per omissió: \"n - ha de contenir totes les etiquetes\"",
"Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Opcions: \"n - ha de contenir totes les etiquetes / any - ha de contenir una de les etiquetes\"",
// "Quick Admin Bar" => "Quick Admin Bar",
// "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features" => "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features",
"Display mode: module or header. Leave empty for module mode" => "Mòdul o encapçalament: Mode de visualització. Deixar en blanc per a la manera de mòdul",
"Google AdSense" => "Google AdSense",
"Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Mostra un text / imatge de Google AdSense publicitat. Aquest mòdul ha de ser actualitzat per donar suport al nou codi de Google",
"ad_channel" => "ad_channel",
"Advertisement channel, as optionally provided by Google" => "Canal de Publicitat, que opcionalment proveït per Google",
"client" => "client",
"As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "Segons el que proporciona Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
"display" => "mostrar",
"Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Format bandera Global al que disposa Google. Per exemple:  \"display=468*60_as\"",
"color_bg" => "color_bg",
"Background color, as optionally provided by Google" => "Color de fons, com opcionalment proveït per Google",
"color_border" => "color_border",
"Border color, as optionally provided by Google" => "Color de la vora, com opcionalment proveït per Google",
"color_link" => "color_link",
"Link color, as optionally provided by Google" => "Color de Link, com opcionalment proveït per Google",
"color_text" => "COLOR_TEXT",
"Text color, as optionally provided by Google" => "Color del text, ja que opcionalment proveït per Google",
"color_url" => "color_url",
"URL color, as optionally provided by Google" => "Color d'URL, com opcionalment proporcionat per Google",
"Article Archives" => "Arxius d'Articles",
"Shows links to the published articles for each month" => "Mostra enllaços als articles publicats per cada mes",
"If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "Si s'estableix a \"y\", mostra un botó amb l'etiqueta \"...\" Més que els enllaços per tal de paginat dels articles seleccionats",
"Default: \"n\"" => "Per omissió: \"n\"",
"If set to a category identifier, only consider the articles in the specified category" => "Si s'estableix en un identificador de categoria, només tenen en compte els articles de la categoria especificada",
"Example value: 13" => "Valor d'exemple: 13",
"Topic filter (by names)" => "Filtre Tema (amb noms)",
"If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Si s'estableix en una llista de noms dels temes de l'article separades per signes de suma, només tenen en compte els articles en els assumptes de l'article especificades. Si la cadena està precedida per un signe d'exclamació (\"! \"), L'efecte s'inverteix, és a dir, no es consideren articles en els assumptes de l'article especificades",
"Topic filter (by identifiers)" => "Tema filtre (per identificadors)",
"If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Si s'estableix en una llista d'identificadors tema de l'article, separats per signes de suma, només tenen en compte els articles en els assumptes de l'article especificades. Si la cadena està precedida per un signe d'exclamació (\"! \"), L'efecte s'inverteix, és a dir, no es consideren articles en els assumptes de l'article especificades",
"Example values: 13, !13, 1+3, !1+5+7" => "Valors d'exemple: 13, !13, 1+3, !1+5+7",
"Types filter" => "Tipus de filtres",
"If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "Si s'estableix en una llista de noms dels tipus d'articles separats per signes de més, només tenen en compte els articles dels tipus especificats. Si la cadena està precedida per un signe d'exclamació (\"! \"), L'efecte s'inverteix, és a dir, no es consideren articles dels tipus d'articles especificats",
"Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Valors d'exemple: Event, !Event, Event+Review, !Event+Classified+Article",
"Language filter" => "Idioma filtre",
"If set to a language code, only consider the articles in the specified language" => "Si s'estableix en un codi d'idioma, només tenen en compte els articles en l'idioma especificat",
"Article Topics" => "Temes de l'article",
"Lists all article topics with links to their articles" => "Llista tots els assumptes de l'article amb enllaços als seus articles",
"Lists the specified number of published articles in the specified order" => "Mostra el nombre especificat d'articles publicats en l'ordre especificat",
"Show publication time" => "Mostra moment de la publicació",
"If set to \"y\", article publication times are shown" => "Si s'estableix a \"y\", es mostren temps de publicació d'articles",
"Show creation time" => "Mostra el temps de creació",
"If set to \"y\", article creation times are shown" => "Si s'estableix a \"y\", es mostren hores de creació d'articles",
"Show rating selector" => "Mostra selector de qualificació",
"If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "Si s'estableix a \"y\", ofereix a l'usuari filtrar articles basats en un mínim i un valor màxim",
"Image width" => "Amplada d'Imatge",
"If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "Si s'activa, mostra una imatge de cada article si s'aplica, amb l'amplada determinada (en píxels). Pròpia imatge de l'article s'utilitza, amb un retorn a la imatge el tema d'aquest article",
"If set to a category identifier, only lists the articles in the specified category" => "Si s'estableix en un identificador de categoria, només s'enumeren els articles de la categoria especificada",
"If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Si s'estableix en una llista de noms dels temes de l'article separades per signes de suma, només s'enumeren els articles en els assumptes de l'article especificades. Si la cadena està precedida per un signe d'exclamació (\"! \"), L'efecte s'inverteix, és a dir, els articles en els assumptes de l'article especificades no estan llistats",
"If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Si s'estableix en una llista d'identificadors tema de l'article, separats per signes de suma, només s'enumeren els articles en els assumptes de l'article especificades. Si la cadena està precedida per un signe d'exclamació (\"! \"), L'efecte s'inverteix, és a dir, els articles en els assumptes de l'article especificades no estan llistats",
"If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "Si s'estableix en una llista de noms dels tipus d'articles separats per signes de suma, només s'enumeren els articles dels tipus especificats. Si la cadena està precedida per un signe d'exclamació (\"! \"), L'efecte s'inverteix, és a dir, els articles dels tipus d'articles especificats no estan llistats",
"If set to a language code, only lists the articles in the specified language" => "Si s'estableix un codi d'idioma, només s'enumeren els articles en l'idioma especificat",
"Specifies how the articles should be sorted" => "Especifica com s'han d'ordenar els articles",
"Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Els valors possibles són creats i created_asc (equivalent), created_desc, autor, classificació, topicId, lang i el títol. Llevat que \"_DESC\" s'especifica, l'ordre és ascendent. \"Creat\" tipus d'article de la data de creació",
"If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "Si s'estableix en un enter, compensa la llista dels articles pel nombre donat. Per exemple, si el mòdul s'estableix el contrari a la llista dels 10 articles publicats més recentment, l'establiment de la compensació a 10 faria que la llista de mòduls de l'11 al article 20 per tal dels temps publicació descendent lloc",
"If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "Si s'estableix a \"y\", mostra un botó amb l'etiqueta \"Més\" que es vincula a una vista paginada dels articles seleccionats",
"Absolute URL" => "URL absoluta",
"If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "Si s'estableix a \"y\", alguns dels enllaços d'utilitzar un URL absoluta en lloc d'una relació. Això pot evitar enllaços trencats si el mòdul ha de ser enviat en un butlletí de notícies, per exemple,",
"If set to 0, will take the topicId of the article if in an article" => "Si s'estableix a 0, es portarà a la topicId l'article si en un article",
"Tiki Assistant" => "Tiki Assistent",
"Display an assistant to guide new Tiki admins" => "Mostra un assistent per guiar nous administradors Tiki",
"Newest Blog Post Comments" => "El nou bloc Comentaris",
"Displays the specified number of the blog post comments most recently added" => "Mostra el nombre especificat dels blocs d'enviar un comentari més recentment afegits",
"No date" => "Sense data",
"If set to \"y\", the date of comments is not displayed in the module box" => "Si s'estableix a \"y\", la data dels comentaris no es mostra en el quadre de mòdul",
"Verbose tooltips" => "Tooltips Verbose",
"If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "Si s'estableix a \"y\", títol de l'entrada de bloc és només visible com un suggeriment i no es mostra",
// "Options: \"y,n\"" => "Options: \"y,n\"",
"Last-Visited Pages" => "Pàgines Últim visitat",
"Displays the last Wiki pages visited by the user" => "Mostra les últimes pàgines Wiki visitats per l'usuari",
"Maximum number of characters in page names allowed before truncating" => "Capacitat màxima de caràcters en els noms de pàgina permesos abans de truncar",
"Show Namespace" => "Mostra Espai de noms",
"Show namespace prefix in page names" => "Mostra prefix d'espai de noms de pàgina",
"A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "Una jerarquia d'on es troba. Ex:. Home> Secció 1> Subsecció C",
"Label preceding the crumbs" => "Etiqueta que precedeix les molles",
"Menu Id" => "Aneu Menu",
"Menu to take the crumb trail from" => "Menú per agafar el sender de punts de",
"Menu Start Level" => "Menú Inici Nivell",
"Lowest level of the menu to display" => "Nivell més baix del menú per a mostrar",
"Menu Stop Level" => "Menú parada de nivell",
"Highest level of the menu to display" => "El nivell més alt del menú per a mostrar",
"Show Site Crumb" => "Mostrar Lloc molla",
"Display the first crumb, usually the site, when using menu crumbs" => "Veure el primer molla, en general el lloc, utilitzant les engrunes de menú",
"Show Page Crumb" => "Mostrar Pàgina molla",
"Display the last crumb, usually the page, when using menu crumbs" => "Mostra la última molla, en general a la pàgina, en utilitzar les molles de menú",
"Show Crumb Links" => "Mostra molla Links",
"Display links on the crumbs" => "Mostrar vincles amb les engrunes",
"Includes a calendar or a list of calendar events" => "Inclou un calendari o una llista dels esdeveniments del calendari",
"Calendars filter" => "Filtren Calendaris",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default",
"Displayed month (relative)" => "Mes que es mostra (relatiu)",
"Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distància de mes a mes a mostrar. Una distància de -1 es mostrarà el mes anterior. En establir aquesta opció implica un tipus de vista del calendari amb un lapse de temps mes. Valors d'exemple: 2, 0, -2, -12",
"View type" => "Veure el tipus",
"Determines how to show events. Possible values: %0, %1" => "Determina com mostrar els esdeveniments. Valors possibles: %0, 1%",
"Calendar view type time span" => "Vista calendari Tipus de lapse de temps",
"If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "Si en el calendari (o \"table\") tipus de vista, determina el període de temps indicat pel calendari. Valors possibles: %0, %1, %2, %3, %4, %5. Un usuari canviar aquest interval de temps en el calendari pot canviar l'interval de temps del mòdul mostra per a ell",
"Show action" => "Mostrar l'acció",
"Viewmode when clicking on a day" => "ViewMode en fer clic en un dia",
"Put a link on all the days , not only those with event" => "Posa un enllaç a tots els dies, no només aquells amb esdeveniments",
"View navigation bar" => "Veure barra de navegació",
"Cart" => "Carro",
"Displays the content of the cart, allows quantities to be modified and proceeds to payment" => "Mostra el contingut de la cistella, permet modificar les quantitats i procedir al pagament",
// "Use AJAX" => "Use AJAX",
// "Use AJAX services for managing the cart" => "Use AJAX services for managing the cart",
// "Show Items" => "Show Items",
// "Shows the items in the cart as they are added" => "Shows the items in the cart as they are added",
// "Shows the number of items in the cart" => "Shows the number of items in the cart",
// "Checkout URL" => "Checkout URL",
// "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated" => "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated",
// "(Default empty: Goes to tiki-payment.php)" => "(Default empty: Goes to tiki-payment.php)",
// "Post-Payment URL" => "Post-Payment URL",
// "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc" => "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc",
// "Show Total Weight" => "Show Total Weight",
// "Shows the weight of the items in the cart" => "Shows the weight of the items in the cart",
// "Shown after the weight" => "Shown after the weight",
// "Show Item Buttons" => "Show Item Buttons",
// "Shows add, remove and delete buttons on items" => "Shows add, remove and delete buttons on items",
"The quantities in your cart were updated" => "Les quantitats a la cistella han actualitzat",
"Gift card added" => "Targeta regal afegit",
"Gift card not found" => "Targeta de regal que no es troba",
"Gift card removed" => "Targeta de regal eliminat",
"Displays links to categories as a tree" => "Mostra enllaços a categories com a arbre",
"Object type filter" => "Tipus d'objecte de filtre",
"Object type filter to apply when accessing a linked category. Example values" => "Filtre de tipus d'objecte d'aplicar quan s'accedeix a una categoria relacionada. Valors d'exemple",
"Deep" => "Profund",
"Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Mostra objectes subcategories quan s'accedeix a una categoria relacionada. Valors possibles: On (per omissió), aparell de",
"Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Límits mostren les categories a un subarbre de categories que comencen amb la categoria amb l'ID donat. Valor d'exemple: 11. Per defecte: 0 (no es limiti pantalla)",
"Show these categories and their children" => "Mostra aquestes categories i els seus fills",
"Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Mostra només les categories i els nens Categories immediats d'aquests en l'ordre en el paràmetre especifica. Valors d'exemple: 3,5,6",
"Category links to a page named as the category" => "Els enllaços de categoria a una pàgina anomenada com la categoria",
"If y, category links to a page named as the category" => "Si i, links categoria a una pàgina anomenada com la categoria",
// "Hide Empty" => "Hide Empty",
// "If y, only categories with child objects will be shown" => "If y, only categories with child objects will be shown",
// "Only Children" => "Only Children",
// "If y, only direct child categories will be shown. Default: n" => "If y, only direct child categories will be shown. Default: n",
"Custom URL" => "URL personalitzada",
// "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" " => "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" ",
"Category Transitions" => "Categoria Transitions",
"Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Mostra els controls per activar les transicions categoria i canviar l'estat de la pàgina d'acord a regles predefinides",
"Example Transition" => "Exemple Transició",
"Change Category" => "Canviar Categoria",
"Enables to categorize an object" => "Permet classificar un objecte",
// "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
"Category identifier" => "Identificador Categoria",
"Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Canvia l'arrel de les categories que es mostren en per omissió \"Inici\" a la categoria amb l'identificador donat",
"Note that the root category is not displayed" => "Tingueu en compte que la categoria de l'arrel no es mostra",
"Defaults to 0 (root)" => "Per omissió és 0 (root)",
"No top" => "No superior",
"In non-detailed view, disallow uncategorizing. Example value: 1" => "Atesa no detallada, uncategorizing no s'utilitzaran. Valor exemple: 1",
"Display path" => "Mostra la ruta",
// "Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Unless set to \"n\", display relative category paths in the category tree rather than category names",
"Paths are relative to the root category, which is not displayed" => "Les rutes són relatives a la categoria arrel, que no es mostra",
"Multiple categories" => "Categories múltiples",
"If set to \"n\", only allows categorizing in one category (from those displayed)" => "Si s'estableix a \"n\", només permet classificar en una categoria (dels quals es mostren)",
"Categorize" => "Categoritzar",
"String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "Cadena que es mostra al botó per enviar noves categories, quan diverses categories estan habilitats. Valor per omissió: Classificar",
"Shy" => "Shy",
"If set to \"y\", the module is not shown on pages which are not already categorized" => "Si s'estableix a \"y\", el mòdul no apareix a les pàgines que no estan ja catalogats",
"Detailed" => "Detallat",
"If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "Si s'estableix a \"y\", mostra una llista de categories en què l'objecte és. Si la cancel·lació no es desactiva, es fa amb la llista",
"If set to \"n\", the detailed list of categories will not offer to unassign a category" => "Si s'estableix a \"n\", la llista detallada de les categories de no oferir a cancel·lar l'assignació d'una categoria",
"If set to \"y\", allow to assign new categories" => "Si s'estableix a \"y\", permetrà assignar noves categories",
"Example values: y, n" => "Valors d'exemple: y, n",
"Default value: y" => "Valor per omissió: y",
"Group filter" => "Filtre de grup",
// "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories",
"Default value: n" => "Valor per omissió: n",
"Image URL not in category" => "URL Imatge no en la categoria",
"Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Molt particularment paràmetre. Si tant aquesta com \"URL de la imatge en la categoria\" s'estableix i la categoria arrel conté una sola categoria infantil, el mòdul només mostra una imatge amb aquesta URL si l'objecte no està en la categoria",
"Image URL in category" => "URL de la imatge de la categoria",
"Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Molt particularment paràmetre. Si tant aquesta com \"URL de la imatge no està en la categoria\" s'estableix i la categoria arrel conté una sola categoria infantil, el mòdul només mostra una imatge amb aquesta URL si l'objecte es troba en la categoria",
"Categorize %s" => "Classificar %s",
"Categorize %s in %s" => "Classifica %s en %s",
// "Collapse Button" => "Collapse Button",
// "Bootstrap collapse button" => "Bootstrap collapse button",
// "CSS selector defining which objects get collapsed" => "CSS selector defining which objects get collapsed",
// "CSS class for containing DIV element" => "CSS class for containing DIV element",
// "CSS selector defining the collapsing objects' container" => "CSS selector defining the collapsing objects' container",
"Received Objects" => "Objectes rebuts",
"Displays the number of pages received (via Communications)" => "Mostra el nombre de pàgines rebudes (a través de les Comunicacions)",
"Contributors" => "Contribuïdors",
"Lists the contributors to the wiki page being viewed and some information on them" => "Enumera els contribuents a la pàgina wiki que s'està veient i alguna informació sobre ells",
"Shows the credits a user has" => "Mostra els crèdits que té un usuari",
"Newest Directory Sites" => "El nou Directori de Llocs",
"Displays the specified number of the directory sites most recently added" => "Mostra el nombre especificat dels llocs del directori recentment agregats",
"Directory category identifier" => "Categoria identificador Directori",
"If set to a directory category identifier, only displays the sites in the specified directory category" => "Si s'estableix en una categoria identificador de directori, només mostra els llocs al directori de la categoria especificada",
"If set to \"y\", displays a button labelled \"More\" that links to the directory" => "Si s'estableix a \"y\", mostra un botó amb l'etiqueta \"Més\" que enllaça amb el directori",
"Show description" => "Mostrar descripció",
"If set to \"y\", the description of the directory site appears" => "Si s'estableix a \"y\", apareix la descripció del lloc del directori",
"Maximum length of description" => "La longitud màxima de la descripció",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
"Default: blank" => "Per omissió: en blanc",
"Directory Statistics" => "Estadístiques Directori",
"Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Mostra informació sobre el directori, incloent el nombre de llocs validats i el nombre de categories per validar, de les cerques i els enllaços visitats",
"Top Directory Sites" => "Top Sites Directori",
"Displays the specified number of the directory sites from most visited to least visited" => "Mostra el nombre especificat dels llocs del directori de més visitada a menys visitat",
// "Domain Password" => "Domain Password",
// "Store personal passwords for other domains securely in Tiki" => "Store personal passwords for other domains securely in Tiki",
// "System the credentials apply for. The name must match a defined Password Domain" => "System the credentials apply for. The name must match a defined Password Domain",
// "Use current user" => "Use current user",
// "Use the currently logged-in user. The username is not editable. (y/n) Default: y" => "Use the currently logged-in user. The username is not editable. (y/n) Default: y",
// "Can Update" => "Can Update",
// "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n" => "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n",
// "Show domain prompt" => "Show domain prompt",
// "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y" => "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y",
// "No Password Domains found" => "No Password Domains found",
// "Domain is not valid" => "Domain is not valid",
// "No domain specified" => "No domain specified",
// "No user defined" => "No user defined",
// "No password saved" => "No password saved",
// "Read error" => "Read error",
// "No password specified" => "No password specified",
// "No username specified" => "No username specified",
// "Failed to save password" => "Failed to save password",
// "Failed to save user" => "Failed to save user",
// "Saved OK" => "Saved OK",
"Facebook" => "Facebook",
"Shows the Wall of a user" => "Mostra el perfil d'un usuari",
"Tiki user to show Facebook wall of" => "Usuari Tiki per mostrar mur de Facebook d'",
"Show username in timeline. y|n" => "Mostra nom d'usuari a la línia de temps. y|n",
"user not registered with facebook" => "usuari no s'ha registrat al facebook",
"No username given" => "N nom d'usuari donat",
"Featured Links" => "Enllaços recomanats",
"Displays the site's first featured links" => "Mostrar els primers enllaços destacats del lloc",
"Displays links to file galleries" => "Mostra enllaços a galeries d'arxius",
"Top-Rated Topics" => "Temes amb millor puntuació",
"Displays the specified number of the forum topics with the best ratings" => "Mostra el nombre especificat dels temes en les millors qualificacions",
"Newest Forum Posts" => "Publicacions més recents als fòrums",
"Displays the latest forum posts" => "Mostra les darreres publicacions als fòrums",
"Topics only" => "Només tòpics",
"If set to \"y\", only displays topics" => "Si s'estableix a \"y\", només mostra els temes",
"List of forum identifiers" => "Llista d'identificadors fòrum",
"If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "Si s'estableix en una llista d'identificadors fòrum, restringeix els llocs als quals en els fòrums identificats. Els identificadors estan separats per dos punts (\": \")",
"Show date" => "Mostra data",
"If set to \"y\", show post date directly instead of as tooltip" => "Si s'estableix a \"y\", mostrar data directament en lloc de com informació sobre eines",
"Show time" => "Show d'hora",
"Show times after dates" => "Horaris de l'espectacle després de les dates",
"If set to \"y\", show post author directly instead of as tooltip" => "Si s'estableix a \"y\", després de mostrar autor directament en lloc de com informació sobre eines",
"Most Commented Forums" => "Fòrums amb més comentaris",
"Display the specified number of the forums with the most comments" => "Mostra el nombre especificat dels fòrums amb la majoria dels comentaris",
"Top Visited Forum Topics" => "Temes principals fòrums visitats",
"Display the specified number of the forum topics with the most reads" => "Mostra el nombre especificat dels temes en la majoria de lectures",
"Top Visited Forums" => "Top dels fòrums visitats",
"Display the specified number of the forums with the most visits" => "Mostra el nombre especificat dels fòrums amb més visites",
"Tags Editor" => "Editor de Marques",
"Shows current tags and enables adding and removing some if permissions allow" => "Mostrar marques actuals i permet afegir i treure algunes si els permisos ho permeten",
"Wiki Page Tags" => "Wiki Pàgina Etiquetes",
"Displays current tags on wiki pages and enables adding tags if permissions allow" => "Mostra les marques lliures actuals a les pàgines wiki i permet afegir etiquetes si els permisos permeten",
"Similar-Tag Items" => "Ítems amb Marques Similars",
"Shows content with multiple tags in common" => "Mostra el contingut amb múltiples marques en comú",
"Type of objects to extract" => "Tipus d'objectes per extreure",
"Most Popular Tags" => "Marques Més Populars",
"Shows the most popular tags. More popularity is indicated by a larger font" => "Mostrar les marques lliures més populars. Més de popularitat s'indica mitjançant una font més gran",
"Display type" => "Tipus de pantalla",
"If set to \"cloud\", links are displayed as a cloud" => "Si s'estableix a \"núvol\", els vincles es mostren com un núvol",
"Default: \"list\"" => "Per omissió: \"llista\"",
"Maximum elements" => "Elements Màxim",
"If set to a number, limits the number of tags displayed" => "Si s'estableix en un nombre, limita el nombre d'etiquetes que apareixen",
"BlogId" => "BlogId",
// "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5" => "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5",
"My Preferred Tags" => "Les Meves Marques Preferides",
"Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size" => "Mostra als usuaris registrats les marques lliures que prefereixin, en base al nombre d'objectes que s'afegeixen a l'etiqueta. S'indica una major preferència per un tipus de lletra més gran",
"My preferred tags" => "Les meves marques preferides",
// "Displays a list of friends" => "Displays a list of friends",
// "GIT detail" => "GIT detail",
// "GIT commit and last update information" => "GIT commit and last update information",
"Google Search" => "Cerca a Google",
"Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Mostra una forma senzilla de buscar a Google. per omissió, els resultats de la cerca es limiten als que en el lloc de Tiki",
"Groups Emulation" => "Grups d'emulació",
"Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Permet canviar temporalment la pertinença a grups d'entre un i veure com els usuaris en menys grups experimenten el lloc",
// "Show All Groups" => "Show All Groups",
// "If set to \"n\", the list is not shown" => "If set to \"n\", the list is not shown",
// "Show Your Groups" => "Show Your Groups",
"Emulate Groups" => "Emula Grups",
"Last Actions" => "Últimes accions",
"Displays the specified number of last actions" => "Mostra el nombre especificat d'últimes accions",
"Show user" => "Mostra de l'usuari",
"If set to \"y\", user names are displayed in the module box" => "Si s'estableix a \"y\", els noms d'usuari es mostren en el quadre de mòdul",
"If set to \"y\", action dates are displayed in the module box" => "Si s'estableix a \"y\", les dates de l'acció es mostren en el quadre de mòdul",
"Maximum number of characters in action descriptions before truncating" => "Capacitat màxima de caràcters en les descripcions de l'acció abans de truncar",
"Newest Blog Posts" => "Nous posts de bloc",
"Lists the specified number of blogs posts from newest to oldest" => "Mostra el nombre especificat de blocs missatges del més recent al més antic",
"If set to \"y\", the date of posts is not displayed in the module box" => "Si s'estableix a \"y\", la data dels missatges no es mostra en el quadre de mòdul",
"Blog identifier" => "Identificador Bloc",
"If set to a blog identifier, restricts the blog posts to those in the identified blog" => "Si s'estableix en un identificador bloc, restringeix les entrades del bloc als del bloc identificats",
"Newest Category Items" => "Nous elements de categoria",
"Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Llista el nombre especificat d'objectes del tipus donat en la categoria donada, a partir de la creat més recentment",
"Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identificador de la categoria en la que es llisten els objectes. No es mostraran els objectes merament en les categories infantil",
"Maximum number of characters in object names allowed before truncating" => "Capacitat màxima de caràcters en els noms d'objectes permesos abans de truncar",
"Type of the objects to list. Example values" => "Tipus dels objectes a la llista. Valors d'exemple",
"no object here yet" => "encara no hi ha cap objecte aquí",
"Newest Blogs" => "Darrers Blocs",
"Displays the specified number of blogs from newest to oldest" => "Mostra el nombre especificat de blocs, del més nou al més antic",
"Newest FAQs" => "Nous FAQs",
"Displays the specified number of FAQs from newest to oldest" => "Mostra el nombre especificat de preguntes freqüents del més recent al més antic",
"Newest Quizzes" => "Nous Qüestionaris",
"Displays the specified number of quizzes from newest to oldest" => "Mostra el nombre especificat de concursos del més recent al més antic",
"Last-Modified File Galleries" => "Galeries File Last-Modified",
"Display the specified number of file galleries, starting from the most recently modified" => "Mostra el nombre especificat de galeries d'arxius, començant pel més modificat recentment",
"Newest Files" => "Darrers arxius",
"List the specified number of files, starting from the most recently added" => "Llistar el nombre especificat d'arxius, a partir de la afegit més recentment",
"Gallery identifiers" => "Identificadors Galeria",
"If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "Si s'estableix en un conjunt d'identificadors galeria d'arxius, restringeix els arxius als que en les galeries identificats. El valor és una seqüència separada per dos punts d'enters",
"Example value: 13, 2:13, 1:2:3:5:6" => "Valor d'exemple: 13, 2:13, 1:2:3:5:6",
"Last-Modified Image Galleries" => "Last-Modified Galeries d'imatges",
"Displays the specified number of image galleries, starting from the most recently modified" => "Mostra el nombre especificat de galeries d'imatges, començant pel més modificat recentment",
"Newest Images" => "Darreres imatges",
"List the specified number of images, starting from the most recently added" => "Llistar el nombre especificat d'imatges, a partir de la afegit més recentment",
"Gallery identifier" => "Galeria identificador",
"If set to an image gallery identifier, restricts the images to those in the identified gallery" => "Si s'estableix en una galeria d'imatges identificador, restringeix les imatges a les de la galeria identificat",
"Link content" => "Contingut d'Enllaç",
"Display the links as image names or thumbnails" => "Vegeu els enllaços com noms de les imatges o miniatures",
"Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Valors possibles: \"noms\" o \"miniatures \". Valor per omissió: \"noms \"",
"Last-Modified Events" => "Esdeveniments Last-Modified",
"Display the specified number of calendar events, starting from the most recently modified" => "Mostra el nombre especificat d'esdeveniments de calendari, començant pel més modificat recentment",
"Calendar Identifier" => "Calendari Identificador",
"If set to a calendar identifier, restricts the events to those in the identified calendar" => "Si s'estableix en un identificador de calendari, restringeix els esdeveniments als quals en el calendari identificat",
"Maximum number of characters in event names allowed before truncating" => "Capacitat màxima de caràcters en els noms d'esdeveniments permesos abans de truncar",
"Hide Date" => "Data Amaga",
"If set to \"y\", it will hide date" => "Si s'estableix a \"y\", que s'oculta data",
"Latest Changes" => "Darrers canvis",
"List the specified number of pages, starting from the most recently modified" => "Llistar el nombre especificat de pàgines, començant pel més modificat recentment",
"Link Target" => "Enllaç Target",
"Target URL of the \"...more\" link at the bottom of the module" => "URL de destinació de l'enllaç \"...Més\" a la part inferior del mòdul",
"Last-Modified Blogs" => "Blocs Last-Modified",
"Displays the specified number of blogs, starting from the most recently modified" => "Mostra el nombre especificat dels blocs, començant pel més modificat recentment",
"Newest Podcasts" => "Darrers podcasts",
"Displays Podcasts" => "Mostra Podcasts",
"File galleries IDs" => "Arxiu galeries ID",
"List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "Llista d'IDs de galeries d'arxius de tipus \"Podcast (Audio) \". Identificadors estan separats per dos punts (\":\"). Si no hi ha, s'analitzaran tots els arxius de les galeries",
"Width of mediaplayer in pixels" => "Ample del mediaplayer en píxels",
"Height of mediaplayer in pixels" => "Alçada del mediaplayer en píxels",
"Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Camí al reproductor de mp3. Per exemple media/player_mp3_maxi.swf si descarregues player_mp3_maxi.swf de http://flash-mp3-player.net/players/maxi/download/ als directori de mitjans media/ (s'ha de crear el directori o pots triar un altre lloc)",
"Bottom Link URL" => "URL de l'enllaç de sota",
"URL for a link at bottom of module" => "URL d'un enllaç a la part inferior del mòdul",
"Bottom Link URL Text" => "Text de la URL de l'enllaç de sota",
"Text for link if Bottom Link URL is set" => "Text d'enllaç si s'ajusta Bottom Enllaç URL",
"More Podcasts" => "Més Podcasts",
"Verbose" => "Verboso",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\"",
"Newest Article Submissions" => "Nous Peticions article",
"Lists the specified number of article submissions from newest to oldest" => "Mostra el nombre especificat dels articles presentats del més recent al més antic",
"Newest Tracker Comments" => "Comentaris més recents a Formularis-bd",
"Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Llista el nombre especificat de un formulari-bd de comentaris (opcionalment restringir als d'un un formulari-bd específic o element del registre) començant pel més recentment publicat",
"Tracker identifier" => "Formulari-bd identificador",
"If set to a tracker identifier, only displays the comments on the given tracker" => "Si s'estableix en un identificador de seguiment, només mostra els comentaris al formulari-bd donat",
"Item identifier" => "Identificador d'article",
"If set to an item identifier, only displays the comments on the given item" => "Si s'estableix en un identificador de tema, només es mostren els comentaris sobre l'article donat",
"Newest Tracker Items" => "Nous Ítems de Formulari-bd",
"Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Mostra el valor d'un camp del nombre especificat d'elements del registre. Si el tracker no té cap altre camp principal, es requereix ja sigui el nom del camp o l'identificador de camp",
"Identifier of the tracker from which items are listed" => "Identificador del formulari-bd de la qual s'enumeren els articles",
"Field identifier" => "Identificador de camp",
"Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identificador del camp des del qual s'enumeren els valors. Si s'estableix el nom del camp, aquest paràmetre s'ignora",
"Field name" => "Nom del camp",
"Name of the field from which values are listed" => "Nom del camp de la qual s'enumeren els valors de",
"Example value: age" => "Valor d'exemple: l'edat",
"Specifies how the items should be sorted" => "Especifica com s'han d'ordenar els elements",
"Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Els valors possibles són creats i created_asc (equivalent), created_desc, estat, lastModif, CreatedBy i lastModifBy. Llevat que \"_DESC\" s'especifica, l'ordre és ascendent. \"Creat\" tipus d'article de la data de creació. \"\" LastModif tipus en l'última data de modificació dels articles. \"\" LastModif_desc classe per tal de l'última data de modificació descendent",
"Status filter" => "Filtre Estat",
"If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "Si s'estableix un límit als elements de la llista als que tenen els estats indicats. Els valors són combinacions de \"o\" (obert), \"p\" (pendent) i \"c\" (tancat). Els valors possibles",
"Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "No es pot determinar quin camp per mostrar. Formulari-bd identificador pot ser vàlid o el un formulari-bd té cap camp principal i es van establir ni identificador de camp, ni nom de camp",
"You do not have permission to view this tracker" => "No té permís per veure aquest un formulari-bd",
"Last Items" => "Últims Punts",
"Last modified Items" => "Últims Punts modificats",
"Newest Validated FAQ Questions" => "Nous Validat Ajuda Preguntes",
"Displays the specified number of validated questions FAQs from newest to oldest" => "Mostra el nombre específic de preguntes validades FAQs del més recent al més antic",
"FAQ identifier" => "Faq identificador",
"If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ" => "Si s'estableix en un identificador de preguntes freqüents, restringeix les preguntes escollides a les que en el FAQ identificat",
"Last Visitors" => "Últims visitants",
"Displays information about the specified number of users in decreasing order of last login time" => "Mostra informació sobre el nombre específic d'usuaris per tal de l'última hora de l'entrada disminueix",
"Show profile pictures" => "Mostrar avatars",
"If set to \"y\", show user profile pictures" => "Si s'estableix a \"y\", mostrar els avatars d'usuaris",
"Maximum number of characters in user names allowed before truncating" => "Capacitat màxima de caràcters en els noms d'usuari permès abans de truncar",
"Don't show date" => "No mostrar data",
"YouTube Playlist" => "YouTube Playlist",
"Display a YouTube playlist" => "Mostra una llista de reproducció de YouTube",
"Playlist ID" => "Playlist ID",
"ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "Identificador de la llista de reproducció de YouTube per mostrar (no la URL completa). Exemple: id = 4DE69387D46DA2F6",
// "Google YouTube API Key" => "Google YouTube API Key",
"Width of each video in pixels" => "Ample de cada vídeo en píxels",
"Height of each video in pixels" => "Alçada de cada vídeo en píxels",
// "Allow FullScreen" => "Allow FullScreen",
"Bottom Link" => "Enllaç de sota",
"Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url d'un enllaç a la part inferior del mòdul. Exemple: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
"Bottom Link Text" => "Text de l'enllaç de sota",
"Text for link if link_url is set, otherwise 'More Videos'" => "Text d'enllaç si link_url s'estableix, en cas contrari 'Més vídeos'",
"Video Descriptions" => "Descripcions de vídeo",
"Display description of video on title mouseover if 'y'. Default is 'y'" => "Veure descripció del vídeo en el títol mouseover si 'i'. Per omissió és 'i'",
"Order by" => "Ordenar per",
"Criteria to order by the videos in the list. Default is 'position'" => "Criteris per ordenar els vídeos a la llista. Per omissió és 'posició'",
"position" => "posició",
"commentCount" => "commentCount",
"duration" => "durada",
"published" => "publicat",
"reversedPosition" => "reversedPosition",
"title" => "títol",
"viewCount" => "Viewcount",
// "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
"No Playlist found" => "No s'ha trobat Playlist",
"No Playlist ID was provided" => "No Playlist ID es va proporcionar",
"Live Support" => "Suport en directe",
"Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Li diu als usuaris si un operador de suport està present i els permet sol·licitar el suport, si és possible. Si l'usuari és un operador, enllaços a la consola de l'operador",
"Server Load" => "La càrrega del servidor",
"Report of server resources used" => "Informe dels recursos del servidor utilitzats",
"Locator" => "Localitzador",
"Presents a map with the geolocated content within the page" => "Presenta un mapa amb el contingut geolocalitzat dins de la pàgina",
// "Preference \"%0\" is disabled" => "Preference \"%0\" is disabled",
"Log-in box" => "Quadre de connexió",
"Input size" => "Mida d'entrada",
"Number of characters for username and password input fields" => "Nombre de caràcters per als camps d'entrada de nom d'usuari i contrasenya",
"Display mode: module, header or popup. Leave empty for module mode" => "Mode de visualització: module (mòdul), header (encapçalat) o popup (emergent). Deixar en blanc per al mode de mòdul",
"Show Register" => "Mostrar Registre",
"Show the register link" => "Mostra a l'enllaç per registrar-se",
"Show I Forgot" => "Mostra He oblidat",
"Show the \"I forgot my password\" link" => "Mostra l'enllaç \"He oblidat la contrasenya\"",
"Show Remember me" => "Mostrar Recordar",
"Show the \"Remember me\" checkbox" => "Mostra la casella de verificació per a \"Recordar-me\"",
// "Show user avatar" => "Show user avatar",
// "Show the user avatar when in popup mode" => "Show the user avatar when in popup mode",
// "Show user name" => "Show user name",
// "Show the user name when in popup mode" => "Show the user name when in popup mode",
// "Groups for switch user listing" => "Groups for switch user listing",
// "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")" => "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")",
// "Menu ID" => "Menu ID",
// "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"" => "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"",
"Logo" => "Logo",
"Site logo, title and subtitle" => "Logo del lloc, títol i subtítol",
// "Image URL" => "Image URL",
// "Image to use. Defaults to sitelogo_src preference" => "Image to use. Defaults to sitelogo_src preference",
// "CSS colour to use as background. Defaults to sitelogo_bgcolor preference" => "CSS colour to use as background. Defaults to sitelogo_bgcolor preference",
// "Image title attribute. Defaults to sitelogo_title preference" => "Image title attribute. Defaults to sitelogo_title preference",
// "Alt" => "Alt",
// "Image alt attribute. Defaults to sitelogo_alt preference" => "Image alt attribute. Defaults to sitelogo_alt preference",
// "URL for the image and titles link. Defaults to \"./\"" => "URL for the image and titles link. Defaults to \"./\"",
// "Logo Title" => "Logo Title",
// "Large text to go next to image. Defaults to sitetitle preference" => "Large text to go next to image. Defaults to sitetitle preference",
// "Logo Subtitle" => "Logo Subtitle",
// "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference" => "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference",
// "Logo Class" => "Logo Class",
// "CSS class for the image container div. Defaults to sitelogo" => "CSS class for the image container div. Defaults to sitelogo",
// "Title Class" => "Title Class",
// "CSS class title text container div. Defaults to sitetitles" => "CSS class title text container div. Defaults to sitetitles",
"Map Feature Editor" => "Editor de mapes Feature",
"Allows shapes to be drawn over the map" => "Permet dibuixar formes sobre el mapa",
"Tracker to store the feature in" => "Formulari-bd per a emmagatzemar-hi la funcionalitat",
"Hidden Input" => "Entrada oculta",
"Hidden values to be sent over to the dialog. fieldName(value)" => "Valors ocults que s'envien a través de la finestra de diàleg. fieldName (valor)",
"Standard controls" => "Els controls estàndard",
"Dispay the standard draw controls" => "Mostra els controls de drenatge estàndard",
"Mode change on insert" => "Canvi de mode d'inserció",
"Target mode to enter after successfully inserting an item" => "La manera Target per entrar després d'inserir correctament un element",
"Edit details" => "Edita detalls",
"Edit the tracker item's details through a dialog after the initial item creation" => "Editeu els detalls de l'element de seguiment a través d'un diàleg després de la creació inicial de l'element",
"Layer Selector" => "Selector de Capa",
"Include base layer" => "Incloure capa base",
"Include the drop list for the base layers" => "Inclogui la llista desplegable per a les capes de base",
"Include optional layers" => "Incloure capes opcionals",
"Include the checkboxes for the optional layers" => "Inclogui les caselles de verificació de les capes opcionals",
"Replace the map's built-in layer controls" => "Substituïu el mapa dels controls integrats de capa",
"Mode Selector" => "Selector de manera",
"Toggle input modes for the map" => "Maneres d'entrada de palanca per al mapa",
"Map location search" => "Mapa del lloc Cerca",
"Simple search controls for the map" => "Controls de cerca simples per al mapa",
"Menu" => "Menú",
"Displays a menu or a structure as a menu" => "Mostra un menú o una estructura de menú",
"Identifier of a menu (from tiki-admin_menus.php)" => "Identificador d'un menú (de tiki-admin_menus.php)",
"Structure" => "Estructura",
"Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identificador d'una estructura de pàgines wiki (nom o número del tiki-admin_structures.php)",
"Direction for menu: horiz or vert (default vert)" => "Mode de menú: horiz o vert (per omissió vert)",
"CSS/Superfish" => "CSS / Superfish",
// "Use CSS Superfish menu (if bootstrap = n). y|n (default y)" => "Use CSS Superfish menu (if bootstrap = n). y|n (default y)",
// "Use Bootstrap menus" => "Use Bootstrap menus",
// "Show Navbar Toggle Button" => "Show Navbar Toggle Button",
// "Used in Bootstrap navbar menus when viewport is too narrow for menu items" => "Used in Bootstrap navbar menus when viewport is too narrow for menu items",
// "The URL of the navbar brand (logo)" => "The URL of the navbar brand (logo)",
// "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu" => "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu",
// "CSS class(es) for the menu nav element" => "CSS class(es) for the menu nav element",
// "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar" => "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar",
"DOM #id" => "DOM #id",
"Id of the menu in the DOM" => "Aneu de menú al DOM",
"CSS class" => "Classe CSS",
"Class of the menu container" => "Classe del recipient menú",
"Limit low visibles levels" => "Límit baixos nivells Visibles",
"All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "Tot l'inici submenús en aquest nivell es mostrarà si la url coincideixi amb una de les opcions d'aquest nivell o per sobre o per sota de",
"Limit top visible levels" => "Límit els nivells superiors visibles",
"Do not display options higher than this level" => "No mostrar opcions superiors a aquest nivell",
"Link on Section" => "Link a la secció",
"Create links on menu sections" => "Crear enllaços a les seccions del menú",
"(y/n default y)" => "(s/n en anglès: y/n. Per omissió: y)",
"Translate labels" => "Traduir etiquetes",
"Menu Cookie" => "Galetes Menu",
"Open the menu to show current option if possible" => "Obriu el menú per mostrar l'opció actual, si és possible",
// "Set Selected" => "Set Selected",
// "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue" => "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue",
"One of these parameters has to be set" => "Un d'aquests paràmetres ha de ser establert",
"Menu Page" => "Pàgina que fa de Menú",
"Displays a Wiki page" => "Mostra una pàgina Wiki",
"Page to display in the menu. Example value: HomePage" => "Pàgina per mostrar al menú. Valor d'exemple: HomePage",
"Use default namespace" => "Fes servir l'espai-de-noms per omissió",
"Prepend the default namespace to the page name for localized menus per workspace (1/0)" => "Anteposar l'espai de noms per omissió per al nom de la pàgina de menús localitzats per àrea de treball (1/0)",
"Menu style" => "Estil del menú",
"Display the page as a menu (horiz / vert)" => "Mostra la pàgina com a menú (horiz / vert)",
"Wiki Structure Menu" => "Menú a partir de l'Estructura Wiki",
"Displays a structure" => "Mostra una estructura",
"N.B. Deprecated, use the Menu module instead" => "Atenció: Obsolet, utilitzeu el mòdul Menú en el seu lloc",
"Structure to display in the menu" => "Estructura que es mostrarà al menú",
"Unread Inter-User Messages" => "Missatges no llegits entre-usuaris",
"Displays to users their number of new inter-user messages and a link to their message box" => "Mostra als usuaris el nombre de missatges nous entre els usuaris i un enllaç a la seva bústia de missatges",
"Show If Empty" => "Mostra si és buit",
"Show the module when there are no messages waiting. y|n " => "Mostra el mòdul quan no hi ha missatges en espera. y|n (si|no)",
"Default=y" => "Per omissió=y",
"Messages" => "Missatges",
"Small live chat box" => "Petita caixa de xat en viu",
"Channels" => "Canals",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
"By default, a single channel named \"default\" exists" => "per omissió, un únic canal anomenat \"defecte\" existeix",
"Mobile" => "Mòbil",
"Currently only shows switch to and from mobile mode" => "Actualment només mostra interruptor cap i des de la manera mòbil",
"To Label" => "Com etiquetar",
"Switch to normal site label" => "Canvieu al l'etiqueta lloc normal,",
"From Label" => "Segons l'etiqueta",
"Switch to mobile site label" => "Canviar a l'etiqueta de lloc mòbil",
"Switch Perspective" => "Canvi de Perspectiva",
"Also switch perspective back to this one when leaving mobile mode" => "També canvia la perspectiva de nou a aquest al sortir de manera mòbil",
"Stay" => "Romandre",
"Stay on same page" => "Romandre a la mateixa pàgina",
"Switch to mobile site" => "Canvia a vesió de mòbil",
"Switch to normal site" => "Canvia a vesió normal",
"Months Links" => "Months links (Arxiu per mesos)",
"Link to articles or blog posts for the current month and those preceding it" => "Enllaç als articles o entrades de bloc per al mes en curs i les que la van precedir",
"Type of objects to link to" => "Tipus d'objectes per lligar-se a",
"Possible values" => "Els valors possibles",
"\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" per publicacions de bloc, \"cms\" per articles publicats",
"Object Identifier" => "Identificador d'objecte",
"Identifier of an object with children to link to" => "Identificador d'un objecte amb nens per lligar-se a",
"This is required for the blog Object type" => "Això és necessari per al tipus d'objecte blocs",
"For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "Per exemple, un identificador de 3 i un tipus d'objecte blocs mostraran els enllaços a les entrades del bloc al bloc amb identificador març",
"List by month" => "Arxiu mensual",
"Most Commented" => "Més comentats/des",
"Display the most commented objects of a certain type" => "Mostra els objectes més comentats d'un cert tipus",
"Type of objects to consider" => "Tipus d'objectes a considerar",
"Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Valors possibles: de wiki (pàgines Wiki), bloc (blog), article (els articles)",
"Language Filter" => "Idioma filtre",
"If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "Si s'estableix en una etiqueta RFC1766 llenguatge, restringeix els objectes considerats aquells en l'idioma especificat",
// "Request the creation of a mustread item based on the current object" => "Request the creation of a mustread item based on the current object",
// "Object Field" => "Object Field",
// "Permanent name of the field containing the object reference" => "Permanent name of the field containing the object reference",
// "Notifications Link" => "Notifications Link",
// "Shows an icon with the number of and a link to user notifications" => "Shows an icon with the number of and a link to user notifications",
"Pending Article Submissions" => "Enviaments d'Articles Pendents",
"Displays the number of article submissions waiting examination and a link to the list" => "Mostra el nombre d'articles presentats examen d'espera i un enllaç a la llista",
"Old Articles" => "Articles antics",
"Displays the specified number of old articles (which do not show on articles home page anymore)" => "Mostra el nombre especificat de vells articles (que no es mostren a la pàgina principal d'articles més)",
// "Package Module" => "Package Module",
// "A module that shows content from a Tiki Package View" => "A module that shows content from a Tiki Package View",
// "Name of package (vendor/name)" => "Name of package (vendor/name)",
// "Name of package in the form vendor/name" => "Name of package in the form vendor/name",
// "Name of the view file without the .php" => "Name of the view file without the .php",
// "Other parameters" => "Other parameters",
// "URL encoded string of other parameters (will not replace standard parameters)" => "URL encoded string of other parameters (will not replace standard parameters)",
"Payments Outstanding" => "Els pagaments pendents",
"Displays the payments outstanding for the current user" => "Mostrar els pagaments pendents per a l'usuari actual",
// "List of active permissions for current object" => "List of active permissions for current object",
"Enables to change current perspective" => "Permet canviar la perspectiva actual",
"Powered By" => "Potenciat Per",
"Powered by Tiki, and others" => "Potenciat per Tiki, i altres",
"Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Mostra el missatge \"Powered by Tiki Wiki CMS Groupware\"",
"Tiki version info" => "Tiki version info",
"Shows theme credits (contents of credits.tpl)" => "Mostra els crèdits del tema (contingut de credits.tpl)",
"Shows various \"powered by\" icons" => "Mostra diferents \"powered by\" icones",
"Quick Edit" => "Edició Ràpida",
"Enables to quickly create or edit Wiki pages" => "Permet crear o editar ràpidament pàgines Wiki",
"Deprecated - use the Search module instead" => "Desaprovat - utilitzar el mòdul de cerca en lloc",
"Template identifier" => "Identificador de plantilla",
"If set to a template identifier, the specified template is used for creating new Wiki pages" => "Si s'estableix en un identificador de plantilla, la plantilla especificat s'utilitza per a la creació de noves pàgines Wiki",
"If set, send the form to the given location (relative to Tiki's root) for processing" => "Si s'estableix, envieu el formulari al lloc donat (relatiu a l'arrel del Tiki) per al processament de",
"SUBMIT label" => "ENVIAR etiqueta",
"The label on the button to submit the form" => "L'etiqueta al botó per enviar el formulari",
"Create/Edit" => "Crea/edita",
"INPUT SIZE" => "MIDA D'ENTRADA",
"Size attribute (horizontal, in characters) of the text input field for page names" => "Qualitat Grandària (horitzontal, en caràcters) del camp d'entrada de text per als noms de pàgina",
"Optional heading to display at the top of the module's content" => "Opcional encapçalat per mostrar a la part superior dels continguts del mòdul",
"Category to preselect" => "Categoria de preselecció",
"If set, pages created through the module have this category prechecked to be categorized in" => "Si s'estableix, les pàgines creades a través del mòdul tenen aquesta categoria preseleccionada per a ser-hi classificats en ella",
"Tip to be shown" => "Suggeriment que es mostra",
"Custom text to be shown as a tip at the top of the edit page" => "Text que es mostra com una punta a la part superior de la pàgina d'edició",
"Title of tip to be shown" => "Títol de la punta que es mostra",
"Custom title to be shown for the tip at the top of the edit page" => "Títol propi que es mostra per la punta a la part superior de la pàgina d'edició",
"Custom header template" => "Plantilla de capçalera personalitzat",
"Wiki page to be used as a template to show content on top of edit page" => "Pàgina Wiki per a ser utilitzat com a plantilla per mostrar el contingut a la part superior de la pàgina d'edició",
"Quick Edit a Wiki Page" => "Crea/Edita pàgina Wiki",
"Quick Search" => "Cerca Ràpida",
"Performs a search query and persists the results in the module for quick navigation access" => "Realitza una consulta de cerca i persisteix el resultat en el mòdul d'accés de navegació ràpida",
"Filter object type" => "Tipus d'objecte Filter",
"Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limitar els resultats de la cerca a un tipus d'objecte específic. Introduïu un tipus d'objecte d'utilitzar un filtre estàtic o escriptura \"selector\" per proporcionar una entrada",
"Filter category" => "Categoria de filtre",
"Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls" => "Limitar els resultats de la cerca a una categoria específica. Introduïu la llista separada per comes d'identificadors de categories per incloure en el selector. Categoria individual es mostrarà cap control",
"Quick Administration" => "Administració ràpida",
// "Some helpful tools for administrators" => "Some helpful tools for administrators",
"Random Image" => "Imatge aleatòria",
"Displays a random image" => "Mostra una imatge aleatòria",
"If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "Si s'estableix en una galeria d'imatges identificador, restringeix les imatges escollides a les de la galeria identificat",
"Show link" => "Mostra dades de contacte",
"If set to \"n\", the image thumbnail does not link to the image" => "Si s'estableix a \"n\", la miniatura de la imatge no es vincula a la imatge",
"Default: \"y\"" => "Per omissió : \"y\"",
"Show name" => "Mostrar nom",
"If set to \"y\", the name of the image is displayed" => "Si s'estableix a \"y\", es mostra el nom de la imatge",
"If set to \"y\", the description of the image is displayed" => "Si s'estableix a \"y\", es mostra la descripció de la imatge",
"Random Pages" => "Pàgines a l'atzar",
"Displays the specified number of random wiki pages" => "Mostra el nombre especificat de pàgines wiki atzar",
"New User Registration" => "Registre d'un Nou Usuari",
"Permit anonymous visitors to create an account on the site" => "Permetre que els visitants anònims per crear un compte en el lloc",
"News Feeds" => "Notícies externes",
"List of feeds available on this site" => "Llista dels feeds disponibles en aquest lloc",
"Multi-purpose search module (go or edit page by name and/or search site)" => "Mòdul de cerca multiusos (anar o editar la pàgina pel seu nom i / o el lloc de cerca)",
"Legacy Mode" => "Legacy Mode",
"Setting to emulate previous behaviour" => "Configuració d'emular el comportament anterior",
"If set to \"y\" the search performed is a \"Tiki search\"" => "Si s'estableix a \"y\" la cerca realitzada és un \"search Tiki \"",
" (full text search)" => " (cerca de text complet)",
"Show Object Type Filter" => "Mostra Filtre de Tipus d'objecte",
"If set to \"y\" shows a dropdown of sections to search" => "Si s'estableix a \"y\" mostra una llista desplegable de les seccions per buscar",
" (no object filter)" => " (sense filtre d'objecte)",
"Use autocomplete" => "Utilitza automàtic",
"If set to \"y\" input uses autocomplete for pagenames if applicable" => "Si s'estableix a input \"y\" utilitza automàtic per noms de pàgines si escau",
" (use autocomplete)" => " (utilitza l'autocompleció)",
"Advanced search" => "Cerca advançada",
"Use advanced (boolean) search (full text search only)" => "Utilitza cerca avançada (booleana; només en cerques a text complet)",
" (use advanced search)" => " (utilitza la cerca avançada)",
"Advanced search checkbox" => "Casella de cerca avançada",
"Show advanced search checkbox (full text search only)" => "Mostra casella de cerca avançada (només en cerques a text complet)",
" (advanced search checkbox off)" => " (casella de cerca avançada desactivada)",
"Advanced search help" => "Buscar ajuda Avançada",
"Show advanced search help icon (full text search only)" => "Mostra icona d'ajuda de cerca avançada (només en cerques a text complet)",
" (advanced search help off)" => " (ajuda de la cerca avançada desactivada)",
"Show Search Button" => "Mostra Botó de cerca",
"Show search button" => "Mostra el botó de cerca",
" (do show search button)" => "(mostra el botó de cerca)",
"Show Go Button" => "Mostrar el Botó d'Anar-hi",
"Show go to page button" => "Mostra anar al botó de pàgina",
" (do show go button)" => " (No mostrar el botó anar)",
"Show Edit Button" => "Mostra botó d'edició",
"Show edit button" => "Mostra botó d'edició",
" (do show edit button)" => " (mostra el botó d'edició)",
"Default Button" => "Botó per omissió",
"Action to perform on entering <return>" => "Acció a realitzar en entrar <return>",
" (search|go|edit)" => " (cerca|ves|edita)",
"Search Form Action" => "Formulari de cerca d'Acció",
" tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php o tiki-searchindex.php (per cercar al Tiki)",
// "Search Submit Label" => "Search Submit Label",
"Go Form Action" => "Anar Formulari d'acció",
// "Go Submit Label" => "Go Submit Label",
"Go" => "Fes-ho",
"Edit Form Action" => "Edita Formulari d'acció",
"Edit Submit Label" => "Edita Enviar Label",
"Input field width" => "Ample del camp d'entrada",
"Width of the text input field (in characters)" => "Ample del camp d'entrada de text (en caràcters)",
" 0 (leave automatic width)" => " 0 (deixa amplada automàtica)",
"Select size" => "Seleccioneu la mida",
"Size of the Search Filter dropdown list" => "La mida de la llista desplegable Filtre de cerca",
"Edit Template identifier" => "Edita identificador de plantilla",
"If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "Si s'estableix en un identificador de categoria, les pàgines creades a través del mòdul es classifiquen automàticament en la categoria especificada",
"Compact mode" => "Mode Compacte",
"Makes the three buttons only appear on mouse-over" => "Fa que els tres botons només apareixen el ratolí sobre",
// "Additional filters" => "Additional filters",
// "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test" => "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test",
"Search is disabled" => "La cerca es troba desactivada",
"Search for Wiki Page" => "Cercar Pàgina Wiki",
// "More Like This" => "More Like This",
// "Uses the unified search to provide similar documents" => "Uses the unified search to provide similar documents",
// "Object Type Filters" => "Object Type Filters",
// "Comma-separated types to allow" => "Comma-separated types to allow",
// "Text Search Filters" => "Text Search Filters",
// "Comma-separated text search filters to use. Use \"=\" to separate field and value" => "Comma-separated text search filters to use. Use \"=\" to separate field and value",
// "Object id of item you want to get similar items to" => "Object id of item you want to get similar items to",
// "The object id of the item. If none is provided, Tiki will attempt to resolve the current object" => "The object id of the item. If none is provided, Tiki will attempt to resolve the current object",
// "Object type of item you want to get similar items to" => "Object type of item you want to get similar items to",
// "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object" => "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object",
"Search For a Wiki Page" => "Cerca una Pàgina Wiki",
"Search for a wiki page by name" => "Cerca d'una pàgina wiki per nom",
"Exact match checkbox checked by default if set to \"y\"" => "En cas afirmatiu (y), la casella de coincidència exacta apareixerà marcada per omissió",
"Semantic Links" => "Enllaços semàntics",
"List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Enumereu les relacions conegudes de la pàgina Wiki mostrada. Per a cada tipus de relació que figura a la pàgina, es mostren totes les pàgines a les que enllaça o des de les quals hi és enllaçada",
"Links for sharing, reporting etc" => "Enllaços per compartir, informar, etc",
"Report" => "Informe",
"Report to Webmaster" => "Informa als administradors web",
"Share this page" => "Comparteix aquesta pàgina",
"Use icons for report, share and email links" => "Utilitza les icones d'enllaços informe, compartir i correu electrònic",
"Show Facebook \"Like\" button on the current page" => "Mostra Facebook botó \"com\" a la pàgina actual",
"Facebook: URL" => "Facebook: URL",
"URL to \"Like\" (leave blank for current URL)" => "URL de \"Like\" (deixar en blanc per a URL actual)",
"Facebook: Send" => "Facebook: Enviar",
"Show Facebook \"Send\" button" => "Botó Mostra Facebook \"Envia \"",
"Facebook: Layout" => "Facebook: Layout",
"Size, layout and amount of social context" => "Mida, disposició i quantitat de context social",
"Facebook: Width" => "Facebook: Ample",
"Facebook: Height" => "Facebook: Alçada",
"Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Alçada de l'envàs en unitats de CSS (per exemple, \"120px\" o \"2em \")",
"Facebook: Show Faces" => "Facebook: Mostra Cares",
"Show pictures of others who like this" => "Veure fotos d'altres persones que els agrada",
"Facebook: Verb" => "Facebook: Verb",
"Verb to display in button" => "Verb que es mostrarà al botó",
"Facebook: Colors" => "Facebook: Colors",
"Color scheme" => "Combinació de colors",
"Facebook: Font" => "Facebook: Font",
"Font to display" => "Font per mostrar",
"Facebook: Locale" => "Facebook: Locale",
"Locale in the format ll_CC (default \"en_US\")" => "Locale al ll_cc format (per omissió \"en_US\")",
"Facebook: Referrals" => "Facebook: Referits",
"Label for tracking referrals (optional)" => "Etiqueta per al seguiment de les referències (opcional)",
"Facebook: App Id" => "Facebook: App Id",
"ID of your Facebook app (optional)" => "ID de l'aplicació de Facebook (opcional)",
"Show Twitter Follow Button on the current page" => "Mostra Twitter Follow Button a la pàgina actual",
"Twitter: User Name" => "Twitter: Nom d'usuari",
"Twitter user name to quote as \"via\"" => "Nom d'usuari de Twitter per citar com \"a través de\"",
"Twitter: Label" => "Twitter: Label",
"Text to display. Default \"Tweet\"" => "Text a mostrar. Per defecte \"Tweet \"",
"Twitter: URL" => "Twitter: URL",
"URL to \"Tweet\" (leave blank for current URL)" => "URL per \"Tweet\" (deixar en blanc per a URL actual)",
"Twitter: Show Count" => "Twitter: Show Comte",
"Position of Tweet count" => "Posició del Tweet recompte",
"Twitter: Language" => "Twitter: Idioma",
"Two letter language code" => "Codi de dos lletres",
"Twitter: Width" => "Twitter: Ample",
"Width in pixels or percentage (e.g. 300px)" => "Ample en píxels o en percentatge (per exemple, 300px)",
"Twitter: Height" => "Twitter: Alçada",
"Twitter: Text" => "Twitter: Text",
"Tweet text (leave empty to use page title" => "Text del Tweet (Deixar en blanc per utilitzar títol de la pàgina",
"LinkedIn" => "LinkedIn",
"Linked in share button" => "Enllaçat al botó de compartir",
"LinkedIn: URL" => "LinkedIn: URL",
"URL to share (leave blank for current URL)" => "URL per compartir (deixar en blanc per a URL actual)",
"LinkedIn: Count Mode" => "LinkedIn: mode de recompte",
"Position of count" => "Posició del recompte",
"Google +1" => "Google +1",
"Google +1 button" => "Botó de Google +1",
"Google: Size" => "Google: Mida",
"Google button size" => "Mida del botó Google",
"Google: Annotation" => "Google: Anotació",
"Google annotation" => "Google anotació",
"Google: Language" => "Google: Idioma",
"Google language" => "Llenguatge de Google",
"Google: URL" => "Google: URL",
// "Creates or shows a short url for the visiting page" => "Creates or shows a short url for the visiting page",
"The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent." => "La xerrada és una eina de missatgeria ràpida. Missatges recarreguen cada vegada que la pàgina canvia. Qualsevol persona que tingui els permisos adequats poden veure tots els missatges. Una altra permís permet enviar missatges",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
"Label on the button to post a message" => "Etiqueta al botó per enviar un missatge",
"Wait label" => "Esperi etiqueta",
"Label on the button to post a message when the message is being posted if AJAX is enabled" => "Etiqueta al botó per enviar un missatge quan es va registrar el missatge si AJAX està habilitada",
"Please wait.." => "Si us plau espera..",
"Maximum messages shown" => "Màxim missatges mostrats",
"Number of messages to display" => "Nombre de missatges per mostrar",
"Tweet" => "Tweet",
"If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "Si s'estableix a \"1\" i l'usuari ens ha autoritzat als missatges tweet amb Twitter, l'usuari pot decidir si vol cridar a través de Twitter",
"If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "Si s'estableix a \"1\" i l'usuari ens ha autoritzat a Facebook, l'usuari pot decidir si vol afegir el crit al seu mur de Facebook",
"Since Last Visit (Simple)" => "Des de la Darrera Visita (Simple)",
"Displays to logged-in users the number of new or updated objects since their last login date and time" => "Mostra als usuaris registrats el nombre d'objectes nous o actualitzats des de l'última data i l'hora d'inici de sessió",
"Since your last visit" => "Des de la teva última visita",
"Since Last Visit" => "Des de la Darrera Visita",
"Displays to logged-in users new or updated objects since a point in time, by default their last login date and time" => "Mostra als usuaris registrats objectes nous o actualitzats des d'un punt en el temps, per omissió l'última data i l'hora d'inici de sessió",
"Show users" => "Mostrar els usuaris",
"If set to \"n\", do not show new users" => "Si s'estableix a \"n\", no mostren els nous usuaris",
"If set to \"n\", do not show tracker changes" => "Si s'estableix a \"n\", no mostren canvis un formulari-bd",
"Calendar focus" => "Enfocament Calendar",
// "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar",
"Show date as a calendar link" => "Mostrar la data com un vincle de calendari",
"If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "Si s'estableix a \"n\", no afegir un enllaç al calendari tiki en la data en la capçalera (fins i tot si s'estableix el calendari de característiques)",
"Fold sections by default" => "Seccions Doblega per omissió",
"If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "Si s'estableix a \"y\", dobla automàticament les seccions i mostrar només el títol (l'usuari ha de fer clic a cada secció per veure els detalls de les modificacions)",
// "Use tabbed presentation" => "Use tabbed presentation",
// "If set to \"y\", use Bootstrap tabs to show the result" => "If set to \"y\", use Bootstrap tabs to show the result",
"Minimum timespan" => "Interval de temps mínim",
"Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "En lloc de l'última hora de l'entrada, tornar aquest temps mínim, s'especifica en el dia, en el cas de l'última hora d'entrada és més recent",
"Maximum comment length" => "Longitud màxima del comentari",
"Changes since" => "Canvis des de",
"Since your last visit.." => "Desde la teva darrera visita..",
"In the last %0 days.." => "En els darrers %0 dies..",
"new comments" => "comentaris nous",
" (archived)" => " (archivat)",
"new posts" => "noves publicacions",
"wiki pages changed" => "pàgines del wiki modificades",
"new articles" => "articles nous",
"new FAQs" => "Noves FAQs",
"new blogs" => "nous blocs",
"new blog posts" => "noves publicacions de bloc",
"new image galleries" => "noves galeries d'imatge",
"new images" => "imatges noves",
"new file galleries" => "noves galeries de fitxers",
"new files" => "arxius nous",
"new polls" => "sondejos nous",
"new users" => "usuaris/es nous/ves",
"new tracker items" => "nous ítems del formulari",
"updated tracker items" => "ítems de formularis-db actualitzats",
// "new calendars" => "new calendars",
// "new events" => "new events",
// "starting on" => "starting on",
"If comments don't use titles this sets the maximum length for the comment snippet" => "Si els comentaris no utilitzen títols aquest estableix la longitud màxima del comentari snippet",
"SVN Up Info" => "SVN Up Info",
"SVN Version and last update information" => "SVN versió i l'última informació d'actualització",
"Switch Language" => "Canvia l'Idioma",
"Displays a language picker to change the language of the site" => "Mostra un selector d'idioma per canviar l'idioma del lloc",
"Display mode" => "Mode de visualització",
"Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Canvis com es mostra la llista d'idiomes. Els valors possibles són llista desplegable, banderes i paraules. Valors predefinits de llista desplegable",
// "Switch Admin Language" => "Switch Admin Language",
// "Displays a language picker to change the language of admin site" => "Displays a language picker to change the language of admin site",
"Switch Theme" => "Canvia el Tema (d'estil)",
// "Enables to quickly change the theme for the user" => "Enables to quickly change the theme for the user",
// "Not allowed here" => "Not allowed here",
// "Displayed theme" => "Displayed theme",
"Admin Theme" => "Tema administració",
"Terminology" => "Terminologia",
"Support for multilingual terminology" => "Suport a la terminologia multilingüe",
"Root category" => "Categoria Arrel",
"All terms will automatically be put in that category. " => "Tots els termes seran automàticament posats en aquesta categoria.",
"Note that the category must already exist. " => "Tingueu en compte que la categoria ja ha d'existir.",
"Defaults to 'Term'" => "Per omissió és 'Term'",
"Tiki Tests" => "Proves de Tiki",
"Tiki test suite helper" => "Tiki Test Suite ajuda",
"Most Active blogs" => "Blocs més actius",
"Displays the specified number of blogs with links to them, from the most active one to the least" => "Mostra el nombre especificat de blocs amb enllaços a ells, des del més actiu almenys",
"Blog activity measurement can be more or less accurate" => "Bloc de mesura de l'activitat pot ser més o menys precisa",
"Lists the specified number of articles with links to them, from the most visited one to the least" => "Mostra el nombre especificat d'articles amb enllaços a ells, des del més visitat almenys",
"Top Blog Posters" => "Bloc Top Posters",
"Displays the specified number of users who posted to blogs, starting with the one having most posts" => "Mostra el nombre específic d'usuaris que publiquen en blogs, començant pel que té la majoria dels missatges",
"Limit to a blog" => "Limitar a un bloc",
"Top File Galleries" => "Galeria d'arxius principals",
"Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Mostra el nombre especificat de galeries d'arxius amb enllaços a ells, començant pel que té la majoria dels èxits",
"Top Files" => "Top Arxius",
"Displays the specified number of files with links to them, starting with the one with most hits" => "Mostra el nombre especificat d'arxius amb enllaços a ells, començant pel que té la majoria dels èxits",
"Top Forum Posters" => "Els publicadors de Fòrums més actius",
"Displays the specified number of users who posted to forums, starting with the one having most posts" => "Mostra el nombre específic d'usuaris que publiquen en fòrums, començant pel que té la majoria dels missatges",
"Top Image Galleries" => "Top Galeries d'imatges",
"Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Mostra el nombre especificat de galeries d'imatges amb enllaços a ells, començant pel que té la majoria dels èxits",
"Top Images" => "Imatges per dalt",
"Displays the specified number of images with links to them, from the most visited one to the least" => "Mostra el nombre especificat de les imatges amb enllaços a ells, des del més visitat almenys",
"Top Objects" => "Objects més actius",
"Displays the specified number of objects, starting with the one having the most hits" => "Mostra el nombre especificat d'objectes, a partir de la que té la majoria dels accessos",
"Top Pages" => "Pàgines per dalt",
"Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Mostra el nombre de pàgines wiki amb enllaços a ells, començant pel que té la majoria dels cops",
"Top Quizzes" => "Qüestionaris principals",
"Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Mostra el nombre especificat de concursos amb enllaços a ells, començant pel que té la majoria dels cops",
"Top Visited Blogs" => "Blocs més visitats",
"Display the specified number of blogs with links to them, from the most visited one to the least" => "Mostra el nombre especificat de blocs amb enllaços a ells, des del més visitat almenys",
"Show Last Post" => "Mostra Darrer missatge",
"Top Visited FAQs" => "Top Visitat FAQs",
"Display the specified number of FAQs with links to them, from the most visited one to the least" => "Mostra el nombre especificat de preguntes freqüents amb enllaços a ells, des del més visitat almenys",
"Tracker Input" => "Formulari-bd d'entrada",
"Allows a dialog to be opened to create new tracker items" => "Permet obrir un quadre de diàleg per crear nous elements del registre",
"Tracker ID to render" => "Formulari-bd de ID per fer",
"Text Input" => "L'entrada de text",
"Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Camps múltiples del text a mostrar com a part del formulari principal, amb l'etiqueta. Els noms de camp s'assignen als noms permanents en les definicions de camp del formulari-bd. ex: nombreGrupo (Nom de grup) relatedTask (tasques)",
"Location Field" => "Ubicació Camp",
"Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtenir les coordenades d'un mapa proper i els envia al camp d'ubicació. A més del nom de camp,: marcador o: finestra gràfica es poden utilitzar com el sufix. Per omissió és: marcador",
"Capture StreetView" => "Captura StreetView",
"Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Incloure un botó a la interfície StreetView per crear elements del registre de la ubicació. Per pujar la imatge des del paràmetre URL i ubicació",
"Alter the submit button label" => "Canvieu l'etiqueta del botó d'enviament",
"Operation to perform on success" => "Operació a realitzar en cas d'èxit",
"Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operació a realitzar en el següent format: operationName (argument). Les operacions actuals es redirigeixen a la plantilla d'URL com a argument. @ @ ValueName serà reemplaçat pel valor apropiat en què Itemid valueName, estat o un nom permanent",
"Mode change on complete" => "Canvi de mode de completa",
"Target mode to enter after dialog closes" => "La manera Target per entrar després del tancament de diàleg",
"Tracker Help" => "Formulari-bd Ajuda",
"Display the fields of a tracker (name and identifier)" => "Mostra els camps d'un (nom i identificador) Formulari-bd (Tracker)",
"Text field height" => "Alçada del camp de text",
"Number of lines" => "Nombre de línies",
"Text field width" => "Ample del camp de text",
"Number of characters" => "Nombre de caràcters",
"Translate Updates" => "Actualitzacions de traduccions",
"Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Els enllaços a versions de la pàgina wiki que s'està veient en altres idiomes, distingint entre les traduccions millor, equivalents o pitjors. Opcionalment mostra en ell l'actualitat de la traducció que s'està veient",
"Reference language" => "Idioma referència",
"If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "Si s'estableix en un codi d'idioma, restringeix les pàgines traduïdes es mostren a la pàgina de referència, llevat que s'estigui visualitzant la pàgina",
"Show language" => "Mostra idioma",
"If \"y\" the page language will be shown instead of the page name" => "Si \"y\" es mostrarà \\ l'idioma de la pàgina en comptes del nom de la pàgina",
"Default = \"y\"" => "Per omissió = \"y\"",
"Tweets" => "Tweets",
"Shows the tweets from the Twitter timeline of a user" => "Mostra els tweets de la línia de temps de Twitter d'un usuari",
"Tiki user to show Twitter timeline of" => "Tiki usuari per mostrar la línia de temps de Twitter",
"Show public|friends timeline. " => "Mostra la línia de temps pública dels amics",
// "Search string" => "Search string",
"user not registered with twitter" => "usuari no s'ha registrat al Twitter",
"Lists the specified number of calendar events, ordered by their start date" => "Mostra el nombre específic d'esdeveniments de calendari, ordenats per la seva data d'inici",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "Si s'estableix a una llista d'identificadors de calendari, restringeix els esdeveniments als quals en els calendaris identificats. Els identificadors estan separats per barres verticals (\"|\"), comes (\",\") o dos punts (\":\")",
"Maximum days in the future" => "Capacitat màxima de dies en el futur",
"Maximum distance to event start dates in days (looking forward)" => "La distància màxima per a les dates d'inici de l'esdeveniment en dies (ganes)",
"Maximum days in the past" => "Capacitat màxima de dies en el passat",
"Maximum distance to event end dates in days (looking backward)" => "Distància màxima de les dates de finalització de l'esdeveniment en dies (mirant cap enrere)",
"cellpadding" => "cellpadding",
"If set to an integer, apply this cellpadding to the HTML table generated" => "Si s'estableix en un enter, s'apliqui aquest cellpadding la taula HTML generada",
"cellspacing" => "cellspacing",
"If set to an integer, apply this cellspacing to the HTML table generated" => "Si s'estableix en un enter, s'apliqui aquest espaiat de cel·la a la taula HTML generada",
"If set to \"y\", event descriptions are displayed" => "Si a \"y\", es mostren les descripcions d'esdeveniments setembre",
"Show end date and time" => "Mostra la data i hora finals",
"If set to \"y\", event end dates and times are displayed, when appropriate" => "Si s'estableix a \"y\", dates i hores de finalització de l'esdeveniment es mostren, si escau, quan sigui apropiat",
"Use custom calendar background colors" => "Utilitza colors de fons personalitzats per al calendari",
"If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "Si s'estableix a \"y\", els esdeveniments es mostren amb color de fons personalitzat del seu calendari (si s'ha establert)",
"Show information in tooltips" => "Mostra informació sobre eines",
"If set to \"n\", event tooltips will not display event information" => "Si s'estableix a \"n\", informació sobre eines d'esdeveniments no es mostrarà la informació de l'esdeveniment",
"Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Donar format a utilitzar per a la majoria de les dates. Vegeu <a href=\"http://www.php.net/manual/en/function.strftime.php\">Documentació strftime()</a>",
"site preference for short date format followed by site preference for short time format" => "preferència de lloc per al format de data curta seguida de preferència lloc per al format de temps curt",
"If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "Si s'estableix en un enter, noms esdeveniment poden aquest nombre de caràcters, com a màxim, abans de ser truncada",
"My Blogs" => "Els meus Blocs",
"Displays to registered users their blogs" => "Mostra als usuaris registrats seus blocs",
"My Bookmarks" => "Els meus Favorits",
"Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Interfície lleuger a favorits de l'usuari, permetent veure-les de manera concisa, fer algunes manipulacions i marcar la pàgina que s'està veient",
"My Image Galleries" => "Els meus Galeries d'imatges",
"Displays to registered users their image galleries" => "Mostra als usuaris registrats a les seves galeries d'imatges",
"User Pages" => "Pàgines de l'usuari",
"Displays to registered users the specified number of wiki pages which they were the last to edit" => "Mostra als usuaris registrats el nombre especificat de pàgines wiki que van ser els últims a editar",
"My Pages" => "Les meves pàgines",
"My Tasks" => "Les meves tasques",
"Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Interfície lleuger per a les tasques de l'usuari, el que permet veure-les de manera concisa i fer algunes manipulacions",
"The task title must have at least 3 characters" => "El títol de la tasca ha de tenir com a mínim 3 caràcters",
"Public Tasks" => "Tasques Públiques",
"Lists the public user tasks of a chosen group, with links to tasks" => "Enumera les tasques d'usuari públiques d'un grup seleccionat, amb enllaços a les tasques",
"User-Group Tracker" => "Formulari-bd d'usuari-Group",
"User and Group tracker links" => "Usuari i de grup formulari-bd enllaços",
// "Users List" => "Users List",
// "Display a list of users with optional extra information from each" => "Display a list of users with optional extra information from each",
"Login" => "Connecta't",
// "Show the user name" => "Show the user name",
"y|n" => "s|n",
// "Show the user real name" => "Show the user real name",
"Last Login" => "Darrera Connexió",
// "Show the last login date" => "Show the last login date",
// "Show the direct and included groups a user belongs to" => "Show the direct and included groups a user belongs to",
// "Show the user profile picture" => "Show the user profile picture",
// "Show a link to the userPage" => "Show a link to the userPage",
// "Log" => "Log",
// "Show a link to the user logs(feature actionlog must be activated)" => "Show a link to the user logs(feature actionlog must be activated)",
// "Show only the users of the group" => "Show only the users of the group",
// "Groupname" => "Groupname",
// "Included Groups" => "Included Groups",
// "Show only the users of the group group and of a group including group" => "Show only the users of the group group and of a group including group",
// "initial" => "initial",
// "Show only the users whose name begins with the letter" => "Show only the users whose name begins with the letter",
// "a letter" => "a letter",
// "heading" => "heading",
// "Show the table heading" => "Show the table heading",
// "Sort users in ascending or descending order using these values: " => "Sort users in ascending or descending order using these values: ",
"My Score" => "La meva puntuació",
"Display the logged user's rank and score" => "Mostra la posició de l'usuari connectat i la puntuació",
"Most Active Users" => "Usuaris més actius",
"Display the specified number of users and their score, starting from the one with the highest score" => "Mostra el nombre especificat d'usuaris i la seva puntuació, a partir de l'una amb la puntuació més alta",
// "websearch" => "websearch",
// "Displays a simple form to perform a web search with choice on multiple search engines" => "Displays a simple form to perform a web search with choice on multiple search engines",
"Related Items" => "Articles relacionats",
"Lists objects which share a category with the viewed object" => "Llista d'objectes que comparteixen una categoria amb l'objecte vist",
"Online Users" => "Usuaris connectats",
"Display information about users currently logged in" => "Mostra informació sobre els usuaris actualment connectats en",
"Display the number of users logged in, the list of users logged in, or both" => "Mostra el nombre d'usuaris connectats, la llista d'usuaris connectats, o tots dos",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
"Cluster Mode" => "Clúster Mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Silent Mode" => "Silent Mode",
// "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it" => "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it",
"Newest Comments" => "Nous comentaris",
"Lists the specified number of comments starting from the most recently posted" => "Mostra el nombre especificat dels comentaris a partir del més recent publicat",
"More in tooltips" => "Més informació sobre eines a",
"If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "Si s'estableix a \"y\", el nom de l'objecte en el qual es fa un comentari que no es mostra en el quadre de mòdul, sinó que es movia en la informació sobre eines de l'article",
"Type of the objects from which comments will be listed. Possible values" => "Tipus dels objectes dels quals s'enumeren els comentaris. Els valors possibles",
"Display user profile pictures instead of numbers" => "Mostra avatars d'usuari en lloc de nombres",
"Comments about objects in this language only" => "Comentaris sobre els objectes en aquest llenguatge només",
"Last article comments" => "Darrers comentaris d'articles",
"Last wiki comments" => "Darrers comentaris de pàgines wiki",
// "Hold a chat session using XMPP (uses the ConverseJS client)" => "Hold a chat session using XMPP (uses the ConverseJS client)",
// "XMPP" => "XMPP",
"Displays YouTube videos and/or a link to a YouTube user's page" => "Mostra vídeos de YouTube i / o un enllaç a la pàgina d'un usuari de YouTube",
"Video identifiers" => "Identificadors de vídeo",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
"YouTube user identifier" => "Identificador d'usuari de YouTube",
"If set to a YouTube user identifier, display a link to the videos of this user" => "Si s'estableix en un identificador d'usuari de YouTube, mostra un enllaç als vídeos d'aquest usuari",
"Videos on YouTube" => "Vídeos a YouTube",
// "Module Zone" => "Module Zone",
// "Can contain other modules so can be used as a Bootstrap navbar object, for example" => "Can contain other modules so can be used as a Bootstrap navbar object, for example",
// "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel" => "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel",
// "Example for a Bootstrap \"social\" navbar" => "Example for a Bootstrap \"social\" navbar",
"Bibliography Search" => "Bibliografia Cerca",
"Search the group's Zotero library for entries with the specified tags" => "Cerca a la biblioteca Zotero del grup per les entrades amb les etiquetes especificades",
"failure" => "fracàs",
"You do not have sufficient permissions to perform this action" => "No té permisos suficients per realitzar aquesta acció",
"Please enter Biblio Code" => "Si us plau, introdueixi el codi Biblio",
"Biblio code must not exceed 50 characters" => "Codi Biblio no ha de superar els 50 caràcters",
"success" => "èxit",
"Page not found. Please save the page first" => "Pàgina no trobada. Deseu la pàgina primera",
"This reference already exists in the library" => "Aquesta referència ja existeix a la biblioteca",
"Reference added to library" => "Es va agregar una referència a la biblioteca",
"This biblio code already exists" => "Aquest codi ja existeix biblio",
"Bibliography saved" => "Bibliografia guardat",
"Reference already exists" => "Referència ja existeix",
"Reference added" => "Referència afegir",
"Invalid server key" => "Clau del servidor invàlida",
"Invalid username or password" => "Usuari o contrasenya  no vàlids",
"Cookie not found" => "No s'ha trobat la galeta",
// "This user is your friend" => "This user is your friend",
// "You share the following groups with this user" => "You share the following groups with this user",
// "Unlike" => "Unlike",
// "There is no activity to display in this stream" => "There is no activity to display in this stream",
// "%0 %1" => "%0 %1",
// "%0 posted a comment to" => "%0 posted a comment to",
// "%0 started a new discussion" => "%0 started a new discussion",
// "Join the discussion" => "Join the discussion",
// "%0 replied to a thread" => "%0 replied to a thread",
// "%0 corrected a message" => "%0 corrected a message",
// "%0 requested an action from you" => "%0 requested an action from you",
// "%0 triggered your %1 priority saved filter" => "%0 triggered your %1 priority saved filter",
// "Critical Priority" => "Critical Priority",
// "See your saved filter" => "See your saved filter",
// "High Priority" => "High Priority",
// "Low Priority" => "Low Priority",
// "Recommended Reading" => "Recommended Reading",
// "Based on your previous activity, we believe you might find this useful" => "Based on your previous activity, we believe you might find this useful",
// "Was this useful" => "Was this useful",
// "Help us improve" => "Help us improve",
// "%0 created a tracker" => "%0 created a tracker",
// "%0 created a tracker item" => "%0 created a tracker item",
// "%0 modified a tracker item" => "%0 modified a tracker item",
// "%0 has added %1 to his stream" => "%0 has added %1 to his stream",
// "%0 is now followed by %1" => "%0 is now followed by %1",
// "%0 and %1 became friends" => "%0 and %1 became friends",
// "%0 created a page" => "%0 created a page",
// "%0 modified a page" => "%0 modified a page",
// "View changes" => "View changes",
// "history" => "history",
// "Show More" => "Show More",
"Saving..." => "Estalvi ..",
"Adding.." => "Addició ..",
"References Available" => "Referències disponibles",
"Add to library" => "Afegeix a la biblioteca",
"Library References" => "Referències Biblioteca",
"Use" => "Ús",
"Edit Library References" => "Referències Biblioteca",
"Part" => "Part",
"URI" => "URI",
"Publisher" => "Editor",
"Enter the CSS class name to be added in the 'li' tag for listing this reference" => "Introduïu el nom de la classe CSS que s'afegeix al tag 'li' per a la inclusió d'aquesta referència",
"Enter template format in which you want to display the reference details in the bibliography listing. For example" => "Introduïu format de plantilla a la que voleu mostrar les dades de referència en la llista bibliogràfica. Per exemple",
"All the codes must be in lower case letters separated with spaces" => "Tots els codis han d'estar en minúscules separats per espais",
"Please save the page before creating the bibliography" => "Deseu la pàgina abans de la creació de la bibliografia",
"Preference Filters" => "Filtres de preferències",
// "basic" => "basic",
"Set as my default" => "Fixa com les meves per omissió",
"Provide Feedback" => "Proporciona Retroalimenació",
"Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them" => "Un cop seleccionat, es mostrarà una o més icones al costat de totes les característiques perquè puguis proporcionar alguna informació 'in situ' sobre elles",
"Icon for 'Like'" => "Icona per a 'M'agrada'",
"Icon for 'Fix me'" => "Icona per a 'Agrregla'm'",
"Icon for 'What is this for?'" => "Icona per a 'Per a què és això?'",
"Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)" => "Els teus vots s'enviaran en connectar-te amb mother.tiki.org (actualment només a través del botó 'Connectar > <strong>Enviar Info</strong>')",
"Click to read more" => "Fes clic aquí per llegir més",
"Rebuild Admin Index" => "Reconstrueix l'Índex d'Administració",
"Control Panels" => "Panells de Control",
"Search preferences" => "Preferències de Cerca",
"Configuration search" => "Cerca als panells de configuració",
"Note: The search index needs rebuilding, this will take a few minutes" => "Nota: L'índex de cerca necessita reconstrucció, això prendrà uns minuts",
"Preference Search Results" => "Resultats de cerca de preferències",
"Apply Changes" => "Aplica els canvis",
"Apply" => "Aplica",
"No results" => "Sense resultats",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Not what you expected? Try %0rebuilding%1 the preferences search index" => "Not what you expected? Try %0rebuilding%1 the preferences search index",
"Access" => "Accés",
"Users" => "Usuaris",
// "Banning" => "Banning",
"Directories" => "Directoris",
"External Feeds" => "Alimentacions externes",
"HTML Pages" => "Pàgines HTML",
// "Wiki Structures" => "Wiki Structures",
"System" => "Sistema",
// "Activity Rules" => "Activity Rules",
"Content Templates" => "Plantilles de contingut",
// "Languages" => "Languages",
"Mail Notifications" => "Notificacions per correu",
"Menus" => "Menús",
// "User Credits" => "User Credits",
"Transitions" => "Transicions",
"Plugin Approval" => "Aprovació d'Ús de Connectors",
"Mods" => "Mods",
"Tools" => "Eines",
"Action Log" => "Registre d'accions",
"Cookies" => "Galetes",
// "DSN/Content Authentication" => "DSN/Content Authentication",
// "Edit TPL" => "Edit TPL",
"External Pages Cache" => "Pàgines externa memòria cau",
"External Wikis" => "Wikis externa",
// "Importer" => "Importer",
// "PhpInfo" => "PhpInfo",
// "Referer Statistics" => "Referer Statistics",
// "Search Statistics" => "Search Statistics",
"Security Admin" => "Admin Seguretat ",
"Server Check" => "Comprovació del servidor",
// "Synchronize Dev" => "Synchronize Dev",
// "System Cache" => "System Cache",
// "System Logs" => "System Logs",
// "Sitemap" => "Sitemap",
"Wizards" => "Assistents",
"Cancel Edit" => "Cancel·la edició",
// "Banners listing" => "Banners listing",
"Activate the feature" => "Activeu la funció",
// "Site ads and banners" => "Site ads and banners",
// "Apply changes" => "Apply changes",
// "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>" => "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>",
// "List of articles" => "List of articles",
// "List of article types" => "List of article types",
"Article Types" => "Article Tipus",
// "List of article topics" => "List of article topics",
"General Settings" => "Configuracions Generals",
"Features" => "Funcionalitats",
// "Custom (Article Own) images setting" => "Custom (Article Own) images setting",
"Sharing on social networks" => "Compartir en xarxes socials",
"Import CSV file" => "Importeu un fitxer CSV",
"Batch upload (CSV file)" => "Pujada en bloc (arxiu CSV)",
"File format: title,authorName,heading,body,lang,user" => "Format d'arxiu: títol, authorName, encapçalat, cos, lang, l'usuari",
// "Articles Listing and View" => "Articles Listing and View",
"List articles" => "Llistar articles",
// "Article view" => "Article view",
// "Blogs listing" => "Blogs listing",
"Blogs Listings" => "Blocs Llistats",
// "Items to display" => "Items to display",
// "Calendars listing" => "Calendars listing",
"General settings" => "Paràmetres generals",
// "Categories listing" => "Categories listing",
// "Browse Categories" => "Browse Categories",
"Administration" => "Administració",
// "Administer Categories" => "Administer Categories",
// "Organize objects" => "Organize objects",
"Organize Objects" => "Organitzar objectes",
"Category objects" => "Objectes Categoria",
// "Re-apply last saved category defaults to wiki pages" => "Re-apply last saved category defaults to wiki pages",
"Performance" => "Rendiment",
// "Comments listing" => "Comments listing",
"Site-wide features" => "Característiques a nivell del Lloc",
"Display options" => "Opcions de visualització",
// "Annotations" => "Annotations",
"Using comments in various features" => "Ús de comentaris en diverses característiques",
// "Group Administration" => "Group Administration",
// "User Administration" => "User Administration",
// "Community Features" => "Community Features",
"Community" => "Comunitat",
// "Additional options" => "Additional options",
// "Social Interaction" => "Social Interaction",
// "Friendship and followers" => "Friendship and followers",
"Select which items to display when listing users" => "Seleccioneu els elements que voleu mostrar quan els usuaris anunci",
// "Activity stream" => "Activity stream",
"Tiki Connect" => "Connexió amb Tiki ('Tiki Connect')",
"Join the community" => "Uneix-te a la comunitat",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware és Programari Lliure i de Codi Obert (FOSS, de les seves sigles en anglès). És un projecte que el porta una comunitat que existeix i millora gràcies a la participació de gent com ara TU mateix",
"Join the Community" => "Uneix-te a la Comunitat",
"Tiki news" => "Novetats de Tiki",
"Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded feed RSS de info.tiki.org TOT, per la seva banda",
"Tiki Newsletter" => "Tiki Butlletí",
"Promote your site" => "Promoure el seu lloc",
"Add your site to the Tiki directory." => "Afegeixi el seu lloc a la directori de Tiki",
"Submit your site" => "Enviï el seu lloc",
"Spread the word" => "Corre la veu",
"Add the \"Powered by\" module to your site. " => "Afegiu el mòdul \"Potenciat per\" al seu lloc.",
"Manage Modules" => "Administrar mòduls",
"Help improve Tiki" => "Ajuda a millorar Tiki",
"Submit a feature request or bug report" => "Envia una petició de funcionalitat o informe d'error",
// "Visit Tiki development site" => "Visit Tiki development site",
"Make a financial contribution to the Tiki Association" => "Fes una contribució financera a l'Associació de Tiki",
"Contribute to Tiki" => "Contribueix a Tiki",
"New Feature" => "Nova Funcionalitat",
"Please note: Experimental - work in progress" => "Si us plau, pren nota: Experimental - treball en curs",
"Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "'Tiki Connect' és una forma de permetre que el projecte de Tiki sàpiga com està sent usat, i quines parts els agraden més a la gent o altres voldrien que arreglessin (o expliquessin)",
"Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Un cop habilitat, quan cliques el botó '<strong>Envia Info</strong>' de més avall seràs connectat amb <em>mother.tiki.org</em>, que és on es recolliran les dades",
"You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)" => "També pots enviar retroalimentació sobre Tiki si selecciones la casella 'Proporciona Retroalimentació ' (un cop 'Tiki Connect' estigui habilitat, al costat de la barra de 'Filtres de Preferències' més amunt)",
"Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'" => "Apareixeran icones al costat de totes les preferències on podràs indicar que 'M'agrada', indicar que 'Falta arreglar' o preguntar 'Per a què és això?'",
"Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)" => "Els teus vots seran enviats quan et connectis amb mother.tiki.org (actualment només a través de fer clic al botó '<strong>Envia Info</strong>')",
"Send Info" => "Envia Info",
"Send the data" => "Envia les dades",
"Preview info" => "Previsualitza la info",
"See what is going to be sent" => "Consulta el que es va a enviar",
"Fill form" => "Omple el formulari",
"Fill this form in based on other preferences" => "Omple aquest formulari basant-te en altres preferències",
"Advanced settings" => "Opcions Avançades",
"Exposed to assist testing and development" => "Exposades per assistir al testeig i desenvolupament",
// "Connections Received" => "Connections Received",
"Rebuild received connections index" => "Reconstruir rebut índex connexions",
"<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong> Estadístiques del servidor: </strong> %0 informes rebuts de %1 Tikis",
"Jitsi" => "Jitsi",
"Provision URL" => "URL de Provisió",
// "Allows a copyright to be determined for various objects" => "Allows a copyright to be determined for various objects",
// "Directories listing" => "Directories listing",
// "Extention package error" => "Extention package error",
// "Cannot show page because the extension package is not installed or activated" => "Cannot show page because the extension package is not installed or activated",
// "Extension package admin template page is missing" => "Extension package admin template page is missing",
// "FAQ listing" => "FAQ listing",
// "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
"Global features" => "Característiques globals",
// "Main features" => "Main features",
// "Secondary features" => "Secondary features",
// "Administrative features" => "Administrative features",
"Watches" => "Avisos",
// "Additional features" => "Additional features",
// "Payment and Accounting" => "Payment and Accounting",
// "Mail and Sharing" => "Mail and Sharing",
"Interaction with online services or other software" => "Interacció amb els serveis en línia o un altre programari",
"Configuration completed" => "Configuració completa",
"Authenticate with Zotero" => "Autenticar amb Zotero",
"Interface" => "Interfície",
"jQuery plugins and add-ons" => "Connectors (Plugins) de jQuery plugins i complements",
"Programmer" => "Programador",
"Logging and Reporting" => "Registres i informes",
"Visible to admin only" => "Visible només a l'admin",
"Include Smarty notices" => "Inclous avisos d'Smarty",
"Custom Code" => "Codi Adaptat",
"To create or remove file galleries, select" => "Per crear o eliminar galeries d'arxius, seleccioneu",
"from the application menu" => "des del menú de l'aplicació",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si decideixes guaradr arxius en un directori, t'has assegurar que l'usuari no pot accedir directament el directori.",
"You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Tens dues opcions per fer-ho: xatejar <ul> <li> Utilitza un directori fora de l'arrel del document, assegureu-vos que el teu script PHP pot llegir i escriure en aquest directori </li> <li> Utilitza un directori al document arrel i empra .htaccess per a evitar que l'usuari pugui llistar el contingut del directori </li> </ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Per configurar la ruta al directori empra rutes estil UNIX; per exemple arxius/ o c:/foo/arxius o /www/arxius/",
// "File galleries listing" => "File galleries listing",
"Move files from database to directory" => "Moure arxius de base de dades en el directori",
"Move files from directory to database" => "Moure arxius des del directori de la base de dades",
"Manage comment settings" => "Gestioni comentari ajustos",
"Update mime of all non archived octet-stream files" => "Actualitzar mim de tots els fitxers octet-stream no arxivats",
"Upload Regex" => "Pujar Regex",
// "Settings for Media Alchemyst" => "Settings for Media Alchemyst",
// "Settings for Diagrams" => "Settings for Diagrams",
// "Listings" => "Listings",
// "Configuration for gallery listings" => "Configuration for gallery listings",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "La modificació d'aquests paràmetres <em> no </em> afectar galeries d'arxius existents. Aquests canvis s'aplicaran <em> només </em> a les noves galeries d'arxius",
"Admin Listings" => "Administra Llistats",
// "Configuration for gallery administration listings" => "Configuration for gallery administration listings",
"Search Indexing" => "Indexació de cerca",
"Handlers" => "Manejadors",
"Add custom handlers to make your files &quot;searchable&quot; content" => "Afegeix controladors personalitzats per fer els fitxers de contingut \"cerca\"",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Utilitza <strong> %1 </strong> com a nom d'arxiu intern. Per exemple, utilitza cadenes <strong> %1 </strong> per convertir el document a text, utilitzant la comanda <strong>strings</strong> de Unix",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "Per eliminar un controlador, deixa el camp de <strong>Comanda del sistema</strong> en blanc",
"Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki està preconfigurat per manejar molts tipus comuns. Si algun dels que estan en aquesta llista, és perquè l'eina de línia d'ordres no està disponible",
"Missing Handlers" => "Manipuladors Desapareguts",
// "Mime Types" => "Mime Types",
// "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly" => "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly",
// "Fix vnd.ms-* mime type files" => "Fix vnd.ms-* mime type files",
"MIME Type" => "Tipus MIME",
"System Command" => "Sistema de Comando",
"Reindex all files for search" => "Reindexa tots els arxius per a la cerca",
"Enhancements" => "Millores",
// "H5P Info" => "H5P Info",
// "Service URL to purge unused libraries can be found here. Can be used in a cron task" => "Service URL to purge unused libraries can be found here. Can be used in a cron task",
"SCORM" => "SCORM",
// "OCR Indexing" => "OCR Indexing",
// "Forums listing" => "Forums listing",
// "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums" => "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums",
"Threads" => "Fils",
"Searches" => "Cerques",
// "Forum Listing" => "Forum Listing",
// "Tags listing" => "Tags listing",
// "Browse Tags" => "Browse Tags",
"Translate tags" => "Tradueix marcadors",
// "Translate Tags" => "Translate Tags",
// "Remove tags not applied to any objects" => "Remove tags not applied to any objects",
// "Clean Up Unused Tags" => "Clean Up Unused Tags",
"Random tag cloud colors" => "Atzar colors núvol d'etiquetes",
"Separate colors with a comma (,)" => "Colors amb una coma (,)",
"Alphanumeric ASCII characters only" => "Només caràcters ASCII alfanumèrics",
"No accents or special characters" => "No hi ha accents o caràcters especials",
"Accept all characters" => "Accepta tots els caràcters",
// "Tag search page" => "Tag search page",
// "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Per afegir/eliminar galeries d'imatges, ves a \"Galeries d'Imatges\" en el menú de principal l'aplicació, o",
"Click Here" => "Cliqueu aquí",
"You can upload images of a size of " => "Pots pujar imatges fins la mida de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altera les variables de l'arxiu php.ini file_uploads, upload_max_filesize, post_max_size i database variables (max_allowed_packet for mysql) per canviar aquest valor",
"Galleries features" => "Preferència de galeries",
"Gallery listing configuration" => "Configuració de llistat de galeries",
"Comments settings" => "Opcions Comentaris",
// "Manage images" => "Manage images",
// "Remove unused images" => "Remove unused images",
// "Remove unused images in the system gallery" => "Remove unused images in the system gallery",
// "Remove images not being used in wiki pages, articles or blog posts" => "Remove images not being used in wiki pages, articles or blog posts",
"Move images from database storage to filesystem storage" => "Moure les imatges des de l'emmagatzematge en base de dades a l'emmagatzematge en el sistema d'arxius",
"Move images from filesystem storage to database storage" => "Moure les imatges des de l'emmagatzematge en el sistema d'arxius a l'emmagatzematge en base de dades",
// "Move images" => "Move images",
"All galleries" => "Totes les galeries",
"System Gallery" => "Galeria del sistema",
"Reset or upgrade your database" => "Torna a especificar o actualitza la teva base de dades",
// "Create and edit menus" => "Create and edit menus",
"Server Fitness" => "Aptitud del servidor",
// "Check if your server meets the requirements for running Tiki" => "Check if your server meets the requirements for running Tiki",
// "Check for Updates Now" => "Check for Updates Now",
// "Check if a new Tiki version is available" => "Check if a new Tiki version is available",
"General Preferences" => "Preferències Generals",
// "Release check" => "Release check",
"Last update from SVN" => "Darrera actualització a partir de SVN",
// "Site identity" => "Site identity",
// "Themes" => "Themes",
// "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences" => "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences",
"These values will be stored in plain text in the database" => "Aquests valors s'emmagatzemen en text sense format a la base de dades",
"Email to send a test mail" => "Correu-e per a enviar un missatge de prova",
// "Logging and reporting" => "Logging and reporting",
// "Web Cron" => "Web Cron",
// "Call Web Cron URL" => "Call Web Cron URL",
// "Scheduler Settings" => "Scheduler Settings",
"Sessions" => "Sessions",
// "Advanced configuration" => "Advanced configuration",
"Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Tingueu en compte que l'emmagatzematge de dades de la sessió a la base de dades és una opció avançada d'administració de sistemes, i és per als administradors que tenen accés integral i la comprensió de la base de dades, per tal de fer front a qualsevol efecte inesperat",
"Changing this feature will immediately log you out when you save this preference" => "Canviar aquesta característica immediatament la sessió es tancarà en desar aquesta preferència",
"Enable now" => "Habilita-ho ara mateix",
"Contact" => "Contacte",
// "Terms and conditions" => "Terms and conditions",
// "Home page" => "Home page",
"Redirects" => "Redireccionaments",
// "Site access" => "Site access",
// "Test site closed message" => "Test site closed message",
"The namespace separator should not" => "El separador d'espai de noms no ha de",
"contain any of the characters not allowed in wiki page names, typically" => "contenir cap dels caràcters no permesos en noms de pàgines wiki, en general",
"conflict with wiki syntax tagging" => "entrar en conflicte amb la sintaxi de marcat wiki",
"To use :: as a separator, you should also use ::: as the wiki center tag syntax" => "Per utilitzar :: com a separador, també ha d'utilitzar ::: com la sintaxi wiki de l'etiqueta de centrat",
"Note: a conversion of :: to ::: for existing pages must be done manually" => "Nota: s'ha de realitzar manualment una conversió de :: a ::: per a les pàgines existents",
"If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "Si l'estripador a la visualització del nom de pàgina entra en conflicte amb el separador d'espai de noms, s'utilitzarà l'espai de noms i la visualització del nom de pàgina no serà estripat",
// "php.net" => "php.net",
"Date and Time Format Help" => "Ajuda per a la Data i Format de Temps",
// "Time zone and format" => "Time zone and format",
"Date/time selectors" => "Selectors de Dia/hora",
// "Manage customized local string translations" => "Manage customized local string translations",
// "Upload a file with translations for the selected language" => "Upload a file with translations for the selected language",
"Edit languages" => "Edita els idiomes",
// "Intertiki Client" => "Intertiki Client",
// "Set up this Tiki site as the Intertiki client" => "Set up this Tiki site as the Intertiki client",
// "Client server settings" => "Client server settings",
// "Currently linked master server" => "Currently linked master server",
// "Add an available master server" => "Add an available master server",
// "The InterTiki Server fields are for defining for every master server you want to have access to from this client" => "The InterTiki Server fields are for defining for every master server you want to have access to from this client",
// "Server name" => "Server name",
// "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value" => "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value",
// "Server host" => "Server host",
// "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above" => "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above",
// "Server port" => "Server port",
// "The port number the master tiki responds to HTTP on (usually 80)" => "The port number the master tiki responds to HTTP on (usually 80)",
// "Server path" => "Server path",
// "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field" => "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field",
// "Server groups" => "Server groups",
// "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)" => "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)",
// "Available master Tiki servers" => "Available master Tiki servers",
// "Delete master server" => "Delete master server",
// "Intertiki Master Server" => "Intertiki Master Server",
// "Set up this Tiki site as the InterTiki master server" => "Set up this Tiki site as the InterTiki master server",
// "Master server settings" => "Master server settings",
// "Allowed client servers" => "Allowed client servers",
// "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)" => "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)",
// "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key" => "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key",
"IP" => "IP",
// "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1" => "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1",
// "Username of primary contact on client machine. Useful for adminstration" => "Username of primary contact on client machine. Useful for adminstration",
"Can register" => "Es pot registrar",
// "To change the host key you need to remove and add it as a new one" => "To change the host key you need to remove and add it as a new one",
"New:" => "Nou:",
"New" => "Nou/va",
"Enable/disable Tiki features in " => "Habilita/deshabilita funcionalitats de Tiki en ",
", but configure them elsewhere" => ", però configura-les en un altre lloc",
// "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})" => "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})",
// "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples" => "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples",
"Registration" => "Registre",
"Log in" => "Connecta't",
"Generate a passcode" => "Generar una clau d'accés",
"Requires PHP GD library" => "Requereix la llibreria PHP GD",
// "Group and tracker login settings" => "Group and tracker login settings",
"Users can select a group to join at registration" => "Els usuaris poden seleccionar un grup per unir-se al registre",
"By default, new users automatically join the Registered group" => "per omissió, els nous usuaris s'uneixen automàticament el grup Registrats",
// "Other login settings" => "Other login settings",
// "Cookie consent" => "Cookie consent",
// "Assign users to groups by matching email patterns" => "Assign users to groups by matching email patterns",
// "An email pattern must be defined in the settings for at least one group for this to produce any results" => "An email pattern must be defined in the settings for at least one group for this to produce any results",
// "Remote Tiki Autologin" => "Remote Tiki Autologin",
// "You must install PHP extension LDAP" => "You must install PHP extension LDAP",
"You must change the Authentication Method to LDAP for these changes to take effect" => "Ha de canviar el mètode d'autenticació d'LDAP perquè aquests canvis tinguin efecte",
// "LDAP bind settings" => "LDAP bind settings",
// "LDAP user" => "LDAP user",
// "LDAP admin" => "LDAP admin",
"LDAP external groups" => "Grups externs LDAP",
// "LDAP group" => "LDAP group",
// "LDAP group member - if group membership can be found in group attributes" => "LDAP group member - if group membership can be found in group attributes",
// "LDAP user group - if group membership can be found in user attributes" => "LDAP user group - if group membership can be found in user attributes",
"PAM" => "PAM",
"You must change the Authentication Method to PAM for these changes to take effect" => "Ha de canviar el mètode d'autenticació de PAM perquè aquests canvis tinguin efecte",
"Shibboleth Authentication " => "Autenticació Shibboleth",
"You must change the Authentication Method to Shibboleth for these changes to take effect" => "Ha de canviar el mètode d'autenticació d'Shibboleth perquè aquests canvis tinguin efecte",
// "SAML2" => "SAML2",
// "based on Onelogin's php-saml " => "based on Onelogin's php-saml ",
// "You must change the Authentication Method to SAML for these changes to take effect" => "You must change the Authentication Method to SAML for these changes to take effect",
// "Identity provider settings" => "Identity provider settings",
// "Attribute mapping" => "Attribute mapping",
// "Group mapping" => "Group mapping",
"CAS" => "CAS",
// "CAS (central authentication service)" => "CAS (central authentication service)",
"You must change the Authentication Method to CAS for these changes to take effect" => "Ha de canviar el mètode d'autenticació d'EAP perquè aquests canvis tinguin efecte",
// "CAS server" => "CAS server",
"CAS Server Name" => "CAS Nom del servidor",
"CAS Server Port" => "Port del servidor CAS",
"CAS Server Path" => "Ruta del servidor CAS",
"phpBB User Database Authentication " => "phpBB autenticació de base de dades de l'usuari",
"You must change the Authentication Method to phpBB for these changes to take effect" => "Ha de canviar el mètode d'autenticació a phpBB perquè aquests canvis tinguin efecte",
"You must turn Users can register off for phpBB Authentication to function properly" => "Heu d'activar usuaris poden registrar-se per l'autenticació del phpBB per funcionar",
"MySql only (for now)" => "Només MySql (per ara)",
// "Web server" => "Web server",
"Web Server Authentication " => "Autenticació de servidor web",
"You must change the Authentication Method to Web Server for these changes to take effect" => "Ha de canviar el mètode d'autenticació amb el servidor web perquè aquests canvis tinguin efecte",
// "Password Blacklist" => "Password Blacklist",
// "Password blacklist tools" => "Password blacklist tools",
// "Upload Word List for Processing" => "Upload Word List for Processing",
// "Words currently indexed" => "Words currently indexed",
// "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below" => "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below",
// "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file" => "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file",
// "Use 'LOAD DATA INFILE'" => "Use 'LOAD DATA INFILE'",
// "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions" => "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions",
// "Create or Replace Word Index" => "Create or Replace Word Index",
// "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first" => "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first",
// "Delete Temporary Index" => "Delete Temporary Index",
// "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete" => "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete",
// "Blacklist Currently Using" => "Blacklist Currently Using",
// "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future" => "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future",
// "Number of passwords (limit)" => "Number of passwords (limit)",
// "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396" => "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396",
// "Minimum Password Length" => "Minimum Password Length",
// "The minimum password length for your password. This will filter out any password that has an illegal length" => "The minimum password length for your password. This will filter out any password that has an illegal length",
// "Require Numbers &amp; Letters" => "Require Numbers &amp; Letters",
// "If checked, will filter out any password that does not have both upper and lower case letters" => "If checked, will filter out any password that does not have both upper and lower case letters",
// "Require Special Characters" => "Require Special Characters",
// "If checked, will filter out any passwords that do not have special characters" => "If checked, will filter out any passwords that do not have special characters",
// "Save & Set as Default" => "Save & Set as Default",
// "View Password List" => "View Password List",
// "OAuth Server Settings" => "OAuth Server Settings",
// "Main theme" => "Main theme",
"Theme Screenshot" => "Theme Captura",
// "Theme Preferences" => "Theme Preferences",
// "{{\$theme|escape|ucfirst}}" => "{{\$theme|escape|ucfirst}}",
// "No theme preferences found" => "No theme preferences found",
// "General layout" => "General layout",
// "Admin pages layout" => "Admin pages layout",
// "Admin theme must be selected first" => "Admin theme must be selected first",
// "Fixed vs full width layout" => "Fixed vs full width layout",
// "Logo and Title" => "Logo and Title",
"Module zone visibility" => "Visibilitat Zona mòdul",
// "Site report bar" => "Site report bar",
// "Limits" => "Limits",
"UI Effects" => "Efectes de la interfície d'usuari",
"Standard UI effects" => "Els efectes estàndard d'interfície d'usuari",
"Tab UI effects" => "Tab efectes UI",
"Customization" => "Personalització",
// "Custom codes" => "Custom codes",
"Editing" => "Editant",
"View Templates" => "Visualitza les plantilles",
"Edit Templates" => "edita plantilles",
"Miscellaneous" => "Miscel·lània",
// "Responsive images" => "Responsive images",
// "Context menus" => "Context menus",
// "currently used in file galleries only" => "currently used in file galleries only",
"Separators" => "Separadors",
// "Smarty templates (TPL files)" => "Smarty templates (TPL files)",
"Defaults" => "Per omissió",
"See also" => "Consulta també el/la",
"Search Engine Friendly URLs" => "Motor de cerca friendly URL",
// "Also" => "Also",
// "here" => "here",
// "for more information on geo tagging" => "for more information on geo tagging",
"Meta tags" => "Meta tags",
// "Geo Metatags" => "Geo Metatags",
"Robots" => "Robots",
"&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site" => "Els &quot;Mòduls&quot; són els elements de contingut a la part superior i inferior i en les columnes de la dreta i l'esquerra de la pàgina",
"Admin &gt; Modules" => "Administració> Mòduls",
"from the menu to create and edit modules" => "al menú per crear i editar els mòduls",
"{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
"Hint" => "Suggeriment",
"If you lose your login module, use tiki-login_scr.php to be able to login" => "Si perd el mòdul d'inici de sessió, utilitzeu tiki-login_scr.php ser capaç d'iniciar sessió",
// "Composer not found" => "Composer not found",
// "Composer could not be executed, so the automated check on the packages cannot be performed" => "Composer could not be executed, so the automated check on the packages cannot be performed",
// "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer" => "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer",
// "Result of executing the changes to the packages" => "Result of executing the changes to the packages",
// "Composer errors" => "Composer errors",
// "Composer returned some errors" => "Composer returned some errors",
// "Issues with composer environment" => "Issues with composer environment",
// "Run %0 from a shell to try to fix this, see %1 for more info" => "Run %0 from a shell to try to fix this, see %1 for more info",
// "Packages" => "Packages",
// "Packages check could not be performed at the moment due to missing" => "Packages check could not be performed at the moment due to missing",
// "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow" => "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow",
// "Installed Packages" => "Installed Packages",
// "Status of the packages registered in the composer.json file" => "Status of the packages registered in the composer.json file",
// "Version Required" => "Version Required",
// "Version Installed" => "Version Installed",
// "Installed" => "Installed",
// "Missing" => "Missing",
// "Enable extension" => "Enable extension",
// "Update extension" => "Update extension",
// "Disable extension" => "Disable extension",
// "Removal not available" => "Removal not available",
// "This package is not managed by Tiki and likely was installed manually" => "This package is not managed by Tiki and likely was installed manually",
// "One or more packages appear to be missing" => "One or more packages appear to be missing",
// "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed" => "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed",
// "Could not validate the status of one or more packages" => "Could not validate the status of one or more packages",
// "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually" => "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually",
// "Install packages from the administrator interface" => "Install packages from the administrator interface",
// "The administrator interface can be used to install the packages marked as missing in the list above" => "The administrator interface can be used to install the packages marked as missing in the list above",
// "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them" => "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them",
// "Fix Missing Packages" => "Fix Missing Packages",
// "Install packages manually" => "Install packages manually",
// "Make sure <code>composer</code> is installed" => "Make sure <code>composer</code> is installed",
// "Composer can be installed manually, in the host machine, by following the instructions from the" => "Composer can be installed manually, in the host machine, by following the instructions from the",
// "website" => "website",
// "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>" => "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>",
// "Below is an example of how to do this in a Linux-like operating system" => "Below is an example of how to do this in a Linux-like operating system",
// "Install the missing packages" => "Install the missing packages",
// "You can install the missing packages by issuing the command" => "You can install the missing packages by issuing the command",
// "Available Packages" => "Available Packages",
// "These packages have been identified as required by one or more features" => "These packages have been identified as required by one or more features",
// "Licence" => "Licence",
// "Required by" => "Required by",
// "Not Available" => "Not Available",
"Install" => "Instal·lació",
// "There appear to be some optional packages that can be installed" => "There appear to be some optional packages that can be installed",
// "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package" => "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package",
// "The administrator interface can be used to install the optional packages in the list above" => "The administrator interface can be used to install the optional packages in the list above",
// "Click the \"Install Package\" button, and Tiki will try to install them" => "Click the \"Install Package\" button, and Tiki will try to install them",
// "Make sure there is a <code>composer.json</code> file in the root of the website" => "Make sure there is a <code>composer.json</code> file in the root of the website",
// "If there is not already a <code>composer.json</code> file, then create one" => "If there is not already a <code>composer.json</code> file, then create one",
// "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point" => "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point",
// "Install the package" => "Install the package",
// "Packages can be installed by issuing a command" => "Packages can be installed by issuing a command",
// "for each package that is to be installed" => "for each package that is to be installed",
// "Packages Custom" => "Packages Custom",
// "There are no manual managed packages installed in the folder vendor_custom" => "There are no manual managed packages installed in the folder vendor_custom",
// "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages" => "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages",
// "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab" => "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab",
// "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>" => "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>",
// "For information only" => "For information only",
// "These packages are managed manually and displayed here for informational purposes" => "These packages are managed manually and displayed here for informational purposes",
// "Packages Bundled" => "Packages Bundled",
// "These packages are bundled with Tiki, and displayed here for informational purposes" => "These packages are bundled with Tiki, and displayed here for informational purposes",
// "Composer Packages Bundled" => "Composer Packages Bundled",
// "status of the packages registered in the vendor_bundled/composer.json file" => "status of the packages registered in the vendor_bundled/composer.json file",
// "Diagnose" => "Diagnose",
// "Diagnose Composer Installation" => "Diagnose Composer Installation",
// "Use the button below to test your composer installation" => "Use the button below to test your composer installation",
// "Diagnose Composer" => "Diagnose Composer",
// "Composer management" => "Composer management",
// "Install Composer" => "Install Composer",
// "Update Composer" => "Update Composer",
// "Remove composer.lock" => "Remove composer.lock",
// "Clean vendor folder" => "Clean vendor folder",
// "{\$diagnostic_composer_location}" => "{\$diagnostic_composer_location}",
// "Extensions Preferences" => "Extensions Preferences",
// "Activate Extension Package" => "Activate Extension Package",
// "Extension Package Groups API" => "Extension Package Groups API",
"Payments" => "Pagaments",
"Choose payment system" => "Trieu el sistema de pagament",
"You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "Només es pot utilitzar un mètode de pagament: PayPal o Cclite o Tiki Crèdits usuari",
"PayPal is working at the moment. See PayPal.com" => "PayPal està treballant en aquest moment. Veure PayPal.com",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: comptabilitat en moneda comunitari per als sistemes de negociació de canvi local (LETS). Veure",
"sourceforge.net" => "sourceforge.net",
"Tiki User Credits: Requires this other feature to be configured" => "Tiki Crèdits usuari: Es requereix aquesta altra funció que voleu configurar",
// "Israel Post payment module" => "Israel Post payment module",
"Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite és per crear i administrar les divises i els grups comercials alternatives o complementàries",
"Work in progress since Tiki 6" => "Treball en curs des Tiki 6",
"Advanced Shopping Cart" => "Avançada Cistella",
// "Cart settings" => "Cart settings",
// "Advanced cart tracker names setup" => "Advanced cart tracker names setup",
// "Products tracker setup" => "Products tracker setup",
"Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Depenent de la funció que utilitzeu, és possible que tingui alguns o tots els següents camps per ser configurat",
"Shipping" => "Enviament",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Output compression is active" => "Compressió de sortida està actiu",
"Compression is handled by" => "La compressió és manejat per",
// "PHP settings" => "PHP settings",
"Some PHP.INI settings that can increase performance" => "Alguns ajustos php.ini que poden augmentar el rendiment",
"'realpath_cache_size setting': %0" => "'realpath_cache_size setting': %0",
"(percentage used %0 %" => "(Percentatge utilitzat %0 %",
"Determines the size of the realpath cache to be used by PHP" => "Determina la mida de la memòria cau de la ruta real per ser utilitzat per PHP",
"'realpath_cache_ttl setting': %0 seconds" => "'realpath_cache_ttl setting': %0 segons",
"Duration of time (in seconds) for which to cache realpath information for a given file or directory" => "Durada de temps (en segons) pels quals emmagatzemar en memòria cau informació realpath d'un fitxer o directori donat",
"Bytecode Cache" => "Memòria cau Bytecode",
// "Using <strong>%0</strong>. These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>. These stats affect all PHP applications running on the server",
"Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuració de l'entorn <em>xcache.admin.enable_auth</em> impedeix l'accés a les estadístiques. Això també evitarà que la memòria cau de ser netejat a esborrar memòria cau de les plantilles",
"Memory Used" => "Memòria utilitzada",
"Cache Hits" => "Encerts de memòria cau",
"Misses" => "Misses",
"Few hits recorded. Statistics may not be representative" => "Pocs èxits registrats. Les estadístiques poden no ser representatius",
"Low hit ratio. %0 may be misconfigured and not used" => "Baixa proporció d'èxit. %0 pot ser mal configurat i no s'utilitzen",
"Little memory available. Thrashing likely to occur" => "Poc memòria disponible. Thrashing probable que passi",
// "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)" => "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)",
"Small amount of memory allocated to %0. Verify the configuration" => "Petita quantitat de memòria assignada a %0. Comproveu la configuració",
"Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuració <em>%0</em> està habilitada. Desactivació de xecs modificació pot millorar el rendiment, sinó que requerirà Instruccions clara sobre actualitzacions d'arxius",
"<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> no ha de ser desactivat a causa de l'autenticació en XCache",
"Clear all APC caches" => "Neteja totes les memòries Cau d'APC",
// "Clear APC caches" => "Clear APC caches",
"Clear Caches" => "Neteja les memòries Cau",
// "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments",
// "Major Slowdown" => "Major Slowdown",
"Major slowdown" => "Major a poc a poc",
"These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "Aquests solen disminuir la velocitat de Tiki. Si tens un lloc de gran volum, és possible que vulguis desactivar-los",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>",
// "Time and Memory Limits" => "Time and Memory Limits",
// "PDF settings" => "PDF settings",
// "Wiki print version" => "Wiki print version",
// "Other features" => "Other features",
"Tiki Configuration Profiles" => "Perfils de configuració de Tiki",
"Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Alguns dels seus perfils Repositoris no va a connectar. Això pot evitar que l'aplicació de determinats perfils",
// "Find profiles" => "Find profiles",
// "Search by name, types and repository" => "Search by name, types and repository",
// "Profile types" => "Profile types",
"Profile repository" => "Repositori de perfil",
// "Suggested Profiles" => "Suggested Profiles",
"Featured Site Profiles" => "Perfils de Lloc Destacats",
// "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
"Full Profiles" => "Perfils complets",
"Full Profiles are full featured out of the box solutions" => "Perfils complets estan amb totes les funcions de les solucions de caixa",
"Mini Profiles" => "Mini perfils",
"Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "Mini perfils es configuren funcions específiques i són una gran manera d'afegir més funcionalitat a una configuració existent",
"Learning Profiles" => "Perfils d'Aprenentatge",
"Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "Perfils d'aprenentatge li permetrà avaluar ràpidament les característiques específiques de Tiki",
// "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>" => "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>",
"Repository" => "Repositori",
"Profile type" => "Tipus de perfil",
// "See profile info below (may take a few seconds to load)" => "See profile info below (may take a few seconds to load)",
"applied" => "aplicat",
"JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript ha d'estar <strong> Activat </strong> per tal d'aplicar perfils. Si us plau, activa el JavaScript i torna a intentar",
"Export YAML" => "Exporta YAML",
"Export modified preferences as YAML" => "Exportar preferències modificades com a YAML",
"Toggle Visible" => "Commuta les caselles de verificació visibles",
"Show added preferences" => "Mostrar les preferències afegides",
"no default" => "no té valor predeterminat",
// "Repository status" => "Repository status",
// "status of the registered profile repositories" => "status of the registered profile repositories",
"Refresh" => "Refrescar",
"Profile tester" => "Perfil tester",
"Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Enganxa o escriu el wiki i YAML (amb o sense el {literal}{CODE}{/literal}) en l'àrea de text inferior",
"This will run the profile and make potentially unrecoverable changes in your database" => "Això executarà el perfil i fer canvis potencialment irrecuperables a la base de dades",
// "Test profile name" => "Test profile name",
// "Permission added" => "Permission added",
// "User added" => "User added",
// "User modified" => "User modified",
// "Group added" => "Group added",
// "old value" => "old value",
// "Installer added" => "Installer added",
// "Profile without changes" => "Profile without changes",
"Global configuration" => "Configuració global",
"This preference needs to be disabled" => "Aquesta preferència ha d'estar deshabilitada",
// "Enabling ratings for forums" => "Enabling ratings for forums",
"You need to" => "Necessites",
// "Create or edit a forum and enable" => "Create or edit a forum and enable",
"Posts can be rated" => "Les publicacions poden ser puntuades",
"While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user" => "Mentre editis un fòrum, escull si vols mostrar la \"Mostra de la informació de l'usuari/a > <strong>Valoració del Tema</strong>\" per cada usuari",
"Set the rating options at" => "Especifica les opcions de valoració a",
"Ratings" => "Valoracions",
"see above" => "veure més amunt",
"Permissions involved" => "Permissos involucrats",
"tiki" => "tiki",
// "Default Options" => "Default Options",
"Cache duration" => "Durada de la memòria cau",
"Create new" => "Crea nou",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds",
"Feeds" => "Alimentacions",
"Feed for articles" => "Alimentar els articles",
"Feed for blogs" => "Els pinsos per a blogs",
"Feed for individual blogs" => "Els pinsos per als blocs individuals",
"Feed for image galleries" => "Els pinsos per a galeries d'imatges",
"Feed for individual image galleries" => "Els pinsos per a galeries d'imatges individuals",
"Feed for file galleries" => "Els pinsos per a galeries d'arxius",
"Feed for individual file galleries" => "Els pinsos per a galeries d'arxius individuals",
"Feed for wiki pages (with diff)" => "Els pinsos per a les pàgines wiki (amb diff)",
// "with diff" => "with diff",
"Feed for wiki pages (no diff)" => "Els pinsos per a les pàgines wiki (sense diff)",
// "no diff" => "no diff",
"Feed for forums" => "Alimentar els fòrums",
"Feed for individual forums" => "Alimentar els fòrums individuals",
"Feed for trackers" => "Els pinsos per als formularis-bd",
"Feed for calendars" => "Els pinsos per als calendaris",
"Feed for directories" => "Contingut per als directoris",
"Feed for shoutbox" => "Aliment per al quadre de xerrada",
// "Incoming Feeds" => "Incoming Feeds",
"You can see users rank by score in the module users_rank, for that go to" => "Pots veure un ranking d'usuaris per puntuació en el mòdul de ranking d'usuaris (users_rank); si t'interessa, ves a",
"Admin modules" => "Admin moòuls",
"Cause scores older than a certain number of days to expire" => "Fes que caduqui la puntuació (score) més antiga que un nombre determinat de dies",
// "Scoring rules" => "Scoring rules",
// "Unique rule ID" => "Unique rule ID",
// "Rule" => "Rule",
// "A label or ID to help identify which event was triggered to get points" => "A label or ID to help identify which event was triggered to get points",
// "Pts recipient type" => "Pts recipient type",
// "Recipient Type" => "Recipient Type",
// "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event" => "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event",
// "Pts recipient" => "Pts recipient",
// "The ID of the points recipient" => "The ID of the points recipient",
// "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered" => "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered",
// "Points Given" => "Points Given",
// "This is the numerical value of the points being given" => "This is the numerical value of the points being given",
// "Triggering event" => "Triggering event",
// "Reversal event" => "Reversal event",
// "Valid Triggering Object IDs" => "Valid Triggering Object IDs",
// "Valid Object Ids" => "Valid Object Ids",
// "This is a comma-separated list of object ids for which the event is valid" => "This is a comma-separated list of object ids for which the event is valid",
// "Min. Time Between Scoring" => "Min. Time Between Scoring",
// "Time between scoring" => "Time between scoring",
// "This is the amount of time in seconds that a user must wait before again being able to get points for this event" => "This is the amount of time in seconds that a user must wait before again being able to get points for this event",
"can be seen on page" => "pot ser vist a la pàgina",
"in Admin menu" => "al menú d'Administració",
// "Also see the Search Indexing tab" => "Also see the Search Indexing tab",
"File Gallery admin panel" => "Panell d'administració de Galeries d'Arxius",
// "About the Unified Index" => "About the Unified Index",
// "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things" => "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things",
// "Disabling this will cause some parts of Tiki to be unavailable" => "Disabling this will cause some parts of Tiki to be unavailable",
// "Find out more about it here" => "Find out more about it here",
// "Search engine settings" => "Search engine settings",
// "About Unified search engines" => "About Unified search engines",
// "Advantages" => "Advantages",
// "Fast performance. Works out of the box with Tiki and even on most basic server setups" => "Fast performance. Works out of the box with Tiki and even on most basic server setups",
// "Disadvantages" => "Disadvantages",
// "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable" => "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable",
// "link" => "link",
// " for full list) " => " for full list) ",
"Lucene (PHP implementation)" => "Lucene (PHP aplicació)",
// "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki" => "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki",
// "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues" => "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues",
// "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki" => "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki",
// "Needs to be separately installed from Tiki and requires more configuration" => "Needs to be separately installed from Tiki and requires more configuration",
// "for more information) " => "for more information) ",
// "About Use MySQL Full-Text Search as fallback" => "About Use MySQL Full-Text Search as fallback",
// "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability" => "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability",
// "Elastic search only" => "Elastic search only",
// "Experiment with LIST plugin syntax" => "Experiment with LIST plugin syntax",
// "After you have found the correct contents, you may copy-paste them in a LIST plugin" => "After you have found the correct contents, you may copy-paste them in a LIST plugin",
// "Legacy search" => "Legacy search",
"Forum searches" => "Cerques al Fòrum",
"Search Results" => "Resultats de la cerca",
// "Items to display in search results" => "Items to display in search results",
// "Information to display for each result" => "Information to display for each result",
// "Stored Search" => "Stored Search",
"Configuration" => "Configuració",
// "ManifoldCF Configuration Checker" => "ManifoldCF Configuration Checker",
// "Occurrences of string in database" => "Occurrences of string in database",
// "Set default table" => "Set default table",
// "Text to search" => "Text to search",
// "Results for " => "Results for ",
// "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}" => "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}",
"Occurrences" => "Occurrències",
// "View occurrences" => "View occurrences",
// "in table " => "in table ",
// "column" => "column",
// "Page preview" => "Page preview",
"View page" => "Visualitza la pàgina",
// "View blog post" => "View blog post",
// "View file" => "View file",
// "View gallery" => "View gallery",
// "View category" => "View category",
// "View article" => "View article",
// "View forum" => "View forum",
// "View calendar" => "View calendar",
// "View calendar item" => "View calendar item",
// "View tracker" => "View tracker",
// "View tracker item" => "View tracker item",
// "View forum comment" => "View forum comment",
// "Back to first level results" => "Back to first level results",
"Admin groups" => "Administra grups",
"Admin Groups" => "Administració de grups",
"Admin users" => "Administra usuaris",
"Admin Users" => "Administrar usuaris",
"Manage permissions" => "Administrar els permisos",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings" => "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings",
"General Security" => "Seguretat General",
// "MySQL SSL connection" => "MySQL SSL connection",
"MySQL SSL connection is active" => "La connexió SSL de MySQL és activa",
"MySQL connection is not encrypted" => "La connexió de MySQL no és xifrada",
"To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"" => "Per a activar l'SSL, copia els arxius clau (.pem) al directori db/cert. Els noms d'arxiu han d'acabar en \"-key.pem\", \"-cert.pem\", \"-ca.pem\"",
"MySQL Server does not have SSL activated" => "El servidor MySQL no té l'SSL activat",
// "Smarty and Features Security" => "Smarty and Features Security",
"Please also see:" => "Si us plau, mira també:",
"HTTPS (SSL) and other login preferences" => "HTTPS (SSL) i altres preferències d'inici de sessió",
// "User Encryption" => "User Encryption",
// "Requires the OpenSSL PHP extension for encryption" => "Requires the OpenSSL PHP extension for encryption",
// "You have OpenSSL installed" => "You have OpenSSL installed",
// "OpenSSL is not loaded" => "OpenSSL is not loaded",
// "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption" => "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption",
// "You may also want to add the Domain Password module somewhere" => "You may also want to add the Domain Password module somewhere",
// "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ" => "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ",
// "The user can add passwords for a registered password domain" => "The user can add passwords for a registered password domain",
// "Statistics for existing data" => "Statistics for existing data",
// "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension" => "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension",
// "CSRF security" => "CSRF security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "HTTP Headers" => "HTTP Headers",
// "Use these options to add options related with security to the HTTP Headers" => "Use these options to add options related with security to the HTTP Headers",
// "Spam Protection" => "Spam Protection",
// "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself" => "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself",
"Search results" => "Resultats de la cerca",
"Site Access" => "Accés al lloc",
// "Admin IDS custom rules" => "Admin IDS custom rules",
"Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)",
"OpenPGP" => "OpenPGP",
// "OpenPGP functionality for PGP/MIME encrypted email messaging" => "OpenPGP functionality for PGP/MIME encrypted email messaging",
"Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging" => "De Funcionalitat OpenPGP Experimental de PGP / MIME missatges de correu electrònic xifrat",
"All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses" => "Tots email-messaging/notifications/butlletins s'envien com PGP / MIME xifrats, signats amb la clau del signant, i són totalment 100 %opac als forasters. Tots els comptes d'usuari han de configurar correctament en gnupg clauer amb claus públiques relacionades amb les seves adreces de correu electrònic-tiki-relacionats amb el compte",
"If you use preferences option for the signer passphrase, clear the file option just for security" => "Si utilitzeu l'opció de preferències per al signant contrasenya, desmarqueu l'opció d'arxiu només per a la seguretat",
"If you use file for the signer passphrase, clear the preferences option just for security" => "Si utilitzeu l'arxiu per signant contrasenya, desmarqueu l'opció de preferències només per a la seguretat",
// "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring" => "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring",
"SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requereix el <strong>mòdul de reescriptura d'URL </strong> de IIS. No semblen tenir aquest mòdul instal·lat",
// "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
"SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL no funcionarà a menys Tiki directives específiques s'implementen en l'arxiu %0",
"To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "Per habilitar aquest arxiu, només cal copiar el fitxer %0 (que es troba al directori arrel de la instal·lació de Tiki) a %1",
"If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "Si necessites mantenir %0 un arxiu existent (no de Tiki), només cal que li afegeixis directives de Tiki",
"When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "En actualitzar Tiki (per exemple, des de la versió 7 a la versió 8), assegura't d'utilitzar el nou arxiu de configuració de reescriptura URL",
"%0 file is missing" => "no es troba l'arxiu %0",
"Unable to verify that your URL rewriting configuration is up to date" => "No es pot verificar que la configuració de reescriptura d'URL està actualitzada",
"SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL pot no funcionar en absolut o correctament si la configuració de reescriptura URL Tiki no està actualitzada",
"%0 is not in the expected format" => "%0 no està en el format esperat",
"%0 may simply be outdated" => "%0 podria simplement estar desfasat",
"To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "Per actualitzar l'arxiu, si no s'ha personalitzat, copieu el fitxer %0 (que es troba al directori arrel de la instal·lació de Tiki) a %1 , reemplaçant aquest últim",
"%0 file is out of date" => "l'arxiu %0 està desfasat",
"The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "La directiva RewriteBase no sembla estar configurada correctament. Això és necessari perquè funcioni correctament sefurl",
"The current value in %0 is %1 but the base url for this site is %2" => "El valor actual en %0 és %1 però la url base per a aquest lloc és %2",
// "For example, if the field is left blank, the canonical URL domain is" => "For example, if the field is left blank, the canonical URL domain is",
// "URL parameters" => "URL parameters",
"List of Url Parameters that should go in the path" => "Llista de paràmetres d'URL que han d'anar en el camí",
// "Known types" => "Known types",
"Invert" => "Invertir",
"Show Usage" => "Mostrar Ús",
"Delete &amp; Unreference" => "Eliminar i Unreference",
"Invert Relation" => "Invertir Relació",
// "New types" => "New types",
"Fix" => "Fixar",
"No occurences found" => "No hi ha ocurrències trobades",
"If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "Si no desitges limitar-lo, es mostrarà un quadre d'entrada, en cas contrari, serà una casella de verificació",
// "Social network integration" => "Social network integration",
"To use Twitter integration, you must register this site as an application at" => "Per utilitzar la integració de Twitter, ha de registrar aquest lloc com una sol·licitud en",
"and allow write access for the application" => "i permetre l'accés d'escriptura per a l'aplicació",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Introduïu &lt;your site URL&gt;tiki-socialnetworks.php com a URL de devolució de trucada",
"To use Facebook integration, you must register this site as an application at" => "Per utilitzar la integració de Facebook, ha de registrar aquest lloc com una sol·licitud en",
"and allow extended access for the application" => "i permetre l'accés estesa per a l'aplicació",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Introduïu &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook com a URL del lloc i &lt;your site&gt; com a lloc de domini",
"The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it" => "Les següents preferències afecten quins permisos se li demana a l'usuari que permeti Tiki fer per Facebook per a autoritzar-",
// "bit.ly" => "bit.ly",
"There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "No hi ha necessitat de crear un lloc en tot el compte de bit.ly, cada usuari pot tenir el seu propi compte, però això permet que les estadístiques en tot el lloc",
"Go to" => "Ves a",
"to sign up for an account" => "per inscriure en un compte",
"to retrieve the API key" => "per recuperar la clau API",
// "To use LinkedIn integration, you must register this site as an application at" => "To use LinkedIn integration, you must register this site as an application at",
// "and allow necessary permissions for the application" => "and allow necessary permissions for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs" => "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs",
// "Share This" => "Share This",
// "This is a new control panel on Tiki and work is still in progress" => "This is a new control panel on Tiki and work is still in progress",
// "Tiki Statistics" => "Tiki Statistics",
// "Piwik Analytics" => "Piwik Analytics",
"Text area (that apply throughout many features)" => "Àrea de text (que té aplicació a través de moltes funcions)",
"Wiki syntax" => "Sintaxi Wiki",
// "Typography" => "Typography",
"Default size" => "Mida per omissió",
"External links and images" => "Enllaços i imatges externs",
"External links will be identified with" => "Els enllaços externs s'identifiquen amb",
"About plugins" => "Sobre connectors (plugins)",
"Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Els connectors (plugins) de Tiki poden afegir funcionalitat a les pàgines wiki, articles, blocs, etc. Pots activar-los i desactivar-los a sota",
// "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>",
"The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "La icona d'edició-plugin és una manera fàcil perquè els usuaris puguin editar els paràmetres de cada plugin en pàgines wiki. Es pot desactivar per a connectors individuals a baix",
"Check disabled plugins used in wiki pages" => "Comprovi els connectors (plugins) deshabilitats que s'estan emprant en pàgines wiki",
"Disabled used plugins" => "Plugins utilitzats per a minusvàlids",
"Plugin preferences" => "Les preferències del mòdul",
"Edit plugin icons" => "Edita les icones del connector",
// "Plugin List" => "Plugin List",
// "Use the filter input above to find plugins, or enter return to see the whole list" => "Use the filter input above to find plugins, or enter return to see the whole list",
"Search Help" => "Ajuda de la cerca",
"Disable edit plugin icon (make plugin inline)" => "Desactivar editar la icona complement (plug-in crea línia)",
"Plugin Aliases" => "Aliases de connectors (Plugins)",
"About plugin aliases" => "Sobre àlies de connectors (plugins)",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins",
// "Find out more here" => "Find out more here",
// "This page is designed to work with JavaScript" => "This page is designed to work with JavaScript",
// "Available alias" => "Available alias",
// "Plugin Alias" => "Plugin Alias",
// "Enable Checked Plugins" => "Enable Checked Plugins",
// "General information" => "General information",
"Plugin name" => "Nom de Connector (Plugin)",
// "Base plugin" => "Base plugin",
// "Body label" => "Body label",
"Dependencies" => "Dependències",
// "Inline (no plugin edit UI)" => "Inline (no plugin edit UI)",
// "Simple plugin arguments" => "Simple plugin arguments",
// "Add parameter" => "Add parameter",
"Argument" => "Argument",
// "Delete this parameter" => "Delete this parameter",
// "Default Value" => "Default Value",
// "Plugin parameter documentation" => "Plugin parameter documentation",
// "Add parameter documentation" => "Add parameter documentation",
// "Delete this parameter's documentation" => "Delete this parameter's documentation",
"Safe" => "Segur",
"Plugin body" => "Cos Programes",
// "Ignore user input" => "Ignore user input",
// "Default content" => "Default content",
// "Body Parameters" => "Body Parameters",
// "Add body parameter" => "Add body parameter",
// "Delete this body parameter" => "Delete this body parameter",
"Encoding" => "Codificació",
// "Argument source (if different)" => "Argument source (if different)",
// "Composed plugin arguments" => "Composed plugin arguments",
// "Add composed parameter" => "Add composed parameter",
// "Delete this composed argument" => "Delete this composed argument",
"Pattern" => "Patró",
// "Composed parameters" => "Composed parameters",
// "Delete this composed parameter" => "Delete this composed parameter",
"Tracker settings" => "Configuració del formulari-bd",
// "Field settings" => "Field settings",
// "Linked wiki pages" => "Linked wiki pages",
// "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features" => "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features",
"Tracker attachment preferences" => "Formulari-bd de preferències del document adjunt",
// "Tracker force-fill feature" => "Tracker force-fill feature",
"Field Types" => "Tipus de camp",
// "Field types" => "Field types",
"Tracker attachments" => "Adjunts del formulari-bd",
"dls" => "baixades",
"Switch storage" => "Canviar d'emmagatzematge",
"Change all to db" => "Canvia-ho tot a base de dades",
"Change all to file" => "Canvia-ho tot a arxius",
// "User Settings" => "User Settings",
"Default user preferences" => "Preferències de l'usuari per omissió",
"Users Default Preferences" => "Preferències per defecte per als nous usuaris",
// "My Account Items" => "My Account Items",
"User Features" => "Funcionalitats d'Usuaris/ies",
// "User Account Features" => "User Account Features",
// "User Info and Picture" => "User Info and Picture",
"User information display" => "Mostra de la informació de l'usuari/a",
// "Messaging and Notifications" => "Messaging and Notifications",
// "User notifications" => "User notifications",
"For the digest emails to be sent out, you will need to set-up a cron job" => "Hauràs de posar un treball periòdic al servidor (cron job) per als correus de resum que s'han d'enviar",
"Adjust the command parameters for your digest frequency. Default frequency is 7 days" => "Ajusta els paràmetres de la comanda per a la teva freqüència d'enviament de resums. Per defecte la freqüència és de 7 dies",
"Sample command" => "Exemple de comanda",
"User Files" => "Arxius d'Usuari",
"Kaltura" => "Kaltura",
"Kaltura Registration" => "Kaltura Registre",
"To get a Kaltura Partner ID" => "Per obtenir un ID de soci Kaltura",
"Setup your own instance of Kaltura Community Edition (CE)" => "Configureu la seva pròpia instància de Kaltura Community Edition (CE)",
"get an account via Kaltura.com" => "obtenir un compte a través de Kaltura.com",
"List Media" => "Llista dels mitjans de comunicació",
"List Remix Entries" => "Llista Remix comentaris",
"Add New Media" => "Afegir Nous Mitjans",
"Plugin to embed in pages" => "Programes per incrustar en pàgines",
// "Enable related tracker field types" => "Enable related tracker field types",
"Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura partner settings" => "Kaltura partner settings",
// "Kaltura dynamic player" => "Kaltura dynamic player",
// "Kaltura contribution wizard" => "Kaltura contribution wizard",
"You can manually edit these values in lib/videogals/standardTikiKcw.xml" => "Pots editar manualment aquests valors en lib / videogals / standardTikiKcw.xml",
"Recreate KCW \"uiConf\"" => "Recrear KCW \"uiConf\"",
"Legacy support" => "Suport Llegat",
"Webservices" => "Webservices",
"Use the 'Quick Edit' module to easily create or edit wiki pages" => "Utilitza el mòdul \"edició ràpida\" per crear o editar fàcilment pàgines wiki",
// "List wiki pages" => "List wiki pages",
// "List structures" => "List structures",
"Page display" => "Visualització de pàgina",
// "Automatic table of contents" => "Automatic table of contents",
// "General features" => "General features",
"Export Wiki Pages" => "Exporta Pàgines del Wiki",
// "Redirect and Similar" => "Redirect and Similar",
// "Wikiwords Features" => "Wikiwords Features",
"If you change storage, it is better to move all the files for easy backup.." => "Si canvia d'emmagatzematge, és millor moure tots els arxius de còpia de seguretat fàcil ..",
// "Move all attachments to database" => "Move all attachments to database",
// "Move all attachments to file system" => "Move all attachments to file system",
"Remove unused pictures" => "Elimina fotos no emprades",
"Move images from wiki_up to the home file gallery" => "Moure imatges de wiki_up a la galeria d'arxius inicial",
// "Move images to home gallery" => "Move images to home gallery",
"If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "Si utilitza aquests botons plau assegureu-vos de tenir una còpia de seguretat de la base de dades i el directori wiki_up",
"Wiki watch" => "Subscripcions per correu-e al Wiki",
"Namespaces" => "Espais de noms",
"Settings that may be affected by the namespace separator" => "Ajustos que poden ser afectats pel separador d'espai de noms",
"Flagged Revision" => "Revisions Marcades",
"Page Listings" => "Llistats Pàgina",
"Select which items to display when listing pages" => "Seleccioneu els elements que voleu mostrar quan pàgines del llistat",
// "Database dumps and restores" => "Database dumps and restores",
// "Name for dump" => "Name for dump",
// "Create Database Dump" => "Create Database Dump",
// "Wiki database" => "Wiki database",
"Restore" => "Restaurar",
// "Dump files" => "Dump files",
// "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks" => "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks",
// "The HTML files generated may refer to files not included in the dump" => "The HTML files generated may refer to files not included in the dump",
// "Dumps do not include files attached to wiki pages" => "Dumps do not include files attached to wiki pages",
// "Dumping will overwrite the preexisting dump" => "Dumping will overwrite the preexisting dump",
// "Create Dump File" => "Create Dump File",
// "Download Dump File" => "Download Dump File",
// "Remove Dump File" => "Remove Dump File",
// "Mass replace and page permissions report" => "Mass replace and page permissions report",
"Mass search and replace" => "Cercar i reemplaçar massivament",
"Report wiki pages with direct object permissions" => "Informe pàgines wiki amb permisos d'objecte directe",
"Wiki attachments" => "Adjuncions del Wiki",
// "Move attachment to database" => "Move attachment to database",
// "Move to database" => "Move to database",
// "Move attachment to file system" => "Move attachment to file system",
// "Move to file system" => "Move to file system",
"Exclusive" => "Exclusiu",
"Share Common" => "Acció Ordinària",
"Edit perspective" => "Edita perspectiva",
// "No areas found. Click \"Update Areas\" to populate this list" => "No areas found. Click \"Update Areas\" to populate this list",
// "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> " => "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> ",
"Update areas" => "Actualització de les àrees",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>",
"Page links" => "Pàgina d'enllaços",
"Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature" => "Tingueu en compte que si la funció SEFURL està activada, els enllaços de pàgines creades amb wysiwyg no es podran actualitzar de forma automàtica quan es reanomenin pàgines. Aquesta qüestió s'aborda a través de la funció \"empra sintaxi Wiki en mode WYSIWYG\"",
// "WYSIWYG editor features" => "WYSIWYG editor features",
"Related features" => "Característiques relacionades",
"{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Posició",
"Cache Time" => "Temps en memòria cau",
"secs" => "segs",
"Use Ctrl+Click to select multiple options" => "Empra Ctrl+Click per a seleccionar multiples opcions",
"The" => "La",
"Display Modules to All Groups" => "Mòduls de pantalla per a tots els grups",
"setting will override your selection of specific groups" => "ajust anul·larà la selecció de grups específics",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrat ara per a tots els usuaris/es escollits inclós amb mòduls personalment assignats.",
"Displayed for the eligible users with no personal assigned modules" => "Mostrat per als usuaris/es escollits sense mòduls personalment no assignats",
"Displayed now, can't be unassigned" => "Mostrat ara, no es pot estar sense assignar",
"Not displayed until a user chooses it" => "No mostrat fins que l'usuari l'esculli",
"Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Atès que els usuaris <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">poden configurar els mòduls</a>, seleccioneu",
"to make sure users will notice any newly assigned modules" => "per garantir que els usuaris notaran els mòduls assignats recentment",
"required" => "requerit",
"Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Paràmetres: params específiques al mòdul i / o params generals  ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separador entre params: '&'. Per exemple maxlen=15&nonums=y",
"Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Introduïu els paràmetres en format URL, per exemple, 'nobox=y&class=rbox-data'",
"Edit custom module" => "Edita mòdul personalitzat",
// "Enter the code below" => "Enter the code below",
"Anti-Bot verification code image" => "Imatge del codi de verificació anti-robots",
"Try another code" => "Prova amb un altre codi",
// "Your article has been added" => "Your article has been added",
// "Create Article" => "Create Article",
"Author:" => "Autor:",
// "Expires" => "Expires",
"Users rating: " => "Valoració dels Usuaris: ",
"{\$topicName}" => "{\$topicName}",
// "List all articles of the same topic" => "List all articles of the same topic",
"{\$topicName|escape}" => "{\$topicName|escape}",
"{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
"You do not have permission to read complete articles" => "No té permís per llegir els articles complets",
"First page" => "Primera pàgina",
"Previous page" => "Pàgina anterior",
"Next page" => "Pàgina següent",
"Last page" => "Última pàgina",
"Related content" => "Contingut relacionat",
"bytes" => "octets",
// "Article actions" => "Article actions",
"Send a link" => "Envia un enllaç",
// "Get a short URL" => "Get a short URL",
"Attached files" => "Els arxius adjunts",
"Upload file" => "Pujar un arxiu",
// "File upload comment" => "File upload comment",
"Attach" => "Adjunció",
"Attach a file to this item" => "Afegeix un fitxer a aquest ítem",
"{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "més informació",
"No attachments for this item" => "No hi ha afegits per a aquest ítem",
// "Blog actions" => "Blog actions",
// "Blog Actions" => "Blog Actions",
"Monitor" => "Vigila-ho per correu-e",
// "Stop monitoring" => "Stop monitoring",
"Group Monitor" => "Subscriu a grups sencers d'usuaris",
"RSS" => "RSS",
"Watched by categories" => "Vigilat per categories",
// "Blog post actions" => "Blog post actions",
"Save to notepad" => "Guardar al bloc de notes",
// "Published By" => "Published By",
"Publish Date" => "Data de publicació",
"Previous post" => "Publicació prèvia",
"Next post" => "Publicació següent",
"More..." => "Més...",
"pages" => "pàgines",
"Last" => "Darrer",
"private" => "privat",
"permanent link" => "Enllaç de Permanència",
"Leave a comment" => "Deixa un comentari",
"%0 comment" => "%0 comentari",
"%0 comments" => "%0 comentaris",
// "{\$item.name}" => "{\$item.name}",
// "{\$sub.name}" => "{\$sub.name}",
"Parent Gallery" => "Galeria mare",
"No records found" => "No es trobaren registres",
"Category:" => "Categoria:",
"Select Categories" => "Selecciona Categories",
"Admin Categories" => "Administrar categories",
"Select/deselect all categories" => "Selecciona/deselecciona totes les categories",
"No categories defined" => "No hi ha categories definides",
"Browse Category" => "Navega per les categories",
"Are you sure you want to archive this comment" => "Estàs segur que vols arxivar aquest comentari",
"Are you sure you want to unarchive this comment" => "Estàs segur que desitges anul·lar l'arxiu d'aquest comentari",
// "Edit Comment" => "Edit Comment",
// "Comments unlocked" => "Comments unlocked",
"Post new comment" => "Publica un comentari nou",
"There are no comments at this time" => "No hi ha comentaris ara mateix",
"Add Comment" => "Afegeix un comentari",
"Reply" => "Respon",
"Archived" => "Arxivada/des",
"Unarchive" => "Desarxiva",
"Archive" => "Arxiu",
"Rejected" => "Rebutjat/da",
"Approve" => "Aprovar",
"Reject" => "Rebutja",
"Are you sure you want to lock comments on this object" => "Estàs segur que vols bloquejar comentaris sobre aquest objecte",
"Are you sure you want to approve this comment" => "Estàs segur que desitges aprovar aquest comentari",
"Are you sure you want to reject this comment" => "Estàs segur que vol rebutjar aquesta observació",
// "Go back to" => "Go back to",
"You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity" => "Actualment estàs registrat en aquest lloc. Aquesta secció és opcional. Al omplir, no vincular aquest missatge al seu compte i preservar el seu anonimat",
"Website" => "Lloc web",
"Send me an email when someone replies" => "Envia'm un correu-e quan algú respongui",
// "Are you sure you want to delete this comment" => "Are you sure you want to delete this comment",
"Are you sure you want to unlock comments on this object" => "Estàs segur que desitges desbloquejar comentaris sobre aquest objecte",
"Posted by" => "Publicat per",
"posts:" => "publicacions:",
// "Private message" => "Private message",
"private message" => "missatge privat",
// "Send eMail to user" => "Send eMail to user",
// "User online" => "User online",
// "User offline" => "User offline",
// "Download attachment" => "Download attachment",
// "Remove attachment" => "Remove attachment",
"Deliberation Items" => "Articles Deliberació",
"top of page" => "dalt de la pàgina",
"Notification" => "Notificació",
// "Delete post" => "Delete post",
"Report this post" => "Informa d'aquesta publicacó",
"Group monitor" => "Fes que un grup ho segueixi per correu-e",
// "Moderator actions for selected topics" => "Moderator actions for selected topics",
// "Reported messages" => "Reported messages",
"Reported" => "Mostrat a l'informe",
// "Queued messages" => "Queued messages",
"Queued" => "En cua",
"Sort:" => "Ordena:",
"Threshold" => "Llindar mínim",
"Replies" => "Respostes",
"below your current threshold" => "sota el teu llindar actual",
"New Reply" => "Resposta nova",
"Editing reply" => "Editant la resposta",
"Reply to the selected post" => "Respon a la publicació seleccionada",
"Post new message" => "Publica un nou missatge",
"If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address" => "Si desitja ser notificat quan algú respongui a aquest temes | si us plau digueu la vostra adreça de correu electrònic",
"Maximum size" => "Mida màxima",
"Reply to parent post" => "Respon a la publicació original",
"Post new reply" => "Publica una resposta nova",
"Post as Anonymous" => "Publica-ho anònimament",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Si us plau, tingues present que en previsualitzar no es manté l'arxiu adjunt i l'hauràs de seleccionar abans de publicar definitivament",
"Posting replies" => "Publicant respostes",
"Please enter a title" => "Si us plau, introdueix un títol",
"1 comment" => "1 comentari",
"Go back" => "Tornar Enrera",
"Return to home page" => "Torna a la pàgina d'inici",
"Type of contribution:" => "Tipus de contribució:",
// "No contribution records found" => "No contribution records found",
"{\$prefs.cookie_consent_description}" => "{\$prefs.cookie_consent_description}",
"{\$prefs.cookie_consent_question}" => "{\$prefs.cookie_consent_question}",
"{\$prefs.cookie_consent_button}" => "{\$prefs.cookie_consent_button}",
"Copyrights" => "Copyrights",
// "Authors" => "Authors",
"Copyright Holder" => "Titular de Dret d'Autor",
// "Do you really want to remove the %0 route" => "Do you really want to remove the %0 route",
"Back to tracker list" => "Tornar a la llista de seguiment",
"System error" => "Error del sistema",
"The following error message was returned" => "S'ha retornat el següent missatge d'error",
"Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Base de dades no està al dia! Visiteu <a href=\"tiki-install.php\"> l'Instal.lador de Tiki</a> per resoldre aquest problema",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "Si tens accés per consola (SSH), també pots utilitzar el següent, en la línia d'ordres, des de l'arrel de la instal·lació de Tiki",
"The query was" => "La consulta va ser",
"The built query was likely" => "La consulta construïda va ser probablement",
"Stacktrace" => "Stacktrace",
"Tiki is unable to connect to the database" => "Tiki no pot connectar-se a la base de dades",
"An error occurred while performing the request" => "S'ha produït un error en fer la sol·licitud",
"Current URL" => "URL actual",
"Command" => "Comanda",
"exec" => "executa",
"Type <code>help</code> to get list of available commands" => "Escriu <code>help</code> (ajuda) per obtenir una llista de les comandes disponibles",
"Page generation debugging log" => "Registre de depuració de la generació de pàgines",
"Features state" => "Estat de les característiques",
"features matched" => "característiques coincidents",
"Watchlist" => "Llista de coses vigilades",
// "Page discussion" => "Page discussion",
// "This page has been discussed once" => "This page has been discussed once",
// "Access discussion" => "Access discussion",
// "This page has been discussed %0 times" => "This page has been discussed %0 times",
// "Access discussion (%0 replies)" => "Access discussion (%0 replies)",
// "There are no discussions currently on this page" => "There are no discussions currently on this page",
// "Start discussion" => "Start discussion",
"Duplicate File Gallery" => "Duplica la galeria d'arxius",
"Duplicate categories" => "Duplica les categories",
"Duplicate permissions" => "Duplica els permisos",
"Duplicate" => "Duplica",
"There are individual permissions set for this file gallery" => "Existeixen permisos fixats individualment per a aquesta galeria de fitxers",
// "Manage Permissions" => "Manage Permissions",
"Properties" => "Propietats",
"{\$gal_info.name}" => "{\$gal_info.name}",
"Other (%0)" => "Altres (0%)",
"Any file" => "Qualsevol Arxiu",
"Podcast (audio)" => "Podcast (àudio)",
"Podcast (video)" => "Podcast (vídeo)",
"Gallery is visible to non-admin users" => "Gallery és visible per als usuaris que no siguin administradors",
"Gallery is unlocked" => "La Galeria no està bloquejada",
// "Users with upload permission can add files to the gallery (not just the gallery owner)" => "Users with upload permission can add files to the gallery (not just the gallery owner)",
// "Respect permissions for backlinks to view a file" => "Respect permissions for backlinks to view a file",
"Files can be locked at download" => "Els arxius poden ser tancades per la descàrrega",
"Maximum number of archives for each file" => "Nombre màxim d'arxius per a cada fitxer",
"unlimited" => "sense límit",
"Parent gallery" => "Galeria mare",
"Owner of the gallery" => "Propietari de la galeria",
"Mb" => "MegaOctets (Mb)",
"Min" => "Min",
"Group of users alerted when file gallery is modified" => "Grup d'usuaris d'alerta quan es modifica la galeria arxiu",
"Allows each user to be selected for small groups" => "Permet seleccionar cada usuari per a grups petits",
"Maximum width of images in gallery" => "Amplada màxima de les imatges a la galeria",
"If an image is wider than this, it will be resized" => "Si una imatge és més ampli que això, es canviarà la mida",
"Attention: In this case, the original image will be lost" => "Atenció: En aquest cas, la imatge original es perdrà",
"Maximum height of images in gallery" => "L'alçada màxima de les imatges a la galeria",
"If an image is higher than this, it will be resized" => "Si la imatge és més gran que això, es canviarà la mida",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup per entrar quan la imatge seleccionada de \"gerent de la galeria arxiu \"",
"The default is " => "Per omissió és",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Els noms de camp han de ser substituïts quan tancat en %caràcters. per exemple %fileId%, %name%, %filename%, %description%",
// "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs" => "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs",
// "Display Settings" => "Display Settings",
"Finder View" => "Vista de Finder (moderna)",
"Select which items to display when listing galleries" => "Seleccioneu els elements que voleu mostrar quan galeries llistat",
"Max description display size" => "Tamany màxim de la mostra de descripció",
"Max rows per page" => "Max files per pàgina",
// "View inserted gallery after save" => "View inserted gallery after save",
"File error" => "Error d'arxiu",
"Perhaps you are looking for:" => "Potser estaves cercant:",
"There are no wiki pages similar to '{\$page|escape}'" => "No hi ha pàgines wiki similars a '{\$page|escape}'",
"Token Error" => "Token Error",
"Go to Log in Page" => "Ves a la Pàgina per Connectar-te",
"Create this page" => "Crear aquest pàgina",
"(page will be orphaned)" => "(la pàgina es quedarà òrfena)",
"Close Window" => "Tanca Finestra",
// "Redirecting in %0 seconds" => "Redirecting in %0 seconds",
// "Permission successfully changed" => "Permission successfully changed",
// "Global permission" => "Global permission",
// "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)",
// "</em>\"}Object permission for the %0 %1" => "</em>\"}Object permission for the %0 %1",
// "Permissions successfully changed" => "Permissions successfully changed",
// "Global permissions" => "Global permissions",
// "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)",
// "</em>\"}Object permissions for the %0 %1" => "</em>\"}Object permissions for the %0 %1",
// "" => "",
// "No permissions were changed" => "No permissions were changed",
// "The following change has been applied" => "The following change has been applied",
// "The following changes have been applied" => "The following changes have been applied",
// "{\$item.mes[0]|stringfix}" => "{\$item.mes[0]|stringfix}",
"Preference name" => "Nom de la preferència",
"Upload" => "Puja",
"Open as WebFolder" => "Obre com a CarpetaWeb (webdav)",
// "Delete gallery" => "Delete gallery",
"Edit: " => "Edit:",
// "Display as PDF" => "Display as PDF",
"Download current version" => "Descarregueu la versió actual",
// "Browser display" => "Browser display",
"Archives" => "Arxius",
// "Upload new version" => "Upload new version",
// "Replace draft" => "Replace draft",
// "Upload draft" => "Upload draft",
// "Validate draft" => "Validate draft",
"Validate your draft" => "Valida el teu projecte",
// "Delete draft" => "Delete draft",
"Delete your draft" => "Eliminar el projecte",
// "Edit properties" => "Edit properties",
// "Refresh metadata" => "Refresh metadata",
// "Page view" => "Page view",
// "File already locked by %0" => "File already locked by %0",
// "Lock file" => "Lock file",
"Download and lock" => "Descarrega i bloqueja",
"Open your draft in WebDAV" => "Obriu el seu projecte a WebDAV",
"Open in WebDAV" => "Obre a través de WebDAV",
"Share a link to this file" => "Comparteix un enllaç a aquest arxiu",
"Email a link to this file" => "Envia per correu-e un enllaç a aquest arxiu",
"Click here to use the file" => "Clica aquí per a inserir amb sintaxi Wiki",
"The checkbox is disabled because this preference is disabled globally" => "La casella de verificació està desactivada perquè aquesta preferència està desactivada globalment",
// "Please enable the preference globally first" => "Please enable the preference globally first",
// "Site administrators can enable the preference" => "Site administrators can enable the preference",
"Show an icon in a column" => "Mostra una icona en una columna",
// "Search.." => "Search..",
// "Select files" => "Select files",
// "Too many files selected. De-select some files before adding more" => "Too many files selected. De-select some files before adding more",
// "Current Selection" => "Current Selection",
"Click to remove" => "Fes clic per eliminar",
"Upload Files" => "Puja fitxers",
// "Drop files or " => "Drop files or ",
// "Choose files" => "Choose files",
// "Automatic upload" => "Automatic upload",
// "Last modification: %0" => "Last modification: %0",
// "No files found" => "No files found",
"Upload from URL" => "Puja des de URL",
"URL:" => "URL:",
"File added" => "S'ha afegit l'arxiu",
// "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} " => "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} ",
// "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section" => "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section",
"Upload File" => "Puja l'arxiu",
// "Or drop files here from your file manager" => "Or drop files here from your file manager",
// "Or drop file here from your file manager" => "Or drop file here from your file manager",
// "Export PDF" => "Export PDF",
"Start the Slideshow" => "Inicia el passi de diapositives",
"Pause the Slideshow" => "Pausael passi de diapositives",
"There are no images to display" => "No hi ha cap imatge per a ser mostrada",
// "Select Files (%0)" => "Select Files (%0)",
"Sort By" => "Ordena per",
"Sort direction" => "Direcció d'ordenació",
"Any" => "Qualsevol",
"Lookup" => "Cercar",
"Deep search" => "Cerca profunda",
"Select Tags" => "Selecciona Marques (tags)",
"Include objects without a specified language" => "Inclou objectes sense llenguatge especificat",
// "View Saved Searches" => "View Saved Searches",
"Add to filter" => "Afegeix al filtre",
// "{\$whatlabel}" => "{\$whatlabel}",
"Clear Filter" => "Neteja el Filtre",
"any type" => "qualsevol tipus",
"Article Topic" => "Tema de l'article",
"any topic" => "qualsevol tòpic",
"any language" => "qualsevol idioma",
"not in" => "però no en",
// "Date From" => "Date From",
// "Date To" => "Date To",
"any category" => "qualsevol categoria",
"Multiple select" => "Selecció múltiple",
"{\$value}" => "{\$value}",
"{\$duration.label}" => "{\$duration.label}",
"Orphans" => "Òrfens/es",
"{\$find_other}" => "{\$find_other}",
// "Displayed rows" => "Displayed rows",
// "Hide Map" => "Hide Map",
// "Show Map" => "Show Map",
"Module errors" => "Errors de mòdul",
"The following modules could not be loaded" => "Els següents mòduls no es va poder carregar",
"Change" => "Canvia",
// "Show PHP error messages" => "Show PHP error messages",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Posa marques separades per espais. Per a marques amb més d'una paraula, no empris espais i posa les paraules juntes o bé envolta-les per dobles cometes",
"Untag" => "Desmarca",
// "Goal" => "Goal",
// "Eligible Groups" => "Eligible Groups",
// "No eligible groups" => "No eligible groups",
// "No goals configured yet" => "No goals configured yet",
// "Goal Administration" => "Goal Administration",
// "%0 was removed" => "%0 was removed",
// "Are you sure you want to delete %0" => "Are you sure you want to delete %0",
// "View Goal" => "View Goal",
// "Eligibility" => "Eligibility",
// "Goal Attribution" => "Goal Attribution",
// "Individual Goal" => "Individual Goal",
// "Group Goal" => "Group Goal",
// "Range Type" => "Range Type",
// "Rolling" => "Rolling",
// "Fixed" => "Fixed",
// "Time span" => "Time span",
// "In days" => "In days",
// "YYYY-MM-DD HH:MM:SS" => "YYYY-MM-DD HH:MM:SS",
// "Rewards are given to individuals achieving the goal or group members for group goals" => "Rewards are given to individuals achieving the goal or group members for group goals",
// "Changes will not be saved" => "Changes will not be saved",
// "Your changes to conditions are not saved until you save the goal" => "Your changes to conditions are not saved until you save the goal",
"Operator" => "Operador",
"At Least" => "Com a mínim",
"At Most" => "Com a molt",
// "Metric" => "Metric",
// "Event Type" => "Event Type",
// "Badge" => "Badge",
// "Hide condition from users" => "Hide condition from users",
// "Members of" => "Members of",
// "Your changes to rewards are not saved until you save the goal" => "Your changes to rewards are not saved until you save the goal",
// "Credit Type" => "Credit Type",
// "Credit Quantity" => "Credit Quantity",
// "Hide reward from users" => "Hide reward from users",
// "No conditions yet" => "No conditions yet",
// "Add Condition" => "Add Condition",
// "No rewards yet" => "No rewards yet",
// "Add Reward" => "Add Reward",
// "Modify Eligibility" => "Modify Eligibility",
// "No groups are eligible to this goal" => "No groups are eligible to this goal",
// "Major Version" => "Major Version",
// "Minor Version" => "Minor Version",
// "Tutorial URL" => "Tutorial URL",
// "Restricted" => "Restricted",
// "Return to list" => "Return to list",
"Images Galleries" => "Galeries d'Imatges",
"Edit this page" => "edita aquesta pàgina",
"RSS Wiki" => "RSS del Wiki",
"RSS Blogs" => "RSS dels Blocs",
"RSS Articles" => "RSS dels Articles",
"RSS Image Galleries" => "RSS de les Galeries d'Imatges",
"RSS File Galleries" => "RSS de les Galeries d'Arxius",
"RSS Forums" => "RSS dels Fòrums",
"RSS Directories" => "RSS dels Directoris",
"RSS Calendars" => "RSS dels Calendaris",
"RSS Tracker" => "RSS Formulari-bd",
// "Use Selected Icon" => "Use Selected Icon",
// "Do you really want to remove the custom IDS rule with Id %0" => "Do you really want to remove the custom IDS rule with Id %0",
// "Back to IDS Rules list" => "Back to IDS Rules list",
// "Toggle interactive translation" => "Toggle interactive translation",
"Once checked, click on any string to translate it" => "Un cop seleccionada, clica sobre qualsevol cadena de text per traduir-la",
// "Turn off interactive translation" => "Turn off interactive translation",
"Interactive Translation" => "Traducció interactiva",
"Translation" => "Traducció",
"Couldn't find any translatable string" => "No s'ha pogut trobar qualsevol cadena traduïble",
"Save translations" => "Desa les traduccions",
"Changes will be applied on next page load only" => "S'aplicaran els canvis un cop carreguis la pàgina de nou",
"Upload Successful" => "Pujar èxit",
// "custom.php" => "custom.php",
// "Download custom.php file for the selected language" => "Download custom.php file for the selected language",
// "custom.json" => "custom.json",
// "Download custom.json file for the selected language" => "Download custom.json file for the selected language",
// "Custom translation file does not exist. Save a custom translation to create the file" => "Custom translation file does not exist. Save a custom translation to create the file",
"Translations" => "Traduccions",
// "Translation text" => "Translation text",
// "Add a new row" => "Add a new row",
// "Add row" => "Add row",
// "Customized String Translations" => "Customized String Translations",
// "Manage custom translations" => "Manage custom translations",
// "Process Type" => "Process Type",
// "Select how the uploaded translations should be processed" => "Select how the uploaded translations should be processed",
// "No translations in the database available to export" => "No translations in the database available to export",
// "Translations in the database" => "Translations in the database",
// "Merge all translations, whether or not they are marked as general (for contribution)" => "Merge all translations, whether or not they are marked as general (for contribution)",
// "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database" => "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database",
"To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "Per ser capaç d'escriure les seves traduccions tornar a language.php assegureu-vos que el servidor web té permisos d'escriptura al lang/directori",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Toggle right modules" => "Toggle right modules",
// "Toggle left modules" => "Toggle left modules",
"Toggle module contents" => "Intercanvia el contingut del mòdul",
"Toggle" => "Commuta",
// "Move up" => "Move up",
// "Move down" => "Move down",
// "Move to opposite side" => "Move to opposite side",
// "{\$count_label}" => "{\$count_label}",
"Show Tree" => "Mostra l'Arbre",
"Hide Tree" => "Amaga l'Arbre",
// "Select action to perform with checked.." => "Select action to perform with checked..",
"Assign permissions to file galleries" => "Assignar permisos a les galeries d'arxius",
// "Delete selected items" => "Delete selected items",
// "Download zip version" => "Download zip version",
// "Reset to default list view settings" => "Reset to default list view settings",
// "Move selected file or gallery" => "Move selected file or gallery",
"Move to" => "Mou a",
// "Assign file gallery permissions to groups" => "Assign file gallery permissions to groups",
"No Additional Sort" => "Sense ordenació addicional",
"Other Sorts" => "Altres ordenacions",
// "Locked by-" => "Locked by-",
"No information" => "No hi ha informació",
"{\$topic|escape}" => "{\$topic|escape}",
"{\$type|escape}" => "{\$type|escape}",
// "The leader of " => "The leader of ",
// "has added you. To visit it, logon and go to the home page " => "has added you. To visit it, logon and go to the home page ",
// "You have been added" => "You have been added",
// "This is to inform you that your request to join" => "This is to inform you that your request to join",
// " has been accepted" => " has been accepted",
// "To visit it, go to the home page" => "To visit it, go to the home page",
// "Leader approved your request" => "Leader approved your request",
// "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the" => "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the",
// "Leader rejected your request" => "Leader rejected your request",
// "This is to inform you that you have been removed from " => "This is to inform you that you have been removed from ",
// " If you did not request this removal, or have any questions or concerns, please contact" => " If you did not request this removal, or have any questions or concerns, please contact",
// "You have been removed from it" => "You have been removed from it",
"Upgrade Available" => "Actualització disponible",
"Upgrades Available" => "Actualitzacions disponible",
// "{\$subject}" => "{\$subject}",
// "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link" => "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link",
"Blog post:" => "Publicació de bloc:",
"at:" => "a:",
"Gift Certificate Information" => "Informació de certificat de regal",
"Name:" => "Nom:",
"Description:" => " Descripció",
"Percentage Discount" => "Percentatge de descompte",
"Value of Gift Certificate" => "Valor de certificat de regal",
"Redeem Code" => "Canviar Codi",
// "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase" => "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase",
// "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made" => "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made",
"You can review your order at" => "Pots revisar la teva comanda en",
// "Your {\$prefs.mail_template_custom_text}cart order" => "Your {\$prefs.mail_template_custom_text}cart order",
// "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site" => "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site",
"To the newsletter:" => "Als butlletins de notícies:",
// "Please access the following URL to confirm your subscription" => "Please access the following URL to confirm your subscription",
// "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link" => "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link",
"The administrator approved your account." => "L'administrador ha aprovat el teu compte.",
// "Confirm your {\$prefs.mail_template_custom_text}email at %s" => "Confirm your {\$prefs.mail_template_custom_text}email at %s",
// "Remove {\$prefs.mail_template_custom_text}file" => "Remove {\$prefs.mail_template_custom_text}file",
"GalleryId" => "GalleryId",
"Identifier" => "Identificador",
// "{\$prefs.mail_template_custom_text}File Gallery quota exceeded" => "{\$prefs.mail_template_custom_text}File Gallery quota exceeded",
"User:" => "Usuari/a:",
// "A new message was posted to {\$prefs.mail_template_custom_text}forum" => "A new message was posted to {\$prefs.mail_template_custom_text}forum",
"New topic:" => "Tòpic nou:",
// "An anonymous {\$prefs.mail_template_custom_text}user" => "An anonymous {\$prefs.mail_template_custom_text}user",
"Title:" => "Títol:",
"An anonymous user" => "Un usuaria anònim",
// "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL",
// "Note that this is an edited post" => "Note that this is an edited post",
"Topic:" => "Tema:",
// "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL" => "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL",
// "To instantly approve this post without logging in, use the following URL" => "To instantly approve this post without logging in, use the following URL",
// "You have been invited to access %0 by %1" => "You have been invited to access %0 by %1",
// "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0" => "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0",
// "Your access is valid until %0" => "Your access is valid until %0",
// "Your {\$prefs.mail_template_custom_text}temporary access to %0" => "Your {\$prefs.mail_template_custom_text}temporary access to %0",
"You are invited by" => "Estàs convidat per",
"You join this group" => "T'apuntes a aquest grup",
"Join me on %s" => "Apunta'm a %s",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "{\$prefs.mail_template_custom_text}page not found" => "{\$prefs.mail_template_custom_text}page not found",
// "%0 mentioned you in %1" => "%0 mentioned you in %1",
// "You've been mentioned on %0" => "You've been mentioned on %0",
"A new {\$prefs.mail_template_custom_text}message was posted to you" => "S'ha publicat un nou missatge per a tu {\$prefs.mail_template_custom_text}",
"Click here to read the full message and / or reply" => "Clica aquí per a llegir el missatge sencer i / o respondre",
"New {\$prefs.mail_template_custom_text}message arrived from %s" => "Ha arribat un nou missatge {\$prefs.mail_template_custom_text} de part de %s",
"Hi" => "Hola",
"Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "La petició de registre de compte {\$prefs.mail_template_custom_text} per a {\$mail_site} ha estat validada per les persones adminisgtradores i el teu compte ara ja és actiu",
"To login with your username and password, please follow this link:" => "Per connectar-te amb el teu nom d'usuari i contrasenya, segueix aquest enllaç, si us plau:",
"Enjoy the site!" => "Disfruta del lloc!",
"User Account Activated" => "Compte d'usuari/a Tiki activat",
"{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first" => "{\$mail_user} <{\$mail_email}> ha demanat una nova contrasenya a {\$mail_site}, però tu primer has de validar el compte {\$prefs.mail_template_custom_text}",
"has requested an account on" => "ha demanat un compte a",
"Group:" => "Grup:",
"User Tracker" => "Formulari-bd d'usuaris",
"To validate that {\$prefs.mail_template_custom_text}account, please follow the link" => "Per validar aquest compte {\$prefs.mail_template_custom_text}, si us plau segueix l'enllaç",
"Assign to a group" => "Assigna a un grup",
"View user's data" => "Visualitza les dades de l'usuari",
"Best regards" => "Records",
"User Registration Request" => "Petició de Registre d'Usuari",
"Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request" => "Ves a la teva xarxa d'amistat per a acceptar o rebutjar aquesta petició {\$prefs.mail_template_custom_text}",
"You're invited to join my {\$prefs.mail_template_custom_text}network of friends" => "Has estat convidat a unir-te la meva xarxa d'amistats {\$prefs.mail_template_custom_text}",
"The user" => "L'usuari/a",
"registered at your {\$prefs.mail_template_custom_text}site" => "s'ha registrat al teu lloc {\$prefs.mail_template_custom_text}site",
"New {\$prefs.mail_template_custom_text}user registration" => "Nou registre d'usuari/a {\$prefs.mail_template_custom_text}",
// "Start of article" => "Start of article",
"Published" => "Publicat/da",
"By:" => "Per",
"Bye bye!" => "Adéu!",
// "This email address has been removed from the list of subscribers of: " => "This email address has been removed from the list of subscribers of: ",
"Newsletter:" => "Butlletí:",
"Bye bye from %s at %s" => "Fins aviat, de %s en %s",
// "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link" => "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link",
"Welcome to our newsletter!" => "Benvingut/da al nostre butlletí!",
"This email address has been added to the list of subscribers of: " => "S'ha afegit aquesta adreça de coprreu-e a la llista de subscriptors/es de: ",
"You can always cancel your subscription using:" => "Sempre pots cancel.lar la teva subscripció emprant:",
"Welcome to %s at %s" => "Benvingut/da %s  %s",
"Reply Notification: " => "Notificació de resposta: ",
"{\$prefs.mail_template_custom_text}Email Notification" => "Notificació per correu-e {\$prefs.mail_template_custom_text}",
"Someone requested a password reset for your %0account" => "Algú ha demanat una contrasenya nova per al teu compte %0",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Si us plau, clica en el següent enllaç per confirmar que vols canviar la teva contrasenya i anar a la pantalla on hauràs d'introduir una contrasenya nova. Si us plau, escull una contrasenya que només sàpigues tu, i no la comparteixis amb altres persones",
"Important: Username & password are CaSe SenSitiVe" => "Important: el nom com a persona usuària i la contrasenya són sensibles a les Majúscules i minúscules",
"Important: The old password remains active if you don't click the link above." => "Important: La teva antiga contrasenya roman activa si no punxes sobre l'enllaç de més amunt.",
"Your account information for %s" => "La informació del teu compte Tiki per %s",
"}Plugin %0 is pending approval on %1" => "} Programes %0 està pendent d'aprovació a %1",
// "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>",
"Plugin arguments" => "Arguments Plugin",
"Report on %0 for %1" => "Informe sobre %0 per a %1",
"Last {\$prefs.mail_template_custom_text}Report sent on %0" => "Darrer Informe {\$prefs.mail_template_custom_text} enviat el dia %0",
"Changes in detail" => "Canvis en detall",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Estàs rebent correus-e de notificació agrupats en un resum periòdic. Per a rebre'ls en canvi individualment tot just es publiquin, canvia les teves preferències a %0",
// "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at" => "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at",
"Feed" => "Alimentar",
// "New categories" => "New categories",
// "Configure settings for the new category at" => "Configure settings for the new category at",
// "New {\$prefs.mail_template_custom_text}source category in RSS feed" => "New {\$prefs.mail_template_custom_text}source category in RSS feed",
// "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes",
"Details" => "Detalls",
"Site" => "Lloc",
// "[%0] Scheduler \"%1\" was healed" => "[%0] Scheduler \"%1\" was healed",
// "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes",
// "[%0] Scheduler \"%1\" is stalled" => "[%0] Scheduler \"%1\" is stalled",
// "Look at this {\$prefs.mail_template_custom_text}link" => "Look at this {\$prefs.mail_template_custom_text}link",
// "A friend sends you a {\$prefs.mail_template_custom_text}link from: " => "A friend sends you a {\$prefs.mail_template_custom_text}link from: ",
// "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link:" => "Pots editar l'enviament seguint aquest enllaç:",
"Heading:" => "Encapçalament:",
"Body:" => "Cos:",
// "New {\$prefs.mail_template_custom_text}article submitted at %s" => "New {\$prefs.mail_template_custom_text}article submitted at %s",
// "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}" => "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}",
// "{\$mail_user|username}" => "{\$mail_user|username}",
// "{\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "{\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}",
// "View the {\$prefs.mail_template_custom_text}tracker item at" => "View the {\$prefs.mail_template_custom_text}tracker item at",
// "The last content before deletion was as follows" => "The last content before deletion was as follows",
"Download the file at:" => "Descarrega l'arxiu a:",
// "{\$mail_trackerName}" => "{\$mail_trackerName}",
"item" => "ítem",
// "was deleted at" => "was deleted at",
"was modified at" => "ha estat modificat a",
// "Please visit this {\$prefs.mail_template_custom_text}link before logging in again" => "Please visit this {\$prefs.mail_template_custom_text}link before logging in again",
"Last attempt" => "Darrer intent",
// "Confirm your {\$prefs.mail_template_custom_text}account at %s" => "Confirm your {\$prefs.mail_template_custom_text}account at %s",
// "{\$prefs.mail_template_custom_text}Site" => "{\$prefs.mail_template_custom_text}Site",
// "{\$prefs.mail_template_custom_text}Account suspended" => "{\$prefs.mail_template_custom_text}Account suspended",
// "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user" => "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Si vols confirmar que vols ser membres d'aquest lloc web, clica al següent enllaç per a connectar-te per primer cop",
"Welcome to the site!" => "Benvingut/da al lloc web",
"Your personal access to" => "El teu accés personal a",
// "joined" => "joined",
// "User joined" => "User joined",
// "You are getting this email because you are a leader of" => "You are getting this email because you are a leader of",
// "Click here to manage members" => "Click here to manage members",
// "You are getting this email because you are a leader" => "You are getting this email because you are a leader",
// "The user needs to be approved before he is admitted" => "The user needs to be approved before he is admitted",
// "user joined" => "user joined",
// "You are getting this email because you are a group leader" => "You are getting this email because you are a group leader",
// "left" => "left",
// "user left" => "user left",
"You or someone registered this email address at" => "tu o alguna persona ha registrat aquesta adreça de correu-e a",
// "If you want to be a registered user in this %0site you will have to use the following link to login for the first time" => "If you want to be a registered user in this %0site you will have to use the following link to login for the first time",
// "Your {\$prefs.mail_template_custom_text}registration confirmation" => "Your {\$prefs.mail_template_custom_text}registration confirmation",
"You will receive an email with the information needed to log into this site the first time" => "Rebràs un correu electrònic amb la informació necessària per a accedir a aquest lloc per primera vegada",
"Your account request has been stored and will be activated by the admin as soon as possible." => "La teva petició de compte ha estat arxivada i serà activada per la persona administradora tan aviat com li sigui possible.",
"You'll receive email notification once your account is activated." => "Rebràs notificació per correu-e un cop ja s'hagi activat el teu compte.",
"Please do not attempt to login until you receive the email notification." => "Si us plau, no intentis connectar-te fins que rebis la notificació per correu-e.",
// "New {\$prefs.mail_template_custom_text}article post" => "New {\$prefs.mail_template_custom_text}article post",
// "Edit {\$prefs.mail_template_custom_text}article post" => "Edit {\$prefs.mail_template_custom_text}article post",
// "Delete {\$prefs.mail_template_custom_text}article post" => "Delete {\$prefs.mail_template_custom_text}article post",
"{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} per {\$mail_user|username} el",
"View the article at:" => "Visualitza l'article a:",
"Expiration Date" => "Data de caducitat",
"If you don't want to receive these notifications follow this link:" => "Si no vols rebre aquestes notificacions segueix aquest enllaç:",
"The old article follows" => "L'article antic segueix a sota",
// "New {\$prefs.mail_template_custom_text}article post at" => "New {\$prefs.mail_template_custom_text}article post at",
// "Edited {\$prefs.mail_template_custom_text}article post at" => "Edited {\$prefs.mail_template_custom_text}article post at",
// "Deleted {\$prefs.mail_template_custom_text}article post at" => "Deleted {\$prefs.mail_template_custom_text}article post at",
// "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at:" => "Visualitza el bloc a:",
// "New {\$prefs.mail_template_custom_text}blog post at %s" => "New {\$prefs.mail_template_custom_text}blog post at %s",
"View item calendar at:" => "Mostra l'entrada del calendari a:",
// "Modified {\$prefs.mail_template_custom_text}calendar item" => "Modified {\$prefs.mail_template_custom_text}calendar item",
// "New {\$prefs.mail_template_custom_text}calendar item" => "New {\$prefs.mail_template_custom_text}calendar item",
"changed" => "modificat",
// "A new {\$prefs.mail_template_custom_text}category was created in" => "A new {\$prefs.mail_template_custom_text}category was created in",
"Created by:" => "Creat per:",
"created" => "creat",
// "A {\$prefs.mail_template_custom_text}category was removed in" => "A {\$prefs.mail_template_custom_text}category was removed in",
"Removed by" => "Eliminat per",
"removed" => "eliminat/da",
// "A {\$prefs.mail_template_custom_text}category was updated" => "A {\$prefs.mail_template_custom_text}category was updated",
"Updated by" => "Actualitzat per",
"Old:" => "Antic:",
"updated" => "Actualitzat",
// "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by",
"an anonymous user" => "un usuari anònim",
// "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by",
"You can view the comment by following this link" => "Pots veure el comentari en el següent enllaç",
"Comment:" => "Comentari:",
"File Gallery %s changed" => "La galeria d'arxius %s ha canviat",
// "A file was removed from the {\$prefs.mail_template_custom_text}file gallery" => "A file was removed from the {\$prefs.mail_template_custom_text}file gallery",
// "A new file was posted to {\$prefs.mail_template_custom_text}file gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}file gallery",
"File Description" => "Descripció de l'arxiu",
// "You can download the new file at" => "You can download the new file at",
// "The new file ID is %0 and it is in gallery ID %1" => "The new file ID is %0 and it is in gallery ID %1",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "Ha canviat la galeria d'imatges {\$galleryName}",
// "A new file was posted to {\$prefs.mail_template_custom_text}image gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}image gallery",
// "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link:" => "Pots veure el mapa actualitzat seguint aquest enllaç:",
"You can edit the map following this link:" => "Pots editar el mapa seguint aquest enllaç:",
// "An object was added to {\$prefs.mail_template_custom_text}category" => "An object was added to {\$prefs.mail_template_custom_text}category",
"Added by" => "Afegit per",
"Object type:" => "Tipus d'objecte:",
// "An object was removed from {\$prefs.mail_template_custom_text}category" => "An object was removed from {\$prefs.mail_template_custom_text}category",
// "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure" => "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure",
"Structure modified" => "Estructura modificada",
"has consulted your" => "ha consultat al seu",
"Go to the File Gallery" => "Anar a la galeria Arxiu",
"Download the file" => "Descarregueu el fitxer",
// "A new file has been attached to {\$prefs.mail_template_custom_text}page" => "A new file has been attached to {\$prefs.mail_template_custom_text}page",
"File name" => "Nom de l'arxiu",
// "New {\$prefs.mail_template_custom_text}attachment on %s, page" => "New {\$prefs.mail_template_custom_text}attachment on %s, page",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here" => "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here",
"You can view the page by following this link:" => "Pots veure la pàgina si segueixes aquest enllaç:",
"You can view a diff back to the previous version by following this link:" => "Pots veure els canvis respecte la versió anterior si segueixes aquest enllaç:",
"The changes in this version follow below, followed after by the current full page text." => "Els canvis en aquesta versió són a sota, seguides després per la versió sencera actual del text de la pàgina.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Línies: {\$oldd} canviades per +Línies: {\$newd}",
"The old page content follows below" => "L'anterior contingut de la pàgina es mostra a continuació a sota",
"The new page content follows below." => "El nou contingut de la pàgina segueix a sota.",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}",
"Wiki page renamed" => "La pàgina Wiki ha estat reanomenada",
"Old name" => "Nom vell",
"New name" => "Nou nom",
// "Your %0account ID" => "Your %0account ID",
// "has been generated" => "has been generated",
// "Thank you for your %0registration" => "Thank you for your %0registration",
"You may log in now." => "Ara pots connectar-te.",
// "Operation Completed" => "Operation Completed",
// "Return to Query List" => "Return to Query List",
// "Do you really want to remove the %0 account" => "Do you really want to remove the %0 account",
// "Delete Account" => "Delete Account",
"Active" => "Actiu/va",
"Account name" => "Nom del compte",
// "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND" => "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND",
// "Reply handler requires notifications to be enabled and the reply email pattern to be configured" => "Reply handler requires notifications to be enabled and the reply email pattern to be configured",
"POP server" => "Servidor POP",
// "POP" => "POP",
"IMAP" => "IMAP",
"Admin Topics" => "Admin temes",
"Admin Types" => "Administrar tipus",
"Allow anonymous access" => "Permetre accès anònim",
// "Warning: Enabling anonymous access will disable all permission checking for mailed-in content" => "Warning: Enabling anonymous access will disable all permission checking for mailed-in content",
// "Allow admin access" => "Allow admin access",
// "Administrators have full access to the system. Disabling admin mail-in is the safest option" => "Administrators have full access to the system. Disabling admin mail-in is the safest option",
"Allow attachments" => "Permetre adjunts",
// "Allow routing" => "Allow routing",
// "Allow per user routing of incoming email to structures" => "Allow per user routing of incoming email to structures",
// "Show inline images" => "Show inline images",
// "For HTML email, attempt to create a WYSIWYG wiki-page" => "For HTML email, attempt to create a WYSIWYG wiki-page",
// "Keep HTML format" => "Keep HTML format",
// "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection" => "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection",
"Discard to the end from" => "Descarta fins al final des de",
// "Auto-assign category" => "Auto-assign category",
// "Only affects wiki-put, when creating a new wiki page" => "Only affects wiki-put, when creating a new wiki page",
// "Auto-assign namespace" => "Auto-assign namespace",
// "Email response when no access" => "Email response when no access",
// "Leave email on server on error" => "Leave email on server on error",
// "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki" => "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki",
// "Add Account" => "Add Account",
// "Operation not reversible" => "Operation not reversible",
// "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used" => "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used",
"Event" => "Esdeveniment",
// "Disable rule" => "Disable rule",
// "Enable rule" => "Enable rule",
// "Unknown status" => "Unknown status",
// "Current Type" => "Current Type",
// "New Type" => "New Type",
// "The rule has been removed" => "The rule has been removed",
// "Are you sure you want to delete this rule" => "Are you sure you want to delete this rule",
// "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it" => "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it",
// "Sample Rule" => "Sample Rule",
// "Basic Rule (Record Event)" => "Basic Rule (Record Event)",
// "Tracker Rule" => "Tracker Rule",
// "Advanced Rule" => "Advanced Rule",
// "Community Control Panel" => "Community Control Panel",
// "Event Chain Diagram" => "Event Chain Diagram",
// "Rule Type" => "Rule Type",
// "Allow Notifications" => "Allow Notifications",
// "Recipient" => "Recipient",
// "Cached sample data helps to view available variables for event types" => "Cached sample data helps to view available variables for event types",
// "Sample available" => "Sample available",
// "Sample currently not available" => "Sample currently not available",
// "Source Event" => "Source Event",
// "Target Event" => "Target Event",
// "All event names are required to have at least 3 components" => "All event names are required to have at least 3 components",
// "%0 Copy" => "%0 Copy",
// "Clone of Menu Id" => "Clone of Menu Id",
// "Symbol Information" => "Symbol Information",
// "Profile Source" => "Profile Source",
"Clone" => "Clona-ho",
"dynamic collapsed" => "col·lapsat dinàmic",
"dynamic extended" => "dinàmic extès",
"fixed" => "fixat",
"Labels of all options will be wiki parsed" => "Les etiquetes de totes les opcions seran wiki analitzat",
"Folder Icon" => "Icona de la carpeta",
"Path and filename of closed folder icon" => "Ruta d'accés i nom de fitxer de la icona de carpeta tancada",
"Configure icons for menu entries" => "Configuració d'icones per a les entrades del menú",
"For wiki page, use ((PageName))" => "A la pàgina wiki, ús ((NombrePágina))",
"Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecció de 2 grups significa que l'opció es veurà si l'usuari pertany als 2 grups. Si voleu que els 2 grups per veure l'opció, crear 2 opcions amb un grup cada",
"If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "Si l'adreça URL és ((NombrePágina)), no cal posar els grups, l'opció només es mostra si la pàgina es pot visualitzar",
"Sections" => "Seccions",
"Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Feature / preferències amb una coma (,) per a una I o una barra vertical Separeu (|) per un OR",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separa permisos amb una coma (,) per a una I o una barra vertical (|) per un OR",
// "Input an HTML class value for the menu option. Separate with a space for multiple classes" => "Input an HTML class value for the menu option. Separate with a space for multiple classes",
"Tips" => "Consells",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "Per afegir noves opcions al menú estableix el camp optionId a 0. Per suprimir una opció configura el camp per treure a 'y'",
// "Duplicate options will be ignored" => "Duplicate options will be ignored",
"Show Quick URLs" => "Mostra Urls Ràpides",
"Some useful URLs" => "Algunes URLS útils",
"Hide Quick URLs" => "Amaga Urls Ràpides",
"Home" => "Inici",
"Choose" => "Escull",
"Home Page" => "Pàgina Inicial",
"Home Blog" => "Bloc Inicial",
"Home Image Gal" => "Galeria d'imatges Inicial",
"Home Image Gallery" => "Galeria d'imatges Inicial",
"Home File Gal" => "Galeria d'arxius Inicial",
"Home File Gallery" => "Galeria d'arxius Inicial",
"User preferences" => "Preferències de l'usuari",
"User prefs" => "Prefs de l'usuari",
"Wiki Home" => "Inici del Wiki",
"List galleries" => "Llista les galeries",
"List image galleries" => "Llista galeries d'imatges",
"Upload image" => "Pujar imatge",
"Gallery Rankings" => "Posicions de galeries",
"Browse a gallery" => "Fulleja una galeria",
"Articles home" => "Inici d'articles",
"All articles" => "Tots els articles",
"List Blogs" => "Llista Blocs",
"Create Blog" => "Crea Bloc",
"View a forum" => "Visualitza fòrum",
"View a thread" => "Visualitza missatge",
"View a FAQ" => "Veure una PUF",
"Take a quiz" => "Resol un test",
"Quiz stats" => "Estadístiques dels Tests",
"Stats for a Quiz" => "Estadístiques per un Test",
"Message Archive" => "Arxiu de missatges",
"Archive is full!" => "L'arxiu és ple!",
"Unread" => "No llegit",
"Flagged" => "Marcada",
"Unflagged" => "Desmarcada",
"Containing" => "Contenint",
"Sender" => "Remitent",
"No messages to display" => "No hi ha cap missatge per mostrar",
"Broadcast message" => "Difondre un missatge",
"All users" => "Tots els usuaris",
"Lowest" => "El més baix",
"Very High" => "Molt Alt",
"Body" => "Cos",
"Send" => "Envia",
"Compose message" => "Escriu un missatge",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Si vols que la gent et pugui respondre, habilita l'opció <a href='tiki-user_preferences.php'>Permet missatges d'altres usuaris</a> a les teves preferències.",
// "To: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "To: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"CC" => "CC",
// "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"Reply-to my email" => "Respon-me al meu correu-e",
"The user will be able to reply to you directly via email" => "La persona usuària podrà respondre't directament via correu-e",
"Send me a copy" => "Envia'm una còpia",
"You will be sent a copy of this email" => "Se t'enviarà una còpia d'aquest correu-e",
"No messages to download" => "No hi ha missatges per descarregar",
// "full" => "full",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "La bústia de correu és plena! Esborra o arxiva alguns missatges si vols rebre'n més.",
"is reply to" => "és resposta a",
"Find replied message" => "busca missatges contestats",
"Perform action with checked:" => "Amb els seleccionats, realitza l'acció:",
"Mark as read" => "Marca com llegit",
"Mark as unread" => "Marca com no llegit",
"Mark as flagged" => "Marca com a senyalat",
"Mark as unflagged" => "Marca com no senyalat",
"Mark" => "marca",
"Mailbox" => "Bústia",
"Compose" => "Redacta",
"Broadcast" => "Difon",
"Auto-archive age for read messages:" => "Edat d'autoarxivament per als missatges llegits:",
"Read message" => "Llegeix missatge",
// "Flagged:Click to unflag" => "Flagged:Click to unflag",
// "Not flagged:Click to flag" => "Not flagged:Click to flag",
"replyall" => "respondre tot",
// "Reply All" => "Reply All",
"From:" => "de part de:",
"Cc" => "Cc",
// "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>",
// "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>",
"Sent Messages" => "Missatges enviats",
"Replied" => "Respost",
"Not replied" => "No repost",
// "Move to archive" => "Move to archive",
"Image Metadata for" => "Metadades d'imatge per",
"<em>Note: only basic metadata processed for this file type</em>" => "<em> Nota: només metadades bàsics processats per a aquest tipus d'arxiu </em>",
"{\$subtypes@key|escape}" => "{\$subtypes@key|escape}",
"{\$fields@key|lower|capitalize|escape}" => "{\$fields@key|lower|capitalize|escape}",
"{\$fieldarray.label|escape}" => "{\$fieldarray.label|escape}",
"{\$fieldarray@key|escape}" => "{\$fieldarray@key|escape}",
"{\$fieldarray.suffix|escape}" => "{\$fieldarray.suffix|escape}",
"No metadata found" => "No s'han trobat les metadades",
"Read-only metadata extracted from the file" => "De només lectura metadades extreu de l'arxiu",
"<em>Only basic metadata processed for this file type.</em>" => "<em> metadades Només bàsica processada per a aquest tipus d'arxiu. </em>",
"Control panels" => "Panells de control",
"Turn on interactive translation" => "Activa la traducció interactiva",
"Comment moderation" => "Moderació de Comentaris",
"Clear all caches" => "Neteja totes les memòries cau",
"Plugin approval" => "Aprovació de Plugins",
"Logs" => "Registres",
"Smarty debug window" => "Finestra de depuració de smarty",
"Display type unknown, you have to enter the banner type" => "Tipus de pantalla desconegut, has d'introduir el tipus de pancarta",
"You forgot your Google ad_client number !" => "Heu oblidat el vostre número de Google ad_client!",
"Thank you for installing Tiki" => "Gràcies per instal·lar Tiki",
"To configure your Tiki" => "Per configurar el teu Tiki",
"from the menu" => "des del menú",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Llegiu la <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">documentació de configuració</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Mira els <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">videos de demostració",
"To remove this module" => "Per eliminar aquest mòdul",
"Admin Modules" => "Administració de Mòduls",
"and remove the assistant module" => "i eliminar el mòdul de l'assistent",
"You can also add other modules" => "Pots afegir també altres mòduls",
"To customize the menu" => "Per adaptar el menú",
"Admin Menus" => "Administració de Menús",
"and edit menu ID 42" => "i edita el menú ID 42",
"Or, create your own menu and add it to a module" => "O, crea el teu propi menú i afegeix-ho com a mòdul",
"To begin configuring Tiki, please" => "Per començar a configurar Tiki, si us plau",
"login" => "connecta't",
"as admin" => "com l'Administrador",
"The Tiki Community" => "La Comunitat de Tiki",
"To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "Per obtenir més informació, visiteu: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
"Tiki Documentation" => "Tiki Documentació",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "Per obtenir ajuda, visiteu <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\"> http://doc.tiki.org </a>",
"on" => "en",
"Published on" => "Publicat el",
"on blogpost" => "a blogpost",
"Untitled" => "Intitulat",
"{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
"{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add Event" => "Afegeix Esdeveniment",
"Unit cost" => "Cost unitari",
"Qty" => "Quantitat",
"Cart contains <span>%0</span> items" => "El carret conté <span>%0</span> ítems",
"Total weight %0 %1" => "Pes Total %0 %1",
"Gift Certificate" => "Un certificat de regal",
"Remove Gift Certificate" => "Eliminar un certificat de regal",
"Add Gift Certificate" => "Afegir un certificat de regal",
"Check-out" => "Sortida",
"Your cart is empty" => "La teva cistella està buida",
"Missing %0 of the following categories" => "Manca de %0 de les següents categories",
"%0 extra of the following categories" => "%0 addicional de les següents categories",
"Unknown comparison" => "Desconegut comparació",
"Impossible condition, %0 of" => "Condició impossible, %0 de",
"Assign into category" => "Assigneu a la categoria",
"{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
"Unassign category" => "Anul·lar categoria",
"{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "Pàgines:",
"{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Pàgina inicial",
"1 more contributor" => "1 col·laborador més",
"{\$hiddenContributors} more contributors" => "{\$hiddenContributors} més contribuïdors",
"low" => "baixa",
"Sites" => "Llocs",
"Sites to validate" => "Llocs per validar",
"Categories:" => "Categories:",
"Visited links" => "Enllaços visitats",
"Pass" => "Contrasenya",
"By" => "Per",
"Add tags" => "Afegeix etiquetes",
// "No tags yet" => "No tags yet",
"List everything tagged" => "Llista tot el que estigui etiquetat",
"Last updated" => "Actualitzat per darrera vegada el",
"All Groups" => "Tots els Grups",
"Your Groups" => "Els teus Grups",
"Emulated Groups" => "Grups emulades",
"Switch to Groups" => "Canvia a Grups",
"Simulate" => "Simula-ho",
"Add Post" => "Afegeix Missatge",
"insert original" => "inserta l'original",
"insert thumbnail" => "insert el contacte",
"more" => "més",
"Last %0 Podcasts" => "Darrera %0 Podcasts",
"This is likely not a podcast file" => "Això no és probable que un arxiu de podcast",
"The path to a podcast player is required" => "Es requereix que la ruta d'accés a un reproductor de podcasts",
"{\$link_text}" => "{\$link_text}",
"No profile picture" => "Sense avatar",
"You" => "Tu",
"Never logged in" => "Mai s'ha connectat",
"{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Obre la consola d'operador",
"Execution time" => "Temps d'execució",
"Memory usage" => "Memòria d'ús",
"Queries" => "Consultes",
"Server load" => "Càrrega del servidor",
"Logged in as" => "Connectat com a",
"Log out" => "Desconnecta't",
"Return to Main User" => "Retorna a l'usuari principal",
// "Return to main user" => "Return to main user",
"Switch" => "Canvi",
"Switch User" => "Canvia't per l'Usuari",
"Email:" => "Correu-e:",
// "Email address or " => "Email address or ",
// "User account ID" => "User account ID",
"Enter a username and click 'Switch'.<br>Useful for testing permissions" => "Escriu el nom d'usuari i fes clic a 'Canvia'. <br>Útil per comprovar permisos",
"Switch user" => "Canvia usuari",
// "Toggle Dropdown" => "Toggle Dropdown",
"My Account" => "ElmeuTiki",
// "{\$user|username|escape|replace:'&amp;':'&'}" => "{\$user|username|escape|replace:'&amp;':'&'}",
"Log in through CAS" => "Entrada a través de CAS",
"Log in as admin" => "Inicieu la sessió com a administrador",
"Log in through Shibboleth" => "Entrada a través de Shibboleth",
// "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t" => "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t",
"CapsLock is on" => "Tens activada la tecla de bloqueig de majúscules",
"Click here if you've forgotten your password" => "Fes clic aquí si has oblidat la teva contrasenya",
"I forgot my password" => "He oblidat la meva contrasenya",
"Click here to register" => "Fes clic aquí per registrar-te",
"Click here to log in using the default security protocol" => "Fes clic aquí per entrar usant el protocol de seguretat per defecte",
"Standard" => "Estàndar",
"Click here to log in using a secure protocol" => "Fes clic aquí per entrar usant un protocol segur",
"Secure" => "Segur",
"Stay in SSL mode" => "Roman en mode segur (ssl)",
"local account" => "compte local",
// "Log in via Facebook" => "Log in via Facebook",
// "Log in via LinkedIn" => "Log in via LinkedIn",
"OpenID Log in" => "Connexió via OpenID",
// "OpenID Login" => "OpenID Login",
"What is OpenID" => "Qué és OpenID",
// "Change the logo" => "Change the logo",
// "Click to change or upload new logo" => "Click to change or upload new logo",
// "{\$module_params.sitetitle|escape}" => "{\$module_params.sitetitle|escape}",
// "{\$module_params.sitesubtitle|escape}" => "{\$module_params.sitesubtitle|escape}",
"No acceptable field to store the feature was found in the specified tracker" => "No s'ha trobat cap camp acceptable per a emmagatzemar la funció al formulari-bd especificat",
// "Edit this menu" => "Edit this menu",
"You have" => "Tens",
"new messages" => "nous missatges",
"new message" => "nou missatge",
"You have 0 new messages" => "No tens missatges nous",
"No article found" => "No s'ha trobat l'article",
"No blog post found" => "No hi ha entrada de bloc trobat",
"We have" => "Tenim",
"submissions waiting to be examined" => "col·laboracions esperant ser examinades",
// "Permissions applied from" => "Permissions applied from",
// "No permissions to display" => "No permissions to display",
"Stay on this page" => "Romangui en aquesta pàgina",
"Edit perspectives" => "Edita perspectives",
"Within %0" => "Dins de %0",
"Search Terms" => "Termes de cerca",
"Any type" => "Qualsevol tipus",
"Recent Preferences" => "Preferències recents",
"Wiki feed" => "Wiki feed",
"Blogs feed" => "RSS Blocs",
"Articles feed" => "Articles d'alimentació",
"Image Galleries feed" => "Galeries d'imatges alimenten",
"Image Galleries" => "Galeries d'imatges",
"File Galleries feed" => "Galeries d'arxiu de l'alimentació",
"Forums feed" => "Fòrums d'alimentació",
// "Directory feed" => "Directory feed",
// "Calendar feed" => "Calendar feed",
"{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Lloc complet",
"Image Gals" => "Imatges Gals",
"Search for text throughout the site" => "Cerca el text per tot el lloc",
"Go directly to a page, or search in page titles if exact match is not found" => "Ves directament a una página, o cerca als títols de pàgines si no hi ha cap pàgina amb aquest nom exacte",
"Edit existing page or create a new one" => "Edita una pàgina pre-existent o crea'n una de nova",
// "External" => "External",
"Exact match" => "Ocurrència exacta",
"Page Relations" => "Relacions Pàgina",
// "Get short url" => "Get short url",
"Copy" => "Copiar",
// "Copied" => "Copied",
"Tweet with Twitter" => "Tweet amb Twitter",
"Post on my Facebook wall" => "Publica-ho al meu mur de Facebook",
"Shout date" => "Data de Crida",
"Delete this shout" => "Eliminar aquest crit",
"Edit this shout" => "Edita aquest crit",
"Read More" => "Llegeix més",
"Since your last visit on" => "Des de la teva última visita el...",
"New Images" => "Imatges noves",
"Wiki Pages Changed" => "Pàgines del wiki modificades",
"New Files" => "Arxius nous",
"New Comments" => "Comentaris nous",
"New Tracker Items" => "Nous ítems del formulari",
"New Calendar Events" => "Nous Esdeveniments al Calendari",
"New Users" => "Usuaris/es nous/ves",
"click to edit" => "fes clic per editar",
"Nothing has changed" => "Res no ha canviat",
"Tracker Items" => "Ítems del formulari-bd",
"Updated" => "Actualitzats/des",
"Multiple" => "Múltiple/s",
"including" => "incloent",
// "No Subversion checkout or unable to determine last update" => "No Subversion checkout or unable to determine last update",
"Find term" => "Trobar termini",
"{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
"If not found, you will be given a chance to create it" => "Si no es troba, se li donarà l'oportunitat de crear-",
"TikiTests Menu" => "TikiTests Menu",
"List Tests" => "Proves de llista",
"Create Test" => "Crear prova",
"Top galleries" => "Galeries per dalt",
"Posted to" => "Publicat a",
"(Read More)" => "(Llegeix més)",
"Missing values" => "Els valors perduts",
"Add Marker" => "Afegeix punt",
"Tracker name" => "Nom del Formulari-bd",
"Insert fields in wiki textarea" => "Inserir camps en wiki textarea",
"There are no translations of this page." => "No hi ha traduccions d'aquesta pàgina.",
"Up-to-date-ness" => "Nivell d'actualització",
"Incoming:" => "Entrant:",
"To <strong>continue translating</strong>, select the language to translate from" => "Per <strong> continuar traduint </strong>, seleccioneu l'idioma que voleu traduir de",
"update from it" => "actualitza-ho des d'ella",
"None match your" => "Cap encaixa amb els teus",
"Set your preferred languages." => "Especifica el teu idioma preferit.",
"preferred languages" => "idiomes preferits",
"Outgoing:" => "Sortint:",
"update it" => "actualitza des d'ella",
"click to view" => "punxa per veure",
"Bookmarks" => "Adreces d'interès",
"Cache" => "Memòria cau",
"Create Bookmark" => "Crear marcador",
"New Folder" => "Nova carpeta",
"Done" => "fet",
"Del" => "Esb",
"select" => "selecciona",
"{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
"Group information" => "Informació del Grup",
"You need to activate user and/or group trackers" => "Necessites activar el formulari d'usuari i/o de grup",
"view" => "veure",
"%0 out of %1 users" => "%0 de %1 usuaris",
"online users" => "usuaris en línia",
"online user" => "usuari connectat",
"on host" => "al servidor",
"User does not accept messages" => "Usuari no accepta missatges",
"Send a message to" => "Envia un missatge a",
"More Videos" => "Més Videos",
"No results were found. Are you sure you searched for a tag" => "No s'han trobat resultats. Estàs segur que s'ha buscat una etiqueta",
"We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "No estem Autoritzats per accedir al grup en aquest moment. Si tens accés al grup Zotero, pots concedir a aquest lloc l'accés de lectura",
// "Mark all as read" => "Mark all as read",
// "You receive this notification because you requested it" => "You receive this notification because you requested it",
// "If you did not request these emails or did so in an error, please use the following link" => "If you did not request these emails or did so in an error, please use the following link",
// "Manage your notifications" => "Manage your notifications",
// "Notification Digest" => "Notification Digest",
// "No notifications available" => "No notifications available",
// "Priorities" => "Priorities",
// "No unread notifications" => "No unread notifications",
// "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped" => "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped",
// "Required Action" => "Required Action",
// "Add all members" => "Add all members",
// "OR Select individuals.." => "OR Select individuals..",
// "Add selected members" => "Add selected members",
"Detail" => "Detall",
// "Respond" => "Respond",
// "Opened" => "Opened",
// "Logged In" => "Logged In",
// "Unopened" => "Unopened",
// "People" => "People",
// "Empty list" => "Empty list",
// "Responses" => "Responses",
"Entry" => "Entrada",
"Request Date" => "Data de Sol·licitud",
// "Action Req'd" => "Action Req'd",
// "None (Owner)" => "None (Owner)",
// "Nothing to do" => "Nothing to do",
// "Add Item" => "Add Item",
// "On this document" => "On this document",
// "Saving" => "Saving",
// "This window will close automatically in 3 seconds.." => "This window will close automatically in 3 seconds..",
// "An error occurred, please try again" => "An error occurred, please try again",
// "Consent screen" => "Consent screen",
// "Do you really want to proceed" => "Do you really want to proceed",
"No individual permissions, category permissions apply" => "No hi ha permisos individuals; s'apliquen els permisos de categoria",
"There are individual permissions set for this object" => "Hi ha permisos individuals establerts per a aquest objecte",
"No individual permissions. Global permissions apply." => "No hi ha permisos individuals, s'aplicaràn els permisos globals",
// "Search and select what you are looking for from the options that appear" => "Search and select what you are looking for from the options that appear",
// "No matching results" => "No matching results",
// "Search and select what you are looking for from the options that appear." => "Search and select what you are looking for from the options that appear.",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparant la versió {\$old.version} amb la versió {\$new.version}",
"Version:" => "Versió:",
"Current" => "Actual",
"Session" => "Sessió",
"Old Session" => "Old Sessió",
"Old Version" => "Old Version",
"New Session" => "Nova sessió",
"New Version" => "Nova Version",
"Versions are identical" => "Les versions són idèntiques",
// "Example wikidiff plugin syntax" => "Example wikidiff plugin syntax",
"Minimum %0 characters long" => "Mínim %0 caràcters de llarg",
// "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + ..",
// "Password is too common" => "Password is too common",
// "Individual permissions" => "Individual permissions",
// "Select image" => "Select image",
// "Pick a file" => "Pick a file",
// "Upload or record media" => "Upload or record media",
// "Convert to List" => "Convert to List",
// "{\$info.title|escape}" => "{\$info.title|escape}",
// "{\$info.description|default:''|escape}" => "{\$info.description|default:''|escape}",
// "Auto generate Biblio Code" => "Auto generate Biblio Code",
// "New reference created" => "New reference created",
// "Problems while creating the reference" => "Problems while creating the reference",
"[-]" => "[-]",
"vote" => "vota",
// "Use &quot;%0&quot; to separate values" => "Use &quot;%0&quot; to separate values",
// "Reset to default value" => "Reset to default value",
// "Restore current value" => "Restore current value",
// "Change your preference filter settings in order to view advanced preferences by default" => "Change your preference filter settings in order to view advanced preferences by default",
// "advanced" => "advanced",
// "Change your preference filter settings in order to view experimental preferences by default" => "Change your preference filter settings in order to view experimental preferences by default",
"experimental" => "Experimental",
"Requires" => "Requireix",
"You need apply profile" => "Cal aplicar el perfil",
"You need to set" => "Cal establir",
// "Requires package" => "Requires package",
// "Missing tiki package" => "Missing tiki package",
"User rating" => "Valoració de l'usuari/a",
"Rate" => "Valora-ho",
"User rating on thread topic" => "Valoració d'usuari/a sobre el tema del fil de debat",
// "Debug Information" => "Debug Information",
// "Engine does not provide any debug information" => "Engine does not provide any debug information",
"A valid email is mandatory to register" => "Cal una adreça de correu-e vàlida per enregistrar-te",
"{\$customfields[ir].label}" => "{\$customfields[ir].label}",
"{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email address as your log-in name" => "Empra el teu correu-e com a nom per connectar-te",
"Lowercase only" => "Només minúscules",
"New Password" => "Nova Contrasenya",
"Confirm password" => "Repetiu la contrasenya",
// "Passwords match" => "Passwords match",
"Generate a password" => "Generar una contrasenya",
"Passcode to register" => "Codi de pas per registrar-se",
"Not your password" => "No la teva contrasenya",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
"The passcode (to block robots from registration) is" => "El codi d'accés (per bloquejar els robots d'inscripció) és",
// "{\$remarksbox_title|escape}" => "{\$remarksbox_title|escape}",
// "Do you really want to remove the %0 scheduler" => "Do you really want to remove the %0 scheduler",
// "Reset the scheduler, will mark this run as failed, allowing it to be executed again" => "Reset the scheduler, will mark this run as failed, allowing it to be executed again",
// "Back to schedulers list" => "Back to schedulers list",
// "Reversal Event" => "Reversal Event",
// "Unique Name" => "Unique Name",
// "Type (e.g. user)" => "Type (e.g. user)",
// "Field value (e.g. user)" => "Field value (e.g. user)",
// "Pt. value" => "Pt. value",
"The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "Els documents es retornen ordenats per rellevància en funció de l'ordre, la proximitat, la freqüència dels termes.",
"Default search behavior" => "Comportament de cerca predeterminat",
"By default, all search terms are <em>optional</em>" => "Per omissió, tots els termes de cerca són <em> opcionals </em>",
"It behaves like an OR logic" => "Es comporta com una OR lògica",
"Objects that contain the more terms are rated higher in the results and will appear first" => "Els objectes que contenen els més termes s'han valorat més alt en els resultats i apareixeran primer",
"For example, <strong>wiki forum</strong> will find" => "Per exemple, <strong>wiki fòrum</strong> trobarà",
"objects that include both tokenized terms" => "objectes que incloguin ambdós termes tokenitzats",
"objects that include the term <strong>wiki</strong>" => "objectes que inclouen el terme <strong>wiki</strong>",
"objects that include the term <strong>forum</strong>" => "objectes que incloguin el terme <strong>fòrum</strong>",
"Boolean operators" => "Operadors booleans",
"You can use AND or OR or NOT also to do a boolean search" => "Pots utilitzar AND o OR o NOT també per fer una cerca booleana",
"Example: <strong>wiki and forum</strong> will find objects with both terms" => "Exemple: <strong> wiki and fòrum </strong> trobarà els objectes amb els dos termes",
"Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Exemple: <strong>wiki or fòrum</strong> trobarà objectes amb un dels termes",
"Grouping terms" => "Agrupant Termes",
"Use parenthesis ( ) to group terms into subexpressions" => "Utilitza parèntesis () per agrupar termes en subexpressions",
"Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Exemple: <strong>wiki and (fòrum blog)</strong> trobarà objectes que contenen <strong>wiki</strong> i <strong>fòrum</strong> o que contenen <strong>wiki</strong> i <strong>blog</strong> en qualsevol ordre",
"Finding phrases" => "Trobant Frases",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other" => "Fes servir cometes ( <kbd>\" \"</kbd> ) al voltant d'una frase per trobar termes en l'ordre exacte, un al costat de l'altre",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Exemple: <kbd>\"Alex Campana\"</kbd> no trobarà <strong> Campana Alex </strong> o <strong> Alex G. Campana </strong>, però sí <strong> Alex Campanar </strong>.",
// "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it" => "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it",
// "media image" => "media image",
// "Expand table" => "Expand table",
// "Restore layout" => "Restore layout",
"Items found" => "Ítems trobats",
"Indexed" => "Indexació",
"Queue size" => "Mida de la cua",
// "Batch Size" => "Batch Size",
// "Process %0" => "Process %0",
// "Process Batch" => "Process Batch",
"Your index was last fully rebuilt on %0" => "El teu índex es va restaurar totalment per última vegada el %0",
"version" => "versió",
// "Fallback search engine" => "Fallback search engine",
// "Fallback search index was rebuild" => "Fallback search index was rebuild",
// "Fallback search index was not rebuilt" => "Fallback search index was not rebuilt",
// "Execution Statistics" => "Execution Statistics",
// "Current Memory usage" => "Current Memory usage",
// "Memory peak usage before indexing" => "Memory peak usage before indexing",
// "Memory peak usage after indexing" => "Memory peak usage after indexing",
// "Number of queries" => "Number of queries",
// "Rebuilding index.." => "Rebuilding index..",
// "Enable logging" => "Enable logging",
// "Log file is saved as %0" => "Log file is saved as %0",
// "Rebuild" => "Rebuild",
// "Process Queue" => "Process Queue",
// "Indexing Problems" => "Indexing Problems",
// "If the indexing does not complete, check the log file to see where it ended" => "If the indexing does not complete, check the log file to see where it ended",
// "Last line of log file (web)" => "Last line of log file (web)",
// "Last line of log file (console)" => "Last line of log file (console)",
// "Not enough memory" => "Not enough memory",
// "Time limit too short" => "Time limit too short",
// "High resource usage" => "High resource usage",
// "Command Line Utilities" => "Command Line Utilities",
// "Cache Expired" => "Cache Expired",
// "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over" => "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over",
"Index" => "Índex",
// "Defined" => "Defined",
"Valid" => "Vàlid",
// "May not work or corrupt data" => "May not work or corrupt data",
// "Alter" => "Alter",
// "No instances configured" => "No instances configured",
// "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes" => "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes",
// "Create Index" => "Create Index",
// "Return to List of Saved Searches" => "Return to List of Saved Searches",
// "Do you really want to remove the %0 saved search" => "Do you really want to remove the %0 saved search",
// "Other Queries" => "Other Queries",
// "No stored queries" => "No stored queries",
"Create New" => "Crear nou",
// "This will help you recognize your stored queries if ever you want to modify or remove them" => "This will help you recognize your stored queries if ever you want to modify or remove them",
// "Use Existing" => "Use Existing",
"{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "Darrera modificació",
// "No pages matched the search criteria test" => "No pages matched the search criteria test",
"Download Log File" => "Descàrrega fitxer de registre",
// "Resend newsletter" => "Resend newsletter",
"Send Newsletter" => "Envia el Butlletí",
// "Send newsletter" => "Send newsletter",
// "This content is licensed under the terms of the" => "This content is licensed under the terms of the",
"To edit the copyright notices" => "Per editar els avisos de Copyright",
"Know the username" => "Coneixes el nom d'usuari",
"%0 has been accepted" => "%0 ha estat acceptat/da",
"Do you really want to approve %0" => "Realment vols aprovar %0",
"Do you really want to remove %0" => "Realment vols eliminar %0",
"No friends have been added" => "No tens amics aquí",
"Incoming requests" => "Peticions rebudes",
// "Accept and add" => "Accept and add",
"Still waiting for approval" => "Encara pendent/s d'aprovació",
"Do you really want to cancel request for %0" => "Realment vols cancel·lar la petició per a %0",
"%0 has been removed from your friends" => "%0 ha estat eliminat de les teves amistats aquí",
"Page alias.." => "Nom àlies de pàgina ..",
"Monitor the Sub-Structure" => "Vigila la Sub-Estructura",
"Stop Monitoring the Sub-Structure" => "Deixa de vigilar la Sub-Estructura",
"locked by %0" => "bloquejat per %0",
"Locked" => "Bloquejat",
"Edit page" => "Edita la pàgina",
"Add new child page" => "Afegir nova pàgina secundària",
// "About &amp; News" => "About &amp; News",
// "Information and introduction portal" => "Information and introduction portal",
"Documentation" => "Documentació",
// "How to use Tiki" => "How to use Tiki",
// "Development" => "Development",
// "How make Tiki" => "How make Tiki",
// "Forums and general community information" => "Forums and general community information",
// "How make Tiki look pretty" => "How make Tiki look pretty",
// "Manage" => "Manage",
// "Initializite this format with the current tracker fields" => "Initializite this format with the current tracker fields",
// "Tracker Name" => "Tracker Name",
// "File Delimiter" => "File Delimiter",
// "Comma (,)" => "Comma (,)",
// "Semicolon (;)" => "Semicolon (;)",
// "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes" => "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes",
"Field Type" => "Tipus de Camp",
// "Primary Key" => "Primary Key",
// "PK" => "PK",
// "Unique Key" => "Unique Key",
// "UK" => "UK",
// "Read-Only" => "Read-Only",
// "RO" => "RO",
// "Export-Only" => "Export-Only",
// "EO" => "EO",
// "Required to import data. Can be any field as long as it is unique" => "Required to import data. Can be any field as long as it is unique",
// "Impose unique value requirement for the target column. This only works with Transactional Import feature" => "Impose unique value requirement for the target column. This only works with Transactional Import feature",
// "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process" => "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process",
// "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict" => "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict",
// "Simple headers" => "Simple headers",
// "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format" => "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format",
// "Import updates" => "Import updates",
// "Import update" => "Import update",
// "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported" => "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported",
// "Ignore blanks" => "Ignore blanks",
// "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way" => "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way",
// "Transactional import" => "Transactional import",
// "Import transaction" => "Import transaction",
// "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved" => "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved",
// "Bulk import" => "Bulk import",
// "Bulk Import" => "Bulk Import",
// "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent" => "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent",
"Are you sure you want to delete this item" => "Estàs segur que desitges eliminar aquest article",
"Delete item" => "Eliminar element",
// "Select a field.." => "Select a field..",
// "Select Mode" => "Select Mode",
// "No primary key" => "No primary key",
// "Side" => "Side",
// "Filters will be available in partial export menus" => "Filters will be available in partial export menus",
// "Skip Unmodified" => "Skip Unmodified",
// "Will not re-import items that have not changed" => "Will not re-import items that have not changed",
// "Import Completed" => "Import Completed",
// "Your import was completed succesfully" => "Your import was completed succesfully",
"CSV File" => "Arxiu CSV",
// "Applied filters" => "Applied filters",
// "Create Tracker from File" => "Create Tracker from File",
// "Export Full" => "Export Full",
// "Export Partial" => "Export Partial",
// "Export Custom" => "Export Custom",
// "No tabular formats defined" => "No tabular formats defined",
// "Modes" => "Modes",
"This book" => "Aquest llibre",
"Start date" => "Data d'inici",
"before" => "abans",
"after" => "després",
"don't display" => "no es mostren",
"Decimals" => "Decimals",
"Decimal Point" => "Coma decimal",
"Auto Tax" => "Impost Auto",
"Tasks" => "Tasques",
"Book new entries" => "Noves entrades de la llibreta",
"Confirm stack entries" => "Confirmar entrades de la pila",
"Book into Stack" => "Reservar a Pila",
"Accounts" => "Comptes",
"Journal" => "Revista",
"Fetch all" => "Obtenir totes les",
"Create new account" => "Crea un compte",
"Edit Account" => "Edita Compte",
"Account number" => "Número de compte",
"Notes" => "Notes",
"Budget" => "Pressupost",
"Create account" => "Crea un compte",
"Modify account" => "Modificar compte",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1",
"Delete this account" => "Esborrar aquest compte",
"Back to book page" => "Retorn a la pàgina del llibre",
"Account" => "Compte",
"Debit" => "Dèbit",
"Credit" => "Crèdit",
"Tax" => "Impost",
// "Unlock account" => "Unlock account",
// "Lock account" => "Lock account",
// "Remove account" => "Remove account",
"Create a new account" => "Crea un compte",
"printable version" => "Versió per imprimir",
"export table" => "Exportar taula",
"View account" => "Veure compte",
"Edit this account" => "Edita aquest compte",
"My books" => "Els meus llibres",
"Tax automation" => "Automatització d'Impostos",
"hide" => "oculta",
"behind" => "darrere",
// "Close book" => "Close book",
// "Close book? (This action cannot be undone)" => "Close book? (This action cannot be undone)",
"Create a book" => "Crea un llibre",
"Book properties" => "Propietats Llibre",
"Name of the book" => "Nom del llibre",
"First date in journal" => "Primera data de publicació",
"Last date in journal" => "Darrera data de publicació",
"Currency settings" => "Configuració de divises",
"Currency (up to 3 letters) " => "Moneda (fins a 3 lletres)",
"Position of the currency " => "Posició de la moneda",
"Show no currency" => "No mostris moneda",
"Show currency in front of numbers" => "Mostra divisa davant dels números",
"Show currency behind numbers" => "Mostra divisa darrere dels números",
"Decimal point" => "Coma decimal",
"Decimal" => "Decimal",
"Quote strings with" => "Citar cadenes amb",
"End of Line" => "Fi de Línia",
"Carriage return" => "Retorn de carro",
"Line feed" => "Salt de línia",
"Carriage Return/Line feed" => "Retorn / Line feed carro",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
"Allow automatic tax calculation" => "Permetre el càlcul automàtic d'impostos",
"Create a new book" => "Crear un nou llibre",
// "Canceled Journal" => "Canceled Journal",
// "Booking Date" => "Booking Date",
"Amount" => "Quantitat",
"Book a transaction" => "Reservi una transacció",
// "\"}Delete account %0" => "\"}Delete account %0",
"Add entry" => "Afegir entrada",
"Book" => "Llibre",
// "\"}Record entry in book %0" => "\"}Record entry in book %0",
"Export {\$what}" => "Exporta {\$what}",
"Export CSV settings" => "Configuració d'Exportació CSV",
"Separator between fields" => "Separador entre camps",
"Quote character for text" => "Caràcter cotització per al text",
"Export as CSV" => "Exporta com a CSV",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1",
// "Cancel transaction" => "Cancel transaction",
"Balance" => "Balanç",
"Deleted" => "Suprimit",
"Debit Account" => "Compte Dèbit",
"Debit Amount" => "Monto Dèbit",
"Debit Text" => "Text Dèbit",
"Credit Account" => "Compte de Crèdit",
"Credit Amount" => "Monto de Crèdit",
"Credit Text" => "Text de crèdit",
"Book a transaction into the stack" => "Reservi una transacció dins de la pila",
// "\"}Record stack entry in book %0" => "\"}Record stack entry in book %0",
// "\"}Modify stack entry in book %0" => "\"}Modify stack entry in book %0",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1",
// "Remove transaction" => "Remove transaction",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1",
// "Confirm transaction" => "Confirm transaction",
"Do not group by item" => "No agrupis per ítem",
"Group by item" => "Agrupa per ítem",
"Calendar View" => "Vista de Calendari",
"Tiki Action Calendar" => "Calendari d'accions del Tiki",
"Tools Calendars" => "Eines de Calendaris",
"Check / Uncheck All" => "Marcar / desmarcar tot",
"Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>" => "Manca el correu-e de l'enviador. Pots posar-lo <a href=\"%0\" class=\"alert-link\">al panell de control general.</a>",
"Database Version Problem" => "Hi ha un problema amb la versió de la base de dades",
// "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "Vendor folder issues" => "Vendor folder issues",
// "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>" => "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>",
// "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded" => "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded",
// "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries" => "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries",
// "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>" => "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>",
// "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file" => "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file",
// "Installer not locked" => "Installer not locked",
// " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. " => " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. ",
// "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder" => "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder",
// "You can also use the following, on the command line, from the root of your Tiki installation" => "You can also use the following, on the command line, from the root of your Tiki installation",
// "Search Index outdated" => "Search Index outdated",
// "The search index might be outdated. It is recommended to rebuild the search index" => "The search index might be outdated. It is recommended to rebuild the search index",
// "File gallery directory web accessable" => "File gallery directory web accessable",
// "This is a potential security risk" => "This is a potential security risk",
// "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database" => "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database",
// "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>" => "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>",
"Please select some actions to be reported" => "Si us plau seleccioni algunes accions que s'han de notificar",
"End" => "Fi",
"Users and Groups" => "Usuaris i grups",
"Misc" => "Misc",
"Units" => "Unitats",
"kb" => "kb",
// "Contribution Time" => "Contribution Time",
"Graph Contributions" => "Gràfic Contribucions",
"Group Bar Plot" => "Grup Bar Terreny",
"Accumulated Bar Plot" => "Gràfic de Barres Apilades",
"Background color" => "Color del rerafons",
"{\$color}" => "{\$color}",
"Legend background color" => "Llegenda color de fons",
"Save graphs to image gallery" => "Guardar els gràfics de la galeria d'imatges",
"Records:" => "Registres:",
"See Statistics" => "Mostra les estadístiques",
"contribution" => "tipus de contribució",
"contributor" => "contribuent",
"{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
"{\$actionlog.objectType}" => "{\$actionlog.objectType}",
"{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Delete action from log" => "Delete action from log",
// "Select action to perform with checked" => "Select action to perform with checked",
// "Delete selected actions from log" => "Delete selected actions from log",
"Edit Action" => "Edita acció",
"Save Action" => "Guardar acció",
"Statistics" => "Estadístiques",
"Volumes are equally distributed on each contributors/author" => "Els volums es distribueixen per igual en cada un dels col·laboradors / autor",
"connection time" => "temps de connexió",
"connection seconds" => "segon de connexió",
"mns" => "mns",
"Volume per category" => "Volum per categoria",
"Volume per category and per user" => "Volum per categoria i per usuari",
"Number of actions per user" => "Nombre d'accions per usuari",
"Total number of users" => "Nombre total d'usuaris",
"Number of actions per object" => "Nombre d'accions per objecte",
"Total number of objects" => "Nombre total d'objectes",
"Bigbluebutton" => "Bigbluebutton (Conferències Web)",
"Time in bigbluebutton (in minutes)" => "Temps a bigbluebutton (en minuts)",
"Number of actions per category" => "Nombre d'accions per categoria",
"Number of actions per category and per user" => "Nombre d'accions per categoria i per usuari",
"Volume per the users' group and per contribution" => "Volum per grup d'usuaris i per contribució",
"Volume per group and per contribution" => "Volum per grup i per contribució",
"Volume per user and per contribution" => "Volum per usuari i per contribució",
"Volume per users' contribution and time" => "Volum per la contribució i el temps dels usuaris",
"Volume per contribution and time" => "Volum per la contribució i el temps",
"Weeks" => "Setmanes",
"How" => "Com",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "Cal revisar la caixa de gravat per a cada tipus d'acció que poden estar interessats en tenir algun informe posterior. Per veure un informe d'alguns tipus d'accions, seleccioneu les caselles de verificació de denúncies d'aquest tipus d'acció, anar a la pestanya Informes i seleccionar filtres addicionals. L'informe només conté les accions que s'han produït des que el tipus d'acció s'ha establert en gravat",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Les accions en pàgines wiki (excepte les de visualització) sempre es registren però es pot selecionar que no es mostrin als informes.",
"Recorded" => "Registrat",
"{\$actionlog.action}" => "{\$actionlog.action}",
"Import as CSV" => "Importar com CSV",
"Banning rules have been updated" => "Banning normes han estat actualitzades",
"Add or edit rules" => "Afegir o editar regles",
"Rule title" => "Titol de la regla",
"Username regex matching" => "Apaarellament de regex de nom d'usuari",
"Multiple IP regex matching" => "Múltiple coincidència d'expressions regulars IP",
"IP regex matching" => "IP comprovació",
"Banned from sections" => "Expulsat de les seccions",
"{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Regla activada per dates",
"Rule active from" => "Regla activa desde",
"Rule active until" => "Regla activa fins",
"Custom message to the user" => "Personalitzar missatge a l'usuari/a",
"Import rules as CSV" => "Les normes d'importació com CSV",
"Column names on the first line" => "Els nom de les columnes van a la primera línia",
"Sections format" => "Format de les seccions",
"section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "noms de secció són separat per canonades (barres verticals). Per veure un exemple i utilitzar com a plantilla, afegir una regla a mà, i exportar-com csv",
"See" => "Consulta",
"Import as new rules" => "Importar les noves regles",
"Find:" => "Troba:",
// "Current rules" => "Current rules",
"x" => "x",
// "Delete selected banning rules" => "Delete selected banning rules",
"User/IP" => "Usuari/a-IP",
// "Delete banning rule" => "Delete banning rule",
// "No rules found" => "No rules found",
"Admin Calendars" => "Administrar Calendaris",
"Create Calendar" => "Crear Calendari",
"View Calendars" => "Mostra els Calendaris",
"Calendar name" => "Nom del calendari",
"Participants" => "Participants",
// "Personal" => "Personal",
// "Field will show in popup" => "Field will show in popup",
"Custom location" => "Personalitzar Llocs",
"Custom participants" => "Participants customitzats",
// "Custom languages" => "Custom languages",
"Add event" => "Afegeix esdeveniment",
// "Delete calendar" => "Delete calendar",
"Edit Calendar" => "Edita el Calendari",
"Custom classification" => "Classificacions personalitzats",
"Custom language" => "Personalitzar Idiomes",
"Custom subscription list" => "Llista de subscripcions customitzada",
"Custom priority" => "Personalitzar Prioritats",
"Personal Calendar" => "Calendari personal",
"Start of day" => "Inici del dia",
"End of day" => "Final del dia",
"Days to display" => "Dies per mostrar",
"Standard color" => "Colors estàndard",
"Green" => "Verd",
"Purple" => "Violeta",
"Orange" => "Taronja",
"Yellow" => "Groc",
"Custom foreground color" => "Color de davant personalitzat",
"Custom background color" => "Color del fons personalitzat",
"Default event status" => "Estatus de l'esdeveniment per omissió",
// "Show in popup view" => "Show in popup view",
"Show in calendar view" => "Mostra a la vista de calendari",
"Group of users alerted when calendar event is modified" => "Grup d'usuaris a avisar quan un esdeveniment del calendari sigui modificat",
"Default length of events is all day" => "Esdeveniment predeterminat per a tot el dia",
"Event name on each day in calendar view" => "Nom de l'esdeveniment per a cada dia de la vista del calendari",
"Delete events older than" => "Esborra esdeveniments més vells que",
// "Delete old events" => "Delete old events",
"Browse the category system" => "Navega pel sistema de categories",
// "Create category" => "Create category",
// "Edit category" => "Edit category",
"Edit this category:" => "edita aquesta categoria:",
"Add new category" => "Afegeix una nova categoria",
"Apply parent category permissions" => "Aplicar permisos de categoria dels pares",
"Objects in category" => "Objectes en la categoria",
// "Remove from this category" => "Remove from this category",
// "Remove object from category" => "Remove object from category",
"{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Remove checked" => "Remove checked",
// "Remove objects from category" => "Remove objects from category",
// "Moving objects" => "Moving objects",
"Moving objects between categories" => "Moure objectes entre les categories",
"Current category" => "Categoria actual",
// "Perform an action on all objects in the current category" => "Perform an action on all objects in the current category",
// "Unassign objects from category" => "Unassign objects from category",
// "Move to selected category" => "Move to selected category",
// "Choose destination category" => "Choose destination category",
// "Copy to selected category" => "Copy to selected category",
// "Add objects" => "Add objects",
"Add objects to category" => "Afegir objectes a la categoria",
"Objects" => "Objectes",
"Quiz" => "Test",
"Batch upload" => "Puja al rerafons",
// "Sample file content" => "Sample file content",
// "Content templates" => "Content templates",
"Templates" => "Plantilles",
"Visible in no sections" => "Visible en cap secció",
"Remove section" => "Traieu la secció",
// "Uncategorized" => "Uncategorized",
// "{\$catName}" => "{\$catName}",
// "Remove template" => "Remove template",
"Edit template" => "Edita Plantilles",
// "Create template" => "Create template",
"Use the Administration page of each enabled feature to allow the use of content templates" => "Utilitza la pàgina d'administració de cada entitat habilitada per permetre l'ús de plantilles de contingut",
"Name field is mandatory" => "Camp Nom és obligatori",
"No features are configured to use templates" => "No hi ha característiques estan configurats per utilitzar plantilles",
"Template Type" => "Tipus de Plantilla",
"Text area" => "Àrea de Text",
"Admin Contributions" => "Administrar Tipus de Contribucions",
"Edit the contribution:" => "Edita el tipus de contribució:",
"Contributions are mandatory in wiki pages" => "És obligatori especificar tipus de contribucions en les pàgines wiki",
"Contributions are mandatory in forums" => "És obligatori especificar tipus de contribucions en els fòrums",
"Contributions are mandatory in comments" => "És obligatori especificar tipus de contribucions en els comentaris",
"Contributions are mandatory in blogs" => "Les contribucions són obligatòries en els blocs",
"Contributions are displayed in the comment/post" => "Es mostren els tipus de contributions en els comentaris/publicacions",
"Create a new contribution" => "Crea un nou tipus de contribució",
"List of contributions" => "Llista de tipus de contribucions",
// "Remove contribution" => "Remove contribution",
"Admin cookies" => "Administrar cookies",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Crear/editar galetes",
"Upload Cookies from textfile" => "Puja Galetes des d'un arxiu de text ",
// "Upload from disk" => "Upload from disk",
"Remove all cookies" => "Esborrar totes les cookies",
"cookie" => "galeta",
// "Remove cookie" => "Remove cookie",
"Manage Credits" => "Gestioni Crèdits",
"(YYYY-MM-DD HH:MM:SS)" => "(AAAA-MM-DD HH:MM:SS)",
"(level credits always 0)" => "(Crèdits de nivell sempre 0)",
"Delete Checked" => "Eliminar seleccionats",
"User Credits Expiry Summary (Plans)" => "Usuari Crèdits Resum de caducitat (Plans)",
"User Plan" => "Pla de l'Usuari",
"Start of Latest Plan" => "Inici del darrer pla",
"Start of Next Plan" => "Inici del següent Pla d'",
"Expiry" => "Venciment",
"Use User Credits" => "Utilitza Crèdits usuari",
"Restore User Level Credits" => "Restaurar Nivell Usuari Crèdits",
"Historical Usage Report" => "Informe d'ús històric",
"all types" => "tots els tipus",
"filter" => "filtra",
"Usage Date" => "Ús de Data",
"Amount Used" => "Quantitat utilitzada",
"No such user" => "Aquest usuari no existeix",
"Manage Credit Types" => "Gestionar tipus de crèdit",
"Display Text" => "Mostra el text",
"Unit Text" => "Unitat de Text",
"Is Static Level Credit" => "És el crèdit Nivell Estàtic",
"Display Bar Length Scaling Divisor" => "Mostra Longitud de la barra d'escala Divisor",
"Purge Expired and Used Credits (All Users)" => "Purgar Crèdits Vençuts i Usats (tots els usuaris)",
"Purge" => "Purga",
"Admin Content Sources" => "Fonts de Contingut admin",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Empra Admin DSN per definir la base de dades a ser emprada pel connector 'SQL plugin'.",
"Create/edit DSN" => "Crear / editar DSN",
"Local (Tiki database)" => "Local (Tiki base de dades)",
"See db/local.php" => "Veure db/local.php",
// "Remove DSN" => "Remove DSN",
"Content Authentication" => "Autenticació del contingut",
"Identification" => "Identificació",
"HTTP Basic" => "HTTP Basic",
"HTTP Session / Login" => "Sessió HTTP / Login",
"HTTP Session / Visit" => "Sessió HTTP / Visita",
"Admin External Wikis" => "Wikis extern administració",
"Create/Edit External Wiki" => "Crea/Edita un Wiki External",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (empra \$page per ser reemplaçat pel nom de la pàgina a l'exemple d'URL: http://www.example.com/tiki-index.php?page=\$page)",
// "<em>[prefix]</em>main, such as tiki_main" => "<em>[prefix]</em>main, such as tiki_main",
// "Search as" => "Search as",
// "Leave blank to search using currently active groups" => "Leave blank to search using currently active groups",
"ExtWiki" => "Wikiext",
// "Search As" => "Search As",
// "Remove external wiki" => "Remove external wiki",
"Admin Forums" => "Administrar fòrums",
// "Create Forum" => "Create Forum",
"Age" => "Edat",
"PPD" => "Ppd",
"Create/Edit Forums" => "Crea/Edita Fòrums",
"Edit this Forum:" => "edita aquest fòrum:",
"Create New Forum" => "Crear un Nou Fòrum",
// "Main details" => "Main details",
// "Image symbolizing the forum" => "Image symbolizing the forum",
"Only allow replies to the first message (flat forum)" => "Només permetre respostes al primer missatge (fòrum plana)",
"Moderator user" => "Usuari moderador",
"Moderator group" => "Grup moderador",
"Password protected" => "Contrasenya protegida",
"Forum password" => "Contrasenya del Fòrum",
"Prevent flooding" => "Prevenir edicions simultànies",
"Minimum time between posts" => "Temps mínim entre publicacions",
"Send the posts of this forum to this email address" => "Enviar post d'aquest fòrum a aquest correu-e",
"Prune unreplied-to messages after" => "Eliminar missatges sense resposta després de ",
"Prune old messages after" => "Eliminar missatges antics després de",
// "Forum-mailing list synchronization" => "Forum-mailing list synchronization",
"Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address" => "Missatges reenviats a aquest fòrum per a aquesta adreça d'e-mail , en un format que pot ser emprat per a retornar a la primera adreça d'e-mail",
"Send emails even when the post is generated by an inbound email" => "Envia correus-e encara que un correu d'entrada hagi generat la publicació",
"Append a reply link to outbound mails" => "Afegeix un enllaç de resposta als correus enviats",
"Originating email address for emails from this forum" => "Originant adreça d'e-mail  per a correus des de aquest fòrum",
"Add messages from this email to the forum" => "Afegeix missatges d'aquest correu-e al fòrum",
"POP3 server" => "servidor POP3",
"Forums list" => "Llista de Fòrums",
"Display last post titles" => "Mostra darrers títols enviats",
"Forum topics (threads) list" => "Llista de temes (fils de debat) del Fòrum",
"Default order of topics" => "Ordre per defecte per a temes",
"Topics per page" => "Temes per pàgina",
"Topic list configuration" => "Configuració de la llista de temes",
"Last post title" => "Títol de l'última publicació",
"Last post profile picture" => "Avatar de l'última publicació",
"Author profile picture" => "Avatar de l'Autor",
"Use topic smileys" => "Empra emoticons",
"Show topic summary" => "Mostra el resum del tema",
"Forum threads" => "Fils de debat del Forum",
"Default ordering of threads" => "Ordenació per omissió dels fils de debat",
"Default style of threads" => "Estil per omissió dels fils de debat",
"Approval type" => "Tipus d'Aprovació",
"Topic Rating" => "Valoració de Temes",
"User Level" => "Nivell d'usuari/a",
"eMail" => "Correu-e",
"Online" => "Online",
"Permission" => "Permís",
// "Store attachments in" => "Store attachments in",
// "File system" => "File system",
"Max attachment size (bytes)" => "Tamany Màxim d'adjunts (en octets)",
"Shows number of attachments of the all thread in forum list" => "Mostra el nombre d'arxius adjunts de la llista de tots els fils al fòrum",
"Duplicate Forum" => "Duplica el Fòrum",
"Admin Hotwords" => "Admin paraules calentes",
"Add Hotword" => "Afegeix una paraula clau",
"Word" => "Paraula",
// "Delete hotword" => "Delete hotword",
"Admin HTML Page Dynamic Zones" => "Admin HTML Pàgina zones dinàmiques",
"Admin HTML pages" => "Administra pàginas HTML",
"Edit zone" => "Edita zona",
"Dynamic zones" => "Zones dinàmiques",
"zone" => "zona",
"content" => "contingut",
"Mass update" => "Actualització massiva",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Utilitza {literal}{ed id=Nom} {/literal} o {literal} {ted id=Nom}{/literal} per inserir zones dinàmiques",
"Create new HTML page" => "Crea una nova pàgina HTML",
"Edit this HTML page:" => "Edita aquesta pàgina HTML:",
"Apply template" => "Aplica plantilla",
"{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dinàmic",
"Static" => "Estàtic",
"Refresh rate (if dynamic)" => "Freqüència d'actualització (si és dinàmica)",
"Last Modif" => "Darrera modificació",
"Admin dynamic zones" => "Zones dinàmiques admin",
// "Remove HTML page" => "Remove HTML page",
// "IDS Rules" => "IDS Rules",
// "Add a new Rule" => "Add a new Rule",
// "Rule ID" => "Rule ID",
// "Impact" => "Impact",
// "Edit rule settings" => "Edit rule settings",
// "Edit Rule" => "Edit Rule",
// "Add a new rule" => "Add a new rule",
// "Rule Id" => "Rule Id",
// "Rule Id must be numeric" => "Rule Id must be numeric",
// "Rule Regex" => "Rule Regex",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository:" => "Edita Dipòsit:",
"Create New Repository" => "Crea Nou Dipòsit",
"Human-readable repository name" => "Nom de dipòsit en format llegible",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Ruta al dipòsit (sistemes de fitxers locals: adreça web relativa/absoluta, remots: prefixada amb 'http://')",
"File name of start page" => "Nom de l'arxiu de la pàgina de començament",
"Start page" => "Pàgina d'inici",
"CSS file to load when browse this repository" => "Fitxer CSS per carregar quan es navegui per aquest dipòsit",
"CSS File" => "Arxiu CSS",
"Is repository visible to users" => "Dipòsit visible per a les persones usuàries?",
"Can files from repository be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Cacheable" => "Captable en memòria cau",
"Clear all cached pages of this repository" => "Neteja totes les pàgines en memòria cau d'aquest dipòsit?",
"Clear cache" => "Neteja memòria cau",
"Seconds count 'till cached page will be expired" => "Segons que resten fins que la pàgina quedi expirada",
"Cache expiration" => "Expiració de la memòria cau",
"Human-readable text description of repository" => "Text de descriptió en format llegible del dipòsit",
"Available Repositories" => "Dipòsits disponibles",
"Edit rules" => "edita normes",
"Edit Rules for Repository:" => "Editar Regles pel Dipòsit:",
"Configure Repositories" => "Configura dipòsits",
"List Repositories" => "Llista dipòsits",
"Configure this Repository" => "Configurar aquest dipòsit",
"View this Repository" => "Veure aquest dipòsit",
"New Rule" => "Nova regla",
"Copy Rules" => "Copiar regles",
"view/hide copy rules dialog" => "veure/amagar diàleg de copies de regles",
"Source repository" => "Eines del dipòsit",
// "Rules will be applied in this order ('0' or empty = auto)" => "Rules will be applied in this order ('0' or empty = auto)",
"Rule order" => "Ordre de regles",
"Text to search for" => "Text a cercar per",
"Text to replace" => "Texte a reemplaçar",
"Is this regular expression or simple search/replacer" => "És aquesta una expressió regular  o una simple paraula de cerca",
"Regex" => "Expresió Regular",
"Is case sensitive (for simple replacer)" => "És sensible a les majúscules (per a poder sobreescriure)",
"Case sensitive" => "Sensible a Majúscules",
// "subset of chars: imsxeADSXUu, which are regex modifiers" => "subset of chars: imsxeADSXUu, which are regex modifiers",
"Regex modifiers" => "Modificadors d'expresions regulars",
"Human-readable text description of rule" => "Norma escrita de forma llegible",
"Check to enable this rule" => "marcar per a habilitar aquesta norma",
"Preview options" => "Previsualitzar opcions",
"Apply all rules or just this to generate preview" => "Aplica totes les normes o només per a generar aquesta vista prèvia",
"Apply all rules" => "Aplica totes les normes",
"View source code after rules applied" => "Visualitza el codi font després que s'apliquin les regles",
"Code preview" => "vista prèvia del Codi",
"Generate HTML preview" => "Generar vista prèvia",
"HTML preview" => "Vista prèvia en HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Fitxer test del dipòsit per generar previsualització per (buit = pàgina d'inici configurada)",
"Preview Results" => "Previsualitzar resultats",
"Rules List" => "Llista de Regles",
"Case" => "Cas",
"Admin Invoices" => "Factures admin",
"Admin keywords" => "Paraules clau de admin",
"Edit page keywords" => "Editar pàgines paraules clau",
"Current Page Keywords" => "Pàgina actual Paraules clau",
"Search by page" => "Cerca per pàgina",
"results found" => "resultats trobats",
// "Remove keywords for this page" => "Remove keywords for this page",
"No pages found" => "No s'han trobat pàgines",
// "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Genera posicions per cops",
"List of featured links" => "Llista d'enllaços destacats",
// "Remove featured link" => "Remove featured link",
"Add Featured Link" => "Afegeix un enllaç",
"Edit this Featured Link:" => "Edita aquest Enllaç Especial:",
"Create new Featured Link" => "Crea un nou Enllaç Especial",
"disables the link" => "deshabilita l'enllaç",
"Link type" => "Tipus d'enllaç",
"replace current page" => "reemplaçar la pàgina actual",
"framed" => "en un marc",
"open new window" => "obrir una finestra nova",
"Mail-in accounts" => "Comptes de Correu-in",
// "Allow" => "Allow",
"Leave" => "Deixar",
// "Auto-category" => "Auto-category",
// "Auto-namespace" => "Auto-namespace",
"Administrator" => "Administrador/a",
// "Admin Mail-in Routes" => "Admin Mail-in Routes",
"Check Mail-in accounts" => "comprovar comptes de Mail",
"Check automatically" => "comprovar automàticament",
"Frequency" => "Freqüència",
// "Check Manually Now" => "Check Manually Now",
// "Admin Mail-in routes" => "Admin Mail-in routes",
// "Structure Routing" => "Structure Routing",
"Wiki structures feature is not enabled" => "La funcionalitat de les Wiki Estructures no està activada",
// "List Menus" => "List Menus",
"Create menu option" => "Crear opció de menú",
// "Edit This Menu" => "Edit This Menu",
// "Export menu options" => "Export menu options",
// "Import menu options" => "Import menu options",
"Manage menu" => "Menú Administrar",
"Menu options" => "Opcions del menú",
// "Save Options" => "Save Options",
// "New option" => "New option",
// "Check this if the option is an alternative to the previous one" => "Check this if the option is an alternative to the previous one",
// "Drag this on to the menu area below" => "Drag this on to the menu area below",
// "URL or ((page name))" => "URL or ((page name))",
// "Test URL" => "Test URL",
// "Remove Option" => "Remove Option",
"Preview menu" => "Previsualitza menú",
// "Deploy" => "Deploy",
// "Menu Options" => "Menu Options",
"RESET" => "REAJUST",
"Clear Cache" => "Esborra memòria cau",
"Show hidden modules" => "Mostrar mòduls ocults",
"Hide hidden modules" => "Amaga mòduls ocults",
"Exit Modules" => "Surt dels Mòduls",
"Modules Parameters" => "Mòduls Paràmetres",
"The following required parameters are missing" => "Els següents paràmetres necessaris no estan disponibles",
"Drag the modules around to re-order then click save when ready" => "Arrossega els mòduls al voltant per a re-ordenar-los i llavors fes clic a Desa quan estiguis llest",
"Double click them to edit" => "Feu doble clic per editar",
"Modules with \"position: absolute\" in their style can be dragged in to position" => "Mòduls amb \"position: absolute\" en el seu estil es poden arrossegar fins a la posició",
"New modules can be dragged from the \"All Modules\" tab" => "Es poden arrossegar nous mòduls des de la pestanya \"tots els mòduls\"",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>",
"More info here" => "Més info aquí",
"Assigned modules" => "Mòduls Assignats",
"Assign/Edit modules" => "Assignar / editar mòduls",
"Assigned Modules" => "Mòduls assignats",
"Add module" => "Afegeix mòdul",
// "You will need to go" => "You will need to go",
// "to reorder or move modules in the left or right columns since you have created a custom order for these" => "to reorder or move modules in the left or right columns since you have created a custom order for these",
// "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user" => "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user",
"Edit module" => "Edita mòdul",
"Assign new module" => "Assigna un nou mòdul",
"Edit this assigned module:" => "Edita el mòdul asignat:",
"Module Options" => "Opcions del mòdul",
"Custom Modules" => "Mòduls personalitzats",
// "Delete custom module" => "Delete custom module",
"Create new custom module" => "Crear un nou mòdul personalitzat",
"Edit this custom module" => "Edita aquest mòdul personalitzat",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Parse using" => "Parse using",
// "Wiki Markup" => "Wiki Markup",
"Objects that can be included" => "Objectes que es poden incloure",
"Available polls" => "Sondejos disponibles",
"Random active poll" => "Sondeig actiu aleatori",
"Random current poll" => "Sondeig actual aleatori",
// "Use gallery" => "Use gallery",
"Random image from" => "Imatge a l'atzar de",
"Dynamic content blocks" => "Blocs de contingut dinàmic",
// "Use dynamic content" => "Use dynamic content",
"External feeds" => "Alimentacions externes",
// "Use RSS module" => "Use RSS module",
"Banner zones" => "Zones de banners",
// "Use banner zone" => "Use banner zone",
// "Use wiki structure" => "Use wiki structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes",
"To use a default Tiki menu" => "Per utilitzar un menú predeterminat Tiki",
"All Modules" => "Tots els mòduls",
"Show all modules" => "Mostra tots els mòduls",
"Admin newsletter subscriptions" => "Administrar subscripcions al butlletí",
"Subscriptions" => "Subscripcions",
"Groups included through inheritance" => "Grups inclosos per herència",
// "Remove subscription" => "Remove subscription",
"Wiki Page Name" => "Nom de pàgina wiki",
"Validate Addresses" => "Valida les adreces",
"Add To List" => "Afegeix-ne a la llista",
"Subscribed" => "Subscrit/s",
// "Mark subscription as valid" => "Mark subscription as valid",
"Unsubscribed" => "Donat/s de baixa",
// "Remove selected subscriptions" => "Remove selected subscriptions",
"Add subscribers" => "Afegeix subscriptors/es",
"You can add several email addresses by separating them with commas." => "Pots afegir varies adreces de correu electrònic separant-les amb comes.",
// "Add email" => "Add email",
// "Add user" => "Add user",
"Users from group" => "Usuaris/es del grup",
"Group subscription also subscribes included groups" => "La subscripció al grup també subscriu als grups inclosos",
// "Don't send confirmation email" => "Don't send confirmation email",
"The user email will be refreshed at each newsletter sending" => "El correu-e de l'usuari/a s'actualitzarà cada vegada que s'enviï un butlletí",
"Import emails from file" => "Importa correus-e des d'un arxiu",
// ".txt file, one email per line" => ".txt file, one email per line",
// "Don't send confirmation emails" => "Don't send confirmation emails",
"Import emails from wiki page" => "Importa correus-e des d'una pàgina wiki",
"Wiki page, one email per line" => "Pàgina wiki, un correu-e a cada línia",
// "Import emails from tracker" => "Import emails from tracker",
"Subscribe group" => "Subscriu el grup",
"Including group inheritance" => "Incloent herència de grups",
"Including group, group users and emails will be refreshed at each newsletter sending" => "El grup, els usuaris del grup i els correus electrònics s'actualitzaran a cada butlletí que s'enviï",
"Use subscribers of another newsletter" => "Empra subscriptors/es d'un altre butlletí",
"Use emails from wiki page" => "Empra correus-e des de pàgina wiki",
"Wiki page" => "Pàgina Wiki",
"Emails on a wiki page which will be added at each newsletter sending, one email per line" => "Correus-e a una pàgina wiki que seran afegits cada vegada que s'enviï un nou butlletí, amb un correu-e a cada línia",
"Don't subscribe emails" => "No subscriguis correus-e",
"Export Subscriber Emails" => "Exporta els correus-e dels subscriptors",
"Admin newsletters" => "Administrar butlletins",
"List Newsletters" => "Llista Butlletins",
"Send Newsletters" => "Envia Butlletins",
"Editions" => "Edicions",
"Drafts" => "Esborranys",
"Last Sent" => "últims enviats",
// "Remove newsletter" => "Remove newsletter",
"Create/Edit Newsletters" => "Crea/edita butlletins",
"There are individual permissions set for this newsletter" => "Hi ha permisos individuals fixats per a aquest butlletí",
"Users can subscribe/unsubscribe to this list" => "Els usuaris es poden subscriure/desubscriure a la llista d'aquest butlletí",
"Users can subscribe any email address" => "Els usuaris poden subscriure qualsevol adreça de correu-e",
"Add unsubscribe instructions to each newsletter" => "Afegir instruccions de desubscripció a cada butlletí",
"Validate email addresses" => "Valida adreces de correu-e",
"Allow customized text message to be sent with the HTML version" => "Permet que s'hi pugui posar un missatge de text senzill personalitzat amb l'enviament de la versió en html",
"Allow clipping of articles into newsletter" => "Permet el pinçat d'articles a incloure a dins d'un butlletí",
"Automatically clip articles into newsletter" => "Pinça automàticament articles a dins del butlletí",
"Do not send newsletter if clip is empty" => "No envieu butlletí si la pinça d'articles a incloure és buida",
"Clip articles published in the past number of days" => "Pinça els articles publicats en el darrer número de dies per a incloure'ls",
"Article types to clip" => "Tipus d'articles a pinçar per a incloure'ls",
"Mail notifications" => "Notificacions per correu-e",
// "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "Afegeix notificació",
"Destination" => "Destinació",
"Myself" => "Jo mateix",
"Note that a user is not notified for his or her own action" => "Tingueu en compte que un usuari no és notificat per la seva pròpia acció",
"User / Group" => "Usuari / grup",
// "Delete mail notification event" => "Delete mail notification event",
// "Delete selected notification events" => "Delete selected notification events",
"Trackers Outbound Emails" => "Correus electrònics sortints de Formularis-bd (Trackers)",
"Forums Outbound Emails" => "Fòrums correus electrònics sortints",
// "OAuth Server" => "OAuth Server",
// "List of clients" => "List of clients",
// "Client_id" => "Client_id",
// "Client_secret" => "Client_secret",
// "Redirect_uri" => "Redirect_uri",
"Admin Polls" => "Administrar sondejos",
"Preview poll" => "Previsualitza sondeig",
"Add poll option" => "Afegix opció per al sondeig",
"Edit poll option" => "Edita l'opció del sondeig",
"Poll options" => "Opcions del sondeig",
"Votes" => "Vots",
"Set last poll as current" => "Posar l'últim sondeig com actual",
"Close all polls but last" => "Tanca tots els sondejos menys el darrer",
"Activate all polls" => "Activar tots els sondejos",
"Create poll" => "Crea un sondeig",
"Edit poll" => "Edita el sondeig",
"active" => "actiu/va",
"object" => "objecte",
"Toggle Quick Options" => "Activar ràpides",
"Add Option" => "Afegir Opció",
"Leave box empty to delete an option" => "Deixa caixa buida per eliminar una opció",
// "Votes older than x days are not considered" => "Votes older than x days are not considered",
"0 for no limit" => "0 per ilimitat",
"Results" => "Resultats",
"Add poll to pages" => "Afegeix sondeig a pàgines",
"{\$channels[ix].title}" => "{\$channels[ix].title}",
"This menu shows only Polls with 'status': \"template\"" => "Aquest menú només mostra Sondejos de 'status': \"template\"",
"{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Bloqueja les pàgines",
// "Custom Route" => "Custom Route",
// "Add a new Custom Route" => "Add a new Custom Route",
// "Edit route settings" => "Edit route settings",
// "Edit route" => "Edit route",
// "Add a new route" => "Add a new route",
// "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value" => "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value",
// "The users will get redirected to the tracker item that has a field that matches the value found in the URL" => "The users will get redirected to the tracker item that has a field that matches the value found in the URL",
// "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10" => "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10",
// "Router Type" => "Router Type",
// "Check this option to set route as a Short URL" => "Check this option to set route as a Short URL",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Aquesta pàgina és per configurar els paràmetres d'alimentació externa de lectura / importats per Tiki. Per generar / exportar aliments, busqui \"Feeds\" al panell d'administració, o",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed" => "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed",
"Content for the feed" => "Contingut per a l'alimentació",
// "Refresh All feeds" => "Refresh All feeds",
"Show Date" => "Mostrar Data",
"Refresh rate" => "Temps de refresc",
// "Article generator" => "Article generator",
"Edit Feed" => "Edita Alimenti",
"Create Feed" => "Crear Alimenti",
"Create new external feed" => "Crea alimentació externa",
// "Show feed title" => "Show feed title",
"Show publish date" => "Mostrar data de publicació",
"Article Generator" => "Article Generador",
"Article Generator for %0" => "Generador d'articles per a %0",
// "Once you have defined the settings below, each new item in this rss feed will generate a new article" => "Once you have defined the settings below, each new item in this rss feed will generate a new article",
// "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones" => "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones",
// "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content" => "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content",
"Use Article Submission System" => "Utilitza el Sistema d'Enviament d'articles",
"Expiration" => "Caducitat",
"Publish in the future" => "Publicar en el futur",
"-1 to use original publishing date from the feed" => "-1 Per utilitzar la data de publicació original de l'alimentació",
// "Custom Settings for Source Categories" => "Custom Settings for Source Categories",
// "No source categories detected for this feed" => "No source categories detected for this feed",
// "Source Category" => "Source Category",
// "Priority (10 is highest)" => "Priority (10 is highest)",
// "Categorize Created Articles" => "Categorize Created Articles",
"Configure" => "Configura",
"Add a new Scheduler" => "Afegeix una nova programació",
"Schedulers" => "Programacions",
"Run Time" => "Hora d'execució",
"Re-Run" => "Re-executa-ho",
"Edit scheduler settings" => "Edita els paràmetres de la programació",
// "Stalled" => "Stalled",
// "Run now" => "Run now",
"Edit scheduler" => "Edita la programació",
"Add a new scheduler" => "Afegeix una programació",
"Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *" => "Empra format de CRON per introduir-hi els valors al \"Temps d'execució\":\n\t\t\t\t<br>\n\t\t\t\tMinut, Hora, Dia del mes, Mes, Dia de la setmana\n\t\t\t\t<br>\n\t\t\t\tP.e. cada 5 minuts: */5 * * * *",
"Run if missed" => "Executa'l si és saltat",
"Scheduler logs" => "Registres de la programació (logs)",
// "Last {\$numOfLogs} Logs" => "Last {\$numOfLogs} Logs",
// "Running" => "Running",
"Failed" => "No  han tingut èxit",
// "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>",
"Tiki settings" => "Configuració de Tiki",
"Tiki variable" => "Variable de Tiki",
"Setting" => "Configuració",
"Risk Factor" => "Factor de Risc",
"Explanation" => "Explicació",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "Sobre WikiPlugins i seguretat: Assegureu-vos de només concedir el permís \"tiki_p_plugin_approve\" als editors de confiança",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "Pots desactivar plugins perillosos a  (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
"You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "Pots aprovar l'ús de connectors (plugins) a <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
"Security checks" => "Els controls de seguretat",
"Check all tiki files" => "Comprova tots els arxius de tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Tingues present que això pot prendre's una estona molt llarga. Seria convenient comprovar el paràmetre del temps màxim d'execució (max_execution_time) a l'arxiu php.ini.",
"File checks" => "Comprovacions d'arxius",
"Check file permissions" => "Comprovi els permisos d'arxiu",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "Aquesta revisió intenta buscar arxius amb permisos d'arxius problemàtics. Alguns permisos dels arxius que es mostren aquí com un problema pot ser problemàtic o inevitable en alguns entorns",
"See end of table for detailed explanations" => "Veure al final de la taula per a una explicació detallada",
"owner" => "propietari",
"special" => "especial",
"other" => "un altre",
"uid" => "uid",
"gid" => "gid",
"suid" => "suid",
"sgid" => "sgid",
"sticky" => "enganxós",
"r" => "r",
"w" => "w",
"Set User ID (suid) files" => "Estableixi els arxius ID d'usuari (suid)",
"World writable files or directories" => "Arxius o directoris escribibles Món",
"Files or directories the Webserver can write to" => "Els arxius o directoris del servidor web poden escriure a",
"Strange Inodes (not file, not link, not directory)" => "Inodes estranyes (no arxiu, no enllaç, no directori)",
"Executable files" => "Els arxius executables",
"What to do with these check results" => "Què fer amb aquests resultats de la comprovació",
"Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Fitxers SUID no formen part del tiki i no hi ha necessitat d'arxius suid en un espai web. De vegades els intrusos que obtenen privilegis elevats deixen arxius suid de \"mantenir la porta oberta \"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information",
"Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Els inodes que no són arxius o directoris que no són part del tiki. Reviseu aquests inodes",
"Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Ajust del bit d'execució pot ser perillós si el servidor web està configurat per executar scripts CGI des que els directoris. Si utilitza el mòdul php habitual (per Apache) i després scripts PHP i altres arxius en tiki no necessita tenir el bit d'execució. Pots treure el bit d'executable amb chmod",
"Admin Shoutbox Words" => "Administra quadre d'avisos",
"Add Banned Word" => "Afegeix una paraula prohibida",
"Are you sure you want to delete this word?" => "Segur que voleu eliminar aquesta paraula?",
// "Rebuild sitemap" => "Rebuild sitemap",
// "Submit the Sitemap" => "Submit the Sitemap",
// "You can submit the sitemap for processing in all major search engines using the following URL" => "You can submit the sitemap for processing in all major search engines using the following URL",
// "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap" => "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap",
// "Automate Sitemap generation" => "Automate Sitemap generation",
// "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t" => "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t",
// "Or you can use directly the command line" => "Or you can use directly the command line",
"XML Zip Import" => "XML Import Zip",
"Feedback" => "Retroalimentació",
// "Structure created" => "Structure created",
"View Page" => "Visualitza pàgina",
"Please Confirm" => "Si us plau, confirma-ho",
"You will remove structure" => "Esborraràs lestructura",
"Destroy the structure leaving the wiki pages" => "Destrueix l'estructura deixant les pàgines wiki",
"Destroy the structure and remove the pages" => "Destrueix l'estructura i esborra les pàgines",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict:" => "Pren nota que les pàgines següents formen part també d'una altra estructura. Assegura't que els permisos d'accés (si n'hi ha) no entren en conflicte:",
"The following pages have automatically been categorized with the same categories as the structure:" => "Les pàgines següents han estat categoritzades automàticament amb les mateixes categories que l'estructura:",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent:" => "Les pàgines següents estan assignades a categories però l'estrucura no en té assignada cap. És possible que vulguis descategoritzar-les per ser consistent:",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent:" => "Les següents pàgines es troben en categories a les quals l'estructura no es troba assignada. És possible qeu vulguis recategoritzar-les a fi i efecte de ser consistent:",
// "Existing Structures" => "Existing Structures",
// "View Structure" => "View Structure",
"View structure" => "Visualitza l'estructura",
// "Export pages" => "Export pages",
// "Dump tree" => "Dump tree",
"Create WebHelp" => "Crear AjudaWeb",
"View WebHelp" => "Visualitza ajutweb",
"XML Zip" => "Zip XML",
"Perform action with selected" => "Realitza l'acció amb els seleccionats",
".." => "..",
"Delete with the pages" => "Esborra-ho amb les pàgines",
// "Create Structure" => "Create Structure",
"Alias" => "Àlies",
"Tree" => "Arbre",
"Use single spaces to indent structure levels" => "Empra espais simples per indentar nivells d'estructura",
"Create New Structure" => "Crear nova estructura",
"Edit survey questions" => "Edita preguntes de l'enquesta",
"Add a New Question" => "Afegir una nova pregunta",
"List Surveys" => "Llista Enquestes",
"Survey Stats" => "Estadístiques d'enquestes",
"This survey stats" => "Aquesta enquesta estadístiques",
"Edit this Survey" => "Edita aquesta enquesta",
"Admin Surveys" => "Administra enquestes",
"Questions" => "Preguntes",
"Question" => "Pregunta",
"Answer is mandatory" => "La resposta és obligatòria",
// "Required answers" => "Required answers",
// "Single choice using radio buttons" => "Single choice using radio buttons",
// "Example: \"one, two, many, lots\"" => "Example: \"one, two, many, lots\"",
// "(Use \"\\,\" to include a comma" => "(Use \"\\,\" to include a comma",
// "Multiple choice using checkboxes" => "Multiple choice using checkboxes",
"For a rate, you can give the maximum value." => "Per a una valoració, pots donar el valor màxim.",
// "Multiple choices of thumbnail from a file gallery, options contains Gallery ID" => "Multiple choices of thumbnail from a file gallery, options contains Gallery ID",
// "Example: 4" => "Example: 4",
// "Options are: rows,columns,toolbars" => "Options are: rows,columns,toolbars",
// "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)" => "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)",
// "For the 'short text' type, options are: columns" => "For the 'short text' type, options are: columns",
// "Example: 60" => "Example: 60",
// "A heading to go between questions. Options are newpage,tag" => "A heading to go between questions. Options are newpage,tag",
// "Example: y,h4" => "Example: y,h4",
"Options (if apply)" => "Opcions (si és el cas)",
"Admin surveys" => "Administrar enquestes",
"Create/Edit Surveys" => "Crea/Edita Enquestes",
"Edit this Survey:" => "Edita aquesta Enquesta:",
"Create New Survey" => "Crea Nova Enquesta",
"There are individual permissions set for this survey" => "Hi ha permisos individuals fixats per a aquesta enquesta",
// "Synchronize Dev/Prod Servers" => "Synchronize Dev/Prod Servers",
// "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one" => "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one",
// "Remote Server Address" => "Remote Server Address",
// "Show diff" => "Show diff",
"Local" => "Local",
"Remote" => "Remot",
"System Administration" => "Administració del Sistema",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Si el teu Tiki està actuant de forma rara, la primera cosa a provar és netejar la memòria cau de sota. També és molt important netejar la teva memòria cau després d'una actualització (per FTP/SSH si és necessari).",
"Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>" => "Mira també l'opció \"Reconstruir l'Índex \" al <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Panell de Control de Cerca</a>",
"Clear cached content" => "Neteja el contingut emmagatzemat en memòria cau",
"Empty" => "Buit",
// "All user preference sessions" => "All user preference sessions",
// "Save directories" => "Save directories",
"Directories to save" => "Directoris a desar",
"Directory is not writeable" => "No es pot escriure al Directori",
"Full Path to the Zip File" => "Ruta d'accés completa a l'arxiu Zip",
// "ZIP" => "ZIP",
// "Generate zip" => "Generate zip",
"A zip has been written to %0" => "S'ha escrit un arxiu comprimit en format zip a %0",
"Groups still used in the database but no more defined" => "Grups encara s'utilitzen a la base de dades però no més definits",
"Admin Tokens" => "Tokens admin",
"List tokens" => "Llista de tokens",
"Timeout" => "Temps d'espera",
// "Hits left" => "Hits left",
"Max hits" => "Max èxits",
// "Create Temp User" => "Create Temp User",
// "Temp User Prefix" => "Temp User Prefix",
"Add new token" => "Afegeix nou token",
"Token successfully created" => "Token creat amb èxit",
"Full URL" => "URL",
"Timeout in seconds (-1 for unlimited)" => "Temps d'espera en segons (-1 a il·limitada)",
"Maximum number of hits (-1 for unlimited)" => "El nombre màxim d'accessos (-1 per a un nombre il·limitat)",
"Groups (separated by comma)" => "Grups (separats per comes)",
"View mode" => "Mode de visualització",
"Wiki and WYSIWYG" => "Wiki i WYSIWYG",
"Wiki only" => "Només Wiki",
// "WYSIWYG (HTML mode)" => "WYSIWYG (HTML mode)",
// "WYSIWYG (wiki mode)" => "WYSIWYG (wiki mode)",
"Reset to Global" => "Restablir Global",
"Reset to defaults" => "Retorn prefixats",
"Formatting Tools" => "Eines de format",
"Plugin Tools" => "Eines de Connectors (Plugins)",
"Edit tool" => "Eina d'Edició",
"Wysiwyg Token" => "Wysiwyg Token",
"Custom Tools" => "Eines personalitzades",
"Add a new custom tool" => "Afegir una nova eina personalitzada",
"To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "Per configurar les barres d'eines en les diferents àrees d'edició de text, seleccioneu la secció i, opcionalment, marqui la casella comentaris, que voleu editar i arrossegament les icones de la caixa de l'esquerra a les barres d'eines a la dreta.  <br>\nDrag icons darrere de la files de la barra d'eines a la llista completa per eliminar-los. <br>\nIcons amb <strong> negreta </​​strong> etiquetes són per a àrees de text wiki, els que són <em> cursiva </em> són per al mode WYSIWYG, i els que són <strong><em> negreta i cursiva </em> </strong> són per a tots dos. <br>\nPer desar el conjunt actual utilitza el desplegable (i, opcionalment, marca la casella comentaris) a la part inferior de la pàgina per configurar on desitges que apareguin aquestes barres d'eines i fes clic a Desa",
"If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "Si estàs experimentant problemes amb aquesta pàgina després d'actualitzar de Tiki 4, per favor utilitza aquest enllaç per eliminar totes les eines personalitzades",
"Delete all custom tools" => "Eliminar totes les eines personalitzades",
"Warning: There is no undo" => "Advertència: no es pot desfer",
"List Articles" => "Llista els Articles",
"Add topic" => "Afegeix Tema",
"Notification Email" => "Correu-e de notificació",
// "You will be able to add a notification email per article topic when you edit the topic after its creation" => "You will be able to add a notification email per article topic when you edit the topic after its creation",
"topic image" => "imatge del tema",
"Activate" => "Activa",
// "De-activate" => "De-activate",
"Remove with articles" => "Esborrar amb els articles",
"Tracker Fields" => "Camps de Formulari-bd",
"Admin Tracker" => "Administra formulari",
"Import Fields" => "Importa els Camps",
"Mandatory" => "Obligatori",
"Save All" => "Desa-ho Tot",
"Remove Selected" => "Elimina els seleccionats",
"Export Selected" => "Exporta els seleccionats",
"Subset Selection" => "Selecció de subconjunt",
"Category Selection" => "Selecció de categoria",
"Group Selection" => "Selecció de grups",
"Add Group" => "Afegeix Grup",
// "Press Enter for each group" => "Press Enter for each group",
// "At least two elements are required to create transitions. Additional tabs appear once the selection is completed" => "At least two elements are required to create transitions. Additional tabs appear once the selection is completed",
"Draw Transition Diagram" => "Dibuixeu diagrama de transició",
"Guards" => "Guàrdies",
"preserved" => "en conserva",
"No transitions" => "No hi ha transicions",
"New / Edit" => "Nuevo / Edita",
"Edit <em>%0</em>" => "Edita <em>%0</em>",
"New transition" => "New transició",
"Upon trigger, preserve the initial state" => "A gallet, preservar l'estat inicial",
"Members" => "Membres",
"No guards on this transition" => "No hi ha guàrdies en aquesta transició",
"New Guard" => "Nova Guàrdia",
"Exactly" => "Exactly",
"States" => "Estats",
// "Body of POST request" => "Body of POST request",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Introdueix l'URL d'un servei web que torni ja sigui JSON o YAML. Els paràmetres poden ser especificats per tancar un nom entre signes de percentatge. Per exemple: %name%. %service% i %template% són paraules clau reservades i no es poden utilitzar",
"Parameters (%name%)" => "Paràmetres (%name%)",
"Operation" => "Operació",
// "%0 requires no parameter" => "%0 requires no parameter",
"Test Input" => "Entrada de prova",
// "Bypass cache" => "Bypass cache",
"Response Information" => "Informació de la Resposta",
"OIntegrate Version" => "OIntegrate Version",
"Not supported" => "No compatible",
"Schema Version" => "Versió d'esquema",
"Schema Documentation" => "Documentació d'esquema",
"Not specified, default used" => "No s'especifica, per omissió utilitza",
"Content Type" => "Tipus de contingut",
"Not specified" => "Sense especificar",
"Returned Data" => "Les dades obtingudes",
// "tuncated at approx. 1MB" => "tuncated at approx. 1MB",
"Proposed Templates" => "Plantilles propostes",
"Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Registrar aquest servei web. Serà possible registrar les plantilles després. Nom del servei només ha de contenir lletres",
"Register Service" => "Registre de servei",
"Registered Templates" => "Plantilles registrats",
"Engine" => "Motor",
"Output" => "Sortida",
// "Toggle template source" => "Toggle template source",
"Register Template" => "Registrar Plantilla",
// "Add New Group" => "Add New Group",
"Invitation List" => "Llista de convidats",
"List of existing groups" => "Llista de grups existents",
"Inherits Permissions from" => "Hereta els permisos de",
"User Choice" => "elecció de l'usuari",
"Edit group" => "Edita el grup",
"{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
"{\$users[user].groupHome}" => "{\$users[user].groupHome}",
"{\$users[user].userChoice}" => "{\$users[user].userChoice}",
// "Create group" => "Create group",
"Group is NOT being monitored. Click icon to START monitoring" => "El Grup NO està essent monitorejat. Fes clic a la icona per a COMENÇAR A monitorejar-lo",
"Group IS being monitored. Click icon to STOP monitoring" => "El Grup SI que està essent monitorejat. Fes clic a la icona per a DEIXAR DE monitorejar-lo",
// "Inheritance" => "Inheritance",
// "Permissions will be inherited from these groups" => "Permissions will be inherited from these groups",
// "Indirectly included groups" => "Indirectly included groups",
// "Group Home" => "Group Home",
"Use wiki page name or full URL" => "Empra pàgina Wiki o URL sencera",
"For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "Per altres funcions Tiki, utilitzeu enllaços relatius a l'arrel del Wiki (com <em>/tiki-forums.php</em>)",
// "Default Category" => "Default Category",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Categoria per defecte assignada a objectes no categoritzats editats per un usuari amb aquest grup per defecte",
"Use site default" => "Fes servir el que hi ha per defecte al lloc",
// "Group color" => "Group color",
// "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color" => "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color",
"Group Information Tracker" => "Formulari-bd per a la informació del Grup",
// "choose a group tracker .." => "choose a group tracker ..",
// "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign" => "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign",
"choose a field ..." => "escull un camp ...",
// "Select the user selector field from the above tracker" => "Select the user selector field from the above tracker",
// "Go to trackers list" => "Go to trackers list",
// "User Registration Tracker" => "User Registration Tracker",
// "choose a user tracker .." => "choose a user tracker ..",
// "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign" => "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign",
// "Select user field" => "Select user field",
"Choose a field .." => "Escull un camp ..",
// "No fields in tracker .." => "No fields in tracker ..",
// "Select the user selector field from the above tracker to link a tracker item to the user upon registration" => "Select the user selector field from the above tracker to link a tracker item to the user upon registration",
// "No fields in this tracker" => "No fields in this tracker",
// "Go to tracker list" => "Go to tracker list",
// "User Wizard Fields" => "User Wizard Fields",
// "By default, the same fields as in registration are used" => "By default, the same fields as in registration are used",
// "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time" => "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time",
// "Group or User Tracker Registration Fields" => "Group or User Tracker Registration Fields",
// "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete" => "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete",
"User can assign himself or herself to the group" => "L'usuari es pot afegir ell mateix al grup",
// "Membership expiry" => "Membership expiry",
// "Anniversary" => "Anniversary",
// "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date" => "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date",
"Or" => "O",
// "Number of Days" => "Number of Days",
// "Number of days after which all users will be unassigned from the group" => "Number of days after which all users will be unassigned from the group",
// "Pro-Rate Membership" => "Pro-Rate Membership",
// "Payment for membership extension is prorated at a minimum interval" => "Payment for membership extension is prorated at a minimum interval",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "Els usuaris s'assignen automàticament en inscriure en el grup si els seus missatges de correu electrònic que coincideixi amb el patró",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Assign Permissions" => "Assignar permisos",
"Group tracker item : {\$groupitemid}" => "Item del formulari de Grup : {\$groupitemid}",
"Edit Item" => "Edita ítem",
"Group tracker item not found" => "No s'ha trobat l'ítem del formulari de Grup",
// "</i>\"}%0 members" => "</i>\"}%0 members",
// "Assigned" => "Assigned",
"Edit user" => "Editeu l'usuari",
// "Remove from group" => "Remove from group",
// "No members" => "No members",
// "Add or ban users" => "Add or ban users",
"Add to group" => "Afegeix al grup",
// "Ban from group" => "Ban from group",
// "</i>\"}Users banned from %0" => "</i>\"}Users banned from %0",
// "Banned members" => "Banned members",
"Unban user" => "Desbloqueja usuari",
// "Unban user %0 from group %1" => "Unban user %0 from group %1",
// "No banned members" => "No banned members",
// "</i>\"}%0 import/export" => "</i>\"}%0 import/export",
// "Export group users (CSV file)" => "Export group users (CSV file)",
"Charset encoding" => "Codificació de Caràcters",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
// "Import users to group (CSV file)" => "Import users to group (CSV file)",
// "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Afegeix un nou usuari",
"Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Des d'aquest lloc Tiki està en mode esclau i grups de les importacions, els grups de mestres es tornen a importar automàticament a cada inici de sessió",
"Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Des d'aquest lloc Tiki està en mode esclau i les importacions preferències, les preferències de l'usuari mestres es tornen a importar automàticament a cada inici de sessió",
"Number of displayed rows" => "Nombre de files mostrades",
"More Criteria" => "Més Criteris",
"Group (direct)" => "Grup (directe)",
"Email not confirmed" => "El correu electrònic no confirmat",
"User not validated" => "L'usuari no validada",
"OpenID" => "OpenID",
// "Edit account settings" => "Edit account settings",
"N" => "N",
"Registered %0 ago" => "Fa Registered %0",
"Need to validate email" => "Necessita de validar el correu-e",
// "Edit this included group" => "Edit this included group",
// "Add or remove from a group" => "Add or remove from a group",
// "Edit group expiry" => "Edit group expiry",
"Change user preferences" => "Canvia les preferències de l'usuari",
// "Switch to this user" => "Switch to this user",
// "Validate user" => "Validate user",
// "Invalidate user" => "Invalidate user",
// "Remove link with OpenID for this user" => "Remove link with OpenID for this user",
"Remove link with OpenID account" => "Eliminar vinculació compte OpenID",
// "Remove users.." => "Remove users..",
// "Ban IPs" => "Ban IPs",
// "Change group assignments" => "Change group assignments",
// "Set default groups" => "Set default groups",
// "Send wiki page content by email" => "Send wiki page content by email",
// "Warning: User Encryption is Active" => "Warning: User Encryption is Active",
// "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted" => "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted",
"Assign user to Groups" => "Assigna l'usuari a Grups",
// "Intertiki Enabled" => "Intertiki Enabled",
// "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"" => "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"",
"Use the email as username" => "Empra correu-e com a nom d'usuari",
// "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames" => "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames",
// "Changing username is disabled for Intertiki sites" => "Changing username is disabled for Intertiki sites",
"No password is required" => "No cal contrasenya",
"Tiki is configured to delegate the password managment to LDAP" => "Tiki està configurat per delegar la gerència contrasenya LDAP",
"New password" => "Nova contrasenya",
"Confirm new password" => "Confirma contrasenya nova",
"User must change password at next login" => "L'usuari ha de canviar la contrasenya a la següent connexió",
"Send an email to the user to enable him or her to validate their account" => "Envia un correu electrònic a l'usuari per tal de permetre que ell validi el seu compte",
// "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>",
// "Add a user tracker item for this user" => "Add a user tracker item for this user",
// "User tracker" => "User tracker",
// "View item" => "View item",
// "Modify this user\\'s data" => "Modify this user\\'s data",
"Pass confirmed" => "Contrasenya confirmada el",
"Email confirmed" => "Correu-e confirmat el",
"%0 days ago" => "Fa %0 dia/es",
"Current Login" => "Inicia sessió actual",
"You do not have permission to edit this user" => "No té permís per editar aquest usuari",
// "Your file should contain in the first row (first entry) the following fields" => "Your file should contain in the first row (first entry) the following fields",
// "user1,pass1,email1,group1,group1" => "user1,pass1,email1,group1,group1",
// "user2,pass2,email2,\"group1,group2\",group1" => "user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time" => "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time",
// "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any" => "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any",
// "Existing Users" => "Existing Users",
"Don't overwrite" => "No sobreescriure",
"Overwrite groups" => "Sobreescriure grups",
"Create groups" => "Crear grups",
"The user must change his or her password the first time they log in" => "L'usuari ha de canviar la contrasenya en el primer inici de sessió",
// "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>" => "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>",
// "Temporary Users" => "Temporary Users",
// "Token Access Feature Dependency" => "Token Access Feature Dependency",
// "The token access feature is needed for Temporary Users to login" => "The token access feature is needed for Temporary Users to login",
// "Turn it on here" => "Turn it on here",
// "Feature Conflict" => "Feature Conflict",
// "This feature currently is incompatible with the \"Use email as username\" feature" => "This feature currently is incompatible with the \"Use email as username\" feature",
// "Turn it off here" => "Turn it off here",
// "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature" => "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature",
// "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token" => "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token",
// "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself" => "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself",
// "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms" => "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms",
// "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails" => "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails",
// "To revoke access before validity expires or to review who has access, please see" => "To revoke access before validity expires or to review who has access, please see",
// "Email addresses (comma-separated)" => "Email addresses (comma-separated)",
// "Valid for days (use -1 for forever)" => "Valid for days (use -1 for forever)",
// "Username prefix" => "Username prefix",
// "Autologin (non-SEFURL) path" => "Autologin (non-SEFURL) path",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences",
"Add Type" => "Afegeix tipus de",
"Add article type" => "Afegeix tipus d'article",
"{\$types[user].type|escape}" => "{\$types[user].type|escape}",
"View articles with this type" => "Veure articles amb aquest tipus",
"Show before publish date" => "Mostrar abans de la data de publicació",
"Show after expire date" => "Mostrar després de la data expirada",
"Heading only" => "Encapçalament només",
"Comment can rate article" => "Els comentaris poden valorar l'article",
"Show image" => "Mostrar imatge",
"Show profile picture" => "Mostrar avatar",
"Show expire date" => "Mostrar data d'expiració",
"Show reads" => "Mostrar lectures",
"Show size" => "Mostrar mida",
"Show topline" => "Mostra línea superior",
"Show subtitle" => "Mostra subtítol",
"Show source" => "Mostra font",
"Show image caption" => "Mostra la llegenda imatge",
"Creator can edit" => "El creador pot editar-ho",
"Custom attribute" => "Atribut a mida",
"Assign User %0 to Groups" => "Assigna l'Usuari %0 als grups",
"{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"backlinks to" => "retroenllaços cap a",
"No backlinks to this page" => "No hi ha retroenllaços a aquesta pàgina",
"Directory batch upload" => "Càrrega de lots de directoris",
"Browse Gallery" => "Fulleja galeria",
"Upload From Disk" => "Pujar des del disc local",
"available images" => "imatges disponibles",
"Filesize" => "Mida de l'arxiu",
"Filetype" => "Tipus d'arxiu",
"Remove File Extension from Image Name" => "Traieu l'extensió d'arxiu en Nom d'imatge",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ex. per \"digicam0001.jpg\" s'utilitzarà digicam0001 pel camp nom",
"Convert the last sub directory to a sub gallery" => "Convertir l'últim sub directori per una galeria de sub",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "per exemple. de \"misc/screenshots/digicam0001.jpg\" es crearà una galeria anomenada \"screenshots\" ",
"Use the last sub directory name as description" => "Utilitza el darrer nom de subdirectori com a descripció",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "per exemple. de \"misc/screenshots/digicam0001.jpg\" es crearà una descripció \"screenshots\" ",
"Select a Gallery" => "Selecciona una Galeria",
"Process" => "Procés",
"Browse File Gallery" => "Navega per la Galeria d'Arxius",
"Please do not use this feature to upload data into the database" => "Si us plau, no utilitzeu aquesta funció per carregar les dades a la base de dades",
"Available Files" => "Fitxers disponibles",
// "File Permissions" => "File Permissions",
// "File is writable" => "File is writable",
// "File is not writable" => "File is not writable",
"Total: %0" => "Total: %0",
"Select a File Gallery" => "Selecciona una galeria d'arxius",
"Root" => "Arrel",
// "Upload into galleries according to sub-directories" => "Upload into galleries according to sub-directories",
// "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists" => "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists",
// "Create sub-galleries" => "Create sub-galleries",
// "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set" => "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set",
// "Upload into galleries according sub-directory as galleryId" => "Upload into galleries according sub-directory as galleryId",
// "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists" => "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists",
"Process files" => "Procés d'arxius",
"Edit Post" => "Edita la publicació",
"New Post" => "Nova Publicació",
"View post" => "Visualitza la publicació",
"View Blog" => "Visualitza el Bloc",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Avís: Recorda que això és només una previsualització, i que no ha estat gravat encara!",
"Excerpt" => "Extracte",
"Admin the Category System" => "Administració del Sistema de Classificació",
"Browse in" => "Navega per",
// "or in" => "or in",
"Image galleries" => "Galeries d'imatges",
"Trackers Items" => "Ítems dels Formularis-bd",
"Sheets" => "Fulls",
"Find in" => "Troba a",
// " in the current category and its subcategories" => " in the current category and its subcategories",
"Hide subcategories objects" => "Amaga els objectes de les subcategories",
"Show subcategories objects" => "Mostra els objectes de les subcategories",
// "Up one level" => "Up one level",
"{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
// "Clear tags" => "Clear tags",
"With all selected tags" => "Amb totes les etiquetes seleccionades",
"With one selected tag" => "Amb una etiqueta seleccionada",
"With last selected tag" => "Amb l'última etiqueta seleccionada",
"More Popular Tags" => "Etiquetes més populars",
"Alphabetically" => "Alfabèticament",
"By Size" => "Per mida",
"Cloud" => "Núvol",
"{\$feature_label}" => "{\$feature_label}",
// "Filter in" => "Filter in",
"All blogs" => "Tots els blocs",
"{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
// "Delete Tag" => "Delete Tag",
"Browsing Gallery" => "Fullejant Galeria",
// "Gallery actions" => "Gallery actions",
"List Galleries" => "Llista les Galeries",
"Edit Gallery" => "Edita la Galeria",
"Upload Image" => "Pujarimatge",
"Directory Batch" => "Directori per pujada en bloc",
"List Gallery" => "Llista la galeria",
"All Images" => "Totes les imatges",
"Rebuild Thumbnails" => "Reconstrueix miniatures",
"{\$advice}" => "{\$advice}",
"Sort Images by" => "Ordena la imatge per",
"subgallery" => "subgaleria",
"Subgallery" => "Subgaleria",
// "Original size" => "Original size",
"rotate right" => "voltar a la dreta",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Pots veure la imatge que representa a aquesta galeria (la primera, a l'atzar, etc.) al teu navegador emprant",
"You can include the gallery's image in an HTML page using" => "Pots incloure la imatge d'aquesta galeria en una pàgina HTML emprant",
"You can include the image in a tiki page using" => "Pots incloure la imatge d'aquesta galeria en una pàgina de Tiki emprant",
"Browsing Image" => "Fullejant imatge",
"Return to Gallery" => "Torna a la galeria",
"Edit Image" => "Editar la imatge",
"Bigger" => "Més gran",
// "Slideshow forward" => "Slideshow forward",
// "Repeat" => "Repeat",
"Click to zoom" => "Fes clic per ampliar",
"Image Name" => "Nom de la imatge",
"Image size" => "Mida de la imatge",
"Image Scale" => "Escala de la imatge",
"Original Size" => "Tamany original",
"Move image" => "Moure la imatge",
"Include the image in a tiki page using the following syntax" => "Inclou la imatge d'aquesta galeria en una pàgina de Tiki emprant la següent sintaxi",
"To include the image in an HTML page" => "Per a incloure la imatge en una pàgina HTML",
"To link to this page from another tiki page" => "Per a enllaçar a aquesta pàgina des d'una altra pàgina de Tiki",
// "Monitoring" => "Monitoring",
"Visible Calendars" => "Calendaris Visibles",
"Group Calendars" => "Calendaris de Grup",
"Export calendars" => "Exporta els calendaris",
"advanced parameters" => "parametres avançats",
"Export as iCal" => "Exporta com a iCal",
"January" => "Gener",
"February" => "Febrer",
"March" => "Març",
"April" => "Abril",
"May" => "Maig",
"June" => "Juny",
"July" => "Juliol",
"August" => "Agost",
"September" => "Setembre",
"October" => "Octubre",
"November" => "Novembre",
"December" => "Desembre",
"Jan." => "Gen",
"Feb." => "Feb",
"Mar" => "Mar",
"Apr." => "Abr",
"Aug." => "Ago",
"Sep." => "Set",
"Oct." => "Oct",
"Nov." => "Nov",
"Dec." => "Des",
"Sun" => "Dg",
"Mon" => "Dl",
"Tue" => "Dm",
"Wed" => "Dc",
"Thu" => "Dj",
"Fri" => "Dv",
"Sat" => "Ds",
"today" => "avui",
// "semester" => "semester",
// "quarter" => "quarter",
"all-day" => "tot-el-dia",
"Organized by" => "Organitzat per",
"Classification" => "Classificació",
"View this Week" => "Visualitza aquesta Setmana",
"Change Focus" => "Change Focus",
"View this Day" => "Visualitza aquesta Dia",
"Calendar event : " => "Esdeveniment del Calendari : ",
"New event" => "Nou esdeveniment",
"View event" => "Visualitza esdeveniment",
"Edit/Delete event" => "Edita/Esborra l'esdeveniment",
// "Export Event as iCal" => "Export Event as iCal",
"Edit Calendar Item" => "edita l'item del calendari",
"New Calendar Item" => "Nova Cita al Calendari",
"Created by" => "Creat por",
"Recurrence" => "Recurrència",
"This event depends on a recurrence rule" => "Aquest esdeveniment depèn d'una regla de recurrència",
"ending by" => "acabant pel",
"ending after" => "acabant després de",
"events" => "esdeveniments",
// "(%0 events have been manually modified)" => "(%0 events have been manually modified)",
// "(%0 event has been manually modified)" => "(%0 event has been manually modified)",
"This event is not recurrent" => "Aquest esdeveniment no és recurrent",
"On a weekly basis" => "En base setmanal",
"Each" => "Cada",
"of the week" => "de la setmana",
"On a monthly basis" => "En base mensual",
"of the month" => "del mes",
"On a yearly basis" => "En base anual",
"of" => "de",
"Starting on" => "Començant el",
"Start period" => "Període d'inici",
// "End Period" => "End Period",
"End after" => "S'acaba després de",
"occurrences" => "occurrències",
"occurrence" => "occurrència",
"End before" => "Acaba abans de",
"Event occurs once on" => "L'esdeveniment ocorre un cop el",
"Event is repeated" => "Aquest esdeveniment es troba repetit",
"times" => "vegades",
"{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "de cada mes",
"on each" => "a cada",
"{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
"starting" => "començant",
"ending" => "acabant",
"Show duration" => "Mostra la durada",
"Events cannot end before they start" => "Els esdeveniments no poden acabar abans de començar",
"No description" => "Sese descripció",
"or new" => "o nou/va",
"Choose users to alert" => "Escull a quins usuaris avisar",
"Withdraw me from the list of participants" => "Treu-me de la llista de participants",
"Add me to the list of participants" => "Afegeix-me a la llista de participants",
"Roles" => "Rols",
"chair" => "presideix",
"default role" => "rol per defecte",
"required participant" => "participant requerit",
"optional participant" => "participant opcional",
"non-participant" => "no participant",
"Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in:" => "Posa la llista de participants separats per comes. Els rols han de ser posats en un prefix separats per dos punts com a:",
"role:login_or_email,login_or_email" => "rol:nom_d_usuari_o_correu-e,nom_d_usuari_o_correu-e",
"If no role is provided, default role will be \"Chair participant\"" => "Si no es posa cap rol, el rol per omissió serà \"Membre participant\"",
"Update this event only" => "Actualitza només aquest esdeveniment",
"Update every unchanged event in this recurrence series" => "Actualitza tots els esdeveniments no modificats d'aquesta regla de recurrència",
"Update every event in this recurrence series" => "Actualitza tots els esdeveniments d'aquesta regla de recurrència",
"Delete event" => "Esborra esdeveniment",
"Delete recurrent events" => "Esborra els events recurrents",
"Calendar import" => "Importa calendari",
"Calendar has been updated" => "El calendari ha estat actualitzat",
"%0 column name can be used instead of %1" => "Es pot emprar el nom de columna %0 enlloc de %1",
"import" => "importa",
// "Previous {\$viewmode|escape}" => "Previous {\$viewmode|escape}",
"D" => "D",
"W" => "S",
"M" => "M",
// "Next {\$viewmode|escape}" => "Next {\$viewmode|escape}",
"%d/%m" => "%d/%m",
"%m/%d" => "%m/%d",
"Advanced parameters for iCal export" => "Paràmetres avançats per a l'exportació iCal",
"Calendars to be exported" => "Calendaris que s'han d'exportar",
"Export calendars iCal" => "Exporta els calendaris en format iCal",
"Export calendars CSV" => "Exporta els calendaris en format CSV",
"Your account has been validated" => "S'ha validat el teu compte",
"You have to choose a password to use this account" => "Has d'escollir una contrasenya per a emprar aquest compte",
// "Change password" => "Change password",
// "Set password" => "Set password",
// "Old Password" => "Old Password",
"Repeat Password" => "Repeteix la contrasenya",
"MySQL or MariaDB Database Properties" => "Propietats de la base de dades MySQL o MariaDB",
// "Acknowledge (OK)" => "Acknowledge (OK)",
"Property" => "Propietat",
"Tiki Fitness" => "Aptitud de Tiki",
// "Acknowledge" => "Acknowledge",
// "New database engine" => "New database engine",
// "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki" => "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki",
"MySQL crashed Tables" => "Taules de MySQL Trencades",
"Be careful" => "Ves amb compte",
"The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure" => "La següent llista és només una mirada molt ràpida a SHOW TABLE STATUS que et diu, si les taules han estat marcades com a trencades. Si experimentes problemes de bases de dades hauries d'exercutar de totes formes CHECK TABLE o myisamchk per a assegurar-te del seu estat",
"Test sending emails" => "Comprova l'enviament de correus-e",
"To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>" => "Per comprovar si la teva instal·lació és capaç d'enviar correus-e, visita si us plau l'<a href=\"tiki-install.php\">Instal·lador de Tiki</a>",
"Server Information" => "Informació del Servidor",
"Server Properties" => "Propietats del Servidor",
"Special directories" => "Directoris Especials",
"To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>" => "Per a fer còpies de seguretat d'aquests directoris, ves a <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>",
"Fitness" => "Aptitud",
"Directory is writeable" => "El directori es escrivible",
"Apache properties" => "Propietats d'Apache",
"IIS properties" => "Propietats de IIS",
"PHP scripting language properties" => "Propietats d'idioma de rutines de PHP",
// "Change PHP configuration values" => "Change PHP configuration values",
// "{\$php_sapi_info.message}" => "{\$php_sapi_info.message}",
// "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>" => "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>",
// "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>" => "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>",
"PHP Security properties" => "Propietats de seguretat de PHP",
"To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>" => "Per a comprovar la integritat dels arxius de la teva instal·lació de Tiki, ves a <a href=\"tiki-admin_security.php\">Admin->Seguretat</a>",
// "Tiki Security" => "Tiki Security",
// "Sensitive Data Exposure" => "Sensitive Data Exposure",
// "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information",
// "Print configurations" => "Print configurations",
// "mPDF Information" => "mPDF Information",
// "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print" => "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print",
// "File Gallery Search Indexing" => "File Gallery Search Indexing",
// "More information %0 here %1" => "More information %0 here %1",
// "Command Missing" => "Command Missing",
// "The command \"shell_exec\" is required for file gallery search indexing" => "The command \"shell_exec\" is required for file gallery search indexing",
// "Mimetype" => "Mimetype",
// "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable" => "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable",
"MySQL Variable Information" => "Informació de Variables de MySQL",
"PHP Info" => "Informació de PHP",
"For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>" => "Per a una informació més detallada sobre la teva instal·lació de PHP, consulta <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>",
// "Benchmark PHP/MySQL" => "Benchmark PHP/MySQL",
// "Check" => "Check",
// "BOM Detected Files" => "BOM Detected Files",
// "Scanned files" => "Scanned files",
// "BOM files detected" => "BOM files detected",
// "No BOM files detected" => "No BOM files detected",
// "TRIM" => "TRIM",
// "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>" => "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>",
// "Requirements" => "Requirements",
// "OS not supported" => "OS not supported",
// "Apparently tiki is running on a Windows based server. This feature is not supported natively" => "Apparently tiki is running on a Windows based server. This feature is not supported natively",
// "User Data Encryption" => "User Data Encryption",
// "MCrypt encryption found in users data preferences" => "MCrypt encryption found in users data preferences",
// "Found %0 user(s) with data preferences encrypted with MCrypt" => "Found %0 user(s) with data preferences encrypted with MCrypt",
// "No user preferences were found with data encrypted with MCrypt" => "No user preferences were found with data encrypted with MCrypt",
// "Tiki Packages" => "Tiki Packages",
// "OCR Status" => "OCR Status",
"Please choose the language for this page" => "Si us plau, escull l'idioma d'aquesta pàgina",
"Choose language" => "Escull l'idioma",
"Contact Us" => "Contacta'ns",
"Send a message to us" => "Envia'ns un missatge",
"Your email" => "El teu correu-e",
"Contact us by email" => "Contacta'ns via correu-e",
"Click here to send us an email" => "Fes clic aquí per a enviar-nos un correu electrònic",
"Send another message" => "Envia un altre missatge",
"Contacts" => "Contactes",
"Group View" => "Vista agrupada",
"Create/edit contacts" => "Crea/edita contactes",
"First Name" => "Primer nom",
"Last Name" => "Darrer Nom",
"Nickname" => "Sobrenom",
"Publish this contact to groups" => "Publica aquest contact a grups",
// "Extra Fields" => "Extra Fields",
"Copy page" => "Copia Pàgina",
"Invalid page name" => "Nom de pàgina invàlid",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "El nom de pàgina especificat conté caracters que no són permesos. No et serà possible desar la pàgina fins que no eliminis aquests caracters: <strong>%0</strong>",
"The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "El nom de pàgina especificat conté caracters que poden fer-la d'accés difícil. Potser vols reconsiderar eliminar-ne aquests: <strong>%0</strong>",
"Use this name anyway" => "Utilitza aquest nom de totes maneres",
// "Duplicate tags" => "Duplicate tags",
"Quick Create Multilanguage Pages" => "Creació ràpida de Pàgines Multilíngües",
"Following pages were created, as translations of each other" => "Les següents pàgines van ser creades, com les traduccions dels altres",
"Following pages were not created" => "No es van crear pàgines següents",
"page already exists" => "la pàgina ja existeix",
"Enter the names of a new page page in various languages" => "Escriu el nom d'una nova pàgina en diversos idiomes",
"Preferred languages" => "Idiomes preferits",
"Other languages" => "Altres idiomes",
"Create pages" => "Crear pàgines",
"View generated WebHelp" => "Veure generat WebHelp",
"No structure" => "Cap estructura",
"Top page" => "La pàgina més activa",
"Add a new site" => "Afegeix una nova web",
"You cannot add sites until Directory Categories are setup." => "No pots afegir enllaços fins que es configurin les categories d'enllaços.",
"Please contact the Site Administrator" => "Si us plau, contacteu amb l'administrador del portal",
"<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\"> Afegir una categoria del directori ara </a>",
"Site added" => "Lloc afegit",
"The following site was added, but may require validation by the admin before appearing on the lists" => "S'afegeix el següent lloc, però pot requerir la validació per l'administrador abans d'aparèixer a les llistes",
"Edit a site" => "Editar un lloc",
"Add a site" => "Afegiu un lloc",
"Directory Categories" => "Directori de Categories",
"{\$countries[ux]}" => "{\$countries[ux]}",
"Admin Directory" => "Administrar directori",
"There are" => "Hi ha/n",
"invalid sites" => "web Invàlida",
"valid sites" => "llocs vàlids",
"Users have visited" => "Els usuaris han visitat",
"sites from the directory" => "llocs desde el directori",
"Users have searched" => "Els usuaris han cercat",
"times from the directory" => "vegades del directori",
"Validate" => "Valida",
"Admin directory categories" => "Administrar directori de categories",
"Parent directory category" => "Categoria del directori",
"Add a directory category" => "Afegeix una categoria directori",
"Edit this directory category" => "edita aquest directori de categoria",
"Add a Directory Category" => "Afegir una categoria de directoris",
"Child type" => "tipus infantil",
"Most visited directory sub-categories" => "Directori subcategories Més visitats",
"Directory category description" => "Directori Descripció de la categoria",
"Random directory sub-categories" => "Directori Random subcategories",
"Maximum number of child directory categories to show" => "Nombre màxim de nens a mostrar",
"Allow sites in this directory category" => "Permetre que els llocs d'aquesta categoria del directori",
"Show number of sites in this directory category" => "Mostra el nombre de llocs en aquesta categoria del directori",
"Editor group" => "Editor de grup",
"Directory Subcategories" => "Subcategories Directori",
"cType" => "cTipus",
"allow" => "permetre",
"count" => "compte",
"editor" => "editor",
// "Relate" => "Relate",
"Admin related directory categories" => "Categories directoris relacionats admin",
"Add a related directory category" => "Afegir una categoria del directori relacionada",
"Directory Category" => "Directori de categoria",
"Mutual" => "Mutu",
"Related directory categories" => "Categories directoris relacionats",
"Admin sites" => "Administració de llocs web",
"Is valid" => "És vàlid",
"New Sites" => "Nous llocs",
"Popular Sites" => "Llocs fantàstics",
"any" => "qualsevol",
"in entire directory" => "a tot el directori",
"in current directory category" => "en la categoria del directori actual",
"Sort by" => "Ordenat per",
"Hits (desc)" => "Hits (desc)",
"Hits (asc)" => "Hits (asc)",
"Last updated (desc)" => "Darrera actualització (desc)",
"Last updated (asc)" => "Darrera actualització (asc)",
"sort" => "ordenar",
"Added:" => "Afegit:",
"No records" => "No hi ha registres",
"Total directory categories" => "Total de categories del directori",
"Total links" => "Enllaços totals",
"Links to validate" => "Enllaços per validar",
"Searches performed" => "Cerca enllestida",
"Total links visited" => "Nombre d'enllaços visitats",
"Directory ranking" => "llista de Directoris",
"Validate sites" => "Valida llocs",
"country" => "país",
"Discounts" => "Descomptes",
// "{\$prefs.payment_currency|escape}" => "{\$prefs.payment_currency|escape}",
// " or " => " or ",
"Maximum time the discount can be used in the first phase of payment" => "Temps màxim el descompte pot ser utilitzat en la primera etapa dels pagaments",
"-1 for unlimited" => "-1 per ilimitat",
"Translation of this page is incomplete" => "La traducció d'aquesta pàgina està incompleta",
"To add <strong>new content</strong> to the page" => "Per afegir <strong> nou contingut </strong> a la pàgina",
"use the editor" => "utilitzar l'editor",
"Edit article" => "Editar article",
"View Articles" => "Visualitza articles",
"Allow full HTML" => "Permetre HTML complet",
"Keep any HTML tag" => "Mantingui qualsevol etiqueta HTML",
"If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "Si no està activat, Tiki retindrà algunes etiquetes HTML (a, p, pre, img, hr, b, i)",
// "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"{\$typei|escape}" => "{\$typei|escape}",
// "Click \"Preview\" after selecting article type to have appropriate edit form fields" => "Click \"Preview\" after selecting article type to have appropriate edit form fields",
// "Publication" => "Publication",
// "If checked, the article is published" => "If checked, the article is published",
"User (article owner)" => "Usuari (propietari de l'article)",
"Time" => "Temps",
"Own Image" => "Imatge pròpia",
"If not the topic image" => "No la imatge tòpic Si",
// "Max file size : {\$prefs.article_image_file_size_max/1000} KB" => "Max file size : {\$prefs.article_image_file_size_max/1000} KB",
"Current Image" => "Imatge actual",
"Article image" => "Imatge de l'article",
"Image caption" => "Requadre de la imatge",
// "Default will use the topic name" => "Default will use the topic name",
"Use own image" => "Empra imatge pròpia",
"Float text around image" => "text flotant al voltant de la imatge",
// "Read Article" => "Read Article",
// "Maximum dimensions of custom image in view mode" => "Maximum dimensions of custom image in view mode",
// "Maximum dimensions of custom image in list mode" => "Maximum dimensions of custom image in list mode",
"Attach existing article ID as translation" => "Adjuntar l'ID d'un article existent com a traducció d'aquest",
"Topline" => "Línia superior",
// "http://.." => "http://..",
// "Test your link: " => "Test your link: ",
"Apply content template" => "Aplica la plantilla de contingut",
// "{\$template.name|escape}" => "{\$template.name|escape}",
"Email addresses to be sent notifications (comma-separated)" => "Correus-e a rebre una notificació (separats per comes)",
"Cancel the edit (changes will be lost)." => "Cancel·la l'edició, perdràs els teus canvis.",
// "Create or edit banners" => "Create or edit banners",
"List banners" => "Llista butlletins",
"URL to link the banner" => "URL on enllaça el banner",
"Client" => "Client",
"Maximum impressions" => "Impressions màximes",
"Maximum number of impressions for a user" => "Maximum impressions d'un usuari",
"Maximum clicks" => "Clicks Màx",
"URIs where the banner appears only" => "URI on la bandera apareix només",
"Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Escriviu cada URI inclòs amb el caràcter #. Exemple: #/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear" => "URIs where the banner will not appear",
"Or, create a new zone" => "O bé, crear una nova zona",
// "New Zone" => "New Zone",
"Show the banner only between these dates" => "Mostrar el banner només en aquestes dates",
"From date" => "Des de la data",
"To date" => "Fins la data",
"Use dates" => "Utilitza dates",
// "Show the banner only in these hours" => "Show the banner only in these hours",
"Show the banner only on" => "Mostrar el banner sempre on",
"Select ONE method for the banner" => "Seleccioneu UN mètode per al banner",
"Use Image" => "Empra imatge",
// "Use Image from URL" => "Use Image from URL",
// "(the image will be requested at the URL for each impression)" => "(the image will be requested at the URL for each impression)",
"Use Flash" => "Empra Flash",
"Movie Size" => "Mida del vídeo",
// "width in pixels" => "width in pixels",
"Pixels" => "Píxels",
// "height in pixels" => "height in pixels",
"FlashPlugin min version" => "Versió min del connector FlashPlugin",
"ex" => "ex",
// "Use Text" => "Use Text",
"Save the Banner" => "Desar el banner",
"Remove zones (info entered for any banner in the zones will be lost)" => "Esborrar Zones (es perdrà l'informació entrada per el banner)",
"Edit Blog" => "Edita Bloc",
"A category is mandatory" => "Una categoria és obligatòria",
"Individual permissions are set for this blog" => "Existeixen permisos fixats individualment per a aquest bloc",
"Allow other users to post in this blog" => "Permet a altres usuaris de publicar en aquest bloc",
"Even if others post to the blog, the author is always its administrator" => "Si els altres publiquen al blog, l'autor ha de ser sempre amo",
"Allow search" => "Permetre cerca",
"Allow comments" => "Permetre comentaris",
"Use post excerpt" => "Utilitza missatge extracte",
"Display Options" => "Opcions de visualització",
// "Displayed posts" => "Displayed posts",
"Number of posts to show per page" => "Quantitat de missatges per mostrar per pàgina",
"Display the blog title on the posts list page" => "Mostrar títol del bloc en els llocs de pàgina de la llista",
"Display the blog title on the post page" => "Mostrar títol del bloc a la pàgina posterior",
"Display the blog description" => "Veure descripció del bloc",
"Display breadcrumbs" => "Mostrar rastre de molles de pa",
"Display the author in blog posts" => "Mostra autor en publicacions al bloc",
"Display the publish date in blog posts" => "Mostrar la data publicada al bloc",
"Show user profile picture" => "Mostra l'avatar de l'usuari",
"Show the post's related content" => "Mostra publicar contingut relacionat",
"The checkbox is disabled because the tags feature is disabled globally" => "La casella de verificació està desactivada perquè feature_freetags està deshabilitada globalment",
// "Related posts" => "Related posts",
"Maximum number of related posts to display" => "El nombre màxim de missatges relacionats per mostrar",
"Blog heading" => "Encapçalament",
"Heading preview" => "La partida de visualització prèvia",
"Blog post heading" => "Blog post partida",
"Organizer" => "Organitzador",
"Move objects between categories" => "Moure objectes entre categories",
"Click on the category name to display the list of objects in that category" => "Fes clic al nom de la categoria que desitja llistar. La llista d'objectes d'aquesta categoria es farà visible",
"Select the objects to affect. Controls will appear in the category browser" => "Seleccioneu els objectes que voleu modificar. Controls apareixeran a la categoria dels navegadors",
"Use the plus and minus signs to add or remove the categories on selected objects" => "Utilitza els signes més i menys per afegir o eliminar les categories d'objectes seleccionats",
// "Object list result" => "Object list result",
// "Select objects to change categorization" => "Select objects to change categorization",
"More results are available. Please refine the search criteria" => "Més resultats disponibles. Si us plau, refinar els criteris de cerca",
"Select all" => "Selecciona-ho tot",
"Unselect all" => "Deselecciona-ho tot",
"The file will be saved in" => "Es gravarà l'arxiu a",
// "Currently trying" => "Currently trying",
"Try" => "Prova",
// "Missing Package" => "Missing Package",
// "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package" => "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package",
// "Please contact the Administrator to install it" => "Please contact the Administrator to install it",
"Tiki Docs" => "Tiki Docs",
"Save file" => "Desa el fitxer",
"Cancel editing file" => "Cancel edició d'arxius",
"Editing file" => "Editant l'arxiu",
"Save and Back" => "Desa-ho i retorna",
"Rename" => "Reanomenar",
"Toggle Fullscreen" => "Commuta la Pantalla Completa",
"More information" => "Més informació",
"Wiki Page Editor" => "l'Editor de pàgines Wiki",
"More help on editing wiki pages" => "Més ajuda sobre l'edició de pàgines wiki",
"The syntax system used for creating pages in Tiki" => "El sistema de sintaxi per crear pàgines en Tiki",
"Bold text" => "Text en negreta",
"Italic text" => "Text en cursiva",
"single quotes" => "Apòstrofs",
"Underlined text" => "Text subratllat",
"Colored text" => "Text en colors",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "Es mostrarà amb el codi HTML o nom en anglès del color indicat. El color del nom en anglès pot contenir dos colors separats per una coma. En aquest cas, el primer color seria el color de la lletra i el segon el color del fons",
"Deleted text" => "Text esborrat",
"2 dashes" => "2 guions",
"Headings" => "Capçaleres (o Títols)",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostra/amaga la secció de la capçalera. + (mostrat) o - (amaga) per defecte",
"Autonumbered Headings" => "Estils de títol autonumerats",
"{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} imprimeixen una taula de continguts (índex) per a la página actual basant-se en les págines filles de la seva estructura (toc) o en els amb encapçalaments amb estils de títol amb ! (maketoc)",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Els paràmetres típics per a maketoc són: title|maxdepth|levels|nums, i per a toc són: order|showdesc|shownum|structId|maxdepth|pagename",
"Horizontal rule" => "Regla horitzontal",
"Text box" => "Requadre de text",
"Box content" => "Contingut de la caixa",
"Centered text" => "Text centrat",
"Inserts an editable variable" => "Inserta una variable editable",
"External links" => "Enllaços externs",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "empra claudators per a un enllaç extern: [URL], [URL|descripció_de_l_enllaç],[URL|descripció_de_l_enllaç|relació] o [URL|descripció_de_l_enllaç|relació|nocache] (aquest darrer evita que el Wiki local desi una còpia de la pàgina enllaçada a la memòria cau; es pot emprar la relació per insertar l'atribut rel per a l'enllaç - útil , p.e., per als efectes visuals amb la funcionalitat shadowbox).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Per a un Wiki extern, empri NomWikiExtern:NomPagina o ((Nom Wiki Extern: Nom Pagina))",
"Square Brackets" => "Corxets",
"Use [[foo] to show [foo]." => "Empra [[foo] per mostrar [foo].",
"JoinCapitalizedWords or use" => "AjuntarParaulesEnMajúscula o usar",
"page|description" => "pàg|desc",
"for wiki references" => "per referències del wiki",
"page|#anchor" => "pàgina|#àncora",
"page|#anchor|desc" => "pàgina|#àncora|descripció",
"for wiki heading/anchor references" => "per a referències a estils de títol wiki/àncora",
"SomeName" => "AlgunNom",
"prevents referencing" => "impedeix referenciar",
"Lists" => "Llistes",
"for bullet lists" => "per a llistes de punts",
"for numbered lists" => "per a llistes numerades",
"definition" => "definició",
"for definiton lists" => "per a llistes de definicions",
"Indentation" => "Sagnat",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Crea un sagnat de text per a cada més (útil en llistes per continuar amb la numeració més avall)",
"Tables" => "Taules",
"row" => "fila",
"col" => "col",
"Monospace font" => "Font monoespaiada",
"Code sample" => "Mostra de codi",
"(very useful especially in tables)" => "(molt útil especialment en les taules)",
"Multi-page pages" => "Pàgines múltiples",
"to separate pages" => "per separar pàgines",
"Non-parsed sections" => "Seccions no analitzades",
"data" => "dades",
"Prevents wiki parsing of the enclosed data." => "Evita interpretar el codi wiki de les dades incloses.",
"Preformated sections" => "Seccions preformatades",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "~pp~ data ~/pp~ Mostra text/codi preformatat; no es fa cap processat de sintaxi Wiki dins d'aquestes seccions (com amb np), i l'espaiat és fixe (no es fa cap plegament de línies llarges). ~pre~ data ~/pre~ també mostra text preformatat amb espaiat fix, però es si que es processa la sintaxi wiki en el text..",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Comentari Tiki ~/tc~ fa un comentari a Tiki.  Serà eliminat completament del text mostrat, però es desarà en l'arxiu per a referències futures i és visible pels editors de les pàgines.  ~hc~ Comentari HTML ~/hc~ fa un comentari HTML.  Serà  insertat com a comentari en l'HTML produït; aquests no es mostraran en navegadors web, però poden ser vistos en mostrar el codi font de la pàgina del navegador o formes similar.",
"Block Preformatting" => "Preformatat de Block",
"Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Sagna (inserta espais al principi per alinear el paràgraf més a la dreta) el text amb qualsevol nombre d'espais per convertir-lo en un bloc monoespaiat que encara segŭeix altres instruccions de format Wiki. Serà sagnat amb el mateix nombre d'espais que has emprat. Nota que d'aquesta forma no es preseva ni l'espaiat exacte ni els salts de línia; empra ~pp~...~/pp~ per això.",
"Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew" => "Inseriu resp. text de dreta a esquerra i d'esquerra a dreta direcció DIV (fins al final del text) i marcadors per Langages com àrab o hebreu",
"Special characters" => "Caràcters especials",
"hard space" => "espai rigid (no permet que es trenqui la línia)",
"numeric between ~ for HTML numeric characters entity" => "numeric entre ~ per a entitats html de caràcters numèrics",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Fixa't que els arguments dels connectors (plugins) es poden envoltar de cometes dobles (&quot;); això permet que continguin , o = o &gt;",
"More help here" => "Més ajuda, aquí",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Els connectors (plugins) del Wiki estenen la funació de la sintaxi wiki amb instruccions més especialitzades",
"Activate/deactivate plugins" => "Activa/desactiva Connectors (plugins)",
"No description available" => "No hi ha disponible cap descripció",
"For more information, please see" => "Per a més informació, si us plau consulta",
"WYSIWYG Editor" => "Editor Visual (Wysiwyg)",
"More help on WYSIWYG editing" => "Més ajuda sobre l'edició visual amb wysiwyg",
// "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>" => "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar",
"<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong> N.B. </Strong> Amb aquest botó converteixes la font de la pàgina de sintaxi wiki a HTML, o viceversa.\n\tEl Procés de conversió no és totalment transparent, el que significa que pots notar diferències entre l'aspecte d'una pàgina en els diferents modes.\n\tAixò millorarà en futures actualitzacions, però com els dos sistemes presenten diferències significatives en el que poden fer, és poc probable que alguna vegada la conversió sigui totalment transparent",
"<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong> N.B. </Strong> L'ús d'aquest botó canvia entre l'editor WYSIWYG i l'editor wiki habitual, però deixa la font de la pàgina en la sintaxi wiki",
"Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Plugins Wiki es poden utilitzar i editar en mode WYSIWYG, feu doble clic en el connector perquè aparegui el plugin d'editar forma emergent. <br>\n\\ Hi ha un exemple del connector {ldelim}BOX{rdelim}",
// "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered" => "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered",
// "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around" => "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around",
// "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "Explora Imatges",
"Edit successful!" => "Edició feta amb èxit!",
"The following image was successfully edited" => "La imatge següent ha estat editada amb èxit",
"Image Description" => "Descripció de la imatge",
"Upload from disk to change the image:" => "Puja des del disc per canviar la imatge:",
"Save and Go Next" => "Desa i ves al següent",
"Edit Invoice" => "Edita Factura",
"Invoice Number" => "Número de factura",
"Date Issued" => "Data d'emissió",
"Work Description" => "Descripció del treball",
"Taxable" => "Imposable",
"New Item" => "Nou element",
"Invoice Note" => "Factura Nota",
"Save Invoice" => "Desa Factura",
"Customized String Translation" => "Traducció de cadenes de text a mida",
// "Manage local translations in a custom.php file" => "Manage local translations in a custom.php file",
// "Download language.php file for the selected language" => "Download language.php file for the selected language",
// "Download Database Translations" => "Download Database Translations",
// "Download a file with all the translations in the database for the selected language" => "Download a file with all the translations in the database for the selected language",
// "Translations in the database will be merged with the other translations in language.php for the selected language" => "Translations in the database will be merged with the other translations in language.php for the selected language",
"Add a translation" => "Afegeix una traducció",
"Untranslated strings" => "Cadenes de text no traduïdes",
"Show only database stored untranslated strings" => "Mostra només la base de dades emmagatzemades cadenes sense traduir",
"Edit translations" => "Edita traduccions",
"Show only database stored translations" => "Mostra únicament traduccions guardades a la base de dades",
// "Original string" => "Original string",
"Last changed by %0 on %1" => "Darrera modificació de %0 a %1",
// "Contribute" => "Contribute",
"Undecided" => "Indecís",
// "Save translation in the database" => "Save translation in the database",
// "Delete translation from the database" => "Delete translation from the database",
"Compare" => "Comparar",
// "Compare the original translation with the database translation" => "Compare the original translation with the database translation",
// "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes" => "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes",
"Translate all" => "Tradueix tot",
"Delete all" => "Net.",
"Are you sure you want to delete all untranslated strings from database" => "Estàs segur que vols eliminar totes les cadenes sense traduir de la base de dades",
"Are you sure you want to delete all translations from database" => "Estàs segur que vols eliminar totes les traduccions de la base de dades",
"Return to the default perspective" => "Tornar a la perspectiva defecte",
"Switch to" => "Canvieu a",
// "Preference List" => "Preference List",
// "Search preferences below and drag them into the preference list above" => "Search preferences below and drag them into the preference list above",
"Program dynamic content for block" => "Programar el contingut dinàmic per al bloc",
"Create New Block" => "Crear un nou bloc",
"Return to block listing" => "Torna a la llista de blocs",
"Block description: " => "Descripció del bloc",
"You are editing block:" => "Estàs editant el bloc:",
// "Publising Date" => "Publising Date",
"Publishing Date" => "Data de Publicació",
"Edit question options" => "edita opcions de pregunta",
"List Quizzes" => "Fes llista dels qüestionaris",
"Quiz Stats" => "Estadístiques de Tests",
"This Quiz Stats" => "Estadistiques d'aquest test",
"Edit this Quiz" => "Edita aquest test",
"Admin Quizzes" => "Administrar qüestionaris",
"Create/edit options for question" => "Crear/edita opcions per a una pregunta",
"points" => "punts",
"Quiz can be repeated" => "El test pot repetir-se",
// "Time Limit" => "Time Limit",
"Create/edit quizzes" => "Crea/edita qüestionaris",
"There are individual permissions set for this quiz" => "Hi ha permisos individuals per a aquest Test",
"Store quiz results" => "Desar resultats d'aquest test",
"Quiz is time-limited" => "El test té un temps limitat",
"Maximum time" => "Temps màxim",
"Passing Percentage" => "Percentatge d'aprovació'",
"%" => "%",
"Edit quiz questions" => "edita preguntes del test",
"Create/edit questions for quiz" => "Crear/edita preguntes per a test",
"Question Type" => "Tipus de pregunta",
"Import questions from text" => "Importa preguntes des de text",
// "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct" => "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct",
"Input" => "Entrada",
"Maximum score" => "maxResultat",
"Edit quiz results" => "Edita resultats de proves",
"From Points" => "Des de punts",
"To Points" => "Fins a punts",
"Reports" => "Informes",
"Report Builder" => "Generador d'informes",
"Report Type" => "Tipus d'informe",
"Select Report Type" => "Seleccionar tipus d'informe",
"Wiki Data" => "Wiki Data",
"Export As CSV" => "Exportar com CSV",
"You will remove" => "Eliminaràs",
"and its subpages from the structure, now you have two options:" => "i amb les seves subpàgines de l'estructura, ara tens dues opcions:",
"and its subpages from the structure" => "i les seves subpàgines de l'estructura",
// "Remove from structure" => "Remove from structure",
"Remove from structure and remove page too" => "Elimina de l'estructura i elimina també les pàgines",
"The page already exists. The page that has been added to the structure is the existing one." => "La pàgina ja existeix. La pàgina que s'ha afegit a l'estructura és l'existent.",
"The following pages added have automatically been categorized with the same categories as the structure:" => "Les pàgines següents afegides han estat automàticament categoritzades amb les mateixes categories que l'estructura:",
"Structure Layout" => "Disseny de l'estructura",
// "Monitor the structure" => "Monitor the structure",
// "Stop Monitoring the structure" => "Stop Monitoring the structure",
"Add pages" => "Afegeix pàgines",
"Use an existing page by dragging it into the structure above" => "Empra la pàgina pre-existent a través de deixar-ho caure a l'estructura de sobre",
"{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "Categoritza totes les pàgines de l'estructura juntes",
"Remove existing categories from ALL pages before recategorizing" => "Elimina les categories existents de TOTES les pàgines abans de recategoritzar",
"Move to another structure" => "Mou a una altra estructura",
"at the beginning" => "al principi",
"at the end" => "al final",
"Submit article" => "Enviar col·laboracions",
"List submissions" => "Llista d'enviaments",
"Use ...page... to separate pages in a multi-page post" => "Empra ...page... per separar pàgines en una publicació multi-pàgina",
// "Fields with <b>*</b> are optional" => "Fields with <b>*</b> are optional",
"<b>Topline</b>=small line above Title" => "<b>Línia superior</b>=línia petita sobre el Títol",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítol</b>=linia petita sota el Títol",
"<b>Source</b>=URL to article source" => "<b>Font</b>=URL a la font de l'article",
"Author Name" => "Nom de l'autor",
"Own image size x" => "Dimensió x d'imatge pròpia",
"Own image size y" => "Dimensió y d'imatge pròpia",
"Auto-Approve Article" => "Autoaprova l'Article",
"View template" => "Visualitza plantilla",
"Template listing" => "Llistat de plantilles",
"Available templates" => "Plantilles Permesses",
"Important" => "Important",
// "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme:" => "Desa només en el Tema:",
"Delete the copy in the theme:" => "Esborra la còpia en el tema:",
"Admin Article Topics" => "Admin Temes d'Articles",
// "Edit article topic" => "Edit article topic",
"Admin notifications" => "Administra les notificacions",
// "Enter email addresses " => "Enter email addresses ",
"Translate:" => "Tradueix:",
"View Article" => "Visualitza Article",
"Attach or detach existing translations of this page" => "Adjunta o desadjunta traduccions existents d'aquesta pàgina",
// "Manage Translations" => "Manage Translations",
"You must specify the object language" => "Has d'especificar l'idioma de l'objecte",
"The object doesn't exist" => "L'objecte no existeix",
"The object doesn't have a language" => "L'objecte no té un idioma",
"The object already has a translation for this language" => "L'objecte ja té una traducció per a aquest idioma",
"The object is already in the set of translations" => "L'objecte ja hi és en el conjunt de la traducció",
"Translate this page to a new language" => "Tradueix aquesta pàgina a un nou idioma",
"Select language to translate to" => "Selecciona l'idioma al qual traduir-la",
"Enter the page title" => "Introdueix el títol de la pàgina",
// "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
"Create translation" => "Crea la traducció",
"Change language for this page" => "Canvia l'idioma per a aquesta pàgina",
"Change Language" => "Change Language",
// "You forgot to specify the language of the translation. Please choose a language in the picklist" => "You forgot to specify the language of the translation. Please choose a language in the picklist",
"The page already exists. It was selected in the list below." => "\"La pàgina ja existeix. Va ser seleccionada a la llista de sota.\"",
"No language is assigned to this page." => "No hi ha cap idioma assignat a aquesta pàgina.",
"Please select a language before translating." => "Si us plau, selecciona un idioma abans de fer la traducció.",
// "Set Page Language" => "Set Page Language",
"Edit Section:" => "Edita la secció",
// "Edit %0" => "Edit %0",
"Update '{\$page}'" => "Actualitza '{\$page}'",
"{\$customTip|escape}" => "{\$customTip|escape}",
// "Preview your changes" => "Preview your changes",
"Draft written on" => "Esborrany desat el",
"Warning: new versions of this page have been made after this draft" => "Avís: s'han fet noves versions d'aquesta pàgina després d'aquest esborrany",
"The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page." => "El LlocdeProves (SandBox) és una pàgina on pots practicar les teves habilitats d'edició, emprar la opció de previsualització per previsualitzar l'aspecte de la pàgina, i no es guarda cap versió per a aquesta pàgina.",
// "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)" => "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)",
"An edit summary is mandatory" => "És obligatori posar un resum d'edició",
"Translate from" => "Tradueix des de",
"Changes that need to be translated are highlighted below" => "Els canvis que cal traduir es mostren destacats a sota",
"No comment" => "Cap comentari",
"All Versions" => "totes les versions",
"Edit wiki page" => "Edita la pàgina wiki",
"Select the style used to display differences to be translated" => "Selecciona l'estil emprat per mostrar diferències que cal traduir",
"text full" => "text sencer",
"Change the style used to display differences to be translated" => "Canvia l'estil emprat per mostrar les diferències que s'han de traduir",
"Change diff styles" => "Canvia l'estil de diff",
"Translate to" => "Tradueix a",
"Reproduce the changes highlighted on the left using the editor below" => "Reprodueix els canvis destacats a l'esquerra emprant l'editor de sota",
"Describe the change you made" => "Descriure el canvi realitzat",
"Edit comment: Enter some text to describe the changes you are currently making" => "Edita el comentari: Introdueix una mica de text per descriure els canvis que estàs fent actualment",
"Monitor this page" => "Segueix aquesta pàgina",
"Upload picture" => "Puja foto",
"Add another image" => "Afegeix una altra imatge",
"Categorization has been preset for this edit" => "La categorització ha estat ja pre-seleccionada per a aquesta edició",
"Categories will be inherited from the structure top page" => "S'heredaran les categories de la pàgina inicial de l'estructura",
// "Leave page and go to..." => "Leave page and go to...",
// "Wiki Preferences" => "Wiki Preferences",
// "Copyright notices" => "Copyright notices",
// "Copyright page" => "Copyright page",
"{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Lock this page" => "Bloqueja aquesta pàgina",
"Allow comments on this page" => "Permet comentaris a aquesta pàgina",
// "HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "HTML tags are used to create elements of the wiki page, instead of being displayed as code",
"Try to convert HTML to wiki" => "Prova de convertir HTML a wiki",
"Import page" => "Pàgina d'importació",
// "Export page" => "Export page",
// "Export all versions" => "Export all versions",
// "Attach file" => "Attach file",
"Only cache a page if it should look the same to all groups authorized to see it" => "Només escorcollar una pàgina si és que ha de ser el mateix per a tots els grups autoritzats per a veure",
"{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
"Site default" => "El que hi ha per defecte a aquest lloc",
// "as Creator &amp; Last Editor" => "as Creator &amp; Last Editor",
// "no (disabled)" => "no (disabled)",
"Description (used for metatags)" => "Descripció (utilitzat per metatags)",
"My Footnotes" => "Les meves notes al peu de pàgina",
"{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "No hi ha cap plantilla de sondeig disponible.",
"Please ask an administrator to create one." => "Haurieu de preguntar a l'administrador per crear-ho.",
// "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Petició de traducció",
"Send urgent translation request." => "Envia una petició de traducció urgent.",
// "Geolocation" => "Geolocation",
"Show page title" => "Mostra el títol de la pàgina",
"Explicit Namespace" => "Espai de noms explícita",
"The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace" => "L'espai de noms d'una pàgina s'endevina automàticament a partir del nom de la pàgina. No obstant això, poden sorgir algunes excepcions. Aquesta opció permet anul·lar l'espai de noms",
// "Page layout" => "Page layout",
// "Site Default" => "Site Default",
"{\$title}" => "{\$title}",
"List Sheets" => "Llista fulls",
"Graph" => "Grafica",
"Export to file" => "Exporta a presentar",
"Charset encoding:" => "Codificació de caràcters:",
"Autodetect" => "Autodetecta",
"Admin FAQ" => "Administració de PMF",
"List FAQs" => "Fer llista de PUFs",
"View FAQ" => "Veure PUF",
"Edit this FAQ" => "Edita aquesta PUF",
"New Question" => "Pregunta nova",
"Edit FAQ question" => "Edita FAQ pregunta",
"Add FAQ question" => "Afegir FAQ pregunta",
"Use a question from another FAQ" => "Empra pregunta d'una altra PUF",
"FAQ questions" => "Preguntes d'Ús Freqüent (PUFs)",
"Suggested questions" => "Preguntes suggerides",
"No suggested questions" => "No hi ha cap suggeriment",
"File Archive" => "Arxiva el fitxer",
"Size (width x height)" => "Mida (amplada x alçada)",
"Content waiting for approval" => "Contingut en espera d'aprovació",
"You are currently viewing the latest version of the page" => "Estàs veient actualment l'última versió de la pàgina",
"You can also view the {self_link}latest approved version{/self_link}" => "També pot veure el {self_link}darrera versió aprovada{/self_link}",
"You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "Pots aprovar aquesta revisió i posar-lo a disposició d'un públic més ampli. Assegureu-vos de revisar tots els canvis abans d'aprovar",
"Show changes since last approved revision" => "Mostra els canvis des de l'última revisió aprovada",
"This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "Aquesta pàgina no té revisió aprovada abans. <strong> Tot el contingut ha de ser revisat. </strong>",
"Approve current revision" => "Aprovar la revisió actual",
// "Reject current revision" => "Reject current revision",
"You are currently viewing the approved version of the page" => "Estàs veient la versió aprovada de la pàgina",
"You can also view the {self_link latest=1}latest version{/self_link}" => "També pot veure el  {self_link latest=1}última versió{/self_link}",
"View the {self_link latest=1}latest version{/self_link}" => "Veure el {self_link latest=1}última versió{/self_link}",
"Forum Importer" => "Importador de Fòrums",
"Import from a Local SQL File" => "Importa a partir d'arxiu SQL Local",
"Forum Type" => "Tipus de Fòrum",
"DB Prefix" => "Prefix de DB",
"Local SQL Filename on Server (path will be stripped)" => "Arxiu SQL local al servidor (la ruta serà estripada)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Ha d'estar a tikiroot/{\$tmpdir} o a tikiroot/img/wiki_up",
"Get Forum List" => "Obtenir llista Fòrum",
"Verification" => "Verificació",
"File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "L'arxiu ha de ser un arxiu de SQL i existir en <i>\$tikiroot/temp</i> ó <i>\$tikiroot/img/wiki_up</i>",
"File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "No s'ha especificat l'arxiu, o no va ser possible trobar-lo en cap dels dos llocs.  Si us plau, posar l'arxiu en algun dels dos directoris i torna Enrere. Si l'arxiu hi és en ambdos llocs, el lloc \$tikiroot/{\$filecheck} serà escollit preferentment.",
"Proceed" => "Procedir",
"Go Back" => "Torna enrere",
"Select a Forum You Wish to Move (ONE at a time!)" => "Selecciona un Fòrum que vulguis moure (UN cada cop!)",
"Which Forum Do You Wish to Import this Into?" => "A quin fòrum vols importar això?",
// "Refresh list" => "Refresh list",
"Edit queued message" => "edita missatge en cua",
// "Make this a thread of" => "Make this a thread of",
"None, this is a thread message" => "Cap, aquest és un missatge fil",
"summary" => "resum",
"Announce" => "Anunci",
"Hot" => "Calent",
"no feeling" => "sense sentiment",
"frown" => "front",
"exclaim" => "Exclamació",
"idea" => "idea",
"mad" => "boig",
"neutral" => "neutral",
"question" => "pregunta",
"sad" => "trist",
"happy" => "feliç",
"wink" => "parpadejar",
"Save and Approve" => "Desa i aprova",
// "Convert to topic" => "Convert to topic",
"New Topic" => "Nou tema",
"no summary" => "sense resum",
"No messages queued yet" => "Encara no hi ha missatges a la cua",
"Search by name" => "Cerca per nom de fòrum",
"Search in content" => "Cerca al contingut dels fòrums",
"Last Post" => "Darrer missatge",
// "{\$section|escape}" => "{\$section|escape}",
// "No forums found" => "No forums found",
// "Loading" => "Loading",
"Reported by" => "Reportat per",
"Perfom action with checked" => "Realitza l'acció amb els items seleccionats",
"Un-report" => "Un-informe",
"Tag translation" => "Etiqueta traducció",
// "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated" => "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated",
// "Show checkboxes" => "Show checkboxes",
"There are no tags on this page in your preferred languages" => "No hi ha etiquetes en aquesta pàgina per als teus idiomes preferits",
"Set language" => "Especifica idioma",
"Universal" => "Universal",
// "Displayed languages" => "Displayed languages",
"Friendship Network" => "Xarxa d'amistats",
"Galleries" => "Galeries",
"Create New Gallery" => "Crear una nova galeria",
// "Migrate Images to File Gallery" => "Migrate Images to File Gallery",
"Create a gallery" => "Crear una galeria",
"Edit this gallery:" => "edita aquesta galeria:",
"There are individual permissions set for this gallery" => "Existeixen permisos fixats individualment per a aquesta galeria",
"Gallery is visible to non-admin users?" => "Galeria visible per usuaris no autoritzats",
"Max Rows per page" => "Files màx. per pàgina",
"Thumbnails size X" => "Mida x per a miniatures",
"Thumbnails size Y" => "Mida Y per a miniatures",
"Fields to show during browsing the gallery" => "Camps que es mostren quan es navega per la galeria",
"XY-Size" => "mida-XY",
"Gallery Image" => "Imatge de la galeria",
"Available scales" => "Permesses escales",
"Global default" => "Per defecte Global",
"Bounding box" => "Requadre delimitador",
"default scale" => "escala per defecte",
// "Default scale" => "Default scale",
"No scales available" => "No hi ha cap escala disponible",
"Original image is default scale" => "La imatge original és a l'escala per defecte",
"Add scaled images with bounding box of square size" => "Afegeix imatges escalades amb requadre delimitador quadrat",
"Other users can upload images to this gallery" => "Permetre a altres usuaris afegir imatges en aquesta galeria",
"You can access the gallery using the following URL" => "Pots accedir a la galeria emprant la URL",
"Available Galleries" => "Galeries disponibles",
"Choose a filter" => "Escull un filtre",
"Imgs" => "Imtgs",
// "Make map" => "Make map",
"Select Graphic Type" => "Selecciona Tipus de Gràfic",
"Pie Chart" => "Gràfic de Pastís",
"Multiline" => "Multilínia",
"Multibar" => "Multibarra",
"Bar Stack" => "Barres apilades",
"Independant Scale" => "Escala independent",
"Horizontal Scale" => "Escala horitzontal",
"Vertical Scale" => "Escala vertical",
"Series" => "Sèries",
"Edit Spreadsheet" => "Edita full de càlcul",
"List Spreadsheets" => "Llista de fulls de càlcul",
"Wiki plug-in" => "Connector Wiki (plug-in)",
"Spreadsheet History" => "Història de full de càlcul",
"Roll back" => "Roll back",
"Toggle Full Screen" => "Commuta la Pantalla Completa",
"Date Selection" => "Selecció de dates",
"Edit Date" => "Edita la Data",
"View Spreadsheet" => "Veure full de càlcul",
"Clone Spreadsheet" => "Clona el Full de càlcul",
"Roll back spreadsheet" => "Fer retrocedir el càlcul",
"Import From File" => "Importa des d'un arxiu",
// "File to import" => "File to import",
"Grab Wiki Tables" => "Agafa les Taules Wiki",
"Import pages from a Structured Text Dump" => "Importa pàgines d'una descarrega de text estructurada",
"Name of the dump file (it has to be in dump/)" => "Nom de l'arxiu de descàrrega (ha d'estar a dump/)",
"Overwrite existing pages if the name is the same" => "Sobreescriu pàgines existents si el nom és el mateix",
// "Remove previously existing page versions" => "Remove previously existing page versions",
"excerpt" => "extracte",
"Result" => "Resultat",
"body" => "cos",
"Name of the zip file on the server" => "Nom del fitxer zip al servidor",
"Tiki Importer" => "Tiki Importador",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "Si NO disposa d'una nova instal·lació de Tiki, feu una còpia de seguretat de la base de dades abans d'utilitzar aquest importador",
"If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "Si les pàgines contenen codi XML, l'HTML purificador eliminar-lo. Desactivar aquesta funció",
"Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "El teu PHP està corrent amb habilitat el mode segur. Això podria causar problemes en el procés d'importació com safe mode limita a la possibilitat de canviar en temps d'execució de les configuracions de PHP (com max_execution_time). Es recomana executar aquest script sense mode segur",
"Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depenent de la mida de l'arxiu original de programari, el procés d'importació pot trigar una mica a completar-se. Això podria ser un problema segons el teu PHP i el servidor web. Aquest script intenta canviar la configuració pertinent, però hi ha opcions que no es poden canviar des d'aquí. Per tant, si estàs tenint problemes amb la web, si us plau tracta d'augmentar el valor de les següents configuracions de PHP: max_input_time, max_execution_time (aquesta opció està limitada per la configuració del servidor web, si estàs executant Apache també canvia la configuració del temps d'espera), post_max_size , upload_max_filesize, memory_limit. Es recomana executar aquesta seqüència de comandaments al servidor on es poden canviar els valors dels paràmetres (si cal)",
"Select the software to import from" => "Seleccioneu el programari que voleu importar",
"Select.." => "Selecciona ..",
"WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "ADVERTÈNCIA: assegura't de tenir una còpia de seguretat abans d'executar l'script. Si no tens una còpia de seguretat, aquesta és l'última oportunitat per cancel·lar l'importador fent clic al botó Cancel·la",
"Congratulations! You have successful imported your data to Tiki" => "Enhorabona! Has importat amb èxit les dades a Tiki",
"%0 pages imported from a total of %1" => "%0 pàgines importades d'un total de %1",
"%0 pages imported" => "%0 pàgines importades",
"(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(pots veure la lista de pàgines wiki en el teu lloc web <a href=\"tiki-listpages.php\">aquí</a>)",
"%0 posts imported" => "%0 entrades importades",
"%0 tags imported" => "%0 marques lliures importades",
"%0 categories imported" => "%0 categories importades",
"Importer log" => "Registre d'Importador",
"Suggested .htaccess rules" => "Suggerides Regles .htaccess",
"Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Installation" => "Instal·lació",
"Tiki Icon" => "Icona de Tiki",
"Tiki Project Web Site" => "Lloc Web del Projecte Tiki",
"Support Forums" => "Fòrums de Suport",
"Welcome" => "Benvinguts",
// "Welcome to the <strong>Tiki %0</strong> installer" => "Welcome to the <strong>Tiki %0</strong> installer",
// "Use this script to install a new database or upgrade your existing database" => "Use this script to install a new database or upgrade your existing database",
"For the latest information about this release, please read the" => "Per a la darrera informació sobre aquest alliberament, si us plau, llegeix les",
"Release Notes" => "Notes d'alliberament",
"For complete documentation, please visit" => "Per a la documentació completa, si us plau visita",
"For more information about Tiki, please visit" => "Per més informació sobre Tiki, si us plau visita",
"Select your language" => "Selecciona el teu idioma",
// "License" => "License",
"Tiki is software distributed under the LGPL license" => "Tiki és programari distribuït sota la llicència LGPL",
"Review the System Requirements" => "Revisa els requeriments del Sistema",
"Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Abans d'instal·lar Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">revisa la documentación</a> i confirma que el teu sistema té els requeriments mínims",
"This installer will perform some basic checks automatically" => "Aquest instal·lador realitzarà algunes comprovacions bàsiques automàticament",
"Please see: " => "Si us plau, consulti: ",
"a detailed report about your server" => "un informe detallat sobre el servidor",
"Memory" => "Memòria",
"Tiki has not detected your PHP memory_limit" => "Tiki no ha detectat el teu  memory_limit de PHP",
"This probably means you have no set limit (all is well)" => "Això probablement vol dir que no tens límit específicat (tot està bé)",
"Tiki has detected your PHP memory limit at" => "Tiki ha detectat que tens el limit de memòria de PHP a",
"Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requereix <strong> almenys </strong> 128 MB de memòria de PHP per a l'execució de l'escriptura",
"Allocating too little memory will cause Tiki to display blank pages" => "Permetre massa poca memòria provocarà que Tiki mostri pàgines en blanc en algunes funcionalitats",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "Per canviar el límit de memòria, utilitzeu la clau <strong>memory_limit</strong> en el seu arxiu <strong>php.ini</strong> (per exemple: memory_limit = 128M) i reinicieu el servidor web",
"Tiki has detected your PHP memory_limit at" => "Tiki ha detectat el paràmetre de PHP memory_limit del teu servidor web en",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki empra la funció PHP <strong>mail</strong> per enviar notificacions per correu-e i missatges",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Per tal de provar la configuració del teu sistema, Tiki provarà d'enviar-te un missatge de correu-e de prova",
"Test email" => "Test email",
// "tiki@example.com" => "tiki@example.com",
"Email address to send test to" => "Adreça de correu-e a on enviar el correu-e de prova",
"Copy test mail to " => "Copia el correu-e de prova a ",
"Send Test Message" => "Envia missatge de prova",
"Tiki was able to send a test message to" => "Tiki ha pogut enviar el missatge de prova a ",
"Tiki was not able to send a test message" => "Tiki no ha pogut enviar cap missatge de prova",
"Review your mail log for details" => "Revisa el registre del correu-e del servidor per més detalls",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Revisa els paràmetres del correu en l'arxiu <strong>php.ini</strong> del teu sistema (per exemple: confirma que la ruta <strong>sendmail_path</strong> és correcta)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si el teu hoste requereix autenticació SMTP, pot ser necessària una mica més de configuració addicional",
"Image Processing" => "Processat d'imatges",
"Tiki detected" => "Tiki ha detectat",
"Tiki can create images" => "Tiki pot crear imatges",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki no ha pogut crear una imatge de prova. Si us plau, comprova la configuració de la llibreria GD",
"Tiki was not able to detect the GD library" => "Tiki no ha pogut detectar la llibreria GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki empra la llibreria GD per processar imatges a les galeries d'imatges i per al suport al CAPTCHA (imatges de verificació anti-robots)",
"Set the Database Connection" => "Especifica la connexió a la base de dades",
"Tiki requires an active database connection" => "Tiki requireix una connexió activa a base de dades",
"You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them" => "Has de crear la base de dades i usuari  <strong>abans</strong> de completar aquesta pàgina, a menys que el teu usuari de la base de dades tingui permisos per crear noves bases de dades i no només emprar-les",
"Tiki cannot find a database connection" => "Tiki no pot trobar cap connexió amb la base de dades",
"This is normal for a new installation" => "Això és normal per a una instal·lació nova",
"Tiki found an existing database connection in your local.php file" => "Tiki ha trobat que ja existeix una connexió a base dades en el teu arxiu local.php",
"Database name: %0" => "Nom de la base de dades: %0",
"Tiki found an automatic database connection for your environment" => "Tiki ha trobat una connexió automàtica a una base de dades per al teu entorn",
"Use Existing Connection" => "Empra la connexió existent",
"Modify database connection" => "Modifca la connexió a la base de dades",
"Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Empra aquesta pàgina per crear una nova connexió a base de dades, o empra el <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">procés d'instal.lació manual</a>",
"Database information" => "Informació de la Base de dades",
"Enter your database connection information" => "Introdueix la informació de la teva connexió a base de dades",
// "DBMS driver" => "DBMS driver",
// "Select the database driver to use with Tiki" => "Select the database driver to use with Tiki",
// "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension" => "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension",
"Host name" => "Nom de l'hoste",
"Enter the host name or IP for your database" => "Introdueix el nom de l'hoste o IP per a la teva base de dades",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Empra <strong>localhost</strong> si la base de dades s'està executant a la mateixa màquina que el Tiki",
"For non-default port number use <strong>example.com;port=3307</strong>" => "Pels no-defecte del nombre de port utilització <strong> example.com; port = 3307 </strong>",
"Database name" => "Nom de la Base de dades",
// "Name of the database to be used. This database will be created if it does not exist and permissions allow creation" => "Name of the database to be used. This database will be created if it does not exist and permissions allow creation",
// "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created" => "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created",
"If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "Si utilitzeu una base de dades que ja està sent utilitzat per una altra cosa (no recomanat), xec db / tiki.sql per assegurar-se que els noms de les taules utilitzades per Tiki ja no s'utilitzen",
"Database user" => "Usuari de la Base de dades",
// "Enter a database user with administrator permission for the Tiki database" => "Enter a database user with administrator permission for the Tiki database",
"User name:" => "Nom d'usuari:",
"Database username" => "Usuari de la base de dades",
// "Create the above database user just for this Tiki database" => "Create the above database user just for this Tiki database",
"Administrative database user" => "Usuari administratiu de bases de dades",
"Enter database administrator user name and password" => "Introdueix el nom d'usuari administrador de la base de dades i la seva contrasenya",
// "This is a DB admin user which has permission to create new databases and new users" => "This is a DB admin user which has permission to create new databases and new users",
"DB admin user name" => "Nom d'usuari administrador de la BD",
"DB admin password" => "Contrasenya de l'administrador de la BD",
"Character set" => "Conjunt de caràcters",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Altament recomanat per a instal·lacions noves. De totes formes, si estàs actualitzant o migrant una base de dades prèvia de Tiki, es recomana que treguis la selecció d'aquesta casella de sota",
"Always force connection to use UTF-8" => "Força sempre a que s'utilitzi el conjunt de caràcters UTF-8 per a la connexió a la base de dades",
"Install & Upgrade" => "Instal·lació & Actualització",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "No s'ha pogut esecificar el paràmetre max_execution_time per a PHP. És possible que hi et trobis amb problemes quan creis o actualitzis la base de dades emprant aquest instal·lador en un sistema lent. Això es manifestar a través d'una pàgina en blanc",
"This install will populate (or upgrade) the database" => "Aquesta instal·lació omplirà (o actualitzarà) la base de dades",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>" => "Si vols actualitzar des d'una versió anterior de Tiki, assegura't d'haver llegit i entès les <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">instruccions d'Actualització</a>",
"A new install will populate the database" => "S'omplirà la base de dades amb una instal·lació nova",
"Encoding Issue" => "Qüestió de la codificació",
// "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>",
"Character Set Conversion" => "Conjunt de caràcters",
"Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Empra sota el teu propi risc. Si les dades a la base de dades contenen actualment dades convertides inadequadament, aquest procés pot fer que les coses empitjorin. Aquest procés és adequat per a instal·lacions noves. Requereix el privilegi ALTER sobre la base de dades",
"Convert database and tables to UTF-8" => "Converteix la base de dades i taules a UTF-8",
// "This will destroy your current database: %0" => "This will destroy your current database: %0",
"Reinstall the database" => "Reinstal·la la base de dades",
"Select database engine" => "Selecciona el motor de base de dades",
"MyISAM" => "MyISAM",
"InnoDB" => "InnoDB",
"Reinstall" => "Reinstal·la-ho",
"Upgrade" => "Actualització",
"Warning: Category Permissions Will Not Be Upgraded" => "Avís: Els permisos de categories no seran actualitzats automàticament",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Els permisos de categories han estat modificats substancialment des de la versió 3. Si has estat emprant permisos de categories, tingues en compte que és possible que no funcionin adequadament després d'actualitzar a Tiki 4 o versions posteriors, i serà necessari que els reconfiguris manualment",
"Automatically upgrade your existing database to version" => "Actualitza automàticament la teva base de dades existent a la versió",
"This site has an admin account configured" => "Aquest lloc té un compte d'administrador configurat",
"Please log in with your admin password to continue" => "Si us plau, connecta't amb la teva contrasenya de persona administradora (admin) per tal de continuar",
"Review the Upgrade" => "Revisa l'Actualització",
"Review the Installation" => "Revisa la Instal·lació",
"Upgrade complete" => "Actualització completa",
"Installation complete" => "Instal·lació completa",
"Your database has been configured and Tiki is ready to run" => "La teva base de dades ha estat configurada i Tiki està llest per funcionar",
"If this is your first install, your admin password is <strong>admin</strong>." => "Si és la teva primera instal·lació, la teva contrasenya d'administrador <strong>admin</strong>.",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Ara pots connectar-te al teu Tiki com a usuari <strong>admin</strong> i començar a configurar l'aplicació",
"Upgrade operations executed successfully" => "Operacions d'actualització executades amb èxit",
"Installation operations executed successfully" => "Operacions d'instal·lació executades amb èxit",
"SQL queries" => "Consultes SQL",
"Database was left unchanged" => "S'ha deixat la base de dades sense canvis",
"Operations failed" => "Operacions que no han tingut èxit",
"Display details" => "Mostra detalls",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages." => "Durant una actualització, és normal tenir missatges d'error SQL de l'estil <strong>La taula ja existeix</strong>.",
"Check all errors" => "Reviseu tots els errors",
"Configure General Settings" => "Configuracions Generals",
"Complete these fields to configure common, general settings for your site" => "Completa aquests camps per configurar paràmetres comuns i generals del teu lloc",
"The information you enter here can be changed later" => "La informació que introdueixis aquí la podràs canviar més endavant",
"Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings" => "Consulta la <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentació</a> per a més informació d'aquests i altres paràmetres",
"My Tiki" => "El Meu Tiki",
"This will appear in the browser title bar" => "Això apareixerà en la barra de títol del navegador",
"Email sent by your site will use this address" => "Els correus-e enviats pel teu lloc empraran aquesta adreça de sortida",
"Network Proxy" => "Servidor intermediari de xarxa (network proxy)",
"Toggle section display" => "Commuta la mostra de la secció",
"Secure Log in" => "Connexió Segura",
"It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "Es recomana escollir l'opció \"Requereix connexió segura (https)\" per a major seguretat. Es necessita un certificat de seguretat i una IP dedicada per a implementar una connexió segura",
"HTTPS login" => "Connexió segura HTTPS",
"PHP error reporting level" => "Nivell d'informes d'error de PHP",
"Report all errors except notices" => "Informar de tots els errors excepte les notificacions",
"Visible to Admin only" => "Visibles només a persones administradores",
"Admin email" => "Correu-e de l'admin",
// "admin@example.com" => "admin@example.com",
"This is the email address for your administrator account" => "Aquesta és l'adreça de correu-e del teu compte d'administrador/a",
"Set up htaccess file" => "Posa a punt l'arxiu htaccess",
"Method" => "Mètode",
"Select how to set up your htaccess file" => "Selecciona com posar a punt l'arxiu htaccess",
"Upgrade fix" => "Reparació per a actualitzacions (opcional)",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will",
"Create the <em>Admins</em> group, if missing" => "Es crearà el grup <em>Admins</em>, si no hi és present",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "Es donarà el permís <em>tiki_p_admin</em> al grup, si hi manca",
"Add the administrator account to the group, if missing" => "S'afegirà el compte d'administrador (admin) al grup, si no hi és",
"To do so enter the name of the main admin account in the field below" => "Per a això introduïu el nom del compte d'administrador principal al camp de baix",
// "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>" => "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>",
"Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Marca aquesta casella si tens una gran quantitat de comptes deshabilitades després d'una actualització de tiki4",
"List of accounts that will be enabled" => "Llista de comptes que s'habilitaran",
"Last Notes" => "Darreres notes",
// "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future" => "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future",
// "Subscribe to Tiki Releases newsletter" => "Subscribe to Tiki Releases newsletter",
// "Critical & Security update" => "Critical & Security update",
// "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates" => "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates",
// "We don't share subscribed emails and we send very few of these newsletters per year" => "We don't share subscribed emails and we send very few of these newsletters per year",
// "Please use the following link and subscribe" => "Please use the following link and subscribe",
// "Tiki Releases newsletter" => "Tiki Releases newsletter",
// "First Wizards, then Control Panels with Preference Filter" => "First Wizards, then Control Panels with Preference Filter",
// "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator" => "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator",
// "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})" => "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})",
// "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install" => "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install",
// "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels" => "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels",
// "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided" => "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided",
// "Storing your uploaded files" => "Storing your uploaded files",
// "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database" => "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database",
// "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more" => "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more",
// "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other" => "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other",
// "Tiki Community" => "Tiki Community",
// "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users" => "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users",
// "Get Help with Tiki" => "Get Help with Tiki",
// "Hire a Tiki Service Provider" => "Hire a Tiki Service Provider",
// "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>" => "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>",
"Enter Your Tiki" => "Entra al teu Tiki",
"Ready to run" => "Preparat per funcionar",
"The installation is complete" => "S'ha acabat el procés d'instal·lació",
".htaccess File" => "Arxiu .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomanem habilitar l'arxiu <strong>.htaccess</strong> per al teu Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Això et permetrà emprar les  SEFURLs (adreces d'internet amigables als cercadors) i ajudar a millorar la seguretat del teu lloc",
// "Your .htaccess file has been set up (%0)" => "Your .htaccess file has been set up (%0)",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
"Enter Tiki and Lock Installer" => "Entra a Tiki i bloqueja l'Instal·lador",
"Recommended" => "Recomanat",
"Enter Tiki Without Locking Installer" => "Entra a Tiki Sense Bloquejar l'Instal·lador",
"Not recommended due to security risk" => "No recomanat a causa dels riscos de seguretat",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Ja pots accedir ara al lloc amb normalitat. Informa de qualsevol incidència o problemes que detectis (si és el cas) als fòrums comunitaris de tiki.org o al formulari de registre d'errors a dev.tiki.org",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Segur que vols intentar solucionar la codificació de la teva base de dades sencera",
"Upgrading and running into encoding issues" => "Actualitzant i trobant-te amb incidències de codificació",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Podem intentar solucionar-ho, però <strong>assegura't que tens còpies de seguretat, i que pots restaurar-les</strong>",
"Previous table encoding" => "Codificació anterior de les taules",
"Please select" => "Si us plau, selecciona una",
"Click to fix double encoding (dangerous)" => "Clica per arreglar la codificació doble (perillós)",
"Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Uups. Has d'assegurar-te que el conjunt de caràcters del client està forçat a UTF-8. Re-especifica la connexió a la base de dades per poder continuar",
"MultiTiki Setup" => "Instal·lació MultiTiki",
"Default Installation" => "Instal·lació per omissió",
"DB OK" => "BD OK",
"No DB" => "Cap BD",
"Adding a new host" => "Afegint un nou hoste",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Per afegir un nou allotjament virtual executa l'arxiu setup.sh amb el nom del domini del nou allotjament com a últim paràmetre",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Estàs actualitzant un lloc Tiki existent",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ves directament al pas d'<strong>Instal·lació / Actualització</strong> ",
"Install/Upgrade" => "Instal·lació / Actualització",
"Powered by" => "Basat en",
"Powered by Tiki Wiki CMS Groupware" => "Potenciat per Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Neteja versió captada i actualitza memòria cau",
"configure rules" => "configura normes",
"Edit Repository" => "Edita dipòsit",
"Invitation" => "Invitació",
"Invitations list" => "Llista Invitacions",
"The mail has been sent to: " => "El missatge ha estat enviat a:",
"You are about to send an invitation to theses people, please confirm" => "Estàs a punt d'enviar una invitació a les tesis persones, confirmi si us plau",
"Fill this box with the list of emails you want to invite " => "Omple aquest quadre amb la llista de missatges de correu electrònic que voleu convidar",
"Format of the list above " => "El format de la llista anterior",
"CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Estil: Una línia per invitació, amb el format: cognom, nom, adreça de correu electrònic",
"Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Tot el que apareix com a correu electrònic en el text serà detectat i utilitzat (en aquest cas, {literal}{firstname} i {lastname}{/literal} es tindrà en compte en el contingut del correu electrònic)",
"Type here the email subject you'll want to be sent to them " => "Escrigui aquí l'assumpte del correu electrònic que voleu que s'enviarà als",
"Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Escriu aquí el contingut del correu electrònic que desitjes que se'ls enviï (i deixa que la paraula {literal}{link}{/literal} sigui substituïda per l'enllaç de registre correcte)",
"Type here the content that the user will see when he'll click on the link from the mail " => "Escriu aquí el contingut que l'usuari veurà quan faci clic a l'enllaç del correu",
"Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special " => "Selecciona un grup o més que voleu que aquestes subscripcions siguin a dins. No n'escullis cap si no vols res especial ",
"Invoices" => "Factures",
"New Invoice" => "Nova factura",
"Clients" => "Clientela",
"New Client" => "Nou Client",
"Invoice Reports" => "Informes de factures",
"Add more media" => "Afegir més mitjans",
"Change Details" => "Canviar Detalls",
"Video Title" => "Video Title",
"Editor" => "Editor",
"Embed code" => "Codi Embed",
"Plays" => "Reprodueix",
"No action specified" => "Cap acció especificada",
"This file is not expected to be called directly" => "No s'espera que aquest arxiu perquè es digui directament",
"Last Changes" => "Últimes modificacions",
"Last 2 days" => "Darrers 2 dies",
"Last 3 days" => "Darrers 3 dies",
"Last 5 days" => "Darrers 5 dies",
"Last week" => "Darrera setmana",
"Last 2 weeks" => "Darreres 2 setmanes",
"Last month" => "Darrer mes",
"Search by Date" => "Cerca per data",
"Found" => "Trobat",
"LastChanges" => "DarrersCanvis",
"Ip" => "Ip",
"{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
"v" => "v",
"Diff" => "Dif",
"Pages like" => "Pàgines similars",
"New Article" => "Nou Article",
"New Submission" => "Nou enviament",
"View Submissions" => "Veure col·laboracions",
"Expiry Date" => "Data de Caducitat",
"{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
"{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
"{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
"{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
"{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
"Select Duplicates" => "Selecciona els Duplicats",
// "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "Crea una banner",
"Use Dates?" => "Utilitzar dates?",
"Max Impressions" => "Impressions màx",
"Impressions" => "Impressions",
"Max Clicks" => "Clics Max.",
"Clicks" => "Clics",
// "List Posts" => "List Posts",
"The cache is used by" => "La memòria cau és emprada per",
"{\$headerName}" => "{\$headerName}",
"Approval" => "Aprova-ho",
// "Delete comment" => "Delete comment",
"(no title)" => "(sense títol)",
"{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "Aprovat/da",
"More Information" => "Més informació",
// "Delete selected comments" => "Delete selected comments",
// "Delete and ban selected comments" => "Delete and ban selected comments",
// "Delete and ban" => "Delete and ban",
"Dynamic Content System" => "Sistema contingut Dinàmic",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "També pots emprar {literal}{content label=x}{/literal}, on x és l'etiqueta del bloc de contingut",
"Available content blocks" => "Blocs disponibles",
"Current Value" => "Valor actual",
"Current ver" => "Versió actual",
"Next ver" => "Propera versió",
"Future vers" => "Vers. futura",
"Program" => "Programar",
"Create/Edit content block" => "Crea/Edita bloc de contingut",
"Edit content block" => "Edita bloc de contingut",
"Create content block" => "Crea bloc de contingut",
"Available FAQs" => "PMF disponibles",
// "Questions / Suggested" => "Questions / Suggested",
"Edit/Create" => "Edita/Crea",
"Edit this FAQ:" => "Editeu aquesta PMF:",
"Create new FAQ" => "Creeu una nova PMF",
"Create New FAQ:" => "Creeu una nova PMF:",
"Users can suggest questions" => "Els usuaris poden suggerir preguntes",
"Create a File Gallery" => "Crear una galeria d'arxius",
// "{\$name}" => "{\$name}",
// "Finder" => "Finder",
"RSS feed" => "Alimentació RSS",
"Hide file information from list view" => "Amaga la informació de l'arxiu de la vista de llista",
// "Hide list view information" => "Hide list view information",
"Show file information from list view" => "Mostra la informació de l'arxiu a la vista de llista",
// "Show list view information" => "Show list view information",
// "Create Diagram" => "Create Diagram",
// "Batch" => "Batch",
"SlideShow" => "Passi de diapositives",
// "Create H5P" => "Create H5P",
"Be careful to set the right permissions on the files you link to" => "Tingues cura de posar els permisos adients als arxius als que enllaces",
"Keep gallery window open" => "Manté la finestra de la galeria oberta",
"optional" => "opcional",
"Modifications" => "Modificacions",
"Property <b>{\$fgp_name}</b> Changed" => "Ha canviat la propietat <b>{\$fgp_name}</b>",
// "Search for text within files in all galleries" => "Search for text within files in all galleries",
// "Search by identifier" => "Search by identifier",
// "Search for the file with this number, in all galleries" => "Search for the file with this number, in all galleries",
// "Maximum width" => "Maximum width",
"You can access the file gallery using the following URL" => "Pots accedir a la galeria d'arxius emprant la URL",
"Gallery Images" => "Galeries d'imatges",
"Inviter" => "Qui et convida",
"Only successful invitations" => "Només les invitacions èxit",
"Only pending invitations" => "Només invitacions pendents",
"Number of invitations" => "Nombre d'invitacions",
"Invoice Clients" => "Clients Factura",
"Tax Status" => "Situació fiscal",
"New Contact" => "Nou contacte",
"Client Name" => "Nom del Client",
"Remix Entries" => "Remix comentaris",
"Browse Media" => "Examinar els mitjans de comunicació",
"Browse Remixes" => "Examinar Remixes",
"Please select some media entries to use" => "Si us plau, seleccioneu algunes entrades dels mitjans de comunicació a utilitzar",
"Media Id" => "ID de mitjans",
"Wiki plugin code" => "Codi del Wiki Plugin",
"No entries" => "Sense entrades",
"No media entries found" => "No s'han trobat entrades de mèdia",
"to upload" => "per pujar",
"Modified By" => "Modificat per",
"No mix entries found" => "No hi ha entrades de mescla que es troba",
"Object Permissions List" => "Llista de Permisos d'objecte",
"Object Permissions" => "Permisos d'objecte",
// "Object permissions" => "Object permissions",
// "Category permissions" => "Category permissions",
// "Perform action with selected permissions" => "Perform action with selected permissions",
// "Assign to this group" => "Assign to this group",
// "Only default global permissions are being used" => "Only default global permissions are being used",
"Reason" => "Raó",
// "No object permissions apply" => "No object permissions apply",
"{\$special.reason|escape}" => "{\$special.reason|escape}",
// "No category permissions apply" => "No category permissions apply",
"Blog: %0" => "Bloc: %0",
"New Blog Post" => "Nova Publicació de Bloc",
"Post Title" => "Títol de Publicació",
"Blog Title" => "Títol de la Bloc",
// "(bytes)" => "(bytes)",
// "Delete Expired Submissions" => "Delete Expired Submissions",
// "Deletes expired submissions 1000 at a time to avoid timeouts" => "Deletes expired submissions 1000 at a time to avoid timeouts",
"Survey stats" => "Estadístiques de l'enquesta",
// "Take survey" => "Take survey",
"Import Structure" => "Estructura de les importacions",
"Import From Profile/YAML" => "Importa de perfil / YAML",
// "Manage Tabular Formats" => "Manage Tabular Formats",
// "Clone remote" => "Clone remote",
"Items" => "Ítems",
// "{\$tracker.name|escape}" => "{\$tracker.name|escape}",
"Do you really remove this tracker" => "Realment treu aquest un formulari-bd",
"Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "¿Realment desitja esborrar tots els articles d'aquest un formulari-bd? (Nota: no es pot desfer i les notificacions no s'enviarà)",
"users registered" => "usuaris enregistrats",
"like" => "com",
"Distance (km)" => "Distància (km)",
"{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Llista les Pàgines Wiki",
"Page aliases found" => "Àlies Pàgina troben",
"Create a Wiki Page" => "Crea una pàgina Wiki",
"Insert name of the page you wish to create" => "Inserta el nom de la pàgina que vols crear",
"Create page within %0" => "Crear pàgina dins de %0",
"Page creator" => "Creador de la pàgina",
"Last author" => "Darrer autor",
"Last version" => "Darrera versió",
"Status of the page" => "Estatus de la pàgian",
"Links to other items in page" => "enllaça a altres ítems a la pàgina",
"Links to this page in other pages" => "Enllaós a aquesta pàgina en altres pàgines",
"Backl." => "Retroenll.",
"Page size" => "Mida de pàgina",
"Lang." => "Idiom.",
"No page" => "No pàgina",
"No pages found with" => "No s'han trobat amb pàgines",
// "Download PDF" => "Download PDF",
// "Download zipped file" => "Download zipped file",
// "Add page name as page header" => "Add page name as page header",
"Open client window" => "Obre la finestra de client",
"Generate HTML" => "Genera HTML",
"Transcripts" => "Transcripcions",
"Online operators" => "Operadors connectats",
"Accepted requests" => "Sol·licituds acceptades",
"{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "transcripcions",
"offline" => "fora de línia",
"Offline operators" => "Operadors desconnectats",
"{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Afegiu un operador al sistema",
"Operators must be tiki users" => "Els operadors han de ser usuaris del tiki",
"Set as Operator" => "Definit com a operador",
"Chat started" => "Xat iniciat",
"Operator:" => "Operador:",
"Live support:User window" => "Suport Directe:finestra de l'usuari/a",
"Request live support" => "Demanar soport en directe",
"Request support" => "Demanar suport",
"Your request is being processed" => "La teva petició està essent processada",
"cancel request and exit" => "Cancel·lar petició i sortir",
"cancel request and leave a message" => "Cancel·lar petició i deixar un missatge",
"Live support:Console" => "Suport Directe:Consol·la",
"Status:" => "Estat:",
"{\$status}" => "{\$status}",
"be online" => "estar connectat",
"be offline" => "estar desconnectat",
"You are not an operator" => "No és un operador",
"Support requests" => "Peticións d'ajuda",
"Requested" => "Sol·licitat",
"Accept" => "Accepta",
"Join" => "Uneix-te",
"No support requests" => "No hi ha peticions de suport",
"Support chat transcripts" => "Suport de transcripcions de chat",
"Back to admin" => "Torna a admin",
"operator" => "operador",
"started" => "començat",
"reason" => "raó",
"msgs" => "mstgs",
"Transcript" => "Transcripció",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Per qüestions de seguretat hem de validar periòdicament la teva adreça de correu-e per permetre l'acés continuat en aquest lloc.",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "Se t'ha enviat un correu-e de validació. Si us plau, obre'l i segueix les instruccions per obtenir de nou accés al lloc.",
"Thank you" => "Gràcies",
"Mail-in feature" => "Prestació Correu-in",
"Click here to go to mailin admin" => "Fes clic aquí per anar a Mailin administrador",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Manca una dependència. Pots obtenir l'arxiu' <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> i pujar-lo a dins de la carpeta files/ al servidor",
"Mini Calendar" => "Mini Calendari",
"Prefs" => "Prefs",
"Daily" => "Diari",
"Weekly" => "Setmanal",
"Remove old events" => "Elimina els esdeveniments antics",
"h" => "h",
"mins" => "minuts",
"Edit Event" => "Edita Esdeveniment",
"Mini Calendar: Preferences" => "Mini Calendari: Preferències",
"Calendar Interval in daily view" => "Vista diària dels intervals del calendari",
"Start hour for days" => "Hora d'inici per als dies",
"End hour for days" => "Hora d'acabament per als dies",
"Reminders" => "Recordatoris",
"no reminders" => "sense recordatoris",
"min" => "min",
"Or enter path or URL" => "O entreu-hi el camí o la URL",
"Add Topic" => "Afegiu-hi un tema",
"Tiki Mods" => "Tiki Mods",
// "Tiki \"Mods\" are obsolete as of Tiki 19" => "Tiki \"Mods\" are obsolete as of Tiki 19",
// "Tiki now uses \"Packages\" instead" => "Tiki now uses \"Packages\" instead",
// "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>" => "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>",
"y" => "s",
// "Records" => "Records",
"User Galleries" => "Galeries de l'usuari/a",
"My Articles" => "Els meus Articles",
"User Articles" => "Articles de l'usuari",
"My User Items" => "Els meus ítems d'usuari",
"User Items" => "Ítems d'usuari",
"Unread Messages" => "Missatges no llegits",
"User forum topics" => "Tòpics de l'usuari als fòrums",
// "Forum topic" => "Forum topic",
"Date of post" => "Data de publicació",
"User forum replies" => "Respostes de l'usuari al fòrum",
"User Blogs" => "Blocs de l'usuari",
"My blog Posts" => "El meu bloc Publicacions",
"User Blog Posts" => "Usuari posts de bloc",
"To display the objects you created or contributed to:" => "Per mostrar els objectes en els que participes:",
// "My Items" => "My Items",
"My Info" => "Les meves informacions",
"My Watches" => "Els meus avisos",
"Contacts Preferences" => "Preferències dels contactes",
"Notepad" => "Bloc de notes",
"MyFiles" => "Elsmeusarxius",
"Sent editions" => "Edicions enviades",
"Admin Newsletters" => "Administra Butlletins",
"HTML version" => "Versió en HTML",
"Text version" => "Versió en Text senzill",
"The newsletter was sent to {\$sent} email addresses" => "El butlletí ha estat enviat a {\$sent} adreces de correu-e",
"Delete errors" => "Esborra errors",
"Not sent" => "No s'ha enviat",
"Subscribe to Newsletter" => "Subscriure a butlletí",
"Subscribe to this Newsletter" => "Subscriu",
"Available Newsletters" => "Butlletins disponibles",
"Write a note" => "Escriu una nota",
"quota" => "quota",
"No notes yet" => "Encara no hi ha notes",
"Merge selected notes into" => "fusiona les notes seleccionades en",
"Reading note:" => "Nota de lectura:",
"List notes" => "Llista de notes",
"Write note" => "Escriu nota",
"Wiki Create" => "Crea wiki",
"Wiki Overwrite" => "Sobrescriu wiki",
"Object Watches" => "Subscripcions a l'objecte",
"Groups watching" => "Grups observació",
"Changes to groups watching" => "Els canvis en els grups que miren",
"These changes to group watches" => "Aquests canvis a subscripcions de grups",
"were made to these descendants" => "han estat fets a aquests descendents",
"This Category" => "Aquesta Categoria",
"All Descendants" => "Tots els descendents",
"Assign global permissions" => "Assignar permisos globals",
"Assign permissions to " => "Assignar permisos a ",
"Edit Permissions" => "Edita els permisos",
"Currently editing Global permissions" => "Actualment permisos d'edició Global",
"This object's direct permissions override any global permissions or category permissions affecting this object" => "Permisos directes d'aquest objecte anul·len els permisos globals o permisos categoria que afecten aquest objecte",
"This category's direct permissions override any global permissions affecting objects in it" => "Permisos directes d'aquesta categoria tenen prioritat sobre els permisos globals que afecten els objectes en ella",
"To edit global permissions" => "Per editar els permisos globals",
"No permissions yet applied to this object but category permissions affect this object and are displayed below" => "Sense permisos encara apliquen a aquest objecte, però els permisos de categoria afecten aquest objecte i es mostren a continuació",
"To edit category permissions" => "Per editar els permisos de categoria",
// "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below" => "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below",
// "To edit parent object's permissions" => "To edit parent object's permissions",
"No direct permissions yet applied to this object. Global permissions apply" => "No hi ha permisos directes aplicats encara a aquest objecte. Manen els permisos globals",
"Currently inherited permissions displayed" => "Actualment es mostren els permisos heretats",
"Show permissions for disabled features" => "Mostra permisos per les funcions desactivades",
"Assign permissions to this category" => "Assignar permisos a aquesta categoria",
"Assign permissions to this object" => "Assigna permisos a aquest objecte",
"Delete category permissions" => "Eliminar els permisos de categoria",
"Delete object permissions" => "Eliminar els permisos d'objectes",
"Reset Perms" => "Restablir Permisos",
"This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "Això eliminarà tots els ajustaments aquí i permisos es restablirà a heretar els permisos de categoria que s'estableixen, o els permisos globals a tot el lloc",
"This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "Això eliminarà tots els ajustaments aquí i permisos es restablirà a heretar els permisos globals a tot el lloc",
"Permissions Clipboard" => "Portapapers de Permisos",
"Copy the permissions set here" => "Copieu el conjunt permisos aquí",
"Paste" => "Enganxa",
"Paste copied permissions from " => "Enganxeu permisos copiades de",
"Assign or remove permissions on <em>all</em> child categories" => "Assignar o treure permisos de <em> tots </em> categories infantil",
"Are you sure you want to affect all child categories?\\nThere is no undo" => "Estàs segur que desitges afectar totes les categories filles?\\nNo es pot desfer",
"Assign or remove permissions on all pages of the sub-structure" => "Assignar o treure permisos de totes les pàgines de la sub-estructura",
"Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Estàs segur que desitges afectar totes les pàgines d'aquest sub-estructura?\\nNo es pot desfer",
"You must select at least one feature" => "Heu de seleccionar almenys una característica",
"View Differences" => "Veure diferències",
"Permissions added" => "Permisos afegit",
"Permissions removed" => "Permisos remoguts",
"Select groups" => "Seleccioneu els grups",
"Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for" => "Alguns dels grups s'han ocultat de forma automàtica. <br> Seleccioneu els grups a continuació per assignar permisos per",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "Aquests grups no són els grups que tenen permisos en l'objecte. Només els grups que es poden veure a les columnes de la primera pestanya",
"Select only groups that have a perm with the object" => "Seleccioneu només els grups que tenen una permanent amb l'objecte",
"Group name" => "Nom del Grup",
"Select features" => "Seleccioneu les característiques",
"Some of your features have been automatically hidden.<br> Select the features below to assign permissions for" => "Algunes de les seves característiques s'han ocultat de forma automàtica. <br> Seleccionar les característiques a continuació per assignar permisos per",
"Feature name" => "Nom de la característica",
"Quick Permissions" => "Permisos ràpids",
"Assign Quick-Permissions to this object" => "Assignar ràpid permisos per a aquest objecte",
// "Individual permissions are currently assigned (See tab Assign Permissions)" => "Individual permissions are currently assigned (See tab Assign Permissions)",
"<em>Quick permissions</em> should be considered as an experimental feature" => "<em> permisos ràpids </em> s'han de considerar com una característica experimental",
"Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Encara que es fixaran com s'esperava mitjançant aquest formulari permisos, que no mostra necessàriament els permisos actuals fiable",
"There is also no undo - <strong>Use with care!</strong>" => "Tampoc hi ha desfer - <strong> Utilitza amb cura </strong>",
"Your OpenID identity is valid" => "La teva identitat OpenID és vàlida",
"Your identity gives you access to multiple user accounts." => "La teva identitat et dona accés a múltiples comptes d'usuari.",
"Select account" => "Selecciona compte",
"Orphan Pages" => "Pàgines òrfenes",
"Browser not supported" => "Explorador no suportat",
"Contributions by author" => "Contribucions d'autor",
"Similar" => "Similar",
"Make Structure" => "Fes Estructura",
"Discuss" => "Debat",
"Bookmark" => "Marcador",
"View latest version before editing" => "Veure última versió abans d'editar",
"Contributions to" => "Les contribucions a",
"current version" => "versió actual",
"Words" => "Paraules",
"Whitespaces" => "Espais en blanc",
"Characters" => "Personatges",
"Printable characters" => "Caràcters imprimibles",
"Page changes" => "Canvis de pàgina",
"Original wiki text" => "Text original wiki",
"Parsed Text (HTML)" => "Text analitzat (HTML)",
"Output text only (No HTML tags)" => "Text de sortida només (No hi ha etiquetes HTML)",
"Show statistics" => "Mostrar estadístiques",
"Visualize page changes" => "Vegeu els canvis de pàgina",
"Show popups" => "Mostra elements emergents",
"Escape HTML / Wiki syntax in page changes" => "Sintaxi d'escapament HTML / Wiki en canvis de pàgina",
"Show contributions" => "Mostra contribucions",
// "Collapse Into Edit Sessions" => "Collapse Into Edit Sessions",
"Show All Versions" => "Mostra totes les versions",
"Preview of version" => "Previsualitzacióde la versió",
"(current)" => "(actual)",
"Roll back to this version" => "Restableix aquesta versió",
"Content Approval" => "Aprovació de contingut",
"This revision is currently marked as approved" => "Aquesta revisió s'ha marcat actualment aprovat",
"Remove Approval" => "Traieu Aprovació",
"This revision has not been approved" => "Aquesta revisió no ha estat aprovat",
"Approve Revision" => "Aprovar la revisió",
// "History view" => "History view",
// "This revision may not be the latest approved revision" => "This revision may not be the latest approved revision",
// "This revision has been rejected" => "This revision has been rejected",
"Source of version" => "Codi font de la versió",
"Update Translation" => "Actualitza traducció",
"Hide translation history" => "Amaga l'historial de la traducció",
"Show translation history" => "Mostra l'historial de la traducció",
"Enable pagination" => "Habilitar paginació",
// "rows per page" => "rows per page",
// "HTML allowed" => "HTML allowed",
// "HTML syntax is allowed either by page setting or use of the WYSIWIG editor" => "HTML syntax is allowed either by page setting or use of the WYSIWIG editor",
"from %0" => "des %0",
"approved" => "aprovat",
"Updated from" => "Actualitza des de",
"Used to update" => "Emprat per actualitzar",
// "rejected" => "rejected",
// "Difference" => "Difference",
"Older Version" => "Versió més vella",
// "Israel Post" => "Israel Post",
// "Order ID" => "Order ID",
// "Payment authorized (not captured)" => "Payment authorized (not captured)",
// "Payment authorized (captured)" => "Payment authorized (captured)",
// "Unknown state" => "Unknown state",
// "Date Paid" => "Date Paid",
"Payer" => "Pagador",
// "Payer email from %0" => "Payer email from %0",
"View payment info" => "Veure informació de pagament",
"Cancel this payment request" => "Cancel·lar la sol·licitud de pagament",
"View payment request" => "Veure sol·licitud de pagament",
"Paypal" => "Paypal",
"Transaction ID" => "ID de transacció",
"Payment made by <em>%0, %1</em> (%2)" => "Pagament per <em> %0, %1 </em> (%2)",
"Payment Request" => "Sol·licitud de pagament",
"{\$wp_member_title}" => "{\$wp_member_title}",
// "For each user: " => "For each user: ",
// "per full period" => "per full period",
// "applicable prorated pricing provided" => "applicable prorated pricing provided",
// "free periods provided" => "free periods provided",
// "full free" => "full free",
// "prorated free" => "prorated free",
"Payment Status" => "Estat del pagament",
"{\$payment_info.state|capitalize|escape}" => "{\$payment_info.state|capitalize|escape}",
// "Capture Payment" => "Capture Payment",
"Paid amount" => "Quantitat pagada",
"Initial amount" => "Import inicial",
"Amount remaining" => "Import restant",
"Payment request initiated" => "Sol·licitud de pagament va iniciar",
"Payment request due" => "Sol·licitud de pagament ha",
"Pay with PayPal" => "Paga amb PayPal",
"Pay with Paypal" => "Paga amb Paypal",
// "Proceed to Israel Post" => "Proceed to Israel Post",
"Pay With Cclite" => "Pagarà amb Cclite",
"Refresh page" => "Refrescar",
"Payment info" => "Informació sobre el pagament",
"Trade with Cclite" => "El comerç amb Cclite",
"Payment problem" => "Problema de Pagament",
"Pay With Tiki Credits" => "Pagarà amb Tiki Crèdits",
"Pay with Tiki User Credits" => "Pagar amb Tiki Crèdits usuari",
"Credit type" => "Tipus de Crèdit",
"Credits left" => "Crèdits que li queden",
"Amount to pay" => "La quantitat a pagar",
"Pay using" => "Pagui usant",
"Payment Details" => "Detalls del pagament",
"Enter a Manual Payment" => "Introduïu un Pagament Manual",
"Enter payment" => "Introduïu pagament",
"using" => "ús",
"Payment information" => "Informació del pagament",
// "No outstanding payments found" => "No outstanding payments found",
// "No paid payments found" => "No paid payments found",
// "<em>No cancelled payments found</em>" => "<em>No cancelled payments found</em>",
"Request" => "Sol·licitar",
"Payable within" => "A pagar en",
"Pick your profile picture" => "Escull el teu avatar",
"Your current profile picture" => "El teu avatar actual",
"Full size" => "La mida complet",
"no profile picture" => "cap avatar",
// "Pick user profile picture from the library" => "Pick user profile picture from the library",
"Pick user profile picture" => "Escull l'Avatar de l'usuari",
"Hide all" => "Amaga-ho tot",
"icons" => "icones",
"Show all" => "Mostra-ho tot",
"random" => "aleatori",
"Upload your own profile picture" => "Puja el teu propi avatar",
// "Select your profile picture" => "Select your profile picture",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Arxiu (només imatges .gif, .jpg i .png d'aproximadament 45px × 45px)",
"File (only .gif, .jpg and .png images)" => "Arxiu (únicament imatges .gif, .jpg i .png)",
"Plugin execution was denied" => "S'ha denegat l'execució del connector",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Després de la validació dels arguments per un editor, es va denegar l'execució del connector. Aquesta ús del connector serà eventualment eliminat o corregit",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "Aquest ús del connector ha estat afegit o modificat recentment. Fins que un edior del lloc en validi els paràmetres, la seva execució no és possible",
"You are allowed to" => "T'està permés de",
"View arguments" => "Veure els arguments",
"Execute the plugin in preview mode (may be dangerous)" => "Executar el connector en mode de previsualització (pot ser perillós)",
"Approve the plugin for public execution" => "Aprovar l'ús del connector per a execució pública",
"View Details" => "Mostra detalls",
"This plugin does not contain any arguments" => "Aquest connector no conté arguments",
"This plugin's body is empty" => "El cos del connector és buit",
// "Experiment with plugin LIST" => "Experiment with plugin LIST",
// "Test Plugin LIST" => "Test Plugin LIST",
"For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "Per a més seguretat, concedeixi la <strong> tiki_p_plugin_approve </strong> el permís només per als grups d'usuaris de confiança",
// "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins",
"This page lists the plugins that require validation, the first time they are encountered" => "Aquesta pàgina enumera els plugins que requereixen validació, la primera vegada que es troben",
"Each plugin contains a unique <em>signature</em> that is preserved" => "Cada plugin conté una signatura única <em> </em> que es conserva",
"When you upgrade from an old version, you may need to reparse all the pages" => "Quan s'actualitza des d'una versió anterior, pot ser que hagi de tornar a analitzar totes les pàgines",
"If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "Si un plugin ja no està en ús (per exemple, s'ha eliminat de la pàgina wiki), utilitzeu <strong>Clear</strong> per eliminar de la llista",
"The plugin will automatically be added if it is encountered" => "Automàticament s'afegeix el complement si es troba",
"Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Connectors poden ser individualment prèviament, aprova, o es rebutja des del lloc en particular que conté el plugin",
"For security, you should review each plugin to ensure it is safe to approve" => "Per raons de seguretat, ha de revisar cada plugin per assegurar-se que és segur per aprovar",
"Added By" => "Autor del producte",
"Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>" => "Pàgina Wiki: <a href=\"%0#%2\" title=\"Visualitza aquesta pàgina.\">%1</a>",
// "View this page" => "View this page",
"Approve all pending plugins" => "Aprovar tots els plugins pendents",
"Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Usant <strong> Aprovar </strong> o <strong> Aprovar-ho tot </strong> aprovarà i activarà els connectors pendents",
"Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Utilitza aquesta funció <strong>només</strong> si has verificat que tots els connectors pendents són segurs",
"No plugins pending approval" => "No hi ha connectors pendents d'aprovació",
"{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Visualitza resultats",
// "Sorry" => "Sorry",
"Other Polls" => "Altres Sondejos",
"Poll Results" => "Resultats del Sondeig",
// "All Polls" => "All Polls",
// "Top-Voted Polls" => "Top-Voted Polls",
"Edit Poll" => "Edita el Sondeig",
"Find the poll" => "Troba el sondeig",
"{\$what}" => "{\$what}",
"Number of top voted polls to show" => "Nombre a mostrar de sondejos amb més participació",
// "Show results in this range" => "Show results in this range",
"Start:" => "Inici:",
"End:" => "Final:",
// "Show all results with no time span consideration" => "Show all results with no time span consideration",
// "Show all results with time span consideration" => "Show all results with time span consideration",
// "Show all results" => "Show all results",
// "Find results" => "Find results",
// "Show detailed results of this poll" => "Show detailed results of this poll",
"List Votes" => "Llista Vots",
// "Preference translation" => "Preference translation",
"Popup preview" => "Vista prèvia emergent",
"Close preview" => "Tancar vista prèvia",
// "Permalink" => "Permalink",
"The original document is available at" => "El document original està disponible en",
"Print multiple pages" => "Imprimir múltiples pàgines",
"Selected Structures" => "Estructures seleccionades",
"Add Structure" => "Afegeix estructura",
"No structures" => "Cap estructura",
"Available Pages" => "Pàgines disponibles",
"No pages" => "Cap pàgina",
"All pages selected" => "Totes les pàgines seleccionades",
"Add Page" => "Afegeix pàgina",
"Remove Page" => "Eliminar pàgina",
"Selected Pages" => "Pàgines Seleccionades",
"No pages selected" => "Cap pàgina seleccionada",
"Add Pages from Structures" => "Afegeix pàgines des d'Estructures",
"Edit quiz" => "Edita el qüestionari",
"Current Version" => "Versió actual",
"General Options" => "Opcions generals",
"Publication Date" => "Data de publicació",
"at " => "a ",
"Use " => "Empra ",
"randomly selected questions." => "preguntes seleccionades a l'atzar.",
"Test-time Options" => "Opcions de test amb temps limitat",
"Shuffle questions" => "Qüestions barrejades",
"Shuffle answers" => "Respostes barrejades",
"Limit questions displayed per page to " => "Limita les preguntes mostrades per pàgina a ",
// "question(s)" => "question(s)",
"Impose a time limit of " => "Imposa un temps limit de ",
"Allow students to store partial results and return to quiz." => "Permet als estudiants guardar els resultats parcials i tornar al qüestionari.",
"Allow students to retake this quiz " => "Permet als estudiants repetir aquest qüestionari ",
"Grading and Feedback" => "Avaluació i retroalimentació",
"Grading method " => "Mètode d'avaluació ",
"Show students their score " => "Mostra als estudiants la seva puntuació ",
// "Show students the correct answers" => "Show students the correct answers",
"Publish statistics " => "Publica les estadístiques ",
"Extra Options" => "Opcions extres",
"Solicit additional questions from students" => "Solicita preguntes addicionals dels estudiants",
"Link quiz to forum named: " => "Enllaça la pregunta al fòrum anomenat: ",
"Prologue:" => "Pròleg:",
"Epilogue:" => "Epíleg:",
"Quiz result stats" => "Estadístiques dels resultats dels Tests",
"User answers" => "Respostes de l'usuari/a",
"Stats for quizzes" => "Estadistiques de qüestionaris",
"taken" => "pres/os",
"Av score" => "Resultat mitjà",
"Av time" => "Temps mitjà",
"Stats for quiz" => "Estadistiques per test",
"Clear Stats" => "Esborrar estadístiques",
"time taken" => "temps emprat",
// "Pass/Fail" => "Pass/Fail",
"Passed" => "Aprovat",
"Stats for this quiz Questions " => "Estadístiques per a les preguntes d'aquest test",
"Top 10" => "10 per dalt",
"Top 20" => "20 per dalt",
"Top 50" => "50 per dalt",
"Top 100" => "100 per dalt",
"Rank" => "Posició",
"Not Published" => "No Publicat",
"This article is currently unpublished and visible only to editors." => "Aquest article actualment no està publicat i només és visible per l'Editor",
"Received articles" => "Articles rebuts",
"Topic image" => "Imatge del tòpic",
"Edit received article" => "Edita article rebut",
"Image x size" => "Mida x de la imatge",
"Image y size" => "Mida y de la imatge",
"Image name" => "Nom de la imatge",
"Image:" => "Imatge:",
"Publishing date" => "Data de publicació",
"Accept Article" => "Accepta Article",
"Received Pages" => "Pàgines Rebudes",
"Edit Received Page" => "Edita la Pàgina Rebuda",
"The highlight pages already exist." => "Les pàgines ressaltades ja existeixen.",
"Please, change the name if you want the page to be uploaded." => "Si us plau, canvia el nom si vols que es pugi la pàgina.",
"Received Structures" => "Estructures rebudes",
// "Prefix the checked: " => "Prefix the checked: ",
// " Postfix the checked: " => " Postfix the checked: ",
// "References" => "References",
// "Add a new library reference" => "Add a new library reference",
// "Edit reference settings" => "Edit reference settings",
// "Reference usage" => "Reference usage",
// "Delete reference" => "Delete reference",
// "Edit reference" => "Edit reference",
// "If you change the value of Biblio Code, you might loose the link between references" => "If you change the value of Biblio Code, you might loose the link between references",
// "Pages using reference %0" => "Pages using reference %0",
"Referer stats" => "Estadístiques de referenciadors",
"Register as a new user" => "Registrar-se com a usuari nou",
"Tiki site registered" => "Llocs Tiki registrats",
"The following site was added and validation by admin may be needed before appearing on the lists" => "El lloc web següent s'hi ha afegit i potser necessitarà ser validat per l'administrador abans d'aparèixer a les llistes",
"You don't have permission to use this feature." => "No tens permís per emprar aquesta característica. Prova (re)connectar-te primer, enregistrant-te abans si no ho has fet encara",
"Please register." => "Si us plau, registreu-vos.",
"Register this site at Tiki.org" => "Registrar aquest lloc Tiki.org",
"Read this first!" => "Llegeix això abans de començar!",
"On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "En aquesta pàgina pots fer que Tiki.org conegui de l'existència del teu lloc tiki. Se mostrat allà en una llista de llocs tiki coneguts",
"Registering is voluntary." => "Registrar-se és voluntari.",
"Registering does not give you any benefits except one more link to your site." => "Registrar-se no et dona cap més avantatge que un enllaç més cap al teu lloc.",
"You don't get any emails, we don't sell the data about your site." => "No aconseguiràs adreces d'e-correus, no venem les dades dels llocs.",
"Registering is just for us to get an overview of Tiki's usage." => "El registre només és per fer-nos una idea de l'ús que es fa de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si el teu lloc és privat o està en una (intranet/xarxa interna), no et registris!",
"tiki.org" => "tiki.org",
"Information about your site" => "Informació del teu lloc",
"Enter your username or email" => "Introdueix el teu nom d'usuari o correu-e",
"Enter your email" => "Introdueix el teu correu-e",
"Request Password Reset" => "Demana un Canvi de Contrasenya",
"Rename page" => "Renombrar la pàgina",
// "Redirect original page" => "Redirect original page",
// "301 Redirect - \\\"moved permanently\\\" HTTP response status code" => "301 Redirect - \\\"moved permanently\\\" HTTP response status code",
// "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)" => "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)",
// "Roll back page %0 to version %1" => "Roll back page %0 to version %1",
// "Describe the reason for roll back" => "Describe the reason for roll back",
// "Enter some text to describe the reason for rolling back" => "Enter some text to describe the reason for rolling back",
"This feature currently searches and replaces within wiki pages only" => "Aquesta característica actualment cerca i reemplaça només dins de les pàgines del wiki",
"Max number of pages at a time" => "Nombre màxim de pàgines alhora",
"Number of surrounding chars to preview" => "Nombre de caràcters que envolten la vista prèvia",
"Replace selected" => "Substitueix els seleccionats",
"Searched" => "Cercat",
// "Search Query" => "Search Query",
"Search in" => "Cercar a",
"Date Search" => "Cerca per dates",
"All dates" => "Totes les dades",
"{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "Ítems del Calendari",
"{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}\"" => "{\$where_label|escape}\"",
"{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Cerca simple",
"No pages matched the search criteria" => "Cap pàgina ha encaixat en el criteri de cerca",
"You can also send newsletters using an external client" => "També pot enviar butlletins de notícies amb un client extern",
"This newsletter will be sent to {\$subscribers} email addresses." => "Aquest butlletí serà enviat a {\$subscribers} adreces de correu-e.",
// "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds" => "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds",
"Reply to" => "Respondre al",
// "Send from" => "Send from",
"Recipients" => "Destinataris",
"Validated" => "Validats/des",
"Is user" => "És usuari/a",
"Sending Newsletter" => "Enviament del Butlletí",
// "sending to {\$subscribers} addresses" => "sending to {\$subscribers} addresses",
// "with the 'Reply To' email set to: {\$replyto}" => "with the 'Reply To' email set to: {\$replyto}",
// "with the 'Send From' email set to: {\$sendfrom}" => "with the 'Send From' email set to: {\$sendfrom}",
"Prepare a newsletter to be sent" => "Prepara un butlletí per ser enviat",
"Admin templates" => "Admin plantilles",
"Data HTML" => "Dades HTML",
"Must be wiki parsed" => "Interpreta el format Wiki",
// "Wiki Parsed" => "Wiki Parsed",
"Is HTML" => "És HTML",
"Data Txt" => "Dades Txt",
"Article Clip (read only)" => "Retall d'article (només de lectura)",
"Clip Now" => "Inclou retalls ara",
"Clip Articles" => "Inclou retalls d'articles",
"To include the article clipping into your newsletter, cut and paste it into the contents" => "Per a incloure retalls d'articles al teu butlletí, talla i enganxa-ho en els continguts del butlletí",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "Si s'ha activat l'autoretallat, també pots introduir \"~~~articleclip~~~\" que serà reemplaçat amb el darrer \tretall quan s'enviï",
"Be careful not to paste articles that must not be seen by the recipients" => "Aneu amb compte de no enganxar els articles que no han de ser vistos pels receptors",
"Attached Files" => "Arxius adjunts",
"remove" => "eliminar",
"octets" => "octets",
"To add a file, click here" => "Per a afegir un arxiu, clica aquí",
"Reply To Email" => "Respon al Correu-e",
"if not" => "si no",
"Sender email not set" => "Correu electrònic del remitent no s'estableix",
// "Send From Email" => "Send From Email",
"Preview your changes." => "Previsualitza els teus canvis.",
"Save as Draft" => "Desa-ho com a esborrany",
"Save your changes" => "Desa els canvis",
"Save any changes and send to all subscribers" => "Desa qualsevol canvi i envia a totes les persones subscriptores",
"Drafts (%0)" => "Esborranys (0%)",
"Sent Editions (%0)" => "Edicions enviats (%0)",
"Send objects" => "Envia objectes",
"Transmission results" => "Resultats de la transmissió",
"Send Wiki Pages" => "Envia pàgines del Wiki",
"Send a structure" => "Envia una estructura",
"Send Articles" => "Envia articles",
"Add Article" => "Afegeix article",
"Send objects to this site" => "Envia objectes a aquest lloc",
"Ex: http://tiki.org or localhost" => "Ex: http://tiki.org o localhost",
"Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Utilitza /commxmlrpc.php si el teu Tiki està instal·lat en l'arrel, en cas contrari adapta /tiki a la teva necessitat",
"Report this page" => "Informa d'aquesta pàgina",
"Page shared" => "Pàgina compartida",
"The link was sent via email to the following addresses" => "S'ha enviat l'enllaç via correu-e a les adreces següens",
"The link was sent via Twitter" => "S'ha enviat l'enllaç via Twitter",
"The link was posted on your Facebook wall" => "S'ha publicat l'enllaç al teu mur de Facebook",
"The link was sent as message to" => "S'ha enviat l'enllaç com a missatge a",
"The link was published in a" => "S'ha publicat l'enllaç en un/a",
"Have a look at this page" => "Fes una ullada a aquesta pàgina",
// "Access rights are granted for the page" => "Access rights are granted for the page",
"Short link" => "Enllaç curt",
// "Send email" => "Send email",
"Recipient(s)" => "Destinatari(s)",
"Separate multiple email addresses with a comma and a space" => "Múltiples adreces d'email amb una coma i un espai",
"Separate multiple email addresses with a comma" => "Separa múltiples adreces de correu-e amb comes",
"Your name" => "El teu nom",
// "Recipients can subscribe to token notifications" => "Recipients can subscribe to token notifications",
// "Token Access Limit" => "Token Access Limit",
// "How many times recipients can access this page" => "How many times recipients can access this page",
"Tweet via Twitter" => "Tweet via Twitter",
"Authorize with Twitter first" => "Autoritza primer amb Twitter",
"Have a look at " => "Fes una ullada a ",
"Put on my Facebook wall" => "Posa en el meu mur de Facebook",
"Authorize with Facebook first" => "Autoritza primer amb Facebook",
"Link text" => "Text de l'enllaç",
"This will be the title for the URL" => "Aquesta serà el títol per a la URL",
"Like this post" => "m'agrada aquesta publicació",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "No tens permís per enviar missatges o no permets a altres usuaris que t'enviïn missatges",
// "User(s)" => "User(s)",
"Separate multiple recipients with a semicolon" => "Separeu els destinataris amb un punt i coma",
"Post on forum" => "Publica a un fòrum",
"There is no forum where you can post a message" => "No hi ha cap fòrum on puguis publicar un missatge",
"password-protected" => "protegit per contrasenya",
"Share access rights" => "Comparteix els permisos d'accés",
"Return to previous page" => "Tornar a la pàgina anterior",
// "Create sheet" => "Create sheet",
// "Configure sheet" => "Configure sheet",
"There are individual permissions set for this sheet" => "Hi ha permisos individuals fixats per a aquest full",
"Class Name" => "Nom de Classe",
"Header Rows" => "Files de Capçalera",
"Footer Rows" => "Files de Peu de pàgina",
"Wiki Parse Values" => "Processa valors i sintaxi Wiki",
"Parent Spreadsheet" => "Full de càlcul dels Pares",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Converteix aquest full en un \"fill\" d'un multi-full de càlcul(llibre de càlcul)",
"You can access the sheet using the following URL" => "Pots accedir a aquest full emprant la següent URL",
"Banned Words" => "Paraules prohibides",
"Change shoutbox general settings" => "canvia les opcions generals del diàleg",
"auto-link urls" => "auto-enllaç urls",
"Post or edit a message" => "Editar o enviar missatge",
"Location : " => "Lloc : ",
"Content may be out of date" => "Aquest contingut pot estar desfasat",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages:" => "S'ha enviat una petició urgent de traducció. Fins que la pàgina no estigui actualitzada, pots veure una versió corregida a les pàgines següents:",
// "Update from it" => "Update from it",
"page: %0/%1" => "Pàgina: %0/%1",
"This text was automatically translated by Google Translate from the following page: " => "Aquest text ha estat traduït automàticament per Google Translate en la següent pàgina:",
"Rate this page" => "Valora aquesta pàgina",
"Last edited by" => "Editat per darrera vegada per",
"based on work by" => "basat en treball fet per",
"Contributors to this page" => "Contribuïdors a aquesta pàgina",
"Last Modification:" => "última modificació:",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
"Twitter authorisation" => "Twitter autorització",
"to manage your authorisations at Twitter" => "per administrar les seves autoritzacions a Twitter",
"this site with twitter.com to use Twitter integration of this site" => "aquest lloc amb twitter.com utilitzar Twitter integració d'aquest lloc",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
"Facebook authorisation" => "Facebook autorització",
// "to manage your authorizations at Facebook" => "to manage your authorizations at Facebook",
// "this site within facebook.com to use Facebook integration with this site" => "this site within facebook.com to use Facebook integration with this site",
// "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first" => "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first",
// "LinkedIn authorisation" => "LinkedIn authorisation",
// "this site to link your user to your LinkedIn account" => "this site to link your user to your LinkedIn account",
"The site admin has set up a global account which will be used for this site" => "El lloc s'ha creat un compte d'administrador global que s'utilitzarà per a aquest lloc",
"bit.ly Login" => "bit.ly Login",
"bit.ly Key" => "bit.ly Clau",
"Save changes" => "Desa els canvis",
"You will be redirected to the home page shortly" => "Seràs redirigit a la pàgina d'inici en breu",
"to go to the home page immediately" => "per anar a la pàgina d'inici immediat",
"Please provide local account information" => "Serveixin-se proporcionar informació de compte local",
// "Do you already have a local account for this site" => "Do you already have a local account for this site",
// "Login to link to it using the following form instead" => "Login to link to it using the following form instead",
"Link to Existing Account" => "Enllaç al compte existent",
"You will not see the latest queries" => "No va a veure més consultes",
"Query" => "Consulta",
"Params" => "Params",
"Most viewed objects" => "Objectes més visualitzats",
"Most viewed objects in the last 7 days" => "Objectes més visualitzats en els darrers 7 dies",
"Site Stats" => "Estadístiques del lloc",
"Date of first pageview" => "Data de la primera visita de pàgina",
"Days since first pageview" => "Dies des de la primera visita de pàgina",
"Total pageviews" => "Visualitzacions de pàgines en total",
"Average pageviews per day" => "Mitjana de visualització de pàgines per dia",
"Wiki Stats" => "Estadístiques del Wiki",
"Size of Wiki Pages" => "Mida de les pàgines del Wiki",
"Average page length" => "Mida mitjana de les pàgines",
"Average versions per page" => "Mitjana de versions per pàgina",
"Visits to wiki pages" => "Visites a pàgines del wiki",
"Average links per page" => "Quantitat mitjana d'enllaços per pàgina",
"Image galleries Stats" => "Estadístiques de galeries d'imatges",
"Average images per gallery" => "Mitjana d'imatges per galeria",
"Total size of images" => "Mida total de les imatges",
"Average image size" => "Mida mitjana d'imatge",
"Visits to image galleries" => "Visites a galeries d'imatges",
"File galleries Stats" => "Estadístiques de galeries d'arxius",
"Average files per gallery" => "Mitjana d'arxius per galeria",
"Total size of files" => "Mida total dels arxius",
"Average file size" => "Mida mitjana d'arxiu",
"Visits to file galleries" => "Visites a les galeries d'arxius",
"Articles Stats" => "Articles Estadístiques",
"Total reads" => "Quantitat de notes llegides",
"Average reads per article" => "Mitjana de lectures per article",
"Total articles size" => "Mida total dels articles",
"Average article size" => "Mida mitajana d'un article",
"Forum Stats" => "Estadístiques de fòrums",
"Total topics" => "Quantitat de temes",
"Average topics per forums" => "Quantitat mitjana de temes per fòrum",
"Total replies" => "Respostes totals",
"Average number of replies per topic" => "Nombre mitjà de respostes per tema",
"Visits to forums" => "Visites als fòrums",
"Blog Stats" => "Estadístiques dels Blocs web",
"Weblogs" => "Blocs Web",
"Total posts" => "Publicacions totals",
"Average posts per weblog" => "Promig d'enviaments per bitàcola web",
"Total size of blog posts" => "Mida total de les publicacions per bloc web",
"Average posts size" => "Mida mitjana d'una publicació",
"Visits to weblogs" => "Visites als blocs web",
"Poll Stats" => "Estadístiques de sondejos",
"Total votes" => "Vots totals",
"Average votes per poll" => "Mitjana de vots per sondeig",
"FAQ Stats" => "FAQ Estadístiques",
"Total questions" => "Preguntes en total",
"Average questions per FAQ" => "Mitjana de preguntes per PUF",
"User Stats" => "Estadístiques d'usuaris",
"Average bookmarks per user" => "Mitjana d'enllaços d'interès per usuari",
"Average questions per quiz" => "Mitjana de preguntes per Test",
"Quizzes taken" => "Qüestionaris presos",
"Average quiz score" => "Puntuació mitjana de tests",
"Average time per quiz" => "Temps mitjà per test",
"Most viewed objects in period" => "Majoria dels objectes vistos en el període",
"{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
"{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Gràfica d'ús",
"Usage chart image" => "Emprar imatge de gràfic",
"Daily Usage" => "Ús diari",
// "Piwik Analytics Dashboard" => "Piwik Analytics Dashboard",
// "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard" => "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard",
"Stats for surveys" => "Estadístiques per enquestes",
"Last taken" => "Darrer pres",
"Stats for survey" => "Estadístiques per enquesta",
// "Select a user to preview its answer (marked as" => "Select a user to preview its answer (marked as",
// "User voted" => "User voted",
// "Select User" => "Select User",
// "no answer" => "no answer",
"Tiki Logs" => "Tiki Logs",
"Export through Action Log" => "Exporta a través de Registre d'Accions",
"Clean logs older than" => "Esborra els registres més antics de",
// "Are you sure you want to revert" => "Are you sure you want to revert",
// "Revert" => "Revert",
"Time Left" => "Temps Restant",
"Send Answers" => "Envia respostes",
"Thank you for your submission" => "Gràcies pel teu enviament",
"Send a link to a friend" => "Envia un enllaç a un amic/ga",
"Your email was sent" => "El teu correu-e ha estat enviat",
"The link was sent to the following addresses:" => "S'ha enviat l'enllaç a les següents adreces:",
"Friend's email" => "Email del amic",
"Your comment" => "El teu comentari",
"I found an interesting page that I thought you would like" => "He trobat una pàgina interessant que he pensat que et podria agradar",
"TikiTests Edit" => "TikiTests Edit",
"Summary mode" => "Mode de resum",
"Show Page Differences" => "Mostra diferència pàgina",
"Show Tidy Errors and Warnings" => "Mostrar errors Tidy i advertències",
"Show POST Data" => "Mostra dades POST",
"Use Current Session/Log out" => "Utilitza sessió actual / Desconnexió",
"Recorded Links" => "Enllaços gravats",
"Element to compare (Xpath expression)" => "Element per comparar (Xpath expressió)",
"Test Xpath Expression" => "Prova d'Expressió XPath",
"Post Variables" => "Publiqui Variables",
"Tidy Results" => "Resultats Tidy",
"Delete this link" => "Eliminar aquest enllaç",
"TikiTests List" => "Llista TikiTests",
"Config" => "Configuració",
"Replay" => "Replay",
"Tidy extension not present" => "Extensió Tidy no està present",
"PECL HTTP extension present" => "PECL HTTP extensió actual",
"cURL extension present" => "cURL extensió actual",
"PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP i extensió cURL no està present. Repetició de la TikiTest no serà possible",
"List TikiTests" => "Llista TikiTests",
"Create a TikiTest" => "Crear un TikiTest",
"Replay the TikiTest" => "Repetir l'TikiTest",
"Edit the TikiTest" => "Editeu el TikiTest",
"TikiTests Record Configuration" => "TikiTests Configuració de gravació",
"Start Recording Test" => "Inicia prova de gravació",
"TikiTests Replay Configuration" => "TikiTests Configuració de reproducció",
"Failure" => "Fallada",
"Reference" => "Referència",
"The pages are different" => "Les pàgines són diferents",
"The pages are identical" => "Les pàgines són idèntics",
"Recording to pause press the pause button" => "Gravació en pausa, premeu el botó de pausa",
"Pause the recording" => "Pausa l'enregistrament",
"Paused to resume press the play button" => "Pausa per reprendre, premeu el botó de reproducció",
"Resume the recording" => "Reprendre l'enregistrament",
"Stop the recording" => "Aturar la gravació",
"Control by Objects" => "Control per objectes",
"Control by Sections" => "Control per Seccions",
"Assign themes to categories" => "Assigna themes a categories",
"Assigned categories" => "Categories assignades",
// "Delete selected" => "Delete selected",
"Control by Categories" => "Control per Categories",
"Assign themes to objects" => "Assignar aspectes als objectes",
"Assigned objects" => "Objectes Assignats",
"Assign themes to sections" => "Assignar aspectes a les seccions",
"Assigned sections" => "Seccions Assignades",
// "Timesheets" => "Timesheets",
"Apply the following profile for enhancements: " => "Aplica el següent perfil de configuració per a millores: ",
"Time Tracker" => "Formulari-bd de Temps",
"Local Cache (Not Committed)" => "En memòria cau local (No Enviades)",
"Saved (Committed)" => "Desades (Enviades)",
"New task" => "Nova",
"Toggle completed" => "Intercanvia les completades",
"Toggle archived" => "Intercanvia les arxivades",
"Task name" => "Nom de la tasca",
"Estimate (in min.)" => "Estimació (en min.)",
"Estimate" => "Estimació",
"Task is completed" => "Tasca completada",
"Task is archived" => "Tasca arxivada",
"Created at" => "Creat/da el",
"Are you sure you want to delete all tasks" => "Segur que vols esborrar totes les tasques",
"Commit Time Sheet Items" => "Envia els ítems del full de temps",
"View All" => "Visualitza'ls tots",
"View My Items" => "Visualitza els meus ítems",
"Summary" => "Resum",
"Time Spent" => "Temps invertit",
"Done By" => "Fet per",
"Add Tracker" => "Afegeix formulari-bd",
"Add Tracker To Tracker Report" => "Afegeix formulari-bd a l'Informe de Formularis-bd",
"View Tracker Report" => "Veure Informe de Formulari-bd",
"Pick tracker to join" => "Tria formulari-bd a unir",
"Pick fields to join on" => "Tria els camps per a la unió",
"Join inner" => "Unió per l'interior",
"Join outer" => "Unió per l'exterior",
"Tracker - Open" => "Formulari-bd (Tracker) - Obert",
"Tracker - Pending" => "Formulari-bd (Tracker) - Pendent",
"Tracker - Closed" => "Formulari-bd (Tracker) - Tancat",
"Tracker Item History" => "Historial de l'Item del Formulari-bd",
"View Tracker Item" => "Veure Ítem del Formulari-bd",
"Not logging" => "No accedir",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable",
"Old" => "Vell/a",
"Edit File:" => "Edita l'Arxiu:",
"Advanced mode" => "Mode avançat",
"Simple mode" => "Mode senzill",
"Retry" => "Intenta de nou",
"Additional Info" => "Informació adicional",
"Syntax Tips" => "Consells de sintaxi",
// "Download link using Tiki syntax" => "Download link using Tiki syntax",
// "Display an image using Tiki syntax" => "Display an image using Tiki syntax",
// "Use as a thumbnail with ShadowBox" => "Use as a thumbnail with ShadowBox",
// "Download link using HTML" => "Download link using HTML",
"You locked the file" => "Has bloquejat l'arxiu",
"The file has been locked by {\$fileInfo.lockedby}" => "L'arxiu està bloquejat per {\$fileInfo.lockedby}",
"File title" => "Títol de l'arxiu",
"required field for podcasts" => "els podcasts requereixen aquest camp",
"File description" => "Descripció de l'arxiu",
// "Re-upload from disk" => "Re-upload from disk",
// "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>" => "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>",
// "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
"Unzip zip files" => "Descomprimeix els arxius zip",
"File can be deleted after" => "Es pot esborrar l'arxiu després",
// "OCR files if supported" => "OCR files if supported",
"Creator of file, if different from the 'Uploaded by' user" => "Creador de l'arxiu, si és diferent de l'usuari que ha pujat l'arxiu",
// "File Type" => "File Type",
// "No type" => "No type",
"Maximum number of downloads" => "El nombre màxim de descàrregues",
"-1 for no limit" => "-1 per ilimitat",
"Upload File(s)" => "Puja Arxiu(s)",
"Add Another File" => "Afegeix un altre arxiu",
"Maximum file size is around" => "La mida màxima de l'arxiu és al voltant de",
"Note: You are running IIS" => "Nota: Està executant IIS",
"maxAllowedContentLength also limits upload size" => "maxAllowedContentLength també limita la mida de càrrega",
"Please check web.config in the Tiki root folder" => "Comprovar web.config a la carpeta arrel Tiki favor",
"Uploading file.." => "Pujant l'arxiu..",
"No File to Upload.." => "No hi ha cap arxiu per pujar..",
// "Keeps a reference to the remote file" => "Keeps a reference to the remote file",
// "Video file uploaded" => "Video file uploaded",
"Link to file from a Wiki page" => "Enllaç a l'arxiu des d'una pàgina Wiki",
"For image files" => "Per a arxius d'imatge",
"Display full size" => "Veure a mida completa",
"Display thumbnail that enlarges" => "Mostra un contacte que s'engrandeix en fer clic a sobre",
"Batch Upload Results" => "Pujada en bloc: Resultats",
"Upload successful!" => "Pujada amb èxit!",
"The following image was successfully uploaded" => "La següent imatge s'ha pujat correctament",
"Image ID thumb" => "Diapositiva de la Imatge ID",
"You can view this image in your browser using" => "Pots visualitzar aquesta imatge en el vostre cercador emprant",
"You can include the image in an Wiki page using" => "Pots incloure la imatge a una pàgina wiki emprant",
"or use filename" => "o utilitza el nom del fitxer",
"Now enter the image URL" => "Introduïu ara la URL de la imatge",
"or upload a local image from your disk" => "o puja una imatge local des del teu disc",
"Batch Upload" => "Puja al rerafons",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatures (opcional, impedeix que es generin contactes pel sistema)",
"Upload From Disk:" => "Puja des de Disc:",
"No gallery available" => "No hi ha galeria disponible",
"You have to create a gallery first!" => "Has de crear una galeria primer!",
"User assigned modules" => "Mòduls assignats per l'usuari",
// "to assign modules, which will make them available for creating a custom order on this page" => "to assign modules, which will make them available for creating a custom order on this page",
"Restore defaults" => "Recupera predeterminats",
"The column is disabled" => "La columna està desactivada",
"#" => "#",
"Move module up" => "Pujar mòdul",
"Move module down" => "Baixar mòdul",
// "Move to right side" => "Move to right side",
// "Move to left side" => "Move to left side",
"Assign module" => "Assigna mòdul",
"top" => "A dalt de tot",
"Current folder" => "Carpeta actual",
"Folders" => "Carpetes",
"Folder in" => "En la carpeta",
// "Refresh cache" => "Refresh cache",
"Admin folders and bookmarks" => "Administració de carpetes i adreces d'interès",
"a folder" => "una carpeta",
"a bookmark" => "un marcador",
"User Contacts Preferences" => "Contactes Preferències d'Usuari",
"Change preferences" => "Canviar preferències",
"Manage Fields" => "Gestiona els camps",
"{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{\$chdata.name}" => "{\$chdata.name}",
"Send me a message" => "Envia'm un missatge",
"Basic Data" => "Dades bàsiques",
// "Assign group" => "Assign group",
"Assign Group" => "Assignar Grup",
"User Icon" => "Icona d'usuari",
"{\$gender}" => "{\$gender}",
"(non public)" => "(no públic)",
"{\$country|stringfix}" => "{\$country|stringfix}",
"User's homepage" => "Pàgina d'inici de l'usuari",
"Personal Wiki Page" => "Pàgina Wiki Personal",
// "Your relationship with other users" => "Your relationship with other users",
// "Relationship of this user to you" => "Relationship of this user to you",
"The user has chosen to make his information private" => "L'usuari ha escollit convertir la seva informació en privada",
"Additional Information" => "Informació adicional",
"Change user information" => "Canvieu la informació de l'usuari",
"User Contribution" => "Contribucions d'usuari",
"has contributed to the following content" => "ha contribuït al següent contingut",
"has not contributed to any content yet" => "No ha contribuït amb cap contingut encara",
"Blogs Posts" => "Blocs Missatges",
"Forum comments" => "Comentaris del Fòrum",
"Forum topics" => "Tòpics del Fòrum",
"Who Looks at Items?" => "Qui mira les coses?",
"Who Looks at Your Items?" => "Qui mira les meves coses?",
"Who Looks at His or Her Items" => "Qui mira les teves coses",
"Send Me A Message" => "Envia'm un missatge",
"Send me a message !" => "Envia'm un missatge !",
"The following message will be sent to user" => "El següent missatge serà enviat a l'usuari",
"Message Body" => "Cos del missatge",
// "My Mail-in" => "My Mail-in",
// "Are you sure you want to delete the routing rule" => "Are you sure you want to delete the routing rule",
// "Configure how your mailed-in wiki pages are to be linked / organized" => "Configure how your mailed-in wiki pages are to be linked / organized",
// "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked" => "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked",
// "Only newly created pages, using the mail-in wiki-put function, are affected" => "Only newly created pages, using the mail-in wiki-put function, are affected",
// "Go to wiki structure setting" => "Go to wiki structure setting",
"Toggle options" => "Opcions de commutació",
"Male" => "Home",
"Female" => "Dona",
// "Your Personal Wiki Page" => "Your Personal Wiki Page",
"User's personal tracker information" => "Informació personal de l'usuari a la base de dades (tracker)",
"View extra information" => "Visualitza informació extra",
"Your personal tracker information" => "Informació del teu formulari-bd personal",
// "Is email public" => "Is email public",
"Unavailable - please set your email below" => "No disponible - si us plau, posa el teu correu-e a sota",
// "Preferred perspective" => "Preferred perspective",
// "Email character set" => "Email character set",
// "Admin Language" => "Admin Language",
"Can you read more languages?" => "Pots llegir més idiomes?",
// "Other languages you can read" => "Other languages you can read",
"Select language..." => "Selecciona l'idioma...",
// "Select from the dropdown to add automatically to the list below" => "Select from the dropdown to add automatically to the list below",
// "Displayed timezone" => "Displayed timezone",
"Detect user time zone if browser allows, otherwise site default" => "Detecta la zona horària de l'usuari si el navegador ho permet, d'altra forma, per defecte del lloc",
// "Site time zone <strong>%0</strong> is enforced and overrides user preferences" => "Site time zone <strong>%0</strong> is enforced and overrides user preferences",
"Use 12-hour clock in time selectors" => "Empra rellotge de 12-hores en selectors de temps",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Mostra requadre d'informació en passar el ratolí per sobre per a cada usuari que permet que la seva informació sigui pública",
"User Messages" => "Missatges d'usuari",
"Notify sender when reading his mail" => "Avisa l'autor quan llegiu el seu missatge",
// "Message priority notification" => "Message priority notification",
// "Read message auto-archiving" => "Read message auto-archiving",
"never" => "mai",
// "Auto-archive read messages after selected days" => "Auto-archive read messages after selected days",
"User Tasks" => "Tasques d'usuari",
// "XMPP account JID" => "XMPP account JID",
// "If empty, Tiki will provide default value" => "If empty, Tiki will provide default value",
// "You have to provide this when using custom XMPP server" => "You have to provide this when using custom XMPP server",
"My user items" => "Els meus ítems d'usuari",
// "My articles" => "My articles",
"My level" => "El meu nivell",
// "Remember which remarksbox (alert box) you have closed and don't show them again" => "Remember which remarksbox (alert box) you have closed and don't show them again",
"Reset remark boxes visibility" => "Torna a especificar la visibilitat dels requadres destacats",
"This will reset the visibility of all the tips, notices and warning remarks boxes you have closed" => "Això tornarà a posar a punt la visibilitat de tots els requadres destacats de pistes, indicacions i avisos que has tancat",
"Account Information" => "Informació del compte",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deixa els camps \"Contrasenya nova\" i \"Confirma contrasenya nova\" en blanc per mantenir la contrasenya actual",
"Current password (required)" => "Contrasenya actual (requerida)",
"Account Deletion" => "Esborrat del compte",
"Are you really sure you want to delete the account %0" => "Estàs segur realment de voler esborrar el compte %0",
"Check this box if you really want to delete the account" => "Marca aquesta casella si vols esborrar realment el compte",
"Delete the account" => "Esborra el compte",
"Delete my account" => "Esborra el meu compte",
"Task list" => "Llista de tasques",
"Admin mode off" => "Mode Administrador inactiu",
"Admin mode on" => "Mode Administrador activat",
"Task help" => "Ajuda de tasques",
"Empty Trash" => "Buida paperea",
"Task received" => "Tasca rebre",
"You received this task" => "Has rebut aquesta tasca",
"Task sent" => "Tasca enviada",
"You sent this task to another user" => "Tu vas enviar a aquesta tasca a un altre usuari",
"Task shared by a group" => "Tasca compartida per un grup de",
"Task is shared by a group" => "La tasca és compartida per un grup de",
"Accepted by task user and creator" => "Acceptada per l'usuari i creador de la tasca",
"Task has been accepted by user and creator" => "La tasca ha estat acceptat per l'usuari i creador",
"Rejected by a user" => "Rebutjat per l'usuari",
"Task has been rejected by a user" => "La tasca ha estat rebutjada per un usuari",
"Waiting for me" => "Esperant que jo",
"Task has not yet been accepted or rejected by you" => "La tasca encara no ha estat acceptada o rebutjada per tu",
"Waiting for other user" => "Esperant un altre usuari",
"Task has not yet been accepted or rejected by another user" => "La tasca encara no ha estat acceptada o rebutjada per un altre usuari",
"Admin Mode" => "Mode administrador",
"Edit Task" => "Edita la tasca",
"NOT accept" => "NO acceptis",
"Remove from Trash" => "Elimina de la paperera",
"Move to trash" => "Mou a la paperera",
"Move to Trash" => "Mou a la paperera",
"Task saved" => "Tasca guardada",
"View Task" => "Mostra la tasca",
"Open a new task" => "Obre una nova tasca",
"Last Version" => "última versió",
"taskId" => "IdTasca",
"Task user" => "Usuari de la tasca",
"Only the creator can delete this task" => "Només el creador pot esborrar aquesta tasca",
"Use start date and time" => "Empra data i hora d'inici",
"Use end date and time" => "Empra data i hora de finalització",
"Open / In Process" => "Oberta / en procés",
"Waiting / Not Started" => "En espera / no iniciada",
"Percentage completed" => "Percentatge completat",
"Waiting" => "Esperant",
"Shared for Group" => "Compartida per al group",
"Accepted by User" => "Acceptada per l'usuari/a",
"No / Rejected" => "No / rebutjada",
"Accepted by Creator" => "Acceptada pel creador",
"This message will be send to users if you are makeing changes of assigned tasks" => "Aquest missatge serà enviat als usuaris si fas canvis a tasques assignades",
"Send a message with changes" => "Envia missatge amb canvis",
"Modified by" => "Modificada per",
"Marked as deleted" => "Marcat com a eliminat",
"Inform task user by email" => "Informa a l'usuari de la tasca per correu-e",
"Reload" => "Recarrega",
"You can only view this task" => "Pots veure només aquesta tasca",
"In the trash" => "En les escombraries",
"Not Accepted by One User" => "No acceptada per un/a usuari/a",
"Not Accepted User" => "Usuari no acceptat",
"No tasks entered" => "No hi ha cap tasca",
"Select One" => "Selecciona un/a",
"Trash" => "Brossa",
"Undo Trash" => "Desfés paperera",
"Show:" => "Mostra:",
"Received" => "Rebut/da",
"Submitted" => "Enviat/da",
"Shared" => "Compartit/da",
"All Shared Tasks" => "Totes les tasques compartides",
// "Previous version" => "Previous version",
// "Next version" => "Next version",
"completed (100%)" => "completat/da (100%)",
"Public for group" => "Pública per al grup",
// "Wikis" => "Wikis",
// "Forum Threads" => "Forum Threads",
// "{\$userinfo['user_country']|stringfix}" => "{\$userinfo['user_country']|stringfix}",
// "{\$userinfo['user_gender']}" => "{\$userinfo['user_gender']}",
// "This user has contributed to the following wiki pages" => "This user has contributed to the following wiki pages",
// "This user has not contributed to any wiki pages yet" => "This user has not contributed to any wiki pages yet",
// "This user has not contributed any blog posts yet" => "This user has not contributed any blog posts yet",
// "This user has contributed to the following tracker items" => "This user has contributed to the following tracker items",
// "This user has not contributed to any tracker items yet" => "This user has not contributed to any tracker items yet",
// "This user has contributed to the following articles" => "This user has contributed to the following articles",
// "This user has not contributed to any articles yet" => "This user has not contributed to any articles yet",
// "This user has started to the following forum threads" => "This user has started to the following forum threads",
// "This user has not contributed to any forums yet" => "This user has not contributed to any forums yet",
// "Add to Network" => "Add to Network",
// "Remove from Network" => "Remove from Network",
"User Watches and preferences" => "Subscripcions d'usuari i preferències",
"You need to set your email to receive email notifications" => "Cal configurar el seu correu electrònic per rebre notificacions per correu electrònic",
"Use reports to summarise notifications about objects you are watching." => "Empra resums periòdics de notificacions de canvis als objectes que estàs seguint",
"Use reports" => "Empra resums periòdics",
// "Reporting interval" => "Reporting interval",
"Every minute" => "Cada minut",
"Hourly" => "Cada hora",
"Monthly" => "Mensual",
// "Report length" => "Report length",
"Short report" => "Informe breu",
"Detailed report" => "Informe detallat",
// "Report format" => "Report format",
// "Send report even if no activity" => "Send report even if no activity",
"My watches" => "Els meus seguiments",
"Use \"watches\" to monitor wiki pages or other objects." => "Fes servir els \"seguiments\" per vigilar pàgines wiki o altres objectes.",
// "Watch new items by clicking the {icon name='watch'} button on specific pages" => "Watch new items by clicking the {icon name='watch'} button on specific pages",
"Add Watch" => "Afegeix avís",
"Select event type" => "Selecciona tipus d'esdeveniment",
"All watched events" => "Tots els esdeveniments vigilats",
"A user submits a blog post" => "Un usuari envia una publicació de bloc",
"A user posts a forum thread" => "Una persona usuària publica un fil de discussió del fòrum",
"A user posts a forum topic" => "Una persona usuària publica un topic del fòrum",
"A user edited or commented on a wiki page" => "Un usuari editar o comentat en una pàgina wiki",
"A user edited a wiki page" => "Un usuari edita una pàgina wiki",
"{\$w.type}" => "{\$w.type}",
"Use this form to control notifications about objects you are watching" => "Utilitza aquest formulari per controlar les notificacions sobre els objectes que està veient",
// "Send notification when I am the editor" => "Send notification when I am the editor",
"Used space" => "Espai utilitzat",
"up to" => "fins",
"no limit for admin" => "hi ha un límit per al admin",
"User Menu" => "Menú d'Usuari",
"May need to refresh twice to see changes" => "Es necessita actualitzar dos cops per tal de veure els canvis",
"Add top level bookmarks to menu" => "Afegeix els millors favorits al menú",
"Add or edit an item" => "Afegeix o edita un ítem",
"New Window" => "Nova finestra",
"replace window" => "reemplaçar la finestra",
"Delete Selected" => "Esborrar seleccionats",
"Pos" => "Pos",
"User_versions_for" => "Versions de l'usuari per a",
// "Monitor articles" => "Monitor articles",
// "Stop monitoring articles" => "Stop monitoring articles",
"{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
// "\"}Actions for %0" => "\"}Actions for %0",
"No articles yet" => "Sense articles encara",
"New article" => "Nou article",
"Banner stats" => "Pancarta: estadístiques",
"Create new banner" => "Crea un nou banner",
"Banner Information" => "Informació de la Pancarta",
"Click ratio" => "Taxa de clicks",
"Weekdays" => "Dies de la setmana",
"mon" => "dl",
"tue" => "dm",
"wed" => "dc",
"thu" => "dj",
"fri" => "dv",
"sat" => "ds",
"sun" => "dg",
"Banner raw data" => "Dades en brut del bànner",
"Cached" => "Carregat en memòria cau",
"This is a cached version of the page." => "Aquesta és una versió en memòria cau de la pàgina",
"Click here to view the Google cache of the page instead." => "Cliqueu aquí per veure la memòria cau Google de la pàgina.",
"{\$faq_info.title}" => "{\$faq_info.title}",
"There are no questions in this FAQ" => "No hi ha preguntes en aquest FAQ",
"Answers" => "Respostes",
"Add Suggestion" => "Afegeix un suggeriment",
"Edit Forum" => "Editar fòrum",
"Forum List" => "Llista de fòrums",
// "Forum actions" => "Forum actions",
// "Monitor topics" => "Monitor topics",
// "Stop monitoring topics" => "Stop monitoring topics",
// "Monitor topics and threads" => "Monitor topics and threads",
// "Stop monitoring topics and threads" => "Stop monitoring topics and threads",
// "Group monitor topics" => "Group monitor topics",
// "Group monitor topics and threads" => "Group monitor topics and threads",
"Post New" => "Publica'n una de nova",
"Deliberation" => "Deliberació",
"Add Deliberation Item" => "Afegir Deliberació article",
"Watch for replies" => "Vigila per correu-e les respostes",
"Send me an email when someone replies to my topic" => "Envia'm un missatge de correu-e quan algú respongui al meu tòpic",
"Don't send me any emails" => "No m'enviïs missatges de correu-e",
"Enter your name" => "Introdueix el teu nom",
"Editing posts" => "Editant publicacions",
// "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax" => "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax",
// "Moderator actions on selected topics" => "Moderator actions on selected topics",
"Emot" => "Emot",
"Rating <br/>(avg/max)" => "Valoració <br/>(mig/max)",
"Detailed results <br/>(counts)" => "Resultats detallats <br/>(recomptes)",
"Detailed results <br/>(counts/%)" => "Resultats detallats <br/>(recomptes/%)",
"pts" => "pts",
// "Topic locked" => "Topic locked",
// "Forum locked" => "Forum locked",
// "No topics found" => "No topics found",
"posts in this forum" => "publicacions en aquest fòrum",
// "Filter Posts" => "Filter Posts",
"Last post date" => "Data de l'últim missatge",
"All posts" => "Tots els escrits",
"Last hour" => "La última hora",
"Last 24 hours" => "Les últimes 24 hores",
"Last 48 hours" => "Les últimes 48 hores",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "normal",
"announce" => "anunci",
"hot" => "calent",
"Posts with no replies" => "Missatges sense resposta",
"Topic List" => "Llista de temes",
"The post has been reported and will be reviewed by a moderator." => "S'ha informat de la publicació i serà revisada per un moderador.",
// "Previous topic" => "Previous topic",
// "Next topic" => "Next topic",
"You are viewing a reply to" => "Estàs en la resposta a",
// "Thread actions" => "Thread actions",
// "Print this page" => "Print this page",
"Print all pages" => "Imprimeix totes les pàgines",
"Show posts" => "Mostrar publicacions",
"Jump to forum" => "Saltar al fòrum",
"View Invoice" => "Veure Factura",
"Invoice %0" => "Factura %0",
"Date Issued %0" => "Data d'emissió %0",
"Amount: %0" => "Quantitat: %0",
"Payment Terms: %0" => "Condicions de pagament: %0",
// "This sheet is already being edited by %0" => "This sheet is already being edited by %0",
"Back to Page" => "Tornar a la pàgina",
"Tiki Sheet" => "Full Tiki",
"Save current spreadsheet" => "Desa el full de càlcul actual",
"Cancel editing current spreadsheet" => "Cancel editar fulls de càlcul actual",
"No parse" => "No parse",
"What would you like to add" => "Què li agradaria afegir",
"New spreadsheet" => "Nou full de càlcul",
"Existing spreadsheet" => "Full de càlcul existent",
"Tracker as a spreadsheet" => "Formulari-bd com un full de càlcul",
"Spreadsheet from file gallery" => "Full de càlcul de la galeria arxiu",
"Cell" => "Cèl·lula",
"Set Reference" => "Establir referència",
"Un-Merge" => "Un-Merge",
"Adds an additional row to bottom of the spreadsheet" => "Afegeix una fila addicional a la part inferior del full de càlcul",
"Add Row" => "Afegeix Fil·la",
"Adds an additional rows to bottom of the spreadsheet" => "Afegeix una fila addicional a la part inferior del full de càlcul",
"Add Multi-Rows" => "Afegeix Múltiples Fil·les",
"Delets the current row thats highlighted" => "Esborra les files actuals que són destacades",
"Delete Row" => "Esborra Fil·la",
"Inserts an additional row after currently selected row" => "Insereix una fila addicional després de la fila actualment seleccionada",
"Insert Row Before" => "Insereix fila abans",
"Insert Row After" => "Insereix fila Després",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Mostrar Tot",
"Hides or shows the currently selected row" => "Oculta o mostra la fila actualment seleccionada",
"Toggle Hide Row" => "Activar Amaga Row",
"Adds an additional column to the right of the spreadsheet" => "Afegeix una columna addicional a la dreta del full de càlcul",
"Add Column" => "Afegeix Columna",
"Adds an additional columns to the right of the spreadsheet" => "Afegeix 01:00 columnes addicionals a la dreta del full de càlcul",
"Add Multi-Columns" => "Afegeix Múltiples Columnes",
"Deletes the current column thats highlighted" => "Elimina les columnes això és actual seleccionat",
"Delete Column" => "Esborra Columna",
"Inserts an additional column after currently selected column" => "Insereix una columna addicional després d'aquesta columna",
"Insert Column Before" => "Insereix columna a l'esquerra",
"Insert Column After" => "Insereix columna",
"Fill down current cell value" => "Ompliu per valor de la cel·la actual",
"Fill Down" => "Omplir cap avall",
"Fill up current cell value" => "Omplir valor de la cel·la",
"Fill Up" => "Omplir",
// "Unhides all the hidden columns" => "Unhides all the hidden columns",
"Hides or shows the currently selected column" => "Oculta o mostra la columna seleccionada",
"Toggle Hide Column" => "Activar Amaga columna",
"Add new spreadsheet" => "Afegir nou full de càlcul",
"Add Spreadsheet" => "Afegir el full de càlcul",
"Delete the current spreadsheet" => "Eliminar el full de càlcul actual",
"Delete Spreadsheet" => "Eliminar fulls de càlcul",
"Recompiles the current sheet" => "Torna a compilar el full actual",
"Change the title of the sheet" => "Canviar el títol del full",
"Wrap Cell Range" => "Rang de cel Wrap",
"Wrap with SUM" => "Emboliqui amb SUM",
"Wrap with CEILING" => "Emboliqui amb SOSTRE",
"Wrap with COUNT" => "Emboliqui amb COUNT",
"Wrap with MAX" => "Emboliqui amb MAX",
"Wrap with MIN" => "Emboliqui amb MIN",
"Redo" => "Refer",
"Toggle State" => "Estat Toggle",
"Function Reference" => "Referència de funcions",
"Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Exemple d'ús: =SUM(SUM(A1:B1) + SUM(D7))",
"=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
"Returns the absolute value of a number" => "Retorna el valor absolut d'un nombre",
"Returns a rounded number" => "Retorna un nombre arrodonit",
"Returns a number rounded up based on a multiple of significance" => "Retorna un nombre arrodonit en base a un múltiple d'importància",
"Counts the number of cells that contain a value" => "Compta el nombre de cel·les que contenen un valor",
"Counts full days from a specific date - format(YYYY,MM,DD)" => "Compta els dies complets des de la data - format (AAAA, MM, DD)",
"Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converteix un nombre a text, utilitzant un format de moneda - Opcions (nombre, decimals, símbol)",
"Returns a logical value of FALSE" => "Retorna un valor lògic FALS",
"Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Retorna una representació de text d'un nombre arrodonit a un nombre especificat de decimals - Opcions (nombre, decimals, useCommas)",
"Returns a number rounded down based on a multiple of significance" => "Retorna un nombre arrodonit a la baixa sobre la base d'un múltiple d'importància",
"Returns the integer portion of a number" => "Retorna la part entera d'un nombre",
"Returns the largest value from the numbers provided" => "Retorna el valor màxim dels nombres sempre",
"Returns the smallest value from the numbers provided" => "Retorna el valor més petit dels números proporcionats",
"Converts a value to a number" => "Converteix un valor en un nombre",
"Gets full date of today" => "Obté la data completa d'avui",
"Returns the mathematical constant called pi, which is 3.14159265358979" => "Retorna la constant matemàtica pi trucada, que és 3.14159265358979",
"Returns the result of a number raised to a given power" => "Retorna el resultat d'un nombre elevat a una potència donada",
"Returns a random number that is greater than or equal to 0 and less than 1" => "Retorna un nombre aleatori que és més gran que o igual a 0 i menor que 1",
"Returns a number rounded to a specified number of digits" => "Retorna un nombre arrodonit a un nombre especificat de dígits",
"Returns all of the values in each of the specified cells and added together" => "Retorna tots els valors en cadascuna de les cel·les especificades i se sumarà",
"Returns a logical value of TRUE" => "Retorna un valor lògic VERITABLE",
"Converts a text value that represents a number to a number" => "Converteix un valor de text que representa un número a un nombre",
"Italics" => "Cursiva",
"Uppercase" => "Majúscules",
"Capitalize" => "Capitalitzar",
"Lowercase" => "Minúscules",
"Font Size +" => "Mida de la lletra +",
"Font Size -" => "Mida de lletra -",
// "{\$tracker_info.name}" => "{\$tracker_info.name}",
// "Tracker actions" => "Tracker actions",
// "Group Monitoring" => "Group Monitoring",
// "Stop Watching" => "Stop Watching",
"atts" => "adjunts",
"List Attachments" => "Llista els Deures",
"View/Edit" => "Veure / Canviar",
"Insert New Item" => "Inserta un nou ítem",
"View inserted item" => "Mostra el registre insertat",
"Insert new item" => "Inserta un nou ítem",
"Synchronization" => "Sincronització",
"This tracker is a remote copy of <a href=\"%0\">%0</a>" => "Aquest formulari-bd és una còpia remota de <a href=\"%0\">%0</a>",
"It was last updated on %0" => "Es va actualitzar per última vegada el %0",
"Reload field definitions" => "Actualitzar definicions de camp",
"Items added locally" => "Els productes afegits a nivell local",
"Push new items" => "Empeny nous ítems",
"Safe modifications (no remote conflict)" => "Modificacions assegurances (no hi ha conflicte a distància)",
"Dangerous modifications (remote conflict)" => "Modificacions perilloses (conflicte a distància)",
"On push, local items will be removed until data reload" => "L'empenta, s'eliminaran els elements locals fins que les dades recàrrega",
"Push local changes" => "Premeu canvis locals",
"Local changes will be lost" => "Es perdran els canvis locals",
"When reloading the data from the source, all local changes will be lost" => "En tornar a carregar les dades de la font, es perdran tots els canvis locals",
"New items that must be preserved should be pushed using the above controls" => "Nous elements que han de ser preservats han de ser empeses amb els controls anteriors",
"Modifications that must be preserved should be replicated" => "Modificacions que han de ser preservats han de ser replicats",
"Without conflicts: Using the above controls" => "Sense conflictes: L'ús dels controls anteriors",
"With conflicts: Manually on the source" => "Amb conflictes: manual de la font",
"Using the above controls will cause information loss" => "Ús dels controls anteriors causarà la pèrdua d'informació",
"Reload data from source" => "Actualitzar les dades de la font",
// "Tracker item actions" => "Tracker item actions",
"Move to another tracker" => "Mou a un altre formulari-bd",
// "Save Returning to Item List" => "Save Returning to Item List",
// "Save and Comment" => "Save and Comment",
"Special Operations" => "Operacions especials",
"close" => "tanca",
"Open Tiki WebDAV (Wiki pages) as WebFolder" => "Obrir Tiki WebDAV (pàgines Wiki) com WebFolder",
"Open Tiki WebDAV as WebFolder" => "Obrir Tiki WebDAV com WebFolder",
"Parent page" => "Pàgina filial",
// "Manage Stucture" => "Manage Stucture",
"Child" => "Filla",
"page id" => "id de pàgina",
// "Please wait" => "Please wait",
// " The PDF is being prepared, please wait.." => " The PDF is being prepared, please wait..",
// "Show structure" => "Show structure",
// "Hide structure bar and any toc" => "Hide structure bar and any toc",
"Hide structure" => "Amaga estructura",
// "Page actions" => "Page actions",
// " PDF" => " PDF",
// "Warning:mPDF Package Missing" => "Warning:mPDF Package Missing",
// "Click to toggle on/off" => "Click to toggle on/off",
// "Edit icons" => "Edit icons",
"Wysiwyg" => "Wysiwyg (Editor Visual)",
// "Send link" => "Send link",
// "Monitor page" => "Monitor page",
// "Stop monitoring page" => "Stop monitoring page",
// "Monitor sub-structure" => "Monitor sub-structure",
// "Stop monitoring sub-structure" => "Stop monitoring sub-structure",
// "Group monitor structure" => "Group monitor structure",
"Profiles Wizard" => "Assistent de Perfils",
"Changes Wizard" => "Assistent d'Actualització",
// "Configuration Wizard" => "Configuration Wizard",
"steps" => "passos",
"User Wizard" => "Assistent d'Usuaris",
"Wizard Steps" => "Passos de l'Assistent",
// "Change Theme" => "Change Theme",
// "Change Transition" => "Change Transition",
// "Convex" => "Convex",
// "Concave" => "Concave",
// " Handouts" => " Handouts",
// "Exit Slideshow" => "Exit Slideshow",
"More types available" => "Més tipus disponibles",
// "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>",
"Description contains wiki syntax" => "La descripció contè sintaxi wiki",
"Restrict visibility to administrators" => "Restringir la visibilitat als administradors",
"Useful if you are working on a live tracker" => "Útil si estàs treballant en un un formulari-bd en viu",
"Add Field &amp; Edit Advanced Options" => "Afegeix un camp &amp; Edita les Opcions Avançades",
// "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)" => "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)",
// "Clear All" => "Clear All",
"Options for %0" => "Opcions per a %0",
"Separate multiple with commas" => "Separa mutiples valors amb comes",
// "Separate multiple with &quot;{\$def.separator}&quot" => "Separate multiple with &quot;{\$def.separator}&quot",
"Error Message" => "Missatge d'error",
"Visible by all" => "Visible per tothom",
"Visible by all but not in RSS feeds" => "Visible per tots, però no en els canals RSS",
"Visible after creation by administrators only" => "Visible després de la creació només per les persones administradores",
"Editable by administrators only" => "Editable només pels administradors",
// "Editable after creation by administrators only" => "Editable after creation by administrators only",
"Editable by administrators and creator only" => "Editable només pels administradors i pel creador",
"Immutable after creation" => "Immutable després de la creació",
"Creator requires a user field with auto-assign to creator (1)" => "La opció del Creador requereix un camp d'usuari autoassignat al creador (1)",
"Visible by" => "Visible per",
// "List of Group names with permission to see this field" => "List of Group names with permission to see this field",
// "Separated by comma (,)" => "Separated by comma (,)",
"Editable by" => "Editable per",
// "List of Group names with permission to edit this field" => "List of Group names with permission to edit this field",
"Changing the permanent name may have consequences in integrated systems" => "Canviar el nom permanent pot tenir conseqüències en els sistemes integrats",
"Changing the field type may cause irretrievable data loss - use with caution" => "Canviar el tipus de camp pot causar una pèrdua irremediable de dades - empra-ho amb precaució",
// "Make sure you rebuild the search index if you change field type" => "Make sure you rebuild the search index if you change field type",
// "Deprecated" => "Deprecated",
// "To export tracker or tracker items please" => "To export tracker or tracker items please",
// "enable" => "enable",
// "and use" => "and use",
// "Tracker Tabular" => "Tracker Tabular",
// "It is easy to use, optimised and far more powerful" => "It is easy to use, optimised and far more powerful",
"Export Tracker Items" => "Exporta Ítems del Formulari-bd",
"ISO-8859-1 Latin" => "ISO-8859-1 Latin",
"Delimitor (left)" => "Delimitador (esquerra)",
"Delimitor (right)" => "Delimitador (dreta)",
"Carriage return inside field value" => "Retorn de carro dins del valor d'un camp",
"Export dates as UNIX Timestamps to facilitate importing" => "Exportació dates com marques de temps UNIX per facilitar la importació de",
"Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Exporta es camps de tipus EnllaçaItem (ItemLink) com a itemId de l'ítem enllaçat (per facilitar l'importat posterior)",
"Export country type fields as the system name of the country (to facilitate importing)" => "Camps de tipus dels països d'exportació com el nom del sistema del país (per facilitar la importació)",
"Parse as wiki text" => "Interpreta com a text wiki",
"Generic information" => "Informació genèrica",
"Number of records" => "Nombre de registres",
"First record" => "Primer registre",
"Quick Export" => "Exportació Ràpida",
"Produce a CSV with basic formatting" => "Produeix un arxiu CSV amb formateig bàsic",
// "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'" => "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'",
"Tracker Export" => "Exporta el Formulari-bd",
// "Copy the definition text above and paste into the Import Structure box for a new tracker" => "Copy the definition text above and paste into the Import Structure box for a new tracker",
"Profile Export" => "Exporta com a Perfil de Configuració",
"Produce YAML for a profile" => "Produeix el codi YAML per a un perfil de configuració",
"Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "ID de l'formulari-bd i de camp relacionats (com els que es fa referència en ItemLink, opcions de camp itemsList, per exemple) no es converteixen actualment referències a objectes del perfil, pel que serà necessari el reemplaçament manual d'",
"For example: \$profileobject:field_ref\$" => "Per exemple: \$profileobject:field_ref\$",
"Export Profile" => "Perfil Exportació",
"Fields Export" => "Exporta",
// "Copy the definition text above and paste into the Import Fields box on a tracker's fields page" => "Copy the definition text above and paste into the Import Fields box on a tracker's fields page",
"YAML Export" => "YAML Exportació",
"Profile for trackerId %0" => "Perfil de trackerId %0",
"Raw data" => "Les dades en brut",
"Preserve tracker ID" => "Preservar formulari-bd ID",
"Use \"Tracker -> Export -> Structure\" to produce this data" => "Utilitza \"Formulari-bd (Tracker) -> Exportar -> Estructura\" per produir aquestes dades",
// "Tracker import completed" => "Tracker import completed",
"Return to Trackers" => "Retorna als Formularis-bd",
"Import fields for this tracker" => "Camps d'importació per a aquest un formulari-bd",
"Raw Fields" => "Camps en brut",
"Preserve Field IDs" => "Manté els IDs dels camps",
"Confirmation" => "Confirmació",
"Imported file '%0'" => "Arxiu importat '%0'",
"Import completed with '%0'" => "Importació completa amb '%0'",
// "To import items into a tracker please" => "To import items into a tracker please",
"The order of the fields does not matter, but you need to add a header with the field names" => "L'ordre dels camps, no importa, però cal afegir una capçalera amb els noms dels camps",
// "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import" => "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import",
"Auto-incremented itemid fields shall be included with no matter what values" => "Itemid camps d'increment automàtic s'inclouran, independentment valors",
// "If you are having problems, try a different line ending for your csv file that matches the server operating system" => "If you are having problems, try a different line ending for your csv file that matches the server operating system",
"UNIX Timestamp" => "Marca de temps UNIX",
"Character encoding" => "Codificació de caràcters",
"Create as new items" => "Creu nous elements",
"Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Data d'actualització lastModif si els articles són actualitzats (actualització d'estat i creat només si els camps s'especifiquen a l'csv)",
// "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance" => "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance",
// "Please note: This is an experimental new feature - work in progress" => "Please note: This is an experimental new feature - work in progress",
"YAML" => "YAML",
// "Create another" => "Create another",
// "Do you really want to remove the \"%0\" tracker" => "Do you really want to remove the \"%0\" tracker",
// "Please note" => "Please note",
// "This tracker, its fields and all of its %0 items will be permanently removed from your system" => "This tracker, its fields and all of its %0 items will be permanently removed from your system",
"Are you sure you want to remove the fields? Data will be lost" => "Estàs segur que desitges eliminar el camp? Les dades es perdran",
"Remove Fields" => "Eliminar camps",
"Return to field administration" => "Tornar a l'administració sobre el terreny",
// "Replacement" => "Replacement",
// "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one" => "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one",
"Description is wiki-parsed" => "La descripció conté sintaxi wiki que s'ha de processar",
// "Field Prefix" => "Field Prefix",
"Allow ratings (deprecated, use rating field)" => "Permetre valoracions (obsolet, utilitzeu el camp valoracions)",
"Rating options" => "Opcions de la Valoracions",
"Show ratings in listing" => "Mostra les valoracions en els llistats",
"Show comments in listing" => "Veure comentaris en el llistat",
"Display last comment author and date" => "Veure autor i data de l'últim comentari",
// "Allow attachments (deprecated, use files field)" => "Allow attachments (deprecated, use files field)",
"Display attachments in listing" => "Veure arxius adjunts en el llistat",
"Attachment attributes (sortable)" => "Atributs Adjunt (ordenable)",
// "Recommended size: 64x64px" => "Recommended size: 64x64px",
"Show status to tracker administrator only" => "Mostra l'estat només als administradors del formulari-bd",
"Show creation date when listing items" => "Mostra la data de creació en mostrar llistes d'ítems",
"Creation date format" => "Format de la Data de creació",
"Show item creator" => "Mostra el creador de l'ítem",
"Show creation date when viewing items" => "Mostra la data de creació en visualitzar ítems individuals",
"Show last modification date when listing items" => "Mostra data d'última modificació en mostrar llistes d'ítems",
"Show item last modifier" => "Mostra l'últim modificador de l'ítem",
"Modification date format" => "Format de la data de modificació",
"Show last modification date when viewing items" => "Mostra l'última data de modificació en visualitzar ítems individuals",
"Hide empty fields from item view" => "Amaga els camps buits de la vista d'ítems individuals",
"List detail popup" => "Detalls desplegables de la llista",
// "Section Format" => "Section Format",
"Section format" => "Format de la Secció",
"Determines how headers will be rendered when using header fields as form section dividers" => "Determina com es representaran les capçaleres utilitzant camps de capçalera com divisors de seccions de formulari",
// "Set to <em>Configured</em> to use the four following fields" => "Set to <em>Configured</em> to use the four following fields",
// "Use Form Classes" => "Use Form Classes",
// "Input Form Classes" => "Input Form Classes",
// "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)" => "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)",
"Template to display an item" => "Plantilla per a mostrar un ítem",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:nomdePagina per a una pàgina wiki o tpl:tplName per a una plantilla",
"Template to edit an item" => "Plantilla per editar un ítem",
"New item status" => "Estat del nou ítem",
"Modified item status" => "Estat de l'ítem modificat",
"No change" => "Cap canvi",
"Default status displayed in list mode" => "Mostrar l'estat per omissió en el mode de llista",
"Copy activity to email" => "Copieu l'activitat al correu electrònic",
"Use simplified email format" => "Empra el format de correu-e simplificat",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "El formulari-bd emprarà el camp de text anomenat Subject si hi ha algun com a subject i emprarà el correu-e de l'usuari com a enviador, o per a usuaris anònims, el camp de correu-e si existeix",
"Publish RSS feed for this tracker" => "Publicar RSS feed per aquest un formulari-bd",
"Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requereix \"RSS per formulari-bd\" que es troba a Admin / RSS",
"(Currently set)" => "(Actualment fixat)",
"(Currently not set)" => "(En l'actualitat no establert)",
"Group alerted on item modification" => "Grup alertat en modificar-se un ítem",
"Allow user selection for small groups" => "Permetre la selecció d'usuari per a grups petits",
"User can see his own items" => "L'usuari pot veure els seus propis elements",
// "The tracker needs a user field with the item-owner activated" => "The tracker needs a user field with the item-owner activated",
"No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user" => "No es necessita cap permís addicional a nivell de permisos de formularis-bd per permetre a l'usuari veure només els seus propis ítems a través el Plugin TrackerList amb el paràmetre view=user",
"Item creator can modify his items" => "El creador de l'ítem pot modificar els seus ítems",
"The tracker needs a user field with the auto-assign activated" => "El formulari-bd necessita un camp d'usuari amb l'auto-assignació activada",
"Item creator can remove his items" => "El creador de l'ítem pot eliminar els seus ítems",
"User can take ownership of item created by anonymous" => "L'usuari pot prendre possessió de l'objecte creat per usuaris anònims",
"Only one item per user or IP" => "Només un ítem per usuari o IP",
"The tracker needs a user or IP address field with the auto-assign set to Creator" => "El formulari-bd té un usuari o un camp d'adreça IP auto-assignada al Creador",
"Members of the creator group can modify items" => "Els membres del grup del creador poden modificar ítems",
"The tracker needs a group field with the auto-assign activated" => "El formulari-bd té un camp de grup que té activada l'auto-assignació",
"Members of the creator group can remove items" => "Els membres del grup creador poden eliminar ítems",
"Restrict non admins to wiki page access only" => "Restringir als no administradors d'accedir-hi només per pàgina wiki",
"Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports" => "Només els usuaris amb permisos d'administració (seguiment tiki_p_admin_trackers) poden utilitzar les interfícies de formularis-bd (tiki-tiki-view_tracker.php i view_tracker_item.php). Això és útil si voleu que els usuaris d'aquests formularis-bd només puguin accedir-hi a través de les pàgines del wiki, on es poden emprar els diferents connectors (plugins) de formularis-bd per a incrustar-hi formularis i informes",
"Creation date constraint" => "Restriccions en la data de creació",
// "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below" => "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below",
"Before" => "Abans de",
"Auto-create corresponding categories" => "Auto-crear les categories corresponents",
"Create a group for each item" => "Creeu un grup per a cada ítem",
"Groups will include" => "Els Grups inclouran",
"Creator is assigned to the group" => "El creator s'assigna al grup de",
"Will become the creator's default group" => "Es convertirà en el grup per omissió del creador",
"Will become the new item's group creator" => "Es convertirà en el grup creador del nou element",
"Copy the default group in the field ID before updating the group" => "Copieu el grup per omissió al camp d'ID abans d'actualitzar el grup",
"Non Advanced Search or Natural Search" => "Cerca No Avançada o Cerca Natural",
"Advanced Search or Boolean Search" => "Cerca avançada o Cerca booleana",
"Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Els objectes que contenen el major nombre de termes s'han valorat més alt en els resultats i apareixeran primer en el seu tipus",
"objects that include both terms" => "objectes que inclouen ambdós termes",
"Requiring terms" => "Requerint Termes",
"Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Afegir un signe més (+) abans d'un terme per indicar que el terme <em>ha d'aparèixer</em> en els resultats",
"Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Exemple: <strong>+wiki fòrum</strong> trobarà objectes que continguin almenys <strong>wiki</strong>. Els objectes amb dos termes i moltes ocurrències dels termes apareixeran primer",
"Excluding terms" => "Excloent termes",
"Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Afegir un signe menys (-) davant d'un terme per indicar que el terme <em> no ha d'aparèixer</em> en els resultats",
"To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>." => "Per reduir el valor d'un terme sense excloure per complet, <a href=\"#reducing\" title=\"Reduir el valor d'un terme\">empra una tilda</a>.",
"Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Exemple: <strong>-wiki fòrum</strong> trobarà objectes que no contenen <strong>wiki</strong>, però contenen <strong>fòrum</strong>",
"Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Exemple: <strong> +wiki +(forum blog) </strong> trobarà objectes que contenen <strong> wiki </strong> i <strong> fòrum </strong> o que continguin <strong> wiki </strong> i <strong> el bloc </strong> en qualsevol ordre",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed" => "Fes servir cometes (\"\") al voltant d'una frase per trobar termes en l'ordre exacte, tal i com van ser escrits",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Exemple: <strong> \"Alex Campana\" </strong> no trobarà <strong> Campana Alex </strong> o <strong> Alex G. Campana </strong>.",
"Using wildcards" => "Ús de comodins",
"Add an asterisk ( * ) after a term to find objects that include the root word" => "Afegir un asterisc (*) després d'un terme per trobar els objectes que inclouen la paraula arrel",
"For example, <strong>run*</strong> will find" => "Per exemple, <strong>corre*</strong> es troba",
"objects that include the term <strong>run</strong>" => "objectes que inclouen el terme <strong>corre</strong>",
"objects that include the term <strong>runner</strong>" => "objectes que inclouen el terme <strong>corredor</strong>",
"objects that include the term <strong>running</strong>" => "objectes que inclouen el terme <strong>corrents</strong>",
"Reducing a term's value" => "Reduir el valor d'un terme",
"Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Afegir una titlla (~) abans d'un terme per reduir el seu valor indicat al rànquing dels resultats",
"Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)." => "Els objectes que contenen el terme apareixerà més baix que altres objectes (a diferència dels <a href=\"#excluding\" title=\"Excloent termes\">signe menys</a>\tque exclouran completament un terme).",
"Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>" => "Exemple: <strong> +wiki ~fòrum </strong> qualificarà a un objecte amb només <strong>wiki</strong> major que un objecte amb <strong>wiki</strong> i <strong>fòrum</strong>",
"Changing relevance value" => "Canvi de valor rellevància",
"Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Afegir un menor que (<) i major que (>) davant d'un terme per canviar la contribució del terme per al valor total rellevància assignada a un objecte",
"Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Exemple: <strong> +wiki +(&gt;fòrum &lt; blog) </strong> trobarà objectes que contenen <strong> wiki </strong> i <strong> fòrum </strong> o <strong> wiki </strong> i <strong> blog </strong> en qualsevol ordre. <strong>wiki fòrum</strong> serà classificat millor",
// "{\$confirmation_message}" => "{\$confirmation_message}",
// "\"}Are you sure you want to set this %0 to \"open\"" => "\"}Are you sure you want to set this %0 to \"open\"",
// "\"}Are you sure you want to set this %0 to \"pending\"" => "\"}Are you sure you want to set this %0 to \"pending\"",
// "\"}Are you sure you want to set this %0 to \"closed\"" => "\"}Are you sure you want to set this %0 to \"closed\"",
// "{\$field.name|truncate:65|escape}" => "{\$field.name|truncate:65|escape}",
"Hold \"Ctrl\" in order to select multiple values" => "Mantingues presionada la tecla \"Ctrl\" per a seleccionar múltiples valors",
// "{\$field_name}" => "{\$field_name}",
// "{\$description}" => "{\$description}",
"{\$sc.label|escape}" => "{\$sc.label|escape}",
"Admin Fields" => "Els camps admin",
"It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "És molt probable que l'autenticació es requereix per accedir a aquestes dades en el lloc remot. Configureu la font d'autenticació de l'administrador DSN",
"Search for trackers to clone" => "Cerca formularis-bd per clonar",
"After" => "Després de",
"Do you really want to remove the scheduled event" => "Segur que vols esborrar aquest esdeveniment programat",
// "Remove event" => "Remove event",
"No events registered" => "No hi ha cap esdeveniment registrat",
"Reference date" => "Data de referència",
"After creation" => "Després de la creació",
"After last modification" => "Després de la darrera modificació",
"Delay prior to status change" => "Decataltge abans del canvi d'estatus",
"Mail subject text" => "Text de l'assumpte del correu-e",
"Mail body ressource" => "Recurs del cos del missatge",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:paginaWiki per a una pàgina wiki o tplName.tpl per a una plantilla",
// "Existing Article" => "Existing Article",
// "Article URL" => "Article URL",
"(automatically generated after item creation)" => "(generat automàticament després de la creació de l'item)",
// "Change Event" => "Change Event",
"Other:" => "Altre/a:",
"Attached files limitation" => "Limitació d'arxius adjunts",
"The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved" => "La quantitat d'arxius que es poden adjuntar es limita a <strong>%0</strong>. Es conservaran els arxius més recents",
"Browse files" => "Examinar arxius",
// "Browse Files" => "Browse Files",
"Link to existing Vimeo URL" => "Enllaç a la URL existent de Vimeo",
"Type or paste the URL and press ENTER" => "Escriviu o enganxeu l'adreça URL i premeu ENTER",
// "You do not have permission to upload files to this gallery" => "You do not have permission to upload files to this gallery",
// "You do not have permission to add a member to a group" => "You do not have permission to add a member to a group",
"Select Icon" => "Selecciona Icona",
// "Remove image" => "Remove image",
"Are you sure you want to delete this image" => "Segur que vols esborrar aquesta imatge",
// "{\$field.options_map.addItems|escape}" => "{\$field.options_map.addItems|escape}",
"Add Media" => "Afegir un mitjà",
"Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19" => "Format: x,y,zoom on x és la longitud, y és la latitud, i el Zoom pot anar de 0(vista de tota la Terra) fins a 19",
// "This bug has been demonstrated on {\$field.options_map.domain|escape}" => "This bug has been demonstrated on {\$field.options_map.domain|escape}",
// "Please demonstrate your bug on {\$field.options_map.domain|escape}" => "Please demonstrate your bug on {\$field.options_map.domain|escape}",
// "Bug needs to be created first" => "Bug needs to be created first",
// "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created" => "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created",
// "Show.tiki.org snapshot creation is in progress" => "Show.tiki.org snapshot creation is in progress",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"",
// "Password reset" => "Password reset",
// "Password reset was successful" => "Password reset was successful",
// "Password reset failed" => "Password reset failed",
// "Show.tiki.org instance destruction in progress" => "Show.tiki.org instance destruction in progress",
// "Show.tiki.org instance destruction is in progress... Please wait.." => "Show.tiki.org instance destruction is in progress... Please wait..",
// "Show.tiki.org is not configured properly" => "Show.tiki.org is not configured properly",
// "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks" => "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks",
// "Show.tiki.org is currently unavailable" => "Show.tiki.org is currently unavailable",
// "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Show.tiki.org is under maintenance" => "Show.tiki.org is under maintenance",
// "Show.tiki.org is currently under maintenance. Sorry for the inconvenience" => "Show.tiki.org is currently under maintenance. Sorry for the inconvenience",
// "Unable to get information from {\$field.options_map.domain|escape}" => "Unable to get information from {\$field.options_map.domain|escape}",
// "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Instance is being created" => "Instance is being created",
// "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks" => "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks",
// "About {\$field.options_map.domain|escape}" => "About {\$field.options_map.domain|escape}",
// "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}" => "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}",
// "Create {\$field.options_map.domain|escape} instance" => "Create {\$field.options_map.domain|escape} instance",
// "Accessing the Tiki instance that demonstrates this bug" => "Accessing the Tiki instance that demonstrates this bug",
// "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0" => "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"",
// "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0" => "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0",
// "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload" => "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload",
// "Snapshots" => "Snapshots",
// "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation" => "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0",
// "Create new snapshot" => "Create new snapshot",
// "Destroy this {\$field.options_map.domain|escape} instance" => "Destroy this {\$field.options_map.domain|escape} instance",
// "Reset password to 12345" => "Reset password to 12345",
// "SVN update" => "SVN update",
// "Debug Mode Information" => "Debug Mode Information",
// "Get instance information and refresh cache" => "Get instance information and refresh cache",
// "Filter by group" => "Filter by group",
// "Select user(s)" => "Select user(s)",
// "View stand alone wiki page" => "View stand alone wiki page",
// "Source of wiki page" => "Source of wiki page",
// "History of wiki page" => "History of wiki page",
// "No articles" => "No articles",
"Administrator intervention required" => "Requereix la intervenció de l'administrador",
// "Tags is not enabled" => "Tags is not enabled",
"LastModif" => "Última modificació",
"You did not vote yet" => "No has votat encara",
"My rating" => "La meva puntuació",
"{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "Clica per tal de votar aquest valor",
// "Remove your rating" => "Remove your rating",
"%0 element(s)" => "%0 element (s)",
"Language: %0" => "Idioma: %0",
// "You have subscribed" => "You have subscribed",
"You have not yet subscribed" => "Encara no t'has subscrit",
"with" => "amb",
"friends" => "amics",
// "Translation.." => "Translation..",
// "No language assigned" => "No language assigned",
// "Set page language" => "Set page language",
// "Set article language" => "Set article language",
"Current language" => "Idioma actual",
"Show all translations of this page on a single page" => "Mostra totes les traduccions d'aquesta pàgina en una sola pàgina",
"All languages" => "Tots els idiomes",
"Machine translations" => "Les traduccions automàtiques",
"Translate page" => "Tradueix la pàgina",
"Manage page translations" => "Gestiona les traduccions de la pàgina",
"Translate article" => "Traduir article",
"Manage article translations" => "Gestioni traduccions article",
"Are you sure you want to detach these translations" => "Segur que vols separar aquestes traduccions",
"Current translation set" => "Conjunt de traduccions actual",
// "Detach translation" => "Detach translation",
"Are you sure you want to detach the translation" => "Segur que vols separar la traducció",
"No translations available at this time" => "No hi ha cap traducció disponible actualment",
"Add a new object to the set" => "Afegeix un nou objecte al conjunt",
"All possible translations exist" => "Ja existeixen totes les possibles traduccions",
// "Email this wiki page" => "Email this wiki page",
// "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki" => "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki",
// "Bcc" => "Bcc",
// "Enter a valid email to send a blind copy to (optional)" => "Enter a valid email to send a blind copy to (optional)",
// "%0 away" => "%0 away",
// "Shared groups" => "Shared groups",
// "Friendship" => "Friendship",
// "Add to or remove from" => "Add to or remove from",
// "Add to" => "Add to",
// "Remove from" => "Remove from",
// "These groups" => "These groups",
// "Use Ctrl+Click or Command+Click to select multiple options" => "Use Ctrl+Click or Command+Click to select multiple options",
// "Set default group" => "Set default group",
// "Remove users" => "Remove users",
// "Remove the users' pages" => "Remove the users' pages",
// "Remove the user pages belonging to these users" => "Remove the user pages belonging to these users",
// "Delete user items from these trackers" => "Delete user items from these trackers",
// "Warning: Experimental" => "Warning: Experimental",
// "Select trackers here to have items in them which are \"owned\" by these users deleted" => "Select trackers here to have items in them which are \"owned\" by these users deleted",
// "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically" => "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically",
// "Delete user files" => "Delete user files",
// "Delete the users' file galleries and all the files in them" => "Delete the users' file galleries and all the files in them",
// "Ban users" => "Ban users",
// "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning" => "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning",
// "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided" => "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided",
// "Cancel login process" => "Cancel login process",
// "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login" => "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login",
// "Birth date" => "Birth date",
// "Validate your age and proceed to login" => "Validate your age and proceed to login",
// "I approve the above terms and conditions" => "I approve the above terms and conditions",
// "I Decline, log out" => "I Decline, log out",
"However, no account is associated to the OpenID identifier." => "Ara bé, no hi ha cap compte associat a l'identificador OpenID.",
"If you use an email filter, be sure to add %0 to your accepted list" => "Si empres un filtre de correu-e, assegura't d'afegir %0 a la llista de les adreces que acceptes",
"Associate OpenID with an existing Tiki account" => "Associar OpenID amb un compte existent Tiki",
// "Browse for video file to upload" => "Browse for video file to upload",
// "Upload Progress" => "Upload Progress",
// "Vimeo Setup Error" => "Vimeo Setup Error",
// "{\$errMsg}" => "{\$errMsg}",
// "Available space: %0 megabytes" => "Available space: %0 megabytes",
// "No standard definition uploads available currently" => "No standard definition uploads available currently",
// "No high definition uploads available currently" => "No high definition uploads available currently",
// "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines" => "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines",
// "You will also need to rebuild your caches and search index" => "You will also need to rebuild your caches and search index",
// "Re-generate URLs" => "Re-generate URLs",
// "The following item(s) include page(s) being deleted and will break" => "The following item(s) include page(s) being deleted and will break",
// "Remove {\$idesc}" => "Remove {\$idesc}",
// "Create redirect" => "Create redirect",
// "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)" => "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)",
// "Redirect to" => "Redirect to",
"Use this thread to discuss the page:" => "Utilitza aquest fòrum per parlar de la pàgina:",
"Missing or incorrect trackerId parameter for the plugin" => "Paràmetre trackerId manca o incorrecta per al connector",
"List Trackers" => "Llista Formularis-bd",
// "resource day" => "resource day",
// "resource month" => "resource month",
// "resource year" => "resource year",
// "resource week" => "resource week",
// "list day" => "list day",
// "list month" => "list month",
// "list year" => "list year",
// "list week" => "list week",
"list" => "llista",
// "agenda month" => "agenda month",
// "agenda week" => "agenda week",
// "agenda day" => "agenda day",
// "{\$params.label|escape}" => "{\$params.label|escape}",
"Subtract" => "Sostreure",
"Meeting ID" => "ID de la reunió",
"Current attendees" => "Assistents actuals",
"No attendees at this time" => "No hi ha assistents en aquest moment",
"Last time we checked, the room you requested did not exist" => "L'última vegada que ho vam mirar, la sala que has demanat no s'havia preparat encara",
"Current recordings" => "Enregistraments actuals",
"On %0 from %1 to %2" => "El %0 de %1 a %2",
"This will permanently remove the recording" => "Aquesta acció eliminarà la gravació de forma permanent",
"(including audio recording & chat log)" => "(Incloent l'enregistrament d'àudio i registre de la xerrada)",
"{\$button_label}" => "{\$button_label}",
// "{\$moretext|escape}" => "{\$moretext|escape}",
"{\$ftptitle}" => "{\$ftptitle}",
// "No permission to change the following task" => "No permission to change the following task",
// "Project update not possible as you lack rights for updating a parent project" => "Project update not possible as you lack rights for updating a parent project",
// "Start date is a milestone" => "Start date is a milestone",
// "End date is a milestone" => "End date is a milestone",
// "Task has constraints" => "Task has constraints",
// "Error: there is a dependency on an open task" => "Error: there is a dependency on an open task",
// "Error: due to a descendant of a closed task" => "Error: due to a descendant of a closed task",
// "This task has external dependencies" => "This task has external dependencies",
// "GANNT_ERROR_LOADING_DATA_TASK_REMOVED" => "GANNT_ERROR_LOADING_DATA_TASK_REMOVED",
// "Cannot depend on ancestors" => "Cannot depend on ancestors",
// "The data inserted are invalid for the field format" => "The data inserted are invalid for the field format",
// "An error has occurred while loading the data. A task has been trashed" => "An error has occurred while loading the data. A task has been trashed",
// "Cannot close a task with open issues" => "Cannot close a task with open issues",
// "You cannot exchange tasks of different depth" => "You cannot exchange tasks of different depth",
// "Sem" => "Sem",
// "Cannot move task" => "Cannot move task",
// "Please save your project" => "Please save your project",
// "Error: date settings" => "Error: date settings",
// "Cannot depend on descendants" => "Cannot depend on descendants",
// "code/short name" => "code/short name",
// "start" => "start",
// "dur" => "dur",
// "depe" => "depe",
// "assignees" => "assignees",
// "completed" => "completed",
// "suspended" => "suspended",
// "undefined" => "undefined",
// "Task editor" => "Task editor",
// "is milestone" => "is milestone",
// "status" => "status",
// "progress" => "progress",
// "Assignments" => "Assignments",
// "Role" => "Role",
// "est.wklg" => "est.wklg",
"Number of Users" => "Nombre d'usuaris",
"Percentage of Total" => "Percentatge del total",
// "Email address of invitee" => "Email address of invitee",
"Set in these groups" => "Situat en aquests grups",
"Number of result" => "Nombre de resultat",
"Message sent to" => "Missatge enviat a",
"Email sent to" => "Correu electrònic enviat a",
// "recipients" => "recipients",
// "Message preview" => "Message preview",
// "Number of Recipients" => "Number of Recipients",
"Send Mail" => "Enviar correu",
"Send to users" => "Enviar als usuaris",
"Send to" => "Enviar a",
"Email address (if more than one, separated by \",\")" => "Correu electrònic separades per comes",
"Send to groups" => "Enviar a grups",
"Preview Mail" => "Vista prèvia de correu",
// "You will receive a copy of the email yourself. Please give it a few minutes" => "You will receive a copy of the email yourself. Please give it a few minutes",
// "Please wait while your email is being sent.." => "Please wait while your email is being sent..",
// "Previous npm-asset/pdfjs-dist package has been deprecated" => "Previous npm-asset/pdfjs-dist package has been deprecated",
// "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package" => "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package",
"Check to remove" => "Comproveu per eliminar",
// "Contents of email to be sent to user" => "Contents of email to be sent to user",
// "Append custom message" => "Append custom message",
// "Approve user" => "Approve user",
// "Reject user" => "Reject user",
"Add in group" => "Afegir en el grup",
"Set as default group for users" => "Establir com a grup per omissió per als usuaris",
"Join myself" => "Apunta'm a mi mateix/a",
"Leave myself" => "Desapunta'm a mi mateix/a",
"Cost for one period" => "El cost per un període",
"Free for the rest of the current period, a prorated value of" => "Gratis per a la resta del període actual, un valor prorratejat",
"Prorated cost for first period" => "Cost prorratejat per al primer període",
"Special offer! Free additional periods" => "Ofertes especials Períodes addicionals gratis",
// "Membership to %0 for %1 for %2 %3" => "Membership to %0 for %1 for %2 %3",
"separated by |" => "separats per |",
"{\$periodslabel}" => "{\$periodslabel}",
// "vs" => "vs",
// "Mine" => "Mine",
// "Save Changes" => "Save Changes",
// "Edit Pivot Table" => "Edit Pivot Table",
// "Click to view interactive SCORM learning object" => "Click to view interactive SCORM learning object",
// "Download original file" => "Download original file",
"Re-Apply" => "Torneu a aplicar",
// "wrote" => "wrote",
// "{\$wp_emptymsg}" => "{\$wp_emptymsg}",
"{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
"Last Day" => "Últim dia",
"Last Week" => "Darrera Setmana",
"{\$action}" => "{\$action}",
"Groups you are in" => "Grups en què es troba",
"(This is an included group)" => "(Aquest és un grup inclòs)",
"(You are a leader)" => "(Ets un líder)",
"Your default group" => "El grup per omissió",
"Leave Group" => "Deixar grup",
"Manage Group" => "Gestioni Grup",
"Change default group" => "Canviar grup per omissió",
"Subscribe to a group" => "Subscriu-te a un grup",
"Groups you can join" => "Grups als que pots unir-te",
"This group requires approval to join" => "Aquest grup requereix aprovació per unir-se",
"Subscribe to groups" => "Subscriu-te a grups",
"Subscription confirmed!" => "Subscripció confirmada!",
"Subscribe to the newsletter" => "Subscriu-te al butlletí",
"Mini TimeSheet" => "Mini Timesheet",
"Full View" => "Ampliar",
// "End tour" => "End tour",
"Before:" => "Abans:",
"After:" => "Després:",
// "-- Choose an option --" => "-- Choose an option --",
"{\$export_action}" => "{\$export_action}",
"Map View" => "Visualització en mapa",
"Field error" => "Error Camp",
"Stop Monitor" => "Deixa de vigilar per correu-e",
"Tracker - " => "Formulari-bd (Tracker) -",
"{\$checkbox.title}" => "{\$checkbox.title}",
"Export Tracker" => "Exporta Formulari-bd",
"Close item" => "Tancar element",
"Open item" => "Element obert",
"Pend item" => "Punt Pendent",
"{\$params.label}" => "{\$params.label}",
"Please login first" => "Si us plau, connecta't primer",
"Toggle display" => "Intercanvia com es mostra",
"Close:" => "Tanca:",
// "Page approved by %0 on %1" => "Page approved by %0 on %1",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
"Save the page as a partial translation." => "Desa la pàgina com a traducció parcial.",
"Partial Translation" => "Traducció Parcial",
"Save the page as a completed translation." => "Desa la pàgina com a traducció completa.",
"Complete Translation" => "Traducció Completa",
"Save the page, but do not count it as new content to be translated" => "Desa la pàgina, però no ho comptis com a nou contingut per a ser traduït",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Desa la pàgina, però no enviïs notificacions <br/>i no ho comptis com a nou contingut<br/> per ser traduït",
"Save Minor Edit" => "Edició Menor",
"Save the page." => "Desa la pàgina.",
"If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions" => "Si ets un administrador experimentat amb Tiki, considera si algunes d'aquestes funcions avançades de sota et podrien ser útils per al teu cas d'ús. Són útils, per exemple, si crees periòdicament un conjunt similar d'objectes Tiki per a diferents grups d'usuaris amb conjunts de permisos similars",
"Workspaces UI in doc.tiki.org" => "Workspaces UI a doc.tiki.org",
"Enable using the same wiki page name in different contexts" => "Permet emprar el mateix nom de pàgina wiki en diferents contextos",
"E.g. ns1:_:MyPage and ns2:_:MyPage" => "Per exemple, ns1:_:LaMevaPagina and ns2:_:LaMevaPagina",
"Workspaces & Areas admin panel" => "Panell d'administració d'Espais de treball & Àrees",
// "Automatic table of contents for a wiki page" => "Automatic table of contents for a wiki page",
"Auto TOC options" => "Opcions per a Auto TOC (Auto Index)",
"Auto TOC" => "Taula de Continguts Automàtica (Auto TOC)",
// "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc" => "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc",
"Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu" => "Les Categories de Contingut es posen a punt a la pàgina d'administració de categories. Si us plau, mira l'element de Categories dins l'apartat d'Administració del menú",
"Set up categories here" => "Posa a punt les categories aquí",
// "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages" => "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages",
// "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there" => "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there",
"Configure general user & community features and settings related to sharing and social networks" => "Configura les funcionalitats generals d'usuaris i comunitat i les preferències relacionades amb el compartir i les xarxes socials",
"Add a <b>User and Registration tracker</b>" => "Afegir un <b>Formulari-bd d'Usuaris i Registre</b>",
"User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users" => "Formulari-bd d'Usuaris i Registre: Podeu utilitzar formularis-bd per recollir informació addicional per als usuaris durant el registre o fins i tot més tard, una vegada que són usuaris registrats",
"Some uses of this type of tracker could be" => "Alguns dels usos d'aquest tipus de formulari-bd podrien ser",
"To collect user information (such as mailing address or phone number)" => "Per recopilar informació de l'usuari (com l'adreça postal o número de telèfon)",
"To require the user to acknowledge a user agreement" => "Per sol·licitar l'usuari a reconèixer un acord d'usuari",
"To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)" => "Per evitar el registre d'spammers, demanant als nous usuaris de proporcionar una raó per la qual volen afegir-s'hi (hauria d'haver un avís notificant a l'usuari que la seva resposta ha d'indicar que ell o ella entén clarament de què es tracta el lloc web, per exemple)",
"The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually" => "El Perfil de configuració habilitarà l'opció 'Formularis-bd' i alguns altres ajustos necessaris. Un cop aplicat el perfil, se't proporcionaran instruccions sobre mesures addicionals que necessites dur a terme de forma manual després",
"apply profile now" => "aplica el perfil ara",
// "new window" => "new window",
"To set up the <strong>User Watches</strong> and their associated settings, visit the page to " => "Per posar a punt les <strong>Subscripcions d'Usuaris</strong> i les configuracions associades, visita la pàgina per a ",
"Community General Settings" => "Preferències Generals de Comunitat",
"admin panel" => "panell d'administració",
"in doc.tiki.org" => "a doc.tiki.org",
"Sharing & Networking" => "Compartint i Fent Xarxa",
"Social Network" => "Xarxa Social",
"Friendship and Followers" => "Amistat i Seguidors/es",
"Set the site time zone and format for displaying dates and times" => "Posa a punt la zona horària i com es mostren els dies i les hores",
// "Date and Time options" => "Date and Time options",
"Date and Time admin panel" => "Panell d'Administració del Dia i Hora",
"Select editor type" => "Selecciona tipus d'editor",
"Only Plain Text Editor (Disable Wysiwyg)" => "Només Editor de Text Pla (Deshabilita Wysiwyg)",
"Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>" => "Empra només l'editor de text pla, que és el mode d'editor més estable i el més compatible amb les funcionalitats de Tiki. L'Editor Wysiwyg Sencer serà deshabilitat, però encara podràs inserir seccions wysiwyg a través de l'editor de text plan amb el  <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>",
"Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page" => "Empra un editor Wysiwyg (What You See Is What You Get; és a dir, un editor Visual), per omissió en totes les noves pàgines o només en algunes quan sigui seleccionat. Proporciona una interfície visual preferida per molts. Podràs configurar les opcions de l'Editor Wysiwyg Sencer a la propera pàgina de l'assistent",
// "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor" => "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor",
"Set up the main Tiki features. The wiki and file gallery features are always enabled" => "Habilita les principals funcionalitats de Tiki que necessitis. Les funcionalitat del Wiki i galeries d'arxius sempre són actives",
"Main Tiki features" => "Principals funcionalitats de Tiki",
"Tiki has many more features" => "Tiki té moltes més funcionalitats",
"Global Features" => "Funcionalitats Globals",
"Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made" => "Habilita les notificacions per correu-e a usuaris quan hi hagi canvis a ítems específics (pàgines, publicacions, formularis-bd, etc.)",
"Set up the file gallery and attachments" => "Posa a punt les teves galeries d'arxius i adjunts",
"Choose to store them either in the database or in files on disk, among other options" => "Escull de desar-les o en la base de dades o en arxius en disc, entre altres opcions",
// "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder" => "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder",
"elFinder" => "elFinder",
"Wiki admin panel" => "Panell d'administració del wiki",
// "File storage" => "File storage",
"Set elFinder as the default file gallery viewer" => "Escull elFinder com al visualitzador de galeries d'arxius per omissió",
"File Gallery storage" => "Emmagatzematge del contingut de les Galeries d'arxius",
"Attachment storage" => "Emmagatzematge dels adjunts (a pàgines wiki)",
"Select the site language" => "Selecciona l'idioma del lloc",
// "Language options" => "Language options",
// "Configure the log-in, registration and validation preferences for the new accounts" => "Configure the log-in, registration and validation preferences for the new accounts",
// "Registration and log-in options" => "Registration and log-in options",
"Login admin panel" => "Panell d'Administració de Connexions",
"Configure the Tiki theme and other look & feel preferences" => "Configura el tema d'estil de Tiki i altres preferències d'aparença",
"Look & Feel options" => "Opcions d'aparença",
"Look & Feel admin panel" => "Panell d'Administració d'Aparença",
"Namespace settings" => "Preferències de l'Espai de Noms",
"There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>" => "Hi ha dos sistemes de cerca a Tiki que empren diferents motors de cerca: la <strong>Cerca Bàsica</strong> i la <strong>Cerca Avançada</strong>",
// "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)" => "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)",
"Basic Search" => "Cerca Bàsica",
"Uses MySQL full-text search" => "Empra la Cerca de MySQL a Text-Complet",
"If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below" => "Si s'habilita, el mòdul de cerca i la funcionalitat de cerca en el menú principal de l'aplicació l'empraran per omissió, fins i tot si també s'habilita l'opció de 'Cerca Avançada' a sota",
"Advanced Search" => "Cerca Avançada",
"Uses Unified Search Index with a specified search engine" => "Empra l'Índex Unificat de Cerca amb un motor de cerca especificat",
"If you have issues with Advanced Search, simply revert to Basic Search" => "Si tens problemes amb la Cerca Avançada, torna simplement a emprar només la Cerca Bàsica",
"Unified Search is required by a number of other features, e.g. the community friendship network" => "La Cerca Unificada és requerida per un cert nombre d'altres funcionalitats, per exemple, la xarxa d'amistat dins la comunitat",
"Other settings" => "Altres paràmetres",
"Also see the Search Indexing tab here" => "Veure també aquí la pestanya d'indexació de les cerques",
// "Search admin card" => "Search admin card",
"Search in doc.tiki.org" => "Cerca a doc.tiki.org",
// "Hierarchical organization of wiki pages" => "Hierarchical organization of wiki pages",
"Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage" => "Les estructures organitzen un grup de pàgines wiki en un arbre o un llibre pel qual els usuaris poden navegar fàcilment. La creació d'una estructura és el mètode més ràpid per a la creació de diverses pàgines wiki alhora. És una gran manera de fer un llibre, així com de permetre als usuaris de crear pàgines noves que es troben de forma automàtica en un índex comú. Les pàgines noves poden heretar permisos de la pàgina inicial de l'estructura",
"Structures options" => "Opcions d'Estructures",
"Set up the text area environment (Editing and Plugins)" => "Posa a punt l'entorn d'Àrea de Text (Edició i Connectors - Plugins)",
"Editing and plugins admin panel" => "Panell d'Administració d'Edició i Connectors (plugins)",
"Set up the Wiki environment" => "Posa a punt l'entorn del Wiki",
"Wiki environment" => "Entorn del Wiki",
"Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar" => "Cerca la icona <img src=\"img/icons/camera.png\" /> a la barra d'eines de l'editor",
"Requires Java" => "Requereix de Java",
"Verify your Java installation" => "Verifica la teva instal·lació de Java",
// "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages" => "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages",
// "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>" => "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>",
"Get Started" => "Posa't en marxa",
"Congratulations! You now have a working instance of Tiki %0" => "Felicitats! Ara tens una instància funcional de Tiki %0",
"You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below" => "Pots <a href=\"tiki-index.php\">començar a utilitzar-la immediatament</a>, o pots configurar-la per satisfer millor les teves necessitats, utilitzant un dels ajudants de configuració que tens a continuació",
"Mouse over the icons to know more about the features and preferences that are new for you" => "Passa el ratolí sobre les icones per saber més sobre les característiques i preferències que et siguin noves",
"Example: " => "Exemple: ",
"Help icon" => "Icona d'Ajuda",
"You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it" => "Rebràs més informació sobre les característiques i preferències cada vegada vegis aquesta icona disponible i passis el punter del ratolí sobre ella",
"Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic" => "Si ademés hi fas click, se t'obrirà una nova finestra amb la corresponent pàgina de documentació per a obtenir més informació sobre aquesta funcionalitat o tema",
"Configuration Profiles Wizard" => "Assistent de Perfils de Configuració",
"You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>" => "Pots començar aplicant alguns de les nostres plantilles de configuració a través de l'<b>Assistent de Perfils de Configuració</b>",
"They are like the <b>Macros</b> from many computer languages" => "Són com les <b>Macros</b> de molts llenguatges de programació",
// "It is best to apply them from the start and you can always preview and reverse the process" => "It is best to apply them from the start and you can always preview and reverse the process",
// "Configuration Profiles" => "Configuration Profiles",
"Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you" => "Cadascun d'ells proporciona una solució reduïda pre-fabricada que reuneix la majoria de les necessitats d'un tipus particular de comunitat o lloc (espai de Bloc personal, Intranet d'Empresa, ...) o que extèn la configuració bàsica amb funcionalitats extra ja pre-configurades per a tu",
"If you are new to Tiki administration, we recommend that you start with this approach" => "Si ets nou en l'administració de Tiki, et recomanem que comencis amb aquesta aproximació",
"If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below" => "Si el perfil que has seleccionat no satisfà les teves necessitats, encara tens l'opció de personalitzar-ho encara més amb una de les aproximacions de sota",
"Start Configuration Profiles Wizard (Macros)" => "Inicia l'Assistent de Perfils de Configuració (Macros)",
"Configuration Walkthrough" => "Tutorial de Configuració",
"Alternatively, you may use the <b>Configuration Wizard</b>" => "Alternativament, pots emprar l'<b>Assistent de Configuració</b>",
"This will guide you through the most common preference settings in order to customize your site" => "Això et guiarà a través de les preferències més comuns de configuració per tal de personalitzar el teu lloc ",
// "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc" => "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc",
"Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further" => "Utilitza aquest assistent si cap dels <b>Perfils de Configuració</b> sembla un bon punt de partida, o si necessites personalitzar el seu teu lloc encara més",
"Start Configuration Wizard" => "Inicia l'Assistent de Configuració",
"Or you may use the <b>Changes Wizard</b>" => "Pots també utilitzar l'<b>Assistent d'actualització</b>",
"This will guide you through the most common new settings and informations in order to upgrade your site" => "Això et guiarà a través de les noves configuracions i informacions més comunes per tal d'actualitzar el teu lloc",
"Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version" => "Utilitza aquest assistent si vas a actualitzar una versió prèvia de Tiki, especialment si vens de l'anterior versió de Suport a Llarg Termini (LTS, de les sigles en anglès)",
"Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels" => "Alguns d'aquests paràmetres són també disponibles des de l'Assistent de Configuració, i tots són disponibles a través dels Panells de Control",
"But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site" => "Però aquest assistent et permetrà aprendre sobre elles, així com activar-les/desactivar-les fàcilment d'acord a les teves necessitats i interessos per al teu lloc",
"Start Changes Wizard" => "Inicia l'Assistent d'Actualització",
"Use the <b>Control Panels</b> to manually browse through the full list of preferences" => "Empra els <b>Panells de Control</b> per cercar manualment a la llista de totes les preferències",
// "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings" => "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings",
// "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with" => "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with",
// "Explore the control panels and configure your Tiki manually" => "Explore the control panels and configure your Tiki manually",
"Go to the Control Panels" => "Ves als Panells de Control",
// "You can check if your server meets the requirements for running Tiki version %0" => "You can check if your server meets the requirements for running Tiki version %0",
// "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly" => "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly",
// "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback" => "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback",
// "Check your server fitness" => "Check your server fitness",
// "Go to the Tiki Server Compatibility Check" => "Go to the Tiki Server Compatibility Check",
"You are done with the admin wizard" => "Has acabat amb l'assistent d'administració",
"Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin" => "Tria un altre <a href=\"%0\">Assistent</a> per continuar amb la configuració del teu lloc com a administrador",
"Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user" => "Visita l'<a href=\"%0\">Assistent d'usuaris</a> per a establir algunes de les preferències com a usuari",
"Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were" => "O clica al botó  <strong>Finalitza</strong> per a acabar l'assistent d'administració i retornar a on eres",
"You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode" => "Pots escollir d'emprar per omissió el mode Compatible Wiki (el contingut es desa amb sintaxi wiki), o el mode HTML",
// "Wysiwyg editor" => "Wysiwyg editor",
"Select the Wysiwyg editor mode" => "Selecciona el mode d'editor Wysiwyg",
"Compatible Wiki mode" => "Mode Compatible Wiki",
"Use wiki syntax for saved pages" => "Empra sintaxi wiki per a les pàgines desades",
"This is the most compatible with Tiki functionality and the most stable editor mode" => "Aquesta és la funcionalitat de Tiki més compatible i el mode d'editor més estable",
"Tools and functions in the editor toolbar will be limited" => "Les eines i funcions seran limitades a la barra d'eines de l'editor",
"HTML mode" => "Mode HTML",
"Use HTML syntax for saved pages" => "Empra sintaxi HTML per a desar les pàgines",
"Best compatibility with inline editing" => "Té la major compatibilitat amb l'edició wysiwyg en-línia",
"Loses some wiki related features, such as SlideShow, and has some problems with SEFURL" => "Perd algunes funcionalitats relacionades amb el Wiki, com els passis de diapositives, i té alguns problemes amb les urls amigables als cercadors (SEFURL)",
"Full editor toolbar" => "Barra d'eines sencera a l'editor",
"Wysiwyg admin panel" => "Panell d'administració de Wysiwyg",
"Documentation site" => "Lloc de Documentació",
"Related pages from the Official Documentation site <em>https://doc.tiki.org</em>" => "Pàgines relacionades del lloc de la Documentació Oficial <em>https://doc.tiki.org</em>",
"To see it in full size out of this frame" => "Per veure-ho a mida completa fora d'aquest marc",
"Main new features and settings in Tiki 13" => "Principals funcionalitats i opcions noves en Tiki 13",
"Tiki13" => "Tiki13",
"Tiki13 is a post-LTS version" => "Tiki13 és una versió post-LTS (Suport a Llarg Termini, de les sigles en anglès)",
"It will be supported until 14.1 is released" => "Serà suportada fins que s'alliberi la versió 14.1",
"The requirements increased (IE9, PHP 5.5)" => "Els requisits del servidor han augmentat (IE9, PHP 5.5)",
"Major changes have happened, including moving to Bootstrap" => "Han ocorregut canvis majors, incloent la migració a Bootstrap",
// "New Themes" => "New Themes",
// "Site layouts (based on 'Bootstrap')" => "Site layouts (based on 'Bootstrap')",
// "The changes in this area were refactored in Tiki 14" => "The changes in this area were refactored in Tiki 14",
"Goal, Recognition and Rewards" => "Objectius, Reconeixements i Recompenses",
// "Main new features and settings in Tiki 14" => "Main new features and settings in Tiki 14",
// "Tiki14" => "Tiki14",
// "Tiki14 is a standard non-LTS version" => "Tiki14 is a standard non-LTS version",
// "It will be supported until 15.1 is released" => "It will be supported until 15.1 is released",
// "The requirements are the same as in the previous version (IE9, PHP 5.5)" => "The requirements are the same as in the previous version (IE9, PHP 5.5)",
// "Minor changes have happened, compared to post-LTS versions such as Tiki13" => "Minor changes have happened, compared to post-LTS versions such as Tiki13",
// "New modules" => "New modules",
// "A new module called <strong>Module zone</strong> was added" => "A new module called <strong>Module zone</strong> was added",
// "Module zone" => "Module zone",
// "New module meant to provide a horizontal 'navigation bar' for the website" => "New module meant to provide a horizontal 'navigation bar' for the website",
// "Tiki Addons" => "Tiki Addons",
// "Addons allow a way for developers to add an even broader range of functionality" => "Addons allow a way for developers to add an even broader range of functionality",
// "Addons" => "Addons",
// "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase" => "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase",
// "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki" => "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki",
// "Other new features" => "Other new features",
// "Improved and extended features" => "Improved and extended features",
"See the full list of changes" => "Mira la llista sencera de canvis",
// "Main new features and settings in Tiki 15" => "Main new features and settings in Tiki 15",
// "Tiki15" => "Tiki15",
// "Tiki15 is an LTS version" => "Tiki15 is an LTS version",
// "As it is a Long-Term Support (LTS) version, it will be supported for 5 years" => "As it is a Long-Term Support (LTS) version, it will be supported for 5 years",
// "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended" => "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended",
// "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki" => "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki",
// "In Tiki 15, an addons repository was added" => "In Tiki 15, an addons repository was added",
// "New Wiki Plugins" => "New Wiki Plugins",
// "Social Networks with Linkedin" => "Social Networks with Linkedin",
// "Temporary User Accounts" => "Temporary User Accounts",
// "Display more information here" => "Display more information here",
// "You can use this feature through: " => "You can use this feature through: ",
// "Admin Users > Temporary Users (tab)" => "Admin Users > Temporary Users (tab)",
// "Statistics Control Panel" => "Statistics Control Panel",
"You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "És molt recomanable utilitzar un directori d'arxiu que l'arxiu d'emmagatzematge Gallery, en utilitzar aquesta funció",
"Console" => "Consola",
// "There is a console.php command to set a scheduled batch upload cron task" => "There is a console.php command to set a scheduled batch upload cron task",
// "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)" => "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)",
// "Removed features" => "Removed features",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Main new and improved features and settings in Tiki 16" => "Main new and improved features and settings in Tiki 16",
// "Tiki16" => "Tiki16",
// "Tiki16 is a standard non-LTS version" => "Tiki16 is a standard non-LTS version",
// "It will be supported until 17.1 is released" => "It will be supported until 17.1 is released",
// "New PHP minimum requirement for Tiki 16 is PHP 5.6" => "New PHP minimum requirement for Tiki 16 is PHP 5.6",
// "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others" => "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others",
// "Tracker Force-Fill Feature" => "Tracker Force-Fill Feature",
// "Improved Fields" => "Improved Fields",
// "Improved Plugins and extended features" => "Improved Plugins and extended features",
// "There are a few new console.php commands to set scheduled cron tasks" => "There are a few new console.php commands to set scheduled cron tasks",
// "Filtering to Index-based Plugins" => "Filtering to Index-based Plugins",
// "Filter UI added in any wiki plugin using unified search index" => "Filter UI added in any wiki plugin using unified search index",
// "PDF Settings (Control Panel > Print)" => "PDF Settings (Control Panel > Print)",
// "New method to create PDF: mPDF" => "New method to create PDF: mPDF",
// "New Profiles" => "New Profiles",
// "Bug_Tracker_16" => "Bug_Tracker_16",
// "Execute on list" => "Execute on list",
// "GeoCMS_Maps" => "GeoCMS_Maps",
// "Work_Custom_Pricing" => "Work_Custom_Pricing",
// "Main new and improved features and settings in Tiki 17" => "Main new and improved features and settings in Tiki 17",
// "Tiki17" => "Tiki17",
// "Tiki17 is a standard non-LTS version" => "Tiki17 is a standard non-LTS version",
// "It will be supported until 18.1 is released" => "It will be supported until 18.1 is released",
// "Many libraries have been upgraded" => "Many libraries have been upgraded",
// "Improved Plugins" => "Improved Plugins",
// "HTTP Header Options" => "HTTP Header Options",
// "Intrusion Detection System (IDS) with Expose" => "Intrusion Detection System (IDS) with Expose",
// "Other new or Extended Features" => "Other new or Extended Features",
// "Preferences can be set" => "Preferences can be set",
// "One system cron job can trigger all required actions at their specific scheduled times" => "One system cron job can trigger all required actions at their specific scheduled times",
// "Main new and improved features and settings in Tiki 18" => "Main new and improved features and settings in Tiki 18",
// "Tiki18" => "Tiki18",
// "This is an LTS version" => "This is an LTS version",
// "New Features" => "New Features",
// "Composer Web Install (<b>Packages</b>)" => "Composer Web Install (<b>Packages</b>)",
// "Style guide tool" => "Style guide tool",
// "Look and feel colors can be customized with a style guide tool" => "Look and feel colors can be customized with a style guide tool",
// "PDF from URL: mPDF new settings" => "PDF from URL: mPDF new settings",
// "Other Extended Features" => "Other Extended Features",
// "Real-time collaboration tools (<b>RTC</b>)" => "Real-time collaboration tools (<b>RTC</b>)",
// "New actions can be performed" => "New actions can be performed",
// "Drag and drop added to menu management" => "Drag and drop added to menu management",
"Profiles" => "Perfils (de Configuració)",
// "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items" => "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items",
// "Calendars and Calendar Items will now appear in search results of the unified search index" => "Calendars and Calendar Items will now appear in search results of the unified search index",
// "Certain tracker fields can be converted keeping options" => "Certain tracker fields can be converted keeping options",
// "New Fields" => "New Fields",
// "Activity_Stream" => "Activity_Stream",
// "Simple_Forum" => "Simple_Forum",
// "Timesheets_Tracker" => "Timesheets_Tracker",
// "User_Profile_Business" => "User_Profile_Business",
// "Main new and improved features and settings in Tiki 19" => "Main new and improved features and settings in Tiki 19",
// "Tiki19" => "Tiki19",
// "It is a Standard Term Support (STS) version" => "It is a Standard Term Support (STS) version",
// "It will be supported until Tiki 20.1 is released" => "It will be supported until Tiki 20.1 is released",
// "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones" => "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones",
// "Federation" => "Federation",
// "Other New Features" => "Other New Features",
// "Added a preview button in tracker field files to enable pdf view in new window without download document" => "Added a preview button in tracker field files to enable pdf view in new window without download document",
// "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item" => "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item",
// "Create tracker from File" => "Create tracker from File",
// "GanttChart" => "GanttChart",
// "Hide Fixed Top Nav Bar on Scroll 19" => "Hide Fixed Top Nav Bar on Scroll 19",
// "Scheduler_Presets" => "Scheduler_Presets",
// "And many more improvements" => "And many more improvements",
// "Main new and improved features and settings in Tiki 20" => "Main new and improved features and settings in Tiki 20",
// "Tiki20" => "Tiki20",
// "It will be supported until Tiki 21.1 is released" => "It will be supported until Tiki 21.1 is released",
// "Groupmail_20" => "Groupmail_20",
"Improvements that can help novice admins to set up their tiki sites more easily and improve their usability" => "Millores que poden ajudar els administradors novells a crear els seus llocs tiki més fàcilment i millorar la seva usabilitat",
"Basic Information about Wizards" => "Informació bàsica sobre els Assistents",
// "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)" => "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)",
// "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled" => "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled",
"The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site" => "L'Assistent d'Usuaris ve desactivat per omissió, i tens l'opció d'activar-lo i configurar-lo per al teu lloc",
"Wizards settings" => "Opcions dels Assistents",
"Here you can see listed other features and settings that were not included in the previous sections" => "Aquí pots veure llistades altres funcionalitats i opcions que no han estat incloses en els apartats anteriors",
"Ratings in Forums" => "Valoracions en Fòrums",
"New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user" => "Nova opció per a cada fòrum: \"Pantalla d'Informació de l'usuari > <strong>Valoració del Tema</strong>\" per part de cada usuari",
"Topic Rating by each user" => "Valoració del Tema (fil de debat) per part de cada usuari",
"Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply" => "Des Tiki12.2, hi ha una nova opció als fòrums per permetre la visualització opcional en cada resposta de la valoració per part de cada usuari a aquest 'tema' (fil inicial de debat o discussió) del fòrum",
"This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion" => "Aquesta configuració és útil per facilitar la tasca d'arribar a un consens sobre les deliberacions (en els debats i discussions en fòrums) mitjançant la identificació d'una forma més clara de la posició (valoració del tema) de cada persona en cada moment sobre el plantejament inicial en aquest fil de debat",
"Sysadmin Tasks" => "Tasques d'Administració del Sistema",
"Search Index" => "Índex de cerca",
"You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>" => "Pots reconstruir l'índex de cerca unificada (funció '<b>Cerca avançada</b>') visitant example.com/tiki-admin.php?page=search&rebuild=now o mitjançant l'establiment d'una <b>feina periòdica (cron job)</b>",
"Cron Job to Rebuild Search Index" => "Feina Periòdica (Cron Job) per a Reconstruir l'Índex de Cerca",
"Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index" => "A partir de Tiki9, si tenies un lloc gran havies de configurar una feina periòdica (cron job) per a reconstruir periòdicament l'índex de cerca",
"Starting in Tiki11, the syntax to rebuild the search index changed" => "A partir de Tiki11, la sintaxi per reconstruir l'índex de cerca ha canviat",
"Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line" => "A partir de Tiki11, existeix la rutina <b>console.php</b> per a ajudar a administrar la teva instància de Tiki o <em>MultiTiki</em> a través de la línia d'ordres",
"Console (console.php script)" => "Consola (rutina console.php)",
"Example: Database update" => "Exemple: Actualització de bases de dades",
// "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>" => "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>",
"Mail Queue" => "Cua de Correu-e",
"Daily Reports for User Watches" => "Informes Diaris per als seguiments de l'usuari/a",
"Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending" => "A partir de Tiki12.2, console.php també s'encarrega de la funcionalitat d'enviament de la <strong>Cua de Correu-e</strong>, que s'ha arreglat també, i és una característica molt útil en Tikis amb una càrrega pesada de enviament de notificacions per correu electrònic",
"When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished" => "Quan Tiki té molts correus electrònics de notificació per a enviar sobre els nous canvis en el teu lloc (per exemple, un nou esdeveniment al calendari), el lloc pot semblar que no respon durant uns segons fins que finalitzi tot l'enviament de correu-e",
"The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button" => "Quants més usuaris/àries o grups subscrits hi hagi per a rebre correus-e de notificació de canvis en aquest objecte, més llarg serà el tems sense resposta aparent just després de que l'usuari/a hagi fet clic al botó d'enviar",
// "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job" => "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job",
// "Example: Send the Mail Queue" => "Example: Send the Mail Queue",
// "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups" => "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups",
// "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)" => "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)",
// "Example: Send the Daily Report" => "Example: Send the Daily Report",
"Other Features" => "Altres característiques",
"New permissions and action log settings" => "Nous permisos i opcions del registre d'accions",
"Wiki Inline Editing" => "Edició Wiki En Línia",
"Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4" => "A partir de la versió 12, Tiki ofereix l'opció d'editar en línia una pàgina wiki en mode WYSIWYG amb un editor simplificat, que es basa en Ckeditor4",
"The editor can be quickly turned on/off. All processing is done client side" => "L'editor es pot activar o desactivar de forma àgil. Tot el processament es realitza en el costat del client (en el teu navegador web)",
"Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown" => "A partir de Tiki12, els resultats de les valoracions es poden mostrar de forma selectiva a només alguns grups d'usuaris, i s'han introduït altres paràmetres nous que permeten afinar la informació que es mostra",
"bigbluebutton" => "bigbluebutton",
"New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings" => "El nou permís explícit tiki_p_bigbluebutton_view_rec és ara necessari per tal de veure les gravacions",
"tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted" => "tiki_p_bigbluebutton_view_rec ja no està implícit quan s'ha concedit el permís tiki_p_bigbluebutton_join",
"Switch editor" => "Canvia d'editor",
"Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted" => "A partir de la versió 7, Tiki ofereix l'opció de permetre als usuaris canviar l'editor de text pla pel de WYSIWYG i viceversa, sempre que l'usuari pertanyi a un grup que tingui atorgat el permís necessari",
"Action log settings" => "Opcions del Registre d'Accions",
"Joined Room" => "S'ha unit a la Sala",
"Left Room" => "Ha deixat la Sala",
"You are reaching the end of the <em>Changes Wizard</em>" => "Estàs arribant al final de l'<em>Assistent d'Actualització</em>",
"Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least" => "Ja que estàs fent una actualització, probablement tenies una instal·lació anterior de Tiki durant un temps, i potser ja tinguis certa experiència, al menys, utilitzant algunes característiques de Tiki",
"That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community" => "És per això que ens agradaria <strong>demanar-te que ens envïis alguna informació sobre el teu ús de Tiki</strong>, a l'hora que tindràs en un futur l'oportunitat de connectar-te amb altres administradors prop vostre a la Comunitat d'usuaris de Tiki",
"Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Un cop estigui habilitat '<em>Tiki Connect</em>', en fer clic al botó de sota '<strong>Envia informació</strong>' se't connectarà amb <em>mother.tiki.org</em>, que és on es recolliran les dades",
"You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above" => "També pots enviar informació de retroalimentació sobre Tiki marcant la casella '<em>Proporciona Retroalimenació</em>' (un cop <em>Tiki Connect</em> estigui habilitat), al costat de '<em>Mostra-ho en connectar-nos els admins<em>' a dalt",
// "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}" => "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}",
"Connect" => "Connecta",
"Site title is required" => "Cal indicar el títol del Lloc",
"Here you can set up a few options and features related to Trackers which were added across several versions of Tiki" => "Aquí pots configurar algunes opcions i funcionalitats relacionades amb els formularis-bd que van ser afegides al llarg de diverses versions de Tiki",
"You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site" => "Potser no hagis notat especialment quan hi van aparèixer però has de conèixer aquestes millores ja que podries estar interessat en emprar-ne alguna al teu lloc",
"Tracker Field Types" => "Tipus de camp a Formularis-bd",
// "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>" => "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>",
"Former ways to manage ratings in trackers are <b>deprecated</b>" => "Algunes de les formes anteriors de gestionar les valoracions en Formularis-bd han quedat <b>obsoletes</b>",
"Deprecated Rating Systems in Trackers" => "Sistemes de Valoració obsolets en Formularis-bd",
"Tracker field types" => "Tipus de camp de Formularis-bd",
"edit Tracker" => "edita el Formulari-bd",
"Other options to be set elsewhere" => "Altres opcions que s'estableixen en altres llocs",
"Add a <em>User and Registration tracker</em>" => "Afegir un Formulari-bd d'informació extra d'<em>Usuaris i Registre</em>",
"In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins" => "En les llistes de ítems d'un formulari-bd, a través de la interfície de la funcionalitat de formularis-bd, així com a través de llistes en plugins relacionats amb els formularis-bd",
"You can set it in" => "Ho pots establir a",
"tracker edition" => "edició del formulari-bd",
"Some User Interface (UI) improvements which usually come disabled in new Tiki installations" => "Algunes millores d'interfície d'usuari (IU) que normalment venen deshabilitades en les noves instal·lacions de Tiki",
"They are proven to be useful enhancements in some production environments" => "Han demostrat ser millores útils en alguns entorns de producció",
"The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try" => "Els que encara estan etiquetats com a <em>experimentals</em> <img src=img/icons/error.png> podrien haver deixat de funcionar en alguns entorns, però és molt probable que funcionin tal i com estan en el teu entorn, raó per la qual potser t'agradaria provar-les",
"Icons and Profile Pictures" => "Icones i Avatars",
"Text Areas" => "Àrees de Text",
"You are done with the Changes Wizard" => "Ja has acabat amb l'Assistent d'Actualització",
"You are done with the Configuration Profiles Wizard" => "Has acabat amb l'Assistent de Perfils de Configuració",
// "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site" => "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site",
"Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences" => "Visita l'<a href=\"%0\">Assistent d'Usuaris</a> per a especificar algunes de les teves preferències d'usuari",
// "Some profiles were created for use cases of project management" => "Some profiles were created for use cases of project management",
// "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly" => "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly",
"It creates" => "Es creen",
// "a sample tracker that will hold the tasks" => "a sample tracker that will hold the tasks",
// "a sample wiki page linked to that tracker to display the tasks" => "a sample wiki page linked to that tracker to display the tasks",
// "Some demo data to help you get started" => "Some demo data to help you get started",
"Click to expand" => "Fes clic per ampliar",
// "Work custom pricing" => "Work custom pricing",
// "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one" => "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one",
// "Work Custom Pricing" => "Work Custom Pricing",
// "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile" => "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile",
// "Wildcard items" => "Wildcard items",
// "This profile adds a way to provide reusable items in a tracker coming from another one working as templates" => "This profile adds a way to provide reusable items in a tracker coming from another one working as templates",
// "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are" => "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are",
// "A couple of trackers. One for current items, and another one for the reusable items working ass templates" => "A couple of trackers. One for current items, and another one for the reusable items working ass templates",
// "A few wiki pages to list, view and edit items" => "A few wiki pages to list, view and edit items",
// "Some example items in both trackers to help you get started" => "Some example items in both trackers to help you get started",
"Check out some commonly used configurations in Tiki sites" => "Fes una ullada a algunes configuracions d'ús comú en els llocs de Tiki",
"User & Registration Tracker" => "Formulari-bd d'Usuaris i Registre",
"This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users" => "Aquest perfil et permet sol·licitar més detalls en el procés de registre o en l'Assistent d'Usuaris, així com proporcionar més informació personalitzada als teus usuaris",
"It includes" => "Inclous",
"A long list of predefined usual fields, to choose from" => "Una llarga llista de camps habituals predefinits, per a triar-ne",
"Some fields already prepared to display custom information from your specific site" => "Alguns camps ja preparats per mostrar informació personalitzada des del teu lloc concret",
"The chance to easily customize it with the power of Trackers" => "La possibilitat de personalitzar-lo fàcilment amb el poder dels Formularis-bd",
"Custom Contact Form" => "Formulari de Contacte Personalitzat",
"This profile eases the task to create a custom contact form adapted to the specific case of that site" => "Aquest perfil facilita la tasca de crear un formulari de contacte personalitzat adaptat al cas concret d'aquest lloc",
"More details" => "Més detalls",
"Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point" => "Habilita Formularis-bd i estableix uns camps per crear un formulari de 'Contacta'ns' bàsic com a punt de partida",
"New fields can be added asking questions specific for the site" => "Es poden afegir nous camps fent preguntes específiques per al lloc",
"You decide where and when to display the link to the contact us form in your Tiki menus and pages" => "Tu decideixes on i quan es mostrarà l'enllaç amb el formulari de contacte en els teus menús i pàgines de Tiki",
"This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields" => "Aquest perfil crea dos formularis-bd vinculats. Un que permet pre-seleccionar els elements d'una llista desplegable sobre la base dels elements d'un desplegable anterior. I un segon formulari-bd que conté les opcions que apareixen als camps desplegables",
"Useful for Geographic data (State, Country/Province, ...)" => "Útil per les dades geogràfiques (Estat, País/Província, ...)",
"Useful for Types and Subtypes" => "Útil per a tipus i subtipus",
"Useful for Program Names and Versions" => "Útil per a Noms de programa i les seves Versions",
"Easily manage the options in the second tracker without editing the dropdown in the first tracker" => "Administra fàcilment les opcions del segon formulari-bd sense editar del menú desplegable en el primer formulari-bd",
"Sortable Tables" => "Taules Ordenables",
"This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature" => "Aquest perfil crea un parell d'exemples de taules amb dades que poden ser ordenades i filtrades de forma interactiva en temps real, emprant la funcionalitat 'Jquery Sortable Tables'",
"Useful to sort and filter data in real time" => "Útil per ordenar i filtrar les dades en temps real",
"Same approach for FancyTable and TrackerList Plugins" => "Mateixa aproximació per als Connectors (Plugins) FancyTable i TrackerList",
"Sorting can be server-side or client-side based " => "L'ordenació pot ser del costat del servidor o del costat del client",
"Some profiles are highly customized for very specialized use cases, and they are listed in this special category" => "Alguns perfils són altament personalitzats per a casos d'ús molt especialitzats, i són inclosos en aquesta categoria especial",
"Demo Profiles" => "Perfils de Demo",
"They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site" => "Estan destinats inicialment per a entorns de prova, de manera que, després d'haver jugat amb la característica, no t'hagis de barallar amb l'eliminació dels objectes creats, ni amb la restauració de la configuració potencialment canviat al seu lloc",
"Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on" => "Una vegada que sàpigues el que fan, també pots aplicar-los en el teu lloc web de debó, per tal de tenir plantilles funcionals de les característiques subjacents, que pots adaptar més tard al teu lloc concret",
"These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected" => "Aquests perfils de configuració <strong>requereixen de programari addicional</strong> a instal·lar al servidor per a què funcionin com s'espera",
"See details in the instructions page shown in your site once each profile is applied" => "Consulta els detalls a la pàgina d'instruccions que es mostrarà al teu lloc web una vegada que s'hagi aplicat cada perfil",
"CartoGraf" => "Cartograf",
"CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools" => "Cartograf és una aplicació de mapes interactiva basada en web per a millorar l'aprenentatge en classes d'història i geografia a escoles de secundària i instituts",
"CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application" => "Cartograf és un gran exemple de com utilitzar els perfils en una aplicació de propòsit general (Tiki) per fer una aplicació molt específica",
"This profile is using Tiki as Framework, with these details" => "Aquest perfil utilitza Tiki com a marc de treball, amb aquests detalls",
"It is mainly based on Maps, Drawings, PluginAppFrame and Trackers" => "Es basa principalment en mapes, dibuixos, PluginAppFrame i Formularis-bd",
"It uses its own Cartograf style (downloaded aside)" => "Utilitza el seu propi estil Cartograf (s'ha de descarregar a part)",
"It allows custom markers for maps (placed in a file gallery)" => "Permet marcadors personalitzats per a mapes (col·locats en una galeria d'arxius)",
"It is used in production at http://cartograf.recitus.qc.ca (in French)" => "S'utilitza a nivell de producció a http://cartograf.recitus.qc.ca (en francès)",
"R demo" => "R demo",
"This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages" => "Aquest perfil demostra usos comuns del llenguatge R per a estadística de cara a produir gràfics avançats i/o interactius i informes en pàgines web 2.0",
"It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)" => "Utilitza el Projecte R per al programari d'Estadística i el PluginR de Tiki (cap dels dos es troba dins la instal·lació per defecte de Tiki i necessiten ser instal·lats a part en el mateix servidor que Tiki)",
"The profile creates many demo pages, which comprise" => "El perfil crea moltes pàgines de demostració, que inclouen",
"Simple R syntax in wiki pages to produce interactive charts" => "Sintaxi de R senzilla en pàgines wiki per a produir gràfics interactius",
"Advanced usage to create full GUI for an R application" => "Ús avançat per crear una IGU (GUI) completa per a una aplicació de R",
"Many other examples of nice charts and reports that you can produce with this system" => "Molts altres exemples de gràfics i informes bonics que es poden produir amb aquest sistema",
"r.tiki.org site" => "Lloc r.tiki.org",
"r.tiki.org live site" => "lloc en viu r.tiki.org",
// "GeoCMS Maps" => "GeoCMS Maps",
// "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps" => "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps",
"R Heatmaps" => "R Heatmaps",
"This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)" => "Aquest perfil afegeix una interfície web per a un paquet de R anomenat EasyHeatMap (l'enllaç al paquet d'R associat és proporcionat a la pàgina d'instruccions un cop aplicat el perfil)",
"This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)" => "Aquest paquet d'R permet la creació i edició de gràfics de tipus Heatmap (com els emprats en Bioinformàtica)",
"This profile creates" => "Aquest perfil crea",
"A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you" => "Una sola pàgina wiki on funciona tota la generació Heatmap, per permetre la depuració de la instal·lació del paquets d'R i del servidor requerits si alguna cosa falla",
"A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets" => "Algunes pàgines wiki per mostrar, veure i editar anàlisis en R para producir Heatmaps per a l'expressió diferencial de conjunts de gens",
"Example input files and default values provided as a happy path to produce your first Heatmaps" => "Es donen arxius d'entrada d'exemple i els valors per omissió que permeten un camí feliç per produir els teus primers Heatmaps",
"Plugin R" => "Plugin R",
"Plugin R in doc.tiki.org" => "Plugin R a doc.tiki.org",
"Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example" => "Cadascun d'aquests perfils crea una instància funcional amb algunes característiques concretes activades, com ara formularis-bases de dades (trackers) i pàgines wiki a mida per a fins específics, per exemple",
"They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real" => "L'objectiu no és aplicar-los inicialment en entorns en producció, ja que no es poden revertir amb facilitat, i els canvis i els nous objectes es creen de veritat en el teu lloc web",
"Bug Tracker" => "Base de dades d'errades ('Bug Tracker')",
"This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below" => "Aquest perfil us permet veure un formulari-bd ('Tracker') en acció amb algunes dades de demostració, i una interfície personalitzada en una pàgina wiki per a afegir nous elements, a més de tenir-los mostrats a sota",
"Uses PluginTracker in a wiki page to add items" => "Utilitza el connector Formulari-bd ('Plugin Tracker') en una pàgina wiki per afegir elements",
"Create some custom feedback for message to the user after item insertion" => "Crea una retroalimentació personalitzada per mostrar un missatge a l'usuari després de la inserció de l'ítem",
"Uses PluginTrackerList to display inserted items" => "Utilitza el connector de Llista de Formulari-bd ('Plugin TrackerList') per mostrar els elements inserits",
"Timesheet" => "Full d'hores",
"This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names" => "Aquest perfil permet enregistrar el temps dedicat a projectes. Crea dos formularis-bd: un per mantenir el temps, i l'altre amb els noms dels projectes",
"Allows to track your time spent on projects" => "Permet realitzar un seguiment del teu temps dedicat a projectes",
"Customize your project categories" => "Personalitza les teves categories de projectes",
"Add or edit your timesheet fields as desired" => "Afegeix o edita els camps del Full d'hores si ho desitjes",
"Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker" => "Tots dos formularis-bd estan vinculats, de manera que els noms dels projectes poden ser elegits en introduir ítems al formulari-bd d'informe d'hores",
"Plugin Timesheet" => "Connector (Plugin) Full d'Hores",
"Plugin Timesheet in doc.tiki.org" => "Connector Full d'hores ('Plugin Timesheet') a doc.tiki.org",
"Tracker as Calendar" => "Formulari-bd com a Calendari",
"This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way" => "Aquest perfil crea un formulari-bd amb algunes dades de demostració i la interfície wiki que s'utilitzarà per a mostrar i gestionar un calendari d'esdeveniments d'una manera visual atractiva",
"Advanced use of Plugin TrackerList" => "Ús avançat de connector Llista de Formulari-bd ('Plugin TrackerList')",
"Working example of Plugin TrackerCalendar" => "Exemple funcional del connector CalendariDeFormulari-bd ('Plugin TrackerCalendar')",
"Drag & Drop to resize or move events" => "Arrossega i deixa anar per a redimensionar o moure esdeveniments",
"Several display modes, useful for Project & Resource Management" => "Diverses maneres de visualització, útil per a la gestió de projectes i de recursos",
"Voting System" => "Sistema de Votació",
"This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote" => "Aquest perfil estableix un sistema de votació en la qual només els membres d'un grup poden votar. Es crea un formulari-bd, 2 grups d'usuaris, un usuari en cada grup i una pàgina wiki personalitzada com a interfície per a votar",
"Group homepage set for the voting group" => "Pàgina d'inici personalitzada per al grup dels votants",
"Only one vote per member is allowed" => "Només es permet un vot per membre",
"Results shown in real time (Plugin TrackerStat)" => "Es mostren els resultats a temps real (amb 'Plugin TrackerStat')",
"Other candidates can be voted beyond the proposed" => "Es pot votar a altres candidats més enllà dels proposats",
"Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site" => "Fes una ullada a aquestes configuracions més avançades que demostren algunes altres característiques de Tiki que et podrien interessar en el teu lloc",
"Shopping Cart" => "Carret de la compra",
"This profile provides a Shopping Cart and the corresponding basic payment system" => "Aquest perfil proporciona un carret de la compra i el sistema de pagament bàsic corresponent",
"It currently uses the PayPal shopping cart rather than the built in Tiki" => "S'utilitza actualment el carret de la compra de PayPal en lloc de l'incorporat al Tiki",
"A tracker for products including price, weight, image and stock quantity" => "Un formulari-bd de productes incloent el preu, el pes, la imatge i la quantitat d'existències",
"Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users" => "Alguns ítems de mostra que tenen estat d'obert, pendent o tancat, amb diferents permisos per veure o editar per a diferents grups d'usuaris",
"A small category subtree to classify products" => "Un petit subarbre de categories per a classificar els productes",
"Wiki pages to display the available products list, one product details page and a search form" => "Pàgines Wiki per mostrar la llista de productes disponibles, una per als detalls del producte i una per al formulari de cerca",
"Easy GeoBlog" => "Geoblog fàcil",
"This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features" => "Aquest perfil mostra la geolocalització dels missatges de bloc, juntament amb altres característiques associades",
"Single map with all geolocated blog posts" => "Mapa individual amb totes les entrades del bloc geolocalitzades",
"Different home page once the user logs in" => "Pàgina principal diferent una vegada que l'usuari hi inicia la sessió",
"Random header image from files included in a file gallery" => "Imatge de capçalera aleatòria a partir dels arxius inclosos en una galeria d'arxius",
"WYSIWYG Editor (compatible mode with wiki syntax)" => "Editor WYSIWYG (mode compatible amb la sintaxi wiki)",
"Wiki, Search, Menu & Tags" => "Wiki, Cerca, Menú i Marques Lliures (tags)",
"Comments moderation & Banning (for anonymous comments to your site)" => "Moderació de comentaris i Bloqueig (per a comentaris anònims al teu lloc)",
// "Profile Conditional_Display_in_Forms" => "Profile Conditional_Display_in_Forms",
// "This profile demonstrates the setup to conditionally hide or display some fields in a form" => "This profile demonstrates the setup to conditionally hide or display some fields in a form",
// "Conditional_Display_in_Forms" => "Conditional_Display_in_Forms",
// "Main features used" => "Main features used",
// "Plugin JQ (jQuery)" => "Plugin JQ (jQuery)",
// "Plugin TrackerIf" => "Plugin TrackerIf",
// "Profile Execute_on_list" => "Profile Execute_on_list",
// "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute" => "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute",
// "Plugin ListExecute" => "Plugin ListExecute",
// "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes" => "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes",
// "Structured Master Documents" => "Structured Master Documents",
// "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more" => "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more",
// "Many pages are pre-created to let you easily set up several wiki structures" => "Many pages are pre-created to let you easily set up several wiki structures",
// "A common navigation menu is created and shown at the top of pages in the structure" => "A common navigation menu is created and shown at the top of pages in the structure",
// "You can easily print (export) them all together in a single html" => "You can easily print (export) them all together in a single html",
// "Permissions or Monitoring can be applied in bulk to the whole structure or substructures" => "Permissions or Monitoring can be applied in bulk to the whole structure or substructures",
// "Consensus Forums" => "Consensus Forums",
// "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held" => "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held",
// "Users ratings in Forums" => "Users ratings in Forums",
// "Topics with less agreement can be easily identified from the topic list" => "Topics with less agreement can be easily identified from the topic list",
// "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus" => "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus",
// "Replies can also be rated, but without affecting the topic rating average" => "Replies can also be rated, but without affecting the topic rating average",
// "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile" => "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile",
// "Barter Market" => "Barter Market",
// "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge" => "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge",
// "minimal number of fields in these trackers, which can be extended" => "minimal number of fields in these trackers, which can be extended",
// "tracker items are categorized" => "tracker items are categorized",
// "a few modules added, including a wiki page menu" => "a few modules added, including a wiki page menu",
// "best display if using just one column (right, for instance)" => "best display if using just one column (right, for instance)",
// "Revision Approval (ISO9001)" => "Revision Approval (ISO9001)",
// "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)" => "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)",
// "Additions: 1 group, 2 users, 2 wiki pages, 3 categories" => "Additions: 1 group, 2 users, 2 wiki pages, 3 categories",
// "Revision approval is set for homepage and 'official document'" => "Revision approval is set for homepage and 'official document'",
// "Wiki Argument Variables are used in the 'official document'" => "Wiki Argument Variables are used in the 'official document'",
"Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles" => "Inicialitza Tiki com una aplicació, per exemple, un bloc, mitjançant l'aplicació d'un dels 4 perfils de configuració destacats",
"Collaborative Community" => "Comunitat Col·laborativa",
"Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Configuració per ajudar a experts en el tema i els entusiastes de treballar junts per construir una base de coneixement",
"Uses" => "Usa",
"Wiki Editing" => "Edició Wiki",
"Personal Member Spaces" => "Espais personals dels membres",
"Company Intranet" => "Intranet d'Empresa",
"Setup for a Corporate Intranet of a typical medium-sized business" => "Configuració d'una Intranet corporativa d'una empresa típica de mida mitjana",
"Company News Articles" => "Articles de Notícies de l'Empresa",
"Executive Blog" => "Bloc Executiu",
"File Repository & Management" => "Repositori i gestió d'arxius",
"Collaborative Wiki" => "Wiki col·laboratiu",
"Personal Blog and Profile" => "Bloc i perfil personal",
"Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Configuració amb moltes característiques interessants per ajudar a integrar la web social i establir una forta presència a la blogosfera",
"Blog (Full set of blog related features)" => "Bloc (conjunt complet de característiques relacionades amb el blog)",
"RSS Integration" => "Integració de notícies per RSS",
"Video Log" => "Registre de Vídeos",
"Small Organization Web Presence" => "Presència Web d'Organització Petita",
"Setup for a Web Presence of a typical small business or non-profit" => "Configuració per a la presència a la web d'una petita entitat típica o organització sense ànim de lucre",
"Company News & Updates" => "Notícies i actualitzacions de l'entitat",
"Highlight Company's Products and Services" => "Productes i serveis destacats de la companyia",
"File Gallery (great for Media Kit)" => "Galeria d'arxius (ideal per a Kit Multimedia)",
"Contact Form" => "Formulari de contacte",
// "Profiles admin card" => "Profiles admin card",
// "Check out some useful changes in the configuration for site administrators" => "Check out some useful changes in the configuration for site administrators",
"Debug Mode Enabled" => "Mode de depuració Habilitat ('Debug_Mode_Enabled')",
"Debug Mode Disabled" => "Mode de depuració Deshabilitat ('Debug_Mode_Disabled')",
"Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise" => "El perfil <i>Debug_Mode_Enabled</i> t'ajudarà a detectar possibles errors i advertències que queden amagats sinó",
"Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand" => "Un cop aplicat, potser voldràs saber com aplicar el perfil oposat: <i>Debug_Mode_Disabled</i>, si no canvies la configuració apropiada a mà",
"Enables/Disables debugging tools" => "Habilita/Deshabilita les eines de depuració",
"Enables/Disables logging tools" => "Habilita/Deshabilita les eines de registre",
"Disables/Enables redirections to similar pages" => "Deshabilita/Habilita les redireccions a pàgines similars",
"Enables/Disables error and warning display to all users, not only admins" => "Habilita/Deshabilita el fet de mostrar errors i advertències en pantalla a tots els usuaris, no només als administradors",
// "This configuration profile enables the Scheduler feature and loads a preset of schedulers" => "This configuration profile enables the Scheduler feature and loads a preset of schedulers",
// "Each scheduler can replace a former cron job action in the server" => "Each scheduler can replace a former cron job action in the server",
// "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need" => "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need",
// "This configuration profile showcases the activity stream feature in Tiki" => "This configuration profile showcases the activity stream feature in Tiki",
// "Activity Stream data can also be reviewed through PluginPivotTable" => "Activity Stream data can also be reviewed through PluginPivotTable",
// "It is somewhat similar to the basic Action log feature in Tiki" => "It is somewhat similar to the basic Action log feature in Tiki",
"Check out some useful profiles that involve changing the display mode of content in your site" => "Fes una ullada a alguns perfils útils que impliquen canviar la manera de presentar el contingut al teu lloc",
"Slideshow demo" => "Demo de Presentació de Diapositives",
// "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works" => "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works",
"All content is in a wiki page, which can be printed to your audience in just a few sheets of paper" => "Tot el contingut es troba en una pàgina wiki, que es pot imprimir per al teu públic en tan sols uns pocs fulls de paper",
"Headers of different levels are used as markers of 'new slide' and used as titles" => "Les capçaleres de diferent nivell s'utilitzen com a marcadors de 'nova diapositiva' i s'utilitzen com als seus títols",
"Many settings can be predefined as parameters of a call to PluginSlideshow" => "Es poden predefinir molts ajustos com a paràmetres d'una crida al Connector Presentació de Diapositives (PluginSlideshow)",
"Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to" => "Permet notes de les diapositives en una pantalla diferent per a les configuracions amb monitor dual, números de diapositiva al peu de pàgina, comptador de temps, estil amb imatges de fons, barra de navegació amb la llista de totes les diapositives per saltar-ne a qualsevol altra",
// "Hide Fixed Top Navigation Bar on scroll" => "Hide Fixed Top Navigation Bar on scroll",
// "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards" => "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards",
// "Hide Fixed Top Navi Bar on Scroll" => "Hide Fixed Top Navi Bar on Scroll",
// "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'" => "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'",
// "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice" => "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice",
// "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky" => "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky",
// "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus" => "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus",
"Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration" => "Fes una ullada a aquest conjunt de perfils potencialment útils per al teu lloc que impliquen només una petita quantitat de canvis en la configuració del lloc",
"Menu on Wiki page" => "Menú en pàgina Wiki",
"This profile sets up a side module with a menu based on a wiki page in the right hand-side column" => "Aquest perfil configura un mòdul lateral amb un menú basat en una pàgina wiki a la columna del costat de la dreta",
"With this profile you can" => "Amb aquest perfil es pot",
"use wiki syntax to edit it" => "utilitzar la sintaxi wiki per a editar-lo",
"delegate its edition with wiki page permissions" => "delegar la seva edició amb permisos a nivell de pàgina wiki",
"use plugins to manage conditional display of sections" => "utilitzar connectors (plugins) per a gestionar la visualització condicional de seccions",
"Random header images" => "Imatges de capçalera a l'atzar",
"This profile adds a module in the top zone that displays a random image from a File Gallery" => "Aquest perfil afegeix un mòdul a la zona superior que mostra una imatge aleatòria a partir de les que hi ha a una galeria d'arxius",
"Some sample images to fit the default configuration are also provided as a starting point" => "S'inclouen algunes imatges de mostra, com a punt de partida, adaptades a la configuració per omissió",
"default configuration uses images at 800x150px resized by the top module parameters to match the header default size" => "la configuració predeterminada utilitza imatges en 800x150px redimensionades pels paràmetres del mòdul superior perquè coincideixin amb la mida que té la capçalera per omissió",
"a different random image is shown at each page load" => "es mostra una imatge aleatòria diferent en cada càrrega de pàgina",
"elFinder modern file galery manager (with drag & drop capabilities!) is used by default" => "s'utilitza per omissió el gestor modern de galeries d'arxius 'elFinder' (que permet arrossegar i deixar anar arxius!)",
"you can tweak the module and file gallery defaults as needed for your needs" => "pots ajustar el mòdul i els paràmetres per omissió de la galeria d'arxius segons necessitis",
"Multilingual Wiki" => "Wiki multilingüe",
"This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion" => "Aquest perfil permet la traducció de continguts de Tiki, i estableix els mòduls per canviar l'idioma, així com per mostrar els enllaços a les pàgines de traducció amb el seu grau d'acabament",
"The enabled features comprise" => "Les característiques habilitades comprenen",
"Multilingual freetags" => "Marques Lliures (tags) multilingües",
"Countries By Region" => "Països per Regió",
"This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions" => "Aquest perfil crearà un conjunt de categories i subcategories en el teu lloc amb els noms dels països agrupats per regions",
"The regions listed with their countries are" => "Les regions que figuren amb els seus països són",
"Saharan, Sub-Saharan Africa" => "Àfrica Sahariana i Sub-Sahariana",
"Middle East, North Africa" => "Àfrica del Nord, i Central de l'Est",
"Asia" => "Àsia",
"North, Central America" => "Amèrica Central i del Nord",
"Oceania" => "Oceania",
"South America" => "Amèrica del Sud",
"Check out this set of useful configurations that involve using some new technology for your site" => "Fes una ullada a aquest conjunt de configuracions útils que impliquen l'ús d'una nova tecnologia per al teu lloc",
"Write Together" => "Escriviu Junts",
"This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS" => "Aquest perfil afegeix una pàgina wiki simple en un mòdul lateral (amb el Mòdul menupage), que mostra el botó per iniciar la co-escriptura amb TogetherJS",
"Allows cowriting documents in real time" => "Permet escriure documents entre vàries persones en temps real",
"Allows voice communication in real time while editing" => "Permet la comunicació de veu en temps real durant l'edició",
"Uses the TogetherJS Mozilla widget" => "Utilitza el giny TogetherJS de Mozilla",
"Post-it Sticky Note" => "Notes Post-it Adhesives",
"This profile allows to display a sticky note (a \"post-it\") in your tiki site" => "Aquest perfil permet mostrar una nota adhesiva (un \"post-it\") al teu lloc tiki",
"You can move it to another location" => "Pots moure-les a una altra ubicació",
"You can customize the contents and which groups of users will see it (by default, only to Admins)" => "Pots personalitzar-ne el seu contingut i quins els grups d'usuaris les veuran (per omissió, només visible per als administradors)",
"It will be shown for each user of that group until manually closed" => "Es mostra per a cada usuari d'aquest grup fins que es tanqui manualment",
// "Groupmail" => "Groupmail",
// "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages" => "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages",
// "A tracker for email messages received and store addresses in the Contacts feature" => "A tracker for email messages received and store addresses in the Contacts feature",
// "Webmail configuration to use an account for groupmail" => "Webmail configuration to use an account for groupmail",
// "A side module with markers to indicate who took which message" => "A side module with markers to indicate who took which message",
// "A system to review communication logs from that group mail account" => "A system to review communication logs from that group mail account",
// "Profile X" => "Profile X",
// "This profile allows to " => "This profile allows to ",
// "Feature_X in doc.tiki.org" => "Feature_X in doc.tiki.org",
// "User Dummy" => "User Dummy",
// "This is a dummy page" => "This is a dummy page",
"Set up basic information as a user on this site" => "Posa a punt la informació bàsica com a usuari en aquest lloc",
"Your personal Wiki Page" => "La teva pàgina personal al Wiki",
"The feature 'User Preferences' is currently disabled in this site" => "La funcionalitat 'Preferències d'Usuari/a' es troba actualment deshabilitada en aquest lloc web",
"Enable the feature" => "Habilita la funcionalitat",
"Enable it" => "Habilita-la",
"You might ask your site admin to enable it" => "Podries demanar-li a l'administrador del lloc d'habilitar-ho",
"Use 'watches' to monitor wiki pages or other objects" => "Empra 'notificacions per correu-e' per monitorejar pàgines wiki o altres objectes",
"Set up below preferences related to receiving notifications by email about changes in the site" => "Posa a punt a sota les preferències relacionades amb la rebuda de notificacions per correu-e sobre canvis en el lloc",
"Send notification when I am the editor:" => "Envia un correu-e de notificació de canvis, també quan jo sóc l'editor que els fa, en les seccions escollides a sota:",
"The feature user watches is disabled in this site" => "La funcionalitat de notificacions d'usuari es troba deshabilitada en aquest lloc",
"Set up the general settings for your account" => "Posa a punt els paràmetres del teu compte",
"User Params" => "Paràmetres d'Usuari/a",
"Is email public? (uses scrambling to prevent spam)" => "És públic aquest correu-e ? (per a provenir spam)",
"Does your email application need a special character set" => "Necessita el teu programa lector de correu-e un conjunt de caracters especial",
"Preferred language" => "Idioma/es preferit/s",
"Site time zone is enforced and overrides user preferences" => "La zona horària del lloc està fixada i mana per sobre de les preferències d'usuari",
"The feature with the user preferences screen is disabled in this site" => "La funcionalitat amb la pantalla de preferències d'usuari es troba deshabilitada en aquest lloc",
"Use reports to summarise notifications about objects you are watching" => "Empra informes per a resumir les notificacions per correu-e sobre els objectes que estàs seguint",
"You are not allowed to remove this notification " => "No se li permet eliminar aquesta notificació",
"Interval in which you want to get the reports" => "Interval per al qual vols rebre els resums periòdics",
"HTML-Email" => "Correu-e en HTML",
"Send me an email also if nothing happened" => "Envia'm un correu-e també si no passa res",
"The feature daily reports of user watches is disabled in this site" => "La funcionalitat d'informes diaris de notificacions d'usuari per correu-e es troba deshabilitada en aquest lloc",
"Use this form to fill in some extra information about you" => "Utilitza aquest formulari per a introduir una mica més d'informació sobre tu",
"Extra information about you" => "Més informació sobre tu",
"Tiki User Wizard" => "Assistent d'Usuaris de Tiki",
"This wizard will help you fill in data and main settings for your account on this website" => "Aquest assistent t'ajudarà a omplir les dades i paràmetres principals per al teu compte en aquest lloc web",
"Depending on the features enabled by the site admin, you will be offered more or less options" => "Depenent de les funcionalitats habilitades pels administradors del lloc, se't mostraran més o menys opcions",
"If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature" => "Si no pots indicar les teves preferències d'usuari (Nom real, si mantenir la teva informació pública o privada, selecció de fus horari, ...), pots demanar als administradors del lloc d'habilitar la funcionalitat de preferències d'usuari",
"Click at the \"Start\" button above to launch it" => "Clica al botó \"Inici\" de sobre per a iniciar-lo",
"To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>" => "Per obtenir més informació sobre aquesta versió de Tiki, ves a <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>",
"You are done with the user wizard" => "Has acabat amb l'assistent d'usuaris",
"Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences" => "Visita la pàgina de les <a href=\"%0\">Preferències d'Usuari</a> completes per a configurar les teves altres preferències",
"Or..." => "O...",
"Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were" => "Clica al botó  <strong>Finalitza</strong> per a acabar l'assistent d'usuaris i retornar a on eres",
// "Show on admin log-in" => "Show on admin log-in",
"Finish" => "Finalitza",
// "Start the Wizardry" => "Start the Wizardry",
"Save and Continue" => "Desa-ho i Continúa",
"No turning back" => "No hi ha marxa enrere",
"Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available" => "Una vegada que encén la seva plantilla per al mode avançat, no hi ha marxa enrere. La interfície senzilla ja no estarà disponible",
"Return to simple interface" => "Tornar a la senzilla interfície",
// "Workspace Name" => "Workspace Name",
"Wiki Page Source" => "Wiki Pàgina Font",
"Not enough options" => "No hi ha prou opcions",
"This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power" => "Aquesta és la interfície d'edició senzilla que ofereix un subconjunt de les funcions disponibles. Botons controlen el nivell avançat i obtenir més poder",
"Advanced Mode" => "Mode avançat",
"Bind area" => "Àrea Bind",
"Is managing group" => "És la gestió de grup",
"Workspace creator joins this group" => "Espai de treball creador s'uneix a aquest grup",
"Add group" => "Afegir grup",
"Select Permissions" => "Seleccioneu Permisos",
"Edit content template" => "Edita plantilla de contingut",
"Add page" => "Afegir pàgina",
// "Default (Font-awesome)" => "Default (Font-awesome)",
// "The default system icon set using Font-awesome fonts" => "The default system icon set using Font-awesome fonts",
// "Solid" => "Solid",
// "Outline" => "Outline",
// "Font Awesome Regular" => "Font Awesome Regular",
// "Font Awesome Pro Only" => "Font Awesome Pro Only",
// "Brands" => "Brands",
// "Legacy (pre Tiki14) icons" => "Legacy (pre Tiki14) icons",
// "Legacy (pre Tiki14) icons, mainly using famfamfam images" => "Legacy (pre Tiki14) icons, mainly using famfamfam images",
// "Custom icons" => "Custom icons",
// "Custom icons for the theme" => "Custom icons for the theme",
// "Theme icons" => "Theme icons",
// "Icons to be used for this theme" => "Icons to be used for this theme",
// "This field is manadatory" => "This field is manadatory",
"Design by" => "Dissenyat per",
"Missing book id" => "Falta el ID del llibre",
"You do not have the right view this page" => "No tens la visió correcta aquesta pàgina",
// "%0 account in book %1 modified" => "%0 account in book %1 modified",
// "%0 account created for book %1" => "%0 account created for book %1",
// "Account %0 in book %1 unlocked" => "Account %0 in book %1 unlocked",
// "Account %0 in book %1 not unlocked" => "Account %0 in book %1 not unlocked",
// "Account %0 in book %1 locked" => "Account %0 in book %1 locked",
// "Account %0 in book %1 not locked" => "Account %0 in book %1 not locked",
// "Delete account %0 from book %1" => "Delete account %0 from book %1",
// "%0 account deleted from book %1" => "%0 account deleted from book %1",
"Missing account id" => "Falta el ID de compte",
"You do not have the rights to view this account" => "No tens els drets per veure aquest compte",
"You do not have the rights to manage accounts" => "No tens els drets per administrar comptes",
// "You do not have permission to create a book" => "You do not have permission to create a book",
// "Book %0 successfully created" => "Book %0 successfully created",
// "You do not have permission to close this book" => "You do not have permission to close this book",
// "Close book (this action cannot be undone)" => "Close book (this action cannot be undone)",
// "Book successfully closed" => "Book successfully closed",
// "The attempt to close the book was unsuccessful" => "The attempt to close the book was unsuccessful",
// "Cancel journal %0 in book %1" => "Cancel journal %0 in book %1",
// "Journal shown below successfully canceled" => "Journal shown below successfully canceled",
"Missing journal id" => "Falta Identificació de la revista",
"You do not have the right to cancel transactions" => "No tens el dret de cancel·lar les operacions",
"Error retrieving data from journal" => "Error en recuperar les dades de diari",
"You do not have the right to book" => "No tens el dret de reservar",
// "Record entry in book %0" => "Record entry in book %0",
// "Journal %0 successfully recorded in book %1" => "Journal %0 successfully recorded in book %1",
"Don't know what to export" => "No sé què exportar",
"You do not have the right export/view this data" => "No tens el dret d'exportació / veure aquesta informació",
"You do not have the right to book into the stack" => "No tens el dret de reservar a la pila",
// "Record stack entry in book %0" => "Record stack entry in book %0",
// "Modify stack entry in book %0" => "Modify stack entry in book %0",
// "Delete stack %0 from book %1" => "Delete stack %0 from book %1",
// "Confirm stack %0 for book %0" => "Confirm stack %0 for book %0",
// "Stack %0 successfully modified in book %1" => "Stack %0 successfully modified in book %1",
// "Stack %0 successfully deleted from book %1" => "Stack %0 successfully deleted from book %1",
// "Stack %0 recorded in book %1" => "Stack %0 recorded in book %1",
// "Stack %0 deleted from book %1" => "Stack %0 deleted from book %1",
// "Stack %0 confirmed and recorded as entry in book %1" => "Stack %0 confirmed and recorded as entry in book %1",
"Tiki Calendar" => "Calendari del Tiki",
"%0 enabled" => "%0 ha estat habilitat/da",
"%0 disabled" => "%0 ha estat deshabilitat/da",
"%0 set" => "%0 ha estat posat/da",
"%0 unset" => "%0 ha estat tret/a",
// "item added" => "item added",
// "items added" => "items added",
// "item deleted" => "item deleted",
// "items deleted" => "items deleted",
"Help on Configuration Sections" => "Ajuda en seccions de configuració",
// "Default preference filters set" => "Default preference filters set",
"%0 reset" => "reinici de %0",
"Search error" => "Error de cerca",
// "Global site configuration, date formats, etc" => "Global site configuration, date formats, etc",
"Switches for major features" => "Interruptors per les principals característiques",
"User registration, remember me cookie settings and authentication methods" => "Registre d'usuaris, recorda't de mi configuració de cookies i mètodes d'autenticació",
// "User related preferences like info and picture, features, messages and notification, files, etc" => "User related preferences like info and picture, features, messages and notification, files, etc",
"Repository configuration, browse and apply profiles" => "Configuració del repositori, buscar i aplicar perfils",
"Look & Feel" => "Aparença",
"Theme selection, layout settings and UI effect controls" => "Selecció de temes, la configuració de disseny d'interfície d'usuari i controls d'efectes",
"Editing and Plugins" => "Edició i connectors (Plugins)",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Aspectes relacionats amb l'edició de text aplicables a molts àrees. Activació de connectors (plugins) i gestió dels alias de connectors",
"Module appearance settings" => "Configuració d'aspecte del mòdul",
"i18n" => "i18n (Internacionalització i idiomes)",
"Internationalization and localization - multilingual features" => "Internacionalització i localització - les característiques multilingües",
"Meta Tags" => "Meta Etiquetes",
"Information to include in the header of each page" => "Informació a incloure en la capçalera de cada pàgina",
"Maps" => "Mapes",
"Settings and features for maps" => "Configuració i característiques dels mapes",
"Server performance settings" => "Configuració de rendiment del servidor",
"Site security settings" => "Aspectes de configuració del lloc",
"Outgoing RSS feed setup" => "Configuració feed RSS sortint",
"Tiki Connect - join in" => "Tiki Connect - participa-hi",
// "Rating settings" => "Rating settings",
"Search configuration" => "Configuració de cerca",
"Wiki page settings and features" => "Configuració i funcionalitats de pàgines Wiki",
"Defaults and configuration for file galleries" => "Valors predefinits i la configuració de les galeries d'arxius",
"Settings for blogs" => "Ajustos per blocs",
"Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Incompliments i configuració per a galeries d'imatges (s'eliminaran gradualment en favor de les galeries d'arxius)",
"Settings and features for articles" => "Configuració i característiques dels articles",
"Settings and features for forums" => "Configuració i característiques dels fòrums",
"Settings and features for trackers" => "Configuració i característiques per trackers",
"Settings and features for polls" => "Configuració i característiques dels sondejos",
"Settings and features for calendars" => "Configuració i característiques dels calendaris",
"Settings and features for categories" => "Configuració i característiques de les categories",
"Configure workspace feature" => "Configurar l'espai de treball de funció",
"Values of actions for users rank score" => "Els valors de les accions dels usuaris puntuació de rang",
"Settings and features for tags" => "Configuració i característiques per marques lliures",
"Settings and features for FAQs" => "Configuració i característiques de FAQs",
"Settings and features for directory of links" => "Configuració i les característiques del directori d'enllaços",
"Site-wide copyright information" => "Informació del lloc en tot el dret d'autor",
"Message settings" => "Configuració de missatges",
// "Webmail settings" => "Webmail settings",
"Options for WYSIWYG editor" => "Opcions per a l'editor WYSIWYG",
// "Site advertisements and notices" => "Site advertisements and notices",
"InterTiki" => "InterTiki",
"Set up links between Tiki servers" => "Enllaçar servidors Tiki",
"Manage semantic wiki links" => "Administrar enllaços wiki semàntica",
"Register and manage web services" => "Registrar i gestionar els serveis web",
// "SEF URL" => "SEF URL",
"Video integration configuration" => "Configuració de la integració de vídeo",
// "Payment settings" => "Payment settings",
"Configure social networks integration" => "Configureu la integració de les xarxes socials",
"User specific features and settings" => "Funcions i paràmetres específics de l'usuari",
"Configure share feature" => "Configura funció de compartir",
// "Configure statistics reporting for your site usage" => "Configure statistics reporting for your site usage",
// "Print Settings" => "Print Settings",
// "Settings and features for print versions and pdf generation" => "Settings and features for print versions and pdf generation",
// "External packages installation and management" => "External packages installation and management",
// "RTC" => "RTC",
// "Real-time collaboration tools" => "Real-time collaboration tools",
"Help on %0 Config" => "Ajuda en %0 Config",
// "Remove selected actions" => "Remove selected actions",
// "The selected action has been deleted from the log" => "The selected action has been deleted from the log",
// "%0 actions have been deleted from the log" => "%0 actions have been deleted from the log",
// "No actions were deleted from the log" => "No actions were deleted from the log",
"Must specify actionId" => "Cal especificar actionID",
"Users Contributions: Addition" => "Contribucions dels Usuaris: Suma",
"%s Contributions: Addition" => "%s Contribucions: Suma",
"Users Contributions: Suppression" => "Contribucions dels Usuaris: supressió",
"%s Contributions: Suppression" => "%s Contribucions: supressió",
"Total Contributions Addition per Day" => "Contribucions totals addició per Dia",
"Total Contributions Addition per Week" => "Contribucions totals addició per Setmana",
"Total Contributions Suppression per Day" => "Contribucions total supressió per Dia",
"Total Contributions Suppression per Week" => "Contribucions total supressió per Setmana",
"Total Contributions: Addition" => "Total de contribucions: Suma",
"Total Contributions: Suppression" => "Total de contribucions: supressió",
"Groups Contributions: Addition" => "Grups Contribucions: Suma",
"Groups Contributions: Suppression" => "Grups Contribucions: supressió",
"white" => "blanc",
"gray" => "gris",
"silver" => "plata",
"ivory" => "ivori",
"whitesmoke" => "whiteSmoke",
"beige" => "beix",
"darkgrey" => "darkgrey",
// "No rule selected for deletion. No deletions were performed" => "No rule selected for deletion. No deletions were performed",
// "The selected banning rule has been deleted" => "The selected banning rule has been deleted",
// "%0 banning rules have been deleted" => "%0 banning rules have been deleted",
// "The following banning rule has been saved or replaced" => "The following banning rule has been saved or replaced",
// "The following %0 banning rules have been saved or replaced" => "The following %0 banning rules have been saved or replaced",
// "No changes were made to the following selected banning rules" => "No changes were made to the following selected banning rules",
// "Only %0 of the selected banning rules shown below were added or changed" => "Only %0 of the selected banning rules shown below were added or changed",
// "No banning rules were selected" => "No banning rules were selected",
"Multiple IP Banning" => "Multiple IP Banning",
"Access from your localization was forbidden due to excessive spamming" => "L'accés des de la seva localització ha estat prohibit per excessiu spamming",
// "Not saved" => "Not saved",
// "Username pattern empty" => "Username pattern empty",
// "Default IP pattern still set" => "Default IP pattern still set",
// "Calendar %0 deleted" => "Calendar %0 deleted",
// "Calendar %0 not deleted" => "Calendar %0 not deleted",
// "One calendar event deleted" => "One calendar event deleted",
// "No calendar events deleted" => "No calendar events deleted",
// "%0 calendar events deleted" => "%0 calendar events deleted",
// "No such category with parentID %0" => "No such category with parentID %0",
// "One object unassigned from category" => "One object unassigned from category",
// "%0 objects unassigned from category" => "%0 objects unassigned from category",
// "No objects unassigned" => "No objects unassigned",
// "Incorrect category ID %0 - objects not moved" => "Incorrect category ID %0 - objects not moved",
// "One object moved to selected category" => "One object moved to selected category",
// "%0 objects moved to selected category" => "%0 objects moved to selected category",
// "No objects moved" => "No objects moved",
// "Incorrect category ID %0 - objects not copied" => "Incorrect category ID %0 - objects not copied",
// "One object copied to selected category" => "One object copied to selected category",
// "%0 objects copied to selected category" => "%0 objects copied to selected category",
// "No objects copied" => "No objects copied",
// "One page added to category" => "One page added to category",
// "%0 pages added to category" => "%0 pages added to category",
// "No pages added to category" => "No pages added to category",
// "%0 %1 removed from category %2" => "%0 %1 removed from category %2",
// "%0 %1 not removed from category %2" => "%0 %1 not removed from category %2",
// "Delete category" => "Delete category",
// "Category ID %0 and descendants deleted" => "Category ID %0 and descendants deleted",
// "Category ID %0 not deleted" => "Category ID %0 not deleted",
// "Category cannot be parent of itself - no changes made" => "Category cannot be parent of itself - no changes made",
// "Category %0 updated" => "Category %0 updated",
// "Category %0 created" => "Category %0 created",
"The file does not have the required header:" => "L'arxiu no té l'encapçalamet requerit:",
// "Incorrect parameter %0" => "Incorrect parameter %0",
// "Categories imported" => "Categories imported",
"Edit permissions for this category" => "Edita els permisos per a aquesta categoria",
// "Assign permissions" => "Assign permissions",
// "Template removed" => "Template removed",
// "Template not removed" => "Template not removed",
// "Section removed" => "Section removed",
// "Section not removed" => "Section not removed",
// "Template %0 created or modified" => "Template %0 created or modified",
// "Template %0 not created or modified" => "Template %0 not created or modified",
// "Contribution settings saved" => "Contribution settings saved",
// "Contribution settings not saved" => "Contribution settings not saved",
// "Contribution added" => "Contribution added",
// "Contribution not added" => "Contribution not added",
// "Contribution modified" => "Contribution modified",
// "Contribution not modified" => "Contribution not modified",
// "Contribution removed" => "Contribution removed",
// "Contribution not removed" => "Contribution not removed",
// "Cookie removed" => "Cookie removed",
// "Cookie not removed" => "Cookie not removed",
// "All cookies removed" => "All cookies removed",
// "No cookies removed" => "No cookies removed",
// "File uploaded and one cookie created or replaced" => "File uploaded and one cookie created or replaced",
// "File uploaded and %0 cookies created or replaced" => "File uploaded and %0 cookies created or replaced",
// "Upload failed - no cookies created" => "Upload failed - no cookies created",
"Upload failed" => "Ha fallat la pujada",
// "Cookie saved" => "Cookie saved",
// "Cookie not saved" => "Cookie not saved",
"Admin credits" => "Crèdits admin",
// "DSN removed" => "DSN removed",
// "DSN not removed" => "DSN not removed",
// "DSN created or modified" => "DSN created or modified",
// "DSN not created or modified" => "DSN not created or modified",
// "External wiki removed" => "External wiki removed",
// "External wiki not removed" => "External wiki not removed",
// "External wiki saved" => "External wiki saved",
// "External wiki not saved" => "External wiki not saved",
// "Forum saved" => "Forum saved",
// "Forum not saved" => "Forum not saved",
// "Forum duplicated" => "Forum duplicated",
// "Forum not duplicated" => "Forum not duplicated",
"All posted" => "Tots els enviaments",
"Queue anonymous posts" => "Encua les publicacions anònimes",
"Queue all posts" => "Encua totes les publicacions",
"No attachments" => "Cap adjunt",
"Everybody can attach" => "Tots poden adjuntar",
"Only users with attach permission" => "Només usuaris/es amb permís per a adjuntar ",
"Moderators and admin can attach" => "Els Moderadors i administradors poden adjuntar",
"No display" => "Sense visualització",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Punts (desc)",
"Replies (desc)" => "Respostes (desc)",
"Reads (desc)" => "Lectures (desc)",
"You have to provide a hotword and a URL" => "Has de proveïr una paraula calenta i una URL",
// "Hotword added" => "Hotword added",
// "Hotword not added" => "Hotword not added",
// "Hotword deleted" => "Hotword deleted",
// "Hotword not deleted" => "Hotword not deleted",
// "One dynamic zone updated" => "One dynamic zone updated",
// "%0 dynamic zones updated" => "%0 dynamic zones updated",
// "Dynamic zones not updated" => "Dynamic zones not updated",
// "Hotword saved" => "Hotword saved",
// "Hotword not saved" => "Hotword not saved",
// "HTML page removed" => "HTML page removed",
// "HTML page not removed" => "HTML page not removed",
// "HTML page saved" => "HTML page saved",
// "HTML page not saved" => "HTML page not saved",
// "A custom rule with the same ID already exists" => "A custom rule with the same ID already exists",
// "Tiki IDS is not enabled" => "Tiki IDS is not enabled",
"Requested action is not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"Repository name can't be an empty" => "El nom de dipòsit no pot quedar buit",
"No repository" => "Cap dipòsit",
"Search is mandatory field" => "Buscar es camp obligatori",
"File not found " => "No s'ha trobat el fitxer ",
"Requested action in not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"You need to apply the \"Invoice\" profile" => "Cal aplicar el perfil de configuració \"Invoice\" (factura)",
// "Remove keywords" => "Remove keywords",
// "Keywords for page \"%0\" saved" => "Keywords for page \"%0\" saved",
// "Keywords for page \"%0\" removed" => "Keywords for page \"%0\" removed",
// "Keywords were not updated" => "Keywords were not updated",
// "Featured link saved" => "Featured link saved",
// "Featured link not saved" => "Featured link not saved",
// "Non-existent link" => "Non-existent link",
// "Featured link removed" => "Featured link removed",
// "Featured link not removed" => "Featured link not removed",
"Frequency should be a positive integer!" => "la Freqüència hauria de ser un integrador positiu",
"Mail-in accounts set to be checked every %s minutes" => "S'ha especificat que es comprovin cada %s minuts els comptes de Correu-dins",
"Automatic Mail-in accounts checking disabled" => "Estàs desactivada la comprovació de comptes correu-dins automàtica",
"No menu indicated" => "No s'indica cap menú",
// "Delete menu ID %0" => "Delete menu ID %0",
// "Reset the Application Menu to the current system default" => "Reset the Application Menu to the current system default",
// "Module file in use. You need to edit %0 to configure your modules" => "Module file in use. You need to edit %0 to configure your modules",
// "%0 cache files cleared" => "%0 cache files cleared",
// "Module unassigned" => "Module unassigned",
// "Module not unassigned" => "Module not unassigned",
// "Displayed order may not change if other modules now have the same order rank" => "Displayed order may not change if other modules now have the same order rank",
// "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1" => "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1",
// "Standard module display order moved up" => "Standard module display order moved up",
// "Standard module display order not moved up" => "Standard module display order not moved up",
// "Standard module display order moved down" => "Standard module display order moved down",
// "Standard module display order not moved down" => "Standard module display order not moved down",
// "Standard display of modules reordered or moved" => "Standard display of modules reordered or moved",
// "Standard display of modules not reordered or moved" => "Standard display of modules not reordered or moved",
// "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1" => "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1",
"Cannot create or update module: You need to specify a name for the module" => "No es pot crear o actualitzar el mòdul: cal especificar el nom del mòdul",
"Cannot create or update module: You cannot leave the data field empty" => "No es pot crear o actualitzar el mòdul: no es pot deixar buit el camp data",
"A module with that \"name\" already exists, please choose another" => "Un mòdul amb aquest \"name\" ja existeix, per favor tria un altre",
// "Custom module created" => "Custom module created",
// "Custom module modified" => "Custom module modified",
// "Custom not module created" => "Custom not module created",
// "Custom module not modified" => "Custom module not modified",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module",
// "Module assigned" => "Module assigned",
// "Module not assigned" => "Module not assigned",
// "Custom module deleted" => "Custom module deleted",
// "Custom module not deleted" => "Custom module not deleted",
"Appearance" => "Aparença",
"No newsletter indicated" => "No s'ha indicat cap butlletí",
"Newsletter does not exist" => "Butlletí no existeix",
// "subscription" => "subscription",
// "subscriptions" => "subscriptions",
// "No subscriptions removed" => "No subscriptions removed",
// "Subscription removed" => "Subscription removed",
// "Subscription not removed" => "Subscription not removed",
// "Subscription marked as valid" => "Subscription marked as valid",
// "Subscription not marked as valid" => "Subscription not marked as valid",
// "Errors encountered when attempting to add subscription" => "Errors encountered when attempting to add subscription",
// "Subscription added" => "Subscription added",
"Error opening uploaded file" => "Error en obrir el fitxer enviat",
// "Error importing from wiki page \"%0\"" => "Error importing from wiki page \"%0\"",
// "Wiki page \"%0\" imported" => "Wiki page \"%0\" imported",
// "Error importing from tracker ID %0" => "Error importing from tracker ID %0",
// "Tracker ID %0 imported" => "Tracker ID %0 imported",
// "Not all subscriptions created" => "Not all subscriptions created",
// "Subscriptions not created" => "Subscriptions not created",
// "Subscriptions created" => "Subscriptions created",
// "Group \"%0\" subscribed" => "Group \"%0\" subscribed",
// "Group \"%0\" not subscribed" => "Group \"%0\" not subscribed",
// "Subscribers added" => "Subscribers added",
// "Subscribers not added" => "Subscribers not added",
// "Emails from wiki page \"%0\" subscribed" => "Emails from wiki page \"%0\" subscribed",
// "Emails from wiki page \"%0\" not subscribed" => "Emails from wiki page \"%0\" not subscribed",
// "%0 \$word removed" => "%0 \$word removed",
// "Newsletter removed" => "Newsletter removed",
// "Newsletter not removed" => "Newsletter not removed",
// "Newsletter created or modified" => "Newsletter created or modified",
// "Newsletter not created or modified" => "Newsletter not created or modified",
"You need to provide a username or an email" => "Ha d'indicar un nom d'usuari o un correu-e",
"The user has no email set. No notifications will be sent" => "L'usuari no té conjunt de correu electrònic. No s'enviaran les notificacions",
// "Mail notification event added" => "Mail notification event added",
// "Mail notification event deleted" => "Mail notification event deleted",
// "One mail notification events deleted" => "One mail notification events deleted",
// "%0 mail notifications events deleted" => "%0 mail notifications events deleted",
"No poll indicated" => "No s'indica cap sondeig",
// "Name is required" => "Name is required",
// "Task is required" => "Task is required",
// "Run Time is required" => "Run Time is required",
// "Run Time format is invalid" => "Run Time format is invalid",
// "Status cannot be empty" => "Status cannot be empty",
// "Scheduler %s was updated" => "Scheduler %s was updated",
// "Scheduler %s was created" => "Scheduler %s was created",
"Inactive" => "Inactiu/va",
"unsafe" => "insegur",
"The Path to store files in the filegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'arxius ha d'estar fora del directori arrel de tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'imatges ha d'estar fora del directori arrel de tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "La funcionalitat \"Edita Plantilles\" està activada. No permetis emprar aquesta funcionalitat a ningú amb qui no confiïs. Pot ser emprada fàcilment per injectar codi php.",
"The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "El \"Snarf Wikiplugin\" està activada. Pot ser utilitzat pels editors de wiki per incloure les pàgines de la xarxa local i a través de reemplaçament d'expressions regulars crear qualsevol codi HTML",
"The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement" => "El \"Wikiplugin Regex\" està activada. Pot ser utilitzat pels editors de wiki per crear qualsevol HTML a través de reemplaçament d'expressions regulars",
"The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "El \"Lsdir Wikiplugin\" està activada. Pots ser utilitzat pels editors de wiki per veure el contingut de qualsevol directori",
"The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "El \"Bloglist Wikiplugin\" està activada. Pot ser utilitzat pels editors de wiki per divulgar publicacions al bloc privat",
"The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "El \"Wikiplugin iframe\" està activada. Pot ser utilitzat pels editors de wiki per als atacs de cross site scripting",
"The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "El \"Wikiplugin js\" està activada. Pot ser utilitzat pels editors de wiki utilitzar JavaScript, que es pot utilitzar per fer tot tipus de coses desagradables, com els atacs de cross site scripting, etc",
"The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "El \"JQ Wikiplugin\" està activada. Pot ser utilitzat pels editors de wiki utilitzar JavaScript, que es pot utilitzar per fer tot tipus de coses desagradables, com els atacs de cross site scripting, etc",
"The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "El \"Redirect Wikiplugin\" està activada. Pot ser utilitzat pels editors de wiki per als atacs de cross site scripting",
"The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "El \"Wikiplugin mòdul\" s'activa. Pot ser utilitzat pels editors de wiki per afegir mòduls que permeten accedir a la informació (vegeu la llista mòdul)",
"The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "El \"Wikiplugin de Llista d'usuaris\" està activat. Pot ser utilitzat pels editors de wiki per mostrar la llista d'usuaris",
"The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "El \"Wikiplugin UserCount\" està activat. Pot ser utilitzat pels editors de wiki per mostrar un recompte del nombre d'usuaris",
"The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "El \"Wikiplugin SQL\" està activada. Pot ser utilitzat pels editors de wiki per executar ordres SQL",
"risky" => "arriscat",
// "To the extent secure logins are not required, data transmitted between the browser and server is not private" => "To the extent secure logins are not required, data transmitted between the browser and server is not private",
// "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php",
// "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php",
"Unlocked" => "Desbloquejat",
"The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed" => "L'instal·lador no està bloquejat. Es podria accedir a l'instal·lador, posant la base de dades en risc de ser alterada o destruïda",
"Path disclosure" => "Desglossament del camí",
"Path disclosure through error message" => "Desglossament del camí mitjançant un missatge d'error",
"SQL injection" => "Injecció SQL",
"SQL injection by authenticated user" => "Injecció SQL per un usuari autenticat",
"SQL injection by authenticated user with special privileges" => "Injecció SQL per un usuari autenticat amb privilegis especials",
"SQL injection without authentication" => "Injecció SQL sense autenticació",
"PHP command injection" => "Injecció de comanda PHP",
"PHP command injection by authenticated user" => "Injecció de comanda PHP per usuari autenticat",
"PHP command injection by authenticated user with special privileges" => "Injecció de comanda PHP per usuari autenticat amb privilegis especials",
"PHP command injection without authentication" => "Injecció de comanda PHP sense autenticació",
"File upload" => "Arxiu pujat",
"File is not readable. Unable to check." => "L'arxiu no es pot llegir. No es pot comprovar.",
// "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous" => "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous",
"This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "Això no és un arxiu de Tiki. Comproveu si aquest arxiu va ser pujat i si és perillós",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Aquest és un arxiu modificat. No es pot comprovar la versió. Comprova si és perillós.",
"This file is from another Tiki version: " => "Aquest fitxer és d'una altra versió del Wiki:",
"Shoutbox Words" => "Paraules Shoutbox",
"You have to provide a word" => "Cal que poseu una paraula",
"You do not have permission to view this page." => "No tens autorització per veure aquesta pàgina",
"You do not have permission to edit this page." => "No teniu autorització per a editar aquesta pàgina",
"You must specify a page name, it will be created if it doesn't exist." => "Has d'especificar un nom de pàgina, serà creada si no existeix.",
"page not added (Exists)" => "pàgina no afegida (ja existeix)",
"No survey indicated" => "No s'ha indicat cap enquesta",
"Tiki Cache/Sys Admin" => "Tiki cau / Sys administració",
"WYSIWYG Plugin" => "Connector (Plugin) WYSIWYG",
"Are you sure you want to delete all your custom tools" => "Estàs segur que vols  suprimir totes les eines personalitzades",
"Are you sure you want to delete this custom tool" => "Segur que vols eliminar aquesta eina personalitzada",
"Are you sure you want to remove this topic" => "Estàs segur que desitges eliminar aquest tema",
"Are you sure you want to remove this topic AND all the articles related" => "Estàs segur que desitges eliminar aquest tema i tots els articles relacionats",
"No tracker indicated" => "No s'ha indicat cap formulari-bd",
// "Tracker Fields %0" => "Tracker Fields %0",
"You don't have permission to use this feature" => "No tens permís per emprar aquesta funcionalitat",
// "Are you sure you want to delete the webservice \"%0\"" => "Are you sure you want to delete the webservice \"%0\"",
// "Are you sure you want to delete the template \"%0\"" => "Are you sure you want to delete the template \"%0\"",
// "Webservice error \"%0\" not saved (alpha characters only)" => "Webservice error \"%0\" not saved (alpha characters only)",
"User doesn't exist" => "Aquest usuari no existeix",
"No records were found. Check the file please!" => "No s'ha trobat cap registre. Revisa el fitxer si us plau!",
"User login or email is required" => "És necessari un nom o correu-e de l'usuari",
"User does not exist on master" => "L'usuari no existeix al mestre",
"User login is required" => "Es requereix l'entrada de l'usuari/a",
"Email is required" => "Es requereix correu-e",
"User is duplicated" => "Usuari/a duplicat/da",
"Created account %s <%s>" => "S'ha creat el compte %s <%s>",
"Assigned %s in group %s" => "Assignat %s al grup %s",
// "Users added" => "Users added",
// "%0 users not added" => "%0 users not added",
"Email validation requested but email address not set" => "Validació sol·licitat, adreça de correu electrònic no estableix",
"The passwords do not match" => "Les contrasenyes no coincideixen",
"Password not set" => "Contrasenya no establerta",
"User %s already exists" => "L'usuari %s ja existeix",
"User login contains invalid characters" => "El nom d'usuari per connectar-te conté caràcters invàlids",
"New user created with username %s" => "Nou usuari creat amb nom d'usuari %s",
"Impossible to create new %s with %s %s." => "No ha estat possible de crear cap nou/va %s amb %s %s.",
// "User account %0 has been invalidated by the admin" => "User account %0 has been invalidated by the admin",
// "An error occurred - the user account %0 has not been invalidated by the admin" => "An error occurred - the user account %0 has not been invalidated by the admin",
// "Link to OpenID for user %0 has been removed" => "Link to OpenID for user %0 has been removed",
// "An error occurred - the link to OpenID for user %0 has not been removed" => "An error occurred - the link to OpenID for user %0 has not been removed",
// "Modify this user's data" => "Modify this user's data",
"%s changed from %s to %s" => "Ha canviat %s de %s a %s",
"%s modified successfully." => "S'ha modificat %s amb èxit.",
"%s modification failed." => "la modificació de %s ha fallat.",
"Impossible to change %s from %s to %s" => "Impossible canviar %s de %s a %s",
"email" => "correu-e",
// "Unable to change %s from %s to %s" => "Unable to change %s from %s to %s",
"Review" => "Revisió",
"Classified" => "Classificat",
"Failed to add attribute" => "No s'ha pogut afegir atributs",
"rss feed disabled" => "alimentació rss desactivada",
// "Are you sure you want to add user %0 to group %1" => "Are you sure you want to add user %0 to group %1",
"You have to indicate a group" => "Cal indicar un grup",
"This group is invalid" => "Aquest grup és invàlid",
// "Remote system user needs to be configured" => "Remote system user needs to be configured",
// "Remote system group for autologin need to be configured" => "Remote system group for autologin need to be configured",
// "User name needs to be specified" => "User name needs to be specified",
// "Base URL not received from remote system" => "Base URL not received from remote system",
// "Email needs to be specified" => "Email needs to be specified",
"The page cannot be found" => "No s'ha pogut trobar la pàgina",
// "Image Galleries Configuration Panel" => "Image Galleries Configuration Panel",
"Could not read image %s." => "No es pot llegir la imatge %s.",
"Image %s upload failed." => "La pujada de la imatge %s ha fallat.",
"Image %s uploaded successfully." => "La imatge %s ha pujat correctament.",
"Image %s removed from Batch directory." => "La imatge %s ha estat eliminada del directori de lots.",
"Impossible to remove image %s from Batch directory." => "És impossible eliminar la imatge %s del directori de lots.",
"Incorrect directory chosen for batch upload of images." => "S'ha escollit un directori incorrecte per a la càrrega de lots d'imatges.",
"Please setup that dir on " => "Si us plau, configureu aquest directori a ",
"Please contact the website administrator." => "Si us plau, contacta l'administrador de lloc web.",
"Directory batch" => "Directori per pujada en bloc",
// "File Galleries Configuration Panel" => "File Galleries Configuration Panel",
"Incorrect directory chosen for batch upload of files" => "Directori incorrecta triat per a càrrega per lots d'arxius",
// "It isn't possible to post in any blog" => "It isn't possible to post in any blog",
// "You may need to create a blog first" => "You may need to create a blog first",
"You do not have permission to edit this post" => "Permís denegat per editar aquesta publicació",
"Top visited blogs" => "Blocs més visitats",
"Last posts" => "Darrers enviaments",
"Top active blogs" => "Blocs més actius",
"No blogId specified" => "No s'ha especificat cap bloc",
"Stop watching all categories" => "Deixa de mirar totes les categories",
"Watch all categories" => "Veure totes les categories",
"Group watches for all categories" => "Subscripcions a grups per a totes les categories",
"Stop watching this category and its descendants" => "Deixar de veure aquesta categoria i els seus descendents",
"Watch this category and its descendants" => "Veure aquesta categoria i els seus descendents",
"Group watches for this category" => "Subscripcions a grups per a aquesta categoria",
"Stop watching this category" => "Deixa de seguir aquesta categoria",
"Watch this category" => "Segueix aquesta categoria",
"Nothing tagged yet" => "No hi ha res etiquetat encara",
"You must clear your browser cache." => "Has d'esborrar la memòria cau (cache) del teu navegador.",
"You do not have permission to access this gallery" => "No estàs autoritzat/da a accedir a aquesta galeria",
"No gallery indicated" => "No s'ha indicat cap galeria",
"You do not have permission to remove images from this gallery" => "No tens autorització per suprimir imatges d'aquesta galeria",
"You do not have permission to rebuild thumbnails in this gallery" => "Permís denegat, no podeu refer miniatures en aquesta galeria",
"You do not have permission to rotate images in this gallery" => "Permís denegat, no podeu rotar les imatges d'aquesta galeria",
"No image indicated" => "No s'ha indicat cap imatge",
"picture not found" => "no s'ha trobat la imatge",
"You do not have permission to move images from this gallery" => "No estàs autoritzat/da a moure imatges d'aquesta galeria",
"You do not have permission to view the calendar" => "Permís denegat, no podeu veure el calendari",
"You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "Necessites <a href=\"tiki-admin_calendars.php?cookietab=2\">crear un calendari</a>",
"event without name" => "Event sense nom",
"You do not have permission to view this page" => "Permís denegat: no pots veure aquesta pàgina",
"Invalid date format" => "Format de data no vàlid",
"Your PHP installation does not have calendar enabled" => "La seva instal·lació de PHP no té habilitat el calendari",
"%H:%M %Z" => "%H:%M %Z",
"Invalid username or activation code. Maybe this code has already been used." => "Nom d'usuari o codi d'activació invàlids. Potser ja s'ha fet servir aquest codi d'activació.",
"Your email could not be validated; make sure you email is correct" => "No s'ha pogut validar el teu correu-e; assegura't que el teu correu-e és correcte",
"You can not use the same password again" => "No pots emprar la mateixa contrasenya de nou",
"Invalid old password" => "Contrasenya antiga invàlida",
"Invalid request. Expecting channels array" => "Invalid petició. Comptar amb canals de gamma",
"Missing channel name" => "Falta el nom de canal",
"One of the requested channels cannot be requested. It does not exist or permission is denied" => "Un dels canals demanats no es poden sol·licitar. No existeix ni permís és denegat",
"One of the install profiles could not be obtained" => "Un dels perfils d'instal.lació no es va poder obtenir",
"info" => "info",
// "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them" => "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them",
// "How to change this value" => "How to change this value",
// "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them" => "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them",
// "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors" => "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors",
// "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information" => "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information",
// "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information" => "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information",
// "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '" => "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '",
// "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring" => "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring",
// "No errors will be reported although the error_reporting level is all the way up at ' . \$e . " => "No errors will be reported although the error_reporting level is all the way up at ' . \$e . ",
// "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information" => "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information",
"good" => "bo",
// "ini_set is used in some places to accommodate special needs of some Tiki features" => "ini_set is used in some places to accommodate special needs of some Tiki features",
// "unsure" => "unsure",
// "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini",
"The PDO extension is the suggested database driver/abstraction layer" => "L'extensió PDO és la capa de conductor / abstracció de base de dades suggerit",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
"bad" => "dolent",
// "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning" => "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning",
"N/A" => "N / A",
// "Unable to detect" => "Unable to detect",
// "Cannot determine the size of this disk drive" => "Cannot determine the size of this disk drive",
// "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space" => "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space",
// "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files" => "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files",
// "When the disk space is filled, users, including administrators, will not be able to log in to Tiki" => "When the disk space is filled, users, including administrators, will not be able to log in to Tiki",
// "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported" => "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported",
// "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)" => "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)",
// "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for" => "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for",
// "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see" => "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see",
// "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see" => "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see",
// "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes" => "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes",
// "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used",
// "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache" => "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache",
// "It is recommended to use Zend opcode cache as the ByteCode Cache" => "It is recommended to use Zend opcode cache as the ByteCode Cache",
// "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used",
// "The memory_limit is at" => "The memory_limit is at",
// "This is known to support smooth functioning even for bigger sites" => "This is known to support smooth functioning even for bigger sites",
// "This will normally work, but the site might run into problems when it grows" => "This will normally work, but the site might run into problems when it grows",
"Your memory_limit is at" => "La seva memory_limit està en",
// "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default" => "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default",
// "The session.save_handler should be set to 'files'" => "The session.save_handler should be set to 'files'",
// "Well set! The default setting of 'files' is recommended for Tiki" => "Well set! The default setting of 'files' is recommended for Tiki",
// "The session.save_path must writable" => "The session.save_path must writable",
// "The session.save_path is writable" => "The session.save_path is writable",
// "If you would be using the recommended session.save_handler setting of 'files\\" => "If you would be using the recommended session.save_handler setting of 'files\\",
// "It doesn't matter though, since your session.save_handler is not set to 'files'" => "It doesn't matter though, since your session.save_handler is not set to 'files'",
// "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started" => "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started",
// "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request" => "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request",
// "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start" => "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start",
// "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup" => "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup",
// "This appears to work" => "This appears to work",
// "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki" => "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki",
// "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki" => "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki",
"register_globals should be off by default. See the PHP manual for details" => "register_globals ha de ser desactivada per omissió. Consulteu el manual de PHP per més detalls",
// "Correctly set! And this is also future proof as register_globals is deprecated" => "Correctly set! And this is also future proof as register_globals is deprecated",
"safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode està obsolet i ha de ser desactivada per omissió. Vegeu la <a href=\"http://www.php.net/manual/de/features.safe-mode.php\"> Manual de PHP </a> per a més informació",
// "Correctly set! And this is also future proof as safe_mode is deprecated" => "Correctly set! And this is also future proof as safe_mode is deprecated",
// "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior" => "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior",
// "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated" => "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated",
// "Correctly set! Tiki is fully UTF-8 and so should be this installation" => "Correctly set! Tiki is fully UTF-8 and so should be this installation",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file",
// "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a time zone set protects the site from related errors" => "Well done! Having a time zone set protects the site from related errors",
// "Files can be uploaded to Tiki" => "Files can be uploaded to Tiki",
// "Files cannot be uploaded to Tiki" => "Files cannot be uploaded to Tiki",
// "The max_execution_time is at" => "The max_execution_time is at",
// "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless" => "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless",
// "The max_execution_time is unlimited" => "The max_execution_time is unlimited",
"This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "Això no és necessàriament dolent, però és una bona idea limitar aquest temps en els servidors de produccions per tal d'eliminar les seqüències que s'executen inesperadament llargues",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s",
// "The max_input_time is at" => "The max_input_time is at",
// "The max_input_time is unlimited" => "The max_input_time is unlimited",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds",
// "The max_file_uploads is at" => "The max_file_uploads is at",
// "This is the maximum number of files allowed to be uploaded simultaneously" => "This is the maximum number of files allowed to be uploaded simultaneously",
// "The maximum number of files allowed to be uploaded is not available" => "The maximum number of files allowed to be uploaded is not available",
// "The upload_max_filesize is at" => "The upload_max_filesize is at",
// "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly" => "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly",
// "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site" => "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site",
// "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site" => "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site",
// "The post_max_size is at" => "The post_max_size is at",
// "The GD extension is needed for manipulation of images and for CAPTCHA images" => "The GD extension is needed for manipulation of images and for CAPTCHA images",
"The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "L'extensió GD està carregat i Tiki pot crear imatges, però es necessita l'extensió FreeType per a la generació de text de la imatge",
"The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "L'extensió GD es carrega, però Tiki no és capaç de crear imatges. Canviar la configuració de la biblioteca GD favor",
// "ImageMagick is used as a fallback in case GD is not available" => "ImageMagick is used as a fallback in case GD is not available",
"ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick està disponible, però no pot crear imatges. Comprovar la configuració ImageMagick favor",
// "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example" => "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example",
// "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file" => "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file",
// "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it" => "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it",
// "mbstring extension is needed for an UTF-8 compatible lower case filter" => "mbstring extension is needed for an UTF-8 compatible lower case filter",
"calendar extension is needed by Tiki" => "extensió del calendari cal per Tiki",
// "The calendar feature of Tiki will not function without this" => "The calendar feature of Tiki will not function without this",
"ctype extension is needed by Tiki" => "extensió ctype cal per Tiki",
// "This extension is needed for the dom extension (see below)" => "This extension is needed for the dom extension (see below)",
// "This extension is needed by Tiki" => "This extension is needed by Tiki",
// "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server" => "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server",
// "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17" => "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17",
// "This extension is required for H5P" => "This extension is required for H5P",
// "This extension is required for many features in Tiki" => "This extension is required for many features in Tiki",
"This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "Aquesta extensió s'utilitza per interpretar la informació de SVN TortoiseSVN 1.7 o superior",
// "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available" => "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available",
// "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries" => "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries",
// "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL" => "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL",
// "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt" => "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt",
// "Ability to generate random numbers, useful for example for CAPTCHA and other security features" => "Ability to generate random numbers, useful for example for CAPTCHA and other security features",
// "This extension is required and used frequently in validation functions invoked within Zend Framework" => "This extension is required and used frequently in validation functions invoked within Zend Framework",
"The eval() function is required by the Smarty templating engine" => "La funció eval() és requerida pel motor de plantilles Smarty",
"You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "Obtindrà \"Si us plau, poseu-vos en contacte amb suport tècnic sobre\" missatges en lloc de mòduls. eval () és més probable que desactivar a través Suhosin",
"The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "Es necessita la classe ZipArchive per a funcions com ara XML Wiki Import / Export i PluginArchiveBuilder",
"The DateTime class is needed for the WebDAV feature" => "Es necessita la classe DateTime per a la funció WebDAV",
// "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server" => "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server",
"Tiki requires MySQL >= 5.x" => "Tiki requereix MySQL >= 5.x",
// "The max_allowed_packet setting is at" => "The max_allowed_packet setting is at",
// "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Your database supports the utf8mb4 character set required in Tiki19 and above" => "Your database supports the utf8mb4 character set required in Tiki19 and above",
// "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation" => "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation",
// "Tiki is fully utf8mb4 and so should be every part of the stack" => "Tiki is fully utf8mb4 and so should be every part of the stack",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified" => "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified",
// "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki" => "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down" => "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down",
// "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down" => "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down",
"ON" => "Activat/da",
"OFF" => "Desactivat/da",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki",
// "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess" => "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess",
// "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"" => "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"",
// "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again" => "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again",
// "Not Working" => "Not Working",
// "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki" => "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki",
// "Working" => "Working",
// "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs" => "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly",
// "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly",
// "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
"The URL Rewrite Module is required to use SEFURL on IIS" => "El mòdul de reescriptura d'URL es requereix per utilitzar SEFURL a IIS",
// "Not Installed" => "Not Installed",
// "Tesseract PHP package could not be found. Try installing through Packages" => "Tesseract PHP package could not be found. Try installing through Packages",
// "Tesseract PHP dependency installed" => "Tesseract PHP dependency installed",
// "The installed Tesseract version is lower than the required version" => "The installed Tesseract version is lower than the required version",
// "Tesseract package" => "Tesseract package",
// "languages installed" => "languages installed",
// "Not all languages installed. You may need to install additional languages for multilingual support" => "Not all languages installed. You may need to install additional languages for multilingual support",
// "Tesseract languages" => "Tesseract languages",
// "Tesseract could not be found" => "Tesseract could not be found",
// "Tesseract meets or exceeds the version requirements" => "Tesseract meets or exceeds the version requirements",
// "Tesseract binary" => "Tesseract binary",
// "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path" => "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path",
// "Path setup correctly" => "Path setup correctly",
// "Your path may not be configured correctly. It appears to be located at " => "Your path may not be configured correctly. It appears to be located at ",
// "Your path is configured, but we were unable to tell if it was configured properly or not" => "Your path is configured, but we were unable to tell if it was configured properly or not",
// "Tesseract path" => "Tesseract path",
// "Pdfimages path" => "Pdfimages path",
// "Scheduler has been successfully setup" => "Scheduler has been successfully setup",
// "Scheduler needs to have a console command of \"ocr:all\" set" => "Scheduler needs to have a console command of \"ocr:all\" set",
// "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser" => "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser",
// "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration" => "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration",
"safe" => "segur",
"WebKit is enabled" => "WebKit està habilitat",
// "The Blogs feature is enabled" => "The Blogs feature is enabled",
// "Exec can potentially be used to execute arbitrary code on the server" => "Exec can potentially be used to execute arbitrary code on the server",
// "Tiki does not need it; perhaps it should be disabled" => "Tiki does not need it; perhaps it should be disabled",
// "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled" => "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled",
// "Exec can be potentially be used to execute arbitrary code on the server" => "Exec can be potentially be used to execute arbitrary code on the server",
// "Tiki needs it to run the Plugins R/RR" => "Tiki needs it to run the Plugins R/RR",
// "If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "If this is needed and the other PHP software on the server can be trusted, this should be enabled",
"Passthru is similar to exec" => "Passthru és similar a exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
"Shell_exec is similar to exec" => "Shell_exec és similar a l'executiu",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled",
"System is similar to exec" => "El sistema és similar a l'executiu",
// "Tiki does not need it; it is good that it is disabled" => "Tiki does not need it; it is good that it is disabled",
"Proc_open is similar to exec" => "Proc_open és similar a l'executiu",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "popen is similar to exec" => "popen is similar to exec",
// "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled",
"Curl_exec can potentially be abused to write malicious code" => "Curl_exec potencialment es pot abusar d'escriure codi maliciós",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled",
"Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec potencialment es pot abusar d'escriure codi maliciós",
"It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "És probablement un mite urbà que això és perillós. Tiki equip tornarà a examinar aquesta comprovació, però es va advertir",
// "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature" => "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature",
// "session.use_trans_sid should be off by default. See the PHP manual for details" => "session.use_trans_sid should be off by default. See the PHP manual for details",
// "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them" => "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them",
// "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off" => "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off",
// "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information",
// "To manage this instance from a remote server you need SSH or FTP access to this server" => "To manage this instance from a remote server you need SSH or FTP access to this server",
// "Command found" => "Command found",
// "Command not found, check if it is installed and available in one of the paths above" => "Command not found, check if it is installed and available in one of the paths above",
// "Extension loaded in PHP" => "Extension loaded in PHP",
// "Extension not loaded in PHP" => "Extension not loaded in PHP",
"Test mail from Tiki Server Compatibility Test" => "Electrònic de prova de prova de compatibilitat Tiki servidor",
// "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered" => "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered",
// "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php" => "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php",
// "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts" => "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts",
"The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "L'extensió Fileinfo és necessària per a la preferència 'Validar el contingut del fitxer carregat'",
// "The intl extension is required for Tiki 15 and newer" => "The intl extension is required for Tiki 15 and newer",
// "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters" => "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters",
// "Congratulations!\n\nThis server can send emails.\n\n" => "Congratulations!\n\nThis server can send emails.\n\n",
// "The path '%0' on preference '%1' does not exist" => "The path '%0' on preference '%1' does not exist",
// "The lib '%0' on preference '%1', option '%2' does not exist" => "The lib '%0' on preference '%1', option '%2' does not exist",
// "The class '%0' needed for preference '%1', with option '%2' selected, does not exist" => "The class '%0' needed for preference '%1', with option '%2' selected, does not exist",
// "The extension '%0' on preference '%1', with option '%2' selected, is not loaded" => "The extension '%0' on preference '%1', with option '%2' selected, is not loaded",
"Top authors" => "Els autors més actius",
// "User %0 validated by the admin" => "User %0 validated by the admin",
"Problem. Try to log in again to receive new confirmation instructions." => "Problema. Prova de connectar-te de nou per rebre noves intruccions de confirmació.",
"Invalid" => "Invàlid",
"You must include a subject or a message" => "Ha d'incloure un tema o un missatge",
"You must make sure to have a valid email address in the From field" => "Has d'assegurar-te de tenir una adreça vàlida de correu electrònic al camp De",
"%0 sent you a message" => "%0 t'ha enviat un missatge",
"last version" => "última versió",
"Cannot rename page because the new name begins with reserved prefix" => "No es pot reanomenar la pàgina perquè el nom nou comença amb un prefix reservat",
"Cannot copy page because maybe new page name already exists" => "No es pot copiar la pàgina degut a que ja existeix tal nou nom de la pàgina",
"TikiHelp WebHelp generation engine. Generating WebHelp using" => "Motor de generació WebHelp TikiHelp. Generant WebHelp utilitzant",
"Eliminating previous files" => "Eliminar arxius anteriors",
"Index: <strong>%0</strong>" => "Índex: <strong>%0</strong>",
"Directory: <strong>%0</strong>" => "Directori: <strong>%0</strong>",
// "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix" => "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix",
"You need to change chmod 'whelp' manually to 777" => "Necessites canviar via chmod 'whelp' manualment a 777",
"Creating directory structure in <strong>%0</strong>" => "Crear l'estructura de directoris en <strong>%0</strong>",
"Submit a new link" => "Enviar un nou enllaç",
"Must enter a name to add a site. " => "Has d'afegir un nom per afegir un nou lloc. ",
"Must enter a url to add a site. " => "Has d'afegir una url per afegir un nou lloc. ",
"URL already added to the directory. Duplicate site? " => "L'URL ja ha estat afegida al directori. Lloc duplicat? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori). ",
"Must select a category. " => "Has de seleccionar una categoria. ",
"Must enter a name to add a site" => "Has d'escriure un nom per a la web a afegir",
"Must enter a url to add a site" => "Has d'escriure una dreça URL per a afegir una web",
"URL already added to the directory. Duplicate site?" => "L'URL ja ha estat afegida al directori. Lloc duplicat?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori)",
"Must select a category" => "Has d'escollir una categoria",
"Browse Directory" => "Explorar directori",
"How to use Directory" => "Com utilitzar Directory",
"No site indicated" => "No s'ha indicat cap lloc",
"This feature is disabled: %0" => "Aquesta funció està desactivada: %0",
"No parent specified" => "No s'ha especificat cap pare",
"Latest sites of directory %0" => "Últims llocs de directori %0",
"Discount code already exists" => "Ja hi ha codi de descompte",
// "Invalid fileId. Please provide a valid fileId to preview a specific file" => "Invalid fileId. Please provide a valid fileId to preview a specific file",
// "Unable to display file" => "Unable to display file",
"File has been deleted" => "L'arxiu ha estat esborrat",
"You cannot download this file right now. Your score is low or file limit was reached" => "No es pot descarregar aquest fitxer. La seva puntuació és baixa o s'arriba al límit d'arxiu",
// "File locked" => "File locked",
// "File not locked" => "File not locked",
"Error : The file %s doesn't exist." => "Error: El fitxer %s no existeix.",
"Article not found" => "Article no trobat",
"You do not have permission to edit this article" => "No tens permís per editar aquest article",
"Invalid email:" => "Correu Invàlid:",
"The language can't be changed as its set of translations has already this language" => "No es pot canviar a aquest idioma per que el conjunt de traduccions ja té aquest idioma",
"Banner not found" => "No s'ha trobat el banner",
"You do not have permission to edit this banner" => "No tens permís per editar aquest banner",
"You do not have permission to edit this blog" => "No tens permís per editar aquest bloc",
// "No filters applied" => "No filters applied",
// "You do not have permission to write the css file" => "You do not have permission to write the css file",
"Wrong file type, expected one of %0" => "Tipus d'arxiu incorrecte, un s'espera de %0",
"You do not have permission to view/edit this file" => "No té permís per veure / editar el fitxer",
" drawing" => " dibuix",
"Wrong file type, expected %0" => "Tipus d'arxiu incorrecte, que s'espera %0",
"New Svg Image" => "Nova SVG Imatge",
"Invalid request to edit an image" => "La petició per editar la imatge no és vàlida",
"You have permission to edit images but not in this gallery" => "No estàs autoritzat per editar imatges en aquesta galeria",
"Failed to edit the image" => "s'ha produït un error en editar la imatge",
"Edit or export languages" => "Edita o exporta idiomes",
"Edit Perspectives" => "Edita Perspectives",
"No content id indicated" => "Cap id de contingut especificat",
"No question indicated" => "No s'ha indicat cap pregunta",
"No quiz indicated" => "No has indicat cap test",
// "View this wiki page" => "View this wiki page",
"No structure indicated" => "No s'ha indicat cap estructura",
"Invalid structure_id or page_ref_id" => "Estructura Invàlida o referència invàlida",
"You do not have permission to edit submissions" => "Permís denegat per editar col·laboracions",
"You have to create a topic first" => "Has de crear un tòpic primer",
"Template directory %0 unknown" => "Plantilla directori %0 desconeguda",
"You do not have permission to do that" => "No teniu permís per fer això",
"You do not have permission to write the template:" => "No teniu permís per escriure la plantilla:",
"You do not have permission to read the template" => "No teniu permís per llegir la plantilla",
"No topic id specified" => "No s'ha especificat cap id de tema",
"Invalid topic id specified" => "Tema Invàlid",
"No object indicated" => "No s'ha indicat cap objecte",
"Only wiki pages are supported" => "Només s'admeten pàgines wiki",
// "Forbidden" => "Forbidden",
// "New diagram" => "New diagram",
// "Edit diagram" => "Edit diagram",
"Override lock and carry on with edit" => "Ignora el bloqueig i continua per editar",
"Page is currently being edited" => "La pàgina està essent editada en aquest moment",
"page imported" => "pàgina importada",
"created from import" => "creada des de l'importació",
// "To review the changes you have just made %0compare the versions%1 in history of this page" => "To review the changes you have just made %0compare the versions%1 in history of this page",
// "Page %0 saved (version %1)" => "Page %0 saved (version %1)",
"This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "Aquesta pàgina està sent editada per %0. Consulteu amb l'usuari abans d'editar la pàgina si us plau,\td'una altra forma els canvis s'emmagatzemarien com a dues versions diferents a la història de la pàgina i hauries de combinar-les manualment més tard",
"Can't import remote HTML page" => "No es pot importar la pàgina HTML remota",
"The Sandbox is disabled" => "El LlocdeProves està deshabilitat",
"The page cannot be edited because it is locked" => "No es pot editar la pàgina perquè està bloquejada",
"That page already exists. Go back and choose a different name." => "La pàgina ja existeix. Ves enrere i escull un nom diferent.",
"The page name is" => "Nom de la pàgina és",
"The translation set already contains a page in this language." => "El conjunt de traducció ja conté una pàgina en aquest idioma.",
"The file cannot be opened" => "No es pot obrir el fitxer",
"Problem zip initialisation" => "Problema d'inicialització zip",
"Problem zip" => "Problema amb el Zip",
"Another user is currently exporting that tracker. Please try again later" => "Un altre usuari està actualment exportant aquest tracker, prova-ho més tard",
"No questions group indicated" => "No s'ha indicat cap grup de preguntes",
"Remove archive: " => "Eliminar arxiu:",
"Remove file gallery: " => "Traieu galeria arxiu:",
"You do not have permission to edit this file" => "Permís denegat, no podeu editar aquest fitxer",
"Most-visited file galleries" => "Les galeries de fitxers més visitades",
"Most downloaded files" => "Arxius més descarregats",
"Last files" => "Els últims fitxers",
"No gallery ID specified" => "No s'ha especificat el galleryId",
"Form error - no import method selected for some reason." => "Error de formulari-bd html - no s'ha seleccionat cap mètode d'importació per alguna raó.",
"Form error - no server-side filename entered for selected import method." => "Error de formulari-bd html - no s'ha introduït cap nom d'arxiu al costat del servidor per al mètode d'importaicó seleccionat.",
"No forum indicated" => "No s'ha indicat cap fòrum",
"Last forum topics" => "Últims temes en fòrums",
"Last replied forum topics" => "Darrera resposta els temes en",
"Most-Read Forum Topics" => "Els més llegits Els temes del fòrum",
"Top topics" => "Temes principals",
"Forum posts" => "Escrits del Fòrum",
"Most-Visited Forums" => "Fòrums més visitats",
"No forumId specified" => "No s'ha especificat el fòrumId",
"List Forums" => "Llista Fòrums",
"Not supported yet" => "No s'admet encara",
// "All files copied" => "All files copied",
"id" => "id",
"first uploaded image" => "primera imatge pujada",
"last uploaded image" => "última imatge pujada",
"first image" => "primera imatge",
"last image" => "La última imatge",
"random image" => "imatge aleatòria",
"You do not have permission to create galleries and so you cannot edit them" => "Permís denegat, no podeu crear galeries ni editar-les",
"You do not have permission to edit this gallery" => "Permís denegat, no podeu editar aquesta galeria",
"You do not have permission to remove this gallery" => "Permís denagat, no podeu eliminar aquesta galeria",
"Top images" => "Les imatges més emprades",
"Last images" => "Les últimes imatges",
"No valid renderer found. GD or PDFLib required." => "No s'ha trobat un renderitzador vàlid. Es requereix un GD o PDFLib.",
"No sheet specified." => "No s'ha especificat cap full.",
// "Unknown Graphic" => "Unknown Graphic",
// "Unknown Renderer" => "Unknown Renderer",
"You must select a renderer." => "Has de seleccionar un renderitzador.",
"Invalid Series for current graphic." => "Sèrie no vàlida per al gràfic actual.",
"overwriting old page" => "Reescriure la pàgina antiga",
"updated from structured text import" => "actualitzat amb la importació de text estructurada",
"page created" => "pàgina creada",
"created from structured text import" => "creat a partir de la importació de text estructurat",
// "Unable to locate import file" => "Unable to locate import file",
// "Pages in zip file %0 successfully imported" => "Pages in zip file %0 successfully imported",
"Invalid software name" => "Nom del programari no vàlid",
// "No wiki page specified" => "No wiki page specified",
"This version does not exist" => "Aquesta versió no existeix",
"There is more than one item in the tracker with this title" => "Hi ha més d'un ítem al tracker (base de dades) amb aquest títol",
"There are no items in the tracker with this title" => "No hi ha cap ítem al tracker amb aquest títol",
"Are you sure you want to undo the last change" => "Segur que vols desfer l'últim canvi",
"There is nothing to undo" => "Res a desfer",
"You have requested that this page be machine translated" => "Has sol·licitat que aquesta pàgina sigui traduïda per una màquina",
"However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "No obstant això, la funció de la traducció automàtica no està activada. Si us plau, activa aquesta funció, o demana a un administrador del lloc que ho faci",
"No repository given" => "Cap dipòsit indicat",
"This invitation does not exist or is deprecated" => "Aquesta invitació no existeix o està caducada",
"Congratulations! You are now part of this invitation group(s)" => "Felicitats! Ara ja ets part d'aquest grup(s) convidat(s)",
"Communication error" => "Error de comunicació",
"Invalid response provided by the Kaltura server. Please retry" => "Resposta invàlida proporcionada pel servidor Kaltura. Si us plau torni a provar",
"Are you sure you want to permanently remove the article with identifier %0" => "Estàs segur que vols  suprimir de forma permanent l'article amb identificador %0",
"Are you sure you want to permanently remove these %0 articles" => "Estàs segur que vols suprimir permanentment aquests %0 articles",
"You do not have permission to remove articles" => "No té permís per eliminar l'article",
"You do not have permission to remove banners" => "No té autorització per eliminar banners",
"List Blog Posts" => "Llista de publicacions de bloc",
"You do not have permission to remove this blog" => "No tens permís per esborrar aquest bloc",
"You do not have permission to view the comments for this blog" => "No té permís per veure els comentaris d'aquest bloc",
// "The following comment has been deleted" => "The following comment has been deleted",
// "The following comments have been deleted" => "The following comments have been deleted",
// "Delete selected comments and ban" => "Delete selected comments and ban",
// "Users have been pre-selected for banning in the highlighted section of the form below" => "Users have been pre-selected for banning in the highlighted section of the form below",
// "One comment approved" => "One comment approved",
// "%0 comments approved" => "%0 comments approved",
// "No comments approved" => "No comments approved",
// "One comment rejected" => "One comment rejected",
// "%0 comments rejected" => "%0 comments rejected",
// "No comments rejected" => "No comments rejected",
// "Comment archived" => "Comment archived",
// "%0 comments archived" => "%0 comments archived",
// "No comments archived" => "No comments archived",
// "Comment unarchived" => "Comment unarchived",
// "%0 comments unarchived" => "%0 comments unarchived",
// "No comments unarchived" => "No comments unarchived",
// "Action not performed since no comments were selected" => "Action not performed since no comments were selected",
"Approved Status" => "Estat Aprovat",
"This blog has no posts" => "Aquest bloc no té publicacions",
"Dynamic content" => "El contingut dinàmic",
"Admin FAQs" => "Administració FAQs",
"Non-existent gallery" => "Aquesta galeria no existeix",
"You do not have permission to view this gallery" => "No teniu permís per veure aquesta galeria",
// "One item moved" => "One item moved",
// "%0 items moved" => "%0 items moved",
// "No items moved" => "No items moved",
// "One item moved and one item failed to move" => "One item moved and one item failed to move",
// "One item moved and %0 items failed to move" => "One item moved and %0 items failed to move",
// "%0 items moved and one item failed to move" => "%0 items moved and one item failed to move",
// "%0 items moved and %0 items failed to move" => "%0 items moved and %0 items failed to move",
// "One item deleted" => "One item deleted",
// "%0 items deleted" => "%0 items deleted",
// "No items deleted" => "No items deleted",
// "One item deleted and one item failed to delete" => "One item deleted and one item failed to delete",
// "One item deleted and %0 items failed to delete" => "One item deleted and %0 items failed to delete",
// "%0 items deleted and one item failed to delete" => "%0 items deleted and one item failed to delete",
// "%0 items moved and %0 items failed to delete" => "%0 items moved and %0 items failed to delete",
// "List view settings reset for one gallery" => "List view settings reset for one gallery",
// "List view settings reset for %0 galleries" => "List view settings reset for %0 galleries",
// "List view settings not changed for the selected gallery" => "List view settings not changed for the selected gallery",
// "List view settings not changed for the %0 selected galleries" => "List view settings not changed for the %0 selected galleries",
// "List view settings reset for %0 galleries and not changed for one gallery" => "List view settings reset for %0 galleries and not changed for one gallery",
// "List view settings reset for %0 galleries and not changed for %0 galleries" => "List view settings reset for %0 galleries and not changed for %0 galleries",
// "No files selected" => "No files selected",
// "Metadata refreshed for one file" => "Metadata refreshed for one file",
// "Metadata refreshed for %0 files" => "Metadata refreshed for %0 files",
// "Metadata not refreshed" => "Metadata not refreshed",
// "Metadata refreshed for one file and not refreshed for one file" => "Metadata refreshed for one file and not refreshed for one file",
// "Metadata refreshed for one file and not refreshed for %0 files" => "Metadata refreshed for one file and not refreshed for %0 files",
// "Metadata refreshed for %0 files and not refreshed for one file" => "Metadata refreshed for %0 files and not refreshed for one file",
// "Metadata refreshed for %0 files and not refreshed for %0 files" => "Metadata refreshed for %0 files and not refreshed for %0 files",
// "Incorrect file ID" => "Incorrect file ID",
"The file is already locked by %s" => "L'arxiu ja està bloquejat per %s",
// "File unlocked" => "File unlocked",
// "File not unlocked" => "File not unlocked",
// "Files in this gallery are not lockable" => "Files in this gallery are not lockable",
"You don't have permission to validate files from this gallery" => "Permís denegat no pot validar arxius d'aquesta galeria",
// "Error retrieving file" => "Error retrieving file",
// "Draft validated" => "Draft validated",
// "Validation failed" => "Validation failed",
// "File deleted" => "File deleted",
// "File not deleted" => "File not deleted",
// "Metadata refreshed" => "Metadata refreshed",
// "You need upload permission to edit files" => "You need upload permission to edit files",
// "You need permission to create galleries to edit them" => "You need permission to create galleries to edit them",
// "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode" => "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode",
"Quota too big" => "Quota massa gran",
"Quota too small" => "Quota massa petit",
// "Gallery %0 created or modified" => "Gallery %0 created or modified",
// "Gallery %0 not created or modified" => "Gallery %0 not created or modified",
"You do not have permission to duplicate this gallery" => "No tens permís per duplicar aquesta galeria",
// "Gallery duplicated" => "Gallery duplicated",
// "Gallery not duplicated" => "Gallery not duplicated",
// "Remove file gallery %0" => "Remove file gallery %0",
// "Incorrect gallery ID" => "Incorrect gallery ID",
// "Gallery %0 deleted" => "Gallery %0 deleted",
// "Gallery %0 not deleted" => "Gallery %0 not deleted",
"Could not find the file requested" => "No s'ha pogut trobar l'arxiu demanat",
// "File %0 updated" => "File %0 updated",
// "File %0 not updated" => "File %0 not updated",
// "Invalid %0 parameter" => "Invalid %0 parameter",
// "File %0 not found" => "File %0 not found",
// "User watch added" => "User watch added",
// "User watch not added" => "User watch not added",
// "User watch removed" => "User watch removed",
// "User watch not removed" => "User watch not removed",
// "Not modified for" => "Not modified for",
// "Not downloaded for" => "Not downloaded for",
"This gallery does not exist" => "Aquesta galeria no existeix",
"Error importing" => "Error en importar",
"Error converting" => "Error en convertir",
"Importing" => "Important",
"Processing" => "Tractant",
"Ready" => "Llest",
"Pending moderation" => "Tot esperant la moderació",
"Blocked" => "Obstruït",
"Invalid action" => "Acció no vàlid",
"Remove permission %0 from %1" => "Traieu el permís %0 des de %1",
"Assign permission %0 to %1" => "Assignar permisos de %0 a %1",
"Delete posts" => "Eliminar missatges",
"View submissions" => "Veure presentacions",
"Are you sure you want to permanently remove the submitted article with identifier %0" => "Estàs segur que vols suprimir de forma permanent l'article presentat amb identificador %0",
"Are you sure you want to permanently remove these %0 submitted articles" => "Estàs segur que vols suprimir permanentment aquests %0 articles presentats",
"Are you sure you want to approve these %0 submitted articles" => "Estàs segur que desitges aprovar aquestes %0 articles presentats",
// "Are you sure you want to permanently remove all expired submitted articles" => "Are you sure you want to permanently remove all expired submitted articles",
// "Pages not in a structure" => "Pages not in a structure",
"You are neither an administrator nor an operator of live support" => "No ets ni un administrador ni un operador de suport en temps real",
"Username field cannot be empty. Please go back and try again" => "El camp d'usuari no pot quedar en blanc. Si us plau, torna enrere i prova de nou",
"Unable to contact remote server." => "No es pot contactar amb el servidor remot.",
"XMLRPC Error: " => "Error XMLRPC: ",
"Unable to create login" => "Incapaç de crear el compte (login)",
// "No groups set on Intertiki client" => "No groups set on Intertiki client",
"%d or more unsuccessful login attempts have been made" => "S'han produït %d o més intents fallits de connexió",
"Your account has been suspended" => "S'ha suspès (al menys temporalment) el teu compte",
"Contact your site administrator to reactivate it" => "Contacta a l'administrador del teu lloc per a reactivar-ho",
"An email has been sent to you with the instructions to follow." => "Se t'ha enviat un correu-e amb instruccions a seguir.",
"Account requires administrator approval" => "Compte desactivat",
"You did not validate your account" => "Encara no has validat el teu compte",
"Resend" => "Torna a enviar-ho",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "Hauries d'haver rebut un correu-e. Comprova la teva bústia de correu-e i correu no desitjat. Si no, clica sobre el botó de sota per a tornar a enviar el correu-e",
"You must use the right case for your username" => "Has d'emprar exactament les majúscules i minúscules del teu nom d'usuari",
"You are not yet validated" => "Encara no estàs validat",
"You are already logged in" => "No estàs connectat",
// "Authentication error" => "Authentication error",
"The mail can't be sent. Contact the administrator" => "El missatge no es pot enviar. Contacta l'administrador",
"There is more than one user account with this email. Please contact the administrator" => "Hi ha més d'un compte d'usuari amb aquest correu-e. Si us plau contacta amb els administradors",
"Your default nickname is already in use. A new one has to be selected." => "El teu nom d'usuari per defecte ja està en ús. Has d'escollir-ne un altre.",
"Verification cancelled" => "S'ha cancel·lat la verificació",
"The selected account is not associated with your identity." => "El compte seleccionat no està associat amb la teva identitat.",
"unknown action" => "acció no coneguda",
"Authentication method is not OpenID" => "El mètode d'autenticació no és OpenID",
"Authentication error; probably not a valid OpenID" => "Error d'autenticació, probablement no és un OpenID vàlida",
"Could not redirect to server: " => "No es pot redirigir al servidor:",
"OpenID authentication failed: " => "Autenticació OpenID fallar:",
"You have already validated your account. Please log in" => "Ja has validat el teu compte. Si us plau, entra-hi",
"No page provided" => "No sempre la pàgina",
// "User module unassigned" => "User module unassigned",
// "User module not unassigned" => "User module not unassigned",
// "User module moved up" => "User module moved up",
// "User module not moved up" => "User module not moved up",
// "User module moved down" => "User module moved down",
// "User module not moved down" => "User module not moved down",
// "User module moved to opposite side" => "User module moved to opposite side",
// "User module not moved to opposite side" => "User module not moved to opposite side",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
"You must log in to use this feature" => "Heu d'estar connecta't per emprar aquesta característica",
// "\$tikiMonitorRestriction need to be an array" => "\$tikiMonitorRestriction need to be an array",
"My Account Home" => "Inici ElmeuTiki",
"You do not have permission to view other users data" => "No tens permís per veure les dades de les altres persones usuàries",
// "Subscription confirmed for newsletter %0 (%1)" => "Subscription confirmed for newsletter %0 (%1)",
// "Subscription request failed" => "Subscription request failed",
// "You have been unsubscribed from newsletter %0" => "You have been unsubscribed from newsletter %0",
// "Your request to unsubscribe failed" => "Your request to unsubscribe failed",
"You must be logged in to subscribe to newsletters" => "Has d'estar connectat per subscriure't a un butlletí",
// "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter" => "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter",
// "Newsletter not subscribed" => "Newsletter not subscribed",
"No note indicated" => "No s'ha indicat cap nota",
"merged note:" => "nota escapçada:",
"The file is too large" => "El fitxer es massa gran",
"No item indicated" => "No s'ha indicat cap ítem",
"Are you sure you want to delete this note" => "Segur que vols eliminar aquesta nota",
"created from notepad" => "creada des del bloc de notes",
"Note not found" => "Tingueu en compte que no es troba",
"No name indicated for wiki page" => "No s'ha indicat cap nom per la pàgina wiki",
"Not enough information to display this page" => "No hi ha suficient informació per mostrar aquesta pàgina",
"You do not have permission to assign permissions for this object" => "No teniu permís per assignar permisos per a aquest objecte",
// "Are you sure you want to modify permissions" => "Are you sure you want to modify permissions",
// "%0 and all the children groups" => "%0 and all the children groups",
"Are you sure you want to remove the direct permissions from this object" => "Estàs segur que desitges eliminar els permisos directes d'aquest objecte",
"Are you sure you want to paste the copied permissions into this object" => "Estàs segur que vols enganxar els permisos copiades en aquest objecte",
// "Error while processing payment: " => "Error while processing payment: ",
// "Payment has been confirmed" => "Payment has been confirmed",
// "Payment confirmation has not been received yet" => "Payment confirmation has not been received yet",
"Manual payment entered" => "Pagament manual entrar",
"You do not have permission to enter payment" => "No té permís per entrar al pagament",
"New payment requested" => "Nou pagament sol·licitat",
"Cancel payment %0" => "Cancel pagament %0",
"Payment canceled" => "Pagament cancel·lat",
// "You need permission to edit pages in order to experiment on plugin LIST" => "You need permission to edit pages in order to experiment on plugin LIST",
// "No preference given" => "No preference given",
// "This preference is not translatable" => "This preference is not translatable",
"No article indicated" => "No s'indica un article",
"Article is not published yet" => "L'article no ha estat publicat",
"No post indicated" => "No s'ha indicat cap publicació",
"Blog not found" => "No es troba el bloc",
"Missing object list type argument" => "Manca llista d'objectes argument de tipus",
"Index (%0)" => "Índex (%0)",
"No pages indicated" => "No s'han indicat les pàgines",
"Multiple Print" => "Impressió Múltiple",
"Pageviews" => "Visualitzacions de pàgines",
"No result indicated" => "No hi ha cap resultat indicat",
"Invalid or unknown username" => "El nom de l'usuari es invàlid o desconegut",
"Unable to send mail. User has not configured email" => "No es pot enviar el mail. L'usuari no té el correu electrònic configurat",
"Invalid or unknown email address" => "Correu-e invàlid o desconegut",
"Please provide a username or email address" => "Si us plau, indica el teu nom d'usuari o correu-e",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password." => "Si us plau, contacta a l'Administrador si no reps el correu-e, o si hi ha algun problema en canviar-te la contrasenya.",
"An email with a link to reset your password has been sent " => "S'ha enviat el correu-e amb l'enllaç per canviar la teva contrasenya ",
"to the email" => "al correu-e",
"to the registered email address for" => "a l'adreça de correu-e registrada per a",
"Rename wiki page" => "Reanomena pàgina wiki",
// "Page renamed from %0 to %1. Semantic alias redirect created" => "Page renamed from %0 to %1. Semantic alias redirect created",
// "Are you sure you want to roll back \"%0\" to version #%1" => "Are you sure you want to roll back \"%0\" to version #%1",
"Non-existent version" => "Aquesta versió no existeix",
"Tiki RSS Feed Error Message: %0" => "Tiki RSS Missatge d'error: %0",
"This match was not case sensitive" => "Aquest partit no és sensible a majúscules",
"No items selected" => "Cap item seleccionat",
"Page cannot be found: " => "No es pot trobar la pàgina: ",
"Page has changed since preview: " => "La pàgina ha canviat des de la vista prèvia:",
"Page not updated due to error in replacing: " => "Pàgina no actualitzada a causa d'un error en la substitució:",
"Page updated: " => "Pàgina actualitzada:",
"Search Stats" => "Cerca Estadístiques",
"%0: Results for \"%1\"" => "%0: Resultats per \"%1\"",
// "Your query was stored" => "Your query was stored",
"Searchindex" => "SearchIndex",
"A problem occurred during file uploading" => "Va passar un problema durant la càrrega d'arxius",
// "File causing trouble was at rank" => "File causing trouble was at rank",
// "The error was %0" => "The error was %0",
"Error: You can't send the same newsletter by refreshing this frame content" => "Error: No es pot enviar el mateix butlletí de notícies mitjançant l'actualització d'aquest contingut frame",
"No newsletters available." => "No hi ha cap butlletí disponible.",
"Cannot login to server maybe the server is down" => "No puc connectar-me al servidor potser el servidor està caigut",
"successfully sent" => "enviat amb èxit",
"not sent" => "no enviat",
"Error: " => "Error: ",
"Send Pages" => "Enviar pàgines",
"Notice: this variable may not be empty" => "Avís: aquesta variable no pot estar buida",
"Notice: invalid variable value:" => "Avís: valor de variable no vàlid:",
"Report to the webmaster" => "Informa al mestre Web",
"Token called" => "Token cridat",
"Error sending tweet" => "Error enviant a Twitter",
"Your link was sent" => "El seu enllaç va ser enviat",
"One of the email addresses that was input is invalid" => "Una de les adreces de correu electrònic que heu escrit és invàlida",
"Your email is mandatory" => "És obligatori el seu correu electrònic",
"Error sending mail to" => "Error en enviar el correu a",
"Share page" => "Comparteix la pàgina",
"No text given for tweet" => "No s'ha donat cap text per a Twitter",
"You don't have permission to post in this forum" => "S'ha denegat el permís per a publicar al fòrum",
"Spreadsheet - " => "Full de càlcul -",
"Are you sure you want to delete this spreadsheet" => "Estàs segur que vols suprimir aquest full de càlcul",
// "URL provided is empty or unsupported" => "URL provided is empty or unsupported",
// "Unable to generate a short url for the requested resource" => "Unable to generate a short url for the requested resource",
// "'%0' short url" => "'%0' short url",
"You do not have permission to edit messages %0" => "No té permís per editar missatges %0",
// "Sitemap file not available" => "Sitemap file not available",
// "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator" => "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator",
// "Exporting slideshow as PDF requires a working installation of mPDF" => "Exporting slideshow as PDF requires a working installation of mPDF",
// "Export to PDF error: %0" => "Export to PDF error: %0",
"Permission denied. You cannot view this page" => "Permís denegat. No pots veure aquesta pàgina",
"Email is mandatory" => "El correu electrònic és obligatori",
"Username and email are mandatory" => "Es obligatori indicar el nom d'usuari i correu-e",
"The email address is invalid" => "El correu-e no és vàlid",
"Clean the sql logs" => "Netegeu els registres sql",
"Are you sure you want to clear all statistics and data for this survey" => "Estàs segur que desitges esborrar totes les estadístiques i les dades per a aquest estudi",
// "The following list of changes has been reverted" => "The following list of changes has been reverted",
// "Log already reverted" => "Log already reverted",
// "Invalid System Log ID" => "Invalid System Log ID",
"You cannot take this quiz twice" => "No pots accedir a aquest test dues vegades",
"The quiz time limit was exceeded. The quiz score cannot be computed" => "S'ha excedit el temps límit del qüestionari i no pot ser completat",
"You cannot take this survey twice" => "No pots fer aquesta enquesta dues vegades",
"Please create a category first" => "Si us plau, primer crea una categoria",
"Committing.." => "Enviant...",
"Could not save" => "No s'ha pogut desar",
"Tracker item:" => "Registre del formulari-bd:",
"No trackerId specified" => "No s'ha especificat cap trackerId",
"Incorrect file gallery" => "Galeria d'arxius errònia",
"You must lock the file before editing it" => "Cal bloquejar el fitxer abans d'editar",
"Error processing zipped image package" => "Error al processar la imatge comprimida amb zip",
"No permission to upload zipped image packages" => "No hi ha permisos per pujar paquets d'imatges enzipades",
"The uploaded file is not recognized as a image" => "El fitxer pujat no és reconegut com a imatge",
"You do not have permission to upload images" => "No tens autorització per pujar imatges",
"You have permission to upload images but not to this gallery" => "Tens autorització per penjar imatges, malgrat no en aquesta galeria",
"Cannot get image from URL" => "No s'ha pogut aconseguir la imatge des de la URL",
"That is not an image (or you have php < 4.0.5)" => "Això no es una imatge (o be te php < 4.0.5)",
"Usage" => "Ús",
// "Default user modules restored" => "Default user modules restored",
// "Default user modules not restored" => "Default user modules not restored",
// "User module assigned" => "User module assigned",
// "User module not assigned" => "User module not assigned",
// "User module display order moved up. Displayed order may not change if other modules now have the same order rank" => "User module display order moved up. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved up" => "User module display order not moved up",
// "User module display order moved down. Displayed order may not change if other modules now have the same order rank" => "User module display order moved down. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved down" => "User module display order not moved down",
// "User module moved to left column" => "User module moved to left column",
// "User module not moved to left column" => "User module not moved to left column",
// "User module moved to right column" => "User module moved to right column",
// "User module not moved to right column" => "User module not moved to right column",
"TOP" => "MÉS ACTIUS/VES",
"No URL indicated" => "No s'ha indicat cap url",
"ERROR: Either the subject or body must be non-empty" => "ERROR: El títol o el cos no han d'estar buits",
"Unknown user" => "Usuari desconegut",
// "Added new structure route" => "Added new structure route",
// "Deleted structure route" => "Deleted structure route",
// "Updated structure route" => "Updated structure route",
// "Notification preferences set" => "Notification preferences set",
// "Errors were encountered when setting notification preferences" => "Errors were encountered when setting notification preferences",
"Email is set to %s" => "El correu-e ha estat canviat a %s",
"Password has been changed" => "S'ha canviat la contrasenya",
"Invalid password. Your current password is required to change administrative information" => "Contrasenya no vàlida. Es requereix la contrasenya actual per canviar la informació administrativa",
"The passwords did not match" => "Les contrasenyes no coincideixen",
"If you really want to delete your account, you must check the checkbox" => "Si realment vols esborrar el teu compte, has de seleccionar aquesta casella",
// "User report preferences saved" => "User report preferences saved",
// "User report preferences not saved" => "User report preferences not saved",
// "User reports disabled" => "User reports disabled",
// "User report not disabled" => "User report not disabled",
"was moved to the trash" => "va ser mogut/da a la paperera",
"was moved to the trash by" => "llençat a la paperera per",
"open / in process" => "oberta / en procés",
"Rights by creator" => "Drets per creador",
"END" => "FI",
"Percentage" => "Percentatge",
"Task accepted by creator" => "Tasca acceptada pel creador",
"Task accepted by task user" => "Tasca acceptada per l'usuari de la tasca",
"Task NOT accepted by creator" => "Tasca NO acceptada pel creador",
"Task NOT accepted by task user" => "Tasca NO acceptada per l'usuari de la tasca",
"Sorry, this task does not exist or you don't have permission to view this task" => "Disculpeu, aquesta tasca no existeix o no teniu permís per veure-la",
"Task entries:" => "Entrades de tasques:",
"Changes:" => "Canvis:",
"Info message" => "Missatge d'info",
"NEW Task" => "Tasca NOVA",
"Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks!" => "Disculpeu, no tens autorització per enviar tasques a altres usuaris o l'usuari no té autorització per rebre'n!",
"Changes on Task" => "Canvis a la tasca",
"You received a new task" => "Heu rebut una tasca nova",
"The priority is" => "La prioritat és",
"very low" => "molt baixa",
"high" => "alta",
"very high" => "molt alta",
"You must start your work at least on" => "Heu de començar la vostra feina com a mínim el",
"You must finish your work on" => "Heu de finalizar la vostra feina el",
"Log in and click the link below" => "Connecta't i punxa en l'enllaç de sota",
"Please read the task and work on it!" => "Si us plau, llegiu la tasca i treballeu-hi!",
"Sorry, there was an error while trying to write data into the database" => "Disculpeu, hi ha hagut un error mentre s'intentava escriure informació a la base de dades",
// "Unsubscribe from user watch email notifications" => "Unsubscribe from user watch email notifications",
// "Unsubscribed from user watch email notification" => "Unsubscribed from user watch email notification",
// "Unsubscribe failed" => "Unsubscribe failed",
// "Unknown watch type" => "Unknown watch type",
"Language watch" => "Vigila l'idioma",
"Category watch: %0, Language: %1" => "Subscripció per correu-e a Categoria: %0, Idioma: %1",
// "User watch deleted" => "User watch deleted",
// "User watch not deleted" => "User watch not deleted",
"Cannot upload this file. The storage quota would be exceeded" => "No es pot pujar aquest arxiu , no hi ha espai suficient",
"No user indicated" => "No s'ha indicat usuari",
"Non-existent user" => "Aquest usuari no existeix",
"No banner indicated" => "No s'ha indicat cap banner",
"No blog indicated" => "No s'ha indicat cap bloc",
"Post not found" => "Publiqui no trobat",
"You do not have permission to view this blog post while it is marked as private" => "No teniu permís per veure aquesta entrada del bloc, mentre que es marca com privat",
"No cache information available" => "No hi ha informació disponible a la memòria cau",
"You must suggest a question; please try again" => "Ha suggerir una pregunta, si us plau-ho a provar",
"No FAQ indicated" => "no s'ha indicat cap PUF",
// "Are you sure you want to remove that attachment" => "Are you sure you want to remove that attachment",
// "Are you sure you want to remove that topic" => "Are you sure you want to remove that topic",
"You do not have permission to remove someone else's post!" => "No tens permís per eliminar la publicació d'algú altre!",
"Incorrect thread" => "Fil de discussió incorrecte",
// "Thread %0 does not exist" => "Thread %0 does not exist",
"No thread indicated" => "No s'ha indicat cap tema",
"Files are read only at this time" => "Els arxius són de només lectura en aquest moment",
"Are you sure you want to clone this spreadsheet" => "Estàs segur que vols clonar aquest full de càlcul",
"Clone Error" => "Hi ha hagut un error Clonant",
"Are you sure you want to roll back this spreadsheet" => "Estàs segur que vols restaurar aquest full de càlcul",
"Rollback Error" => "Error Rollback",
"Tracker Added To Spreadsheet" => "Formulari-bd Agregat a full de càlcul",
"Tracker Removed From Spreadsheet" => "Formulari-bd tret de full de càlcul",
"Spreadsheet added" => "Full de càlcul afegeix",
"Spreadsheet removed" => "Full de càlcul eliminat",
"File removed" => "Arxiu eliminat",
"Spreadsheet truncated" => "Full de càlcul truncat",
"Create or view tracker" => "Crear o veure el formulari-bd",
"Admin this tracker" => "Administració del formulari-bd",
// "Are you sure you want to delete the selected items" => "Are you sure you want to delete the selected items",
"Create tracker item" => "Crea l'ítem del formulari-bd",
// "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission" => "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission",
// "Are you sure you want to permanently delete this item" => "Are you sure you want to permanently delete this item",
"Are you sure you want to remove this attachment" => "Estàs segur que desitges eliminar aquest arxiu adjunt",
"Edit/Delete" => "Edita/Esborra",
"You don't have a personal tracker item yet. Click here to make one" => "No tens encara cap ítem del formulari-bd. Clica aquí per a fer-ne un",
"That tracker does not use extras." => "Aquell formulari-bd no empra extres.",
"Address book" => "Llibre d'adreces",
"Top pages" => "Les pàgines més actives",
"Last pages" => "Les últimes pàgines",
// "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace" => "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace",
);
