<?php
// (c) Copyright by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// The original strings (English) are case-sensitive.

/* Note for translators about translation of text ending with punctuation
 *
 * The current list of concerned punctuation can be found in 'lib/init/tra.php'
 * On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
 * For clarity, we explain here only for colons: ':' but it is the same for the rest
 *
 * Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
 *
 * Technical justification:
 * If a string ending with colon needs translating (like "{tr}Login:{/tr}")
 * then Tiki tries to translate 'Login' and ':' separately.
 * This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
 * and it still allows to translate ":" as " :" for languages that
 * need it (like French)
 * Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
 * This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.
 */
$lang = array(
"Welsh" => "Walisisch",
"Slovene" => "Slovenisch",
"Arabic" => "Arabisch",
"Bulgarian" => "Bulgarisch",
"Catalan" => "Katalanisch",
"Simplified Chinese" => "Vereinfachtes Chinesisch",
"Czech" => "Tschechisch",
"Danish" => "Dänisch",
"German" => "Deutsch",
"English" => "Englisch en",
"English British" => "Englisch en-uk",
"Spanish" => "Spanisch",
"Greek" => "Griechisch",
"Farsi" => "Persisch",
"Finnish" => "Finnisch",
"Fijian" => "Fiji",
"French" => "Französisch",
"Frisian Netherlands" => "Friesisch NL",
"Galician" => "Galizisch",
"Hebrew" => "Hebräisch",
"Croatian" => "Kroatisch",
"Indonesian" => "Indonesisch",
"Icelandic" => "Isländisch",
"Italian" => "Italienisch",
"Inuktitut" => "Inuktitut",
// "Inuktitut (Roman)" => "Inuktitut (Roman)",
// "Iniunnaqtun" => "Iniunnaqtun",
"Japanese" => "Japanisch",
"Korean" => "Koreanisch",
"Hungarian" => "Ungarisch",
"Lithuanian" => "Lithauisch",
"Low German" => "Plattdeutsch",
"Dutch" => "Holländisch NL",
"Norwegian" => "Norwegisch",
"Polish" => "Polnisch",
"Portuguese" => "Portugiesisch",
"Brazilian Portuguese" => "Brazilianisches Portugiesisch",
"Romanian" => "Rumänisch",
"Romansh" => "Romanssh",
"Russian" => "Russisch",
"Pijin Solomon" => "Salomonen-Pidgin",
"Sinhala" => "Singhalesisch",
"Slovak" => "Slovakisch",
"Albanian" => "Albanisch",
"Serbian Latin" => "Serbisch (Latin)",
"Swedish" => "Schwedisch",
// "Swahili" => "Swahili",
// "Thai" => "Thai",
"Tuvaluan" => "Tuvaluisch",
"Turkish" => "Türkisch",
"Traditional Chinese" => "Traditionelles Chinesisch",
"Ukrainian" => "Ukrainisch",
// "Urdu" => "Urdu",
"Vietnamese" => "Vietnamesisch",
"Afghanistan" => "Afghanistan",
"Aland Islands" => "Aland Inseln",
"Aland_Islands" => "Aland_Inseln",
"Albania" => "Albanien",
"Algeria" => "Algerien",
"American Samoa" => "Amerikanisch Samoa",
"American_Samoa" => "Amerikanisch_Samoa",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentinen",
"Armenia" => "Armenien",
"Aruba" => "Aruba",
"Australia" => "Australien",
"Austria" => "Österreich",
"Azerbaijan" => "Azerbaijan",
"Bahamas" => "Bahamas",
"Bahrain" => "Bahrain",
"Bangladesh" => "Bangladesch",
"Barbados" => "Barbados",
"Belarus" => "Belarus",
"Belgium" => "Belgien",
"Belize" => "Belize",
"Benin" => "Benin",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Bolivia" => "Bolivien",
"Bosnia and Herzegovina" => "Bosnien und Herzegovina",
"Bosnia_and_Herzegovina" => "Bosnien_und_Herzegovina",
"Botswana" => "Botswana",
"Bouvet Island" => "Bouvetinsel",
"Bouvet_Island" => "Bouvetinsel",
"Brazil" => "Brazilien",
"British Indian Ocean Territory" => "Britisches Territorium im Indischen Ozean",
"British Virgin Islands" => "Britische Jungferninseln",
"British_Indian_Ocean_Territory" => "Britisches_Territorium_im_Indischen_Ozean",
"British_Virgin_Islands" => "Britische_Jungferninseln",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgarien",
"Burkina Faso" => "Burkina Faso",
"Burkina_Faso" => "Burkina_Faso",
"Burundi" => "Burundi",
"Cambodia" => "Kambodscha",
"Cameroon" => "Kamerun",
"Canada" => "Kananda",
"Cape Verde" => "Kap Verde",
"Cape_Verde" => "Kap_Verde",
"Catalan Countries" => "Katalanische Länder",
"Catalan_Countries" => "Katalanische_Länder",
"Cayman Islands" => "Kaymaninseln",
"Cayman_Islands" => "Kaymaninseln",
"Central African Republic" => "Zentralafrikanische Republik",
"Central_African_Republic" => "Zentralafrikanische_Republik",
"Chad" => "Tschad",
"Chile" => "Chile",
"China" => "China",
"Christmas Island" => "Weihnachtsinsel",
"Christmas_Island" => "Weihnachtsinsel",
"Cocos Islands" => "Kokosinseln",
"Cocos_Islands" => "Kokosinseln",
"Colombia" => "Kolumbien",
"Comoros" => "Komoren",
"Democratic Republic of the Congo" => "Demokratische Republik Kongo",
"Democratic_Republic_of_the_Congo" => "Demokratische_Republik_Kongo",
"Congo" => "Kongo",
"Cook Islands" => "Cookinseln",
"Cook_Islands" => "Cookinseln",
"Costa Rica" => "Costa Rica",
"Costa_Rica" => "Costa_Rica",
"Croatia" => "Kroatien",
"Cuba" => "Cuba",
"Cyprus" => "Zypern",
"Czech Republic" => "Tschechien",
"Czech_Republic" => "Tschechien",
"Denmark" => "Dänemark",
"Djibouti" => "Djibouti",
"Dominica" => "Dominica",
"Dominican Republic" => "Dominikanische Republik",
"Dominican_Republic" => "Dominikanische_Republik",
"Ecuador" => "Equador",
"Egypt" => "Ägypten",
"El Salvador" => "El Salvador",
"El_Salvador" => "El_Salvador",
// "England" => "England",
"Equatorial Guinea" => "Äquatorialguinea",
"Equatorial_Guinea" => "Äquatorialguinea",
"Eritrea" => "Eritrea",
"Estonia" => "Estland",
"Ethiopia" => "Äthiopien",
"Europe" => "Europa",
"Falkland Islands" => "Falklandinseln",
"Falkland_Islands" => "Falklandinseln",
"Faroe Islands" => "Schafsinseln",
"Faroe_Islands" => "Schafsinseln",
"Federated States of Micronesia" => "Mikronesien",
"Federated_States_of_Micronesia" => "Mikronesiens",
"Fiji" => "Fiji",
"Finland" => "Finland",
"France" => "Frankreich",
"French Guiana" => "Französisch-Guayana",
"French Polynesia" => "Französisch-Polynesien",
"French Southern Territories" => "Französische südliche Territorien",
"French_Guiana" => "Französisch-Guayana",
"French_Polynesia" => "Französisch-Polynesien",
"French_Southern_Territories" => "Französische_südliche_Territorien",
"Gabon" => "Gabun",
"Gambia" => "Gambia",
"Georgia" => "Georgien",
"Germany" => "Deutschland",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Greece" => "Griechenland",
"Greenland" => "Grönland",
"Grenada" => "Grenada",
"Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea Bissau" => "Guinea-Bissau",
"Guinea" => "Guinea",
"Guinea_Bissau" => "Guinea-Bissau",
"Guyana" => "Guyana",
"Haiti" => "Haiti",
"Heard Island and McDonald Islands" => "Heard und die McDonaldinseln",
"Heard_Island_and_McDonald_Islands" => "Heard_und_die_McDonaldinseln",
"Honduras" => "Honduras",
"Hong Kong" => "Hongkong",
"Hong_Kong" => "Hongkong",
"Hungary" => "Ungarn",
"Iceland" => "Island",
"India" => "Indien",
"Indonesia" => "Indonesien",
"Iran" => "Iran",
"Iraq" => "Irak",
"Ireland" => "Irland",
"Isle of Man" => "Isle of Man",
"Israel" => "Israel",
"Italy" => "Italien",
"Ivory Coast" => "Elfenbeinküste",
"Ivory_Coast" => "Elfenbeinküste",
"Jamaica" => "Jamaica",
"Japan" => "Japan",
"Jersey" => "Jersey",
"Jordan" => "Jordanien",
"Kazakstan" => "Kazakhstan",
"Kenya" => "Kenia",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Kyrgyzstan" => "Kirgisistan",
"Laos" => "Laos",
"Latvia" => "Lettland",
"Lebanon" => "Libanon",
"Lesotho" => "Lesotho",
"Liberia" => "Liberien",
"Libya" => "Libyen",
"Liechtenstein" => "Liechtenstein",
"Lithuania" => "Litauen",
"Luxemburg" => "Luxemburg",
"Macao" => "Macao",
"Macedonia" => "Mazedonien",
"Madagascar" => "Madagaskar",
"Malawi" => "Malawi",
"Malaysia" => "Malaysien",
"Maldives" => "Malediven",
"Mali" => "Mali",
"Malta" => "Malta",
"Marshall Islands" => "Marshallinseln",
"Marshall_Islands" => "Marshallinseln",
"Martinique" => "Martinique",
"Mauritania" => "Mauretanien",
"Mauritius" => "Mauritius",
"Mayotte" => "Mayotte",
"Mexico" => "Mexico",
"Moldova" => "Moldawien",
"Monaco" => "Monaco",
"Mongolia" => "Mongolei",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Morocco" => "Marokko",
"Mozambique" => "Mosambik",
"Myanmar" => "Myanmar",
"Namibia" => "Namibia",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Netherlands Antilles" => "Niederländische Antillen",
"Netherlands" => "Niederlande",
"Netherlands_Antilles" => "Niederländische_Antillen",
"New Caledonia" => "Neukaledonien",
"New Zealand" => "Neuseeland",
"New_Caledonia" => "Neukaledonien",
"New_Zealand" => "Neuseeland",
"Nicaragua" => "Nicaragua",
"Niger" => "Niger",
"Nigeria" => "Nigeria",
"Niue" => "Niue",
"None" => "Keine",
"Norfolk Island" => "Norfolkinsel",
"Norfolk_Island" => "Norfolkinsel",
"North Korea" => "Nord Korea",
"North_Korea" => "Nord_Korea",
"Northern Mariana Islands" => "Nördliche Marianen",
"Northern_Mariana_Islands" => "Nördliche_Marianen",
"Norway" => "Norwegen",
"Oman" => "Oman",
"Other" => "Sonstige",
"Pakistan" => "Pakistan",
"Palau" => "Palau",
"Palestine" => "Palästina",
"Panama" => "Panama",
"Papua New Guinea" => "Papua-Neuguinea",
"Papua_New_Guinea" => "Papua-Neuguinea",
"Paraguay" => "Paraguay",
"Peru" => "Peru",
"Philippines" => "Philippinen",
"Pitcairn" => "Pitcairn",
"Poland" => "Polen",
"Portugal" => "Portugal",
"Puerto Rico" => "Puerto Rico",
"Puerto_Rico" => "Puerto_Rico",
"Quatar" => "Katar",
"Republic of Macedonia" => "Mazedonien",
"Republic_of_Macedonia" => "Mazedonien",
"Reunion" => "Reunion",
"Romania" => "Rumänien",
"Russia" => "Russland",
"Russian Federation" => "Russische Föderation",
"Russian_Federation" => "Russische_Föderation",
"Rwanda" => "Ruanda",
"Saint Helena" => "St. Helena",
"Saint Kitts and Nevis" => "St. Kitts und Nevis",
"Saint Lucia" => "St. Lucia",
"Saint Pierre and Miquelon" => "Saint-Pierre und Miquelon",
"Saint_Helena" => "St._Helena",
"Saint_Kitts_and_Nevis" => "St. Kitts und Nevis",
"Saint_Lucia" => "St._Lucia",
"Saint_Pierre_and_Miquelon" => "Saint-Pierre_und_Miquelon",
"Samoa" => "Samoa",
"San Marino" => "San Marino",
"San_Marino" => "San_Marino",
"Sao Tome and Principe" => "Sao Tome und Principe",
"Sao_Tome_and_Principe" => "Sao_Tome_und_Principe",
"Saudi Arabia" => "Saudi-Arabien",
"Saudi_Arabia" => "Saudi-Arabien",
"Senegal" => "Senegal",
"Serbia" => "Serbien",
"Seychelles" => "Seychellen",
"Sierra Leone" => "Sierra Leone",
"Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapur",
"Slovakia" => "Slowakei",
"Slovenia" => "Slowenien",
"Solomon Islands" => "Salomonen",
"Solomon_Islands" => "Salomonen",
"Somalia" => "Somalia",
"South Africa" => "Südafrika",
"South Georgia and South Sandwich Islands" => "Südgeorgien und die Südlichen Sandwichinseln",
"South Korea" => "Süd Korea",
"South_Africa" => "Südafrika",
"South_Georgia_and_South_Sandwich_Islands" => "Südgeorgien_und_die_Südlichen_Sandwichinseln",
"South_Korea" => "Süd_Korea",
"Spain" => "Spanien",
"Sri Lanka" => "Sri Lanka",
"Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St. Vincent und die Grenadinen",
"St_Vincent_Grenadines" => "St._Vincent_und_die_Grenadinen",
"Sudan" => "Sudan",
"Surinam" => "Suriname",
"Svalbard and Jan Mayen" => "Spitzbergen",
"Svalbard_and_Jan_Mayen" => "Spitzbergen",
"Swaziland" => "Swasiland",
"Sweden" => "Schweden",
"Switzerland" => "Schweiz",
"Syria" => "Syrien",
"Taiwan" => "Taiwan",
"Tajikistan" => "Tadschikistan",
"Tanzania" => "Tanzania",
"Thailand" => "Thailand",
"Timor-Leste" => "Osttimor",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinidad und Tobago",
"Trinidad_Tobago" => "Trinidad_und_Tobago",
"Tunisia" => "Tunesien",
"Turkey" => "Türkei",
"Turkmenistan" => "Turkmenistan",
"Turks and Caicos Islands" => "Turks- und Caicosinseln",
"Turks_and_Caicos_Islands" => "Turks-_und_Caicosinseln",
"Tuvalu" => "Tuvalu",
"US Virgin Islands" => "Amerikanische Jungferninseln",
"US_Virgin_Islands" => "Amerikanische_Jungferninseln",
"Uganda" => "Uganda",
"Ukraine" => "Ukraine",
"United Arab Emirates" => "Vereinigte Arabische Emirate",
"United Kingdom" => "Vereinigtes Königreich",
"United Nations Organization" => "Vereinte Nationen",
"United States Minor Outlying Islands" => "United States Minor Outlying Islands",
"United States" => "Vereinigte Staaten",
"United_Arab_Emirates" => "Vereinigte_Arabische_Emirate",
"United_Kingdom" => "Vereinigtes_Königreich",
"United_Kingdom_-_England_and_Wales" => "Vereinigtes_Königreich_-_England_und_Wales",
"United_Kingdom_-_Northern_Ireland" => "Vereinigtes_Königreich_-_Nord_Irland",
"United_Kingdom_-_Scotland" => "Vereinigtes_Königreich_-_Schottland",
"United_Nations_Organization" => "Vereinte_Nationen",
"United_States" => "Vereinigte_Staaten",
"United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
"Uruguay" => "Uruguay",
"Uzbekistan" => "Usbekistan",
"Vanuatu" => "Vanuatu",
"Vatican" => "Vatikan",
"Venezuela" => "Venezuela",
"Viet Nam" => "Vietnam",
"Viet_Nam" => "Vietnam",
"Wales" => "Wales",
"Wallis and Futuna" => "Wallis und Futuna",
"Wallis_and_Futuna" => "Wallis_und_Futuna",
"Western Sahara" => "Westsahara",
"Western_Sahara" => "Westsahara",
"World" => "Welt",
"Yemen" => "Jemen",
"Yugoslavia" => "Jugoslawien",
"Zambia" => "Sambia",
"Zimbabwe" => "Simbabwe",
"the former Yugoslav Republic of Macedonia" => "die frühere Jugoslawische Republik Mazedonien",
"the_former_Yugoslav_Republic_of_Macedonia" => "die_frühere_Jugoslawische_Republik_Mazedonien",
// "File %0 succesfully imported" => "File %0 succesfully imported",
// "category defaults" => "category defaults",
"You must specify a directory" => "Du musst ein Verzeichnis angeben",
// "ViewerJS URI not set" => "ViewerJS URI not set",
// "ViewerJS URI not found (local file not readable)" => "ViewerJS URI not found (local file not readable)",
// "ViewerJS URI not found (%0)" => "ViewerJS URI not found (%0)",
// "Tags successfully cleaned up" => "Tags successfully cleaned up",
// "Tag cleanup failed" => "Tag cleanup failed",
// "Remove orphan images" => "Remove orphan images",
// "Orphan images successfully removed" => "Orphan images successfully removed",
"moved %d images, %d errors occurred" => "%d Bilder verschoben, %d Fehler aufgetreten",
"a timeout occurred. Hit the reload button to move the rest" => "eine Zeitüberschreitung ist eingetreten. Klicke auf neu laden, um den Rest zu verschieben",
"Tiki Email Test" => "Tiki E-Mailtest",
"Tiki Test email from" => "Tiki E-Mailtest von",
"Unable to send mail" => "Kann E-Mail nicht senden",
"Test mail sent to" => "Test-E-Mail senden an",
// "Remove this server" => "Remove this server",
// "Remove this host" => "Remove this host",
// "registration choices" => "registration choices",
// "Assign users to groups based on email patterns" => "Assign users to groups based on email patterns",
// "This method of captcha is not supported by your server, please select another or upgrade" => "This method of captcha is not supported by your server, please select another or upgrade",
// "You need to select a file to upload" => "You need to select a file to upload",
// "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists" => "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists",
// "Unable to Write Password File to Disk" => "Unable to Write Password File to Disk",
// "Delete temporary index" => "Delete temporary index",
// "%d users were assigned to groups based on user emails matching the patterns defined for the groups" => "%d users were assigned to groups based on user emails matching the patterns defined for the groups",
// "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups" => "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups",
// "composer.lock file was removed" => "composer.lock file was removed",
// "composer.lock file is not writable, so it can not be removed" => "composer.lock file is not writable, so it can not be removed",
// "composer.lock file do not exists" => "composer.lock file do not exists",
// "Vendor folder contents was removed" => "Vendor folder contents was removed",
// "Vendor folder is not writable" => "Vendor folder is not writable",
// "Vendor folder do not exists" => "Vendor folder do not exists",
"Used" => "Benutzt",
"Available" => "Verfügbar",
"Hit" => "Treffer",
"Miss" => "fehlgeschlagen",
"An error occurred: " => "Ein Fehler ist aufgetreten: ",
// "profile applied" => "profile applied",
"The following list of changes has been applied:" => "Folgende Änderungen wurden übernommen:",
// "Profile forgotten" => "Profile forgotten",
// "New rating configuration %0 created" => "New rating configuration %0 created",
// "Rating configuration updated for %0" => "Rating configuration updated for %0",
// "Scoring events replaced with form data" => "Scoring events replaced with form data",
// "Unable to get info from log file" => "Unable to get info from log file",
"You must set a home file gallery" => "Du musst ein Home-Dateiarchiv festlegen",
"Tag already exists" => "Marke existiert bereits",
// "Tag %0 created" => "Tag %0 created",
// "Tag %0 not found" => "Tag %0 not found",
// "Tag %0 restored" => "Tag %0 restored",
// "Tag %0 not restored" => "Tag %0 not restored",
// "Tag %0 removed" => "Tag %0 removed",
// "Tag %0 not removed" => "Tag %0 not removed",
// "Process to remove pictures has completed" => "Process to remove pictures has completed",
// "Dump created at %0" => "Dump created at %0",
// "Dump was not created. Please check permissions for the storage/ directory" => "Dump was not created. Please check permissions for the storage/ directory",
// "Dump file %0 removed" => "Dump file %0 removed",
// "Dump file %0 was not removed" => "Dump file %0 was not removed",
// "No update was made" => "No update was made",
// "Areas were updated" => "Areas were updated",
// "Are you sure you want to remove that post" => "Are you sure you want to remove that post",
"Re:" => "Aw:",
"This forum is flat and doesn't allow replies to other replies" => "Dieses Forum ist flach und erlaubt keine Antworten zu anderen Antworten",
"Copyright management" => "Copyrightverwaltung",
"No page indicated" => "Keine Seite angegeben",
"You must supply all the information, including title and year." => "Du musst alle Daten angeben, inkl. Titel und Jahr.",
// "Sorry, that mail has been taken by another operator" => "Sorry, that mail has been taken by another operator",
"Wiki Page" => "Wiki Seite",
// "Tracker item not found" => "Tracker item not found",
// "Put this item back" => "Put this item back",
// "Taken by %0" => "Taken by %0",
// "Take this email" => "Take this email",
"TAKE" => "NEHMEN",
"View contact" => "Kontakte einsehen",
"ID" => "ID",
"Type" => "Typ",
"Name" => "Name",
"Description" => "Beschreibung",
"Size" => "Größe",
"Created" => "Erstellt",
"Uploaded" => "Hochgeladen",
"Last modified" => "Zuletzt modifiziert",
"Uploaded by" => "Hochgeladen von",
"Creator" => "Ersteller",
"Last modified by" => "Zuletzt bearbeitet von",
"Comment" => "Kommentar",
"Files" => "Dateien",
"Hits" => "Zugriffe",
"Last download" => "Letzter Download",
"Locked by" => "Gesperrt von",
"Backlinks" => "Backlinks",
// "Delete after" => "Delete after",
"Share" => "Share",
"Source" => "Quelle",
"Explorer" => "Explorer",
"Path" => "Pfad",
"Slideshow" => "Diashow",
// "Gallery icon" => "Gallery icon",
"Register" => "Registrieren",
"Group" => "Gruppe",
"Tiki Installer" => "Tiki Installer",
"MySQL Improved (mysqli)" => "MySQL verbessert (mysqli)",
"MySQL classic (mysql)" => "MySQL klassisch (mysql)",
// "Invalid database user" => "Invalid database user",
"No database name specified" => "Es wurde kein Datenbankname angegeben",
// "Automatic" => "Automatic",
// "Make a symlink" => "Make a symlink",
// "Make a copy" => "Make a copy",
// "Do nothing" => "Do nothing",
// "symlink created" => "symlink created",
// "copy created" => "copy created",
"Email address not valid, test mail not sent" => "E-Mailadresse ungültig. Es wird keine Test-E-Mail gesendet",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "E-Mailaddresse leer und \"Kopie\" Checkbox nicht gesetzt. Es wird keine Test-E-Mail gesendet",
"Test mail from Tiki installer %0" => "Test-E-Mail vom Tiki Installer %0",
"Tiki version" => "Tiki-Version",
"PHP version" => "PHP version",
"Server" => "Server",
"Sent" => "Ausgang",
"Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Es wurden ungültige Zeichen im Datenbanknamen entdeckt. Bitte benutze alphanumerische Zeichen oder _ oder -",
"Database `%0` was created" => "Datenbank `%0` wurde erstellt",
"Database `%0` creation failed. You need to create the database" => "Die Erstellung der Datenbank `%0` ist fehlgeschlagen. Du musst die Datenbank erstellen",
// "Database `%0`. Unable to connect to database" => "Database `%0`. Unable to connect to database",
// "User `%0` was created" => "User `%0` was created",
// "User `%0` creation failed" => "User `%0` creation failed",
"Congratulations!\n\nYour server can send emails.\n\n" => "Gratulation!\n\nDein Server kann E-Mails senden.\n\n",
// "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Failed to convert document into image" => "Failed to convert document into image",
// "Please check Tiki Action Log for more information" => "Please check Tiki Action Log for more information",
"No automated tax" => "Keine automatische Steuer",
"Account name must not be empty" => "Kontoname darf nicht leer sein",
"Budget is not a valid amount: " => "Budget enthält keinen gültigen Betrag",
"Locked must be either 0 or 1" => "Gesperrt muss entweder 0 oder 1 sein",
"Error creating account" => "Fehler bei Erstellung des Kontos",
"AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "KontoID %0 wird bereits benutzt und darf nicht geändert werden. Bitte deaktiviere es, wenn es nicht länger benötigt wird",
"Error updating account" => "Fehler bei der Aktualisierung des Kontos",
"Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Das Konto ist bereits in Benutzung und darf nicht gelöscht werden. Bitte deaktiviere es, wenn es nicht länger benötigt wird",
"Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Zurückrollung fehlgeschlagen. Inkonsistente Datenbank: Bereinigung für die JournalId %0 im Buch %1 ist notwendig",
"successfully rolled back #" => "erfolgreich zurückgerollt #",
"Booking error creating journal entry" => "Buchungsfehler bei Erstellung des Journaleintrages",
"Booking error creating debit entry" => "Buchungsfehler bei Erstellung des Debitoreneintrages",
"Booking error creating credit entry" => "Buchungsfehler bei Erstellung des Kreditoreneintrages",
"The number of debit entries differs: " => "Anzahl von Debitoreneinträgen weicht ab: ",
"The number of credit entries differs: " => "Anzahl von Kreditoreneinträgen weicht ab: ",
"Splitting is only allowed on one side" => "Aufteilung ist nur auf einer Seite erlaubt",
"Invalid debit amount " => "Ungültiger Debitorbetrag ",
"Invalid debit account number " => "Ungültiges Debitorenkonto ",
"Invalid credit amount " => "Ungültiger Kreditorbetrag ",
"Invalid credit account number " => "Ungültiges Kreditorenkonto ",
"Difference between debit and credit amounts " => "Unterschied zwischen Debitoren- und Kreditorenbetrag ",
"Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Zurückrollung fehlgeschlagen. Inkonsistente Datenbank: Bereinigung für die StapelId %0 im Buch %1 benötigt",
"Booking error creating stack entry" => "Buchungsfehler bei Erstellung des Stapeleintrages",
"Booking error creating stack debit entry" => "Buchungsfehler bei Erstellung des Stapeldebitoreneintrages",
"Booking error creating stack credit entry" => "Buchungsfehler bei Erstellung des Stapelkreditoreneintrages",
"Error deleting entry from stack" => "Fehler beim Löschen des Eintrages von Stapel",
"Booking error confirming stack entry" => "Buchungsfehler bei Bestätigung des Stapeleintrages",
"Error while updating statement" => "Fehler bei Aktualisierung der Abrechnung",
"is not a number" => "ist keine Nummer",
// "must be greater than 0" => "must be greater than 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
"Error checking" => "Fehler bei Überprüfung",
"does not exist" => "existiert nicht",
"already exists" => "existiert bereits",
"This book has been closed. You can't create new accounts." => "Dieses Buch wurde bereits geschlossen. Du kannst keine neuen Konten erstellen.",
"This book has been closed. You can't modify the account" => "Dieses Buch wurde geschlossen. Du kannst das Konto nicht verändern",
"This book has been closed. You can't delete the account" => "Dieses Buch wurde geschlossen. Du kannst das Konto nicht löschen",
"The date of the transaction is before the start date of this book" => "Das Transaktionsdatum liegt vor dem Datum zu dem das Buch startet",
"The date of the transaction is after the end date of this book." => "Das Datum des Geschäftsvorfalls liegt hinter dem Enddatum des Buches.",
"This book has been closed. Bookings can no longer be made in it" => "Dieses Buch wurde geschlossen. Du kannst nicht mehr hinein buchen",
"Invalid booking date" => "Ungültiges Buchungsdatum",
"This book has been closed. Transactions can no longer be cancelled in it" => "Dieses Buch wurde geschlossen. Du kannst Transaktionen nicht mehr abbrechen",
// "APC system, user and opcode caches cleared" => "APC system, user and opcode caches cleared",
// "APC %0 cache cleared" => "APC %0 cache cleared",
// "APC %0 cache not cleared" => "APC %0 cache not cleared",
"New article post" => "Neue Artikeleinreichung",
"Edited article post" => "Bearbeitete Artikeleinreichung",
"Deleted article post" => "Gelöschte Artikeleinreichung",
"The file has incorrect syntax or is not a CSV file" => "Diese Datei ist keine CSV Datei oder hat nicht die erforderliche Syntax",
"Error line: %d" => "Fehlerzeile: %d",
// "Import failed due to data format. Make sure the file has Unix-style line breaks" => "Import failed due to data format. Make sure the file has Unix-style line breaks",
"Spam is not welcome here" => "Spam ist hier nicht willkommen",
"anonymous" => "anonym",
"Blog cannot be found" => "Blog nicht gefunden",
"Locked by %0" => "Gesperrt von %0",
"refresh" => "aktualisieren",
"go back to this crumb" => "gehe zurück zu dieser Brotkrume",
"Administration" => "Verwaltung",
// "Cache file %0 is not writable" => "Cache file %0 is not writable",
"All day" => "den ganzen Tag",
"First day of week: Sunday (its ID is 0) - Translators, you need to localize this string!" => "1",
"Sunday" => "Sonntag",
"Su" => "So",
"Monday" => "Montag",
"Tuesday" => "Dienstag",
"Wednesday" => "Mittwoch",
"Thursday" => "Donnerstag",
"Friday" => "Freitag",
"Saturday" => "Samstag",
"Mo" => "Mo",
"Tu" => "Di",
"We" => "Mi",
"Th" => "Do",
"Fr" => "Fr",
"Sa" => "Sa",
"in" => "in",
"continued" => "weiter",
"New Image Uploaded by" => "Neue Bilder hochgeladen von",
"New Subscriptions" => "Neue Abonnenten",
"New Item in Tracker" => "Neuer Eintrag im Tracker",
"tracker" => "Tracker",
"by" => "von",
"Wiki" => "Wiki Seite",
"Image Gallery" => "Bildergalerie",
"Articles" => "Artikel",
"Blogs" => "Blogs",
"Forums" => "Foren",
"Directory" => "Linkverzeichnis",
"File Gallery" => "Dateiarchiv",
"FAQs" => "FAQs",
"Quizzes" => "Quiz",
"Trackers" => "Tracker",
"Survey" => "Umfrage",
"Newsletter" => "Newsletter",
// "Please type this word backwards" => "Please type this word backwards",
"Empty CAPTCHA value" => "Leerer Captcha Wert",
"You have mistyped the anti-bot verification code. Please try again" => "Du hast den Anti-Bot Prüfcode nicht richtig eingegeben. Bitte versuche es noch einmal",
"Failed to validate CAPTCHA" => "Konnte Captcha nicht bestätigen",
"CAPTCHA ID field is missing" => "Captcha ID-Feld fehlt",
"Get a visual challenge" => "Erhalte eine optische Aufgabe",
"Get an audio challenge" => "Erhalte eine akustische Aufgabe",
"Get a new challenge" => "Erhalte eine neue Aufgabe",
"Type the two words" => "Tippe die zwei Wörter",
"Type what you hear" => "Tippe was Du hörst",
"Help" => "Hilfe",
"Play sound again" => "Spiele den Sound nochmals",
"Download audio as an MP3 file" => "Lade den Sound als MP3 herunter",
"Incorrect. Try again" => "Falsch. Versuche es nochmals",
// "Invalid category identifier: \"%0\"" => "Invalid category identifier: \"%0\"",
"Top" => "Oben",
"A category named %0 already exists in %1" => "Eine Kategorie namens %0 existiert bereits in %1",
"article" => "Artikel",
"blog" => "Blog",
"directory" => "Linkverzeichnis",
"faq" => "FAQ",
"FAQ" => "FAQ",
"file gallery" => "Dateiarchiv",
"forum" => "Forum",
"image gallery" => "Bildergalerie",
"newsletter" => "Newsletter",
"poll" => "Abstimmung",
"quiz" => "Quiz",
"survey" => "Umfrage",
"wiki page" => "Wiki-Seite",
"image" => "Bild",
"calendar" => "Kalender",
"template" => "Vorlage",
"Permission denied" => "Zugriff verweigert",
"Invalid filename (using filters for filenames)" => "Ungültiger Dateiname (verwende Filter)",
"Cannot upload this file - maximum upload size exceeded" => "Datei überschreitet maximale Größe für das Hochladen",
"Cannot write to this file" => "Kann diese Datei nicht schreiben",
"(not registered)" => "(nicht registriert)",
"Anonymous" => "Unbekannt",
"Your comment was rejected" => "Dein Kommentar wurde zurückgewiesen",
"Cannot perform spam check: %0" => "Kann kein Spam-Prüfung vornehmen: %0",
"Please wait %0 seconds between posts" => "Bitte warte %0 Sekunden zwischen zwei Posts",
"Wrong password. Cannot post comment" => "Falsches Passwort. Kommentar kann nicht gespeichert werden",
"A contribution is mandatory" => "Die Art der Beteiligung muss angegeben werden",
// "Please enter a Title and Message for your new forum topic" => "Please enter a Title and Message for your new forum topic",
// "Please enter a Title and Message for your forum reply" => "Please enter a Title and Message for your forum reply",
// "Please enter a Message for your forum reply" => "Please enter a Message for your forum reply",
"Invalid Email" => "Ungültige E-Mail",
"Your message has been queued for approval and will be posted after a moderator approves it" => "Deine Nachricht wurde zur Freigabe eingereiht und wird veröffentlicht, wenn ein Moderator sie akzeptiert",
// "Use this thread to discuss the %s page" => "Use this thread to discuss the %s page",
"This forum is locked" => "Dieses Forum ist gesperrt",
"This thread is locked" => "Dieser Thread ist gesperrt",
// "An error occurred; please contact the administrator" => "An error occurred; please contact the administrator",
// "Route was updated" => "Route was updated",
// "Route was created" => "Route was created",
"Page cannot be found" => "Seite nicht gefunden",
// "From is required" => "From is required",
// "There is a route with the same From path already defined" => "There is a route with the same From path already defined",
// "Type is required" => "Type is required",
// "Selected type is not supported" => "Selected type is not supported",
"To" => "An",
"Article" => "Artikel",
"Blog" => "Blog",
"Forum" => "Forum",
"Object" => "Objekt",
"Tracker" => "Tracker",
"Field" => "Feld",
"Tracker Item Id" => "Tracker Objekt ID",
// "%s is required" => "%s is required",
"Error" => "Fehler",
"Note" => "Hinweis",
"Success" => "Erfolgreich",
"Warning" => "Warnung",
// "Feedback class called with no feedback provided" => "Feedback class called with no feedback provided",
// "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator" => "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator",
// "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Invalid request" => "Invalid request",
// "Failed to convert document %0 to pdf" => "Failed to convert document %0 to pdf",
// "Please check Action Log for more information" => "Please check Action Log for more information",
// "Please contact the administrator" => "Please contact the administrator",
// "H5P requires the CURL extension to be installed in PHP" => "H5P requires the CURL extension to be installed in PHP",
// "Failed to write to temp file %0" => "Failed to write to temp file %0",
// " (code=%0)" => " (code=%0)",
// "Exporting H5P content %0 failed" => "Exporting H5P content %0 failed",
// "Saving H5P content %0 (fileId %1) failed" => "Saving H5P content %0 (fileId %1) failed",
// "H5P directory is not writable: %0" => "H5P directory is not writable: %0",
// "Too many arguments on ceil" => "Too many arguments on ceil",
// "Too many arguments on date" => "Too many arguments on date",
// "Divide by zero on \"%0\"" => "Divide by zero on \"%0\"",
// "Too many arguments on floor" => "Too many arguments on floor",
"Unexpected values: %0" => "Unerwartete Werte: %0",
// "Field must be provided and contain one argument: list" => "Field must be provided and contain one argument: list",
// "Field must be provided and contain a function" => "Field must be provided and contain a function",
// "Too many arguments on less than" => "Too many arguments on less than",
// "Too many arguments on more than" => "Too many arguments on more than",
// "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]" => "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]",
// "Too many arguments for pad" => "Too many arguments for pad",
// "Too few arguments for pad" => "Too few arguments for pad",
// "Too many arguments on round" => "Too many arguments on round",
// "Content required" => "Content required",
// "Field must be provided and contain one argument: separator" => "Field must be provided and contain one argument: separator",
// "Field must be provided and contain one or more values: key or keys" => "Field must be provided and contain one or more values: key or keys",
// "Str-replace needs exactly 3 arguments: search, replace and subject" => "Str-replace needs exactly 3 arguments: search, replace and subject",
// "Too many arguments on strtotime" => "Too many arguments on strtotime",
// "Too few arguments on strtotime" => "Too few arguments on strtotime",
// "Field must be provided and contain one argument: group" => "Field must be provided and contain one argument: group",
// "Field must be provided and contain at least one argument: aggregate" => "Field must be provided and contain at least one argument: aggregate",
"%0 near \"%1\"" => "%0 nahe \"%1\"",
"Expecting \"(\"" => "Erwarte \"(\"",
"Unexpected \"%0\"" => "Unerwartet \"%0\"",
"Expecting \")\"" => "Erwarte \")\"",
"No formula provided" => "Keine Formel angegeben",
"Variable not found \"%0\"" => "Variable nicht gefunden \"%0\"",
"Unknown operation \"%0\"" => "Unbekannte Operation \"%0\"",
"Articles deleted" => "Gelöschte Artikel",
"removed the article" => "hat den Artikel entfernt",
"Edited articles" => "Bearbeitete Artikel",
"edited the article" => "hat den Artikel bearbeitet",
"New articles submitted" => "Neu eingereichte Artikel",
"created the article" => "hat den Artikel erstellt",
"New blog posts" => "Neuer Blog-Eintrag",
"replied to the blog" => "hat im Blog geantwortet",
"New calendar events" => "Neue Kalenderereignisse",
"%0 added or updated event %1" => "%0 hat das Ereignis %1 hinzugefügt oder aktualisiert",
"Changes in categories" => "Änderungen in Kategorieren",
"added the %0 %1 to the category %2" => "hat %0 %1 zur Kategorie %2 hinzugefügt",
"created the subcategory" => "erstellte die Unterkategorie",
"removed the subcategory" => "entfernte die Unterkategorie",
"from" => "von",
"edited the category" => "änderte die Kategorie",
"removed the %0 %1 from the category %2" => "hat %0 %1 von der Kategorie %2 entfernt",
"File galleries changed" => "Dateiarchive geändert",
"%0 edited the file gallery %1" => "%0 hat das Dateiarchiv %1 bearbeitet",
"%0 uploaded the file %1" => "%0 hat die Datei %1 bearbeitet",
"onto" => "nach",
"%0 removed the file %1 from %2" => "%0 hat die Datei %1 aus %2 entfernt",
"New replies in forum topics" => "Neue Antworten in Forenthemen",
"%0 <a href=%1>replied</a> to the topic %2" => "%0 hat auf Thme %2 <a href=%1>geantwortet</a>",
"New posts in forums" => "Neue Beiträge in Foren",
"%0 created the topic %1 at forum %2" => "%0 hat das Thema %1 im Forum %2 erstellt",
"Image galleries changed" => "Bildergalerien geändert",
"changed the picture gallery" => "änderte die Bildergalerie",
"uploaded the picture" => "lud das Bild",
"removed the picture" => "entfernte das Bild",
// "Wiki pages added to a structure" => "Wiki pages added to a structure",
"%0 added %1 wiki page to a structure" => "%0 hat Wiki-Seite %1 einer Struktur beigefügt",
// "Wiki pages moved down in a structure tree" => "Wiki pages moved down in a structure tree",
"%0 moved a wiki page down in a structure tree" => "%0 hat eine Wiki-Seite in einer Baumstruktur nach unten verschoben",
// "Wiki pages moved up in a structure tree" => "Wiki pages moved up in a structure tree",
"%0 moved a wiki page up in a structure tree" => "%0 hat eine Wiki-Seite in einer Baumstruktur nach oben verschoben",
// "Wiki pages removed from structure" => "Wiki pages removed from structure",
"%0 removed %1 wiki page from a structure" => "%0 hat Wiki-Seite %1 von einer Struktur getrennt",
// "File attached to tracker" => "File attached to tracker",
"%0 attached a file (%1) to tracker item %2" => "%0 hat eine Datei (%1) an den Trackereintrag %2 gehangen",
"Comments in tracker items" => "Kommentare in Tracker-Einträgen",
"%0 added a new comment to %1 on tracker %2" => "%0 hat einen neuen Kommentar zu %1 im Tracker %2 hinzugefügt",
"%0 added a new comment to item id %1 on tracker %2" => "%0 hat einen neuen Kommentar zur Eintrag-ID %1 im Tracker %2 hinzugefügt",
"Tracker items modified" => "Tracker-Einträge geändert",
"%0 added or updated tracker item %1 on tracker %2" => "%0 hat den Trackereintrag %1 im Tracker %2 hinzugefügt oder aktualisiert",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 hat die Trackereintrag-ID %1 im Tracker %2 hinzugefügt oder aktualisiert",
"New attachments in wiki pages" => "Neue Anhänge zu Wiki Seiten",
"%0 uploaded the file %1 onto %2" => "%0 hat die Datei %1 in %2 hochgeladen",
"Wiki pages updated" => "Wiki-Seiten aktualisiert",
"%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 hat die Wiki-Seite %1 in (<a href=%2>dieser Chronik</a> bearbeitet; <a href=%3>gesamte Chronik</a>)",
// "Wiki pages created" => "Wiki pages created",
// "%0 created the wikipage %1" => "%0 created the wikipage %1",
// "Wiki pages deleted" => "Wiki pages deleted",
// "%0 deleted the wikipage %1" => "%0 deleted the wikipage %1",
"and %0 more changes of the same type" => "und %0 weitere Änderung(en) vom gleichen Typ",
"Nothing has happened." => "Es wurde nichts geändert",
// "Report on %0 from %1 " => "Report on %0 from %1 ",
"(no changes)" => "(keine Änderungen)",
"(1 change)" => "(1 Änderung)",
"(%0 changes)" => "(%0 Änderungen)",
// "Scheduler task is stalled" => "Scheduler task is stalled",
// "Scheduler task is already running" => "Scheduler task is already running",
// "Unable to decode task params" => "Unable to decode task params",
// "***** Running scheduler %s *****" => "***** Running scheduler %s *****",
// "Scheduler %0 (id: %1) is stalled" => "Scheduler %0 (id: %1) is stalled",
// "Skip scheduler %s - %s" => "Skip scheduler %s - %s",
// "***** Scheduler %s - FAILED *****\n%s" => "***** Scheduler %s - FAILED *****\n%s",
// "***** Scheduler %s - OK *****" => "***** Scheduler %s - OK *****",
// "Scheduler with id %0 does not exist or is not active" => "Scheduler with id %0 does not exist or is not active",
// "Scheduler `%0` (id: %1) is stalled" => "Scheduler `%0` (id: %1) is stalled",
// "Scheduler `%0` (id: %1) was healed" => "Scheduler `%0` (id: %1) was healed",
// "Scheduler `%0` (id: %1) was not healed" => "Scheduler `%0` (id: %1) was not healed",
// "Scheduler %0 (id: %1) is not stalled, no need to heal" => "Scheduler %0 (id: %1) is not stalled, no need to heal",
// "Missing parameters to run the command" => "Missing parameters to run the command",
// "Executing console command: %s" => "Executing console command: %s",
// "Console command" => "Console command",
// "Missing the URL to call" => "Missing the URL to call",
// "Missing the file path to where the output should be saved" => "Missing the file path to where the output should be saved",
// "URL to invoke: %s" => "URL to invoke: %s",
// "Save output to: %s" => "Save output to: %s",
// "Using basic authentication" => "Using basic authentication",
// "Including additional headers" => "Including additional headers",
// "Sending request" => "Sending request",
// "Request was successful" => "Request was successful",
// "Failed to open file %s to write" => "Failed to open file %s to write",
// "Request failed" => "Request failed",
"URL" => "URL",
// "Output File" => "Output File",
// "File path to save the output" => "File path to save the output",
// "Additional HTTP Headers" => "Additional HTTP Headers",
// "One HTTP Header per line" => "One HTTP Header per line",
// "Auth Username" => "Auth Username",
// "Auth Password" => "Auth Password",
// "Missing shell command to execute" => "Missing shell command to execute",
// "Executing shell command: %s" => "Executing shell command: %s",
// "Shell command" => "Shell command",
// "Run timeout" => "Run timeout",
// "in seconds" => "in seconds",
// "Checking tiki version" => "Checking tiki version",
// "Sending emails" => "Sending emails",
// "Tiki version email sent to" => "Tiki version email sent to",
// "Tiki Version Updated" => "Tiki Version Updated",
// "Tiki Updates: " => "Tiki Updates: ",
// "Tiki Updates" => "Tiki Updates",
// "Invalid cron time format" => "Invalid cron time format",
// "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1" => "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1",
// "Missing required action parameter or value: %0" => "Missing required action parameter or value: %0",
// "Cannot apply change_status action to an object type %0" => "Cannot apply change_status action to an object type %0",
// "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Tracker item %0 not found" => "Tracker item %0 not found",
// "Tracker item %0 status %1 is different than the \"from\" status %2" => "Tracker item %0 status %1 is different than the \"from\" status %2",
// "Cannot apply delete action to an aggregation type %0" => "Cannot apply delete action to an aggregation type %0",
// "Cannot apply delete action to an object type %0" => "Cannot apply delete action to an object type %0",
// "Tracker field %0 not found" => "Tracker field %0 not found",
// "Cannot find file to delete: %0" => "Cannot find file to delete: %0",
// "Are you sure you want to permanently delete this object" => "Are you sure you want to permanently delete this object",
// "EmailAction - send to %0, subject - %1" => "EmailAction - send to %0, subject - %1",
// "Error sending email: %0" => "Error sending email: %0",
// "Page %s cannot be found" => "Page %s cannot be found",
// "EmailAction - can't send new message" => "EmailAction - can't send new message",
// "Cannot apply filegal_change_filename action to an object type %0" => "Cannot apply filegal_change_filename action to an object type %0",
// "Tracker field %0 not found for tracker %1" => "Tracker field %0 not found for tracker %1",
// "Tracker field %0 is not a Files field type" => "Tracker field %0 is not a Files field type",
// "filegal_change_filename action missing value parameter" => "filegal_change_filename action missing value parameter",
// "Cannot apply filegal_image_overlay action to an object type %0" => "Cannot apply filegal_image_overlay action to an object type %0",
// "filegal_image_overlay action missing value parameter" => "filegal_image_overlay action missing value parameter",
// "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1" => "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1",
// "Cannot apply tracker_item_modify action to an aggregation type %0" => "Cannot apply tracker_item_modify action to an aggregation type %0",
// "Cannot apply tracker_item_modify action to an object type %0" => "Cannot apply tracker_item_modify action to an object type %0",
// "tracker_item_modify action missing value, calc, add or remove parameter" => "tracker_item_modify action missing value, calc, add or remove parameter",
// "Field %0 not found on Action TrackerItemModify" => "Field %0 not found on Action TrackerItemModify",
// "Error applying tracker_item_modify calc formula to item %0: %1" => "Error applying tracker_item_modify calc formula to item %0: %1",
// "Unknown search action step: %0" => "Unknown search action step: %0",
// "Cannot apply wiki_approval action to an object type %0" => "Cannot apply wiki_approval action to an object type %0",
// "Wiki page %0 is not in pending state" => "Wiki page %0 is not in pending state",
// "Wiki page %0 does not require approval" => "Wiki page %0 does not require approval",
"Tentative" => "Unter Vorbehalt",
"Confirmed" => "Zugesagt",
"Cancelled" => "Abgelehnt",
"unknown" => "unbekannt",
"Unknown" => "Unbekannt",
// "Tracker Status" => "Tracker Status",
// "Webservice %0 field \"%1\" not found" => "Webservice %0 field \"%1\" not found",
"%0 (latest)" => "%0 (letzten)",
// "Elasticsearch does not support optimize" => "Elasticsearch does not support optimize",
// "Federated index %0 not found" => "Federated index %0 not found",
// "Unknown mapping type \"%0\" for field \"%1\"" => "Unknown mapping type \"%0\" for field \"%1\"",
"Document not found in index %1 (%0)" => "Dokument wurde nicht im Index %1 (%0) gefunden",
// "String \"%0\" cannot be formatted as a number for field \"%1\"" => "String \"%0\" cannot be formatted as a number for field \"%1\"",
// "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker" => "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker",
// "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0" => "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0",
// "Feature not supported" => "Feature not supported",
// "Parsing search query failed: \"%0\"" => "Parsing search query failed: \"%0\"",
// "Sort field %0 not found in index" => "Sort field %0 not found in index",
"No results for query" => "Keine Ergebnisse für Abfrage",
"Missing template \"%0\"" => "Fehlende Vorlage \"%0\"",
// "Template tplwiki page \"%0\" not found" => "Template tplwiki page \"%0\" not found",
// "Template wiki page \"%0\" not found" => "Template wiki page \"%0\" not found",
// "Error evaluating formula %0: %1" => "Error evaluating formula %0: %1",
"No value for '%0'" => "Kein Wert für '%0'",
"Unknown formatting rule '%0' for '%1'" => "Unbekannte Formatierungsregel '%0' für '%1'",
// "Category Tree" => "Category Tree",
"Categories" => "Kategorien",
"%0 (Tree)" => "%0 (Baum)",
"Tags" => "Tags",
// "Letter" => "Letter",
// "First word" => "First word",
"Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexierung beim Bearbeiten von \"%0\" (Typ %1) fehlgeschlagen. Der Fehler war \"%2\"",
// "Object %0 type %1 returned null from getDocument function" => "Object %0 type %1 returned null from getDocument function",
"Could not perform index modification: %0" => "Konnte die folgende Index-Modifizierung nicht durchführen: %0 ",
// "Feature not supported: %0" => "Feature not supported: %0",
"Missing objectype or qualifier for relation filter" => "Objekttyp oder Kennzeichner fehlt für Verhältnis-Filter",
// "Range filter \"from\" parameter not valid: \"%0\"" => "Range filter \"from\" parameter not valid: \"%0\"",
// "Range filter \"to\" parameter not valid: \"%0\"" => "Range filter \"to\" parameter not valid: \"%0\"",
// "Range filter \"gap\" parameter not valid: \"%0\"" => "Range filter \"gap\" parameter not valid: \"%0\"",
// "The range filter is missing \\\"from\\\" or \\\"to\\\"" => "The range filter is missing \\\"from\\\" or \\\"to\\\"",
// "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"" => "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"",
// "Distance sort: Missing lat or lon arguments" => "Distance sort: Missing lat or lon arguments",
// "Script sort: Missing source argument" => "Script sort: Missing source argument",
// "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled" => "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled",
"filterRange: \"from\" value not parsed" => "Filterbereich: \"von\" Wert nicht geparsed",
"filterRange: \"to\" value not parsed" => "Filterbereich: \"bis\" Wert nicht geparsed",
// "Malformed search query" => "Malformed search query",
"%0 (%1)" => "%0  (%1)",
// "Please confirm" => "Please confirm",
"OK" => "OK",
// "Are you sure you want to %0 the following %1" => "Are you sure you want to %0 the following %1",
// "Please confirm your action for the following item" => "Please confirm your action for the following item",
// "Please confirm your action for the following items" => "Please confirm your action for the following items",
"Activity stream currently unavailable" => "Aktivitätenstrom zur Zeit nicht verfügbar",
"Permission Denied" => "Zugriff verweigert",
// "Activity rule deleted" => "Activity rule deleted",
// "%0 activity rules deleted" => "%0 activity rules deleted",
// "No activity rules deleted" => "No activity rules deleted",
// "Delete Rule" => "Delete Rule",
// "Activity (id:' . (string) \$id . " => "Activity (id:' . (string) \$id . ",
// "No activities deleted" => "No activities deleted",
// "Delete Activity" => "Delete Activity",
// "Sample activity rule %0 updated" => "Sample activity rule %0 updated",
// "Sample activity rule %0 created" => "Sample activity rule %0 created",
// "Sample activity rule %0 unchanged" => "Sample activity rule %0 unchanged",
// "Edit Rule %0" => "Edit Rule %0",
// "Create Sample Rule" => "Create Sample Rule",
// "Basic activity rule %0 updated" => "Basic activity rule %0 updated",
// "Basic activity rule %0 created" => "Basic activity rule %0 created",
// "Basic activity rule %0 unchanged" => "Basic activity rule %0 unchanged",
// "Create Record Rule" => "Create Record Rule",
// "Tracker activity rule %0 updated" => "Tracker activity rule %0 updated",
// "Tracker activity rule %0 created" => "Tracker activity rule %0 created",
// "Tracker activity rule %0 unchanged" => "Tracker activity rule %0 unchanged",
// "Create Tracker Rule" => "Create Tracker Rule",
// "Advanced activity rule %0 updated" => "Advanced activity rule %0 updated",
// "Advanced activity rule %0 created" => "Advanced activity rule %0 created",
// "Advanced activity rule %0 unchanged" => "Advanced activity rule %0 unchanged",
// "Create Advanced Rule" => "Create Advanced Rule",
// "Sample" => "Sample",
"Basic" => "Basis",
"Advanced" => "Fortgeschritten",
// "Invalid rule type" => "Invalid rule type",
// "Type changed for activity rule %0" => "Type changed for activity rule %0",
// "Change Rule Type" => "Change Rule Type",
// "Status changed for activity rule %0" => "Status changed for activity rule %0",
// "Change Rule Status" => "Change Rule Status",
// "Content could not be loaded" => "Content could not be loaded",
// "Create article from URL" => "Create article from URL",
"Invalid input" => "Ungültige Eingabe",
"Invalid data" => "Falsche Daten",
// "Authentication added or modified" => "Authentication added or modified",
// "Authentication not added or modified" => "Authentication not added or modified",
// "Authentication deleted" => "Authentication deleted",
// "Authentication not deleted" => "Authentication not deleted",
"Oops" => "Upps",
"Action not found (%0 in %1)" => "Aktion nicht gefunden (%0 in %1)",
"Controller not found (%0)" => "Kontroller nicht gefunden (%0)",
// "No change made for one object already in the category" => "No change made for one object already in the category",
// "No change made for %0 objects already in the category" => "No change made for %0 objects already in the category",
// "One object added to category" => "One object added to category",
// "%0 objects added to category" => "%0 objects added to category",
// "No objects added to category" => "No objects added to category",
// "No change made for one object not in the category" => "No change made for one object not in the category",
// "No change made for %0 objects not in the category" => "No change made for %0 objects not in the category",
// "One object removed from category" => "One object removed from category",
// "%0 objects removed from category" => "%0 objects removed from category",
// "No objects removed from category" => "No objects removed from category",
// "Invalid %0 ID: %1" => "Invalid %0 ID: %1",
"Comments not allowed on this page" => "Kommentare sind auf dieser Seite nicht erlaubt",
"Loading.." => "Lade..",
"Comments" => "Kommentare",
"Parent is locked" => "Übergeordnetes Objekt ist gesperrt",
"Pseudonym must be specified" => "Pseudonym muss angegeben werden",
"Email must be specified" => "E-Mail muss angegeben werden",
"Title is empty" => "Titel ist leer",
"Content is empty" => "Inhalt ist leer",
// "Duplicated comment, there is already another comment with the same text" => "Duplicated comment, there is already another comment with the same text",
"Your comment was posted" => "Dein Kommentar wurde veröffentlicht",
"Permissions denied" => "Berechtigungen verweigert",
// "Lock comments" => "Lock comments",
// "Unlock comments" => "Unlock comments",
"Comment not found" => "Kommentar nicht gefunden",
"Comment already approved" => "Kommentar bereits bestätigt",
"Invalid argument" => "Ungültiges Argument",
"Thread not specified" => "Thread nicht angegeben",
// "Comment permissions: %0 object %1 not found" => "Comment permissions: %0 object %1 not found",
"Feature disabled" => "Funktion deaktiviert",
"Reserved for administrators during development" => "Reserviert für Administratoren während der Entwicklung",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
"There was an error (Tiki Connect is still experimental). Please try again" => "Etwas ist fehlgeschlagen. Tiki Connect ist immer noch experimentell. Versuche es bitte erneut",
"registration" => "Registrierung",
"confirmation" => "Bestätigung",
"Connect Feature disabled" => "Connect-Funktion deaktiviert",
"Connect server mode disabled" => "Connect-Server-Modus deaktiviert",
"Please confirm that you want to participate in Tiki Connect" => "Bitte bestätige, dass Du an Tiki Connect teilnehmen möchtest",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
"There was a problem at the server (Tiki Connect is still experimental)" => "Etwas ist auf dem Server fehlgeschlagen. Tiki Connect ist immer noch experimentell",
"CAPTCHA code problem" => "Captcha-Code-Problem",
"Connect data received, thanks" => "Connect-Daten erhalten. Danke",
"Your Tiki site is not registered here yet. Please try again" => "Deine Tiki ist hier noch nicht registriert. Versuche es bitte nochmals",
// "Remove custom route" => "Remove custom route",
// "Inline editor update" => "Inline editor update",
"Preview" => "Vorschau",
// "Syntax Help" => "Syntax Help",
"WYSIWYG Help" => "WYSIWYG Hilfe",
"Plugin Help" => "Pluginhilfe",
// "Spreadsheet Help" => "Spreadsheet Help",
// "Edit Help" => "Edit Help",
"Edit" => "Bearbeiten",
// "Tracker %0 not found" => "Tracker %0 not found",
// "The following parameters could not be converted to plugin list at this stage:\n" => "The following parameters could not be converted to plugin list at this stage:\n",
// "Plugins found containing: %0" => "Plugins found containing: %0",
// "No plugins found containing: %0" => "No plugins found containing: %0",
// "You do not have permission to edit \"%0\"" => "You do not have permission to edit \"%0\"",
// "Undefined parameter" => "Undefined parameter",
"Missing parameters" => "Fehlende Parameter",
// "%0 Plugin modified by editor" => "%0 Plugin modified by editor",
// "Page \"%0\" not found" => "Page \"%0\" not found",
// "%0 Plugin converted to list" => "%0 Plugin converted to list",
// "Plugin %0 on page %1 converted" => "Plugin %0 on page %1 converted",
"Authentication required" => "Authentifizierung erforderlich",
"Feature disabled: %0" => "Deaktivierte Funktion: %0",
// "Edit conflict" => "Edit conflict",
// "Edit conflict: %0 \"%1\" is being edited already by %2" => "Edit conflict: %0 \"%1\" is being edited already by %2",
"Field Required" => "Feld erforderlich",
"Not found" => "Nicht gefunden",
// "File Upload" => "File Upload",
// "File could not be uploaded" => "File could not be uploaded",
// "No file arrived" => "No file arrived",
// "File too large" => "File too large",
// "Unknown errors" => "Unknown errors",
// "File empty" => "File empty",
// "Batch file processed: \"%0\"" => "Batch file processed: \"%0\"",
"You don't have permission to upload zipped file packages" => "Berechtigung zum Hochladen gepackter Dateien nicht vorhanden",
"Browse" => "Durchsuchen",
// "Gallery List" => "Gallery List",
"Upload from source disabled" => "Hochladen von Quelle deaktiviert",
// "Unable to retrieve file from remote site. Please try a different URL" => "Unable to retrieve file from remote site. Please try a different URL",
"File could not be uploaded. Restrictions apply" => "Datei konnte nicht hochgeladen werden. Es gelten Beschränkungen",
"Manual refresh disabled" => "Manuelle Aktualisierung deaktiviert",
// "Gallery ID %0 not found" => "Gallery ID %0 not found",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help" => "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help",
"Requested gallery does not exist" => "Angefordertes Archiv existiert nicht",
// "Vimeo not authenticated" => "Vimeo not authenticated",
// "Upload Video" => "Upload Video",
"Unknown error" => "unbekannter Fehler",
// "No action was selected. Please select an action before clicking OK" => "No action was selected. Please select an action before clicking OK",
// "Merge selected posts with another topic" => "Merge selected posts with another topic",
// "Merge this post" => "Merge this post",
// "Merge these posts" => "Merge these posts",
// "Merge selected topics with another topic" => "Merge selected topics with another topic",
// "Merge this topic" => "Merge this topic",
// "Merge these topics" => "Merge these topics",
"Merge" => "Zusammenführen",
// "With this topic" => "With this topic",
// "All topics or posts were selected, leaving none to merge with. Please make your selection again" => "All topics or posts were selected, leaving none to merge with. Please make your selection again",
// "No topics were selected. Please select the topics you wish to merge before clicking the merge button" => "No topics were selected. Please select the topics you wish to merge before clicking the merge button",
// "The following post has been merged with the %0 topic" => "The following post has been merged with the %0 topic",
// "The following posts have been merged with the %0 topic" => "The following posts have been merged with the %0 topic",
// "Move this topic" => "Move this topic",
// "Move these topics" => "Move these topics",
// "From the %0 forum to the below forum" => "From the %0 forum to the below forum",
// "Move selected topics to another forum" => "Move selected topics to another forum",
"Move" => "Verschieben",
// "No topics were selected. Please select the topics you wish to move before clicking the move button" => "No topics were selected. Please select the topics you wish to move before clicking the move button",
// "The following topic has been moved to the %0 forum" => "The following topic has been moved to the %0 forum",
// "The following topics have been moved to the %0 forum" => "The following topics have been moved to the %0 forum",
// "Delete the following forum %0" => "Delete the following forum %0",
"Delete" => "Löschen",
// "No topics were selected. Please select the topics you wish to delete before clicking the delete button" => "No topics were selected. Please select the topics you wish to delete before clicking the delete button",
// "The following topic has been deleted" => "The following topic has been deleted",
// "The following topics have been deleted" => "The following topics have been deleted",
// "Delete the following attachment" => "Delete the following attachment",
// "No attachments were selected. Please select an attachment to delete" => "No attachments were selected. Please select an attachment to delete",
// "The following attachment has been deleted" => "The following attachment has been deleted",
// "The following attachments have been deleted" => "The following attachments have been deleted",
// "Reserved for forum administrators" => "Reserved for forum administrators",
// "Delete the following forum" => "Delete the following forum",
// "Delete the following forums" => "Delete the following forums",
// "No forums were selected. Please select a forum to delete" => "No forums were selected. Please select a forum to delete",
// "The following forum has been deleted" => "The following forum has been deleted",
// "The following forums have been deleted" => "The following forums have been deleted",
// "Reserved for forum administrators and moderators" => "Reserved for forum administrators and moderators",
// "%0 the following topic" => "%0 the following topic",
// "%0 the following topics" => "%0 the following topics",
// "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button" => "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button",
"locked" => "gesperrt",
"unlocked" => "entsperrt",
// "The following topic has been %0" => "The following topic has been %0",
// "The following topics have been %0" => "The following topics have been %0",
// "%0 the following thread" => "%0 the following thread",
// "thread" => "thread",
// "No threads were selected. Please select the threads you wish to %0" => "No threads were selected. Please select the threads you wish to %0",
// "archived" => "archived",
// "unarchived" => "unarchived",
// "The following thread has been %0" => "The following thread has been %0",
// "The following thread have been %0" => "The following thread have been %0",
// "The goal is currently disabled" => "The goal is currently disabled",
// "This goal is not enabled" => "This goal is not enabled",
// "Not eligible for this goal" => "Not eligible for this goal",
// "The goal has not been evaluated, administrator view" => "The goal has not been evaluated, administrator view",
// "Reserved for administrators" => "Reserved for administrators",
// "Manage Goals" => "Manage Goals",
// "Create Goal" => "Create Goal",
// "Edit Goal" => "Edit Goal",
// "Remove Goal" => "Remove Goal",
// "Conditions" => "Conditions",
// "Pages created" => "Pages created",
// "Condition" => "Condition",
// "Rewards" => "Rewards",
// "No available rewards" => "No available rewards",
// "Reward" => "Reward",
// "Restricted access" => "Restricted access",
// "Modify Eligibility for %0" => "Modify Eligibility for %0",
// "Delete the following group" => "Delete the following group",
// "Delete the following groups" => "Delete the following groups",
// "No groups were selected. Please select one or more groups" => "No groups were selected. Please select one or more groups",
// "The following group cannot be deleted" => "The following group cannot be deleted",
// "The following groups cannot be deleted" => "The following groups cannot be deleted",
// "The following group has been deleted" => "The following group has been deleted",
// "The following groups have been deleted" => "The following groups have been deleted",
"Group already exists" => "Gruppe existiert bereits",
// "Create the group %0" => "Create the group %0",
"Create" => "Erstellen",
// "Group name cannot be empty" => "Group name cannot be empty",
// "Group %0 (ID %1) successfully created" => "Group %0 (ID %1) successfully created",
// "Group %0 not created" => "Group %0 not created",
// "Modify the group %0" => "Modify the group %0",
// "Modify" => "Modify",
// "Group %0 successfully modified" => "Group %0 successfully modified",
// "Group %0 not modified" => "Group %0 not modified",
// "Add the following user to group %0" => "Add the following user to group %0",
// "Add the following users to group %0" => "Add the following users to group %0",
"Add" => "Hinzufügen",
// "One or more users must be selected" => "One or more users must be selected",
// "The following user was added to group %0" => "The following user was added to group %0",
// "The following users were added to group %0" => "The following users were added to group %0",
// "Ban the following user from group %0" => "Ban the following user from group %0",
// "Ban the following users from group %0" => "Ban the following users from group %0",
"Ban" => "Verbannen",
// "The following user was banned from group %0" => "The following user was banned from group %0",
// "The following users were banned from group %0" => "The following users were banned from group %0",
// "Unban the following user from group %0" => "Unban the following user from group %0",
// "Unban the following users from group %0" => "Unban the following users from group %0",
// "Unban" => "Unban",
// "The following user was unbanned from group %0" => "The following user was unbanned from group %0",
// "The following users were unbanned from group %0" => "The following users were unbanned from group %0",
// "h5p_enabled" => "h5p_enabled",
// "Create H5P Content" => "Create H5P Content",
// "Create H5P content" => "Create H5P content",
// "H5P Embed" => "H5P Embed",
// "No fileID provided" => "No fileID provided",
// "H5P Plugin" => "H5P Plugin",
// "Cannot find H5P content with fileId: %0" => "Cannot find H5P content with fileId: %0",
// "Edit H5P Content" => "Edit H5P Content",
// "H5P Edit" => "H5P Edit",
// "Waiting for javascript.." => "Waiting for javascript..",
// "H5P Content Libraries" => "H5P Content Libraries",
// "File not found on server. Check file upload settings" => "File not found on server. Check file upload settings",
// "H5P Results" => "H5P Results",
// "No contentId provided" => "No contentId provided",
// "H5P User Data" => "H5P User Data",
// "H5P User Results" => "H5P User Results",
// "You have successfully added %0 new media items" => "You have successfully added %0 new media items",
// "You have successfully added one new media item" => "You have successfully added one new media item",
// "No language provided" => "No language provided",
// "lang/\$language directory is not writable" => "lang/\$language directory is not writable",
"Wrote %d new strings and updated %d to lang/%s/language.php" => "%d neue Texte und %d aktualisierte in die Datei lang/%s/language.php geschrieben",
"Write to language.php" => "Schreibe in die Datei language.php",
// "Custom Translations" => "Custom Translations",
// "Invalid file type" => "Invalid file type",
// "File does not exist" => "File does not exist",
// "Invalid file type: php not allowed" => "Invalid file type: php not allowed",
// "Upload Translations" => "Upload Translations",
"Feature Disabled" => "Funktion deaktiviert",
// "Invalid file parameter supplied" => "Invalid file parameter supplied",
"Translation not supported for the specified object type" => "Übersetzung ist für den angegebenen Objekttyp nicht verfügbar",
"No source provided" => "Keine Quelle angegeben",
"Manage translations" => "Übersetzungen verwalten",
"No source or target provided" => "Keine Quelle oder Ziel angegeben",
// "You do not have permission to attach the selected translations" => "You do not have permission to attach the selected translations",
"Could not attach the translations" => "Konnte Übersetzungen nicht anhängen",
// "You do not have permission to detach the selected translations" => "You do not have permission to detach the selected translations",
"The object has no language indicated and cannot be translated" => "Objekt hat keine Sprache und kann nicht übersetzt werden",
// "The language directory is not readable" => "The language directory is not readable",
// "The language directory is not writeable" => "The language directory is not writeable",
// "String translation set is not an array" => "String translation set is not an array",
// "Can not fopen custom.php" => "Can not fopen custom.php",
// "Can not fwrite custom.php" => "Can not fwrite custom.php",
// "Source string translation set is not an array" => "Source string translation set is not an array",
// "Target string translation set is not an array" => "Target string translation set is not an array",
// "Invalid process type" => "Invalid process type",
// "Add new and update existing" => "Add new and update existing",
// "Add new only" => "Add new only",
// "Update existing only" => "Update existing only",
// "Replace all" => "Replace all",
// "Failed to connect or authenticate with remote host" => "Failed to connect or authenticate with remote host",
// "Account created or modified" => "Account created or modified",
// "Account not created or modified" => "Account not created or modified",
// "Modify Account" => "Modify Account",
// "Create Account" => "Create Account",
// "Account removed" => "Account removed",
// "Account not removed" => "Account not removed",
// "Remove Account" => "Remove Account",
// "Menu %0 not found" => "Menu %0 not found",
// "The %0 menu has been edited" => "The %0 menu has been edited",
// "The %0 menu has been created" => "The %0 menu has been created",
// "An error occurred - the %0 menu may not have been edited" => "An error occurred - the %0 menu may not have been edited",
// "An error occurred - the %0 menu may not have been created" => "An error occurred - the %0 menu may not have been created",
// "Edit Menu" => "Edit Menu",
// "Create Menu" => "Create Menu",
// "Menu %0 cloned as menu %1" => "Menu %0 cloned as menu %1",
"Clone this menu and its options" => "Klone dieses Menü mitsamt seinen Optionen",
// "Menu option %0 not found" => "Menu option %0 not found",
// "Menu Option %0" => "Menu Option %0",
// "Create Menu Option" => "Create Menu Option",
// "Your menu options have been imported" => "Your menu options have been imported",
// "Import Menu Options" => "Import Menu Options",
// "Menu Preview" => "Menu Preview",
// "The %0 menu has been removed" => "The %0 menu has been removed",
// "The %0 menu has not been removed" => "The %0 menu has not been removed",
// "Delete the %0 menu" => "Delete the %0 menu",
// "You don't have permission to edit menus (tiki_p_edit_menu)" => "You don't have permission to edit menus (tiki_p_edit_menu)",
// "You don't have permission to edit menu options (tiki_p_edit_menu_option)" => "You don't have permission to edit menu options (tiki_p_edit_menu_option)",
// "You don't have permission to edit menu options (edit_menu_option)" => "You don't have permission to edit menu options (edit_menu_option)",
// "Must Read" => "Must Read",
// "Invalid request method" => "Invalid request method",
// "Cannot circulate" => "Cannot circulate",
// "Circulate" => "Circulate",
// "Group does not exist" => "Group does not exist",
// "Misconfigured feature" => "Misconfigured feature",
// "Target field not found" => "Target field not found",
// "Object not found" => "Object not found",
// "Must Read for %0" => "Must Read for %0",
// "Must Read Item not found" => "Must Read Item not found",
"Read" => "Lesen",
// "Respond Privately" => "Respond Privately",
"Completed" => "Erledigt",
// "Missing %0 parameter" => "Missing %0 parameter",
// "Not Found" => "Not Found",
"No box available for %0" => "Keine Box für %0 verfügbar",
// "Invalid attribute name \"%0\"" => "Invalid attribute name \"%0\"",
// "Cannot lock \"%0\"" => "Cannot lock \"%0\"",
// "Reserved for payment administrators" => "Reserved for payment administrators",
// "Recommendations for %0" => "Recommendations for %0",
"Remote service inaccessible (%0)" => "Remote-Dienst ist unerreichbar (%0)",
// "Execution output" => "Execution output",
// "Scheduler %0 - FAILED" => "Scheduler %0 - FAILED",
// "Scheduler %0 - OK" => "Scheduler %0 - OK",
// "Running %0" => "Running %0",
// "Reset scheduler run" => "Reset scheduler run",
"Rebuild Index" => "Index neu erstellen",
// "Process Update Queue" => "Process Update Queue",
"empty" => "leer",
// "Lookup Result" => "Lookup Result",
// "ManifoldCF Configuration Check" => "ManifoldCF Configuration Check",
// "Create ManifoldCF Index" => "Create ManifoldCF Index",
// "A query could not be created because the name is already in use" => "A query could not be created because the name is already in use",
// "Could not obtain the query" => "Could not obtain the query",
// "Save Search" => "Save Search",
// "Saved Searches" => "Saved Searches",
// "Delete Saved Search" => "Delete Saved Search",
// "Edit Saved Search" => "Edit Saved Search",
// "Search functionality currently unavailable" => "Search functionality currently unavailable",
// "Theme Customizer" => "Theme Customizer",
// "Item not found" => "Item not found",
"Reserved for tracker administrators" => "Für Tracker-Administratoren reserviert",
"Type does not exist" => "Typ existiert nicht",
"Add Field" => "Feld hinzufügen",
// "Warning: There is a conflict in permanent names, which can cause indexing errors" => "Warning: There is a conflict in permanent names, which can cause indexing errors",
// "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4" => "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4",
// "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen" => "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen",
"Warning: Required field types not enabled: %0" => "Warnung: der erforderliche Feldtyp (%0) ist nicht aktiviert",
"Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker enthält kein aufgelistetes Feld. Es werden keine sinnvollen Daten in der Standardliste ausgegeben",
"The tracker contains no field in the title, so no link will be generated" => "Tracker enthält kein Feld im Titel. Es wird kein Link erstellt",
// "Field handler not found" => "Field handler not found",
// "%0" => "%0",
"CAPTCHA" => "CAPTCHA",
"Distinct" => "Verschieden",
"Page Name" => "Seitenname",
"Password" => "Passwort",
"Regular Expression (Pattern)" => "Regulärer Ausdruck (Muster)",
"Username" => "Benutzername",
// "Export Fields" => "Export Fields",
"Invalid data provided" => "Ungültige Daten",
"Import Tracker Fields" => "Importiere Tracker-Felder",
// "No item to clone" => "No item to clone",
// "Duplicate Item" => "Duplicate Item",
// "Item could not be created. Only one item per user is allowed" => "Item could not be created. Only one item per user is allowed",
// "Item created" => "Item created",
// "New \"%0\" item successfully created" => "New \"%0\" item successfully created",
// "New tracker item %0 successfully created" => "New tracker item %0 successfully created",
// "Tracker item could not be created" => "Tracker item could not be created",
"Create Item" => "Erstelle Eintrag",
// "Tracker item %0 has been updated" => "Tracker item %0 has been updated",
// "%0: Updated \"%1\"" => "%0: Updated \"%1\"",
// "Comment for edit #%0" => "Comment for edit #%0",
// "Update Item" => "Update Item",
// "Are you sure you would like to update this item" => "Are you sure you would like to update this item",
"Save" => "Speichern",
// "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0" => "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0",
// "Tracker item %0 has been successfully deleted" => "Tracker item %0 has been successfully deleted",
"Remove" => "Entfernen",
// "Validation error" => "Validation error",
// "Create Tracker" => "Create Tracker",
"Duplicate Tracker" => "Tracker duplizieren",
// "Export Items" => "Export Items",
// "Import Tracker Structure" => "Import Tracker Structure",
"File upload failed" => "Hochladen der Datei ist fehlgeschlagen",
"Uploaded file could not be read" => "Hochgeladene Datei konnte nicht gelesen werden",
// "Import Items" => "Import Items",
// "Import Tracker From Profile/YAML" => "Import Tracker From Profile/YAML",
"Last Modification" => "Letzte Änderung",
"Creation Date" => "Erstellungsdatum",
"Item ID" => "Eintrag-Id",
"Filename" => "Dateiname",
"Creation date" => "Erstellungsdatum",
"Views" => "Ansichten",
"File size" => "Dateigröße",
"Version" => "Version",
"File type" => "Dateityp",
"Long description" => "Lange Beschreibung",
"User" => "Benutzer",
// "Select Tracker" => "Select Tracker",
"You don't have permission to view the tracker" => "Es ist nicht erlaubt, Tracker anzusehen",
// "The item to clone isn't visible" => "The item to clone isn't visible",
// "You don't have permission to create new items" => "You don't have permission to create new items",
// "Cannot remove item %0 from this tracker" => "Cannot remove item %0 from this tracker",
"You don't have permission to export" => "Exportieren ist nicht erlaubt",
"Remote Source" => "Remote Quelle",
"Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Automatisch erstelltes Feld für synchronisierte Tracker. Enthält die Eintrag-ID des Remote-Eintrags",
// "Clone Remote Tracker" => "Clone Remote Tracker",
"Tracker does not exist" => "Tracker existiert nicht",
"Tracker is not synchronized with a remote source" => "Der Tracker ist nicht mit der Remote-Quelle synchronisiert",
// "Tabular Formats" => "Tabular Formats",
// "Remove Format" => "Remove Format",
// "Create Tabular Format" => "Create Tabular Format",
// "Edit Format: %0" => "Edit Format: %0",
// "Format %0 not found" => "Format %0 not found",
// "Duplicate Format: %0" => "Duplicate Format: %0",
// "%0 copy" => "%0 copy",
// "Fields in %0" => "Fields in %0",
// "No formats available" => "No formats available",
// "Select Format" => "Select Format",
// "Primary Key required" => "Primary Key required",
// "Your import was completed successfully" => "Your import was completed successfully",
"Import" => "Importieren",
// "Filter %0" => "Filter %0",
"Filter" => "Filtern",
"Export %0" => "Exportiere %0",
"Export" => "Exportieren",
// "Create tabular format and tracker from file" => "Create tabular format and tracker from file",
"Operation reserved for tracker administrators" => "Operation ist für Tracker-Administratoren reserviert",
"Events" => "Ereignisse",
"The following mandatory fields are missing: %0" => "Nachfolgende zwingende Felder fehlen (%0)",
"Invalid value in %0: %1" => "Ungültiger Wert in %0: %1",
"Invalid value in %0" => "Ungültiger Wert in %0",
// "Field %0 does not exist in tracker" => "Field %0 does not exist in tracker",
// "The terms and conditions were modified while you were reading them" => "The terms and conditions were modified while you were reading them",
// "You are required to approve the terms of use to continue" => "You are required to approve the terms of use to continue",
// "Terms and Conditions" => "Terms and Conditions",
// "You must enter your date of birth to continue" => "You must enter your date of birth to continue",
// "Age Validation" => "Age Validation",
// "We were unable to create your account because this email is already in use" => "We were unable to create your account because this email is already in use",
"Friend" => "Freund",
// "Remove Friend" => "Remove Friend",
"Add Friend" => "Eine(n) Freund(in) befügen",
// "Following you" => "Following you",
// "Remove Follower" => "Remove Follower",
// "You are following" => "You are following",
// "Stop Following" => "Stop Following",
// "Follow" => "Follow",
// "Awaiting your approval" => "Awaiting your approval",
// "Refuse Request" => "Refuse Request",
// "Accept &amp; Add" => "Accept &amp; Add",
"Accept Request" => "Akzeptiere Anfrage",
// "Waiting for approval" => "Waiting for approval",
// "Cancel Request" => "Cancel Request",
"Hidden" => "versteckt",
"km" => "km",
// "You need to set \"Show my information on mouseover\"" => "You need to set \"Show my information on mouseover\"",
"Click here" => "Klicke hier",
// "You need to log in" => "You need to log in",
// "Delete the following user" => "Delete the following user",
// "Delete the following users" => "Delete the following users",
// "No users were selected. Please select one or more users" => "No users were selected. Please select one or more users",
// "The following user has been deleted" => "The following user has been deleted",
// "Submit form below to ban this user" => "Submit form below to ban this user",
// "The following users have been deleted" => "The following users have been deleted",
// "Submit form below to ban these users" => "Submit form below to ban these users",
// "Ban the following user's IP" => "Ban the following user's IP",
// "Clicking Ban will redirect you to a form where this user's is preselected for IP banning" => "Clicking Ban will redirect you to a form where this user's is preselected for IP banning",
// "Ban the following users' IPs" => "Ban the following users' IPs",
// "Clicking Ban will redirect you to a form where these users' are preselected for IP banning" => "Clicking Ban will redirect you to a form where these users' are preselected for IP banning",
// "See highlighted section in the form below for users you have selected for banning" => "See highlighted section in the form below for users you have selected for banning",
// "Remove the following user from group %0" => "Remove the following user from group %0",
// "For this user" => "For this user",
// "For these selected users" => "For these selected users",
// "Change group assignments for selected users" => "Change group assignments for selected users",
"%s %s assigned to %s %s" => "%s %s zugewiesen zu %s %s",
"user" => "Benutzer",
"group" => "Gruppe",
// "An error occurred. The group assignment failed" => "An error occurred. The group assignment failed",
"%s %s removed from %s %s." => "%s %s wurde aus %s %s entfernt.",
// "The following user" => "The following user",
// "The following users" => "The following users",
// "%0 had the following group set as default" => "%0 had the following group set as default",
// "%0 been %1 the following %2" => "%0 been %1 the following %2",
// "Set default group for selected users" => "Set default group for selected users",
// "Make this the default group" => "Make this the default group",
// "group %s set as the default group for user %s" => "group %s set as the default group for user %s",
// "For the following user" => "For the following user",
// "For the following users" => "For the following users",
// "The following group has been set as the default group" => "The following group has been set as the default group",
// "Send wiki page content by email to selected users" => "Send wiki page content by email to selected users",
"Page not found" => "Seite wurde nicht gefunden",
// "The page does not have a description, which is mandatory to perform this action" => "The page does not have a description, which is mandatory to perform this action",
// "Invalid bcc email address" => "Invalid bcc email address",
// "and blind copied (bcc) to %0" => "and blind copied (bcc) to %0",
// "The template page has no text or the text cannot be extracted" => "The template page has no text or the text cannot be extracted",
// "Mail sent to user %s" => "Mail sent to user %s",
// "The page %0 has been emailed to the following user" => "The page %0 has been emailed to the following user",
// "The page %0 has been emailed to the following users" => "The page %0 has been emailed to the following users",
// "And blind copied to %0" => "And blind copied to %0",
// "No user was selected" => "No user was selected",
// "Message not sent - no subject or body" => "Message not sent - no subject or body",
// "Your message was successfully sent to %0" => "Your message was successfully sent to %0",
"An error occurred, please check your mail settings and try again" => "Ein Fehler ist aufgetreten. Prüfe bitte Deine E-Maileinstellungen und versuche es nochmals",
// "Please specify validity period" => "Please specify validity period",
// "The group %0 does not exist" => "The group %0 does not exist",
// "Your invite has been sent" => "Your invite has been sent",
// "You must set a user for whom to set an avatar" => "You must set a user for whom to set an avatar",
// "You do not have the permission to change the avatar" => "You do not have the permission to change the avatar",
// "You must select an avatar to upload" => "You must select an avatar to upload",
// "An error occurred. User page for %0 could not be deleted" => "An error occurred. User page for %0 could not be deleted",
"Deleted account %s" => "Konto %s gelöscht",
// "An error occurred. User %0 could not be deleted" => "An error occurred. User %0 could not be deleted",
"secure connection required" => "sichere Verbindung erforderlich",
// "You cannot see this user's data" => "You cannot see this user's data",
// "Send Me a Message" => "Send Me a Message",
// "Upload Avatar" => "Upload Avatar",
"Must be authenticated" => "Muss authentifiziert sein",
// "Notifications for %0" => "Notifications for %0",
// "No notifications" => "No notifications",
"Notifications" => "Benachrichtigungen",
// "Unread Notifications" => "Unread Notifications",
// "Mark all notifications as read" => "Mark all notifications as read",
// "Must be registered" => "Must be registered",
// "Friend List" => "Friend List",
// "User not found" => "User not found",
// "Approve Friend" => "Approve Friend",
// "Regenerate Wiki URLs" => "Regenerate Wiki URLs",
// "the only version of" => "the only version of",
// "all versions of" => "all versions of",
// "the last version of" => "the last version of",
// "Delete %0 the following %1" => "Delete %0 the following %1",
// "You do not have permission to remove the selected page(s)" => "You do not have permission to remove the selected page(s)",
// "No pages were selected. Please select one or more pages" => "No pages were selected. Please select one or more pages",
// "An error occurred. %0%1 could not be deleted" => "An error occurred. %0%1 could not be deleted",
"All versions" => "Alle Versionen",
// "The last version" => "The last version",
// "Version %0" => "Version %0",
// "%0 of the following page %1 been deleted" => "%0 of the following page %1 been deleted",
// "%0 of the following pages %1 been deleted" => "%0 of the following pages %1 been deleted",
// "Redirection page not specified. 301 redirect not created" => "Redirection page not specified. 301 redirect not created",
// "Semantic aliases (301 Redirects) to this page were created when other pages were deleted" => "Semantic aliases (301 Redirects) to this page were created when other pages were deleted",
// "A semantic alias (301 Redirect) to this page was created when page %0 was deleted" => "A semantic alias (301 Redirect) to this page was created when page %0 was deleted",
// "301 Redirects to the following page were created" => "301 Redirects to the following page were created",
// "A 301 Redirect to the following page was created" => "A 301 Redirect to the following page was created",
// "The following page and 301 Redirects to it were created" => "The following page and 301 Redirects to it were created",
// "The following page and a 301 Redirect to it were created" => "The following page and a 301 Redirect to it were created",
// "Delete the following %0 of %1" => "Delete the following %0 of %1",
// "No version were selected. Please select one or more versions" => "No version were selected. Please select one or more versions",
// "An error occurred. Version %0 could not be deleted" => "An error occurred. Version %0 could not be deleted",
// "The following version of %0 has been deleted" => "The following version of %0 has been deleted",
// "The following versions of %0 have been deleted" => "The following versions of %0 have been deleted",
// "Print the following page" => "Print the following page",
// "Print the following pages" => "Print the following pages",
"Print" => "Drucken",
// "No page specified" => "No page specified",
// "Export the following page to PDF" => "Export the following page to PDF",
// "Export the following pages to PDF" => "Export the following pages to PDF",
"PDF" => "PDF",
// "Lock the following page" => "Lock the following page",
// "Lock the following pages" => "Lock the following pages",
"Lock" => "Sperren",
// "Excludes selected pages already locked or for which you lack permission to lock" => "Excludes selected pages already locked or for which you lack permission to lock",
// "You do not have permission to lock the selected pages or they have already been locked" => "You do not have permission to lock the selected pages or they have already been locked",
// "The following page was not locked due to an error" => "The following page was not locked due to an error",
// "The following pages were not locked due to an error" => "The following pages were not locked due to an error",
// "The following page has been locked" => "The following page has been locked",
// "The following pages have been locked" => "The following pages have been locked",
// "Unlock the following page" => "Unlock the following page",
// "Unlock the following pages" => "Unlock the following pages",
"Unlock" => "Entsperren",
// "Excludes selected pages already unlocked or for which you lack permission to unlock" => "Excludes selected pages already unlocked or for which you lack permission to unlock",
// "You do not have permission to unlock the selected pages or they have already been unlocked" => "You do not have permission to unlock the selected pages or they have already been unlocked",
// "The following page was not unlocked due to an error" => "The following page was not unlocked due to an error",
// "The following pages were not unlocked due to an error" => "The following pages were not unlocked due to an error",
// "The following page has been unlocked" => "The following page has been unlocked",
// "The following pages have been unlocked" => "The following pages have been unlocked",
// "Download a zipped file of the following page" => "Download a zipped file of the following page",
// "Download a zipped file of the following pages" => "Download a zipped file of the following pages",
// "Zip" => "Zip",
// "Add page name as header of the following page" => "Add page name as header of the following page",
// "Add page name as header of the following pages" => "Add page name as header of the following pages",
// "The following page was not found" => "The following page was not found",
// "The following pages were not found" => "The following pages were not found",
// "The page name was added as header to the following page" => "The page name was added as header to the following page",
// "The page name was added as header to the following pages" => "The page name was added as header to the following pages",
// "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents",
// "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents",
// "Create Workspace" => "Create Workspace",
// "Workspace Templates" => "Workspace Templates",
// "Create Workspace Template" => "Create Workspace Template",
"Edit template %0" => "Bearbeite Vorlage %0",
"Workspaces" => "Arbeitsbereiche",
"Could not create workspace root" => "Konnte Arbeitsbereichswurzel (workspace root) nicht erstellen",
"Invalid user" => "Ungültiger Benutzer",
// "Invalid token" => "Invalid token",
// "Empty authorization" => "Empty authorization",
// "Wrong authorization format" => "Wrong authorization format",
// "You don't have enough privileges" => "You don't have enough privileges",
// "Select a filter" => "Select a filter",
"n/a" => "n/a",
// "Server-side Processing" => "Server-side Processing",
// "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort" => "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort",
// "Overall Sort Settings" => "Overall Sort Settings",
// "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts" => "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts",
"Pre-sorted Columns" => "Vorsortierte Spalten",
// "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns" => "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns",
// "Sort Settings by Column" => "Sort Settings by Column",
// "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5" => "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5",
// "Set %0 to one of the following" => "Set %0 to one of the following",
// "Also handle strings in numeric columns with" => "Also handle strings in numeric columns with",
// "Handle empty cells with" => "Handle empty cells with",
// "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)" => "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)",
// "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5" => "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5",
"Column Filters" => "Spalten Filter",
// "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters" => "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters",
// "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)" => "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)",
// "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>" => "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>",
// "Options generated automatically if not set and the %0server%1 parameter is not %0y%1" => "Options generated automatically if not set and the %0server%1 parameter is not %0y%1",
// "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown" => "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown",
// "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually" => "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually",
// "Date range - " => "Date range - ",
"(from and to values set defaults for these fields when user clicks on the input field)" => "(von und bis Werte bestimmen die Standardwerte dieser Felder wenn der Benutzer das Eingabefeld anklickt)",
// "Beware that items with empty date values will not be shown when default date range filters are applied" => "Beware that items with empty date values will not be shown when default date range filters are applied",
// "Numeric range - " => "Numeric range - ",
// "No filter - " => "No filter - ",
// "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list" => "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list",
// "Filter Options" => "Filter Options",
// "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1" => "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1",
// "Paginate" => "Paginate",
// "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: " => "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: ",
// "Column Select" => "Column Select",
// "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns" => "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns",
// "Totals" => "Totals",
// "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1" => "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1",
// "Setting to %0 will add one column total row set as follows: %1" => "Setting to %0 will add one column total row set as follows: %1",
// "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations" => "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations",
// "Instructions for each total option follows" => "Instructions for each total option follows",
// "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total" => "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total",
// "set what the calculation is. Choices are" => "set what the calculation is. Choices are",
// "Click %0 for a description of these options" => "Click %0 for a description of these options",
// "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)" => "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)",
// "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals" => "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals",
// "Total Format" => "Total Format",
// "Format for table totals (click %0 for patterns). Example" => "Format for table totals (click %0 for patterns). Example",
// "Total Options" => "Total Options",
// "Pipe-separated options for totals for each column which are set in the %0 parameter" => "Pipe-separated options for totals for each column which are set in the %0 parameter",
// "overrides the default number format set in %0" => "overrides the default number format set in %0",
// "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter" => "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter",
"Example:" => "Beispiel:",
// "Page totals" => "Page totals",
// "Please install Faker package" => "Please install Faker package",
// "Object \"%0\" of type \"%1\" not found" => "Object \"%0\" of type \"%1\" not found",
// "The value of items is not a number" => "The value of items is not a number",
// "Tracker not found" => "Tracker not found",
// "Invalid field definition: %0" => "Invalid field definition: %0",
// "Checking for image gallery files skipped" => "Checking for image gallery files skipped",
// "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter" => "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter",
// "Tracker Attachments" => "Tracker Attachments",
// "Wiki Attachments" => "Wiki Attachments",
// "Forum Attachments" => "Forum Attachments",
// "Configured to stores files in Database" => "Configured to stores files in Database",
// "Configured to stores files on Disk: %0" => "Configured to stores files on Disk: %0",
// "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files" => "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files",
// "Files in DB: %0" => "Files in DB: %0",
// "Files on Disk: %0" => "Files on Disk: %0",
// "No Issues found" => "No Issues found",
// "Found %0 Issues, details below" => "Found %0 Issues, details below",
// "The following files are missing" => "The following files are missing",
"Id" => "ID",
// "The following files have different size that expected" => "The following files have different size that expected",
// "The following files are unknown, exists in the folder, but not in the database" => "The following files are unknown, exists in the folder, but not in the database",
// "Copy files from file galleries to a regular directory on the file system" => "Copy files from file galleries to a regular directory on the file system",
// "Feature Galleries not set up" => "Feature Galleries not set up",
// "File Copy: Gallery #%0 not found" => "File Copy: Gallery #%0 not found",
// "File Copy: Destination path required" => "File Copy: Destination path required",
// "No files to copy" => "No files to copy",
// "File Copy starting.." => "File Copy starting..",
// "File Copy complete" => "File Copy complete",
// "Move files from file galleries to a regular directory on the file system" => "Move files from file galleries to a regular directory on the file system",
// "File Move: Gallery #%0 not found" => "File Move: Gallery #%0 not found",
// "File Move: Destination path required" => "File Move: Destination path required",
// "No files to move" => "No files to move",
// "Use the --confirm option to proceed with the move operation" => "Use the --confirm option to proceed with the move operation",
// "File Move starting.." => "File Move starting..",
// "File Move complete" => "File Move complete",
// "Migrate images from the Image Gallery to the File Gallery" => "Migrate images from the Image Gallery to the File Gallery",
// "All files migrated" => "All files migrated",
// "No files migrated, default file gallery path is not writable" => "No files migrated, default file gallery path is not writable",
// "%0 reached for %1 (%2)" => "%0 reached for %1 (%2)",
"Search index could not be updated: %0" => "Suchindex konnte nicht aktualisiert werden: %0",
// "Clean Tiki install" => "Clean Tiki install",
// "Force installation. Overwrite any current database" => "Force installation. Overwrite any current database",
// "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM" => "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM",
// "Installation completed" => "Installation completed",
// "Queries executed successfully: %0" => "Queries executed successfully: %0",
// "Error %0 in" => "Error %0 in",
// "Database already exists" => "Database already exists",
// "Dependencies not satisfied. Exiting" => "Dependencies not satisfied. Exiting",
// "Composer could not be executed" => "Composer could not be executed",
// "Extension %0 is now disabled" => "Extension %0 is now disabled",
// "Extension %0 was not disabled" => "Extension %0 was not disabled",
// "Extension %0 was updated" => "Extension %0 was updated",
// "Extension %0 is now enabled" => "Extension %0 is now enabled",
// "Extension %0 was not enabled" => "Extension %0 was not enabled",
// "Installing package: " => "Installing package: ",
// "Invalid Package: " => "Invalid Package: ",
// "No packages available to be installed" => "No packages available to be installed",
// "No packages found in composer.json in the root of the project" => "No packages found in composer.json in the root of the project",
// "No packages installed" => "No packages installed",
// "Packages Installed" => "Packages Installed",
// "Packages Available to Install" => "Packages Available to Install",
// "No packages available to be removed" => "No packages available to be removed",
// "Removing package: " => "Removing package: ",
// "Packages that can be removed" => "Packages that can be removed",
// "No packages available to be updated" => "No packages available to be updated",
// "Updating package: " => "Updating package: ",
// "Packages that can be updated" => "Packages that can be updated",
// "Approve a list of plugin invocations/calls" => "Approve a list of plugin invocations/calls",
// "List fingerprints of the plugin invocations/calls to approve separated by commas" => "List fingerprints of the plugin invocations/calls to approve separated by commas",
// "Approve all plugin invocations/calls" => "Approve all plugin invocations/calls",
// "You must either use the option --all or provide a list of fingerprints to approve" => "You must either use the option --all or provide a list of fingerprints to approve",
// "Approving all pending plugins" => "Approving all pending plugins",
// "Approving a list of plugins" => "Approving a list of plugins",
// "Approving plugin %0" => "Approving plugin %0",
// "Plugins approved with success" => "Plugins approved with success",
// "List all plugin invocations/calls" => "List all plugin invocations/calls",
// "Shows only invocations/calls pending approval" => "Shows only invocations/calls pending approval",
// "Listing plugins in status: %0" => "Listing plugins in status: %0",
// "Found %0 plugins" => "Found %0 plugins",
// "No plugins found" => "No plugins found",
// "Parses all the pages to refresh the list of plugin invocations/calls" => "Parses all the pages to refresh the list of plugin invocations/calls",
// "Plugin list refreshed with success" => "Plugin list refreshed with success",
// "Not enough arguments (missing: \"article\" or \"--all\" options)" => "Not enough arguments (missing: \"article\" or \"--all\" options)",
// "Not enough arguments (missing: \"calendar\" or \"--all\" option)" => "Not enough arguments (missing: \"calendar\" or \"--all\" option)",
// "Not enough arguments (missing: \"category\" or \"--all\" options)" => "Not enough arguments (missing: \"category\" or \"--all\" options)",
// "Not enough arguments (missing: \"forum\" or \"--all\" option)" => "Not enough arguments (missing: \"forum\" or \"--all\" option)",
// "Not enough arguments (missing: \"menu\" or \"--all\" option)" => "Not enough arguments (missing: \"menu\" or \"--all\" option)",
// "Not enough arguments (missing: \"name\" or \"--all\" options)" => "Not enough arguments (missing: \"name\" or \"--all\" options)",
// "Not enough arguments (missing: \"tracker\" or \"--all\" option)" => "Not enough arguments (missing: \"tracker\" or \"--all\" option)",
// "No Items found to export" => "No Items found to export",
// "Tracker item %0 exported" => "Tracker item %0 exported",
// "Tracker item %0 failed to exported" => "Tracker item %0 failed to exported",
// "Tracker items for tracker %0 exported" => "Tracker items for tracker %0 exported",
// "Not enough arguments (missing: \"page\" or \"--all\" option)" => "Not enough arguments (missing: \"page\" or \"--all\" option)",
// "Profile name" => "Profile name",
// "profiles.tiki.org" => "profiles.tiki.org",
// "Re-apply profiles when already applied" => "Re-apply profiles when already applied",
// "Return to the user information about what is going to be applied" => "Return to the user information about what is going to be applied",
// "Some of the named object references in the profile are invalid" => "Some of the named object references in the profile are invalid",
// "Profile applied" => "Profile applied",
// "Installation failed" => "Installation failed",
// "Dry-run for profile: " => "Dry-run for profile: ",
// "Permission removed: " => "Permission removed: ",
// "Permission added: " => "Permission added: ",
// "User modified: " => "User modified: ",
// "User added: " => "User added: ",
// "Group modified: " => "Group modified: ",
// "Group added: " => "Group added: ",
// "Preference set: %0= %1 old value= %2" => "Preference set: %0= %1 old value= %2",
// "Installer added: " => "Installer added: ",
// "Profile was already applied. Nothing happened" => "Profile was already applied. Nothing happened",
// "SCSS Parse Error" => "SCSS Parse Error",
// "SCSS Compiler Error" => "SCSS Compiler Error",
// "SCSS Range Error" => "SCSS Range Error",
// "SCSS Server Error" => "SCSS Server Error",
// "SCSS Error" => "SCSS Error",
// "Preference \"sitemap_enable\" is not enabled" => "Preference \"sitemap_enable\" is not enabled",
// "New sitemap created" => "New sitemap created",
"File not found" => "Datei nicht gefunden",
// "File is not a .zip file" => "File is not a .zip file",
// "Theme installed" => "Theme installed",
// "Theme not found" => "Theme not found",
// "Theme removed successfully" => "Theme removed successfully",
// "An error occurred while deleting theme" => "An error occurred while deleting theme",
// "CSS folder not found" => "CSS folder not found",
// "Configuration file added" => "Configuration file added",
// "Preference inserted or updated" => "Preference inserted or updated",
// "Menu inserted or update" => "Menu inserted or update",
// "Module inserted or update" => "Module inserted or update",
// "Theme updated" => "Theme updated",
// "Could not open file" => "Could not open file",
// "Displays the Tiki (tiki) or PHP version (php), empty to display both" => "Displays the Tiki (tiki) or PHP version (php), empty to display both",
// "Internal error: mandatory parameter field_fetch_url is missing" => "Internal error: mandatory parameter field_fetch_url is missing",
// "Internal error: mandatory parameter object_store_url is missing" => "Internal error: mandatory parameter object_store_url is missing",
// "Problem finding the associated user. %0 is not recognized. See EventNotify.php" => "Problem finding the associated user. %0 is not recognized. See EventNotify.php",
// "Event name may be empty or invalid" => "Event name may be empty or invalid",
// "Arguments are expected to be a value map" => "Arguments are expected to be a value map",
"New File" => "Neue Datei",
// "Unable to write to destination path: %0" => "Unable to write to destination path: %0",
"Cannot resize the file" => "Kann Datei nicht in der Größe anpassen",
"Cannot write the file" => "Kann Datei nicht schreiben",
"Image was reduced: %s x %s -> %s x %s" => "Bild wurde verkleinert: %s x %s -> %s x %s",
"`%0` does not match acceptable naming patterns" => "`%0` passt nicht zu den akzeptierten Namensmustern",
// "Duplicate file found as `%0`. Upload rejected" => "Duplicate file found as `%0`. Upload rejected",
// "Mail-in auto-reply" => "Mail-in auto-reply",
"Sorry, you can't use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion",
// "The functionality you are trying to access is currently disabled" => "The functionality you are trying to access is currently disabled",
// "No required action found" => "No required action found",
// "Rejected message, user globally denied" => "Rejected message, user globally denied",
// "Rejected message, associated action disabled (%0)" => "Rejected message, associated action disabled (%0)",
// "Performing action (%0)" => "Performing action (%0)",
// "Rejected message, user locally denied (%0)" => "Rejected message, user locally denied (%0)",
// "Rejected message, no associated action" => "Rejected message, no associated action",
"Submit Article" => "Artikel einreichen",
// "Unable to find suitable action" => "Unable to find suitable action",
// "Wiki Append" => "Wiki Append",
// "Wiki Get" => "Wiki Get",
// "Wiki Prepend" => "Wiki Prepend",
// "Wiki Create/Update" => "Wiki Create/Update",
// "created from mail-in" => "created from mail-in",
// "Create or update article" => "Create or update article",
// "Reply Handler" => "Reply Handler",
// "Wiki (multiple actions)" => "Wiki (multiple actions)",
// "Login failed for IMAP account on %0:%1 for user %2" => "Login failed for IMAP account on %0:%1 for user %2",
// "Login failed for POP3 account on %0:%1 for user %2" => "Login failed for POP3 account on %0:%1 for user %2",
// "= New composer.json file content" => "= New composer.json file content",
// "= Composer execution output" => "= Composer execution output",
"Errors" => "Fehler",
// "Unable to download composer installer from %0" => "Unable to download composer installer from %0",
// "Invalid composer installer signature" => "Invalid composer installer signature",
// "composer.phar installed in temp folder" => "composer.phar installed in temp folder",
// "There was a problem when installing Composer" => "There was a problem when installing Composer",
// "Tiki root directory is not writable, so file \"%0\" can not be created" => "Tiki root directory is not writable, so file \"%0\" can not be created",
// "Tiki root directory is not writable, so directory \"%0\" can not be created" => "Tiki root directory is not writable, so directory \"%0\" can not be created",
// "Tiki can not write to file \"%0\"" => "Tiki can not write to file \"%0\"",
// "Tiki can not write to directory \"%0\"" => "Tiki can not write to directory \"%0\"",
// "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping.." => "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping..",
// "Warning: Profile %0 already installed. Skipping.." => "Warning: Profile %0 already installed. Skipping..",
// "Profile %0 applied" => "Profile %0 applied",
// "Warning: Profile %0 is not installed. Skipping.." => "Warning: Profile %0 is not installed. Skipping..",
// "Profile %0 removed" => "Profile %0 removed",
// "%0 library not found. This may be due to a typo or caused by a recent update" => "%0 library not found. This may be due to a typo or caused by a recent update",
// "Package %0 is not a Tiki Extension" => "Package %0 is not a Tiki Extension",
// "Package %0 is already enabled" => "Package %0 is already enabled",
// "Package %0 is not enabled" => "Package %0 is not enabled",
"Calendar does not exist" => "Kalender existiert nicht",
"Calendar already exists" => "Kalender existiert bereits",
"File gallery does not exist" => "Dateiarchiv existiert nicht",
"File gallery already exists" => "Dateiarchiv existiert bereits",
// "Untitled - From Profile Import" => "Untitled - From Profile Import",
// "Field \"%0\" in Tracker %1 has no value for itemId %2" => "Field \"%0\" in Tracker %1 has no value for itemId %2",
"Created by profile installer" => "Erstellt durch die Profilinstallation",
"Page updated by profile installer" => "Seite durch Profilinstallation aktualisiert",
// "Tiki (%0) is not satisfiable by profile required Tiki version (%1)" => "Tiki (%0) is not satisfiable by profile required Tiki version (%1)",
"Nothing was changed. Please check the profile for errors" => "Es wurde nichts geändert. Bitte prüfe die Profile auf Fehler",
"Applying profile" => "Profil anwenden",
"Added (or modified)" => "Hinzugefügt (oder verändert)",
"Group changed (or modified)" => "Gruppe ge- oder verändert",
// "Installer reverted" => "Installer reverted",
// "Installer removed" => "Installer removed",
// "Group removed" => "Group removed",
// "Group modified" => "Group modified",
// "Permission removed" => "Permission removed",
// "Permission assign" => "Permission assign",
"Preference set" => "Einstellung festgelegt",
// "<error>Package %0:  No folder was found. Did you forgot to install?</error>" => "<error>Package %0:  No folder was found. Did you forgot to install?</error>",
// "Package set" => "Package set",
"Modified permission %s for %s" => "Veränderte Berechtigung %s für %s",
"Modified permission %s on %s/%s for %s" => "Veränderte Berechtigung %s auf %s/%s für %s",
"User %0 was added to %1" => "Benutzer %0 wurde %1 hinzugefügt",
"No name" => "kein Name",
"Bad object" => "ungültiges Objekt",
// "Could not parse YAML in profile: \"%0\"" => "Could not parse YAML in profile: \"%0\"",
// "Profile Path cannot be found" => "Profile Path cannot be found",
"Syntax error: " => "Syntaxfehler: ",
"Circular reference" => "Zirkelschluss",
"Permissions' object must have a field 'type' and 'id'" => "Berechtigungsobjekt muss ein Feld 'type' und eines 'id' haben",
"Needs a 'type' and 'data' field" => "Benötigt ein 'type' und 'data'-Feld",
// "Source: %0:%1 (%2)" => "Source: %0:%1 (%2)",
// "Recommendation: %0:%1 (%2)" => "Recommendation: %0:%1 (%2)",
// "The directory with path: ' . \$path_or_id . ' could not be found" => "The directory with path: ' . \$path_or_id . ' could not be found",
// "The file with path: ' . \$path_or_id . ' could not be found" => "The file with path: ' . \$path_or_id . ' could not be found",
// "The wiki page with name: ' . \$name . ' could not be found" => "The wiki page with name: ' . \$name . ' could not be found",
// "Theme already installed" => "Theme already installed",
// "Version %0 is no longer supported" => "Version %0 is no longer supported",
"A minor upgrade to %0 is strongly recommended" => "%0 benötigt einen unwesentlichen (minor) Upgrade",
"A major upgrade to %0 is strongly recommended" => "%0 benötigt einen wesentlichen (major) Upgrade ",
// "Version %0 is still supported. However, an upgrade to %1 is available" => "Version %0 is still supported. However, an upgrade to %1 is available",
// "Version %0 is still supported. However, a major upgrade to %1 is available" => "Version %0 is still supported. However, a major upgrade to %1 is available",
// "Replace spaces with dashes" => "Replace spaces with dashes",
// "Replace spaces with underscores" => "Replace spaces with underscores",
// "URL Encode (Tiki Classic)" => "URL Encode (Tiki Classic)",
// "Duplicate entry found (%0)" => "Duplicate entry found (%0)",
// "Filter error: \"%0\"" => "Filter error: \"%0\"",
"Action" => "Aktion",
"Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site" => "Erstelle ein Formular, welches irgendwo eingesetzt wird - nicht zwingend bei Trackern oder überhaupt in der Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Eintrag",
// "The protocol to use in the form: either get or post" => "The protocol to use in the form: either get or post",
"Script" => "Skript",
// "The URL of the destination of the form" => "The URL of the destination of the form",
"Parameters" => "Parameter",
// "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form" => "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form",
// "Attach articles to the tracker item" => "Attach articles to the tracker item",
"Topic" => "Thema",
// "Default article topic" => "Default article topic",
"Article Type" => "Artikel-Typ",
// "Default article type" => "Default article type",
"Auto-Increment" => "Automatisches Hochzählen",
"Enable an incrementing value field, or itemId field" => "Erlaubt ein im Wert zunehmendes Feld oder ein itemId-Feld",
"Start" => "Start",
"The starting value for the field" => "Der Startwert des Feldes",
"Prepend" => "Voranstellen",
"Text that will be displayed before the field" => "Text, der vor dem Feld angezeigt wird",
"Append" => "Anhängen",
"Text that will be displayed after the field" => "Text, der nach dem Feld angezeigt wird",
"If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "Wird \"itemId\" eingetragen, dann wird das Feld so eingestellt, dass es mit dem aktuellen Datenbank itemID-Feld-Wert übereinstimmt",
// "Update Empty" => "Update Empty",
"No" => "Nein",
"Yes" => "Ja",
// "Note: %0 auto-increment item values updated" => "Note: %0 auto-increment item values updated",
// "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********" => "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********",
// "Date and Time (Calendar Item)" => "Date and Time (Calendar Item)",
// "Associate calendar items with tracker items" => "Associate calendar items with tracker items",
// "Experimental: (work in progress, use with care)" => "Experimental: (work in progress, use with care)",
// "Calendar Id" => "Calendar Id",
// "Calendar to use for associated events" => "Calendar to use for associated events",
// "Show Event Id" => "Show Event Id",
// "Show an input for the event id when editing the field, allow lost events to be reattached" => "Show an input for the event id when editing the field, allow lost events to be reattached",
// "Calendar Item %0 not found" => "Calendar Item %0 not found",
// "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2" => "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2",
"Category" => "Kategorie",
"Enable the tracker item to be categorized in one or more categories under the specified main category" => "Erlaubt es für eine oder mehrere Kategorien unterhalb der angegebene Hauptkategorie den Trackereintrag zu beeinflussen",
"Parent Category" => "Übergeordnete Kategorie",
"Child categories will be provided as options for the field" => "Untergeordnete Kategorien werden als Optionen für das Feld angeboten",
"Input Type" => "Eingabetyp",
"User interface control to be used" => "Zu benutzende Interface-Steuerung",
"Dropdown" => "Auswahlliste (drop down)",
"Radio buttons" => "Optionsschaltfläche",
"List box" => "Listenbox",
"Multiple-selection checkboxes" => "Kontrollkästchen für multiple Auswahl",
"Select All" => "Alle auswählen",
"Includes a control to select all available options for multi-selection controls" => "Ermöglicht Wahl aller multiplen Auswahl-Steuerungen",
"No controls" => "Keine Steuerung",
"Include controls" => "Steuerung einbinden",
"All descendants" => "Alle nachfolgenden",
"Display all descendants instead of only first-level descendants" => "Zeige alle nachfolgenden oder nur die der ersten Ebene",
"First level only" => "Nur erste Ebene",
// "All descendants and display full path" => "All descendants and display full path",
"Displays the field description in a help tooltip" => "Zeigt die Feldbeschreibung in einem Tooltip als Hilfe",
"No help" => "Keine Hilfe",
"Tooltip" => "Tooltip",
// "Output Type" => "Output Type",
// "Plain list with items separated by line breaks (default)" => "Plain list with items separated by line breaks (default)",
// "Links separated by line breaks" => "Links separated by line breaks",
// "Unordered list of labels" => "Unordered list of labels",
// "Unordered list of links" => "Unordered list of links",
// "Do not Inherit Categories" => "Do not Inherit Categories",
// "Inherit (default)" => "Inherit (default)",
// "Do not inherit" => "Do not inherit",
// "Recategorization event" => "Recategorization event",
// "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving" => "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving",
// "Indexing" => "Indexing",
// "-Blank (no data)-" => "-Blank (no data)-",
// "%0 (any of)" => "%0 (any of)",
// "%0 (all of)" => "%0 (all of)",
// "Tracker items will inherit their tracker's categories unless this option is set" => "Tracker items will inherit their tracker's categories unless this option is set",
"Checkbox" => "Kontrollkästchen",
"Provide a checkbox field for yes/no, on/off input" => "Stellt ein Kontrollkästchenfeld zur Auswahl von ja/nein oder an/aus-Eingaben zur Verfügung",
"Computed Field" => "Berechnendes Feld",
"Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type" => "Erstellt einen berechneten Wert, basierend auf numerischen Feldwerten. Du solltest erwägen hierfür einen Webdienst oder Javaskript zu benutzen (anstelle dieses Typs)",
"This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field" => "Diese Funktion ist noch in Benutzung um rückwärtige Kompatibilität sicherzustellen. Auch wenn hiermit keine Fehler verbunden sind, kann es als Überträger für Attacken benutzten werden, die hohen Schaden verursachen. Ein Webdienst-Feld oder benutzerdefinierter Javaskript ist anstelle dieses Feldes empfohlen",
"Formula" => "Formel",
"The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "Die zu berechnende Formel mit verschiedenen Operatoren (+ - * / und Klammern). Verweise auf andere Felder werden mit der Feld-ID und einem vorangestellten # erstellt",
"Decimal Places" => "Dezimalstellen",
"Number of decimal places to round to" => "Anzahl der Dezimalstellen, die vor dem Runden geschützt werden",
"Decimal separator when displaying data" => "Dezimaltrennzeichen für die Anzeige von Daten",
"Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details" => "Einzelner Buchstabe. Benutze c für Komma, d für Punkt oder s für Leerzeichen. Das gültige Dezimaltrennzeichen bei der Eingabe von Zahlen kann von der Spracheneinstellung der Site oder des Browsers abhängen. Weitere Details enthält die Dokumentation",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
"Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed" => "Einzelnes Zeichen. Benutze c für Komma, d für Punkt oder s für Leerzeichen. Wenn Daten eingegeben werden, wird ein Trennzeichen nicht benötigt",
"Country Selector" => "Länderauswahl",
"Enable a selection from a specified list of countries" => "Erlaubt die Auswahl aus einer Länderliste",
"Display" => "Anzeigen",
"Specify the rendering type for the field" => "Legt den Listentyp für das Feld fest",
"Name and flag" => "Name und Flagge",
"Name only" => "Nur Name",
"Flag only" => "Nur Flagge",
"Sort order" => "Sortierreihenfolge",
"Determines whether the ordering should be based on the translated name or the English name" => "Legt fest, ob die Sortierung anhand des übersetzten Namens oder des englischen Namens vorgenommen werden soll",
"Translated name" => "Übersetzter Name",
"English name" => "Englischer Name",
"Currency Field" => "Währungsfeld",
"Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric" => "Stellt ein einzeiliges Feld zur Eingabe von numerischen Werten zur Verfügung. Vorangestellte oder angehängte Werte können alphanumerisch sein",
"Same Row" => "Gleiche Zeile",
"Displays the next field on the same line" => "Zeigt das nächste Feld in der gleichen Zeile",
"Display Size" => "Anzeigegröße",
"Visible size of the field, in characters. Does not affect the numeric length" => "Sichtbare Größe des Feldes in Zeichen. Betrifft nicht die numerische Länge",
"Text to be displayed in front of the currency amount" => "Text, der vor dem Währungsbetrag angezeigt wird",
"Text to be displayed after the numeric value" => "Text, der nach dem nummerischen Wert angezeigt wird",
"Locale" => "Ort",
"Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Trage Lokalisierung für Währungsformatierung ein, z.B. en_US oder en_US.UTF-8 oder en_US.ISO-8559-1. Standardwert ist en_US",
"Currency" => "Währung",
"A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "Ein benutzerdefinierter Währungscode. Nicht erforderlich wenn Lokalisierung eingestellt ist und ein Standardcode gewünscht ist. Standardwert ist USD",
"Symbol" => "Symbol",
"Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Lege fest, ob der Währungscode (z.B. USD) oder das Währungssymbol (z.B. \$) angezeigt wird. Standardmäßig wird das Symbol angezeigt",
"Currency code" => "Währungscode",
"Currency symbol" => "Währungssymbol",
"First or all" => "Erster oder alle",
"Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Lege fest, ob der Währungscode oder das -symbol bei allen Beträgen oder nur dem ersten Betrag erscheint",
"First item only" => "Nur erster Eintrag",
"All" => "Alle",
// "Currency Tracker" => "Currency Tracker",
// "Tracker containing available currencies and exchange rates" => "Tracker containing available currencies and exchange rates",
"Date and Time" => "Datum und Zeit",
"Provide drop-down options to accurately select a date and/or time" => "Stellt Auswahl für genaue Datums- und/oder Zeitwahl zur Verfügung",
"Components to be included" => "Einzuschließende Komponenten",
"Date only" => "Nur Datum",
"Start year" => "Startjahr",
"Year to allow selecting from" => "Jahr ab dem die Auswahl möglich sein soll",
"End year" => "Endjahr",
"Year to allow selecting to" => "Jahr bis zu dem die Auswahl möglich sein soll",
"Default selection" => "Standardauswahl",
"Indicates if blank dates should be allowed" => "Legt fest, ob leere Datumsangaben zulässig sein sollen",
"Current Date" => "Aktuelles Datum",
"Blank" => "Neue Seite",
// "Time Ago" => "Time Ago",
// "Use timeago.js if the feature is enabled" => "Use timeago.js if the feature is enabled",
// "Item Date Field" => "Item Date Field",
// "Use this date as the item's global date in the search index" => "Use this date as the item's global date in the search index",
"Allow users to select only from a specified set of options" => "Beschränkt die Auswahlmöglichkeiten eines Users auf eine bestimmte Auswahl der Optionen",
"Option" => "Option",
"If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label" => "Eine Option. Wenn ein Gleichheitszeichen vorhanden, wird der erste Teil als der Wert und der zweite Teil als Bezeichnung verwendet",
"Dropdown selector with \"Other\" field" => "Auswahl mit einem anderen Feld",
"Allow users to select from a specified set of options or to enter an alternate option" => "Erlaubt es Benutzern eine Auswahl aus vorgegeben Optionen zu treffen oder eine alternative Option einzugeben",
// "To change the label of the \"Other\" option, use \"other=Label\"" => "To change the label of the \"Other\" option, use \"other=Label\"",
"Radio Buttons" => "Optionsschaltfläche (radio buttons)",
"Multiselect" => "Multiple Auswahl",
"Allow a user to select multiple values from a specified set of options" => "Erlaubt es einem Benutzer multiple Werte aus einem Satz von Optionen zu wählen",
"Dynamic Items List" => "Dynamische Objektliste",
"Dynamically update a selection list based on linked data from another tracker" => "Aktualisiert eine Auswahlliste dynamisch, basierend auf verknüpften Daten eines anderen Trackers",
"Tracker ID" => "Tracker-Id",
"Tracker to link with" => "Tracker zu dem verlinkt werden soll",
"Field ID (Other tracker)" => "Feld-ID (anderer Tracker)",
"Field ID to link with in the other tracker" => "Feld-ID auf die im anderen Tracker verlinkt werden soll",
"Field ID (This tracker)" => "Feld-ID (dieser Tracker)",
"Field ID to link with in the current tracker" => "Feld-ID auf die in diesem Tracker verlinkt werden soll",
"Listed Field" => "Aufgelistetes Feld",
"Field ID to be displayed in the dropdown list" => "Feld-ID, die in der Auswahlliste angezeigt werden soll",
"Status Filter" => "Status Filter",
"Restrict listed items to specific statuses" => "Beschränke aufzulistende Einträge nach derem Status",
"all" => "alle",
"open" => "offen",
"pending" => "anstehend",
"closed" => "geschlossen",
"open, pending" => "offen, anstehend",
"pending, closed" => "anstehend, geschlossen",
// "Hide blank" => "Hide blank",
// "Hide first blank option, thus preselecting the first available option" => "Hide first blank option, thus preselecting the first available option",
"Select multiple values" => "Wähle multiple Werte",
"Allow the user to select multiple values" => "Erlaube dem Benutzer, multiple Werte auszuwählen",
// "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***" => "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***",
"*** ERROR: Field %0 not found ***" => "*** FEHLER: Datei %0 nicht gefunden ***",
// "*** ERROR: No remote tracker selected for DynamicList Field %0 ***" => "*** ERROR: No remote tracker selected for DynamicList Field %0 ***",
// "DynamicList field: Field \"%0\" not found" => "DynamicList field: Field \"%0\" not found",
"Email" => "E-Mail",
"Enable an email address to be input with the option of making it active" => "Erlaubt die Eingabe einer E-Mailadresse mit der Option, sie zu aktivieren",
"Link Type" => "Link-Typ",
"How the email address will be rendered" => "Wie die E-Mailadresse behandelt wird",
"Plain text" => "Nur Text",
"Encoded mailto link" => "Kodierter mailto-Link",
"Simple mailto link" => "Einfacher mailto-Link",
"Watch Open" => "Beobachte 'offen'",
"Notify this address every time the status changes to open" => "Benachrichtige diese Adresse jedes Mal, wenn sich der Status auf offen ändert",
"Watch Pending" => "Beobachte 'anstehend'",
"Notify this address every time the status changes to pending" => "Benachrichtige diese Adresse jedes Mal, wenn sich der Status auf anstehend ändert",
"Watch Closed" => "Beobachte 'geschlossen'",
"Notify this address every time the status changes to closed" => "Benachrichtige diese Adresse jedes Mal, wenn sich der Status auf geschlossen ändert",
"Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Fehler in Tracker-Feld-Fabrik: Einstellung \"%0\" ist für den Feldtyp \"%1\" erforderlich",
"Attachment" => "Anhang",
// "Deprecated in favor of the Files field" => "Deprecated in favor of the Files field",
"List View" => "Listenansicht",
"Defines how attachments will be displayed within the field" => "Legt fest, wie Anhänge innerhalb eines Feldes angezeigt werden",
"name" => "Name",
"type" => "Typ",
"name, size" => "Name, Größe",
"name, type, size" => "Name, Typ, Größe",
"uploader" => "hochgeladen von",
"mediaplayer" => "Mediaplayer",
"Download" => "Herunterladen",
"Attached and upload files stored in the file galleries to the tracker item" => "Angehängte und hochzuladende Dateien, gespeichert in den Dateiarchiven zum Trackereintrag",
"Gallery ID" => "Archiv ID",
"File gallery to upload new files into" => "Dateiarchiv in welches neue Datei hochgeladen werden",
"MIME Type Filter" => "MIME-Typ-Filter",
"Mask for accepted MIME types in the field" => "Maske für gültige MIME-Typen in dem Feld",
"File Count" => "Dateizähler",
"Maximum number of files to be attached on the field" => "Maximale Anzahl von Dateien, die an das Feld angehängt werden können",
"Display Mode" => "Anzeigemodus",
// "Show files as object links or via a wiki plugin (img so far)" => "Show files as object links or via a wiki plugin (img so far)",
"Links" => "Links",
// "Bare Links" => "Bare Links",
"Table" => "Tabelle",
"Images" => "Bilder",
"Vimeo" => "Vimeo",
// "Google Viewer" => "Google Viewer",
// "Moodle Scorm Viewer" => "Moodle Scorm Viewer",
// "Display parameters" => "Display parameters",
"URL-encoded parameters used such as in the {img} plugin, for example,." => "URL-kodierte Parameter so wie sie im {img}-Plugin verwendet werden. Z.B.",
// "Display parameters for lists" => "Display parameters for lists",
// "Display Order" => "Display Order",
// "Sort order for the files" => "Sort order for the files",
// "Default (order added to tracker item)" => "Default (order added to tracker item)",
// "Name (A - Z)" => "Name (A - Z)",
// "Name (Z - A)" => "Name (Z - A)",
// "Filename (A - Z)" => "Filename (A - Z)",
// "Filename (Z - A)" => "Filename (Z - A)",
// "Created date (old - new)" => "Created date (old - new)",
// "Created date (new - old)" => "Created date (new - old)",
// "Last modified date (old - new)" => "Last modified date (old - new)",
// "Last modified date (new - old)" => "Last modified date (new - old)",
// "File size (small - large)" => "File size (small - large)",
// "File size (large - small)" => "File size (large - small)",
// "Hits (low - high)" => "Hits (low - high)",
// "Hits (high - low)" => "Hits (high - low)",
"Include Child Galleries" => "Untergeordnete Archive mit einbeziehen",
"Use files from child galleries as well" => "Benutzt ebenfalls Dateien von untergeordneten Dateiarchiven",
"Replace Existing File" => "Ersetze bestehende Datei",
"Replace the existing file, if any, instead of uploading a new one" => "Ersetze bestehende Datei (sofern vorhanden) anstelle sie neu hochzuladen",
// "Browse Gallery ID" => "Browse Gallery ID",
// "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)" => "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)",
// "Restrict permissions to view the file gallery to hide the button" => "Restrict permissions to view the file gallery to hide the button",
// "Duplicate Gallery ID" => "Duplicate Gallery ID",
// "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)" => "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)",
// "Index As Map Layer" => "Index As Map Layer",
// "Index the files in a specific format for use in map searchlayers to display trails and features" => "Index the files in a specific format for use in map searchlayers to display trails and features",
// "GeoJSON" => "GeoJSON",
// "GPX" => "GPX",
// "Upload In Modal" => "Upload In Modal",
// "Upload files in a new modal window" => "Upload files in a new modal window",
// "Maximum image width" => "Maximum image width",
// "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings",
// "Maximum image height" => "Maximum image height",
// "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings",
// "Add Descriptions" => "Add Descriptions",
// "Add descriptions on uploaded files" => "Add descriptions on uploaded files",
// "Show files as object links or via a wiki plugin (img, Vimeo)" => "Show files as object links or via a wiki plugin (img, Vimeo)",
// "Files field: Gallery #%0 not found" => "Files field: Gallery #%0 not found",
// "Token access needs to be enabled for Google viewer to be used" => "Token access needs to be enabled for Google viewer to be used",
// "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")" => "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")",
"Problem with uploaded file: \"%0\"" => "Problem mit der hochgeladenen Datei: \"%0\"",
"No gallery for uploaded file, galleryId=%0" => "Kein Dateiarchiv für die hochgeladene Datei (galleryId=%0)",
"You don't have permission to upload a file to gallery \"%0\"" => "Keine Berechtigungen um eine Datei in das Dateiarchiv \"%0\" hochzuladen",
"Allow tags to be shown or added for tracker items" => "Erlaubt Anzeige von Tags bzw. Hinzufügung zu Trackereinträgen",
"Visible size of the input field" => "Sichtbare Größe des Eingabefeldes",
"Hide or show the input help" => "Zeige oder verstecke die Eingabehilfe",
"Show" => "Zeigen",
"Hide" => "Verbergen",
"Suggest" => "Vorschlag",
"Hide or show the tag suggestions" => "Zeige oder verstecke Vorschläge für Tags",
"Geographic Feature" => "Geografische Merkmale",
// "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved" => "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved",
"Feature cannot be set or modified through this interface" => "Funktion kann durch dieses Interface nicht eingestellt oder verändert werden",
"Feature cannot be viewed" => "Funktion kann nicht angesehen werden",
"Group Selector" => "Gruppenauswahl",
"Allow a selection from a specified list of user groups" => "Erlaubt die Auswahl aus einer angegebenen Liste von Benutzergruppen",
"Auto-Assign" => "Automatisch zuweisen",
"Determines if any group should be automatically assigned to the field" => "Legt fest, ob alle Gruppen automatisch zu diesem Feld zugewiesen werden soll",
"Modifier" => "Bearbeiter",
"Group Filter" => "Gruppenfilter",
"Limit listed groups to those including the specified group" => "Beschränkt die aufgelisteten Gruppen auf diejenigen, die die angegebene Gruppe enthalten",
"User Groups" => "Benutzergruppen",
// "Show groups user belongs to instead of the ones user has permission to see" => "Show groups user belongs to instead of the ones user has permission to see",
"Assign to the group" => "Zu einer Gruppe zuweisen",
"For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated" => "Bei nicht automatisch zuweisendem Feld wird der Benutzer (Benutzerauswahl, wenn vorhanden, oder Benutzer) zu der Gruppe zugewiesen und die Gruppe wird seine Standardgruppe. Bei der Gruppe muss die Benutzerwahl-Einstellung aktiviert sein",
"Assign" => "Zuweisen",
// "Unassign from previous selection" => "Unassign from previous selection",
// "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated" => "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated",
"Unassign" => "Zuordnung aufheben",
"Email Notification" => "E-Mailbenachrichtigung",
// "Add selected group to group monitor the item. Group watches feature must be enabled" => "Add selected group to group monitor the item. Group watches feature must be enabled",
"Header" => "Kopf/Überschrift",
"Display a heading between fields to delimit a section and allow visual folding of the fields" => "Zeigte eine Überschrift zwischen den Feldern um einen Abschnitt zu begrenzen und um Felder zusammenzulegen",
"Heading Level" => "Überschriftsebene",
"Level of the heading to use for complex tracker structures needing multiple heading levels" => "Überschriftsebene (für komplexe Trackerstrukturen werden multiple Überschriftsebenen benötigt)",
// "Section Toggle" => "Section Toggle",
"Default State" => "Standard-Status",
// "No toggle" => "No toggle",
"Open" => "Offen",
"Closed" => "Geschlossen",
"Icon" => "Symbol",
"Provide the ability to select an image as an icon attached to the tracker item from the file galleries" => "Erlaubt es ein Bild aus den Dateiarchiven als angehängtes Symbol für einen Trackereintrag auszuwählen",
"Default image" => "Standardbild",
"Path to the default icon used" => "Pfad zum Standardsymbol",
// "Maximum Icons" => "Maximum Icons",
// "Number of icons to display in each gallery (default 120)" => "Number of icons to display in each gallery (default 120)",
// "Update icon event" => "Update icon event",
// "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items" => "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items",
"Image" => "Bild",
"List image width" => "Bildbreite Listenansicht",
"Display size in pixels" => "Anzeigegröße in Pixel",
"List image height" => "Bildhöhe Listenansicht",
"Detail image width" => "Bildbreite Detailansicht",
"Detail image height" => "Bildhöhe Detailansicht",
"Maximum image size" => "Maximale Bildgröße",
"Maximum image width or height in pixels" => "Maximale Bildhöhe oder -breite in Pixel",
"Shadowbox" => "Shadowbox",
"Shadowbox usage on this field" => "Shadowbox-Benutzung für dieses Feld",
"Do not use" => "Nicht benutzen",
"One box per item" => "Eine Box pro Objekt",
"Use the same box for all images" => "Benutze die gleiche Box für alle Bilder",
"Missing Icon" => "Fehlend-Symbol",
"Icon to use when no images have been uploaded" => "Zu benutzendes Symbol, wenn kein Bild hochgeladen wurde",
"Invalid imagename (using filters for filenames)" => "Ungültiger Dateiname (Dateinamen werden gefiltert)",
"In Group" => "In Gruppe",
"Indicate if the user associated with the item is a member of a specified group" => "Gibt an, ob der mit diesem Eintrag verbundene Benutzer ein Mitglied eine bestimmten Gruppe ist",
"Group Name" => "Gruppenname",
"Name of the group to verify" => "Name der zu prüfenden Gruppe",
"How to display the result" => "Wie das Ergebnis angezeigt werden soll",
"Yes/No" => "Ja/Nein",
"Join date" => "Beitrittsdatum",
"Expiration date" => "Verfallsdatum",
"IP Selector" => "IP Auswahl",
"IP address input field" => "Eingabefeld IP-Adresse",
"Auto-assign" => "Automatisch zuweisen",
"Automatically assign the value on creation or edit" => "Weise automatisch die IP bei Erstellung oder beim Bearbeiten zu",
"Item Link" => "Objekt-Link",
"Link to another item, similar to a foreign key" => "Link zu einem anderen Eintrag (ähnlich einem Fremdschlüssel)",
"Tracker to link to" => "Tracker auf den verlinkt werden soll",
"Field ID" => "Feld-Id",
"Default field to display" => "Standardfeld, das angezeigt werden soll",
"How the link to the item should be rendered" => "Wie soll der Link zum Eintrag wiedergegeben werden",
"Value" => "Wert",
"Link" => "Link",
"Multiple Fields" => "Multiple Felder",
// "Display the values from multiple fields instead of a single one" => "Display the values from multiple fields instead of a single one",
// "Format for Customising Multiple Fields" => "Format for Customising Multiple Fields",
// "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"" => "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"",
// "Multiple Fields display type" => "Multiple Fields display type",
// "Display multiple fields as concatenated list in a dropdown or as a table" => "Display multiple fields as concatenated list in a dropdown or as a table",
// "Plugin TrackerList options" => "Plugin TrackerList options",
// "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)" => "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)",
"Limit the available items to a selected set" => "Beschränke die verfügbaren Einträge nach ihrem Status",
"Link Page" => "Verlinkte Seite",
"Link to a wiki page instead of directly to the item" => "Verlinke auf eine Wiki Seite anstelle direkt mit dem Eintrag",
"Add Items" => "Objekte hinzufügen",
"Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Anzuzeigender Text, wenn neue Objekte hinzugefügt werden, z.B. \"Füge Objekt ... hinzu\" (erfordert jQuery-UI)",
"Add Item Template Page" => "Füge Objekt Vorlagenseite hinzu",
"Wiki page to use as a Pretty Tracker template" => "Wiki Seite für die Vorlage für schönen Tracker",
"Preselect item based on value in this field" => "Vorausgewählter Eintrag, basierend auf dem Wert in diesem Feld",
"Preselect item based on value in specified field ID of item being edited" => "Vorausgewählter Eintrag, basierend auf dem Wert in einem angegebenen Feld (ID) eines bearbeiteten Eintrags",
"Preselect based on the value in this remote field" => "Vorausgewählter Eintrag, basierend auf einem Ziel-Feld",
"Match preselect item to this field ID in the tracker that is being linked to" => "Gleiche vorausgewähltes Eintrag mit dieser Feld-ID im Tracker ab, der verlinkt ist",
"Preselection matching method" => "Methode für Abgleich für vorausgewählten Eintrag",
"Method to use to match fields for preselection purposes" => "Zu benutzende Methode für den Feldabgleich zum Zweck der Vorauswahl",
"Exact Match" => "Exakte Übereinstimmung",
"Field here is part of field there" => "Das Feld hier ist Teil des Feldes dort",
"Match domain, used for URL fields" => "Gleiche Domäne ab. Für URL-Felder zu benutzen",
// "Cross select. Load all matching items in the remote tracker" => "Cross select. Load all matching items in the remote tracker",
// "Cross select. Load all matching items in the remote tracker plus wildcards" => "Cross select. Load all matching items in the remote tracker plus wildcards",
"One item per value" => "Ein Eintrag pro Wert",
// "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items" => "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items",
// "Displays all the items for a same label with a notation value (itemId)" => "Displays all the items for a same label with a notation value (itemId)",
// "Display only one item for each label" => "Display only one item for each label",
"Index remote fields" => "Indexiere Ziel-Felder",
"Index one or multiple fields from the master tracker along with the child, separated by |" => "Indexiere eines oder multiple Felder vom Haupt-Tracker (master) mit dem nachgeordneten Tracker (child), getrennt durch |",
// "Cascade actions" => "Cascade actions",
"Status" => "Status",
// "Categories and status" => "Categories and status",
// "Categories and delete" => "Categories and delete",
// "Delete and status" => "Delete and status",
// "ItemLink: Tracker %0 not found for field \"%1\"" => "ItemLink: Tracker %0 not found for field \"%1\"",
// "ItemLink: Field %0 not found for field \"%1\"" => "ItemLink: Field %0 not found for field \"%1\"",
// "ItemLink field \"%0\": Tracker ID #%1 not found" => "ItemLink field \"%0\": Tracker ID #%1 not found",
// "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status" => "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status",
// "Unsupported field conversion type: from %0 to %1" => "Unsupported field conversion type: from %0 to %1",
"Items List" => "Objektliste",
"Display a list of field values from another tracker that has a relation with this tracker" => "Zeigt eine Liste mit Feldwerten aus einem anderen Tracker, der eine Verbindung mit diesem Tracker hat",
"Tracker from which to list items" => "Tracker von dem Einträge aufgelistet werden sollen",
"Link Field ID" => "Link-Feld-ID",
"Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Feld-ID des anderen Tracker der den Objektlink erhält, der auf diesen Eintrag in diesem Tracker enthält oder einen anderen Wert, der übereinstimmen muss",
"Value Field ID" => "Wert-Feld-ID",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty",
"Fields to display" => "Anzuzeigende Felder",
"Display alternate fields from the other tracker instead of the item title" => "Zeige alternative Felder aus dem anderen Tracker anstelle des Objekttitels",
// "Format for customising fields to display" => "Format for customising fields to display",
// "Sort Fields" => "Sort Fields",
// "Order results by one or more fields from the other tracker" => "Order results by one or more fields from the other tracker",
"How the link to the items should be rendered" => "Wie der Link zu den Einträgen behandelt werden soll",
// "Permission denied importing into linked tracker %0" => "Permission denied importing into linked tracker %0",
// "Errors occurred importing into linked tracker %0" => "Errors occurred importing into linked tracker %0",
// "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
"Date and Time (Date Picker)" => "Datum und Zeit (Date Picker)",
"Provide a jQuery UI date picker to select a date and, optionally, a time" => "Bietet die Möglichkeit Datum und optional auch Zeit per jQuery-UI Date Picker auszuwählen",
"Default value" => "Standardwert",
"Default date and time for new items" => "Standarddatum und -Uhrzeit für neue Tracker-Einträge",
"None (undefined)" => "Keines (undefiniert)",
"Item creation date and time" => "Erstellungsdatum und -zeit",
// "Not before" => "Not before",
// "Field ID from this tracker to compare the value against and validate it is not before that timestamp" => "Field ID from this tracker to compare the value against and validate it is not before that timestamp",
// "Not after" => "Not after",
// "Field ID from this tracker to compare the value against and validate it is not after that timestamp" => "Field ID from this tracker to compare the value against and validate it is not after that timestamp",
// "Date Picker Field: \"%0\" is not a valid internal date value" => "Date Picker Field: \"%0\" is not a valid internal date value",
// "%0 cannot be before %1" => "%0 cannot be before %1",
// "%0 cannot be after %1" => "%0 cannot be after %1",
"Kaltura Video" => "Kaltura Video",
// "Display a series of attached Kaltura videos" => "Display a series of attached Kaltura videos",
// "URL-encoded parameters used in the {kaltura} plugin, for example," => "URL-encoded parameters used in the {kaltura} plugin, for example,",
"Language" => "Sprache",
"Assign a language to the tracker item to enable multilingual trackers" => "Weise dem Tracker-Eintrag eine Sprache zu, um mehrsprachige Tracker zu aktivieren",
"Indicates if the language should be assigned as the item's language" => "Gibt an, ob die Sprache als die Tracker-Eintrag-Sprache zugewiesen werden soll",
"LDAP" => "LDAP",
"Display a field value from a specific user in LDAP" => "Zeigt einen Feldwert eines bestimmten Benutzers in LDAP",
"LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP Filter. Kann %field_name% enthalten, was mit dem gegenwärtigen Feldnamen ersetzt wird",
"Field name returned by LDAP" => "Von LDAP zurückgegebener Feldname",
"DSN" => "DSN",
"Data source name registered in Tiki" => "Datenquellen-Name (DSN, data source name), der bei Tiki registriert ist",
"Location" => "Ort",
"Enable a geographic location to be selected for the item and displayed on a map" => "Erlaubt eine Geolokalisierung eines Eintrages und zeigt dies auf einer Karte",
"Use as item location" => "Benutze als Ort des Eintrags",
// "List View Width" => "List View Width",
// "Width of map in pixels when tracker items are shown in list view" => "Width of map in pixels when tracker items are shown in list view",
// "List View Height" => "List View Height",
// "Height of map in pixels when tracker items are shown in list view" => "Height of map in pixels when tracker items are shown in list view",
// "Item View Width" => "Item View Width",
// "Width of map in pixels when a single tracker item is shown" => "Width of map in pixels when a single tracker item is shown",
// "Item View Height" => "Item View Height",
// "Height of map in pixels when a single tracker item is shown" => "Height of map in pixels when a single tracker item is shown",
// "Fields To Search" => "Fields To Search",
// "Fields in this tracker to use as a source to search for a location for" => "Fields in this tracker to use as a source to search for a location for",
// "When To Search" => "When To Search",
// "Event to attempt to search for a location" => "Event to attempt to search for a location",
"Never" => "Nie",
// "Save (when Location is empty)" => "Save (when Location is empty)",
// "Save (always)" => "Save (always)",
// "Indexing (when Location is empty)" => "Indexing (when Location is empty)",
// "Indexing (always)" => "Indexing (always)",
// "Location: Field %0 not found for field \"%1\"" => "Location: Field %0 not found for field \"%1\"",
// "Could not find a location for \"%0\"" => "Could not find a location for \"%0\"",
"When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps" => "Wenn aktiviert, wird der Feldwert als anzuzeigende Geolokalisierung des Eintrages gespeichert",
// "Mathematical Calculation" => "Mathematical Calculation",
// "Perform a calculation upon saving the item based on other fields within the same item" => "Perform a calculation upon saving the item based on other fields within the same item",
// "Calculation" => "Calculation",
// "Calculation in the Rating Language" => "Calculation in the Rating Language",
// "Re-calculation event" => "Re-calculation event",
// "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed" => "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed",
// "Value will be re-calculated on save. Current value: %0" => "Value will be re-calculated on save. Current value: %0",
"Numeric Field" => "Numerisches Feld",
"Text to be displayed in front of the numeric value" => "Text, der vor dem numerischen Wert angezeigt wird",
"Thousands separator when displaying data" => "Tausendertrennzeichen für die Anzeige von Daten",
"Page Selector" => "Seitenauswahl",
"Allow a selection from the list of pages" => "Erlaubt eine Auswahl aus einer Liste von Seiten",
"Will auto-assign the creator of the item" => "Fügt automatisch den Ersteller eines Eintrages hinzu",
"Visible size of the input in characters" => "Sichtbare Größe der Eingabe in Zeichen",
"Create Page" => "Seite erstellen",
"Create missing pages using the page name in this file as the template" => "Erstelle fehlende Seiten mit dem Seitennamen in dieser Datei als Vorlage",
"Display the value as a link to the page" => "Zeige den Wert als Link zu der Seite",
"Rating" => "Bewertung",
// "A rating of the tracker item. Permissions involved: %0" => "A rating of the tracker item. Permissions involved: %0",
"The possible options (comma-separated integers) for the rating" => "Die möglichen Optionen für die Bewertung (mit Kommata getrennte ganze Zahlen)",
"Mode" => "Modus",
"Display rating options as" => "Zeige Bewertungsoptionen als",
"Stars" => "Sterne",
"Single Option: for example, Like" => "Einzelne Option: z.B. Gefällt mir",
"Labels" => "Bezeichnungen",
"The text labels (comma-separated) for the possible options" => "Die Textbezeichnungen für die möglichen Optionen (mit Kommata getrennt)",
"Stars (deprecated)" => "Sterne (veraltet)",
"Display a star rating" => "Zeigt eine Sterne-Bewertung",
"A possible option for the rating" => "Eine mögliche Option für die Bewertung",
// "Stars (system - deprecated)" => "Stars (system - deprecated)",
"Average" => "Durchschnitt",
"Number of votes:" => "Anzahl der Abstimmungen:",
"Your rating" => "Deine Bewertung",
"Relations" => "Beziehungen",
"Allow arbitrary relations to be created between the trackers and other objects in the system" => "Erlaubt es beliebige Beziehungen zwischen Trackern und anderen Objekten im System zu erstellen",
"Relation" => "Beziehung",
"Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Beziehungsqualifizierer. Muss ein dreiteiliger Kennzeichner sein, der aus mit Punkten getrennten Buchstaben besteht",
"URL-encoded list of filters to be applied on object selection" => "URL-kodierte Liste von Filtern, die auf die Objektauswahl angewendet wird",
"Format" => "Format",
// "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field" => "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field",
"Read-only" => "Nur-lesen",
"Only display the incoming relations instead of manipulating them" => "Zeige die eingehenden Beziehungen nur an ohne sie zu verändern",
"Include Invert" => "Umkehren",
"Include invert relations in the list" => "Beziehe auch Beziehungen umkehren in die Liste ein",
// "Control how the relations are displayed in view mode" => "Control how the relations are displayed in view mode",
"List" => "Liste",
"Count" => "Zähler",
// "Count with toggle for list" => "Count with toggle for list",
// "Force Refresh" => "Force Refresh",
// "Re-save related tracker items" => "Re-save related tracker items",
// "On Save" => "On Save",
// "Extra Filter Field" => "Extra Filter Field",
// "Filter objects by value of another field. Use a jQuery seletor to target the element in the page" => "Filter objects by value of another field. Use a jQuery seletor to target the element in the page",
// "Extra Filter Key" => "Extra Filter Key",
// "Key to filter objects by using the value from the Extra Filter Field above" => "Key to filter objects by using the value from the Extra Filter Field above",
// "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save" => "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save",
"and" => "und",
// "show.tiki.org" => "show.tiki.org",
// "Create, display or manage show.tiki.org instances" => "Create, display or manage show.tiki.org instances",
// "Domain name of show server" => "Domain name of show server",
// "For example, show.tikiwiki.org" => "For example, show.tikiwiki.org",
// "Supported Versions" => "Supported Versions",
// "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"" => "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"",
// "Shell username on remote server" => "Shell username on remote server",
// "The shell username on the show server" => "The shell username on the show server",
// "Public key file path" => "Public key file path",
// "System path to public key on local server. Only RSA keys are supported" => "System path to public key on local server. Only RSA keys are supported",
// "Private key file path" => "Private key file path",
// "System path to private key on local server. Only RSA keys are supported" => "System path to private key on local server. Only RSA keys are supported",
// "Show debugging information" => "Show debugging information",
// "Show debugging info during testing" => "Show debugging info during testing",
// "Fixed user ID" => "Fixed user ID",
// "Set fixed user ID instead of using the user ID of the creator of the tracker item" => "Set fixed user ID instead of using the user ID of the creator of the tracker item",
"Static Text" => "Statischer Text",
"Display the field description as static text to present notes or additional instructions" => "Zeigt einen statischen Text, der für Hinweise oder zusätzliche Anweisungen genutzt werden kann",
"Wiki Parse" => "Wiki parsen",
"Indicates if the description should be parsed as wiki syntax for formatting" => "Gibt an, ob die Beschreibung als Wiki-Syntax geparst und formatiert werden soll",
"Handle line breaks as new lines only" => "Behandele Zeilenumbrüche nur als neue Zeilen",
// "Wiki Parse with Pretty Tracker replacements" => "Wiki Parse with Pretty Tracker replacements",
"Maximum Length (List)" => "Maximale Länge (Liste)",
"Maximum number of characters to be displayed in list mode" => "Maximale Anzahl von Zeichen, die im Listenmodus angezeigt werden",
"Text Field" => "Textfeld",
"Single-line text input" => "Einzeilige Texteingabe",
// "Display the field name and input on the same row" => "Display the field name and input on the same row",
"Visible size of the field, in characters" => "Sichtbare Größe des Feldes in Zeichen",
"Text to prepend when displaying the value" => "Voranzustellender Text, wenn ein Wert angezeigt wird",
// "Text to append when displaying the value" => "Text to append when displaying the value",
"Maximum Length" => "Maximale Länge",
"Maximum amount of characters to store" => "Maximale Anzahl von Zeichen, die gespeichert werden",
"Autocomplete" => "Autovervollständigen",
"Enable autocompletion while typing in the field" => "Aktiviere beim Eintragen in das Feld die automatische Vervollständigung",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
// "Full-text search of the content of the field" => "Full-text search of the content of the field",
// "Search for a value prefix" => "Search for a value prefix",
// "Search for a precise value" => "Search for a precise value",
// "Full-text search in the current language" => "Full-text search in the current language",
// "Full-text search in a specific language (%0)" => "Full-text search in a specific language (%0)",
// "%0 (any language)" => "%0 (any language)",
// "Full-text search in any language" => "Full-text search in any language",
"Text Area" => "Textbereich",
"Multi-line text input" => "Mehrzeilige Texteingabe",
"Toolbars" => "Werkzeug Symbole",
"Enable the toolbars as syntax helpers" => "Aktiviere Symbolleiste zur Syntaxhilfe",
"Disable" => "Ausschalten",
"Enable" => "Aktivieren",
"Width" => "Breite",
"Size of the text area, in characters" => "Größe des Textbereichs in Zeichen",
"Height" => "Höhe",
"Size of the text area, in lines" => "Größe des Textbereichs in Zeilen",
"Character Limit" => "Zeichengrenze",
"Maximum number of characters to be stored" => "Maximale Anzahl von Zeichen, die gespeichert werden",
"Display Limit (List)" => "Anzeigegrenze (Liste)",
"Maximum number of characters to be displayed in list mode before the value gets truncated" => "Maximale Anzahl von anzuzeigenden Zeichen in der Listenansicht (Rest wird abgeschnitten)",
"Word Count" => "Wortzähler",
"Limit the length of the text, in number of words" => "Beschränke die Länge des Textes in Wörtern",
"Distinct Values" => "Verschiedene Werte",
"All values in the field must be different" => "Alle Werte im Feld müssen anders sein",
"Use WYSIWYG" => "Benutze WYSIWYG",
"Use a rich text editor instead of inputting plain text" => "Benutze einen Rich Text Editor (ähnlich Textverarbeitung) anstelle einer einfachen Textbox",
"Word Limit Exceeded" => "Wortgrenze überschritten",
"Character Limit Exceeded" => "Zeichengrenze überschritten",
"Create a link to a specified URL" => "Erstellt einen Link zu einer angegebene URL",
"How the URL should be rendered" => "Wie eine URL behandelt werden soll",
"URL as link" => "URL als Link",
"Site title as link" => "Site-Titel als Link",
"URL as link plus site title" => "URL als Link plus Site-Title",
// "Text as link (see Other)" => "Text as link (see Other)",
// "Label of the link text. Requires \"Display\" to be set to \"Text as link\"" => "Label of the link text. Requires \"Display\" to be set to \"Text as link\"",
"Display the list of groups for the user associated with the tracker items" => "Zeigt die Liste der Gruppen des Benutzers, der mit diesem Tracker verknüpft ist",
// "Show direct groups memberships only" => "Show direct groups memberships only",
// "Do not show inherited/included groups" => "Do not show inherited/included groups",
// "Specify Fields" => "Specify Fields",
// "Get the groups for users from these fields, not the \"owner\" user fields" => "Get the groups for users from these fields, not the \"owner\" user fields",
"User Preference" => "Benutzereinstellungen",
"Allow user preference changes from a tracker" => "Erlaubt es Benutzereinstellungen mit einem Tracker zu verändern",
"Preference Name" => "Einstellungsname",
"Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name der zu ändernden Einstellung. Passwort (password) und E-Mail (email) sind zwar keine Einstellungen aber gültige Werte, die geändert werden können",
"User Selector" => "Benutzerauswahl",
// "Allow the selection of a user or users from a list" => "Allow the selection of a user or users from a list",
"Assign the value based on the creator or modifier" => "Weist einen Wert zu, basierend darauf ob Ersteller oder Bearbeiter",
// "Item Owner" => "Item Owner",
// "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker" => "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker",
// "Send an email notification to the user(s) every time the item is modified" => "Send an email notification to the user(s) every time the item is modified",
"Only when other users modify the item" => "Nur wenn andere Benutzer dieses Objekt verändern",
// "Notification Template" => "Notification Template",
// "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)" => "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)",
// "Email Format" => "Email Format",
// "Choose between values text or html, depending on the syntax in the template file that will be used" => "Choose between values text or html, depending on the syntax in the template file that will be used",
"text" => "Text",
"html" => "html",
// "Multiple selection" => "Multiple selection",
// "Allow selection of multiple users from the list" => "Allow selection of multiple users from the list",
// "Yes (complete list)" => "Yes (complete list)",
// "Yes (filterable by group)" => "Yes (filterable by group)",
"Group IDs" => "Gruppen-IDs",
"Limit the list of users to members of specific groups" => "Beschränke die Liste der Benutzer auf die Mitglieder der angegebenen Gruppen",
// "Groups that can modify autoassigned values" => "Groups that can modify autoassigned values",
// "List of group IDs who can change this field, even without tracker_admin permission" => "List of group IDs who can change this field, even without tracker_admin permission",
// "Show real name if possible" => "Show real name if possible",
// "User \"%0\" not found" => "User \"%0\" not found",
"User Subscription" => "Benutzerabonnement",
// "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item" => "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item",
"Webservice" => "Webdienst",
"Display the result of a registered webservice call" => "Zeigt das Ergebnis eines registrierten Webdienste-Aufrufes",
"Service Name" => "Dienstname",
"Webservice name as registered in Tiki" => "Webdienst-Name, so wie in Tiki registriert",
"Template Name" => "Vorlagenname",
"Template name to use for rendering as registered with the webservice" => "Zu benutzender Vorlagenname, der mit dem Webdienst registriert ist",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name",
// "Require parameters" => "Require parameters",
// "Do not execute the request if parameters are missing or empty" => "Do not execute the request if parameters are missing or empty",
// "All required" => "All required",
// "(default)" => "(default)",
// "First only required" => "First only required",
// "No parameters required" => "No parameters required",
// "Cache time" => "Cache time",
// "Time in seconds to cache the result for before trying again" => "Time in seconds to cache the result for before trying again",
"Read only" => "Nur lesen",
// "Webservice %0 not found" => "Webservice %0 not found",
// "Webservice template %0 not found" => "Webservice template %0 not found",
// "Unknown webservice error (code: %0)" => "Unknown webservice error (code: %0)",
// "Unknown webservice error" => "Unknown webservice error",
// "Data too long for Webservice field %0 with %1" => "Data too long for Webservice field %0 with %1",
// "Error updating Webservice field %0" => "Error updating Webservice field %0",
// "Embed an associated wiki page" => "Embed an associated wiki page",
// "Field that is used for Wiki Page Name" => "Field that is used for Wiki Page Name",
// "Field to get page name to create page name with" => "Field to get page name to create page name with",
// "Namespace for Wiki Page" => "Namespace for Wiki Page",
// "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information" => "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information",
// "Default (trackerfield<fieldId>)" => "Default (trackerfield<fieldId>)",
// "No namespace" => "No namespace",
// "Custom namespace" => "Custom namespace",
// "Custom Namespace" => "Custom Namespace",
// "The custom namespace to use if the custom option is selected" => "The custom namespace to use if the custom option is selected",
// "Rename Wiki Page when changed in tracker" => "Rename Wiki Page when changed in tracker",
// "Rename associated wiki page when the field that is used for Wiki Page Name is changed" => "Rename associated wiki page when the field that is used for Wiki Page Name is changed",
// "Delete Wiki Page when tracker item is deleted" => "Delete Wiki Page when tracker item is deleted",
// "Delete associated wiki page when the tracker item is deleted" => "Delete associated wiki page when the tracker item is deleted",
// "Action Buttons" => "Action Buttons",
// "Display wiki page buttons when editing the item" => "Display wiki page buttons when editing the item",
// "Remove Bad Chars" => "Remove Bad Chars",
// "Remove bad characters from the Wiki Page name" => "Remove bad characters from the Wiki Page name",
// "The page name provided already exists. Please choose another" => "The page name provided already exists. Please choose another",
// "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1" => "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1",
// "Missing Page Name field #%0 for Wiki field #%1" => "Missing Page Name field #%0 for Wiki field #%1",
// "Page \"%0\" already exists. Not overwriting" => "Page \"%0\" already exists. Not overwriting",
// "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)" => "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)",
// "Look up a single item by ID" => "Look up a single item by ID",
"Search" => "Suche",
// "Full-text search across all of the content" => "Full-text search across all of the content",
// "Modification Date" => "Modification Date",
// "Unknown value" => "Unknown value",
// "Modified Date" => "Modified Date",
"Actions" => "Aktionen",
// "Dynamic Filters" => "Dynamic Filters",
// "From %0 to %1" => "From %0 to %1",
// "Field not found: %0" => "Field not found: %0",
// "Filter mode not found: %0 for %1" => "Filter mode not found: %0 for %1",
// "Field mode not found: %0 for %1" => "Field mode not found: %0 for %1",
// "Primary Key fields cannot be read-only" => "Primary Key fields cannot be read-only",
// "Column \"%0\" cannot co-exist with \"%1\"" => "Column \"%0\" cannot co-exist with \"%1\"",
// "Column \"%0:%1\" found multiple times" => "Column \"%0:%1\" found multiple times",
// "Primary key already defined" => "Primary key already defined",
// "Not enough columns, expecting \"%0\"" => "Not enough columns, expecting \"%0\"",
// "Header \"%0\" found where \"%1\" was expected" => "Header \"%0\" found where \"%1\" was expected",
// "Header \"%0\" found where ignored column was expected" => "Header \"%0\" found where ignored column was expected",
// "new tracker(s) item(s) created" => "new tracker(s) item(s) created",
// "tracker(s) item(s) updated" => "tracker(s) item(s) updated",
// "Line %0" => "Line %0",
// "duplicate entry" => "duplicate entry",
// "duplicate entry for unique column %0" => "duplicate entry for unique column %0",
// "Import file contains errors. Please review and fix before importing" => "Import file contains errors. Please review and fix before importing",
// "Primary Key not defined" => "Primary Key not defined",
"Create page:" => "Seite erstellen:",
"Plugin execution pending approval" => "Pluginausführung wartet auf Bestätigung",
// "Edit plugin" => "Edit plugin",
// "Wiki page pagination has not been enabled" => "Wiki page pagination has not been enabled",
// "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"" => "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"",
"Internal error" => "Interner Fehler",
"User error" => "Benutzerfehler",
"Plugin argument(s) missing" => "Pluginargument(e) fehlen",
"Plugin <strong>%0</strong> cannot be executed." => "Plugin <strong>%0</strong> kann nicht ausgeführt werden.",
"Set" => "Ok",
"Plugin disabled" => "Plugin deaktiviert",
// "Edit Plugin" => "Edit Plugin",
// "Unable to locate cryptphrase" => "Unable to locate cryptphrase",
// "Single Container" => "Single Container",
// "Classic Tiki (3 containers - header, middle, footer)" => "Classic Tiki (3 containers - header, middle, footer)",
// "Classic Bootstrap (fixed top navbar)" => "Classic Bootstrap (fixed top navbar)",
"Line:" => "Zeile:",
"Lines:" => "Zeilen:",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiUnterschied::anwenden: Zeilenzahl weicht ab: %s != %s",
"WikiDiff::_check: failed" => "WikiUnterschied::_prüfen: fehlgeschlagen",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiUnterschied::_prüfen: Bearbeitungssequenz ist nicht optimal",
"WikiDiff Okay: LCS = %s" => "WikiUnterschied Okay: LCS = %s",
// "Problem setting user for \"%0\"" => "Problem setting user for \"%0\"",
// "Problem setting group for \"%0\"" => "Problem setting group for \"%0\"",
// "Problem setting mode for \"%0\"" => "Problem setting mode for \"%0\"",
// "Upload was not successful for \"%0\"" => "Upload was not successful for \"%0\"",
// "Subgallery number to galleryId error: Too many subdirs (%0)</span>" => "Subgallery number to galleryId error: Too many subdirs (%0)</span>",
// "Subgallery number to galleryId error: Not an integer (%0)</span>" => "Subgallery number to galleryId error: Not an integer (%0)</span>",
// "Subgallery number to galleryId error: Gallery with ID %0 not found</span>" => "Subgallery number to galleryId error: Gallery with ID %0 not found</span>",
// "Created by batch upload by user \"%0\" on %1" => "Created by batch upload by user \"%0\" on %1",
// "Create gallery \"%0\" failed</span>" => "Create gallery \"%0\" failed</span>",
// "No permsission to create gallery \"%0\"</span>" => "No permsission to create gallery \"%0\"</span>",
// "Gallery \"%0\" not found</span>" => "Gallery \"%0\" not found</span>",
"Upload was successful" => "Hochladen war erfolgreich",
"File %s removed from Batch directory." => "Datei %s wurde aus dem Batchupload-Verzeichnis gelöscht.",
"Impossible to remove file %s from Batch directory." => "Konnte Datei %s nicht aus dem Batchupload-Verzeichnis löschen.",
"Invalid directory name" => "Ungültiger Verzeichnisname",
// "Move was not successful for \"%0\"" => "Move was not successful for \"%0\"",
// "Copy was not successful for \"%0\"" => "Copy was not successful for \"%0\"",
// "Move was successful" => "Move was successful",
// "Copy was successful" => "Copy was successful",
// "Cannot write to this path: " => "Cannot write to this path: ",
// "Cannot read this file: " => "Cannot read this file: ",
// "Cannot remove file from gallery" => "Cannot remove file from gallery",
// "Migrated Image Galleries" => "Migrated Image Galleries",
// "Converted from image gallery" => "Converted from image gallery",
"My Files" => "Meine Dateien",
// "Files of %0" => "Files of %0",
"Cannot open this file" => "Kann Datei nicht öffnen",
" copy" => " kopieren",
// "Processing search text from a \"%0\" file in gallery #%1" => "Processing search text from a \"%0\" file in gallery #%1",
"User File Galleries" => "Benutzer-Dateiarchive",
"Wiki Attachment File Galleries" => "Dateiarchive für Wiki Anhänge",
"File Galleries" => "Dateiarchive",
"The upload was not completed" => "Der Upload wurde nicht durchgeführt",
"Reason: The global quota has been reached" => "Grund: das globale Speicherkontingent wurde erreicht",
"Reason: The quota has been reached in \"%s\"" => "Grund: das Speicherkontingent in \"%s\" wurde erreicht",
"File gallery quota exceeded" => "Speicherkontigent für Dateiarchiv überschritten",
"Number of files transferred to the database" => "Anzahl von Dateien, die in die Datenbank übertragen wurden",
"Number of files transferred to the file system" => "Anzahl von Dateien, die in das Dateisystem übertragen wurden",
"Old File deleted" => "Alte Datei gelöscht",
"Incorrect param" => "Ungültiger Parameter",
"You do not have permission to remove files from this gallery" => "Zugriff Verweigert. Du kannst keine Dateien aus dieser Galerie entfernen",
"Warning: The file is used in" => "WARNUNG: Diese Datei wird benutzt in",
"You are trying to edit multiple files in different galleries, which is not supported yet" => "Du versuchst verschiedene Dateien in verschiedenen Dateiarchiven zu bearbeiten. Dies wird noch nicht unterstützt",
"The specified file does not exist" => "Die angegebene Datei existiert nicht",
"Upload was not successful" => "Hochladen war nicht erfolgreich",
"An exception occurred" => "Eine Ausnahme ist aufgetreten",
"Batch file processed" => "Stapeldatei verarbeitet",
"Errors detected" => "Fehler entdeckt",
"Check that these paths exist and are writable by the web server" => "Prüfe, dass diese Pfade existieren und vom Webserver geschrieben werden können",
"File added: " => "Datei hinzugefügt: ",
"Cannot read the file" => "Kann Datei nicht lesen",
"Warning: Empty file" => "Warnung: Datei leer",
"Please re-upload the file" => "Bitte lade Deine Datei erneut hoch",
"The upload was not successful due to duplicate file content" => "Hochladen war nicht erfolgreich. Doppelter Dateiinhalt",
// "Files uploaded" => "Files uploaded",
// "File \"%0\" uploaded" => "File \"%0\" uploaded",
"File update was successful" => "Datei erfolgreich aktualisiert",
"Automatic revision from source" => "Automatische Revision aus der Quelle",
// "Images successfully moved to file gallery %0" => "Images successfully moved to file gallery %0",
// "Images could not be opened or uploaded" => "Images could not be opened or uploaded",
// "No changes were made since no images in wiki_up were found in Wiki pages" => "No changes were made since no images in wiki_up were found in Wiki pages",
// "No images found" => "No images found",
// "%0 on page %1 could not be opened" => "%0 on page %1 could not be opened",
// "%0 on page %1 could not be uploaded into the file gallery" => "%0 on page %1 could not be uploaded into the file gallery",
// "%0 used on page %1 was moved and given the file ID %2" => "%0 used on page %1 was moved and given the file ID %2",
// "Forcing a filetype of image/svg+xml is blocked for security reasons" => "Forcing a filetype of image/svg+xml is blocked for security reasons",
// "SVG files are not safe and cannot be uploaded" => "SVG files are not safe and cannot be uploaded",
// "PHP Zip extension not found, reqiuired for Feature H5P" => "PHP Zip extension not found, reqiuired for Feature H5P",
// "PHP Class \"ZipArchive\" not found" => "PHP Class \"ZipArchive\" not found",
// "Missing content parameters" => "Missing content parameters",
// "Invalid content parameters" => "Invalid content parameters",
// "Missing title" => "Missing title",
// "Title is too long. Must be 256 letters or shorter" => "Title is too long. Must be 256 letters or shorter",
// "Invalid content type" => "Invalid content type",
// "Created by H5P" => "Created by H5P",
// "The chosen content type isn't installed" => "The chosen content type isn't installed",
"This is an approximation based on your server memory limit:" => "Dieser Wert basiert auf einer Schätzung des Speicherlimits Deines Servers",
"This is the value of your server's PHP '%s' setting" => "Das ist der Wert der PHP '%s' Einstellung Deines Servers",
// "Not a git repository" => "Not a git repository",
// "Branch \"%s\" not found" => "Branch \"%s\" not found",
// "Can't get Git object file" => "Can't get Git object file",
// "Goal achieved" => "Goal achieved",
// "Event Count" => "Event Count",
// "Event Count (Forever)" => "Event Count (Forever)",
// "Goal Reached (Periodic)" => "Goal Reached (Periodic)",
// "Goal Reached (Forever)" => "Goal Reached (Forever)",
// "Has Badge" => "Has Badge",
// "Add One-Time Badge" => "Add One-Time Badge",
// "%0 Badge" => "%0 Badge",
// "Remove One-Time Badge" => "Remove One-Time Badge",
// "%0 Badge (Remove)" => "%0 Badge (Remove)",
"Credits" => "Credits",
// "%0 credit(s) - %1" => "%0 credit(s) - %1",
// "Unknown credit type" => "Unknown credit type",
"You are alerted by the server " => "Du bist vom Server alarmiert ",
"You can check the modifications at: " => "Du kannst die Veränderungen prüfen unter : ",
"You are alerted of a change on " => "Du bist alarmiert von einer Änderung auf ",
// "JavaScript file \"%0\" cannot be found so will not be minified" => "JavaScript file \"%0\" cannot be found so will not be minified",
"No image yet, sorry." => "Leider noch keine Bilder vorhanden.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "Unbekanntes Zielverzeichnis. Bitte konfiguriere <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "entlinken fehlgeschlagen",
"The uploaded file exceeds the upload_max_filesize directive in php.ini" => "Die hochgeladene Datei überschreitet die upload_max_filesize Anweisung in der Datei php.ini",
"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "Die hochgeladene Datei überschreitet die MAX_FILE_SIZE Anweisung die im HTML-Formular angegeben wurde",
"The uploaded file was only partially uploaded. Please try again" => "Die hochgeladenene Datei wurde nur teilweise hochgeladen. Bitte nochmals versuchen",
"No file was uploaded" => "Es wurde keine Datei hochgeladen",
"Missing a temporary folder" => "Es fehlt ein temporärer Ordner",
"Failed to write file to disk" => "Konnte nicht auf Festplatte schreiben",
"File upload stopped by extension" => "Hochladen der Datei aufgrund der Erweiterung gestoppt",
"Set new blog as Tiki homepage" => "Wähle neuen Blog als Tiki Homepage",
"Importation completed" => "Import abgeschlossen",
"<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Klicke hier</a>, um den Import abzuschließen",
"Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Es wurden %0 Beiträge, %1 Seiten, %2 Tags und %3 Kategorien gefunden. Sie werden in Tiki hinzugefügt",
"Item \"%0\" NOT imported (there was already a item with the same name)" => "Objekt \"%0\" NICHT importiert (es existiert bereits ein Objekt mit dem gleichen Namen)",
"Page \"%0\" sucessfully imported" => "Seite \"%0\" erfolgreich importiert",
"Post \"%0\" sucessfully imported" => "Beitrag \"%0\" erfolgreich importiert",
"Import images and other attachments" => "Importiere Bilder und andere Anhänge",
"Update internal links (experimental)" => "Aktualisiere interne Links (experimentell)",
"Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)" => "Schlage .htaccess-Regel vor, um alte WP-URLs zu neuen Tiki-URLs weiterzuleiten (experimentell)",
"Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Die Klasse DOMDocument ist nicht verfügbar. Prüfe Deine PHP-Installation. Für weitere Informationen siehe http://php.net/manual/en/book.dom.php",
"Invalid file MIME type" => "Ungültiger Datei MIME-Typ",
"There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Fehler beim Laden der XML Datei. Möglicherweise ist Deine XML Datei nicht richtig formatiert. Einige Versionen von Wordpress erstellen fehlerhafte XML Dateien. Siehe hierzu die Tiki Importer Dokumentation für weitere Informationen",
"Invalid WordPress XML file" => "Ungültige Wordpress XML Datei",
"No attachments found to import" => "Keine Anhänge zum Importieren gefunden",
"Importing attachments" => "Importiere Anhänge",
"Attachment %0 successfully imported" => "Anhang %0 erfolgreich importiert",
"Unable to download attachment %0. Error message was: %1 %2" => "Kann Anhang %0 nicht herunterladen. Die Fehlermeldung lautet: %1 %2",
"%0 attachments imported and %1 errors" => "%0 Anhänge importiert und %1 Fehler",
"Page \"%0\" successfully extracted" => "Seite \"%0\" erfolgreich extrahiert",
"Post \"%0\" successfully extracted" => "Post \"%0\" erfolgreich extrahiert",
"Extracting data from XML file" => "Extrahiere Daten aus der XML Datei",
"Number of page revisions to import (0 for all revisions):" => "Anzahl der Seitenrevisionen, die importiert werden sollen (0 für alle Revisionen):",
"What to do with page names that already exists in Tiki" => "Was soll mit Wikiseitennamen geschehen, die bereits in der Tiki existieren",
"Do not import" => "Nicht importieren",
"Override" => "überschreiben",
"Prepend software name as a prefix to the page name" => "Hänge den Softwarenamen als Präfix an den Seitennamen an",
"Page %0 sucessfully imported" => "Seite %0 erfolgreich importiert",
"Page %0 NOT imported (there was already a page with the same name)" => "Seite %0 NICHT importiert (es existiert bereits eine Seite mit dem gleichen Namen)",
"%0 pages parsed. Starting to insert those pages into Tiki" => "%0 Seiten geparst. Beginne damit, die Seiten in Tiki einzufügen",
"Import images and attachments (see documentation for more information)" => "Importiere Bilder und Anhänge (siehe Dokumentation für weitere Informationen)",
"Add a maketoc at the top of each page" => "Füge ein maketoc (Inhaltsverzeichnis) am oberen Seitenrand jeder Seite ein",
"The XML file does not validate against the MediaWiki XML schema" => "XML Datei entspricht nicht dem Mediawiki XML Schema",
"Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments" => "ABBRUCH: Zielverzeichnis für Anhänge (%0) existiert nicht. Behebe das Problem oder fahre ohne den Import der Anhänge fort",
"Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments" => "ABBRUCH: Zielverzeichnis für Anhänge (%0) ist nicht beschreibbar. Behebe das Problem oder fahre ohne den Import der Anhänge fort",
"File %0 is not being imported because there is already a file with the same name in the destination directory (%1)" => "Datei %0 wird NICHT importiert, weil es bereits eine Datei mit diesem Namen im Zielverzeichnis (%1) gibt",
"File %0 successfully imported" => "Datei %0 erfolgreich importiert",
"Unable to download file %0. File not found" => "Kann Datei %0 nicht herunterladen. Datei nicht gefunden",
"Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer" => "Fehler beim Parsen der Revision %0 der Seite \"%1\". Entweder existiert ein Problem mit dem Seitensyntax oder mit dem Text_Wiki-Parser (dem Parser der vom Importer benutzt wird)",
"Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Seite \"%0\" erfolgreich mit %1 Revisionen geparsed (total %2 Revisionen)",
"Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Seite %0 wird NICHT importiert. Es war nicht möglich irgendeine der Seitenrevisionen zu parsen",
"MediaWiki XML file version %0 is not supported" => "Mediawiki XML-Dateiversion %0 wird nicht unterstützt",
"Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "ABBRUCH: Du musst die PHP Einstellung 'allow_url_fopen' aktivieren, um Anhänge zu importieren. Behebe das Problem oder versuche den Import ohne Anhänge",
"Parsing pages" => "Seiten parsen",
"No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments" => "Kein Anhang zum importieren gefunden! Stelle sicher, dass Du Deine XML-Datei mit dem dumpDump.php-Skript mit der Option --uploads erstellt hast. Das ist die einzige Möglichkeit, Anhänge zu importieren",
// "Invalid template name: %0" => "Invalid template name: %0",
// "Unnamed file" => "Unnamed file",
"string" => "String",
"Unknown language" => "unbekannte Sprache",
"Error: unable to write to lang/%s/language.php" => "FEHLER: nicht in der Lage die Datei lang/%s/language.php zu schreiben",
"The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again" => "Die Datei lang/%0/language.php ist nicht korrekt formatiert. Starte das Skript get_strings.php?lang=%0 und versuche nochmals die Sprachen zu exportieren",
"Contributions" => "Beiträge",
// "reverted" => "reverted",
"section level 0" => "Abschnittsebene 0",
"sorted section level 0" => "Sortierte Abschnittsebene 0",
"section level 1" => "Abschnittsebene 1",
"section level 2" => "Abschnittsebene 2",
"section level 3" => "Abschnittsebene 3",
"option" => "Option",
"separator" => "Trennlinie",
"You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu" => "Du kannst optionId = 0 nur benutzen, um eine neue Option zu erstellen oder optionId mit einer im Menü bestehenden ID benutzen, um diese zu aktualisieren",
"menu" => "Menü",
"NONE" => "KEINES",
"(values not interpreted)" => "(Werte nicht intepretiert)",
"Unknown Field: " => "Unbekanntes Feld:",
// "duplicate fields do not match" => "duplicate fields do not match",
"Description not available" => "Beschreibung nicht verfügbar",
"Module Title" => "Modultitel",
"Title to display at the top of the box." => "Titel der am oberen Rand der Modulbox angezeigt wird.",
"No Box" => "Keine Box",
"Show only the content" => "Zeige nur den Inhalt an",
"Title, background, etcs" => "Dekorationen",
"Show module decorations" => "Zeige Moduldekorationen",
"No Title" => "Keinen Title",
// "Hide module title" => "Hide module title",
"Module displayed depending on category. Separate multiple category IDs or names by semi-colons" => "In Abhängigkeit von Kategorien angezeigtes Modul. Multiple Kategorie-IDs oder -namen können durch Semikolon getrennt werden",
"No Category" => "Keine Kategorie",
"Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above" => "In Abhängigkeit von Kategorien verstecktes Modul. Multiple Kategorie-IDs oder -namen können durch Semikolon getrennt werden. Diese Einstellung ist vor der vorherigen vorrangig",
// "Category subtrees" => "Category subtrees",
// "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)" => "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)",
"Perspective" => "Perspektive",
"Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons." => "Zeige das Modul nur innerhalb einer der angegebenen Perspektiven-IDs. Verschiedene IDs werden durch Semikolon getrennt.",
"Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons." => "Das Modul nur innerhalb einer spezifischen Sprache verfügbar machen. Sprachen werden über den Sprachcode (zwei Zeichen) ausgewählt. Verschiedene Werte werden durch Semikolon getrennt.",
"Section" => "Bereich",
// "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page" => "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page",
"Page Filter" => "Seitenfilter",
"Module is displayed only on the specified page(s). Separate multiple page names by semi-colons." => "Modul steht nur auf bestimmten Seiten zur Verfügung. Verschiedene Seitennamen werden durch Semikolon getrennt.",
"No Page" => "Seitenausschluss",
"Module is not displayed on the specified page(s). Separate multiple page names by semi-colons." => "Modul steht auf den angegebenen Seiten nicht zur Verfügung. Verschiedene Seitennamen werden durch Semikolon getrennt.",
"Theme" => "Theme",
"Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons" => "Aktivierte/deaktiverte Module, abhängig vom Dateinamen des Theme (Z.B. \"thenews.css\"). Bestimmte Themes können entweder ein- oder ausgeschlossen werden. Theme-Namen mit dem Präfix \"!\" befinden sich in der Ausschlussliste. Multiple Werte können durch Semikolon getrennt werden",
"Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module." => "Modul steht in Abhängigkeit des Benutzers mit der Wikiseite zur Verfügung. Entweder können nur Ersteller der Seite (Eintrag: y) oder Nichtersteller (Eintrag: n) das Modul sehen.",
"Contributor" => "Beitragende",
"Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module." => "Modul steht in Abhängigkeit des Benutzers mit der Wikiseite zur Verfügung. Entweder können nur zur Seite Beitragende (Eingabe: y) oder nur nicht zur Seite Beitragende (Eingabe: n) das Modul sehen.",
"Flip" => "Umdrehen",
"Users can open and close the module." => "Benutzer kann das Modul ausblenden.",
"Style" => "Stil",
// "CSS style attribute (for example, to position the module)" => "CSS style attribute (for example, to position the module)",
"Class" => "Klasse",
// "Extra class (for CSS or JavaScript)" => "Extra class (for CSS or JavaScript)",
"Containing Class" => "Beinhaltend Klasse",
"Custom CSS class of div around the module" => "Benutzerdefinierte CSS-Klasse rundherum",
// "Cookie Consent" => "Cookie Consent",
// "Show only if consent to accept cookies has been granted" => "Show only if consent to accept cookies has been granted",
"No Numbers" => "Keine Zahlen",
"If set to \"y\", the module will not number list items." => "Wenn \"y\" eingetragen wird, nummeriert das Modul die Listeneinträge nicht.",
"Rows" => "Zeilen",
"Number of rows, or items, to display." => "Anzahl von anzuzeigenden Zeilen oder Einträgen.",
"Default: 10." => "Standard: 10.",
"Failed to execute \"%0\" module" => "Konnte das \"%0\"-Modul nicht ausführen",
// "Missing dependencies" => "Missing dependencies",
"Contact the system administrator" => "Kontaktiere den Systemadministrator",
// "Module file \"%0\" not found" => "Module file \"%0\" not found",
"Newsletter subscription information at" => "Abonnenteninformationen für Newsletter von",
// "Cannot add subscribers from a newsletter that includes this newsletter's subscribers" => "Cannot add subscribers from a newsletter that includes this newsletter's subscribers",
// " after sending to" => " after sending to",
// " after error in sending to" => " after error in sending to",
// " after failure to send to" => " after failure to send to",
// "Error - potential cross site request forgery detected" => "Error - potential cross site request forgery detected",
// "Potential cross site forgery request detected" => "Potential cross site forgery request detected",
"Limiting the email send rate. Resuming in %0 seconds" => "Beschränke die Senderate der E-Mails. Fortsetzung in %0 Sekunden",
"Newsletter successfully sent to %s users" => "Newsletter erfolgreich zu %s Benutzern gesendet",
"Number of errors: %s" => "Es ist/sind %s Fehler aufgetreten",
// "End of last article" => "End of last article",
// "potential CSRF" => "potential CSRF",
"invalid email" => "ungültige E-Mail",
"A user registers" => "Ein Benutzer registriert sich",
"A user submits an article" => "Ein Benutzer reicht einen Artikel ein",
"A user edits an article" => "Benutzer bearbeitet einen Artikel",
"A user deletes an article" => "Benutzer löscht einen Artikel",
"An article is submitted, edited, deleted or commented on." => "Ein Artikel wurde eingereicht, bearbeitet, gelöscht oder kommentiert.",
"A new blog post is published" => "Ein neuer Blog-Eintrag ist veröffentlicht",
"A blog post comment is posted or edited" => "Ein Kommentar einer Blog-Seite wurde gepostet bzw. editiert",
"A wiki page is created, deleted or edited, except for minor changes." => "Eine Wiki Seite wurde erstellt, gelöscht oder bearbeitet - mit Ausnahme von geringfügigen Änderungen.",
"A wiki page is created, deleted or edited, even for minor changes." => "Eine Wiki Seite wurde erstellt, gelöscht oder bearbeitet (auch ggf. nur geringfügig)",
"A wiki page comment is posted or edited" => "Kommentar zu einer Wikiseite wird erstellt oder geändert",
"An article comment is posted or edited" => "Ein Kommentar wurde zu einem Artikel abgegeben oder bearbeitet",
"Token is called" => "Token wurde aufgerufen",
"User joins a group" => "Benutzer tritt einer Gruppe bei",
// "User's comment is replied" => "User's comment is replied",
"Category change in a language" => "Kategorieänderung in einer Sprache",
"A new page is created in a language" => "Eine neue Seite (Übersetzung) wird erstellt",
// "Cannot save invalid client" => "Cannot save invalid client",
// "Name cannot be empty" => "Name cannot be empty",
// "Redirect URI cannot be empty" => "Redirect URI cannot be empty",
// "Invalid URL for redirect URI" => "Invalid URL for redirect URI",
"section edit" => "Abschnittsbearbeitung",
// "Engine \"%0\" not found" => "Engine \"%0\" not found",
// "Output converter \"%0\" not found" => "Output converter \"%0\" not found",
// "Parsed Data" => "Parsed Data",
"Data" => "Daten",
// "Mapping" => "Mapping",
"Edit Section" => "Bearbeite Abschnitt",
"index" => "Index",
"Table of contents" => "Inhaltsverzeichnis",
"Show/Hide" => "Ein-/Ausblenden",
// "Processing page: %0, is_html: %1" => "Processing page: %0, is_html: %1",
"Payment was sent but verification is not currently available (this feature is a work in progress)" => "Bezahlung gesendet. Überprüfung gegenwärtig nicht möglich (in Arbeit)",
// "Cart: Product code mismatch" => "Cart: Product code mismatch",
// "Cart: Product exchange mismatch" => "Cart: Product exchange mismatch",
// "Invalid gift certificate: %0" => "Invalid gift certificate: %0",
"Please enter your shopper information first" => "Bitte trage zuerst Deine Informationen ein",
// "No email found for gift certificate recipient" => "No email found for gift certificate recipient",
"Gift card is not valid for products in cart" => "Geschenkgutschein ist kein gültiges Produkt für den Warenkorb",
"for" => "für",
"Bundled Product" => "Gebündeltes Produkt",
"Product" => "Produkt",
"Quantity" => "Menge",
"Unit Price" => "Preis pro Einheit",
"There is insufficient inventory to meet your request" => "Es ist kein ausreichender Produktbestand für Deine Anfrage vorhanden",
// "Advanced Shopping Cart setup error: Orders profile missing" => "Advanced Shopping Cart setup error: Orders profile missing",
"Gift Certificate: " => "Geschenkgutschein: ",
"Gift Certificate Amount Used: " => "Anzahl benutzter Geschenkgutscheinte: ",
"No registries specified in admin/payment/cclite" => "Keine Registrierungen unter Verwalten/Bezahlung/Cclite angegeben",
"Cclite payment initiated on %0" => "CClite-Bezahlung veranlasst am %0",
"Connection to Cclite server %0 failed for %1<br />\"%2\"" => "Verbindung zum cclite Server %0 ist für %1 fehlgeschlagen<br />\"%2\"",
"Tiki credits payment done on %0 for %1 (using %2)" => "Tiki Credits Bezahlung wurde am %0 mit %1 erledigt (%2 wurde benutzt)",
// "PDF webkit path \"%0\" not found" => "PDF webkit path \"%0\" not found",
// "The PDF webkit path has not been set" => "The PDF webkit path has not been set",
// "PDF WeasyPrint path \"%0\" not found" => "PDF WeasyPrint path \"%0\" not found",
// "The PDF WeasyPrint path has not been set" => "The PDF WeasyPrint path has not been set",
// "PDF webservice URL \"%0\" not found" => "PDF webservice URL \"%0\" not found",
// "The PDF webservice URL has not been set" => "The PDF webservice URL has not been set",
// "The package mPDF is not installed. You can install it using packages" => "The package mPDF is not installed. You can install it using packages",
// "PDF generation failed" => "PDF generation failed",
// "This is set by the administrator (search for \"print\" in the control panels to locate the setting)" => "This is set by the administrator (search for \"print\" in the control panels to locate the setting)",
// "Required function shell_exec is not enabled" => "Required function shell_exec is not enabled",
"No category jail set in any perspective" => "Kein Kategoriegefängnis in irgendeiner Pespektive festgelegt",
"Areas root category ID" => "Kategorie-Id der Bereichewurzel",
"is invalid" => "ist ungültig",
// "Access-Control-Allow-Origin" => "Access-Control-Allow-Origin",
// "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server" => "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server",
// "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site" => "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site",
// "Record basic events" => "Record basic events",
// "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged" => "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged",
// "Record tracker item update" => "Record tracker item update",
// "Enable recording of basic internal Tiki events" => "Enable recording of basic internal Tiki events",
// "Record tracker item creation" => "Record tracker item creation",
// "Record user following users" => "Record user following users",
// "Record user being followed by users" => "Record user being followed by users",
// "Record user adding new friend" => "Record user adding new friend",
// "Custom activities" => "Custom activities",
// "Allow the defining of custom behaviors in addition to internal events" => "Allow the defining of custom behaviors in addition to internal events",
// "Enable notifications through activities" => "Enable notifications through activities",
// "Allow users to create notifications using activities" => "Allow users to create notifications using activities",
"Ajax auto-save" => "Ajax automatisches Speichern",
"Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing." => "Speichert Deine Bearbeitungen während Du mit der Bearbeitung fortfährst. Hierdurch kannst Du nach einer \"Unterbrechung\" Deine Arbeit wieder herstellen. Aktiviert ausserdem \"Live\" Vorschau und ist zudem erforderlich für WYSIWYG-Plugin-Bearbeitung",
// "Inline editing" => "Inline editing",
// "Enable inline editing of certain values. Currently limited to tracker item fields" => "Enable inline editing of certain values. Currently limited to tracker item fields",
// "Tracker list inline editing" => "Tracker list inline editing",
// "Enable inline editing of all fields on the tracker list page" => "Enable inline editing of all fields on the tracker list page",
// "ffmpeg path" => "ffmpeg path",
// "Path to the location of the ffmpeg binary" => "Path to the location of the ffmpeg binary",
// "ffprobe path" => "ffprobe path",
// "Path to the location of the ffprobe binary" => "Path to the location of the ffprobe binary",
// "Alchemy Image library" => "Alchemy Image library",
// "Select either Image Magick or GD Graphics Library" => "Select either Image Magick or GD Graphics Library",
// "Imagemagick" => "Imagemagick",
// "GD" => "GD",
// "unoconv path" => "unoconv path",
// "Path to the location of the unoconv binary" => "Path to the location of the unoconv binary",
// "ghostscript path" => "ghostscript path",
// "Path to the location of the ghostscript binary" => "Path to the location of the ghostscript binary",
// " (Extension not loaded)" => " (Extension not loaded)",
// "Search index rebuild" => "Search index rebuild",
// "Tracker item export" => "Tracker item export",
// "Tracker clear" => "Tracker clear",
// "Printing to PDF" => "Printing to PDF",
// "PHP execution" => "PHP execution",
// "for example 256M, currently is %0" => "for example 256M, currently is %0",
// "for example 30 seconds, currently is %0 seconds" => "for example 30 seconds, currently is %0 seconds",
// "%0 memory limit" => "%0 memory limit",
// "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server" => "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server",
// "for example: 256M" => "for example: 256M",
// "%0 time limit" => "%0 time limit",
// "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values" => "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values",
"seconds" => "Sekunden",
"Users accept internal messages by default" => "Standardmässig interne Nachrichten empfangen",
// "Users can opt out of internal messages" => "Users can opt out of internal messages",
"ID of category whose child categories are bound to a perspective by areas" => "Die untergeordneten Kategorien dieser Kategorien-Id werden durch die Bereiche-Funktion an Perspektiven gebunden",
"Newest first" => "Neueste zuerst",
"ascending" => "aufsteigend",
"descending" => "absteigend",
// "Article order" => "Article order",
"Default sort mode for the articles on the list-articles page" => "Standardsortierung für Artikel in der Artikelauflistung",
"Title of articles homepage" => "Titel der Artikelhauptseite",
// "Select the default title for the page that displays all articles" => "Select the default title for the page that displays all articles",
"Title" => "Titel",
"Title length" => "Titellänge",
// "characters" => "characters",
"Publication date" => "Veröffentlichungsdatum",
"Visible" => "Sichtbar",
"Author (owner)" => "Author (Besitzer)",
// "Author name (as displayed)" => "Author name (as displayed)",
"Author rating" => "Autorbewertung",
// "Users rating" => "Users rating",
"Reads" => "Zugriffe",
// "Is published" => "Is published",
"Trailer position" => "Position des Aufmachers",
"Between heading and body" => "Zwischen Kopf und Hauptteil",
"Header text position" => "Textposition des Titels",
"Requires a smaller image for list view" => "Erfordert ein kleineres Bild für die Listenansicht",
"Next to image" => "Neben dem Bild",
"Below image" => "Unter dem Bild",
"Oldest first" => "Älteste zuerst",
"Points" => "Punkte",
"Number per page" => "Standardanzahl pro Seite",
// "Set the number of comments per page" => "Set the number of comments per page",
"comments" => "Kommentare",
"Display order" => "Standardsortierung",
// "Set the display order of comments" => "Set the display order of comments",
"Paginate articles" => "Paginiere Artikel",
"Divide articles into multiple pages with pagebreak markers." => "Teile Artikel in multiple Seiten mit Seitenumbrüchen.",
// "Article creator remains article owner" => "Article creator remains article owner",
// "Last article editor does not automatically become author (owner)" => "Last article editor does not automatically become author (owner)",
"User ratings on articles" => "Benutzerbewertungen bei Artikeln",
"Allow users to rate articles" => "Erlaubt es Benutzern Artikel zu bewerten",
// "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set" => "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set",
"Article rating options" => "Bewertungsoptionen für Artikel",
"List of options available for the rating of articles" => "Liste von verfügbaren Optionen für die Bewertung von Artikeln",
"Default maximum width for custom article images" => "Standard für die maximale Breite für benutzerdefinierte Artikelbilder",
// "Set the default maximum width of the article image" => "Set the default maximum width of the article image",
"pixels" => "Pixel",
// "\"0\" for no maximum" => "\"0\" for no maximum",
"Default maximum height for custom article images" => "Standard für die maximale Höhe für benutzerdefinierte Artikelbilder",
// "Set the default maximum height of article images" => "Set the default maximum height of article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Sets the default maximum width of custom article images in list mode (on View Articles page)" => "Sets the default maximum width of custom article images in list mode (on View Articles page)",
// "\"0\" to default to the view mode maximum" => "\"0\" to default to the view mode maximum",
"Default maximum height of custom article images in list mode (on View Articles page)" => "Standard für die maximale Höhe für benutzerdefinierte Artikelbilder im Listenmodus (bei Artikel ansehen)",
// "Set the default maximum height of custom article images in list mode (on the View Articles page)" => "Set the default maximum height of custom article images in list mode (on the View Articles page)",
// "Article image maximum file size" => "Article image maximum file size",
// "Maximum file size for an article image. Article images are stored in the database so it should remain low" => "Maximum file size for an article image. Article images are stored in the database so it should remain low",
// "kilobytes" => "kilobytes",
"Custom attributes for article types" => "Benutzerdefinierte Felder für Artikel",
"Enable additional custom fields for article types" => "Erlaube zusätzliche, benutzerdefinierte Felder für Artikeltypen",
"Your ShareThis publisher identifier (optional)" => "Deine \"ShareThis\" Identifikation (optional)",
// "Set to define your ShareThis publisher identifier" => "Set to define your ShareThis publisher identifier",
// "record your ShareThis publisher ID" => "record your ShareThis publisher ID",
"Related articles" => "Verwandte Artikel",
"Display a list of related articles at the bottom of an article page" => "Zeige eine Liste von verwandten Artikeln am unteren Rand der Artikelseite",
// "Use new articles" => "Use new articles",
// "Use the new CustomSearch-based article lists rather than database information" => "Use the new CustomSearch-based article lists rather than database information",
// "Article copyright" => "Article copyright",
// "Apply copyright management preferences to this feature" => "Apply copyright management preferences to this feature",
"Authentication method" => "Authentifizierungsmethode",
"Tiki supports several authentication methods. The default method is to use the internal user database" => "Tiki unterstützt verschiedene Authentifizierungsmethoden. Standardmäßig wird die interne Benutzerdatenbank benutzt",
"Tiki" => "Tiki",
"Tiki and OpenID" => "Tiki und OpenID",
"Tiki and PAM" => "Tiki und PAM",
"Tiki and LDAP" => "Tiki und LDAP",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service, zentraler Authentifizierungsdienst)",
// "SAML" => "SAML",
"Shibboleth" => "Shibboleth",
"Web Server" => "Webserver",
"phpBB" => "phpBB",
// "Token access" => "Token access",
"With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service" => "Erlaube den Zugriff auf Inhalte mit übergeordneten Rechten, wenn ein Token vorgelegt wird. Der primäre Zwecke dieser Authentifizierung ist der, Externen vorübergehenden Zugriff zu gewähren",
// "Token access default timeout" => "Token access default timeout",
// "The default duration for which the generated tokens will be valid" => "The default duration for which the generated tokens will be valid",
// "Token access default maximum hits" => "Token access default maximum hits",
// "The default maximum number of times a token can be used before it expires" => "The default maximum number of times a token can be used before it expires",
"hits" => "Treffer",
"Share access rights with friends when using Tell a friend" => "Gleiche Rechte für einen Freund, wenn \"Zeige das einem Freund\" benutzt wird",
"Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site" => "Erlaube es Benutzern Deine Zugriffsrechte für die gegenwärtige Seite zu teilen, wenn ein Link per E-Mail gesendet wird. Die Lebensspanne des Links wird von der Site definiert",
// "Do not delete temporary users when token is deleted/expired" => "Do not delete temporary users when token is deleted/expired",
// "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms" => "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms",
"Share access rights with friends when using Share" => "Gleiche Rechte für einen Freund, wenn \"send a link\" benutzt wird",
"Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site" => "Erlaube es Benutzern Deine Zugriffsrechte für die gegenwärtige Seite zu teilen, wenn ein Link per E-Mail/Twitter/Facebook gesendet wird. Die Lebensspanne des Links wird von der Site definiert",
"Create user if not registered in Tiki" => "Erstelle Benutzer, wenn nicht in Tiki",
// "Automatically create a new Tiki user for the PHPbb login" => "Automatically create a new Tiki user for the PHPbb login",
"Use Tiki authentication for Admin log-in" => "Benutze Tiki Authentifizierung für Administratorlogin",
// "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”" => "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”",
// "Disable Tiki users who don’t have a phpBB login as they could have been deleted" => "Disable Tiki users who don’t have a phpBB login as they could have been deleted",
"phpBB Version" => "phpBB Version",
"3" => "3",
"phpBB Database Hostname" => "phpBB Datenbank Hostname",
"phpBB Database Username" => "phpBB Datenbank Benutzername",
"phpBB Database Password" => "phpBB Datenbank Passwort",
"phpBB Database Name" => "phpBB Datenbank Name",
"phpBB Table Prefix" => "phpBB Tabellenpräfix",
"Use Tiki authentication for users created in Tiki" => "Benutze Tiki Authentifzierung für Benutzer, die in Tiki erstellt wurden",
// "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP" => "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP",
"Host" => "Host",
// "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL" => "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL",
"Port" => "Port",
// "The port number your LDAP server uses (389 is the default, 636 if you check SSL)" => "The port number your LDAP server uses (389 is the default, 636 if you check SSL)",
"Write LDAP debug Information in Tiki Logs" => "Schreibe LDAP Debuginformation in Tiki Logs",
// "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)" => "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)",
// "Do not enable this option for production sites" => "Do not enable this option for production sites",
"Use SSL (ldaps)" => "Benutze SSL (ldaps)",
"Use TLS" => "Benutze TLS",
"LDAP Bind Type" => "LDAP Bind-Typ",
// "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>" => "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>",
"Default: Anonymous Bind" => "Standard: Anonymous Bind",
"Full: userattr=username,UserDN,BaseDN" => "Voll: userattr=username,UserDN,BaseDN",
"OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
"Active Directory (username@domain)" => "Active Directory (Benutzername@Domäne)",
"Plain Username" => "Einfacher Benutzername",
"Search scope" => "Suchumfang",
// "Used after authentication for getting user and group information" => "Used after authentication for getting user and group information",
"Subtree" => "Subtree (dieses Objekt und alles darunter)",
"One level" => "One level (eine Ebene unterhalb des BaseDNs)",
"Base object" => "Base object",
"Base DN" => "Base DN",
"User DN" => "Benutzer DN",
"User attribute" => "Benutzerattribut",
"User OC" => "Benutzer OC",
"Realname attribute" => "Echtnamenattribut",
// "Synchronize Tiki user attributes with the LDAP values" => "Synchronize Tiki user attributes with the LDAP values",
"Country attribute" => "Länderattribut",
"Email attribute" => "E-Mailattribut",
"Group DN" => "Group DN",
"Group name attribute" => "Group name attribute",
"Group description attribute" => "Group description attribute",
"Group OC" => "Group OC",
"Member attribute" => "Member attribute",
"Member is DN" => "Member is DN",
"Group attribute" => "Gruppenattribut",
"Group attribute in group entry" => "Group attribute in group entry",
"(Leave this empty if the group name is already given in the user attribute)" => "(Lasse dies leer, wenn der Gruppenname bereits im Benutzerattribut angegeben ist)",
"Admin user" => "Administrator-Benutzer",
"Admin password" => "Administrator-Passwort",
"Use an external LDAP server for groups" => "Benutze einen externen LDAP Server für Gruppen",
"Anonymous Bind" => "Standard: Anonymous Bind",
"Corresponding user attribute in 1st directory" => "Entsprechendes Benutzerattribut im ersten Verzeichnis",
// "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database" => "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database",
// "Disable Tiki users with no phpBB login" => "Disable Tiki users with no phpBB login",
// "Default Bootstrap" => "Default Bootstrap",
"Available languages" => "Verfügbare Sprachen",
// "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset" => "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset",
// "Available themes" => "Available themes",
"Restrict available themes" => "Verfügbare Themes einschränken",
// "BigBlueButton web conferencing" => "BigBlueButton web conferencing",
"Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration mit dem BigBlueButton Server für Webkonferenzen und Bildschirmteilung",
"BigBlueButton server location" => "BigBlueButton Server Adresse",
"Full URL to the BigBlueButton installation" => "Volle URL zur BigBlueButton Installation",
"http://host.example.com/" => "http://host.beispiel.com/",
"BigBlueButton server salt" => "BigBlueButton Server Salt",
"A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic" => "Der salt Schlüssel wird vom BigBlueButton Server genutzt um Prüfsummen zu erstellen um zu erkennen, ob die Anfragen authentisch sind",
"BigBlueButton recording maximum duration" => "Maximale Aufzeichnungsdauer für BigBlueButton",
"A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open" => "Es muss eine maximale Dauer für Treffen mit BigBlueButton angegeben werden. Hierdurch wird verhindert, dass exzessiv lange Sitzungen aufgezeichnet werden, wenn ein Benutzer das Fenster zu lange geöffnet lässt",
"minutes" => "Minuten",
// "BigBlueButton dynamic configuration" => "BigBlueButton dynamic configuration",
// "Uses the advanced options of BigBlueButton to configure the XML per room" => "Uses the advanced options of BigBlueButton to configure the XML per room",
"Default ordering" => "Standardsortierung",
// "Default order" => "Default order",
"Creation Date (desc)" => "Erstellungsdatum (absteigend)",
"Last modification date (desc)" => "Datum letzte Änderung (absteigend)",
"Blog title (asc)" => "Blog-Titel (aufsteigend)",
"Number of posts (desc)" => "Anzahl Posts (absteigend)",
"Visits (desc)" => "Besuchszahlen (absteigend)",
"Activity (desc)" => "Aktivität (absteigend)",
"Disabled" => "Deaktiviert",
"Link to user information" => "Link auf Benutzerinformationen",
"User profile picture" => "Benutzer Avatar",
"Posts" => "Einträge",
"Visits" => "Besuche",
"Activity" => "Aktivität",
// "Blog post copyright" => "Blog post copyright",
"Module (box) shadow start" => "Modul (Box) Schatten Anfang",
"Module (box) shadow end" => "Modul (Box) Schatten Ende",
"Days to display in the calendar" => "Tage, die im Kalender angezeigt werden",
"Default view mode" => "Standardansicht",
"Day" => "Tag",
"Week" => "Woche",
"Month" => "Monat",
"Quarter" => "Quartal",
"Semester" => "Halbjahr",
"Year" => "Jahr",
"View list begins" => "Ansichtsliste beginnt mit",
"Focus date" => "Fokus Datum",
"Period beginning" => "Periodenbeginn",
"First day of the week" => "Erster Tag der Woche",
"Depends user language" => "hängt von der Benutzersprache ab",
"Split hours in periods of" => "Teile Stunden in Abschnitte von",
"1" => "1",
"5" => "5",
"10" => "10",
"15" => "15",
"30" => "30",
// "Minute Interval" => "Minute Interval",
"First year in the dropdown" => "Erstes Jahr im Ausklapplistenfeld",
"years" => "Jahre",
// "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled" => "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled",
"Last year in the dropdown" => "Letztes Jahr im Ausklapplistenfeld",
"Enter a year or use +/- N to specify a year relative to the current year" => "Trage ein Jahr ein oder benutze +/-, um ein Jahr in Relation zum aktuellen Jahr anzugeben",
"Sticky popup" => "Sticky Popup",
"Item view tab" => "Tab 'Eintrag ansehen'",
"Show \"Add to Google Calendar\" icon" => "Zeige ein \"Zu Googlekalender hinzufügen\"-Symbol",
"Show \"Export Calendars\" button" => "Zeige Schaltfläche zum Exportieren von Kalendern",
// "Show \"Export Calendar Item\" Button" => "Show \"Export Calendar Item\" Button",
// "Allow exporting a single calendar event as an iCal file" => "Allow exporting a single calendar event as an iCal file",
"Use FullCalendar to display calendars" => "Benutze FullCalendar um Kalender anzuzeigen",
"Treat calendar item descriptions as HTML" => "Behandele Kalendereintrag-Beschreibungen als HTML",
"Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Benutze dies, wenn Du den WYSIWYG-Editor für Kalender benutzt. Dies ist für Altdaten für Tikiversionen vor 7.0",
"Enable watch events when you are the editor" => "Beobachtungspunkt für Seite beim Ändern setzen",
// "Check this to receive email notifications of events you changed yourself" => "Check this to receive email notifications of events you changed yourself",
"CAPTCHA image word length" => "Wortlänge des Captchabildes",
"Number of characters the CAPTCHA will display" => "Wortlänge des Captchabildes",
// "CAPTCHA image width" => "CAPTCHA image width",
"Width of the CAPTCHA image in pixels" => "Breite des Captchabildes in Pixel",
// "CAPTCHA image noise" => "CAPTCHA image noise",
"Level of noise of the CAPTCHA image" => "Störungslevel des Captchabildes",
"Choose a smaller number for less noise and easier reading" => "Wähle eine geringere Zahl für die Störung um die Leesbarkeit zu erhöhen",
// "CAPTCHA questions" => "CAPTCHA questions",
// "Requires anonymous visitors to enter the answer to a question" => "Requires anonymous visitors to enter the answer to a question",
// "CAPTCHA questions and answers" => "CAPTCHA questions and answers",
// "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line" => "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line",
// "One question per line with a colon separating the question and answer" => "One question per line with a colon separating the question and answer",
"Try automatically to connect SSO" => "Versuche automatisch SSO zu verbinden",
"Force CAS log-out when the user logs out from Tiki." => "Erzwinge CAS-Abmeldung, wenn sich der Benutzer von der Tiki abmeldet",
"Show alternate log-in method in header" => "Zeige im Kopf alternative Login-Methoden",
"CAS server version" => "CAS Serverversion",
"none" => "keine",
"Version 1.0" => "Version 1.0",
"Version 2.0" => "Version 2.0",
"Hostname" => "Hostname",
"Hostname of the CAS server" => "Hostname des CAS Server",
"Port of the CAS server" => "Port des CAS Server",
"Path for the CAS server" => "Pfad für den CAS Server",
"CAS Extra Parameter" => "Zusätzliche CAS Parameter",
"Extra Parameter to pass to the CAS Server" => "Zusätzliche, an den CAS Server zu übergebende Parameter",
"CAS Authentication Verification Timeout" => "Zeitüberschreitung für CAS Authentifizierungsüberprüfung",
"Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Authentifizierung mit dem CAS Server alle N Sekunden prüfen. Nie bedeutet, dass die Überprüfung nicht erneut vorgenommen wird",
"minute" => "Minute",
"hour" => "Stunde",
// "Provides the current categories to Smarty templates" => "Provides the current categories to Smarty templates",
// "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance" => "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance",
// "Categories to add as CSS classes to <body>" => "Categories to add as CSS classes to <body>",
// "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag" => "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag",
// "Clear cache upon category change" => "Clear cache upon category change",
// "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date" => "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date",
// "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts" => "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts",
"Category jail" => "Kategoriegefängnis",
"Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Beschränkt die Sichtbarkeit von Objekten auf diejenigen, die in dieser Kategorie-IDs sind. Wird hauptsächlich benutzt um Arbeitsbereiche von Perspektiven zu erstellen",
// "This should only be set for perspectives, and not globally" => "This should only be set for perspectives, and not globally",
// "Category jail root" => "Category jail root",
// "Always display categories outside of the jail root, which would be for normal categorization" => "Always display categories outside of the jail root, which would be for normal categorization",
"Category defaults" => "Voreingestellte Kategorien",
"Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default" => "Erzwinge das Vorhandensein bestimmter Kategorien. Wird keine Kategorie aus einem bestimmten Satz angegeben, weise standardmäßig eine Kategorie zu",
"Use *7 to specify all the categories in the subtree of 7 + category 7" => "Benutze *7, um alle Unterkategorien im Unterverzeichnis 7 sowie die Kategorie 7 anzugeben",
"Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Kann dies nur für Objektnamen tun, die dem regulären Ausdruck (regex) entsprechen. (Beispiel: /^RND_/ = Name, der mit RND_ beginnt)(optional)",
"Can do for wiki only (optional)" => "Kann dies nur für Wiki tun (optional)",
"Rename will only reassign the categories for wiki pages" => "Umbenennen wird die Kategorien nur Wiki Seiten wieder zuweisen",
"One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page" => "Eine pro Zeile. Beispiel: 1,4,6,*7/4:/^RND_/:wiki page",
"Synchronize multilingual categories" => "Synchronisiere mehrsprachige Kategorien",
"Make sure that the categories of the translations are synchronized when modified on any version" => "Stelle sicher, dass die Kategorien bei den Übersetzungen synchronisiert werden, wenn irgendeine Version verändert wird",
"Only those specified" => "Nur die angegebenen",
"All but those specified" => "Alle außer den angegebenen",
"Synchronized categories" => "Synchronisierte Kategorien",
"List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)" => "Kategorienliste, die von der multilingualen Synchronisation betroffen ist. Abhängig von der übergeordneten Funktion wird diese Liste als Whitelist (nur Kategorien erlaubt) oder als Blacklist (alle außer den angegebenen) benutzt",
// "Sort categories case insensitively" => "Sort categories case insensitively",
// "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings" => "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings",
// "Automatically geocode items with this category" => "Automatically geocode items with this category",
"Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatisches geokodieren von Objekten aus Basis des Kategorienamens wenn sie in den Unterkategorien dieser Kategorie-ID kategorisiert werden",
// "Replace any existing geocode" => "Replace any existing geocode",
"When automatically geocoding items based on category name, replace existing geocode, if any" => "Wenn Objekte auf Basis des Kategorienamens geokodiert werden, ersetzt die eventuell bestehende Kodierung",
"Use approximate geocode location" => "Benutze ungefähre geokodierte Position",
"When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "Wenn Objekte auf Basis des Kategorienamens geokodiert werden, benutze angenäherte Lokalisierung anstelle des exakten Ortes",
"\"More Like This\" algorithm for categories" => "Ähnlichkeits-Algorithmus für Kategorien",
"Weighted" => "Gewichtet",
"Minimum number of categories in common" => "Mindestanzahl von Kategorien, die übereinstimmen",
// "categories" => "categories",
"2" => "2",
"4" => "4",
"6" => "6",
"7" => "7",
"8" => "8",
"9" => "9",
// "List objects with most categories in common" => "List objects with most categories in common",
// "No minimum is applied" => "No minimum is applied",
// "Maximum number of \"more like this\" objects" => "Maximum number of \"more like this\" objects",
// "The default maximum records setting for the site is used of this is set to 0" => "The default maximum records setting for the site is used of this is set to 0",
// "objects" => "objects",
// "Generate custom facets from categories" => "Generate custom facets from categories",
// "Comma-separated list of category IDs" => "Comma-separated list of category IDs",
// "Show category object count" => "Show category object count",
// "Show object count when browsing categories, complying with search and type filters" => "Show object count when browsing categories, complying with search and type filters",
// "Can slow the loading of the categories page on large sites" => "Can slow the loading of the categories page on large sites",
"Exclude these category IDs" => "Schließe diese Kategorie-IDs aus",
"Category path won't appear for these category IDs" => "Kategoriepfad erscheint nicht für diese Kategorie-IDs",
// "Category path format" => "Category path format",
// "Alter how the category path will be rendered" => "Alter how the category path will be rendered",
// "Links to the category when the category is visible" => "Links to the category when the category is visible",
// "Text label when the category is visible" => "Text label when the category is visible",
// "Link when visible, text label otherwise" => "Link when visible, text label otherwise",
// "Always display the category path labels" => "Always display the category path labels",
"Center shadow start" => "Schattenanfang Hauptteil",
"Center shadow end" => "Schattenende Hauptteil",
// "Users can choose the language of their interface" => "Users can choose the language of their interface",
"Allow users to change the language of the menus and labels" => "Erlaubt es Benutzern, die Sprache in Menüs und Bezeichnungen zu ändern",
"Users can change theme" => "Registrierte Benutzer können Theme ändern",
// "Users can override the theme with this setting" => "Users can override the theme with this setting",
"Users can change their password" => "Benutzer können ihr Passwort ändern",
// "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin" => "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin",
"Disable comment titles" => "Titel für Kommentare abschalten",
"Don't display the title input field on comments and their replies" => "Verstecke Titelfeld bei Kommentaren und deren Antworten",
"Email field" => "E-Mailfeld",
"Email field for comments (only for anonymous users)" => "E-Mailfeld für Kommentare (nur für anonyme Benutzer)",
"Website field" => "Webseitenfeld",
"Website field for comments (only for anonymous users)" => "Websitefeld für Kommentare (nur für anonyme Benutzer)",
"Use vote system for comments" => "Benutzerabstimmung für Kommentare",
// "Allow users with permission to vote on comments" => "Allow users with permission to vote on comments",
// "Permissions involved: %0" => "Permissions involved: %0",
"Archive comments" => "Kommentare archivieren",
"If a comment is archived, only admins can see it" => "Wenn ein Kommentar archiviert wir, können ihn nur Administratoren sehen",
"Use Akismet to filter comments" => "Benutze Akismet um Kommentare zu filtern",
"Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam" => "Verhindere und erkenne Kommentar-Spam mittels des Akismet Dienstes. Wenn die Moderation von Kommentaren aktiviert ist, zeigt Akismet an, ob ein Kommentar moderiert werden muss oder nicht. Ist sie ausgeschaltet, wird der Kommentar zurückgewiesen, wenn er als Spam eingestuft wurde",
"Akismet API Key" => "Akismet API Schlüssel",
"Key required for the Akismet comment spam prevention" => "Der Schlüssel ist erforderlich, damit der Akismet Spam-Schutz für Kommentare funktioniert",
"Obtain this key by registering your site at [%0]" => "Registriere Deine Seite bei %0 um einen Schlüssel zu erhalten",
"Filter spam for registered users" => "Spam-Filter auch bei registrierten Benutzern",
"Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening" => "Aktiviere den Spam-Filter auch für registrierte Benutzer. Sinnvoll, wenn Deine Site eine einfache Registrierung ohne weitere Validierung erlaubt",
"Allow comments to be edited by their author" => "Gestatte, dass Autoren ihre Komentare korrigieren können",
// "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc" => "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc",
// "Inline comments using Apache Annotator" => "Inline comments using Apache Annotator",
// "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations" => "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations",
// "Anchor links on headings" => "Anchor links on headings",
// "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page" => "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page",
// "Number of comments per page" => "Number of comments per page",
// "Sort mode for comments" => "Sort mode for comments",
// "Automatically present a terms of use page to be accepted by users accessing the site" => "Automatically present a terms of use page to be accepted by users accessing the site",
// "Terms of Use page name" => "Terms of Use page name",
// "Wiki page for Terms of Use content. The page may be translated using the multilingual feature" => "Wiki page for Terms of Use content. The page may be translated using the multilingual feature",
// "Minimum age" => "Minimum age",
// "When presenting the terms of use, request age" => "When presenting the terms of use, request age",
// "0 to ignore age validation" => "0 to ignore age validation",
// "Tiki connect" => "Tiki connect",
"Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Verbinde Deine Tiki mit der Gemeinschaft durch Senden von anonymisierten statistischen Daten an tiki.org",
"This feature is still under development" => "Experimentell: diese Funktion ist immer noch in der Entwicklung",
// "Send site information" => "Send site information",
"Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you" => "Zusätzlich Schlüsselwörter, Lokalisierung etc an tiki.org senden, so dass Du Dich mit Tikis in Deiner Nähe verbinden kannst",
"Site title" => "Site-Titel",
"Name of site to be listed on Tiki Connect" => "Name der Site für Tiki Verbindung",
// "Site title is required to send site information" => "Site title is required to send site information",
"Email contact" => "E-Mailkontakt",
"Email to register" => "E-Mail zum Registrieren",
"URL to register" => "URL zum Registrieren",
"Key words" => "Schlüsselwörter",
"Key words or tags describing your site" => "Schlüsselwörter oder Tags, die Deine Site beschreiben",
"Site location" => "Site-Ort",
"Site location expressed as longitude, latitude, and zoom" => "Site-Ort als Längengrad,Breitengrad,Zoom",
"Send anonymous information" => "Sende anonyme Informationen",
"Send anonymous usage information" => "Sende anonyme Benutzungs-Information",
"Connection frequency" => "Verbindungshäufigkeit",
// "How often to send information" => "How often to send information",
"hours" => "Stunden",
// "Click \"Send Info\" to connect" => "Click \"Send Info\" to connect",
"Currently not in use" => "Experimentell. Gegenwärtig nicht in Benutzung. Klicke auf \"Sends Info\" zum Verbinden",
// "Tiki connect server URL" => "Tiki connect server URL",
"Where to send the information" => "Wohin die Informationen gesendet werden sollen",
"Last connection" => "Letzte Verbindung",
"Connect server mode" => "Connect-Server-Modus",
"For use by mother.tiki.org" => "Für die Benutzung durch mother.tiki.org",
"Connect GUID" => "Connect GUID",
"For use by mother.tiki.org. Do not modify" => "Zur Benutzung für mother.tiki.org. Nicht verändern",
"Allow anonymous visitors to use the \"Contact Us\" feature." => "Erlaube es anonymen Benutzer die \"Kontaktiere uns\"-Funktion zu nutzen.",
// "Display contact priority" => "Display contact priority",
// "Display contact priority option" => "Display contact priority option",
"Contact user" => "Kontaktperson",
// "User to contact" => "User to contact",
"Cookie name" => "Cookie Name",
"Domain" => "Domäne",
// "The domain that the cookie is available to" => "The domain that the cookie is available to",
// "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically" => "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically",
// "Ask permission of the user before setting any cookies, and comply with the response" => "Ask permission of the user before setting any cookies, and comply with the response",
// "Complies with EU Privacy and Electronic Communications Regulations" => "Complies with EU Privacy and Electronic Communications Regulations",
// "Cookie consent name" => "Cookie consent name",
// "Name of the cookie to record the user's consent if the user agrees" => "Name of the cookie to record the user's consent if the user agrees",
// "Cookie consent expiration" => "Cookie consent expiration",
// "Expiration date of the cookie to record consent (in days)" => "Expiration date of the cookie to record consent (in days)",
"days" => "Tage",
// "Cookie consent text" => "Cookie consent text",
// "Description for the dialog" => "Description for the dialog",
// "Wiki-parsed" => "Wiki-parsed",
// "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))" => "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))",
// "Cookie consent question" => "Cookie consent question",
// "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox" => "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox",
// "I accept cookies from this site" => "I accept cookies from this site",
// "Cookie consent button" => "Cookie consent button",
// "Label on the agreement button" => "Label on the agreement button",
"Continue" => "Weiter",
// "Cookie consent alert" => "Cookie consent alert",
// "Alert displayed when user tries to access or use a feature requiring cookies" => "Alert displayed when user tries to access or use a feature requiring cookies",
// "Sorry, cookie consent required" => "Sorry, cookie consent required",
// "Cookie consent mode" => "Cookie consent mode",
// "Appearance of consent dialog" => "Appearance of consent dialog",
// "Dialog style requires feature_jquery_ui" => "Dialog style requires feature_jquery_ui",
"Plain" => "flach",
"Banner" => "Banner",
"Dialog" => "Dialog",
// "Cookie consent dialog ID" => "Cookie consent dialog ID",
// "DOM id for the dialog container div" => "DOM id for the dialog container div",
// "Cookie consent disabled" => "Cookie consent disabled",
// "Do not give the option to refuse cookies but still inform the user about cookie usage" => "Do not give the option to refuse cookies but still inform the user about cookie usage",
// "Refresh the remember-me cookie expiration" => "Refresh the remember-me cookie expiration",
// "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated" => "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated",
// "Name of the cookie to remember the user's login" => "Name of the cookie to remember the user's login",
"Count admin pageviews" => "Seitenaufrufe durch Administrator mitzählen",
"Include pageviews by Admin when reporting stats" => "Bezieht Seitenaufrufe durch den Administrator mit ein, wenn Statistiken erstellt werden",
"Enable daily reports for new users" => "Aktiviere tägliche Berichte für neue Benutzer",
// "Determines if daily reports will be automatically enabled for new users" => "Determines if daily reports will be automatically enabled for new users",
"Default character set for sending mail" => "Zeichensatz in E-Mails",
"Specify the character encoding used by Tiki when sending mail notifications" => "Zeichensatz in E-Mails",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "Standard-Kartendatei",
"Default diff style" => "Voreingestellter Vergleichsstil",
"Only with last version" => "Nur mit letzter Version",
"HTML diff" => "HTML Vergleich",
"Side-by-side diff" => "Seite-an-Seite-Vergleich",
"Side-by-side diff by characters" => "Seite-an-Seite-Vergleich nach Zeichen",
"Inline diff" => "Zeilenvergleich",
"Inline diff by characters" => "Zeilenvergleich nach Zeichen",
"Full side-by-side diff" => "Kompletter Seite-an-Seite-Vergleich",
"Full side-by-side diff by characters" => "Kompletter Seite-an-Seite-Vergleich nach Zeichen",
"Full inline diff" => "Kompletter Zeilenvergleich",
"Full inline diff by characters" => "Kompletter Zeilenvergleich nach Zeichen",
"Unified diff" => "Einheitlicher Vergleich",
"Side-by-side view" => "Seite-an-Seite-Ansicht",
"rows" => "Zeilen",
// "Comment box" => "Comment box",
// "Size (height) of the comment text area" => "Size (height) of the comment text area",
"Forum reply" => "Forumantwort",
// "Select default calendars to display" => "Select default calendars to display",
// "Group transition sets default" => "Group transition sets default",
// "Sets the group transitioned to as the user's default group" => "Sets the group transitioned to as the user's default group",
// "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites" => "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites",
"Disable browser's autocomplete feature for username and password fields" => "Deaktiviere die Autovervollständigenfunktion des Browsers für Benutzername und Passwort Felder",
"Use direct pagination links" => "Seitennavigation über Seitenzahlen",
"Maximum number of links around the current item" => "Maximale Zahl von Links um das aktuelle Objekt",
// "links" => "links",
"Maximum number of links after the first or before the last item" => "Maximale Zahl von Links nach dem ersten oder vor dem letzten Objekt",
"Show country flag" => "Zeige Landesflagge",
"Show the country flag" => "Zeige die Landesflagge",
"Enable \"popular sites\"" => "Coole Links aktivieren",
"Validate URLs" => "URLs überprüfen",
// "Should Tiki check the URL" => "Should Tiki check the URL",
// "Columns per page" => "Columns per page",
"Number of columns per page when listing directory categories" => "Anzahl von Spalten, wenn die Verzeichniskategorien aufgelistet werden",
// "columns" => "columns",
"Links per page" => "Links pro Seite",
// "How many links should be displayed per page" => "How many links should be displayed per page",
"Method to open Directory links" => "Wie werden Links geöffnet?",
"The linked-to website can be opened in various ways" => "Art und Weise Links zu öffnen",
"Replace the current window" => "Aktuelles Fenster ersetzen",
"Open a new window" => "Neues Fenster",
"Open an iframe" => "Frame innerhalb der Seite",
"Fields display order" => "Darstellungsreihenfolge der Felder",
// "The order date field inputs should be listed in" => "The order date field inputs should be listed in",
// "Year to show first in dropdown lists" => "Year to show first in dropdown lists",
// "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year" => "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year",
// "year(s)" => "year(s)",
// "Year to show last on dropdown lists" => "Year to show last on dropdown lists",
// "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year" => "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year",
"Re-validate user email after" => "Re-validiere Benutzer per E-Mail nach",
// "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid" => "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid",
"Use \"-1\" for never" => "Benutze \"-1\" für niemals",
"Email footer" => "E-Mail Fußbereich",
"Text appended to outgoing emails" => "Text, der an ausgehende E-Mails angehängt wird",
"PHP errors visible to admin only" => "PHP Fehler nur für Administratoren sichtbar",
"During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators." => "Zu Entwicklungszwecken ist es besser Fehler allen Benutzern anzuzeigen. In Produktivumgebungen, sollten die Fehler aber nur Administratoren angezeigt werden.",
// "PHP Errors will be shown to only the Admin user" => "PHP Errors will be shown to only the Admin user",
"PHP Error reporting level" => "PHP Fehler berichten",
"Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist" => "Schwelle, von der an Fehler berichtet werden",
"No error reporting" => "Keine Fehlerausgabe",
"Report all PHP errors except strict" => "Alle PHP-Fehler außer STRICT ausgeben",
"Report all PHP errors" => "Alle PHP Fehler ausgeben",
"Report all PHP errors except notices" => "Alle PHP-Fehler außer Hinweisen (NOTICES) ausgeben",
"According to the PHP configuration" => "Entsprechend der PHP Einstellungen",
"Default number of comments per page" => "Standardanzahl von Kommentaren pro Seite",
// "Maximum number of comments to display on each page. Users may override this number" => "Maximum number of comments to display on each page. Users may override this number",
"Default order of comments" => "Standardsortierung für Kommentare",
// "In which order to list the comments on the page" => "In which order to list the comments on the page",
// "Prefix for answers" => "Prefix for answers",
// "The prefix for that Tiki should display for each FAQ answer" => "The prefix for that Tiki should display for each FAQ answer",
"Q and A" => "Frage & Antwort",
"Question ID" => "Frage ID",
// "FAQ copyright" => "FAQ copyright",
// "Limit blog categories to those under this category" => "Limit blog categories to those under this category",
"If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None." => "Wenn Du eine Fehlermeldung erhältst, dass eine Kategorie für die Bearbeitung eines Blogeintrages erforderlich ist, dann solltest Du ggf. diese Auswahl auf Keine stellen.",
"Areas" => "Bereiche",
"Binding categories and perspectives to each other" => "Bindet Kategorien und Perspektiven aneinander",
// "Pages and collaboratively authored documents with edit history" => "Pages and collaboratively authored documents with edit history",
"Online diaries or journals" => "Online Tagebücher oder Journale",
"Enable directory batch loading" => "Batch-Upload aus Verzeichnis erlauben",
// "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols" => "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols",
"You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird muss ein vom Webserver lesbares Verzeichnis benutzt werden (am besten außerhalb des Webspace). Dorthin müssen die Bilder dann mit scp, ftp o.ä. übertragen werden.",
"Rankings" => "Bewertungen",
// "Users can see several charts or rankings about the file" => "Users can see several charts or rankings about the file",
// "Image gallery" => "Image gallery",
"Collections of images for viewing or downloading (photo albums)" => "Sammlung von Bilddateien zum Ansehen oder Herunterladen (Fotoalbum)",
"File galleries can be used instead" => "Du kannst alternativ Dateiarchive dafür benutzen",
// "Image Gallery Comments" => "Image Gallery Comments",
// "Users with permission may post threaded comments. The comments will appear at the bottom of the page" => "Users with permission may post threaded comments. The comments will appear at the bottom of the page",
// "Limit image gallery categories to those under this category" => "Limit image gallery categories to those under this category",
// "Machine translation" => "Machine translation",
// "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service" => "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service",
"Database and form generator" => "Databank und Formulargenerator",
"Threaded or flat discussions" => "Onlinediskussionen über vielfältige Themen. Thematisch sortiert oder flache Ansicht",
// "File gallery" => "File gallery",
"Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability" => "Computerdateien, Videos oder Software zum Herunterladen. Mit check-in- & check-out-Funktion (Sperren)",
"Save files as drafts" => "Dateien als Entwurf speichern",
// "Allow saving of files as drafts" => "Allow saving of files as drafts",
"File gallery configuration templates" => "Konfigurationsvorlagen Dateiarchive",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Abstimmungen",
"Presentation of a set of votable options, typically displayed in a module" => "Kurze Liste von abstimmbaren Optionen; erscheint in einem Modul (linke oder rechte Spalte)",
"Newsletters" => "Newsletter",
"Content mailed to registered users or other subscribers" => "Inhalt, der an registrierte Benutzer geschickt wird",
"Calendar" => "Kalender",
"Events calendar with public, private and group channels" => "Ereigniskalender mit öffentlichen, privaten und Gruppenkanälen",
"Banners" => "Banner",
"Insert, track, and manage advertising banners" => "Füge Werbebanner ein, verfolge und verwalte sie",
// "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access" => "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access",
// "Unified user details " => "Unified user details ",
// "Use User Details Page using the Unified Index" => "Use User Details Page using the Unified Index",
"Score" => "Bewertung",
"Score is a game to motivate participants to increase their contribution by comparing to other users" => "Bewertung ist ein Spiel, damit die Teilnehmer motiviert werden, ihre Beiträge zu steigern und damit im Rang zu steigen und sich mit anderen Benutzen zu vergleichen",
// "Score expiry" => "Score expiry",
// "Unified search index" => "Unified search index",
// "Enables searching for content at the site using a Tiki-managed index" => "Enables searching for content at the site using a Tiki-managed index",
"Enables tags to be set on pages and other items for freeform categorization" => "Erlaubt es Tags auf Seiten und anderen Objekten auf der Website einzutragen und eine Tag-Wolke zur Navigation erstellen zu lassen",
// "Action log" => "Action log",
"Provides the ability to track the actions of users and produce reports on a per-user or per-category basis" => "Erlaubt es die Handlungen von Benutzern zu verfolgen und einen Bericht hierüber pro Benutzer und pro Kategorie zu erstellen",
"Contribution" => "Beitrag",
"Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports" => "Erlaubt es Benutzern den Typ ihres Beitrages festzulegen, während sie ein Objekt bearbeiten. Die Beiträge werden dann farblich kodiert in der Historie und anderen Berichten angezeigt",
"Multilingual" => "Mehrsprachig",
"Enables internationalization features and multilingual support at the site" => "Aktiviert die Internationalisierungsfunktion und mehrsprachige Unterstützung für die gesamte Site",
"Frequently asked questions and answers" => "Häufig gestellte Fragen und Antworten",
"There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs" => "Du kannst stattdessen Wiki Seiten verwenden",
"Surveys" => "Umfragen",
"Create questionnaires with multiple-choice or open-ended questions" => "Umfrage mit multiple-choice- oder offenen Fragen",
"User-submitted Web links" => "Von Benutzern eingereichte Weblinks",
// "Sets of questions that can be presented, with the sessions timed and the scores recorded" => "Sets of questions that can be presented, with the sessions timed and the scores recorded",
// "Featured links" => "Featured links",
"A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc." => "Einfaches Menüsystem, mit dem man optional eine externe Webseite in einem iframe einbinden kann",
"Copyright" => "Copyright",
"Use the Copyright Management System (or ©MS) to display the license of your content" => "Das Copyright-Verwaltungssystem (oder ©MS) ist eine Art, Deinen Inhalt zu lizensieren",
"Wiki references" => "Wiki-Referenzen",
// "Permits using references and the reference library" => "Permits using references and the reference library",
// "Library references" => "Library references",
// "Enforce library reference as master" => "Enforce library reference as master",
// "Reference style" => "Reference style",
// "Default style when using references" => "Default style when using references",
// "AMA citation style (default)" => "AMA citation style (default)",
// "MLA citation style" => "MLA citation style",
// "Display reference in a popover" => "Display reference in a popover",
// "Display the details of the reference in a popover" => "Display the details of the reference in a popover",
"Shoutbox" => "Shoutbox",
"Quick comment (graffiti) box. Like a group chat, but not in real time" => "Box für schnelle Kommentare (graffiti). Wie ein Gruppenchat aber nicht in Echtzeit",
"Live support system" => "Onlinesupport-System",
"One-on-one chatting with customer" => "Eins-zu-Eins chat mit einem Kunden",
// "Tell a friend" => "Tell a friend",
"Add to each page an \"Email this page\" link" => "Füge einen Link \"Diese Seite per E-Mail senden\" in alle Seiten ein",
"Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums" => "Füge einen \"Share\" Link in allen Seiten hinzu, um sie per E-Mail, Twitter, Facebook, Nachricht oder Forum zu versenden",
"Be careful when allowing anonymous users to activate the antibot feature" => "sei vorsichtig, wenn Du anonymen Nutzern erlaubst, die Anti-Bot-Funktion zu nutzen",
"HTML pages" => "HTML-Seiten",
"Static and dynamic HTML content" => "Statischer oder dynamischer HTML Inhalt",
"HTML can be used in wiki pages. This is a separate feature" => "HTML kann in Wiki Seiten benutzt werden. Dies ist eine separate Funktion",
// "Contact us" => "Contact us",
"A basic contact form a visitor can use to contact the site admin" => "Einfaches Formular für Besucher um Administratoren zu kontaktieren",
"Minichat" => "Minichat",
"Real-time group text chatting enabled through a module" => "Echtzeit Gruppen-Textchat",
// "Comments moderation" => "Comments moderation",
"Enables the admin or other authorized group member to validate comments before they are visible" => "Ein Administrator muss einen Kommentar bestätigen, bevor er sichtbar wird",
// "Add author name in From email header" => "Add author name in From email header",
// "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"" => "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"",
// "Comments locking" => "Comments locking",
"Comments can be closed (no comments, or no new comments)" => "Kommentare können geschlossen werden (keine neunen Kommentare)",
// "Allow logged-in users to post comments anonymously" => "Allow logged-in users to post comments anonymously",
"This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement" => "Dies kann benutzt werden, um ehrliches Feedback durch Anonymität zu erzeugen. Z.B. für ein Forum in welchem um Feedback über Missstände oder um interne Verbesserungsvorschläge gebeten wird",
// "Show the page description" => "Show the page description",
"Display the wiki page description between the page title and the page content" => "Zeige die Seitenbeschreibung unter der Überschrift wenn eine Seite angesehen wird",
"Display page name as page title" => "Zeige den Seitennamen als Seitentitel",
"Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title" => "Zeige den Seitennamen am oberen Rand der Seite als Seitentitel. Wenn nicht aktiviert, sollte der Seiteninhalt strukturiert sein um einen Kopf zu beinhalten",
// "Show the page ID" => "Show the page ID",
"Each wiki page has a numeric ID and this can be displayed" => "Zeige die interne Seiten ID, wenn die Seite angesehen wird",
"Individual wiki cache" => "Individueller Wiki Cache",
"Allow users to change the duration of the cache on a per-page basis" => "Erlaubt es Benutzern, die Dauer des Caches auf einer pro-Seite-Basis zu ändern",
// "Date picker for date selection" => "Date picker for date selection",
// "JavaScript popup date selector (uses jQuery UI DatePicker)" => "JavaScript popup date selector (uses jQuery UI DatePicker)",
// "Output should be HTML purified" => "Output should be HTML purified",
"This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results" => "Dies aktiviert den HTML-Reiniger bei Ausgaben, um potentiell verbleibende Sicherheitsrisiken wie XSS auszufiltern",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Full screen" => "Vollbild",
"Allow users to activate full-screen mode" => "Benutzer darf Fullscreen-Anzeige aktivieren",
// "CSS menus" => "CSS menus",
"Use CSS-styled (Suckerfish) vertical and horizontal menus" => "CSS Menüs (suckerfish)",
"Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)" => "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)",
// "Quick permission assignment" => "Quick permission assignment",
"Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object" => "Schnelle Rechte erlauben Klassen mit Rechten zu definieren und Objekten zu gewähren",
// "User encryption" => "User encryption",
// "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored" => "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored",
// "Enable personal, secure storage of sensitive data such as passwords" => "Enable personal, secure storage of sensitive data such as passwords",
// "This is an experimental feature. Using it may cause loss of the encrypted data" => "This is an experimental feature. Using it may cause loss of the encrypted data",
// "Password domains" => "Password domains",
// "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself" => "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself",
// "HTML purifier" => "HTML purifier",
"If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results." => "Wenn Du HTML in Deinen Seiten benutzt und es ausgefiltert wird, solltest Du prüfen, ob es sich um gültigen HTML-Code handelt. Alternativ kann diese Funktion deaktiviert werden.",
"Ajax" => "Ajax",
// "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work" => "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work",
// "This feature is required for the interface for many features to work properly" => "This feature is required for the interface for many features to work properly",
"Webmail" => "Webmail",
"Intertiki" => "Intertiki",
"Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Erlaubt es verschiedenen Tiki Sites (untergeordneten Sites) ihre Authentifikation von der Hauptseite zu erhalten",
"Mail-in" => "Mail-in",
"Create and publish wiki pages and articles via email" => "Fülle Wiki Seiten und Artikel durch E-Mail",
"Mindmap" => "Mindmap",
// "Display in a graphical way the connection among wiki pages" => "Display in a graphical way the connection among wiki pages",
"Print indexed" => "Indexiert drucken",
"Generate a printable version of the whole wiki or a subset of pages, filtered by category" => "Indexiert drucken",
"Spreadsheet" => "Tabellen",
"Spreadsheets with calculations and charts" => "Datentabellen mit Berechnungen und Diagrammen",
// "Slideshow (reveal.js)" => "Slideshow (reveal.js)",
"Create simple presentations via Wiki Syntax" => "Webbasierte Diashow",
// "Slideshow (reveal.js) PDF export" => "Slideshow (reveal.js) PDF export",
"Wiki-page-based slideshow to pdf export" => "Webbasierter Diashow-zu-pdf-Export",
"Invoice" => "Rechnung",
"Invoice system" => "Rechnungssystem",
// "Full WYSIWYG editor" => "Full WYSIWYG editor",
"WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience" => "WYSIWYG ist ein Akronym und steht für for What You See Is What You Get (Was Du siehst, bekommst Du). Benutzt CKEditor",
// "Kaltura video management" => "Kaltura video management",
"Integration with the Kaltura video management platform" => "Integration zur Kaltura Video-Verwaltungsplattform",
// "Friendship network" => "Friendship network",
"Users can identify other users as their friends" => "Benutzer kann andere Benutzer als seine Freunde identifizieren",
"Banning system" => "Benutzersperrsystem",
"Deny access to specific users based on username, IP, and date/time range" => "Zugriff für bestimmten Benutzer nach Benutzername, IP und Datum/Zeit verweigern",
"Stats" => "Statistiken",
"Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Zeichnet einfache Statistiken zu Hauptfunktionen von Tiki auf (Anzahl von Wiki Seiten, Größe von Dateiarchiven, etc.)",
// "Action calendar" => "Action calendar",
"Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page." => "Zeigt einen Kalender mit Systemereignissen, so wie Veränderungen von Wiki Seiten, Forumposts und Veröffentlichungen von Artikeln. Tage mit Ereignissen beeinhalten einen Link zum jeweiligen Ereignis.",
"Referrer stats" => "Referer-Statistik",
"Record domain name of sites that send visitors to this Tiki" => "Zeichnet Domänennamen der Sites auf, von denen Besucher zu dieser Tiki gelangen",
"Redirect on error" => "Bei Fehler wieder verbinden",
"On an error, refresh to the homepage as specified on the Admin General page" => "Gehe bei einem Fehler zur Homepage, wie unter Verwalten->Allgemein konfiguriert, zurück",
"Communications (send/receive objects)" => "Kommunikation (Objekte senden/empfangen)",
"Send/receive wiki pages and articles between Tiki-powered sites" => "Sende/empfange Wiki Seiten und Artikel zwischen Tiki-powered Sites",
"Display \"My Account\" in the application menu" => "'MeinTiki' im Anwendungsmenü anzeigen",
// "Mini calendar" => "Mini calendar",
// "Displays a personal calendar for each user" => "Displays a personal calendar for each user",
// "User preferences screen" => "User preferences screen",
// "User notepad" => "User notepad",
// "My bookmarks" => "My bookmarks",
// "User contacts" => "User contacts",
// "User watches" => "User watches",
// "Receive email notification of changes. Each user can choose to be notified of changes to specific items" => "Receive email notification of changes. Each user can choose to be notified of changes to specific items",
// "Group watches" => "Group watches",
// "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group" => "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group",
// "Daily reports for user watches" => "Daily reports for user watches",
// "Allows you to schedule daily reports of watches to be sent (batched) at specific times" => "Allows you to schedule daily reports of watches to be sent (batched) at specific times",
// "User watches translations" => "User watches translations",
// "User watches languages" => "User watches languages",
"Watch language-specific changes within a category" => "Beobachte sprachspezifische Änderungen innerhalb einer Kategorie",
// "User menu" => "User menu",
"Unmaintained feature" => "vernachlässigte Funktion",
// "User tasks" => "User tasks",
"User messages" => "Benutzernachrichten",
// "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group)." => "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group).",
// "User files" => "User files",
"Menu user levels" => "Menü per Benutzer konfigurieren",
"Enables control of the per-group visibility of menu options" => "Erlaubt es Menüoptionen einzustellen, die von Benutzern gesehen werden können",
// "Group alert" => "Group alert",
"Integrator" => "Integrator",
"XMLRPC API" => "XMLRPC-API",
"Debugger console" => "Debug-Konsole",
// "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions" => "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions",
// "Only viewable by admins" => "Only viewable by admins",
// "Not suitable for production use" => "Not suitable for production use",
"TikiTests" => "TikiTests",
"Permits recording and playback of functional tests" => "Erlaubt es funktionale Test aufzuzeichnen und wiederzugeben",
"Check for updates automatically" => "Automatisch nach neuer Version suchen",
"Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection" => "Tiki prüft auf Aktualisierungen, wenn Du auf die Hauptverwaltungsseite zugreifst",
// "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters" => "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters",
// "Require confirmation of an action if a possible CSRF is detected" => "Require confirmation of an action if a possible CSRF is detected",
// "Deprecated. Using may cause false errors" => "Deprecated. Using may cause false errors",
"Detect browser language" => "Sprache des Clients abfragen",
"Look up the user's preferred language through browser preferences" => "Schlage die bevorzugte Benutzersprache in den Browsereinstellungen des Benutzers nach",
"Show pages in user's preferred language" => "Zeige Seiten in der vom Benutzer bevorzugten Sprache",
"When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences" => "Wenn eine Seite zugegriffen wird, welche eine gleichwertige Übersetzung in der vom Benutzer bevorzugten Sprache enthält, bevorzuge die übersetzte Seite",
// "Synchronize page and site language" => "Synchronize page and site language",
"Changing the page language also changes the site language" => "Die Änderungen der Seitensprache ändert auch die Site-Sprache",
"Translation assistant" => "Übersetzungsassistent",
"Track translation operations between pages" => "Verfolge Übersetzungen zwischen Seiten",
"Urgent translation notifications" => "Dringende Übersetzungsnachricht",
// "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users" => "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users",
"Incomplete translation notice" => "Nachricht bei unvollständiger Übersetzung",
"When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete" => "Wenn eine Seite in eine neue Sprache übersetzt wird, wird automatisch eine Nachricht in diese Seite eingefügt um anzuzeigen, dass die Übersetzung noch nicht vollständig ist",
"Multilingual structures" => "Mehrsprachige Strukturen",
"Structures search for equivalent pages in other languages" => "Strukturen sollen in gleichwertigen Seiten in anderen Sprachen suchen. Kann Leistungsprobleme in großen Strukturen verursachen",
// "May cause performance problems with larger structures" => "May cause performance problems with larger structures",
"Display all languages in a single page" => "Zeige alle Übersetzungen in einer einzelnen Seite",
"List all languages as options in the page-language dropdown list, to see them all at once" => "Liste alle Sprachen als Option im Ausklapplistenfeld der Seite auf um alle Sprachen auf einmal zu sehen",
"GZip output" => "GZip-Ausgaben",
"Compress your pages on-the-fly, if the requesting browser supports this" => "Komprimiere Seiten direkt (on the fly), wenn der anfordernde Browser dies unterstützt",
// "Help system" => "Help system",
// "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/" => "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/",
"Smileys" => "Smileys",
"Also known as emoticons" => "Auch bekannt als Emoticons",
// "Tagging users" => "Tagging users",
// "Add support for @username mentions" => "Add support for @username mentions",
// "User mention notifications" => "User mention notifications",
// "Add support for @username mentions notifications" => "Add support for @username mentions notifications",
// "Draw (SVG edit)" => "Draw (SVG edit)",
"Draw enables creating and editing SVG images in all wiki text areas" => "Zeichnen gibt Dir die Möglichkeit, SVG Bildateien überall in Tiki zu bearbeiten",
// "Draw (SVG edit) hide buttons" => "Draw (SVG edit) hide buttons",
"Hide buttons in Draw, HTML id, comma-separated" => "Verstecke Schaltflächen in Tiki Zeichnen, HTML ID, kommatagetrennt.  Beispiel: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"" => "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"",
// "Separate base image" => "Separate base image",
// "Leaves the initially edited image as a separate file and stores the drawing separately" => "Leaves the initially edited image as a separate file and stores the drawing separately",
// "Draw in user file gallery" => "Draw in user file gallery",
"Docs (WebODF)" => "Dokumente (WebODF)",
"Docs enables viewing and editing Open Document Format files" => "Dokumente ermöglicht das Ansehen/die Bearbeitung von Dateien im Open Dokument Format",
// "Dynamic content system" => "Dynamic content system",
"Block of content which can be reused and programmed (timed)" => "Inhaltsblock, der wiederholt genutzt werden und programmiert werden kann (zeitlich angepasst)",
// "Use file galleries to store images" => "Use file galleries to store images",
"If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead" => "Wenn deaktiviert werden Bilder unter ../img/wiki_up/.. gespeichert",
"External link icon" => "Symbole für externe Links",
// "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set" => "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set",
// "Add \"rel=nofollow\" to external links" => "Add \"rel=nofollow\" to external links",
"Semantic links" => "Semantische Links",
"Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages" => "Über Backlinks hinausgehende Möglichkeit semantische Verbindungen zwischen Wiki Seiten herzustellen",
// "Web services" => "Web services",
"Can receive web services via JSON or YAML" => "Kann Webdienste in JSON oder YAML konsumieren",
"Use folder icons for menu section (parent) items" => "Menüs als Ordner darstellen",
// "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)" => "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)",
"Breadcrumbs" => "Brotkrumen",
"Indicates the navigation path through parent pages to the current page" => "Versucht Dir zu zeigen, wo Du Dich befindest",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonyme Editoren müssen Anti-Robot Code (CAPTCHA) eingeben",
// "Use CAPTCHA to ensure that anonymous input is from a person" => "Use CAPTCHA to ensure that anonymous input is from a person",
"Protect email against spam" => "E-Mailadressen vor Spam schützen",
// "Protect email against spam submissions" => "Protect email against spam submissions",
"Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Schützt E-Mail gegen Spam. Funktioniert gegenwärtig nicht auf Wiki Seiten, die im WYSIWYG-Modus bearbeiet wurden (Tiki 6.1)",
// "Site ads" => "Site ads",
// "Enable advertising" => "Enable advertising",
// "Activate will display content for Admin only. Select Publish to display for all users" => "Activate will display content for Admin only. Select Publish to display for all users",
"Anonymous voting" => "Anonymes Abstimmen",
"Allow anonymous users to participate in voting" => "Gestatte, dass anonyme Benutzer mitstimmen können",
// "This can be overridden by specific permissions" => "This can be overridden by specific permissions",
"Allow re-voting" => "Nochmaliges Abstimmen zulassen",
// "Visitors can vote mulitiple times in a poll" => "Visitors can vote mulitiple times in a poll",
// "When logged in, Tiki tracks users by username or otherwise IP address" => "When logged in, Tiki tracks users by username or otherwise IP address",
"Comments for polls" => "Kommentare für Abstimmungen",
"Comments for FAQs" => "Kommentare für FAQs",
"Search engine friendly URL" => "Suchmaschinenfreundliche URL",
"If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config" => "Wenn Du Apache Webserver benutzt, dann kannst Du die Datei _htaccess in .htaccess umkopieren, um kurze URLs zu erhalten. Auf einem IIS musst Du hierfür web_config in web.config umkopieren",
// "SEFURL postfilter" => "SEFURL postfilter",
// "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead" => "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead",
// "Article title in SEFURL" => "Article title in SEFURL",
// "The article title rather than article number can be displayed in the search engine friendly URL" => "The article title rather than article number can be displayed in the search engine friendly URL",
// "Blog title in SEFURL" => "Blog title in SEFURL",
// "The blog title rather than blog number can be displayed in the search engine friendly URL" => "The blog title rather than blog number can be displayed in the search engine friendly URL",
// "Display forum thread or forum post title in the search engine friendly URL" => "Display forum thread or forum post title in the search engine friendly URL",
// "Tracker title in SEFURL" => "Tracker title in SEFURL",
// "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`" => "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`",
// "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)" => "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)",
// "Limit the number of characters in the tracker item or forum thread title" => "Limit the number of characters in the tracker item or forum thread title",
"Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Schreibe tiki-view_tracker.php?itemId=yyy neu um Seite mit yyy zu präfixen",
"This redirection uses the wiki prefix alias feature" => "Diese Weiterleitung benutzt die Wiki Präfixalias-Funktion",
"Canonical URL tag" => "Tag für kanonische (wahre) URL",
"Indicates to search engines which URL to use, to prevent duplicate listings" => "Gibt für Suchmaschinen an, welche URL genutzt werden soll, um doppelte Auflistung zu verhindern",
// "Canonical URL domain" => "Canonical URL domain",
// "Custom Routes" => "Custom Routes",
// "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL" => "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL",
"Show module controls" => "Zeige Modulkontrolle",
// "Enable controls in modules" => "Enable controls in modules",
"Perspectives" => "Perspektiven",
"Permits overriding of preferences" => "Erlaubt es Präferenzen zu überschreiben",
"Search and replace" => "Suchen und ersetzen",
"Enables finding and replacing of content in the edit box" => "Erlaubt es Inhalte in einer Bearbeitenbox zu finden und zu ersetzen",
"Submissions" => "Einreichungen",
"Articles can be submitted but need to be approved before they are published." => "Einreichungen werden eingesendet, müssen aber noch vor Veröffentlichung bestätigt werden",
// "Users can see several charts or rankings about the item" => "Users can see several charts or rankings about the item",
"Comments on articles" => "Kommentare für Artikel",
// "Users with permission can post or reply to comments. The comments will appear at the bottom of the page" => "Users with permission can post or reply to comments. The comments will appear at the bottom of the page",
"Article content templates" => "Artikel Inhaltsvorlagen",
"Predefined content for an article" => "Vordefinierter Inhalt für Nachrichtenartikel",
"template article news" => "Vorlage Nachrichtenartikel",
// "Print articles" => "Print articles",
"Specify notification emails when creating articles" => "Spezifiziere Benachrichtigungs-E-Mails, wenn Artikel erstellt werden",
// "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation" => "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation",
"ShareThis buttons" => "ShareThis-Schaltfläche",
// "Enable sharing site content via ShareThis" => "Enable sharing site content via ShareThis",
"Insert a ShareThis button from [http://www.sharethis.com]" => "Füge eine ShareThis-Schaltfläche von [http://www.sharethis.com] ein",
// "Category path" => "Category path",
"Show the category tree above the wiki page" => "Zeige den Kategorienbaum überhalb von Wiki Seiten",
"Show category objects" => "Zeige Kategorieobjekte",
"Show, at the bottom of the wiki page, objects in the same category" => "Zeige Kategorieobjekte unterhalb einer Wiki Seite, welche der gleichen Kategorie zugeordnet sind",
"Ignore category viewing restrictions" => "Kategorie-Sichteinschränkungen ignorieren",
// "Display items the user may not be entitled to view in search results" => "Display items the user may not be entitled to view in search results",
"Will improve performance, but may show forbidden results" => "Verbessert die Leistung. Zeigt jedoch möglicherweise verbotenen Ergebnisse",
"List pages" => "Seiten auflisten",
// "Allow viewing the wiki page list" => "Allow viewing the wiki page list",
// "Latest changes" => "Latest changes",
// "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display." => "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display.",
"Orphan pages" => "Verwaiste Seiten",
// "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)" => "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)",
"MySQL full-text search" => "MySQL Volltextsuche",
"Referer search highlighting" => "Hervorhebung der Suchbegriffe auf den gefundenen Seiten",
// "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility" => "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility",
"Search statistics" => "Suchstatistik",
// "Enables administrators to collect and view statistics on search activity" => "Enables administrators to collect and view statistics on search activity",
"Ignore individual object permissions" => "Individuelle Objektberechtigungen ignorieren",
"Object filter" => "Objektfilter",
"Enables object type filters to be displayed above the search results to further reduce search results by object type" => "gestatte das filtern von Objekten",
"Search box" => "Suchbox",
// "Shows a search box above the search results to do additional searches" => "Shows a search box above the search results to do additional searches",
// "Include the number of visits in the search results" => "Include the number of visits in the search results",
"Relevance" => "Relevanz",
// "Display Tiki's estimate of the relevance of search matches in the search results" => "Display Tiki's estimate of the relevance of search matches in the search results",
"Object type" => "Objekttyp",
// "Shows object type filters above the search results to further reduce search results by object type" => "Shows object type filters above the search results to further reduce search results by object type",
"Last-modified date" => "Zuletzt verändert (Datum)",
// "Show the last-modified date in search results" => "Show the last-modified date in search results",
// "Users can see several charts or rankings about the page" => "Users can see several charts or rankings about the page",
"Custom blog headings" => "Benutzerdefinierte Blogüberschriften",
"Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead" => "Die Benutzung von benutzerdefinierten Blog-Überschriften verbraucht deutlich mehr Serverressourcen. Solange Du nicht eine Vorlage pro Blog benötigst solltest Du eine angepasste Vorlagen-Datei benutzen",
"Publish dates can be modified" => "Veröffentlichungsdaten können verändert werden",
// "Blog post Comments" => "Blog post Comments",
// "Users can view the “top” or “most” downloaded files" => "Users can view the “top” or “most” downloaded files",
// "File gallery comments" => "File gallery comments",
// "Store user files in a file gallery" => "Store user files in a file gallery",
// "Use the file gallery admin and the individual file gallery settings to manage file storage preferences" => "Use the file gallery admin and the individual file gallery settings to manage file storage preferences",
// "userfiles" => "userfiles",
"Use file galleries for wiki attachments" => "Benutze Dateiarchive für Wiki Anhänge",
// "Wiki attachments will be stored in the file gallery" => "Wiki attachments will be stored in the file gallery",
"Batch uploading" => "Stapelhochladen (batch upload)",
// "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature" => "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature",
"Accept wiki syntax" => "Wiki-Syntax erlauben",
"Topic archiving" => "Themenarchivierung",
"Quick jumps" => "Schnellsprünge",
"Replies are empty" => "Antworten sind leer",
"If disabled, replies will quote the original post" => "Wenn die Funktion ausgeschaltet ist, werden in den Antworten die Originalposts zitiert",
// "Allows quoting in flat forums" => "Allows quoting in flat forums",
// "Allows users to reply" => "Allows users to reply",
"First post of a thread can have an empty body" => "Der erste Post eines Threads darf keinen leeren Text haben",
"Will be a thread title" => "Dies wird dann der Threadtitel sein.",
"Forum name search" => "Forum Namenssuche",
"When listing forums" => "Wenn Foren aufgelistet werden",
"Forum content search" => "Foren Inhaltssuche",
"Topic content search" => "Themen Inhaltssuche",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Index posts on forum section change" => "Index posts on forum section change",
// "Re-indexes forum posts to match the parent section when the section is changed" => "Re-indexes forum posts to match the parent section when the section is changed",
"Edit CSS" => "CSS bearbeiten",
// "Edit CSS files directly in the browser" => "Edit CSS files directly in the browser",
// "May not be functional in Tiki 14+" => "May not be functional in Tiki 14+",
"Theme Control" => "Themekonfiguration",
"Assign different themes to various sections, categories, and objects." => "Weise verschiedene Themes verschiedenen Abschnitten, Kategorieren und Objekten zu",
"design themes" => "Design-Themes",
// "Tiki template viewing" => "Tiki template viewing",
"Edit templates" => "Vorlagen bearbeiten",
// "Custom HTML head content" => "Custom HTML head content",
// "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here" => "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here",
// "Add base tag in the HTML head section" => "Add base tag in the HTML head section",
// "The base tag specifies a default address for all links on a page" => "The base tag specifies a default address for all links on a page",
"Site logo and title" => "Site Logo und Titel",
// "Display a site logo image and/or title in the page header area" => "Display a site logo image and/or title in the page header area",
"This setting is expected to be moved from here to the admin-modules page" => "Wird wahrscheinlich in Module integriert und dann obsolet werden",
"Left column" => "Linke Spalte",
"Controls visibility of the left column of modules" => "Einstellung zur Sichtbarkeit der linken Modulspalte",
"sidebar" => "Seitenbalken",
"Only if one or more modules are assigned" => "Nur wenn Module",
"Always" => "Immer",
"User decides" => "Benutzer wählt",
"Right column" => "Rechte Spalte",
"Controls visibility of the right column of modules" => "Einstellung zur Sichtbarkeit der rechten Modulspalte",
"Prefix breadcrumbs with \"Location : \"" => "Stelle Brotkrumen \"Location : \" voran",
// "Place the term \"Location:\" in the breadcrumbs" => "Place the term \"Location:\" in the breadcrumbs",
"Site location bar" => "Position des Brotkrumen-Balkens",
"Use breadcrumbs module" => "Benutze Brotkrumen-Modul",
"Top of center column" => "Kopfteil der mittleren Spalte",
// "Larger font" => "Larger font",
"Entire location" => "Gesamter Ort",
"Page name" => "Seitenname",
"Use page description" => "Seitenbeschreibung benutzen",
"Extreme top of page, above the site logo, etc" => "Seitenkopf",
// "Custom code just before the closing </body> tag" => "Custom code just before the closing </body> tag",
// "Enter lines here to be placed near the end of the HTML file" => "Enter lines here to be placed near the end of the HTML file",
"Webmaster report" => "Webmaster Bericht",
// "Activate the feature to report a problematic page to the webmaster." => "Activate the feature to report a problematic page to the webmaster.",
"Webmaster email" => "Webmaster E-Mail",
"Leave blank to use the default sender email" => "Leer lassen, um die Standard-Absender-E-Mail-Adresse zu verwenden",
// "A specific email address can be set for receiving the webmaster reports" => "A specific email address can be set for receiving the webmaster reports",
"Email this page" => "Diese Seite per E-Mail verschicken",
"Adds a link at the bottom if set, otherwise adds a link at the top" => "Füge einen Link am unteren Rand ein, wenn eingestellt, sonst füge den Link am oberen Rand ein",
// "This enables users to share a page with others, by emailing a short message and link to the page" => "This enables users to share a page with others, by emailing a short message and link to the page",
"Shadow layer" => "Schattenschichten",
"Additional div elements for shadows, radiused corners or other decorative styling" => "Zusätzliche Schichten für Schatten, abgerundete Ecken oder andere dekorative Veränderungen",
"Tooltips" => "Tooltips",
// "Enable tooltips such as this to have a custom appearance, styled by CSS" => "Enable tooltips such as this to have a custom appearance, styled by CSS",
"Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc" => "Stellt diverse Ausklappmenüs in vielen Texteingabeboxen zur Verfügung für Seitennamen, Benutzernamen, Gruppen, Tags etc",
"Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
"Reflection" => "Reflektion",
// "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"" => "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"",
"JQuery UI" => "JQuery UI",
"Include jQuery UI library. Enables a number of interface features" => "Bindet jQuery UI-Bibliothek ein. Aktiviert viele Benutzerinterfacefunktionen",
"jQuery UI theme" => "jQuery UI theme",
"jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc" => "jQuery UI theme. Beispielsweise in Tabellenkalkulation benutzt",
"Validation" => "Validierung",
"Provides various validation possibilities such as for trackers" => "Stellt verschiedene Validierungsmöglichkeiten zur Verfügung, so wie in Trackern",
// "jQuery infinite carousel" => "jQuery infinite carousel",
// "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel" => "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel",
// "jQuery sortable tables" => "jQuery sortable tables",
// "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables" => "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables",
// "jQuery media" => "jQuery media",
// "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used" => "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used",
// "TagCanvas" => "TagCanvas",
// "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud" => "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud",
// "jQuery zoom" => "jQuery zoom",
// "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"" => "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"",
// "Use tabs" => "Use tabs",
"Separates page content into tabbed panels" => "Verkleinert Seiten durch Aufteilung der Inhalte in Tabs",
"Wiki content templates" => "Wiki Inhaltsvorlagen",
"Prewritten content (probably partial content) for a wiki page" => "Vordefinierter Inhalt für eine Wiki Seite",
"Warn on edit conflict" => "Bei Bearbeitenkonflikt warnen",
"When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages" => "Tiki wird Benutzer warnen, die versuchen, eine Seite zu bearbeiten, die bereits von einem anderen Benutzer bearbeitet wird",
"Undo" => "Rückgängig",
"Footnotes" => "Fußnoten",
"Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages." => "Erstelle private Notizen für eine Seite, die nur vom Autor selbst angesehen werden kann",
"Allow HTML" => "HTML erlauben",
// "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code",
// "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus" => "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus",
"Log bytes changes (+/-) in action logs" => "Logge Byte-Änderungen (+/-) in Action Logs",
"May impact performance" => "Könnte die Performance beeinträchtigen",
"Sandbox" => "Sandbox",
// "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved" => "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved",
"Comments below wiki pages" => "Kommentare unter Wikiseiten",
"Allow users to upload images to a page" => "Erlaubt es Benutzern Bilder zu einer Seite hochzuladen",
// "Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)" => "Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)",
"WikiWords" => "WikiWorte",
// "Automatically convert \\\"CamelCase\\\" words into wiki links" => "Automatically convert \\\"CamelCase\\\" words into wiki links",
"Link plural WikiWords to their singular forms" => "Mehrzahl-WikiWords auf ihre Einzahl-Variante verlinken",
"Accept dashes and underscores in WikiWords" => "Binde- und Unterstriche in WikiWords erlauben",
"History" => "Historie",
// "Users (with permission) can see the history of each wiki page" => "Users (with permission) can see the history of each wiki page",
"Display IP address" => "Zeige IP Adresse",
// "Wiki full history" => "Wiki full history",
"Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Speichere alle Versionen und nicht nur wenn der Seiteninhalt, die Beschreibung oder ein Bearbeitungskommentar geändert wurde",
"View page contributions by author" => "Zeige Seitenmitwirkung nach Autor",
"Visualize the contributions that different authors have made to a wiki page" => "Visualisiere Beiträge zu einer Wiki Seite durch verschiedene Autoren",
"Discuss pages on forums" => "Seiten im Forum diskutieren",
// "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page" => "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page",
"View source" => "Quelltext ansehen",
// "Users (with permission) can see the wiki and/or HTML syntax of the page" => "Users (with permission) can see the wiki and/or HTML syntax of the page",
// "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”" => "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”",
// "Present a list of pages that link to the current page" => "Present a list of pages that link to the current page",
"Similar pages" => "Ähnliche Seiten",
// "Display a list of pages named similarly to the current page" => "Display a list of pages named similarly to the current page",
"Structures" => "Strukturen",
// "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document" => "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document",
"Structures drill down menu" => "Drilldown-Menü für Strukturen",
"Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down" => "Drilldown-Menü für Strukturen (Ajax-Stil)",
"Open page as structure" => "Seite als Struktur öffnen",
// "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL" => "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL",
"Make structure from page" => "Struktur aus einer Seite entnehmen",
// "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure" => "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure",
"Categorize structure pages together" => "Kategoriesiere Strukturseiten zusammen",
// "Place new pages of a structure in the same category as the structure's root page" => "Place new pages of a structure in the same category as the structure's root page",
// "Disable inherited direct object permissions" => "Disable inherited direct object permissions",
"Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure" => "Normalerweise erben Seiten Objektberechtigungen von ihrer übergeordneten Seite (parent page). Jedoch überschreiben Objektberechtigungen Kategorieberechtigungen. Wenn Sie also in Strukturen auf Kategorieberechtigungen vertrauen wollen, können Sie diese Einstellung in Betracht ziehen, um das Vererben von direkten Objektberechtigungen zu deaktivieren, wenn Seiten aus einer Struktur hinzugefügt werden",
"Create webhelp from structure" => "Erzeuge Webhilfe aus einer Struktur",
// "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format" => "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format",
"Import HTML" => "HTML importieren",
"Enable import of HTML pages." => "gestatte das importieren von HTML-Seiten",
"Use date parameter" => "Benutze Datumsparameter",
// "Allow wiki page version to be selected from a parameter \"date\" on the url" => "Allow wiki page version to be selected from a parameter \"date\" on the url",
"Report it in wiki links" => "Berichte es in Wiki Links",
// "Add the date parameter to wiki links" => "Add the date parameter to wiki links",
"Import pages" => "Importiere Seiten",
"A personal wiki page for each user" => "Eine persönliche Seite für den Benutzer selbst",
"Userpage prefix" => "Präfix für Benutzerseiten",
"All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required" => "Alle Benutzerseiten haben ein gemeinsames, allgemein gültiges Präfix. Die Verknüpfung von Präfix und Benutzernamen erstellt den Dateinamen. Der Präfix darf nicht leer sein",
"Users can lock pages" => "Benutzer können ihre Seiten schliessen",
// "Enable users to lock pages and so prevent others from editing them" => "Enable users to lock pages and so prevent others from editing them",
"MultiPrint" => "Mehrfachdruck",
// "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document" => "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document",
// "Print Wiki" => "Print Wiki",
// "Provide a print icon and layout of the wiki page formatted for printing" => "Provide a print icon and layout of the wiki page formatted for printing",
"Pages not in structure" => "Seiten, die in keiner Struktur sind",
// "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display" => "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display",
"Attachments" => "Anhänge",
"Allow users to upload (attach) files to a page" => "Erlaubt es Benutzern Dateien zu einer Seite hochzuladen und anzuhängen",
// "Limit wiki page categories to those under this category" => "Limit wiki page categories to those under this category",
"If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"." => "Wenn Du eine Fehlermeldung erhältst, dass eine Kategorie für die Bearbeitung einer Wiki-Seite erforderlich ist, dann solltest Du ggf. diese Auswahl auf Keine stellen.",
// "Show/hide icon before headings" => "Show/hide icon before headings",
// "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below" => "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below",
"Wiki argument variables" => "Wiki Argumentvariablen",
"Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Erlaube Abfragevariablen innerhalb von Wiki Inhalten mit {{paramname}} oder {{paramname|default}} - Sonderfall {{page}} {{user}}",
"Users can choose to stay in SSL mode after an HTTPS login" => "Benutzer darf nach HTTPS Login wahlweise mit SSL fortfahren",
"Users can switch between secured or standard mode at login" => "Benutzer darf zwischen HTTPS und normalem Login wählen",
"Wiki paragraph formatting" => "Wiki Absatzformatierung",
"Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "</br>Weil die Wiki Absatzformatierung <b>eingeschaltet</b> ist, werden alle Gruppen mit nicht leeren Zeilen zu einem Absatz zusammengefasst. Zeilen können jede Länge haben und werden zusammen auf die nächste Zeile umbrochen. Absätze werden durch leere Zeilen voneinander getrennt.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "</br>Weil die Wiki Absatzformatierung <b>ausgeschaltet</b> ist, wird jede Textzeile so angezeigt, wie sie geschrieben wurde. D.h., dass Du jeden Absatz, der auch als solcher erhalten bleiben soll, den gesamten Text ohne Zeilenumbrüche schreiben musst.",
// "Create line breaks within paragraphs" => "Create line breaks within paragraphs",
// "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs" => "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs",
"Automonospaced text" => "Blockschrift durch Einrücken",
// "Lines indented with spaces will automatically be converted to monospace font" => "Lines indented with spaces will automatically be converted to monospace font",
"Tables syntax" => "Tabellensyntax",
"|| for rows" => "|| für Spalten",
"<return> for rows" => "\\n für Spalten",
"AutoLinks" => "URLs in Links verwandeln",
"Web (http://) and email addresses will automatically be converted to links" => "Tiki konvertiert automatisch http:// und E-Mailadressen in Links",
"Hotwords" => "Hotwords",
"Open hotwords in new window" => "Öffne Hotwords in einem neuen Fenster",
"Characters that limit a hotword" => "Zeichen, die ein Hotword beschränken",
"Use Quote plugin rather than \">\" for quoting" => "Benutze Zitatplugin anstelle von \">\" für Zitate",
// "Center text using ::: instead of :" => "Center text using ::: instead of :",
// "Useful to avoid conflicts with C++ scope operators or default namespace separator" => "Useful to avoid conflicts with C++ scope operators or default namespace separator",
"String to use to delimit simplebox" => "String zur Begrenzung von Simplebox",
"Users can choose to show their gender" => "Benutzer kann auswählen, sein Geschlecht zu zeigen",
"Real name" => "Echtname",
"Gender" => "Geschlecht",
// "Profile picture (avatar)" => "Profile picture (avatar)",
"Country" => "Land",
"Last login" => "Letzte Anmeldung",
"Distance" => "Entfernung",
"Manual selection of time/date" => "Manuelle Auswahl von Zeit/Datum",
"WebDAV access to Tiki" => "WebDAV Zugang zu Tiki",
"Allow file gallery access with WebDAV" => "Erlaubt den Zugriff auf Dateiarchive mit WebDAV",
"use tiki-webdav.php as the URI of the WebDAV repository" => "benutze tiki-webdav.php als URL des WebDAV Repositoriums",
"Fixed width" => "Feste Breite",
"Restrict the width of the site content area, in contrast to a liquid (full-width) layout" => "Beschränkt die Breite der Site",
"Social networks" => "Soziale Netzwerke",
"Integration with social applications and networks like Twitter and Facebook" => "Integration mit verschiedenen sozialen Netzwerken wie Twitter oder Facebook",
// "Group transition" => "Group transition",
"Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Aktiviert Übergänge für Benutzer zwischen verschiedenen Gruppen. Übergänge erstellen einen Benutzerbestätigungsarbeitsablauf",
// "Category transition" => "Category transition",
"Enables transitions for objects between different categories. Transitions will create a document workflow" => "Aktiviert Übergänge für Objekte zwischen verschiedenen Kategorien. Übergänge erzeugen einen Dokumentenarbeitsablauf",
// "Tiki user credits" => "Tiki user credits",
"Invite users" => "Lade Benutzer ein",
"Allow users to invite new users to register at this site, by sending an email." => "Erlaube Benutzern andere Benutzer einzuladen, sich bei dieser Tiki zu registrieren",
"Alternate registration page" => "Alternative Registrierungsseite",
"Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page" => "Führt dazu, dass jeder Zugriff tiki-register.php zu einer alternativen Seite zur Registrierung weitergeleitet wird",
"Load balancer" => "Last Verteiler",
"Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server" => "Aktiviere dies nur, wenn der Server hinter einem Ausgleichsregler (umgekehrter Proxy) liegt. Dies erlaubt Tiki die IP des Benutzers anstelle der des Proxyservers zu loggen",
// "Tiki is behind a frontend-proxy/load-balancer that rewrites ports" => "Tiki is behind a frontend-proxy/load-balancer that rewrites ports",
// "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links" => "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links",
"Accounting" => "Buchhaltung",
"Double-entry accounting system" => "Doppeltes Buchführungssystem",
// "Code editor (CodeMirror)" => "Code editor (CodeMirror)",
// "CodeMirror code editor, which provides syntax highlighting" => "CodeMirror code editor, which provides syntax highlighting",
"Syntax highlighter (CodeMirror) Theme" => "Theme für Syntaxhervorhebung (CodeMirror)",
"CodeMirror themes (clear cache after changing)" => "CodeMirror-Themes (löschen den Cache, wenn Du dies änderst)",
"default" => "standard",
// "Off (but switchable)" => "Off (but switchable)",
"Dummy preference" => "Dummy Präferenz",
"This is useful for developers to learn how to create a new preference. HTML may be used" => "Dies ist für Entwickler hilfreich, um zu lernen, wie neue Einstellungen erstellt werden",
"This is the detail." => "Das ist das Detail.",
"This is the warning." => "Das ist die Warnung.",
"This is the hint. Wiki syntax may be used" => "Das ist der Hinweis.",
"This is the shorthint. Wiki syntax may be used" => "Das ist der Kurzhinweis.",
// "Time sheet" => "Time sheet",
"A project time manager" => "Eine Zeitverwaltung für Projekte",
// "This feature will be removed after Tiki18 and before Tiki19" => "This feature will be removed after Tiki18 and before Tiki19",
// "HTML feed" => "HTML feed",
"A way to transfer HTML content from one Tiki site to another" => "Ein Weg HTML-Stückchen zwischen verschiedenen Sites hin- und herzuschieben",
// "Send an email notification to group leaders when a user joins" => "Send an email notification to group leaders when a user joins",
// "Send an email notification to group leaders when a user leaves" => "Send an email notification to group leaders when a user leaves",
// "Inline comments" => "Inline comments",
// "Contextual comments" => "Contextual comments",
// "Enable JavaScript plugin for equal-height rows" => "Enable JavaScript plugin for equal-height rows",
// "Enable responsive rows, the contained elements of which have the same height" => "Enable responsive rows, the contained elements of which have the same height",
// "Conditional formatting" => "Conditional formatting",
// "Use different coloring for certain system objects. Only groups are supported for now" => "Use different coloring for certain system objects. Only groups are supported for now",
// "Store session variable for current theme" => "Store session variable for current theme",
// "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing" => "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing",
// "Parent category of theme control categories" => "Parent category of theme control categories",
// "Choose the parent category of categories used for theme control" => "Choose the parent category of categories used for theme control",
// "Automatically select the theme-control category of the current theme when categorizing" => "Automatically select the theme-control category of the current theme when categorizing",
// "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme" => "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme",
// "Certain pages redirect to homepage when language is changed" => "Certain pages redirect to homepage when language is changed",
// "List of pages that redirect" => "List of pages that redirect",
// "List of names of pages that always redirect to the homepage when the language is switched" => "List of names of pages that always redirect to the homepage when the language is switched",
// "Separate page names by commas" => "Separate page names by commas",
// "User wizard" => "User wizard",
// "Wizard to help users set up their basic settings and account details" => "Wizard to help users set up their basic settings and account details",
// "Present different input fields in the User Wizard than are in the Registration form" => "Present different input fields in the User Wizard than are in the Registration form",
// "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form" => "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form",
// "Tracker fields presented in the User Wizard as User Details" => "Tracker fields presented in the User Wizard as User Details",
// "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)" => "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)",
// "Enable Typography Features" => "Enable Typography Features",
// "Features to replace normal characters with typographic equivalents" => "Features to replace normal characters with typographic equivalents",
// "Smart “curly” quotes" => "Smart “curly” quotes",
// "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes" => "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes",
// "Convert approximative ASCII quotes" => "Convert approximative ASCII quotes",
// "Convert plain-ASCII quote substitutes `` '\\" => "Convert plain-ASCII quote substitutes `` '\\",
// "Smart em-dash and ellipsis" => "Smart em-dash and ellipsis",
// "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…" => "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…",
// "Smart no-break space" => "Smart no-break space",
// "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it" => "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it",
// "Display only select calendars by default" => "Display only select calendars by default",
// "Master Tiki server" => "Master Tiki server",
// "Master Tiki server that this client will obtain user authorizations from" => "Master Tiki server that this client will obtain user authorizations from",
// "Overrides manually registered local users" => "Overrides manually registered local users",
"Import user preferences" => "Importiere Benutzereinstellungen",
// "Client Tiki will copy the user preferences from the master server" => "Client Tiki will copy the user preferences from the master server",
// "This will overwrite local user preferences every time the user logs in" => "This will overwrite local user preferences every time the user logs in",
"Import user groups" => "Importiere Benutzergruppen",
// "Groups the user belongs to on the master server will be imported (along with their security definitions)" => "Groups the user belongs to on the master server will be imported (along with their security definitions)",
// "This will overwrite local groups every time a user logs in" => "This will overwrite local groups every time a user logs in",
// "Limit group import" => "Limit group import",
// "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation" => "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation",
// "This list will limit the group import feature to only those groups listed here" => "This list will limit the group import feature to only those groups listed here",
// "Intertiki shared cookie" => "Intertiki shared cookie",
// "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites" => "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites",
// "This site is a master server" => "This site is a master server",
// "Scheduler" => "Scheduler",
// "Provides the ability to run tasks at a scheduled time" => "Provides the ability to run tasks at a scheduled time",
// "Convert from absolute to relative link" => "Convert from absolute to relative link",
// "Process wiki text and convert internal links from absolute to relative links" => "Process wiki text and convert internal links from absolute to relative links",
// "It's recommended to set a cron job to periodically rebuild the search index" => "It's recommended to set a cron job to periodically rebuild the search index",
"HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "HTML-Reiniger ist eine zu den Standards kompatible HTML Filterbibliothek, geschrieben in PHP und integriert in Tiki. HTML-Reiniger entfernt nicht nur jeglichen bösartigen Code (besser bekannt als XSS) mit einer gründlichen Überprüfung und sicheren, zulassenden Whitelist. Es macht auch alle Dokumente kompatibel zu den Standards, was sonst nur durch vertieftes Verständnis der W3C-Spezifikationen möglich ist",
"Show user's contribution on the user information page" => "Zeige die Beiträge des Benutzers auf der Benutzerinformationseite an",
// "View user's contribution on the user information page" => "View user's contribution on the user information page",
// "Users' drawings are stored in their user files gallery" => "Users' drawings are stored in their user files gallery",
"Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index" => "nofollow wird benutzt, um Suchmaschinen zu instruieren, dass Links die Suchmaschinen nicht beeinflussen. Das kann Suchmaschinenspam reduzieren und 'spamdexing' (Suchmaschinen-Spamming) verhindern",
// "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised" => "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised",
// "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated" => "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated",
// "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6" => "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6",
"Require file creator's name for anonymous uploads" => "Name des Autors der Datei für anonymes Hochladen erforderlich",
"Redirect to similar wiki page" => "Weiterleiten auf eine ähnliche Wikiseite",
"If a requested page doesn't exist, redirect to a similarly named page" => "Wenn eine angeforderte Seite nicht existiert, auf eine ähnlich klingende Seite weiterleiten",
"Redirect to page alias, if any" => "Weiterleitung auf einen Seiten-Alias (wenn existent)",
"If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "Wenn eine angeforderte Seite nicht existiert, auf eine Alias-Seite weiterleiten (wenn angegeben mittels eines semantischen Alias-Links)",
"User's information page" => "Benutzerseite",
// "Display a user's gender if permitted by the user" => "Display a user's gender if permitted by the user",
// "Allow showing user's information on mouseover" => "Allow showing user's information on mouseover",
// "Show users' information on mouseover" => "Show users' information on mouseover",
"Requires user's information to be public" => "Erfordert, dass die Benutzerinformationen öffentlich sind",
// "Show the user's real name" => "Show the user's real name",
// "Federated search" => "Federated search",
// "Search through alternate site indices" => "Search through alternate site indices",
// "Elasticsearch is required" => "Elasticsearch is required",
// "Elasticsearch tribe node URL" => "Elasticsearch tribe node URL",
// "URL of the tribe client node accessing multiple clusters" => "URL of the tribe client node accessing multiple clusters",
"Default feed format" => "Standardfeedformat",
"ATOM 1.0" => "ATOM 1.0",
"RSS 2.0" => "RSS 2.0",
"Feed author name" => "Name des Feedautors",
// "Default author of each item in the feed" => "Default author of each item in the feed",
"This field is mandatory unless both feed author email and homepage are empty." => "Dieses Feld ist zwingend, es sei denn, die Felder Feedautor und Homepage bleiben leer.",
"Feed author email" => "E-Mail des Feedautors",
// "Email of the author of each item in the feed" => "Email of the author of each item in the feed",
"Feed author homepage" => "Homepage des Feedautors",
// "Homepage URL of the author of each item in the feed" => "Homepage URL of the author of each item in the feed",
"Feed editor email" => "E-Mail des Feedbearbeiters",
"Email address for person responsible for editorial content" => "E-Mailadressen der Person, die für den redaktionellen Inhalt verantwortlich ist",
"Feed webmaster email" => "E-Mail des Feedwebmasters",
"Email address for person responsible for technical issues relating to channel" => "E-Mailaddresse der Person, die für technische Fragen bezüglich des Kanals verantwortlich ist",
"Feed image path" => "Feed Bildpfad",
"Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Legt ein GIF, JPEG oder PNG Bild fest, das zusammen mit dem Feed angezeigt werden kann",
// "Feed language" => "Feed language",
// "The default language for this feed" => "The default language for this feed",
// "RSS basic authentication" => "RSS basic authentication",
"Propose basic HTTP authentication if the user has no permission to see the feed" => "Empfehle Basis-HTTP-Authentifizierung, wenn der Benutzer keine Rechte hat, den Feed einzusehen",
"Feed caching time" => "Feed Cache-Zeit",
// "Cache the feed for this number of seconds" => "Cache the feed for this number of seconds",
"Use 0 for no caching" => "Benutze 0 für kein caching",
"Feed caching is done for anonymous users only" => "Feed-Caching wird nur für anonyme Benutzer vorgenommen",
"RSS for articles" => "RSS für Artikel",
"RSS feeds for articles" => "RSS Feeds für Artikel",
"RSS for blogs" => "RSS für Blogs",
"RSS feeds for blogs" => "RSS Feeds für Blogs",
"RSS for individual blogs" => "RSS für individuelle Blogs",
"RSS feeds for individual blogs" => "RSS Feeds für individuelle Blogs",
"RSS for image galleries" => "RSS für Bildergalerie",
"RSS feed for image galleries" => "RSS Feeds für Bildergalerien",
"RSS for individual image galleries" => "RSS für individuelle Bildergalerien",
"RSS feeds for individual image galleries" => "RSS Feeds für individuelle Bildergalerien",
"RSS for file galleries" => "RSS für Dateiarchive",
"RSS feed for file galleries" => "RSS Feeds für Dateiarchive",
"RSS for individual file galleries" => "RSS für individuelle Dateiarchive",
"RSS feeds for individual file galleries" => "RSS Feeds für individuelle Dateiarchive",
"RSS for wiki pages" => "RSS für Wiki-Seiten",
"RSS feed for wiki pages" => "RSS Feeds für Wiki",
"RSS for forums" => "RSS für Foren",
"RSS feed for forums" => "RSS Feeds für Foren",
"RSS for individual forums" => "RSS für individuelle Foren",
"RSS feeds for individual forums" => "RSS Feeds für individuelle Foren",
"RSS per tracker" => "RSS für Tracker",
"RSS feed per tracker" => "RSS Feed für Tracker",
"RSS for calendar events" => "RSS für Kalenderereignisse",
"RSS feed for calendar events" => "RSS Feeds für Kalenderereignisse",
"RSS for directories" => "RSS für Linkverzeichnisse",
"RSS feed for directories" => "RSS Feeds für Linkverzeichnisse",
"RSS for shoutbox" => "RSS für Shoutbox",
"RSS feed for shoutbox" => "RSS Feeds für Shoutbox",
"Maximum number of items to display" => "Maximale Anzahl von anzuzeigenden Einträgen",
// "items" => "items",
"Show author" => "Zeige Autor",
"Homepage URL" => "Homepage-URL",
"Tiki RSS feed for articles" => "Tiki RSS Artikel Feed",
"Tiki RSS feed for blogs" => "Tiki RSS Weblog Feed",
"Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Titel, der dem Blogtitel aller Blogs vorangestellt wird. Wenn das Feld leer ist, wird nur der Blogtitel verwendet",
"Tiki RSS feed for image galleries" => "Tiki RSS Feed von Bildergalerien",
"Tiki RSS feed for the image gallery: " => "Tiki RSS Feed von Bildergalerie: ",
"Tiki RSS feed for file galleries" => "Tiki RSS Dateiarchiv Feed",
"Tiki RSS feed for the file gallery: " => "Tiki RSS Feed von Dateiarchiv: ",
"Tiki RSS feed for the wiki pages" => "Tiki RSS Wiki Feed",
"Tiki RSS feed for forums" => "Tiki RSS Foren Feed",
"Tiki RSS feed for forum: " => "Tiki RSS Feed von Forum: ",
"Tiki RSS feed for individual trackers: " => "Tiki RSS Feed von Tracker: ",
"Tiki RSS feed for calendars" => "Tiki RSS Feed für Kalender",
"Tiki RSS feed for directory sites" => "Tiki RSS Feed von Linkverzeichnis",
"Tiki RSS feed for shoutbox messages" => "Tiki RSS Feed für Shoutboxnachrichten",
"Article RSS description" => "Artikel RSS Beschreibung",
"Description to be published as part of the RSS feed for articles" => "Mitveröffentlichte Beschreibung des RSS Feed für Artikel",
"Last articles." => "Neueste Artikel.",
"Blogs RSS description" => "Blogs RSS Beschreibung",
"Description to be published as part of the RSS feed for blogs" => "Mitveröffentlichte Beschreibung des RSS Feed für Blogs",
"Last posts to weblogs." => "Neueste Weblog-Einträge.",
"Blog RSS Description" => "Blog RSS Beschreibung",
"Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used" => "Beschreibung, die der Blogbeschreibung vorangestellt wird und als Teil des RSS Feed für individuelle Blogs mitveröffentlicht wird. Wenn das Feld leer ist, wird nur die Blogbeschreibung genutzt",
"Image galleries RSS description" => "Bildergalerien RSS Beschreibung",
"Description to be published as part of the RSS feed for image galleries" => "Mitveröffentlichte Beschreibung des RSS Feed für Bildergalerien",
"Latest images uploaded to the image galleries" => "Zuletzt in die Bildergalerie hochgeladene Bilder",
"Individual image galleries RSS Description" => "Individuelle Bildergalerie RSS Beschreibung",
"Description to be published as part of the RSS feeds for individual image galleries" => "Mitveröffentlichte Beschreibung des RSS Feed für individuelle Bildergalerien",
"Latest images uploaded to this image gallery." => "Zuletzt in diese Bildergalerie hochgeladene Bilder. ",
"File galleries RSS description" => "Dateiarchive RSS Beschreibung",
"Description to be published as part of the RSS feed for file galleries" => "Mitveröffentlichte Beschreibung des RSS Feed für Dateiarchive",
"Latest files uploaded to the file galleries." => "Neueste Dateien in den Dateiarchiven.",
"Individual file galleries RSS description" => "Individuelle Dateiarchive RSS Beschreibung",
"Description to be published as part of the RSS feeds for individual file galleries" => "Mitveröffentlichte Beschreibung des RSS Feed für individuelle Dateiarchive",
"Latest files uploaded to this file gallery." => "Zuletzt in diese Dateiarchiv hochgeladene Dateien. ",
"Wiki pages RSS description" => "Wiki Seiten RSS Beschreibung",
"Description to be published as part of the RSS feed for wiki pages pages" => "Mitveröffentlichte Beschreibung des RSS Feed für Wiki Seiten",
"Latest wiki page changes." => "Zuletzt geänderte Wikiseiten.",
"Forums RSS description" => "Foren RSS Beschreibung",
"Description to be published as part of the RSS feed for forums" => "Mitveröffentlichte Beschreibung des RSS Feed für Foren",
"Latest forum topics." => "Neueste Forenthemen.",
"Individual forums RSS description" => "Individuelle Foren RSS Beschreibung",
"Description to be published as part of the RSS feeds for individual forums" => "Mitveröffentlichte Beschreibung des RSS Feed für individuelle Foren",
"Latest posts to this form" => "Zuletzt in diesem Forum veröffentlicht. ",
"Individual trackers RSS description" => "Individuelle Tracker RSS Beschreibung",
"Description to be published as part of the RSS feed for individual trackers" => "Mitveröffentlichte Beschreibung des RSS Feed für individuelle Tracker",
"Latest additions to this tracker" => "Zuletzt in diesem Tracker veröffentlicht",
"Calendar events RSS description" => "Kalendereignisse RSS Beschreibung",
"Description to be published as part of the RSS feed for calendar events" => "Mitveröffentlichte Beschreibung des RSS Feed für Kalendereignisse",
"Upcoming Events" => "nächste Termine",
"Directories RSS description" => "Linkverzeichnisse RSS Beschreibung",
"Description to be published as part of the RSS feed for directories" => "Mitveröffentlichte Beschreibung des RSS Feed für Linkverzeichnisse",
"Latest sites." => "Neueste Sites.",
"Shoutbox RSS description" => "Shoutbox RSS Beschreibung",
"Description to be published as part of the RSS feed for shoutbox messages" => "Mitveröffentlichte Beschreibung des RSS Feed für Shoutbox-Nachrichten",
"Latest shoutbox messages" => "Letzten Shoutboxnachrichten",
// "Tracker labels" => "Tracker labels",
// "Include tracker field labels in the RSS output" => "Include tracker field labels in the RSS output",
"Page" => "Seite",
// "Finder view" => "Finder view",
"Show as a column" => "Zeige als Spalte",
"Show in popup box" => "Zeige in Popupbox",
"Both" => "Beides",
"Podcast directory" => "Podcastverzeichnis",
// "File system directory for storing podcast files" => "File system directory for storing podcast files",
"The server must be able to read/write the directory." => "Der Server muss in das Verzeichnis schreiben und von dort lesen können.",
"Required for podcasts." => "Erforderlich für Podcasts.",
"To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc" => "Wenn Du Stapelhochladen in ein Verzeichnis aktivierst, musst Du ein weblesbares Verzeichnis verwenden (ausserhalb des Webspace wäre besser). Dann finde einen Weg die Dateien mittels scp, ftp oder eines anderen Protokolls dorthin hochzuladen.",
"The server must be able to read the directory." => "Der Server muss das Verzeichnis lesen zu können.",
"The directory can be outside the web space." => "Das Verzeichnis kann ausserhalb des Webspace liegen.",
"Prevent download if score becomes negative" => "Downloads bei negativer Bewertung verbieten",
// "If using Tiki Score system, users with a negative score cannot download files" => "If using Tiki Score system, users with a negative score cannot download files",
"Allow download limit per file" => "Dateiweise Downloadbegrenzung erlauben",
// "Allow file duplicates" => "Allow file duplicates",
"Allow the same file to be uploaded more than once" => "Selbe Datei darf mehrfach hochgeladen werden",
"Yes, even in the same gallery" => "Ja, sogar in das gleiche Dateiarchiv",
"Only in different galleries" => "Nur in verschiedenen Dateiarchive",
"Display ZIP option in gallery" => "Zeige ZIP-Option im Archiv",
"Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery." => "Zeige im Archiv die ZIP-Option (beim Hochladen und bei der Verzeichnisdatei)",
"Must match" => "Muss übereinstimmen mit",
// "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)" => "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)",
"Cannot match" => "Darf nicht übereinstimmen mit",
// "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted" => "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted",
"Quota for all files and archives" => "Speicherkontingent für allen Dateien und Archive",
// "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)" => "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)",
"0 for unlimited" => "0 for unbegrenzte",
// "megabytes" => "megabytes",
"Quota for each file gallery" => "Das Speicherkontingent kann für jedes Dateiarchiv individuell festgelegt werden",
// "A different quota can be defined for each file gallery" => "A different quota can be defined for each file gallery",
"Default quota for each new gallery" => "Standardkontigent für jedes neues Dateiarchiv",
"Show quota bar in the list page" => "Zeige Speicherkontigentnutzung bei der Auflistung",
"Yes, display bar and detail text" => "Ja, Balken anzeigen und detaillierten Text",
"Yes, display only bar" => "Ja, nur Balken anzeigen",
"Yes, display only text" => "Ja, zeige nur Text",
"Storage" => "Speicher",
// "Specify if uploaded files should be stored in the database or file directory" => "Specify if uploaded files should be stored in the database or file directory",
"Store in database" => "Speichern in der Datenbank",
"Store in directory" => "Speichern im Verzeichnis",
"Path to the directory to store file gallery files" => "Pfad um Dateien im Dateiarchiv zu erstellen",
// "Searchable file gallery content" => "Searchable file gallery content",
"Include the search form on the current gallery page just after \"Find\"" => "Füge eine Suchbox im aktuellen Dateiarchiv hinter dem DIV-Tag \"find\" hinzu",
"Include a search form in file galleries" => "Füge eine Suchbox für Dateiarchive hinzu",
// "Display hits ratio to maximum" => "Display hits ratio to maximum",
"Display hits with a ratio of hits to maximum hits" => "Zeige Treffer mit einem Verhältnis zwischen Treffern / maximalen Treffern",
"Display properties in the context menu" => "Zeige Eigenschaften im Kontextmenü",
"Display \"Replace\" in the context menu" => "Zeige Ersetzen-Menü im Kontextmenü",
"Automatic deletion of old files" => "Automatisch veraltete Dateien löschen",
"The user will have an option when uploading a file to specify the time after which the file is deleted" => "Der Benutzer hat die Möglichkeit, eine Zeit anzugeben, nachdem die hochgeladene Datei wieder gelöscht wird",
"A cron job must be set up in order to delete the files." => "Ein Cronjob muss konfiguriert werden, um die Dateien zu löschen.",
"Allow action on multiple files or galleries" => "Erlaube Aktion auf verschiedene Dateien oder Archive",
"Include \"Remove\" as an option for the checkbox action in file galleries" => "Die check-Schaltfläche in einem Dateiarchiv kann entfernt werden",
"Deletion emails notification" => "Benachrichtigung per E-Mail von der Löschung an",
"Email addresses (comma-separated) to receive a copy of each deleted file" => "Diese E-Mailadressen erhalten eine Kopie jeder gelöschten Datei. E-Mails werden durch Kommata voneinander getrennt",
"Keep the same fileId for the latest version of a file" => "Behalte die gleiche Datei-ID für die aktuellste Version einer Datei",
"If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file" => "Wenn gewählt, bleibt die Datei-ID der neuesten Version einer Datei gleich. Der Link auf eine Datei gibt dann immer die neueste Version zurück. Wenn nicht gewählt, wird die Datei-ID für immer einer Datei zugewiesen. Ein Link auf eine Datei gibt dann genau diese Version der Datei zurück",
"Show thumbnail actions" => "Zeige Vorschaubild-Funktionen",
"Show the checkbox and wrench icon for file actions menu when not displaying details" => "Zeige das Kontrollkästchen und den Schraubenschlüssel für Dateiaktionen, wenn keine Details angezeigt werden",
"Maximum thumbnail size" => "Max Größe für Vorschaubilder",
"Maximum width or height for image thumbnails" => "Maximale Breite oder Höhe für Vorschaubilder",
"Automatic indexing of file content" => "Automatisch Dateiinhalte indexieren",
"Uses command line tools to extract the information from the files based on their MIME types." => "Benutze Befehlszeilenwerkzeuge um die Informationen aus Dateien je nach deren MIME-Typs zu entnehmen.",
// "Asynchronous indexing" => "Asynchronous indexing",
"Upload files from remote source" => "Dateien von einer entfernten Quelle hochladen",
"Enable copying files to file galleries from a URL that will be polled for new revisions." => "Erlaubt es Dateien in Dateiarchiven von fernen Quellen zu erstellen, welche auf aktuelle Versionen geprüft werden.",
"Remote source refresh frequency limit" => "Aktualisierungsintervall für entfernte Quelle",
// "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests" => "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests",
// "Set to zero to disable refresh" => "Set to zero to disable refresh",
"Display controls to attempt a file refresh" => "Schaltfläche zur manuellen Aktualisierung anzeigen",
"Let users trigger a refresh attempt from the remote host." => "Erlaubt es dem Benutzer eine manuelle Aktualisierung von der fernen Quelle durchzuführen",
"Allow searching for existing files in the tracker files field" => "Erlaube das Suchen nach bestehenden Dateien im Tracker-Dateien-Feld",
"Search files using the search index." => "Suche Dateien mit dem Suchindex.",
"Set MIME type based on file suffix" => "Mimetyp basierend auf Dateiendung reparieren",
"Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream" => "Repariert Mimetypen von Bildern anhand der Dateiendung, wenn sie als application/octet-stream erkannt wurden",
// "Clean XML Always" => "Clean XML Always",
// "Sanitize XML based files such as SVG for all users" => "Sanitize XML based files such as SVG for all users",
// "Allow SVG file upload" => "Allow SVG file upload",
// "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files." => "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files.",
"Maximum name length" => "Maximale Namenslänge",
"Length to which to truncate file names in browse view" => "Länge nach der Dateinamen in Browseransicht abgeschnitten werden",
// "Maximum width of images" => "Maximum width of images",
// "Default maximum width of images in galleries" => "Default maximum width of images in galleries",
// "Maximum height of images" => "Maximum height of images",
// "Default maximum height of images in galleries" => "Default maximum height of images in galleries",
// "Use elFinder UI" => "Use elFinder UI",
// "Alternative file manager with drag and drop capability" => "Alternative file manager with drag and drop capability",
// "Use Viewer JS" => "Use Viewer JS",
// "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages" => "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages",
// "Viewer JS URI" => "Viewer JS URI",
// "Where ViewerJS is installed" => "Where ViewerJS is installed",
// "Use PDF.js" => "Use PDF.js",
// "Uses PDF.js to display PDF files in web pages" => "Uses PDF.js to display PDF files in web pages",
// "Default view" => "Default view",
// "Default sort field" => "Default sort field",
"Last modification date" => "Datum der letzten Veränderung",
"Owner" => "Besitzer",
"Default sort direction" => "Standard-Sortierrichtung",
"Descending" => "Absteigend",
"Ascending" => "Aufsteigend",
"Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Trage die ID irgendeiner Datei in irgendeinem Dateiarchiv ein, um sie als Symbol für dieses Dateiarchiv in der Browseransicht zu verwenden",
// "Show explorer" => "Show explorer",
// "Show path" => "Show path",
// "Show slideshow" => "Show slideshow",
"Name-filename" => "Name - Dateiname",
"Filename only" => "Nur Dateiname",
// "Created / Uploaded" => "Created / Uploaded",
// "Show icon in column" => "Show icon in column",
// "OCR Files" => "OCR Files",
// "Extract and index text from supported file types" => "Extract and index text from supported file types",
// "OCR Every File" => "OCR Every File",
// "Attempt to OCR every supported file" => "Attempt to OCR every supported file",
// "View or export office documents as PDF" => "View or export office documents as PDF",
// "If enabled allows to view documents without download or to export documents as PDF files" => "If enabled allows to view documents without download or to export documents as PDF files",
// "Maximum width of file preview in pixels" => "Maximum width of file preview in pixels",
// "The maximum value of width in pixels for the files preview in the popover" => "The maximum value of width in pixels for the files preview in the popover",
// "Export diagram image on save" => "Export diagram image on save",
// "If enabled, diagrams will be cached in PNG format when saved or edited" => "If enabled, diagrams will be cached in PNG format when saved or edited",
// "Use draw.io public services to export images" => "Use draw.io public services to export images",
// "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback" => "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback",
"Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory" => "Trage ein Verzeichnis auf Deinem Server ein. Z.B.: /var/www/ . Es wird empfohlen, dass dieses Verzeichnis nicht aus dem Web erreichbar ist. PHP muss in der Lage sein dieses Verzeichnis zu lesen/schreiben",
// "Use jQuery upload" => "Use jQuery upload",
// "Use the improved Tiki 15+ upload page" => "Use the improved Tiki 15+ upload page",
// "Redirect to file gallery" => "Redirect to file gallery",
// "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery" => "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery",
// "Revision approval" => "Revision approval",
"Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges" => "Benutze gekennzeichnete Revisionen, um unbestätigte Wiki Seiten Revisionen vor Benutzern mit geringeren Rechten zu verstecken",
// "Revision approval categories" => "Revision approval categories",
"List of category IDs for which revision approval is required" => "Liste von Kategorie-IDs bei welchen eine Revisionsbestätigung erforderlich ist",
"Footer shadow div start" => "Fußbereich Schattenstart",
"Footer shadow div end" => "Fußbereich Schattenende",
// "Forum image file gallery" => "Forum image file gallery",
// "File gallery used to store images for forums" => "File gallery used to store images for forums",
"Uploaded filenames must match regex" => "Hochgeladene Dateinamen müssen diese RegEx erfüllen",
"Manage thread defaults per-forum" => "Verwalte Threadstandards pro Forum",
"Display thread configuration bar" => "Zeige Balken zur Konfiguration von Threads",
"Allows users to override the defaults" => "Erlaube Benutzern die Standardeinstellungen zu ändern",
"Display the thread configuration bar only when the number of posts exceeds" => "Zeige Balken zur Konfiguration von Threads nur, wenn mindestens die Zahl von Posts überschritten wird",
"posts" => "Einträge",
"Keep settings for all forums during the user session" => "Behalte die Einstellungen für alle Foren während einer Benutzersitzung",
"Default style" => "Standardstil",
"Threaded" => "Threaded",
"Headers only" => "nur Köpfe",
"Default sort mode" => "Standardsortiermethode",
"Title (desc)" => "Titel (absteigend)",
"Title (asc)" => "Titel (aufsteigend)",
"Topics" => "Themen",
"Posts per day" => "Einträge pro Tag",
"Last post" => "Neuester Eintrag",
"Description length" => "Länge der Beschreibung",
"Require reply to have a title" => "Erzwinge Titel in Antwort",
"Present an empty title input form and require it to be filled in before the forum post is submitted" => "Zeigt eine leere Titel-Box, die ausgefüllt werden muss, bevor ein Forumeintrag eingereicht werden kann",
// "Prevent Nesting of Quote wikiplugins when replying" => "Prevent Nesting of Quote wikiplugins when replying",
// "Strips quote plugin in reply in order to prevent nesting of quote plugins" => "Strips quote plugin in reply in order to prevent nesting of quote plugins",
// "Forum post categories" => "Forum post categories",
// "Categories available in the category picker for forum posts" => "Categories available in the category picker for forum posts",
// "Include category selector in forum list" => "Include category selector in forum list",
// "Allow inbound email posts from anyone" => "Allow inbound email posts from anyone",
// "Allow posts from non-users in forums using inbound posts from a specified email address" => "Allow posts from non-users in forums using inbound posts from a specified email address",
// "Parse HTML in inbound email posts" => "Parse HTML in inbound email posts",
// "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG" => "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG",
"Experimental" => "Experimentell",
// "Has problems with some HTML emails, especially those with table-based layouts" => "Has problems with some HTML emails, especially those with table-based layouts",
// "Strip wiki markup from outgoing forum emails" => "Strip wiki markup from outgoing forum emails",
// "Convert outgoing emails from forum posts to plain text" => "Convert outgoing emails from forum posts to plain text",
// "Send moderation email" => "Send moderation email",
// "Send email to forum moderators when post is queued" => "Send email to forum moderators when post is queued",
// "Approve link in moderation email" => "Approve link in moderation email",
// "Include a link for forum moderators to approve queue from email" => "Include a link for forum moderators to approve queue from email",
// "Do not start messages titles with 'Re:'" => "Do not start messages titles with 'Re:'",
"Don't display forum thread titles" => "Verstecke Titel für Forumthreads",
"Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display" => "Die meisten Titel bleiben unverändert, da sie in direkter Antwort auf den vorherigen Forumseintrag erfolgen. Diese Einstellung versteckt die Titel in Formularen und in der Anzeige",
// "Include a dropdown selector in the forum list to choose a category for the post" => "Include a dropdown selector in the forum list to choose a category for the post",
"Creation date (asc)" => "Erstellungsdatum (aufsteigend)",
"Topics (desc)" => "Themen (absteigend)",
"Threads (desc)" => "Threads (absteigend)",
"Latest post (desc)" => "Neueste Einträge (absteigend)",
"Name (desc)" => "Name (absteigend)",
"Name (asc)" => "Name (aufsteigend)",
// "Href" => "Href",
"Object ID" => "Objekt-ID",
// "Comments locked" => "Comments locked",
"Multilingual tags" => "Mehrsprachige Tags",
"Permits translation management of tags" => "Erlaubt Übersetzungen von Tags",
// "Ordering of tagged objects" => "Ordering of tagged objects",
// "Default sort mode for tagged items" => "Default sort mode for tagged items",
"Show tag cloud" => "Zeige Tag-Wolke",
// "Show the full tag cloud in the list-tags screen" => "Show the full tag cloud in the list-tags screen",
"Maximum number of tags in cloud" => "Maximale Anzahl von Tags in der Wolke",
// "tags" => "tags",
"Show tags in middle column" => "Zeige Tags in der mittleren Spalte",
// "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page." => "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page.",
"Preload random tag" => "Lade automatisch einen zufälligen Tag",
// "A random tag will be selected on the tag search page (if no tag is pre-selected)." => "A random tag will be selected on the tag search page (if no tag is pre-selected).",
// "Tag Suggestions" => "Tag Suggestions",
"Number of tags to show in tag suggestions" => "Anzahl von Tags im Tag-Vorschlag",
"Valid characters pattern" => "Muster für gültige Zeichen",
// "Click on the links below to set or clear a pattern to limit characters accepted in tags. " => "Click on the links below to set or clear a pattern to limit characters accepted in tags. ",
"Lowercase tags only" => "Tags nur in Kleinbuchstaben",
// "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly." => "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly.",
// "GD %0 detected" => "GD %0 detected",
// "GD not detected" => "GD not detected",
// "Imagick %0 detected" => "Imagick %0 detected",
// "Imagick 0 not detected" => "Imagick 0 not detected",
"Batch loading directory" => "Batch-Upload Verzeichnis",
// "Needs to be a web-readable directory" => "Needs to be a web-readable directory",
"Display image information in a mouseover box" => "Zeige Bildinformationen in einer Mouseoverbox",
// "Yes, and don't display that information under the image" => "Yes, and don't display that information under the image",
"Parent" => "Oberkategorie",
"Uploaded image names must match regex" => "Hochgeladene Bildnamen müssen diese RegEx erfüllen",
"Uploaded image names cannot match regex" => "Hochgeladene Bildnamen dürfen dieser RegEx nicht entsprechen",
"Directory path" => "Verzeichnis",
// "If you change this directory, move any images to the new directory either manually or using the 'Mover' below" => "If you change this directory, move any images to the new directory either manually or using the 'Mover' below",
// "Image processing library" => "Image processing library",
// "Imagick" => "Imagick",
// "Generate password" => "Generate password",
"Display a button on the registration form to automatically generate a very secure password for the user." => "\"Passwort Generator \" als Option bei Registrierung anbieten",
// "The generated password may not include any restrictions (such as minimum/maximum length" => "The generated password may not include any restrictions (such as minimum/maximum length",
// "Maps & Location Enabled" => "Maps & Location Enabled",
// "Provide controls to load map and location libraries" => "Provide controls to load map and location libraries",
"Geolocate wiki pages" => "Geolokalisiere Wiki Seiten",
"Provide controls to indicate a geographic location of wiki pages in the edit form" => "Einstellmöglichkeit zur geografischen Lokalisierung von Wikiseiten beim Bearbeiten",
"Geolocate articles" => "Geolokalisiere Artikel",
"Provide controls to indicate a geographic location in the article edit form." => "Möglichkeit Artikel im Rahmen der Bearbeiten-Funktion geografisch zu lokalisieren",
"Geolocate blog posts" => "Geolokalisiere Blogeinträge",
"Provide controls to indicate a geographic location in the blog post edit form." => "Möglichkeit Blogeinträge im Rahmen der Bearbeiten-Funktion geografisch zu lokalisieren",
"Available tile layers on maps" => "Kachelschichten bei Karten verfügbar",
// "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing" => "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing",
// "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1" => "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1",
"Google Street View" => "Google Street View",
// "Open Google Street View in a new window to see the visible coordinates" => "Open Google Street View in a new window to see the visible coordinates",
// "Google Street View overlay" => "Google Street View overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Zoom level for the found location" => "Zoom level for the found location",
// "Zoom level when a searched-for location is found" => "Zoom level when a searched-for location is found",
// "Street" => "Street",
// "Town" => "Town",
// "Region" => "Region",
// "Continent" => "Continent",
// "OpenLayers version" => "OpenLayers version",
// "OpenLayers 2.x (for use up to at least 15.x)" => "OpenLayers 2.x (for use up to at least 15.x)",
// "OpenLayers 3+ (experimental)" => "OpenLayers 3+ (experimental)",
// "Bing Maps API Key" => "Bing Maps API Key",
// "Needed for Bing Map Layers" => "Needed for Bing Map Layers",
// "Nextzen Maps API Key" => "Nextzen Maps API Key",
// "Needed for Nextzen Map Layers" => "Needed for Nextzen Map Layers",
"Browser title" => "Browsertitel",
"Visible label in the browser's title bar on all pages. Also appears in search engine results." => "Bezeichnung in der Browsertitelzeile auf allen Seiten. Erscheint auch so in Suchmaschinen.",
// "Fallback for tiki base URL" => "Fallback for tiki base URL",
// "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line" => "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line",
"Validate new user registrations by email" => "Validiere neue Benutzer per E-Mail",
// "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses" => "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses",
// "Wiki homepage" => "Wiki homepage",
"The default home page of the wiki when no other page is specified. The page will be created if it does not already exist" => "Startseite für die Wiki, wenn kein Seitenname angegeben wird. Die Seite wird erstellt, wenn sie nicht existiert",
"Use group homepages" => "Gruppen-Homepages benutzen",
"Users can be directed to different pages upon logging in, depending on their default group" => "Benutzer können beim Login zu verschiedenen Seiten weitergeleitet werden, abhängig von deren Standardgruppe",
"Go to the group homepage only if logging in from the default homepage" => "Sprung zur Gruppen-Homepage nur bei Login über die Default-Homepage",
"Cache external pages" => "Cache externe Seiten",
"Cache external images" => "Cache externe Bilder",
"Temporary directory" => "Temporäres Verzeichnis",
"Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory" => "Tiki erfordert vollen Lese- und Schreibzugriff auf dieses Verzeichnis",
"Help URL" => "Hilfe URL",
"The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki" => "Das Standardhilfesystem kann unvollständig sein. Du kannst Dir mit der Tiki Dokumentation weiterhelfen",
"Open external links in new window" => "Externe Links in neuem Fenster öffnen",
// "Open links to external sites in a new browser tab or window" => "Open links to external sites in a new browser tab or window",
// "Allow image lazy loading" => "Allow image lazy loading",
// "Allow that images are loaded in a lazy way" => "Allow that images are loaded in a lazy way",
"License page" => "Lizenzseite",
// "The wiki page where the license information is written" => "The wiki page where the license information is written",
"Submit notice" => "Einreichungsnachricht",
// "Text to appear when content is being submitted" => "Text to appear when content is being submitted",
"Full path to gdaltindex" => "Kompletter Pfad zu gdaltindex",
"Full path to ogr2ogr" => "Kompletter Pfad zu ogr2ogr",
"Map Zone" => "Kartenzone",
"Always display modules to all groups" => "Module immer in allen Gruppen anzeigen",
// "Any setting for the Groups parameter will be ignored and the module will be displayed to all users" => "Any setting for the Groups parameter will be ignored and the module will be displayed to all users",
"Hide anonymous-only modules from registered users" => "Anonym-Module bei registrierten Benutzern verstecken",
// "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module" => "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module",
"Hide anonymous-only modules from Admins" => "Verstecke Module für nur-anonyme Benutzer für Administratoren",
"Maximum number of articles on the articles homepage" => "Maximale Anzahl der Artikel auf der Artikelhauptseite",
// "The number of articles to show on each page of the Articles homepage" => "The number of articles to show on each page of the Articles homepage",
// "articles" => "articles",
"Site Ads and Banners Content" => "Site-Werbung und Bannerinhalt",
"Test" => "Test",
"URL to go to when clicking on a username" => "Angesteuerte URL, wenn Benutzername geklickt wird",
"Default" => "Standard",
"Use %user% for login name and %userId% for userId)" => "Benutze %user% für den Loginnamen und %userId% für die BenutzerID)",
"Forgot password" => "Passwort vergessen",
"Users can request a password reset. They will receive a link by email" => "Benutzer können die Zurücksetzung des Passworts anfordern. Sie erhalten einen Link per Email",
"Group theme" => "Gruppentheme",
"Enable groups to each have their own visual theme." => "Jede Gruppe kann ihr eigenes Theme benutzen",
// "The displayed title of the website" => "The displayed title of the website",
"Subtitle" => "Untertitel",
// "A short phrase that, for example, describes the site" => "A short phrase that, for example, describes the site",
"Maximum number of records in listings" => "Maximale Anzahl von Einträgen in Listen",
// "records" => "records",
"Maximum number of versions:" => "Maximale Anzahl von Versionen:",
// "versions" => "versions",
"Users can register" => "Benutzer können sich registrieren",
// "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page" => "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page",
// "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option" => "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option",
// "Yes, with \"deep MX\" search" => "Yes, with \"deep MX\" search",
"Require validation by Admin" => "Erfordert Validierung durch einen Administrator",
"The administrator will receive an email for each new user registration, and must validate the user before the user can log in" => "Der Administrator erhält eine E-Mail bei jeder neuen Benutzerregistrierung und muss jeden Benutzer validieren, bevor sich dieser anmelden kann",
"Require passcode to register" => "Benötigt Code zur Registrierung",
"Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users" => "Benutzer muss einen Code zur Registrierung eingeben. Du musst die Benutzer über diesen Code informieren. Benutze das zur Beschränkung auf nur die Benutzer, die eingeladen wurden",
"Passcode" => "Code",
"Alphanumeric code required to complete the registration" => "Alphanumerische Code ist für die Vervollständigung der Registrierung erforderlich",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Registration page key" => "Registration page key",
// "Key required to be on included the URL to access the registration page (if not empty)" => "Key required to be on included the URL to access the registration page (if not empty)",
// "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue" => "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue",
"Use a tracker to collect more user information" => "Benutze Tracker um mehr Informationen über Benutzer zu erhalten",
"Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user" => "Zeige einen Tracker (Formular), das die Benutzer ausfüllen müssen, um mit der Registrierung fortzufahren. Benutze diesen Tracker um zusätzliche Informationen zu jedem Benutzer zu speichern",
"Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display" => "Benutze \"Gruppenverwaltung\" um Tracker und Felder auszuwählen",
"Use tracker to collect more group information" => "Benutze Tracker um mehr Gruppeninformationen zu erhalten",
"Create a new group for each user" => "Erzeuge eine neue Benutzergruppe für jeden Benutzer",
// "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level" => "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level",
"Synchronize Tiki groups with a directory" => "Synchronisiere Tiki Gruppen mit einem Verzeichnis",
"Define the directory within the \"LDAP\" tab" => "Definiere das Verzeichnis im \"LDAP\"-Tab",
"Synchronize Tiki users with a directory" => "Synchronisiere Tiki Benutzer mit einem Verzeichnis",
"Remember me" => "Merken",
"Duration" => "Dauer",
// "The length of time before the user will need to log in again" => "The length of time before the user will need to log in again",
"day" => "Tag",
"week" => "Woche",
"month" => "Monat",
"year" => "Jahr",
// "Homepage Browser title" => "Homepage Browser title",
// "Customize Browser title for the custom homepage" => "Customize Browser title for the custom homepage",
"Use custom homepage" => "Benutze benutzerdefinierte Homepage",
"Use the top page of a Tiki feature or another homepage" => "Benutze eine Tiki-Funktion-Homepage oder eine andere Homepage",
// "This option will override the Use Tiki feature as homepage setting" => "This option will override the Use Tiki feature as homepage setting",
"Use the top page of a Tiki feature as the homepage" => "Benutze diese Funktion als Startseite",
"Select the Tiki feature to provide the site homepage. Only enabled features are listed" => "Wähle die Tiki-Funktion, die als Site-Homepage benutzt werden soll. Nur aktivierte Funktionen werden gezeigt",
"Disable JavaScript" => "JavaScript ausschalten",
"Disable JavaScript for the purpose of testing even if enabled in the browser" => "Deaktiviere zu Testzwecken JavaScript, auch wenn der Browser es erlaubt",
// "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly" => "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly",
// "Maximum rows per page" => "Maximum rows per page",
"Images per row" => "Bilder pro Zeile",
// "images" => "images",
// "Thumbnail width" => "Thumbnail width",
// "Thumbnail height" => "Thumbnail height",
// "Default scale size" => "Default scale size",
"Set blogs homepage first" => "Zuerst sind Blogs einzustellen",
"Set Image gal homepage first" => "Zuerst sind Bildergalerien einzustellen",
"Image Gallery:" => "Bildergalerie:",
"File Gallery:" => "Dateiarchiv:",
"Set Forum homepage first" => "Zuerst ist die Forumseite einzustellen",
"Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Weil Passwörter verschlüsselt sind, können diese dem Benutzer nicht mitgeteilt werden. Nur Änderungen der Passwörter sind möglich",
"Validate user's email server" => "Validiere E-Mail-Server des Benutzers",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
"The group name will be the same as the user's username" => "Die Benutzergruppe erhält den Namen des neuen Benutzers",
// "After logging in, users will automatically be logged in again when they leave and return to the site" => "After logging in, users will automatically be logged in again when they leave and return to the site",
"User's choice" => "Benutzerwahl",
"Google Maps API Key" => "Google Maps API Schlüssel",
// "Needed for Street View or other advanced features" => "Needed for Street View or other advanced features",
"Default x for map center" => "Standard X-Koordinate für die Kartenmitte",
"Default y for map center" => "Standard Y-Koordinate für die Kartenmitte",
"Default zoom level" => "Standard Zoomlevel",
"whole earth" => "Gesamte Erde",
"country size" => "Ländergröße",
"city size" => "Stadtgröße",
"max zoom" => "maximaler Zoom",
"Show map mode buttons in articles list" => "Zeige eine Kartenmodusschaltfläche in der Artikelliste",
"Show map mode buttons in page list" => "Zeige eine Kartenmodusschaltfläche in der Seitenliste",
// "Goal, recognition and rewards" => "Goal, recognition and rewards",
// "A tool to set motivational goals to increase engagement on the site" => "A tool to set motivational goals to increase engagement on the site",
// "Reward badge tracker" => "Reward badge tracker",
// "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user" => "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user",
// "0 to disable" => "0 to disable",
// "Groups not eligible for goals" => "Groups not eligible for goals",
// "Groups that will not be on the eligible group list" => "Groups that will not be on the eligible group list",
// "H5P support" => "H5P support",
// "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content" => "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content",
// "Whitelist" => "Whitelist",
// "Allowed filetypes" => "Allowed filetypes",
// "H5P Tracker User" => "H5P Tracker User",
// "Store H5P results" => "Store H5P results",
// "H5P Developer Mode" => "H5P Developer Mode",
// "Use \"patched\" libraries" => "Use \"patched\" libraries",
// "Default Gallery" => "Default Gallery",
// "File gallery to create new H5P content in by default" => "File gallery to create new H5P content in by default",
// "Store user state" => "Store user state",
// "Allows users to resume at the point they last got to" => "Allows users to resume at the point they last got to",
// "Save Frequency" => "Save Frequency",
// "How often to update user data" => "How often to update user data",
// "Allows users to export H5P content" => "Allows users to export H5P content",
// "Hub Is Enabled" => "Hub Is Enabled",
// "Updates libraries from h5p.org" => "Updates libraries from h5p.org",
// "Site Key" => "Site Key",
// "H5P Site Key" => "H5P Site Key",
// "H5P UUID" => "H5P UUID",
// "H5P Unique ID" => "H5P Unique ID",
// "Content Type Updated" => "Content Type Updated",
"Last update" => "Letzte Aktualisierung",
// "Check Requirements" => "Check Requirements",
// "Unused so far" => "Unused so far",
// "Send Usage Statistics" => "Send Usage Statistics",
// "Request User Consent" => "Request User Consent",
// "LRS Content Types" => "LRS Content Types",
// "Reporting (?)" => "Reporting (?)",
"HHeader shadow div start" => "Kopf Schatten Start",
"Header shadow div end" => "Kopf Schatten Ende",
"Custom CSS" => "Benutzerdefiniertes CSS",
// "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n" => "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n",
"Custom JavaScript" => "Benutzerdefiniertes JavaScript",
"Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages" => "Binded einen benutzerdefinierten JavaScript-Block in alle Seiten ein.",
// "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page" => "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page",
"Do not include the < script > tags" => "Keine <script> und </script> Tags aufnehmen",
// "Custom Less" => "Custom Less",
// "Compiles a new version of the currently selected theme and option using definitions declared here" => "Compiles a new version of the currently selected theme and option using definitions declared here",
// "Custom Less (CSS precompiler) - no longer used" => "Custom Less (CSS precompiler) - no longer used",
// "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon.." => "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon..",
"Highlight group" => "Gruppe hervorheben",
"Home blog (main blog)" => "Home-Blog (Haupt-Blog)",
"Home forum (main forum)" => "Home-Forum (Hauptforum)",
"Home file gallery (main file gallery)" => "Hauptverzeichnisgalerie",
// "Select the default file gallery" => "Select the default file gallery",
"Home gallery (main gallery)" => "Home-Galerie (Hauptgalerie)",
"No image gallery available (create one first)" => "Keine Bildergalerie verfügbar (erstelle zuerst eine)",
"No file gallery available (create one first)" => "Kein Dateiarchiv verfügbar (erstelle zuerst eines)",
"No blog available (create one first)" => "Keine Blogs verfügbar (erstelle zuerst eines)",
"HTTP port" => "HTTP-Port",
// "The port used to access this server; if not specified, port 80 will be used" => "The port used to access this server; if not specified, port 80 will be used",
"If not specified, port 80 will be used" => "Wenn leer, wird Port 80 benutzt",
"HTTP lookup: skip framesets" => "HTTP-Abfrage - Frameset übergehen",
"When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "Wenn eine HTTP Abfrage an eine externe Quelle gestellt wird, prüfe, ob das Ergebnis ein Frameset ist. Benutze Heuristik um den wahren Inhalt zurückzugeben",
"Registration referrer check" => "Referer-Prüfung bei Registrierung",
"Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Benutze HTTP-Referer um zu prüfen, ob die Registrierung vom gleichen Host geschickt wurde. (Kann in manschen Installationen nicht funktionieren.)",
// "HTTP header x-frame options" => "HTTP header x-frame options",
// "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt" => "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt",
// "Header value" => "Header value",
// "DENY" => "DENY",
// "SAMEORIGIN" => "SAMEORIGIN",
// "HTTP header x-xss-protection" => "HTTP header x-xss-protection",
// "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers" => "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers",
// "0" => "0",
// "1;mode=block" => "1;mode=block",
// "HTTP header x-content-type-options" => "HTTP header x-content-type-options",
// "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed" => "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed",
// "HTTP header content-security-policy" => "HTTP header content-security-policy",
// "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page" => "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page",
// "HTTP header strict-transport-security" => "HTTP header strict-transport-security",
// "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP" => "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP",
// "HTTP header public-key-pins" => "HTTP header public-key-pins",
// "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it" => "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it",
"HTTPS for user-specific links" => "Benutze HTTPS, wenn benutzerspezifische Links erstellt werden",
// "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "HTTPS-Port",
// "the HTTPS port for this server" => "the HTTPS port for this server",
"Use HTTPS login" => "Benutze HTTPS Login",
"Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Erhöhe die Sicherheit, indem Du es erlaubst, dass Authentifizierungsdaten via SSL übertragen werden. Zertifikate müssen auf diesem Server konfiguriert sein",
"Allow secure (HTTPS) login" => "Erlaube sicheren Login (https)",
"Encourage secure (HTTPS) login" => "Schlage sicheren Login (https) vor",
"Consider we are always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber prüfe nicht nach",
"Require secure (HTTPS) login" => "Sicherer Login (https) notwendig",
"Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible" => "Stelle nicht HTTPS als erforderlich ein, bevor Du nicht die Verbindung konfiguriert und getestet hast. Andernfalls kann es sein, dass die gesamte Site unerreichbar ist",
// "Enable intrusion detection system" => "Enable intrusion detection system",
// "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations" => "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations",
// "Intrusion detection system mode" => "Intrusion detection system mode",
// "Define IDS operation mode, log only, or log and block with impact over a given threshold" => "Define IDS operation mode, log only, or log and block with impact over a given threshold",
// "Log only" => "Log only",
// "Log and block requests" => "Log and block requests",
// "Intrusion detection system threshold" => "Intrusion detection system threshold",
// "Define IDS threshold, when configured in \"Log and block requests\" more" => "Define IDS threshold, when configured in \"Log and block requests\" more",
// "Custom rules file" => "Custom rules file",
// "Log to file" => "Log to file",
// "Log to database" => "Log to database",
// "Default for img-fluid class used in the IMG plugin" => "Default for img-fluid class used in the IMG plugin",
// "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden" => "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden",
// "Errors log file" => "Errors log file",
// "location, from your tiki root dir, where you want the error log file stored" => "location, from your tiki root dir, where you want the error log file stored",
// "Access log file" => "Access log file",
// "location, from your tiki root dir, where you want the access log file stored" => "location, from your tiki root dir, where you want the access log file stored",
"IP can be checked" => "IP kann überprüft werden",
"Check anonymous votes by user's IP" => "Überprüfe anonyme Abstimmungen anhand der Benutzer-IP",
"Use CDN for JavaScript" => "Benutze CDN für JavaScript",
"Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)" => "Erhalte jQuery- und jQuery UI-Bibliotheken durch ein Content Delivery Network (CDN)",
// "Google" => "Google",
"jQuery" => "jQuery",
// "Assume JavaScript is enabled even if not supported" => "Assume JavaScript is enabled even if not supported",
// "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter" => "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter",
"Slide" => "Gleiten",
"Fade" => "Ausblenden",
"Blind (UI)" => "Blenden (UI)",
"Clip (UI)" => "Abtrennen (UI)",
"Drop (UI)" => "Fallen (UI)",
"Explode (UI)" => "Explodieren (UI)",
"Fold (UI)" => "Falten (UI)",
"Puff (UI)" => "Pusten (UI)",
"Slide (UI)" => "Gleiten (UI)",
"Effect for modules" => "Effekte für Module",
"Effect for tabs" => "Effekte für Tabs",
"Speed" => "Geschwindigkeit",
"Fast" => "Schnell",
"Normal" => "Normal",
"Slow" => "Langsam",
"Direction" => "Bewegungsrichtung",
"Vertical" => "Vertikal",
"Horizontal" => "Horizontal",
"Left" => "Linker Rand",
"Right" => "Rechter Rand",
"Up" => "Aufwärts",
"Down" => "Abwärts",
// "jQuery-UI Chosen Select Boxes" => "jQuery-UI Chosen Select Boxes",
// "Styled replacement for dropdown select lists and multiple-select inputs" => "Styled replacement for dropdown select lists and multiple-select inputs",
// "Sortable Chosen Multi-selects" => "Sortable Chosen Multi-selects",
// "Enable drag and drop re-ordering of Chosen multi-select options" => "Enable drag and drop re-ordering of Chosen multi-select options",
// "Visual style of Colorbox (a.k.a. \"Shadowbox\")" => "Visual style of Colorbox (a.k.a. \"Shadowbox\")",
"One" => "Eine",
"Two" => "zwei",
"Three" => "drei",
// "Four" => "Four",
// "Five" => "Five",
// "FitVids.js" => "FitVids.js",
// "jQuery plugin for fluid-width (responsive) embedded videos" => "jQuery plugin for fluid-width (responsive) embedded videos",
// "jQuery Timeago" => "jQuery Timeago",
// "jQuery plugin for fuzzy timestamps" => "jQuery plugin for fuzzy timestamps",
// "SmartMenus" => "SmartMenus",
// "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more" => "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more",
// "SmartMenus Mode" => "SmartMenus Mode",
"Blue" => "Blau",
"Clean" => "Aufräumen",
// "Mint" => "Mint",
"Simple" => "Einfach",
// "Draggable Modals" => "Draggable Modals",
// "Modal popups can be moved around" => "Modal popups can be moved around",
// "Resizable Modals" => "Resizable Modals",
// "Modal popups can be resized" => "Modal popups can be resized",
// "jQuery Double Scroll" => "jQuery Double Scroll",
// "jQuery plugin which adds an extra horizontal scroll bar at the top" => "jQuery plugin which adds an extra horizontal scroll bar at the top",
"Partner ID" => "Partner ID",
"Kaltura Partner ID" => "Kaltura Partner ID",
"User secret" => "Benutzergeheimnis",
"Kaltura partner-setting user secret" => "Kaltura Partnereinstellungen: Benutzergeheimnis",
"Admin secret" => "Administratorgeheimnis",
"Kaltura partner-setting admin secret" => "Kaltura Partnereinstellungen: Administratorgeheimnis",
// "Kaltura video player ID" => "Kaltura video player ID",
"Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamischer Player (KDP) Benutzerinterface Konfigurations-ID",
// "Kaltura video player ID (in entry edit mode)" => "Kaltura video player ID (in entry edit mode)",
// "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail" => "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail",
// "KCW UI configuration ID" => "KCW UI configuration ID",
"Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Konfigurations-Wizard (KKW) Benutzerinterface Konfigurations-ID",
// "Kaltura service URL" => "Kaltura service URL",
// "for example, https://www.kaltura.com/" => "for example, https://www.kaltura.com/",
// "Show remixes from old versions of Kaltura" => "Show remixes from old versions of Kaltura",
// "Show remixes from old versions of Kaltura (remixing is no longer supported)" => "Show remixes from old versions of Kaltura (remixing is no longer supported)",
// "Keep versions for" => "Keep versions for",
// "Do not delete versions younger than this number of days" => "Do not delete versions younger than this number of days",
"Use database for translation" => "Für Übersetzung Datenbank benutzen",
"Use the database to store the translated strings and allow using interactive translation" => "Benutze die Datenbank zur Speicherung von übersetzten Texten und erlaube interaktive Übersetzung",
// "Edit, export and import languages" => "Edit, export and import languages",
// "Manage contribution of translated strings" => "Manage contribution of translated strings",
// "Offers to set whether each translated string should be contributed to the Tiki community or kept locally" => "Offers to set whether each translated string should be contributed to the Tiki community or kept locally",
// "Machine translation implementation" => "Machine translation implementation",
// "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required" => "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required",
// "Google Translate" => "Google Translate",
// "Bing Translate" => "Bing Translate",
// "Enable machine translation of wiki pages" => "Enable machine translation of wiki pages",
// "Makes additional languages available to the list of languages on the page" => "Makes additional languages available to the list of languages on the page",
// "Google Translate API Key" => "Google Translate API Key",
// "The key must be generated from the Google console. Choose to create a server key" => "The key must be generated from the Google console. Choose to create a server key",
// "Bing Translate Client ID" => "Bing Translate Client ID",
// "The application must be registered" => "The application must be registered",
// "Bing Translate Client Secret" => "Bing Translate Client Secret",
// "Display available translations as dropdown" => "Display available translations as dropdown",
// "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list" => "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list",
"Default language" => "Standard-Sprache",
"The site language is used when no other language is specified by the user" => "Site-Sprache, die genutzt wird, wenn vom Benutzer keine andere Sprache angegeben wurde",
// "Default admin language" => "Default admin language",
// "The site language is used in admin section when no other language is specified by the user" => "The site language is used in admin section when no other language is specified by the user",
"Language inclusion threshold" => "Schwelle für Einbeziehung von Sprachen",
"When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "Wenn die Anzahl von Sprachen der Site beschränkt wird und unter dieser Wert liegt, werden alle Sprachen zur Liste der bevorzugten Sprachen hinzugefügt, auch wenn durch den Benutzer nicht spezifiziert. Den spezifizierten Sprachen wird jedoch der Vorrang eingeräumt",
// "languages" => "languages",
"Layout width" => "Layout-Breite",
"The width of the content area of the site, centered in the browser window" => "Beschränkt die Breite, in der die Seite angezeigt wird (Standard: 990px)",
"for example, 960px" => "Beispiel: 800px",
// "Tabs optional" => "Tabs optional",
"Users can choose not to have tabs. A <b>no tabs</b> button will be displayed" => "Benutzer kann wählen, ob er Tabs nicht haben möchte",
"Add group CSS info" => "CSS Info für Gruppe hinzufügen",
"Add CSS classes to the page BODY tag based on the user's group membership" => "Classen (classes) dem BODY-Tag beifügen um Mitgliedschaft festzulegen",
"Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Entweder grp_Anonymous oder grp_Registered und möglicherweise grp_Admins ebenfalls",
// "If this option is disabled, this user wouldn’t be able to log in" => "If this option is disabled, this user wouldn’t be able to log in",
"Create the user" => "Erstelle den Benutzer",
"Deny access" => "Zugang verweigern",
"Create user if not in LDAP" => "Erstelle Benutzer, wenn nicht in LDAP",
// "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user" => "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user",
// "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”" => "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”",
"Maximum average server load threshold in the last minute" => "Maximale durchschnittliche Serverlast-Schwelle in der letzten Minute",
// "Lock Content Templates" => "Lock Content Templates",
// "Enable users to lock content templates and so prevent others from editing them" => "Enable users to lock content templates and so prevent others from editing them",
// "Lock Wiki Structures" => "Lock Wiki Structures",
// "Enable users to lock wiki structures and so prevent others from editing them" => "Enable users to lock wiki structures and so prevent others from editing them",
"Log mail in Tiki logs" => "Mails in Tiki Logs protokollieren",
"A line of type mail will be included in the System Log with the destination address and subject of each email sent" => "Mails in Tiki Logs protokollieren",
"Smarty template usage indicator" => "Smarty Vorlage Nutzungs-Anzeige",
"Add HTML comment at start and end of each Smarty template (.tpl file)" => "Füge einen HTML-Kommentar am Anfang und am Ende einer jeden Smarty-Vorlage (TPL) ein",
"Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source." => "Nur zur Entwicklung zu benutzen, nicht für den Produktiveinsatz, weil diese Warnungen sowohl in E-Mails eingefügt werden, als auch für andere Benutzer sichtbar sind.",
"You need to clear your Tiki template cache for this change to take effect" => "Du musst den Tiki Vorlagencache löschen, damit sich der Effekt zeigt",
"Log SQL" => "SQL-Abfragen protokollieren",
"All SQL queries will be registered in the database in the adodb_logsql table. " => "Logge SQL Abfragen",
// "Do not enable this feature all the time. It can be very resource intensive and will impact performance" => "Do not enable this feature all the time. It can be very resource intensive and will impact performance",
"Log queries using more than" => "Protokolliere Abfragen, die mehr als ... Sekunden benötigen",
"Use to log only queries that exceed a specific amount of time" => "Das kann die Performance negativ beeinträchtigen",
"Use email as username" => "Benutze E-Mail als Benutzername",
"Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field" => "Anstelle neue Benutzernamen zu erstellen, benutze die E-Mailadresse des Benutzers zur Authentifizierung",
"Obscure email when using email as username" => "Verdecke E-Mailadresse, wenn der Benutzername gleich der E-Mailadresse ist (wenn möglich). Die Verdeckung ist ggf. nicht vollständig",
// "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead" => "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead",
// "Coverage will not be complete" => "Coverage will not be complete",
// "User can login via username or email" => "User can login via username or email",
// "This will allow users to login using their email (as well as their username)" => "This will allow users to login using their email (as well as their username)",
// "Auto-generate 6-digit username on registration" => "Auto-generate 6-digit username on registration",
// "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)" => "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)",
"HTTP Basic Authentication" => "HTTP Basisauthentifizierung",
"Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials" => "Überprüfe Berechtigungen von der HTTP Basisauthentifizierung. Hilfreich um Webdiensten zu erlauben, Berechtigungen zu benutzen",
"SSL Only (Recommended)" => "Nur SSL (empfohlen)",
// "Prevent multiple log-ins by the same user" => "Prevent multiple log-ins by the same user",
// "Users (other than admin) cannot log in simultaneously with multiple browsers" => "Users (other than admin) cannot log in simultaneously with multiple browsers",
// "Grab session if already logged in" => "Grab session if already logged in",
// "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out" => "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out",
// "Enable autologin from remote Tiki" => "Enable autologin from remote Tiki",
// "Used with autologin_remotetiki in the redirect plugin" => "Used with autologin_remotetiki in the redirect plugin",
// "System username to use to initiate autologin from remote Tiki" => "System username to use to initiate autologin from remote Tiki",
// "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin" => "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin",
// "System groupname to use for auto login token" => "System groupname to use for auto login token",
// "For security, please create a group that has no users and no permissions and specify its name here" => "For security, please create a group that has no users and no permissions and specify its name here",
// "Create a new user account if the user that is trying to autologin does not exist on this Tiki" => "Create a new user account if the user that is trying to autologin does not exist on this Tiki",
// "Allowed groups from remote Tiki to autologin" => "Allowed groups from remote Tiki to autologin",
// "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone" => "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone",
// "Sync these groups from remote Tiki on autologin" => "Sync these groups from remote Tiki on autologin",
// "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly" => "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly",
// "Automatically logout remote Tiki after logout" => "Automatically logout remote Tiki after logout",
// "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well" => "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well",
// "Redirect direct logins to this site to remote Tiki" => "Redirect direct logins to this site to remote Tiki",
// "URL of autologin page on remote Tiki to redirect user to login" => "URL of autologin page on remote Tiki to redirect user to login",
// "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin" => "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin",
"Long date format" => "Langes Datumsformat",
// "Specify how Tiki displays the date (longer version)" => "Specify how Tiki displays the date (longer version)",
"Long time format" => "Langes Zeitformat",
// "Specify how Tiki displays the time (longer version)" => "Specify how Tiki displays the time (longer version)",
"%A %d of %B, %Y" => "%A, %d. %B %Y",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"%A %d of %B, %Y %H:%M:%S %Z" => "%A, %d. %B %Y %H:%M:%S %Z",
"Force lowercase" => "Erzwinge Kleinbuchstaben",
// "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>" => "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>",
// "Email newline character(s)" => "Email newline character(s)",
// "End-of-line (EOL) character used in outgoing emails" => "End-of-line (EOL) character used in outgoing emails",
"CRLF (standard)" => "CRLF (Standard)",
"LF (some Unix MTA)" => "LF (Einige Unix MTA)",
// "Text string used to customise mail templates" => "Text string used to customise mail templates",
// "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files" => "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files",
"Main shadow start" => "Hauptteil Schatten Start",
"Main shadow end" => "Hauptteil Schatten Ende",
"Maximum length" => "Maximale Länge",
// "The greatest number of characters for a valid username" => "The greatest number of characters for a valid username",
"Memcache" => "Speichercaching",
"Enable connection to memcached servers to store temporary information" => "Aktiviere Verbindung zu Memcached-Servern, um temporäre Informationen zu speichern",
"Requires the PHP memcache extension." => "Erfordert die PHP memcache Erweiterung",
"Memcache servers" => "Memcache Server",
"Server list which may be accessed. For each server, the address, port and weight must be specified" => "Serverliste, auf die zugegriffen wird. Für jeden Server muss die Adresse, der Port und seine Gewichtung angegeben werden",
// "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"" => "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"",
"Memcache key prefix" => "Memcache key Präfix",
"When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts" => "Wenn das Memcache-Cluster von mehreren Anwendungen genutzt wird, können Konflikte durch Benutzung einzigartiger Präfixe vermieden werden",
"Memcache expiration" => "Memcache Verfallszeit",
"Duration for which the data will be kept" => "Dauer, für welche die Daten gespeichert werden",
"Cache wiki data in memcache" => "Cache Wikidaten in memcache",
"Cache wiki output in memcache" => "Cache Wikiausgaben in memcache",
"Cache forum output in memcache" => "Cache Forenausgaben in memcache",
"Menu icons" => "Menü-Symbole",
// "Allows icons to be defined for menu entries" => "Allows icons to be defined for menu entries",
"Default path for the icons" => "Standardpfad für Symboldateien",
// "Edit menu icon" => "Edit menu icon",
// "Adds an icon on the navbar to edit menu entries" => "Adds an icon on the navbar to edit menu entries",
// "Maximum mailbox size" => "Maximum mailbox size",
// "Maximum number of messages allowed in the mailbox" => "Maximum number of messages allowed in the mailbox",
"messages" => "Nachrichten",
// "Maximum mail archive size" => "Maximum mail archive size",
// "Maximum number of archive messages allowed" => "Maximum number of archive messages allowed",
// "Maximum sent box size" => "Maximum sent box size",
// "Maximum number of sent messages allowed in the mailbox" => "Maximum number of sent messages allowed in the mailbox",
// "Truncate internal message notification" => "Truncate internal message notification",
// "Number of characters to show in the message notification sent through email, with a link to read the full internal message" => "Number of characters to show in the message notification sent through email, with a link to read the full internal message",
"Keywords" => "Schlüsselwörter",
"A list of keywords (separated by commas) that describe this website" => "Eine Liste von Schlüsselwörtern (getrennt mit Kommata), die Deine Site beschreiben",
"Include tags" => "Tags einbinden",
"If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags" => "Wenn die Tags-Funktion aktiviert ist, benutze Tags in den Meta Schlüsselwörtern für jede Seite mit eingegebenen Tags. Dies erlaubt individuelle Seiten mit verschiedenen Meta tags",
"Use thread title instead" => "Benutze stattdessen Threadtitel",
"Use the forum thread title in the meta title tag" => "Benutze den Foren-Themen-Titel im Meta-Titel-Tag",
"Use the image title instead" => "Benutze stattdessen Bildtitel",
"Use the image title in the meta title tag" => "Benutze den Bildtitel im Meta-Titel-Tag",
"A short description of the website. Some search engines display this information with the website's listing" => "Eine kurze Beschreibung Deiner Site. Einige Suchmaschinen zeigen diese Informationen mit der Auflistung Deiner Site an",
"Page description" => "Seitenbeschreibung",
"Use each page description as a meta tag for that page" => "Benutze eine individuelle Seitenbeschreibung als ein Meta-Tag für diese Seite",
"Author" => "Autor",
"The author of this website. Typically this is the Admin or Webmaster" => "Der Autor Deiner Site. Typischerweise ist dies der Admin oder Webmaster",
"geo.position" => "Geo Position",
"The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "Der Breiten- und Längengrad der physikalischen Lage Deiner Site. Z.B. \"38.898748, -77.037684\"",
"geo.region" => "Geo Region",
"The ISO-3166 country and region codes for your location. For example, \"US-NY\"" => "Der ISO-3166 Länder- und Regionen-Code Deines Ortes. Z.B.: \"US-NY\"",
"geo.placename" => "Geo Ort",
"A free-text description of your location" => "Eine Freitext-Beschreibung Deines Ortes",
"Meta robots" => "Meta Roboter",
// "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca" => "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca",
// "Should be comma separated eg. noimageindex, nocache" => "Should be comma separated eg. noimageindex, nocache",
"Revisit after" => "Neubesuch nach",
// "Specify how often (in days) Web robots should visit your site" => "Specify how often (in days) Web robots should visit your site",
"Middle shadow div start" => "Schattenanfang Mitte",
"Middle shadow div end" => "Schattenende Mitte",
"Minimum length" => "Minimale Länge",
// "The least possible number of characters for a valid username" => "The least possible number of characters for a valid username",
// "The least possible number of characters for a valid password" => "The least possible number of characters for a valid password",
"Mobile access" => "Mobiler Zugriff",
// "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)" => "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)",
// "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)" => "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)",
"Mobile Perspectives" => "Mobile Perspektiven",
"Top module zone" => "Modulzone oberer Bildschirmrand",
// "Activate zone for modules such as site logo, log-in form, etc. (page header)" => "Activate zone for modules such as site logo, log-in form, etc. (page header)",
"Topbar module zone" => "Modulzone Topbar (horizontaler Menübalken)",
// "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc" => "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc",
"topbar" => "oberer Balken",
"Page top module zone" => "Modulzone oberer Seitenrand",
// "Activate zone for modules such as breadcrumbs, banners, share icons, etc" => "Activate zone for modules such as breadcrumbs, banners, share icons, etc",
"Bottom module zone" => "Modulzone unterer Bildschirmrand",
// "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)" => "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)",
"Page bottom module zone" => "Modulzone unterer Seitenrand",
// "Activate zone for modules at the bottom of the main column of each page" => "Activate zone for modules at the bottom of the main column of each page",
// "Module file" => "Module file",
// "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles" => "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles",
// "Extra module zones available" => "Extra module zones available",
// "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones" => "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones",
// "Comma-separated list, maximum of 20 characters per entry" => "Comma-separated list, maximum of 20 characters per entry",
// "Allow users to control the notifications they receive based on content changes" => "Allow users to control the notifications they receive based on content changes",
// "Notification digests" => "Notification digests",
// "Enable digest notifications (requires a cron job)" => "Enable digest notifications (requires a cron job)",
// "Clear individual notifications" => "Clear individual notifications",
// "Allow users to selectively clear notifications instead of simply having a clear-all button" => "Allow users to selectively clear notifications instead of simply having a clear-all button",
// "Notification count refresh interval" => "Notification count refresh interval",
// "Show unread notification count and refresh every [x] seconds" => "Show unread notification count and refresh every [x] seconds",
// "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds" => "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds",
// "Notification reply-to email pattern" => "Notification reply-to email pattern",
// "Email model to use for the notification email reply-to address" => "Email model to use for the notification email reply-to address",
// "noreply+PLACEHOLDER@example.com" => "noreply+PLACEHOLDER@example.com",
"\"More Like This\" algorithm" => "Algorithmus für \"Ähnliches\"",
// "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order" => "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order",
"Minimum number of tags in common" => "Mindestzahl übereinstimmender Tags",
// "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature" => "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature",
"Multi-domain" => "Multi-Domäne",
"Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation" => "Erlaubt es Domänennamen auf Perspektiven abzubilden und multiple Domänen (auf der gleiche Instanz) zu simulieren",
"Multi-domain Configuration" => "Multi-domain Konfiguration",
"Comma-separated values mapping the domain name to the perspective ID" => "Komma-separierte Werte mit dem der Domänenname auf die entsprechende Perspektiven-ID abgebildet wird",
"One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1" => "Eine Domain pro Zeile. Perspektiven werden durch Komme getrennt. Bsp.: tiki.org,1",
"Switch domain when switching perspective" => "Schalte Domäne, um wenn die Perspektive umgeschaltet wird",
"Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work" => "Bedenke, dass verschiedene Domänen verschiedene Login-Sitzungen haben. Selbst bei Subdomänen musst Du mit session cookies umgehen können, damit es funktioniert",
// "Must read" => "Must read",
// "Allow assignment of mandatory readings and track progress" => "Allow assignment of mandatory readings and track progress",
// "Must read tracker" => "Must read tracker",
// "Tracker containing the individual read requests" => "Tracker containing the individual read requests",
// "Namespace" => "Namespace",
// "Enable namespaces feature for wiki pages" => "Enable namespaces feature for wiki pages",
// "Namespace separator" => "Namespace separator",
// "Select the character, symbol, or text to use as the namespace separator" => "Select the character, symbol, or text to use as the namespace separator",
// "Default namespace" => "Default namespace",
// "Namespace to use when creating wiki pages. Should be defined within perspectives" => "Namespace to use when creating wiki pages. Should be defined within perspectives",
// "Hide namespace indicator in structure path" => "Hide namespace indicator in structure path",
// "Hide namespace indicator in page title" => "Hide namespace indicator in page title",
// "Force all non-namespace page links to the same namespace" => "Force all non-namespace page links to the same namespace",
// "If the current page is in a namespace, all links without a namespace will have it added automatically" => "If the current page is in a namespace, all links without a namespace will have it added automatically",
"Throttle newsletter send rate" => "Drossele die Senderate des Newsletter",
"Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pause für eine angegebene Zahl von Sekunden vor jedem Stapel um eine Überlastung des E-Mailservers zu verhindern",
"Newsletter pause length" => "Newsletter Pausenlänge",
"Number of seconds delay before each batch" => "Anzahl von Sekunden zwischen jedem Stapel",
"Newsletter batch size" => "Newsletter Stapel-Größe",
// "Number of emails to send in each batch" => "Number of emails to send in each batch",
// "emails" => "emails",
"Allow sending newsletters through external clients" => "Erlaube Newsletter durch externe Clients zu senden",
"Generate mailto links using the recipients as the BCC list" => "Erstelle mailto-Links aus den Empfängern in der BCC-Liste",
"This will expose the list if email addresses to all users allowed to send newsletters" => "Hierdurch wird die E-Mailadressen-Liste für alle Benutzer aufgedeckt, die Newsletter versenden können",
"Use relative (next / previous) pagination links" => "Benutze relative Paginierungslinks (nächstes/vorheriges Objekt)",
// "Encryption key for OAuthServer" => "Encryption key for OAuthServer",
// "A key used to encrypt/decrypt authorization codes" => "A key used to encrypt/decrypt authorization codes",
// "PGP/MIME encrypted email messaging" => "PGP/MIME encrypted email messaging",
// "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses" => "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses",
// "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on" => "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on",
// "Path to gnupg keyring" => "Path to gnupg keyring",
// "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\" => "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\",
// "Path to gpg executable" => "Path to gpg executable",
// "Full path to gpg executable" => "Full path to gpg executable",
// "Read signer pass phrase from prefs or from a file" => "Read signer pass phrase from prefs or from a file",
// "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\" => "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\",
// "preferences" => "preferences",
"file" => "Datei",
// "Signer pass phrase" => "Signer pass phrase",
// "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file" => "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file",
// "leave empty if read from file" => "leave empty if read from file",
// "Path to signer pass phrase filename" => "Path to signer pass phrase filename",
// "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file" => "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file",
"Wiki buttons" => "Wiki Schaltflächen",
"Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)" => "Seitenbeschreibung, Symbole, Backlinks, ..",
"Top " => "Top/oben",
"Bottom" => "Unten",
"Neither" => "Weder noch",
// "Pages can reoccur in structure" => "Pages can reoccur in structure",
"A page can be listed multiple times in a structure" => "Eine Seite kann innerhalb einer Struktur mehrfach auftreten",
// "Fetch page content from incoming feeds" => "Fetch page content from incoming feeds",
// "Page content from the source will be fetched before sending the content to the generators" => "Page content from the source will be fetched before sending the content to the generators",
// "if set, will display 'first' and 'last' links on pages" => "if set, will display 'first' and 'last' links on pages",
// "Display \"fast-forward\" links" => "Display \"fast-forward\" links",
"Display \"fast-forward\" links (to advance 10 percent of the total number of pages) " => "Zeige Links zum schnellen Navigieren (10 Prozent der Gesamtzahl der Seiten) ",
"Hide pagination when there is only one page" => "Verberge Paginierungslinks, wenn es nur eine Seite gibt",
// "Don't display pagination on single pages" => "Don't display pagination on single pages",
"Use Icons" => "Benutze Symbole",
"Display 'First' and 'Last' links" => "Zeige Links für 'erstes' und 'letztes' Objekt",
"Require characters and numerals" => "Erfordert Buchstaben und Ziffern",
"For improved security, require users to include a mix of alphabetical characters and numerals in passwords" => "Für erhöhte Sicherheit von Benutzern fordern, in Passwörtern eine Mischung aus Buchstaben und Ziffern zu benutzen",
// "Password file used" => "Password file used",
// "The automatically selected file is recommended unless you generate your own blacklist file" => "The automatically selected file is recommended unless you generate your own blacklist file",
// "Prevent common passwords" => "Prevent common passwords",
// "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist" => "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist",
"Password expires after" => "Passwort läuft ab nach",
// "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in" => "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in",
"Require alphabetical characters in lower and upper case" => "Erfordert alphabetische Buchstaben in Groß-/Kleinschreibung",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords" => "Passwort muss mindestens ein alphabetisches Zeichen in Kleinbuchstaben enthalten (z.B. a) und eines in Großbuchstaben (z.B. A)",
"Require special characters" => "Erfordert spezielle Zeichen",
"Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords" => "Passwort muss mindestens ein Sonderzeichen enthalten (z.B. \" / \$ % ? & * ( ) _ + ..)",
"Require no consecutive repetition of the same character" => "Gleiche Zeichen dürfen nicht aufeinanderfolgen",
"Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"" => "Passwort darf nicht das gleiche Zeichen mehrfach hintereinander haben, wie z.B. 111 oder aab",
"The password must be different from the user's log-in name" => "Passwort muss sich vom Benutzernamen unterscheiden",
"Payment" => "Bezahlung",
"Feature for tracking and managing payment requests" => "Funktion um Zahlungsanfragen zu verwalten und verfolgen",
// "Payment system" => "Payment system",
"Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Gegenwärtig besteht die Wahl zwischen PayPal, Cclite (in Entwicklung) und Tiki User Credits",
"PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: siehe PayPal.com - Cclite: Gemeinschaftswährung",
"PayPal" => "PayPal",
// "Israel Post Payment Module" => "Israel Post Payment Module",
"Cclite" => "Cclite",
"Tiki User Credits" => "Tiki User Credits",
// "PayPal ID" => "PayPal ID",
// "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type" => "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type",
// "Primary email of your PayPal account (Personal or Business)" => "Primary email of your PayPal account (Personal or Business)",
// "PayPal business password" => "PayPal business password",
// "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts" => "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts",
// "Primary password of your PayPal Pro business account - OPTIONAL" => "Primary password of your PayPal Pro business account - OPTIONAL",
// "Paypal business signature" => "Paypal business signature",
// "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts" => "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts",
// "Your API signature associated with your PayPal Pro business account - OPTIONAL" => "Your API signature associated with your PayPal Pro business account - OPTIONAL",
"PayPal environment" => "Paypalumgebung",
"Used to switch between the PayPal sandbox, used for testing and development and the live environment" => "Benutzt, um zwischen der Paypal-Sandbox (Testen und entwickeln) und der Echtumgebung umzuschalten",
"Production" => "Produktion",
// "PayPal instant payment notification (IPN)" => "PayPal instant payment notification (IPN)",
"Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server" => "Aktiviere IPN für automatischen Zahlungsabschluss. Wenn aktiviert, wird Paypal per Ping versuchen, die Seite zu errreichen, wenn eine Bezahlung bestätigt wurde. Die Bezahlung wird dann automatisch eingetragen. Dies kann ggf. nicht möglich sein, wenn es sich nicht um einen öffentlichen Server handelt",
// "Payment data transfer (PDT)" => "Payment data transfer (PDT)",
// "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically" => "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically",
// "Payment data transfer (PDT) token" => "Payment data transfer (PDT) token",
// " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT" => " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT",
// "Redirect after PDT payment" => "Redirect after PDT payment",
// "Optionally, after receiving a successful payment, the user will be redirected to this page" => "Optionally, after receiving a successful payment, the user will be redirected to this page",
"Currency used when entering payments" => "Zu benutzende Währung, wenn Bezahlungen eingegeben werden",
"Default acceptable payment delay" => "Standard für akzeptierbare Zahlungsverzögerung",
"Number of days before a payment request becomes overdue. This can be changed per payment request." => "Anzahl von Tagen, bis die Zahlungsanforderung fällig wird. Dies kann pro Zahlungsanfrage geändert werden.",
// "Cclite registries" => "Cclite registries",
"Registries in Cclite" => "Registrierungen in Cclite",
"Registry names in Cclite" => "Registrierungsnamen in Cclite",
// "Cclite registry currencies" => "Cclite registry currencies",
"Currencies in Cclite" => "Währungen in Cclite",
"Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)." => "Jede Registrierung kann seine eigene Währung haben, allerdings nur eine pro Registrierung (Groß-/Kleinschreibung beachten)",
// "Cclite server URL" => "Cclite server URL",
"Full URL of the repository" => "Volle URL des Repository",
"for example, https://cclite.yourdomain.org/cclite/" => "z.B. https://cclite.DeineSite.org/cclite/",
// "Cclite merchant key" => "Cclite merchant key",
// "Corresponds with merchant key setting in Cclite" => "Corresponds with merchant key setting in Cclite",
// "Cclite merchant user" => "Cclite merchant user",
"Username in Cclite representing \"the management\"" => "Benutzername in Cclite entsprechend \"der Geschäftsführung\". Standard ist \"manager\"",
// "Cclite enable payments" => "Cclite enable payments",
"Select Cclite test or live operation." => "Test oder Live-Ausführung",
"Live" => "Live",
// "Hashing algorithm" => "Hashing algorithm",
"Encryption type" => "Verschlüsselungstyp",
"SHA1" => "SHA1",
"SHA256" => "SHA256",
"SHA512" => "SHA512",
// "Cclite payment notification" => "Cclite payment notification",
"To do" => "To do",
// "Wiki page with manual payment instructions" => "Wiki page with manual payment instructions",
// "Enter wiki page name" => "Enter wiki page name",
// "Invoice prefix" => "Invoice prefix",
"The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice" => "Präfix muss angegeben werden und einzigartig sein, wenn das gleiche Paypal-Konto für verschiedenen Tiki-Sites genutzt wird, da Paypal prüft, das Rechnungen nicht mehrfach gezahlt werden",
"Types of credit to use" => "Credit-Typen, die benutzt werden",
"This is a list of the types of Tiki user credits that are acceptable for payment" => "Dies ist eine Liste von \"Tiki-User-Credits\"-Typen, mit denen Bezahlung möglich ist",
"Exchange rate for types of credit to use" => "Wechselkurs für zu benutzende Credits",
"This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency" => "Dies ist eine Liste von Credits, deren Menge eine Einheit (1) der Bezahlungswährung entspricht",
// "User can only see own outstanding payments" => "User can only see own outstanding payments",
"Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments" => "Ein Benutzer kann nur seine ausstehenden Zahlungen einsehen (es sei denn er hat das Recht Zahlungen zu verwalten)",
// "User can only see own past or cancelled payments" => "User can only see own past or cancelled payments",
"Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments" => "Ein Benutzer kann nur seine letzte Zahlung oder abgebrochene Zahlungen sehen (es sei denn er hat das Recht Zahlungen zu verwalten)",
// "Anonymous users can pay outstanding invoices" => "Anonymous users can pay outstanding invoices",
// "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)" => "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)",
"Manage product inventory" => "Verwalte Produktinventar",
"Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "Aktiviere die Produktinventar-Funktion. Tracker müssen hierfür richtig konfiguriert sein. Die Objekt-ID muss dem Produkt-Code entsprechen",
// "Products tracker ID" => "Products tracker ID",
"ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code." => "Tracker-ID des Trackers, der für die Produkte zur Verfügung steht. Erforderlich für erweiterte Warenkorbfunktionen. Die Objekt-ID wird der Produkt-Code werden",
// "Products tracker name" => "Products tracker name",
// "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code" => "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code",
// "Inventory type field ID" => "Inventory type field ID",
"In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"" => "Feld-ID im Produkttracker, innerhalb der der Inventartyp gespeichert werden soll. Der Wert des Feldes muss entweder \"none\" oder \"internal\" sein",
// "Inventory total field ID" => "Inventory total field ID",
"In the products tracker, the ID of the field to store the total inventory of products" => "Feld-ID im Produkttracker, innerhalb der das gesamte Inventar des Produkts gespeichert werden soll",
// "Inventory total less hold field ID" => "Inventory total less hold field ID",
"In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts" => "Feld-ID im Produkttracker, innerhalb der das gesamte Inventar des Produkts gespeichert werden soll, mit Ausnahme der Menge, die derzeit in Warenkörben liegt",
// "Inventory hold timeout" => "Inventory hold timeout",
"Minutes to hold inventory before making it available again when there is no user cart action" => "Anzahl der Minuten, die das Inventar im Warenkorb gehalten werden soll, bevor es wieder allgemein verfügbar ist, wenn keine Warenkorbaktionen durchgeführt werden",
"Bundled products feature for cart" => "Produktbündelfunktion für Warenkorb",
"Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "Aktiviere die Funktion für Produktbündel. Tracker müssen hierfür richtig konfiguriert sein. Die Objekt-ID muss dem Produkt-Code entsprechen",
// "Product name field name" => "Product name field name",
"In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle" => "Feldname im Produkttracker für die Produktnamen, die als Bezeichnung des Produkts benutzten werden, z.B. in einem Bündel",
// "Items in bundle field name" => "Items in bundle field name",
"In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)." => "Feldname im Produkttracker des Feldes mit einer kommaseparierten Liste von Produkt-IDs der Produkte in einem Bündel (d.h. wenn das Feld alles enthält, dann ist dieses Produkt ein Bündel). Du kannst auch die Anzahl von Unter-Produkten festlegen, z.B. 23:(\"Doppelpunkt\")2,24 bedeutet: Objekt 23 (x2) + Objekt 24 (x1)",
// "Product price field name" => "Product price field name",
"In the products tracker, the name of the field for the product price" => "Feldname im Produkttracker für den Produktpreis",
// "Associated event ID field name" => "Associated event ID field name",
// "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with" => "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with",
// "Product class ID field name" => "Product class ID field name",
// "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature",
// "Gift certificate template field name" => "Gift certificate template field name",
// "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature",
// "Record cart orders in trackers" => "Record cart orders in trackers",
// "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording" => "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording",
// "Orders profile" => "Orders profile",
"Wiki page containing the profile for creating orders (page name must not have spaces)" => "Wiki Seite, auf der sich das Profil für die Bestellungen befindet (Seitenname darf keine Leerzeichen enthalten)",
// "Order item profile" => "Order item profile",
"Wiki page containing the profile for creating order items (page name must not have spaces)" => "Wiki Seite, auf der sich das Profil zur Erstellung von Bestellobjekten befindet (Seitenname darf keine Leerzeichen enthalten)",
// "Allow anonymous shopping" => "Allow anonymous shopping",
// "Allow shopping by anonymous users and record the orders in trackers" => "Allow shopping by anonymous users and record the orders in trackers",
// "Anonymous orders profile" => "Anonymous orders profile",
"Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)" => "Wiki Seite, auf der sich das Profil zur Bestellung von anonymen Benutzern befindet (Seitenname darf keine Leerzeichen enthalten)",
// "Anonymous order item profile" => "Anonymous order item profile",
"Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)" => "Wiki Seite, auf der sich das Profil für Bestellobjekte für anonyme Benutzer befindet (Seitenname darf keine Leerzeichen enthalten)",
// "Anonymous shopper info profile" => "Anonymous shopper info profile",
// "Anonymous users order review page" => "Anonymous users order review page",
"Wiki page where anonymous users can review their orders" => "Wiki Seite, auf der ein anonymer Benutzer seine Bestellungen einsehen kann)",
// "Temporary shopper group" => "Temporary shopper group",
// "Group name of group with permission to access review page via a token" => "Group name of group with permission to access review page via a token",
// "Enable association of product orders" => "Enable association of product orders",
"Enable association of products with events (or projects, etc.)." => "Erlaube Verknüpfung von Produkten zu Ereignissen (oder Projekten etc...)",
// "Events tracker ID" => "Events tracker ID",
// "Tracker ID of tracker that is the events tracker" => "Tracker ID of tracker that is the events tracker",
// "Events tracker name" => "Events tracker name",
// "Name of tracker that is the events tracker" => "Name of tracker that is the events tracker",
// "Event start field name" => "Event start field name",
// "Field name in events tracker of start date/time" => "Field name in events tracker of start date/time",
// "Event end field name" => "Event end field name",
// "Field name in events tracker of end date/time" => "Field name in events tracker of end date/time",
"Allow exchange of products" => "Erlaube Austausch von Produkten",
// "Order items tracker ID" => "Order items tracker ID",
// "Tracker ID of tracker that is the order items tracker" => "Tracker ID of tracker that is the order items tracker",
"Gift certificates" => "Geschenkgutscheine",
// "Gift certificate tracker ID" => "Gift certificate tracker ID",
// "ID of tracker that is the gift certificate tracker" => "ID of tracker that is the gift certificate tracker",
// "Gift certificate tracker name" => "Gift certificate tracker name",
// "Name of tracker that is the gift certificate tracker" => "Name of tracker that is the gift certificate tracker",
// "Orders tracker name" => "Orders tracker name",
// "Name of tracker that is the orders tracker" => "Name of tracker that is the orders tracker",
// "Order items tracker name" => "Order items tracker name",
// "Name of tracker that is the order items tracker" => "Name of tracker that is the order items tracker",
// "Product classes tracker name" => "Product classes tracker name",
// "Name of tracker that is the product classes tracker" => "Name of tracker that is the product classes tracker",
// "Payment heading" => "Payment heading",
// "Heading displayed on payment form" => "Heading displayed on payment form",
// "Israel Post payment environment" => "Israel Post payment environment",
// "Switch between test transactions and real transactions" => "Switch between test transactions and real transactions",
// "Israel Post use pre-authorization" => "Israel Post use pre-authorization",
// "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post" => "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post",
// "Israel Post business ID" => "Israel Post business ID",
// "Provided by Israel Post, usually the business name" => "Provided by Israel Post, usually the business name",
// "Israel Post API password" => "Israel Post API password",
// "Provided by Israel Post" => "Provided by Israel Post",
"Send to URL" => "Leite auf folgende URL weiter",
// "URL to redirect to on \"permission denied\"" => "URL to redirect to on \"permission denied\"",
"On permission denied, display login module" => "Wenn keine Rechte vorhanden sind, zeige das Loginmodul (für anonymen Benutzer)",
// "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead" => "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead",
"PHP libxml extension" => "PHP LibXML Erweiterung",
// "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default",
"PHP DateTime" => "PHP DatumUhrzeit",
// "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0" => "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0",
// "Number of comments to show on poll pages" => "Number of comments to show on poll pages",
// "The order in which order polls are displayed" => "The order in which order polls are displayed",
"Show categories" => "Kategorien anzeigen",
// "For polls that are categorized, the category is displayed" => "For polls that are categorized, the category is displayed",
"Show objects" => "Zeige Objekte",
// "List wiki pages or other site objects that the poll is attached to" => "List wiki pages or other site objects that the poll is attached to",
"Multiple polls per object" => "Multiple Abstimmungen pro Objekt",
"When used with the rating features, allow multiple polls to be attached to a single object" => "Wenn zusammen mit der Bewertungsfunktion genutzt, werden multiple Abstimmungen pro Einzelobjekt erlaubt",
// "Disable textarea toolbar" => "Disable textarea toolbar",
// "Don't display the toolbar on text inputs in surveys" => "Don't display the toolbar on text inputs in surveys",
// "Precision of survey results calculation" => "Precision of survey results calculation",
// "Number of decimal places in the percentage figures" => "Number of decimal places in the percentage figures",
// "decimal places" => "decimal places",
// "Set display settings for all galleries" => "Set display settings for all galleries",
"PDF from URL" => "PDF von einer URL",
"Using external tools, generate PDF documents from URLs" => "Externe Werkzeuge werden benutzt um PDF Dokumente von URLs zu erstellen",
"WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "WeasyPrint" => "WeasyPrint",
// "mPDF" => "mPDF",
"Webservice URL" => "URL des Webdienst",
"URL to a service that takes a URL as the query string and returns a PDF document" => "URL zu einem Dienst, der aus einer URL ein PDF-Dokument erstellt",
"WebKit path" => "WebKit Pfad",
"Full path to the wkhtmltopdf executable to generate the PDF document with" => "Vollständiger Pfad zur ausführbaren Datei von wkhtmltopdf um damit PDF Dokumente zu erstellen",
// "WeasyPrint path" => "WeasyPrint path",
// "Full path to the weasyprint executable to generate the PDF document with" => "Full path to the weasyprint executable to generate the PDF document with",
// "Print Friendly PDF" => "Print Friendly PDF",
// "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file" => "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file",
// "PDF Orientation" => "PDF Orientation",
// "Landscape or portrait" => "Landscape or portrait",
"Portrait" => "Portrait",
"Landscape" => "Gestalten",
// "PDF page size" => "PDF page size",
// "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)" => "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)",
// "Legal" => "Legal",
// "Tabloid/Ledger" => "Tabloid/Ledger",
// "A0" => "A0",
// "A1" => "A1",
// "A2" => "A2",
// "A3" => "A3",
// "A4" => "A4",
// "A5" => "A5",
// "A6" => "A6",
// "Generate auto table of contents with PDF" => "Generate auto table of contents with PDF",
// "Link TOC with content" => "Link TOC with content",
// "Link table of contents headings with content in the PDF" => "Link table of contents headings with content in the PDF",
// "TOC heading" => "TOC heading",
// "Heading to be displayed above the table of contents" => "Heading to be displayed above the table of contents",
// "PDF TOC levels" => "PDF TOC levels",
// "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3" => "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3",
// "Show Page title" => "Show Page title",
// "Print wiki page title with pdf" => "Print wiki page title with pdf",
// "PDF header text" => "PDF header text",
// "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}" => "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}",
// "HTML / Wiki Syntax / " => "HTML / Wiki Syntax / ",
// "Left text" => "Left text",
// "Center Text" => "Center Text",
// "Right Text" => "Right Text",
// "PDF footer text" => "PDF footer text",
// "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}" => "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}",
// "Left margin" => "Left margin",
// "Numeric value.For example 10" => "Numeric value.For example 10",
// "Right margin" => "Right margin",
// "Numeric value, no need to add px. For example 10" => "Numeric value, no need to add px. For example 10",
// "Top margin" => "Top margin",
// "Bottom margin" => "Bottom margin",
// "Header margin from top of document" => "Header margin from top of document",
// "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Header can overlap text if top margin is not set properly" => "Warning: Header can overlap text if top margin is not set properly",
// "Footer margin from bottom of document" => "Footer margin from bottom of document",
// "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Footer can overlap text if bottom margin is not set properly" => "Warning: Footer can overlap text if bottom margin is not set properly",
// "Hyperlink behaviour in PDF" => "Hyperlink behaviour in PDF",
// "Off (Links will be removed)" => "Off (Links will be removed)",
// "Add as footnote (Links will be listed at end of document" => "Add as footnote (Links will be listed at end of document",
// "PDF Bookmarks" => "PDF Bookmarks",
// "Automatically generate bookmarks" => "Automatically generate bookmarks",
// "H1-H6, separated by |.For example: H1|H2|H3" => "H1-H6, separated by |.For example: H1|H2|H3",
// "Number of columns" => "Number of columns",
// "Default - 1 Column" => "Default - 1 Column",
// "2 Columns" => "2 Columns",
// "3 Columns" => "3 Columns",
// "4 Columns" => "4 Columns",
// "PDF password for viewing" => "PDF password for viewing",
// "Password-protect the generated PDF" => "Password-protect the generated PDF",
// "Watermark text" => "Watermark text",
// "PDF watermark text, if any" => "PDF watermark text, if any",
// "Watermark Image URL" => "Watermark Image URL",
// "The watermark image will appear under the text. Enter the complete image URL" => "The watermark image will appear under the text. Enter the complete image URL",
// "PDF page background color" => "PDF page background color",
// "Enter a valid CSS color code" => "Enter a valid CSS color code",
// "PDF page background image" => "PDF page background image",
// "Enter the full URL" => "Enter the full URL",
// "CoverPage text settings" => "CoverPage text settings",
// "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings" => "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings",
// "Coverpage image URL" => "Coverpage image URL",
// "Print wiki authors" => "Print wiki authors",
// "Include wiki page authors and date in print versions of wiki pages" => "Include wiki page authors and date in print versions of wiki pages",
// "Print original wiki URL" => "Print original wiki URL",
// "Include original wiki page URL in print versions of wiki pages" => "Include original wiki page URL in print versions of wiki pages",
// "Print original tracker item URL" => "Print original tracker item URL",
// "Print original forum post URL" => "Print original forum post URL",
// "Include original forum post URL in print version of forum posts" => "Include original forum post URL in print version of forum posts",
"Repository URLs" => "Repository-URLs",
"List of URLs for the profile repositories that will be used" => "Zu benutzende Liste von URLs für die Profil-Repositories",
"Enter multiple repository URLs, one per line" => "Trage multiple Repository-URLs ein, eines pro Zeile",
"Data channels" => "Datenkanäle",
"Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Datenkanäle sind Vorlagen, die von einem POst request angewendet werden können. Sie können zur Automatisierung bei komplexeren Installationen verwendet werden",
"Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Datenkanäle erstellen einen bezeichneten Kanal, um Profile aus einem Benutzerbereich aufzurufen. Ein Kanal pro Zeile. Jede Zeile ist kommabegrenzt und enthält __Kanalname, Domain, Profil, erlaubte Gruppen, (optional) \$profilerequest:input\$ matches to groups__",
"There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "Es gibt zu bedenkende Sicherheitsgesichtspunkt im Zusammenhang mit der Benutzung von Datenkanälen. Stelle sicher, dass die Profilseite nur von Administratoren kontrolliert wird",
"Developer mode" => "Entwicklermodus",
"For profiles under an approval workflow, always use the latest version, even if not approved" => "Benutze für Profile in einem Bestätigungs-Arbeitsablauf immer die neueste Version. Auch dann, wenn sie nicht bestätigt sind",
"Make sure you review the profiles you install" => "Stelle sicher, die Profile nach Installation zu überprüfen",
// "Automatically approve wiki-plugins on pages installed by profiles" => "Automatically approve wiki-plugins on pages installed by profiles",
// "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved" => "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved",
// "Make sure your profiles are not executable or editable by untrusted users" => "Make sure your profiles are not executable or editable by untrusted users",
"Proxy host name" => "Proxy Host-Name",
"Proxy host - without http:// or similar, just the host name" => "Proxy Host - ohne http:// oder ähnliches, nur den Hostnamen",
"Proxy port" => "Proxy Port",
"Proxy username" => "Proxy Benutzername",
"Proxy password" => "Proxy Passwort",
"Quantify change size" => "Quantifiziere Veränderungsgröße",
"In addition to tracking the changes, track the change size and display approximately how up-to-date the page is" => "Zusätzlich zur Beobachtung von Änderungen, verfolge auch die Änderungen der Größe und zeige die ungefähre Aktualität der Seite",
"Advanced Rating" => "Fortgeschrittene Bewertung",
"In an advanced rating system, the options and calculation method can be configured." => "Fortgeschrittenes Bewertungssystem, bei dem Optionen und Berechnungsmethoden eigenhändig festgelegt werden können.",
"Rating recalculation mode" => "Methode zur Neuberechnung der Bewertung",
"Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent." => "Legt fest, wie Bewertungen neu berechnet werden. Abhängig von der Site-Last sind einiges Einstellungen vorteilhafter. Sites mit großem Datenvolumen sollten Cron-job auswählen. Neuberechnung bei Abstimmung kann ungenau sein, wenn die Neuberechnung länger dauert.",
"Recalculate on vote" => "Neuberechnung beim Bewerten",
"Randomly recalculate oldest ratings (on load)" => "Zufälliges Neuberechnen älterer Bewertungen (beim Laden)",
"Randomly recalculate oldest ratings (on vote)" => "Zufälliges Neuberechnen älterer Bewertungen (beim Bewerten)",
"Cron job (must be set manually)" => "Cron job (muss manuell eingestellt werden)",
// "Before any attempt to re-index the object" => "Before any attempt to re-index the object",
"Recalculation odds (1 in X)" => "Neuberechnungsquote (1 von X)",
"Dice roll performed on every request. When successful, will recalculate a certain number of votes." => "Nach Zufallsprinzip werden eine bestimmte Anzahl von Bewertungen neuberechnet",
"votes" => "Stimmen",
"Recalculation count" => "Neuberechnungszähler",
"How many ratings should be recalculated when odds strike." => "Anzahl der Bewertungen, die neu berechnet werden sollen",
// "ratings" => "ratings",
// "Smiley Ratings" => "Smiley Ratings",
// "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration" => "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration",
"Enabled" => "Aktiviert",
// "Detailed rating results" => "Detailed rating results",
// "Displays a table with the result count and percentage per rating option" => "Displays a table with the result count and percentage per rating option",
// "Reversed Rating Options" => "Reversed Rating Options",
// "Displays the ratings options in reverse" => "Displays the ratings options in reverse",
// "Include percentages in the detailed rating results" => "Include percentages in the detailed rating results",
// "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown" => "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown",
// "Default rating options" => "Default rating options",
// "List of options available" => "List of options available",
// "Multiple votes per user" => "Multiple votes per user",
// "Allow users to vote multiple times in the same poll" => "Allow users to vote multiple times in the same poll",
"Use reCAPTCHA" => "Benutze reCAPTCHA",
"Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA" => "Benutze reCAPTCHA, einen speziallen Captchadienst anstelle des Standard CAPTCHA",
"You will need to register at [http://www.google.com/recaptcha]" => "Du musst Dich hierfür unter [http://www.google.com/recaptcha] registrieren",
// "Site key" => "Site key",
// "reCAPTCHA public key obtained after registering" => "reCAPTCHA public key obtained after registering",
// "Secret key" => "Secret key",
// "reCAPTCHA private key obtained after registering" => "reCAPTCHA private key obtained after registering",
// "reCAPTCHA theme" => "reCAPTCHA theme",
// "Choose a theme for the reCAPTCHA widget" => "Choose a theme for the reCAPTCHA widget",
// "Black Glass" => "Black Glass",
"Red" => "Rot",
// "White" => "White",
// "reCAPTCHA version" => "reCAPTCHA version",
// "1.0" => "1.0",
// "2.0" => "2.0",
// "3.0" => "3.0",
"Record untranslated strings" => "Zeichne nicht übersetzte Texte auf",
"Keep track of the unsuccessful attemps to translate strings" => "Verfolge nicht erfolgreiche Versuche einen Text zu übersetzen",
// "Redis" => "Redis",
// "Enable connection to Redis to store cache" => "Enable connection to Redis to store cache",
// "Requires PHP Redis" => "Requires PHP Redis",
// "Redis Host" => "Redis Host",
// "IP address or domain name for Redis server" => "IP address or domain name for Redis server",
// "Redis Port" => "Redis Port",
// "Port for Redis server" => "Port for Redis server",
// "Redis connection timeout" => "Redis connection timeout",
// "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited" => "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited",
// "Redis Prefix" => "Redis Prefix",
// "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none" => "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none",
// "Redis cache expiry" => "Redis cache expiry",
// "Duration for which the cache will be kept. 0 means unlimited" => "Duration for which the cache will be kept. 0 means unlimited",
// "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern" => "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern",
"Restrict supported languages" => "Beschränke unterstützte Sprachen",
"Limit the languages made available on the site" => "Beschränke die verfügbaren Sprachen für die Site",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Enable SAML Auth" => "Enable SAML Auth",
// "IdP Entity Id" => "IdP Entity Id",
// "Identifier of the IdP entity (\"Issuer\")" => "Identifier of the IdP entity (\"Issuer\")",
// "Single sign-on service URL" => "Single sign-on service URL",
// "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")" => "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")",
// "Single log-out service URL" => "Single log-out service URL",
// "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")" => "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")",
// "X.509 certificate" => "X.509 certificate",
// "Public x509 certificate of the IdP.  (\"X.509 certificate\")" => "Public x509 certificate of the IdP.  (\"X.509 certificate\")",
// "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section" => "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section",
// "Sync user group with IdP data" => "Sync user group with IdP data",
// "This should be enabled to sync groups with the IdP" => "This should be enabled to sync groups with the IdP",
// "Enable Single Logout Service" => "Enable Single Logout Service",
// "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers" => "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers",
"Default group" => "Standardgruppe",
// "When provisioning a new user and not group found, assign that group" => "When provisioning a new user and not group found, assign that group",
// "Account matcher" => "Account matcher",
// "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost" => "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost",
// "Log-in link text" => "Log-in link text",
// "The text that appears on the log-in page" => "The text that appears on the log-in page",
// "SAML attribute that will be mapped to the Tiki username" => "SAML attribute that will be mapped to the Tiki username",
// "The SAML attribute that will be mapped to the Tiki username" => "The SAML attribute that will be mapped to the Tiki username",
// "SAML attribute that will be mapped to the Tiki email" => "SAML attribute that will be mapped to the Tiki email",
// "The SAML attribute that will be mapped to the Tiki email" => "The SAML attribute that will be mapped to the Tiki email",
// "SAML attribute that will be mapped to the Tiki group" => "SAML attribute that will be mapped to the Tiki group",
// "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation" => "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation",
// "Admins" => "Admins",
// "Set here the values of the IdP related to the user group info that will be matched with the Admins group" => "Set here the values of the IdP related to the user group info that will be matched with the Admins group",
"Registered" => "Registriert",
// "Set here the values of the IdP related to the user group info that will be matched with the Registered group" => "Set here the values of the IdP related to the user group info that will be matched with the Registered group",
// "Debug Mode" => "Debug Mode",
// "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed." => "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed.",
// "Strict Mode" => "Strict Mode",
// "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated" => "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated",
// "Service Provider Entity ID" => "Service Provider Entity ID",
// "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID" => "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID",
// "Requested NameIDFormat" => "Requested NameIDFormat",
// "Specifies constraints on the name identifier to be used to represent the requested subject" => "Specifies constraints on the name identifier to be used to represent the requested subject",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified" => "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress" => "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName" => "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:entity" => "urn:oasis:names:tc:SAML:2.0:nameid-format:entity",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:transient" => "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" => "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted" => "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos" => "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos",
// "Requested AuthnContext" => "Requested AuthnContext",
// "Authentication context: unselect all to accept any type, otherwise select the valid contexts" => "Authentication context: unselect all to accept any type, otherwise select the valid contexts",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified" => "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Password" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Password",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" => "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:X509" => "urn:oasis:names:tc:SAML:2.0:ac:classes:X509",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos",
// "urn:federation:authentication:windows" => "urn:federation:authentication:windows",
// "Enable Lowercase URL encoding" => "Enable Lowercase URL encoding",
// "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues." => "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues.",
// "Encrypt nameID" => "Encrypt nameID",
// "Sign AuthnRequest" => "Sign AuthnRequest",
// "The samlp:AuthnRequest messages sent by this SP will be signed" => "The samlp:AuthnRequest messages sent by this SP will be signed",
// "Sign LogoutRequest" => "Sign LogoutRequest",
// "The samlp:logoutRequest messages sent by this SP will be signed" => "The samlp:logoutRequest messages sent by this SP will be signed",
// "Sign LogoutResponse" => "Sign LogoutResponse",
// "The samlp:logoutResponse messages sent by this SP will be signed" => "The samlp:logoutResponse messages sent by this SP will be signed",
// "Sign Metadata" => "Sign Metadata",
// "The Metadata published by this SP will be signed" => "The Metadata published by this SP will be signed",
// "Reject Unsigned Messages" => "Reject Unsigned Messages",
// "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received" => "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received",
// "Reject Unsigned Assertions" => "Reject Unsigned Assertions",
// "Reject unsigned saml:Assertion received" => "Reject unsigned saml:Assertion received",
// "Reject Unencrypted Assertions" => "Reject Unencrypted Assertions",
// "Reject unencrypted saml:Assertion received" => "Reject unencrypted saml:Assertion received",
// "Retrieve Parameters From Server" => "Retrieve Parameters From Server",
// "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters" => "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters",
// "Service Provider X.509 certificate" => "Service Provider X.509 certificate",
// "Public x509 certificate of the SP" => "Public x509 certificate of the SP",
// "Service Provider Private Key" => "Service Provider Private Key",
// "Private key of the SP" => "Private key of the SP",
// "Signature Algorithm" => "Signature Algorithm",
// "Algorithm that the toolkit will use on the signing process" => "Algorithm that the toolkit will use on the signing process",
// "http://www.w3.org/2000/09/xmldsig#rsa-sha1" => "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
// "http://www.w3.org/2000/09/xmldsig#dsa-sha1" => "http://www.w3.org/2000/09/xmldsig#dsa-sha1",
// "Scheduler stalled after (minutes)" => "Scheduler stalled after (minutes)",
// "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection" => "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection",
// "Notify on stalled schedulers" => "Notify on stalled schedulers",
// "Send an email notification when a stalled scheduler is detected" => "Send an email notification when a stalled scheduler is detected",
// "Users to notify on stalled task" => "Users to notify on stalled task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Self healing after (minutes)" => "Self healing after (minutes)",
// "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing" => "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing",
// "Notify on healed schedulers" => "Notify on healed schedulers",
// "Send an email notification when a stalled scheduler is healed" => "Send an email notification when a stalled scheduler is healed",
// "Users to notify on healed task" => "Users to notify on healed task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Number of logs to keep" => "Number of logs to keep",
// "0 will keep all logs" => "0 will keep all logs",
"SCORM support" => "SCORM Unterstützung",
"Handle SCORM package files on upload. SCORM is a standard used in learning management systems" => "Behandele SCORM Paketdateien beim Hochladen. SCORM ist ein Standard für austauschbare elektronische Lerninhalte",
"SCORM Tracker" => "SCORM Tracker",
"The ID number of the tracker used to store SCORM metadata" => "Tracker ID zuzr Speicherung von SCORM Metadaten",
"Parse search results" => "Parse die Suchergebnisse",
// "When enabled search results are parsed so content formatting is visible in the search results" => "When enabled search results are parsed so content formatting is visible in the search results",
"Default where" => "Wo soll standardmäßig gesucht werden",
"When object filter is not on, limit to search one type of object" => "Wenn kein Objektfilter gewählt ist, beschränke die Suche auf einen Objekttypen",
"Entire site" => "Ganze Site",
"Wiki Pages" => "Wikiseiten",
"Wiki pages" => "Wiki-Seiten",
// "Blog posts" => "Blog posts",
// "Tracker items" => "Tracker items",
"Spreadsheets" => "Tabellenkalkulation",
"Restrict search language by default" => "Beschränke standardmäßig die Suchsprache",
"Only search content that is in the interface language, otherwise show the language menu" => "Wenn aktiviert, suche nur Inhalte in der Interface-Sprache. Andernfalls zeige Sprachenmenü",
"Autocomplete page names" => "Seitennamen automatisch vervollständigen",
// "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc" => "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc",
// "deprecated" => "deprecated",
"Category filter" => "Kategorienfilter",
"Tag filter" => "Tag-Filter",
// "Use facets for default search interface" => "Use facets for default search interface",
// "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines" => "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines",
// "Facet result count" => "Facet result count",
// "Default number of facet results to obtain" => "Default number of facet results to obtain",
// "facet results" => "facet results",
// "Search index outdated" => "Search index outdated",
// "Number of days to consider the search index outdated" => "Number of days to consider the search index outdated",
// "Show error on missing field" => "Show error on missing field",
// "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly" => "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly",
// "File thumbnail preview" => "File thumbnail preview",
// "Have a preview of attachments in search results" => "Have a preview of attachments in search results",
// "Use date histogram aggregations" => "Use date histogram aggregations",
// "Use date histogram aggregations (facets) when indexing, requires Elasticsearch" => "Use date histogram aggregations (facets) when indexing, requires Elasticsearch",
// "Date histogram aggregations interval" => "Date histogram aggregations interval",
// "Default interval for date histogram aggregations" => "Default interval for date histogram aggregations",
// "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0" => "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0",
// "Date range aggregations ranges" => "Date range aggregations ranges",
// "Default ranges for date range aggregations" => "Default ranges for date range aggregations",
// "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0" => "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0",
// "Excluded facets" => "Excluded facets",
// "List of facets (a.k.a. aggregations) to exclude from the default search results" => "List of facets (a.k.a. aggregations) to exclude from the default search results",
// "Avoid Duplicated Facets" => "Avoid Duplicated Facets",
// "Avoid Facets appearing with the same name, usually by appending the Tracker name" => "Avoid Facets appearing with the same name, usually by appending the Tracker name",
// "Parse wiki syntax in comments" => "Parse wiki syntax in comments",
"Parse wiki syntax in comments in all sections apart from Forums" => "Parse die Wikisyntax in Kommentaren in allen Abschnitten (außer Foren)",
"Use \"Accept wiki syntax\" for forums in admin forums page" => "Benutze \"Akzeptiere Wiki-Syntax\" für Foren auf der Foren-Verwaltungsseite",
// "Short URL" => "Short URL",
// "Provides the ability to create a short url, easy to share" => "Provides the ability to create a short url, easy to share",
// "Short URL base URL" => "Short URL base URL",
// "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website" => "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website",
"Sender email" => "E-Mailabsender",
"Email address that will be used as the sender for outgoing emails" => "E-Mailaddresse, die als Abesender für ausgehende E-Mails benutzt wird",
// "Sender full name" => "Sender full name",
// "Real name that will be used as the sender for outgoing emails" => "Real name that will be used as the sender for outgoing emails",
"Time zone" => "Zeitzone",
"Indicates the default time zone to use for the server" => "Gibt an, welche Standardzeitzone auf diesem Server benutzt werden soll",
"Session storage location" => "Speicherort für Sitzungsdaten",
"Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Wähle, wo die Sitzungsinformationen gespeichert werden sollen. Memcache-Sitzungen erfordern, dass Memcache konfiguriert wird",
"Default (from php.ini)" => "Standard (aus php.ini)",
"Database" => "Datenbank",
"Session lifetime" => "Lebenszeit von Sitzungdaten",
"Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance." => "Wert in Minuten. Dies ist die Minimalzeit, die Du eingeloggt bist. Wenn Du möchtest, dass es die genaue Zeit ist, musst Du in der .htaccess-Datei session.gc_probability und session.gc_divisor in 1 ändern. Sei vorsichtig, da die Änderung die Serverperformance beeinträchtigt.",
"Silent session" => "Stille Sitzung",
"Do not automatically start sessions" => "Starte Sitzungen nicht automatisch",
// "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)" => "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)",
// "Can cause problems when combined with cookie consent and JavaScript-disabled browsers" => "Can cause problems when combined with cookie consent and JavaScript-disabled browsers",
"Session cookie name" => "Sitzungs-Cookie-Name",
"Session cookie name used instead of the PHP default configuration" => "Name des Sitzungs-Cookies der anstelle der Standard-PHP-Konfiguration verwendet werden soll",
"Protect all sessions with HTTPS" => "Schütze alle Sitzungen mit HTTPS",
"Always redirect to HTTPS to prevent a session hijack through network sniffing" => "Immer zu HTTPS weiterleiten, um zu verhindern, dass die Sitzung durch Netzwerk-Sniffing entführt wird",
"Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site" => "Aktiviere dies nur, wenn Du SSL konfiguriert hast. Andernfalls sperrst Du Dich aus der Tiki aus",
"Display links on the share page" => "Zeige Links auf der Share-Seite",
"Token notification" => "Token-Benachrichtigung",
"Users can subscribe to the notifications of consultation of the token." => "Benutzer können die Benachrichtigungen über die Abfrage des Tokens abonnieren",
"Add contact" => "Füge Kontakt hinzu",
"If not already in the list, recipients are added to the list of contacts." => "Wenn er noch nicht existiert, dann wird der Empfänger in die Kontaktliste aufgenommen",
"Display name and email" => "Zeige Name und E-Mail",
"If the user is connected, the name and email will display in the page." => "Wenn Benutzer verbunden ist, werden Name und E-Mail in der Seite angezeigt",
// "Number of times accessed" => "Number of times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Maximum number of times accessed" => "Maximum number of times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "page hits" => "page hits",
// "The name of the default group" => "The name of the default group",
"Create with default group" => "Erstelle mit Standardgruppe",
"Valid affiliations" => "Gültige Mitgliedschaft",
// "A list of affiliations which will allow users to log in to this wiki" => "A list of affiliations which will allow users to log in to this wiki",
"Separate multiple affiliations with commas" => "Trenne multiple Mitgliedschaften durch Kommata",
"Shipping service" => "Transportservice",
"Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Zeige einen JSON-Dienst zur Kalkulation der Transportkosten. Providerkonten müssen ggf. angegeben werden (FedEx, UPS, ...)",
"FedEx API" => "FedEx API",
"Enable shipping rate calculation through FedEx APIs" => "Aktiviere die Transportkostenberechnung mittels der FedEx API",
"FedEx key" => "FedEx Schlüssel",
"Developer key" => "Entwickler Schlüssel",
"FedEx password" => "FedEx Passwort",
"FedEx meter number" => "FedEx Meter Nummer",
"FedEx account number" => "FedEx Kontonummer",
"UPS API" => "UPS API",
"Enable shipping rate calculation using the UPS carrier" => "Aktiviere die Berechnung von Transportkosten für den Transport mit UPS",
"UPS username" => "UPS Benutzername",
"UPS credentials" => "UPS Legitimation",
"UPS password" => "UPS Passwort",
"UPS access key" => "UPS Zugriffsschlüssel",
"Custom shipping provider" => "Benutzerdefinierter Anlieferer",
"Short date format" => "Kurzes Datumsformat",
// "Specify how Tiki displays the date (shorter version)" => "Specify how Tiki displays the date (shorter version)",
"Short time format" => "Kurzes Zeitformat",
// "Specify how Tiki displays the time (shorter version)" => "Specify how Tiki displays the time (shorter version)",
// "Short JavaScript date format" => "Short JavaScript date format",
// "Used in jQuery-UI date picker fields" => "Used in jQuery-UI date picker fields",
// "Short JavaScript time format" => "Short JavaScript time format",
// "Used in jQuery-UI datetime picker fields" => "Used in jQuery-UI datetime picker fields",
"%Y-%m-%d" => "%d.%m.%Y",
"%H:%M" => "%H:%M",
// "yy-mm-dd" => "yy-mm-dd",
// "HH:mm" => "HH:mm",
"%Y-%m-%d %H:%M" => "%d.%m.%Y %H:%M",
"Display available translations" => "Zeige verfügbare Übersetzungen",
// "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons" => "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons",
// "Close site" => "Close site",
// "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site" => "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site",
// "Coming soon" => "Coming soon",
"Message" => "Nachricht",
// "Site is closed for maintenance; please come back later" => "Site is closed for maintenance; please come back later",
// "Server is currently too busy; please come back later" => "Server is currently too busy; please come back later",
"Locations (breadcrumbs)" => "Positionszeichen (Brotkrumen, breadcrumbs)",
// "Examples:  » / >  : -> →" => "Examples:  » / >  : -> →",
"Choices" => "Auswahlen",
// "Examples: | / ¦  " => "Examples: | / ¦  ",
"Browser title position" => "Anordnung des Site-Titels",
// "Position of the browser title in the full browser bar relative to the current page's descriptor" => "Position of the browser title in the full browser bar relative to the current page's descriptor",
// "After current page's descriptor" => "After current page's descriptor",
// "Before current page's descriptor" => "Before current page's descriptor",
// "No browser title, only current page's descriptor" => "No browser title, only current page's descriptor",
// "Only browser title, no current page's descriptor" => "Only browser title, no current page's descriptor",
"Browser title display mode" => "Browser-Titel Anzeigemodus",
"When breadcrumbs are used, method to display the browser title." => "Wenn Brotkrumen genutzt werden: Methode in welcher der Browsertitel angezeigt werden soll.",
"Most-specific first" => "Genauestes Element zuerst",
"Least-specific first (site)" => "Allgemeinstes Element zuerst",
"Current only" => "Nur aktuelles Element",
// "Favicons" => "Favicons",
// "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used" => "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used",
"Site terminal" => "Site terminal",
"Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Erlaubt es, Benutzer abhängig von der original IP-Adresse in eine bestimmte Perspektive weiterzuleiten. Kann innerhalb von Intranets benutzt werden, um verschiedene Konfigurationen für Benutzer in Abhängigkeit ihrer Abteilung zu benutzen oder um Personen im Web auszuschließen. Unspezifische IPs werden standardmäßig behandelt, einschließlich der Multi-Domänen-Behandlung. Manuell gewählte Perspektiven haben vor dieser Regelung Vorrang",
"Site terminal configuration" => "Site terminal Konfiguration",
"Provides the mapping from subnets to perspective" => "Ermöglicht Abbildung aus Subnetzen auf Perspektive",
"One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "Eines pro Zeile. Netzwerkpräfix in CIDR-Notation (Adresse / Maskengröße), durch Komma getrennt mit der Perspektiv-ID",
// "Google Analytics account number" => "Google Analytics account number",
// "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY" => "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY",
// "Google Analytics Groups Option" => "Google Analytics Groups Option",
// "Define option for Google Analytics groups" => "Define option for Google Analytics groups",
// "Included" => "Included",
// "Excluded" => "Excluded",
// "Google Analytics Available Groups" => "Google Analytics Available Groups",
// "User groups for which Google Analytics will be available" => "User groups for which Google Analytics will be available",
// "Google Global Site Tag Mode" => "Google Global Site Tag Mode",
// "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js" => "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js",
// "Google authentication credentials file" => "Google authentication credentials file",
// "Path to the Google Service Account credentials JSON file" => "Path to the Google Service Account credentials JSON file",
// "Site layout" => "Site layout",
// "Changes the template for the overall site layout" => "Changes the template for the overall site layout",
// "Admin layout" => "Admin layout",
// "Specify which layout template to use for admin pages" => "Specify which layout template to use for admin pages",
// "Enable layout per page, etc" => "Enable layout per page, etc",
// "Specify an alternate layout for a particular wiki page, etc" => "Specify an alternate layout for a particular wiki page, etc",
// "Piwik server URL" => "Piwik server URL",
// "The URL to the Piwik server of this site" => "The URL to the Piwik server of this site",
// "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL" => "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL",
// "Site Id" => "Site Id",
// "The ID of this website in Piwik" => "The ID of this website in Piwik",
// "Piwik JavaScript tracking code" => "Piwik JavaScript tracking code",
// "Piwik Groups Option" => "Piwik Groups Option",
// "Define option for Piwik groups" => "Define option for Piwik groups",
// "Piwik Available Groups" => "Piwik Available Groups",
// "User groups for which piwik will be available" => "User groups for which piwik will be available",
// "Security timeout" => "Security timeout",
// "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case" => "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case",
// "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting" => "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting",
// "Code to be placed on every page of this website just before the </body> tag" => "Code to be placed on every page of this website just before the </body> tag",
"Publish" => "veröffentlichen",
// "Make the banner visible to all site visitors" => "Make the banner visible to all site visitors",
// "Activate must be turned on for Publish to take effect" => "Activate must be turned on for Publish to take effect",
"Logo source (image path)" => "Logo Quelle (Bildpfad)",
"Logo background color" => "Logo Hintergrundfarbe",
// "A legacy option to add a background color to the div that contains the logo image" => "A legacy option to add a background color to the div that contains the logo image",
"Examples:" => "Beispiele:",
"Logo title (on mouseover)" => "Logotitel bei Mouseover",
// "This appears as tool tip text. The site logo is also a link to the site index (top page)" => "This appears as tool tip text. The site logo is also a link to the site index (top page)",
"HTML \"alt\" tag description" => "Logo Alternativer Text (ALT)",
// "Normally a description of the image, such as \"Example.com logo\"" => "Normally a description of the image, such as \"Example.com logo\"",
// "Used by text browsers, screen readers, etc" => "Used by text browsers, screen readers, etc",
// "Site icon" => "Site icon",
// "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space" => "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space",
// "Recommended image height: 32 pixel" => "Recommended image height: 32 pixel",
// "Sitemap protocol" => "Sitemap protocol",
// "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines" => "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines",
"Include Smarty notices in the PHP error report" => "Füge auch Smarty Hinweise in den PHP Fehlerbericht hinzu",
"In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur" => "In den meisten Fällen können Smarty Hinweise ignoriert werden. Sie können aber hilfreich sein, wenn während der Entwicklung seltsame Probleme auftreten",
// "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages" => "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages",
// "Smarty security" => "Smarty security",
"Do not allow PHP code in Smarty templates" => "PHP-Code in Smarty-Vorlagen verbieten",
"You should leave this on unless you know what you are doing" => "Du solltest dies aktiviert lassen, wenn Du nicht genau weist, was Du tust",
// "Extra Smarty modifiers" => "Extra Smarty modifiers",
// "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates" => "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates",
// "There may be security implications. Make sure you know what you are doing" => "There may be security implications. Make sure you know what you are doing",
// "Extra Smarty functions" => "Extra Smarty functions",
// "Make additional PHP functions available as Smarty functions. This may be needed for custom templates" => "Make additional PHP functions available as Smarty functions. This may be needed for custom templates",
// "Extra Smarty directories" => "Extra Smarty directories",
// "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)" => "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)",
"Smarty compilation" => "Smarty Zusammenstellung",
"Indicates when the template cache should be refreshed" => "Zeigt an, wenn der Vorlagencache aktualisiert werden sollte",
"Modified" => "Geändert",
"Never check (performance)" => "Nie prüfen (performant)",
"Always (development, slow)" => "Immer (Entwicklung, langsam)",
// "Smarty cache permissions" => "Smarty cache permissions",
// "Permissions that enable Smarty to write to the templates_c directory" => "Permissions that enable Smarty to write to the templates_c directory",
// "User writable (0644)" => "User writable (0644)",
// "User & group writable (0664)" => "User & group writable (0664)",
// "Social network type" => "Social network type",
// "Select how the friendship relations within the social network should be treated" => "Select how the friendship relations within the social network should be treated",
// "Follow (as in Twitter)" => "Follow (as in Twitter)",
// "Friend (as in Facebook)" => "Friend (as in Facebook)",
// "Followers need approval" => "Followers need approval",
"Consumer key" => "Verbraucherschlüssel",
"Consumer key generated by registering this Tiki site as an application at Twitter" => "Verbraucherschlüssel, der bei der Registrierung Deiner Site bei Twitter erstellt wurde",
"Consumer secret" => "Verbrauchergeheimnis",
"Consumer secret generated by registering this Tiki site as an application at Twitter" => "Verbrauchergeheimnis, das bei der Registrierung Deiner Site bei Twitter erstellt wurde",
// "Twitter site name" => "Twitter site name",
// "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title" => "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title",
// "Twitter site image" => "Twitter site image",
// "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL" => "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL",
"Application secret" => "Anwendungsgeheimnis",
"Application secret generated by registering this Tiki site as an application at Facebook" => "Anwendungsgeheimnis, das bei der Registrierung Deiner Site bei Facebook erstellt wurde",
"Application ID" => "Anwendungs-ID",
"Application ID generated by registering this Tiki site as an application at Facebook" => "Anwendungs-IDS, die bei der Registrierung Deiner Site bei Facebook erstellt wurde",
// "Facebook site name" => "Facebook site name",
// "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title" => "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title",
// "Facebook site image" => "Facebook site image",
// "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices" => "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices",
"Login using Facebook" => "Login mittels Facebook",
"Allow users to log in using Facebook" => "Erlaubt Benutzern, sich mittels Facebook anzumelden",
"Auto-create Tiki user" => "Tiki-Benutzer automatisch erstellen",
"Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatisch Tikibenutzer mit dem Benutzernamen fb_xxxxxxxx für Benutzer erstellen, die sich mittels Facebook anmelden und noch kein Tiki Konto haben. Wenn nicht, werden sie gefragt, ein Tiki Konto zu verlinken oder sich zu registrieren",
// "Require Facebook users to enter local account info on creation" => "Require Facebook users to enter local account info on creation",
"Require Facebook users to enter local account info, specifically email and local log-in name" => "Erfordert vom Facebookbenutzer, dass lokale Konteninformationen angegeben werden, insbesondere E-Mail und lokaler Anmeldenamen",
// "Tiki can post to the Facebook wall" => "Tiki can post to the Facebook wall",
// "Tiki may post status messages, notes, photos, and videos to the Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to the Facebook Wall",
"Tiki can manage events" => "Tiki kann Ereignisse verwalten",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
"Tiki can manage pages" => "Tiki kann Seiten verwalten",
"Tiki can manage user pages." => "Tiki kann Benutzerseiten verwalten",
"Tiki can SMS" => "Tiki kann SMS",
"Tiki can use SMS functions via Facebook." => "Tiki kann SMS via Facebook senden",
// "Set user email from Facebook on creation" => "Set user email from Facebook on creation",
// "Create a user tracker item on registration" => "Create a user tracker item on registration",
// "First and last name tracker field IDs to set on creation" => "First and last name tracker field IDs to set on creation",
// "bit.ly login" => "bit.ly login",
"Site-wide log-in name (username) for bit.ly" => "Site-weites Login (Benutzernamen) für bit.ly",
// "bit.ly key" => "bit.ly key",
"Site-wide API key for bit.ly" => "Site-weiter API Schlüssel für bit.ly",
"Use site-wide account" => "Benutze Konto für gesamte Site",
// "When set to \"yes\", only the site-wide account will be used for all users" => "When set to \"yes\", only the site-wide account will be used for all users",
// "Client ID" => "Client ID",
// "Client ID generated by registering this site as an application at LinkedIn" => "Client ID generated by registering this site as an application at LinkedIn",
// "Client secret" => "Client secret",
// "Client Secret generated by registering this site as an application at LinkedIn" => "Client Secret generated by registering this site as an application at LinkedIn",
// "Log in using LinkedIn" => "Log in using LinkedIn",
// "Allow users to log in using LinkedIn" => "Allow users to log in using LinkedIn",
// "Auto-create Tiki user from LinkedIn" => "Auto-create Tiki user from LinkedIn",
// "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Set user email from LinkedIn on creation" => "Set user email from LinkedIn on creation",
// "Tiki will set the user's email from Facebook on creation" => "Tiki will set the user's email from Facebook on creation",
// "Sets whether a tracker item should be created for the user upon registration" => "Sets whether a tracker item should be created for the user upon registration",
// "Comma-separated, with first name field followed by last name field; for example, '2,3'" => "Comma-separated, with first name field followed by last name field; for example, '2,3'",
// "Tiki will set the user's email from LinkedIn on creation" => "Tiki will set the user's email from LinkedIn on creation",
// "Stored searches" => "Stored searches",
// "Allow users to store search queries" => "Allow users to store search queries",
// "Expose Jitsi provision URL" => "Expose Jitsi provision URL",
// "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server" => "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server",
// "Jitsi configuration" => "Jitsi configuration",
// "Content of a Jitsi-format Java properties file" => "Content of a Jitsi-format Java properties file",
// "Location where tracker attachment files are stored" => "Location where tracker attachment files are stored",
// "Filesystem" => "Filesystem",
// "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory" => "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory",
// "Site theme" => "Site theme",
// "Icons of the displayed theme" => "Icons of the displayed theme",
// "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com" => "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com",
// "Site theme option" => "Site theme option",
// "Supplemental style sheet for the selected theme" => "Supplemental style sheet for the selected theme",
// "theme option, theme-option, style option, options, css" => "theme option, theme-option, style option, options, css",
// "Custom theme URL" => "Custom theme URL",
// "Local or external URL of the custom Bootstrap-compatible CSS file to use" => "Local or external URL of the custom Bootstrap-compatible CSS file to use",
// "Admin theme" => "Admin theme",
// "Theme for the settings panels and other administration pages" => "Theme for the settings panels and other administration pages",
// "Admin theme option" => "Admin theme option",
// "Option theme includes main theme CSS" => "Option theme includes main theme CSS",
// "Don't include the main theme stylesheet because its contents are included in the option stylesheet" => "Don't include the main theme stylesheet because its contents are included in the option stylesheet",
// "Navbar background color" => "Navbar background color",
// "Dark" => "Dark",
// "Light" => "Light",
// "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme" => "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme",
// "Fixed topbar offset" => "Fixed topbar offset",
// "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content" => "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content",
// "topbar offset, top offset, fixed topbar, top padding, offset" => "topbar offset, top offset, fixed topbar, top padding, offset",
"Icons" => "Symbole",
// "Icon set used by the site" => "Icon set used by the site",
// "Theme Customizer tool" => "Theme Customizer tool",
// "Activate the theme customizer tool to enable easy theme customization" => "Activate the theme customizer tool to enable easy theme customization",
"Check frequency" => "Prüfhäufigkeit",
// "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. " => "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. ",
// "Click \"Check for Updates Now\" to perform an update check" => "Click \"Check for Updates Now\" to perform an update check",
"Each day" => "täglich",
"Each week" => "wöchentlich",
"Each month" => "Monatlich",
// "Upgrade cycle" => "Upgrade cycle",
// "Tiki upgrade frequency for this site to check against" => "Tiki upgrade frequency for this site to check against",
// "Regular (8 months)" => "Regular (8 months)",
// "Long-Term Support" => "Long-Term Support",
"Minify JavaScript" => "Verkleinere JavaScript",
"Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Komprimiere JavaScript-Dateien, die auf der Seite genutzt werden, in eine einzelne Datei, um sie statisch zu verteilen. Veränderungen an den JavaScript-Dateien erfordern den Cache zu löschen. Benutzt http://code.google.com/p/minify/",
// "Minify late JavaScript" => "Minify late JavaScript",
// "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page" => "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page",
"Minify CSS" => "Verkleinere CSS",
// "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared" => "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared",
// "Uses http://code.google.com/p/minify/" => "Uses http://code.google.com/p/minify/",
"Minify CSS into a single file" => "Verkleinere CSS in eine einzelne Datei",
"In addition to reducing the size of the CSS files, reduce the number of files by consolidating them" => "Um zusätzlich die Größe des CSS zu reduzieren, verringere die Anzahl der einzubindenden Dateien",
"This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"" => "Diese Einstellung kann ggf. nicht ohne weiteres für alle Stile funktionieren. Import muss @import url(\"...\") und nicht @import \"...\" benutzen",
// "Prefix CSS" => "Prefix CSS",
// "Use -prefix-free JavaScript library to add vendor specific css prefixes" => "Use -prefix-free JavaScript library to add vendor specific css prefixes",
// "May be replaced by a server-side option soon" => "May be replaced by a server-side option soon",
"Skip date for same day" => "Datum bei Anzeige für den heutigen Tag weglassen",
"When displaying short date and time, skip date for today. Only time will be displayed" => "Wenn das kurze Datums- und Zeitformat genutzt wird, lasse das Datum für heute weg. Nur die Zeit wird angezeigt",
"Cache-control header" => "Kopf Cache-Kontrolle",
"Custom HTTP header to use when a session is active" => "Benutzerdefinierter HTTP Kopf wenn eine Sitzung aktiv ist",
"Example: no-cache, pre-check=0, post-check=0" => "Beispiel: no-cache, pre-check=0, post-check=0",
"Cache-control header (no session)" => "Kopf Cache-Kontrolle (keine Sitzung)",
"Custom HTTP header to use when no session is active" => "Benutzerdefinierter HTTP Kopf, wenn keine Sitzung aktiv ist",
// "Content delivery networks" => "Content delivery networks",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance",
// "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com",
// "Content delivery networks in SSL" => "Content delivery networks in SSL",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode",
// "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com",
// "Check CDN files exists" => "Check CDN files exists",
// "Check that minified JS and CSS files exist before including them in the page" => "Check that minified JS and CSS files exist before including them in the page",
"Domain prefix handling" => "Behandlung des Domain Präfix",
"Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Entferne oder füge automatisch das www.-Präfix zu Domänennamen hinzu um URLs zu vereinheitlichen",
"Leave as-is" => "Lass es wie es ist",
"Remove the www" => "Entferne das WWW",
"Add the www" => "Füge WWW hinzu",
"Domain redirects" => "Domainweiterleitungen",
"When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "Wenn die Site von speziellen Domänennamen aufgerufen wird, leite auf eine alternative Domäne weiter und Beibehaltung der URL. Hilfreich für Domänennamenübergänge, wie z.B. tikiwiki.org zu tiki.org",
"One entry per line, with each entry a comma-separated list: old domain, new domain" => "Ein Eintrag pro Zeile. Einträge sind mit Komma zu trennen: alte Domain, neue Domain",
"Validate uploaded file content" => "Validiere hochgeladenen Dateiinhalt",
"Do not trust user input and open the files to verify their content" => "Vertraue keinen Benutzereingaben und öffne die Dateien, um deren Inhalt zu prüfen",
"Allow the tiki_p_trust_input permission" => "Erlaube die tiki_p_trust_input Berechtigung",
"Bypass user input filtering." => "Umgeht die Filterung von Benutzereingaben",
"Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Beachte: alle Berechtigungen werden der Administratorgruppe, einschließlich dieser, gewährt. Wenn Du dies aktivierst, kannst Du Deine Site XSS-Attacken (Cross Site Scripting) für Administratoren aussetzen",
// "Object selector threshold" => "Object selector threshold",
// "Number of records after which the object selectors will request searching instead of selecting from a list" => "Number of records after which the object selectors will request searching instead of selecting from a list",
// "Object selector search field" => "Object selector search field",
// "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")" => "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")",
// "Client key for this site" => "Client key for this site",
// "This must match the shared key entered in the Master’s key field" => "This must match the shared key entered in the Master’s key field",
// "Synchronize remote tracker" => "Synchronize remote tracker",
"Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand" => "Erlaubt es einen Tracker auf einem Remote Host zu klonen und die Daten nach Bedarf lokal zu synchronisieren",
"Refresh item link items when the master is modified" => "Aktualisiere Objektlink-Einträge, wenn der Haupteintrag verändert wird",
"To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "Zur Verwendung bei Objektlinks in Trackern. Dadurch bleibt der Index in gutem Zustand wenn Daten im indexierten Haupteintrag verändert und zur Suche benutzt werden",
// "Refresh items list items when related items are created or modified" => "Refresh items list items when related items are created or modified",
// "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified" => "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified",
// "Clone tracker items" => "Clone tracker items",
// "Allow copying tracker item information to a new tracker item" => "Allow copying tracker item information to a new tracker item",
// "Trackers available for insertion from wiki pages" => "Trackers available for insertion from wiki pages",
// "List of tracker IDs made available when attempting to insert" => "List of tracker IDs made available when attempting to insert",
// "Change field types" => "Change field types",
// "Allow field type to be changed after creation" => "Allow field type to be changed after creation",
// "Use with care" => "Use with care",
// "Show comments below items" => "Show comments below items",
// "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab" => "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab",
// "Use legacy tracker insertion screen" => "Use legacy tracker insertion screen",
// "Use the legacy tracker insertion screen (a tab) instead of a popup dialog" => "Use the legacy tracker insertion screen (a tab) instead of a popup dialog",
// "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful" => "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful",
// "Show tracker status in objectlink" => "Show tracker status in objectlink",
// "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs" => "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs",
// "Sync wiki page name to linked tracker field" => "Sync wiki page name to linked tracker field",
// "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation" => "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation",
// "Redirect page views to the linked tracker item" => "Redirect page views to the linked tracker item",
// "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL" => "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL",
// "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL" => "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL",
// "Tracker for articles" => "Tracker for articles",
// "Have a tracker to supplement article information" => "Have a tracker to supplement article information",
// "Tracker ID of tracker for articles" => "Tracker ID of tracker for articles",
// "A tracker for articles must contain an \"Articles\" field" => "A tracker for articles must contain an \"Articles\" field",
// "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items" => "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items",
// "Tracker tabular" => "Tracker tabular",
// "Allows management of import/export tracker profiles and management of custom list formats" => "Allows management of import/export tracker profiles and management of custom list formats",
// "Always notify watchers" => "Always notify watchers",
// "Send item updated notifications to watchers even if nothing has changed" => "Send item updated notifications to watchers even if nothing has changed",
// "Require users to fill in tracker information" => "Require users to fill in tracker information",
// "Tracker ID of tracker required to be filled in" => "Tracker ID of tracker required to be filled in",
// "Mandatory tracker field to check for required filling in" => "Mandatory tracker field to check for required filling in",
// "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it" => "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it",
// "Fields that are asked for in the modal for force-filling" => "Fields that are asked for in the modal for force-filling",
// "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested" => "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested",
// "Tracker item links use prefix alias" => "Tracker item links use prefix alias",
// "Links for tracker items will use the prefix alias automatically everywhere" => "Links for tracker items will use the prefix alias automatically everywhere",
// "Tracker report resize button" => "Tracker report resize button",
// "Add a button to resize long tracker reports" => "Add a button to resize long tracker reports",
// "Tracker list order" => "Tracker list order",
// "Default order for the main tracker list" => "Default order for the main tracker list",
// "Id Ascending" => "Id Ascending",
// "Id Descending" => "Id Descending",
"Created Ascending" => "Erstellung aufsteigend",
"Created Descending" => "Erstellung absteigend",
"Name Ascending" => "Name aufsteigend",
"Name Descending" => "Name absteigend",
// "Last Modified Ascending" => "Last Modified Ascending",
// "Last Modified Descending" => "Last Modified Descending",
// "Number of Items Ascending" => "Number of Items Ascending",
// "Number of Items Descending" => "Number of Items Descending",
// "Tracker History Diff Style" => "Tracker History Diff Style",
// "Default style for tracker history" => "Default style for tracker history",
"Original" => "Original",
// "Index article info in tracker item" => "Index article info in tracker item",
// "Require users to fill in a tracker form if not done already by prompting them with a modal dialog" => "Require users to fill in a tracker form if not done already by prompting them with a modal dialog",
// "Storage settings when file galleries are not used" => "Storage settings when file galleries are not used",
"Unified search engine" => "Suchmaschiene für vereinheitlichte Suche",
"Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server" => "Suchmaschinen, die für die Indexierung des Inhalts Deiner Tiki benutzt werden. Einige Maschinen sind geeigneter für größere Sites, erfordern aber zusätzliche Software auf dem Server",
// "Lucene (PHP implementation) - Deprecated" => "Lucene (PHP implementation) - Deprecated",
// "Elasticsearch" => "Elasticsearch",
"Lucene index location" => "Speicherort für den Lucene Index",
"Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database." => "Pfad zum Lucene Suchindex. Der Index muss sich im lokalen Dateisystem befinden, und zwar mit genug Speicher, um die Datenbank aufzunehmen.",
"Highlight results snippets" => "Hebe die Suchergebnisse hervor",
"Highlight the result snippet based on the search query to improve user experience" => "Hebe die Suchergebnisse auf Basis der Suchanfrage hervor. Wird die Option aktiviert kann es zu Performanceproblemen kommen. Die Benutzung wird jedoch benutzerfreundlicher..",
"Lucene maximum results" => "Maximale Ergebnisse Lucene",
"Maximum number of results to produce. Results beyond these will need a more refined query to be reached" => "Maximale Menge an anzuzeigenden Ergebnissen. Darüber hinausgehende Ergebnisse benötigen eine stärker verfeinerte Suche",
// "results" => "results",
"Lucene maximum result-set limit" => "Grenze für maximales Lucene Ergebnis",
"Maximum size of result set to consider" => "Maximale Größe des Ergebnissatzes. Standard 1000, 0 = unbegrenzt",
"This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "Dies wird benötigt, wenn Ergebnisränge und Sortierreihenfolgen berechnet werden. Dies kann bei größeren Datenmengen zu \"Zu wenig Speicher\"-Fehlermeldungen führen. Der Standardwert von 1000 ist mit einem PHP memory_limit von 128M sicher benutzbar",
// "result sets" => "result sets",
"Lucene terms per query limit" => "Begrenzung für Begriffe pro Suche",
"Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximale Anzahl von zu erstellenden Begriffen. Erhöhe diesen Wert, wenn Du eine Fehlermeldung (Terms per query limit is reached) erhältst. Kann insbesondere bei Suchen mit Platzhaltern, Bereichssuchen und Fuzzy-Suchen auftreten",
// "terms" => "terms",
"Lucene maximum number of buffered documents" => "Lucene maximale Anzahl gepufferter Dokumente",
"Number of documents required before the buffered in-memory documents are written into a new segment" => "Erforderliche Anzahl von Dokumenten bevor die im Speicher gepufferten Dokumente in ein neues Segment geschrieben werden",
// "documents" => "documents",
"Lucene maximum number of merge documents" => "Lucene maximal verschmolzene Dokumente",
"Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Größte Zahl von Dokumenten, die jemals von addDocument() verschmolzen wurden. Kleine Werte (z.B. weniger als 10.000) sind am besten für interaktives Indexieren, weil hierdurch die Länge der Pausen beim Indexieren auf wenige Sekunden beschränkt wird. Größere Werte sind am besten für Stapelindexieren und schnellere Suchen",
"Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Kleine Werte (z.B. weniger als 10.000) sind am besten für interaktives Indexieren. Benutze 0 für den Lucene-Standard (praktisch unendlich)",
// "merge documents" => "merge documents",
// "Default Boolean Operator" => "Default Boolean Operator",
"Use OR or AND as the default search operator" => "Benutze OR (oder, Standard) oder AND (und) als Standardoperator",
"AND" => "AND",
"OR" => "OR",
"Lucene merge factor" => "Lucene Verschmelzungs-Faktor",
"How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster" => "Wie oft Indexsegmente von addDocument() verschmolzen werden. Kleinere Werte verbrauchen beim Indexieren weniger RAM. Suche in nicht optimierten Indizes ist schneller aber die Indexierungsgeschwindigkeit ist langsamer. Größere Werte verbrauchen mehr RAM beim Indexieren. Suchen in nicht optimierten Indexen ist langsamer, die Indexierung aber schneller. Dadurch sind größere Werte (> 10) am besten für Stapelindexierung und kleinere Werte (< 10) für interaktiv gewartete Indizes",
"Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained" => "Größere Werte (> 10) sind am besten für Stapelindexierung und kleinere Werte (< 10) für interaktiv gewartete Indizes",
"Incremental Index Update" => "Inkrementelle Index-Aktualisierung",
"Update the index incrementally as the site content is modified" => "Aktualisiere den Index inkrementell, wenn der Inhalt der Site verändert wird. Das kann zu geringerer Performance und Genauigkeit führen, als wenn der Index periodisch erstellt wird.",
// "This may lead to lower performance and accuracy than processing the index on a periodic basis" => "This may lead to lower performance and accuracy than processing the index on a periodic basis",
"Field weights" => "Feldgewichtung",
// "Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results" => "Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results",
// "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search" => "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search",
"One field per line, field_name__:__5.3" => "Ein Feld pro Zeile, Feld_Name__:__5.3",
"Default content fields" => "Standard Inhaltsfelder",
// "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search" => "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search",
"Tokenize version numbers" => "Markiere Versionsnummern",
"Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7." => "Markiere Versionsnummern, so dass Hauptversionen gefunden werden, wenn Unterversionen genannten sind. Z.B. Eine suche nach 2.7 findet Dukumente, die 2.7.4 enthalten, nicht aber solche mit 1.2.7.",
// "Cache per user and query for Tiki built-in search" => "Cache per user and query for Tiki built-in search",
// "Time in minutes a user has a same query cached applied to Tiki built-in search interface only" => "Time in minutes a user has a same query cached applied to Tiki built-in search interface only",
"Index forum replies together with initial post" => "Indexiere Forenantworten mit dem Stammeintrag",
"Forum replies will be indexed together with the initial post as a single document instead of being indexed separately." => "Wenn aktiviert, werden Forenantworten zusammen mit dem Stammeintrag als ein einheitliches Dokument indexiert (anstelle einer getrennten Indexierung)",
// "Relation types to index within object" => "Relation types to index within object",
// "Comma-separated relation types for which objects should be indexed in their related objects" => "Comma-separated relation types for which objects should be indexed in their related objects",
// "Elasticsearch needed" => "Elasticsearch needed",
// "Cache individual search formatters" => "Cache individual search formatters",
// "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache" => "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache",
"Format to use for tracker field keys" => "Zu benutzendes Format für Tracker-Feldschlüssel",
"Choose between field IDs and permanent names for the tracker indexing" => "Wähle zwischen Feld-IDs und dauerhaften Namen für die Tracker-Indexierung",
"Permanent name" => "Permanenter Name",
"Field ID (backward compatibility mode with Tiki 7 and 8)" => "Feld-ID (Abwärtskompatibilitätsmodus zu Tiki 7 und 8)",
// "Index Tracker Category names" => "Index Tracker Category names",
// "Index the names and paths of category field values" => "Index the names and paths of category field values",
// "Requires reindexing" => "Requires reindexing",
// "Cache result-specific formatted results" => "Cache result-specific formatted results",
// "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific" => "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific",
// "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature" => "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature",
// "Excluded categories" => "Excluded categories",
// "List of category IDs to exclude from the search index" => "List of category IDs to exclude from the search index",
// "Excluded plugins" => "Excluded plugins",
// "List of plugin names to exclude while indexing" => "List of plugin names to exclude while indexing",
// "Exclude all plugins" => "Exclude all plugins",
// "Indexing will exclude all plugins" => "Indexing will exclude all plugins",
// "Except included plugins" => "Except included plugins",
// "List of plugin names that are required to be included while indexing, when excluding all" => "List of plugin names that are required to be included while indexing, when excluding all",
// "Example: fancytable,list,trackerlist,trackerfilter" => "Example: fancytable,list,trackerlist,trackerfilter",
// "Elasticsearch URL" => "Elasticsearch URL",
// "URL of any node in the cluster" => "URL of any node in the cluster",
// "Elasticsearch index prefix" => "Elasticsearch index prefix",
// "The prefix that is used for all indexes for this installation in Elasticsearch" => "The prefix that is used for all indexes for this installation in Elasticsearch",
// "Elasticsearch current index" => "Elasticsearch current index",
// "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index" => "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index",
// "Do not change this value unless you know what you are doing" => "Do not change this value unless you know what you are doing",
// "Tokenize CamelCase words" => "Tokenize CamelCase words",
// "Consider the components of camel-case words as separate tokens, allowing them to be searched individually" => "Consider the components of camel-case words as separate tokens, allowing them to be searched individually",
// "Conflicts with Tokenize Version Numbers" => "Conflicts with Tokenize Version Numbers",
// "Elasticsearch field limit per index" => "Elasticsearch field limit per index",
// "fields" => "fields",
// "The maximum number of fields per search index in Elasticsearch version 5.x and above" => "The maximum number of fields per search index in Elasticsearch version 5.x and above",
// "Use MySQL Full-Text Search (fallback)" => "Use MySQL Full-Text Search (fallback)",
// "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback" => "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback",
// "MySQL full-text search current index" => "MySQL full-text search current index",
// "Unified index identifier fields (Internal)" => "Unified index identifier fields (Internal)",
// "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding" => "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding",
// "Use unified search in category admin" => "Use unified search in category admin",
// "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index" => "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index",
// "Stop Word List" => "Stop Word List",
// "Words excluded from the search index, because they can be too frequent and produce unwanted results" => "Words excluded from the search index, because they can be too frequent and produce unwanted results",
// "MySQL full-text search has its own list of stop words configured in the server" => "MySQL full-text search has its own list of stop words configured in the server",
// "Automatically trim Elasticsearch results on date-sorted query" => "Automatically trim Elasticsearch results on date-sorted query",
// "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date" => "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date",
// "Highlight results pages" => "Highlight results pages",
// "Highlight words on the result pages based on the search query" => "Highlight words on the result pages based on the search query",
// "Plugins tab of the textarea control panel loads with an empty list" => "Plugins tab of the textarea control panel loads with an empty list",
// "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially" => "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially",
// "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")" => "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")",
// "Possessive Stemmer" => "Possessive Stemmer",
// "LIST plugin cache default on" => "LIST plugin cache default on",
// "If selected, LIST plugins will be cached by default unless turned off at plugin level" => "If selected, LIST plugins will be cached by default unless turned off at plugin level",
// "LIST plugin cache default expiry" => "LIST plugin cache default expiry",
// "Default number of minutes for LIST plugin cache expiry" => "Default number of minutes for LIST plugin cache expiry",
// "The possessive stemmer removes possessives (trailing \"'s\\" => "The possessive stemmer removes possessives (trailing \"'s\\",
"Re-validate user by email after" => "Re-validiere Benutzer per E-Mail nach",
"unsuccessful login attempts" => "erfolglosen Login Versuchen",
// "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password" => "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password",
// "brute force, brute-force, login failure, login-failure, failed logins" => "brute force, brute-force, login failure, login-failure, failed logins",
"Suspend account after" => "Konto sperren nach",
// "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again",
"URL the user is redirected to after account validation" => "URL, auf die ein Benutzer nach Validierung seines Kontos weitergeleitet wird",
// "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"" => "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"",
"Account validated successfully." => "Konto erfolgreich bestätigt.",
"The URL that the anonymous user is redirected to when a page is not found" => "URL, auf die ein anonymer Benutzer weitergeleitet wird, wenn die Seite nicht gefunden wird",
// "Use Only ASCII in SEFURLs" => "Use Only ASCII in SEFURLs",
// "Do not use accented characters in short (search engine friendly) URLs" => "Do not use accented characters in short (search engine friendly) URLs",
// "Close site when server load is above the threshold" => "Close site when server load is above the threshold",
"Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site" => "Site schließen, wenn die Serverlast über der Schwelle liegt (außer für diejenigen mit Rechten)",
"Use proxy" => "Proxy benutzen",
"Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified" => "Proxy benutzen",
"Use context menus for actions (icons)" => "Benutze Kontextmenüs für Aktionen (Symbole)",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
"Use context menus for actions (text)" => "Benutze Kontextmenüs für Aktionen (Text)",
// "Show user's real name" => "Show user's real name",
"Show the user's real name instead of username (log-in name), when possible." => "Zeige den Echtnamen des Benutzers anstelle seines Anmeldenamens (wenn möglich)",
// "User emails must be unique" => "User emails must be unique",
// "The email address of each user must be unique" => "The email address of each user must be unique",
"Display user tracker information on the user information page" => "Zeige Benutzertrackerinformationen auf der Benutzerinformationseite",
"Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Trage die BenutzertrackerID, dann die FeldIDs ein, die angezeigt werden sollen. Alle getrennt durch Kommata. Beispiel: 1,1,2,3,4 (BenutzertrackerID 1 gefolgt von den FeldIDs 1-4)",
"Users can configure modules" => "Benutzer kann Module konfigurieren",
// "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user" => "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user",
"Users can open and close the modules" => "Benutzer kann Module ausblenden",
"Allows users to open and close modules using the icon in the module header" => "Erlaube Benutzern Module anzuzeigen/zu verstecken",
"Module decides" => "Wahl durch Modul",
"Store full-size copy of profile picture in file gallery" => "Speichere Kopie des Avatar in voller Größe in den Dateiarchiven",
// "Size of the small profile picture stored for users" => "Size of the small profile picture stored for users",
// "Crop the profile picture thumbnail to a square" => "Crop the profile picture thumbnail to a square",
"File gallery in which to store full-size profile picture" => "Dateiarchiv benutzen um eine Kopie des Avatars in voller Größe zu speichern",
"Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Trage die Archiv-ID hier ein. Bitte erstelle ein zweckbestimmtes Archiv, welches aus Sicherheitsgründen nur für Administratoren ist oder stelle sicher, dass Dateiarchiv-Berechtigungen so eingestellt sind, dass nur Administratoren bearbeiten können",
"File ID of default profile picture" => "Datei-ID des Standard-Avatar-Bildes",
"File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries" => "Datei-ID des im Dateiarchiv zu benutzenden Bildes als Avatar, wenn der Benutzer kein Avatarbild hat",
"Display who has viewed \"my items\" on the user information page" => "Zeige an, wer meine Sachen auf der Benutzerinformationseite angesehen hat",
"This requires activation of tracking of views for various items in the action log" => "Du musst die Überwachung des Ansehens verschiedener Objekte im Aktionslog aktivieren, damit dies funktoniert",
// "Length of \"who viewed my items\" history" => "Length of \"who viewed my items\" history",
"Number of days before the current day to consider when displaying \"who viewed my items\"" => "Anzahl von Tagen, vor aktueller Zeit, anhand der festgelegt wird, ob jemand unter \"Wer sieht meine Sachen an\" angezeigt wird",
"Show to others \"who viewed my items\" on the user information page" => "Zeige anderen auf der Benutzerinformationseite, wer meine Sachen angesehen hat",
"Show to others \"who viewed my items\" on the user information page. Admins can always see this information" => "Zeige anderen, wer sich meine Sachen ansicht auf der Benutzerinformationsseite. Administratoren können diese Informationen immer sehen",
"Use pretty trackers for registration form" => "Benutze schöne Tracker für das Registrierungsformular",
"Registration pretty tracker template" => "Vorlage für schönen Registrierungstracker",
"Use a wiki page name or Smarty template file with a .tpl extension." => "Benutze Wiki Seiten Namen oder Vorlage-Datei mit .tpl-Dateiendung",
// "Hide Mandatory" => "Hide Mandatory",
// "Hide mandatory fields indication with an asterisk (shown by default)" => "Hide mandatory fields indication with an asterisk (shown by default)",
"Output the registration results" => "Gebe die Eingaben des Registrierungsformulars aus",
"Use a wiki page as template to output the registration results to" => "Benutze eine Wiki-Seite als Vorlage zur Ausgabe der Registrierungseingaben",
"Output registration pretty tracker template" => "Ausgabevorlage des schönen Registrierungstrackers",
"Wiki page only" => "Nur Wiki-Seiten",
"Page name field ID" => "Seitennamenfeld-Id",
"User tracker IDs to sync prefs from" => "Benutze Tracker-IDs, um Einstellungen zu sychronisieren",
"Select one or more trackers to sync user preferences from" => "Trage die (durch Komma getrennten) IDs der Tracker ein, mit denen die Benutzereinstellungen synchronisiert werden sollen",
"Tracker field IDs to sync the \"real name\" pref from" => "Trackerfeld-IDs, um Einstellungen des Echtnamen zu synchronisieren",
"Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"." => "Trage die IDs getrennt mit Kommata in der Priorität ihrer Auswahl ein. Jeder Eintrag kann multiple Felder mit einem + verketten, z.B. 2+3,4",
// "Tracker field IDs to sync user groups" => "Tracker field IDs to sync user groups",
// "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups" => "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups",
"Synchronize long/lat/zoom to location field" => "Synchronisiere Länge/Breite/Zoom mit Lokalisierungs-Feld",
"Synchronize user geolocation preferences with the main location field." => "Synchronisiere Geolokalisierung des Benutzers mit dem Haupt-Lokalisierungs-Feld",
"Change user system language when changing user tracker item language" => "Ändere Benutzersprache im System, wenn die Sprache des Trackereintrages des Benutzers geändert wird",
// "Assign a user tracker item when registering if email equals this field" => "Assign a user tracker item when registering if email equals this field",
// "Maximum users in drop-down lists" => "Maximum users in drop-down lists",
// "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large" => "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large",
"users" => "Benutzer",
"Use the user's real name instead of log-in name in the autocomplete selector in trackers" => "Benutze den Echtnamen des Benutzers anstelle seines Login in der Autovervollständigenauswahl in Trackern",
"Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature." => "Benutze den Echtnamen des Benutzers anstelle seines Login in der Autovervollständigenauswahl in der Nachrichtenfunktion",
// "User favorites" => "User favorites",
"Enable users to flag content as their favorite" => "Erlaubt es Benutzern Inhalte als deren Favoriten zu markieren",
// "User likes" => "User likes",
// "Enable users to \"like\" content" => "Enable users to \"like\" content",
"Users must choose a group at registration" => "Benutzer müssen eine Gruppe beim Registrieren wählen",
"Users cannot register without choosing one of the groups indicated above" => "Benutzer können sich nicht registrieren, ohne zuvor eine der oben definierten Gruppen auszuwählen",
// "Users available in search results" => "Users available in search results",
// "Users available within search results. Content related to the user will be included in the index" => "Users available within search results. Content related to the user will be included in the index",
"Public" => "öffentlich",
// "Use Gravatar for user profile pictures" => "Use Gravatar for user profile pictures",
// "Always request the Gravatar image for the user profile picture" => "Always request the Gravatar image for the user profile picture",
// "Configuration for multilike" => "Configuration for multilike",
// "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)" => "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)",
// "Force users to upload an avatar" => "Force users to upload an avatar",
"Score ascending" => "Punkte aufsteigend",
"Score descending" => "Punkte absteigend",
"Name ascending" => "Name aufsteigend",
"Name descending" => "Name absteigend",
"Login ascending" => "Login aufsteigend",
"Login descending" => "Login absteigend",
"User the tracker's field ID whose value is used as the output page name." => "Id des Benutzertrackerfeldes, dessen Wert als Seitenname der Ausgabe genutzt wird",
// "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup" => "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup",
"Quota" => "Kontingent",
"Private" => "privat",
// "Users cannot see each other's files or galleries" => "Users cannot see each other's files or galleries",
// "Users can see each other's files, but don't see the galleries in listings" => "Users can see each other's files, but don't see the galleries in listings",
"Username pattern" => "Muster für Benutzernamen",
// "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/" => "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/",
"Serve profile pictures statically" => "Avatarbilder statisch anliefern",
"When enabled, feature checks and permission checks will be skipped" => "Wenn aktiviert wird die Funktionen- und die Berechtigungs-Überprüfung übersprungen",
"Displayed time zone" => "Angezeigte Zeitzone",
"Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback." => "Benutze die Zeitzone aus den Benutzereinstellungen oder entnehme die Zeitzone dem Browser (bei anonymen Benutzern). Wenn alles nicht möglich: greife auf die Standardzeitzone zurück.",
"Always the site default time zone." => "Benutzer immer die Standard Site-Zeitzone.",
"Number of visited pages to remember" => "Anzahl besuchter Seiten zum Vorhalten",
// "visited pages" => "visited pages",
"User information" => "Benutzerangaben",
// "Specify if the user's information is public or private" => "Specify if the user's information is public or private",
"Use 12-hour clock for time selectors" => "Benutze 12-Stunden-Uhr für Zeitauswahl",
"Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc" => "Benutze die 12-Stunden-Uhr (mit AM und PM) für Zeitauswahlen, die in manchen Bearbeitungsfenstern für die Angabe des Veröffentlichungs- und Bearbeitungsdatums verwendet werden",
"Use interface that shows differences in any versions" => "Benutze neue Benutzeroberfläche für Unterschiedsanzeige für alle Versionen",
"Tasks per page" => "Aufgaben pro Seite",
// "tasks" => "tasks",
"20" => "20",
"40" => "40",
"50" => "50",
"Messages per page" => "Nachrichten pro Seite",
"Allow messages from other users" => "Nachrichten von anderen Anwendern erlauben",
"Notify sender when reading mail" => "Absender benachrichtigen, wenn E-Mail gelesen wird",
"Send me an email for messages with priority equal to or greater than" => "Schicke mir eine E-Mail beim Eintreffen von Nachrichten mit Priorität größer gleich",
// "priority" => "priority",
"Auto-archive read messages after" => "Autoarchiviere gelesene Nachrichten nach",
// "The number of days after which Tiki will archive the messages that have been read by the user" => "The number of days after which Tiki will archive the messages that have been read by the user",
"60" => "60",
"My pages" => "Meine Seiten",
// "List all wiki pages edited by the user" => "List all wiki pages edited by the user",
"My blogs" => "Meine Blogs",
// "List all blogs and blog posts edited by the user" => "List all blogs and blog posts edited by the user",
"My galleries" => "Meine Galerien",
// "List all galleries edited by the user" => "List all galleries edited by the user",
"My messages" => "Meine Nachrichten",
// "List all messages and replies by the user" => "List all messages and replies by the user",
"My tasks" => "Meine Aufgaben",
// "List all tasks by the user" => "List all tasks by the user",
"My forum topics" => "Meine Foren-Themen",
// "List all forum topics by the user" => "List all forum topics by the user",
"My forum replies" => "Meine Foren-Antworten",
// "List all forum replies by the user" => "List all forum replies by the user",
"My items" => "Meine Einträge",
// "List all tracker items by the user" => "List all tracker items by the user",
"Character set for mail" => "E-Mailzeichensatz",
// "Keep closed remarksbox hidden" => "Keep closed remarksbox hidden",
// "XMPP account JID or username" => "XMPP account JID or username",
// "XMPP account password" => "XMPP account password",
// "XMPP http-bind URL" => "XMPP http-bind URL",
// "Full URL to the http-bind" => "Full URL to the http-bind",
// "https://xmpp.example.org/http-bind/" => "https://xmpp.example.org/http-bind/",
// "Pre-set show user's info on mouseover" => "Pre-set show user's info on mouseover",
// "Set new users' info to display in a popup when their name is hovered over" => "Set new users' info to display in a popup when their name is hovered over",
// "Remember the alert boxes that users have closed and don't display them again" => "Remember the alert boxes that users have closed and don't display them again",
"Validator emails (separated by comma) if different than the sender email" => "E-Mail des/der Validierer (durch Komma getrennt) wenn von Absender-E-Mail abweichend",
// "Vimeo upload" => "Vimeo upload",
// "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API" => "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API",
// "Vimeo delete" => "Vimeo delete",
// "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted" => "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted",
// "Permanently removes videos from the registered vimeo.com account" => "Permanently removes videos from the registered vimeo.com account",
// "Vimeo consumer key" => "Vimeo consumer key",
// "API consumer key" => "API consumer key",
// "Vimeo consumer secret" => "Vimeo consumer secret",
// "API consumer secret" => "API consumer secret",
// "Vimeo access token" => "Vimeo access token",
// "The access token that is automatically generated by Vimeo when API keys are requested" => "The access token that is automatically generated by Vimeo when API keys are requested",
// "Vimeo access token secret" => "Vimeo access token secret",
// "The access token secret automatically generated by Vimeo when API keys are requested" => "The access token secret automatically generated by Vimeo when API keys are requested",
// "Vimeo Default Gallery" => "Vimeo Default Gallery",
// "The The ID of the default file gallery in which to store the Vimeo reference" => "The The ID of the default file gallery in which to store the Vimeo reference",
"Display by default" => "Standardmäßig anzeigen",
"Path (if stored in directory)" => "Pfadangabe (wenn in einem Verzeichnis gespeichert wird)",
"Edit idle timeout" => "Bearbeiten Idle-Timeout",
// "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains" => "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains",
// "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually" => "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually",
// "How to trigger Web Cron" => "How to trigger Web Cron",
// "Calling the Web Cron URL" => "Calling the Web Cron URL",
// "Adding JavaScript that calls Web Cron" => "Adding JavaScript that calls Web Cron",
// "URL and JavaScript" => "URL and JavaScript",
// "Run interval" => "Run interval",
// "The amount of time of each run" => "The amount of time of each run",
"Token" => "Token",
// "The token to use when running the cron manually" => "The token to use when running the cron manually",
// "Default cache" => "Default cache",
// "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response" => "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response",
// "Last Modified" => "Last Modified",
"Last editor" => "Letzter Bearbeiter",
"Wiki link format" => "Wikilink-Format",
"Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))" => "Welche Ebene von Sonderzeichnen in Wiki Links zu Seitennamen akzeptiert werden. Bsp.: ((Seite &eacute;&agrave;&icirc;))",
"\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"." => "Strict erlaubt nur Basiszeichen (wie a-z und 0-9). Wenn in Seitennamen besondere Zeichen (Akzente, Sonderzeichen, Umlaute) benutzt werden, sollte Strict nicht benutzt werden.",
"Complete" => "Komplett",
"Relaxed" => "Relaxed",
"Strict" => "Strict",
// "Wiki URL scheme" => "Wiki URL scheme",
// "Alter the SEFURL pattern for page names" => "Alter the SEFURL pattern for page names",
// "Use the \"View\" action to regenerate your URLs after changing this setting" => "Use the \"View\" action to regenerate your URLs after changing this setting",
// "Show the page version" => "Show the page version",
"Display the page version information when viewing the page" => "Zeigt Information zur Seitenversion, wenn die Seite angesehen wird",
// "Display the page name above the page area" => "Display the page name above the page area",
"Display the page name in small text at the top of each page (above the page's content)." => "Zeigt Seitenname oberhalb der Seite anstelle innerhalb der Seite",
// "Display the page name inside the page content" => "Display the page name inside the page content",
"Page name display stripper" => "Seitennamen-Abtrenner",
"The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "Begrenzungszeichen in Seitennamen. Der Teil hinter dem Zeichen wird nicht angezeigt. Wenn der Seitennamen-Abtrenner mit dem Namensraum-Trenner in Konflikt tritt, wird der Namensraum verwendet und der Seitennamen nicht abgetrennt",
"Wiki author list style" => "Wiki Autor Listenstil",
"Change the list format that is used to display the authors of the page." => "Ändert das Listenformat, das benutzt wird, um Autoren einer Seite anzuzeigen",
"Creator and Author" => "Ersteller & Autor",
"Business style" => "Geschäftlich",
"Collaborative style" => "Kollaborativ",
"Page last modified on" => "Seite zuletzt geändert am",
"none (disabled)" => "Keine (abgeschaltet)",
"Specify wiki author list style per page" => "Lege Wiki Autor Listenstil pro Seite fest",
"Enable the style in which the author list is displayed to be modified on a per-page basis" => "Erlaubt es, den Stil, wie Autoren pro Seite aufgelistet werden, zu verändern",
"Wiki page edit buttons location" => "Anordnung Wiki Aktionenzeile",
"Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page" => "Schaltflächen: Speichern, Vorschau, Abbrechen, ..",
"Wiki navigation bar location" => "Anordnung Wiki Navigationszeile",
"When using the ...page... page break wiki syntax" => "Wenn der ...page... Seitenumbruch Wiki Syntax benutzt wird",
"Wiki top line location" => "Anordnung Wiki Topzeile",
// "Page description, page actions, icons, backlinks..." => "Page description, page actions, icons, backlinks...",
// "Display ShareThis icon prominently" => "Display ShareThis icon prominently",
// "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)" => "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)",
"Cache wiki pages (global)" => "Wikiseiten cachen (global)",
"Enable page cache globally for wiki pages" => "Aktiviere Seitencache global für Wiki Seiten",
"no cache" => "kein Cache",
"Allow comments per wiki page" => "Erlaube Kommentare pro Wikiseite",
"Enable control of comments on wiki pages on a per-page basis." => "Aktiviere Kontrolle für Kommentare auf Wiki Seiten individuell",
"Enable (default On)" => "Anschalten (Standard: an)",
"Enable (default Off)" => "Anschalten (Standard: aus)",
// "Wiki copyright" => "Wiki copyright",
"Prevent special characters in page names" => "Vermeide Sonderzeichen in Seitennamen",
"Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters" => "Einige Buchstaben können verhindern, dass eine Wiki Seite leicht durch Wiki Links erreicht wird. Diese Option verhindert, dass Seiten mit solchen Zeichen erstellt werden",
"Page ranking reload probability" => "Wahrscheinlichkeit für Seitenrangaktualisierung",
"Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking" => "Die Ermittlung des Seitenrangs ist rechenintensiv und kann nicht bei jedem Laden durchgeführt werden. Er wird bei zufälligen Seitenaufrufen nach dem würfelbasierten Zufallsprinzip kalkuliert. Diese Option legt fest, wieviele Seiten der Würfel hat. Größere Zahlen führen zu geringerem Laden aber auch zu höherer Ungenauigkeit des Rangs",
"Encourage contribution to wiki pages by anonymous" => "Animiere zu Beiträgen zu Wikiseiten durch anonyme Benutzer",
"When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page" => "Wenn die Seite nicht bearbeitet werden kann und der Benutzer anonym ist sollen Bearbeitungslinks trotzdem angezeigt werden. Der Besucher wird dann aufgefordert sich anzumelden und dadurch motiviert sich zu registrieren",
"Warn before page lock timeout" => "Warne bevor die Seite mit Timeout schliesst",
"Provide a JavaScript alert before the user's lock on a page times out" => "Zeigt eine JavaScript Alarmmeldung an, bevor die Benutzersperre einer Seite abläuft",
"Dynamic variables" => "Dynamische Variablen",
"Global snippets of text that can be included in wiki pages and edited in place" => "Globale Textschnippsel, die in Wiki Seiten eingebunden und am jeweiligen Ort geändert werden können",
"Single (%varname%)" => "Einfach (%Variablenname%)",
"Double (%%varname%%)" => "Doppelt (%%Variablenname%%)",
"Multilingual dynamic variables" => "Mehrsprachige dynamische Variablen",
"Make dynamic variable content language-specific" => "Mache den Inhalt dynamischer Variablen sprachenspezifisch",
// "Allow plugin-specific edits" => "Allow plugin-specific edits",
// "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page" => "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page",
// "This feature is unavailable outside wiki pages, whether or not this preference is enabled" => "This feature is unavailable outside wiki pages, whether or not this preference is enabled",
// "Allow section-specific edits" => "Allow section-specific edits",
// "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section" => "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section",
// "Section-specific edits maximum level" => "Section-specific edits maximum level",
// "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections" => "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections",
// "Only display focused edit icons (for sections and/or plugins) on request" => "Only display focused edit icons (for sections and/or plugins) on request",
// "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page" => "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page",
// "Allow minor edits of wiki pages" => "Allow minor edits of wiki pages",
"Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)." => "Geringfügige Änderungen markieren neue Inhalte nicht für notwendige Übersetzungen und senden auch keine Beobachten-Benachrichtigungen (es sei denn die Funktion \"Beobachte geringfügige Änderungen\" ist markiert).",
// "Display comment list by default" => "Display comment list by default",
// "Display Post new comment form by default" => "Display Post new comment form by default",
// "Simple wiki comment ratings" => "Simple wiki comment ratings",
// "Enable users to rate comments based on a simple numeric scale" => "Enable users to rate comments based on a simple numeric scale",
"Wiki rating options" => "Wiki Bewertungsoptionen",
// "List of options available for the rating of wiki comments" => "List of options available for the rating of wiki comments",
"Add a slideshow button on wiki pages" => "Füge eine Diashow-Schaltfläche auf Wiki Seiten hinzu",
"Page creators are administrators of their pages" => "Ersteller sind auch Administratoren ihrer Seiten",
"Create watch for author on page creation" => "Beobachtungspunkt für Seite beim Erstellen setzen",
"Enable watches on comments" => "Beobachtungspunkte auf Kommentare aktivieren",
"Watch minor edits" => "Beobachte untergeordnete Änderungen",
"Page ID" => "Seiten ID",
// "Page name maximum displayed length" => "Page name maximum displayed length",
// "Comment of the latest edit" => "Comment of the latest edit",
// "Description maximum displayed length" => "Description maximum displayed length",
"Versions" => "Versionen",
"Categories path" => "Kategoriepfade",
"Default sort order" => "Standard-Sortierreihenfolge",
"Sort Direction" => "Sortierreihenfolge",
// "Visibility of discussion" => "Visibility of discussion",
// "Just a button among others (default), or special section" => "Just a button among others (default), or special section",
// "In the button bar (default)" => "In the button bar (default)",
// "Special section above button bar" => "Special section above button bar",
"Forum for discussion" => "Forum für Diskussion",
"Allow management of keywords on a per-page basis" => "Erlaubt es Schlüsselwörter auf einer pro-Seiten-Basis zu verwalten",
"Similar pages only listed in same language" => "Ähnliche Seiten nur in der gleichen Sprache auflisten",
"When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page" => "Wenn ähnliche Seiten aufgelistet werden, so wie in der Seite 404 (nicht gefunden), zeige nur Seiten in der gleichen Sprache",
"Mandatory wiki page edit summary" => "Es muss eine Zusammenfassung bei der Bearbeitung von Wiki Seiten angegeben werden",
"Reject save attempts that do not include an edit summary describing the changes made" => "Lehne Speichern ohne Angabe einer Bearbeitungszusammenfassung bezüglich der gemachten Änderungen ab",
// "Position of tags selection" => "Position of tags selection",
// "Place the tags selection more prominently than under the \"Properties\" tab" => "Place the tags selection more prominently than under the \"Properties\" tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Tags tab" => "Tags tab",
"Structure navigation bar location" => "Anordnung der Navigationsleiste für Strukturen",
"Display Next and Back buttons, breadcrumbs, and a form to add a new page" => "Zeige Nächste/zurück-Schaltflächen, Brotkrumen und Formular, um einen neue Seite hinzuzufügen",
// "Backlink page names maximum displayed length" => "Backlink page names maximum displayed length",
// "Show blog posts" => "Show blog posts",
// "Blog posts linking to a wiki page are shown as backlinks" => "Blog posts linking to a wiki page are shown as backlinks",
// "Show forum posts" => "Show forum posts",
// "Forum posts linking to a wiki page are shown as backlinks" => "Forum posts linking to a wiki page are shown as backlinks",
// "Show comments" => "Show comments",
// "Comments linking to a wiki page are shown as backlinks" => "Comments linking to a wiki page are shown as backlinks",
// "Show articles" => "Show articles",
// "Articles linking to a wiki page are shown as backlinks" => "Articles linking to a wiki page are shown as backlinks",
// "Show tracker items" => "Show tracker items",
// "Tracker items linking to a wiki page are shown as backlinks" => "Tracker items linking to a wiki page are shown as backlinks",
"Show trackers" => "Zeige Tracker",
// "Trackers with a description linking to a wiki page are shown as backlinks" => "Trackers with a description linking to a wiki page are shown as backlinks",
// "Show tracker fields" => "Show tracker fields",
// "Tracker fields with a description linking to a wiki page are shown as backlinks" => "Tracker fields with a description linking to a wiki page are shown as backlinks",
// "Show calendar events" => "Show calendar events",
// "Calendar events with a description linking to a wiki page are shown as backlinks." => "Calendar events with a description linking to a wiki page are shown as backlinks.",
"Simple wiki ratings" => "Einfache Wiki Bewertungen",
// "Enable users to rate wiki pages based on a simple numeric scale" => "Enable users to rate wiki pages based on a simple numeric scale",
"List of options available for the rating of wiki pages" => "Optionsliste für die Bewertung von Wiki Seiten",
"Semantic link types to use as page alias markers" => "Link-Typ für semantische Links (für die Benutzung als Seiten-Alias)",
"Comma-separated list of semantic links to identify a page as an alias of another" => "Mit Kommata getrennte Liste von zu benutzenden semantischen Links, um eine Seite als Alias zu einer weiteren zu identifizieren",
"Redirect pages using these prefix-alias semantic links" => "Weiterleiten pages using these prefix alias semantic links",
"Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link" => "Kommagetrennte Liste von Präfixen von denen Seiten auf eine Seite mit semantischem Link weitergeleitet werden",
// "Wiki page pagination" => "Wiki page pagination",
// "Enable the separation of a wiki page's content into a set of two or more paginated pages" => "Enable the separation of a wiki page's content into a set of two or more paginated pages",
// "Wiki page separator" => "Wiki page separator",
// "The separator to use in wiki page content to mark the end of each page section" => "The separator to use in wiki page content to mark the end of each page section",
// "Wiki auto-toc" => "Wiki auto-toc",
// "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties" => "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties",
// "Inline auto-toc" => "Inline auto-toc",
// "Change the display of the table of contents for wiki pages to inline" => "Change the display of the table of contents for wiki pages to inline",
// "Table of contents position" => "Table of contents position",
// "Position of the table of contents, either top, left, right (right is the default)" => "Position of the table of contents, either top, left, right (right is the default)",
// "Table of contents offset" => "Table of contents offset",
// "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin" => "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin",
// "Table of contents default" => "Table of contents default",
// "Set the default for the table of contents (default \"on\" and can be toggled per page)" => "Set the default for the table of contents (default \"on\" and can be toggled per page)",
"On" => "Am",
"Off" => "Aus",
// "Add an option to hide the page title per wiki page" => "Add an option to hide the page title per wiki page",
// "Enable the page title to not be displayed, on a per-page basis" => "Enable the page title to not be displayed, on a per-page basis",
// "Multilevel style numbering for ordered lists" => "Multilevel style numbering for ordered lists",
// "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc" => "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc",
// "Force link to included page" => "Force link to included page",
// "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used" => "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used",
// "Date Field" => "Date Field",
// "The field indexed as the global \"date\" field" => "The field indexed as the global \"date\" field",
// "You will need to rebuild the search index after changing this" => "You will need to rebuild the search index after changing this",
// "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it" => "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it",
// "Maximum displayed length of the latest edit's comment" => "Maximum displayed length of the latest edit's comment",
"Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf" => "Global cache time for the plugin snarf",
"Default cache time for the plugin snarf" => "Standard-Chache-Zeit für das Plugin Snarf",
"0 for no cache" => "0 für keinen Cache",
// "GUI for the list plugin" => "GUI for the list plugin",
// "Experimental GUI for the list plugin in popup plugin edit forms" => "Experimental GUI for the list plugin in popup plugin edit forms",
// "(listgui)" => "(listgui)",
// "Plugin trackerlist converter" => "Plugin trackerlist converter",
// "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead" => "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead",
// "Maximum plugin parsing passes" => "Maximum plugin parsing passes",
// "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin" => "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin",
// "passes" => "passes",
// "Setting this to a higher value than the default of 500 may have performance implications" => "Setting this to a higher value than the default of 500 may have performance implications",
"Inline plugin %0" => "Inline-Plugin %0",
"Plugin pending approval notification" => "Plugin wartet auf Bestätigung",
"Send an email alert to users with permission to approve plugins when a plugin approval is pending" => "Alarmiere einen Benutzer mit Berechtigungen durch E-Mail, wenn ein Plugin noch bestätigt werden muss",
// "Hide admin wizard on log-in when an admin user logs in" => "Hide admin wizard on log-in when an admin user logs in",
// "Workspace UI" => "Workspace UI",
// "Combines multiple site features to create a workspace experience for workgroups" => "Combines multiple site features to create a workspace experience for workgroups",
// "Workspace root category" => "Workspace root category",
// "ID of the root category containing all workspaces" => "ID of the root category containing all workspaces",
// "This value is automatically managed and should not need to be modified manually" => "This value is automatically managed and should not need to be modified manually",
// "Full WYSIWYG editor is optional" => "Full WYSIWYG editor is optional",
// "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used" => "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used",
// "Switching between HTML and wiki formats can cause problems for some pages" => "Switching between HTML and wiki formats can cause problems for some pages",
// "Full WYSIWYG editor is displayed by default" => "Full WYSIWYG editor is displayed by default",
// "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages" => "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages",
"Reopen with the same editor" => "Wieder-Öffnen einer Seite mit dem gleichen Editor",
// "Ensures the editor last used to edit a page or item is used for the next edit as the default" => "Ensures the editor last used to edit a page or item is used for the next edit as the default",
// "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed" => "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed",
"Use Wiki syntax in WYSIWYG" => "Benutze den Wikisyntax in WYSIWYG",
// "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"" => "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"",
// "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools" => "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools",
// "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)" => "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)",
// "CKeditor offers possibilities which may not be expressible in Tiki syntax" => "CKeditor offers possibilities which may not be expressible in Tiki syntax",
// "Full WYSIWYG editor skin" => "Full WYSIWYG editor skin",
// "Moono (Default)" => "Moono (Default)",
// "Kama" => "Kama",
// "Bootstrap CK" => "Bootstrap CK",
// "Minimalist" => "Minimalist",
// "Office 2013" => "Office 2013",
// "Typefaces" => "Typefaces",
// "List of font names separated by semi-colons (\";\")" => "List of font names separated by semi-colons (\";\")",
// "Inline WYSIWYG editor" => "Inline WYSIWYG editor",
// "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required" => "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required",
// "Extra plugins" => "Extra plugins",
// "List of plugin names (separated by,)" => "List of plugin names (separated by,)",
// "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard" => "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard",
// "Support Tiki's \"wiki syntax\" in HTML pages" => "Support Tiki's \"wiki syntax\" in HTML pages",
// "XMPP client (ConverseJS)" => "XMPP client (ConverseJS)",
// "Integration with Converse.js XMPP client" => "Integration with Converse.js XMPP client",
// "XMPP server domain" => "XMPP server domain",
// "example.org" => "example.org",
// "XMPP MUC Domain" => "XMPP MUC Domain",
// "Required for auto-joining rooms" => "Required for auto-joining rooms",
// "conference.example.org" => "conference.example.org",
// "The authentication method to be used by XMPP client" => "The authentication method to be used by XMPP client",
// "OAuth (uses Tiki as provider)" => "OAuth (uses Tiki as provider)",
// "Openfire TikiToken" => "Openfire TikiToken",
// "Allow anonymous" => "Allow anonymous",
// "Allow anonymous users on Chat" => "Allow anonymous users on Chat",
// "Openfire REST API endpoint" => "Openfire REST API endpoint",
// "Full URL to API endpoint" => "Full URL to API endpoint",
// "https://xmpp.example.org:9091/plugins/restapi/v1/" => "https://xmpp.example.org:9091/plugins/restapi/v1/",
// "Rest API username" => "Rest API username",
// "Username to allow Openfire API usage" => "Username to allow Openfire API usage",
// "Rest API password" => "Rest API password",
// "Password to allow Openfire API usage" => "Password to allow Openfire API usage",
// "ConverseJS Debug Mode" => "ConverseJS Debug Mode",
// "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console" => "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console",
// "ConverseJS Extra Settings" => "ConverseJS Extra Settings",
// "JSON format object defining extra optional settings to initialize ConverseJS" => "JSON format object defining extra optional settings to initialize ConverseJS",
"SMTP server" => "SMTP-Server",
"Security" => "Sicherheit",
"SSL" => "SSL",
"TLS" => "TLS",
"Mail sender" => "Mailversand über",
// "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications" => "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications",
"Sendmail" => "Sendmail",
"SMTP" => "SMTP",
// "File (debug)" => "File (debug)",
"Authentication" => "Authentifizierung",
"Mail server authentication" => "Mailserver Authentifizierung",
"LOGIN" => "LOGIN",
"PLAIN" => "PLAIN",
"CRAM-MD5" => "CRAM-MD5",
// "Local server name" => "Local server name",
// "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line" => "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line",
// "Mail delivery" => "Mail delivery",
// "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail" => "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail",
// "Send immediately" => "Send immediately",
// "Queue" => "Queue",
// "Verify HTTPS certificates of remote servers" => "Verify HTTPS certificates of remote servers",
// "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)" => "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)",
// "Do not enforce verification" => "Do not enforce verification",
// "Enforce verification" => "Enforce verification",
// "Use CURL for HTTP connections" => "Use CURL for HTTP connections",
// "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available" => "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available",
// "Zotero bibliography" => "Zotero bibliography",
"Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system" => "Verbinde Tiki mit dem Zotero Bibliographieverwaltungsystem",
// "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style" => "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style",
// "Zotero client key" => "Zotero client key",
"Required identification key. Registration required." => "Erforderlicher Identifizierungsschlüssel. Registrierung erforderlich.",
// "Zotero client secret" => "Zotero client secret",
// "Zotero group ID" => "Zotero group ID",
"Numeric ID of the group, can be found in the URL." => "Numerische ID der Gruppe; kann der URL entnommen werden",
// "Zotero reference style" => "Zotero reference style",
"Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Benutze einen alternativen Zotero Referenz-Stil beim Formatieren. Die Referenzformate müssen auf dem Zotero-Server installiert sein",
"Unmatched system requirement. Missing PHP extension among %0" => "Systemvoraussetzungen nicht erfüllt. Fehlende PHP Erweiterung unter %0",
"Unmatched system requirement. The database you are using does not support this feature" => "Systemvoraussetzungen nicht erfüllt. Die von Dir benutzte Datenbank unterstützt diese Funktion nicht",
"Missing default for preference \"%0\"" => "Fehlende Standardeinstellung für \"%0\"",
"Configuration forced by host" => "Konfiguration von Host erzwungen",
"Disabled by host" => "Von Host deaktiviert",
"Settings" => "Einstellungen",
"Permissions" => "Berechtigungen",
"View" => "Betrachten",
"Modules" => "Module",
"Plugins" => "Plugins",
"Like" => "Gefällt mir",
// "Missing preference \"%0\" for \"%1\"" => "Missing preference \"%0\" for \"%1\"",
// "%0 set to minimum of %1 instead of submitted value of %2" => "%0 set to minimum of %1 instead of submitted value of %2",
// "%0 set to maximum of %1 instead of submitted value of %2" => "%0 set to maximum of %1 instead of submitted value of %2",
"Don't like" => "Gefällt mir nicht",
"Wiki top pages" => "Wiki-Top-Seiten",
"Most-relevant pages" => "Relevanteste Seiten",
"Wiki last pages" => "Neueste Wiki-Seiten",
// "Forums last topics" => "Forums last topics",
"Topic date" => "Themendatum",
"Forums last posts" => "Neueste Forenposts",
"Forums most-read topics" => "Foren mit den meistgelesenen Themen",
"Forums best topics" => "Foren mit den beliebtesten Themen",
"Most-visited forums" => "Meistbesuchte Foren",
"Forums with most posts" => "Foren mit den meisten Beiträgen",
"Wiki top galleries" => "Wiki Top Galerien",
"Wiki top file galleries" => "Wiki Top Dateiarchive",
"Wiki top images" => "Wiki Top Bilder",
"Wiki top files" => "Wiki Top Dateien",
"Downloads" => "Downloads",
"Wiki most-recent images" => "Wiki neueste Bilder",
"Upload date" => "Hochlade-Datum",
"Wiki most-recent files" => "Wiki neueste Dateien",
"Top Articles" => "Top Artikel",
"Most-visited blogs" => "Meistbesuchte Blogs",
"Most-active blogs" => "Aktivste Blogs",
"Blogs last posts" => "Neueste Blog-Einträge",
"Post date" => "Eintragsdatum",
"Wiki top authors" => "Wiki Top Autoren",
"Pages" => "Seiten",
"Top article authors" => "Top Artikel-Autoren",
"Expecting three arguments for article-info" => "Erwarte drei Argumente für Artikelinfo",
"Unsupported property. Supported properties are: " => "Nicht unterstützte Eigenschaft. Unterstütze Eigenschaften sind: ",
"The Articles feature is not activated" => "Artikelfunktion nicht aktiviert",
"Object must be provided and contain two arguments: type and object" => "Objekt muss angegeben werden und zwei Argumente enthalten: type und object",
"Invalid property" => "Ungültige Eigenschaft",
// "Item must be provided and contain one argument: type, object-id" => "Item must be provided and contain one argument: type, object-id",
// "List must be provided and contain at least one argument: category IDs" => "List must be provided and contain at least one argument: category IDs",
"Invalid range" => "Ungültiger Bereich",
"Invalid revote period" => "Ungültige Neuabstimmungs-Periode",
"Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Erwarte, dass \"keep\" entweder \"latest\" oder \"oldest\" ist",
// "Qualifier must be provided and contain one argument: type" => "Qualifier must be provided and contain one argument: type",
// "From must be provided and contain two arguments: type, object-id" => "From must be provided and contain two arguments: type, object-id",
// "To must be provided and contain two arguments: type, object-id" => "To must be provided and contain two arguments: type, object-id",
// "Field must be provided and contain one argument: field permanent name" => "Field must be provided and contain one argument: field permanent name",
"Unknown variables referenced: %0" => "Unbekannte referenzierte Variable: %0",
"Username is required" => "Benutzername ist erforderlich",
"Password is required" => "Passwort ist erforderlich",
"User already exists" => "Benutzer existiert bereits",
"Invalid username" => "Benutzername ungültig",
"Username is too long" => "Benutzername zu lang",
"Username cannot contain uppercase letters" => "Benutzername darf keine Grossbuchstaben enthalten",
"Wrong passcode. You need to know the passcode to register at this site" => "Falsches Passwort. Du musst Dein Passwort kennen, um Dich an dieser Site zu registrieren",
"You must choose a group" => "Du musst eine Gruppe wählen",
"Email not valid. Should be in the format \"mailbox@example.com\"" => "E-Mail-Adresse ist ungültig. Sie muss folgendes Format haben \"mailbox@beispiel.de\"",
"One of these groups is required" => "Einer dieser Gruppen ist erforderlich",
"This field is required" => "Dieses Feld ist erforderlich",
"The passwords don't match" => "Die Passwörter stimmen nicht überein",
"Username must be at least %0 characters long" => "Benutzername muss mindestens %0 Zeichen lang sein",
"Username cannot contain more than %0 characters" => "Benutzername darf nicht mehr als %0 Zeichen lang sein",
"This invitation does not exist or is deprecated or wrong email" => "Diese Einladung existiert nicht oder ist abgelaufen oder die E-Mailadresse ist falsch",
"The title and description must be entered, to generate a feed" => "Die Felder, Titel und Beschreibung sind erforderlich, um einen Feed zu erstellen",
"To fix this error go to Admin -> Feeds" => "Um den Fehler zu beheben, gehe zu Verwalten -> Feeds",
"Please contact the site administrator and request this error to be corrected" => "Bitte kontaktiere den Site-Administrator und bitte ihn, den Fehler zu beheben",
"If you set feed author email or URL, you must set feed author name" => "Wenn Du die Feed-Autor-E-Mail-Adresse oder URL einträgst, muss Du den Feed-Autornamen angeben",
"Feed logo" => "Feed-Logo",
"Unspecified" => "unbekannt",
"Log In" => "Anmeldung",
"See other users' profiles" => "Profil eines anderen Benutzers ansehen",
"Have your profile seen" => "Benutzer sieht sich Ihr Profil an",
"Make friends" => "Freundschaft schließen",
"Receive a message" => "Nachricht empfangen",
"Send a message" => "Nachricht schicken",
"Read an article" => "Artikel lesen",
"Publish an article" => "Artikel veröffentlichen",
"Have your article read" => "Benutzer liest Deinen Artikel",
"Create new file gallery" => "Neues Dateiarchiv anlegen",
"Upload a new file to a gallery" => "Datei in Archiv hochladen",
"Download another user's file" => "Datei eines anderen Benutzers herunterladen",
"Have your file downloaded" => "Benutzer lädt eine Deiner Dateien herunter",
"Create a new image gallery" => "Neue Bildgalerie anlegen",
"Upload a new image to a gallery" => "Bild in Galerie hochladen",
"View another user's gallery" => "Galerie eines anderen Benutzers anschauen",
"View another user's images" => "Bild eines anderen Benutzers betrachten",
"Have your gallery viewed by another user" => "Benutzer betrachtet Deine Galerie",
"Have your image viewed" => "Benutzer betrachtet eines Deiner Bilder",
"Create a new blog" => "Neuen Blog erstellen",
"Post in a blog" => "Eintrag in Blog vornehmen",
"Read another user's blog" => "Blog eines anderen Benutzers lesen",
"Have your blog read" => "Benutzer liest Deinen Blog",
"Create a new wiki page" => "Neue Wiki-Seite erstellen",
"Edit an existing page" => "Vorhandene Wiki-Seite bearbeiten",
"Attach a file" => "Datei anhängen",
// "Create a new forum topic" => "Create a new forum topic",
// "Reply to a forum topic" => "Reply to a forum topic",
// "Read a forum post" => "Read a forum post",
// "Have your forum post read" => "Have your forum post read",
// "Create a new tracker item" => "Create a new tracker item",
// "Edit a tracker item" => "Edit a tracker item",
// "View a tracker item" => "View a tracker item",
// "Have your tracker item viewed" => "Have your tracker item viewed",
// "Tracker field content added" => "Tracker field content added",
// "Favorite an item" => "Favorite an item",
// "Have your item favorited" => "Have your item favorited",
// "Have your item rated (per rating)" => "Have your item rated (per rating)",
// "Have your item unrated (per rating)" => "Have your item unrated (per rating)",
"Add a profile photo" => "Ein ProfilFoto beifügen",
"Try rebuilding or optimizing the index on the search admin page" => "versuche den Index auf der Verwaltungs-Suchseite neu aufzubauen oder zu optimieren",
// "Invalid table name" => "Invalid table name",
// "Invalid column name" => "Invalid column name",
"Wiki Comment" => "Wiki Kommentare",
"Calendar item" => "Kalendereintrag",
"Gallery" => "Galerie",
"Blog post" => "Blog-Eintrag",
"Tracker item" => "Trackereintrag",
"The search index could not be updated. The site is misconfigured. Contact an administrator" => "Der Suchindex konnte nicht aktualisiert werden. Die Site ist fehlerhaft konfiguriert. Kontaktiere eine Administrator",
// "Rebuild in progress" => "Rebuild in progress",
"The search index could not be rebuilt" => "Such-Index konnte nicht neu erstellt werden",
"The active index could not be removed, probably due to a file permission issue" => "Konnte aktiven Index nicht löschen. Möglicherweise eine Datei-Berechtigungsfrage",
"The new index could not be made active, probably due to a file permission issue" => "Konnte neunen Index nicht über aktiven transferieren. Möglicherweise eine Datei-Berechtigungsfrage",
"Failed to delete the old index" => "Löschung des alten Index gelang nicht",
"blog post" => "Blogeintrag",
"forum post" => "Forumeintrag",
"tracker item" => "Trackereintrag",
// "tracker field" => "tracker field",
"sheet" => "Tiki Tabellen",
"comment" => "Kommentar",
// "category" => "category",
// "webservice" => "webservice",
// "activity" => "activity",
// "calendar item" => "calendar item",
// "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate" => "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate",
// "Contact the site administrator. The index needs rebuilding" => "Contact the site administrator. The index needs rebuilding",
// "Client Node" => "Client Node",
// "Elasticsearch Version" => "Elasticsearch Version",
// "Lucene Version" => "Lucene Version",
// "Cluster Name" => "Cluster Name",
// "Cluster Status" => "Cluster Status",
// "Cluster Node Count" => "Cluster Node Count",
// "Index %0" => "Index %0",
// "%0 documents, totaling %1" => "%0 documents, totaling %1",
// "Node %0" => "Node %0",
// "Using %0, since %1" => "Using %0, since %1",
// "%0 documents, totaling %1 bytes" => "%0 documents, totaling %1 bytes",
// "Using %0 bytes, since %1" => "Using %0 bytes, since %1",
// "Field Count Tried on Last Rebuild" => "Field Count Tried on Last Rebuild",
// "Field limit setting is lower than Tiki needs to store in the index" => "Field limit setting is lower than Tiki needs to store in the index",
// "Information Missing" => "Information Missing",
"Object Type" => "Objekttyp",
// "date_histogram" => "date_histogram",
// "Date Histogram" => "Date Histogram",
// "date_range" => "date_range",
"Date Range" => "Datenspanne",
// "Local Search" => "Local Search",
// "Federated Search" => "Federated Search",
// "Index not found" => "Index not found",
"Rebuild search index" => "Such-Index neu erstellen",
// "Click here to rebuild index" => "Click here to rebuild index",
// "On Demand" => "On Demand",
// "You can revisit the results of this saved search on demand" => "You can revisit the results of this saved search on demand",
// "Mobile mode: Permission denied, please log in" => "Mobile mode: Permission denied, please log in",
" has accessed your temporary shared content" => " hat auf Deinen temporär gesharten Inhalt zugegriffen",
"has accessed the following shared content" => "hat auf folgenden gesharten Inhalt zugegriffen",
"Your access to this page has expired" => "Dein Zugriff auf diese Seite ist abgelaufen",
"Handling actions of plugin \"%s\" failed" => "Handhabung von Aktionen des Plugins \"%s\" fehlgeschlagen",
"You must choose an option" => "Du musst eine Option auswählen",
"For you to vote, cookies must be allowed" => "Um abzustimmen, müssen Cookies erlaubt sein",
"This poll is closed" => "Diese Abstimmung ist geschlossen",
// "Preference %0 failed to unserialize. Value was \"%1\"" => "Preference %0 failed to unserialize. Value was \"%1\"",
// "A tracker with id \"%0\" is required to be filled in, but it was deleted" => "A tracker with id \"%0\" is required to be filled in, but it was deleted",
// "Update the preference \"<b>%0</b>\" on admin panel" => "Update the preference \"<b>%0</b>\" on admin panel",
"Congratulations" => "Gratulation",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "Das hier ist Deine Standard-Homepage für Deine Tiki. Wenn Du diese Seite siehst, war Deine Installation erfolgreich",
"You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "Du kannst diese Seite nach Deinem Log-in ändern. Du kannst in der Dokumentation zum sog. [http://doc.tiki.org/wiki+syntax|Wiki Syntax] weitere Details hierzu nachlesen",
// "Get started" => "Get started",
"To begin configuring your site" => "Um Deine Site zu konfigurieren",
"1) Log in with your newly created password" => "1) Logge Dich mit Deinem neu erstellten Passwort ein",
"2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard" => "2) Ggf. händisch die gewünschten [tiki-admin.php?page=features|Tiki-Funktionen] aktivieren, die nicht mit dem Admin-Wizard aktiviert wurden",
"3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running" => "3) [tiki-admin.php?page=profiles|Tiki-Profile] starten, um noch schneller anfangen zu können",
// "Need help" => "Need help",
"For more information" => "Weitere Informationen",
// "[https://tiki.org/Introduction|Learn more about Tiki]" => "[https://tiki.org/Introduction|Learn more about Tiki]",
// "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[https://tiki.org/Join|Join the Tiki community]" => "[https://tiki.org/Join|Join the Tiki community]",
"new" => "neu",
"Saved" => "gespeichert",
"Save failed" => "speichern fehlgeschlagen",
"Standard Shipping" => "Standardlieferung",
"3 to 5 working days" => "3-5 Werktage",
"Express Shipping" => "Expresslieferung",
"Next day delivery" => "Lieferung am nächsten Tag",
"Custom Shipping Example" => "Benutzerdefiniertes Lieferbeispiel",
"UPS_CODE_%0" => "UPS_CODE_%0",
"Problem reading custom shipping provider \"%0\"" => "Problem beim Lesen des benutzerdefinierten Anlieferers \"%0\"",
// "Modified date" => "Modified date",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
"No records to display" => "Keine anzuzeigenden Einträge",
// "Please specify the name of the package and the view" => "Please specify the name of the package and the view",
// "Error: Unable to locate view file for the package" => "Error: Unable to locate view file for the package",
// "Error: Unable to locate function name for the view" => "Error: Unable to locate function name for the view",
"Previous" => "Vorherige",
"current" => "aktuell",
"Next" => "nächste",
"More results may be available. Refine criteria to access the estimated %0 results" => "Es können weitere Ergebnisse verfügbar sein. Verfeinere die Suchkriterien, um geschätzte weitere %0 Ergebnisse zu erhalten",
"Tab View" => "mit Tabs",
"No Tabs" => "ohne Tabs",
"This edit session will expire in" => "Die Bearbeitungszeit läuft ab in",
// "There is an autosaved draft of your recent edits, to use it instead " => "There is an autosaved draft of your recent edits, to use it instead ",
// "If you want the original instead of the autosaved draft of your edits" => "If you want the original instead of the autosaved draft of your edits",
"click here" => "klicke hier",
"AutoSave" => "Autospeichern",
"Your edit session has expired" => "Deine Bearbeitungssitzung ist abgelaufen",
"Your edit session will expire in" => "Deine Bearbeitungssitzung endet in",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Du musst jetzt auf VORSCHAU oder SPEICHERN klicken, damit Deine Änderungen nicht verloren gehen",
// "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page",
"Help page" => "Hilfeseite",
// "View or edit tpl" => "View or edit tpl",
// "View tpl" => "View tpl",
// "itemId required" => "itemId required",
// "Plugin name not specified" => "Plugin name not specified",
// "Delete file" => "Delete file",
// "File (ID %0) removed" => "File (ID %0) removed",
// "File (ID %0) not removed" => "File (ID %0) not removed",
// "File uploaded" => "File uploaded",
// "File not uploaded" => "File not uploaded",
// "Missing _id or _type params" => "Missing _id or _type params",
"Wrong attachments gallery" => "Falsches Anhangarchiv",
"You are attempting to display a gallery that is not a valid attachment gallery" => "Du versuchst ein Dateiarchiv anzeigen zu lassen, welches kein gültiges Anhang-Archiv ist",
// "Missing 'to' or 'from' parameter" => "Missing 'to' or 'from' parameter",
"at" => "um",
"to" => "bis",
"Favorite" => "Favorit",
"Hour" => "Stunde",
"Minute" => "Minute",
"a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "Klicke hier, um die Sprachen zu bearbeiten",
"The text is" => "Der Text ist",
"character(s) too long - please edit it." => "Zeichen zu lang. Bitte anpassen.",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Clear filter" => "Clear filter",
"Filter:" => "Filtern:",
// "Type not specified" => "Type not specified",
// "lock perm not found" => "lock perm not found",
// "admin perm not found" => "admin perm not found",
"Missing parameter" => "Fehlender Parameter",
// "Multivalue configuration not found" => "Multivalue configuration not found",
"No records found." => "Keine Einträge gefunden.",
"No object information provided" => "Keine Objektinformationen angegeben",
"No title specified" => "Kein Titel angegeben",
"Relation not found" => "Verbindung nicht gefunden",
"tags disabled" => "Tags sind deaktiviert",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "%0 list separated with \"%1\"" => "%0 list separated with \"%1\"",
// "Object selector requires Unified Index to be enabled" => "Object selector requires Unified Index to be enabled",
"Currency in payment (%0) does not match the currency for that registry (%1)" => "Bezahlwährung (%0) entspricht nicht der Währung für diese Registrierung (%1)",
// "Payment error" => "Payment error",
"This invoice does not exist or access to it is restricted" => "Diese Rechnung existiert nicht oder ist Zugriffsbeschränkt",
"You do not have the permission that is needed to use this feature" => "Keine Berechtigung zur Nutzung dieser Funktion",
"(not found in an admin panel)" => "(konnte auf der Verwaltungsseite nicht gefunden werden)",
"Preference %0 is not defined" => "Einstellung %0 ist nicht definiert",
"Drag this out of the perspective and resave the perspective" => "Ziehe dies auf die Perspektive und speichere es erneut",
"No object information provided for rating" => "Keine Objektinformationen für Bewertung angegeben",
"An error occurred" => "Ein Fehler ist aufgetreten",
// "Configure Ratings" => "Configure Ratings",
// "Unavailable" => "Unavailable",
// "Invalid fields provided" => "Invalid fields provided",
// "Missing or invalid tracker reference" => "Missing or invalid tracker reference",
// "Configured" => "Configured",
"General" => "Allgemein",
// "Tracker rendering error (section=\"%0\" mode=\"%1\")" => "Tracker rendering error (section=\"%0\" mode=\"%1\")",
"No rows found" => "Keine Zeilen gefunden",
"Toggle sections" => "Auswahl umschalten",
"Show only selected" => "Zeige nur Ausgewählte",
"You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "Du solltest ggf. auch das Recht tiki_p_modify_object_categories im Abschnitt Tiki setzen",
// "You are logged in" => "You are logged in",
"Request not from this host" => "Anfrage stammt nicht von diesem Host",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Bitte trage ein(e) gültige %s ein.  Keine Leerzeichen, mehr als %d Zeichen und muss %s enthalten",
"username" => "Benutzername",
"password" => "Passwort",
"Cookies must be enabled to log in to this site" => "Aktiviere 'Cookies akzeptieren', um Dich einloggen zu können",
// "wikidiff: error - no object_id specified" => "wikidiff: error - no object_id specified",
// "wikidiff: error - no old version specified" => "wikidiff: error - no old version specified",
// "wikidiff: error - page \"%0\" not found" => "wikidiff: error - page \"%0\" not found",
// "wikidiff: Error - only wiki pages supported currently" => "wikidiff: Error - only wiki pages supported currently",
"second" => "Sekunde",
"months" => "Monate",
"weeks" => "Wochen",
"done" => "fertig",
"Text cut here" => "Textschnitt hier",
"Task" => "Aufgabe",
"Priority" => "Priorität",
"Start date:" => "Anfangsdatum",
"End date:" => "Enddatum",
"in %s days, the %s" => "in %s Tagen, der %s",
"in %s day, the %s" => "in %s Tag, der %s",
"Today" => "Heute",
"%0 and %1" => "%0 und %1",
"Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Zugriff verboten: die angegebene Wiki Seite kann nicht als Smartyvorlagenquelle genutzt werden",
"No WSDL found" => "Kein WSDL gefunden",
// "Facebook feed data not retrieved" => "Facebook feed data not retrieved",
// "Facebook profile information not retrieved" => "Facebook profile information not retrieved",
// "You need to link your local account to Facebook before you can login using it" => "You need to link your local account to Facebook before you can login using it",
// "We were unable to create a new user with your Facebook account. Please contact the administrator" => "We were unable to create a new user with your Facebook account. Please contact the administrator",
// "We were unable to connect to your LinkedIn account. Please contact the administrator" => "We were unable to connect to your LinkedIn account. Please contact the administrator",
// "We were unable to log you in using your LinkedIn account. Please contact the administrator" => "We were unable to log you in using your LinkedIn account. Please contact the administrator",
// "You need to link your local account to LinkedIn before you can login using it" => "You need to link your local account to LinkedIn before you can login using it",
"pvs" => "Besuche",
"Days with the most pageviews" => "Tage mit den meisten Seitenaufrufen",
"Day with the most pageviews" => "Tag mit den meisten Seitenaufrufen",
"Days with the fewest pageviews" => "Tage mit den wenigsten Seitenaufrufen",
"Day with the fewest pageviews" => "Tag mit den wenigsten Seitenaufrufen",
"No pageviews yet" => "Bislang keine Seitenaufrufe",
"Use this tree to copy the structure" => "Diesen Baum benutzen zum Erstellen der Struktur",
// "system" => "system",
"created from structure" => "aus Struktur erstellt",
"%d choice(s) must be made for the question" => "Du musst %d Auswahl(en) für die Frage vornehmen",
"At least %d choice(s) must be made for the question" => "Du musst mindestens %d Auswahl(en) für die Frage auswählen",
"Fewer than %d choice(s) must be made for the question" => "Du darfst höchstens %d Auswahl(en) für die Frage vornehmen",
"One choice" => "Eine Auswahl",
"Multiple choices" => "Multiple Auswahlen",
// "Thumbnails" => "Thumbnails",
"Short text" => "Kurzbeschreibung",
"Wiki textarea" => "Wiki Textbereich",
"Rate (1 to 5)" => "Bewerte (1..5)",
"Rate (1 to 10)" => "Bewerte (1..10)",
"Heading" => "Überschrift",
// "Icon not found: %0" => "Icon not found: %0",
// "Icon set: Class not defined for icon %0" => "Icon set: Class not defined for icon %0",
// "Custom theme by specifying URL" => "Custom theme by specifying URL",
"Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator." => "Erforderliche Funktion: <b>%0</b>. Wenn Du nicht die erforderlichen Rechte hast, diese Funktion zu aktivieren, frage den Siteadministrator.",
// "CSRF check not performed" => "CSRF check not performed",
// "Required headers are missing" => "Required headers are missing",
// "Requesting site could not be identified because %0 and %1 were empty" => "Requesting site could not be identified because %0 and %1 were empty",
// "Request needs to originate from this site" => "Request needs to originate from this site",
// "The %0 host (%1) does not match this server (%2)" => "The %0 host (%1) does not match this server (%2)",
// "Ticket has expired. Reload the page" => "Ticket has expired. Reload the page",
// "Ticket matches but is expired" => "Ticket matches but is expired",
// "Reloading the page may help" => "Reloading the page may help",
// "Ticket does not match or is missing" => "Ticket does not match or is missing",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked" => "Potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Request to %0 failed CSRF check" => "Request to %0 failed CSRF check",
// "Confirm action" => "Confirm action",
// "Please confirm action" => "Please confirm action",
"unknown error" => "Unbekannter Fehler",
"You are not logged in" => "Du bist nicht angemeldet",
"You do not have permission to view this section" => "Zugriff verweigert. Du kannst diesen Bereich nicht betrachten",
"For the security of your password, direct access to the feed is only available via HTTPS" => "Zur Sicherheit für Dein Passwort besteht Zugriff auf den Feed nur via HTTPS",
"Help link" => "Hilfelink",
"You are banned from" => "Du wurdest verbannt von",
"wiki" => "Wiki",
"img-g" => "Bildergalerien",
"file-g" => "Dateiarchive",
"quizzes" => "Quiz",
"arts" => "Artikel",
"blogs" => "Blogs",
"forums" => "Foren",
// "Tiki links converted to relative links" => "Tiki links converted to relative links",
// "TikiLib::create_page: Cannot create page \"%0\", it already exists.)" => "TikiLib::create_page: Cannot create page \"%0\", it already exists.)",
"The file was successfully uploaded" => "Die Datei wurde erfolgreich hochgeladen",
"The file was only partially uploaded" => "Die Datei, die Du herunterladen möchtest, wurde nur teilweise hochgeladen",
"No file was uploaded. Was a file selected " => "Es wurde keine Datei hochgeladen. War eine Datei gewählt ",
"A temporary folder is missing" => "Ein temporärer Ordner fehlt",
// "Alias <b>%0</b> link already present in %1 page(s)" => "Alias <b>%0</b> link already present in %1 page(s)",
"%d points" => "%d Punkte",
"Removed" => "Gelöscht",
"Plugin %0 pending approval" => "Plugin %0 erwartet Bestätigung",
"Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked" => "Sea Surfing (CSRF) entdeckt. Operation wurde geblockt",
"Bold" => "Fett",
"img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "Kursiv",
"img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Unterstrichen",
"img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "Durchgestrichen",
"img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Code" => "Quellcode",
// "img/icons/page_white_code.png" => "img/icons/page_white_code.png",
"Non-parsed (wiki syntax does not apply)" => "Non-parsed (Wikisyntax gilt hier nicht)",
"img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Zentrieren",
"Horizontal Bar" => "Horizontaler Balken",
"Page Break" => "Seitenumbruch",
"Box" => "Box",
"Title bar" => "Titelbalken",
// "Bullet List" => "Bullet List",
// "Numbered List" => "Numbered List",
"Special Characters" => "Spezielle Zeichen",
"Foreground color" => "Vordergrundfarbe",
"Background Color" => "Hintergrundfarbe",
"Wiki Link" => "Wiki Link",
"img/icons/page_link.png" => "img/icons/page_link.png",
// "Object Link" => "Object Link",
"External Link" => "Externer Link",
"img/icons/world_link.png" => "img/icons/world_link.png",
"img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Tabelle erstellen",
"img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Text finden",
"img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Text ersetzen",
"Full-screen edit" => "in Vollbild bearbeiten",
"Wiki Help" => "Wiki Hilfe",
"Choose or upload images" => "Wähle Bilder oder lade hoch",
"img/icons/pictures.png" => "img/icons/pictures.png",
"Choose or upload files" => "Wähle Dateien oder lade sie hoch",
"Switch Editor (wiki or WYSIWYG)" => "Editor umschalten (Wiki oder WYSIWYG)",
"img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Admin Toolbars" => "Verwalte Toolbars",
// "img/icons/wrench.png" => "img/icons/wrench.png",
"Save Sheet" => "Speichere Tabelle",
"Add row after selection or to the end if no selection" => "Füge Zeile nach der Auswahl oder am Ende hinzu, wenn keine Auswahl vorhanden",
"img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
"Add multiple rows after selection or to the end if no selection" => "Füge multiple Zeilen nach der Auswahl oder am Ende hinzu, wenn keine Auswahl vorhanden",
"img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
"Add row before selection or to end if no selection" => "Füge Zeile vor der Auswahl oder am Ende hinzu, wenn keine Auswahl vorhanden",
"Delete selected row" => "Lösche ausgewählte Zeilen",
"img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
"Add column after selection or to the end if no selection" => "Füge Spalte nach der Auswahl oder am Ende hinzu, wenn keine Auswahl vorhanden",
"img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
"Delete selected column" => "Lösche ausgewählte Spalten",
"img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
"Add multiple columns after selection or to the end if no selection" => "Füge mehrere Spalten nach der Auswahl oder am Ende hinzu, wenn keine Auswahl vorhanden",
"img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
"Add column before selection or to the end if no selection" => "Füge Spalten vor der Auswahl oder am Ende hinzu, wenn keine Auswahl vorhanden",
"Get Cell Range" => "Ermittle Zellenumfang",
"img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Suchen",
"Refresh calculations" => "Neu Berechnen",
"Finish editing" => "Bearbeiten beenden",
"Reset Colors" => "Farben zurücksetzen",
"Reset" => "Zurücksetzen",
// "Show this text" => "Show this text",
// "Link to this page" => "Link to this page",
// "Anchor" => "Anchor",
// "Semantic relation" => "Semantic relation",
"Cancel" => "Abbrechen",
"Insert" => "Einfügen",
// "Types of object" => "Types of object",
// "Link to this object" => "Link to this object",
// "link to this URL" => "link to this URL",
// "No cache" => "No cache",
// "Case Insensitivity" => "Case Insensitivity",
// "Note: Uses regular expressions" => "Note: Uses regular expressions",
"Close" => "Schließen",
"Replace" => "Ersetzen",
// "Replace All" => "Replace All",
// "Flat" => "Flat",
"Tabs" => "Tabs",
// "No template available for %0 - %1" => "No template available for %0 - %1",
// "Tracker %0 not found for Field %1" => "Tracker %0 not found for Field %1",
"*** ERROR: Tracker ID not set ***" => "*** FEHLER: Tracker-ID nicht angegeben ***",
"*** ERROR: Field ID not set ***" => "*** *** FEHLER: Feld-ID nicht angegeben ***",
"*** ERROR: Tracker %0 not found ***" => "*** FEHLER: Tracker %0 wurde nicht gefunden ***",
// "TrackerLib::get_all_items: No item for itemId %0" => "TrackerLib::get_all_items: No item for itemId %0",
// "Tracker list_items ran out of memory after %0 items" => "Tracker list_items ran out of memory after %0 items",
// "No fields found in header, not a comma-separated values file" => "No fields found in header, not a comma-separated values file",
"Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem beim Einfügen des Trackereintrages: TrackerID: %0, erstellt: %1, zuletzt Verändert: %2, Status=%3",
"Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem beim Konvertieren des Trackereintrag-Linkfeldes: TrackerID: %0, Feld-ID: %1, Eintrag-ID: %2",
// "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"" => "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"",
"Field is not numeric" => "Feld ist nicht numerisch",
"Function" => "Funktion",
"Pending" => "Anstehend",
"Tracker field setup error - display field not found: " => "Tracker Feldeinstellungsfehler - Anzeigefeld nicht gefunden: ",
// "Item Creation" => "Item Creation",
"Item Modification" => "Eintragveränderung",
"Item" => "Eintrag",
"Subject" => "Betreff",
"Tracker was modified at %0 by %1" => "Tracker wurde am %0 von %1 verändert",
"View the tracker item at" => "Siehe Trackereintrag bei",
// "Missing wiki email template page \"%0\"" => "Missing wiki email template page \"%0\"",
"Tracker field not enabled: fieldId=%0 type=%1" => "Trackerfeld nicht aktiviert: FeldID=%0 Type=%1",
// "Field not specified" => "Field not specified",
"No extra information for that attached file. " => "Keine zusätzlichen Informationen zu dieser angehängten Datei vorhanden. ",
// "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list" => "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list",
// "Could not create /storage/pass_blacklists directory" => "Could not create /storage/pass_blacklists directory",
// "Existing password blacklist file was overwritten" => "Existing password blacklist file was overwritten",
// "Existing password blacklist file could not be overwritten" => "Existing password blacklist file could not be overwritten",
// "File Error. Password file not created" => "File Error. Password file not created",
// "File Error. Password file generation interrupted" => "File Error. Password file generation interrupted",
// "Password blacklist file generated" => "Password blacklist file generated",
// "Unable to Populate Blacklist: File dose not exist or is not readable" => "Unable to Populate Blacklist: File dose not exist or is not readable",
// "Critical" => "Critical",
// "Immediate notification by email" => "Immediate notification by email",
"High" => "hoch",
// "Will be sent to you with the next periodic digest" => "Will be sent to you with the next periodic digest",
"Low" => "niedrig",
// "Included in your personalized recent changes feed" => "Included in your personalized recent changes feed",
// "Anywhere" => "Anywhere",
// "translations of %0" => "translations of %0",
// "%0 in %1" => "%0 in %1",
// "%0 for %1" => "%0 for %1",
// "Any activity" => "Any activity",
// "Page modified" => "Page modified",
// "Page created" => "Page created",
// "Any forum activity" => "Any forum activity",
// "New topics" => "New topics",
// "Any item activity" => "Any item activity",
// "New items" => "New items",
// "Action Required" => "Action Required",
// "Recommendation Received" => "Recommendation Received",
// "%0 (%1 level up, entire structure)" => "%0 (%1 level up, entire structure)",
// "%0 (%1 level up)" => "%0 (%1 level up)",
// "%0 (current subtree)" => "%0 (current subtree)",
// "%0 Reply Handler" => "%0 Reply Handler",
// "The user [ %0 ] is not registered with this wiki and autocreate is disabled" => "The user [ %0 ] is not registered with this wiki and autocreate is disabled",
// "The user [ %0|%1 ] is not registered with this wiki and the creation process failed" => "The user [ %0|%1 ] is not registered with this wiki and the creation process failed",
// "unverified" => "unverified",
// "Your Information" => "Your Information",
"User Information" => "Benutzerinformationen",
"Can create/close a book" => "Kann ein Buch erstellen/schließen",
"Can create/edit/lock accounts" => "Kann Konten erstellen/bearbeiten/sperren",
"Create a new transaction" => "Kann eine neue Transaktion erstellen",
"Permission to view the journal" => "Berechtigung, um das Journal einzusehen",
"Can book into the stack where statements can be changed" => "Kann in den Stapel buchen, wo Auszüge geändert werden können",
"Can import statements from external accounts" => "Kann Buchungen von externen Konten importieren",
"Can manage templates for recurring transactions" => "Kann Vorlagen für wiederkehrende Transaktionen verwalten",
"Can admin the articles" => "Kann Artikel verwalten",
"Can approve submissions" => "Kann Einreichungen bestätigen",
"Can admin article topics" => "Kann Artikelthemen verwalten",
"Can admin article types" => "Kann Artikeltypen verwalten",
"Can read article headings" => "Kann Artikelüberschriften lesen",
"Submitted articles are automatically approved" => "Eingereichte Artikel werden automatisch bestätigt",
"Can edit articles" => "Kann Artikel bearbeiten",
// "Can edit the user (owner) of articles" => "Can edit the user (owner) of articles",
"Can edit submissions" => "Kann Einreichungen bearbeiten",
// "Can read articles (applies to article or topic level)" => "Can read articles (applies to article or topic level)",
"Can remove articles" => "Kann Artikel löschen",
"Can remove submissions" => "Kann Einreichungen löschen",
"Can submit articles" => "Kann Artikel einreichen",
"Can rate articles" => "Kann Artikel bewerten",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
"Can join a meeting" => "Kann einem Meeting beitreten",
"Can moderate a meeting" => "Kann ein Meeting moderieren",
"Can create a meeting" => "Kann ein Meeting starten",
// "Can use XMPP chat" => "Can use XMPP chat",
"Can admin blogs" => "Kann Blogs verwalten",
"Can assign perms to blog" => "Kann einem Blog Rechte zuweisen",
"Can post to a blog" => "Kann einen Blogeintrag posten",
"Can create a blog" => "Kann einen Blog erstellen",
"Can read blogs" => "Kann Blogs lesen",
"Can view in module and feed the blog posts" => "Kann Blog in Modulen sehen und die Blogeinträge feeden",
"Can view in module and feed the blog" => "Kann Blog in Modulen sehen und den Blog feeden",
"Can create/admin calendars" => "Kann Kalender erstellen/verwalten",
"Can add events in the calendar" => "Kann Ereignisse in den Kalender eintragen",
"Can edit events in the calendar" => "Kann Ereignisse im Kalender verändern",
"Can browse the calendar" => "Kann den Kalender durchstöbern",
"Can view event details" => "Kann Ereignisdetails einsehen",
"Can add himself or herself to the participants" => "Kann eigene Benutzer zu den Teilnehmern hinzufügen",
"Can add guest to the participants" => "Kann Gäste zu den Teilnehmern einladen",
"Can view Tiki tools calendar" => "Kann Tiki Werkzeug-Kalender einsehen",
"Can admin categories" => "Kann Kategorien verwalten",
"Can see the category in a listing" => "Kann die Kategorie in einer Auflistung einsehen",
"Can add objects to the category (tiki_p_modify_object_categories permission required)" => "Kann Objekte zur Kategorie hinzufügen (benötigt tiki_p_modify_object_categories)",
"Can remove objects from the category (tiki_p_modify_object_categories permission required)" => "Kann Objekte aus der Kategorie entfernen (benötigt tiki_p_modify_object_categories)",
// "Can assign perms to category" => "Can assign perms to category",
"Administrator can create channels, remove channels, etc" => "Administrator kann Kanäle erstellen, entfernen, etc.",
"Can use the chat system" => "Kann das Chatsystem benutzen",
"Can admin received articles" => "Kann empfangene Artikel verwalten",
"Can admin received pages" => "Kann empfangene Seiten verwalten",
"Can send articles to other sites" => "Kann Artikel zu anderen Sites schicken",
"Can send articles to this site" => "Kann Artikel zu dieser Site schicken",
"Can send pages to this site" => "Kann Seiten zu dieser Site schicken",
"Can send pages to other sites" => "Kann Seiten zu anderen Sites schicken",
"Can post new comments" => "Kann neue Kommentare posten",
"Can read comments" => "Kann Kommentare lesen",
"Can admin comments" => "Kann Kommentare verwalten",
"Can edit all comments" => "Kann alle Kommentare bearbeiten",
"Can delete comments" => "Kann Kommentare löschen",
"Can vote on comments" => "Kann für Kommentare abstimmen",
"Can admin content templates" => "Kann Inhaltsvorlagen verwalten",
"Can edit content templates" => "Kann Inhaltsvorlagen bearbeiten",
// "Can lock content templates" => "Can lock content templates",
"Can use content templates" => "Kann Inhaltsvorlagen benutzen",
"Can admin contributions" => "Kann Einreichungen verwalten",
"Can admin the directory" => "Kann das Linkverzeichnis verwalten",
"Can admin directory categories" => "Kann Verzeichniskategorien verwalten",
"Can admin directory sites" => "Kann Linkverzeichnisse verwalten",
"Submitted links are valid" => "Eingereichte Link sind automatisch gültig",
"Can submit sites to the directory" => "Kann Sites zum Linkverzeichnis hinzufügen",
"Can validate submitted links" => "Kann eingereichte Links validieren",
"Can use the directory" => "Kann das Linkverzeichnis benutzen",
"Can execute arbitrary queries on a given DSN" => "Kann frei wählbare Anfragen bei einem gegebenen DSN durchführen",
"Can admin FAQs" => "Kann FAQs verwalten",
"Can suggest FAQ questions" => "Kann eine Frage zu einem FAQ vorschlagen",
"Can view FAQs" => "Kann FAQs einsehen",
"Can download files" => "Kann Dateien herunterladen",
"Can upload files" => "Kann Dateien hochladen",
"Can list file galleries" => "Kann Dateiarchive auflisten",
"Can view file galleries" => "Kann Dateiarchive einsehen",
"Can admin file galleries" => "Kann Dateiarchive verwalten",
"Can assign permissions to file galleries" => "Kann Rechte zum Dateiarchiv zuweisen",
"Can use Directory Batch Load" => "Kann den Verzeichnis Batchupload nutzen",
"Can upload .zip file packages" => "Kann zip-Dateien mit Dateien hochladen",
"Can create file galleries" => "Kann Dateiarchive erstellen",
"Can edit a gallery file" => "Kann Dateiarchive bearbeiten",
"Can remove files" => "Kann Dateien entfernen",
"Can view file galleries explorer" => "Kann den Dateiarchivbrowser einsehen",
"Can view file galleries path" => "Kann den Dateiarchivpfad einsehen",
// "Can upload files containing JavaScript" => "Can upload files containing JavaScript",
// "Can upload SVG files" => "Can upload SVG files",
"Can admin forums" => "Kann Foren verwalten",
"Can attach files to forum posts" => "Kann an Forumposts anhängen",
"Auto approve forum posts" => "Forumposts werden automatisch bestätigt",
"Can post in forums" => "Kann in Foren posten",
"Can start threads in forums" => "Kann einen Thread im Forum starten",
"Can read forums" => "Kann Foren lesen",
"Can report posts to moderator" => "Kann einen Post dem Moderator melden",
"Can vote on comments in forums" => "Kann Kommentare in Foren bewerten",
"Can browse tags" => "Kann Tags durchstöbern",
"Can admin tags" => "Kann Tags verwalten",
"Can tag objects" => "Kann Tags zu einem Objekt zuweisen",
"Can unassign tags from an object" => "Kann Tags von einem Objekt entfernen",
"Can subscribe to groups" => "Kann sich Gruppen zuordnen",
"Can invite user to my groups" => "Kann Benutzer zu meiner Gruppen einladen",
"Can view the group" => "Kann die Gruppe einsehen",
"Can view the group members" => "Kann Gruppenmitglieder einsehen",
"Can add group members" => "Kann Mitglieder zu einer Gruppe hinzufügen",
"Can remove group members" => "Kann Gruppenmitglieder entfernen",
"Can join or leave the group" => "Kann einer Gruppe beitreten/sie verlassen",
// "Can view H5P content" => "Can view H5P content",
// "Can edit H5P content" => "Can edit H5P content",
// "Can administer H5P content" => "Can administer H5P content",
"Can edit HTML pages" => "Kann HTML Seiten bearbeiten",
"Can view HTML pages" => "Kann HTML Seiten einsehen",
"Can admin Image Galleries" => "Kann Bildergalerien verwalten",
"Can assign permissions to image galleries" => "Kann Rechte zu einer Bildergalerie zuweisen",
"Can upload .zip files of images" => "Kann zip-Dateien mit Bildern hochladen",
"Can create image galleries" => "Kann Bildergalerien erstellen",
"Can list image galleries" => "Kann Bildergalerien auflisten",
"Can upload images" => "Kann Bilder hochladen",
"Can view image galleries" => "Kann Bildergalerien einsehen",
"Can admin Kaltura video feature" => "Kann Kaltura Video-Funktion verwalten",
"Can upload video or record from webcam" => "Kann Video hochladen oder mit Webcam aufnehmen",
"Can edit media information" => "Kann Medieninformationen bearbeiten",
"Can delete media" => "Kann Medien löschen",
"Can download media" => "Kann Medien herunterladen",
"Can list media" => "Kann Medien auflisten",
"Can view media" => "Kann Medien ansehen",
"Can broadcast messages to all users" => "Kann eine Nachricht zu allen Benutzern senden",
"Can broadcast messages to groups" => "Kann eine Nachricht zur Gruppe senden",
"Can use the messaging system" => "Kann das Nachrichtensystem nutzen",
"Can admin newsletters" => "Kann Newsletter verwalten",
"Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)" => "Kann viele E-Mails auf einmal abonnieren (erfordert tiki_p_subscribe email)",
"Can send newsletters" => "Kann Newsletter versenden",
"Can subscribe any email address to newsletters" => "Kann jede E-Mail zum Newsletter anmelden",
"Can subscribe to newsletters" => "Kann Newsletter abonnieren",
"Can view the archive of a newsletters" => "Kann ein Newsletterarchiv einsehen",
"Can list newsletters" => "Kann Newsletter auflisten",
"Can administer payments" => "Kann Zahlungen verwalten",
"Can view payment requests and details" => "Kann Zahlungsanfragen und -details einsehen",
"Can enter manual payments" => "Kann eine manuelle Bezahlung eingeben",
"Can request a payment" => "Kann eine Bezahlung anfordern",
"Can view the perspective" => "Kann Perspektiven einsehen",
"Can edit the perspective" => "Kann eine Perspektive bearbeiten",
"Can create a perspective" => "Kann eine Perspektive erstellen",
"Can admin perspectives" => "Kann Perspektiven verwalten",
"Can admin polls" => "Kann Abstimmung verwalten",
"Can view poll results" => "Kann Abstimmungsergebnisse einsehen",
// "Can view poll user choices" => "Can view poll user choices",
"Can vote in polls" => "Kann Abstimmungen bewerten",
"Can view poll voters" => "Kann Bewerter von Abstimmung einsehen",
"Can admin quizzes" => "Kann Quiz verwalten",
"Can take quizzes" => "Kann an einem Quiz teilnehmen",
"Can view quiz stats" => "Kann Quizstatistiken einsehen",
"Can view user quiz results" => "Kann Quizergebnisse von Benutzern einsehen",
"Can admin spreadsheets" => "Kann Tabellen verwalten",
"Can create and edit spreadsheets" => "Kann Tabellen erstellen und bearbeiten",
"Can view spreadsheets" => "Kann Tabelle einsehen",
"Can view spreadsheets history" => "Kann Tabellenhistorie einsehen",
"Can admin the shoutbox (edit/remove messages)" => "Kann Shoutbox verwalten (Nachrichten bearbeiten/entfernen)",
"Can post messages in the shoutbox" => "Kann Nachrichten in der Shoutbox posten",
"Can view the shoutbox" => "Kann Shoutbox einsehen",
"Can use social network integration" => "Benutzer kann die Integration von sozialen Netzwerken nutzen",
"Can register this site with social networks" => "Benutzer kann die Site bei sozialen Netzwerken registrieren",
"Admin live support system" => "Kann Livesupportsystem verwalten",
"Can use live support system" => "Kann Livesupportsystem benutzen",
"Can admin surveys" => "Kann Umfragen verwalten",
"Can take surveys" => "Kann an Umfragen teilnehmen",
"Can view survey stats" => "Kann Umfrageergebnisse einsehen",
"Can admin TikiTests" => "Kann die TikiTests verwalten",
"Can edit TikiTests" => "Kann TikiTests bearbeiten",
"Can replay TikiTests" => "Kann TikiTests wiedergeben",
"Can admin trackers" => "Kann Tracker verwalten",
"Can attach files to tracker items" => "Kann Dateien an Trackereinträge anhängen",
"Can view tracker item attachments and download them" => "Kann Anhänge zu Trackereinträgen einsehen und herunterladen",
"Can post tracker item comments" => "Kann Kommentare zu Trackerelementen hinzufügen",
"Can view tracker item comments" => "Kann Kommentare zu Trackereinträgen einsehen",
"Can create new tracker items" => "Kann neues Trackerelement hinzufügen",
"Can list trackers" => "Kann Tracker auflisten",
"Can change tracker items" => "Kann Trackereinträge ändern",
"Can change pending tracker items" => "Kann noch anstehende Trackereinträge ändern",
"Can change closed tracker items" => "Kann geschlossene Trackereinträge ändern",
"Can remove tracker items" => "Kann Trackereinträge entfernen",
"Can remove pending tracker items" => "Kann noch anstehende Trackereinträge entfernen",
"Can remove closed tracker items" => "Kann geschlossene Trackereinträge entfernen",
"Can view rating result for tracker items" => "Kann Bewertungsergebnis für Trackereinträge einsehen",
"Can rate tracker items" => "Kann einen Trackereintrag bewerten",
"Can re-rate tracker items" => "Kann nochmal bei Trackereinträgen abstimmen",
"Can view trackers" => "Kann Tracker einsehen",
"Can view closed trackers items" => "Kann geschlossene Trackereinträge einsehen",
"Can view pending trackers items" => "Kann anstehende Trackereinträge einsehen",
"Can watch a tracker" => "Kann Tracker beobachten",
"Can export tracker items" => "Kann Trackerelemente exportieren",
"Can save a CSV backup of all trackers" => "Kann ein .CSV-Datensicherung aller Tracker durchführen",
// "Manage tracker views" => "Manage tracker views",
// "View list view of tracker tabular data. Tracker item permissions apply" => "View list view of tracker tabular data. Tracker item permissions apply",
// "Export a tracker tabular view to CSV. Tracker permissions may not apply" => "Export a tracker tabular view to CSV. Tracker permissions may not apply",
// "Import a CSV file into a tabular tracker. Tracker permissions may not apply" => "Import a CSV file into a tabular tracker. Tracker permissions may not apply",
"Can trigger the transition between two states" => "Kann den Übergang zwischen zwei Zuständen veranlassen",
"Can admin users" => "Kann Benutzer verwalten",
"Can cache user bookmarks" => "Kann Benutzerbookmarks cachen",
"Can configure modules" => "Kann Module konfigurieren",
"Can create user bookmarks" => "Kann Benutzerbookmarks erstellen",
"Can use the mini event calendar" => "Kann den Mini-Ereigniskalender benutzen",
"Can use the notepad" => "Kann Notizblock benutzen",
"Can admin public tasks" => "Kann öffentliche Aufträge verwalten",
"Can use tasks" => "Kann Aufgaben benutzen",
"Can receive tasks from other users" => "Kann Aufträge von anderen Benutzern erhalten",
"Can send tasks to other users" => "Kann Aufträge an andere Benutzern senden",
"Can upload personal files" => "Kann eigene Dateien hochladen",
"Can create items in personal menu" => "Kann Einträge im persönlichen Menü erstellen",
"Can list registered users" => "Kann registrierte Benutzer auflisten",
"Can invite users by email, and include them in groups" => "Kann Benutzer per E-Mail einladen und sie in Gruppen einbinden",
"Can delete his/her own account" => "Kann sein/ihr eigenes Konto löschen",
"Can use webmail" => "Kann Webmail benutzen",
"Can use group webmail" => "Kann Gruppenwebmail benutzen",
"Can admin group webmail accounts" => "Kann Gruppen-Webmail-Konten verwalten",
"Can use personal webmail accounts" => "Kann persönliche Webmail Accounts benutzen",
"Can admin personal webmail accounts" => "Kann persönliche Webmailkonten verwalten",
"Can view page/pages" => "Kann eine Seite/Seiten einsehen",
"Can edit pages" => "Kann Seiten bearbeiten",
// "Can inline-edit pages" => "Can inline-edit pages",
"Can view wiki history" => "Kann Wiki Historie einsehen",
"Can admin the wiki" => "Kann die Wiki verwalten",
"Can assign permissions to wiki pages" => "Kann Rechte zu Wikiseiten zuweisen",
"Can edit copyright notices" => "Kann Copyrighthinweis ändern",
"Can edit dynamic variables" => "Kann dynamische Variablen bearbeiten",
"Can export wiki pages using the export feature" => "Kann mittels Exportfunktion Wiki Seiten exportieren",
"Can lock pages" => "Kann Seiten sperren",
"Can save as a minor edit" => "Kann Seite als geringfügige Änderung speichern",
"Can remove" => "Kann entfernen",
"Can rename pages" => "Kann Seiten umbenennen",
"Can roll back pages" => "Kann Seiten zurückrollen",
"Can upload pictures to wiki pages" => "Kann Bilder zu Wikiseiten hochladen",
// "Can use the page as a template for a tracker or unified search" => "Can use the page as a template for a tracker or unified search",
"Can view in module and feed the wiki pages reference" => "Kann Wiki Seiten in Modulen sehen und die Wiki Seiten-Referenzen feeden",
"Can admin attachments on wiki pages" => "Kann Anhänge auf Wiki Seiten verwalten",
"Can add and change ratings on wiki pages" => "Kann Bewertungen zu Wiki Seiten hinzufügen und ändern",
"Can attach files to wiki pages" => "Kann Dateien an Wiki-Seiten anhängen",
"Can view and download wiki page attachments" => "Kann Wiki Anhänge ansehen und herunterladen",
"Can view wiki comments" => "Kann Wiki Kommentare ansehen",
"Can view rating of wiki pages" => "Kann Bewertungen von Wiki Seiten einsehen",
"Can view source of wiki pages" => "Kann Quelltext von Wikiseiten einsehen",
"Can participate in rating of wiki pages" => "Kann an Bewertungen von Wiki Seiten teilnehmen",
"Can view similar wiki pages" => "Kann ähnliche Wikiseiten einsehen",
"View page backlinks" => "Kann Backlinks einsehen",
"Can view unapproved revisions of pages" => "Kann unbestätigte Revisionen von Seiten einsehen",
"Can approve revisions of pages" => "Kann Revisionen von Seiten bestätigen",
"Can view contributions to a page" => "Kann Beiträge zu Wikiseiten einsehen",
// "Can use reference library items" => "Can use reference library items",
// "Can add to, edit and remove reference library items" => "Can add to, edit and remove reference library items",
// "Can administer structures" => "Can administer structures",
"Can create and edit structures" => "Kann Strukturen erstellen und bearbeiten",
// "Can lock structures" => "Can lock structures",
"Can watch structures" => "Kann Strukturen beobachten",
"Administrator can manage users, groups and permissions and all features" => "Administrator kann Benutzer, Gruppen, Berechtigungen und alle Funktionen verwalten",
"Can access site when closed" => "Kann auf Site zugreifen, wenn diese geschlossen ist",
"Administrator can admin banners" => "Administrator kann Banner verwalten",
"Can ban users or IP addresses" => "Kann Benutzer oder IPS verbannen",
"Can admin the dynamic content system" => "Kann dynamische Inhalte verwalten",
"Can admin integrator repositories and rules" => "Kann Integrator Repositories und Regeln verwalten",
// "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n" => "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n",
"Can admin mail-in accounts" => "Kann Mail-in-Konten verwalten",
"Can edit object permissions" => "Kann Objektberechtigungen ändern",
"Can admin external feeds" => "Kann externe Feeds verwalten",
"Can clean cache" => "Kann den Cache löschen",
"Can create a new CSS file (style sheet) appended with -user" => "Kann neues CSS mit Suffix -user erstellen",
"Can remove the association between two pages in a translation set" => "Kann die Verknüpfung zwischen zwei Seiten in einem Übersetzungsset löschen",
"Can admin cookies" => "Kann Cookies verwalten",
"Can edit translations and create new languages" => "Kann Übersetzungen bearbeiten und neue Sprachen anlegen",
"Can edit menus" => "Kann Menüs bearbeiten",
"Can edit menu options" => "Kann Menüoptionen bearbeiten",
"Can edit site templates" => "Kann Site-Vorlagen bearbeiten",
"Can search" => "Kann suchen",
"Can report a link to the webmaster" => "Kann einen Link dem Webmaster berichten",
"Can send a link to a friend" => "Kann einem Freund einen Link senden",
"Can share a page (email, Twitter, Facebook, message, forums)" => "Kann die Seite mit anderen teilen (E-Mail,Twitter, Facebook, Nachrichten, Forums)",
"Can use HTML in pages" => "Kann HTML-Seiten benutzen",
"Can view action log" => "Kann das Aktionslog einsehen",
"Can view the action log for users of his or her groups" => "Kann das Aktionslog für Gruppenmitglieder seiner Gruppe einsehen",
"Can view integrated repositories" => "Kann integriertes Depot (repository) einsehen",
// "Can view results from user ratings" => "Can view results from user ratings",
"Can view referrer stats" => "Kann Referer-Statistiken einsehen",
"Can view site stats" => "Kann Sitestatistiken einsehen",
"Can view site templates" => "Kann Sitevorlagen einsehen",
// "Can view results from webservice requests" => "Can view results from webservice requests",
// "Can administer webservices" => "Can administer webservices",
"Can admin toolbars" => "Kann Toolbars verwalten",
"Trust all user inputs including plugins (no security checks)" => "Vertraue allen Benutzereingaben einschließlich Plugins (keine Sicherheitsprüfung)",
"Can view unapproved plugin details" => "Kann unbestätigte Plugindetails einsehen",
"Can execute unapproved plugin registered" => "Kann unbestätigte Plugins ausführen",
"Can approve plugin execution" => "Kann Pluginausführung bestätigen",
"Can admin mail notifications" => "Kann Mailbenachrichtigungen verwalten",
"Can use the importer" => "Kann den Importer benutzen",
"Can change the categories of an object" => "Kann Kategorien eines Objekts ändern",
"User can administer modules" => "Benutzer kann Module verwalten",
"Can switch between wiki and WYSIWYG modes while editing" => "Kann zwischen Wiki- und WYSIWYG-Modus umschalten",
"Can create a new workspace for a given template" => "Kann einen neuen Arbeitsbereich für die gegebene Vorlage erstellen",
// "Can manage all aspects of a goal" => "Can manage all aspects of a goal",
// "Can manage who is eligible for a goal" => "Can manage who is eligible for a goal",
// "Cannot add user %0 to nonexistent group %1" => "Cannot add user %0 to nonexistent group %1",
// "Cannot add nonexistent user %0 to group %1" => "Cannot add nonexistent user %0 to group %1",
"User \"%0\" is banned from the group \"%1\"" => "Benutzer \"%0\" wurde aus der Gruppe \"%1\" verbannt",
"Do you want to unban them and continue" => "Möchtest Du die Verbannung rückgängig machen und fortfahren",
// "Email cannot be set because this email is already in use by another user" => "Email cannot be set because this email is already in use by another user",
"Password should be at least %0 characters long" => "Password sollte mindestens %0 Zeichen lang sein",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"" => "Passwort muss mindestens ein alphabetisches Zeichen in Kleinbuchstaben enthalten (z.B. a) und eines in Großbuchstaben (z.B. A)",
"Password must contain both letters and numbers" => "Passwort muss sowohl Buchstaben als auch Zahlen enthalten",
"Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Passwort muss mindestens ein Sonderzeichen enthalten (z.B. \" / \$ % ? & * ( ) _ + ..)",
// "The password is blacklisted because it is too common" => "The password is blacklisted because it is too common",
// "No user tracker found with id #%0" => "No user tracker found with id #%0",
"The administrator has not yet validated your account. Please wait" => "Der Administrator hat Dein Konto noch nicht validiert. Bitte warte",
"You must validate your account first. An email has been sent to you" => "Du musst zuerst Dein Konto validieren. Eine E-Mail wurde Dir zugesandt",
// "Email address is required" => "Email address is required",
// "Invalid email address \"%0\"" => "Invalid email address \"%0\"",
// "Unable to send mail to invite \"%0\"" => "Unable to send mail to invite \"%0\"",
// "The email could not be retrieved from the IdP and is required" => "The email could not be retrieved from the IdP and is required",
// "The username could not be retrieved from the IdP and is required" => "The username could not be retrieved from the IdP and is required",
// "SAML Login failed. User not authenticated" => "SAML Login failed. User not authenticated",
"Can edit one's own forum posts" => "Kann eigene Forumposts ändern",
"The registration mail can't be sent. Contact the administrator" => "Die Registrierungs-E-Mail konnte nicht gesendet werden. Benachrichtige bitte den Administrator.",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "Die Registrierungs-E-Mail kann nicht gesendet werden, weil keine Serveremailadresse angegeben wurde und diese Funktion deaktiviert ist",
"The user email confirmation can't be sent. Contact the administrator" => "Die E-Mailbestätigung des Benutzers kann nicht gesendet werden. Kontaktiere den Administrator",
// "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)",
"Edit field: (Incorrect validation parameter)" => "Feld bearbeiten: (ungültiger Validierungsparameter)",
"Page already exists" => "Seite existiert schon",
"Page does not exist" => "Seite existiert nicht",
// "Email already in use" => "Email already in use",
"Invalid email" => "Ungültige E-Mail",
"Invalid character combination for username" => "Ungültige Zeichenkombination im Benutzernamen",
// "Username must be all lower case" => "Username must be all lower case",
"Personal Phone" => "privates Telefon",
"Personal Mobile" => "privates Mobiltelefon",
"Personal Fax" => "privates Fax",
"Work Phone" => "Geschäftliches Telefon",
"Work Mobile" => "Geschäftliches Mobiltelefon",
"Work Fax" => "Geschäftliches Fax",
"Company" => "Firma",
"Organization" => "Organisation",
"Department" => "Abteilung",
"Division" => "Branche",
"Job Title" => "Beruf",
"Street Address" => "Straße",
"City" => "Stadt",
"State" => "Status",
"Postal Code" => "PLZ",
// "Mail to: User not found" => "Mail to: User not found",
"(AT)" => "(AT)",
"(DOT)" => "(PUNKT)",
// "Webservice error on %0 request \"%1\"" => "Webservice error on %0 request \"%1\"",
// "You will need to rebuild the search index to see these changes" => "You will need to rebuild the search index to see these changes",
// "Parse To Wiki %0: preg_replace error #%1" => "Parse To Wiki %0: preg_replace error #%1",
"Cannot create aliased page" => "Kann Alias-Seite nicht erstellen",
"You attempted to create the following page" => "Du hast versucht, die folgende Seite zu erstellen",
"That page is an alias for the following pages" => "Diese Seite ist ein Alias für die folgenden Seiten",
"If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this" => "Wenn Du eine Seite erstellen willst, musst Du zuerst alle von den obigen Seiten bearbeiten und den Alias-Link entfernen, der vorhanden sein kann. Dieser Link sollte in etwa aussehen wie",
"Can't parse HTML data - no grammar file" => "Kann HTML-Daten nicht parsen - keine Grammatik-Datei",
"Rollback by %0 to version %1" => "zurückgerollte Version",
"Removed version \$version" => "gelöschte Version \$version",
"Changed actual version to \$version" => "Ändere aktuelle Version zu \$version",
"No version indicated" => "Keine Version angegeben",
"Plugin " => "Plugin ",
"failed" => "fehlgeschlagen",
"Required parameters are in</em> <b>bold</b>" => "Erforderliche Parameter sind </em> <b>fett</b> dargestellt",
"Parameter Info" => "Parameter Info",
"There are no approved versions of this page" => "Es gibt keine bestätigten Versionen von dieser Seite",
"Semantic token already exists" => "Semantisches Token existiert bereits",
"Invalid semantic token name" => "Ungültiger semantischer Token-Name",
"Semantic token not found" => "Semantisches Token nicht gefunden",
"Page locked" => "Seite sperren",
"Page unlocked" => "Seite entsperren",
// "Initial content copied from version %0 of page %1" => "Initial content copied from version %0 of page %1",
// "You don't have permission to use category '%0'" => "You don't have permission to use category '%0'",
// "You don't have permission to edit categories" => "You don't have permission to edit categories",
// "You don't have permission to edit tags" => "You don't have permission to edit tags",
"Removed last version" => "Löschte letzte Version",
"Activity Stream" => "Aktivitätenstrom",
// "Create a social network activity stream" => "Create a social network activity stream",
"List configuration information" => "Liste Konfigurationsinformationen",
// "Auto-Scroll" => "Auto-Scroll",
// "Automatically load next page of results when scrolling down" => "Automatically load next page of results when scrolling down",
"Add Tag" => "Tag hinzufügen",
// "Provide an input field for adding a tag to an object" => "Provide an input field for adding a tag to an object",
// "Object type and id, as in %0type:id%1, if unset, will use current object" => "Object type and id, as in %0type:id%1, if unset, will use current object",
// "Add Reference" => "Add Reference",
// "Add a bibliography reference" => "Add a bibliography reference",
// "Biblio Code" => "Biblio Code",
// "The code to be added as reference" => "The code to be added as reference",
// "missing bibliography definition" => "missing bibliography definition",
"Add Relation" => "Beziehung hinzufügen",
// "Provide a button to toggle a pre-specified relation" => "Provide a button to toggle a pre-specified relation",
"Qualifier" => "Kennzeichner",
"Relation qualifier. Usually a three-part string separated by two periods" => "Beziehungskennzeichner. Normalerweise ein dreiteiliger String, getrennt durch zwei Punkte",
"Source Object" => "Quellobjekt",
// "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank",
"Target Object" => "Zielobjekt",
// "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank",
"Button Text for Add" => "Schaltflächentext für Hinzufügen",
"Text to show on the button to add relation" => "Text, der auf der Schaltfläche zum Hinzufügen einer Beziehung angezeigt wird",
"Button Text for Already Added State" => "Schaltflächentext für bereits hinzugefügte Beziehung",
"Text to show on the button when relation is already added" => "Text, der auf der Schaltfläche angezeigt wird, wenn eine Beziehung bereits hinzugefügt wurde",
"Relation Added" => "Beziehung hinzugefügt",
"Mouseover Button Text for Remove" => "Text Mouseover-Schaltfläche zum Entfernen",
"Text to show on the button to remove relation" => "Text, der auf der Schaltfläche zum Entfernen einer Beziehung angezeigt wird",
"Remove Relation" => "Entferne Beziehung",
"Button ID" => "Schaltflächen-Id",
"A unique ID to distinguish the button from others on the page if there is more than one" => "Eine einzigartige ID, um die Schaltfläche von anderen auf der Seite zu unterscheiden, wenn mehr als eine vorhanden sind",
// "Set Button Class" => "Set Button Class",
// "Class or classes for the Button" => "Class or classes for the Button",
"Source and target object cannot be the same" => "Quell- und Zielobjekt dürfen nicht identisch sein",
"Add to cart" => "Zum Warenkorb hinzufügen",
"PluginAddToCart" => "PluginAddToCart",
// "Add a product to the shopping cart" => "Add a product to the shopping cart",
"Product code" => "Produktcode",
"Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Einzigartige Kennung (ID) für das Produkt. Zwei Produkte mit dem selben Code sind dasselbe und die benutzte Information ist diejenige des ersten eingetragenen",
"Label for the product in the cart" => "Bezeichnung für das Produkt im Warenkorb",
"Product Type" => "Produkttyp",
"The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket" => "Der Produktyp, der verkauft wird, z.B. Standardprodukt, Geschenkgutschein, Event-Ticket",
"Product Class" => "Produktklasse",
"The class the product belongs to. Can be used to limit how gift cards are used" => "Die Klasse, zu der ein Produkt gehört. Kann dazu benutzt werden einzuschränken, wie Geschenkgutscheine benutzt werden",
"Product Bundle" => "Produktbündel",
"The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart" => "Das Bündel, zu dem ein Produkt zugehört. Kann dazu benutzt werden einzuschränken, wie Geschenkgutscheine benutzt werden. Hierdurch werden automatisch andere Produkte in der gleichen Klasse in den Warenkorb hinzugefügt",
"Bundle Class" => "Bündelklasse",
"The class the bundle belongs to. Can be used to limit how gift cards are used" => "Die Klasse, der das Bündel zugehört. Kann dazu benutzt werden einzuschränken, wie Geschenkgutscheine benutzt werden",
"Price" => "Preis",
"The price to charge for the item" => "Der Preis, der für ein Produkt berechnet wird",
// "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)" => "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)",
"Button label" => "Bezeichnung Schaltfläche",
// "Text for the submit button. default" => "Text for the submit button. default",
"Associated event code" => "Zugewiesener Event-Code",
"Unique identifier for the event that is associated to the product" => "Einzigartige Kennung (ID) für das Ereignis, der dem Produkt zugewiesen ist",
"Automatically check out" => "Automatisch zur Kasse",
"Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)" => "Automatisch zur Kasse gehen und Benutzer zur Zahlung weiterleiten (das ist deaktiviert, wenn bereits etwas im Warenkorb liegt)",
// "Hide Quantity" => "Hide Quantity",
// "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)" => "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)",
"Buy on behalf of" => "Kaufe im Auftrag für",
"Allows the selection of user to make purchase on behalf of" => "Erlaubt die Auswahl eines Benutzers für den der Einkauf getätigt wird",
"Shop as anonymous always" => "Immer als Anonymus einkaufen",
"Add to cart as anonymous shopper even if logged in" => "Lege es als anonymer Benutzer in den Warenkorb - auch wenn angemeldet",
"Forward to this URL after free purchase" => "Nach kostenlosem Kauf auf diese URL weiterleiten",
"Gift certificate" => "Geschenkgutschein",
"Allows user to add gift certificate from the product view" => "Erlaube es Benutzer einen Geschenkgutschein aus der Produktansicht hinzuzufügen",
"Order Item ID to exchange product" => "Bestellobjekt-ID, um Produkt auszutauschen",
"Used in conjunction with exchange feature" => "Wird in Verbindung mit der Austausch-Funktion benutzt",
"Product ID to exchange to" => "Produkt-ID in die getauscht werden soll",
"Amount of new product to exchange for" => "Anzahl von neuen Produkten mit denen getauscht werden soll",
"Should normally be set to the amount of products in the order being exchanged" => "Es sollte normalerweise die Menge an Produkten eingestellt werden, die in der Bestellung getauscht wird",
"Ajax add to cart feature" => "Ajax-Funktion: zum Warenkorb hinzufügen",
"Attempts to turn on Ajax for the cart" => "Versucht Ajax für den Warenkorb zu aktivieren",
"Weight" => "Gewicht",
// "The weight of the item" => "The weight of the item",
"The order was recorded and is now awaiting payment. Reference number is %0" => "Die Bestellung wurde entgegen genommen. Die Bezahlung steht aus. Referenznummer ist %0",
"Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Deine kostenlose Bestellung von %0 (%1) wurde bearbeitet. Eine Bestätigungs-E-Mail wurde Dir zugesandt",
"Your free order of %0 (%1) has been processed" => "Deine kostenlose Bestellung von %0 (%1) wurde bearbeitet",
"%0 (%1) was added to your cart" => "%0 (%1) wurde dem Warenkorb hinzugefügt",
"Add to Google Calendar" => "Zu Googlekalender hinzufügen",
"Add a calendar item to a Google calendar." => "Fügt einen Kalendereintrag zum Google Kalender hinzu",
"Calendar item ID" => "Kalendereintrags-ID",
"The item ID of the calendar to add to Google calendar" => "Die Eintrags-ID des Kalenders, um sie in Google Kalender hinzuzufügen",
"A calendar item ID number" => "Eine Kalendereintrag ID-Nummer",
"Icon Style" => "Symbolstil",
"Choose the icon style" => "Wähle den Symbolstil",
"Either 1, 2 or 3" => "Entweder 1, 2 oder 3",
"Adjust Inventory" => "Bestand anpassen",
"PluginAdjustInventory" => "PluginAdjustInventory",
// "Adjust the inventory level of a product" => "Adjust the inventory level of a product",
"Product ID" => "Produkt ID",
"Product ID of item in the cart tracker" => "Produkt ID eines Objekts im Einkaufswagen-Tracker",
// "Show Add" => "Show Add",
// "Show option to add to inventory" => "Show option to add to inventory",
// "Show Subtract" => "Show Subtract",
// "Show option to subtract from inventory" => "Show option to subtract from inventory",
"Inventory was adjusted by %0" => "Bestand wurde angepasst um %0",
"User Agent Info" => "User Agent Informationen",
"Show the user's browser and server information." => "Zeigt Browser- und Serverinformationen des Benutzers",
"Info" => "Information",
"Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Zeigt die IP-Adresse des Besuchers (IP oder Standard), Browserinformationen (BROWSER), oder Serversoftware (SVRSW)",
"IP address" => "IP-Addresse",
"Server software" => "Serversoftware",
"Browser" => "Browser",
// "Ajax Load" => "Ajax Load",
// "Load data into an HTML div using Ajax or in an iframe" => "Load data into an HTML div using Ajax or in an iframe",
// "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML" => "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML",
// "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1" => "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1",
// "Selector" => "Selector",
// "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1" => "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1",
"Target" => "Ziel",
// "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page" => "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page",
// "HTML id for the div or iframe" => "HTML id for the div or iframe",
// "Class for the div or iframe" => "Class for the div or iframe",
// "In pixels or percentage. Default value is %0" => "In pixels or percentage. Default value is %0",
// "Make Links Absolute" => "Make Links Absolute",
// "Convert relative links in the incoming data to be absolute. Default value is \"All\"" => "Convert relative links in the incoming data to be absolute. Default value is \"All\"",
// "Images Only" => "Images Only",
// "Links Only" => "Links Only",
// "Parameter URL missing" => "Parameter URL missing",
"Anchor Link" => "Ankerlink",
"Create a link to an anchor" => "Erstelle einen Link zu einem Anker",
"Anchor link label" => "Ankerlinkbezeichung",
"Anchor Name" => "Ankername",
"The anchor name as defined in the Aname plugin" => "Der Ankername, so wie er im Plugin ANAME definiert wurde",
"The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "Der Name der Wiki Seite, die den Anker enthält. Wenn leer, wird der Anker auf der Seite gesucht, wo das Plugin benutzt wird",
"Create an anchor that can be linked to" => "Erstelle einen Anker, zu dem ein Link gesetzt werden kann",
"The name of the anchor" => "Der Name des Ankers",
"Image Annotation" => "Bildkommentierung",
"Annotate an image" => "Kommentiere ein Bild",
"Autogenerated content. Leave blank initially" => "Automatisch erstellter Inhalt. Anfänglich frei lassen",
// "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0" => "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0",
// "Absolute URL to the image or relative path from Tiki site root" => "Absolute URL to the image or relative path from Tiki site root",
"Image width in pixels" => "Bildbreite in Pixel",
"Image height in pixels" => "Bildhöhe in Pixel",
"Alignment" => "Ausrichtung",
// "Image alignment" => "Image alignment",
"Center" => "Zentrieren",
"CSS Class" => "CSS-Klasse",
// "Class of the containing DIV element" => "Class of the containing DIV element",
// "Show List" => "Show List",
// "Show the list of annotations below the image" => "Show the list of annotations below the image",
// "(y/n)" => "(y/n)",
"Show Link" => "Zeige Link",
// "Show the link below the label in the popups" => "Show the link below the label in the popups",
"Save changes to annotations" => "Speichere Änderungen an Anmerkungen",
"Image annotations changed" => "Bildanmerkungen geändert",
"Editable" => "bearbeitbar",
"Label" => "Beschriftung",
"Application Frame" => "Anwendungsrahmen",
// "Create a frame in which to assemble custom applications" => "Create a frame in which to assemble custom applications",
"Application layout" => "Anwendungslayout",
"Minimum height" => "Mindesthöhe",
"Prevent the frame from becoming any shorter than the specified size" => "Verhindert, dass der Rahmen kleiner wird, als die angegebene Größe",
// "Maximum height" => "Maximum height",
// "Prevent the frame from becoming any higher than the specified size" => "Prevent the frame from becoming any higher than the specified size",
"Hide left column" => "Verstecke linke Spalte",
"Hide the left column when the application frame is in use to provide more space to the application" => "Verstecke die linke Spalte, wenn der Anwendungsrahmen benutzt wird, damit die Anwendung mehr Platz hat",
"Hide right column" => "Verstecke rechte Spalte",
"Hide the right column when the application frame is in use to provide more space to the application" => "Verstecke die rechte Spalte, wenn der Anwendungsrahmen benutzt wird, damit die Anwendung mehr Platz hat",
"Full page" => "Volle Seite",
"Completely fill the content area of the page" => "Belege den gesamten Inhaltsbereich der Seite",
"Absolute Position" => "Absolute Position",
"Use all available space for the application frame (by means of CSS absolute positioning)" => "Positioniere den App-Frame, um die absolute Position zu verwenden und wirklich allen verfügbaren Platz zu nutzen",
"When using absolute mode, leave some space for the header at the top" => "Bei der Nutzung des absoluten Modus, lasse etwas Platz am Anfang für den Kopf",
// "Fill the complete page" => "Fill the complete page",
"Template file not found: %0" => "Vorlage-Datei nicht gefunden: %0",
// "Pan/Zoom" => "Pan/Zoom",
"Select" => "Auswählen",
// "Select/Modify" => "Select/Modify",
// "Draw Polygon" => "Draw Polygon",
// "Draw Path" => "Draw Path",
// "Reset Zoom" => "Reset Zoom",
"Archive Builder" => "Archiv erzeugen",
// "Define an archive that can be downloaded" => "Define an archive that can be downloaded",
"Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Beschreibung des Archivinhalts. Multiple Handler stehen zur Verfügung. Eine pro Zeile, z.B.: Seite-als-pdf:irgendein-Ordner/foo.pdf:HomePage , Tracker-Anhänge:Ziel-Ordner/:3435",
"Archive Name" => "Archivname",
"Upon download, the name of the file that will be provided" => "Der Dateiname, der beim Download angeboten wird",
"Missing \".zip\" file name extension" => "Fehlende Dateierweiterung zip",
"Incorrect parameter" => "Falsche Parameter",
"Download archive" => "Archiv herunterladen",
"Display a field of an article" => "Zeige ein Feld eines Artikels",
"The article field (component) to display. The default field is \"Heading\"" => "Das Artikelfeld, das angezeigt werden soll. Standardfeld ist der Kopf",
"Article ID" => "Artikel ID",
"The article to display. If no value is provided, the most recent article will be used" => "Der anzuzeigende Artikel. Wenn kein Wert angegeben wird, wird der jüngste Artikel verwendet",
"Article List" => "Artikelliste",
"Display multiple articles" => "Zeige multiple Artikel",
"Use Pagination" => "Benutze Paginierung",
// "Activate pagination when the articles list is long. Default is %0" => "Activate pagination when the articles list is long. Default is %0",
"Maximum Displayed" => "Maximal angezeigte Anzahl",
// "The number of articles to display in the list (use %0 to show all)" => "The number of articles to display in the list (use %0 to show all)",
"Topic Name Filter" => "Themanamensfilter",
"Filter the list of articles by topic. Example: " => "Filtere die Liste der Artikel nach deren Themen. Beispiel: ",
"Topic ID Filter" => "Thema ID-Filter",
"Filter the list of articles by topic ID. Example: " => "Filtere die Liste der Artikel nach deren Themen-ID. Beispiel: ",
// "Valid topic IDs" => "Valid topic IDs",
"Type Filter" => "Typfilter",
"Filter the list of articles by types. Example: " => "Filtere die Liste der Artikel nach den Typen. Beispiel: ",
// "Valid article types" => "Valid article types",
"Category ID" => "Kategorie-ID",
// "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted" => "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted",
"List only articles in this language" => "Liste nur Artikel in dieser Sprache",
// "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items" => "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items",
// "random or column names to add _asc _desc to: " => "random or column names to add _asc _desc to: ",
"Specific order" => "Bestimmte Reihenfolge",
"List of ArticleId that must appear in this order if present" => "Liste von Artikel-IDs, die in dieser Reihenfolge erscheinen müssen (wenn bestehend)",
"Only these articles" => "Nur diese Artikel",
// "List of article IDs to display, separated by \"%0\"" => "List of article IDs to display, separated by \"%0\"",
"Not these articles" => "Nicht diese Artikel",
// "List of article IDs to not display, separated by \"%0\"" => "List of article IDs to not display, separated by \"%0\"",
"Quiet" => "Still",
"Whether to not report when there are no articles (no reporting by default)" => "Ob berichtet werden soll, wenn keine Artikel vorhanden (standardmäßig wird nicht berichtet)",
"Title Only" => "Nur Titel",
"Whether to only show the title of the articles (not set to title only by default)" => "Ob nur Titel der Artikel angezeigt werden sollen (standardmäßig werden nicht nur Titel angezeigt)",
// "Show Article Body" => "Show Article Body",
// "Whether to show the body of the articles instead of the heading (not set by default)" => "Whether to show the body of the articles instead of the heading (not set by default)",
"Starting Article" => "Startartikel",
// "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)" => "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)",
"This will not work if Pagination is used" => "Dies funktioniert nicht, wenn Paginierung benutzt wird",
"Start Date" => "Startdatum",
"Earliest date to select articles from" => "Frühestes Datum, von dem ab Artikel ausgewählt werden sollen",
// " (%0YYYY-MM-DD%1)" => " (%0YYYY-MM-DD%1)",
"End date" => "Enddatum",
"Latest date to select articles from" => "Spätestes Datum, von dem ab Artikel ausgewählt werden sollen",
"Period quantity" => "Periodenanzahl",
// "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored" => "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored",
"Period unit" => "Periodeneinheit",
"Time unit used with \"Period quantity\"" => "Zeiteinheit, die mit \"Periodenanzahl\" benutzt wird",
"Override Dates" => "Überschreibt Daten",
// "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)" => "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)",
"Containing class" => "Containerklasse",
// "CSS class to add to the containing \"div.article\" (default: \"%0\")" => "CSS class to add to the containing \"div.article\" (default: \"%0\")",
// "Valid CSS class" => "Valid CSS class",
"Large First Image" => "Großes erstes Bild",
// "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article" => "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article",
"Additional URL parameter for the link to read the article" => "Zusätzliche URL Parameter für den Artikellink",
"Show actions (buttons and links)" => "Zeige Aktionen (Schaltflächen und Links)",
// "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do",
"No translation" => "Keine Übersetzung",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language",
// "Use Source URL" => "Use Source URL",
// "Use the external source URL as link for articles" => "Use the external source URL as link for articles",
// "Display an attachment or a list of them" => "Display an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment",
"File" => "Datei",
"Same as name" => "Gleich wie Name",
// "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page",
"Show Description" => "Zeige Beschreibung",
"Shows the description as the link text instead of the file name (not used by default)" => "Zeigt die Beschreibung als Linktext anstelle des Dateinamens (nicht standardmäßig genutzt)",
"Bullets" => "Aufzählungszeichen",
"Makes the list of attachments a bulleted list (not set by default)" => "Die Liste von Anhängen wird als Liste mit Aufzählungszeichnen erstellt (nicht standardmäßig eingestellt)",
// "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)",
"Custom Label" => "Benutzerdefinierte Bezeichnung",
// "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed" => "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)",
"Order Number" => "Sortiernummer",
// "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment",
// "Attachment name, file, id or num" => "Attachment name, file, id or num",
// "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)",
"File Type Icon" => "Dateityp-Symbol",
// "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)" => "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)",
"Page \"%0\" does not exist" => "Seite \"%0\" nicht vorhanden",
"No such attachment on this page" => "Kein solcher Anhang auf dieser Seite",
"Attributes" => "Attribute",
"Assign generic attributes to the current object" => "Weise einem Objekt generelle Attribute zu",
// "Add popups and color coding that identifies authors" => "Add popups and color coding that identifies authors",
"Username of the author of the text" => "Name des Benutzers, der den Text geschrieben hat",
"Deleted by User" => "Gelöscht von Benutzer",
"Username of the person who deleted the text" => "Name des Benutzers, der den Text gelöscht hat",
"Make Visible" => "Sichbar machen",
"Show popup with author/deleted by" => "Zeige Popup mit Autor/gelöscht von",
"Generate a popup with names of author(s) (default: no)" => "Erstellt ein Popup mit Namen der/des Autors/Autoren (Standard: nein)",
"deleted by" => "gelöscht von",
"Should this author's contribution be visible (default: no)" => "Sollen die Beiträge dieses Autors sichtbar sein (Standard: nein)",
// "Auto Query Args" => "Auto Query Args",
// "Automatically propagate arguments when clicking on links" => "Automatically propagate arguments when clicking on links",
// "Arguments for auto query" => "Arguments for auto query",
// "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin" => "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin",
"Profile picture" => "Profile picture",
"Display a user's profile picture" => "Zeige den Benutzeravatar",
// "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page" => "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page",
"Float" => "Textumfluss",
"Align the profile picture on the page" => "Avatar auf der Seite ausrichten",
// "Full Size" => "Full Size",
// "If full-size images are stored in the file gallery, show the full-size image" => "If full-size images are stored in the file gallery, show the full-size image",
"Back" => "Zurück",
// "Display a link that goes back one page in the browser history" => "Display a link that goes back one page in the browser history",
// "List all pages that link to a particular page" => "List all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "Die Seite, auf die Links zeigen. Standardwert ist die gegenwärtige Seite",
"Displayed Information" => "Angezeigte Information",
"Pipe separated list of fields to display. ex: hits|user" => "Durch Senkrechtstriche getrennt Felderliste, die angezeigt wird. Beispiel: Treffer|Benutzter",
"Excluded pages" => "Ausgeschlossene Seiten",
// "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1" => "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1",
"Include Self" => "Selbst eingeschlossen",
"With or without self-link (default is without)" => "Mit oder ohne Link auf sich selbst (standardmäßig ohne)",
"With or without header (default is with header)" => "Mit oder ohne Kopf (standardmäßig mit Kopf)",
"With header" => "Mit Kopf",
"Without header" => "Ohne Kopf",
"No pages link to" => "Keine Seiten linken auf",
"One page links to" => "Ein Seitenverweis auf",
"pages link to" => "Seitenverweise auf",
"Add a banner" => "Ein Banner einfügen",
"Zone" => "Bereich",
"Name of the zone created in Admin > Banners" => "Name der unter Verwalten > Banner erstellten Zone",
"Determines the browser behavior when the banner is clicked" => "Legt das Browserverhalten fest, wenn ein Banner angeklickt wird",
"missing parameter" => "fehlender Parameter",
// "Benchmark" => "Benchmark",
// "Performance-test wiki content (used by developers to optimize plugins)" => "Performance-test wiki content (used by developers to optimize plugins)",
// "Iteration Quantity" => "Iteration Quantity",
// "The number of iterations to process" => "The number of iterations to process",
// "Each Iteration Details" => "Each Iteration Details",
// "Provides time and memory of each iteration" => "Provides time and memory of each iteration",
"BigBlueButton" => "BigBlueButton",
// "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system" => "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system",
"Meeting" => "Meeting",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1",
// "Anonymous Prefix" => "Anonymous Prefix",
"Unregistered users will get this token prepended to their name" => "Unregistrierte Benutzer erhalten dieses Token vor ihren Namen vorangestellt",
"Welcome Message" => "Willkommensnachricht",
"A message to be provided when someone enters the room" => "Die anzuzeigende Nachricht, wenn jemand den Raum betritt",
"Dial Number" => "Nummer wählen",
"The phone-in support number to join from traditional phones" => "Die Supportnummer, um von traditionellen Telefonen hinein anzurufen",
"Voice Bridge" => "Sprachbrücke",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID",
"Log-out URL" => "Log-out URL",
"URL to which the user will be redirected after logging out of BigBlueButton" => "URL auf die ein Benutzer weitergeleitet wird, wenn es sich von BigBlueButton abmeldet",
"Record" => "Aufzeichnen",
// "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8" => "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8",
// "Display Recordings" => "Display Recordings",
// "Enable or Disable the display of video recordings" => "Enable or Disable the display of video recordings",
// "Display Attendees" => "Display Attendees",
// "Enable or Disable the display of attendees list" => "Enable or Disable the display of attendees list",
"BigBlueButton is misconfigured or inaccessible" => "BigBlueButton ist falsch konfiguriert oder nicht erreichbar",
"Blog List" => "Blogliste",
"Display posts from a site blog" => "Zeigt Posts von einem Blog der Site",
"Blog ID" => "Blog ID",
// "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown" => "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown",
"Maximum Items" => "Maximale Einträge",
"Maximum number of entries to list (no maximum set by default)" => "Maximale Anzahl von Einträgen für die Liste (standardmäßig wird kein Maximum vorgegeben)",
"Only display posts created by this user (all posts listed by default)" => "Liste nur Beiträge von diesem Benutzer auf (standardmäßig werden alle Beiträge aufgelistet)",
"Simple List" => "Einfache Liste",
// "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts" => "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts",
"Character Count" => "Zeichenzähler",
// "Number of characters to display if not a simple list (defaults to all)" => "Number of characters to display if not a simple list (defaults to all)",
// "Word Boundary" => "Word Boundary",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only",
// "Ellipsis" => "Ellipsis",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)",
"More" => "Mehr",
// "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)",
// "Show Icons" => "Show Icons",
// "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)" => "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)",
// "Use Excerpt" => "Use Excerpt",
// "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)" => "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)",
"Earliest date to select posts from" => "Frühestes Datum, von dem Einträge ausgewählt werden",
"End Date" => "Enddatum",
"Latest date to select posts from" => "Spätestes Datum vom dem an Einträge ausgewählt werden",
"Container Class" => "Containerklasse",
// "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)" => "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)",
// "Missing blog ID for Bloglist plugin" => "Missing blog ID for Bloglist plugin",
// "Create a formatted box with a title bar" => "Create a formatted box with a title bar",
// "Box Title" => "Box Title",
"Displayed above the content" => "Über dem Inhalt anzuzeigen",
"As defined by CSS, name, or color hex code" => "Wie durch das CSS festgelegt, Name oder Hex-Code",
// "Valid CSS color name or code" => "Valid CSS color name or code",
// "Box Width" => "Box Width",
"Text Alignment" => "Textausrichtung",
"Aligns the text within the box (left-aligned by default)" => "Richtet den Text innerhalb der Box aus (standardmäßig linksbündig)",
"Float Position" => "Textumfluss",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)",
"Clear" => "Zurücksetzen",
// "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)" => "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)",
"Apply custom CSS class to the box" => "Wende benutzerdefinierte CSS-Klasse auf die Box an",
"CSS Style" => "CSS-Stil",
// "Enter CSS styling tags for the div type used e.g. padding: 5px" => "Enter CSS styling tags for the div type used e.g. padding: 5px",
"Button" => "Schaltfläche",
"Add a link formatted as a button" => "Fügt einen als Schaltfläche formatierten Link ein",
// "Label for the button (ignored if the text is defined)" => "Label for the button (ignored if the text is defined)",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it" => "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it",
"Label for the button" => "Bezeichnung für die Schaltfläche",
// "Icon Name" => "Icon Name",
// "Enter an iconset name to show an icon in the button" => "Enter an iconset name to show an icon in the button",
// "Button Type" => "Button Type",
// "Use a type to style the button. By default btn-primary will be applied" => "Use a type to style the button. By default btn-primary will be applied",
// "Danger" => "Danger",
// "Primary" => "Primary",
// "Button width" => "Button width",
// "In pixels or percentage. (e.g. 200px or 100%)" => "In pixels or percentage. (e.g. 200px or 100%)",
// "Button height" => "Button height",
// "CSS class for the button. Note that the btn class is always applied by default" => "CSS class for the button. Note that the btn class is always applied by default",
// "CSS style attributes" => "CSS style attributes",
// "Link Relation" => "Link Relation",
// "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation" => "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation",
// "Auto Arguments" => "Auto Arguments",
// "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter" => "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter",
// "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL" => "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL",
// "Flip Id" => "Flip Id",
// "HTML id attribute of the element to show/hide content" => "HTML id attribute of the element to show/hide content",
// "Flip Hide Text" => "Flip Hide Text",
// "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown" => "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown",
// "Flip Default Open" => "Flip Default Open",
// "If set to %0, the flip is open by default (if no cookie jar)" => "If set to %0, the flip is open by default (if no cookie jar)",
// "Escape Apostrophes" => "Escape Apostrophes",
// "If set to %0, will escape the apostrophes in onclick" => "If set to %0, will escape the apostrophes in onclick",
// "Disable Button" => "Disable Button",
// "Set to %0 to disable the button" => "Set to %0 to disable the button",
"lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php fehlt oder ist nicht lesbar",
"Display a calendar and its events" => "Zeigt einen Kalender und seine Ereignisse",
"Calendar IDs" => "Kalender-IDs",
// "Comma-separated list of calendar Ids to restrict the events to specified calendars" => "Comma-separated list of calendar Ids to restrict the events to specified calendars",
"Example values:" => "Beispielwerte:",
"Not set by default." => "Standardmäßig nicht eingetragen.",
"View Type" => "Ansichtstyp",
// "Determines how events" => "Determines how events",
// "%0 (default) shows events in a calendar" => "%0 (default) shows events in a calendar",
"View Time Span" => "Zeitspanne",
// "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar" => "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar",
"Default is month" => "Standard ist Monat",
"Navigation Bar" => "Navigationsbalken",
// "Show or hide the navigation bar (not shown by default)" => "Show or hide the navigation bar (not shown by default)",
"Carousel" => "Karussell",
"Display images in a self-advancing carousel" => "Zeigt Bilder in einem selbständig drehenden Karussell",
// "Images Source" => "Images Source",
// "Choose where to get your images from" => "Choose where to get your images from",
"Select an option" => "Wähle eine Option",
"All the images in a file gallery" => "Alle Bilder in einer Datei-Galerie",
// "A list of file IDs" => "A list of file IDs",
"File Gallery ID" => "Dateiarchiv-ID",
"ID number of the file gallery that contains the images to be displayed" => "ID-Nummer des Dateiarchivs, welches die anzuzeigenden Bilder enthält",
// "File IDs" => "File IDs",
// "List of IDs of images from the File Galleries separated by commas" => "List of IDs of images from the File Galleries separated by commas",
"Sort Mode" => "Sortierreihenfolge",
// "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2" => "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2",
// "Transition Time" => "Transition Time",
"The time (in milliseconds) for the transition between two images" => "Die Zeit (in Millisekunden), die für den Übergang zwischen zwei Bildern benötigt wird",
"number" => "Nummer",
// "Display Time" => "Display Time",
"The time (in milliseconds) to display each image" => "Die Zeit (in Millisekunden), die ein Bild angezeigt wird",
// "Caption Height" => "Caption Height",
"The height of the caption. This is a fraction of the height of the images" => "Die Höhe der Überschrift. Dies ist ein Bruchteil der Höhe des Bildes",
"real between 0 and 1" => "Reelle Zahl zwischen 0 und 1",
// "Display Progress Bar" => "Display Progress Bar",
// "Display Thumbnails" => "Display Thumbnails",
"Display thumbnails, number, count etc" => "Zeige Vorschaubilder, Zahl, Zähler, etc",
"Buttons" => "Schaltflächen",
"Numbers" => "Zahlen",
// "Thumbnail Box Width" => "Thumbnail Box Width",
// "Width of thumbnail box in CSS units (default %0)" => "Width of thumbnail box in CSS units (default %0)",
// "Thumbnail Box Height" => "Thumbnail Box Height",
// "Height of thumbnail box in CSS units (default %0)" => "Height of thumbnail box in CSS units (default %0)",
// "Start Automatically" => "Start Automatically",
"Start the carousel automatically when the page loads (default: Yes)" => "Bewege das Karussel automatisch, wenn die Seite lädt (Standardmäßig aktiviert)",
"Legacy v2 param" => "Altdaten v2 Parameter",
"Display thumbnails" => "Zeige Vorschaubilder",
// "Thumbnail Numbers" => "Thumbnail Numbers",
"Display place numbers in the thumbnail boxes" => "Zeige Stellennummer in der Vorschaubild-Boxen",
// "Thumbnail Background" => "Thumbnail Background",
"Use corresponding image as background for a thumbnail box" => "Benutze korrespondierende Bild als Hintergrund für die Vorschaubild-Box",
// "Thumbnail Font Size" => "Thumbnail Font Size",
// "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)" => "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)",
// "CSS units" => "CSS units",
// "Image Size" => "Image Size",
// "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels" => "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels",
// "Real between 0 and 1, or integer over 10" => "Real between 0 and 1, or integer over 10",
// "Makes images clickable" => "Makes images clickable",
// "In case there are URLs in the image description, the image is made clickable and links to the first URL found" => "In case there are URLs in the image description, the image is made clickable and links to the first URL found",
"Cart Missing User Info" => "Fehlende Benutzerinformationen Warenkorb",
"PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check completeness of user input for a shopping cart transaction" => "Check completeness of user input for a shopping cart transaction",
// "Information Type" => "Information Type",
"Post Purchase" => "Nach Kauf",
"Required before purchase" => "Erforderlich vor Kauf",
"Product Class ID" => "Produktklassen-ID",
// "CasperJS" => "CasperJS",
// "Enable running CasperJS scripts from this Tiki site" => "Enable running CasperJS scripts from this Tiki site",
// "CasperJS not available" => "CasperJS not available",
// "Execute CasperJS script" => "Execute CasperJS script",
"List categories and objects assigned to them" => "Listet Kategorien und zu diesen zugewiesene Objekte auf",
"Category IDs" => "Kategorie-IDs",
// "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page" => "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page",
"Types" => "Typen",
// "List of object types to include in the list, separated by \"+\", for example, " => "List of object types to include in the list, separated by \"+\", for example, ",
// "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)" => "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)",
"Hits Ascending" => "Treffer aufsteigend",
"Hits Descending" => "Treffer absteigend",
"Item ID Ascending" => "Eintrags-ID aufsteigend",
"Item ID Descending" => "Eintrags-ID absteigend",
"Type Ascending" => "Typ aufsteigend",
"Type Descending" => "Typ absteigend",
"Random" => "zufällig",
"Split" => "Aufteilen",
"Whether multiple categories will be listed on different lines (default is to split them)" => "Ob multiple Kategorien in verschiedenen Zeilen aufgelistet werden (standardmäßig werden sie getrennt)",
"And" => "Und",
// "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)" => "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)",
// "Sub-categories" => "Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)",
"Show descriptions (not shown by default)" => "Zeige Beschreibungen (werden standardmäßig nicht angezeigt)",
"Show object names (shown by default)" => "Zeige Objektnamen (werden standardmäßig angezeigt)",
"Show type (shown by default)" => "Zeige Typ (wird standardmäßig angezeigt)",
"One Per Line" => "Einer pro Zeile",
"Show one object per line (multiple per line shown by default)" => "Zeige ein Objekt pro Zeile (standardmäßig werden mehrere pro Zeile angezeigt)",
// "Child Links" => "Child Links",
"Show children category links (shown by default)" => "Zeige Links zu Kinderkategorien (werden standardmäßig angezeigt)",
// "Top Link" => "Top Link",
"Show top category link (shown by default)" => "Zeige Link zur Hauptkategorie (wird standardmäßig angezeigt)",
"Maximum Records" => "Maximale Einträge",
// "Maximum number of objects to list (default is %0)" => "Maximum number of objects to list (default is %0)",
"Show title text above category object lists (shown by default)" => "Zeige Titeltext über der Kategorieobjektliste (wird standardmäßig angezeigt)",
"List only objects in this language" => "Liste nur Objekte in dieser Sprache auf",
// "Only apply if %0" => "Only apply if %0",
"Categories are disabled" => "Kategorien sind nicht aktiviert",
"PluginCategoryTransition" => "PluginCategoryTransition",
"Display controls to trigger category transitions for any object" => "Zeigt Steuerelemente um Kategorieüberleitungen für ein Objekt auszulösen",
"Redirect URL" => "Weiterleitungs-URL",
"URL the user is sent to after transition is done" => "URL, an die ein Benutzer weitergeleitet wird, nachdem die Überleitung erledigt ist",
"Category Orphans" => "Kategoriewaisen",
"List objects that are not categorized" => "Listet Objekte auf, die nicht kategorisiert sind",
// "Determine which type of objects are shown (default is %0)" => "Determine which type of objects are shown (default is %0)",
"Calendars" => "Kalender",
// "Max" => "Max",
// "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records" => "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records",
"Result Offset" => "Ergebnisversatz",
"Result number at which the listing should start (default is no offset)" => "Zahl, bei der die Auflistung der Ergebnisse beginnen soll (standardmäßig ohne Versatz)",
"Category Path" => "Kategoriepfad",
"Show the full category path for a wiki page" => "Zeigt den vollen Kategoriepfad einer Wiki Seite",
"Separator" => "Trennzeichen",
// "String used to separate the categories in the path. Default character is %0" => "String used to separate the categories in the path. Default character is %0",
"Display Top Category" => "Zeige Hauptkategorie",
"Show the top category as part of the path name (not shown by default)" => "Zeige Hauptkategorie als Teile des Kategoriepfades (wird standardmäßig nicht angezeigt)",
// "Access and use a cclite social credit and alternative currency account" => "Access and use a cclite social credit and alternative currency account",
// "Mode of operation - summary or recent. Default: %0" => "Mode of operation - summary or recent. Default: %0",
"Account summary" => "Kontozusammenfassung",
"Recent transactions" => "Kürzliche Transaktionen",
"Registry" => "Registrierung",
"Registry to query. Default: site preference (or first in list when more than one)" => "Abzufragende Registrierung. Standard: Site-Einstellung (oder erste in Liste, wenn mehr als eine)",
"You need to be logged in to view this information" => "Du musst angemeldet sein, um diese Informationen zu sehen",
"Center text" => "Text zentrieren",
"Chart" => "Diagramm",
"Display a chart from TikiSheet." => "Zeige ein Diagramm von einer Tiki Tabelle",
"Chart caption" => "Diagrammbeschriftung",
"Spreadsheet ID" => "Tabellen-ID",
"Data sheet ID" => "Datentabellen-ID",
"Chart Type" => "Diagrammtyp",
// "Specify a valid chart type" => "Specify a valid chart type",
"Chart Width" => "Diagrammbreite",
"Width in pixels" => "Breite in Pixel",
"Chart Height" => "Diagrammhöhe",
"Height in pixels" => "Höhe in Pixel",
"Value series" => "Datenreihe",
"Required for pie charts" => "Erforderlich für Tortendiagramm",
// "Independent series" => "Independent series",
"Required for types other than pie chart" => "Erforderlich für andere Typen als Tortendiagramm",
// "Dependent series" => "Dependent series",
"Description needed" => "Beschreibung erforderlich",
"Colors" => "Farben",
"List of colors to use" => "Liste zu benutzender Farben",
"Styles" => "Stile",
"List of styles to use" => "Liste zu benutzender Stile",
"Labels for the series or values in the legend" => "Bezeichnung für die Datenreihen oder Werten in der Legende",
"Chart as PDF" => "Diagramm als PDF",
"Chart as PostScript" => "Diagramm als PostScript",
// "Chart JS" => "Chart JS",
// "Create a JS Chart" => "Create a JS Chart",
// "JSON encoded array for data and options" => "JSON encoded array for data and options",
// "Chart Id" => "Chart Id",
// "A custom ID for the chart" => "A custom ID for the chart",
// "The type of chart. Currently works with pie, bar and doughnut" => "The type of chart. Currently works with pie, bar and doughnut",
// "The height of the chart in px" => "The height of the chart in px",
// "The width of the chart in px" => "The width of the chart in px",
// "Chart data values" => "Chart data values",
// "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)" => "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)",
// "Chart data labels" => "Chart data labels",
// "Colon-separated labels for the datasets in the chart. Max 10, if left empty" => "Colon-separated labels for the datasets in the chart. Max 10, if left empty",
// "Chart colors" => "Chart colors",
// "Colon-separated colors for the datasets in the chart. Max 10, if left empty" => "Colon-separated colors for the datasets in the chart. Max 10, if left empty",
// "Chart highlight" => "Chart highlight",
// "Colon-separated color of chart section when highlighted" => "Colon-separated color of chart section when highlighted",
// "Uses the non-minified version of the chart.js library for easier debugging" => "Uses the non-minified version of the chart.js library for easier debugging",
// "Values must be set for chart" => "Values must be set for chart",
// "Check Referer" => "Check Referer",
// "Display content based on the address that originated the request for the current page" => "Display content based on the address that originated the request for the current page",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met",
// "Referer List" => "Referer List",
// "Comma-separated list of domains to check" => "Comma-separated list of domains to check",
// "Display code with syntax highlighting and line numbering" => "Display code with syntax highlighting and line numbering",
"Code to be displayed" => "Anzuzeigender Code",
"Caption" => "Beschriftung",
"Code snippet label" => "Code-Schnippsel Bezeichnung",
"Line Wrapping" => "Wortumbruch",
// "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends" => "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends",
// "Any supported language listed at http://codemirror.net/mode/" => "Any supported language listed at http://codemirror.net/mode/",
"Line Numbers" => "Zeilennummern",
// "Show line numbers for each line of code" => "Show line numbers for each line of code",
"Right to Left" => "Rechts nach links",
"Switch the text display from left to right, to right to left (left to right by default)" => "Schalte die Textanzeige von links-nach-rechts-Schrift auf rechts-nach-links um (Standard: links-nach-rechts)",
"Code Tag" => "Code-TAG",
"Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Bindet den Code in einen HTML-Code-Tag ein, z.B.: &lt;code&gt;Benutzereingabe&lt;code&gt",
// "Any supported theme listed at https://codemirror.net/demo/theme.html" => "Any supported theme listed at https://codemirror.net/demo/theme.html",
"Colorbox" => "Colorbox",
"Display a gallery of images in a popup slideshow" => "Zeigt eine Galerie von Bildern in einer Popup-Diashow",
"Image Gallery ID" => "Bildergalerie-ID",
"ID number of the image gallery that contains the images to be displayed" => "ID-Nummer der Bildergalerie, welche die anzuzeigenden Bilder enthält",
"File ID Filter" => "Datei-ID Filter",
// "Colon-separated list of fileIds in a file gallery to show" => "Colon-separated list of fileIds in a file gallery to show",
"Thumb" => "Vorschau",
// "Display as a thumbnail or full size" => "Display as a thumbnail or full size",
"Show File Title" => "Zeige Dateititel",
"Show file title" => "Zeige Dateititel",
"Show File Name" => "Zeige Dateinamen",
"Show file name" => "Zeige Dateinamen",
"Show All Thumbs" => "Zeige alle Vorschaubilder",
"Show thumbnails of all the images in the gallery" => "Zeige Vorschaubilder von allen Bildern in der Galerie",
"Parse Descriptions" => "Parse Beschreibungen",
"Parse the file descriptions as wiki syntax" => "Wiki parst die Dateibeschreibungen",
"This feature is disabled" => "Diese Funktion ist deaktiviert",
// "Display a comment area for a specified object" => "Display a comment area for a specified object",
// "Object type the comment is associated with" => "Object type the comment is associated with",
"Tracker Item" => "Trackereintrag",
// "Submission" => "Submission",
// "Blog Post" => "Blog Post",
"The current wiki page to which you have added the plugin" => "Die gegenwärtige Wiki Seite, zu der Du das Plugin hinzugefügt hast",
"Dynamic Content" => "Dynamischer Inhalt",
"Display content from dynamic content repository" => "Zeigt Inhalte vom Speicher der dynamischen Inhalte",
"Content ID" => "Inhalts-ID",
"Dynamic content ID. The value can be obtained in the listing" => "ID des dynamischen Inhalts. Dieser Werte kann in der Liste erhalten werden",
"Content Label" => "Inhaltsbezeichnung",
"Label of the dynamic content to display" => "Bezeichnung des anzuzeigenden dynamischen Inhalts",
"Contributions Dashboard" => "Anzeige der Beitragenden",
// "List users' contributions to a page" => "List users' contributions to a page",
"Notice" => "Nachricht",
"Default Beginning Date" => "Standard Startdatum",
"Default Ending Date" => "Standard Enddatum",
"Dashboard Types" => "Anzeigetypen",
// "The types of charts that will be rendered, separated by commas" => "The types of charts that will be rendered, separated by commas",
"Update" => "Aktualisieren",
"Convene" => "Einladung",
// "Suggest meeting dates and times and vote to select one" => "Suggest meeting dates and times and vote to select one",
"Convene data generated from user input" => "Aus Benutzereingaben generierte Einladungsdaten",
// "Title for the event" => "Title for the event",
"Calendar ID" => "Kalender-ID",
"ID number of the site calendar in which to store the date for the events with the most votes" => "ID-Nummer des Site-Kalenders, worin die Daten für die Ereignisse mit den meisten Stimmen gespeichert werden",
// "Minimum Votes" => "Minimum Votes",
// "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it" => "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it",
// "Date-Time Format" => "Date-Time Format",
"Display date and time in short or long format, according to the site wide setting" => "Zeige Datum und Zeit entsprechend der site-weiten Einstellungen in einem Kurz- oder einem Langformat",
"Short" => "Kurz",
"Long" => "Lang",
// "Observe Admin Permissions" => "Observe Admin Permissions",
// "Show user profile pictures" => "Show user profile pictures",
"Delete Date" => "Lösche Datum",
// "UTC date time: %0" => "UTC date time: %0",
"Add Date" => "Datum hinzufügen",
// "Not OK" => "Not OK",
"Unconfirmed" => "Unbestätigt",
"Add User" => "Benutzer hinzufügen",
"Not ok" => "Nicht OK",
"Ok" => "Ok",
// "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users" => "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users",
// "Show user's profile pictures next to their names" => "Show user's profile pictures next to their names",
"Edit User/Save changes" => "Bearbeite Benutzer/Speichere Änderungen",
"Delete User" => "Lösche Benutzer",
// "Username.." => "Username..",
"Selected Date" => "Wähle Datum",
"Add as Calendar Event" => "Füge als Kalenderereignis hinzu",
// "This page is being edited by another user. Please reload the page and try again later" => "This page is being edited by another user. Please reload the page and try again later",
// "Delete this date" => "Delete this date",
// "Are you sure you want to remove this user's votes" => "Are you sure you want to remove this user's votes",
// "There is no undo" => "There is no undo",
"Cookie" => "Glückskeks",
// "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)" => "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)",
// "Display content based on whether cookie consent has been granted by the user" => "Display content based on whether cookie consent has been granted by the user",
"Wiki syntax containing the content that can be hidden or shown" => "Wiki Syntax, der den Inhalt enthält, der angezeigt oder versteckt werden kann",
// "No Cookie Message" => "No Cookie Message",
// "Message displayed if user has not consented to accepting cookies" => "Message displayed if user has not consented to accepting cookies",
// "Containing Element" => "Containing Element",
// "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container" => "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container",
// "Element CSS Class" => "Element CSS Class",
// "CSS class for above" => "CSS class for above",
// "No Consent CSS Class" => "No Consent CSS Class",
// "CSS class for no consent message. Default: %0" => "CSS class for no consent message. Default: %0",
"Insert copyright notices" => "Fügt Copyright-Notizen ein.",
// "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1" => "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1",
"Countdown" => "Countdown",
// "Display the time until or after a date and time" => "Display the time until or after a date and time",
"Text to append to the countdown" => "Text, der an den Countdown angehängt wird",
"Target date and time. Multiple formats accepted" => "Zieldatum und-zeit. Verschiedene Formate werden akzeptiert",
"Items to Show" => "Anzuzeigende Einträge",
// "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
"Years" => "Jahre",
"Years, Months" => "Jahre, Monate",
"Years, Months, Days" => "Jahre, Monate, Tage",
"Years, Months, Days, Hours" => "Jahre, Monate, Tage, Stunden",
"Years, Months, Days, Hours, Minutes" => "Jahre, Monate, Tage, Stunden, Minuten",
"Years, Months, Days, Hours, Minutes & Seconds" => "Jahre, Monate, Tage, Stunden, Minuten & Sekunden",
"Months" => "Monate",
"Months, Days" => "Monate, Tage",
"Months, Days, Hours" => "Monate, Tage, Stunden",
"Months, Days, Hours, Minutes" => "Monate, Tage, Stunden, Minuten",
"Months, Days, Hours, Minutes & Seconds" => "Monate, Tage, Stunden, Minuten & Sekunden",
"Days" => "Tage",
"Days & Hours" => "Tage & Stunden",
"Days, Hours & Minutes" => "Tage, Stunden & Minuten",
"Days, Hours, Minutes & Seconds" => "Tage, Stunden, Minuten & Sekunden",
"Hours" => "Stunden",
"Hours & Minutes" => "Stunden & Minuten",
"Hours, Minutes & Seconds" => "Stunden, Minuten & Sekunden",
"Minutes" => "Minuten",
"Minutes & Seconds" => "Minuten & Sekunden",
"Seconds" => "Sekunden",
"Calendar Days" => "Kalendertage",
// "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default" => "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default",
"Handle Past Events" => "Behandlung vergangener Ereignisse",
// "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text" => "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text",
"Text" => "Text",
// "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text" => "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text",
"default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
"Thousands separator" => "Tausendertrennzeichen",
// "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator",
"Comma" => "Komma",
"Period" => "Punkt",
"Space" => "Leerzeichen",
"Countdown: Missing \"enddate\" parameter for plugin" => "COUNTDOWN: \"enddate\"-Parameter (Enddatum) wurde im Plugin nicht angegeben",
"will happen in less than a year" => "wird in weniger als einem Jahr passieren",
"will happen in less than a month" => "wird in weniger als einem Monat passieren",
"will happen in less than a day" => "wird in weniger als einem Tag passieren",
// "will happen in less than an hour" => "will happen in less than an hour",
"will happen in less than a minute" => "wird in weniger als einer Minute passieren",
"is happening this second" => "passiert in dieser Sekunde",
"happened in the last year" => "hat im letzten Jahr stattgefunden",
"happened in the last month" => "hat im letzten Monat stattgefunden",
"happened in the last day" => "hat gestern stattgefunden",
"happened in the last hour" => "hat vorherige Stunde stattgefunden",
"happened in the last minute" => "hat vor einer Minute stattgefunden",
"until" => "bis",
"since" => "seit",
"is over" => "ist vorbei",
"Custom Search" => "Benutzerdefinierte Suche",
// "Create a custom search form for searching or listing items on the site" => "Create a custom search form for searching or listing items on the site",
"LIST plugin configuration information" => "LIST-Plugin Konfigurationsinformationen",
"Template wiki page" => "Wiki Seitenvorlage",
"Wiki page where search user interface template is found" => "Wiki Seite, welche die Vorlage mit der Suchoberfläche enthält",
// "Template file" => "Template file",
// "Smarty template (.tpl) file where search user interface template is found" => "Smarty template (.tpl) file where search user interface template is found",
// "Search Id" => "Search Id",
// "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users",
// "Search Delay" => "Search Delay",
// "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)" => "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)",
// "Fade DIV Id" => "Fade DIV Id",
// "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner",
// "Recall Last Search" => "Recall Last Search",
// "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving" => "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving",
// "Custom JavaScript Page" => "Custom JavaScript Page",
"The wiki page on which custom JavaScript is to be executed on return of Ajax results" => "Die Wiki Seite mit auszuführendem, benutzerdefinierten JavaScript nachdem die AJAX Ergebnisse zurückgegeben wurden",
"Destination Div" => "Ziel-Div",
"The id of an existing div to contain the search results" => "ID zu einem bereits vorhandenen DIV, welches die Suchergebnisse beinhalten wird",
"Search On Load" => "Suche beim Laden",
"Execute the search when the page loads (default: Yes)" => "Führe die Suche beim Laden der Seite aus (Standard: ja)",
// "Require Input" => "Require Input",
// "Require first input field to be filled for search to trigger" => "Require first input field to be filled for search to trigger",
// "Force Sort" => "Force Sort",
// "Force the use of specified sort mode in place of search relevance even when there is a text search query" => "Force the use of specified sort mode in place of search relevance even when there is a text search query",
// "Trim Linefeeds" => "Trim Linefeeds",
// "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs" => "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs",
// "Searchable Only Results" => "Searchable Only Results",
// "Only include results marked as searchable in the index" => "Only include results marked as searchable in the index",
// "Use custom search JavaScript file" => "Use custom search JavaScript file",
// "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size" => "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size",
// "JavaScript disabled" => "JavaScript disabled",
// "JavaScript is required for this search feature" => "JavaScript is required for this search feature",
"Template is not specified" => "Vorlage ist nicht angegeben",
"Template page not found" => "Vorlagenseite wurde nicht gefunden",
// "Please enter a search query" => "Please enter a search query",
// "_from parameter not valid: \"%0\"" => "_from parameter not valid: \"%0\"",
// "_to parameter not valid: \"%0\"" => "_to parameter not valid: \"%0\"",
// "_gap parameter not valid: \"%0\"" => "_gap parameter not valid: \"%0\"",
"_group is needed to be set if _style is checkbox or radio" => "_group muss angegeben werden, wenn _style ein Kontrollkästchen oder eine Optionsschaltfläche ist",
// "Cypht webmail" => "Cypht webmail",
// "Embed Cypht webmail and news reader" => "Embed Cypht webmail and news reader",
// "Mailbox name" => "Mailbox name",
"IMAP server" => "IMAP Server",
// "IMAP port" => "IMAP port",
// "IMAP use TLS" => "IMAP use TLS",
// "Use secure connection to IMAP server" => "Use secure connection to IMAP server",
// "IMAP username" => "IMAP username",
// "Account mailbox username" => "Account mailbox username",
// "IMAP password" => "IMAP password",
// "Account mailbox password" => "Account mailbox password",
// "SMTP connection name" => "SMTP connection name",
// "SMTP port" => "SMTP port",
// "SMTP use TLS" => "SMTP use TLS",
// "Use secure TLS/SSL connection to SMTP server" => "Use secure TLS/SSL connection to SMTP server",
// "SMTP no authentication" => "SMTP no authentication",
// "Disable SMTP authentication if your server does not support it" => "Disable SMTP authentication if your server does not support it",
// "Use global settings" => "Use global settings",
// "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages" => "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages",
// "Groupmail use" => "Groupmail use",
// "Share this mailbox for Groupmail usage or keep it private" => "Share this mailbox for Groupmail usage or keep it private",
"GroupMail: Group (e.g. \"Help Team\")" => "Gruppen-E-Mail: Gruppe (z.B. \"HilfeTeam\")",
"GroupMail: Tracker ID (to store GroupMail activity)" => "Gruppen-E-Mail: Tracker-ID (in dem die GruppenEmail-Aktivität gespeichert wird)",
"From Field ID" => "Von-Feld-ID",
"GroupMail: From Field (Id of field in tracker to store email From header)" => "Gruppen-E-Mail: Von-Feld (ID des Trackerfeldes in dem Email-von gespeichert wird)",
"Subject Field ID" => "Betreff Feld-ID",
"GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "Gruppen-E-Mail: Betreff-Feld (ID des Trackerfeldes in dem der Email-Betreff gespeichert wird)",
"Message Field ID" => "Nachricht Feld-ID",
"GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "Gruppen-E-Mail: Nachrichten-Feld (ID des Trackerfeldes in dem der Email-Nachrichtkennung (ID) gespeichert wird)",
"Content Field ID" => "Inhalt Feld-ID",
"GroupMail: Content Field (Id of field in tracker to store email message body content)" => "Gruppen-E-Mail: Inhalt-Feld (ID des Trackerfeldes in dem der Email-Text gespeichert wird)",
"Account Field ID" => "Konto Feld-ID",
"GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "Gruppen-E-Mail: Konto-Feld (ID des Trackerfeldes in dem der Webmail-Kontoname gespeichert wird)",
"DateTime Field Id" => "DatumZeit FeldID",
"GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "Gruppen-E-Mail: DatumZeit-Feld (ID des Trackerfeldes in dem der Zeitstempel gespeichert wird)",
"Operator Field ID" => "Operator Feld-ID",
"GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "Gruppen-E-Mail: Operator-Feld (ID des Trackerfeldes in dem der Operatorname (Benutzername) gespeichert wird)",
// "UI display presentational purposes only" => "UI display presentational purposes only",
// "E.g. imap.your-domain.com" => "E.g. imap.your-domain.com",
// "Default is 993" => "Default is 993",
// "E.g. smtp.your-domain.com" => "E.g. smtp.your-domain.com",
// "Default is 587" => "Default is 587",
// "Only one cypht plugin per page can be used" => "Only one cypht plugin per page can be used",
"Data Channel" => "Datenkanal",
// "Display a form to access data channels" => "Display a form to access data channels",
// "List of fields to display. One field per line. Comma delimited: %0" => "List of fields to display. One field per line. Comma delimited: %0",
// "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag" => "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag",
// "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel" => "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel",
// "To use fixed hidden preset\n\t\t\tvalues use %0" => "To use fixed hidden preset\n\t\t\tvalues use %0",
"Channel Name" => "Kanalname",
"Name of the channel as registered by the administrator" => "Name des Kanals, so wie vom Administrator registriert",
"Return URL" => "Rückgabe-URL",
// "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object" => "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object",
// "Return URL on error" => "Return URL on error",
// "URL to go to after data channel has run and failed. If not specified, use the success URL" => "URL to go to after data channel has run and failed. If not specified, use the success URL",
"Do not use returnURI but instead return true quietly" => "Benutze nicht returnURL sondern stille Rückgabe anstelle dessen",
// "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context" => "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context",
"Button Label" => "Schaltflächenbezeichnung",
"Label for the submit button. Default: \"Go\"" => "Bezeichnung für die Absendeschaltfläche. Standard: \"Go\"",
"CSS class for this form" => "CSS-Klasse für dieses Formular",
"Template" => "Vorlage",
// "Template to be used to render the form, instead of the default template" => "Template to be used to render the form, instead of the default template",
"Empty Caches" => "Caches leeren",
"Which caches to empty. Default \"Clear all Tiki caches\"" => "Welche Caches geleert werden sollen. Standard \"Alle Tiki Caches leeren\"",
"Clear all Tiki caches" => "Lösche alle Tiki Caches",
"All user prefs sessions" => "Alle Benutzer-Prefs-Sitzungen",
"Price to execute the data channel (%0)" => "Preis für die Ausführung des Datenkanals (%0)",
"Payment Label" => "Bezahlungsbezeichnung",
"Debug" => "Debug",
// "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)",
"Multiple Values" => "Multiple Werte",
// "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)",
"Data channel" => "Datenkanal",
"DB Report" => "DB Bericht",
// "Query an ADOdb database and display results (does not work with PDO)" => "Query an ADOdb database and display results (does not work with PDO)",
"report definition" => "Berichtsdefinition",
"Full DSN" => "Vollständiger DSN",
// "A full DSN (Data Source Name) connection string. Example: " => "A full DSN (Data Source Name) connection string. Example: ",
"Wiki DSN Name" => "Wiki DSN-Name",
"The name of a DSN connection defined by the Wiki administrator" => "Der Name einer DSN Verbindung, festgelegt durch den Wiki Administrator",
"Wiki Syntax" => "Wiki Syntax",
"Parse wiki syntax within the report (not parsed by default)" => "Parse Wiki Syntax innerhalb des Berichts (standardmäßig nicht geparst)",
"Display the parsed report definition (not displayed by default)" => "Zeige die geparste Berichtsdefinition (wird standardmäßig nicht angezeigt)",
"Missing db or dsn parameter" => "Fehlender DB oder DSN Parameter",
"AdoDb not found" => "AdoDb nicht gefunden",
"No DSN connection string found" => "Kein DSN Verbindungsstring gefunden",
"Run a database report" => "Starte einen Datenbankbericht",
// "Diagram" => "Diagram",
// "Display mxGraph/Draw.io diagrams" => "Display mxGraph/Draw.io diagrams",
// "fileId" => "fileId",
// "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options" => "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options",
"page" => "Seite",
// "Page of the diagram that should be displayed" => "Page of the diagram that should be displayed",
// "annotate" => "annotate",
// "Id of the file in the file gallery. A image file to include in the diagram" => "Id of the file in the file gallery. A image file to include in the diagram",
// "Image alignment when exporting a PDF" => "Image alignment when exporting a PDF",
// "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"" => "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"",
// "Previous xorti/mxgraph-editor package has been deprecated.<br/>" => "Previous xorti/mxgraph-editor package has been deprecated.<br/>",
// "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator" => "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator",
// "Create New Diagram" => "Create New Diagram",
// "Page (inline)" => "Page (inline)",
// "Tiki wasn't able to find the file with id %0" => "Tiki wasn't able to find the file with id %0",
// "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure" => "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure",
" in " => " in ",
// "Selected file to annotate must be an image" => "Selected file to annotate must be an image",
// "Can not retrieve size from file %0" => "Can not retrieve size from file %0",
// "Create a custom popup dialog box" => "Create a custom popup dialog box",
"Button labels separated by commas" => "Schaltflächenbezeichnungen, getrennt durch Kommata",
// "Button Actions" => "Button Actions",
"JavaScript to perform on first button click" => "Auszuführender JS beim ersten Klick auf die Schaltfläche",
// "Dialog Width" => "Dialog Width",
"In pixels" => "in Pixel",
"HTML ID" => "HTML-ID",
// "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)" => "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)",
// "Show Animation" => "Show Animation",
// "Hide Animation" => "Hide Animation",
// "Auto Open" => "Auto Open",
// "Open dialog automatically" => "Open dialog automatically",
"Modal" => "Modal",
// "Use modal form" => "Use modal form",
"Wiki page to use as dialog body" => "Wiki-Seite für den Text des Dialogs",
"Open Action" => "Aktion beim Öffnen",
"JavaScript to execute when dialog opens" => "Auszuführendes JS, wenn sich ein Dialog öffnet",
"Div" => "DIV",
"Define and format sections of a page or text" => "Definiert und formatiert Abschnitte einer Seite oder Textes",
// "Indicate the type of HTML tag to use (default is %0)" => "Indicate the type of HTML tag to use (default is %0)",
"Span" => "Span",
"Pre" => "Letzte",
"Teletype" => "Teletype",
"Paragraph" => "Absatz",
"Block quote" => "Geblocktes Zitat",
// "H1" => "H1",
// "H2" => "H2",
// "H3" => "H3",
// "H4" => "H4",
// "H5" => "H5",
// "H6" => "H6",
// "Valid CSS color name or hex code" => "Valid CSS color name or hex code",
"Box width" => "Boxbreite",
"In pixels or percentage. Default is original size" => "In Pixel oder Prozentsatz. Standard ist die Originalgröße",
"Aligns the text within the element" => "Richtet den Text innerhalb des Elements aus",
"Justify" => "Blocksatz",
// "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set" => "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set",
"Content cannot wrap around this object because of what the parameter is set to" => "Objekten ist es nicht erlaubt, die Seite(n) zu umgeben, die eingestellt sind",
"Apply custom CSS class to the div" => "Wende benutzerdefinierte CSS-Klasse auf das DIV an",
"Title attribute" => "Titel Attribut",
"Title for the div, usually displayed as a tooltip" => "Titel des div, normalerweise als Tooltip dargestellt",
// "onClick attribute" => "onClick attribute",
// "Enter on onclick event" => "Enter on onclick event",
// "Style attribute" => "Style attribute",
// "Enter CSS styling tags for the div type used" => "Enter CSS styling tags for the div type used",
// "Data attributes" => "Data attributes",
// "URL encoded list or attributes and values" => "URL encoded list or attributes and values",
// "ARIA attributes" => "ARIA attributes",
// "URL encoded list or attributes and values, e.g. label, expanded etc" => "URL encoded list or attributes and values, e.g. label, expanded etc",
// "Role attribute" => "Role attribute",
// "e.g. button, heading, search etc" => "e.g. button, heading, search etc",
"Sets the id attribute of the div, as defined by HTML" => "Legt die DIV-ID Attribute fest, wie in HTML definiert",
"Definition List" => "Definitionsliste",
"Create a definition list" => "Erstellt eine Definitionsliste",
// "One entry per line. Each line is in %0Term: Definition%1 format" => "One entry per line. Each line is in %0Term: Definition%1 format",
"List Type" => "Listentyp",
// "Type of definition list (left-aligned or horizontal)" => "Type of definition list (left-aligned or horizontal)",
// "Standard (left-aligned)" => "Standard (left-aligned)",
// "Horizontal (inline) " => "Horizontal (inline) ",
"Draw" => "Zeichnen",
// "Embed a drawing in a page" => "Embed a drawing in a page",
"Drawing ID" => "Zeichnungs-ID",
"Internal ID of the file ID" => "Interne ID der Datei-ID",
// "Width in pixels or percentage. Default value is page width, for example, %0 or %1" => "Width in pixels or percentage. Default value is page width, for example, %0 or %1",
"Height in pixels or percentage. Default value is complete drawing height" => "Höhe in Pixel oder Prozentsatz. Standardmäßig die vollständige Zeichnungshöhe",
"Force Display Archive" => "Erzwinge Archivanzeige",
// "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision",
"Draw New SVG Image" => "Neues SVG-Bild zeichnen",
"Edit SVG Image" => "Bearbeite SVG-Bild",
// "List of dynamic variables" => "List of dynamic variables",
// "Show dynamic variables and their values" => "Show dynamic variables and their values",
"Layout" => "Layout",
"Set to table to show results in a table (not shown in a table by default)" => "Wähle Tabelle, um die Ergebnisse in einer Tabelle anzuzeigen (wird standardmäßig nicht in einer Tabelle angezeigt)",
"String to use between elements of the list if table layout is not used" => "Text, der zwischen Elementen der Liste stehen soll, wenn kein Tabellenlayout benutzt wird",
// "Parsed result" => "Parsed result",
"Syntax" => "Syntax",
// "Value per database" => "Value per database",
"Equation" => "Gleichung",
// "Render an equation written in LaTeX syntax as an image" => "Render an equation written in LaTeX syntax as an image",
"equation" => "Gleichung",
// "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator" => "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator",
// "Display events from calendars" => "Display events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)" => "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)",
"Maximum Days" => "Maximale Tage",
// "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0" => "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0",
"Maximum Events" => "Maximale Ereignisse",
// "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)" => "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)",
"Show Time" => "Zeige Zeit",
"Show the time along with the date (shown by default)" => "Zeige Zeit zusammen mit Datum (standardmäßig angezeigt)",
"Show the description of the event (shown by default)" => "Zeige die Beschreibung des Ereignisses (standardmäßig angezeigt)",
// "Time Span" => "Time Span",
// "Specify the time span" => "Specify the time span",
"Past" => "Vergangen",
// "Future" => "Future",
// "Activate pagination when Events listing are long. Default is %0" => "Activate pagination when Events listing are long. Default is %0",
"Exercise" => "Übung",
"PluginExercise" => "PluginExercise",
// "Create an exercise/test with questions and grade" => "Create an exercise/test with questions and grade",
"Answer" => "Antwort",
"Used inline to specify the right answer to the question and propose an input field" => "Wird inline benutzt, um die richtige Antwort zur Frage zu hinterlegen und ein Eingabefeld zu zeigen",
"Incorrect" => "Falsch",
// "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")" => "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")",
"Check your score" => "Prüfe Deinen Punktestand",
"You scored %0 out of %1" => "Du hast %0 von insgesamt %1 erzielt",
"Good" => "Gut",
"Extend Cart Inventory Hold" => "Erweitere Bestandszeit",
"PluginExtendCartHold" => "PluginExtendCartHold",
// "Extend the time that items are held in a shopping cart" => "Extend the time that items are held in a shopping cart",
"Create a link that shows/hides initially hidden content" => "Erstelle einen Link, der anfänglich versteckten Inhalt anzeigt/verbirgt",
// "Content of the hideable zone (in Wiki syntax)" => "Content of the hideable zone (in Wiki syntax)",
"Label for link that shows and hides the content when clicked" => "Bezeichnung für den Link, der den Inhalt zeigt und versteckt, wenn er angeklickt wird",
"Unspecified label" => "Nicht spezifierte Bezeichnung",
"Arrow icon showing that content can be hidden or shown" => "Pfeilsymbol, welches anzeigt, dass Inhalte versteckt bzw. angezeigt werden können",
"Show Speed" => "Anzeigegeschwindigkeit",
// "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or %0 or %1" => "Integer greater than 0 and less than or equal to 1000, or %0 or %1",
"Hide Speed" => "Verstecke Geschwindigkeit",
// "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Use Bootstrap" => "Use Bootstrap",
// "Use Bootstrap collapsible box" => "Use Bootstrap collapsible box",
// "Apply custom CSS class" => "Apply custom CSS class",
"Fancy List" => "Ausgefallene Liste",
// "Create a formatted numbered list" => "Create a formatted numbered list",
"One item per line starting with anything followed by \")\"" => "Ein Eintrag pro Zeile, beginnend mit irgendetwas gefolgt von \")\"",
"Use Div" => "Benutze DIV",
"Use the HTML div tag instead of the HTML ordered list tag (ol)" => "Benutze das HTML-Tag DIV anstelle des HTML-Tags für Listen (ol)",
"CSS class for the fancylist" => "CSS-Klasse für die ausgefallene Liste",
"Heading Row" => "Kopfreihe",
// "Header rows of the table. Use %0 to separate multiple rows" => "Header rows of the table. Use %0 to separate multiple rows",
"Heading CSS Class" => "Kopf CSS-Klasse",
"CSS class to apply to the heading row" => "CSS-Klasse für die Kopfreihe",
"Header Horizontal Alignment" => "Horizontale Ausrichtung Kopf",
// "Horizontal alignments for header cells, separated by %0. Choices: %1" => "Horizontal alignments for header cells, separated by %0. Choices: %1",
"Header Vertical Alignment" => "Vertikale Ausrichtung Kopf",
// "Vertical alignments for header cells, separated by %0\". Choices: %1" => "Vertical alignments for header cells, separated by %0\". Choices: %1",
"Column Widths" => "Spaltenbreite",
// "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0" => "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0",
"Cell Horizontal Align" => "Horizontale Ausrichtung Zellen",
// "Table body column horizontal alignments, separated by %0. Choices: %1" => "Table body column horizontal alignments, separated by %0. Choices: %1",
"Cell Vertical Align" => "Vertikale Ausrichtung Zellen",
// "Table body column vertical alignments, separated by %0. Choices: %1" => "Table body column vertical alignments, separated by %0. Choices: %1",
"Fancy Table" => "Ausgefallene Tabelle",
// "Create a formatted table that can be filtered and sorted" => "Create a formatted table that can be filtered and sorted",
// "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases" => "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases",
// "The jQuery Sortable Tables feature must be activated for the sort feature to work" => "The jQuery Sortable Tables feature must be activated for the sort feature to work",
// "JavaScript must be enabled for the sort feature to work" => "JavaScript must be enabled for the sort feature to work",
// "Unable to load the jQuery Sortable Tables feature" => "Unable to load the jQuery Sortable Tables feature",
// "Display a button for a user to click to make an object a favorite" => "Display a button for a user to click to make an object a favorite",
// "Indicate type of object" => "Indicate type of object",
// "Enter the ID of the object" => "Enter the ID of the object",
// "Link to a file that's attached or in a gallery or archive" => "Link to a file that's attached or in a gallery or archive",
"Label for the link to the file (ignored if the file is a wiki attachment)" => "Bezeichnung für den LInk zu der Datei (wird ignoriert, wenn die Datei ein Wiki Anhang ist)",
"Indicate whether the file is in a file gallery or is a wiki page attachment" => "Gib an, ob die Datei in einem Dateiarchiv liegt oder ein Anhang zu einer Wiki Seite ist",
// "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used" => "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used",
"Custom Description" => "Benutzerdefinierte Beschreibung",
"Custom text that will be used for the link instead of the file name or file description" => "Benutzerdefinierter Text, der anstelle des Dateinamens oder der Dateibeschreibung als Link benutzt wird",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty",
"Attachment Description" => "Anhangbeschreibung",
"Show the attachment description as the link label instead of the attachment file name" => "Zeige die Anhangbeschreibung als die Linkbezeichnung anstelle des Dateinamens der angehängten Datei",
"Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Gibt an, dass es sich um ein Bild handelt, dass in der Zeile mittels des IMG-Tags angezeigt werden soll",
"File ID" => "Datei-ID",
"File ID of a file in a file gallery or an archive" => "Datei-ID der Datei im Dateiarchiv oder einem Archiv",
"Example value:" => "Beispielswert:",
"Date" => "Datum",
// "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1" => "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1",
"Show Icon" => "Zeige Symbol",
"Show an icon version of the file or file type with the link to the file" => "Zeige eine Symbolversion der Datei oder des Dateityps mit einem Link zur Datei",
// "Browser Display" => "Browser Display",
// "Display in different browser window or tab instead of downloading" => "Display in different browser window or tab instead of downloading",
"File Gallery File/Archive" => "Dateiarchiv-Datei/Archiv",
"Wiki Page Attachment" => "Wiki Seiten-Anhang",
"The date has not been set" => "Das Datum wurde nicht angegeben",
"Incorrect date format" => "Ungültiges Datumsformat",
"No such file" => "Keine solche Datei",
"Wiki attachments are disabled" => "Wiki-Anhänge sind deaktiviert",
"List files by ID, gallery or category, or show a slideshow of image files." => "Liste Dateien nach ID, Archiv oder Kategorie auf oder zeige eine Diashow mit Bilddateien",
// "Title for the file listing, or the link text when %0" => "Title for the file listing, or the link text when %0",
"File Galleries IDs" => "Dateiarchiv-ID",
// "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)" => "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)",
// "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)" => "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon",
// "Valid category IDs separated by colons" => "Valid category IDs separated by colons",
// "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty" => "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty",
// "Valid file IDs separated by colons" => "Valid file IDs separated by colons",
// "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0" => "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0",
// "Last modified Ascending" => "Last modified Ascending",
// "Last modified Descending" => "Last modified Descending",
"File Name Ascending" => "Dateiname aufsteigend",
"File Name Descending" => "Dateiname absteigend",
"File Size Ascending" => "Dateigröße aufsteigend",
"File Size Descending" => "Dateigröße absteigend",
"File Type Ascending" => "Dateityp aufsteigend",
"File Type Descending" => "Dateityp absteigend",
"Last Download Ascending" => "Letzter Download aufsteigend",
"Last Download Descending" => "Letzter Download absteigend",
"Show Action" => "Zeige Aktion",
// "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)" => "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)",
"Show Find" => "Zeige Suchen",
"Show a search box above the list (not shown by default)" => "Zeige eine Suchbox über der Liste (wird standardmäßig nicht angezeigt)",
// "Show Find is recursive" => "Show Find is recursive",
// "The search box digs recursively in sub-galleries (by default)" => "The search box digs recursively in sub-galleries (by default)",
"Show Title" => "Zeige Titel",
// "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used",
"Show ID" => "Zeige ID",
"Show the ID number of each file (shown by default)" => "Zeige die ID-Nummer jeder Datei (wird standardmäßig angezeigt)",
"Show the file-type icon for each file" => "Zeige ein Symbol zu jeder Datei, das den Dateityp angibt",
"Show Name" => "Zeige Name",
// "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show",
"Show Filename" => "Zeige Dateiname",
// "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show",
"Show Size" => "Zeige Größe",
"Show the size of each file in kilobytes (shown by default except in slide show)" => "Zeige die Größe jeder Datei in Kilobytes (wird standardmäßig angezeigt, außer in der Diashow)",
// "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show",
"Show Creation Date" => "Zeige Erstellungsdatum",
"Show the date each file was created (not shown by default)" => "Zeige das Datum, zu dem jede Datei erstellt wurde (wird standardmäßig nicht angezeigt)",
"Show Last Modification Date" => "Zeige Datum der letzten Veränderung",
"Show the date each file was last modified (shown by default)" => "Zeige zu jeder Datei das Datum der letzten Änderung (wird standardmäßig angezeigt)",
// "Show Last Modification Time as well as Date" => "Show Last Modification Time as well as Date",
// "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)" => "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)",
"Show Hits" => "Zeige Treffer",
"Show the number of hits each file has received (not shown by default)" => "Zeige die Anzahl von Treffern, die jede Datei erhalten hat (wird standardmäßig nicht angezeigt)",
"Show Locked By" => "Zeige gesperrt von",
"For locked files, show the username of the user who locked it (not shown by default)" => "Zeige bei gesperrten Dateien den Benutzernamen, der die Datei gesperrt hat (wird standardmäßig nicht angezeigt)",
"Show the username of the user who is the author of the file (not shown by default)" => "Zeige den Benutzernamen desjenigen, der Autor der Datei ist (wird standardmäßig nicht angezeigt)",
"Show Creator" => "Zeige Ersteller",
"Show the username of the user who is the creator of the file (not shown by default)" => "Zeige den Benutzernamen desjenigen, der Ersteller der Datei ist (wird standardmäßig nicht angezeigt)",
"Show Parent Gallery Name" => "Zeige den Namen des übergeordneten Archivs",
"Show the name of the parent gallery" => "Zeige den Namen des übergeordneten Archivs",
"Show File Count" => "Zeige Dateizähler",
// "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)",
// "Show Source" => "Show Source",
// "Show the source (shown by default)" => "Show the source (shown by default)",
"Show Slideshow" => "Zeige Diashow",
"Show a link that produces a popup slideshow when clicked (not set by default)" => "Zeige einen Link, der beim klicken eine Popup-Diashow aufruft (standardmäßig nicht eingestellt)",
"Slideshow Width" => "Diashow-Breite",
"Set width of slideshow popup" => "Legt die Breite des Diashow-Popup fest",
"Slideshow Height" => "Diashow-Höhe",
"Set height of slideshow popup" => "Legt die Höhe des Diashow-Popup fest",
"Show Comments" => "Zeige Kommentar",
"Show comments for each file (not shown by default)" => "Zeige Kommentare für jede Datei (werden standardmäßig nicht gezeigt)",
"Show Last Editor" => "Zeige letzten Bearbeiter",
"Show the username of the user who last modified the file (shown by default)" => "Zeige den Benutzernamen desjenigen, der die Datei zuletzt verändert hat (wird standardmäßig angezeigt)",
"Show image thumbnail" => "Zeige Vorschaubild",
"Show Image thumb" => "Zeige Vorschaubild",
"Show only files created by this user" => "Zeige nur Dateien, die von diesem Benutzer erstellt wurden",
"Show Upload" => "Zeige Hochladen",
"Show a simple form to upload files to the gallery (not shown by default)" => "Zeige ein einfaches Hochladeformular im Archiv (wird standardmäßig nicht angezeigt)",
"Number of rows (default: -1 = all)" => "Anzahl von Zeilen (Standard: -1 = alle)",
"Recursive" => "Rekursiv",
"With subgalleries" => "Mit Unter-Dateiarchiven",
// "Fitnesse Test Suite" => "Fitnesse Test Suite",
// "Create test suites for applications built using Tiki" => "Create test suites for applications built using Tiki",
// "Test execution scenario" => "Test execution scenario",
// "Fixture not found: %0" => "Fixture not found: %0",
// "Tracker Math for [%0|%1]" => "Tracker Math for [%0|%1]",
// "Tracker Field not found: %0" => "Tracker Field not found: %0",
// "Field is not a math field: %0" => "Field is not a math field: %0",
// "Tracker Data for [%0|%1]" => "Tracker Data for [%0|%1]",
// "Table must contain at least one field named itemId" => "Table must contain at least one field named itemId",
// "%0 (expect: %1)" => "%0 (expect: %1)",
"Flash Video" => "Flashvideo",
"Embed a video or audio file" => "Bette eine Video-/Audiodatei ein",
"Flash Type" => "Flashtyp",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo",
"Blip.tv" => "Blip.tv",
"File Gallery Podcast" => "Dateiarchiv Podcast",
"Movie URL" => "Film-URL",
"Youtube" => "Youtube",
// "URL to the movie to include, for example, %0" => "URL to the movie to include, for example, %0",
"File Gallery Podcast ID" => "Dateiarchiv Podcast-ID",
"ID of a file from a podcast gallery - will work only with podcast gallery" => "ID der Datei aus dem Podcast-Archiv - funktioniert nur mit einem Podcast-Archiv",
"YouTube URL" => "YouTube URL",
"Complete URL to the YouTube video" => "Vollständige URL zum YouTube Video",
"Vimeo URL" => "Vimeo URL",
"Complete URL to the Vimeo video" => "Vollständige URL zum Vimeo Video",
// "Width of movie in pixels (default is %0)" => "Width of movie in pixels (default is %0)",
// "Height of movie in pixels (default is %0)" => "Height of movie in pixels (default is %0)",
"Quality" => "Qualität",
// "Flash video quality. Default value: %0" => "Flash video quality. Default value: %0",
"Medium" => "Mittel",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
"Invalid URL" => "Ungültige URL",
"Missing parameter movie to the plugin flash" => "Fehlender Parameter: Film für das Plugin Flash",
// "Fluid Grid" => "Fluid Grid",
// "Arrange content into rows and columns using a Bootstrap fluid grid" => "Arrange content into rows and columns using a Bootstrap fluid grid",
// "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Join Columns" => "Spalten anfügen",
// "Merge empty cells into the cell to their left" => "Merge empty cells into the cell to their left",
// "Device size" => "Device size",
// "Specify the device size below which the cells will be stacked vertically" => "Specify the device size below which the cells will be stacked vertically",
"Small" => "klein",
"Large" => "Groß",
// "Extra Large" => "Extra Large",
"Column Sizes" => "Spaltengröße",
// "Specify all column widths in units which add up to 12" => "Specify all column widths in units which add up to 12",
"First" => "erste",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Spalte",
"Line" => "Linie",
"Custom Class" => "Benutzerdefinierte Klasse",
"Add a class to customize the design" => "Füge eine Klasse hinzu, um das Design anzupassen",
"Font" => "Schriftart",
// "Format the font type and size of text" => "Format the font type and size of text",
"Content" => "Inhalt",
"Font Family" => "Schriftart",
"Select the font family to display the content" => "Wähle die Schriftart in welcher der Inhalt angezeigt werden soll",
"Font Size" => "Schriftgröße",
// "Define the size of the font in pixels (enter %0 to get a font of 12px)" => "Define the size of the font in pixels (enter %0 to get a font of 12px)",
"Footnote" => "Fußnote",
"Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Erstelle automatisch nummerierte Fußnoten (zusammen mit dem Plugin Fußnotenbereich)",
"The footnote" => "Die Fußnote",
"Tag" => "Tag",
// "Tag footnote with unique identifier" => "Tag footnote with unique identifier",
// "One word made of alphanumeric characters" => "One word made of alphanumeric characters",
// "Same as Tag" => "Same as Tag",
// "Tag to existing footnote by its Tag" => "Tag to existing footnote by its Tag",
// "Same as" => "Same as",
// "Tag to existing footnote number" => "Tag to existing footnote number",
// "tag name (since 17) or footnote number" => "tag name (since 17) or footnote number",
// "Add class to footnotearea" => "Add class to footnotearea",
// "Scheme" => "Scheme",
// "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)" => "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)",
// "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)" => "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)",
// "Error: Tag not found in any previous footnote" => "Error: Tag not found in any previous footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Filter footnotearea by footnote class" => "Filter footnotearea by footnote class",
// "SameAs Style" => "SameAs Style",
// "Numbering style for sameas referencing" => "Numbering style for sameas referencing",
// "Valid Tiki ((Number Style))" => "Valid Tiki ((Number Style))",
"Tagged" => "Tagged",
"List similarly tagged objects" => "Listet ähnlich getaggte Objekte",
"Tags to find similar to" => "Zu findende Tags, die ähnlich sind zu",
"Leave blank to use the object's own tags" => "Freilassen, um die Tags des Objektes selbst zu nutzen",
"Type of objects to extract. Set to All to find all types" => "Zu extrahierende Objekttypen. Wähle alle, um alle Typen zu finden",
"Same" => "Gleich",
"Blog Posts" => "Blogeinträge",
// "Faqs" => "Faqs",
"Offset" => "Abstand (Offset)",
"Start record" => "Starte Aufzeichnung",
"Default -1 (all)" => "Standard -1 (alle)",
// "Determine sort order based on various fields (Default: %0)" => "Determine sort order based on various fields (Default: %0)",
"Comments locked Ascending" => "Kommentare gesperrt aufsteigend",
"Comments locked Descending" => "Kommentare gesperrt absteigend",
"Description Ascending" => "Beschreibung aufsteigend",
"Description Descending" => "Beschreibung absteigend",
"Href Ascending" => "HREF aufsteigend",
"Href Descending" => "HREF absteigend",
"Object ID Ascending" => "ObjektID aufsteigend",
"Object ID Descending" => "ObjektID absteigend",
"Show objects with names or descriptions similar to the text entered here" => "Zeige Objekte mit Namen oder Beschreibungen, die dem hier eingegebenen Text ähnlich sind",
// "Choose whether to broaden" => "Choose whether to broaden",
"n|y" => "n|j",
// "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags" => "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags",
"Show Titles Only" => "Zeige nur Titel",
"Choose whether to show titles only (not shown by default)" => "Wähle Titel (nicht) anzuzeigen (standardmäßig nicht angezeigt)",
// "Max Image Size" => "Max Image Size",
// "Height or width in pixels. Default: %0 (no maximum)" => "Height or width in pixels. Default: %0 (no maximum)",
// "Show a 'more' link that links to the full list of tagged objects (not shown by default)" => "Show a 'more' link that links to the full list of tagged objects (not shown by default)",
"More URL" => "Mehr-URL",
// "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects" => "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects",
// "More label" => "More label",
// "Alternate text to display on the \"more\" link (default is \"more\")" => "Alternate text to display on the \"more\" link (default is \"more\")",
// "Friend and unfriend other users" => "Friend and unfriend other users",
// "Add or Remove Friend Button" => "Add or Remove Friend Button",
"Other User" => "Anderer Benutzer",
"Button Text" => "Schaltflächentext",
// "The user you wish to change relations with" => "The user you wish to change relations with",
// "Button text that's displayed when friending a user" => "Button text that's displayed when friending a user",
// "Button text that's displayed when un-friending a user" => "Button text that's displayed when un-friending a user",
// "Add to Friend Network" => "Add to Friend Network",
// "Remove from Friend Network" => "Remove from Friend Network",
"FTP" => "FTP",
"Create a button for downloading a file from an FTP server" => "Erstelle eine Schaltfläche um eine Datei von einem FTP-Server herunterzuladen",
// "File name on the server" => "File name on the server",
"Server Name" => "Servername",
"Name of the server for the FTP account. Example: " => "Name des Servers mit dem FTP-Konto. Beispiel: ",
"Username for the FTP account" => "Benutzername für den Zugriff auf das FTP-Konto",
"Password for the FTP account" => "Passwort für den Zugriff auf das FTP-Konto",
"Download Button Label" => "Download Schaltflächenbezeichnung",
"Label for the FTP download button" => "Bezeichnung für die Schaltfläche für das Herunterladen vom FTP-Server",
"missing parameters" => "fehlende Parameter",
"Connection failed" => "Verbindung fehlgeschlagen",
// "Set a Full-Width Page Title" => "Set a Full-Width Page Title",
// "Display the page title the full width of the site content container. " => "Display the page title the full width of the site content container. ",
// "PluginFullWidthTitle" => "PluginFullWidthTitle",
// "Page title" => "Page title",
// "If you need to include tpl files" => "If you need to include tpl files",
// "Icon Source" => "Icon Source",
// "Source path of the icon" => "Source path of the icon",
"Galleriffic" => "Galleriffic",
// "Display a slideshow of images on a page using the Galleriffic script" => "Display a slideshow of images on a page using the Galleriffic script",
// "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual table field name in place of %2" => "%0 or %1 with actual table field name in place of %2",
// "Thumbs Width" => "Thumbs Width",
// "Width in pixels or percentage. (e.g. %0 or %1)" => "Width in pixels or percentage. (e.g. %0 or %1)",
// "Image Slideshow Width" => "Image Slideshow Width",
// "Width in pixels or percentage of the largest image. (e.g. %0 or %1)" => "Width in pixels or percentage of the largest image. (e.g. %0 or %1)",
// "Image Slideshow Height" => "Image Slideshow Height",
// "Height in pixels or percentage of the largest images. (e.g. %0 or %1)" => "Height in pixels or percentage of the largest images. (e.g. %0 or %1)",
"Start Slideshow" => "Diashow abspielen",
"Automatically start the slideshow" => "Diashow automatisch abspielen",
"Delay" => "Verzögerung",
"Delay in milliseconds between each transition" => "Verzögerung in Millisekunden zwischen den Bildwechseln",
"Number of thumbnails" => "Anzahl der Thumbnails",
"The number of thumbnails to show per page" => "Die Anzahl der Thumbnails je Seite",
// "Show Top Pager" => "Show Top Pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show Bottom Pager" => "Show Bottom Pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
"Play Slideshow" => "Diashow abspielen",
"Pause Slideshow" => "Diashow pausieren",
"Previous Photo" => "Vorheriges Foto",
"Next Photo" => "Nächstes Foto",
"Prev" => "vorherige",
// "Gantt Chart" => "Gantt Chart",
// "Create and display a gantt graphic using tracker data" => "Create and display a gantt graphic using tracker data",
// "Tracker to search from" => "Tracker to search from",
// "Order Field" => "Order Field",
// "Permanent name of the field to use for row number order" => "Permanent name of the field to use for row number order",
// "Level Field" => "Level Field",
// "Permanent name of the field to use for row level" => "Permanent name of the field to use for row level",
// "Status Field" => "Status Field",
// "Permanent name of the field to use for row status" => "Permanent name of the field to use for row status",
// "Dependency Field" => "Dependency Field",
// "Permanent name of the field to use for row dependency" => "Permanent name of the field to use for row dependency",
// "Progress Field" => "Progress Field",
// "Permanent name of the field to use for row progress, values between 0-100" => "Permanent name of the field to use for row progress, values between 0-100",
// "Name Field" => "Name Field",
// "Permanent name of the field to use for row name" => "Permanent name of the field to use for row name",
// "Description Field" => "Description Field",
// "Permanent name of the field to use for row description" => "Permanent name of the field to use for row description",
// "Code Field" => "Code Field",
// "Permanent name of the field to use for row code" => "Permanent name of the field to use for row code",
// "Begin Date Field" => "Begin Date Field",
// "Permanent name of the field to use for event beginning" => "Permanent name of the field to use for event beginning",
// "End Date Field" => "End Date Field",
// "Permanent name of the field to use for event ending" => "Permanent name of the field to use for event ending",
// "Resources Field" => "Resources Field",
// "Permanent name of the field to use for resources ending" => "Permanent name of the field to use for resources ending",
// "Roles Field" => "Roles Field",
// "Permanent name of the field to use for roles ending" => "Permanent name of the field to use for roles ending",
// "Effort Field" => "Effort Field",
// "Permanent name of the field to use for effort ending, values in milliseconds" => "Permanent name of the field to use for effort ending, values in milliseconds",
// "Start Is Milestone" => "Start Is Milestone",
// "Flag field to start is milestone" => "Flag field to start is milestone",
// "End Is Milestone" => "End Is Milestone",
// "Flag field to end is milestone" => "Flag field to end is milestone",
// "Writable" => "Writable",
// "Flag field to write or not in tasks" => "Flag field to write or not in tasks",
// "Deletable" => "Deletable",
// "Flag field that permit to delete or not tasks" => "Flag field that permit to delete or not tasks",
// "Parent Writable" => "Parent Writable",
// "Flag field to write or not in parent tasks" => "Flag field to write or not in parent tasks",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer",
// "Tracker data source not found" => "Tracker data source not found",
// "Order tracker field parameter is mandatory" => "Order tracker field parameter is mandatory",
// "Level tracker field parameter is mandatory" => "Level tracker field parameter is mandatory",
// "Depends tracker field parameter is mandatory" => "Depends tracker field parameter is mandatory",
// "You are trying to update a tracker that is not used by this gantt chart" => "You are trying to update a tracker that is not used by this gantt chart",
// "Gantt chart updated" => "Gantt chart updated",
"Gauge" => "Balkenanzeige",
"Display a horizontal bar gauge" => "Zeigt eine horizontale Balkenanzeige",
"description" => "Beschreibung",
"Current value to be represented by the gauge" => "Gegenwärtiger Wert, der auf der Anzeige dargestellt werden soll",
"Maximum Value" => "Maximaler Wert",
// "Maximum possible value. Default: %0" => "Maximum possible value. Default: %0",
"Label displayed on the left side of the gauge" => "Bezeichnung, die links von der Anzeige erscheint",
"Color" => "Farbe",
"Main color of the gauge. Use HTML color codes or names" => "Hauptfarbe der Anzeige. Benutze HTML Farbcodes oder Namen",
"Background color of the gauge. Use HTML color codes or names" => "Hintergrundfarbe der Anzeige. Benutze HTML Farbcodes oder Namen",
"Bar width in pixels" => "Balkenbreite in Pixel",
"Label Width" => "Bezeichnungsbreite",
"Label width, in pixels" => "Breite in Pixel, die der Bezeichnung zugeordnet werden",
"Display Percentage" => "Zeige Prozentsatz an",
// "Set to %0 (Yes) to display a percentage of the maximum" => "Set to %0 (Yes) to display a percentage of the maximum",
"Display Value" => "Zeige Wert",
// "Set to %1 (No) to hide the numeric value (shown by default)" => "Set to %1 (No) to hide the numeric value (shown by default)",
"Bar height in pixels" => "Balkenhöhe in Pixel",
// "GDGraph" => "GDGraph",
// "Create a simple graph from supplied data" => "Create a simple graph from supplied data",
// "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body" => "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body",
// "14, backported to 12.4" => "14, backported to 12.4",
// "Graph Type" => "Graph Type",
// "Defines what ype of graph or chart is to be generated" => "Defines what ype of graph or chart is to be generated",
// "Vertical Bar" => "Vertical Bar",
// "Graph Title" => "Graph Title",
// "Displayed above the graph" => "Displayed above the graph",
// "Alt Tag" => "Alt Tag",
// "Text for image alt tag" => "Text for image alt tag",
// "Graph Image Width" => "Graph Image Width",
// "Overall width in pixels. Default value is %0" => "Overall width in pixels. Default value is %0",
// "Graph Image Height" => "Graph Image Height",
// "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown" => "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown",
"Get Security Token" => "Erhalte Sicherheits-Token",
"PluginGetAccessToken" => "PluginGetAccessToken",
// "Display a link on a secure page using an access token" => "Display a link on a secure page using an access token",
// "Entry Patg" => "Entry Patg",
// "The path or part of the path that the token is for" => "The path or part of the path that the token is for",
// "Query Keys" => "Query Keys",
// "Query string parameter keys that the token is for, separated by a colon (:)" => "Query string parameter keys that the token is for, separated by a colon (:)",
// "Query Values" => "Query Values",
// "Query string parameter values that the token is for, separated by a colon (:)" => "Query string parameter values that the token is for, separated by a colon (:)",
"Google Analytics" => "Google Analytics",
"Add the tracking code for Google Analytics" => "Fügt einen Trackingcode für Google Analytics ein",
"Account Number" => "Kontonummer",
// "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1" => "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1",
// "Groups Option" => "Groups Option",
// "Define option for Google Analytics groups, include or exclude" => "Define option for Google Analytics groups, include or exclude",
// "Available Groups" => "Available Groups",
// "Google Analytics Chart" => "Google Analytics Chart",
// "Draw charts from Google Analytics data" => "Draw charts from Google Analytics data",
// "JSON File" => "JSON File",
// "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)" => "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)",
// "Profle IDs" => "Profle IDs",
// "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin" => "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin",
// "Query String" => "Query String",
// "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0" => "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0",
// "Metrics" => "Metrics",
// "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"" => "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"",
// "default \"30daysAgo\"" => "default \"30daysAgo\"",
// "default \"yesterday\"" => "default \"yesterday\"",
// "Dimensions" => "Dimensions",
// "default \"ga:date\"" => "default \"ga:date\"",
// "Segment" => "Segment",
// "default \"\"" => "default \"\"",
// "Max Results" => "Max Results",
// "default 50" => "default 50",
"Sort" => "Sortieren",
// "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"" => "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"",
// "Container" => "Container",
// "ID of a DIV to contain the chart (optional)" => "ID of a DIV to contain the chart (optional)",
// "Type of chart, e.g. LINE, PIE etc" => "Type of chart, e.g. LINE, PIE etc",
// "Bar" => "Bar",
// "Pie" => "Pie",
// "Geo" => "Geo",
// "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "googlechart: No credentials file" => "googlechart: No credentials file",
// "googlechart: No query_ids supplied" => "googlechart: No query_ids supplied",
// "googlechart exception: %0" => "googlechart exception: %0",
"Google Doc" => "Google Dokument",
"Display a Google document" => "Zeigt ein Google Dokument an",
"Leave this empty" => "Lasse dies leer",
"Type of Google document" => "Typ des Google-Dokuments",
"Document" => "Dokument",
// "Slides" => "Slides",
// "Forms" => "Forms",
"Key" => "Schlüssel",
// "Google doc key - for example" => "Google doc key - for example",
"Name of iframe. Default is \"Frame\" + the key" => "Name des IFRAME. Standard ist \"Frame\" + dem Schlüssel",
// "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly",
"Width in pixels or %" => "Breite in Pixel oder %",
"Height in pixels or %" => "Höhe in Pixel oder %",
// "Position of frame on page" => "Position of frame on page",
"Middle" => "Mittel",
"Frame Border" => "Frame-Rahmen",
"Choose whether to show a border around the iframe" => "Wähle, ob ein Rahmen um den IFRAME angezeigt werden soll",
"Margin Height" => "Randhöhe",
"Margin height in pixels" => "Randhöhe in Pixel",
"Margin Width" => "Randbreite",
"Margin width in pixels" => "Randbreite in Pixel",
"Scrolling" => "Scrollen",
"Choose whether to add a scroll bar" => "Wähle, ob Scrollbalken angezeigt werden sollen",
"Auto" => "Auto",
"Edit Link" => "Bearbeitungslink",
"Choose whether to show an edit link and set its location" => "Wähle, ob und wo ein Bearbeitungslink angezeigt werden soll",
"Required parameter \"type\" missing" => "Erforderlicher Parameter \"type\" fehlt",
"Required parameter \"key\" missing" => "Erforderlicher Parameter \"key\" fehlt",
"Display content based on the user's groups or friends" => "Inhalte basierend auf der Gruppe des Benutzers oder seiner Freunde anzeigen",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions",
"Allowed User Friends" => "Erlaubte Benutzerfreunde",
// "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample",
"Allowed Groups" => "Erlaubte Gruppen",
// "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample",
"Denied Groups" => "Abgelehnte Gruppen",
// "Pipe-separated list of groups not allowed to view the block" => "Pipe-separated list of groups not allowed to view the block",
// "Allowed Groups Pending Membership" => "Allowed Groups Pending Membership",
// "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding" => "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding",
// "Allowed Groups Full Membership" => "Allowed Groups Full Membership",
// "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending" => "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending",
"Group Expiration" => "Gruppenablauf",
// "Show the expiration date of a group the user belongs to" => "Show the expiration date of a group the user belongs to",
// "The name of an existing group on the site" => "The name of an existing group on the site",
"not in group" => "nicht in Gruppe",
"never expires" => "läuft nie ab",
"Group List" => "Gruppenliste",
// "Create a complete or filtered list of groups" => "Create a complete or filtered list of groups",
// "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed",
"Group Homepage" => "Gruppenhomepage",
"Link the group name to the group homepage, if there is one (not linked to by default)" => "Verlinke den Gruppennamen auf die Gruppenhomepage, wenn existent (standardmäßig nicht verlinkt)",
"Recursively List Groups" => "Rekursive Gruppenliste",
"Recursively list the included groups (the default is to not list them repeatedly)" => "Rekursive Auflistung in Bezug auf die eingeschlossenen Listen (standardmäßig nicht rekursiv)",
// "List only your own" => "List only your own",
// "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)" => "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)",
"GroupMail Core" => "Gruppen-E-Mail Kern",
// "Display GroupMail functions on a page" => "Display GroupMail functions on a page",
"From Email" => "Von E-Mail",
"Email address to report" => "E-Mailaddresse an die berichtet wird",
"ID of GroupMail Logs tracker (set up in alias by profile)" => "ID des GruppenMail-Log-Trackers (vom Profil eingestellt unter Alias)",
"ID of GroupMail Logs tracker field (usually set up in alias by profile)" => "ID des GruppenMail-Log-Tracker-Feldes (gewöhnlich vom Profil unter Alias eingestellt)",
"Datetime Field ID" => "Datum-Zeit Feld-ID",
"Group Stats" => "Gruppenstatistik",
"Show the distribution of users among groups" => "Zeigt die Verteilung von Benutzern zwischen Gruppen",
"Groups" => "Gruppen",
"Groups, separated by \":\". If empty, all groups will be listed" => "Gruppen, getrennt durch :. Wenn leer, werden alle Gruppen aufgelistet",
"Percentage of" => "Prozentsatz von",
// "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter" => "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter",
// "Users in groups" => "Users in groups",
"Site users" => "Site-Benutzer",
"Show Percentage" => "Zeige Prozentsatz",
// "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)" => "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)",
"Show Bar" => "Zeige Balken",
// "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)",
// "H5P" => "H5P",
// "Enable the creation, sharing and reuse of interactive HTML5 content" => "Enable the creation, sharing and reuse of interactive HTML5 content",
// "The H5P file in a file gallery" => "The H5P file in a file gallery",
// "H5P is not compatible with the Inline comments (annotations) feature" => "H5P is not compatible with the Inline comments (annotations) feature",
"Has Bought" => "Hat gekauft",
// "Check whether a user has bought an item or added it to the shopping cart" => "Check whether a user has bought an item or added it to the shopping cart",
"PluginHasBought" => "PluginHasBought",
// "Key Name" => "Key Name",
"Key name of passcode to be checked" => "Zu prüfender Schlüsselname des Passworts",
// "Key Labels" => "Key Labels",
"Label of the key name of passcode to be checked" => "Bezeichnung der Schlüsselnamen der Passwörter, die zu überprüfen sind",
"Tracker from which to get passcode to check against" => "Tracker aus dem das Passwort stammt, das abgeglichen werden soll",
"Field ID from which to get passcode to check against" => "Feld-ID aus der das Passwort stammt, das abgeglichen werden soll",
"Item ID from which to get passcode to check against" => "Objekt-ID aus der das Passwort stammt, das abgeglichen werden soll",
"Please fill in all fields" => "Bitte fülle alle Felder aus",
"HTML" => "HTML",
"Add HTML to a page" => "Füge HTML zu einer Seite hinzu",
"HTML code" => "HTML-Code",
// "Move to HTML head" => "Move to HTML head",
// "Insert the code in the HTML head section rather than in the body" => "Insert the code in the HTML head section rather than in the body",
"Parse wiki syntax within the HTML code" => "Parse Wiki Syntax innerhalb von HTML-Code",
"HTML Feed" => "HTML Feed",
// "Add an item to HTML Feed" => "Add an item to HTML Feed",
// "Name of this feed" => "Name of this feed",
"HTML Feed Link" => "HTML-Feed-Link",
// "Receive and display content from another site sent using PluginHTMLFeed" => "Receive and display content from another site sent using PluginHTMLFeed",
"Initial Value" => "Anfänglicher Wert",
// "Feed Location" => "Feed Location",
// "Content Name" => "Content Name",
// "Content Style" => "Content Style",
"Highlight" => "Highlight",
"Asterisk" => "Stern",
"HTML Feed Link Type" => "HTML-Feed Linktyp",
"Backlink" => "Backlink",
"Popup" => "Popup",
"Hover" => "Schweben",
// "Moderated" => "Moderated",
"Date of last accepted HTML item, not used if not moderated" => "Datum des zuletzt akzeptierten HTML-Objekts. Nicht verwendet, wenn moderiert",
// "Display an icon" => "Display an icon",
// "Name of the icon" => "Name of the icon",
// "Valid icon name" => "Valid icon name",
// "Size of the icon (greater than 0 and less than 10)" => "Size of the icon (greater than 0 and less than 10)",
// "greater than 0 and less than 10" => "greater than 0 and less than 10",
"Rotate" => "Rotierung",
// "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)" => "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)",
// "90, 180, 270, horizontal, vertical" => "90, 180, 270, horizontal, vertical",
// "Style supported by the current icon set" => "Style supported by the current icon set",
"Iframe" => "Iframe",
// "Include the body of another web page in a scrollable frame within a page" => "Include the body of another web page in a scrollable frame within a page",
"Frame title" => "Frame-Titel",
"Pixels or %" => "Pixel oder %",
"Align the iframe on the page" => "Ausrichtung des IFRAME auf der Seite",
// "Responsive" => "Responsive",
// "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device" => "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device",
// "16 by 9" => "16 by 9",
// "4 by 3" => "4 by 3",
"no" => "nein",
// "Display one or more custom-formatted images" => "Display one or more custom-formatted images",
// "Image Source" => "Image Source",
// "Choose where to get the image from" => "Choose where to get the image from",
"An image in the file galleries" => "Ein Bild aus einem Dateiarchiv",
"An image attached to a wiki page" => "Ein Bild an einer Wiki-Seite angehangen",
"An image anywhere on the Internet" => "Ein Bild irgendwo aus dem Internet",
// "One random image from a file gallery" => "One random image from a file gallery",
// "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)",
// "Valid file IDs separated by commas or |" => "Valid file IDs separated by commas or |",
"Image ID" => "Bild-ID",
// "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)",
// "Valid image IDs separated by commas or |" => "Valid image IDs separated by commas or |",
// "Full URL to the image to display" => "Full URL to the image to display",
"Numeric ID of a file gallery. Displays a random image from that gallery" => "Numerische ID eines Dateiarchivs. Zeigt ein zufälliges Bild aus diesem Dateiarchiv",
"Numeric ID of a file gallery. Displays all images from that gallery" => "Numerische ID eines Dateiarchivs. Zeigt alle Bilder aus diesem Dateiarchiv",
"Attachment ID" => "Anhang ID",
// "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)" => "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)",
// "Valid attachment IDs separated by commas or |" => "Valid attachment IDs separated by commas or |",
"Thumbnail" => "Vorschau",
// "Makes the image a thumbnail with various options" => "Makes the image a thumbnail with various options",
// "Simple - links to full size image on a new page" => "Simple - links to full size image on a new page",
// "\"Lightbox\" - enlarges in an overlay box when clicked" => "\"Lightbox\" - enlarges in an overlay box when clicked",
// "Mouseover - enlarges in a popup when moused over" => "Mouseover - enlarges in a popup when moused over",
// "Mouseover (sticky)" => "Mouseover (sticky)",
// "Popup - enlarges in a separate window" => "Popup - enlarges in a separate window",
// "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1" => "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1",
// "Image Height" => "Image Height",
// "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Image Width" => "Image Width",
// "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Serve retina images" => "Serve retina images",
// "Serves up retina images to high density screen displays. Width must be set to use this" => "Serves up retina images to high density screen displays. Width must be set to use this",
// "Responsive Image Widths" => "Responsive Image Widths",
// "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"" => "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"",
// "Sizes" => "Sizes",
// "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters" => "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters",
// "Maximum Size" => "Maximum Size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings",
// "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description" => "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description",
// "Alternate Text" => "Alternate Text",
"Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternativer Text, der angezeigt wird, wenn das Bild nicht lädt. Standardmäßig \"Image\"",
// "Responsive Image" => "Responsive Image",
// "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class" => "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class",
// "Featured Image" => "Featured Image",
// "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose" => "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose",
"Comment Ascending" => "Kommentar aufsteigend",
"Comment Descending" => "Kommentar absteigend",
"Max Hits Ascending" => "Maximale Treffer aufsteigend",
"Max Hits Descending" => "Maximale Treffer absteigend",
"User Ascending" => "Benutzer aufsteigend",
"User Descending" => "Benutzer absteigend",
"Author Ascending" => "Autor aufsteigend",
"Author Descending" => "Autor absteigend",
"Locked By Ascending" => "Gesperrt von aufsteigend",
"Locked By Descending" => "Gesperrt von absteigend",
"Last modified User Ascending" => "Zuletzt verändert durch Benutzer aufsteigend",
"Last modified User Descending" => "Zuletzt verändert durch Benutzer absteigend",
"Last modified Date Ascending" => "Datum der letzten Änderung aufsteigend",
"Last modified Date Descending" => "Datum der letzten Änderung absteigend",
"Delete After Ascending" => "Löschen nach aufsteigend",
"Delete After Descending" => "Löschen nach absteigend",
"Votes Ascending" => "Stimmen aufsteigend",
"Votes Descending" => "Stimmen absteigend",
"Points Ascending" => "Punkte aufsteigend",
"Points Descending" => "Punkte absteigend",
"Archive ID Ascending" => "Archiv-ID aufsteigend",
"Archive ID Descending" => "Archiv-ID absteigend",
// "Enlarge Button" => "Enlarge Button",
// "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1" => "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1",
"Browse Popup" => "Browse Popup",
// "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked" => "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked",
// "Image Map" => "Image Map",
"Name of the image map to use for the image" => "Name der zu benutzenden Bildkarte ür das Bild",
// "Horizontal spacing" => "Horizontal spacing",
// "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Vertical spacing" => "Vertical spacing",
// "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Align image using legacy align tag" => "Align image using legacy align tag",
// "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email" => "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email",
// "Align Image" => "Align Image",
// "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page" => "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page",
// "Image Style" => "Image Style",
// "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects" => "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects",
// "Align Image Block" => "Align Image Block",
// "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1" => "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1",
// "Image Block Style" => "Image Block Style",
// "Description Style" => "Description Style",
// "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects" => "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects",
// "Wrapping" => "Wrapping",
"Control how other items wrap around the image" => "Kontrolliert, wie andere Objekte um das Bild herumfließen",
// "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows" => "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows",
// "Link Title" => "Link Title",
// "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties" => "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties",
"Metadata" => "Metadaten",
// "Display the image metadata (IPTC, EXIF and XMP information)" => "Display the image metadata (IPTC, EXIF and XMP information)",
// "Compression Quality" => "Compression Quality",
// "0 to 100 (default is 75)" => "0 to 100 (default is 75)",
// "Default Settings" => "Default Settings",
// "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Mandatory Setting" => "Mandatory Setting",
// "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Image Gallery Image" => "Image Gallery Image",
"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Bildergaleriebrowser wird geöffnet, wenn das Vorschaubild angeklickt wird und wenn das Bild in einer Tiki Bildergalerie abgelegt ist",
"Same as \"browse\" except that the page opens in a new window or tab" => "Gleich wie \"browse\", aber die Seite öffnet sich in einem neuen Fenster oder Tab",
"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Macht das Bild zu einem Vorschaubild, welches sich beim Klicken oder Mouseover zur eigentlichen Größe vergrößert (es sei denn \"link\" wird auf ein anderes Ziel gesetzt). \"browse\" und \"browsepopup\" funktionieren nur bei Bildergalerien und \"download\" nur bei Dateiarchiven oder Anhängen",
// "Hide Draw Icon" => "Hide Draw Icon",
// "Do not show draw/edit icon button under image" => "Do not show draw/edit icon button under image",
// "Overlay with zoom" => "Overlay with zoom",
// "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked" => "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked",
// "Zoom" => "Zoom",
// "Adds a magnifying glass icon and zooms the image when hovered over" => "Adds a magnifying glass icon and zooms the image when hovered over",
"PluginImg: User lacks permission to view image" => "PluginImg: Benutzer hat nicht die Berechtigung das Bild zu sehen",
"File is not an image" => "Datei ist kein Bild",
"Server does not support image manipulation" => "Server unterstützt keine Bildbearbeitung",
// "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator" => "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator",
// "SVG Image replace error \"%0\"" => "SVG Image replace error \"%0\"",
"Enlarge" => "Vergrößern",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''",
"''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Benutze NUR EINEN der folgenden Parameter: fileId, randomGalleryId, fgalId, attId, id, oder src.''",
// "Draw on the Image" => "Draw on the Image",
"Include" => "Einbinden",
// "Include a portion of another wiki page" => "Include a portion of another wiki page",
// "Name of the source wiki page (which contains the included portion)" => "Name of the source wiki page (which contains the included portion)",
// "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start",
"Stop" => "Anhalten",
// "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end",
// "Read more button" => "Read more button",
// "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)" => "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)",
// "Read more button label" => "Read more button label",
// "Label of the button linking to the source page (if it is displayed)" => "Label of the button linking to the source page (if it is displayed)",
// "Text to show when the page selected to be included is not found anymore" => "Text to show when the page selected to be included is not found anymore",
// "Permission denied message" => "Permission denied message",
// "Text to show when the page exists but the user has insufficient permissions to see it" => "Text to show when the page exists but the user has insufficient permissions to see it",
// "No version approved error message" => "No version approved error message",
// "Text to show when the page exists but no version is approved" => "Text to show when the page exists but no version is approved",
// "Edit Icon" => "Edit Icon",
// "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings" => "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings",
// "Max inclusions" => "Max inclusions",
// "Maximum amount of times the same page can be included. Defaults to 5" => "Maximum amount of times the same page can be included. Defaults to 5",
// "Parse Included Page" => "Parse Included Page",
// "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents" => "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents",
// "Max characters included" => "Max characters included",
// "Limit the length of the included text" => "Limit the length of the included text",
"Read more" => "Mehr lesen",
// "The text above comes from page \"%s\". Click to go to that page" => "The text above comes from page \"%s\". Click to go to that page",
"Include Plugin" => "Include Plugin",
"Edit the included page" => "Bearbeite die eingebundene Seite",
// "Include Template File" => "Include Template File",
// "Include a Smarty template (.tpl) file in a page" => "Include a Smarty template (.tpl) file in a page",
// "TPL file name" => "TPL file name",
// "If you need to include Smarty template files" => "If you need to include Smarty template files",
// "Values passed to the TPL" => "Values passed to the TPL",
// "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1" => "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1",
// "Include URL" => "Include URL",
// "Include the body content from a URL" => "Include the body content from a URL",
// "URL to external file to include" => "URL to external file to include",
// "Missing parameter url for plugin %0" => "Missing parameter url for plugin %0",
// "Insert Tracker Item" => "Insert Tracker Item",
// "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item" => "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item",
// "Item not inserted" => "Item not inserted",
"Invite" => "Einladen",
"Invite a user to join your groups" => "Lade einen Benutzer ein, Deiner Gruppe beizutreten",
"Confirmation message after posting form" => "Bestätigungsmeldung nach Formularpost",
"Including Group" => "Einzuschließende Gruppen",
"Will list only the groups that include this group" => "Listet nur die Gruppen auf, die diese Gruppen beinhalten",
"Default Group" => "Standardgruppe",
"Dropdown list will show this group by default" => "Ausklappliste zeigt dieses Gruppe standardmäßig",
// "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default",
"The following mandatory fields are missing" => "Folgende, zwingende Felder fehlen",
"Email address" => "E-Mailadresse",
// "Add jQuery JavaScript code" => "Add jQuery JavaScript code",
"JavaScript code" => "JavaScript Code",
"Not On Ready" => "Nicht wenn fertig",
"Do not execute on document ready (execute inline)" => "Nicht ausführen, wenn das Dokument fertig ist (inline ausführen)",
"No JavaScript" => "Kein JavaScript",
"Optional markup for when JavaScript is off" => "Optionaler Markup, wenn JavaScript abgeschalten ist",
// "Language to apply JQuery to" => "Language to apply JQuery to",
"<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq plugin inactive: JavaScript off -->",
"JavaScript" => "JavaScript",
// "Add JavaScript code or files" => "Add JavaScript code or files",
"JavaScript filename" => "JavaScript Dateiname",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
"Display a video created through the Kaltura feature" => "Zeige ein Video, das mit Kaltura erstellt wurde",
"Kaltura Entry ID" => "Kaltura Eintrag-ID",
// "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one" => "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one",
// "Kaltura Video Player ID" => "Kaltura Video Player ID",
// "Width of the player in pixels or percent" => "Width of the player in pixels or percent",
// "Height of the player in pixels or percent" => "Height of the player in pixels or percent",
"Align" => "Ausrichten",
// "Alignment of the player" => "Alignment of the player",
// "Not set" => "Not set",
// "Centre" => "Centre",
// "Alignment of the player using CSS float" => "Alignment of the player using CSS float",
// "Add Media Button Label" => "Add Media Button Label",
// "Text to display on button for adding new media" => "Text to display on button for adding new media",
"Add media" => "Medium beifügen",
// "Player Type" => "Player Type",
// "Set player type" => "Set player type",
// "KDP" => "KDP",
// "HTML5" => "HTML5",
"Upload Media" => "Medien hochladen",
// "Media ID or permission to upload video is required" => "Media ID or permission to upload video is required",
// "Log in to upload video" => "Log in to upload video",
// "Player not found" => "Player not found",
// "Kaltura player: unsupported type" => "Kaltura player: unsupported type",
// "Show alternative content based on the page language" => "Show alternative content based on the page language",
// "Content to show" => "Content to show",
// "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Not Language" => "Keine Sprache",
// "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Show the last modification date for a page" => "Zeige das Datum, an dem eine Seite zuletzt verändert wurde",
"Page name to display information of. Default value is current page" => "Seitenname von der Informationen angezeigt werden. Standardmäßig die gegenwärtige Seite",
"Date format" => "Datumsformat",
// "Set date and time format according to site settings" => "Set date and time format according to site settings",
// "Long date" => "Long date",
// "Short date" => "Short date",
// "Long datetime" => "Long datetime",
// "Short datetime" => "Short datetime",
// "ISO" => "ISO",
// "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects" => "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects",
// "Display page header" => "Display page header",
// "Set to No, to hide header on the page" => "Set to No, to hide header on the page",
// "Display Page Footer" => "Display Page Footer",
// "Display Page Left Bar" => "Display Page Left Bar",
// "Set to No, to hide left on the page" => "Set to No, to hide left on the page",
// "Display Page Right Bar" => "Display Page Right Bar",
// "Set to No, to hide right on the page" => "Set to No, to hide right on the page",
// "Page Full Width" => "Page Full Width",
// "100% Page width" => "100% Page width",
// "Page Content Width" => "Page Content Width",
// "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)" => "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)",
// "Page Background Image URL" => "Page Background Image URL",
// "Enter image url, in case of single image" => "Enter image url, in case of single image",
// "Background Repear" => "Background Repear",
// "Cover,Repeat,no-repeat" => "Cover,Repeat,no-repeat",
// "Page Background Sliding Images" => "Page Background Sliding Images",
// "Enter file gallery id for fading background" => "Enter file gallery id for fading background",
// "Page Content Top Margin" => "Page Content Top Margin",
// "Enter value in % or px for example 30%, 300px, default will be 0" => "Enter value in % or px for example 30%, 300px, default will be 0",
// "Page Header Width" => "Page Header Width",
// "Enter page header width in px or %, leave blank for same width as page body.)" => "Enter page header width in px or %, leave blank for same width as page body.)",
// "Page Footer Width" => "Page Footer Width",
// "Enter page footer width in px or %, leave blank for same width as page body.)" => "Enter page footer width in px or %, leave blank for same width as page body.)",
// "Page Background Color" => "Page Background Color",
// "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)" => "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)",
// "Content Background Color" => "Content Background Color",
// "Content Text Color" => "Content Text Color",
// "Enter a valid CSS color code, for example #000,#fff,#ccc" => "Enter a valid CSS color code, for example #000,#fff,#ccc",
// "Content Border Radius" => "Content Border Radius",
// "To make content div round cornered, for example 10px" => "To make content div round cornered, for example 10px",
// "Content Border Shadow" => "Content Border Shadow",
// "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)" => "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)",
// "Transition Delay" => "Transition Delay",
// "Time interval to pause before moving to next slide in seconds" => "Time interval to pause before moving to next slide in seconds",
// "Display Page Action Buttons" => "Display Page Action Buttons",
// "Set to No, to hide page action buttons, with and under content" => "Set to No, to hide page action buttons, with and under content",
// "Display top bar(under header)" => "Display top bar(under header)",
// "Set to No, to hide topbar on the page" => "Set to No, to hide topbar on the page",
// "Display page top bar(above page content)" => "Display page top bar(above page content)",
// "Set to No, to hide page topbar module zone" => "Set to No, to hide page topbar module zone",
// "Display page bottom bar(under page content)" => "Display page bottom bar(under page content)",
// "Set to No, to hide page bottom bar module zone" => "Set to No, to hide page bottom bar module zone",
// "Create a \"Like\" button" => "Create a \"Like\" button",
// "Count only" => "Count only",
// "Sets whether to only show the count of likes rather than give the option to vote" => "Sets whether to only show the count of likes rather than give the option to vote",
// "Search for, list, and filter all types of items and display custom-formatted results" => "Search for, list, and filter all types of items and display custom-formatted results",
// "Use List GUI" => "Use List GUI",
// "Use the graphical user interface for editing this list plugin" => "Use the graphical user interface for editing this list plugin",
// "Cache Output" => "Cache Output",
// "Cache output of this list plugin" => "Cache output of this list plugin",
// "Cache Expiry Time" => "Cache Expiry Time",
// "Time before cache is expired in minutes" => "Time before cache is expired in minutes",
// "Cache Purge Rules" => "Cache Purge Rules",
// "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches" => "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches",
// "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block" => "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block",
// "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine" => "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine",
// "Error: {MULTISEARCH(id=x)} needs an ID to be specified" => "Error: {MULTISEARCH(id=x)} needs an ID to be specified",
// "List Execute" => "List Execute",
// "Set custom actions that can be executed on a filtered list of objects" => "Set custom actions that can be executed on a filtered list of objects",
// "Invalid action: %0" => "Invalid action: %0",
// "There are too many search result items to apply %0 action to" => "There are too many search result items to apply %0 action to",
// "Unknown error executing action %0 on item %1" => "Unknown error executing action %0 on item %1",
// "Error executing action %0 on item %1" => "Error executing action %0 on item %1",
// "Action %0 executed successfully on %1 item(s)" => "Action %0 executed successfully on %1 item(s)",
"List Pages" => "Seiten auflisten",
"List pages based on various criteria" => "Liste Seiten auf Basis diverser Kriterien auf",
"Result number at which the listing should start" => "Ergebniszahl, bei der die Auflistung beginnen soll",
"Limit number of items displayed in the list. Default is to display all" => "Beschränke die Zahl aufgelisteter Objekte. Standardmäßig werden alle angezeigt",
"Initial" => "Anfang",
// "Initial page to show" => "Initial page to show",
"Show Name Only" => "Zeige nur Namen",
"Show only the page names" => "Zeige nur die Seitennamen",
// "Category Filter" => "Category Filter",
// "Filter categories by Id numbers. Use different separators to filter as follows" => "Filter categories by Id numbers. Use different separators to filter as follows",
// "Page is in any of the specified categories. Example" => "Page is in any of the specified categories. Example",
// "Page must be in all of the specified categories. Example" => "Page must be in all of the specified categories. Example",
// "Page is in the first specified category and not in any of the others. Example" => "Page is in the first specified category and not in any of the others. Example",
// "Valid category ID or list separated by :, + or -" => "Valid category ID or list separated by :, + or -",
"Structure Head" => "Strukturkopf",
"Filter by structure head" => "Filtern nach Strukturkopf",
"Show Page Alias" => "Zeige Seitenalias",
"Show page alias in the list" => "Zeige Seitenalias in der Liste",
// "Include Tag" => "Include Tag",
// "Only pages with specific tag (separate tags using %0)" => "Only pages with specific tag (separate tags using %0)",
// "Exclude Tag" => "Exclude Tag",
// "Only pages with specific tag excluded (separate tags using %0)" => "Only pages with specific tag excluded (separate tags using %0)",
// "Show Number of Pages" => "Show Number of Pages",
// "Show the number of pages matching criteria" => "Show the number of pages matching criteria",
"Only pages with names similar to the text entered for this parameter will be listed" => "Es werden nur Seiten aufgelistet, deren Namen ähnlich zu dem hier eingegeben Text für diesen Parameter ist",
"Two-letter language code to filter pages listed" => "Zweibuchstabiger Sprachenbezeichnung, um die aufgelisteten Seiten zu filtern",
"Orphan Language" => "Verwaiste Sprache",
// "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed" => "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed",
"Load Translations" => "Übersetzung laden",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter",
"Page name and text entered for the filter parameter must match exactly to be listed" => "Seitenname und für den Filterparameter eingegebener Text müssen exakt übereinstimmen, um aufgelistet zu werden",
"Only Orphan Pages" => "Nur verwaiste Seiten",
"Only list orphan pages" => "Nur verwaiste Seiten auflisten",
"For List Pages" => "Für Seitenauflistung",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples" => "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples",
// "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start",
// "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end",
"Length" => "Länge",
"Number of characters to display" => "Anzahl von anzuzeigenden Zeichen",
// "Checkboxes" => "Checkboxes",
// "Offset Argument" => "Offset Argument",
"Pagination" => "Paginierung",
// "Exclude Page(s)" => "Exclude Page(s)",
// "Wiki page names to be excluded from list" => "Wiki page names to be excluded from list",
// "Local Files" => "Local Files",
// "Show a link to local or shared files and directories" => "Show a link to local or shared files and directories",
// "Local file or directory path" => "Local file or directory path",
"List Directory" => "Verzeichnis auflisten",
// "If the path above is a directory then list the contents" => "If the path above is a directory then list the contents",
// "Show MIME file-type icons" => "Show MIME file-type icons",
// "List files in a directory" => "List files in a directory",
"Full path to the server-local directory. Default is the document root" => "Voller Pfad zum lokalen Verzeichnis des Servers. Standard: Dokumentenstammverzeichnis",
"URL Prefix" => "URL Präfix",
// "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example" => "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example",
"Set the sort order of the file list" => "Lege Sortierreihenfolge der Liste fest",
"File Name" => "Dateiname",
"File Size" => "Dateigröße",
"Last Access" => "Letzter Zugriff",
"Last Metadata Change" => "Letzte Änderung der Metadaten",
// "Only list files with file names that contain this filter. Example" => "Only list files with file names that contain this filter. Example",
"Limit" => "Limit",
"Maximum amount of files to display. Default is no limit" => "Maximale Anzahl anzuzeigendes Dateien. Standardmäßig keine Beschränkung",
"could not be opened because it doesn't exist or permission was denied" => "konnte nicht geöffnet werden, weil es nicht existiert oder der Zugriff verweigert wurde",
"Mail" => "E-Mail",
// "Mail other users or groups" => "Mail other users or groups",
"Limit the list of groups to the groups including each group" => "Beschränke die Liste der Gruppen auf die Gruppen einschließlich jeder Gruppe",
// "Group Dropdown" => "Group Dropdown",
"Show a dropdown list of groups (not shown by default)" => "Zeigt ein ausklappbares Listenfeld der Gruppen (wird standardmäßig nicht gezeigt)",
// "Recurse Groups" => "Recurse Groups",
// "Show each group and each group included in this group" => "Show each group and each group included in this group",
// "Recurse Group Users" => "Recurse Group Users",
// "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times..." => "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times...",
// "User Dropdown" => "User Dropdown",
"Show a dropdown list of users (not shown by default)" => "Zeigt ein ausklappbares Listenfeld der Benutzer (wird standardmäßig nicht gezeigt)",
// "User Emails" => "User Emails",
// "Show a box for user to enter email addresses" => "Show a box for user to enter email addresses",
"Real Name Dropdown" => "Echtnamen Ausklapplistenfeld",
"Show a dropdown list of user real names (not shown by default)" => "Zeigt ein ausklappbares Listenfeld der Echtnamen (wird standardmäßig nicht gezeigt)",
// "Show in popup instead of inline" => "Show in popup instead of inline",
// "Text to show on the button to send emails (default: %0Send mail%1)" => "Text to show on the button to send emails (default: %0Send mail%1)",
// "Send mail" => "Send mail",
// "Email Subject" => "Email Subject",
// "Present Email subject content" => "Present Email subject content",
// "Bypass Preview" => "Bypass Preview",
// "Send emails without first previewing" => "Send emails without first previewing",
// "Debug mode (admins only)" => "Debug mode (admins only)",
// "Show list of emails that are sent (admins only)" => "Show list of emails that are sent (admins only)",
// "Mail send was unsuccessful" => "Mail send was unsuccessful",
"Map" => "Karte",
"Display a map" => "Zeige eine Karte",
"Instructions to load content" => "Anleitung, um Inhalte zu laden",
"Scope" => "Bereich",
// "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1" => "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1",
"Controls" => "Steuerelemente",
// "Comma-separated list of map controls will be displayed on the map and around it" => "Comma-separated list of map controls will be displayed on the map and around it",
"Width of the map in pixels" => "Breite der Karte in Pixel",
"Height of the map in pixels" => "Höhe der Karte in Pixel",
// "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1" => "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1",
// "Popup Style" => "Popup Style",
// "Alter the way the information is displayed when objects are loaded on the map" => "Alter the way the information is displayed when objects are loaded on the map",
// "Bubble" => "Bubble",
"MapServer File" => "MapServer Datei",
"MapServer file identifier. Only fill this in if you are using MapServer" => "MapServer Datei-ID. Nur eintragen, wenn Du den MapServer benutzt",
"Extents" => "Ausdehnungen",
"Size of the map" => "Größe der Karte",
// "Show item name in a tooltip on hover" => "Show item name in a tooltip on hover",
// "Open Layers Version" => "Open Layers Version",
// "OL2 or OL3+ so far (default ol2)" => "OL2 or OL3+ so far (default ol2)",
// "OpenLayers 2.x" => "OpenLayers 2.x",
// "Tileset layers" => "Tileset layers",
// "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)" => "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)",
// "Cluster Distance" => "Cluster Distance",
// "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)" => "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)",
// "Cluster Hover Behavior" => "Cluster Hover Behavior",
// "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)" => "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)",
// "Show Features" => "Show Features",
// "Cluster Fill Color" => "Cluster Fill Color",
// "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)" => "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)",
// "Cluster Text Color" => "Cluster Text Color",
// "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)" => "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)",
// "Color Picker" => "Color Picker",
// "Markdown" => "Markdown",
// "Parse the body of the plugin using a Markdown parser" => "Parse the body of the plugin using a Markdown parser",
// "Markdown syntax to be parsed" => "Markdown syntax to be parsed",
"Mayan Calendars" => "Mayakalender",
"Convert a Gregorian date to a Mayan calendar date" => "Konvertiere ein gregorianisches Datum in ein Datum des Mayakalender",
"You must use the variable substitution" => "Du musst die Variablenersetzung benutzen",
"LongCount: " => "LongCount: ",
"Tzolkin: " => "Tzolkin: ",
"Haab: " => "Haab: ",
"Misc: " => "Versch.: ",
"Example: template " => "Beispiel: Vorlage ",
// "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
"Default template: " => "Standardvorlage: ",
"Gregorian date" => "Gregorianisches Datum",
// "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date" => "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date",
" is not a valid date format. should be dd.mm.yyyy" => " ist kein gültiges Datumsformat. Es sollte sein TT.MM.JJJJ",
"Media Player" => "Mediaplayer",
"Add a media player to a page" => "Füge einen Mediaplayer zu einer Seite hinzu",
"Allow full-screen" => "Vollbild erlauben",
"Allow full-screen mode" => "Vollbildmodus erlauben",
"MP3 URL" => "MP3 URL",
"FLV URL" => "FLV URL",
// "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled" => "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled",
// "Player width in px or %" => "Player width in px or %",
// "Player height in px or %" => "Player height in px or %",
// "Set the style" => "Set the style",
"Media Type" => "Medientyp",
// "Media type for HTML5" => "Media type for HTML5",
// "Audio" => "Audio",
"Video" => "Videostreaming-Integration",
"Flash Window Mode" => "Flash Fenster-Modus",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: ",
"Transparent" => "Transparent",
"Opaque" => "Blickdicht",
"Window" => "Fenster",
// "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)" => "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)",
// "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)" => "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)",
// "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below" => "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below",
// "Download file" => "Download file",
"Member List" => "Mitgliederliste",
"List and allow editing of group members" => "Liste und erlaube Bearbeiten von Gruppenmitgliedern",
// "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated" => "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated",
// "Descriptions" => "Descriptions",
"Display group descriptions below list name" => "Zeige die Gruppenbeschreibung unterhalb des Listennamens",
"How to show the member lists" => "Wie Mitgliederliste angezeigt werden soll",
"Maximum" => "Maximum",
// "Maximum number of users to list in each group (default %0100%1)" => "Maximum number of users to list in each group (default %0100%1)",
"Members Only" => "Nur Mitglieder",
// "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user" => "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user",
"Sort mode" => "Sortiermodus",
"Sort mode for member listing" => "Sortiermodus für die Auflistung von Mitgliedern",
"Read only mode. All ability to modify membership is hidden" => "Nur-Lese-Modus. Alle Möglichkeiten zur Bearbeitung der Mitgliedschaft sind versteckt",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
"Required" => "Erforderlich",
"Only groups including the group that you specify will be listed" => "Nur Gruppen, die die von Dir angegebene Gruppe beinhaltet werden aufgelistet",
// "Notify Added User" => "Notify Added User",
// "Notify Removed User" => "Notify Removed User",
// "Email notification to removed user" => "Email notification to removed user",
// "Need Approval" => "Need Approval",
// "Add approve/reject user buttons for private addon groups" => "Add approve/reject user buttons for private addon groups",
"Member Payment" => "Mitgliederbezahlung",
// "Receive payment from a member to extend membership to a group" => "Receive payment from a member to extend membership to a group",
"Name of the group for which the subscription should be added or extended" => "Gruppenname, für welche die Mitgliedschaft hinzugefügt oder verlängert werden soll",
"Price per period (%0)" => "Preis pro Zeiteinheit (%0)",
"Current User Member" => "Gegenwärtiger Benutzer Mitglied",
"Membership only for the current user" => "Mitgliedschaft nur für den gegenwärtigen Benutzer",
"Input Title" => "Eingabetitel",
// "Title of the initial input form" => "Title of the initial input form",
// "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years" => "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years",
"Supports wiki syntax" => "Unterstützt Wikisyntax",
// "Input Title Only" => "Input Title Only",
// "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well" => "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well",
// "Initial Payment Form Title" => "Initial Payment Form Title",
// "Add a title to the payment form when initially shown after clicking \"Continue\"" => "Add a title to the payment form when initially shown after clicking \"Continue\"",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years",
// "Payment Form Title Only" => "Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well",
// "Subsequent Payment Form Title" => "Subsequent Payment Form Title",
// "Title of the payment form after the initial showing" => "Title of the payment form after the initial showing",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years",
// "Subsequent Payment Form Title Only" => "Subsequent Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well",
// "Prevent Double Request" => "Prevent Double Request",
"Prevent user from extended if there is already a pending request" => "Verhindere Verlängerung, wenn bereits eine anhängige Anfrage vorhanden ist",
// "Free Periods" => "Free Periods",
// "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought",
// "Hide Period" => "Hide Period",
// "Do not allow user to set period - use default of 1" => "Do not allow user to set period - use default of 1",
"Periods Label" => "Periodenbezeichnung",
// "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)" => "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)",
// "Page that payment service returns to after processing" => "Page that payment service returns to after processing",
// "Annual, commencing %0 %1 each year" => "Annual, commencing %0 %1 each year",
// "Monthly, commencing on day %0 each month" => "Monthly, commencing on day %0 each month",
"The user " => "Der Benutzer ",
" already has a pending extension request payment invoice " => " hat bereits eine Rechnung über die Verlängerung ",
// "%0 to %1 %2 for %3" => "%0 to %1 %2 for %3",
// "periods" => "periods",
// "period" => "period",
// "Membership to %0 for %1 users for %2 %3" => "Membership to %0 for %1 users for %2 %3",
"The group " => "Die Gruppe ",
" does not have a membership term" => " hat keine Mitgliedschaftsdauer",
" Go to " => " Gehe zu ",
"Admin > Groups" => "Verwalten > Gruppen",
" to specify a term for this group by automatically unassigning users after a certain number of days" => " um eine Dauer für diese Gruppe durch automatisches Entfernen von Benutzern nach einer bestimmten Anzahl von Tagen festzulegen",
" does not exist" => " existiert nicht",
// "MetaTag" => "MetaTag",
// "Add custom meta tags to the HTML head section of the page where the plugin is used" => "Add custom meta tags to the HTML head section of the page where the plugin is used",
// "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here" => "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here",
// "Name attribute of the meta tag" => "Name attribute of the meta tag",
// "Content attribute of the meta tag" => "Content attribute of the meta tag",
"Mini Quiz" => "Mini Quiz",
"Create a quiz using a tracker" => "Erstelle ein Quiz mit einem Tracker",
"Instructions::Feedback" => "Instruktionen::Rückmeldung",
"Numeric value representing the miniquiz tracker ID" => "Numerischer Wert für die Miniquiz Tracker-ID",
"Module" => "Modul",
"Display a module" => "Zeige ein Modul",
"Module Name" => "Modulname",
"Module name as known in Tiki" => "Modulname wie in Tiki bekannt",
// "Select Yes (%0y%1) to hide the title (default is to show the title)" => "Select Yes (%0y%1) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)" => "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)",
"Align the module to the left or right on the page allowing other elements to align against it" => "Modul links oder rechts anordnen, so dass anderen Elementen erlaubt wird, sich daran ausrichtend, anzuordnen",
// "Number of rows (default: %010%1)" => "Number of rows (default: %010%1)",
"Parse" => "Parsen",
"Parse wiki syntax" => "Parse Wiki-Syntax",
"Default:" => "Voreingestellt:",
"Show only the content with no title or borders, etc. around the content" => "Zeige nur den Inhalt ohne eine umgebende Box",
"Title, background, etc" => "Dekoration",
"Show module title (heading) background, etc. (default is to show them)" => "Zeige Boxdekoration (werden standardmäßig angezeigt)",
// "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)" => "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)",
"Title Background" => "Titelhintergrund",
// "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)" => "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)",
"Module Style" => "Modul-Stil",
// "Inline CSS for the containing div element, for example, %0max-width:80%%1" => "Inline CSS for the containing div element, for example, %0max-width:80%%1",
// "Valid CSS styling" => "Valid CSS styling",
"CSS styling for the module data itself" => "CSS-Styling für die Moduldaten selbst",
"Custom CSS class." => "Benutzerdefinierte CSS-Klasse",
// "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons",
// "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above",
// "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated" => "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated",
// "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module",
"Please choose a module" => "Bitte ein Modul wählen",
"to be used as argument" => "als Argument zu verwenden",
"Sorry, no such module" => "Kein solches Modul vorhanden",
// "Module List" => "Module List",
// "Display the modules assigned to a zone" => "Display the modules assigned to a zone",
// "Zone Name" => "Zone Name",
// "The name of the module zone to include. Can be a custom zone name" => "The name of the module zone to include. Can be a custom zone name",
// "Top bar" => "Top bar",
// "Page top" => "Page top",
// "Page bottom" => "Page bottom",
"Monospace" => "Nichtproportionale Schrift",
"Display text in a monospace font" => "Zeige Text in nichtproportionaler Schrift",
// "Text that the font will be applied to" => "Text that the font will be applied to",
"Font name as recognized by browsers" => "Schriftartname, wie den Browsern bekannt",
"Mouseover" => "Mouseover",
// "Display hidden content by mousing over text" => "Display hidden content by mousing over text",
"Hidden content, unless the label parameter is undefined, in which case this is the label" => "Versteckter Inhalt. Es sei denn der Bezeichnungsparameter ist nicht definiert, dann ist dies die Bezeichnung",
"Text displayed on the page. The body is the hidden content" => "Auf der Seite angezeigter Text. Der Hauptteil ist der versteckte Text",
"Destination link when mouseover text is clicked. Use http:// for external links" => "Ziellink, wenn der Mouseover-Text angeklickt wird. Benutze http:// für externe Links",
"DEPRECATED" => "ABGELEHNT",
"Hidden content. The body contains the label" => "Verdeckter Inhalt. Der Hauptteil enthält die Bezeichnung",
// "Mouseover box width. Default: %0400px%1" => "Mouseover box width. Default: %0400px%1",
// "Mouseover box height. Default: %0200px%1" => "Mouseover box height. Default: %0200px%1",
"Offset X" => "Versatz X",
// "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1" => "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1",
"Offset Y" => "Versatz Y",
// "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1" => "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1",
"Parse Body" => "Parse Hauptteil",
"Parse the body of the plugin as wiki content (parsed by default)" => "Parse den Hauptteil als Wiki Inhalt (standardmäßig wird geparst)",
"Parse Label" => "Parse Bezeichnung",
"Parse the label as wiki content (parsed by default)" => "Parse die Bezeichnung als Wiki Inhalt (standardmäßig wird geparst)",
"CSS class to apply" => "Anzuwendende CSS-Klasse",
"Background color to apply to the popup" => "Hintergrundfarbe für das Popup",
"Text Color" => "Textfarbe",
"Color to apply to the text in the popup" => "Textfarbe für das Popup",
"Sticky" => "sticky",
"When enabled, popup stays visible until it is clicked" => "Wenn aktiviert, bleibt das Popup sichtbar, bis es angeklickt wird",
"Padding" => "Innenabstand",
"Padding size in pixels" => "Größe Innenabstand in Pixel",
"Effect" => "Effekt",
"Set the type of show/hide animation that will be used" => "Stelle ein, welche Art der Anzeigen-/Versteckenanimation benutzt wird",
"Effect Speed" => "Effektgeschwindigkeit",
"Set the speed of the animation" => "Stelle die Geschwindigkeit der Animation ein",
"Close Delay" => "Verzögerung beim Schließen",
"Number of seconds before popup closes" => "Anzahl von Sekunden, nach denen das Popup geschlossen wird",
// "HTML tag to use for the label. Default %0a%1" => "HTML tag to use for the label. Default %0a%1",
"No label specified" => "Keine Bezeichnung angegeben",
"MediaWiki Table" => "MediaWiki Tabelle",
// "Display a table using MediaWiki syntax" => "Display a table using MediaWiki syntax",
"Fancy" => "Ausgefallen",
// "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter" => "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter",
"True" => "Wahr",
"False" => "Falsch",
"Wiki Classes" => "Wiki Klassen",
// "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)" => "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)",
"MySpace" => "MySpace",
"Display a MySpace Flash mp3 playlist" => "Zeige eine MySpace Flash MP3 Playliste",
"MySpace Page" => "MySpace Seite",
"MySpace page name" => "MySpace Seitenname",
// "Network condition" => "Network condition",
// "Display content based on the user's IP address" => "Display content based on the user's IP address",
// "Content to display conditionally" => "Content to display conditionally",
// "IPv4 List" => "IPv4 List",
// "Comma-separated list of IPv4 addresses to match against the visitor's address" => "Comma-separated list of IPv4 addresses to match against the visitor's address",
"Now" => "Jetzt",
// "Show the current date and time" => "Show the current date and time",
// "Time format using the PHP format described here: %0" => "Time format using the PHP format described here: %0",
// "Based site long date and time setting" => "Based site long date and time setting",
// "Date to display" => "Date to display",
// "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0" => "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0",
// "Allow Invalid Dates" => "Allow Invalid Dates",
// "Allow return values that are not a valid date, such as the day of the month" => "Allow return values that are not a valid date, such as the day of the month",
// "Plugin now when parameter not valid. %0" => "Plugin now when parameter not valid. %0",
"Object Hits" => "Objekttreffer",
"Display the number of hits for certain objects" => "Zeige die Anzahl der Treffer für ein bestimmtes Objekt",
// "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title" => "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1" => "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1",
// "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits" => "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits",
// "Since a date" => "Since a date",
// "Date since the hits are collected in a format supported by strtotime" => "Date since the hits are collected in a format supported by strtotime",
// "Display a link to an object" => "Display a link to an object",
// "The object type" => "The object type",
// "The item to display" => "The item to display",
// "Tiki Package View" => "Tiki Package View",
// "Display the output of a Tiki Package View" => "Display the output of a Tiki Package View",
// "Package Name" => "Package Name",
// "Name of package in the form %0vendor/name%1" => "Name of package in the form %0vendor/name%1",
// "Name of the view" => "Name of the view",
// "Name of the view file without the %0.php%1" => "Name of the view file without the %0.php%1",
"Page Tabs" => "Seiten-Tabs",
"PluginPageTabs" => "PluginPageTabs",
// "Display the content of a wiki page in a set of tabs" => "Display the content of a wiki page in a set of tabs",
"Wiki page names" => "Wiki Seitennamen",
// "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent",
"Parameter" => "Parameter",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met",
// "Names of parameters required to display text, separated by %0|%1" => "Names of parameters required to display text, separated by %0|%1",
// "Source where the parameter is checked" => "Source where the parameter is checked",
// "REQUEST" => "REQUEST",
// "GET" => "GET",
// "POST" => "POST",
// "COOKIE" => "COOKIE",
// "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"" => "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"",
"Show the details of a payment request or invoice." => "Zeige Details zu einer Bezahlungsanfrage oder Rechnung",
"Payment Request Number" => "Nummer Zahlungsanfrage",
"Unique identifier of the payment request" => "Einzigartige Kennung (ID) des Bezahlungsanfrage",
// "Payment List" => "Payment List",
// "Show details of payments. The payments considered may be restrained by user or date" => "Show details of payments. The payments considered may be restrained by user or date",
// "Payment type" => "Payment type",
"Outstanding" => "Ausstehend",
"Overdue" => "Überfällig",
// "Authorized" => "Authorized",
// "Output format" => "Output format",
"Total" => "Gesamt",
// "JSON (for advanced custom usage)" => "JSON (for advanced custom usage)",
// "Payments by a particular user" => "Payments by a particular user",
// "Payer email" => "Payer email",
// "Date range start, accepts most date formats" => "Date range start, accepts most date formats",
// "Date range end" => "Date range end",
// "Advanced filter" => "Advanced filter",
// "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)" => "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)",
// "List offset" => "List offset",
// "For pagination" => "For pagination",
// "Payments per page" => "Payments per page",
// "Automatic (newest first)" => "Automatic (newest first)",
// "User A to Z" => "User A to Z",
// "User Z to A" => "User Z to A",
// "Amount low to high" => "Amount low to high",
// "Amount high to low" => "Amount high to low",
// "Payment: oldest first" => "Payment: oldest first",
// "Payment: newest first" => "Payment: newest first",
// "Request: oldest first" => "Request: oldest first",
// "Request: newest first" => "Request: newest first",
// "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter" => "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter",
// "Plugin paymentlist: Unrecognised type \"%0\"" => "Plugin paymentlist: Unrecognised type \"%0\"",
// "No payments found" => "No payments found",
// "Payments by anonymous where the payer's email is recorded" => "Payments by anonymous where the payer's email is recorded",
// "PayPal Button" => "PayPal Button",
// "Embed a PayPal button" => "Embed a PayPal button",
// "Type of PayPal button" => "Type of PayPal button",
// "Shopping cart" => "Shopping cart",
// "Buy Now" => "Buy Now",
// "Donations" => "Donations",
// "Cart Action" => "Cart Action",
"Action if Shopping Cart selected for type" => "Vorgang, wenn Einkaufswagen (shopping cart) als Typus ausgewählt wird",
"Add to Cart" => "Zum Einkauf (cart) dazufügen",
// "View Cart" => "View Cart",
// "Item Name" => "Item Name",
// "Item name or description. Required for Shopping cart" => "Item name or description. Required for Shopping cart",
// "Item price" => "Item price",
// "Button appearance" => "Button appearance",
"Smaller" => "Kleiner",
"Custom" => "Benutzerdefiniert",
// "Custom Button" => "Custom Button",
// "Custom button image URL" => "Custom button image URL",
// "Optional item identifier, often a tracker itemId" => "Optional item identifier, often a tracker itemId",
// "Number of items, empty or 0 to have an input the user can fill in" => "Number of items, empty or 0 to have an input the user can fill in",
// "Shipping Cost" => "Shipping Cost",
// "The cost of shipping this item" => "The cost of shipping this item",
"Additional Shipping Cost" => "Zusätzliche Transportkosten",
// "The cost of shipping each additional unit of this item" => "The cost of shipping each additional unit of this item",
// "Weight of item" => "Weight of item",
// "Weight Unit" => "Weight Unit",
// "The unit of measure if weight is specified" => "The unit of measure if weight is specified",
// "Kilos" => "Kilos",
// "Pounds" => "Pounds",
// "Business ID" => "Business ID",
// "PayPal business name/ID" => "PayPal business name/ID",
// "(Uses value in admin/payment if not set here)" => "(Uses value in admin/payment if not set here)",
// "Use MiniCart" => "Use MiniCart",
// "See https://github.com/jeffharrell/MiniCart" => "See https://github.com/jeffharrell/MiniCart",
// "Shipping Address Prompt" => "Shipping Address Prompt",
// "Indicate whether to prompt for and require an address" => "Indicate whether to prompt for and require an address",
// "Prompt for address" => "Prompt for address",
// "Do not prompt for address" => "Do not prompt for address",
// "Prompt for and require address" => "Prompt for and require address",
// "Completed payment return URL" => "Completed payment return URL",
// "Empty for current page, %0n%1 to disable" => "Empty for current page, %0n%1 to disable",
// "Continue Shopping URL" => "Continue Shopping URL",
// "Cancel payment URL" => "Cancel payment URL",
// "Form title" => "Form title",
// "Tooltip for the form and alt attribute for the image" => "Tooltip for the form and alt attribute for the image",
// "PayPal — The safer, easier way to pay online" => "PayPal — The safer, easier way to pay online",
// "Button text" => "Button text",
// "The checkout button text" => "The checkout button text",
// "Subtotal text" => "Subtotal text",
// "The subtotal text" => "The subtotal text",
// "Discount text" => "Discount text",
// "The discount text" => "The discount text",
// "Shipping text" => "Shipping text",
// "The shipping text" => "The shipping text",
// "Processing text" => "Processing text",
// "The processing text" => "The processing text",
// "PayPal button" => "PayPal button",
// "Item name (item_name) required" => "Item name (item_name) required",
// "Price (amount) required" => "Price (amount) required",
// "For customized PDF generation, to override global PDF settings" => "For customized PDF generation, to override global PDF settings",
// "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\" => "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\",
// "Generate table of contents" => "Generate table of contents",
// "Set if table of contents will be autogenerated before PDF content" => "Set if table of contents will be autogenerated before PDF content",
// "Link TOC headings with content on PDF document" => "Link TOC headings with content on PDF document",
// "Heading to be appeared before table of content is printed" => "Heading to be appeared before table of content is printed",
// "TOC levels" => "TOC levels",
// "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>" => "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>",
// "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page" => "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page",
// "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page" => "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page",
// "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly" => "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly",
// "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly" => "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly",
// "Generate PDF Bookmarks" => "Generate PDF Bookmarks",
// "Values H1-H6,separated by | <code>For example H1|H2|H3</code>" => "Values H1-H6,separated by | <code>For example H1|H2|H3</code>",
// "Secure confidential PDF with password, leave blank if password protected is not needed" => "Secure confidential PDF with password, leave blank if password protected is not needed",
// "Watermark text value, for example: Confidential, Draft etc. " => "Watermark text value, for example: Confidential, Draft etc. ",
// "Watermark image, enter full URL" => "Watermark image, enter full URL",
// "Full URL of watermark image" => "Full URL of watermark image",
// "Page background color" => "Page background color",
// "Page background image" => "Page background image",
// "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>" => "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>",
// "For pluginPDF, please select mpdf as default PDF engine from Print Settings" => "For pluginPDF, please select mpdf as default PDF engine from Print Settings",
// "Manual bookmark entry for a PDF file" => "Manual bookmark entry for a PDF file",
// "Bookmark Label" => "Bookmark Label",
// "Bookmark level" => "Bookmark level",
// "Insert page with new settings in PDF" => "Insert page with new settings in PDF",
// "Page Content" => "Page Content",
// "PDF page header text" => "PDF page header text",
// "PDF page footer text" => "PDF page footer text",
// "Watermark text for this page. Set value as \"off\", to turn off watermark of the page" => "Watermark text for this page. Set value as \"off\", to turn off watermark of the page",
// "Watermark text value, for example: Confidential, Draft etc" => "Watermark text value, for example: Confidential, Draft etc",
// "Watermark image, enter full url" => "Watermark image, enter full url",
// "To turn off watermark image on the page, set value as <code>off</code>" => "To turn off watermark image on the page, set value as <code>off</code>",
// "PluginPDF Page Break" => "PluginPDF Page Break",
// "Helpful to format PDF files created, plugin adds page break in PDF file generated" => "Helpful to format PDF files created, plugin adds page break in PDF file generated",
"Display content based on permission settings" => "Zeige Inhalte basierend auf Berechtigungen",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions",
"Possible Permissions" => "Möglliche Berechtigungen",
// "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext" => "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext",
"Forbidden Permissions" => "Verbotene Berechtigungen",
// "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show" => "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show",
"Global" => "global",
// "Indicate whether the permissions are global or local to the object" => "Indicate whether the permissions are global or local to the object",
// "Display content based on the user's current perspective" => "Display content based on the user's current perspective",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition",
"Allowed Perspectives" => "Erlaubte Perspektiven",
"Pipe-separated list of identifiers of perspectives in which the block is shown" => "Mit Senkrechtstrichen getrennte Liste von Kennungen (IDs) von Perspektiven, in welchen der Block angezeigt wird",
"Denied Perspectives" => "Abgelehnte Perspektiven",
// "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown" => "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown",
// "Pivot table" => "Pivot table",
// "Create and display data in pivot table for reporting" => "Create and display data in pivot table for reporting",
// "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on" => "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on",
// "Data source" => "Data source",
// "Override item permissions" => "Override item permissions",
// "Return all tracker items ignoring permissions to view the corresponding items" => "Return all tracker items ignoring permissions to view the corresponding items",
// "Width of pivot table. Units: % or px" => "Width of pivot table. Units: % or px",
// "Height of pivot table. Units: px" => "Height of pivot table. Units: px",
// "Pivot table Rows" => "Pivot table Rows",
// "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. " => "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. ",
// "Use permanentNames in case of tracker fields" => "Use permanentNames in case of tracker fields",
// "Separated by colon (:) if more than one" => "Separated by colon (:) if more than one",
// "Pivot table Columns" => "Pivot table Columns",
// "Which field or fields to use as table columns. Leaving blank will use the first available field" => "Which field or fields to use as table columns. Leaving blank will use the first available field",
// "Values used to decide what heatmapColors to use" => "Values used to decide what heatmapColors to use",
// "Color for each heatmapDomain value" => "Color for each heatmapDomain value",
// "Renderer Name" => "Renderer Name",
// "Display format of data" => "Display format of data",
// "Table Barchart" => "Table Barchart",
// "Heatmap" => "Heatmap",
// "Row Heatmap" => "Row Heatmap",
// "Col Heatmap" => "Col Heatmap",
// "Line Chart" => "Line Chart",
// "Bar Chart" => "Bar Chart",
// "Overlay Bar Chart" => "Overlay Bar Chart",
// "Stacked Bar Chart" => "Stacked Bar Chart",
// "Relative Bar Chart" => "Relative Bar Chart",
// "Boxplot Chart" => "Boxplot Chart",
// "Horizontal Boxplot Chart" => "Horizontal Boxplot Chart",
// "Area Chart" => "Area Chart",
// "Histogram" => "Histogram",
// "Density Histogram" => "Density Histogram",
// "Percent Histogram" => "Percent Histogram",
// "Probability Histogram" => "Probability Histogram",
// "Density Histogram Horizontal" => "Density Histogram Horizontal",
// "Percent Histogram Horizontal" => "Percent Histogram Horizontal",
// "Probability Histogram Horizontal" => "Probability Histogram Horizontal",
// "Horizontal Histogram" => "Horizontal Histogram",
// "Histogram2D" => "Histogram2D",
// "Density Histogram2D" => "Density Histogram2D",
// "Percent Histogram2D" => "Percent Histogram2D",
// "Probability Histogram2D" => "Probability Histogram2D",
// "Density Histogram2D Horizontal" => "Density Histogram2D Horizontal",
// "Percent Histogram2D Horizontal" => "Percent Histogram2D Horizontal",
// "Probability Histogram2D Horizontal" => "Probability Histogram2D Horizontal",
// "Horizontal Histogram2D" => "Horizontal Histogram2D",
// "Scatter Chart" => "Scatter Chart",
// "Treemap" => "Treemap",
// "Aggregator Name" => "Aggregator Name",
// "Function to apply on the numeric values from the variables selected" => "Function to apply on the numeric values from the variables selected",
// "Count Unique Values" => "Count Unique Values",
// "List Unique Values" => "List Unique Values",
// "Sum" => "Sum",
// "Integer Sum" => "Integer Sum",
// "Minimum" => "Minimum",
// "Sum over Sum" => "Sum over Sum",
// "80% Upper Bound" => "80% Upper Bound",
// "80% Lower Bound" => "80% Lower Bound",
// "Sum as Fraction of Total" => "Sum as Fraction of Total",
// "Sum as Fraction of Rows" => "Sum as Fraction of Rows",
// "Sum as Fraction of Columns" => "Sum as Fraction of Columns",
// "Count as Fraction of Total" => "Count as Fraction of Total",
// "Count as Fraction of Rows" => "Count as Fraction of Rows",
// "Count as Fraction of Columns" => "Count as Fraction of Columns",
"Values" => "Werte",
// "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts" => "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts",
// "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function" => "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function",
// "Inclusions" => "Inclusions",
// "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings" => "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings",
// "Filter list limit" => "Filter list limit",
// "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row" => "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row",
// "Aggregate details" => "Aggregate details",
// "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string" => "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string",
// "Highlight my items" => "Highlight my items",
// "Highlight owned items' values in Charts" => "Highlight owned items' values in Charts",
// "Highlight my group items" => "Highlight my group items",
// "Highlight items' values belonging to one of my groups in Charts" => "Highlight items' values belonging to one of my groups in Charts",
// "Color for each highlighted group items" => "Color for each highlighted group items",
// "xAxis label" => "xAxis label",
// "Override label of horizontal axis when using Chart renderers" => "Override label of horizontal axis when using Chart renderers",
// "yAxis label" => "yAxis label",
// "Override label of vertical axis when using Chart renderers" => "Override label of vertical axis when using Chart renderers",
// "Chart title" => "Chart title",
// "Override title when using Chart renderers" => "Override title when using Chart renderers",
// "Chart hover bar" => "Chart hover bar",
// "Display the Chart hover bar or not" => "Display the Chart hover bar or not",
// "Translate displayed data" => "Translate displayed data",
// "Use translated data values for calculations and display" => "Use translated data values for calculations and display",
// "Default value: No" => "Default value: No",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>",
// "Missing data parameter with format: source:ID, e.g. tracker:1" => "Missing data parameter with format: source:ID, e.g. tracker:1",
// "Error data parameter" => "Error data parameter",
// "You do not have rights to view tracker data" => "You do not have rights to view tracker data",
// "Unified search index not found" => "Unified search index not found",
// "Split wiki modifier should specify a field" => "Split wiki modifier should specify a field",
// "For example 'tracker:1' or 'activitystream'" => "For example 'tracker:1' or 'activitystream'",
// "Piwik" => "Piwik",
// "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter" => "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter",
// "Piwik server url" => "Piwik server url",
// "The url to your Piwik Server, where data for the report are collected and available" => "The url to your Piwik Server, where data for the report are collected and available",
// "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users" => "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users",
// "The ID of this website in Piwik To be improved" => "The ID of this website in Piwik To be improved",
// "Module and Action To Widgetize" => "Module and Action To Widgetize",
// "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma" => "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma",
// "Actions - Pages" => "Actions - Pages",
// "Actions - Entry pages" => "Actions - Entry pages",
// "Actions - Exit pages" => "Actions - Exit pages",
// "Actions - Outlinks" => "Actions - Outlinks",
// "Dashboard" => "Dashboard",
// "Live - Visitor in real time" => "Live - Visitor in real time",
// "Live - Simple Last Visit Count" => "Live - Simple Last Visit Count",
// "Live - Visitor Profile Popup" => "Live - Visitor Profile Popup",
// "Referrers - All referrers" => "Referrers - All referrers",
// "Referrers - Search engines" => "Referrers - Search engines",
// "Resolution - Screen Resolution" => "Resolution - Screen Resolution",
// "SEO - SEO Ranking (slow)" => "SEO - SEO Ranking (slow)",
// "User Country Map - RealTime Map" => "User Country Map - RealTime Map",
// "User Country Map - Visitor Map" => "User Country Map - Visitor Map",
// "User Country Map - Country" => "User Country Map - Country",
// "User Country Map - Continent" => "User Country Map - Continent",
// "User Language - Language" => "User Language - Language",
// "User Language - Language Code" => "User Language - Language Code",
// "Visits Time - By day of the week" => "Visits Time - By day of the week",
// "Visits Time - Visit Information Per Local Time" => "Visits Time - Visit Information Per Local Time",
// "Visits Time - Visit Information Per Server Time" => "Visits Time - Visit Information Per Server Time",
// "Visits Summary - by day of the week" => "Visits Summary - by day of the week",
// "Visits Summary - over time" => "Visits Summary - over time",
// "Visits Summary - overview with graph" => "Visits Summary - overview with graph",
// "Visitors - Visitor map" => "Visitors - Visitor map",
// "Visitors - Pages per visit" => "Visitors - Pages per visit",
// "Visitors - Frequency overview" => "Visitors - Frequency overview",
// "Visitors - Returning visits over time" => "Visitors - Returning visits over time",
// "Visitor Devices - Device type" => "Visitor Devices - Device type",
// "Visitor Devices - browser" => "Visitor Devices - browser",
// "Visitor Devices - Browser Versions" => "Visitor Devices - Browser Versions",
// "Visitor Devices - OS Families" => "Visitor Devices - OS Families",
// "Visitor Devices - OS Versions" => "Visitor Devices - OS Versions",
// "Visitor Interest - Number Of Visits Per Visit Duration" => "Visitor Interest - Number Of Visits Per Visit Duration",
// "Visitor Interest - Number Of Visits Per Page" => "Visitor Interest - Number Of Visits Per Page",
// "Visitor Interest - Number Of Visits By Visit Count" => "Visitor Interest - Number Of Visits By Visit Count",
// "Visitor Interest - Number Of Visits By Days Since Last" => "Visitor Interest - Number Of Visits By Days Since Last",
// "Visitor Setting - Screen resolution" => "Visitor Setting - Screen resolution",
// "Statistics period" => "Statistics period",
// "Data display duration. If range is selected you must enter the start and end the date" => "Data display duration. If range is selected you must enter the start and end the date",
"Range" => "Bereich",
// "Date or Start date" => "Date or Start date",
// "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd" => "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd",
// "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)" => "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)",
// "Module width" => "Module width",
// "Optional, width of the module in px or % (100% by default)" => "Optional, width of the module in px or % (100% by default)",
// "Module height" => "Module height",
// "Optional, height of the module in px" => "Optional, height of the module in px",
// "Iframe Scrolling" => "Iframe Scrolling",
// "Optional, scrolling of the iframe that contain the module (no by default)" => "Optional, scrolling of the iframe that contain the module (no by default)",
// "Piwik javascript code" => "Piwik javascript code",
// "Define option for Piwik groups, include or exclude" => "Define option for Piwik groups, include or exclude",
// "Plugin Piwik error" => "Plugin Piwik error",
// "Piwik server url is required" => "Piwik server url is required",
// "Site Id is required" => "Site Id is required",
// "moduleToWidgetize is required" => "moduleToWidgetize is required",
// "Period set to range but no end date provided" => "Period set to range but no end date provided",
// "PlayScorm" => "PlayScorm",
// "Play a SCORM learning object in an iframe using Moodle" => "Play a SCORM learning object in an iframe using Moodle",
// "Numeric ID of a SCORM zip file in a File Gallery" => "Numeric ID of a SCORM zip file in a File Gallery",
// "Moodle URL" => "Moodle URL",
// "Web address of the Moodle instance" => "Web address of the Moodle instance",
// "Moodle Course ID" => "Moodle Course ID",
// "Course ID in Moodle to upload SCORM objects to" => "Course ID in Moodle to upload SCORM objects to",
// "Frame Width" => "Frame Width",
// "Frame Height" => "Frame Height",
// "Numeric ID" => "Numeric ID",
// "Numeric ID to distinguish multiple plugins of there is more than one" => "Numeric ID to distinguish multiple plugins of there is more than one",
"Either the module or plugin parameter must be set, but not both" => "Das Modul oder der Plugin-Parameter muss angegeben werden, aber nicht beides",
"Plugin Manager error: %0%1 not found" => "Plugin Manager Fehler: %0%1 nicht gefunden",
"Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager Fehler: %0%1%2%3%4 nicht gefunden",
"Plugin Manager error:  %0%1 not found" => "Plugin Manager Fehler: %0%1 nicht gefunden",
"Options" => "Optionen",
"Accepted Values" => "Akzeptierte Werte",
"(body of plugin)" => "(Hauptteil des Plugins)",
// "%0separator:%1 " => "%0separator:%1 ",
"(blank)" => "(leer)",
"any string except for HTML and PHP tags" => "jeder Text mit Ausnahme von HTML und PHP Tags",
"Since" => "seit",
"no parameters" => "keine Parameter",
"Preferences required" => "Einstellungen erforderlich",
// "Introduced in %0" => "Introduced in %0",
"Required parameters are in%0 %1bold%2" => "Erforderliche Parameter sind in %0 %1bold%2",
"Plugin Manager" => "Plugin Manager",
"List wiki plugin or module information for the site" => "Liste Wiki Plugin oder Modulinformationen für die Site auf",
"Information" => "Information",
// "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1" => "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1",
"One or more of: description | parameters | paraminfo" => "Eine oder mehrere von: description | parameters | paraminfo",
"Description and Parameters" => "Beschreibung & Parameter",
"Description & Parameter Info" => "Beschreibung & Parameter Info",
"Parameters & Parameter Info" => "Parameter & Parameterinformationen",
"Plugin" => "Plugin",
// "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter" => "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter",
// "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter" => "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter",
"Single Title" => "Einzelne Überschrift",
"Set placement of plugin name and description when displaying information for only one plugin" => "Wähle Palzierung des Pluginnamen und der -beschreibung, wenn die Informationen nur für ein einzelnes Plugin angezeigt werden",
"Title Heading" => "Titelüberschrift",
// "Sets the heading size for the title, e.g., %0h2%1" => "Sets the heading size for the title, e.g., %0h2%1",
"Start with this plugin record number (must be an integer 1 or greater)" => "Starte mit dieser Aufzeichnungsnummer des Plugins (muss ein Ganzzahlwert von 1 oder größer sein)",
// "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater",
// "Parameter Type" => "Parameter Type",
// "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions" => "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions",
// "Show Parameter Type" => "Show Parameter Type",
// "Show the parameter %0doctype%1 value" => "Show the parameter %0doctype%1 value",
// "Show Top Info" => "Show Top Info",
// "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default" => "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default",
"Poll" => "Abstimmung",
// "Embed a poll" => "Embed a poll",
// "Title of the poll" => "Title of the poll",
"Numeric value representing the poll ID" => "Numerischer Wert für die AbstimmungsID",
"Show poll title (shown by default)" => "Zeige Abstimmungstitel (wird standardmäßig angezeigt)",
"Show result" => "Zeige Ergebnis",
// "Set how results of the poll will be shown (default is %0link%1)" => "Set how results of the poll will be shown (default is %0link%1)",
// "Voted" => "Voted",
"Show total votes" => "Zeige Gesamtabstimmungszahl",
// "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)" => "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)",
"Preference" => "Einstellung",
// "Display content based on global preference settings" => "Display content based on global preference settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions",
// "Document Preferences" => "Document Preferences",
// "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)" => "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)",
// "Preference-Tab" => "Preference-Tab",
// "The name of the preference tab to display, or a list of available tabs upon invalid" => "The name of the preference tab to display, or a list of available tabs upon invalid",
// "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2" => "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2",
"Pretty Tracker View Tracking" => "Schöne Tracker Ansicht",
"PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Store tiki.tracker.pretty.views attribute for a trackeritem" => "Store tiki.tracker.pretty.views attribute for a trackeritem",
// "Set to %0y%1 to record view each time this is loaded" => "Set to %0y%1 to record view each time this is loaded",
// "Set to %0n%1 to hide showing of attribute" => "Set to %0n%1 to hide showing of attribute",
"Set to ID of tracker item" => "Lege die ID des Trackereintrages fest",
// "Preview Files" => "Preview Files",
// "Enabled to generate preview of images or video files" => "Enabled to generate preview of images or video files",
// "Id of the file in the file gallery" => "Id of the file in the file gallery",
// "Animation" => "Animation",
// "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)" => "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)",
// "Width of the result in pixels" => "Width of the result in pixels",
// "Height of the result in pixels" => "Height of the result in pixels",
// "Show download link to the original file" => "Show download link to the original file",
"Profile Application" => "Profile anwenden",
"Add a button for applying a profile." => "Füge eine Schaltfläche zur Anwendung eines Profiles ein.",
// "Profile repository domain. Default value is %0profiles.tiki.org%1" => "Profile repository domain. Default value is %0profiles.tiki.org%1",
"Profile Name" => "Profilname",
"Name of the profile to be applied" => "Name des anzuwendenden Profiles",
"Profile plugin only available to administrators" => "Profilplugin steht nur Administratoren zur Verfügung",
"Profile %0/%1 not found" => "Profil %0/%1 nicht gefunden",
// "Profile Symbol Value" => "Profile Symbol Value",
// "Display the profile symbol related with profile and a reference and optionally with domain or package" => "Display the profile symbol related with profile and a reference and optionally with domain or package",
// "Reference key" => "Reference key",
// "Reference name" => "Reference name",
// "Package" => "Package",
// "Package extension name" => "Package extension name",
"Proposal" => "Vorschlag",
"Allow users to vote on a proposal and view the results" => "Erlaube Benutzern zu einem Vorschlag abzustimmen und die Ergebnisse einzusehen",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "Die Liste der Abstimmungen. Entweder 0, +1 oder -1 gefolgt von einem Benutzernamen",
// "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable" => "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable",
// "Weights" => "Weights",
// "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example" => "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example",
"Accept proposal" => "Vorschlag akzeptieren",
"Still undecided" => "Immer noch unentschieden",
"Reject proposal" => "Vorschlag ablehnen",
"Quote" => "Zitat",
"Format text as a quote" => "Formatiere Text als Zitat",
"Quoted text" => "zitierter Text",
"Reply To" => "Antwort an",
"Name of the quoted person" => "Name der zitierten Person",
// "Thread Id for Forum replies" => "Thread Id for Forum replies",
// "The thread Id of the comment being replied to in forums. Overwrites replyto" => "The thread Id of the comment being replied to in forums. Overwrites replyto",
// "Source URL" => "Source URL",
// "The URL to the source quoted" => "The URL to the source quoted",
// "Date when the statement quoted was made" => "Date when the statement quoted was made",
// "YYYY-MM-DD" => "YYYY-MM-DD",
// "R syntax" => "R syntax",
// "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms" => "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms",
"Random Include" => "Zufälliges Einbinden",
"Include a random page's content." => "Füge den Inhalt einer zufälligen Seite ein",
"Random Dynamic Content" => "Zufälliger dynamischer Inhalt",
"Display pre-programmed changing content" => "Zeige vor-programmierten, veränderlichen Inhalt",
"Numeric value representing the content ID" => "Numerischer Wert der Inhalts-ID",
"User List with Real Names" => "Benutzerliste mit Realnamen",
"Show user real names for members of a group" => "Zeige Realnamen der Benutzer für Mitglieder einer Gruppe",
// "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included",
"Result limit" => "Ergebnis Limit",
"Set to sort in ascending or descending order (unsorted by default" => "Lege die Sortierreihenfolge (auf- oder absteigend) fest (standardmäßig unsortiert",
"Make the listed names links to various types of user information" => "Die gelisteten Namen verlinken zu verschiedenen Arten von Benutzerinformationen",
"User Page" => "Benutzerseite",
"User Preferences" => "Benutzer-Einstellungen",
"Exclude" => "Ausschliessen",
"Exclude certain test or admin names from the list" => "Schließe Test- oder Administrator-Namen von der Liste aus",
"admin" => "Verwalten",
"admin-test" => "admin-test",
"test" => "test",
"test-admin" => "test-admin",
"Preferences" => "Einstellungen",
"Redirect" => "Weiterleitung",
"Redirect to another page." => "Leite auf eine andere Seite weiter",
"Wiki page name to redirect to" => "Wiki Seitename, auf den weitergeleitet wird",
"Complete URL, internal or external" => "Komplette URL, intern oder extern",
"The ID of a perspective to switch to (requires feature_perspective)" => "Die ID einer Perspektive zu der umgeschalten wird (erfordert feature_perspective)",
// "Auto login remote Tiki and redirect to page there" => "Auto login remote Tiki and redirect to page there",
// "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com" => "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com",
"perspective " => "Perspektive ",
"nowhere" => "nirgendwo",
// "Remote system error" => "Remote system error",
"REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "Plugin WEITERLEITUNG: Die Weiterleitung auf '%s' ist just nach Speichern der Seite deaktiviert",
"REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "Plugin WEITERLEITUNG: Die Weiterleitung auf '%s' ist im Vorschaumodus deaktiviert. ",
"REDIRECT plugin: redirect loop detected" => "Plugin WEITERLEITUNG: Weiterleitungsschleife entdeckt",
"Regular Expression" => "Regulärer Ausdruck",
"Perform a regular expression search and replace" => "Führe eine Suche/Ersetzung nach einem regulären Ausdruck durch",
"Each line of content is evaluated separately" => "Jede Zeile des Inhalts wird gesondert bewertet",
// "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page" => "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page",
"Register Member Payment" => "Mitgliederreistrierung und -bezahlung",
// "Register and make a member payment at the same time" => "Register and make a member payment at the same time",
"NA" => "NA",
"Fixed Periods" => "Vorgegebene Perioden",
// "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample" => "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample",
"Insufficient Privileges" => "Unzureichende Rechte",
"Submit" => "Abschicken",
"You will be redirected in 5 seconds" => "Du wirst innerhalt von 5 Sekunden weitergeleitet",
// "Display the relation of an object to the rest of the site" => "Display the relation of an object to the rest of the site",
"Qualifiers" => "Kennzeichner",
"Comma-separated list of relation qualifiers" => "Kommaseparierte Liste von Kennzeichnern der Beziehung",
// "Object identifier as %0type:itemId%1" => "Object identifier as %0type:itemId%1",
"Single List" => "Einzige Liste",
"Render all qualifiers into a single list without displaying the qualifier name" => "Alle Kennzeichner in einer einzigen Liste wiedergeben, ohne den Namen des Kennzeichners auszugeben",
// "Empty Message" => "Empty Message",
// "Message to give if result is empty and no relations are found" => "Message to give if result is empty and no relations are found",
"Remarks Box" => "Bemerkungsbox",
// "Display a comment, tip, note or warning box" => "Display a comment, tip, note or warning box",
"remarks text" => "Bemerkungstext",
"Select type of remarksbox, which determines what icon and style will be displayed" => "Wähle den Typ der Bemerkungsbox, der die Art des Symbols und den Stil festlegt",
"Confirm" => "bestätigen",
"Tip" => "Tip",
"Label displayed above the remark" => "Bezeichnung, die über dem Hinweis angezeigt wird",
"Use the highlight class for formatting (not used by default)" => "Benutze die Hervorhebungsklasse für die Formatierung (wird standardmäßig nicht benutzt)",
"Custom Icon" => "Benutzerdefiniertes Symbol",
"Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)" => "Trage einen Tiki Symboldateinamen ein (mit oder ohne Erweiterung) oder den Pfad zu einem benutzerdefiniertem Symbol",
"Show a close button (not shown by default)" => "Zeige eine Schließenschaltfläche (wird standardmäßig nicht angezeigt)",
// "Width (e.g. %0100%%1 or %0250px%1 - default \"\")" => "Width (e.g. %0100%%1 or %0250px%1 - default \"\")",
// "Remember Dismiss" => "Remember Dismiss",
// "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set" => "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set",
// "Sets an HTML id for the account" => "Sets an HTML id for the account",
// "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter" => "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter",
// "RR (R syntax also)" => "RR (R syntax also)",
// "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call" => "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call",
// "R Code" => "R Code",
// "echo" => "echo",
// "Show a code block with the R commands to be run before running them (similarly to the echo command)" => "Show a code block with the R commands to be run before running them (similarly to the echo command)",
// "echo debug" => "echo debug",
// "Show a code block with the R commands to be run even if the R program fails to execute" => "Show a code block with the R commands to be run even if the R program fails to execute",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "wikisyntax" => "wikisyntax",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
"width" => "Breite",
// "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio" => "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio",
"height" => "Höhe",
// "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio" => "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio",
// "units" => "units",
// "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm" => "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm",
// "pointsize" => "pointsize",
// "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger" => "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger",
// "bg" => "bg",
// "The initial background colour (optional). Options: white, yellow, grey, ... and transparent" => "The initial background colour (optional). Options: white, yellow, grey, ... and transparent",
// "parse_body" => "parse_body",
// "parses the body content to allow data to be generated from other plugins" => "parses the body content to allow data to be generated from other plugins",
// "res" => "res",
// "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much" => "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much",
// "svg" => "svg",
// "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "pdf" => "pdf",
// "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "onefile" => "onefile",
// "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file" => "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file",
// "LoadAndSave" => "LoadAndSave",
// "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages" => "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages",
// "Caching strategy" => "Caching strategy",
// "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin" => "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin",
// "Limit cache duration" => "Limit cache duration",
// "Force cache recalculation after time limit. Default: No limit" => "Force cache recalculation after time limit. Default: No limit",
// "CacheBy" => "CacheBy",
// "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)" => "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)",
// "Page Name (pagename)" => "Page Name (pagename)",
// "Page Id (pageid)" => "Page Id (pageid)",
// "Cache age" => "Cache age",
// "Display cache last modification date below the graph (default option: do not display)" => "Display cache last modification date below the graph (default option: do not display)",
// "attId" => "attId",
// "AttId from a tracker Item attachment. ex: 1. (Optional)" => "AttId from a tracker Item attachment. ex: 1. (Optional)",
// "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required" => "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required",
// "csv" => "csv",
// "xml" => "xml",
// "x11" => "x11",
// "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()" => "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()",
// "removen" => "removen",
// "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)" => "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)",
// "Custom output" => "Custom output",
// "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file" => "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file",
// "security" => "security",
// "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)" => "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)",
// "Cache was last modified: %0" => "Cache was last modified: %0",
// "One cache per plugin" => "One cache per plugin",
// "One cache per plugin per user" => "One cache per plugin per user",
// "No caching: Ignore and replace existing cache, if any" => "No caching: Ignore and replace existing cache, if any",
// "No limit" => "No limit",
// "1 hour" => "1 hour",
// "1 day" => "1 day",
// "7 days" => "7 days",
// "30 days" => "30 days",
// "365 days" => "365 days",
// "Don't display cache creation date" => "Don't display cache creation date",
// "Display cache creation date" => "Display cache creation date",
// "Blocked commands found: " => "Blocked commands found: ",
// "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you" => "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you",
// "command unavailable" => "command unavailable",
// "The __R__ package needs to be installed on the server" => "The __R__ package needs to be installed on the server",
// "See requirements on [https://doc.tiki.org/PluginR]" => "See requirements on [https://doc.tiki.org/PluginR]",
// "The path to the __R__ command could not be found on your system" => "The path to the __R__ command could not be found on your system",
// "Maybe this file is inaccessible due to safe mode restrictions" => "Maybe this file is inaccessible due to safe mode restrictions",
// "The path to the __convert__ command could not be found on your system" => "The path to the __convert__ command could not be found on your system",
// "You need to ensure that you have __imagemagick__ installed successfully on the server" => "You need to ensure that you have __imagemagick__ installed successfully on the server",
// "Cached R output from %0. If you click, you will re-run all R scripts in this page" => "Cached R output from %0. If you click, you will re-run all R scripts in this page",
// "Save Image as SVG" => "Save Image as SVG",
// "Save Image as PDF" => "Save Image as PDF",
// "plot" => "plot",
"RSS Feed" => "RSS Feed",
// "Display items from one or more RSS feeds" => "Display items from one or more RSS feeds",
"IDs" => "IDs",
// "List of feed IDs separated by colons. ex: %0" => "List of feed IDs separated by colons. ex: %0",
"Result Count" => "Ergebniszähler",
"Number of results displayed" => "Anzahl der angezeigten Ergebnisse",
"Show date of each item (not shown by default)" => "Zeige Datum jedes Objekts (wird standardmäßig nicht angezeigt)",
"Show feed descriptions (not shown by default)" => "Zeige Feed Beschreibungen (wird standardmäßig nicht angezeigt)",
"Show authors (not shown by default)" => "Zeige Autoren (wird standardmäßig nicht angezeigt)",
"URL to a favicon to put before each entry" => "URL zu einem Favicon, das vor jeden Eintrag gesetzt wird",
"Show the title of the feed (shown by default)" => "Zeige den Titel des Feeds (wird standardmäßig angezeigt)",
// "Ticker" => "Ticker",
// "Turn static feed display into ticker news like" => "Turn static feed display into ticker news like",
// "Description Length" => "Description Length",
// "Max characters/length, truncates text to fit design" => "Max characters/length, truncates text to fit design",
"Scroll" => "Scroll",
"Show animated text that scrolls up or down" => "Zeige animierten Text, der hoch oder runter scrollt",
// "Width in pixels. Example: %0" => "Width in pixels. Example: %0",
// "Number of pixels followed by \"px\"" => "Number of pixels followed by \"px\"",
// "Height in pixels. Example: %0" => "Height in pixels. Example: %0",
// "Scroll speed in number of seconds (default is %0)" => "Scroll speed in number of seconds (default is %0)",
"SourceForge" => "SourceForge",
"Creates a link to SourceForge tracker items" => "Erstellt einen Link zu SourceForge Trackereinträgen",
"Group ID" => "Gruppen-ID",
"SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge Projekt-ID (zeigt sich als group_id in der URL des Trackereintrages",
"SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge Tracker-ID (zeigt sich als atid in der URL des Trackereintrages",
"SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge Eintrag-ID (zeigt sich als aid in der URL des Trackereintrages",
"Link title" => "Linktitel",
// "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)",
"ShareThis" => "ShareThis",
"Add a ShareThis button" => "Füge eine ShareThis-Schaltfläche ein",
"Send Services" => "Sende-Dienst",
// "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services" => "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services",
"AIM" => "AIM",
// "AIM and Email" => "AIM and Email",
// "AIM and SMS" => "AIM and SMS",
// "Email and SMS" => "Email and SMS",
"Button Style" => "Schaltflächenstil",
// "Set button style" => "Set button style",
"Rotate Image" => "Rotierungsbild",
// "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping" => "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping",
"Multiple Icons" => "Multiple Symbole",
// "Enter pipe-separated list of services, e.g., %0" => "Enter pipe-separated list of services, e.g., %0",
"First Services Shown" => "Erster anzuzeigender Dienst",
// "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget",
"Custom link text for the button" => "Benutzerdefinierter Text für die Schaltfläche",
"Header Title" => "Kopftitel",
"Optional header title text for the widget" => "Optionales Kopftiteltext für das Widget",
"Header Background" => "Kopfhintergrund",
// "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used" => "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used",
"Header Text Color" => "Textfarbe Kopf",
"HTML color code (not color name) for the header text if an optional header title is used" => "HTML Farbcode (nicht Farbname) für den Kopftext wenn ein optionaler Kopftitel benutzt wird",
"Link text color for services" => "Linktextfarbe für Dienste",
"HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML Farbcode (nicht Farbname) für Linktext für ale Sende- und Eintragsdienste, die im Widget angezeigt werden",
// "Set whether the widget will show in a popup window" => "Set whether the widget will show in a popup window",
"Embedded Elements" => "Eingebettete Elemente",
// "Allow embedded elements (like flash) to be seen while iframe is loading" => "Allow embedded elements (like flash) to be seen while iframe is loading",
"Sheet" => "Tabelle",
"Display data from a TikiSheet" => "Zeige Daten aus einer Tiki Tabelle",
"Spreadsheet Heading" => "Tabellenkopf",
// "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required" => "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required",
"Sheet Url Location" => "Tabellen URL",
// "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired" => "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired",
// "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)" => "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1" => "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1",
"Height in pixels or percentage. Default value is complete spreadsheet height" => "Höhe in Pixel oder Prozentsatz. Standardwert ist die vollständige Tabellenhöhe",
// "Show edit button. Default is to show depending on user's permissions" => "Show edit button. Default is to show depending on user's permissions",
"Show subsheets" => "Zeige Untertabellen",
// "Show multi-sheets (default is to show)" => "Show multi-sheets (default is to show)",
// "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1" => "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1",
"Apply custom CSS class to the containing div" => "Benutzerdefinierte CSS-Klasse für das enthaltende DIV",
"New sheet in page: " => "Neue Tabelle aus Seite: ",
"Create New Sheet" => "Erstelle neue Tabelle",
"Error loading spreadsheet" => "Fehler beim Laden der Tabelle",
"Edit Sheet" => "Sheet bearbeiten",
"Collect Anonymous Shopper Info" => "Sammele Informationen über anonymen Einkäufer",
"PluginShopperinfo" => "PluginShopperinfo",
// "Collect shopper information for the shopping cart" => "Collect shopper information for the shopping cart",
"Values to be collected" => "Zu sammelnde Werte",
"Names of values to be collected separated by : as defined in shopper profile" => "Namen der Werte, die gesammelt werden sollen, getrennt durch : so wie im Einkaufsprofile definiert",
"Labels for the values to be collected" => "Bezeichnungen für die zu sammelnden Werte",
// "Labels of the values to be collected separated by a colon" => "Labels of the values to be collected separated by a colon",
"Show even if logged in" => "Zeige auch, wenn angemeldet",
"Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normalerweise wird dies für anonyme Benutzer verwendet, wird ggf. aber auch benötigt, wenn angemeldet",
// "Shorten" => "Shorten",
// "Show/hide a portion of text" => "Show/hide a portion of text",
// "Char length of always visible portion of text" => "Char length of always visible portion of text",
// "More text" => "More text",
// "A label indicating the text is expandable" => "A label indicating the text is expandable",
// "Less text" => "Less text",
// "A label for collapse text action" => "A label for collapse text action",
"Show Pages" => "Seite anzeigen",
"Find pages by searching within page names" => "Finde Seiten durch Suchen in den Seitennamen",
"Search criteria" => "Suchkriterium",
"Maximum amount of results displayed" => "Maximale Menge von angezeigten Ergebnissen",
"Display page name and/or description. Both displayed by default" => "Zeige Seitenname und/oder Beschreibung an. Standardmäßig wird beides angezeigt",
"Name & Description" => "Name & Beschreibung",
// "Show Preference" => "Show Preference",
// "Display the value of public global preferences" => "Display the value of public global preferences",
// "Name of preference to be displayed" => "Name of preference to be displayed",
"Add Bibliography" => "Bibliographie beifügen",
// "Add bibliography listing in the footer of a wiki page" => "Add bibliography listing in the footer of a wiki page",
// "Title to be displayed in the bibliography listing. Default is %0Bibliography%1" => "Title to be displayed in the bibliography listing. Default is %0Bibliography%1",
// "Show bibliography title. Title is shown by default" => "Show bibliography title. Title is shown by default",
// "Header Tag" => "Header Tag",
// "The HTML header tag level of the title. Default: %01%1" => "The HTML header tag level of the title. Default: %01%1",
// "Remove the lines around the list of references" => "Remove the lines around the list of references",
// "Remove the horizontal lines displayed above and below the list of references" => "Remove the horizontal lines displayed above and below the list of references",
// "Page identifier" => "Page identifier",
// "Provide the page id" => "Provide the page id",
// "Bibliography" => "Bibliography",
"Signature" => "Unterschrift",
// "Sign and date your contribution to a page" => "Sign and date your contribution to a page",
// "Auto-generated, the username" => "Auto-generated, the username",
// "Date and time" => "Date and time",
// "Auto-generated, the timestamp" => "Auto-generated, the timestamp",
"Skype" => "Skype",
// "Add a link for calling or chating with a Skype user" => "Add a link for calling or chating with a Skype user",
"Name or number to call or chat with" => "Name oder Nummer der/die angerufen oder mit dem gechattet werden soll",
"Set whether to call or chat. Default is chat" => "Lege fest, ob angerufen oder gechattet werden soll. Standard ist Chat",
"Call" => "Aufruf",
"Chat" => "Chat",
"Show status" => "Zeige Status",
// "Show a status icon or not i.e. if online/offline/etc. Default is to not show status" => "Show a status icon or not i.e. if online/offline/etc. Default is to not show status",
"yes" => "ja",
// "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web" => "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web",
"click to" => "klicke auf",
"Slider" => "Gleiter",
// "Embed a mini-slideshow of content on a page" => "Embed a mini-slideshow of content on a page",
"Content separated by \"/////\"" => "Inhalte, getrennt durch /////",
"Slider Titles" => "Gleiterüberschriften",
// "Pipe-separated list of slider titles. Example" => "Pipe-separated list of slider titles. Example",
// "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels" => "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels",
"The theme to use in slider" => "Das im Gleiter zu benutzende Theme",
"Expand" => "Erweitern",
// "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set" => "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set",
// "Resize" => "Resize",
// "Set whether solitary images/objects in the panel will be expanded to fit the viewport" => "Set whether solitary images/objects in the panel will be expanded to fit the viewport",
"Show Multiple" => "Zeige Multiple",
"Set this value to a number and it will show that many slides at once" => "Trage eine Zahl ein und es werden soviele Gleiter auf einmal angezeigt",
// "Arrows" => "Arrows",
// "Set whether to show forward and backward buttons" => "Set whether to show forward and backward buttons",
"Navigation" => "Navigation",
// "Set whether to show a list of anchor links to link to each panel" => "Set whether to show a list of anchor links to link to each panel",
// "Start / Stop" => "Start / Stop",
// "Set whether to show a start/stop button and add slideshow functionality" => "Set whether to show a start/stop button and add slideshow functionality",
"Toggle Arrows" => "Pfeile umschalten",
// "Set whether side navigation arrows slide out on hovering and hide at other times" => "Set whether side navigation arrows slide out on hovering and hide at other times",
"Toggle Controls" => "Steuerung umschalten",
// "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times" => "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times",
"Enable Arrows" => "Aktiviere Pfeile",
// "Set whether arrows are clickable" => "Set whether arrows are clickable",
"Enable Navigation" => "Aktiviere Navigation",
// "Set whether navigation links are clickable" => "Set whether navigation links are clickable",
"Enable Start Stop" => "Aktiviere Start/Stop",
// "Set whether the play/stop button is clickable. Previously %0" => "Set whether the play/stop button is clickable. Previously %0",
"Enable Keyboard" => "Aktiviere Tastatur",
// "Set whether keyboard arrow keys will work for this slider" => "Set whether keyboard arrow keys will work for this slider",
"Auto Play" => "Automatisch Abspielen",
// "Set whether the slideshow will start running automatically; replaces %0 option" => "Set whether the slideshow will start running automatically; replaces %0 option",
"Auto Play Locked" => "Sperrung beim automatischen Abspielen",
// "Keep playing the slideshow even if the user changes slides" => "Keep playing the slideshow even if the user changes slides",
"Auto Play Delayed" => "Verzögerung beim automatischen Abspielen",
// "Set whether there will be a delay in advancing slides" => "Set whether there will be a delay in advancing slides",
"Pause On Hover" => "Pause beim Überfahren mit Maus",
// "Set whether the slideshow will pause on hover while the slideshow is active" => "Set whether the slideshow will pause on hover while the slideshow is active",
"Stop At End" => "Stop am Ende",
// "Set whether the slideshow stops on the last page" => "Set whether the slideshow stops on the last page",
// "Delay between slides" => "Delay between slides",
"Time in milliseconds between slideshow transitions (in AutoPlay mode)" => "Zeit zwischen den Dias in Millisekunden (im AutoPlay Betrieb)",
// "Right To Left" => "Right To Left",
// "Set whether the slideshow moves right-to-left" => "Set whether the slideshow moves right-to-left",
"Resume On Video End" => "Fortsetzen nach Videoende",
// "Set whether auto play stops until the video is complete (for supported video types)" => "Set whether auto play stops until the video is complete (for supported video types)",
// "Animation Time" => "Animation Time",
// "Milliseconds between slides" => "Milliseconds between slides",
// "Panel Hashtags" => "Panel Hashtags",
// "Set whether to include a hashtag in the page URL, allowing links to specific panels" => "Set whether to include a hashtag in the page URL, allowing links to specific panels",
// "Create a slideshow from the content of a wiki page" => "Create a slideshow from the content of a wiki page",
// "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI",
// "Parallax Background Image" => "Parallax Background Image",
// "URL of the background image to use in your slideshow, overrides %0" => "URL of the background image to use in your slideshow, overrides %0",
"Valid URL" => "Gültige URL",
// "Parallax Background Size" => "Parallax Background Size",
// "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)" => "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)",
// "Parallax Background Horizontal" => "Parallax Background Horizontal",
// "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis" => "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis",
// "Parallax Background Vertical" => "Parallax Background Vertical",
// "Transition" => "Transition",
// " Transition style" => " Transition style",
// "Transition Speed" => "Transition Speed",
// "Background Transition" => "Background Transition",
// "Transition style for full page slide backgrounds" => "Transition style for full page slide backgrounds",
// "Display presentation control arrows" => "Display presentation control arrows",
// "Controls Layout" => "Controls Layout",
// "Determines where controls appear, \"edges\" or \"bottom-right\"" => "Determines where controls appear, \"edges\" or \"bottom-right\"",
// "Controls Back Arrows" => "Controls Back Arrows",
// "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"" => "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"",
// "Progress" => "Progress",
// "Display a presentation progress bar" => "Display a presentation progress bar",
// "Slide Number" => "Slide Number",
// "Display the page number of the current slide" => "Display the page number of the current slide",
// "Fragments" => "Fragments",
// "Turns fragments on and off globally" => "Turns fragments on and off globally",
// "Fragment Effects" => "Fragment Effects",
// "Fragment Highlight Color" => "Fragment Highlight Color",
// "Auto Slide" => "Auto Slide",
// "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides" => "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides",
// "Auto Slide Stoppable" => "Auto Slide Stoppable",
// "Stop auto-sliding after user input" => "Stop auto-sliding after user input",
// "Auto-align Images" => "Auto-align Images",
// "Automatically move images to left hand side of slide text, will only align images greater than 200px in width" => "Automatically move images to left hand side of slide text, will only align images greater than 200px in width",
// "Start Slideshow Presentation" => "Start Slideshow Presentation",
// "SlideshowSlide" => "SlideshowSlide",
// "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings" => "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings",
// "Enter content of slide" => "Enter content of slide",
// "Slide Background color" => "Slide Background color",
// "Set background color for slide" => "Set background color for slide",
// "Slide Text color" => "Slide Text color",
// "Set Text color for slide" => "Set Text color for slide",
// "Background Video URL" => "Background Video URL",
// "Automatically plays a full size video behind the slide" => "Automatically plays a full size video behind the slide",
// "Mute Background Video" => "Mute Background Video",
// "Flags if the audio should be muted for background video" => "Flags if the audio should be muted for background video",
// "Loop Background Video" => "Loop Background Video",
// "Flags if the background video played in loop" => "Flags if the background video played in loop",
// "Transition In" => "Transition In",
// "Select entry transition effect for slide" => "Select entry transition effect for slide",
// "Transition Out" => "Transition Out",
// "Select exit transition effect for slide" => "Select exit transition effect for slide",
"Smarty function" => "Smarty-Funktion",
// "Insert a Smarty function or variable" => "Insert a Smarty function or variable",
// "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1" => "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1",
"Snarf" => "Stibitzen",
"Display the contents of another web page" => "Zeigt den Inhalt einer anderen Webseite",
"Full URL to the page to include" => "Volle URL zu der einzubindenden Seite",
"Regular Expression Pattern" => "Muster für regulären Ausdruck (RegEx)",
"PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-konforme Muster für reguläre Ausdrücke, um die Teile zu finden, die sie ändern wollen",
"Regular Expression Replacement" => "Ersetzung für regulären Ausdruck",
"PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-konformer regulärer-Ausdruck-Ersetzungsssyntax, um anzuzeigen, in was der Inhalt geändert wird",
"Enable/disable word wrapping of snippets of code (enabled by default)" => "Zeilenumbruch bei Codeschnippseln aktivieren/deaktivieren (standardmäßig aktiviert",
// "Syntax highlighting to use for code snippets (Plugin Code is used for this)" => "Syntax highlighting to use for code snippets (Plugin Code is used for this)",
// "Set to Yes (%0) to add line numbers to code snippets (not shown by default)" => "Set to Yes (%0) to add line numbers to code snippets (not shown by default)",
"Parse wiki syntax within the code snippet (not parsed by default)" => "Parse Wiki Syntax innerhalb von Codeschnippseln (standardmäßig wird nicht geparst)",
"Switch the text display from left to right to right to left" => "Schalte die Textanzeige von links-nach-rechts zu rechts-nach-links um",
"HTML Content" => "HTML-Inhalt",
// "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)" => "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)",
"Cache URL" => "Cache-URL",
// "Cache time in minutes. Default is to use site preference, Set to %0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to %0 for no cache",
"Text to click on to fetch the URL via Ajax" => "Text zum klicken, um die URL mit Ajax abzurufen",
"Sort lines of text" => "Sortiere Textzeilen",
"Data to sort, one entry per line" => "Zu sortierende Daten. Ein Eintrag pro Zeile",
"Order" => "Reihenfolge",
"Set the sort order of lines of content (default is ascending)" => "Sortierreihenfolge des Inhalts festlegen (Standard ist absteigend)",
"Reverse" => "Umgekehrt",
"Shuffle" => "mischen",
// "Arrange content on a page into rows and columns" => "Arrange content on a page into rows and columns",
// "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Generate the colspan attribute if columns are missing" => "Generiere das COLSPAN Attribut, wenn Spalten fehlen",
"Fixed Size" => "Feste Größe",
"Generate the width attribute for the columns" => "Generiere das WIDTH Attribut für die Spalten",
// "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)" => "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)",
// "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns",
// "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1" => "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1",
"SQL" => "SQL",
"Query a MySQL database and display the results" => "Frage eine MySQL Databank ab und zeige die Ergebnisse",
// "The SQL query goes in the body. Example: " => "The SQL query goes in the body. Example: ",
"DSN Name" => "DSN-Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0" => "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0",
// "Raw return" => "Raw return",
// "Return with table formatting (default) or raw data with no table formatting" => "Return with table formatting (default) or raw data with no table formatting",
// "Raw" => "Raw",
// "Delim" => "Delim",
// "The delimiter to be used between data elements (sets %0)" => "The delimiter to be used between data elements (sets %0)",
// "Turn wiki parsing of select results on and off (default is on)" => "Turn wiki parsing of select results on and off (default is on)",
"Missing db param" => "Datenbank-Parameter fehlt",
"Could not obtain valid DSN connection" => "Erhalte keine gültige DSN-Verbindung",
"Stat" => "Statistik",
"Show various statistics for an object" => "Zeige verschiedene Statistiken zu einem Objekt",
// "Colon-separated list of object type to show stats for" => "Colon-separated list of object type to show stats for",
"Article & Tracker Item" => "Artikel & Trackereintrag",
"Article & Tracker Item & Wiki" => "Artikel & Trackereintrag & Wiki",
"Article & Wiki" => "Artikel & Wiki",
"Article & Wiki & Tracker Item" => "Artikel & Wiki & Trackereintrag",
"Tracker Item & Article" => "Trackereintrag & Artikel",
"Tracker Item & Article & Wiki" => "Trackereintrag & Artikel & Wiki",
"Tracker Item & Wiki" => "Trackereintrag & Wiki",
"Tracker Item & Wiki & Article" => "Trackereintrag & Wiki & Artikel",
"Wiki & Article" => "Wiki & Artikel",
"Wiki & Article & Tracker Item" => "Wiki & Artikel & Trackereintrag",
"Wiki & Tracker Item" => "Wiki & Trackereintrag",
"Wiki & Tracker Item & Article" => "Wiki & Trackereintrag & Artikel",
"Parent ID" => "Übergeordnete ID",
"Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Trage eine Tracker-ID ein, um die Statistiken auf diesen Tracker zu beschränken (nur für die Benutzung mit Trackereinträgen)",
"Last 24 Hours" => "Letzten 24 Stunden",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"" => "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"",
"Added" => "Hinzugefügt",
"Added and Viewed" => "Hinzugefügt und angesehen",
"Viewed" => "Angesehen",
"Viewed & Added" => "Hinzugefügt & angesehen",
// "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last 7 Days" => "Letzte 7 Tage",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Week" => "Diese Woche",
// "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Month" => "Letzter Monat",
// "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Month" => "Dieser Monat",
// "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Year" => "Letztes Jahr",
// "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Year" => "Dieses Jahr",
// "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Incorrect parameter: " => "Falscher Parameter: ",
"Subscript" => "Tiefgestellt",
"Apply subscript font to text" => "Text tieferstellen (subscript)",
"Subscribe Group" => "Anmeldung bei Gruppe",
"Allow users to subscribe to a group" => "Erlaube es Benutzer sich bei einer Gruppe anzumelden",
"text displayed before the button" => "Text, der vor der Schaltfläche angezeigt wird",
"Group name to subscribe to or unsubscribe from" => "Name der Gruppe zum Anschließen/Abmelden",
"Subscribe Text" => "Anmeldetext",
// "Subscribe text, containing %0 as the placeholder for the group name" => "Subscribe text, containing %0 as the placeholder for the group name",
"Subscribe" => "Abonnieren",
"Unsubscribe Text" => "Abmeldetext",
// "Unsubscribe text, containing %0 as the placeholder for the group name" => "Unsubscribe text, containing %0 as the placeholder for the group name",
"Unsubscribe" => "Abmelden",
"Subscribe Action" => "Anmeldeaktion",
// "Subscribe button label, containing %0 as the placeholder for the group name" => "Subscribe button label, containing %0 as the placeholder for the group name",
"Unsubscribe Action" => "Abmeldeaktion",
// "Unsubscribe button label, containing %0 as the placeholder for the group name" => "Unsubscribe button label, containing %0 as the placeholder for the group name",
"Post-subscribe URL" => "URL nach Anmeldung",
"URL to send the user to after subscribing, if required" => "URL auf die ein Benutzer nach Anmeldung weitergeleitet wird (wenn erforderlich)",
"Post-unsubscribe URL" => "URL nach Abmeldung",
"URL to send the user to after unsubscribing, if required" => "URL auf die ein Benutzer nach Abmeldung weitergeleitet wird (wenn erforderlich)",
// "Make this the default group text, containing %0 as the placeholder for the group name" => "Make this the default group text, containing %0 as the placeholder for the group name",
"Not Default Group" => "Nicht Standardgruppe",
// "Stop this being default group text, containing %0 as the placeholder for the group name" => "Stop this being default group text, containing %0 as the placeholder for the group name",
"Default Group Action" => "Standard Gruppenaktion",
"Default group button label. Will subscribe to the group first if not already a member" => "Standard Gruppenschaftflächenbezeichnung. Tritt dieser Gruppe zuerst bei, wenn nicht bereits Mitglied",
"Not Default Group Action" => "Nicht Standard Gruppenaktion",
"Stop this being default group button label. Does not unsubscribe from the group" => "Stoppe dies als standard Gruppenschaftflächenbezeichnung. Meldet nicht von der Gruppe ab",
// "Second Default" => "Second Default",
"Group name to set as default when user stops this group being it" => "Gruppenname, der als Standardgruppe festgelegt wird, wenn Benutzer diese Gruppe als Standard abwählt",
// "Redirect to new home page after default group change. (default is to redirect)" => "Redirect to new home page after default group change. (default is to redirect)",
// "Can Always Leave" => "Can Always Leave",
// "Always allow leaving a group even if the group settings do not allow user choice" => "Always allow leaving a group even if the group settings do not allow user choice",
"Subscribe Groups" => "Gruppenanmeldung",
"Allow users to subscribe to a list of groups" => "Erlaube es Benutzer sich bei einer Liste von Gruppen anzumelden",
// "Text shown in the dropdown box. Default: %0Subscribe to a group%1" => "Text shown in the dropdown box. Default: %0Subscribe to a group%1",
"Show Subscribe Box" => "Zeige Anmeldebox",
// "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for",
"Subscribe Box Style" => "Stil der Anmeldebox",
// "Style to show the subscribe box" => "Style to show the subscribe box",
"Show Default" => "Zeige Standard",
// "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group" => "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group",
"Group Description" => "Gruppenbeschreibung",
"Show the description of the group (not shown by default)" => "Zeigt die Beschreibung der Gruppe (wird standardmäßig nicht angezeigt)",
"Colon-separated list of groups. By default the list of groups available to the user" => "Durch Doppelpunkt getrennte Liste von Gruppen. Standardmäßig die Liste von Gruppen, die für den Benutzer verfügbar sind",
"Only list groups that include the group being specified here" => "Liste nur Gruppen auf, welche die hier angegebene Gruppe beinhalten",
"Default URL" => "Standard-URL",
"Page user will be directed to after clicking on icon to change default group" => "Seite, auf die der Benutzer weitergeleitet wird, nachdem er das Symbol zur Änderung der Standardgruppe angeklickt hat",
"Leader Group Name" => "Gruppenname Leiter",
// "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name" => "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name",
"Pending Users Group Name" => "Gruppennahme für anhängige Anmeldungen",
// "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name",
"Group Management Page Name" => "Seitenname Gruppenverwaltung",
// "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name" => "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name",
"Hide link for groups including" => "Link zu eingeschlossenen Gruppen verstecken",
"Hide link to group home page for groups that include the group being specified here" => "Verstecke den Link zur Gruppen-Homepage bei Gruppen, welche die hier angegebene beinhalten",
"Always allow leaving group" => "Jederzeit das Verlassen der Gruppe erlauben",
// "Always allow leaving group even if the group settings do not allow user choice" => "Always allow leaving group even if the group settings do not allow user choice",
"You do not have permission to subscribe to groups" => "Du hast keine Berechtigung, Gruppen beizutreten",
"Subscribe to newsletter" => "Newsletter abonnieren",
"Allow users to subscribe to a newsletter" => "Erlaube Benutzer einen Newsletter zu abonnieren",
"Invitation message" => "Einladungsnachricht",
"Newsletter ID" => "Newsletter-ID",
// "Identification number of the Newsletter that you want to allow the users to subscribe to" => "Identification number of the Newsletter that you want to allow the users to subscribe to",
"Confirmation Message" => "Bestätigungsnachricht",
"Confirmation message after posting form. The plugin body is then the button label" => "Bestätigungsnachricht nachdem das Formular gesendet wurde. Der Plugin-Hauptteil ist dann die Schaltflächenbezeichnung",
"Button label. The plugin body is then the confirmation message" => "Schaltflächenbezeichnung. Der Hauptteil des Plugins ist dann die Bestätigungsnachricht",
// "Choose whether the output should be parsed as wiki syntax" => "Choose whether the output should be parsed as wiki syntax",
// "In Module" => "In Module",
// "Display the newsletter subscription form in module view (if included in a Tiki module)" => "Display the newsletter subscription form in module view (if included in a Tiki module)",
"Already subscribed" => "Bereits abonniert",
"Superscript" => "Hochgestellt",
"Apply superscript font to text" => "Text hochstellen (superscript)",
// "Embed a survey" => "Embed a survey",
// "Id of the survey set up by the administrator" => "Id of the survey set up by the administrator",
"Wiki Page to redirect the user after his vote" => "Wiki Seite, auf die nach Abgabe der Abstimmung weitergeleitet wird",
// "Language for the survey" => "Language for the survey",
// "Swiper" => "Swiper",
// "Embed swiper in content, support file galleries, files id and custom content" => "Embed swiper in content, support file galleries, files id and custom content",
// "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> " => "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> ",
// "Enter file gallery id for slider" => "Enter file gallery id for slider",
// "Transition Effect" => "Transition Effect",
// "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"" => "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"",
// "Slider Placement on Page" => "Slider Placement on Page",
// "Placement of slider, above topbar, below topbar, above menus and content or inside content" => "Placement of slider, above topbar, below topbar, above menus and content or inside content",
// "Inside Content" => "Inside Content",
// "Above top bar / Top of page" => "Above top bar / Top of page",
// "Above Content/Under top bar" => "Above Content/Under top bar",
// "Slider pagination, default bullets" => "Slider pagination, default bullets",
// "Fraction" => "Fraction",
// "Progress bar" => "Progress bar",
// "Display navigation arrows" => "Display navigation arrows",
// "Slider Background Color" => "Slider Background Color",
// "Slider background color, enter color code for example #000" => "Slider background color, enter color code for example #000",
// "Slider Parallax Background Image" => "Slider Parallax Background Image",
// "Enter image url for parallax background behind swiper" => "Enter image url for parallax background behind swiper",
// "Enter width of slider in px, default 100%" => "Enter width of slider in px, default 100%",
// "Enter height of slider in px, default min height 100px, max height will adjust with content" => "Enter height of slider in px, default min height 100px, max height will adjust with content",
// "Slide title color" => "Slide title color",
// "Enter text color code of slide title, for example #ccc" => "Enter text color code of slide title, for example #ccc",
// "Title font size" => "Title font size",
// "For example 42px, default 32 px" => "For example 42px, default 32 px",
// "Slide description color" => "Slide description color",
// "Enter text color code of slide description, for example #ccc" => "Enter text color code of slide description, for example #ccc",
// "Description font size" => "Description font size",
// "For example 24px, default 16 px" => "For example 24px, default 16 px",
// "Slide content background" => "Slide content background",
// "Slide content position" => "Slide content position",
// "Enter position for example top:20%;left:20% or bottom:20%;right:10%" => "Enter position for example top:20%;left:20% or bottom:20%;right:10%",
// "Autoplay slider, on by default" => "Autoplay slider, on by default",
// "Auto Play Delay" => "Auto Play Delay",
// "Show thumbnails under main slider" => "Show thumbnails under main slider",
// "Duration of transition between slides (in seconds)" => "Duration of transition between slides (in seconds)",
// "Auto Height" => "Auto Height",
// "Set to true and slider wrapper will adopt its height to the height of the currently active slide" => "Set to true and slider wrapper will adopt its height to the height of the currently active slide",
// "Space Between" => "Space Between",
// "Distance between slides in px" => "Distance between slides in px",
// "Slides Per View" => "Slides Per View",
// "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view" => "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view",
// "Slides Per View Mobile Screen" => "Slides Per View Mobile Screen",
// "Slides visible at the same time on small screens" => "Slides visible at the same time on small screens",
// "Slides Per View Tablet" => "Slides Per View Tablet",
// "Slides visible at the same time on low resolution tablets" => "Slides visible at the same time on low resolution tablets",
// "Slides Per Column" => "Slides Per Column",
// "Number of slides per column, for multirow layout" => "Number of slides per column, for multirow layout",
// "Slides Per Column Fill" => "Slides Per Column Fill",
// "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row" => "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row",
// "Centered Slides" => "Centered Slides",
// "If true, then active slide will be centered, not always on the left side" => "If true, then active slide will be centered, not always on the left side",
// "Slides Offset Before" => "Slides Offset Before",
// "Add (in px) additional slide offset in the beginning of the container (before all slides)" => "Add (in px) additional slide offset in the beginning of the container (before all slides)",
// "Slides Offset After" => "Slides Offset After",
// "Add (in px) additional slide offset in the end of the container (after all slides)" => "Add (in px) additional slide offset in the end of the container (after all slides)",
// "Slide To Clicked Slide" => "Slide To Clicked Slide",
// "Set to true and click on any slide will produce transition to this slide" => "Set to true and click on any slide will produce transition to this slide",
// "Free Mode" => "Free Mode",
// "If true then slides will not have fixed positions" => "If true then slides will not have fixed positions",
// "Preload Images" => "Preload Images",
// "When enabled Swiper will force to load all images" => "When enabled Swiper will force to load all images",
// "Update On Images Ready" => "Update On Images Ready",
// "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true" => "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true",
// "Loop Slider" => "Loop Slider",
// "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))" => "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))",
// " Please update composer to install required files" => " Please update composer to install required files",
// "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body" => "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body",
"Arrange content in tabs" => "Arrangiere Inhalt in Tabs",
"Tabs content, separated by \"/////\"" => "Inhalte der Tabs, getrennt durch /////",
"Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want the last state to be remembered). Example" => "Unique tabset name (if you want the last state to be remembered). Example",
"Tab Titles" => "Tab Titel",
// "Pipe-separated list of tab titles. Example" => "Pipe-separated list of tab titles. Example",
"Toggle Tabs" => "Tabs umschalten",
"Allow toggling between tabs and no-tabs view" => "Erlaubt es zwischen Tab- und Ohne-Tab-Ansicht umzuschalten",
"Inside Pretty Tracker" => "Innerhalb schöner Tracker",
"Parse pretty tracker variables within tabs" => "Parse Schöne-Tracker-Variablen innerhalb von Tabs",
"No tab title specified. At least one must be specified in order for the tabs to appear" => "Kein Tab Titel angegeben. Es muss aber mindestens einer angegeben werden, damit die Tabs dargestellt werden",
"Apply an HTML tag to content" => "Wende eine HTML Tag auf einen Inhalt an",
"Tag Name" => "Tag-Name",
// "Any valid HTML tag, 0% by default" => "Any valid HTML tag, 0% by default",
"Equivalent to the style attribute of an HTML tag" => "Gleichbedeutend mit dem Style-Attribut eines HTML-Tag",
"Timeline" => "Zeitleiste",
"Display a timeline" => "Zeigt eine Zeitleiste",
// "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)" => "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)",
// "Width of the timeline as CSS units (default: %0)" => "Width of the timeline as CSS units (default: %0)",
// "Height of the timeline as CSS units (default: %0)" => "Height of the timeline as CSS units (default: %0)",
"Primary Scale Unit" => "Primäre Skaleneinheit",
// "Unit of time to use for the primary scale (default is Month)" => "Unit of time to use for the primary scale (default is Month)",
"Decade" => "Jahrzent",
"Century" => "Jahrhundert",
"Secondary Scale Unit" => "Sekundäre Skaleneinheit",
// "Unit of time to use for the secondary scale" => "Unit of time to use for the secondary scale",
"TimeSheet" => "Zeiterfassung",
// "Embed a timesheet into a page" => "Embed a timesheet into a page",
"Title Search" => "Titelsuche",
// "Search page titles" => "Search page titles",
"Search Criteria" => "Suchkriterien",
"Portion of a page name" => "Teil eines Seitennamens",
"Also show page hits or user" => "Zeige ebenfalls Seitentreffer oder Benutzer",
// "Hits and user" => "Hits and user",
// "User and hits" => "User and hits",
"Pipe-separated list of page names to exclude from results" => "Mit Senkrechtstrichen getrennte Liste von Seitennamen, die vom Suchergebnis ausgeschlossen werden sollen",
"No Header" => "Kein Kopf",
// "Set to Yes (%0) to have no header for the search results" => "Set to Yes (%0) to have no header for the search results",
"No pages found for title search" => "Titelsuche hat keine Seiten gefunden",
"One page found for title search" => "Titelsuche hat eine Seite gefunden",
"pages found for title search" => "Seiten bei Titelsuche gefunden",
"Table of Contents (Structure)" => "Inhaltsverzeichnis (Struktur)",
// "Display a table of contents of pages in a structure" => "Display a table of contents of pages in a structure",
"Structure ID" => "Struktur-ID",
// "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided" => "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided",
// "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided" => "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided",
"Order items in ascending or descending order (default is ascending)" => "Sortiere Objekte in auf- oder absteigender Reihenfolge. Standardmäßig wird absteigend sortiert",
// "Sort Order" => "Sort Order",
// "Order for the first Level of pages that will be displayed. Order by structure is the default" => "Order for the first Level of pages that will be displayed. Order by structure is the default",
// "Structure Order" => "Structure Order",
// "Alphabetic Order" => "Alphabetic Order",
// "Display the page description in front of the page name" => "Display the page description in front of the page name",
"Show Numbering" => "Zeige Nummerierung",
"Display the section numbers or not" => "Zeige die Abschnittnummerierung oder nicht",
"Style to apply" => "Anzuwendender Stil",
"Admin" => "Verwalten",
// "Start Level" => "Start Level",
// "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)" => "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)",
// "Maximum Level Depth" => "Maximum Level Depth",
// "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)" => "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)",
// "Together" => "Together",
// "Collaborate in real time" => "Collaborate in real time",
// "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience" => "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience",
// "Button Name" => "Button Name",
// "Set the button name. Default is CoWrite with TogetherJS" => "Set the button name. Default is CoWrite with TogetherJS",
// "CoWrite with TogetherJS" => "CoWrite with TogetherJS",
// "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time" => "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time",
// "Tour" => "Tour",
// "Quick and easy way to build your product tours with Bootstrap popovers" => "Quick and easy way to build your product tours with Bootstrap popovers",
// "Content of the step" => "Content of the step",
// "Element" => "Element",
// "Element to show the popup on; if empty, use the plugin location itself" => "Element to show the popup on; if empty, use the plugin location itself",
// "Title of the step" => "Title of the step",
// "Index of the step to show after this one, starting from 0, -1 for the last one" => "Index of the step to show after this one, starting from 0, -1 for the last one",
// "Index of the step to show before this one, starting from 0, -1 not to show" => "Index of the step to show before this one, starting from 0, -1 not to show",
// "Path to the page on which the step should be shown" => "Path to the page on which the step should be shown",
// "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below" => "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below",
// "Placement" => "Placement",
// "The placement of the popup" => "The placement of the popup",
// "Orphan" => "Orphan",
// "Setting to true removes the pointer on the popup and centers it on the page" => "Setting to true removes the pointer on the popup and centers it on the page",
// "Backdrop" => "Backdrop",
// "Show a dark backdrop behind the popover and its element, highlighting the current step" => "Show a dark backdrop behind the popover and its element, highlighting the current step",
// "Only Show Once" => "Only Show Once",
// "Show automatically only once. tour_id should also be set if there are multiple tours" => "Show automatically only once. tour_id should also be set if there are multiple tours",
// "Show Until Dismissed" => "Show Until Dismissed",
// "Show automatically only until dismissed. tour_id should also be set if there are multiple tours" => "Show automatically only until dismissed. tour_id should also be set if there are multiple tours",
// "Tour ID" => "Tour ID",
// "Set a tour ID to be able to only show the tour once" => "Set a tour ID to be able to only show the tour once",
// "Restart Button" => "Restart Button",
// "Display a button to restart the tour. Enter the text to appear on the button" => "Display a button to restart the tour. Enter the text to appear on the button",
"Translate" => "Übersetzen",
"Translate text to the user language" => "Übersetze Text in die Sprache des Benutzer",
// "Embed a form to populate a tracker" => "Embed a form to populate a tracker",
"Numeric value representing the tracker ID" => "Numerischer Wert der Tracker-ID",
"Fields" => "Felder",
// "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0" => "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0",
// "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters" => "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters",
// "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically" => "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically",
// "Action Style" => "Action Style",
// "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example" => "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example",
// "Display the title of the tracker at the top of the form (not shown by default)" => "Display the title of the tracker at the top of the form (not shown by default)",
"Show the tracker's description (not shown by default)" => "Zeige die Tracker-Beschreibung (wird standardmäßig nicht gezeigt)",
// "Show Fields Descriptions" => "Show Fields Descriptions",
// "Show the tracker's field descriptions (shown by default)" => "Show the tracker's field descriptions (shown by default)",
"Mark Mandatory" => "Als zwingend markieren",
"Indicate mandatory fields with an asterisk (shown by default)" => "Zwingende Felder mit einem Stern versehen (wird standardmäßig so gezeigt)",
"Show Status" => "Zeige Status",
"Show the status of the items (not shown by default)" => "Zeige den Status der Einträge (wird standardmäßig nicht gezeigt)",
"Embedded" => "eingebettet",
// "To send an email once the tracker item has been created. Format: %0from" => "To send an email once the tracker item has been created. Format: %0from",
// "template%0" => "template%0",
// "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)" => "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)",
// "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used" => "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used",
// "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)" => "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)",
// "Keep params in URL" => "Keep params in URL",
// "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL" => "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL",
"URL Target" => "URL-Ziel",
// "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)" => "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)",
"Self" => "selbst",
"Overwrite" => "Überschreiben",
// "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)" => "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)",
// "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)" => "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)",
// "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item" => "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item",
"Label for the reset button, to return all fields to their default values" => "Bezeichnung der Reset-Schaltfläche, um alle Werte auf die Standardwerte zurückzusetzen",
"reset" => "zurücksetzen",
// "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)" => "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)",
// "User&field" => "User&field",
// "User field to filter" => "User field to filter",
// "User field to filter user tracker items to" => "User field to filter user tracker items to",
// "Field to filter" => "Field to filter",
// "Field to filter user tracker items to" => "Field to filter user tracker items to",
// "Field to filter Value" => "Field to filter Value",
// "Value to filter user tracker items to" => "Value to filter user tracker items to",
// "Criteria" => "Criteria",
// "If more than one item found, will choose under this criteria. Used in combination with" => "If more than one item found, will choose under this criteria. Used in combination with",
// "creationDate - Ascending" => "creationDate - Ascending",
// "creationDate - Descending" => "creationDate - Descending",
"Status of the item used in combination with" => "Status des benutzten Eintrages in Kombination mit",
"or" => "oder",
// "Transaction name" => "Transaction name",
// "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name" => "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name",
// "Transaction Step" => "Transaction Step",
// "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0" => "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0",
// "Final Transaction Step" => "Final Transaction Step",
// "Indicate whether this is the final transaction step" => "Indicate whether this is the final transaction step",
// "Transaction previous URL" => "Transaction previous URL",
// "The page to go back to when the \"previous\" button is clicked" => "The page to go back to when the \"previous\" button is clicked",
// "Transaction previous button label" => "Transaction previous button label",
// "Text for the \"previous\" button label" => "Text for the \"previous\" button label",
"ItemId" => "Eintrag-ID",
// "ItemId identifying the item to be edited" => "ItemId identifying the item to be edited",
"Ignore ItemId" => "Ignoriere Eintrag-ID",
// "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)" => "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)",
"Template File" => "Vorlagendatei",
// "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template" => "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template",
// "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template" => "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template",
"New Status" => "Neuer Status",
// "Default status applied to newly created or saved items" => "Default status applied to newly created or saved items",
// "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form",
// "Autosave Fields" => "Autosave Fields",
// "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave" => "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave",
// "Autosave Values" => "Autosave Values",
// "Colon-separated values corresponding to %0. Special syntax cases" => "Colon-separated values corresponding to %0. Special syntax cases",
// "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field" => "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field",
// "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name" => "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name",
// "Increase-only Fields" => "Increase-only Fields",
// "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field" => "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field",
"Registration Fields" => "Registrierungsfelder",
// "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers" => "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers",
// "Register to group" => "Register to group",
// "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)" => "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)",
// "Validate users" => "Validate users",
// "Here one can overrule the default validate users by e-mail preference" => "Here one can overrule the default validate users by e-mail preference",
"Output To Wiki" => "Ausgabe an Wiki",
// "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId" => "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId",
"Discard After Output" => "Nach Ausgabe verwerfen",
// "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages" => "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages",
"Template Page" => "Vorlagenseite",
// "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5" => "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5",
// "Output Wiki Namespace" => "Output Wiki Namespace",
// "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page" => "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page",
// "Store Relation" => "Store Relation",
// "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)" => "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)",
"Multiple Fill Fields" => "Multiple Felder füllen",
// "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0" => "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0",
// "Fill Fields Separator" => "Fill Fields Separator",
// "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)" => "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)",
// "Fill Fields Defaults" => "Fill Fields Defaults",
"Colon-separated list of default values for Multiple Fill Fields" => "Mit Doppelpunkt getrennte Liste von Standardwerten zur Füllung multipler Felder",
"Embed the tracker in a form tag" => "Bette den Tracker in ein Form-Tag ein",
// "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons" => "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons",
// "Use ajax to create/update tracker items" => "Use ajax to create/update tracker items",
// "Use ajax to create and update tracker items instead of form submission via request variables" => "Use ajax to create and update tracker items instead of form submission via request variables",
// "Transactions" => "Transactions",
// "You need to define both transaction name and transaction step, or none of the two" => "You need to define both transaction name and transaction step, or none of the two",
// "You need to choose transactionFinalStep (y/n)" => "You need to choose transactionFinalStep (y/n)",
// "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button" => "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button",
// "Tracker: Field #%0 not found in fields parameter or template" => "Tracker: Field #%0 not found in fields parameter or template",
"The page to output the results to already exists. Try another name" => "Die Seite, auf die die Ergebnisse ausgegeben werden sollen, existiert bereits. Versuche einen anderen Namen",
// "Tracker Transaction: Field #%0 not found in fields parameter or template" => "Tracker Transaction: Field #%0 not found in fields parameter or template",
"Tracker was modified at " => "Tracker wurde verändert auf ",
// "Form saved successfully" => "Form saved successfully",
"Incorrect fieldId" => "Ungültige FeldID",
"Following fields are incorrect" => "Die folgenden Felder sind nicht korrekt",
// "Error: Read only field \"%0\"" => "Error: Read only field \"%0\"",
// "This field is mandatory" => "This field is mandatory",
"Missing wiki template page \"%0\"" => "Es fehlt die Wiki Vorlagenseite \"%0\"",
"Each line is a list of %d field values separated with: %s" => "Jede Zeile ist eine Liste von %d Feldwerten, getrennt mit: %s",
"You do not have permission to insert an item" => "Du hast keine Berechtigung einen Eintrag einzufügen",
"Incorrect item" => "Falscher Eintrag",
"You do not have permission to modify an item" => "Du hast keine Berechtigung einen Eintrag zu verändern",
"The page to output the results to contains the following prohibited characters: %0. Try another name" => "Die Seite, auf welche die Ergebnisse ausgegeben werden sollen, enthält ungültige Zeichen, nämlich: %0. Versuche einen anderen Namen",
// "Please ensure you are using the correct field ID and that it is properly included in the template, if any" => "Please ensure you are using the correct field ID and that it is properly included in the template, if any",
"Passwords do not match" => "Passwörter stimmen nicht überein",
"Insert one item per line" => "Füge einen Eintrag pro Zeile hinzu",
"Fields marked with an * are mandatory." => "Mit * markierte Felder sind zwingend.",
// "Tracker Calendar" => "Tracker Calendar",
// "Create and display a calendar using tracker data" => "Create and display a calendar using tracker data",
// "Resource Descriptor Field" => "Resource Descriptor Field",
// "Permanent name of the field to use as the resource indicator" => "Permanent name of the field to use as the resource indicator",
// "Coloring Discriminator Field" => "Coloring Discriminator Field",
// "Permanent name of the field to use to segment the information into color schemes" => "Permanent name of the field to use to segment the information into color schemes",
// "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages" => "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages",
// "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)" => "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)",
// "Add All Fields" => "Add All Fields",
// "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId" => "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId",
// "Use Session Storage" => "Use Session Storage",
// "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript" => "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript",
// "Agenda by Months" => "Agenda by Months",
// "Display the option to change the view to agenda by months" => "Display the option to change the view to agenda by months",
// "Agenda by Weeks" => "Agenda by Weeks",
// "Display the option to change the view to agenda by weeks" => "Display the option to change the view to agenda by weeks",
// "Agenda by Days" => "Agenda by Days",
// "Display the option to change the view to agenda by days" => "Display the option to change the view to agenda by days",
// "List by Years" => "List by Years",
// "Display the option to change the view to list by years" => "Display the option to change the view to list by years",
// "List by Months" => "List by Months",
// "Display the option to change the view to list by months" => "Display the option to change the view to list by months",
// "List by Weeks" => "List by Weeks",
// "Display the option to change the view to list by weeks" => "Display the option to change the view to list by weeks",
// "List by Days" => "List by Days",
// "Display the option to change the view to list by days" => "Display the option to change the view to list by days",
// "Resources by Years" => "Resources by Years",
// "Display the option to change the view to resources by years" => "Display the option to change the view to resources by years",
// "Resources by Months" => "Resources by Months",
// "Display the option to change the view to resources by months" => "Display the option to change the view to resources by months",
// "Resources by Weeks" => "Resources by Weeks",
// "Display the option to change the view to resources by weeks" => "Display the option to change the view to resources by weeks",
// "Resources by Days" => "Resources by Days",
// "Display the option to change the view to resources by days" => "Display the option to change the view to resources by days",
"Default View" => "Standardansicht",
// "Choose the default view for the Tracker Calendar" => "Choose the default view for the Tracker Calendar",
// "Default Year" => "Default Year",
// "Choose the default year (yyyy) to use for the display" => "Choose the default year (yyyy) to use for the display",
// "Default Month" => "Default Month",
// "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc" => "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc",
// "Default Day" => "Default Day",
// "Choose the default day (dd) to use for the display" => "Choose the default day (dd) to use for the display",
// "Colormap for coloring" => "Colormap for coloring",
// "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0" => "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0",
// "First day of the Week" => "First day of the Week",
// "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)" => "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)",
// "Show Weekends" => "Show Weekends",
// "Display Saturdays and Sundays (shown by default)" => "Display Saturdays and Sundays (shown by default)",
// "Day Start" => "Day Start",
// "First time slot that will be displayed for each day, e.g. %0" => "First time slot that will be displayed for each day, e.g. %0",
// "Day End" => "Day End",
// "Last time slot that will be displayed for each day, e.g. %0" => "Last time slot that will be displayed for each day, e.g. %0",
// "Slot Duration" => "Slot Duration",
// "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)" => "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)",
// "Overlapping allowed" => "Overlapping allowed",
// "Allow resources to overlap in time" => "Allow resources to overlap in time",
// "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator" => "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator",
// "Fields not found" => "Fields not found",
"Tracker Comments" => "Trackerkommentare",
// "Display the number of comments for a tracker" => "Display the number of comments for a tracker",
"Item Count" => "Eintragzähler",
"Determines whether the number of items will be shown (not shown by default)" => "Legt fest, ob die Zahl der Einträge angezeigt wird (wird standardmäßig nicht gezeigt)",
"Enter a username to select the items of the current user" => "Trage einen Benutzernamen ein, um die Einträge des gegenwärtigen Benutzers auszuwählen",
"a user name" => "ein Benutzername",
"Comments found" => "Kommentare gefunden",
"Filters" => "Filter",
// "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1" => "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1",
// "Format choices are" => "Format choices are",
// "dropdown" => "dropdown",
// "radio buttons" => "radio buttons",
// "multiple choice dropdown" => "multiple choice dropdown",
// "checkbox" => "checkbox",
// "text with wild characters" => "text with wild characters",
// "exact text match" => "exact text match",
// "initials" => "initials",
// "advanced search" => "advanced search",
// "range search (from/to)" => "range search (from/to)",
// "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal" => "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal",
// "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)" => "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)",
"Display List" => "Anzeigeliste",
"Show the full list (before filtering) initially (filtered list shown by default)" => "Zeige anfänglich vollständige Liste (vor Filterung) (standardmäßig wird gefilterte Liste angezeigt)",
"Displays all the filters on the same line (not shown on same line by default)" => "Zeigt alle Filter in der gleichen Zeile an (standardmäßig nicht in der gleichen Zeile angezeigt)",
"Yes with field label in dropdown" => "Ja mit Feldbezeichnung in Ausklapplistenfeld",
"No Toggle" => "Kein Umschalten",
// "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)" => "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)",
"Export CSV" => "CSV exportieren",
"Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Bezeichnung für die Exportierenschaltfläche. Leer lassen um \"Filter\" anzuzeigen",
// "Export Status Field" => "Export Status Field",
// "Export the status field if the Export CSV option is used" => "Export the status field if the Export CSV option is used",
// "Export Created Date Field" => "Export Created Date Field",
// "Export the created date field if the Export CSV option is used" => "Export the created date field if the Export CSV option is used",
// "Export Modified Date Field" => "Export Modified Date Field",
// "Export the modified date field if the Export CSV option is used" => "Export the modified date field if the Export CSV option is used",
// "Export Character Set" => "Export Character Set",
// "Character set to be used if the Export CSV option is used" => "Character set to be used if the Export CSV option is used",
// "Map View Buttons" => "Map View Buttons",
"Display Mapview and Listview buttons" => "Zeige Schaltflächen für Karten- und Listenansicht",
// " - was %0 until 12.0" => " - was %0 until 12.0",
"Tracker Filter" => "Trackerfilter",
"Create a form to filter tracker fields" => "Erstelle eine Formular, um Trackerfelder zu filtern",
"notice" => "Hinweis",
// "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set" => "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set",
// "TrackerFields: Unknown tracker field used in the parameter \"filters\"" => "TrackerFields: Unknown tracker field used in the parameter \"filters\"",
"tracker field type not processed yet" => "Tracker Feldtyp noch nicht bearbeitet",
"Tracker If" => "Tracker wenn",
"Display content based on results of a tracker field test" => "Zeige Inhalt basierend auf Ergebnissen eines Trackerfeld-Tests",
"Ignore" => "Ignorieren",
"Ignore test in edit mode" => "Ignoriere Test in Bearbeitungsmodus",
"Copy Tracker Item" => "Kopiere Trackereintrag",
"PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Copy a tracker item" => "Copy a tracker item",
// "Tracker from which to copy item, joined tracker ids separated by %0:%1" => "Tracker from which to copy item, joined tracker ids separated by %0:%1",
// "Link Field IDs" => "Link Field IDs",
// "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1" => "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1",
// "Copy Field IDs" => "Copy Field IDs",
// "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1" => "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1",
// "Update Field IDs" => "Update Field IDs",
// "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1" => "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1",
"New Values" => "Neue Werte",
// "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId" => "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId",
"ID of item to make copy of, otherwise input is asked for" => "ID des Eintrages von dem eine Kopie erstellt wird. Andernfalls wird nach einer Eingabe gefragt",
"Make this number of copies on load" => "Erstelle Anzahl von Kopien beim Laden",
"Set the number of copies to make on load of plugin automatically" => "Legt die Anzahl von Kopien fest, die das Plugin beim Laden automatisch erstellt",
"Returns array non-interactively" => "Gibt Array nicht interaktiv zurück",
// "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode" => "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode",
"Missing mandatory parameters" => "Es fehlen erforderliche Parameter",
"Number of update fields do not match new values" => "Anzahl von Update-Feldern stimmt nicht mit neuen Werten überein",
"Tracker Item Field" => "Tracker Eintrag-Feld",
"Display or test the value of a tracker item field" => "Zeige oder teste den Wert eines Trackerfeldes",
// "Wiki text containing an %0{ELSE}%1 marker" => "Wiki text containing an %0{ELSE}%1 marker",
// "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user" => "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user",
"Numeric value representing the field ID displayed or tested" => "Numerischer Wert, der die Feld-ID repräsentiert, welche angezeigt oder gestestet wird",
"Colon-separated list of field IDs. Default is all fields" => "Durch Doppelpunkt getrennte Liste von FeldIDs. Standardmäßig alle Felder",
"Status of the tracker item" => "Status des Trackereintrags",
"Open & Pending" => "Offen & unerledigt",
"Open & Closed" => "Offen & geschlossen",
"Pending & Closed" => "Unerledigt & geschlossen",
"Open, Pending & Closed" => "Offen, unerledigt & geschlossen",
// "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter" => "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter",
"Value to compare against" => "Wert, gegen den verglichen werden soll",
"You are not allowed to view this item" => "Du hast keine Berechtigung diesen Eintrag anzusehen",
"You don't have permission to view this field" => "Du hast keine Berechtigung dieses Feld anzusehen",
// "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1" => "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1",
// "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default" => "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default",
// "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param" => "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param",
"Sticky Popup" => "Klebriges Popup",
// "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)",
"Display the title of the tracker (not shown by default)" => "Zeige den Titel des Trackers an (wird standardmäßig nicht gezeigt)",
"Show Links" => "Zeige Links",
// "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work" => "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work",
"Row" => "Reihe",
"Show Item Count" => "Zeige Eintragzähler",
"Show the number of items found (not shown by default)" => "Zeige die Nummer von gefundenen Einträgen (standardmäßig nicht angezeigt)",
"Show Initials" => "Zeige Anfangsbuchstaben",
// "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)" => "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)",
// "Creation date display is based on tracker settings unless overridden here" => "Creation date display is based on tracker settings unless overridden here",
"Last Modification Date" => "Datum der letzten Veränderung",
// "Last modification date display is based on tracker settings unless overridden here" => "Last modification date display is based on tracker settings unless overridden here",
// "Last modified by user display is based on tracker settings unless overridden here" => "Last modified by user display is based on tracker settings unless overridden here",
"Show Field Name" => "Zeige Feldnamen",
"Use the field names as column titles (used by default)" => "Benutze die Feldnamen als Spaltentitel (standardmäßig so benutzt)",
"Show Item Rank" => "Zeige Eintragrang",
"Show item ranks (not shown by default)" => "Zeige Rang des Eintrages (standardmäßig nicht angezeigt)",
// "Show comments count or last comment date and user depending on tracker preferences" => "Show comments count or last comment date and user depending on tracker preferences",
"Only show items matching certain status filters (only items with open status shown by default)" => "Zeige nur Objekte, die einen bestimmten Status haben (standardmäßig werden nur Objekte mit dem Status: offen angezeigt)",
// "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified" => "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified",
// "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)" => "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)",
"Sort Choice" => "Sortiersart",
// "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1" => "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1",
// "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1" => "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1",
"Offset of first item. Default is no offset" => "Versatz des ersten Objekts. Standardmäßig kein Versatz",
"Fix offset always (no pagination)" => "Immer fester Abstand (keine Paginierung)",
// "Fix offset to that specified. This will disallow pagination" => "Fix offset to that specified. This will disallow pagination",
"Show Pagination" => "Zeige Paginierung",
"Determines whether pagination will be shown (shown by default)" => "Legt fest, ob Paginierung angezeigt wird (wird standardmäßig angezeigt)",
// "Show button to make entire width of tables visible" => "Show button to make entire width of tables visible",
// "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)" => "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)",
"Filter Field" => "Filter Feld",
"Colon-separated list of fields to allow filtering on" => "Doppelpunktgetrennte Liste von Feldern, nach denen gefiltert werden darf",
"Filter Value" => "Filter Wert",
// "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match" => "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match",
// "text that ends in \"value\"" => "text that ends in \"value\"",
// "text that begins with \"value\"" => "text that begins with \"value\"",
// "the current user's login name" => "the current user's login name",
// "the current user's default group" => "the current user's default group",
// "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead" => "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead",
// "any text" => "any text",
"Exact Value" => "genauer Wert",
// "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by" => "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by",
// "tracker item is in category with ID x or one its descendants" => "tracker item is in category with ID x or one its descendants",
// "tracker item is not in category with ID x or one of its descendants" => "tracker item is not in category with ID x or one of its descendants",
// "match against the value of a Tiki preference" => "match against the value of a Tiki preference",
// "match if value does not equal a Tiki preference value" => "match if value does not equal a Tiki preference value",
// "match if the field does not equal \"value\"" => "match if the field does not equal \"value\"",
// "match for non empty values (opposite with %0exactvalue%1=\"\")" => "match for non empty values (opposite with %0exactvalue%1=\"\")",
// "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)" => "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)",
// "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )" => "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )",
// "match if less than \"value\"" => "match if less than \"value\"",
// "match if greater than \"value\"" => "match if greater than \"value\"",
// "match if less than or equal to \"value\"" => "match if less than or equal to \"value\"",
// "match if greater than or equal to \"value\"" => "match if greater than or equal to \"value\"",
// "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are" => "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are",
// "the value of this field will be posted to the action" => "the value of this field will be posted to the action",
// "the name of the post" => "the name of the post",
// "the title of the submit button" => "the title of the submit button",
// "the name of the submit button" => "the name of the submit button",
// "the file that will be called upon submit" => "the file that will be called upon submit",
// "optional template inserted before the submit button and returned" => "optional template inserted before the submit button and returned",
// "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1" => "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1",
// "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case" => "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case",
// "comma-separated list of pre-checked items" => "comma-separated list of pre-checked items",
// "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1" => "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1",
// "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1" => "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1",
"goIfOne" => "Nur 1 Ergebnis",
// "Display the item rather than list if only one item is found" => "Display the item rather than list if only one item is found",
// "Show a 'more' button that links to the tracker item (not shown by default)" => "Show a 'more' button that links to the tracker item (not shown by default)",
"More link pointing to specified URL instead of default tracker item link" => "Mehr-Link, der auf eine bestimmte URL zeigt anstelle auf den Standard Tracker-Eintrag-Link",
// "Display only the items of the following" => "Display only the items of the following",
// "the current user" => "the current user",
// "the current page name" => "the current page name",
// "the current IP address" => "the current IP address",
// "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1" => "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1",
// "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins" => "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins",
// "Template Wiki Page" => "Template Wiki Page",
// "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins" => "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins",
"View User" => "Benutzer ansehen",
"Will display the items of the specified user" => "Zeigt die Objekte des angegebenen Benutzers",
// "Colon-separated list of item IDs to restrict the listing to" => "Colon-separated list of item IDs to restrict the listing to",
"Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignoriere den EintragID-URL-Parameter beim Filtern der Liste (wird standardmäßig nicht ignoriert)",
// "The link that will be on each main field when %0showlinks=\"y\"%1. Special values" => "The link that will be on each main field when %0showlinks=\"y\"%1. Special values",
// "will link to the item based on its item ID" => "will link to the item based on its item ID",
// "will link to the item based on its offset value" => "will link to the item based on its offset value",
// "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused" => "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused",
// "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example" => "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example",
// "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties" => "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties",
// "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1" => "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1",
// "Left Delimiter" => "Left Delimiter",
// "Smarty left delimiter for Latex generation. Example" => "Smarty left delimiter for Latex generation. Example",
// "Right Delimiter" => "Right Delimiter",
// "Smarty right delimiter for Latex generation Example" => "Smarty right delimiter for Latex generation Example",
"List Mode" => "Listenmodus",
// "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting",
"Comma Separated Values" => "Kommagetrennte Werte",
"Export Button" => "Exportschaltfläche",
"Show an export button (not shown by default)" => "Zeige eine Exportierenschaltfläche (standardmäßig nicht angezeigt)",
"Compute" => "Bereche",
// "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable" => "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable",
"fieldId" => "FeldID",
// "%0, separated by %1" => "%0, separated by %1",
"Silent" => "still",
// "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)",
"Show Delete" => "Zeige Löschen",
// "Show a delete icon for each item (not shown by default)" => "Show a delete icon for each item (not shown by default)",
// "Url to redirect to after delete" => "Url to redirect to after delete",
"Show Open Item" => "Zeige offenen Eintrag",
"Show an open item  option (not shown by default)" => "Zeige Option für offenen Eintrag (wird standardmäßig nicht gezeigt)",
"Show Close Item" => "Zeige geschlossenen Eintrag",
"Show a close item option (not shown by default)" => "Zeige Option für geschlossenen Eintrag (wird standardmäßig nicht gezeigt)",
"Show Pending Item" => "Zeige anstehenden Eintrag",
"Show a pending item option (not shown by default)" => "Zeige Optionen für einen anstehenden Eintrag (standardmäßig nicht angezeigt)",
"Show Watch Button" => "Zeige Beobachtenschaltfläche",
"Show a watch button (not shown by default)" => "Zeige eine Beobachtungsschaltfläche (standardmäßig nicht angezeigt)",
"Show Feed Button" => "Zeige Feed-Schaltfläche",
"Show an RSS feed button (not shown by default)" => "Zeige eine RSS-Feed-Schaltfläche (standardmäßig nicht angezeigt)",
// "Show Results Map" => "Show Results Map",
// "Show Map of results (not shown by default)" => "Show Map of results (not shown by default)",
"Calendar Field IDs" => "Kalenderfeld-IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1",
"Calendar View Mode" => "Kalenderansichtsmodus",
"Calendar view type time span (default is month)" => "Kalenderansichtsspanne (Standard ist month für Monat)",
"Two months" => "Two months",
"Trimester" => "Trimester",
"Calendar Popup" => "Kalender-Popup",
// "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)" => "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)",
// "Calendar item popups will stay open if set to y (Yes). Not sticky by default" => "Calendar item popups will stay open if set to y (Yes). Not sticky by default",
"Beginning of Month" => "Beginn des Monats",
"Set whether calendar will begin at the beginning of the month (does by default)" => "Lege fest, ob der Kalender am Monatsanfang beginnen soll (ist standardmäßig so eingestellt)",
"Show calendar navigation bar (shown by default)" => "Zeige Kalendernavigationsbalken (standardmäßig angezeigt)",
"Partial" => "Teilweise",
"Calendar Title" => "Kalendertitel",
"Enter a title to display a calendar title (not set by default)" => "Lege einen Titel für den Kalender fest (standardmäßig nicht eingestellt)",
"Calendar Delta" => "Kalender-Abweichung",
"Set the calendar delta that will be shown (not set by default)" => "Lege die Kalenderabweichung fest, die angezeigt wird (standardmäßig nicht eingestellt)",
"Plus Month" => "Plus Monat",
"Minus Month" => "Minus Monat",
"Plus Two months" => "Plus Two months",
"Minus Two months" => "Minus Two months",
"Display Spreadsheet" => "Zeige Tabelle",
"Display tracker as a spreadsheet (not used by default)" => "Zeige Tracker als Tabelle (standardmäßig nicht benutzt)",
"Force Compile" => "Erzwinge Zusammenstellen",
// "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)" => "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)",
"Period type" => "Abschnittstyp",
"Time period after creation or after modification" => "Zeitabschnitt nach Erstellung oder nach Veränderung",
"Creation" => "Erstellung",
"Modification" => "Veränderung",
// "Inline edit" => "Inline edit",
// "Colon-separated list of fields for which inline editing will be enabled" => "Colon-separated list of fields for which inline editing will be enabled",
// "Inline edit All" => "Inline edit All",
"Allow all displayed fields to be editable" => "Gestatte, dass alle angezeigte Felder veränderbar sind",
// "Compile Each Item" => "Compile Each Item",
// "Compile each item separately instead of compiling the entire template" => "Compile each item separately instead of compiling the entire template",
"Tracker List" => "Trackerliste",
"List, filter and sort the items in a tracker" => "Liste auf, filtere und sortiere Einträge eines Trackers",
// "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y" => "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y",
// "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly" => "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly",
// "For best results the date filter should only be applied to date field types" => "For best results the date filter should only be applied to date field types",
// "To filter the category field type, the exact category name or id needs to be entered" => "To filter the category field type, the exact category name or id needs to be entered",
"incorrect filterfield" => "falsches Filterfeld",
// "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field" => "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field",
"Error in tracker ID" => "Fehler in der Tracker-ID",
"No field indicated" => "Kein Feld angegeben",
"Check Tracker Passcodes" => "Prüfe Tracker Passwörter",
"PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Verify a tracker passcode" => "Verify a tracker passcode",
// "Session Key Names" => "Session Key Names",
"Tracker Prefill" => "Tracker Vorfüllung",
"Create a button to prefill tracker fields" => "Erstelle eine Schaltfläche, um Tracker vorauszufüllen",
// "Tracker page name" => "Tracker page name",
"URL Parameters" => "URL-Parameter",
// "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1" => "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1",
"Field 1" => "Feld 1",
"Field ID for the first field" => "Feld-ID für das erste Feld",
"Value 1" => "Wert 1",
"Content that should be used to prefill the field" => "Inhalt, der zur Vorfüllung des Feldes genutzt werden soll",
"Field 2" => "Feld 2",
"Field ID for the second field" => "Feld-ID für das zweite Feld",
"Value 2" => "Wert 2",
"Field 3" => "Feld 3",
"Field ID for the third field" => "Feld-ID für das dritte Feld",
"Value 3" => "Wert 3",
"Field 4" => "Feld 4",
"Field ID for the fourth field" => "Feld-ID für das vierte Feld",
"Value 4" => "Wert 4",
"Field 5" => "Feld 5",
"Field ID for the fifth field" => "Feld-ID für das fünfte Feld",
"Value 5" => "Wert 5",
"Field 6" => "Feld 6",
"Field ID for the sixth field" => "Feld-ID für das sechste Feld",
"Value 6" => "Wert 6",
"Field 7" => "Feld 7",
"Field ID for the seventh field" => "Feld-ID für das siebte Feld",
"Value 7" => "Wert 7",
"Field 8" => "Feld 8",
"Field ID for the eighth field" => "Feld-ID für das achte Feld",
"Value 8" => "Wert 8",
// "Tracker Query Template" => "Tracker Query Template",
// "Generate a form from tracker data" => "Generate a form from tracker data",
// "Wiki Syntax, with variables from tracker query" => "Wiki Syntax, with variables from tracker query",
// "The name of the tracker to be queried, or if %0, the tracker ID" => "The name of the tracker to be queried, or if %0, the tracker ID",
// "Turn tracker query debug on (off by default)" => "Turn tracker query debug on (off by default)",
// "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs" => "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs",
// "Render" => "Render",
// "Render as needed for trackers (default)" => "Render as needed for trackers (default)",
// "Item id of tracker item" => "Item id of tracker item",
// "Tracker Item Ids" => "Tracker Item Ids",
// "Item id of tracker items, separated with comma" => "Item id of tracker items, separated with comma",
// "Like Filters" => "Like Filters",
// "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "And Filters" => "And Filters",
// "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Or Filters" => "Or Filters",
// "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Get Last" => "Get Last",
// "Retrieve only the last item from the tracker" => "Retrieve only the last item from the tracker",
"Tracker Stats" => "Tracker Statistik",
"Display statistics about a tracker." => "Zeige Statistiken zu einem Tracker.",
// "Colon-separated list of field IDs to be displayed. Example" => "Colon-separated list of field IDs to be displayed. Example",
// ". " => ". ",
// "Leave it empty to display all fields from this tracker" => "Leave it empty to display all fields from this tracker",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)" => "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)",
// "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)" => "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)",
"Only show items matching certain status filters" => "Zeige nur solche Einträge, die mit bestimmten Statusfiltern übereinstimmen",
// "Add a link to the tracker" => "Add a link to the tracker",
// "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example" => "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example",
"invalid status" => "ungültiger Status",
"incorrect fieldId" => "falsche Feld-Id",
"Tracker Timeline" => "Tracker Zeitleiste",
"Show a timeline view of a tracker" => "Zeige einen Zeitleistenansicht eines Trackers",
"Title Field" => "Titellfeld",
"Tracker Field ID containing the item title" => "Tracker Feld-ID, die den Eintragtitel enthält",
"Summary Field" => "Summenfeld",
// "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
"Element Group" => "Elementgruppe",
// "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row",
"Lower Bound" => "Untere Grenze",
// "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Upper Bound" => "Obere Grenze",
// "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Zeiteinheit für die primäre Skala (Standard ist Stunde - * nur Vergleich)",
"Decade *" => "Dekade *",
"Century *" => "Jahrhundert *",
"Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Zeiteinheit für die sekundäre Skala (Standard ist leer - * nur Vergleich)",
"Timeline height" => "Höhe Zeitleiste",
// "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)",
"Lower band height" => "Höhe untere Leiste",
// "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)",
"Link Group Name" => "Link Gruppenname",
"Convert the group name to a link" => "Konvertiere den Gruppennamen zu einem Link",
"Page Link Field" => "Seitenlink-Feld",
"Tracker Field ID containing the page name for item details" => "Tracker Feld-ID, die den Seitennamen für Eintragdetails enthält",
"SIMILE Timeline" => "SIMILE Zeitleiste",
"Use the SIMILE Timeline Widget" => "Benutze das SIMILE Zeileisten-Widget",
"Image Field" => "Bildfeld",
"Tracker Field ID containing in image" => "Tracker Feld-ID, die ein Bild enthält",
"Missing parameter: %0" => "Fehlender Parameter: %0",
"Start date after end date" => "Startdatum liegt nach dem Enddatum",
"Tracker Toggle" => "Tracker umschalten",
"Numeric value representing the field ID tested" => "Numerischer Feld-ID des zu testenden Feldes",
// "Element Visibility" => "Element Visibility",
// "Set whether visible when the field has the value" => "Set whether visible when the field has the value",
"HTML id of the element that is toggled" => "HTML-ID des Elements, das umgeschaltet wird",
// "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set" => "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set",
// "trackertoggle: Param fieldId is required" => "trackertoggle: Param fieldId is required",
// "trackertoggle: Param fieldId field %0 does not exsist" => "trackertoggle: Param fieldId field %0 does not exsist",
// "trackertoggle: Param value is required" => "trackertoggle: Param value is required",
// "trackertoggle: Param id is required" => "trackertoggle: Param id is required",
// "Adjust the visibility of content based on a tracker field's value, possibly dynamically" => "Adjust the visibility of content based on a tracker field's value, possibly dynamically",
"Trade" => "Handel",
// "Send payments between members using cclite" => "Send payments between members using cclite",
"Currency depends on the selected registry" => "Währung hängt von gewählter Registrierung ab",
"Registry to trade in. Default: site preference (or first in list when more than one)" => "Registrierung in die eingetauscht werden soll. Standard: Site-Einstellung (oder erste in der Liste, wenn mehr als eine)",
"Currency to trade in. Default: Cclite currency preference for registry set above" => "Währung in die eingetauscht werden soll. Standard: Cclite Währungseinstellung für die oben eingestellte Registierung",
// "Name of the user to receive or send the payment" => "Name of the user to receive or send the payment",
"Leave empty to display an input box" => "Lasse leer, um eine Eingabebox anzuzeigen",
"Offered or wanted item" => "Angebotenes oder gesuchtes Objekt",
// "%0Offered%1" => "%0Offered%1",
"Offered" => "Angebotenes",
"Wanted" => "Gesucht",
// "%0Continue%1" => "%0Continue%1",
"Title of the input form" => "Titel des Eingabeformulars",
// "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted",
"Please log in" => "Bitte anmelden",
" needs to validate their account" => " muss sein Benutzerkonto validieren",
"Transclude" => "Vorlageneinbindung",
"PluginTransclude" => "PluginTransclude",
"Include the content of another page with certain changes" => "Binde den Inhalt einer anderen Seite mit gewissen Änderungen ein",
"Name of the wiki page to use as a template for the values" => "Name der Wiki Seite, die als Vorlage für die Werte genommen werden soll",
"Attempt to include a page that cannot be viewed" => "Versuch eine Seite einzubinden, die nicht angesehen werden kann",
"Page named \"%0\" does not exist at this time" => "Die Seite \"%0\" existiert derzeit nicht",
"Translated" => "Übersetzt",
// "Create multilingual links" => "Create multilingual links",
"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] oder ((wikiname)) oder ((inter:interwiki)) (Benutze Wiki Syntax)",
// "Two letter language code of the language, example" => "Two letter language code of the language, example",
"Flag" => "Flagge",
// "Country name, example" => "Country name, example",
// "Translate a link from one language to another" => "Translate a link from one language to another",
// "TranslationOf" => "TranslationOf",
// "Original Page" => "Original Page",
// "Name of the page from which this link will be translated" => "Name of the page from which this link will be translated",
// "Translation Language" => "Translation Language",
// "Two letter language code of the language in which you want to translate this\n                    link. Example" => "Two letter language code of the language in which you want to translate this\n                    link. Example",
// "Translation Name" => "Translation Name",
// "Name of the page that will become the translation of the \"Original Page\"" => "Name of the page that will become the translation of the \"Original Page\"",
// "Translate this link" => "Translate this link",
"Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Twitter Path" => "Twitter Path",
// "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. " => "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. ",
// "Widget Id" => "Widget Id",
// "Numeric identifier of the widget" => "Numeric identifier of the widget",
// "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1" => "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1",
// "light" => "light",
// "dark" => "dark",
// "Link Color" => "Link Color",
// "Text color for individual tweets. Default is theme default" => "Text color for individual tweets. Default is theme default",
"Valid HTML color codes (with beginning #) or names" => "Gültige HTML-Farb-Codes (beginnen mit #) oder Namen",
// "Border Color" => "Border Color",
// "Change the border color used by the widget. Default is theme default" => "Change the border color used by the widget. Default is theme default",
// "Height of widget in pixels. Default is %0" => "Height of widget in pixels. Default is %0",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is %0" => "Width of widget in pixels or 'auto' to fit to width of page. Default is %0",
"Number of pixels or the word 'auto'" => "Anzahl von Pixel oder das Wort 'auto'",
// "Default is with Header" => "Default is with Header",
// "No Footer" => "No Footer",
// "Default is with Footer" => "Default is with Footer",
// "Footer" => "Footer",
// "Layout Option: No Borders" => "Layout Option: No Borders",
// "Default is with Borders" => "Default is with Borders",
"Borders" => "Ränder",
// "No Borders" => "No Borders",
// "No Scrollbar" => "No Scrollbar",
// "Default is with Scrollbar" => "Default is with Scrollbar",
// "Scrollbar" => "Scrollbar",
// "Transparent Background" => "Transparent Background",
// "Transparent Shell Background. Default is theme default" => "Transparent Shell Background. Default is theme default",
// "Theme default" => "Theme default",
"User Count" => "Benutzerzähler",
// "Display number of users for a site or one or more groups" => "Display number of users for a site or one or more groups",
// "Group name. If left blank, the total number of users for the site will be shown" => "Group name. If left blank, the total number of users for the site will be shown",
// "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings" => "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings",
// "UserInGroup" => "UserInGroup",
// "checks if an individual user is in a particular Group and simply return a string set to either true or false" => "checks if an individual user is in a particular Group and simply return a string set to either true or false",
// "userId" => "userId",
// "the userId to be checked" => "the userId to be checked",
// "test group" => "test group",
// "the Group that the userId check is made against" => "the Group that the userId check is made against",
// "text for true result" => "text for true result",
// "The text that is displayed if the test result is true" => "The text that is displayed if the test result is true",
// "text for false result" => "text for false result",
// "The text that is displayed if the test result is false" => "The text that is displayed if the test result is false",
// "Last Login information" => "Last Login information",
// "PluginUserLastLogged" => "PluginUserLastLogged",
// "Show the last login information for a given or current user" => "Show the last login information for a given or current user",
// "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank" => "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank",
// "DateFormat" => "DateFormat",
// "Date format setting. Short_datetime used by default" => "Date format setting. Short_datetime used by default",
"User Link" => "Benutzerlink",
"Display a link to a user's information page" => "Zeige einen Link zur Informationsseite des Benutzers",
"User account name (which can be an email address)" => "Name des Benutzerkontos (kann eine E-Mailadresse sein)",
"User List" => "Benutzerliste",
"Display a list of registered users" => "Zeigt eine Liste registrierter Benutzer",
"Login Filter" => "Anmeldefilter",
"Separator to use between users in the list. Default: comma" => "Trennzeichen zwischen Benutzern in der Liste. Standard: Komma",
// "Set to sort in ascending or descending order" => "Set to sort in ascending or descending order",
// "Set to table to display results in a table" => "Set to table to display results in a table",
// "Make the user names listed links to different types of user information" => "Make the user names listed links to different types of user information",
"User info" => "Benutzerinfo",
"User page" => "Benutzerseite",
"User pref" => "Benutzereinstellungen",
"Real Name" => "Tatsächlicher Name",
"Display the user's real name (when available) instead of login name" => "Zeige den Echtnamen des Benutzers anstelle seines Anmeldenamen (wenn verfügbar)",
"Filter on a group" => "Filter auf eine Gruppe",
"Display contents based on user preference settings" => "Zeige Inhalt basierend auf den Benutzereinstellungen",
"Create tabs for showing alternate versions of content" => "Erstelle Tabs um Inhalte verschiedener Versionen anzuzeigen",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault",
// "Display a navigation box that allows users to select a specific version to display" => "Display a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default" => "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default",
"Default Label" => "Standardbezeichnung",
// "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'" => "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'",
// "Embed a Vimeo video" => "Embed a Vimeo video",
// "Complete URL to the Vimeo video. Example" => "Complete URL to the Vimeo video. Example",
// "or leave blank to upload one" => "or leave blank to upload one",
"Quality of the video" => "Qualität des Videos",
"Expand to full screen" => "Erweitere zu Vollbild",
// "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)" => "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)",
// "Numeric ID of a Tracker Files field, using Vimeo displayMode" => "Numeric ID of a Tracker Files field, using Vimeo displayMode",
// "Numeric ID of a Tracker item, using Vimeo displayMode" => "Numeric ID of a Tracker item, using Vimeo displayMode",
// "Gallery ID to upload to" => "Gallery ID to upload to",
// "Froogaloop API" => "Froogaloop API",
// "Use Vimeo Froogaloop API" => "Use Vimeo Froogaloop API",
// "Show the Video Title" => "Show the Video Title",
// "(default is to show)" => "(default is to show)",
// "Show Byline" => "Show Byline",
// "Show Portrait" => "Show Portrait",
// "Vimeo video not found for file #%0" => "Vimeo video not found for file #%0",
// "Feature required" => "Feature required",
// "Feature \"vimeo_upload\" is required to be able to add videos here" => "Feature \"vimeo_upload\" is required to be able to add videos here",
// "You do not have permsission to add files here" => "You do not have permsission to add files here",
// "You do not have permsission modify this tracker item" => "You do not have permsission modify this tracker item",
// "You do not have permsission modify this page" => "You do not have permsission modify this page",
// "Show the creator's byline" => "Show the creator's byline",
// "Show the creator's profile picture" => "Show the creator's profile picture",
"Vote" => "Bewertung",
"Create a tracker for voting" => "Erstelle einen Tracker für Bewertungen",
// "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example" => "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example",
// "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)" => "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)",
// "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)" => "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)",
"Show Stats" => "Zeige Statistiken",
"Choose whether to show the voting results (shown by default)" => "Wähle, ob die Abstimmungsergebnisse angezeigt werden (werden standardmäßig angezeigt)",
"Show Stats After" => "Zeige Statistiken nach",
// "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)",
// "Show Toggle" => "Show Toggle",
// "Show toggle or not to display the form and the results" => "Show toggle or not to display the form and the results",
"Votings" => "Abstimmungen",
"Saves voting information in Smarty variables for display" => "Speichert Abstimmungsinformationen in Smarty-Variablen zur Anzeige",
"Object Key" => "Objektschlüssel",
"Object key that is used to record votes" => "Objektschlüssel für die Aufzeichnung der Abstimmungen",
"Return value" => "Rückgabewert",
"Value to display as output of plugin" => "Anzuzeigender Wert als Ausgabe des Plugins",
"Wanted Pages" => "Gesuchte Seiten",
"Show location of links to pages not yet created" => "Zeige Links zu Seiten an, die noch nicht erstellt wurden",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)",
"a valid regex-expression (PCRE)" => "ein gültiger regulärer Ausdruck (PCRE)",
"Split By" => "Getrennt durch",
"The character by which ignored patterns are separated" => "Das Zeichen, durch das ignorierte Muster getrennt werden",
// "Skip Alias" => "Skip Alias",
// "Whether to skip wanted pages that have a defined alias (not skipped by default)" => "Whether to skip wanted pages that have a defined alias (not skipped by default)",
"Skip Extension" => "Überspringe Erweiterung",
"Whether to include external wikis in the list (not included by default)" => "Ob externe Wikis in die Liste eingebunden werden sollen (standardmäßig nicht eingebunden)",
"Collect" => "Sammeln",
// "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column",
"From" => "Von",
"Switch on debug output with details about the items (debug not on by default)" => "Schalte Debug für die Ausgabe mit Details zu den Einträgen ein (standardmäßig ist Debug nicht angeschaltet)",
"Memory Saver" => "Speicher-Sparer",
// "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell",
"Line break" => "Zeilenumbruch",
"Separate Row" => "Getrennte Zeile",
"Level" => "Ebene",
// "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex",
"Full" => "Voll",
"non-valid custom regex" => "nicht gültiger benutzerdefinierter regulärer Ausdruck (regex)",
", " => ", ",
"ignored" => "ignorierten",
"External Wiki" => "Externes Wiki",
"dash-WikiWord" => "dash-WikiWort",
"WikiWord" => "Wiki-Wort",
"not in level" => "nicht in Ebene",
"valid" => "gültig",
"End of debug output" => "Ende der Debug-Ausgabe",
"Wanted Page" => "gesuchte Seiten",
"Referenced By Page" => "Referenziert von Seite",
// "Web Document Viewer" => "Web Document Viewer",
// "View a document in a page" => "View a document in a page",
// "File Id" => "File Id",
// "The FileId of a file in a File Gallery of the file you wish to embed in the viewer" => "The FileId of a file in a File Gallery of the file you wish to embed in the viewer",
// "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter" => "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter",
// "No FileId or URL has been set" => "No FileId or URL has been set",
"Web Service" => "Webdienst",
// "Display remote information exposed in JSON or YAML or SOAP XML" => "Display remote information exposed in JSON or YAML or SOAP XML",
// "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter",
"Complete service URL" => "Vollständige Dienste-URL",
"Registered service name" => "Registrierter Dienstname",
// "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided",
"Body as Parameter" => "Hauptteil als Parameter",
// "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful" => "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful",
// "Parameters formatted like a query" => "Parameters formatted like a query",
"Unknown Template" => "unbekannte Vorlage",
"Unknown Service" => "Unbekannter Dienst",
// "Wiki Diff" => "Wiki Diff",
// "Display the differences between two wiki objects" => "Display the differences between two wiki objects",
// "Object Id" => "Object Id",
// "Object to do a diff on (page name for wiki pages)" => "Object to do a diff on (page name for wiki pages)",
// "Object type (wiki pages only)" => "Object type (wiki pages only)",
// "Old version" => "Old version",
// "Integer for old version number, or date" => "Integer for old version number, or date",
// "New version" => "New version",
// "Leave empty for current version" => "Leave empty for current version",
// "Diff Style" => "Diff Style",
// "Defaults to \"diff style\" preference if empty" => "Defaults to \"diff style\" preference if empty",
// "Show version info" => "Show version info",
// "Show the heading \"Comparing version X with version Y\"" => "Show the heading \"Comparing version X with version Y\"",
// "Use a WYSIWYG editor to edit a section of content" => "Use a WYSIWYG editor to edit a section of content",
// "Minimum width for DIV. Default" => "Minimum width for DIV. Default",
// "Minimum height for DIV. Default" => "Minimum height for DIV. Default",
"Use HTML" => "HTML benutzen",
// "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed" => "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed",
// "XMLupdate" => "XMLupdate",
// "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory" => "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory",
// "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file " => "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file ",
// "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory" => "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory",
// "XML node attribute name" => "XML node attribute name",
// "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space" => "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space",
// "XML node listed in output" => "XML node listed in output",
// "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set" => "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set",
// "Xmpp" => "Xmpp",
// "Chat using Xmpp" => "Chat using Xmpp",
// "Room Name" => "Room Name",
// "Room to auto-join" => "Room to auto-join",
// "View Mode" => "View Mode",
// "Fullscreen" => "Fullscreen",
// "Overlayed" => "Overlayed",
// "Chat room width in CSS units" => "Chat room width in CSS units",
// "Chat room height in CSS units" => "Chat room height in CSS units",
"Visibility" => "Sichtbarkeit",
// "This room is visible to anyone or only for members" => "This room is visible to anyone or only for members",
// "Members only" => "Members only",
// "Show Real JIDs of Occupants to" => "Show Real JIDs of Occupants to",
// "If just moderator or anyone else can fetch information about an occupant" => "If just moderator or anyone else can fetch information about an occupant",
// "If just \"moderator\", anonymous user will not be able to change their nicknames" => "If just \"moderator\", anonymous user will not be able to change their nicknames",
// "Anyone" => "Anyone",
// "Moderator" => "Moderator",
// "Show controlbox on load" => "Show controlbox on load",
// "If controlbox should be shown after page load" => "If controlbox should be shown after page load",
// "This preference only works when view mode is overlayed" => "This preference only works when view mode is overlayed",
// "Show occupants" => "Show occupants",
// "If occupants window should be visible by default" => "If occupants window should be visible by default",
// "This preference only works when view mode is embedded" => "This preference only works when view mode is embedded",
// "Groups (comma-separated)" => "Groups (comma-separated)",
// "Allowed groups to use this resource" => "Allowed groups to use this resource",
// "Is secret" => "Is secret",
// "If the room will be listed on public chat room list" => "If the room will be listed on public chat room list",
// "Archiving" => "Archiving",
// "If room messages will be stored" => "If room messages will be stored",
// "Persistent" => "Persistent",
// "If room will continue to exist after last user leaves" => "If room will continue to exist after last user leaves",
// "If room is moderated" => "If room is moderated",
// "PluginXMPP Error: No room specified" => "PluginXMPP Error: No room specified",
// "Add a group to room" => "Add a group to room",
// "Add users to room" => "Add users to room",
"YouTube" => "Youtube",
// "Embed a YouTube video in a page" => "Embed a YouTube video in a page",
"Movie" => "Film",
// "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)" => "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)",
// "Privacy-Enhanced" => "Privacy-Enhanced",
// "Enable privacy-enhanced mode" => "Enable privacy-enhanced mode",
// "Start time" => "Start time",
// "Start time offset in seconds" => "Start time offset in seconds",
// "Quality of the video. Default is %0high%1" => "Quality of the video. Default is %0high%1",
"Enlarge video to full screen size" => "Video auf Vollbild vergrößern",
"Related" => "Verwandt",
"Show related videos (shown by default)" => "Zeige verbundene Videos (werden standardmäßig gezeigt)",
"Background" => "Hintergrund",
// "Toolbar background color. Use an HTML color code" => "Toolbar background color. Use an HTML color code",
// "Example" => "Example",
"HTML color code, e.g. ffffff" => "HTML Farbcode, z.B. ffffff",
// "Toolbar border colors. Use an HTML color code" => "Toolbar border colors. Use an HTML color code",
"Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube Fehler: Filmparameter nicht angegeben",
// "Invalid YouTube URL provided" => "Invalid YouTube URL provided",
"Zotero Citation" => "Zotero Zitierung",
"Retrieves and includes a Zotero reference in the page." => "Empfängt und fügt Zoteroverweise in die Seite ein.",
"Reference Key" => "Referenz-Schlüssel",
// "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module",
"Reference Tag" => "Referenz-Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references" => "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references",
"Zotero Reference List" => "Zotero-Referenzliste",
// "Display the complete reference list from a Zotero server" => "Display the complete reference list from a Zotero server",
"Provide the list of references with a given tag" => "Stelle die Liste der Referenzen eines gegebenen Tags zur Verfügung",
"No results obtained. The Zotero citation server may be down" => "Keine Ergebnisse erhalten. Der Zotero-Server könnte down sein",
// "Set up some advanced options" => "Set up some advanced options",
// "Set up Auto TOC" => "Set up Auto TOC",
// "Define Categories" => "Define Categories",
// "Set up User & Community features" => "Set up User & Community features",
// "Set up Date and Time" => "Set up Date and Time",
// "Select Editor type" => "Select Editor type",
// "Set up Main features" => "Set up Main features",
// "Set up File Gallery & Attachments" => "Set up File Gallery & Attachments",
// "Set up File storage" => "Set up File storage",
// "Set up Language" => "Set up Language",
// "Set up Login" => "Set up Login",
// "Set up Look & Feel" => "Set up Look & Feel",
// "Set up Namespace" => "Set up Namespace",
// "Set up Search" => "Set up Search",
// "Set up Structures" => "Set up Structures",
// "Set up Text Area" => "Set up Text Area",
// "Set up Wiki environment" => "Set up Wiki environment",
// "Tiki Setup" => "Tiki Setup",
// "Configuration Wizard Completed" => "Configuration Wizard Completed",
// "Set up Wysiwyg editor" => "Set up Wysiwyg editor",
// "Related doc.tiki.org pages" => "Related doc.tiki.org pages",
// "New in Tiki 13" => "New in Tiki 13",
// "New in Tiki 14" => "New in Tiki 14",
// "New in Tiki 15 (LTS)" => "New in Tiki 15 (LTS)",
// "New in Tiki 16" => "New in Tiki 16",
// "New in Tiki 17" => "New in Tiki 17",
// "New in Tiki 18 (LTS)" => "New in Tiki 18 (LTS)",
// "New in Tiki 19" => "New in Tiki 19",
// "New in Tiki 20" => "New in Tiki 20",
// "Novice Admin Assistance" => "Novice Admin Assistance",
// "Other features and settings" => "Other features and settings",
// "Permissions & Logs" => "Permissions & Logs",
// "Send feedback & Connect" => "Send feedback & Connect",
// "User Interface" => "User Interface",
// "Changes Wizard Completed" => "Changes Wizard Completed",
// "Configuration Profiles Wizard Completed" => "Configuration Profiles Wizard Completed",
// "Demo of Cases in Project Management" => "Demo of Cases in Project Management",
// "Demo of Commonly Used Configurations" => "Demo of Commonly Used Configurations",
// "Demo of Highly Specialized Configurations" => "Demo of Highly Specialized Configurations",
// "Demo of Interesting Use Cases" => "Demo of Interesting Use Cases",
// "Demo of More Advanced Configurations" => "Demo of More Advanced Configurations",
// "Demo of Other Interesting Use Cases" => "Demo of Other Interesting Use Cases",
// "Featured Site Configurations" => "Featured Site Configurations",
// "Useful Administration Configurations" => "Useful Administration Configurations",
// "Useful Changes in Display Mode" => "Useful Changes in Display Mode",
// "Useful Micro Configurations" => "Useful Micro Configurations",
// "Useful New Technology Configurations" => "Useful New Technology Configurations",
"Personal Information" => "Persönliche Informationen",
"User Watches" => "Benutzerbeobachtungspunkte",
// "Notification Preferences" => "Notification Preferences",
"unicode" => "Unicode",
"Report Preferences" => "Berichte Einstellungen",
// "User Details" => "User Details",
// "You cannot access this page directly" => "You cannot access this page directly",
// "Welcome to the User Wizard" => "Welcome to the User Wizard",
// "User Wizard Completed" => "User Wizard Completed",
// "Invalid wizard stepNr specified" => "Invalid wizard stepNr specified",
"Articles Home" => "Artikelhauptseite",
// "Delete selected messages" => "Delete selected messages",
// "%0 archived message was deleted" => "%0 archived message was deleted",
// "%0 archived messages were deleted" => "%0 archived messages were deleted",
// "No messages were deleted" => "No messages were deleted",
// "No messages were selected to delete" => "No messages were selected to delete",
// "The message must have either a subject or a body" => "The message must have either a subject or a body",
"User %s does not have the permission" => "Benutzer %s hat nicht die Berechtigung",
"The message has been sent to" => "Die Nachricht wurde gesendet an",
"The message will be sent to" => "Diese Nachricht wird gesendet an",
// "See below for how the broadcast message will be handled upon confirmation" => "See below for how the broadcast message will be handled upon confirmation",
// "No valid users to send the message to" => "No valid users to send the message to",
"User %s does not want to receive messages" => "Benutzer %s möchte keine Nachrichten erhalten",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Ausgangsordner ist voll. Bitte ein paar verschickte Nachrichten archivieren oder löschen, damit weitere verschickt werden können.",
// "See below for how message will be handled upon confirmation" => "See below for how message will be handled upon confirmation",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Zum Versenden von Nachrichten musst Du auch Antwort empfangen können. Bitte aktiviere 'Nachrichten von anderen Anwendern erlauben' in den Benutzereinstellungen.",
"User %s can not receive messages, mailbox is full" => "Benutzer %s kann keine Nachrichten empfangen, Briefkasten ist voll.",
"User %s can not receive messages" => "Benutzer %s kann keine Nachrichten empfangen.",
"Invalid user: %s" => "Ungültiger Benutzer: %s.",
// "%0 message was marked" => "%0 message was marked",
// "%0 messages were marked" => "%0 messages were marked",
// "No messages were marked" => "No messages were marked",
// "No messages were selected to mark" => "No messages were selected to mark",
// "%0 message was deleted" => "%0 message was deleted",
// "%0 messages were deleted" => "%0 messages were deleted",
// "%0 message was archived" => "%0 message was archived",
// "%0 messages were archived" => "%0 messages were archived",
// "No messages were archived" => "No messages were archived",
// "No messages were selected to archive" => "No messages were selected to archive",
"Archive is full. Delete some messages from archive first." => "Archiv ist voll! Bitte erst ein paar Nachrichten aus dem Archiv löschen.",
// "Delete message" => "Delete message",
// "Message deleted" => "Message deleted",
// "Message not deleted" => "Message not deleted",
"No more messages" => "Keine weiteren Nachrichten",
// "Delete archive message" => "Delete archive message",
// "Archive message deleted" => "Archive message deleted",
// "Archive message not deleted" => "Archive message not deleted",
// "Delete sent message" => "Delete sent message",
// "Sent message deleted" => "Sent message deleted",
// "Sent message not deleted" => "Sent message not deleted",
// "%0 sent message was deleted" => "%0 sent message was deleted",
// "%0 sent messages were deleted" => "%0 sent messages were deleted",
"Action Calendar" => "Aktionenkalendar",
"Item types filter" => "Typfilter",
"If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes." => "Wenn Typen eingetragen werden, wird die Anzeige auf die eingetragenen Typen beschränkt. Einzelne Typen sind durch Kommas zu separieren.",
"Possible item type values:" => "Mögliche Typeneinträge:",
"Similar Content" => "Ähnlicher Inhalt",
"Find similar content based on tags." => "Finde ähnlichen Inhalt anhand von Tags.",
"Similar Content Filter" => "Filter für ähnlichen Inhalt",
"Display only similar content of type specified" => "Zeige nur ähnliche Inhalt wie vom angegebenen Typ",
"Default: \"All Content Type\"" => "Standard: \"alle Inhaltstypen\"",
"Options: \"article, wiki page, blog post\"" => "Optionen: \"article, wiki page, blog post\"",
"Broaden FreeTag Search" => "FreeTag-Suche erweitern",
"Find similar content that contains one of the Tags or All of the Tags" => "Finde ähnlichen Inhalt der eines oder alle der Tags enthält",
"Default: \"n - needs to contain all of the Tags\"" => "Standard: \"n - es müssen alle Tags enthalten sein\"",
"Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Optionen: \"n - Es müssen alle Tags enthalten sein / y - Es muss einer der Tags enthalten sein\"",
// "Quick Admin Bar" => "Quick Admin Bar",
// "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features" => "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features",
"Display mode: module or header. Leave empty for module mode" => "Anzeigemodus: Modul (module) oder Kopf (header). Leer lassen für Modulmodus",
"Google AdSense" => "Google AdSense",
"Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code." => "Zeigt eine Google AdSense Werbung (Text/Bild). Dieses Modul sollte aktualisiert werden, um den neuen Googlecode zu unterstützen.",
"ad_channel" => "ad_channel (Werbekanal)",
"Advertisement channel, as optionally provided by Google." => "Werbekanal, wie optional von Google bereitgestellt.",
"client" => "client",
"As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "Wie von Google bereitgestellt. Format: \"pub-xxxxxxxxxxxxxxxx\"",
"display" => "display (Anzeige)",
"Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Globales Banner-Format, wie optional von Google bereitgestellt. Z.B.: \"display=468*60_as\"",
"color_bg" => "color_bg",
"Background color, as optionally provided by Google." => "Hintergrundfarbe, wie optional von Google bereitgestellt.",
"color_border" => "color_border",
"Border color, as optionally provided by Google." => "Rahmenfarbe, wie optional von Google bereitgestellt.",
"color_link" => "color_link",
"Link color, as optionally provided by Google." => "Linkfarbe, wie optional von Google bereitgestellt.",
"color_text" => "color_text",
"Text color, as optionally provided by Google." => "Textfarbe, wie optional von Google bereitgestellt.",
"color_url" => "color_url",
"URL color, as optionally provided by Google." => "URL Farbe, wie optional von Google bereitgestellt.",
"Article Archives" => "Artikelarchive",
"Shows links to the published articles for each month." => "Zeigt Links zu veröffentlichten Artikeln für jeden Monat.",
"If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles." => "Wenn \"y\" eingetragen wird, erhält man eine Schaltfläche \"mehr\", die zur einer paginierten Ansicht der gewählten Artikel führt.",
"Default: \"n\"." => "Standard: \"n\".",
"If set to a category identifier, only consider the articles in the specified category." => "Wenn eine Kategorie-ID eingetragen wird, werden nur die Artikel in der angegebenen Kategorie berücksichtigt.",
"Example value: 13." => "Beispielswert: 13.",
"Topic filter (by names)" => "Themenfilter (nach Namen)",
"If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Wird Liste von Artikelthemen-Namen ausgewählt, getrennt mit Plus-Zeichen, dann berücksichtige nur die Artikel mit den angegebenen Artikelthemen. Wird der Text von einem Ausrufezeichen (\"!\") angeführt, wird der Effekt umgekehrt, d.h. es werden Artikel mit den angegebenen Themen nicht berücksichtigt",
"Topic filter (by identifiers)" => "Themenfilter (nach Kennung, ID)",
"If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Wird Liste von Artikelthemen-Kennungen (IDs) ausgewählt, getrennt mit Plus-Zeichen, dann berücksichtige nur die Artikel mit den angegebenen Artikelthemen. Wird der Text von einem Ausrufezeichen (\"!\") angeführt, wird der Effekt umgekehrt, d.h. es werden Artikel mit den angegebenen Themen nicht berücksichtigt",
"Example values: 13, !13, 1+3, !1+5+7" => "Beispielwerte: 13, !13, 1+3, !1+5+7",
"Types filter" => "Typenfilter",
"If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "Wird Liste von Artikeltypen-Namen ausgewählt, getrennt mit Plus-Zeichen, dann berücksichtige nur die Artikel mit den angegebenen Artikeltypen. Wird der Text von einem Ausrufezeichen (\"!\") angeführt, wird der Effekt umgekehrt, d.h. es werden Artikel mit den angegebenen Typen nicht berücksichtigt",
"Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Beispielwerte: Ereignis, !Ereignis, Ereignis+Rezension, !Ereignis+vertraulich+Artikel",
"Language filter" => "Sprachenfilter",
"If set to a language code, only consider the articles in the specified language" => "Wenn ein Sprachenkode angegeben wurde, werden nur Artikel in der angegebenen Sprache berücksichtigt",
"Article Topics" => "Artikelthemen",
"Lists all article topics with links to their articles." => "Listet alle Artikelthemen mit Links zu den jeweiligen Artikeln.",
"Lists the specified number of published articles in the specified order." => "Liste zu einer festgelegten Anzahl von veröffentlichten Artikeln in einer festlegbaren Reihenfolge.",
"Show publication time" => "Zeige Veröffentlichungsdatum",
"If set to \"y\", article publication times are shown." => "Wenn \"Y\" eingetragen wird, wird das Veröffentlichkeitsdatum angezeigt.",
"Show creation time" => "Zeige Erstellungsdatum",
"If set to \"y\", article creation times are shown." => "Wenn \"Y\" eingetragen wird, wird das Erstellungsdatum angezeigt.",
"Show rating selector" => "Zeige Bewertungsauswahl",
"If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating." => "Wenn \"Y\" eingetragen wird, kann der Benutzer die Artikel nach minimalen und maximalen Bewertungen filtern ",
"Image width" => "Bildbreite",
"If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image." => "Wenn eingetragen, wird ein Bild mit der angegebenen Größe (in Pixel) zu jedem Artikel angezeigt (wenn zutreffend). Das eigene Bild des Artikels wird benutzt, mit Rückgriff auf das Bild des Artikelthemas.",
"If set to a category identifier, only lists the articles in the specified category." => "Wenn eine Kategorie angegeben wird, werden nur Artikel in dieser Kategorie aufgelistet.",
"If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed." => "Wenn eine Liste von Artikelthemen, getrennt durch Pluszeichen, eingetragen wird, werden nur die Artikel gelistet mit den angegebenen Themen. Wird ein Ausrufezeichen \"!\" vorangestellt, wird der Effekt umgekehrt, d.h. Artikel mit den angegebenen Themen werden nicht gelistet.",
"If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Wird Liste von Artikelthemen-Kennungen (IDs) ausgewählt, getrennt mit Plus-Zeichen, dann liste nur die Artikel mit den angegebenen Artikelthemen auf. Wird der Text von einem Ausrufezeichen (\"!\") angeführt, wird der Effekt umgekehrt, d.h. es werden Artikel mit den angegebenen Themen nicht aufgelistet",
"If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "Wird Liste von Artikeltypen-Namen ausgewählt, getrennt mit Plus-Zeichen, dann liste nur die Artikel mit den angegebenen Artikeltypen auf. Wird der Text von einem Ausrufezeichen (\"!\") angeführt, wird der Effekt umgekehrt, d.h. es werden Artikel mit den angegebenen Typen nicht aufgelistet",
"If set to a language code, only lists the articles in the specified language" => "Wird ein Sprachencode angegeben, liste nur Artikel in der angegebenen Sprache auf",
"Specifies how the articles should be sorted" => "Legt fest, wie die Artikel sortiert werden",
"Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Mögliche Werte sind created (erstellt) und das äquivalente created_asc (erstellt_aufsteigend), created_desc (erstellt_absteigend), author (Autor), rating (Bewertung), topicID , lang (Sprache) und title (Titel). Sofern nicht \"_desc\" (absteigend) angegeben ist, wird aufsteigend sortiert. \"created\" (erstellt) sortiert nach dem Erstellungsdatum des Artikels",
"Default value:" => "Standardwert:",
"If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead." => "Wenn eine ganze Zahl eingetragen wird, wird die Artikelliste um den eingetragenen Wert versetzt. Z.B. wenn das Modul so konfiguriert wurde, dass die 10 jüngsten Artikel gelistet werden, führt ein offset von 10 zu einer Auflistung der Artikel 11 bis 20 in absteigender Sortierung des Veröffentlichungsdatums.",
"If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles." => "Wenn \"Y\" eingetragen wird, wird eine Schaltfläche \"mehr\" angezeigt, die zu einer paginierten Ansicht der ausgewählten Artikel führt.",
"Absolute URL" => "Absolute URL",
"If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example." => "Wenn \"y\" eingetragen wird, benutzen Links absolute URL anstelle von Relativen. Damit kann man defekte Links vermeiden, wenn das Modul in einem Newsletter versandt wird.",
"If set to 0, will take the topicId of the article if in an article" => "Wird 0 eingetragen, wird die Themen-ID des Artikels genommen, wenn in einem Artikel",
"Tiki Assistant" => "Tiki Assistent",
"Display an assistant to guide new Tiki admins" => "Zeigt einen Assistenten, um neue Tiki Administratoren zu führen",
"Newest Blog Post Comments" => "Neueste Blog Kommentare",
"Displays the specified number of the blog post comments most recently added." => "Zeigt eine bestimmte Anzahl von Kommentaren zu Blogeinträgen, die zuletzt abgegeben wurden.",
"No date" => "kein Datum",
"If set to \"y\", the date of comments is not displayed in the module box" => "Wird \"y\" gewählt, wird das Datum des Kommentars in der Modulbox nicht angezeigt",
"Verbose tooltips" => "Ausführliche Tooltips",
"If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "Wird \"y\" gewählt, wird der Titel des Blogeintrags nur als Tooltip und sonst nicht angezeigt",
"Default: \"n\"" => "Standard: \"n\".",
"Options: \"y,n\"" => "Optionen: \"y,n\"",
"Last-Visited Pages" => "Zuletzt besuchte Seiten",
"Displays the last Wiki pages visited by the user." => "Zeigt die zuletzt von einem Benutzer besuchte Wiki Seite.",
"Maximum number of characters in page names allowed before truncating." => "Maximale Anzahl von Zeichen einer Seite, bevor diese abgeschnitten wird.",
// "Show Namespace" => "Show Namespace",
// "Show namespace prefix in page names" => "Show namespace prefix in page names",
"A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "Eine Hierarchie, wo Du Dich befindest. Z.B.: Start > Abschnitt 1 > Unterabschnitt C",
"Label preceding the crumbs" => "Bezeichnung vor den Krumen",
"Menu Id" => "Menü-ID",
"Menu to take the crumb trail from" => "Krumen-Spur, aus der das Menü erstellt wird",
"Menu Start Level" => "Menü Startebene",
"Lowest level of the menu to display" => "Kleinste Ebene des Menüs, die angezeigt wird",
"Menu Stop Level" => "Menü Stopebene",
"Highest level of the menu to display" => "Höchste Ebene, die angezeigt wird",
"Show Site Crumb" => "Zeige Site-Krumen",
"Display the first crumb, usually the site, when using menu crumbs" => "Zeige den ersten Krumen. Normalerweise die Site, wenn Krumen genutzt werden",
"Show Page Crumb" => "Zeige Seiten-Krumen",
"Display the last crumb, usually the page, when using menu crumbs" => "Zeige den letzten Krumen. Normalerweise die einzelne Seite, wenn Krumen benutzt werden",
"Show Crumb Links" => "Zeige Krumen-Links",
"Display links on the crumbs" => "Zeige die Krumen als Links",
"Includes a calendar or a list of calendar events." => "Beeinhaltet einen Kalender oder eine Liste von Kalendereignissen.",
"Calendars filter" => "Kalenderfilter",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "Wird eine Liste von KalenderIDs angegeben, werden die Ereignisse auf die in den angegebenen Kalender beschränkt. IDs werden durch Senkrechtstriche (\"|\"), Kommata (\",\") oder Doppelpunkte (\":\") getrennt. Beispielwerte: \"13\", \"4,7\", \"31:49\". Standardmäßig ohne Eintrag",
"Displayed month (relative)" => "Angezeigter Monat (relativ)",
"Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Abstand in Monaten zum anzuzeigenden Monat. Ein Abstand von -1 zeigt den vorangegangenen Monat. Wird diese Option gewählt, muss die Kalenderansicht mit monatlicher Zeitspanne gewählt werden. Beispielwerte: 2, 0, -2, -12",
"View type" => "Anzeigetyp",
"Determines how to show events. Possible values: %0, %1" => "Legt fest, wie Ereignisse angezeigt werden. Mögliche Werte: %0, %1",
"Calendar view type time span" => "Zeitspanne für Kalenderansicht",
"If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "In der Kalender- (oder \"Tabellen-\") Ansicht legt dies die vom Kalender anzuzeigende Zeitspanne fest. Mögliche Werte: %0, %1, %2, %3 ,%4, %5. Ein Benutzer, der diese Werte im Kalender ändert, kann die Zeitspanne ändern, die ihm das Modul anzeigt",
"Show action" => "Zeige Aktion",
"Viewmode when clicking on a day" => "Anzeigemodus, wenn auf einen tag geklickt wird.",
"Put a link on all the days , not only those with event" => "Setze einen Link auf alle Tage, nicht nur diejenigen mit Ereignis",
"View navigation bar" => "Zeige Navigations-Bar an",
"Cart" => "Warenkorb",
// "Displays the content of the cart, allows quantities to be modified and proceeds to payment" => "Displays the content of the cart, allows quantities to be modified and proceeds to payment",
// "Use AJAX" => "Use AJAX",
// "Use AJAX services for managing the cart" => "Use AJAX services for managing the cart",
// "Show Items" => "Show Items",
// "Shows the items in the cart as they are added" => "Shows the items in the cart as they are added",
// "Shows the number of items in the cart" => "Shows the number of items in the cart",
// "Checkout URL" => "Checkout URL",
// "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated" => "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated",
// "(Default empty: Goes to tiki-payment.php)" => "(Default empty: Goes to tiki-payment.php)",
// "Post-Payment URL" => "Post-Payment URL",
// "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc" => "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc",
// "Show Total Weight" => "Show Total Weight",
// "Shows the weight of the items in the cart" => "Shows the weight of the items in the cart",
// "Shown after the weight" => "Shown after the weight",
// "Show Item Buttons" => "Show Item Buttons",
// "Shows add, remove and delete buttons on items" => "Shows add, remove and delete buttons on items",
"The quantities in your cart were updated" => "Die Mengen im Warenkorb wurden aktualisiert",
"Gift card added" => "Geschenkkarte hinzugefügt",
"Gift card not found" => "Geschenkkarte nicht gefunden",
"Gift card removed" => "Geschenkkarte entfernt",
"Displays links to categories as a tree." => "Zeigt Links zu Kategorien in einer Baumansicht.",
"Object type filter" => "Objekttypfilter",
"Object type filter to apply when accessing a linked category. Example values" => "Anzuwendender Objekttyp-Filter wenn auf eine verlinkte Kategorie zugegriffen wird. Beispielwerte",
"Deep" => "Tiefe",
"Show subcategories objects when accessing a linked category. Possible values: on (default), off." => "Zeige Objekte aus Unterkategorien, wenn auf eine verlinkte Kategorie zugegriffen wird. Mögliche Werte: on (Standard), off",
"Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Beschränkt angezeigte Kategorieren auf einen Unterbaum von Kategorien, beginnend mit mit der Kategorie mit der angegebenen ID. Beispielwert: 11. Standard: 0 (keine Beschränkung)",
"Show these categories and their children" => "Zeige diese Kategorien und deren Kinder",
"Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Zeige nur diese Kategorien und ihre unmittelbar untergeordneten Kategorien in der angegeben Reihenfolge. Beispielwerte: 3,5,6",
"Category links to a page named as the category" => "Kategorielinks zu einer Seite, die wie die Kategorie benannt wurde",
"If y, category links to a page named as the category" => "Wenn y (ja), verlinkt die Kategorie auf eine Seite mit dem Namen der Kategorie",
// "Hide Empty" => "Hide Empty",
// "If y, only categories with child objects will be shown" => "If y, only categories with child objects will be shown",
// "Only Children" => "Only Children",
// "If y, only direct child categories will be shown. Default: n" => "If y, only direct child categories will be shown. Default: n",
"Custom URL" => "Benutzerdefinierte URL",
// "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" " => "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" ",
"Category Transitions" => "Kategorienüberleitungen",
"Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Zeigt Bedienelemente, um Kategorieüberleitungen zu ermöglichen und den Seitenstatus entsprechend vordefinierter Regeln zu ändern",
"Example Transition" => "Beispielüberleitung",
"Change Category" => "Kategorien ändern",
"Enables to categorize an object." => "Erlaubt es ein Objekt zu kategorisieren.",
// "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
"Category identifier" => "Kategorie-Kennung (ID)",
"Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Ändert die Hauptkategorie der angezeigten Kategorien vom Standard (\"TOP\") zu der Kategorie mit der angegebenen Kennung (ID)",
"Note that the root category is not displayed" => "Beachte, dass die Hauptkategorie nicht angezeigt wird",
"Defaults to 0 (root)" => "Standardmäßig 0 (Hauptkategorie)",
"No top" => "Kein TOP",
"In non-detailed view, disallow uncategorizing. Example value: 1" => "Verbiete Entkategorisieren in der Nicht-Detail-Ansicht. Beispielwert: 1",
"Display path" => "Zeige Pfad",
"Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Solange nicht \"n\" ausgewählt wird, zeige relative Kategoriepfade im Kategoriebaum anstelle der Kategorienamen",
"Paths are relative to the root category, which is not displayed" => "Pfade sind relativ zur Hauptkategorie, welche nicht angezeigt wird",
"Multiple categories" => "Multiple Kategorien",
"If set to \"n\", only allows categorizing in one category (from those displayed)" => "Wird \"n\" eingetragen, ist nur die Kategorisierung in einer Kategorie erlaubt (von den angezeigten)",
"Categorize" => "Kategorisieren",
"String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "Auf der Schaltfläche zum Absenden neuer Kategorien erscheinender Text (wenn multiple Kategorieren aktiviert sind). Standardwert: Kategorisiere",
"Shy" => "Schüchtern",
"If set to \"y\", the module is not shown on pages which are not already categorized" => "Wird \"y\" ausgewählt, dann wird das Modul nicht auf Seiten gezeigt, die nicht bereits kategorisiert sind",
"Detailed" => "detailliert",
"If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "Wird \"y\" eingetragen, wird eine Liste der Kategorien angezeigt, in der das Objekt eingetragen ist. Wenn Löschen nicht deaktiviert ist, wird es mit der Liste erledigt",
"If set to \"n\", the detailed list of categories will not offer to unassign a category" => "Wird \"n\" eingetragen, ermöglicht die detaillierte Liste kein entkategorisieren",
"If set to \"y\", allow to assign new categories" => "Wird \"y\", allow to assign new categories",
"Example values: y, n" => "Beispielwerte: y, n",
"Default value: y" => "Standardwert: y",
"Group filter" => "Gruppenfilter",
"Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Sehr spezielle Filteroption. Wird \"y\" ausgewählt, werden nur Kategorien (und Unterkategorien) angezeigt, deren Name mit einem der Namen der Gruppen des Benutzers übereinstimmen",
"Default value: n" => "Standardwert: n",
"Image URL not in category" => "Bild-URL nicht in Kategorie",
"Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Sehr spezieller Parameter. Wird beides, d.h. dieses und \"Bild-URL in Kategorie\", ausgewählt und enthält die Hauptkategorie eine einzelne Unterkategorie, dann zeigt das Modul nur ein Bild mit dieser URL, wenn das Objekt nicht der Kategorie zugeordnet ist",
"Image URL in category" => "Bild-URL in Kategorie",
"Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Sehr spezieller Parameter. Wird beides, d.h. dieses und \"Bild-URL nicht in Kategorie\", ausgewählt und enthält die Hauptkategorie eine einzelne Unterkategorie, dann zeigt das Modul nur ein Bild mit dieser URL, wenn das Objekt der Kategorie zugeordnet ist",
"Categorize %s" => "Kategorisiere %s",
"Categorize %s in %s" => "Kategorisiere %s in %s",
// "Collapse Button" => "Collapse Button",
// "Bootstrap collapse button" => "Bootstrap collapse button",
// "CSS selector defining which objects get collapsed" => "CSS selector defining which objects get collapsed",
// "CSS class for containing DIV element" => "CSS class for containing DIV element",
// "CSS selector defining the collapsing objects' container" => "CSS selector defining the collapsing objects' container",
"Received Objects" => "Empfangene Objekte",
"Displays the number of pages received (via Communications)." => "Zeigt die Zahl der Seiten, die über Mail-in empfangen wurden.",
"Contributors" => "Beitragende",
"Lists the contributors to the wiki page being viewed and some information on them." => "Listet alle Beiträge zu einer angezeigten Wiki Seite auf und ein paar weitere Informationen.",
"Shows the credits a user has." => "Zeigt Benutzer Credits.",
"Newest Directory Sites" => "Neueste Links",
"Displays the specified number of the directory sites most recently added." => "Zeigt eine bestimmte Anzahl von Links, die zuletzt hinzugefügt wurden.",
"Directory category identifier" => "Verzeichniskategorie-Kennung (ID)",
"If set to a directory category identifier, only displays the sites in the specified directory category" => "Wird eine Verzeichniskategorie-Kennung (ID) eingetragen, werden nur die Sites in der angegebenen Verzeichniskategorie angezeigt",
"If set to \"y\", displays a button labelled \"More\" that links to the directory" => "Wird \"y\" eingetragen, erscheint eine Schaltfläche mit der Bezeichnung \"Mehr\", welche auf das Verzeichnis verlinkt",
"Show description" => "Beschreibung zeigen",
"If set to \"y\", the description of the directory site appears" => "Wird \"y\" eingetragen, erscheint die Beschreibung der Verzeichnisseite angezeigt",
"Maximum length of description" => "Maximale Länge der Beschreibung",
"If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "Wird bei \"Beschreibung anzeigen\" \"y\" eingetragen, kann hiermit die maximale Länge (in Zeichen) festgelegt werden. Bleibt das Feld leer, wird kein Maximum festgelegt und die gesamte Beschreibung angezeigt",
"Default: blank" => "Standard: leer",
"Directory Statistics" => "Linkverzeichnisstatistik",
"Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links." => "Zeigt Statistiken über das Linkverzeichnis, einschließlich der Zahl der geprüften und noch zu prüfenden Sites, der Zahl der Kategorien, Suchen und der besuchten Links.",
"Top Directory Sites" => "Top Linkeinträge",
"Displays the specified number of the directory sites from most visited to least visited." => "Zeigt eine bestimmte Anzahl von Links, sortiert nach der Häufigkeit der Besuche.",
// "Domain Password" => "Domain Password",
// "Store personal passwords for other domains securely in Tiki" => "Store personal passwords for other domains securely in Tiki",
// "System the credentials apply for. The name must match a defined Password Domain" => "System the credentials apply for. The name must match a defined Password Domain",
// "Use current user" => "Use current user",
// "Use the currently logged-in user. The username is not editable. (y/n) Default: y" => "Use the currently logged-in user. The username is not editable. (y/n) Default: y",
// "Can Update" => "Can Update",
// "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n" => "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n",
// "Show domain prompt" => "Show domain prompt",
// "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y" => "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y",
// "No Password Domains found" => "No Password Domains found",
// "Domain is not valid" => "Domain is not valid",
// "No domain specified" => "No domain specified",
// "No user defined" => "No user defined",
// "No password saved" => "No password saved",
// "Read error" => "Read error",
// "No password specified" => "No password specified",
// "No username specified" => "No username specified",
// "Failed to save password" => "Failed to save password",
// "Failed to save user" => "Failed to save user",
// "Saved OK" => "Saved OK",
"Facebook" => "Facebook",
// "Shows the Wall of a user" => "Shows the Wall of a user",
// "Tiki user to show Facebook wall of" => "Tiki user to show Facebook wall of",
// "Show username in timeline. y|n" => "Show username in timeline. y|n",
// "user not registered with facebook" => "user not registered with facebook",
// "No username given" => "No username given",
"Featured Links" => "Linktips",
"Displays the site's first featured links." => "Zeigt die ersten Linktips der Site.",
"Displays links to file galleries." => "Zeigt Links zu Dateiarchiven.",
"Top-Rated Topics" => "Höchstbewertete Themen",
"Displays the specified number of the forum topics with the best ratings." => "Zeigt eine bestimmte Anzahl von Forenthemen mit den besten Bewertungen.",
"Newest Forum Posts" => "Neueste Forenbeiträge",
"Displays the latest forum posts." => "Zeigt den neuesten Forumpost.",
"Topics only" => "nur Themen",
"If set to \"y\", only displays topics" => "Wird \"y\" eingetragen, erscheinen nur Themen",
"List of forum identifiers" => "Liste von Foren-IDs",
"If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "Wird eine Liste von Foren-IDs angegeben, werden Beiträge auf diejenigen in den angegebene Foren beschränkt. Kennzeichen (IDs) werden durch Doppelpunkte getrennt(\":\")",
"Show date" => "Datum anzeigen",
"If set to \"y\", show post date directly instead of as tooltip" => "Wenn \"Y\" (ja) eingetragen wird, dann wird das Post-Datum direkt und nicht als Tooltip angezeigt",
"Show time" => "Zeige Zeit",
"Show times after dates" => "Zeige Zeiten nach den Daten",
"If set to \"y\", show post author directly instead of as tooltip" => "Wird \"y\" eingetragen, dann zeige den Author des Beitrags direkt und nicht als Tooltip",
"Most Commented Forums" => "Meistkommentierte Foren",
"Display the specified number of the forums with the most comments." => "Zeige eine bestimmte Anzahl von Foren mit den meisten Kommentaren.",
"Top Visited Forum Topics" => "Meistbesuchte Forenthemen",
"Display the specified number of the forum topics with the most reads" => "Zeige eine bestimmte Anzahl von Forenthemen, die am häufigsten gelesen wurden",
"Top Visited Forums" => "Meistbesuchte Forenthemen",
"Display the specified number of the forums with the most visits" => "Zeige eine bestimmte Anzahl von Foren mit den meisten Besuchen",
"Tags Editor" => "Tags Editor",
"Shows current tags and enables adding and removing some if permissions allow." => "Zeigt derzeitige Tags und erlaubt Hinzufügen/Entfernen wenn entsprechende Rechte vorhanden sind.",
"Wiki Page Tags" => "Wiki Seiten Tags",
"Displays current tags on wiki pages and enables adding tags if permissions allow." => "Zeigt derzeitige Tags auf Wiki Seiten und erlaubt Tags hinzuzufügen, wenn hierzu Rechte vorhanden sind.",
"Similar-Tag Items" => "Tags mit ähnlichem Inhalt",
"Shows content with multiple tags in common." => "Zeige Inhalt mit multiplen Tags im allgemeinen",
"Type of objects to extract." => "Objekttypen zum extrahieren.",
"Most Popular Tags" => "Populärste Tags",
"Shows the most popular tags. More popularity is indicated by a larger font." => "Zeigt die populärsten Tags. Eine höhere Beliebtheit wird durch eine größere Schrift angezeigt.",
"Display type" => "Anzeigetyp",
"If set to \"cloud\", links are displayed as a cloud" => "Wenn \"cloud\" eingetragen wird, werden die Links in einer Wolke angezeigt",
"Default: \"list\"" => "Standard: \"Liste\"",
"Maximum elements" => "Maximale Anzahl",
"If set to a number, limits the number of tags displayed" => "Wenn eine Zahl eingetragen wird, wird die Anzahl angezeigter Tags beschränkt",
// "BlogId" => "BlogId",
// "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5" => "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5",
"My Preferred Tags" => "Benutzerpräferierte Tags",
"Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size." => "Zeigt registrierten Benutzern die Tags an, die von ihnen bevorzugt werden, basierend auf der Anzahl von Objekten, die von ihnen getagt wurden. Höhere Beliebtheit wird durch eine größere Schrift angezeigt.",
"My preferred tags" => "Meine bevorzugten Tags",
// "Displays a list of friends" => "Displays a list of friends",
// "GIT detail" => "GIT detail",
// "GIT commit and last update information" => "GIT commit and last update information",
"Google Search" => "Google-Suche",
"Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site." => "Zeigt ein einfaches Formular, um mit Google zu suchen. Standardmäßig werden die Suchergebnisse auf die Tiki Site beschränkt.",
"Groups Emulation" => "Gruppen Emulation",
"Enables temporarily changing one's group memberships to see how users in fewer groups experience the site." => "Erlaubt es die eigene Gruppenmitgliedschaft temporär zu ändern, um zu sehen, wie Benutzer in anderen Gruppen die Site erleben.",
// "Show All Groups" => "Show All Groups",
// "If set to \"n\", the list is not shown" => "If set to \"n\", the list is not shown",
// "Show Your Groups" => "Show Your Groups",
"Emulate Groups" => "Gruppen emulieren",
"Last Actions" => "Letzte Aktionen",
"Displays the specified number of last actions." => "Zeigt eine bestimmte Anzahl von zuletzt durchgeführten Aktionen.",
"Show user" => "Zeige Benutzer",
"If set to \"y\", user names are displayed in the module box" => "Wird \"y\" eingetragen, dann werden Benutzernamen in der Modulbox angezeigt",
"If set to \"y\", action dates are displayed in the module box" => "Wird \"y\" eingetragen, dann werden Aktionsdaten in der Modulbox angezeigt",
"Maximum number of characters in action descriptions before truncating" => "Maximale Anzahl von Zeichen in der Aktionsbeschreibung, bevor diese abgeschnitten wird",
"Newest Blog Posts" => "Neueste Blog-Einträge",
"Lists the specified number of blogs posts from newest to oldest." => "Listet eine bestimmte Anzahl von Blogs, sortiert von den neuesten zu den ältesten.",
"If set to \"y\", the date of posts is not displayed in the module box" => "Wird \"y\" eingetragen, dann wird das Datum der Beiträge nicht in der Modulbox angezeigt",
"Blog identifier" => "Blog-Kennung (ID)",
"If set to a blog identifier, restricts the blog posts to those in the identified blog" => "Wird eine Blog-Kennung (ID) eingetragen, werden die Blog-Einträge auf die im angegebenen Blog beschränkt",
"Newest Category Items" => "Neueste Kategorien",
"Lists the specified number of objects of the given type in the given category, starting from the most recently created." => "Listet eine bestimmte Anzahl von Objekten eines speziellen Typs in einer vorgegebenen Kategorie auf, beginnend mit der jüngst erstellen.",
"Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Kategoriekennung (ID) aus der Objekte aufgelistet werden. Objekte, welche nur in Unterkategorien vorkommen, werden nicht angezeigt",
"Maximum number of characters in object names allowed before truncating" => "Maximale Anzahl von Zeichen in Objektnamen, bevor diese abgeschnitten werden",
"Type of the objects to list. Example values" => "Aufzulistende Objekttypen. Beispielwerte",
"no object here yet" => "bisher noch keine Objekte",
"Newest Blogs" => "Neueste Blogs",
"Displays the specified number of blogs from newest to oldest." => "Zeige eine bestimmte Anzahl von Blogs, sortiert von den neuesten zu den ältesten.",
"Newest FAQs" => "Neueste FAQs",
"Displays the specified number of FAQs from newest to oldest." => "Zeige eine bestimmte Anzahl von FAQs, sortiert von den neuesten zu den ältesten.",
"Newest Quizzes" => "Neueste Quiz",
"Displays the specified number of quizzes from newest to oldest." => "Zeige eine bestimmte Anzahl von Quiz, sortiert von den neuesten zu den ältesten.",
"Last-Modified File Galleries" => "Zuletzt veränderte Dateiarchive",
"Display the specified number of file galleries, starting from the most recently modified" => "Zeige eine bestimmte Anzahl von Dateiarchiven, beginnend mit dem zuletzt veränderten",
"Newest Files" => "Neueste Dateien",
"List the specified number of files, starting from the most recently added." => "Zeigt eine bestimmte Anzahl von Dateien, angefangen mit der jügst hinzugefügten.",
"Gallery identifiers" => "Dateiachiv-Kennungen (IDs)",
"If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "Wird eine Liste mit Dateiarchiv-Kennungen (IDs) eingetragen, werden die Dateien auf die in den angegebenen Dateiarchiven beschränkt. Der Wert ist eine mit Doppelpunkten getrennte Sequenz von ganzen Zahlen",
"Example value: 13, 2:13, 1:2:3:5:6" => "Beispielwert: 13, 2:13, 1:2:3:5:6",
"Last-Modified Image Galleries" => "Zuletzt veränderte Bildergalerien",
"Displays the specified number of image galleries, starting from the most recently modified." => "Zeige eine bestimmte Anzahl von Bildergalerien, beginnend mit der zuletzt veränderten.",
"Newest Images" => "Neueste Bilder",
"List the specified number of images, starting from the most recently added" => "Liste eine bestimmte Anzahl von Bildern auf, angefangen mit dem zuletzt hinzugefügten",
"Gallery identifier" => "Dateiachiv-Kennung (ID)",
"If set to an image gallery identifier, restricts the images to those in the identified gallery" => "Wird eine Bildergalerie-Kennung (ID) angegeben, werden die Bilder auf die in der angegebenen Bildergalerie beschränkt",
"Link content" => "Linkinhalt",
"Display the links as image names or thumbnails" => "Zeige den Link als Bildnamen oder Vorschaubild",
"Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Mögliche Werte: \"names\" oder \"thumbnails\" (Namen oder Vorschaubilder). Standardwert: \"names\"",
"Last-Modified Events" => "Zuletzt veränderte Ereignisse",
"Display the specified number of calendar events, starting from the most recently modified" => "Zeige eine bestimme Anzahl von Kalenderereignissen, beginnend mit dem zuletzt veränderten",
"Calendar Identifier" => "Kalenderidetifizierer",
"If set to a calendar identifier, restricts the events to those in the identified calendar" => "Wird eine Kalender-Kennung (ID) angegeben, werden die Ereignisse auf die im angegebenen Kalender beschränkt",
"Maximum number of characters in event names allowed before truncating" => "Maximale Zeichenanzahl in Ereignisnamen, bevor diese abgeschnitten werden",
"Hide Date" => "Verstecke Datum",
"If set to \"y\", it will hide date" => "Wenn \"y\" eigetragen wird, wird das Datum versteckt",
"Latest Changes" => "Neueste Änderungen",
"List the specified number of pages, starting from the most recently modified" => "Liste die angegebene Anzahl von Seiten auf, beginnend mit der zuletzt veränderten",
"Link Target" => "Link-Ziel",
"Target URL of the \"...more\" link at the bottom of the module." => "Ziel-URL des \"mehr\"-Link am Ende des Moduls.",
"Last-Modified Blogs" => "Zuletzt geänderte Blogs",
"Displays the specified number of blogs, starting from the most recently modified." => "Zeigt eine bestimmte Anzahl von Blogs, angefangen mit den zuletzt veränderten.",
"Newest Podcasts" => "Neueste Podcasts",
"Displays Podcasts." => "Zeigt Podcasts an.",
"File galleries IDs" => "Dateiarchiv-IDs",
"List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "Liste von IDs von Dateiarchiven des Typs \"Podcast (Audio)\". Mehrere IDs werden durch Doppelpunkt (\":\") getrennt. Wenn keine angegeben wird, werden alle Dateiachive gescannt",
"Width of mediaplayer in pixels" => "Breite des Mediaplayer in Pixel",
"Height of mediaplayer in pixels" => "Höhe des Mediaplayer in Pixel",
"Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Pfad zum mp3-Player. Z.B. media/player_mp3_maxi.swf wenn Du player_mp3_maxi.swf von http://flash-mp3-player.net/players/maxi/download/ in das Verzeichnis media/ heruntergeladen hast (das Verzeichnis muss von Dir angelegt oder ein anderer Ort gewählt werden)",
"Bottom Link URL" => "URL für Link am Ende",
"URL for a link at bottom of module" => "URL für einen Link am unteren Rand des Moduls",
"Bottom Link URL Text" => "Text für URL-Link am Ende",
"Text for link if Bottom Link URL is set" => "Text für den Link wenn URL-Link am Ende angegeben wurde",
"More Podcasts" => "Mehr Podcasts",
"Verbose" => "Ausführlich",
"Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Zeige Podcast-Beschreibung unter dem Player (bei \"y\") und bei \"n\" nur beim Mouseover über dem Titel",
"Newest Article Submissions" => "Neueste Einreichungen",
"Lists the specified number of article submissions from newest to oldest." => "Zeigt eine bestimmte Anzahl von Artikeleinreichungen, angefangen bei der jüngsten bis zur ältesten.",
"Newest Tracker Comments" => "Neueste Tracker Kommentare",
"Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted." => "Listet eine bestimmte Anzahl von Kommentaren zu Trackern auf (optional: beschränkt auf einen einzelnen Tracker/Trackereintrag), beginnend mit dem zuletzt abgegebenen.",
"Tracker identifier" => "Tracker-Kennung (ID)",
"If set to a tracker identifier, only displays the comments on the given tracker" => "Wird eine Tracker-Kennung (ID) eingetragen, dann werden nur Kommentare zu diesem Tracker angezeigt",
"Item identifier" => "Eintragkennung (ID)",
"If set to an item identifier, only displays the comments on the given item" => "Wird eine Eintrag-Kennung (ID) eingetragen, dann werden nur Kommentare zu diesem Eintrag angezeigt",
"Newest Tracker Items" => "Neueste Trackereinträge",
"Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required." => "Zeigt den Wert eines Feldes einer festgelegten Anzahl von Trackereinträgen an. Wenn der angegebene Tracker kein Hauptfeld hat, ist die Angabe des Feldnamens oder des Feldidentifzierers erforderlich.",
"Identifier of the tracker from which items are listed" => "Kennung (ID) des Trackers, aus dem Einträge aufgelistet werden",
"Field identifier" => "Feldkennung (ID)",
"Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Kennung (ID) des Feldes aus dem Werte aufgelistet werden sollen. Wird ein Feldname eingetragen, wird dieser Parameter ignoriert",
"Field name" => "Feldname",
"Name of the field from which values are listed" => "Feldname aus dem Werte aufgelistet werden sollen",
"Example value: age" => "Beispielwert: age (Alter)",
"Specifies how the items should be sorted" => "Legt fest, wie die Objekte sortiert werden sollen",
"Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Mögliche Werte sind created (erstellt) und das äquivalente created_asc (erstellt_aufsteigend), created_desc (erstellt_absteigend), status, lastModif (zuletzt modifiziert), createdBy (erstellt durch), und lastModifBy (zuletzt modifiziert durch). Sofern nicht \"_desc\" (absteigend) angegeben ist, wird aufsteigend sortieren. \"lastModif\" (zuletzt modifizeriert) sortiert nach dem Modifizierungsdatum des Artikels. \"lastModif_desc\" (zuletzt modifizeriert absteigend) sortiert nach Modifizierungsdatum des Artikels in absteigenden Datumsfolge.",
"Status filter" => "Statusfilter",
"If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "Wenn angegeben, engt die Liste auf Sätze mit den spezifizierten Status(en). Werte können aus \"o\" (offen), \"p\" (anstehend bzw. noch nicht abgeschlossen. Engl.pending) und \"c\" (abgeschlossen. Engl. closed). Mögliche Werte",
"Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Kann nicht die anzuzeigenden Felder ermitteln. Die Tracker-Kennung (ID) könnte ungültig sein. Der Tracker könnte kein Hauptfeld enthalten und weder die Feld-ID noch der Feld-Name wurde angegeben",
"You do not have permission to view this tracker" => "Du hast keine Berechtigung, diesen Tracker einzusehen",
"Last Items" => "Neueste Einträge",
"Last modified Items" => "Zuletzt geänderte Einträge",
"Newest Validated FAQ Questions" => "Letzte bestätigte FAQs Fragen",
"Displays the specified number of validated questions FAQs from newest to oldest." => "Zeigt eine bestimmte Anzahl von geprüften Fragen aus FAQs, sortiert von den neuesten zu den ältesten.",
"FAQ identifier" => "FAQ-Kennung (ID)",
"If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ" => "Wird eine FAQ-Kennung (ID) eingetragen, werden auf die Fragen im angegebenen FAQ beschränkt",
"Last Visitors" => "Letzte Besucher",
"Displays information about the specified number of users in decreasing order of last login time." => "Zeigt Informationen über eine bestimmte Anzahl von Benutzern mit deren letzter Anmeldezeit in absteigender Reihenfolge.",
"Show profile pictures" => "Zeige Avatare",
"If set to \"y\", show user profile pictures" => "Wenn \"y\" eingetragen wird, zeige Benutzeravatare",
"Maximum number of characters in user names allowed before truncating" => "Maximale Zeichenzahl in Benutzernamen, bevor diese abgeschnitten werden",
"Don't show date" => "Datum nicht zeigen",
"YouTube Playlist" => "YouTube Playliste",
"Display a YouTube playlist" => "Zeige eine YouTube Playliste",
"Playlist ID" => "ID der Playliste",
"ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID der anzuzeigenden YouTube Playliste (nicht die gesamte URL). Beispiel: id=4DE69387D46DA2F6",
// "Google YouTube API Key" => "Google YouTube API Key",
"Width of each video in pixels" => "Breite jedes Videos in Pixel",
"Height of each video in pixels" => "Höhe jedes Videos in Pixel",
// "Allow FullScreen" => "Allow FullScreen",
"Bottom Link" => "Unterer Link",
"Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "URL für einen Link am unteren Rand eines Moduls. Beispiel: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
"Bottom Link Text" => "Text für unteren Link",
"Text for link if link_url is set, otherwise 'More Videos'" => "Text für den Link, wenn link_url angegeben wurde. Andernfalls: 'Mehr Videos'",
"Video Descriptions" => "Video Beschreibungen",
"Display description of video on title mouseover if 'y'. Default is 'y'" => "Zeige Beschreibung des Videos beim Mouseover über dem Titel, wenn ja ('y') gewählt. Standard ist ja ('y')",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "Dauer",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
"No Playlist found" => "Keine Playliste gefunden",
"No Playlist ID was provided" => "Es wurde keine Playlist ID angegeben",
"Live Support" => "Online-Support",
"Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console." => "Teilt Benutzern mit, ob ein Livesupport-Mitarbeiter online ist und erlaubt es, Support anzufragen. Ist der Benutzer selbst  eine entsprechende Person zeigt der Link auf die Bedienkonsole.",
"Server Load" => "Serverlast",
"Report of server resources used" => "Berichtet über vom Server benutze Ressourcen.",
"Locator" => "Lokalisierung",
"Presents a map with the geolocated content within the page." => "Präsentiert eine Karte auf einer Seite mit geografisch lokalisiertem Inhalt.",
// "Preference \"%0\" is disabled" => "Preference \"%0\" is disabled",
"Log-in box" => "Log-in Box",
"Input size" => "Eingabegröße",
"Number of characters for username and password input fields" => "Anzahl Zeichen für Benutzername und Passwort",
"Display mode: module, header or popup. Leave empty for module mode" => "Anzeigemodus: Modul (module), Kopf (header) oder Popup (popup). Leer lassen für Modulmodus",
"Show Register" => "Zeige Registrieren",
"Show the register link" => "Zeige den Registrieren-Link",
"Show I Forgot" => "Zeige Vergessen",
"Show the \"I forgot my password\" link" => "Zeige den den \"Ich habe mein Passwort vergessen\"-Link",
"Show Remember me" => "Zeige Erinnern",
"Show the \"Remember me\" checkbox" => "Zeige das \"An mich erinnern\"-Häkchenfeld",
// "Show user avatar" => "Show user avatar",
// "Show the user avatar when in popup mode" => "Show the user avatar when in popup mode",
// "Show user name" => "Show user name",
// "Show the user name when in popup mode" => "Show the user name when in popup mode",
// "Groups for switch user listing" => "Groups for switch user listing",
// "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")" => "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")",
// "Menu ID" => "Menu ID",
// "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"" => "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"",
"Logo" => "Logo",
"Site logo, title and subtitle" => "Logo, Titel und Untertitel der Seite",
// "Image URL" => "Image URL",
// "Image to use. Defaults to sitelogo_src preference" => "Image to use. Defaults to sitelogo_src preference",
// "CSS colour to use as background. Defaults to sitelogo_bgcolor preference" => "CSS colour to use as background. Defaults to sitelogo_bgcolor preference",
// "Image title attribute. Defaults to sitelogo_title preference" => "Image title attribute. Defaults to sitelogo_title preference",
// "Alt" => "Alt",
// "Image alt attribute. Defaults to sitelogo_alt preference" => "Image alt attribute. Defaults to sitelogo_alt preference",
// "URL for the image and titles link. Defaults to \"./\"" => "URL for the image and titles link. Defaults to \"./\"",
// "Logo Title" => "Logo Title",
// "Large text to go next to image. Defaults to sitetitle preference" => "Large text to go next to image. Defaults to sitetitle preference",
// "Logo Subtitle" => "Logo Subtitle",
// "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference" => "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference",
// "Logo Class" => "Logo Class",
// "CSS class for the image container div. Defaults to sitelogo" => "CSS class for the image container div. Defaults to sitelogo",
// "Title Class" => "Title Class",
// "CSS class title text container div. Defaults to sitetitles" => "CSS class title text container div. Defaults to sitetitles",
"Map Feature Editor" => "Kartenmarkierungs-Editor",
"Allows shapes to be drawn over the map" => "Erlaubt es Formen über Karten zu zeichnen",
"Tracker to store the feature in" => "Tracker, in dem die Markierungen gespeichert werden",
"Hidden Input" => "Versteckte Eingabe",
"Hidden values to be sent over to the dialog. fieldName(value)" => "Mittels des Dialogs zu sendende versteckte Werte. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Mode change on insert" => "Mode change on insert",
// "Target mode to enter after successfully inserting an item" => "Target mode to enter after successfully inserting an item",
// "Edit details" => "Edit details",
// "Edit the tracker item's details through a dialog after the initial item creation" => "Edit the tracker item's details through a dialog after the initial item creation",
"Layer Selector" => "Schichtauswahl",
// "Include base layer" => "Include base layer",
// "Include the drop list for the base layers" => "Include the drop list for the base layers",
// "Include optional layers" => "Include optional layers",
// "Include the checkboxes for the optional layers" => "Include the checkboxes for the optional layers",
"Replace the map's built-in layer controls" => "Ersetze die von Seiten der Karte eingebauten Schichten-Steuerelemente",
"Mode Selector" => "Modusauswahl",
"Toggle input modes for the map" => "Schaltet zwischen Eingabemodi für die Karte hin und her",
"Map location search" => "Kartensuche",
"Simple search controls for the map" => "Einfache Suchfunktion für die Karte",
"Menu" => "Menü",
"Displays a menu or a structure as a menu" => "Zeigt ein Menü oder eine Struktur als Menü",
"Identifier of a menu (from tiki-admin_menus.php)" => "Kennzeichner (ID) eines Menü (von tiki-admin_menus.php)",
"Structure" => "Struktur",
"Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Kennung einer Struktur von Wiki Seiten (Name oder Nummer aus tiki-admin_structures.php)",
"Direction for menu: horiz or vert (default vert)" => "Ausrichtung für Menüs horiz (für horizontal) vert (für vertikal) (Standard: vert)",
"CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu (if bootstrap = n). y|n (default y)" => "Use CSS Superfish menu (if bootstrap = n). y|n (default y)",
// "Use Bootstrap menus" => "Use Bootstrap menus",
// "Show Navbar Toggle Button" => "Show Navbar Toggle Button",
// "Used in Bootstrap navbar menus when viewport is too narrow for menu items" => "Used in Bootstrap navbar menus when viewport is too narrow for menu items",
// "The URL of the navbar brand (logo)" => "The URL of the navbar brand (logo)",
// "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu" => "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu",
// "CSS class(es) for the menu nav element" => "CSS class(es) for the menu nav element",
// "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar" => "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar",
"DOM #id" => "DOM #id",
"Id of the menu in the DOM" => "ID des Menü im DOM",
"CSS class" => "CSS-Klasse",
"Class of the menu container" => "Klasse des Menücontainer",
"Limit low visibles levels" => "Beschränke Sichtbarkeit unterer Ebenen",
"All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "Alle Untermenüs, die ab dieser Ebene beginnen werden angezeigt, wenn die URL mit einer Option dieser Ebene oder einer darüber bzw. darunter übereinstimmt",
"Limit top visible levels" => "Beschränke Sichtbarkeit oberer Ebenen",
"Do not display options higher than this level" => "Zeige keine Optionen, die über dieser Ebene liegen",
"Link on Section" => "Link auf Abschnitt",
"Create links on menu sections" => "Erstelle Links für Menüabschnitte",
"(y/n default y)" => "(y/n. Standard: y)",
"Translate labels" => "Übersetze Bezeichnungen",
"Menu Cookie" => "Menü-Cookie",
"Open the menu to show current option if possible" => "Öffne das Menü und zeige gegenwärtige Option wenn möglich",
// "Set Selected" => "Set Selected",
// "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue" => "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue",
"One of these parameters has to be set" => "Einer dieser Parameter muss angegeben werden",
"Menu Page" => "Menüseite",
"Displays a Wiki page" => "Anzeige einer Wiki-Seite",
"Page to display in the menu. Example value: HomePage" => "Im Menü anzuzeigende Seite. Beispiel: Startseite",
// "Use default namespace" => "Use default namespace",
// "Prepend the default namespace to the page name for localized menus per workspace (1/0)" => "Prepend the default namespace to the page name for localized menus per workspace (1/0)",
// "Menu style" => "Menu style",
// "Display the page as a menu (horiz / vert)" => "Display the page as a menu (horiz / vert)",
"Wiki Structure Menu" => "Wiki Struktur Menü",
"Displays a structure." => "Zeigt eine Struktur.",
"N.B. Deprecated, use the Menu module instead" => "Veraltet. Benutze das Menümodul stattdessen",
"Structure to display in the menu" => "Im Menü anzuzeigende Struktur",
"Unread Inter-User Messages" => "Ungelesene Inter-Benutzernachrichten",
"Displays to users their number of new inter-user messages and a link to their message box." => "Zeigt Benutzern die Zahl der neuen Inter-User-Nachrichten und einen Link zu deren Postbox.",
"Show If Empty" => "Zeige wenn leer",
"Show the module when there are no messages waiting. y|n " => "Zeige das Modul, wenn keine Nachrichten warten. y|n ",
"Default=y" => "Standard=y",
"Messages" => "Nachrichten",
"Small live chat box" => "Kleine Livechat Box",
"Channels" => "Kanäle",
"List of chat channels. Channel names are separated by a comma (\",\")." => "Liste der Chatkanäle. Einzelne Kanalnamen werden durch Komma getrennt (\",\")",
"By default, a single channel named \"default\" exists." => "Standardmäßig existiert ein einzelner Kanal mit Namen \"default\"",
"Mobile" => "Tiki Mobil",
"Currently only shows switch to and from mobile mode" => "Gegenwärtige wird nur der Schalter hin zum und weg vom mobilen Modus angezeigt",
"To Label" => "Zu-Bezeichnung",
"Switch to normal site label" => "Bezeichnung für Umschaltung zur normalen Site",
"From Label" => "Von-Bezeichnung",
"Switch to mobile site label" => "Bezeichnung für Umschaltung zur mobilen Site",
"Switch Perspective" => "Pespektive umschalten",
"Also switch perspective back to this one when leaving mobile mode" => "Schalte auch Perspektiven zurück zu dieser, wenn der Mobil-Modus verlassen wird",
"Stay" => "Bleibe",
"Stay on same page" => "Bleibe auf der gleichen Seite",
"Switch to mobile site" => "Schalte zur mobilen Site",
"Switch to normal site" => "Schalte zur normalen Site",
"Months Links" => "Links des Monats",
"Link to articles or blog posts for the current month and those preceding it." => "Link zu einem Objekt eines vorgegebenen Typs für den aktuellen Monat und den vorhergehenden.",
"Type of objects to link to" => "Objekttypen zum verlinken",
"Possible values:" => "Mögliche Werte:",
"\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" für Blogeinträge, \"cms\" für veröffentlichte Artikel",
"Object Identifier" => "Objektkennung",
"Identifier of an object with children to link to" => "Kennung (ID) eines Objektes mit Nachfolgern auf die verlinkt werden soll",
"This is required for the blog Object type" => "Dies ist für den Blog-Objekttyp erforderlich",
"For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "Z.B. wird eine Kennung (ID) von 3 und ein Blog-Objekttyp Link zu Blogeinträgen mit der Blog-Kennung (ID) 3 anzeigen",
"List by month" => "Auflistung nach Monat",
"Most Commented" => "Am häufigsten kommentiert",
"Display the most commented objects of a certain type." => "Zeigt die am häufigsten kommentierten Objekte eines speziellen Typs.",
"Type of objects to consider" => "Zu berücksichtigende Objekttypen",
"Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Mögliche Werte: wiki (Wiki-Seiten), blog (Blog-Beiträge), article (Artikel)",
"Language Filter" => "Objektsprachenfilter",
"If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "Wenn ein RFC1766 Sprach-Tag gesetzt ist, werden nur Objekte in der festgelegten Sprache berücksichtigt",
// "Request the creation of a mustread item based on the current object" => "Request the creation of a mustread item based on the current object",
// "Object Field" => "Object Field",
// "Permanent name of the field containing the object reference" => "Permanent name of the field containing the object reference",
// "Notifications Link" => "Notifications Link",
// "Shows an icon with the number of and a link to user notifications" => "Shows an icon with the number of and a link to user notifications",
"Pending Article Submissions" => "Wartende Einreichungen",
"Displays the number of article submissions waiting examination and a link to the list." => "Zeigt die Zahl von Artikeleinreichungen, die auf eine Überprüfung warten und einen Link zu dieser Liste.",
"Old Articles" => "Alte Artikel",
"Displays the specified number of old articles (which do not show on articles home page anymore)." => "Zeigt eine bestimmte Anzahl von veralteten Artikeln (die nicht mehr auf der Artikelhomepage auftauchen).",
// "Package Module" => "Package Module",
// "A module that shows content from a Tiki Package View" => "A module that shows content from a Tiki Package View",
// "Name of package (vendor/name)" => "Name of package (vendor/name)",
// "Name of package in the form vendor/name" => "Name of package in the form vendor/name",
// "Name of the view file without the .php" => "Name of the view file without the .php",
// "Other parameters" => "Other parameters",
// "URL encoded string of other parameters (will not replace standard parameters)" => "URL encoded string of other parameters (will not replace standard parameters)",
"Payments Outstanding" => "Ausstehende Zahlungen",
"Displays the payments outstanding for the current user." => "Zeigt ausstehende Zahlungen für den gegenwärtigen Benutzer an.",
// "List of active permissions for current object" => "List of active permissions for current object",
"Enables to change current perspective." => "Erlaubt es die aktuelle Perspektive zu ändern.",
"Powered By" => "Powered By",
"Powered by Tiki, and others" => "Powered by Tiki und anderen",
"Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Zeigt eine \"Powered by Tiki Wiki CMS Groupware\" Nachricht",
"Tiki version info" => "Tiki Versionsinfo",
"Shows theme credits (contents of credits.tpl)" => "Zeige Theme Credits (Inhalt von credits.tpl)",
"Shows various \"powered by\" icons" => "Zeige verschiedene \"powered by\" Symbole",
"Quick Edit" => "Schnellbearbeitung",
"Enables to quickly create or edit Wiki pages" => "Aktiviert die schnelle Erstellung oder Bearbeitung von Wiki Seiten",
"Deprecated - use the Search module instead" => "Veraltet - benutze stttdessen das Suchmodul",
"Template identifier" => "Vorlagen-Kennung (ID)",
"If set to a template identifier, the specified template is used for creating new Wiki pages" => "Wenn eine Vorlagenkennung (template identifier, ID) gesetzt ist, wird die angegebene Vorlage zum Erstellen neuer Wiki-Seiten verwendet",
"If set, send the form to the given location (relative to Tiki's root) for processing" => "Wenn gewählt, sende das Formular zur Verarbeitung zum angegeben Ort (relativ zum Tiki Stammverzeichnis, root)",
"SUBMIT label" => "Absende-Schaltfläche",
"The label on the button to submit the form" => "Die Bezeichnung der Schaltfläche, um das Formular abzusenden",
"Create/Edit" => "Hinzufügen/bearbeiten",
"INPUT SIZE" => "Eingabegröße",
"Size attribute (horizontal, in characters) of the text input field for page names" => "Größe des Texteingabefeldes für Seitennamen (horizontal in Zeichen)",
"Optional heading to display at the top of the module's content" => "Optionale Überschrift die am Anfang des Moduls angezeigt wird",
"Category to preselect" => "Vorauszuwählende Kategorie",
"If set, pages created through the module have this category prechecked to be categorized in" => "Wenn gewählt, werden Seiten, die durch dieses Modul erstellt werden, automatisch in dieser Kategorie eingetragen",
"Tip to be shown" => "Anzuzeigender Tip",
"Custom text to be shown as a tip at the top of the edit page" => "Benutzerdefinierter Text, der oben auf einer Bearbeitungsseite als Tip angezeigt wird",
"Title of tip to be shown" => "Titel des anzuzeigenden Tipps",
"Custom title to be shown for the tip at the top of the edit page" => "Benutzerdefinierte Überschrift, die alt Tipp am Anfang der Bearbeitungsseite angezeigt wird",
"Custom header template" => "Vorlage benutzerdefinierter Kopf",
"Wiki page to be used as a template to show content on top of edit page" => "Als Vorlage zu benutzende Wiki Seite, um Inhalt am Anfang der Bearbeitungsseite anzuzeigen",
"Quick Edit a Wiki Page" => "Schnellbearbeitung einer Wiki-Seite",
"Quick Search" => "Schnelle Suche",
"Performs a search query and persists the results in the module for quick navigation access" => "Führt eine schnelle Suche durch und behält die Ergebnisse im Modul für eine weitere schnelle Navigation",
"Filter object type" => "Objekttyp-Filter",
"Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Beschränke Suchergebnisse auf bestimmte Objekttypen. Trage einen Objekttyp für einen statischen Filter ein oder schreibe \"selector\", um einen Eingabe zur Verfügung zu stellen",
"Filter category" => "Kategorie filtern",
"Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls" => "Beschränke Suchergebnisse auf eine bestimmte Kategorie. Trage die mit Kommata getrennte Liste von Kategorie-IDs ein, um sie in diese Auswahl einzubeziehen. Einzelne Kategorie zeigt keine Steuerung an",
// "Quick Administration" => "Quick Administration",
// "Some helpful tools for administrators" => "Some helpful tools for administrators",
"Random Image" => "Zufallsbild",
"Displays a random image." => "Zeigt ein zufälliges Bild.",
"If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "Wird einen Bildergalerie-Kennung (ID) angegeben, werden die ausgewählten Bilder auf die in der angegebenen Galerie beschränkt",
"Show link" => "Zeige Link",
"If set to \"n\", the image thumbnail does not link to the image" => "Wird \"n\" eigetragen, verlinkt das Vorschaubild nicht auf das Bild",
"Default: \"y\"" => "Vorgabe: \"y\"",
"Show name" => "Name anzeigen",
"If set to \"y\", the name of the image is displayed" => "Wird \"y\" eingetragen, wird der Name des Bildes angezeigt",
"If set to \"y\", the description of the image is displayed" => "Wird \"y\" eingetragen, wird die Beschreibung des Bildes angezeigt",
"Random Pages" => "Zufällige Seiten",
"Displays the specified number of random wiki pages." => "Zeigt eine bestimmte Zahl von zufälligen Wiki Seiten.",
"New User Registration" => "Registrierung neuer Benutzer",
"Permit anonymous visitors to create an account on the site" => "Erlaube anonymen Besuchern ein Konto auf dieser Site zu erstellen",
"News Feeds" => "Feeds-Liste",
"List of feeds available on this site." => "Liste von Feeds von dieser Site.",
"Multi-purpose search module (go or edit page by name and/or search site)" => "Mehrzweck-Suchformular (gehe zu/bearbeite Seite und/oder durchsuche die Site)",
"Legacy Mode" => "Herkömmlicher Modus",
"Setting to emulate previous behaviour" => "Einstellung, um früheres Verhalten zu emulieren",
"If set to \"y\" the search performed is a \"Tiki search\"" => "Wird \"y\" eingetragen, dann wird die Suche durch die \"Tiki Suche\" durchgeführt",
" (full text search)" => " (Volltextsuche)",
"Show Object Type Filter" => "Zeige Objekttyp-Filter",
"If set to \"y\" shows a dropdown of sections to search" => "Wird \"y\" eingetragen, erscheint ein Auswahlfeld mit zu durchsuchenden Abschnitten",
" (no object filter)" => " (kein Objektfilter)",
"Use autocomplete" => "Benutze Autovervollständigen",
"If set to \"y\" input uses autocomplete for pagenames if applicable" => "Wird \"y\" eingetragen, benutzt die Eingabe automatisches Vervollständigen von Seitennamen wenn verwendbar",
" (use autocomplete)" => " (benutze Autovervollständigen)",
"Advanced search" => "Erweiterte Suche",
"Use advanced (boolean) search (full text search only)" => "Benutze erweiterte (boolesche) Suche (nur für Volltextsuche)",
" (use advanced search)" => " (benutze erweiterte Suche)",
"Advanced search checkbox" => "Erweiterte Suche Auswahl",
"Show advanced search checkbox (full text search only)" => "Zeige Häkchenfeld für erweiterte Suche (nur für Volltextsuche)",
" (advanced search checkbox off)" => " (erweiterte Suche nicht aktiviert)",
"Advanced search help" => "Hilfe erweiterte Suche",
"Show advanced search help icon (full text search only)" => "Zeige Hilfesymbol für erweiterte Suche (nur für Volltextsuche)",
" (advanced search help off)" => " (erweiterte Suche Hilfe aus)",
"Show Search Button" => "Zeige Suchenschaltfläche",
"Show search button" => "Zeige Suchenschaltfläche",
" (do show search button)" => " (zeige Suchenschaltfläche)",
"Show Go Button" => "Zeige Gehe-zu-Schaltfläche",
"Show go to page button" => "Zeige Gehe-zu-Seite Schaltfläche",
" (do show go button)" => " (zeige Gehe-zu-Schaltfläche)",
"Show Edit Button" => "Zeige Bearbeitenschaltfläche",
"Show edit button" => "Zeige Bearbeitenschaltfläche",
" (do show edit button)" => " (zeige Bearbeitenschaltfläche)",
"Default Button" => "Standardschaltfläche",
"Action to perform on entering <return>" => "Aktion, die durchgeführt wird, wenn <Enter> gedrückt wird",
" (search|go|edit)" => " (suchen|gehe zu|bearbeiten)",
"Search Form Action" => "Suchformular-Aktion",
" tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php oder tiki-searchindex.php (für Tiki-Suche)",
// "Search Submit Label" => "Search Submit Label",
"Go Form Action" => "Gehe-zu-Formular-Aktion",
// "Go Submit Label" => "Go Submit Label",
"Go" => "Los",
"Edit Form Action" => "Bearbeiten-Formular-Aktion",
"Edit Submit Label" => "Bezeichnung Bearbeiten absenden",
"Input field width" => "Breite Eingabefeld",
"Width of the text input field (in characters)" => "Breite des Texteingabefeldes (in Zeichen)",
" 0 (leave automatic width)" => " 0 (automatische Breite)",
"Select size" => "Wähle Größe",
"Size of the Search Filter dropdown list" => "Größe des Suchfilter-Auswahlfeldes",
"Edit Template identifier" => "Kennung (ID) für Bearbeitungsvorlage",
"If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "Wird eine Kategoriekennung (ID) angegeben, werden Seiten, die durch dieses Modul erstellt wurden automatisch in dieser Kategorie eingetragen",
"Compact mode" => "Kompaktmodus",
"Makes the three buttons only appear on mouse-over" => "Führt dazu, dass die drei Schaltflächen nur beim mouse-over angezeigt werden",
// "Additional filters" => "Additional filters",
// "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test" => "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test",
"Search is disabled" => "Suche ist deaktiviert",
"Search for Wiki Page" => "Suche auf der Wiki Seite",
// "More Like This" => "More Like This",
// "Uses the unified search to provide similar documents" => "Uses the unified search to provide similar documents",
// "Object Type Filters" => "Object Type Filters",
// "Comma-separated types to allow" => "Comma-separated types to allow",
// "Text Search Filters" => "Text Search Filters",
// "Comma-separated text search filters to use. Use \"=\" to separate field and value" => "Comma-separated text search filters to use. Use \"=\" to separate field and value",
// "Object id of item you want to get similar items to" => "Object id of item you want to get similar items to",
// "The object id of the item. If none is provided, Tiki will attempt to resolve the current object" => "The object id of the item. If none is provided, Tiki will attempt to resolve the current object",
// "Object type of item you want to get similar items to" => "Object type of item you want to get similar items to",
// "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object" => "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object",
"Search For a Wiki Page" => "Suche nach einer Wiki Seite",
"Search for a wiki page by name" => "Suche nach einem Wiki Seitennamen",
"Exact match checkbox checked by default if set to \"y\"" => "Kontrollkästchen für exakte Übereinstimmung. Standardmäßig angewählt, wenn \"y\" eingetragen wird",
"Semantic Links" => "Semantische Link",
"List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Liste bekannte Beziehungen für die angezeigten Wiki Seiten auf. Für jeden Beziehungstyp werden alle Seiten aufgelistet, auf die verlinkt wird oder von denen verlinkt wird",
"Links for sharing, reporting etc." => "Links zum sharen, berichten, etc.",
"Report" => "Bericht",
"Report to Webmaster" => "Berichte an den Webmaster",
"Share this page" => "Diese Seite einem Freund mitteilen",
"Use icons for report, share and email links" => "Benutze Symbole für Berichte-, Share- und E-Mail-Links",
"Show Facebook \"Like\" button on the current page" => "Zeige die Facebook \"Gefällt mir\"-Schaltfläche auf der gegenwärtigen Seite",
"Facebook: URL" => "Facebook: URL",
"URL to \"Like\" (leave blank for current URL)" => "URL zu \"Gefällt mir\" (leerlassen für gegenwärtige URL)",
"Facebook: Send" => "Facebook: Senden",
"Show Facebook \"Send\" button" => "Zeige Facebook \"Sende\"-Schaltfläche",
"Facebook: Layout" => "Facebook: Layout",
"Size, layout and amount of social context" => "Größe, Layout und Menge an sozialen Inhalten",
"Facebook: Width" => "Facebook: Breite",
"Facebook: Height" => "Facebook: Höhe",
"Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Containerhöhe in CSS Einheiten (z.B. \"120px\" oder \"2em\")",
"Facebook: Show Faces" => "Facebook: Zeige Gesichter",
"Show pictures of others who like this" => "Zeige Bilder von anderen, denen das gefällt",
"Facebook: Verb" => "Facebook: Verb",
"Verb to display in button" => "In Schaltflächen anzuzeigendes Verb",
"Facebook: Colors" => "Facebook: Farben",
"Color scheme" => "Farbschema",
"Facebook: Font" => "Facebook: Schriftart",
"Font to display" => "Anzeigeschriftart",
"Facebook: Locale" => "Facebook: Lokalisierung",
"Locale in the format ll_CC (default \"en_US\")" => "Lokalisierung im ll_CC-Format (Standard \"en_US\")",
"Facebook: Referrals" => "Facebook: Empfehlungen",
"Label for tracking referrals (optional)" => "Bezeichnung für die Nachverfolgung von Empfehlungen (optional)",
"Facebook: App Id" => "Facebook: App Id",
"ID of your Facebook app (optional)" => "ID zu Deiner Facebook App (optional)",
"Show Twitter Follow Button on the current page" => "Zeige die Twitter \"Follow\"-Schaltfläche auf der gegenwärtigen Seite",
"Twitter: User Name" => "Twitter: Benutzername",
"Twitter user name to quote as \"via\"" => "Twitter Benutzername für das Zitieren als \"via\"",
"Twitter: Label" => "Twitter: Bezeichnung",
"Text to display. Default \"Tweet\"" => "Anzuzeigender Text. Standard: \"Tweet\"",
"Twitter: URL" => "Twitter: URL",
"URL to \"Tweet\" (leave blank for current URL)" => "URL zum \"Tweet\" (leer lassen für gegenwärtige URL)",
"Twitter: Show Count" => "Twitter: Zeige Zähler",
"Position of Tweet count" => "Position des Tweet-Zählers",
"Twitter: Language" => "Twitter: Sprache",
"Two letter language code" => "Zwei Buchstaben-Länder-Code",
"Twitter: Width" => "Twitter: Breite",
"Width in pixels or percentage (e.g. 300px)" => "Breite in Pixel oder als Prozentsatz (z.B. 300px)",
"Twitter: Height" => "Twitter: Höhe",
"Twitter: Text" => "Twitter: Text",
"Tweet text (leave empty to use page title" => "Tweet-Text (leerlasen, um Seitentitel zu verwenden",
"LinkedIn" => "LinkedIn",
"Linked in share button" => "LinkedIn Share-Schaltfläche",
"LinkedIn: URL" => "LinkedIn: URL",
"URL to share (leave blank for current URL)" => "URL zum sharen (leerlassen für die gegenwärtige URL)",
"LinkedIn: Count Mode" => "LinkedIn: Zählermodus",
"Position of count" => "Position des Zählers",
"Google +1" => "Google +1",
"Google +1 button" => "Google +1 Schaltfläche",
"Google: Size" => "Google: Größe",
"Google button size" => "Google Schaltflächengröße",
"Google: Annotation" => "Google: Anmerkung",
"Google annotation" => "Google Anmerkung",
"Google: Language" => "Google: Sprache",
"Google language" => "Google Sprache",
"Google: URL" => "Google: URL",
// "Creates or shows a short url for the visiting page" => "Creates or shows a short url for the visiting page",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent." => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent.",
"If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content." => "Wenn \"1\" eingetragen wird, werden Postdaten und -uhrzeiten als Tooltips anstelle direkt im Modul angezeigt.",
"Label on the button to post a message." => "Bezeichnung der Schaltfläche, um einen Nachricht zu senden.",
"Wait label" => "Wartebezeichnung",
"Label on the button to post a message when the message is being posted if AJAX is enabled" => "Bezeichnung der Schaltfläche, um eine Nachricht abzusenden, wenn AJAX aktiviert ist",
"Please wait.." => "Bitte warten..",
"Maximum messages shown" => "Maximale Anzahl von Nachrichten, die angezeigt werden",
"Number of messages to display." => "Anzahl von anzuzeigenden Nachrichten.",
"Tweet" => "Tweet",
"If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter." => "Wenn \"1\" eingetragen wird und der Benutzer uns zum twittern autorisiert hat, kann der Benutzer entscheiden, ob er twittern will.",
"If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall." => "Wenn \"1\" eingetragen wird und der Benutzer bei Facebook angemeldet ist, kann der Benutzer entscheiden, ob er den Eintrag an seine Facebook Pinnwand schreiben will.",
"Since Last Visit (Simple)" => "Seit letzten Besuch (einfach)",
"Displays to logged-in users the number of new or updated objects since their last login date and time." => "Zeigt angemeldeten Benutzern die Zahl neuer oder aktualisierter Objekte seit ihrem letzten Login.",
"Since your last visit" => "Was ist neu?",
"Since Last Visit" => "Seit letzten Besuch",
"Displays to logged-in users new or updated objects since a point in time, by default their last login date and time." => "Zeigt angemeldeten Benutzern neue oder aktualisierte Objekte seit einem bestimmten Zeitpunkt, standardmäßig dem Datum und der Uhrzeit des letzten Login.",
"Show users" => "Zeige Benutzer",
"If set to \"n\", do not show new users." => "Wenn \"n\" eingetragen wird, werden keinen neuen Benutzer angezeigt.",
"If set to \"n\", do not show tracker changes." => "Wenn \"n\" eingetragen wird, werden keine Trackeränderungen angezeigt.",
"Calendar focus" => "Kalenderfokus",
"Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Solange nicht \"ignore\" eingetragen wird, ändert das Modul den Zeit-Referenzpunkt vom Datum/Zeit des letzten Login des Benutzer zu einem Tag an dem der Benutzer den Kalender aufruft",
"Show date as a calendar link" => "Zeige Datum als Kalenderlink",
"If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "Wenn \"n\" eingetragen wird, wird kein Kalenderlink im Datum im Kopfbereich des Modul angezeigt (auch nicht wenn die Kalenderfunktion aktiviert ist)",
"Fold sections by default" => "Abschnitte standardmäßig einklappen",
"If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "Wenn \"y\" eingetragen wird, werden Abschnitte automatisch eingeklappt und es wird nur der Titel angezeigt (Benutzer müssen auf jeden Abschnitt klicken, um die Details der Änderungen zu sehen)",
// "Use tabbed presentation" => "Use tabbed presentation",
// "If set to \"y\", use Bootstrap tabs to show the result" => "If set to \"y\", use Bootstrap tabs to show the result",
"Minimum timespan" => "Mindestzeitspanne",
"Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Gehe anstelle zur letzten Login-Zeit die Mindestzeitspanne zurück. Angegeben in Tagen, für den Fall, dass der Login neuer ist",
// "Maximum comment length" => "Maximum comment length",
"Changes since" => "Änderungen seit",
"Since your last visit..." => "Seit Deinem letzten Besuch",
"In the last %0 days.." => "In den letzten %0 Tagen..",
"new comments" => "Neue Kommentare",
" (archived)" => " (archiviert)",
"new posts" => "neue Forenposts",
"wiki pages changed" => "Wiki-Seiten geändert",
"new articles" => "neue Artikel",
"new FAQs" => "neue FAQs",
"new blogs" => "Neue Blogs",
"new blog posts" => "Neue Blog Veröffentlichungen",
"new image galleries" => "neue Bildergalerien",
"new images" => "Neue Bilder",
"new file galleries" => "neue Dateiarchive",
"new files" => "Neue Dateien",
"new polls" => "Neue Abstimmungen",
"new users" => "Neue Benutzer",
"new tracker items" => "neue Trackereinträge",
"updated tracker items" => "aktualisierte Trackereinträge",
// "new calendars" => "new calendars",
// "new events" => "new events",
// "starting on" => "starting on",
// "If comments don't use titles this sets the maximum length for the comment snippet" => "If comments don't use titles this sets the maximum length for the comment snippet",
"SVN Up Info" => "SVN Up Info",
"SVN Version and last update information." => "SVN Version Informationen zum letzten Update.",
"Switch Language" => "Sprache umstellen",
"Displays a language picker to change the language of the site." => "Zeigt eine Sprachauswahl, um die Site-Sprache zu ändern.",
"Display mode" => "Anzeigemodus",
"Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Ändere die Listenansicht für Sprachen. Möglich sind droplist (f. Ausklappliste), flags (f. Flaggen), words (f. Worte). Standard ist droplist (Ausklappliste)",
// "Switch Admin Language" => "Switch Admin Language",
// "Displays a language picker to change the language of admin site" => "Displays a language picker to change the language of admin site",
"Switch Theme" => "Theme ändern",
// "Enables to quickly change the theme for the user" => "Enables to quickly change the theme for the user",
// "Not allowed here" => "Not allowed here",
// "Displayed theme" => "Displayed theme",
// "Admin Theme" => "Admin Theme",
"Terminology" => "Terminologie",
"Support for multilingual terminology" => "Unterstützung für multilinguale Terminologie",
"Root category" => "Hauptkategorie",
"All terms will automatically be put in that category. " => "Alle Begriffe werden automatisch in diese Kategorie gelegt",
"Note that the category must already exist. " => "Beachte, dass eine Kategorie bereits existieren muss",
"Defaults to 'Term'" => "Standards für 'Term'",
"Tiki Tests" => "Tiki Tests",
"Tiki test suite helper." => "Tiki Testsuite Hilfe",
"Most Active blogs" => "Aktivste Blogs",
"Displays the specified number of blogs with links to them, from the most active one to the least." => "Zeige eine bestimmte Anzahl von Blogs mit Links zu diesen, sortiert nach den Aktivsten.",
"Blog activity measurement can be more or less accurate." => "Die Messung der Blogaktivität kann mehr oder weniger genau sein.",
"Lists the specified number of articles with links to them, from the most visited one to the least." => "Zeige eine bestimmte Anzahl von Artikeln mit Links zu diesen, sortiert nach den am häufigsten besuchten.",
// "Top Blog Posters" => "Top Blog Posters",
// "Displays the specified number of users who posted to blogs, starting with the one having most posts" => "Displays the specified number of users who posted to blogs, starting with the one having most posts",
// "Limit to a blog" => "Limit to a blog",
"Top File Galleries" => "Top Dateiarchive",
"Displays the specified number of file galleries with links to them, starting with the one with most hits." => "Zeige eine bestimmte Anzahl von Dateiarchiven mit Links zu diesen, angefangen mit dem Dateiarchiv mit den meisten Treffern.",
"Top Files" => "Top Dateien",
"Displays the specified number of files with links to them, starting with the one with most hits." => "Zeige eine bestimmte Anzahl von Dateien mit Links zu diesen, angefangen mit der Datei mit den meisten Treffern.",
"Top Forum Posters" => "Top Forum Poster",
"Displays the specified number of users who posted to forums, starting with the one having most posts." => "Zeige eine bestimmte Anzahl von Benutzern, die in Foren posten, angefangen mit dem, der die meisten Posts hat.",
"Top Image Galleries" => "Top Bildergalerien",
"Displays the specified number of image galleries with links to them, starting with the one with most hits." => "Zeige eine bestimmte Anzahl von Bildergalerien, mit Links zu diesen, beginnend mit derjenigen mit den meisten Treffern.",
"Top Images" => "Top Bilder",
"Displays the specified number of images with links to them, from the most visited one to the least." => "Zeige eine bestimmte Anzahl von Bildern mit Links zu diesen, von den am häufigsten besuchten zu den am wenigsten besuchten.",
"Top Objects" => "Top Objekte",
"Displays the specified number of objects, starting with the one having the most hits" => "Zeige eine bestimmte Anzahl von Objekten, beginnend mit dem, mit den meisten Treffern",
"Top Pages" => "Top Seiten",
"Displays the specified number of wiki pages with links to them, starting with the one having the most hits." => "Zeige eine bestimmte Anzahl von Wiki Seiten mit Links zu diesen, angefangen mit der Seite mit den meisten Treffern.",
"Top Quizzes" => "Top Quiz",
"Displays the specified number of quizzes with links to them, starting with the one having the most hits." => "Zeige eine bestimmte Anzahl von Quiz mit Links zu diesen, angefangen mit dem Quiz mit den meisten Treffern.",
"Top Visited Blogs" => "Meistbesuchte Blogs",
"Display the specified number of blogs with links to them, from the most visited one to the least." => "Zeige eine bestimmte Anzahl von Blogs mit Links zu diesen, sortiert nach den am häufigsten besuchten.",
"Show Last Post" => "Zeige letzten Post",
"Top Visited FAQs" => "Meistbesuchte FAQs",
"Display the specified number of FAQs with links to them, from the most visited one to the least" => "Zeige eine bestimmte Anzahl von FAQs mit Links zu ihnen an, sortiert nach den am häufigsten besuchten ",
"Tracker Input" => "Tracker-Eingabe",
"Allows a dialog to be opened to create new tracker items" => "Erlaubt einen Dialog, um einen neuen Trackereintrag anzulegen",
"Tracker ID to render" => "Tracker-ID zur Verarbeitung",
"Text Input" => "Texteingabe",
"Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Anzuzeigende multiple Textfelder als Teil des Hauptformulars zusammen mit der Bezeichnung. Feldnamen verknüpfen zu den permanenten Namen in den Tracker-Felddefinitionen. Z.B. groupName(Group Name) relatedTask(Task)",
"Location Field" => "Ortsfeld",
"Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Erhalte Koordinaten aus einer nahen Karte und sende sie an das Ort-Feld. Zusätzlich zum Feldnamen können :marker oder :viewport als Suffixe verwendet werden. Als Standard wird :marker verwendet",
"Capture StreetView" => "Erfasse StreetView",
"Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Füge eine Schaltfläche auf dem StreetView-Interface hinzu, um Trackereinträge von dem Ort zu erstellen. Erfordert die Parameter \"Bild von URL hochladen\" und \"Ort\"",
"Alter the submit button label" => "Verändere die Absendeschaltfläche",
"Operation to perform on success" => "Operation, die bei Erfolg ausgeführt wird",
"Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Format für die Operation: OperationsName(Argument). Gegenwärtige Operationen werden mit der URL-Vorlage als Argument weitergeleitet. @valueName@ wird durch den entsprechenden Wert ersetzt, wobei valueName entweder Eintrag-ID, Status oder ein permanenter Name ist",
// "Mode change on complete" => "Mode change on complete",
// "Target mode to enter after dialog closes" => "Target mode to enter after dialog closes",
"Tracker Help" => "Trackerhilfe",
"Display the fields of a tracker (name and identifier)" => "Zeigt die Felder eines Tracker (Name und Kennung, ID)",
"Text field height" => "Textfeldhöhe",
"Number of lines" => "Zeilenanzahl",
"Text field width" => "Textfeldbreite",
"Number of characters" => "Zeichenzahl",
"Translate Updates" => "Stand der Übersetzung",
"Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed." => "Links zu Versionen von Wiki Seiten, die in anderen Sprachen angezeigt werden. Es wird zwischen besseren, gleichwertigen und schlechteren Übersetzungen unterschieden. Optional wird die Aktualität der aktuell angezeigten Übersetzung dargestellt.",
"Reference language" => "Referenzsprache",
"If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed." => "Wenn ein Sprachcode angegeben wird, werden die auf der Referenzseite angezeigten Seiten eingeschränkt; es sei denn, die Seite wird angezeigt.",
"Show language" => "Zeige Sprache",
"If \"y\" the page language will be shown instead of the page name." => "Wenn \"y\", dann wird die Seitensprache anstelle des Seitennamen angezeigt",
"Default = \"y\"." => "Standard = \"y\".",
// "Tweets" => "Tweets",
// "Shows the tweets from the Twitter timeline of a user" => "Shows the tweets from the Twitter timeline of a user",
// "Tiki user to show Twitter timeline of" => "Tiki user to show Twitter timeline of",
// "Show public|friends timeline. " => "Show public|friends timeline. ",
// "Search string" => "Search string",
// "user not registered with twitter" => "user not registered with twitter",
"Lists the specified number of calendar events, ordered by their start date." => "Listet eine bestimmte Anzahl von Kalendereignissen, geordnet nach Startdatum.",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "Wird eine Liste von Kalendern angegeben, werden die Ereignisse auf die ausgewählten Kalender beschränkt. IDs werden durch Senkrechtstriche (\"|\"), Kommata (\",\") oder Doppelpunkte (\":\") getrennt",
"Maximum days in the future" => "Maximale Tage in der Zukunft",
"Maximum distance to event start dates in days (looking forward)" => "Maximaler Abstand zum Ereignis-Startdatum in Tagen (nach vorne blickend)",
"Maximum days in the past" => "Maximale Anzahl von Tagen in der Vergangenheit",
"Maximum distance to event end dates in days (looking backward)" => "Maximaler Abstand zum Ereignis-Enddatum in Tagen (zurück blickend)",
"cellpadding" => "Zelleninnenabstand",
"If set to an integer, apply this cellpadding to the HTML table generated" => "Eingabe eines ganzen Zahl legt den Zelleninnenabstand der erstellten HTML-Tabelle fest",
"cellspacing" => "Zellenabstand",
"If set to an integer, apply this cellspacing to the HTML table generated" => "Eingabe einer ganzen Zahl legt den Zellenabstand der erstellten HTML-Tabelle fest",
"If set to \"y\", event descriptions are displayed" => "Wird \"y\" eingetragen, werden Ereignisbeschreibungen angezeigt",
"Show end date and time" => "Blende Enddatum und -uhrzeit ein",
"If set to \"y\", event end dates and times are displayed, when appropriate" => "Wird \"y\", eingetragen, werden Enddatum und -uhrzeit des Ereignisses angezeigt, sofern angebracht",
"Use custom calendar background colors" => "Benutze benutzerdefinierte Kalenderhintergrundfarben",
"If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "Wird \"y\" eingetragen, werden Ereignisse in der angegebenen Hintergrundfarbe in Kalender angezeigt",
"Show information in tooltips" => "Zeige Informationen in der Tooltip-Hilfe",
"If set to \"n\", event tooltips will not display event information" => "Wird \"n\" eingetragen, wird in der Tooltip-Hilfe eine Ereignisinformationen angezeigt",
"Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format für die meisten Daten. Siehe <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() Dokumentation</a>",
"site preference for short date format followed by site preference for short time format" => "Site-Einstellung für kurzes Datumsformat gefolgt von der Site-Einstellung für das kurze Zeitformat",
"If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "Wird ein Ganzzahlwert angegeben, werden Ereignisnamen mit einer Zeichenanszahl erlaubt, bis der Wert erreicht ist, danach wird abgeschnitten",
"My Blogs" => "Meine Blogs",
"Displays to registered users their blogs." => "Zeigt registrierten Benutzern deren Blogs.",
"My Bookmarks" => "Benutzerlesezeichen",
"Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweightinterface für Benutzer Bookmarks, um diese übersichtlich anzuzeigen, zu bearbeiten und um die aktuell angezeigte Seite zu bookmarken",
"My Image Galleries" => "Benutzer Bildergalerien",
"Displays to registered users their image galleries." => "Zeigt registrierten Benutzern deren Bildergalerien.",
"User Pages" => "Benutzerseiten",
"Displays to registered users the specified number of wiki pages which they were the last to edit." => "Zeigt registrierten Benutzern eine bestimmte Anzahl von Wiki Seiten an, die sie zuletzt bearbeitet haben.",
"My Pages" => "Meine Seiten",
"My Tasks" => "Benutzeraufgaben",
"Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweightinterface für Benutzeraufgaben, um diese übersichtlich anzuzeigen und zu bearbeiten",
"The task title must have at least 3 characters" => "Der Aufgabentitel muss mindestens drei Zeichen lang sein",
"Public Tasks" => "Öffentliche Aufgaben",
"Lists the public user tasks of a chosen group, with links to tasks." => "Listet die öffentlichen Benutzeraufgaben einer gewählten Gruppe mit Links zu diesen Aufgaben.",
"User-Group Tracker" => "Benutzer-/Gruppen Tracker",
"User and Group tracker links." => "Benutzer und Gruppen Trackerlinks.",
// "Users List" => "Users List",
// "Display a list of users with optional extra information from each" => "Display a list of users with optional extra information from each",
"Login" => "Login",
// "Show the user name" => "Show the user name",
"y|n" => "y|n",
// "Show the user real name" => "Show the user real name",
// "Last Login" => "Last Login",
// "Show the last login date" => "Show the last login date",
// "Show the direct and included groups a user belongs to" => "Show the direct and included groups a user belongs to",
// "Show the user profile picture" => "Show the user profile picture",
// "Show a link to the userPage" => "Show a link to the userPage",
// "Log" => "Log",
// "Show a link to the user logs(feature actionlog must be activated)" => "Show a link to the user logs(feature actionlog must be activated)",
// "Show only the users of the group" => "Show only the users of the group",
// "Groupname" => "Groupname",
// "Included Groups" => "Included Groups",
// "Show only the users of the group group and of a group including group" => "Show only the users of the group group and of a group including group",
// "initial" => "initial",
// "Show only the users whose name begins with the letter" => "Show only the users whose name begins with the letter",
// "a letter" => "a letter",
// "heading" => "heading",
// "Show the table heading" => "Show the table heading",
// "Sort users in ascending or descending order using these values: " => "Sort users in ascending or descending order using these values: ",
"My Score" => "Meine Punktzahl",
"Display the logged user's rank and score" => "Zeige den Rank und die Punktzahl des eingeloggten Benutzers",
"Most Active Users" => "Top Benutzer",
"Display the specified number of users and their score, starting from the one with the highest score." => "Zeigt eine bestimmte Anzahl von Benutzern und derem Score, angefangen mit demjenigen, mit dem höchsten Wert.",
// "websearch" => "websearch",
// "Displays a simple form to perform a web search with choice on multiple search engines" => "Displays a simple form to perform a web search with choice on multiple search engines",
"Related Items" => "Was ist zugeordnet",
"Lists objects which share a category with the viewed object." => "Zeigt Objekte, welche der gleichen Kategorie zugeordnet sind, wie das betrachtete Objekt.",
"Online Users" => "Online Benutzer",
"Display information about users currently logged in" => "Zeige Informationen über gegenwärtig angemeldete Benutzer",
"Display the number of users logged in, the list of users logged in, or both." => "Zeige die Anzahl der angemeldeten Benutzer (count), die Liste der angemeldeten Benutzer (list) oder beides (both).",
"Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Mögliche Werte: \"count\", \"list\" oder \"both\". Standardwert: \"both\"",
"Cluster Mode" => "Cluster-Modus",
"If set to \"1\", separate users based on which host/server they logged on." => "Wenn \"1\" eingetragen wird, werden die Benutzer danach getrennt, auf welchem host/server sie angemeldet sind.",
// "Silent Mode" => "Silent Mode",
// "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it" => "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it",
"Newest Comments" => "Neueste Kommentare",
"Lists the specified number of comments starting from the most recently posted." => "Listet eine bestimmte Anzahl von Kommentaren auf, beginnend mit dem zuletzt abgegebenen.",
"More in tooltips" => "Mehr in Tooltip-Hilfe",
"If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "Wird \"y\" angegeben, wird das Objekt, das kommentiert wurde, nicht in der Modulbox angezeigt, dafür aber in der Tooltip-Hilfe des Objektes",
"Type of the objects from which comments will be listed. Possible values" => "Objekttypen, von denen Kommentare aufgelistet werden. Mögliche Werte",
// "Display user profile pictures instead of numbers" => "Display user profile pictures instead of numbers",
// "Comments about objects in this language only" => "Comments about objects in this language only",
"Last article comments" => "Neueste Artikelkommentare",
"Last wiki comments" => "Die letzten Wiki-Kommentare",
// "Hold a chat session using XMPP (uses the ConverseJS client)" => "Hold a chat session using XMPP (uses the ConverseJS client)",
// "XMPP" => "XMPP",
"Displays YouTube videos and/or a link to a YouTube user's page." => "Zeigt ein YouTube Video und/oder einen Link zu einer YouTube-Benutzerseite.",
"Video identifiers" => "Videokennung (ID)",
"List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "Liste der YouTube Videokennung (ID), die angezeigt werden. Identifzierer werden durch Kommata getrennt (\",\")",
"YouTube user identifier" => "YouTube Benutzeridentifzierer",
"If set to a YouTube user identifier, display a link to the videos of this user" => "Wenn YouTube Benutzeridentifzierer gewählt wurde, dann zeige einen Link zu den Videos dieses Benutzers",
"Videos on YouTube" => "Videos auf YouTube",
// "Module Zone" => "Module Zone",
// "Can contain other modules so can be used as a Bootstrap navbar object, for example" => "Can contain other modules so can be used as a Bootstrap navbar object, for example",
// "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel" => "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel",
// "Example for a Bootstrap \"social\" navbar" => "Example for a Bootstrap \"social\" navbar",
"Bibliography Search" => "Bibliographiesuche",
"Search the group's Zotero library for entries with the specified tags" => "Suche in der Zotero-Bibliothek der Gruppe nach Einträge mit den angegebenen Tags",
// "failure" => "failure",
// "You do not have sufficient permissions to perform this action" => "You do not have sufficient permissions to perform this action",
// "Please enter Biblio Code" => "Please enter Biblio Code",
// "Biblio code must not exceed 50 characters" => "Biblio code must not exceed 50 characters",
// "success" => "success",
// "Page not found. Please save the page first" => "Page not found. Please save the page first",
// "This reference already exists in the library" => "This reference already exists in the library",
// "Reference added to library" => "Reference added to library",
// "This biblio code already exists" => "This biblio code already exists",
// "Bibliography saved" => "Bibliography saved",
// "Reference already exists" => "Reference already exists",
// "Reference added" => "Reference added",
"Invalid server key" => "Ungültiger Serverschlüssel",
"Invalid username or password" => "Ungültiger Benutzername oder Passwort",
"Cookie not found" => "Cookie nicht gefunden",
// "This user is your friend" => "This user is your friend",
// "You share the following groups with this user" => "You share the following groups with this user",
// "Unlike" => "Unlike",
// "There is no activity to display in this stream" => "There is no activity to display in this stream",
// "%0 %1" => "%0 %1",
// "%0 posted a comment to" => "%0 posted a comment to",
// "%0 started a new discussion" => "%0 started a new discussion",
// "Join the discussion" => "Join the discussion",
// "%0 replied to a thread" => "%0 replied to a thread",
// "%0 corrected a message" => "%0 corrected a message",
// "%0 requested an action from you" => "%0 requested an action from you",
// "%0 triggered your %1 priority saved filter" => "%0 triggered your %1 priority saved filter",
// "Critical Priority" => "Critical Priority",
// "See your saved filter" => "See your saved filter",
// "High Priority" => "High Priority",
// "Low Priority" => "Low Priority",
// "Recommended Reading" => "Recommended Reading",
// "Based on your previous activity, we believe you might find this useful" => "Based on your previous activity, we believe you might find this useful",
// "Was this useful" => "Was this useful",
// "Help us improve" => "Help us improve",
// "%0 created a tracker" => "%0 created a tracker",
"%0 created a tracker item" => "%0 erstellte einen Tracker-Satz",
"%0 modified a tracker item" => "%0 änderte einen Tracker-Satz",
// "%0 has added %1 to his stream" => "%0 has added %1 to his stream",
"%0 is now followed by %1" => "%0 wird nun von %1 gefolgt",
"%0 and %1 became friends" => "%0 and %1 sind jetzt befreundet",
// "%0 created a page" => "%0 created a page",
// "%0 modified a page" => "%0 modified a page",
// "View changes" => "View changes",
// "history" => "history",
// "Show More" => "Show More",
"Saving..." => "Speichere..",
// "Adding.." => "Adding..",
// "References Available" => "References Available",
"Add to library" => "Zur Bibliothek beifügen",
// "Library References" => "Library References",
"Use" => "Benutze",
// "Edit Library References" => "Edit Library References",
"Part" => "Teil",
// "URI" => "URI",
// "Publisher" => "Publisher",
// "Enter the CSS class name to be added in the 'li' tag for listing this reference" => "Enter the CSS class name to be added in the 'li' tag for listing this reference",
// "Enter template format in which you want to display the reference details in the bibliography listing. For example" => "Enter template format in which you want to display the reference details in the bibliography listing. For example",
// "All the codes must be in lower case letters separated with spaces" => "All the codes must be in lower case letters separated with spaces",
// "Please save the page before creating the bibliography" => "Please save the page before creating the bibliography",
"Preference Filters" => "Einstellungsfilter",
// "basic" => "basic",
"Set as my default" => "Als Standard setzen",
// "Provide Feedback" => "Provide Feedback",
// "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them" => "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them",
// "Icon for 'Like'" => "Icon for 'Like'",
// "Icon for 'Fix me'" => "Icon for 'Fix me'",
// "Icon for 'What is this for?'" => "Icon for 'What is this for?'",
// "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)" => "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)",
// "Click to read more" => "Click to read more",
// "Rebuild Admin Index" => "Rebuild Admin Index",
// "Control Panels" => "Control Panels",
// "Search preferences" => "Search preferences",
"Configuration search" => "Einstellungen suchen",
"Note: The search index needs rebuilding, this will take a few minutes" => "Hinweis: Der Suchindex muss neu erstellt werden. Dies wird ein paar Minuten dauern",
// "Preference Search Results" => "Preference Search Results",
// "Apply Changes" => "Apply Changes",
"Apply" => "Übernehmen",
"No results" => "Keine Ergebnisse",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Not what you expected? Try %0rebuilding%1 the preferences search index" => "Not what you expected? Try %0rebuilding%1 the preferences search index",
"Access" => "Zugang",
"Users" => "Benutzer",
// "Banning" => "Banning",
"Directories" => "Verzeichnisse",
"External Feeds" => "Externe Feeds",
"HTML Pages" => "HTML-Seiten",
// "Wiki Structures" => "Wiki Structures",
"System" => "System",
// "Activity Rules" => "Activity Rules",
"Content Templates" => "Inhaltsvorlagen",
// "Languages" => "Languages",
"Mail Notifications" => "E-Mail-Benachrichtigungen",
"Menus" => "Menüs",
// "User Credits" => "User Credits",
"Transitions" => "Überleitungen",
"Plugin Approval" => "Bestätigung von Plugins",
"Mods" => "Mods",
"Tools" => "Werkzeuge",
"Action Log" => "Aktionslog",
"Cookies" => "Cookies",
// "DSN/Content Authentication" => "DSN/Content Authentication",
// "Edit TPL" => "Edit TPL",
"External Pages Cache" => "Cache für externe Seiten",
"External Wikis" => "Externe Wiki-Seiten",
// "Importer" => "Importer",
// "PhpInfo" => "PhpInfo",
// "Referer Statistics" => "Referer Statistics",
// "Search Statistics" => "Search Statistics",
"Security Admin" => "Sicherheit",
// "Server Check" => "Server Check",
// "Synchronize Dev" => "Synchronize Dev",
// "System Cache" => "System Cache",
// "System Logs" => "System Logs",
// "Sitemap" => "Sitemap",
// "Wizards" => "Wizards",
"Cancel Edit" => "Bearbeitung verwerfen",
// "Banners listing" => "Banners listing",
"Activate the feature" => "Funktion aktivieren",
// "Site ads and banners" => "Site ads and banners",
// "Apply changes" => "Apply changes",
// "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>" => "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>",
// "List of articles" => "List of articles",
// "List of article types" => "List of article types",
"Article Types" => "Artikeltypen",
// "List of article topics" => "List of article topics",
"General Settings" => "Generelle Einstellungen",
"Features" => "Funktionen",
// "Custom (Article Own) images setting" => "Custom (Article Own) images setting",
"Sharing on social networks" => "Sharing in sozialen Netzwerken",
"Import CSV file" => "CSV-Datei importieren",
"Batch upload (CSV file)" => "Stapelhochladen (CSV-Datei)",
"File format: title,authorName,heading,body,lang,user" => "Dateiformat: Titel,Autorname,Überschrift (Kopf),Text (Body),Sprache,Benutzer",
// "Articles Listing and View" => "Articles Listing and View",
"List articles" => "Artikel auflisten",
// "Article view" => "Article view",
// "Blogs listing" => "Blogs listing",
"Blogs Listings" => "Blogauflistungen",
// "Items to display" => "Items to display",
// "Calendars listing" => "Calendars listing",
"General settings" => "Allgemeine Einstellungen",
// "Categories listing" => "Categories listing",
// "Browse Categories" => "Browse Categories",
// "Administer Categories" => "Administer Categories",
// "Organize objects" => "Organize objects",
"Organize Objects" => "Objekte kategorisieren",
"Category objects" => "Kategorieobjekte",
// "Re-apply last saved category defaults to wiki pages" => "Re-apply last saved category defaults to wiki pages",
"Performance" => "Performance",
// "Comments listing" => "Comments listing",
"Site-wide features" => "Site-weite Funktionen",
"Display options" => "Anzeigeoptionen",
// "Annotations" => "Annotations",
"Using comments in various features" => "Kommentarbenutzung in verschiedenen Funktionen",
// "Group Administration" => "Group Administration",
// "User Administration" => "User Administration",
// "Community Features" => "Community Features",
"Community" => "Gemeinschaft",
// "Additional options" => "Additional options",
// "Social Interaction" => "Social Interaction",
// "Friendship and followers" => "Friendship and followers",
"Select which items to display when listing users" => "Wähle, welche Dinge bei der Auflistung der Benutzer angezeigt werden sollen",
// "Activity stream" => "Activity stream",
"Tiki Connect" => "Tiki Verbindung",
"Join the community!" => "Schließ Dich der Gemeinschaft an!",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU." => "Tiki Wiki CMS Groupware ist frei und Open Source Software (FOSS). Sie ist ein Gemeinschaftsgelenktes Projekt, welches nur durch die Teilnahme von einzelnen Benutzer - so wie DU - existiert und verbessert wird.",
"Join the Community" => "Trete der Gemeinschaft bei",
"Tiki news" => "Tiki Neuigkeiten",
"Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Bette RSS Feed von info.tiki.org ein (zu erledigen). Zwischenzeitlich",
"Tiki Newsletter" => "Tiki Newsletter",
"Promote your site" => "Bewerbe Deine Site",
"Add your site to the Tiki directory." => "Füge Deine Site zum Tiki-Verzeichnis hinzu",
"Submit your site" => "Übermittele Deine Site",
"Spread the word" => "Weitersagen",
"Add the \"Powered by\" module to your site. " => "Füge das \"Powered by\"-Modul zu Deiner Site hinzu. ",
"Manage Modules" => "Module verwalten",
"Help improve Tiki" => "Helfe Tiki zu verbessern",
"Submit a feature request or bug report" => "Übermittele eine Funktionsanfrage oder einen Fehlerbericht",
// "Visit Tiki development site" => "Visit Tiki development site",
"Make a financial contribution to the Tiki Association" => "Leiste einen finanziellen Beitrag zur Tiki-Gemeinschaft",
"Contribute to Tiki" => "Trage zu Tiki bei",
"New Feature" => "Neue Funktion",
"Please note: Experimental - work in progress" => "Beachte bitte: experimentell - hieran wird noch gearbeitet",
"Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Verbindung ist ein Weg die Tiki Gemeinschaft wissen zu lassen, wie Tiki genutzt wird und welche Teile von den Benutzern gemocht werden oder repariert werden müssen (oder erklärt werden müssen)",
// "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)" => "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)",
// "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'" => "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'",
// "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)" => "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)",
"Send Info" => "Sende Info",
"Send the data" => "Sende die Daten",
"Preview info" => "Vorschauinfo",
"See what is going to be sent" => "Siehe, was gesendet werden wird",
"Fill form" => "Formular ausfüllen",
"Fill this form in based on other preferences" => "Fülle dieses Formular basierend auf anderen Einstellungen aus",
"Advanced settings" => "Erweiterte Einstellungen",
"Exposed to assist testing and development" => "Herausgestellt, um beim Testen und Entwickeln zu unterstützen",
// "Connections Received" => "Connections Received",
"Rebuild received connections index" => "Erstelle Verbindungs-Index neu",
"<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Serverstatistik:</strong> %0 Berichte von %1 Tikis erhalten",
// "Jitsi" => "Jitsi",
// "Provision URL" => "Provision URL",
// "Allows a copyright to be determined for various objects" => "Allows a copyright to be determined for various objects",
// "Directories listing" => "Directories listing",
// "Extention package error" => "Extention package error",
// "Cannot show page because the extension package is not installed or activated" => "Cannot show page because the extension package is not installed or activated",
// "Extension package admin template page is missing" => "Extension package admin template page is missing",
// "FAQ listing" => "FAQ listing",
// "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
"Global features" => "Globale Funktionen",
// "Main features" => "Main features",
// "Secondary features" => "Secondary features",
// "Administrative features" => "Administrative features",
"Watches" => "Beobachtungspunkte",
// "Additional features" => "Additional features",
// "Payment and Accounting" => "Payment and Accounting",
// "Mail and Sharing" => "Mail and Sharing",
"Interaction with online services or other software" => "Interaktion mit Onlinediensten und anderer Software",
"Configuration completed" => "Konfiguration vollständig",
"Authenticate with Zotero" => "Bei Zotero authentifizieren",
"Interface" => "Interface",
"jQuery plugins and add-ons" => "jQuery Plugins und Add-ons",
"Programmer" => "Entwickler",
"Logging and Reporting" => "Protokollierung und Benachrichtigung",
"Visible to admin only" => "Nur für Administrator sichtbar",
"Include Smarty notices" => "Auch Smarty-Hinweise anzeigen",
"Custom Code" => "Angepasster Code",
"To create or remove file galleries, select" => "Um ein Dateiarchiv zu erstellen oder zu entfernen, wähle",
"from the application menu" => "aus dem Anwendungsmenü",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Wenn Dateien in einem Verzeichnis (statt in der Datenbank) gespeichert werden sollen, sollte das Verzeichnis nicht direkt zugreifbar sein.",
// "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Das Verzeichnis sollte in Unix-Notation angegeben werden, z.B. files/ oder c:/foo/files oder /www/files/",
// "File galleries listing" => "File galleries listing",
"Move files from database to directory" => "Verschiebe Dateien von der Datenbank in ein Verzeichnis",
"Move files from directory to database" => "Verschiebe Dateien aus einem Verzeichnis in die Datenbank ",
"Manage comment settings" => "Verwalte Kommentareinstellungen",
"Update mime of all non archived octet-stream files" => "Aktualisiere MIME für alle nicht archivierten octet-stream-Dateien",
"Used:" => "Benutzt:",
"Upload Regex" => "Regulärer Ausdruck für das Hochladen (regex)",
// "Settings for Media Alchemyst" => "Settings for Media Alchemyst",
// "Settings for Diagrams" => "Settings for Diagrams",
// "Listings" => "Listings",
// "Configuration for gallery listings" => "Configuration for gallery listings",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Veränderungen beeinflussen bestehende Dateiarchive <em>nicht</em>. Diese Änderungen betreffend <em>nur</em> neue Dateiarchive",
"Admin Listings" => "Admin Listen",
// "Configuration for gallery administration listings" => "Configuration for gallery administration listings",
"Search Indexing" => "Indexierung",
"Handlers" => "Handler",
"Add custom handlers to make your files &quot;searchable&quot; content" => "Füge einen benutzerdefinierten Handler hinzu, um den Inhalt Deiner Dateien \"durchsuchbar\" zu machen",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Benutze <strong>%1</strong> für den internen Dateinamen. Zum Beispiel, benutze <strong>strings %1</strong>, um ein Dokument mit dem Unixbefehl <strong>strings</strong> in Text umzuwandeln.",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "Um einen Handler zu löschen, lass das Feld <strong>Systembefehl</strong> leer",
"Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable." => "Tiki wurde vorkonfiguriert, um viele verschiedene Dateitypen handzuhaben. Wird keine nachfolgend aufgeführt, liegt das daran, dass die Befehlszeile nicht zur Verfügung steht.",
"Missing Handlers" => "Fehlende Handler",
// "Mime Types" => "Mime Types",
// "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly" => "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly",
// "Fix vnd.ms-* mime type files" => "Fix vnd.ms-* mime type files",
"MIME Type" => "MIME-Typ",
"System Command" => "Systembefehl",
"Reindex all files for search" => "Dateien für Suche neu indizieren",
// "Enhancements" => "Enhancements",
// "H5P Info" => "H5P Info",
// "Service URL to purge unused libraries can be found here. Can be used in a cron task" => "Service URL to purge unused libraries can be found here. Can be used in a cron task",
"SCORM" => "SCORM",
// "OCR Indexing" => "OCR Indexing",
// "Forums listing" => "Forums listing",
// "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums" => "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums",
"Threads" => "Threads",
"Searches" => "Suchanfragen",
// "Forum Listing" => "Forum Listing",
// "Tags listing" => "Tags listing",
// "Browse Tags" => "Browse Tags",
"Translate tags" => "Tags übersetzen",
// "Translate Tags" => "Translate Tags",
// "Remove tags not applied to any objects" => "Remove tags not applied to any objects",
// "Clean Up Unused Tags" => "Clean Up Unused Tags",
"Random tag cloud colors" => "Farben für zufällige Tags",
"Separate colors with a comma (,)" => "Trenne Farben mit Kommata (,)",
"Alphanumeric ASCII characters only" => "Nur alphanumerische ASCII-Zeichen",
"No accents or special characters" => "Keine Akzente oder Sonderzeichen",
"Accept all characters" => "Akzeptiere alle Zeichen",
// "Tag search page" => "Tag search page",
// "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Bildgalerien hinzufügen/löschen über Menüpunkt 'Bildgalerien' im Menü im Seitenbalken oder",
"Click Here" => "hier klicken",
"You can upload images of a size of " => "Maximale Größe zum uploaden von Bildern: ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Ändere in der php.ini die Parameter file_uploads, upload_max_filesize, post_max_size und die Datenbankparameter (max_allowed_packet für MySQL), um diesen Größe zu ändern",
"Galleries features" => "Galerieeigenschaften",
"Gallery listing configuration" => "Einstellungen Galerie-Liste",
"Comments settings" => "Kommentareinstellungen",
// "Manage images" => "Manage images",
// "Remove unused images" => "Remove unused images",
// "Remove unused images in the system gallery" => "Remove unused images in the system gallery",
// "Remove images not being used in wiki pages, articles or blog posts" => "Remove images not being used in wiki pages, articles or blog posts",
"Move images from database storage to filesystem storage" => "Verschiebe Bilder von der Datenbank in ein Verzeichnis",
"Move images from filesystem storage to database storage" => "Verschiebe alle Bilder aus dem Dateisystem in die Datenbank",
// "Move images" => "Move images",
"All galleries" => "Alle Galerien",
"System Gallery" => "Systemgalerie",
"Reset or upgrade your database" => "Datenbank neu aufsetzen oder aktualisieren",
// "Create and edit menus" => "Create and edit menus",
// "Server Fitness" => "Server Fitness",
// "Check if your server meets the requirements for running Tiki" => "Check if your server meets the requirements for running Tiki",
// "Check for Updates Now" => "Check for Updates Now",
// "Check if a new Tiki version is available" => "Check if a new Tiki version is available",
"General Preferences" => "Verschiedene Einstellungen",
// "Release check" => "Release check",
"Last update from SVN" => "Letztes Update von SVN",
// "Site identity" => "Site identity",
// "Themes" => "Themes",
// "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences" => "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences",
"These values will be stored in plain text in the database" => "Diese Werte werden in Klartext in der Datenbank gespeichert",
"Email to send a test mail" => "E-Mailadresse für die Testmail",
// "Logging and reporting" => "Logging and reporting",
// "Web Cron" => "Web Cron",
// "Call Web Cron URL" => "Call Web Cron URL",
// "Scheduler Settings" => "Scheduler Settings",
"Sessions" => "Sitzungen",
// "Advanced configuration" => "Advanced configuration",
"Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects." => "Beachte bitte, dass das Speichern von Sitzungsdaten in der Datenbank eine fortgeschrittene Funktion ist. Sie ist nur für Systemadministratoren gedacht, die vollen Zugriff auf und ein entsprechendes Verständnis für die Datenbank haben, um ggf. mit unerwarteten Effekten umgehen zu können.",
"Changing this feature will immediately log you out when you save this preference." => "Ändern und Speichern dieses Werts hat eine umgehende Abmeldung zur Folge.",
"Enable now" => "Jetzt aktivieren",
"Contact" => "Kontakt",
// "Terms and conditions" => "Terms and conditions",
// "Home page" => "Home page",
"Redirects" => "Weiterleitungen",
// "Site access" => "Site access",
// "Test site closed message" => "Test site closed message",
// "The namespace separator should not" => "The namespace separator should not",
// "contain any of the characters not allowed in wiki page names, typically" => "contain any of the characters not allowed in wiki page names, typically",
// "conflict with wiki syntax tagging" => "conflict with wiki syntax tagging",
// "To use :: as a separator, you should also use ::: as the wiki center tag syntax" => "To use :: as a separator, you should also use ::: as the wiki center tag syntax",
// "Note: a conversion of :: to ::: for existing pages must be done manually" => "Note: a conversion of :: to ::: for existing pages must be done manually",
// "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
// "php.net" => "php.net",
"Date and Time Format Help" => "Hilfe zum Datums- und Zeitformat",
// "Time zone and format" => "Time zone and format",
"Sample:" => "Beispiel:",
// "Date/time selectors" => "Date/time selectors",
// "Manage customized local string translations" => "Manage customized local string translations",
// "Upload a file with translations for the selected language" => "Upload a file with translations for the selected language",
"Edit languages" => "Sprachen bearbeiten",
// "Intertiki Client" => "Intertiki Client",
// "Set up this Tiki site as the Intertiki client" => "Set up this Tiki site as the Intertiki client",
// "Client server settings" => "Client server settings",
// "Currently linked master server" => "Currently linked master server",
// "Add an available master server" => "Add an available master server",
// "The InterTiki Server fields are for defining for every master server you want to have access to from this client" => "The InterTiki Server fields are for defining for every master server you want to have access to from this client",
// "Server name" => "Server name",
// "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value" => "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value",
// "Server host" => "Server host",
// "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above" => "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above",
// "Server port" => "Server port",
// "The port number the master tiki responds to HTTP on (usually 80)" => "The port number the master tiki responds to HTTP on (usually 80)",
// "Server path" => "Server path",
// "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field" => "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field",
// "Server groups" => "Server groups",
// "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)" => "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)",
// "Available master Tiki servers" => "Available master Tiki servers",
// "Delete master server" => "Delete master server",
// "Intertiki Master Server" => "Intertiki Master Server",
// "Set up this Tiki site as the InterTiki master server" => "Set up this Tiki site as the InterTiki master server",
// "Master server settings" => "Master server settings",
// "Allowed client servers" => "Allowed client servers",
// "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)" => "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)",
// "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key" => "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key",
"IP" => "IP",
// "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1" => "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1",
// "Username of primary contact on client machine. Useful for adminstration" => "Username of primary contact on client machine. Useful for adminstration",
// "Can register" => "Can register",
// "To change the host key you need to remove and add it as a new one" => "To change the host key you need to remove and add it as a new one",
"New" => "Neu",
"Enable/disable Tiki features in " => "Tiki-Funktionen ein/ausschalten unter ",
", but configure them elsewhere" => ", konfiguriert werden sie dann an anderen Stellen.",
// "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})" => "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})",
// "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples" => "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples",
"Registration" => "Registrierung",
"Log in" => "Log In",
"Generate a passcode" => "Erzeuge ein Passwort",
"Requires PHP GD library" => "Erfordert PHP GD Bibliothek",
// "Group and tracker login settings" => "Group and tracker login settings",
"Users can select a group to join at registration:" => "Benutzer können eine Benutzergruppe bei ihrer ersten Registrierung wählen",
"By default, new users automatically join the Registered group" => "Standardmäßig werden neue Benutzer automatisch in die Gruppe \"Registered\" einsortiert",
// "Other login settings" => "Other login settings",
// "Cookie consent" => "Cookie consent",
// "Assign users to groups by matching email patterns" => "Assign users to groups by matching email patterns",
// "An email pattern must be defined in the settings for at least one group for this to produce any results" => "An email pattern must be defined in the settings for at least one group for this to produce any results",
// "Remote Tiki Autologin" => "Remote Tiki Autologin",
// "You must install PHP extension LDAP" => "You must install PHP extension LDAP",
"You must change the Authentication Method to LDAP for these changes to take effect" => "Du musst die Authentifizierung auf LDAP umstellen, damit diese Einstellungen funktionieren",
// "LDAP bind settings" => "LDAP bind settings",
// "LDAP user" => "LDAP user",
// "LDAP admin" => "LDAP admin",
"LDAP external groups" => "LDAP externe Gruppen",
// "LDAP group" => "LDAP group",
// "LDAP group member - if group membership can be found in group attributes" => "LDAP group member - if group membership can be found in group attributes",
// "LDAP user group - if group membership can be found in user attributes" => "LDAP user group - if group membership can be found in user attributes",
"PAM" => "PAM",
"You must change the Authentication Method to PAM for these changes to take effect" => "Du musst die Authentifizierung auf PAM umstellen, damit diese Einstellungen funktionieren",
"Shibboleth Authentication " => "Shibboleth Authentifizierung ",
"You must change the Authentication Method to Shibboleth for these changes to take effect" => "Du musst die Authentifizierung auf Shibboleth umstellen, damit diese Einstellungen funktionieren",
// "SAML2" => "SAML2",
// "based on Onelogin's php-saml " => "based on Onelogin's php-saml ",
// "You must change the Authentication Method to SAML for these changes to take effect" => "You must change the Authentication Method to SAML for these changes to take effect",
// "Identity provider settings" => "Identity provider settings",
// "Attribute mapping" => "Attribute mapping",
// "Group mapping" => "Group mapping",
"CAS" => "CAS",
// "CAS (central authentication service)" => "CAS (central authentication service)",
"You must change the Authentication Method to CAS for these changes to take effect" => "Du musst die Authentifizierung zu CAS ändern, damit sich diese Änderungen auswirken",
// "CAS server" => "CAS server",
"CAS Server Name" => "CAS Servername",
"CAS Server Port" => "CAS Serverport",
"CAS Server Path" => "CAS Serverpfad",
"phpBB User Database Authentication " => "phpBB Benutzer Datenbankauthentifizierung ",
"You must change the Authentication Method to phpBB for these changes to take effect" => "Du musst die Authentifizierung auf phpBB umstellen, damit diese Einstellungen funktionieren",
"You must turn Users can register off for phpBB Authentication to function properly" => "Du musst \"Benutzer können sich registrieren\" ausschalten, damit phpBB Authentifizierung funktioniert",
"MySql only (for now)" => "nur MySql (vorerst)",
// "Web server" => "Web server",
"Web Server Authentication " => "Webserver Authentifizierung ",
"You must change the Authentication Method to Web Server for these changes to take effect" => "Du musst die Authentifizierung auf Webserver umstellen, damit diese Einstellungen funktionieren",
// "Password Blacklist" => "Password Blacklist",
// "Password blacklist tools" => "Password blacklist tools",
// "Upload Word List for Processing" => "Upload Word List for Processing",
// "Words currently indexed" => "Words currently indexed",
// "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below" => "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below",
// "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file" => "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file",
// "Use 'LOAD DATA INFILE'" => "Use 'LOAD DATA INFILE'",
// "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions" => "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions",
// "Create or Replace Word Index" => "Create or Replace Word Index",
// "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first" => "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first",
// "Delete Temporary Index" => "Delete Temporary Index",
// "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete" => "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete",
// "Blacklist Currently Using" => "Blacklist Currently Using",
// "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future" => "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future",
// "Number of passwords (limit)" => "Number of passwords (limit)",
// "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396" => "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396",
// "Minimum Password Length" => "Minimum Password Length",
// "The minimum password length for your password. This will filter out any password that has an illegal length" => "The minimum password length for your password. This will filter out any password that has an illegal length",
// "Require Numbers &amp; Letters" => "Require Numbers &amp; Letters",
// "If checked, will filter out any password that does not have both upper and lower case letters" => "If checked, will filter out any password that does not have both upper and lower case letters",
// "Require Special Characters" => "Require Special Characters",
// "If checked, will filter out any passwords that do not have special characters" => "If checked, will filter out any passwords that do not have special characters",
// "Save & Set as Default" => "Save & Set as Default",
// "View Password List" => "View Password List",
// "OAuth Server Settings" => "OAuth Server Settings",
// "Main theme" => "Main theme",
"Theme Screenshot" => "Theme-Screenshot",
// "Theme Preferences" => "Theme Preferences",
// "{{\$theme|escape|ucfirst}}" => "{{\$theme|escape|ucfirst}}",
// "No theme preferences found" => "No theme preferences found",
// "General layout" => "General layout",
// "Admin pages layout" => "Admin pages layout",
// "Admin theme must be selected first" => "Admin theme must be selected first",
// "Fixed vs full width layout" => "Fixed vs full width layout",
// "Logo and Title" => "Logo and Title",
"Module zone visibility" => "Sichtbarkeit Modulzonen",
// "Site report bar" => "Site report bar",
// "Limits" => "Limits",
"UI Effects" => "UI Effekte",
"Standard UI effects" => "Standard UI Effekte",
"Tab UI effects" => "Tab UI Effekte",
"Customization" => "Anpassung",
// "Custom codes" => "Custom codes",
"Editing" => "Bearbeiten",
"View Templates" => "Vorlagen ansehen",
"Edit Templates" => "Vorlagen bearbeiten",
"Miscellaneous" => "Verschiedenes",
// "Responsive images" => "Responsive images",
// "Context menus" => "Context menus",
// "currently used in file galleries only" => "currently used in file galleries only",
"Separators" => "Trennzeichen",
// "Smarty templates (TPL files)" => "Smarty templates (TPL files)",
"Defaults" => "Standards",
"See also" => "Siehe auch",
"Search Engine Friendly URLs" => "Suchmaschinenfreundliche URLs",
// "Also" => "Also",
// "here" => "here",
// "for more information on geo tagging" => "for more information on geo tagging",
"Meta tags" => "Metatags",
// "Geo Metatags" => "Geo Metatags",
"Robots" => "Robots",
"&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site." => "\"Module\" sind die Bereiche mit Inhalten ganz oben unten, sowie in den linken und rechten Spalten der Site.",
"Admin &gt; Modules" => "Verwalten > Module",
"from the menu to create and edit modules" => "vom Menü, um Module zu erstellen oder zu bearbeiten",
"{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
"Hint" => "Hinweis",
"If you lose your login module, use tiki-login_scr.php to be able to login!" => "Wenn das Login Modul verloren geht, benutze tiki-login_scr.php, um Dich wieder anmelden zu können!",
// "Composer not found" => "Composer not found",
// "Composer could not be executed, so the automated check on the packages cannot be performed" => "Composer could not be executed, so the automated check on the packages cannot be performed",
// "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer" => "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer",
// "Result of executing the changes to the packages" => "Result of executing the changes to the packages",
// "Composer errors" => "Composer errors",
// "Composer returned some errors" => "Composer returned some errors",
// "Issues with composer environment" => "Issues with composer environment",
// "Run %0 from a shell to try to fix this, see %1 for more info" => "Run %0 from a shell to try to fix this, see %1 for more info",
// "Packages" => "Packages",
// "Packages check could not be performed at the moment due to missing" => "Packages check could not be performed at the moment due to missing",
// "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow" => "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow",
// "Installed Packages" => "Installed Packages",
// "Status of the packages registered in the composer.json file" => "Status of the packages registered in the composer.json file",
// "Version Required" => "Version Required",
// "Version Installed" => "Version Installed",
// "Installed" => "Installed",
// "Missing" => "Missing",
// "Enable extension" => "Enable extension",
// "Update extension" => "Update extension",
// "Disable extension" => "Disable extension",
// "Removal not available" => "Removal not available",
// "This package is not managed by Tiki and likely was installed manually" => "This package is not managed by Tiki and likely was installed manually",
// "One or more packages appear to be missing" => "One or more packages appear to be missing",
// "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed" => "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed",
// "Could not validate the status of one or more packages" => "Could not validate the status of one or more packages",
// "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually" => "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually",
// "Install packages from the administrator interface" => "Install packages from the administrator interface",
// "The administrator interface can be used to install the packages marked as missing in the list above" => "The administrator interface can be used to install the packages marked as missing in the list above",
// "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them" => "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them",
// "Fix Missing Packages" => "Fix Missing Packages",
// "Install packages manually" => "Install packages manually",
// "Make sure <code>composer</code> is installed" => "Make sure <code>composer</code> is installed",
// "Composer can be installed manually, in the host machine, by following the instructions from the" => "Composer can be installed manually, in the host machine, by following the instructions from the",
// "website" => "website",
// "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>" => "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>",
// "Below is an example of how to do this in a Linux-like operating system" => "Below is an example of how to do this in a Linux-like operating system",
// "Install the missing packages" => "Install the missing packages",
// "You can install the missing packages by issuing the command" => "You can install the missing packages by issuing the command",
// "Available Packages" => "Available Packages",
// "These packages have been identified as required by one or more features" => "These packages have been identified as required by one or more features",
// "Licence" => "Licence",
// "Required by" => "Required by",
// "Not Available" => "Not Available",
"Install" => "Installieren",
// "There appear to be some optional packages that can be installed" => "There appear to be some optional packages that can be installed",
// "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package" => "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package",
// "The administrator interface can be used to install the optional packages in the list above" => "The administrator interface can be used to install the optional packages in the list above",
// "Click the \"Install Package\" button, and Tiki will try to install them" => "Click the \"Install Package\" button, and Tiki will try to install them",
// "Make sure there is a <code>composer.json</code> file in the root of the website" => "Make sure there is a <code>composer.json</code> file in the root of the website",
// "If there is not already a <code>composer.json</code> file, then create one" => "If there is not already a <code>composer.json</code> file, then create one",
// "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point" => "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point",
// "Install the package" => "Install the package",
// "Packages can be installed by issuing a command" => "Packages can be installed by issuing a command",
// "for each package that is to be installed" => "for each package that is to be installed",
// "Packages Custom" => "Packages Custom",
// "There are no manual managed packages installed in the folder vendor_custom" => "There are no manual managed packages installed in the folder vendor_custom",
// "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages" => "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages",
// "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab" => "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab",
// "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>" => "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>",
// "For information only" => "For information only",
// "These packages are managed manually and displayed here for informational purposes" => "These packages are managed manually and displayed here for informational purposes",
// "Packages Bundled" => "Packages Bundled",
// "These packages are bundled with Tiki, and displayed here for informational purposes" => "These packages are bundled with Tiki, and displayed here for informational purposes",
// "Composer Packages Bundled" => "Composer Packages Bundled",
// "status of the packages registered in the vendor_bundled/composer.json file" => "status of the packages registered in the vendor_bundled/composer.json file",
// "Diagnose" => "Diagnose",
// "Diagnose Composer Installation" => "Diagnose Composer Installation",
// "Use the button below to test your composer installation" => "Use the button below to test your composer installation",
// "Diagnose Composer" => "Diagnose Composer",
// "Composer management" => "Composer management",
// "Install Composer" => "Install Composer",
// "Update Composer" => "Update Composer",
// "Remove composer.lock" => "Remove composer.lock",
// "Clean vendor folder" => "Clean vendor folder",
// "{\$diagnostic_composer_location}" => "{\$diagnostic_composer_location}",
// "Extensions Preferences" => "Extensions Preferences",
// "Activate Extension Package" => "Activate Extension Package",
// "Extension Package Groups API" => "Extension Package Groups API",
"Payments" => "Bezahlungen",
"Choose payment system" => "Wähle das Bezahlsystem",
"You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "Du kannst nur eine Bezahlmethode auswählen: PayPal, Cclite oder Tiki User Credits",
"PayPal is working at the moment. See PayPal.com" => "PayPal funktioniert derzeit. Siehe auch PayPal.com",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite:Gemeinschatfswährungbuchhaltung für lokale Austauschhandelssystem (local exchange trading systems = LETS). Siehe ",
"sourceforge.net" => "sourceforge.net",
"Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: erfordert, dass diese Funktion konfiguriert wird",
// "Israel Post payment module" => "Israel Post payment module",
"Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite ist zur Erstellung und Verwaltung alternativer oder ergänzender Handelswährungen und Gruppen",
"Work in progress since Tiki 6" => "In Arbeit seit Tiki 6",
"Advanced Shopping Cart" => "Erweiterter Warenkorb",
// "Cart settings" => "Cart settings",
// "Advanced cart tracker names setup" => "Advanced cart tracker names setup",
// "Products tracker setup" => "Products tracker setup",
"Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Abhängig davon welche Funktion Du benutzt, musst Du ggf. einige oder alle der folgenden Felder festlegen",
"Shipping" => "Transport",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Output compression is active" => "Ausgabekompression ist aktiv",
"Compression is handled by" => "Kompression durchgeführt von",
// "PHP settings" => "PHP settings",
// "Some PHP.INI settings that can increase performance" => "Some PHP.INI settings that can increase performance",
// "'realpath_cache_size setting': %0" => "'realpath_cache_size setting': %0",
"(percentage used %0 %" => "(Prozent aufgebraucht %0 %",
// "Determines the size of the realpath cache to be used by PHP" => "Determines the size of the realpath cache to be used by PHP",
// "'realpath_cache_ttl setting': %0 seconds" => "'realpath_cache_ttl setting': %0 seconds",
// "Duration of time (in seconds) for which to cache realpath information for a given file or directory" => "Duration of time (in seconds) for which to cache realpath information for a given file or directory",
"Bytecode Cache" => "Bytecode-Cache",
// "Using <strong>%0</strong>. These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>. These stats affect all PHP applications running on the server",
"Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Die Konfigurationseinstellung <em>xcache.admin.enable_auth</em> verhindert den Zugriff auf die Statistiken. Dies verhindert auch das Löschen des Cache, wenn der Vorlagencache gelöscht wird",
// "Memory Used" => "Memory Used",
"Cache Hits" => "Cache-Treffer",
// "Misses" => "Misses",
"Few hits recorded. Statistics may not be representative." => "Nur wenige Treffer aufgezeichnet. Die Statistiken können nicht repräsentativ sein.",
"Low hit ratio. %0 may be misconfigured and not used." => "Geringe Trefferrate. %0 könnte falsch konfiguriert und nicht benutzt sein.",
"Little memory available. Thrashing likely to occur" => "Wenig Speicher verfügbar. Seitenflattern (thrashing) wird wahrscheinlich auftreten",
// "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)" => "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)",
"Small amount of memory allocated to %0. Verify the configuration." => "%0 wurde nur eine geringe Menge Speicher zugeteilt. Überprüfe die Konfiguration.",
"Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates." => "Konfiguration <em>%0</em> ist aktiviert. Die Performance kann durch Deaktivieren von Veränderungsüberprüfungen verbessert werden. Dies erfordert aber ein manuelles Löschen nach Dateiupdates.",
"<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> sollte nicht deaktiviert sein aufgrund der Authentifizierung bei XCache",
// "Clear all APC caches" => "Clear all APC caches",
// "Clear APC caches" => "Clear APC caches",
// "Clear Caches" => "Clear Caches",
// "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments",
// "Major Slowdown" => "Major Slowdown",
"Major slowdown" => "Besondere Verlangsamer",
"These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "Von diesen Funktionen wird berichtet, dass sie Tiki verlangsamen können. Wenn Du eine Site mit hohem Datenvolumen hast, solltest Du diese Funktionen ggf. deaktivieren",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>",
// "Time and Memory Limits" => "Time and Memory Limits",
// "PDF settings" => "PDF settings",
// "Wiki print version" => "Wiki print version",
// "Other features" => "Other features",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Einige Deiner Profile-Repositories können nicht verbunden werden. Dies kann Dich daran hindern gewisse Profile anzuwenden",
// "Find profiles" => "Find profiles",
// "Search by name, types and repository" => "Search by name, types and repository",
// "Profile types" => "Profile types",
"Profile repository" => "Profil-Respository",
// "Suggested Profiles" => "Suggested Profiles",
// "Featured Site Profiles" => "Featured Site Profiles",
// "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
"Full Profiles" => "Volle Profile",
"Full Profiles are full featured out of the box solutions." => "Volle Profile sind vollständig ausgestalte, sofort einsetzbare Lösungen.",
"Mini Profiles" => "Mini Profile",
"Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration." => "Mini Profile konfigurieren spezifische Funktionen und sind gut geeignet, um mehr Funktionalität zu einer existieren Konfiguration hinzuzufügen.",
"Learning Profiles" => "Lernprofile",
"Learning Profiles will allow you to quickly evaluate specific features in Tiki." => "Lernprofile erlauben es schnell bestimmte Funktionen zu beurteilen",
// "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>" => "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>",
"Repository" => "Repository",
// "Profile type" => "Profile type",
// "See profile info below (may take a few seconds to load)" => "See profile info below (may take a few seconds to load)",
"applied" => "angewendet",
"JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript muss <b>aktiviert</b> sein, damit Profile angewendet werden können. Bitte aktiviere JavaScript und versuche es erneut",
"Export YAML" => "YAML exportieren",
"Export modified preferences as YAML" => "Exportiere veränderte Einstellungen als YAML",
"Toggle Visible" => "Sichtbarkeit umschalten",
"Show added preferences" => "Zeige hinzugefügte Einstellungen",
"no default" => "kein Standard",
// "Repository status" => "Repository status",
// "status of the registered profile repositories" => "status of the registered profile repositories",
"Refresh" => "Aktualisieren",
"Profile tester" => "Profiltester",
"Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Wiki Markup und YAML in das Testeingabefeld, unten, einfügen oder hineintippen (mit oder ohne {literal}{CODE}{/literal} Tags)",
"This will run the profile and make potentially unrecoverable changes in your database" => "Hierdurch wird ein Profile gestartet und es werden möglicherweise nicht mehr rückgängig machbare Änderungen an der Datenbank vorgenommen",
// "Test profile name" => "Test profile name",
// "Permission added" => "Permission added",
// "User added" => "User added",
// "User modified" => "User modified",
// "Group added" => "Group added",
// "old value" => "old value",
// "Installer added" => "Installer added",
// "Profile without changes" => "Profile without changes",
"Global configuration" => "Globale Einstellungen",
// "This preference needs to be disabled" => "This preference needs to be disabled",
// "Enabling ratings for forums" => "Enabling ratings for forums",
// "You need to" => "You need to",
// "Create or edit a forum and enable" => "Create or edit a forum and enable",
"Posts can be rated" => "Einträge dürfen bewertet werden",
// "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user" => "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Set the rating options at" => "Set the rating options at",
"Ratings" => "Bewertungen",
// "see above" => "see above",
// "Permissions involved" => "Permissions involved",
// "tiki" => "tiki",
// "Default Options" => "Default Options",
"Cache duration" => "Cachedauer",
"Create new" => "Erstelle neu",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds",
"Feeds" => "Feeds",
"Feed for articles" => "Feed für Artikel",
"Feed for blogs" => "Feed für Blogs",
"Feed for individual blogs" => "Feed für individuelle Blogs",
"Feed for image galleries" => "Feed für Bildergalerien",
"Feed for individual image galleries" => "Feed für individuelle Bildergalerien",
"Feed for file galleries" => "Feed für Dateiarchive",
"Feed for individual file galleries" => "Feed für individuelle Dateiarchive",
"Feed for wiki pages (with diff)" => "Feed für Wiki Seiten (mit Diff)",
// "with diff" => "with diff",
"Feed for wiki pages (no diff)" => "Feed für Wiki Seiten (ohne diff)",
// "no diff" => "no diff",
"Feed for forums" => "Feed für Foren",
"Feed for individual forums" => "Feed für individuelle Foren",
"Feed for trackers" => "Feed für Tracker",
"Feed for calendars" => "Feed für Kalender",
"Feed for directories" => "Feed für Verzeichnisse",
"Feed for shoutbox" => "Feed für Shoutbox",
// "Incoming Feeds" => "Incoming Feeds",
"You can see users rank by score in the module users_rank, for that go to" => "Den Benutzerrang nach Bewertung kann man dem Modul user_rank entnehmen, einschaltbar unter",
"Admin modules" => "Module verwalten",
// "Cause scores older than a certain number of days to expire" => "Cause scores older than a certain number of days to expire",
// "Scoring rules" => "Scoring rules",
// "Unique rule ID" => "Unique rule ID",
// "Rule" => "Rule",
// "A label or ID to help identify which event was triggered to get points" => "A label or ID to help identify which event was triggered to get points",
// "Pts recipient type" => "Pts recipient type",
// "Recipient Type" => "Recipient Type",
// "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event" => "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event",
// "Pts recipient" => "Pts recipient",
// "The ID of the points recipient" => "The ID of the points recipient",
// "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered" => "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered",
// "Points Given" => "Points Given",
// "This is the numerical value of the points being given" => "This is the numerical value of the points being given",
// "Triggering event" => "Triggering event",
// "Reversal event" => "Reversal event",
// "Valid Triggering Object IDs" => "Valid Triggering Object IDs",
// "Valid Object Ids" => "Valid Object Ids",
// "This is a comma-separated list of object ids for which the event is valid" => "This is a comma-separated list of object ids for which the event is valid",
// "Min. Time Between Scoring" => "Min. Time Between Scoring",
// "Time between scoring" => "Time between scoring",
// "This is the amount of time in seconds that a user must wait before again being able to get points for this event" => "This is the amount of time in seconds that a user must wait before again being able to get points for this event",
"can be seen on page" => "kann eingesehen werden unter",
"in Admin menu" => "im Menü Verwaltung",
// "Also see the Search Indexing tab" => "Also see the Search Indexing tab",
"File Gallery admin panel" => "Dateiarchiv-Verwaltung",
// "About the Unified Index" => "About the Unified Index",
// "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things" => "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things",
// "Disabling this will cause some parts of Tiki to be unavailable" => "Disabling this will cause some parts of Tiki to be unavailable",
// "Find out more about it here" => "Find out more about it here",
// "Search engine settings" => "Search engine settings",
// "About Unified search engines" => "About Unified search engines",
// "Advantages" => "Advantages",
// "Fast performance. Works out of the box with Tiki and even on most basic server setups" => "Fast performance. Works out of the box with Tiki and even on most basic server setups",
// "Disadvantages" => "Disadvantages",
// "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable" => "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable",
// "link" => "link",
// " for full list) " => " for full list) ",
"Lucene (PHP implementation)" => "Lucene (PHP Implementierung)",
// "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki" => "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki",
// "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues" => "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues",
// "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki" => "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki",
// "Needs to be separately installed from Tiki and requires more configuration" => "Needs to be separately installed from Tiki and requires more configuration",
// "for more information) " => "for more information) ",
// "About Use MySQL Full-Text Search as fallback" => "About Use MySQL Full-Text Search as fallback",
// "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability" => "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability",
// "Elastic search only" => "Elastic search only",
// "Experiment with LIST plugin syntax" => "Experiment with LIST plugin syntax",
// "After you have found the correct contents, you may copy-paste them in a LIST plugin" => "After you have found the correct contents, you may copy-paste them in a LIST plugin",
// "Legacy search" => "Legacy search",
"Forum searches" => "Forumsuchen",
"Search Results" => "Suchergebnisse",
// "Items to display in search results" => "Items to display in search results",
// "Information to display for each result" => "Information to display for each result",
// "Stored Search" => "Stored Search",
"Configuration" => "Konfiguration",
// "ManifoldCF Configuration Checker" => "ManifoldCF Configuration Checker",
// "Occurrences of string in database" => "Occurrences of string in database",
// "Set default table" => "Set default table",
// "Text to search" => "Text to search",
// "Results for " => "Results for ",
// "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}" => "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}",
// "Occurrences" => "Occurrences",
// "View occurrences" => "View occurrences",
// "in table " => "in table ",
// "column" => "column",
// "Page preview" => "Page preview",
"View page" => "Seite anzeigen",
// "View blog post" => "View blog post",
// "View file" => "View file",
// "View gallery" => "View gallery",
// "View category" => "View category",
// "View article" => "View article",
// "View forum" => "View forum",
// "View calendar" => "View calendar",
// "View calendar item" => "View calendar item",
// "View tracker" => "View tracker",
// "View tracker item" => "View tracker item",
// "View forum comment" => "View forum comment",
// "Back to first level results" => "Back to first level results",
"Admin groups" => "Gruppen verwalten",
"Admin Groups" => "Gruppen verwalten",
"Admin users" => "Benutzer verwalten",
"Admin Users" => "Benutzer verwalten",
"Manage permissions" => "Rechte verwalten",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings" => "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings",
"General Security" => "Generelle Sicherheit",
// "MySQL SSL connection" => "MySQL SSL connection",
// "MySQL SSL connection is active" => "MySQL SSL connection is active",
// "MySQL connection is not encrypted" => "MySQL connection is not encrypted",
// "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"" => "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"",
// "MySQL Server does not have SSL activated" => "MySQL Server does not have SSL activated",
// "Smarty and Features Security" => "Smarty and Features Security",
"Please also see:" => "Bitte siehe auch:",
"HTTPS (SSL) and other login preferences" => "HTTPS (SSL) und andere Logineinstellungen",
// "User Encryption" => "User Encryption",
// "Requires the OpenSSL PHP extension for encryption" => "Requires the OpenSSL PHP extension for encryption",
// "You have OpenSSL installed" => "You have OpenSSL installed",
// "OpenSSL is not loaded" => "OpenSSL is not loaded",
// "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption" => "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption",
// "You may also want to add the Domain Password module somewhere" => "You may also want to add the Domain Password module somewhere",
// "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ" => "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ",
// "The user can add passwords for a registered password domain" => "The user can add passwords for a registered password domain",
// "Statistics for existing data" => "Statistics for existing data",
// "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension" => "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension",
// "CSRF security" => "CSRF security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "HTTP Headers" => "HTTP Headers",
// "Use these options to add options related with security to the HTTP Headers" => "Use these options to add options related with security to the HTTP Headers",
// "Spam Protection" => "Spam Protection",
// "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself" => "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself",
"Search results" => "Suchergebnisse",
"Site Access" => "Zugriff auf die Site",
// "Admin IDS custom rules" => "Admin IDS custom rules",
"Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)",
// "OpenPGP" => "OpenPGP",
// "OpenPGP functionality for PGP/MIME encrypted email messaging" => "OpenPGP functionality for PGP/MIME encrypted email messaging",
// "Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging" => "Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging",
// "All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses" => "All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses",
// "If you use preferences option for the signer passphrase, clear the file option just for security" => "If you use preferences option for the signer passphrase, clear the file option just for security",
// "If you use file for the signer passphrase, clear the preferences option just for security" => "If you use file for the signer passphrase, clear the preferences option just for security",
// "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring" => "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring",
"SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL (suchmaschinenfreundliche URL) erfordert, dass das <strong>URL Rewrite module</strong> für IIS. Es erscheint, als wäre dieses Modul bei Dir nicht installiert",
// "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
"SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL wird nicht funktionieren, solange nicht Tiki-spezifische Anweisungen auf die %0-Datei angewandt wurden",
"To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "Um diese Datei zu aktivieren, kopiere die %0-Datei (befindet sich im Hauptverzeichnis Deiner Tiki Installation) nach %1",
"If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "Wenn Du eine (nicht-Tiki) %0-Datei aufbewahren willst, füge ihr einfach Tiki-Anweisungen hinzu",
"When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "Wenn Du Tiki aktualisierst (z.B. von Version 7 auf Version 8), stelle sicher, dass Du die neue URL-Rewriting-Konfigurationsdatei benutzt",
"%0 file is missing" => "%0-Datei fehl",
"Unable to verify that your URL rewriting configuration is up to date" => "Es kann nicht überprüft werden, ob Deine URL-Rewriting-Konfigurationsdatei aktuell ist",
"SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL kann möglicherweise nicht vollständig oder richtig funktionieren, wenn die Tiki-URL-rewriting-Konfiguration nicht aktuell ist",
"%0 is not in the expected format" => "%0 ist nicht im erwarteten Format",
"%0 may simply be outdated" => "%0 ist möglicherweise nicht mehr aktuell",
"To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "Um diese Datei zu aktualisieren (wenn sie nicht modifiziert wurde), musst Du nur die %0-Datei (befindet sich im Hauptverzeichnis Deiner Tiki Installation) nach %1 kopieren und die dort befindliche überschreiben",
"%0 file is out of date" => "%0-Datei ist nicht aktuell",
"The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "Die RewriteBase Direktive scheint nicht richtig konfiguriert zu sein. Dies ist für die richtige Funktion von sefurl (suchmaschinenfreundliche URLs) erforderlich",
"The current value in %0 is %1 but the base url for this site is %2" => "Der gegenwärtige Wert in %0 ist %1, aber die Base-URL für diese Site lautet %2",
// "For example, if the field is left blank, the canonical URL domain is" => "For example, if the field is left blank, the canonical URL domain is",
// "URL parameters" => "URL parameters",
"List of Url Parameters that should go in the path" => "Liste der URL Parameter, die in den Pfad aufgenommen werden",
// "Known types" => "Known types",
"Invert" => "invertieren",
"Show Usage" => "Zeige Benutzung",
"Delete &amp; Unreference" => "Löschen & Verweis aufheben",
"Invert Relation" => "Beziehung invertieren",
// "New types" => "New types",
"Fix" => "Fix",
"No occurences found." => "Keine Vorkommen gefunden.",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Social network integration" => "Social network integration",
"To use Twitter integration, you must register this site as an application at" => "Um die Twitterintegration zu nutzen, muss der Siteadministrator diese Site bei Twitter als eine Anwendung registrieren und zwar unter",
"and allow write access for the application" => "und der Anwendung Schreibrechte einräumen",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Trage &lt;Deine Site URL&gt;tiki-socialnetworks.php als Rückmeldungs-URL ein",
"To use Facebook integration, you must register this site as an application at" => "Um die Integration von Facebook nutzen zu können, musst Du diese Site als Anwendung einrichten unter",
"and allow extended access for the application" => "und der Anwendung Schreibrechte einräumen",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Trage &lt;Deine Site-URL&gt;tiki-socialnetworks.php?request_facebook als Site-URL und &lt;Deine Site&gt; als Site-Domain ein",
"The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it." => "Die folgenden Einstellungen legen fest, was Tiki über Facebook veranlassen kann.",
// "bit.ly" => "bit.ly",
"There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "Es ist nicht notwendig, ein bit.ly-Konto für die gesamte Site zu erstellen; jeder Benutzer kann sein eigenes Konto haben. Ein Gesamtkonto ermöglicht aber Statistiken für die gesamte Site",
"Go to" => "Gehe zu",
"to sign up for an account" => "um Dich für ein Konto anzumelden",
"to retrieve the API key" => "um den API Schlüssel zu erhalten",
// "To use LinkedIn integration, you must register this site as an application at" => "To use LinkedIn integration, you must register this site as an application at",
// "and allow necessary permissions for the application" => "and allow necessary permissions for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs" => "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs",
// "Share This" => "Share This",
// "This is a new control panel on Tiki and work is still in progress" => "This is a new control panel on Tiki and work is still in progress",
// "Tiki Statistics" => "Tiki Statistics",
// "Piwik Analytics" => "Piwik Analytics",
"Text area (that apply throughout many features)" => "Textbereiche (hat Auswirkungen auf viele Funktionen)",
"Wiki syntax" => "Wikisyntax",
// "Typography" => "Typography",
"Default size" => "Standardgröße",
"External links and images" => "Externe Links und Bilder",
"External links will be identified with" => "Externe Links werden identifiziert durch",
"About plugins" => "Über Plugins",
"Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below." => "Durch Tiki-Plugins werden zusätzliche Funktionen zu Wikiseiten, Artikeln, Blogs, etc. hinzugefügt. Du kannst unten Plugins an- und abschalten.",
// "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>",
"The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below." => "Durch das \"Bearbeite Plugin-Symbol\" kann man auf Wikiseiten einfach die Parameter eines Plugins ändern. Diese Funktion kann für jedes Plugin einzeln deaktiviert werden",
"Check disabled plugins used in wiki pages" => "Prüfe auf deaktivierte Plugins in den Wikiseiten",
"Disabled used plugins" => "Deaktivierte genutzte Plugins",
"Plugin preferences" => "Plugin-Einstellungen",
"Edit plugin icons" => "Symbol zur Pluginbearbeitung",
// "Plugin List" => "Plugin List",
// "Use the filter input above to find plugins, or enter return to see the whole list" => "Use the filter input above to find plugins, or enter return to see the whole list",
"Search Help" => "Suchhilfe",
"Disable edit plugin icon (make plugin inline)" => "Deaktiviere das Symbol zum Bearbeiten des Plugins (make plugin inline)",
"Plugin Aliases" => "Pluginalias",
"About plugin aliases" => "Über Plugin-Alias",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins",
// "Find out more here" => "Find out more here",
// "This page is designed to work with JavaScript" => "This page is designed to work with JavaScript",
// "Available alias" => "Available alias",
// "Plugin Alias" => "Plugin Alias",
// "Enable Checked Plugins" => "Enable Checked Plugins",
// "General information" => "General information",
"Plugin name" => "Pluginname",
// "Base plugin" => "Base plugin",
// "Body label" => "Body label",
"Dependencies" => "Abhängigkeiten",
// "Inline (no plugin edit UI)" => "Inline (no plugin edit UI)",
// "Simple plugin arguments" => "Simple plugin arguments",
// "Add parameter" => "Add parameter",
"Argument" => "Argument",
// "Delete this parameter" => "Delete this parameter",
// "Default Value" => "Default Value",
// "Plugin parameter documentation" => "Plugin parameter documentation",
// "Add parameter documentation" => "Add parameter documentation",
// "Delete this parameter's documentation" => "Delete this parameter's documentation",
"Safe" => "Sicher",
"Plugin body" => "Plugin Hauptteil",
// "Ignore user input" => "Ignore user input",
// "Default content" => "Default content",
// "Body Parameters" => "Body Parameters",
// "Add body parameter" => "Add body parameter",
// "Delete this body parameter" => "Delete this body parameter",
"Encoding" => "Formatierung",
// "Argument source (if different)" => "Argument source (if different)",
// "Composed plugin arguments" => "Composed plugin arguments",
// "Add composed parameter" => "Add composed parameter",
// "Delete this composed argument" => "Delete this composed argument",
"Pattern" => "Muster",
// "Composed parameters" => "Composed parameters",
// "Delete this composed parameter" => "Delete this composed parameter",
"Tracker settings" => "Tracker Einstellungen",
// "Field settings" => "Field settings",
// "Linked wiki pages" => "Linked wiki pages",
// "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features" => "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features",
"Tracker attachment preferences" => "Einstellungen Trackeranhänge",
// "Tracker force-fill feature" => "Tracker force-fill feature",
"Field Types" => "Feldtypen",
// "Field types" => "Field types",
"Tracker attachments" => "Trackeranhänge",
"dls" => "DLs",
"Switch storage" => "Speicherort wechseln",
"Change all to db" => "Alle auf Datenbank umstellen",
"Change all to file" => "Alle auf Datei umstellen",
// "User Settings" => "User Settings",
"Default user preferences" => "Standardbenutzereinstellungen",
"Users Default Preferences" => "Benutzer-Standardeinstellungen",
// "My Account Items" => "My Account Items",
// "User Features" => "User Features",
// "User Account Features" => "User Account Features",
// "User Info and Picture" => "User Info and Picture",
"User information display" => "Benutzer-Informationen anzeigen",
// "Messaging and Notifications" => "Messaging and Notifications",
// "User notifications" => "User notifications",
// "For the digest emails to be sent out, you will need to set-up a cron job" => "For the digest emails to be sent out, you will need to set-up a cron job",
// "Adjust the command parameters for your digest frequency. Default frequency is 7 days" => "Adjust the command parameters for your digest frequency. Default frequency is 7 days",
// "Sample command" => "Sample command",
"User Files" => "Benutzerdateien",
"Kaltura" => "Kaltura",
"Kaltura Registration" => "Kaltura Registrierung",
"To get a Kaltura Partner ID:" => "Um eine Kaltura Partner ID zu bekommen:",
"Setup your own instance of Kaltura Community Edition (CE)" => "Richte Deine eigene Instanz der Kaltura Community Edition (CE) ein",
"get an account via Kaltura.com" => "registriere Dich auf Kaltura.com",
// "List Media" => "List Media",
"List Remix Entries" => "Liste der Remixeinträge",
"Add New Media" => "Füge neue Medien hinzu",
// "Plugin to embed in pages" => "Plugin to embed in pages",
// "Enable related tracker field types" => "Enable related tracker field types",
"Kaltura / Tiki config" => "Kaltura / Tiki konfigurieren",
// "Kaltura partner settings" => "Kaltura partner settings",
// "Kaltura dynamic player" => "Kaltura dynamic player",
// "Kaltura contribution wizard" => "Kaltura contribution wizard",
"You can manually edit these values in lib/videogals/standardTikiKcw.xml" => "Du kannst diese Werte in lib/videogals/standardTikiKcw.xml bearbeiten",
// "Recreate KCW \"uiConf\"" => "Recreate KCW \"uiConf\"",
// "Legacy support" => "Legacy support",
"Webservices" => "Webdienste",
"Use the 'Quick Edit' module to easily create or edit wiki pages." => "Benutze das 'Schnell-Erstellen' Modul, um Wikiseiten vereinfacht zu erstellen",
// "List wiki pages" => "List wiki pages",
// "List structures" => "List structures",
"Page display" => "Seitenanzeige",
// "Automatic table of contents" => "Automatic table of contents",
// "General features" => "General features",
"Export Wiki Pages" => "Exportiere Wiki-Seiten",
// "Redirect and Similar" => "Redirect and Similar",
// "Wikiwords Features" => "Wikiwords Features",
"If you change storage, it is better to move all the files for easy backup.." => "Wenn Du den Speicherort ändern kannst, ist es besser, alle Dateien zu verschieben, für eine einfache Datensicherung..",
// "Move all attachments to database" => "Move all attachments to database",
// "Move all attachments to file system" => "Move all attachments to file system",
"Remove unused pictures" => "Entferne unbenutzte Bilder",
"Move images from wiki_up to the home file gallery" => "Verschiebe Bilder von wiki_up in das Haupt-Dateiarchiv",
// "Move images to home gallery" => "Move images to home gallery",
"If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "Wenn Du diese Schaltflächen benutzt, solltest Du sicher stellen, dass Du eine Sicherheitskopie Deiner Datenbank und des Verzeichnisses wiki_up hast",
"Wiki watch" => "Wiki Beobachtung",
// "Namespaces" => "Namespaces",
// "Settings that may be affected by the namespace separator" => "Settings that may be affected by the namespace separator",
"Flagged Revision" => "Gekennzeichnete Revision",
"Page Listings" => "Seiten auflisten",
"Select which items to display when listing pages" => "Wähle anzuzeigende Punkte aus, die in Auflistungen erscheinen sollen",
// "Database dumps and restores" => "Database dumps and restores",
// "Name for dump" => "Name for dump",
// "Create Database Dump" => "Create Database Dump",
// "Wiki database" => "Wiki database",
"Restore" => "Wiederherstellen",
// "Dump files" => "Dump files",
// "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks" => "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks",
// "The HTML files generated may refer to files not included in the dump" => "The HTML files generated may refer to files not included in the dump",
// "Dumps do not include files attached to wiki pages" => "Dumps do not include files attached to wiki pages",
// "Dumping will overwrite the preexisting dump" => "Dumping will overwrite the preexisting dump",
// "Create Dump File" => "Create Dump File",
// "Download Dump File" => "Download Dump File",
// "Remove Dump File" => "Remove Dump File",
// "Mass replace and page permissions report" => "Mass replace and page permissions report",
"Mass search and replace" => "Massensuchen und Ersetzen",
// "Report wiki pages with direct object permissions" => "Report wiki pages with direct object permissions",
"Wiki attachments" => "Wiki-Anhänge",
// "Move attachment to database" => "Move attachment to database",
// "Move to database" => "Move to database",
// "Move attachment to file system" => "Move attachment to file system",
// "Move to file system" => "Move to file system",
// "Exclusive" => "Exclusive",
// "Share Common" => "Share Common",
"Edit perspective" => "Bearbeite Perspektive",
// "No areas found. Click \"Update Areas\" to populate this list" => "No areas found. Click \"Update Areas\" to populate this list",
// "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> " => "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> ",
"Update areas" => "Bereiche aktualisieren",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>",
"Page links" => "Seitenlinks",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature",
// "WYSIWYG editor features" => "WYSIWYG editor features",
"Related features" => "Verknüpfte Funktionen",
"{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Position",
"Cache Time" => "Cache-Zeit",
"secs" => "Sekunden",
"Use Ctrl+Click to select multiple options" => "Benutze Strg+Klick, um mehrere Optionen auszuwählen",
"The" => "Das",
"Display Modules to All Groups" => "Zeige Module allen Gruppen",
"setting will override your selection of specific groups" => "Einstellung überschreibt Deine Auswahl spezifischer Gruppen",
"Displayed now for all eligible users even with personal assigned modules" => "Sichtbar für alle Benutzer, auch die mit persönlicher Modul-Konfiguration",
"Displayed for the eligible users with no personal assigned modules" => "Sichtbar für Benutzer ohne persönliche Modul-Konfiguration",
"Displayed now, can't be unassigned" => "Immer anzeigen, kann nicht wegkonfiguriert werden",
"Not displayed until a user chooses it" => "Nicht anzeigen bis der Benutzer es konfiguriert",
"Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Weil <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Benutzer Module konfigurieren können</a>, wähle entweder",
"to make sure users will notice any newly assigned modules." => "um sicherzustellen, dass die Benutzer neu hinzugefügte Module bemerken.",
"required" => "erforderlich",
"Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Parameter: bestimmte Modul- oder generelle Parameter ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Trennzeichen zwischen Parametern:'&amp;'. z.B. maxlen=15&amp;nonums=y",
"Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Trage die Parameter im URL-Format ein, z.B. 'nobox=y&class=rbox-data'",
"Edit custom module" => "Benutzerdefiniertes Modul bearbeiten",
// "Enter the code below" => "Enter the code below",
"Anti-Bot verification code image" => "Anti-Bot Überprüfungsbild",
"Try another code" => "Versuche einen anderen Code",
// "Your article has been added" => "Your article has been added",
// "Create Article" => "Create Article",
// "Expires" => "Expires",
// "Users rating: " => "Users rating: ",
"{\$topicName}" => "{\$topicName}",
// "List all articles of the same topic" => "List all articles of the same topic",
"{\$topicName|escape}" => "{\$topicName|escape}",
"{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
"You do not have permission to read complete articles" => "Du hast keine Berechtigung den kompletten Artikel zu lesen",
"First page" => "Erste Seite",
"Previous page" => "Vorherige Seite",
"Next page" => "Nächste Seite",
"Last page" => "Letzte Seite",
"Related content" => "Verbundener Inhalt",
"bytes" => "Bytes",
// "Article actions" => "Article actions",
"Send a link" => "Sende einen Link",
// "Get a short URL" => "Get a short URL",
"Attached files" => "Angehängte Dateien",
"Upload file" => "Datei hochladen",
// "File upload comment" => "File upload comment",
"Attach" => "Anhängen",
"Attach a file to this item" => "Datei an diesen Eintrag anhängen",
"{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "mehr Infos",
"No attachments for this item" => "Keine Anhänge für diesen Eintrag",
// "Blog actions" => "Blog actions",
// "Blog Actions" => "Blog Actions",
"Monitor" => "Überwachen",
// "Stop monitoring" => "Stop monitoring",
"Group Monitor" => "Mit Gruppe beobachten",
"RSS" => "RSS",
"Watched by categories" => "Beobachtet durch die Kategorien",
// "Blog post actions" => "Blog post actions",
"Save to notepad" => "Im Notizblock speichern",
// "Published By" => "Published By",
"Publish Date" => "Veröffentlichungsdatum",
"Previous post" => "Vorheriger Beitrag",
"Next post" => "nächster Beitrag",
"More..." => "Mehr...",
"pages" => "Seiten",
"Last" => "letzte",
"private" => "privat",
"permanent link" => "permanent link",
"Leave a comment" => "Hinterlasse einen Kommentar",
"%0 comment" => "%0 Kommentar",
"%0 comments" => "%0 Kommentare",
// "{\$item.name}" => "{\$item.name}",
// "{\$sub.name}" => "{\$sub.name}",
"Parent Gallery" => "Übergeordnete Galerie",
"No records found" => "Keine Datensätze gefunden",
"Category:" => "Kategorie",
"Select Categories" => "Kategorien auswählen",
"Admin Categories" => "Kategorien verwalten",
"Select/deselect all categories" => "Auswahl/Abwahl aller Kategorien",
"No categories defined" => "Keine Kategorien definiert",
"Browse Category" => "Kategorien durchstöbern",
"Are you sure you want to archive this comment" => "Bist Du sicher, dass Du diesen Kommentar archivieren willst",
"Are you sure you want to unarchive this comment" => "Bist Du sicher, dass Du diesen Kommentar entarchivieren willst",
// "Edit Comment" => "Edit Comment",
// "Comments unlocked" => "Comments unlocked",
"Post new comment" => "Neuen Kommentar posten",
"There are no comments at this time" => "Derzeit gibt es keine Kommentare",
"Add Comment" => "Kommentieren",
"Reply" => "Antwort",
"Archived" => "Archiviert",
"Unarchive" => "Entarchivieren",
"Archive" => "Archivieren",
"Rejected" => "abgelehnt",
"Approve" => "Freigeben",
"Reject" => "Ablehnen",
"Are you sure you want to lock comments on this object" => "Bist Du sicher, dass Du Kommentare zu diesem Objekt sperren willst",
"Are you sure you want to approve this comment" => "Bist Du sicher, dass Du diesen Kommentar bestätigen willst",
"Are you sure you want to reject this comment" => "Bist Du sicher, dass Du diesen Kommentar ablehnen willst",
// "Go back to" => "Go back to",
// "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity",
"Website" => "Website",
"Send me an email when someone replies" => "Sende mir eine E-Mail, wenn jemand antwortet",
// "Are you sure you want to delete this comment" => "Are you sure you want to delete this comment",
"Are you sure you want to unlock comments on this object" => "Bist Du sicher, dass Du Kommentare zu diesem Objekt entsperren willst",
"Posted by" => "Veröffentlicht von",
// "Private message" => "Private message",
"private message" => "private Nachricht",
// "Send eMail to user" => "Send eMail to user",
// "User online" => "User online",
// "User offline" => "User offline",
// "Download attachment" => "Download attachment",
// "Remove attachment" => "Remove attachment",
// "Deliberation Items" => "Deliberation Items",
"top of page" => "Anfang der Seite",
"Notification" => "Benachrichtigung",
// "Delete post" => "Delete post",
"Report this post" => "Diesen Beitrag melden",
// "Group monitor" => "Group monitor",
// "Moderator actions for selected topics" => "Moderator actions for selected topics",
// "Reported messages" => "Reported messages",
"Reported" => "Berichtet",
// "Queued messages" => "Queued messages",
"Queued" => "anstehend",
"Threshold" => "Schwellenwert",
"Replies" => "Antworten",
"below your current threshold" => "unterhalb Deines aktuellen Schwellenwerts",
"New Reply" => "Neue Antwort",
"Editing reply" => "Antwort bearbeiten",
"Reply to the selected post" => "Auf den ausgewählten Beitrag antworten",
"Post new message" => "Neuen Beitrag erstellen",
// "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address",
"Maximum size" => "Maximale Größe",
"Reply to parent post" => "Auf Vaterpost antworten",
"Post new reply" => "Neue Antwort schreiben",
"Post as Anonymous" => "Anonym posten",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Bitte beachte, dass die Vorschau die angehängte Datei nicht behält. Sie muss neu gewählt werden",
"Posting replies" => "Post-Antworten",
"Please enter a title" => "Bitte trage einen Titel ein",
"1 comment" => "1 Kommentar",
"Go back" => "Zurück",
"Return to home page" => "Zur Home-Seite zurückkehren",
"Type of contribution:" => "Art der Beteiligung:",
// "No contribution records found" => "No contribution records found",
// "{\$prefs.cookie_consent_description}" => "{\$prefs.cookie_consent_description}",
// "{\$prefs.cookie_consent_question}" => "{\$prefs.cookie_consent_question}",
// "{\$prefs.cookie_consent_button}" => "{\$prefs.cookie_consent_button}",
"Copyrights" => "Copyrights",
// "Authors" => "Authors",
"Copyright Holder" => "Urheberrechtshalter",
// "Do you really want to remove the %0 route" => "Do you really want to remove the %0 route",
"Back to tracker list" => "Zurück zur Tracker-Liste",
"System error" => "Systemfehler",
"The following error message was returned" => "Die folgende Fehlermeldung wurde zurückgegeben",
"Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Datenbank ist gegenwärtig nicht aktuell! Besuche <a href=\"tiki-install.php\">Tiki Installer</a>, um dieses Problem zu beheben",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation:" => "Wenn Du Shell (SSH) Zugang hast, kannst Du auch folgendes aus dem Rootverzeichnis deiner Tikiinstallation in der Kommandozeile nutzen:",
"The query was" => "Die Abfrage war",
"The built query was likely" => "Die Abfrage lautete wahrscheinlich",
"Stacktrace" => "Stacktrace",
"Tiki is unable to connect to the database" => "Tiki kann sich nicht mit der Datenbank verbinden",
"An error occurred while performing the request" => "Ein Fehler ist aufgetreten, als die Anfrage bearbeitet wurde",
"Current URL" => "Aktuelle URL",
"Command" => "Befehle",
"exec" => "Ausführen",
"Type <code>help</code> to get list of available commands" => "<code>help</code> für eine Befehlsübersicht eingeben",
"Page generation debugging log" => "Debug-Log der Seitengenerierung",
"Features state" => "Status der Funktion",
"features matched" => "Features gefunden",
"Watchlist" => "Beobachtungsliste",
// "Page discussion" => "Page discussion",
// "This page has been discussed once" => "This page has been discussed once",
// "Access discussion" => "Access discussion",
// "This page has been discussed %0 times" => "This page has been discussed %0 times",
// "Access discussion (%0 replies)" => "Access discussion (%0 replies)",
// "There are no discussions currently on this page" => "There are no discussions currently on this page",
// "Start discussion" => "Start discussion",
"Duplicate File Gallery" => "Dateiarchiv duplizieren",
"Duplicate categories" => "Kategorien duplizieren",
"Duplicate permissions" => "Berechtigungen duplizieren",
"Duplicate" => "Kopiere",
"There are individual permissions set for this file gallery" => "Für dieses Dateiarchiv sind individuelle Berechtigungen gesetzt",
// "Manage Permissions" => "Manage Permissions",
"Properties" => "Eigenschaften",
"{\$gal_info.name}" => "{\$gal_info.name}",
"Required for podcasts" => "Erforderlich für Podcasts",
// "Other (%0)" => "Other (%0)",
"Any file" => "Jede Datei",
"Podcast (audio)" => "Podcast (Audio)",
"Podcast (video)" => "Podcast (Video)",
"Gallery is visible to non-admin users" => "Dateiarchiv kann von Nicht-Admins angesehen werden",
// "Gallery is unlocked" => "Gallery is unlocked",
// "Users with upload permission can add files to the gallery (not just the gallery owner)" => "Users with upload permission can add files to the gallery (not just the gallery owner)",
// "Respect permissions for backlinks to view a file" => "Respect permissions for backlinks to view a file",
"Files can be locked at download" => "Dateien können beim Herunterladen gesperrt werden",
"Maximum number of archives for each file" => "Maximale Anzahl von Dateiarchiven für jede einzelne Datei",
"unlimited" => "unbegrenzt",
"Parent gallery" => "Mutter-Galerie",
"Owner of the gallery" => "Besitzer der Galerie",
"Mb" => "MB",
"Min" => "Min",
"Group of users alerted when file gallery is modified" => "Benutzergruppen, die benachrichtigt werden, wenn das Dateiarchiv verändert wird",
"Allows each user to be selected for small groups" => "Bei kleinen Gruppen können alle Mitglieder ausgewählt werden",
"Maximum width of images in gallery" => "Maximale Breite für Bilder im Dateiarchiv",
"If an image is wider than this, it will be resized." => "Wenn ein Bild breiter ist, wird es in der Größe angepasst.",
"Attention: In this case, the original image will be lost." => "Achtung: in diesem Fall geht das Originalbild verloren.",
"Maximum height of images in gallery" => "Maximale Höhe für Bilder im Dateiarchiv",
"If an image is higher than this, it will be resized." => "Wenn ein Bild höher ist, wird es in der Größe angepasst.",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Einzutragender Wiki Markup, wenn ein Bild aus dem \"Dateiarchiv Manager\" gewählt wird",
"The default is " => "Der Standard ist ",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Feldnamen werden ersetzt, wenn sie mit %-Zeichen einschlossen werden. Z.B. %fileId%, %name%, %filename%, %description%",
// "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs" => "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs",
// "Display Settings" => "Display Settings",
// "Finder View" => "Finder View",
"Select which items to display when listing galleries" => "Wähle die Informationen, die beim Auflisten von Dateiarchiven angezeigt werden",
"Max description display size" => "Maximale Anzeigebreite der Beschreibung",
"Max rows per page" => "Max. Zeilen pro Seite",
// "View inserted gallery after save" => "View inserted gallery after save",
"File error" => "Dateifehler",
"Perhaps you are looking for" => "Suchst Du möglicherweise nach",
"There are no wiki pages similar to '{\$page|escape}'" => "Es gibt keine zu '{\$page|escape}' ähnliche Wiki-Seite",
"Token Error" => "Token-Fehler",
"Go to Log in Page" => "Gehe zur Login-Seite",
"Create this page" => "Diese Seite anlegen",
"(page will be orphaned)" => "(Seite wird verwaist sein)",
"Close Window" => "Fenster schließen",
// "Redirecting in %0 seconds" => "Redirecting in %0 seconds",
// "Permission successfully changed" => "Permission successfully changed",
// "Global permission" => "Global permission",
// "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)",
// "</em>\"}Object permission for the %0 %1" => "</em>\"}Object permission for the %0 %1",
// "Permissions successfully changed" => "Permissions successfully changed",
// "Global permissions" => "Global permissions",
// "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)",
// "</em>\"}Object permissions for the %0 %1" => "</em>\"}Object permissions for the %0 %1",
// "" => "",
// "No permissions were changed" => "No permissions were changed",
// "The following change has been applied" => "The following change has been applied",
// "The following changes have been applied" => "The following changes have been applied",
// "{\$item.mes[0]|stringfix}" => "{\$item.mes[0]|stringfix}",
"Preference name:" => "Einstellungsname:",
"Upload" => "Hochladen",
"Open as WebFolder" => "Als Webordner öffnen",
// "Delete gallery" => "Delete gallery",
"Edit: " => "Bearbeite: ",
// "Display as PDF" => "Display as PDF",
"Download current version" => "Lade die aktuelle Version herunter",
// "Browser display" => "Browser display",
"Archives" => "Archiv",
// "Upload new version" => "Upload new version",
// "Replace draft" => "Replace draft",
// "Upload draft" => "Upload draft",
// "Validate draft" => "Validate draft",
"Validate your draft" => "Bestätige Deinen Entwurf",
// "Delete draft" => "Delete draft",
"Delete your draft" => "Lösche Deinen Entwurf",
// "Edit properties" => "Edit properties",
// "Refresh metadata" => "Refresh metadata",
// "Page view" => "Page view",
// "File already locked by %0" => "File already locked by %0",
// "Lock file" => "Lock file",
"Download and lock" => "Herunterladen und Sperren",
"Open your draft in WebDAV" => "Öffne Deinen Entwurf in WebDAV",
"Open in WebDAV" => "Öffne in WebDAV",
"Share a link to this file" => "Share einen Link zu dieser Datei",
"Email a link to this file" => "Sende einen Link per E-Mail zu dieser Datei",
"Click here to use the file" => "Klicke hier, um Wiki-Syntax einzufügen",
"The checkbox is disabled because this preference is disabled globally." => "Die Checkbox ist deaktiviert, weil diese Einstellung in den globalen Einstellungen deaktiviert wurde.",
"Please enable the preference globally first." => "Bitte aktiviere diese Einstellung zuerst in den globalen Einstellungen.",
// "Site administrators can enable the preference" => "Site administrators can enable the preference",
"Show an icon in a column" => "Zeige ein Symbol in einer Spalte",
// "Search.." => "Search..",
// "Select files" => "Select files",
// "Too many files selected. De-select some files before adding more" => "Too many files selected. De-select some files before adding more",
// "Current Selection" => "Current Selection",
"Click to remove" => "Anklicken zum Entfernen",
"Upload Files" => "Dateien hochladen",
// "Drop files or " => "Drop files or ",
// "Choose files" => "Choose files",
// "Automatic upload" => "Automatic upload",
// "Last modification: %0" => "Last modification: %0",
// "No files found" => "No files found",
"Upload from URL" => "Von URL hochladen",
"File added" => "Datei hinzugefügt",
// "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} " => "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} ",
// "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section" => "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section",
"Upload File" => "Datei hochladen",
// "Or drop files here from your file manager" => "Or drop files here from your file manager",
// "Or drop file here from your file manager" => "Or drop file here from your file manager",
// "Export PDF" => "Export PDF",
"Start the Slideshow" => "Diashow starten",
"Pause the Slideshow" => "Diashow pausieren",
"There are no images to display" => "Es gibt keine anzuzeigenden Bilder",
// "Select Files (%0)" => "Select Files (%0)",
// "Sort By" => "Sort By",
// "Sort direction" => "Sort direction",
"Any" => "Beliebig",
"Lookup" => "Nachschlagen",
"Deep search" => "Tiefe Suche",
"Select Tags" => "Wähle Tags",
"Include objects without a specified language" => "Auch Objekte ohne Sprache einbeziehen",
// "View Saved Searches" => "View Saved Searches",
"Add to filter" => "Füge zum Filter hinzu",
// "{\$whatlabel}" => "{\$whatlabel}",
"Clear Filter" => "Sucheingaben löschen",
"any type" => "Jeder Typ",
"Article Topic" => "Artikel-Thema",
"any topic" => "Jedes Thema",
"any language" => "Jede beliebige Sprache",
"not in" => "aber nicht in",
// "Date From" => "Date From",
// "Date To" => "Date To",
"any category" => "Jede Kategorie",
"Multiple select" => "Mehrfachauswahl",
"{\$value}" => "{\$value}",
"{\$duration.label}" => "{\$duration.label}",
"Orphans" => "Waisen",
"{\$find_other}" => "{\$find_other}",
// "Displayed rows" => "Displayed rows",
// "Hide Map" => "Hide Map",
// "Show Map" => "Show Map",
"Module errors" => "Modulfehler",
"The following modules could not be loaded" => "Die folgenden Module konnten nicht geladen werden",
"Change" => "Ändern",
// "Show PHP error messages" => "Show PHP error messages",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes." => "Schreibe die Tags durch Leerzeichen getrennt. Für Tags, die aus mehr als einem Wort bestehen, benutze keine Leerzeichen, sondern schreibe die Worte zusammen, oder setze sie in \"Anführungszeichen\".",
"Untag" => "Untag",
// "Goal" => "Goal",
// "Eligible Groups" => "Eligible Groups",
// "No eligible groups" => "No eligible groups",
// "No goals configured yet" => "No goals configured yet",
// "Goal Administration" => "Goal Administration",
// "%0 was removed" => "%0 was removed",
// "Are you sure you want to delete %0" => "Are you sure you want to delete %0",
// "View Goal" => "View Goal",
// "Eligibility" => "Eligibility",
// "Goal Attribution" => "Goal Attribution",
// "Individual Goal" => "Individual Goal",
// "Group Goal" => "Group Goal",
// "Range Type" => "Range Type",
// "Rolling" => "Rolling",
// "Fixed" => "Fixed",
// "Time span" => "Time span",
// "In days" => "In days",
// "YYYY-MM-DD HH:MM:SS" => "YYYY-MM-DD HH:MM:SS",
// "Rewards are given to individuals achieving the goal or group members for group goals" => "Rewards are given to individuals achieving the goal or group members for group goals",
// "Changes will not be saved" => "Changes will not be saved",
// "Your changes to conditions are not saved until you save the goal" => "Your changes to conditions are not saved until you save the goal",
"Operator" => "Operator",
"At Least" => "Mindestens",
"At Most" => "Höchstens",
// "Metric" => "Metric",
// "Event Type" => "Event Type",
// "Badge" => "Badge",
// "Hide condition from users" => "Hide condition from users",
// "Members of" => "Members of",
// "Your changes to rewards are not saved until you save the goal" => "Your changes to rewards are not saved until you save the goal",
// "Credit Type" => "Credit Type",
// "Credit Quantity" => "Credit Quantity",
// "Hide reward from users" => "Hide reward from users",
// "No conditions yet" => "No conditions yet",
// "Add Condition" => "Add Condition",
// "No rewards yet" => "No rewards yet",
// "Add Reward" => "Add Reward",
// "Modify Eligibility" => "Modify Eligibility",
// "No groups are eligible to this goal" => "No groups are eligible to this goal",
// "Major Version" => "Major Version",
// "Minor Version" => "Minor Version",
// "Tutorial URL" => "Tutorial URL",
// "Restricted" => "Restricted",
// "Return to list" => "Return to list",
"Images Galleries" => "Bildergalerien",
"Edit this page" => "Ändere diese Seite",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogs",
"RSS Articles" => "RSS Artikel",
"RSS Image Galleries" => "RSS Bildergalerien",
"RSS File Galleries" => "RSS Dateiarchive",
"RSS Forums" => "RSS Foren",
"RSS Directories" => "RSS Linkverzeichnisse",
"RSS Calendars" => "RSS Kalender",
"RSS Tracker" => "RSS Tracker",
// "Use Selected Icon" => "Use Selected Icon",
// "Do you really want to remove the custom IDS rule with Id %0" => "Do you really want to remove the custom IDS rule with Id %0",
// "Back to IDS Rules list" => "Back to IDS Rules list",
// "Toggle interactive translation" => "Toggle interactive translation",
"Once checked, click on any string to translate it" => "Wenn der Haken gesetzt ist, kannst Du jeden Text anklicken, um ihn zu übersetzen",
// "Turn off interactive translation" => "Turn off interactive translation",
"Interactive Translation" => "Interaktive Übersetzung",
"Translation" => "Übersetzung",
"Couldn't find any translatable string" => "Konnte keinen übersetzbaren Text finden",
"Save translations" => "Übersetzungen speichern",
"Changes will be applied on next page load only" => "Änderungen werden angewendet, wenn die Seite das nächste Mal geladen wird",
"Upload Successful" => "Erfolgreich hochgeladen",
// "custom.php" => "custom.php",
// "Download custom.php file for the selected language" => "Download custom.php file for the selected language",
// "custom.json" => "custom.json",
// "Download custom.json file for the selected language" => "Download custom.json file for the selected language",
// "Custom translation file does not exist. Save a custom translation to create the file" => "Custom translation file does not exist. Save a custom translation to create the file",
"Translations" => "Übersetzungen",
// "Translation text" => "Translation text",
// "Add a new row" => "Add a new row",
// "Add row" => "Add row",
// "Customized String Translations" => "Customized String Translations",
// "Manage custom translations" => "Manage custom translations",
// "Process Type" => "Process Type",
// "Select how the uploaded translations should be processed" => "Select how the uploaded translations should be processed",
"Note:" => "Hinweis:",
// "No translations in the database available to export" => "No translations in the database available to export",
// "Translations in the database" => "Translations in the database",
// "Merge all translations, whether or not they are marked as general (for contribution)" => "Merge all translations, whether or not they are marked as general (for contribution)",
// "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database" => "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database",
"To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "Um Deine Übersetzungen in die language.php Datei schreiben zu können, stelle sicher, dass der Webserver Schreibrechte in das lang/-Verzeichnis hat",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Toggle right modules" => "Toggle right modules",
// "Toggle left modules" => "Toggle left modules",
"Toggle module contents" => "Modulinhalt umschalten",
"Toggle" => "Umschalten",
// "Move up" => "Move up",
// "Move down" => "Move down",
// "Move to opposite side" => "Move to opposite side",
// "{\$count_label}" => "{\$count_label}",
"Show Tree" => "Zeige Baum",
"Hide Tree" => "Verstecke Baum",
// "Select action to perform with checked.." => "Select action to perform with checked..",
"Assign permissions to file galleries" => "Rechte für Dateiarchive zuweisen",
// "Delete selected items" => "Delete selected items",
// "Download zip version" => "Download zip version",
// "Reset to default list view settings" => "Reset to default list view settings",
// "Move selected file or gallery" => "Move selected file or gallery",
"Move to" => "Verschieben nach",
// "Assign file gallery permissions to groups" => "Assign file gallery permissions to groups",
"No Additional Sort" => "Keine zusätzliche Sortierung",
"Other Sorts" => "Andere Sortierungen",
// "Locked by-" => "Locked by-",
"No information" => "Keine Information",
"{\$topic|escape}" => "{\$topic|escape}",
"{\$type|escape}" => "{\$type|escape}",
// "The leader of " => "The leader of ",
// "has added you. To visit it, logon and go to the home page " => "has added you. To visit it, logon and go to the home page ",
// "You have been added" => "You have been added",
// "This is to inform you that your request to join" => "This is to inform you that your request to join",
// " has been accepted" => " has been accepted",
// "To visit it, go to the home page" => "To visit it, go to the home page",
// "Leader approved your request" => "Leader approved your request",
// "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the" => "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the",
// "Leader rejected your request" => "Leader rejected your request",
// "This is to inform you that you have been removed from " => "This is to inform you that you have been removed from ",
// " If you did not request this removal, or have any questions or concerns, please contact" => " If you did not request this removal, or have any questions or concerns, please contact",
// "You have been removed from it" => "You have been removed from it",
"Upgrade Available" => "Upgrade vorhanden",
"Upgrades Available" => "Mehrere Upgrades Available",
// "{\$subject}" => "{\$subject}",
// "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link" => "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link",
"Blog post:" => "Blog-Eintrag:",
"at:" => "auf:",
"Gift Certificate Information" => "Geschenkgutschein-Information",
"Description:" => "Beschreibung:",
"Percentage Discount" => "Rabatt-Prozentsatz",
"Value of Gift Certificate" => "Wert des Geschenkgutscheins",
"Redeem Code" => "Code einlösen",
// "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase" => "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase",
// "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made" => "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made",
"You can review your order at" => "Du kannst Deine Bestellung einsehen unter",
// "Your {\$prefs.mail_template_custom_text}cart order" => "Your {\$prefs.mail_template_custom_text}cart order",
// "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site" => "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site",
"To the newsletter:" => "Zum Newsletter:",
// "Please access the following URL to confirm your subscription" => "Please access the following URL to confirm your subscription",
// "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link" => "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link",
"The administrator approved your account" => "Der Administrator hat Dein Konto bestätigt",
// "Confirm your {\$prefs.mail_template_custom_text}email at %s" => "Confirm your {\$prefs.mail_template_custom_text}email at %s",
// "Remove {\$prefs.mail_template_custom_text}file" => "Remove {\$prefs.mail_template_custom_text}file",
"GalleryId" => "Galerie-ID",
"Identifier" => "Kennung/ID",
// "{\$prefs.mail_template_custom_text}File Gallery quota exceeded" => "{\$prefs.mail_template_custom_text}File Gallery quota exceeded",
"File gallery:" => "Dateiarchiv:",
"User:" => "Benutzer:",
// "A new message was posted to {\$prefs.mail_template_custom_text}forum" => "A new message was posted to {\$prefs.mail_template_custom_text}forum",
"New topic" => "Neues Thema",
// "An anonymous {\$prefs.mail_template_custom_text}user" => "An anonymous {\$prefs.mail_template_custom_text}user",
"Title:" => "Titel:",
"An anonymous user" => "Ein anonymer Benutzer",
// "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL",
// "Note that this is an edited post" => "Note that this is an edited post",
// "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL" => "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL",
// "To instantly approve this post without logging in, use the following URL" => "To instantly approve this post without logging in, use the following URL",
// "You have been invited to access %0 by %1" => "You have been invited to access %0 by %1",
// "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0" => "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0",
// "Your access is valid until %0" => "Your access is valid until %0",
// "Your {\$prefs.mail_template_custom_text}temporary access to %0" => "Your {\$prefs.mail_template_custom_text}temporary access to %0",
"You are invited by" => "Du wurdest eingeladen von",
"You join this group" => "Du trittst dieser Gruppe bei",
"Join me on %s" => "Füge mich in %s hinzu",
"Tiki mail-in auto-reply" => "Automatische Tiki Mail-in Antwort",
// "{\$prefs.mail_template_custom_text}page not found" => "{\$prefs.mail_template_custom_text}page not found",
// "%0 mentioned you in %1" => "%0 mentioned you in %1",
// "You've been mentioned on %0" => "You've been mentioned on %0",
// "A new {\$prefs.mail_template_custom_text}message was posted to you" => "A new {\$prefs.mail_template_custom_text}message was posted to you",
// "Click here to read the full message and / or reply" => "Click here to read the full message and / or reply",
// "New {\$prefs.mail_template_custom_text}message arrived from %s" => "New {\$prefs.mail_template_custom_text}message arrived from %s",
"Hi" => "Hallo",
// "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now",
"To login with your username and password, please follow this link" => "Um Dich mit Deinem Benutzernamen und Passwort anzumelden, folge bitte diesem Link",
"Enjoy the site!" => "Viel Spass auf der Site!",
"User Account Activated" => "Benutzerkonto aktiviert",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first",
"has requested an account on" => "hat einen Zugang beantragt für",
"Group:" => "Gruppe",
"User Tracker" => "Benutzer-Tracker",
// "To validate that {\$prefs.mail_template_custom_text}account, please follow the link" => "To validate that {\$prefs.mail_template_custom_text}account, please follow the link",
"Assign to a group" => "Zu Gruppe zuweisen",
"View user's data" => "Daten des Benutzers einsehen",
"Best regards" => "Mit besten Grüßen",
"User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
// "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request" => "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request",
// "You're invited to join my {\$prefs.mail_template_custom_text}network of friends" => "You're invited to join my {\$prefs.mail_template_custom_text}network of friends",
"The user" => "Der Benutzer",
// "registered at your {\$prefs.mail_template_custom_text}site" => "registered at your {\$prefs.mail_template_custom_text}site",
// "New {\$prefs.mail_template_custom_text}user registration" => "New {\$prefs.mail_template_custom_text}user registration",
// "Start of article" => "Start of article",
"Published" => "Veröffentlicht",
"By:" => "Von:",
"Bye bye!" => "Auf Wiedersehen!",
// "This email address has been removed from the list of subscribers of: " => "This email address has been removed from the list of subscribers of: ",
"Bye bye from %s at %s" => "Auf Wiedersehen von %s an %s",
// "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link" => "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link",
"Welcome to our newsletter!" => "Willkommen zu diesem Newsletter!",
// "This email address has been added to the list of subscribers of: " => "This email address has been added to the list of subscribers of: ",
"You can always cancel your subscription using:" => "Du kannst das Newsletter-Abonnement jederzeit rückgängig machen über:",
"Welcome to %s at %s" => "Willkommen zu %s bei %s",
// "Reply Notification: " => "Reply Notification: ",
// "{\$prefs.mail_template_custom_text}Email Notification" => "{\$prefs.mail_template_custom_text}Email Notification",
// "Someone requested a password reset for your %0account" => "Someone requested a password reset for your %0account",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Bitte klicke auf den folgenden Link um Dein Passwort zurückzusetzen und zu der Seite zugelangen, wo Du Dein neues \"permanentes\" Passwort eingeben musst. Bitte wähle ein Passwort, dass nur Du kennst. Teile dieses niemandem mit",
"Important: Username & password are CaSe SenSitiVe" => "Wichtig: Bei Benutzername und Passwort wird zwischen Groß- und Kleinbuchstaben unterschieden",
"Important: The old password remains active if you don't click the link above" => "Wichtig: das alte Password bleibt solange gültig, bis Du auf den vorstehenden Link klickst",
"Your account information for %s" => "Deine Tikikontoinformationen für %s",
"}Plugin %0 is pending approval on %1" => "}Plugin %0 wartet auf %1 auf Bestätigung",
// "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>",
"Plugin arguments" => "Plugin Argumente",
// "Report on %0 for %1" => "Report on %0 for %1",
// "Last {\$prefs.mail_template_custom_text}Report sent on %0" => "Last {\$prefs.mail_template_custom_text}Report sent on %0",
"Changes in detail:" => "Änderungen im Detail:",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Du erhältst Benachrichtigungsemails, zusammengefasst in einem periodischen Extrakt. Um sie einzeln zu erhalten, wenn sie geschickt werden, ändere Deine Einstellungen unter %0",
// "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at" => "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at",
"Feed" => "Feed",
// "New categories" => "New categories",
// "Configure settings for the new category at" => "Configure settings for the new category at",
// "New {\$prefs.mail_template_custom_text}source category in RSS feed" => "New {\$prefs.mail_template_custom_text}source category in RSS feed",
// "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes",
"Details" => "Details",
"Site" => "Link",
// "[%0] Scheduler \"%1\" was healed" => "[%0] Scheduler \"%1\" was healed",
// "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes",
// "[%0] Scheduler \"%1\" is stalled" => "[%0] Scheduler \"%1\" is stalled",
// "Look at this {\$prefs.mail_template_custom_text}link" => "Look at this {\$prefs.mail_template_custom_text}link",
// "A friend sends you a {\$prefs.mail_template_custom_text}link from: " => "A friend sends you a {\$prefs.mail_template_custom_text}link from: ",
// "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link:" => "Du kannst diesen Beitrag bearbeiten, wenn Du hier klickst:",
"Heading:" => "Kopfbereich:",
"Body:" => "Hauptteil:",
// "New {\$prefs.mail_template_custom_text}article submitted at %s" => "New {\$prefs.mail_template_custom_text}article submitted at %s",
// "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}" => "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}",
// "{\$mail_user|username}" => "{\$mail_user|username}",
// "{\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "{\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}",
// "View the {\$prefs.mail_template_custom_text}tracker item at" => "View the {\$prefs.mail_template_custom_text}tracker item at",
// "The last content before deletion was as follows" => "The last content before deletion was as follows",
"Download the file at" => "Lade die Datei herunter unter",
// "{\$mail_trackerName}" => "{\$mail_trackerName}",
"item" => "Eintrag",
// "was deleted at" => "was deleted at",
"was modified at" => "wurde verändert am",
// "Please visit this {\$prefs.mail_template_custom_text}link before logging in again" => "Please visit this {\$prefs.mail_template_custom_text}link before logging in again",
"Last attempt" => "Letzter Versuch",
// "Confirm your {\$prefs.mail_template_custom_text}account at %s" => "Confirm your {\$prefs.mail_template_custom_text}account at %s",
// "{\$prefs.mail_template_custom_text}Site" => "{\$prefs.mail_template_custom_text}Site",
// "{\$prefs.mail_template_custom_text}Account suspended" => "{\$prefs.mail_template_custom_text}Account suspended",
// "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user" => "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Wenn Du Deine Mitgliedschaft in der Site bestätigen willst, klicke den folgenden Link, um Dich zum ersten Mal anzumelden",
"Welcome to the site!" => "Willkommen bei der Site",
"Your personal access to" => "Dein persönlicher Zugriff auf",
// "joined" => "joined",
// "User joined" => "User joined",
// "You are getting this email because you are a leader of" => "You are getting this email because you are a leader of",
// "Click here to manage members" => "Click here to manage members",
// "You are getting this email because you are a leader" => "You are getting this email because you are a leader",
// "The user needs to be approved before he is admitted" => "The user needs to be approved before he is admitted",
// "user joined" => "user joined",
// "You are getting this email because you are a group leader" => "You are getting this email because you are a group leader",
// "left" => "left",
// "user left" => "user left",
"You or someone registered this email address at" => "Du oder jemand anderes registriere Deine E-Mailadresse bei",
// "If you want to be a registered user in this %0site you will have to use the following link to login for the first time" => "If you want to be a registered user in this %0site you will have to use the following link to login for the first time",
// "Your {\$prefs.mail_template_custom_text}registration confirmation" => "Your {\$prefs.mail_template_custom_text}registration confirmation",
"You will receive an email with the information needed to log into this site the first time" => "Du wirst eine E-Mail mit den erforderlichen Informationen bezüglich des ersten Einloggens in diese Site erhalten",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst möglich bearbeitet.",
"You'll receive email notification once your account is activated" => "Du erhältst eine E-Mailbenachrichtigung, wenn Dein Konto aktiviert wurde",
"Please do not attempt to login until you receive the email notification" => "Bitte melde Dich nicht an, bevor Du die E-Mailbestätigung erhalten hast",
// "New {\$prefs.mail_template_custom_text}article post" => "New {\$prefs.mail_template_custom_text}article post",
// "Edit {\$prefs.mail_template_custom_text}article post" => "Edit {\$prefs.mail_template_custom_text}article post",
// "Delete {\$prefs.mail_template_custom_text}article post" => "Delete {\$prefs.mail_template_custom_text}article post",
"{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} von {\$mail_user|username} am",
"View the article at:" => "Klicke hier um zu dem Artikel zu gelangen:",
"Expiration Date" => "Ablaufdatum",
"If you don't want to receive these notifications follow this link:" => "Falls Du diese Benachrichtigungen nicht mehr bekommen möchtest, klicke hier:",
"The old article follows" => "Der alte Artikel folgt",
// "New {\$prefs.mail_template_custom_text}article post at" => "New {\$prefs.mail_template_custom_text}article post at",
// "Edited {\$prefs.mail_template_custom_text}article post at" => "Edited {\$prefs.mail_template_custom_text}article post at",
// "Deleted {\$prefs.mail_template_custom_text}article post at" => "Deleted {\$prefs.mail_template_custom_text}article post at",
// "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at:" => "Zeige den Blog auf:",
// "New {\$prefs.mail_template_custom_text}blog post at %s" => "New {\$prefs.mail_template_custom_text}blog post at %s",
"View item calendar at" => "Siehe Kalendereintrag am",
// "Modified {\$prefs.mail_template_custom_text}calendar item" => "Modified {\$prefs.mail_template_custom_text}calendar item",
// "New {\$prefs.mail_template_custom_text}calendar item" => "New {\$prefs.mail_template_custom_text}calendar item",
"changed" => "geändert",
// "A new {\$prefs.mail_template_custom_text}category was created in" => "A new {\$prefs.mail_template_custom_text}category was created in",
"Created by" => "Erstellt von",
"created" => "erstellt",
// "A {\$prefs.mail_template_custom_text}category was removed in" => "A {\$prefs.mail_template_custom_text}category was removed in",
"Removed by" => "Gelöscht von",
"removed" => "entfernt",
// "A {\$prefs.mail_template_custom_text}category was updated" => "A {\$prefs.mail_template_custom_text}category was updated",
"Updated by" => "Aktualisiert von",
"Old" => "Alt",
"updated" => "aktualisiert",
// "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by",
"an anonymous user" => "einem anonymen Benutzer",
// "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by",
"You can view the comment by following this link" => "Du kannst den Kommentar mit diesem Link einsehen",
"Comment:" => "Kommentar:",
"File Gallery %s changed" => "Dateiverzeichnis %s geändert",
// "A file was removed from the {\$prefs.mail_template_custom_text}file gallery" => "A file was removed from the {\$prefs.mail_template_custom_text}file gallery",
// "A new file was posted to {\$prefs.mail_template_custom_text}file gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}file gallery",
"File Description" => "Dateibeschreibung",
// "You can download the new file at" => "You can download the new file at",
// "The new file ID is %0 and it is in gallery ID %1" => "The new file ID is %0 and it is in gallery ID %1",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "Bildergalerie {\$galleryName} geändert",
// "A new file was posted to {\$prefs.mail_template_custom_text}image gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}image gallery",
// "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link" => "Du kannst die aktualisierte Karte ansehen, wenn Du diesem Link folgst",
"You can edit the map following this link" => "Du kannst die Karte bearbeiten, wenn Du diesem Link folgst",
// "An object was added to {\$prefs.mail_template_custom_text}category" => "An object was added to {\$prefs.mail_template_custom_text}category",
"Added by" => "Hinzugefügt durch",
// "An object was removed from {\$prefs.mail_template_custom_text}category" => "An object was removed from {\$prefs.mail_template_custom_text}category",
// "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure" => "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure",
"Structure modified" => "Struktur verändert",
"has consulted your" => "hat von Dir konsultiert",
"Go to the File Gallery" => "Gehe zum Dateiarchiv",
"Download the file" => "Lade die Datei herunter",
// "A new file has been attached to {\$prefs.mail_template_custom_text}page" => "A new file has been attached to {\$prefs.mail_template_custom_text}page",
"File name" => "Dateiname",
// "New {\$prefs.mail_template_custom_text}attachment on %s, page" => "New {\$prefs.mail_template_custom_text}attachment on %s, page",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here" => "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here",
"You can view the page by following this link:" => "Du kannst die Seite betrachten, indem Du diesem Link folgst:",
"You can view a diff back to the previous version by following this link:" => "Du kannst einen Blick auf die vorherige Version werfen, indem Du diesem Link folgst:",
"The changes in this version follow below, followed after by the current full page text." => "Die Änderungen dieser Version folgen unten, gefolgt von dem aktuellen kompletten Seiteninhalt.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Zeilen: {\$oldd} geändert zu +Zeilen: {\$newd}",
"The old page content follows below" => "Der Inhalt der alten Seite folgt unten stehend",
"The new page content follows below." => "Der neue Seiteninhalt folgt unten.",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}",
"Wiki page renamed" => "Wiki Seite umbenannt",
"Old name" => "Alter Name",
"New name" => "Neuer Name",
// "Your %0account ID" => "Your %0account ID",
// "has been generated" => "has been generated",
// "Thank you for your %0registration" => "Thank you for your %0registration",
"You may log in now." => "Du kannst Dich jetzt anmelden.",
// "Operation Completed" => "Operation Completed",
// "Return to Query List" => "Return to Query List",
// "Do you really want to remove the %0 account" => "Do you really want to remove the %0 account",
// "Delete Account" => "Delete Account",
"Active" => "Aktiv",
"Account name" => "Kontoname",
// "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND" => "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND",
// "Reply handler requires notifications to be enabled and the reply email pattern to be configured" => "Reply handler requires notifications to be enabled and the reply email pattern to be configured",
"POP server" => "POP-Server",
// "POP" => "POP",
"IMAP" => "IMAP",
"Admin Topics" => "Themen verwalten",
"Admin Types" => "Typen verwalten",
"Allow anonymous access" => "Anonymen Zugriff erlauben",
// "Warning: Enabling anonymous access will disable all permission checking for mailed-in content" => "Warning: Enabling anonymous access will disable all permission checking for mailed-in content",
"Allow admin access" => "Gestatte Admin-Zugriff",
// "Administrators have full access to the system. Disabling admin mail-in is the safest option" => "Administrators have full access to the system. Disabling admin mail-in is the safest option",
"Allow attachments" => "Anhänge erlauben",
// "Allow routing" => "Allow routing",
// "Allow per user routing of incoming email to structures" => "Allow per user routing of incoming email to structures",
// "Show inline images" => "Show inline images",
// "For HTML email, attempt to create a WYSIWYG wiki-page" => "For HTML email, attempt to create a WYSIWYG wiki-page",
// "Keep HTML format" => "Keep HTML format",
// "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection" => "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection",
"Discard to the end from" => "Verwerfe zum Ende von",
// "Auto-assign category" => "Auto-assign category",
// "Only affects wiki-put, when creating a new wiki page" => "Only affects wiki-put, when creating a new wiki page",
// "Auto-assign namespace" => "Auto-assign namespace",
// "Email response when no access" => "Email response when no access",
// "Leave email on server on error" => "Leave email on server on error",
// "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki" => "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki",
// "Add Account" => "Add Account",
// "Operation not reversible" => "Operation not reversible",
// "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used" => "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used",
"Event" => "Ereignis",
// "Disable rule" => "Disable rule",
// "Enable rule" => "Enable rule",
// "Unknown status" => "Unknown status",
// "Current Type" => "Current Type",
// "New Type" => "New Type",
// "The rule has been removed" => "The rule has been removed",
// "Are you sure you want to delete this rule" => "Are you sure you want to delete this rule",
// "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it" => "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it",
// "Sample Rule" => "Sample Rule",
// "Basic Rule (Record Event)" => "Basic Rule (Record Event)",
// "Tracker Rule" => "Tracker Rule",
// "Advanced Rule" => "Advanced Rule",
// "Community Control Panel" => "Community Control Panel",
// "Event Chain Diagram" => "Event Chain Diagram",
// "Rule Type" => "Rule Type",
// "Allow Notifications" => "Allow Notifications",
// "Recipient" => "Recipient",
// "Cached sample data helps to view available variables for event types" => "Cached sample data helps to view available variables for event types",
// "Sample available" => "Sample available",
// "Sample currently not available" => "Sample currently not available",
// "Source Event" => "Source Event",
// "Target Event" => "Target Event",
// "All event names are required to have at least 3 components" => "All event names are required to have at least 3 components",
// "%0 Copy" => "%0 Copy",
// "Clone of Menu Id" => "Clone of Menu Id",
// "Symbol Information" => "Symbol Information",
// "Profile Source" => "Profile Source",
"Clone" => "Klonen",
"dynamic collapsed" => "Dynamisch eingeklappt",
"dynamic extended" => "Dynamisch ausgeklappt",
"fixed" => "fest",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
"Folder Icon" => "Ordnersymbol",
"Path and filename of closed folder icon" => "Pfad und Dateiname für das Symbol für den geschlossenen Ordner",
"Configure icons for menu entries" => "Konfiguriere Symbole für Menüs",
"For wiki page, use ((PageName))" => "Benutze ((PageName)) für eine Wiki Seite",
"Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Die Auswahl von 2 Gruppen führt dazu, dass der Benutzer beiden angehören muss, um die Option zu sehen. Wenn Du möchtest, dass 2 Gruppen diese Option sehen können, erstelle zwei Optionen, jeweils eine pro Gruppe",
"If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "Wenn die URL ((PageName)) ist, musst Du keine Gruppen festlegen. Die Option wird nur angezeigt, wenn die Seite angezeigt werden kann",
"Sections" => "Bereiche",
"Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Trenne multiple Funktionen/Einstellungen mit einem Komma ( , ) für ein UND (AND) oder einem Senkrechtstrich ( | ) für ein ODER (OR)",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Trenne mutiple Rechte mit einem Komma ( , ) für ein UND oder einem Senkrechtstrich ( | ) für ein ODER",
// "Input an HTML class value for the menu option. Separate with a space for multiple classes" => "Input an HTML class value for the menu option. Separate with a space for multiple classes",
"Tips" => "Tips",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "Um neue Optionen zum Menü hinzuzufügen, trage im optionId Feld 0 ein. Um eine Option zu entfernen, trage bei Feld entfernen 'y' ein",
// "Duplicate options will be ignored" => "Duplicate options will be ignored",
"Show Quick URLs" => "Quick URLs anzeigen",
"Some useful URLs" => "Einige nützliche URLs",
"Hide Quick URLs" => "Quick URLs verstecken",
"Home" => "Startseite",
"Choose" => "Auswählen",
"Home Page" => "Startseite",
"Home Blog" => "Home-Blog",
"Home Image Gal" => "Home-BilderGal",
"Home Image Gallery" => "Home-Bildergalerie",
"Home File Gal" => "Home-Dateiarchiv",
"Home File Gallery" => "Home-Dateiarchiv",
"User preferences" => "Benutzereinstellungen",
"User prefs" => "Benutzereinstellungen",
"Wiki Home" => "Wiki-Home",
"List galleries" => "Galerien auflisten",
"List image galleries" => "Bildergalerien auflisten",
"Upload image" => "Bild hochladen",
"Gallery Rankings" => "Galerie-Bewertungen",
"Browse a gallery" => "Galerie ansehen",
"Articles home" => "Artikel-Home",
"All articles" => "Alle Artikel",
"List Blogs" => "Blogs auflisten",
"Create Blog" => "Blog erstellen",
"View a forum" => "Forum ansehen",
"View a thread" => "Thread ansehen",
"View a FAQ" => "Eine FAQ ansehen",
"Take a quiz" => "Ein Quiz durchführen",
"Quiz stats" => "Quizstatistik",
"Stats for a Quiz" => "Statistik für ein Quiz",
"Message Archive" => "Nachrichtenarchiv",
"Archive is full!" => "Archiv ist voll!",
"Unread" => "Ungelesen",
"Flagged" => "Gekennzeichnet",
"Unflagged" => "Nicht gekennzeichnet",
"Containing" => "die enthalten",
"Sender" => "Absender",
"No messages to display" => "Keine Nachrichten anzuzeigen",
"Broadcast message" => "Nachricht an Verteiler",
"All users" => "Alle Benutzer",
"Lowest" => "sehr niedrig",
"Very High" => "sehr hoch",
"Body" => "Text",
"Send" => "Verschicken",
"Compose message" => "Nachricht erstellen",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "Wenn Du möchtest, dass man Dir antworten kann, musst Du <a href='tiki-user_preferences.php'>Erlaube Nachrichten von anderen Benutzern</a> in Deinen Einstellungen aktivieren",
// "To: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "To: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"CC" => "CC",
// "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"Reply-to my email" => "Antwort auf meine E-Mailadresse",
"The user will be able to reply to you directly via email" => "Der Benutzer kann Dir direkt via E-Mail antworten",
"Send me a copy" => "Sende mir eine Kopie",
"You will be sent a copy of this email" => "Du erhältst eine Kopie dieser E-Mail",
"No messages to download" => "Keine Nachricht zum Herunterladen",
// "full" => "full",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "Mailbox ist voll! Bitte ein paar Nachrichten archivieren oder löschen, damit weitere empfangen werden können.",
"is reply to" => "ist Antwort auf",
"Find replied message" => "suche beantwortete Nachricht",
"Perform action with checked:" => "Aktion auf alle markierten Elemente ausführen",
"Mark as read" => "Markiere als gelesen",
"Mark as unread" => "Markiere als ungelesen",
"Mark as flagged" => "Markiere als gekennzeichnet",
"Mark as unflagged" => "Markiere als ungekennzeichnet",
"Mark" => "Markieren",
"Mailbox" => "Briefkasten",
"Compose" => "Erstellen",
"Broadcast" => "Verteiler",
"Auto-archive age for read messages:" => "Mindestalter gelesener Nachrichten für Auto-Archivierung:",
"Read message" => "Nachricht lesen",
// "Flagged:Click to unflag" => "Flagged:Click to unflag",
// "Not flagged:Click to flag" => "Not flagged:Click to flag",
"replyall" => "allen antworten",
// "Reply All" => "Reply All",
"From:" => "Von:",
"Cc" => "Cc",
// "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>",
// "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>",
"Sent Messages" => "Gesendete Nachrichten",
"Replied" => "Beantwortet",
"Not replied" => "Nicht beantwortet",
// "Move to archive" => "Move to archive",
// "Image Metadata for" => "Image Metadata for",
"<em>Note: only basic metadata processed for this file type</em>" => "<em>Hinweis: für diesen Datei-typus werden nur einfache (basic) Metadaten verarbeitet</em>",
// "{\$subtypes@key|escape}" => "{\$subtypes@key|escape}",
// "{\$fields@key|lower|capitalize|escape}" => "{\$fields@key|lower|capitalize|escape}",
// "{\$fieldarray.label|escape}" => "{\$fieldarray.label|escape}",
// "{\$fieldarray@key|escape}" => "{\$fieldarray@key|escape}",
// "{\$fieldarray.suffix|escape}" => "{\$fieldarray.suffix|escape}",
// "No metadata found" => "No metadata found",
// "Read-only metadata extracted from the file" => "Read-only metadata extracted from the file",
"<em>Only basic metadata processed for this file type.</em>" => "<em>Für diesen Datei-typus werden nur einfache (basic) Metadaten verarbeitet.</em>",
// "Control panels" => "Control panels",
// "Turn on interactive translation" => "Turn on interactive translation",
// "Comment moderation" => "Comment moderation",
// "Clear all caches" => "Clear all caches",
// "Plugin approval" => "Plugin approval",
"Logs" => "Logs",
// "Smarty debug window" => "Smarty debug window",
"Display type unknown, you have to enter the banner type" => "Anzeigetyp unbekannt. Du musst den Banner-Typ angeben",
"You forgot your Google ad_client number !" => "Es wurde keine Google ad_client Nummer angegeben!",
"Thank you for installing Tiki" => "Danke, dass Du Tiki installiert hast",
"To configure your Tiki" => "Um Deine Tiki zu konfigurieren",
"from the menu" => "aus dem Menü",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Lies die <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Dokumentation\" target=\"_blank\">Konfigurationsdokumentation</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Siehe die <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">Demonstrationsvideos an",
"To remove this module" => "Um dieses Modul zu entfernen",
"Admin Modules" => "Module verwalten",
"and remove the assistant module" => "und entferne das Assistenzmodul",
"You can also add other modules" => "Du kannst auch andere Module hinzufügen",
"To customize the menu" => "Um das Menü individuell anzupassen",
"Admin Menus" => "Menüs verwalten",
"and edit menu ID 42" => "und bearbeite Menü ID 42",
"Or, create your own menu and add it to a module" => "Oder erstelle Dein eigenes Menü und füge es als Modul hinzu",
"To begin configuring Tiki, please" => "Um mit der Konfiguration der Tiki zu beginnen, bitte",
"login" => "Anmeldung",
"as admin" => "als Administrator",
"The Tiki Community" => "Die Tiki Gemeinschaft",
"To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "Um mehr zu lernen, besuche: <a href=\"http://tiki.org\" title=\"Die Tiki Gemeinschaft\" target=\"_blank\">http://tiki.org</a>",
"Tiki Documentation" => "Tiki Dokumentation",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "Für Hilfe, besuche <a href=\"http://doc.tiki.org\" title=\"Tiki Dokumentation\" target=\"_blank\">http://doc.tiki.org</a>",
"on" => "am",
"Published on" => "Veröffentlicht am",
"on blogpost" => "auf Blogeintrag",
"Untitled" => "ohne Titel",
"{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
"{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add Event" => "Termin hinzufügen",
"Unit cost" => "Preis/Einheit",
"Qty" => "Menge",
// "Cart contains <span>%0</span> items" => "Cart contains <span>%0</span> items",
// "Total weight %0 %1" => "Total weight %0 %1",
"Gift Certificate" => "Geschenkgutschein",
"Remove Gift Certificate" => "Entferne Geschenkgutschein",
"Add Gift Certificate" => "Füge Gutschein hinzu",
"Check-out" => "Abmelden",
"Your cart is empty" => "Dein Warenkorb ist leer",
"Missing %0 of the following categories" => "Es fehlt/fehlen %0 der folgenden Kategorien",
"%0 extra of the following categories" => "%0 zusätzlich zu den folgenden Kategorien",
"Unknown comparison" => "Unbekannter Vergleich",
"Impossible condition, %0 of" => "Unmögliche Bedingung, %0 von",
"Assign into category" => "Zu Kategorie zuweisen",
"{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
"Unassign category" => "Aus Kategorie entfernen",
"{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "Seiten:",
"{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Homepage",
"1 more contributor" => "1 weiterer Beitragender",
"{\$hiddenContributors} more contributors" => "{\$hiddenContributors} weitere Beitragende",
"low" => "niedrig",
"Sites" => "Links",
"Sites to validate" => "Zu überprüfende Links",
"Categories:" => "Kategorien:",
"Visited links" => "Besuchte Links",
"Pass" => "Passwort",
"By" => "Von",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Trage Tags durch Leerzeichen getrennt ein. Für Tags mit mehr als einem Wort, benutze keine Leerzeichen und schreibe die Worte zusammen oder umschließe sie mit Anführungszeichen",
"Add tags" => "Tags hinzufügen",
// "No tags yet" => "No tags yet",
"List everything tagged" => "Liste alles mit Tags versehene",
"Last updated" => "Zuletzt aktualisiert",
"All Groups" => "Alle Gruppen",
"Your Groups" => "Deine Gruppen",
"Emulated Groups" => "Emuliere Gruppen",
"Switch to Groups" => "Zu Gruppen umschalten",
"Simulate" => "Simuliere",
"Add Post" => "Posting beifugen",
"insert original" => "Original einfügen",
"insert thumbnail" => "Miniaturbild einfügen",
"more" => "mehr",
"Last %0 Podcasts" => "Die letzten %0 Podcasts",
"This is likely not a podcast file" => "Dies ist wahrscheinlich keine Podcast-Datei",
"The path to a podcast player is required" => "Der Pfad zu einem Podcastplayer ist erforderlich",
"{\$link_text}" => "{\$link_text}",
"No profile picture" => "Kein Avatar",
"You" => "Du",
// "Never logged in" => "Never logged in",
"{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Operatorkonsole öffnen",
// "Execution time" => "Execution time",
// "Memory usage" => "Memory usage",
// "Queries" => "Queries",
"Server load" => "Serverlast",
"Logged in as" => "Angemeldet als",
"Log out" => "Abmelden",
// "Return to Main User" => "Return to Main User",
// "Return to main user" => "Return to main user",
"Switch" => "Wechseln",
"Switch User" => "Benutzer wechseln",
"Email:" => "E-Mail:",
// "Email address or " => "Email address or ",
// "User account ID" => "User account ID",
// "Enter a username and click 'Switch'.<br>Useful for testing permissions" => "Enter a username and click 'Switch'.<br>Useful for testing permissions",
"Switch user" => "Benutzer wechseln",
// "Toggle Dropdown" => "Toggle Dropdown",
"My Account" => "Mein Tiki",
// "{\$user|username|escape|replace:'&amp;':'&'}" => "{\$user|username|escape|replace:'&amp;':'&'}",
"Log in through CAS" => "Einloggen mittels CAS",
"Log in as admin" => "Einloggen als Administrator",
"Log in through Shibboleth" => "Login mittels Shibboleth",
// "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t" => "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t",
"CapsLock is on" => "CapsLock ist aktiviert",
"Click here if you've forgotten your password" => "Klicke hier, wenn Du Dein Passwort vergessen hast",
"I forgot my password" => "Ich habe mein Passwort vergessen",
"Click here to register" => "Klicke hier, um Dich zu registrieren",
"Click here to log in using the default security protocol" => "Klicke hier, um Dich mit dem standard Sicherheitsprotokoll anzumelden",
"Standard" => "Standard",
"Click here to log in using a secure protocol" => "Klicke hier, um ein sicheres Anmeldeprotokoll zu verwenden",
"Secure" => "Sicher",
"Stay in SSL mode" => "In SSL-Modus bleiben",
"local account" => "lokales Konto",
// "Log in via Facebook" => "Log in via Facebook",
// "Log in via LinkedIn" => "Log in via LinkedIn",
"OpenID Log in" => "OpenID Anmeldung",
// "OpenID Login" => "OpenID Login",
"What is OpenID" => "Was ist OpenID",
// "Change the logo" => "Change the logo",
// "Click to change or upload new logo" => "Click to change or upload new logo",
// "{\$module_params.sitetitle|escape}" => "{\$module_params.sitetitle|escape}",
// "{\$module_params.sitesubtitle|escape}" => "{\$module_params.sitesubtitle|escape}",
"No acceptable field to store the feature was found in the specified tracker" => "Im angegebenen Tracker wurde kein gültiges Feld zum Abspeichern des Merkmals gefunden",
// "Edit this menu" => "Edit this menu",
"You have" => "Du hast",
"new messages" => "neue Nachrichten",
"new message" => "neue Nachricht",
"You have 0 new messages" => "Du hast keine neuen Nachrichten",
"No article found" => "Kein Artikel gefunden",
"No blog post found" => "Kein Blog-Eintrag gefunden",
"We have" => "Wir haben",
"submissions waiting to be examined" => "Einreichungen, die auf Sichtung warten",
// "Permissions applied from" => "Permissions applied from",
// "No permissions to display" => "No permissions to display",
"Stay on this page" => "Bleibe auf dieser Seite",
"Edit perspectives" => "Perspektiven bearbeiten",
// "Within %0" => "Within %0",
"Search Terms" => "Suchbegriffe",
"Any type" => "Jeder Typ",
// "Recent Preferences" => "Recent Preferences",
"Wiki feed" => "Wiki Feed",
"Blogs feed" => "Blogs Feed",
"Articles feed" => "Artikel Feed",
"Image Galleries feed" => "Bildergalerie Feed",
"Image Galleries" => "Bildergalerien",
"File Galleries feed" => "Dateiarchiv Feed",
"Forums feed" => "Foren Feeds",
// "Directory feed" => "Directory feed",
// "Calendar feed" => "Calendar feed",
"{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Ganze Site",
"Image Gals" => "Bildergalerien",
"Search for text throughout the site" => "Nach Text auf der ganzen Site suchen",
"Go directly to a page, or search in page titles if exact match is not found" => "Gehe direkt zu einer Seite oder durchsuche die Seitentitel, wenn kein genauer Treffer erzielt wurde",
"Edit existing page or create a new one" => "Bearbeite bestehende Seiten oder erstelle neue",
// "External" => "External",
"Exact match" => "nur genaue Treffer",
"Page Relations" => "Seitenbeziehungen",
// "Get short url" => "Get short url",
"Copy" => "Kopieren",
// "Copied" => "Copied",
"Tweet with Twitter" => "Mit Twitter tweeten",
"Post on my Facebook wall" => "Post das auf meiner Facebook-Pinnwand",
"Shout date" => "Datum Shout-Beitrag",
"Delete this shout" => "Lösche diesen Shout-Beitrag",
"Edit this shout" => "Bearbeite diesen Shout-Beitrag",
"Read More" => "Weiterlesen",
"Since your last visit on" => "Letzter Besuch",
"New Images" => "Neue Bilder",
"Wiki Pages Changed" => "Wiki-Seiten geändert",
"New Files" => "Neue Dateien",
"New Comments" => "Neue Kommentare",
"New Tracker Items" => "Neue Trackereinträge",
"New Calendar Events" => "Neue Kalenderereignisse",
"New Users" => "Neue Benutzer",
"click to edit" => "Bearbeiten mit Klick",
"Nothing has changed" => "Keine Änderungen",
"Tracker Items" => "Trackerobjekte",
// "Updated" => "Updated",
"Multiple" => "mehrfach",
"including" => "einschließlich",
// "No Subversion checkout or unable to determine last update" => "No Subversion checkout or unable to determine last update",
"Find term:" => "Suche Ausdruck:",
"{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
"If not found, you will be given a chance to create it." => "Wenn nichts gefunden wird, erhältst Du die Möglichkeit ihn zu erstellen.",
"TikiTests Menu" => "TikiTests Menü",
"List Tests" => "Tests auflisten",
"Create Test" => "Test erstellen",
"Top galleries" => "Top Galerien",
"Posted to" => "Posted zu",
"(Read More)" => "(Lies mehr)",
"Missing values" => "Fehlende Werte",
"Add Marker" => "Füge Markierung hinzu",
"Tracker name" => "Trackername",
"Insert fields in wiki textarea" => "Füge Felder in Wiki Textbereiche ein",
"There are no translations of this page" => "Es gibt keine Übersetzungen dieser Seite",
"Up-to-date-ness" => "Aktualität",
"Incoming" => "Eingehend",
"To <strong>continue translating</strong>, select the language to translate from:" => "Um mit der <strong>Übersetzung fortzufahren</strong>, wähle eine Sprache, aus der übersetzt werden soll:",
"update from it" => "von hier aktualisieren",
"None match your" => "Keine Übereinstimmung Deiner",
"Set your preferred languages." => "Bevorzugte Sprachen einstellen.",
"preferred languages" => "bevorzugte Sprache(n)",
"Outgoing" => "Ausgehend",
"update it" => "aktualisiere es",
"click to view" => "klicken zum Ansehen",
"Bookmarks" => "Lesezeichen",
"Cache" => "Cache",
"Create Bookmark" => "Erstelle Bookmark",
"New Folder" => "Neuer Ordner",
"Done" => "fertig",
"Del" => "Löschen",
"select" => "wähle",
"{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
"Group information" => "Gruppeninformationen",
"You need to activate user and/or group trackers." => "Du musst Benutzer- und/oder Gruppen-Tracker aktivieren.",
"view" => "betrachten",
"%0 out of %1 users" => "%0 von insgesamt %1 Benutzern",
"online users" => "Benutzer (alle) online",
"online user" => "Benutzer online",
"on host" => "auf Host",
"User does not accept messages" => "Benutzer akzeptiert keine Nachrichten",
"Send a message to" => "Schicke eine Nachricht an",
"More Videos" => "Mehr Videos",
"No results were found. Are you sure you searched for a tag" => "Kein Ergebnis gefunden. Bist Du sicher, dass Du nach einem Tag gesucht hast",
"We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "Wir sind nicht authorisiert derzeit auf diese Gruppe zuzugreifen. Wenn Du Zugriff zur Zotero-Gruppe hast, kannst Du dieser Site Lese-Zugriff gewähren",
// "Mark all as read" => "Mark all as read",
// "You receive this notification because you requested it" => "You receive this notification because you requested it",
// "If you did not request these emails or did so in an error, please use the following link" => "If you did not request these emails or did so in an error, please use the following link",
// "Manage your notifications" => "Manage your notifications",
// "Notification Digest" => "Notification Digest",
// "No notifications available" => "No notifications available",
// "Priorities" => "Priorities",
// "No unread notifications" => "No unread notifications",
// "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped" => "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped",
// "Required Action" => "Required Action",
// "Add all members" => "Add all members",
// "OR Select individuals.." => "OR Select individuals..",
// "Add selected members" => "Add selected members",
"Detail" => "Detail",
// "Respond" => "Respond",
// "Opened" => "Opened",
// "Logged In" => "Logged In",
// "Unopened" => "Unopened",
// "People" => "People",
// "Empty list" => "Empty list",
// "Responses" => "Responses",
"Entry" => "Eintrag",
"Request Date" => "Anfragedatum",
// "Action Req'd" => "Action Req'd",
// "None (Owner)" => "None (Owner)",
// "Nothing to do" => "Nothing to do",
// "Add Item" => "Add Item",
// "On this document" => "On this document",
// "Saving" => "Saving",
// "This window will close automatically in 3 seconds.." => "This window will close automatically in 3 seconds..",
// "An error occurred, please try again" => "An error occurred, please try again",
// "Consent screen" => "Consent screen",
// "Do you really want to proceed" => "Do you really want to proceed",
"No individual permissions, category permissions apply" => "Keine individuellen Berechtigungen - Kategorieberechtigungen gelten",
"There are individual permissions set for this object" => "Für dieses Objekt existieren individuelle Berechtigungen",
"No individual permissions. Global permissions apply." => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
// "Search and select what you are looking for from the options that appear" => "Search and select what you are looking for from the options that appear",
// "No matching results" => "No matching results",
// "Search and select what you are looking for from the options that appear." => "Search and select what you are looking for from the options that appear.",
"Comparing version {\$old.version} with version {\$new.version}" => "Vergleiche Version {\$old.version} mit Version {\$new.version}",
"Current" => "Aktuell",
"Session" => "Sitzungsdaten",
"Old Session" => "Alte Sitzung",
"Old Version" => "Alte Version",
"New Session" => "Neue Sitzung",
"New Version" => "Neue Version",
"Versions are identical" => "Versionen sind identisch",
// "Example wikidiff plugin syntax" => "Example wikidiff plugin syntax",
"Minimum %0 characters long" => "Mindestens %0 Zeichen lang",
// "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + ..",
// "Password is too common" => "Password is too common",
// "Individual permissions" => "Individual permissions",
// "Select image" => "Select image",
// "Pick a file" => "Pick a file",
// "Upload or record media" => "Upload or record media",
// "Convert to List" => "Convert to List",
// "{\$info.title|escape}" => "{\$info.title|escape}",
// "{\$info.description|default:''|escape}" => "{\$info.description|default:''|escape}",
// "Auto generate Biblio Code" => "Auto generate Biblio Code",
// "New reference created" => "New reference created",
// "Problems while creating the reference" => "Problems while creating the reference",
"[-]" => "[-]",
"vote" => "Abstimmen",
// "Use &quot;%0&quot; to separate values" => "Use &quot;%0&quot; to separate values",
"Warning:" => "Warnung:",
// "Reset to default value" => "Reset to default value",
// "Restore current value" => "Restore current value",
// "Change your preference filter settings in order to view advanced preferences by default" => "Change your preference filter settings in order to view advanced preferences by default",
// "advanced" => "advanced",
// "Change your preference filter settings in order to view experimental preferences by default" => "Change your preference filter settings in order to view experimental preferences by default",
"experimental" => "experimentell",
"Requires" => "setzt voraus: ",
// "You need apply profile" => "You need apply profile",
"You need to set" => "Du musst folgende Funktion einstellen:",
// "Requires package" => "Requires package",
// "Missing tiki package" => "Missing tiki package",
// "User rating" => "User rating",
"Rate" => "Bewerten",
// "User rating on thread topic" => "User rating on thread topic",
// "Debug Information" => "Debug Information",
// "Engine does not provide any debug information" => "Engine does not provide any debug information",
"A valid email is mandatory to register" => "Zum Registrieren ist eine gültige E-Mailadresse nötig.",
"{\$customfields[ir].label}" => "{\$customfields[ir].label}",
"{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email address as your log-in name" => "Benutze Deine E-Mail als Login",
"Lowercase only" => "Nur Kleinbuchstaben",
// "New Password" => "New Password",
"Confirm password" => "Passwort wiederholen",
// "Passwords match" => "Passwords match",
"Generate a password" => "Passwort vorschlagen",
"Passcode to register" => "Passwort zum Registrieren",
"Not your password" => "Nicht Dein Passwort",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_title|escape}" => "{\$remarksbox_title|escape}",
// "Do you really want to remove the %0 scheduler" => "Do you really want to remove the %0 scheduler",
// "Reset the scheduler, will mark this run as failed, allowing it to be executed again" => "Reset the scheduler, will mark this run as failed, allowing it to be executed again",
// "Back to schedulers list" => "Back to schedulers list",
// "Reversal Event" => "Reversal Event",
// "Unique Name" => "Unique Name",
// "Type (e.g. user)" => "Type (e.g. user)",
// "Field value (e.g. user)" => "Field value (e.g. user)",
// "Pt. value" => "Pt. value",
"The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "Die Dokumente werden nach Relevanz sortiert ausgegeben, abhängig von Reihenfolge, Nähe, Häufigkeit von Begriffen. ",
"Default search behavior" => "Standard Suchverhalten",
"By default, all search terms are <em>optional</em>." => "Standardmäßig sind alle Suchbegriffe <em>optional</em>.",
"It behaves like an OR logic." => "Dieses Verhalten entspricht der ODER-Logik.",
"Objects that contain the more terms are rated higher in the results and will appear first" => "Objekte, die mehr Begriffe enthalten, werden in den Ergebnissen höher bewertet und daher weiter oben erscheinen",
"For example, <strong>wiki forum</strong> will find:" => "Zum Beispiel, <strong>Wiki Forum</strong> wird finden:",
"objects that include both tokenized terms" => "Objekte, die beide tokenisierte Begriffe enthalten",
"objects that include the term <strong>wiki</strong>" => "Objekte, die den Ausdruck <strong>Wiki</strong> enthalten",
"objects that include the term <strong>forum</strong>" => "Objekte, die den Ausdruck <strong>Forum</strong> enthalten",
"Boolean operators" => "Boole'sche Operatoren",
"You can use AND or OR or NOT also to do a boolean search" => "Du kannst auch AND oder OR oder NOT für eine Bool'sche Suche benutzen",
"Example: <strong>wiki and forum</strong> will find objects with both terms" => "Beispiel: <strong>wiki und forum</strong> findet Objekte mit beiden Begriffen",
"Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Beispiel: <strong>wiki oder forum</strong> findet Objekte mit einem der beiden Begriffe",
"Grouping terms" => "Begriffe gruppieren",
"Use parenthesis ( ) to group terms into subexpressions." => "Benutze Klammern ( ) um Begriffe in Unterausdrücke zu gruppieren.",
"Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Beispiel: <strong>wiki und (forum blog)</strong> findet Objekte, die <strong>wiki</strong> und <strong>forum</strong> oder <strong>wiki</strong> und <strong>blog</strong> enthalten, wobei die Reihenfolge beliebig sein kann",
"Finding phrases" => "Phrasen finden",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other" => "Benutze Anführungszeichen (<kbd>\" \"</kbd>), um einen Satz um die Begriffe genau in der angegebenen Reihenfolge zu finden",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Beispiel: <kbd>\"Alex Bell\"</kbd> findet nicht <strong>Bell Alex</strong> oder <strong>Alex G. Bell</strong> aber <strong>Alex Bells</strong>. ",
// "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it" => "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it",
// "media image" => "media image",
// "Expand table" => "Expand table",
// "Restore layout" => "Restore layout",
"Items found:" => "Gefundene Objekte: ",
"Indexed" => "Indexierung",
"Queue size" => "Größe Warteschlange",
// "Batch Size" => "Batch Size",
// "Process %0" => "Process %0",
// "Process Batch" => "Process Batch",
"Your index was last fully rebuilt on %0" => "Ihr Index wurde zuletzt völlig neuerstellt am %0",
"version" => "Version",
// "Fallback search engine" => "Fallback search engine",
// "Fallback search index was rebuild" => "Fallback search index was rebuild",
// "Fallback search index was not rebuilt" => "Fallback search index was not rebuilt",
// "Execution Statistics" => "Execution Statistics",
// "Current Memory usage" => "Current Memory usage",
// "Memory peak usage before indexing" => "Memory peak usage before indexing",
// "Memory peak usage after indexing" => "Memory peak usage after indexing",
// "Number of queries" => "Number of queries",
// "Rebuilding index.." => "Rebuilding index..",
// "Enable logging" => "Enable logging",
// "Log file is saved as %0" => "Log file is saved as %0",
// "Rebuild" => "Rebuild",
// "Process Queue" => "Process Queue",
// "Indexing Problems" => "Indexing Problems",
// "If the indexing does not complete, check the log file to see where it ended" => "If the indexing does not complete, check the log file to see where it ended",
// "Last line of log file (web)" => "Last line of log file (web)",
// "Last line of log file (console)" => "Last line of log file (console)",
// "Not enough memory" => "Not enough memory",
// "Time limit too short" => "Time limit too short",
// "High resource usage" => "High resource usage",
// "Command Line Utilities" => "Command Line Utilities",
// "Cache Expired" => "Cache Expired",
// "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over" => "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over",
"Index" => "Index",
// "Defined" => "Defined",
"Valid" => "Gültig",
// "May not work or corrupt data" => "May not work or corrupt data",
// "Alter" => "Alter",
// "No instances configured" => "No instances configured",
// "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes" => "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes",
// "Create Index" => "Create Index",
// "Return to List of Saved Searches" => "Return to List of Saved Searches",
// "Do you really want to remove the %0 saved search" => "Do you really want to remove the %0 saved search",
// "Other Queries" => "Other Queries",
// "No stored queries" => "No stored queries",
"Create New" => "Erstelle neu",
// "This will help you recognize your stored queries if ever you want to modify or remove them" => "This will help you recognize your stored queries if ever you want to modify or remove them",
// "Use Existing" => "Use Existing",
"{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Relevance:" => "Relevanz:",
"Last modification:" => "Letzte Änderung:",
// "No pages matched the search criteria test" => "No pages matched the search criteria test",
"Download Log File" => "Lade Log-Datei herunter",
// "Resend newsletter" => "Resend newsletter",
"Send Newsletter" => "Newsletter versenden",
// "Send newsletter" => "Send newsletter",
// "This content is licensed under the terms of the" => "This content is licensed under the terms of the",
"To edit the copyright notices" => "Zum Bearbeiten der Copyright-Hinweise",
// "Know the username" => "Know the username",
"%0 has been accepted" => "%0 wurde angenommen",
// "Do you really want to approve %0" => "Do you really want to approve %0",
// "Do you really want to remove %0" => "Do you really want to remove %0",
// "No friends have been added" => "No friends have been added",
// "Incoming requests" => "Incoming requests",
// "Accept and add" => "Accept and add",
// "Still waiting for approval" => "Still waiting for approval",
// "Do you really want to cancel request for %0" => "Do you really want to cancel request for %0",
"%0 has been removed from your friends" => "%0 wurde aus Deinem/Ihrem Freundeskreis entfernt ",
"Page alias.." => "Seiten-Alias..",
"Monitor the Sub-Structure" => "Sub-Struktur beobachten",
"Stop Monitoring the Sub-Structure" => "Beobachtung Sub-Struktur beenden",
"locked by %0" => "gesperrt von %0",
"Locked" => "Gesperrt",
"Edit page" => "Seite bearbeiten",
"Add new child page" => "Füge neue Kind-Seite hinzu",
// "About &amp; News" => "About &amp; News",
// "Information and introduction portal" => "Information and introduction portal",
"Documentation" => "Dokumentation",
// "How to use Tiki" => "How to use Tiki",
// "Development" => "Development",
// "How make Tiki" => "How make Tiki",
// "Forums and general community information" => "Forums and general community information",
// "How make Tiki look pretty" => "How make Tiki look pretty",
// "Manage" => "Manage",
// "Initializite this format with the current tracker fields" => "Initializite this format with the current tracker fields",
// "Tracker Name" => "Tracker Name",
// "File Delimiter" => "File Delimiter",
// "Comma (,)" => "Comma (,)",
// "Semicolon (;)" => "Semicolon (;)",
// "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes" => "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes",
// "Field Type" => "Field Type",
// "Primary Key" => "Primary Key",
// "PK" => "PK",
// "Unique Key" => "Unique Key",
// "UK" => "UK",
// "Read-Only" => "Read-Only",
// "RO" => "RO",
// "Export-Only" => "Export-Only",
// "EO" => "EO",
// "Required to import data. Can be any field as long as it is unique" => "Required to import data. Can be any field as long as it is unique",
// "Impose unique value requirement for the target column. This only works with Transactional Import feature" => "Impose unique value requirement for the target column. This only works with Transactional Import feature",
// "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process" => "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process",
// "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict" => "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict",
// "Simple headers" => "Simple headers",
// "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format" => "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format",
// "Import updates" => "Import updates",
// "Import update" => "Import update",
// "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported" => "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported",
// "Ignore blanks" => "Ignore blanks",
// "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way" => "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way",
// "Transactional import" => "Transactional import",
// "Import transaction" => "Import transaction",
// "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved" => "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved",
// "Bulk import" => "Bulk import",
// "Bulk Import" => "Bulk Import",
// "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent" => "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent",
"Are you sure you want to delete this item" => "Bist Du sicher, dass Du diesen Eintrag entfernen willst",
"Delete item" => "Eintrag entfernen",
// "Select a field.." => "Select a field..",
// "Select Mode" => "Select Mode",
// "No primary key" => "No primary key",
// "Side" => "Side",
// "Filters will be available in partial export menus" => "Filters will be available in partial export menus",
// "Skip Unmodified" => "Skip Unmodified",
// "Will not re-import items that have not changed" => "Will not re-import items that have not changed",
// "Import Completed" => "Import Completed",
// "Your import was completed succesfully" => "Your import was completed succesfully",
"CSV File" => "CSV Datei",
// "Applied filters" => "Applied filters",
// "Create Tracker from File" => "Create Tracker from File",
// "Export Full" => "Export Full",
// "Export Partial" => "Export Partial",
// "Export Custom" => "Export Custom",
// "No tabular formats defined" => "No tabular formats defined",
// "Modes" => "Modes",
"This book" => "Dieses Buch",
"Start date" => "Startdatum",
"before" => "vorher",
"after" => "dahinter",
"don't display" => "nicht anzeigen",
"Decimals" => "Dezimalstellen",
"Decimal Point" => "Dezimalpunkt",
"Auto Tax" => "Steuerautomatik",
"Tasks" => "Aufgaben",
"Book new entries" => "Buchen",
"Confirm stack entries" => "Bestätige Stapeleinträge",
"Book into Stack" => "Buche in Stapel",
"Accounts" => "Konten",
"Journal" => "Journal",
"Fetch all" => "Alle abrufen",
"Create new account" => "Erstelle ein neues Konto",
"Edit Account" => "Konto bearbeiten",
"Account number" => "Kontonummer",
"Notes" => "Notizen",
"Budget" => "Budget",
"Create account" => "Erstelle Konto",
"Modify account" => "Konto bearbeiten",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1",
"Delete this account" => "Lösche dieses Konto",
"Back to book page" => "Zurück zur Buchungsseite",
"Account" => "Konto",
"Debit" => "Debitor",
"Credit" => "Kreditor",
"Tax" => "Steuer",
// "Unlock account" => "Unlock account",
// "Lock account" => "Lock account",
// "Remove account" => "Remove account",
"Create a new account" => "Erstelle ein neues Konto",
"printable version" => "druckbare Version",
"export table" => "Tabelle exportieren",
"View account" => "Konto ansehen",
"Edit this account" => "Bearbeite dieses Konto",
"My books" => "Meine Bücher",
"Tax automation" => "Steuerautomatik",
"hide" => "verstecken",
"behind" => "dahinter",
// "Close book" => "Close book",
// "Close book? (This action cannot be undone)" => "Close book? (This action cannot be undone)",
"Create a book" => "Erstelle ein Buch",
"Book properties" => "Bucheigenschaften",
"Name of the book" => "Name des Buches",
"First date in journal" => "Erstes Datum im Journal",
"Last date in journal" => "Letztes Datum im Journal",
"Currency settings" => "Währungseinstellungen",
"Currency (up to 3 letters) " => "Währung (bis zu 3 Buchstaben) ",
"Position of the currency " => "Position des Währungszeichens",
"Show no currency" => "Zeige kein Währungszeichen",
"Show currency in front of numbers" => "Zeige Währungszeichen vor den Beträgen",
"Show currency behind numbers" => "Zeige Währungszeichen hinter den Beträgen",
"Decimal point" => "Dezimaltrennzeichen",
"Decimal" => "Dezimal",
"Quote strings with" => "Trenne Text mit",
"End of Line" => "Zeilenende",
"Carriage return" => "Wagenrücklauf (carriage return)",
"Line feed" => "Zeilenvorschub (line feed)",
"Carriage Return/Line feed" => "Wagenrücklauf/Zeilenvorschub (carriage Return/line feed)",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
"Allow automatic tax calculation" => "Erlaube automatische Steuerberechnung",
"Create a new book" => "Erstelle ein neues Buch",
// "Canceled Journal" => "Canceled Journal",
// "Booking Date" => "Booking Date",
"Amount" => "Betrag",
"Book a transaction" => "Buche einen Geschäftsvorfall",
// "\"}Delete account %0" => "\"}Delete account %0",
"Add entry" => "Eintrag hinzufügen",
"Book" => "Buchen",
// "\"}Record entry in book %0" => "\"}Record entry in book %0",
"Export {\$what}" => "Exportiere {\$what}",
"Export CSV settings" => "Exportiere CSV Einstellungen",
"Separator between fields" => "Feldertrennzeichen",
"Quote character for text" => "Anführungszeichen für Text",
"Export as CSV" => "Exportiere als CSV",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1",
// "Cancel transaction" => "Cancel transaction",
"Balance" => "Balance",
"Deleted" => "Gelöscht",
"Debit Account" => "Debitorenkonto",
"Debit Amount" => "Debitorenbetrag",
"Debit Text" => "Debitorentext",
"Credit Account" => "Kreditorenkonto",
"Credit Amount" => "Kreditorenbetrag",
"Credit Text" => "Kreditorentext",
"Book a transaction into the stack" => "Buche einen Geschäftsvorfall in einen Buchungsstapel",
// "\"}Record stack entry in book %0" => "\"}Record stack entry in book %0",
// "\"}Modify stack entry in book %0" => "\"}Modify stack entry in book %0",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1",
// "Remove transaction" => "Remove transaction",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1",
// "Confirm transaction" => "Confirm transaction",
"Do not group by item" => "Nicht nach Objekt gruppieren",
"Group by item" => "Gruppiere nach Objekt",
"Calendar View" => "Kalenderansicht",
"Tiki Action Calendar" => "Tiki Aktionenkalender",
"Tools Calendars" => "Kalendereinträge",
"Check / Uncheck All" => "Alle (ent)markieren",
// "Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>" => "Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>",
"Database Version Problem" => "Datenbank Versionsproblem",
// "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "Vendor folder issues" => "Vendor folder issues",
// "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>" => "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>",
// "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded" => "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded",
// "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries" => "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries",
// "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>" => "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>",
// "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file" => "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file",
// "Installer not locked" => "Installer not locked",
// " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. " => " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. ",
// "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder" => "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder",
// "You can also use the following, on the command line, from the root of your Tiki installation" => "You can also use the following, on the command line, from the root of your Tiki installation",
// "Search Index outdated" => "Search Index outdated",
// "The search index might be outdated. It is recommended to rebuild the search index" => "The search index might be outdated. It is recommended to rebuild the search index",
// "File gallery directory web accessable" => "File gallery directory web accessable",
// "This is a potential security risk" => "This is a potential security risk",
// "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database" => "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database",
// "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>" => "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>",
"Please select some actions to be reported." => "Bitte wähle Aktionen aus, die berichtet werden sollen.",
"End" => "Ende",
"Users and Groups" => "Benutzer und Gruppen",
"Misc." => "Verschiedenes.",
"Units" => "Einheiten",
"kb" => "kB",
// "Contribution Time" => "Contribution Time",
"Graph Contributions" => "Zeige Grafik",
"Group Bar Plot" => "Gruppen-Balkendiagramm",
"Accumulated Bar Plot" => "Kummuliertes Balkendiagramm",
"Background color" => "Hintergrundfarbe",
"{\$color}" => "{\$color}",
"Legend background color" => "Hintergrundfarbe Legende",
"Save graphs to image gallery" => "Speichere Graphik zur Bildergalerie",
"Records:" => "Gespeichert:",
"See Statistics" => "Statistiken einsehen",
"contribution" => "Mitwirkung",
"contributor" => "Beitragender",
"{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
"{\$actionlog.objectType}" => "{\$actionlog.objectType}",
"{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Delete action from log" => "Delete action from log",
// "Select action to perform with checked" => "Select action to perform with checked",
// "Delete selected actions from log" => "Delete selected actions from log",
"Edit Action" => "Bearbeite Aktion",
"Save Action" => "Speichere Aktion",
"Statistics" => "Statistiken",
"Volumes are equally distributed on each contributors/author" => "Volumen werden auf jeden Beitragenden/Autor gleich verteilt",
"connection time" => "Verbindungszeit",
"connection seconds" => "Verbindung in Sekunden",
"mns" => "Minuten",
"Volume per category" => "Umfang pro Kategorie",
"Volume per category and per user" => "Umfang pro Kategorie und pro Benutzer",
"Number of actions per user" => "Anzahl von Aktionen pro Benutzer",
"Total number of users:" => "Gesamtzahl von Benutzern:",
"Number of actions per object" => "Anzahl von Aktionen pro Objekt",
"Total number of objects:" => "Gesamtanzahl von Objekten:",
// "Bigbluebutton" => "Bigbluebutton",
// "Time in bigbluebutton (in minutes)" => "Time in bigbluebutton (in minutes)",
"Number of actions per category" => "Anzahl von Aktionen pro Kategorie",
"Number of actions per category and per user" => "Anzahl von Aktionen pro Kategorie und pro Benutzer",
"Volume per the users' group and per contribution" => "Volumen pro Gruppe des Benutzers und pro Beitrag",
"Volume per group and per contribution" => "Volumen pro Gruppe und pro Beitrag",
"Volume per user and per contribution" => "Volumen pro Benutzer und pro Beitrag",
"Volume per users' contribution and time" => "Volumen pro Benutzerbeitrag und Zeit",
"Volume per contribution and time" => "Volumen pro Beitrag und Zeit",
"Weeks" => "Wochen",
"How" => "Wie es geht",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded." => "Du musst das Feld 'aufgezeichnet' für jeden Aktionstyp daraufhin prüfen, ob Du hierüber später einen Bericht haben willst. Um einen Bericht von einigen Aktionstypen zu erhalten, klicke das 'berichtet'-Feld dieser Aktionstypen, gehe auf den Tab Bericht und wähle zusätzliche Filter. Der Bericht wird nur die Aktionen beinhalten, die entstanden sind, nachdem der Aktionstyp auf 'aufgezeichnet' gesetzt wurde.",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Wiki-Aktionen außer 'hat angesehen' werden immer gespeichert, gehen aber nicht in Berichte ein.",
"Recorded" => "Aufgezeichnet",
"{\$actionlog.action}" => "{\$actionlog.action}",
"Import as CSV" => "Importiere als CSV",
"Banning rules have been updated" => "Verbannungsregeln wurden aktualisiert",
"Add or edit rules" => "Regeln hinzufügen oder bearbeiten",
"Rule title" => "Regelbezeichnung",
"Username regex matching" => "Übereinstimmung regulärer Ausdruck Benutzernamen (regex)",
"Multiple IP regex matching" => "Übereinstimmung regulärer Ausdruck multiple IPs (regex)",
"IP regex matching" => "Übereinstimmung regulärer Ausdruck IPs (regex)",
// "Banned from sections" => "Banned from sections",
"{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Sperrung über Zeitraum",
"Rule active from" => "Regel gültig von",
"Rule active until" => "Regel gültig bis",
"Custom message to the user" => "Spezielle Nachricht für den Benutzer",
"Import rules as CSV" => "Regeln als CSV importieren",
"Column names on the first line" => "Spaltennamen in der ersten Linie",
"Sections format" => "Abschnittsformat",
"section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "Abschnittsnamen werden durch Senkrechtstriche getrennt. Um ein Beispiel zu sehen und es als Vorlage zu benutzen, füge eine Regel von Hand hinzu und exportiere sie als CSV",
"See" => "Siehe",
"Import as new rules" => "Als neue Regeln importieren",
"Find:" => "Suche:",
// "Current rules" => "Current rules",
"x" => "X",
// "Delete selected banning rules" => "Delete selected banning rules",
"User/IP" => "Benutzername/IP",
// "Delete banning rule" => "Delete banning rule",
// "No rules found" => "No rules found",
"Admin Calendars" => "Kalender verwalten",
"Create Calendar" => "Erstelle Kalender",
"View Calendars" => "Kalender ansehen",
"Calendar name" => "Kalendername",
"Participants" => "Teilnehmer",
// "Personal" => "Personal",
// "Field will show in popup" => "Field will show in popup",
"Custom location" => "Persönliche Örtlichkeiten",
"Custom participants" => "Persönliche Teinehmer",
// "Custom languages" => "Custom languages",
"Add event" => "Ereignis hinzufügen",
// "Delete calendar" => "Delete calendar",
"Edit Calendar" => "Kalender bearbeiten",
// "Custom classification" => "Custom classification",
"Custom language" => "Persönliche Sprache",
"Custom subscription list" => "Persönliche Abo-Liste",
"Custom priority" => "Persönliche Prioritäten",
"Personal Calendar" => "Persönlicher Kalender",
"Start of day" => "Start des Tages",
"End of day" => "Ende des Tages",
"Days to display" => "Anzuzeigende Tage",
"Standard color" => "Standardfarben",
"Green" => "Grün",
"Purple" => "Violett",
"Orange" => "Orange",
"Yellow" => "Gelb",
"Custom foreground color" => "Standardvordergrundfabe",
"Custom background color" => "Standardhintergrundfarbe",
"Default event status" => "Standardstatus für Ereignis",
// "Show in popup view" => "Show in popup view",
"Show in calendar view" => "Zeige in Kalenderansicht",
"Group of users alerted when calendar event is modified" => "Benutzergruppe die benachrichtigt wird, wenn ein Kalendereintrag verändert wird",
"Default length of events is all day" => "Standardereignis für den ganzen Tag",
"Event name on each day in calendar view" => "Ereignisname für jeden Tag in der Kalenderansicht",
"Delete events older than:" => "Lösche Ereignisse, die älter sind als",
// "Delete old events" => "Delete old events",
"Browse the category system" => "Kategoriesystem durchstöbern",
// "Create category" => "Create category",
// "Edit category" => "Edit category",
"Edit this category:" => "Diese Kategorie bearbeiten:",
"Add new category" => "Neue Kategorie hinzufügen",
"Apply parent category permissions" => "Wende übergeordnete Kategorie an",
"Objects in category" => "Objekte in Kategorie",
// "Remove from this category" => "Remove from this category",
// "Remove object from category" => "Remove object from category",
"{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Remove checked" => "Remove checked",
// "Remove objects from category" => "Remove objects from category",
// "Moving objects" => "Moving objects",
"Moving objects between categories" => "Objekte zwischen Kategorien verschieben",
"Current category" => "Aktuelle Kategorie",
// "Perform an action on all objects in the current category" => "Perform an action on all objects in the current category",
// "Unassign objects from category" => "Unassign objects from category",
// "Move to selected category" => "Move to selected category",
// "Choose destination category" => "Choose destination category",
// "Copy to selected category" => "Copy to selected category",
// "Add objects" => "Add objects",
"Add objects to category" => "Objekte zu Kategorie hinzufügen",
"Objects" => "Objekte",
"Quiz" => "Quiz",
"Batch upload" => "Stapelhochladen",
// "Sample file content" => "Sample file content",
// "Content templates" => "Content templates",
"Templates" => "Vorlagen",
"Visible in no sections" => "In keinem Abschnitt sichtbar",
"Remove section" => "Entferne Abschnitt",
// "Uncategorized" => "Uncategorized",
// "{\$catName}" => "{\$catName}",
// "Remove template" => "Remove template",
"Edit template" => "Vorlage bearbeiten",
// "Create template" => "Create template",
"Use the Administration page of each enabled feature to allow the use of content templates." => "Benutze die Verwaltungsseite jeder einzelnen Funktion, um zu erlauben Inhaltsvorlagen zu nutzen.",
"Name field is mandatory" => "Namenfeld ist zwingend",
"No features are configured to use templates" => "Keine Funktionen sind zur Benutzung von Vorlagen konfiguriert",
// "Template Type" => "Template Type",
"Text area" => "Textbereiche",
"Admin Contributions" => "Beteiligungslisten verwalten",
"Edit the contribution:" => "Beitrag bearbeiten:",
"Contributions are mandatory in wiki pages" => "Angabe bei Wikiseiten zwingend",
"Contributions are mandatory in forums" => "Angabe bei Foreneinträgen zwingend",
"Contributions are mandatory in comments" => "Angabe bei Kommentaren zwingend",
"Contributions are mandatory in blogs" => "Angabe bei Blogeinträgen zwingend",
"Contributions are displayed in the comment/post" => "Beteiligung wird in Kommentar/Beitrag angezeigt",
"Create a new contribution" => "Neue Beteiligungsliste erstellen",
"List of contributions" => "Übersicht der Beteiligungslisten",
// "Remove contribution" => "Remove contribution",
"Admin cookies" => "Cookies verwalten",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Cookies hinzufügen/bearbeiten",
"Upload Cookies from textfile" => "Cookies aus Textdatei hochladen",
// "Upload from disk" => "Upload from disk",
"Remove all cookies" => "Alle Cookies löschen",
"cookie" => "Cookie",
// "Remove cookie" => "Remove cookie",
"Manage Credits" => "Kredit verwalten",
"(YYYY-MM-DD HH:MM:SS)" => "(JJJJ-MM-TT HH:MM:SS)",
"(level credits always 0)" => "(Level Credits immer 0)",
"Delete Checked" => "Lösche Geprüfte",
"User Credits Expiry Summary (Plans)" => "Zusammenfassung Verfall User Credits (Pläne)",
"User Plan" => "Benutzerplan",
"Start of Latest Plan" => "Start des letzten Plans",
"Start of Next Plan" => "Start des nächsten Plans",
"Expiry" => "Ablauf",
"Use User Credits" => "Benutze User Credits",
"Restore User Level Credits" => "Benutzer Level Credits wiederherstellen",
"Historical Usage Report" => "Bericht über frühere Benutzung",
"all types" => "alle Typen",
"filter" => "Filtern",
"Usage Date" => "Gebrauchsdatum",
"Amount Used" => "Benutzte Menge",
"No such user" => "Kein solcher Benutzer",
"Manage Credit Types" => "Kredittypen verwalten",
"Display Text" => "Anzeigetext",
"Unit Text" => "Einheit",
"Is Static Level Credit" => "Ist das statischer Level Credit?",
"Display Bar Length Scaling Divisor" => "Divisor für Anzeigebalken",
"Purge Expired and Used Credits (All Users)" => "Abgelaufene und benutzte Credits (alle Benutzer) löschen",
"Purge" => "Löschen",
"Admin Content Sources" => "Verwalte Inhaltsquellen",
"Use Admin DSN to define the database to be used by the SQL plugin" => "Benutze DSN verwalten, um die Datenbank zu definieren, die vom SQL-Plugin benutzt wird",
"Create/edit DSN" => "Erzeuge/bearbeite DSN",
"Local (Tiki database)" => "Lokal (Tiki Datenbank)",
"See db/local.php" => "Siehe db/local.php",
// "Remove DSN" => "Remove DSN",
"Content Authentication" => "Inhalts-Authentifikation",
"Identification" => "Identifikation",
"HTTP Basic" => "HTTP Basic",
"HTTP Session / Login" => "HTTP Sitzung / Login",
"HTTP Session / Visit" => "HTTP Sitzung / Besuch",
"Admin External Wikis" => "Verwalte externe Wikis",
"Create/Edit External Wiki" => "Externes Wiki erstellen/bearbeiten",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (\$page benutzen und mit dem Wiki Seitennamen ersetzen, z.B.: http://qum74.mms-dresden.telekom.de/tiki/tiki-index.php?page=\$page)",
// "<em>[prefix]</em>main, such as tiki_main" => "<em>[prefix]</em>main, such as tiki_main",
// "Search as" => "Search as",
// "Leave blank to search using currently active groups" => "Leave blank to search using currently active groups",
"ExtWiki" => "ExtWiki",
// "Search As" => "Search As",
// "Remove external wiki" => "Remove external wiki",
"Admin Forums" => "Foren verwalten",
// "Create Forum" => "Create Forum",
"Age" => "Alter",
"PPD" => "PPT",
"Create/Edit Forums" => "Foren hinzufügen/bearbeiten",
"Edit this Forum:" => "Dieses Forum bearbeiten:",
"Create New Forum" => "Neues Forum erstellen",
// "Main details" => "Main details",
// "Image symbolizing the forum" => "Image symbolizing the forum",
"Only allow replies to the first message (flat forum)" => "Nur Antworten auf den ersten Beitrag erlauben (flaches Forum)",
"Moderator user" => "Moderator",
"Moderator group" => "Moderatorengruppe",
"Password protected" => "mit Passwort gesichert",
"Forum password" => "Foren-Passwort",
"Prevent flooding" => "Flooding verhindern",
"Minimum time between posts" => "Minimale Zeit zwischen zwei Beiträgen",
"Send the posts of this forum to this email address" => "Beiträge in diesem Forum an E-Mailadresse weiterleiten",
"Prune unreplied-to messages after" => "Nicht beantwortete Nachrichten löschen nach",
"Prune old messages after" => "Alte Nachrichten löschen nach",
// "Forum-mailing list synchronization" => "Forum-mailing list synchronization",
"Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address" => "Nachrichten in dieses Forum an die angegebene E-Mailadresse weiterleiten in einem Format, das Rückantworten ins Forum erlaubt",
"Send emails even when the post is generated by an inbound email" => "Nachrichten auch schicken, wenn das Posting per E-Mail getätigt wurde",
"Append a reply link to outbound mails" => "Antwort-Link an ausgehende Nachrichten anhängen",
"Originating email address for emails from this forum" => "Absenderadresse für Nachrichten aus diesem Forum",
"Add messages from this email to the forum" => "Nachrichten von dieser E-Mailadresse in das Forum weiterleiten",
"POP3 server" => "POP3 Server",
// "Forums list" => "Forums list",
"Display last post titles" => "Neueste Beitragstitel anzeigen",
// "Forum topics (threads) list" => "Forum topics (threads) list",
"Default order of topics" => "Standardsortierung für Themen",
"Topics per page" => "Themen pro Seite",
"Topic list configuration" => "Einstellungen Themenliste",
"Last post title" => "Titel letzter Eintrag",
"Last post profile picture" => "Avatar letzter Eintrag",
"Author profile picture" => "Autor Avatar",
"Use topic smileys" => "Smilies für Themen benutzen",
"Show topic summary" => "Themenzusammenfassung anzeigen",
// "Forum threads" => "Forum threads",
// "Default ordering of threads" => "Default ordering of threads",
// "Default style of threads" => "Default style of threads",
"Approval type" => "Bestätigung nötig für",
// "Topic Rating" => "Topic Rating",
"User Level" => "Benutzerlevel",
"eMail" => "E-Mail",
"Online" => "Online",
"Permission" => "Berechtigung",
// "Store attachments in" => "Store attachments in",
// "File system" => "File system",
"Max attachment size (bytes)" => "Maximale Größe (Bytes)",
"Shows number of attachments of the all thread in forum list" => "Zeige Anzahl der Anhänge aller Threads in der Forenliste",
"Duplicate Forum" => "Forum kopieren",
"Admin Hotwords" => "Hotwords verwalten",
"Add Hotword" => "Hotword hinzufügen",
"Word" => "Wort",
// "Delete hotword" => "Delete hotword",
"Admin HTML Page Dynamic Zones" => "Verwalte HTML-Seite dynamische Zonen",
"Admin HTML pages" => "HTML-Seiten verwalten",
"Edit zone" => "Bereiche bearbeiten",
"Dynamic zones" => "Dynamische Bereiche",
"zone" => "Bereich",
"content" => "Inhalt",
"Mass update" => "Massenaktualisierung",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Benutze {literal}{ed id=name}{/literal} oder {literal}{ted id=name}{/literal}, um dynamische Zone einzufügen",
"Create new HTML page" => "Neue HTML-Seite erstellen",
"Edit this HTML page:" => "Diese HTML-Seite bearbeiten:",
"Apply template" => "Vorlage anwenden",
"{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dynamisch",
"Static" => "Statisch",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
"Last Modif" => "Letzte Änderung",
"Admin dynamic zones" => "Verwalte dynamische Zonen",
// "Remove HTML page" => "Remove HTML page",
// "IDS Rules" => "IDS Rules",
// "Add a new Rule" => "Add a new Rule",
// "Rule ID" => "Rule ID",
// "Impact" => "Impact",
// "Edit rule settings" => "Edit rule settings",
// "Edit Rule" => "Edit Rule",
// "Add a new rule" => "Add a new rule",
// "Rule Id" => "Rule Id",
// "Rule Id must be numeric" => "Rule Id must be numeric",
// "Rule Regex" => "Rule Regex",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository:" => "Repository bearbeiten:",
"Create New Repository" => "Neues Repository erstellen",
"Human-readable repository name" => "Repository-Name in Klartext",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Pfad zum Repository (lokales Dateisystem: relatives/absolutes Web-Root, nicht Lokal: mit dem Präfix \"http://\")",
"File name of start page" => "Dateiname der Startseite",
"Start page" => "Startseite",
"CSS file to load when browse this repository" => "Zu ladende CSS Datei, wenn dieses Repository durchstöbert wird",
"CSS File" => "CSS-Datei",
"Is repository visible to users" => "Ist Repository für Benutzer sichtbar",
"Can files from repository be cached" => "Können Dateien aus dem Repository gecached werden",
"Cacheable" => "cachebar",
"Clear all cached pages of this repository" => "Lösche alle gecachten Seiten dieses Repositories",
"Clear cache" => "Cache leeren",
"Seconds count 'till cached page will be expired" => "Sekundenzähler bis die gecachte Seite abgelaufen ist",
"Cache expiration" => "Cache Verfallszeit",
"Human-readable text description of repository" => "Repository-Beschreibung in Klartext",
"Available Repositories" => "Vorhandene Repositories",
"Edit rules" => "Regeln bearbeiten",
"Edit Rules for Repository:" => "Regeln ändern für Repository:",
"Configure Repositories" => "Repositories konfigurieren",
"List Repositories" => "Repositories auflisten",
"Configure this Repository" => "Dieses Repository konfigurieren",
"View this Repository" => "Repository ansehen",
"New Rule" => "Neue Regeln",
"Copy Rules" => "Regeln kopieren",
"view/hide copy rules dialog" => "zeige/verstecke Regeln-kopieren-Dialog",
"Source repository" => "Quellen-Repository",
// "Rules will be applied in this order ('0' or empty = auto)" => "Rules will be applied in this order ('0' or empty = auto)",
"Rule order" => "Reihenfolge der Regeln",
"Text to search for" => "Zu suchender Text",
"Text to replace" => "Zu ersetzender Text",
"Is this regular expression or simple search/replacer" => "Ist dies ein regulärer Ausdruck (regex) oder ein einfaches Suchen/Ersetzen",
"Regex" => "Regex (regulärer Ausdruck)",
"Is case sensitive (for simple replacer)" => "Ist abhängig von Groß-/Kleinschreibung (für einfachen Ersetzer)",
"Case sensitive" => "Groß-/Kleinschreibung beachten",
// "subset of chars: imsxeADSXUu, which are regex modifiers" => "subset of chars: imsxeADSXUu, which are regex modifiers",
"Regex modifiers" => "Regex-Modifizierer",
"Human-readable text description of rule" => "Textbeschreibung der Regel in Klartext",
"Check to enable this rule" => "Haken setzen, um diese Regel zu aktivieren",
"Preview options" => "Vorschau-Einstellungen",
"Apply all rules or just this to generate preview" => "Alle Regeln anwenden oder nur diese, um eine Vorschau zu erstellen",
"Apply all rules" => "Alle Regeln anwenden",
"View source code after rules applied" => "Quellcode einsehen, nachdem Regeln angewendet wurden",
"Code preview" => "Code-Vorschau",
"Generate HTML preview" => "HTML-Vorschau erstellen",
"HTML preview" => "HTML-Vorschau",
"Test file from repository to generate preview for (empty = configured start page)" => "Testdatei aus dem Repository, um eine Vorschu zu erstellen für (leer = konfigurierte Startseite)",
"Preview Results" => "Vorschau der Ergebnisse",
"Rules List" => "Regelliste",
"Case" => "Fall",
"Admin Invoices" => "Rechnungen verwalten",
"Admin keywords" => "Verwalte Schlüsselwörter",
"Edit page keywords" => "Bearbeite Seitenschlüsselwörter",
"Current Page Keywords" => "Gegenwärtige Seitenschlüsselwörter",
"Search by page" => "Suche nach Seite",
"results found" => "Ergebnisse gefunden",
// "Remove keywords for this page" => "Remove keywords for this page",
"No pages found" => "Keine Seiten gefunden",
// "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Positionen nach Zugriffen vergeben",
"List of featured links" => "Liste vorhandener Linktips",
// "Remove featured link" => "Remove featured link",
"Add Featured Link" => "Linktip hinzufügen",
"Edit this Featured Link:" => "Diesen Linktip bearbeiten:",
"Create new Featured Link" => "Neuen Linktip anlegen",
"disables the link" => "deaktiviert den Link",
"Link type" => "Linktyp",
"replace current page" => "Aktuelle Seite ersetzen",
"framed" => "umrahmt",
"open new window" => "Neues Fenster öffnen",
"Mail-in accounts" => "Mail-in-Konten",
// "Allow" => "Allow",
// "Leave" => "Leave",
// "Auto-category" => "Auto-category",
// "Auto-namespace" => "Auto-namespace",
"Administrator" => "Administrator",
// "Admin Mail-in Routes" => "Admin Mail-in Routes",
"Check Mail-in accounts" => "Mail-in-Konten prüfen",
"Check automatically" => "Automatisch überprüfen",
"Frequency" => "Frequenz",
// "Check Manually Now" => "Check Manually Now",
// "Admin Mail-in routes" => "Admin Mail-in routes",
// "Structure Routing" => "Structure Routing",
// "Wiki structures feature is not enabled" => "Wiki structures feature is not enabled",
// "List Menus" => "List Menus",
"Create menu option" => "Erstelle Menüoption",
// "Edit This Menu" => "Edit This Menu",
// "Export menu options" => "Export menu options",
// "Import menu options" => "Import menu options",
"Manage menu" => "Menü verwalten:",
"Menu options" => "Menüoptionen",
// "Save Options" => "Save Options",
// "New option" => "New option",
// "Check this if the option is an alternative to the previous one" => "Check this if the option is an alternative to the previous one",
// "Drag this on to the menu area below" => "Drag this on to the menu area below",
// "URL or ((page name))" => "URL or ((page name))",
// "Test URL" => "Test URL",
// "Remove Option" => "Remove Option",
"Preview menu" => "Vorschau des Menüs",
// "Deploy" => "Deploy",
// "Menu Options" => "Menu Options",
"RESET" => "ZURÜCKSETZEN",
"Clear Cache" => "Cache leeren",
"Show hidden modules" => "Zeige versteckte Module",
"Hide hidden modules" => "Verberge versteckte Module",
"Exit Modules" => "Modulbearbeitung verlassen",
"Modules Parameters" => "Modulparameter",
"The following required parameters are missing:" => "Es fehlen die nachfolgend genannten notwendigen Parameter:",
"Drag the modules around to re-order then click save when ready" => "Ziehe die Module herum, um sie neu zu ordnen und klicke speichern, wenn Du fertig bist",
"Double click them to edit" => "Doppelklicke sie zum Bearbeiten",
"Modules with \"position: absolute\" in their style can be dragged in to position" => "Module mit der Positionsangabe \"absolute\" können in eine andere Position verschoben werden",
"New modules can be dragged from the \"All Modules\" tab" => "Neue Module können aus dem Tab \"Alle Module\" gezogen werden",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>",
"More info here" => "Hier gibt es weitere Infos",
"Assigned modules" => "Zugewiesene Module",
"Assign/Edit modules" => "Module zuweisen/ändern",
"Assigned Modules" => "Zugewiesene Module",
"Add module" => "Module hinzufügen",
// "You will need to go" => "You will need to go",
// "to reorder or move modules in the left or right columns since you have created a custom order for these" => "to reorder or move modules in the left or right columns since you have created a custom order for these",
// "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user" => "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user",
"Edit module" => "Module bearbeiten",
"Assign new module" => "Neues Modul hinzufügen",
"Edit this assigned module:" => "Dieses zugewiesene Modul bearbeiten:",
"Module Options" => "Moduloptionen",
"Custom Modules" => "Benutzerdefinierte Module",
// "Delete custom module" => "Delete custom module",
"Create new custom module" => "Erstelle ein neues benutzerdefiniertes Modul",
"Edit this custom module" => "Bearbeite dieses benutzerdefinierte Modul",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Parse using" => "Parse using",
// "Wiki Markup" => "Wiki Markup",
"Objects that can be included" => "Objekte, die eingebunden werden können",
"Available polls" => "Verfügbare Abstimmungen",
"Random active poll" => "Zufällige aktive Abstimmung",
"Random current poll" => "Zufällige aktuelle Abstimmung",
// "Use gallery" => "Use gallery",
// "Random image from" => "Random image from",
"Dynamic content blocks" => "Dynamische Inhaltsblöcke",
// "Use dynamic content" => "Use dynamic content",
"External feeds" => "Externe Feeds",
// "Use RSS module" => "Use RSS module",
"Banner zones" => "Bannerzonen",
// "Use banner zone" => "Use banner zone",
// "Use wiki structure" => "Use wiki structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes",
"To use a default Tiki menu:" => "Um ein standard Tikimenü zu benutzen:",
"All Modules" => "Alle Module",
"Show all modules" => "Zeige alle Module",
"Admin newsletter subscriptions" => "Newsletter-Abonnenten verwalten",
"Subscriptions" => "Registrierungen",
"Groups included through inheritance" => "Durch Erbschaft einbezogene Gruppen",
// "Remove subscription" => "Remove subscription",
"Wiki Page Name" => "Wiki Seitenname",
"Validate Addresses" => "Adressen validieren",
"Add To List" => "Zu Liste hinzufügen",
"Subscribed" => "abonniert",
// "Mark subscription as valid" => "Mark subscription as valid",
"Unsubscribed" => "Abbestellt",
// "Remove selected subscriptions" => "Remove selected subscriptions",
"Add subscribers" => "Abonnenten hinzufügen",
"You can add several email addresses by separating them with commas." => "Es können durch Komma getrennt mehrere E-Mailadressen angegeben werden.",
// "Add email" => "Add email",
// "Add user" => "Add user",
// "Users from group" => "Users from group",
"Group subscription also subscribes included groups" => "Gruppenabonnement abonniert ebenso enthaltene Gruppen",
// "Don't send confirmation email" => "Don't send confirmation email",
"The user email will be refreshed at each newsletter sending" => "Die Benutzer E-Mail wird bei jedem gesendeten Newsletter aktualisiert",
"Import emails from file" => "Importiere E-Mails aus einer Datei",
// ".txt file, one email per line" => ".txt file, one email per line",
// "Don't send confirmation emails" => "Don't send confirmation emails",
"Import emails from wiki page" => "Importiere E-Mails von einer Wiki Seite",
"Wiki page, one email per line" => "Wiki Seite, eine E-Mail je Zeile",
// "Import emails from tracker" => "Import emails from tracker",
"Subscribe group" => "Abonniere Gruppe",
"Including group inheritance" => "Einschließlich Gruppenerbschaft",
"Including group, group users and emails will be refreshed at each newsletter sending" => "Eingeschlossene Gruppen, Gruppenbenutzer und E-Mailadressen werden bei jedem neuen Newsletter aktualisiert",
"Use subscribers of another newsletter" => "Benutze Abonnenten eines anderen Newsletters",
"Use emails from wiki page" => "Benutze E-Mail von einer Wiki Seite",
"Wiki page" => "Wiki Seite",
"Emails on a wiki page which will be added at each newsletter sending, one email per line" => "E-Mails auf einer Wiki Seite, die zu jedem Newsletter beigefügt wird. Eine E-Mail je Zeile",
"Don't subscribe emails" => "abonniere nicht E-Mails",
"Export Subscriber Emails" => "Abonnenten E-Mails exportieren",
"Admin newsletters" => "Newsletter verwalten",
"List Newsletters" => "Newsletter auflisten",
"Send Newsletters" => "Newsletter versenden",
"Editions" => "Ausgaben",
"Drafts" => "Entwürfe",
"Last Sent" => "Zuletzt gesendet",
// "Remove newsletter" => "Remove newsletter",
"Create/Edit Newsletters" => "Newsletter hinzufügen/bearbeiten",
"There are individual permissions set for this newsletter" => "Es existieren individuelle Berechtigungen für diesen Newsletter",
"Users can subscribe/unsubscribe to this list" => "Benutzer können sich für diese Liste an-/abmelden",
"Users can subscribe any email address" => "Benutzer können beliebige E-Mailadressen eintragen",
"Add unsubscribe instructions to each newsletter" => "Hinweise zur Abmeldung von der Liste an jeden Newsletter anhängen",
"Validate email addresses" => "E-Mailadressen überprüfen",
"Allow customized text message to be sent with the HTML version" => "Angepasste Textversion mit der HTML-Version verschicken",
"Allow clipping of articles into newsletter" => "Erlaube Artikelausschnitte in Newslettern",
"Automatically clip articles into newsletter" => "Automatisch Artikelausschnitte in Newsletter einfügen",
// "Do not send newsletter if clip is empty" => "Do not send newsletter if clip is empty",
"Clip articles published in the past number of days" => "Artikelausschnitte der letzten Zahl von Tagen einfügen",
"Article types to clip" => "Artikeltypen aus den Ausschnitte eingefügt werden",
"Mail notifications" => "E-Mail-Benachrichtigungen",
// "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "Benachrichtigung hinzufügen",
// "Destination" => "Destination",
"Myself" => "Mich selbst einfügen",
// "Note that a user is not notified for his or her own action" => "Note that a user is not notified for his or her own action",
"User / Group" => "Benutzer/Gruppe",
// "Delete mail notification event" => "Delete mail notification event",
// "Delete selected notification events" => "Delete selected notification events",
"Trackers Outbound Emails" => "Ausgehende E-Mails Tracker",
"Forums Outbound Emails" => "Ausgehende E-Mails Foren",
// "OAuth Server" => "OAuth Server",
// "List of clients" => "List of clients",
// "Client_id" => "Client_id",
// "Client_secret" => "Client_secret",
// "Redirect_uri" => "Redirect_uri",
"Admin Polls" => "Abstimmungen verwalten",
"Preview poll" => "Vorschau der Abstimmung",
"Add poll option" => "Eine Abstimmungsoption hinzufügen",
"Edit poll option" => "Bearbeite Abstimmungsoption",
"Poll options" => "Abstimmungs-Optionen",
"Votes" => "Stimmen",
"Set last poll as current" => "Letzte Abstimmung als aktuelle Abstimmung setzen",
"Close all polls but last" => "Alle bis auf die letzte Abstimmung schließen",
"Activate all polls" => "Alle Abstimmungen aktivieren",
"Create poll" => "Erstelle Abstimmung",
"Edit poll" => "Bearbeite Abstimmung",
"active" => "aktiv",
"object" => "Objekt",
"Toggle Quick Options" => "Schnell-Optionen ein-/ausblenden",
"Add Option" => "Füge Option hinzu",
"Leave box empty to delete an option" => "Lasse Box leer, um eine Option zu löschen",
// "Votes older than x days are not considered" => "Votes older than x days are not considered",
"0 for no limit" => "0 für unbegrenzt",
"Results" => "Ergebnisse",
"Add poll to pages" => "Füge Abstimmung zu Seite hinzu",
"{\$channels[ix].title}" => "{\$channels[ix].title}",
"This menu shows only Polls with 'status': \"template\"" => "Dieses Menü zeigt nur Abstimmungen mit 'Status': \"Template\"",
"{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Sperre die Seiten",
// "Custom Route" => "Custom Route",
// "Add a new Custom Route" => "Add a new Custom Route",
// "Edit route settings" => "Edit route settings",
// "Edit route" => "Edit route",
// "Add a new route" => "Add a new route",
// "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value" => "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value",
// "The users will get redirected to the tracker item that has a field that matches the value found in the URL" => "The users will get redirected to the tracker item that has a field that matches the value found in the URL",
// "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10" => "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10",
// "Router Type" => "Router Type",
// "Check this option to set route as a Short URL" => "Check this option to set route as a Short URL",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Hier können externe Feeds konfiguriert werden, damit diese von Tiki eingelesen werden können. Um Feeds aus Inhalten von Tiki zu generieren, benutze die Einstellung \"Feed\" auf der Adminseite, oder",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed" => "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed",
"Content for the feed" => "Inhalt für den Feed",
// "Refresh All feeds" => "Refresh All feeds",
// "Show Date" => "Show Date",
"Refresh rate:" => "Aktualisierungsintervall:",
// "Article generator" => "Article generator",
"Edit Feed" => "Feed bearbeiten",
"Create Feed" => "Feed erstellen",
"Create new external feed" => "Erzeuge einen neuen externen Feed",
// "Refresh rate" => "Refresh rate",
// "Show feed title" => "Show feed title",
"Show publish date" => "Zeige Veröffentlichungsdatum",
"Article Generator" => "Artikelgenerator",
// "Article Generator for %0" => "Article Generator for %0",
// "Once you have defined the settings below, each new item in this rss feed will generate a new article" => "Once you have defined the settings below, each new item in this rss feed will generate a new article",
// "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones" => "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones",
// "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content" => "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content",
"Use Article Submission System" => "Benutze Artikeleinreichungssystem",
"Expiration" => "Verfallszeit",
"Publish in the future" => "In der Zukunft veröffentlichen",
"-1 to use original publishing date from the feed" => "-1, um die Orginalveröffentlichungszeit des Feed zu benutzen",
// "Custom Settings for Source Categories" => "Custom Settings for Source Categories",
// "No source categories detected for this feed" => "No source categories detected for this feed",
// "Source Category" => "Source Category",
// "Priority (10 is highest)" => "Priority (10 is highest)",
// "Categorize Created Articles" => "Categorize Created Articles",
"Configure" => "Konfigurieren",
// "Add a new Scheduler" => "Add a new Scheduler",
// "Schedulers" => "Schedulers",
// "Run Time" => "Run Time",
// "Re-Run" => "Re-Run",
// "Edit scheduler settings" => "Edit scheduler settings",
// "Stalled" => "Stalled",
// "Run now" => "Run now",
// "Edit scheduler" => "Edit scheduler",
// "Add a new scheduler" => "Add a new scheduler",
// "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *" => "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *",
// "Run if missed" => "Run if missed",
// "Scheduler logs" => "Scheduler logs",
// "Last {\$numOfLogs} Logs" => "Last {\$numOfLogs} Logs",
// "Running" => "Running",
"Failed" => "Fehlgeschlagen",
// "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>",
"Tiki settings" => "Tikieinstellungen",
"Tiki variable" => "Tiki Variable",
"Setting" => "Einstellung",
"Risk Factor" => "Risikofaktor",
"Explanation" => "Erklärung",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors." => "Über Wikiplugins und Sicherheit: Stelle sicher, dass die Berechtigung \"tiki_p_plugin_approve\" nur vertrauenswürdigen Editoren gegeben wird.",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)." => "Du kannst riskante Plugins unter (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>) deaktivieren.",
"You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>." => "Du kannst Plugins zur Benutzung unter <a href=\"tiki-plugins.php\">tiki-plugins.php</a> freigeben.",
"Security checks" => "Sicherheitsüberprüfungen",
"Check all tiki files" => "Alle Tiki-Dateien überprüfen",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Achtung, dies kann viel Zeit in Anspruch nehmen. Der Parameter max_execution_time setting in der php.ini sollte entsprechend hoch sein, damit das Script nicht abbricht.",
"File checks" => "Datei-Checks",
"Check file permissions" => "Prüfe Dateiberechtigungen",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Diese Überprüfung versucht Dateien mit problematischen Berechtigungen zu finden. Manche Dateiberechtigungen, die als problematisch angezeigt werden, sind es aber möglicherweise nicht oder sie sind sogar für manchen Funktionen unvermeidlich.",
"See end of table for detailed explanations." => "Siehe das Ende der Tabelle für detaillierte Informationen.",
"owner" => "Eigentümer",
"special" => "speziell",
"other" => "andere",
"uid" => "uid",
"gid" => "gid",
"suid" => "suid",
"sgid" => "sgid",
"sticky" => "festgeheftet",
"r" => "r",
"w" => "w",
"Set User ID (suid) files" => "Lege BenutzerID-Dateien (suid) fest",
"World writable files or directories" => "Global beschreibbare Dateien oder Verzeichnisse",
"Files or directories the Webserver can write to" => "Dateien oder Verzeichnisse in die der Webserver schreiben kann",
"Strange Inodes (not file, not link, not directory)" => "Seltsame Inodes (weder Datei, noch Link noch Verzeichnis)",
"Executable files" => "Ausführbare Dateien",
"What to do with these check results" => "Was soll mit diesen Prüfergebnissen geschehen",
"Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "BenutzerID-Dateien (suid files) sind nicht Teil von Tiki und haben keinen Grund im Webspace zu liegen. Eindringlinge, die erweiterte Rechte erlangt hatten, hinterlassen manchmal solche Dateien, um \"die Tür offen zu halten\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information",
"Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes, die keine Dateien oder Verzeichnisse sind, sind nicht Teil von Tiki. Überprüfe diese Inodes",
"Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Es ist gefährlich, das Ausführbar-Bit zu setzen, wenn der Webserver so konfiguriert ist, dass er CGI-Skripte aus diesem Verzeichnis ausführt. Wenn Du das übliche PHP-Modul (für Apache) ausführst, dann müssen PHP-Skripte und andere Tiki-Dateien nicht mit dem Ausführbar-Bit versehen sein. Du kannst dieses Bit sicher mit CHMOD entfernen",
"Admin Shoutbox Words" => "Verwaltung Shoutboxwörter",
"Add Banned Word" => "Füge verbotenes Wort hinzu",
"Are you sure you want to delete this word?" => "Soll das Wort wirklich gelöscht werden?",
// "Rebuild sitemap" => "Rebuild sitemap",
// "Submit the Sitemap" => "Submit the Sitemap",
// "You can submit the sitemap for processing in all major search engines using the following URL" => "You can submit the sitemap for processing in all major search engines using the following URL",
// "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap" => "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap",
// "Automate Sitemap generation" => "Automate Sitemap generation",
// "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t" => "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t",
// "Or you can use directly the command line" => "Or you can use directly the command line",
"XML Zip Import" => "XML Zip Import",
"Feedback" => "Rückmeldung",
// "Structure created" => "Structure created",
"View Page" => "Seite anzeigen",
"Please Confirm" => "Bitte bestätigen",
"You will remove structure" => "Du entfernst die Struktur",
"Destroy the structure leaving the wiki pages" => "Nur Struktur (ohne Seiten) entfernen",
"Destroy the structure and remove the pages" => "Struktur und Seiten entfernen",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Beachte, dass die folgenden Seiten Teil einer anderen Struktur sind. Stelle sicher, dass es keine Konflikte mit den Zugriffsrechten (wenn existent) gibt",
"The following pages have automatically been categorized with the same categories as the structure" => "Die folgenden Seiten wurden automatisch mit der gleichen Kategorie kategorisiert wie die Struktur",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "Die folgenden Seiten haben Kategorieren, aber die Struktur hat keine. Du solltest die Kategorieren ggf. entfernen, um Inkonsistenzen zu vermeiden",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "Die folgenden Seiten haben Kategorien, die der Struktur aber nicht zugeordnet ist. Du solltest ggf. die Kategorien angleichen, um Inkonsistenzen zu vermeiden",
// "Existing Structures" => "Existing Structures",
// "View Structure" => "View Structure",
"View structure" => "Struktur ansehen",
// "Export pages" => "Export pages",
// "Dump tree" => "Dump tree",
"Create WebHelp" => "Erstelle WebHelp",
"View WebHelp" => "Siehe WebHelp",
"XML Zip" => "XML Zip",
"Perform action with selected" => "Führe Aktion mit Ausgewählten durch",
".." => "..",
"Delete with the pages" => "Mit den Seiten löschen",
// "Create Structure" => "Create Structure",
"Alias" => "Alias",
"Tree" => "Baum",
"Use single spaces to indent structure levels" => "Strukturelevel durch Einrücken (einzelne Leerzeichen) definieren",
"Create New Structure" => "Neue Struktur anlegen",
"Edit survey questions" => "Umfrage bearbeiten",
"Add a New Question" => "Füge eine neue Frage hinzu",
"List Surveys" => "Umfragen auflisten",
"Survey Stats" => "Umfragen-Statistik",
"This survey stats" => "Statistiken zu dieser Umfrage",
"Edit this Survey" => "Diese Umfrage bearbeiten",
"Admin Surveys" => "Umfragen verwalten",
"Questions" => "Fragen",
"Question" => "Frage",
"Answer is mandatory" => "Antwort ist zwingend",
// "Required answers" => "Required answers",
// "Single choice using radio buttons" => "Single choice using radio buttons",
// "Example: \"one, two, many, lots\"" => "Example: \"one, two, many, lots\"",
// "(Use \"\\,\" to include a comma" => "(Use \"\\,\" to include a comma",
// "Multiple choice using checkboxes" => "Multiple choice using checkboxes",
"For a rate, you can give the maximum value" => "Für eine Bewertung kannst Du einen Maximalwert festlegen",
// "Multiple choices of thumbnail from a file gallery, options contains Gallery ID" => "Multiple choices of thumbnail from a file gallery, options contains Gallery ID",
// "Example: 4" => "Example: 4",
// "Options are: rows,columns,toolbars" => "Options are: rows,columns,toolbars",
// "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)" => "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)",
// "For the 'short text' type, options are: columns" => "For the 'short text' type, options are: columns",
// "Example: 60" => "Example: 60",
// "A heading to go between questions. Options are newpage,tag" => "A heading to go between questions. Options are newpage,tag",
// "Example: y,h4" => "Example: y,h4",
"Options (if apply)" => "Optionen (falls nötig)",
"Admin surveys" => "Umfragen verwalten",
"Create/Edit Surveys" => "Umfragen hinzufügen/bearbeiten",
"Edit this Survey:" => "Diese Umfrage bearbeiten:",
"Create New Survey" => "Neue Unfrage erstellen",
"There are individual permissions set for this survey" => "Für diese Umfrage sind individuelle Berechtigungen gesetzt",
// "Synchronize Dev/Prod Servers" => "Synchronize Dev/Prod Servers",
// "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one" => "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one",
// "Remote Server Address" => "Remote Server Address",
// "Show diff" => "Show diff",
"Local" => "Lokal",
"Remote" => "Ziel",
// "System Administration" => "System Administration",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Wenn sich Dein Tiki seltsam verhält, versuche zuerst den Cache zu leeren. Wichtig, auch nach einer Aktualisierung den Cache leeren (per FTP / SSH, wenn nötig).",
// "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>" => "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>",
"Clear cached content" => "Lösche gecachte Inhalte",
"Empty" => "Leeren",
// "All user preference sessions" => "All user preference sessions",
// "Save directories" => "Save directories",
"Directories to save" => "Zu sichernde Verzeichnisse",
"Directory is not writeable" => "Verzeichnis ist nicht beschreibbar",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "ZIP" => "ZIP",
// "Generate zip" => "Generate zip",
"A zip has been written to %0" => "Eine Zip-Datei wurde in %0 erstellt",
"Groups still used in the database but no more defined" => "Gruppen, die immer noch in der Datenbank stehen, aber nicht mehr definiert sind",
"Admin Tokens" => "Tokens verwalten",
"List tokens" => "Tokens auflisten",
"Timeout" => "Timeout",
// "Hits left" => "Hits left",
"Max hits" => "Max Treffer",
// "Create Temp User" => "Create Temp User",
// "Temp User Prefix" => "Temp User Prefix",
"Add new token" => "Neues Token hinzufügen",
"Token successfully created" => "Token erfolgreich erstellt",
"Full URL" => "Volle URL",
"Timeout in seconds (-1 for unlimited)" => "Timeout in Sekunden (-1 für unbegrenzt)",
"Maximum number of hits (-1 for unlimited)" => "Maximale Anzahl von Treffern (-1 für unbegrenzt)",
"Groups (separated by comma)" => "Gruppen (getrennt durch Kommata)",
"View mode" => "Ansichtsmodus",
"Wiki and WYSIWYG" => "Wiki und WYSIWYG",
"Wiki only" => "Nur Wiki",
// "WYSIWYG (HTML mode)" => "WYSIWYG (HTML mode)",
// "WYSIWYG (wiki mode)" => "WYSIWYG (wiki mode)",
"Reset to Global" => "Auf Global zurücksetzen",
"Reset to defaults" => "Auf Standardwerte zurücksetzen",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
"Edit tool" => "Werkzeug bearbeiten",
"Wysiwyg Token" => "Wysiwyg Token",
// "Custom Tools" => "Custom Tools",
"Add a new custom tool" => "Füge ein neues benutzerdefiniertes Werkzeug hinzu",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
"If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools:" => "Wenn Du Probleme mit dieser Seite hast, nachdem Du von Tiki 4 ein Upgrade durchgeführt hast, klicke auf diesen Link, um alle veränderten Tools zurückzusetzen:",
"Delete all custom tools" => "Lösche alle benutzerdefinierten Tools",
"Warning: There is no undo!" => "Warnung: es gibt kein Rückgängigmachen!",
"List Articles" => "Artikel auflisten",
"Add topic" => "Thema hinzufügen",
"Notification Email" => "Benachrichtigungs-E-Mail",
// "You will be able to add a notification email per article topic when you edit the topic after its creation" => "You will be able to add a notification email per article topic when you edit the topic after its creation",
"topic image" => "Themenlogo",
"Activate" => "Aktivieren",
// "De-activate" => "De-activate",
"Remove with articles" => "Typ und zugehörige Artikel löschen",
// "Tracker Fields" => "Tracker Fields",
"Admin Tracker" => "Tracker verwalten",
// "Import Fields" => "Import Fields",
"Mandatory" => "Pflicht",
"Save All" => "Alle Speichern",
"Remove Selected" => "Entferne Ausgewählte",
"Export Selected" => "Exportiere Ausgewählte",
"Subset Selection" => "Untermengen-Auswahl",
"Category Selection" => "Kategorieauswahl",
"Group Selection" => "Gruppenauswahl",
// "Add Group" => "Add Group",
// "Press Enter for each group" => "Press Enter for each group",
// "At least two elements are required to create transitions. Additional tabs appear once the selection is completed" => "At least two elements are required to create transitions. Additional tabs appear once the selection is completed",
"Draw Transition Diagram" => "Zeichne ein Transitions-Diagrann",
"Guards" => "Guards",
"preserved" => "bewahrt",
"No transitions" => "Keine Übergänge",
"New / Edit" => "Neu / Bearbeiten",
"Edit <em>%0</em>" => "Bearbeite <em>%0</em>",
"New transition" => "Neue Übergänge",
"Upon trigger, preserve the initial state" => "Bewahre den anfänglichen Zustand nach Auslösung",
"Members" => "Mitglieder",
"No guards on this transition" => "Keine Guards für diese Transition",
"New Guard" => "Neuer Guard",
"Exactly" => "Exakt",
"States" => "Staten",
// "Body of POST request" => "Body of POST request",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used." => "Trage die URL eines Webservices ein, der Daten im JSON oder YAML-Format bereitstellt. Parameter können durch Prozentzeichen eingeschlossen angegeben werden. Z.B. %name%. %service% und %template% sind reservierte Schlüsselwörter und können nicht verwendet werden.",
"Parameters (%name%):" => "Parameter (%name%):",
"Operation" => "Operation",
// "%0 requires no parameter" => "%0 requires no parameter",
"Test Input" => "Test Eingabe",
// "Bypass cache" => "Bypass cache",
"Response Information" => "Antwortinformationen",
"OIntegrate Version" => "OIntegrate Version",
"Not supported" => "Nicht unterstützt",
"Schema Version" => "Schema Version",
"Schema Documentation" => "Schema Dokumentation",
"Not specified, default used" => "Nicht angegeben. Standard wird genutzt",
"Content Type" => "Inhaltstyp",
"Not specified" => "Nicht angegeben",
"Returned Data" => "Zurückgegebene Daten",
// "tuncated at approx. 1MB" => "tuncated at approx. 1MB",
"Proposed Templates" => "Vorgeschlagene Vorlagen",
"Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Registriere diesen Webdienst. Es ist möglich, die Vorlagen später zu registrieren. Dienstname darf nur Buchstaben enthalten",
"Register Service" => "Dienst registrieren",
"Registered Templates" => "Registrierte Vorlagen",
"Engine" => "Antrieb (engine)",
"Output" => "Ausgabe",
// "Toggle template source" => "Toggle template source",
"Register Template" => "Vorlage registrieren",
// "Add New Group" => "Add New Group",
"Invitation List" => "Einladungsliste",
"List of existing groups" => "Liste vorhandener Gruppen",
"Inherits Permissions from" => "Erbt Rechte von",
"User Choice" => "Benutzerwahl",
"Edit group" => "Bearbeite Gruppe",
"{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
"{\$users[user].groupHome}" => "{\$users[user].groupHome}",
"{\$users[user].userChoice}" => "{\$users[user].userChoice}",
// "Create group" => "Create group",
"Group is NOT being monitored. Click icon to START monitoring" => "Gruppe wird NICHT überwacht. Klicke auf das Symbol, um Überwachung zu STARTEN",
"Group IS being monitored. Click icon to STOP monitoring" => "Gruppe WIRD überwacht. Klicke auf das Symbol, um die Überwachung zu STOPPEN",
// "Inheritance" => "Inheritance",
// "Permissions will be inherited from these groups" => "Permissions will be inherited from these groups",
// "Indirectly included groups" => "Indirectly included groups",
// "Group Home" => "Group Home",
"Use wiki page name or full URL" => "Wiki-Seitennamen oder volle URL benutzen",
"For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "Benutze für andere Tiki-Funktionen relative Links (so wie <em>/tiki-forums.php</em>)",
// "Default Category" => "Default Category",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
"Use site default" => "Benutze Standards der Site",
// "Group color" => "Group color",
// "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color" => "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color",
"Group Information Tracker" => "Gruppeninformationen-Tracker",
// "choose a group tracker .." => "choose a group tracker ..",
// "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign" => "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign",
"choose a field .." => "wähle ein Feld ..",
// "Select the user selector field from the above tracker" => "Select the user selector field from the above tracker",
// "Go to trackers list" => "Go to trackers list",
// "User Registration Tracker" => "User Registration Tracker",
// "choose a user tracker .." => "choose a user tracker ..",
// "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign" => "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign",
// "Select user field" => "Select user field",
"Choose a field .." => "Wähle ein Feld ..",
// "No fields in tracker .." => "No fields in tracker ..",
// "Select the user selector field from the above tracker to link a tracker item to the user upon registration" => "Select the user selector field from the above tracker to link a tracker item to the user upon registration",
// "No fields in this tracker" => "No fields in this tracker",
// "Go to tracker list" => "Go to tracker list",
// "User Wizard Fields" => "User Wizard Fields",
// "By default, the same fields as in registration are used" => "By default, the same fields as in registration are used",
// "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time" => "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time",
// "Group or User Tracker Registration Fields" => "Group or User Tracker Registration Fields",
// "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete" => "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete",
"User can assign himself or herself to the group" => "Benutzer kann sich selbst zu einer Gruppe hinzufügen",
// "Membership expiry" => "Membership expiry",
// "Anniversary" => "Anniversary",
// "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date" => "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date",
"Or" => "Oder",
// "Number of Days" => "Number of Days",
// "Number of days after which all users will be unassigned from the group" => "Number of days after which all users will be unassigned from the group",
// "Pro-Rate Membership" => "Pro-Rate Membership",
// "Payment for membership extension is prorated at a minimum interval" => "Payment for membership extension is prorated at a minimum interval",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "Benutzer werden automatisch bei Registrierung zu dieser Gruppe hinzugefügt, wenn ihre E-Mail dem folgenden Muster entspricht",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Assign Permissions" => "Berechtigungen vergeben",
"Group tracker item : {\$groupitemid}" => "Gruppentrackereintrag: {\$groupitemid}",
"Edit Item" => "Punkt bearbeiten",
"Group tracker item not found" => "Gruppentrackereintrag nicht gefunden",
// "</i>\"}%0 members" => "</i>\"}%0 members",
// "Assigned" => "Assigned",
"Edit user" => "Benutzerdaten bearbeiten",
// "Remove from group" => "Remove from group",
// "No members" => "No members",
// "Add or ban users" => "Add or ban users",
"Add to group" => "Zur Gruppe hinzufügen",
// "Ban from group" => "Ban from group",
// "</i>\"}Users banned from %0" => "</i>\"}Users banned from %0",
// "Banned members" => "Banned members",
"Unban user" => "Benutzer-Verbannung aufheben",
// "Unban user %0 from group %1" => "Unban user %0 from group %1",
// "No banned members" => "No banned members",
// "</i>\"}%0 import/export" => "</i>\"}%0 import/export",
// "Export group users (CSV file)" => "Export group users (CSV file)",
"Charset encoding" => "Zeichensatz",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
// "Import users to group (CSV file)" => "Import users to group (CSV file)",
// "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Neuen Benutzer hinzufügen",
"Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Seit diese Tiki Site im Slavemodus ist und Gruppen importiert, werden die Mastergruppen bei jedem Login automatisch neu importiert",
"Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Seit diese Tiki Site im Slavemodus ist und Einstellungen importiert, werden die Master-Benutzereinstellungen bei jedem Login automatisch neu importiert",
"Number of displayed rows" => "Angezeigte Zeilenanzahl",
"More Criteria" => "Erweiterte Suchoptionen",
"Group (direct)" => "Gruppe (direkt)",
"Email not confirmed" => "E-Mail nicht bestätigt",
// "User not validated" => "User not validated",
"OpenID" => "OpenID",
// "Edit account settings" => "Edit account settings",
"N" => "N",
"Registered %0 ago" => "Registriert seit %0",
"Need to validate email" => "Muss E-Mail validieren",
// "Edit this included group" => "Edit this included group",
// "Add or remove from a group" => "Add or remove from a group",
// "Edit group expiry" => "Edit group expiry",
"Change user preferences" => "Ändere Benutzereinstellungen",
// "Switch to this user" => "Switch to this user",
// "Validate user" => "Validate user",
// "Invalidate user" => "Invalidate user",
// "Remove link with OpenID for this user" => "Remove link with OpenID for this user",
"Remove link with OpenID account" => "Entferne Link mit OpenID-Konto",
// "Remove users.." => "Remove users..",
// "Ban IPs" => "Ban IPs",
// "Change group assignments" => "Change group assignments",
// "Set default groups" => "Set default groups",
// "Send wiki page content by email" => "Send wiki page content by email",
// "Warning: User Encryption is Active" => "Warning: User Encryption is Active",
// "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted" => "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted",
"Assign user to Groups" => "Weise Benutzer einer Gruppe zu",
// "Intertiki Enabled" => "Intertiki Enabled",
// "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"" => "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"",
"Use the email as username" => "Benutze E-Mail als Benutzernamen",
// "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames" => "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames",
// "Changing username is disabled for Intertiki sites" => "Changing username is disabled for Intertiki sites",
"No password is required" => "Kein Passwort erforderlich",
"Tiki is configured to delegate the password managment to LDAP" => "Tiki wurde konfiguriert, um die Passwortverwaltung LDAP zu überlassen",
"New password" => "Neues Passwort",
"Confirm new password" => "Passwort bestätigen",
"User must change password at next login" => "Benutzer muss sein Passwort beim nächsten Login ändern",
"Send an email to the user to enable him or her to validate their account." => "Sende dem Benutzer eine E-Mail, damit sein Konto validiert werden kann.",
// "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>",
// "Add a user tracker item for this user" => "Add a user tracker item for this user",
// "User tracker" => "User tracker",
// "View item" => "View item",
// "Modify this user\\'s data" => "Modify this user\\'s data",
"Pass confirmed" => "Passwort bestätigt",
"Email confirmed" => "E-Mail bestätigt",
"%0 days ago" => "%0 Tage her",
"Current Login" => "Gegenwärtige Anmeldung",
"You do not have permission to edit this user" => "Du hast keine Berechtigung, diesen Benutzer zu bearbeiten",
// "Your file should contain in the first row (first entry) the following fields" => "Your file should contain in the first row (first entry) the following fields",
// "user1,pass1,email1,group1,group1" => "user1,pass1,email1,group1,group1",
// "user2,pass2,email2,\"group1,group2\",group1" => "user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time" => "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time",
// "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any" => "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any",
// "Existing Users" => "Existing Users",
"Don't overwrite" => "Nicht überschreiben",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "The user must change his or her password the first time they log in" => "The user must change his or her password the first time they log in",
// "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>" => "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>",
// "Temporary Users" => "Temporary Users",
// "Token Access Feature Dependency" => "Token Access Feature Dependency",
// "The token access feature is needed for Temporary Users to login" => "The token access feature is needed for Temporary Users to login",
// "Turn it on here" => "Turn it on here",
// "Feature Conflict" => "Feature Conflict",
// "This feature currently is incompatible with the \"Use email as username\" feature" => "This feature currently is incompatible with the \"Use email as username\" feature",
// "Turn it off here" => "Turn it off here",
// "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature" => "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature",
// "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token" => "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token",
// "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself" => "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself",
// "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms" => "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms",
// "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails" => "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails",
// "To revoke access before validity expires or to review who has access, please see" => "To revoke access before validity expires or to review who has access, please see",
// "Email addresses (comma-separated)" => "Email addresses (comma-separated)",
// "Valid for days (use -1 for forever)" => "Valid for days (use -1 for forever)",
// "Username prefix" => "Username prefix",
// "Autologin (non-SEFURL) path" => "Autologin (non-SEFURL) path",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences",
"Add Type" => "Typ hinzufügen",
"Add article type" => "Artikeltyp hinzufügen",
"{\$types[user].type|escape}" => "{\$types[user].type|escape}",
"View articles with this type" => "Artikel mit diesem Typ ansehen",
"Show before publish date" => "Vor Veröffentlichungsdatum anzeigen",
"Show after expire date" => "Nach Verfallsdatum anzeigen",
"Heading only" => "nur Kopfteil",
"Comment can rate article" => "Kommentar kann Artikel bewerten",
"Show image" => "Zeige Bild",
"Show profile picture" => "Zeige Avatar",
"Show expire date" => "Zeige Verfallsdatum",
"Show reads" => "Zeige Zugriffe",
"Show size" => "Zeige Größe",
"Show topline" => "Aufmacher anzeigen",
"Show subtitle" => "Untertitel anzeigen",
"Show source" => "Zeige Quelle",
"Show image caption" => "Zeige Bildbeschriftung",
"Creator can edit" => "Ersteller kann bearbeiten",
"Custom attribute" => "Angepasste Attribute",
"Assign User %0 to Groups" => "Weise Benutzer %0 zu Gruppen zu",
"{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"backlinks to" => "Backlinks zu",
"No backlinks to this page" => "Keine Backlinks zu dieser Seite",
"Directory batch upload" => "Aus Verzeichnis einlesen",
"Browse Gallery" => "Dateiarchiv anzeigen",
"Upload From Disk" => "Hochladen von Festplatte",
"available images" => "Bilder vorhanden",
"Filesize" => "Dateigröße",
"Filetype" => "Dateityp",
"Remove File Extension from Image Name" => "Dateiendung im Namensfeld entfernen",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "z.B. wird von \"digicam0001.jpg\" der Name digicam0001 im Namensfeld benutzt",
"Convert the last sub directory to a sub gallery" => "Wandele das letzte Unterverzeichnis in eine Untergalerie um",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "Bsp.: von \"misc/screenshots/digicam0001.jpg\" wird eine Galerie mit dem Namen \"screenshots\" erstellt",
"Use the last sub directory name as description" => "Benutze das letzte Unterverzeichnis als Beschreibung",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "Bsp.: von \"misc/screenshots/digicam0001.jpg\" wird eine Beschreibung \"screenshots\" erstellt",
"Select a Gallery" => "Ziel-Galerie auswählen",
"Process" => "Prozess",
"Browse File Gallery" => "Dateiarchiv durchsehen",
"Please do not use this feature to upload data into the database." => "Mit dieser Funktion bitte keine Daten in die Datenbank laden.",
"Available Files" => "verfügbare Dateien",
// "File Permissions" => "File Permissions",
// "File is writable" => "File is writable",
// "File is not writable" => "File is not writable",
"Total: %0" => "Gesamt: %0",
"Select a File Gallery" => "Dateiarchiv auswählen",
"Root" => "Root",
// "Upload into galleries according to sub-directories" => "Upload into galleries according to sub-directories",
// "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists" => "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists",
// "Create sub-galleries" => "Create sub-galleries",
// "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set" => "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set",
// "Upload into galleries according sub-directory as galleryId" => "Upload into galleries according sub-directory as galleryId",
// "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists" => "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists",
"Process files" => "Dateien verarbeiten",
"Edit Post" => "Eintrag bearbeiten",
"New Post" => "Neue Veröffentlichung",
"View post" => "Eintrag ansehen",
"View Blog" => "Blog betrachten",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Hinweis: Dies ist nur eine Vorschau und wurde noch nicht gespeichert!",
"Excerpt" => "Auszug",
"Admin the Category System" => "Verwalte das Kategoriesystem",
"Browse in:" => "Suche in:",
// "or in" => "or in",
"Image galleries" => "Bildergalerien",
"Trackers Items" => "Trackereinträge",
"Sheets" => "Tabellen",
"Find in" => "Finde in",
// " in the current category and its subcategories" => " in the current category and its subcategories",
"Hide subcategories objects" => "Einträge von Unterkategorien verstecken",
"Show subcategories objects" => "Einträge von Unterkategorien anzeigen",
// "Up one level" => "Up one level",
"{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
// "Clear tags" => "Clear tags",
"With all selected tags" => "Mit allen gewählten Tags",
"With one selected tag" => "Mit einem gewählten Tag",
"With last selected tag" => "Mit dem zuletzt gewählten Tag",
"More Popular Tags" => "Beliebtere Tags",
"Alphabetically" => "Alphabetisch",
"By Size" => "Nach Größe",
"Cloud" => "Wolke",
"{\$feature_label}" => "{\$feature_label}",
// "Filter in" => "Filter in",
// "All blogs" => "All blogs",
"{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
// "Delete Tag" => "Delete Tag",
"Browsing Gallery" => "Galerie ansehen",
// "Gallery actions" => "Gallery actions",
"List Galleries" => "Dateiarchive auflisten",
"Edit Gallery" => "Archiv bearbeiten",
"Upload Image" => "Bild hochladen",
"Directory Batch" => "Aus Verzeichnis einlesen",
"List Gallery" => "Galerie als Liste zeigen",
"All Images" => "Alle Bilder",
"Rebuild Thumbnails" => "Thumbnails neu erzeugen",
"{\$advice}" => "{\$advice}",
"Sort Images by" => "Bilder sortieren nach",
"subgallery" => "Unter-Galerie",
"Subgallery" => "Unter-Galerie",
// "Original size" => "Original size",
"rotate right" => "rechts drehen",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Du kannst dieses Bild der Galerie (erstes, zufälliges, etc.) in Deinem Browser sehen mittels",
"You can include the gallery's image in an HTML page using" => "Du kannst das Galeriebild in einer HTML-Seite nutzen mittels",
"You can include the image in a tiki page using" => "Du kannst das Bild in einer Tiki Seite nutzen mittels",
"Browsing Image" => "Bild ansehen",
"Return to Gallery" => "Zurück zur Galerie",
"Edit Image" => "Bild bearbeiten",
"Bigger" => "Größer",
// "Slideshow forward" => "Slideshow forward",
// "Repeat" => "Repeat",
"Click to zoom" => "Klicken zum Zoomen",
"Image Name" => "Bildname",
"Image size" => "Bildgröße",
"Image Scale" => "Bildskalierung",
"Original Size" => "Originalgröße",
"Hits:" => "Zugriffe:",
"Move image" => "Bild verschieben",
"Include the image in a tiki page using the following syntax" => "Das Bild kann mit dem folgenden Syntax in einer Wiki Seite genutzt werden",
"To include the image in an HTML page" => "Um das Bild in eine HTML-Seite einzufügen",
"To link to this page from another tiki page" => "Um von einer anderen Tiki Seite auf diese Seite zu verlinken",
// "Monitoring" => "Monitoring",
"Visible Calendars" => "Sichtbare Kalender",
"Group Calendars" => "Gruppenkalender",
"Export calendars" => "Kalender exportieren",
"advanced parameters" => "erweiterte Parameter",
"Export as iCal" => "Exportiere als iCal",
"January" => "Januar",
"February" => "Februar",
"March" => "März",
"April" => "April",
"May" => "Mai",
"June" => "Juni",
"July" => "Juli",
"August" => "August",
"September" => "September",
"October" => "Oktober",
"November" => "November",
"December" => "Dezember",
"Jan." => "Jan",
"Feb." => "Feb",
"Mar" => "Mär",
"Apr." => "Apr",
"Aug." => "Aug",
"Sep." => "Sep",
"Oct." => "Okt",
"Nov." => "Nov",
"Dec." => "Dez",
"Sun" => "So",
"Mon" => "Mo",
"Tue" => "Di",
"Wed" => "Mi",
"Thu" => "Do",
"Fri" => "Fr",
"Sat" => "Sa",
"today" => "heute",
// "semester" => "semester",
// "quarter" => "quarter",
"all-day" => "ganzer Tag",
"Organized by" => "Organisiert von",
"Classification" => "Klassifizierung",
"View this Week" => "Diese Woche ansehen",
"Change Focus" => "Hierher wechseln",
"View this Day" => "Diesen Tag ansehen",
"Calendar event : " => "Kalendereignis : ",
"New event" => "Neues Ereignis",
"View event" => "Ereignis ansehen",
"Edit/Delete event" => "Ereignis bearbeiten/löschen",
// "Export Event as iCal" => "Export Event as iCal",
"Edit Calendar Item" => "Kalendereintrag bearbeiten",
"New Calendar Item" => "Neuer Kalender-Eintrag",
"Recurrence" => "Wiederholung",
"This event depends on a recurrence rule" => "Dieses Ereignis hängt von einer Wiederholungsregel ab",
"ending by" => "endet am",
"ending after" => "endet nach",
"events" => "Ereignissen",
// "(%0 events have been manually modified)" => "(%0 events have been manually modified)",
// "(%0 event has been manually modified)" => "(%0 event has been manually modified)",
"This event is not recurrent" => "Dieses Ereignis ist nicht wiederkehrend",
"On a weekly basis" => "wöchentlich",
"Each" => "jeden",
"of the week" => "der Woche",
"On a monthly basis" => "Monatlich",
"of the month" => "des Monats",
"On a yearly basis" => "jährlich",
"of" => ".",
"Starting on" => "Startet am",
"Start period" => "Startperiode",
// "End Period" => "End Period",
"End after" => "Endet nach",
"occurrences" => "Häufigkeiten",
"occurrence" => "Häufigkeit",
"End before" => "Endet vor",
"Event occurs once on" => "Ereignis findet statt am",
"Event is repeated" => "Ereignis wird wiederholt",
"times" => "mal",
"{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "eines jeden Monats",
"on each" => "an jedem",
"{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
"starting" => "startet",
"ending" => "endet",
"Show duration" => "Blende Dauer ein",
"Events cannot end before they start" => "Ereignis kann nicht enden bevor es startet",
"No description" => "Keine Beschreibung",
"or new" => "oder neu",
"Choose users to alert" => "Wähle zu alarmierende Benutzer",
"Withdraw me from the list of participants" => "Entferne mich von der Liste der Teilnehmer",
"Add me to the list of participants" => "Füge mich zur Liste der Teilnehmer hinzu",
"Roles" => "Rollen",
"chair" => "Vorsitz",
"default role" => "Standard Rolle",
"required participant" => "erforderlicher Teilnehmer",
"optional participant" => "optionaler Teilnehmer",
"non-participant" => "nicht Teilnehmer",
"Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in" => "Teilnehmerliste durch Komma getrennt angeben. Rollen müssen in Form eines Präfix durch eine Spalte getrennt angegeben werden, so wie in",
"role:login_or_email,login_or_email" => "Rolle: Login_oder_E-Mail,Login_oder_E-Mail",
"If no role is provided, default role will be \"Chair participant\"" => "Wird keine Rolle angegeben, ist die Standardrolle \"Vorsitz\"",
"Update this event only" => "Aktualisiere nur dieses Ereignis",
"Update every unchanged event in this recurrence series" => "Aktualisiere jedes ungeänderte Ereignis mit dieser Wiederkehregel",
"Update every event in this recurrence series" => "Aktualisiere jedes Ereignis mit dieser Wiederkehregel",
"Delete event" => "Ereignis löschen",
"Delete recurrent events" => "Lösche wiederkehrende Ereignisse",
"Calendar import" => "Kalender importieren",
"Calendar has been updated" => "Kalender wurde aktualisiert",
"%0 column name can be used instead of %1" => "%0 Spaltenname kann anstelle von %1 benutzt werden",
"import" => "Import",
// "Previous {\$viewmode|escape}" => "Previous {\$viewmode|escape}",
"D" => "T",
"W" => "W",
"M" => "M",
// "Next {\$viewmode|escape}" => "Next {\$viewmode|escape}",
"%d/%m" => "%d/%m",
"%m/%d" => "%d.%m.",
"Advanced parameters for iCal export" => "Erweiterte Parameter für iCal-Export",
"Calendars to be exported" => "Zu exportierende Kalender",
"Export calendars iCal" => "Exportiere Kalender als iCal",
"Export calendars CSV" => "Exportiere Kalender als CSV",
"Your account has been validated" => "Dein Konto wurde validiert",
"You have to choose a password to use this account" => "Du musst ein Passwort auswählen, um dieses Konto zu nutzen",
// "Change password" => "Change password",
// "Set password" => "Set password",
// "Old Password" => "Old Password",
// "Repeat Password" => "Repeat Password",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Acknowledge (OK)" => "Acknowledge (OK)",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Acknowledge" => "Acknowledge",
// "New database engine" => "New database engine",
// "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki" => "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki",
// "MySQL crashed Tables" => "MySQL crashed Tables",
// "Be careful" => "Be careful",
// "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure" => "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure",
// "Test sending emails" => "Test sending emails",
// "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>" => "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Special directories" => "Special directories",
// "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>" => "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>",
// "Fitness" => "Fitness",
// "Directory is writeable" => "Directory is writeable",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "Change PHP configuration values" => "Change PHP configuration values",
// "{\$php_sapi_info.message}" => "{\$php_sapi_info.message}",
// "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>" => "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>",
// "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>" => "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>",
// "PHP Security properties" => "PHP Security properties",
// "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>" => "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>",
// "Tiki Security" => "Tiki Security",
// "Sensitive Data Exposure" => "Sensitive Data Exposure",
// "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information",
// "Print configurations" => "Print configurations",
// "mPDF Information" => "mPDF Information",
// "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print" => "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print",
// "File Gallery Search Indexing" => "File Gallery Search Indexing",
// "More information %0 here %1" => "More information %0 here %1",
// "Command Missing" => "Command Missing",
// "The command \"shell_exec\" is required for file gallery search indexing" => "The command \"shell_exec\" is required for file gallery search indexing",
// "Mimetype" => "Mimetype",
// "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable" => "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
// "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>" => "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>",
// "Benchmark PHP/MySQL" => "Benchmark PHP/MySQL",
// "Check" => "Check",
// "BOM Detected Files" => "BOM Detected Files",
// "Scanned files" => "Scanned files",
// "BOM files detected" => "BOM files detected",
// "No BOM files detected" => "No BOM files detected",
// "TRIM" => "TRIM",
// "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>" => "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>",
// "Requirements" => "Requirements",
// "OS not supported" => "OS not supported",
// "Apparently tiki is running on a Windows based server. This feature is not supported natively" => "Apparently tiki is running on a Windows based server. This feature is not supported natively",
// "User Data Encryption" => "User Data Encryption",
// "MCrypt encryption found in users data preferences" => "MCrypt encryption found in users data preferences",
// "Found %0 user(s) with data preferences encrypted with MCrypt" => "Found %0 user(s) with data preferences encrypted with MCrypt",
// "No user preferences were found with data encrypted with MCrypt" => "No user preferences were found with data encrypted with MCrypt",
// "Tiki Packages" => "Tiki Packages",
// "OCR Status" => "OCR Status",
"Please choose the language for this page:" => "Wähle bitte eine Sprache für diese Seite:",
"Choose language" => "Wähle Sprache",
"Contact Us" => "Kontaktiere uns",
"Send a message to us" => "Schick uns eine Nachricht",
"Your email" => "Deine E-Mail",
"Contact us by email" => "Kontaktiere uns per E-Mail",
"Click here to send us an email" => "Hier klicken, um uns eine E-Mail zu schicken",
"Send another message" => "Sende noch eine Nachricht",
"Contacts" => "Kontakte",
"Group View" => "Gruppenansicht",
"Create/edit contacts" => "Kontakte hinzufügen/bearbeiten",
"First Name" => "Vorname",
"Last Name" => "Nachname",
"Nickname" => "Spitzname",
"Publish this contact to groups" => "Veröffentliche diesen Kontakt zu Gruppen",
// "Extra Fields" => "Extra Fields",
"Copy page" => "Kopiere Seite",
"Invalid page name" => "Ungültiger Seitenname",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "Der angegebene Seitenname enthält ungültige Zeichen. Ein Speichern der Seite ist nicht möglich, bevor diese nicht entfernt werden: <strong>%0</strong>",
"The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "Der angegebene Seitenname enthält Zeichen, die den Zugriff auf die Seite erschweren können. Du solltest diese ggf. entfernen: <strong>%0</strong>",
"Use this name anyway" => "Benutze diesen Namen trotzdem",
// "Duplicate tags" => "Duplicate tags",
"Quick Create Multilanguage Pages" => "Schnell mehrsprachige Seiten erstellen",
"Following pages were created, as translations of each other" => "Die folgenden Seiten wurden als Übersetzung voneinander erstellt",
"Following pages were not created" => "Folgende Seiten wurden nicht erstellt",
"page already exists" => "Seite existiert bereits",
"Enter the names of a new page page in various languages" => "Trage die Namen der neuen Seiten in verschiedenen Sprachen ein",
"Preferred languages" => "Bevorzugte Sprachen",
"Other languages" => "Andere Sprachen",
"Create pages" => "Erstelle Seiten",
"View generated WebHelp" => "Erstellte WebHilfe ansehen",
"No structure" => "Keine Struktur",
"Top page" => "Top-Seite",
"Add a new site" => "Füge neuen Link hinzu",
"You cannot add sites until Directory Categories are setup." => "Links können erst hinzugefügt werden, wenn Kategorien dafür eingerichtet wurden.",
"Please contact the Site Administrator" => "Bitte kontaktiere den Administrator der Site.",
"<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Füge jetzt eine Verzeichniskategorie hinzu</a>",
"Site added" => "Link hinzugefügt",
"The following site was added, but may require validation by the admin before appearing on the lists." => "Der folgende Link wurde hinzugefügt, muss aber ggf. durch einen Administrator geprüft werden, bevor er in der Liste erscheint.",
"Edit a site" => "Eine Site bearbeiten",
"Add a site" => "Link hinzufügen",
"Directory Categories" => "Verzeichniskategorien",
"{\$countries[ux]}" => "{\$countries[ux]}",
"Admin Directory" => "Linkverzeichnis verwalten",
"There are" => "Es gibt",
"invalid sites" => "ungültige Links",
"valid sites" => "gültige Links",
"Users have visited" => "Benutzer besuchten",
"sites from the directory" => "Links aus dem Verzeichnis",
"Users have searched" => "Benutzer suchten",
"times from the directory" => "mal im Linkverzeichnis",
"Validate" => "überprüfen",
"Admin directory categories" => "Verzeichniskategorien verwalten",
"Parent directory category" => "Übergeordnete Verzeichniskategorie",
"Add a directory category" => "Verzeichniskategorie hinzufügen",
"Edit this directory category" => "Diese Verzeichniskategorie bearbeiten",
"Add a Directory Category" => "Verzeichniskategorie hinzufügen",
"Child type" => "Kind-Typ",
"Most visited directory sub-categories" => "Am häufigsten besuchte Verzeichnisunterkategorien",
"Directory category description" => "Verzeichniskategorie Erklärung",
"Random directory sub-categories" => "zufällig gewählte Verzeichnisunterkategorien",
"Maximum number of child directory categories to show" => "Maximalzahl der angezeigten Kinder",
"Allow sites in this directory category" => "Sites in dieser Verzeichniskategorie erlauben",
"Show number of sites in this directory category" => "Anzahl der Sites in dieser Verzeichniskategorie zeigen",
"Editor group" => "Editor-Gruppe",
"Directory Subcategories" => "Verzeichnis-Unterkategorien",
"cType" => "Kindtyp",
"allow" => "Sites erlaubt",
"count" => "Anzahl",
"editor" => "Ersteller",
// "Relate" => "Relate",
"Admin related directory categories" => "Verwandte Verzeichniskategorien verwalten",
"Add a related directory category" => "Eine verwandte Verzeichniskategorie hinzufügen",
"Directory Category" => "Verzeichniskategorie",
"Mutual" => "gegenseitig",
"Related directory categories" => "Verwandte Verzeichniskategorien",
"Admin sites" => "Links verwalten",
"Is valid" => "Ist gültig",
"New Sites" => "Neue Links",
"Popular Sites" => "Coole Links",
"any" => "irgendeines",
"in entire directory" => "im gesamten Linkverzeichnis",
"in current directory category" => "in gegenwärtiger Linkverzeichniskategorie",
"Sort by" => "Sortiere nach",
"Hits (desc)" => "Treffer/Zugriffe (absteigend)",
"Hits (asc)" => "Treffer/Zugriffe (aufsteigend)",
"Last updated (desc)" => "Letzes Update (absteigend)",
"Last updated (asc)" => "Letzes Update (aufsteigend)",
"sort" => "sortieren",
"No records" => "Keine Einträge",
"Total directory categories" => "Verzeichniskategorien gesamt",
"Total links" => "Links gesamt",
"Links to validate" => "Zu überprüfende Links",
"Searches performed" => "Durchgeführte Suchaufträge",
"Total links visited" => "Besuchte Links gesamt",
"Directory ranking" => "Rang im Verzeichnis",
"Validate sites" => "Links überprüfen",
"country" => "Land",
"Discounts" => "Diskonts",
// "{\$prefs.payment_currency|escape}" => "{\$prefs.payment_currency|escape}",
// " or " => " or ",
"Maximum time the discount can be used in the first phase of payment" => "Maximale Zeit, für die der Diskont in der ersten Phase der Zahlung genutzt werden kann",
"-1 for unlimited" => "-1 forfür unbeschränkt",
"Translation of this page is incomplete." => "Die Übersetzung der Seite ist unvollständig.",
"To add <strong>new content</strong> to the page" => "Um <strong>neuen Inhalt</strong> zur Seite",
"use the editor" => "hinzuzufügen, benutze den Editor",
"Edit article" => "Artikel erstellen/bearbeiten",
"View Articles" => "Artikel ansehen",
"Allow full HTML" => "Erlaube volles HTML",
"Keep any HTML tag" => "Behalte jeden HTML-TAG",
"If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "Wenn nicht aktiviert, hält Tiki einige HTML-Tags zurück (a, p, pre, img, hr, b, i)",
// "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"{\$typei|escape}" => "{\$typei|escape}",
// "Click \"Preview\" after selecting article type to have appropriate edit form fields" => "Click \"Preview\" after selecting article type to have appropriate edit form fields",
// "Publication" => "Publication",
// "If checked, the article is published" => "If checked, the article is published",
// "User (article owner)" => "User (article owner)",
"Time" => "Zeit",
"Own Image" => "Eigenes Bild",
"If not the topic image" => "Wenn nicht das Themenbild",
// "Max file size : {\$prefs.article_image_file_size_max/1000} KB" => "Max file size : {\$prefs.article_image_file_size_max/1000} KB",
"Current Image" => "Aktuelles Bild",
"Article image" => "Artikellogo",
"Image caption" => "Bildbeschreibung",
// "Default will use the topic name" => "Default will use the topic name",
"Use own image" => "Eigenes Bild benutzen",
"Float text around image" => "Text fließt um Bilder herum",
// "Read Article" => "Read Article",
// "Maximum dimensions of custom image in view mode" => "Maximum dimensions of custom image in view mode",
// "Maximum dimensions of custom image in list mode" => "Maximum dimensions of custom image in list mode",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Topline" => "Introzeile",
// "http://.." => "http://..",
// "Test your link: " => "Test your link: ",
"Apply content template" => "Inhaltsvorlage anwenden",
// "{\$template.name|escape}" => "{\$template.name|escape}",
"Email addresses to be sent notifications (comma-separated)" => "E-Mailbenachrichtigung an (mehrere per Komma getrennt)",
"Cancel the edit (changes will be lost)" => "Bearbeitung abbrechen, Deine Änderungen werden verworfen",
// "Create or edit banners" => "Create or edit banners",
"List banners" => "Banner anzeigen",
"URL to link the banner" => "URL, die mit dem Banner verknüpft wird",
"Client" => "Agent",
"Maximum impressions" => "Max. Aufrufe",
"Maximum number of impressions for a user" => "Maximale Anzahl Aufrufe eines Benutzers",
"Maximum clicks" => "Maximale Klicks",
"URIs where the banner appears only" => "URLs, wo das Banner ausschließlich erscheinen soll",
"Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Trage jede URL getrennt mit einem #-Zeichen ein. Beispiel: #/diese_Seite#/tiki-index.php?page=diese_Seite#",
// "URIs where the banner will not appear" => "URIs where the banner will not appear",
"Or, create a new zone" => "Oder, erstelle eine neue Zone",
// "New Zone" => "New Zone",
"Show the banner only between these dates" => "Banner nur während dieser Tage zeigen",
"From date" => "Von Datum",
"To date" => "Bis Datum",
"Use dates" => "Datum benutzen",
// "Show the banner only in these hours" => "Show the banner only in these hours",
"Show the banner only on" => "Zeige das Banner nur auf",
"Select ONE method for the banner" => "EINE Methode für das Banner auswählen",
"Use Image" => "Bild benutzen",
// "Use Image from URL" => "Use Image from URL",
// "(the image will be requested at the URL for each impression)" => "(the image will be requested at the URL for each impression)",
"Use Flash" => "Benutze Flash",
"Movie Size" => "Filmgröße",
// "width in pixels" => "width in pixels",
"Pixels" => "Pixel",
// "height in pixels" => "height in pixels",
"FlashPlugin min version" => "FlashPlugin min. Version",
"ex" => "Bsp",
// "Use Text" => "Use Text",
"Save the Banner" => "Das Banner speichern",
"Remove zones (info entered for any banner in the zones will be lost)" => "Zonen entfernen (Du verlierst die eingegebenen Informationen für das Banner)",
"Edit Blog" => "Blog bearbeiten",
"A category is mandatory" => "Eine Kategorie ist obligatorisch",
"Individual permissions are set for this blog" => "Es gibt individuelle Berechtigungen für dieses Blog",
"Allow other users to post in this blog" => "Erlaube anderen Benutzern in diesen Blog zu schreiben",
"Even if others post to the blog, the author is always its administrator" => "Wenn andere in den Blog posten, soll der Autor jeweils Eigentümer sein",
"Allow search" => "Suchen erlauben",
"Allow comments" => "Kommentare erlauben",
"Use post excerpt" => "Benutze Eintrags-Exzerpt",
"Display Options" => "Anzeigeoptionen",
// "Displayed posts" => "Displayed posts",
"Number of posts to show per page" => "Anzuzeigende Anzahl der Einträge je Seite",
"Display the blog title on the posts list page" => "Zeige den Blog Titel in der Listenansicht",
"Display the blog title on the post page" => "Zeige den Blog Titel auf der Eingabeseite",
"Display the blog description" => "Zeige die Blogbeschreibung",
"Display breadcrumbs" => "Zeige die Breadcrumbs",
"Display the author in blog posts" => "Zeige den Autor im Blogeintrag an",
"Display the publish date in blog posts" => "Zeige das Publizierungsdatum in den Blogeinträgen an",
"Show user profile picture" => "Zeige den Benutzer-Avatar an",
"Show the post's related content" => "Zeige zum Eintrag \"verbundene\" Inhalte",
"The checkbox is disabled because the tags feature is disabled globally" => "Das Häkchenfeld ist deaktiviert, weil die Funktion Tags global deaktiviert ist",
// "Related posts" => "Related posts",
"Maximum number of related posts to display" => "Maximal anzuzeigende Anzahl \"verbundener\" Einträge",
"Blog heading" => "Blog Kopfbereich",
"Heading preview" => "Überschrift Vorschau",
"Blog post heading" => "Blogeintrag Kopfbereich",
"Organizer" => "Organizer",
"Move objects between categories" => "Objekte zwischen Kategorien verschieben",
"Click on the category name to display the list of objects in that category." => "Klicke auf einen Kategorienamen. Du erhältst eine Liste aller Objekte in dieser Kategorie.",
"Select the objects to affect. Controls will appear in the category browser." => "Wähle das Objekt aus, dessen Kategorie Du ändern möchtest. Steuerfunktionen erscheinen im Kategoriebrowser.",
"Use the plus and minus signs to add or remove the categories on selected objects." => "Benutzer die Plus- und Minuszeichen, um Kategorien zum Objekt hinzuzufügen oder zu entfernen.",
// "Object list result" => "Object list result",
// "Select objects to change categorization" => "Select objects to change categorization",
"More results are available. Please refine the search criteria" => "Weitere Ergebnisse sind verfügbar. Bitte verfeinere die Suchkriterien",
"Select all" => "alle auswählen",
"Unselect all" => "alle abwählen",
"The file will be saved in" => "Diese Datei wird gespeichert in",
// "Currently trying" => "Currently trying",
"Try" => "Ausprobieren",
// "Missing Package" => "Missing Package",
// "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package" => "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package",
// "Please contact the Administrator to install it" => "Please contact the Administrator to install it",
"Tiki Docs" => "Tiki Dokumente",
"Save file" => "Datei speichern",
"Cancel editing file" => "Bearbeitung der Datei abbrechen",
"Editing file" => "Bearbeitung der Datei",
"Save and Back" => "Speichern und zurück",
"Rename" => "Umbenennen",
"Toggle Fullscreen" => "Vollbild umschalten",
"More information" => "Weitere Informationen",
"Wiki Page Editor" => "Wiki Seiteneditor",
"More help on editing wiki pages" => "Weitere Hilfe für die Bearbeitung von Wiki Seiten",
"The syntax system used for creating pages in Tiki" => "Das Syntaxsystem für die Erstellung von Seiten in Tiki",
"Bold text" => "Fetter Text",
"Italic text" => "Kursiver Text",
"single quotes" => "einzelne Anführungszeichen",
"Underlined text" => "unterstrichener Text",
"Colored text" => "Farbiger Text",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background." => "Zeigt die indizierte HTML Farbe oder den Farbnamen an. Der Farbname kann zwei Farben durch ein Komma getrennt enthalten. In diesem Fall stellt die erste Farbe den Vordergrund und die zweite Farbe den Hintergrund dar.",
"Deleted text" => "gelöschter Text",
"2 dashes" => "2 Bindestriche",
"Headings" => "Überschriften",
"show/hide heading section. + (shown) or - (hidden) by default" => "zeige/verberge Kopfbereich - standardmässig + (angezeigt) oder - (verborgen)",
"Autonumbered Headings" => "Automatisch nummerierte Überschriften",
"{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} gibt eine Inhaltsangabe für die gegenwärtige Seite aus, basierend auf Strukturen (toc) oder ! Überschriften (maketoc)",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename." => "Übliche optionale Parameter für maketoc sind: title|maxdepth|levels|nums - und für toc sind es: order|showdesc|shownum|structId|maxdepth|pagename.",
"Horizontal rule" => "Horizontale Linie",
"Text box" => "Textbox",
"Box content" => "Box-Inhalt",
"Centered text" => "Zentrierter Text",
"Inserts an editable variable" => "Fügt eine bearbeitbare Variable ein.",
"External links" => "Externe Links",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "Benutze eckige Klammern für externe Links: [URL], [URL|Link_Beschreibung],[URL|Link_Beschreibung|Relation] oder [URL|Link_Beschreibung|Relation|nocache] (Das Letzte verhindert das Cachen der gelinkten Seite durch das lokale Wiki; Relation kann benutzt werden, um relative Attribute für den Link einzufügen - nützlich zum Beispiel für Shadowbox).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Für ein externes Wiki benutze: ExternalWikiName:PageName oder ((External Wiki Name: Page Name))",
"Square Brackets" => "Eckige Klammern",
"Use [[foo] to show [foo]." => "[[foo] benutzen, damit [foo] ausgegeben wird.",
"JoinCapitalizedWords or use" => "ZusammenGrossKleinSchreibung oder benutze",
"page|description" => "Seite|Beschr.",
"for wiki references" => "für Wiki-Referenzen",
"page|#anchor" => "Seite|#Anker",
"page|#anchor|desc" => "Seite|#Anker|Beschreibung",
"for wiki heading/anchor references" => "für Wiki Kopf/Ankerreferenz",
"SomeName" => "EinName",
"prevents referencing" => "verhindert Referenzierung",
"Lists" => "Listen",
"for bullet lists" => "für einfache Listen",
"for numbered lists" => "für nummerierte Listen",
"definition" => "Definition",
"for definiton lists" => "für Definitionslisten",
"Indentation" => "Einrückung",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "erstellt eine Einrückung für jedes Pluszeichen (nützlich in Listen, um in der gleichen Eben fortzusetzen)",
"Tables" => "Tabellen",
"row" => "Reihe",
"col" => "Spalte",
"Monospace font" => "Nichtproportionale Schrift",
"Code sample" => "Code Beispiel",
"(very useful especially in tables)" => "(sehr nützlich, vor allem in Tabellen)",
"Multi-page pages" => "Mehrseitige Seiten",
"to separate pages" => "und Seiten in mehrere zu trennen",
"Non-parsed sections" => "Nicht geparste Bereiche",
"data" => "Daten",
"Prevents wiki parsing of the enclosed data." => "Verhindert das parsen von Wikisyntax der eingeschlossenen Daten",
"Preformated sections" => "Vorformatierte Bereiche",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "~pp~ Text ~/pp~ Zeigt vorformatierten Text/Code; es findet keine Wikibearbeitung des Textes mehr statt (so wie np). Auch Abstände sind fixiert (es findet kein Zeilenumbruch statt).  ~pre~ Text ~/pre~ macht das Gleiche wie ~pp Text ~/pp; nur wird der Text Wikibearbeitet.",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "~tc~ Text ~/tc~ erstellt einen Tikikommentar.  Dieser ist nicht sichtbar, wird aber zusammen mit der Datei zu künftigen Nachweisen abgespeichert.  ~hc~ Text ~/hc~ fügt einen HTML-Kommentar ein.  Er wird als Kommentar im HTML-Output eingefügt und kann dann vom Browser über die Quelltextanzeige angezeigt werden.",
"Block Preformatting" => "Block Vorformatierung",
"Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Rücke Text mit einer beliebigen Zahl von Leerzeichen ein, um ihn in in einen Block nichtproportionaler Schrift umzuwandeln. Andere Wiki Formatierungen bleiben erhalten. Er wird mit der gleichen Zahl von Leerzeichen eingerückt, die benutzt wurden.  Beachte, dass dieser Modus nicht die exakten Abstände und Zeilenumbrüche erhält; Benutze ~pp~...~/pp~ hierfür",
"Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew." => "Fügt ein DIV für die Textschreibrichtung recht-nach-links bzw. links-nach-rechts-ein. Außerdem eine Kennzeichnung für die Sprache als Arabisch und Herbräisch.",
"Special characters" => "Sonderzeichen",
"hard space" => "untrennbares Leerzeichen",
"numeric between ~ for HTML numeric characters entity" => "numerisch zwischen ~ für eine numerische HTML-Zeicheneinheit",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Beachte, dass Pluginargumente in Anführungszeichen eingeschlossen werden können (\"); dies erlaubt ihnen, 'or  = or >' zu enthalten;",
"More help here" => "Hier mehr Hilfe",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki Plugins erweitern die Funktionen des Wiki Syntaxes um weitere, spezialisierte Befehle",
"Activate/deactivate plugins" => "Plugins aktivieren/deaktivieren",
"No description available" => "Keine Beschreibung vorhanden.",
"For more information, please see" => "Für weitere Informationen siehe auch",
"WYSIWYG Editor" => "WYSIWYG Editor",
"More help on WYSIWYG editing" => "Weitere Hilfe für die WYSIWYG-Bearbeitung",
// "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>" => "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar",
"<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent." => "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa. \tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes. \tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent.",
"<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>Beachte:</strong> Diese Schaltfläche schaltet zwischen WYSIWYG und dem normalen Wiki Editor um, lässt aber den Seitenquelltext im Wiki Syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered" => "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered",
// "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around" => "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around",
// "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "Bild betrachten",
"Edit successful!" => "Bearbeitung erfolgreich!",
"The following image was successfully edited" => "Das folgende Bild wurde erfolgreich bearbeitet",
"Image Description" => "Bildbeschreibung",
"Upload from disk to change the image" => "Von Festplatte hochladen, um das Bild zu ändern",
"Save and Go Next" => "Speichern und zum nächsten gehen",
"Edit Invoice" => "Bearbeite Rechnung",
"Invoice Number" => "Rechnungsnummer",
"Date Issued" => "Ausstellungsdatum",
"Work Description" => "Beschreibung der Position",
"Taxable" => "Steuerpflichtig",
"New Item" => "Neue Position",
"Invoice Note" => "Rechnungshinweis",
"Save Invoice" => "Rechnung speichern",
"Customized String Translation" => "Benutzerdefinierte Übersetzung",
// "Manage local translations in a custom.php file" => "Manage local translations in a custom.php file",
// "Download language.php file for the selected language" => "Download language.php file for the selected language",
// "Download Database Translations" => "Download Database Translations",
// "Download a file with all the translations in the database for the selected language" => "Download a file with all the translations in the database for the selected language",
// "Translations in the database will be merged with the other translations in language.php for the selected language" => "Translations in the database will be merged with the other translations in language.php for the selected language",
"Add a translation" => "Übersetzung hinzufügen",
"Untranslated strings" => "Unübersetzte Texte",
"Show only database stored untranslated strings" => "Zeige nur unübersetzte Texte, die in der Datenbank gespeichert sind",
"Edit translations" => "Übersetzungen bearbeiten",
"Show only database stored translations" => "Zeige nur in der Datenbank gespeicherte Übersetzungen",
"Translation:" => "Übersetzung:",
// "Original string" => "Original string",
"Last changed by %0 on %1" => "Zuletzt geändert von %0 am %1",
// "Contribute" => "Contribute",
"Undecided" => "Unentschieden",
// "Save translation in the database" => "Save translation in the database",
// "Delete translation from the database" => "Delete translation from the database",
"Compare" => "Vergleichen",
// "Compare the original translation with the database translation" => "Compare the original translation with the database translation",
// "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes" => "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes",
"Translate all" => "Alle übersetzen",
"Delete all" => "alle löschen",
"Are you sure you want to delete all untranslated strings from database" => "Bist Du sicher, dass Du alle nicht übersetzten Strings aus der Datenbank löschen willst",
"Are you sure you want to delete all translations from database" => "Bist Du sicher, dass Du alle übersetzten Strings aus der Datenbank löschen willst",
"Return to the default perspective" => "Kehre zur Standardperspektive zurück",
"Switch to" => "Schalte um zu",
// "Preference List" => "Preference List",
// "Search preferences below and drag them into the preference list above" => "Search preferences below and drag them into the preference list above",
"Program dynamic content for block" => "Dynamischen Inhalt für den Block programmieren",
"Create New Block" => "Neuen Block erzeugen",
"Return to block listing" => "Zurück zur Block-Auflistung",
"Block description: " => "Blockbeschreibung: ",
"You are editing block:" => "Du bearbeitest Block:",
// "Publising Date" => "Publising Date",
"Publishing Date" => "Veröffentlichungszeitpunkt",
"Edit question options" => "Antworten bearbeiten",
"List Quizzes" => "Quiz auflisten",
"Quiz Stats" => "Quizstatistiken",
"This Quiz Stats" => "Statistik für dieses Quiz",
"Edit this Quiz" => "Dieses Quiz bearbeiten",
"Admin Quizzes" => "Quiz verwalten",
"Create/edit options for question" => "Optionen für Frage erstellen/bearbeiten",
"points" => "Bewertung",
"Quiz can be repeated" => "Quiz kann wiederholt werden",
// "Time Limit" => "Time Limit",
"Create/edit quizzes" => "Quiz hinzufügen/bearbeiten",
"There are individual permissions set for this quiz" => "Für dieses Quiz gibt es individuelle Berechtigungen",
"Store quiz results" => "Quiz-Ergebnisse abspeichern",
"Quiz is time-limited" => "Ratezeit ist limitiert",
"Maximum time" => "Maximale Zeit",
"Passing Percentage" => "Erfolgreich bei mindestens %",
"%" => "%",
"Edit quiz questions" => "Quizfragen bearbeiten",
"Create/edit questions for quiz" => "Fragen für Quiz erstellen/bearbeiten",
"Question Type" => "Fragetyp",
"Import questions from text" => "Importiere Fragen aus Text",
// "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct" => "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct",
"Input" => "Eingabe",
"Maximum score" => "maxPunktzahl",
"Edit quiz results" => "Quizzergebnisse bearbeiten",
"From Points" => "von Punkten",
"To Points" => "zu Punkten",
"Reports" => "Berichte",
"Report Builder" => "Berichtersteller",
"Report Type" => "Berichtstyp",
"Select Report Type" => "Wähle Berichtstyp",
"Wiki Data" => "Wiki Daten",
"Export As CSV" => "Als CSV exportieren",
"You will remove" => "Du entfernst",
"and its subpages from the structure, now you have two options:" => "und seine Unterseiten von der Struktur. Du hast jetzt zwei Optionen:",
"and its subpages from the structure" => "und seine Unterseiten von der Struktur",
// "Remove from structure" => "Remove from structure",
"Remove from structure and remove page too" => "Aus Struktur und die Seite selbst entfernen",
"The page already exists. The page that has been added to the structure is the existing one." => "Die Seite existiert bereits. Die Seite, die zur Struktur hinzugefügt wurde ist die existierende.",
"The following pages added have automatically been categorized with the same categories as the structure" => "Die folgenden Seiten wurden automatisch mit der gleichen Kategorie wie die Struktur sie hat kategorisiert",
"Structure Layout" => "Struktur Layout",
// "Monitor the structure" => "Monitor the structure",
// "Stop Monitoring the structure" => "Stop Monitoring the structure",
"Add pages" => "Seiten hinzufügen",
"Use an existing page by dragging it into the structure above" => "Benutze bereits existierende Seite, indem Du sie in die Struktur oben ziehst",
"{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "Kategorisiere alle Seiten in der Struktur zusammen",
"Remove existing categories from ALL pages before recategorizing" => "Entferne bestehende Kategorien von ALLEN Seiten bevor sie neu kategorisiert werden",
"Move to another structure" => "verschieben in andere Struktur",
"at the beginning" => "am Anfang",
"at the end" => "am Ende",
"Submit article" => "Artikel einreichen",
"List submissions" => "Einreichungen auflisten",
"Use ...page... to separate pages in a multi-page post" => "Benutze ...page... um den Eintrag in mehrere Seiten zu untergliedern",
// "Fields with <b>*</b> are optional" => "Fields with <b>*</b> are optional",
"<b>Topline</b>=small line above Title" => "<b>Kopfzeile</b>=schmale Zeile über Titel",
"<b>Subtitle</b>=small line below Title" => "<b>Untertitel</b>=schmale Zeile unter Titel",
"<b>Source</b>=URL to article source" => "<b>Quelltext</b>=URL zum Artikel-Quelltext",
"Author Name" => "Autor",
"Own image size x" => "Eigene Bildbreite",
"Own image size y" => "Eigene Bildhöhe",
"Auto-Approve Article" => "Artikel automatisch freigeben",
"View template" => "Vorlage betrachten",
"Template listing" => "Vorlagenliste",
"Available templates" => "Verfügbare Templates",
"Important" => "Wichtig",
// "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme:" => "Nur für diesen Style speichern:",
"Delete the copy in the theme" => "Lösche die Kopie des Theme",
"Admin Article Topics" => "Verwalte Artikelthemen",
// "Edit article topic" => "Edit article topic",
"Admin notifications" => "Administratorbenachrichtigung",
// "Enter email addresses " => "Enter email addresses ",
"View Article" => "Artikel anzeigen",
"Attach or detach existing translations of this page" => "Hänge existierende Übersetzungen dieser Seite an oder löse sie ab",
// "Manage Translations" => "Manage Translations",
"You must specify the object language" => "Du musst die Sprache des Objekts angeben",
"The object doesn't exist" => "Das Objekt ist nicht vorhanden",
"The object doesn't have a language" => "Das Objekt hat nicht die angegebene Sprache",
"The object already has a translation for this language" => "Das Objekt hat bereits eine Übersetzung für diese Sprache",
"The object is already in the set of translations" => "Das Objekt ist bereits als Übersetzung gespeichert",
"Translate this page to a new language" => "Übersetze diese Seite in eine neue Sprache",
"Select language to translate to:" => "Wähle die Sprache in die übersetzt wird:",
"Enter the page title:" => "Titel für Seite eingeben:",
// "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
"Create translation" => "Übersetzung erstellen",
"Change language for this page" => "Sprache für diese Seite ändern",
"Change Language" => "Sprache ändern",
// "You forgot to specify the language of the translation. Please choose a language in the picklist" => "You forgot to specify the language of the translation. Please choose a language in the picklist",
"The page already exists. It was selected in the list below." => "\"Die Seite existiert bereits. Die wurde in der Liste unterhalb ausgewählt.\"",
"No language is assigned to this page" => "Keine Sprache für diese Seite festgelegt",
"Please select a language before translating" => "Bitte lege eine Sprache für die Seite fest, bevor Du die Übersetzung beginnst",
// "Set Page Language" => "Set Page Language",
// "Edit %0" => "Edit %0",
"Update '{\$page}'" => "Aktualisiere '{\$page}'",
"{\$customTip|escape}" => "{\$customTip|escape}",
"Preview your changes" => "Vorschau Deiner Änderungen",
"Draft written on" => "Entwurf geschrieben am",
"Warning: new versions of this page have been made after this draft" => "Warnung: von dieser Seite wurden neue Versionen nach diesem Entwurf erstellt",
"The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page." => "Die SandBox ist eine Seite, an der Du Bearbeiten üben kannst. Benutze die Vorschaufunktion, um sich das Resultat Deiner Seite anzusehen. Keine Version dieser Seite wird gespeichert.",
// "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)" => "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)",
"An edit summary is mandatory" => "Eine Bearbeitungszusammenfassung ist zwingend",
"Translate from" => "Übersetzen aus",
"Changes that need to be translated are highlighted below" => "Änderungen, die übersetzt werden müssen sind unten hervorgehoben",
"No comment" => "kein Kommentar",
"All Versions" => "Alle Versionen",
"Edit wiki page" => "Wiki-Seite bearbeiten",
"Select the style used to display differences to be translated" => "Wähle den Stil, mit dem die zu übersetzenden Unterschiede hervorgehoben werden sollen",
"text full" => "Text voll",
"Change the style used to display differences to be translated" => "Ändere den Stil, mit dem die zu übersetzenden Unterschiede hervorgehoben werden sollen",
"Change diff styles" => "Ändere den Diff-Style",
"Translate to" => "Übersetzen auf",
"Reproduce the changes highlighted on the left using the editor below" => "Reproduziere die hervorgehobenen Änderungen auf der linken Seite mittels des Editor",
"Describe the change you made" => "Kurze Beschreibung Deiner Änderungen",
"Edit comment: Enter some text to describe the changes you are currently making" => "Bearbeitungskommentar: Trage einen Text ein, der beschreibt, welche Änderungen Du machst",
"Monitor this page" => "Diese Seite beobachten",
"Upload picture" => "Bild hochladen",
"Add another image" => "weiteres Bild anhängen",
"Categorization has been preset for this edit" => "Kategorisierung wurde für diese Bearbeitung vorgegeben",
"Categories will be inherited from the structure top page" => "Kategorien werden von der obersten Seite der Struktur vererbt",
// "Leave page and go to..." => "Leave page and go to...",
// "Wiki Preferences" => "Wiki Preferences",
// "Copyright notices" => "Copyright notices",
// "Copyright page" => "Copyright page",
"{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Lock this page" => "Diese Seite sperren:",
"Allow comments on this page" => "Erlaube Kommentare auf dieser Seite",
// "HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "HTML tags are used to create elements of the wiki page, instead of being displayed as code",
"Try to convert HTML to wiki" => "Versuche HTML in Wiki zu konvertieren",
"Import page" => "Seite importieren",
// "Export page" => "Export page",
// "Export all versions" => "Export all versions",
// "Attach file" => "Attach file",
"Only cache a page if it should look the same to all groups authorized to see it" => "Cache nur dann eine Seite, wenn sie für alle authorisierten Gruppen gleich aussehen soll",
"{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
"Site default" => "Site-Default",
"as Creator &amp; Last Editor" => "als Ersteller &amp; letzter Bearbeiter",
"no (disabled)" => "keine (deaktiviert)",
"Description (used for metatags)" => "Beschreibung (für Metatags benutzt)",
"My Footnotes" => "Fußnoten",
"{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "Keine Abstimmungsvorlage vorhanden.",
"Please ask an administrator to create one." => "Du solltest den Administrator bitten, eines anzulegen",
// "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Anfrage Übersetzung",
"Send urgent translation request" => "Sende dringende Übersetzungsanfrage",
// "Geolocation" => "Geolocation",
// "Show page title" => "Show page title",
// "Explicit Namespace" => "Explicit Namespace",
// "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace" => "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace",
// "Page layout" => "Page layout",
// "Site Default" => "Site Default",
"{\$title}" => "{\$title}",
"List Sheets" => "Tabellen auflisten",
"Graph" => "Grafik",
"Export to file" => "In Datei exportieren",
"Charset encoding:" => "Zeichensatzkodierung:",
"Autodetect" => "Automatische Erkennung",
"Admin FAQ" => "FAQ verwalten",
"List FAQs" => "FAQs auflisten",
"View FAQ" => "FAQ anzeigen",
"Edit this FAQ" => "Diese FAQ bearbeiten",
"New Question" => "Neue Frage",
"Edit FAQ question" => "FAQ-Frage bearbeiten",
"Add FAQ question" => "FAQ-Frage hinzufügen",
"Use a question from another FAQ" => "Eine Frage aus einer anderen FAQ benutzen",
"FAQ questions" => "FAQ-Fragen",
"Suggested questions" => "Vorgeschlagene Fragen",
"No suggested questions" => "Keine vorgeschlagenen Fragen",
"File Archive" => "Dateiarchiv",
"Size (width x height)" => "Größe (Breite x Höhe)",
"Content waiting for approval" => "Auf Bestätigung wartender Inhalt",
"You are currently viewing the latest version of the page" => "Du siehst Dir gegenwärtig die aktuellste Version der Seite an",
"You can also view the {self_link}latest approved version{/self_link}" => "Du kannst auch die {self_link}zuletzt bestätigte Version{/self_link} ansehen",
"You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "Du kannst diese Version bestätigen und sie einem größeren Publikum zugänglich machen. Stelle sicher, dass Du alle Änderungen prüfst, bevor die Seite freigegeben wird",
"Show changes since last approved revision" => "Zeige Änderungen seit letzter bestätigter Revision",
"This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "Diese Seite hat keine früheren bestätigten Revisionen. <strong>Der gesamte Inhalt muss geprüft werden.</strong>",
"Approve current revision" => "Bestätige gegenwärtige Revision",
// "Reject current revision" => "Reject current revision",
"You are currently viewing the approved version of the page" => "Du siehst Dir gegenwärtig die bestätigte Version der Seite an",
"You can also view the {self_link latest=1}latest version{/self_link}" => "Du kannst auch die {self_link latest=1}aktuellste Version{/self_link} ansehen",
"View the {self_link latest=1}latest version{/self_link}" => "{self_link latest=1}Aktuellste Version{/self_link} ansehen",
"Forum Importer" => "Forum Importierer",
"Import from a Local SQL File" => "Von einer lokalen SQL-Datei importieren",
"Forum Type" => "Forumtyp",
"DB Prefix" => "Datenbankpräfix",
"Local SQL Filename on Server (path will be stripped)" => "Lokaler SQL Dateiname auf dem Server (Pfadangabe wird entfernt)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Muss in tikiroot/{\$tmpdir} oder tikiroot/img/wiki_up sein",
"Get Forum List" => "Hole Forumsliste",
"Verification" => "Übgerprüfung",
"File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "Datei muss eine SQL-Datei sein und entweder in <i>\$tikiroot/temp</i> oder <i>\$tikiroot/img/wiki_up</i> sein",
"File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "Datei wurde nicht angegeben oder konnte nicht gefunden werden. Bitte kopiere die Datei in eines der Verzeichnisse und gehe zurück. Wenn die Datei in beiden Verzeichnissen existiert, wird \$tikiroot/{\$filecheck} bevorzugt",
"Proceed" => "Fortfahren",
"Go Back" => "Zurück",
"Select a Forum You Wish to Move (ONE at a time!)" => "Wähle ein Forum, dass Du verschieben willst (nur EINES auf einmal!)",
"Which Forum Do You Wish to Import this Into" => "In welches Forum soll dies importiert werden",
// "Refresh list" => "Refresh list",
"Edit queued message" => "Nachrichten-Liste bearbeiten",
// "Make this a thread of" => "Make this a thread of",
"None, this is a thread message" => "nichts, dies ist eine Thread-Nachricht",
"summary" => "Zusammenfassung",
"Announce" => "Ankündigung",
"Hot" => "hot",
"no feeling" => "gleichgültig",
"frown" => "verdutzt",
"exclaim" => "ausrufend",
"idea" => "Idee",
"mad" => "sauer",
"neutral" => "neutral",
"question" => "fragend",
"sad" => "traurig",
"happy" => "fröhlich",
"wink" => "winkend",
"Save and Approve" => "Speichern und freigeben",
// "Convert to topic" => "Convert to topic",
"New Topic" => "Neues Thema",
"no summary" => "keine Zusammenfassung",
"No messages queued yet" => "Es stehen keine Nachrichten an",
"Search by name" => "Suche nach Name",
"Search in content" => "Suche im Inhalt",
"Last Post" => "Neuester Eintrag",
// "{\$section|escape}" => "{\$section|escape}",
// "No forums found" => "No forums found",
// "Loading" => "Loading",
"Reported by" => "Gemeldet von",
"Perfom action with checked" => "Führe Aktion mit geprüften durch",
"Un-report" => "ent-berichten",
"Tag translation" => "Tag-Übersetzung",
// "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated" => "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated",
// "Show checkboxes" => "Show checkboxes",
"There are no tags on this page in your preferred languages" => "Es gibt keine Tags in der von Dir bevorzugten Sprache auf dieser Seite",
"Set language" => "Sprache einstellen",
"Universal" => "Universal",
// "Displayed languages" => "Displayed languages",
"Friendship Network" => "Freundschaftsnetzwerk",
"Galleries" => "Galerien",
"Create New Gallery" => "Neue Galerie anlegen",
// "Migrate Images to File Gallery" => "Migrate Images to File Gallery",
"Create a gallery" => "Neue Galerie anlegen",
"Edit this gallery:" => "Diese Galerie bearbeiten:",
"There are individual permissions set for this gallery" => "Für diese Galerie gibt es individuelle Berechtigungen",
"Gallery is visible to non-admin users?" => "Galerie sichtbar für Nicht-Administratoren?",
"Max Rows per page" => "Max. Zeilen pro Seite",
"Thumbnails size X" => "Thumbnails Breite",
"Thumbnails size Y" => "Thumbnails Höhe",
"Fields to show during browsing the gallery" => "Angezeigte Felder beim Durchstöbern der Galerie",
"XY-Size" => "XY-Dimension",
"Gallery Image" => "Galerie Logo",
"Available scales" => "Verfügbare Skalierungen",
"Global default" => "Globaler Standard",
"Bounding box" => "Rahmen",
"default scale" => "Standardmaßstab",
// "Default scale" => "Default scale",
"No scales available" => "Keine Skalierungen verfügbar",
"Original image is default scale" => "Originalbild ist die Standard-Skalierung",
"Add scaled images with bounding box of square size" => "Skalierte Bilder in Box anzeigen, Kantenlänge",
"Other users can upload images to this gallery" => "Andere Benutzer können Bilder in diese Galerie hochladen",
"You can access the gallery using the following URL" => "Du kannst die Galerie über folgende URL erreichen",
"Available Galleries" => "Verfügbare Galerien",
"Choose a filter" => "Filter wählen",
"Imgs" => "Bilder",
// "Make map" => "Make map",
"Select Graphic Type" => "Wähle den Grafiktyp",
"Pie Chart" => "Tortendiagramm",
"Multiline" => "Liniendiagramm",
"Multibar" => "Balkendiagramm",
"Bar Stack" => "gestapelte Balken",
"Independant Scale" => "Unabhängige Skalierung",
"Horizontal Scale" => "Horizontale Skalierung",
"Vertical Scale" => "Vertikale Skalierung",
"Series" => "Serien",
"Edit Spreadsheet" => "Tabelle bearbeiten",
"List Spreadsheets" => "Tabellen auflisten",
"Wiki plug-in" => "Wiki Plug-in",
"Spreadsheet History" => "Tabellenkalkulations-Historie",
"Roll back" => "Zurückrollen",
"Toggle Full Screen" => "Vollbild umschalten",
"Date Selection" => "Datumsauswahl",
"Edit Date" => "Datum bearbeiten",
"View Spreadsheet" => "Tabelle ansehen",
"Clone Spreadsheet" => "Tabelle klonen",
"Roll back spreadsheet" => "Tabellen zurückrollen",
"Import From File" => "Aus Datei Importieren",
// "File to import" => "File to import",
"Grab Wiki Tables" => "Wiki Tabellen wählen",
"Import pages from a Structured Text Dump" => "Seiten aus einem strukturierten Text-Dump importieren",
"Name of the dump file (it has to be in dump/)" => "Name der Dump-Datei (sie muss in dump/ sein)",
"Overwrite existing pages if the name is the same" => "Überschreibe vorhandene Seiten, falls der Name gleich ist",
// "Remove previously existing page versions" => "Remove previously existing page versions",
"excerpt" => "Auszug",
"Result" => "Ergebnis",
"body" => "Inhalt",
"Name of the zip file on the server" => "Name der ZIP-Datei auf dem Server",
"Tiki Importer" => "Tiki Importer",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer!" => "Wenn Du KEINE neue Tikiinstallation benutzt, erstelle vorher unbedingt ein Backup Deiner Datenbank bevor Du diesen Importer benutzt.",
"If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "Wenn Deine Seiten XML-Code enthalten, wird der HTML Bereiniger diesen löschen. Deaktiviere diese Funktion",
"Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Dein PHP läuft im Sicherheitsmodus. Dies kann Probleme beim Importieren verursachen, da der Sicherheitsmodus die Möglichkeiten einschränkt PHP-Einstellungen vorzunehmen (wie etwa max_execution_time). Es wird empfohlen das Script ohne Sicherheitsmodus laufen zu lassen",
"Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)." => "Abhängig von der Größe der Datei der Quellsoftware kann der Importvorgang einer Weile dauern. Dies kann zu einem Problem mit Deinen PHP und Webserver Einstellungen führen. Das Skript versucht daher die relevanten Einstellungen zu ändern. Manche Einstellungen können durch das Skript aber nicht verändert werden. Wenn Du also Probleme beim Import hast, versuche die folgenden PHP Einstellungen zu erhöhen: max_input_time, max_execution_time (diese Einstellung ist durch den Webserver begrenzt. Wenn Du einen Apacheserver benutzt musst Du auch dort die Timeouteinstellungen ändern), post_max_size, upload_max_filesize, memory_limit. Es ist daher zu empfehlen, das Skript auf einem Server laufen zu lassen, auf dem man die vorgenannten Werte ändern kann (wenn nötig).",
"Select the software to import from" => "Wähle die Software von der importiert werden soll",
"Select.." => "Wähle..",
"WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNUNG: Stelle sicher, dass Du eine Sicherheitskopie erstellt hast, bevor Du das Script startest. Wenn Du keine Sicherheitskopie hast, ist das die letzte Möglichkeit den Importierer durch klicken auf Abbrechen zu stoppen",
"Congratulations! You have successful imported your data to Tiki" => "Gratulation! Du hast Deine Daten erfolgreich in Tiki importiert",
"%0 pages imported from a total of %1" => "%0 Seiten von insgesamt %1 importiert",
"%0 pages imported" => "%0 Seiten importiert",
"(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(Du kannst eine Liste von Wiki Seiten Deiner Site <a href=\"tiki-listpages.php\">hier</a> sehen)",
"%0 posts imported" => "%0 Posts importiert",
"%0 tags imported" => "%0 Tags importiert",
"%0 categories imported" => "%0 Kategorieren importiert",
"Importer log" => "Importer-Log",
"Suggested .htaccess rules" => "Vorgeschlagene .htaccess-Regeln",
"Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Installation" => "Installation",
"Tiki Icon" => "Tiki-Symbol",
"Tiki Project Web Site" => "Tiki Projekt Website",
"Support Forums" => "Support Foren",
"Welcome" => "Willkommen",
// "Welcome to the <strong>Tiki %0</strong> installer" => "Welcome to the <strong>Tiki %0</strong> installer",
// "Use this script to install a new database or upgrade your existing database" => "Use this script to install a new database or upgrade your existing database",
"For the latest information about this release, please read the" => "Für aktuelle Informationen zu dieser Veröffentlichung lies bitte die",
"Release Notes" => "Veröffentlichungshinweise",
"For complete documentation, please visit" => "Für eine vollständige Dokumentation besuche bitte",
"For more information about Tiki, please visit" => "Für mehr Information über Tiki besuche bitte",
"Select your language" => "Wähle Deine Sprache",
// "License" => "License",
"Tiki is software distributed under the LGPL license" => "Tiki Software wird unter der LGPL Lizenz vertrieben",
"Review the System Requirements" => "Prüfe die Systemvorraussetzungen",
// "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements",
"This installer will perform some basic checks automatically" => "Dieser Installer wird einige Prüfungen automatisch ausführen",
// "Please see: " => "Please see: ",
"a detailed report about your server" => "ein detailierter Bericht über Ihren Server",
"Memory" => "Speicher",
"Tiki has not detected your PHP memory_limit" => "Tiki hat Dein PHP memory_limit nicht erkannt",
"This probably means you have no set limit (all is well)" => "Das heißt wahrscheinlich, dass Du überhaupt kein Limit gesetzt hast (dann ist alles in Ordnung)",
"Tiki has detected your PHP memory limit at" => "Tiki hat Deine PHP Speichergrenze erkannt",
"Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki erfordert <strong>mindestens</strong> 128MB PHP Speicher zur Ausführung von Skripten",
"Allocating too little memory will cause Tiki to display blank pages" => "Wird zu wenig Speicher zur Verfügung gestellt, können leere Seiten angezeigt werden",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "Um die Speichergrenze zu ändern, benutze den Eintrag <strong>memory_limit</strong> in Deiner <strong>php.ini</strong>-Datei (z.B.: memory_limit = 128M) und starte Deinen Webserver neu",
"Tiki has detected your PHP memory_limit at" => "Tiki hat Deine PHP Speichergrenze erkannt",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages." => "Tiki benutzt die PHP <strong>mail</strong> Funktion um Nachrichten zu verschicken.",
"To test your system configuration, Tiki will attempt to send a test message to you." => "Zum Testen der korrekten E-Mailkonfiguration kannst Du hier eine Testnachricht verschicken.",
"Test email" => "Test-E-Mail",
// "tiki@example.com" => "tiki@example.com",
"Email address to send test to" => "E-Mailadresse, an die die Test-E-Mail gesandt wird",
"Copy test mail to " => "Test-Mail in Kopie an ",
"Send Test Message" => "Test-Nachricht senden",
"Tiki was able to send a test message to" => "Tiki konnte eine Test-Nachricht abschicken an",
"Tiki was not able to send a test message" => "Tiki konnte die Textnachricht nicht senden",
"Review your mail log for details" => "Prüfe Dein E-Maillog für Details",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Überprüfe die E-Maileinstellungen in Deiner <strong>php.ini</strong> Datei (z.B.: prüfe, dass der <strong>sendmail_path</strong> richtig eingestellt ist)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Wenn Dein Host eine SMTP Authentifizierung benötigt, müssen möglicherweise zusätzliche Konfigurationen vorgenommen werden",
"Image Processing" => "Bild-Bearbeitung",
"Tiki detected" => "Tiki erkannte",
"Tiki can create images" => "Tiki kann Bilder erstellen",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki konnte kein Beispielbild erstellen. Bitte prüfe Deine GD Bibliothekskonfiguration",
"Tiki was not able to detect the GD library." => "Tiki konnt die GD-Bibliothek nicht finden.",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support." => "Tiki benutzt die GD-Bibliothek zur Verarbeitung von Bildern sowie für die CAPTCHA-Unterstützung.",
"Set the Database Connection" => "Datenbank-Verbindung einrichten",
"Tiki requires an active database connection." => "Tiki benötigt eine aktive Datenbank-Verbindung.",
// "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them" => "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them",
"Tiki cannot find a database connection." => "Tiki kann keine Datenbankkonfiguration finden.",
"This is normal for a new installation" => "Dies ist normal für eine neue Installation",
"Tiki found an existing database connection in your local.php file" => "Tiki hat eine existierende Datenbankverbindung in Deiner lokalen local.php-Datei gefunden",
// "Database name: %0" => "Database name: %0",
// "Tiki found an automatic database connection for your environment" => "Tiki found an automatic database connection for your environment",
"Use Existing Connection" => "Verwende vorhandene Verbindung",
"Modify database connection" => "Verändere die Datenbankverbindung",
// "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
"Database information" => "Datenbankinformation",
"Enter your database connection information." => "Trage hier die Datenbankkonfiguration ein.",
// "DBMS driver" => "DBMS driver",
// "Select the database driver to use with Tiki" => "Select the database driver to use with Tiki",
// "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension" => "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension",
"Host name:" => "Rechnername:",
"Enter the host name or IP for your database." => "Name oder IP-Adresse des Rechners, auf dem die Datenbank läuft.",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Benutze <strong>localhost</strong>, wenn die Datenbank auf der gleichen Maschine wie die Tiki läuft",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
"Database name" => "Datenbankname",
// "Name of the database to be used. This database will be created if it does not exist and permissions allow creation" => "Name of the database to be used. This database will be created if it does not exist and permissions allow creation",
// "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created" => "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created",
"If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "Wenn Du eine Datenbank verwendest, die bereits benutzt wird (nicht empfohlen), prüfe db/tiki.sql, um sicher zu stellen, dass die Tabellennamen, die Tiki verwendet, nicht bereits benutzt werden",
"Database user" => "Datenbankbenutzer",
// "Enter a database user with administrator permission for the Tiki database" => "Enter a database user with administrator permission for the Tiki database",
"User name" => "Benutzername",
// "Database username" => "Database username",
// "Create the above database user just for this Tiki database" => "Create the above database user just for this Tiki database",
// "Administrative database user" => "Administrative database user",
// "Enter database administrator user name and password" => "Enter database administrator user name and password",
// "This is a DB admin user which has permission to create new databases and new users" => "This is a DB admin user which has permission to create new databases and new users",
// "DB admin user name" => "DB admin user name",
// "DB admin password" => "DB admin password",
"Character set" => "Zeichensatz",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Absolut empfohlen für neue Installationen. Wenn Du aber eine Aktualisierung oder eine Migration einer früheren Datenbank durchführst, ist zu empfehlen, den Haken nicht zu setzen",
"Always force connection to use UTF-8" => "Erzwinge für die Verbindung immer UTF-8",
// "Install & Upgrade" => "Install & Upgrade",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Die Einstellung max_execution_time konnte für PHP nicht gesetzt werden. Du kannst ggf. Probleme haben, wenn Du die Datenbank mit diesem Installer auf einem langsamen System erstellst/aktualisierst. Dies kann dazu führen, dass leere Seiten angezeigt werden",
"This install will populate (or upgrade) the database" => "Diese Installation führt zum Bestücken oder Aktualisieren der Datenbank",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>",
"A new install will populate the database" => "Eine neue Installation wird in die Datenbank vorgenommen",
"Encoding Issue" => "Kodierungsproblem",
// "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>",
"Character Set Conversion" => "Zeichensatzumwandlung",
"Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Auf eigenes Risiko benutzen. Wenn die Daten in der Datenbank unsachgemäß konvertierte Daten enthält, kann alles noch schlimmer werden. Geeignet für neue Installationen. Erfordert ALTER-Rechte in der Datenbank",
"Convert database and tables to UTF-8" => "Konvertiere Datenbank und Tabellen nach UTF-8",
// "This will destroy your current database: %0" => "This will destroy your current database: %0",
"Reinstall the database" => "Datenbank neu installieren",
"Select database engine" => "Wähle Datenbank-Engine",
"MyISAM" => "MyISAM",
"InnoDB" => "InnoDB",
"Reinstall" => "Neu Installieren",
"Upgrade" => "Aktualisieren",
"Warning: Category Permissions Will Not Be Upgraded" => "Warnung: Kategorienrechte werden nicht aktualisiert",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Kategorieberechtigungen wurden seit der Version 3 umgestaltet. Wenn Du bisher Kategorieberechtigungen genutzt hast, beachte, dass diese nach der Aktualisierung zur Version 4 oder höher ggf. nicht mehr richtig funktionieren und neu konfiguriert werden müssen",
// "Automatically upgrade your existing database to version" => "Automatically upgrade your existing database to version",
"This site has an admin account configured" => "Auf dieser Site ist ein Administratorkonto konfiguriert",
"Please log in with your admin password to continue" => "Bitte melde Dich mit Deinem Administratorpasswort an, um fortzufahren",
"Review the Upgrade" => "Siehe die Aktualisierung durch",
"Review the Installation" => "Einstellungen prüfen",
"Upgrade complete" => "Aktualisierung vollständig",
"Installation complete" => "Installation vollständig",
"Your database has been configured and Tiki is ready to run" => "Deine Datenbank wurde konfiguriert und Tiki kann nun gestartet werden",
"If this is your first install, your admin password is <strong>admin</strong>" => "Wenn das Deine erste Installation ist, lautet Dein Administratorpasswort: <strong>admin</strong>",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Du kannst Dich jetzt an Deiner Tiki als Benutzer <strong>admin</strong> anmelden und anfangen Tiki zu konfigurieren",
"Upgrade operations executed successfully" => "Aktualisierungen wurden erfolgreich ausgeführt",
"Installation operations executed successfully" => "Installation wurde erfolgreich ausgeführt",
"SQL queries" => "SQL Abfragen",
"Database was left unchanged" => "Die Datenbank wurde unverändert gelassen",
"Operations failed" => "Operationen fehlgeschlagen",
"Display details" => "Zeige Details",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Während der Aktualisierung ist es normal SQL-Fehler mit der Meldung <strong>Table already exists</strong> zu erhalten",
"Check all errors" => "Setze Haken bei allen Fehlern",
"Configure General Settings" => "Verschiedene Einstellungen II",
"Complete these fields to configure common, general settings for your site" => "Fülle die Felder aus, um generelle Einstellungen Deiner Site festzulegen",
"The information you enter here can be changed later" => "Die Informationen, die hier eingegeben werden, können später wieder geändert werden",
// "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings",
// "My Tiki" => "My Tiki",
"This will appear in the browser title bar" => "Dies wird in der Titelleiste Deines Browsers stehen",
"Email sent by your site will use this address" => "E-Mails, die von Deiner Site gesendet werden, benutzen diese E-Mailadresse",
// "Network Proxy" => "Network Proxy",
// "Toggle section display" => "Toggle section display",
"Secure Log in" => "Sicheres Login",
// "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "HTTPS-Login",
"PHP error reporting level:" => "PHP Fehler Ausgabelevel:",
"Report all errors except notices" => "Alle Fehler außer Hinweisen ausgeben",
"Visible to Admin only" => "Nur für Administratoren sichtbar",
"Admin email" => "Administrator-E-Mail",
// "admin@example.com" => "admin@example.com",
"This is the email address for your administrator account" => "Dies ist die E-Mailadresse für Dein Administratorkonto",
// "Set up htaccess file" => "Set up htaccess file",
"Method" => "Methode",
// "Select how to set up your htaccess file" => "Select how to set up your htaccess file",
"Upgrade fix" => "Aktualisierungsprobleme",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will",
"Create the <em>Admins</em> group, if missing" => "Erstelle die<em>Admins</em>-Gruppe, wenn sie fehlt",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "Erlaube dieser Gruppe auf <em>tiki_p_admin</em> zuzugreifen, wenn nicht gestattet",
"Add the administrator account to the group, if missing" => "Füge das Administratorkonto der Gruppe hinzu, wenn es fehlt",
"To do so enter the name of the main admin account in the field below" => "Um so fortzufahren, trage in das Feld hierunter den Namen des Hauptadministratorkontos ein",
// "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>" => "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>",
"Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Setze den Haken, wenn Du nach einer Aktualisierung auf Tiki 4 viele deaktivierte Konten hast",
"List of accounts that will be enabled" => "Liste der Konten, die aktiviert werden",
// "Last Notes" => "Last Notes",
// "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future" => "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future",
// "Subscribe to Tiki Releases newsletter" => "Subscribe to Tiki Releases newsletter",
// "Critical & Security update" => "Critical & Security update",
// "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates" => "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates",
// "We don't share subscribed emails and we send very few of these newsletters per year" => "We don't share subscribed emails and we send very few of these newsletters per year",
// "Please use the following link and subscribe" => "Please use the following link and subscribe",
// "Tiki Releases newsletter" => "Tiki Releases newsletter",
// "First Wizards, then Control Panels with Preference Filter" => "First Wizards, then Control Panels with Preference Filter",
// "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator" => "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator",
// "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})" => "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})",
// "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install" => "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install",
// "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels" => "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels",
// "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided" => "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided",
// "Storing your uploaded files" => "Storing your uploaded files",
// "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database" => "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database",
// "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more" => "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more",
// "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other" => "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other",
// "Tiki Community" => "Tiki Community",
// "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users" => "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users",
// "Get Help with Tiki" => "Get Help with Tiki",
// "Hire a Tiki Service Provider" => "Hire a Tiki Service Provider",
// "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>" => "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>",
"Enter Your Tiki" => "Tiki aufrufen",
// "Ready to run" => "Ready to run",
"The installation is complete" => "Die Installation ist vollständig",
".htaccess File" => ".htaccess-Datei",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Wir empfehlen, die <strong>.htaccess</strong>-Datei für Deine Tiki zu nutzen",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Hierdurch werden SEFURLs (suchmaschinenfreundliche URL) aktiviert und die Site-Sicherheit verbessert",
// "Your .htaccess file has been set up (%0)" => "Your .htaccess file has been set up (%0)",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
"Enter Tiki and Lock Installer" => "Betrete die Tiki und sperre den Installer",
"Recommended" => "Empfohlen",
"Enter Tiki Without Locking Installer" => "Betrete die Tiki ohne den Installer zu sperren",
// "Not recommended due to security risk" => "Not recommended due to security risk",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Du kannst jetzt normal auf die Site zugreifen. Du kannst alle Probleme, die Du findest, in den Tiki Foren oder dem Bug-Tracker melden",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Bist Du sicher, dass Du versuchen möchtest, das Kodierungsproblem Deiner gesamten Datenbank zu beheben",
"Upgrading and running into encoding issues" => "Kodierungsprobleme beim Aktualisieren",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Wir können versuchen, das Problem zu beheben. Stelle <strong>sicher, dass Du Datenbanksicherungen hast und sie wieder einspielen kannst</strong>",
"Previous table encoding" => "Vorherige Tabellenkodierung",
"Please select" => "Wähle bitte",
// "Click to fix double encoding (dangerous)" => "Click to fix double encoding (dangerous)",
"Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Hoppla. Du musst sicherstellen, dass der Zeichensatz des Clients zwingend UTF-8 benutzt. Setze die Datenbankverbindung zurück, um Fortzufahren",
"MultiTiki Setup" => "MultiTiki Setup",
"Default Installation" => "Standardinstallation",
"DB OK" => "DB OK",
"No DB" => "Keine DB",
"Adding a new host" => "Einen neuen Host hinzufügen",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Um einen neuen virtuellen Host hinzuzufügen, starte setup.sh mit dem Domänennamen des neuen Host als letztem Parameter",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Aktualisierst Du eine existierende Tiki Site",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Gehe direkt zum <strong>Installieren/Aktualisieren</strong>-Schritt",
"Install/Upgrade" => "Installieren/Aktualisieren",
"Powered by" => "Powered by",
"Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Cache aktualisieren",
"configure rules" => "Regeln konfigurieren",
"Edit Repository" => "Repository bearbeiten",
"Invitation" => "Einladung",
"Invitations list" => "Einladungsliste",
"The mail has been sent to: " => "Die E-Mail wurde gesendet an: ",
"You are about to send an invitation to theses people, please confirm" => "Du bist dabei, die Einladung an diese Menschen zu senden, bitte bestätigen",
"Fill this box with the list of emails you want to invite " => "Fülle diese Box mit der Liste von E-Mails, an die Du die Einladung schicken möchtest ",
"Format of the list above " => "Format der oben stehenden Liste ",
"CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV-Stil: eine Zeile pro Einladung mit dem Format: Nachname,Vorname,E-Mail",
"Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Alles, was als E-Mail im Text erscheint wird entdeckt und benutzt (in diesem Fall werden im E-Mailinhalt {literal}{firstname} und {lastname}{/literal} ignoriert)",
"Type here the email subject you'll want to be sent to them " => "Trage hier den E-Mailbetreff ein, der gesendet werden soll",
"Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Trage hier den E-Mailinhalt ein, der gesendet werden soll. Lasse das {literal}{link}{/literal}-Wort unverändert, da es durch einen Link zur Registrierung ersetzt wird",
"Type here the content that the user will see when he'll click on the link from the mail " => "Tippe hier den Inhalt ein, den der Benutzer sieht, wenn er auf den Link in der E-Mail klickt ",
"Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special " => "Wähle eine oder mehr Gruppen für dieses Abonnement. Wähle keine, wenn Du nichts Spezielles wünschst ",
"Invoices" => "Rechnungen",
"New Invoice" => "Neue Rechnung",
"Clients" => "Kunden",
"New Client" => "Neuer Kunde",
"Invoice Reports" => "Rechnungsberichte",
"Add more media" => "Füge weitere Medien hinzu",
"Change Details" => "Ändere Details",
"Video Title" => "Videotitel",
"Editor" => "Editor",
"Embed code" => "Code einbetten",
"Plays" => "Abspielungen",
"No action specified" => "Keine Aktion angegeben",
// "This file is not expected to be called directly" => "This file is not expected to be called directly",
"Last Changes" => "Neueste Änderungen",
"Last 2 days" => "Letzten 2 Tage",
"Last 3 days" => "Letzten 3 Tage",
"Last 5 days" => "Letzten 5 Tage",
"Last week" => "Letzte Woche",
"Last 2 weeks" => "Letzten 2 Wochen",
"Last month" => "Letzten Monat",
"Search by Date" => "Suche nach Datum",
"Found" => "Fand",
"LastChanges" => "LetzteÄnderungen",
"Ip" => "IP",
"{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
"v" => "v",
"Diff" => "Unterschiede",
"Pages like" => "Ähnliche Seiten",
"New Article" => "Neuer Artikel",
"New Submission" => "Neue Einreichung",
"View Submissions" => "Einreichungen ansehen",
"Expiry Date" => "Verfallsdatum",
"{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
"{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
"{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
"{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
"{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
"Select Duplicates" => "Duplikate auswählen",
// "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "Banner erstellen",
"Use Dates?" => "Datum benutzen?",
"Max Impressions" => "Max Aufrufe",
"Impressions" => "Aufrufe",
"Max Clicks" => "Max Klicks",
"Clicks" => "Klicks",
// "List Posts" => "List Posts",
"The cache is used by" => "Der Cache wird benutzt von",
"{\$headerName}" => "{\$headerName}",
"Approval" => "Freigabe",
// "Delete comment" => "Delete comment",
"(no title)" => "(kein Titel)",
"{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "Bestätigt",
"More Information" => "Weitere Informationen",
// "Delete selected comments" => "Delete selected comments",
// "Delete and ban selected comments" => "Delete and ban selected comments",
// "Delete and ban" => "Delete and ban",
"Dynamic Content System" => "Dynamischer Inhalt",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "Du kannst ebenso {literal}{content label=x}{/literal} benutzen, wobei x die Bezeichnung des Inhaltsblocks ist",
"Available content blocks" => "Verfügbare Inhaltsblöcke",
"Current Value" => "Aktueller Wert",
"Current ver" => "Aktuelle Ver.",
"Next ver" => "Nächste Ver.",
"Future vers" => "Zukünftige Version",
"Program" => "Programm",
"Create/Edit content block" => "Erstelle/bearbeite Inhaltsblöcke",
"Edit content block" => "Inhalts-Block bearbeiten",
"Create content block" => "Erstelle Inhaltsblock",
"Available FAQs" => "Verfügbare FAQs",
// "Questions / Suggested" => "Questions / Suggested",
"Edit/Create" => "Hinzufügen/bearbeiten",
"Edit this FAQ:" => "Diese FAQ bearbeiten:",
"Create new FAQ" => "Neue FAQ erstellen",
"Create New FAQ:" => "Neue FAQ erstellen:",
"Users can suggest questions" => "Benutzer können Fragen vorschlagen",
"Create a File Gallery" => "Dateiarchiv anlegen",
// "{\$name}" => "{\$name}",
// "Finder" => "Finder",
"RSS feed" => "RSS Feed",
// "Hide file information from list view" => "Hide file information from list view",
// "Hide list view information" => "Hide list view information",
// "Show file information from list view" => "Show file information from list view",
// "Show list view information" => "Show list view information",
// "Create Diagram" => "Create Diagram",
// "Batch" => "Batch",
"SlideShow" => "SlideShow",
// "Create H5P" => "Create H5P",
"Be careful to set the right permissions on the files you link to" => "Sei vorsichtig und setze die richtigen Rechte für die Dateien, die Du verlinkst",
"Keep gallery window open" => "Halte Galeriefenster offen",
"optional" => "optional",
"Modifications" => "Veränderungen",
"Property <b>{\$fgp_name}</b> Changed" => "Eigentum <b>{\$fgp_name}</b> geändert",
// "Search for text within files in all galleries" => "Search for text within files in all galleries",
// "Search by identifier" => "Search by identifier",
// "Search for the file with this number, in all galleries" => "Search for the file with this number, in all galleries",
// "Maximum width" => "Maximum width",
"You can access the file gallery using the following URL" => "Du kannst das Dateiarchiv unter der folgenden URL erreichen",
"Gallery Images" => "Galerie-Bilder",
"Inviter" => "Einlader",
"Only successful invitations" => "Nur erfolgreiche Einladungen",
"Only pending invitations" => "Nur anstehende Einladungen",
"Number of invitations" => "Anzahl von Einladungen",
"Invoice Clients" => "Rechnungskunden",
"Tax Status" => "Steuerstatus",
"New Contact" => "Neuer Kontakt",
"Client Name" => "Kundenname",
// "Remix Entries" => "Remix Entries",
// "Browse Media" => "Browse Media",
"Browse Remixes" => "Browse Remixe",
"Please select some media entries to use" => "Bitte wähle Medieneinträge zur Benutzung aus",
"Media Id" => "Medien-ID",
"Wiki plugin code" => "Wiki-Plugin-Code",
"No entries" => "Keine Einträge",
"No media entries found" => "Keine Medieneinträge gefunden",
"to upload" => "hochzuladen",
"Modified By" => "Verändert von",
"No mix entries found" => "Keine Mix-Einträge gefunden",
"Object Permissions List" => "Liste der Objektberechtigungen",
"Object Permissions" => "Objektberechtigungen",
// "Object permissions" => "Object permissions",
// "Category permissions" => "Category permissions",
// "Perform action with selected permissions" => "Perform action with selected permissions",
// "Assign to this group" => "Assign to this group",
// "Only default global permissions are being used" => "Only default global permissions are being used",
"Reason" => "Grund",
// "No object permissions apply" => "No object permissions apply",
"{\$special.reason|escape}" => "{\$special.reason|escape}",
// "No category permissions apply" => "No category permissions apply",
"Blog: %0" => "Blog: %0",
"New Blog Post" => "Neuer Blogeintrag",
"Post Title" => "Beitrag-Titel",
"Blog Title" => "Blog-Titel",
// "(bytes)" => "(bytes)",
// "Delete Expired Submissions" => "Delete Expired Submissions",
// "Deletes expired submissions 1000 at a time to avoid timeouts" => "Deletes expired submissions 1000 at a time to avoid timeouts",
"Survey stats" => "Umfragen-Statistik",
// "Take survey" => "Take survey",
// "Import Structure" => "Import Structure",
// "Import From Profile/YAML" => "Import From Profile/YAML",
// "Manage Tabular Formats" => "Manage Tabular Formats",
// "Clone remote" => "Clone remote",
"Items" => "Einträge",
// "{\$tracker.name|escape}" => "{\$tracker.name|escape}",
"Do you really remove this tracker" => "Willst Du diesen Tracker wirklich entfernen",
"Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Möchtest Du wirklich alle Einträge dieses Trackers löschen? (Beachte, dass dies nicht rückgängig gemacht werden kann und keine Benachrichtigungen versandt werden)",
"users registered" => "registrierte Benutzer",
"like" => "wie",
"Distance (km)" => "Entfernung (km)",
"{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Wikiseitenliste",
"Page aliases found" => "Seitenalias gefunden",
"Create a Wiki Page" => "Erstelle eine Wiki Seite",
"Insert name of the page you wish to create" => "Füge Seitennamen ein, um eine Seite zu erstellen",
// "Create page within %0" => "Create page within %0",
"Last modification" => "Letzte Änderung",
"Page creator" => "Seiten-Ersteller",
"Last author" => "Letzter Autor",
"Last version" => "Neueste Version",
"Status of the page" => "Status der Seite",
"Links to other items in page" => "Verlinkt auf andere Objekte auf der Seite",
"Links to this page in other pages" => "Verlinkt diese Seite auf anderen Seiten",
"Backl" => "Backl",
"Page size" => "Seiten-Größe",
"Lang" => "Sprache",
// "No page" => "No page",
"No pages found with" => "Es wurden keine Seiten gefunden mit",
// "Download PDF" => "Download PDF",
// "Download zipped file" => "Download zipped file",
// "Add page name as page header" => "Add page name as page header",
"Open client window" => "Clientfenster öffnen",
"Generate HTML" => "HTML erzeugen",
"Transcripts" => "Logbücher",
"Online operators" => "Operatoren online",
"Accepted requests" => "Bearbeitete Anfragen",
"{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "Logs",
"offline" => "offline",
"Offline operators" => "Abwesende Operatoren",
"{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Neuen Operator hinzufügen",
"Operators must be tiki users" => "Operatoren müssen Tiki Benutzer sein",
"Set as Operator" => "Als Operator hinzufügen",
"Chat started" => "Chat begonnen",
"Live support:User window" => "Online-Support: Benutzerfenster",
"Request live support" => "Live Support-Anfrage stellen",
"Request support" => "Supportanfrage stellen",
"Your request is being processed" => "Deine Anfrage wird bearbeitet",
"cancel request and exit" => "Anfrage abbrechen und verlassen",
"cancel request and leave a message" => "Anfrage abbrechen und Nachricht hinterlassen",
"Live support:Console" => "Live Support: Konsole",
"{\$status}" => "{\$status}",
"be online" => "online gehen",
"be offline" => "offline gehen",
"You are not an operator" => "Du bist kein Operator",
"Support requests" => "Support-Anfragen",
"Requested" => "Angefragt",
"Accept" => "annehmen",
"Join" => "Beitreten",
"No support requests" => "Keine Supportanfragen",
"Support chat transcripts" => "Support Chat-Logbücher",
"Back to admin" => "Zurück zur Verwaltung",
"operator" => "Operator",
"started" => "gestartet",
"reason" => "Grund",
"msgs" => "Nachrichten",
"Transcript" => "Logbuch",
"For security purposes we must periodically validate your email address to allow continued access to this site" => "Aus Sicherheitsgründen müssen wir regelmäßig Deine E-Mailadresse überprüfen, um Dir fortlaufenden Zugang zur Site zu gewähren",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "Eine Validierungs-E-Mail wurde Dir zugesandt. Bitte öffne diese E-Mail und folge den Anweisungen, um wieder Zugriff auf die Site zu erhalten",
"Thank you" => "Danke",
"Mail-in feature" => "Mail-in-Funktion",
"Click here to go to mailin admin" => "Klicke hier, um zur Mail-In-Verwaltung zu gelangen",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/." => "Notwendige Datei fehlt. Lade <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> herunter und lege die Datei unter files/ ab.",
"Mini Calendar" => "Minikalender",
"Prefs" => "Einstellungen",
"Daily" => "Täglich",
"Weekly" => "Wöchentlich",
"Remove old events" => "Alte Termine löschen",
"h" => "h",
"mins" => "Min.",
"Edit Event" => "Ereignis bearbeiten",
"Mini Calendar: Preferences" => "Mini-Kalender: Einstellungen",
"Calendar Interval in daily view" => "Kalender Intervall in Tagesansicht",
"Start hour for days" => "Tag beginnt um",
"End hour for days" => "Tag endet um",
"Reminders" => "Erinnerungen",
"no reminders" => "keine Erinnerungen",
"min" => "Min.",
"Or enter path or URL" => "Oder Pfad oder URL eingeben",
"Add Topic" => "Thema hinzufügen",
"Tiki Mods" => "Tiki Mods",
// "Tiki \"Mods\" are obsolete as of Tiki 19" => "Tiki \"Mods\" are obsolete as of Tiki 19",
// "Tiki now uses \"Packages\" instead" => "Tiki now uses \"Packages\" instead",
// "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>" => "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>",
"y" => "j",
// "Records" => "Records",
"User Galleries" => "Benutzer-Galerien",
"My Articles" => "Meine Artikel",
"User Articles" => "Benutzerartikel",
"My User Items" => "Meine Benutzer-Objekte",
"User Items" => "Benutzereinträge",
"Unread Messages" => "Ungelesene Nachrichten",
"User forum topics" => "Benutzerforenthemen",
// "Forum topic" => "Forum topic",
"Date of post" => "Beitrags-Datum",
"User forum replies" => "Benutzerforenantworten",
"User Blogs" => "Benutzer-Blogs",
// "My blog Posts" => "My blog Posts",
// "User Blog Posts" => "User Blog Posts",
"To display the objects you created or contributed to" => "Um die Objekte anzuzeigen, die Du erstellt oder zu denen Du beigetragen hast",
// "My Items" => "My Items",
"My Info" => "Über mich",
"My Watches" => "Meine Beobachtungspunkte",
"Contacts Preferences" => "Kontakteinstellungen",
"Notepad" => "Notizblock",
"MyFiles" => "Meine Dateien",
"Sent editions" => "Gesendete Ausgaben",
"Admin Newsletters" => "Newsletter verwalten",
"HTML version" => "HTML-Version",
"Text version" => "Text-Version",
"The newsletter was sent to {\$sent} email addresses" => "Der Newsletter wurde an {\$sent} E-Mailadressen verschickt",
"Delete errors" => "Lösche Fehler",
"Not sent" => "nicht gesendet",
"Subscribe to Newsletter" => "Newsletter abonnieren",
"Subscribe to this Newsletter" => "Abonnieren",
"Available Newsletters" => "Verfügbare Newsletter",
"Write a note" => "Notiz schreiben",
"quota" => "Speicherkontingent",
"No notes yet" => "Noch keine Notizen vorhanden.",
"Merge selected notes into" => "Notizen verschmelzen mit",
"Reading note:" => "Notiz lesen:",
"List notes" => "Notizen auflisten",
"Write note" => "Notiz schreiben",
"Wiki Create" => "Wiki erstellen",
"Wiki Overwrite" => "Wiki überschreiben",
"Object Watches" => "Objektbeobachtungen",
"Groups watching" => "Beobachtende Gruppen",
"Changes to groups watching" => "Ändert die beobachtenden Gruppen",
"These changes to group watches" => "Diese Änderungen zur Gruppenbeobachtung",
"were made to these descendants" => "wurde für diese Nachkommen vorgenommen",
"This Category" => "Diese Kategorie",
"All Descendants" => "Alle Abkömmlinge",
"Assign global permissions" => "Globale Rechte zuweisen",
"Assign permissions to " => "Berechtigungen vergeben für ",
"Edit Permissions" => "Berechtigungen bearbeiten",
"Currently editing Global permissions." => "Aktuell werden globale Rechte bearbeitet.",
"This object's direct permissions override any global permissions or category permissions affecting this object." => "Diese direkten Objektberechtigungen überschreiben alle globalen Rechte oder Kategorierechte, die dieses Objekt betreffen.",
"This category's direct permissions override any global permissions affecting objects in it" => "Diese direkt auf die Kategorie bezogenen Rechte überschreiben die globalen Rechte und beeinflussen die Objekte in der Kategorie",
"To edit global permissions" => "Um globale Berechtigungen zu ändern",
"No permissions yet applied to this object but category permissions affect this object and are displayed below" => "Das Objekt hat noch keine Berechtigungen. Die Kategorieberechtigungen wirken sich aber bereits auf das Objekt aus und werden unten angezeigt",
"To edit category permissions" => "Um Kategorierechte zu bearbeiten",
// "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below" => "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below",
// "To edit parent object's permissions" => "To edit parent object's permissions",
"No direct permissions yet applied to this object. Global permissions apply." => "Derzeit sind keine direkten Rechte für dieses Objekt wirksam. Globale Rechte sind daher gültig.",
"Currently inherited permissions displayed." => "Die derzeit gültigen, geerbten Rechte werden angezeigt.",
"Show permissions for disabled features" => "Zeige Berechtigungen für deaktivierte Funktionen",
"Assign permissions to this category" => "Weise dieser Kategorie Rechte zu",
"Assign permissions to this object" => "Diesem Objekt Berechtigungen zuweisen",
"Delete category permissions" => "Lösche Kategorierechte",
"Delete object permissions" => "Lösche Objektberechtigungen",
"Reset Perms" => "Setze Berechtigungen zurück",
"This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "Dies entfernt alle Einstellungen hier und die Rechte werden zurückgesetzt, so dass alle Kategorierechte geerbt werden, die eingetragen sind. Wenn keine angegeben sind, werden die globalen Rechte der Site angewendet",
"This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "Dies entfernt alle Einstellungen hier und die Rechte werden zurückgesetzt, so dass die globalen Rechte der Site geerbt werden.",
"Permissions Clipboard" => "Berechtigungen Zwischenablage",
"Copy the permissions set here" => "Kopiere den Berechtigungssatz hier",
"Paste" => "Einfügen",
"Paste copied permissions from " => "Füge kopierte Berechtigungen ein von ",
"Assign or remove permissions on <em>all</em> child categories" => "Berechtigungen <em>allen</em> Unterkategorien zuweisen oder davon entfernen",
"Are you sure you want to affect all child categories?\\nThere is no undo" => "Bist Du sicher, dass Du alle Unterkategorieren beeinflussen willst?\\nDieser Befehl kann nicht rückgängig gemacht werden",
"Assign or remove permissions on all pages of the sub-structure" => "Berechtigungen allen Seiten der Unterstruktur zuweisen oder davon entfernen",
"Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Bist Du sicher, dass Du alle Seiten in der Unterstruktur beeinflussen willst?\\nDies kann nicht rückgängig gemacht werden",
"You must select at least one feature" => "Du musst mindestens eine Funktion auswählen",
"View Differences" => "Unterschiede anzeigen",
"Permissions added:" => "Hinzugefügte Rechte:",
"Permissions removed:" => "Entfernte Rechte:",
"Select groups" => "Gruppen auswählen",
// "Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab." => "Diese Gruppen sind nicht die Gruppen, die Berechtigungen für das Objekt haben. Dies sind nur die Gruppen, die man in der ersten Spalte des ersten Tabs sehen kann.",
"Select only groups that have a perm with the object" => "Wähle nur Gruppen, die Berechtigungen auf das Objekt haben",
"Group name" => "Gruppenname",
"Select features" => "Funktionen wählen",
// "Some of your features have been automatically hidden.<br> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br> Select the features below to assign permissions for",
"Feature name" => "Funktionsname",
"Quick Permissions" => "Schnelle Rechte",
"Assign Quick-Permissions to this object" => "Schnell Rechte zu diesem Objekt hinzufügen",
// "Individual permissions are currently assigned (See tab Assign Permissions)" => "Individual permissions are currently assigned (See tab Assign Permissions)",
"<em>Quick permissions</em> should be considered as an experimental feature." => "<em>Schnelle Rechtevergabe</em> sollte ausschließlich als eine experimentelle Funktion betrachtet werden.",
"Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably." => "Obwohl die hier vergebenen Rechte korrekt gesetzt werden, kann es dazu kommen, dass die gegenwärtigen Rechte nicht richtig angezeigt werden.",
"There is also no undo - <strong>Use with care!</strong>" => "Es gibt kein Rückgängigmachen! - <strong>Benutzung auf eigene Gefahr!</strong>",
"Your OpenID identity is valid" => "Deine OpenID Identität ist gültig",
"Your identity gives you access to multiple user accounts" => "Deine Identität gibt Dir Zugriff auf mehrere Benutzerkonten",
"Select account" => "Wähle Konto",
"Orphan Pages" => "Verwaiste Seiten",
"Browser not supported" => "Browser wird nicht unterstützt",
"Contributions by author" => "Beiträge nach Autor",
"Similar" => "Ähnlich",
"Make Structure" => "Struktur erstellen",
"Discuss" => "Diskutieren",
"Bookmark" => "Bookmark",
"View latest version before editing" => "Letzte Version vor Bearbeitung ansehen",
"Contributions to" => "Beiträge zu",
"current version" => "gegenwärtige Version",
"Words" => "Wörter",
"Whitespaces" => "Leerraum",
"Characters" => "Zeichen",
"Printable characters" => "Druckbare Zeichen",
"Page changes" => "Seitenänderungen",
"Original wiki text" => "Original Wikitext",
"Parsed Text (HTML)" => "Geparster Text (HTML)",
"Output text only (No HTML tags)" => "Nur Ausgabetext (keine HTML Tags)",
"Show statistics" => "Zeige Statistiken",
"Visualize page changes" => "Visualisiere Seitenänderungen",
"Show popups" => "Zeige Popups",
"Escape HTML / Wiki syntax in page changes" => "Maskiere HTML / Wiki Syntax in Seitenänderungen",
"Show contributions" => "Zeige Beiträge",
// "Collapse Into Edit Sessions" => "Collapse Into Edit Sessions",
"Show All Versions" => "Zeige alle Versionen",
"Preview of version" => "Vorschau der Version",
"(current)" => "(aktuell)",
"Roll back to this version" => "diese Version wieder herstellen",
"Content Approval" => "Inhaltsbestätigung",
"This revision is currently marked as approved" => "Diese Revision ist gegenwärtig als bestätigt markiert",
"Remove Approval" => "Entferne Bestätigung",
"This revision has not been approved" => "Diese Revision wurde nicht bestätigt",
"Approve Revision" => "Bestätige Revision",
// "History view" => "History view",
// "This revision may not be the latest approved revision" => "This revision may not be the latest approved revision",
// "This revision has been rejected" => "This revision has been rejected",
"Source of version:" => "Text der Version:",
"Update Translation" => "Übersetzung aktualisieren",
"Hide translation history" => "Verstecke Übersetzungshistorie",
"Show translation history" => "Zeige Übersetzungshistorie",
"Enable pagination" => "Paginierung aktivieren",
// "rows per page" => "rows per page",
// "HTML allowed" => "HTML allowed",
// "HTML syntax is allowed either by page setting or use of the WYSIWIG editor" => "HTML syntax is allowed either by page setting or use of the WYSIWIG editor",
"from %0" => "von %0",
"approved" => "bestätigt",
"Updated from" => "Aktualisiert von",
"Used to update" => "Benutzt für Aktualisierung",
// "rejected" => "rejected",
// "Difference" => "Difference",
"Older Version" => "Ältere Version",
// "Israel Post" => "Israel Post",
// "Order ID" => "Order ID",
// "Payment authorized (not captured)" => "Payment authorized (not captured)",
// "Payment authorized (captured)" => "Payment authorized (captured)",
// "Unknown state" => "Unknown state",
// "Date Paid" => "Date Paid",
"Payer" => "Bezahler",
// "Payer email from %0" => "Payer email from %0",
"View payment info" => "Bezahlungsinfo einsehen",
"Cancel this payment request" => "Breche Zahlungsanfrage ab",
"View payment request" => "Zahlungsanfrage einsehen",
"Paypal" => "Paypal",
"Transaction ID" => "Transaktions-ID",
"Payment made by <em>%0, %1</em> (%2)" => "Bezahlung erfolgt durch <em>%0, %1</em> (%2)",
// "Payment Request" => "Payment Request",
"{\$wp_member_title}" => "{\$wp_member_title}",
// "For each user: " => "For each user: ",
// "per full period" => "per full period",
// "applicable prorated pricing provided" => "applicable prorated pricing provided",
// "free periods provided" => "free periods provided",
// "full free" => "full free",
// "prorated free" => "prorated free",
// "Payment Status" => "Payment Status",
// "{\$payment_info.state|capitalize|escape}" => "{\$payment_info.state|capitalize|escape}",
// "Capture Payment" => "Capture Payment",
"Paid amount" => "Bezahlter Betrag",
"Initial amount" => "Anfänglicher Betrag",
"Amount remaining" => "Verbleibender Betrag",
// "Payment request initiated" => "Payment request initiated",
// "Payment request due" => "Payment request due",
// "Pay with PayPal" => "Pay with PayPal",
"Pay with Paypal" => "Zahle mit Paypal",
// "Proceed to Israel Post" => "Proceed to Israel Post",
// "Pay With Cclite" => "Pay With Cclite",
"Refresh page" => "Seite aktualisieren",
"Payment info" => "Bezahlungsinfo",
"Trade with Cclite" => "Tausche mit Cclite",
"Payment problem" => "Bezahlungsproblem",
// "Pay With Tiki Credits" => "Pay With Tiki Credits",
"Pay with Tiki User Credits" => "Zahle mit Tiki User Credits",
"Credit type" => "Credit-Typ",
"Credits left" => "Verbleibende Credits",
"Amount to pay" => "Zu zahlender Betrag",
"Pay using" => "Bezahle mit",
// "Payment Details" => "Payment Details",
// "Enter a Manual Payment" => "Enter a Manual Payment",
"Enter payment" => "Trage Bezahlung ein",
"using" => "benutzen",
"Payment information" => "Bezahlungsinfo",
// "No outstanding payments found" => "No outstanding payments found",
// "No paid payments found" => "No paid payments found",
// "<em>No cancelled payments found</em>" => "<em>No cancelled payments found</em>",
"Request" => "Anfrage",
"Payable within" => "Zahlbar innerhalb",
"Pick your profile picture" => "Wähle Deinen Avatar",
"Your current profile picture" => "Dein momentaner Avatar",
"Full size" => "Volle Größe",
"no profile picture" => "kein Avatar",
// "Pick user profile picture from the library" => "Pick user profile picture from the library",
"Pick user profile picture" => "Nutzer-Avatar auswählen",
"Hide all" => "Alles verbergen",
"icons" => "Symbole",
"Show all" => "Zeige alles",
"random" => "zufällig",
"Upload your own profile picture" => "Eigenen Avatar hochladen",
// "Select your profile picture" => "Select your profile picture",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Datei (nur .gif, .jpg und .png Bilder ca. 45px × 45px)",
"File (only .gif, .jpg and .png images)" => "Dateien (nur .gif, .jpg und .png Bilder)",
"Plugin execution was denied" => "Plugin-Ausführung wurde abgelehnt",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Nach der Argumentprüfung durch einen Editor wurde die Ausführung des Plugin abgelehnt. Dieses Plugin wird irgendwann entfernt oder korrigiert",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible." => "Dieses Plugin wurde kürzlich hinzugefügt oder verändert. Bis ein Editor der Site die Parameter geprüft hat, kann das Plugin nicht ausgeführt werden.",
"You are allowed to:" => "Es ist Dir erlaubt zu:",
"View arguments" => "Argumente einzusehen",
"Execute the plugin in preview mode (may be dangerous)" => "Das Plugin im Vorschaumodus auszuführen (kann gefährlich sein)",
"Approve the plugin for public execution" => "Das Plugin für öffentliches Ausführen zu bestätigen",
"View Details" => "Details anzeigen",
"This plugin does not contain any arguments" => "Dieses Plugin enthält keine Argumente",
"This plugin's body is empty" => "Der Hauptteil des Plugins ist leer",
// "Experiment with plugin LIST" => "Experiment with plugin LIST",
// "Test Plugin LIST" => "Test Plugin LIST",
"For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "Aus Sicherheitsgründen sollte die Berechtigung <strong>tiki_p_plugin_approve</strong> nur vertrauenswürdigen Benutzergruppen gewährt werden",
// "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins",
"This page lists the plugins that require validation, the first time they are encountered" => "Diese Seite listet alle Plugins, die eine Bestätigung erfordern, sobald sie das erste Mal angetroffen wurden",
"Each plugin contains a unique <em>signature</em> that is preserved" => "Jedes Plugin enthält eine einzigartige <em>Signatur</em>, welche aufbewahrt wird",
"When you upgrade from an old version, you may need to reparse all the pages." => "Wenn Du von einer älteren Version aktualisierst, müssen ggf. alle Seiten neu geparst werden.",
"If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "Wenn ein Plugin nicht länger benötigt wird (z.B. weil es von der Wiki Seite entfernt wurde), benutze <strong>Löschen</strong>, um es von der Liste zu entfernen",
"The plugin will automatically be added if it is encountered" => "Das Plugin wird automatisch hinzugefügt, wenn es angetroffen wird",
"Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins können von dem Ort, wo sie eingesetzt werden, individuell bestätigt, abgelehnt oder vorangezeigt werden",
"For security, you should review each plugin to ensure it is safe to approve" => "Aus Sicherheitsgründen solltest Du jedes Plugin vor der Bestätigung überprüfen",
"Added By" => "Hinzugefügt durch",
// "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>" => "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>",
// "View this page" => "View this page",
"Approve all pending plugins" => "Bestätige alle unbestätigten Plugins",
"Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Benutze <strong>Bestätigen</strong> oder <strong>alle bestätigen</strong> um alle wartenden Plugins zu bestätigen und zu aktivieren",
"Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Benutze diese Funktion <strong>nur dann</strong>, wenn Du geprüft hast, dass alle Plugins sicher sind",
"No plugins pending approval" => "Es warten keine Plugins auf Bestätigung",
"{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Ergebnisse anschauen",
// "Sorry" => "Sorry",
"Other Polls" => "Andere Abstimmungen",
"Poll Results" => "Abstimmungsergebnisse",
// "All Polls" => "All Polls",
// "Top-Voted Polls" => "Top-Voted Polls",
"Edit Poll" => "Abstimmung bearbeiten",
"Find the poll" => "Finde die Abstimmung",
"{\$what}" => "{\$what}",
"Number of top voted polls to show" => "Anzahl der am höchsten bewerteten Abstimmungen, die angezeigt werden sollen",
// "Show results in this range" => "Show results in this range",
"End:" => "Ende:",
// "Show all results with no time span consideration" => "Show all results with no time span consideration",
// "Show all results with time span consideration" => "Show all results with time span consideration",
// "Show all results" => "Show all results",
// "Find results" => "Find results",
// "Show detailed results of this poll" => "Show detailed results of this poll",
"List Votes" => "Stimmen auflisten",
// "Preference translation" => "Preference translation",
"Popup preview" => "Popup-Vorschau",
"Close preview" => "Schließe Vorschau",
// "Permalink" => "Permalink",
"The original document is available at" => "Das Originaldokument ist zu finden unter",
"Print multiple pages" => "Mehrere Seiten drucken",
"Selected Structures" => "Ausgewählte Strukturen",
"Add Structure" => "Struktur hinzufügen",
"No structures" => "Keine Strukturen",
"Available Pages" => "Verfügbare Seiten",
"No pages" => "Keine Seiten",
"All pages selected" => "Alle Seiten ausgewählt",
"Add Page" => "Seite hinzufügen",
"Remove Page" => "Seite entfernen",
"Selected Pages" => "Ausgewählte Seiten",
"No pages selected" => "Keine Seiten ausgewählt",
"Add Pages from Structures" => "Füge Seiten aus Strukturen hinzu",
"Edit quiz" => "Bearbeite Quiz",
"Current Version" => "Gegenwärtige Version",
"General Options" => "Generelle Optionen",
"Publication Date" => "Veröffentlichungsdatum",
"at " => "am",
"Use " => "Benutze",
"randomly selected questions" => "zufällig ausgewählte Fragen",
"Test-time Options" => "Test-Zeit Optionen",
"Shuffle questions" => "Fragen durcheinanderwürfeln",
"Shuffle answers" => "Antworten durcheinanderwürfeln",
"Limit questions displayed per page to " => "Beschränke angezeigte Fragen pro Seite auf",
// "question(s)" => "question(s)",
"Impose a time limit of " => "Festlegung einer Zeitgrenze von",
"Allow students to store partial results and return to quiz" => "Erlaube es Teilergebnisse zu speichern und zum Quiz zurückzukehren",
"Allow students to retake this quiz " => "Erlaube es ein Quiz nochmals zu absolvieren",
"Grading and Feedback" => "Einstufung und Rückmeldung",
"Grading method " => "Einstufungsmethode ",
"Show students their score " => "Zeige Schülern ihren Punktestand ",
// "Show students the correct answers" => "Show students the correct answers",
"Publish statistics " => "Statistiken veröffentlichen",
"Extra Options" => "Extra Optionen",
"Solicit additional questions from students" => "Erbitte zusätzliche Fragen von Schülern",
"Link quiz to forum named: " => "Verlinke Quiz auf Forum mit Namen: ",
"Prologue" => "Prolog",
"Epilogue" => "Epilog",
"Quiz result stats" => "Statistiken zum Quizergebnis",
"User answers" => "Benutzerantworten",
"Stats for quizzes" => "Statistik für die Quiz",
"taken" => "teilgenommen",
"Av score" => "durchschn. Bewertung",
"Av time" => "durchschn. Zeit",
"Stats for quiz" => "Statistik für das Quiz",
"Clear Stats" => "Statistiken zurücksetzen",
"time taken" => "benötigte Zeit",
// "Pass/Fail" => "Pass/Fail",
"Passed" => "bestanden",
"Stats for this quiz Questions " => "Statistik für die Fragen in diesem Quiz ",
"Top 10" => "Top 10",
"Top 20" => "Top 20",
"Top 50" => "Top 50",
"Top 100" => "Top 100",
"Rank" => "Rang",
"Not Published" => "Nicht veröffentlicht",
"This article is currently unpublished and visible only to editors." => "Dieser Artikel ist derzeit nicht veröffentlicht und daher nur für Bearbeiter sichtbar",
"Received articles" => "Empfangene Artikel",
"Topic image" => "Themenlogo",
"Edit received article" => "Empfangenen Artikel bearbeiten",
"Image x size" => "Bildbreite",
"Image y size" => "Bildhöhe",
"Image name" => "Bildname",
"Image:" => "Bild:",
"Publishing date" => "Veröffentlichungszeitpunkt",
"Accept Article" => "Artikel annehmen",
"Received Pages" => "Empfangene Seiten",
"Edit Received Page" => "Bearbeite empfangene Seite",
"The highlight pages already exist" => "Die hervorgehobenen Seiten existieren bereits",
"Please, change the name if you want the page to be uploaded" => "Bitte ändere den Namen, wenn Du möchtest, dass die Seite hochgeladen wird",
"Received Structures" => "Empfangene Strukturen",
// "Prefix the checked: " => "Prefix the checked: ",
// " Postfix the checked: " => " Postfix the checked: ",
// "References" => "References",
// "Add a new library reference" => "Add a new library reference",
// "Edit reference settings" => "Edit reference settings",
// "Reference usage" => "Reference usage",
// "Delete reference" => "Delete reference",
// "Edit reference" => "Edit reference",
// "If you change the value of Biblio Code, you might loose the link between references" => "If you change the value of Biblio Code, you might loose the link between references",
// "Pages using reference %0" => "Pages using reference %0",
"Referer stats" => "Referer-Statistik",
"Register as a new user" => "Als neuer Benutzer registrieren",
"Tiki site registered" => "Tiki Site registriert",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Folgende Site wurde hinzugefügt. Der Link erscheint erst nach Überprüfung des Administrators in der Liste",
"You don't have permission to use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion vorhanden.",
"Please register" => "Bitte registrieren",
"Register this site at Tiki.org" => "Registriere diese Site bei Tiki.org",
"Read this first!" => "Bitte lesen!",
"On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "Auf dieser Seite kannst Du Deine Tiki bei Tiki.org bekanntmachen. Sie wird dort in einer Liste von bekannten Tiki-Sites gezeigt",
"Registering is voluntary." => "Die Registrierung ist freiwillig.",
"Registering does not give you any benefits except one more link to your site." => "Eine Registrierung bringt keine Vorteile außer einen zusätzlichen Link auf die Site.",
"You don't get any emails, we don't sell the data about your site." => "Du bekommst keine E-Mails und wir verkaufen auch keine Daten. :)",
"Registering is just for us to get an overview of Tiki's usage." => "Die Registrierung hilft uns einen kleinen Überblick über die Nutzung von Tiki zu gewinnen.",
"If your site is private or inside your intranet, you should not register!" => "Wenn Deine Tiki Site rein privat oder nur in Deinem Intranet zu erreichen ist, tragen Deine Site bitte nicht ein!",
"tiki.org" => "tiki.org",
"Information about your site" => "Informationen zu Deiner Site",
"Enter your username or email" => "Trage Deinen Benutzernamen oder E-Mail ein",
"Enter your email" => "Trage Deine E-Mail ein",
// "Request Password Reset" => "Request Password Reset",
"Rename page" => "Seite umbenennen",
// "Redirect original page" => "Redirect original page",
// "301 Redirect - \\\"moved permanently\\\" HTTP response status code" => "301 Redirect - \\\"moved permanently\\\" HTTP response status code",
// "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)" => "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)",
// "Roll back page %0 to version %1" => "Roll back page %0 to version %1",
// "Describe the reason for roll back" => "Describe the reason for roll back",
// "Enter some text to describe the reason for rolling back" => "Enter some text to describe the reason for rolling back",
"This feature currently searches and replaces within wiki pages only" => "Diese Funktion sucht und ersetzt Text nur innerhalb von Wikiseiten",
"Max number of pages at a time" => "Maximale Anzahl von Seiten auf einmal",
"Number of surrounding chars to preview" => "Anzahl von umgebenden Zeichen für die Vorschau",
"Replace selected" => "Ersetze ausgewähltes",
"Searched" => "Gesucht",
// "Search Query" => "Search Query",
"Search in" => "Suche in",
"Date Search:" => "Datumssuche:",
"All dates" => "Alle Daten",
"{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "Kalendereinträge",
"{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}\"" => "{\$where_label|escape}\"",
"{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Einfache Suche",
"No pages matched the search criteria" => "Keine passenden Seiten zum Suchkriterium",
"You can also send newsletters using an external client" => "Du kannst auch Newsletter durch einen externen Client senden",
"This newsletter will be sent to {\$subscribers} email addresses." => "Der Newsletter wird an {\$subscribers} E-Mailadressen verschickt.",
// "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds" => "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds",
"Reply to" => "Antwort an",
// "Send from" => "Send from",
"Recipients" => "Empfänger",
"Validated" => "Validiert",
"Is user" => "Ist Benutzer",
"Sending Newsletter" => "Sende Newsletter",
// "sending to {\$subscribers} addresses" => "sending to {\$subscribers} addresses",
// "with the 'Reply To' email set to: {\$replyto}" => "with the 'Reply To' email set to: {\$replyto}",
// "with the 'Send From' email set to: {\$sendfrom}" => "with the 'Send From' email set to: {\$sendfrom}",
"Prepare a newsletter to be sent" => "Newsletter für Versand vorbereiten",
"Admin templates" => "Vorlagen verwalten",
"Data HTML:" => "HTML-Daten",
"Must be wiki parsed" => "Wiki Parser anwenden",
// "Wiki Parsed" => "Wiki Parsed",
"Is HTML" => "Ist HTML",
"Data Txt:" => "Text",
"Article Clip (read only):" => "Artikelausschnitt (nur lesen):",
"Clip Now" => "Jetzt ausschneiden",
"Clip Articles" => "Artikel ausschneiden",
"To include the article clipping into your newsletter, cut and paste it into the contents." => "Um den Artikel in deinen Newsletter einzufügen, schneide ihn aus und füge ihn bei den Inhalten ein (Copy/Paste)",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending." => "Wenn Autoclipping aktiviert ist, kannst Du auch \"~~~articleclip~~~\" verwenden, das beim Senden mit dem letzten Clip ersetzt wird.",
"Be careful not to paste articles that must not be seen by the recipients" => "Gebe acht, keine Artikel einzufügen, die von Empfängern nicht gesehen werden dürfen",
"Attached Files" => "Angehängte Dateien",
"remove" => "entfernen",
"octets" => "Oktett",
"To add a file, click here" => "Um eine Datei anzuhängen, klicke hier",
"Reply To Email" => "Antworte per E-Mail",
"if not:" => "wenn nicht:",
"Sender email not set" => "E-Mail-Absenderadresse nicht angegeben",
// "Send From Email" => "Send From Email",
"Save as Draft" => "Als Entwurf speichern",
"Save your changes" => "Speichere Deine Änderungen",
"Save any changes and send to all subscribers" => "Speichere alle Änderungen und sende sie zu allen Abonnenten",
"Drafts (%0)" => "Entwurf (%0)",
"Sent Editions (%0)" => "Gesendete Editionen (%0)",
"Send objects" => "Objekte senden",
"Transmission results" => "Übertragungsergebnisse",
"Send Wiki Pages" => "Wiki-Seiten senden",
"Send a structure" => "Sende eine Struktur",
"Send Articles" => "Artikel senden",
"Add Article" => "Artikel hinzufügen",
"Send objects to this site" => "Objekte an diese Site senden",
"Ex: http://tiki.org or localhost" => "Z.B.: http://tiki.org oder localhost",
"Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Benutze /commxmlrpc.php wenn Deine Tiki im Root installiert ist. Wenn nicht passe /tiki nach Deinen Bedürfnissen an",
"Report this page" => "Berichte diese Seite",
"Page shared" => "Seite geshared",
"The link was sent via email to the following addresses" => "Dieser Link wurde via E-Mail zu folgender Adresse geschickt",
"The link was sent via Twitter" => "Dieser Link wurde via Twitter gesendet",
"The link was posted on your Facebook wall" => "Dieser Link wurde auf Deine Facebook Pinnwand geschrieben",
"The link was sent as message to" => "Dieser Link wurde als Nachricht gesendet an",
"The link was published in a" => "Dieser Link wurde veröffentlicht in eine(r)",
"Have a look at this page" => "Werfe einen Blick auf diese Seite",
// "Access rights are granted for the page" => "Access rights are granted for the page",
"Short link" => "Kurzlink",
// "Send email" => "Send email",
"Recipient(s)" => "Empfänger",
"Separate multiple email addresses with a comma and a space" => "Trenne multiple E-Mailadressen mit einem Komma und einem Leerzeichen",
"Separate multiple email addresses with a comma." => "Trenne multiple E-Mailadressen mit einem Komma.",
"Your name" => "Dein Name",
// "Recipients can subscribe to token notifications" => "Recipients can subscribe to token notifications",
// "Token Access Limit" => "Token Access Limit",
// "How many times recipients can access this page" => "How many times recipients can access this page",
"Tweet via Twitter" => "Via Twitter tweeten",
"Authorize with Twitter first" => "Zuerst die Twitteranmeldung eintragen",
"Have a look at " => "Werfe eine Blick auf ",
"Put on my Facebook wall" => "An die Facebook Pinnwand schreiben",
"Authorize with Facebook first" => "Zuerst die Facebookanmeldung eintragen",
"Link text" => "Linktext",
"This will be the title for the URL" => "Dies wird der Titel für die URL sein",
"Like this post" => "Diesen Eintrag mögen",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "Du hast entweder keine Berechtigung, Nachrichten zu senden, oder hast es verboten, dass andere Benutzer Dir Nachrichten schicken können",
// "User(s)" => "User(s)",
"Separate multiple recipients with a semicolon" => "Trenne multiple Empfänger mit einem Semikolon",
"Post on forum" => "Im Forum posten",
"There is no forum where you can post a message" => "Es gibt kein Forum, in welches Du eine Nachricht eintragen kannst",
"password-protected" => "passwortgeschützt",
"Share access rights" => "Teile Zugriffsrechte",
"Return to previous page" => "Zu vorheriger Seite zurückkehren",
// "Create sheet" => "Create sheet",
// "Configure sheet" => "Configure sheet",
"There are individual permissions set for this sheet" => "Für diese Tabelle sind individuelle Berechtigungen vergeben",
"Class Name:" => "Klassenname:",
"Header Rows" => "Kopfzeilen",
"Footer Rows" => "Fußzeilen",
"Wiki Parse Values" => "Wiki Parser Werte",
"Parent Spreadsheet" => "Übergeordnete Tabelle",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Hierdurch kann eine Tabelle zum \"Kind\" eines multiplen Tabellensatzes gemacht werden",
"You can access the sheet using the following URL:" => "Du hast Zugriff auf diese Tabelle mit der folgenden URL:",
"Banned Words" => "Verbannte Worte",
"Change shoutbox general settings" => "Shoutbox-Einstellungen ändern",
"auto-link urls" => "Automatisch URLs in Links wandeln",
"Post or edit a message" => "Eine Nachricht posten oder bearbeiten",
"Location : " => "Ort: ",
"Content may be out of date" => "Inhalt kann nicht mehr aktuell sein",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "Eine dringende Übersetzungsanfrage wurde gesendet. Bis diese Seite aktualisiert wurde, kannst Du eine korrigierte Version dieser Seite auf den folgenden Seiten ansehen",
// "Update from it" => "Update from it",
"page: %0/%1" => "Seite: %0/%1",
"This text was automatically translated by Google Translate from the following page: " => "Dieser Text wurde automatisch von Google Translate von der folgenden Seite übersetzt: ",
// "Rate this page" => "Rate this page",
"Last edited by" => "Zuletzt bearbeitet von",
"based on work by" => "basierend auf der Arbeit von",
"Contributors to this page" => "Zu dieser Seite haben beigesteuert",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
"Twitter authorisation" => "Twitterautorisierung",
"to manage your authorisations at Twitter" => "um die Autorisierung bei Twitter zu verwalten",
"this site with twitter.com to use Twitter integration of this site" => "diese Site bei twitter.com um die Twitter-Integration der Site zu benutzen",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
"Facebook authorisation" => "Facebookautorisierung",
// "to manage your authorizations at Facebook" => "to manage your authorizations at Facebook",
// "this site within facebook.com to use Facebook integration with this site" => "this site within facebook.com to use Facebook integration with this site",
// "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first" => "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first",
// "LinkedIn authorisation" => "LinkedIn authorisation",
// "this site to link your user to your LinkedIn account" => "this site to link your user to your LinkedIn account",
"The site admin has set up a global account which will be used for this site" => "Der Siteadministrator hat ein globales Konto eingerichtet, dass für diese Site benutzt wird",
"bit.ly Login" => "bit.ly Login",
"bit.ly Key" => "bit.ly Schlüssel",
"Save changes" => "Änderungen speichern",
"You will be redirected to the home page shortly" => "Du wirst gleich auf die Startseite weitergeleitet",
"to go to the home page immediately" => "um direkt zur Homepage zu gehen",
"Please provide local account information" => "Bitte gebe Deine Kontoinformationen für Dein lokales Konto an",
// "Do you already have a local account for this site" => "Do you already have a local account for this site",
// "Login to link to it using the following form instead" => "Login to link to it using the following form instead",
"Link to Existing Account" => "Link zu bestehendem Konto",
"You will not see the latest queries" => "Du wirst nicht die letzten Abfragen sehen",
"Query" => "Abfrage",
"Params" => "Parameter",
"Most viewed objects" => "Meist besuchte Objekte (gesamt)",
"Most viewed objects in the last 7 days" => "Meist besuchte Objekte der letzten 7 Tage",
"Site Stats" => "Site-Statistik",
"Date of first pageview" => "Datum des ersten Seitenaufrufs",
"Days since first pageview" => "Tagen seit dem ersten Seitenaufruf",
"Total pageviews" => "Besuche gesamt",
"Average pageviews per day" => "Durchschn. Besuche pro Tag",
"Wiki Stats" => "Wiki-Statistik",
"Size of Wiki Pages" => "Größe der Wiki-Seiten",
"Average page length" => "Durchschn. Seitenlänge",
"Average versions per page" => "Durchschn. Versionen pro Seite",
"Visits to wiki pages" => "Besuche auf Wiki-Seiten",
"Average links per page" => "Durchschn. Links pro Seite",
"Image galleries Stats" => "Bildergalerie-Statistik",
"Average images per gallery" => "Durchschn. Bilder pro Galerie",
"Total size of images" => "Größe der Bilder gesamt",
"Average image size" => "Durchschn. Bildgröße",
"Visits to image galleries" => "Besuche in Bildergalerien",
"File galleries Stats" => "Dateiarchiv-Statistik",
"Average files per gallery" => "Durchschn. Dateien pro Archiv",
"Total size of files" => "Größe der Dateien gesamt",
"Average file size" => "Durchschn. Dategröße",
"Visits to file galleries" => "Besuche in Dateiarchiven",
"Articles Stats" => "Artikel-Statistik",
"Total reads" => "Zugriffe insgesamt",
"Average reads per article" => "Durchschn. Zugriffe pro Artikel",
"Total articles size" => "Artikel Größe gesamt",
"Average article size" => "Durchschn. Artikelgröße",
"Forum Stats" => "Foren-Statistik",
"Total topics" => "Themen gesamt",
"Average topics per forums" => "Durchschn. Themen pro Forum",
"Total replies" => "Gesamtzahl Antworten",
"Average number of replies per topic" => "Durchschnittliche Anzahl von Antworten pro Thema",
"Visits to forums" => "Besuche in Foren",
"Blog Stats" => "Blog-Statistik",
"Weblogs" => "Blogs",
"Total posts" => "Posts gesamt",
"Average posts per weblog" => "Durchschn. Einträge pro Blog",
"Total size of blog posts" => "Gesamtgröße der Blog-Posts",
"Average posts size" => "Durchschn. Post Größe",
"Visits to weblogs" => "Besuche auf Blogs",
"Poll Stats" => "Abstimmungs-Statistik",
"Total votes" => "Stimmen gesamt",
"Average votes per poll" => "Durchschn. Stimmen pro Abstimmung",
"FAQ Stats" => "FAQ Statistiken",
"Total questions" => "Fragen gesamt",
"Average questions per FAQ" => "Durchschn. Fragen pro FAQ",
"User Stats" => "Benutzer-Statistik",
"Average bookmarks per user" => "Durchschn. Lesezeichen pro Benutzer",
"Average questions per quiz" => "Durchschn. Fragen pro Quiz",
"Quizzes taken" => "Quiz durchgeführt",
"Average quiz score" => "Durchschn. Quiz-Punktzahl",
"Average time per quiz" => "Durchschn. Zeit pro Quiz",
"Most viewed objects in period" => "Die am meisten angesehenen Objekte in einer Periode",
"{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
"{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Benutzungsdiagramm",
"Usage chart image" => "Grafik der Nutzungsstatistik",
"Daily Usage" => "Zugriffe / Tag",
// "Piwik Analytics Dashboard" => "Piwik Analytics Dashboard",
// "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard" => "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard",
"Stats for surveys" => "Statistik für Umfrage",
"Last taken" => "Zuletzt teilgenommen",
"Stats for survey" => "Statistik für Umfrage",
// "Select a user to preview its answer (marked as" => "Select a user to preview its answer (marked as",
// "User voted" => "User voted",
// "Select User" => "Select User",
// "no answer" => "no answer",
"Tiki Logs" => "Tiki Logs",
"Export through Action Log" => "Exportiere durch Aktionslog",
"Clean logs older than" => "Lösche Logs die älter sind als",
// "Are you sure you want to revert" => "Are you sure you want to revert",
// "Revert" => "Revert",
"Time Left" => "Verbleibende Zeit",
"Send Answers" => "Antworten senden",
"Thank you for your submission" => "Vielen Dank für Deine Teilnahme",
"Send a link to a friend" => "Sende einem Freund einen Link",
"Your email was sent" => "Deine E-Mail wurde verschickt",
"The link was sent to the following addresses" => "Der Link wurde zu den folgenden Adressen gesendet",
"Friend's email" => "E-Mail des Freundes",
"Your comment" => "Dein Kommentar",
"I found an interesting page that I thought you would like." => "Ich habe eine interessante Seite gefunden. Vielleicht möchtest Du sie einmal ansehen.",
"TikiTests Edit" => "TikiTests bearbeiten",
"Summary mode" => "Zusammenfassungsmodus",
"Show Page Differences" => "Zeige Seitenunterschiede",
"Show Tidy Errors and Warnings" => "Zeige Bereinigungsfehler und Warnungen",
"Show POST Data" => "Zeige POST-Daten",
"Use Current Session/Log out" => "Benutze gegenwärtige Sitzung/Abmeldung",
"Recorded Links" => "Aufgezeichnete Links",
"Element to compare (Xpath expression)" => "Zu vergleichendes Element (Xpath-Ausdruck)",
"Test Xpath Expression" => "Teste Xpath-Ausdruck",
"Post Variables" => "Post Variablen",
"Tidy Results" => "Bereinige Ergebnisse",
"Delete this link" => "Lösche diesen Link",
"TikiTests List" => "TikiTests Liste",
"Config" => "Konfigurieren",
"Replay" => "Wiedergeben",
"Tidy extension not present" => "Tidy-Erweiterung nicht vorhanden",
"PECL HTTP extension present" => "PECL HTTP-Erweiterung vorhanden",
"cURL extension present" => "cURL-Erweiterung vorhanden",
"PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP und cURL-Erweiterungen sind nicht vorhanden. Wiedergabe von TikiTest ist daher nicht möglich",
"List TikiTests" => "Liste TikiTests",
"Create a TikiTest" => "Erstelle ein TikiTest",
"Replay the TikiTest" => "Gebe ein TikiTest wieder",
"Edit the TikiTest" => "Bearbeite ein TikiTest",
"TikiTests Record Configuration" => "TikiTests Aufzeichnungskonfiguration",
"Start Recording Test" => "Starte Aufzeichnung eines Test",
"TikiTests Replay Configuration" => "TikiTests Wiedergabekonfiguration",
"Failure" => "Fehler",
"Reference" => "Referenz",
"The pages are different" => "Die Seiten sind unterschiedlich",
"The pages are identical" => "Die Seiten sind identisch",
"Recording to pause press the pause button" => "Für Pause den Pause-Knopf drücken",
"Pause the recording" => "Pausiere die Aufzeichnung",
"Paused to resume press the play button" => "Pausiert. Drücke Abspielen, um weiter aufzuzeichnen",
"Resume the recording" => "Zeichne weiter auf",
"Stop the recording" => "Stoppe Aufzeichnung",
"Control by Objects" => "Kontrolle anhand der Objekte",
"Control by Sections" => "Theme Bereiche",
"Assign themes to categories" => "Kategorien Themes zuweisen",
"Assigned categories" => "Zugeordnete Kategorien",
// "Delete selected" => "Delete selected",
"Control by Categories" => "Theme Kategorien",
"Assign themes to objects" => "Objekten Themen zuordnen",
"Assigned objects" => "Zugeordnete Objekte",
"Assign themes to sections" => "Bereichen Themen zuweisen",
"Assigned sections" => "Zugeordnete Bereiche",
// "Timesheets" => "Timesheets",
"Apply the following profile for enhancements: " => "Wende das folgende Profil für Erweiterungen an: ",
"Time Tracker" => "Zeit-Tracker",
"Local Cache (Not Committed)" => "Lokaler Cache (nicht gesendet)",
"Saved (Committed)" => "Gespeichert (gesendet)",
"New task" => "Neue Aufgabe",
// "Toggle completed" => "Toggle completed",
// "Toggle archived" => "Toggle archived",
"Task name" => "Aufgabenname",
"Estimate (in min.)" => "Geschätzt (in Min.)",
"Estimate" => "Geschätzt",
"Task is completed" => "Aufgabe ist abgeschlossen",
"Task is archived" => "Aufgabe ist archiviert",
"Created at" => "Erstellt am/um",
"Are you sure you want to delete all tasks" => "Bist Du sicher, dass Du alle Aufgaben löschen willst",
"Commit Time Sheet Items" => "Sende Zeiterfassungs-Einträge",
"View All" => "Alle ansehen",
"View My Items" => "Meine Einträge ansehen",
"Summary" => "Zusammenfassung",
"Time Spent" => "Verbrachte Zeit",
"Done By" => "Durch",
"Add Tracker" => "Tracker hinzufügen",
"Add Tracker To Tracker Report" => "Tracker zum Tracker-Report hinzufügen",
"View Tracker Report" => "Trackerbericht ansehen",
"Pick tracker to join" => "Wähle Tracker zum aneinanderfügen",
"Pick fields to join on" => "Wähle Felder zum aneinanderfügen",
"Join inner" => "Innere Verbindung",
"Join outer" => "Äußere Verbindung",
"Tracker - Open" => "Tracker - offen",
"Tracker - Pending" => "Tracker - anstehend",
"Tracker - Closed" => "Tracker - geschlossen",
"Tracker Item History" => "Historie des Trackereintrages",
"View Tracker Item" => "Trackereintrag ansehen",
"Not logging" => "Nicht loggen",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable",
"Edit File:" => "Datei bearbeiten:",
"Advanced mode" => "Erweiterter Modus",
"Simple mode" => "Einfacher Modus",
"Retry" => "Nochmal versuchen",
"Additional Info" => "Zusätzliche Info",
"Syntax Tips" => "Syntax Tipps",
// "Download link using Tiki syntax" => "Download link using Tiki syntax",
// "Display an image using Tiki syntax" => "Display an image using Tiki syntax",
// "Use as a thumbnail with ShadowBox" => "Use as a thumbnail with ShadowBox",
// "Download link using HTML" => "Download link using HTML",
"You locked the file" => "Du hast die Datei gesperrt",
"The file has been locked by {\$fileInfo.lockedby}" => "Die Datei wurde gesperrt von {\$fileInfo.lockedby}",
// "File title" => "File title",
"required field for podcasts" => "bei PodCasts erforderlich",
// "File description" => "File description",
// "Re-upload from disk" => "Re-upload from disk",
// "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>" => "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>",
// "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
"Unzip zip files" => "Zipdateien entpacken",
"File can be deleted after" => "Datei kann danach gelöscht werden",
// "OCR files if supported" => "OCR files if supported",
"Creator of file, if different from the 'Uploaded by' user" => "Ersteller der Datei, wenn abweichend vom 'Hochgeladen von' Benutzer",
// "File Type" => "File Type",
// "No type" => "No type",
"Maximum number of downloads" => "Maximale Anzahl von Downloads",
"-1 for no limit" => "-1 für keine Begrenzung",
"Upload File(s)" => "Datei(en) hochladen",
"Add Another File" => "Eine weitere Datei zufügen",
"Maximum file size is around:" => "Die maximale Dateigröße beträgt ca. ",
// "Note: You are running IIS" => "Note: You are running IIS",
// "maxAllowedContentLength also limits upload size" => "maxAllowedContentLength also limits upload size",
"Please check web.config in the Tiki root folder" => "Überprüfe bitte web.config im Tiki Basispfad (root folder).",
"Uploading file..." => "Datei wird hochgeladen...",
"No File to Upload.." => "Keine Datei zum hochladen..",
// "Keeps a reference to the remote file" => "Keeps a reference to the remote file",
// "Video file uploaded" => "Video file uploaded",
"Link to file from a Wiki page" => "Link zu einer Datei von einer Wiki Seite",
// "For image files" => "For image files",
"Display full size" => "In voller Größe anzeigen",
"Display thumbnail that enlarges" => "Vorschau anzeigen, die vergrößert werden kann",
"Batch Upload Results" => "Ergebnis Batchupload",
"Upload successful!" => "Upload erfolgreich!",
"The following image was successfully uploaded" => "Das folgende Bild wurde erfolgreich hochgeladen",
"Image ID thumb" => "Bild ID Vorschau",
"You can view this image in your browser using" => "Du kannst dieses Bild in Deinem Browser betrachten",
"You can include the image in an Wiki page using" => "Du kannst ein Bild in einer Wiki Seite einbinden mit",
"or use filename" => "oder Dateinamen verwenden",
"Now enter the image URL" => "Bitte jetzt die Bild-URL eingeben",
"or upload a local image from your disk" => "oder ein lokales Bild von Deiner Festplatte hochladen",
"Batch Upload:" => "Stapelhochladen:",
"Thumbnail (optional, overrides automatic thumbnail generation):" => "Vorschaubild (optional, überschreibt automatische Vorschaubild-Erzeugung):",
"Upload From Disk:" => "Von Festplatte hochladen:",
"No gallery available" => "Kein Archiv verfügbar",
"You have to create a gallery first" => "Du musst zuerst ein Archiv erstellen",
"User assigned modules" => "Vom Benutzer zugewiesene Module",
// "to assign modules, which will make them available for creating a custom order on this page" => "to assign modules, which will make them available for creating a custom order on this page",
"Restore defaults" => "Standardeinstellungen wiederherstellen",
"The column is disabled" => "Diese Spalte ist deaktiviert",
"#" => "#",
"Move module up" => "Modul nach oben verschieben",
"Move module down" => "Modul nach unten verschieben",
// "Move to right side" => "Move to right side",
// "Move to left side" => "Move to left side",
"Assign module" => "Modul zuweisen",
"top" => "Top",
"Current folder" => "Aktueller Ordner",
"Folders" => "Ordner",
"Folder in" => "Ordner in",
// "Refresh cache" => "Refresh cache",
"Admin folders and bookmarks" => "Ordner und Lesezeichen verwalten",
"a folder" => "eines Ordners",
"a bookmark" => "eines Bookmarks",
"User Contacts Preferences" => "Einstellungen Benutzerkontakte",
"Change preferences" => "Einstellungen übernehmen",
"Manage Fields" => "Felder verwalten",
"{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{\$chdata.name}" => "{\$chdata.name}",
"Send me a message" => "Schick mir eine Nachricht",
"Basic Data" => "Allgemeine Daten",
// "Assign group" => "Assign group",
"Assign Group" => "Gruppe zuweisen",
"User Icon" => "Benutzersymbol",
"{\$gender}" => "{\$gender}",
"(non public)" => "(nicht öffentlich)",
"{\$country|stringfix}" => "{\$country|stringfix}",
"User's homepage" => "Homepage des Benutzers",
"Personal Wiki Page" => "Private Wiki-Seite",
// "Your relationship with other users" => "Your relationship with other users",
// "Relationship of this user to you" => "Relationship of this user to you",
"The user has chosen to make his information private" => "Der Benutzer hat diese Information als privat deklariert",
"Additional Information" => "Zusätzliche Informationen",
// "Change user information" => "Change user information",
"User Contribution" => "Benutzerbeiträge",
"has contributed to the following content" => "hat folgende Inhalte beigetragen",
"has not contributed to any content yet" => "hat bislang noch keine Inhalte beigetragen",
// "Blogs Posts" => "Blogs Posts",
"Forum comments" => "Forenkommentare",
"Forum topics" => "Forenthemen",
"Who Looks at Items?" => "Wer sieht meine Beiträge an?",
"Who Looks at Your Items?" => "Wer sieht meine Beiträge an?",
"Who Looks at His or Her Items?" => "Wer sieht seine Beiträge an?",
"Send Me A Message" => "Eine Nachricht schicken",
"Send me a message !" => "Schick' mir eine Nachricht!",
"The following message will be sent to user" => "Die nachfolgende Nachricht wird geschickt an",
"Message Body" => "Nachricht",
// "My Mail-in" => "My Mail-in",
// "Are you sure you want to delete the routing rule" => "Are you sure you want to delete the routing rule",
// "Configure how your mailed-in wiki pages are to be linked / organized" => "Configure how your mailed-in wiki pages are to be linked / organized",
// "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked" => "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked",
// "Only newly created pages, using the mail-in wiki-put function, are affected" => "Only newly created pages, using the mail-in wiki-put function, are affected",
// "Go to wiki structure setting" => "Go to wiki structure setting",
"Toggle options" => "Optionen umschalten",
"Male" => "männlich",
"Female" => "weiblich",
// "Your Personal Wiki Page" => "Your Personal Wiki Page",
"User's personal tracker information" => "Informationen über persönlichen Benutzertracker",
"View extra information" => "Zusätzliche Informationen anzeigen",
"Your personal tracker information" => "Informationen zu Deinem persönlichen Tracker",
// "Is email public" => "Is email public",
"Unavailable - please set your email below" => "Nicht verfügbar - bitte zuerst E-Mailadresse eingeben",
// "Preferred perspective" => "Preferred perspective",
// "Email character set" => "Email character set",
// "Admin Language" => "Admin Language",
"Can you read more languages?" => "Verstehst Du auch andere Sprachen?",
// "Other languages you can read" => "Other languages you can read",
"Select language..." => "Wähle Sprache...",
// "Select from the dropdown to add automatically to the list below" => "Select from the dropdown to add automatically to the list below",
// "Displayed timezone" => "Displayed timezone",
"Detect user time zone if browser allows, otherwise site default" => "Versuche Zeitzone zu erkennen, ansonsten Site-Default benutzen",
// "Site time zone <strong>%0</strong> is enforced and overrides user preferences" => "Site time zone <strong>%0</strong> is enforced and overrides user preferences",
// "Use 12-hour clock in time selectors" => "Use 12-hour clock in time selectors",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Bei MouseOver über Benutzername: Infofenster zu Benutzer anzeigen (sofern dieser das erlaubt)",
"User Messages" => "Benutzernachrichten",
"Notify sender when reading his mail" => "Lesebestätigung an den Autor einer Nachricht übermitteln",
// "Message priority notification" => "Message priority notification",
// "Read message auto-archiving" => "Read message auto-archiving",
"never" => "niemals",
// "Auto-archive read messages after selected days" => "Auto-archive read messages after selected days",
"User Tasks" => "Benutzeraufgaben",
// "XMPP account JID" => "XMPP account JID",
// "If empty, Tiki will provide default value" => "If empty, Tiki will provide default value",
// "You have to provide this when using custom XMPP server" => "You have to provide this when using custom XMPP server",
"My user items" => "Meine Benutzer-Objekte",
// "My articles" => "My articles",
"My level" => "Mein Level",
// "Remember which remarksbox (alert box) you have closed and don't show them again" => "Remember which remarksbox (alert box) you have closed and don't show them again",
// "Reset remark boxes visibility" => "Reset remark boxes visibility",
// "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed" => "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed",
"Account Information" => "Kontoinformationen",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Felder \"Neues Passwort\" und \"Passwort bestätigen\" frei lassen, um das alte Passwort zu behalten",
"Current password (required)" => "aktuelles Passwort (erforderlich)",
"Account Deletion" => "Konto löschen",
"Are you really sure you want to delete the account %0" => "Bist Du wirklich sicher, dass Du das Konto %0 löschen willst",
"Check this box if you really want to delete the account" => "Setze den Haken, wenn Du Dein Konto wirklich löschen willst",
"Delete the account:" => "Lösche das Konto:",
"Delete my account" => "Mein Konto löschen",
"Task list" => "Aufgabenübersicht",
"Admin mode off" => "Verwaltungsmodus aus",
"Admin mode on" => "Verwaltungsmodus an",
"Task help" => "Hilfe",
"Empty Trash" => "Papierkorb löschen",
"Task received" => "Aufgabe empfangen",
"You received this task" => "Du hast diese Aufgabe empfangen",
"Task sent" => "Aufgabe gesendet",
"You sent this task to another user" => "Du hast diese Aufgabe einem anderen Benutzer zugesandt",
"Task shared by a group" => "Aufgabe geteilt von einer Gruppe",
"Task is shared by a group" => "Die Gruppe teilt sich diese Aufgabe",
"Accepted by task user and creator" => "Von Aufgabenbenutzer und -ersteller akzeptiert",
"Task has been accepted by user and creator" => "Aufgabe wurde von Benutzer und vom Ersteller akzeptiert",
"Rejected by a user" => "Abgelehnt von Benutzer",
"Task has been rejected by a user" => "Aufgabe wurde von einem Benutzer abgelehnt",
"Waiting for me" => "Auf mich wartend",
"Task has not yet been accepted or rejected by you" => "Aufgabe wurde von Dir noch nicht angenommen oder abgelehnt",
"Waiting for other user" => "Auf andere Benutzer wartend",
"Task has not yet been accepted or rejected by another user" => "Aufgabe wurde von einem anderen Benutzer noch nicht angenommen oder abgelehnt",
"Admin Mode" => "Verwaltungsmodus",
"Edit Task" => "Aufgabe bearbeiten",
"NOT accept" => "NICHT annehmen",
"Remove from Trash" => "Aus dem Papierkorb",
"Move to trash" => "Verschiebe in Müll",
"Move to Trash" => "Verschiebe in Müll",
"Task saved" => "Aufgabe gespeichert",
"View Task" => "Aufgabe ansehen",
"Open a new task" => "Neue Aufgabe hinzufügen",
"Last Version" => "Neueste Version",
"taskId" => "Aufgaben-Nummer",
"Task user" => "ist zu bearbeiten von",
"Only the creator can delete this task" => "Nur Ersteller kann die Aufgabe löschen",
"Use start date and time" => "Startdatum/-zeit benutzen",
"Use end date and time" => "Endedatum/-zeit benutzen",
"Open / In Process" => "Offen / in Bearbeitung",
"Waiting / Not Started" => "Wartend / noch nicht begonnen",
"Percentage completed" => "Prozent erledigt",
"Waiting" => "Wartend",
"Shared for Group" => "Wird geteilt von Gruppe",
"Accepted by User" => "Akzeptiert von Benutzer",
"No / Rejected" => "Nein / zurückgewiesen",
"Accepted by Creator" => "Vom Ersteller akzeptiert",
"This message will be send to users if you are makeing changes of assigned tasks" => "Diese Nachricht wird Benutzern geschickt, wenn Du eine Änderung an der zugewiesenen Aufgabe vornimmst",
"Send a message with changes" => "Nachricht mit Änderungen verschicken",
"Modified by" => "Geändert von",
"Marked as deleted" => "Als gelöscht markiert",
"Inform task user by email" => "Bearbeiter per E-Mail informieren",
"Reload" => "Aktualisieren",
"You can only view this task" => "Du kannst diese Aufgabe nur ansehen",
"In the trash" => "In den Papierkorb",
"Not Accepted by One User" => "Nicht akzeptiert von einem Benutzer",
"Not Accepted User" => "Nicht akzeptierender Benutzer",
"No tasks entered" => "Keine Aufgaben vorhanden",
"Select One" => "Status",
"Trash" => "Müll",
"Undo Trash" => "Aus Papierkorb",
"Show:" => "Anzeigen:",
"Received" => "Erhalten",
"Submitted" => "Zugewiesen",
"Shared" => "Geteilt",
"All Shared Tasks" => "Alle geteilten Aufgaben",
// "Previous version" => "Previous version",
// "Next version" => "Next version",
"completed (100%)" => "erledigt (100%)",
"Public for group" => "Öffentlich für die Gruppe",
// "Wikis" => "Wikis",
// "Forum Threads" => "Forum Threads",
// "{\$userinfo['user_country']|stringfix}" => "{\$userinfo['user_country']|stringfix}",
// "{\$userinfo['user_gender']}" => "{\$userinfo['user_gender']}",
// "This user has contributed to the following wiki pages" => "This user has contributed to the following wiki pages",
// "This user has not contributed to any wiki pages yet" => "This user has not contributed to any wiki pages yet",
// "This user has not contributed any blog posts yet" => "This user has not contributed any blog posts yet",
// "This user has contributed to the following tracker items" => "This user has contributed to the following tracker items",
// "This user has not contributed to any tracker items yet" => "This user has not contributed to any tracker items yet",
// "This user has contributed to the following articles" => "This user has contributed to the following articles",
// "This user has not contributed to any articles yet" => "This user has not contributed to any articles yet",
// "This user has started to the following forum threads" => "This user has started to the following forum threads",
// "This user has not contributed to any forums yet" => "This user has not contributed to any forums yet",
// "Add to Network" => "Add to Network",
// "Remove from Network" => "Remove from Network",
"User Watches and preferences" => "Benutzer-Beobachtungspunkte und Einstellungen",
"You need to set your email to receive email notifications" => "Du musst Deine E-Mail angeben, um E-Mailbenachrichtigungen zu erhalten",
"Use reports to summarise notifications about objects you are watching." => "Nutze Berichte, um Benachrichtigungen in einer E-Mail zusammenzufassen.",
"Use reports" => "Berichte nutzen",
// "Reporting interval" => "Reporting interval",
// "Every minute" => "Every minute",
// "Hourly" => "Hourly",
"Monthly" => ";onatlich",
// "Report length" => "Report length",
"Short report" => "Kurzer Bericht",
"Detailed report" => "Detaillierter Bericht",
// "Report format" => "Report format",
// "Send report even if no activity" => "Send report even if no activity",
"My watches" => "Meine Beobachtungspunkte",
"Use \"watches\" to monitor wiki pages or other objects." => "Benutze \"Beobachtungspunkte\" um Wikiseiten oder andere Objekte zu überwachen.",
// "Watch new items by clicking the {icon name='watch'} button on specific pages" => "Watch new items by clicking the {icon name='watch'} button on specific pages",
"Add Watch" => "Beobachtungspunkt hinzufügen",
"Select event type" => "Ereignis auswählen",
"All watched events" => "Alle beobachteten Ereignisse",
"A user submits a blog post" => "Ein Benutzer reicht einen Blogeintrag ein",
"A user posts a forum thread" => "Ein Benutzer hat einen Beitrag in einem Forum veröffentlicht",
"A user posts a forum topic" => "Ein Benutzer hat ein Forumthema veröffentlicht",
"A user edited or commented on a wiki page" => "Ein Benutzer hat eine Wiki Seite bearbeitet oder kommentiert",
"A user edited a wiki page" => "Jemand hat eine Wikiseite bearbeitet",
"{\$w.type}" => "{\$w.type}",
// "Use this form to control notifications about objects you are watching" => "Use this form to control notifications about objects you are watching",
// "Send notification when I am the editor" => "Send notification when I am the editor",
"Used space:" => "Benutzter Speicher:",
"up to" => "bis zu",
"no limit for admin" => "keine Beschränkung für Administrator",
"User Menu" => "Benutzermenü",
"May need to refresh twice to see changes" => "Evtl. zweimal Refresh nötig, damit die Änderungen sichtbar werden",
"Add top level bookmarks to menu" => "Lesezeichen der obersten Ebene ins Menü übernehmen",
"Add or edit an item" => "Eintrag hinzufügen/bearbeiten",
"New Window" => "Neues Fenster",
"replace window" => "Fenster ersetzen",
"Delete Selected" => "Markierte löschen",
"Pos" => "Position",
"User_versions_for" => "Benutzer_Versionen_für",
// "Monitor articles" => "Monitor articles",
// "Stop monitoring articles" => "Stop monitoring articles",
"{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
// "\"}Actions for %0" => "\"}Actions for %0",
"No articles yet." => "Noch keine Artikel.",
// "New article" => "New article",
"Banner stats" => "Banner-Statistik",
"Create new banner" => "Neues Banner erzeugen",
"Banner Information" => "Banner-Information",
"Click ratio" => "Click-Ratio",
"Weekdays" => "Wochentage",
"mon" => "Mo",
"tue" => "Di",
"wed" => "Mi",
"thu" => "Do",
"fri" => "Fr",
"sat" => "Sa",
"sun" => "So",
"Banner raw data" => "Banner Rohdaten",
"Cached" => "gecached",
"This is a cached version of the page." => "Dies ist eine gecachte Version der Seite.",
"Click here to view the Google cache of the page instead." => "Zum Betrachten der Seite im Google-Cache hier klicken.",
"{\$faq_info.title}" => "{\$faq_info.title}",
"There are no questions in this FAQ" => "Es sind keine Fragen in diesem FAQ",
"Answers" => "Antworten",
"Add Suggestion" => "Vorschlag hinzufügen",
"Edit Forum" => "Forum bearbeiten",
"Forum List" => "Forenliste",
// "Forum actions" => "Forum actions",
// "Monitor topics" => "Monitor topics",
// "Stop monitoring topics" => "Stop monitoring topics",
// "Monitor topics and threads" => "Monitor topics and threads",
// "Stop monitoring topics and threads" => "Stop monitoring topics and threads",
// "Group monitor topics" => "Group monitor topics",
// "Group monitor topics and threads" => "Group monitor topics and threads",
"Post New" => "Neuen Beitrag erstellen",
// "Deliberation" => "Deliberation",
// "Add Deliberation Item" => "Add Deliberation Item",
"Watch for replies" => "Antworten beobachten",
"Send me an email when someone replies to my topic" => "Antworten per E-Mail an mich verschicken",
"Don't send me any emails" => "keine E-Mails an mich verschicken",
"Enter your name" => "Gib Deinen Namen ein",
"Editing posts" => "Beiträge bearbeiten",
// "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax" => "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax",
// "Moderator actions on selected topics" => "Moderator actions on selected topics",
"Emot" => "Stimmung",
// "Rating <br/>(avg/max)" => "Rating <br/>(avg/max)",
// "Detailed results <br/>(counts)" => "Detailed results <br/>(counts)",
// "Detailed results <br/>(counts/%)" => "Detailed results <br/>(counts/%)",
"pts" => "Punkte",
// "Topic locked" => "Topic locked",
// "Forum locked" => "Forum locked",
// "No topics found" => "No topics found",
"posts in this forum" => "Beiträge in diesem Forum",
// "Filter Posts" => "Filter Posts",
"Last post date" => "Beitrags-Alter",
"All posts" => "alle Beiträge",
"Last hour" => "Letzte Stunde",
"Last 24 hours" => "Letzte 24 Stunden",
"Last 48 hours" => "Letzte 48 Stunden",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "normal",
"announce" => "Ankündigung",
"hot" => "heißes Thema",
"Posts with no replies" => "ohne Antworten",
"Topic List" => "Themenliste",
"The post has been reported and will be reviewed by a moderator" => "Der Eintrag wurde gemeldet und wird von einem Moderator überprüft",
// "Previous topic" => "Previous topic",
// "Next topic" => "Next topic",
"You are viewing a reply to" => "Du siehst Dir eine Antwort an, auf",
// "Thread actions" => "Thread actions",
// "Print this page" => "Print this page",
"Print all pages" => "Alle Seiten drucken",
"Show posts" => "Zeige Beiträge",
"Jump to forum:" => "Springe zu Forum:",
"View Invoice" => "Rechnung ansehen",
"Invoice %0" => "Rechnung Nr. %0",
"Date Issued %0" => "Austellungsdatum: ",
"Amount: %0" => "Betrag: %0",
"Payment Terms: %0" => "Bezahlungsbedingungen: %0",
// "This sheet is already being edited by %0" => "This sheet is already being edited by %0",
"Back to Page" => "Zurück zu Seite",
"Tiki Sheet" => "TikiTabellen",
"Save current spreadsheet" => "Speichere gegenwärtige Tabelle",
"Cancel editing current spreadsheet" => "Bearbeitung gegenwärtiger Tabelle abbrechen",
"No parse" => "Nicht parsen",
"What would you like to add" => "Was möchtest Du hinzufügen",
"New spreadsheet" => "Neue Tabelle",
"Existing spreadsheet" => "Existierende Tabelle",
"Tracker as a spreadsheet" => "Tracker als eine Tabelle",
"Spreadsheet from file gallery" => "Tabelle aus einem Dateiarchiv",
"Cell" => "Zelle",
"Set Reference" => "Referenz setzen",
"Un-Merge" => "Teilen",
"Adds an additional row to bottom of the spreadsheet" => "Fügt eine zusätzliche Zeile am Ende der Tabelle ein",
"Add Row" => "Zeile hinzufügen",
"Adds an additional rows to bottom of the spreadsheet" => "Fügt zusätzliche Zeilen am Ende der Tabelle ein",
"Add Multi-Rows" => "Zeilen hinzufügen",
"Delets the current row thats highlighted" => "Löscht die aktuell hervorgehobene Zeile",
"Delete Row" => "Zeile löschen",
"Inserts an additional row after currently selected row" => "Fügt eine zusätzliche Zeile nach der aktuell gewählten ein",
"Insert Row Before" => "Füge Zeile davor ein",
"Insert Row After" => "Füge Zeile danach ein",
"Unhides all the hidden rows" => "Deckt alle versteckten Zeilen auf",
"Show All" => "Zeige alle",
"Hides or shows the currently selected row" => "Versteckt oder zeigt die gewählten Zeilen",
"Toggle Hide Row" => "Schaltet Zeilenverstecken um",
"Adds an additional column to the right of the spreadsheet" => "Fügt eine zusätzliche Spalte rechts zur Tabelle hinzu",
"Add Column" => "Spalte hinzufügen",
"Adds an additional columns to the right of the spreadsheet" => "Fügt zusätzliche Spalten rechts zur Tabelle hinzu",
"Add Multi-Columns" => "Spalten hinzufügen",
"Deletes the current column thats highlighted" => "Löscht die aktuell hervorgehobene Spalte",
"Delete Column" => "Spalte löschen",
"Inserts an additional column after currently selected column" => "Fügt eine Spalte nach der gegenwärtig ausgewählten hinzu",
"Insert Column Before" => "Spalte davor einfügen",
"Insert Column After" => "Spalte danach einfügen",
"Fill down current cell value" => "Aktuellen Zellenwert nach unten füllen",
"Fill Down" => "Nach unten füllen",
"Fill up current cell value" => "Aktuellen Zellenwert nach oben füllen",
"Fill Up" => "Nach oben füllen",
"Unhides all the hidden columns" => "Deckt alle versteckten Spalten auf",
"Hides or shows the currently selected column" => "Versteckt oder zeigt die gewählten Spalten",
"Toggle Hide Column" => "Schaltet Spaltenverstecken um",
"Add new spreadsheet" => "Neue Tabelle hinzufügen",
"Add Spreadsheet" => "Tabelle hinzufügen",
"Delete the current spreadsheet" => "Lösche die aktuelle Tabelle",
"Delete Spreadsheet" => "Tabelle löschen",
"Recompiles the current sheet" => "Aktuelle Tabelle neu berechnen",
"Change the title of the sheet" => "Titel der Tabelle ändern",
"Wrap Cell Range" => "Umhülle Zellenumfang",
"Wrap with SUM" => "Umhülle mit SUM",
"Wrap with CEILING" => "Umhülle mit CEILING",
"Wrap with COUNT" => "Umhülle mit COUNT",
"Wrap with MAX" => "Umhülle mit MAX",
"Wrap with MIN" => "Umhülle mit MIN",
"Redo" => "Wiederholen",
"Toggle State" => "Status umschalten",
"Function Reference" => "Funktionsreferenz",
"Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Benutzungsbeispiel: =SUM(SUM(A1:B1) + SUM(D7))",
"=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
"Returns the absolute value of a number" => "Gibt den absoluten Wert einer Zahl wieder",
"Returns a rounded number" => "Gibt eine gerundete Zahl wieder",
"Returns a number rounded up based on a multiple of significance" => "Gibt eine Zahl aufgerundet auf ein Vielfaches der angegeben Signifikanz zurück",
"Counts the number of cells that contain a value" => "Zählt die Zellen, die einen Wert enthalten",
"Counts full days from a specific date - format(YYYY,MM,DD)" => "Zählt volle Tage von einem bestimmten Datum an - Format(JJJJ,MM,TT)",
"Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Konvertiert eine Zahl mit einem Währungsformat zu Text - Optionen (Nummer, Dezimal, Symbol)",
"Returns a logical value of FALSE" => "Gibt einen logischen Wert von FALSE zurück",
"Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Gibt einen Text einer gerundeten Zahl zurück - Optionen: number, decimals, useCommas (Zahl, Dezimalstellen zum Runden, Benutzung von Kommata)",
"Returns a number rounded down based on a multiple of significance" => "Gibt eine Zahl abgerundet auf ein Vielfaches der angegeben Signifikanz zurück",
"Returns the integer portion of a number" => "Gibt den Ganzzahl-Anteil einer Zahl zurück",
"Returns the largest value from the numbers provided" => "Gibt den höchsten Wert einer Menge an Zahlen wieder",
"Returns the smallest value from the numbers provided" => "Gibt den geringsten Wert einer Menge an Zahlen wieder",
"Converts a value to a number" => "Konvertiert einen Wert in eine Zahl",
"Gets full date of today" => "Fügt volles, heutiges Datum ein",
"Returns the mathematical constant called pi, which is 3.14159265358979" => "Gibt die mathematische Konstante pi wieder (3,14159265358979)",
"Returns the result of a number raised to a given power" => "Gibt das Ergebnis einer potentierten Zahl wieder",
"Returns a random number that is greater than or equal to 0 and less than 1" => "Gibt eine zufällige Zahl größer 0 und kleiner 1 zurück",
"Returns a number rounded to a specified number of digits" => "Gibt eine auf eine bestimmte Anzahl Stellen gerundete Zahl zurück",
"Returns all of the values in each of the specified cells and added together" => "Gibt alle Werte in den angegebenen Zellen aufaddiert, zurück",
"Returns a logical value of TRUE" => "Gibt einen logischen Wert von WAHR zurück",
"Converts a text value that represents a number to a number" => "Konvertiert einen Textwert, der eine Zahl repräsentiert, in eine Zahl",
"Italics" => "Kursiv",
"Uppercase" => "Kapitälchen",
"Capitalize" => "Grossbuchstaben",
"Lowercase" => "Kleinbuchstaben",
"Font Size +" => "Schriftgröße +",
"Font Size -" => "Schriftgröße -",
// "{\$tracker_info.name}" => "{\$tracker_info.name}",
// "Tracker actions" => "Tracker actions",
// "Group Monitoring" => "Group Monitoring",
// "Stop Watching" => "Stop Watching",
"atts" => "Anhänge",
"List Attachments" => "Anhänge auflisten",
"View/Edit" => "Ansehen/Bearbeiten",
"Insert New Item" => "Neuen Eintrag hinzufügen",
"View inserted item" => "eingefügten Eintrag anschauen",
"Insert new item" => "Neuen Eintrag hinzufügen",
"Synchronization" => "Synchronisation",
"This tracker is a remote copy of <a href=\"%0\">%0</a>" => "Dieser Tracker ist eine remote-Kopie von <a href=\"%0\">%0</a>",
"It was last updated on %0" => "Er wurde zuletzt am %0 aktualisiert",
"Reload field definitions" => "Felddefinitionen neu laden",
"Items added locally" => "Lokal hinzugefügte Einträge",
"Push new items" => "Schiebe neue Einträge",
"Safe modifications (no remote conflict)" => "Sichere Veränderungen (keine Zielkonflikte)",
"Dangerous modifications (remote conflict)" => "Gefährliche Veränderungen (Zielkonflikte)",
"On push, local items will be removed until data reload" => "Beim Schieben werden lokale Objekte entfernt bis Daten neu geladen werden",
"Push local changes" => "Schiebe lokale Änderungen",
"Local changes will be lost" => "Lokale Änderungen gehen verloren",
"When reloading the data from the source, all local changes will be lost" => "Wenn die Daten von der Quelle neu eingelesen werden, gehen alle lokalen Änderungen verloren",
"New items that must be preserved should be pushed using the above controls" => "Neue Einträge, die erhalten bleiben sollen, sollten mit der obigen Steuerung geschoben werden",
"Modifications that must be preserved should be replicated" => "Veränderungen, die erhalten bleiben sollen, sollten kopiert werden",
"Without conflicts: Using the above controls" => "Ohne Konflikte: Benutze die obigen Steuerelemente",
"With conflicts: Manually on the source" => "Mit Konflikten: Manuell an der Quelle",
"Using the above controls will cause information loss" => "Benutzung der obigen Steuerelemente wird zum Verlust von Informationen führen",
"Reload data from source" => "Daten erneut von Quelle laden",
// "Tracker item actions" => "Tracker item actions",
"Move to another tracker" => "Verschiebe in einen anderen Tracker",
// "Save Returning to Item List" => "Save Returning to Item List",
// "Save and Comment" => "Save and Comment",
"Special Operations" => "Spezielle Operation",
"close" => "schließ",
"Open Tiki WebDAV (Wiki pages) as WebFolder" => "Öffne Tiki WebDAV (Wiki Seiten) als WebOrdner",
"Open Tiki WebDAV as WebFolder" => "Öffne Tiki WebDAV als WebOrdner",
"Parent page" => "Übergeordnete Seite",
// "Manage Stucture" => "Manage Stucture",
"Child" => "neue Unterseite",
"page id" => "Seiten-ID",
// "Please wait" => "Please wait",
// " The PDF is being prepared, please wait.." => " The PDF is being prepared, please wait..",
// "Show structure" => "Show structure",
// "Hide structure bar and any toc" => "Hide structure bar and any toc",
"Hide structure" => "Verstecke Struktur",
// "Page actions" => "Page actions",
// " PDF" => " PDF",
// "Warning:mPDF Package Missing" => "Warning:mPDF Package Missing",
// "Click to toggle on/off" => "Click to toggle on/off",
// "Edit icons" => "Edit icons",
"Wysiwyg" => "Wysiwyg",
// "Send link" => "Send link",
// "Monitor page" => "Monitor page",
// "Stop monitoring page" => "Stop monitoring page",
// "Monitor sub-structure" => "Monitor sub-structure",
// "Stop monitoring sub-structure" => "Stop monitoring sub-structure",
// "Group monitor structure" => "Group monitor structure",
// "Profiles Wizard" => "Profiles Wizard",
// "Changes Wizard" => "Changes Wizard",
// "Configuration Wizard" => "Configuration Wizard",
// "steps" => "steps",
// "User Wizard" => "User Wizard",
// "Wizard Steps" => "Wizard Steps",
// "Change Theme" => "Change Theme",
// "Change Transition" => "Change Transition",
// "Convex" => "Convex",
// "Concave" => "Concave",
// " Handouts" => " Handouts",
// "Exit Slideshow" => "Exit Slideshow",
"More types available" => "Weitere Typen verfügbar",
// "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>",
"Description contains wiki syntax" => "Beschreibung enthält Wiki Syntax",
"Restrict visibility to administrators" => "Beschränkt Sichtbarkeit auf Administratoren",
"Useful if you are working on a live tracker" => "Hilfreich, wenn Du an einem Live-Tracker arbeitest",
"Add Field &amp; Edit Advanced Options" => "Füge Feld hinzu &amp; Bearbeite Erweiterte Optionen",
// "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)" => "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)",
// "Clear All" => "Clear All",
"Options for %0" => "Optionen für %0",
"Separate multiple with commas" => "Multiple mit Kommata trennen",
// "Separate multiple with &quot;{\$def.separator}&quot" => "Separate multiple with &quot;{\$def.separator}&quot",
"Error Message" => "Fehlermeldung",
"Visible by all" => "Für alle sichtbar",
// "Visible by all but not in RSS feeds" => "Visible by all but not in RSS feeds",
// "Visible after creation by administrators only" => "Visible after creation by administrators only",
"Editable by administrators only" => "Nur für Administratoren bearbeitbar",
// "Editable after creation by administrators only" => "Editable after creation by administrators only",
"Editable by administrators and creator only" => "Nur für Administratoren und Ersteller bearbeitbar",
// "Immutable after creation" => "Immutable after creation",
"Creator requires a user field with auto-assign to creator (1)" => "Ersteller erfordert ein Benutzerfeld mit automatischer Zuweisung zum Ersteller (1)",
"Visible by" => "Sichtbar für",
// "List of Group names with permission to see this field" => "List of Group names with permission to see this field",
// "Separated by comma (,)" => "Separated by comma (,)",
"Editable by" => "Bearbeitbar durch",
// "List of Group names with permission to edit this field" => "List of Group names with permission to edit this field",
"Changing the permanent name may have consequences in integrated systems" => "Die Änderung des permanenten Namens kann bei integrierten System zu Konsequenzen führen",
// "Changing the field type may cause irretrievable data loss - use with caution" => "Changing the field type may cause irretrievable data loss - use with caution",
// "Make sure you rebuild the search index if you change field type" => "Make sure you rebuild the search index if you change field type",
// "Deprecated" => "Deprecated",
// "To export tracker or tracker items please" => "To export tracker or tracker items please",
// "enable" => "enable",
// "and use" => "and use",
// "Tracker Tabular" => "Tracker Tabular",
// "It is easy to use, optimised and far more powerful" => "It is easy to use, optimised and far more powerful",
"Export Tracker Items" => "Exportiere Trackerobjekte",
"ISO-8859-1 Latin" => "ISO-8859-1 Latin",
"Delimitor (left)" => "Begrenzer (links)",
"Delimitor (right)" => "Begrenzer (rechts)",
"Carriage return inside field value" => "Zeilenumbruch innerhalb eines Feldwertes",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
"Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Exportiere Objektlink-Typ-Felder als Objekt-ID des verlinkten Objekts (Um Importieren zu erleichtern)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
"Parse as wiki text" => "Parse als Wiki-Text",
"Generic information" => "Allgemeine Information",
"Number of records" => "Anzahl von Aufzeichnungen",
"First record" => "Erste Aufzeichnung",
"Quick Export" => "Schneller Export",
"Produce a CSV with basic formatting" => "Erstelle eine CSV-Datei mit Basisformatierung",
// "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'" => "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'",
"Tracker Export" => "Tracker Export",
// "Copy the definition text above and paste into the Import Structure box for a new tracker" => "Copy the definition text above and paste into the Import Structure box for a new tracker",
"Profile Export" => "Profilexport",
"Produce YAML for a profile" => "Erstelle YAML für ein Profil",
"Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Verknüpfter Tracker und Feld-IDs (so wie die in ItemLink, ItemsList field options verwiesenen) werden gegenwärtig nicht zu Profilobjektreferenzen konvertiert. Sie müssen manuell ersetzt werden",
"For example: \$profileobject:field_ref\$" => "Zum Beispiel: \$profileobject:field_ref\$",
"Export Profile" => "Profil exportieren",
"Fields Export" => "Exportieren",
// "Copy the definition text above and paste into the Import Fields box on a tracker's fields page" => "Copy the definition text above and paste into the Import Fields box on a tracker's fields page",
"YAML Export" => "YAML exportieren",
"Profile for trackerId %0" => "Profil für Tracker-ID %0",
"Raw data" => "Rohdaten",
"Preserve tracker ID" => "Behalte Tracker-ID bei",
// "Use \"Tracker -> Export -> Structure\" to produce this data" => "Use \"Tracker -> Export -> Structure\" to produce this data",
// "Tracker import completed" => "Tracker import completed",
"Return to Trackers" => "Zurück zu Trackern",
"Import fields for this tracker" => "Importiere Felder für diesen Tracker",
"Raw Fields" => "Unbearbeitete Felder (raw)",
"Preserve Field IDs" => "Bewahre Feld-IDs",
"Confirmation" => "Bestätigung",
"Imported file '%0'" => "Importierte Datei '%0'",
"Import completed with '%0'" => "Import beendet mit '%0'",
// "To import items into a tracker please" => "To import items into a tracker please",
"The order of the fields does not matter, but you need to add a header with the field names" => "Die Reihenfolge der Feder spielt keine Rolle. Du musst aber eine Kopfzeile mit den Feldnamen hinzufügen",
// "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import" => "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import",
"Auto-incremented itemid fields shall be included with no matter what values" => "Automatisch zunehmende ID-Felder sollten eingeschlossen werden - die Werte sind unerheblich",
// "If you are having problems, try a different line ending for your csv file that matches the server operating system" => "If you are having problems, try a different line ending for your csv file that matches the server operating system",
"UNIX Timestamp" => "UNIX Zeitstempel",
"Character encoding" => "Zeichensatz",
"Create as new items" => "Erstelle als neue Einträge",
"Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Aktualisiere Datum der letzten Veränderung wenn Einträge aktualisiert werden (Status und Erstellung werden nur aktualisiert, wenn die Felder im csv angegeben sind)",
// "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance" => "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance",
// "Please note: This is an experimental new feature - work in progress" => "Please note: This is an experimental new feature - work in progress",
// "YAML" => "YAML",
// "Create another" => "Create another",
"Do you really want to remove the \"%0\" tracker" => "Möchtest Du wirklich den Tracker %0 Tracker entfernen",
// "Please note" => "Please note",
// "This tracker, its fields and all of its %0 items will be permanently removed from your system" => "This tracker, its fields and all of its %0 items will be permanently removed from your system",
"Are you sure you want to remove the fields? Data will be lost" => "Bist Du sicher, dass Du die Felder entfernen willst? Die Daten gehen verloren",
"Remove Fields" => "Entferne Felder",
"Return to field administration" => "Zurückkehren zur Feldverwaltung",
// "Replacement" => "Replacement",
// "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one" => "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one",
"Description is wiki-parsed" => "Beschreibung wird wiki-geparst",
// "Field Prefix" => "Field Prefix",
"Allow ratings (deprecated, use rating field)" => "Erlaube Bewertung (veraltet. Benutze Bewertungsfeld)",
"Rating options" => "Bewertungsoptionen",
"Show ratings in listing" => "Zeige Bewertung in Auflistung",
"Show comments in listing" => "Zeige Kommentare in Auflistung",
"Display last comment author and date" => "Zeige Autor und Datum des letzten Kommentars",
// "Allow attachments (deprecated, use files field)" => "Allow attachments (deprecated, use files field)",
"Display attachments in listing" => "Zeige Anhänge in Auflistung",
"Attachment attributes (sortable)" => "Anhangeigenschaften (sortierbar)",
// "Recommended size: 64x64px" => "Recommended size: 64x64px",
"Show status to tracker administrator only" => "Zeige Status nur für Tracker-Administrator",
"Show creation date when listing items" => "Zeige Erstellungsdatum, wenn Einträge aufgelistet werden",
"Creation date format" => "Format des Erstellungsdatums",
"Show item creator" => "Zeige Ersteller des Eintrages",
"Show creation date when viewing items" => "Zeige Erstellungsdatum, wenn ein Eintrag angezeigt wird",
"Show last modification date when listing items" => "Zeige Datum der letzten Änderung, wenn ein Eintrag angezeigt wird",
"Show item last modifier" => "Zeige den Veränderer, der Eintrag zuletzt geändert hat",
"Modification date format" => "Format des Veränderungsdatums",
"Show last modification date when viewing items" => "Zeige Veränderungsdatum, wenn ein Eintrag angezeigt wird",
"Hide empty fields from item view" => "Verstecke leer Felder in der Anzeige",
"List detail popup" => "Popup Listendetail",
// "Section Format" => "Section Format",
// "Section format" => "Section format",
// "Determines how headers will be rendered when using header fields as form section dividers" => "Determines how headers will be rendered when using header fields as form section dividers",
// "Set to <em>Configured</em> to use the four following fields" => "Set to <em>Configured</em> to use the four following fields",
// "Use Form Classes" => "Use Form Classes",
// "Input Form Classes" => "Input Form Classes",
// "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)" => "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)",
"Template to display an item" => "Vorlage, um einen Eintrag anzuzeigen",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "Wiki: Seitenname für eine Wikiseite tpl: tpl-Name für eine Vorlage",
"Template to edit an item" => "Vorlage, um einen Eintrag zu bearbeiten",
"New item status" => "Status für neuen Eintrag",
"Modified item status" => "Status für veränderten Eintrag",
"No change" => "Keine Änderung",
"Default status displayed in list mode" => "Status, die in der Listenanzeige ausgegeben werden sollen",
"Copy activity to email" => "Benachrichtige über Aktivitäten per E-Mail",
"Use simplified email format" => "Vereinfachtes E-Mailformat benutzen",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "Der Tracker benutzt das mit \"subject\" bezeichnete Feld für den E-Mailbetreff und die E-Mailadresse des Benutzers. Bei anonymen Benutzern, das Feld \"email\" (wenn vorhanden) als Absender",
"Publish RSS feed for this tracker" => "Veröffentliche RSS Feed für diesen Tracker",
"Requires \"RSS per tracker\" to be set in Admin/RSS" => "Erfordert, dass \"RSS pro Tracker\" unter Verwalten/RSS eingestellt wird",
"(Currently set)" => "(Gegenwärtig eingestellt)",
"(Currently not set)" => "(Gegenwärtig nicht eingestellt)",
"Group alerted on item modification" => "Gruppenbenachrichtigung bei Veränderung eines Eintrages",
"Allow user selection for small groups" => "Erlaube Benutzerauswahl für kleine Gruppen",
// "User can see his own items" => "User can see his own items",
// "The tracker needs a user field with the item-owner activated" => "The tracker needs a user field with the item-owner activated",
// "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user" => "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user",
"Item creator can modify his items" => "Eintragersteller kann seinen Eintrag verändern",
"The tracker needs a user field with the auto-assign activated" => "Der Tracker benötigt ein Benutzerfeld mit aktivierter automatischer Zuweisung",
// "Item creator can remove his items" => "Item creator can remove his items",
"User can take ownership of item created by anonymous" => "Benutzer kann Objekt-Besitz von 'Anonymous' übernehmen",
"Only one item per user or IP" => "Nur ein Eintrag pro Benutzer oder IP-Adresse",
// "The tracker needs a user or IP address field with the auto-assign set to Creator" => "The tracker needs a user or IP address field with the auto-assign set to Creator",
"Members of the creator group can modify items" => "Mitglieder der Erstellergruppe können Einträge verändern",
"The tracker needs a group field with the auto-assign activated" => "Der Tracker benötigt ein Gruppenfeld mit aktivierter automatischer Zuweisung",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Restrict non admins to wiki page access only" => "Restrict non admins to wiki page access only",
// "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports" => "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports",
"Creation date constraint" => "Beschränkung Erstellungsdatum",
// "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below" => "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below",
"Before" => "Davor",
"Auto-create corresponding categories" => "Automatisch entsprechende Kategorien erstellen",
"Create a group for each item" => "Erstelle eine Gruppe für jeden Eintrag",
"Groups will include" => "Gruppen werden beeinhalten",
"Creator is assigned to the group" => "Ersteller wird zugewiesen zur Gruppe",
"Will become the creator's default group" => "Wird die Standardgruppe des Erstellers",
"Will become the new item's group creator" => "Wird der Ersteller der Gruppe für neue Einträge",
"Copy the default group in the field ID before updating the group" => "Kopiere die Standardgruppe in die Feld-ID vor der Aktualisierung der Gruppe",
"Non Advanced Search or Natural Search" => "Nicht erweiterte Suche oder natürliche Suche",
"Advanced Search or Boolean Search" => "Erweiterte oder Boolesche Suche",
"Objects that contain the more terms are rated higher in the results and will appear first in their type." => "Objekte die mehrere Begriffe (oder diese mehrfach) enthalten, werden in der Ergebnisliste höher bewertet und erscheinen in deren Typen zuerst.",
"objects that include both terms" => "Objekte, die beide Ausdrücke enthalten",
"Requiring terms" => "Zwingende Begriffe",
"Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results." => "Füge ein Pluszeichen ( + ) vor einem Begriff ein, um anzuzeigen, dass der Begriff im Suchergebnis enthalten sein <em>muss</em>.",
"Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first." => "Beispiel: <strong>+Wiki Forum</strong> findet Objekte, die mindestens <strong>Wiki</strong> enthalten. Objekte, die beide Begriffe und ggf. diese auch mehrfach enthalten, werden zuerst erscheinen.",
"Excluding terms" => "Begriffe ausschließen",
"Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results." => "Füge ein Minuszeichen ( - ) vor einen Suchbegriff ein, damit der Suchbegriff <em>nicht</em> in den gefundenen Ergebnissen enthalten ist.",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>",
"Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Beispiel: <strong>-Wiki Forum</strong> wird Objekte finden, die nicht <strong>Wiki</strong> aber <strong>Forum</strong> enthalten",
"Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order." => "Beispiel: <strong>+Wiki +(Forum Blog)</strong> findet Objekte, die <strong>Wiki</strong> und <strong>Forum</strong> enthalten oder Objekte, die <strong>Wiki</strong> und <strong>Blog</strong> in irgendeiner Reihenfolge enthalten.",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed." => "Benutze Anführungszeichen ( <kbd>\" \"</kbd> ), um einen Ausdruck exakt so zu suchen, wie er eingegeben wurde.",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Beispiel: <kbd>\"Alex Bell\"</kbd> findet nicht <strong>Bell Alex</strong> oder <strong>Alex G. Bell</strong>.",
"Using wildcards" => "Platzhalter benutzen",
"Add an asterisk ( * ) after a term to find objects that include the root word." => "Füge einen Stern ( * ) nach einem Begriff ein, um Objekte zu finden, die den Wortteil vor dem Stern enthalten",
"For example, <strong>run*</strong> will find:" => "Zum Beispiel findet der Begriff, <strong>run*</strong>:",
"objects that include the term <strong>run</strong>" => "Objekte, die den Begriff <strong>run</strong> enthalten",
"objects that include the term <strong>runner</strong>" => "Objekte, die den Begriff <strong>runner</strong> enthalten",
"objects that include the term <strong>running</strong>" => "Objekte, die den Begriff <strong>running</strong> enthalten",
"Reducing a term's value" => "Die Bedeutung eines Suchbegriffs reduzieren",
"Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Füge einen Tilde ( ~ ) vor einem Begriff ein, um seinen Wert in der Rangfolge der Ergebnisse zu reduzieren",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)",
"Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>." => "Beispiel: <strong>+Wiki ~Forum</strong> bewertet ein Objekt höher, wenn es nur den Begriff <strong>Wiki</strong> enthält, als wenn sowohl die Begriffe <strong>Wiki</strong> als auch <strong>Forum</strong> enthalten sind.",
"Changing relevance value" => "Änderung des Relevanzwertes",
"Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object." => "Füge ein kleiner-als- ( < ) oder größer-als- ( > ) Zeichen vor einen Begriff ein, um den Beitrag des Suchbegriffs zur Gesamtrelevanz eines Objektes zu ändern.",
"Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher." => "Beispiel: <strong>+Wiki +(>Forum < Blog)</strong> findet Objekte, die <strong>Wiki</strong> und <strong>Forum</strong> oder <strong>Wiki</strong> und <strong>Blog</strong> in irgendeiner Reihenfolge enthalten. <strong>Wiki Forum</strong> wird höher bewertet.",
// "{\$confirmation_message}" => "{\$confirmation_message}",
// "\"}Are you sure you want to set this %0 to \"open\"" => "\"}Are you sure you want to set this %0 to \"open\"",
// "\"}Are you sure you want to set this %0 to \"pending\"" => "\"}Are you sure you want to set this %0 to \"pending\"",
// "\"}Are you sure you want to set this %0 to \"closed\"" => "\"}Are you sure you want to set this %0 to \"closed\"",
// "{\$field.name|truncate:65|escape}" => "{\$field.name|truncate:65|escape}",
"Hold \"Ctrl\" in order to select multiple values" => "Halte \"Ctrl/Strg\", um mehrere Werte auszuwählen",
// "{\$field_name}" => "{\$field_name}",
// "{\$description}" => "{\$description}",
"{\$sc.label|escape}" => "{\$sc.label|escape}",
"Admin Fields" => "Felder verwalten",
"It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "Es ist sehr wahrscheinlich, dass die Remote Site eine Authentifizierung erfordert, bevor auf die Daten zugegiffen werden kann. Konfiguriere die Authentifizierung unter DSN verwalten",
"Search for trackers to clone" => "Suche nach Trackern zum Klonen",
"After" => "Danach",
"Do you really want to remove the scheduled event" => "Möchtest Du wirklich das geplante Ereignis löschen",
// "Remove event" => "Remove event",
"No events registered" => "Keine Ereignisse eingetragen",
"Reference date" => "Referenzdatum",
"After creation" => "nach Erstellung",
"After last modification" => "nach letzter Änderung",
"Delay prior to status change" => "Verzögerung vor Statusänderung",
"Mail subject text" => "E-Mail-Betreff ",
"Mail body ressource" => "E-Mail-Text ",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "Wiki: Seitenname für eine Wikiseite oder tpl-Name.tpl für eine Vorlage",
// "Existing Article" => "Existing Article",
// "Article URL" => "Article URL",
"(automatically generated after item creation)" => "(automatisch erstellt nach Eintragerstellung)",
// "Change Event" => "Change Event",
"Attached files limitation" => "Dateianhang-Beschänkung",
// "The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved" => "The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved",
// "Browse files" => "Browse files",
// "Browse Files" => "Browse Files",
// "Link to existing Vimeo URL" => "Link to existing Vimeo URL",
// "Type or paste the URL and press ENTER" => "Type or paste the URL and press ENTER",
// "You do not have permission to upload files to this gallery" => "You do not have permission to upload files to this gallery",
// "You do not have permission to add a member to a group" => "You do not have permission to add a member to a group",
"Select Icon" => "Wähle Symbol",
// "Remove image" => "Remove image",
"Are you sure you want to delete this image" => "Bist Du sicher, dass Du dieses Bild löschen willst",
// "{\$field.options_map.addItems|escape}" => "{\$field.options_map.addItems|escape}",
"Add Media" => "Medium beifügen",
"Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19" => "Format: x,y,zoom wobei x für den Längengrad und y für den Breitengrad steht. Zoom liegt zwischen 0 (gesamte Erde) und 19",
// "This bug has been demonstrated on {\$field.options_map.domain|escape}" => "This bug has been demonstrated on {\$field.options_map.domain|escape}",
// "Please demonstrate your bug on {\$field.options_map.domain|escape}" => "Please demonstrate your bug on {\$field.options_map.domain|escape}",
// "Bug needs to be created first" => "Bug needs to be created first",
// "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created" => "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created",
// "Show.tiki.org snapshot creation is in progress" => "Show.tiki.org snapshot creation is in progress",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"",
// "Password reset" => "Password reset",
// "Password reset was successful" => "Password reset was successful",
// "Password reset failed" => "Password reset failed",
// "Show.tiki.org instance destruction in progress" => "Show.tiki.org instance destruction in progress",
// "Show.tiki.org instance destruction is in progress... Please wait.." => "Show.tiki.org instance destruction is in progress... Please wait..",
// "Show.tiki.org is not configured properly" => "Show.tiki.org is not configured properly",
// "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks" => "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks",
// "Show.tiki.org is currently unavailable" => "Show.tiki.org is currently unavailable",
// "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Show.tiki.org is under maintenance" => "Show.tiki.org is under maintenance",
// "Show.tiki.org is currently under maintenance. Sorry for the inconvenience" => "Show.tiki.org is currently under maintenance. Sorry for the inconvenience",
// "Unable to get information from {\$field.options_map.domain|escape}" => "Unable to get information from {\$field.options_map.domain|escape}",
// "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Instance is being created" => "Instance is being created",
// "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks" => "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks",
// "About {\$field.options_map.domain|escape}" => "About {\$field.options_map.domain|escape}",
// "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}" => "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}",
// "Create {\$field.options_map.domain|escape} instance" => "Create {\$field.options_map.domain|escape} instance",
// "Accessing the Tiki instance that demonstrates this bug" => "Accessing the Tiki instance that demonstrates this bug",
// "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0" => "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"",
// "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0" => "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0",
// "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload" => "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload",
// "Snapshots" => "Snapshots",
// "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation" => "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0",
// "Create new snapshot" => "Create new snapshot",
// "Destroy this {\$field.options_map.domain|escape} instance" => "Destroy this {\$field.options_map.domain|escape} instance",
// "Reset password to 12345" => "Reset password to 12345",
// "SVN update" => "SVN update",
// "Debug Mode Information" => "Debug Mode Information",
// "Get instance information and refresh cache" => "Get instance information and refresh cache",
// "Filter by group" => "Filter by group",
// "Select user(s)" => "Select user(s)",
// "View stand alone wiki page" => "View stand alone wiki page",
// "Source of wiki page" => "Source of wiki page",
// "History of wiki page" => "History of wiki page",
// "No articles" => "No articles",
"Administrator intervention required" => "Administratoreingriff erforderlich",
// "Tags is not enabled" => "Tags is not enabled",
"LastModif" => "Zul.Veränd.",
"You did not vote yet" => "Du hast noch nicht abgestimmt",
"My rating" => "Meine Bewertung",
"{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "Klicke, um für diesen Wert abzustimmen",
// "Remove your rating" => "Remove your rating",
"%0 element(s)" => "%0 Element(e)",
"Language: %0" => "Sprache: %0",
// "You have subscribed" => "You have subscribed",
"You have not yet subscribed" => "Du hast noch nicht abonniert",
"with" => "weite",
"friends" => "Freunde",
// "Translation.." => "Translation..",
// "No language assigned" => "No language assigned",
// "Set page language" => "Set page language",
// "Set article language" => "Set article language",
"Current language" => "Gegenwärtige Sprache",
"Show all translations of this page on a single page" => "Zeige alle Übersetzungen dieser Seite auf einer einzelnen Seite",
"All languages" => "Alle Sprachen",
"Machine translations" => "Maschinenübersetzung",
"Translate page" => "Übersetze Seite",
"Manage page translations" => "Verwalte Seitenübersetzungen",
"Translate article" => "Übersetze Artikel",
"Manage article translations" => "Verwalte Artikelübersetzungen",
"Are you sure you want to detach these translations" => "Bist Du sicher, dass Du diese Übersetzungen abtrennen willst",
"Current translation set" => "Gegenwärtiger Satz an Übersetzungen",
// "Detach translation" => "Detach translation",
"Are you sure you want to detach the translation" => "Bist Du sicher, dass Du diese Übersetzung abtrennen willst",
"No translations available at this time" => "Zur Zeit sind keine Übersetzungen verfügbar",
"Add a new object to the set" => "Füge ein neues Objekt zu diesem Satz hinzu",
"All possible translations exist" => "Alle möglichen Übersetzungen existieren bereits",
// "Email this wiki page" => "Email this wiki page",
// "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki" => "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki",
// "Bcc" => "Bcc",
// "Enter a valid email to send a blind copy to (optional)" => "Enter a valid email to send a blind copy to (optional)",
// "%0 away" => "%0 away",
// "Shared groups" => "Shared groups",
// "Friendship" => "Friendship",
// "Add to or remove from" => "Add to or remove from",
// "Add to" => "Add to",
// "Remove from" => "Remove from",
// "These groups" => "These groups",
// "Use Ctrl+Click or Command+Click to select multiple options" => "Use Ctrl+Click or Command+Click to select multiple options",
// "Set default group" => "Set default group",
// "Remove users" => "Remove users",
// "Remove the users' pages" => "Remove the users' pages",
// "Remove the user pages belonging to these users" => "Remove the user pages belonging to these users",
// "Delete user items from these trackers" => "Delete user items from these trackers",
// "Warning: Experimental" => "Warning: Experimental",
// "Select trackers here to have items in them which are \"owned\" by these users deleted" => "Select trackers here to have items in them which are \"owned\" by these users deleted",
// "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically" => "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically",
// "Delete user files" => "Delete user files",
// "Delete the users' file galleries and all the files in them" => "Delete the users' file galleries and all the files in them",
// "Ban users" => "Ban users",
// "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning" => "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning",
// "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided" => "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided",
// "Cancel login process" => "Cancel login process",
// "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login" => "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login",
// "Birth date" => "Birth date",
// "Validate your age and proceed to login" => "Validate your age and proceed to login",
// "I approve the above terms and conditions" => "I approve the above terms and conditions",
// "I Decline, log out" => "I Decline, log out",
"However, no account is associated to the OpenID identifier" => "Allerdings ist kein Konto mit dem OpenID-Kennung verknüpft",
"If you use an email filter, be sure to add %0 to your accepted list" => "Wenn Du einen E-Mail Filter benutzt, dann stelle sicher, dass Du E-Mails von %0 empfangen kannst",
"Associate OpenID with an existing Tiki account" => "Verbinde OpenID mit einem bestehenden Tiki Konto",
// "Browse for video file to upload" => "Browse for video file to upload",
// "Upload Progress" => "Upload Progress",
// "Vimeo Setup Error" => "Vimeo Setup Error",
// "{\$errMsg}" => "{\$errMsg}",
// "Available space: %0 megabytes" => "Available space: %0 megabytes",
// "No standard definition uploads available currently" => "No standard definition uploads available currently",
// "No high definition uploads available currently" => "No high definition uploads available currently",
// "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines" => "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines",
// "You will also need to rebuild your caches and search index" => "You will also need to rebuild your caches and search index",
// "Re-generate URLs" => "Re-generate URLs",
// "The following item(s) include page(s) being deleted and will break" => "The following item(s) include page(s) being deleted and will break",
// "Remove {\$idesc}" => "Remove {\$idesc}",
// "Create redirect" => "Create redirect",
// "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)" => "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)",
// "Redirect to" => "Redirect to",
"Use this thread to discuss the page" => "Benutze diesen Thread, um die Seite zu diskutieren",
"Missing or incorrect trackerId parameter for the plugin" => "Fehlende oder ungültige TrackerId Parameter für dieses Plugin",
"List Trackers" => "Tracker auflisten",
// "resource day" => "resource day",
// "resource month" => "resource month",
// "resource year" => "resource year",
// "resource week" => "resource week",
// "list day" => "list day",
// "list month" => "list month",
// "list year" => "list year",
// "list week" => "list week",
"list" => "Liste",
// "agenda month" => "agenda month",
// "agenda week" => "agenda week",
// "agenda day" => "agenda day",
// "{\$params.label|escape}" => "{\$params.label|escape}",
"Subtract" => "Abziehen",
"Meeting ID" => "Meeting ID",
"Current attendees" => "Gegenwärtige Teilnehmer",
"No attendees at this time" => "Gegenwärtig keine Teilnehmer",
"Last time we checked, the room you requested did not exist" => "Bei der letzten Überprüfung wurde der von Dir angeforderte Raum nicht gefunden",
"Current recordings" => "Gegenwärtige Aufzeichnungen",
"On %0 from %1 to %2" => "Am %0 von %1 bis %2",
// "This will permanently remove the recording" => "This will permanently remove the recording",
"(including audio recording & chat log)" => "(mit Audio-Aufzeichnung und chat-Protocol)",
"{\$button_label}" => "{\$button_label}",
// "{\$moretext|escape}" => "{\$moretext|escape}",
"{\$ftptitle}" => "{\$ftptitle}",
// "No permission to change the following task" => "No permission to change the following task",
// "Project update not possible as you lack rights for updating a parent project" => "Project update not possible as you lack rights for updating a parent project",
// "Start date is a milestone" => "Start date is a milestone",
// "End date is a milestone" => "End date is a milestone",
// "Task has constraints" => "Task has constraints",
// "Error: there is a dependency on an open task" => "Error: there is a dependency on an open task",
// "Error: due to a descendant of a closed task" => "Error: due to a descendant of a closed task",
// "This task has external dependencies" => "This task has external dependencies",
// "GANNT_ERROR_LOADING_DATA_TASK_REMOVED" => "GANNT_ERROR_LOADING_DATA_TASK_REMOVED",
// "Cannot depend on ancestors" => "Cannot depend on ancestors",
// "The data inserted are invalid for the field format" => "The data inserted are invalid for the field format",
// "An error has occurred while loading the data. A task has been trashed" => "An error has occurred while loading the data. A task has been trashed",
// "Cannot close a task with open issues" => "Cannot close a task with open issues",
// "You cannot exchange tasks of different depth" => "You cannot exchange tasks of different depth",
// "Sem" => "Sem",
// "Cannot move task" => "Cannot move task",
// "Please save your project" => "Please save your project",
// "Error: date settings" => "Error: date settings",
// "Cannot depend on descendants" => "Cannot depend on descendants",
// "code/short name" => "code/short name",
// "start" => "start",
// "dur" => "dur",
// "depe" => "depe",
// "assignees" => "assignees",
// "completed" => "completed",
// "suspended" => "suspended",
// "undefined" => "undefined",
// "Task editor" => "Task editor",
// "is milestone" => "is milestone",
// "status" => "status",
// "progress" => "progress",
// "Assignments" => "Assignments",
// "Role" => "Role",
// "est.wklg" => "est.wklg",
"Number of Users" => "Anzahl Benutzer",
"Percentage of Total" => "Prozentsatz",
// "Email address of invitee" => "Email address of invitee",
"Set in these groups" => "In diesen Gruppen",
// "Number of result" => "Number of result",
"Message sent to" => "Nachricht gesandt an",
"Email sent to" => "E-Mail senden an",
// "recipients" => "recipients",
// "Message preview" => "Message preview",
// "Number of Recipients" => "Number of Recipients",
"Send Mail" => "Sende E-Mail",
"Send to users" => "Sende an Benutzer",
"Send to" => "Sende an",
"Email address (if more than one, separated by \",\")" => "E-Mail getrennt durch Komma",
"Send to groups" => "Sende an Gruppen",
"Preview Mail" => "E-Mailvorschau",
// "You will receive a copy of the email yourself. Please give it a few minutes" => "You will receive a copy of the email yourself. Please give it a few minutes",
// "Please wait while your email is being sent.." => "Please wait while your email is being sent..",
// "Previous npm-asset/pdfjs-dist package has been deprecated" => "Previous npm-asset/pdfjs-dist package has been deprecated",
// "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package" => "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package",
"Check to remove" => "Haken setzen zum Entfernen",
// "Contents of email to be sent to user" => "Contents of email to be sent to user",
// "Append custom message" => "Append custom message",
// "Approve user" => "Approve user",
// "Reject user" => "Reject user",
"Add in group" => "Füge in Gruppe bei",
// "Set as default group for users" => "Set as default group for users",
"Join myself" => "Füge mich hinzu",
"Leave myself" => "Entferne mich",
"Cost for one period" => "Kosten für einen Zeitabschnitt",
"Free for the rest of the current period, a prorated value of" => "Kostenlos für den Rest der gegenwärtigen Periode. Ein anteiliger Wert von",
"Prorated cost for first period" => "Anteiliger Betrag für die erste Periode",
"Special offer! Free additional periods" => "Spezielles Angebot! Freie zusätzliche Perioden",
// "Membership to %0 for %1 for %2 %3" => "Membership to %0 for %1 for %2 %3",
"separated by |" => "getrennt durch |",
"{\$periodslabel}" => "{\$periodslabel}",
// "vs" => "vs",
// "Mine" => "Mine",
// "Save Changes" => "Save Changes",
// "Edit Pivot Table" => "Edit Pivot Table",
// "Click to view interactive SCORM learning object" => "Click to view interactive SCORM learning object",
// "Download original file" => "Download original file",
"Re-Apply" => "Nochmals anwenden",
"wrote" => "schrieb",
// "{\$wp_emptymsg}" => "{\$wp_emptymsg}",
"{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
"Last Day" => "Letzter Tag",
"Last Week" => "Letzte Woche",
"{\$action}" => "{\$action}",
"Groups you are in" => "Gruppen in denen Du bist",
"(This is an included group)" => "(Das ist eine eingeschlossene Gruppe)",
"(You are a leader)" => "(Du bist ein Leiter)",
"Your default group" => "Deine Standardgruppe",
"Leave Group" => "Gruppe verlassen",
"Manage Group" => "Gruppe verwalten",
"Change default group" => "Ändere Standardgruppe",
"Subscribe to a group" => "Zu einer Gruppe beitreten",
"Groups you can join" => "Gruppen denen Du beitreten kannst",
"This group requires approval to join" => "Diese Gruppe erfordert eine Bestätigung, um beizutreten",
"Subscribe to groups" => "Gruppen beitreten",
"Subscription confirmed!" => "Abonnement bestätigt!",
"Subscribe to the newsletter" => "Newsletter abonnieren",
"Mini TimeSheet" => "Mini-Zeiterfassung",
"Full View" => "Volle Ansicht",
// "End tour" => "End tour",
// "-- Choose an option --" => "-- Choose an option --",
"{\$export_action}" => "{\$export_action}",
"Map View" => "Kartenansicht",
// "Field error" => "Field error",
"Stop Monitor" => "Nicht mehr beobachten",
"Tracker - " => "Tracker - ",
"{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
"Close item" => "Eintrag schließen",
"Open item" => "Eintrag öffnen",
"Pend item" => "Eintrag anstehend markieren",
"{\$params.label}" => "{\$params.label}",
"Please login first" => "Bitte zuerst anmelden",
"Toggle display" => "Anzeige umschalten",
// "Page approved by %0 on %1" => "Page approved by %0 on %1",
"Page last modified on %0 by %1" => "Seite zuletzt geändert: am %0 von <span class='link'><span class='link'>%1</span></span>",
"Created by %0" => "Erstellt von %0",
"Last Modification: %0 by %1" => "Letzte Änderung: %0 by %1",
"Save the page as a partial translation" => "Speichere die Seite als teilweise Übersetzung",
"Partial Translation" => "Teilweise Übersetzung",
"Save the page as a completed translation" => "Speichere die Seite als vollständige Übersetzung",
"Complete Translation" => "Vollständige Übersetzung",
"Save the page, but do not count it as new content to be translated" => "Speichere die Seite, aber markiere den Inhalt als nicht zur weiteren Übersetzung erforderlich",
"Save the page, but do not send notifications and do not count it as new content to be translated" => "Speichere die Seite, aber sende keine Benachrichtigungen und markiere den Inhalt als nicht zur weiteren Übersetzung erforderlich",
"Save Minor Edit" => "Änderung als geringfügig speichern",
"Save the page" => "Seite speichern",
// "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions" => "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions",
// "Workspaces UI in doc.tiki.org" => "Workspaces UI in doc.tiki.org",
// "Enable using the same wiki page name in different contexts" => "Enable using the same wiki page name in different contexts",
// "E.g. ns1:_:MyPage and ns2:_:MyPage" => "E.g. ns1:_:MyPage and ns2:_:MyPage",
// "Workspaces & Areas admin panel" => "Workspaces & Areas admin panel",
// "Automatic table of contents for a wiki page" => "Automatic table of contents for a wiki page",
// "Auto TOC options" => "Auto TOC options",
// "Auto TOC" => "Auto TOC",
// "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc" => "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc",
// "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu" => "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu",
// "Set up categories here" => "Set up categories here",
// "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages" => "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages",
// "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there" => "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there",
// "Configure general user & community features and settings related to sharing and social networks" => "Configure general user & community features and settings related to sharing and social networks",
// "Add a <b>User and Registration tracker</b>" => "Add a <b>User and Registration tracker</b>",
// "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users" => "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users",
// "Some uses of this type of tracker could be" => "Some uses of this type of tracker could be",
// "To collect user information (such as mailing address or phone number)" => "To collect user information (such as mailing address or phone number)",
// "To require the user to acknowledge a user agreement" => "To require the user to acknowledge a user agreement",
// "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)" => "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)",
// "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually" => "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually",
// "apply profile now" => "apply profile now",
// "new window" => "new window",
// "To set up the <strong>User Watches</strong> and their associated settings, visit the page to " => "To set up the <strong>User Watches</strong> and their associated settings, visit the page to ",
// "Community General Settings" => "Community General Settings",
// "admin panel" => "admin panel",
// "in doc.tiki.org" => "in doc.tiki.org",
// "Sharing & Networking" => "Sharing & Networking",
// "Social Network" => "Social Network",
// "Friendship and Followers" => "Friendship and Followers",
// "Set the site time zone and format for displaying dates and times" => "Set the site time zone and format for displaying dates and times",
// "Date and Time options" => "Date and Time options",
// "Date and Time admin panel" => "Date and Time admin panel",
// "Select editor type" => "Select editor type",
// "Only Plain Text Editor (Disable Wysiwyg)" => "Only Plain Text Editor (Disable Wysiwyg)",
// "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>" => "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>",
// "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page" => "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page",
// "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor" => "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor",
// "Set up the main Tiki features. The wiki and file gallery features are always enabled" => "Set up the main Tiki features. The wiki and file gallery features are always enabled",
// "Main Tiki features" => "Main Tiki features",
// "Tiki has many more features" => "Tiki has many more features",
// "Global Features" => "Global Features",
// "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made" => "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made",
// "Set up the file gallery and attachments" => "Set up the file gallery and attachments",
// "Choose to store them either in the database or in files on disk, among other options" => "Choose to store them either in the database or in files on disk, among other options",
// "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder" => "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder",
// "elFinder" => "elFinder",
// "Wiki admin panel" => "Wiki admin panel",
// "File storage" => "File storage",
// "Set elFinder as the default file gallery viewer" => "Set elFinder as the default file gallery viewer",
// "File Gallery storage" => "File Gallery storage",
// "Attachment storage" => "Attachment storage",
// "Select the site language" => "Select the site language",
// "Language options" => "Language options",
// "Configure the log-in, registration and validation preferences for the new accounts" => "Configure the log-in, registration and validation preferences for the new accounts",
// "Registration and log-in options" => "Registration and log-in options",
// "Login admin panel" => "Login admin panel",
// "Configure the Tiki theme and other look & feel preferences" => "Configure the Tiki theme and other look & feel preferences",
// "Look & Feel options" => "Look & Feel options",
// "Look & Feel admin panel" => "Look & Feel admin panel",
// "Namespace settings" => "Namespace settings",
// "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>" => "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>",
// "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)" => "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)",
// "Basic Search" => "Basic Search",
// "Uses MySQL full-text search" => "Uses MySQL full-text search",
// "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below" => "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below",
"Advanced Search" => "Fortgeschrittene Suche",
// "Uses Unified Search Index with a specified search engine" => "Uses Unified Search Index with a specified search engine",
// "If you have issues with Advanced Search, simply revert to Basic Search" => "If you have issues with Advanced Search, simply revert to Basic Search",
// "Unified Search is required by a number of other features, e.g. the community friendship network" => "Unified Search is required by a number of other features, e.g. the community friendship network",
// "Other settings" => "Other settings",
"Also see the Search Indexing tab here" => "Siehe auch Indexierung-Tab",
// "Search admin card" => "Search admin card",
// "Search in doc.tiki.org" => "Search in doc.tiki.org",
// "Hierarchical organization of wiki pages" => "Hierarchical organization of wiki pages",
// "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage" => "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage",
// "Structures options" => "Structures options",
// "Set up the text area environment (Editing and Plugins)" => "Set up the text area environment (Editing and Plugins)",
// "Editing and plugins admin panel" => "Editing and plugins admin panel",
// "Set up the Wiki environment" => "Set up the Wiki environment",
// "Wiki environment" => "Wiki environment",
// "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar" => "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar",
// "Requires Java" => "Requires Java",
// "Verify your Java installation" => "Verify your Java installation",
// "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages" => "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages",
// "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>" => "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>",
// "Get Started" => "Get Started",
// "Congratulations! You now have a working instance of Tiki %0" => "Congratulations! You now have a working instance of Tiki %0",
// "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below" => "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below",
// "Mouse over the icons to know more about the features and preferences that are new for you" => "Mouse over the icons to know more about the features and preferences that are new for you",
"Example: " => "Beispiel: ",
// "Help icon" => "Help icon",
// "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it" => "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it",
// "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic" => "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic",
// "Configuration Profiles Wizard" => "Configuration Profiles Wizard",
// "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>" => "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>",
// "They are like the <b>Macros</b> from many computer languages" => "They are like the <b>Macros</b> from many computer languages",
// "It is best to apply them from the start and you can always preview and reverse the process" => "It is best to apply them from the start and you can always preview and reverse the process",
// "Configuration Profiles" => "Configuration Profiles",
// "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you" => "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you",
// "If you are new to Tiki administration, we recommend that you start with this approach" => "If you are new to Tiki administration, we recommend that you start with this approach",
// "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below" => "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below",
// "Start Configuration Profiles Wizard (Macros)" => "Start Configuration Profiles Wizard (Macros)",
// "Configuration Walkthrough" => "Configuration Walkthrough",
// "Alternatively, you may use the <b>Configuration Wizard</b>" => "Alternatively, you may use the <b>Configuration Wizard</b>",
// "This will guide you through the most common preference settings in order to customize your site" => "This will guide you through the most common preference settings in order to customize your site",
// "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc" => "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc",
// "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further" => "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further",
// "Start Configuration Wizard" => "Start Configuration Wizard",
// "Or you may use the <b>Changes Wizard</b>" => "Or you may use the <b>Changes Wizard</b>",
// "This will guide you through the most common new settings and informations in order to upgrade your site" => "This will guide you through the most common new settings and informations in order to upgrade your site",
// "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version" => "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version",
// "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels" => "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels",
// "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site" => "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site",
// "Start Changes Wizard" => "Start Changes Wizard",
// "Use the <b>Control Panels</b> to manually browse through the full list of preferences" => "Use the <b>Control Panels</b> to manually browse through the full list of preferences",
// "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings" => "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings",
// "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with" => "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with",
// "Explore the control panels and configure your Tiki manually" => "Explore the control panels and configure your Tiki manually",
// "Go to the Control Panels" => "Go to the Control Panels",
// "You can check if your server meets the requirements for running Tiki version %0" => "You can check if your server meets the requirements for running Tiki version %0",
// "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly" => "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly",
// "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback" => "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback",
// "Check your server fitness" => "Check your server fitness",
// "Go to the Tiki Server Compatibility Check" => "Go to the Tiki Server Compatibility Check",
// "You are done with the admin wizard" => "You are done with the admin wizard",
// "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin" => "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user",
// "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were" => "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were",
// "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode" => "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode",
// "Wysiwyg editor" => "Wysiwyg editor",
// "Select the Wysiwyg editor mode" => "Select the Wysiwyg editor mode",
// "Compatible Wiki mode" => "Compatible Wiki mode",
// "Use wiki syntax for saved pages" => "Use wiki syntax for saved pages",
// "This is the most compatible with Tiki functionality and the most stable editor mode" => "This is the most compatible with Tiki functionality and the most stable editor mode",
// "Tools and functions in the editor toolbar will be limited" => "Tools and functions in the editor toolbar will be limited",
// "HTML mode" => "HTML mode",
// "Use HTML syntax for saved pages" => "Use HTML syntax for saved pages",
// "Best compatibility with inline editing" => "Best compatibility with inline editing",
// "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL" => "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL",
// "Full editor toolbar" => "Full editor toolbar",
// "Wysiwyg admin panel" => "Wysiwyg admin panel",
// "Documentation site" => "Documentation site",
// "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>" => "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>",
// "To see it in full size out of this frame" => "To see it in full size out of this frame",
// "Main new features and settings in Tiki 13" => "Main new features and settings in Tiki 13",
// "Tiki13" => "Tiki13",
// "Tiki13 is a post-LTS version" => "Tiki13 is a post-LTS version",
// "It will be supported until 14.1 is released" => "It will be supported until 14.1 is released",
// "The requirements increased (IE9, PHP 5.5)" => "The requirements increased (IE9, PHP 5.5)",
// "Major changes have happened, including moving to Bootstrap" => "Major changes have happened, including moving to Bootstrap",
// "New Themes" => "New Themes",
// "Site layouts (based on 'Bootstrap')" => "Site layouts (based on 'Bootstrap')",
// "The changes in this area were refactored in Tiki 14" => "The changes in this area were refactored in Tiki 14",
// "Goal, Recognition and Rewards" => "Goal, Recognition and Rewards",
// "Main new features and settings in Tiki 14" => "Main new features and settings in Tiki 14",
// "Tiki14" => "Tiki14",
// "Tiki14 is a standard non-LTS version" => "Tiki14 is a standard non-LTS version",
// "It will be supported until 15.1 is released" => "It will be supported until 15.1 is released",
// "The requirements are the same as in the previous version (IE9, PHP 5.5)" => "The requirements are the same as in the previous version (IE9, PHP 5.5)",
// "Minor changes have happened, compared to post-LTS versions such as Tiki13" => "Minor changes have happened, compared to post-LTS versions such as Tiki13",
// "New modules" => "New modules",
// "A new module called <strong>Module zone</strong> was added" => "A new module called <strong>Module zone</strong> was added",
// "Module zone" => "Module zone",
// "New module meant to provide a horizontal 'navigation bar' for the website" => "New module meant to provide a horizontal 'navigation bar' for the website",
// "Tiki Addons" => "Tiki Addons",
// "Addons allow a way for developers to add an even broader range of functionality" => "Addons allow a way for developers to add an even broader range of functionality",
// "Addons" => "Addons",
// "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase" => "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase",
// "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki" => "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki",
// "Other new features" => "Other new features",
// "Improved and extended features" => "Improved and extended features",
// "See the full list of changes" => "See the full list of changes",
// "Main new features and settings in Tiki 15" => "Main new features and settings in Tiki 15",
// "Tiki15" => "Tiki15",
// "Tiki15 is an LTS version" => "Tiki15 is an LTS version",
// "As it is a Long-Term Support (LTS) version, it will be supported for 5 years" => "As it is a Long-Term Support (LTS) version, it will be supported for 5 years",
// "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended" => "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended",
// "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki" => "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki",
// "In Tiki 15, an addons repository was added" => "In Tiki 15, an addons repository was added",
// "New Wiki Plugins" => "New Wiki Plugins",
// "Social Networks with Linkedin" => "Social Networks with Linkedin",
// "Temporary User Accounts" => "Temporary User Accounts",
// "Display more information here" => "Display more information here",
// "You can use this feature through: " => "You can use this feature through: ",
// "Admin Users > Temporary Users (tab)" => "Admin Users > Temporary Users (tab)",
// "Statistics Control Panel" => "Statistics Control Panel",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "Console" => "Console",
// "There is a console.php command to set a scheduled batch upload cron task" => "There is a console.php command to set a scheduled batch upload cron task",
// "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)" => "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)",
// "Removed features" => "Removed features",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Main new and improved features and settings in Tiki 16" => "Main new and improved features and settings in Tiki 16",
// "Tiki16" => "Tiki16",
// "Tiki16 is a standard non-LTS version" => "Tiki16 is a standard non-LTS version",
// "It will be supported until 17.1 is released" => "It will be supported until 17.1 is released",
// "New PHP minimum requirement for Tiki 16 is PHP 5.6" => "New PHP minimum requirement for Tiki 16 is PHP 5.6",
// "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others" => "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others",
// "Tracker Force-Fill Feature" => "Tracker Force-Fill Feature",
// "Improved Fields" => "Improved Fields",
// "Improved Plugins and extended features" => "Improved Plugins and extended features",
// "There are a few new console.php commands to set scheduled cron tasks" => "There are a few new console.php commands to set scheduled cron tasks",
// "Filtering to Index-based Plugins" => "Filtering to Index-based Plugins",
// "Filter UI added in any wiki plugin using unified search index" => "Filter UI added in any wiki plugin using unified search index",
// "PDF Settings (Control Panel > Print)" => "PDF Settings (Control Panel > Print)",
// "New method to create PDF: mPDF" => "New method to create PDF: mPDF",
// "New Profiles" => "New Profiles",
// "Bug_Tracker_16" => "Bug_Tracker_16",
// "Execute on list" => "Execute on list",
// "GeoCMS_Maps" => "GeoCMS_Maps",
// "Work_Custom_Pricing" => "Work_Custom_Pricing",
// "Main new and improved features and settings in Tiki 17" => "Main new and improved features and settings in Tiki 17",
// "Tiki17" => "Tiki17",
// "Tiki17 is a standard non-LTS version" => "Tiki17 is a standard non-LTS version",
// "It will be supported until 18.1 is released" => "It will be supported until 18.1 is released",
// "Many libraries have been upgraded" => "Many libraries have been upgraded",
// "Improved Plugins" => "Improved Plugins",
// "HTTP Header Options" => "HTTP Header Options",
// "Intrusion Detection System (IDS) with Expose" => "Intrusion Detection System (IDS) with Expose",
// "Other new or Extended Features" => "Other new or Extended Features",
// "Preferences can be set" => "Preferences can be set",
// "One system cron job can trigger all required actions at their specific scheduled times" => "One system cron job can trigger all required actions at their specific scheduled times",
// "Main new and improved features and settings in Tiki 18" => "Main new and improved features and settings in Tiki 18",
// "Tiki18" => "Tiki18",
// "This is an LTS version" => "This is an LTS version",
// "New Features" => "New Features",
// "Composer Web Install (<b>Packages</b>)" => "Composer Web Install (<b>Packages</b>)",
// "Style guide tool" => "Style guide tool",
// "Look and feel colors can be customized with a style guide tool" => "Look and feel colors can be customized with a style guide tool",
// "PDF from URL: mPDF new settings" => "PDF from URL: mPDF new settings",
// "Other Extended Features" => "Other Extended Features",
// "Real-time collaboration tools (<b>RTC</b>)" => "Real-time collaboration tools (<b>RTC</b>)",
// "New actions can be performed" => "New actions can be performed",
// "Drag and drop added to menu management" => "Drag and drop added to menu management",
"Profiles" => "Profile",
// "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items" => "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items",
// "Calendars and Calendar Items will now appear in search results of the unified search index" => "Calendars and Calendar Items will now appear in search results of the unified search index",
// "Certain tracker fields can be converted keeping options" => "Certain tracker fields can be converted keeping options",
// "New Fields" => "New Fields",
// "Activity_Stream" => "Activity_Stream",
// "Simple_Forum" => "Simple_Forum",
// "Timesheets_Tracker" => "Timesheets_Tracker",
// "User_Profile_Business" => "User_Profile_Business",
// "Main new and improved features and settings in Tiki 19" => "Main new and improved features and settings in Tiki 19",
// "Tiki19" => "Tiki19",
// "It is a Standard Term Support (STS) version" => "It is a Standard Term Support (STS) version",
// "It will be supported until Tiki 20.1 is released" => "It will be supported until Tiki 20.1 is released",
// "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones" => "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones",
// "Federation" => "Federation",
// "Other New Features" => "Other New Features",
// "Added a preview button in tracker field files to enable pdf view in new window without download document" => "Added a preview button in tracker field files to enable pdf view in new window without download document",
// "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item" => "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item",
// "Create tracker from File" => "Create tracker from File",
// "GanttChart" => "GanttChart",
// "Hide Fixed Top Nav Bar on Scroll 19" => "Hide Fixed Top Nav Bar on Scroll 19",
// "Scheduler_Presets" => "Scheduler_Presets",
// "And many more improvements" => "And many more improvements",
// "Main new and improved features and settings in Tiki 20" => "Main new and improved features and settings in Tiki 20",
// "Tiki20" => "Tiki20",
// "It will be supported until Tiki 21.1 is released" => "It will be supported until Tiki 21.1 is released",
// "Groupmail_20" => "Groupmail_20",
// "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability" => "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability",
// "Basic Information about Wizards" => "Basic Information about Wizards",
// "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)" => "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)",
// "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled" => "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled",
// "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site" => "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site",
// "Wizards settings" => "Wizards settings",
// "Here you can see listed other features and settings that were not included in the previous sections" => "Here you can see listed other features and settings that were not included in the previous sections",
// "Ratings in Forums" => "Ratings in Forums",
// "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user" => "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Topic Rating by each user" => "Topic Rating by each user",
// "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply" => "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply",
// "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion" => "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion",
// "Sysadmin Tasks" => "Sysadmin Tasks",
// "Search Index" => "Search Index",
// "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>" => "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>",
// "Cron Job to Rebuild Search Index" => "Cron Job to Rebuild Search Index",
// "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index" => "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index",
// "Starting in Tiki11, the syntax to rebuild the search index changed" => "Starting in Tiki11, the syntax to rebuild the search index changed",
// "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line" => "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line",
// "Console (console.php script)" => "Console (console.php script)",
// "Example: Database update" => "Example: Database update",
// "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>" => "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>",
// "Mail Queue" => "Mail Queue",
"Daily Reports for User Watches" => "Tägliche Berichte für Benutzerbeobachtungspunkte",
// "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending" => "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending",
// "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished" => "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished",
// "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button" => "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button",
// "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job" => "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job",
// "Example: Send the Mail Queue" => "Example: Send the Mail Queue",
// "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups" => "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups",
// "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)" => "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)",
// "Example: Send the Daily Report" => "Example: Send the Daily Report",
// "Other Features" => "Other Features",
// "New permissions and action log settings" => "New permissions and action log settings",
// "Wiki Inline Editing" => "Wiki Inline Editing",
// "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4" => "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4",
// "The editor can be quickly turned on/off. All processing is done client side" => "The editor can be quickly turned on/off. All processing is done client side",
// "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown" => "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown",
// "bigbluebutton" => "bigbluebutton",
// "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings" => "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings",
// "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted" => "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted",
// "Switch editor" => "Switch editor",
// "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted" => "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted",
// "Action log settings" => "Action log settings",
// "Joined Room" => "Joined Room",
// "Left Room" => "Left Room",
// "You are reaching the end of the <em>Changes Wizard</em>" => "You are reaching the end of the <em>Changes Wizard</em>",
// "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least" => "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least",
// "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community" => "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community",
// "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above" => "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above",
// "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}" => "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}",
"Connect" => "Verbinden",
"Site title is required" => "Site-Titel ist erforderlich",
// "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki" => "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki",
// "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site" => "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site",
// "Tracker Field Types" => "Tracker Field Types",
// "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>" => "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>",
// "Former ways to manage ratings in trackers are <b>deprecated</b>" => "Former ways to manage ratings in trackers are <b>deprecated</b>",
// "Deprecated Rating Systems in Trackers" => "Deprecated Rating Systems in Trackers",
// "Tracker field types" => "Tracker field types",
// "edit Tracker" => "edit Tracker",
// "Other options to be set elsewhere" => "Other options to be set elsewhere",
// "Add a <em>User and Registration tracker</em>" => "Add a <em>User and Registration tracker</em>",
// "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins" => "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins",
// "You can set it in" => "You can set it in",
// "tracker edition" => "tracker edition",
// "Some User Interface (UI) improvements which usually come disabled in new Tiki installations" => "Some User Interface (UI) improvements which usually come disabled in new Tiki installations",
// "They are proven to be useful enhancements in some production environments" => "They are proven to be useful enhancements in some production environments",
// "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try" => "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try",
// "Icons and Profile Pictures" => "Icons and Profile Pictures",
// "Text Areas" => "Text Areas",
// "You are done with the Changes Wizard" => "You are done with the Changes Wizard",
// "You are done with the Configuration Profiles Wizard" => "You are done with the Configuration Profiles Wizard",
// "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site" => "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences",
// "Some profiles were created for use cases of project management" => "Some profiles were created for use cases of project management",
// "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly" => "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly",
// "It creates" => "It creates",
// "a sample tracker that will hold the tasks" => "a sample tracker that will hold the tasks",
// "a sample wiki page linked to that tracker to display the tasks" => "a sample wiki page linked to that tracker to display the tasks",
// "Some demo data to help you get started" => "Some demo data to help you get started",
// "Click to expand" => "Click to expand",
// "Work custom pricing" => "Work custom pricing",
// "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one" => "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one",
// "Work Custom Pricing" => "Work Custom Pricing",
// "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile" => "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile",
// "Wildcard items" => "Wildcard items",
// "This profile adds a way to provide reusable items in a tracker coming from another one working as templates" => "This profile adds a way to provide reusable items in a tracker coming from another one working as templates",
// "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are" => "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are",
// "A couple of trackers. One for current items, and another one for the reusable items working ass templates" => "A couple of trackers. One for current items, and another one for the reusable items working ass templates",
// "A few wiki pages to list, view and edit items" => "A few wiki pages to list, view and edit items",
// "Some example items in both trackers to help you get started" => "Some example items in both trackers to help you get started",
// "Check out some commonly used configurations in Tiki sites" => "Check out some commonly used configurations in Tiki sites",
// "User & Registration Tracker" => "User & Registration Tracker",
// "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users" => "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users",
// "It includes" => "It includes",
// "A long list of predefined usual fields, to choose from" => "A long list of predefined usual fields, to choose from",
// "Some fields already prepared to display custom information from your specific site" => "Some fields already prepared to display custom information from your specific site",
// "The chance to easily customize it with the power of Trackers" => "The chance to easily customize it with the power of Trackers",
// "Custom Contact Form" => "Custom Contact Form",
// "This profile eases the task to create a custom contact form adapted to the specific case of that site" => "This profile eases the task to create a custom contact form adapted to the specific case of that site",
// "More details" => "More details",
// "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point" => "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point",
// "New fields can be added asking questions specific for the site" => "New fields can be added asking questions specific for the site",
// "You decide where and when to display the link to the contact us form in your Tiki menus and pages" => "You decide where and when to display the link to the contact us form in your Tiki menus and pages",
// "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields" => "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields",
// "Useful for Geographic data (State, Country/Province, ...)" => "Useful for Geographic data (State, Country/Province, ...)",
// "Useful for Types and Subtypes" => "Useful for Types and Subtypes",
// "Useful for Program Names and Versions" => "Useful for Program Names and Versions",
// "Easily manage the options in the second tracker without editing the dropdown in the first tracker" => "Easily manage the options in the second tracker without editing the dropdown in the first tracker",
// "Sortable Tables" => "Sortable Tables",
// "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature" => "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature",
// "Useful to sort and filter data in real time" => "Useful to sort and filter data in real time",
// "Same approach for FancyTable and TrackerList Plugins" => "Same approach for FancyTable and TrackerList Plugins",
// "Sorting can be server-side or client-side based " => "Sorting can be server-side or client-side based ",
// "Some profiles are highly customized for very specialized use cases, and they are listed in this special category" => "Some profiles are highly customized for very specialized use cases, and they are listed in this special category",
// "Demo Profiles" => "Demo Profiles",
// "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site" => "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site",
// "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on" => "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on",
// "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected" => "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected",
// "See details in the instructions page shown in your site once each profile is applied" => "See details in the instructions page shown in your site once each profile is applied",
// "CartoGraf" => "CartoGraf",
// "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools" => "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools",
// "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application" => "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application",
// "This profile is using Tiki as Framework, with these details" => "This profile is using Tiki as Framework, with these details",
// "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers" => "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers",
// "It uses its own Cartograf style (downloaded aside)" => "It uses its own Cartograf style (downloaded aside)",
// "It allows custom markers for maps (placed in a file gallery)" => "It allows custom markers for maps (placed in a file gallery)",
// "It is used in production at http://cartograf.recitus.qc.ca (in French)" => "It is used in production at http://cartograf.recitus.qc.ca (in French)",
// "R demo" => "R demo",
// "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages" => "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages",
// "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)" => "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)",
// "The profile creates many demo pages, which comprise" => "The profile creates many demo pages, which comprise",
// "Simple R syntax in wiki pages to produce interactive charts" => "Simple R syntax in wiki pages to produce interactive charts",
// "Advanced usage to create full GUI for an R application" => "Advanced usage to create full GUI for an R application",
// "Many other examples of nice charts and reports that you can produce with this system" => "Many other examples of nice charts and reports that you can produce with this system",
// "r.tiki.org site" => "r.tiki.org site",
// "r.tiki.org live site" => "r.tiki.org live site",
// "GeoCMS Maps" => "GeoCMS Maps",
// "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps" => "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps",
// "R Heatmaps" => "R Heatmaps",
// "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)" => "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)",
// "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)" => "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)",
// "This profile creates" => "This profile creates",
// "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you" => "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you",
// "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets" => "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets",
// "Example input files and default values provided as a happy path to produce your first Heatmaps" => "Example input files and default values provided as a happy path to produce your first Heatmaps",
// "Plugin R" => "Plugin R",
// "Plugin R in doc.tiki.org" => "Plugin R in doc.tiki.org",
// "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example" => "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example",
// "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real" => "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real",
// "Bug Tracker" => "Bug Tracker",
// "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below" => "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below",
// "Uses PluginTracker in a wiki page to add items" => "Uses PluginTracker in a wiki page to add items",
// "Create some custom feedback for message to the user after item insertion" => "Create some custom feedback for message to the user after item insertion",
// "Uses PluginTrackerList to display inserted items" => "Uses PluginTrackerList to display inserted items",
// "Timesheet" => "Timesheet",
// "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names" => "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names",
// "Allows to track your time spent on projects" => "Allows to track your time spent on projects",
// "Customize your project categories" => "Customize your project categories",
// "Add or edit your timesheet fields as desired" => "Add or edit your timesheet fields as desired",
// "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker" => "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker",
// "Plugin Timesheet" => "Plugin Timesheet",
// "Plugin Timesheet in doc.tiki.org" => "Plugin Timesheet in doc.tiki.org",
// "Tracker as Calendar" => "Tracker as Calendar",
// "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way" => "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way",
// "Advanced use of Plugin TrackerList" => "Advanced use of Plugin TrackerList",
// "Working example of Plugin TrackerCalendar" => "Working example of Plugin TrackerCalendar",
// "Drag & Drop to resize or move events" => "Drag & Drop to resize or move events",
// "Several display modes, useful for Project & Resource Management" => "Several display modes, useful for Project & Resource Management",
// "Voting System" => "Voting System",
// "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote" => "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote",
// "Group homepage set for the voting group" => "Group homepage set for the voting group",
// "Only one vote per member is allowed" => "Only one vote per member is allowed",
// "Results shown in real time (Plugin TrackerStat)" => "Results shown in real time (Plugin TrackerStat)",
// "Other candidates can be voted beyond the proposed" => "Other candidates can be voted beyond the proposed",
// "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site" => "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site",
// "Shopping Cart" => "Shopping Cart",
// "This profile provides a Shopping Cart and the corresponding basic payment system" => "This profile provides a Shopping Cart and the corresponding basic payment system",
// "It currently uses the PayPal shopping cart rather than the built in Tiki" => "It currently uses the PayPal shopping cart rather than the built in Tiki",
// "A tracker for products including price, weight, image and stock quantity" => "A tracker for products including price, weight, image and stock quantity",
// "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users" => "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users",
// "A small category subtree to classify products" => "A small category subtree to classify products",
// "Wiki pages to display the available products list, one product details page and a search form" => "Wiki pages to display the available products list, one product details page and a search form",
// "Easy GeoBlog" => "Easy GeoBlog",
// "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features" => "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features",
// "Single map with all geolocated blog posts" => "Single map with all geolocated blog posts",
// "Different home page once the user logs in" => "Different home page once the user logs in",
// "Random header image from files included in a file gallery" => "Random header image from files included in a file gallery",
// "WYSIWYG Editor (compatible mode with wiki syntax)" => "WYSIWYG Editor (compatible mode with wiki syntax)",
// "Wiki, Search, Menu & Tags" => "Wiki, Search, Menu & Tags",
// "Comments moderation & Banning (for anonymous comments to your site)" => "Comments moderation & Banning (for anonymous comments to your site)",
// "Profile Conditional_Display_in_Forms" => "Profile Conditional_Display_in_Forms",
// "This profile demonstrates the setup to conditionally hide or display some fields in a form" => "This profile demonstrates the setup to conditionally hide or display some fields in a form",
// "Conditional_Display_in_Forms" => "Conditional_Display_in_Forms",
// "Main features used" => "Main features used",
// "Plugin JQ (jQuery)" => "Plugin JQ (jQuery)",
// "Plugin TrackerIf" => "Plugin TrackerIf",
// "Profile Execute_on_list" => "Profile Execute_on_list",
// "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute" => "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute",
// "Plugin ListExecute" => "Plugin ListExecute",
// "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes" => "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes",
// "Structured Master Documents" => "Structured Master Documents",
// "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more" => "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more",
// "Many pages are pre-created to let you easily set up several wiki structures" => "Many pages are pre-created to let you easily set up several wiki structures",
// "A common navigation menu is created and shown at the top of pages in the structure" => "A common navigation menu is created and shown at the top of pages in the structure",
// "You can easily print (export) them all together in a single html" => "You can easily print (export) them all together in a single html",
// "Permissions or Monitoring can be applied in bulk to the whole structure or substructures" => "Permissions or Monitoring can be applied in bulk to the whole structure or substructures",
// "Consensus Forums" => "Consensus Forums",
// "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held" => "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held",
// "Users ratings in Forums" => "Users ratings in Forums",
// "Topics with less agreement can be easily identified from the topic list" => "Topics with less agreement can be easily identified from the topic list",
// "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus" => "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus",
// "Replies can also be rated, but without affecting the topic rating average" => "Replies can also be rated, but without affecting the topic rating average",
// "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile" => "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile",
// "Barter Market" => "Barter Market",
// "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge" => "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge",
// "minimal number of fields in these trackers, which can be extended" => "minimal number of fields in these trackers, which can be extended",
// "tracker items are categorized" => "tracker items are categorized",
// "a few modules added, including a wiki page menu" => "a few modules added, including a wiki page menu",
// "best display if using just one column (right, for instance)" => "best display if using just one column (right, for instance)",
// "Revision Approval (ISO9001)" => "Revision Approval (ISO9001)",
// "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)" => "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)",
// "Additions: 1 group, 2 users, 2 wiki pages, 3 categories" => "Additions: 1 group, 2 users, 2 wiki pages, 3 categories",
// "Revision approval is set for homepage and 'official document'" => "Revision approval is set for homepage and 'official document'",
// "Wiki Argument Variables are used in the 'official document'" => "Wiki Argument Variables are used in the 'official document'",
// "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles" => "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles",
// "Collaborative Community" => "Collaborative Community",
"Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Einstellung, damit verschiedene Menschen zusammen eine Wissenssammlung aufbauen können",
// "Uses" => "Uses",
"Wiki Editing" => "Wiki Bearbeitung",
"Personal Member Spaces" => "Persönliche Mitgliederbereiche",
// "Company Intranet" => "Company Intranet",
"Setup for a Corporate Intranet of a typical medium-sized business" => "Einstellungen für ein Firmenintranet für typische mittlere Unternehmen",
"Company News Articles" => "Artikelsystem für Firmenneuigkeiten",
"Executive Blog" => "Geschäftsführungs-Blog",
"File Repository & Management" => "Dateienspeicherung und Verwaltung",
"Collaborative Wiki" => "Gemeinsame Wiki",
// "Personal Blog and Profile" => "Personal Blog and Profile",
"Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Einstellung mit vielen coolen Funktionen, um Dich im sozialen Netz zu integrieren und Deine Präsenz in der Blogosphäre zu erstellen",
"Blog (Full set of blog related features)" => "Blog (Alle Einstellungen für die Funktionalität von Blogs)",
"RSS Integration" => "RSS Integration (RSS-Feeds)",
"Video Log" => "Video-Tagebuch",
// "Small Organization Web Presence" => "Small Organization Web Presence",
"Setup for a Web Presence of a typical small business or non-profit" => "Einstellung für eine Web-Präsenz für ein typisches kleines Unternehmen oder eine Non-profit-Organisation",
"Company News & Updates" => "Neuigkeiten und Updates des Unternehmens",
"Highlight Company's Products and Services" => "Hebe Unternehmens-Produkte und -dienste hervor",
"File Gallery (great for Media Kit)" => "Dateiarchiv (z.B. für Medien)",
"Contact Form" => "Kontaktformular",
// "Profiles admin card" => "Profiles admin card",
// "Check out some useful changes in the configuration for site administrators" => "Check out some useful changes in the configuration for site administrators",
// "Debug Mode Enabled" => "Debug Mode Enabled",
// "Debug Mode Disabled" => "Debug Mode Disabled",
// "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise" => "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise",
// "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand" => "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand",
// "Enables/Disables debugging tools" => "Enables/Disables debugging tools",
// "Enables/Disables logging tools" => "Enables/Disables logging tools",
// "Disables/Enables redirections to similar pages" => "Disables/Enables redirections to similar pages",
// "Enables/Disables error and warning display to all users, not only admins" => "Enables/Disables error and warning display to all users, not only admins",
// "This configuration profile enables the Scheduler feature and loads a preset of schedulers" => "This configuration profile enables the Scheduler feature and loads a preset of schedulers",
// "Each scheduler can replace a former cron job action in the server" => "Each scheduler can replace a former cron job action in the server",
// "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need" => "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need",
// "This configuration profile showcases the activity stream feature in Tiki" => "This configuration profile showcases the activity stream feature in Tiki",
// "Activity Stream data can also be reviewed through PluginPivotTable" => "Activity Stream data can also be reviewed through PluginPivotTable",
// "It is somewhat similar to the basic Action log feature in Tiki" => "It is somewhat similar to the basic Action log feature in Tiki",
// "Check out some useful profiles that involve changing the display mode of content in your site" => "Check out some useful profiles that involve changing the display mode of content in your site",
// "Slideshow demo" => "Slideshow demo",
// "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works" => "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works",
// "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper" => "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper",
// "Headers of different levels are used as markers of 'new slide' and used as titles" => "Headers of different levels are used as markers of 'new slide' and used as titles",
// "Many settings can be predefined as parameters of a call to PluginSlideshow" => "Many settings can be predefined as parameters of a call to PluginSlideshow",
// "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to" => "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to",
// "Hide Fixed Top Navigation Bar on scroll" => "Hide Fixed Top Navigation Bar on scroll",
// "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards" => "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards",
// "Hide Fixed Top Navi Bar on Scroll" => "Hide Fixed Top Navi Bar on Scroll",
// "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'" => "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'",
// "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice" => "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice",
// "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky" => "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky",
// "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus" => "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus",
// "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration" => "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration",
// "Menu on Wiki page" => "Menu on Wiki page",
// "This profile sets up a side module with a menu based on a wiki page in the right hand-side column" => "This profile sets up a side module with a menu based on a wiki page in the right hand-side column",
// "With this profile you can" => "With this profile you can",
// "use wiki syntax to edit it" => "use wiki syntax to edit it",
// "delegate its edition with wiki page permissions" => "delegate its edition with wiki page permissions",
// "use plugins to manage conditional display of sections" => "use plugins to manage conditional display of sections",
// "Random header images" => "Random header images",
// "This profile adds a module in the top zone that displays a random image from a File Gallery" => "This profile adds a module in the top zone that displays a random image from a File Gallery",
// "Some sample images to fit the default configuration are also provided as a starting point" => "Some sample images to fit the default configuration are also provided as a starting point",
// "default configuration uses images at 800x150px resized by the top module parameters to match the header default size" => "default configuration uses images at 800x150px resized by the top module parameters to match the header default size",
// "a different random image is shown at each page load" => "a different random image is shown at each page load",
// "elFinder modern file galery manager (with drag & drop capabilities!) is used by default" => "elFinder modern file galery manager (with drag & drop capabilities!) is used by default",
// "you can tweak the module and file gallery defaults as needed for your needs" => "you can tweak the module and file gallery defaults as needed for your needs",
// "Multilingual Wiki" => "Multilingual Wiki",
// "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion" => "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion",
// "The enabled features comprise" => "The enabled features comprise",
// "Multilingual freetags" => "Multilingual freetags",
// "Countries By Region" => "Countries By Region",
// "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions" => "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions",
// "The regions listed with their countries are" => "The regions listed with their countries are",
// "Saharan, Sub-Saharan Africa" => "Saharan, Sub-Saharan Africa",
// "Middle East, North Africa" => "Middle East, North Africa",
// "Asia" => "Asia",
// "North, Central America" => "North, Central America",
// "Oceania" => "Oceania",
// "South America" => "South America",
// "Check out this set of useful configurations that involve using some new technology for your site" => "Check out this set of useful configurations that involve using some new technology for your site",
// "Write Together" => "Write Together",
// "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS" => "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS",
// "Allows cowriting documents in real time" => "Allows cowriting documents in real time",
// "Allows voice communication in real time while editing" => "Allows voice communication in real time while editing",
// "Uses the TogetherJS Mozilla widget" => "Uses the TogetherJS Mozilla widget",
// "Post-it Sticky Note" => "Post-it Sticky Note",
// "This profile allows to display a sticky note (a \"post-it\") in your tiki site" => "This profile allows to display a sticky note (a \"post-it\") in your tiki site",
// "You can move it to another location" => "You can move it to another location",
// "You can customize the contents and which groups of users will see it (by default, only to Admins)" => "You can customize the contents and which groups of users will see it (by default, only to Admins)",
// "It will be shown for each user of that group until manually closed" => "It will be shown for each user of that group until manually closed",
// "Groupmail" => "Groupmail",
// "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages" => "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages",
// "A tracker for email messages received and store addresses in the Contacts feature" => "A tracker for email messages received and store addresses in the Contacts feature",
// "Webmail configuration to use an account for groupmail" => "Webmail configuration to use an account for groupmail",
// "A side module with markers to indicate who took which message" => "A side module with markers to indicate who took which message",
// "A system to review communication logs from that group mail account" => "A system to review communication logs from that group mail account",
// "Profile X" => "Profile X",
// "This profile allows to " => "This profile allows to ",
// "Feature_X in doc.tiki.org" => "Feature_X in doc.tiki.org",
// "User Dummy" => "User Dummy",
// "This is a dummy page" => "This is a dummy page",
// "Set up basic information as a user on this site" => "Set up basic information as a user on this site",
"Your personal Wiki Page" => "Deine persönliche Wiki-Seite",
// "The feature 'User Preferences' is currently disabled in this site" => "The feature 'User Preferences' is currently disabled in this site",
// "Enable the feature" => "Enable the feature",
// "Enable it" => "Enable it",
// "You might ask your site admin to enable it" => "You might ask your site admin to enable it",
// "Use 'watches' to monitor wiki pages or other objects" => "Use 'watches' to monitor wiki pages or other objects",
// "Set up below preferences related to receiving notifications by email about changes in the site" => "Set up below preferences related to receiving notifications by email about changes in the site",
// "The feature user watches is disabled in this site" => "The feature user watches is disabled in this site",
// "Set up the general settings for your account" => "Set up the general settings for your account",
// "User Params" => "User Params",
"Is email public? (uses scrambling to prevent spam)" => "E-Mailadresse öffentlich? (es wird Verschlüsselung gegen Spam benutzt)",
"Does your email application need a special character set" => "Benötigt der Mailreader einen speziellen Zeichensatz?",
"Preferred language:" => "Bevorzugte Sprache:",
// "Site time zone is enforced and overrides user preferences" => "Site time zone is enforced and overrides user preferences",
"Use 12-hour clock in time selectors:" => "Benutze 12-Stunden-Uhr für Zeitauswahl",
"Send me an email for messages with priority equal to or greater than:" => "Schicke mir eine E-Mail beim Eintreffen von Nachrichten mit Priorität größer gleich:",
// "The feature with the user preferences screen is disabled in this site" => "The feature with the user preferences screen is disabled in this site",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
"You are not allowed to remove this notification " => "Es ist Dir nicht erlaubt, diese Benachrichtigung zu entfernen ",
"Interval in which you want to get the reports" => "Intervall in dem Du Berichte erhalten möchtest",
"HTML-Email" => "HTML E-Mail",
"Send me an email also if nothing happened" => "Schicke mir eine E-Mail, auch wenn nichts passiert ist",
// "The feature daily reports of user watches is disabled in this site" => "The feature daily reports of user watches is disabled in this site",
// "Use this form to fill in some extra information about you" => "Use this form to fill in some extra information about you",
// "Extra information about you" => "Extra information about you",
// "Tiki User Wizard" => "Tiki User Wizard",
// "This wizard will help you fill in data and main settings for your account on this website" => "This wizard will help you fill in data and main settings for your account on this website",
// "Depending on the features enabled by the site admin, you will be offered more or less options" => "Depending on the features enabled by the site admin, you will be offered more or less options",
// "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature" => "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature",
// "Click at the \"Start\" button above to launch it" => "Click at the \"Start\" button above to launch it",
// "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>" => "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>",
// "You are done with the user wizard" => "You are done with the user wizard",
// "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences" => "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences",
// "Or.." => "Or..",
// "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were" => "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were",
// "Show on admin log-in" => "Show on admin log-in",
// "Finish" => "Finish",
// "Start the Wizardry" => "Start the Wizardry",
// "Save and Continue" => "Save and Continue",
// "No turning back" => "No turning back",
// "Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available" => "Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available",
// "Return to simple interface" => "Return to simple interface",
// "Workspace Name" => "Workspace Name",
// "Wiki Page Source" => "Wiki Page Source",
// "Not enough options" => "Not enough options",
// "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power" => "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power",
"Advanced Mode" => "Fortgeschrittener Modus",
// "Bind area" => "Bind area",
// "Is managing group" => "Is managing group",
// "Workspace creator joins this group" => "Workspace creator joins this group",
"Add group" => "Gruppe hinzufügen",
// "Select Permissions" => "Select Permissions",
"Edit content template" => "Bearbeite die Inhaltsvorlage ",
"Add page" => "Seite beifügen",
// "Default (Font-awesome)" => "Default (Font-awesome)",
// "The default system icon set using Font-awesome fonts" => "The default system icon set using Font-awesome fonts",
// "Solid" => "Solid",
// "Outline" => "Outline",
// "Font Awesome Regular" => "Font Awesome Regular",
// "Font Awesome Pro Only" => "Font Awesome Pro Only",
// "Brands" => "Brands",
// "Legacy (pre Tiki14) icons" => "Legacy (pre Tiki14) icons",
// "Legacy (pre Tiki14) icons, mainly using famfamfam images" => "Legacy (pre Tiki14) icons, mainly using famfamfam images",
// "Custom icons" => "Custom icons",
// "Custom icons for the theme" => "Custom icons for the theme",
// "Theme icons" => "Theme icons",
// "Icons to be used for this theme" => "Icons to be used for this theme",
// "This field is manadatory" => "This field is manadatory",
"Design by" => "Design von",
"Missing book id" => "Die Buch-ID fehlt",
"You do not have the right view this page" => "Du hast keine Berechtigung, diese Seite einzusehen",
// "%0 account in book %1 modified" => "%0 account in book %1 modified",
// "%0 account created for book %1" => "%0 account created for book %1",
// "Account %0 in book %1 unlocked" => "Account %0 in book %1 unlocked",
// "Account %0 in book %1 not unlocked" => "Account %0 in book %1 not unlocked",
// "Account %0 in book %1 locked" => "Account %0 in book %1 locked",
// "Account %0 in book %1 not locked" => "Account %0 in book %1 not locked",
// "Delete account %0 from book %1" => "Delete account %0 from book %1",
// "%0 account deleted from book %1" => "%0 account deleted from book %1",
"Missing account id" => "Konto-ID fehlt",
"You do not have the rights to view this account" => "Du hast keine Berechtigung, dieses Konto einzusehen",
"You do not have the rights to manage accounts" => "Du hast keine Berechtigung, Konten zu verwalten",
// "You do not have permission to create a book" => "You do not have permission to create a book",
// "Book %0 successfully created" => "Book %0 successfully created",
// "You do not have permission to close this book" => "You do not have permission to close this book",
// "Close book (this action cannot be undone)" => "Close book (this action cannot be undone)",
// "Book successfully closed" => "Book successfully closed",
// "The attempt to close the book was unsuccessful" => "The attempt to close the book was unsuccessful",
// "Cancel journal %0 in book %1" => "Cancel journal %0 in book %1",
// "Journal shown below successfully canceled" => "Journal shown below successfully canceled",
"Missing journal id" => "Fehlende Journal-ID",
"You do not have the right to cancel transactions" => "Du hast keine Berechtigung Transaktionen abzubrechen",
"Error retrieving data from journal" => "Fehler beim Empfangen von Daten aus dem Journal",
"You do not have the right to book" => "Du hast keine Berechtigung zu buchen",
// "Record entry in book %0" => "Record entry in book %0",
// "Journal %0 successfully recorded in book %1" => "Journal %0 successfully recorded in book %1",
"Don't know what to export" => "Nicht bekannt, was exportiert werden soll",
"You do not have the right export/view this data" => "Du hast keine Berechtigung, diese Daten einzusehen/zu exportieren",
"You do not have the right to book into the stack" => "Du hast keine Berechtigung in den Stapel zu buchen",
// "Record stack entry in book %0" => "Record stack entry in book %0",
// "Modify stack entry in book %0" => "Modify stack entry in book %0",
// "Delete stack %0 from book %1" => "Delete stack %0 from book %1",
// "Confirm stack %0 for book %0" => "Confirm stack %0 for book %0",
// "Stack %0 successfully modified in book %1" => "Stack %0 successfully modified in book %1",
// "Stack %0 successfully deleted from book %1" => "Stack %0 successfully deleted from book %1",
// "Stack %0 recorded in book %1" => "Stack %0 recorded in book %1",
// "Stack %0 deleted from book %1" => "Stack %0 deleted from book %1",
// "Stack %0 confirmed and recorded as entry in book %1" => "Stack %0 confirmed and recorded as entry in book %1",
"Tiki Calendar" => "Tiki Aktionenkalender",
"%0 enabled" => "%0 aktiviert",
"%0 disabled" => "%0 deaktiviert",
"%0 set" => "%0 eingestellt",
"%0 unset" => "%0 abgestellt",
// "item added" => "item added",
// "items added" => "items added",
// "item deleted" => "item deleted",
// "items deleted" => "items deleted",
"Help on Configuration Sections" => "Hilfe bei Konfigurationsabschnitten",
// "Default preference filters set" => "Default preference filters set",
"%0 reset" => "%0 zurücksetzen",
"Search error" => "Suchfehler",
// "Global site configuration, date formats, etc" => "Global site configuration, date formats, etc",
"Switches for major features" => "Hauptfunktionen an- und ausschalten",
"User registration, remember me cookie settings and authentication methods" => "Benutzeregistrierung, Erinnere Dich an mich Cookie Einstellungen und Authentifizierungsmethoden",
// "User related preferences like info and picture, features, messages and notification, files, etc" => "User related preferences like info and picture, features, messages and notification, files, etc",
"Repository configuration, browse and apply profiles" => "Repository-Konfiguration, Profile durchstöbern und anwenden",
"Look & Feel" => "Look & Feel",
"Theme selection, layout settings and UI effect controls" => "Theme auswählen, Layouteinstellungen, UI-Effekte Einstellungen",
"Editing and Plugins" => "Bearbeiten und Plugins",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Einstellungen zur Textbearbeitung in vielen Bereichen. Pluginaktivierung und Verwaltung von Plugin-Alias",
"Module appearance settings" => "Einstellungen zur Darstellung von Modulen",
"i18n" => "i18n",
// "Internationalization and localization - multilingual features" => "Internationalization and localization - multilingual features",
"Meta Tags" => "Meta tags",
"Information to include in the header of each page" => "Informationen, die im Kopf jeder Seite eingetragen sind",
"Maps" => "Karten",
"Settings and features for maps" => "Einstellungen und Funktionen für Karten",
"Server performance settings" => "Einstellungen für die Serverperformance",
"Site security settings" => "Sicherheitseinstellungen der Site",
"Outgoing RSS feed setup" => "Einstellung ausgehender Feed",
"Tiki Connect - join in" => "Tiki Verbindung - mach mit",
// "Rating settings" => "Rating settings",
"Search configuration" => "Suche konfigurieren",
"Wiki page settings and features" => "Wiki-Seiten Einstellungen und Funktionen",
"Defaults and configuration for file galleries" => "Standardwerte und Konfiguration für Dateiarchive",
"Settings for blogs" => "Einstellungen für Blogs",
"Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Standardwerte und Konfiguration für Bildergalerien (wird zugunsten von Dateiarchiven auslaufen)",
"Settings and features for articles" => "Einstellungen und Funktionen für Artikel",
"Settings and features for forums" => "Einstellungen und Funktionen für Foren",
"Settings and features for trackers" => "Einstellungen und Funktionen für Tracker",
"Settings and features for polls" => "Einstellungen und Funktionen für Abstimmungen",
"Settings and features for calendars" => "Einstellungen und Funktionen für Kalender",
"Settings and features for categories" => "Einstellungen und Funktionen für Kategorien",
// "Configure workspace feature" => "Configure workspace feature",
"Values of actions for users rank score" => "Werte für Aktionen für die Ermittlung des Benutzerrangs",
"Settings and features for tags" => "Einstellungen und Funktionen für Tags",
"Settings and features for FAQs" => "Einstellungen und Funktionen für FAQs",
"Settings and features for directory of links" => "Einstellungen und Funktionen für Linkverzeichnisse",
"Site-wide copyright information" => "Site-weite Copyright-Informationen",
"Message settings" => "Einstellungen Nachrichten",
// "Webmail settings" => "Webmail settings",
"Options for WYSIWYG editor" => "Optionen für den WYSIWYG Editor",
// "Site advertisements and notices" => "Site advertisements and notices",
"InterTiki" => "InterTiki",
"Set up links between Tiki servers" => " Links zwischen Tikiservern einstellen",
"Manage semantic wiki links" => "Verwalte semantische Wiki Links",
"Register and manage web services" => "Registriere und verwalte Webdienste",
// "SEF URL" => "SEF URL",
"Video integration configuration" => "Konfiguration der Videointegration",
// "Payment settings" => "Payment settings",
"Configure social networks integration" => "Konfiguriere die Integration sozialer Netzwerke",
"User specific features and settings" => "Benutzerspezifische Funktionen und Einstellungen",
"Configure share feature" => "Verwalte Share-Funktion",
// "Configure statistics reporting for your site usage" => "Configure statistics reporting for your site usage",
// "Print Settings" => "Print Settings",
// "Settings and features for print versions and pdf generation" => "Settings and features for print versions and pdf generation",
// "External packages installation and management" => "External packages installation and management",
// "RTC" => "RTC",
// "Real-time collaboration tools" => "Real-time collaboration tools",
"Help on %0 Config" => "Hilfe für die Konfiguration von %0",
// "Remove selected actions" => "Remove selected actions",
// "The selected action has been deleted from the log" => "The selected action has been deleted from the log",
// "%0 actions have been deleted from the log" => "%0 actions have been deleted from the log",
// "No actions were deleted from the log" => "No actions were deleted from the log",
"Must specify actionId" => "Du musst die actionId angeben",
"Users Contributions: Addition" => "Benutzerbeiträge: Hinzufügung",
"%s Contributions: Addition" => "%s Beiträge: Hinzufügung",
"Users Contributions: Suppression" => "Benutzerbeiträge: Unterdrückung",
"%s Contributions: Suppression" => "%s Beiträge: Unterdrückung",
"Total Contributions Addition per Day" => "Gesamtbeiträge hinzugefügt pro Tag",
"Total Contributions Addition per Week" => "Gesamtbeiträge hinzugefügt pro Woche",
"Total Contributions Suppression per Day" => "Gesamtbeiträge unterdrückt pro Tag",
"Total Contributions Suppression per Week" => "Gesamtbeiträge unterdrückt pro Woche",
"Total Contributions: Addition" => "Gesamtbeiträge: Hinzufügung",
"Total Contributions: Suppression" => "Gesamtbeiträge: Unterdrückung",
"Groups Contributions: Addition" => "Gruppenbeiträge: Addition",
"Groups Contributions: Suppression" => "Gruppenbeiträge: Unterdrückung",
"white" => "weiss",
"gray" => "grau",
"silver" => "silber",
"ivory" => "elfenbeinfarben",
"whitesmoke" => "rauchweiss",
"beige" => "beige",
"darkgrey" => "dunkelgrau",
// "No rule selected for deletion. No deletions were performed" => "No rule selected for deletion. No deletions were performed",
// "The selected banning rule has been deleted" => "The selected banning rule has been deleted",
// "%0 banning rules have been deleted" => "%0 banning rules have been deleted",
// "The following banning rule has been saved or replaced" => "The following banning rule has been saved or replaced",
// "The following %0 banning rules have been saved or replaced" => "The following %0 banning rules have been saved or replaced",
// "No changes were made to the following selected banning rules" => "No changes were made to the following selected banning rules",
// "Only %0 of the selected banning rules shown below were added or changed" => "Only %0 of the selected banning rules shown below were added or changed",
// "No banning rules were selected" => "No banning rules were selected",
"Multiple IP Banning" => "Verbannung multipler IPs",
"Access from your localization was forbidden due to excessive spamming" => "Zugriff wurde aufgrund massivem Spamming verboten",
// "Not saved" => "Not saved",
// "Username pattern empty" => "Username pattern empty",
// "Default IP pattern still set" => "Default IP pattern still set",
// "Calendar %0 deleted" => "Calendar %0 deleted",
// "Calendar %0 not deleted" => "Calendar %0 not deleted",
// "One calendar event deleted" => "One calendar event deleted",
// "No calendar events deleted" => "No calendar events deleted",
// "%0 calendar events deleted" => "%0 calendar events deleted",
// "No such category with parentID %0" => "No such category with parentID %0",
// "One object unassigned from category" => "One object unassigned from category",
// "%0 objects unassigned from category" => "%0 objects unassigned from category",
// "No objects unassigned" => "No objects unassigned",
// "Incorrect category ID %0 - objects not moved" => "Incorrect category ID %0 - objects not moved",
// "One object moved to selected category" => "One object moved to selected category",
// "%0 objects moved to selected category" => "%0 objects moved to selected category",
// "No objects moved" => "No objects moved",
// "Incorrect category ID %0 - objects not copied" => "Incorrect category ID %0 - objects not copied",
// "One object copied to selected category" => "One object copied to selected category",
// "%0 objects copied to selected category" => "%0 objects copied to selected category",
// "No objects copied" => "No objects copied",
// "One page added to category" => "One page added to category",
// "%0 pages added to category" => "%0 pages added to category",
// "No pages added to category" => "No pages added to category",
// "%0 %1 removed from category %2" => "%0 %1 removed from category %2",
// "%0 %1 not removed from category %2" => "%0 %1 not removed from category %2",
// "Delete category" => "Delete category",
// "Category ID %0 and descendants deleted" => "Category ID %0 and descendants deleted",
// "Category ID %0 not deleted" => "Category ID %0 not deleted",
// "Category cannot be parent of itself - no changes made" => "Category cannot be parent of itself - no changes made",
// "Category %0 updated" => "Category %0 updated",
// "Category %0 created" => "Category %0 created",
"The file does not have the required header" => "Diese Datei hat nicht den erforderlichen Kopf",
// "Incorrect parameter %0" => "Incorrect parameter %0",
// "Categories imported" => "Categories imported",
"Edit permissions for this category" => "Berechtigungen dieser Kategorie ändern",
// "Assign permissions" => "Assign permissions",
// "Template removed" => "Template removed",
// "Template not removed" => "Template not removed",
// "Section removed" => "Section removed",
// "Section not removed" => "Section not removed",
// "Template %0 created or modified" => "Template %0 created or modified",
// "Template %0 not created or modified" => "Template %0 not created or modified",
// "Contribution settings saved" => "Contribution settings saved",
// "Contribution settings not saved" => "Contribution settings not saved",
// "Contribution added" => "Contribution added",
// "Contribution not added" => "Contribution not added",
// "Contribution modified" => "Contribution modified",
// "Contribution not modified" => "Contribution not modified",
// "Contribution removed" => "Contribution removed",
// "Contribution not removed" => "Contribution not removed",
// "Cookie removed" => "Cookie removed",
// "Cookie not removed" => "Cookie not removed",
// "All cookies removed" => "All cookies removed",
// "No cookies removed" => "No cookies removed",
// "File uploaded and one cookie created or replaced" => "File uploaded and one cookie created or replaced",
// "File uploaded and %0 cookies created or replaced" => "File uploaded and %0 cookies created or replaced",
// "Upload failed - no cookies created" => "Upload failed - no cookies created",
"Upload failed" => "Hochladen fehlgeschlagen",
// "Cookie saved" => "Cookie saved",
// "Cookie not saved" => "Cookie not saved",
"Admin credits" => "Kredits verwalten",
// "DSN removed" => "DSN removed",
// "DSN not removed" => "DSN not removed",
// "DSN created or modified" => "DSN created or modified",
// "DSN not created or modified" => "DSN not created or modified",
// "External wiki removed" => "External wiki removed",
// "External wiki not removed" => "External wiki not removed",
// "External wiki saved" => "External wiki saved",
// "External wiki not saved" => "External wiki not saved",
// "Forum saved" => "Forum saved",
// "Forum not saved" => "Forum not saved",
// "Forum duplicated" => "Forum duplicated",
// "Forum not duplicated" => "Forum not duplicated",
"All posted" => "keine Nachricht",
"Queue anonymous posts" => "anonyme Nachrichten",
"Queue all posts" => "alle Nachrichten",
"No attachments" => "keine Anhänge",
"Everybody can attach" => "jeder darf Dateien anhängen",
"Only users with attach permission" => "nur Benutzer mit Anhangserlaubnis",
"Moderators and admin can attach" => "nur Moderatoren und Administratoren",
"No display" => "keine",
"Date (desc)" => "Datum (absteigend)",
"Date (asc)" => "Datum (aufsteigend)",
"Score (desc)" => "Bewertung (absteigend)",
"Replies (desc)" => "Antworten (absteigend)",
"Reads (desc)" => "Zugriffe (absteigend)",
"You have to provide a hotword and a URL" => "Du musst ein Hotword und eine URL angeben",
// "Hotword added" => "Hotword added",
// "Hotword not added" => "Hotword not added",
// "Hotword deleted" => "Hotword deleted",
// "Hotword not deleted" => "Hotword not deleted",
// "One dynamic zone updated" => "One dynamic zone updated",
// "%0 dynamic zones updated" => "%0 dynamic zones updated",
// "Dynamic zones not updated" => "Dynamic zones not updated",
// "Hotword saved" => "Hotword saved",
// "Hotword not saved" => "Hotword not saved",
// "HTML page removed" => "HTML page removed",
// "HTML page not removed" => "HTML page not removed",
// "HTML page saved" => "HTML page saved",
// "HTML page not saved" => "HTML page not saved",
// "A custom rule with the same ID already exists" => "A custom rule with the same ID already exists",
// "Tiki IDS is not enabled" => "Tiki IDS is not enabled",
"Requested action is not supported on repository" => "Angeforderte Aktion wird im Repository nicht unterstützt",
"Repository name can't be an empty" => "Repository-Name muss angegeben werden",
"No repository" => "Kein Repository",
"Search is mandatory field" => "Suche ist ein erforderliches Feld",
"File not found " => "Datei nicht gefunden ",
"Requested action in not supported on repository" => "Angeforderte Aktion wird im Repository nicht unterstützt",
"You need to apply the \"Invoice\" profile" => "Du musst das Rechnungsprofil (\"Invoice\") anwenden",
// "Remove keywords" => "Remove keywords",
// "Keywords for page \"%0\" saved" => "Keywords for page \"%0\" saved",
// "Keywords for page \"%0\" removed" => "Keywords for page \"%0\" removed",
// "Keywords were not updated" => "Keywords were not updated",
// "Featured link saved" => "Featured link saved",
// "Featured link not saved" => "Featured link not saved",
// "Non-existent link" => "Non-existent link",
// "Featured link removed" => "Featured link removed",
// "Featured link not removed" => "Featured link not removed",
"Frequency should be a positive integer" => "Häufigkeit sollte ein positiver Ganzzahlwert sein",
"Mail-in accounts set to be checked every %s minutes" => "Mail-in-Konten werden alle %s Minuten geprüft",
"Automatic Mail-in accounts checking disabled" => "Automatische Prüfung der Mail-in-Konten ist deaktiviert",
"No menu indicated" => "Kein Menü angegeben",
// "Delete menu ID %0" => "Delete menu ID %0",
// "Reset the Application Menu to the current system default" => "Reset the Application Menu to the current system default",
// "Module file in use. You need to edit %0 to configure your modules" => "Module file in use. You need to edit %0 to configure your modules",
// "%0 cache files cleared" => "%0 cache files cleared",
// "Module unassigned" => "Module unassigned",
// "Module not unassigned" => "Module not unassigned",
// "Displayed order may not change if other modules now have the same order rank" => "Displayed order may not change if other modules now have the same order rank",
// "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1" => "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1",
// "Standard module display order moved up" => "Standard module display order moved up",
// "Standard module display order not moved up" => "Standard module display order not moved up",
// "Standard module display order moved down" => "Standard module display order moved down",
// "Standard module display order not moved down" => "Standard module display order not moved down",
// "Standard display of modules reordered or moved" => "Standard display of modules reordered or moved",
// "Standard display of modules not reordered or moved" => "Standard display of modules not reordered or moved",
// "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1" => "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1",
"Cannot create or update module: You need to specify a name for the module" => "Kann kein Modul erstellen/aktualiseren: Du musst einen Namen für das Modul angeben",
"Cannot create or update module: You cannot leave the data field empty" => "Kann kein Modul erstellen/aktualiseren: Du darfst das Datenfeld nicht leer lassen",
"A module with that \"name\" already exists, please choose another" => "Ein Modul mit diesem \"Namen\" existiert bereits. Bitte wähle einen anderen",
// "Custom module created" => "Custom module created",
// "Custom module modified" => "Custom module modified",
// "Custom not module created" => "Custom not module created",
// "Custom module not modified" => "Custom module not modified",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module",
// "Module assigned" => "Module assigned",
// "Module not assigned" => "Module not assigned",
// "Custom module deleted" => "Custom module deleted",
// "Custom module not deleted" => "Custom module not deleted",
"Appearance" => "Erscheidungsbild",
"No newsletter indicated" => "Kein Newsletter angegeben",
"Newsletter does not exist" => "Newsletter existiert nicht",
// "subscription" => "subscription",
// "subscriptions" => "subscriptions",
// "No subscriptions removed" => "No subscriptions removed",
// "Subscription removed" => "Subscription removed",
// "Subscription not removed" => "Subscription not removed",
// "Subscription marked as valid" => "Subscription marked as valid",
// "Subscription not marked as valid" => "Subscription not marked as valid",
// "Errors encountered when attempting to add subscription" => "Errors encountered when attempting to add subscription",
// "Subscription added" => "Subscription added",
"Error opening uploaded file" => "Fehler beim Öffnen der hochgeladenen Datei",
// "Error importing from wiki page \"%0\"" => "Error importing from wiki page \"%0\"",
// "Wiki page \"%0\" imported" => "Wiki page \"%0\" imported",
// "Error importing from tracker ID %0" => "Error importing from tracker ID %0",
// "Tracker ID %0 imported" => "Tracker ID %0 imported",
// "Not all subscriptions created" => "Not all subscriptions created",
// "Subscriptions not created" => "Subscriptions not created",
// "Subscriptions created" => "Subscriptions created",
// "Group \"%0\" subscribed" => "Group \"%0\" subscribed",
// "Group \"%0\" not subscribed" => "Group \"%0\" not subscribed",
// "Subscribers added" => "Subscribers added",
// "Subscribers not added" => "Subscribers not added",
// "Emails from wiki page \"%0\" subscribed" => "Emails from wiki page \"%0\" subscribed",
// "Emails from wiki page \"%0\" not subscribed" => "Emails from wiki page \"%0\" not subscribed",
// "%0 \$word removed" => "%0 \$word removed",
// "Newsletter removed" => "Newsletter removed",
// "Newsletter not removed" => "Newsletter not removed",
// "Newsletter created or modified" => "Newsletter created or modified",
// "Newsletter not created or modified" => "Newsletter not created or modified",
"You need to provide a username or an email" => "Du musst einen Benutzernamen oder eine E-Mail angeben",
"The user has no email set. No notifications will be sent" => "Der Benutzer hat keine E-Mail angegeben. Es werden keine Benachrichtigungen gesendet",
// "Mail notification event added" => "Mail notification event added",
// "Mail notification event deleted" => "Mail notification event deleted",
// "One mail notification events deleted" => "One mail notification events deleted",
// "%0 mail notifications events deleted" => "%0 mail notifications events deleted",
"No poll indicated" => "Keine Abstimmung angegeben",
// "Name is required" => "Name is required",
// "Task is required" => "Task is required",
// "Run Time is required" => "Run Time is required",
// "Run Time format is invalid" => "Run Time format is invalid",
// "Status cannot be empty" => "Status cannot be empty",
// "Scheduler %s was updated" => "Scheduler %s was updated",
// "Scheduler %s was created" => "Scheduler %s was created",
// "Inactive" => "Inactive",
"unsafe" => "unsicher",
"The Path to store files in the filegallery should be outside the tiki root directory" => "Der Pfad des Dateiarchivs sollte außerhalb des Tiki-Verzeichnisses liegen.",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "Der Pfad der Bildergalerien sollte außerhalb des Tiki-Verzeichnisses liegen.",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "Die Funktion \"Vorlagen bearbeiten\" ist aktiviert. Du solltest niemandem erlauben, diese Funktion zu nutzen, dem Du nicht traust. Sie kann verwendet werden, um schadhaften Code einzuschleusen.",
"The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "Das \"Snarf Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden, um Seiten aus dem lokalen Netzwerk einzubinden und via Ersetzung mit regulären Ausdrücken (regex) beliebiges HTML zu erzeugen",
"The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement" => "Das \"Regex Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden, um beliebig HTML durch Ersetzung mit regulären Ausdrücken zu erstellen",
"The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "Das \"Lsdir Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden, um den Inhalt jedes Verzeichnisses anzusehen",
"The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "Das \"Bloglist Wikiplugin\" ist aktiviert.Es kann in Wiki Editoren genutzt werden, um die Post aus privaten Blogs aufzuzeigen",
"The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "Das \"iframe Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren für cross site scripting-Attacken genutzt werden",
"The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "Das \"js Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden um JavaScript zu nutzen, was wiederherum dazu genutzt werden kann, üble Dinge zu tun, wie z.B. cross site scripting-Attacken, etc",
"The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "Das \"JQ Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden um JavaScript zu nutzen, was wiederherum dazu genutzt werden kann, üble Dinge zu tun, wie z.B. cross site scripting-Attacken, etc",
"The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "Das \"Redirect Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren für cross site scripting-Attacken genutzt werden",
"The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)." => "Das \"Modul Wikiplugin\" ist aktiviert. Es kann von Wikieditoren genutzt werden, um Module hinzuzufügen, die Zugriff auf Informationen erlauben (siehe Modulliste)",
"The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "Das \"Userlist Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden, um eine Liste der Benutzer anzuzeigen",
"The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "Das \"Usercount Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden, um eine Anzahl der Benutzer anzuzeigen",
"The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "Das \"SQL Wikiplugin\" ist aktiviert. Es kann in Wiki Editoren genutzt werden, um SQL-Befehle auszuführen",
"risky" => "gefährlich",
// "To the extent secure logins are not required, data transmitted between the browser and server is not private" => "To the extent secure logins are not required, data transmitted between the browser and server is not private",
// "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php",
// "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php",
// "Unlocked" => "Unlocked",
// "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed" => "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed",
"Path disclosure" => "Pfadveröffentlichung",
"Path disclosure through error message" => "Pfadveröffentlichung durch Fehlermeldung",
"SQL injection" => "SQL-Injection",
"SQL injection by authenticated user" => "SQL-Injection durch authentifizierten Benutzer",
"SQL injection by authenticated user with special privileges" => "SQL-Injection durch authentifizierten Benutzer mit speziellen Rechten",
"SQL injection without authentication" => "SQL-Injection ohne Authentifizierung",
"PHP command injection" => "PHP Befehl-Injection",
"PHP command injection by authenticated user" => "PHP Befehl-Injection durch authentifizierten Benutzer",
"PHP command injection by authenticated user with special privileges" => "PHP Befehl-Injection durch authentifizierten Benutzer mit speziellen Rechten",
"PHP command injection without authentication" => "PHP Befehl-Injection ohne Authentifizierung",
"File upload" => "Datei hochladen",
"File is not readable. Unable to check." => "Diese Datei ist lesegeschützt und konnte nicht überprüft werden.",
// "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous" => "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous",
"This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "Dies ist keine Tiki-Datei. Prüfe, ob diese Datei hochgeladen wurde und ob Sie ggf. gefährlich ist",
"This is a modified File. Cannot check version. Check if it is dangerous" => "Dies ist eine veränderte Datei. Kann die Version nicht prüfen. Prüfe, ob die Datei gefährlich ist",
"This file is from another Tiki version: " => "Diese Datei stammt aus einer anderen Tiki-Version: ",
"Shoutbox Words" => "Shoutbox Wörter",
"You have to provide a word" => "Es muss ein Wort angegeben werden",
"You do not have permission to view this page." => "Zugriff verweigert. Du kannst diese Seite nicht betrachten.",
"You do not have permission to edit this page." => "Zugriff verweigert. Du kannst diese Seite nicht bearbeiten",
"You must specify a page name, it will be created if it doesn't exist." => "Ein Seitenname muss angegeben werden. Die Seite wird neu angelegt, wenn sie noch nicht vorhanden ist",
"page not added (Exists)" => "Seite nicht hinzugefügt (existiert schon)",
"No survey indicated" => "Keine Umfrage angegeben",
"Tiki Cache/Sys Admin" => "Tiki Cache/System verwalten",
"WYSIWYG Plugin" => "WYSIWYG Plugin",
"Are you sure you want to delete all your custom tools" => "Bist Du sicher, dass Du alle Deine benutzerdefinierten Werkzeuge löschen willst",
"Are you sure you want to delete this custom tool" => "Bist Du sicher, dass Du dieses benutzerdefinierte Werkzeug löschen willst",
"Are you sure you want to remove this topic" => "Bist Du sicher, dass Du dieses Thema löschen willst",
"Are you sure you want to remove this topic AND all the articles related" => "Bist Du sicher, dass Du dieses Thema und alle dazugehörigen Artikel löschen willst",
"No tracker indicated" => "Kein Tracker angegeben",
// "Tracker Fields %0" => "Tracker Fields %0",
"You don't have permission to use this feature" => "Keine Berechtigung zur Nutzung dieses Features",
// "Are you sure you want to delete the webservice \"%0\"" => "Are you sure you want to delete the webservice \"%0\"",
// "Are you sure you want to delete the template \"%0\"" => "Are you sure you want to delete the template \"%0\"",
// "Webservice error \"%0\" not saved (alpha characters only)" => "Webservice error \"%0\" not saved (alpha characters only)",
"User doesn't exist" => "Benutzer existiert nicht",
"No records were found. Check the file please!" => "Keine Einträge gefunden. Bitte die Datei überprüfen!",
"User login or email is required" => "Benutzer Login oder E-Mail erforderlich",
"User does not exist on master" => "Dieser Benutzer existiert nicht im Hauptsystem",
"User login is required" => "Benutzerlogin ist erforderlich",
"Email is required" => "E-Mail ist erforderlich",
"User is duplicated" => "Benutzer ist erforderlich",
"Created account %s <%s>" => "Konto %s <%s> angelegt",
"Assigned %s in group %s" => "%s zu Gruppe %s hinzugefügt",
// "Users added" => "Users added",
// "%0 users not added" => "%0 users not added",
"Email validation requested but email address not set" => "Die E-Mailbestätigung erfordert die Angabe der E-Mailadresse",
"The passwords do not match" => "Die Passwörter stimmen nicht überein",
"Password not set" => "Passwort nicht angegeben",
"User %s already exists" => "Benutzer %s schon vorhanden",
"User login contains invalid characters" => "Benutzerlogin beeinhaltet ungültige Zeichen",
"New user created with username %s" => "Neuer Benutzer mit Benutzernamen %s erstellt",
"Impossible to create new %s with %s %s" => "Erstellen von neuem %s mit %s %s nicht möglich",
// "User account %0 has been invalidated by the admin" => "User account %0 has been invalidated by the admin",
// "An error occurred - the user account %0 has not been invalidated by the admin" => "An error occurred - the user account %0 has not been invalidated by the admin",
// "Link to OpenID for user %0 has been removed" => "Link to OpenID for user %0 has been removed",
// "An error occurred - the link to OpenID for user %0 has not been removed" => "An error occurred - the link to OpenID for user %0 has not been removed",
// "Modify this user's data" => "Modify this user's data",
"%s changed from %s to %s" => "%s geändert von %s auf %s",
"%s modified successfully." => "%s erfolgreich geändert.",
"%s modification failed." => "%s Änderung fehlgeschlagen.",
"Impossible to change %s from %s to %s" => "Nicht möglich zu ändern %s von %s zu %s",
"email" => "E-Mail",
// "Unable to change %s from %s to %s" => "Unable to change %s from %s to %s",
"Review" => "Rezension",
"Classified" => "vertraulich",
"Failed to add attribute" => "Attribut hinzufügen fehlgeschlagen",
"rss feed disabled" => "RSS Feed nicht aktiv",
// "Are you sure you want to add user %0 to group %1" => "Are you sure you want to add user %0 to group %1",
"You have to indicate a group" => "Du musst eine Gruppe angeben",
"This group is invalid" => "Diese Gruppe ist ungültig",
// "Remote system user needs to be configured" => "Remote system user needs to be configured",
// "Remote system group for autologin need to be configured" => "Remote system group for autologin need to be configured",
// "User name needs to be specified" => "User name needs to be specified",
// "Base URL not received from remote system" => "Base URL not received from remote system",
// "Email needs to be specified" => "Email needs to be specified",
"The page cannot be found" => "Die Seite kann nicht gefunden werden",
// "Image Galleries Configuration Panel" => "Image Galleries Configuration Panel",
"Could not read image %s." => "Konnte Bilddatei %s nicht lesen.",
"Image %s upload failed" => "Hochladen des Bildes %s gescheitert",
"Image %s uploaded successfully" => "Bild %s wurde erfolgreich hochgeladen",
"Image %s removed from Batch directory" => "Bild %s wurde vom Stapelverzeichnis entfernt",
"Impossible to remove image %s from Batch directory" => "Bild %s konnte nicht vom Stapelverzeichnis entfernt werden",
"Incorrect directory chosen for batch upload of images." => "Kein gültiges Bilder-Uploadverzeichnis ausgewählt.",
"Please setup that dir on " => "Bitte lege das Verzeichnis hier fest: ",
"Please contact the website administrator" => "Bitte kontatkiere den Websiteadministrator",
"Directory batch" => "Aus Verzeichnis einlesen",
// "File Galleries Configuration Panel" => "File Galleries Configuration Panel",
"Incorrect directory chosen for batch upload of files." => "Kein gültiges Datei-Verzeichnis zum Hochladen ausgewählt.",
// "It isn't possible to post in any blog" => "It isn't possible to post in any blog",
// "You may need to create a blog first" => "You may need to create a blog first",
"You do not have permission to edit this post" => "Zugriff verweigert. Du kannst diesen Eintrag nicht bearbeiten",
"Top visited blogs" => "Meistbesuchte Blogs",
"Last posts" => "neueste Beiträge",
"Top active blogs" => "aktivste Blogs",
"No blogId specified" => "Keine blogId angegeben",
"Stop watching all categories" => "Stoppe Beobachtung aller Kategorieren",
"Watch all categories" => "Beobachte alle Kategorien",
"Group watches for all categories" => "Gruppenbeobachtung für alle Kategorien",
"Stop watching this category and its descendants" => "Stoppe Beobachtung dieser Kategorie und aller untergeordneten Kategorien",
"Watch this category and its descendants" => "Beobachte diese Kategorie und alle Unterkategorien",
"Group watches for this category" => "Gruppenüberwachung für diese Kategorie hinzufügen",
"Stop watching this category" => "Diese Kategorie nicht mehr beobachten",
"Watch this category" => "Beobachte diese Kategorie",
"Nothing tagged yet" => "Noch nichts getagged",
"You must clear your browser cache." => "Du musst Deinen Browser-Cache leeren.",
"You do not have permission to access this gallery" => "Zugriff verweigert. Du kannst auf diese Galerie nicht zugreifen.",
"No gallery indicated" => "Keine Galerie angegeben",
"You do not have permission to remove images from this gallery" => "Zugriff verweigert. Du kannst keine Bilder aus dieser Galerie entfernen",
"You do not have permission to rebuild thumbnails in this gallery" => "Neuerstellung der Thumbnails in dieser Galerie nicht gestattet",
"You do not have permission to rotate images in this gallery" => "Rotation der Bilder in dieser Galerie nicht gestattet",
"No image indicated" => "Kein Bild angegeben",
"picture not found" => "Bild nicht gefunden",
"You do not have permission to move images from this gallery" => "Zugriff verweigert. Du kannst keine Bilder aus dieser Galerie verschieben",
"You do not have permission to view the calendar" => "Berechtigung für den Zugriff auf den Kalender nicht vorhanden",
"You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "Du musst einen <a href=\"tiki-admin_calendars.php?cookietab=2\">Kalender erstellen</a>",
"event without name" => "Ereignis ohne Name",
"You do not have permission to view this page" => "Du hast nicht die notwendigen Rechte, um diese Seite anzuzeigen",
"Invalid date format" => "Ungültiges Datumsformat",
"Your PHP installation does not have calendar enabled" => "Bei Deiner PHP Installation ist Kalender nicht aktiviert",
"%H:%M %Z" => "%H:%M %Z",
"Invalid username or activation code. Maybe this code has already been used" => "Ungültiger Benutzername oder Aktivierungscode. Möglicherweise wurde dieser Code bereits benutzt",
"Your email could not be validated; make sure you email is correct" => "Deine E-Mail konnte nicht validiert werden; stelle sicher, dass Deine E-Mail richtig ist",
"You can not use the same password again" => "Es ist nicht erlaubt, dasselbe Passwort noch einmal zu verwenden",
"Invalid old password" => "Ungültiges altes Passwort",
"Invalid request. Expecting channels array" => "Ungültige Anfrage. Erwarte Kanalarray",
"Missing channel name" => "Fehlender Kanalname",
"One of the requested channels cannot be requested. It does not exist or permission is denied" => "Einer der angeforderten Kanäle kann nicht angefordert werden. Er existiert nicht oder der Zugriff wird verweigert",
"One of the install profiles could not be obtained" => "Eines der Installationsprofile konnte nicht erhalten werden",
// "info" => "info",
// "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them" => "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them",
// "How to change this value" => "How to change this value",
// "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them" => "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them",
// "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors" => "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors",
// "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information" => "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information",
// "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information" => "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information",
// "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '" => "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '",
// "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring" => "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring",
// "No errors will be reported although the error_reporting level is all the way up at ' . \$e . " => "No errors will be reported although the error_reporting level is all the way up at ' . \$e . ",
// "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information" => "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information",
// "good" => "good",
// "ini_set is used in some places to accommodate special needs of some Tiki features" => "ini_set is used in some places to accommodate special needs of some Tiki features",
// "unsure" => "unsure",
// "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning" => "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning",
// "N/A" => "N/A",
// "Unable to detect" => "Unable to detect",
// "Cannot determine the size of this disk drive" => "Cannot determine the size of this disk drive",
// "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space" => "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space",
// "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files" => "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files",
// "When the disk space is filled, users, including administrators, will not be able to log in to Tiki" => "When the disk space is filled, users, including administrators, will not be able to log in to Tiki",
// "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported" => "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported",
// "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)" => "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)",
// "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for" => "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for",
// "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see" => "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see",
// "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see" => "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see",
// "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes" => "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes",
// "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used",
// "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache" => "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache",
// "It is recommended to use Zend opcode cache as the ByteCode Cache" => "It is recommended to use Zend opcode cache as the ByteCode Cache",
// "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used",
// "The memory_limit is at" => "The memory_limit is at",
// "This is known to support smooth functioning even for bigger sites" => "This is known to support smooth functioning even for bigger sites",
// "This will normally work, but the site might run into problems when it grows" => "This will normally work, but the site might run into problems when it grows",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default" => "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default",
// "The session.save_handler should be set to 'files'" => "The session.save_handler should be set to 'files'",
// "Well set! The default setting of 'files' is recommended for Tiki" => "Well set! The default setting of 'files' is recommended for Tiki",
// "The session.save_path must writable" => "The session.save_path must writable",
// "The session.save_path is writable" => "The session.save_path is writable",
// "If you would be using the recommended session.save_handler setting of 'files\\" => "If you would be using the recommended session.save_handler setting of 'files\\",
// "It doesn't matter though, since your session.save_handler is not set to 'files'" => "It doesn't matter though, since your session.save_handler is not set to 'files'",
// "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started" => "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started",
// "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request" => "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request",
// "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start" => "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start",
// "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup" => "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup",
// "This appears to work" => "This appears to work",
// "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki" => "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki",
// "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki" => "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Correctly set! And this is also future proof as register_globals is deprecated" => "Correctly set! And this is also future proof as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Correctly set! And this is also future proof as safe_mode is deprecated" => "Correctly set! And this is also future proof as safe_mode is deprecated",
// "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior" => "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior",
// "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated" => "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated",
// "Correctly set! Tiki is fully UTF-8 and so should be this installation" => "Correctly set! Tiki is fully UTF-8 and so should be this installation",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file",
// "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a time zone set protects the site from related errors" => "Well done! Having a time zone set protects the site from related errors",
// "Files can be uploaded to Tiki" => "Files can be uploaded to Tiki",
// "Files cannot be uploaded to Tiki" => "Files cannot be uploaded to Tiki",
// "The max_execution_time is at" => "The max_execution_time is at",
// "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless" => "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless",
// "The max_execution_time is unlimited" => "The max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s",
// "The max_input_time is at" => "The max_input_time is at",
// "The max_input_time is unlimited" => "The max_input_time is unlimited",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds",
// "The max_file_uploads is at" => "The max_file_uploads is at",
// "This is the maximum number of files allowed to be uploaded simultaneously" => "This is the maximum number of files allowed to be uploaded simultaneously",
// "The maximum number of files allowed to be uploaded is not available" => "The maximum number of files allowed to be uploaded is not available",
// "The upload_max_filesize is at" => "The upload_max_filesize is at",
// "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly" => "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly",
// "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site" => "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site",
// "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site" => "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site",
// "The post_max_size is at" => "The post_max_size is at",
// "The GD extension is needed for manipulation of images and for CAPTCHA images" => "The GD extension is needed for manipulation of images and for CAPTCHA images",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case GD is not available" => "ImageMagick is used as a fallback in case GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example" => "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example",
// "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file" => "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file",
// "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it" => "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it",
// "mbstring extension is needed for an UTF-8 compatible lower case filter" => "mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "The calendar feature of Tiki will not function without this" => "The calendar feature of Tiki will not function without this",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for the dom extension (see below)" => "This extension is needed for the dom extension (see below)",
// "This extension is needed by Tiki" => "This extension is needed by Tiki",
// "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server" => "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server",
// "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17" => "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17",
// "This extension is required for H5P" => "This extension is required for H5P",
// "This extension is required for many features in Tiki" => "This extension is required for many features in Tiki",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available" => "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available",
// "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries" => "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries",
// "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL" => "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL",
// "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt" => "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt",
// "Ability to generate random numbers, useful for example for CAPTCHA and other security features" => "Ability to generate random numbers, useful for example for CAPTCHA and other security features",
// "This extension is required and used frequently in validation functions invoked within Zend Framework" => "This extension is required and used frequently in validation functions invoked within Zend Framework",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server" => "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "The max_allowed_packet setting is at" => "The max_allowed_packet setting is at",
// "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Your database supports the utf8mb4 character set required in Tiki19 and above" => "Your database supports the utf8mb4 character set required in Tiki19 and above",
// "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation" => "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation",
// "Tiki is fully utf8mb4 and so should be every part of the stack" => "Tiki is fully utf8mb4 and so should be every part of the stack",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified" => "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified",
// "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki" => "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down" => "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down",
// "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down" => "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down",
// "ON" => "ON",
// "OFF" => "OFF",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki",
// "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess" => "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess",
// "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"" => "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"",
// "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again" => "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again",
// "Not Working" => "Not Working",
// "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki" => "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki",
// "Working" => "Working",
// "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs" => "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly",
// "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly",
// "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "Not Installed" => "Not Installed",
// "Tesseract PHP package could not be found. Try installing through Packages" => "Tesseract PHP package could not be found. Try installing through Packages",
// "Tesseract PHP dependency installed" => "Tesseract PHP dependency installed",
// "The installed Tesseract version is lower than the required version" => "The installed Tesseract version is lower than the required version",
// "Tesseract package" => "Tesseract package",
// "languages installed" => "languages installed",
// "Not all languages installed. You may need to install additional languages for multilingual support" => "Not all languages installed. You may need to install additional languages for multilingual support",
// "Tesseract languages" => "Tesseract languages",
// "Tesseract could not be found" => "Tesseract could not be found",
// "Tesseract meets or exceeds the version requirements" => "Tesseract meets or exceeds the version requirements",
// "Tesseract binary" => "Tesseract binary",
// "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path" => "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path",
// "Path setup correctly" => "Path setup correctly",
// "Your path may not be configured correctly. It appears to be located at " => "Your path may not be configured correctly. It appears to be located at ",
// "Your path is configured, but we were unable to tell if it was configured properly or not" => "Your path is configured, but we were unable to tell if it was configured properly or not",
// "Tesseract path" => "Tesseract path",
// "Pdfimages path" => "Pdfimages path",
// "Scheduler has been successfully setup" => "Scheduler has been successfully setup",
// "Scheduler needs to have a console command of \"ocr:all\" set" => "Scheduler needs to have a console command of \"ocr:all\" set",
// "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser" => "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser",
// "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration" => "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration",
"safe" => "sicher",
// "WebKit is enabled" => "WebKit is enabled",
// "The Blogs feature is enabled" => "The Blogs feature is enabled",
// "Exec can potentially be used to execute arbitrary code on the server" => "Exec can potentially be used to execute arbitrary code on the server",
// "Tiki does not need it; perhaps it should be disabled" => "Tiki does not need it; perhaps it should be disabled",
// "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled" => "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled",
// "Exec can be potentially be used to execute arbitrary code on the server" => "Exec can be potentially be used to execute arbitrary code on the server",
// "Tiki needs it to run the Plugins R/RR" => "Tiki needs it to run the Plugins R/RR",
// "If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "System is similar to exec" => "System is similar to exec",
// "Tiki does not need it; it is good that it is disabled" => "Tiki does not need it; it is good that it is disabled",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "popen is similar to exec" => "popen is similar to exec",
// "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
// "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature" => "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature",
// "session.use_trans_sid should be off by default. See the PHP manual for details" => "session.use_trans_sid should be off by default. See the PHP manual for details",
// "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them" => "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them",
// "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off" => "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off",
// "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information",
// "To manage this instance from a remote server you need SSH or FTP access to this server" => "To manage this instance from a remote server you need SSH or FTP access to this server",
// "Command found" => "Command found",
// "Command not found, check if it is installed and available in one of the paths above" => "Command not found, check if it is installed and available in one of the paths above",
// "Extension loaded in PHP" => "Extension loaded in PHP",
// "Extension not loaded in PHP" => "Extension not loaded in PHP",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered" => "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered",
// "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php" => "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php",
// "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts" => "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
// "The intl extension is required for Tiki 15 and newer" => "The intl extension is required for Tiki 15 and newer",
// "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters" => "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters",
// "Congratulations!\n\nThis server can send emails.\n\n" => "Congratulations!\n\nThis server can send emails.\n\n",
// "The path '%0' on preference '%1' does not exist" => "The path '%0' on preference '%1' does not exist",
// "The lib '%0' on preference '%1', option '%2' does not exist" => "The lib '%0' on preference '%1', option '%2' does not exist",
// "The class '%0' needed for preference '%1', with option '%2' selected, does not exist" => "The class '%0' needed for preference '%1', with option '%2' selected, does not exist",
// "The extension '%0' on preference '%1', with option '%2' selected, is not loaded" => "The extension '%0' on preference '%1', with option '%2' selected, is not loaded",
"Top authors" => "Top Autoren",
// "User %0 validated by the admin" => "User %0 validated by the admin",
"Problem. Try to log in again to receive new confirmation instructions" => "Problem. Versuche erneut Dich anzumelden, um neue Bestätigungsanweisungen zu erhalten",
"Invalid" => "Ungültig",
"You must include a subject or a message" => "Du musst einen Betreff oder eine Nachricht angeben",
"You must make sure to have a valid email address in the From field" => "Du musst eine gültige E-Mail-Adresse im Von-Feld angeben",
"%0 sent you a message" => "%0 hat Dir eine Nachricht gesendet",
"last version" => "neueste Version",
"Cannot rename page because the new name begins with reserved prefix" => "Kann Seite nicht umbenennen, weil der neue Name mit einer reservierten Präfix beginnt",
"Cannot copy page because maybe new page name already exists" => "Kann Seite nicht kopieren weil möglicherweise die neue Seite bereits existiert",
"TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHilfe WebHilfe Erstellungsmaschine. Erstelle WebHilfe mittels",
"Eliminating previous files" => "Entferne frühere Dateien",
"Index: <strong>%0</strong>" => "Index: <strong>%0</strong>",
"Directory: <strong>%0</strong>" => "Verzeichnis: <strong>%0</strong>",
// "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix" => "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix",
"You need to change chmod 'whelp' manually to 777" => "Du musst mit chmod 'whelp' manuell auf 777 setzen",
"Creating directory structure in <strong>%0</strong>" => "Erstelle Verzeichnisstruktur in <strong>%0</strong>",
"Submit a new link" => "Neuen Link einreichen",
"Must enter a name to add a site. " => "Ein Seitenname muss angegeben werden. ",
"Must enter a url to add a site. " => "Eine URL muss angegeben werden. ",
"URL already added to the directory. Duplicate site? " => "URL schon im Verzeichnis vorhanden. Doppelter Eintrag? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verfügbar und kann daher nicht zum Linkverzeichnis hinzugefügt werden. ",
"Must select a category. " => "Eine Kategorie muss ausgewählt werden. ",
"Must enter a name to add a site" => "Zum Hinzufügen mu&szlig der Name der Site angegeben werden",
"Must enter a url to add a site" => "Die URL der Site muss angegeben werden",
"URL already added to the directory. Duplicate site?" => "URL im Verzeichnis schon vorhanden. Doppelter Eintrag?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verfügbar und kann daher nicht zum Linkverzeichnis hinzugefügt werden",
"Must select a category" => "Eine Kategorie muss ausgewählt werden",
"Browse Directory" => "Verzeichnis durchstöbern",
"How to use Directory" => "Wie das Linkverzeichnis zu benutzen ist",
"No site indicated" => "Kein Site angegeben",
"This feature is disabled: %0" => "Diese Funktion ist deaktiviert: %0",
"No parent specified" => "Übergeordnetes nicht angegeben",
"Latest sites of directory %0" => "Die letzten Sites des Verzeichnisses %0",
"Discount code already exists" => "Diskontocode existiert bereits",
// "Invalid fileId. Please provide a valid fileId to preview a specific file" => "Invalid fileId. Please provide a valid fileId to preview a specific file",
// "Unable to display file" => "Unable to display file",
"File has been deleted" => "Datei wurde gelöscht",
"You cannot download this file right now. Your score is low or file limit was reached" => "Du kannst diese Datei aktuell nicht herunterladen. Dein Punktestand ist zu niedrig oder die Dateibeschränkung wurde erreicht",
// "File locked" => "File locked",
// "File not locked" => "File not locked",
"Error : The file %s doesn't exist" => "Fehler : die Datei %s existiert nicht",
"Article not found" => "Artikel nicht gefunden",
"You do not have permission to edit this article" => "Zugriff verweigert. Du kannst diesen Artikel nicht bearbeiten",
"The language can't be changed as its set of translations has already this language" => "Die Sprache kann nicht geändert werden, da ihre Übersetzungen bereits in dieser Sprache sind",
"Banner not found" => "Banner nicht gefunden",
"You do not have permission to edit this banner" => "Du hast keine Berechtigung dieses Banner zu bearbeiten",
"You do not have permission to edit this blog" => "Zugriff verweigert. Du kannst diesen Blog nicht bearbeiten",
// "No filters applied" => "No filters applied",
// "You do not have permission to write the css file" => "You do not have permission to write the css file",
// "Wrong file type, expected one of %0" => "Wrong file type, expected one of %0",
"You do not have permission to view/edit this file" => "Du hast keine Berechtigung diese Datei anzusehen/zu bearbeiten",
" drawing" => " zeichnen",
"Wrong file type, expected %0" => "Falscher Dateityp. Erwartet wurde %0",
"New Svg Image" => "Neues SVG-Bild",
"Invalid request to edit an image" => "Ungültige Anforderung zur Bearbeitung eines Bildes",
"You have permission to edit images but not in this gallery" => "Zugriff verweigert. Du kannst Bilder bearbeiten, jedoch nicht in dieser Galerie",
"Failed to edit the image" => "Bearbeitung des Bildes fehlgeschlagen",
"Edit or export languages" => "Sprache bearbeiten oder exportieren",
"Edit Perspectives" => "Perspektiven bearbeiten",
"No content id indicated" => "Keine Inhalts-ID angegeben",
"No question indicated" => "Keine Frage angegeben",
"No quiz indicated" => "Kein Quiz angegeben",
// "View this wiki page" => "View this wiki page",
"No structure indicated" => "Keine Struktur angegeben",
"Invalid structure_id or page_ref_id" => "Ungültige structure_id oder page_ref_id",
"You do not have permission to edit submissions" => "Zugriff verweigert. Du kannst Einreichungen nicht bearbeiten",
"You have to create a topic first" => "Du musst zuerst ein Thema erstellen",
"Template directory %0 unknown" => "Vorlagenverzeichnis (%0) unbekannt",
"You do not have permission to do that" => "Du hast nicht die Berechtigung, das zu tun",
"You do not have permission to write the template" => "Du hast keine Berechtigungen, die Vorlage zu schreiben",
"You do not have permission to read the template" => "Du hast keine Berechtigung, die Vorlage zu lesen",
"No topic id specified" => "Keine Themen-ID angegeben",
"Invalid topic id specified" => "Ungültige Themen-ID angegeben",
"No object indicated" => "Kein Objekt angegeben",
"Only wiki pages are supported" => "Es werden nur Wiki Seiten unterstützt",
// "Forbidden" => "Forbidden",
// "New diagram" => "New diagram",
// "Edit diagram" => "Edit diagram",
"Override lock and carry on with edit" => "Sperre überschreiten und mit Bearbeiten fortfahren",
"Page is currently being edited" => "Seite wird gegenwärtig bearbeitet",
"page imported" => "Seite importiert",
"created from import" => "aus Import erstellt",
// "To review the changes you have just made %0compare the versions%1 in history of this page" => "To review the changes you have just made %0compare the versions%1 in history of this page",
// "Page %0 saved (version %1)" => "Page %0 saved (version %1)",
"This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "Diese Seite wird von %0 bearbeitet. Bitte setze Dich mit dem Benutzer in Verbindung, bevor Du die Seite bearbeitest.\tAndernfalls werden die Änderungen in zwei getrennten Versionen in der Historie gespeichert. Die Inhalt müssen dann manuelle zusammengeführt werden",
"Can't import remote HTML page" => "Kann externe HTML-Seite nicht importieren",
"The Sandbox is disabled" => "Die SandBox ist deaktiviert",
"The page cannot be edited because it is locked" => "Seite kann wegen Sperrung nicht bearbeitet werden",
"That page already exists. Go back and choose a different name" => "Seite existiert bereits. Gehe zurück und wähle einen anderen Namen",
"The page name is" => "Der Seitenname ist",
"The translation set already contains a page in this language" => "Der Übersetzungsssatz enthält bereits eine Seite in dieser Sprache",
"The file cannot be opened" => "Kann Datei nicht öffnen",
"Problem zip initialisation" => "Probleme bei ZIP-Initialisierung",
"Problem zip" => "ZIP-Problem",
"Another user is currently exporting that tracker. Please try again later" => "Ein anderer Benutzer exportiert gerade diesen Tracker. Versuche es bitte später nochmals",
"No questions group indicated" => "Keine FAQ-Gruppe angegeben",
"Remove archive: " => "Entferne Archiv: ",
"Remove file gallery: " => "Entferne Dateiarchiv: ",
"You do not have permission to edit this file" => "Berechtigung zum Bearbeiten dieser Datei nicht vorhanden",
"Most-visited file galleries" => "Meistbesuchte Dateiarchive",
"Most downloaded files" => "Häufigste Downloads",
"Last files" => "Neueste Dateien",
"No gallery ID specified" => "Keine galleryId angegeben.",
"Form error - no import method selected for some reason" => "Formularfehler - aus irgendeinem Grund wurde keine Importmethode gewählt",
"Form error - no server-side filename entered for selected import method" => "Formularfehler - kein serverseitiger Dateiname für die gewählte Importmethode eingegeben",
"No forum indicated" => "Kein Forum angegeben",
"Last forum topics" => "Neueste Forenthemen",
"Last replied forum topics" => "Forenthemen auf die zuletzt geantwortet wurde",
"Most-Read Forum Topics" => "Meistgelesene Themen",
"Top topics" => "Top Themen",
"Forum posts" => "Zahl der Einträge",
"Most-Visited Forums" => "Meistbesuchte Foren",
"No forumId specified" => "Keine forumId angegeben",
"List Forums" => "Foren auflisten",
"Not supported yet" => "noch nicht unterstützt",
// "All files copied" => "All files copied",
"id" => "ID",
"first uploaded image" => "erstes hochgeladenes Bild",
"last uploaded image" => "neustes Bild",
"first image" => "erstes Bild",
"last image" => "neuestes Bild",
"random image" => "zufälliges Bild",
"You do not have permission to create galleries and so you cannot edit them" => "Zugriff verweigert. Du kannst Galerien nicht erzeugen, also auch nicht bearbeiten",
"You do not have permission to edit this gallery" => "Zugriff verweigert. Du kannst diese Galerie nicht bearbeiten",
"You do not have permission to remove this gallery" => "Zugriff verweigert. Du kannst diese Galerie nicht löschen",
"Top images" => "Top Bilder",
"Last images" => "Neueste Bilder",
"No valid renderer found. GD or PDFLib required" => "Kein gültiger Renderer gefunden. GD oder PDFLib erforderlich",
"No sheet specified" => "Kein Tabellenblatt angegeben",
// "Unknown Graphic" => "Unknown Graphic",
// "Unknown Renderer" => "Unknown Renderer",
"You must select a renderer" => "Du musst einen Renderer angeben",
"Invalid Series for current graphic" => "Ungültige Serie für gegenwärtige Graphik",
"overwriting old page" => "überschreibe alte Seite",
"updated from structured text import" => "aus strukturiertem Textimport aktualisiert",
"page created" => "Seite erstellt",
"created from structured text import" => "aus strukturiertem Textimport erstellt",
// "Unable to locate import file" => "Unable to locate import file",
// "Pages in zip file %0 successfully imported" => "Pages in zip file %0 successfully imported",
"Invalid software name" => "Ungütliger Softwarename",
// "No wiki page specified" => "No wiki page specified",
"This version does not exist" => "Diese Version existiert nicht",
"There is more than one item in the tracker with this title" => "Es existieren mehrere Einträge in dem Tracker mit diesem Titel",
"There are no items in the tracker with this title" => "In dem Tracker mit diesem Titel sind keine Einträge vorhanden",
// "Are you sure you want to undo the last change" => "Are you sure you want to undo the last change",
// "There is nothing to undo" => "There is nothing to undo",
"You have requested that this page be machine translated" => "Du hast eine maschinelle Übersetzung dieser Seite angefordert",
"However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "Allerdings ist das maschinelle Überetzen nicht aktiviert. Aktiviere diese Funktion oder bitte einen Site Administrator es zu tun",
"No repository given" => "Kein Repository angegeben",
"This invitation does not exist or is deprecated" => "Diese Einladung existiert nicht oder ist veraltet",
"Congratulations! You are now part of this invitation group(s)" => "Gratulation! Du bist nun Teil dieser Einladungsgruppe(n)",
"Communication error" => "Kommunikationsfehler",
"Invalid response provided by the Kaltura server. Please retry" => "Ungültige Antwort vom Kaltura-Server. Bitte nochmal versuchen",
"Are you sure you want to permanently remove the article with identifier %0" => "Bist Du sicher, dass Du den Artikel mit der ID %0 permanent löschen willst",
"Are you sure you want to permanently remove these %0 articles" => "Bist Du sicher, dass Du diese %0 Artikel permanent löschen willst",
"You do not have permission to remove articles" => "Zugriff verweigert. Du kannst Artikel nicht entfernen",
"You do not have permission to remove banners" => "Zugriff verweigert. Du kannst keine Banner entfernen",
"List Blog Posts" => "Liste Blog-Einträge",
"You do not have permission to remove this blog" => "Zugriff verweigert. Du kannst diesen Blog nicht entfernen",
"You do not have permission to view the comments for this blog" => "Du hast keine Berechtigung, um die Kommentare zu diesem Blog einzusehen",
// "The following comment has been deleted" => "The following comment has been deleted",
// "The following comments have been deleted" => "The following comments have been deleted",
// "Delete selected comments and ban" => "Delete selected comments and ban",
// "Users have been pre-selected for banning in the highlighted section of the form below" => "Users have been pre-selected for banning in the highlighted section of the form below",
// "One comment approved" => "One comment approved",
// "%0 comments approved" => "%0 comments approved",
// "No comments approved" => "No comments approved",
// "One comment rejected" => "One comment rejected",
// "%0 comments rejected" => "%0 comments rejected",
// "No comments rejected" => "No comments rejected",
// "Comment archived" => "Comment archived",
// "%0 comments archived" => "%0 comments archived",
// "No comments archived" => "No comments archived",
// "Comment unarchived" => "Comment unarchived",
// "%0 comments unarchived" => "%0 comments unarchived",
// "No comments unarchived" => "No comments unarchived",
// "Action not performed since no comments were selected" => "Action not performed since no comments were selected",
"Approved Status" => "Freigabestatus",
"This blog has no posts." => "Dieser Blog hat keine Einträge.",
"Dynamic content" => "Dynamische Inhalte",
"Admin FAQs" => "FAQs verwalten",
"Non-existent gallery" => "Nicht existierende Galerie",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
// "One item moved" => "One item moved",
// "%0 items moved" => "%0 items moved",
// "No items moved" => "No items moved",
// "One item moved and one item failed to move" => "One item moved and one item failed to move",
// "One item moved and %0 items failed to move" => "One item moved and %0 items failed to move",
// "%0 items moved and one item failed to move" => "%0 items moved and one item failed to move",
// "%0 items moved and %0 items failed to move" => "%0 items moved and %0 items failed to move",
// "One item deleted" => "One item deleted",
// "%0 items deleted" => "%0 items deleted",
// "No items deleted" => "No items deleted",
// "One item deleted and one item failed to delete" => "One item deleted and one item failed to delete",
// "One item deleted and %0 items failed to delete" => "One item deleted and %0 items failed to delete",
// "%0 items deleted and one item failed to delete" => "%0 items deleted and one item failed to delete",
// "%0 items moved and %0 items failed to delete" => "%0 items moved and %0 items failed to delete",
// "List view settings reset for one gallery" => "List view settings reset for one gallery",
// "List view settings reset for %0 galleries" => "List view settings reset for %0 galleries",
// "List view settings not changed for the selected gallery" => "List view settings not changed for the selected gallery",
// "List view settings not changed for the %0 selected galleries" => "List view settings not changed for the %0 selected galleries",
// "List view settings reset for %0 galleries and not changed for one gallery" => "List view settings reset for %0 galleries and not changed for one gallery",
// "List view settings reset for %0 galleries and not changed for %0 galleries" => "List view settings reset for %0 galleries and not changed for %0 galleries",
// "No files selected" => "No files selected",
// "Metadata refreshed for one file" => "Metadata refreshed for one file",
// "Metadata refreshed for %0 files" => "Metadata refreshed for %0 files",
// "Metadata not refreshed" => "Metadata not refreshed",
// "Metadata refreshed for one file and not refreshed for one file" => "Metadata refreshed for one file and not refreshed for one file",
// "Metadata refreshed for one file and not refreshed for %0 files" => "Metadata refreshed for one file and not refreshed for %0 files",
// "Metadata refreshed for %0 files and not refreshed for one file" => "Metadata refreshed for %0 files and not refreshed for one file",
// "Metadata refreshed for %0 files and not refreshed for %0 files" => "Metadata refreshed for %0 files and not refreshed for %0 files",
// "Incorrect file ID" => "Incorrect file ID",
"The file is already locked by %s" => "Diese Datei ist bereits gesperrt von %s",
// "File unlocked" => "File unlocked",
// "File not unlocked" => "File not unlocked",
// "Files in this gallery are not lockable" => "Files in this gallery are not lockable",
"You don't have permission to validate files from this gallery" => "Erlaubnis verweigert. Du kannst keine Dateien aus diesem Archiv validieren",
// "Error retrieving file" => "Error retrieving file",
// "Draft validated" => "Draft validated",
// "Validation failed" => "Validation failed",
// "File deleted" => "File deleted",
// "File not deleted" => "File not deleted",
// "Metadata refreshed" => "Metadata refreshed",
// "You need upload permission to edit files" => "You need upload permission to edit files",
// "You need permission to create galleries to edit them" => "You need permission to create galleries to edit them",
// "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode" => "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode",
"Quota too big" => "Kontingent zu gross",
"Quota too small" => "Kontingent zu klein",
// "Gallery %0 created or modified" => "Gallery %0 created or modified",
// "Gallery %0 not created or modified" => "Gallery %0 not created or modified",
// "You do not have permission to duplicate this gallery" => "You do not have permission to duplicate this gallery",
// "Gallery duplicated" => "Gallery duplicated",
// "Gallery not duplicated" => "Gallery not duplicated",
// "Remove file gallery %0" => "Remove file gallery %0",
// "Incorrect gallery ID" => "Incorrect gallery ID",
// "Gallery %0 deleted" => "Gallery %0 deleted",
// "Gallery %0 not deleted" => "Gallery %0 not deleted",
"Could not find the file requested" => "Konnte die angegebene Datei nicht finden",
// "File %0 updated" => "File %0 updated",
// "File %0 not updated" => "File %0 not updated",
// "Invalid %0 parameter" => "Invalid %0 parameter",
// "File %0 not found" => "File %0 not found",
// "User watch added" => "User watch added",
// "User watch not added" => "User watch not added",
// "User watch removed" => "User watch removed",
// "User watch not removed" => "User watch not removed",
// "Not modified for" => "Not modified for",
// "Not downloaded for" => "Not downloaded for",
"This gallery does not exist" => "Diese Galerie ist nicht vorhanden",
"Error importing" => "Fehler bei Import",
"Error converting" => "Fehler beim Konvertieren",
"Importing" => "Importiere",
"Processing" => "Zugreifen",
"Ready" => "Fertig",
"Pending moderation" => "Wartende Moderation",
"Blocked" => "Blockiert",
"Invalid action" => "Ungültige Aktion",
"Remove permission %0 from %1" => "Entferne Berechtigung %0 von %1",
"Assign permission %0 to %1" => "Weise Berechtigung %0 zu %1 zu",
// "Delete posts" => "Delete posts",
"View submissions" => "Einreichungen ansehen",
"Are you sure you want to permanently remove the submitted article with identifier %0" => "Bist Du sicher, dass Du den eingerechten Artikel mit der ID %0 dauerhaft löschen willst",
"Are you sure you want to permanently remove these %0 submitted articles" => "Bist Du sicher, dass Du diese %0 eingereichten Artikel dauerhaft löschen willst",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to permanently remove all expired submitted articles" => "Are you sure you want to permanently remove all expired submitted articles",
// "Pages not in a structure" => "Pages not in a structure",
"You are neither an administrator nor an operator of live support" => "Du bist weder ein Administrator noch ein Operator des Live-Support",
"Username field cannot be empty. Please go back and try again" => "Das Feld Benutzername darf nicht leer bleiben. Bitte gehe zurück und versuche es erneut",
"Unable to contact remote server" => "Kann auf den Fernserver nicht zugreifen",
"XMLRPC Error: " => "XMLRPC-Fehler: ",
"Unable to create login" => "Kann Login nicht erstellen",
// "No groups set on Intertiki client" => "No groups set on Intertiki client",
// "%d or more unsuccessful login attempts have been made" => "%d or more unsuccessful login attempts have been made",
"Your account has been suspended" => "Dein Konto wurde gesperrt",
// "Contact your site administrator to reactivate it" => "Contact your site administrator to reactivate it",
"An email has been sent to you with the instructions to follow" => "Eine E-Mail mit Anweisungen wurde an Dich gesandt",
"Account requires administrator approval" => "Konto deaktiviert",
"You did not validate your account" => "Du hast Dein Konto nicht validiert",
"Resend" => "Nochmal senden",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "Du solltest eine E-Mail erhalten haben. Bitte prüfe Dein Postfach und Deinen Spam-Ordner. Andernfalls klicke auf nochmal senden",
"You must use the right case for your username" => "Du musst Groß- und Kleinschreibung in Deinem Benutzernamen beachten",
"You are not yet validated" => "Du bist noch nicht validiert",
"You are already logged in" => "Du bist bereits angemeldet",
// "Authentication error" => "Authentication error",
"The mail can't be sent. Contact the administrator" => "Die E-Mail kann nicht gesendet werden. Kontaktiere den Administrator",
// "There is more than one user account with this email. Please contact the administrator" => "There is more than one user account with this email. Please contact the administrator",
"Your default nickname is already in use. A new one has to be selected" => "Dein Standard-Kurzname wird bereits benutzt. Ein neuer muss gewählt werden",
"Verification cancelled" => "Überprüfung abgebrochen",
"The selected account is not associated with your identity" => "Das ausgewählte Konto ist nicht mit Deiner Identität verküpft",
"unknown action" => "unbekannte Aktion",
"Authentication method is not OpenID" => "Authentifizierungsmethode ist nicht OpenID",
"Authentication error; probably not a valid OpenID" => "Authentifizierungsfehler; möglicherweise keine gültige OpenID",
"Could not redirect to server: " => "Kann nicht weiterleiten auf Server: ",
"OpenID authentication failed: " => "OpenID Authentifizierung fehlgeschlagen: ",
"You have already validated your account. Please log in" => "Du hast Dein Konto bereits bestätigt. Bitte melde Dich an",
"No page provided" => "Keine Seite angegeben",
// "User module unassigned" => "User module unassigned",
// "User module not unassigned" => "User module not unassigned",
// "User module moved up" => "User module moved up",
// "User module not moved up" => "User module not moved up",
// "User module moved down" => "User module moved down",
// "User module not moved down" => "User module not moved down",
// "User module moved to opposite side" => "User module moved to opposite side",
// "User module not moved to opposite side" => "User module not moved to opposite side",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
"You must log in to use this feature" => "Du musst Dich anmelden, um diese Funktion zu nutzen",
"\$tikiMonitorRestriction need to be an array" => "\$tikiMonitorRestriction muss ein Array sein",
"My Account Home" => "Meine Tiki-Startseite",
"You do not have permission to view other users data" => "Du hast keine Berechtigung, die Daten anderer Benutzer einzusehen",
// "Subscription confirmed for newsletter %0 (%1)" => "Subscription confirmed for newsletter %0 (%1)",
// "Subscription request failed" => "Subscription request failed",
// "You have been unsubscribed from newsletter %0" => "You have been unsubscribed from newsletter %0",
// "Your request to unsubscribe failed" => "Your request to unsubscribe failed",
"You must be logged in to subscribe to newsletters" => "Du musst eingeloggt sein, um Newsletter abonnieren zu können",
// "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter" => "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter",
// "Newsletter not subscribed" => "Newsletter not subscribed",
"No note indicated" => "Keine Notiz angegeben",
"merged note" => "zusammengefügte Nachricht",
"The file is too large" => "Datei ist zu groß",
"No item indicated" => "Kein Objekt angegeben",
"Are you sure you want to delete this note" => "Bist Du sicher, dass Du diese Nachricht löschen willst",
"created from notepad" => "Aus dem Notitzblock erstellt",
"Note not found" => "Nachricht nicht gefunden",
"No name indicated for wiki page" => "Kein Name für die Wiki-Seite angegeben",
"Not enough information to display this page" => "Nicht genug Informationen, um diese Seite anzuzeigen",
"You do not have permission to assign permissions for this object" => "Du hast keine Berechtigungen, um dem Objekt Rechte zuzuweisen",
// "Are you sure you want to modify permissions" => "Are you sure you want to modify permissions",
// "%0 and all the children groups" => "%0 and all the children groups",
"Are you sure you want to remove the direct permissions from this object" => "Bist Du sicher, dass Du die direkten Berechtigungen von diesem Objekt entfernen möchtest",
"Are you sure you want to paste the copied permissions into this object" => "Bist Du sicher, dass Du die kopierten Rechte auf dieses Objekt anwenden willst",
// "Error while processing payment: " => "Error while processing payment: ",
// "Payment has been confirmed" => "Payment has been confirmed",
// "Payment confirmation has not been received yet" => "Payment confirmation has not been received yet",
"Manual payment entered" => "Manuelle Zahlung eingegeben",
"You do not have permission to enter payment" => "Du hast keine Berechtigungen, um eine Zahlung einzugeben",
"New payment requested" => "Neue Zahlungsanfrage",
"Cancel payment %0" => "Breche Zahlung %0 ab",
"Payment canceled" => "Bezahlung abgebrochen",
// "You need permission to edit pages in order to experiment on plugin LIST" => "You need permission to edit pages in order to experiment on plugin LIST",
// "No preference given" => "No preference given",
// "This preference is not translatable" => "This preference is not translatable",
"No article indicated" => "Kein Artikel angegeben",
"Article is not published yet" => "Artikel ist noch nicht veröffentlicht",
"No post indicated" => "Kein Posting angegeben",
"Blog not found" => "Blog nicht gefunden",
"Missing object list type argument" => "Fehlendes Objektlistentypargument",
"Index (%0)" => "Index (%0)",
"No pages indicated" => "Keine Seiten angegeben",
"Multiple Print" => "Multipler Druck",
"Pageviews" => "Seitenaufrufe",
"No result indicated" => "Kein Ergebnis angegeben",
"Invalid or unknown username" => "Ungültiger oder unbekannter Benutzername",
"Unable to send mail. User has not configured email" => "Kann E-Mail nicht senden. Der Benutzer hat E-Mail nicht konfiguriert",
"Invalid or unknown email address" => "Ungültige oder unbekannte E-Mail",
"Please provide a username or email address" => "Bitte gib Deinen Benutzernamen oder Deine E-Mail an",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Bitte kontaktiere den Administrator, wenn Du die E-Mail nicht erhältst, oder sonst ein Problem mit dem Zurücksetzen Deines Passworts auftritt",
"An email with a link to reset your password has been sent " => "Eine E-Mail zur Zurücksetzung Deines Passworts wurde gesendet ",
"to the email" => "zu der E-Mail",
"to the registered email address for" => "an die registrierte E-Mailadresse für",
// "Rename wiki page" => "Rename wiki page",
// "Page renamed from %0 to %1. Semantic alias redirect created" => "Page renamed from %0 to %1. Semantic alias redirect created",
// "Are you sure you want to roll back \"%0\" to version #%1" => "Are you sure you want to roll back \"%0\" to version #%1",
"Non-existent version" => "Nicht existierende Version",
"Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Fehlermeldung: %0",
"This match was not case sensitive" => "Diese Übereinstimmung ist nicht auf Groß-/Kleinschreibung geprüft",
"No items selected" => "Keine Objekte gewählt",
"Page cannot be found: " => "Seite nicht gefunden: ",
"Page has changed since preview: " => "Seite wurde seit Vorschau geändert: ",
"Page not updated due to error in replacing: " => "Seite wurde aufgrund eines Fehlers beim Ersetzen nicht aktualisiert: ",
"Page updated: " => "Seite aktualisiert: ",
"Search Stats" => "Suchstatistiken",
"%0: Results for \"%1\"" => "%0: Ergebnis für \"%1\"",
// "Your query was stored" => "Your query was stored",
"Searchindex" => "Suchindex",
"A problem occurred during file uploading" => "Ein Problem ist beim Datei hochladen aufgetreten",
// "File causing trouble was at rank" => "File causing trouble was at rank",
// "The error was %0" => "The error was %0",
"Error: You can't send the same newsletter by refreshing this frame content" => "Fehler: Du kannst den Newsletter nicht nochmals durch Aktualisierung des Inhalts senden",
"No newsletters available." => "Keine Newsletter vorhanden.",
"Cannot login to server maybe the server is down" => "Kann nicht am Server annmelden. Der Server ist möglicherweise nicht aktiv",
"successfully sent" => "erfolgreich verschickt",
"not sent" => "nicht verschickt",
"Error: " => "Fehler: ",
"Send Pages" => "Seiten verschicken",
"Notice: this variable may not be empty" => "Hinweis: diese Variable darf nicht leer sein",
"Notice: invalid variable value" => "Hinweis: ungültiger Variablenwert",
"Report to the webmaster" => "Berichte dem Webmaster",
"Token called" => "Token aufgerufen",
"Error sending tweet" => "Fehler beim senden des Tweet",
"Your link was sent" => "Dein Link wurde gesendet",
"One of the email addresses that was input is invalid" => "Eine der eingegebenen E-Mailadressen ist ungültig",
"Your email is mandatory" => "Die Angabe Deiner E-Mail ist erforderlich",
"Error sending mail to" => "Fehler beim Senden der E-Mail an",
"Share page" => "Share Seite",
"No text given for tweet" => "Kein Text zum twittern",
"You don't have permission to post in this forum" => "Erlaubnis in das Forum zu posten verweigert",
"Spreadsheet - " => "Tabellenkalkulation - ",
"Are you sure you want to delete this spreadsheet?" => "Bist Du sicher, dass Du diese Tabelle löschen willst?",
// "URL provided is empty or unsupported" => "URL provided is empty or unsupported",
// "Unable to generate a short url for the requested resource" => "Unable to generate a short url for the requested resource",
// "'%0' short url" => "'%0' short url",
"You do not have permission to edit messages %0" => "Du hast nicht die Berechtigung die Nachrichten von %0 zu bearbeiten",
// "Sitemap file not available" => "Sitemap file not available",
// "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator" => "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator",
// "Exporting slideshow as PDF requires a working installation of mPDF" => "Exporting slideshow as PDF requires a working installation of mPDF",
// "Export to PDF error: %0" => "Export to PDF error: %0",
"Permission denied. You cannot view this page" => "Zugriff verweigert. Du kannst diese Seite nicht ansehen",
// "Email is mandatory" => "Email is mandatory",
"Username and email are mandatory" => "Benutzername und E-Mail sind erforderlich",
"The email address is invalid" => "E-Mail ist ungültig",
"Clean the sql logs" => "Lösche die SQL-Logs",
"Are you sure you want to clear all statistics and data for this survey" => "Bist Du sicher, dass Du alle Statistiken und Daten für diese Umfrage löschen willst",
// "The following list of changes has been reverted" => "The following list of changes has been reverted",
// "Log already reverted" => "Log already reverted",
// "Invalid System Log ID" => "Invalid System Log ID",
"You cannot take this quiz twice" => "Du kannst dieses Quiz nicht zweimal durchführen",
"The quiz time limit was exceeded. The quiz score cannot be computed" => "Quizzeit überschritten. Quiz kann nicht gewertet werden",
"You cannot take this survey twice" => "Du kannst nicht zweimal an dieser Umfrage teilnehmen",
"Please create a category first" => "Bitte erst eine Kategorie anlegen",
"Committing.." => "Übertrage..",
"Could not save" => "Konnte nicht speichern",
"No trackerId specified" => "Keine trackerId angegeben",
"Incorrect file gallery" => "Falsches Dateiarchiv",
"You must lock the file before editing it" => "Du musst die Datei sperren, bevor Du sie bearbeitest",
"Error processing zipped image package" => "Fehler beim Verarbeiten der gepackten Bilddateien",
"No permission to upload zipped image packages" => "Berechtigung zum Hochladen gepackter Bildarchive nicht vorhanden",
"The uploaded file is not recognized as a image" => "Die hochgeladene Datei konnte nicht als Bild identifiziert werden",
"You do not have permission to upload images" => "Zugriff verweigert. Du kannst keine Bilder hochladen",
"You have permission to upload images but not to this gallery" => "Zugriff verweigert. Du kannst Bilder hochladen, aber nicht in diese Galerie",
"Cannot get image from URL" => "Kann Bild nicht von URL beziehen",
"That is not an image (or you have php < 4.0.5)" => "Dies ist kein Bild (oder die PHP Version ist kleiner als 4.0.5)",
"Usage" => "Zugriffe",
// "Default user modules restored" => "Default user modules restored",
// "Default user modules not restored" => "Default user modules not restored",
// "User module assigned" => "User module assigned",
// "User module not assigned" => "User module not assigned",
// "User module display order moved up. Displayed order may not change if other modules now have the same order rank" => "User module display order moved up. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved up" => "User module display order not moved up",
// "User module display order moved down. Displayed order may not change if other modules now have the same order rank" => "User module display order moved down. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved down" => "User module display order not moved down",
// "User module moved to left column" => "User module moved to left column",
// "User module not moved to left column" => "User module not moved to left column",
// "User module moved to right column" => "User module moved to right column",
// "User module not moved to right column" => "User module not moved to right column",
"TOP" => "TOP",
"No URL indicated" => "Keine URL angegeben",
"ERROR: Either the subject or body must be non-empty" => "FEHLER: Text und Betreff dürfen nicht leer sein.",
"Unknown user" => "Unbekannter Benutzer",
// "Added new structure route" => "Added new structure route",
// "Deleted structure route" => "Deleted structure route",
// "Updated structure route" => "Updated structure route",
// "Notification preferences set" => "Notification preferences set",
// "Errors were encountered when setting notification preferences" => "Errors were encountered when setting notification preferences",
"Email is set to %s" => "E-Mailadresse ist jetzt %s",
"Password has been changed" => "Passwort wurde geändert",
"Invalid password. Your current password is required to change administrative information" => "Falsches Passwort. Dein gegenwärtiges Passwort ist erforderlich, um die Informationen zu ändern",
"The passwords did not match" => "Die Passwörter stimmen nicht überein",
"If you really want to delete your account, you must check the checkbox" => "Wenn Du das Konto wirklich löschen willst, musst Du das Kontrollkästchen anklicken",
// "User report preferences saved" => "User report preferences saved",
// "User report preferences not saved" => "User report preferences not saved",
// "User reports disabled" => "User reports disabled",
// "User report not disabled" => "User report not disabled",
"was moved to the trash" => "wurde in den Papierkorb verschoben",
"was moved to the trash by" => "weggeworfen von",
"open / in process" => "offen / in Bearbeitung",
"Rights by creator" => "Rechte beim Ersteller",
"END" => "ENDE",
"Percentage" => "Prozensatz",
"Task accepted by creator" => "Aufgabe von Ersteller akzeptiert",
"Task accepted by task user" => "Aufgabe von Aufgabenbenutzer akzeptiert",
"Task NOT accepted by creator" => "Aufgabe von Ersteller NICHT akzeptiert",
"Task NOT accepted by task user" => "Aufgabe von Aufgabenbenutzer NICHT akzeptiert",
"Sorry, this task does not exist or you don't have permission to view this task" => "Diese Aufgabe existiert nicht oder Du hast keine Rechte diese Aufgabe anzusehen",
"Task entries" => "Aufgabeneinträge",
"Changes:" => "Änderungen:",
"Info message" => "Benachrichtigung",
"NEW Task" => "Neue Aufgabe",
"Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks" => "Es ist Dir nicht erlaubt, Aufgaben anderen Benutzern zu senden, oder der Empfängerbenutzer darf keine Aufgaben empfangen",
"Changes on Task" => "Änderungen an Aufgabe",
"You received a new task" => "Neue Aufgabe erhalten",
"The priority is" => "Die Priorität ist",
"very low" => "sehr niedrig",
"high" => "hoch",
"very high" => "sehr hoch",
"You must start your work at least on" => "Du musst Deine Arbeit spätestens aufnehmen am",
"You must finish your work on" => "Du musst Deine Arbeit spätestens abschließen am",
"Log in and click the link below" => "Melde Dich an und klicke auf den unten stehenden Link",
"Please read the task and work on it" => "Bitte lies die Aufgabe und arbeite daran",
"Sorry, there was an error while trying to write data into the database" => "Es ist ein Fehler beim Schreiben von Daten in die Datenbank aufgetreten",
// "Unsubscribe from user watch email notifications" => "Unsubscribe from user watch email notifications",
// "Unsubscribed from user watch email notification" => "Unsubscribed from user watch email notification",
// "Unsubscribe failed" => "Unsubscribe failed",
// "Unknown watch type" => "Unknown watch type",
"Language watch" => "Sprachenüberwachung",
"Category watch: %0, Language: %1" => "Kategorieüberwachung: %0, Sprache: %1",
// "User watch deleted" => "User watch deleted",
// "User watch not deleted" => "User watch not deleted",
"Cannot upload this file. The storage quota would be exceeded" => "Hochladen würde Kontingent überschreiten",
"No user indicated" => "Kein Benutzer angegeben",
"Non-existent user" => "Nicht existierender Benutzer",
"No banner indicated" => "Kein Banner angegeben",
"No blog indicated" => "Kein Blog angegeben",
"Post not found" => "Post nicht gefunden",
"You do not have permission to view this blog post while it is marked as private" => "Du hast nicht die Rechte, um diesen Blogpost zu sehen, solange er als privat markiert ist",
"No cache information available" => "Keine Cache-Informationen verfügbar",
"You must suggest a question; please try again" => "Du musst eine Frage vorschlagen; versuche es erneut",
"No FAQ indicated" => "Keine FAQ angegeben",
// "Are you sure you want to remove that attachment" => "Are you sure you want to remove that attachment",
// "Are you sure you want to remove that topic" => "Are you sure you want to remove that topic",
"You do not have permission to remove someone else's post!" => "Keine Erlaubnis zum Löschen von Beiträgen anderer Benutzer!",
"Incorrect thread" => "Falscher Thread",
// "Thread %0 does not exist" => "Thread %0 does not exist",
"No thread indicated" => "Kein Thread angegeben",
"Files are read only at this time" => "Dateien sind zur Zeit nur lesbar",
"Are you sure you want to clone this spreadsheet" => "Bist Du sicher, dass Du diese Rechentabelle klonen willst",
"Clone Error" => "Klonungsfehler",
"Are you sure you want to roll back this spreadsheet" => "Bist Du sicher, dass Du diese Tabelle zurückrollen willst",
"Rollback Error" => "Rückroll-Fehler",
"Tracker Added To Spreadsheet" => "Tracker zu Tabelle hinzugefügt",
"Tracker Removed From Spreadsheet" => "Tracker von Tabelle entfernt",
"Spreadsheet added" => "Tabelle hinzugefügt",
"Spreadsheet removed" => "Tabelle entfernt",
"File removed" => "Datei entfernt",
"Spreadsheet truncated" => "Rechentabelle abgeschnitten",
// "Create or view tracker" => "Create or view tracker",
"Admin this tracker" => "Diesen Tracker administrieren",
// "Are you sure you want to delete the selected items" => "Are you sure you want to delete the selected items",
"Create tracker item" => "Erstelle einen Trackereintrag",
// "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission" => "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission",
// "Are you sure you want to permanently delete this item" => "Are you sure you want to permanently delete this item",
"Are you sure you want to remove this attachment" => "Bist Du sicher, dass Du diesen Anhang löschen willst",
"Edit/Delete" => "Bearbeiten/löschen",
"You don't have a personal tracker item yet. Click here to make one" => "Du hast noch keinen persönlichen Trackereintrag. Klicke hier um einen zu erstellen",
"That tracker does not use extras" => "Dieser Tracker benutzt keine Extras",
"Address book" => "Adressbuch",
"Top pages" => "Top-Seiten",
"Last pages" => "Letzte Seiten",
// "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace" => "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace",
);
