<?php
// (c) Copyright by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// The original strings (English) are case-sensitive.

/* Note for translators about translation of text ending with punctuation
 *
 * The current list of concerned punctuation can be found in 'lib/init/tra.php'
 * On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
 * For clarity, we explain here only for colons: ':' but it is the same for the rest
 *
 * Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
 *
 * Technical justification:
 * If a string ending with colon needs translating (like "{tr}Login:{/tr}")
 * then Tiki tries to translate 'Login' and ':' separately.
 * This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
 * and it still allows to translate ":" as " :" for languages that
 * need it (like French)
 * Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
 * This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.
 */
$lang = array(
"Welsh" => "Gallois",
"Slovene" => "Slovène",
"Arabic" => "Arabe",
"Bulgarian" => "Bulgare",
"Catalan" => "Catalan",
"Simplified Chinese" => "Chinois simplifié",
"Czech" => "Tchèque",
"Danish" => "Danois",
"German" => "Allemand",
"English" => "Anglais",
"English British" => "Anglais britannique",
"Spanish" => "Espagnol",
"Greek" => "Grec",
"Farsi" => "Persan",
"Finnish" => "Finnois",
"Fijian" => "Fidjien",
"French" => "Français",
"Frisian Netherlands" => "Frison Pays-Bas",
"Galician" => "Galicien",
"Hebrew" => "Hébreu",
"Croatian" => "Croate",
"Indonesian" => "Indonésien",
"Icelandic" => "Islandais",
"Italian" => "Italien",
"Inuktitut" => "Inuktitut",
// "Inuktitut (Roman)" => "Inuktitut (Roman)",
// "Iniunnaqtun" => "Iniunnaqtun",
"Japanese" => "Japonais",
"Korean" => "Coréen",
"Hungarian" => "Hongrois",
"Lithuanian" => "Lituanien",
"Low German" => "Bas-allemand",
"Dutch" => "Hollandais",
"Norwegian" => "Norvégien",
"Polish" => "Polonais",
"Portuguese" => "Portugais",
"Brazilian Portuguese" => "Brésilien",
"Romanian" => "Roumain",
"Romansh" => "Romanche",
"Russian" => "Russe",
"Pijin Solomon" => "Pidgin des Îles des Salomons",
"Sinhala" => "Cinghalais",
"Slovak" => "Slovaque",
"Albanian" => "Albanais",
"Serbian Latin" => "Serbe latin",
"Swedish" => "Suédois",
// "Swahili" => "Swahili",
// "Thai" => "Thai",
"Tuvaluan" => "Tuvalu",
"Turkish" => "Turc",
"Traditional Chinese" => "Chinois traditionnel",
"Ukrainian" => "Ukrainien",
// "Urdu" => "Urdu",
"Vietnamese" => "Vietnamien",
"Afghanistan" => "Afghanistan",
"Aland Islands" => "Îles Aland",
"Aland_Islands" => "Åland",
"Albania" => "Albanie",
"Algeria" => "Algérie",
"American Samoa" => "Samoa",
"American_Samoa" => "Samoa_américaines",
"Andorra" => "Andorre",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentine",
"Armenia" => "Arménie",
"Aruba" => "Aruba",
"Australia" => "Australie",
"Austria" => "Autriche",
"Azerbaijan" => "Azerbaïdjan",
"Bahamas" => "Bahamas",
"Bahrain" => "Bahreïn",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbade",
"Belarus" => "Biélorussie",
"Belgium" => "Belgique",
"Belize" => "Belize",
"Benin" => "Bénin",
"Bermuda" => "Bermudes",
"Bhutan" => "Bhoutan",
"Bolivia" => "Bolivie",
"Bosnia and Herzegovina" => "Bosnie-Herzégovine",
"Bosnia_and_Herzegovina" => "Bosnie-Herzégovine",
"Botswana" => "Botswana",
"Bouvet Island" => "Île Bouvet",
"Bouvet_Island" => "Île_Bouvet",
"Brazil" => "Brésil",
"British Indian Ocean Territory" => "Territoire britannique de l'océan Indien",
"British Virgin Islands" => "Îles Vierges britanniques",
"British_Indian_Ocean_Territory" => "Territoire_britannique_de_l'océan_Indien",
"British_Virgin_Islands" => "Îles_Vierges_Britanniques",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgarie",
"Burkina Faso" => "Burkina Faso",
"Burkina_Faso" => "Burkina_Faso",
"Burundi" => "Burundi",
"Cambodia" => "Cambodge",
"Cameroon" => "Cameroun",
"Canada" => "Canada",
"Cape Verde" => "Cap-Vert",
"Cape_Verde" => "Cap-Vert",
"Catalan Countries" => "Pays_catalans",
"Catalan_Countries" => "Pays_Catalans",
"Cayman Islands" => "Îles Caïmans",
"Cayman_Islands" => "Îles_Caïmans",
"Central African Republic" => "République centrafricaine",
"Central_African_Republic" => "République_centrafricaine",
"Chad" => "Tchad",
"Chile" => "Chili",
"China" => "Chine",
"Christmas Island" => "Île Christmas",
"Christmas_Island" => "Île_Christmas",
"Cocos Islands" => "Île Cocos",
"Cocos_Islands" => "Îles Cocos",
"Colombia" => "Colombie",
"Comoros" => "Comores",
"Democratic Republic of the Congo" => "Congo Démocratique",
"Democratic_Republic_of_the_Congo" => "République_démocratique_du_Congo",
"Congo" => "Congo",
"Cook Islands" => "Îles Cook",
"Cook_Islands" => "Îles_Cook",
"Costa Rica" => "Costa Rica",
"Costa_Rica" => "Costa_Rica",
"Croatia" => "Croatie",
"Cuba" => "Cuba",
"Cyprus" => "Chypre",
"Czech Republic" => "République tchèque",
"Czech_Republic" => "République_tchèque",
"Denmark" => "Danemark",
"Djibouti" => "Djibouti",
"Dominica" => "Dominique",
"Dominican Republic" => "République dominicaine",
"Dominican_Republic" => "République_dominicaine",
"Ecuador" => "Equateur",
"Egypt" => "Egypte",
"El Salvador" => "Salvador",
"El_Salvador" => "Salvador",
// "England" => "England",
"Equatorial Guinea" => "Guinée équatoriale",
"Equatorial_Guinea" => "Guinée_équatoriale",
"Eritrea" => "Erythrée",
"Estonia" => "Estonie",
"Ethiopia" => "Ethiopie",
"Europe" => "Europe",
"Falkland Islands" => "Îles Malouines",
"Falkland_Islands" => "Îles_Malouines",
"Faroe Islands" => "Îles Féroé",
"Faroe_Islands" => "Îles_Féroé",
"Federated States of Micronesia" => "États fédérés de Micronésie",
"Federated_States_of_Micronesia" => "États_fédérés_de_Micronésie",
"Fiji" => "Fidji",
"Finland" => "Finlande",
"France" => "France",
"French Guiana" => "Guyane",
"French Polynesia" => "Polynésie française",
"French Southern Territories" => "Terres australes et antarctiques françaises",
"French_Guiana" => "Guyane",
"French_Polynesia" => "Polynésie_française",
"French_Southern_Territories" => "Terres_australes_françaises",
"Gabon" => "Gabon",
"Gambia" => "Gambie",
"Georgia" => "Géorgie",
"Germany" => "Allemagne",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Greece" => "Grèce",
"Greenland" => "Groenland",
"Grenada" => "Grenade",
"Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernesey",
"Guinea Bissau" => "Guinée-Bissao",
"Guinea" => "Guinée",
"Guinea_Bissau" => "Guinée-Bissao",
"Guyana" => "Guyane",
"Haiti" => "Haïti",
"Heard Island and McDonald Islands" => "Île Heard et îles McDonald",
"Heard_Island_and_McDonald_Islands" => "Îles_Heard-et-MacDonald",
"Honduras" => "Honduras",
"Hong Kong" => "Hong Kong",
"Hong_Kong" => "Hong_Kong",
"Hungary" => "Hongrie",
"Iceland" => "Islande",
"India" => "Inde",
"Indonesia" => "Indonésie",
"Iran" => "Iran",
"Iraq" => "Irak",
"Ireland" => "Irlande",
"Isle of Man" => "Île de Man",
"Israel" => "Israël",
"Italy" => "Italie",
"Ivory Coast" => "Côte d'Ivoire",
"Ivory_Coast" => "Côte_d'Ivoire",
"Jamaica" => "Jamaïque",
"Japan" => "Japon",
"Jersey" => "Jersey",
"Jordan" => "Jordanie",
"Kazakstan" => "Kazakhstan",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Koweït",
"Kyrgyzstan" => "Kirghizistan",
"Laos" => "Laos",
"Latvia" => "Lettonie",
"Lebanon" => "Liban",
"Lesotho" => "Lesotho",
"Liberia" => "Libéria",
"Libya" => "Libye",
"Liechtenstein" => "Liechtenstein",
"Lithuania" => "Lituanie",
"Luxemburg" => "Luxembourg",
"Macao" => "Macao",
"Macedonia" => "Macédoine",
"Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malaisie",
"Maldives" => "Maldives",
"Mali" => "Mali",
"Malta" => "Malte",
"Marshall Islands" => "Îles Marshall",
"Marshall_Islands" => "Îles_Marshall",
"Martinique" => "Martinique",
"Mauritania" => "Mauritanie",
"Mauritius" => "Mauritanie",
"Mayotte" => "Mayotte",
"Mexico" => "Mexique",
"Moldova" => "Moldavie",
"Monaco" => "Monaco",
"Mongolia" => "Mongolie",
"Montenegro" => "Monténégro",
"Montserrat" => "Montserrat",
"Morocco" => "Maroc",
"Mozambique" => "Mozambique",
"Myanmar" => "Myanmar",
"Namibia" => "Namibie",
"Nauru" => "Nauru",
"Nepal" => "Népal",
"Netherlands Antilles" => "Antilles néerlandaises",
"Netherlands" => "Pays-Bas",
"Netherlands_Antilles" => "Antilles_néerlandaises",
"New Caledonia" => "Nouvelle_Calédonie",
"New Zealand" => "Nouvelle_Zélande",
"New_Caledonia" => "Nouvelle-Calédonie",
"New_Zealand" => "Nouvelle-Zélande",
"Nicaragua" => "Nicaragua",
"Niger" => "Niger",
"Nigeria" => "Nigéria",
"Niue" => "Nioué",
"None" => "Aucun",
"Norfolk Island" => "Île Norfolk",
"Norfolk_Island" => "Île_Norfolk",
"North Korea" => "Corée du Nord",
"North_Korea" => "Corée_du_Nord",
"Northern Mariana Islands" => "Îles Mariannes du Nord",
"Northern_Mariana_Islands" => "Îles_Mariannes_du_Nord",
"Norway" => "Norvège",
"Oman" => "Oman",
"Other" => "Autre",
"Pakistan" => "Pakistan",
"Palau" => "Palaos",
"Palestine" => "Palestine",
"Panama" => "Panama",
"Papua New Guinea" => "Papouasie - Nouvelle - Guinée",
"Papua_New_Guinea" => "Papouasie-Nouvelle-Guinée",
"Paraguay" => "Paraguay",
"Peru" => "Pérou",
"Philippines" => "Philippines",
"Pitcairn" => "Îles Pitcairn",
"Poland" => "Pologne",
"Portugal" => "Portugal",
"Puerto Rico" => "Porto Rico",
"Puerto_Rico" => "Porto_Rico",
"Quatar" => "Qatar",
"Republic of Macedonia" => "République de Macédoine",
"Republic_of_Macedonia" => "République_de_Macédoine",
"Reunion" => "Réunion",
"Romania" => "Roumanie",
"Russia" => "Russie",
"Russian Federation" => "Fédération de Russie",
"Russian_Federation" => "Fédération de Russie",
"Rwanda" => "Rwanda",
"Saint Helena" => "Sainte-Hélène",
"Saint Kitts and Nevis" => "Saint-Christophe-et-Niévès",
"Saint Lucia" => "Sainte-Lucie",
"Saint Pierre and Miquelon" => "Saint Pierre et Miquelon",
"Saint_Helena" => "Sainte-Hélène",
"Saint_Kitts_and_Nevis" => "Saint-Christophe-et-Niévès",
"Saint_Lucia" => "Sainte-Lucie",
"Saint_Pierre_and_Miquelon" => "Saint-Pierre-et-Miquelon",
"Samoa" => "Samoa",
"San Marino" => "Saint-Marin",
"San_Marino" => "Saint-Marin",
"Sao Tome and Principe" => "São Tomé-et-Principe",
"Sao_Tome_and_Principe" => "Sao_Tomé-et-Principe",
"Saudi Arabia" => "Arabie Saoudite",
"Saudi_Arabia" => "Arabie_saoudite",
"Senegal" => "Sénégal",
"Serbia" => "Serbie",
"Seychelles" => "Seychelles",
"Sierra Leone" => "Sierra Leone",
"Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapour",
"Slovakia" => "Slovaquie",
"Slovenia" => "Slovénie",
"Solomon Islands" => "Îles Salomon",
"Solomon_Islands" => "Îles_Salomon",
"Somalia" => "Somalie",
"South Africa" => "Afrique du Sud",
"South Georgia and South Sandwich Islands" => "Géorgie du Sud et les îles Sandwich du Sud",
"South Korea" => "Corée du Sud",
"South_Africa" => "Afrique_du_Sud",
"South_Georgia_and_South_Sandwich_Islands" => "Géorgie_du_Sud-et-les_Îles_Sandwich_du_Sud",
"South_Korea" => "Corée_du_Sud",
"Spain" => "Espagne",
"Sri Lanka" => "Sri Lanka",
"Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St Vincent Grenadines",
"St_Vincent_Grenadines" => "St_Vincent_Grenadines",
"Sudan" => "Soudan",
"Surinam" => "Suriname",
"Svalbard and Jan Mayen" => "Svalbard et Jan Mayen",
"Svalbard_and_Jan_Mayen" => "Île_Jan_Mayen",
"Swaziland" => "Swaziland",
"Sweden" => "Suède",
"Switzerland" => "Suisse",
"Syria" => "Syrie",
"Taiwan" => "Taiwan",
"Tajikistan" => "Tadjikistan",
"Tanzania" => "Tanzanie",
"Thailand" => "Thaïlande",
"Timor-Leste" => "Timor oriental",
"Togo" => "Togo",
"Tokelau" => "Tokélaou",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinité-et-Tobago",
"Trinidad_Tobago" => "Trinité-et-Tobago",
"Tunisia" => "Tunisie",
"Turkey" => "Turquie",
"Turkmenistan" => "Turkménistan",
"Turks and Caicos Islands" => "Îles Turques et Caïques",
"Turks_and_Caicos_Islands" => "Îles_Turques-et-Caïques",
"Tuvalu" => "Tuvalu",
"US Virgin Islands" => "Îles Vierges américaines",
"US_Virgin_Islands" => "Îles_Vierges_américaines",
"Uganda" => "Ouganda",
"Ukraine" => "Ukraine",
"United Arab Emirates" => "Émirats arabes unis",
"United Kingdom" => "Royaume-Uni",
"United Nations Organization" => "Organisation des Nations Unies",
"United States Minor Outlying Islands" => "Îles mineures éloignées des États-Unis",
"United States" => "États-Unis",
"United_Arab_Emirates" => "Émirats_arabes_unis",
"United_Kingdom" => "Royaume-Uni",
"United_Kingdom_-_England_and_Wales" => "Royaume-Uni_-_Angleterre_et_Pays_de_Galles",
"United_Kingdom_-_Northern_Ireland" => "Royaume-Uni_-_Irlande_du_Nord",
"United_Kingdom_-_Scotland" => "Royaume-Uni_-_Écosse",
"United_Nations_Organization" => "Organisation_des_Nations_Unies",
"United_States" => "États-Unis_d'Amérique",
"United_States_Minor_Outlying_Islands" => "Îles_mineures_éloignées_des_États-Unis",
"Uruguay" => "Uruguay",
"Uzbekistan" => "Ouzbékistan",
"Vanuatu" => "Vanuatu",
"Vatican" => "Vatican",
"Venezuela" => "Venezuela",
"Viet Nam" => "Viêt Nam",
"Viet_Nam" => "Viêt_Nam",
"Wales" => "Pays de Galles",
"Wallis and Futuna" => "Wallis-et-Futuna",
"Wallis_and_Futuna" => "Wallis-et-Futuna",
"Western Sahara" => "Sahara occidental",
"Western_Sahara" => "Sahara_occidental",
"World" => "Monde",
"Yemen" => "Yémen",
"Yugoslavia" => "Yougoslavie",
"Zambia" => "Zambie",
"Zimbabwe" => "Zimbabwe",
"the former Yugoslav Republic of Macedonia" => "l'Ex-République yougoslave de Macédoine",
"the_former_Yugoslav_Republic_of_Macedonia" => "Ancienne_République_yougoslave_de_Macédoine",
"File %0 succesfully imported" => "Le fichier %0 importé avec succès",
"category defaults" => "catégorie par défaut",
"You must specify a directory" => "Vous devez spécifier un répertoire",
"ViewerJS URI not set" => "ViewerJS URI non défini",
"ViewerJS URI not found (local file not readable)" => "ViewerJS URI non trouvé (fichier local non lisible)",
"ViewerJS URI not found (%0)" => "ViewerJS URI non trouvé (%0)",
"Tags successfully cleaned up" => "Balises nettoyées avec succès",
"Tag cleanup failed" => "Le nettoyage des balises a échoué",
// "Remove orphan images" => "Remove orphan images",
"Orphan images successfully removed" => "Les images orphelines ont été supprimées avec succès",
"moved %d images, %d errors occurred." => "%d images déplacées, %d erreurs trouvées.",
"a timeout occurred. Hit the reload button to move the rest" => "un dépassement de temps est survenu. Pressez le bouton recharger pour déplacer le reste",
"Tiki Email Test" => "Test Courriel Tiki",
"Tiki Test email from" => "Courriel de test Tiki de",
"Unable to send mail" => "Incapable d'envoyer le courriel",
"Test mail sent to" => "Courriel de test envoyé à",
// "Remove this server" => "Remove this server",
// "Remove this host" => "Remove this host",
"registration choices" => "choix d'inscription",
// "Assign users to groups based on email patterns" => "Assign users to groups based on email patterns",
"This method of captcha is not supported by your server, please select another or upgrade" => "Cette méthode de captcha n'est pas supportée par votre serveur, veuillez en sélectionner une autre ou mettre à jour",
"You need to select a file to upload" => "Vous devez sélectionner un fichier à télécharger",
// "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists" => "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists",
"Unable to Write Password File to Disk" => "Impossible d'écrire le fichier de mot de passe sur le disque",
// "Delete temporary index" => "Delete temporary index",
"%d users were assigned to groups based on user emails matching the patterns defined for the groups" => "%d utilisateurs ont été affectés à des groupes en fonction des e-mails des utilisateurs correspondant aux modèles définis pour les groupes",
"No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups" => "Aucun e-mail d'utilisateur ne correspond aux définitions de modèle de groupe, ou les utilisateurs correspondants ont déjà été attribués ou les modèles de messagerie n'ont été définis pour aucun groupe.",
"composer.lock file was removed" => "Le fichier composer.lock a été supprimé",
"composer.lock file is not writable, so it can not be removed" => "Le fichier composer.lock n'est pas accessible en écriture, il ne peut donc pas être supprimé",
"composer.lock file do not exists" => "Le fichier composer.lock n'existe pas",
"Vendor folder contents was removed" => "Le contenu du dossier vendor a été supprimé",
"Vendor folder is not writable" => "Le dossier vendor n'est pas accessible en écriture",
"Vendor folder do not exists" => "Le dossier vendor n'existe pas",
"Used" => "Utilisé",
"Available" => "Disponible",
"Hit" => "Visite",
"Miss" => "Raté",
"An error occurred: " => "Une erreur s'est produite : ",
"profile applied" => "profil appliqué",
"The following list of changes has been applied" => "La liste suivante de changement a été appliquée",
// "Profile forgotten" => "Profile forgotten",
"New rating configuration %0 created" => "New rating configuration %0 created",
"Rating configuration updated for %0" => "Nouvelle configuration d'évaluation %0 créée",
"Scoring events replaced with form data" => "Evénements d'évaluation remplacés par des données de formulaire",
"Unable to get info from log file" => "Impossible d'obtenir des informations du fichier journal",
"You must set a home file gallery" => "Vous devez définir une galerie de fichiers d'accueil",
"Tag already exists" => "Le marqueur existe déjà",
"Tag %0 created" => "Tag %0 créé",
"Tag %0 not found" => "Balise %0 introuvable",
"Tag %0 restored" => "Balise %0 restauré",
"Tag %0 not restored" => "Balise %0 non restauré",
"Tag %0 removed" => "Balise %0 supprimé",
"Tag %0 not removed" => "Balise %0 non supprimé",
"Process to remove pictures has completed" => "Le processus de suppression des images est terminé",
"Dump created at %0" => "Dump créé à %0",
"Dump was not created. Please check permissions for the storage/ directory" => "Dump n'a pas été créé. Veuillez vérifier les autorisations pour le répertoire de stockage /",
"Dump file %0 removed" => "Fichier Dump %0 supprimé",
"Dump file %0 was not removed" => "Le fichier Dump %0 n'a pas été supprimé",
"No update was made" => "Aucune mise à jour n'a été effectuée",
"Areas were updated" => "Les zones ont été mises à",
"Are you sure you want to remove that post?" => "Êtes-vous sûr de vouloir supprimer ce post ?",
"Re" => "Re",
"This forum is flat and doesn't allow replies to other replies" => "Ce forum est à plat et ne permet pas de répondre aux autres réponses.",
"Copyright management" => "Gestion des droits d'auteur",
"No page indicated" => "Aucune page indiquée",
"You must supply all the information, including title and year." => "Vous devez fournir toutes les informations, y compris titre et année.",
// "Sorry, that mail has been taken by another operator" => "Sorry, that mail has been taken by another operator",
"Wiki Page" => "Page Wiki",
// "Tracker item not found" => "Tracker item not found",
// "Put this item back" => "Put this item back",
// "Taken by %0" => "Taken by %0",
// "Take this email" => "Take this email",
// "TAKE" => "TAKE",
"View contact" => "Voir le contact",
"ID" => "ID",
"Type" => "Type",
"Name" => "Nom",
"Description" => "Description",
"Size" => "Taille",
"Created" => "Créé",
"Uploaded" => "Envoyé",
"Last modified" => "Modifié",
"Uploaded by" => "Téléchargé par",
"Creator" => "Créateur",
"Last modified by" => "Dernière modification par",
"Comment" => "Commentaire",
"Files" => "Fichiers",
"Hits" => "Visites",
"Last download" => "Dernier téléchargement",
"Locked by" => "Verrouillé par",
"Backlinks" => "Pages pointant vers cette page",
"Delete after" => "Supprimer après",
"Share" => "Partager",
"Source" => "Source",
"Explorer" => "Explorateur",
"Path" => "Chemin d'accès",
"Slideshow" => "Diaporama",
"Gallery icon" => "Icône de la galerie",
"Register" => "S'inscrire",
"Group" => "Groupe",
"Tiki Installer" => "Installeur Tiki",
"MySQL Improved (mysqli)" => "MySQL amélioré (mysqli)",
"MySQL classic (mysql)" => "MySQL classique (mysql)",
"Invalid database user" => "Utilisateur de la base de données incorrect",
"No database name specified" => "Pas de base de données spécifiée",
"Automatic" => "Automatique",
"Make a symlink" => "Créer un lien symbolique",
"Make a copy" => "Créer une copie",
"Do nothing" => "Ne rien faire",
"symlink created" => "Lien symbolique créé",
"copy created" => "copie créée",
"Email address not valid, test mail not sent" => "Adresse mail non valide, l'email de test n'a pas été envoyé",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Pas d'adresse mail et la case \"copy\"\" non cochée, le courriel de test n'a pas été envoyé",
"Test mail from Tiki installer %0" => "Tester le mail de l'installateur Tiki %0",
"Tiki version:" => "Version de Tiki :",
"PHP version:" => "Version PHP :",
"Server:" => "Serveur :",
"Sent:" => "Envoyé :",
"Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Certains caractères non valides ont été détectés dans le nom de la base de données. Veuillez utiliser des caractères alphanumériques ou _ ou -",
"Database `%0` was created" => "La base de données `%0` a été créée",
"Database `%0` creation failed. You need to create the database" => "La création de la base de données `%0` a échoué. Vous devez créer vous-même la base de données",
"Database `%0`. Unable to connect to database" => "Base de données `% 0`. Impossible de se connecter à la base de données",
"User `%0` was created" => "L'utilisateur `%0` a été créé",
"User `%0` creation failed" => "La création de l'utilisateur `%0` a échoué",
"Congratulations!\n\nYour server can send emails.\n\n" => "Félicitations !\n\nVotre serveur peut envoyer des emails.\n\n",
// "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Failed to convert document into image" => "Failed to convert document into image",
// "Please check Tiki Action Log for more information" => "Please check Tiki Action Log for more information",
"No automated tax" => "Aucune taxe automatisée",
"Account name must not be empty" => "Le nom du compte ne peut pas être vide",
"Budget is not a valid amount: " => "Le montant du budget n'est pas valide",
"Locked must be either 0 or 1" => "Fermé doit être 0 ou 1",
"Error creating account" => "Erreur pendant la création du compte",
"AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "L'Id de compte %0 est déjà en service et ne peut être changé. Merci de le désactiver si il n'est plus nécessaire",
"Error updating account" => "Erreur pendant la mise à jour du compte",
"Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Le compte est toujours utilisé et ne doit pas être supprimé. Désactivez-le, si il n'est plus utile désormais",
"Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "L'annulation de la transaction a échoué, base de données incohérente : Nettoyage nécessaire pour l'Id de journal %0 dans le livre %1",
"successfully rolled back #" => "annulation de la transaction réussie #",
"Booking error creating journal entry" => "Erreur d'enregistrement pendant la création d'une entrée de journal",
"Booking error creating debit entry" => "Erreur d'enregistrement pendant la création d'une entrée de débit",
"Booking error creating credit entry" => "Erreur d'enregistrement pendant la création d<br /><br />'une entrée de crédit",
"The number of debit entries differs: " => "Le nombre d'entrées de débit diffère : ",
"The number of credit entries differs: " => "Le nombre d'entrées de crédit diffère : ",
"Splitting is only allowed on one side" => "La partition est autorisée seulement sur un côté",
"Invalid debit amount " => "Montant de débit incorrect ",
"Invalid debit account number " => "Numéro de compte bancaire incorrecte ",
"Invalid credit amount " => "Montant de crédit incorrect ",
"Invalid credit account number " => "Numéro de compte de crédit incorrect",
"Difference between debit and credit amounts " => "Différence entre les montants débit et crédit",
"Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "L'annulation de la transaction a échoué, base de données incohérente : Nettoyage nécessaire pour l'Id de pile %0 dans le livre %1",
"Booking error creating stack entry" => "Erreur de réservation pendant la création d'une entrée de pile",
"Booking error creating stack debit entry" => "Erreur de réservation pendant la création d'une entrée de pile débit",
"Booking error creating stack credit entry" => "Erreur de réservation pendant la création d'une entrée de pile crédit",
"Error deleting entry from stack" => "Erreur pendant la suppression d'une entrée de la pile",
"Booking error confirming stack entry" => "Erreur de réservation pendant la confirmation d'une entrée de pile",
"Error while updating statement" => "Erreur lors de la mise à jour la déclaration",
"is not a number" => "n'est pas un nombre",
"must be greater than 0" => "doit être supérieur à 0",
"Invalid transaction - please contact administrator" => "Transaction invalide - veuillez contacter l'administrateur",
"Error checking" => "Vérification des erreurs",
"does not exist" => "n'exsite pas",
"already exists" => "existe déjà",
"This book has been closed. You can't create new accounts" => "Ce livre a été clôturé. Vous ne pouvez pas créer de nouveaux comptes",
"This book has been closed. You can't modify the account" => "Ce livre a été clôturé. Vous ne pouvez pas modifier le compte",
"This book has been closed. You can't delete the account" => "Ce livre a été clôturé. Vous ne pouvez pas supprimer le compte",
"The date of the transaction is before the start date of this book" => "La date pour l'opération est antérieure à celle de début de ce livre",
"The date of the transaction is after the end date of this book" => "La date pour l'opération est postérieure à celle de fin de ce livre",
"This book has been closed. Bookings can no longer be made in it" => "Ce livre a été clôturé. Vous ne pouvez rien y ajouter de plus",
"Invalid booking date" => "Date de réservation incorrecte",
"This book has been closed. Transactions can no longer be cancelled in it" => "Ce livre a été clôturé. Vous ne pouvez plus y annuler d'écritures",
// "APC system, user and opcode caches cleared" => "APC system, user and opcode caches cleared",
// "APC %0 cache cleared" => "APC %0 cache cleared",
// "APC %0 cache not cleared" => "APC %0 cache not cleared",
"New article post" => "Nouvel article publié",
"Edited article post" => "Modifier une publication d'article",
"Deleted article post" => "Publication d'article supprimée",
"The file has incorrect syntax or is not a CSV file" => "Le fichier n'est pas un fichier CSV ou la syntaxe est incorrecte",
"Error line: %d" => "Erreur à la ligne : %d",
"Import failed due to data format. Make sure the file has Unix-style line breaks" => "L'importation a échoué en raison du format de données. Assurez-vous que le fichier a des sauts de ligne de type Unix",
"Spam is not welcome here" => "Le spam n'est pas le bienvenu ici",
"anonymous" => "anonyme",
"Blog cannot be found" => "Le blogue est introuvable",
"Locked by %0" => "Verrouillé par %0",
"refresh" => "rafraichir",
"go back to this crumb" => "revenir à ce point du fil d'Ariane",
"Administration" => "Administration",
// "Cache file %0 is not writable" => "Cache file %0 is not writable",
"All day" => "Journée entière",
"First day of week: Sunday (its ID is 0) - Translators, you need to localize this string!" => "Premier jour de la semaine : Lundi (son ID est 1) ",
"Sunday" => "Dimanche",
"Su" => "Di",
"Monday" => "Lundi",
"Tuesday" => "Mardi",
"Wednesday" => "Mercredi",
"Thursday" => "Jeudi",
"Friday" => "Vendredi",
"Saturday" => "Samedi",
"Mo" => "Lu",
"Tu" => "Ma",
"We" => "Me",
"Th" => "Je",
"Fr" => "Ve",
"Sa" => "Sa",
"in" => "dans",
"continued" => "se continue",
"New Image Uploaded by" => "Nouvelle image envoyée par",
"New Subscriptions" => "Nouvelles inscriptions",
"New Item in Tracker" => "Nouvelle fiche dans les formulaires",
"tracker" => "Formulaires",
"by" => "par",
"Wiki" => "Wiki",
"Image Gallery" => "Galerie d'images",
"Articles" => "Articles",
"Blogs" => "Blogues",
"Forums" => "Forums de discussion",
"Directory" => "Annuaire de sites",
"File Gallery" => "Galerie de fichiers",
"FAQs" => "FAQs",
"Quizzes" => "QCMs",
"Trackers" => "Formulaires",
"Survey" => "Enquête",
"Newsletter" => "Lettre d'informations",
"Please type this word backwards" => "Veuillez taper ce mot en arrière",
"Empty CAPTCHA value" => "Valeur de captcha vide",
"You have mistyped the anti-bot verification code. Please try again" => "Vous avez mal tapé le code de vérification anti-robot. Veuillez réessayer",
"Failed to validate CAPTCHA" => "La validation du captcha a échoué",
"CAPTCHA ID field is missing" => "Le champ ID du Captcha est manquant",
"Get a visual challenge" => "Gagner un challenge visuel",
"Get an audio challenge" => "Gagner un challenge audio",
"Get a new challenge" => "Gagner un nouveau challenge",
"Type the two words" => "Écrivez les deux mots",
"Type what you hear" => "Écrivez ce que vous entendez",
"Help" => "Aide",
"Play sound again" => "Rejouer le son",
"Download audio as an MP3 file" => "Télécharger le son en MP3",
"Incorrect. Try again" => "Incorrect. Essayez encore",
"Invalid category identifier: \"%0\"" => "Identificateur de catégorie non valide: \"%0\"",
"Top" => "Racine",
"A category named %0 already exists in %1" => "Une catégorie nommée %0 existe déjà dans %1",
"article" => "article",
"blog" => "blogue",
"directory" => "répertoire des liens",
"faq" => "FAQ",
"FAQ" => "FAQ",
"file gallery" => "galerie de fichiers",
"forum" => "Forums",
"image gallery" => "galerie d'images",
"newsletter" => "lettre d'informations",
"poll" => "sondage",
"quiz" => "QCM",
"survey" => "enquête",
"wiki page" => "Page Wiki",
"image" => "image",
"calendar" => "calendrier",
"template" => "gabarit",
"Permission denied" => "Droit d'accès refusé",
"Invalid filename (using filters for filenames)" => "Nom de fichier invalide (le nom ne répond pas aux filtres)",
"Cannot upload this file - maximum upload size exceeded" => "Envoi du fichier impossible - taille maximale dépassée",
"Cannot write to this file" => "Impossible d'écrire dans ce fichier",
"(not registered)" => "(non enregistré)",
"Anonymous" => "Anonyme",
"Your comment was rejected" => "Votre commentaire a été rejeté",
"Cannot perform spam check: %0" => "Ne peut exécuter la détection de spam : %0",
"Please wait %0 seconds between posts" => "Veuillez patienter %0 secondes entre les messages",
"Wrong password. Cannot post comment" => "Mot de passe incorrect. Vous ne pouvez pas publier un commentaire",
"A contribution is mandatory" => "Une contribution est obligatoire",
"Please enter a Title and Message for your new forum topic" => "Veuillez entrer un titre et un message pour votre nouveau sujet de forum",
"Please enter a Title and Message for your forum reply" => "Veuillez entrer un titre et un message pour votre réponse au forum",
"Please enter a Message for your forum reply" => "Veuillez entrer un titre et un message pour votre réponse au forum",
"Invalid Email" => "Adresse mail invalide",
"Your message has been queued for approval and will be posted after a moderator approves it." => "Votre message a été mis en attente de validation. Il sera affiché après qu'un modérateur l'ait approuvé.",
"Use this thread to discuss the %s page" => "Utilisez ce fil pour discuter de la page %s",
"This forum is locked" => "Ce forum est verrouillé",
"This thread is locked" => "Ce fil de discussion est verrouillé",
"An error occurred; please contact the administrator" => "Une erreur est survenue veuillez contacter l'administrateur",
"Route was updated" => "Route a été mis à jour",
"Route was created" => "Route a été créée",
"Page cannot be found" => "Page introuvable",
"From is required" => "De 'expeditaire' est requis",
"There is a route with the same From path already defined" => "Il existe un route avec le même chemin 'De' déjà défini",
"Type is required" => "Le type est requis",
"Selected type is not supported" => "Le type sélectionné n'est pas supporté",
"To" => "À",
"Article" => "Article",
"Blog" => "Blogue",
"Forum" => "Forum",
"Object" => "Objet",
"Tracker" => "Formulaire",
"Field" => "Champ",
// "Tracker Item Id" => "Tracker Item Id",
"%s is required" => "%s est requis",
"Error" => "Erreur",
"Note" => "Remarque",
"Success" => "Succès",
"Warning" => "Avertissement",
"Feedback class called with no feedback provided" => "Classe Feedback appelée sans Fournir de feedback",
// "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator" => "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator",
// "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Invalid request" => "Invalid request",
// "Failed to convert document %0 to pdf" => "Failed to convert document %0 to pdf",
// "Please check Action Log for more information" => "Please check Action Log for more information",
// "Please contact the administrator" => "Please contact the administrator",
// "H5P requires the CURL extension to be installed in PHP" => "H5P requires the CURL extension to be installed in PHP",
// "Failed to write to temp file %0" => "Failed to write to temp file %0",
// " (code=%0)" => " (code=%0)",
// "Exporting H5P content %0 failed" => "Exporting H5P content %0 failed",
// "Saving H5P content %0 (fileId %1) failed" => "Saving H5P content %0 (fileId %1) failed",
// "H5P directory is not writable: %0" => "H5P directory is not writable: %0",
// "Too many arguments on ceil" => "Too many arguments on ceil",
// "Too many arguments on date" => "Too many arguments on date",
// "Divide by zero on \"%0\"" => "Divide by zero on \"%0\"",
// "Too many arguments on floor" => "Too many arguments on floor",
"Unexpected values: %0" => "Valeur inattendue : %0",
// "Field must be provided and contain one argument: list" => "Field must be provided and contain one argument: list",
// "Field must be provided and contain a function" => "Field must be provided and contain a function",
// "Too many arguments on less than" => "Too many arguments on less than",
// "Too many arguments on more than" => "Too many arguments on more than",
// "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]" => "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]",
// "Too many arguments for pad" => "Too many arguments for pad",
// "Too few arguments for pad" => "Too few arguments for pad",
// "Too many arguments on round" => "Too many arguments on round",
// "Content required" => "Content required",
// "Field must be provided and contain one argument: separator" => "Field must be provided and contain one argument: separator",
// "Field must be provided and contain one or more values: key or keys" => "Field must be provided and contain one or more values: key or keys",
// "Str-replace needs exactly 3 arguments: search, replace and subject" => "Str-replace needs exactly 3 arguments: search, replace and subject",
// "Too many arguments on strtotime" => "Too many arguments on strtotime",
// "Too few arguments on strtotime" => "Too few arguments on strtotime",
// "Field must be provided and contain one argument: group" => "Field must be provided and contain one argument: group",
// "Field must be provided and contain at least one argument: aggregate" => "Field must be provided and contain at least one argument: aggregate",
"%0 near \"%1\"" => "%0 près de \"%1\"",
"Expecting \"(\"" => "Attendu \"(\"",
"Unexpected \"%0\"" => "Inattendu \"%0\"",
"Expecting \")\"" => "Attendu \")\"",
"No formula provided" => "Aucune formule fournie",
"Variable not found \"%0\"" => "Variable non trouvée \"%0\"",
"Unknown operation \"%0\"" => "Opération inconnue \"%0\"",
// "Articles deleted" => "Articles deleted",
"removed the article" => "a supprimé l'article",
// "Edited articles" => "Edited articles",
"edited the article" => "a édité l'article",
// "New articles submitted" => "New articles submitted",
"created the article" => "a créé l'article",
// "New blog posts" => "New blog posts",
"replied to the blog" => "a répondu dans le blogue",
// "New calendar events" => "New calendar events",
"%0 added or updated event %1" => "%0 a ajouté ou mis à jour l'événement %1",
// "Changes in categories" => "Changes in categories",
// "added the %0 %1 to the category %2" => "added the %0 %1 to the category %2",
"created the subcategory" => "a créé la sous-catégorie",
"removed the subcategory" => "a supprimé la sous-catégorie",
"from" => "de",
"edited the category" => "a édité la catégorie",
// "removed the %0 %1 from the category %2" => "removed the %0 %1 from the category %2",
// "File galleries changed" => "File galleries changed",
// "%0 edited the file gallery %1" => "%0 edited the file gallery %1",
// "%0 uploaded the file %1" => "%0 uploaded the file %1",
"onto" => "dans",
// "%0 removed the file %1 from %2" => "%0 removed the file %1 from %2",
// "New replies in forum topics" => "New replies in forum topics",
"%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>a répondu</a> au sujet %2",
// "New posts in forums" => "New posts in forums",
// "%0 created the topic %1 at forum %2" => "%0 created the topic %1 at forum %2",
// "Image galleries changed" => "Image galleries changed",
"changed the picture gallery" => "a changé la galerie d'images",
"uploaded the picture" => "a envoyé l'image",
"removed the picture" => "a supprimé l'image",
// "Wiki pages added to a structure" => "Wiki pages added to a structure",
// "%0 added %1 wiki page to a structure" => "%0 added %1 wiki page to a structure",
// "Wiki pages moved down in a structure tree" => "Wiki pages moved down in a structure tree",
// "%0 moved a wiki page down in a structure tree" => "%0 moved a wiki page down in a structure tree",
// "Wiki pages moved up in a structure tree" => "Wiki pages moved up in a structure tree",
// "%0 moved a wiki page up in a structure tree" => "%0 moved a wiki page up in a structure tree",
// "Wiki pages removed from structure" => "Wiki pages removed from structure",
// "%0 removed %1 wiki page from a structure" => "%0 removed %1 wiki page from a structure",
// "File attached to tracker" => "File attached to tracker",
// "%0 attached a file (%1) to tracker item %2" => "%0 attached a file (%1) to tracker item %2",
// "Comments in tracker items" => "Comments in tracker items",
"%0 added a new comment to %1 on tracker %2" => "%0 a ajouté un nouveau commentaire pour %1 sur le formulaire %2",
"%0 added a new comment to item id %1 on tracker %2" => "%0 a ajouté un nouveau commentaire sur la fiche %1 du formulaire %2",
// "Tracker items modified" => "Tracker items modified",
"%0 added or updated tracker item %1 on tracker %2" => "%0 a ajouté ou mis à jour la fiche de formulaire %1 du formulaire %2",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 a ajouté ou mis à jour la fiche de formulaire ayant pour id %1 sur le formulaire %2",
// "New attachments in wiki pages" => "New attachments in wiki pages",
// "%0 uploaded the file %1 onto %2" => "%0 uploaded the file %1 onto %2",
// "Wiki pages updated" => "Wiki pages updated",
// "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)",
// "Wiki pages created" => "Wiki pages created",
// "%0 created the wikipage %1" => "%0 created the wikipage %1",
// "Wiki pages deleted" => "Wiki pages deleted",
// "%0 deleted the wikipage %1" => "%0 deleted the wikipage %1",
// "and %0 more changes of the same type" => "and %0 more changes of the same type",
"Nothing has happened" => "Il ne s'est rien passé",
// "Report on %0 from %1 " => "Report on %0 from %1 ",
// "(no changes)" => "(no changes)",
// "(1 change)" => "(1 change)",
// "(%0 changes)" => "(%0 changes)",
// "Scheduler task is stalled" => "Scheduler task is stalled",
// "Scheduler task is already running" => "Scheduler task is already running",
// "Unable to decode task params" => "Unable to decode task params",
// "***** Running scheduler %s *****" => "***** Running scheduler %s *****",
// "Scheduler %0 (id: %1) is stalled" => "Scheduler %0 (id: %1) is stalled",
// "Skip scheduler %s - %s" => "Skip scheduler %s - %s",
// "***** Scheduler %s - FAILED *****\n%s" => "***** Scheduler %s - FAILED *****\n%s",
// "***** Scheduler %s - OK *****" => "***** Scheduler %s - OK *****",
// "Scheduler with id %0 does not exist or is not active" => "Scheduler with id %0 does not exist or is not active",
// "Scheduler `%0` (id: %1) is stalled" => "Scheduler `%0` (id: %1) is stalled",
// "Scheduler `%0` (id: %1) was healed" => "Scheduler `%0` (id: %1) was healed",
// "Scheduler `%0` (id: %1) was not healed" => "Scheduler `%0` (id: %1) was not healed",
// "Scheduler %0 (id: %1) is not stalled, no need to heal" => "Scheduler %0 (id: %1) is not stalled, no need to heal",
// "Missing parameters to run the command" => "Missing parameters to run the command",
// "Executing console command: %s" => "Executing console command: %s",
// "Console command" => "Console command",
// "Missing the URL to call" => "Missing the URL to call",
// "Missing the file path to where the output should be saved" => "Missing the file path to where the output should be saved",
// "URL to invoke: %s" => "URL to invoke: %s",
// "Save output to: %s" => "Save output to: %s",
// "Using basic authentication" => "Using basic authentication",
// "Including additional headers" => "Including additional headers",
// "Sending request" => "Sending request",
// "Request was successful" => "Request was successful",
// "Failed to open file %s to write" => "Failed to open file %s to write",
// "Request failed" => "Request failed",
"URL" => "Adresse Web",
// "Output File" => "Output File",
// "File path to save the output" => "File path to save the output",
// "Additional HTTP Headers" => "Additional HTTP Headers",
// "One HTTP Header per line" => "One HTTP Header per line",
// "Auth Username" => "Auth Username",
// "Auth Password" => "Auth Password",
// "Missing shell command to execute" => "Missing shell command to execute",
// "Executing shell command: %s" => "Executing shell command: %s",
// "Shell command" => "Shell command",
// "Run timeout" => "Run timeout",
// "in seconds" => "in seconds",
// "Checking tiki version" => "Checking tiki version",
// "Sending emails" => "Sending emails",
// "Tiki version email sent to" => "Tiki version email sent to",
// "Tiki Version Updated" => "Tiki Version Updated",
// "Tiki Updates: " => "Tiki Updates: ",
// "Tiki Updates" => "Tiki Updates",
// "Invalid cron time format" => "Invalid cron time format",
// "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1" => "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1",
// "Missing required action parameter or value: %0" => "Missing required action parameter or value: %0",
// "Cannot apply change_status action to an object type %0" => "Cannot apply change_status action to an object type %0",
// "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Tracker item %0 not found" => "Tracker item %0 not found",
// "Tracker item %0 status %1 is different than the \"from\" status %2" => "Tracker item %0 status %1 is different than the \"from\" status %2",
// "Cannot apply delete action to an aggregation type %0" => "Cannot apply delete action to an aggregation type %0",
// "Cannot apply delete action to an object type %0" => "Cannot apply delete action to an object type %0",
// "Tracker field %0 not found" => "Tracker field %0 not found",
// "Cannot find file to delete: %0" => "Cannot find file to delete: %0",
// "Are you sure you want to permanently delete this object" => "Are you sure you want to permanently delete this object",
// "EmailAction - send to %0, subject - %1" => "EmailAction - send to %0, subject - %1",
// "Error sending email: %0" => "Error sending email: %0",
// "Page %s cannot be found" => "Page %s cannot be found",
// "EmailAction - can't send new message" => "EmailAction - can't send new message",
// "Cannot apply filegal_change_filename action to an object type %0" => "Cannot apply filegal_change_filename action to an object type %0",
// "Tracker field %0 not found for tracker %1" => "Tracker field %0 not found for tracker %1",
// "Tracker field %0 is not a Files field type" => "Tracker field %0 is not a Files field type",
// "filegal_change_filename action missing value parameter" => "filegal_change_filename action missing value parameter",
// "Cannot apply filegal_image_overlay action to an object type %0" => "Cannot apply filegal_image_overlay action to an object type %0",
// "filegal_image_overlay action missing value parameter" => "filegal_image_overlay action missing value parameter",
// "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1" => "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1",
// "Cannot apply tracker_item_modify action to an aggregation type %0" => "Cannot apply tracker_item_modify action to an aggregation type %0",
// "Cannot apply tracker_item_modify action to an object type %0" => "Cannot apply tracker_item_modify action to an object type %0",
// "tracker_item_modify action missing value, calc, add or remove parameter" => "tracker_item_modify action missing value, calc, add or remove parameter",
// "Field %0 not found on Action TrackerItemModify" => "Field %0 not found on Action TrackerItemModify",
// "Error applying tracker_item_modify calc formula to item %0: %1" => "Error applying tracker_item_modify calc formula to item %0: %1",
// "Unknown search action step: %0" => "Unknown search action step: %0",
// "Cannot apply wiki_approval action to an object type %0" => "Cannot apply wiki_approval action to an object type %0",
// "Wiki page %0 is not in pending state" => "Wiki page %0 is not in pending state",
// "Wiki page %0 does not require approval" => "Wiki page %0 does not require approval",
"Tentative" => "Proposé",
"Confirmed" => "Confirmé",
"Cancelled" => "Annulé",
"unknown" => "inconnu",
"Unknown" => "Inconnu",
// "Tracker Status" => "Tracker Status",
// "Webservice %0 field \"%1\" not found" => "Webservice %0 field \"%1\" not found",
"%0 (latest)" => "%0 (le plus récent)",
// "Elasticsearch does not support optimize" => "Elasticsearch does not support optimize",
// "Federated index %0 not found" => "Federated index %0 not found",
// "Unknown mapping type \"%0\" for field \"%1\"" => "Unknown mapping type \"%0\" for field \"%1\"",
// "Document not found in index %1 (%0)" => "Document not found in index %1 (%0)",
// "String \"%0\" cannot be formatted as a number for field \"%1\"" => "String \"%0\" cannot be formatted as a number for field \"%1\"",
// "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker" => "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker",
// "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0" => "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0",
// "Feature not supported" => "Feature not supported",
// "Parsing search query failed: \"%0\"" => "Parsing search query failed: \"%0\"",
// "Sort field %0 not found in index" => "Sort field %0 not found in index",
"No results for query" => "Aucun résultat pour la requête",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "Template tplwiki page \"%0\" not found" => "Template tplwiki page \"%0\" not found",
// "Template wiki page \"%0\" not found" => "Template wiki page \"%0\" not found",
// "Error evaluating formula %0: %1" => "Error evaluating formula %0: %1",
"No value for '%0'" => "Pas de valeur pour '%0'",
"Unknown formatting rule '%0' for '%1'" => "Règle de formatage '%0' inconnue pour '%1'",
// "Category Tree" => "Category Tree",
"Categories" => "Catégories",
// "%0 (Tree)" => "%0 (Tree)",
"Tags" => "Mots-clés",
// "Letter" => "Letter",
// "First word" => "First word",
"Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "L'indexation a échoué en traitant \"%0\" (type %1) avec l'erreur \"%2\"",
// "Object %0 type %1 returned null from getDocument function" => "Object %0 type %1 returned null from getDocument function",
// "Could not perform index modification: %0" => "Could not perform index modification: %0",
// "Feature not supported: %0" => "Feature not supported: %0",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Range filter \"from\" parameter not valid: \"%0\"" => "Range filter \"from\" parameter not valid: \"%0\"",
// "Range filter \"to\" parameter not valid: \"%0\"" => "Range filter \"to\" parameter not valid: \"%0\"",
// "Range filter \"gap\" parameter not valid: \"%0\"" => "Range filter \"gap\" parameter not valid: \"%0\"",
// "The range filter is missing \\\"from\\\" or \\\"to\\\"" => "The range filter is missing \\\"from\\\" or \\\"to\\\"",
// "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"" => "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"",
// "Distance sort: Missing lat or lon arguments" => "Distance sort: Missing lat or lon arguments",
// "Script sort: Missing source argument" => "Script sort: Missing source argument",
// "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled" => "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
"Malformed search query" => "Requête de recherche invalide",
// "%0 (%1)" => "%0 (%1)",
// "Please confirm" => "Please confirm",
"OK" => "OK",
// "Are you sure you want to %0 the following %1" => "Are you sure you want to %0 the following %1",
// "Please confirm your action for the following item" => "Please confirm your action for the following item",
// "Please confirm your action for the following items" => "Please confirm your action for the following items",
// "Activity stream currently unavailable" => "Activity stream currently unavailable",
"Permission Denied" => "Permission refusée",
// "Activity rule deleted" => "Activity rule deleted",
// "%0 activity rules deleted" => "%0 activity rules deleted",
// "No activity rules deleted" => "No activity rules deleted",
// "Delete Rule" => "Delete Rule",
// "Activity (id:' . (string) \$id . " => "Activity (id:' . (string) \$id . ",
// "No activities deleted" => "No activities deleted",
// "Delete Activity" => "Delete Activity",
// "Sample activity rule %0 updated" => "Sample activity rule %0 updated",
// "Sample activity rule %0 created" => "Sample activity rule %0 created",
// "Sample activity rule %0 unchanged" => "Sample activity rule %0 unchanged",
// "Edit Rule %0" => "Edit Rule %0",
// "Create Sample Rule" => "Create Sample Rule",
// "Basic activity rule %0 updated" => "Basic activity rule %0 updated",
// "Basic activity rule %0 created" => "Basic activity rule %0 created",
// "Basic activity rule %0 unchanged" => "Basic activity rule %0 unchanged",
// "Create Record Rule" => "Create Record Rule",
// "Tracker activity rule %0 updated" => "Tracker activity rule %0 updated",
// "Tracker activity rule %0 created" => "Tracker activity rule %0 created",
// "Tracker activity rule %0 unchanged" => "Tracker activity rule %0 unchanged",
// "Create Tracker Rule" => "Create Tracker Rule",
// "Advanced activity rule %0 updated" => "Advanced activity rule %0 updated",
// "Advanced activity rule %0 created" => "Advanced activity rule %0 created",
// "Advanced activity rule %0 unchanged" => "Advanced activity rule %0 unchanged",
// "Create Advanced Rule" => "Create Advanced Rule",
"Sample" => "Résultat",
"Basic" => "De base",
"Advanced" => "Avancé",
// "Invalid rule type" => "Invalid rule type",
// "Type changed for activity rule %0" => "Type changed for activity rule %0",
// "Change Rule Type" => "Change Rule Type",
// "Status changed for activity rule %0" => "Status changed for activity rule %0",
// "Change Rule Status" => "Change Rule Status",
// "Content could not be loaded" => "Content could not be loaded",
// "Create article from URL" => "Create article from URL",
"Invalid input" => "Entrée non valide",
"Invalid data" => "Données non valides",
// "Authentication added or modified" => "Authentication added or modified",
// "Authentication not added or modified" => "Authentication not added or modified",
// "Authentication deleted" => "Authentication deleted",
// "Authentication not deleted" => "Authentication not deleted",
"Oops" => "Oups",
"Action not found (%0 in %1)" => "Action non trouvée (%0 dans %1)",
"Controller not found (%0)" => "Contrôleur non trouvé (%0)",
// "No change made for one object already in the category" => "No change made for one object already in the category",
// "No change made for %0 objects already in the category" => "No change made for %0 objects already in the category",
// "One object added to category" => "One object added to category",
// "%0 objects added to category" => "%0 objects added to category",
// "No objects added to category" => "No objects added to category",
// "No change made for one object not in the category" => "No change made for one object not in the category",
// "No change made for %0 objects not in the category" => "No change made for %0 objects not in the category",
// "One object removed from category" => "One object removed from category",
// "%0 objects removed from category" => "%0 objects removed from category",
// "No objects removed from category" => "No objects removed from category",
// "Invalid %0 ID: %1" => "Invalid %0 ID: %1",
"Comments not allowed on this page" => "Commentaires non autorisés sur cette page",
"Loading..." => "Chargement...",
"Comments" => "Commentaires",
"Parent is locked" => "Le parent est verrouillé",
"Pseudonym must be specified" => "Le pseudonyme doit être spécifié",
"Email must be specified" => "L'adresse courriel doit être spécifiée",
"Title is empty" => "Le titre est vide",
"Content is empty" => "Le contenu est vide",
// "Duplicated comment, there is already another comment with the same text" => "Duplicated comment, there is already another comment with the same text",
"Your comment was posted" => "Votre commentaire a été publié",
"Permissions denied" => "Permissions refusées",
// "Lock comments" => "Lock comments",
// "Unlock comments" => "Unlock comments",
"Comment not found" => "Commentaire non trouvé",
"Comment already approved" => "Commentaire déjà approuvé",
"Invalid argument" => "Argument non valide",
"Thread not specified" => "Fil de discussion non spécifié",
// "Comment permissions: %0 object %1 not found" => "Comment permissions: %0 object %1 not found",
"Feature disabled" => "Fonctionnalité désactivée",
"Reserved for administrators during development" => "Réservé aux administrateurs pendant le développement",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
"There was an error (Tiki Connect is still experimental). Please try again" => "Quelque chose s'est mal passé. Tiki Connect est encore expérimental. Merci d'essayer à nouveau",
"registration" => "enregistrement",
"confirmation" => "confirmation",
"Connect Feature disabled" => "Fonctionnalité 'Connect' desactivée",
"Connect server mode disabled" => "Mode serveur 'Connect' désactivé",
"Please confirm that you want to participate in Tiki Connect" => "Merci de confirmer que vous voulez participer à 'Tiki Connect'",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
"There was a problem at the server (Tiki Connect is still experimental)" => "Quelque chose s'est mal passé sur le serveur. 'Tiki Connect' est encore expérimental",
"CAPTCHA code problem" => "Problème de code Captcha",
"Connect data received, thanks" => "Données Connect reçues, merci",
"Your Tiki site is not registered here yet. Please try again" => "Votre Tiki n'est pas encore enregistré ici, merci d'essayer à nouveau",
// "Remove custom route" => "Remove custom route",
// "Inline editor update" => "Inline editor update",
"Preview" => "Aperçu",
// "Syntax Help" => "Syntax Help",
"WYSIWYG Help" => "Aide Wysiwyg",
"Plugin Help" => "Aide Plugiciels",
// "Spreadsheet Help" => "Spreadsheet Help",
// "Edit Help" => "Edit Help",
"Edit" => "Éditer",
// "Tracker %0 not found" => "Tracker %0 not found",
// "The following parameters could not be converted to plugin list at this stage:\n" => "The following parameters could not be converted to plugin list at this stage:\n",
// "Plugins found containing: %0" => "Plugins found containing: %0",
// "No plugins found containing: %0" => "No plugins found containing: %0",
// "You do not have permission to edit \"%0\"" => "You do not have permission to edit \"%0\"",
// "Undefined parameter" => "Undefined parameter",
"Missing parameters" => "Paramètres manquants",
// "%0 Plugin modified by editor" => "%0 Plugin modified by editor",
// "Page \"%0\" not found" => "Page \"%0\" not found",
// "%0 Plugin converted to list" => "%0 Plugin converted to list",
// "Plugin %0 on page %1 converted" => "Plugin %0 on page %1 converted",
"Authentication required" => "Authentification requise",
"Feature disabled: %0" => "Fonctionnalité désactivée : %0",
// "Edit conflict" => "Edit conflict",
// "Edit conflict: %0 \"%1\" is being edited already by %2" => "Edit conflict: %0 \"%1\" is being edited already by %2",
"Field Required" => "Champs requis",
"Not found" => "Non trouvé",
// "File Upload" => "File Upload",
// "File could not be uploaded" => "File could not be uploaded",
// "No file arrived" => "No file arrived",
// "File too large" => "File too large",
// "Unknown errors" => "Unknown errors",
// "File empty" => "File empty",
// "Batch file processed: \"%0\"" => "Batch file processed: \"%0\"",
"You don't have permission to upload zipped file packages" => "Aucun droit pour envoyer des paquetages de fichiers zippés",
"Browse" => "Parcourir",
// "Gallery List" => "Gallery List",
"Upload from source disabled" => "Téléchargement à partir de la source désactivé",
// "Unable to retrieve file from remote site. Please try a different URL" => "Unable to retrieve file from remote site. Please try a different URL",
"File could not be uploaded. Restrictions apply" => "Le fichier n'a pas pu être téléchargé. Des restrictions s'appliquent",
"Manual refresh disabled" => "Rafraîchissement manuel désactivé",
// "Gallery ID %0 not found" => "Gallery ID %0 not found",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help" => "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help",
"Requested gallery does not exist" => "La galerie demandée n'existe pas",
// "Vimeo not authenticated" => "Vimeo not authenticated",
// "Upload Video" => "Upload Video",
"Unknown error" => "Erreur inconnue",
// "No action was selected. Please select an action before clicking OK" => "No action was selected. Please select an action before clicking OK",
// "Merge selected posts with another topic" => "Merge selected posts with another topic",
// "Merge this post" => "Merge this post",
// "Merge these posts" => "Merge these posts",
// "Merge selected topics with another topic" => "Merge selected topics with another topic",
// "Merge this topic" => "Merge this topic",
// "Merge these topics" => "Merge these topics",
"Merge" => "Fusionner",
// "With this topic" => "With this topic",
// "All topics or posts were selected, leaving none to merge with. Please make your selection again" => "All topics or posts were selected, leaving none to merge with. Please make your selection again",
// "No topics were selected. Please select the topics you wish to merge before clicking the merge button" => "No topics were selected. Please select the topics you wish to merge before clicking the merge button",
// "The following post has been merged with the %0 topic" => "The following post has been merged with the %0 topic",
// "The following posts have been merged with the %0 topic" => "The following posts have been merged with the %0 topic",
"Move this topic" => "Déplacer ce sujet",
"Move these topics" => "Déplacer ces sujets",
// "From the %0 forum to the below forum" => "From the %0 forum to the below forum",
"Move selected topics to another forum" => "Déplacer les sujets sélectionnés vers un autre forum",
"Move" => "Déplacer",
"No topics were selected. Please select the topics you wish to move before clicking the move button" => "Aucun sujet n'a été sélectionné. Veuillez sélectionner les sujets que vous souhaitez déplacer avant de cliquer sur le bouton de déplacer",
"The following topic has been moved to the %0 forum" => "Le sujet suivant a été déplacé vers le %0 forum",
"The following topics have been moved to the %0 forum" => "Les sujets suivants ont été déplacés vers le %0 forum",
// "Delete the following forum %0" => "Delete the following forum %0",
"Delete" => "Supprimer",
"No topics were selected. Please select the topics you wish to delete before clicking the delete button" => "Aucun sujet n'a été sélectionné. Veuillez sélectionner les sujets que vous souhaitez supprimer avant de cliquer sur le bouton Supprimer",
"The following topic has been deleted" => "Le sujet suivant a été supprimé",
"The following topics have been deleted" => "Les sujets suivants ont été supprimés",
// "Delete the following attachment" => "Delete the following attachment",
"No attachments were selected. Please select an attachment to delete" => "Aucune pièce jointe n'a été sélectionnée. Veuillez sélectionner une pièce jointe à supprimer",
"The following attachment has been deleted" => "La pièce jointe suivante a été supprimée",
"The following attachments have been deleted" => "Les pièces jointes suivantes ont été supprimées",
"Reserved for forum administrators" => "Réservé aux administrateurs du forum",
// "Delete the following forum" => "Delete the following forum",
// "Delete the following forums" => "Delete the following forums",
"No forums were selected. Please select a forum to delete" => "Aucun forum n'a été sélectionné. Veuillez sélectionner un forum à supprimer",
"The following forum has been deleted" => "Le forum suivant a été supprimé",
"The following forums have been deleted" => "Les forums suivants ont été supprimés",
"Reserved for forum administrators and moderators" => "Réservé aux administrateurs du forum et aux modérateurs",
// "%0 the following topic" => "%0 the following topic",
// "%0 the following topics" => "%0 the following topics",
// "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button" => "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button",
"locked" => "verrouillé",
"unlocked" => "non verrouillé",
"The following topic has been %0" => "Le sujet suivant a été %0",
"The following topics have been %0" => "Les sujets suivants ont été %0",
// "%0 the following thread" => "%0 the following thread",
// "thread" => "thread",
// "No threads were selected. Please select the threads you wish to %0" => "No threads were selected. Please select the threads you wish to %0",
"archived" => "archivé",
"unarchived" => "désarchivé",
// "The following thread has been %0" => "The following thread has been %0",
// "The following thread have been %0" => "The following thread have been %0",
"The goal is currently disabled" => "L'objectif est actuellement désactivé",
"This goal is not enabled" => "Cet objectif n'est pas activé",
// "Not eligible for this goal" => "Not eligible for this goal",
// "The goal has not been evaluated, administrator view" => "The goal has not been evaluated, administrator view",
"Reserved for administrators" => "Réservé aux administrateurs",
"Manage Goals" => "Gérer les objectifs",
"Create Goal" => "Créer un objectif",
"Edit Goal" => "Modifier l'objectif",
"Remove Goal" => "Supprimer l'objectif",
"Conditions" => "Conditions",
"Pages created" => "Pages créées",
"Condition" => "Condition",
// "Rewards" => "Rewards",
// "No available rewards" => "No available rewards",
// "Reward" => "Reward",
"Restricted access" => "Accès restreint",
"Modify Eligibility for %0" => "Modifier l'éligibilité pour %0",
"Delete the following group" => "Supprimer le groupe suivant",
"Delete the following groups" => "Supprimer les groupes suivants",
"No groups were selected. Please select one or more groups" => "Aucun groupe n'a été sélectionné. Veuillez sélectionner un ou plusieurs groupes",
"The following group cannot be deleted" => "Le groupe suivant ne peut pas être supprimé",
"The following groups cannot be deleted" => "Les groupes suivants ne peuvent pas être supprimés",
"The following group has been deleted" => "Le groupe suivant a été supprimé",
"The following groups have been deleted" => "Les groupes suivants ont été supprimés",
"Group already exists" => "Ce groupe existe déjà",
"Create the group %0" => "Créer le groupe %0",
"Create" => "Créer",
// "Group name cannot be empty" => "Group name cannot be empty",
// "Group %0 (ID %1) successfully created" => "Group %0 (ID %1) successfully created",
// "Group %0 not created" => "Group %0 not created",
// "Modify the group %0" => "Modify the group %0",
// "Modify" => "Modify",
// "Group %0 successfully modified" => "Group %0 successfully modified",
// "Group %0 not modified" => "Group %0 not modified",
// "Add the following user to group %0" => "Add the following user to group %0",
// "Add the following users to group %0" => "Add the following users to group %0",
"Add" => "Ajouter",
// "One or more users must be selected" => "One or more users must be selected",
// "The following user was added to group %0" => "The following user was added to group %0",
// "The following users were added to group %0" => "The following users were added to group %0",
// "Ban the following user from group %0" => "Ban the following user from group %0",
// "Ban the following users from group %0" => "Ban the following users from group %0",
// "Ban" => "Ban",
// "The following user was banned from group %0" => "The following user was banned from group %0",
// "The following users were banned from group %0" => "The following users were banned from group %0",
// "Unban the following user from group %0" => "Unban the following user from group %0",
// "Unban the following users from group %0" => "Unban the following users from group %0",
// "Unban" => "Unban",
// "The following user was unbanned from group %0" => "The following user was unbanned from group %0",
// "The following users were unbanned from group %0" => "The following users were unbanned from group %0",
// "h5p_enabled" => "h5p_enabled",
// "Create H5P Content" => "Create H5P Content",
// "Create H5P content" => "Create H5P content",
// "H5P Embed" => "H5P Embed",
// "No fileID provided" => "No fileID provided",
// "H5P Plugin" => "H5P Plugin",
// "Cannot find H5P content with fileId: %0" => "Cannot find H5P content with fileId: %0",
// "Edit H5P Content" => "Edit H5P Content",
// "H5P Edit" => "H5P Edit",
// "Waiting for javascript.." => "Waiting for javascript..",
// "H5P Content Libraries" => "H5P Content Libraries",
// "File not found on server. Check file upload settings" => "File not found on server. Check file upload settings",
// "H5P Results" => "H5P Results",
// "No contentId provided" => "No contentId provided",
// "H5P User Data" => "H5P User Data",
// "H5P User Results" => "H5P User Results",
// "You have successfully added %0 new media items" => "You have successfully added %0 new media items",
// "You have successfully added one new media item" => "You have successfully added one new media item",
// "No language provided" => "No language provided",
// "lang/\$language directory is not writable" => "lang/\$language directory is not writable",
"Wrote %d new strings and updated %d to lang/%s/language.php" => "Enregistrement de %d nouvelles chaines et %d mise à jour dans lang/%s/language.php",
"Write to language.php" => "Écrire dans language.php",
"Custom Translations" => " Traductions personnalisées",
// "Invalid file type" => "Invalid file type",
// "File does not exist" => "File does not exist",
// "Invalid file type: php not allowed" => "Invalid file type: php not allowed",
"Upload Translations" => "Téléverser des traductions",
"Feature Disabled" => "Fonctionnalité désactivée",
// "Invalid file parameter supplied" => "Invalid file parameter supplied",
"Translation not supported for the specified object type" => "Traduction non supportée pour le type d'objet spécifié",
"No source provided" => "Aucune source précisée",
"Manage translations" => "Gérer les traductions",
"No source or target provided" => "Aucune source ou cible précisée",
// "You do not have permission to attach the selected translations" => "You do not have permission to attach the selected translations",
"Could not attach the translations" => "N'a pas pu attacher les traductions",
// "You do not have permission to detach the selected translations" => "You do not have permission to detach the selected translations",
"The object has no language indicated and cannot be translated" => "L'objet n'a aucune langue et ne peut donc être traduit",
// "The language directory is not readable" => "The language directory is not readable",
// "The language directory is not writeable" => "The language directory is not writeable",
// "String translation set is not an array" => "String translation set is not an array",
// "Can not fopen custom.php" => "Can not fopen custom.php",
// "Can not fwrite custom.php" => "Can not fwrite custom.php",
// "Source string translation set is not an array" => "Source string translation set is not an array",
// "Target string translation set is not an array" => "Target string translation set is not an array",
// "Invalid process type" => "Invalid process type",
// "Add new and update existing" => "Add new and update existing",
// "Add new only" => "Add new only",
// "Update existing only" => "Update existing only",
// "Replace all" => "Replace all",
// "Failed to connect or authenticate with remote host" => "Failed to connect or authenticate with remote host",
// "Account created or modified" => "Account created or modified",
// "Account not created or modified" => "Account not created or modified",
// "Modify Account" => "Modify Account",
// "Create Account" => "Create Account",
// "Account removed" => "Account removed",
// "Account not removed" => "Account not removed",
// "Remove Account" => "Remove Account",
// "Menu %0 not found" => "Menu %0 not found",
// "The %0 menu has been edited" => "The %0 menu has been edited",
// "The %0 menu has been created" => "The %0 menu has been created",
// "An error occurred - the %0 menu may not have been edited" => "An error occurred - the %0 menu may not have been edited",
// "An error occurred - the %0 menu may not have been created" => "An error occurred - the %0 menu may not have been created",
// "Edit Menu" => "Edit Menu",
// "Create Menu" => "Create Menu",
// "Menu %0 cloned as menu %1" => "Menu %0 cloned as menu %1",
"Clone this menu and its options" => "Cloner ce menu et ses options",
// "Menu option %0 not found" => "Menu option %0 not found",
// "Menu Option %0" => "Menu Option %0",
// "Create Menu Option" => "Create Menu Option",
// "Your menu options have been imported" => "Your menu options have been imported",
// "Import Menu Options" => "Import Menu Options",
// "Menu Preview" => "Menu Preview",
// "The %0 menu has been removed" => "The %0 menu has been removed",
// "The %0 menu has not been removed" => "The %0 menu has not been removed",
// "Delete the %0 menu" => "Delete the %0 menu",
// "You don't have permission to edit menus (tiki_p_edit_menu)" => "You don't have permission to edit menus (tiki_p_edit_menu)",
// "You don't have permission to edit menu options (tiki_p_edit_menu_option)" => "You don't have permission to edit menu options (tiki_p_edit_menu_option)",
// "You don't have permission to edit menu options (edit_menu_option)" => "You don't have permission to edit menu options (edit_menu_option)",
// "Must Read" => "Must Read",
// "Invalid request method" => "Invalid request method",
// "Cannot circulate" => "Cannot circulate",
// "Circulate" => "Circulate",
// "Group does not exist" => "Group does not exist",
// "Misconfigured feature" => "Misconfigured feature",
// "Target field not found" => "Target field not found",
// "Object not found" => "Object not found",
// "Must Read for %0" => "Must Read for %0",
// "Must Read Item not found" => "Must Read Item not found",
"Read" => "Lu",
// "Respond Privately" => "Respond Privately",
"Completed" => "Terminé",
// "Missing %0 parameter" => "Missing %0 parameter",
// "Not Found" => "Not Found",
// "No box available for %0" => "No box available for %0",
// "Invalid attribute name \"%0\"" => "Invalid attribute name \"%0\"",
// "Cannot lock \"%0\"" => "Cannot lock \"%0\"",
// "Reserved for payment administrators" => "Reserved for payment administrators",
// "Recommendations for %0" => "Recommendations for %0",
"Remote service inaccessible (%0)" => "Service distant inaccessible (%0)",
// "Execution output" => "Execution output",
// "Scheduler %0 - FAILED" => "Scheduler %0 - FAILED",
// "Scheduler %0 - OK" => "Scheduler %0 - OK",
// "Running %0" => "Running %0",
// "Reset scheduler run" => "Reset scheduler run",
"Rebuild Index" => "Reconstruire l'index",
// "Process Update Queue" => "Process Update Queue",
"empty" => "vide",
// "Lookup Result" => "Lookup Result",
// "ManifoldCF Configuration Check" => "ManifoldCF Configuration Check",
// "Create ManifoldCF Index" => "Create ManifoldCF Index",
// "A query could not be created because the name is already in use" => "A query could not be created because the name is already in use",
// "Could not obtain the query" => "Could not obtain the query",
// "Save Search" => "Save Search",
// "Saved Searches" => "Saved Searches",
// "Delete Saved Search" => "Delete Saved Search",
// "Edit Saved Search" => "Edit Saved Search",
// "Search functionality currently unavailable" => "Search functionality currently unavailable",
// "Theme Customizer" => "Theme Customizer",
// "Item not found" => "Item not found",
"Reserved for tracker administrators" => "Reservé aux administrateurs de formulaire",
"Type does not exist" => "Le type n'existe pas",
"Add Field" => "Ajouter un champ",
// "Warning: There is a conflict in permanent names, which can cause indexing errors" => "Warning: There is a conflict in permanent names, which can cause indexing errors",
// "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4" => "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4",
// "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen" => "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
"Tracker contains no listed field, no meaningful information will be provided in the default list" => "Le formulaire ne contient aucun champ listé, aucune information significative ne sera fournie dans la liste par défaut",
"The tracker contains no field in the title, so no link will be generated" => "Le formulaire ne contient aucun champ dans le titre, aucun lien ne sera généré",
// "Field handler not found" => "Field handler not found",
// "%0" => "%0",
"CAPTCHA" => "CAPTCHA",
"Distinct" => "Distinct",
"Page Name" => "Nom de la page",
"Password" => "Mot de passe",
"Regular Expression (Pattern)" => "Expression régulière (Modèle)",
"Username" => "Nom d'utilisateur",
// "Export Fields" => "Export Fields",
"Invalid data provided" => "Données fournies non valides",
"Import Tracker Fields" => "Importer les champs du formulaire",
// "No item to clone" => "No item to clone",
// "Duplicate Item" => "Duplicate Item",
// "Item could not be created. Only one item per user is allowed" => "Item could not be created. Only one item per user is allowed",
// "Item created" => "Item created",
// "New \"%0\" item successfully created" => "New \"%0\" item successfully created",
// "New tracker item %0 successfully created" => "New tracker item %0 successfully created",
// "Tracker item could not be created" => "Tracker item could not be created",
"Create Item" => "Créer une fiche",
// "Tracker item %0 has been updated" => "Tracker item %0 has been updated",
// "%0: Updated \"%1\"" => "%0: Updated \"%1\"",
// "Comment for edit #%0" => "Comment for edit #%0",
// "Update Item" => "Update Item",
// "Are you sure you would like to update this item" => "Are you sure you would like to update this item",
"Save" => "Enregistrer",
// "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0" => "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0",
// "Tracker item %0 has been successfully deleted" => "Tracker item %0 has been successfully deleted",
"Remove" => "Supprimer",
// "Validation error" => "Validation error",
// "Create Tracker" => "Create Tracker",
"Duplicate Tracker" => "Dupliquer le formulaire",
// "Export Items" => "Export Items",
// "Import Tracker Structure" => "Import Tracker Structure",
"File upload failed" => "L'envoi du fichier a échoué",
"Uploaded file could not be read" => "Le fichier envoyé n'a pas pu être lu",
// "Import Items" => "Import Items",
// "Import Tracker From Profile/YAML" => "Import Tracker From Profile/YAML",
"Last Modification" => "Dernière modification",
"Creation Date" => "Date de création",
"Item ID" => "Identificateur de fiche",
"Filename" => "Nom du fichier",
"Creation date" => "Date de création",
"Views" => "Vues",
"File size" => "Taille du fichier",
"Version" => "Version",
"File type" => "Type du fichier",
"Long description" => "Description longue",
"User" => "Utilisateur",
// "Select Tracker" => "Select Tracker",
"You don't have permission to view the tracker" => "Non autorisé à voir le formulaire",
// "The item to clone isn't visible" => "The item to clone isn't visible",
// "You don't have permission to create new items" => "You don't have permission to create new items",
// "Cannot remove item %0 from this tracker" => "Cannot remove item %0 from this tracker",
"You don't have permission to export" => "Non autorisé à exporter",
"Remote Source" => "Source distante",
"Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Champ généré automatiquement pour les formulaires synchronisés. Contient l'identifiant de la fiche distante",
// "Clone Remote Tracker" => "Clone Remote Tracker",
"Tracker does not exist" => "Le formulaire n'existe pas",
"Tracker is not synchronized with a remote source" => "Le formulaire n'est pas synchronisé avec la source distante",
// "Tabular Formats" => "Tabular Formats",
// "Remove Format" => "Remove Format",
// "Create Tabular Format" => "Create Tabular Format",
// "Edit Format: %0" => "Edit Format: %0",
// "Format %0 not found" => "Format %0 not found",
// "Duplicate Format: %0" => "Duplicate Format: %0",
// "%0 copy" => "%0 copy",
// "Fields in %0" => "Fields in %0",
// "No formats available" => "No formats available",
// "Select Format" => "Select Format",
// "Primary Key required" => "Primary Key required",
// "Your import was completed successfully" => "Your import was completed successfully",
"Import" => "Importer",
// "Filter %0" => "Filter %0",
"Filter" => "Filtrer",
"Export %0" => "Exporter %0",
"Export" => "Exporter",
// "Create tabular format and tracker from file" => "Create tabular format and tracker from file",
"Operation reserved for tracker administrators" => "Opération reservée aux administrateurs de formulaire",
"Events" => "Évènements",
"The following mandatory fields are missing: %0" => "Les champs obligatoires suivants sont manquants : %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
// "Field %0 does not exist in tracker" => "Field %0 does not exist in tracker",
// "The terms and conditions were modified while you were reading them" => "The terms and conditions were modified while you were reading them",
// "You are required to approve the terms of use to continue" => "You are required to approve the terms of use to continue",
// "Terms and Conditions" => "Terms and Conditions",
// "You must enter your date of birth to continue" => "You must enter your date of birth to continue",
// "Age Validation" => "Age Validation",
// "We were unable to create your account because this email is already in use" => "We were unable to create your account because this email is already in use",
"Friend" => "Ami",
// "Remove Friend" => "Remove Friend",
"Add Friend" => "Rajoutez un ami",
"Following you" => "Vous suivant",
// "Remove Follower" => "Remove Follower",
// "You are following" => "You are following",
// "Stop Following" => "Stop Following",
"Follow" => "Suivre",
// "Awaiting your approval" => "Awaiting your approval",
// "Refuse Request" => "Refuse Request",
// "Accept &amp; Add" => "Accept &amp; Add",
// "Accept Request" => "Accept Request",
// "Waiting for approval" => "Waiting for approval",
// "Cancel Request" => "Cancel Request",
"Hidden" => "Caché",
"km" => "km",
// "You need to set \"Show my information on mouseover\"" => "You need to set \"Show my information on mouseover\"",
"Click here" => "Cliquer ici",
// "You need to log in" => "You need to log in",
// "Delete the following user" => "Delete the following user",
// "Delete the following users" => "Delete the following users",
// "No users were selected. Please select one or more users" => "No users were selected. Please select one or more users",
// "The following user has been deleted" => "The following user has been deleted",
// "Submit form below to ban this user" => "Submit form below to ban this user",
// "The following users have been deleted" => "The following users have been deleted",
// "Submit form below to ban these users" => "Submit form below to ban these users",
// "Ban the following user's IP" => "Ban the following user's IP",
// "Clicking Ban will redirect you to a form where this user's is preselected for IP banning" => "Clicking Ban will redirect you to a form where this user's is preselected for IP banning",
// "Ban the following users' IPs" => "Ban the following users' IPs",
// "Clicking Ban will redirect you to a form where these users' are preselected for IP banning" => "Clicking Ban will redirect you to a form where these users' are preselected for IP banning",
// "See highlighted section in the form below for users you have selected for banning" => "See highlighted section in the form below for users you have selected for banning",
// "Remove the following user from group %0" => "Remove the following user from group %0",
// "For this user" => "For this user",
// "For these selected users" => "For these selected users",
// "Change group assignments for selected users" => "Change group assignments for selected users",
"%s %s assigned to %s %s" => "%s %s attribué à %s %s",
"user" => "utilisateur",
"group" => "Groupes",
// "An error occurred. The group assignment failed" => "An error occurred. The group assignment failed",
"%s %s removed from %s %s." => "%s %s supprimé de %s %s.",
// "The following user" => "The following user",
// "The following users" => "The following users",
// "%0 had the following group set as default" => "%0 had the following group set as default",
// "%0 been %1 the following %2" => "%0 been %1 the following %2",
// "Set default group for selected users" => "Set default group for selected users",
// "Make this the default group" => "Make this the default group",
// "group %s set as the default group for user %s" => "group %s set as the default group for user %s",
// "For the following user" => "For the following user",
// "For the following users" => "For the following users",
// "The following group has been set as the default group" => "The following group has been set as the default group",
// "Send wiki page content by email to selected users" => "Send wiki page content by email to selected users",
"Page not found" => "Aucune page trouvée",
// "The page does not have a description, which is mandatory to perform this action" => "The page does not have a description, which is mandatory to perform this action",
// "Invalid bcc email address" => "Invalid bcc email address",
// "and blind copied (bcc) to %0" => "and blind copied (bcc) to %0",
// "The template page has no text or the text cannot be extracted" => "The template page has no text or the text cannot be extracted",
// "Mail sent to user %s" => "Mail sent to user %s",
// "The page %0 has been emailed to the following user" => "The page %0 has been emailed to the following user",
// "The page %0 has been emailed to the following users" => "The page %0 has been emailed to the following users",
// "And blind copied to %0" => "And blind copied to %0",
// "No user was selected" => "No user was selected",
// "Message not sent - no subject or body" => "Message not sent - no subject or body",
// "Your message was successfully sent to %0" => "Your message was successfully sent to %0",
"An error occurred, please check your mail settings and try again" => "Une erreur est survenue, merci de vérifier vos réglages de mail et de réessayer",
// "Please specify validity period" => "Please specify validity period",
// "The group %0 does not exist" => "The group %0 does not exist",
// "Your invite has been sent" => "Your invite has been sent",
// "You must set a user for whom to set an avatar" => "You must set a user for whom to set an avatar",
// "You do not have the permission to change the avatar" => "You do not have the permission to change the avatar",
// "You must select an avatar to upload" => "You must select an avatar to upload",
// "An error occurred. User page for %0 could not be deleted" => "An error occurred. User page for %0 could not be deleted",
"Deleted account %s" => "Supprimer le compte %s",
// "An error occurred. User %0 could not be deleted" => "An error occurred. User %0 could not be deleted",
// "secure connection required" => "secure connection required",
// "You cannot see this user's data" => "You cannot see this user's data",
// "Send Me a Message" => "Send Me a Message",
// "Upload Avatar" => "Upload Avatar",
"Must be authenticated" => "Doit être authentifié",
// "Notifications for %0" => "Notifications for %0",
// "No notifications" => "No notifications",
"Notifications" => "Notifications",
// "Unread Notifications" => "Unread Notifications",
// "Mark all notifications as read" => "Mark all notifications as read",
// "Must be registered" => "Must be registered",
// "Friend List" => "Friend List",
// "User not found" => "User not found",
// "Approve Friend" => "Approve Friend",
// "Regenerate Wiki URLs" => "Regenerate Wiki URLs",
// "the only version of" => "the only version of",
// "all versions of" => "all versions of",
// "the last version of" => "the last version of",
// "Delete %0 the following %1" => "Delete %0 the following %1",
// "You do not have permission to remove the selected page(s)" => "You do not have permission to remove the selected page(s)",
// "No pages were selected. Please select one or more pages" => "No pages were selected. Please select one or more pages",
// "An error occurred. %0%1 could not be deleted" => "An error occurred. %0%1 could not be deleted",
"All versions" => "Toutes versions",
// "The last version" => "The last version",
// "Version %0" => "Version %0",
// "%0 of the following page %1 been deleted" => "%0 of the following page %1 been deleted",
// "%0 of the following pages %1 been deleted" => "%0 of the following pages %1 been deleted",
// "Redirection page not specified. 301 redirect not created" => "Redirection page not specified. 301 redirect not created",
// "Semantic aliases (301 Redirects) to this page were created when other pages were deleted" => "Semantic aliases (301 Redirects) to this page were created when other pages were deleted",
// "A semantic alias (301 Redirect) to this page was created when page %0 was deleted" => "A semantic alias (301 Redirect) to this page was created when page %0 was deleted",
// "301 Redirects to the following page were created" => "301 Redirects to the following page were created",
// "A 301 Redirect to the following page was created" => "A 301 Redirect to the following page was created",
// "The following page and 301 Redirects to it were created" => "The following page and 301 Redirects to it were created",
// "The following page and a 301 Redirect to it were created" => "The following page and a 301 Redirect to it were created",
// "Delete the following %0 of %1" => "Delete the following %0 of %1",
// "No version were selected. Please select one or more versions" => "No version were selected. Please select one or more versions",
// "An error occurred. Version %0 could not be deleted" => "An error occurred. Version %0 could not be deleted",
// "The following version of %0 has been deleted" => "The following version of %0 has been deleted",
// "The following versions of %0 have been deleted" => "The following versions of %0 have been deleted",
// "Print the following page" => "Print the following page",
// "Print the following pages" => "Print the following pages",
"Print" => "Imprimer",
// "No page specified" => "No page specified",
// "Export the following page to PDF" => "Export the following page to PDF",
// "Export the following pages to PDF" => "Export the following pages to PDF",
"PDF" => "PDF",
// "Lock the following page" => "Lock the following page",
// "Lock the following pages" => "Lock the following pages",
"Lock" => "Verrouiller",
// "Excludes selected pages already locked or for which you lack permission to lock" => "Excludes selected pages already locked or for which you lack permission to lock",
// "You do not have permission to lock the selected pages or they have already been locked" => "You do not have permission to lock the selected pages or they have already been locked",
// "The following page was not locked due to an error" => "The following page was not locked due to an error",
// "The following pages were not locked due to an error" => "The following pages were not locked due to an error",
// "The following page has been locked" => "The following page has been locked",
// "The following pages have been locked" => "The following pages have been locked",
// "Unlock the following page" => "Unlock the following page",
// "Unlock the following pages" => "Unlock the following pages",
"Unlock" => "Déverrouiller",
// "Excludes selected pages already unlocked or for which you lack permission to unlock" => "Excludes selected pages already unlocked or for which you lack permission to unlock",
// "You do not have permission to unlock the selected pages or they have already been unlocked" => "You do not have permission to unlock the selected pages or they have already been unlocked",
// "The following page was not unlocked due to an error" => "The following page was not unlocked due to an error",
// "The following pages were not unlocked due to an error" => "The following pages were not unlocked due to an error",
// "The following page has been unlocked" => "The following page has been unlocked",
// "The following pages have been unlocked" => "The following pages have been unlocked",
// "Download a zipped file of the following page" => "Download a zipped file of the following page",
// "Download a zipped file of the following pages" => "Download a zipped file of the following pages",
// "Zip" => "Zip",
// "Add page name as header of the following page" => "Add page name as header of the following page",
// "Add page name as header of the following pages" => "Add page name as header of the following pages",
// "The following page was not found" => "The following page was not found",
// "The following pages were not found" => "The following pages were not found",
// "The page name was added as header to the following page" => "The page name was added as header to the following page",
// "The page name was added as header to the following pages" => "The page name was added as header to the following pages",
// "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents",
// "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents",
// "Create Workspace" => "Create Workspace",
// "Workspace Templates" => "Workspace Templates",
// "Create Workspace Template" => "Create Workspace Template",
// "Edit template %0" => "Edit template %0",
// "Workspaces" => "Workspaces",
// "Could not create workspace root" => "Could not create workspace root",
"Invalid user" => "Utilisateur invalide",
// "Invalid token" => "Invalid token",
// "Empty authorization" => "Empty authorization",
// "Wrong authorization format" => "Wrong authorization format",
// "You don't have enough privileges" => "You don't have enough privileges",
// "Select a filter" => "Select a filter",
"n/a" => "n/d",
// "Server-side Processing" => "Server-side Processing",
// "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort" => "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort",
// "Overall Sort Settings" => "Overall Sort Settings",
// "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts" => "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts",
"Pre-sorted Columns" => "Colonnes pré-triées",
// "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns" => "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns",
// "Sort Settings by Column" => "Sort Settings by Column",
// "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5" => "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5",
// "Set %0 to one of the following" => "Set %0 to one of the following",
// "Also handle strings in numeric columns with" => "Also handle strings in numeric columns with",
// "Handle empty cells with" => "Handle empty cells with",
// "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)" => "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)",
// "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5" => "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5",
// "Column Filters" => "Column Filters",
// "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters" => "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters",
// "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)" => "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)",
// "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>" => "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>",
// "Options generated automatically if not set and the %0server%1 parameter is not %0y%1" => "Options generated automatically if not set and the %0server%1 parameter is not %0y%1",
// "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown" => "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown",
// "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually" => "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually",
// "Date range - " => "Date range - ",
// "(from and to values set defaults for these fields when user clicks on the input field)" => "(from and to values set defaults for these fields when user clicks on the input field)",
// "Beware that items with empty date values will not be shown when default date range filters are applied" => "Beware that items with empty date values will not be shown when default date range filters are applied",
// "Numeric range - " => "Numeric range - ",
// "No filter - " => "No filter - ",
// "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list" => "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list",
// "Filter Options" => "Filter Options",
// "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1" => "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1",
// "Paginate" => "Paginate",
// "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: " => "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: ",
// "Column Select" => "Column Select",
// "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns" => "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns",
// "Totals" => "Totals",
// "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1" => "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1",
// "Setting to %0 will add one column total row set as follows: %1" => "Setting to %0 will add one column total row set as follows: %1",
// "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations" => "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations",
// "Instructions for each total option follows" => "Instructions for each total option follows",
// "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total" => "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total",
// "set what the calculation is. Choices are" => "set what the calculation is. Choices are",
// "Click %0 for a description of these options" => "Click %0 for a description of these options",
// "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)" => "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)",
// "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals" => "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals",
// "Total Format" => "Total Format",
// "Format for table totals (click %0 for patterns). Example" => "Format for table totals (click %0 for patterns). Example",
// "Total Options" => "Total Options",
// "Pipe-separated options for totals for each column which are set in the %0 parameter" => "Pipe-separated options for totals for each column which are set in the %0 parameter",
// "overrides the default number format set in %0" => "overrides the default number format set in %0",
// "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter" => "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter",
"Example:" => "Exemple :",
// "Page totals" => "Page totals",
// "Please install Faker package" => "Please install Faker package",
// "Object \"%0\" of type \"%1\" not found" => "Object \"%0\" of type \"%1\" not found",
// "The value of items is not a number" => "The value of items is not a number",
// "Tracker not found" => "Tracker not found",
// "Invalid field definition: %0" => "Invalid field definition: %0",
// "Checking for image gallery files skipped" => "Checking for image gallery files skipped",
// "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter" => "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter",
// "Tracker Attachments" => "Tracker Attachments",
// "Wiki Attachments" => "Wiki Attachments",
// "Forum Attachments" => "Forum Attachments",
// "Configured to stores files in Database" => "Configured to stores files in Database",
// "Configured to stores files on Disk: %0" => "Configured to stores files on Disk: %0",
// "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files" => "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files",
// "Files in DB: %0" => "Files in DB: %0",
// "Files on Disk: %0" => "Files on Disk: %0",
// "No Issues found" => "No Issues found",
// "Found %0 Issues, details below" => "Found %0 Issues, details below",
// "The following files are missing" => "The following files are missing",
"Id" => "ID",
// "The following files have different size that expected" => "The following files have different size that expected",
// "The following files are unknown, exists in the folder, but not in the database" => "The following files are unknown, exists in the folder, but not in the database",
// "Copy files from file galleries to a regular directory on the file system" => "Copy files from file galleries to a regular directory on the file system",
// "Feature Galleries not set up" => "Feature Galleries not set up",
// "File Copy: Gallery #%0 not found" => "File Copy: Gallery #%0 not found",
// "File Copy: Destination path required" => "File Copy: Destination path required",
// "No files to copy" => "No files to copy",
// "File Copy starting.." => "File Copy starting..",
// "File Copy complete" => "File Copy complete",
// "Move files from file galleries to a regular directory on the file system" => "Move files from file galleries to a regular directory on the file system",
// "File Move: Gallery #%0 not found" => "File Move: Gallery #%0 not found",
// "File Move: Destination path required" => "File Move: Destination path required",
// "No files to move" => "No files to move",
// "Use the --confirm option to proceed with the move operation" => "Use the --confirm option to proceed with the move operation",
// "File Move starting.." => "File Move starting..",
// "File Move complete" => "File Move complete",
// "Migrate images from the Image Gallery to the File Gallery" => "Migrate images from the Image Gallery to the File Gallery",
// "All files migrated" => "All files migrated",
// "No files migrated, default file gallery path is not writable" => "No files migrated, default file gallery path is not writable",
// "%0 reached for %1 (%2)" => "%0 reached for %1 (%2)",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
// "Clean Tiki install" => "Clean Tiki install",
// "Force installation. Overwrite any current database" => "Force installation. Overwrite any current database",
// "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM" => "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM",
// "Installation completed" => "Installation completed",
// "Queries executed successfully: %0" => "Queries executed successfully: %0",
// "Error %0 in" => "Error %0 in",
// "Database already exists" => "Database already exists",
// "Dependencies not satisfied. Exiting" => "Dependencies not satisfied. Exiting",
// "Composer could not be executed" => "Composer could not be executed",
// "Extension %0 is now disabled" => "Extension %0 is now disabled",
// "Extension %0 was not disabled" => "Extension %0 was not disabled",
// "Extension %0 was updated" => "Extension %0 was updated",
// "Extension %0 is now enabled" => "Extension %0 is now enabled",
// "Extension %0 was not enabled" => "Extension %0 was not enabled",
// "Installing package: " => "Installing package: ",
// "Invalid Package: " => "Invalid Package: ",
// "No packages available to be installed" => "No packages available to be installed",
// "No packages found in composer.json in the root of the project" => "No packages found in composer.json in the root of the project",
// "No packages installed" => "No packages installed",
// "Packages Installed" => "Packages Installed",
// "Packages Available to Install" => "Packages Available to Install",
// "No packages available to be removed" => "No packages available to be removed",
// "Removing package: " => "Removing package: ",
// "Packages that can be removed" => "Packages that can be removed",
// "No packages available to be updated" => "No packages available to be updated",
// "Updating package: " => "Updating package: ",
// "Packages that can be updated" => "Packages that can be updated",
// "Approve a list of plugin invocations/calls" => "Approve a list of plugin invocations/calls",
// "List fingerprints of the plugin invocations/calls to approve separated by commas" => "List fingerprints of the plugin invocations/calls to approve separated by commas",
// "Approve all plugin invocations/calls" => "Approve all plugin invocations/calls",
// "You must either use the option --all or provide a list of fingerprints to approve" => "You must either use the option --all or provide a list of fingerprints to approve",
// "Approving all pending plugins" => "Approving all pending plugins",
// "Approving a list of plugins" => "Approving a list of plugins",
// "Approving plugin %0" => "Approving plugin %0",
// "Plugins approved with success" => "Plugins approved with success",
// "List all plugin invocations/calls" => "List all plugin invocations/calls",
// "Shows only invocations/calls pending approval" => "Shows only invocations/calls pending approval",
// "Listing plugins in status: %0" => "Listing plugins in status: %0",
// "Found %0 plugins" => "Found %0 plugins",
// "No plugins found" => "No plugins found",
// "Parses all the pages to refresh the list of plugin invocations/calls" => "Parses all the pages to refresh the list of plugin invocations/calls",
// "Plugin list refreshed with success" => "Plugin list refreshed with success",
// "Not enough arguments (missing: \"article\" or \"--all\" options)" => "Not enough arguments (missing: \"article\" or \"--all\" options)",
// "Not enough arguments (missing: \"calendar\" or \"--all\" option)" => "Not enough arguments (missing: \"calendar\" or \"--all\" option)",
// "Not enough arguments (missing: \"category\" or \"--all\" options)" => "Not enough arguments (missing: \"category\" or \"--all\" options)",
// "Not enough arguments (missing: \"forum\" or \"--all\" option)" => "Not enough arguments (missing: \"forum\" or \"--all\" option)",
// "Not enough arguments (missing: \"menu\" or \"--all\" option)" => "Not enough arguments (missing: \"menu\" or \"--all\" option)",
// "Not enough arguments (missing: \"name\" or \"--all\" options)" => "Not enough arguments (missing: \"name\" or \"--all\" options)",
// "Not enough arguments (missing: \"tracker\" or \"--all\" option)" => "Not enough arguments (missing: \"tracker\" or \"--all\" option)",
// "No Items found to export" => "No Items found to export",
// "Tracker item %0 exported" => "Tracker item %0 exported",
// "Tracker item %0 failed to exported" => "Tracker item %0 failed to exported",
// "Tracker items for tracker %0 exported" => "Tracker items for tracker %0 exported",
// "Not enough arguments (missing: \"page\" or \"--all\" option)" => "Not enough arguments (missing: \"page\" or \"--all\" option)",
// "Profile name" => "Profile name",
// "profiles.tiki.org" => "profiles.tiki.org",
// "Re-apply profiles when already applied" => "Re-apply profiles when already applied",
// "Return to the user information about what is going to be applied" => "Return to the user information about what is going to be applied",
// "Some of the named object references in the profile are invalid" => "Some of the named object references in the profile are invalid",
// "Profile applied" => "Profile applied",
// "Installation failed" => "Installation failed",
// "Dry-run for profile: " => "Dry-run for profile: ",
// "Permission removed: " => "Permission removed: ",
// "Permission added: " => "Permission added: ",
// "User modified: " => "User modified: ",
// "User added: " => "User added: ",
// "Group modified: " => "Group modified: ",
// "Group added: " => "Group added: ",
// "Preference set: %0= %1 old value= %2" => "Preference set: %0= %1 old value= %2",
// "Installer added: " => "Installer added: ",
// "Profile was already applied. Nothing happened" => "Profile was already applied. Nothing happened",
// "SCSS Parse Error" => "SCSS Parse Error",
// "SCSS Compiler Error" => "SCSS Compiler Error",
// "SCSS Range Error" => "SCSS Range Error",
// "SCSS Server Error" => "SCSS Server Error",
// "SCSS Error" => "SCSS Error",
// "Preference \"sitemap_enable\" is not enabled" => "Preference \"sitemap_enable\" is not enabled",
// "New sitemap created" => "New sitemap created",
"File not found" => "Fichier non trouvé",
// "File is not a .zip file" => "File is not a .zip file",
// "Theme installed" => "Theme installed",
// "Theme not found" => "Theme not found",
// "Theme removed successfully" => "Theme removed successfully",
// "An error occurred while deleting theme" => "An error occurred while deleting theme",
// "CSS folder not found" => "CSS folder not found",
// "Configuration file added" => "Configuration file added",
// "Preference inserted or updated" => "Preference inserted or updated",
// "Menu inserted or update" => "Menu inserted or update",
// "Module inserted or update" => "Module inserted or update",
// "Theme updated" => "Theme updated",
// "Could not open file" => "Could not open file",
// "Displays the Tiki (tiki) or PHP version (php), empty to display both" => "Displays the Tiki (tiki) or PHP version (php), empty to display both",
// "Internal error: mandatory parameter field_fetch_url is missing" => "Internal error: mandatory parameter field_fetch_url is missing",
// "Internal error: mandatory parameter object_store_url is missing" => "Internal error: mandatory parameter object_store_url is missing",
// "Problem finding the associated user. %0 is not recognized. See EventNotify.php" => "Problem finding the associated user. %0 is not recognized. See EventNotify.php",
// "Event name may be empty or invalid" => "Event name may be empty or invalid",
// "Arguments are expected to be a value map" => "Arguments are expected to be a value map",
"New File" => "Nouveau Fichier",
// "Unable to write to destination path: %0" => "Unable to write to destination path: %0",
"Cannot resize the file" => "Ne peut pas redimensionner le fichier",
"Cannot write the file" => "Impossible d'écrire le fichier",
"Image was reduced: %s x %s -> %s x %s" => "L'image a été réduite : %s x %s -> %s x %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
// "Duplicate file found as `%0`. Upload rejected" => "Duplicate file found as `%0`. Upload rejected",
// "Mail-in auto-reply" => "Mail-in auto-reply",
"Sorry, you can't use this feature." => "Désolé, vous ne pouvez pas utiliser cette fonctionnalité.",
// "The functionality you are trying to access is currently disabled" => "The functionality you are trying to access is currently disabled",
// "No required action found" => "No required action found",
// "Rejected message, user globally denied" => "Rejected message, user globally denied",
// "Rejected message, associated action disabled (%0)" => "Rejected message, associated action disabled (%0)",
// "Performing action (%0)" => "Performing action (%0)",
// "Rejected message, user locally denied (%0)" => "Rejected message, user locally denied (%0)",
// "Rejected message, no associated action" => "Rejected message, no associated action",
"Submit Article" => "Soumettre un article",
// "Unable to find suitable action" => "Unable to find suitable action",
// "Wiki Append" => "Wiki Append",
// "Wiki Get" => "Wiki Get",
// "Wiki Prepend" => "Wiki Prepend",
// "Wiki Create/Update" => "Wiki Create/Update",
// "created from mail-in" => "created from mail-in",
// "Create or update article" => "Create or update article",
// "Reply Handler" => "Reply Handler",
// "Wiki (multiple actions)" => "Wiki (multiple actions)",
// "Login failed for IMAP account on %0:%1 for user %2" => "Login failed for IMAP account on %0:%1 for user %2",
// "Login failed for POP3 account on %0:%1 for user %2" => "Login failed for POP3 account on %0:%1 for user %2",
// "= New composer.json file content" => "= New composer.json file content",
// "= Composer execution output" => "= Composer execution output",
"Errors" => "Erreurs",
// "Unable to download composer installer from %0" => "Unable to download composer installer from %0",
// "Invalid composer installer signature" => "Invalid composer installer signature",
// "composer.phar installed in temp folder" => "composer.phar installed in temp folder",
// "There was a problem when installing Composer" => "There was a problem when installing Composer",
// "Tiki root directory is not writable, so file \"%0\" can not be created" => "Tiki root directory is not writable, so file \"%0\" can not be created",
// "Tiki root directory is not writable, so directory \"%0\" can not be created" => "Tiki root directory is not writable, so directory \"%0\" can not be created",
// "Tiki can not write to file \"%0\"" => "Tiki can not write to file \"%0\"",
// "Tiki can not write to directory \"%0\"" => "Tiki can not write to directory \"%0\"",
// "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping.." => "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping..",
// "Warning: Profile %0 already installed. Skipping.." => "Warning: Profile %0 already installed. Skipping..",
// "Profile %0 applied" => "Profile %0 applied",
// "Warning: Profile %0 is not installed. Skipping.." => "Warning: Profile %0 is not installed. Skipping..",
// "Profile %0 removed" => "Profile %0 removed",
// "%0 library not found. This may be due to a typo or caused by a recent update" => "%0 library not found. This may be due to a typo or caused by a recent update",
// "Package %0 is not a Tiki Extension" => "Package %0 is not a Tiki Extension",
// "Package %0 is already enabled" => "Package %0 is already enabled",
// "Package %0 is not enabled" => "Package %0 is not enabled",
"Calendar does not exist" => "Le calendrier n'existe pas",
"Calendar already exists" => "Le calendrier existe déjà",
"File gallery does not exist" => "La galerie de fichier n'existe pas",
"File gallery already exists" => "La galerie de fichier existe déjà",
// "Untitled - From Profile Import" => "Untitled - From Profile Import",
// "Field \"%0\" in Tracker %1 has no value for itemId %2" => "Field \"%0\" in Tracker %1 has no value for itemId %2",
"Created by profile installer" => "Créé par l'installeur de profils",
"Page updated by profile installer" => "Page mise à jour par l'installeur de profils",
// "Tiki (%0) is not satisfiable by profile required Tiki version (%1)" => "Tiki (%0) is not satisfiable by profile required Tiki version (%1)",
"Nothing was changed. Please check the profile for errors" => "Rien n'a été modifié, merci de rechercher les erreurs dans le profil",
"Applying profile" => "Application en cours du profil",
"Added (or modified)" => "Ajouté (ou modifié)",
"Group changed (or modified)" => "Groupe modifié",
// "Installer reverted" => "Installer reverted",
// "Installer removed" => "Installer removed",
// "Group removed" => "Group removed",
// "Group modified" => "Group modified",
// "Permission removed" => "Permission removed",
// "Permission assign" => "Permission assign",
"Preference set" => "Préférence activée",
// "<error>Package %0:  No folder was found. Did you forgot to install?</error>" => "<error>Package %0:  No folder was found. Did you forgot to install?</error>",
// "Package set" => "Package set",
"Modified permission %s for %s" => "Permission modifiée %s pour %s",
"Modified permission %s on %s/%s for %s" => "Permission modifiée %s sur %s/%s pour %s",
"User %0 was added to %1" => "L'utilisateur %0 a été ajouté à %1",
"No name" => "Pas de nom",
"Bad object" => "Mauvais objet",
// "Could not parse YAML in profile: \"%0\"" => "Could not parse YAML in profile: \"%0\"",
// "Profile Path cannot be found" => "Profile Path cannot be found",
"Syntax error: " => "Erreur de syntaxe: ",
"Circular reference" => "Référence circulaire",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
"Needs a 'type' and 'data' field" => "Nécessite un champ 'type' et 'data'",
// "Source: %0:%1 (%2)" => "Source: %0:%1 (%2)",
// "Recommendation: %0:%1 (%2)" => "Recommendation: %0:%1 (%2)",
// "The directory with path: ' . \$path_or_id . ' could not be found" => "The directory with path: ' . \$path_or_id . ' could not be found",
// "The file with path: ' . \$path_or_id . ' could not be found" => "The file with path: ' . \$path_or_id . ' could not be found",
// "The wiki page with name: ' . \$name . ' could not be found" => "The wiki page with name: ' . \$name . ' could not be found",
// "Theme already installed" => "Theme already installed",
// "Version %0 is no longer supported" => "Version %0 is no longer supported",
// "A minor upgrade to %0 is strongly recommended" => "A minor upgrade to %0 is strongly recommended",
// "A major upgrade to %0 is strongly recommended" => "A major upgrade to %0 is strongly recommended",
// "Version %0 is still supported. However, an upgrade to %1 is available" => "Version %0 is still supported. However, an upgrade to %1 is available",
// "Version %0 is still supported. However, a major upgrade to %1 is available" => "Version %0 is still supported. However, a major upgrade to %1 is available",
// "Replace spaces with dashes" => "Replace spaces with dashes",
// "Replace spaces with underscores" => "Replace spaces with underscores",
// "URL Encode (Tiki Classic)" => "URL Encode (Tiki Classic)",
// "Duplicate entry found (%0)" => "Duplicate entry found (%0)",
// "Filter error: \"%0\"" => "Filter error: \"%0\"",
"Action" => "Action",
"Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site" => "Créer un formulaire qui sera publié quelque part, pas nécessairement dans les formulaires, ou même Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Publier",
// "The protocol to use in the form: either get or post" => "The protocol to use in the form: either get or post",
"Script" => "Script",
// "The URL of the destination of the form" => "The URL of the destination of the form",
"Parameters" => "Paramètres",
// "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form" => "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form",
// "Attach articles to the tracker item" => "Attach articles to the tracker item",
"Topic" => "Sujet",
// "Default article topic" => "Default article topic",
"Article Type" => "Type de l'article",
// "Default article type" => "Default article type",
"Auto-Increment" => "Auto-Incrémentation",
"Enable an incrementing value field, or itemId field" => "Permet un champ compteur automatique ou un champ identificateur",
"Start" => "Début",
"The starting value for the field" => "La valeur de départ pour ce champ",
"Prepend" => "Préfixer",
"Text that will be displayed before the field" => "Texte qui sera affiché avant le champ",
"Append" => "Postfixer",
"Text that will be displayed after the field" => "Texte qui sera affiché après le champ",
"If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "Si défini à \"Identificateur de fiche\", définira ce champ pour correspondre à la valeur de l'identifiant réel de cette fiche dans la base de données",
"Update Empty" => "Mettre à jour si le champs est vide",
"No" => "Non",
"Yes" => "Oui",
// "Note: %0 auto-increment item values updated" => "Note: %0 auto-increment item values updated",
"Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********" => "Ajoutez des numéros d'incrémentation automatique aux éléments de ce tracker qui n'en ont pas un. ********** N.B. Cela modifie les données et il n'y a pas d'annulation **********",
// "Date and Time (Calendar Item)" => "Date and Time (Calendar Item)",
// "Associate calendar items with tracker items" => "Associate calendar items with tracker items",
// "Experimental: (work in progress, use with care)" => "Experimental: (work in progress, use with care)",
// "Calendar Id" => "Calendar Id",
// "Calendar to use for associated events" => "Calendar to use for associated events",
// "Show Event Id" => "Show Event Id",
// "Show an input for the event id when editing the field, allow lost events to be reattached" => "Show an input for the event id when editing the field, allow lost events to be reattached",
// "Calendar Item %0 not found" => "Calendar Item %0 not found",
// "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2" => "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2",
"Category" => "Catégorie",
"Enable the tracker item to be categorized in one or more categories under the specified main category" => "Permet à une ou plusieurs catégories sous la catégorie principale spécifiée d'être affectée(s) à la fiche de formulaire",
"Parent Category" => "Catégorie parente",
"Child categories will be provided as options for the field" => "Les catégories enfants seront proposées en option pour le champ",
"Input Type" => "Type d'entrée",
"User interface control to be used" => "Contrôle d'interface utilisateur à utiliser",
"Dropdown" => "Liste déroulante",
"Radio buttons" => "Boutons radio",
"List box" => "Liste",
"Multiple-selection checkboxes" => "Cases à cocher à sélection multiple",
"Select All" => "Tout sélectionner",
"Includes a control to select all available options for multi-selection controls" => "Inclut un contrôle pour sélectionner toutes les options dans les contrôles à sélection multiple",
"No controls" => "Aucun contrôle",
"Include controls" => "Inclure les contrôles",
"All descendants" => "Tous les descendants",
"Display all descendants instead of only first-level descendants" => "Afficher tous les descendants au lieu de ceux de premier niveau seulement",
"First level only" => "Premier niveau seulement",
// "All descendants and display full path" => "All descendants and display full path",
"Displays the field description in a help tooltip" => "Affiche la description du champ dans une infobulle d'aide",
"No help" => "Pas d'aide",
"Tooltip" => "Infobulle",
// "Output Type" => "Output Type",
// "Plain list with items separated by line breaks (default)" => "Plain list with items separated by line breaks (default)",
// "Links separated by line breaks" => "Links separated by line breaks",
// "Unordered list of labels" => "Unordered list of labels",
// "Unordered list of links" => "Unordered list of links",
// "Do not Inherit Categories" => "Do not Inherit Categories",
// "Inherit (default)" => "Inherit (default)",
// "Do not inherit" => "Do not inherit",
// "Recategorization event" => "Recategorization event",
// "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving" => "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving",
// "Indexing" => "Indexing",
// "-Blank (no data)-" => "-Blank (no data)-",
// "%0 (any of)" => "%0 (any of)",
// "%0 (all of)" => "%0 (all of)",
// "Tracker items will inherit their tracker's categories unless this option is set" => "Tracker items will inherit their tracker's categories unless this option is set",
"Checkbox" => "Case à cocher",
"Provide a checkbox field for yes/no, on/off input" => "Fournit un champ case à cocher pour entrer oui/non, marche/arrêt",
"Computed Field" => "Champ calculé",
"Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type" => "Fournit une valeur calculée basée sur des valeurs numériques de champ. Envisager d'utiliser des services web ou du javascript pour réaliser cette tâche plutôt que d'utiliser ce type",
"This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field" => "Cette fonctionnalité est encore en place pour une compatibilité ascendante. Bien qu'il n'y ait pas de problèmes particuliers associés à elle, elle pourrait être utilisé comme vecteur pour des attaques causant de nombreux dommages. Un champ service web ou un JavaScript personnalisé est recommandé plutôt que ce type de champ",
"Formula" => "Formule",
"The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "La formule à calculer supportant des opérateurs divers (+ - * / et parenthèses), des références à un autre champ en utilisant l'identificateur de ce champ précédé par #",
"Decimal Places" => "Emplacement de la décimale",
"Number of decimal places to round to" => "Nombre de décimales à préserver avant d'arrondir",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details" => "Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed" => "Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed",
"Country Selector" => "Sélecteur de pays",
"Enable a selection from a specified list of countries" => "Permet une sélection à partir d'une liste spécifiée de pays",
"Display" => "Afficher",
"Specify the rendering type for the field" => "Spécifier le type de rendu pour le champ",
"Name and flag" => "Nom et drapeau",
"Name only" => "Nom seulement",
"Flag only" => "Drapeau seulement",
"Sort order" => "Sens du tri",
"Determines whether the ordering should be based on the translated name or the English name" => "Détermine si l'ordre doit être basé sur le nom traduit ou le nom anglais",
"Translated name" => "Nom traduit",
"English name" => "Nom anglais",
"Currency Field" => "Champ monétaire",
"Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric" => "Fournit un champ numerique sur une ligne. Préfixer ou ajouter à la fin, les valeurs peuvent être alphanumériques",
"Same Row" => "Même ligne",
"Displays the next field on the same line" => "Affiche le champ suivant sur la même ligne",
"Display Size" => "Taille d'affichage",
"Visible size of the field, in characters. Does not affect the numeric length" => "Taille visible du champ en caractères. N'affecte pas la longueur numérique",
"Text to be displayed in front of the currency amount" => "Texte à afficher devant le montant monétaire",
"Text to be displayed after the numeric value" => "Texte à afficher après la valeur numérique",
"Locale" => "Locale",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
"Currency" => "Devise",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
"Currency symbol" => "Symbole monétaire",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
"All" => "Tous",
// "Currency Tracker" => "Currency Tracker",
// "Tracker containing available currencies and exchange rates" => "Tracker containing available currencies and exchange rates",
"Date and Time" => "Date et heure",
"Provide drop-down options to accurately select a date and/or time" => "Fournit des options en liste déroulante pour choisir avec précision date et/ou heure",
"Components to be included" => "Composants à inclure",
"Date only" => "Date seulement",
"Start year" => "Année début",
"Year to allow selecting from" => "Année autorisée pour le début de sélection",
"End year" => "Année fin",
"Year to allow selecting to" => "Année autorisée pour la fin de sélection",
"Default selection" => "Sélection par défaut",
"Indicates if blank dates should be allowed" => "Indique si les dates vides devraient être autorisées",
"Current Date" => "Date du jour",
"Blank" => "Blanc",
// "Time Ago" => "Time Ago",
"Use timeago.js if the feature is enabled" => "Utilisez timeago.js si la fonction est activée",
"Item Date Field" => "Date pour la fiche (item)",
"Use this date as the item's global date in the search index" => "Utilisez cette date comme date globale de la fiche dans l'index de recherche",
"Allow users to select only from a specified set of options" => "Autorise les utilisateurs à choisir seulement à partir d'un ensemble spécifié d'options",
"Option" => "Option",
"If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label" => "Une option, si elle contient un signe égal, la première partie sera utilisée comme valeur tandis que la seconde sera l'étiquette",
"Dropdown selector with \"Other\" field" => "Liste déroulante avec un champ 'Autre'",
"Allow users to select from a specified set of options or to enter an alternate option" => "Autorise les utilisateurs à choisir à partir d'un ensemble spécifié d'options ou à entrer une autre option",
// "To change the label of the \"Other\" option, use \"other=Label\"" => "To change the label of the \"Other\" option, use \"other=Label\"",
"Radio Buttons" => "Boutons radio",
"Multiselect" => "Sélection multiple",
"Allow a user to select multiple values from a specified set of options" => "Permet à un utilisateur de sélectionner plusieurs éléments dans une liste d'options",
"Dynamic Items List" => "Liste dynamique de fiches",
"Dynamically update a selection list based on linked data from another tracker" => "Met à jour dynamiquement une liste basée sur des données liées d'un autre formulaire",
"Tracker ID" => "Id de formulaire",
"Tracker to link with" => "Formulaire avec lequel faire le lien",
"Field ID (Other tracker)" => "ID de champ (Autre formulaire)",
"Field ID to link with in the other tracker" => "ID du champ pour créer le lien dans l'autre formulaire",
"Field ID (This tracker)" => "ID de champ (Ce formulaire)",
"Field ID to link with in the current tracker" => "ID du champ pour créer le lien avec le formulaire actuel",
"Listed Field" => "Champ répertorié",
"Field ID to be displayed in the dropdown list" => "ID du champ à afficher dans la liste déroulante",
"Status Filter" => "Filtre de statut",
"Restrict listed items to specific statuses" => "Restreindre les fiches listées à celles ayant des statuts spécifiques",
"all" => "tout",
"open" => "en cours (o)",
"pending" => "en attente",
"closed" => "fermé",
"open, pending" => "ouvert, en attente",
"pending, closed" => "en attente, fermé",
// "Hide blank" => "Hide blank",
// "Hide first blank option, thus preselecting the first available option" => "Hide first blank option, thus preselecting the first available option",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***" => "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***",
"*** ERROR: Field %0 not found ***" => "*** ERREUR : Champ %0 non trouvé ***",
// "*** ERROR: No remote tracker selected for DynamicList Field %0 ***" => "*** ERROR: No remote tracker selected for DynamicList Field %0 ***",
// "DynamicList field: Field \"%0\" not found" => "DynamicList field: Field \"%0\" not found",
"Email" => "Adresse courriel",
"Enable an email address to be input with the option of making it active" => "Permet d'entrer une adresse courriel avec l'option de la rendre active",
"Link Type" => "Type de lien",
"How the email address will be rendered" => "Comment l'adresse courriel sera affichée",
"Plain text" => "Texte en clair",
"Encoded mailto link" => "Encoder les liens mailto",
"Simple mailto link" => "Lien mailto simple",
"Watch Open" => "Surveiller ouvert",
"Notify this address every time the status changes to open" => "Notifier cette adresse à chaque changement d'état vers ouvert",
"Watch Pending" => "Surveiller en attente",
"Notify this address every time the status changes to pending" => "Notifier cette adresse à chaque changement d'état vers en attente",
"Watch Closed" => "Surveiller fermé",
"Notify this address every time the status changes to closed" => "Notifier cette adresse à chaque changement d'état vers fermé",
"Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Erreur gestionnaire champ de formulaire : Préférence \"%0\" requise pour le type de champ \"%1\"",
"Attachment" => "Fichier joint",
// "Deprecated in favor of the Files field" => "Deprecated in favor of the Files field",
"List View" => "Vue en liste",
"Defines how attachments will be displayed within the field" => "Définit comment les pièces jointes seront affichées dans le champ",
"name" => "nom",
"type" => "type",
"name, size" => "nom, taille",
"name, type, size" => "nom, type, taille",
"uploader" => "téléchargeur",
"mediaplayer" => "Lecteur média",
"Download" => "Télécharger",
"Attached and upload files stored in the file galleries to the tracker item" => "Fichiers joints à la fiche de formulaire téléchargés et stockés dans la galerie de fichiers",
"Gallery ID" => "ID de la galerie",
"File gallery to upload new files into" => "Galerie de fichiers destinée à recevoir les nouveaux fichiers téléchargés",
"MIME Type Filter" => "Filtre de type MIME",
"Mask for accepted MIME types in the field" => "Masquer pour les types MIME acceptés dans le champ",
"File Count" => "Nombre de fichiers",
"Maximum number of files to be attached on the field" => "Nombre maximum de fichiers à joindre au champ",
"Display Mode" => "Mode d'affichage",
// "Show files as object links or via a wiki plugin (img so far)" => "Show files as object links or via a wiki plugin (img so far)",
"Links" => "Liens",
// "Bare Links" => "Bare Links",
"Table" => "Table",
"Images" => "Images",
"Vimeo" => "Vimeo",
// "Google Viewer" => "Google Viewer",
// "Moodle Scorm Viewer" => "Moodle Scorm Viewer",
// "Display parameters" => "Display parameters",
"URL-encoded parameters used such as in the {img} plugin, for example,." => "Paramètres encodés de l'URL utilisés comme dans le pugiciel {img} . i.e",
// "Display parameters for lists" => "Display parameters for lists",
// "Display Order" => "Display Order",
// "Sort order for the files" => "Sort order for the files",
// "Default (order added to tracker item)" => "Default (order added to tracker item)",
// "Name (A - Z)" => "Name (A - Z)",
// "Name (Z - A)" => "Name (Z - A)",
// "Filename (A - Z)" => "Filename (A - Z)",
// "Filename (Z - A)" => "Filename (Z - A)",
// "Created date (old - new)" => "Created date (old - new)",
// "Created date (new - old)" => "Created date (new - old)",
// "Last modified date (old - new)" => "Last modified date (old - new)",
// "Last modified date (new - old)" => "Last modified date (new - old)",
// "File size (small - large)" => "File size (small - large)",
// "File size (large - small)" => "File size (large - small)",
// "Hits (low - high)" => "Hits (low - high)",
// "Hits (high - low)" => "Hits (high - low)",
"Include Child Galleries" => "Inclure les galeries enfants",
"Use files from child galleries as well" => "Utiliser aussi bien les fichiers à partir des galeries enfants",
// "Replace Existing File" => "Replace Existing File",
// "Replace the existing file, if any, instead of uploading a new one" => "Replace the existing file, if any, instead of uploading a new one",
// "Browse Gallery ID" => "Browse Gallery ID",
// "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)" => "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)",
// "Restrict permissions to view the file gallery to hide the button" => "Restrict permissions to view the file gallery to hide the button",
// "Duplicate Gallery ID" => "Duplicate Gallery ID",
// "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)" => "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)",
// "Index As Map Layer" => "Index As Map Layer",
// "Index the files in a specific format for use in map searchlayers to display trails and features" => "Index the files in a specific format for use in map searchlayers to display trails and features",
// "GeoJSON" => "GeoJSON",
// "GPX" => "GPX",
// "Upload In Modal" => "Upload In Modal",
// "Upload files in a new modal window" => "Upload files in a new modal window",
// "Maximum image width" => "Maximum image width",
// "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings",
// "Maximum image height" => "Maximum image height",
// "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings",
// "Add Descriptions" => "Add Descriptions",
// "Add descriptions on uploaded files" => "Add descriptions on uploaded files",
// "Show files as object links or via a wiki plugin (img, Vimeo)" => "Show files as object links or via a wiki plugin (img, Vimeo)",
// "Files field: Gallery #%0 not found" => "Files field: Gallery #%0 not found",
// "Token access needs to be enabled for Google viewer to be used" => "Token access needs to be enabled for Google viewer to be used",
// "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")" => "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")",
"Problem with uploaded file: \"%0\"" => "Problème avec le fichier envoyé : \"%0\"",
"No gallery for uploaded file, galleryId=%0" => "Pas de galerie pour le fichier envoyé, Id de galerie = %0",
"You don't have permission to upload a file to gallery \"%0\"" => "Pas le droit d'envoyer un fichier dans la galerie \"%0\"",
"Allow tags to be shown or added for tracker items" => "Autorise les mots-clés à être affichés ou ajoutés aux fiches formulaires",
"Visible size of the input field" => "Taille visible du champ de saisie",
"Hide or show the input help" => "Masquer ou afficher l'aide à la saisie",
"Show" => "Montrer",
"Hide" => "Cacher",
"Suggest" => "Suggérer",
"Hide or show the tag suggestions" => "Masquer ou afficher les suggestions de mots-clés",
// "Geographic Feature" => "Geographic Feature",
// "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved" => "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved",
"Feature cannot be set or modified through this interface" => "Il n'est pas possible de modifier ceci via cette interface",
// "Feature cannot be viewed" => "Feature cannot be viewed",
"Group Selector" => "Sélecteur de groupe",
"Allow a selection from a specified list of user groups" => "Permet une sélection à partir d'une liste spécifiée de groupes d'utilisateurs",
"Auto-Assign" => "Auto-assigner",
"Determines if any group should be automatically assigned to the field" => "Détermine si un groupe devrait être automatiquement assigné au champ",
"Modifier" => "Modificateur",
"Group Filter" => "Filtre de groupe",
"Limit listed groups to those including the specified group" => "Limiter les groupes listés à ceux incluant le groupe spécifié",
"User Groups" => "Groupes de l'utilisateur",
// "Show groups user belongs to instead of the ones user has permission to see" => "Show groups user belongs to instead of the ones user has permission to see",
// "Assign to the group" => "Assign to the group",
// "For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated" => "For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated",
"Assign" => "Attribuer",
// "Unassign from previous selection" => "Unassign from previous selection",
// "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated" => "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated",
"Unassign" => "Désattribuer",
// "Email Notification" => "Email Notification",
// "Add selected group to group monitor the item. Group watches feature must be enabled" => "Add selected group to group monitor the item. Group watches feature must be enabled",
"Header" => "En-tête",
"Display a heading between fields to delimit a section and allow visual folding of the fields" => "Affiche un en-tête entre les champs pour délimiter une section et laisser replier les champs",
"Heading Level" => "Niveau d'en-tête",
"Level of the heading to use for complex tracker structures needing multiple heading levels" => "Niveau de l'en-tête à employer pour les structures complexes de formulaire nécessitant plusieurs niveaux d'en-tête",
// "Section Toggle" => "Section Toggle",
"Default State" => "État par défaut",
// "No toggle" => "No toggle",
"Open" => "Ouvert",
"Closed" => "Fermé",
"Icon" => "Icône",
"Provide the ability to select an image as an icon attached to the tracker item from the file galleries" => "Permet de sélectionner une image comme icône attachée à la fiche de formulaire, à partir des galeries de fichiers",
"Default image" => "Image par défaut",
"Path to the default icon used" => "Chemin vers l'icône par défaut utilisée",
// "Maximum Icons" => "Maximum Icons",
// "Number of icons to display in each gallery (default 120)" => "Number of icons to display in each gallery (default 120)",
// "Update icon event" => "Update icon event",
// "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items" => "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items",
"Image" => "Image",
"List image width" => "Largeur de la liste d'image",
"Display size in pixels" => "Afficher la taille en pixels",
"List image height" => "Hauteur de la liste d'image",
"Detail image width" => "Largeur d'image individuelle",
"Detail image height" => "Hauteur d'image individuelle",
"Maximum image size" => "Taille maximum d'image",
"Maximum image width or height in pixels" => "Hauteur et largeur maximum de l'image en pixels",
"Shadowbox" => "Shadowbox",
"Shadowbox usage on this field" => "Utilisation d'une boîte ombrée sur ce champ",
"Do not use" => "Ne pas utiliser",
"One box per item" => "Un conteneur par élément",
"Use the same box for all images" => "Utiliser le même conteneur pour toutes les images",
"Missing Icon" => "Icône manquante",
"Icon to use when no images have been uploaded" => "Icône à utiliser quand aucune image n'a été téléchargé",
"Invalid imagename (using filters for filenames)" => "Nom d'image invalide (avec les filtres pour les noms de fichiers)",
"In Group" => "Dans le groupe",
"Indicate if the user associated with the item is a member of a specified group" => "Indique si l'utilisateur associé à l'objet est membre d'un groupe",
"Group Name" => "Nom de Groupe",
"Name of the group to verify" => "Nom du groupe à vérifier",
"How to display the result" => "Comment afficher le résultat",
"Yes/No" => "Oui/Non",
"Join date" => "Date d'inscription",
"Expiration date" => "Date d'expiration",
"IP Selector" => "Sélecteur d'IP",
"IP address input field" => "Champ adresse IP",
"Auto-assign" => "Auto-assignation",
"Automatically assign the value on creation or edit" => "Assigner la valeur automatiquement à la création ou à la modification",
"Item Link" => "Lien vers un autre champ",
"Link to another item, similar to a foreign key" => "Lien vers un autre champ, assimilable à une clé étrangère",
"Tracker to link to" => "Formulaire à associer",
"Field ID" => "ID du Champ",
"Default field to display" => "Champ par défaut à afficher",
"How the link to the item should be rendered" => "Comment le lien vers la fiche devrait être rendu",
"Value" => "Valeur",
"Link" => "Lien",
"Multiple Fields" => "Champs multiples",
// "Display the values from multiple fields instead of a single one" => "Display the values from multiple fields instead of a single one",
// "Format for Customising Multiple Fields" => "Format for Customising Multiple Fields",
// "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"" => "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"",
// "Multiple Fields display type" => "Multiple Fields display type",
// "Display multiple fields as concatenated list in a dropdown or as a table" => "Display multiple fields as concatenated list in a dropdown or as a table",
// "Plugin TrackerList options" => "Plugin TrackerList options",
// "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)" => "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)",
"Limit the available items to a selected set" => "Limiter les fiches disponibles à un ensemble choisi",
"Link Page" => "Lien vers page",
"Link to a wiki page instead of directly to the item" => "Faire un lien vers une page wiki plutôt que directement vers une fiche",
"Add Items" => "Ajouter des fiches",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
"Add Item Template Page" => "Ajouter une page gabarit de fiche",
// "Wiki page to use as a Pretty Tracker template" => "Wiki page to use as a Pretty Tracker template",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on the value in this remote field" => "Preselect based on the value in this remote field",
// "Match preselect item to this field ID in the tracker that is being linked to" => "Match preselect item to this field ID in the tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
"Exact Match" => "Correspondance exacte",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "Cross select. Load all matching items in the remote tracker" => "Cross select. Load all matching items in the remote tracker",
// "Cross select. Load all matching items in the remote tracker plus wildcards" => "Cross select. Load all matching items in the remote tracker plus wildcards",
// "One item per value" => "One item per value",
// "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items" => "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items",
// "Displays all the items for a same label with a notation value (itemId)" => "Displays all the items for a same label with a notation value (itemId)",
// "Display only one item for each label" => "Display only one item for each label",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Cascade actions" => "Cascade actions",
"Status" => "État",
// "Categories and status" => "Categories and status",
// "Categories and delete" => "Categories and delete",
// "Delete and status" => "Delete and status",
// "ItemLink: Tracker %0 not found for field \"%1\"" => "ItemLink: Tracker %0 not found for field \"%1\"",
// "ItemLink: Field %0 not found for field \"%1\"" => "ItemLink: Field %0 not found for field \"%1\"",
// "ItemLink field \"%0\": Tracker ID #%1 not found" => "ItemLink field \"%0\": Tracker ID #%1 not found",
// "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status" => "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status",
// "Unsupported field conversion type: from %0 to %1" => "Unsupported field conversion type: from %0 to %1",
"Items List" => "Liste de fiches",
"Display a list of field values from another tracker that has a relation with this tracker" => "Affiche une liste de valeurs de champs d'un autre formulaire qui a une relation avec celui-ci",
"Tracker from which to list items" => "Formulaire à partir duquel lister des fiches",
"Link Field ID" => "ID du champ de liaison",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
"Value Field ID" => "ID du champ valeur",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty",
"Fields to display" => "Champs à afficher",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "Format for customising fields to display" => "Format for customising fields to display",
// "Sort Fields" => "Sort Fields",
// "Order results by one or more fields from the other tracker" => "Order results by one or more fields from the other tracker",
"How the link to the items should be rendered" => "Comment le lien vers les fiches devrait être rendu",
// "Permission denied importing into linked tracker %0" => "Permission denied importing into linked tracker %0",
// "Errors occurred importing into linked tracker %0" => "Errors occurred importing into linked tracker %0",
// "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
"Date and Time (Date Picker)" => "Date et heure (Sélecteur de date)",
"Provide a jQuery UI date picker to select a date and, optionally, a time" => "Fournir un sélecteur de date jQuery UI pour sélectionner une date et, éventuellement, une heure",
"Default value" => "Valeur par défaut",
"Default date and time for new items" => "Date et heure par défaut pour les nouvelles fiches",
"None (undefined)" => "Aucun (non défini)",
"Item creation date and time" => "Date et heure de création de l'article",
 "Not before" => "Pas avant",
"Field ID from this tracker to compare the value against and validate it is not before that timestamp" => "L'ID de champ de ce tracker pour comparer la valeur et valider qu'elle n'est pas antérieur à cet horodatage (timestamp)",
"Not after" => "Pas après",
"Field ID from this tracker to compare the value against and validate it is not after that timestamp" => "L'ID de champ de ce tracker pour comparer la valeur et valider qu'elle n'est pas postérieur à cet horodatage (timestamp)",
// "Date Picker Field: \"%0\" is not a valid internal date value" => "Date Picker Field: \"%0\" is not a valid internal date value",
// "%0 cannot be before %1" => "%0 cannot be before %1",
// "%0 cannot be after %1" => "%0 cannot be after %1",
"Kaltura Video" => "Vidéo Kaltura",
// "Display a series of attached Kaltura videos" => "Display a series of attached Kaltura videos",
// "URL-encoded parameters used in the {kaltura} plugin, for example," => "URL-encoded parameters used in the {kaltura} plugin, for example,",
"Language" => "Langue",
"Assign a language to the tracker item to enable multilingual trackers" => "Assigner une langue à une fiche de formulaire pour activer le multilinguisme",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
"LDAP" => "LDAP",
"Display a field value from a specific user in LDAP" => "Afficher des informations d'un utilisateur provenant de l'annuaire LDAP",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
"Field name returned by LDAP" => "Nom de champ retourné par LDAP",
"DSN" => "DSN",
"Data source name registered in Tiki" => "Nom de la source de données enregistrée dans Tiki",
"Location" => "Lieu",
"Enable a geographic location to be selected for the item and displayed on a map" => "Permet de choisir une géolocalisation pour la fiche et l'affiche sur une carte",
"Use as item location" => "Utiliser en tant que localisation de la fiche",
// "List View Width" => "List View Width",
// "Width of map in pixels when tracker items are shown in list view" => "Width of map in pixels when tracker items are shown in list view",
// "List View Height" => "List View Height",
// "Height of map in pixels when tracker items are shown in list view" => "Height of map in pixels when tracker items are shown in list view",
// "Item View Width" => "Item View Width",
// "Width of map in pixels when a single tracker item is shown" => "Width of map in pixels when a single tracker item is shown",
// "Item View Height" => "Item View Height",
// "Height of map in pixels when a single tracker item is shown" => "Height of map in pixels when a single tracker item is shown",
// "Fields To Search" => "Fields To Search",
// "Fields in this tracker to use as a source to search for a location for" => "Fields in this tracker to use as a source to search for a location for",
// "When To Search" => "When To Search",
// "Event to attempt to search for a location" => "Event to attempt to search for a location",
"Never" => "Jamais",
// "Save (when Location is empty)" => "Save (when Location is empty)",
// "Save (always)" => "Save (always)",
// "Indexing (when Location is empty)" => "Indexing (when Location is empty)",
// "Indexing (always)" => "Indexing (always)",
// "Location: Field %0 not found for field \"%1\"" => "Location: Field %0 not found for field \"%1\"",
// "Could not find a location for \"%0\"" => "Could not find a location for \"%0\"",
"When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps" => "Quand activé, enregistre la valeur du champ en tant que géolocalisation de la fiche pour affichage sur les cartes de localisation",
"Mathematical Calculation" => "Calcul mathématique",
"Perform a calculation upon saving the item based on other fields within the same item" => "Effectue un calcul à partir d'autres champs de la fiche à chaque sauvegarde",
"Calculation" => "Calcul",
"Calculation in the Rating Language" => "Calcul dans le langage de calculation (Rating Language)",
"Re-calculation event" => "Déclenchement du re-calcul",
"Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed" => "Permet de spécifier d'autres déclencheurs du re-calcul. Le choix de l'indexation est utile pour des champs de scores dynamiques qui ne sont jamais affichés",
"Value will be re-calculated on save. Current value: %0" => "Cette valeur sera recalculée à chaque sauvegarde. Valeur actuelle : %0",
"Numeric Field" => "Champ numérique",
"Text to be displayed in front of the numeric value" => "Texte à afficher avant la valeur numérique",
"Thousands separator when displaying data" => "Séparateur des milliers à l'affichage des données",
"Page Selector" => "Sélecteur de page",
"Allow a selection from the list of pages" => "Permet une sélection à partir de la liste des pages",
"Will auto-assign the creator of the item" => "Assignera automatiquement le créateur de la fiche",
"Visible size of the input in characters" => "Taille visible du champ de saisie",
"Create Page" => "Créer une page",
"Create missing pages using the page name in this file as the template" => "Créer les pages manquantes en utilisant le nom de page dans ce fichier comme modèle",
"Display the value as a link to the page" => "Afficher la valeur en tant que lien vers la page",
"Rating" => "Cote",
// "A rating of the tracker item. Permissions involved: %0" => "A rating of the tracker item. Permissions involved: %0",
"The possible options (comma-separated integers) for the rating" => "Les options possibles (entiers séparés par des virgules) pour la notation",
"Mode" => "Mode",
// "Display rating options as" => "Display rating options as",
"Stars" => "Étoiles",
// "Single Option: for example, Like" => "Single Option: for example, Like",
"Labels" => "Étiquettes",
// "The text labels (comma-separated) for the possible options" => "The text labels (comma-separated) for the possible options",
"Stars (deprecated)" => "Étoile (obsolète)",
"Display a star rating" => "Affiche un notation par étoile",
"A possible option for the rating" => "Une option possible pour l'estimation",
// "Stars (system - deprecated)" => "Stars (system - deprecated)",
"Average" => "Moyenne",
"Number of votes" => "Nombre de votes",
"Your rating" => "Votre vote",
"Relations" => "Relations",
"Allow arbitrary relations to be created between the trackers and other objects in the system" => "Permet de créer une relation arbitraire entre les formulaires et d'autres objets dans le système",
"Relation" => "Rapport",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
"Format" => "Format",
// "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field" => "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field",
"Read-only" => "Lecture seule",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
// "Control how the relations are displayed in view mode" => "Control how the relations are displayed in view mode",
"List" => "Liste",
"Count" => "Compte",
// "Count with toggle for list" => "Count with toggle for list",
// "Force Refresh" => "Force Refresh",
// "Re-save related tracker items" => "Re-save related tracker items",
// "On Save" => "On Save",
// "Extra Filter Field" => "Extra Filter Field",
// "Filter objects by value of another field. Use a jQuery seletor to target the element in the page" => "Filter objects by value of another field. Use a jQuery seletor to target the element in the page",
// "Extra Filter Key" => "Extra Filter Key",
// "Key to filter objects by using the value from the Extra Filter Field above" => "Key to filter objects by using the value from the Extra Filter Field above",
// "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save" => "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save",
"and" => "et",
// "show.tiki.org" => "show.tiki.org",
// "Create, display or manage show.tiki.org instances" => "Create, display or manage show.tiki.org instances",
// "Domain name of show server" => "Domain name of show server",
// "For example, show.tikiwiki.org" => "For example, show.tikiwiki.org",
// "Supported Versions" => "Supported Versions",
// "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"" => "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"",
// "Shell username on remote server" => "Shell username on remote server",
// "The shell username on the show server" => "The shell username on the show server",
// "Public key file path" => "Public key file path",
// "System path to public key on local server. Only RSA keys are supported" => "System path to public key on local server. Only RSA keys are supported",
// "Private key file path" => "Private key file path",
// "System path to private key on local server. Only RSA keys are supported" => "System path to private key on local server. Only RSA keys are supported",
// "Show debugging information" => "Show debugging information",
// "Show debugging info during testing" => "Show debugging info during testing",
// "Fixed user ID" => "Fixed user ID",
// "Set fixed user ID instead of using the user ID of the creator of the tracker item" => "Set fixed user ID instead of using the user ID of the creator of the tracker item",
"Static Text" => "Texte statique",
// "Display the field description as static text to present notes or additional instructions" => "Display the field description as static text to present notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
"Indicates if the description should be parsed as wiki syntax for formatting" => "Indique si la description doit être analysée comme syntaxe wiki pour sa mise en forme",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Wiki Parse with Pretty Tracker replacements" => "Wiki Parse with Pretty Tracker replacements",
"Maximum Length (List)" => "Longueur maximum (Liste)",
"Maximum number of characters to be displayed in list mode" => "Nombre maximum de caractères à afficher en mode liste",
"Text Field" => "Champ texte",
"Single-line text input" => "Texte sur une seule ligne",
// "Display the field name and input on the same row" => "Display the field name and input on the same row",
"Visible size of the field, in characters" => "Taille visible du champ en caractères",
"Text to prepend when displaying the value" => "Texte à ajouter au début en affichant la valeur",
// "Text to append when displaying the value" => "Text to append when displaying the value",
"Maximum Length" => "Longueur maximum",
"Maximum amount of characters to store" => "Nombre maximum de caractère à enregistrer",
"Autocomplete" => "Saisie semi-automatique",
"Enable autocompletion while typing in the field" => "Activer la complétion automatique lors de la saisie dans le champ",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
// "Full-text search of the content of the field" => "Full-text search of the content of the field",
// "Search for a value prefix" => "Search for a value prefix",
// "Search for a precise value" => "Search for a precise value",
// "Full-text search in the current language" => "Full-text search in the current language",
// "Full-text search in a specific language (%0)" => "Full-text search in a specific language (%0)",
// "%0 (any language)" => "%0 (any language)",
// "Full-text search in any language" => "Full-text search in any language",
"Text Area" => "Zone de texte",
"Multi-line text input" => "Texte sur plusieurs lignes",
"Toolbars" => "Barres d'outils",
"Enable the toolbars as syntax helpers" => "Activer les barres d'outils comme aides à la syntaxe",
"Disable" => "Désactiver",
"Enable" => "Activer",
"Width" => "Largeur",
"Size of the text area, in characters" => "Taille de la zone de texte en caractères",
"Height" => "Hauteur",
"Size of the text area, in lines" => "Taille de la zone de texte en lignes",
"Character Limit" => "Nombre limite de caractères",
"Maximum number of characters to be stored" => "Nombre maximum de caractères à enregistrer",
"Display Limit (List)" => "Limite d'affichage (List)",
"Maximum number of characters to be displayed in list mode before the value gets truncated" => "Nombre maximum de caractères à afficher en mode liste avant que la valeur ne soit tronquée",
"Word Count" => "Nombre de mots",
"Limit the length of the text, in number of words" => "Limiter la longueur du texte en mots",
"Distinct Values" => "Valeurs distinctes",
"All values in the field must be different" => "Toutes les valeurs du champ doivent être différentes",
"Use WYSIWYG" => "Utiliser WYSIWYG",
"Use a rich text editor instead of inputting plain text" => "Utiliser un éditeur de texte riche à la place de la boite de texte",
"Word Limit Exceeded" => "Nombre maximum de mots atteint",
"Character Limit Exceeded" => "Nombre de caractères dépassé",
"Create a link to a specified URL" => "Créer un lien vers une URL",
"How the URL should be rendered" => "Comment l'URL doit être affichée",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "Text as link (see Other)" => "Text as link (see Other)",
// "Label of the link text. Requires \"Display\" to be set to \"Text as link\"" => "Label of the link text. Requires \"Display\" to be set to \"Text as link\"",
"Display the list of groups for the user associated with the tracker items" => "Affiche la liste du/des groupe(s) de l'utilisateur associé à la fiche",
// "Show direct groups memberships only" => "Show direct groups memberships only",
// "Do not show inherited/included groups" => "Do not show inherited/included groups",
// "Specify Fields" => "Specify Fields",
// "Get the groups for users from these fields, not the \"owner\" user fields" => "Get the groups for users from these fields, not the \"owner\" user fields",
"User Preference" => "Préférence utilisateur",
"Allow user preference changes from a tracker" => "Autorise le changement de préférence utilisateur à partir d'un formulaire",
// "Preference Name" => "Preference Name",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
"User Selector" => "Sélection d'un utilisateur",
// "Allow the selection of a user or users from a list" => "Allow the selection of a user or users from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Item Owner" => "Item Owner",
// "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker" => "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker",
// "Send an email notification to the user(s) every time the item is modified" => "Send an email notification to the user(s) every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Notification Template" => "Notification Template",
// "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)" => "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)",
// "Email Format" => "Email Format",
// "Choose between values text or html, depending on the syntax in the template file that will be used" => "Choose between values text or html, depending on the syntax in the template file that will be used",
"text" => "texte",
"html" => "html",
// "Multiple selection" => "Multiple selection",
// "Allow selection of multiple users from the list" => "Allow selection of multiple users from the list",
// "Yes (complete list)" => "Yes (complete list)",
// "Yes (filterable by group)" => "Yes (filterable by group)",
"Group IDs" => "IDs de groupes",
"Limit the list of users to members of specific groups" => "Limiter la liste des utilisateurs aux membres des groupes spécifiés",
// "Groups that can modify autoassigned values" => "Groups that can modify autoassigned values",
// "List of group IDs who can change this field, even without tracker_admin permission" => "List of group IDs who can change this field, even without tracker_admin permission",
// "Show real name if possible" => "Show real name if possible",
// "User \"%0\" not found" => "User \"%0\" not found",
"User Subscription" => "Abonnement utilisateur",
// "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item" => "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item",
"Webservice" => "Service Web",
"Display the result of a registered webservice call" => "Afficher le résultat d'un appel à un service Web",
"Service Name" => "Nom du service",
"Webservice name as registered in Tiki" => "Nom du service web tel qu'enregistré dans Tiki",
"Template Name" => "Nom du template",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name",
// "Require parameters" => "Require parameters",
// "Do not execute the request if parameters are missing or empty" => "Do not execute the request if parameters are missing or empty",
// "All required" => "All required",
// "(default)" => "(default)",
// "First only required" => "First only required",
// "No parameters required" => "No parameters required",
// "Cache time" => "Cache time",
// "Time in seconds to cache the result for before trying again" => "Time in seconds to cache the result for before trying again",
"Read only" => "Lecture seule",
// "Webservice %0 not found" => "Webservice %0 not found",
// "Webservice template %0 not found" => "Webservice template %0 not found",
// "Unknown webservice error (code: %0)" => "Unknown webservice error (code: %0)",
// "Unknown webservice error" => "Unknown webservice error",
// "Data too long for Webservice field %0 with %1" => "Data too long for Webservice field %0 with %1",
// "Error updating Webservice field %0" => "Error updating Webservice field %0",
// "Embed an associated wiki page" => "Embed an associated wiki page",
// "Field that is used for Wiki Page Name" => "Field that is used for Wiki Page Name",
// "Field to get page name to create page name with" => "Field to get page name to create page name with",
// "Namespace for Wiki Page" => "Namespace for Wiki Page",
// "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information" => "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information",
// "Default (trackerfield<fieldId>)" => "Default (trackerfield<fieldId>)",
// "No namespace" => "No namespace",
// "Custom namespace" => "Custom namespace",
// "Custom Namespace" => "Custom Namespace",
// "The custom namespace to use if the custom option is selected" => "The custom namespace to use if the custom option is selected",
// "Rename Wiki Page when changed in tracker" => "Rename Wiki Page when changed in tracker",
// "Rename associated wiki page when the field that is used for Wiki Page Name is changed" => "Rename associated wiki page when the field that is used for Wiki Page Name is changed",
// "Delete Wiki Page when tracker item is deleted" => "Delete Wiki Page when tracker item is deleted",
// "Delete associated wiki page when the tracker item is deleted" => "Delete associated wiki page when the tracker item is deleted",
// "Action Buttons" => "Action Buttons",
// "Display wiki page buttons when editing the item" => "Display wiki page buttons when editing the item",
// "Remove Bad Chars" => "Remove Bad Chars",
// "Remove bad characters from the Wiki Page name" => "Remove bad characters from the Wiki Page name",
// "The page name provided already exists. Please choose another" => "The page name provided already exists. Please choose another",
// "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1" => "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1",
// "Missing Page Name field #%0 for Wiki field #%1" => "Missing Page Name field #%0 for Wiki field #%1",
// "Page \"%0\" already exists. Not overwriting" => "Page \"%0\" already exists. Not overwriting",
// "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)" => "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)",
// "Look up a single item by ID" => "Look up a single item by ID",
"Search" => "Recherches",
// "Full-text search across all of the content" => "Full-text search across all of the content",
// "Modification Date" => "Modification Date",
// "Unknown value" => "Unknown value",
// "Modified Date" => "Modified Date",
"Actions" => "Actions",
// "Dynamic Filters" => "Dynamic Filters",
// "From %0 to %1" => "From %0 to %1",
// "Field not found: %0" => "Field not found: %0",
// "Filter mode not found: %0 for %1" => "Filter mode not found: %0 for %1",
// "Field mode not found: %0 for %1" => "Field mode not found: %0 for %1",
// "Primary Key fields cannot be read-only" => "Primary Key fields cannot be read-only",
// "Column \"%0\" cannot co-exist with \"%1\"" => "Column \"%0\" cannot co-exist with \"%1\"",
// "Column \"%0:%1\" found multiple times" => "Column \"%0:%1\" found multiple times",
// "Primary key already defined" => "Primary key already defined",
// "Not enough columns, expecting \"%0\"" => "Not enough columns, expecting \"%0\"",
// "Header \"%0\" found where \"%1\" was expected" => "Header \"%0\" found where \"%1\" was expected",
// "Header \"%0\" found where ignored column was expected" => "Header \"%0\" found where ignored column was expected",
// "new tracker(s) item(s) created" => "new tracker(s) item(s) created",
// "tracker(s) item(s) updated" => "tracker(s) item(s) updated",
// "Line %0" => "Line %0",
// "duplicate entry" => "duplicate entry",
// "duplicate entry for unique column %0" => "duplicate entry for unique column %0",
// "Import file contains errors. Please review and fix before importing" => "Import file contains errors. Please review and fix before importing",
// "Primary Key not defined" => "Primary Key not defined",
"Create page" => "Créer la page",
"Plugin execution pending approval" => "Plugiciel en attente d'approbation",
// "Edit plugin" => "Edit plugin",
// "Wiki page pagination has not been enabled" => "Wiki page pagination has not been enabled",
// "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"" => "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"",
"Internal error" => "Erreur interne",
"User error" => "Erreur utilisateur",
"Plugin argument(s) missing" => "Argument(s) du Plugiciel manquant(s)",
"Plugin <strong>%0</strong> cannot be executed" => "Le Plugiciel <strong>%0</strong> n'a pas pu être exécuté",
"Set" => "Choisir",
"Plugin disabled" => "Plugiciel désactivé",
// "Edit Plugin" => "Edit Plugin",
// "Unable to locate cryptphrase" => "Unable to locate cryptphrase",
// "Single Container" => "Single Container",
// "Classic Tiki (3 containers - header, middle, footer)" => "Classic Tiki (3 containers - header, middle, footer)",
// "Classic Bootstrap (fixed top navbar)" => "Classic Bootstrap (fixed top navbar)",
"Line" => "Ligne",
"Lines" => "Lignes",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: nombre de lignes différent: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check : a échoué",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check : séquence de modification non optimale",
"WikiDiff Okay: LCS = %s" => "WikiDiff OK : LCS = %s",
// "Problem setting user for \"%0\"" => "Problem setting user for \"%0\"",
// "Problem setting group for \"%0\"" => "Problem setting group for \"%0\"",
// "Problem setting mode for \"%0\"" => "Problem setting mode for \"%0\"",
// "Upload was not successful for \"%0\"" => "Upload was not successful for \"%0\"",
// "Subgallery number to galleryId error: Too many subdirs (%0)</span>" => "Subgallery number to galleryId error: Too many subdirs (%0)</span>",
// "Subgallery number to galleryId error: Not an integer (%0)</span>" => "Subgallery number to galleryId error: Not an integer (%0)</span>",
// "Subgallery number to galleryId error: Gallery with ID %0 not found</span>" => "Subgallery number to galleryId error: Gallery with ID %0 not found</span>",
// "Created by batch upload by user \"%0\" on %1" => "Created by batch upload by user \"%0\" on %1",
// "Create gallery \"%0\" failed</span>" => "Create gallery \"%0\" failed</span>",
// "No permsission to create gallery \"%0\"</span>" => "No permsission to create gallery \"%0\"</span>",
// "Gallery \"%0\" not found</span>" => "Gallery \"%0\" not found</span>",
"Upload was successful" => "Envoi réussi",
"File %s removed from Batch directory." => "Fichier %s supprimé du répertoire de téléchargement par lot.",
"Impossible to remove file %s from Batch directory." => "Impossible de détruire le fichier %s du répertoire de téléchargement par lot.",
"Invalid directory name" => "Nom de répertoire invalide",
// "Move was not successful for \"%0\"" => "Move was not successful for \"%0\"",
// "Copy was not successful for \"%0\"" => "Copy was not successful for \"%0\"",
// "Move was successful" => "Move was successful",
// "Copy was successful" => "Copy was successful",
// "Cannot write to this path: " => "Cannot write to this path: ",
// "Cannot read this file: " => "Cannot read this file: ",
// "Cannot remove file from gallery" => "Cannot remove file from gallery",
// "Migrated Image Galleries" => "Migrated Image Galleries",
// "Converted from image gallery" => "Converted from image gallery",
"My Files" => "Mes fichiers",
// "Files of %0" => "Files of %0",
"Cannot open this file" => "Impossible d'ouvrir ce fichier",
" copy" => " copie",
// "Processing search text from a \"%0\" file in gallery #%1" => "Processing search text from a \"%0\" file in gallery #%1",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "Galeries des fichiers",
"The upload was not completed" => "Le téléchargement ne s'est pas fait",
"Reason: The global quota has been reached" => "Cause : le quota global a été atteint",
"Reason: The quota has been reached in \"%s\"" => "Cause : le quota a été atteint dans \"%s\"",
"File gallery quota exceeded" => "Quota de galerie de fichier dépassé",
"Number of files transferred to the database" => "Nombre de fichiers transferrés vers la base de données",
"Number of files transferred to the file system" => "Nombre de fichiers transferrés vers le gestionnaire de fichiers",
"Old File deleted" => "Ancien fichier supprimé",
"Incorrect param" => "Paramètre incorrect",
"You do not have permission to remove files from this gallery" => "Vous n'avez pas les droits pour supprimer des fichiers de cette galerie",
"Warning: The file is used in" => "AVERTISSEMENT : Le fichier est utilisé dans",
"You are trying to edit multiple files in different galleries, which is not supported yet" => "Vous essayez de modifier des fichiers dans différentes galeries, ce qui n'est pas encore supporté",
"The specified file does not exist" => "Le fichier spécifié n'existe pas",
"Upload was not successful" => "L'envoi s'est mal passé",
"An exception occurred" => "Une exception s'est produite",
"Batch file processed" => "Fichier batch traité",
"Errors detected" => "Erreurs détectées",
"Check that these paths exist and are writable by the web server" => "Vérifier que ces chemins existent et peuvent être écrits par le serveur web",
"File added: " => "Fichier ajouté : ",
"Cannot read the file" => "Impossible de lire le fichier",
"Warning: Empty file" => "Attention : fichier vide",
"Please re-upload the file" => "SVP, réenvoyer votre fichier",
"The upload was not successful due to duplicate file content" => "L'envoi n'a pas réussi. Un fichier de même contenu existe déjà",
// "Files uploaded" => "Files uploaded",
// "File \"%0\" uploaded" => "File \"%0\" uploaded",
"File update was successful" => "Succès de la mise à jour du fichier",
"Automatic revision from source" => "Révision automatique depuis la source",
// "Images successfully moved to file gallery %0" => "Images successfully moved to file gallery %0",
// "Images could not be opened or uploaded" => "Images could not be opened or uploaded",
// "No changes were made since no images in wiki_up were found in Wiki pages" => "No changes were made since no images in wiki_up were found in Wiki pages",
// "No images found" => "No images found",
// "%0 on page %1 could not be opened" => "%0 on page %1 could not be opened",
// "%0 on page %1 could not be uploaded into the file gallery" => "%0 on page %1 could not be uploaded into the file gallery",
// "%0 used on page %1 was moved and given the file ID %2" => "%0 used on page %1 was moved and given the file ID %2",
// "Forcing a filetype of image/svg+xml is blocked for security reasons" => "Forcing a filetype of image/svg+xml is blocked for security reasons",
// "SVG files are not safe and cannot be uploaded" => "SVG files are not safe and cannot be uploaded",
// "PHP Zip extension not found, reqiuired for Feature H5P" => "PHP Zip extension not found, reqiuired for Feature H5P",
// "PHP Class \"ZipArchive\" not found" => "PHP Class \"ZipArchive\" not found",
// "Missing content parameters" => "Missing content parameters",
// "Invalid content parameters" => "Invalid content parameters",
// "Missing title" => "Missing title",
// "Title is too long. Must be 256 letters or shorter" => "Title is too long. Must be 256 letters or shorter",
// "Invalid content type" => "Invalid content type",
// "Created by H5P" => "Created by H5P",
// "The chosen content type isn't installed" => "The chosen content type isn't installed",
"This is an approximation based on your server memory limit" => "Ceci est une approximation basée sur la limite mémoire du serveur",
"This is the value of your server's PHP '%s' setting" => "Valeur du paramètre '%s' du serveur PHP",
// "Not a git repository" => "Not a git repository",
// "Branch \"%s\" not found" => "Branch \"%s\" not found",
// "Can't get Git object file" => "Can't get Git object file",
// "Goal achieved" => "Goal achieved",
// "Event Count" => "Event Count",
// "Event Count (Forever)" => "Event Count (Forever)",
// "Goal Reached (Periodic)" => "Goal Reached (Periodic)",
// "Goal Reached (Forever)" => "Goal Reached (Forever)",
// "Has Badge" => "Has Badge",
// "Add One-Time Badge" => "Add One-Time Badge",
// "%0 Badge" => "%0 Badge",
// "Remove One-Time Badge" => "Remove One-Time Badge",
// "%0 Badge (Remove)" => "%0 Badge (Remove)",
"Credits" => "Crédits",
// "%0 credit(s) - %1" => "%0 credit(s) - %1",
// "Unknown credit type" => "Unknown credit type",
"You are alerted by the server " => "Alerte du serveur ",
"You can check the modifications at: " => "Vous pouvez accéder à la modification à l'adresse :",
"You are alerted of a change on " => "Vous êtes alerté d'un changement sur ",
// "JavaScript file \"%0\" cannot be found so will not be minified" => "JavaScript file \"%0\" cannot be found so will not be minified",
"No image yet, sorry." => "Pas encore d'images, désolé.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "Répertoire cible inconnu. SVP le configurez dans <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "unlink a échoué",
"The uploaded file exceeds the upload_max_filesize directive in php.ini" => "La taille du fichier téléchargé dépasse la directive upload_max_filesize dans php.ini",
"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "La taille du fichier téléchargé dépasse la directive MAX_FILE_SIZE qui é été spécifiée dans le formulaire HTML",
"The uploaded file was only partially uploaded. Please try again" => "Le fichier téléchargé ne l'a été que partiellement. Merci de réessayer",
"No file was uploaded" => "Aucun fichier rapatrié",
"Missing a temporary folder" => "Répertoire temporaire manquant",
"Failed to write file to disk" => "Écriture du fichier impossible sur le disque",
"File upload stopped by extension" => "Télechargement du fichier annulé par l'extension",
"Set new blog as Tiki homepage" => "Faire du nouveau blogue la page d'accueil de Tiki",
"Importation completed" => "Importation terminée",
"<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Cliquer ici</a> pour terminer le processus d'importation",
"Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Trouvé : %0 publications, %1 pages, %2 mots-clés et %3 catégories. Insertion en cours dans Tiki",
"Item \"%0\" NOT imported (there was already a item with the same name)" => "Fiche \"%0\" NON importée (il existait déjà une fiche portant le même nom)",
"Page \"%0\" sucessfully imported" => "Page \"%0\" importée avec succès",
"Post \"%0\" sucessfully imported" => "La publication \"%0\" a té importée aevc succès",
"Import images and other attachments" => "Importer les images et autres pièces jointes",
"Update internal links (experimental)" => "Mettre à jour les liens internes (expérimental)",
"Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)" => "Proposer des règles .htaccess pour rediriger les anciennes URL WP vers les nouvelles dans Tiki (expérimental)",
"Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Classe DOMDocument non disponible, vérifier votre installation PHP. Pour plus d'information, voir http://php.net/manual/en/book.dom.php",
"Invalid file MIME type" => "Type mime invalid",
"There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Erreur lors du chargement du fichier XML. Probablement votre fichier XML est mal construit. Quelques versions de Wordpress génèrent un fichier XML mal construit. Voir la documentation de l'Importateur Tiki pour plus d'information",
"Invalid WordPress XML file" => "Fichier XML Wordpress incorrect",
"No attachments found to import" => "Aucune pièce jointe à importer",
"Importing attachments" => "Importation des pièces jointes en cours",
"Attachment %0 successfully imported" => "Pièce jointe %0 importée avec succès",
"Unable to download attachment %0. Error message was: %1 %2" => "Impossible de télécharger la pièce jointe %0. Le message d'erreur était : %1 %2",
"%0 attachments imported and %1 errors" => "%0 pièces jointes importées et %1 erreur(s)",
"Page \"%0\" successfully extracted" => "La page \"%0\" extraite avec succès",
"Post \"%0\" successfully extracted" => "Publication \"%0\" extraite avec succès",
"Extracting data from XML file" => "Extraction des données du fichier XML",
"Number of page revisions to import (0 for all revisions):" => "Nombre de révisions de pages à importer (0 pour toutes) ",
"What to do with page names that already exists in Tiki?" => "Que faire avec les noms de pages qui existent déjà dans Tiki ?",
"Do not import" => "Ne pas importer",
"Override" => "Outrepasser",
"Prepend software name as a prefix to the page name" => "Ajouter le nom du logiciel comme préfixe au nom de la page",
"Page %0 sucessfully imported" => "Page %0 importée avec succès",
"Page %0 NOT imported (there was already a page with the same name)" => "Page %0 NON importée (il y a déjà une page du même nom)",
"%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pages analysées. Démarrage de leur insertion dans Tiki",
"Import images and attachments (see documentation for more information)" => "Importer images et pièces jointes (voir la documentation pour plus de précisions)",
"Add a maketoc at the top of each page" => "Ajouter une table des matières en haut de chaque page",
"The XML file does not validate against the MediaWiki XML schema" => "Le fichier XML ne valide pas le schéma XML Mediawiki",
"Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments" => "ECHEC : Le répertoire de destination pour les pièces jointes (%0) n'existe pas. Régler le problème ou importer sans les pièces jointes",
"Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments" => "ECHEC : Le répertoire de destination pour les pièces jointes (%0) n'autorise pas l'écriture.",
"File %0 is not being imported because there is already a file with the same name in the destination directory (%1)" => "Importation IMPOSSIBLE du fichier %0 parce qu'il existe déjà un fichier de même nom dans le répertoire de destination (%1)",
"File %0 successfully imported" => "Fichier %0 importé avec succès",
"Unable to download file %0. File not found" => "Impossible de télécharger le fichier %0. Fichier non trouvé",
"Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer" => "Erreur lors de l'analyse de la révision %0 de la page \"%1\". Ou il y a un problème dans la syntaxe de la page ou dans l'analyseur Text_Wiki (l'analyseur utilisé par l'importateur)",
"Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" analysée avec succès avec %1 révisions (sur un total de %2 révisions)",
"Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" ne sera PAS importée. Il n'a pas été possible d'analyser n'importe laquelle de ses révision.",
"MediaWiki XML file version %0 is not supported" => "Le fichier XML Médiawiki version %0 n'est pas supporté",
"Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "Échec; Vous devez activer le réglage PHP 'allow_url_fopen' pour pouvoir importer les pièces jointes. Réglez le problème ou essayez d'importer sans les pièces jointes",
"Parsing pages" => "Analyse des pages",
"No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments" => "Aucune pièce jointe à importer ! Vérifiez quevous avez créé votre fichier XML avec le script dumpDump.php et avec l'option --uploads. C'est la seule façon d'importer des pièces jointes",
// "Invalid template name: %0" => "Invalid template name: %0",
// "Unnamed file" => "Unnamed file",
"string" => "chaîne",
"Unknown language" => "Langue inconnue",
"Error: unable to write to lang/%s/language.php" => "ERREUR: impossible d'écrire dans le fichier lang/%s/language.php",
"The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again" => "Le fichier lang/%0/language.php n'est pas correctement formaté. Exécuter get_strings.php?lang=%0 et ensuite essayer d'exporter les traductions à nouveau",
"Contributions" => "Contributions",
// "reverted" => "reverted",
"section level 0" => "section niveau 0",
"sorted section level 0" => "section triée niveau 0",
"section level 1" => "section niveau 1",
"section level 2" => "section niveau 2",
"section level 3" => "section niveau 3",
"option" => "option",
"separator" => "intercalaire",
"You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu" => "Vous ne pouvez utiliser optionId=0 que pour créer une nouvelle option ou alors optionId=XX avec XX correspondant à un id déjà présent dans le menu pour le mettre à jour",
"menu" => "menu",
"NONE" => "AUCUN",
// "(values not interpreted)" => "(values not interpreted)",
// "Unknown Field: " => "Unknown Field: ",
// "duplicate fields do not match" => "duplicate fields do not match",
"Description not available" => "Description indisponible",
"Module Title" => "Titre du module",
"Title to display at the top of the box" => "Titre à afficher en haut de la boite",
"No Box" => "Pas de boîte",
"Show only the content" => "Ne montrer que le contenu",
"Title, background, etcs" => "Décorations",
"Show module decorations" => "Montrer les décorations du module",
"No Title" => "Sans titre",
// "Hide module title" => "Hide module title",
"Module displayed depending on category. Separate multiple category IDs or names by semi-colons" => "Module affiché selon la catégorie. Plusieurs identificateurs ou noms de catégories peuvent être séparés par ':'",
"No Category" => "Catégorie(s) interdite(s)",
"Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above" => "Module affiché selon la catégorie. Plusieurs identificateurs ou noms de catégories peuvent être séparés par ':'. Ceci l'emporte sur la paramètre 'Catégorie' au dessus",
// "Category subtrees" => "Category subtrees",
// "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)" => "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)",
"Perspective" => "Perspective",
"Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons" => "Afficher le module seulement dans l'une des perspectives indiquées par leur ID. Séparés par des points-virgules",
"Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons" => "Module applicable seulement pour les langues spécifiées. Les langues sont définies par un code à deux lettres. Les valeurs multiples sont séparées par des points-virgules",
"Section" => "Section",
// "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page" => "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page",
"Page Filter" => "Filtre de page",
"Module is displayed only on the specified page(s). Separate multiple page names by semi-colons" => "Module applicable seulement pour les noms de pages sections spécifiés. Les valeurs multiples peuvent être séparées par des points-virgules",
"No Page" => "Pas de Page",
"Module is not displayed on the specified page(s). Separate multiple page names by semi-colons" => "Module non applicable pour les noms de pages spécifiés.Les valeurs multiples peuvent être séparées par des points-virgules",
"Theme" => "Thème",
"Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons" => "Module activé ou non selon le nom du fichier du thème (Ex. : \"thenews.css\"). Les thèmes spécifiés peuvent être inclus ou exclus. Les noms de thèmes préfixés par \"!\" sont exclus. Les valeurs multiples peuvent être séparées par des points-virgules",
"Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module disponible seulement sur la base des relations de l'utilisateur avec la page wiki. Soit seulement les contributeurs (y) ou seulement les non-contributeurs (n) verront le module",
"Contributor" => "Contributeur",
"Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module disponible seulement sur la base des relations de l'utilisateur avec la page wiki. Soit seulement les contributeurs (y) ou seulement les non-contributeurs (n) verront le module",
"Flip" => "Masquer",
"Users can open and close the module" => "Les utilisateurs peuvent afficher/cacher le module",
"Style" => "Style",
"CSS style attribute (for example, to position the module)" => "Attribut de style CSS (par exemple, pour positionner le module)",
"Class" => "Classe",
// "Extra class (for CSS or JavaScript)" => "Extra class (for CSS or JavaScript)",
// "Containing Class" => "Containing Class",
// "Custom CSS class of div around the module" => "Custom CSS class of div around the module",
// "Cookie Consent" => "Cookie Consent",
// "Show only if consent to accept cookies has been granted" => "Show only if consent to accept cookies has been granted",
"No Numbers" => "Pas de numéros",
"If set to \"y\", the module will not number list items" => "Si réglé sur \"y\", le module ne numérotera pas les éléments de la liste",
"Rows" => "Nb max. de rangées \n(si applicable au module)",
"Number of rows, or items, to display" => "Nombre de rangées ou éléments à afficher",
"Default: 10" => "Par défaut : 10",
"Failed to execute \"%0\" module" => "A échoué à exécuter le module \"%0\"",
// "Missing dependencies" => "Missing dependencies",
"Contact the system administrator" => "Contacter l'administrateur système",
// "Module file \"%0\" not found" => "Module file \"%0\" not found",
"Newsletter subscription information at" => "Les informations concernant la lettre d'information sont disponibles à",
// "Cannot add subscribers from a newsletter that includes this newsletter's subscribers" => "Cannot add subscribers from a newsletter that includes this newsletter's subscribers",
// " after sending to" => " after sending to",
// " after error in sending to" => " after error in sending to",
// " after failure to send to" => " after failure to send to",
// "Error - potential cross site request forgery detected" => "Error - potential cross site request forgery detected",
// "Potential cross site forgery request detected" => "Potential cross site forgery request detected",
"Limiting the email send rate. Resuming in %0 seconds" => "Limitation en cours de la fréquence d'envoi de courriel. Reprise dans %0 secondes",
"Newsletter successfully sent to %s users" => "La lettre de nouvelles a été envoyée avec succès à %s utilisateurs",
"Number of errors: %s" => "Il y a eu %s erreurs",
// "End of last article" => "End of last article",
// "potential CSRF" => "potential CSRF",
"invalid email" => "email invalide",
"A user registers" => "Un utilisateur s'inscrit",
"A user submits an article" => "Un utilisateur soumet un article",
"A user edits an article" => "Un utilisateur édite un article",
"A user deletes an article" => "Un utilisateur supprime un article",
"An article is submitted, edited, deleted or commented on." => "Un article est soumis, modifié, supprimé ou commenté.",
"A new blog post is published" => "Une nouvelle publication de blogue est en ligne",
// "A blog post comment is posted or edited" => "A blog post comment is posted or edited",
"A wiki page is created, deleted or edited, except for minor changes." => "Une page wiki est créée, modifiée ou supprimée, sauf pour des changements mineurs.",
"A wiki page is created, deleted or edited, even for minor changes." => "Une page wiki est créée, modifiée ou supprimée, même pour des changements mineurs.",
"A wiki page comment is posted or edited" => "Un commentaire dans une page Wiki a été envoyé ou modifié",
"An article comment is posted or edited" => "Un commentaire sur un article est publié ou modifié",
"Token is called" => "Un jeton a été appelé",
// "User joins a group" => "User joins a group",
// "User's comment is replied" => "User's comment is replied",
"Category change in a language" => "Un changement de catégorie dans une langue",
"A new page is created in a language" => "Une nouvelle page a été créé dans une langue",
// "Cannot save invalid client" => "Cannot save invalid client",
// "Name cannot be empty" => "Name cannot be empty",
// "Redirect URI cannot be empty" => "Redirect URI cannot be empty",
// "Invalid URL for redirect URI" => "Invalid URL for redirect URI",
"section edit" => "édition de la section",
// "Engine \"%0\" not found" => "Engine \"%0\" not found",
// "Output converter \"%0\" not found" => "Output converter \"%0\" not found",
// "Parsed Data" => "Parsed Data",
"Data" => "Contenu",
// "Mapping" => "Mapping",
"Edit Section" => "Modifier cette section",
"index" => "index",
"Table of contents" => "Table des matières",
"Show/Hide" => "Afficher/Cacher",
// "Processing page: %0, is_html: %1" => "Processing page: %0, is_html: %1",
"Payment was sent but verification is not currently available (this feature is a work in progress)" => "Payement envoyé mais la vérification est indisponible (travail en cours)",
// "Cart: Product code mismatch" => "Cart: Product code mismatch",
// "Cart: Product exchange mismatch" => "Cart: Product exchange mismatch",
// "Invalid gift certificate: %0" => "Invalid gift certificate: %0",
"Please enter your shopper information first" => "Merci de commencer par entrer vos informations acheteur",
// "No email found for gift certificate recipient" => "No email found for gift certificate recipient",
"Gift card is not valid for products in cart" => "Carte-cadeau non valide pour les produits dans le panier",
"for" => "pour",
"Bundled Product" => "Produit Packagé",
"Product" => "Produit",
"Quantity" => "Quantité",
"Unit Price" => "Prix unitaire",
"There is insufficient inventory to meet your request" => "Il n'y a pas assez de stock pour votre demande",
// "Advanced Shopping Cart setup error: Orders profile missing" => "Advanced Shopping Cart setup error: Orders profile missing",
"Gift Certificate: " => "Certificat-Cadeau: ",
"Gift Certificate Amount Used: " => "Montant de Certificat-Cadeau utilisé : ",
"No registries specified in admin/payment/cclite" => "Aucun registre spécifié dans admin/payment/cclite",
"Cclite payment initiated on %0" => "Paiement Cclite initié à %0",
"Connection to Cclite server %0 failed for %1<br />\"%2\"" => "La connexion au serveur cclite %0 a échouée pour %1<br />\"%2\"",
"Tiki credits payment done on %0 for %1 (using %2)" => "Paiement de crédits Tiki effectué sur %0 pour %1 (en utilisant %2)",
// "PDF webkit path \"%0\" not found" => "PDF webkit path \"%0\" not found",
// "The PDF webkit path has not been set" => "The PDF webkit path has not been set",
// "PDF WeasyPrint path \"%0\" not found" => "PDF WeasyPrint path \"%0\" not found",
// "The PDF WeasyPrint path has not been set" => "The PDF WeasyPrint path has not been set",
// "PDF webservice URL \"%0\" not found" => "PDF webservice URL \"%0\" not found",
// "The PDF webservice URL has not been set" => "The PDF webservice URL has not been set",
// "The package mPDF is not installed. You can install it using packages" => "The package mPDF is not installed. You can install it using packages",
// "PDF generation failed" => "PDF generation failed",
// "This is set by the administrator (search for \"print\" in the control panels to locate the setting)" => "This is set by the administrator (search for \"print\" in the control panels to locate the setting)",
// "Required function shell_exec is not enabled" => "Required function shell_exec is not enabled",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category ID" => "Areas root category ID",
// "is invalid" => "is invalid",
// "Access-Control-Allow-Origin" => "Access-Control-Allow-Origin",
// "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server" => "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server",
// "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site" => "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site",
// "Record basic events" => "Record basic events",
// "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged" => "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged",
// "Record tracker item update" => "Record tracker item update",
// "Enable recording of basic internal Tiki events" => "Enable recording of basic internal Tiki events",
// "Record tracker item creation" => "Record tracker item creation",
// "Record user following users" => "Record user following users",
// "Record user being followed by users" => "Record user being followed by users",
// "Record user adding new friend" => "Record user adding new friend",
// "Custom activities" => "Custom activities",
// "Allow the defining of custom behaviors in addition to internal events" => "Allow the defining of custom behaviors in addition to internal events",
// "Enable notifications through activities" => "Enable notifications through activities",
// "Allow users to create notifications using activities" => "Allow users to create notifications using activities",
"Ajax auto-save" => "Enregistrement automatique Ajax",
"Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing." => "Sauvegarde vos modifications au fur et à mesure vous permettant de retrouver votre travail après une \"interruption\". Active aussi la prévisualisation en \"Direct\" et est exigé pour le traitement du plugiciel wysiwyg",
// "Inline editing" => "Inline editing",
// "Enable inline editing of certain values. Currently limited to tracker item fields" => "Enable inline editing of certain values. Currently limited to tracker item fields",
// "Tracker list inline editing" => "Tracker list inline editing",
// "Enable inline editing of all fields on the tracker list page" => "Enable inline editing of all fields on the tracker list page",
// "ffmpeg path" => "ffmpeg path",
// "Path to the location of the ffmpeg binary" => "Path to the location of the ffmpeg binary",
// "ffprobe path" => "ffprobe path",
// "Path to the location of the ffprobe binary" => "Path to the location of the ffprobe binary",
// "Alchemy Image library" => "Alchemy Image library",
// "Select either Image Magick or GD Graphics Library" => "Select either Image Magick or GD Graphics Library",
// "Imagemagick" => "Imagemagick",
// "GD" => "GD",
// "unoconv path" => "unoconv path",
// "Path to the location of the unoconv binary" => "Path to the location of the unoconv binary",
// "ghostscript path" => "ghostscript path",
// "Path to the location of the ghostscript binary" => "Path to the location of the ghostscript binary",
// " (Extension not loaded)" => " (Extension not loaded)",
// "Search index rebuild" => "Search index rebuild",
// "Tracker item export" => "Tracker item export",
// "Tracker clear" => "Tracker clear",
// "Printing to PDF" => "Printing to PDF",
// "PHP execution" => "PHP execution",
// "for example 256M, currently is %0" => "for example 256M, currently is %0",
// "for example 30 seconds, currently is %0 seconds" => "for example 30 seconds, currently is %0 seconds",
// "%0 memory limit" => "%0 memory limit",
// "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server" => "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server",
// "for example: 256M" => "for example: 256M",
// "%0 time limit" => "%0 time limit",
// "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values" => "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values",
"seconds" => "secondes",
"Users accept internal messages by default" => "Les utilisateurs acceptent les messages internes par défaut",
// "Users can opt out of internal messages" => "Users can opt out of internal messages",
// "ID of category whose child categories are bound to a perspective by areas" => "ID of category whose child categories are bound to a perspective by areas",
"Newest first" => "Le plus récent d'abord",
"ascending" => "croissant",
"descending" => "décroissant",
// "Article order" => "Article order",
"Default sort mode for the articles on the list-articles page" => "Mode de tri par défaut des articles dans la liste des articles",
"Title of articles homepage" => "Titre de la page d'accueil des articles",
// "Select the default title for the page that displays all articles" => "Select the default title for the page that displays all articles",
"Title" => "Titre",
"Title length" => "Longueur du titre",
// "characters" => "characters",
"Publication date" => "Date de publication",
"Visible" => "Visible",
// "Author (owner)" => "Author (owner)",
"Author name (as displayed)" => "Nom de l'auteur (tel qu'affiché)",
"Author rating" => "Evaluation de l'Auteur",
// "Users rating" => "Users rating",
"Reads" => "Lectures",
// "Is published" => "Is published",
"Trailer position" => "Position de la bande-annonce",
"Between heading and body" => "Entre l'en-tête et le corps",
"Header text position" => "Position du texte d'en-tête",
"Requires a smaller image for list view" => "Nécessite une image plus petite pour l'affichage en liste",
"Next to image" => "Image suivante",
"Below image" => "Sous l'image",
"Oldest first" => "Le plus vieux d'abord",
"Points" => "Points",
"Number per page" => "Nombre par défaut par page",
// "Set the number of comments per page" => "Set the number of comments per page",
"comments" => "commentaires",
"Display order" => "Tri par défaut",
// "Set the display order of comments" => "Set the display order of comments",
"Paginate articles" => "Paginer les articles",
"Divide articles into multiple pages with pagebreak markers" => "Diviser articles en plusieurs pages avec des sauts de page",
// "Article creator remains article owner" => "Article creator remains article owner",
// "Last article editor does not automatically become author (owner)" => "Last article editor does not automatically become author (owner)",
"User ratings on articles" => "Evaluations de l'utilisateur sur les articles",
"Allow users to rate articles" => "Permet aux utilisateurs de noter les articles",
// "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set" => "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set",
"Article rating options" => "Options de notation des articles",
"List of options available for the rating of articles" => "Liste des options possibles pour noter les articles",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Set the default maximum width of the article image" => "Set the default maximum width of the article image",
"pixels" => "pixels",
// "\"0\" for no maximum" => "\"0\" for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Set the default maximum height of article images" => "Set the default maximum height of article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Sets the default maximum width of custom article images in list mode (on View Articles page)" => "Sets the default maximum width of custom article images in list mode (on View Articles page)",
// "\"0\" to default to the view mode maximum" => "\"0\" to default to the view mode maximum",
// "Default maximum height of custom article images in list mode (on View Articles page)" => "Default maximum height of custom article images in list mode (on View Articles page)",
// "Set the default maximum height of custom article images in list mode (on the View Articles page)" => "Set the default maximum height of custom article images in list mode (on the View Articles page)",
// "Article image maximum file size" => "Article image maximum file size",
// "Maximum file size for an article image. Article images are stored in the database so it should remain low" => "Maximum file size for an article image. Article images are stored in the database so it should remain low",
// "kilobytes" => "kilobytes",
"Custom attributes for article types" => "Attributs personnalisés pour les types d'article",
"Enable additional custom fields for article types" => "Autoriser des champs personnalisés additionnels pour les types d'articles",
"Your ShareThis publisher identifier (optional)" => "Votre identifiant de 'publisher' sur www.sharethis.com (optionnel)",
// "Set to define your ShareThis publisher identifier" => "Set to define your ShareThis publisher identifier",
// "record your ShareThis publisher ID" => "record your ShareThis publisher ID",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of an article page" => "Display a list of related articles at the bottom of an article page",
// "Use new articles" => "Use new articles",
// "Use the new CustomSearch-based article lists rather than database information" => "Use the new CustomSearch-based article lists rather than database information",
// "Article copyright" => "Article copyright",
// "Apply copyright management preferences to this feature" => "Apply copyright management preferences to this feature",
"Authentication method" => "Méthode d'authentification",
"Tiki supports several authentication methods. The default method is to use the internal user database" => "Tiki supporte plusieurs méthodes d'authentification. La valeur par défaut est d'utiliser la base de données interne d'utilisateurs",
"Tiki" => "Tiki",
"Tiki and OpenID" => "Tiki et OpenID",
"Tiki and PAM" => "Tiki et l'authentification PAM",
"Tiki and LDAP" => "Tiki et LDAP",
"CAS (Central Authentication Service)" => "CAS (Service Centralisé d'Authentification)",
// "SAML" => "SAML",
"Shibboleth" => "Shibboleth",
"Web Server" => "Serveur Web",
"phpBB" => "phpBB",
// "Token access" => "Token access",
"With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service" => "Autorise à accéder au contenu avec des droits supérieurs sur présentation d'un jeton. La première utilisation de cette méthode d'authentification est d'accorder un accès temporaire à du contenu à un service externe",
// "Token access default timeout" => "Token access default timeout",
// "The default duration for which the generated tokens will be valid" => "The default duration for which the generated tokens will be valid",
// "Token access default maximum hits" => "Token access default maximum hits",
// "The default maximum number of times a token can be used before it expires" => "The default maximum number of times a token can be used before it expires",
// "hits" => "hits",
"Share access rights with friends when using Tell a friend" => "Partager les droits d'accès avec des amis lors de l'utilisation du bouton « Le dire à un ami »",
"Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site" => "Permettre aux utilisateurs de partager leurs droits d'accès sur la page courante avec un ami lors de l'envoie d'un lien par mail. La durée de vie de ces liens est définie par le site",
// "Do not delete temporary users when token is deleted/expired" => "Do not delete temporary users when token is deleted/expired",
// "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms" => "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms",
"Share access rights with friends when using Share" => "Partager les droits d'accès avec des amis lors de l'utilisation du bouton « Partager »",
"Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site" => "Permettre aux utilisateurs de partager leurs droits d'accès sur la page courante avec un ami lors de l'envoie d'un lien par mail/Twitter/Facebook. La durée de vie de ces liens est définie par le site",
"Create user if not registered in Tiki" => "Créer l'utilisateur s'il n'existe pas dans Tiki",
// "Automatically create a new Tiki user for the PHPbb login" => "Automatically create a new Tiki user for the PHPbb login",
"Use Tiki authentication for Admin log-in" => "Utiliser l'authentification Tiki pour le compte Admin",
// "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”" => "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”",
// "Disable Tiki users who don’t have a phpBB login as they could have been deleted" => "Disable Tiki users who don’t have a phpBB login as they could have been deleted",
"phpBB Version" => "Version de phpBB",
"3" => "3",
"phpBB Database Hostname" => "Serveur de base de données de phpBB",
"phpBB Database Username" => "Nom d'utilisateur de la base de données de phpBB",
"phpBB Database Password" => "Mot de passe de la base de données de phpBB",
"phpBB Database Name" => "Nom de la base de données phpBB",
"phpBB Table Prefix" => "Préfixe des tables phpBB",
"Use Tiki authentication for users created in Tiki" => "Utiliser l'authentification Tiki pour les utilisateurs créés dans Tiki",
// "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP" => "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP",
"Host" => "Serveur",
// "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL" => "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL",
"Port" => "Port",
// "The port number your LDAP server uses (389 is the default, 636 if you check SSL)" => "The port number your LDAP server uses (389 is the default, 636 if you check SSL)",
"Write LDAP debug Information in Tiki Logs" => "Inscrire les informations de debug LDAP dans les logs Tiki",
// "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)" => "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)",
// "Do not enable this option for production sites" => "Do not enable this option for production sites",
"Use SSL (ldaps)" => "Utiliser SSL (ldaps)",
"Use TLS" => "Utiliser TLS",
"LDAP Bind Type" => "Type de liaison LDAP",
// "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>" => "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>",
"Default: Anonymous Bind" => "Default: Bind anonyme",
"Full: userattr=username,UserDN,BaseDN" => "Complet : userattr=nom utilisateur,Utilisateur DN,DN de Base",
"OpenLDAP: cn=username,BaseDN" => "LDAP ouvert : cn=nom utilisateur,DN de Base",
"Active Directory (username@domain)" => "Active Directory (nom_utilisateur@domaine)",
"Plain Username" => "Nom d'utilsateur ordinaire",
"Search scope" => "Délimiter la recherche",
// "Used after authentication for getting user and group information" => "Used after authentication for getting user and group information",
"Subtree" => "Sous-arbre",
"One level" => "Un niveau",
"Base object" => "Objet de base",
"Base DN" => "DN de Base",
"User DN" => "Utilisateur DN",
"User attribute" => "Attribut utilisateur",
"User OC" => "Utilisateur OC",
"Realname attribute" => "Attribut nom réel",
// "Synchronize Tiki user attributes with the LDAP values" => "Synchronize Tiki user attributes with the LDAP values",
"Country attribute" => "Attribut pays",
"Email attribute" => "Attribut e-mail",
"Group DN" => "Groupe DN",
"Group name attribute" => "Attribut nom du groupe",
"Group description attribute" => "Attribut description du groupe",
"Group OC" => "Groupe OC",
"Member attribute" => "Attribut membre",
"Member is DN" => "Membre est DN",
"Group attribute" => "Attribut groupe",
"Group attribute in group entry" => "Attribut groupe dans une entrée de groupe",
"(Leave this empty if the group name is already given in the user attribute)" => "(Laisser vide si le nom du groupe est déjà donné dans l'attribut utilisateur)",
"Admin user" => "Utilisateur Admin",
"Admin password" => "Mot de passe administrateur",
"Use an external LDAP server for groups" => "Utiliser un serveur externe LDAP pour les groupes",
"Anonymous Bind" => "Default: Bind anonyme",
"Corresponding user attribute in 1st directory" => "Attribut utilisateur correspondant dans le 1er répertoire",
// "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database" => "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database",
// "Disable Tiki users with no phpBB login" => "Disable Tiki users with no phpBB login",
// "Default Bootstrap" => "Default Bootstrap",
"Available languages" => "Langues disponibles",
// "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset" => "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset",
// "Available themes" => "Available themes",
"Restrict available themes" => "Limiter les thèmes disponibles",
// "BigBlueButton web conferencing" => "BigBlueButton web conferencing",
"Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Intégration avec le serveur collaboratif BigBlueButton pour une conférence web et le partage d'écran",
"BigBlueButton server location" => "Emplacement du serveur BigBlueButton",
"Full URL to the BigBlueButton installation" => "URL complète vers l'installation de BigBlueButton",
"http://host.example.com/" => "http://serveur.exemple.com/",
"BigBlueButton server salt" => "Clé d'authentification serveur BigBlueButton",
"A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic" => "Une clé utilisée pour générer des sommes de contrôle pour le serveur BigBlueButton pour authentifier les requêtes",
"BigBlueButton recording maximum duration" => "Durée maximale d'enregistrement BigBlueButton",
// "A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open" => "A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open",
"minutes" => "minutes",
// "BigBlueButton dynamic configuration" => "BigBlueButton dynamic configuration",
// "Uses the advanced options of BigBlueButton to configure the XML per room" => "Uses the advanced options of BigBlueButton to configure the XML per room",
"Default ordering" => "Ordre par défaut",
// "Default order" => "Default order",
"Creation Date (desc)" => "Date de Création (desc)",
"Last modification date (desc)" => "Date de dernière modification (desc)",
"Blog title (asc)" => "Titre du blogue (asc)",
"Number of posts (desc)" => "Nombre d'articles (desc)",
"Visits (desc)" => "Visites (desc)",
"Activity (desc)" => "Activité (desc)",
"Disabled" => "Désactivée",
"Link to user information" => "Lien vers les informations utilisateur",
"User profile picture" => "Avatar utilisateur",
"Posts" => "Articles",
"Visits" => "Visites",
"Activity" => "Activité",
// "Blog post copyright" => "Blog post copyright",
"Module (box) shadow start" => "Calque des Modules (boîte) - Début",
"Module (box) shadow end" => "Calque des Modules (boîte) - Fin",
"Days to display in the calendar" => "Jours à afficher dans le calendrier",
"Default view mode" => "Vue par défaut",
"Day" => "Jour",
"Week" => "Semaine",
"Month" => "Mois",
"Quarter" => "Trimestre",
"Semester" => "Semestre",
"Year" => "Année",
"View list begins" => "Début de l'affichage",
"Focus date" => "Date choisie",
"Period beginning" => "Début de période",
"First day of the week" => "Premier jour de la semaine",
"Depends user language" => "Dépend de la langue utilisateur",
"Split hours in periods of" => "Découpage des heures par",
// "Minute Interval" => "Minute Interval",
"First year in the dropdown" => "Première année dans la liste déroulante",
"years" => "années",
// "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled" => "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled",
"Last year in the dropdown" => "Dernière année dans la liste déroulante",
"Enter a year or use +/- N to specify a year relative to the current year" => "Entrer une année ou utilisez +/- N pour spécifier une année relative à l'année courante",
"Sticky popup" => "Popup collant",
"Item view tab" => "Onglet affichage élément",
"Show \"Add to Google Calendar\" icon" => "Afficher l'icone ajouter au calendrier Google",
"Show \"Export Calendars\" button" => "Afficher le bouton 'Exporter les calendriers'",
// "Show \"Export Calendar Item\" Button" => "Show \"Export Calendar Item\" Button",
// "Allow exporting a single calendar event as an iCal file" => "Allow exporting a single calendar event as an iCal file",
"Use FullCalendar to display calendars" => "Utiliser FullCalendar pour afficher les calendriers",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
"Enable watch events when you are the editor" => "Envoyer une notification de changement quand je suis l'éditeur",
// "Check this to receive email notifications of events you changed yourself" => "Check this to receive email notifications of events you changed yourself",
"CAPTCHA image word length" => "Longueur du mot de l'image captcha",
"Number of characters the CAPTCHA will display" => "Longueur du mot de l'image captcha",
// "CAPTCHA image width" => "CAPTCHA image width",
"Width of the CAPTCHA image in pixels" => "Largeur de l'image captcha en pixels",
// "CAPTCHA image noise" => "CAPTCHA image noise",
"Level of noise of the CAPTCHA image" => "Niveau de bruit dans l'image captcha",
"Choose a smaller number for less noise and easier reading" => "Choisissez un nombre inférieur pour moins de bruit et une lecture plus facile",
// "CAPTCHA questions" => "CAPTCHA questions",
// "Requires anonymous visitors to enter the answer to a question" => "Requires anonymous visitors to enter the answer to a question",
// "CAPTCHA questions and answers" => "CAPTCHA questions and answers",
// "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line" => "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line",
// "One question per line with a colon separating the question and answer" => "One question per line with a colon separating the question and answer",
"Try automatically to connect SSO" => "Essayer de se connecter automatiquement à SSO",
"Force CAS log-out when the user logs out from Tiki." => "Force la déconnexion CAS lors de la déconnexion de Tiki",
"Show alternate log-in method in header" => "Afficher la méthode de connexion alternative dans l'en-tête",
"CAS server version" => "Version du serveur CAS",
"none" => "aucun",
"Version 1.0" => "Version 1.0",
"Version 2.0" => "Version 2.0",
"Hostname" => "Nom du serveur",
"Hostname of the CAS server" => "Nom du serveur CAS",
"Port of the CAS server" => "Port du serveur CAS",
"Path for the CAS server" => "Chemin pour le serveur CAS",
"CAS Extra Parameter" => "Paramètre supplémentaire CAS",
"Extra Parameter to pass to the CAS Server" => "Paramètre supplémentaire à fournir au serveur CAS",
"CAS Authentication Verification Timeout" => "Délai d'attente pour la vérification d'authentification CAS",
"Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Vérifier l'authentification avec le serveur CAS toutes les N secondes. Une valeur nulle siginifie ne jamais revérifier",
"minute" => "minute",
"hour" => "heure",
// "Provides the current categories to Smarty templates" => "Provides the current categories to Smarty templates",
// "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance" => "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance",
// "Categories to add as CSS classes to <body>" => "Categories to add as CSS classes to <body>",
// "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag" => "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag",
// "Clear cache upon category change" => "Clear cache upon category change",
// "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date" => "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date",
// "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts" => "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts",
"Category jail" => "Prison de catégorie",
"Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limite la visibilité des objets à ceux dans ces IDs de catégorie. Utilisé principalement pour créer des espaces de travail à partir de perspectives",
// "This should only be set for perspectives, and not globally" => "This should only be set for perspectives, and not globally",
// "Category jail root" => "Category jail root",
// "Always display categories outside of the jail root, which would be for normal categorization" => "Always display categories outside of the jail root, which would be for normal categorization",
"Category defaults" => "Catégories par défaut",
"Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default" => "Forcer certaines catégories à être présentes. Si aucune des catégories d'un ensemble donné n'est fournie, assigner une catégorie par défaut",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page" => "One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page",
"Synchronize multilingual categories" => "Synchroniser les catégories multilingues",
"Make sure that the categories of the translations are synchronized when modified on any version." => "S'assurer que les catégories des traductions sont synchronisées quand elles sont modifiées dans n'importe quelle version.",
"Only those specified" => "Uniquement ceux spécifiés",
"All but those specified" => "Tous sauf celles spécifiées",
"Synchronized categories" => "Synchroniser les catégories",
"List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)" => "Liste des catégories concernées par la synchronisation multilingue. Selon la fonctionnalité parente, cette liste sera utilisée comme une liste blanche (seules catégories permises) ou comme une liste noire (tous sauf celles spécifiées)",
// "Sort categories case insensitively" => "Sort categories case insensitively",
// "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings" => "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings",
// "Automatically geocode items with this category" => "Automatically geocode items with this category",
"Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Géolocaliser automatiquement les objets en se basant sur le nom de catégorie lorsqu'ils sont catégorisés dans les sous-catégories de cette catégorie.",
// "Replace any existing geocode" => "Replace any existing geocode",
"When automatically geocoding items based on category name, replace existing geocode, if any" => "Lorsqu'on géolocalise automatiquement les objets en se basant sur le nom de catégorie, remplacer le code de géolocalisation existant s'il existe.",
"Use approximate geocode location" => "Utiliser une géolocalisation approximative",
"When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "Lorsqu'on géolocalise automatiquement les objets en se basant sur le nom de catégorie, utiliser une localisation approximative plutôt que précise",
"\"More Like This\" algorithm for categories" => "Algorithme \"Plus comme ceci\" pour les catégories",
"Weighted" => "Pondéré",
"Minimum number of categories in common" => "Nombre minimum de catégories en commun",
// "categories" => "categories",
"2" => "2",
"4" => "4",
"6" => "6",
"7" => "7",
"8" => "8",
"9" => "9",
// "List objects with most categories in common" => "List objects with most categories in common",
// "No minimum is applied" => "No minimum is applied",
// "Maximum number of \"more like this\" objects" => "Maximum number of \"more like this\" objects",
// "The default maximum records setting for the site is used of this is set to 0" => "The default maximum records setting for the site is used of this is set to 0",
// "objects" => "objects",
// "Generate custom facets from categories" => "Generate custom facets from categories",
// "Comma-separated list of category IDs" => "Comma-separated list of category IDs",
// "Show category object count" => "Show category object count",
// "Show object count when browsing categories, complying with search and type filters" => "Show object count when browsing categories, complying with search and type filters",
// "Can slow the loading of the categories page on large sites" => "Can slow the loading of the categories page on large sites",
"Exclude these category IDs" => "Exclure ces identificateurs de catégorie",
"Category path won't appear for these category IDs" => "Le chemin de catégorie n'apparaîtra pas pour ces IDs de catégorie",
// "Category path format" => "Category path format",
// "Alter how the category path will be rendered" => "Alter how the category path will be rendered",
// "Links to the category when the category is visible" => "Links to the category when the category is visible",
// "Text label when the category is visible" => "Text label when the category is visible",
// "Link when visible, text label otherwise" => "Link when visible, text label otherwise",
// "Always display the category path labels" => "Always display the category path labels",
"Center shadow start" => "Calque central - Début",
"Center shadow end" => "Calque central - Fin",
"Users can choose the language of their interface" => "Les utilisateurs peuvent choisir la langue de leur interface",
"Allow users to change the language of the menus and labels" => "Autoriser les utilsateurs à changer la langue des menus et étiquettes",
"Users can change theme" => "Les utilisateurs peuvent changer de thème",
// "Users can override the theme with this setting" => "Users can override the theme with this setting",
"Users can change their password" => "Les utilisateurs peuvent changer leur mot de passe",
// "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin" => "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin",
"Disable comment titles" => "Désactiver les titres pour les commentaires",
"Don't display the title input field on comments and their replies" => "Cacher le titre des commentaires ainsi que leurs réponses",
"Email field" => "Champ adresse mail",
"Email field for comments (only for anonymous users)" => "Champ adresse mail pour les commentaires (seulement pour les anonymes)",
"Website field" => "Champ site web",
"Website field for comments (only for anonymous users)" => "Champ site web pour les commentaires (seulement pour les utilisateurs anonymes)",
"Use vote system for comments" => "Utiliser le système de vote pour les commentaires",
// "Allow users with permission to vote on comments" => "Allow users with permission to vote on comments",
// "Permissions involved: %0" => "Permissions involved: %0",
"Archive comments" => "Archiver les commentaires",
"If a comment is archived, only admins can see it" => "Si un commentaire est archivé, seul l'administrateur peut le voir",
"Use Akismet to filter comments" => "Utiliser Akismet pour filtrer les commentaires",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam",
"Akismet API Key" => "Clé de l'API Akismet",
// "Key required for the Akismet comment spam prevention" => "Key required for the Akismet comment spam prevention",
"Obtain this key by registering your site at [%0]" => "Obtenir cette clé en enregistrant votre site sur [%0]",
// "Filter spam for registered users" => "Filter spam for registered users",
// "Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening" => "Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening",
// "Allow comments to be edited by their author" => "Allow comments to be edited by their author",
// "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc" => "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc",
// "Inline comments using Apache Annotator" => "Inline comments using Apache Annotator",
// "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations" => "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations",
// "Anchor links on headings" => "Anchor links on headings",
// "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page" => "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page",
// "Number of comments per page" => "Number of comments per page",
// "Sort mode for comments" => "Sort mode for comments",
// "Automatically present a terms of use page to be accepted by users accessing the site" => "Automatically present a terms of use page to be accepted by users accessing the site",
// "Terms of Use page name" => "Terms of Use page name",
// "Wiki page for Terms of Use content. The page may be translated using the multilingual feature" => "Wiki page for Terms of Use content. The page may be translated using the multilingual feature",
// "Minimum age" => "Minimum age",
// "When presenting the terms of use, request age" => "When presenting the terms of use, request age",
// "0 to ignore age validation" => "0 to ignore age validation",
// "Tiki connect" => "Tiki connect",
"Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connecter votre Tiki à la Communauté en envoyant des données statistiques anonymes à tiki.org",
"This feature is still under development" => "Cette fonctionnalité est en cours de développement (Expérimentale)",
// "Send site information" => "Send site information",
"Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you" => "Additionnellement envoyer des mots-clés, emplacement etc. de sorte à pouvoir entrer en contact avec des Tikis proches de vous",
"Site title" => "Titre du Site",
"Name of site to be listed on Tiki Connect" => "Nom du site sur Tiki Connect",
// "Site title is required to send site information" => "Site title is required to send site information",
"Email contact" => "Contact courriel",
"Email to register" => "Adresse mail à enregistrer",
"URL to register" => "URL à enregistrer",
"Key words" => "Mots-clés",
"Key words or tags describing your site" => "Mots clés ou slogans décrivant votre site",
"Site location" => "Emplacement du Site",
"Site location expressed as longitude, latitude, and zoom" => "Emplacement du site en tant que longitude, latitude, zoom",
// "Send anonymous information" => "Send anonymous information",
// "Send anonymous usage information" => "Send anonymous usage information",
"Connection frequency" => "Fréquence de connexion",
// "How often to send information" => "How often to send information",
"hours" => "heures",
// "Click \"Send Info\" to connect" => "Click \"Send Info\" to connect",
// "Currently not in use" => "Currently not in use",
// "Tiki connect server URL" => "Tiki connect server URL",
"Where to send the information" => "Où envoyer l'information",
"Last connection" => "Dernière connexion",
// "Connect server mode" => "Connect server mode",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
// "Connect GUID" => "Connect GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
"Allow anonymous visitors to use the \"Contact Us\" feature" => "Autoriser les visiteurs anonymes à utiliser la fonctionnalité \"Nous contacter\"",
// "Display contact priority" => "Display contact priority",
// "Display contact priority option" => "Display contact priority option",
"Contact user" => "Utilisateur du contact",
// "User to contact" => "User to contact",
"Cookie name" => "Nom du Cookie",
"Domain" => "Domaine",
// "The domain that the cookie is available to" => "The domain that the cookie is available to",
// "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically" => "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically",
// "Ask permission of the user before setting any cookies, and comply with the response" => "Ask permission of the user before setting any cookies, and comply with the response",
// "Complies with EU Privacy and Electronic Communications Regulations" => "Complies with EU Privacy and Electronic Communications Regulations",
// "Cookie consent name" => "Cookie consent name",
// "Name of the cookie to record the user's consent if the user agrees" => "Name of the cookie to record the user's consent if the user agrees",
// "Cookie consent expiration" => "Cookie consent expiration",
// "Expiration date of the cookie to record consent (in days)" => "Expiration date of the cookie to record consent (in days)",
"days" => "jours",
// "Cookie consent text" => "Cookie consent text",
// "Description for the dialog" => "Description for the dialog",
// "Wiki-parsed" => "Wiki-parsed",
// "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))" => "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))",
// "Cookie consent question" => "Cookie consent question",
// "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox" => "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox",
// "I accept cookies from this site" => "I accept cookies from this site",
"Cookie consent button" => "Bouton de consentement des cookies",
// "Label on the agreement button" => "Label on the agreement button",
"Continue" => "Continuer",
// "Cookie consent alert" => "Cookie consent alert",
// "Alert displayed when user tries to access or use a feature requiring cookies" => "Alert displayed when user tries to access or use a feature requiring cookies",
// "Sorry, cookie consent required" => "Sorry, cookie consent required",
// "Cookie consent mode" => "Cookie consent mode",
// "Appearance of consent dialog" => "Appearance of consent dialog",
// "Dialog style requires feature_jquery_ui" => "Dialog style requires feature_jquery_ui",
"Plain" => "À plat",
"Banner" => "Bannière",
"Dialog" => "Dialogue",
// "Cookie consent dialog ID" => "Cookie consent dialog ID",
// "DOM id for the dialog container div" => "DOM id for the dialog container div",
// "Cookie consent disabled" => "Cookie consent disabled",
// "Do not give the option to refuse cookies but still inform the user about cookie usage" => "Do not give the option to refuse cookies but still inform the user about cookie usage",
// "Refresh the remember-me cookie expiration" => "Refresh the remember-me cookie expiration",
// "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated" => "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated",
// "Name of the cookie to remember the user's login" => "Name of the cookie to remember the user's login",
"Count admin pageviews" => "Compter les affichages de pages d'administration",
"Include pageviews by Admin when reporting stats" => "Inclure les pages vues par l'administrateur dans les rapports de statistiques",
"Enable daily reports for new users" => "Activer les rapports journaliers pour les nouveaux utilisateurs",
// "Determines if daily reports will be automatically enabled for new users" => "Determines if daily reports will be automatically enabled for new users",
"Default character set for sending mail" => "Jeu de caractères par défaut pour les courriels sortants",
"Specify the character encoding used by Tiki when sending mail notifications" => "Jeu de caractères par défaut pour les courriels sortants",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "fichier-carte par défaut",
"Default diff style" => "Style par défaut du diff",
"Only with last version" => "Seulement avec la dernière version",
"HTML diff" => "diff HTML",
"Side-by-side diff" => "Diff. côte à côte",
"Side-by-side diff by characters" => "Diff. côte à côte sur les caractères",
"Inline diff" => "Diff. entrelacée",
"Inline diff by characters" => "Diff. entrelacée sur les caractères",
"Full side-by-side diff" => "Diff. côte à côte complet",
"Full side-by-side diff by characters" => "Diff. côte à côte complète sur les caractères",
"Full inline diff" => "Diff. entrelacée complète",
"Full inline diff by characters" => "Diff. entrelacée complète sur les caractères",
"Unified diff" => "Diff. entrelacé",
"Side-by-side view" => "Affichage côte à côte",
"rows" => "lignes",
// "Comment box" => "Comment box",
// "Size (height) of the comment text area" => "Size (height) of the comment text area",
"Forum reply" => "Réponse au Forum",
// "Select default calendars to display" => "Select default calendars to display",
// "Group transition sets default" => "Group transition sets default",
// "Sets the group transitioned to as the user's default group" => "Sets the group transitioned to as the user's default group",
// "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites" => "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites",
"Disable browser's autocomplete feature for username and password fields" => "Désactiver la fonction de complétion automatique du navigateur pour les champs username et le mot de passe",
"Use direct pagination links" => "Utiliser les liens de pagination directs",
"Maximum number of links around the current item" => "Nombre maximum de liens autour de l'élément courant",
// "links" => "links",
"Maximum number of links after the first or before the last item" => "Nombre maximum de liens après le premier ou avant le dernier élément",
"Show country flag" => "Afficher les drapeaux des pays",
"Show the country flag" => "Afficher le drapeau du pays",
"Enable \"popular sites\"" => "Activer les sites cools",
"Validate URLs" => "Tester la validité des adresses Web",
// "Should Tiki check the URL" => "Should Tiki check the URL",
// "Columns per page" => "Columns per page",
"Number of columns per page when listing directory categories" => "Nombre de colonnes par page dans le listing des catégories",
// "columns" => "columns",
"Links per page" => "Liens par page",
// "How many links should be displayed per page" => "How many links should be displayed per page",
"Method to open Directory links" => "Méthode pour ouvrir les liens de l'Annuaire",
"The linked-to website can be opened in various ways" => "Méthode pour ouvrir les liens du répertoire",
"Replace the current window" => "remplacer la fenêtre courante (r)",
"Open a new window" => "nouvelle fenêtre",
"Open an iframe" => "cadre dans la fenêtre (i)",
"Fields display order" => "Ordre d'affichage des champs",
// "The order date field inputs should be listed in" => "The order date field inputs should be listed in",
// "Year to show first in dropdown lists" => "Year to show first in dropdown lists",
// "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year" => "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year",
// "year(s)" => "year(s)",
// "Year to show last on dropdown lists" => "Year to show last on dropdown lists",
// "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year" => "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year",
"Re-validate user email after" => "Demander aux utilisateurs de se confirmer par courrier électronique après",
// "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid" => "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid",
"Use \"-1\" for never" => "Utiliser \"-1\" pour \"jamais\"",
"Email footer" => "Pied de page des courriels",
"Text appended to outgoing emails" => "Texte ajouté en fin des courriels sortants",
"PHP errors visible to admin only" => "Les erreurs PHP visibles aux admins seulement",
"During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators" => "A des fins de développement, il est plus utile d'afficher les erreurs pour tous les utilisateurs. Cependant la version définitive ne devrait afficher celles-ci qu'aux administrateurs",
// "PHP Errors will be shown to only the Admin user" => "PHP Errors will be shown to only the Admin user",
"PHP Error reporting level" => "Niveau de signalement des erreurs PHP",
"Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist" => "Niveau à partir duquel les messages d'erreur seront pris en compte",
"No error reporting" => "Rapport d'erreurs désactivé",
"Report all PHP errors except strict" => "Signaler toutes les erreurs PHP excepté les strictes",
"Report all PHP errors" => "Signaler toutes les erreurs PHP",
"Report all PHP errors except notices" => "Signaler toutes les erreurs PHP excepté les notifications",
"According to the PHP configuration" => "Selon la configuration PHP",
"Default number of comments per page" => "Nombre par défaut de commentaires par page",
// "Maximum number of comments to display on each page. Users may override this number" => "Maximum number of comments to display on each page. Users may override this number",
"Default order of comments" => "Ordre par défaut des commentaires",
// "In which order to list the comments on the page" => "In which order to list the comments on the page",
// "Prefix for answers" => "Prefix for answers",
// "The prefix for that Tiki should display for each FAQ answer" => "The prefix for that Tiki should display for each FAQ answer",
"Q and A" => "Q et R",
"Question ID" => "Numéro de la question",
// "FAQ copyright" => "FAQ copyright",
// "Limit blog categories to those under this category" => "Limit blog categories to those under this category",
"If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "Si vous obtenez un message d'erreur indiquant qu'une catégorie obligatoire est requise pour modidifer une publication existante de blogue, c'est cette option qu'il faut incriminer. La définir à 'None'",
"Areas" => "Zonages",
"Binding categories and perspectives to each other" => "Lier des catégories et des perspectives entre elles",
// "Pages and collaboratively authored documents with edit history" => "Pages and collaboratively authored documents with edit history",
"Online diaries or journals." => "Journal en ligne ou cybercarnet.",
"Enable directory batch loading" => "Permettre le téléchargement par lot par répertoire",
// "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols" => "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols",
"You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory" => "Si vous activez le téléchargement par lot, vous devez créer un répertoire pouvant être lu par le serveur web (de préférence hors de l'arborescence du site). Ensuite installer un moyen d'envoyer les images dans ce répertoire par ftp, scp ou autres",
"Rankings" => "Classements",
// "Users can see several charts or rankings about the file" => "Users can see several charts or rankings about the file",
// "Image gallery" => "Image gallery",
"Collections of images for viewing or downloading (photo albums)" => "Collections d'images pour la visualisation ou le téléchargement (album photo)",
"File galleries can be used instead" => "Vous pouvez plutôt utiliser les galeries de fichier",
// "Image Gallery Comments" => "Image Gallery Comments",
// "Users with permission may post threaded comments. The comments will appear at the bottom of the page" => "Users with permission may post threaded comments. The comments will appear at the bottom of the page",
// "Limit image gallery categories to those under this category" => "Limit image gallery categories to those under this category",
// "Machine translation" => "Machine translation",
// "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service" => "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service",
"Database and form generator" => "Base de données et générateur de formulaire",
"Threaded or flat discussions" => "Discussions en ligne sur une variété de sujets dont les réponses sont affichées selon un fil de discussion (emboîtement des messages) ou à plat",
"File gallery" => "Galerie de fichier",
"Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability" => "Fichiers, vidéos ou logiciels à télécharger. Avec check-in et check-out (blocage)",
"Save files as drafts" => "Enregistrer des brouillons de fichiers",
// "Allow saving of files as drafts" => "Allow saving of files as drafts",
"File gallery configuration templates" => "Modèles de configuration des galeries de fichier",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Sondages",
"Presentation of a set of votable options, typically displayed in a module" => "Liste brève de choix de vote ; apparaît dans un module (colonne de gauche ou de droite).",
"Newsletters" => "Lettres de nouvelles",
"Content mailed to registered users or other subscribers" => "Contenu envoyé par mail aux utilisateurs inscrits",
"Calendar" => "Calendrier",
"Events calendar with public, private and group channels." => "Calendrier d'évenements avec canaux public, privé et groupe.",
"Banners" => "Bannières",
"Insert, track, and manage advertising banners." => "Insérer, suivre et gèrer les bannières publicitaires.",
// "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access" => "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access",
// "Unified user details " => "Unified user details ",
// "Use User Details Page using the Unified Index" => "Use User Details Page using the Unified Index",
"Score" => "Système d'évaluation",
"Score is a game to motivate participants to increase their contribution by comparing to other users" => "Le score est une compétition destinée à motiver les participants à accroître leur contribution en se comparant les uns aux autres",
// "Score expiry" => "Score expiry",
// "Unified search index" => "Unified search index",
// "Enables searching for content at the site using a Tiki-managed index" => "Enables searching for content at the site using a Tiki-managed index",
"Enables tags to be set on pages and other items for freeform categorization." => "Permet de définir des mots-clés sur les pages et objets divers au sein du site et de générer des schémas de navigation en forme de nuage de mots-clés.",
// "Action log" => "Action log",
"Provides the ability to track the actions of users and produce reports on a per-user or per-category basis" => "Permet de garder une trace de ce que font les utilisateurs et produire des rapports sur des bases par utilisateur ou par catégorie",
"Contribution" => "Contribution",
"Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports" => "Permet aux utilisateurs de spécifier le type de contribution qu'ils font en éditant les objets. Les contributions sont ensuite affichées sous forme de code de couleurs dans l'historique et autres rapports",
"Multilingual" => "Multilingue",
"Enables internationalization features and multilingual support at the site" => "Active les fonctionnalités d'internationalisation et le support multi-langues pour le site",
"Frequently asked questions and answers" => "Questions fréquemment posées et réponses",
"There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs" => "Vous pouvez plutôt utiliser les pages wiki",
"Surveys" => "Enquêtes",
"Create questionnaires with multiple-choice or open-ended questions" => "Questionnaire à choix multiple ou question ouverte",
"User-submitted Web links" => "Liens Web soumis par les utilisateurs",
"Sets of questions that can be presented, with the sessions timed and the scores recorded." => "Questionnaire chronométré avec enregistrement des scores.",
// "Featured links" => "Featured links",
"A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc." => "Menu système simple qui peut optionellement ajouter une iframe sur une page externe",
"Copyright" => "Droits d'auteur",
"Use the Copyright Management System (or ©MS) to display the license of your content" => "Le système de gestion des droits d'auteur (ou © MS) est une façon d'accorder les licences de vos contenus",
"Wiki references" => "Références Wiki",
// "Permits using references and the reference library" => "Permits using references and the reference library",
// "Library references" => "Library references",
// "Enforce library reference as master" => "Enforce library reference as master",
// "Reference style" => "Reference style",
// "Default style when using references" => "Default style when using references",
// "AMA citation style (default)" => "AMA citation style (default)",
// "MLA citation style" => "MLA citation style",
// "Display reference in a popover" => "Display reference in a popover",
// "Display the details of the reference in a popover" => "Display the details of the reference in a popover",
"Shoutbox" => "Mégaphone",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
"Live support system" => "Système d'assistance en ligne",
"One-on-one chatting with customer" => "Discussion en tête à tête avec un client.",
// "Tell a friend" => "Tell a friend",
"Add to each page an \"Email this page\" link" => "Ajoute un lien \"Envoyer cette page\" dans toutes les pages",
"Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums" => "Ajouter un lien \"Partager\" dans toutes les pages pour l'envoyer par e-mail, Twitter, Facebook, message ou forums.",
"Be careful when allowing anonymous users to activate the antibot feature." => "Veiller à activer la fonctionnalité antibot quand vous autoriser les anonymes.",
"HTML pages" => "Pages HTML",
"Static and dynamic HTML content" => "Contenu HTML statique et dynamique",
"HTML can be used in wiki pages. This is a separate feature" => "Le HTML peut être utilisé dans les pages wiki. Ceci est une fonctionnalité séparée",
// "Contact us" => "Contact us",
"A basic contact form a visitor can use to contact the site admin" => "Affiche un formulaire pour contacter l'administrateur du site",
"Minichat" => "Mini clavardage (chat)",
"Real-time group text chatting enabled through a module" => "Discussion en temps réel de groupe.",
// "Comments moderation" => "Comments moderation",
"Enables the admin or other authorized group member to validate comments before they are visible" => "Un administrateur doit valider un commentaire avant qu'il ne soit visible",
// "Add author name in From email header" => "Add author name in From email header",
// "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"" => "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"",
// "Comments locking" => "Comments locking",
"Comments can be closed (no comments, or no new comments)" => "Les commentaires peuvent être fermés (pas de nouveaux commentaires)",
// "Allow logged-in users to post comments anonymously" => "Allow logged-in users to post comments anonymously",
// "This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement" => "This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement",
// "Show the page description" => "Show the page description",
"Display the wiki page description between the page title and the page content" => "Afficher la description des pages sous l'en-tête lorsque la page est affichée",
"Display page name as page title" => "Afficher le nom des pages comme titre des pages",
"Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title" => "Affiche le nom de la page en haut de chaque en tant que titre. Si non validé, le contenu de la page devra être structuré pour contenir un en-tête",
// "Show the page ID" => "Show the page ID",
"Each wiki page has a numeric ID and this can be displayed" => "Afficher l'ID (interne) des pages lorsque la page est visible",
"Individual wiki cache" => "Cache wiki individuel",
"Allow users to change the duration of the cache on a per-page basis" => "Permettre aux utilisateurs de changer la durée du cache pour chaque page",
// "Date picker for date selection" => "Date picker for date selection",
// "JavaScript popup date selector (uses jQuery UI DatePicker)" => "JavaScript popup date selector (uses jQuery UI DatePicker)",
// "Output should be HTML purified" => "Output should be HTML purified",
"This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results" => "Ceci active le Purificateur HTML sur les sorties pour filtrer des problèmes potentiels de sécurité restants comme XSS",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Full screen" => "Plein écran",
"Allow users to activate full-screen mode" => "Autoriser aux utilisateurs l'activation du mode plein écran",
// "CSS menus" => "CSS menus",
"Use CSS-styled (Suckerfish) vertical and horizontal menus" => "Menus CSS (suckerfish).",
"Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)" => "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)",
// "Quick permission assignment" => "Quick permission assignment",
"Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object." => "L'affectation rapide des droits permet de définir des catégories de privilèges et de les octroyer à des rôles sur les objets.",
// "User encryption" => "User encryption",
// "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored" => "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored",
// "Enable personal, secure storage of sensitive data such as passwords" => "Enable personal, secure storage of sensitive data such as passwords",
// "This is an experimental feature. Using it may cause loss of the encrypted data" => "This is an experimental feature. Using it may cause loss of the encrypted data",
// "Password domains" => "Password domains",
// "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself" => "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself",
// "HTML purifier" => "HTML purifier",
"If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "Si vous utilisez du code HTML dans vos pages et qu'il est enlevé, assurez-vous que votre HTML est valide ou désactivez cette fonctionnalité",
"Ajax" => "Ajax",
// "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work" => "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work",
// "This feature is required for the interface for many features to work properly" => "This feature is required for the interface for many features to work properly",
"Webmail" => "Messagerie",
"Intertiki" => "Intertiki",
"Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Autorise plusieurs sites Tiki (esclaves) à utiliser l'authentification d'un site Tiki maître",
"Mail-in" => "Contenu par mail entrant",
"Create and publish wiki pages and articles via email" => "Peupler pages wiki et articles par courriel",
"Mindmap" => "Carte mentale",
// "Display in a graphical way the connection among wiki pages" => "Display in a graphical way the connection among wiki pages",
"Print indexed" => "Imprimer Globalement",
"Generate a printable version of the whole wiki or a subset of pages, filtered by category" => "Imprimer Globalement",
"Spreadsheet" => "Tableur",
"Spreadsheets with calculations and charts" => "Feuilles de données avec calculs et graphiques.",
// "Slideshow (reveal.js)" => "Slideshow (reveal.js)",
"Create simple presentations via Wiki Syntax" => "Diaporama basé sur le Web",
// "Slideshow (reveal.js) PDF export" => "Slideshow (reveal.js) PDF export",
// "Wiki-page-based slideshow to pdf export" => "Wiki-page-based slideshow to pdf export",
"Invoice" => "Facture",
"Invoice system" => "Système de facturation",
// "Full WYSIWYG editor" => "Full WYSIWYG editor",
"WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience" => "WYSIWYG est un acronyme pour What You See Is What You Get. Utilise CKEditor.",
// "Kaltura video management" => "Kaltura video management",
// "Integration with the Kaltura video management platform" => "Integration with the Kaltura video management platform",
// "Friendship network" => "Friendship network",
"Users can identify other users as their friends" => "Les utilisateurs peuvent déclarer d'autres utilisateurs comme leurs amis",
"Banning system" => "Système d'interdiction",
"Deny access to specific users based on username, IP, and date/time range" => "Interdit l'accès à certains utilisateurs sur la base du nom, de l'adresse IP et du créneau de date/heure",
"Stats" => "Statistiques",
"Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Enregistrer des statistiques basiques à propos des fonctionnalités majeures de Tiki (nombre de pages Wiki, taille des galeries de fichiers, etc.)",
// "Action calendar" => "Action calendar",
"Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page." => "Affiche un calendrier des événements reliés au système comme les modifications de pages wiki et les publications sur les forums ou sur les articles. Les jours contenant des événements affichent des liens vers la page du calendrier des actions.",
"Referrer stats" => "Statistiques des origines",
"Record domain name of sites that send visitors to this Tiki" => "Enregistre les noms de domaines des visiteurs du site",
"Redirect on error" => "Redirection en cas d'erreur",
"On an error, refresh to the homepage as specified on the Admin General page" => "En cas d'erreur, retour à la page d'accueil configurée dans Administration->Général",
"Communications (send/receive objects)" => "Communications (envoyer/recevoir des objets)",
"Send/receive wiki pages and articles between Tiki-powered sites" => "Envoyer/recevoir des pages wiki et articles entre des sites Tiki",
"Display \"My Account\" in the application menu" => "Affiche 'MonTiki' dans le menu application",
// "Mini calendar" => "Mini calendar",
// "Displays a personal calendar for each user" => "Displays a personal calendar for each user",
// "User preferences screen" => "User preferences screen",
// "User notepad" => "User notepad",
// "My bookmarks" => "My bookmarks",
// "User contacts" => "User contacts",
// "User watches" => "User watches",
// "Receive email notification of changes. Each user can choose to be notified of changes to specific items" => "Receive email notification of changes. Each user can choose to be notified of changes to specific items",
// "Group watches" => "Group watches",
// "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group" => "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group",
// "Daily reports for user watches" => "Daily reports for user watches",
// "Allows you to schedule daily reports of watches to be sent (batched) at specific times" => "Allows you to schedule daily reports of watches to be sent (batched) at specific times",
// "User watches translations" => "User watches translations",
// "User watches languages" => "User watches languages",
"Watch language-specific changes within a category" => "Surveiller des changements spécifiques à certaines langues dans une catégorie",
// "User menu" => "User menu",
"Unmaintained feature" => "Fonctionnalités délaissées",
// "User tasks" => "User tasks",
"User messages" => "Messages utilisateur",
// "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group)." => "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group).",
// "User files" => "User files",
"Menu user levels" => "Niveaux d'utilisateurs de menus",
"Enables control of the per-group visibility of menu options" => "Permettre le contrôle des options de menu pouvant être vues par un utilisateur.",
// "Group alert" => "Group alert",
"Integrator" => "Intégrateur",
"XMLRPC API" => "API XMLRPC",
"Debugger console" => "Console de débogage",
// "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions" => "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions",
// "Only viewable by admins" => "Only viewable by admins",
// "Not suitable for production use" => "Not suitable for production use",
"TikiTests" => "TikiTests",
"Permits recording and playback of functional tests" => "Permet l'enregistrement et l'exécution des tests fonctionnels",
"Check for updates automatically" => "Vérifier les mises à jour automatiquement",
"Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection" => "Tiki vérifiera la présence de mises à jour lors de l'accès à la page d'administration principale",
"Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters" => "Abonnez-vous aux newsletters Tiki pour être informé des nouveautés. https://doc.tiki.org/Newsletters",
// "Require confirmation of an action if a possible CSRF is detected" => "Require confirmation of an action if a possible CSRF is detected",
// "Deprecated. Using may cause false errors" => "Deprecated. Using may cause false errors",
"Detect browser language" => "Utiliser la préférence langue du navigateur",
"Look up the user's preferred language through browser preferences" => "Look up the user's preferred language through browser preferences",
"Show pages in user's preferred language" => "Affiche les pages dans la langue préférée de l'utilisateur",
"When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences" => "Lors d'un accès à un page ayant un équivalent dans la langue préférée de l'utilisateur, favoriser la page traduite",
// "Synchronize page and site language" => "Synchronize page and site language",
"Changing the page language also changes the site language" => "Changer la langue de la page change également la langue du site",
"Translation assistant" => "Assistant de traduction",
"Track translation operations between pages" => "Suivre les opérations de traduction entre les pages",
"Urgent translation notifications" => "Notifications d'une traduction urgente",
// "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users" => "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users",
"Incomplete translation notice" => "Notification des traductions incomplètes",
"When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete" => "Quand une page est traduite dans une nouvelle langue, une mention sera automatiquement insérée dans la page pour indiquer que la traduction n'est pas encore complète",
"Multilingual structures" => "Structures multilingues",
// "Structures search for equivalent pages in other languages" => "Structures search for equivalent pages in other languages",
// "May cause performance problems with larger structures" => "May cause performance problems with larger structures",
"Display all languages in a single page" => "Afficher toutes les langues dans une seule page",
// "List all languages as options in the page-language dropdown list, to see them all at once" => "List all languages as options in the page-language dropdown list, to see them all at once",
"GZip output" => "Activer la compression GZip des pages",
"Compress your pages on-the-fly, if the requesting browser supports this" => "Compresser vos pages à la volée, si le navigateur demandant le permet",
// "Help system" => "Help system",
// "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/" => "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/",
"Smileys" => "Frimousses",
"Also known as emoticons" => "Aussi appelées émoticônes",
// "Tagging users" => "Tagging users",
// "Add support for @username mentions" => "Add support for @username mentions",
// "User mention notifications" => "User mention notifications",
// "Add support for @username mentions notifications" => "Add support for @username mentions notifications",
// "Draw (SVG edit)" => "Draw (SVG edit)",
"Draw enables creating and editing SVG images in all wiki text areas" => "Draw vous donne la capacité d'éditer des images SVG tout autour de Tiki",
// "Draw (SVG edit) hide buttons" => "Draw (SVG edit) hide buttons",
// "Hide buttons in Draw, HTML id, comma-separated" => "Hide buttons in Draw, HTML id, comma-separated",
// "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"" => "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"",
// "Separate base image" => "Separate base image",
// "Leaves the initially edited image as a separate file and stores the drawing separately" => "Leaves the initially edited image as a separate file and stores the drawing separately",
// "Draw in user file gallery" => "Draw in user file gallery",
"Docs (WebODF)" => "Documents (WebODF)",
// "Docs enables viewing and editing Open Document Format files" => "Docs enables viewing and editing Open Document Format files",
// "Dynamic content system" => "Dynamic content system",
"Block of content which can be reused and programmed (timed)" => "Bloc de contenu qui peut être réutilisé et programmé (temporisé)",
// "Use file galleries to store images" => "Use file galleries to store images",
"If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead" => "Si désactivé, mes images seront alors stockées dans ../img/wiki_up/..",
"External link icon" => "Icône des liens externes",
// "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set" => "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set",
// "Add \"rel=nofollow\" to external links" => "Add \"rel=nofollow\" to external links",
"Semantic links" => "Liens sémantiques",
"Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages" => "Allant au-delà des 'Backlinks', permet de définir des relations un peu sémantiques entre des pages wiki",
// "Web services" => "Web services",
"Can receive web services via JSON or YAML" => "Droit de consommer des webservices JSON ou YAML",
"Use folder icons for menu section (parent) items" => "Afficher les icônes des menus comme des répertoires",
// "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)" => "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)",
"Breadcrumbs" => "Fil d'ariane",
"Indicates the navigation path through parent pages to the current page" => "Tente de montrer où vous êtes",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Les éditeurs anonymes doivent saisir un code de vérification anti-bot (CAPTCHA)",
// "Use CAPTCHA to ensure that anonymous input is from a person" => "Use CAPTCHA to ensure that anonymous input is from a person",
"Protect email against spam" => "Protéger les adresses mails contre les spammeurs",
// "Protect email against spam submissions" => "Protect email against spam submissions",
"Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protéger le courriel contre le spam ne fonctionne pas actuellement dans les pages éditées en mode WYSIWYG (Tiki 6.1)",
// "Site ads" => "Site ads",
// "Enable advertising" => "Enable advertising",
// "Activate will display content for Admin only. Select Publish to display for all users" => "Activate will display content for Admin only. Select Publish to display for all users",
"Anonymous voting" => "Votes anonymes",
// "Allow anonymous users to participate in voting" => "Allow anonymous users to participate in voting",
// "This can be overridden by specific permissions" => "This can be overridden by specific permissions",
"Allow re-voting" => "Un même votant peut re-voter",
// "Visitors can vote mulitiple times in a poll" => "Visitors can vote mulitiple times in a poll",
// "When logged in, Tiki tracks users by username or otherwise IP address" => "When logged in, Tiki tracks users by username or otherwise IP address",
"Comments for polls" => "Commentaires pour les sondages",
"Comments for FAQs" => "Commentaires pour les FAQs",
"Search engine friendly URL" => "URLs courts (SEFURL)",
"If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config" => "Si vous utilisez Apache, vous pouvez copier _htaccess en .htaccess pour obtenir des URLs courtes. Sur IIS, copier web_config en web.config",
// "SEFURL postfilter" => "SEFURL postfilter",
// "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead" => "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead",
// "Article title in SEFURL" => "Article title in SEFURL",
// "The article title rather than article number can be displayed in the search engine friendly URL" => "The article title rather than article number can be displayed in the search engine friendly URL",
// "Blog title in SEFURL" => "Blog title in SEFURL",
// "The blog title rather than blog number can be displayed in the search engine friendly URL" => "The blog title rather than blog number can be displayed in the search engine friendly URL",
// "Display forum thread or forum post title in the search engine friendly URL" => "Display forum thread or forum post title in the search engine friendly URL",
// "Tracker title in SEFURL" => "Tracker title in SEFURL",
// "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`" => "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`",
// "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)" => "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)",
// "Limit the number of characters in the tracker item or forum thread title" => "Limit the number of characters in the tracker item or forum thread title",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
"This redirection uses the wiki prefix alias feature" => "Cette redirection utilise la fonctionnalité 'wiki prefix alias'",
"Canonical URL tag" => "Balise URL canonique",
"Indicates to search engines which URL to use, to prevent duplicate listings" => "Indique aux moteurs de recherche quelle URL utiliser ce qui évite les doublons dnas les listes",
// "Canonical URL domain" => "Canonical URL domain",
// "Custom Routes" => "Custom Routes",
// "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL" => "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL",
"Show module controls" => "Afficher le contrôle des modules",
// "Enable controls in modules" => "Enable controls in modules",
"Perspectives" => "Perspectives",
"Permits overriding of preferences" => "Permet de passer outre les préférences",
"Search and replace" => "Rechercher et remplacer",
"Enables finding and replacing of content in the edit box" => "Permet la recherche et remplacement du contenu dans la boîte d'édition",
"Submissions" => "Soumissions",
// "Articles can be submitted but need to be approved before they are published" => "Articles can be submitted but need to be approved before they are published",
// "Users can see several charts or rankings about the item" => "Users can see several charts or rankings about the item",
"Comments on articles" => "Commentaires pour les articles",
// "Users with permission can post or reply to comments. The comments will appear at the bottom of the page" => "Users with permission can post or reply to comments. The comments will appear at the bottom of the page",
"Article content templates" => "Gabarits de contenu d'article",
// "Predefined content for an article" => "Predefined content for an article",
// "template article news" => "template article news",
// "Print articles" => "Print articles",
"Specify notification emails when creating articles" => "Définir l'email de notification lors de la création d'article",
// "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation" => "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation",
"ShareThis buttons" => "Boutons ShareThis",
// "Enable sharing site content via ShareThis" => "Enable sharing site content via ShareThis",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
// "Category path" => "Category path",
"Show the category tree above the wiki page" => "Afficher l'arborescence des catégories, en haut des pages wiki",
"Show category objects" => "Montrer les objets de la catégorie",
"Show, at the bottom of the wiki page, objects in the same category" => "Afficher les objets partageant la même catégorie, en-dessous des pages Wiki",
"Ignore category viewing restrictions" => "Ignorer les restrictions d'affichage sur les catégories",
// "Display items the user may not be entitled to view in search results" => "Display items the user may not be entitled to view in search results",
"Will improve performance, but may show forbidden results" => "Augmente les performances, mais risque d'afficher des résultats non autorisés",
"List pages" => "Liste des pages",
// "Allow viewing the wiki page list" => "Allow viewing the wiki page list",
// "Latest changes" => "Latest changes",
// "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display." => "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display.",
"Orphan pages" => "Pages orphelines",
// "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)" => "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)",
"MySQL full-text search" => "Recherche Full-Text MySQL",
"Referer search highlighting" => "Mise en relief de la chaîne recherchée",
// "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility" => "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility",
"Search statistics" => "Statistiques des recherches",
// "Enables administrators to collect and view statistics on search activity" => "Enables administrators to collect and view statistics on search activity",
"Ignore individual object permissions" => "Ignorer les droits individuels sur les objets",
"Object filter" => "Filtre d'objet",
// "Enables object type filters to be displayed above the search results to further reduce search results by object type" => "Enables object type filters to be displayed above the search results to further reduce search results by object type",
"Search box" => "Boîte de recherche",
// "Shows a search box above the search results to do additional searches" => "Shows a search box above the search results to do additional searches",
// "Include the number of visits in the search results" => "Include the number of visits in the search results",
"Relevance" => "Pertinence",
// "Display Tiki's estimate of the relevance of search matches in the search results" => "Display Tiki's estimate of the relevance of search matches in the search results",
"Object type" => "Type de l'objet",
// "Shows object type filters above the search results to further reduce search results by object type" => "Shows object type filters above the search results to further reduce search results by object type",
"Last-modified date" => "Date de la dernière modification",
// "Show the last-modified date in search results" => "Show the last-modified date in search results",
// "Users can see several charts or rankings about the page" => "Users can see several charts or rankings about the page",
"Custom blog headings" => "En-tête de blog personnalisé",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead",
"Publish dates can be modified" => "Les date de publication peuvent être modifiées",
// "Blog post Comments" => "Blog post Comments",
// "Users can view the “top” or “most” downloaded files" => "Users can view the “top” or “most” downloaded files",
// "File gallery comments" => "File gallery comments",
// "Store user files in a file gallery" => "Store user files in a file gallery",
// "Use the file gallery admin and the individual file gallery settings to manage file storage preferences" => "Use the file gallery admin and the individual file gallery settings to manage file storage preferences",
// "userfiles" => "userfiles",
"Use file galleries for wiki attachments" => "Utiliser les galeries de fichiers pour les fichiers joints wiki",
// "Wiki attachments will be stored in the file gallery" => "Wiki attachments will be stored in the file gallery",
"Batch uploading" => "Téléchargement par lot",
// "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature" => "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature",
"Accept wiki syntax" => "Accepter la syntaxe Wiki",
"Topic archiving" => "Archivage de sujets",
"Quick jumps" => "Liens rapides",
"Replies are empty" => "Les réponses sont vides",
"If disabled, replies will quote the original post" => "Si désactivé, les réponses citeront le message original.",
// "Allows quoting in flat forums" => "Allows quoting in flat forums",
// "Allows users to reply" => "Allows users to reply",
"First post of a thread can have an empty body" => "Le premier message d'un fil de discussion peut avoir un corps vide.",
"Will be a thread title" => "Sera un titre d'un fil de discussion",
"Forum name search" => "Recherche par nom de Forum",
"When listing forums" => "Sur la liste des forums",
"Forum content search" => "Recherche sur le contenu des Forums",
"Topic content search" => "Recherche dans le sujet",
"Tiki-indexed search" => "Recherche indexée de Tiki",
"Use database (full-text) search" => "Utiliser les recherches (full-text) en base de données",
// "Index posts on forum section change" => "Index posts on forum section change",
// "Re-indexes forum posts to match the parent section when the section is changed" => "Re-indexes forum posts to match the parent section when the section is changed",
"Edit CSS" => "Modifier le CSS",
"Edit CSS files directly in the browser" => "Modifier les fichiers CSS directement dans le navigateur",
"May not be functional in Tiki 14+" => "Peut ne pas être fonctionnel dans Tiki 14+",
"Theme Control" => "Contrôle des thèmes",
"Assign different themes to various sections, categories, and objects." => "Assigner différents thèmes à différentes sections, catégories, et objets",
"design themes" => "concevoir des thèmes",
// "Tiki template viewing" => "Tiki template viewing",
"Edit templates" => "Modifier les gabarits",
// "Custom HTML head content" => "Custom HTML head content",
// "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here" => "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here",
// "Add base tag in the HTML head section" => "Add base tag in the HTML head section",
// "The base tag specifies a default address for all links on a page" => "The base tag specifies a default address for all links on a page",
"Site logo and title" => "Titre et logo du site",
"Display a site logo image and/or title in the page header area" => "Afficher un logo du site et/ou un titre de la zone d'en-tête de la page",
"This setting is expected to be moved from here to the admin-modules page" => "Ce paramètre devrait être déplacée d'ici vers la page admin-modules",
"Left column" => "Colonne gauche",
"Controls visibility of the left column of modules" => "Contôle la visibilité de la colonne de modules gauche",
"sidebar" => "Barre latérale",
"Only if one or more modules are assigned" => "Seulement si modules",
"Always" => "Toujours",
"User decides" => "L'utilisateur décide",
"Right column" => "Colonne de droite",
"Controls visibility of the right column of modules" => "Contôle la visibilité de la colonne de modules droite",
"Prefix breadcrumbs with \"Location : \"" => "Prefixer le fil d'ariane avec \"Emplacement : \"",
"Place the term \"Location:\" in the breadcrumbs." => "Placer le mot \"Location:\" dans la file d'ariane.",
"Site location bar" => "Fil d'Ariane du site",
"Use breadcrumbs module" => "Utiliser le module Fil d'ariane",
"Top of center column" => "Haut de la colonne centrale",
"Larger font" => "Police plus large",
"Entire location" => "Tout le fil d'ariane",
"Page name" => "Nom de la page",
"Use page description" => "Utiliser la description de la page",
"Extreme top of page, above the site logo, etc" => "Haut de la page",
"Custom code just before the closing </body> tag" => "Personnaliser le code juste avant de fermer la balise </body>",
// "Enter lines here to be placed near the end of the HTML file" => "Enter lines here to be placed near the end of the HTML file",
"Webmaster report" => "Signaler au webmestre",
"Activate the feature to report a problematic page to the webmaster." => "Activer la fonctionnalité pour signaler d'une page problématique au webmester.",
"Webmaster email" => "Email du webmestre",
"Leave blank to use the default sender email" => "Laisser vide pour utiliser l'émetteur par défaut",
"A specific email address can be set for receiving the webmaster reports" => "Une adresse email spécifique peut être configurée pour recevoir les rapports du webmester",
"Email this page" => "Envoyez cette page par courriel",
"Adds a link at the bottom if set, otherwise adds a link at the top" => "Ajoute un lien en bas si sélectionné, ou en haut sinon.",
"This enables users to share a page with others, by emailing a short message and link to the page" => "Ceci permet aux utilisateurs de partager une page aux autres, en envoyant un court message par mail avec le lien de la page",
"Shadow layer" => "Calque",
"Additional div elements for shadows, radiused corners or other decorative styling" => "Couches additionnelles pour les ombres, les boîtes arrondies ou autre style de décoration",
"Tooltips" => "Info-bulles",
// "Enable tooltips such as this to have a custom appearance, styled by CSS" => "Enable tooltips such as this to have a custom appearance, styled by CSS",
"Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc" => "Fournit différents menus déroulants pour de nombreuses boîtes de saisie de texte pour les noms de page, les noms d'utilisateur, les groupes, les tags, etc.",
"Superfish" => "Superfish",
"Adds animation effects to CSS \"Suckerfish\" menus" => "Ajoute un effect d'animation au menu CSS \"Suckerfish\"",
"Reflection" => "Reflection",
"Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"" => "Crée un reflet sous d'une image. Utilisé dans le Plugiciel Img avec \"class=reflect\" comme paramètre",
"JQuery UI" => "JQuery UI",
"Include jQuery UI library. Enables a number of interface features" => "Inclu la bibliothèque jQuery UI. Active de nombreuses fonctionnalités pour l'interface utilisateur (IU)",
"jQuery UI theme" => "Thème interface utilisateur jQuery",
"jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc" => "Thème jQuery UI. Utilisé dans les feuilles de calcul par exemple",
"Validation" => "Validation",
"Provides various validation possibilities such as for trackers" => "Fournit des possibilités variées de validation comme dans les Formulaires",
// "jQuery infinite carousel" => "jQuery infinite carousel",
// "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel" => "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel",
// "jQuery sortable tables" => "jQuery sortable tables",
// "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables" => "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables",
// "jQuery media" => "jQuery media",
// "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used" => "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used",
// "TagCanvas" => "TagCanvas",
// "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud" => "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud",
// "jQuery zoom" => "jQuery zoom",
// "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"" => "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"",
// "Use tabs" => "Use tabs",
// "Separates page content into tabbed panels" => "Separates page content into tabbed panels",
"Wiki content templates" => "Gabarits de contenu Wiki",
// "Prewritten content (probably partial content) for a wiki page" => "Prewritten content (probably partial content) for a wiki page",
"Warn on edit conflict" => "Avertir en cas de conflit de modification",
"When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages" => "Lorsqu'un utilisateur est en train de modifier une page, le boutton de modification sera coloré en rouge et le nom de l'utilisateur modifiant la page sera affiché comme une info-bulle. Cette fonctionnalité est utile pour prévenir des collisions lors de la modification de pages",
"Undo" => "Annuler",
"Footnotes" => "Notes de bas de page",
"Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages." => "Créer des notes privées pour une page qui ne sont visibles que par l'auteur",
"Allow HTML" => "Permettre le HTML",
"Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "Option par page : les balises HTML sont utilisées pour créer des éléments de la page Wiki, au lieu d'être affiché comme code",
"This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus" => "Ceci est potentiellement dangereux, comme il permet l'ajout du HTML brut. Rassurez-vous d'activer cette option seulement si les utilisateurs approuvés peuvent créer et modifier des menus",
"Log bytes changes (+/-) in action logs" => "Journaliser les changements d'octets (+/-) dans le journal des actions",
"May impact performance" => "Peut impacter les performances",
"Sandbox" => "Bac à sable",
// "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved" => "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved",
"Comments below wiki pages" => "Commentaires en bas des pages wiki",
"Allow users to upload images to a page" => "Autoriser les utilisateurs à télécharger des images (photos) vers une page",
"Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)" => "Les utilisateurs peuvent exporter des pages individuelles et structurer le contenu de pages comme un fichier (nécessite la permission tiki_p_admin_wiki)",
"WikiWords" => "Mots Wiki",
// "Automatically convert \\\"CamelCase\\\" words into wiki links" => "Automatically convert \\\"CamelCase\\\" words into wiki links",
"Link plural WikiWords to their singular forms" => "Lier les pluriels des MotWikis à leur singulier",
"Accept dashes and underscores in WikiWords" => "Accepter les tirets et les tirets bas (underscores) dans les mots Wiki",
"History" => "Historique",
// "Users (with permission) can see the history of each wiki page" => "Users (with permission) can see the history of each wiki page",
"Display IP address" => "Afficher l'adresse IP",
"Wiki full history" => "Historique complète de la page wiki",
"Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Enregistrer toutes les versions, plutôt que seulement quand le contenu de la page change ou sa description ou quand un commentaire d'édition est donné",
"View page contributions by author" => "Voir les contributions aux pages par auteur",
"Visualize the contributions that different authors have made to a wiki page" => "Visualiser les contributions de différents auteurs à une page wiki",
"Discuss pages on forums" => "Discuter les pages dans un forum",
// "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page" => "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page",
"View source" => "Voir fichier source",
// "Users (with permission) can see the wiki and/or HTML syntax of the page" => "Users (with permission) can see the wiki and/or HTML syntax of the page",
// "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”" => "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”",
// "Present a list of pages that link to the current page" => "Present a list of pages that link to the current page",
"Similar pages" => "Pages similaires",
// "Display a list of pages named similarly to the current page" => "Display a list of pages named similarly to the current page",
"Structures" => "Structures",
// "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document" => "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document",
// "Structures drill down menu" => "Structures drill down menu",
// "Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down" => "Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down",
"Open page as structure" => "Ouvrir une page en tant que structure",
// "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL" => "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL",
"Make structure from page" => "Créer une structure avec la page",
// "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure" => "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure",
"Categorize structure pages together" => "Catégoriser les structures de pages ensemble",
// "Place new pages of a structure in the same category as the structure's root page" => "Place new pages of a structure in the same category as the structure's root page",
// "Disable inherited direct object permissions" => "Disable inherited direct object permissions",
// "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure" => "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure",
"Create webhelp from structure" => "Créer l'aide web à partir d'une structure",
// "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format" => "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format",
"Import HTML" => "Importer du HTML",
// "Enable import of HTML pages" => "Enable import of HTML pages",
"Use date parameter" => "Utiliser le paramètre date",
// "Allow wiki page version to be selected from a parameter \"date\" on the url" => "Allow wiki page version to be selected from a parameter \"date\" on the url",
"Report it in wiki links" => "Le retranscrire dans les liens Wiki",
// "Add the date parameter to wiki links" => "Add the date parameter to wiki links",
"Import pages" => "Import de pages",
"A personal wiki page for each user" => "Une page personnelle que l'utilisateur doit gérer",
"Userpage prefix" => "Préfixe de la page utilisateur",
"All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required" => "Toutes les pages utilisateurs partagent un préfixe commun. La concaténation du préfixe et du nom de l'utilisateur générera le nom de la page. Le préfixe ne peut pas être vide",
"Users can lock pages" => "Les utilisateurs peuvent verrouiller les pages",
// "Enable users to lock pages and so prevent others from editing them" => "Enable users to lock pages and so prevent others from editing them",
"MultiPrint" => "Multi-impression",
// "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document" => "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document",
// "Print Wiki" => "Print Wiki",
// "Provide a print icon and layout of the wiki page formatted for printing" => "Provide a print icon and layout of the wiki page formatted for printing",
"Pages not in structure" => "Pages qui ne sont pas dans une structure",
// "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display" => "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display",
"Attachments" => "Fichiers joints",
"Allow users to upload (attach) files to a page" => "Autoriser les utilisateurs de rattacher des fichiers aux pages",
// "Limit wiki page categories to those under this category" => "Limit wiki page categories to those under this category",
"If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"" => "Si vous obtenez un message d'erreur signalant qu'une catégorie est obligatoirement requise pour éditer une page wiki, c'est cette option qui est à blâmer. La définir à 'None'",
// "Show/hide icon before headings" => "Show/hide icon before headings",
// "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below" => "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below",
"Wiki argument variables" => "Variables Wiki en argument",
"Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Permet d'écrire des variables requises dans un contenu wiki en utilisant {{paramname}} ou {{paramname|default}} - cas spécial {{page}} {{user}}",
"Users can choose to stay in SSL mode after an HTTPS login" => "Les utilisateurs peuvent choisir de rester en mode SSL après un login HTTPS",
"Users can switch between secured or standard mode at login" => "Les utilisateurs peuvent commuter entre le mode standard et le mode sécurisé au login",
"Wiki paragraph formatting" => "Mise en forme des paragraphes dans le Wiki",
"Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Puisque la fonction de formatage des paragraphes est activé, tous les groupes de lignes avec du texte sont rassemblées au sein de paragraphes. Les lignes, qui peuvent être de tailles indifférentes, sont agrégées avec les lignes suivantes. Les paragraphes sont séparés par des lignes blanches.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Puisque la fonction de formatage des paragraphes est désactivée, chaque ligne sera présentée comme vous la saisissez. Cela signifie que si vous voulez que les paragraphes soient présentés convenablement, vous devez saisir tout le paragraphe consécutivement.",
// "Create line breaks within paragraphs" => "Create line breaks within paragraphs",
// "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs" => "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs",
"Automonospaced text" => "Texte à espacement constant",
// "Lines indented with spaces will automatically be converted to monospace font" => "Lines indented with spaces will automatically be converted to monospace font",
"Tables syntax" => "Syntaxe des tables",
"|| for rows" => "|| pour les rangées",
"<return> for rows" => "<Entrée> pour les rangées",
"AutoLinks" => "Liens automatiques",
"Web (http://) and email addresses will automatically be converted to links" => "Tiki convertira automatiquement 'http://...' et les adresses courriel en des liens",
"Hotwords" => "Mot/liens automatiques",
"Open hotwords in new window" => "Ouvrir les mots/liens automatique dans une nouvelle fenêtre",
// "Characters that limit a hotword" => "Characters that limit a hotword",
"Use Quote plugin rather than \">\" for quoting" => "Utiliser le plugiciel Quote plutôt que \">\" pour citer",
// "Center text using ::: instead of :" => "Center text using ::: instead of :",
// "Useful to avoid conflicts with C++ scope operators or default namespace separator" => "Useful to avoid conflicts with C++ scope operators or default namespace separator",
// "String to use to delimit simplebox" => "String to use to delimit simplebox",
"Users can choose to show their gender" => "Les utilisateurs peuvent choisir d'afficher leur genre",
"Real name" => "Nom réel",
"Gender" => "Sexe",
// "Profile picture (avatar)" => "Profile picture (avatar)",
"Country" => "Pays",
"Last login" => "Dernière connexion",
"Distance" => "Distance",
"Manual selection of time/date" => "Sélection manuelle de la date et de l'heure",
"WebDAV access to Tiki" => "Accès à Tiki via WebDAV",
"Allow file gallery access with WebDAV" => "Permet l'accès aux galeries de fichiers par WebDAV",
"use tiki-webdav.php as the URI of the WebDAV repository" => "utilise tiki-webdav.php tel que l'URL du référentiel WebDAV",
"Fixed width" => "Largeur fixe",
"Restrict the width of the site content area, in contrast to a liquid (full-width) layout" => "Contraint la largeur du site",
"Social networks" => "Réseaux sociaux",
"Integration with social applications and networks like Twitter and Facebook" => "Intégration de réseaux sociaux comme Twitter ou Facebook",
// "Group transition" => "Group transition",
"Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Active la transition entre différents groupes des utilisateurs. Ces transitions constituent un « workflow » d'approbation pour les utilisateurs",
// "Category transition" => "Category transition",
"Enables transitions for objects between different categories. Transitions will create a document workflow" => "Active la transition d'objets entre différentes catégories. Ces transistion consituent un « workflow » de document",
// "Tiki user credits" => "Tiki user credits",
"Invite users" => "Inviter des utilisateurs",
"Allow users to invite new users to register at this site, by sending an email." => "Autoriser les utilisateurs à inviter de nouveaux utilisateurs par mail pour s'inscrire sur ce site",
// "Alternate registration page" => "Alternate registration page",
// "Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page" => "Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page",
"Load balancer" => "Équilibreur de charge",
"Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server" => "Activer cette option seulement si le serveur est derrière un équilibreur de charge (ou reverse proxy), cela permet de logguer dans tiki l'adresse IP de l'utilisateur, au lieu de l'adresse IP du serveur proxy",
// "Tiki is behind a frontend-proxy/load-balancer that rewrites ports" => "Tiki is behind a frontend-proxy/load-balancer that rewrites ports",
// "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links" => "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links",
"Accounting" => "Comptabilité",
"Double-entry accounting system" => "Système de comptabilité à partie double",
// "Code editor (CodeMirror)" => "Code editor (CodeMirror)",
// "CodeMirror code editor, which provides syntax highlighting" => "CodeMirror code editor, which provides syntax highlighting",
// "Syntax highlighter (CodeMirror) Theme" => "Syntax highlighter (CodeMirror) Theme",
// "CodeMirror themes (clear cache after changing)" => "CodeMirror themes (clear cache after changing)",
"default" => "défaut",
// "Off (but switchable)" => "Off (but switchable)",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference. HTML may be used" => "This is useful for developers to learn how to create a new preference. HTML may be used",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint. Wiki syntax may be used" => "This is the hint. Wiki syntax may be used",
// "This is the shorthint. Wiki syntax may be used" => "This is the shorthint. Wiki syntax may be used",
// "Time sheet" => "Time sheet",
"A project time manager" => "Un gestionnaire de temps de projet",
// "This feature will be removed after Tiki18 and before Tiki19" => "This feature will be removed after Tiki18 and before Tiki19",
// "HTML feed" => "HTML feed",
"A way to transfer HTML content from one Tiki site to another" => "Un moyen pour pousser et tirer des extraits html depuis un site vers un autre",
// "Send an email notification to group leaders when a user joins" => "Send an email notification to group leaders when a user joins",
// "Send an email notification to group leaders when a user leaves" => "Send an email notification to group leaders when a user leaves",
// "Inline comments" => "Inline comments",
// "Contextual comments" => "Contextual comments",
// "Enable JavaScript plugin for equal-height rows" => "Enable JavaScript plugin for equal-height rows",
// "Enable responsive rows, the contained elements of which have the same height" => "Enable responsive rows, the contained elements of which have the same height",
// "Conditional formatting" => "Conditional formatting",
// "Use different coloring for certain system objects. Only groups are supported for now" => "Use different coloring for certain system objects. Only groups are supported for now",
// "Store session variable for current theme" => "Store session variable for current theme",
// "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing" => "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing",
// "Parent category of theme control categories" => "Parent category of theme control categories",
// "Choose the parent category of categories used for theme control" => "Choose the parent category of categories used for theme control",
// "Automatically select the theme-control category of the current theme when categorizing" => "Automatically select the theme-control category of the current theme when categorizing",
// "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme" => "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme",
// "Certain pages redirect to homepage when language is changed" => "Certain pages redirect to homepage when language is changed",
// "List of pages that redirect" => "List of pages that redirect",
// "List of names of pages that always redirect to the homepage when the language is switched" => "List of names of pages that always redirect to the homepage when the language is switched",
// "Separate page names by commas" => "Separate page names by commas",
// "User wizard" => "User wizard",
// "Wizard to help users set up their basic settings and account details" => "Wizard to help users set up their basic settings and account details",
// "Present different input fields in the User Wizard than are in the Registration form" => "Present different input fields in the User Wizard than are in the Registration form",
// "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form" => "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form",
// "Tracker fields presented in the User Wizard as User Details" => "Tracker fields presented in the User Wizard as User Details",
// "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)" => "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)",
// "Enable Typography Features" => "Enable Typography Features",
// "Features to replace normal characters with typographic equivalents" => "Features to replace normal characters with typographic equivalents",
"Smart “curly” quotes" => "Guillemets “courbes” intelligents",
"Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes" => "Convertit les guillemets \\\"droits\\\" en guillements “courbes”, converti aussi l’apostrophe et les guillements ‘simples’",
"Convert approximative ASCII quotes" => "Conversion des guillements ASCII",
// "Convert plain-ASCII quote substitutes `` '\\" => "Convert plain-ASCII quote substitutes `` '\\",
"Smart em-dash and ellipsis" => "Tiret et points de suspension intelligents",
"Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…" => "Converti le double trait-d'union \\-- en tiret long — ainsi que trois points consécutifs\\... en caractère typographique de points de suspension…",
"Smart no-break space" => "Espace insécable intelligent",
"Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it." => "Empêche les sauts de lignes à des endroits innapropriés en remplaçant le certains espaces par des espaces insécables à certains endroits : autour de certains signes de ponctuation, lorsqu'utilisé comme sépartateur de millier, ainsi qu'entre une abbréviation unité et la valeur numérique qui la précède.",
// "Display only select calendars by default" => "Display only select calendars by default",
// "Master Tiki server" => "Master Tiki server",
// "Master Tiki server that this client will obtain user authorizations from" => "Master Tiki server that this client will obtain user authorizations from",
// "Overrides manually registered local users" => "Overrides manually registered local users",
"Import user preferences" => "Importer des préférences utilisateur",
// "Client Tiki will copy the user preferences from the master server" => "Client Tiki will copy the user preferences from the master server",
// "This will overwrite local user preferences every time the user logs in" => "This will overwrite local user preferences every time the user logs in",
"Import user groups" => "Importer des groupes d'utilisateurs",
// "Groups the user belongs to on the master server will be imported (along with their security definitions)" => "Groups the user belongs to on the master server will be imported (along with their security definitions)",
// "This will overwrite local groups every time a user logs in" => "This will overwrite local groups every time a user logs in",
// "Limit group import" => "Limit group import",
// "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation" => "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation",
// "This list will limit the group import feature to only those groups listed here" => "This list will limit the group import feature to only those groups listed here",
// "Intertiki shared cookie" => "Intertiki shared cookie",
// "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites" => "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites",
// "This site is a master server" => "This site is a master server",
"Scheduler" => "Planificateur",
// "Provides the ability to run tasks at a scheduled time" => "Provides the ability to run tasks at a scheduled time",
// "Convert from absolute to relative link" => "Convert from absolute to relative link",
// "Process wiki text and convert internal links from absolute to relative links" => "Process wiki text and convert internal links from absolute to relative links",
// "It's recommended to set a cron job to periodically rebuild the search index" => "It's recommended to set a cron job to periodically rebuild the search index",
"HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "Purificateur HTML est une bibliothèque de filtrage HTML conforme aux normes écrite en PHP et intégrée à Tiki. Le purificateur ne se contentera pas de supprimer tout code pernicieux (plus connu sous le nom de XSS) au moyen d'une liste blanche minutieusement vérifiée, sûre mais aussi tolérante, il vérifiera aussi que vos documents  sont conformes aux normes, opération réalisable seulement grâce à une connaissance exhaustive des spécifications W3C",
"Show user's contribution on the user information page" => "Afficher les contributions de l'utilisateur sur sa page d'information",
// "View user's contribution on the user information page" => "View user's contribution on the user information page",
// "Users' drawings are stored in their user files gallery" => "Users' drawings are stored in their user files gallery",
"Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index" => "nofollow est utilisé pour informer certains moteurs de recherche que les liens ne devrait pas influencer la recherche. Il peut ainsi réduire le spam des moteurs de recherche et empêcher « spamdexing »",
// "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised" => "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised",
// "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated" => "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated",
// "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6" => "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6",
"Require file creator's name for anonymous uploads" => "Nécessite le nom de l'auteur pour les téléchargements en anonyme",
"Redirect to similar wiki page" => "Redirection vers une page wiki similaire",
"If a requested page doesn't exist, redirect to a similarly named page" => "Lors de l'édition d'une page, rediriger vers une page de nom similaire si celle-ci n'existe pas",
// "Redirect to page alias, if any" => "Redirect to page alias, if any",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
"User's information page" => "Page de l'utilisateur",
// "Display a user's gender if permitted by the user" => "Display a user's gender if permitted by the user",
// "Allow showing user's information on mouseover" => "Allow showing user's information on mouseover",
// "Show users' information on mouseover" => "Show users' information on mouseover",
"Requires user's information to be public" => "Nécessite que les informations de l'utilisateur soient publiques",
// "Show the user's real name" => "Show the user's real name",
// "Federated search" => "Federated search",
// "Search through alternate site indices" => "Search through alternate site indices",
// "Elasticsearch is required" => "Elasticsearch is required",
// "Elasticsearch tribe node URL" => "Elasticsearch tribe node URL",
// "URL of the tribe client node accessing multiple clusters" => "URL of the tribe client node accessing multiple clusters",
"Default feed format" => "Format par défaut du flux",
"ATOM 1.0" => "ATOM 1.0",
"RSS 2.0" => "RSS 2.0",
"Feed author name" => "Nom de l'auteur du flux",
// "Default author of each item in the feed" => "Default author of each item in the feed",
"This field is mandatory unless both feed author email and homepage are empty" => "Ce champ est obligatoire sauf si l'email de l'auteur du flux et sa page d'accueil sont vides tous les deux",
"Feed author email" => "Email de l'auteur du flux",
// "Email of the author of each item in the feed" => "Email of the author of each item in the feed",
"Feed author homepage" => "Page d'accueil de l'auteur du flux",
// "Homepage URL of the author of each item in the feed" => "Homepage URL of the author of each item in the feed",
"Feed editor email" => "Email de l'éditeur du flux",
"Email address for person responsible for editorial content" => "Adresse mail de la personne responsable du contenu rédactionnel",
"Feed webmaster email" => "Email du webmestre du flux",
"Email address for person responsible for technical issues relating to channel" => "Adresse courriel de la personne responsable des problèmes techniques en relation avec cette chaîne",
// "Feed image path" => "Feed image path",
"Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Spécifie un fichier GIF, JPEG ou PNG qui peut être affiché avec le « feed »",
// "Feed language" => "Feed language",
// "The default language for this feed" => "The default language for this feed",
// "RSS basic authentication" => "RSS basic authentication",
"Propose basic HTTP authentication if the user has no permission to see the feed" => "Proposer une authentification http de base si l'utilisateur n'a pas le droit de voir ce flux",
// "Feed caching time" => "Feed caching time",
// "Cache the feed for this number of seconds" => "Cache the feed for this number of seconds",
"Use 0 for no caching" => "Utiliser 0 pour ne pas utiliser le cache",
// "Feed caching is done for anonymous users only" => "Feed caching is done for anonymous users only",
"RSS for articles" => "RSS pour les articles",
"RSS feeds for articles" => "Flux RSS pour les articles",
"RSS for blogs" => "RSS pour les blogues",
"RSS feeds for blogs" => "Flux RSS pour les blogues",
"RSS for individual blogs" => "RSS pour blogues individuels",
"RSS feeds for individual blogs" => "Flux RSS pour les blogues individuels",
"RSS for image galleries" => "RSS pour les galeries d'images",
"RSS feed for image galleries" => "Flus RSS pour les galeries d'images",
"RSS for individual image galleries" => "RSS pour les galeries d'images individuelles",
"RSS feeds for individual image galleries" => "Flux RSS pour les galeries d'images individuelles",
"RSS for file galleries" => "RSS pour les galeries de fichiers",
"RSS feed for file galleries" => "Flux RSS pour les galeries de fichiers",
"RSS for individual file galleries" => "RSS pour les galeries de fichiers individuelles",
"RSS feeds for individual file galleries" => "Flux RSS pour les galeries de fichiers individuelles",
"RSS for wiki pages" => "RSS les pages wiki",
"RSS feed for wiki pages" => "Flux RSS pour le Wiki",
"RSS for forums" => "RSS pour les forums",
"RSS feed for forums" => "Flux RSS pour les forums",
"RSS for individual forums" => "RSS pour les forums individuels",
"RSS feeds for individual forums" => "Flux RSS pour les forums individuels",
"RSS per tracker" => "RSS par formulaire",
"RSS feed per tracker" => "Flux RSS par formulaire",
"RSS for calendar events" => "RSS pour les événements de calendrier",
"RSS feed for calendar events" => "Flux RSS pour les évènements du calendrier",
"RSS for directories" => "RSS for pour les annuaires",
"RSS feed for directories" => "Flux RSS pour les annuaires",
"RSS for shoutbox" => "RSS pour le mégaphone",
"RSS feed for shoutbox" => "Flux RSS pour le mégaphone",
"Maximum number of items to display" => "Nombre maximum d'éléments à afficher",
// "items" => "items",
"Show author" => "Afficher l'auteur",
"Homepage URL" => "URL de la page d'accueil",
"Tiki RSS feed for articles" => "Canal de syndication RSS Tiki pour les articles",
"Tiki RSS feed for blogs" => "Canal de syndication RSS Tiki pour les blogues",
"Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Titre à placer avant le titre du blog pour tous les blogs. Si ce champ est vide seul le titre du blog sera utilisé",
"Tiki RSS feed for image galleries" => "Canal de syndication RSS Tiki pour les galeries d'images",
"Tiki RSS feed for the image gallery: " => "Canal de syndication RSS Tiki pour la galerie d'images : ",
"Tiki RSS feed for file galleries" => "Canal de syndication RSS Tiki pour les galeries de fichiers",
"Tiki RSS feed for the file gallery: " => "Canal de syndication RSS Tiki pour la galerie de fichiers : ",
"Tiki RSS feed for the wiki pages" => "Canal de syndication RSS Tiki pour les pages Wiki",
"Tiki RSS feed for forums" => "Canal de syndication RSS Tiki pour les forums",
"Tiki RSS feed for forum: " => "Canal de syndication RSS Tiki pour le forum : ",
"Tiki RSS feed for individual trackers: " => "Canaux de syndication RSS Tiki pour les formulaires individuels: ",
"Tiki RSS feed for calendars" => "Canaux de syndication RSS Tiki pour les calendriers",
"Tiki RSS feed for directory sites" => "Canal de syndication RSS Tiki pour les sites des répertoires",
"Tiki RSS feed for shoutbox messages" => "Flux RSS Tiki pour les messages du mégaphone",
"Article RSS description" => "Description des RSS des articles",
"Description to be published as part of the RSS feed for articles" => "Description à publier dans le flux RSS des articles",
"Last articles." => "Derniers articles.",
"Blogs RSS description" => "Description de RSS de blogues",
"Description to be published as part of the RSS feed for blogs" => "Description à publier dans le flux RSS des blogues",
"Last posts to weblogs." => "Derniers articles des blogues.",
"Blog RSS Description" => "Description de RSS de blogue",
"Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used" => "Description qui préfixera la description du blogue et sera publiée comem faisant partie du flux RSS pour les blogues individuels. Si ce champ est vide, seule la description du blogue sera utilisée",
"Image galleries RSS description" => "Description du flux RSS des galeries d'images",
"Description to be published as part of the RSS feed for image galleries" => "Description à publier dans le flux RSS des galeries d'images",
"Latest images uploaded to the image galleries." => "Dernières images envoyées dans les galeries d'images.",
"Individual image galleries RSS Description" => "Description des flux RSS individuels pour les galeries d'images",
"Description to be published as part of the RSS feeds for individual image galleries" => "Description à publier dans le flux RSS individuel des galeries d'images",
"Latest images uploaded to this image gallery." => "Dernières images déposées dans cette galerie d'images. ",
"File galleries RSS description" => "Description du flux RSS des galeries de fichiers",
"Description to be published as part of the RSS feed for file galleries" => "Description à publier dans le flux RSS individuel des galeries de fichiers",
"Latest files uploaded to the file galleries." => "Derniers fichiers envoyés dans les galeries de fichiers.",
"Individual file galleries RSS description" => "Description individuelle des flux RSS des galeries de fichiers",
"Description to be published as part of the RSS feeds for individual file galleries" => "Description à publier dans le flux RSS individuel des galeries de fichiers",
"Latest files uploaded to this file gallery." => "Derniers fichiers déposés dans cette galerie de fichiers. ",
"Wiki pages RSS description" => "Description du flux RSS des pages wiki",
"Description to be published as part of the RSS feed for wiki pages pages" => "Description à publier dans le flux RSS des pages wiki",
"Latest wiki page changes." => "Dernières pages Wiki modifiées.",
"Forums RSS description" => "Description des flux RSS des forums",
"Description to be published as part of the RSS feed for forums" => "Description à publier dans le flux RSS des forums",
"Latest forum topics." => "Derniers sujets des forums.",
"Individual forums RSS description" => "Description individuelle des flux RSS des forums",
"Description to be published as part of the RSS feeds for individual forums" => "Description à publier dans le flux RSS des forums",
"Latest posts to this form" => "Derniers messages de ce forum. ",
"Individual trackers RSS description" => "Description des flux RSS des formulaires individuels",
"Description to be published as part of the RSS feed for individual trackers" => "Description à publier en tant que partie du flux RSS pour les formulaires individuels",
"Latest additions to this tracker" => "Derniers éléments publiés dans ce formulaire",
"Calendar events RSS description" => "Description flux RSS des événements du calendrier",
"Description to be published as part of the RSS feed for calendar events" => "Description à publier en tant que partie du flux RSS pour les événements du calendrier",
"Upcoming Events." => "Évènements à venir.",
"Directories RSS description" => "Description du flux RSS des annuaires",
"Description to be published as part of the RSS feed for directories" => "Description à publier en tant que partie du flux RSS pour les annuaires",
"Latest sites." => "Derniers sites.",
"Shoutbox RSS description" => "Description du flux RSS du mégaphone",
"Description to be published as part of the RSS feed for shoutbox messages" => "Description à publier en tant que partie du flux RSS pour les messages du mégaphone",
"Latest shoutbox messages" => "Derniers messages du mégaphone",
// "Tracker labels" => "Tracker labels",
// "Include tracker field labels in the RSS output" => "Include tracker field labels in the RSS output",
"Page" => "Page",
// "Finder view" => "Finder view",
"Show as a column" => "Afficher en tant que colonne",
"Show in popup box" => "Montrer dans une popup",
"Both" => "Les deux",
"Podcast directory" => "Répertoire des Podcasts",
// "File system directory for storing podcast files" => "File system directory for storing podcast files",
"The server must be able to read/write the directory." => "Le serveur web doit avoir les droits en lecture écriture sur le répertoire.",
"Required for podcasts" => "Nécessaire pour les podcasts",
"To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc" => "Si vous autorisez le téléchargement par lots, il vous faudra définir un répertoire accessible en lecture depuis le web (en-dehors de votre espace web serait mieux). Ensuite, prévoir un moyen pour télécharger des fichiers vers ce répertoire (par scp, ftp ou d'autres protocoles)",
"The server must be able to read the directory." => "Le serveur web doit avoir les droits en lecture sur le répertoire.",
"The directory can be outside the web space." => "Le répertoire peut être en-dehors de l'espace web",
"Prevent download if score becomes negative" => "Empêcher téléchargement si le score devient négatif",
// "If using Tiki Score system, users with a negative score cannot download files" => "If using Tiki Score system, users with a negative score cannot download files",
"Allow download limit per file" => "Autoriser la restriction du nombre de téléchargements par fichier",
// "Allow file duplicates" => "Allow file duplicates",
"Allow the same file to be uploaded more than once" => "Permettre à un même fichier d'être envoyé plusieurs fois",
"Yes, even in the same gallery" => "Oui, même dans la même galerie",
"Only in different galleries" => "Seulement dans des galeries différentes",
"Display ZIP option in gallery" => "Afficher l'option zip dans les galeries",
"Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery." => "Afficher dans la galerie l'option zip (en téléchargement de fichier et galerie)",
"Must match" => "Doit correspondre à",
// "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)" => "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)",
"Cannot match" => "Ne doit pas correspondre à",
// "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted" => "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted",
"Quota for all files and archives" => "Quota pour les fichiers et les archives",
// "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)" => "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)",
"0 for unlimited" => "0 pour un nombre illimité",
// "megabytes" => "megabytes",
"Quota for each file gallery" => "Les quotas peuvent être définis pour chaque fichier dans la galerie",
// "A different quota can be defined for each file gallery" => "A different quota can be defined for each file gallery",
"Default quota for each new gallery" => "Quota par défaut pour les nouvelles galeries",
"Show quota bar in the list page" => "Afficher la barre de quota dans la page de liste",
"Yes, display bar and detail text" => "Oui, afficher la barre et le texte détaillé",
"Yes, display only bar" => "Oui, afficher seulement la barre",
"Yes, display only text" => "Oui, afficher seulement le texte",
"Storage" => "Stockage",
// "Specify if uploaded files should be stored in the database or file directory" => "Specify if uploaded files should be stored in the database or file directory",
"Store in database" => "Stocker en base de données",
"Store in directory" => "Stocker dans un répertoire sur le disque",
// "Path to the directory to store file gallery files" => "Path to the directory to store file gallery files",
// "Searchable file gallery content" => "Searchable file gallery content",
"Include the search form on the current gallery page just after \"Find\"" => "Inclure la boîte de recherche sur la galerie courante juste après la div de recherche",
"Include a search form in file galleries" => "Inclure un boîte de recherche dans les galeries de fichiers",
// "Display hits ratio to maximum" => "Display hits ratio to maximum",
"Display hits with a ratio of hits to maximum hits" => "Afficher le nombre d'affichages avec un ratio entre le nombre et le maximum atteint",
"Display properties in the context menu" => "Afficher les propriétés dans le menu contextuel",
"Display \"Replace\" in the context menu" => "Afficher le menu remplacer dans le menu contextuel",
"Automatic deletion of old files" => "Suppression automatique des anciens fichiers",
"The user will have an option when uploading a file to specify the time after which the file is deleted" => "Lors du téléchargement, l'utilisateur aura une option pour spécifier la date à partir de laquelle le fichier sera supprimé",
"A cron job must be set up in order to delete the files" => "Un job Cron doit être programmé en vue d'effacer les fichiers",
"Allow action on multiple files or galleries" => "Autoriser une action sur de multiples fichiers ou galeries",
"Include \"Remove\" as an option for the checkbox action in file galleries" => "Le bouton de contrôle sur la galerie de fichier peut être retiré",
"Deletion emails notification" => "Notification de la suppression d'e-mails",
"Email addresses (comma-separated) to receive a copy of each deleted file" => "Ces boîtes de courriel recevront une copie de chaque fichier supprimé. Les adresses sont séparées par des virgules",
"Keep the same fileId for the latest version of a file" => "Garder le même Id de fichier pour la dernière version du fichier",
"If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file" => "Si activé, l'Id restera identique avec la dernière version. Un lien vers ce fichier fournira toujours la version la plus à jour. Si désactivé, l'Id sera associé à un fichier pour toujours, un lien vers ce fichier restera toujours lié à cette version",
"Show thumbnail actions" => "Montrer les actions pour vignette",
"Show the checkbox and wrench icon for file actions menu when not displaying details" => "Montrer la case à cocher et l'icône clé pour les actions sur un fichier en l'absence d'affichage des détails",
"Maximum thumbnail size" => "Taille maximum de vignette",
"Maximum width or height for image thumbnails" => "Largeur ou hauteur maximum pour les vignettes d'image",
"Automatic indexing of file content" => "Indexer automatiquement le contenu des fichiers",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Asynchronous indexing" => "Asynchronous indexing",
"Upload files from remote source" => "Envoyer des fichiers à partir d'une source distante",
"Enable copying files to file galleries from a URL that will be polled for new revisions" => "Permettre de créer des fichiers dans les galeries de fichiers en utilisant une URL qui sera interrogée pour les nouvelles révisions",
"Remote source refresh frequency limit" => "Limite de fréquence de rafraîchissement de la source distante",
// "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests" => "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests",
// "Set to zero to disable refresh" => "Set to zero to disable refresh",
// "Display controls to attempt a file refresh" => "Display controls to attempt a file refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
"Allow searching for existing files in the tracker files field" => "Permettre de rechercher des fichiers existants dans les champs fichier des formulaires",
"Search files using the search index" => "Rechercher des fichiers en utilisant l'index de recherche",
// "Set MIME type based on file suffix" => "Set MIME type based on file suffix",
// "Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream" => "Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream",
// "Clean XML Always" => "Clean XML Always",
// "Sanitize XML based files such as SVG for all users" => "Sanitize XML based files such as SVG for all users",
// "Allow SVG file upload" => "Allow SVG file upload",
// "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files." => "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files.",
// "Maximum name length" => "Maximum name length",
// "Length to which to truncate file names in browse view" => "Length to which to truncate file names in browse view",
// "Maximum width of images" => "Maximum width of images",
// "Default maximum width of images in galleries" => "Default maximum width of images in galleries",
// "Maximum height of images" => "Maximum height of images",
// "Default maximum height of images in galleries" => "Default maximum height of images in galleries",
// "Use elFinder UI" => "Use elFinder UI",
// "Alternative file manager with drag and drop capability" => "Alternative file manager with drag and drop capability",
// "Use Viewer JS" => "Use Viewer JS",
// "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages" => "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages",
// "Viewer JS URI" => "Viewer JS URI",
// "Where ViewerJS is installed" => "Where ViewerJS is installed",
// "Use PDF.js" => "Use PDF.js",
// "Uses PDF.js to display PDF files in web pages" => "Uses PDF.js to display PDF files in web pages",
// "Default view" => "Default view",
// "Default sort field" => "Default sort field",
"Last modification date" => "Date de dernière modification",
"Owner" => "Propriétaire",
"Default sort direction" => "Sens de tri par défaut",
"Descending" => "Décroissant",
"Ascending" => "Ascendant",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
// "Show explorer" => "Show explorer",
// "Show path" => "Show path",
// "Show slideshow" => "Show slideshow",
"Name-filename" => "Nom-Nom du fichier",
"Filename only" => "Nom du fichier uniquement",
// "Created / Uploaded" => "Created / Uploaded",
// "Show icon in column" => "Show icon in column",
// "OCR Files" => "OCR Files",
// "Extract and index text from supported file types" => "Extract and index text from supported file types",
// "OCR Every File" => "OCR Every File",
// "Attempt to OCR every supported file" => "Attempt to OCR every supported file",
// "View or export office documents as PDF" => "View or export office documents as PDF",
// "If enabled allows to view documents without download or to export documents as PDF files" => "If enabled allows to view documents without download or to export documents as PDF files",
// "Maximum width of file preview in pixels" => "Maximum width of file preview in pixels",
// "The maximum value of width in pixels for the files preview in the popover" => "The maximum value of width in pixels for the files preview in the popover",
// "Export diagram image on save" => "Export diagram image on save",
// "If enabled, diagrams will be cached in PNG format when saved or edited" => "If enabled, diagrams will be cached in PNG format when saved or edited",
// "Use draw.io public services to export images" => "Use draw.io public services to export images",
// "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback" => "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback",
// "Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory" => "Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory",
// "Use jQuery upload" => "Use jQuery upload",
// "Use the improved Tiki 15+ upload page" => "Use the improved Tiki 15+ upload page",
// "Redirect to file gallery" => "Redirect to file gallery",
// "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery" => "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery",
// "Revision approval" => "Revision approval",
"Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges" => "Utilise des versions avec drapeaux pour cacher les versions non approuvées aux utilisateurs ayant moins de privilèges",
// "Revision approval categories" => "Revision approval categories",
"List of category IDs for which revision approval is required" => "Liste des IDs de catégories pour lesquelles une approbation de révision est requise",
"Footer shadow div start" => "Calque du pied de page - Début",
"Footer shadow div end" => "Calque du pied de page - Fin",
// "Forum image file gallery" => "Forum image file gallery",
// "File gallery used to store images for forums" => "File gallery used to store images for forums",
"Uploaded filenames must match regex" => "Les noms de fichiers envoyés doivent correspondre aux expressions régulières",
"Manage thread defaults per-forum" => "Gestion des réglages par défaut des fils de discussion par forum",
"Display thread configuration bar" => "Afficher la barre de configuration du fil de discussion",
"Allows users to override the defaults" => "Autoriser les utilisateurs à outrepasser les valeurs par défauts",
"Display the thread configuration bar only when the number of posts exceeds" => "Afficher la barre de configuration du fil de discussion seulement si le nombre de message est excessif",
"posts" => "Articles",
"Keep settings for all forums during the user session" => "Conserver les paramètres de tous les forums pendant la session de l'utilisateur",
"Default style" => "Style par défaut",
"Threaded" => "Emboîté",
"Headers only" => "En-têtes seulement",
"Default sort mode" => "Mode de tri par défaut",
"Title (desc)" => "Titre (desc)",
"Title (asc)" => "Titre (asc)",
"Topics" => "Sujets",
"Posts per day" => "Publications par jour",
"Last post" => "Dernière publication",
// "Description length" => "Description length",
"Require reply to have a title" => "Exiger un titre dans la réponse",
"Present an empty title input form and require it to be filled in before the forum post is submitted" => "Affiche une boîte de titre (vide) et exige qu'un titre soit saisi avant la soumission de la publication sur le forum",
// "Prevent Nesting of Quote wikiplugins when replying" => "Prevent Nesting of Quote wikiplugins when replying",
// "Strips quote plugin in reply in order to prevent nesting of quote plugins" => "Strips quote plugin in reply in order to prevent nesting of quote plugins",
// "Forum post categories" => "Forum post categories",
// "Categories available in the category picker for forum posts" => "Categories available in the category picker for forum posts",
// "Include category selector in forum list" => "Include category selector in forum list",
// "Allow inbound email posts from anyone" => "Allow inbound email posts from anyone",
// "Allow posts from non-users in forums using inbound posts from a specified email address" => "Allow posts from non-users in forums using inbound posts from a specified email address",
// "Parse HTML in inbound email posts" => "Parse HTML in inbound email posts",
// "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG" => "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG",
"Experimental" => "Expérimental",
// "Has problems with some HTML emails, especially those with table-based layouts" => "Has problems with some HTML emails, especially those with table-based layouts",
// "Strip wiki markup from outgoing forum emails" => "Strip wiki markup from outgoing forum emails",
// "Convert outgoing emails from forum posts to plain text" => "Convert outgoing emails from forum posts to plain text",
// "Send moderation email" => "Send moderation email",
// "Send email to forum moderators when post is queued" => "Send email to forum moderators when post is queued",
// "Approve link in moderation email" => "Approve link in moderation email",
// "Include a link for forum moderators to approve queue from email" => "Include a link for forum moderators to approve queue from email",
// "Do not start messages titles with 'Re:'" => "Do not start messages titles with 'Re:'",
"Don't display forum thread titles" => "Masquer les titres pour les fils de discussion de forum",
"Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display" => "La plupart des titres ne sont pas modifiés car ils sont une réponse directe au fil de discussion parent. Cette fonctionnalité masque le titre dans les fomulaires et à l'affichage",
// "Include a dropdown selector in the forum list to choose a category for the post" => "Include a dropdown selector in the forum list to choose a category for the post",
"Creation date (asc)" => "Date de Création (asc)",
"Topics (desc)" => "Sujets (desc)",
"Threads (desc)" => "Fils de discussion (desc)",
"Latest post (desc)" => "Dernier article (desc)",
"Name (desc)" => "Nom (décroissant)",
"Name (asc)" => "Nom (croissant)",
// "Href" => "Href",
"Object ID" => "Id de l'objet",
// "Comments locked" => "Comments locked",
"Multilingual tags" => "Mots-clés multilingues",
"Permits translation management of tags" => "Permettre la gestion de la traduction des tags",
// "Ordering of tagged objects" => "Ordering of tagged objects",
// "Default sort mode for tagged items" => "Default sort mode for tagged items",
"Show tag cloud" => "Afficher le nuage de mot-clé",
// "Show the full tag cloud in the list-tags screen" => "Show the full tag cloud in the list-tags screen",
"Maximum number of tags in cloud" => "Nombre maximum de mots-clés dans le nuage",
// "tags" => "tags",
"Show tags in middle column" => "Afficher les mots-clés dans la colonne du milieu",
// "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page." => "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page.",
"Preload random tag" => "Précharger un mot-clé choisi aléatoirement",
// "A random tag will be selected on the tag search page (if no tag is pre-selected)." => "A random tag will be selected on the tag search page (if no tag is pre-selected).",
// "Tag Suggestions" => "Tag Suggestions",
"Number of tags to show in tag suggestions" => "Nombre de mots-clés à afficher dans la suggestion de mots-clés",
"Valid characters pattern" => "Modèle valide de caractères",
// "Click on the links below to set or clear a pattern to limit characters accepted in tags. " => "Click on the links below to set or clear a pattern to limit characters accepted in tags. ",
"Lowercase tags only" => "Mots-clés en minuscules uniquement",
// "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly." => "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly.",
// "GD %0 detected" => "GD %0 detected",
// "GD not detected" => "GD not detected",
// "Imagick %0 detected" => "Imagick %0 detected",
// "Imagick 0 not detected" => "Imagick 0 not detected",
"Batch loading directory" => "Répertoire de téléchargement par lot",
// "Needs to be a web-readable directory" => "Needs to be a web-readable directory",
"Display image information in a mouseover box" => "Afficher les informations lors du survol de l'image dans une fenêtre popup",
// "Yes, and don't display that information under the image" => "Yes, and don't display that information under the image",
"Parent" => "Parent",
"Uploaded image names must match regex" => "Les noms d'images envoyées doivent correspondre aux expressions régulières",
"Uploaded image names cannot match regex" => "Les noms d'images envoyées ne correspondent pas aux expressions régulières",
"Directory path" => "Chemin du répertoire",
// "If you change this directory, move any images to the new directory either manually or using the 'Mover' below" => "If you change this directory, move any images to the new directory either manually or using the 'Mover' below",
// "Image processing library" => "Image processing library",
// "Imagick" => "Imagick",
// "Generate password" => "Generate password",
"Display a button on the registration form to automatically generate a very secure password for the user." => "Inclure l'option \"Générateur de mot de passe\" dans le formulaire d'enregistrement",
// "The generated password may not include any restrictions (such as minimum/maximum length" => "The generated password may not include any restrictions (such as minimum/maximum length",
// "Maps & Location Enabled" => "Maps & Location Enabled",
// "Provide controls to load map and location libraries" => "Provide controls to load map and location libraries",
"Geolocate wiki pages" => "Géolocaliser les pages wiki",
"Provide controls to indicate a geographic location of wiki pages in the edit form" => "Fournit des commandes pour géolocaliser les pages wiki à partir de la fonctionnalité d'édition",
"Geolocate articles" => "Géolocaliser les articles",
"Provide controls to indicate a geographic location in the article edit form" => "Fournit des commandes pour géolocaliser les articles à partir de la fonctionnalité d'édition",
"Geolocate blog posts" => "Géolocaliser les publications de blogue",
"Provide controls to indicate a geographic location in the blog post edit form" => "Fournit des commandes pour géolocaliser les publications de blogue à partir de la fonctionnalité d'édition",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing" => "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing",
// "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1" => "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1",
// "Google Street View" => "Google Street View",
// "Open Google Street View in a new window to see the visible coordinates" => "Open Google Street View in a new window to see the visible coordinates",
// "Google Street View overlay" => "Google Street View overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Zoom level for the found location" => "Zoom level for the found location",
// "Zoom level when a searched-for location is found" => "Zoom level when a searched-for location is found",
// "Street" => "Street",
// "Town" => "Town",
// "Region" => "Region",
// "Continent" => "Continent",
// "OpenLayers version" => "OpenLayers version",
// "OpenLayers 2.x (for use up to at least 15.x)" => "OpenLayers 2.x (for use up to at least 15.x)",
// "OpenLayers 3+ (experimental)" => "OpenLayers 3+ (experimental)",
// "Bing Maps API Key" => "Bing Maps API Key",
// "Needed for Bing Map Layers" => "Needed for Bing Map Layers",
// "Nextzen Maps API Key" => "Nextzen Maps API Key",
// "Needed for Nextzen Map Layers" => "Needed for Nextzen Map Layers",
"Browser title" => "Titre des fenêtres",
"Visible label in the browser's title bar on all pages. Also appears in search engine results" => "Texte visible dans la barre de titre des fenêtres du navigateur sur toutes les pages. Il apparaitra aussi dans les moteurs de recherche",
// "Fallback for tiki base URL" => "Fallback for tiki base URL",
// "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line" => "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line",
"Validate new user registrations by email" => "Valider l'enregistrement des nouveaux utilisateurs par mail",
// "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses" => "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses",
// "Wiki homepage" => "Wiki homepage",
"The default home page of the wiki when no other page is specified. The page will be created if it does not already exist" => "Page par défaut utilisée pour le wiki lorsqu'aucune page n'est précisée. La page sera créée si elle n'existe pas",
"Use group homepages" => "Utiliser les pages d'accueil de groupe",
"Users can be directed to different pages upon logging in, depending on their default group." => "Les utilisateurs peuvent être redirigés vers des pages différentes à la connexion en fonction de leur groupe par défaut.",
"Go to the group homepage only if logging in from the default homepage" => "Aller à la page d'accueil du groupe seulement si connecté depuis la page d'accueil par défaut",
"Cache external pages" => "Mettre les pages externes en cache",
"Cache external images" => "Mettre les images externes en cache",
"Temporary directory" => "Répertoire temporaire",
"Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory" => "Tiki doit avoir les droits en lecture/écriture sur ce répertoire",
"Help URL" => "URL de l'aide",
"The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki" => "Le système d'aide par défaut peut être incomplet. Vous pouvez aider à compléter la documentation de Tiki",
"Open external links in new window" => "Ouvrir les liens externes dans une nouvelle fenêtre",
// "Open links to external sites in a new browser tab or window" => "Open links to external sites in a new browser tab or window",
// "Allow image lazy loading" => "Allow image lazy loading",
// "Allow that images are loaded in a lazy way" => "Allow that images are loaded in a lazy way",
"License page" => "Page de licence",
// "The wiki page where the license information is written" => "The wiki page where the license information is written",
"Submit notice" => "Soumettre une notice",
// "Text to appear when content is being submitted" => "Text to appear when content is being submitted",
"Full path to gdaltindex" => "Chemin d'accès complet à gdaltindex",
"Full path to ogr2ogr" => "Chemin d'accès à ogr2ogr",
"Map Zone" => "Zone carte",
"Always display modules to all groups" => "Toujours afficher les modules à tous les groupes",
// "Any setting for the Groups parameter will be ignored and the module will be displayed to all users" => "Any setting for the Groups parameter will be ignored and the module will be displayed to all users",
"Hide anonymous-only modules from registered users" => "Cacher aux utilisateurs inscrits les modules assignés aux utilisateurs anonymes",
// "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module" => "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module",
"Hide anonymous-only modules from Admins" => "Cacher aux admins les modules réservés aux anonymes",
"Maximum number of articles on the articles homepage" => "Nombre maximum d'articles afficher sur la page d'accueil des articles",
// "The number of articles to show on each page of the Articles homepage" => "The number of articles to show on each page of the Articles homepage",
// "articles" => "articles",
"Site Ads and Banners Content" => "Pubs du Site et Contenu des Bannières",
"Test" => "Test",
"URL to go to when clicking on a username" => "L'URL accédée en cliquant sur un nom d’utilisateur",
"Default" => "Défaut",
"Use %user% for login name and %userId% for userId)" => "Utiliser %user% pour l'identifiant de connexion et %userId% pour le userId)",
"Forgot password" => "Mot de passe oublié",
"Users can request a password reset. They will receive a link by email" => "Les utilisateurs peuvant demander à réinitialiser le mot depasse. Ils recevront un lien par courriel",
"Group theme" => "Thème du groupe",
"Enable groups to each have their own visual theme." => "Chaque groupe peut avoir son propre thème",
// "The displayed title of the website" => "The displayed title of the website",
"Subtitle" => "Sous-titre",
// "A short phrase that, for example, describes the site" => "A short phrase that, for example, describes the site",
"Maximum number of records in listings" => "Nombre maximum d'éléments affichés dans chaque liste",
// "records" => "records",
"Maximum number of versions" => "Nombre maximum de versions",
// "versions" => "versions",
"Users can register" => "Permettre aux utilisateurs de s'inscrire",
// "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page" => "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page",
// "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option" => "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option",
// "Yes, with \"deep MX\" search" => "Yes, with \"deep MX\" search",
"Require validation by Admin" => "Demande une validation par Admin",
"The administrator will receive an email for each new user registration, and must validate the user before the user can log in" => "L'administrateur recevra un e-mail pour chaque nouvelle inscription, et doit la valider avant que l'utiliser puisse se connecter",
"Require passcode to register" => "Exiger un code pour l'enregistrement",
"Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users" => "Les utilisateurs doivent fournir un code pour s'enregistrer. Vous devez leur fournir ce code. A utiliser pour limiter l'enregistrement aux seuls invités",
"Passcode" => "Code d'enregistrement",
"Alphanumeric code required to complete the registration" => "Code alphanumérique requis pour terminer l'enregistrement",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Registration page key" => "Registration page key",
// "Key required to be on included the URL to access the registration page (if not empty)" => "Key required to be on included the URL to access the registration page (if not empty)",
// "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue" => "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue",
"Use a tracker to collect more user information" => "Utiliser les formulaires pour collecter des informations complémentaires sur les utilisateurs",
"Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user" => "Afficher un formulaire à remplir par l'utilisteur, en tant que partie du processus d'enregistrement. Utiliser ce formulaire pour stocker des informations additionnelles sur chaque utilisateur",
"Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display" => "Utiliser la page \"Administrer les Groupes\" pour choisir quel formulaire et quels champs afficher",
"Use tracker to collect more group information" => "Utiliser le formulaire pour collecter plus d'informations sur les groupes",
"Create a new group for each user" => "Créer un nouveau groupe pour chaque utilisateur",
// "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level" => "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level",
"Synchronize Tiki groups with a directory" => "Synchroniser les groupes Tiki avec un répertoire",
"Define the directory within the \"LDAP\" tab" => "Definir le répertoire dans l'onglet \"LDAP\"",
"Synchronize Tiki users with a directory" => "Synchroniser les utilisateurs Tiki avec un répertoire",
"Remember me" => "Mémorisez-moi",
"Duration" => "Durée",
// "The length of time before the user will need to log in again" => "The length of time before the user will need to log in again",
"day" => "jour",
"week" => "semaine",
"month" => "mois",
"year" => "année",
// "Homepage Browser title" => "Homepage Browser title",
// "Customize Browser title for the custom homepage" => "Customize Browser title for the custom homepage",
"Use custom homepage" => "Utiliser une page d'accueil personnalisée",
"Use the top page of a Tiki feature or another homepage" => "Utilise une fonctionnalité Tiki comme page par défaut ou une autre page",
// "This option will override the Use Tiki feature as homepage setting" => "This option will override the Use Tiki feature as homepage setting",
"Use the top page of a Tiki feature as the homepage" => "Utiliser une fonctionnalité Tiki comme page d'accueil",
"Select the Tiki feature to provide the site homepage. Only enabled features are listed" => "Sélectionnez la fonctionnalité Tiki à utiliser comme page d'accueil du site. Seules les fonctionnalités activées sont affichée",
"Disable JavaScript" => "Désactiver JavaScript",
"Disable JavaScript for the purpose of testing even if enabled in the browser" => "Désactiver JavaScript pour des fins d'essai, même si le fureteur l’autorise",
// "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly" => "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly",
// "Maximum rows per page" => "Maximum rows per page",
"Images per row" => "Nombre d'images par rangée",
// "images" => "images",
// "Thumbnail width" => "Thumbnail width",
// "Thumbnail height" => "Thumbnail height",
// "Default scale size" => "Default scale size",
"Set blogs homepage first" => "Choisir d'abord une page d'accueil du blog",
"Set Image gal homepage first" => "Choisir d'abord la page d'accueil de la galerie d'image",
"Set Forum homepage first" => "Choisir d'abord la page d'accueil du forum",
"Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Puisque les mots de passe sont encryptés, il n'est pas possible d'indiquer à l'utilisateur quel est son mot de passe. Il est seulement possible de le modifier",
"Validate user's email server" => "Valider le serveur mail de l'utilisateur",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
"The group name will be the same as the user's username" => "Le groupe portera le même nom que celui de l'utilisateur",
// "After logging in, users will automatically be logged in again when they leave and return to the site" => "After logging in, users will automatically be logged in again when they leave and return to the site",
"User's choice" => "Choix de l'utilisateur",
"Google Maps API Key" => "Clé Google Maps API",
// "Needed for Street View or other advanced features" => "Needed for Street View or other advanced features",
"Default x for map center" => "x par défaut pour le centre de la carte",
"Default y for map center" => "y par défaut pour le centre de la carte",
"Default zoom level" => "Niveau du zoom par défaut",
"whole earth" => "toute la terre",
"country size" => "taille pays",
"city size" => "taille ville",
"max zoom" => "zoom maximum",
"Show map mode buttons in articles list" => "Montrer les boutons du mode carte dans la liste d'articles",
"Show map mode buttons in page list" => "Montrer les boutons du mode carte dans la liste de pages",
// "Goal, recognition and rewards" => "Goal, recognition and rewards",
// "A tool to set motivational goals to increase engagement on the site" => "A tool to set motivational goals to increase engagement on the site",
// "Reward badge tracker" => "Reward badge tracker",
// "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user" => "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user",
// "0 to disable" => "0 to disable",
// "Groups not eligible for goals" => "Groups not eligible for goals",
// "Groups that will not be on the eligible group list" => "Groups that will not be on the eligible group list",
// "H5P support" => "H5P support",
// "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content" => "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content",
// "Whitelist" => "Whitelist",
// "Allowed filetypes" => "Allowed filetypes",
// "H5P Tracker User" => "H5P Tracker User",
// "Store H5P results" => "Store H5P results",
// "H5P Developer Mode" => "H5P Developer Mode",
// "Use \"patched\" libraries" => "Use \"patched\" libraries",
// "Default Gallery" => "Default Gallery",
// "File gallery to create new H5P content in by default" => "File gallery to create new H5P content in by default",
// "Store user state" => "Store user state",
// "Allows users to resume at the point they last got to" => "Allows users to resume at the point they last got to",
// "Save Frequency" => "Save Frequency",
// "How often to update user data" => "How often to update user data",
// "Allows users to export H5P content" => "Allows users to export H5P content",
// "Hub Is Enabled" => "Hub Is Enabled",
// "Updates libraries from h5p.org" => "Updates libraries from h5p.org",
// "Site Key" => "Site Key",
// "H5P Site Key" => "H5P Site Key",
// "H5P UUID" => "H5P UUID",
// "H5P Unique ID" => "H5P Unique ID",
// "Content Type Updated" => "Content Type Updated",
"Last update" => "Modifié le",
// "Check Requirements" => "Check Requirements",
// "Unused so far" => "Unused so far",
// "Send Usage Statistics" => "Send Usage Statistics",
// "Request User Consent" => "Request User Consent",
// "LRS Content Types" => "LRS Content Types",
// "Reporting (?)" => "Reporting (?)",
"HHeader shadow div start" => "Calque d'en-tête - Début",
"Header shadow div end" => "Calque d'en-tête - Fin",
"Custom CSS" => "CSS personnalisé",
// "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n" => "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n",
"Custom JavaScript" => "JavaScript personnalisé",
"Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages" => "Inclure un bloc JavaScript dans chaque page",
// "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page" => "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page",
"Do not include the < script > tags" => "Ne pas inclure les balises <script> et </script>",
// "Custom Less" => "Custom Less",
// "Compiles a new version of the currently selected theme and option using definitions declared here" => "Compiles a new version of the currently selected theme and option using definitions declared here",
// "Custom Less (CSS precompiler) - no longer used" => "Custom Less (CSS precompiler) - no longer used",
// "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon.." => "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon..",
"Highlight group" => "Surligner le groupe",
"Home blog (main blog)" => "Accueil - Blogues",
"Home forum (main forum)" => "Accueil - forums",
"Home file gallery (main file gallery)" => "Galeries de fichiers Accueil (galerie de fichiers principale)",
// "Select the default file gallery" => "Select the default file gallery",
"Home gallery (main gallery)" => "Accueil - Galerie",
"No image gallery available (create one first)" => "Aucune galerie d'images n'est disponible (il faut en créer une tout d'abord)",
"No file gallery available (create one first)" => "Aucune galerie n'est disponible (il faut en créer une tout d'abord)",
"No blog available (create one first)" => "Aucun blog disponible (il faut en créer un tout d'abord)",
"HTTP port" => "Port HTTP",
// "The port used to access this server; if not specified, port 80 will be used" => "The port used to access this server; if not specified, port 80 will be used",
"If not specified, port 80 will be used" => "Si laissé à blanc, le port 80 sera utilisé",
// "HTTP lookup: skip framesets" => "HTTP lookup: skip framesets",
// "When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
// "HTTP header x-frame options" => "HTTP header x-frame options",
// "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt" => "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt",
// "Header value" => "Header value",
// "DENY" => "DENY",
// "SAMEORIGIN" => "SAMEORIGIN",
// "HTTP header x-xss-protection" => "HTTP header x-xss-protection",
// "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers" => "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers",
// "0" => "0",
// "1;mode=block" => "1;mode=block",
// "HTTP header x-content-type-options" => "HTTP header x-content-type-options",
// "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed" => "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed",
// "HTTP header content-security-policy" => "HTTP header content-security-policy",
// "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page" => "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page",
// "HTTP header strict-transport-security" => "HTTP header strict-transport-security",
// "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP" => "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP",
// "HTTP header public-key-pins" => "HTTP header public-key-pins",
// "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it" => "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it",
"HTTPS for user-specific links" => "Utiliser HTTPS lors de la fabrication de liens spécifiques aux utilisateurs",
// "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "Port HTTPS",
// "the HTTPS port for this server" => "the HTTPS port for this server",
"Use HTTPS login" => "Utiliser un login HTTPS",
"Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Augmenter la sécurité en autorisant la transmission des identifiants en mode SSL. Les certificats doivent être configurés sur le serveur",
"Allow secure (HTTPS) login" => "Permettre une connexion sécurisée (HTTPS)",
"Encourage secure (HTTPS) login" => "Encourager les connexions sécurisées (HTTPS)",
"Consider we are always in HTTPS, but do not check" => "Considère que nous sommes toujours en HTTPS, sans le vérifier",
"Require secure (HTTPS) login" => "Exiger une connexion sécurisée (HTTPS)",
"Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible" => "Ne pas exiger le mode HTTPS tant que vous n'avez pas configuré et testé la connexion, sinon, vous rendrez l'ensemble de votre site inaccessible",
// "Enable intrusion detection system" => "Enable intrusion detection system",
// "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations" => "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations",
// "Intrusion detection system mode" => "Intrusion detection system mode",
// "Define IDS operation mode, log only, or log and block with impact over a given threshold" => "Define IDS operation mode, log only, or log and block with impact over a given threshold",
// "Log only" => "Log only",
// "Log and block requests" => "Log and block requests",
// "Intrusion detection system threshold" => "Intrusion detection system threshold",
// "Define IDS threshold, when configured in \"Log and block requests\" more" => "Define IDS threshold, when configured in \"Log and block requests\" more",
// "Custom rules file" => "Custom rules file",
// "Log to file" => "Log to file",
// "Log to database" => "Log to database",
// "Default for img-fluid class used in the IMG plugin" => "Default for img-fluid class used in the IMG plugin",
// "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden" => "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden",
// "Errors log file" => "Errors log file",
// "location, from your tiki root dir, where you want the error log file stored" => "location, from your tiki root dir, where you want the error log file stored",
// "Access log file" => "Access log file",
// "location, from your tiki root dir, where you want the access log file stored" => "location, from your tiki root dir, where you want the access log file stored",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
"Use CDN for JavaScript" => "Utiliser un CDN pour JavaScript",
"Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)." => "Obtenir les bibliothèques jQuery et jQuery UI grâce à un réseau de distribution de contenu (CDN)",
// "Google" => "Google",
"jQuery" => "jQuery",
// "Assume JavaScript is enabled even if not supported" => "Assume JavaScript is enabled even if not supported",
// "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter" => "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter",
"Slide" => "Diapositive",
"Fade" => "Disparition graduelle",
"Blind (UI)" => "Rideau (IU)",
"Clip (UI)" => "Rétrécissement (IU)",
"Drop (UI)" => "Chute (IU)",
"Explode (UI)" => "Explosion (IU)",
"Fold (UI)" => "Pliage (IU)",
"Puff (UI)" => "Disparition (IU)",
"Slide (UI)" => "Diapo (IU)",
"Effect for modules" => "Effet pour les modules",
"Effect for tabs" => "Effet pour les onglets",
"Speed" => "Vitesse",
"Fast" => "Rapide",
"Normal" => "Normal",
"Slow" => "Lent",
"Direction" => "Direction",
"Vertical" => "Vertical",
"Horizontal" => "Horizontal",
"Left" => "Gauche",
"Right" => "Droit",
"Up" => "+haut",
"Down" => "+bas",
// "jQuery-UI Chosen Select Boxes" => "jQuery-UI Chosen Select Boxes",
// "Styled replacement for dropdown select lists and multiple-select inputs" => "Styled replacement for dropdown select lists and multiple-select inputs",
// "Sortable Chosen Multi-selects" => "Sortable Chosen Multi-selects",
// "Enable drag and drop re-ordering of Chosen multi-select options" => "Enable drag and drop re-ordering of Chosen multi-select options",
// "Visual style of Colorbox (a.k.a. \"Shadowbox\")" => "Visual style of Colorbox (a.k.a. \"Shadowbox\")",
"One" => "Un",
"Two" => "Deux",
"Three" => "Trois",
// "Four" => "Four",
// "Five" => "Five",
// "FitVids.js" => "FitVids.js",
// "jQuery plugin for fluid-width (responsive) embedded videos" => "jQuery plugin for fluid-width (responsive) embedded videos",
// "jQuery Timeago" => "jQuery Timeago",
// "jQuery plugin for fuzzy timestamps" => "jQuery plugin for fuzzy timestamps",
// "SmartMenus" => "SmartMenus",
// "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more" => "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more",
// "SmartMenus Mode" => "SmartMenus Mode",
"Blue" => "Bleu",
"Clean" => "Nettoyer",
// "Mint" => "Mint",
"Simple" => "Simple",
// "Draggable Modals" => "Draggable Modals",
// "Modal popups can be moved around" => "Modal popups can be moved around",
// "Resizable Modals" => "Resizable Modals",
// "Modal popups can be resized" => "Modal popups can be resized",
// "jQuery Double Scroll" => "jQuery Double Scroll",
// "jQuery plugin which adds an extra horizontal scroll bar at the top" => "jQuery plugin which adds an extra horizontal scroll bar at the top",
"Partner ID" => "ID Partenaire",
"Kaltura Partner ID" => "ID Partenaire Kaltura",
"User secret" => "Secret de l'utilisateur",
"Kaltura partner-setting user secret" => "Réglage code secret utilisateur partenaire Kaltura",
"Admin secret" => "Secret de l'Admin",
"Kaltura partner-setting admin secret" => "Réglage code secret administrateur partenaire Kaltura",
// "Kaltura video player ID" => "Kaltura video player ID",
"Kaltura Dynamic Player (KDP) user interface configuration ID" => "ID de configuration interface utilisateur du Lecteur Dynamique (KDP)",
// "Kaltura video player ID (in entry edit mode)" => "Kaltura video player ID (in entry edit mode)",
// "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail" => "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail",
// "KCW UI configuration ID" => "KCW UI configuration ID",
"Kaltura Configuration Wizard (KCW) user interface configuration ID" => "ID de la configuration interface utilisateur de l'Assistant de Configuration Kaltura (KCW)",
// "Kaltura service URL" => "Kaltura service URL",
// "for example, https://www.kaltura.com/" => "for example, https://www.kaltura.com/",
// "Show remixes from old versions of Kaltura" => "Show remixes from old versions of Kaltura",
// "Show remixes from old versions of Kaltura (remixing is no longer supported)" => "Show remixes from old versions of Kaltura (remixing is no longer supported)",
// "Keep versions for" => "Keep versions for",
// "Do not delete versions younger than this number of days" => "Do not delete versions younger than this number of days",
"Use database for translation" => "Utiliser la base de données pour les traductions",
"Use the database to store the translated strings and allow using interactive translation" => "Utiliser la base de données pour entreposer les traductions et permettre d'utiliser la traduction interactive",
"Edit, export and import languages" => "Modifier, exporter et importer des langues",
// "Manage contribution of translated strings" => "Manage contribution of translated strings",
// "Offers to set whether each translated string should be contributed to the Tiki community or kept locally" => "Offers to set whether each translated string should be contributed to the Tiki community or kept locally",
// "Machine translation implementation" => "Machine translation implementation",
// "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required" => "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required",
// "Google Translate" => "Google Translate",
// "Bing Translate" => "Bing Translate",
// "Enable machine translation of wiki pages" => "Enable machine translation of wiki pages",
// "Makes additional languages available to the list of languages on the page" => "Makes additional languages available to the list of languages on the page",
// "Google Translate API Key" => "Google Translate API Key",
// "The key must be generated from the Google console. Choose to create a server key" => "The key must be generated from the Google console. Choose to create a server key",
// "Bing Translate Client ID" => "Bing Translate Client ID",
// "The application must be registered" => "The application must be registered",
// "Bing Translate Client Secret" => "Bing Translate Client Secret",
// "Display available translations as dropdown" => "Display available translations as dropdown",
// "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list" => "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list",
"Default language" => "Langue par défaut",
"The site language is used when no other language is specified by the user" => "Langue du site utilisée quand aucune autre langue n'est spécifiée par l'utilisateur",
// "Default admin language" => "Default admin language",
// "The site language is used in admin section when no other language is specified by the user" => "The site language is used in admin section when no other language is specified by the user",
"Language inclusion threshold" => "Seuil d'inclusion langue",
"When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "Quand le nombre de langues est réduit sur le site, et est en dessous de ce nombre, toutes les langues sont rajoutées à la liste des langues préférées, même si cela n'a pas été spécifié par l'utilisateur. Toutefois, la priorité est donnée aux langues spécifiées",
"languages" => "langues",
"Layout width" => "Largeur d'affichage",
"The width of the content area of the site, centered in the browser window" => "Contraint la largeur d'affichage du site (défaut : 990px)",
"for example, 960px" => "Ex. : 800px",
// "Tabs optional" => "Tabs optional",
"Users can choose not to have tabs. A <b>no tabs</b> button will be displayed" => "Les utilisateurs peuvent choisir de ne pas avoir d'onglets",
"Add group CSS info" => "Ajouter les informations CSS du groupe",
"Add CSS classes to the page BODY tag based on the user's group membership" => "Ajouter des classes au 'BODY' de la page pour indiquer l'appartenance à un groupe",
"Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Soit 'grp_Anonymous' ou 'grp_Registered' et éventuellement aussi bien 'grp_Admins'",
// "If this option is disabled, this user wouldn’t be able to log in" => "If this option is disabled, this user wouldn’t be able to log in",
"Create the user" => "Créer l'utilisateur",
"Deny access" => "Refuser l'accès",
"Create user if not in LDAP" => "Créer l'utilisateur s'il n'existe pas dans LDAP",
// "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user" => "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user",
// "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”" => "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”",
"Maximum average server load threshold in the last minute" => "Seuil maximum de charge du serveur dans la dernière minute",
// "Lock Content Templates" => "Lock Content Templates",
// "Enable users to lock content templates and so prevent others from editing them" => "Enable users to lock content templates and so prevent others from editing them",
// "Lock Wiki Structures" => "Lock Wiki Structures",
// "Enable users to lock wiki structures and so prevent others from editing them" => "Enable users to lock wiki structures and so prevent others from editing them",
"Log mail in Tiki logs" => "Noter les emails dans les journaux Tiki",
"A line of type mail will be included in the System Log with the destination address and subject of each email sent" => "Noter les emails dans les journaux Tiki",
"Smarty template usage indicator" => "Indicateur d'utilisation des gabarits Smarty",
"Add HTML comment at start and end of each Smarty template (.tpl file)" => "Ajouter des commentaires au format HTML au début et à la fin de chaque modèle Smarty (TPL)",
"Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source." => "À utiliser seulement pour le développement, pas en production, car ces avertissements sont ajoutés aux e-mails et donc visibles aux utilisateurs.",
"You need to clear your Tiki template cache for this change to take effect" => "Vous devez effacer le cache des Templates pour que le changement de paramètre prenne effet",
"Log SQL" => "Journaux SQL",
"All SQL queries will be registered in the database in the adodb_logsql table. " => "Journaliser les requêtes SQL",
// "Do not enable this feature all the time. It can be very resource intensive and will impact performance" => "Do not enable this feature all the time. It can be very resource intensive and will impact performance",
"Log queries using more than" => "Logguer les requêtes qui prennent plus que (secondes)",
"Use to log only queries that exceed a specific amount of time" => "Peut avoir un impact sur les performances",
"Use email as username" => "Utiliser l'email comme nom d'utilisateur",
"Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field" => "Au lieu de créer de nouveaux noms d'utilisateurs, utiliser l'adresse courriel de l'utilisateur pour l'authentification",
"Obscure email when using email as username" => "Coder l'adresse email, si possible, lorsqu'elle est utilisée comme nom d'utilisateur. (la couverture ne sera pas complète)",
// "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead" => "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead",
// "Coverage will not be complete" => "Coverage will not be complete",
// "User can login via username or email" => "User can login via username or email",
// "This will allow users to login using their email (as well as their username)" => "This will allow users to login using their email (as well as their username)",
// "Auto-generate 6-digit username on registration" => "Auto-generate 6-digit username on registration",
// "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)" => "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)",
// "HTTP Basic Authentication" => "HTTP Basic Authentication",
"Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials" => "Vérifier les identifiants à partir de l'authentification de base HTTP, utilise pour autoriser les services web à utiliser des identifiants",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
// "Prevent multiple log-ins by the same user" => "Prevent multiple log-ins by the same user",
// "Users (other than admin) cannot log in simultaneously with multiple browsers" => "Users (other than admin) cannot log in simultaneously with multiple browsers",
// "Grab session if already logged in" => "Grab session if already logged in",
// "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out" => "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out",
// "Enable autologin from remote Tiki" => "Enable autologin from remote Tiki",
// "Used with autologin_remotetiki in the redirect plugin" => "Used with autologin_remotetiki in the redirect plugin",
// "System username to use to initiate autologin from remote Tiki" => "System username to use to initiate autologin from remote Tiki",
// "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin" => "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin",
// "System groupname to use for auto login token" => "System groupname to use for auto login token",
// "For security, please create a group that has no users and no permissions and specify its name here" => "For security, please create a group that has no users and no permissions and specify its name here",
// "Create a new user account if the user that is trying to autologin does not exist on this Tiki" => "Create a new user account if the user that is trying to autologin does not exist on this Tiki",
// "Allowed groups from remote Tiki to autologin" => "Allowed groups from remote Tiki to autologin",
// "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone" => "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone",
// "Sync these groups from remote Tiki on autologin" => "Sync these groups from remote Tiki on autologin",
// "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly" => "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly",
// "Automatically logout remote Tiki after logout" => "Automatically logout remote Tiki after logout",
// "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well" => "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well",
// "Redirect direct logins to this site to remote Tiki" => "Redirect direct logins to this site to remote Tiki",
// "URL of autologin page on remote Tiki to redirect user to login" => "URL of autologin page on remote Tiki to redirect user to login",
// "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin" => "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin",
"Long date format" => "Format long pour la date",
// "Specify how Tiki displays the date (longer version)" => "Specify how Tiki displays the date (longer version)",
"Long time format" => "Format long pour l'heure",
// "Specify how Tiki displays the time (longer version)" => "Specify how Tiki displays the time (longer version)",
"%A %d of %B, %Y" => "%A %d %B %Y",
"%H:%M:%S %Z" => "%Hh%M",
"%A %d of %B, %Y %H:%M:%S %Z" => "%A %d %B %Y %H:%M:%S %Z",
"Force lowercase" => "Forcer en minuscules",
// "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>" => "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>",
"Email newline character(s)" => "Caractère(s) de fin de ligne des courriels",
"End-of-line (EOL) character used in outgoing emails" => "Séquence de caractères marquant la fin d'une ligne dans les courriels sortants",
"CRLF (standard)" => "CRLF (standard)",
"LF (some Unix MTA)" => "LF (certains MTA Unix)",
// "Text string used to customise mail templates" => "Text string used to customise mail templates",
// "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files" => "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files",
"Main shadow start" => "Calque principal - Début",
"Main shadow end" => "Claque principal - Fin",
"Maximum length" => "Taille Maximale",
// "The greatest number of characters for a valid username" => "The greatest number of characters for a valid username",
"Memcache" => "Memcache",
"Enable connection to memcached servers to store temporary information" => "Activer la connexion aux serveurs memcache pour le stockage temporaire d'informations",
"Requires the PHP memcache extension" => "Nécessite l'extension PHP memcache",
"Memcache servers" => "Serveurs Memcache",
"Server list which may be accessed. For each server, the address, port and weight must be specified." => "Liste de serveurs pouvant être utilisés. Pour chacun, l'adresse, le port et le poids doivent être spécifiés.",
// "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"" => "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"",
"Memcache key prefix" => "Préfix pour les clefs Memcache",
"When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts" => "Quand le groupe de machines memcache est utilisé par plusieurs applications, utiliser des préfixes distincts pour chacune d'entre elles aide à éviter les conflits",
"Memcache expiration" => "Expiration Memcache",
"Duration for which the data will be kept" => "Temps de conservation des données",
"Cache wiki data in memcache" => "Mettre les données Wiki dans memcache",
"Cache wiki output in memcache" => "Mettre le rendu Wiki dans memcache",
"Cache forum output in memcache" => "Mettre le rendu des forums dans memcache",
"Menu icons" => "Icônes de menus",
// "Allows icons to be defined for menu entries" => "Allows icons to be defined for menu entries",
"Default path for the icons" => "Chemin par défaut pour les icônes",
// "Edit menu icon" => "Edit menu icon",
// "Adds an icon on the navbar to edit menu entries" => "Adds an icon on the navbar to edit menu entries",
// "Maximum mailbox size" => "Maximum mailbox size",
// "Maximum number of messages allowed in the mailbox" => "Maximum number of messages allowed in the mailbox",
"messages" => "messages",
// "Maximum mail archive size" => "Maximum mail archive size",
// "Maximum number of archive messages allowed" => "Maximum number of archive messages allowed",
// "Maximum sent box size" => "Maximum sent box size",
// "Maximum number of sent messages allowed in the mailbox" => "Maximum number of sent messages allowed in the mailbox",
// "Truncate internal message notification" => "Truncate internal message notification",
// "Number of characters to show in the message notification sent through email, with a link to read the full internal message" => "Number of characters to show in the message notification sent through email, with a link to read the full internal message",
"Keywords" => "Mot(s) clé(s)",
"A list of keywords (separated by commas) that describe this website." => "Une liste de mots clés (séparés par des virgules) qui décrivent votre site.",
"Include tags" => "Inclure les mots-clés",
// "If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags" => "If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags",
"Use thread title instead" => "Utilisez le titre du fil de discussion à la place",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
"Use the image title instead" => "Utiliser le titre de l'image à la place",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of the website. Some search engines display this information with the website's listing" => "A short description of the website. Some search engines display this information with the website's listing",
// "Page description" => "Page description",
// "Use each page description as a meta tag for that page" => "Use each page description as a meta tag for that page",
"Author" => "Auteur",
// "The author of this website. Typically this is the Admin or Webmaster" => "The author of this website. Typically this is the Admin or Webmaster",
"geo.position" => "geo.position",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
"geo.region" => "geo.region",
// "The ISO-3166 country and region codes for your location. For example, \"US-NY\"" => "The ISO-3166 country and region codes for your location. For example, \"US-NY\"",
"geo.placename" => "geo.placename",
// "A free-text description of your location" => "A free-text description of your location",
"Meta robots" => "Méta robots",
// "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca" => "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca",
// "Should be comma separated eg. noimageindex, nocache" => "Should be comma separated eg. noimageindex, nocache",
"Revisit after" => "Revenir après",
// "Specify how often (in days) Web robots should visit your site" => "Specify how often (in days) Web robots should visit your site",
"Middle shadow div start" => "Calque médian - Début",
"Middle shadow div end" => "Calque médian - Fin",
"Minimum length" => "Taille minimale",
// "The least possible number of characters for a valid username" => "The least possible number of characters for a valid username",
// "The least possible number of characters for a valid password" => "The least possible number of characters for a valid password",
"Mobile access" => "Accès mobile",
// "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)" => "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)",
// "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)" => "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)",
"Mobile Perspectives" => "Perspectives 'Mobile'",
"Top module zone" => "Zone modules haut d'écran",
// "Activate zone for modules such as site logo, log-in form, etc. (page header)" => "Activate zone for modules such as site logo, log-in form, etc. (page header)",
"Topbar module zone" => "Zone modules barre du haut",
// "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc" => "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc",
"topbar" => "barre du haut",
"Page top module zone" => "Zone modules haut de page",
// "Activate zone for modules such as breadcrumbs, banners, share icons, etc" => "Activate zone for modules such as breadcrumbs, banners, share icons, etc",
"Bottom module zone" => "Zone modules bas d'écran",
// "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)" => "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)",
"Page bottom module zone" => "Zone modules bas de page",
// "Activate zone for modules at the bottom of the main column of each page" => "Activate zone for modules at the bottom of the main column of each page",
// "Module file" => "Module file",
// "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles" => "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles",
// "Extra module zones available" => "Extra module zones available",
// "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones" => "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones",
// "Comma-separated list, maximum of 20 characters per entry" => "Comma-separated list, maximum of 20 characters per entry",
// "Allow users to control the notifications they receive based on content changes" => "Allow users to control the notifications they receive based on content changes",
// "Notification digests" => "Notification digests",
// "Enable digest notifications (requires a cron job)" => "Enable digest notifications (requires a cron job)",
// "Clear individual notifications" => "Clear individual notifications",
// "Allow users to selectively clear notifications instead of simply having a clear-all button" => "Allow users to selectively clear notifications instead of simply having a clear-all button",
// "Notification count refresh interval" => "Notification count refresh interval",
// "Show unread notification count and refresh every [x] seconds" => "Show unread notification count and refresh every [x] seconds",
// "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds" => "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds",
// "Notification reply-to email pattern" => "Notification reply-to email pattern",
// "Email model to use for the notification email reply-to address" => "Email model to use for the notification email reply-to address",
// "noreply+PLACEHOLDER@example.com" => "noreply+PLACEHOLDER@example.com",
"\"More Like This\" algorithm" => "Algorithme \"Plus comme ceci\"",
// "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order" => "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order",
"Minimum number of tags in common" => "Nombre minimum de mot-clés communs",
// "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature" => "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature",
"Multi-domain" => "Multi-domaines",
"Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation" => "Permet de « mapper » les noms de domaines aux perspectives et ainsi simuler l'hébergement de multiples domaines sur une même instance",
"Multi-domain Configuration" => "Configuration Multi-domaines",
"Comma-separated values mapping the domain name to the perspective ID" => "Valeurs séparées par des virgules reliant le nom de domaine à l'ID de perspective",
"One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1" => "Un domaine par ligne. Séparé par une virgule de l'ID de la perspective. Ex.: tiki.org,1",
"Switch domain when switching perspective" => "Changer de domaine quand la perspective est modifiée",
"Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work" => "Se souvenir que des domaines différents ont des identifiants différents de connexion et donc , dans le cas de sous-domaines, vous devez avoir une totale compréhension des cookies de session pour faire fonctionner cela",
// "Must read" => "Must read",
// "Allow assignment of mandatory readings and track progress" => "Allow assignment of mandatory readings and track progress",
// "Must read tracker" => "Must read tracker",
// "Tracker containing the individual read requests" => "Tracker containing the individual read requests",
// "Namespace" => "Namespace",
// "Enable namespaces feature for wiki pages" => "Enable namespaces feature for wiki pages",
// "Namespace separator" => "Namespace separator",
// "Select the character, symbol, or text to use as the namespace separator" => "Select the character, symbol, or text to use as the namespace separator",
// "Default namespace" => "Default namespace",
// "Namespace to use when creating wiki pages. Should be defined within perspectives" => "Namespace to use when creating wiki pages. Should be defined within perspectives",
// "Hide namespace indicator in structure path" => "Hide namespace indicator in structure path",
// "Hide namespace indicator in page title" => "Hide namespace indicator in page title",
// "Force all non-namespace page links to the same namespace" => "Force all non-namespace page links to the same namespace",
// "If the current page is in a namespace, all links without a namespace will have it added automatically" => "If the current page is in a namespace, all links without a namespace will have it added automatically",
"Throttle newsletter send rate" => "Moduler la fréquence d'envoi des lettres d'informations",
"Pause for a given amount of seconds before each batch to avoid overloading the mail server." => "Faire une pause du nombre de secondes indiqué entre chaque envoi pour éviter de surcharger le serveur de courriel.",
"Newsletter pause length" => "Durée de la pause",
"Number of seconds delay before each batch" => "Nombre de secondes à attendre avant chaque envoi",
"Newsletter batch size" => "Nombre de lettres par envoi",
"Number of emails to send in each batch" => "Nombre de courriels à expédier dans chaque envoi.",
// "emails" => "emails",
"Allow sending newsletters through external clients" => "Autoriser l'envoi de lettres de nouvelles par des clients externes",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
"Use relative (next / previous) pagination links" => "Utiliser des liens de pagination (suivant / précédent) relatifs",
// "Encryption key for OAuthServer" => "Encryption key for OAuthServer",
// "A key used to encrypt/decrypt authorization codes" => "A key used to encrypt/decrypt authorization codes",
// "PGP/MIME encrypted email messaging" => "PGP/MIME encrypted email messaging",
// "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses" => "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses",
// "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on" => "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on",
// "Path to gnupg keyring" => "Path to gnupg keyring",
// "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\" => "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\",
// "Path to gpg executable" => "Path to gpg executable",
// "Full path to gpg executable" => "Full path to gpg executable",
// "Read signer pass phrase from prefs or from a file" => "Read signer pass phrase from prefs or from a file",
// "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\" => "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\",
// "preferences" => "preferences",
"file" => "fichier",
// "Signer pass phrase" => "Signer pass phrase",
// "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file" => "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file",
// "leave empty if read from file" => "leave empty if read from file",
// "Path to signer pass phrase filename" => "Path to signer pass phrase filename",
// "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file" => "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file",
"Wiki buttons" => "Boutons Wiki",
"Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)" => "Description de la page, icônes, liens, ..",
"Top " => "Haut ",
"Bottom" => "Bas",
"Neither" => "Aucun",
// "Pages can reoccur in structure" => "Pages can reoccur in structure",
"A page can be listed multiple times in a structure" => "Une page peut avoir plusieurs occurences dans la même structure",
// "Fetch page content from incoming feeds" => "Fetch page content from incoming feeds",
// "Page content from the source will be fetched before sending the content to the generators" => "Page content from the source will be fetched before sending the content to the generators",
// "if set, will display 'first' and 'last' links on pages" => "if set, will display 'first' and 'last' links on pages",
// "Display \"fast-forward\" links" => "Display \"fast-forward\" links",
"Display \"fast-forward\" links (to advance 10 percent of the total number of pages) " => "Afficher des liens rapides (par tranches de 10% du nombre total de pages)",
"Hide pagination when there is only one page" => "Masquer la pagination lorsqu'il n'y a qu'une seule page",
// "Don't display pagination on single pages" => "Don't display pagination on single pages",
"Use Icons" => "Utiliser les icones",
"Display 'First' and 'Last' links" => "Afficher les 'Premier' et 'Dernier' liens",
"Require characters and numerals" => "Exiger des caractères alphanumériques",
"For improved security, require users to include a mix of alphabetical characters and numerals in passwords" => "Pour une sécurité renforcée, demander aux utilisateurs d'inclure un mélange de caractères et chiffres dans les mots de passe",
// "Password file used" => "Password file used",
// "The automatically selected file is recommended unless you generate your own blacklist file" => "The automatically selected file is recommended unless you generate your own blacklist file",
// "Prevent common passwords" => "Prevent common passwords",
// "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist" => "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist",
"Password expires after" => "Mot de passe expire après",
// "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in" => "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in",
"Require alphabetical characters in lower and upper case" => "Exiger des caractères alphabétiques en minuscules et majuscules",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords" => "Le mot de passe doit contenir au moins un caractère alphabétique en minuscule comme 'a' et un en majuscule comme 'A'",
"Require special characters" => "Exiger des caractères spéciaux",
"Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords" => "Le mot de passe doit contenir au moins un caractères spécial en minuscule comme \" / \$ % ? & * ( ) _ + ..",
"Require no consecutive repetition of the same character" => "Exiger l'absence de répétition consécutive du même caractère",
"Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"" => "Le mot de passe ne doit pas contenir de répétition du même caractère comme  111 ou aab",
"The password must be different from the user's log-in name" => "Le mot de passe doit être différent du login (pseudo) utilisateur",
"Payment" => "Paiement",
"Feature for tracking and managing payment requests" => "Fonctionalité pour la gestion et le suivi des requêtes de paiement",
// "Payment system" => "Payment system",
"Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "A l'heure actuelle, un choix entre PayPal, Cclite (en développement), ou Crédits Utilisateurs Tiki",
"PayPal: see PayPal.com - Cclite: Community currency" => "Paypal : voir le site PayPal.com - Cclite : monnaie de la communauté",
"PayPal" => "PayPal",
// "Israel Post Payment Module" => "Israel Post Payment Module",
"Cclite" => "Cclite",
"Tiki User Credits" => "Crédits utilisateurs Tiki",
// "PayPal ID" => "PayPal ID",
// "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type" => "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type",
// "Primary email of your PayPal account (Personal or Business)" => "Primary email of your PayPal account (Personal or Business)",
// "PayPal business password" => "PayPal business password",
// "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts" => "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts",
// "Primary password of your PayPal Pro business account - OPTIONAL" => "Primary password of your PayPal Pro business account - OPTIONAL",
// "Paypal business signature" => "Paypal business signature",
// "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts" => "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts",
// "Your API signature associated with your PayPal Pro business account - OPTIONAL" => "Your API signature associated with your PayPal Pro business account - OPTIONAL",
"PayPal environment" => "Environnement PayPal",
"Used to switch between the PayPal sandbox, used for testing and development and the live environment" => "Utilisé pour basculer du mode bac à sable paypal, pour les tests et développements, et le mode en ligne",
"Production" => "Production",
// "PayPal instant payment notification (IPN)" => "PayPal instant payment notification (IPN)",
"Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server" => "Activer IPN pour l'achèvement de paiement automatique. Lorsqu'elle est activée, Paypal enverra en retour un ping sur le site quand un paiement est confirmé. Le paiement sera alors automatiquement inscrit. Cela peut ne pas être possible si le serveur n'est pas sur un serveur public",
// "Payment data transfer (PDT)" => "Payment data transfer (PDT)",
// "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically" => "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically",
// "Payment data transfer (PDT) token" => "Payment data transfer (PDT) token",
// " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT" => " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT",
// "Redirect after PDT payment" => "Redirect after PDT payment",
// "Optionally, after receiving a successful payment, the user will be redirected to this page" => "Optionally, after receiving a successful payment, the user will be redirected to this page",
"Currency used when entering payments" => "Devise utilisée lors d'un paiement",
"Default acceptable payment delay" => "Délais acceptable de paiement par défaut",
"Number of days before a payment request becomes overdue. This can be changed per payment request" => "Nombre de jours avant que les demandes de paiement soient en souffrance. Ceci peut être modifié par la demande de paiement",
// "Cclite registries" => "Cclite registries",
// "Registries in Cclite" => "Registries in Cclite",
"Registry names in Cclite" => "Noms de registre dans Cclite",
// "Cclite registry currencies" => "Cclite registry currencies",
// "Currencies in Cclite" => "Currencies in Cclite",
"Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)." => "Chaque registre dans Cclite peut avoir sa propre monnaie. Elle doit être unique pour le registre. (Sensible à la casse)",
// "Cclite server URL" => "Cclite server URL",
"Full URL of the repository" => "URL complète du dépôt",
"for example, https://cclite.yourdomain.org/cclite/" => "i.e. https://cclite.yourdomain.org/cclite/",
// "Cclite merchant key" => "Cclite merchant key",
// "Corresponds with merchant key setting in Cclite" => "Corresponds with merchant key setting in Cclite",
// "Cclite merchant user" => "Cclite merchant user",
"Username in Cclite representing \"the management\"" => "Nom d'utilisateur dans Cclite représentant \"the management\". Par défaut :  \"manager\"",
// "Cclite enable payments" => "Cclite enable payments",
"Select Cclite test or live operation." => "Opération de Test ou En Ligne",
"Live" => "En ligne",
// "Hashing algorithm" => "Hashing algorithm",
"Encryption type" => "Type de cryptage",
"SHA1" => "SHA1",
"SHA256" => "SHA256",
"SHA512" => "SHA512",
// "Cclite payment notification" => "Cclite payment notification",
"To do" => "A FAIRE",
// "Wiki page with manual payment instructions" => "Wiki page with manual payment instructions",
// "Enter wiki page name" => "Enter wiki page name",
// "Invoice prefix" => "Invoice prefix",
"The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice" => "Un préfixe doit être défini et unique si le même compte Paypal est utilisé pour différents sites Tiki car Paypal vérifie que la facture ne soit pas payée deux fois",
"Types of credit to use" => "Types de credits à utiliser",
// "This is a list of the types of Tiki user credits that are acceptable for payment" => "This is a list of the types of Tiki user credits that are acceptable for payment",
"Exchange rate for types of credit to use" => "Cours de change pour les types de crédits à utiliser",
// "This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency" => "This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency",
// "User can only see own outstanding payments" => "User can only see own outstanding payments",
"Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments" => "Sauf à avoir les autorisatons d'administrateur des paiements, un utilisateur ne peut voir que ses paiements en cours",
// "User can only see own past or cancelled payments" => "User can only see own past or cancelled payments",
"Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments" => "Sauf à avoir les autorisatons d'administrateur des paiements, un utilisateur ne peut voir que ses propres paiements passés ou annulés",
// "Anonymous users can pay outstanding invoices" => "Anonymous users can pay outstanding invoices",
// "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)" => "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)",
"Manage product inventory" => "Gérer le stock de produit",
"Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "Activer la fonctionnalité gestion de stock de produit, nécessite la mise en oeuvre d'un formulaire Produits, l'ID de fiche doit être le code du produit",
// "Products tracker ID" => "Products tracker ID",
// "ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code" => "ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code",
// "Products tracker name" => "Products tracker name",
// "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code" => "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code",
// "Inventory type field ID" => "Inventory type field ID",
"In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"" => "Id du champ dans le formulaire Produits pour stocker le type d'inventaire, la valeur doit être \"non\" ou \"internal\"",
// "Inventory total field ID" => "Inventory total field ID",
"In the products tracker, the ID of the field to store the total inventory of products" => "ID du champ dans le formulaire Produits pour stocker l'inventaire total d'un produit",
// "Inventory total less hold field ID" => "Inventory total less hold field ID",
// "In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts" => "In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts",
// "Inventory hold timeout" => "Inventory hold timeout",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
"Bundled products feature for cart" => "Fonctionnalité produits packagés pour le panier d'achat",
"Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "Activer la fonction de gestion des produits packagés, nécessite la mise en oeuvre d'un formulaire Produits, l'ID de la fiche doit être le code du produit",
// "Product name field name" => "Product name field name",
// "In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle" => "In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle",
// "Items in bundle field name" => "Items in bundle field name",
// "In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product price field name" => "Product price field name",
"In the products tracker, the name of the field for the product price" => "Nom du champ dans le formulaire Produits du prix du produit",
// "Associated event ID field name" => "Associated event ID field name",
// "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with" => "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with",
// "Product class ID field name" => "Product class ID field name",
// "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature",
// "Gift certificate template field name" => "Gift certificate template field name",
// "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature",
// "Record cart orders in trackers" => "Record cart orders in trackers",
// "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording" => "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording",
// "Orders profile" => "Orders profile",
// "Wiki page containing the profile for creating orders (page name must not have spaces)" => "Wiki page containing the profile for creating orders (page name must not have spaces)",
// "Order item profile" => "Order item profile",
// "Wiki page containing the profile for creating order items (page name must not have spaces)" => "Wiki page containing the profile for creating order items (page name must not have spaces)",
// "Allow anonymous shopping" => "Allow anonymous shopping",
// "Allow shopping by anonymous users and record the orders in trackers" => "Allow shopping by anonymous users and record the orders in trackers",
// "Anonymous orders profile" => "Anonymous orders profile",
// "Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)" => "Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)",
// "Anonymous order item profile" => "Anonymous order item profile",
// "Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)" => "Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)",
// "Anonymous shopper info profile" => "Anonymous shopper info profile",
// "Anonymous users order review page" => "Anonymous users order review page",
// "Wiki page where anonymous users can review their orders" => "Wiki page where anonymous users can review their orders",
// "Temporary shopper group" => "Temporary shopper group",
// "Group name of group with permission to access review page via a token" => "Group name of group with permission to access review page via a token",
// "Enable association of product orders" => "Enable association of product orders",
"Enable association of products with events (or projects, etc.)." => "Permettre l'association de produits à des événements (ou projets, etc.)",
// "Events tracker ID" => "Events tracker ID",
// "Tracker ID of tracker that is the events tracker" => "Tracker ID of tracker that is the events tracker",
// "Events tracker name" => "Events tracker name",
// "Name of tracker that is the events tracker" => "Name of tracker that is the events tracker",
// "Event start field name" => "Event start field name",
// "Field name in events tracker of start date/time" => "Field name in events tracker of start date/time",
// "Event end field name" => "Event end field name",
// "Field name in events tracker of end date/time" => "Field name in events tracker of end date/time",
"Allow exchange of products" => "Permettre l'échange de produits",
// "Order items tracker ID" => "Order items tracker ID",
// "Tracker ID of tracker that is the order items tracker" => "Tracker ID of tracker that is the order items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift certificate tracker ID" => "Gift certificate tracker ID",
// "ID of tracker that is the gift certificate tracker" => "ID of tracker that is the gift certificate tracker",
// "Gift certificate tracker name" => "Gift certificate tracker name",
// "Name of tracker that is the gift certificate tracker" => "Name of tracker that is the gift certificate tracker",
// "Orders tracker name" => "Orders tracker name",
// "Name of tracker that is the orders tracker" => "Name of tracker that is the orders tracker",
// "Order items tracker name" => "Order items tracker name",
// "Name of tracker that is the order items tracker" => "Name of tracker that is the order items tracker",
// "Product classes tracker name" => "Product classes tracker name",
// "Name of tracker that is the product classes tracker" => "Name of tracker that is the product classes tracker",
// "Payment heading" => "Payment heading",
// "Heading displayed on payment form" => "Heading displayed on payment form",
// "Israel Post payment environment" => "Israel Post payment environment",
// "Switch between test transactions and real transactions" => "Switch between test transactions and real transactions",
// "Israel Post use pre-authorization" => "Israel Post use pre-authorization",
// "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post" => "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post",
// "Israel Post business ID" => "Israel Post business ID",
// "Provided by Israel Post, usually the business name" => "Provided by Israel Post, usually the business name",
// "Israel Post API password" => "Israel Post API password",
// "Provided by Israel Post" => "Provided by Israel Post",
"Send to URL" => "Rediriger vers l'URL",
// "URL to redirect to on \"permission denied\"" => "URL to redirect to on \"permission denied\"",
"On permission denied, display login module" => "Lors d'un accès refusé, afficher le module de login (pour les anonymes)",
// "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead" => "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead",
"PHP libxml extension" => "Extension PHP libxml",
// "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default",
"PHP DateTime" => "Date et Heure PHP",
// "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0" => "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0",
// "Number of comments to show on poll pages" => "Number of comments to show on poll pages",
// "The order in which order polls are displayed" => "The order in which order polls are displayed",
"Show categories" => "Montrer les catégories",
// "For polls that are categorized, the category is displayed" => "For polls that are categorized, the category is displayed",
"Show objects" => "Montrer les objets",
// "List wiki pages or other site objects that the poll is attached to" => "List wiki pages or other site objects that the poll is attached to",
"Multiple polls per object" => "Sondages multiples par objet",
"When used with the rating features, allow multiple polls to be attached to a single object" => "Si utilisé avec la fonctionnalité de notation, autorise que plusieurs sondages soient attachés à un seul objet",
// "Disable textarea toolbar" => "Disable textarea toolbar",
// "Don't display the toolbar on text inputs in surveys" => "Don't display the toolbar on text inputs in surveys",
// "Precision of survey results calculation" => "Precision of survey results calculation",
// "Number of decimal places in the percentage figures" => "Number of decimal places in the percentage figures",
// "decimal places" => "decimal places",
// "Set display settings for all galleries" => "Set display settings for all galleries",
"PDF from URL" => "PDF depuis une URL",
"Using external tools, generate PDF documents from URLs" => "Utilisation d'outils externes pour la génération de document PDF à partir d'URLs",
"WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "WeasyPrint" => "WeasyPrint",
// "mPDF" => "mPDF",
"Webservice URL" => "URL du Service Web",
"URL to a service that takes a URL as the query string and returns a PDF document" => "Lien ou URL à un service prenant une URL comme la chaîne de requête et qui retourne un document au format PDF",
"WebKit path" => "Chemin du WebKit",
"Full path to the wkhtmltopdf executable to generate the PDF document with" => "Chemin complet de l'exécutable qui permet de générer un document PDF",
// "WeasyPrint path" => "WeasyPrint path",
// "Full path to the weasyprint executable to generate the PDF document with" => "Full path to the weasyprint executable to generate the PDF document with",
// "Print Friendly PDF" => "Print Friendly PDF",
// "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file" => "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file",
// "PDF Orientation" => "PDF Orientation",
// "Landscape or portrait" => "Landscape or portrait",
"Portrait" => "Portrait",
"Landscape" => "Paysage",
// "PDF page size" => "PDF page size",
// "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)" => "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)",
// "Legal" => "Legal",
// "Tabloid/Ledger" => "Tabloid/Ledger",
// "A0" => "A0",
// "A1" => "A1",
// "A2" => "A2",
// "A3" => "A3",
// "A4" => "A4",
// "A5" => "A5",
// "A6" => "A6",
// "Generate auto table of contents with PDF" => "Generate auto table of contents with PDF",
// "Link TOC with content" => "Link TOC with content",
// "Link table of contents headings with content in the PDF" => "Link table of contents headings with content in the PDF",
// "TOC heading" => "TOC heading",
// "Heading to be displayed above the table of contents" => "Heading to be displayed above the table of contents",
// "PDF TOC levels" => "PDF TOC levels",
// "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3" => "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3",
// "Show Page title" => "Show Page title",
// "Print wiki page title with pdf" => "Print wiki page title with pdf",
// "PDF header text" => "PDF header text",
// "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}" => "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}",
// "HTML / Wiki Syntax / " => "HTML / Wiki Syntax / ",
// "Left text" => "Left text",
// "Center Text" => "Center Text",
// "Right Text" => "Right Text",
// "PDF footer text" => "PDF footer text",
// "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}" => "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}",
// "Left margin" => "Left margin",
// "Numeric value.For example 10" => "Numeric value.For example 10",
// "Right margin" => "Right margin",
// "Numeric value, no need to add px. For example 10" => "Numeric value, no need to add px. For example 10",
// "Top margin" => "Top margin",
// "Bottom margin" => "Bottom margin",
// "Header margin from top of document" => "Header margin from top of document",
// "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Header can overlap text if top margin is not set properly" => "Warning: Header can overlap text if top margin is not set properly",
// "Footer margin from bottom of document" => "Footer margin from bottom of document",
// "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Footer can overlap text if bottom margin is not set properly" => "Warning: Footer can overlap text if bottom margin is not set properly",
// "Hyperlink behaviour in PDF" => "Hyperlink behaviour in PDF",
// "Off (Links will be removed)" => "Off (Links will be removed)",
// "Add as footnote (Links will be listed at end of document" => "Add as footnote (Links will be listed at end of document",
// "PDF Bookmarks" => "PDF Bookmarks",
// "Automatically generate bookmarks" => "Automatically generate bookmarks",
// "H1-H6, separated by |.For example: H1|H2|H3" => "H1-H6, separated by |.For example: H1|H2|H3",
// "Number of columns" => "Number of columns",
// "Default - 1 Column" => "Default - 1 Column",
// "2 Columns" => "2 Columns",
// "3 Columns" => "3 Columns",
// "4 Columns" => "4 Columns",
// "PDF password for viewing" => "PDF password for viewing",
// "Password-protect the generated PDF" => "Password-protect the generated PDF",
// "Watermark text" => "Watermark text",
// "PDF watermark text, if any" => "PDF watermark text, if any",
// "Watermark Image URL" => "Watermark Image URL",
// "The watermark image will appear under the text. Enter the complete image URL" => "The watermark image will appear under the text. Enter the complete image URL",
// "PDF page background color" => "PDF page background color",
// "Enter a valid CSS color code" => "Enter a valid CSS color code",
// "PDF page background image" => "PDF page background image",
// "Enter the full URL" => "Enter the full URL",
// "CoverPage text settings" => "CoverPage text settings",
// "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings" => "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings",
// "Coverpage image URL" => "Coverpage image URL",
// "Print wiki authors" => "Print wiki authors",
// "Include wiki page authors and date in print versions of wiki pages" => "Include wiki page authors and date in print versions of wiki pages",
// "Print original wiki URL" => "Print original wiki URL",
// "Include original wiki page URL in print versions of wiki pages" => "Include original wiki page URL in print versions of wiki pages",
// "Print original tracker item URL" => "Print original tracker item URL",
// "Print original forum post URL" => "Print original forum post URL",
// "Include original forum post URL in print version of forum posts" => "Include original forum post URL in print version of forum posts",
"Repository URLs" => "URLs de dépôt",
"List of URLs for the profile repositories that will be used" => "Liste des URLs de dépôt des profils qui seront utilisées.",
"Enter multiple repository URLs, one per line." => "Saisir plusieurs URLs de dépôt, une par ligne.",
"Data channels" => "Canaux de données",
"Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Les canaux de données sont des modèles qui peuvent être appliqués à patir d'un requête interactive. Il peuvent être utilisés pour automatiser le travail sur des installations plus complexes",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
"There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "Il y a des considérations de sécurité relatives à l'utilisation des canaux de données. Assurez-vous que la page des profils est contrôlée uniquement par l'administrateur",
"Developer mode" => "Mode développeur",
"For profiles under an approval workflow, always use the latest version, even if not approved." => "Pour les profils sous schéma d'approbation, utiliser toujours la dernière version, même non encore approuvée",
"Make sure you review the profiles you install." => "Vérifier que vous avez relu les profils que vous installez.",
// "Automatically approve wiki-plugins on pages installed by profiles" => "Automatically approve wiki-plugins on pages installed by profiles",
// "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved" => "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved",
// "Make sure your profiles are not executable or editable by untrusted users" => "Make sure your profiles are not executable or editable by untrusted users",
"Proxy host name" => "Serveur proxy",
"Proxy host - without http:// or similar, just the host name" => "Serveur proxy - sans http:// ou assimilé, juste le nom de l'hôte",
"Proxy port" => "Port du serveur proxy",
"Proxy username" => "Utilisateur proxy",
"Proxy password" => "Mot de passe proxy",
"Quantify change size" => "Quantifier la taille de la modification",
"In addition to tracking the changes, track the change size and display approximately how up-to-date the page is" => "En plus de suivre les changements,  suivre le changement de taille et afficher l'état d'actualisation de la page",
"Advanced Rating" => "Évaluation avancée",
// "In an advanced rating system, the options and calculation method can be configured" => "In an advanced rating system, the options and calculation method can be configured",
"Rating recalculation mode" => "Mode de recalcul des notes",
"Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent" => "Détermine quand et comment les agrégats de notes sont recalculés. En fonction de la charge du site, quelques options sont préférables aux autres. Sur les sites importants, cela devrait être fait en tant que job Cron. Le recalcul sur chaque vote peut ne pas être approprié si les calculs sont coûteux en temps",
"Recalculate on vote" => "Recalculer à chaque vote",
"Randomly recalculate oldest ratings (on load)" => "Recalculer aléatoirement les plus anciennes notes (au chargement)",
"Randomly recalculate oldest ratings (on vote)" => "Recalculer aléatoirement les plus anciennes notes (au vot)",
"Cron job (must be set manually)" => "Tâche planifiée (Cron, doit être définie manuellement)",
// "Before any attempt to re-index the object" => "Before any attempt to re-index the object",
"Recalculation odds (1 in X)" => "Chances de recalcul (1 sur X)",
"Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Jet de dé exécuté à chaque requête. En cas de succès, il recalculera un certain nombre de votes",
"votes" => "votes",
"Recalculation count" => "Nombre de recalculs",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "ratings" => "ratings",
// "Smiley Ratings" => "Smiley Ratings",
// "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration" => "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration",
"Enabled" => "Activé",
// "Detailed rating results" => "Detailed rating results",
// "Displays a table with the result count and percentage per rating option" => "Displays a table with the result count and percentage per rating option",
// "Reversed Rating Options" => "Reversed Rating Options",
// "Displays the ratings options in reverse" => "Displays the ratings options in reverse",
// "Include percentages in the detailed rating results" => "Include percentages in the detailed rating results",
// "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown" => "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown",
// "Default rating options" => "Default rating options",
// "List of options available" => "List of options available",
// "Multiple votes per user" => "Multiple votes per user",
// "Allow users to vote multiple times in the same poll" => "Allow users to vote multiple times in the same poll",
"Use reCAPTCHA" => "Utilisation du reCAPTCHA",
"Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA" => "Utiliser reCAPTCHA, un service spécialisé de captcha, plutôt que le CAPTCHA par défaut",
"You will need to register at [http://www.google.com/recaptcha]" => "Vous devrez vous enregistrer à [http://www.google.com/recaptcha]",
// "Site key" => "Site key",
// "reCAPTCHA public key obtained after registering" => "reCAPTCHA public key obtained after registering",
// "Secret key" => "Secret key",
// "reCAPTCHA private key obtained after registering" => "reCAPTCHA private key obtained after registering",
// "reCAPTCHA theme" => "reCAPTCHA theme",
// "Choose a theme for the reCAPTCHA widget" => "Choose a theme for the reCAPTCHA widget",
// "Black Glass" => "Black Glass",
"Red" => "Rouge",
// "White" => "White",
// "reCAPTCHA version" => "reCAPTCHA version",
// "1.0" => "1.0",
// "2.0" => "2.0",
// "3.0" => "3.0",
"Record untranslated strings" => "Enregistrer les chaînes non traduites",
"Keep track of the unsuccessful attemps to translate strings" => "Garder une trace des essais échoués pour traduire des chaînes",
// "Redis" => "Redis",
// "Enable connection to Redis to store cache" => "Enable connection to Redis to store cache",
// "Requires PHP Redis" => "Requires PHP Redis",
// "Redis Host" => "Redis Host",
// "IP address or domain name for Redis server" => "IP address or domain name for Redis server",
// "Redis Port" => "Redis Port",
// "Port for Redis server" => "Port for Redis server",
// "Redis connection timeout" => "Redis connection timeout",
// "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited" => "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited",
// "Redis Prefix" => "Redis Prefix",
// "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none" => "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none",
// "Redis cache expiry" => "Redis cache expiry",
// "Duration for which the cache will be kept. 0 means unlimited" => "Duration for which the cache will be kept. 0 means unlimited",
// "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern" => "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern",
"Restrict supported languages" => "Restreindre la liste des langues disponibles",
"Limit the languages made available on the site" => "Limiter les langues rendues accessibles sur le site",
"Use Ctrl+Click to select multiple languages." => "Utilisez Ctrl + Clic pour sélectionner plusieurs langues.",
// "Enable SAML Auth" => "Enable SAML Auth",
// "IdP Entity Id" => "IdP Entity Id",
// "Identifier of the IdP entity (\"Issuer\")" => "Identifier of the IdP entity (\"Issuer\")",
// "Single sign-on service URL" => "Single sign-on service URL",
// "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")" => "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")",
// "Single log-out service URL" => "Single log-out service URL",
// "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")" => "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")",
// "X.509 certificate" => "X.509 certificate",
// "Public x509 certificate of the IdP.  (\"X.509 certificate\")" => "Public x509 certificate of the IdP.  (\"X.509 certificate\")",
// "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section" => "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section",
// "Sync user group with IdP data" => "Sync user group with IdP data",
// "This should be enabled to sync groups with the IdP" => "This should be enabled to sync groups with the IdP",
// "Enable Single Logout Service" => "Enable Single Logout Service",
// "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers" => "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers",
"Default group" => "Groupe par défaut",
// "When provisioning a new user and not group found, assign that group" => "When provisioning a new user and not group found, assign that group",
// "Account matcher" => "Account matcher",
// "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost" => "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost",
// "Log-in link text" => "Log-in link text",
// "The text that appears on the log-in page" => "The text that appears on the log-in page",
// "SAML attribute that will be mapped to the Tiki username" => "SAML attribute that will be mapped to the Tiki username",
// "The SAML attribute that will be mapped to the Tiki username" => "The SAML attribute that will be mapped to the Tiki username",
// "SAML attribute that will be mapped to the Tiki email" => "SAML attribute that will be mapped to the Tiki email",
// "The SAML attribute that will be mapped to the Tiki email" => "The SAML attribute that will be mapped to the Tiki email",
// "SAML attribute that will be mapped to the Tiki group" => "SAML attribute that will be mapped to the Tiki group",
// "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation" => "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation",
// "Admins" => "Admins",
// "Set here the values of the IdP related to the user group info that will be matched with the Admins group" => "Set here the values of the IdP related to the user group info that will be matched with the Admins group",
"Registered" => "Inscrit",
// "Set here the values of the IdP related to the user group info that will be matched with the Registered group" => "Set here the values of the IdP related to the user group info that will be matched with the Registered group",
// "Debug Mode" => "Debug Mode",
// "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed." => "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed.",
// "Strict Mode" => "Strict Mode",
// "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated" => "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated",
// "Service Provider Entity ID" => "Service Provider Entity ID",
// "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID" => "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID",
// "Requested NameIDFormat" => "Requested NameIDFormat",
// "Specifies constraints on the name identifier to be used to represent the requested subject" => "Specifies constraints on the name identifier to be used to represent the requested subject",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified" => "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress" => "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName" => "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:entity" => "urn:oasis:names:tc:SAML:2.0:nameid-format:entity",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:transient" => "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" => "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted" => "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos" => "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos",
// "Requested AuthnContext" => "Requested AuthnContext",
// "Authentication context: unselect all to accept any type, otherwise select the valid contexts" => "Authentication context: unselect all to accept any type, otherwise select the valid contexts",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified" => "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Password" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Password",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" => "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:X509" => "urn:oasis:names:tc:SAML:2.0:ac:classes:X509",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos",
// "urn:federation:authentication:windows" => "urn:federation:authentication:windows",
// "Enable Lowercase URL encoding" => "Enable Lowercase URL encoding",
// "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues." => "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues.",
// "Encrypt nameID" => "Encrypt nameID",
// "Sign AuthnRequest" => "Sign AuthnRequest",
// "The samlp:AuthnRequest messages sent by this SP will be signed" => "The samlp:AuthnRequest messages sent by this SP will be signed",
// "Sign LogoutRequest" => "Sign LogoutRequest",
// "The samlp:logoutRequest messages sent by this SP will be signed" => "The samlp:logoutRequest messages sent by this SP will be signed",
// "Sign LogoutResponse" => "Sign LogoutResponse",
// "The samlp:logoutResponse messages sent by this SP will be signed" => "The samlp:logoutResponse messages sent by this SP will be signed",
// "Sign Metadata" => "Sign Metadata",
// "The Metadata published by this SP will be signed" => "The Metadata published by this SP will be signed",
// "Reject Unsigned Messages" => "Reject Unsigned Messages",
// "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received" => "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received",
// "Reject Unsigned Assertions" => "Reject Unsigned Assertions",
// "Reject unsigned saml:Assertion received" => "Reject unsigned saml:Assertion received",
// "Reject Unencrypted Assertions" => "Reject Unencrypted Assertions",
// "Reject unencrypted saml:Assertion received" => "Reject unencrypted saml:Assertion received",
// "Retrieve Parameters From Server" => "Retrieve Parameters From Server",
// "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters" => "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters",
// "Service Provider X.509 certificate" => "Service Provider X.509 certificate",
// "Public x509 certificate of the SP" => "Public x509 certificate of the SP",
// "Service Provider Private Key" => "Service Provider Private Key",
// "Private key of the SP" => "Private key of the SP",
// "Signature Algorithm" => "Signature Algorithm",
// "Algorithm that the toolkit will use on the signing process" => "Algorithm that the toolkit will use on the signing process",
// "http://www.w3.org/2000/09/xmldsig#rsa-sha1" => "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
// "http://www.w3.org/2000/09/xmldsig#dsa-sha1" => "http://www.w3.org/2000/09/xmldsig#dsa-sha1",
// "Scheduler stalled after (minutes)" => "Scheduler stalled after (minutes)",
// "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection" => "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection",
// "Notify on stalled schedulers" => "Notify on stalled schedulers",
// "Send an email notification when a stalled scheduler is detected" => "Send an email notification when a stalled scheduler is detected",
// "Users to notify on stalled task" => "Users to notify on stalled task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Self healing after (minutes)" => "Self healing after (minutes)",
// "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing" => "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing",
// "Notify on healed schedulers" => "Notify on healed schedulers",
// "Send an email notification when a stalled scheduler is healed" => "Send an email notification when a stalled scheduler is healed",
// "Users to notify on healed task" => "Users to notify on healed task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Number of logs to keep" => "Number of logs to keep",
// "0 will keep all logs" => "0 will keep all logs",
// "SCORM support" => "SCORM support",
// "Handle SCORM package files on upload. SCORM is a standard used in learning management systems" => "Handle SCORM package files on upload. SCORM is a standard used in learning management systems",
// "SCORM Tracker" => "SCORM Tracker",
// "The ID number of the tracker used to store SCORM metadata" => "The ID number of the tracker used to store SCORM metadata",
"Parse search results" => "Analyser les résultats",
// "When enabled search results are parsed so content formatting is visible in the search results" => "When enabled search results are parsed so content formatting is visible in the search results",
"Default where" => "Position par défaut",
"When object filter is not on, limit to search one type of object" => "Quand le filtre d'objet n'est pas actif, limiter la recherche à un type d'objet",
"Entire site" => "Tout le site",
"Wiki Pages" => "Pages Wiki",
"Wiki pages" => "Pages Wiki",
// "Blog posts" => "Blog posts",
// "Tracker items" => "Tracker items",
"Spreadsheets" => "Tableurs",
"Restrict search language by default" => "Restreindre la langue de recherche par défaut",
// "Only search content that is in the interface language, otherwise show the language menu" => "Only search content that is in the interface language, otherwise show the language menu",
"Autocomplete page names" => "Auto-complétion sur les noms de page",
// "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc" => "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc",
// "deprecated" => "deprecated",
"Category filter" => "Filtre de catégorie",
// "Tag filter" => "Tag filter",
// "Use facets for default search interface" => "Use facets for default search interface",
// "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines" => "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines",
// "Facet result count" => "Facet result count",
// "Default number of facet results to obtain" => "Default number of facet results to obtain",
// "facet results" => "facet results",
// "Search index outdated" => "Search index outdated",
// "Number of days to consider the search index outdated" => "Number of days to consider the search index outdated",
// "Show error on missing field" => "Show error on missing field",
// "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly" => "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly",
// "File thumbnail preview" => "File thumbnail preview",
// "Have a preview of attachments in search results" => "Have a preview of attachments in search results",
// "Use date histogram aggregations" => "Use date histogram aggregations",
// "Use date histogram aggregations (facets) when indexing, requires Elasticsearch" => "Use date histogram aggregations (facets) when indexing, requires Elasticsearch",
// "Date histogram aggregations interval" => "Date histogram aggregations interval",
// "Default interval for date histogram aggregations" => "Default interval for date histogram aggregations",
// "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0" => "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0",
// "Date range aggregations ranges" => "Date range aggregations ranges",
// "Default ranges for date range aggregations" => "Default ranges for date range aggregations",
// "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0" => "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0",
// "Excluded facets" => "Excluded facets",
// "List of facets (a.k.a. aggregations) to exclude from the default search results" => "List of facets (a.k.a. aggregations) to exclude from the default search results",
// "Avoid Duplicated Facets" => "Avoid Duplicated Facets",
// "Avoid Facets appearing with the same name, usually by appending the Tracker name" => "Avoid Facets appearing with the same name, usually by appending the Tracker name",
// "Parse wiki syntax in comments" => "Parse wiki syntax in comments",
"Parse wiki syntax in comments in all sections apart from Forums" => "Interpréter la syntaxe wiki dans les commentaires pour toutes les sections à l'exception des forums",
"Use \"Accept wiki syntax\" for forums in admin forums page" => "Utiliser \"Accepter la syntaxe Wiki\" pour les forums dans la page d'administration des forums",
// "Short URL" => "Short URL",
// "Provides the ability to create a short url, easy to share" => "Provides the ability to create a short url, easy to share",
// "Short URL base URL" => "Short URL base URL",
// "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website" => "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website",
"Sender email" => "Courriel de l'expéditeur",
"Email address that will be used as the sender for outgoing emails" => "Adresse mail utilisée comme expéditeur pour les mails sortants",
// "Sender full name" => "Sender full name",
// "Real name that will be used as the sender for outgoing emails" => "Real name that will be used as the sender for outgoing emails",
"Time zone" => "Fuseau horaire",
"Indicates the default time zone to use for the server" => "Indique le fuseau horaire par défaut à utiliser pour le serveur",
"Session storage location" => "Emplacement de stockage des sessions",
"Select where the session information should be stored. Memcache sessions require memcache to be configured." => "Choisir où les informations de session doivent être stockées. Les sessions Memcache  nécessitent que Memcache soit configuré.",
"Default (from php.ini)" => "Valeur par défaut (depuis php.ini)",
"Database" => "Base de données",
"Session lifetime" => "Durée de la session",
"Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance." => "Valeur fournie en minutes. Ce sera le temps minimum de votre connexion. Si vous voulez que ce soit le temps exact, vous devez ajuster dans .htaccess session.gc_probability et session.gc_divisor à 1. Attention, changer la probabilité affectera les performances du serveur.",
"Silent session" => "Session silencieuse",
"Do not automatically start sessions" => "Ne pas démarrer automatiquement des sessions",
// "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)" => "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)",
// "Can cause problems when combined with cookie consent and JavaScript-disabled browsers" => "Can cause problems when combined with cookie consent and JavaScript-disabled browsers",
"Session cookie name" => "Nom du cookie de session",
"Session cookie name used instead of the PHP default configuration" => "Nom du cookie de session utilisé plutôt que celui par défaut de la configuration PHP.",
// "Protect all sessions with HTTPS" => "Protect all sessions with HTTPS",
"Always redirect to HTTPS to prevent a session hijack through network sniffing" => "Toujours rediriger vers HTTPS pour prévenir les vols de session au travers de l'écoute de réseau",
// "Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site" => "Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site",
"Display links on the share page" => "Afficher les liens dans la page Partager",
"Token notification" => "Notification du jeton",
"Users can subscribe to the notifications of consultation of the token." => "Les utilisateurs peuvent s'inscrire aux notifications de consultation du jeton",
"Add contact" => "Ajouter un contact",
"If not already in the list, recipients are added to the list of contacts." => "S'ils n'existent pas, les receveurs sont ajoutés à la liste des contacts",
"Display name and email" => "Afficher nom et courriel",
"If the user is connected, the name and email will display in the page." => "Si l'utilisateur est connecté, les nom et adresse courriel s'affichant dans la page",
// "Number of times accessed" => "Number of times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Maximum number of times accessed" => "Maximum number of times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "page hits" => "page hits",
// "The name of the default group" => "The name of the default group",
"Create with default group" => "Créer avec le groupe par défaut",
// "Valid affiliations" => "Valid affiliations",
// "A list of affiliations which will allow users to log in to this wiki" => "A list of affiliations which will allow users to log in to this wiki",
"Separate multiple affiliations with commas" => "Utiliser la virgule pour séparer les affiliations multiples",
"Shipping service" => "Service de Messagerie",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
"FedEx API" => "API FedEx",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
"FedEx key" => "Clef FedEx",
"Developer key" => "Clef développeur",
"FedEx password" => "Mot de passe FedEx",
// "FedEx meter number" => "FedEx meter number",
"FedEx account number" => "Numéro de compte FedEx",
"UPS API" => "API UPS",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
"UPS username" => "Nom d'utilisateur UPS",
"UPS credentials" => "Identifiants UPS",
"UPS password" => "Mot de passe UPS",
"UPS access key" => "Clef d'accès UPS",
// "Custom shipping provider" => "Custom shipping provider",
"Short date format" => "Format court pour la date",
// "Specify how Tiki displays the date (shorter version)" => "Specify how Tiki displays the date (shorter version)",
"Short time format" => "Format court pour l'heure",
// "Specify how Tiki displays the time (shorter version)" => "Specify how Tiki displays the time (shorter version)",
// "Short JavaScript date format" => "Short JavaScript date format",
// "Used in jQuery-UI date picker fields" => "Used in jQuery-UI date picker fields",
// "Short JavaScript time format" => "Short JavaScript time format",
// "Used in jQuery-UI datetime picker fields" => "Used in jQuery-UI datetime picker fields",
"%Y-%m-%d" => "%Y-%m-%d",
"%H:%M" => "%H:%M",
// "yy-mm-dd" => "yy-mm-dd",
// "HH:mm" => "HH:mm",
"%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
"Display available translations" => "Afficher les traductions disponibles",
// "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons" => "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons",
// "Close site" => "Close site",
// "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site" => "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site",
// "Coming soon" => "Coming soon",
"Message" => "Message",
// "Site is closed for maintenance; please come back later" => "Site is closed for maintenance; please come back later",
// "Server is currently too busy; please come back later" => "Server is currently too busy; please come back later",
"Locations (breadcrumbs)" => "Emplacement (fil d'ariane)",
// "Examples:  » / >  : -> →" => "Examples:  » / >  : -> →",
"Choices" => "Choix",
// "Examples: | / ¦  " => "Examples: | / ¦  ",
"Browser title position" => "Emplacement du titre des fenêtres",
// "Position of the browser title in the full browser bar relative to the current page's descriptor" => "Position of the browser title in the full browser bar relative to the current page's descriptor",
// "After current page's descriptor" => "After current page's descriptor",
// "Before current page's descriptor" => "Before current page's descriptor",
// "No browser title, only current page's descriptor" => "No browser title, only current page's descriptor",
// "Only browser title, no current page's descriptor" => "Only browser title, no current page's descriptor",
"Browser title display mode" => "Mode d'affichage du titre du navigateur",
"When breadcrumbs are used, method to display the browser title" => "Si le fil d'Ariane est utilisé, méthode par laquelle le titre du navigateur doit être affiché",
"Most-specific first" => "Le plus spécifique d'abord",
"Least-specific first (site)" => "Le moins spécifique d'abord (site)",
"Current only" => "Uniquement celui en cours",
// "Favicons" => "Favicons",
// "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used" => "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used",
"Site terminal" => "Terminaux de site",
// "Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
"Site terminal configuration" => "Configuration de terminaux de site",
"Provides the mapping from subnets to perspective." => "Fournit le routage entre sou-réseaux et perspectives.",
"One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID." => "Un par ligne. Préfixe de réseau en notation CIDR (adresse/taille du masque), séparé par une virgule de l'identifiant de la perspective.",
// "Google Analytics account number" => "Google Analytics account number",
// "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY" => "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY",
// "Google Analytics Groups Option" => "Google Analytics Groups Option",
// "Define option for Google Analytics groups" => "Define option for Google Analytics groups",
// "Included" => "Included",
// "Excluded" => "Excluded",
// "Google Analytics Available Groups" => "Google Analytics Available Groups",
// "User groups for which Google Analytics will be available" => "User groups for which Google Analytics will be available",
// "Google Global Site Tag Mode" => "Google Global Site Tag Mode",
// "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js" => "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js",
// "Google authentication credentials file" => "Google authentication credentials file",
// "Path to the Google Service Account credentials JSON file" => "Path to the Google Service Account credentials JSON file",
// "Site layout" => "Site layout",
// "Changes the template for the overall site layout" => "Changes the template for the overall site layout",
// "Admin layout" => "Admin layout",
// "Specify which layout template to use for admin pages" => "Specify which layout template to use for admin pages",
// "Enable layout per page, etc" => "Enable layout per page, etc",
// "Specify an alternate layout for a particular wiki page, etc" => "Specify an alternate layout for a particular wiki page, etc",
// "Piwik server URL" => "Piwik server URL",
// "The URL to the Piwik server of this site" => "The URL to the Piwik server of this site",
// "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL" => "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL",
// "Site Id" => "Site Id",
// "The ID of this website in Piwik" => "The ID of this website in Piwik",
// "Piwik JavaScript tracking code" => "Piwik JavaScript tracking code",
// "Piwik Groups Option" => "Piwik Groups Option",
// "Define option for Piwik groups" => "Define option for Piwik groups",
// "Piwik Available Groups" => "Piwik Available Groups",
// "User groups for which piwik will be available" => "User groups for which piwik will be available",
// "Security timeout" => "Security timeout",
// "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case" => "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case",
// "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting" => "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting",
// "Code to be placed on every page of this website just before the </body> tag" => "Code to be placed on every page of this website just before the </body> tag",
"Publish" => "Publier",
// "Make the banner visible to all site visitors" => "Make the banner visible to all site visitors",
// "Activate must be turned on for Publish to take effect" => "Activate must be turned on for Publish to take effect",
"Logo source (image path)" => "Chemin du logo du site",
"Logo background color" => "Couleur de fond du Logo",
// "A legacy option to add a background color to the div that contains the logo image" => "A legacy option to add a background color to the div that contains the logo image",
"Examples" => "Exemples",
"Logo title (on mouseover)" => "Titre du Logo (lorsque la souris est dessus)",
// "This appears as tool tip text. The site logo is also a link to the site index (top page)" => "This appears as tool tip text. The site logo is also a link to the site index (top page)",
"HTML \"alt\" tag description" => "Description Alt. (pour les navigateurs textuels)",
// "Normally a description of the image, such as \"Example.com logo\"" => "Normally a description of the image, such as \"Example.com logo\"",
// "Used by text browsers, screen readers, etc" => "Used by text browsers, screen readers, etc",
// "Site icon" => "Site icon",
// "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space" => "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space",
// "Recommended image height: 32 pixel" => "Recommended image height: 32 pixel",
// "Sitemap protocol" => "Sitemap protocol",
// "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines" => "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines",
"Include Smarty notices in the PHP error report" => "Inclure les notifications Smarty dans les rapports d'erreurs PHP",
"In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur" => "Dans la plupart des cas, les avertissements Smarty peuvent être ignorés. Cependant, ils peuvent se révéler utiles lors des phase de développement lorsque des problèmes « étranges » apparaissent",
// "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages" => "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages",
// "Smarty security" => "Smarty security",
"Do not allow PHP code in Smarty templates" => "Ne pas autoriser du code PHP dans les templates smarty",
"You should leave this on unless you know what you are doing" => "Vous devriez laisser ceci activé à moins que vous ne sachiez ce que vous faites",
// "Extra Smarty modifiers" => "Extra Smarty modifiers",
// "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates" => "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates",
// "There may be security implications. Make sure you know what you are doing" => "There may be security implications. Make sure you know what you are doing",
// "Extra Smarty functions" => "Extra Smarty functions",
// "Make additional PHP functions available as Smarty functions. This may be needed for custom templates" => "Make additional PHP functions available as Smarty functions. This may be needed for custom templates",
// "Extra Smarty directories" => "Extra Smarty directories",
// "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)" => "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)",
"Smarty compilation" => "Compilation Smarty",
"Indicates when the template cache should be refreshed." => "Indique lorsque le cache des templates doit être rafraîchi.",
"Modified" => "Modifié",
"Never check (performance)" => "Ne jamais vérifier (performance)",
"Always (development, slow)" => "Toujours (développement, lent)",
// "Smarty cache permissions" => "Smarty cache permissions",
// "Permissions that enable Smarty to write to the templates_c directory" => "Permissions that enable Smarty to write to the templates_c directory",
// "User writable (0644)" => "User writable (0644)",
// "User & group writable (0664)" => "User & group writable (0664)",
// "Social network type" => "Social network type",
// "Select how the friendship relations within the social network should be treated" => "Select how the friendship relations within the social network should be treated",
// "Follow (as in Twitter)" => "Follow (as in Twitter)",
// "Friend (as in Facebook)" => "Friend (as in Facebook)",
// "Followers need approval" => "Followers need approval",
"Consumer key" => "Clef du client",
"Consumer key generated by registering this Tiki site as an application at Twitter" => "Clé client générée par l'enregistrement de votre site en tant qu'application Twitter",
"Consumer secret" => "Code secret client",
"Consumer secret generated by registering this Tiki site as an application at Twitter" => "Code secret client généré par l'enregistrement de votre site en tant qu'application Twitter",
// "Twitter site name" => "Twitter site name",
// "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title" => "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title",
// "Twitter site image" => "Twitter site image",
// "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL" => "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL",
"Application secret" => "Code secret de l'application",
"Application secret generated by registering this Tiki site as an application at Facebook" => "Code secret de l'application générée en enregistrant votre site en tant qu'application Facebook",
"Application ID" => "ID de l'application",
"Application ID generated by registering this Tiki site as an application at Facebook" => "Identificateur de l'application générée en enregistrant votre site en tant qu'application Facebook",
// "Facebook site name" => "Facebook site name",
// "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title" => "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title",
// "Facebook site image" => "Facebook site image",
// "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices" => "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices",
"Login using Facebook" => "Connexion par Facebook",
"Allow users to log in using Facebook" => "Autoriser les utilisateurs à se connecter via Facebook",
"Auto-create Tiki user" => "Créer automatiquement des utilisateurs Tiki",
"Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Créer automatiquement un utilisateur Tiki avec comme nom utilisateur fb_xxxxxxxx pour les utilisateurs se connectant via Facebook si ils n'ont pas encore un compte Tiki. Sinon, il leur sera demandé de relier leur compte Tiki ou de s'enregistrer",
// "Require Facebook users to enter local account info on creation" => "Require Facebook users to enter local account info on creation",
"Require Facebook users to enter local account info, specifically email and local log-in name" => "demander aux utilisateurs Facebook d'entrer leurs informations de compte, spécifiquement adresse mail et nom de connexion",
// "Tiki can post to the Facebook wall" => "Tiki can post to the Facebook wall",
// "Tiki may post status messages, notes, photos, and videos to the Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to the Facebook Wall",
"Tiki can manage events" => "Tiki peut gérer les événements",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
"Tiki can manage pages" => "Tiki peut gérer les pages",
"Tiki can manage user pages." => "Tiki peut gérer les pages utilisateur",
"Tiki can SMS" => "Tiki peut utiliser les SMS",
"Tiki can use SMS functions via Facebook." => "Tiki peut envoyer des SMS via Facebook",
// "Set user email from Facebook on creation" => "Set user email from Facebook on creation",
// "Create a user tracker item on registration" => "Create a user tracker item on registration",
// "First and last name tracker field IDs to set on creation" => "First and last name tracker field IDs to set on creation",
// "bit.ly login" => "bit.ly login",
"Site-wide log-in name (username) for bit.ly" => "Nom de login (utilisateur) de site étendu pour bit.ly",
// "bit.ly key" => "bit.ly key",
"Site-wide API key for bit.ly" => "Clé API pour site étendu bit.ly",
"Use site-wide account" => "Utiliser le compte du site pour tous",
// "When set to \"yes\", only the site-wide account will be used for all users" => "When set to \"yes\", only the site-wide account will be used for all users",
// "Client ID" => "Client ID",
// "Client ID generated by registering this site as an application at LinkedIn" => "Client ID generated by registering this site as an application at LinkedIn",
// "Client secret" => "Client secret",
// "Client Secret generated by registering this site as an application at LinkedIn" => "Client Secret generated by registering this site as an application at LinkedIn",
// "Log in using LinkedIn" => "Log in using LinkedIn",
// "Allow users to log in using LinkedIn" => "Allow users to log in using LinkedIn",
// "Auto-create Tiki user from LinkedIn" => "Auto-create Tiki user from LinkedIn",
// "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Set user email from LinkedIn on creation" => "Set user email from LinkedIn on creation",
// "Tiki will set the user's email from Facebook on creation" => "Tiki will set the user's email from Facebook on creation",
// "Sets whether a tracker item should be created for the user upon registration" => "Sets whether a tracker item should be created for the user upon registration",
// "Comma-separated, with first name field followed by last name field; for example, '2,3'" => "Comma-separated, with first name field followed by last name field; for example, '2,3'",
// "Tiki will set the user's email from LinkedIn on creation" => "Tiki will set the user's email from LinkedIn on creation",
// "Stored searches" => "Stored searches",
// "Allow users to store search queries" => "Allow users to store search queries",
// "Expose Jitsi provision URL" => "Expose Jitsi provision URL",
// "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server" => "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server",
// "Jitsi configuration" => "Jitsi configuration",
// "Content of a Jitsi-format Java properties file" => "Content of a Jitsi-format Java properties file",
// "Location where tracker attachment files are stored" => "Location where tracker attachment files are stored",
// "Filesystem" => "Filesystem",
// "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory" => "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory",
// "Site theme" => "Site theme",
// "Icons of the displayed theme" => "Icons of the displayed theme",
// "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com" => "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com",
// "Site theme option" => "Site theme option",
// "Supplemental style sheet for the selected theme" => "Supplemental style sheet for the selected theme",
// "theme option, theme-option, style option, options, css" => "theme option, theme-option, style option, options, css",
// "Custom theme URL" => "Custom theme URL",
// "Local or external URL of the custom Bootstrap-compatible CSS file to use" => "Local or external URL of the custom Bootstrap-compatible CSS file to use",
// "Admin theme" => "Admin theme",
// "Theme for the settings panels and other administration pages" => "Theme for the settings panels and other administration pages",
// "Admin theme option" => "Admin theme option",
// "Option theme includes main theme CSS" => "Option theme includes main theme CSS",
// "Don't include the main theme stylesheet because its contents are included in the option stylesheet" => "Don't include the main theme stylesheet because its contents are included in the option stylesheet",
// "Navbar background color" => "Navbar background color",
// "Dark" => "Dark",
// "Light" => "Light",
// "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme" => "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme",
// "Fixed topbar offset" => "Fixed topbar offset",
// "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content" => "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content",
// "topbar offset, top offset, fixed topbar, top padding, offset" => "topbar offset, top offset, fixed topbar, top padding, offset",
"Icons" => "Icônes",
// "Icon set used by the site" => "Icon set used by the site",
// "Theme Customizer tool" => "Theme Customizer tool",
// "Activate the theme customizer tool to enable easy theme customization" => "Activate the theme customizer tool to enable easy theme customization",
"Check frequency" => "Fréquence des contrôles",
// "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. " => "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. ",
// "Click \"Check for Updates Now\" to perform an update check" => "Click \"Check for Updates Now\" to perform an update check",
"Each day" => "Chaque jour",
"Each week" => "Chaque semaine",
"Each month" => "Chaque mois",
// "Upgrade cycle" => "Upgrade cycle",
// "Tiki upgrade frequency for this site to check against" => "Tiki upgrade frequency for this site to check against",
// "Regular (8 months)" => "Regular (8 months)",
// "Long-Term Support" => "Long-Term Support",
"Minify JavaScript" => "Compresser JavaScript",
"Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compresser les fichiers JavaScript utilisés dans la page en un seul fichier à distribuer statiquement. Les modifications de ces fichiers nécessitent de vider le cache. Utilise http://code.google.com/p/minify/",
// "Minify late JavaScript" => "Minify late JavaScript",
// "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page" => "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page",
"Minify CSS" => "Compresser le code CSS",
// "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared" => "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared",
// "Uses http://code.google.com/p/minify/" => "Uses http://code.google.com/p/minify/",
"Minify CSS into a single file" => "Minifier les CSS dans un fichier unique",
"In addition to reducing the size of the CSS files, reduce the number of files by consolidating them" => "En plus de réduire la taille des CSS, réduire le nombre de fichiers inclus",
"This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"" => "Cette fonctionnalité peut ne pas marcher telle quelle pour tous les styles. L'import nécessite d'utiliser @import url(\"...\") et non @import \"...\"",
// "Prefix CSS" => "Prefix CSS",
// "Use -prefix-free JavaScript library to add vendor specific css prefixes" => "Use -prefix-free JavaScript library to add vendor specific css prefixes",
// "May be replaced by a server-side option soon" => "May be replaced by a server-side option soon",
"Skip date for same day" => "Ne pas afficher la date pour le jour même",
"When displaying short date and time, skip date for today. Only time will be displayed" => "Lors de l'affichage court des dates et des heures, sauter la date du jour. Seule l'heure sera affichée",
"Cache-control header" => "En-tête Cache-Control",
"Custom HTTP header to use when a session is active" => "En-tête HTTP personnalisée lorsqu'une session est active",
"Example: no-cache, pre-check=0, post-check=0" => "Exemple: no-cache, pre-check=0, post-check=0",
"Cache-control header (no session)" => "En-tête Cache-Control (sans session)",
"Custom HTTP header to use when no session is active" => "En-tête HTTP personnalisée lorsqu'il n'y a pas de session",
// "Content delivery networks" => "Content delivery networks",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance",
// "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com",
// "Content delivery networks in SSL" => "Content delivery networks in SSL",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode",
// "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com",
// "Check CDN files exists" => "Check CDN files exists",
// "Check that minified JS and CSS files exist before including them in the page" => "Check that minified JS and CSS files exist before including them in the page",
"Domain prefix handling" => "Gestion de préfixe de domaine",
"Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Supprimer ou ajouter automatiquement le préfixe « www. » aux noms de domaine afin d'uniformiser les URLs",
"Leave as-is" => "Laisser tel-quel",
"Remove the www" => "Supprimer le www",
"Add the www" => "Ajouter le www",
"Domain redirects" => "Redirection de domaines",
"When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org." => "Lorsque le site est atteint via des noms domaines spécifiques, on redirige le visiteur vers un nom de domaine alternatif en préservent l'URL. Ceci est particulièrement utile lors de transition de noms de domaines comme tikiwiki.org vers tiki.org.",
"One entry per line, with each entry a comma-separated list: old domain, new domain" => "Une entrée par ligne, soit la forme : ancien, nouveau",
"Validate uploaded file content" => "Valider le contenu des fichiers envoyés",
"Do not trust user input and open the files to verify their content" => "Ne pas faire confiance à l'entrée utilisateur et ouvrir les fichiers pour vérifier leur contenu",
// "Allow the tiki_p_trust_input permission" => "Allow the tiki_p_trust_input permission",
// "Bypass user input filtering" => "Bypass user input filtering",
// "Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
// "Object selector threshold" => "Object selector threshold",
// "Number of records after which the object selectors will request searching instead of selecting from a list" => "Number of records after which the object selectors will request searching instead of selecting from a list",
// "Object selector search field" => "Object selector search field",
// "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")" => "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")",
// "Client key for this site" => "Client key for this site",
// "This must match the shared key entered in the Master’s key field" => "This must match the shared key entered in the Master’s key field",
// "Synchronize remote tracker" => "Synchronize remote tracker",
"Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand" => "Permet de cloner un formulaire sur un hôte distant et de synchroniser les données localement sur demande",
// "Refresh item link items when the master is modified" => "Refresh item link items when the master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Refresh items list items when related items are created or modified" => "Refresh items list items when related items are created or modified",
// "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified" => "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified",
// "Clone tracker items" => "Clone tracker items",
// "Allow copying tracker item information to a new tracker item" => "Allow copying tracker item information to a new tracker item",
// "Trackers available for insertion from wiki pages" => "Trackers available for insertion from wiki pages",
// "List of tracker IDs made available when attempting to insert" => "List of tracker IDs made available when attempting to insert",
// "Change field types" => "Change field types",
// "Allow field type to be changed after creation" => "Allow field type to be changed after creation",
// "Use with care" => "Use with care",
// "Show comments below items" => "Show comments below items",
// "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab" => "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab",
// "Use legacy tracker insertion screen" => "Use legacy tracker insertion screen",
// "Use the legacy tracker insertion screen (a tab) instead of a popup dialog" => "Use the legacy tracker insertion screen (a tab) instead of a popup dialog",
// "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful" => "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful",
// "Show tracker status in objectlink" => "Show tracker status in objectlink",
// "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs" => "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs",
// "Sync wiki page name to linked tracker field" => "Sync wiki page name to linked tracker field",
// "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation" => "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation",
// "Redirect page views to the linked tracker item" => "Redirect page views to the linked tracker item",
// "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL" => "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL",
// "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL" => "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL",
// "Tracker for articles" => "Tracker for articles",
// "Have a tracker to supplement article information" => "Have a tracker to supplement article information",
// "Tracker ID of tracker for articles" => "Tracker ID of tracker for articles",
// "A tracker for articles must contain an \"Articles\" field" => "A tracker for articles must contain an \"Articles\" field",
// "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items" => "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items",
// "Tracker tabular" => "Tracker tabular",
// "Allows management of import/export tracker profiles and management of custom list formats" => "Allows management of import/export tracker profiles and management of custom list formats",
// "Always notify watchers" => "Always notify watchers",
// "Send item updated notifications to watchers even if nothing has changed" => "Send item updated notifications to watchers even if nothing has changed",
// "Require users to fill in tracker information" => "Require users to fill in tracker information",
// "Tracker ID of tracker required to be filled in" => "Tracker ID of tracker required to be filled in",
// "Mandatory tracker field to check for required filling in" => "Mandatory tracker field to check for required filling in",
// "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it" => "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it",
// "Fields that are asked for in the modal for force-filling" => "Fields that are asked for in the modal for force-filling",
// "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested" => "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested",
// "Tracker item links use prefix alias" => "Tracker item links use prefix alias",
// "Links for tracker items will use the prefix alias automatically everywhere" => "Links for tracker items will use the prefix alias automatically everywhere",
// "Tracker report resize button" => "Tracker report resize button",
// "Add a button to resize long tracker reports" => "Add a button to resize long tracker reports",
// "Tracker list order" => "Tracker list order",
// "Default order for the main tracker list" => "Default order for the main tracker list",
// "Id Ascending" => "Id Ascending",
// "Id Descending" => "Id Descending",
"Created Ascending" => "Ordre croissant de date de création",
"Created Descending" => "Ordre décroissant de date de création",
"Name Ascending" => "Ordre croissant de nom",
"Name Descending" => "Ordre décroissant de nom",
// "Last Modified Ascending" => "Last Modified Ascending",
// "Last Modified Descending" => "Last Modified Descending",
// "Number of Items Ascending" => "Number of Items Ascending",
// "Number of Items Descending" => "Number of Items Descending",
// "Tracker History Diff Style" => "Tracker History Diff Style",
// "Default style for tracker history" => "Default style for tracker history",
"Original" => "Original",
// "Index article info in tracker item" => "Index article info in tracker item",
// "Require users to fill in a tracker form if not done already by prompting them with a modal dialog" => "Require users to fill in a tracker form if not done already by prompting them with a modal dialog",
// "Storage settings when file galleries are not used" => "Storage settings when file galleries are not used",
"Unified search engine" => "Moteur de recherche unifiée",
// "Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP implementation) - Deprecated" => "Lucene (PHP implementation) - Deprecated",
// "Elasticsearch" => "Elasticsearch",
"Lucene index location" => "Emplacement de l'index Lucene",
"Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Chemin vers l'emplacement de l'index de recherche Lucene. L'index doit être dans un système de fichiers local avec suffisamment d'espace pour contenir le volume de la base de données",
"Highlight results snippets" => "Mettre en évidence la recherche dans le résultat",
"Highlight the result snippet based on the search query to improve user experience" => "Mettre en évidence la recherche dans le résultat de la requête. Activer cette option affectera la performance, mais améliorera l'expérience de l'utilisateur",
// "Lucene maximum results" => "Lucene maximum results",
// "Maximum number of results to produce. Results beyond these will need a more refined query to be reached" => "Maximum number of results to produce. Results beyond these will need a more refined query to be reached",
// "results" => "results",
// "Lucene maximum result-set limit" => "Lucene maximum result-set limit",
// "Maximum size of result set to consider" => "Maximum size of result set to consider",
// "This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "result sets" => "result sets",
// "Lucene terms per query limit" => "Lucene terms per query limit",
// "Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "terms" => "terms",
// "Lucene maximum number of buffered documents" => "Lucene maximum number of buffered documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "documents" => "documents",
// "Lucene maximum number of merge documents" => "Lucene maximum number of merge documents",
// "Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "merge documents" => "merge documents",
// "Default Boolean Operator" => "Default Boolean Operator",
// "Use OR or AND as the default search operator" => "Use OR or AND as the default search operator",
// "AND" => "AND",
// "OR" => "OR",
// "Lucene merge factor" => "Lucene merge factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster",
// "Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained" => "Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained",
"Incremental Index Update" => "Mise à jour incrémentielle de l'index",
"Update the index incrementally as the site content is modified" => "Mettre à jour de façon incrémentale l'index au fur et à mesure que le site est modifié. Ceci peut conduire à de moindres performance et exactitude, que de traiter l'index sur une base périodique",
// "This may lead to lower performance and accuracy than processing the index on a periodic basis" => "This may lead to lower performance and accuracy than processing the index on a periodic basis",
"Field weights" => "Pondération des champs",
"Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results" => "Permet de définir le poids des champs qui s'appliquent lors du classement des pages dans les résultats des recherches. Le poids ne s'applique que lorsque le champ est dans la requête. Pour annuler la valeur d'un champ, utilisez un montant insignifiant, et non 0, ce qui peut conduire à des comportements inattendus, tels que élaguer les résultats",
// "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search" => "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search",
"One field per line, field_name__:__5.3" => "Un champ par ligne, nom_champ__:__5.3",
"Default content fields" => "Champs de contenu par défaut",
"All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search" => "Tous les contenus sont agrégés dans le domaine de contenu. Pour la pondération personnalisée à appliquer, les champs doivent être inclus dans la requête. Cette option permet d'inclure d'autres champs dans la recherche de contenu par défaut",
"Tokenize version numbers" => "Analyser la syntaxe des numéros de version",
"Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Analyser la syntaxe des numéros de version pour que les versions majeures soient trouvées lorsque des versions mineures sont mentionées. Par exemple, rechercher 2.7 retournera 2.7.4 et pas 1.2.7",
// "Cache per user and query for Tiki built-in search" => "Cache per user and query for Tiki built-in search",
// "Time in minutes a user has a same query cached applied to Tiki built-in search interface only" => "Time in minutes a user has a same query cached applied to Tiki built-in search interface only",
// "Index forum replies together with initial post" => "Index forum replies together with initial post",
// "Forum replies will be indexed together with the initial post as a single document instead of being indexed separately" => "Forum replies will be indexed together with the initial post as a single document instead of being indexed separately",
// "Relation types to index within object" => "Relation types to index within object",
// "Comma-separated relation types for which objects should be indexed in their related objects" => "Comma-separated relation types for which objects should be indexed in their related objects",
// "Elasticsearch needed" => "Elasticsearch needed",
// "Cache individual search formatters" => "Cache individual search formatters",
// "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache" => "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache",
// "Format to use for tracker field keys" => "Format to use for tracker field keys",
// "Choose between field IDs and permanent names for the tracker indexing" => "Choose between field IDs and permanent names for the tracker indexing",
"Permanent name" => "Nom permanent",
// "Field ID (backward compatibility mode with Tiki 7 and 8)" => "Field ID (backward compatibility mode with Tiki 7 and 8)",
// "Index Tracker Category names" => "Index Tracker Category names",
// "Index the names and paths of category field values" => "Index the names and paths of category field values",
// "Requires reindexing" => "Requires reindexing",
// "Cache result-specific formatted results" => "Cache result-specific formatted results",
// "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific" => "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific",
// "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature" => "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature",
// "Excluded categories" => "Excluded categories",
// "List of category IDs to exclude from the search index" => "List of category IDs to exclude from the search index",
// "Excluded plugins" => "Excluded plugins",
// "List of plugin names to exclude while indexing" => "List of plugin names to exclude while indexing",
// "Exclude all plugins" => "Exclude all plugins",
// "Indexing will exclude all plugins" => "Indexing will exclude all plugins",
// "Except included plugins" => "Except included plugins",
// "List of plugin names that are required to be included while indexing, when excluding all" => "List of plugin names that are required to be included while indexing, when excluding all",
// "Example: fancytable,list,trackerlist,trackerfilter" => "Example: fancytable,list,trackerlist,trackerfilter",
// "Elasticsearch URL" => "Elasticsearch URL",
// "URL of any node in the cluster" => "URL of any node in the cluster",
// "Elasticsearch index prefix" => "Elasticsearch index prefix",
// "The prefix that is used for all indexes for this installation in Elasticsearch" => "The prefix that is used for all indexes for this installation in Elasticsearch",
// "Elasticsearch current index" => "Elasticsearch current index",
// "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index" => "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index",
// "Do not change this value unless you know what you are doing" => "Do not change this value unless you know what you are doing",
// "Tokenize CamelCase words" => "Tokenize CamelCase words",
// "Consider the components of camel-case words as separate tokens, allowing them to be searched individually" => "Consider the components of camel-case words as separate tokens, allowing them to be searched individually",
// "Conflicts with Tokenize Version Numbers" => "Conflicts with Tokenize Version Numbers",
// "Elasticsearch field limit per index" => "Elasticsearch field limit per index",
// "fields" => "fields",
// "The maximum number of fields per search index in Elasticsearch version 5.x and above" => "The maximum number of fields per search index in Elasticsearch version 5.x and above",
// "Use MySQL Full-Text Search (fallback)" => "Use MySQL Full-Text Search (fallback)",
// "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback" => "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback",
// "MySQL full-text search current index" => "MySQL full-text search current index",
// "Unified index identifier fields (Internal)" => "Unified index identifier fields (Internal)",
// "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding" => "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding",
// "Use unified search in category admin" => "Use unified search in category admin",
// "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index" => "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index",
// "Stop Word List" => "Stop Word List",
// "Words excluded from the search index, because they can be too frequent and produce unwanted results" => "Words excluded from the search index, because they can be too frequent and produce unwanted results",
// "MySQL full-text search has its own list of stop words configured in the server" => "MySQL full-text search has its own list of stop words configured in the server",
// "Automatically trim Elasticsearch results on date-sorted query" => "Automatically trim Elasticsearch results on date-sorted query",
// "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date" => "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date",
// "Highlight results pages" => "Highlight results pages",
// "Highlight words on the result pages based on the search query" => "Highlight words on the result pages based on the search query",
// "Plugins tab of the textarea control panel loads with an empty list" => "Plugins tab of the textarea control panel loads with an empty list",
// "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially" => "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially",
// "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")" => "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")",
// "Possessive Stemmer" => "Possessive Stemmer",
// "LIST plugin cache default on" => "LIST plugin cache default on",
// "If selected, LIST plugins will be cached by default unless turned off at plugin level" => "If selected, LIST plugins will be cached by default unless turned off at plugin level",
// "LIST plugin cache default expiry" => "LIST plugin cache default expiry",
// "Default number of minutes for LIST plugin cache expiry" => "Default number of minutes for LIST plugin cache expiry",
// "The possessive stemmer removes possessives (trailing \"'s\\" => "The possessive stemmer removes possessives (trailing \"'s\\",
"Re-validate user by email after" => "Demander aux utilisateurs de se confirmer par courrier électronique après",
"unsuccessful login attempts" => "logins non réussis",
// "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password" => "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password",
// "brute force, brute-force, login failure, login-failure, failed logins" => "brute force, brute-force, login failure, login-failure, failed logins",
"Suspend account after" => "Suspendre le compte après",
// "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again",
"URL the user is redirected to after account validation" => "L’URL où l’utilisateur est redirigé après la validation du compte",
// "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"" => "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"",
"Account validated successfully." => "Compte validé avec succès.",
"The URL that the anonymous user is redirected to when a page is not found" => "L’URL où l’utilisateur anonyme est redirigé quand une page n'est pas trouvée",
// "Use Only ASCII in SEFURLs" => "Use Only ASCII in SEFURLs",
// "Do not use accented characters in short (search engine friendly) URLs" => "Do not use accented characters in short (search engine friendly) URLs",
// "Close site when server load is above the threshold" => "Close site when server load is above the threshold",
"Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site" => "Fermer le site si la charge du serveur dépasse le seuil (sauf pour les utilisateurs ayant les permissions)",
"Use proxy" => "Utiliser un serveur proxy",
"Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified" => "Utiliser un serveur proxy",
"Use context menus for actions (icons)" => "Utiliser des menus contextuels pour les actions (icônes)",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
"Use context menus for actions (text)" => "Utiliser du texte pour les actions des menus contextuels",
// "Show user's real name" => "Show user's real name",
"Show the user's real name instead of username (log-in name), when possible." => "Afficher le nom de l'utilisateur au lieu de son login (lorsque c'est possible)",
// "User emails must be unique" => "User emails must be unique",
// "The email address of each user must be unique" => "The email address of each user must be unique",
"Display user tracker information on the user information page" => "Afficher les informations de formulaire utilisateur sur la page d'information d'utilisateur",
"Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Indiquer l'identifiant du formulaire utilisateur puis les champs à afficher, séparés par des virgules. Exemple : 1,1,2,3,4 (Formulaire 1 suivi des champs 1 à 4)",
"Users can configure modules" => "Les utilisateurs peuvent configurer les modules",
// "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user" => "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user",
"Users can open and close the modules" => "Les utilisateurs peuvent masquer les modules",
"Allows users to open and close modules using the icon in the module header" => "Permet aux utilisateurs d'afficher/cacher les modules",
"Module decides" => "Le module décide",
"Store full-size copy of profile picture in file gallery" => "Sauvegarder une version grandeur nature de l'avatar dans la galerie de fichier",
// "Size of the small profile picture stored for users" => "Size of the small profile picture stored for users",
// "Crop the profile picture thumbnail to a square" => "Crop the profile picture thumbnail to a square",
"File gallery in which to store full-size profile picture" => "Galerie de fichier pour stocker les avatars",
"Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Entrer l'identifiant de la galerie ici. Merci de créer une galerie dédiée qui soit réservée à l'administrateur seulement pour la sécurité, ou soyez sûr que les permissions de la galerie permettent seulement aux administrateurs les modifications",
"File ID of default profile picture" => "ID de fichier de l'image d'avatar par défaut",
// "File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries" => "File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries",
"Display who has viewed \"my items\" on the user information page" => "Afficher qui a consulté mon profil dans la page d'information de l'utilisateur",
// "This requires activation of tracking of views for various items in the action log" => "This requires activation of tracking of views for various items in the action log",
// "Length of \"who viewed my items\" history" => "Length of \"who viewed my items\" history",
// "Number of days before the current day to consider when displaying \"who viewed my items\"" => "Number of days before the current day to consider when displaying \"who viewed my items\"",
"Show to others \"who viewed my items\" on the user information page" => "Montrer aux autres qui a vu mes affaires sur ma page d'information",
"Show to others \"who viewed my items\" on the user information page. Admins can always see this information" => "Montrer aux autres qui a vu mon activité sur la page d'information utilisateur. Les administrateurs peuvent toujours voir cette information",
"Use pretty trackers for registration form" => "Utiliser des formulaires améliorés pour le formulaire d'enregistrement",
"Registration pretty tracker template" => "Gabarit du formulaire amélioré d'enregistrement",
"Use a wiki page name or Smarty template file with a .tpl extension." => "Utiliser un nom de page wiki ou un fichier gabarit avec l'extension .tpl",
// "Hide Mandatory" => "Hide Mandatory",
// "Hide mandatory fields indication with an asterisk (shown by default)" => "Hide mandatory fields indication with an asterisk (shown by default)",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name field ID" => "Page name field ID",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Select one or more trackers to sync user preferences from" => "Select one or more trackers to sync user preferences from",
// "Tracker field IDs to sync the \"real name\" pref from" => "Tracker field IDs to sync the \"real name\" pref from",
// "Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"" => "Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"",
// "Tracker field IDs to sync user groups" => "Tracker field IDs to sync user groups",
// "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups" => "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation preferences with the main location field" => "Synchronize user geolocation preferences with the main location field",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Assign a user tracker item when registering if email equals this field" => "Assign a user tracker item when registering if email equals this field",
// "Maximum users in drop-down lists" => "Maximum users in drop-down lists",
"Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large." => "Évite les débordement de mémoire et les pertes de performances lorsque la liste des utilisateurs est très grande par l'utilisation d'une boite de sélection automatique.",
"users" => "utilisateurs",
// "Use the user's real name instead of log-in name in the autocomplete selector in trackers" => "Use the user's real name instead of log-in name in the autocomplete selector in trackers",
"Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature." => "Utiliser le nom réel de l'utilisateur plutôt que son identifiant dans le sélecteur d'auto-complétion dans la messagerie",
// "User favorites" => "User favorites",
"Enable users to flag content as their favorite" => "Autorise les utilisateurs à marquer du contenu comme leur favori",
// "User likes" => "User likes",
// "Enable users to \"like\" content" => "Enable users to \"like\" content",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups indicated above" => "Users cannot register without choosing one of the groups indicated above",
// "Users available in search results" => "Users available in search results",
// "Users available within search results. Content related to the user will be included in the index" => "Users available within search results. Content related to the user will be included in the index",
"Public" => "Public",
// "Use Gravatar for user profile pictures" => "Use Gravatar for user profile pictures",
// "Always request the Gravatar image for the user profile picture" => "Always request the Gravatar image for the user profile picture",
// "Configuration for multilike" => "Configuration for multilike",
// "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)" => "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)",
// "Force users to upload an avatar" => "Force users to upload an avatar",
"Score ascending" => "Score croissant",
"Score descending" => "Score décroissant",
"Name ascending" => "Ordre croissant de noms",
"Name descending" => "Ordre décroissant de noms",
"Login ascending" => "Login croissant",
"Login descending" => "Login décroissant",
// "User the tracker's field ID whose value is used as the output page name" => "User the tracker's field ID whose value is used as the output page name",
// "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup" => "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup",
"Quota" => "Quota",
"Private" => "Privé",
// "Users cannot see each other's files or galleries" => "Users cannot see each other's files or galleries",
// "Users can see each other's files, but don't see the galleries in listings" => "Users can see each other's files, but don't see the galleries in listings",
"Username pattern" => "Patron du nom d'utilisateur",
// "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/" => "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/",
"Serve profile pictures statically" => "Servir les images des avatars statiquement",
"When enabled, feature checks and permission checks will be skipped" => "Si activé, les vérifications de fonctionnalités et d'autorisations seront ignorées",
"Displayed time zone" => "Fuseau horaire affiché",
"Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback." => "Utiliser le fuseau horaire attribué dans les préférences de l’utilisateur ou le fuseau horaire automatiquement détecté pour les utilisateurs anonymes (si le fureteur le permet). En dernier recours, utiliser la préférence par défaut du site.",
"Always the site default time zone." => "Toujours le fuseau horaire par défaut.",
"Number of visited pages to remember" => "Nombre de pages visitées à conserver",
// "visited pages" => "visited pages",
"User information" => "Information utilisateur",
// "Specify if the user's information is public or private" => "Specify if the user's information is public or private",
"Use 12-hour clock for time selectors" => "Utiliser le format 12 heures pour les sélecteurs horaires",
// "Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc",
// "Use interface that shows differences in any versions" => "Use interface that shows differences in any versions",
"Tasks per page" => "Tâches par page",
// "tasks" => "tasks",
"Messages per page" => "Messages par page",
"Allow messages from other users" => "Autoriser des messages d'autres utilisateurs",
"Notify sender when reading mail" => "Notifier l'expéditeur lors de la lecture de l'email",
"Send me an email for messages with priority equal to or greater than" => "Envoyez-moi un email pour les messages de priorité égale ou supérieure à",
// "priority" => "priority",
"Auto-archive read messages after" => "Auto-archivage des messages lus après",
// "The number of days after which Tiki will archive the messages that have been read by the user" => "The number of days after which Tiki will archive the messages that have been read by the user",
"My pages" => "Mes pages",
// "List all wiki pages edited by the user" => "List all wiki pages edited by the user",
"My blogs" => "Mes blogues",
// "List all blogs and blog posts edited by the user" => "List all blogs and blog posts edited by the user",
"My galleries" => "Mes galeries",
// "List all galleries edited by the user" => "List all galleries edited by the user",
"My messages" => "Mes messages",
// "List all messages and replies by the user" => "List all messages and replies by the user",
"My tasks" => "Mes tâches",
// "List all tasks by the user" => "List all tasks by the user",
"My forum topics" => "Mes sujets dans le forum",
// "List all forum topics by the user" => "List all forum topics by the user",
"My forum replies" => "Mes réponses dans le forum",
// "List all forum replies by the user" => "List all forum replies by the user",
"My items" => "Mes fiches",
// "List all tracker items by the user" => "List all tracker items by the user",
"Character set for mail" => "Encodage des emails",
// "Keep closed remarksbox hidden" => "Keep closed remarksbox hidden",
// "XMPP account JID or username" => "XMPP account JID or username",
// "XMPP account password" => "XMPP account password",
// "XMPP http-bind URL" => "XMPP http-bind URL",
// "Full URL to the http-bind" => "Full URL to the http-bind",
// "https://xmpp.example.org/http-bind/" => "https://xmpp.example.org/http-bind/",
// "Pre-set show user's info on mouseover" => "Pre-set show user's info on mouseover",
// "Set new users' info to display in a popup when their name is hovered over" => "Set new users' info to display in a popup when their name is hovered over",
// "Remember the alert boxes that users have closed and don't display them again" => "Remember the alert boxes that users have closed and don't display them again",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Vimeo upload" => "Vimeo upload",
// "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API" => "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API",
// "Vimeo delete" => "Vimeo delete",
// "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted" => "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted",
// "Permanently removes videos from the registered vimeo.com account" => "Permanently removes videos from the registered vimeo.com account",
// "Vimeo consumer key" => "Vimeo consumer key",
// "API consumer key" => "API consumer key",
// "Vimeo consumer secret" => "Vimeo consumer secret",
// "API consumer secret" => "API consumer secret",
// "Vimeo access token" => "Vimeo access token",
// "The access token that is automatically generated by Vimeo when API keys are requested" => "The access token that is automatically generated by Vimeo when API keys are requested",
// "Vimeo access token secret" => "Vimeo access token secret",
// "The access token secret automatically generated by Vimeo when API keys are requested" => "The access token secret automatically generated by Vimeo when API keys are requested",
// "Vimeo Default Gallery" => "Vimeo Default Gallery",
// "The The ID of the default file gallery in which to store the Vimeo reference" => "The The ID of the default file gallery in which to store the Vimeo reference",
"Display by default" => "Afficher par défaut",
"Path (if stored in directory)" => "Chemin (si stocker dans un répertoire)",
"Edit idle timeout" => "Modifier le timeout d'inactivité",
// "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains" => "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains",
// "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually" => "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually",
// "How to trigger Web Cron" => "How to trigger Web Cron",
// "Calling the Web Cron URL" => "Calling the Web Cron URL",
// "Adding JavaScript that calls Web Cron" => "Adding JavaScript that calls Web Cron",
// "URL and JavaScript" => "URL and JavaScript",
// "Run interval" => "Run interval",
// "The amount of time of each run" => "The amount of time of each run",
"Token" => "Jeton",
// "The token to use when running the cron manually" => "The token to use when running the cron manually",
// "Default cache" => "Default cache",
// "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response" => "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response",
// "Last Modified" => "Last Modified",
"Last editor" => "Dernier éditeur",
"Wiki link format" => "Format d'un lien Wiki",
"Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))" => "Quel niveau de caractères spéciaux sont acceptés en liens wiki pour les noms de page. Ex. : ((Page &eacute;&agrave;&icirc;))",
"\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"" => "Strict utilisera les caractères simples comme a-z et 0-9. Si vous avez des caractères accentués ou spéciaux dans les noms de page, n'utilisez pas le mode Strict",
"Complete" => "Complet",
"Relaxed" => "Relaché",
"Strict" => "Strict",
// "Wiki URL scheme" => "Wiki URL scheme",
// "Alter the SEFURL pattern for page names" => "Alter the SEFURL pattern for page names",
// "Use the \"View\" action to regenerate your URLs after changing this setting" => "Use the \"View\" action to regenerate your URLs after changing this setting",
// "Show the page version" => "Show the page version",
"Display the page version information when viewing the page" => "Afficher les informations liées à la version de la page lorsque la page est affichée",
// "Display the page name above the page area" => "Display the page name above the page area",
"Display the page name in small text at the top of each page (above the page's content)." => "Afficher le nom de la page au-dessus de la page et non dans la page",
// "Display the page name inside the page content" => "Display the page name inside the page content",
"Page name display stripper" => "Caractère de fin d'affichage des noms de pages",
// "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
"Wiki author list style" => "Style de liste d'auteurs Wiki",
// "Change the list format that is used to display the authors of the page" => "Change the list format that is used to display the authors of the page",
"Creator and Author" => "Créateur & Auteur",
"Business style" => "Style affaire",
"Collaborative style" => "Style collaboratif",
"Page last modified on" => "Dernière modification de la page :",
"none (disabled)" => "aucun (désactivé)",
"Specify wiki author list style per page" => "Spécifier le style de liste d'auteurs par page",
"Enable the style in which the author list is displayed to be modified on a per-page basis" => "Permet la modification du style avec lequel la liste d'auteur sera affichée sur une base page par page",
"Wiki page edit buttons location" => "Emplacement de la barre d'actions Wiki",
"Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page" => "Boutons: Sauvegarder, Aperçu, Annuler, ..",
"Wiki navigation bar location" => "Emplacement de la barre Wiki de navigation",
"When using the ...page... page break wiki syntax" => "Utile lors de l'utilisation de saut de page (\"...page...\" en wiki syntax)",
"Wiki top line location" => "Position de la ligne du haut Wiki",
// "Page description, page actions, icons, backlinks..." => "Page description, page actions, icons, backlinks...",
// "Display ShareThis icon prominently" => "Display ShareThis icon prominently",
// "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)" => "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)",
"Cache wiki pages (global)" => "Antémémoire globale à toutes les pages Wiki",
"Enable page cache globally for wiki pages" => "Activer le cache global pour les pages wiki",
"no cache" => "pas de cache",
"Allow comments per wiki page" => "Autoriser les commentaires par page wiki",
"Enable control of comments on wiki pages on a per-page basis." => "Activer le contrôle des commentaires sur les pages wiki individuellement",
"Enable (default On)" => "Activer (défaut On)",
"Enable (default Off)" => "Activer (défaut Off)",
// "Wiki copyright" => "Wiki copyright",
"Prevent special characters in page names" => "Empêcher les caractères spéciaux dans le nom des pages",
"Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters" => "Certains caractères peuvent empêcher les pages d'être facilement accessibles depuis une URL ou par des liens wiki. Cette option empêche de créer des pages avec de tels caractères",
"Page ranking reload probability" => "Probabilité de recalcul du score de la page",
"Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking" => "Le calcul du classement des pages est une opération coûteuse en temps qui ne peut être effectuée à chaque chargement de page. Le classement sera calculé sur des chargements de pages choisis aléatoirement sur un jet de dé. Cette option indique le nombre de faces du dé. Plus élevé, donne moins de charge, mais moins de précision dans les classements",
"Encourage contribution to wiki pages by anonymous" => "Encourager les contributions aux pages wiki pages pour les anonymes",
"When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page" => "Quand une page n'est pas modifiable et que l'utilisateur est anonyme, afficher quand même les liens d'édition. Un écran de connexion sera affiché et le visiteur encouragé à s'inscrire",
"Warn before page lock timeout" => "Avertir avant l'expiration du verrouillage de la page",
"Provide a JavaScript alert before the user's lock on a page times out" => "Stipuler une alerte JavaScript avant le blocage de l'utilisateur sur un dépassement de temps sur une page",
"Dynamic variables" => "Variable dynamique",
"Global snippets of text that can be included in wiki pages and edited in place" => "Extraits globaux de texte qui peuvent être inclus dans des pages wiki et ensuite modifiés sur place",
"Single (%varname%)" => "Simple (%varname%)",
"Double (%%varname%%)" => "Double (%%varname%%)",
"Multilingual dynamic variables" => "Variables dynamiques multilingues",
"Make dynamic variable content language-specific." => "Rend le contenu des variables dynamiques spécifique à la langue",
"Allow plugin-specific edits" => "Permettre des modifications spécifiques à un plugiciel",
// "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page" => "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page",
// "This feature is unavailable outside wiki pages, whether or not this preference is enabled" => "This feature is unavailable outside wiki pages, whether or not this preference is enabled",
"Allow section-specific edits" => "Permettre des modifications spécifiques à une section",
// "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section" => "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section",
"Section-specific edits maximum level" => "Niveau maximal des modifications spécifiques à une section",
// "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections" => "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections",
"Only display focused edit icons (for sections and/or plugins) on request" => "Afficher les icones d'édition spécifiques à une section ou un plugiciel sur demande seulement",
// "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page" => "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page",
// "Allow minor edits of wiki pages" => "Allow minor edits of wiki pages",
"Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)." => "Les modifications mineures ne marquent pas le nouveau contenu pour traduction et n'envoient pas de notifications de changement (sauf si l'option \"Surveiller les modifications mineures\" est activée).",
// "Display comment list by default" => "Display comment list by default",
// "Display Post new comment form by default" => "Display Post new comment form by default",
// "Simple wiki comment ratings" => "Simple wiki comment ratings",
// "Enable users to rate comments based on a simple numeric scale" => "Enable users to rate comments based on a simple numeric scale",
"Wiki rating options" => "Options d'évaluation Wiki",
// "List of options available for the rating of wiki comments" => "List of options available for the rating of wiki comments",
"Add a slideshow button on wiki pages" => "Ajouter un bouton 'Diaporama' sur les pages wiki",
"Page creators are administrators of their pages" => "L'auteur de la page est administrateur de celle-ci",
"Create watch for author on page creation" => "Activer la surveillance de la page pour l'auteur automatiquement à la création de la page",
"Enable watches on comments" => "Activer la surveillance des commentaires",
"Watch minor edits" => "Surveiller les modifications mineures",
"Page ID" => "ID de la page",
"Page name maximum displayed length" => "Longueur maximale affichée du nom de page",
"Comment of the latest edit" => "Commentaire de la dernière modification",
"Description maximum displayed length" => "Longueur maximale affichée des descriptions",
"Versions" => "Versions",
"Categories path" => "Chemin des catégories",
"Default sort order" => "Ordre du tri par défaut",
"Sort Direction" => "Ordre de tri",
// "Visibility of discussion" => "Visibility of discussion",
// "Just a button among others (default), or special section" => "Just a button among others (default), or special section",
// "In the button bar (default)" => "In the button bar (default)",
// "Special section above button bar" => "Special section above button bar",
"Forum for discussion" => "Forum pour les discussions",
"Allow management of keywords on a per-page basis" => "Autoriser la gestion des mots-clés page par page",
"Similar pages only listed in same language" => "Pages similaires listées seulement si même langue",
"When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page" => "Lors de l'affichage de pages similaires, par exemple quand une page demandée n'existe pas (404), afficher seulement les pages dans la langue demandée",
"Mandatory wiki page edit summary" => "Résumé de l'édition obligatoire sur le wiki",
// "Reject save attempts that do not include an edit summary describing the changes made" => "Reject save attempts that do not include an edit summary describing the changes made",
// "Position of tags selection" => "Position of tags selection",
// "Place the tags selection more prominently than under the \"Properties\" tab" => "Place the tags selection more prominently than under the \"Properties\" tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Tags tab" => "Tags tab",
"Structure navigation bar location" => "Emplacement de la barre de navigation dans la structure",
"Display Next and Back buttons, breadcrumbs, and a form to add a new page" => "Affiche les boutons Suivant/Précédent, le fil d'Ariane, et le formulaire opur ajouter une nouvelle page",
"Backlink page names maximum displayed length" => "Longueur maximale affichée des noms des pages pointant vers cette page",
// "Show blog posts" => "Show blog posts",
// "Blog posts linking to a wiki page are shown as backlinks" => "Blog posts linking to a wiki page are shown as backlinks",
// "Show forum posts" => "Show forum posts",
// "Forum posts linking to a wiki page are shown as backlinks" => "Forum posts linking to a wiki page are shown as backlinks",
// "Show comments" => "Show comments",
// "Comments linking to a wiki page are shown as backlinks" => "Comments linking to a wiki page are shown as backlinks",
// "Show articles" => "Show articles",
// "Articles linking to a wiki page are shown as backlinks" => "Articles linking to a wiki page are shown as backlinks",
// "Show tracker items" => "Show tracker items",
// "Tracker items linking to a wiki page are shown as backlinks" => "Tracker items linking to a wiki page are shown as backlinks",
"Show trackers" => "Afficher les formulaires",
// "Trackers with a description linking to a wiki page are shown as backlinks" => "Trackers with a description linking to a wiki page are shown as backlinks",
// "Show tracker fields" => "Show tracker fields",
// "Tracker fields with a description linking to a wiki page are shown as backlinks" => "Tracker fields with a description linking to a wiki page are shown as backlinks",
// "Show calendar events" => "Show calendar events",
// "Calendar events with a description linking to a wiki page are shown as backlinks." => "Calendar events with a description linking to a wiki page are shown as backlinks.",
"Simple wiki ratings" => "Évaluation wiki simplifiée",
// "Enable users to rate wiki pages based on a simple numeric scale" => "Enable users to rate wiki pages based on a simple numeric scale",
"List of options available for the rating of wiki pages" => "Liste des options disponibles pour l'évaluation des pages wiki",
// "Semantic link types to use as page alias markers" => "Semantic link types to use as page alias markers",
// "Comma-separated list of semantic links to identify a page as an alias of another" => "Comma-separated list of semantic links to identify a page as an alias of another",
"Redirect pages using these prefix-alias semantic links" => "Préfixes des pages à rediriger par des liens sémantiques",
"Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link" => "Liste de préfixes séparés par des virgules des pages qui seront redirigées vers une page ayant un lien sémantique",
// "Wiki page pagination" => "Wiki page pagination",
// "Enable the separation of a wiki page's content into a set of two or more paginated pages" => "Enable the separation of a wiki page's content into a set of two or more paginated pages",
// "Wiki page separator" => "Wiki page separator",
// "The separator to use in wiki page content to mark the end of each page section" => "The separator to use in wiki page content to mark the end of each page section",
// "Wiki auto-toc" => "Wiki auto-toc",
// "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties" => "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties",
// "Inline auto-toc" => "Inline auto-toc",
// "Change the display of the table of contents for wiki pages to inline" => "Change the display of the table of contents for wiki pages to inline",
// "Table of contents position" => "Table of contents position",
// "Position of the table of contents, either top, left, right (right is the default)" => "Position of the table of contents, either top, left, right (right is the default)",
// "Table of contents offset" => "Table of contents offset",
// "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin" => "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin",
// "Table of contents default" => "Table of contents default",
// "Set the default for the table of contents (default \"on\" and can be toggled per page)" => "Set the default for the table of contents (default \"on\" and can be toggled per page)",
"On" => "Le",
"Off" => "Off",
// "Add an option to hide the page title per wiki page" => "Add an option to hide the page title per wiki page",
// "Enable the page title to not be displayed, on a per-page basis" => "Enable the page title to not be displayed, on a per-page basis",
// "Multilevel style numbering for ordered lists" => "Multilevel style numbering for ordered lists",
// "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc" => "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc",
// "Force link to included page" => "Force link to included page",
// "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used" => "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used",
// "Date Field" => "Date Field",
// "The field indexed as the global \"date\" field" => "The field indexed as the global \"date\" field",
// "You will need to rebuild the search index after changing this" => "You will need to rebuild the search index after changing this",
// "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it" => "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it",
"Maximum displayed length of the latest edit's comment" => "Longueur maximale affichée du commentaire de la dernière modification",
"Plugin %0" => "Plugiciel %0",
// "Global cache time for the plugin snarf" => "Global cache time for the plugin snarf",
"Default cache time for the plugin snarf" => "Durée par défaut de mise en cache pour le plugiciel snarf",
"0 for no cache" => "0 pour pas de cache",
// "GUI for the list plugin" => "GUI for the list plugin",
// "Experimental GUI for the list plugin in popup plugin edit forms" => "Experimental GUI for the list plugin in popup plugin edit forms",
// "(listgui)" => "(listgui)",
// "Plugin trackerlist converter" => "Plugin trackerlist converter",
// "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead" => "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead",
// "Maximum plugin parsing passes" => "Maximum plugin parsing passes",
// "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin" => "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin",
// "passes" => "passes",
// "Setting this to a higher value than the default of 500 may have performance implications" => "Setting this to a higher value than the default of 500 may have performance implications",
"Inline plugin %0" => "Plugiciel en ligne %0",
"Plugin pending approval notification" => "Notification des plugiciels en attente de validation",
"Send an email alert to users with permission to approve plugins when a plugin approval is pending" => "Demander par courriel aux utilisateurs habilités d'approuver les plugiciels en attente de validation",
// "Hide admin wizard on log-in when an admin user logs in" => "Hide admin wizard on log-in when an admin user logs in",
// "Workspace UI" => "Workspace UI",
// "Combines multiple site features to create a workspace experience for workgroups" => "Combines multiple site features to create a workspace experience for workgroups",
// "Workspace root category" => "Workspace root category",
// "ID of the root category containing all workspaces" => "ID of the root category containing all workspaces",
// "This value is automatically managed and should not need to be modified manually" => "This value is automatically managed and should not need to be modified manually",
// "Full WYSIWYG editor is optional" => "Full WYSIWYG editor is optional",
// "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used" => "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used",
// "Switching between HTML and wiki formats can cause problems for some pages" => "Switching between HTML and wiki formats can cause problems for some pages",
// "Full WYSIWYG editor is displayed by default" => "Full WYSIWYG editor is displayed by default",
// "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages" => "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages",
"Reopen with the same editor" => "Réouvrir avec le même éditeur",
// "Ensures the editor last used to edit a page or item is used for the next edit as the default" => "Ensures the editor last used to edit a page or item is used for the next edit as the default",
// "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed" => "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed",
"Use Wiki syntax in WYSIWYG" => "Utilisation de la syntaxe wiki dans l'éditeur Wysiwyg",
// "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"" => "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"",
// "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools" => "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools",
// "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)" => "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)",
// "CKeditor offers possibilities which may not be expressible in Tiki syntax" => "CKeditor offers possibilities which may not be expressible in Tiki syntax",
// "Full WYSIWYG editor skin" => "Full WYSIWYG editor skin",
// "Moono (Default)" => "Moono (Default)",
// "Kama" => "Kama",
// "Bootstrap CK" => "Bootstrap CK",
// "Minimalist" => "Minimalist",
// "Office 2013" => "Office 2013",
// "Typefaces" => "Typefaces",
// "List of font names separated by semi-colons (\";\")" => "List of font names separated by semi-colons (\";\")",
// "Inline WYSIWYG editor" => "Inline WYSIWYG editor",
// "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required" => "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required",
// "Extra plugins" => "Extra plugins",
// "List of plugin names (separated by,)" => "List of plugin names (separated by,)",
// "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard" => "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard",
// "Support Tiki's \"wiki syntax\" in HTML pages" => "Support Tiki's \"wiki syntax\" in HTML pages",
// "XMPP client (ConverseJS)" => "XMPP client (ConverseJS)",
// "Integration with Converse.js XMPP client" => "Integration with Converse.js XMPP client",
// "XMPP server domain" => "XMPP server domain",
// "example.org" => "example.org",
// "XMPP MUC Domain" => "XMPP MUC Domain",
// "Required for auto-joining rooms" => "Required for auto-joining rooms",
// "conference.example.org" => "conference.example.org",
// "The authentication method to be used by XMPP client" => "The authentication method to be used by XMPP client",
// "OAuth (uses Tiki as provider)" => "OAuth (uses Tiki as provider)",
// "Openfire TikiToken" => "Openfire TikiToken",
// "Allow anonymous" => "Allow anonymous",
// "Allow anonymous users on Chat" => "Allow anonymous users on Chat",
// "Openfire REST API endpoint" => "Openfire REST API endpoint",
// "Full URL to API endpoint" => "Full URL to API endpoint",
// "https://xmpp.example.org:9091/plugins/restapi/v1/" => "https://xmpp.example.org:9091/plugins/restapi/v1/",
// "Rest API username" => "Rest API username",
// "Username to allow Openfire API usage" => "Username to allow Openfire API usage",
// "Rest API password" => "Rest API password",
// "Password to allow Openfire API usage" => "Password to allow Openfire API usage",
// "ConverseJS Debug Mode" => "ConverseJS Debug Mode",
// "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console" => "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console",
// "ConverseJS Extra Settings" => "ConverseJS Extra Settings",
// "JSON format object defining extra optional settings to initialize ConverseJS" => "JSON format object defining extra optional settings to initialize ConverseJS",
"SMTP server" => "Serveur SMTP",
"Security" => "Sécurité",
"SSL" => "SSL",
"TLS" => "TLS",
"Mail sender" => "Émetteur des courriels",
// "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications" => "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications",
"Sendmail" => "Sendmail",
"SMTP" => "SMTP",
// "File (debug)" => "File (debug)",
"Authentication" => "Authentification",
"Mail server authentication" => "Authentification du serveur de mail",
"LOGIN" => "LOGIN",
"PLAIN" => "PLAIN",
"CRAM-MD5" => "CRAM-MD5",
// "Local server name" => "Local server name",
// "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line" => "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line",
// "Mail delivery" => "Mail delivery",
// "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail" => "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail",
// "Send immediately" => "Send immediately",
// "Queue" => "Queue",
// "Verify HTTPS certificates of remote servers" => "Verify HTTPS certificates of remote servers",
// "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)" => "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)",
// "Do not enforce verification" => "Do not enforce verification",
// "Enforce verification" => "Enforce verification",
// "Use CURL for HTTP connections" => "Use CURL for HTTP connections",
// "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available" => "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available",
// "Zotero bibliography" => "Zotero bibliography",
"Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system" => "Connecte Tiki au système de gestion documentaire Zotero",
// "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style" => "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style",
// "Zotero client key" => "Zotero client key",
"Required identification key. Registration required." => "Paramètre requis. Enregistrement nécessaire.",
// "Zotero client secret" => "Zotero client secret",
// "Zotero group ID" => "Zotero group ID",
"Numeric ID of the group, can be found in the URL." => "Numéro du groupe, peut être trouvé dans l'URL.",
// "Zotero reference style" => "Zotero reference style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
"Unmatched system requirement. Missing PHP extension among %0" => "Condition système requise non satisfaite. Extension php manquante %0",
// "Unmatched system requirement. The database you are using does not support this feature" => "Unmatched system requirement. The database you are using does not support this feature",
"Missing default for preference \"%0\"" => "Valeur par défaut manquante pour la préférence \"%0\"",
"Configuration forced by host" => "Configuration forcée par l'hôte",
"Disabled by host" => "Désactivé par l'hôte",
"Settings" => "Réglages",
"Permissions" => "Droits d'accès",
"View" => "Afficher",
"Modules" => "Modules",
"Plugins" => "Plugiciels",
// "Like" => "Like",
// "Missing preference \"%0\" for \"%1\"" => "Missing preference \"%0\" for \"%1\"",
// "%0 set to minimum of %1 instead of submitted value of %2" => "%0 set to minimum of %1 instead of submitted value of %2",
// "%0 set to maximum of %1 instead of submitted value of %2" => "%0 set to maximum of %1 instead of submitted value of %2",
// "Don't like" => "Don't like",
"Wiki top pages" => "Pages Wiki les plus populaires",
"Most-relevant pages" => "Pages les plus pertinentes",
"Wiki last pages" => "Dernières pages Wiki",
// "Forums last topics" => "Forums last topics",
"Topic date" => "Date du sujet",
"Forums last posts" => "Derniers articles de forum",
"Forums most-read topics" => "Sujets de forums les plus lus",
"Forums best topics" => "Sujets de forums les plus populaires",
"Most-visited forums" => "Forums les plus visités",
"Forums with most posts" => "Forums avec le plus d'articles",
"Wiki top galleries" => "Galeries Wiki les plus populaires",
"Wiki top file galleries" => "Galeries de fichiers Wiki les plus populaires",
"Wiki top images" => "Images Wiki les plus populaires",
"Wiki top files" => "Fichiers Wiki les plus populaires",
"Downloads" => "Téléchargements",
"Wiki most-recent images" => "Dernières images Wiki",
"Upload date" => "Date d'envoi",
"Wiki most-recent files" => "Derniers fichiers Wiki",
"Top Articles" => "Articles les plus populaires",
"Most-visited blogs" => "Blogues les plus visités",
"Most-active blogs" => "Blogues les plus actifs",
"Blogs last posts" => "Dernières publications de blogue",
"Post date" => "Date de publication",
"Wiki top authors" => "Auteurs Wiki les plus actifs",
"Pages" => "Pages",
"Top article authors" => "Auteurs d'articles les plus actifs",
"Expecting three arguments for article-info" => "Trois paramètres attendus pour l'article-info",
"Unsupported property. Supported properties are: " => "Propriété non supportée. Les propriétés supportées sont : ",
"The Articles feature is not activated" => "La fonctionnalité article n'est pas activée",
"Object must be provided and contain two arguments: type and object" => "Un objet doit être fourni et contenir deux arguments : type et objet",
"Invalid property" => "Propriété invalide",
// "Item must be provided and contain one argument: type, object-id" => "Item must be provided and contain one argument: type, object-id",
// "List must be provided and contain at least one argument: category IDs" => "List must be provided and contain at least one argument: category IDs",
"Invalid range" => "Intervalle invalide",
"Invalid revote period" => "Période de nouveau vote invalide",
"Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Attendu que \"keep\" soit \"latest\" ou \"oldest\"",
// "Qualifier must be provided and contain one argument: type" => "Qualifier must be provided and contain one argument: type",
// "From must be provided and contain two arguments: type, object-id" => "From must be provided and contain two arguments: type, object-id",
// "To must be provided and contain two arguments: type, object-id" => "To must be provided and contain two arguments: type, object-id",
// "Field must be provided and contain one argument: field permanent name" => "Field must be provided and contain one argument: field permanent name",
"Unknown variables referenced: %0" => "Variables référencées inconnues : %0",
"Username is required" => "Nom d'utilisateur requis",
"Password is required" => "Mot de passe obligatoire",
"User already exists" => "Cet utilisateur existe déjà",
"Invalid username" => "Nom d'utilisateur invalide",
"Username is too long" => "Nom d'utilisateur trop long",
"Username cannot contain uppercase letters" => "Le nom d'utilisateur ne peut contenir de majuscules",
"Wrong passcode. You need to know the passcode to register at this site" => "Code d'enregistrement erroné : vous devez connaître le code pour l'enregistrement pour vous inscrire dans ce site",
"You must choose a group" => "Vous devez choisir un groupe",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
// "One of these groups is required" => "One of these groups is required",
"This field is required" => "Ce champ est requis",
"The passwords don't match" => "Les mots de passe ne correspondent pas",
// "Username must be at least %0 characters long" => "Username must be at least %0 characters long",
"Username cannot contain more than %0 characters" => "Un nom d'utilisateur ne peut pas contenir plus de %0 caractères",
"This invitation does not exist or is deprecated or wrong email" => "Cette invitation n'existe pas ou est obsolète ou mauvaise adresse électronique",
"The title and description must be entered, to generate a feed" => "Les champs titre et description sont obligatoires à la génération d'un flux RSS",
"To fix this error go to Admin -> Feeds" => "Pour corriger cette erreur aller sur Admin -> Feeds",
"Please contact the site administrator and request this error to be corrected" => "Contactez l'administrateur de votre site et demandez lui de corriger cette erreur",
"If you set feed author email or URL, you must set feed author name" => "Si vous fournissez le mail ou l'URL de l'auteur du flux RSS, vous devez aussi fournir son nom",
"Feed logo" => "Logo du flux",
"Unspecified" => "Non spécifié",
"Log In" => "Connexion",
"See other users' profiles" => "Voir les informations d'un autre utilisateur",
"Have your profile seen" => "Avoir ses informations utilisateur vues",
"Make friends" => "Se faire un ami",
"Receive a message" => "Recevoir un message",
"Send a message" => "Envoyer un message",
"Read an article" => "Lire un article",
"Publish an article" => "Publier un article",
"Have your article read" => "Avoir son article lu",
"Create new file gallery" => "Créer une nouvelle galerie de fichiers",
"Upload a new file to a gallery" => "Envoyer un nouveau fichier dans une galerie",
"Download another user's file" => "Télécharger un fichier d'un autre utilisateur",
"Have your file downloaded" => "Avoir un de ses fichiers téléchargé",
"Create a new image gallery" => "Créer une nouvelle galerie d'images",
"Upload a new image to a gallery" => "Envoyer une nouvelle image dans une galerie",
"View another user's gallery" => "Afficher une galerie d'images d'un autre utilisateur",
"View another user's images" => "Afficher une image d'un autre utilisateur",
"Have your gallery viewed by another user" => "Avoir sa galerie affichée par un autre utilisateur",
"Have your image viewed" => "Avoir une de ses images affichée",
"Create a new blog" => "Créer un nouveau blogue",
"Post in a blog" => "Publier dans un blogue",
"Read another user's blog" => "Lire un blogue d'un autre utilisateur",
"Have your blog read" => "Avoir un de ses blogues lu",
"Create a new wiki page" => "Créer une nouvelle page Wiki",
"Edit an existing page" => "Modifier une page existante",
"Attach a file" => "Joindre un fichier",
// "Create a new forum topic" => "Create a new forum topic",
// "Reply to a forum topic" => "Reply to a forum topic",
// "Read a forum post" => "Read a forum post",
// "Have your forum post read" => "Have your forum post read",
// "Create a new tracker item" => "Create a new tracker item",
// "Edit a tracker item" => "Edit a tracker item",
// "View a tracker item" => "View a tracker item",
// "Have your tracker item viewed" => "Have your tracker item viewed",
// "Tracker field content added" => "Tracker field content added",
// "Favorite an item" => "Favorite an item",
// "Have your item favorited" => "Have your item favorited",
// "Have your item rated (per rating)" => "Have your item rated (per rating)",
// "Have your item unrated (per rating)" => "Have your item unrated (per rating)",
// "Add a profile photo" => "Add a profile photo",
// "Try rebuilding or optimizing the index on the search admin page" => "Try rebuilding or optimizing the index on the search admin page",
// "Invalid table name" => "Invalid table name",
// "Invalid column name" => "Invalid column name",
"Wiki Comment" => "Commentaire Wiki",
"Calendar item" => "Evènement du Calendrier",
"Gallery" => "Galerie",
"Blog post" => "Article de blogue",
"Tracker item" => "Fiche du formulaire",
"The search index could not be updated. The site is misconfigured. Contact an administrator" => "L'index de recherche n'a pas pu être mis à jour. Le site est mal configuré. Contacter un administrateur",
// "Rebuild in progress" => "Rebuild in progress",
// "The search index could not be rebuilt" => "The search index could not be rebuilt",
// "The active index could not be removed, probably due to a file permission issue" => "The active index could not be removed, probably due to a file permission issue",
// "The new index could not be made active, probably due to a file permission issue" => "The new index could not be made active, probably due to a file permission issue",
// "Failed to delete the old index" => "Failed to delete the old index",
"blog post" => "publication de blogue",
"forum post" => "publication du forum",
"tracker item" => "fiche formulaire",
// "tracker field" => "tracker field",
"sheet" => "feuille",
"comment" => "commentaire",
// "category" => "category",
// "webservice" => "webservice",
// "activity" => "activity",
// "calendar item" => "calendar item",
// "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate" => "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate",
// "Contact the site administrator. The index needs rebuilding" => "Contact the site administrator. The index needs rebuilding",
// "Client Node" => "Client Node",
// "Elasticsearch Version" => "Elasticsearch Version",
// "Lucene Version" => "Lucene Version",
// "Cluster Name" => "Cluster Name",
// "Cluster Status" => "Cluster Status",
// "Cluster Node Count" => "Cluster Node Count",
// "Index %0" => "Index %0",
// "%0 documents, totaling %1" => "%0 documents, totaling %1",
// "Node %0" => "Node %0",
// "Using %0, since %1" => "Using %0, since %1",
// "%0 documents, totaling %1 bytes" => "%0 documents, totaling %1 bytes",
// "Using %0 bytes, since %1" => "Using %0 bytes, since %1",
// "Field Count Tried on Last Rebuild" => "Field Count Tried on Last Rebuild",
// "Field limit setting is lower than Tiki needs to store in the index" => "Field limit setting is lower than Tiki needs to store in the index",
// "Information Missing" => "Information Missing",
"Object Type" => "Type de l'objet",
// "date_histogram" => "date_histogram",
// "Date Histogram" => "Date Histogram",
// "date_range" => "date_range",
"Date Range" => "Intervalle de date",
// "Local Search" => "Local Search",
// "Federated Search" => "Federated Search",
// "Index not found" => "Index not found",
"Rebuild search index" => "Reconstruire l'index de recherche",
// "Click here to rebuild index" => "Click here to rebuild index",
// "On Demand" => "On Demand",
// "You can revisit the results of this saved search on demand" => "You can revisit the results of this saved search on demand",
// "Mobile mode: Permission denied, please log in" => "Mobile mode: Permission denied, please log in",
" has accessed your temporary shared content" => " a accédé à votre contenu temporairement partagé",
"has accessed the following shared content" => "A accédé au contenu partagé suivant",
"Your access to this page has expired" => "Votre droit d'accès à cette page a expiré",
"Handling actions of plugin \"%s\" failed" => "L'exécution des actions du plugiciel \"%s\" a échoué",
"You must choose an option" => "Vous devez choisir une option",
"For you to vote, cookies must be allowed" => "Les cookies doivent être autorisés pour pouvoir voter",
"This poll is closed." => "Ce sondage est fermé.",
// "Preference %0 failed to unserialize. Value was \"%1\"" => "Preference %0 failed to unserialize. Value was \"%1\"",
// "A tracker with id \"%0\" is required to be filled in, but it was deleted" => "A tracker with id \"%0\" is required to be filled in, but it was deleted",
// "Update the preference \"<b>%0</b>\" on admin panel" => "Update the preference \"<b>%0</b>\" on admin panel",
"Congratulations" => "Félicitations",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "Ceci est la page d'accueil par défaut de votre Tiki. Si vous la voyez, votre installation s'est déroulée avec succès",
// "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details",
// "Get started" => "Get started",
"To begin configuring your site" => "Pour commencer à configurer votre site",
"1) Log in with your newly created password" => "1) Se connecter avec votre mot de passe récemment créé",
// "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard" => "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard",
// "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running" => "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running",
// "Need help" => "Need help",
"For more information" => "Pour plus d'information",
// "[https://tiki.org/Introduction|Learn more about Tiki]" => "[https://tiki.org/Introduction|Learn more about Tiki]",
// "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[https://tiki.org/Join|Join the Tiki community]" => "[https://tiki.org/Join|Join the Tiki community]",
"new" => "créer",
"Saved" => "Sauvegardé",
"Save failed" => "Sauvegarde échouée",
// "Standard Shipping" => "Standard Shipping",
"3 to 5 working days" => "de 3 à 5 jours de travail",
"Express Shipping" => "Trasport Express",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
// "Modified date" => "Modified date",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- plugiciel jq smarty inactif: feature_jquery off -->",
"No records to display" => "Aucun enregistrement à afficher",
// "Please specify the name of the package and the view" => "Please specify the name of the package and the view",
// "Error: Unable to locate view file for the package" => "Error: Unable to locate view file for the package",
// "Error: Unable to locate function name for the view" => "Error: Unable to locate function name for the view",
"Previous" => "Précédent",
"current" => "en cours",
"Next" => "Suivant",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
"Tab View" => "avec onglets",
"No Tabs" => "sans onglet",
"This edit session will expire in" => "Cette session d'édition va expirer dans",
"There is an autosaved draft of your recent edits, to use it instead " => "Il y a une sauvegarde automatique de vos éditions récentes, pour l'utiliser ",
// "If you want the original instead of the autosaved draft of your edits" => "If you want the original instead of the autosaved draft of your edits",
"click here" => "cliquer ici",
"AutoSave" => "Sauvegarde automatique",
"Your edit session has expired" => "Votre session d'édition a expiré",
"Your edit session will expire in" => "Votre session d'édition va expirer dans",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Vous devez VISUALISER ou ENREGISTRER votre travail maintenant, pour éviter de perdre vos modifications",
// "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page",
"Help page" => "Page d'aide",
// "View or edit tpl" => "View or edit tpl",
// "View tpl" => "View tpl",
// "itemId required" => "itemId required",
// "Plugin name not specified" => "Plugin name not specified",
// "Delete file" => "Delete file",
// "File (ID %0) removed" => "File (ID %0) removed",
// "File (ID %0) not removed" => "File (ID %0) not removed",
// "File uploaded" => "File uploaded",
// "File not uploaded" => "File not uploaded",
// "Missing _id or _type params" => "Missing _id or _type params",
"Wrong attachments gallery" => "Pièces jointes erronées pour cette galerie",
"You are attempting to display a gallery that is not a valid attachment gallery" => "Vous essayez d'afficher une galerie qui n'est pas une pièce jointe de galerie valable",
// "Missing 'to' or 'from' parameter" => "Missing 'to' or 'from' parameter",
"at" => "à",
"to" => "à",
"Favorite" => "Favori",
"Hour" => "Heure",
"Minute" => "Minute",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "Cliquez ici pour aller à l'édition des langues",
"The text is" => "Le texte est",
"character(s) too long - please edit it." => "caractère(s) trop long - SVP, modifiez-le.",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Clear filter" => "Clear filter",
"Filter:" => "Filtre :",
// "Type not specified" => "Type not specified",
// "lock perm not found" => "lock perm not found",
// "admin perm not found" => "admin perm not found",
"Missing parameter" => "Paramètre manquant",
// "Multivalue configuration not found" => "Multivalue configuration not found",
"No records found." => "Aucun résultat.",
"No object information provided" => "Aucune information fournie pour l'objet",
"No title specified" => "Aucun titre spécifié",
"Relation not found" => "Relation non trouvée",
"tags disabled" => "Mots-clés désactivés",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "%0 list separated with \"%1\"" => "%0 list separated with \"%1\"",
// "Object selector requires Unified Index to be enabled" => "Object selector requires Unified Index to be enabled",
"Currency in payment (%0) does not match the currency for that registry (%1)" => "La monnaie du paiement (%0) ne correspond pas à celle de ce registre (%1)",
// "Payment error" => "Payment error",
"This invoice does not exist or access to it is restricted" => "Cette facture n'existe pas ou a un accès limité",
"You do not have the permission that is needed to use this feature" => "Vous n'avez pas les droits pour utiliser cette fonctionnalité",
"(not found in an admin panel)" => "(non trouvé dans un panneau d'admininistration)",
"Preference %0 is not defined" => "La préférence %0 n'est pas définie",
"Drag this out of the perspective and resave the perspective" => "Glisser ceci en dehors de la perspective et l'enregistrer à nouveau",
"No object information provided for rating" => "L'objet ne dispose ni d'information ni de score",
"An error occurred" => "Une erreur s'est produite",
// "Configure Ratings" => "Configure Ratings",
"Unavailable" => "Indisponible",
// "Invalid fields provided" => "Invalid fields provided",
// "Missing or invalid tracker reference" => "Missing or invalid tracker reference",
// "Configured" => "Configured",
"General" => "Général",
// "Tracker rendering error (section=\"%0\" mode=\"%1\")" => "Tracker rendering error (section=\"%0\" mode=\"%1\")",
"No rows found" => "Aucune ligne trouvée",
"Toggle sections" => "Commuter les sections",
"Show only selected" => "N'afficher que les sélectionnés",
"You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "Vous pouvez vouloir donner le droit tiki_p_modify_object_categories dans la section Tiki",
// "You are logged in" => "You are logged in",
// "Request not from this host" => "Request not from this host",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "SVP, saisissez un %s valide. Pas d'espace, plus de %d caractères et contenant %s",
"username" => "nom d'utilisateur",
"password" => "mot de passe",
"Cookies must be enabled to log in to this site" => "Vous devez autoriser les cookies si vous voulez vous connecter sur ce site",
// "wikidiff: error - no object_id specified" => "wikidiff: error - no object_id specified",
// "wikidiff: error - no old version specified" => "wikidiff: error - no old version specified",
// "wikidiff: error - page \"%0\" not found" => "wikidiff: error - page \"%0\" not found",
// "wikidiff: Error - only wiki pages supported currently" => "wikidiff: Error - only wiki pages supported currently",
"second" => "seconde",
"months" => "mois",
"weeks" => "semaines",
"done" => "fait",
"Text cut here" => "Texte coupé ici",
"Task" => "Tâche",
"Priority" => "Priorité",
"Start date" => "Date de début",
"End date" => "Date de fin",
"in %s days, the %s" => "dans %s jours, le %s",
"in %s day, the %s" => "dans %s jour, le %s",
"Today" => "Aujourd'hui",
// "%0 and %1" => "%0 and %1",
"Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission refusée : la page wiki spécifiée ne peut pas être utilisée en tant que ressource gabarit Smarty",
"No WSDL found" => "Aucun WSDL trouvé",
// "Facebook feed data not retrieved" => "Facebook feed data not retrieved",
// "Facebook profile information not retrieved" => "Facebook profile information not retrieved",
// "You need to link your local account to Facebook before you can login using it" => "You need to link your local account to Facebook before you can login using it",
// "We were unable to create a new user with your Facebook account. Please contact the administrator" => "We were unable to create a new user with your Facebook account. Please contact the administrator",
// "We were unable to connect to your LinkedIn account. Please contact the administrator" => "We were unable to connect to your LinkedIn account. Please contact the administrator",
// "We were unable to log you in using your LinkedIn account. Please contact the administrator" => "We were unable to log you in using your LinkedIn account. Please contact the administrator",
// "You need to link your local account to LinkedIn before you can login using it" => "You need to link your local account to LinkedIn before you can login using it",
"pvs" => "pages vues",
"Days with the most pageviews" => "Jours avec le plus de pages vues",
"Day with the most pageviews" => "Jour avec le plus de pages vues",
"Days with the fewest pageviews" => "Jours avec le moins de pages vues",
"Day with the fewest pageviews" => "Jour avec le moins de pages vues",
"No pageviews yet" => "Aucune page vue pour l'instant",
"Use this tree to copy the structure" => "Utiliser cet arbre pour copier la structure",
// "system" => "system",
"created from structure" => "créé à partir d'une structure",
"%d choice(s) must be made for the question" => "Vous devez donner %d réponses à la question",
"At least %d choice(s) must be made for the question" => "Vous devez sélectionner un minimum de %d choix pour répondre à cette question",
"Fewer than %d choice(s) must be made for the question" => "Vous devez donner moins de %d réponses à la question",
"One choice" => "1 choix (c)",
"Multiple choices" => "Choix multiple (m)",
// "Thumbnails" => "Thumbnails",
"Short text" => "Texte court (t)",
"Wiki textarea" => "Zone de texte Wiki",
"Rate (1 to 5)" => "Notation (1..5) (r)",
"Rate (1 to 10)" => "Notation (1..10) (s)",
"Heading" => "En-tête",
// "Icon not found: %0" => "Icon not found: %0",
// "Icon set: Class not defined for icon %0" => "Icon set: Class not defined for icon %0",
// "Custom theme by specifying URL" => "Custom theme by specifying URL",
"Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator" => "Fonctionnalités requises : <b>%0</b>. Si vous n'avez pas les privilèges pour les activer, demander à l'administrateur du site",
// "CSRF check not performed" => "CSRF check not performed",
// "Required headers are missing" => "Required headers are missing",
// "Requesting site could not be identified because %0 and %1 were empty" => "Requesting site could not be identified because %0 and %1 were empty",
// "Request needs to originate from this site" => "Request needs to originate from this site",
// "The %0 host (%1) does not match this server (%2)" => "The %0 host (%1) does not match this server (%2)",
// "Ticket has expired. Reload the page" => "Ticket has expired. Reload the page",
// "Ticket matches but is expired" => "Ticket matches but is expired",
// "Reloading the page may help" => "Reloading the page may help",
// "Ticket does not match or is missing" => "Ticket does not match or is missing",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked" => "Potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Request to %0 failed CSRF check" => "Request to %0 failed CSRF check",
"Confirm action" => "Confirmer l'action",
// "Please confirm action" => "Please confirm action",
"unknown error" => "erreur inconnue",
"You are not logged in" => "Vous n'êtes pas connecté",
"You do not have permission to view this section" => "Vous n'avez pas les droits pour afficher cette section",
"For the security of your password, direct access to the feed is only available via HTTPS" => "Pour la sécurité de votre mot de passe, l'accès à ce canal n'est accessible que via https",
"Help link" => "Lien vers l'Aide",
"You are banned from" => "Vous êtes interdit de la section",
"wiki" => "wiki",
"img-g" => "gal-img",
"file-g" => "gal-fichiers",
"quizzes" => "QCMs",
"arts" => "articles",
"blogs" => "blogues",
"forums" => "forums",
// "Tiki links converted to relative links" => "Tiki links converted to relative links",
// "TikiLib::create_page: Cannot create page \"%0\", it already exists.)" => "TikiLib::create_page: Cannot create page \"%0\", it already exists.)",
"The file was successfully uploaded" => "Le fichier a été téléchargé avec succès",
"The file was only partially uploaded." => "Le fichier que vous tentez d'envoyer n'a été transféré que partiellement.",
"No file was uploaded. Was a file selected " => "Aucun fichier rapatrié. Un fichier a-t-il été sélectionné ",
"A temporary folder is missing" => "Un dossier temporaire est manquant",
// "Alias <b>%0</b> link already present in %1 page(s)" => "Alias <b>%0</b> link already present in %1 page(s)",
"%d points" => "%d points",
"Removed" => "Supprimé",
"Plugin %0 pending approval" => "Plugiciel %0 en attente d'approbation",
"Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked." => "Sea Surfing (CSRF) détecté. Opération bloquée.",
"Bold" => "Gras",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "Italique",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Souligné",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "Barré",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Code" => "Code",
// "img/icons/page_white_code.png" => "img/icons/page_white_code.png",
"Non-parsed (wiki syntax does not apply)" => "Non-analysé (la syntaxe Wiki ne s'applique pas)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Aligné au centre horizontalement",
"Horizontal Bar" => "Barre horizontal",
"Page Break" => "Saut de page",
"Box" => "Boîte",
"Title bar" => "Barre de titre",
// "Bullet List" => "Bullet List",
// "Numbered List" => "Numbered List",
"Special Characters" => "Caractères spéciaux",
"Foreground color" => "Couleur de police",
"Background Color" => "Couleur du fond d'écran",
"Wiki Link" => "Lien Wiki",
// "img/icons/page_link.png" => "img/icons/page_link.png",
// "Object Link" => "Object Link",
"External Link" => "Lien externe",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Tableau",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Rechercher",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Remplacer",
"Full-screen edit" => "Édition plein écran",
"Wiki Help" => "Aide Wiki",
"Choose or upload images" => "Choisir ou télécharger une image",
// "img/icons/pictures.png" => "img/icons/pictures.png",
// "Choose or upload files" => "Choose or upload files",
"Switch Editor (wiki or WYSIWYG)" => "Changer d'éditeur (wiki ou WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Admin Toolbars" => "Administration des barres d'outils",
// "img/icons/wrench.png" => "img/icons/wrench.png",
"Save Sheet" => "Sauvegarde de la feuille de calcul",
"Add row after selection or to the end if no selection" => "Ajouter une ligne après la sélection ou à la fin si pas de sélection",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
"Add multiple rows after selection or to the end if no selection" => "Ajouter des lignes après la sélection ou à la fin si pas de sélection",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
"Add row before selection or to end if no selection" => "Ajouter une ligne avant la sélection ou à la fin si pas de sélection",
"Delete selected row" => "Effacer les lignes sélectionnées",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
"Add column after selection or to the end if no selection" => "Ajouter une colonne après la sélection ou à la fin si pas de sélection",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
"Delete selected column" => "Effacer les colonnes sélectionnées",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
"Add multiple columns after selection or to the end if no selection" => "Ajouter des colonnes après la sélection ou à la fin si pas de sélection",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
"Add column before selection or to the end if no selection" => "Ajouter une colonne avant la sélection ou à la fin si pas de sélection",
"Get Cell Range" => "Obtenir la plage de cellules",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Trouver",
"Refresh calculations" => "Rafraichir les calculs",
"Finish editing" => "Fin de l'édition",
"Reset Colors" => "Réinitialiser les Couleurs",
"Reset" => "Réinitialiser",
// "Show this text" => "Show this text",
// "Link to this page" => "Link to this page",
// "Anchor" => "Anchor",
// "Semantic relation" => "Semantic relation",
"Cancel" => "Annuler",
"Insert" => "Insérer",
// "Types of object" => "Types of object",
// "Link to this object" => "Link to this object",
// "link to this URL" => "link to this URL",
// "No cache" => "No cache",
// "Case Insensitivity" => "Case Insensitivity",
// "Note: Uses regular expressions" => "Note: Uses regular expressions",
"Close" => "Fermer",
"Replace" => "Remplacer",
// "Replace All" => "Replace All",
// "Flat" => "Flat",
"Tabs" => "Onglets",
// "No template available for %0 - %1" => "No template available for %0 - %1",
// "Tracker %0 not found for Field %1" => "Tracker %0 not found for Field %1",
"*** ERROR: Tracker ID not set ***" => "*** ERREUR : ID de formulaire non défini ***",
"*** ERROR: Field ID not set ***" => "*** ERREUR : ID de champ non défini ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "TrackerLib::get_all_items: No item for itemId %0" => "TrackerLib::get_all_items: No item for itemId %0",
// "Tracker list_items ran out of memory after %0 items" => "Tracker list_items ran out of memory after %0 items",
// "No fields found in header, not a comma-separated values file" => "No fields found in header, not a comma-separated values file",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
// "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"" => "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"",
"Field is not numeric" => "Le champ n'est pas numérique",
"Function" => "Fonction",
"Pending" => "En attente",
"Tracker field setup error - display field not found: " => "Erreur de configuration d'un champ de formulaire - champ à afficher non trouvé : ",
// "Item Creation" => "Item Creation",
"Item Modification" => "Modification de la fiche",
"Item" => "Fiche",
"Subject" => "Sujet",
"Tracker was modified at %0 by %1" => "Le formulaire a été modifié à %0 par %1",
"View the tracker item at" => "Voir la fiche du formulaire à",
// "Missing wiki email template page \"%0\"" => "Missing wiki email template page \"%0\"",
// "Tracker field not enabled: fieldId=%0 type=%1" => "Tracker field not enabled: fieldId=%0 type=%1",
// "Field not specified" => "Field not specified",
"No extra information for that attached file. " => "Aucune information supplémentaire pour ce fichier joint. ",
// "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list" => "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list",
// "Could not create /storage/pass_blacklists directory" => "Could not create /storage/pass_blacklists directory",
// "Existing password blacklist file was overwritten" => "Existing password blacklist file was overwritten",
// "Existing password blacklist file could not be overwritten" => "Existing password blacklist file could not be overwritten",
// "File Error. Password file not created" => "File Error. Password file not created",
// "File Error. Password file generation interrupted" => "File Error. Password file generation interrupted",
// "Password blacklist file generated" => "Password blacklist file generated",
// "Unable to Populate Blacklist: File dose not exist or is not readable" => "Unable to Populate Blacklist: File dose not exist or is not readable",
// "Critical" => "Critical",
// "Immediate notification by email" => "Immediate notification by email",
"High" => "Prioritaire",
// "Will be sent to you with the next periodic digest" => "Will be sent to you with the next periodic digest",
"Low" => "Peu prioritaire",
// "Included in your personalized recent changes feed" => "Included in your personalized recent changes feed",
// "Anywhere" => "Anywhere",
// "translations of %0" => "translations of %0",
// "%0 in %1" => "%0 in %1",
// "%0 for %1" => "%0 for %1",
// "Any activity" => "Any activity",
// "Page modified" => "Page modified",
// "Page created" => "Page created",
// "Any forum activity" => "Any forum activity",
// "New topics" => "New topics",
// "Any item activity" => "Any item activity",
// "New items" => "New items",
// "Action Required" => "Action Required",
// "Recommendation Received" => "Recommendation Received",
// "%0 (%1 level up, entire structure)" => "%0 (%1 level up, entire structure)",
// "%0 (%1 level up)" => "%0 (%1 level up)",
// "%0 (current subtree)" => "%0 (current subtree)",
// "%0 Reply Handler" => "%0 Reply Handler",
// "The user [ %0 ] is not registered with this wiki and autocreate is disabled" => "The user [ %0 ] is not registered with this wiki and autocreate is disabled",
// "The user [ %0|%1 ] is not registered with this wiki and the creation process failed" => "The user [ %0|%1 ] is not registered with this wiki and the creation process failed",
// "unverified" => "unverified",
"Your Information" => "Vos informations",
"User Information" => "Information utilisateur",
"Can create/close a book" => "Droit de créer/clôturer un livre",
"Can create/edit/lock accounts" => "Pouvoir créer/éditer/verrouiller des comptes",
"Create a new transaction" => "Créer une nouvelle transaction",
// "Permission to view the journal" => "Permission to view the journal",
"Can book into the stack where statements can be changed" => "Droit d'enregistrer dans le brouillard, où des modifications peuvent être apportées",
"Can import statements from external accounts" => "Droit d'importer des relevés à partir de comptes externes",
"Can manage templates for recurring transactions" => "Droit de gérer des modèles pour les écritures récurrentes",
"Can admin the articles" => "Droit d'administrer les articles",
"Can approve submissions" => "Droit d'approuver les soumissions",
"Can admin article topics" => "Droit d'administrer les sujets d'articles",
"Can admin article types" => "Droit d'administrer les types d'articles",
"Can read article headings" => "Droit de lire les en-têtes d'articles",
"Submitted articles are automatically approved" => "Les articles soumis sont automatiquement approuvés",
"Can edit articles" => "Droit de modifier les articles",
// "Can edit the user (owner) of articles" => "Can edit the user (owner) of articles",
"Can edit submissions" => "Droit de modifier les soumissions",
// "Can read articles (applies to article or topic level)" => "Can read articles (applies to article or topic level)",
"Can remove articles" => "Droit de suppression d'articles",
"Can remove submissions" => "Droit de suppression de soumissions",
"Can submit articles" => "Droit de soumettre des articles",
"Can rate articles" => "Droit de noter les articles",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
"Can join a meeting" => "Droit de se joindre à une réunion",
"Can moderate a meeting" => "Droit de modérer une réunion",
"Can create a meeting" => "Droit de créer une réunion",
// "Can use XMPP chat" => "Can use XMPP chat",
"Can admin blogs" => "Droit d'administrer les blogues",
"Can assign perms to blog" => "Droit d'assigner des permissions sur les blogues",
"Can post to a blog" => "Droit de publier dans un blogue",
"Can create a blog" => "Droit de créer des blogues",
"Can read blogs" => "Droit de lire les blogues",
"Can view in module and feed the blog posts" => "Droit de voir les messages de blogues dans les modules et les flux",
"Can view in module and feed the blog" => "Droit de voir les blogues dans les modules et les flux",
// "Can create/admin calendars" => "Can create/admin calendars",
"Can add events in the calendar" => "Droit d'ajouter des évènements dans le calendrier",
"Can edit events in the calendar" => "Droit de modifier des évènements dans le calendrier",
"Can browse the calendar" => "Droit de parcourir le calendrier",
"Can view event details" => "Droit de voir le détail des évènements",
"Can add himself or herself to the participants" => "Droit d'ajouter un utilisateur aux participants",
"Can add guest to the participants" => "Droit d'ajouter un invité aux participants",
"Can view Tiki tools calendar" => "Droit de parcourir le calendrier des actions Tiki",
"Can admin categories" => "Droit d'administrer les catégories",
"Can see the category in a listing" => "Droit de voir la catégorie dans une liste",
"Can add objects to the category (tiki_p_modify_object_categories permission required)" => "Droit d'ajouter des objets à une catégorie (nécessite tiki_p_modify_object_categories)",
"Can remove objects from the category (tiki_p_modify_object_categories permission required)" => "Droit de retirer des éléments de la catégorie (nécessite tiki_p_modify_object_categories)",
// "Can assign perms to category" => "Can assign perms to category",
"Administrator can create channels, remove channels, etc" => "L'administrateur peut créer des canaux, en supprimer, etc.",
"Can use the chat system" => "Droit d'utiliser le système de discussions (chat)",
"Can admin received articles" => "Droit d'administrer les articles reçus",
"Can admin received pages" => "Droit d'administrer les pages reçues",
"Can send articles to other sites" => "Droit d'envoyer des articles vers d'autres sites",
"Can send articles to this site" => "Droit d'envoyer des articles à ce site",
"Can send pages to this site" => "Droit d'envoyer des pages à ce site",
"Can send pages to other sites" => "Droit d'envoyer des pages vers d'autres sites",
"Can post new comments" => "Droit de publier de nouveaux commentaires",
"Can read comments" => "Droit de lire des commentaires",
"Can admin comments" => "Droit d'administrer les commentaires",
"Can edit all comments" => "Droit d'édition de tous les commentaires",
"Can delete comments" => "Droit de supprimer des commentaires",
"Can vote on comments" => "Droit de voter pour un commentaire",
"Can admin content templates" => "Droit d'administrer les gabarits de contenu",
"Can edit content templates" => "Droit de modifier les gabarits de contenu",
// "Can lock content templates" => "Can lock content templates",
"Can use content templates" => "Droit d'utiliser des gabarits de contenu",
"Can admin contributions" => "Droit d'administrer les contributions",
"Can admin the directory" => "Droit d'administrer le répertoire des liens",
"Can admin directory categories" => "Droit d'administrer les catégories de répertoire",
"Can admin directory sites" => "Droit d'administrer l'annuaire des sites",
"Submitted links are valid" => "Les liens soumis sont valides",
"Can submit sites to the directory" => "Droit de soumettre des sites au répertoire des liens",
"Can validate submitted links" => "Peut valider des liens soumis",
"Can use the directory" => "Droit d'utiliser le répertoire des liens",
"Can execute arbitrary queries on a given DSN" => "Droit d'exécuter une réquête quelconque sur un DSN donné",
"Can admin FAQs" => "Droit d'administrer les FAQs",
"Can suggest FAQ questions" => "Droit de suggérer des questions dans les FAQs",
"Can view FAQs" => "Droit de voir les FAQs",
"Can download files" => "Droit de télécharger des fichiers",
"Can upload files" => "Droit d'envoyer (upload) des fichiers",
"Can list file galleries" => "Droit de lister les galeries de fichiers",
"Can view file galleries" => "Droit de voir les galeries de fichiers",
"Can admin file galleries" => "Droit d'administrer les galeries de fichiers",
"Can assign permissions to file galleries" => "Droit d'assigner des permissions sur les galeries de fichiers",
"Can use Directory Batch Load" => "Droit d'utiliser le chargement par lot dans le répertoire des liens",
"Can upload .zip file packages" => "Droit d'envoyer des fichiers zip avec les fichiers",
"Can create file galleries" => "Droit de créer des galeries de fichiers",
"Can edit a gallery file" => "Droit d'édition d'un fichier de la galerie",
"Can remove files" => "Pouvoir supprimer des fichiers",
"Can view file galleries explorer" => "Droit de voir l'explorateur de galeries de fichiers",
"Can view file galleries path" => "Droit de voir le chemin des galeries de fichiers",
// "Can upload files containing JavaScript" => "Can upload files containing JavaScript",
// "Can upload SVG files" => "Can upload SVG files",
"Can admin forums" => "Droit d'administrer les forums",
"Can attach files to forum posts" => "Droit d'attacher des fichiers aux articles du forum",
"Auto approve forum posts" => "Validation automatique des articles du forum",
"Can post in forums" => "Droit de publier dans le forum",
"Can start threads in forums" => "Droit de démarrer des fils de discussion dans le forum",
"Can read forums" => "Droit de lire des forums",
"Can report posts to moderator" => "Droit de rapporter des message au modérateur",
"Can vote on comments in forums" => "Droit de voter pour des commentaires dans les forums",
"Can browse tags" => "Droit de parcourir les mots-clés",
"Can admin tags" => "Droit d'administrer les mots-clés",
"Can tag objects" => "Droit de marquer des objets",
"Can unassign tags from an object" => "Droit de supprimer des tags associés à un objet",
"Can subscribe to groups" => "Droit de s'inscrire dans les groupes",
"Can invite user to my groups" => "droit d'inviter un utilisateur dans mes groupes",
"Can view the group" => "Droit de voir les groupes",
"Can view the group members" => "Droit de voir les membres d'un groupe",
"Can add group members" => "Droit d'ajouter les membres aux groupes",
"Can remove group members" => "Droit de retirer des membres d'un groupe",
"Can join or leave the group" => "Droit de rejoindre ou quitter un groupe",
// "Can view H5P content" => "Can view H5P content",
// "Can edit H5P content" => "Can edit H5P content",
// "Can administer H5P content" => "Can administer H5P content",
"Can edit HTML pages" => "Droit de modifier les pages HTML",
"Can view HTML pages" => "Droit de voir les pages HTML",
"Can admin Image Galleries" => "Droit d'administrer les galeries d'images",
"Can assign permissions to image galleries" => "Droit d'assigner les droits d'accès des galeries d'images",
"Can upload .zip files of images" => "Droit d'envoyer des fichiers zip avec les images",
"Can create image galleries" => "Droit de créer des galeries d'images",
"Can list image galleries" => "Droit de lister le contenu des galeries d'images",
"Can upload images" => "Droit d'envoyer (upload) des images",
"Can view image galleries" => "Droit de voir les galeries d'images",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
"Can broadcast messages to all users" => "Droit de diffuser des messages vers tous les utilisateurs",
"Can broadcast messages to groups" => "Droit de diffuser des messages vers les groupes",
"Can use the messaging system" => "Droit d'utiliser le système de messagerie",
"Can admin newsletters" => "Droit d'administrer les lettres d'informations",
"Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)" => "Droit de soumettre des adresses mail par lot (recquiert tiki_p_subscribe email)",
"Can send newsletters" => "Droit d'envoyer des lettres d'informations",
"Can subscribe any email address to newsletters" => "Droit de souscrire toute adresse mail aux lettres d'informations",
"Can subscribe to newsletters" => "Droit de s'inscrire à des lettres d'informations",
"Can view the archive of a newsletters" => "Droit de voir les archives d'une newsletter",
"Can list newsletters" => "Droit de lister les newsletters",
"Can administer payments" => "Droits d'administrer les paiements",
"Can view payment requests and details" => "Droit de voir les requêtes de payements ainsi que les détails",
"Can enter manual payments" => "Droit d'entrer un paiement manuel",
"Can request a payment" => "Droit de demander un paiement",
"Can view the perspective" => "Droit de voir la perspective",
"Can edit the perspective" => "Droit d'éditer une perspective",
"Can create a perspective" => "Droit de créer une perspective",
"Can admin perspectives" => "Droits d'administrer les perspectives",
"Can admin polls" => "Droit d'administrer les sondages",
"Can view poll results" => "Droit de voir des résultats de sondages",
// "Can view poll user choices" => "Can view poll user choices",
"Can vote in polls" => "Droit de voter à un sondage",
"Can view poll voters" => "Droit de voir les votants d'un vote",
"Can admin quizzes" => "Droit d'administrer les QCMs",
"Can take quizzes" => "Droit de remplir des QCMs",
"Can view quiz stats" => "Droit de voir les statistiques du QCM",
"Can view user quiz results" => "Droit de voir les résultats des QCMs",
"Can admin spreadsheets" => "Droit d'administrer les feuillets",
"Can create and edit spreadsheets" => "Droit de créer et éditer des feuillets",
"Can view spreadsheets" => "Droit de voir les feuillets",
"Can view spreadsheets history" => "Droit de voir l'historique des feuillets",
"Can admin the shoutbox (edit/remove messages)" => "Droit d'administrer le mégaphone (Modifier/supprimer les messages)",
"Can post messages in the shoutbox" => "Droit de publier des messages dans le mégaphone",
"Can view the shoutbox" => "Droit de voir le mégaphone",
"Can use social network integration" => "l'utilisateur peut utiliser l'intégration des réseaux sociaux",
// "Can register this site with social networks" => "Can register this site with social networks",
"Admin live support system" => "Administrer le système d'assistance en ligne",
"Can use live support system" => "Droit d'utiliser le système de support en ligne",
"Can admin surveys" => "Droit d'administrer les enquêtes",
"Can take surveys" => "Droit de remplir des enquêtes",
"Can view survey stats" => "Droit de voir les statistiques des enquêtes",
"Can admin TikiTests" => "Droit d'administrer les TikiTests",
"Can edit TikiTests" => "Droit d'éditer des TikiTests",
"Can replay TikiTests" => "Droit de rejouer des TikiTests",
"Can admin trackers" => "Droit d'administrer les formulaires",
"Can attach files to tracker items" => "Droit d'attacher des fichiers aux fiches de formulaire",
"Can view tracker item attachments and download them" => "Droit de voir les pièces jointes aux fiches de formulaires et de les télécharger",
"Can post tracker item comments" => "Droit d'ajouter des commentaires aux fiches de formulaire",
"Can view tracker item comments" => "Droit de voir les commentaires des fiches de formulaires",
"Can create new tracker items" => "Droit de créer de nouvelles fiches de formulaire",
"Can list trackers" => "Droit de lister les formulaires",
"Can change tracker items" => "Droit de changer des fiches de formulaire",
"Can change pending tracker items" => "Droit de modifier les fiches des formulaires en attente",
"Can change closed tracker items" => "Droit de modifier les éléments des formulaires clos",
"Can remove tracker items" => "Droit de supprimer des fiches de formulaire",
"Can remove pending tracker items" => "Droit de supprimer des fiches de formulaires en attente",
"Can remove closed tracker items" => "Peut supprimer les fiches de formulaires clôturées",
"Can view rating result for tracker items" => "Droit de voir les notations pour les fiches de formulaire",
"Can rate tracker items" => "Droit de noter les fiches de formulaire",
"Can re-rate tracker items" => "Droit de re-voter une note pour un élément de formulaire",
"Can view trackers" => "Droit de voir les formulaires",
"Can view closed trackers items" => "Droit de voir les éléments de formulaires fermés",
"Can view pending trackers items" => "Droit de voir les élément de formulaire en attente",
"Can watch a tracker" => "Droit de surveiller les formulaires",
"Can export tracker items" => "Droit d'exporter des fiches de formulaires",
"Can save a CSV backup of all trackers" => "Droit de sauvegarder au format CSV tous les formulaires",
// "Manage tracker views" => "Manage tracker views",
// "View list view of tracker tabular data. Tracker item permissions apply" => "View list view of tracker tabular data. Tracker item permissions apply",
// "Export a tracker tabular view to CSV. Tracker permissions may not apply" => "Export a tracker tabular view to CSV. Tracker permissions may not apply",
// "Import a CSV file into a tabular tracker. Tracker permissions may not apply" => "Import a CSV file into a tabular tracker. Tracker permissions may not apply",
"Can trigger the transition between two states" => "Droit de déclencher une transition entre deux états",
"Can admin users" => "Droit d'administrer les utilisateurs",
"Can cache user bookmarks" => "Droit de mettre des signets en antémémoire",
"Can configure modules" => "Droit de configurer des modules",
"Can create user bookmarks" => "Droit de créer des signets utilisateur",
"Can use the mini event calendar" => "Droit d'utiliser Mon Calendrier",
"Can use the notepad" => "Droit d'utiliser le bloc-notes",
"Can admin public tasks" => "Droit d'administrer les tâches publiques",
"Can use tasks" => "Droit d'utiliser les tâches",
"Can receive tasks from other users" => "Pouvoir recevoir des tâches d'autres utilisateurs",
"Can send tasks to other users" => "Droit d'envoyer des tâches à d'autres utilisateurs",
"Can upload personal files" => "Droit d'envoyer (upload) des fichiers personnels",
"Can create items in personal menu" => "Droit de créer des éléments du menu personnel",
"Can list registered users" => "Droit de lister les utilisateurs enregistrés",
"Can invite users by email, and include them in groups" => "Droit d'inviter des utilisateurs par courriel, et les inclure dans des groupes",
"Can delete his/her own account" => "Droit d'effacer son propre compte",
"Can use webmail" => "Droit d'utiliser le webmail",
"Can use group webmail" => "Droit d'utiliser le webmail de groupe",
"Can admin group webmail accounts" => "Droit d'administrer les comptes webmail de groupe",
"Can use personal webmail accounts" => "Droit d'utiliser des comptes webmail personnels",
"Can admin personal webmail accounts" => "Droit d'administrer les comptes webmail personnels",
"Can view page/pages" => "Droit de voir les pages wiki",
"Can edit pages" => "Droit de modifier des pages wiki",
// "Can inline-edit pages" => "Can inline-edit pages",
"Can view wiki history" => "Droit de voir l'historique des pages wiki",
"Can admin the wiki" => "Droit d'administrer le wiki",
"Can assign permissions to wiki pages" => "Droit d'assigner des permissions aux pages wiki",
"Can edit copyright notices" => "Droit de modifier les messages de copyright",
"Can edit dynamic variables" => "Droit de modifier les variables dynamiques",
"Can export wiki pages using the export feature" => "Droit d'exporter des pages wiki avec la fonctionnalité d'export",
"Can lock pages" => "Droit de verrouiller des pages",
"Can save as a minor edit" => "Droit d'enregistrer en tant que version mineure",
"Can remove" => "Droit de supprimer les pages Wiki",
"Can rename pages" => "Droit de renommer des pages",
"Can roll back pages" => "Droit de revenir vers des versions antérieures",
"Can upload pictures to wiki pages" => "Droit d'envoyer des images vers des pages wiki",
// "Can use the page as a template for a tracker or unified search" => "Can use the page as a template for a tracker or unified search",
"Can view in module and feed the wiki pages reference" => "Droit de voir les reference des pages wiki dans les modules et les flux",
"Can admin attachments on wiki pages" => "Droit d'administrer les pièces jointes aux pages wiki",
"Can add and change ratings on wiki pages" => "Droit d'ajouter et modifier les notes associées aux pages du wiki",
"Can attach files to wiki pages" => "Droit d'attacher des fichiers aux pages wiki",
"Can view and download wiki page attachments" => "Droit de voir les pièces jointes aux pages wiki et de les télécharger",
"Can view wiki comments" => "Droit de voir les commentaires associés aux pages wiki",
"Can view rating of wiki pages" => "Droit de voir les notations des pages du wiki",
"Can view source of wiki pages" => "Droit de voir le source des pages wiki",
"Can participate in rating of wiki pages" => "Droit de participer à la notation des pages wiki",
"Can view similar wiki pages" => "Droit de voir les pages wiki similaires",
"View page backlinks" => "Droit de voir les liens arrière (backlinks)",
"Can view unapproved revisions of pages" => "Droit d'afficher les modifications non approuvées des pages",
"Can approve revisions of pages" => "Droit d'approuver les modifications de pages",
"Can view contributions to a page" => "Droit de voir les contributions à une page",
// "Can use reference library items" => "Can use reference library items",
// "Can add to, edit and remove reference library items" => "Can add to, edit and remove reference library items",
// "Can administer structures" => "Can administer structures",
"Can create and edit structures" => "Droit de créer et éditer des structures",
// "Can lock structures" => "Can lock structures",
"Can watch structures" => "Droit de voir les structures",
"Administrator can manage users, groups and permissions and all features" => "L'administrateur peut gérer les utilisateurs, les groupes, les droits et toutes les fonctionnalités",
"Can access site when closed" => "Droit d'accés au site lorsqu'il est fermé",
"Administrator can admin banners" => "L'administrateur peut administrer les bannières",
"Can ban users or IP addresses" => "Droit de bannir des utilisateurs ou des adresses ip",
"Can admin the dynamic content system" => "Droit d'administrer le système de contenu dynamique",
"Can admin integrator repositories and rules" => "Droit d'administrer les dépots d'intégration Tiki et les règles",
// "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n" => "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n",
"Can admin mail-in accounts" => "Droit d'administrer les comptes mail-in",
"Can edit object permissions" => "Droit de modifier les permissions des objets",
"Can admin external feeds" => "Droit d'administrer les flux externes",
"Can clean cache" => "Droit de vider le cache",
"Can create a new CSS file (style sheet) appended with -user" => "Droit de créer des css suffixé avec -user",
"Can remove the association between two pages in a translation set" => "Droit de supprimer l'association entre des pages d'un jeu de traduction",
"Can admin cookies" => "Droit d'administrer les cookies",
"Can edit translations and create new languages" => "Droit de modifier les traductions et d'ajout de nouvelles langues",
"Can edit menus" => "Droit de modifier les menus",
"Can edit menu options" => "Droit de modifier les options des menus",
"Can edit site templates" => "Droit de modifier les gabarits de site",
"Can search" => "Droit de rechercher",
"Can report a link to the webmaster" => "Droit de signaler un lien à l'administrateur du site",
"Can send a link to a friend" => "Droit d'envoyer un lien à un ami",
"Can share a page (email, Twitter, Facebook, message, forums)" => "Droit de partager une page (email, Twitter, Facebook, message, forums)",
"Can use HTML in pages" => "Droit d'utiliser du code HTML dans les pages",
"Can view action log" => "Droit de voir le journal des actions",
"Can view the action log for users of his or her groups" => "Droit de voir le journal des actions pour ses propres groupes",
"Can view integrated repositories" => "Droit de lecture sur les dépots d'intégration",
// "Can view results from user ratings" => "Can view results from user ratings",
"Can view referrer stats" => "Droit de voir les statistiques des pages référantes",
"Can view site stats" => "Droit de voir les statistiques du site",
"Can view site templates" => "Droit de voir les modèles du site",
// "Can view results from webservice requests" => "Can view results from webservice requests",
// "Can administer webservices" => "Can administer webservices",
"Can admin toolbars" => "Droit d'administrer les barres d'outils",
"Trust all user inputs including plugins (no security checks)" => "Faire confiance à toutes les saisies de l'utilisateur y compris les plugiciels (aucune vérification de sécurité)",
"Can view unapproved plugin details" => "Droit de voir les détails des plugiciels non autorisés",
"Can execute unapproved plugin registered" => "Droit d'exécuter des plugiciels non autorisés enregistré",
"Can approve plugin execution" => "Droit d'autoriser l'exécution des plugiciels",
"Can admin mail notifications" => "Droit d'administrer les notifications par mail",
"Can use the importer" => "Droit d'utiliser l'importateur",
"Can change the categories of an object" => "Droit de changer la catégorie d'un objet",
"User can administer modules" => "Droit d'administrer les modules",
"Can switch between wiki and WYSIWYG modes while editing" => "Droit de basculer entre les modes wiki et WYSIWYG pendant l'édition",
// "Can create a new workspace for a given template" => "Can create a new workspace for a given template",
// "Can manage all aspects of a goal" => "Can manage all aspects of a goal",
// "Can manage who is eligible for a goal" => "Can manage who is eligible for a goal",
// "Cannot add user %0 to nonexistent group %1" => "Cannot add user %0 to nonexistent group %1",
// "Cannot add nonexistent user %0 to group %1" => "Cannot add nonexistent user %0 to group %1",
"User \"%0\" is banned from the group \"%1\"" => "L'utilisateur \"%0\" est banni du groupe \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
// "Email cannot be set because this email is already in use by another user" => "Email cannot be set because this email is already in use by another user",
// "Password should be at least %0 characters long" => "Password should be at least %0 characters long",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"" => "Le mot de passe doit contenir au moins un caractère alphabétique en minuscule comme 'a' et un en majuscule comme 'A'",
"Password must contain both letters and numbers" => "Le mot de passe doit contenir des lettres et des chiffres",
"Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Le mot de passe doit contenir au moins un caractères spécial en minuscule comme \" / \$ % ? & * ( ) _ + ..",
// "The password is blacklisted because it is too common" => "The password is blacklisted because it is too common",
// "No user tracker found with id #%0" => "No user tracker found with id #%0",
"The administrator has not yet validated your account. Please wait." => "L'administrateur n'a pas encore validé votre compte. Attendez SVP.",
"You must validate your account first. An email has been sent to you" => "Vous devez tout d'abord valider votre compte. Un courriel vous a été envoyé",
// "Email address is required" => "Email address is required",
// "Invalid email address \"%0\"" => "Invalid email address \"%0\"",
// "Unable to send mail to invite \"%0\"" => "Unable to send mail to invite \"%0\"",
// "The email could not be retrieved from the IdP and is required" => "The email could not be retrieved from the IdP and is required",
// "The username could not be retrieved from the IdP and is required" => "The username could not be retrieved from the IdP and is required",
// "SAML Login failed. User not authenticated" => "SAML Login failed. User not authenticated",
"Can edit one's own forum posts" => "Droit de modifier ses propres articles du forum",
"The registration mail can't be sent. Contact the administrator" => "Le message de confirmation ne peut être envoyé. Contactez l'administrateur",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "Le message d'enregistrement n'a pas pu être envoyé puisqu'aucun serveur de messagerie n'est configuré, et cette fonctionnalité est désactivée",
"The user email confirmation can't be sent. Contact the administrator" => "Le courriel de confirmation n'a pas pu être envoyé. Contactez l'administrateur SVP",
// "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)",
"Edit field: (Incorrect validation parameter)" => "Modifier un champ : (Paramètre de validation incorrect)",
"Page already exists" => "La page existe déjà",
"Page does not exist" => "La page n'existe pas",
// "Email already in use" => "Email already in use",
"Invalid email" => "Adresse électronique invalide",
"Invalid character combination for username" => "Combinaison de caractères incorrecte pour le nom d'utilisateur",
// "Username must be all lower case" => "Username must be all lower case",
"Personal Phone" => "Téléphone privé",
"Personal Mobile" => "Portable privé",
"Personal Fax" => "Télécopieur privé",
"Work Phone" => "Téléphone professionnel",
"Work Mobile" => "Portable professionnel",
"Work Fax" => "Fax professionnel",
"Company" => "Société",
"Organization" => "Organisation",
"Department" => "Départment",
"Division" => "Division",
"Job Title" => "Poste",
"Street Address" => "Adresse postale",
"City" => "Ville",
"State" => "État",
"Postal Code" => "Code postal",
// "Mail to: User not found" => "Mail to: User not found",
"(AT)" => "(À)",
"(DOT)" => "(PT)",
// "Webservice error on %0 request \"%1\"" => "Webservice error on %0 request \"%1\"",
// "You will need to rebuild the search index to see these changes" => "You will need to rebuild the search index to see these changes",
// "Parse To Wiki %0: preg_replace error #%1" => "Parse To Wiki %0: preg_replace error #%1",
"Cannot create aliased page" => "Ne peut pas créer un alias de page",
"You attempted to create the following page" => "Vous avez tenté de créer la page suivante",
"That page is an alias for the following pages" => "Cette page est un alias pour les pages suivantes",
"If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this" => "Si vous voulez créer la page, vous devez d'abord modifier chacune des pages ci-dessus, et supprimer les liens d'alias que chacune peut contenir. Ce lien devrait se présenter à peu près comme ceci",
"Can't parse HTML data - no grammar file" => "Impossible de convertir les données HTML - aucun fichier de grammaire",
"Rollback by %0 to version %1" => "Retour à la version %1 par %0",
"Removed version \$version" => "Version \$version supprimée",
"Changed actual version to \$version" => "Version courante changée en \$version",
"No version indicated" => "Aucune version indiquée",
"Plugin " => "Plugiciel",
"failed" => "a échoué",
"Required parameters are in</em> <b>bold</b>" => "Les paramètres requis sont en</em> <b>gras</b>",
"Parameter Info" => "Information de paramètre",
"There are no approved versions of this page" => "Il n'y a pas de versions approuvées de cette cette page",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
"Page locked" => "Page verrouillée",
"Page unlocked" => "Page déverrouillée",
// "Initial content copied from version %0 of page %1" => "Initial content copied from version %0 of page %1",
// "You don't have permission to use category '%0'" => "You don't have permission to use category '%0'",
// "You don't have permission to edit categories" => "You don't have permission to edit categories",
// "You don't have permission to edit tags" => "You don't have permission to edit tags",
"Removed last version" => "Dernière version supprimée",
// "Activity Stream" => "Activity Stream",
// "Create a social network activity stream" => "Create a social network activity stream",
// "List configuration information" => "List configuration information",
// "Auto-Scroll" => "Auto-Scroll",
// "Automatically load next page of results when scrolling down" => "Automatically load next page of results when scrolling down",
"Add Tag" => "Ajouter un mot-clé",
// "Provide an input field for adding a tag to an object" => "Provide an input field for adding a tag to an object",
// "Object type and id, as in %0type:id%1, if unset, will use current object" => "Object type and id, as in %0type:id%1, if unset, will use current object",
// "Add Reference" => "Add Reference",
// "Add a bibliography reference" => "Add a bibliography reference",
// "Biblio Code" => "Biblio Code",
// "The code to be added as reference" => "The code to be added as reference",
// "missing bibliography definition" => "missing bibliography definition",
"Add Relation" => "Ajouter une relation",
// "Provide a button to toggle a pre-specified relation" => "Provide a button to toggle a pre-specified relation",
"Qualifier" => "Qualifiant",
"Relation qualifier. Usually a three-part string separated by two periods" => "Qualifiant de la relation. Usuellement, une chaîne en trois parties séparées par deux points",
"Source Object" => "Objet source",
// "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank",
"Target Object" => "Objet cible",
// "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank",
"Button Text for Add" => "Texte du bouton pour ajouter",
"Text to show on the button to add relation" => "Texte à afficher sur le bouton pour ajouter la relation",
"Button Text for Already Added State" => "Texte du bouton pour relation déjà ajoutée",
"Text to show on the button when relation is already added" => "Texte à afficher sur le bouton quand la relation est déjà ajoutée",
"Relation Added" => "Relation ajoutée",
"Mouseover Button Text for Remove" => "Texte en survol de souris du bouton pour retirer",
"Text to show on the button to remove relation" => "Texte à afficher sur le bouton pour retirer la relation",
"Remove Relation" => "Retirer la relation",
"Button ID" => "Id du bouton",
"A unique ID to distinguish the button from others on the page if there is more than one" => "Un ID unique pour distinguer le bouton si des autres sont présents sur la page",
// "Set Button Class" => "Set Button Class",
// "Class or classes for the Button" => "Class or classes for the Button",
"Source and target object cannot be the same" => "Source et cible ne peuvent être identiques",
"Add to cart" => "Ajouter au panier",
"PluginAddToCart" => "Plugiciel Ajouter Au Panier",
// "Add a product to the shopping cart" => "Add a product to the shopping cart",
"Product code" => "Code produit",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
"Product Type" => "Type du Produit",
// "The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to. Can be used to limit how gift cards are used" => "The class the product belongs to. Can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart" => "The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to. Can be used to limit how gift cards are used" => "The class the bundle belongs to. Can be used to limit how gift cards are used",
"Price" => "Prix",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)" => "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)",
"Button label" => "Nom du bouton",
// "Text for the submit button. default" => "Text for the submit button. default",
"Associated event code" => "Code de l'évènement associé",
"Unique identifier for the event that is associated to the product" => "Identifiant unique pour l'événement qui est associé au produit",
"Automatically check out" => "Régler automatiquement",
"Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)" => "Régler automatiquement l'achat et diriger l'utilisateur vers le paiement (ceci est désactivé si il y a déjà quelque chose dans le panier)",
// "Hide Quantity" => "Hide Quantity",
// "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)" => "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)",
"Buy on behalf of" => "Acheter au nom de",
"Allows the selection of user to make purchase on behalf of" => "Autorise la sélection d'un utilisateur pour faire l'achat au nom de",
// "Shop as anonymous always" => "Shop as anonymous always",
"Add to cart as anonymous shopper even if logged in" => "Ajouter au panier en tant qu'acheteur anonyme même si connecté",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
"Gift certificate" => "Certificat-cadeau",
"Allows user to add gift certificate from the product view" => "Autorise l'utilisateur à ajouter un certificat-cadeau à partir de la vue produit",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
"Amount of new product to exchange for" => "Quantité du nouveau produit en échange",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
"Ajax add to cart feature" => "Fonctionnalité Ajax ajouter au panier",
"Attempts to turn on Ajax for the cart" => "Tente d'activer Ajax pour le panier",
"Weight" => "Poids",
// "The weight of the item" => "The weight of the item",
"The order was recorded and is now awaiting payment. Reference number is %0" => "La commande a été enregistrée et attend le réglement. Le numéro de référence est %0",
"Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Votre commande gratuite %0 (%1) a été traitée. Un courriel vous a été adressé pour vos archives",
"Your free order of %0 (%1) has been processed" => "Votre commande gratuite %0 (%1) a été traitée",
"%0 (%1) was added to your cart" => "%0 (%1) a été ajouté à votre panier",
"Add to Google Calendar" => "Ajouter au calendrier Google",
"Add a calendar item to a Google calendar." => "Ajouter un élément à un calendrier Google",
"Calendar item ID" => "ID d'événement du calendrier",
"The item ID of the calendar to add to Google calendar" => "L'ID d'élément du calendrier à ajouter au calendrier Google",
"A calendar item ID number" => "Numéro d'identification d'un événement du calendrier",
"Icon Style" => "Style d'Icône",
"Choose the icon style" => "Choisir le style d'icône",
"Either 1, 2 or 3" => "Soit 1, 2 ou 3",
"Adjust Inventory" => "Ajuster l'inventaire",
"PluginAdjustInventory" => "PluginAdjustInventory",
// "Adjust the inventory level of a product" => "Adjust the inventory level of a product",
"Product ID" => "ID de Produit",
"Product ID of item in the cart tracker" => "ID de Produit de la fiche dans le formulaire panier",
// "Show Add" => "Show Add",
// "Show option to add to inventory" => "Show option to add to inventory",
// "Show Subtract" => "Show Subtract",
// "Show option to subtract from inventory" => "Show option to subtract from inventory",
"Inventory was adjusted by %0" => "L'inventaire a été ajusté par %0",
"User Agent Info" => "Infos Agent Utilisateur",
"Show the user's browser and server information." => "Afficher les informations du navigateur de l'utilisateur et du serveur",
"Info" => "Info",
"Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Affiche l'adresse IP du visiteur (IP ou par défaut), les informations du navigateur (BROWSER), ou le logiciel du serveur (SVRSW)",
"IP address" => "Adresse IP",
"Server software" => "Logiciel serveur",
"Browser" => "Navigateur",
// "Ajax Load" => "Ajax Load",
// "Load data into an HTML div using Ajax or in an iframe" => "Load data into an HTML div using Ajax or in an iframe",
// "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML" => "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML",
// "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1" => "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1",
// "Selector" => "Selector",
// "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1" => "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1",
"Target" => "Cible",
// "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page" => "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page",
// "HTML id for the div or iframe" => "HTML id for the div or iframe",
// "Class for the div or iframe" => "Class for the div or iframe",
// "In pixels or percentage. Default value is %0" => "In pixels or percentage. Default value is %0",
// "Make Links Absolute" => "Make Links Absolute",
// "Convert relative links in the incoming data to be absolute. Default value is \"All\"" => "Convert relative links in the incoming data to be absolute. Default value is \"All\"",
// "Images Only" => "Images Only",
// "Links Only" => "Links Only",
// "Parameter URL missing" => "Parameter URL missing",
"Anchor Link" => "Ancre",
"Create a link to an anchor" => "Créer un lien vers une ancre",
"Anchor link label" => "Etiquette du lien d'ancre",
"Anchor Name" => "Nom de l'Ancre",
"The anchor name as defined in the Aname plugin" => "Le nom de l'ancre telle que définie dans le plugiciel ANAME",
"The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "Le nom de la page wiki contenant l'ancre. Si vide, l'ancre sera recherchée dans la page wiki où le plugiciel est utilisé",
"Create an anchor that can be linked to" => "Créer une ancre qui peut être la cible d'un lien",
"The name of the anchor" => "Nom de l'ancre",
"Image Annotation" => "Annotation d'image",
"Annotate an image" => "Annoter une image",
"Autogenerated content. Leave blank initially" => "Contenu autogénéré. Laisser à blanc au départ",
// "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0" => "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0",
// "Absolute URL to the image or relative path from Tiki site root" => "Absolute URL to the image or relative path from Tiki site root",
"Image width in pixels" => "Largeur d'image en pixels",
"Image height in pixels" => "Hauteur d'image en pixels",
"Alignment" => "Alignement",
// "Image alignment" => "Image alignment",
"Center" => "Centre",
"CSS Class" => "Classe CSS",
// "Class of the containing DIV element" => "Class of the containing DIV element",
// "Show List" => "Show List",
// "Show the list of annotations below the image" => "Show the list of annotations below the image",
// "(y/n)" => "(y/n)",
"Show Link" => "Afficher le Lien",
// "Show the link below the label in the popups" => "Show the link below the label in the popups",
"Save changes to annotations" => "Enregistre les modifications dans annotations",
"Image annotations changed" => "Les annotations sur l'image ont été modifiées",
"Editable" => "Éditable",
"Label" => "Étiquette",
// "Application Frame" => "Application Frame",
// "Create a frame in which to assemble custom applications" => "Create a frame in which to assemble custom applications",
// "Application layout" => "Application layout",
// "Minimum height" => "Minimum height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Maximum height" => "Maximum height",
// "Prevent the frame from becoming any higher than the specified size" => "Prevent the frame from becoming any higher than the specified size",
"Hide left column" => "Masquer la colonne de gauche",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
"Hide right column" => "Masquer la colonne de droite",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Completely fill the content area of the page" => "Completely fill the content area of the page",
// "Absolute Position" => "Absolute Position",
// "Use all available space for the application frame (by means of CSS absolute positioning)" => "Use all available space for the application frame (by means of CSS absolute positioning)",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Fill the complete page" => "Fill the complete page",
// "Template file not found: %0" => "Template file not found: %0",
"Pan/Zoom" => "Déplacer/Zoomer",
"Select" => "Choisir",
"Select/Modify" => "Sélectionner/Modifier",
"Draw Polygon" => "Dessiner une forme",
"Draw Path" => "Tracer une ligne",
"Reset Zoom" => "Zoom d'origine",
"Archive Builder" => "Constructeur d'archive",
// "Define an archive that can be downloaded" => "Define an archive that can be downloaded",
"Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description du contenu de l'archive. Plusieurs gestionnaires sont disponibles pour les types de contenu. Un par ligne. Ex. : page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
"Archive Name" => "Nom de l'archive",
"Upon download, the name of the file that will be provided" => "Lors du téléchargement, le nom du fichier qui sera fourni",
"Missing \".zip\" file name extension" => "Extension zip manquante",
"Incorrect parameter" => "Paramètre érroné",
"Download archive" => "Télécharger l'archive",
"Display a field of an article" => "Afficher un champ d'un article",
"The article field (component) to display. The default field is \"Heading\"" => "Champ de l'article à afficher. Champ par défaut : en-tête",
"Article ID" => "ID de l'article",
"The article to display. If no value is provided, the most recent article will be used" => "Article à afficher. En l'absence de valeur, affichage de l'article le plus récent",
"Article List" => "Liste d'articles",
"Display multiple articles" => "Afficher des articles",
"Use Pagination" => "Utiliser la pagination",
// "Activate pagination when the articles list is long. Default is %0" => "Activate pagination when the articles list is long. Default is %0",
"Maximum Displayed" => "Maximum affiché",
// "The number of articles to display in the list (use %0 to show all)" => "The number of articles to display in the list (use %0 to show all)",
"Topic Name Filter" => "Filtre de nom de sujet",
"Filter the list of articles by topic. Example: " => "Filtrer la liste des articles par leur sujet. Exemple : ",
"Topic ID Filter" => "Filtre d'ID de sujet",
"Filter the list of articles by topic ID. Example: " => "Filtrer la liste des articles par leur ID de sujet. Exemple : ",
// "Valid topic IDs" => "Valid topic IDs",
"Type Filter" => "Filtre de type",
"Filter the list of articles by types. Example: " => "Filtrer la liste des articles par leurs types. Exemple : ",
// "Valid article types" => "Valid article types",
"Category ID" => "ID de la catégorie",
// "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted" => "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted",
"List only articles in this language" => "Lister seulement les articles dans cette langue",
// "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items" => "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items",
// "random or column names to add _asc _desc to: " => "random or column names to add _asc _desc to: ",
"Specific order" => "Ordre spécifique",
"List of ArticleId that must appear in this order if present" => "Liste d'IDs d'articles qui doivent apparaître dans cet ordre si ils sont présents",
"Only these articles" => "Seulement ces articles",
// "List of article IDs to display, separated by \"%0\"" => "List of article IDs to display, separated by \"%0\"",
"Not these articles" => "Pas ces articles",
// "List of article IDs to not display, separated by \"%0\"" => "List of article IDs to not display, separated by \"%0\"",
"Quiet" => "Silencieux",
"Whether to not report when there are no articles (no reporting by default)" => "S'il faut ne pas rapporter quand il n'y a pas d'articles (ne rapporte pas par défaut)",
"Title Only" => "Titre seulement",
"Whether to only show the title of the articles (not set to title only by default)" => "S'il faut seulement montrer le titre des articles (ne pas montrer le titre seulement par défaut)",
"Show Article Body" => "Afficher le corps de l'article",
// "Whether to show the body of the articles instead of the heading (not set by default)" => "Whether to show the body of the articles instead of the heading (not set by default)",
"Starting Article" => "Article de départ",
// "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)" => "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)",
"This will not work if Pagination is used" => "Ceci ne fonctionnera pas si la pagination est utilisée",
"Start Date" => "Date de début",
"Earliest date to select articles from" => "Date la plus ancienne pour sélectionner des articles",
// " (%0YYYY-MM-DD%1)" => " (%0YYYY-MM-DD%1)",
"Latest date to select articles from" => "Date la plus récente pour sélectionner des articles",
"Period quantity" => "Nombre de périodes",
// "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored" => "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored",
"Period unit" => "Unité de période",
"Time unit used with \"Period quantity\"" => "Unité de temps utilisée par \"Nombre de périodes\"",
"Override Dates" => "Ne pas tenir compte des dates",
// "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)" => "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)",
"Containing class" => "Classe du conteneur",
// "CSS class to add to the containing \"div.article\" (default: \"%0\")" => "CSS class to add to the containing \"div.article\" (default: \"%0\")",
// "Valid CSS class" => "Valid CSS class",
"Large First Image" => "Taille première image",
// "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article" => "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article",
"Additional URL parameter for the link to read the article" => "Paramètre additionnel de l'URL du lien pour lire l'article",
"Show actions (buttons and links)" => "Afficher les actions (boutons et liens)",
// "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do",
"No translation" => "Pas de traduction",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language",
// "Use Source URL" => "Use Source URL",
// "Use the external source URL as link for articles" => "Use the external source URL as link for articles",
// "Display an attachment or a list of them" => "Display an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment",
"File" => "Fichier",
"Same as name" => "Idem à name",
// "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page",
"Show Description" => "Afficher la description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
"Bullets" => "Puces",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)",
"Custom Label" => "Texte du Lien Personnalisé",
// "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed" => "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)",
"Order Number" => "Numéro de commande",
// "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment",
// "Attachment name, file, id or num" => "Attachment name, file, id or num",
// "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)",
"File Type Icon" => "Icône Type de Fichier",
// "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)" => "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)",
"Page \"%0\" does not exist" => "La page \"%0\" n'existe pas",
"No such attachment on this page" => "Fichier joint inexistant sur cette page",
"Attributes" => "Attributs",
"Assign generic attributes to the current object" => "Assigner des attributs génériques à l'objet courant",
// "Add popups and color coding that identifies authors" => "Add popups and color coding that identifies authors",
"Username of the author of the text" => "Nom de l'utilisateur qui a écrit le texte",
"Deleted by User" => "Supprimé par l'utilisateur",
"Username of the person who deleted the text" => "Nom de l'utilisateur qui a supprimé le texte",
"Make Visible" => "Rendre visible",
"Show popup with author/deleted by" => "Afficher une fenêtre popup avec auteur/supprimé par",
"Generate a popup with names of author(s) (default: no)" => "Générer une fenêtre popup avec les noms des auteurs (par défaut: non)",
"deleted by" => "effacé par",
"Should this author's contribution be visible (default: no)" => "La contribution de cet auteur devrait-elle être visible (par défaut: non)",
// "Auto Query Args" => "Auto Query Args",
// "Automatically propagate arguments when clicking on links" => "Automatically propagate arguments when clicking on links",
// "Arguments for auto query" => "Arguments for auto query",
// "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin" => "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin",
"Profile picture" => "Profile picture",
"Display a user's profile picture" => "Afficher l'avatar de l'utilisateur",
// "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page" => "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page",
"Float" => "Flottant",
"Align the profile picture on the page" => "Aligner l'avatar sur la page",
// "Full Size" => "Full Size",
// "If full-size images are stored in the file gallery, show the full-size image" => "If full-size images are stored in the file gallery, show the full-size image",
"Back" => "Retour",
// "Display a link that goes back one page in the browser history" => "Display a link that goes back one page in the browser history",
// "List all pages that link to a particular page" => "List all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "Les liens de page pointeront vers. La valeur par défaut est la page courante",
"Displayed Information" => "Information affichée",
"Pipe separated list of fields to display. ex: hits|user" => "Liste de champs à afficher, séparés par une barre verticale '|'. Ex. : hits|user",
"Excluded pages" => "Pages exclues",
// "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1" => "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1",
"Include Self" => "Inclure auto-lien",
"With or without self-link (default is without)" => "Avec ou sans auto-lien (par défaut : sans)",
"With or without header (default is with header)" => "Avec ou sans en-tête (par défaut avec en-tête)",
"With header" => "Avec en-tête",
"Without header" => "Sans en-tête",
"No pages link to" => "Aucune page ne pointe vers",
"One page links to" => "Une page pointe vers",
"pages link to" => "pages pointent vers",
"Add a banner" => "Ajouter une bannière",
"Zone" => "Zone",
"Name of the zone created in Admin > Banners" => "Nom de la zone créée dans Administrer > Bannières",
"Determines the browser behavior when the banner is clicked" => "Détermine le comportement du navigateur après un clic sur la bannière",
"missing parameter" => "paramètre manquant",
// "Benchmark" => "Benchmark",
// "Performance-test wiki content (used by developers to optimize plugins)" => "Performance-test wiki content (used by developers to optimize plugins)",
// "Iteration Quantity" => "Iteration Quantity",
// "The number of iterations to process" => "The number of iterations to process",
// "Each Iteration Details" => "Each Iteration Details",
// "Provides time and memory of each iteration" => "Provides time and memory of each iteration",
"BigBlueButton" => "BigBlueButton",
// "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system" => "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system",
"Meeting" => "Conférence",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1",
// "Anonymous Prefix" => "Anonymous Prefix",
"Unregistered users will get this token prepended to their name" => "Les utilisateurs non enregistrés auront leur nom rpéfixé par ce jeton",
"Welcome Message" => "Message de bienvenue",
"A message to be provided when someone enters the room" => "Un message à délivrer quand quelqu'un rejoint le salon",
"Dial Number" => "Numéro d'appel",
"The phone-in support number to join from traditional phones" => "Le numéro de téléphone du support à joindre par téléphone classique",
"Voice Bridge" => "Pont vocal",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID",
"Log-out URL" => "URL après déconnexion",
"URL to which the user will be redirected after logging out of BigBlueButton" => "URL vers laquelle rediriger l'utilisateur quand il s'est déconnecté de BigBlueButton",
"Record" => "Enregistrement",
// "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8" => "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8",
// "Display Recordings" => "Display Recordings",
// "Enable or Disable the display of video recordings" => "Enable or Disable the display of video recordings",
// "Display Attendees" => "Display Attendees",
// "Enable or Disable the display of attendees list" => "Enable or Disable the display of attendees list",
"BigBlueButton is misconfigured or inaccessible" => "BigBlueButton mal configuré ou inaccessible",
"Blog List" => "Liste des blogues",
"Display posts from a site blog" => "Afficher les publications d'un blogue",
"Blog ID" => "ID du Blogue",
// "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown" => "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown",
"Maximum Items" => "Nb. max. d'éléments",
"Maximum number of entries to list (no maximum set by default)" => "Nombre maximum d'entrées à lister (pas de maximump défini par défaut)",
"Only display posts created by this user (all posts listed by default)" => "Afficher seulement les publications créées par cet utilisateur (toutes les publications affichées par défaut)",
"Simple List" => "Liste simple",
// "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts" => "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts",
"Character Count" => "Nombre de caractères",
// "Number of characters to display if not a simple list (defaults to all)" => "Number of characters to display if not a simple list (defaults to all)",
// "Word Boundary" => "Word Boundary",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only",
// "Ellipsis" => "Ellipsis",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)",
"More" => "Plus",
// "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)",
// "Show Icons" => "Show Icons",
// "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)" => "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)",
// "Use Excerpt" => "Use Excerpt",
// "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)" => "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)",
"Earliest date to select posts from" => "Date de départ la plus ancienne pour sélectionner des publications",
"End Date" => "Date de fin",
"Latest date to select posts from" => "Date de départ la plus récente pour sélectionner des publications",
"Container Class" => "Classe du conteneur",
// "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)" => "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)",
// "Missing blog ID for Bloglist plugin" => "Missing blog ID for Bloglist plugin",
// "Create a formatted box with a title bar" => "Create a formatted box with a title bar",
// "Box Title" => "Box Title",
"Displayed above the content" => "Affiché au-dessus du contenu",
"As defined by CSS, name, or color hex code" => "Tel que défini par CSS, nom ou code héxadécimal",
// "Valid CSS color name or code" => "Valid CSS color name or code",
// "Box Width" => "Box Width",
"Text Alignment" => "Alignement du texte",
"Aligns the text within the box (left-aligned by default)" => "Aligne le texte dans la boîte (à gauche par défaut)",
"Float Position" => "Position flottante",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)",
"Clear" => "Vider",
// "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)" => "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)",
"Apply custom CSS class to the box" => "Appliquer une classe CSS personnalisée à la boite",
"CSS Style" => "Style CSS",
// "Enter CSS styling tags for the div type used e.g. padding: 5px" => "Enter CSS styling tags for the div type used e.g. padding: 5px",
"Button" => "Bouton",
"Add a link formatted as a button" => "Ajouter un lien sous forme de bouton",
// "Label for the button (ignored if the text is defined)" => "Label for the button (ignored if the text is defined)",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it" => "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it",
"Label for the button" => "Etiquette pour le bouton",
// "Icon Name" => "Icon Name",
// "Enter an iconset name to show an icon in the button" => "Enter an iconset name to show an icon in the button",
// "Button Type" => "Button Type",
// "Use a type to style the button. By default btn-primary will be applied" => "Use a type to style the button. By default btn-primary will be applied",
// "Danger" => "Danger",
// "Primary" => "Primary",
// "Button width" => "Button width",
// "In pixels or percentage. (e.g. 200px or 100%)" => "In pixels or percentage. (e.g. 200px or 100%)",
// "Button height" => "Button height",
// "CSS class for the button. Note that the btn class is always applied by default" => "CSS class for the button. Note that the btn class is always applied by default",
// "CSS style attributes" => "CSS style attributes",
// "Link Relation" => "Link Relation",
// "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation" => "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation",
// "Auto Arguments" => "Auto Arguments",
// "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter" => "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter",
// "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL" => "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL",
// "Flip Id" => "Flip Id",
// "HTML id attribute of the element to show/hide content" => "HTML id attribute of the element to show/hide content",
// "Flip Hide Text" => "Flip Hide Text",
// "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown" => "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown",
// "Flip Default Open" => "Flip Default Open",
// "If set to %0, the flip is open by default (if no cookie jar)" => "If set to %0, the flip is open by default (if no cookie jar)",
// "Escape Apostrophes" => "Escape Apostrophes",
// "If set to %0, will escape the apostrophes in onclick" => "If set to %0, will escape the apostrophes in onclick",
// "Disable Button" => "Disable Button",
// "Set to %0 to disable the button" => "Set to %0 to disable the button",
"lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php est manquant ou illisible",
"Display a calendar and its events" => "Afficher un calendrier et ses événements",
"Calendar IDs" => "IDs de calendrier",
// "Comma-separated list of calendar Ids to restrict the events to specified calendars" => "Comma-separated list of calendar Ids to restrict the events to specified calendars",
"Example values" => "Exemple de valeurs",
"Not set by default" => "Pas activé par défaut",
"View Type" => "Type de vue",
// "Determines how events" => "Determines how events",
// "%0 (default) shows events in a calendar" => "%0 (default) shows events in a calendar",
"View Time Span" => "Afficher l'intervalle de temps",
// "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar" => "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar",
"Default is month" => "Mois par défaut",
"Navigation Bar" => "Barre de navigation",
// "Show or hide the navigation bar (not shown by default)" => "Show or hide the navigation bar (not shown by default)",
"Carousel" => "Carrousel",
"Display images in a self-advancing carousel" => "Afficher les images dans un carrousel automatique",
// "Images Source" => "Images Source",
// "Choose where to get your images from" => "Choose where to get your images from",
"Select an option" => "Choisir une option",
// "All the images in a file gallery" => "All the images in a file gallery",
// "A list of file IDs" => "A list of file IDs",
"File Gallery ID" => "ID de galerie de fichiers",
"ID number of the file gallery that contains the images to be displayed" => "ID (numérique) de la galerie de fichers qui contient les images à afficher",
// "File IDs" => "File IDs",
// "List of IDs of images from the File Galleries separated by commas" => "List of IDs of images from the File Galleries separated by commas",
"Sort Mode" => "Type de tri",
// "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2" => "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2",
// "Transition Time" => "Transition Time",
"The time (in milliseconds) for the transition between two images" => "Le temps (en millisecondes) de la transition entre deux images",
"number" => "nombre",
// "Display Time" => "Display Time",
"The time (in milliseconds) to display each image" => "Le temps (en millisecondes) d'affichage de chaque image",
// "Caption Height" => "Caption Height",
"The height of the caption. This is a fraction of the height of the images" => "La hauteur de la légende. Ceci est une fraction de la hauteur de l'image",
"real between 0 and 1" => "réel entre 0 et 1",
// "Display Progress Bar" => "Display Progress Bar",
// "Display Thumbnails" => "Display Thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
"Buttons" => "Boutons",
// "Numbers" => "Numbers",
// "Thumbnail Box Width" => "Thumbnail Box Width",
// "Width of thumbnail box in CSS units (default %0)" => "Width of thumbnail box in CSS units (default %0)",
// "Thumbnail Box Height" => "Thumbnail Box Height",
// "Height of thumbnail box in CSS units (default %0)" => "Height of thumbnail box in CSS units (default %0)",
// "Start Automatically" => "Start Automatically",
// "Start the carousel automatically when the page loads (default: Yes)" => "Start the carousel automatically when the page loads (default: Yes)",
// "Legacy v2 param" => "Legacy v2 param",
"Display thumbnails" => "Afficher les vignettes",
// "Thumbnail Numbers" => "Thumbnail Numbers",
"Display place numbers in the thumbnail boxes" => "Afficher les numéros de place dans les boîtes de vignette",
// "Thumbnail Background" => "Thumbnail Background",
"Use corresponding image as background for a thumbnail box" => "Utiliser l'image correspondante comme arrière-plan d'une boîte de vignette",
// "Thumbnail Font Size" => "Thumbnail Font Size",
// "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)" => "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)",
// "CSS units" => "CSS units",
// "Image Size" => "Image Size",
// "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels" => "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels",
// "Real between 0 and 1, or integer over 10" => "Real between 0 and 1, or integer over 10",
// "Makes images clickable" => "Makes images clickable",
// "In case there are URLs in the image description, the image is made clickable and links to the first URL found" => "In case there are URLs in the image description, the image is made clickable and links to the first URL found",
"Cart Missing User Info" => "Info utilisateur manquante pour le panier",
"PluginCartMissingUserInfo" => "Plugiciel Info manquante panier",
// "Check completeness of user input for a shopping cart transaction" => "Check completeness of user input for a shopping cart transaction",
// "Information Type" => "Information Type",
"Post Purchase" => "Après achat",
"Required before purchase" => "Requis avant achat",
"Product Class ID" => "ID de la classe produit",
// "CasperJS" => "CasperJS",
// "Enable running CasperJS scripts from this Tiki site" => "Enable running CasperJS scripts from this Tiki site",
// "CasperJS not available" => "CasperJS not available",
// "Execute CasperJS script" => "Execute CasperJS script",
"List categories and objects assigned to them" => "Lister des catégories et les objets qu'elles contiennent",
"Category IDs" => "Identificateurs des catégories",
// "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page" => "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page",
"Types" => "Types",
// "List of object types to include in the list, separated by \"+\", for example, " => "List of object types to include in the list, separated by \"+\", for example, ",
// "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)" => "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)",
"Hits Ascending" => "En ordre croissant de vues",
"Hits Descending" => "En ordre décroissant de vues",
"Item ID Ascending" => "En ordre croissant d'ID d'élément",
"Item ID Descending" => "En ordre décroissant d'ID d'élément",
"Type Ascending" => "Ordre croissant de type",
"Type Descending" => "Ordre décroissant de type",
"Random" => "Aléatoire",
"Split" => "Eclater",
"Whether multiple categories will be listed on different lines (default is to split them)" => "Lister sur des lignes différentes les multiples catégories ou non (par défaut : oui)",
"And" => "Et",
// "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)" => "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)",
// "Sub-categories" => "Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)",
"Show descriptions (not shown by default)" => "Afficher les descriptions (non affichées par défaut)",
"Show object names (shown by default)" => "Afficher les noms d'objets (valeur par défaut)",
"Show type (shown by default)" => "Afficher le type (affiché par défaut)",
"One Per Line" => "Un(e) par ligne",
"Show one object per line (multiple per line shown by default)" => "Afficher un seul objet par ligne (plusieurs par défaut)",
// "Child Links" => "Child Links",
"Show children category links (shown by default)" => "Afficher les liens vers les catégories enfants (affichés par défaut)",
// "Top Link" => "Top Link",
"Show top category link (shown by default)" => "Afficher le lien vers la catégorie racine (affiché par défaut)",
"Maximum Records" => "Nombre maximum",
// "Maximum number of objects to list (default is %0)" => "Maximum number of objects to list (default is %0)",
"Show title text above category object lists (shown by default)" => "Afficher le texte du titre au dessus des listes d'objets d'une catégorie (affiché par défaut)",
"List only objects in this language" => "Lister seulement les objets dans cette langue",
// "Only apply if %0" => "Only apply if %0",
"Categories are disabled" => "Les catégories sont désactivées",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Display controls to trigger category transitions for any object" => "Display controls to trigger category transitions for any object",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
"Category Orphans" => "Catégories orphelines",
"List objects that are not categorized" => "Lister les objets qui ne sont pas catégorisés",
// "Determine which type of objects are shown (default is %0)" => "Determine which type of objects are shown (default is %0)",
"Calendars" => "Calendriers",
// "Max" => "Max",
// "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records" => "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records",
"Result Offset" => "Décalage de départ",
"Result number at which the listing should start (default is no offset)" => "Numéro de résultat auquel la liste devrait démarrer (par défaut aucun décalage)",
"Category Path" => "Chemin de la catégorie",
"Show the full category path for a wiki page" => "Afficher le chemin complet d'une catégorie d'une page Wiki",
"Separator" => "Séparateur",
// "String used to separate the categories in the path. Default character is %0" => "String used to separate the categories in the path. Default character is %0",
"Display Top Category" => "Afficher la catégorie racine",
"Show the top category as part of the path name (not shown by default)" => "Afficher la catégorie racine comme partie du nom du chemin (non affichée par défaut)",
// "Access and use a cclite social credit and alternative currency account" => "Access and use a cclite social credit and alternative currency account",
// "Mode of operation - summary or recent. Default: %0" => "Mode of operation - summary or recent. Default: %0",
"Account summary" => "Résumé du compte",
"Recent transactions" => "Transactions récentes",
"Registry" => "Registre",
"Registry to query. Default: site preference (or first in list when more than one)" => "Registre à interroger. Par défaut : préférence du site (ou premier de la liste si plusieurs)",
"You need to be logged in to view this information" => "Vous devez être connecté pour voir cette information",
"Center text" => "Centrer le texte",
"Chart" => "Diagramme",
"Display a chart from TikiSheet." => "Afficher un diagramme depuis une feuille de calcul Tiki",
"Chart caption" => "Légende de diagramme",
"Spreadsheet ID" => "ID de la feuille",
"Data sheet ID" => "Identifiant de la feuille de données",
"Chart Type" => "Type de diagramme",
// "Specify a valid chart type" => "Specify a valid chart type",
"Chart Width" => "Largeur du graphe",
"Width in pixels" => "Largeur en pixels",
"Chart Height" => "Hauteur du graphe",
"Height in pixels" => "Hauteur en pixels",
"Value series" => "Série de valeurs",
"Required for pie charts" => "Requis pour les graphiques camembert",
// "Independent series" => "Independent series",
"Required for types other than pie chart" => "Requis pour les autres types que les graphiques camembert",
// "Dependent series" => "Dependent series",
"Description needed" => "Description requise",
"Colors" => "Couleurs",
"List of colors to use" => "Liste de couleurs à utiliser",
"Styles" => "Styles",
"List of styles to use" => "Liste des styles à utiliser",
"Labels for the series or values in the legend" => "Etiquettes pour les séries de valeurs dans la légende",
"Chart as PDF" => "Graphique en PDF",
"Chart as PostScript" => "Graphique en PostScript",
// "Chart JS" => "Chart JS",
// "Create a JS Chart" => "Create a JS Chart",
// "JSON encoded array for data and options" => "JSON encoded array for data and options",
// "Chart Id" => "Chart Id",
// "A custom ID for the chart" => "A custom ID for the chart",
// "The type of chart. Currently works with pie, bar and doughnut" => "The type of chart. Currently works with pie, bar and doughnut",
// "The height of the chart in px" => "The height of the chart in px",
// "The width of the chart in px" => "The width of the chart in px",
// "Chart data values" => "Chart data values",
// "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)" => "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)",
// "Chart data labels" => "Chart data labels",
// "Colon-separated labels for the datasets in the chart. Max 10, if left empty" => "Colon-separated labels for the datasets in the chart. Max 10, if left empty",
// "Chart colors" => "Chart colors",
// "Colon-separated colors for the datasets in the chart. Max 10, if left empty" => "Colon-separated colors for the datasets in the chart. Max 10, if left empty",
// "Chart highlight" => "Chart highlight",
// "Colon-separated color of chart section when highlighted" => "Colon-separated color of chart section when highlighted",
// "Uses the non-minified version of the chart.js library for easier debugging" => "Uses the non-minified version of the chart.js library for easier debugging",
// "Values must be set for chart" => "Values must be set for chart",
// "Check Referer" => "Check Referer",
// "Display content based on the address that originated the request for the current page" => "Display content based on the address that originated the request for the current page",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met",
// "Referer List" => "Referer List",
// "Comma-separated list of domains to check" => "Comma-separated list of domains to check",
// "Display code with syntax highlighting and line numbering" => "Display code with syntax highlighting and line numbering",
"Code to be displayed" => "Code à afficher",
"Caption" => "Légende",
"Code snippet label" => "Étiquette de l'extrait de code",
"Line Wrapping" => "Retour à la ligne automatique",
"Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends." => "Afficher les lignes de code source qui ne rentrent pas dans la largeur de la boîte sur plusieurs lignes. Activer évite les débordements ou les fins de lignes cachées.",
// "Any supported language listed at http://codemirror.net/mode/" => "Any supported language listed at http://codemirror.net/mode/",
"Line Numbers" => "Numéros de ligne",
// "Show line numbers for each line of code" => "Show line numbers for each line of code",
"Right to Left" => "De droite à gauche",
"Switch the text display from left to right, to right to left (left to right by default)" => "Basculer l'affichage du texte de gauche à droite vers un affichage de droite à gauche (gauche à droite par défaut)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Any supported theme listed at https://codemirror.net/demo/theme.html" => "Any supported theme listed at https://codemirror.net/demo/theme.html",
"Colorbox" => "Colorbox",
"Display a gallery of images in a popup slideshow" => "Afficher une galerie d'images dans un diaporama en popup",
"Image Gallery ID" => "ID de la galerie d'images",
"ID number of the image gallery that contains the images to be displayed" => "Valeur numérique de l'ID de la galerie d'images qui contient les images à afficher",
"File ID Filter" => "Filtre d'ID de fichier",
// "Colon-separated list of fileIds in a file gallery to show" => "Colon-separated list of fileIds in a file gallery to show",
"Thumb" => "Vignettage",
// "Display as a thumbnail or full size" => "Display as a thumbnail or full size",
"Show File Title" => "Afficher le titre du fichier",
"Show file title" => "Afficher le titre du fichier",
"Show File Name" => "Afficher le nom du fichier",
"Show file name" => "Afficher le nom du fichier",
"Show All Thumbs" => "Afficher toutes les vignettes",
"Show thumbnails of all the images in the gallery" => "Afficher les vignettes de toutes les images dans la galerie",
"Parse Descriptions" => "Analyser les descriptions",
"Parse the file descriptions as wiki syntax" => "Analyser les descriptions de fichiers en tant que syntaxe wiki",
"This feature is disabled" => "Cette fonctionnalité est désactivée",
// "Display a comment area for a specified object" => "Display a comment area for a specified object",
// "Object type the comment is associated with" => "Object type the comment is associated with",
"Tracker Item" => "Fiche du formulaire",
// "Submission" => "Submission",
// "Blog Post" => "Blog Post",
// "The current wiki page to which you have added the plugin" => "The current wiki page to which you have added the plugin",
"Dynamic Content" => "Contenu dynamique",
"Display content from dynamic content repository" => "Afficher du contenu provenant du dépôt de contenu dynamique",
"Content ID" => "ID du contenu",
"Dynamic content ID. The value can be obtained in the listing" => "ID du contenu dynamique. La valeur peut être obtenue dans la liste",
"Content Label" => "Etiquette du contenu",
"Label of the dynamic content to display" => "Nom du contenu dynamique à afficher",
"Contributions Dashboard" => "Tableau de bord des contributions",
// "List users' contributions to a page" => "List users' contributions to a page",
"Notice" => "Avis",
"Default Beginning Date" => "Date de début par défaut",
"Default Ending Date" => "Date de fin par défaut",
"Dashboard Types" => "Types de tableau de bord",
// "The types of charts that will be rendered, separated by commas" => "The types of charts that will be rendered, separated by commas",
"Update" => "Mettre à jour",
// "Convene" => "Convene",
// "Suggest meeting dates and times and vote to select one" => "Suggest meeting dates and times and vote to select one",
// "Convene data generated from user input" => "Convene data generated from user input",
// "Title for the event" => "Title for the event",
// "Calendar ID" => "Calendar ID",
// "ID number of the site calendar in which to store the date for the events with the most votes" => "ID number of the site calendar in which to store the date for the events with the most votes",
// "Minimum Votes" => "Minimum Votes",
// "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it" => "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it",
// "Date-Time Format" => "Date-Time Format",
// "Display date and time in short or long format, according to the site wide setting" => "Display date and time in short or long format, according to the site wide setting",
// "Short" => "Short",
// "Long" => "Long",
// "Observe Admin Permissions" => "Observe Admin Permissions",
// "Show user profile pictures" => "Show user profile pictures",
// "Delete Date" => "Delete Date",
// "UTC date time: %0" => "UTC date time: %0",
"Add Date" => "Ajouter la date",
// "Not OK" => "Not OK",
// "Unconfirmed" => "Unconfirmed",
"Add User" => "Ajouter l'utilisateur",
// "Not ok" => "Not ok",
"Ok" => "Ok",
// "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users" => "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users",
// "Show user's profile pictures next to their names" => "Show user's profile pictures next to their names",
"Edit User/Save changes" => "Modifier l'utilisateur/Enregistrer les modifications",
"Delete User" => "Supprimer l'utilisateur",
// "Username.." => "Username..",
// "Selected Date" => "Selected Date",
"Add as Calendar Event" => "Ajouter comme événement du calendrier",
// "This page is being edited by another user. Please reload the page and try again later" => "This page is being edited by another user. Please reload the page and try again later",
// "Delete this date" => "Delete this date",
// "Are you sure you want to remove this user's votes" => "Are you sure you want to remove this user's votes",
// "There is no undo" => "There is no undo",
"Cookie" => "Témoin",
// "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)" => "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)",
// "Display content based on whether cookie consent has been granted by the user" => "Display content based on whether cookie consent has been granted by the user",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "No Cookie Message" => "No Cookie Message",
// "Message displayed if user has not consented to accepting cookies" => "Message displayed if user has not consented to accepting cookies",
// "Containing Element" => "Containing Element",
// "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container" => "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container",
// "Element CSS Class" => "Element CSS Class",
// "CSS class for above" => "CSS class for above",
// "No Consent CSS Class" => "No Consent CSS Class",
// "CSS class for no consent message. Default: %0" => "CSS class for no consent message. Default: %0",
"Insert copyright notices" => "Insérer les notices de copyright",
// "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1" => "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1",
"Countdown" => "Compte à rebours",
// "Display the time until or after a date and time" => "Display the time until or after a date and time",
"Text to append to the countdown" => "Texte à ajouter au compte à rebours",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
"Items to Show" => "Fiches à Afficher",
// "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "Jours",
"Days & Hours" => "Jours et Heures",
"Days, Hours & Minutes" => "Jours, Heures & Minutes",
"Days, Hours, Minutes & Seconds" => "Jours, Heures, Minutes & Secondes",
"Hours" => "Heures",
"Hours & Minutes" => "Heures et Minutes",
"Hours, Minutes & Seconds" => "Heures, Minutes & Secondes",
"Minutes" => "Minutes",
"Minutes & Seconds" => "Minutes & Secondes",
"Seconds" => "Secondes",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default" => "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text" => "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text",
"Text" => "Texte",
// "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text" => "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
"Thousands separator" => "Séparateur de milliers",
// "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator",
"Comma" => "Virgule",
"Period" => "Période",
// "Space" => "Space",
// "Countdown: Missing \"enddate\" parameter for plugin" => "Countdown: Missing \"enddate\" parameter for plugin",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "depuis",
// "is over" => "is over",
"Custom Search" => "Recherche personnalisée",
// "Create a custom search form for searching or listing items on the site" => "Create a custom search form for searching or listing items on the site",
"LIST plugin configuration information" => "Information de configuration du plugiciel LISTE",
"Template wiki page" => "Page wiki modèle",
"Wiki page where search user interface template is found" => "Page wiki dans laquelle se trouve le gabarit de l'interface recherche utilisateur",
// "Template file" => "Template file",
// "Smarty template (.tpl) file where search user interface template is found" => "Smarty template (.tpl) file where search user interface template is found",
// "Search Id" => "Search Id",
// "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users",
// "Search Delay" => "Search Delay",
// "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)" => "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)",
// "Fade DIV Id" => "Fade DIV Id",
// "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner",
// "Recall Last Search" => "Recall Last Search",
// "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving" => "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving",
// "Custom JavaScript Page" => "Custom JavaScript Page",
"The wiki page on which custom JavaScript is to be executed on return of Ajax results" => "La page wiki dans laquelle se trouve un JavaScript personnalisé à exécuter au retour des résultats AJAX",
"Destination Div" => "Div de destination",
"The id of an existing div to contain the search results" => "Id (html) d'une div (html) existante pour contenir les les résultats de recherche",
// "Search On Load" => "Search On Load",
"Execute the search when the page loads (default: Yes)" => "Exécuter la recherche quand la page se charge (Oui par défaut)",
// "Require Input" => "Require Input",
// "Require first input field to be filled for search to trigger" => "Require first input field to be filled for search to trigger",
// "Force Sort" => "Force Sort",
// "Force the use of specified sort mode in place of search relevance even when there is a text search query" => "Force the use of specified sort mode in place of search relevance even when there is a text search query",
// "Trim Linefeeds" => "Trim Linefeeds",
// "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs" => "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs",
// "Searchable Only Results" => "Searchable Only Results",
// "Only include results marked as searchable in the index" => "Only include results marked as searchable in the index",
// "Use custom search JavaScript file" => "Use custom search JavaScript file",
// "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size" => "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size",
// "JavaScript disabled" => "JavaScript disabled",
// "JavaScript is required for this search feature" => "JavaScript is required for this search feature",
"Template is not specified" => "Le gabarit n'est pas spécifié",
"Template page not found" => "Page de gabarit non trouvé",
// "Please enter a search query" => "Please enter a search query",
// "_from parameter not valid: \"%0\"" => "_from parameter not valid: \"%0\"",
// "_to parameter not valid: \"%0\"" => "_to parameter not valid: \"%0\"",
// "_gap parameter not valid: \"%0\"" => "_gap parameter not valid: \"%0\"",
"_group is needed to be set if _style is checkbox or radio" => "_group doit être défini si le style est case à cocher ou bouton radio",
// "Cypht webmail" => "Cypht webmail",
// "Embed Cypht webmail and news reader" => "Embed Cypht webmail and news reader",
// "Mailbox name" => "Mailbox name",
"IMAP server" => "Serveur IMAP",
// "IMAP port" => "IMAP port",
// "IMAP use TLS" => "IMAP use TLS",
// "Use secure connection to IMAP server" => "Use secure connection to IMAP server",
// "IMAP username" => "IMAP username",
// "Account mailbox username" => "Account mailbox username",
// "IMAP password" => "IMAP password",
// "Account mailbox password" => "Account mailbox password",
// "SMTP connection name" => "SMTP connection name",
// "SMTP port" => "SMTP port",
// "SMTP use TLS" => "SMTP use TLS",
// "Use secure TLS/SSL connection to SMTP server" => "Use secure TLS/SSL connection to SMTP server",
// "SMTP no authentication" => "SMTP no authentication",
// "Disable SMTP authentication if your server does not support it" => "Disable SMTP authentication if your server does not support it",
// "Use global settings" => "Use global settings",
// "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages" => "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages",
// "Groupmail use" => "Groupmail use",
// "Share this mailbox for Groupmail usage or keep it private" => "Share this mailbox for Groupmail usage or keep it private",
"GroupMail: Group (e.g. \"Help Team\")" => "GroupMail : Groupe (par ex. \"Help Team\")",
"GroupMail: Tracker ID (to store GroupMail activity)" => "GroupMail : Id du formulaire (pour enregistrer l'activité GroupMail)",
"From Field ID" => "Id du champ 'De'",
"GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail : Champ 'De' (Id du champ dans le formulaire pour enregistrer l'émetteur du courriel dans l'en-tête)",
"Subject Field ID" => "Id du champ 'Sujet'",
"GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail : Champ 'Sujet' (Id du champ dans le formulaire pour enregistrer le sujet du courriel dans l'en-tête )",
"Message Field ID" => "Id du champ 'Message'",
"GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail : Champ 'Message' (Id du champ dans le formulaire pour enregistrer l'identificateur du message du courriel)",
"Content Field ID" => "Id du champ 'Contenu'",
"GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail : Champ 'Contenu' (Id du champ dans le formulaire pour enregistrer le contenu du corps du message du courriel)",
"Account Field ID" => "Id du champ 'Compte'",
"GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail : Champ 'Compte' (ID du champ dans le formulaire pour enregistrer le nom du compte Webmail)",
"DateTime Field Id" => "Identificateur du champ date & heure",
"GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail : Champ 'Date & Heure' (Id du champ dans le formulaire pour enregistrer l'horodatage du courriel envoyé)",
"Operator Field ID" => "Id du champ 'Opérateur'",
"GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail : Champ 'Opérateur' (Id du champ dans le formulaire pour enregistrer le nom de l'opérateur (nom d'utilisateur))",
// "UI display presentational purposes only" => "UI display presentational purposes only",
// "E.g. imap.your-domain.com" => "E.g. imap.your-domain.com",
// "Default is 993" => "Default is 993",
// "E.g. smtp.your-domain.com" => "E.g. smtp.your-domain.com",
// "Default is 587" => "Default is 587",
// "Only one cypht plugin per page can be used" => "Only one cypht plugin per page can be used",
"Data Channel" => "Canal de données",
"Display a form to access data channels" => "Afficher un écran de saisie pour accéder aux canaux de données",
// "List of fields to display. One field per line. Comma delimited: %0" => "List of fields to display. One field per line. Comma delimited: %0",
// "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag" => "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag",
// "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel" => "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel",
// "To use fixed hidden preset\n\t\t\tvalues use %0" => "To use fixed hidden preset\n\t\t\tvalues use %0",
"Channel Name" => "Nom du canal",
"Name of the channel as registered by the administrator" => "Nom du canal enregistré par l'administrateur",
"Return URL" => "URL de retour",
// "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object" => "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object",
// "Return URL on error" => "Return URL on error",
// "URL to go to after data channel has run and failed. If not specified, use the success URL" => "URL to go to after data channel has run and failed. If not specified, use the success URL",
"Do not use returnURI but instead return true quietly" => "Ne pas utiliser une URL de retour mais renvoyer Vrai silencieusement",
// "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context" => "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context",
"Button Label" => "Étiquette du bouton",
"Label for the submit button. Default: \"Go\"" => "Label pour le bouton Soumettre. Par défaut : \"Aller\"",
"CSS class for this form" => "Classe CSS pour ce formulaire",
"Template" => "Gabarit",
// "Template to be used to render the form, instead of the default template" => "Template to be used to render the form, instead of the default template",
"Empty Caches" => "Vider les caches",
"Which caches to empty. Default \"Clear all Tiki caches\"" => "Quels caches vider. Par défaut \"Vider tous les caches Tiki\"",
"Clear all Tiki caches" => "Purger tous les caches Tiki",
"All user prefs sessions" => "Toutes les préférences dans les sessions utilisateur",
"Price to execute the data channel (%0)" => "Prix pour exécuter le canal de données (%0)",
"Payment Label" => "Etiquette de paiement",
"Debug" => "Déboguer",
// "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)",
"Multiple Values" => "Valeurs multiples",
// "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)",
"Data channel" => "Canal données",
"DB Report" => "Rapport base de données",
// "Query an ADOdb database and display results (does not work with PDO)" => "Query an ADOdb database and display results (does not work with PDO)",
"report definition" => "définition du rapport",
"Full DSN" => "DSN complet",
// "A full DSN (Data Source Name) connection string. Example: " => "A full DSN (Data Source Name) connection string. Example: ",
"Wiki DSN Name" => "Nom de DSN Wiki",
"The name of a DSN connection defined by the Wiki administrator" => "Nom de la connexion DSN définie par l'administrateur Wiki",
"Wiki Syntax" => "Syntaxe Wiki",
"Parse wiki syntax within the report (not parsed by default)" => "Analyser la syntaxe wiki dans le rapport (non analysé par défaut)",
"Display the parsed report definition (not displayed by default)" => "Afficher la définition analysée du rapport (non affichée par défaut)",
"Missing db or dsn parameter" => "Paramètre DB ou DSN manquant",
// "AdoDb not found" => "AdoDb not found",
"No DSN connection string found" => "Il n'y pas de chaine de connexion DSN",
"Run a database report" => "Lancer un rapport de base de données",
// "Diagram" => "Diagram",
// "Display mxGraph/Draw.io diagrams" => "Display mxGraph/Draw.io diagrams",
// "fileId" => "fileId",
// "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options" => "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options",
"page" => "page",
// "Page of the diagram that should be displayed" => "Page of the diagram that should be displayed",
// "annotate" => "annotate",
// "Id of the file in the file gallery. A image file to include in the diagram" => "Id of the file in the file gallery. A image file to include in the diagram",
// "Image alignment when exporting a PDF" => "Image alignment when exporting a PDF",
// "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"" => "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"",
// "Previous xorti/mxgraph-editor package has been deprecated.<br/>" => "Previous xorti/mxgraph-editor package has been deprecated.<br/>",
// "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator" => "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator",
// "Create New Diagram" => "Create New Diagram",
// "Page (inline)" => "Page (inline)",
// "Tiki wasn't able to find the file with id %0" => "Tiki wasn't able to find the file with id %0",
// "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure" => "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure",
" in " => " en ",
// "Selected file to annotate must be an image" => "Selected file to annotate must be an image",
// "Can not retrieve size from file %0" => "Can not retrieve size from file %0",
// "Create a custom popup dialog box" => "Create a custom popup dialog box",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button Actions" => "Button Actions",
"JavaScript to perform on first button click" => "JS à exécuter sur le 1er clic du bouton",
// "Dialog Width" => "Dialog Width",
"In pixels" => "En pixels",
"HTML ID" => "ID HTML",
// "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)" => "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)",
// "Show Animation" => "Show Animation",
// "Hide Animation" => "Hide Animation",
// "Auto Open" => "Auto Open",
// "Open dialog automatically" => "Open dialog automatically",
// "Modal" => "Modal",
// "Use modal form" => "Use modal form",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JavaScript to execute when dialog opens" => "JavaScript to execute when dialog opens",
"Div" => "Div",
"Define and format sections of a page or text" => "Définir et formater des sections d'une page ou d'un texte",
// "Indicate the type of HTML tag to use (default is %0)" => "Indicate the type of HTML tag to use (default is %0)",
"Span" => "Span",
"Pre" => "Pré",
"Teletype" => "Télétype",
"Paragraph" => "Paragraphe",
"Block quote" => "Citation de bloc",
// "H1" => "H1",
// "H2" => "H2",
// "H3" => "H3",
// "H4" => "H4",
// "H5" => "H5",
// "H6" => "H6",
// "Valid CSS color name or hex code" => "Valid CSS color name or hex code",
"Box width" => "Largeur de la boîte",
"In pixels or percentage. Default is original size" => "En pixels ou pourcentage. Par défaut : taille d'origine",
"Aligns the text within the element" => "Aligne le texte à l'intérieur de l'élément",
"Justify" => "Justifier",
// "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set" => "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set",
"Content cannot wrap around this object because of what the parameter is set to" => "Les éléments ne sont pas autorisés à se disposer sur le(s) côté(s) défini(s) par ce paramètre",
"Apply custom CSS class to the div" => "Appliquer la classe CSS personnalisée à la div",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
// "onClick attribute" => "onClick attribute",
// "Enter on onclick event" => "Enter on onclick event",
// "Style attribute" => "Style attribute",
// "Enter CSS styling tags for the div type used" => "Enter CSS styling tags for the div type used",
// "Data attributes" => "Data attributes",
// "URL encoded list or attributes and values" => "URL encoded list or attributes and values",
// "ARIA attributes" => "ARIA attributes",
// "URL encoded list or attributes and values, e.g. label, expanded etc" => "URL encoded list or attributes and values, e.g. label, expanded etc",
// "Role attribute" => "Role attribute",
// "e.g. button, heading, search etc" => "e.g. button, heading, search etc",
"Sets the id attribute of the div, as defined by HTML" => "Définit l'attribut 'id' de la div, comme défini par HTML",
"Definition List" => "Liste de définition",
"Create a definition list" => "Créer une liste de définitions",
// "One entry per line. Each line is in %0Term: Definition%1 format" => "One entry per line. Each line is in %0Term: Definition%1 format",
// "List Type" => "List Type",
// "Type of definition list (left-aligned or horizontal)" => "Type of definition list (left-aligned or horizontal)",
// "Standard (left-aligned)" => "Standard (left-aligned)",
// "Horizontal (inline) " => "Horizontal (inline) ",
"Draw" => "Dessiner",
// "Embed a drawing in a page" => "Embed a drawing in a page",
"Drawing ID" => "Id du dessin",
"Internal ID of the file ID" => "ID interne de l'id de fichier",
// "Width in pixels or percentage. Default value is page width, for example, %0 or %1" => "Width in pixels or percentage. Default value is page width, for example, %0 or %1",
"Height in pixels or percentage. Default value is complete drawing height" => "Hauteur en pixels ou pourcentage. La valeur par défaut est la hauteur totale du dessin",
"Force Display Archive" => "Forcer l'affichage de l'archive",
// "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision",
"Draw New SVG Image" => "Dessiner une nouvelle image SVG",
"Edit SVG Image" => "Modifier une image SVG",
// "List of dynamic variables" => "List of dynamic variables",
// "Show dynamic variables and their values" => "Show dynamic variables and their values",
"Layout" => "Mise en page générale",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
"String to use between elements of the list if table layout is not used" => "Chaîne à utiliser entre les éléments de la liste si la disposition en tableau n'est pas utilisée",
// "Parsed result" => "Parsed result",
"Syntax" => "Syntaxe",
// "Value per database" => "Value per database",
"Equation" => "Équation",
"Render an equation written in LaTeX syntax as an image" => "Afficher une équation écrite en LaTex sous forme d'image",
"equation" => "équation",
// "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator" => "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator",
// "Display events from calendars" => "Display events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)" => "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)",
"Maximum Days" => "Nb. max. de jours",
// "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0" => "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0",
"Maximum Events" => "Nb. max. d'événements",
// "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)" => "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)",
"Show Time" => "Afficher l'heure",
"Show the time along with the date (shown by default)" => "Afficher le temps avec la date (affiché par défaut)",
"Show the description of the event (shown by default)" => "Afficher la description de l'événement (affichée par défaut)",
// "Time Span" => "Time Span",
// "Specify the time span" => "Specify the time span",
// "Past" => "Past",
// "Future" => "Future",
// "Activate pagination when Events listing are long. Default is %0" => "Activate pagination when Events listing are long. Default is %0",
"Upcoming Events" => "Évènements à venir",
"Exercise" => "Exercice",
"PluginExercise" => "PluginExercise",
// "Create an exercise/test with questions and grade" => "Create an exercise/test with questions and grade",
"Answer" => "Bonne Réponse",
"Used inline to specify the right answer to the question and propose an input field" => "Utilisé en ligne pour spécifier la bonne réponse à la question et proposer un champ de saisie",
"Incorrect" => "Mauvaise Réponse",
// "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")" => "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")",
"Check your score" => "Vérifiez votre score",
"You scored %0 out of %1" => "Votre score est de %0 sur %1",
"Good" => "Exact",
"Extend Cart Inventory Hold" => "Étendre le maintien de l'inventaire du panier",
"PluginExtendCartHold" => "Plugiciel Étendre Maintien Panier",
// "Extend the time that items are held in a shopping cart" => "Extend the time that items are held in a shopping cart",
"Create a link that shows/hides initially hidden content" => "Créer un lien qui montre/cache le contenu intialement masqué",
"Content of the hideable zone (in Wiki syntax)" => "Contenu de la zone pouvant être cachée (en syntaxe Wiki)",
"Label for link that shows and hides the content when clicked" => "Etiquette du lien qui affiche ou masque le contenu quand il est cliqué",
"Unspecified label" => "Étiquette non spécifiée",
"Arrow icon showing that content can be hidden or shown" => "Icône de flèche montrant que le contenu peut être caché ou affiché",
"Show Speed" => "Vitesse pour afficher",
// "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or %0 or %1" => "Integer greater than 0 and less than or equal to 1000, or %0 or %1",
"Hide Speed" => "Vitesse pour masquer",
// "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Use Bootstrap" => "Use Bootstrap",
// "Use Bootstrap collapsible box" => "Use Bootstrap collapsible box",
// "Apply custom CSS class" => "Apply custom CSS class",
"Fancy List" => "Liste enjolivée",
// "Create a formatted numbered list" => "Create a formatted numbered list",
"One item per line starting with anything followed by \")\"" => "Un élément par ligne commençant par n'importe quoi suivi par \")\"",
"Use Div" => "Utiliser 'div'",
"Use the HTML div tag instead of the HTML ordered list tag (ol)" => "Utiliser la balise HTML 'div' au lieu de la balise HTML pour les listes (ol)",
"CSS class for the fancylist" => "Classe CSS pour la liste enjolivée",
"Heading Row" => "Ligne d'en-tête",
// "Header rows of the table. Use %0 to separate multiple rows" => "Header rows of the table. Use %0 to separate multiple rows",
"Heading CSS Class" => "Classe CSS d'en-tête",
"CSS class to apply to the heading row" => "Classe CSS à appliquer à la ligne d'en-tête",
"Header Horizontal Alignment" => "Alignement horizontal de l'en-tête",
// "Horizontal alignments for header cells, separated by %0. Choices: %1" => "Horizontal alignments for header cells, separated by %0. Choices: %1",
"Header Vertical Alignment" => "Alignement vertical de l'en-tête",
// "Vertical alignments for header cells, separated by %0\". Choices: %1" => "Vertical alignments for header cells, separated by %0\". Choices: %1",
"Column Widths" => "Largeurs de colonne",
// "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0" => "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0",
"Cell Horizontal Align" => "Alignement horizontal de la cellule",
// "Table body column horizontal alignments, separated by %0. Choices: %1" => "Table body column horizontal alignments, separated by %0. Choices: %1",
"Cell Vertical Align" => "Alignement vertical de cellule",
// "Table body column vertical alignments, separated by %0. Choices: %1" => "Table body column vertical alignments, separated by %0. Choices: %1",
"Fancy Table" => "Table enjolivée",
// "Create a formatted table that can be filtered and sorted" => "Create a formatted table that can be filtered and sorted",
// "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases" => "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases",
// "The jQuery Sortable Tables feature must be activated for the sort feature to work" => "The jQuery Sortable Tables feature must be activated for the sort feature to work",
// "JavaScript must be enabled for the sort feature to work" => "JavaScript must be enabled for the sort feature to work",
// "Unable to load the jQuery Sortable Tables feature" => "Unable to load the jQuery Sortable Tables feature",
// "Display a button for a user to click to make an object a favorite" => "Display a button for a user to click to make an object a favorite",
// "Indicate type of object" => "Indicate type of object",
// "Enter the ID of the object" => "Enter the ID of the object",
// "Link to a file that's attached or in a gallery or archive" => "Link to a file that's attached or in a gallery or archive",
"Label for the link to the file (ignored if the file is a wiki attachment)" => "Etiquette pour le lien vers le fichier (ignoré si le fichier est une pièce jointe)",
"Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indiquer si le fichier est dans une galerie de fichier ou est attaché à une page wiki",
// "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used" => "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used",
"Custom Description" => "Description personnalisée",
"Custom text that will be used for the link instead of the file name or file description" => "Texte personnalisé qui sera utilisé pour le lien plutôt que le nom de fichier ou la description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty",
"Attachment Description" => "Description pièce jointe",
"Show the attachment description as the link label instead of the attachment file name" => "Afficher la description de la pièce jointe plutôt que le nom de fichier de celle-ci",
"Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indique que cette pièce attachée est une image, et devrait être affichée en ligne en utilisant le mot-clé 'img'",
"File ID" => "ID du fichier",
"File ID of a file in a file gallery or an archive" => "ID de fichier d'un fichier de la galerie ou d'une archive",
"Example value" => "Exemple de valeur",
"Date" => "Date",
// "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1" => "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1",
"Show Icon" => "Afficher l'icône",
"Show an icon version of the file or file type with the link to the file" => "Afficher une icône de version ou du type du fichier avec le lien vers le fichier",
// "Browser Display" => "Browser Display",
// "Display in different browser window or tab instead of downloading" => "Display in different browser window or tab instead of downloading",
"File Gallery File/Archive" => "Fichier/Archive de galerie de fichiers",
"Wiki Page Attachment" => "Pièce jointe à une page Wiki",
"The date has not been set" => "la date n'a pas été positionnée",
"Incorrect date format" => "Format de date incorrect",
"No such file" => "Pas de tel fichier",
"Wiki attachments are disabled" => "Les pièces jointes Wiki sont désactivées",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when %0" => "Title for the file listing, or the link text when %0",
"File Galleries IDs" => "ID de galeries de fichiers",
// "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)" => "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)",
// "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)" => "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon",
// "Valid category IDs separated by colons" => "Valid category IDs separated by colons",
// "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty" => "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty",
// "Valid file IDs separated by colons" => "Valid file IDs separated by colons",
// "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0" => "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0",
// "Last modified Ascending" => "Last modified Ascending",
// "Last modified Descending" => "Last modified Descending",
"File Name Ascending" => "Ordre croissant de nom du fichier",
"File Name Descending" => "Ordre décroissant de nom du fichier",
"File Size Ascending" => "Ordre croissant de taille de fichier",
"File Size Descending" => "Ordre décroissant de taille de fichier",
"File Type Ascending" => "Ordre croissant de type de fichier",
"File Type Descending" => "Ordre décroissant de type de fichier",
"Last Download Ascending" => "Ordre croissant de dernier téléchargement",
"Last Download Descending" => "Ordre décroissant de dernier téléchargement",
"Show Action" => "Afficher les actions",
// "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)" => "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)",
"Show Find" => "Afficher 'Chercher'",
"Show a search box above the list (not shown by default)" => "Afficher une boîte de recherche au dessus de la liste (non affichée par défaut)",
// "Show Find is recursive" => "Show Find is recursive",
// "The search box digs recursively in sub-galleries (by default)" => "The search box digs recursively in sub-galleries (by default)",
"Show Title" => "Afficher le titre",
// "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used",
"Show ID" => "Afficher l'ID",
"Show the ID number of each file (shown by default)" => "Afficher l'ID nuémrique de chaque fichier (affichée par défaut)",
"Show the file-type icon for each file" => "Afficher une icône pour chaque fichier, reflétant son type",
"Show Name" => "Afficher le nom",
// "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show",
"Show Filename" => "Afficher le nom de fichier",
// "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show",
"Show Size" => "Afficher la taille",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show",
"Show Creation Date" => "Afficher la date de création",
"Show the date each file was created (not shown by default)" => "Afficher la date de création pour chacun des fichiers (non affichée par défaut)",
"Show Last Modification Date" => "Afficher la date de dernière modification",
"Show the date each file was last modified (shown by default)" => "Afficher la date de dernière modification pour chacun des fichiers (non affichée par défaut)",
// "Show Last Modification Time as well as Date" => "Show Last Modification Time as well as Date",
// "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)" => "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)",
"Show Hits" => "Afficher les visites",
"Show the number of hits each file has received (not shown by default)" => "Afficher le nombre de visites que chaque fichier a reçues (non affiché par défaut)",
"Show Locked By" => "Afficher 'Verrouillé par'",
"For locked files, show the username of the user who locked it (not shown by default)" => "Pour les fichiers verrouillés, afficher le nom d'utilisateur de celui qui les a verrouillés (non affiché par défaut)",
"Show the username of the user who is the author of the file (not shown by default)" => "Afficher le nom de l'utilisateur qui est l'auteur du fichier (non affiché par défaut)",
"Show Creator" => "Afficher l'auteur",
"Show the username of the user who is the creator of the file (not shown by default)" => "Afficher le nom de l'utilisateur qui est le créateur du fichier (non affiché par défaut)",
"Show Parent Gallery Name" => "Afficher le nom de la galerie parente",
"Show the name of the parent gallery" => "Afficher le nom de la galerie parente",
"Show File Count" => "Afficher le nombre de fichiers",
// "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)",
// "Show Source" => "Show Source",
// "Show the source (shown by default)" => "Show the source (shown by default)",
"Show Slideshow" => "Afficher un diaporama",
"Show a link that produces a popup slideshow when clicked (not set by default)" => "Afficher un lien qui produit un diaporama en popup quand il est cliqué (non défini par défaut)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
"Show Comments" => "Afficher Commentaire",
"Show comments for each file (not shown by default)" => "Afficher les commentaires pour chacun des fichiers (non affichés par défaut)",
"Show Last Editor" => "Afficher le dernier éditeur",
"Show the username of the user who last modified the file (shown by default)" => "Afficher le nom d'utilisateur de celui qui a modifié en dernier le fichier (affiché par défaut)",
"Show image thumbnail" => "Afficher une vignette de l'image",
"Show Image thumb" => "Afficher une vignette de l'image",
"Show only files created by this user" => "Afficher seulement les fichiers créés par cet utilisateur",
"Show Upload" => "Afficher 'Envoyer'",
"Show a simple form to upload files to the gallery (not shown by default)" => "Afficher un formulaire simple de téléchargement vers la galerie (non affiché par défaut)",
"Number of rows (default: -1 = all)" => "Nombre de ligne (par défaut : -1 = toutes)",
"Recursive" => "Récursif",
"With subgalleries" => "Avec  les sous-galeries",
// "Fitnesse Test Suite" => "Fitnesse Test Suite",
// "Create test suites for applications built using Tiki" => "Create test suites for applications built using Tiki",
// "Test execution scenario" => "Test execution scenario",
// "Fixture not found: %0" => "Fixture not found: %0",
// "Tracker Math for [%0|%1]" => "Tracker Math for [%0|%1]",
// "Tracker Field not found: %0" => "Tracker Field not found: %0",
// "Field is not a math field: %0" => "Field is not a math field: %0",
// "Tracker Data for [%0|%1]" => "Tracker Data for [%0|%1]",
// "Table must contain at least one field named itemId" => "Table must contain at least one field named itemId",
// "%0 (expect: %1)" => "%0 (expect: %1)",
"Flash Video" => "Vidéo Flash",
"Embed a video or audio file" => "Insérer un fichier vidéo ou audio",
"Flash Type" => "Type Flash",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo",
"Blip.tv" => "Blip.tv",
"File Gallery Podcast" => "Podcast de la galerie de fichiers",
"Movie URL" => "URL du film",
"Youtube" => "Youtube",
// "URL to the movie to include, for example, %0" => "URL to the movie to include, for example, %0",
"File Gallery Podcast ID" => "ID du fichier en galerie podcast",
"ID of a file from a podcast gallery - will work only with podcast gallery" => "Id d'un fichier dans une galerie de fichiers podcast - ne fonctionnera qu'avec une galerie podcast",
"YouTube URL" => "URL YouTube",
"Complete URL to the YouTube video" => "URL complète de la vidéo YouTube",
"Vimeo URL" => "URL Vimeo",
"Complete URL to the Vimeo video" => "URL complète de la vidéo Vimeo",
// "Width of movie in pixels (default is %0)" => "Width of movie in pixels (default is %0)",
// "Height of movie in pixels (default is %0)" => "Height of movie in pixels (default is %0)",
"Quality" => "Qualité",
// "Flash video quality. Default value: %0" => "Flash video quality. Default value: %0",
"Medium" => "Médium",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
"Invalid URL" => "URL non valide",
"Missing parameter movie to the plugin flash" => "Paramètre manquant au plugiciel flash",
// "Fluid Grid" => "Fluid Grid",
// "Arrange content into rows and columns using a Bootstrap fluid grid" => "Arrange content into rows and columns using a Bootstrap fluid grid",
// "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Join Columns" => "Joindre les colonnes",
// "Merge empty cells into the cell to their left" => "Merge empty cells into the cell to their left",
// "Device size" => "Device size",
// "Specify the device size below which the cells will be stacked vertically" => "Specify the device size below which the cells will be stacked vertically",
"Small" => "Petit",
"Large" => "Large",
// "Extra Large" => "Extra Large",
"Column Sizes" => "Tailles de colonne",
// "Specify all column widths in units which add up to 12" => "Specify all column widths in units which add up to 12",
"First" => "Prem.",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Colonne",
"Custom Class" => "Classe personnalisée",
"Add a class to customize the design" => "Ajouter une classe pour personnaliser le design",
"Font" => "Polices",
// "Format the font type and size of text" => "Format the font type and size of text",
"Content" => "Contenu",
"Font Family" => "Famille de polices",
"Select the font family to display the content" => "Choisir la famille de polices pour afficher le contenu",
"Font Size" => "Taille de la fonte",
// "Define the size of the font in pixels (enter %0 to get a font of 12px)" => "Define the size of the font in pixels (enter %0 to get a font of 12px)",
"Footnote" => "Note de pied de page",
"Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Créer automatiquement des notes de pied de page numérotées (de concert avec le plugiciel FootNoteArea)",
"The footnote" => "La note de pied de page",
"Tag" => "Mot-clé",
// "Tag footnote with unique identifier" => "Tag footnote with unique identifier",
// "One word made of alphanumeric characters" => "One word made of alphanumeric characters",
// "Same as Tag" => "Same as Tag",
// "Tag to existing footnote by its Tag" => "Tag to existing footnote by its Tag",
// "Same as" => "Same as",
// "Tag to existing footnote number" => "Tag to existing footnote number",
// "tag name (since 17) or footnote number" => "tag name (since 17) or footnote number",
// "Add class to footnotearea" => "Add class to footnotearea",
// "Scheme" => "Scheme",
// "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)" => "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)",
// "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)" => "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)",
// "Error: Tag not found in any previous footnote" => "Error: Tag not found in any previous footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Filter footnotearea by footnote class" => "Filter footnotearea by footnote class",
// "SameAs Style" => "SameAs Style",
// "Numbering style for sameas referencing" => "Numbering style for sameas referencing",
// "Valid Tiki ((Number Style))" => "Valid Tiki ((Number Style))",
"Tagged" => "Mots-clés similaires",
"List similarly tagged objects" => "Lister les objets ayant des mots-clés similaires",
"Tags to find similar to" => "Mots-clés à trouver comme similaires",
"Leave blank to use the object's own tags" => "Laisser à blanc pour utiliser les mots-clés de l'objet lui-même",
"Type of objects to extract. Set to All to find all types" => "Type d'objets à extraire. Régler sur tous (All) pour trouver tous les types",
"Same" => "Identique",
"Blog Posts" => "Articles du blogue",
// "Faqs" => "Faqs",
"Offset" => "Décalage",
"Start record" => "Premier enregistrement",
"Default -1 (all)" => "Défaut -1 (tous)",
// "Determine sort order based on various fields (Default: %0)" => "Determine sort order based on various fields (Default: %0)",
"Comments locked Ascending" => "Ordre croissant des commentaires verrouillés",
"Comments locked Descending" => "Ordre décroissant des commentaires verrouillés",
"Description Ascending" => "Ordre croissant de description",
"Description Descending" => "Ordre décroissant de description",
"Href Ascending" => "En ordre croissant d'URL cible",
"Href Descending" => "En ordre décroissant d'URL cible",
"Object ID Ascending" => "En ordre croissant d'ID d'objet",
"Object ID Descending" => "En ordre décroissant d'ID d'objet",
"Show objects with names or descriptions similar to the text entered here" => "Afficher les objets dont les noms et descriptions sont similaires au texte saisi ici",
// "Choose whether to broaden" => "Choose whether to broaden",
"n|y" => "n|o",
// "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags" => "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags",
"Show Titles Only" => "Afficher les titres seulement",
"Choose whether to show titles only (not shown by default)" => "Choisissez si vous souhaitez afficher uniquement les titres (pas affiché par défaut)",
// "Max Image Size" => "Max Image Size",
// "Height or width in pixels. Default: %0 (no maximum)" => "Height or width in pixels. Default: %0 (no maximum)",
// "Show a 'more' link that links to the full list of tagged objects (not shown by default)" => "Show a 'more' link that links to the full list of tagged objects (not shown by default)",
"More URL" => "Lien URL 'Plus'",
// "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects" => "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects",
// "More label" => "More label",
// "Alternate text to display on the \"more\" link (default is \"more\")" => "Alternate text to display on the \"more\" link (default is \"more\")",
// "Friend and unfriend other users" => "Friend and unfriend other users",
// "Add or Remove Friend Button" => "Add or Remove Friend Button",
"Other User" => "Autre utilisateur",
"Button Text" => "Texte du bouton",
// "The user you wish to change relations with" => "The user you wish to change relations with",
// "Button text that's displayed when friending a user" => "Button text that's displayed when friending a user",
// "Button text that's displayed when un-friending a user" => "Button text that's displayed when un-friending a user",
// "Add to Friend Network" => "Add to Friend Network",
// "Remove from Friend Network" => "Remove from Friend Network",
"FTP" => "FTP",
"Create a button for downloading a file from an FTP server" => "Créer un bouton pour télécharger un fichier depuis un serveur FTP",
// "File name on the server" => "File name on the server",
"Server Name" => "Nom du Serveur",
"Name of the server for the FTP account. Example: " => "Nom du serveur où le compte FTP est domicilié. Exemple : ",
"Username for the FTP account" => "Nom utilisateur nécessaire pour accéder au compte FTP",
"Password for the FTP account" => "Mot de passe nécessaire pour accéder au compte FTP",
"Download Button Label" => "Libellé du bouton de téléchargement",
"Label for the FTP download button" => "Etiquette pour le bouton de téléchargement FTP",
"missing parameters" => "paramètres manquants",
"Connection failed" => "Échec de la connexion",
// "Set a Full-Width Page Title" => "Set a Full-Width Page Title",
// "Display the page title the full width of the site content container. " => "Display the page title the full width of the site content container. ",
// "PluginFullWidthTitle" => "PluginFullWidthTitle",
// "Page title" => "Page title",
// "If you need to include tpl files" => "If you need to include tpl files",
// "Icon Source" => "Icon Source",
// "Source path of the icon" => "Source path of the icon",
"Galleriffic" => "Galerie",
// "Display a slideshow of images on a page using the Galleriffic script" => "Display a slideshow of images on a page using the Galleriffic script",
// "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual table field name in place of %2" => "%0 or %1 with actual table field name in place of %2",
// "Thumbs Width" => "Thumbs Width",
// "Width in pixels or percentage. (e.g. %0 or %1)" => "Width in pixels or percentage. (e.g. %0 or %1)",
// "Image Slideshow Width" => "Image Slideshow Width",
// "Width in pixels or percentage of the largest image. (e.g. %0 or %1)" => "Width in pixels or percentage of the largest image. (e.g. %0 or %1)",
// "Image Slideshow Height" => "Image Slideshow Height",
// "Height in pixels or percentage of the largest images. (e.g. %0 or %1)" => "Height in pixels or percentage of the largest images. (e.g. %0 or %1)",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
"Delay" => "Délai",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of thumbnails" => "Number of thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show Top Pager" => "Show Top Pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show Bottom Pager" => "Show Bottom Pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
"Play Slideshow" => "Démarrer le diaporama",
"Pause Slideshow" => "Arrêter le diaporama",
"Previous Photo" => "Photo précédente",
"Next Photo" => "Photo suivante",
"Prev" => "Préc.",
// "Gantt Chart" => "Gantt Chart",
// "Create and display a gantt graphic using tracker data" => "Create and display a gantt graphic using tracker data",
// "Tracker to search from" => "Tracker to search from",
// "Order Field" => "Order Field",
// "Permanent name of the field to use for row number order" => "Permanent name of the field to use for row number order",
// "Level Field" => "Level Field",
// "Permanent name of the field to use for row level" => "Permanent name of the field to use for row level",
// "Status Field" => "Status Field",
// "Permanent name of the field to use for row status" => "Permanent name of the field to use for row status",
// "Dependency Field" => "Dependency Field",
// "Permanent name of the field to use for row dependency" => "Permanent name of the field to use for row dependency",
// "Progress Field" => "Progress Field",
// "Permanent name of the field to use for row progress, values between 0-100" => "Permanent name of the field to use for row progress, values between 0-100",
// "Name Field" => "Name Field",
// "Permanent name of the field to use for row name" => "Permanent name of the field to use for row name",
// "Description Field" => "Description Field",
// "Permanent name of the field to use for row description" => "Permanent name of the field to use for row description",
// "Code Field" => "Code Field",
// "Permanent name of the field to use for row code" => "Permanent name of the field to use for row code",
// "Begin Date Field" => "Begin Date Field",
// "Permanent name of the field to use for event beginning" => "Permanent name of the field to use for event beginning",
// "End Date Field" => "End Date Field",
// "Permanent name of the field to use for event ending" => "Permanent name of the field to use for event ending",
// "Resources Field" => "Resources Field",
// "Permanent name of the field to use for resources ending" => "Permanent name of the field to use for resources ending",
// "Roles Field" => "Roles Field",
// "Permanent name of the field to use for roles ending" => "Permanent name of the field to use for roles ending",
// "Effort Field" => "Effort Field",
// "Permanent name of the field to use for effort ending, values in milliseconds" => "Permanent name of the field to use for effort ending, values in milliseconds",
// "Start Is Milestone" => "Start Is Milestone",
// "Flag field to start is milestone" => "Flag field to start is milestone",
// "End Is Milestone" => "End Is Milestone",
// "Flag field to end is milestone" => "Flag field to end is milestone",
// "Writable" => "Writable",
// "Flag field to write or not in tasks" => "Flag field to write or not in tasks",
// "Deletable" => "Deletable",
// "Flag field that permit to delete or not tasks" => "Flag field that permit to delete or not tasks",
// "Parent Writable" => "Parent Writable",
// "Flag field to write or not in parent tasks" => "Flag field to write or not in parent tasks",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer",
// "Tracker data source not found" => "Tracker data source not found",
// "Order tracker field parameter is mandatory" => "Order tracker field parameter is mandatory",
// "Level tracker field parameter is mandatory" => "Level tracker field parameter is mandatory",
// "Depends tracker field parameter is mandatory" => "Depends tracker field parameter is mandatory",
// "You are trying to update a tracker that is not used by this gantt chart" => "You are trying to update a tracker that is not used by this gantt chart",
// "Gantt chart updated" => "Gantt chart updated",
"Gauge" => "Jauge",
"Display a horizontal bar gauge" => "Afficher une barre de progression horizontale",
"description" => "description",
"Current value to be represented by the gauge" => "Valeur courante à représenter par la barre de progression",
"Maximum Value" => "Valeur maximum",
// "Maximum possible value. Default: %0" => "Maximum possible value. Default: %0",
"Label displayed on the left side of the gauge" => "Etiquette sur le côté gauche de la jauge",
"Color" => "Couleur",
"Main color of the gauge. Use HTML color codes or names" => "Couleur principale de la barre de progression. Utiliser les codes ou noms de couleur",
"Background color of the gauge. Use HTML color codes or names." => "Arrière-plan de la barre de progression. Utiliser les codes ou noms de couleurs HTML",
"Bar width in pixels." => "Largeur de la barre de progression en pixels.",
"Label Width" => "Largeur de l'étiquette",
"Label width, in pixels" => "Largeur en pixels allouée à l'étiquette",
"Display Percentage" => "Afficher les pourcentages",
// "Set to %0 (Yes) to display a percentage of the maximum" => "Set to %0 (Yes) to display a percentage of the maximum",
"Display Value" => "Afficher la valeur",
// "Set to %1 (No) to hide the numeric value (shown by default)" => "Set to %1 (No) to hide the numeric value (shown by default)",
"Bar height in pixels." => "Hauteur de la barre de progression en pixels.",
// "GDGraph" => "GDGraph",
// "Create a simple graph from supplied data" => "Create a simple graph from supplied data",
// "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body" => "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body",
// "14, backported to 12.4" => "14, backported to 12.4",
// "Graph Type" => "Graph Type",
// "Defines what ype of graph or chart is to be generated" => "Defines what ype of graph or chart is to be generated",
// "Vertical Bar" => "Vertical Bar",
// "Graph Title" => "Graph Title",
// "Displayed above the graph" => "Displayed above the graph",
// "Alt Tag" => "Alt Tag",
// "Text for image alt tag" => "Text for image alt tag",
// "Graph Image Width" => "Graph Image Width",
// "Overall width in pixels. Default value is %0" => "Overall width in pixels. Default value is %0",
// "Graph Image Height" => "Graph Image Height",
// "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown" => "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Display a link on a secure page using an access token" => "Display a link on a secure page using an access token",
// "Entry Patg" => "Entry Patg",
// "The path or part of the path that the token is for" => "The path or part of the path that the token is for",
// "Query Keys" => "Query Keys",
// "Query string parameter keys that the token is for, separated by a colon (:)" => "Query string parameter keys that the token is for, separated by a colon (:)",
// "Query Values" => "Query Values",
// "Query string parameter values that the token is for, separated by a colon (:)" => "Query string parameter values that the token is for, separated by a colon (:)",
"Google Analytics" => "Google Analytics",
"Add the tracking code for Google Analytics" => "Ajouter le code de suivi pour Google Analytics",
"Account Number" => "Numéro du Compte",
// "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1" => "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1",
// "Groups Option" => "Groups Option",
// "Define option for Google Analytics groups, include or exclude" => "Define option for Google Analytics groups, include or exclude",
// "Available Groups" => "Available Groups",
// "Google Analytics Chart" => "Google Analytics Chart",
// "Draw charts from Google Analytics data" => "Draw charts from Google Analytics data",
// "JSON File" => "JSON File",
// "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)" => "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)",
// "Profle IDs" => "Profle IDs",
// "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin" => "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin",
// "Query String" => "Query String",
// "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0" => "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0",
// "Metrics" => "Metrics",
// "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"" => "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"",
// "default \"30daysAgo\"" => "default \"30daysAgo\"",
// "default \"yesterday\"" => "default \"yesterday\"",
// "Dimensions" => "Dimensions",
// "default \"ga:date\"" => "default \"ga:date\"",
// "Segment" => "Segment",
// "default \"\"" => "default \"\"",
// "Max Results" => "Max Results",
// "default 50" => "default 50",
"Sort" => "Tri",
// "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"" => "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"",
// "Container" => "Container",
// "ID of a DIV to contain the chart (optional)" => "ID of a DIV to contain the chart (optional)",
// "Type of chart, e.g. LINE, PIE etc" => "Type of chart, e.g. LINE, PIE etc",
// "Bar" => "Bar",
// "Pie" => "Pie",
// "Geo" => "Geo",
// "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "googlechart: No credentials file" => "googlechart: No credentials file",
// "googlechart: No query_ids supplied" => "googlechart: No query_ids supplied",
// "googlechart exception: %0" => "googlechart exception: %0",
"Google Doc" => "Document Google",
"Display a Google document" => "Afficher un document Google",
"Leave this empty" => "Laisser vide",
"Type of Google document" => "Type de document Google",
"Document" => "Document",
// "Slides" => "Slides",
// "Forms" => "Forms",
"Key" => "Clé",
// "Google doc key - for example" => "Google doc key - for example",
"Name of iframe. Default is \"Frame\" + the key" => "Nom du cadre (iframe). Par défaut, c'est  \"Frame\" + la clé",
// "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly",
"Width in pixels or %" => "Largeur en pixels ou %",
"Height in pixels or %" => "Hauteur en pixels ou %",
// "Position of frame on page" => "Position of frame on page",
"Middle" => "Milieu",
"Frame Border" => "Bordure du cadre",
"Choose whether to show a border around the iframe" => "Choisir de montrer ou pas une bordure autour du cadre de page externe",
"Margin Height" => "Hauteur de marge",
"Margin height in pixels" => "Hauteur de marge en pixels",
"Margin Width" => "Largeur de la marge",
"Margin width in pixels" => "Largeur de marge en pixels",
"Scrolling" => "Défilement",
"Choose whether to add a scroll bar" => "Choisir d'ajouter une barre de défilement ou pas",
"Auto" => "Auto",
"Edit Link" => "Modifier le lien",
"Choose whether to show an edit link and set its location" => "Choisir d'afficher ou non un lien d'édition et fixer son emplacement",
"Required parameter \"type\" missing" => "Paramètre requis \"type\" absent",
"Required parameter \"key\" missing" => "Paramètre requis \"key\" absent",
"Display content based on the user's groups or friends" => "Afficher du contenu en fonction des groupes ou amis de l'utilisateur",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions",
"Allowed User Friends" => "Amis de l'utilisateur autorisés",
// "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample",
"Allowed Groups" => "Groupes autorisés",
// "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample",
"Denied Groups" => "Groupes rejetés",
// "Pipe-separated list of groups not allowed to view the block" => "Pipe-separated list of groups not allowed to view the block",
// "Allowed Groups Pending Membership" => "Allowed Groups Pending Membership",
// "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding" => "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding",
// "Allowed Groups Full Membership" => "Allowed Groups Full Membership",
// "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending" => "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending",
"Group Expiration" => "Expiration de l'adhésion à un groupe",
// "Show the expiration date of a group the user belongs to" => "Show the expiration date of a group the user belongs to",
// "The name of an existing group on the site" => "The name of an existing group on the site",
"not in group" => "pas dans le groupe",
"never expires" => "n'expire jamais",
"Group List" => "Liste de groupes",
// "Create a complete or filtered list of groups" => "Create a complete or filtered list of groups",
// "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed",
"Group Homepage" => "Page d'accueil du groupe",
"Link the group name to the group homepage, if there is one (not linked to by default)" => "Lier le nom du groupe à la page d'accueil du groupe, si il y en a une (pas lié par défaut)",
"Recursively List Groups" => "Lister récursivement les groupes",
"Recursively list the included groups (the default is to not list them repeatedly)" => "Agir récursivement sur les groupes inclus (non par défaut)",
// "List only your own" => "List only your own",
// "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)" => "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)",
"GroupMail Core" => "Coeur du GroupMail",
// "Display GroupMail functions on a page" => "Display GroupMail functions on a page",
"From Email" => "Adresse mail expéditeur",
"Email address to report" => "Adresse mail à rapporter",
"ID of GroupMail Logs tracker (set up in alias by profile)" => "Id du formulaire Journal du GroupMail (défini dans l'alias par le profil)",
"ID of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id du champ du formulaire Journal du GroupMail (normalement défini dans l'alias par le profil)",
"Datetime Field ID" => "Id du champ 'date & heure'",
"Group Stats" => "Statistiques de groupe",
"Show the distribution of users among groups" => "Afficher la répartition des utilisateurs dans les groupes",
"Groups" => "Groupes",
"Groups, separated by \":\". If empty, all groups will be listed" => "Groupes séparés par ':'. Si vide, tous les groupes seront listés",
"Percentage of" => "Pourcentage de",
// "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter" => "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter",
// "Users in groups" => "Users in groups",
"Site users" => "Utilisateurs du site",
"Show Percentage" => "Afficher les pourcentages",
// "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)" => "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)",
"Show Bar" => "Afficher les barres",
// "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)",
// "H5P" => "H5P",
// "Enable the creation, sharing and reuse of interactive HTML5 content" => "Enable the creation, sharing and reuse of interactive HTML5 content",
// "The H5P file in a file gallery" => "The H5P file in a file gallery",
// "H5P is not compatible with the Inline comments (annotations) feature" => "H5P is not compatible with the Inline comments (annotations) feature",
// "Has Bought" => "Has Bought",
// "Check whether a user has bought an item or added it to the shopping cart" => "Check whether a user has bought an item or added it to the shopping cart",
// "PluginHasBought" => "PluginHasBought",
// "Key Name" => "Key Name",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Key Labels" => "Key Labels",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
// "Tracker from which to get passcode to check against" => "Tracker from which to get passcode to check against",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
"Please fill in all fields" => "Merci de remplir tous les champs",
"HTML" => "HTML",
"Add HTML to a page" => "Ajouter du HTML à une page",
"HTML code" => "Code HTML",
// "Move to HTML head" => "Move to HTML head",
// "Insert the code in the HTML head section rather than in the body" => "Insert the code in the HTML head section rather than in the body",
"Parse wiki syntax within the HTML code" => "Interpréter la syntaxe wiki à l'intérieur du code HTML",
// "HTML Feed" => "HTML Feed",
// "Add an item to HTML Feed" => "Add an item to HTML Feed",
// "Name of this feed" => "Name of this feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Receive and display content from another site sent using PluginHTMLFeed" => "Receive and display content from another site sent using PluginHTMLFeed",
"Initial Value" => "Valeur initiale",
// "Feed Location" => "Feed Location",
// "Content Name" => "Content Name",
// "Content Style" => "Content Style",
"Highlight" => "Surligner",
"Asterisk" => "Astérisque",
// "HTML Feed Link Type" => "HTML Feed Link Type",
// "Backlink" => "Backlink",
"Popup" => "Popup",
// "Hover" => "Hover",
// "Moderated" => "Moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
// "Display an icon" => "Display an icon",
// "Name of the icon" => "Name of the icon",
// "Valid icon name" => "Valid icon name",
// "Size of the icon (greater than 0 and less than 10)" => "Size of the icon (greater than 0 and less than 10)",
// "greater than 0 and less than 10" => "greater than 0 and less than 10",
"Rotate" => "Alterner",
// "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)" => "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)",
// "90, 180, 270, horizontal, vertical" => "90, 180, 270, horizontal, vertical",
// "Style supported by the current icon set" => "Style supported by the current icon set",
"Iframe" => "Cadre de page",
// "Include the body of another web page in a scrollable frame within a page" => "Include the body of another web page in a scrollable frame within a page",
"Frame title" => "Titre du cadre",
"Pixels or %" => "Pixels ou %",
"Align the iframe on the page" => "Aligner le cadre 'Iframe' dans la page",
// "Responsive" => "Responsive",
// "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device" => "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device",
// "16 by 9" => "16 by 9",
// "4 by 3" => "4 by 3",
"no" => "non",
// "Display one or more custom-formatted images" => "Display one or more custom-formatted images",
// "Image Source" => "Image Source",
// "Choose where to get the image from" => "Choose where to get the image from",
// "An image in the file galleries" => "An image in the file galleries",
// "An image attached to a wiki page" => "An image attached to a wiki page",
// "An image anywhere on the Internet" => "An image anywhere on the Internet",
// "One random image from a file gallery" => "One random image from a file gallery",
// "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)",
// "Valid file IDs separated by commas or |" => "Valid file IDs separated by commas or |",
"Image ID" => "Id Image",
// "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)",
// "Valid image IDs separated by commas or |" => "Valid image IDs separated by commas or |",
// "Full URL to the image to display" => "Full URL to the image to display",
"Numeric ID of a file gallery. Displays a random image from that gallery" => "ID numérique d'une galerie de fichiers. Affiche une image aléatoire à partir de cette galerie",
"Numeric ID of a file gallery. Displays all images from that gallery" => "ID numérique d'une galerie de fichiers. Affiche toutes les images à partir de cette galerie",
"Attachment ID" => "ID de pièce jointe",
// "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)" => "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)",
// "Valid attachment IDs separated by commas or |" => "Valid attachment IDs separated by commas or |",
"Thumbnail" => "Vignette",
// "Makes the image a thumbnail with various options" => "Makes the image a thumbnail with various options",
// "Simple - links to full size image on a new page" => "Simple - links to full size image on a new page",
// "\"Lightbox\" - enlarges in an overlay box when clicked" => "\"Lightbox\" - enlarges in an overlay box when clicked",
// "Mouseover - enlarges in a popup when moused over" => "Mouseover - enlarges in a popup when moused over",
// "Mouseover (sticky)" => "Mouseover (sticky)",
// "Popup - enlarges in a separate window" => "Popup - enlarges in a separate window",
// "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1" => "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1",
// "Image Height" => "Image Height",
// "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Image Width" => "Image Width",
// "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Serve retina images" => "Serve retina images",
// "Serves up retina images to high density screen displays. Width must be set to use this" => "Serves up retina images to high density screen displays. Width must be set to use this",
// "Responsive Image Widths" => "Responsive Image Widths",
// "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"" => "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"",
// "Sizes" => "Sizes",
// "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters" => "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters",
// "Maximum Size" => "Maximum Size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings",
// "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description" => "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description",
// "Alternate Text" => "Alternate Text",
"Alternate text that displays when image does not load. Set to \"Image\" by default" => "Texte alternatif qui s'affiche quand l'image ne peut être chargée. Réglé sur \"Image\" par défaut",
// "Responsive Image" => "Responsive Image",
// "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class" => "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class",
// "Featured Image" => "Featured Image",
// "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose" => "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose",
"Comment Ascending" => "En ordre croissant de commentaires",
"Comment Descending" => "En ordre décroissant de commentaires",
"Max Hits Ascending" => "Ordre croissant du nombre max de visites",
"Max Hits Descending" => "Ordre décroissant du nombre max de visites",
"User Ascending" => "En ordre croissant d'utilisateur",
"User Descending" => "Ordre décroissant de nom d'utilisateur",
"Author Ascending" => "Ordre croissant de nom d'auteur",
"Author Descending" => "Ordre décroissant de nom d'auteur",
"Locked By Ascending" => "Ordre croissant de verrouillé par",
"Locked By Descending" => "Ordre décroissant de verrouillé par",
"Last modified User Ascending" => "Ordre croissant d'utilisateur de la dernière modification",
"Last modified User Descending" => "Ordre décroissant d'utilisateur de la dernière modification",
"Last modified Date Ascending" => "Ordre croissant de date de dernière modification",
"Last modified Date Descending" => "Ordre décroissant de date de dernière modification",
"Delete After Ascending" => "Ordre croissant de supprimer après",
"Delete After Descending" => "Ordre décroissant de supprimer après",
"Votes Ascending" => "Ordre croissant des votes",
"Votes Descending" => "Ordre décroissant des votes",
"Points Ascending" => "Ordre croissant de points",
"Points Descending" => "Ordre décroissant de points",
"Archive ID Ascending" => "Ordre croissant d'identifiant d'archive",
"Archive ID Descending" => "Ordre décroissant d'identifiant d'archive",
// "Enlarge Button" => "Enlarge Button",
// "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1" => "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1",
"Browse Popup" => "Parourir dans une popup",
// "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked" => "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked",
// "Image Map" => "Image Map",
"Name of the image map to use for the image" => "Nom de la 'map' image à utiliser avec l'image",
// "Horizontal spacing" => "Horizontal spacing",
// "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Vertical spacing" => "Vertical spacing",
// "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Align image using legacy align tag" => "Align image using legacy align tag",
// "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email" => "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email",
// "Align Image" => "Align Image",
// "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page" => "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page",
// "Image Style" => "Image Style",
// "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects" => "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects",
// "Align Image Block" => "Align Image Block",
// "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1" => "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1",
// "Image Block Style" => "Image Block Style",
// "Description Style" => "Description Style",
// "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects" => "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects",
// "Wrapping" => "Wrapping",
"Control how other items wrap around the image" => "Contrôler comment les autres éléments se placent autour de l'image",
// "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows" => "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows",
// "Link Title" => "Link Title",
// "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties" => "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties",
"Metadata" => "Méta-données",
// "Display the image metadata (IPTC, EXIF and XMP information)" => "Display the image metadata (IPTC, EXIF and XMP information)",
// "Compression Quality" => "Compression Quality",
// "0 to 100 (default is 75)" => "0 to 100 (default is 75)",
// "Default Settings" => "Default Settings",
// "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Mandatory Setting" => "Mandatory Setting",
// "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Image Gallery Image" => "Image Gallery Image",
"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Une fenêtre de parcours de la galerie d'images s'ouvrira qand la vignette est cliquée si l'image est dans une galerie d'images Tiki",
"Same as \"browse\" except that the page opens in a new window or tab" => "Similaire à \"Parourir\" sauf que la page s'ouvre dans une nouvelle fenêtre ou onglet",
"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Fait de l'image une vignette qui s'agrandit à la taille complète quand elle est cliquée ou survolée par la souris (sauf si \"Lien\" est défini vers une autre cible). \"Parourir\" et \"Parcourir dans une popup\" fonctionnent uniquement avec une galerie d'images et \"Télécharger\" fonctionne seulement avec une galerie de fichiers ou des pièces jointes",
// "Hide Draw Icon" => "Hide Draw Icon",
// "Do not show draw/edit icon button under image" => "Do not show draw/edit icon button under image",
// "Overlay with zoom" => "Overlay with zoom",
// "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked" => "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked",
// "Zoom" => "Zoom",
// "Adds a magnifying glass icon and zooms the image when hovered over" => "Adds a magnifying glass icon and zooms the image when hovered over",
"PluginImg: User lacks permission to view image" => "Plugiciel Image : L'utilisateur n'a pas la persmission de voir l'image",
"File is not an image" => "Le fichier n'est pas une image",
"Server does not support image manipulation" => "Le serveur ne permet pas la manipulation d'image",
// "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator" => "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator",
// "SVG Image replace error \"%0\"" => "SVG Image replace error \"%0\"",
"Enlarge" => "Agrandir",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''",
"''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Utiliser un et un seul de ces paramètres : fileId, randomGalleryId, fgalId, attId, id, ou src.''",
"Draw on the Image" => "Dessiner sur l'image",
"Include" => "Inclure",
// "Include a portion of another wiki page" => "Include a portion of another wiki page",
// "Name of the source wiki page (which contains the included portion)" => "Name of the source wiki page (which contains the included portion)",
// "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start",
"Stop" => "Fin",
// "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end",
// "Read more button" => "Read more button",
// "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)" => "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)",
// "Read more button label" => "Read more button label",
// "Label of the button linking to the source page (if it is displayed)" => "Label of the button linking to the source page (if it is displayed)",
// "Text to show when the page selected to be included is not found anymore" => "Text to show when the page selected to be included is not found anymore",
// "Permission denied message" => "Permission denied message",
// "Text to show when the page exists but the user has insufficient permissions to see it" => "Text to show when the page exists but the user has insufficient permissions to see it",
// "No version approved error message" => "No version approved error message",
// "Text to show when the page exists but no version is approved" => "Text to show when the page exists but no version is approved",
// "Edit Icon" => "Edit Icon",
// "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings" => "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings",
// "Max inclusions" => "Max inclusions",
// "Maximum amount of times the same page can be included. Defaults to 5" => "Maximum amount of times the same page can be included. Defaults to 5",
// "Parse Included Page" => "Parse Included Page",
// "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents" => "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents",
// "Max characters included" => "Max characters included",
// "Limit the length of the included text" => "Limit the length of the included text",
"Read more" => "Lire plus",
// "The text above comes from page \"%s\". Click to go to that page" => "The text above comes from page \"%s\". Click to go to that page",
"Include Plugin" => "Inclure le plugiciel",
"Edit the included page" => "Modifier la page incluse",
// "Include Template File" => "Include Template File",
// "Include a Smarty template (.tpl) file in a page" => "Include a Smarty template (.tpl) file in a page",
// "TPL file name" => "TPL file name",
// "If you need to include Smarty template files" => "If you need to include Smarty template files",
// "Values passed to the TPL" => "Values passed to the TPL",
// "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1" => "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1",
// "Include URL" => "Include URL",
// "Include the body content from a URL" => "Include the body content from a URL",
// "URL to external file to include" => "URL to external file to include",
// "Missing parameter url for plugin %0" => "Missing parameter url for plugin %0",
// "Insert Tracker Item" => "Insert Tracker Item",
// "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item" => "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item",
// "Item not inserted" => "Item not inserted",
"Invite" => "Inviter",
"Invite a user to join your groups" => "Inviter un utilisateur à rejoindre vos groupes",
"Confirmation message after posting form" => "Message de confirmation après le formulaire de publication",
"Including Group" => "Groupe contenant",
"Will list only the groups that include this group" => "Enumérera seulement les groupes incluant ce groupe",
"Default Group" => "Groupe par défaut",
"Dropdown list will show this group by default" => "La liste déroulante montrera ce groupe par défaut",
// "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default",
"The following mandatory fields are missing" => "Les champs obligatoires suivants sont manquants",
"Email address" => "Adresse électronique",
// "Add jQuery JavaScript code" => "Add jQuery JavaScript code",
"JavaScript code" => "Code JavaScript",
"Not On Ready" => "Pas 'On Ready'",
"Do not execute on document ready (execute inline)" => "Ne pas exécuter sur 'document ready' (exécuter en ligne) true|false",
"No JavaScript" => "JavaScript désactivé",
"Optional markup for when JavaScript is off" => "Marquage optionnel quand JavaScript est arrêté",
// "Language to apply JQuery to" => "Language to apply JQuery to",
"<!-- jq plugin inactive: JavaScript off -->" => "<!-- plugiciel jq inactif : JavaScript est désactivé -->",
"JavaScript" => "JavaScript",
// "Add JavaScript code or files" => "Add JavaScript code or files",
"JavaScript filename" => "Nom de fichier JavaScript",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
"Display a video created through the Kaltura feature" => "Afficher une vidéo créée grâce à la fonctionnalité Kaltura",
"Kaltura Entry ID" => "ID de l'entrée Kaltura",
// "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one" => "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one",
// "Kaltura Video Player ID" => "Kaltura Video Player ID",
// "Width of the player in pixels or percent" => "Width of the player in pixels or percent",
// "Height of the player in pixels or percent" => "Height of the player in pixels or percent",
// "Align" => "Align",
// "Alignment of the player" => "Alignment of the player",
// "Not set" => "Not set",
// "Centre" => "Centre",
// "Alignment of the player using CSS float" => "Alignment of the player using CSS float",
// "Add Media Button Label" => "Add Media Button Label",
// "Text to display on button for adding new media" => "Text to display on button for adding new media",
// "Add media" => "Add media",
// "Player Type" => "Player Type",
// "Set player type" => "Set player type",
// "KDP" => "KDP",
// "HTML5" => "HTML5",
// "Upload Media" => "Upload Media",
// "Media ID or permission to upload video is required" => "Media ID or permission to upload video is required",
// "Log in to upload video" => "Log in to upload video",
// "Player not found" => "Player not found",
// "Kaltura player: unsupported type" => "Kaltura player: unsupported type",
// "Show alternative content based on the page language" => "Show alternative content based on the page language",
// "Content to show" => "Content to show",
// "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Not Language" => "Langues rejetées",
// "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Show the last modification date for a page" => "Afficher la date de dernière modification d'une page",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
"Date format" => "Format de date",
// "Set date and time format according to site settings" => "Set date and time format according to site settings",
// "Long date" => "Long date",
// "Short date" => "Short date",
// "Long datetime" => "Long datetime",
// "Short datetime" => "Short datetime",
// "ISO" => "ISO",
// "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects" => "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects",
// "Display page header" => "Display page header",
// "Set to No, to hide header on the page" => "Set to No, to hide header on the page",
// "Display Page Footer" => "Display Page Footer",
// "Display Page Left Bar" => "Display Page Left Bar",
// "Set to No, to hide left on the page" => "Set to No, to hide left on the page",
// "Display Page Right Bar" => "Display Page Right Bar",
// "Set to No, to hide right on the page" => "Set to No, to hide right on the page",
// "Page Full Width" => "Page Full Width",
// "100% Page width" => "100% Page width",
// "Page Content Width" => "Page Content Width",
// "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)" => "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)",
// "Page Background Image URL" => "Page Background Image URL",
// "Enter image url, in case of single image" => "Enter image url, in case of single image",
// "Background Repear" => "Background Repear",
// "Cover,Repeat,no-repeat" => "Cover,Repeat,no-repeat",
// "Page Background Sliding Images" => "Page Background Sliding Images",
// "Enter file gallery id for fading background" => "Enter file gallery id for fading background",
// "Page Content Top Margin" => "Page Content Top Margin",
// "Enter value in % or px for example 30%, 300px, default will be 0" => "Enter value in % or px for example 30%, 300px, default will be 0",
// "Page Header Width" => "Page Header Width",
// "Enter page header width in px or %, leave blank for same width as page body.)" => "Enter page header width in px or %, leave blank for same width as page body.)",
// "Page Footer Width" => "Page Footer Width",
// "Enter page footer width in px or %, leave blank for same width as page body.)" => "Enter page footer width in px or %, leave blank for same width as page body.)",
// "Page Background Color" => "Page Background Color",
// "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)" => "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)",
// "Content Background Color" => "Content Background Color",
// "Content Text Color" => "Content Text Color",
// "Enter a valid CSS color code, for example #000,#fff,#ccc" => "Enter a valid CSS color code, for example #000,#fff,#ccc",
// "Content Border Radius" => "Content Border Radius",
// "To make content div round cornered, for example 10px" => "To make content div round cornered, for example 10px",
// "Content Border Shadow" => "Content Border Shadow",
// "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)" => "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)",
// "Transition Delay" => "Transition Delay",
// "Time interval to pause before moving to next slide in seconds" => "Time interval to pause before moving to next slide in seconds",
// "Display Page Action Buttons" => "Display Page Action Buttons",
// "Set to No, to hide page action buttons, with and under content" => "Set to No, to hide page action buttons, with and under content",
// "Display top bar(under header)" => "Display top bar(under header)",
// "Set to No, to hide topbar on the page" => "Set to No, to hide topbar on the page",
// "Display page top bar(above page content)" => "Display page top bar(above page content)",
// "Set to No, to hide page topbar module zone" => "Set to No, to hide page topbar module zone",
// "Display page bottom bar(under page content)" => "Display page bottom bar(under page content)",
// "Set to No, to hide page bottom bar module zone" => "Set to No, to hide page bottom bar module zone",
// "Create a \"Like\" button" => "Create a \"Like\" button",
// "Count only" => "Count only",
// "Sets whether to only show the count of likes rather than give the option to vote" => "Sets whether to only show the count of likes rather than give the option to vote",
// "Search for, list, and filter all types of items and display custom-formatted results" => "Search for, list, and filter all types of items and display custom-formatted results",
// "Use List GUI" => "Use List GUI",
// "Use the graphical user interface for editing this list plugin" => "Use the graphical user interface for editing this list plugin",
// "Cache Output" => "Cache Output",
// "Cache output of this list plugin" => "Cache output of this list plugin",
// "Cache Expiry Time" => "Cache Expiry Time",
// "Time before cache is expired in minutes" => "Time before cache is expired in minutes",
// "Cache Purge Rules" => "Cache Purge Rules",
// "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches" => "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches",
// "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block" => "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block",
// "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine" => "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine",
// "Error: {MULTISEARCH(id=x)} needs an ID to be specified" => "Error: {MULTISEARCH(id=x)} needs an ID to be specified",
// "List Execute" => "List Execute",
// "Set custom actions that can be executed on a filtered list of objects" => "Set custom actions that can be executed on a filtered list of objects",
// "Invalid action: %0" => "Invalid action: %0",
// "There are too many search result items to apply %0 action to" => "There are too many search result items to apply %0 action to",
// "Unknown error executing action %0 on item %1" => "Unknown error executing action %0 on item %1",
// "Error executing action %0 on item %1" => "Error executing action %0 on item %1",
// "Action %0 executed successfully on %1 item(s)" => "Action %0 executed successfully on %1 item(s)",
"List Pages" => "Liste des pages",
"List pages based on various criteria" => "Lister des pages en fonction de critères variés",
"Result number at which the listing should start" => "Numéro du résultat par lequel la liste devrait débuter",
"Limit number of items displayed in the list. Default is to display all" => "Limiter le nombre d'éléments affichés dans la liste. Par défaut : Tout afficher",
"Initial" => "Début de nom",
// "Initial page to show" => "Initial page to show",
"Show Name Only" => "Affiche le nom seulement",
"Show only the page names" => "Afficher seulement les noms de page",
// "Category Filter" => "Category Filter",
// "Filter categories by Id numbers. Use different separators to filter as follows" => "Filter categories by Id numbers. Use different separators to filter as follows",
// "Page is in any of the specified categories. Example" => "Page is in any of the specified categories. Example",
// "Page must be in all of the specified categories. Example" => "Page must be in all of the specified categories. Example",
// "Page is in the first specified category and not in any of the others. Example" => "Page is in the first specified category and not in any of the others. Example",
// "Valid category ID or list separated by :, + or -" => "Valid category ID or list separated by :, + or -",
"Structure Head" => "En-tête de structure",
"Filter by structure head" => "Filtrer par en-tête de structure",
"Show Page Alias" => "Afficher les alias de la page",
"Show page alias in the list" => "Afficher les alias de la page dans la liste",
// "Include Tag" => "Include Tag",
// "Only pages with specific tag (separate tags using %0)" => "Only pages with specific tag (separate tags using %0)",
// "Exclude Tag" => "Exclude Tag",
// "Only pages with specific tag excluded (separate tags using %0)" => "Only pages with specific tag excluded (separate tags using %0)",
// "Show Number of Pages" => "Show Number of Pages",
// "Show the number of pages matching criteria" => "Show the number of pages matching criteria",
"Only pages with names similar to the text entered for this parameter will be listed" => "Seules les pages avec des noms similaires au texte entré pour ce paramètre seront listées",
"Two-letter language code to filter pages listed" => "Code de langue à deux caractères pour filtrer la liste des pages",
"Orphan Language" => "Langue orpheline",
// "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed" => "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed",
"Load Translations" => "Charger les traductions",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter",
"Page name and text entered for the filter parameter must match exactly to be listed" => "Le nom de page et le texte entré en paramètre du filtre doivent correspondre exactement pour que la page soit listée",
"Only Orphan Pages" => "Seules les pages orphelines",
"Only list orphan pages" => "Lister seulement les pages orphelines",
"For List Pages" => "Pour la liste des pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples" => "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples",
// "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start",
// "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end",
"Length" => "Longueur",
"Number of characters to display" => "Nombre de caractères à afficher",
// "Checkboxes" => "Checkboxes",
// "Offset Argument" => "Offset Argument",
"Pagination" => "Pagination",
// "Exclude Page(s)" => "Exclude Page(s)",
// "Wiki page names to be excluded from list" => "Wiki page names to be excluded from list",
// "Local Files" => "Local Files",
// "Show a link to local or shared files and directories" => "Show a link to local or shared files and directories",
// "Local file or directory path" => "Local file or directory path",
"List Directory" => "Lister un répertoire",
// "If the path above is a directory then list the contents" => "If the path above is a directory then list the contents",
// "Show MIME file-type icons" => "Show MIME file-type icons",
// "List files in a directory" => "List files in a directory",
"Full path to the server-local directory. Default is the document root" => "Chemin absolu vers le répertoire du serveur-local. Par défaut c'est la racine du site",
"URL Prefix" => "Préfixe d'URL",
// "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example" => "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example",
"Set the sort order of the file list" => "Fixer l'ordre de tri de la liste des fichiers",
"File Name" => "Nom du fichier",
"File Size" => "Taille de fichier",
"Last Access" => "Dernier accès",
"Last Metadata Change" => "Dernière modification des méta-données",
// "Only list files with file names that contain this filter. Example" => "Only list files with file names that contain this filter. Example",
"Limit" => "Limite",
"Maximum amount of files to display. Default is no limit" => "Nombre maximum de fichiers à afficher. Par défaut : pas de limite",
"could not be opened because it doesn't exist or permission was denied" => "ne peut pas être ouvert parce que n'existe pas ou vous n'avez pas les droits",
"Mail" => "Courriel",
// "Mail other users or groups" => "Mail other users or groups",
"Limit the list of groups to the groups including each group" => "Limiter la liste des groupes à ceux incluant chaque groupe",
// "Group Dropdown" => "Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse Groups" => "Recurse Groups",
// "Show each group and each group included in this group" => "Show each group and each group included in this group",
// "Recurse Group Users" => "Recurse Group Users",
// "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times..." => "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times...",
// "User Dropdown" => "User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Emails" => "User Emails",
// "Show a box for user to enter email addresses" => "Show a box for user to enter email addresses",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "Show in popup instead of inline" => "Show in popup instead of inline",
// "Text to show on the button to send emails (default: %0Send mail%1)" => "Text to show on the button to send emails (default: %0Send mail%1)",
// "Send mail" => "Send mail",
// "Email Subject" => "Email Subject",
// "Present Email subject content" => "Present Email subject content",
// "Bypass Preview" => "Bypass Preview",
// "Send emails without first previewing" => "Send emails without first previewing",
// "Debug mode (admins only)" => "Debug mode (admins only)",
// "Show list of emails that are sent (admins only)" => "Show list of emails that are sent (admins only)",
// "Mail send was unsuccessful" => "Mail send was unsuccessful",
"Map" => "Carte",
"Display a map" => "Afficher une carte",
// "Instructions to load content" => "Instructions to load content",
"Scope" => "Portée",
// "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1" => "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1",
// "Controls" => "Controls",
// "Comma-separated list of map controls will be displayed on the map and around it" => "Comma-separated list of map controls will be displayed on the map and around it",
"Width of the map in pixels" => "Largeur de la carte en pixels",
"Height of the map in pixels" => "Hauteur de la carte en pixels",
// "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1" => "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1",
// "Popup Style" => "Popup Style",
// "Alter the way the information is displayed when objects are loaded on the map" => "Alter the way the information is displayed when objects are loaded on the map",
// "Bubble" => "Bubble",
"MapServer File" => "Fichier MapServer",
"MapServer file identifier. Only fill this in if you are using MapServer" => "Identificateur du fichier MapServer. A renseigner seulement si vous utilisez MapServer",
"Extents" => "Extensions",
"Size of the map" => "Taille de la carte",
// "Show item name in a tooltip on hover" => "Show item name in a tooltip on hover",
// "Open Layers Version" => "Open Layers Version",
// "OL2 or OL3+ so far (default ol2)" => "OL2 or OL3+ so far (default ol2)",
// "OpenLayers 2.x" => "OpenLayers 2.x",
// "Tileset layers" => "Tileset layers",
// "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)" => "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)",
// "Cluster Distance" => "Cluster Distance",
// "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)" => "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)",
// "Cluster Hover Behavior" => "Cluster Hover Behavior",
// "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)" => "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)",
// "Show Features" => "Show Features",
// "Cluster Fill Color" => "Cluster Fill Color",
// "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)" => "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)",
// "Cluster Text Color" => "Cluster Text Color",
// "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)" => "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)",
// "Color Picker" => "Color Picker",
// "Markdown" => "Markdown",
// "Parse the body of the plugin using a Markdown parser" => "Parse the body of the plugin using a Markdown parser",
// "Markdown syntax to be parsed" => "Markdown syntax to be parsed",
"Mayan Calendars" => "Calendriers Mayas",
"Convert a Gregorian date to a Mayan calendar date" => "Convertir une date du calendrier Grégorien en calendrier Maya",
"You must use the variable substitution" => "Vous devez utiliser la variable de substitution",
"LongCount: " => "LongCount : ",
"Tzolkin: " => "Tzolkin : ",
"Haab: " => "Haab : ",
"Misc: " => "Divers : ",
"Example: template " => "Exemple : template ",
// "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
"Default template: " => "Gabarit par défaut : ",
"Gregorian date" => "Date Grégorienne",
// "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date" => "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date",
" is not a valid date format. should be dd.mm.yyyy" => " n'est pas un format valide de date. devrait être jj.mm.aaaa",
"Media Player" => "Lecteur de Médias",
"Add a media player to a page" => "Ajouter un lecteur média à une page",
"Allow full-screen" => "Autoriser le passage en mode plein écran",
"Allow full-screen mode" => "Autoriser le mode plein écran",
"MP3 URL" => "URL du fichier MP3",
"FLV URL" => "URL du flv",
// "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled" => "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled",
// "Player width in px or %" => "Player width in px or %",
// "Player height in px or %" => "Player height in px or %",
// "Set the style" => "Set the style",
"Media Type" => "Type du Media",
// "Media type for HTML5" => "Media type for HTML5",
// "Audio" => "Audio",
// "Video" => "Video",
"Flash Window Mode" => "Mode fenêtre Flash",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: ",
"Transparent" => "Transparent",
"Opaque" => "Opaque",
"Window" => "Fenêtre",
// "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)" => "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)",
// "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)" => "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)",
// "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below" => "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below",
// "Download file" => "Download file",
"Member List" => "Liste des membres",
"List and allow editing of group members" => "Lister et autoriser la modification des membres du groupe",
// "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated" => "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated",
// "Descriptions" => "Descriptions",
"Display group descriptions below list name" => "Afficher les descriptions des groupes en dessous de la liste des noms",
"How to show the member lists" => "Comment afficher les listes de membres",
"Maximum" => "Maximum",
// "Maximum number of users to list in each group (default %0100%1)" => "Maximum number of users to list in each group (default %0100%1)",
"Members Only" => "Réservé aux membres",
// "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user" => "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user",
"Sort mode" => "Mode de tri",
"Sort mode for member listing" => "Mode de tri pour la liste de membres",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
"Required" => "Requis",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
// "Notify Added User" => "Notify Added User",
// "Notify Removed User" => "Notify Removed User",
// "Email notification to removed user" => "Email notification to removed user",
// "Need Approval" => "Need Approval",
// "Add approve/reject user buttons for private addon groups" => "Add approve/reject user buttons for private addon groups",
"Member Payment" => "Paiement d'un membre",
// "Receive payment from a member to extend membership to a group" => "Receive payment from a member to extend membership to a group",
"Name of the group for which the subscription should be added or extended" => "Nom du groupe pour lequel la souscription doit être ajoutée ou étendue",
"Price per period (%0)" => "Prix par période (%0)",
"Current User Member" => "Membre utilisateur actuel",
"Membership only for the current user" => "Adhésion seulement pour l'utilisateur actuel",
"Input Title" => "Titre du formulaire",
// "Title of the initial input form" => "Title of the initial input form",
// "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years" => "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years",
"Supports wiki syntax" => "Supporte la syntaxe wiki",
// "Input Title Only" => "Input Title Only",
// "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well" => "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well",
// "Initial Payment Form Title" => "Initial Payment Form Title",
// "Add a title to the payment form when initially shown after clicking \"Continue\"" => "Add a title to the payment form when initially shown after clicking \"Continue\"",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years",
// "Payment Form Title Only" => "Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well",
// "Subsequent Payment Form Title" => "Subsequent Payment Form Title",
// "Title of the payment form after the initial showing" => "Title of the payment form after the initial showing",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years",
// "Subsequent Payment Form Title Only" => "Subsequent Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well",
// "Prevent Double Request" => "Prevent Double Request",
"Prevent user from extended if there is already a pending request" => "Préserver l'utilisateur d'une extension si une demande est en attente",
// "Free Periods" => "Free Periods",
// "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought",
// "Hide Period" => "Hide Period",
// "Do not allow user to set period - use default of 1" => "Do not allow user to set period - use default of 1",
// "Periods Label" => "Periods Label",
// "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)" => "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)",
// "Page that payment service returns to after processing" => "Page that payment service returns to after processing",
// "Annual, commencing %0 %1 each year" => "Annual, commencing %0 %1 each year",
// "Monthly, commencing on day %0 each month" => "Monthly, commencing on day %0 each month",
"The user " => "L'utilisateur ",
" already has a pending extension request payment invoice " => " a déjà une facture demande de paiement d'extension en attente ",
// "%0 to %1 %2 for %3" => "%0 to %1 %2 for %3",
// "periods" => "periods",
// "period" => "period",
// "Membership to %0 for %1 users for %2 %3" => "Membership to %0 for %1 users for %2 %3",
"The group " => "Le groupe ",
" does not have a membership term" => " n'a pas de durée de l'adhésion",
" Go to " => " Aller à",
"Admin > Groups" => "Administrer > Groupes",
" to specify a term for this group by automatically unassigning users after a certain number of days" => " pour spécifier un terme pour ce groupe en désaffectant automatiquement les utilisateurs après un certain nombre de jours",
" does not exist" => " n'existe pas",
// "MetaTag" => "MetaTag",
// "Add custom meta tags to the HTML head section of the page where the plugin is used" => "Add custom meta tags to the HTML head section of the page where the plugin is used",
// "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here" => "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here",
// "Name attribute of the meta tag" => "Name attribute of the meta tag",
// "Content attribute of the meta tag" => "Content attribute of the meta tag",
"Mini Quiz" => "Mini Quiz",
"Create a quiz using a tracker" => "Crére un questionnaire en utilisant un formulaire",
"Instructions::Feedback" => "Instructions::Compte-rendu",
"Numeric value representing the miniquiz tracker ID" => "Valeur numérique représentant l'ID du formulaire mini-quiz",
"Module" => "Module",
"Display a module" => "Afficher un module",
"Module Name" => "Nom de module",
"Module name as known in Tiki" => "Nom du module tel que connu dans Tiki",
// "Select Yes (%0y%1) to hide the title (default is to show the title)" => "Select Yes (%0y%1) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)" => "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)",
"Align the module to the left or right on the page allowing other elements to align against it" => "Aligner le module à gauche ou à droite de la page en autorisant les autres éléments à s'aligner contre lui",
// "Number of rows (default: %010%1)" => "Number of rows (default: %010%1)",
"Parse" => "Analyser",
"Parse wiki syntax" => "Analyser la syntaxe wiki",
// "Show only the content with no title or borders, etc. around the content" => "Show only the content with no title or borders, etc. around the content",
"Title, background, etc" => "Décoration",
"Show module title (heading) background, etc. (default is to show them)" => "Afficher les décorations de la boîte (affichées par défaut)",
// "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)" => "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)" => "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing div element, for example, %0max-width:80%%1" => "Inline CSS for the containing div element, for example, %0max-width:80%%1",
// "Valid CSS styling" => "Valid CSS styling",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
"Custom CSS class" => "Classe CSS personnalisée",
// "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons",
// "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above",
// "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated" => "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated",
// "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module",
"Please choose a module" => "SVP choisissez un module",
"to be used as argument" => "à être utilisé comme paramètre",
"Sorry, no such module" => "Désolé module inexistant",
// "Module List" => "Module List",
// "Display the modules assigned to a zone" => "Display the modules assigned to a zone",
// "Zone Name" => "Zone Name",
// "The name of the module zone to include. Can be a custom zone name" => "The name of the module zone to include. Can be a custom zone name",
// "Top bar" => "Top bar",
// "Page top" => "Page top",
// "Page bottom" => "Page bottom",
"Monospace" => "Espacement fixe",
"Display text in a monospace font" => "Afficher le texte dans une police à espacement fixe",
// "Text that the font will be applied to" => "Text that the font will be applied to",
"Font name as recognized by browsers" => "Nom de la police telle que connue des navigateurs",
"Mouseover" => "Survol de souris",
// "Display hidden content by mousing over text" => "Display hidden content by mousing over text",
"Hidden content, unless the label parameter is undefined, in which case this is the label" => "Contenu masqué, à moins que le paramètre de label soit non défini, auquel cas c'est le label",
"Text displayed on the page. The body is the hidden content" => "Texte affiché sur la page. Le corps est le contenu masqué",
"Destination link when mouseover text is clicked. Use http:// for external links" => "Lien de destination quand on clique sur le texte affiché au survol de souris. Utilise http:// pour les liens externes",
"DEPRECATED" => "OBSOLETE",
"Hidden content. The body contains the label" => "Contenu caché. Le corps contient l'étiquette",
// "Mouseover box width. Default: %0400px%1" => "Mouseover box width. Default: %0400px%1",
// "Mouseover box height. Default: %0200px%1" => "Mouseover box height. Default: %0200px%1",
"Offset X" => "Décalage X",
// "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1" => "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1",
"Offset Y" => "Décalage Y",
// "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1" => "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1",
"Parse Body" => "Analyser le corps",
"Parse the body of the plugin as wiki content (parsed by default)" => "Analyser le corps du plugiciel comme du contenu wiki (analysé par défaut)",
"Parse Label" => "Analyser l'étiquette",
"Parse the label as wiki content (parsed by default)" => "Analyser le libellé en tant que contenu wiki (analysé par défaut)",
"CSS class to apply" => "Classe CSS à appliquer",
"Background color to apply to the popup" => "Couleur d'arrière-plan à appliquer à la fenêtre popup",
"Text Color" => "Couleur du Texte",
"Color to apply to the text in the popup" => "Couleur à appliquer au texte dans la fenêtre popup",
"Sticky" => "Captivant",
"When enabled, popup stays visible until it is clicked" => "Si activé, la fenêtre popup reste visible jusqu'à ce qu'elle soit cliquée",
"Padding" => "Marge interne",
"Padding size in pixels" => "Marge interne en pixels",
"Effect" => "Effet",
"Set the type of show/hide animation that will be used" => "Définir le type d'animation afficher/cacher qui sera utilisée",
"Effect Speed" => "Vitesse de l'effet",
"Set the speed of the animation" => "Définit la vitesse de l'animation",
"Close Delay" => "Délai de fermeture",
"Number of seconds before popup closes" => "Nombre de secondes avant que la popup se fermer",
// "HTML tag to use for the label. Default %0a%1" => "HTML tag to use for the label. Default %0a%1",
"No label specified" => "Aucune étiquette spécifiée",
"MediaWiki Table" => "Tableau MediaWiki",
// "Display a table using MediaWiki syntax" => "Display a table using MediaWiki syntax",
"Fancy" => "Enjolivé",
// "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter" => "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter",
"True" => "Vrai",
"False" => "Faux",
"Wiki Classes" => "Classes Wiki",
// "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)" => "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)",
"MySpace" => "MySpace",
"Display a MySpace Flash mp3 playlist" => "Afficher une liste d'écoute de mp3 Flash MySpace",
"MySpace Page" => "Page MySpace",
"MySpace page name" => "Nom de la page MySpace",
// "Network condition" => "Network condition",
// "Display content based on the user's IP address" => "Display content based on the user's IP address",
// "Content to display conditionally" => "Content to display conditionally",
// "IPv4 List" => "IPv4 List",
// "Comma-separated list of IPv4 addresses to match against the visitor's address" => "Comma-separated list of IPv4 addresses to match against the visitor's address",
// "Now" => "Now",
// "Show the current date and time" => "Show the current date and time",
// "Time format using the PHP format described here: %0" => "Time format using the PHP format described here: %0",
// "Based site long date and time setting" => "Based site long date and time setting",
// "Date to display" => "Date to display",
// "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0" => "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0",
// "Allow Invalid Dates" => "Allow Invalid Dates",
// "Allow return values that are not a valid date, such as the day of the month" => "Allow return values that are not a valid date, such as the day of the month",
// "Plugin now when parameter not valid. %0" => "Plugin now when parameter not valid. %0",
// "Object Hits" => "Object Hits",
"Display the number of hits for certain objects" => "Afficher le nombre de visites pour certains objets",
// "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title" => "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1" => "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1",
// "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits" => "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits",
// "Since a date" => "Since a date",
// "Date since the hits are collected in a format supported by strtotime" => "Date since the hits are collected in a format supported by strtotime",
// "Display a link to an object" => "Display a link to an object",
// "The object type" => "The object type",
// "The item to display" => "The item to display",
// "Tiki Package View" => "Tiki Package View",
// "Display the output of a Tiki Package View" => "Display the output of a Tiki Package View",
// "Package Name" => "Package Name",
// "Name of package in the form %0vendor/name%1" => "Name of package in the form %0vendor/name%1",
// "Name of the view" => "Name of the view",
// "Name of the view file without the %0.php%1" => "Name of the view file without the %0.php%1",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display the content of a wiki page in a set of tabs" => "Display the content of a wiki page in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent",
// "Parameter" => "Parameter",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met",
// "Names of parameters required to display text, separated by %0|%1" => "Names of parameters required to display text, separated by %0|%1",
// "Source where the parameter is checked" => "Source where the parameter is checked",
// "REQUEST" => "REQUEST",
// "GET" => "GET",
// "POST" => "POST",
// "COOKIE" => "COOKIE",
// "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"" => "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"",
"Show the details of a payment request or invoice." => "Afficher les détails d'une demande de paiement ou facture",
"Payment Request Number" => "Numéro de demande de paiement",
"Unique identifier of the payment request" => "Identifiant unique de la demande de paiement",
// "Payment List" => "Payment List",
// "Show details of payments. The payments considered may be restrained by user or date" => "Show details of payments. The payments considered may be restrained by user or date",
// "Payment type" => "Payment type",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Authorized" => "Authorized",
// "Output format" => "Output format",
"Total" => "Total",
// "JSON (for advanced custom usage)" => "JSON (for advanced custom usage)",
// "Payments by a particular user" => "Payments by a particular user",
// "Payer email" => "Payer email",
// "Date range start, accepts most date formats" => "Date range start, accepts most date formats",
// "Date range end" => "Date range end",
// "Advanced filter" => "Advanced filter",
// "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)" => "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)",
// "List offset" => "List offset",
// "For pagination" => "For pagination",
// "Payments per page" => "Payments per page",
// "Automatic (newest first)" => "Automatic (newest first)",
// "User A to Z" => "User A to Z",
// "User Z to A" => "User Z to A",
// "Amount low to high" => "Amount low to high",
// "Amount high to low" => "Amount high to low",
// "Payment: oldest first" => "Payment: oldest first",
// "Payment: newest first" => "Payment: newest first",
// "Request: oldest first" => "Request: oldest first",
// "Request: newest first" => "Request: newest first",
// "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter" => "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter",
// "Plugin paymentlist: Unrecognised type \"%0\"" => "Plugin paymentlist: Unrecognised type \"%0\"",
// "No payments found" => "No payments found",
// "Payments by anonymous where the payer's email is recorded" => "Payments by anonymous where the payer's email is recorded",
// "PayPal Button" => "PayPal Button",
// "Embed a PayPal button" => "Embed a PayPal button",
// "Type of PayPal button" => "Type of PayPal button",
// "Shopping cart" => "Shopping cart",
// "Buy Now" => "Buy Now",
// "Donations" => "Donations",
// "Cart Action" => "Cart Action",
// "Action if Shopping Cart selected for type" => "Action if Shopping Cart selected for type",
// "Add to Cart" => "Add to Cart",
// "View Cart" => "View Cart",
// "Item Name" => "Item Name",
// "Item name or description. Required for Shopping cart" => "Item name or description. Required for Shopping cart",
// "Item price" => "Item price",
// "Button appearance" => "Button appearance",
"Smaller" => "Plus petit",
"Custom" => "Personnalisé",
// "Custom Button" => "Custom Button",
// "Custom button image URL" => "Custom button image URL",
// "Optional item identifier, often a tracker itemId" => "Optional item identifier, often a tracker itemId",
// "Number of items, empty or 0 to have an input the user can fill in" => "Number of items, empty or 0 to have an input the user can fill in",
// "Shipping Cost" => "Shipping Cost",
// "The cost of shipping this item" => "The cost of shipping this item",
// "Additional Shipping Cost" => "Additional Shipping Cost",
// "The cost of shipping each additional unit of this item" => "The cost of shipping each additional unit of this item",
// "Weight of item" => "Weight of item",
// "Weight Unit" => "Weight Unit",
// "The unit of measure if weight is specified" => "The unit of measure if weight is specified",
// "Kilos" => "Kilos",
// "Pounds" => "Pounds",
// "Business ID" => "Business ID",
// "PayPal business name/ID" => "PayPal business name/ID",
// "(Uses value in admin/payment if not set here)" => "(Uses value in admin/payment if not set here)",
// "Use MiniCart" => "Use MiniCart",
// "See https://github.com/jeffharrell/MiniCart" => "See https://github.com/jeffharrell/MiniCart",
// "Shipping Address Prompt" => "Shipping Address Prompt",
// "Indicate whether to prompt for and require an address" => "Indicate whether to prompt for and require an address",
// "Prompt for address" => "Prompt for address",
// "Do not prompt for address" => "Do not prompt for address",
// "Prompt for and require address" => "Prompt for and require address",
// "Completed payment return URL" => "Completed payment return URL",
// "Empty for current page, %0n%1 to disable" => "Empty for current page, %0n%1 to disable",
// "Continue Shopping URL" => "Continue Shopping URL",
// "Cancel payment URL" => "Cancel payment URL",
// "Form title" => "Form title",
// "Tooltip for the form and alt attribute for the image" => "Tooltip for the form and alt attribute for the image",
// "PayPal — The safer, easier way to pay online" => "PayPal — The safer, easier way to pay online",
// "Button text" => "Button text",
// "The checkout button text" => "The checkout button text",
// "Subtotal text" => "Subtotal text",
// "The subtotal text" => "The subtotal text",
// "Discount text" => "Discount text",
// "The discount text" => "The discount text",
// "Shipping text" => "Shipping text",
// "The shipping text" => "The shipping text",
// "Processing text" => "Processing text",
// "The processing text" => "The processing text",
// "PayPal button" => "PayPal button",
// "Item name (item_name) required" => "Item name (item_name) required",
// "Price (amount) required" => "Price (amount) required",
// "For customized PDF generation, to override global PDF settings" => "For customized PDF generation, to override global PDF settings",
// "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\" => "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\",
// "Generate table of contents" => "Generate table of contents",
// "Set if table of contents will be autogenerated before PDF content" => "Set if table of contents will be autogenerated before PDF content",
// "Link TOC headings with content on PDF document" => "Link TOC headings with content on PDF document",
// "Heading to be appeared before table of content is printed" => "Heading to be appeared before table of content is printed",
// "TOC levels" => "TOC levels",
// "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>" => "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>",
// "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page" => "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page",
// "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page" => "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page",
// "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly" => "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly",
// "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly" => "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly",
// "Generate PDF Bookmarks" => "Generate PDF Bookmarks",
// "Values H1-H6,separated by | <code>For example H1|H2|H3</code>" => "Values H1-H6,separated by | <code>For example H1|H2|H3</code>",
// "Secure confidential PDF with password, leave blank if password protected is not needed" => "Secure confidential PDF with password, leave blank if password protected is not needed",
// "Watermark text value, for example: Confidential, Draft etc. " => "Watermark text value, for example: Confidential, Draft etc. ",
// "Watermark image, enter full URL" => "Watermark image, enter full URL",
// "Full URL of watermark image" => "Full URL of watermark image",
// "Page background color" => "Page background color",
// "Page background image" => "Page background image",
// "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>" => "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>",
// "For pluginPDF, please select mpdf as default PDF engine from Print Settings" => "For pluginPDF, please select mpdf as default PDF engine from Print Settings",
// "Manual bookmark entry for a PDF file" => "Manual bookmark entry for a PDF file",
// "Bookmark Label" => "Bookmark Label",
// "Bookmark level" => "Bookmark level",
// "Insert page with new settings in PDF" => "Insert page with new settings in PDF",
// "Page Content" => "Page Content",
// "PDF page header text" => "PDF page header text",
// "PDF page footer text" => "PDF page footer text",
// "Watermark text for this page. Set value as \"off\", to turn off watermark of the page" => "Watermark text for this page. Set value as \"off\", to turn off watermark of the page",
// "Watermark text value, for example: Confidential, Draft etc" => "Watermark text value, for example: Confidential, Draft etc",
// "Watermark image, enter full url" => "Watermark image, enter full url",
// "To turn off watermark image on the page, set value as <code>off</code>" => "To turn off watermark image on the page, set value as <code>off</code>",
// "PluginPDF Page Break" => "PluginPDF Page Break",
// "Helpful to format PDF files created, plugin adds page break in PDF file generated" => "Helpful to format PDF files created, plugin adds page break in PDF file generated",
"Display content based on permission settings" => "Afficher du contenu en fonction des réglages des droits",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions",
// "Possible Permissions" => "Possible Permissions",
// "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext" => "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show" => "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show",
"Global" => "Global",
// "Indicate whether the permissions are global or local to the object" => "Indicate whether the permissions are global or local to the object",
// "Display content based on the user's current perspective" => "Display content based on the user's current perspective",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition",
"Allowed Perspectives" => "Perspectives autorisées",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown" => "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown",
// "Pivot table" => "Pivot table",
// "Create and display data in pivot table for reporting" => "Create and display data in pivot table for reporting",
// "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on" => "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on",
// "Data source" => "Data source",
// "Override item permissions" => "Override item permissions",
// "Return all tracker items ignoring permissions to view the corresponding items" => "Return all tracker items ignoring permissions to view the corresponding items",
// "Width of pivot table. Units: % or px" => "Width of pivot table. Units: % or px",
// "Height of pivot table. Units: px" => "Height of pivot table. Units: px",
// "Pivot table Rows" => "Pivot table Rows",
// "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. " => "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. ",
// "Use permanentNames in case of tracker fields" => "Use permanentNames in case of tracker fields",
// "Separated by colon (:) if more than one" => "Separated by colon (:) if more than one",
// "Pivot table Columns" => "Pivot table Columns",
// "Which field or fields to use as table columns. Leaving blank will use the first available field" => "Which field or fields to use as table columns. Leaving blank will use the first available field",
// "Values used to decide what heatmapColors to use" => "Values used to decide what heatmapColors to use",
// "Color for each heatmapDomain value" => "Color for each heatmapDomain value",
// "Renderer Name" => "Renderer Name",
// "Display format of data" => "Display format of data",
// "Table Barchart" => "Table Barchart",
// "Heatmap" => "Heatmap",
// "Row Heatmap" => "Row Heatmap",
// "Col Heatmap" => "Col Heatmap",
// "Line Chart" => "Line Chart",
// "Bar Chart" => "Bar Chart",
// "Overlay Bar Chart" => "Overlay Bar Chart",
// "Stacked Bar Chart" => "Stacked Bar Chart",
// "Relative Bar Chart" => "Relative Bar Chart",
// "Boxplot Chart" => "Boxplot Chart",
// "Horizontal Boxplot Chart" => "Horizontal Boxplot Chart",
// "Area Chart" => "Area Chart",
// "Histogram" => "Histogram",
// "Density Histogram" => "Density Histogram",
// "Percent Histogram" => "Percent Histogram",
// "Probability Histogram" => "Probability Histogram",
// "Density Histogram Horizontal" => "Density Histogram Horizontal",
// "Percent Histogram Horizontal" => "Percent Histogram Horizontal",
// "Probability Histogram Horizontal" => "Probability Histogram Horizontal",
// "Horizontal Histogram" => "Horizontal Histogram",
// "Histogram2D" => "Histogram2D",
// "Density Histogram2D" => "Density Histogram2D",
// "Percent Histogram2D" => "Percent Histogram2D",
// "Probability Histogram2D" => "Probability Histogram2D",
// "Density Histogram2D Horizontal" => "Density Histogram2D Horizontal",
// "Percent Histogram2D Horizontal" => "Percent Histogram2D Horizontal",
// "Probability Histogram2D Horizontal" => "Probability Histogram2D Horizontal",
// "Horizontal Histogram2D" => "Horizontal Histogram2D",
// "Scatter Chart" => "Scatter Chart",
// "Treemap" => "Treemap",
// "Aggregator Name" => "Aggregator Name",
// "Function to apply on the numeric values from the variables selected" => "Function to apply on the numeric values from the variables selected",
// "Count Unique Values" => "Count Unique Values",
// "List Unique Values" => "List Unique Values",
// "Sum" => "Sum",
// "Integer Sum" => "Integer Sum",
// "Minimum" => "Minimum",
// "Sum over Sum" => "Sum over Sum",
// "80% Upper Bound" => "80% Upper Bound",
// "80% Lower Bound" => "80% Lower Bound",
// "Sum as Fraction of Total" => "Sum as Fraction of Total",
// "Sum as Fraction of Rows" => "Sum as Fraction of Rows",
// "Sum as Fraction of Columns" => "Sum as Fraction of Columns",
// "Count as Fraction of Total" => "Count as Fraction of Total",
// "Count as Fraction of Rows" => "Count as Fraction of Rows",
// "Count as Fraction of Columns" => "Count as Fraction of Columns",
"Values" => "Valeurs",
// "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts" => "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts",
// "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function" => "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function",
// "Inclusions" => "Inclusions",
// "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings" => "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings",
// "Filter list limit" => "Filter list limit",
// "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row" => "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row",
// "Aggregate details" => "Aggregate details",
// "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string" => "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string",
// "Highlight my items" => "Highlight my items",
// "Highlight owned items' values in Charts" => "Highlight owned items' values in Charts",
// "Highlight my group items" => "Highlight my group items",
// "Highlight items' values belonging to one of my groups in Charts" => "Highlight items' values belonging to one of my groups in Charts",
// "Color for each highlighted group items" => "Color for each highlighted group items",
// "xAxis label" => "xAxis label",
// "Override label of horizontal axis when using Chart renderers" => "Override label of horizontal axis when using Chart renderers",
// "yAxis label" => "yAxis label",
// "Override label of vertical axis when using Chart renderers" => "Override label of vertical axis when using Chart renderers",
// "Chart title" => "Chart title",
// "Override title when using Chart renderers" => "Override title when using Chart renderers",
// "Chart hover bar" => "Chart hover bar",
// "Display the Chart hover bar or not" => "Display the Chart hover bar or not",
// "Translate displayed data" => "Translate displayed data",
// "Use translated data values for calculations and display" => "Use translated data values for calculations and display",
// "Default value: No" => "Default value: No",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>",
// "Missing data parameter with format: source:ID, e.g. tracker:1" => "Missing data parameter with format: source:ID, e.g. tracker:1",
// "Error data parameter" => "Error data parameter",
// "You do not have rights to view tracker data" => "You do not have rights to view tracker data",
// "Unified search index not found" => "Unified search index not found",
// "Split wiki modifier should specify a field" => "Split wiki modifier should specify a field",
// "For example 'tracker:1' or 'activitystream'" => "For example 'tracker:1' or 'activitystream'",
// "Piwik" => "Piwik",
// "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter" => "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter",
// "Piwik server url" => "Piwik server url",
// "The url to your Piwik Server, where data for the report are collected and available" => "The url to your Piwik Server, where data for the report are collected and available",
// "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users" => "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users",
// "The ID of this website in Piwik To be improved" => "The ID of this website in Piwik To be improved",
// "Module and Action To Widgetize" => "Module and Action To Widgetize",
// "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma" => "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma",
// "Actions - Pages" => "Actions - Pages",
// "Actions - Entry pages" => "Actions - Entry pages",
// "Actions - Exit pages" => "Actions - Exit pages",
// "Actions - Outlinks" => "Actions - Outlinks",
// "Dashboard" => "Dashboard",
// "Live - Visitor in real time" => "Live - Visitor in real time",
// "Live - Simple Last Visit Count" => "Live - Simple Last Visit Count",
// "Live - Visitor Profile Popup" => "Live - Visitor Profile Popup",
// "Referrers - All referrers" => "Referrers - All referrers",
// "Referrers - Search engines" => "Referrers - Search engines",
// "Resolution - Screen Resolution" => "Resolution - Screen Resolution",
// "SEO - SEO Ranking (slow)" => "SEO - SEO Ranking (slow)",
// "User Country Map - RealTime Map" => "User Country Map - RealTime Map",
// "User Country Map - Visitor Map" => "User Country Map - Visitor Map",
// "User Country Map - Country" => "User Country Map - Country",
// "User Country Map - Continent" => "User Country Map - Continent",
// "User Language - Language" => "User Language - Language",
// "User Language - Language Code" => "User Language - Language Code",
// "Visits Time - By day of the week" => "Visits Time - By day of the week",
// "Visits Time - Visit Information Per Local Time" => "Visits Time - Visit Information Per Local Time",
// "Visits Time - Visit Information Per Server Time" => "Visits Time - Visit Information Per Server Time",
// "Visits Summary - by day of the week" => "Visits Summary - by day of the week",
// "Visits Summary - over time" => "Visits Summary - over time",
// "Visits Summary - overview with graph" => "Visits Summary - overview with graph",
// "Visitors - Visitor map" => "Visitors - Visitor map",
// "Visitors - Pages per visit" => "Visitors - Pages per visit",
// "Visitors - Frequency overview" => "Visitors - Frequency overview",
// "Visitors - Returning visits over time" => "Visitors - Returning visits over time",
// "Visitor Devices - Device type" => "Visitor Devices - Device type",
// "Visitor Devices - browser" => "Visitor Devices - browser",
// "Visitor Devices - Browser Versions" => "Visitor Devices - Browser Versions",
// "Visitor Devices - OS Families" => "Visitor Devices - OS Families",
// "Visitor Devices - OS Versions" => "Visitor Devices - OS Versions",
// "Visitor Interest - Number Of Visits Per Visit Duration" => "Visitor Interest - Number Of Visits Per Visit Duration",
// "Visitor Interest - Number Of Visits Per Page" => "Visitor Interest - Number Of Visits Per Page",
// "Visitor Interest - Number Of Visits By Visit Count" => "Visitor Interest - Number Of Visits By Visit Count",
// "Visitor Interest - Number Of Visits By Days Since Last" => "Visitor Interest - Number Of Visits By Days Since Last",
// "Visitor Setting - Screen resolution" => "Visitor Setting - Screen resolution",
// "Statistics period" => "Statistics period",
// "Data display duration. If range is selected you must enter the start and end the date" => "Data display duration. If range is selected you must enter the start and end the date",
"Range" => "Plage",
// "Date or Start date" => "Date or Start date",
// "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd" => "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd",
// "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)" => "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)",
// "Module width" => "Module width",
// "Optional, width of the module in px or % (100% by default)" => "Optional, width of the module in px or % (100% by default)",
// "Module height" => "Module height",
// "Optional, height of the module in px" => "Optional, height of the module in px",
// "Iframe Scrolling" => "Iframe Scrolling",
// "Optional, scrolling of the iframe that contain the module (no by default)" => "Optional, scrolling of the iframe that contain the module (no by default)",
// "Piwik javascript code" => "Piwik javascript code",
// "Define option for Piwik groups, include or exclude" => "Define option for Piwik groups, include or exclude",
// "Plugin Piwik error" => "Plugin Piwik error",
// "Piwik server url is required" => "Piwik server url is required",
// "Site Id is required" => "Site Id is required",
// "moduleToWidgetize is required" => "moduleToWidgetize is required",
// "Period set to range but no end date provided" => "Period set to range but no end date provided",
// "PlayScorm" => "PlayScorm",
// "Play a SCORM learning object in an iframe using Moodle" => "Play a SCORM learning object in an iframe using Moodle",
// "Numeric ID of a SCORM zip file in a File Gallery" => "Numeric ID of a SCORM zip file in a File Gallery",
// "Moodle URL" => "Moodle URL",
// "Web address of the Moodle instance" => "Web address of the Moodle instance",
// "Moodle Course ID" => "Moodle Course ID",
// "Course ID in Moodle to upload SCORM objects to" => "Course ID in Moodle to upload SCORM objects to",
// "Frame Width" => "Frame Width",
// "Frame Height" => "Frame Height",
// "Numeric ID" => "Numeric ID",
// "Numeric ID to distinguish multiple plugins of there is more than one" => "Numeric ID to distinguish multiple plugins of there is more than one",
"Either the module or plugin parameter must be set, but not both" => "Le paramètre du module ou du plugiciel doit être réglé, mais pas les deux",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "Options",
"Accepted Values" => "Valeurs acceptées",
"(body of plugin)" => "(corps du plugiciel)",
// "%0separator:%1 " => "%0separator:%1 ",
"(blank)" => "(vide)",
"any string except for HTML and PHP tags" => "n'importe quelle chaîne de caractères sans mots-clés HTML et PHP",
"Since" => "Depuis",
"no parameters" => "pas de paramètres",
"Preferences required" => "Préférences requises",
// "Introduced in %0" => "Introduced in %0",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
"Plugin Manager" => "Gestionnaire des plugiciels",
"List wiki plugin or module information for the site" => "Lister des informations des plugiciels wiki et modules pour le site",
"Information" => "Information",
// "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1" => "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1",
"One or more of: description | parameters | paraminfo" => "Un ou plus de : description | parameters | paraminfo",
"Description and Parameters" => "Description & Paramètres",
"Description & Parameter Info" => "Description & Information du paramètre",
"Parameters & Parameter Info" => "Paramètres & Information du paramètre",
"Plugin" => "Plugiciel",
// "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter" => "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter",
// "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter" => "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter",
"Single Title" => "Titre si unique",
"Set placement of plugin name and description when displaying information for only one plugin" => "Définir l'emplacement du nom et de la description du plugiciel pour l'affiche de l'information pour un seul plugiciel",
"Title Heading" => "Niveau d'en-tête du titre",
// "Sets the heading size for the title, e.g., %0h2%1" => "Sets the heading size for the title, e.g., %0h2%1",
"Start with this plugin record number (must be an integer 1 or greater)" => "Démarrer avec ce numéro d'enregistrement du plugiciel (doit être un entier 1 ou supérieur)",
// "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater",
// "Parameter Type" => "Parameter Type",
// "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions" => "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions",
// "Show Parameter Type" => "Show Parameter Type",
// "Show the parameter %0doctype%1 value" => "Show the parameter %0doctype%1 value",
// "Show Top Info" => "Show Top Info",
// "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default" => "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default",
"Poll" => "Sondage",
// "Embed a poll" => "Embed a poll",
// "Title of the poll" => "Title of the poll",
"Numeric value representing the poll ID" => "Valeur numérique représentant l'ID du sondage",
"Show poll title (shown by default)" => "Afficher le titre du sondage (affiché par défaut)",
"Show result" => "Montrer le résultat",
// "Set how results of the poll will be shown (default is %0link%1)" => "Set how results of the poll will be shown (default is %0link%1)",
// "Voted" => "Voted",
"Show total votes" => "Afficher le total des voix",
// "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)" => "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)",
"Preference" => "Préférence",
// "Display content based on global preference settings" => "Display content based on global preference settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions",
// "Document Preferences" => "Document Preferences",
// "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)" => "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)",
// "Preference-Tab" => "Preference-Tab",
// "The name of the preference tab to display, or a list of available tabs upon invalid" => "The name of the preference tab to display, or a list of available tabs upon invalid",
// "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2" => "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2",
"Pretty Tracker View Tracking" => "Suivi des vues améliorées de formulaire",
"PluginPrettyTrackerViews" => "Plugiciel PrettyTrackerViews",
// "Store tiki.tracker.pretty.views attribute for a trackeritem" => "Store tiki.tracker.pretty.views attribute for a trackeritem",
// "Set to %0y%1 to record view each time this is loaded" => "Set to %0y%1 to record view each time this is loaded",
// "Set to %0n%1 to hide showing of attribute" => "Set to %0n%1 to hide showing of attribute",
"Set to ID of tracker item" => "Définir l'ID d'une fiche de formulaire",
// "Preview Files" => "Preview Files",
// "Enabled to generate preview of images or video files" => "Enabled to generate preview of images or video files",
// "Id of the file in the file gallery" => "Id of the file in the file gallery",
// "Animation" => "Animation",
// "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)" => "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)",
// "Width of the result in pixels" => "Width of the result in pixels",
// "Height of the result in pixels" => "Height of the result in pixels",
// "Show download link to the original file" => "Show download link to the original file",
"Profile Application" => "Application d'un profil",
"Add a button for applying a profile" => "Ajouter un bouton pour appliquer un profil",
// "Profile repository domain. Default value is %0profiles.tiki.org%1" => "Profile repository domain. Default value is %0profiles.tiki.org%1",
"Profile Name" => "Nom du profil",
"Name of the profile to be applied" => "Nom du profil à appliquer",
"Profile plugin only available to administrators" => "Profil plugiciel uniquement accessibles aux administrateurs",
"Profile %0/%1 not found" => "Profil %0/%1 non trouvé",
// "Profile Symbol Value" => "Profile Symbol Value",
// "Display the profile symbol related with profile and a reference and optionally with domain or package" => "Display the profile symbol related with profile and a reference and optionally with domain or package",
// "Reference key" => "Reference key",
// "Reference name" => "Reference name",
// "Package" => "Package",
// "Package extension name" => "Package extension name",
"Proposal" => "Proposition",
"Allow users to vote on a proposal and view the results" => "Permettre aux utilisateurs de voter sur une proposition et de voir les résultats",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "La liste des votes exprimés. Un vote par ligne. Soit 0, +1 or -1 suivi par un nom d'utilisateur",
// "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable" => "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable",
// "Weights" => "Weights",
// "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example" => "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example",
"Accept proposal" => "Accepter la proposition",
"Still undecided" => "Toujours indécis",
"Reject proposal" => "Rejeter la proposition",
"Quote" => "Citation",
"Format text as a quote" => "Formater le texte comme une citation",
"Quoted text" => "Texte cité",
"Reply To" => "Répondre à",
"Name of the quoted person" => "Nom de la personne citée",
// "Thread Id for Forum replies" => "Thread Id for Forum replies",
// "The thread Id of the comment being replied to in forums. Overwrites replyto" => "The thread Id of the comment being replied to in forums. Overwrites replyto",
// "Source URL" => "Source URL",
// "The URL to the source quoted" => "The URL to the source quoted",
// "Date when the statement quoted was made" => "Date when the statement quoted was made",
// "YYYY-MM-DD" => "YYYY-MM-DD",
// "R syntax" => "R syntax",
// "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms" => "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms",
"Random Include" => "Inclure aléatoirement",
"Include a random page's content" => "Inclure le contenu d'une page aléatoirement choisie",
"Random Dynamic Content" => "Contenu dynamique aléatoire",
"Display pre-programmed changing content" => "Affiche un contenu changeant pré-programmé",
"Numeric value representing the content ID" => "Valeur numérique représentant d'ID du contenu",
"User List with Real Names" => "Liste d'utilisateurs avec noms réels",
"Show user real names for members of a group" => "Afficher les noms réels d'utilisateur pour les membres d'un groupe",
// "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
"User Page" => "Page Utilisateur",
"User Preferences" => "Préférences utilisateur",
"Exclude" => "Exclure",
"Exclude certain test or admin names from the list" => "Exclure certains noms de test ou administrateurs de la liste",
"admin" => "administrateur",
"admin-test" => "admin-test",
"test" => "test",
"test-admin" => "test-admin",
"Preferences" => "Préférences",
"Redirect" => "Redirection",
"Redirect to another page." => "Rediriger vers une autre page",
"Wiki page name to redirect to" => "Nom de la page wiki vers laquelle rediriger",
"Complete URL, internal or external" => "Compléter l'URL, interne ou externe",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "Auto login remote Tiki and redirect to page there" => "Auto login remote Tiki and redirect to page there",
// "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com" => "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com",
"perspective " => "perspective ",
"nowhere" => "nulle part",
// "Remote system error" => "Remote system error",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
"Regular Expression" => "Expression régulière",
"Perform a regular expression search and replace" => "Faire des remplacements par expressions régulières",
"Each line of content is evaluated separately" => "Chaque ligne de contenu est évaluée séparément",
// "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page" => "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page",
// "Register Member Payment" => "Register Member Payment",
// "Register and make a member payment at the same time" => "Register and make a member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample" => "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "Soumettre",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Display the relation of an object to the rest of the site" => "Display the relation of an object to the rest of the site",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as %0type:itemId%1" => "Object identifier as %0type:itemId%1",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
// "Empty Message" => "Empty Message",
// "Message to give if result is empty and no relations are found" => "Message to give if result is empty and no relations are found",
"Remarks Box" => "Boîte de remarque",
// "Display a comment, tip, note or warning box" => "Display a comment, tip, note or warning box",
"remarks text" => "Texte des remarques",
"Select type of remarksbox, which determines what icon and style will be displayed" => "Choisir le type de boîte de remarques, lequel détermine l'icône et le style qui seront affichés",
"Confirm" => "Confirmer",
"Tip" => "Conseil",
"Label displayed above the remark" => "Etiquette affichée au dessus des remarques",
"Use the highlight class for formatting (not used by default)" => "Utiliser la classe surlignée pour le formatage (non utilisée apr défaut)",
"Custom Icon" => "Personnaliser l'icône",
"Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)" => "Entrer le nom d'un fichier icône Tiki (avec ou sans extension) ou un chemin pour afficher une icône personnalisée",
"Show a close button (not shown by default)" => "Afficher un bouton de fermeture (non affiché par défaut)",
// "Width (e.g. %0100%%1 or %0250px%1 - default \"\")" => "Width (e.g. %0100%%1 or %0250px%1 - default \"\")",
// "Remember Dismiss" => "Remember Dismiss",
// "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set" => "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set",
// "Sets an HTML id for the account" => "Sets an HTML id for the account",
// "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter" => "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter",
// "RR (R syntax also)" => "RR (R syntax also)",
// "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call" => "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call",
// "R Code" => "R Code",
// "echo" => "echo",
// "Show a code block with the R commands to be run before running them (similarly to the echo command)" => "Show a code block with the R commands to be run before running them (similarly to the echo command)",
// "echo debug" => "echo debug",
// "Show a code block with the R commands to be run even if the R program fails to execute" => "Show a code block with the R commands to be run even if the R program fails to execute",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "wikisyntax" => "wikisyntax",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
"width" => "Largeur",
// "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio" => "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio",
"height" => "Hauteur",
// "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio" => "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio",
// "units" => "units",
// "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm" => "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm",
// "pointsize" => "pointsize",
// "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger" => "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger",
// "bg" => "bg",
// "The initial background colour (optional). Options: white, yellow, grey, ... and transparent" => "The initial background colour (optional). Options: white, yellow, grey, ... and transparent",
// "parse_body" => "parse_body",
// "parses the body content to allow data to be generated from other plugins" => "parses the body content to allow data to be generated from other plugins",
// "res" => "res",
// "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much" => "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much",
// "svg" => "svg",
// "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "pdf" => "pdf",
// "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "onefile" => "onefile",
// "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file" => "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file",
// "LoadAndSave" => "LoadAndSave",
// "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages" => "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages",
// "Caching strategy" => "Caching strategy",
// "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin" => "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin",
// "Limit cache duration" => "Limit cache duration",
// "Force cache recalculation after time limit. Default: No limit" => "Force cache recalculation after time limit. Default: No limit",
// "CacheBy" => "CacheBy",
// "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)" => "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)",
// "Page Name (pagename)" => "Page Name (pagename)",
// "Page Id (pageid)" => "Page Id (pageid)",
// "Cache age" => "Cache age",
// "Display cache last modification date below the graph (default option: do not display)" => "Display cache last modification date below the graph (default option: do not display)",
// "attId" => "attId",
// "AttId from a tracker Item attachment. ex: 1. (Optional)" => "AttId from a tracker Item attachment. ex: 1. (Optional)",
// "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required" => "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required",
// "csv" => "csv",
// "xml" => "xml",
// "x11" => "x11",
// "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()" => "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()",
// "removen" => "removen",
// "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)" => "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)",
// "Custom output" => "Custom output",
// "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file" => "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file",
// "security" => "security",
// "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)" => "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)",
// "Cache was last modified: %0" => "Cache was last modified: %0",
// "One cache per plugin" => "One cache per plugin",
// "One cache per plugin per user" => "One cache per plugin per user",
// "No caching: Ignore and replace existing cache, if any" => "No caching: Ignore and replace existing cache, if any",
// "No limit" => "No limit",
// "1 hour" => "1 hour",
// "1 day" => "1 day",
// "7 days" => "7 days",
// "30 days" => "30 days",
// "365 days" => "365 days",
// "Don't display cache creation date" => "Don't display cache creation date",
// "Display cache creation date" => "Display cache creation date",
// "Blocked commands found: " => "Blocked commands found: ",
// "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you" => "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you",
// "command unavailable" => "command unavailable",
// "The __R__ package needs to be installed on the server" => "The __R__ package needs to be installed on the server",
// "See requirements on [https://doc.tiki.org/PluginR]" => "See requirements on [https://doc.tiki.org/PluginR]",
// "The path to the __R__ command could not be found on your system" => "The path to the __R__ command could not be found on your system",
// "Maybe this file is inaccessible due to safe mode restrictions" => "Maybe this file is inaccessible due to safe mode restrictions",
// "The path to the __convert__ command could not be found on your system" => "The path to the __convert__ command could not be found on your system",
// "You need to ensure that you have __imagemagick__ installed successfully on the server" => "You need to ensure that you have __imagemagick__ installed successfully on the server",
// "Cached R output from %0. If you click, you will re-run all R scripts in this page" => "Cached R output from %0. If you click, you will re-run all R scripts in this page",
// "Save Image as SVG" => "Save Image as SVG",
// "Save Image as PDF" => "Save Image as PDF",
// "plot" => "plot",
"RSS Feed" => "Flux RSS",
// "Display items from one or more RSS feeds" => "Display items from one or more RSS feeds",
"IDs" => "IDs",
// "List of feed IDs separated by colons. ex: %0" => "List of feed IDs separated by colons. ex: %0",
"Result Count" => "Nombre de résultats",
"Number of results displayed." => "Nombre de résultats affichés.",
"Show date of each item (not shown by default)" => "Afficher la date de chaque fiche (non affichée par défaut)",
"Show feed descriptions (not shown by default)" => "Afficher les descriptions de flux (non affichées par défaut)",
"Show authors (not shown by default)" => "Afficher les auteurs (non affichés par défaut)",
"URL to a favicon to put before each entry" => "Url vers une 'favicon' à mettre devant chaque entrée",
"Show the title of the feed (shown by default)" => "Afficher le titre du flux (affiché par défaut)",
// "Ticker" => "Ticker",
// "Turn static feed display into ticker news like" => "Turn static feed display into ticker news like",
// "Description Length" => "Description Length",
// "Max characters/length, truncates text to fit design" => "Max characters/length, truncates text to fit design",
"Scroll" => "Défilement vertical",
"Show animated text that scrolls up or down" => "Afficher un texte animé qui défile vers le haut ou le bas",
// "Width in pixels. Example: %0" => "Width in pixels. Example: %0",
// "Number of pixels followed by \"px\"" => "Number of pixels followed by \"px\"",
// "Height in pixels. Example: %0" => "Height in pixels. Example: %0",
// "Scroll speed in number of seconds (default is %0)" => "Scroll speed in number of seconds (default is %0)",
"SourceForge" => "SourceForge",
"Creates a link to SourceForge tracker items" => "Crée un lien vers les fiches du formulaire SourceForge",
"Group ID" => "ID du groupe",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
"Link title" => "Titre du lien",
// "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)",
"ShareThis" => "ShareThis",
"Add a ShareThis button" => "Ajouter un bouton ShareThis",
"Send Services" => "Services d'envoi",
// "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services" => "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services",
"AIM" => "AIM",
// "AIM and Email" => "AIM and Email",
// "AIM and SMS" => "AIM and SMS",
// "Email and SMS" => "Email and SMS",
"Button Style" => "Style du bouton",
// "Set button style" => "Set button style",
"Rotate Image" => "Alterner l'image",
// "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping" => "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping",
"Multiple Icons" => "Icônes multiples",
// "Enter pipe-separated list of services, e.g., %0" => "Enter pipe-separated list of services, e.g., %0",
"First Services Shown" => "Premiers services affichés",
// "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget",
"Custom link text for the button" => "Texte personnalisé du lien pour le bouton",
"Header Title" => "Titre d'en-tête",
"Optional header title text for the widget" => "Texte du titre d'en-tête optionnel pour le gadget",
"Header Background" => "Arrière-plan de l'en-tête",
// "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used" => "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used",
"Header Text Color" => "Couleur du texte d'en-tête",
"HTML color code (not color name) for the header text if an optional header title is used" => "Code couleur HTML (pas le nom) pour la couleur du texte d'en-tête si un titre d'en-tête optionnel est utilisé",
"Link text color for services" => "Couleur du texte de lien pour les services",
"HTML color code (not color name) for the link text for all send and post services shown in the widget" => "Code couleur HTML (pas le nom) pour le texte du lien pour tous les envois et réceptions montrés dans le gadget",
// "Set whether the widget will show in a popup window" => "Set whether the widget will show in a popup window",
"Embedded Elements" => "Eléments embarqués",
// "Allow embedded elements (like flash) to be seen while iframe is loading" => "Allow embedded elements (like flash) to be seen while iframe is loading",
"Sheet" => "Feuille",
"Display data from a TikiSheet" => "Afficher des données à partir d'une feuille de calcul Tiki",
"Spreadsheet Heading" => "En-tête de feuille",
// "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required" => "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required",
"Sheet Url Location" => "Url de l'emplacement de la feuille",
// "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired" => "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired",
// "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)" => "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1" => "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1",
"Height in pixels or percentage. Default value is complete spreadsheet height" => "Hauteur en pixels ou pourcentage. La valeur par défaut est la hauteur totale de la feuille de calcul",
// "Show edit button. Default is to show depending on user's permissions" => "Show edit button. Default is to show depending on user's permissions",
"Show subsheets" => "Afficher les sous-feuilles",
// "Show multi-sheets (default is to show)" => "Show multi-sheets (default is to show)",
// "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1" => "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1",
"Apply custom CSS class to the containing div" => "Appliquer une classe CSS personnalisée à la div contenant",
"New sheet in page: " => "Nouvelle feuille dans la page : ",
"Create New Sheet" => "Créer une nouvelle feuille",
"Error loading spreadsheet" => "Erreur au chargement de la feuille de calcul",
"Edit Sheet" => "Éditer la feuille de calcul",
"Collect Anonymous Shopper Info" => "Collecter des informations sur l'acheteur anonyme",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect shopper information for the shopping cart" => "Collect shopper information for the shopping cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
"Labels for the values to be collected" => "Etiquettes pour les valeurs à collecter",
// "Labels of the values to be collected separated by a colon" => "Labels of the values to be collected separated by a colon",
"Show even if logged in" => "Afficher même si connecté",
"Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normalement ceci est utilisé pour les utilisateurs anonymes mais peut quelquefois être utilisé pour ceux connectés aussi",
// "Shorten" => "Shorten",
// "Show/hide a portion of text" => "Show/hide a portion of text",
// "Char length of always visible portion of text" => "Char length of always visible portion of text",
// "More text" => "More text",
// "A label indicating the text is expandable" => "A label indicating the text is expandable",
// "Less text" => "Less text",
// "A label for collapse text action" => "A label for collapse text action",
"Show Pages" => "Afficher les Pages",
"Find pages by searching within page names" => "Trouver des pages en cherchant dans les noms de page",
"Search criteria" => "Critère de recherche",
"Maximum amount of results displayed" => "Nombre maximum de résultats affichés",
"Display page name and/or description. Both displayed by default" => "Afficher le nom et/ou la description de la page. Les deux par défaut",
"Name & Description" => "Nom et Description",
// "Show Preference" => "Show Preference",
// "Display the value of public global preferences" => "Display the value of public global preferences",
// "Name of preference to be displayed" => "Name of preference to be displayed",
// "Add Bibliography" => "Add Bibliography",
// "Add bibliography listing in the footer of a wiki page" => "Add bibliography listing in the footer of a wiki page",
// "Title to be displayed in the bibliography listing. Default is %0Bibliography%1" => "Title to be displayed in the bibliography listing. Default is %0Bibliography%1",
// "Show bibliography title. Title is shown by default" => "Show bibliography title. Title is shown by default",
// "Header Tag" => "Header Tag",
// "The HTML header tag level of the title. Default: %01%1" => "The HTML header tag level of the title. Default: %01%1",
// "Remove the lines around the list of references" => "Remove the lines around the list of references",
// "Remove the horizontal lines displayed above and below the list of references" => "Remove the horizontal lines displayed above and below the list of references",
// "Page identifier" => "Page identifier",
// "Provide the page id" => "Provide the page id",
// "Bibliography" => "Bibliography",
"Signature" => "Signature",
// "Sign and date your contribution to a page" => "Sign and date your contribution to a page",
// "Auto-generated, the username" => "Auto-generated, the username",
// "Date and time" => "Date and time",
// "Auto-generated, the timestamp" => "Auto-generated, the timestamp",
"Skype" => "Skype",
// "Add a link for calling or chating with a Skype user" => "Add a link for calling or chating with a Skype user",
"Name or number to call or chat with" => "Nom ou numéro pour appeler ou discuter",
"Set whether to call or chat. Default is chat" => "Régler soir appeler ou chatter. Chatter par défaut",
"Call" => "Appel",
"Chat" => "Clavardage",
"Show status" => "Voir les statuts",
// "Show a status icon or not i.e. if online/offline/etc. Default is to not show status" => "Show a status icon or not i.e. if online/offline/etc. Default is to not show status",
"yes" => "oui",
// "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web" => "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web",
"click to" => "Cliquer pour",
// "Slider" => "Slider",
// "Embed a mini-slideshow of content on a page" => "Embed a mini-slideshow of content on a page",
"Content separated by \"/////\"" => "Contenu séparé par /////",
"Slider Titles" => "Titres du glisseur",
// "Pipe-separated list of slider titles. Example" => "Pipe-separated list of slider titles. Example",
// "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels" => "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels",
"The theme to use in slider" => "Le thème à utiliser dans le glisseur",
"Expand" => "Augmenter",
// "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set" => "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set",
// "Resize" => "Resize",
// "Set whether solitary images/objects in the panel will be expanded to fit the viewport" => "Set whether solitary images/objects in the panel will be expanded to fit the viewport",
"Show Multiple" => "Afficher plusieurs",
"Set this value to a number and it will show that many slides at once" => "Définir cette valeur à un nombre et il affichera autant de diapositives à la fois",
// "Arrows" => "Arrows",
// "Set whether to show forward and backward buttons" => "Set whether to show forward and backward buttons",
"Navigation" => "Navigation",
// "Set whether to show a list of anchor links to link to each panel" => "Set whether to show a list of anchor links to link to each panel",
// "Start / Stop" => "Start / Stop",
// "Set whether to show a start/stop button and add slideshow functionality" => "Set whether to show a start/stop button and add slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "Set whether side navigation arrows slide out on hovering and hide at other times" => "Set whether side navigation arrows slide out on hovering and hide at other times",
// "Toggle Controls" => "Toggle Controls",
// "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times" => "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times",
"Enable Arrows" => "Activer les flèches",
// "Set whether arrows are clickable" => "Set whether arrows are clickable",
"Enable Navigation" => "Activer la navigation",
// "Set whether navigation links are clickable" => "Set whether navigation links are clickable",
"Enable Start Stop" => "Activer 'Démarrer' 'Arrêter'",
// "Set whether the play/stop button is clickable. Previously %0" => "Set whether the play/stop button is clickable. Previously %0",
"Enable Keyboard" => "Activer le clavier",
// "Set whether keyboard arrow keys will work for this slider" => "Set whether keyboard arrow keys will work for this slider",
"Auto Play" => "Lecture auto",
// "Set whether the slideshow will start running automatically; replaces %0 option" => "Set whether the slideshow will start running automatically; replaces %0 option",
"Auto Play Locked" => "Lecture auto verrouillée",
// "Keep playing the slideshow even if the user changes slides" => "Keep playing the slideshow even if the user changes slides",
"Auto Play Delayed" => "Lecture automatique retardée",
// "Set whether there will be a delay in advancing slides" => "Set whether there will be a delay in advancing slides",
// "Pause On Hover" => "Pause On Hover",
// "Set whether the slideshow will pause on hover while the slideshow is active" => "Set whether the slideshow will pause on hover while the slideshow is active",
"Stop At End" => "Arrêter à la fin",
// "Set whether the slideshow stops on the last page" => "Set whether the slideshow stops on the last page",
// "Delay between slides" => "Delay between slides",
// "Time in milliseconds between slideshow transitions (in AutoPlay mode)" => "Time in milliseconds between slideshow transitions (in AutoPlay mode)",
// "Right To Left" => "Right To Left",
// "Set whether the slideshow moves right-to-left" => "Set whether the slideshow moves right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "Set whether auto play stops until the video is complete (for supported video types)" => "Set whether auto play stops until the video is complete (for supported video types)",
// "Animation Time" => "Animation Time",
// "Milliseconds between slides" => "Milliseconds between slides",
// "Panel Hashtags" => "Panel Hashtags",
// "Set whether to include a hashtag in the page URL, allowing links to specific panels" => "Set whether to include a hashtag in the page URL, allowing links to specific panels",
// "Create a slideshow from the content of a wiki page" => "Create a slideshow from the content of a wiki page",
// "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI",
// "Parallax Background Image" => "Parallax Background Image",
// "URL of the background image to use in your slideshow, overrides %0" => "URL of the background image to use in your slideshow, overrides %0",
// "Valid URL" => "Valid URL",
// "Parallax Background Size" => "Parallax Background Size",
// "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)" => "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)",
// "Parallax Background Horizontal" => "Parallax Background Horizontal",
// "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis" => "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis",
// "Parallax Background Vertical" => "Parallax Background Vertical",
// "Transition" => "Transition",
// " Transition style" => " Transition style",
// "Transition Speed" => "Transition Speed",
// "Background Transition" => "Background Transition",
// "Transition style for full page slide backgrounds" => "Transition style for full page slide backgrounds",
// "Display presentation control arrows" => "Display presentation control arrows",
// "Controls Layout" => "Controls Layout",
// "Determines where controls appear, \"edges\" or \"bottom-right\"" => "Determines where controls appear, \"edges\" or \"bottom-right\"",
// "Controls Back Arrows" => "Controls Back Arrows",
// "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"" => "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"",
// "Progress" => "Progress",
// "Display a presentation progress bar" => "Display a presentation progress bar",
// "Slide Number" => "Slide Number",
// "Display the page number of the current slide" => "Display the page number of the current slide",
// "Fragments" => "Fragments",
// "Turns fragments on and off globally" => "Turns fragments on and off globally",
// "Fragment Effects" => "Fragment Effects",
// "Fragment Highlight Color" => "Fragment Highlight Color",
// "Auto Slide" => "Auto Slide",
// "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides" => "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides",
// "Auto Slide Stoppable" => "Auto Slide Stoppable",
// "Stop auto-sliding after user input" => "Stop auto-sliding after user input",
// "Auto-align Images" => "Auto-align Images",
// "Automatically move images to left hand side of slide text, will only align images greater than 200px in width" => "Automatically move images to left hand side of slide text, will only align images greater than 200px in width",
// "Start Slideshow Presentation" => "Start Slideshow Presentation",
// "SlideshowSlide" => "SlideshowSlide",
// "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings" => "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings",
// "Enter content of slide" => "Enter content of slide",
// "Slide Background color" => "Slide Background color",
// "Set background color for slide" => "Set background color for slide",
// "Slide Text color" => "Slide Text color",
// "Set Text color for slide" => "Set Text color for slide",
// "Background Video URL" => "Background Video URL",
// "Automatically plays a full size video behind the slide" => "Automatically plays a full size video behind the slide",
// "Mute Background Video" => "Mute Background Video",
// "Flags if the audio should be muted for background video" => "Flags if the audio should be muted for background video",
// "Loop Background Video" => "Loop Background Video",
// "Flags if the background video played in loop" => "Flags if the background video played in loop",
// "Transition In" => "Transition In",
// "Select entry transition effect for slide" => "Select entry transition effect for slide",
// "Transition Out" => "Transition Out",
// "Select exit transition effect for slide" => "Select exit transition effect for slide",
"Smarty function" => "Fonction Smarty",
// "Insert a Smarty function or variable" => "Insert a Smarty function or variable",
// "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1" => "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1",
"Snarf" => "Incrustation",
"Display the contents of another web page" => "Afficher le contenu d'une autre page Web",
"Full URL to the page to include" => "Adresse URL complète de l'image à inclure",
"Regular Expression Pattern" => "Expression régulière (Modèle)",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
"Regular Expression Replacement" => "Expression régulière de remplacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets (Plugin Code is used for this)" => "Syntax highlighting to use for code snippets (Plugin Code is used for this)",
// "Set to Yes (%0) to add line numbers to code snippets (not shown by default)" => "Set to Yes (%0) to add line numbers to code snippets (not shown by default)",
"Parse wiki syntax within the code snippet (not parsed by default)" => "Analyser la syntaxe wiki dans l'extrait de code (non analysé par défaut)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
"HTML Content" => "Contenu HTML",
// "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)" => "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)",
// "Cache URL" => "Cache URL",
// "Cache time in minutes. Default is to use site preference, Set to %0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to %0 for no cache",
// "Text to click on to fetch the URL via Ajax" => "Text to click on to fetch the URL via Ajax",
"Sort lines of text" => "Trier des lignes de texte",
"Data to sort, one entry per line" => "Données à trier, une entrée par ligne",
"Order" => "Ordre",
"Set the sort order of lines of content (default is ascending)" => "Fixer l'ordre de tri des lignes de contenu (par défaut : ordre croissant)",
"Reverse" => "Inverse",
"Shuffle" => "Aléatoire",
// "Arrange content on a page into rows and columns" => "Arrange content on a page into rows and columns",
// "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Generate the colspan attribute if columns are missing" => "Généret l'attribut 'colspan' si des colonnes sont manquantes",
"Fixed Size" => "Taille Fixe",
"Generate the width attribute for the columns" => "Générer l'attribut largeur pour les colonnes",
// "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)" => "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)",
// "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns",
// "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1" => "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1",
"SQL" => "SQL",
"Query a MySQL database and display the results" => "Requêter une base de données MySQL et afficher les résultats",
// "The SQL query goes in the body. Example: " => "The SQL query goes in the body. Example: ",
"DSN Name" => "Nom DSN",
// "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0" => "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0",
// "Raw return" => "Raw return",
// "Return with table formatting (default) or raw data with no table formatting" => "Return with table formatting (default) or raw data with no table formatting",
// "Raw" => "Raw",
// "Delim" => "Delim",
// "The delimiter to be used between data elements (sets %0)" => "The delimiter to be used between data elements (sets %0)",
// "Turn wiki parsing of select results on and off (default is on)" => "Turn wiki parsing of select results on and off (default is on)",
"Missing db param" => "Le paramètre db manque",
"Could not obtain valid DSN connection" => "Ne peut obtenir une connection DSN valide",
"Stat" => "Stat.",
"Show various statistics for an object" => "Afficher des statistiques diverses pour un objet",
// "Colon-separated list of object type to show stats for" => "Colon-separated list of object type to show stats for",
"Article & Tracker Item" => "Article & Fiche de formulaire",
"Article & Tracker Item & Wiki" => "Article & Fiche de formulaire & Wiki",
"Article & Wiki" => "Article & Wiki",
"Article & Wiki & Tracker Item" => "Article & Wiki & Fiche de formulaire",
"Tracker Item & Article" => "Fiche de formulaire & Article",
"Tracker Item & Article & Wiki" => "Fiche de formulaire & Article & Wiki",
"Tracker Item & Wiki" => "Fiche de formulaire & Wiki",
"Tracker Item & Wiki & Article" => "Fiche de formulaire & Wiki & Article",
"Wiki & Article" => "Wiki & Article",
"Wiki & Article & Tracker Item" => "Wiki & Article & Fiche de formulaire",
"Wiki & Tracker Item" => "Wiki & Fiche de formulaire",
"Wiki & Tracker Item & Article" => "Wiki & Fiche de formulaire & Article",
"Parent ID" => "ID du Parent",
"Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Entrer une ID de formulaire pour restreindre les statistiques à ce formulaire (pour usage avec fiches de formulaire seulement)",
"Last 24 Hours" => "Dernières 24 heures",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"" => "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"",
"Added" => "Ajouté",
"Added and Viewed" => "Ajouté et Vu",
"Viewed" => "Vu",
"Viewed & Added" => "Vu & Ajouté",
// "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last 7 Days" => "7 derniers jours",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Week" => "Cette semaine",
// "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Month" => "Le mois dernier",
// "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Month" => "Ce Mois",
// "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Year" => "L'année dernière",
// "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Year" => "Cette année",
// "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Incorrect parameter: " => "Paramètre incorrect : ",
"Subscript" => "Souscrit",
"Apply subscript font to text" => "Appliquer une police indice au texte",
"Subscribe Group" => "Inscrire un groupe",
"Allow users to subscribe to a group" => "Autoriser les utilisateurs à s'inscrire à un groupe",
"text displayed before the button" => "texte affiché avant le bouton",
"Group name to subscribe to or unsubscribe from" => "Nom du groupe pour s'y inscire ou désinscrire",
"Subscribe Text" => "Texte d'inscription",
// "Subscribe text, containing %0 as the placeholder for the group name" => "Subscribe text, containing %0 as the placeholder for the group name",
"Subscribe" => "S'abonner",
"Unsubscribe Text" => "Texte de désinscription",
// "Unsubscribe text, containing %0 as the placeholder for the group name" => "Unsubscribe text, containing %0 as the placeholder for the group name",
"Unsubscribe" => "Se désabonner",
"Subscribe Action" => "Action d'inscription",
// "Subscribe button label, containing %0 as the placeholder for the group name" => "Subscribe button label, containing %0 as the placeholder for the group name",
"Unsubscribe Action" => "Action de désinscription",
// "Unsubscribe button label, containing %0 as the placeholder for the group name" => "Unsubscribe button label, containing %0 as the placeholder for the group name",
"Post-subscribe URL" => "URL post-inscription",
"URL to send the user to after subscribing, if required" => "URL vers laquelle envoyer l'utilisateur après son inscription, si nécessaire",
"Post-unsubscribe URL" => "URL post-désincription",
"URL to send the user to after unsubscribing, if required" => "URL vers laquelle envoyer l'utilisateur après sa désinscription, si nécessaire",
// "Make this the default group text, containing %0 as the placeholder for the group name" => "Make this the default group text, containing %0 as the placeholder for the group name",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %0 as the placeholder for the group name" => "Stop this being default group text, containing %0 as the placeholder for the group name",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Second Default" => "Second Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Redirect to new home page after default group change. (default is to redirect)" => "Redirect to new home page after default group change. (default is to redirect)",
// "Can Always Leave" => "Can Always Leave",
// "Always allow leaving a group even if the group settings do not allow user choice" => "Always allow leaving a group even if the group settings do not allow user choice",
"Subscribe Groups" => "S'inscrire à des groupes",
"Allow users to subscribe to a list of groups" => "Autoriser les utilisateurs à s'inscrire à une liste de groupes",
// "Text shown in the dropdown box. Default: %0Subscribe to a group%1" => "Text shown in the dropdown box. Default: %0Subscribe to a group%1",
"Show Subscribe Box" => "Afficher la boîte d'inscription",
// "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box" => "Style to show the subscribe box",
"Show Default" => "Afficher le groupe par défaut",
// "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group" => "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group",
"Group Description" => "Description du groupe",
"Show the description of the group (not shown by default)" => "Afficher la description du groupe (non affichée par défaut)",
"Colon-separated list of groups. By default the list of groups available to the user" => "Liste de groupes séparés par ':'. Par défaut, la liste des groupes accessibles à l'utilisateur",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
"Default URL" => "URL par défaut",
"Page user will be directed to after clicking on icon to change default group" => "Page vers laquelle l'utilisateur sera dirigé après avoir cliqué sur l'icône pour changer le groupe par défaut",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name" => "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name" => "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
"Always allow leaving group" => "Toujours permettre de quitter un groupe",
// "Always allow leaving group even if the group settings do not allow user choice" => "Always allow leaving group even if the group settings do not allow user choice",
"You do not have permission to subscribe to groups" => "Vous n'avez pas les droits pour vous inscrire à des groupes",
"Subscribe to newsletter" => "S'inscrire à la lettre de nouvelles",
"Allow users to subscribe to a newsletter" => "Autoriser les utilisateurs à s'inscrire à une lettre de nouvelles",
"Invitation message" => "Message d'invitation",
"Newsletter ID" => "ID de la lettre de nouvelles",
// "Identification number of the Newsletter that you want to allow the users to subscribe to" => "Identification number of the Newsletter that you want to allow the users to subscribe to",
"Confirmation Message" => "Message de Confirmation",
"Confirmation message after posting form. The plugin body is then the button label" => "Message de confirmation après le formulaire de publication. Le corps du plugiciel est ensuite l'étiquette du bouton",
"Button label. The plugin body is then the confirmation message" => "Label de bouton. Le corps du plugiciel est alors le message de confirmation",
// "Choose whether the output should be parsed as wiki syntax" => "Choose whether the output should be parsed as wiki syntax",
// "In Module" => "In Module",
// "Display the newsletter subscription form in module view (if included in a Tiki module)" => "Display the newsletter subscription form in module view (if included in a Tiki module)",
"Already subscribed" => "Déjà inscrit",
"Superscript" => "Exposant",
"Apply superscript font to text" => "Appliquer une police exposant au texte",
// "Embed a survey" => "Embed a survey",
// "Id of the survey set up by the administrator" => "Id of the survey set up by the administrator",
"Wiki Page to redirect the user after his vote" => "Page Wiki vers laquelle rediriger l'utilisateur après son vote",
// "Language for the survey" => "Language for the survey",
// "Swiper" => "Swiper",
// "Embed swiper in content, support file galleries, files id and custom content" => "Embed swiper in content, support file galleries, files id and custom content",
// "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> " => "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> ",
// "Enter file gallery id for slider" => "Enter file gallery id for slider",
// "Transition Effect" => "Transition Effect",
// "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"" => "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"",
// "Slider Placement on Page" => "Slider Placement on Page",
// "Placement of slider, above topbar, below topbar, above menus and content or inside content" => "Placement of slider, above topbar, below topbar, above menus and content or inside content",
// "Inside Content" => "Inside Content",
// "Above top bar / Top of page" => "Above top bar / Top of page",
// "Above Content/Under top bar" => "Above Content/Under top bar",
// "Slider pagination, default bullets" => "Slider pagination, default bullets",
// "Fraction" => "Fraction",
// "Progress bar" => "Progress bar",
// "Display navigation arrows" => "Display navigation arrows",
// "Slider Background Color" => "Slider Background Color",
// "Slider background color, enter color code for example #000" => "Slider background color, enter color code for example #000",
// "Slider Parallax Background Image" => "Slider Parallax Background Image",
// "Enter image url for parallax background behind swiper" => "Enter image url for parallax background behind swiper",
// "Enter width of slider in px, default 100%" => "Enter width of slider in px, default 100%",
// "Enter height of slider in px, default min height 100px, max height will adjust with content" => "Enter height of slider in px, default min height 100px, max height will adjust with content",
// "Slide title color" => "Slide title color",
// "Enter text color code of slide title, for example #ccc" => "Enter text color code of slide title, for example #ccc",
// "Title font size" => "Title font size",
// "For example 42px, default 32 px" => "For example 42px, default 32 px",
// "Slide description color" => "Slide description color",
// "Enter text color code of slide description, for example #ccc" => "Enter text color code of slide description, for example #ccc",
// "Description font size" => "Description font size",
// "For example 24px, default 16 px" => "For example 24px, default 16 px",
// "Slide content background" => "Slide content background",
// "Slide content position" => "Slide content position",
// "Enter position for example top:20%;left:20% or bottom:20%;right:10%" => "Enter position for example top:20%;left:20% or bottom:20%;right:10%",
// "Autoplay slider, on by default" => "Autoplay slider, on by default",
// "Auto Play Delay" => "Auto Play Delay",
// "Show thumbnails under main slider" => "Show thumbnails under main slider",
// "Duration of transition between slides (in seconds)" => "Duration of transition between slides (in seconds)",
// "Auto Height" => "Auto Height",
// "Set to true and slider wrapper will adopt its height to the height of the currently active slide" => "Set to true and slider wrapper will adopt its height to the height of the currently active slide",
// "Space Between" => "Space Between",
// "Distance between slides in px" => "Distance between slides in px",
// "Slides Per View" => "Slides Per View",
// "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view" => "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view",
// "Slides Per View Mobile Screen" => "Slides Per View Mobile Screen",
// "Slides visible at the same time on small screens" => "Slides visible at the same time on small screens",
// "Slides Per View Tablet" => "Slides Per View Tablet",
// "Slides visible at the same time on low resolution tablets" => "Slides visible at the same time on low resolution tablets",
// "Slides Per Column" => "Slides Per Column",
// "Number of slides per column, for multirow layout" => "Number of slides per column, for multirow layout",
// "Slides Per Column Fill" => "Slides Per Column Fill",
// "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row" => "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row",
// "Centered Slides" => "Centered Slides",
// "If true, then active slide will be centered, not always on the left side" => "If true, then active slide will be centered, not always on the left side",
// "Slides Offset Before" => "Slides Offset Before",
// "Add (in px) additional slide offset in the beginning of the container (before all slides)" => "Add (in px) additional slide offset in the beginning of the container (before all slides)",
// "Slides Offset After" => "Slides Offset After",
// "Add (in px) additional slide offset in the end of the container (after all slides)" => "Add (in px) additional slide offset in the end of the container (after all slides)",
// "Slide To Clicked Slide" => "Slide To Clicked Slide",
// "Set to true and click on any slide will produce transition to this slide" => "Set to true and click on any slide will produce transition to this slide",
// "Free Mode" => "Free Mode",
// "If true then slides will not have fixed positions" => "If true then slides will not have fixed positions",
// "Preload Images" => "Preload Images",
// "When enabled Swiper will force to load all images" => "When enabled Swiper will force to load all images",
// "Update On Images Ready" => "Update On Images Ready",
// "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true" => "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true",
// "Loop Slider" => "Loop Slider",
// "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))" => "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))",
// " Please update composer to install required files" => " Please update composer to install required files",
// "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body" => "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body",
"Arrange content in tabs" => "Disposer un contenu en onglets",
"Tabs content, separated by \"/////\"" => "Contenu des onglets séparés par /////",
"Tabset Name" => "Nom du jeu d'onglets",
// "Unique tabset name (if you want the last state to be remembered). Example" => "Unique tabset name (if you want the last state to be remembered). Example",
"Tab Titles" => "Titres d'onglet",
// "Pipe-separated list of tab titles. Example" => "Pipe-separated list of tab titles. Example",
// "Toggle Tabs" => "Toggle Tabs",
"Allow toggling between tabs and no-tabs view" => "Permet de basculer de l'affichage avec onglets/sans onglets",
// "Inside Pretty Tracker" => "Inside Pretty Tracker",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
"No tab title specified. At least one must be specified in order for the tabs to appear" => "Aucun titre d'onglet n'est spécifié. Il en faut un pour que les onglets apparaissent",
"Apply an HTML tag to content" => "Appliquer une balise HTML au contenu",
"Tag Name" => "Nom de la balise",
// "Any valid HTML tag, 0% by default" => "Any valid HTML tag, 0% by default",
"Equivalent to the style attribute of an HTML tag" => "Equivaut à la balise de style HTML",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)" => "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)",
// "Width of the timeline as CSS units (default: %0)" => "Width of the timeline as CSS units (default: %0)",
// "Height of the timeline as CSS units (default: %0)" => "Height of the timeline as CSS units (default: %0)",
"Primary Scale Unit" => "Unité d'échelle primaire",
// "Unit of time to use for the primary scale (default is Month)" => "Unit of time to use for the primary scale (default is Month)",
"Decade" => "Décade",
"Century" => "Siècle",
"Secondary Scale Unit" => "Unité d'échelle secondaire",
// "Unit of time to use for the secondary scale" => "Unit of time to use for the secondary scale",
"TimeSheet" => "Feuille de temps",
// "Embed a timesheet into a page" => "Embed a timesheet into a page",
"Title Search" => "Recherche par titre",
// "Search page titles" => "Search page titles",
"Search Criteria" => "Critère de recherche",
"Portion of a page name" => "Partie d'un nom de page",
"Also show page hits or user" => "Montrer aussi les scores de la page ou l'utilisateur",
// "Hits and user" => "Hits and user",
// "User and hits" => "User and hits",
"Pipe-separated list of page names to exclude from results" => "Liste séparée par '|' des noms de page à exclure des résultats",
"No Header" => "Pas d'en-tête",
// "Set to Yes (%0) to have no header for the search results" => "Set to Yes (%0) to have no header for the search results",
"No pages found for title search" => "Aucune page trouvée avec la recherche par titre",
"One page found for title search" => "Une page trouvée avec la recherche par titre",
"pages found for title search" => "pages trouvées avec la recherche par titre",
"Table of Contents (Structure)" => "Table des matières (Structure)",
// "Display a table of contents of pages in a structure" => "Display a table of contents of pages in a structure",
"Structure ID" => "ID de la structure",
// "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided" => "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided",
// "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided" => "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided",
"Order items in ascending or descending order (default is ascending)" => "Ordonner les fiches en ordre croissant ou décroissant (croissant par défaut)",
// "Sort Order" => "Sort Order",
// "Order for the first Level of pages that will be displayed. Order by structure is the default" => "Order for the first Level of pages that will be displayed. Order by structure is the default",
// "Structure Order" => "Structure Order",
// "Alphabetic Order" => "Alphabetic Order",
// "Display the page description in front of the page name" => "Display the page description in front of the page name",
"Show Numbering" => "Afficher la numérotation",
"Display the section numbers or not" => "Afficher les numéros de section ou pas",
"Style to apply" => "Style à appliquer",
"Admin" => "Administrer",
// "Start Level" => "Start Level",
// "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)" => "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)",
// "Maximum Level Depth" => "Maximum Level Depth",
// "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)" => "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)",
// "Together" => "Together",
// "Collaborate in real time" => "Collaborate in real time",
// "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience" => "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience",
// "Button Name" => "Button Name",
// "Set the button name. Default is CoWrite with TogetherJS" => "Set the button name. Default is CoWrite with TogetherJS",
// "CoWrite with TogetherJS" => "CoWrite with TogetherJS",
// "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time" => "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time",
// "Tour" => "Tour",
// "Quick and easy way to build your product tours with Bootstrap popovers" => "Quick and easy way to build your product tours with Bootstrap popovers",
// "Content of the step" => "Content of the step",
// "Element" => "Element",
// "Element to show the popup on; if empty, use the plugin location itself" => "Element to show the popup on; if empty, use the plugin location itself",
// "Title of the step" => "Title of the step",
// "Index of the step to show after this one, starting from 0, -1 for the last one" => "Index of the step to show after this one, starting from 0, -1 for the last one",
// "Index of the step to show before this one, starting from 0, -1 not to show" => "Index of the step to show before this one, starting from 0, -1 not to show",
// "Path to the page on which the step should be shown" => "Path to the page on which the step should be shown",
// "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below" => "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below",
// "Placement" => "Placement",
// "The placement of the popup" => "The placement of the popup",
// "Orphan" => "Orphan",
// "Setting to true removes the pointer on the popup and centers it on the page" => "Setting to true removes the pointer on the popup and centers it on the page",
// "Backdrop" => "Backdrop",
// "Show a dark backdrop behind the popover and its element, highlighting the current step" => "Show a dark backdrop behind the popover and its element, highlighting the current step",
// "Only Show Once" => "Only Show Once",
// "Show automatically only once. tour_id should also be set if there are multiple tours" => "Show automatically only once. tour_id should also be set if there are multiple tours",
// "Show Until Dismissed" => "Show Until Dismissed",
// "Show automatically only until dismissed. tour_id should also be set if there are multiple tours" => "Show automatically only until dismissed. tour_id should also be set if there are multiple tours",
// "Tour ID" => "Tour ID",
// "Set a tour ID to be able to only show the tour once" => "Set a tour ID to be able to only show the tour once",
// "Restart Button" => "Restart Button",
// "Display a button to restart the tour. Enter the text to appear on the button" => "Display a button to restart the tour. Enter the text to appear on the button",
"Translate" => "Traduire",
"Translate text to the user language" => "Traduire le texte dans la langue de l'utilisateur",
// "Embed a form to populate a tracker" => "Embed a form to populate a tracker",
"Numeric value representing the tracker ID" => "Valeur numérique représentant l'ID du formulaire",
"Fields" => "Champs",
// "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0" => "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0",
// "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters" => "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters",
// "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically" => "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically",
// "Action Style" => "Action Style",
// "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example" => "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example",
// "Display the title of the tracker at the top of the form (not shown by default)" => "Display the title of the tracker at the top of the form (not shown by default)",
"Show the tracker's description (not shown by default)" => "Afficher la description du formulaire (non affichée par défaut)",
// "Show Fields Descriptions" => "Show Fields Descriptions",
// "Show the tracker's field descriptions (shown by default)" => "Show the tracker's field descriptions (shown by default)",
"Mark Mandatory" => "Marquer comme obligatoire",
"Indicate mandatory fields with an asterisk (shown by default)" => "Indiquer les champs obligatoires avec une astérisque (valeur par défaut)",
"Show Status" => "Afficher le statut",
"Show the status of the items (not shown by default)" => "Afficher le statut des fiches (non affiché par défaut)",
"Embedded" => "Enchâssé",
// "To send an email once the tracker item has been created. Format: %0from" => "To send an email once the tracker item has been created. Format: %0from",
// "template%0" => "template%0",
// "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)" => "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)",
// "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used" => "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used",
// "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)" => "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)",
// "Keep params in URL" => "Keep params in URL",
// "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL" => "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL",
"URL Target" => "URL cible",
// "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)" => "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)",
"Self" => "Self",
"Overwrite" => "Écraser",
// "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)" => "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)",
// "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)" => "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)",
// "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item" => "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item",
"Label for the reset button, to return all fields to their default values" => "Label pour le bouton 'réinitialiser', pour rendre aux champs leurs valeurs par défaut",
"reset" => "réinitialiser",
// "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)" => "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)",
// "User&field" => "User&field",
// "User field to filter" => "User field to filter",
// "User field to filter user tracker items to" => "User field to filter user tracker items to",
// "Field to filter" => "Field to filter",
// "Field to filter user tracker items to" => "Field to filter user tracker items to",
// "Field to filter Value" => "Field to filter Value",
// "Value to filter user tracker items to" => "Value to filter user tracker items to",
// "Criteria" => "Criteria",
// "If more than one item found, will choose under this criteria. Used in combination with" => "If more than one item found, will choose under this criteria. Used in combination with",
// "creationDate - Ascending" => "creationDate - Ascending",
// "creationDate - Descending" => "creationDate - Descending",
"Status of the item used in combination with" => "Statut de la fiche utilisé en combinaison avec",
"or" => "ou",
// "Transaction name" => "Transaction name",
// "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name" => "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name",
// "Transaction Step" => "Transaction Step",
// "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0" => "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0",
// "Final Transaction Step" => "Final Transaction Step",
// "Indicate whether this is the final transaction step" => "Indicate whether this is the final transaction step",
// "Transaction previous URL" => "Transaction previous URL",
// "The page to go back to when the \"previous\" button is clicked" => "The page to go back to when the \"previous\" button is clicked",
// "Transaction previous button label" => "Transaction previous button label",
// "Text for the \"previous\" button label" => "Text for the \"previous\" button label",
"ItemId" => "Id Fiche",
// "ItemId identifying the item to be edited" => "ItemId identifying the item to be edited",
"Ignore ItemId" => "Ignorer l'Id Fiche",
// "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)" => "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)",
"Template File" => "Fichier gabarit",
// "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template" => "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template",
// "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template" => "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template",
"New Status" => "Nouveau Statut",
// "Default status applied to newly created or saved items" => "Default status applied to newly created or saved items",
// "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form",
// "Autosave Fields" => "Autosave Fields",
// "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave" => "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave",
// "Autosave Values" => "Autosave Values",
// "Colon-separated values corresponding to %0. Special syntax cases" => "Colon-separated values corresponding to %0. Special syntax cases",
// "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field" => "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field",
// "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name" => "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name",
// "Increase-only Fields" => "Increase-only Fields",
// "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field" => "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field",
"Registration Fields" => "Champs d'enregistrement",
// "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers" => "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers",
// "Register to group" => "Register to group",
// "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)" => "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)",
// "Validate users" => "Validate users",
// "Here one can overrule the default validate users by e-mail preference" => "Here one can overrule the default validate users by e-mail preference",
"Output To Wiki" => "Sortie vers Wiki",
// "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId" => "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId",
"Discard After Output" => "Ecarter après la sortie",
// "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages" => "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages",
"Template Page" => "Page gabarit",
// "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5" => "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5",
// "Output Wiki Namespace" => "Output Wiki Namespace",
// "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page" => "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page",
// "Store Relation" => "Store Relation",
// "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)" => "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0" => "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0",
// "Fill Fields Separator" => "Fill Fields Separator",
// "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)" => "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)",
// "Fill Fields Defaults" => "Fill Fields Defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
"Embed the tracker in a form tag" => "Enchâsser le formulaire dans une balise 'form'",
// "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons" => "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons",
// "Use ajax to create/update tracker items" => "Use ajax to create/update tracker items",
// "Use ajax to create and update tracker items instead of form submission via request variables" => "Use ajax to create and update tracker items instead of form submission via request variables",
// "Transactions" => "Transactions",
// "You need to define both transaction name and transaction step, or none of the two" => "You need to define both transaction name and transaction step, or none of the two",
// "You need to choose transactionFinalStep (y/n)" => "You need to choose transactionFinalStep (y/n)",
// "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button" => "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button",
// "Tracker: Field #%0 not found in fields parameter or template" => "Tracker: Field #%0 not found in fields parameter or template",
"The page to output the results to already exists. Try another name" => "La page de sortie des résultats existe déjà. Essayer un autre nom",
// "Tracker Transaction: Field #%0 not found in fields parameter or template" => "Tracker Transaction: Field #%0 not found in fields parameter or template",
"Tracker was modified at " => "Le formulaire a été modifié à ",
// "Form saved successfully" => "Form saved successfully",
"Incorrect fieldId" => "Mauvais fieldId",
"Following fields are incorrect" => "Les champs suivants sont incorrects",
// "Error: Read only field \"%0\"" => "Error: Read only field \"%0\"",
// "This field is mandatory" => "This field is mandatory",
"Missing wiki template page \"%0\"" => "Page gabarit wiki \"%0\" manquante",
"Each line is a list of %d field values separated with: %s" => "Chaque ligne contient les valeurs de %d champs séparées par : %s",
"You do not have permission to insert an item" => "Vous n'avez pas les droits pour ajouter une fiche",
"Incorrect item" => "Fiche incorrecte",
"You do not have permission to modify an item" => "Vous n'avez pas les droits pour modifier un élément",
"The page to output the results to contains the following prohibited characters: %0. Try another name" => "Le nom de la page de sortie des résultats contient les caractères suivants prohibés : %0. Essayer un autre nom",
// "Please ensure you are using the correct field ID and that it is properly included in the template, if any" => "Please ensure you are using the correct field ID and that it is properly included in the template, if any",
"Passwords do not match" => "Les mots de passe ne correspondent pas",
"Insert one item per line:" => "Crée une entrée par ligne",
"Fields marked with an * are mandatory." => "Les champs marqués d'un astérisque (*) sont obligatoires.",
// "Tracker Calendar" => "Tracker Calendar",
// "Create and display a calendar using tracker data" => "Create and display a calendar using tracker data",
// "Resource Descriptor Field" => "Resource Descriptor Field",
// "Permanent name of the field to use as the resource indicator" => "Permanent name of the field to use as the resource indicator",
// "Coloring Discriminator Field" => "Coloring Discriminator Field",
// "Permanent name of the field to use to segment the information into color schemes" => "Permanent name of the field to use to segment the information into color schemes",
// "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages" => "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages",
// "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)" => "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)",
// "Add All Fields" => "Add All Fields",
// "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId" => "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId",
// "Use Session Storage" => "Use Session Storage",
// "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript" => "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript",
// "Agenda by Months" => "Agenda by Months",
// "Display the option to change the view to agenda by months" => "Display the option to change the view to agenda by months",
// "Agenda by Weeks" => "Agenda by Weeks",
// "Display the option to change the view to agenda by weeks" => "Display the option to change the view to agenda by weeks",
// "Agenda by Days" => "Agenda by Days",
// "Display the option to change the view to agenda by days" => "Display the option to change the view to agenda by days",
// "List by Years" => "List by Years",
// "Display the option to change the view to list by years" => "Display the option to change the view to list by years",
// "List by Months" => "List by Months",
// "Display the option to change the view to list by months" => "Display the option to change the view to list by months",
// "List by Weeks" => "List by Weeks",
// "Display the option to change the view to list by weeks" => "Display the option to change the view to list by weeks",
// "List by Days" => "List by Days",
// "Display the option to change the view to list by days" => "Display the option to change the view to list by days",
// "Resources by Years" => "Resources by Years",
// "Display the option to change the view to resources by years" => "Display the option to change the view to resources by years",
// "Resources by Months" => "Resources by Months",
// "Display the option to change the view to resources by months" => "Display the option to change the view to resources by months",
// "Resources by Weeks" => "Resources by Weeks",
// "Display the option to change the view to resources by weeks" => "Display the option to change the view to resources by weeks",
// "Resources by Days" => "Resources by Days",
// "Display the option to change the view to resources by days" => "Display the option to change the view to resources by days",
"Default View" => "Vue par défaut",
// "Choose the default view for the Tracker Calendar" => "Choose the default view for the Tracker Calendar",
// "Default Year" => "Default Year",
// "Choose the default year (yyyy) to use for the display" => "Choose the default year (yyyy) to use for the display",
// "Default Month" => "Default Month",
// "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc" => "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc",
// "Default Day" => "Default Day",
// "Choose the default day (dd) to use for the display" => "Choose the default day (dd) to use for the display",
// "Colormap for coloring" => "Colormap for coloring",
// "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0" => "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0",
// "First day of the Week" => "First day of the Week",
// "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)" => "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)",
// "Show Weekends" => "Show Weekends",
// "Display Saturdays and Sundays (shown by default)" => "Display Saturdays and Sundays (shown by default)",
// "Day Start" => "Day Start",
// "First time slot that will be displayed for each day, e.g. %0" => "First time slot that will be displayed for each day, e.g. %0",
// "Day End" => "Day End",
// "Last time slot that will be displayed for each day, e.g. %0" => "Last time slot that will be displayed for each day, e.g. %0",
// "Slot Duration" => "Slot Duration",
// "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)" => "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)",
// "Overlapping allowed" => "Overlapping allowed",
// "Allow resources to overlap in time" => "Allow resources to overlap in time",
// "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator" => "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator",
// "Fields not found" => "Fields not found",
"Tracker Comments" => "Commentaires du formulaire",
// "Display the number of comments for a tracker" => "Display the number of comments for a tracker",
"Item Count" => "Nombre de fiches",
"Determines whether the number of items will be shown (not shown by default)" => "Détermine si le nombre de fiches sera affiché ou non (non affiché par défaut)",
"Enter a username to select the items of the current user" => "Entrer un nom d'utilisateur pour sélectionner les éléments de l'utilisateur actuel",
"a user name" => "un nom d'utilisateur",
"Comments found" => "Commentaires trouvés",
"Filters" => "Filtres",
// "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1" => "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1",
// "Format choices are" => "Format choices are",
// "dropdown" => "dropdown",
// "radio buttons" => "radio buttons",
// "multiple choice dropdown" => "multiple choice dropdown",
// "checkbox" => "checkbox",
// "text with wild characters" => "text with wild characters",
// "exact text match" => "exact text match",
// "initials" => "initials",
// "advanced search" => "advanced search",
// "range search (from/to)" => "range search (from/to)",
// "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal" => "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal",
// "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)" => "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)",
"Display List" => "Afficher la Liste",
"Show the full list (before filtering) initially (filtered list shown by default)" => "Afficher la liste complète (avant filtrage) initialement (liste filtrée affichée par défaut)",
"Displays all the filters on the same line (not shown on same line by default)" => "Affiche tous les filtres sur la même ligne (pas affichés sur la même ligne par défaut)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
"No Toggle" => "Pas de commutateur",
// "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)" => "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)",
"Export CSV" => "Exporter CSV",
"Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Étiquette pour un bouton d'exportation. Laisser à blanc pour afficher plutôt l'habituel bouton \"Filtre\"",
// "Export Status Field" => "Export Status Field",
// "Export the status field if the Export CSV option is used" => "Export the status field if the Export CSV option is used",
// "Export Created Date Field" => "Export Created Date Field",
// "Export the created date field if the Export CSV option is used" => "Export the created date field if the Export CSV option is used",
// "Export Modified Date Field" => "Export Modified Date Field",
// "Export the modified date field if the Export CSV option is used" => "Export the modified date field if the Export CSV option is used",
// "Export Character Set" => "Export Character Set",
// "Character set to be used if the Export CSV option is used" => "Character set to be used if the Export CSV option is used",
// "Map View Buttons" => "Map View Buttons",
"Display Mapview and Listview buttons" => "Afficher les boutons Mapview et Listview",
// " - was %0 until 12.0" => " - was %0 until 12.0",
"Tracker Filter" => "Filtre de formulaire",
"Create a form to filter tracker fields" => "Créer un formulaire pour filtrer les champs du formulaire",
// "notice" => "notice",
// "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set" => "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set",
// "TrackerFields: Unknown tracker field used in the parameter \"filters\"" => "TrackerFields: Unknown tracker field used in the parameter \"filters\"",
"tracker field type not processed yet" => "champ de formulaire non traité pour l'instant",
"Tracker If" => "Test sur formulaire",
"Display content based on results of a tracker field test" => "Afficher du contenu en fonction des résultats d'un text sur un champ de formulaire",
"Ignore" => "Ignorer",
"Ignore test in edit mode" => "Ignorer le test en mode édition",
"Copy Tracker Item" => "Copier une fiche de formulaire",
"PluginTrackerItemCopy" => "Plugiciel Copie fiche formulaire",
// "Copy a tracker item" => "Copy a tracker item",
// "Tracker from which to copy item, joined tracker ids separated by %0:%1" => "Tracker from which to copy item, joined tracker ids separated by %0:%1",
// "Link Field IDs" => "Link Field IDs",
// "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1" => "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1",
// "Copy Field IDs" => "Copy Field IDs",
// "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1" => "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1",
// "Update Field IDs" => "Update Field IDs",
// "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1" => "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1",
"New Values" => "Nouvelles valeurs",
// "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId" => "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId",
"ID of item to make copy of, otherwise input is asked for" => "ID de la fiche à copier, sinon elle sera saisie",
"Make this number of copies on load" => "Faire ce nombre de copies au chargement",
"Set the number of copies to make on load of plugin automatically" => "Définir le nombre de copies à faire au chargement du plugiciel, automatiquement",
"Returns array non-interactively" => "Retourne un tableau de manière non interactive",
// "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode" => "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode",
"Missing mandatory parameters" => "Paramètres obligatoires manquants",
"Number of update fields do not match new values" => "Le nombre de champs à mettre à jour ne correspond pas à celui des nouvelles valeurs",
"Tracker Item Field" => "Champ de fiche de formulaire",
"Display or test the value of a tracker item field" => "Afficher ou tester la valeur d'un champ de fiche de formulaire",
// "Wiki text containing an %0{ELSE}%1 marker" => "Wiki text containing an %0{ELSE}%1 marker",
// "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user" => "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user",
"Numeric value representing the field ID displayed or tested" => "Valeur numérique représentant l'ID du champ à afficher ou tester",
"Colon-separated list of field IDs. Default is all fields" => "Liste d'identificateurs de champs séparés par ':'. Par défaut : tous les champs",
"Status of the tracker item" => "Statut de la fiche de formulaire",
"Open & Pending" => "Ouvert & En attente",
"Open & Closed" => "Ouvert & Fermé",
"Pending & Closed" => "En attente & Cloturé",
"Open, Pending & Closed" => "Ouvert, En attente & Fermé",
// "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter" => "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter",
"Value to compare against" => "Valeur à comparer",
"You are not allowed to view this item" => "Vous n'êtes pas autorisé(e) à voir cette fiche",
"You don't have permission to view this field" => "Vous n'êtes pas autorisé(e) à voir ce champ",
// "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1" => "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1",
// "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default" => "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default",
// "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param" => "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param",
"Sticky Popup" => "Popup 'Post-it'",
// "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)",
"Display the title of the tracker (not shown by default)" => "Afficher le titre du formulaire (non affiché par défaut)",
"Show Links" => "Afficher les liens",
// "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work" => "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work",
"Row" => "Ligne",
"Show Item Count" => "Afficher le nombre de fiches",
"Show the number of items found (not shown by default)" => "Afficher le nombre de fiches trouvées (non affiché par défaut)",
"Show Initials" => "Afficher les initiales",
// "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)" => "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)",
// "Creation date display is based on tracker settings unless overridden here" => "Creation date display is based on tracker settings unless overridden here",
"Last Modification Date" => "Date de dernière modification",
// "Last modification date display is based on tracker settings unless overridden here" => "Last modification date display is based on tracker settings unless overridden here",
// "Last modified by user display is based on tracker settings unless overridden here" => "Last modified by user display is based on tracker settings unless overridden here",
"Show Field Name" => "Afficher le nom du champ",
"Use the field names as column titles (used by default)" => "Utiliser les noms de champs comme titres de colonnes (utilisés par défaut)",
"Show Item Rank" => "Afficher le classement de la fiche",
"Show item ranks (not shown by default)" => "Afficher les classements des fiches (non affichés par défaut)",
// "Show comments count or last comment date and user depending on tracker preferences" => "Show comments count or last comment date and user depending on tracker preferences",
"Only show items matching certain status filters (only items with open status shown by default)" => "Afficher seulement les fiches correspondant à ertains filtres d'état (par défaut, seules les fiches En cours)",
// "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified" => "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified",
// "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)" => "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)",
"Sort Choice" => "Choix de tri",
// "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1" => "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1",
// "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1" => "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1",
"Offset of first item. Default is no offset" => "Décalage de la première fiche. Pas de décalage par défaut",
"Fix offset always (no pagination)" => "Toujours fixer le décalage (pas de pagination)",
// "Fix offset to that specified. This will disallow pagination" => "Fix offset to that specified. This will disallow pagination",
"Show Pagination" => "Afficher la pagination",
"Determines whether pagination will be shown (shown by default)" => "Détermine si la pagination sera affichée (affichée par défaut)",
// "Show button to make entire width of tables visible" => "Show button to make entire width of tables visible",
// "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)" => "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)",
"Filter Field" => "Champ du filtre",
"Colon-separated list of fields to allow filtering on" => "Liste de champs séparés par ':' pour pouvoir les utiliser en critères de tri",
"Filter Value" => "Valeur du filtre",
// "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match" => "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match",
// "text that ends in \"value\"" => "text that ends in \"value\"",
// "text that begins with \"value\"" => "text that begins with \"value\"",
// "the current user's login name" => "the current user's login name",
// "the current user's default group" => "the current user's default group",
// "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead" => "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead",
// "any text" => "any text",
"Exact Value" => "Valeur exacte",
// "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by" => "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by",
// "tracker item is in category with ID x or one its descendants" => "tracker item is in category with ID x or one its descendants",
// "tracker item is not in category with ID x or one of its descendants" => "tracker item is not in category with ID x or one of its descendants",
// "match against the value of a Tiki preference" => "match against the value of a Tiki preference",
// "match if value does not equal a Tiki preference value" => "match if value does not equal a Tiki preference value",
// "match if the field does not equal \"value\"" => "match if the field does not equal \"value\"",
// "match for non empty values (opposite with %0exactvalue%1=\"\")" => "match for non empty values (opposite with %0exactvalue%1=\"\")",
// "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)" => "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)",
// "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )" => "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )",
// "match if less than \"value\"" => "match if less than \"value\"",
// "match if greater than \"value\"" => "match if greater than \"value\"",
// "match if less than or equal to \"value\"" => "match if less than or equal to \"value\"",
// "match if greater than or equal to \"value\"" => "match if greater than or equal to \"value\"",
// "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are" => "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are",
// "the value of this field will be posted to the action" => "the value of this field will be posted to the action",
// "the name of the post" => "the name of the post",
// "the title of the submit button" => "the title of the submit button",
// "the name of the submit button" => "the name of the submit button",
// "the file that will be called upon submit" => "the file that will be called upon submit",
// "optional template inserted before the submit button and returned" => "optional template inserted before the submit button and returned",
// "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1" => "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1",
// "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case" => "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case",
// "comma-separated list of pre-checked items" => "comma-separated list of pre-checked items",
// "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1" => "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1",
// "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1" => "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1",
"goIfOne" => "Aller si unique",
// "Display the item rather than list if only one item is found" => "Display the item rather than list if only one item is found",
// "Show a 'more' button that links to the tracker item (not shown by default)" => "Show a 'more' button that links to the tracker item (not shown by default)",
"More link pointing to specified URL instead of default tracker item link" => "Lien 'Plus' pointant vers une URL spécifiée plutôt que le lien par défaut vers la fiche de formulaire",
// "Display only the items of the following" => "Display only the items of the following",
// "the current user" => "the current user",
// "the current page name" => "the current page name",
// "the current IP address" => "the current IP address",
// "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1" => "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1",
// "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins" => "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins",
// "Template Wiki Page" => "Template Wiki Page",
// "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins" => "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins",
"View User" => "Voir l'utilisateur",
"Will display the items of the specified user" => "Affichera les éléments de l'utilisateur spécifié",
// "Colon-separated list of item IDs to restrict the listing to" => "Colon-separated list of item IDs to restrict the listing to",
"Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignorer le paramètre d'url de l'ID de fiche pour le filtrage de liste (non ignoré par défaut)",
// "The link that will be on each main field when %0showlinks=\"y\"%1. Special values" => "The link that will be on each main field when %0showlinks=\"y\"%1. Special values",
// "will link to the item based on its item ID" => "will link to the item based on its item ID",
// "will link to the item based on its offset value" => "will link to the item based on its offset value",
// "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused" => "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused",
// "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example" => "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example",
// "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties" => "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties",
// "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1" => "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1",
// "Left Delimiter" => "Left Delimiter",
// "Smarty left delimiter for Latex generation. Example" => "Smarty left delimiter for Latex generation. Example",
// "Right Delimiter" => "Right Delimiter",
// "Smarty right delimiter for Latex generation Example" => "Smarty right delimiter for Latex generation Example",
"List Mode" => "Mode en liste",
// "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting",
"Comma Separated Values" => "Valeurs séparées par des virgules",
"Export Button" => "Bouton d'export",
"Show an export button (not shown by default)" => "Afficher un bouton d'exportation (non affiché par défaut)",
"Compute" => "Calculer",
// "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable" => "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable",
"fieldId" => "Id de champ",
// "%0, separated by %1" => "%0, separated by %1",
"Silent" => "Silencieux",
// "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)",
"Show Delete" => "Afficher 'Effacer'",
// "Show a delete icon for each item (not shown by default)" => "Show a delete icon for each item (not shown by default)",
// "Url to redirect to after delete" => "Url to redirect to after delete",
"Show Open Item" => "Afficher 'Ouvrir la fiche'",
"Show an open item  option (not shown by default)" => "Afficher une option 'Ouvrir la fiche'' (non affichée par défaut)",
"Show Close Item" => "Afficher 'Fermer la fiche'",
"Show a close item option (not shown by default)" => "Afficher une option 'Fermer la fiche' (non affichée par défaut)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
"Show Watch Button" => "Afficher le bouton de surveillance",
"Show a watch button (not shown by default)" => "Afficher un bouton de surveillance (non affiché par défaut)",
"Show Feed Button" => "Afficher le bouton de flux RSS",
"Show an RSS feed button (not shown by default)" => "Afficher un bouton 'Flux RSS' (non affiché par défaut)",
// "Show Results Map" => "Show Results Map",
// "Show Map of results (not shown by default)" => "Show Map of results (not shown by default)",
"Calendar Field IDs" => "Identificateurs de champ de calendrier",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1",
"Calendar View Mode" => "Mode d'affichage du calendrier",
"Calendar view type time span (default is month)" => "Intervalle de temps du type de vue calendrier (mois par défaut)",
"Two months" => "Bimestre",
"Trimester" => "Trimestre",
"Calendar Popup" => "Popup calendrier",
// "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)" => "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)",
// "Calendar item popups will stay open if set to y (Yes). Not sticky by default" => "Calendar item popups will stay open if set to y (Yes). Not sticky by default",
"Beginning of Month" => "Début du mois",
"Set whether calendar will begin at the beginning of the month (does by default)" => "Définir si le calendrier démarrera au début du mois (cas par défaut)",
"Show calendar navigation bar (shown by default)" => "Afficher la barre de navigation du calendrier (affichée par défaut)",
"Partial" => "Partiel",
"Calendar Title" => "Titre du calendrier",
"Enter a title to display a calendar title (not set by default)" => "Entrer un titre pour  afficher un titre au calendrier (non défini par défaut)",
"Calendar Delta" => "Intervalle calendrier",
"Set the calendar delta that will be shown (not set by default)" => "Définir l'intervalle de calendrier qui sera affiché (non défini par défaut)",
"Plus Month" => "Mois en plus",
"Minus Month" => "Mois en moins",
"Plus Two months" => "Bimestre en plus",
"Minus Two months" => "Bimestre en moins",
"Display Spreadsheet" => "Afficher en feuille de calcul",
"Display tracker as a spreadsheet (not used by default)" => "Afficher le formulaire comme une feuille de calcul (non utilisé par défaut)",
"Force Compile" => "Forcer la compilation",
// "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)" => "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
"Creation" => "Création",
// "Modification" => "Modification",
// "Inline edit" => "Inline edit",
// "Colon-separated list of fields for which inline editing will be enabled" => "Colon-separated list of fields for which inline editing will be enabled",
// "Inline edit All" => "Inline edit All",
// "Allow all displayed fields to be editable" => "Allow all displayed fields to be editable",
// "Compile Each Item" => "Compile Each Item",
// "Compile each item separately instead of compiling the entire template" => "Compile each item separately instead of compiling the entire template",
"Tracker List" => "Liste de fiches de formulaire",
"List, filter and sort the items in a tracker" => "Lister, filtrer et trier les fiches d'un formulaire",
// "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y" => "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y",
// "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly" => "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly",
// "For best results the date filter should only be applied to date field types" => "For best results the date filter should only be applied to date field types",
// "To filter the category field type, the exact category name or id needs to be entered" => "To filter the category field type, the exact category name or id needs to be entered",
"incorrect filterfield" => "filterfield incorrect",
// "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field" => "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field",
"Error in tracker ID" => "Erreur sur l'ID du formulaire",
"No field indicated" => "Aucun champ indiqué",
// "Check Tracker Passcodes" => "Check Tracker Passcodes",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Verify a tracker passcode" => "Verify a tracker passcode",
// "Session Key Names" => "Session Key Names",
"Tracker Prefill" => "Préremplissage du formulaire",
"Create a button to prefill tracker fields" => "Créer un bouton pour pré-remplir les champs du formulaire",
// "Tracker page name" => "Tracker page name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1" => "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1",
"Field 1" => "Champ 1",
"Field ID for the first field" => "ID du champ pour le premier champ",
"Value 1" => "Valeur 1",
"Content that should be used to prefill the field" => "Contenu à utiliser pour pré-remplir le champ",
"Field 2" => "Champ 2",
"Field ID for the second field" => "ID du champ pour le deuxième champ",
"Value 2" => "Valeur 2",
"Field 3" => "Champ 3",
"Field ID for the third field" => "ID du champ pour le troisième champ",
"Value 3" => "Valeur 3",
"Field 4" => "Champ 4",
"Field ID for the fourth field" => "Identificateur de champ pour le quatrième champ",
"Value 4" => "Valeur 4",
"Field 5" => "Champ 5",
"Field ID for the fifth field" => "ID du champ pour le cinquième champ",
"Value 5" => "Valeur 5",
"Field 6" => "Champ 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
"Field 7" => "Champ 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
"Field 8" => "Champ 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
// "Tracker Query Template" => "Tracker Query Template",
// "Generate a form from tracker data" => "Generate a form from tracker data",
// "Wiki Syntax, with variables from tracker query" => "Wiki Syntax, with variables from tracker query",
// "The name of the tracker to be queried, or if %0, the tracker ID" => "The name of the tracker to be queried, or if %0, the tracker ID",
// "Turn tracker query debug on (off by default)" => "Turn tracker query debug on (off by default)",
// "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs" => "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs",
// "Render" => "Render",
// "Render as needed for trackers (default)" => "Render as needed for trackers (default)",
// "Item id of tracker item" => "Item id of tracker item",
// "Tracker Item Ids" => "Tracker Item Ids",
// "Item id of tracker items, separated with comma" => "Item id of tracker items, separated with comma",
// "Like Filters" => "Like Filters",
// "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "And Filters" => "And Filters",
// "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Or Filters" => "Or Filters",
// "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Get Last" => "Get Last",
// "Retrieve only the last item from the tracker" => "Retrieve only the last item from the tracker",
"Tracker Stats" => "Statistiques des formulaires",
"Display statistics about a tracker" => "Afficher des statistiques en rapport avec un formulaire",
// "Colon-separated list of field IDs to be displayed. Example" => "Colon-separated list of field IDs to be displayed. Example",
// ". " => ". ",
// "Leave it empty to display all fields from this tracker" => "Leave it empty to display all fields from this tracker",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)" => "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)",
// "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)" => "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)",
"Only show items matching certain status filters" => "Afficher seulement les fiches correspondant aux filtres de statut",
// "Add a link to the tracker" => "Add a link to the tracker",
// "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example" => "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example",
"invalid status" => "statut invalide",
"incorrect fieldId" => "Id de champ incorrect",
"Tracker Timeline" => "Chronologie de formulaire",
"Show a timeline view of a tracker" => "Afficher une vue chronologique d'un formulaire",
"Title Field" => "Champ titre",
"Tracker Field ID containing the item title" => "ID du champ de formulaire contenant le titre de la fiche",
"Summary Field" => "Champ résumé",
// "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
"Element Group" => "Groupe d'éléments",
// "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row",
"Lower Bound" => "Limite inférieure",
// "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Upper Bound" => "Limite supérieure",
// "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
"Decade *" => "Décade *",
"Century *" => "Siècle *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)",
// "Link Group Name" => "Link Group Name",
"Convert the group name to a link" => "Convertir le nom du groupe en un lien",
// "Page Link Field" => "Page Link Field",
"Tracker Field ID containing the page name for item details" => "ID du champ de formulaire contenant le nom de la page pour les détails de la fiche",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
"Image Field" => "Champ Image",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
"Missing parameter: %0" => "Paramètre manquant: %0",
"Start date after end date" => "Date de début après la date de fin",
"Tracker Toggle" => "Afficher/masquer selon formulaire",
"Numeric value representing the field ID tested" => "Valeur numérique représentant l'ID du champ testé",
// "Element Visibility" => "Element Visibility",
// "Set whether visible when the field has the value" => "Set whether visible when the field has the value",
"HTML id of the element that is toggled" => "ID Html de l'élément qui affiché/masqué",
// "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set" => "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set",
// "trackertoggle: Param fieldId is required" => "trackertoggle: Param fieldId is required",
// "trackertoggle: Param fieldId field %0 does not exsist" => "trackertoggle: Param fieldId field %0 does not exsist",
// "trackertoggle: Param value is required" => "trackertoggle: Param value is required",
// "trackertoggle: Param id is required" => "trackertoggle: Param id is required",
// "Adjust the visibility of content based on a tracker field's value, possibly dynamically" => "Adjust the visibility of content based on a tracker field's value, possibly dynamically",
"Trade" => "Échange",
// "Send payments between members using cclite" => "Send payments between members using cclite",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Name of the user to receive or send the payment" => "Name of the user to receive or send the payment",
"Leave empty to display an input box" => "Laisser à blanc pour afficher une zone de saisie",
// "Offered or wanted item" => "Offered or wanted item",
// "%0Offered%1" => "%0Offered%1",
// "Offered" => "Offered",
"Wanted" => "Recherché",
// "%0Continue%1" => "%0Continue%1",
"Title of the input form" => "Titre du formulaire de saisie",
// "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted",
"Please log in" => "Merci de vous connecter",
" needs to validate their account" => " nécessite de valider leur compte",
"Transclude" => "Transposer",
"PluginTransclude" => "Plugiciel Transposer",
"Include the content of another page with certain changes" => "Inclure le contenu d'une autre page avec certaines modifications",
"Name of the wiki page to use as a template for the values" => "Nom de la page wiki à utiliser comme gabarit pour les valeurs",
"Attempt to include a page that cannot be viewed" => "Tentative d'inclure une page qui ne peut être affichée",
"Page named \"%0\" does not exist at this time" => "La page nommée \"%0\" n'existe pas à l'heure actuelle",
"Translated" => "Traduite",
// "Create multilingual links" => "Create multilingual links",
"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((nom de la page wiki)) or ((inter:interwiki)) (utiliser la wiki syntax)",
// "Two letter language code of the language, example" => "Two letter language code of the language, example",
"Flag" => "Drapeau",
// "Country name, example" => "Country name, example",
// "Translate a link from one language to another" => "Translate a link from one language to another",
// "TranslationOf" => "TranslationOf",
// "Original Page" => "Original Page",
// "Name of the page from which this link will be translated" => "Name of the page from which this link will be translated",
// "Translation Language" => "Translation Language",
// "Two letter language code of the language in which you want to translate this\n                    link. Example" => "Two letter language code of the language in which you want to translate this\n                    link. Example",
// "Translation Name" => "Translation Name",
// "Name of the page that will become the translation of the \"Original Page\"" => "Name of the page that will become the translation of the \"Original Page\"",
// "Translate this link" => "Translate this link",
"Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Twitter Path" => "Twitter Path",
// "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. " => "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. ",
// "Widget Id" => "Widget Id",
// "Numeric identifier of the widget" => "Numeric identifier of the widget",
// "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1" => "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1",
// "light" => "light",
// "dark" => "dark",
// "Link Color" => "Link Color",
// "Text color for individual tweets. Default is theme default" => "Text color for individual tweets. Default is theme default",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Border Color" => "Border Color",
// "Change the border color used by the widget. Default is theme default" => "Change the border color used by the widget. Default is theme default",
// "Height of widget in pixels. Default is %0" => "Height of widget in pixels. Default is %0",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is %0" => "Width of widget in pixels or 'auto' to fit to width of page. Default is %0",
"Number of pixels or the word 'auto'" => "Nombre de pixels ou le mot 'auto'",
// "Default is with Header" => "Default is with Header",
// "No Footer" => "No Footer",
// "Default is with Footer" => "Default is with Footer",
// "Footer" => "Footer",
// "Layout Option: No Borders" => "Layout Option: No Borders",
// "Default is with Borders" => "Default is with Borders",
"Borders" => "Bordures",
// "No Borders" => "No Borders",
// "No Scrollbar" => "No Scrollbar",
// "Default is with Scrollbar" => "Default is with Scrollbar",
// "Scrollbar" => "Scrollbar",
// "Transparent Background" => "Transparent Background",
// "Transparent Shell Background. Default is theme default" => "Transparent Shell Background. Default is theme default",
// "Theme default" => "Theme default",
"User Count" => "Nombre d'utilisateurs",
// "Display number of users for a site or one or more groups" => "Display number of users for a site or one or more groups",
// "Group name. If left blank, the total number of users for the site will be shown" => "Group name. If left blank, the total number of users for the site will be shown",
// "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings" => "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings",
// "UserInGroup" => "UserInGroup",
// "checks if an individual user is in a particular Group and simply return a string set to either true or false" => "checks if an individual user is in a particular Group and simply return a string set to either true or false",
// "userId" => "userId",
// "the userId to be checked" => "the userId to be checked",
// "test group" => "test group",
// "the Group that the userId check is made against" => "the Group that the userId check is made against",
// "text for true result" => "text for true result",
// "The text that is displayed if the test result is true" => "The text that is displayed if the test result is true",
// "text for false result" => "text for false result",
// "The text that is displayed if the test result is false" => "The text that is displayed if the test result is false",
// "Last Login information" => "Last Login information",
// "PluginUserLastLogged" => "PluginUserLastLogged",
// "Show the last login information for a given or current user" => "Show the last login information for a given or current user",
// "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank" => "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank",
// "DateFormat" => "DateFormat",
// "Date format setting. Short_datetime used by default" => "Date format setting. Short_datetime used by default",
"User Link" => "Lien utilisateur",
"Display a link to a user's information page" => "Afficher un lien vers la page d'information d'un utilisateur",
"User account name (which can be an email address)" => "Nom du compte utilisateur (qui peut-être une adresse courriel)",
"User List" => "Liste des Utilisateurs",
"Display a list of registered users" => "Afficher une liste d'utilisateurs enregistrés",
"Login Filter" => "Filtre d'identifiants",
"Separator to use between users in the list. Default: comma" => "Séparateur à utiliser entre les utilisateurs dans la liste. Par défaut : virgule",
// "Set to sort in ascending or descending order" => "Set to sort in ascending or descending order",
// "Set to table to display results in a table" => "Set to table to display results in a table",
// "Make the user names listed links to different types of user information" => "Make the user names listed links to different types of user information",
"User info" => "Info utilisateur",
"User page" => "Page utilisateur",
"User pref" => "Préf. utilisateur",
"Real Name" => "Nom réel",
"Display the user's real name (when available) instead of login name" => "Afficher le nom réel de l'utilisateur (quand disponible) plutôt que l'identifiant de connexion",
"Filter on a group" => "Filtrer sur un groupe",
"Display contents based on user preference settings" => "afficher des contenus en fonction des réglages des préférences utilisateur",
"Create tabs for showing alternate versions of content" => "Créer des onglets pour afficher différentes versions d'un contenu",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault",
// "Display a navigation box that allows users to select a specific version to display" => "Display a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default" => "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default",
"Default Label" => "Etiquette par défaut",
// "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'" => "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'",
// "Embed a Vimeo video" => "Embed a Vimeo video",
// "Complete URL to the Vimeo video. Example" => "Complete URL to the Vimeo video. Example",
// "or leave blank to upload one" => "or leave blank to upload one",
"Quality of the video" => "Qualité de la vidéo",
"Expand to full screen" => "Passer au mode plein écran",
// "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)" => "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)",
// "Numeric ID of a Tracker Files field, using Vimeo displayMode" => "Numeric ID of a Tracker Files field, using Vimeo displayMode",
// "Numeric ID of a Tracker item, using Vimeo displayMode" => "Numeric ID of a Tracker item, using Vimeo displayMode",
// "Gallery ID to upload to" => "Gallery ID to upload to",
// "Froogaloop API" => "Froogaloop API",
// "Use Vimeo Froogaloop API" => "Use Vimeo Froogaloop API",
// "Show the Video Title" => "Show the Video Title",
// "(default is to show)" => "(default is to show)",
// "Show Byline" => "Show Byline",
// "Show Portrait" => "Show Portrait",
// "Vimeo video not found for file #%0" => "Vimeo video not found for file #%0",
// "Feature required" => "Feature required",
// "Feature \"vimeo_upload\" is required to be able to add videos here" => "Feature \"vimeo_upload\" is required to be able to add videos here",
// "You do not have permsission to add files here" => "You do not have permsission to add files here",
// "You do not have permsission modify this tracker item" => "You do not have permsission modify this tracker item",
// "You do not have permsission modify this page" => "You do not have permsission modify this page",
// "Show the creator's byline" => "Show the creator's byline",
// "Show the creator's profile picture" => "Show the creator's profile picture",
"Vote" => "Voter",
"Create a tracker for voting" => "Créer un formulaire pour voter",
// "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example" => "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example",
// "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)" => "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)",
// "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)" => "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)",
"Show Stats" => "Afficher les Stats",
"Choose whether to show the voting results (shown by default)" => "Choisir d'afficher ou pas les résultats de vote (oui par défaut)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)",
// "Show Toggle" => "Show Toggle",
// "Show toggle or not to display the form and the results" => "Show toggle or not to display the form and the results",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
"Wanted Pages" => "Pages réclamées",
"Show location of links to pages not yet created" => "Afficher l'emplacement des liens vers des pages pas encore créées",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)",
"a valid regex-expression (PCRE)" => "une expression régulière regex (PCRE) valide",
"Split By" => "Séparer par",
"The character by which ignored patterns are separated" => "Le caractère au moyen duquel les modèles ignorés sont séparés",
// "Skip Alias" => "Skip Alias",
// "Whether to skip wanted pages that have a defined alias (not skipped by default)" => "Whether to skip wanted pages that have a defined alias (not skipped by default)",
"Skip Extension" => "Sauter les extensions",
"Whether to include external wikis in the list (not included by default)" => "S'il faut inclure ou non les wikis externes dans la liste (pas inclus par défaut)",
"Collect" => "Collecter",
// "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column",
"From" => "De",
"Switch on debug output with details about the items (debug not on by default)" => "Activer la sortie débogage détaillée concernant les éléments (non activée par défaut)",
"Memory Saver" => "Économiseur de mémoire",
// "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell",
"Line break" => "Saut de ligne",
"Separate Row" => "Séparer les lignes",
"Level" => "Niveau",
// "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex",
"Full" => "Complet",
"non-valid custom regex" => "expression régulière regex invalide",
", " => ", ",
"ignored" => "ignoré",
"External Wiki" => "Wiki externe",
"dash-WikiWord" => "WikiWord-tiret",
"WikiWord" => "Mot Wiki",
"not in level" => "pas dans le niveau",
"valid" => "valide",
"End of debug output." => "Fin des messages de debug.",
"Wanted Page" => "Page réclamée",
"Referenced By Page" => "Reférencée par une page",
// "Web Document Viewer" => "Web Document Viewer",
// "View a document in a page" => "View a document in a page",
// "File Id" => "File Id",
// "The FileId of a file in a File Gallery of the file you wish to embed in the viewer" => "The FileId of a file in a File Gallery of the file you wish to embed in the viewer",
// "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter" => "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter",
// "No FileId or URL has been set" => "No FileId or URL has been set",
"Web Service" => "Service Web",
// "Display remote information exposed in JSON or YAML or SOAP XML" => "Display remote information exposed in JSON or YAML or SOAP XML",
// "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter",
"Complete service URL" => "Compléter l'URL du service",
"Registered service name" => "Nom du service enregistré",
// "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided",
"Body as Parameter" => "Corps en tant que paramètre",
// "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful" => "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful",
// "Parameters formatted like a query" => "Parameters formatted like a query",
"Unknown Template" => "Modèle inconnu",
"Unknown Service" => "Service inconnu",
// "Wiki Diff" => "Wiki Diff",
// "Display the differences between two wiki objects" => "Display the differences between two wiki objects",
// "Object Id" => "Object Id",
// "Object to do a diff on (page name for wiki pages)" => "Object to do a diff on (page name for wiki pages)",
// "Object type (wiki pages only)" => "Object type (wiki pages only)",
// "Old version" => "Old version",
// "Integer for old version number, or date" => "Integer for old version number, or date",
// "New version" => "New version",
// "Leave empty for current version" => "Leave empty for current version",
// "Diff Style" => "Diff Style",
// "Defaults to \"diff style\" preference if empty" => "Defaults to \"diff style\" preference if empty",
// "Show version info" => "Show version info",
// "Show the heading \"Comparing version X with version Y\"" => "Show the heading \"Comparing version X with version Y\"",
// "Use a WYSIWYG editor to edit a section of content" => "Use a WYSIWYG editor to edit a section of content",
// "Minimum width for DIV. Default" => "Minimum width for DIV. Default",
// "Minimum height for DIV. Default" => "Minimum height for DIV. Default",
"Use HTML" => "Utiliser le HTML",
// "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed" => "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed",
// "XMLupdate" => "XMLupdate",
// "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory" => "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory",
// "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file " => "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file ",
// "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory" => "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory",
// "XML node attribute name" => "XML node attribute name",
// "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space" => "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space",
// "XML node listed in output" => "XML node listed in output",
// "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set" => "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set",
// "Xmpp" => "Xmpp",
// "Chat using Xmpp" => "Chat using Xmpp",
// "Room Name" => "Room Name",
// "Room to auto-join" => "Room to auto-join",
// "View Mode" => "View Mode",
// "Fullscreen" => "Fullscreen",
// "Overlayed" => "Overlayed",
// "Chat room width in CSS units" => "Chat room width in CSS units",
// "Chat room height in CSS units" => "Chat room height in CSS units",
"Visibility" => "Visibilité",
// "This room is visible to anyone or only for members" => "This room is visible to anyone or only for members",
// "Members only" => "Members only",
// "Show Real JIDs of Occupants to" => "Show Real JIDs of Occupants to",
// "If just moderator or anyone else can fetch information about an occupant" => "If just moderator or anyone else can fetch information about an occupant",
// "If just \"moderator\", anonymous user will not be able to change their nicknames" => "If just \"moderator\", anonymous user will not be able to change their nicknames",
// "Anyone" => "Anyone",
// "Moderator" => "Moderator",
// "Show controlbox on load" => "Show controlbox on load",
// "If controlbox should be shown after page load" => "If controlbox should be shown after page load",
// "This preference only works when view mode is overlayed" => "This preference only works when view mode is overlayed",
// "Show occupants" => "Show occupants",
// "If occupants window should be visible by default" => "If occupants window should be visible by default",
// "This preference only works when view mode is embedded" => "This preference only works when view mode is embedded",
// "Groups (comma-separated)" => "Groups (comma-separated)",
// "Allowed groups to use this resource" => "Allowed groups to use this resource",
// "Is secret" => "Is secret",
// "If the room will be listed on public chat room list" => "If the room will be listed on public chat room list",
// "Archiving" => "Archiving",
// "If room messages will be stored" => "If room messages will be stored",
// "Persistent" => "Persistent",
// "If room will continue to exist after last user leaves" => "If room will continue to exist after last user leaves",
// "If room is moderated" => "If room is moderated",
// "PluginXMPP Error: No room specified" => "PluginXMPP Error: No room specified",
// "Add a group to room" => "Add a group to room",
// "Add users to room" => "Add users to room",
"YouTube" => "YouTube",
// "Embed a YouTube video in a page" => "Embed a YouTube video in a page",
"Movie" => "Film",
// "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)" => "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)",
// "Privacy-Enhanced" => "Privacy-Enhanced",
// "Enable privacy-enhanced mode" => "Enable privacy-enhanced mode",
// "Start time" => "Start time",
// "Start time offset in seconds" => "Start time offset in seconds",
// "Quality of the video. Default is %0high%1" => "Quality of the video. Default is %0high%1",
"Enlarge video to full screen size" => "Agrandir la vidéo à la taille plein écran",
"Related" => "En relation",
"Show related videos (shown by default)" => "Afficher les vidéos en relation (affichées par défaut)",
"Background" => "Arrière-plan",
// "Toolbar background color. Use an HTML color code" => "Toolbar background color. Use an HTML color code",
"Example" => "Example",
"HTML color code, e.g. ffffff" => "Code couleur HTML, par exemple ffffff",
// "Toolbar border colors. Use an HTML color code" => "Toolbar border colors. Use an HTML color code",
"Plugin YouTube error: the movie parameter is empty" => "Erreur plugiciel YouTube : le paramètre film est vide",
// "Invalid YouTube URL provided" => "Invalid YouTube URL provided",
"Zotero Citation" => "Citation Zotero",
"Retrieves and includes a Zotero reference in the page." => "Retrouve et inclut une référence Zotero dans la page.",
"Reference Key" => "Clé référence",
// "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module",
"Reference Tag" => "Mot-clé de référence",
// "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references" => "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references",
"Zotero Reference List" => "Liste de référence Zotero",
// "Display the complete reference list from a Zotero server" => "Display the complete reference list from a Zotero server",
"Provide the list of references with a given tag" => "Fournir la liste des références pour un mot-clé donné",
"No results obtained. The Zotero citation server may be down" => "Aucun résultat obtenu. Le serveur de références Zotero est peut-être arrêté",
// "Set up some advanced options" => "Set up some advanced options",
// "Set up Auto TOC" => "Set up Auto TOC",
// "Define Categories" => "Define Categories",
// "Set up User & Community features" => "Set up User & Community features",
// "Set up Date and Time" => "Set up Date and Time",
// "Select Editor type" => "Select Editor type",
// "Set up Main features" => "Set up Main features",
// "Set up File Gallery & Attachments" => "Set up File Gallery & Attachments",
// "Set up File storage" => "Set up File storage",
// "Set up Language" => "Set up Language",
// "Set up Login" => "Set up Login",
// "Set up Look & Feel" => "Set up Look & Feel",
// "Set up Namespace" => "Set up Namespace",
// "Set up Search" => "Set up Search",
// "Set up Structures" => "Set up Structures",
// "Set up Text Area" => "Set up Text Area",
// "Set up Wiki environment" => "Set up Wiki environment",
// "Tiki Setup" => "Tiki Setup",
// "Configuration Wizard Completed" => "Configuration Wizard Completed",
// "Set up Wysiwyg editor" => "Set up Wysiwyg editor",
// "Related doc.tiki.org pages" => "Related doc.tiki.org pages",
// "New in Tiki 13" => "New in Tiki 13",
// "New in Tiki 14" => "New in Tiki 14",
// "New in Tiki 15 (LTS)" => "New in Tiki 15 (LTS)",
// "New in Tiki 16" => "New in Tiki 16",
// "New in Tiki 17" => "New in Tiki 17",
// "New in Tiki 18 (LTS)" => "New in Tiki 18 (LTS)",
// "New in Tiki 19" => "New in Tiki 19",
// "New in Tiki 20" => "New in Tiki 20",
// "Novice Admin Assistance" => "Novice Admin Assistance",
// "Other features and settings" => "Other features and settings",
// "Permissions & Logs" => "Permissions & Logs",
// "Send feedback & Connect" => "Send feedback & Connect",
// "User Interface" => "User Interface",
// "Changes Wizard Completed" => "Changes Wizard Completed",
// "Configuration Profiles Wizard Completed" => "Configuration Profiles Wizard Completed",
// "Demo of Cases in Project Management" => "Demo of Cases in Project Management",
// "Demo of Commonly Used Configurations" => "Demo of Commonly Used Configurations",
// "Demo of Highly Specialized Configurations" => "Demo of Highly Specialized Configurations",
// "Demo of Interesting Use Cases" => "Demo of Interesting Use Cases",
// "Demo of More Advanced Configurations" => "Demo of More Advanced Configurations",
// "Demo of Other Interesting Use Cases" => "Demo of Other Interesting Use Cases",
// "Featured Site Configurations" => "Featured Site Configurations",
// "Useful Administration Configurations" => "Useful Administration Configurations",
// "Useful Changes in Display Mode" => "Useful Changes in Display Mode",
// "Useful Micro Configurations" => "Useful Micro Configurations",
// "Useful New Technology Configurations" => "Useful New Technology Configurations",
"Personal Information" => "Informations personnelles",
"User Watches" => "Surveillances utilisateur",
// "Notification Preferences" => "Notification Preferences",
"unicode" => "unicode",
"Report Preferences" => "Préférences des rapports",
// "User Details" => "User Details",
// "You cannot access this page directly" => "You cannot access this page directly",
// "Welcome to the User Wizard" => "Welcome to the User Wizard",
// "User Wizard Completed" => "User Wizard Completed",
// "Invalid wizard stepNr specified" => "Invalid wizard stepNr specified",
"Articles Home" => "Accueil-articles",
// "Delete selected messages" => "Delete selected messages",
// "%0 archived message was deleted" => "%0 archived message was deleted",
// "%0 archived messages were deleted" => "%0 archived messages were deleted",
// "No messages were deleted" => "No messages were deleted",
// "No messages were selected to delete" => "No messages were selected to delete",
// "The message must have either a subject or a body" => "The message must have either a subject or a body",
"User %s does not have the permission" => "L'utilisateur %s n'a pas la permission",
"The message has been sent to" => "Le message a été envoyé à",
"The message will be sent to" => "Le message va être envoyé à",
// "See below for how the broadcast message will be handled upon confirmation" => "See below for how the broadcast message will be handled upon confirmation",
// "No valid users to send the message to" => "No valid users to send the message to",
"User %s does not want to receive messages" => "L'utilisateur %s ne veut pas recevoir de messages",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La boîte des messages envoyés est pleine. Archivez ou supprimez quelques messages envoyés avant, si vous souhaitez pouvoir envoyer d'autres messages.",
// "See below for how message will be handled upon confirmation" => "See below for how message will be handled upon confirmation",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Vous devez pouvoir recevoir des messages pour pouvoir en envoyer. Allez dans vos préférences utilisateur et activez 'Autoriser des messages d'autres utilisateurs'",
"User %s can not receive messages, mailbox is full" => "L'utilisateur %s ne peut pas recevoir de messages. Sa boîte à lettres est pleine",
"User %s can not receive messages" => "L'utilisateur %s ne peut pas recevoir de messages",
"Invalid user: %s" => "Utilisateur invalide : %s",
// "%0 message was marked" => "%0 message was marked",
// "%0 messages were marked" => "%0 messages were marked",
// "No messages were marked" => "No messages were marked",
// "No messages were selected to mark" => "No messages were selected to mark",
// "%0 message was deleted" => "%0 message was deleted",
// "%0 messages were deleted" => "%0 messages were deleted",
// "%0 message was archived" => "%0 message was archived",
// "%0 messages were archived" => "%0 messages were archived",
// "No messages were archived" => "No messages were archived",
// "No messages were selected to archive" => "No messages were selected to archive",
"Archive is full. Delete some messages from archive first." => "L'archive est pleine. Supprimez des messages de l'archive d'abord.",
// "Delete message" => "Delete message",
// "Message deleted" => "Message deleted",
// "Message not deleted" => "Message not deleted",
"No more messages" => "Plus de messages",
// "Delete archive message" => "Delete archive message",
// "Archive message deleted" => "Archive message deleted",
// "Archive message not deleted" => "Archive message not deleted",
// "Delete sent message" => "Delete sent message",
// "Sent message deleted" => "Sent message deleted",
// "Sent message not deleted" => "Sent message not deleted",
// "%0 sent message was deleted" => "%0 sent message was deleted",
// "%0 sent messages were deleted" => "%0 sent messages were deleted",
"Action Calendar" => "Calendrier d'Action",
"Item types filter" => "Filtre sur types d'éléments",
"If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "Si défini comme une liste de types d'éléments, restreint l'affichage de ceux appartenant à l'un de ces types. Chaque ensemble est une liste de codes de types séparés par des virgules",
"Possible item type values" => "Valeurs possibles de type d'éléments",
"Similar Content" => "Contenu similaire",
"Find similar content based on tags." => "Trouver du contenu similaire basé sur les mots-clés.",
"Similar Content Filter" => "Filtre de contenu similaire",
"Display only similar content of type specified" => "Affiche seulement des contenus similaires au type spécifié",
"Default: \"All Content Type\"" => "Par défaut : \"Tout type de contenu\"",
"Options: \"article, wiki page, blog post\"" => "Options : \"article, wiki page, blog post\"",
"Broaden FreeTag Search" => "Elargir la recherche de mots-clés",
"Find similar content that contains one of the Tags or All of the Tags" => "Trouver du contenu similaire qui contient un des mots-clés ou tous les mots-clés.",
"Default: \"n - needs to contain all of the Tags\"" => "Par défaut : \"n - doit contenir tous les mots-clés",
"Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Doit contenir tous les mots-clés / y - Doit contenir au moins un mot-clé\"",
// "Quick Admin Bar" => "Quick Admin Bar",
// "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features" => "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features",
"Display mode: module or header. Leave empty for module mode" => "Mode d'affichage : module ou en-tête. Laisser à blanc pour le mode module",
"Google AdSense" => "Publicité Google AdSense",
"Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Affiche une publicité Google AdSense sour forme de texte/image. Ce module doit être mis à jour pour supporter le nouveau code Google",
"ad_channel" => "Chaîne",
"Advertisement channel, as optionally provided by Google" => "Chaîne publicitaire, optionnellement fournie par Google",
"client" => "Client",
"As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "Tel que fourni par Google. Format : \"pub-xxxxxxxxxxxxxxxx\"",
"display" => "Affichage",
"Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Bannière globale telle que fournie par Google. Par exemple : \"display=468*60_as\"",
"color_bg" => "Arrière-plan",
"Background color, as optionally provided by Google" => "Couleur de l'arrière-plan, optionnellement fournie par Google",
"color_border" => "Bordure",
"Border color, as optionally provided by Google" => "Couleur de la bordure, optionnellement fournie par Google",
"color_link" => "Lien",
"Link color, as optionally provided by Google" => "Couleur du lien, telle que fournie en option par Google",
"color_text" => "Texte",
"Text color, as optionally provided by Google" => "Couleur du texte, telle que fournie en option par Google",
"color_url" => "URL",
"URL color, as optionally provided by Google" => "Couleur du lien (URL), telle que fournie optionnellement par Google",
"Article Archives" => "Archives d'article",
"Shows links to the published articles for each month." => "Affiche les liens vers les articles publiés pour chaque mois.",
"If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "Si défini à \"y\", affiche un bouton \"Plus\", lien vers une vue paginée des artciles sélectionnés",
"Default: \"n\"" => "Valeur par défaut : \"n\"",
"If set to a category identifier, only consider the articles in the specified category" => "Si réglé sur un identificateur de catégorie, prend uniquement en compte les articles de la catégorie désignéeonly consider the articles in the specified category",
"Example value: 13" => "Exemple de valeur : 13",
"Topic filter (by names)" => "Filtre de sujet (par noms)",
"If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Si défini comme une liste d'identifiants de sujets d'articles séparés par \"+\", prendre en compte seulement les articles appartenant à ces sujets. Si la chaîne est précédée par \"!\", l'effet est inversé, c.a.d. ces articles ne seront pas pris en considération",
"Topic filter (by identifiers)" => "Filtre de sujet (par identifiants)",
"If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Si défini comme une liste d'identifiants de sujets d'articles séparés par \"+\", prendre en compte seulement les articles appartenant à ces sujets. Si la chaîne est précédée par \"!\", l'effet est inversé, c.a.d. ces articles ne seront pas pris en considération",
"Example values: 13, !13, 1+3, !1+5+7" => "Exemple de valeurs : 13, !13, 1+3, !1+5+7",
"Types filter" => "Filtre de types",
"If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "Si défini comme une liste de noms de type d'article séparés par \"+\", prendre en considération seulement les articles des types spécifiés. Si la chaîne est précédée par \"!\", l'effet est inversé, i.e. les articles des types spécifiés sont ignorés",
"Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Exemple de valeurs : Event, !Event, Event+Review, !Event+Classified+Article",
"Language filter" => "Filtre de langue",
"If set to a language code, only consider the articles in the specified language" => "Si réglé sur un code de langue, prendre uniquement en compte les articles dans la langue spécifiée",
"Article Topics" => "Sujets des articles",
"Lists all article topics with links to their articles" => "Liste tous les sujets d'articles avec liens vers leurs articles",
"Lists the specified number of published articles in the specified order." => "Liste le nombre déterminé d'articles publiés selon l'ordre choisi.",
"Show publication time" => "Afficher la date de publication",
"If set to \"y\", article publication times are shown" => "Si défini à \"y\", les date et heure de publication sont affichées",
"Show creation time" => "Afficher la date de création",
"If set to \"y\", article creation times are shown" => "Si défini à \"y\", les date et heure de création de l'article sont affichées",
"Show rating selector" => "Afficher un sélecteur de score",
"If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "Si défini à \"y\", offre à l'utilisateur de filtrer les articles dont le score est compris entre un minimum et un maximum",
"Image width" => "Largeur de l'Image",
"If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "Si défini, affiche une image pour chaque article si une image s'applique, avec la largeur donnée (en pixels). L'image propre à l'article est utilisée si elle est définie, sinon celle du sujet de l'article",
"If set to a category identifier, only lists the articles in the specified category" => "Si réglé sur un identificateur de catégorie, affiche seulement les articles de la catégorie désignée",
"If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Si défini comme une liste d'identifiants de sujets d'articles séparés par \"+\", liste seulement les articles appartenant à ces sujets. Si la chaîne est précédée par \"!\", l'effet est inversé, c.a.d. ces articles ne seront pas listés",
"If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Si défini comme une liste d'identifiants de sujets d'articles séparés par \"+\", liste seulement les articles appartenant à ces sujets. Si la chaîne est précédée par \"!\", l'effet est inversé, c.a.d. ces articles ne seront pas listés",
"If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "Si défini comme une liste de noms de type d'article séparés par \"+\", affiche seulement les articles des types spécifiés. Si la chaîne est précédée par \"!\", l'effet est inversé, i.e. les articles des types spécifiés ne sont pas affichés",
"If set to a language code, only lists the articles in the specified language" => "Si réglé sur un code de langue, affiche uniquement en compte les articles dans la langue spécifiée",
"Specifies how the articles should be sorted" => "Spécifie comment les articles doivent être triés",
"Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Les valeurs possibles incluent created et created_asc (équivalentes), created_desc, author, rating, topicId, lang and title. Sauf si \"_desc\" est spécifié, le tri est croissant. \"created\" trie sur la date de création de l'article",
"If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "Si défini comme un nombre entier, décale les articles de la liste du nombre indiqué. Par exemple, si le module a été configuré ailleurs pour afficher les 10 articles les plus récemment publiés, régler le décalage sur 10 fera afficher les articles 11 à 20 en ordre décroissant de publication à la place",
"If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "Si défini à \"y\", affiche un bouton \"Plus\", lien vers une vue paginée des artciles sélectionnés",
"Absolute URL" => "URL absolue",
"If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "Si réglé sur \"y\", quelques liens utilisent une adresse (URL) absolue au lieu d'une relative. Ceci peut éviter des liens morts si le module doit être envoyé dans une lettre de nouvelles, par exemple",
"If set to 0, will take the topicId of the article if in an article" => "Si défini à 0, prendra l'identificateur du sujet de l'article si dans un article",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
"Newest Blog Post Comments" => "Derniers commentaires sur les publications de blogue",
"Displays the specified number of the blog post comments most recently added" => "Affiche le nombre spécifié de commentaires blog les plus récemment ajoutés",
"No date" => "Pas de date",
"If set to \"y\", the date of comments is not displayed in the module box" => "Si défini à \"y\", la date des commentaires n'est pas affichée dans le conteneur du module",
"Verbose tooltips" => "Infobulles bavardes",
"If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "Si défini à \"y\", le titre de la publication du blogue est seulement visible sous forme d'infobulle et non affichée",
"Options: \"y,n\"" => "Options : \"y,n\"",
"Last-Visited Pages" => "Dernières pages visitées",
"Displays the last Wiki pages visited by the user." => "Affiche les dernières pages Wiki visitées par l'utilisateur.",
"Maximum number of characters in page names allowed before truncating" => "Nombre maximum de caractères des noms des pages avant troncature",
// "Show Namespace" => "Show Namespace",
// "Show namespace prefix in page names" => "Show namespace prefix in page names",
"A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "Un hiérarchie de l'endroit où vous êtes. Ex : Accueil > Section 1 > Sous-section C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
"Includes a calendar or a list of calendar events." => "Inclut un calendrier ou une liste d'événements.",
"Calendars filter" => "Filtre de calendriers",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "Si défini comme une liste d'identifiants de calendrier, restreint les événements à ceux des calendriers identifiés. Les identifiants sont séparés par des barres verticales (\"|\"), virgules (\",\") ou deux-ponts (\":\"). Exemples de valeurs : \"13\", \"4,7\", \"31:49\". Non défini par défaut",
"Displayed month (relative)" => "Mois affiché (relatif)",
"Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distance en mois jusqu'au mois à afficher. Une distance de -1 afficherait le mois précédent. Définir cette option implique une vue de type calendrier avec un période de moi. Exemples de valeur : 2, 0, -2, -12",
"View type" => "Type de vue",
"Determines how to show events. Possible values: %0, %1" => "Determine comment afficher les événements. Valeurs possibles : %0, %1",
"Calendar view type time span" => "Période de temps du type de vue calendrier",
"If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "Dans un type de vue calendrier (ou \"table\"), détermine la préiode de temps affichée par le calendrier. Valeurs possibles : %0, %1, %2, %3 ,%4, %5. Un utilisateur modifiant cette pétiode de temps dans le calendrier peut modifier la période de temps que le module affiche pour lui",
"Show action" => "Afficher l'action",
"Viewmode when clicking on a day" => "Mode d'affichage si on clique sur une journée",
"Put a link on all the days , not only those with event" => "Mettre un lien sur tous les jours, pas seulement ceux avec événement",
"View navigation bar" => "Afficher la barre de navigation",
"Cart" => "Panier",
// "Displays the content of the cart, allows quantities to be modified and proceeds to payment" => "Displays the content of the cart, allows quantities to be modified and proceeds to payment",
// "Use AJAX" => "Use AJAX",
// "Use AJAX services for managing the cart" => "Use AJAX services for managing the cart",
// "Show Items" => "Show Items",
// "Shows the items in the cart as they are added" => "Shows the items in the cart as they are added",
// "Shows the number of items in the cart" => "Shows the number of items in the cart",
// "Checkout URL" => "Checkout URL",
// "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated" => "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated",
// "(Default empty: Goes to tiki-payment.php)" => "(Default empty: Goes to tiki-payment.php)",
// "Post-Payment URL" => "Post-Payment URL",
// "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc" => "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc",
// "Show Total Weight" => "Show Total Weight",
// "Shows the weight of the items in the cart" => "Shows the weight of the items in the cart",
// "Shown after the weight" => "Shown after the weight",
// "Show Item Buttons" => "Show Item Buttons",
// "Shows add, remove and delete buttons on items" => "Shows add, remove and delete buttons on items",
"The quantities in your cart were updated" => "Les quantités dans votre panier ont été mises à jour",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
"Displays links to categories as a tree." => "Affiche des liens vers les catégories sous forme d'arborescence.",
"Object type filter" => "Filtre de type d'objet",
"Object type filter to apply when accessing a linked category. Example values" => "Filtre de type d'objet à appliquer quant on accède à une catégorie liée. Exemple de valeurs",
"Deep" => "Profondeur",
"Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Afficher les objets des sous-catégories quand on accède à une catégorie liée. Valeurs possibles : on (défaut), off",
"Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Limite les catégories affichées à un sous-arbre ayant pour racine la catégorie ayant l'ID donné. Exemple de valeur : 11. Défaut: 0 (ne pas limiter l'affichage)",
"Show these categories and their children" => "Afficher ces catégories et toutes leurs sous-catégories",
"Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Afficher seulement ces catégories et les catégories premier enfant de celles-ci dans l'ordre que le paramètre spécifie. Exemples de valeur : 3,5,6",
"Category links to a page named as the category" => "La catégorie pointe vers une page nommée comme la catégorie",
"If y, category links to a page named as the category" => "Si y, la catégorie pointe sur une page du même nom que celle-ci",
// "Hide Empty" => "Hide Empty",
// "If y, only categories with child objects will be shown" => "If y, only categories with child objects will be shown",
// "Only Children" => "Only Children",
// "If y, only direct child categories will be shown. Default: n" => "If y, only direct child categories will be shown. Default: n",
"Custom URL" => "Adresses URL configurables",
// "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" " => "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" ",
"Category Transitions" => "Transitions de catégories",
"Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Affiche des contrôles pour déclencher des transitions de catégorie et modifier l'état de la page selon des règles prédéfinies",
"Example Transition" => "Exemple  de transition",
"Change Category" => "Changer la Catégorie",
"Enables to categorize an object." => "Permet de catégoriser un objet.",
// "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
"Category identifier" => "Identificateur de catégorie",
"Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Change la racine des catégories affichées de \"TOP\" par défaut à la catégorie indiquée par son identificateur",
"Note that the root category is not displayed" => "Veuillez noter que la catégorie racine n'est pas affichée",
"Defaults to 0 (root)" => "Par défaut 0 (racine)",
"No top" => "Vue non détaillée",
"In non-detailed view, disallow uncategorizing. Example value: 1" => "Dans une vue non détaillée, désactiver la décatégorisation. Exemple de valeur : 1",
"Display path" => "Afficher le chemin",
"Unless set to \"n\", display relative category paths in the category tree rather than category names" => "A moins d'être défini à \"n\", afficher les chemins relatifs dans l'arbre des catégories plutôt que les noms de catégorie",
"Paths are relative to the root category, which is not displayed" => "Les chemins sont relatifs à la catégorie racine, qui n'est pas affichée",
"Multiple categories" => "Plusieurs catégories",
"If set to \"n\", only allows categorizing in one category (from those displayed)" => "Si défini à \"n\", permet seulement d'affecter à une seule catégorie (parmi celles affichées)",
"Categorize" => "Catégoriser",
"String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "Chaîne à afficher dans le bouton pour soumettre de nouvelles catégories, quand les catégories multiples sont autorisées. aleur par défaut : Categoriser",
"Shy" => "Timide",
"If set to \"y\", the module is not shown on pages which are not already categorized" => "Si défini à \"y\", le module n'est pas affiché dans les pages non encore catégorisées",
"Detailed" => "Détaillé",
"If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "Si défini à \"y\", montre une liste des catégories dans lesquelles se trouve l'objet. Si la suppression n'est pas désactivée, ce peut être fait avec la liste",
"If set to \"n\", the detailed list of categories will not offer to unassign a category" => "Si défini à \"n\", les listes détaillées de catégories n'offriront pas de désassigner une catégorie",
"If set to \"y\", allow to assign new categories" => "Si défini à \"y\", permet d'assigner de nouvelles catégories",
"Example values: y, n" => "Exemple de valeurs : y, n",
"Default value: y" => "Valeur par défaut : y",
"Group filter" => "Filtre de groupe",
"Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Option de filtre très particulière. Si définie à \"y\", seules catégories ayant un nom correspondant à un des groupes de l'utilisateur sont affichées, ainsi que les descendantes de ces catégories en correspondance",
"Default value: n" => "Valeur par défaut : n",
"Image URL not in category" => "Adresse de l'image pas dans la catégorie",
"Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Paramètre très particulier. Si ceci et «Adresse de l'image dans la catégorie» sont paramétrés, et si la catégorie racine contient une seule catégorie enfant, le module affiche seulement une image avec cette adresse si l'objet n'est pas dans la catégorie",
"Image URL in category" => "Adresse de l'image dans la catégorie",
"Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Paramètre très particulier. Si ceci et «Adresse de l'image pas dans la catégorie» sont paramétrés, et si la catégorie racine contient une seule catégorie enfant, le module affiche seulement une image avec cett adresse si l'objet est dans la catégorie",
"Categorize %s" => "Catégoriser %s",
"Categorize %s in %s" => "Catégoriser %s dans %s",
// "Collapse Button" => "Collapse Button",
// "Bootstrap collapse button" => "Bootstrap collapse button",
// "CSS selector defining which objects get collapsed" => "CSS selector defining which objects get collapsed",
// "CSS class for containing DIV element" => "CSS class for containing DIV element",
// "CSS selector defining the collapsing objects' container" => "CSS selector defining the collapsing objects' container",
"Received Objects" => "Objets reçus",
"Displays the number of pages received (via Communications)" => "Affiche le nombre de pages reçues (via Communications)",
"Contributors" => "Contributeurs",
"Lists the contributors to the wiki page being viewed and some information on them." => "Liste le nom des contributeurs de la page Wiki affichée et certaines informations sur eux.",
"Shows the credits a user has" => "Afficher les crédits que l'utilisateur a",
"Newest Directory Sites" => "Derniers Sites de l'Annuaire",
"Displays the specified number of the directory sites most recently added." => "Affiche le nombre spécifié des sites de l'annuaire ajoutés les plus récemment.",
"Directory category identifier" => "Identificateur de la catégorie de l'annuaire",
"If set to a directory category identifier, only displays the sites in the specified directory category" => "Si défini comme un identificateur de catégorie de l'annuaire, affiche seulement les sites de la catégorie désignée",
"If set to \"y\", displays a button labelled \"More\" that links to the directory" => "Si défini à \"y\", affiche un bouton \"Plus\", lien vers l'Annuaire",
"Show description" => "Afficher la description",
"If set to \"y\", the description of the directory site appears" => "Si réglé sur \"y\", la description du site de l'annuaire est affichée",
"Maximum length of description" => "Longueur maximale des descriptions",
"If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "Si 'Afficher la description' = \"y\", utiliser cette zone pour définir la taille maximale de la description (en caractères). Laisser à blanc pour ne pas définir de maximum (afficher la description entière)",
"Default: blank" => "Par défaut : vide",
"Directory Statistics" => "Statistiques de l'annuaire",
"Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links." => "Affiche les satistiques de l'annuaire de sites, incluant le nombre de sites validés et à valider, le nombre de catégories, de recherches et de liens visités.",
"Top Directory Sites" => "Sites vedettes de l'annuaire",
"Displays the specified number of the directory sites from most visited to least visited." => "Affiche le nombre spécifié de sites de l'annuaire du plus visité au moins visité.",
// "Domain Password" => "Domain Password",
// "Store personal passwords for other domains securely in Tiki" => "Store personal passwords for other domains securely in Tiki",
// "System the credentials apply for. The name must match a defined Password Domain" => "System the credentials apply for. The name must match a defined Password Domain",
// "Use current user" => "Use current user",
// "Use the currently logged-in user. The username is not editable. (y/n) Default: y" => "Use the currently logged-in user. The username is not editable. (y/n) Default: y",
// "Can Update" => "Can Update",
// "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n" => "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n",
// "Show domain prompt" => "Show domain prompt",
// "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y" => "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y",
// "No Password Domains found" => "No Password Domains found",
// "Domain is not valid" => "Domain is not valid",
// "No domain specified" => "No domain specified",
// "No user defined" => "No user defined",
// "No password saved" => "No password saved",
// "Read error" => "Read error",
// "No password specified" => "No password specified",
// "No username specified" => "No username specified",
// "Failed to save password" => "Failed to save password",
// "Failed to save user" => "Failed to save user",
// "Saved OK" => "Saved OK",
"Facebook" => "Facebook",
// "Shows the Wall of a user" => "Shows the Wall of a user",
// "Tiki user to show Facebook wall of" => "Tiki user to show Facebook wall of",
// "Show username in timeline. y|n" => "Show username in timeline. y|n",
// "user not registered with facebook" => "user not registered with facebook",
// "No username given" => "No username given",
"Featured Links" => "Liens vedettes",
"Displays the site's first featured links" => "Affiche les liens vedettes du site",
"Displays links to file galleries." => "Affiche des liens vers les galeries de fichiers.",
"Top-Rated Topics" => "Sujets les mieux notés",
"Displays the specified number of the forum topics with the best ratings." => "Affiche un nombre déterminé des sujets des forums les mieux notés.",
"Newest Forum Posts" => "Derniers articles de forum",
"Displays the latest forum posts." => "Affiche les dernières publications de forum.",
"Topics only" => "Sujets uniquement",
"If set to \"y\", only displays topics" => "Si défini à \"y\", affiche seulement les sujets",
"List of forum identifiers" => "Liste d'identifiants de forums",
"If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "Si défini comme une liste d'identifiants de forums, restreint les publications à celles dans les forums spécifiés. Les identifiants sont séparés par deux-points (\":\")",
"Show date" => "Afficher la date",
"If set to \"y\", show post date directly instead of as tooltip" => "Si défini à \"y\", afficher la date de publication directement plutôt que dans une infobulle",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
"If set to \"y\", show post author directly instead of as tooltip" => "Si défini à \"y\", afficher directement l'auteur plutôt que dans une infobulle",
"Most Commented Forums" => "Forums avec le plus de commentaires",
"Display the specified number of the forums with the most comments." => "Affiche un nombre déterminé des forums avec le plus de commentaires.",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
"Tags Editor" => "Éditeur de mots clés (freetags)",
"Shows current tags and enables adding and removing some if permissions allow" => "Affiche les mots-clés courants et permet d'en ajouter ou supprimer si on a les permissions",
"Wiki Page Tags" => "Mots-clés de page Wiki",
"Displays current tags on wiki pages and enables adding tags if permissions allow." => "Affiche les mots-clés existants sur les pages Wiki et permet d'ajouter des mots-clés si les permissions le permettent.",
"Similar-Tag Items" => "Objets avec mot(s)-clé(s) en commun",
"Shows content with multiple tags in common." => "Afficher le contenu avec des mots-clés en commun.",
"Type of objects to extract" => "Type des objets à extraire",
"Most Popular Tags" => "Mots-clés vedettes",
"Shows the most popular tags. More popularity is indicated by a larger font." => "Afficher les mots-clés les plus populaires. Les plus populaires ont une police plus grande.",
"Display type" => "Type d'affichage",
"If set to \"cloud\", links are displayed as a cloud" => "Si défini sur \"cloud\", les liens sont affichés sous forme de nuage de mots-clés",
"Default: \"list\"" => "Défaut : \"list\"",
"Maximum elements" => "Maximum d'éléments",
"If set to a number, limits the number of tags displayed" => "Si défini comme un nombre, limite le nombre de mots-clés affichés",
// "BlogId" => "BlogId",
// "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5" => "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5",
"My Preferred Tags" => "Mes Mots-Clés Préférés",
"Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size" => "Affiche pour les utilisateurs enregistrés les mots-clés qu'ils préfèrent, basé sur le nombre d'objets auquels ils ont ajouté le mot-clé. Les plus utilisés sont indiqués par une police plus grande",
"My preferred tags" => "Mes mots-clés préférés",
// "Displays a list of friends" => "Displays a list of friends",
// "GIT detail" => "GIT detail",
// "GIT commit and last update information" => "GIT commit and last update information",
"Google Search" => "Rechercher avec Google",
"Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Affiche un formulaire de recherche Google. Par défaut il limite la recherche sur le site Tiki",
"Groups Emulation" => "Émulation de Groupes",
"Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Permettre un changement temporaire des adhésions de groupe afin de voir comment les utilisateurs dans moins de groupes perçoivent le site",
// "Show All Groups" => "Show All Groups",
// "If set to \"n\", the list is not shown" => "If set to \"n\", the list is not shown",
// "Show Your Groups" => "Show Your Groups",
"Emulate Groups" => "Simuler les Groupes",
"Last Actions" => "Dernières actions",
"Displays the specified number of last actions." => "Affiche un nombre déterminé des dernières actions.",
"Show user" => "Montrer l'utilisateur",
"If set to \"y\", user names are displayed in the module box" => "Si réglé sur \"y\", les noms d'utilisateurs sont affichés dans la boîte du module",
"If set to \"y\", action dates are displayed in the module box" => "Si défini à \"y\", les dates d'action sont affichées dans la boîte du module",
"Maximum number of characters in action descriptions before truncating" => "Nombre maximum de caractères des descriptions d'action avant troncature",
"Newest Blog Posts" => "Dernières publications de blogue",
"Lists the specified number of blogs posts from newest to oldest." => "Liste un nombre déterminé d'articles de blogues du plus récent au plus ancien.",
"If set to \"y\", the date of posts is not displayed in the module box" => "Si réglé sur \"y\", la date des publications n'est pas affichée dans la boîte du module",
"Blog identifier" => "Identifiant du blogue",
"If set to a blog identifier, restricts the blog posts to those in the identified blog" => "si réglé sur un identificateur de blogue, restreint les publications à celles du blogue désigné",
"Newest Category Items" => "Derniers éléments catégorisés",
"Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Indique le nombre spécifié d'objets du type donné dans la catégorie donnée, à partir du plus récemment créé",
"Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identificateur d'une catégorie dont les objets sont listés. Les objets seulement reliés aux catégories enfants ne seront pas affichés",
"Maximum number of characters in object names allowed before truncating" => "Nombre maximum de caractères des noms d'objets avant troncature",
"Type of the objects to list. Example values" => "Type des objets à lister. Exemple valeurs",
"no object here yet" => "pas encore d'objet",
"Newest Blogs" => "Derniers blogues créés",
"Displays the specified number of blogs from newest to oldest." => "Affiche un nombre déterminé de blogues du plus récent au plus ancien.",
"Newest FAQs" => "Dernières questions de la FAQ",
"Displays the specified number of FAQs from newest to oldest." => "Affiche un nombre déterminé de FAQs de la plus récente à la plus ancienne.",
"Newest Quizzes" => "Derniers QCMs créés",
"Displays the specified number of quizzes from newest to oldest." => "Affiche un nombre déterminé de quizzes du plus récent au plus ancien.",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
"Newest Files" => "Derniers fichiers",
"List the specified number of files, starting from the most recently added." => "Lister un nombre déterminé de fichiers, en commençant par les plus récemment ajoutés.",
"Gallery identifiers" => "Identifiants de galerie",
"If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "Si défini comme un ensemble d'identificateurs de galeries de fichiers, limite les fichiers à ceux appartenant aux galeries identifiées. La valeur est une suite d'entiers séparés par des points",
"Example value: 13, 2:13, 1:2:3:5:6" => "Exemple de valeurs : 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
"Displays the specified number of image galleries, starting from the most recently modified" => "Affiche un nombre déterminé de galeries d'images, en commençant par la plus récemment modifiée",
"Newest Images" => "Dernières images",
"List the specified number of images, starting from the most recently added" => "Lister un nombre déterminé d'images, en commençant par la plus récemment ajoutée",
"Gallery identifier" => "Identifiant de galerie",
"If set to an image gallery identifier, restricts the images to those in the identified gallery" => "Si défini comme un identificateur de galerie d'images, restreint les images choisies à celles de la galerie identifiée",
"Link content" => "Contenu du lien",
"Display the links as image names or thumbnails" => "Afficher les liens sous forme de noms d'images ou vignettes",
"Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Valeurs possibles : \"names\" ou \"thumbnails\". Par défaut : \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
"If set to a calendar identifier, restricts the events to those in the identified calendar" => "Si réglé sur un identificateur de calendrier, restreint les événements à ceux du calendrier désigné",
"Maximum number of characters in event names allowed before truncating" => "Nombre maximum de caractères des noms d'événements avant troncature",
// "Hide Date" => "Hide Date",
"If set to \"y\", it will hide date" => "Si réglé sur \"Y\", il masquera la date",
"Latest Changes" => "Dernières modifications",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
"Target URL of the \"...more\" link at the bottom of the module" => "Adresse (URL) du lien \"...plus\" au bas du module",
"Last-Modified Blogs" => "Derniers blogues modifiés",
"Displays the specified number of blogs, starting from the most recently modified." => "Affiche un nombre déterminé de blogues, en commençant avec le plus récemment modifié.",
"Newest Podcasts" => "Derniers Podcasts",
"Displays Podcasts." => "Affiche les Podcasts.",
"File galleries IDs" => "IDs des galeries de fichier",
"List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "Liste des IDs de galeries de fichier du type \"Podcast (Audio)\". Les identificateurs sont séparés par deux-points (\":\"). Si rien n'est spécifié, toutes les galeries de fichiers seront examinées",
"Width of mediaplayer in pixels." => "Largeur du lecteur média.",
"Height of mediaplayer in pixels." => "Hauteur en pixels du lecteur média.",
"Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Chemin vers le lecteur mp3. Par exemple media/player_mp3_maxi.swf si vous avez téléchargé 'player_mp3_maxi.swf' depuis http://flash-mp3-player.net/players/maxi/download/ vers le répertoire media/ (répertoire à créer ou vous pouvez choisir un autre emplacement)",
"Bottom Link URL" => "URL du lien inférieur",
"URL for a link at bottom of module" => "URL pour un lien au pied du module",
"Bottom Link URL Text" => "Texte du lien inférieur",
"Text for link if Bottom Link URL is set." => "Texte pour le lien si 'URL du lien inférieur' est définie.",
"More Podcasts" => "Plus de podcasts",
"Verbose" => "Détaillé",
"Display description of podcast below player if \"y\", and on title mouseover if \"n\"." => "Afficher la description du podcast en dessous du lecteur si \"y\", et au survol de souris du titre si \"n\".",
"Newest Article Submissions" => "Dernières soumissions",
"Lists the specified number of article submissions from newest to oldest." => "Liste un nombre déterminé d'articles soumis du plus récent au plus ancien.",
"Newest Tracker Comments" => "Derniers commentaires de formulaire",
"Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Indique le nombre spécifié de commentaires de formulaire (optionnellement restreindre à ceux dans un formulaire ou une fiche de formulaire spécifique) à partir du plus récemment créé",
"Tracker identifier" => "Identificateur de formulaire",
"If set to a tracker identifier, only displays the comments on the given tracker" => "Si défini comme un identitficateur de formulaire, affiche seulement les commentaires du formulaire ainsi indiqué",
"Item identifier" => "Identificateur de fiche",
"If set to an item identifier, only displays the comments on the given item" => "Si défini comme un identificateur de fiche, affiche seulement les commentaires sur la fiche ainsi indiquée",
"Newest Tracker Items" => "Dernières fiches d'utilisateurs",
"Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required." => "Affiche la valeur d'un champ d'un formulaire dont le numéro est spécifié. Si le formulaire spécifié n'a pas de champ principal, le nom ou l'identificateur du champ est requis.",
"Identifier of the tracker from which items are listed" => "Identificateur du formulaire dont les fiches sont listées",
"Field identifier" => "Identificateur de champ",
"Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identificateur du champ dont les valeurs sont listées. Si le nom du champ est choisi, ce paramètre sera ignoré",
"Field name" => "Nom du champ",
"Name of the field from which values are listed" => "Nom du champ dont les valeurs sont listées",
"Example value: age" => "Exemple de valeur : âge",
"Specifies how the items should be sorted" => "Spécifie comment les fiches doivent être triées",
"Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Les valeurs possibles incluent 'created' et 'created_asc' (équivalent), 'created_desc', 'status', 'lastModif', 'createdBy' et 'lastModifBy'. A moins que \"_desc\" soit spécifié, le tri est croissant. \"created\" trie sur la date de création des fiches. \"lastModif\" trie sur la date de dernière modification des fiches. \"lastModif_desc\" trie en ordre décroissant sur la date de dernière modification",
"Status filter" => "Filtre de statut",
"If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "Si défini, limite les fiches affichées à celles ayant les statuts indiqués. Les valeurs sont des combinaisons de \"o\" (ouverte), \"p\" (en attente) et \"c\" (fermées). Valeurs possibles",
"Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Impossible de déterminer quel champ afficher. L'identificateur du formulaire peut ne pas être valide, ou le formulaire n'a pas de champ principal et ni l'identificateur de champ ni un nom de champ n'ont été définis",
"You do not have permission to view this tracker" => "Vous n'avez pas le droit de voir ce formulaire",
"Last Items" => "Dernières fiches",
"Last modified Items" => "Dernières fiches modifiées",
"Newest Validated FAQ Questions" => "Foire Aux Questions (FAQs) dernièrement validées",
"Displays the specified number of validated questions FAQs from newest to oldest" => "Affiche le nombre spécifié de questions validées de la FAQ des plus récentes aux plus anciennes",
"FAQ identifier" => "Identificateur de Faq",
"If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ" => "Si réglé sur un identificateur de FAQ, restreint les questions choisies à celles de la FAQ désignée",
"Last Visitors" => "Derniers visiteurs",
"Displays information about the specified number of users in decreasing order of last login time." => "Affiche les derniers utilisateurs qui se sont connectés sur la plateforme.",
"Show profile pictures" => "Montrer les avatars",
"If set to \"y\", show user profile pictures" => "Si défini à \"y\", montrer les avatars de l'utilisateur",
"Maximum number of characters in user names allowed before truncating" => "Nombre maximal de caractères des noms d'utilisateur avant troncature",
"Don't show date" => "Ne pas afficher la date",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Google YouTube API Key" => "Google YouTube API Key",
"Width of each video in pixels" => "Largeur de chaque vidéo en pixels",
"Height of each video in pixels" => "Hauteur de chaque vidéo en pixels",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "durée",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
"No Playlist found" => "Aucune liste d'écoute trouvée",
"No Playlist ID was provided" => "Aucun ID de liste d'écoute n'a été fourni",
"Live Support" => "Assistance en ligne",
"Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console." => "Dit aux utilisateurs si un assistant en ligne est présent et leur permet de demander de l'aide si cela est possible. Si l'utilisateur est un assistant, il aura accès au panneau de contrôle de l'assistant.",
"Server Load" => "Charge du Serveur",
"Report of server resources used" => "Rapport des ressources serveur utilisées",
"Locator" => "Localisateur",
"Presents a map with the geolocated content within the page" => "Présente une carte avec le contenu géolocalisé de la page",
// "Preference \"%0\" is disabled" => "Preference \"%0\" is disabled",
"Log-in box" => "Boîte de connexion",
"Input size" => "Taille de la saisie",
"Number of characters for username and password input fields" => "Nombre de caractères pour les champs de saisie nom d'utilisateur et mot de passe",
"Display mode: module, header or popup. Leave empty for module mode" => "Mode d'affichage : 'module', 'header' ou 'popup'. Laisser à blanc pour le mode module",
"Show Register" => "Afficher 'S'enregistrer'",
"Show the register link" => "Afficher le lien 'S'enregistrer'",
"Show I Forgot" => "Afficher 'J'ai oublié'",
"Show the \"I forgot my password\" link" => "Afficher le lien 'J'ai oublié mon mot de passe'",
"Show Remember me" => "Afficher 'Se souvenir de moi'",
"Show the \"Remember me\" checkbox" => "Afficher la case à cocher 'Se souvenir de moi'",
// "Show user avatar" => "Show user avatar",
// "Show the user avatar when in popup mode" => "Show the user avatar when in popup mode",
// "Show user name" => "Show user name",
// "Show the user name when in popup mode" => "Show the user name when in popup mode",
// "Groups for switch user listing" => "Groups for switch user listing",
// "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")" => "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")",
// "Menu ID" => "Menu ID",
// "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"" => "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"",
"Logo" => "Logo",
"Site logo, title and subtitle" => "Logo du site, titre et sous-titre",
// "Image URL" => "Image URL",
// "Image to use. Defaults to sitelogo_src preference" => "Image to use. Defaults to sitelogo_src preference",
// "CSS colour to use as background. Defaults to sitelogo_bgcolor preference" => "CSS colour to use as background. Defaults to sitelogo_bgcolor preference",
// "Image title attribute. Defaults to sitelogo_title preference" => "Image title attribute. Defaults to sitelogo_title preference",
// "Alt" => "Alt",
// "Image alt attribute. Defaults to sitelogo_alt preference" => "Image alt attribute. Defaults to sitelogo_alt preference",
// "URL for the image and titles link. Defaults to \"./\"" => "URL for the image and titles link. Defaults to \"./\"",
// "Logo Title" => "Logo Title",
// "Large text to go next to image. Defaults to sitetitle preference" => "Large text to go next to image. Defaults to sitetitle preference",
// "Logo Subtitle" => "Logo Subtitle",
// "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference" => "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference",
// "Logo Class" => "Logo Class",
// "CSS class for the image container div. Defaults to sitelogo" => "CSS class for the image container div. Defaults to sitelogo",
// "Title Class" => "Title Class",
// "CSS class title text container div. Defaults to sitetitles" => "CSS class title text container div. Defaults to sitetitles",
// "Map Feature Editor" => "Map Feature Editor",
"Allows shapes to be drawn over the map" => "Permet de dessiner des formes sur les cartes",
// "Tracker to store the feature in" => "Tracker to store the feature in",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Mode change on insert" => "Mode change on insert",
// "Target mode to enter after successfully inserting an item" => "Target mode to enter after successfully inserting an item",
// "Edit details" => "Edit details",
// "Edit the tracker item's details through a dialog after the initial item creation" => "Edit the tracker item's details through a dialog after the initial item creation",
// "Layer Selector" => "Layer Selector",
// "Include base layer" => "Include base layer",
// "Include the drop list for the base layers" => "Include the drop list for the base layers",
// "Include optional layers" => "Include optional layers",
// "Include the checkboxes for the optional layers" => "Include the checkboxes for the optional layers",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "Menu",
"Displays a menu or a structure as a menu" => "Affiche un menu ou une structure sous forme de menu",
"Identifier of a menu (from tiki-admin_menus.php)" => "Identificateur d'un menu (à partir de tiki-admin_menus.php)",
"Structure" => "Structure",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
"Direction for menu: horiz or vert (default vert)" => "Orientation du menu : 'horiz' ou 'vert' (défaut 'vert')",
"CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu (if bootstrap = n). y|n (default y)" => "Use CSS Superfish menu (if bootstrap = n). y|n (default y)",
// "Use Bootstrap menus" => "Use Bootstrap menus",
// "Show Navbar Toggle Button" => "Show Navbar Toggle Button",
// "Used in Bootstrap navbar menus when viewport is too narrow for menu items" => "Used in Bootstrap navbar menus when viewport is too narrow for menu items",
// "The URL of the navbar brand (logo)" => "The URL of the navbar brand (logo)",
// "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu" => "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu",
// "CSS class(es) for the menu nav element" => "CSS class(es) for the menu nav element",
// "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar" => "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar",
"DOM #id" => "DOM #id",
"Id of the menu in the DOM" => "'Id' du menu dans le DOM",
"CSS class" => "Classe CSS",
"Class of the menu container" => "Classe du conteneur menu",
"Limit low visibles levels" => "Limiter les niveaux inférieurs visibles",
"All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "Tous les sous-menus commençant à ce niveau seront affichés si l'adresse correspond à une des options de ce niveau, ou supérieur ou inférieur",
"Limit top visible levels" => "Limiter les niveaux supérieurs visibles",
"Do not display options higher than this level" => "Ne pas afficher d'options supérieures à ce niveau",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
"(y/n default y)" => "(o/n -défaut o)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "Set Selected" => "Set Selected",
// "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue" => "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue",
"One of these parameters has to be set" => "Un de ces paramètres doit être réglé",
"Menu Page" => "Page dans un menu",
"Displays a Wiki page" => "Affiche une page wiki",
"Page to display in the menu. Example value: HomePage" => "Page à afficher dans le menu. Exemple de valeur : Accueil",
// "Use default namespace" => "Use default namespace",
// "Prepend the default namespace to the page name for localized menus per workspace (1/0)" => "Prepend the default namespace to the page name for localized menus per workspace (1/0)",
// "Menu style" => "Menu style",
// "Display the page as a menu (horiz / vert)" => "Display the page as a menu (horiz / vert)",
"Wiki Structure Menu" => "Structure Wiki dans un menu",
"Displays a structure" => "Affiche une structure",
"N.B. Deprecated, use the Menu module instead" => "Nota bene : Obsolète, utiliser plutôt le module Menu",
"Structure to display in the menu" => "Structure à afficher dans le menu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
"Displays to users their number of new inter-user messages and a link to their message box" => "Affiche aux utilisateurs leur nombre de messages internes et un lien vers leur boîte de réception",
"Show If Empty" => "Afficher si vide",
"Show the module when there are no messages waiting. y|n " => "Afficher le module quand il n'y a pas de message en attente. y|n ",
"Default=y" => "Par défaut = y",
"Messages" => "Messages",
"Small live chat box" => "Petite boîte de clavardage en ligne",
"Channels" => "Canaux",
"List of chat channels. Channel names are separated by a comma (\",\")" => "Liste des canaux de clavardage. Les canaux sont séparés par une virgule (\",\")",
"By default, a single channel named \"default\" exists" => "Par défaut, un canal unique nommé \"default\" existe",
"Mobile" => "Mobile",
"Currently only shows switch to and from mobile mode" => "Affiche seulement actuellement un interrupteur vers/depuis le mode mobile",
"To Label" => "Etiquette 'Vers'",
"Switch to normal site label" => "Etiquette 'Basculer vers le mode normal du site'",
"From Label" => "Etiquette 'Depuis'",
"Switch to mobile site label" => "Etiquette 'Basculer vers le mode mobile du site'",
// "Switch Perspective" => "Switch Perspective",
"Also switch perspective back to this one when leaving mobile mode" => "Également, revenir à cette perspective quand on quitte le mode 'mobile'",
"Stay" => "Rester",
"Stay on same page" => "Rester sur la même page",
"Switch to mobile site" => "Basculer vers le site pour mobile",
"Switch to normal site" => "Basculer vers le site normal",
"Months Links" => "Liens mensuels",
"Link to articles or blog posts for the current month and those preceding it." => "Liste de liens vers les articles ou publications de blogue pour le mois courant et les mois précédents.",
"Type of objects to link to" => "Type des objets cibles",
"Possible values" => "Valeurs possibles",
"\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" pour les blogues, \"cms\" pour les articles publiés",
// "Object Identifier" => "Object Identifier",
"Identifier of an object with children to link to" => "Identificateur d'un objet avec enfant à relier par un lien",
"This is required for the blog Object type" => "Ceci est requis pour le type d'Objet blog",
"For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "Par exemple, un identifiant de 3 et un objet-type «blogue» montreront les liens vers les publications de blogues ayant l'identifiant 3",
"List by month" => "Liste par mois",
"Most Commented" => "Les plus commentés",
// "Display the most commented objects of a certain type" => "Display the most commented objects of a certain type",
"Type of objects to consider" => "Type d'objets à prendre en considération",
"Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Valeurs possibles : wiki (pages Wiki), blog (publications de blogue), article (articles)",
"Language Filter" => "Filtre de langue d'objet",
"If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "Si défini comme une balise de langue RFC1766, restreint les objets considérés à ceux de la langue ainsi spécifiée",
// "Request the creation of a mustread item based on the current object" => "Request the creation of a mustread item based on the current object",
// "Object Field" => "Object Field",
// "Permanent name of the field containing the object reference" => "Permanent name of the field containing the object reference",
// "Notifications Link" => "Notifications Link",
// "Shows an icon with the number of and a link to user notifications" => "Shows an icon with the number of and a link to user notifications",
"Pending Article Submissions" => "Soumissions en attente",
"Displays the number of article submissions waiting examination and a link to the list" => "Affiche le nombre de soumissions d'articles attendant d'être examinés et un lien vers la liste",
"Old Articles" => "Archives",
"Displays the specified number of old articles (which do not show on articles home page anymore)." => "Affiche le nombre spécifié d'anciens articles (qui n'apparaissent désormais plus dans la page d'accueil des articles).",
// "Package Module" => "Package Module",
// "A module that shows content from a Tiki Package View" => "A module that shows content from a Tiki Package View",
// "Name of package (vendor/name)" => "Name of package (vendor/name)",
// "Name of package in the form vendor/name" => "Name of package in the form vendor/name",
// "Name of the view file without the .php" => "Name of the view file without the .php",
// "Other parameters" => "Other parameters",
// "URL encoded string of other parameters (will not replace standard parameters)" => "URL encoded string of other parameters (will not replace standard parameters)",
"Payments Outstanding" => "Paiements restants",
"Displays the payments outstanding for the current user" => "Affiche les paiements en souffrance pour l'utilisateur courant",
// "List of active permissions for current object" => "List of active permissions for current object",
"Enables to change current perspective." => "Permet de changer la perspective actuelle.",
// "Powered By" => "Powered By",
"Powered by Tiki, and others" => "Basé sur Tiki, et autres",
"Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Affiche le message «Basé sur Tiki Wiki CMS Groupware»",
"Tiki version info" => "Info de version Tiki",
"Shows theme credits (contents of credits.tpl)" => "Affiche les crédits de thème (contenus de credits.tpl)",
"Shows various \"powered by\" icons" => "Affiche des icônes variées \"powered by\"",
"Quick Edit" => "Modification rapide",
"Enables to quickly create or edit Wiki pages" => "Permet de créer/modifier rapidement des pages Wiki",
"Deprecated - use the Search module instead" => "Obsolète - utiliser plutôt le module 'Recherche'",
"Template identifier" => "Identificateur de gabarit",
"If set to a template identifier, the specified template is used for creating new Wiki pages" => "Si réglé sur un nom de gabarit, ce gabarit sera utilisé pour la création de nouvelles pages Wiki",
"If set, send the form to the given location (relative to Tiki's root) for processing" => "Si défini, envoyer le formulaire à l'emplacement donné (relatif à la racine Tiki) pour traitement",
"SUBMIT label" => "Etiquette 'SOUMETTRE'",
"The label on the button to submit the form" => "L'étiquette sur le bouton pour soumettre le formulaire",
"Create/Edit" => "Créer/Modifier",
"INPUT SIZE" => "TAILLE DU CHAMP DE SAISIE",
"Size attribute (horizontal, in characters) of the text input field for page names" => "Taille (horizontale, en caractères) du champ de texte pour les noms de page",
"Optional heading to display at the top of the module's content" => "en-tête optionnelle à afficher en haut du contenu du module",
"Category to preselect" => "Catégorie à présélectionner",
"If set, pages created through the module have this category prechecked to be categorized in" => "Si défini, les pages créées au travers du module ont cette catégorie pré-cochée pour y être insérées",
"Tip to be shown" => "Astuce à montrer",
"Custom text to be shown as a tip at the top of the edit page" => "Texte personnalisé pour être affiché comme astuce en haut de la page d'édition",
"Title of tip to be shown" => "Titre de l'astuce à montrer",
"Custom title to be shown for the tip at the top of the edit page" => "Titre personnalisé de l'astuce en haut de la page d'édition",
"Custom header template" => "Personnaliser le modèle d'en-tête",
"Wiki page to be used as a template to show content on top of edit page" => "Page Wiki à utiliser en tant que gabarit pour afficher le contenu en haut de la page d'édition",
"Quick Edit a Wiki Page" => "Créer/modifier une page Wiki",
"Quick Search" => "Recherche rapide",
"Performs a search query and persists the results in the module for quick navigation access" => "Réalise une recherche et affiche les résultats dans le module pour une navigation rapide",
"Filter object type" => "Filtre de type d'objet",
"Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limiter les résultats de recherche à un type spécifique d'objet. Entrer un type d'objet pour utiliser un filtre statique ou écrire \"selector\" pour permettre une saisie",
"Filter category" => "Filtre de catégorie",
"Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls" => "Limiter les résultats de recherche à une catégorie spécifique. Entrer la liste des IDs de catégories à inclure dans le sélecteur. Une catégorie unique n'affichera aucun sélecteur",
// "Quick Administration" => "Quick Administration",
// "Some helpful tools for administrators" => "Some helpful tools for administrators",
"Random Image" => "Image choisie au hasard",
"Displays a random image." => "Affiche une image aléatoire.",
"If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "Si défini comme un identificateur de galerie d'images, restreint les images choisies à celles de la galerie identifiée",
"Show link" => "Afficher le lien",
"If set to \"n\", the image thumbnail does not link to the image" => "Si défini à \"n\", la vignette d'image ne pointe pas vers l'image",
"Default: \"y\"" => "Valeur par défaut : \"y\"",
"Show name" => "Afficher le nom",
"If set to \"y\", the name of the image is displayed" => "Si réglé sur \"y\", le nom de l'image est affiché",
"If set to \"y\", the description of the image is displayed" => "Si réglé sur \"y\", la description de l'image est affichée",
"Random Pages" => "Pages choisies au hasard",
"Displays the specified number of random wiki pages" => "Affiche le nombre spécifié de pages wiki aléatoirement choisies",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
"News Feeds" => "Flux disponibles",
"List of feeds available on this site." => "Liste des flux disponibles sur ce site.",
"Multi-purpose search module (go or edit page by name and/or search site)" => "Module de recherche multi-usages (aller ou modifier la page par son nom et / ou rechercher sur le site)",
"Legacy Mode" => "Mode hérité",
"Setting to emulate previous behaviour" => "Réglage pour émuler le comportement précédent",
"If set to \"y\" the search performed is a \"Tiki search\"" => "Si défini à \"y\" la recherche effectuée est une \"recherche Tiki\"",
" (full text search)" => " (recherche en texte intégral)",
"Show Object Type Filter" => "Afficher le filtre de type d'objet",
"If set to \"y\" shows a dropdown of sections to search" => "Si défini à \"y\" affiche une liste déroulante des sections à rechercher",
" (no object filter)" => " (pas de filtre d'objet)",
"Use autocomplete" => "Utiliser l'auto-complétion",
"If set to \"y\" input uses autocomplete for pagenames if applicable" => "Si défini à \"y\" la saisie utiliser l'auto-complétion pour les noms de page si appliquable",
" (use autocomplete)" => " (utilise l'auto-complétion)",
"Advanced search" => "Recherche avancée",
"Use advanced (boolean) search (full text search only)" => "Utiliser les fonctions avancées (booléen) de recherche (recherche en texte intégral seulement)",
" (use advanced search)" => " (utilise la recherche avancée)",
"Advanced search checkbox" => "Case à cocher recherche avancée",
"Show advanced search checkbox (full text search only)" => "Afficher la case à cocher 'Recherche avancée' (recherche en texte intégral seulement)",
" (advanced search checkbox off)" => " (case recherche avancée désactivée)",
"Advanced search help" => "Aide de la recherche avancée",
"Show advanced search help icon (full text search only)" => "Afficher l'icône d'aide pour la recherche avancée (recherche en texte intégral seulement)",
" (advanced search help off)" => " (aide à la recherche avancée désactivée)",
"Show Search Button" => "Afficher le bouton 'Recherche'",
"Show search button" => "Afficher le bouton 'Recherche'",
" (do show search button)" => " (montre le bouton 'recherche')",
"Show Go Button" => "Afficher le bouton 'Aller'",
"Show go to page button" => "Afficher le bouton 'Aller à la page'",
" (do show go button)" => " (montre le bouton « aller »)",
"Show Edit Button" => "Afficher le bouton 'Modifier'",
"Show edit button" => "Afficher le bouton 'Modifier'",
" (do show edit button)" => " (montre le bouton « modifier »)",
"Default Button" => "Bouton par défaut",
"Action to perform on entering <return>" => "Action à effectuer lorsque <entrée> est tapée",
" (search|go|edit)" => " (rechercher|exécuter|modifier)",
"Search Form Action" => "Action formulaire de recherche",
" tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php ou tiki-searchindex.php (pour la recherche Tiki)",
// "Search Submit Label" => "Search Submit Label",
"Go Form Action" => "Envoi du formulaire",
// "Go Submit Label" => "Go Submit Label",
"Go" => "OK",
"Edit Form Action" => "Action du formulaire d'édition",
"Edit Submit Label" => "Modifier l'étiquette 'Soumettre'",
"Input field width" => "Largeur du champ de saisie",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
" 0 (leave automatic width)" => "0 (laisser la largeur en automatique)",
"Select size" => "Taille du sélecteur",
"Size of the Search Filter dropdown list" => "Taille de la liste déroulante du filtre de recherche",
"Edit Template identifier" => "Modifier l'identificateur de gabarit",
"If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "Si défini comme un identificateur de catégorie, les pages créées au travers de ce module sont automaitquement rattéchées à cette catégorie",
"Compact mode" => "Mode compact",
"Makes the three buttons only appear on mouse-over" => "Fait que les trois boutons apparaissent uniquement lors du survol de souris",
// "Additional filters" => "Additional filters",
// "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test" => "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test",
"Search is disabled" => "La recherche est désactivée",
"Search for Wiki Page" => "Chercher dans les pages Wiki",
// "More Like This" => "More Like This",
// "Uses the unified search to provide similar documents" => "Uses the unified search to provide similar documents",
// "Object Type Filters" => "Object Type Filters",
// "Comma-separated types to allow" => "Comma-separated types to allow",
// "Text Search Filters" => "Text Search Filters",
// "Comma-separated text search filters to use. Use \"=\" to separate field and value" => "Comma-separated text search filters to use. Use \"=\" to separate field and value",
// "Object id of item you want to get similar items to" => "Object id of item you want to get similar items to",
// "The object id of the item. If none is provided, Tiki will attempt to resolve the current object" => "The object id of the item. If none is provided, Tiki will attempt to resolve the current object",
// "Object type of item you want to get similar items to" => "Object type of item you want to get similar items to",
// "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object" => "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object",
// "Search For a Wiki Page" => "Search For a Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
"Exact match checkbox checked by default if set to \"y\"" => "La case à cocher 'correspondance exacte' est cochée par défaut si défini à \"y\"",
"Semantic Links" => " Liens Sémantiques",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
"Links for sharing, reporting etc" => "Liens pour partager, rapporter etc",
"Report" => "Rapport",
"Report to Webmaster" => "Signaler au Webmaster",
"Share this page" => "Partager cette page",
"Use icons for report, share and email links" => "Utiliser des icônes pour rapporter, partager et envoyer par courriel",
"Show Facebook \"Like\" button on the current page" => "Afficher le bouton Facebook \"J'aime\" sur la page en cours",
"Facebook: URL" => "Facebook : URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
"Facebook: Height" => "Facebook : Hauteur",
"Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Hauteur du conteneur en unités CSS (i.e. \"120px\" ou \"2em\")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
"Facebook: Colors" => "Facebook : Couleurs",
// "Color scheme" => "Color scheme",
"Facebook: Font" => "Facebook : Police",
"Font to display" => "Police à afficher",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
"Facebook: App Id" => "Facebook : Id de l'application",
"ID of your Facebook app (optional)" => "ID de votre application Facebook (optionnel)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
"Google +1 button" => "Bouton Google +1",
// "Google: Size" => "Google: Size",
"Google button size" => "Taille du bouton Google",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "Creates or shows a short url for the visiting page" => "Creates or shows a short url for the visiting page",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent." => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent.",
"If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "Si défini à \"1\", affiche les date et heure de publication du message sous forme d'info-bulles plutôt que des les montrer directement dans le contenu du module",
"Label on the button to post a message" => "Label sur le bouton pour poster un message",
"Wait label" => "Etiquette 'Patienter'",
"Label on the button to post a message when the message is being posted if AJAX is enabled" => "Etiquette sur le bouton 'Publier' quand le message est en train d'être publié si AJAX est activé",
"Please wait.." => "Attendez, SVP",
"Maximum messages shown" => "Nombre maximum de messages affichés",
"Number of messages to display" => "Nombre de messages à afficher",
"Tweet" => "Tweet",
"If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "Si défini à \"1\" et que l'utilisateur nous a autorisé à publier des tweets avec Twitter, l'utilisateur peut décider, si il veut utiliser le mégaphone via Twiter",
"If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "Si défini à \"1\" et que l'utilisateur nous a autorisé à utiliser Facebook, l'utilisateur peut décider, si il veut ajouter l'annonce du mégaphone sur son mur Facebook",
"Since Last Visit (Simple)" => "Depuis la dernière visite (simple)",
"Displays to logged-in users the number of new or updated objects since their last login date and time" => "Affiche aux utilisateurs authentifiés le nombre d'objets nouveaux ou modifiés depuis leurs dernières connexions",
"Since your last visit" => "Depuis votre dernière visite",
"Since Last Visit" => "Depuis la dernière visite",
"Displays to logged-in users new or updated objects since a point in time, by default their last login date and time" => "Affiche aux utilisateurs authentifiés les éléments nouveaux ou modifiés depuis un certain moment, par défaut le moment de leur dernière connexion",
"Show users" => "Afficher les utilisateurs",
"If set to \"n\", do not show new users" => "Si défini à \"n\", ne pas montrer les nouveaux utilisateurs",
"If set to \"n\", do not show tracker changes" => "Si défini à  \"n\", ne pas afficher les modifications du formulaire",
"Calendar focus" => "Point de référence du calendrier",
"Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar." => "A moins d'être réglé sur \"ignore\", le module change le point de référence temporel à partir des date et heure de dernière connexion de l'utilisateur jusqu'au jour où l'utilisateur parcourt le calendrier.",
"Show date as a calendar link" => "Afficher la date en tant que lien de calendrier",
"If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)." => "Si défini à \"n\", ne pas ajouter un lien vers le calendrier tiki dans l'en-tête (même si la fonction calendrier est activée).",
"Fold sections by default" => "Replier les sections par défaut",
"If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "Si défini à \"y\", replier automatiquement les sections et montrer seulement le titre (l'utilisateur devra cliquer sur chaque section pour voir les détails ou modifications)",
// "Use tabbed presentation" => "Use tabbed presentation",
// "If set to \"y\", use Bootstrap tabs to show the result" => "If set to \"y\", use Bootstrap tabs to show the result",
"Minimum timespan" => "Intervalle de temps minimum",
"Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Au lieu du moment de la dernière connexion, revenir en arrière de ce temps minimum, spécifié en jours, dans le cas où la dernière connexion est très récente",
// "Maximum comment length" => "Maximum comment length",
"Changes since" => "Modifications depuis",
"Since your last visit..." => "Depuis votre dernière visite...",
"In the last %0 days.." => "Dans les derniers %0 jours...",
"new comments" => "nouveau(x) commentaire(s)",
" (archived)" => " (archivé(e))",
"new posts" => "nouveau(x) article(s) de forum",
"wiki pages changed" => "Page(s) Wiki modifiée(s)",
"new articles" => "nouveau(x) article(s)",
"new FAQs" => "nouvelle(s) FAQ(s)",
"new blogs" => "nouveau(x) blogue(s)",
"new blog posts" => "nouvelle(s) publication(s) de blogue",
"new image galleries" => "nouvelle(s) galerie(s) d'images",
"new images" => "nouvelle(s) image(s)",
"new file galleries" => "nouvelle(s) galerie(s) de fichiers",
"new files" => "nouveau(x) fichier(s)",
"new polls" => "nouveau(x) sondage(s)",
"new users" => "Nouveau(x) utilisateur(s)",
"new tracker items" => "nouvelle(s) fiche(s) de formulaire",
"updated tracker items" => "Fiches de formulaires mises à jour",
// "new calendars" => "new calendars",
// "new events" => "new events",
// "starting on" => "starting on",
// "If comments don't use titles this sets the maximum length for the comment snippet" => "If comments don't use titles this sets the maximum length for the comment snippet",
// "SVN Up Info" => "SVN Up Info",
"SVN Version and last update information" => "Version SVN et information de dernière mise à jour",
"Switch Language" => "Changer de langue",
"Displays a language picker to change the language of the site" => "Affiche un sélecteur de langue pour changer la lague du site",
"Display mode" => "Mode d'affichage",
"Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Modifie la façon dont la liste des langues est affichée. Les valeurs possibles sont liste déroulante (droplist), drapeaux (flags) et noms (words). Par défaut liste déroulante",
// "Switch Admin Language" => "Switch Admin Language",
// "Displays a language picker to change the language of admin site" => "Displays a language picker to change the language of admin site",
"Switch Theme" => "Changer de Thème",
// "Enables to quickly change the theme for the user" => "Enables to quickly change the theme for the user",
// "Not allowed here" => "Not allowed here",
// "Displayed theme" => "Displayed theme",
// "Admin Theme" => "Admin Theme",
"Terminology" => "Terminologie",
"Support for multilingual terminology" => "Support pour terminolgie multilingue",
"Root category" => "Catégorie racine",
"All terms will automatically be put in that category. " => "Tous les termes seront automatiquement affectés à cette catégorie.",
"Note that the category must already exist. " => "Noter que la catégorie doit déjà exister. ",
"Defaults to 'Term'" => "Par défaut 'Term'",
"Tiki Tests" => "Tests Tiki",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "Blogues les plus actifs",
"Displays the specified number of blogs with links to them, from the most active one to the least." => "Affiche un nombre déterminé de blogues hyperliés, du plus actif au moins actif.",
"Blog activity measurement can be more or less accurate." => "La mesure de l'activité du blogue peut être plus au moins précise.",
"Lists the specified number of articles with links to them, from the most visited one to the least." => "Liste le nombre demandé d'articles avec liens vers ceux-ci, du plus visité au moins visité.",
// "Top Blog Posters" => "Top Blog Posters",
// "Displays the specified number of users who posted to blogs, starting with the one having most posts" => "Displays the specified number of users who posted to blogs, starting with the one having most posts",
// "Limit to a blog" => "Limit to a blog",
"Top File Galleries" => "Galeries de fichiers les plus populaires",
"Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Affiche un nombre déterminé de gallerie de fichiers sous forme de liens, en commençant par celui qui a le plus de visites",
// "Top Files" => "Top Files",
"Displays the specified number of files with links to them, starting with the one with most hits." => "Affiche un nombre déterminé de fichiers hyperliés, en commençant avec celui ayant eu le plus d'accès.",
"Top Forum Posters" => "Publieurs de forum les plus actifs",
"Displays the specified number of users who posted to forums, starting with the one having most posts" => "Affiche un nombre spécifié d'utilisateurs qui ont publiés sur le forum, en commençant par celui qui en a publié le plus",
// "Top Image Galleries" => "Top Image Galleries",
"Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Affiche le nombre spécifié de galeries d'images avec liens vers elles, en commençant par celle ayant le plus de visites",
"Top Images" => "Images les plus populaires",
"Displays the specified number of images with links to them, from the most visited one to the least" => "Affiche le nombre spécifié de galerie d'images avec des liens vers elles, en commençant par celle qui a reçu le plus de visites",
"Top Objects" => "Objets les plus vus",
"Displays the specified number of objects, starting with the one having the most hits" => "Affiche le nombre spécifié d'objets, en commençant par celui ayant le plus de visites",
"Top Pages" => "Pages les plus populaires",
"Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Affiche un nombre spécifié de pages Wiki avec liens, en commençant par celles qui ont le plus de visites",
"Top Quizzes" => "Questions à choix multiples (QCMs) les plus populaires",
"Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Affiche un nombre spécifié de quiz avec le lien, en commençant par ceux qui ont le plus visites",
"Top Visited Blogs" => "Blogues les plus visités",
"Display the specified number of blogs with links to them, from the most visited one to the least." => "Affiche un nombre déterminé de blogues hyperliés, du plus visité au moins visité.",
"Show Last Post" => "Afficher la dernière publication",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
// "Tracker Input" => "Tracker Input",
"Allows a dialog to be opened to create new tracker items" => "Permet d'ouvrir un dialogue pour créer de nouvelles fiches de formulaire",
// "Tracker ID to render" => "Tracker ID to render",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
// "Mode change on complete" => "Mode change on complete",
// "Target mode to enter after dialog closes" => "Target mode to enter after dialog closes",
"Tracker Help" => "Assistant formulaire",
"Display the fields of a tracker (name and identifier)" => "Afficher les champs d'un formulaire (nom et identifiant)",
"Text field height" => "Hauteur du champ texte",
"Number of lines" => "Nombre de lignes",
"Text field width" => "Largeur du champ texte",
"Number of characters" => "Nombre de caractères",
"Translate Updates" => "Traduire les mises à jour",
"Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed." => "Hyperlie vers des versions de la page wiki visionnée en d'autres langues, en signalant les traductions meilleures, équivalentes ou moins bonnes. Optionnellement, affiche le niveau d'actualisation de la traduction affichée.",
"Reference language" => "Langue de référence",
"If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "Si réglé sur un code de langue, restreint les pages locales affichées à la page de référence, à moins que celle-ci soit en cours d'affichage",
"Show language" => "Afficher la langue",
"If \"y\" the page language will be shown instead of the page name" => "Si \"y\" la langue de la page sera affichée au lieu du nom de la page",
"Default = \"y\"" => "Défaut = \"y\"",
// "Tweets" => "Tweets",
// "Shows the tweets from the Twitter timeline of a user" => "Shows the tweets from the Twitter timeline of a user",
// "Tiki user to show Twitter timeline of" => "Tiki user to show Twitter timeline of",
// "Show public|friends timeline. " => "Show public|friends timeline. ",
// "Search string" => "Search string",
// "user not registered with twitter" => "user not registered with twitter",
"Lists the specified number of calendar events, ordered by their start date" => "Liste un nombre spécifié d'évènements du calendrier, trié par leurs dates de début",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "Si défini comme une liste d'identificateurs de calendriers, limite les événements à ceux des calendriers identifiés. Les identificateurs sont séparés par des barres verticales \"|\", virgules \",\" ou deux-points \":\"",
"Maximum days in the future" => "Nombre de jours maximum dans le futur",
"Maximum distance to event start dates in days (looking forward)" => "Distance maximale en jours de la date de début d'un événement (recherche en avant)",
"Maximum days in the past" => "Nombre de jours maximum dans le passé",
"Maximum distance to event end dates in days (looking backward)" => "Distance maximale en jours de la date de fin d'un événement (recherche en arrière)",
"cellpadding" => "Marge interne cellule",
"If set to an integer, apply this cellpadding to the HTML table generated" => "Si défini comme un entier, applique cette marge intérieure de cellule à la table HTML générée",
"cellspacing" => "Espacement des cellules",
"If set to an integer, apply this cellspacing to the HTML table generated" => "Si défini comme un entier, applique cet espacement de cellule à la table HTML générée",
"If set to \"y\", event descriptions are displayed" => "Si réglé sur \"y\", les descriptions d'événements sont affichées",
"Show end date and time" => "Afficher date et heure de fin",
"If set to \"y\", event end dates and times are displayed, when appropriate" => "Si réglé sur \"y\", les dates et heures de fin d'événements sont affichées, quand c'est approprié",
"Use custom calendar background colors" => "Utiliser des couleurs d'arrière-plan de calendrier personnalisées",
"If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "Si réglé sur \"y\", les événements sont affichés avec la couleur personnalisée d'arrière-plan du calendrier (si une a été choisie)",
"Show information in tooltips" => "Afficher des informations dans des infobulles",
"If set to \"n\", event tooltips will not display event information" => "Si défini à \"n\", les info-bulles d'événement n'afficheront pas d'information sur celui-ci",
"Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format à employer pour la plupart des dates. Voir <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
"site preference for short date format followed by site preference for short time format" => "préférence du site pour le format court de date suivie par la préférence du site pour le format court d'heure",
"If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "Si une valeur entière est indiquée, les noms d'événements seront tronqués au delà de ce nombre de caractères",
"My Blogs" => "Mes Blogues",
"Displays to registered users their blogs" => "Affiche aux utilisateurs enregistrés leurs blogues",
"My Bookmarks" => "Signets des utilisateurs",
"Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Interface simplifiée vers les signets utilisateur, permettant de les afficher de manière concise, de faire quelques manipulations et marquer la page en cours d'affichage",
"My Image Galleries" => "Utilisateurs de galeries d'images",
"Displays to registered users their image galleries" => "Affiche aux utilisateurs leur galeries d'images",
"User Pages" => "Mes pages",
"Displays to registered users the specified number of wiki pages which they were the last to edit" => "Affiche pour les utilisateurs enregistrés le nombre spécifié de pages wiki où ils ont été les derniers à faire des modifications",
"My Pages" => "Mes Pages",
"My Tasks" => "Tâches utilisateurs",
"Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Interface légère vers les tâches utilisateur, permetttant de les visualiser de manière concise et de faire quelques manipulations",
"The task title must have at least 3 characters" => "Le titre de la tâche doit avoir au moins 3 caractères",
"Public Tasks" => "Tâches publiques",
"Lists the public user tasks of a chosen group, with links to tasks" => "Liste les tâches publiques utilisateur d'un groupe choisi, avec liens vers ces tâches",
"User-Group Tracker" => "Formulaire Groupe d'utilisateurs",
"User and Group tracker links" => "Liens de formulaires utilisateur et groupe",
// "Users List" => "Users List",
// "Display a list of users with optional extra information from each" => "Display a list of users with optional extra information from each",
"Login" => "Login",
// "Show the user name" => "Show the user name",
"y|n" => "o|n",
// "Show the user real name" => "Show the user real name",
"Last Login" => "Dernière authentification",
// "Show the last login date" => "Show the last login date",
// "Show the direct and included groups a user belongs to" => "Show the direct and included groups a user belongs to",
// "Show the user profile picture" => "Show the user profile picture",
// "Show a link to the userPage" => "Show a link to the userPage",
// "Log" => "Log",
// "Show a link to the user logs(feature actionlog must be activated)" => "Show a link to the user logs(feature actionlog must be activated)",
// "Show only the users of the group" => "Show only the users of the group",
// "Groupname" => "Groupname",
// "Included Groups" => "Included Groups",
// "Show only the users of the group group and of a group including group" => "Show only the users of the group group and of a group including group",
// "initial" => "initial",
// "Show only the users whose name begins with the letter" => "Show only the users whose name begins with the letter",
// "a letter" => "a letter",
// "heading" => "heading",
// "Show the table heading" => "Show the table heading",
// "Sort users in ascending or descending order using these values: " => "Sort users in ascending or descending order using these values: ",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
"Most Active Users" => "Utilisateurs les plus actifs",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "websearch" => "websearch",
"Displays a simple form to perform a web search with choice on multiple search engines." => "Affiche un formulaire simple pour effectuer une recherche web avec choix sur plusieurs moteurs de recherche.",
"Related Items" => "Objets de la même catégorie",
"Lists objects which share a category with the viewed object" => "Liste les objets de même catégorie que celui affiché",
// "Online Users" => "Online Users",
// "Display information about users currently logged in" => "Display information about users currently logged in",
"Display the number of users logged in, the list of users logged in, or both" => "Afficher le nombre d'utilisateurs connectés, leur liste, ou les deux",
"Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Valeurs possibles : \"count\", \"list\" ou \"both\". Valeur par défaut : \"both\"",
// "Cluster Mode" => "Cluster Mode",
"If set to \"1\", separate users based on which host/server they logged on" => "Si défini à \"1\", séparer les utilisateurs selon le serveur sur lequel ils se sont connectés",
// "Silent Mode" => "Silent Mode",
// "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it" => "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it",
"Newest Comments" => "Derniers commentaires",
"Lists the specified number of comments starting from the most recently posted" => "Liste le nombre spécifié de commentaires en commençant par le plus récemment publié",
"More in tooltips" => "Plus dans les infobulles",
"If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "Si réglé sur \"y\", le nom de l'objet qui a reçu un commentaire n'est pas affiché dans la boîte du module, mais plutôt déplacé dans l'info-bulle de l'élément",
"Type of the objects from which comments will be listed. Possible values" => "Type des objets dont les commentaires seront listés. Valeurs possibles",
// "Display user profile pictures instead of numbers" => "Display user profile pictures instead of numbers",
// "Comments about objects in this language only" => "Comments about objects in this language only",
"Last article comments" => "Derniers commentaires d'article",
"Last wiki comments" => "Derniers commentaires Wiki",
// "Hold a chat session using XMPP (uses the ConverseJS client)" => "Hold a chat session using XMPP (uses the ConverseJS client)",
// "XMPP" => "XMPP",
"Displays YouTube videos and/or a link to a YouTube user's page" => "Affiche des vidéos YouTube et/ou un lien vers la page YouTube de l'utilisateur",
"Video identifiers" => "Identificateurs de vidéo",
"List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "Liste d'identificateurs de vidéos YouTube à afficher. Les identificateurs sont séparés par une virgule (\",\")",
"YouTube user identifier" => "Identifiant utilisateur YouTube",
"If set to a YouTube user identifier, display a link to the videos of this user" => "Si défini comme un identifiant d'utilisateur YouTube, afficher un lien vers les vidéos de cet utilisateur",
"Videos on YouTube" => "Vidéos sur YouTube",
// "Module Zone" => "Module Zone",
// "Can contain other modules so can be used as a Bootstrap navbar object, for example" => "Can contain other modules so can be used as a Bootstrap navbar object, for example",
// "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel" => "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel",
// "Example for a Bootstrap \"social\" navbar" => "Example for a Bootstrap \"social\" navbar",
"Bibliography Search" => "Recherche documentaire",
"Search the group's Zotero library for entries with the specified tags" => "Rechercher dans la bibliothèque Zotero du groupe les éléments avec les mots-clés spécifiés",
// "failure" => "failure",
// "You do not have sufficient permissions to perform this action" => "You do not have sufficient permissions to perform this action",
// "Please enter Biblio Code" => "Please enter Biblio Code",
// "Biblio code must not exceed 50 characters" => "Biblio code must not exceed 50 characters",
// "success" => "success",
// "Page not found. Please save the page first" => "Page not found. Please save the page first",
// "This reference already exists in the library" => "This reference already exists in the library",
// "Reference added to library" => "Reference added to library",
// "This biblio code already exists" => "This biblio code already exists",
// "Bibliography saved" => "Bibliography saved",
// "Reference already exists" => "Reference already exists",
// "Reference added" => "Reference added",
"Invalid server key" => "Clé du serveur invalide",
"Invalid username or password" => "Nom d'utilisateur ou mot de passe invalide",
"Cookie not found" => "Cookie non trouvé",
// "This user is your friend" => "This user is your friend",
// "You share the following groups with this user" => "You share the following groups with this user",
// "Unlike" => "Unlike",
// "There is no activity to display in this stream" => "There is no activity to display in this stream",
// "%0 %1" => "%0 %1",
// "%0 posted a comment to" => "%0 posted a comment to",
// "%0 started a new discussion" => "%0 started a new discussion",
// "Join the discussion" => "Join the discussion",
// "%0 replied to a thread" => "%0 replied to a thread",
// "%0 corrected a message" => "%0 corrected a message",
// "%0 requested an action from you" => "%0 requested an action from you",
// "%0 triggered your %1 priority saved filter" => "%0 triggered your %1 priority saved filter",
// "Critical Priority" => "Critical Priority",
// "See your saved filter" => "See your saved filter",
// "High Priority" => "High Priority",
// "Low Priority" => "Low Priority",
// "Recommended Reading" => "Recommended Reading",
// "Based on your previous activity, we believe you might find this useful" => "Based on your previous activity, we believe you might find this useful",
// "Was this useful" => "Was this useful",
// "Help us improve" => "Help us improve",
// "%0 created a tracker" => "%0 created a tracker",
// "%0 created a tracker item" => "%0 created a tracker item",
// "%0 modified a tracker item" => "%0 modified a tracker item",
// "%0 has added %1 to his stream" => "%0 has added %1 to his stream",
// "%0 is now followed by %1" => "%0 is now followed by %1",
// "%0 and %1 became friends" => "%0 and %1 became friends",
// "%0 created a page" => "%0 created a page",
// "%0 modified a page" => "%0 modified a page",
// "View changes" => "View changes",
// "history" => "history",
// "Show More" => "Show More",
"Saving..." => "Enregistrement..",
// "Adding.." => "Adding..",
// "References Available" => "References Available",
// "Add to library" => "Add to library",
// "Library References" => "Library References",
"Use" => "Utilisation",
// "Edit Library References" => "Edit Library References",
"Part" => "Partie",
// "URI" => "URI",
// "Publisher" => "Publisher",
// "Enter the CSS class name to be added in the 'li' tag for listing this reference" => "Enter the CSS class name to be added in the 'li' tag for listing this reference",
// "Enter template format in which you want to display the reference details in the bibliography listing. For example" => "Enter template format in which you want to display the reference details in the bibliography listing. For example",
// "All the codes must be in lower case letters separated with spaces" => "All the codes must be in lower case letters separated with spaces",
// "Please save the page before creating the bibliography" => "Please save the page before creating the bibliography",
"Preference Filters" => "Filtres des préférences",
// "basic" => "basic",
"Set as my default" => "Définir comme mes valeurs par défaut",
// "Provide Feedback" => "Provide Feedback",
// "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them" => "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them",
// "Icon for 'Like'" => "Icon for 'Like'",
// "Icon for 'Fix me'" => "Icon for 'Fix me'",
// "Icon for 'What is this for?'" => "Icon for 'What is this for?'",
// "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)" => "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)",
// "Click to read more" => "Click to read more",
"Rebuild Admin Index" => "Reconstruire l'index d'administration",
"Control Panels" => "Panneaux de configuration",
// "Search preferences" => "Search preferences",
"Configuration search" => "Recherche d'options de configuration",
"Note: The search index needs rebuilding, this will take a few minutes" => "Note : L'index de recherche a besoin d'être reconstruit. Cela prendra quelques minutes",
// "Preference Search Results" => "Preference Search Results",
// "Apply Changes" => "Apply Changes",
"Apply" => "Appliquer",
"No results" => "Pas de résultat",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Not what you expected? Try %0rebuilding%1 the preferences search index" => "Not what you expected? Try %0rebuilding%1 the preferences search index",
"Access" => "Accès",
"Users" => "Utilisateurs",
// "Banning" => "Banning",
"Directories" => "Répertoires",
"External Feeds" => "Flux RSS externes",
"HTML Pages" => "Pages HTML",
// "Wiki Structures" => "Wiki Structures",
"System" => "Système",
"Activity Rules" => "Règles d'activités",
"Content Templates" => "Gabarits de contenu",
"Languages" => "Langues",
"Mail Notifications" => "Notifications par courriel",
"Menus" => "Menus",
// "User Credits" => "User Credits",
"Transitions" => "Transitions",
"Plugin Approval" => "Approbation de plugiciel",
"Mods" => "Mods",
"Tools" => "Outils",
"Action Log" => "Journal des actions",
"Cookies" => "Témoins",
// "DSN/Content Authentication" => "DSN/Content Authentication",
// "Edit TPL" => "Edit TPL",
"External Pages Cache" => "Cache de pages externes",
"External Wikis" => "Wikis externes",
// "Importer" => "Importer",
// "PhpInfo" => "PhpInfo",
// "Referer Statistics" => "Referer Statistics",
// "Search Statistics" => "Search Statistics",
"Security Admin" => "Administrer la sécurité",
"Server Check" => "Verification Serveur",
// "Synchronize Dev" => "Synchronize Dev",
// "System Cache" => "System Cache",
// "System Logs" => "System Logs",
// "Sitemap" => "Sitemap",
"Wizards" => "Assistants",
"Cancel Edit" => "Annuler la modification",
// "Banners listing" => "Banners listing",
"Activate the feature" => "Activer la fonctionnalité",
// "Site ads and banners" => "Site ads and banners",
// "Apply changes" => "Apply changes",
// "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>" => "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>",
// "List of articles" => "List of articles",
// "List of article types" => "List of article types",
"Article Types" => "Type d'articles",
// "List of article topics" => "List of article topics",
"General Settings" => "Réglages généraux",
"Features" => "Fonctionnalités",
// "Custom (Article Own) images setting" => "Custom (Article Own) images setting",
"Sharing on social networks" => "Partager sur des réseaux sociaux",
"Import CSV file" => "Importer un fichier CSV",
"Batch upload (CSV file)" => "Chargement par lot (fichier CSV)",
"File format: title,authorName,heading,body,lang,user" => "Format du fichier : titre,NomAuteur,en-tête,corps,langue,utilisateur",
// "Articles Listing and View" => "Articles Listing and View",
"List articles" => "Liste des articles",
// "Article view" => "Article view",
// "Blogs listing" => "Blogs listing",
"Blogs Listings" => "Liste des Blogues",
// "Items to display" => "Items to display",
// "Calendars listing" => "Calendars listing",
"General settings" => "Paramètres généraux",
// "Categories listing" => "Categories listing",
// "Browse Categories" => "Browse Categories",
// "Administer Categories" => "Administer Categories",
// "Organize objects" => "Organize objects",
"Organize Objects" => "Organiser les objets",
"Category objects" => "Objets de la catégorie",
// "Re-apply last saved category defaults to wiki pages" => "Re-apply last saved category defaults to wiki pages",
"Performance" => "Performances",
// "Comments listing" => "Comments listing",
"Site-wide features" => "Les fonctionnalités pour tout le site",
"Display options" => "Options d'affichage",
// "Annotations" => "Annotations",
"Using comments in various features" => "Utilisation des commentaires dans diverses fonctionnalités",
// "Group Administration" => "Group Administration",
// "User Administration" => "User Administration",
// "Community Features" => "Community Features",
"Community" => "Communauté",
// "Additional options" => "Additional options",
// "Social Interaction" => "Social Interaction",
// "Friendship and followers" => "Friendship and followers",
"Select which items to display when listing users" => "Sélectionner les informations utilisateurs à afficher lors du listing",
// "Activity stream" => "Activity stream",
"Tiki Connect" => "Tiki Connect",
"Join the community!" => "Rejoignez la communauté !",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU." => "Tiki Wiki CMS Groupware est un logiciel libre et ouvert (FOSS). C'est un projet porté par une communauté, qui existe et s'améliore grâce à la participation de gens comme VOUS.",
// "Join the Community" => "Join the Community",
// "Tiki news" => "Tiki news",
// "Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded RSS feed from info.tiki.org TODO, meanwhile",
"Tiki Newsletter" => "Lettre de nouvelles Tiki",
"Promote your site" => "Promouvoir votre site",
"Add your site to the Tiki directory." => "Ajouter votre site au répertoire Tiki",
// "Submit your site" => "Submit your site",
// "Spread the word" => "Spread the word",
"Add the \"Powered by\" module to your site. " => "Ajouter le module \"Powered by\" à votre site",
// "Manage Modules" => "Manage Modules",
"Help improve Tiki" => "Aider à améliorer Tiki",
// "Submit a feature request or bug report" => "Submit a feature request or bug report",
// "Visit Tiki development site" => "Visit Tiki development site",
// "Make a financial contribution to the Tiki Association" => "Make a financial contribution to the Tiki Association",
"Contribute to Tiki" => "Contribuer à Tiki",
"New Feature" => "Nouvelle fonctionnalité",
// "Please note: Experimental - work in progress" => "Please note: Experimental - work in progress",
// "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)",
// "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)" => "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)",
// "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'" => "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'",
// "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)" => "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)",
// "Send Info" => "Send Info",
// "Send the data" => "Send the data",
// "Preview info" => "Preview info",
// "See what is going to be sent" => "See what is going to be sent",
// "Fill form" => "Fill form",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
"Advanced settings" => "Réglages avancés",
// "Exposed to assist testing and development" => "Exposed to assist testing and development",
// "Connections Received" => "Connections Received",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Jitsi" => "Jitsi",
// "Provision URL" => "Provision URL",
// "Allows a copyright to be determined for various objects" => "Allows a copyright to be determined for various objects",
// "Directories listing" => "Directories listing",
// "Extention package error" => "Extention package error",
// "Cannot show page because the extension package is not installed or activated" => "Cannot show page because the extension package is not installed or activated",
// "Extension package admin template page is missing" => "Extension package admin template page is missing",
// "FAQ listing" => "FAQ listing",
// "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
"Global features" => "Fonctionnalités globales",
// "Main features" => "Main features",
// "Secondary features" => "Secondary features",
// "Administrative features" => "Administrative features",
"Watches" => "Surveillances",
// "Additional features" => "Additional features",
// "Payment and Accounting" => "Payment and Accounting",
// "Mail and Sharing" => "Mail and Sharing",
"Interaction with online services or other software" => "Interaction avec des services en ligne ou autre logiciel",
"Configuration completed" => "Configuration achevée",
"Authenticate with Zotero" => "Authentifier avec Zotero",
"Interface" => "Interface",
"jQuery plugins and add-ons" => "Plugiciels et modules supplémentaires jQuery",
"Programmer" => "Codeur",
"Logging and Reporting" => "Journaux et rapports",
"Visible to admin only" => "Uniquement visible par les administrateurs",
"Include Smarty notices" => "Inclure les avertissements Smarty",
"Custom Code" => "Code personnalisé",
"To create or remove file galleries, select" => "Pour créer ou supprimer une galerie de fichier, sélectionner",
"from the application menu" => "dans le menu des applications",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si vous décidez d'archiver les fichiers dans un répertoire vous devez vous assurez que les utilisateurs ne peuvent accéder directement au répertoire.",
// "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Pour configurer le chemin du répertoire, utiliser la syntaxe UN*X, comme par exemple : fichiers/ ou c:/foo/fichiers ou /www/fichiers/",
// "File galleries listing" => "File galleries listing",
"Move files from database to directory" => "Déplacer les fichiers de la base de données vers le système de fichiers",
"Move files from directory to database" => "Déplacer les fichiers du système de fichiers vers la base de données",
"Manage comment settings" => "Configuration des commentaires",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
"Upload Regex" => "Patron du téléchargement",
// "Settings for Media Alchemyst" => "Settings for Media Alchemyst",
// "Settings for Diagrams" => "Settings for Diagrams",
// "Listings" => "Listings",
// "Configuration for gallery listings" => "Configuration for gallery listings",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "L'application de ces changements <em>n'affectera pas </em> les galeries existantes. Ils n'affectent que les nouvelles galeries",
// "Admin Listings" => "Admin Listings",
// "Configuration for gallery administration listings" => "Configuration for gallery administration listings",
"Search Indexing" => "Indexed de recherche",
"Handlers" => "Gestionnaires",
"Add custom handlers to make your files &quot;searchable&quot; content" => "Ajouter des gestionnaires personnalisés pour que vos fichiers soient \"recherchables\" par le contenu",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Utiliser %1 pour indiquer le nom du fichier interne dans la commande (exemple: \"strings %1\" pour convertir le fichier en texte en utilisant la commande UNIX strings)",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "Pour supprimer un gestionnaire, laisser la <strong>commande système</strong> vide",
"Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki est pré-configuré pour gérer beaucoup de types. Si un de ceux-là est listé, c'est que l'utilitaire n'est pas disponible",
"Missing Handlers" => "Gestionnaire(s) manquant(s)",
// "Mime Types" => "Mime Types",
// "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly" => "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly",
// "Fix vnd.ms-* mime type files" => "Fix vnd.ms-* mime type files",
"MIME Type" => "Type MIME",
"System Command" => "Commande système",
"Reindex all files for search" => "Ré-indexe tous les fichiers pour la recherche",
// "Enhancements" => "Enhancements",
// "H5P Info" => "H5P Info",
// "Service URL to purge unused libraries can be found here. Can be used in a cron task" => "Service URL to purge unused libraries can be found here. Can be used in a cron task",
// "SCORM" => "SCORM",
// "OCR Indexing" => "OCR Indexing",
// "Forums listing" => "Forums listing",
// "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums" => "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums",
"Threads" => "Fils de discussion",
"Searches" => "Recherches",
// "Forum Listing" => "Forum Listing",
// "Tags listing" => "Tags listing",
// "Browse Tags" => "Browse Tags",
"Translate tags" => "Traduire les mots-clés",
// "Translate Tags" => "Translate Tags",
// "Remove tags not applied to any objects" => "Remove tags not applied to any objects",
// "Clean Up Unused Tags" => "Clean Up Unused Tags",
"Random tag cloud colors:" => "Couleurs des mots-clés du nuage choisies au hasard :",
"Separate colors with a comma (,)" => "Séparer les couleurs avec une virgule (,)",
"Alphanumeric ASCII characters only" => "Caractères alphanumériques ASCII uniqement",
"No accents or special characters" => "Pas d'accents ou caractères spéciaux",
"Accept all characters" => "Accepter tous les caractères",
// "Tag search page" => "Tag search page",
// "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Pour créer/supprimer une galerie d'images, allez dans \"Galeries d'images\" dans le menu application, ou",
"Click Here" => "Cliquer ici",
"You can upload images of a size of " => "Vous pouvez envoyer des images d'une taille de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Modifier les variables dans php.ini : file_uploads, upload_max_filesize, post_max_size et les variables de base de données (max_allowed_packet pour mysql) pour changer cette valeur",
"Galleries features" => "Fonctionnalités des galeries",
"Gallery listing configuration" => "Configuration de l'affichage des galeries",
"Comments settings" => "Configuration des commentaires",
// "Manage images" => "Manage images",
// "Remove unused images" => "Remove unused images",
// "Remove unused images in the system gallery" => "Remove unused images in the system gallery",
// "Remove images not being used in wiki pages, articles or blog posts" => "Remove images not being used in wiki pages, articles or blog posts",
"Move images from database storage to filesystem storage" => "Déplacer les images de la base de données vers le filesystem",
"Move images from filesystem storage to database storage" => "Déplacer les images du filesystem vers la base de données",
// "Move images" => "Move images",
"All galleries" => "Toutes les galeries",
"System Gallery" => "Galerie système",
"Reset or upgrade your database" => "Réinitialiser ou mettre à jour votre base de données",
// "Create and edit menus" => "Create and edit menus",
"Server Fitness" => "Santé du serveur",
// "Check if your server meets the requirements for running Tiki" => "Check if your server meets the requirements for running Tiki",
// "Check for Updates Now" => "Check for Updates Now",
// "Check if a new Tiki version is available" => "Check if a new Tiki version is available",
"General Preferences" => "Préférences générales",
// "Release check" => "Release check",
// "Tiki version" => "Tiki version",
"Last update from SVN" => "Dernière mise à jour depuis SVN",
// "Site identity" => "Site identity",
// "Themes" => "Themes",
// "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences" => "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences",
"These values will be stored in plain text in the database" => "Ces valeurs seront enregistrées en texte clair dans la base de données",
"Email to send a test mail" => "Courriel pour l'envoi d'un test",
// "Logging and reporting" => "Logging and reporting",
// "Web Cron" => "Web Cron",
// "Call Web Cron URL" => "Call Web Cron URL",
// "Scheduler Settings" => "Scheduler Settings",
"Server" => "Serveur",
"Sessions" => "Sessions",
// "Advanced configuration" => "Advanced configuration",
"Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Le stockage des sessions en base de données est une option d'administration avancée et est réservée aux administrateurs ayant un accès intégral et une bonne compréhension de la base de données de façon à pouvoir régler les problèmes éventuels",
"Changing this feature will immediately log you out when you save this preference" => "Changer cette fonctionnalité va vous délogguer immédiatement après l'enregistrement",
"Enable now" => "Activer maintenant",
"Contact" => "Contact",
// "Terms and conditions" => "Terms and conditions",
// "Home page" => "Home page",
"Redirects" => "Redirections",
// "Site access" => "Site access",
// "Test site closed message" => "Test site closed message",
// "The namespace separator should not" => "The namespace separator should not",
// "contain any of the characters not allowed in wiki page names, typically" => "contain any of the characters not allowed in wiki page names, typically",
// "conflict with wiki syntax tagging" => "conflict with wiki syntax tagging",
// "To use :: as a separator, you should also use ::: as the wiki center tag syntax" => "To use :: as a separator, you should also use ::: as the wiki center tag syntax",
// "Note: a conversion of :: to ::: for existing pages must be done manually" => "Note: a conversion of :: to ::: for existing pages must be done manually",
// "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
// "php.net" => "php.net",
"Date and Time Format Help" => "Aide sur le format des dates et heures",
// "Time zone and format" => "Time zone and format",
// "Date/time selectors" => "Date/time selectors",
"Manage customized local string translations" => "Gérer les traductions de chaînes locales personnalisées",
"Upload a file with translations for the selected language" => "Télécharger un fichier avec des traductions pour la langue sélectionnée",
"Edit languages" => "Modifier les langues",
// "Intertiki Client" => "Intertiki Client",
// "Set up this Tiki site as the Intertiki client" => "Set up this Tiki site as the Intertiki client",
// "Client server settings" => "Client server settings",
// "Currently linked master server" => "Currently linked master server",
// "Add an available master server" => "Add an available master server",
// "The InterTiki Server fields are for defining for every master server you want to have access to from this client" => "The InterTiki Server fields are for defining for every master server you want to have access to from this client",
// "Server name" => "Server name",
// "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value" => "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value",
// "Server host" => "Server host",
// "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above" => "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above",
// "Server port" => "Server port",
// "The port number the master tiki responds to HTTP on (usually 80)" => "The port number the master tiki responds to HTTP on (usually 80)",
// "Server path" => "Server path",
// "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field" => "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field",
// "Server groups" => "Server groups",
// "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)" => "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)",
// "Available master Tiki servers" => "Available master Tiki servers",
// "Delete master server" => "Delete master server",
// "Intertiki Master Server" => "Intertiki Master Server",
// "Set up this Tiki site as the InterTiki master server" => "Set up this Tiki site as the InterTiki master server",
// "Master server settings" => "Master server settings",
// "Allowed client servers" => "Allowed client servers",
// "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)" => "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)",
// "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key" => "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key",
"IP" => "I.P.",
// "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1" => "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1",
// "Username of primary contact on client machine. Useful for adminstration" => "Username of primary contact on client machine. Useful for adminstration",
// "Can register" => "Can register",
// "To change the host key you need to remove and add it as a new one" => "To change the host key you need to remove and add it as a new one",
"New" => "Nouveau",
"Enable/disable Tiki features in " => "Activez/désactivez les fonctionnalités Tiki dans ",
", but configure them elsewhere" => ", mais configurez les dans leurs pages associées",
// "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})" => "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})",
// "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples" => "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples",
"Registration" => "Enregistrement",
"Log in" => "Connexion",
"Generate a passcode" => "Générer un code d'enregistrement",
"Requires PHP GD library" => "Nécessite la bibliothèque PHP GD",
// "Group and tracker login settings" => "Group and tracker login settings",
"Users can select a group to join at registration" => "Les utilisateurs peuvent sélectionner un groupe à rejoindre lors de l'enregistrement",
"By default, new users automatically join the Registered group" => "Par défaut, les nouveaux utilisateurs rejoignent le groupe \"Registered\"",
"Other login settings" => "Autres paramètres de connexion",
"Cookie consent" => "Consentement des cookies",
"Assign users to groups by matching email patterns" => "Affecter des utilisateurs à des groupes en faisant correspondre les modèles de messagerie",
"An email pattern must be defined in the settings for at least one group for this to produce any results." => "Un modèle de courrier électronique doit être défini dans les paramètres d'au moins un groupe pour que cela produise des résultats.",
// "Remote Tiki Autologin" => "Remote Tiki Autologin",
// "You must install PHP extension LDAP" => "You must install PHP extension LDAP",
"You must change the Authentication Method to LDAP for these changes to take effect" => "Vous devez changer la méthode d'authentification en LDAP pour que les options ci-dessous soient exploitées",
// "LDAP bind settings" => "LDAP bind settings",
// "LDAP user" => "LDAP user",
// "LDAP admin" => "LDAP admin",
"LDAP external groups" => "LDAP Groupes externes",
// "LDAP group" => "LDAP group",
// "LDAP group member - if group membership can be found in group attributes" => "LDAP group member - if group membership can be found in group attributes",
// "LDAP user group - if group membership can be found in user attributes" => "LDAP user group - if group membership can be found in user attributes",
"PAM" => "PAM",
"You must change the Authentication Method to PAM for these changes to take effect" => "Vous devez changer la méthode d'authentification en PAM pour que les options ci-dessous soient exploitées",
"Shibboleth Authentication " => " Authentification Shibboleth ",
"You must change the Authentication Method to Shibboleth for these changes to take effect" => "Vous devez changer la méthode d'authentification en Shibboleth pour que les options ci-dessous soient exploitées",
// "SAML2" => "SAML2",
// "based on Onelogin's php-saml " => "based on Onelogin's php-saml ",
// "You must change the Authentication Method to SAML for these changes to take effect" => "You must change the Authentication Method to SAML for these changes to take effect",
// "Identity provider settings" => "Identity provider settings",
// "Attribute mapping" => "Attribute mapping",
// "Group mapping" => "Group mapping",
"CAS" => "CAS",
// "CAS (central authentication service)" => "CAS (central authentication service)",
"You must change the Authentication Method to CAS for these changes to take effect" => "Vous devez changer la méthode d'authentification en CAS pour que les options ci-dessous soient exploitées",
// "CAS server" => "CAS server",
"CAS Server Name" => "Nom du serveur CAS",
"CAS Server Port" => "Port du serveur CAS",
"CAS Server Path" => "Chemin du serveur CAS",
"phpBB User Database Authentication " => "Authentification utilisateur base de données phpBB ",
"You must change the Authentication Method to phpBB for these changes to take effect" => "Vous devez changer la méthode d'authentification en phpBB pour que les options ci-dessous soient exploitées",
"You must turn Users can register off for phpBB Authentication to function properly" => "Vous devez désactiver 'Les utilisateurs peuvent s'enregistrer' pour que l'authentification phpBB fonctionne correctement",
"MySql only (for now)" => "MySql seulement (pour le moment)",
// "Web server" => "Web server",
"Web Server Authentication " => "Authentification du serveur Web ",
"You must change the Authentication Method to Web Server for these changes to take effect" => "Vous devez changer la méthode d'authentification en Serveur WEB pour que les options ci-dessous soient exploitées",
// "Password Blacklist" => "Password Blacklist",
// "Password blacklist tools" => "Password blacklist tools",
// "Upload Word List for Processing" => "Upload Word List for Processing",
// "Words currently indexed" => "Words currently indexed",
// "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below" => "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below",
// "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file" => "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file",
// "Use 'LOAD DATA INFILE'" => "Use 'LOAD DATA INFILE'",
// "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions" => "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions",
// "Create or Replace Word Index" => "Create or Replace Word Index",
// "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first" => "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first",
// "Delete Temporary Index" => "Delete Temporary Index",
// "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete" => "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete",
// "Blacklist Currently Using" => "Blacklist Currently Using",
// "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future" => "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future",
// "Number of passwords (limit)" => "Number of passwords (limit)",
// "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396" => "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396",
// "Minimum Password Length" => "Minimum Password Length",
// "The minimum password length for your password. This will filter out any password that has an illegal length" => "The minimum password length for your password. This will filter out any password that has an illegal length",
// "Require Numbers &amp; Letters" => "Require Numbers &amp; Letters",
// "If checked, will filter out any password that does not have both upper and lower case letters" => "If checked, will filter out any password that does not have both upper and lower case letters",
// "Require Special Characters" => "Require Special Characters",
// "If checked, will filter out any passwords that do not have special characters" => "If checked, will filter out any passwords that do not have special characters",
// "Save & Set as Default" => "Save & Set as Default",
// "View Password List" => "View Password List",
// "OAuth Server Settings" => "OAuth Server Settings",
// "Main theme" => "Main theme",
"Theme Screenshot" => "Copie d'écran de thème",
// "Theme Preferences" => "Theme Preferences",
// "{{\$theme|escape|ucfirst}}" => "{{\$theme|escape|ucfirst}}",
// "No theme preferences found" => "No theme preferences found",
// "General layout" => "General layout",
// "Admin pages layout" => "Admin pages layout",
// "Admin theme must be selected first" => "Admin theme must be selected first",
// "Fixed vs full width layout" => "Fixed vs full width layout",
// "Logo and Title" => "Logo and Title",
// "Module zone visibility" => "Module zone visibility",
// "Site report bar" => "Site report bar",
// "Limits" => "Limits",
"UI Effects" => "Effets de l'IU",
"Standard UI effects" => "Effets standards de l'interface utilisateur",
"Tab UI effects" => "Effets des onglets",
"Customization" => "Personnalisation",
// "Custom codes" => "Custom codes",
"Editing" => "Édition",
"View Templates" => "Voir les gabarits",
"Edit Templates" => "Modifier les gabarits",
"Miscellaneous" => "Divers",
// "Responsive images" => "Responsive images",
// "Context menus" => "Context menus",
// "currently used in file galleries only" => "currently used in file galleries only",
"Separators" => "Séparateur",
// "Smarty templates (TPL files)" => "Smarty templates (TPL files)",
"Defaults" => "Défauts",
"See also" => "Voir aussi",
"Search Engine Friendly URLs" => "URLs courts",
// "Also" => "Also",
// "here" => "here",
// "for more information on geo tagging" => "for more information on geo tagging",
"Meta tags" => "Méta-tags",
// "Geo Metatags" => "Geo Metatags",
"Robots" => "Robots",
"&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site." => "\"Modules\" sont des éléments de contenu en haut & en bas et à droite & colonnes de gauche du site.",
"Admin &gt; Modules" => "Administrer > Modules",
"from the menu to create and edit modules" => "à partir du menu pour créer et modifier les modules",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
"Hint" => "Astuce",
"If you lose your login module, use tiki-login_scr.php to be able to login!" => "Si vous perdez votre module 'login' utiliser tiki-login_scr.php pour pouvoir vous connecter !",
// "Composer not found" => "Composer not found",
// "Composer could not be executed, so the automated check on the packages cannot be performed" => "Composer could not be executed, so the automated check on the packages cannot be performed",
// "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer" => "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer",
// "Result of executing the changes to the packages" => "Result of executing the changes to the packages",
// "Composer errors" => "Composer errors",
// "Composer returned some errors" => "Composer returned some errors",
// "Issues with composer environment" => "Issues with composer environment",
// "Run %0 from a shell to try to fix this, see %1 for more info" => "Run %0 from a shell to try to fix this, see %1 for more info",
// "Packages" => "Packages",
// "Packages check could not be performed at the moment due to missing" => "Packages check could not be performed at the moment due to missing",
// "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow" => "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow",
// "Installed Packages" => "Installed Packages",
// "Status of the packages registered in the composer.json file" => "Status of the packages registered in the composer.json file",
// "Version Required" => "Version Required",
// "Version Installed" => "Version Installed",
// "Installed" => "Installed",
// "Missing" => "Missing",
// "Enable extension" => "Enable extension",
// "Update extension" => "Update extension",
// "Disable extension" => "Disable extension",
// "Removal not available" => "Removal not available",
// "This package is not managed by Tiki and likely was installed manually" => "This package is not managed by Tiki and likely was installed manually",
// "One or more packages appear to be missing" => "One or more packages appear to be missing",
// "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed" => "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed",
// "Could not validate the status of one or more packages" => "Could not validate the status of one or more packages",
// "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually" => "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually",
// "Install packages from the administrator interface" => "Install packages from the administrator interface",
// "The administrator interface can be used to install the packages marked as missing in the list above" => "The administrator interface can be used to install the packages marked as missing in the list above",
// "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them" => "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them",
// "Fix Missing Packages" => "Fix Missing Packages",
// "Install packages manually" => "Install packages manually",
// "Make sure <code>composer</code> is installed" => "Make sure <code>composer</code> is installed",
// "Composer can be installed manually, in the host machine, by following the instructions from the" => "Composer can be installed manually, in the host machine, by following the instructions from the",
// "website" => "website",
// "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>" => "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>",
// "Below is an example of how to do this in a Linux-like operating system" => "Below is an example of how to do this in a Linux-like operating system",
// "Install the missing packages" => "Install the missing packages",
// "You can install the missing packages by issuing the command" => "You can install the missing packages by issuing the command",
// "Available Packages" => "Available Packages",
// "These packages have been identified as required by one or more features" => "These packages have been identified as required by one or more features",
// "Licence" => "Licence",
// "Required by" => "Required by",
// "Not Available" => "Not Available",
"Install" => "Installer",
// "There appear to be some optional packages that can be installed" => "There appear to be some optional packages that can be installed",
// "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package" => "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package",
// "The administrator interface can be used to install the optional packages in the list above" => "The administrator interface can be used to install the optional packages in the list above",
// "Click the \"Install Package\" button, and Tiki will try to install them" => "Click the \"Install Package\" button, and Tiki will try to install them",
// "Make sure there is a <code>composer.json</code> file in the root of the website" => "Make sure there is a <code>composer.json</code> file in the root of the website",
// "If there is not already a <code>composer.json</code> file, then create one" => "If there is not already a <code>composer.json</code> file, then create one",
// "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point" => "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point",
// "Install the package" => "Install the package",
// "Packages can be installed by issuing a command" => "Packages can be installed by issuing a command",
// "for each package that is to be installed" => "for each package that is to be installed",
// "Packages Custom" => "Packages Custom",
// "There are no manual managed packages installed in the folder vendor_custom" => "There are no manual managed packages installed in the folder vendor_custom",
// "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages" => "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages",
// "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab" => "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab",
// "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>" => "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>",
// "For information only" => "For information only",
// "These packages are managed manually and displayed here for informational purposes" => "These packages are managed manually and displayed here for informational purposes",
// "Packages Bundled" => "Packages Bundled",
// "These packages are bundled with Tiki, and displayed here for informational purposes" => "These packages are bundled with Tiki, and displayed here for informational purposes",
// "Composer Packages Bundled" => "Composer Packages Bundled",
// "status of the packages registered in the vendor_bundled/composer.json file" => "status of the packages registered in the vendor_bundled/composer.json file",
// "Diagnose" => "Diagnose",
// "Diagnose Composer Installation" => "Diagnose Composer Installation",
// "Use the button below to test your composer installation" => "Use the button below to test your composer installation",
// "Diagnose Composer" => "Diagnose Composer",
// "Composer management" => "Composer management",
// "Install Composer" => "Install Composer",
// "Update Composer" => "Update Composer",
// "Remove composer.lock" => "Remove composer.lock",
// "Clean vendor folder" => "Clean vendor folder",
// "{\$diagnostic_composer_location}" => "{\$diagnostic_composer_location}",
// "Extensions Preferences" => "Extensions Preferences",
// "Activate Extension Package" => "Activate Extension Package",
// "Extension Package Groups API" => "Extension Package Groups API",
"Payments" => "Payements",
"Choose payment system" => "Choisir un modèle de payement",
"You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "Vous ne pouvez utiliser qu'une seule méthode de paiement : PayPal ou Cclite ou Crédits Utilisateur Tiki",
"PayPal is working at the moment. See PayPal.com" => "PayPal est occupé à cet instant. Voir le site PayPal.com",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Comptabilité monétaire communautaire pour les systèmes d'échanges commerciaux locaux (LETS). Voir ",
// "sourceforge.net" => "sourceforge.net",
"Tiki User Credits: Requires this other feature to be configured" => "Crédits Utilisateur Tiki : Cette autre fonctionnalité doit être configurée",
// "Israel Post payment module" => "Israel Post payment module",
"Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite permet de créer et gérer des monnaies d'échange alternatives ou complémentaires et groupes",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
"Advanced Shopping Cart" => "Panier d'achat mode avancé",
// "Cart settings" => "Cart settings",
// "Advanced cart tracker names setup" => "Advanced cart tracker names setup",
// "Products tracker setup" => "Products tracker setup",
"Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Selon la fonctionnalité que vous utilisez, vous devrez définir quelques-uns ou tous les champs suivants",
// "Shipping" => "Shipping",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Output compression is active" => "La compression des pages est activée",
"Compression is handled by" => "La compression est gérée par",
// "PHP settings" => "PHP settings",
// "Some PHP.INI settings that can increase performance" => "Some PHP.INI settings that can increase performance",
// "'realpath_cache_size setting': %0" => "'realpath_cache_size setting': %0",
// "(percentage used %0 %" => "(percentage used %0 %",
// "Determines the size of the realpath cache to be used by PHP" => "Determines the size of the realpath cache to be used by PHP",
// "'realpath_cache_ttl setting': %0 seconds" => "'realpath_cache_ttl setting': %0 seconds",
// "Duration of time (in seconds) for which to cache realpath information for a given file or directory" => "Duration of time (in seconds) for which to cache realpath information for a given file or directory",
"Bytecode Cache" => "Cache pour bytecode",
// "Using <strong>%0</strong>. These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>. These stats affect all PHP applications running on the server",
"Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "L'option de configuration <em>xcache.admin.enable_auth</em> empêche l'accès aux statistiques. Cela empêchera aussi le réinitialisation du cache lors de la réinitialisation des templates",
// "Memory Used" => "Memory Used",
"Cache Hits" => "Accès au cache",
// "Misses" => "Misses",
"Few hits recorded. Statistics may not be representative" => "Peu d'accès au cache enregistrés, les statistiques ne sont peut-être pas représentatives",
"Low hit ratio. %0 may be misconfigured and not used" => "Le ratio d'accès au cache est faible. %0 est peut-être mal configuré ou désactivé",
"Little memory available. Thrashing likely to occur" => "Peu de mémoire disponible. L'éviction rapide du cache est susceptible de se produire",
// "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)" => "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)",
"Small amount of memory allocated to %0. Verify the configuration" => "Peu de mémoire est allouée à %0. Vérifiez sa configuration",
"Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "La configuration de <em>%0</em> est active. La désactivation des vérifications de modifications peut améliorer les performances, mais il sera nécessaire de purger manuellement les caches lors de la mise à jour des fichiers",
"<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> ne devrait pas être désactivé à cause de l'authentification",
// "Clear all APC caches" => "Clear all APC caches",
// "Clear APC caches" => "Clear APC caches",
// "Clear Caches" => "Clear Caches",
// "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments",
// "Major Slowdown" => "Major Slowdown",
"Major slowdown" => "Ralentissements majeurs",
"These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "Ces fonctionnalités peuvent ralentir significativement Tiki. Si vous avez un site à fort traffic, vous pouvez vouloir les désactiver.",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>",
// "Time and Memory Limits" => "Time and Memory Limits",
// "PDF settings" => "PDF settings",
// "Wiki print version" => "Wiki print version",
// "Other features" => "Other features",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Quelques uns de vos dépôts de profils ne répondent pas. Ceci pourrait empêcher d'appliquer certains profils",
// "Find profiles" => "Find profiles",
// "Search by name, types and repository" => "Search by name, types and repository",
// "Profile types" => "Profile types",
"Profile repository" => "dépôt des profils",
// "Suggested Profiles" => "Suggested Profiles",
// "Featured Site Profiles" => "Featured Site Profiles",
// "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
"Full Profiles" => "Profils complets",
"Full Profiles are full featured out of the box solutions." => "Les profils complets sont des solutions clés en mains aux nombreuses fonctionnalités.",
"Mini Profiles" => "Profils minimums",
"Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration." => "Les profils minimums vont configurer des fonctionnalités spécifiques et sont une excellente voie pour enrichir une  configuration existante.",
"Learning Profiles" => "Profils d'apprentissage",
"Learning Profiles will allow you to quickly evaluate specific features in Tiki." => "Les profils d'apprentissage permettent d'évaluer rapidement des fonctionnalités particulières dans Tiki.",
// "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>" => "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>",
"Repository" => "dépôt",
// "Profile type" => "Profile type",
// "See profile info below (may take a few seconds to load)" => "See profile info below (may take a few seconds to load)",
"applied" => "appliquer",
"JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript doit être positionné sur <b>ON</b> pour pouvoir appliquer les Profils. Merci d'activer JavaScript et de réessayer ensuite",
"Export YAML" => "Exporter en YAML",
"Export modified preferences as YAML" => "Exporter les préférences modifiées en YAML",
// "Toggle Visible" => "Toggle Visible",
"Show added preferences" => "Afficher les préférences ajoutées",
"no default" => "pas de valeur par défaut",
// "Repository status" => "Repository status",
// "status of the registered profile repositories" => "status of the registered profile repositories",
"Refresh" => "Actualiser",
"Profile tester" => "Testeur de profil",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
"This will run the profile and make potentially unrecoverable changes in your database" => "Ceci va exécuter le profil et rendre potentiellement irrécupérables les changements dans votre base de données",
// "Test profile name" => "Test profile name",
// "Permission added" => "Permission added",
// "User added" => "User added",
// "User modified" => "User modified",
// "Group added" => "Group added",
// "old value" => "old value",
// "Installer added" => "Installer added",
// "Profile without changes" => "Profile without changes",
"Global configuration" => "Configuration globale",
// "This preference needs to be disabled" => "This preference needs to be disabled",
// "Enabling ratings for forums" => "Enabling ratings for forums",
// "You need to" => "You need to",
// "Create or edit a forum and enable" => "Create or edit a forum and enable",
"Posts can be rated" => "Les publications peuvent être notées",
// "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user" => "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Set the rating options at" => "Set the rating options at",
"Ratings" => "Cotations",
// "see above" => "see above",
// "Permissions involved" => "Permissions involved",
// "tiki" => "tiki",
// "Default Options" => "Default Options",
"Cache duration" => "Durée du cache",
"Create new" => "Créer une nouvelle",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds",
"Feeds" => "Flux",
"Feed for articles" => "Canaux de syndication des articles",
"Feed for blogs" => "Flux pour les blogues",
"Feed for individual blogs" => "Flux individuel pour les blogues",
"Feed for image galleries" => "Canal de syndication pour les galeries d'images",
// "Feed for individual image galleries" => "Feed for individual image galleries",
"Feed for file galleries" => "Canaux de syndication des galeries de fichiers",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "with diff" => "with diff",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "no diff" => "no diff",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
// "Feed for directories" => "Feed for directories",
"Feed for shoutbox" => "Flux pour le mégaphone",
// "Incoming Feeds" => "Incoming Feeds",
"You can see users rank by score in the module users_rank, for that go to" => "Vous pouvez voir le classement des utilisateurs dans le modules users_rank, pour cela allez à",
"Admin modules" => "Administrer les modules",
// "Cause scores older than a certain number of days to expire" => "Cause scores older than a certain number of days to expire",
// "Scoring rules" => "Scoring rules",
// "Unique rule ID" => "Unique rule ID",
// "Rule" => "Rule",
// "A label or ID to help identify which event was triggered to get points" => "A label or ID to help identify which event was triggered to get points",
// "Pts recipient type" => "Pts recipient type",
// "Recipient Type" => "Recipient Type",
// "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event" => "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event",
// "Pts recipient" => "Pts recipient",
// "The ID of the points recipient" => "The ID of the points recipient",
// "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered" => "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered",
// "Points Given" => "Points Given",
// "This is the numerical value of the points being given" => "This is the numerical value of the points being given",
// "Triggering event" => "Triggering event",
// "Reversal event" => "Reversal event",
// "Valid Triggering Object IDs" => "Valid Triggering Object IDs",
// "Valid Object Ids" => "Valid Object Ids",
// "This is a comma-separated list of object ids for which the event is valid" => "This is a comma-separated list of object ids for which the event is valid",
// "Min. Time Between Scoring" => "Min. Time Between Scoring",
// "Time between scoring" => "Time between scoring",
// "This is the amount of time in seconds that a user must wait before again being able to get points for this event" => "This is the amount of time in seconds that a user must wait before again being able to get points for this event",
"can be seen on page" => "peut être vu sur la page",
"in Admin menu" => "dans le menu Admin",
// "Also see the Search Indexing tab" => "Also see the Search Indexing tab",
// "File Gallery admin panel" => "File Gallery admin panel",
// "About the Unified Index" => "About the Unified Index",
// "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things" => "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things",
// "Disabling this will cause some parts of Tiki to be unavailable" => "Disabling this will cause some parts of Tiki to be unavailable",
// "Find out more about it here" => "Find out more about it here",
// "Search engine settings" => "Search engine settings",
// "About Unified search engines" => "About Unified search engines",
// "Advantages" => "Advantages",
// "Fast performance. Works out of the box with Tiki and even on most basic server setups" => "Fast performance. Works out of the box with Tiki and even on most basic server setups",
// "Disadvantages" => "Disadvantages",
// "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable" => "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable",
// "link" => "link",
// " for full list) " => " for full list) ",
"Lucene (PHP implementation)" => "Lucene (Implémentation PHP)",
// "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki" => "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki",
// "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues" => "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues",
// "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki" => "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki",
// "Needs to be separately installed from Tiki and requires more configuration" => "Needs to be separately installed from Tiki and requires more configuration",
// "for more information) " => "for more information) ",
// "About Use MySQL Full-Text Search as fallback" => "About Use MySQL Full-Text Search as fallback",
// "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability" => "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability",
// "Elastic search only" => "Elastic search only",
// "Experiment with LIST plugin syntax" => "Experiment with LIST plugin syntax",
// "After you have found the correct contents, you may copy-paste them in a LIST plugin" => "After you have found the correct contents, you may copy-paste them in a LIST plugin",
// "Legacy search" => "Legacy search",
// "Forum searches" => "Forum searches",
"Search Results" => "Résultats de recherche",
// "Items to display in search results" => "Items to display in search results",
// "Information to display for each result" => "Information to display for each result",
// "Stored Search" => "Stored Search",
"Configuration" => "Configuration",
// "ManifoldCF Configuration Checker" => "ManifoldCF Configuration Checker",
// "Occurrences of string in database" => "Occurrences of string in database",
// "Set default table" => "Set default table",
// "Text to search" => "Text to search",
// "Results for " => "Results for ",
// "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}" => "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}",
// "Occurrences" => "Occurrences",
// "View occurrences" => "View occurrences",
// "in table " => "in table ",
// "column" => "column",
// "Page preview" => "Page preview",
"View page" => "Afficher la page",
// "View blog post" => "View blog post",
// "View file" => "View file",
// "View gallery" => "View gallery",
// "View category" => "View category",
// "View article" => "View article",
// "View forum" => "View forum",
// "View calendar" => "View calendar",
// "View calendar item" => "View calendar item",
// "View tracker" => "View tracker",
// "View tracker item" => "View tracker item",
// "View forum comment" => "View forum comment",
// "Back to first level results" => "Back to first level results",
"Admin groups" => "Administrer les groupes",
"Admin Groups" => "Administrer les groupes",
"Admin users" => "Administrer les utilisateurs",
"Admin Users" => "Administrer les utilisateurs",
"Manage permissions" => "Gérer les droits",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings" => "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings",
"General Security" => "Sécurité Générale",
// "MySQL SSL connection" => "MySQL SSL connection",
// "MySQL SSL connection is active" => "MySQL SSL connection is active",
// "MySQL connection is not encrypted" => "MySQL connection is not encrypted",
// "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"" => "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"",
// "MySQL Server does not have SSL activated" => "MySQL Server does not have SSL activated",
// "Smarty and Features Security" => "Smarty and Features Security",
"Please also see" => "Merci de voir aussi",
"HTTPS (SSL) and other login preferences" => "HTTPS (SSL) et autres préférences de connexion",
// "User Encryption" => "User Encryption",
// "Requires the OpenSSL PHP extension for encryption" => "Requires the OpenSSL PHP extension for encryption",
// "You have OpenSSL installed" => "You have OpenSSL installed",
// "OpenSSL is not loaded" => "OpenSSL is not loaded",
// "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption" => "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption",
// "You may also want to add the Domain Password module somewhere" => "You may also want to add the Domain Password module somewhere",
// "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ" => "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ",
// "The user can add passwords for a registered password domain" => "The user can add passwords for a registered password domain",
// "Statistics for existing data" => "Statistics for existing data",
// "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension" => "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension",
// "CSRF security" => "CSRF security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "HTTP Headers" => "HTTP Headers",
// "Use these options to add options related with security to the HTTP Headers" => "Use these options to add options related with security to the HTTP Headers",
// "Spam Protection" => "Spam Protection",
// "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself" => "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself",
"Search results" => "Résultats de la recherche",
"Site Access" => "Accès au site",
// "Admin IDS custom rules" => "Admin IDS custom rules",
"Tokens" => "Jetons",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)",
// "OpenPGP" => "OpenPGP",
// "OpenPGP functionality for PGP/MIME encrypted email messaging" => "OpenPGP functionality for PGP/MIME encrypted email messaging",
// "Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging" => "Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging",
// "All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses" => "All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses",
// "If you use preferences option for the signer passphrase, clear the file option just for security" => "If you use preferences option for the signer passphrase, clear the file option just for security",
// "If you use file for the signer passphrase, clear the preferences option just for security" => "If you use file for the signer passphrase, clear the preferences option just for security",
// "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring" => "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
"To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "Pour activer ce fichier, copiez simplement le fichier %0 (situé dans le répertoire principal de votre installation de Tiki) vers %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
"%0 file is missing" => "Le ficher %0 est manquant",
"Unable to verify that your URL rewriting configuration is up to date" => "Incapable de vérifier que votre configuration de réécriture d'URL est à jour",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
"%0 is not in the expected format" => "%0 n'est pas du format attendu",
"%0 may simply be outdated" => "%0 est peut-être simplement périmé",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
"%0 file is out of date" => "%0 est périmé",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "For example, if the field is left blank, the canonical URL domain is" => "For example, if the field is left blank, the canonical URL domain is",
// "URL parameters" => "URL parameters",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known types" => "Known types",
"Invert" => "Inverser",
"Show Usage" => "Montrer l'utilisation",
"Delete &amp; Unreference" => "Effacer & déréférencer",
"Invert Relation" => "Inverser la relation",
// "New types" => "New types",
// "Fix" => "Fix",
"No occurences found" => "Aucune occurence trouvée",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Social network integration" => "Social network integration",
"To use Twitter integration, you must register this site as an application at" => "Pour utiliser l'intégration Twitter, vous devez enregistrer ce site en tant qu'application ici :",
"and allow write access for the application" => "et accorder le droit d'écriture à cette application",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Entrer &lt;adresse de votre site&gt;tiki-socialnetworks.php en tant qu'URL de retour",
"To use Facebook integration, you must register this site as an application at" => "Pour utiliser l'intégration Facebook, vous devez enregistrer ce site en tant qu'application ici :",
"and allow extended access for the application" => "et autoriser l'accès étendu à cette application",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Entrer &lt;adresse de votre site&gt;tiki-socialnetworks.php?request_facebook en tant qu'adresse de site et &lt;votre nom de domaine&gt; en tant que 'Site Domain'",
"The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it." => "Les préférences suivantes déterminent quelles permissions seront demandées à l'utilisateur pour dire à Tiki ce qu'il doit laisser faire par Facebook quand celui-ci est autorisé.",
// "bit.ly" => "bit.ly",
"There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "Un compte de site bit.ly n'est pas nécessaire ; chaque utilisateur peut utiliser le sien, mais un compte de site permet des statistiques plus étendues.",
"Go to" => "Aller dans",
"to sign up for an account" => "pour créer un compte",
"to retrieve the API key" => "pour trouver la clé de l'API",
// "To use LinkedIn integration, you must register this site as an application at" => "To use LinkedIn integration, you must register this site as an application at",
// "and allow necessary permissions for the application" => "and allow necessary permissions for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs" => "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs",
// "Share This" => "Share This",
// "This is a new control panel on Tiki and work is still in progress" => "This is a new control panel on Tiki and work is still in progress",
// "Tiki Statistics" => "Tiki Statistics",
// "Piwik Analytics" => "Piwik Analytics",
"Text area (that apply throughout many features)" => "Zones de texte (que l'on retrouve à travers plusieurs fonctionnalités)",
"Wiki syntax" => "Syntaxe Wiki",
// "Typography" => "Typography",
"Default size" => "Taille par défaut",
"External links and images" => "Liens et images externes",
"External links will be identified with" => "Les liens externes seront identifiés par",
"About plugins" => "A propos des plugiciels",
"Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below." => "Les plugiciels Tiki ajoutent des fonctionnalités aux pages wiki, articles, blogues et autres. Vous pouvez les activer ou désactiver ci-dessous.",
// "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>",
"The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below." => "L'icone d'édition de plugiciel est un accès simple pour les utilisateurs qui veulent éditer les paramètres de chaque plugiciel dans les pages wiki. Ceci peut être désactivé pour certains plugiciels ci-dessous.",
"Check disabled plugins used in wiki pages" => "Vérifier les plugiciels désactivés utilisés dans les pages wiki",
"Disabled used plugins" => "Désactivation des plugiciels",
// "Plugin preferences" => "Plugin preferences",
"Edit plugin icons" => "Icone d'édition de plugiciel",
// "Plugin List" => "Plugin List",
// "Use the filter input above to find plugins, or enter return to see the whole list" => "Use the filter input above to find plugins, or enter return to see the whole list",
"Search Help" => "Aide pour la recherche",
"Disable edit plugin icon (make plugin inline)" => "Désactiver l'icone d'édition du plugiciel (plugiciel en ligne)",
"Plugin Aliases" => "Alias de plugiciel",
"About plugin aliases" => "A propos du 'plugin aliases'",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins",
// "Find out more here" => "Find out more here",
// "This page is designed to work with JavaScript" => "This page is designed to work with JavaScript",
// "Available alias" => "Available alias",
// "Plugin Alias" => "Plugin Alias",
// "Enable Checked Plugins" => "Enable Checked Plugins",
// "General information" => "General information",
"Plugin name" => "Nom du plugiciel",
// "Base plugin" => "Base plugin",
// "Body label" => "Body label",
"Dependencies" => "Dépendances",
// "Inline (no plugin edit UI)" => "Inline (no plugin edit UI)",
// "Simple plugin arguments" => "Simple plugin arguments",
// "Add parameter" => "Add parameter",
"Argument" => "Argument",
// "Delete this parameter" => "Delete this parameter",
// "Default Value" => "Default Value",
// "Plugin parameter documentation" => "Plugin parameter documentation",
// "Add parameter documentation" => "Add parameter documentation",
// "Delete this parameter's documentation" => "Delete this parameter's documentation",
"Safe" => "Prudent",
// "Plugin body" => "Plugin body",
// "Ignore user input" => "Ignore user input",
// "Default content" => "Default content",
// "Body Parameters" => "Body Parameters",
// "Add body parameter" => "Add body parameter",
// "Delete this body parameter" => "Delete this body parameter",
"Encoding" => "Encodage",
// "Argument source (if different)" => "Argument source (if different)",
// "Composed plugin arguments" => "Composed plugin arguments",
// "Add composed parameter" => "Add composed parameter",
// "Delete this composed argument" => "Delete this composed argument",
"Pattern" => "Modèle",
// "Composed parameters" => "Composed parameters",
// "Delete this composed parameter" => "Delete this composed parameter",
"Tracker settings" => "Réglages de formulaire",
// "Field settings" => "Field settings",
// "Linked wiki pages" => "Linked wiki pages",
// "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features" => "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features",
"Tracker attachment preferences" => "Préférences pour les pièces jointes de formulaire",
// "Tracker force-fill feature" => "Tracker force-fill feature",
"Field Types" => "Types de champ",
// "Field types" => "Field types",
"Tracker attachments" => "Pièces jointes des formulaires",
"dls" => "téléchgts",
"Switch storage" => "Modifier stockage",
"Change all to db" => "Les mettre tous dans la base de données",
"Change all to file" => "Les mettre tous en fichiers",
"User Settings" => " Paramètres utilisateur",
"Default user preferences" => "Préférences par défaut de l'utilisateur",
"Users Default Preferences" => "Préférences de l'utilisateur par défaut",
// "My Account Items" => "My Account Items",
// "User Features" => "User Features",
// "User Account Features" => "User Account Features",
// "User Info and Picture" => "User Info and Picture",
"User information display" => "Informations affichées de l'éditeur",
// "Messaging and Notifications" => "Messaging and Notifications",
// "User notifications" => "User notifications",
// "For the digest emails to be sent out, you will need to set-up a cron job" => "For the digest emails to be sent out, you will need to set-up a cron job",
// "Adjust the command parameters for your digest frequency. Default frequency is 7 days" => "Adjust the command parameters for your digest frequency. Default frequency is 7 days",
// "Sample command" => "Sample command",
"User Files" => "Fichiers utilisateur",
"Kaltura" => "Kaltura",
"Kaltura Registration" => "Enregistrement Kaltura",
"To get a Kaltura Partner ID:" => "Pour obtenir un ID Partenaire Kaltura :",
"Setup your own instance of Kaltura Community Edition (CE)" => "Construire votre propre instance de Communauté d'édition Kaltura",
"get an account via Kaltura.com" => "obtenir un compte via Kaltura.com",
// "List Media" => "List Media",
"List Remix Entries" => "Liste de Remixages",
"Add New Media" => "Ajouter un nouveau média",
// "Plugin to embed in pages" => "Plugin to embed in pages",
// "Enable related tracker field types" => "Enable related tracker field types",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura partner settings" => "Kaltura partner settings",
// "Kaltura dynamic player" => "Kaltura dynamic player",
// "Kaltura contribution wizard" => "Kaltura contribution wizard",
// "You can manually edit these values in lib/videogals/standardTikiKcw.xml" => "You can manually edit these values in lib/videogals/standardTikiKcw.xml",
// "Recreate KCW \"uiConf\"" => "Recreate KCW \"uiConf\"",
// "Legacy support" => "Legacy support",
"Webservices" => "Services Web",
"Use the 'Quick Edit' module to easily create or edit wiki pages." => "Utilisez le module 'Quick Edit' pour créer ou éditer facilement des pages wiki.",
// "List wiki pages" => "List wiki pages",
// "List structures" => "List structures",
"Page display" => "Affichage d'une page",
// "Automatic table of contents" => "Automatic table of contents",
// "General features" => "General features",
"Export Wiki Pages" => "Exporter les pages Wiki dans un Dump PhpWiki",
// "Redirect and Similar" => "Redirect and Similar",
// "Wikiwords Features" => "Wikiwords Features",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Move all attachments to database" => "Move all attachments to database",
// "Move all attachments to file system" => "Move all attachments to file system",
"Remove unused pictures" => "Supprimer les images inutilisées",
// "Move images from wiki_up to the home file gallery" => "Move images from wiki_up to the home file gallery",
// "Move images to home gallery" => "Move images to home gallery",
// "If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "If you use these buttons please make sure to have a backup of the database and the directory wiki_up",
"Wiki watch" => "Surveillance Wiki",
// "Namespaces" => "Namespaces",
// "Settings that may be affected by the namespace separator" => "Settings that may be affected by the namespace separator",
// "Flagged Revision" => "Flagged Revision",
"Page Listings" => "Préférences d'affichage",
"Select which items to display when listing pages" => "Éléments affichés dans les listes de pages",
// "Database dumps and restores" => "Database dumps and restores",
// "Name for dump" => "Name for dump",
// "Create Database Dump" => "Create Database Dump",
// "Wiki database" => "Wiki database",
"Restore" => "Restaurer",
// "Dump files" => "Dump files",
// "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks" => "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks",
// "The HTML files generated may refer to files not included in the dump" => "The HTML files generated may refer to files not included in the dump",
// "Dumps do not include files attached to wiki pages" => "Dumps do not include files attached to wiki pages",
// "Dumping will overwrite the preexisting dump" => "Dumping will overwrite the preexisting dump",
// "Create Dump File" => "Create Dump File",
// "Download Dump File" => "Download Dump File",
// "Remove Dump File" => "Remove Dump File",
// "Mass replace and page permissions report" => "Mass replace and page permissions report",
"Mass search and replace" => "Recherche et remplacement en masse",
// "Report wiki pages with direct object permissions" => "Report wiki pages with direct object permissions",
"Wiki attachments" => "Fichiers joints Wiki",
// "Move attachment to database" => "Move attachment to database",
// "Move to database" => "Move to database",
// "Move attachment to file system" => "Move attachment to file system",
// "Move to file system" => "Move to file system",
// "Exclusive" => "Exclusive",
// "Share Common" => "Share Common",
"Edit perspective" => "Modifier la perspective",
// "No areas found. Click \"Update Areas\" to populate this list" => "No areas found. Click \"Update Areas\" to populate this list",
// "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> " => "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> ",
// "Update areas" => "Update areas",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>",
"Page links" => "Liens de pages",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature",
// "WYSIWYG editor features" => "WYSIWYG editor features",
"Related features" => "Fonctionnalités associées",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Position",
"Cache Time" => "Temps d'antémémoire",
"secs" => "secs",
"Use Ctrl+Click to select multiple options" => "Utiliser Ctrl+Click pour sélectionner plusieurs options",
"The" => "Le",
"Display Modules to All Groups" => "Afficher les modules à tous les groupes",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
"Displayed now for all eligible users even with personal assigned modules" => "Affiché pour tous les utilisateurs ayant droit même avec des modules personnellement assignés",
"Displayed for the eligible users with no personal assigned modules" => "Affiché pour les utilisateurs ayant droit sans module personnellement assigné",
"Displayed now, can't be unassigned" => "Affiché maintenant, ne peut pas être désassigné",
"Not displayed until a user chooses it" => "Non affiché jusqu'à ce que l'utilisateur en décide autrement",
"Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Parce que <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">les utilisateurs peuvent configurer les modules</a>, faire un autre choix",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
"required" => "obligatoire",
"Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Paramètres: paramètres spécfiques au module et/ou généraux ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Séparateur entre les paramètres : '&amp;'. Ex : maxlen=15&amp;nonums=y",
"Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Entrer les paramètres en format URL, exemple : 'nobox=y&class=rbox-data'",
"Edit custom module" => "Modifier un module personnalisé",
"Enter the code below" => "Entrer le code ci-dessous",
"Anti-Bot verification code image" => "Image du code de vérification Anti-Robot",
"Try another code" => "Essayer un autre code",
// "Your article has been added" => "Your article has been added",
// "Create Article" => "Create Article",
// "Expires" => "Expires",
// "Users rating: " => "Users rating: ",
// "{\$topicName}" => "{\$topicName}",
// "List all articles of the same topic" => "List all articles of the same topic",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
"You do not have permission to read complete articles." => "Vous n'avez pas les droits pour consulter les articles complets.",
"First page" => "Première page",
"Previous page" => "Page précédente",
"Next page" => "Page suivante",
"Last page" => "Dernière page",
"Related content" => "Contenu en relation",
"bytes" => "octets",
// "Article actions" => "Article actions",
"Send a link" => "Envoyer un lien",
// "Get a short URL" => "Get a short URL",
"Attached files" => "Fichiers joints",
"Upload file" => "Envoyer un fichier",
// "File upload comment" => "File upload comment",
"Attach" => "Joindre",
"Attach a file to this item" => "Joindre un fichier à cette fiche",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "plus d'informations",
"No attachments for this item" => "Aucun fichier joint à cette fiche",
// "Blog actions" => "Blog actions",
// "Blog Actions" => "Blog Actions",
"Monitor" => "Surveiller",
// "Stop monitoring" => "Stop monitoring",
"Group Monitor" => "Surveillance de groupe",
"RSS" => "RSS",
"Watched by categories" => "Surveillé via une catégorie",
// "Blog post actions" => "Blog post actions",
"Save to notepad" => "Enregistrer dans le bloc-note",
// "Published By" => "Published By",
"Publish Date" => "Date de publication",
"Previous post" => "Publication précédente",
"Next post" => "Publication suivante",
"More..." => "La suite...",
"pages" => "pages",
"Last" => "Derniers",
"private" => "privé",
"permanent link" => "URL de la publication (permalink)",
"Leave a comment" => "Laisser un commentaire",
"%0 comment" => "%0 commentaire",
"%0 comments" => "%0 commentaires",
// "{\$item.name}" => "{\$item.name}",
// "{\$sub.name}" => "{\$sub.name}",
"Parent Gallery" => "Galerie Parente",
"No records found" => "Aucun résultat",
"Select Categories" => "Sélectionner une ou plusieurs catégorie(s)",
"Admin Categories" => "Administrer les catégories",
"Select/deselect all categories" => "Cocher/Décocher toutes les catégories",
"No categories defined" => "Aucune catégorie définie",
"Browse Category" => "Parcourir la catégorie",
"Are you sure you want to archive this comment" => "Êtes-vous sûr(e) de vouloir archiver ce commentaire",
"Are you sure you want to unarchive this comment" => "Êtes-vous sûr(e) de vouloir désarchiver ce commentaire",
// "Edit Comment" => "Edit Comment",
// "Comments unlocked" => "Comments unlocked",
"Post new comment" => "Publier un nouveau commentaire",
"There are no comments at this time" => "Il n'y a aucun commentaire pour le moment",
"Add Comment" => "Ajouter un Commentaire",
"Reply" => "Répondre",
"Archived" => "Archivé",
"Unarchive" => "Désarchiver",
"Archive" => "Archive",
"Rejected" => "Rejeté",
"Approve" => "Approuver",
"Reject" => "Rejeter",
"Are you sure you want to lock comments on this object" => "Êtes-vous sûr(e) de vouloir verrouiller les commentaires sur cet objet",
"Are you sure you want to approve this comment" => "Êtes-vous sûr(e) de vouloir approuver ce commentaire",
"Are you sure you want to reject this comment" => "Êtes-vous sûr(e) de vouloir rejeter ce commentaire",
// "Go back to" => "Go back to",
// "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity",
"Website" => "Site Web",
"Send me an email when someone replies" => "M'envoyer un courriel quand quelqu'un répond",
// "Are you sure you want to delete this comment" => "Are you sure you want to delete this comment",
"Are you sure you want to unlock comments on this object" => "Êtes-vous sûr(e) de vouloir déverrouiller les commentaires sur cet objet",
"Posted by" => "Envoyé par",
// "Private message" => "Private message",
"private message" => "message privé",
// "Send eMail to user" => "Send eMail to user",
// "User online" => "User online",
// "User offline" => "User offline",
// "Download attachment" => "Download attachment",
// "Remove attachment" => "Remove attachment",
// "Deliberation Items" => "Deliberation Items",
"top of page" => "haut de page",
"Notification" => "Notification",
// "Delete post" => "Delete post",
"Report this post" => "Signaler cette publication",
// "Group monitor" => "Group monitor",
// "Moderator actions for selected topics" => "Moderator actions for selected topics",
// "Reported messages" => "Reported messages",
"Reported" => "Signalée",
// "Queued messages" => "Queued messages",
"Queued" => "Mis en attente",
"Threshold" => "Seuil",
"Search:" => "Rechercher :",
"Replies" => "Réponses",
"below your current threshold" => "en dessous de votre seuil courant",
"New Reply" => "Nouvelle réponse",
"Editing reply" => "Modifier la réponse",
"Reply to the selected post" => "Répondre au message sélectionné",
"Post new message" => "Publier un nouveau message",
// "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address",
"Maximum size" => "Taille maximum",
"Reply to parent post" => "Répondre à un message parent",
"Post new reply" => "Publier un nouveau message",
"Post as Anonymous" => "Poster en tant qu'Anonyme",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Merci de noter que la prévisualisation ne conserve pas le fichier joint que vous devrez spécifier avec de publier",
"Posting replies" => "Publier des réponses",
"Please enter a title" => "Merci d'entrer un titre",
"1 comment" => "1 commentaire",
"Go back" => "Revenir à la page précédente",
"Return to home page" => "Retour à la page d'accueil",
"Type of contribution" => "Type de contribution",
// "No contribution records found" => "No contribution records found",
// "{\$prefs.cookie_consent_description}" => "{\$prefs.cookie_consent_description}",
// "{\$prefs.cookie_consent_question}" => "{\$prefs.cookie_consent_question}",
// "{\$prefs.cookie_consent_button}" => "{\$prefs.cookie_consent_button}",
"Copyrights" => "Droits d'auteur",
"Authors" => "Auteurs",
// "Copyright Holder" => "Copyright Holder",
"Theme:" => "Thème :",
// "Do you really want to remove the %0 route" => "Do you really want to remove the %0 route",
"Back to tracker list" => "Retour à la liste des formulaires",
"System error" => "Erreur système",
"The following error message was returned" => "Le message d'erreur suivant a été renvoyé",
"Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "La base de données n'est actuellement par à jour ! Voir <a href=\"tiki-install.php\">Installateur Tiki</a> pour résoudre ce problème",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation:" => "Si vous avez accès à l'invite de commande (SSH), vous pouvez aussi utiliser cette commande, à partir de la racine de votre installation Tiki :",
"The query was" => "La requête était",
"The built query was likely" => "La requête construite était probablement",
"Stacktrace" => "Stacktrace",
"Tiki is unable to connect to the database" => "Tiki est incapable de se connecter à la base de données",
"An error occurred while performing the request" => "Une erreur s'est produite pendant l'exécution de la requête",
"Current URL" => "URL courante",
"Command" => "Commande",
"exec" => "exécuter",
"Type <code>help</code> to get list of available commands" => "Taper <code>help</code> pour avoir une liste des commandes disponibles",
"Page generation debugging log" => "Trace de debug de la génération de la page",
"Features state" => "État des fonctionnalités",
"features matched" => "fonctionnalités trouvées",
"Watchlist" => "Liste des variables surveillées",
// "Page discussion" => "Page discussion",
// "This page has been discussed once" => "This page has been discussed once",
// "Access discussion" => "Access discussion",
// "This page has been discussed %0 times" => "This page has been discussed %0 times",
// "Access discussion (%0 replies)" => "Access discussion (%0 replies)",
// "There are no discussions currently on this page" => "There are no discussions currently on this page",
// "Start discussion" => "Start discussion",
"Duplicate File Gallery" => "Dupliquer une galerie",
"Duplicate categories" => "Dupliquer les catégories",
"Duplicate permissions" => "Dupliquer les droits d'accès",
"Duplicate" => "Dupliquer",
"There are individual permissions set for this file gallery" => "Des droits d'accès individuels ont été appliqués à cette galerie de fichiers",
// "Manage Permissions" => "Manage Permissions",
"Properties" => "Propriétés",
// "{\$gal_info.name}" => "{\$gal_info.name}",
// "Other (%0)" => "Other (%0)",
"Any file" => "Tous fichiers",
"Podcast (audio)" => "Podcast (audio)",
"Podcast (video)" => "Podcast (vidéo)",
"Gallery is visible to non-admin users" => "Cette galerie est visible aux utilisateurs autres qu'administrateur",
"Gallery is unlocked" => " La galerie est déverrouillée",
// "Users with upload permission can add files to the gallery (not just the gallery owner)" => "Users with upload permission can add files to the gallery (not just the gallery owner)",
"Respect permissions for backlinks to view a file" => "Respectez les autorisations pour les backlinks pour afficher un fichier",
"Files can be locked at download" => "Les fichiers peuvent être verrouillés au téléchargement",
"Maximum number of archives for each file" => "Nombre maximum d'archives pour chaque fichier",
"unlimited" => "illimité",
"Parent gallery" => "Galerie parente",
"Owner of the gallery" => "Propriétaire de la galerie",
"Mb" => "Mo",
"Min" => "Min",
"Group of users alerted when file gallery is modified" => "Groupe des utilisateurs alerté quand un élément de la galerie est modifié",
"Allows each user to be selected for small groups" => "Permettre de sélectionner chaque utilisateur individuellement",
"Maximum width of images in gallery" => "Largeur maximale des images dans la galerie",
"If an image is wider than this, it will be resized" => "Si une image est plus large, elle sera réduite",
"Attention: In this case, the original image will be lost" => "Attention : Dans ce cas, l'image d'origine sera perdue",
"Maximum height of images in gallery" => "Hauteur maximale des images dans la galerie",
"If an image is higher than this, it will be resized" => "Si une image est plus haute, elle sera réduite",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Code wiki à entrer quand l'image est sélectionnée à partir du \"gestionnaire de galerie de fichiers\"",
"The default is " => "La valeur par défaut est ",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Les noms de fichiers seront remplacés quand ils sont entourés par des caractères '%'. Par exemple %fileId%, %name%, %filename%, %description%",
"Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs" => "Les attributs seront remplacés lorsqu'ils seront inclus dans% chars. par exemple. % tiki.content.url% pour les URL de fichiers distants",
// "Display Settings" => "Display Settings",
// "Finder View" => "Finder View",
"Select which items to display when listing galleries" => "Sélectionner les informations que vous souhaitez voir apparaître lors de l'affichage des galeries",
"Max description display size" => "Taille maximum affichée de la description",
"Max rows per page" => "Nombre maximum de rangé",
"View inserted gallery after save" => "Afficher la galerie insérée après l'enregistrement",
"File error" => "Erreur fichier",
"Perhaps you are looking for" => "Peut-être cherchez-vous",
"There are no wiki pages similar to '{\$page|escape}'" => "Il n'existe aucune page wiki similaire à '{\$page|escape}'",
"Token Error" => "Erreur jeton",
"You are not logged in." => "Vous n'êtes pas connecté.",
"Go to Log in Page" => "Aller à la page d'authentification",
"Create this page" => "Créer cette page",
"(page will be orphaned)" => "(la page sera orpheline)",
"Close Window" => "Fermer la fenêtre",
// "Redirecting in %0 seconds" => "Redirecting in %0 seconds",
// "Permission successfully changed" => "Permission successfully changed",
// "Global permission" => "Global permission",
// "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)",
// "</em>\"}Object permission for the %0 %1" => "</em>\"}Object permission for the %0 %1",
// "Permissions successfully changed" => "Permissions successfully changed",
// "Global permissions" => "Global permissions",
// "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)",
// "</em>\"}Object permissions for the %0 %1" => "</em>\"}Object permissions for the %0 %1",
// "" => "",
// "No permissions were changed" => "No permissions were changed",
// "The following change has been applied" => "The following change has been applied",
// "The following changes have been applied" => "The following changes have been applied",
// "{\$item.mes[0]|stringfix}" => "{\$item.mes[0]|stringfix}",
"Preference name" => "Nom de la préférence",
"Upload" => "Envoyer",
"Open as WebFolder" => "Ouvrir dans un dossier Web",
// "Delete gallery" => "Delete gallery",
"Edit: " => "Modifier",
// "Display as PDF" => "Display as PDF",
"Download current version" => "Télécharger la version validée",
// "Browser display" => "Browser display",
"Archives" => "Archives",
// "Upload new version" => "Upload new version",
// "Replace draft" => "Replace draft",
// "Upload draft" => "Upload draft",
// "Validate draft" => "Validate draft",
"Validate your draft" => "Valider votre brouillon",
// "Delete draft" => "Delete draft",
"Delete your draft" => "Effacer votre brouillon",
// "Edit properties" => "Edit properties",
// "Refresh metadata" => "Refresh metadata",
// "Page view" => "Page view",
// "File already locked by %0" => "File already locked by %0",
// "Lock file" => "Lock file",
"Download and lock" => "Télécharger et verrouiller",
"Open your draft in WebDAV" => "Ouvrir votre brouillon dans WebDAV",
"Open in WebDAV" => "Ouvrir dans WebDAV",
"Share a link to this file" => "Partager un lien vers ce fichier",
"Email a link to this file" => "Envoyer par courriel un lien vers ce fichier",
"Click here to use the file" => "Cliquer Ici pour Insérer en Syntaxe Wiki",
"The checkbox is disabled because this preference is disabled globally" => "La case est grisée car la fonctionnalité est désactivée de manière globale",
// "Please enable the preference globally first" => "Please enable the preference globally first",
// "Site administrators can enable the preference" => "Site administrators can enable the preference",
"Show an icon in a column" => "Afficher une icône dans une colonne",
// "Search.." => "Search..",
// "Select files" => "Select files",
// "Too many files selected. De-select some files before adding more" => "Too many files selected. De-select some files before adding more",
// "Current Selection" => "Current Selection",
"Click to remove" => "Cliquer pour supprimer",
"Upload Files" => "Envoyer un fichier",
"Drop files or " => "Déposer des fichiers ou ",
"Choose files" => "Choisir des fichiers",
// "Automatic upload" => "Automatic upload",
// "Last modification: %0" => "Last modification: %0",
// "No files found" => "No files found",
"Upload from URL" => "Télécharger à partir d'une URL",
"File added" => "Fichier ajouté",
// "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} " => "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} ",
// "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section" => "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section",
"Upload File" => "Envoyer un fichier",
// "Or drop files here from your file manager" => "Or drop files here from your file manager",
// "Or drop file here from your file manager" => "Or drop file here from your file manager",
// "Export PDF" => "Export PDF",
"Start the Slideshow" => "Démarrer le diaporama",
"Pause the Slideshow" => "Mettre en pause le diaporama",
"There are no images to display" => "Il n'y a aucune image à afficher",
// "Select Files (%0)" => "Select Files (%0)",
// "Sort By" => "Sort By",
// "Sort direction" => "Sort direction",
"Any" => "Tout",
"Lookup" => "Rechercher",
"Deep search" => "Recherche approfondie",
"Select Tags" => "Choisir un/des mot(s)-clé(s)",
"Include objects without a specified language" => "Inclure les objets pour lesquels aucune langue n'a été spécifiée",
// "View Saved Searches" => "View Saved Searches",
"Add to filter" => "Ajouter au filtre",
// "{\$whatlabel}" => "{\$whatlabel}",
"Clear Filter" => "Vider le filtre",
"any type" => "tout type",
"Article Topic" => "Sujet de l'article",
"any topic" => "n'importe quel sujet",
"any language" => "n'importe quelle langue",
"not in" => "pas dans",
// "Date From" => "Date From",
// "Date To" => "Date To",
"any category" => "toutes catégories",
"Multiple select" => "Sélection multiple",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
"Orphans" => "Orphelins",
// "{\$find_other}" => "{\$find_other}",
"Displayed rows" => "Lignes affichées",
// "Hide Map" => "Hide Map",
// "Show Map" => "Show Map",
"Module errors" => "Erreur dans le module",
"The following modules could not be loaded" => "Les modules suivants n'ont pu être chargés",
"Change" => "Changer",
// "Show PHP error messages" => "Show PHP error messages",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Séparer les mots-clés par des espaces. Les mots-clés formés par des mots composés sont à saisir sans espaces entre les différents mots ou entourer de doubles quotes",
// "Untag" => "Untag",
// "Goal" => "Goal",
// "Eligible Groups" => "Eligible Groups",
// "No eligible groups" => "No eligible groups",
// "No goals configured yet" => "No goals configured yet",
// "Goal Administration" => "Goal Administration",
// "%0 was removed" => "%0 was removed",
// "Are you sure you want to delete %0" => "Are you sure you want to delete %0",
// "View Goal" => "View Goal",
// "Eligibility" => "Eligibility",
// "Goal Attribution" => "Goal Attribution",
// "Individual Goal" => "Individual Goal",
// "Group Goal" => "Group Goal",
// "Range Type" => "Range Type",
// "Rolling" => "Rolling",
// "Fixed" => "Fixed",
// "Time span" => "Time span",
// "In days" => "In days",
// "YYYY-MM-DD HH:MM:SS" => "YYYY-MM-DD HH:MM:SS",
// "Rewards are given to individuals achieving the goal or group members for group goals" => "Rewards are given to individuals achieving the goal or group members for group goals",
// "Changes will not be saved" => "Changes will not be saved",
// "Your changes to conditions are not saved until you save the goal" => "Your changes to conditions are not saved until you save the goal",
"Operator" => "Opérateur",
"At Least" => "Au moins",
"At Most" => "Au plus",
// "Metric" => "Metric",
// "Event Type" => "Event Type",
// "Badge" => "Badge",
// "Hide condition from users" => "Hide condition from users",
// "Members of" => "Members of",
// "Your changes to rewards are not saved until you save the goal" => "Your changes to rewards are not saved until you save the goal",
// "Credit Type" => "Credit Type",
// "Credit Quantity" => "Credit Quantity",
// "Hide reward from users" => "Hide reward from users",
// "No conditions yet" => "No conditions yet",
// "Add Condition" => "Add Condition",
// "No rewards yet" => "No rewards yet",
// "Add Reward" => "Add Reward",
// "Modify Eligibility" => "Modify Eligibility",
// "No groups are eligible to this goal" => "No groups are eligible to this goal",
// "Major Version" => "Major Version",
// "Minor Version" => "Minor Version",
// "Tutorial URL" => "Tutorial URL",
// "Restricted" => "Restricted",
// "Return to list" => "Return to list",
"Images Galleries" => "Galeries d'images",
"Edit this page!" => "Éditer cette page !",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogues",
"RSS Articles" => "RSS Articles",
"RSS Image Galleries" => "RSS Galeries d'images",
"RSS File Galleries" => "Flux RSS Galeries de fichiers",
"RSS Forums" => "RSS Forums",
"RSS Directories" => "RSS Répertoires",
"RSS Calendars" => "Calendriers RSS",
// "RSS Tracker" => "RSS Tracker",
// "Use Selected Icon" => "Use Selected Icon",
// "Do you really want to remove the custom IDS rule with Id %0" => "Do you really want to remove the custom IDS rule with Id %0",
// "Back to IDS Rules list" => "Back to IDS Rules list",
"Toggle interactive translation" => "Switch de traduction interactive",
"Once checked, click on any string to translate it." => "En cochant cette case, vous pouvez traduire une chaîne de texte d'un simple clic.",
"Turn off interactive translation" => "Désactiver la traduction interactive",
"Interactive Translation" => "Traduction interactive",
"Translation" => "Traduction",
"Couldn't find any translatable string" => "N'a pas pu trouver de chaîne à traduire",
"Save translations" => "Sauvegarder les traductions",
"Changes will be applied on next page load only" => "Les changements ne seront appliqués qu'au prochain chargement de la page",
"Upload Successful" => "Succès du rapatriement",
// "custom.php" => "custom.php",
// "Download custom.php file for the selected language" => "Download custom.php file for the selected language",
// "custom.json" => "custom.json",
// "Download custom.json file for the selected language" => "Download custom.json file for the selected language",
// "Custom translation file does not exist. Save a custom translation to create the file" => "Custom translation file does not exist. Save a custom translation to create the file",
"Translations" => "Traductions",
// "Translation text" => "Translation text",
// "Add a new row" => "Add a new row",
// "Add row" => "Add row",
// "Customized String Translations" => "Customized String Translations",
// "Manage custom translations" => "Manage custom translations",
// "Process Type" => "Process Type",
// "Select how the uploaded translations should be processed" => "Select how the uploaded translations should be processed",
"Note:" => "Remarque :",
// "No translations in the database available to export" => "No translations in the database available to export",
// "Translations in the database" => "Translations in the database",
// "Merge all translations, whether or not they are marked as general (for contribution)" => "Merge all translations, whether or not they are marked as general (for contribution)",
// "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database" => "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database",
"To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "Pour pouvoir écrire vos traductions en retour dans language.php, assurez vous que le serveur web a le droit d'écrire dans le répertoire lang/",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Toggle right modules" => "Toggle right modules",
// "Toggle left modules" => "Toggle left modules",
"Toggle module contents" => "Afficher/cacher le contenu du module",
"Toggle" => "Afficher/cacher",
// "Move up" => "Move up",
// "Move down" => "Move down",
// "Move to opposite side" => "Move to opposite side",
// "{\$count_label}" => "{\$count_label}",
"Show Tree" => "Montrer l'Arbre",
"Hide Tree" => "Masquer l'Arbre",
// "Select action to perform with checked.." => "Select action to perform with checked..",
"Assign permissions to file galleries" => "Assigner des permissions aux galeries de fichiers",
// "Delete selected items" => "Delete selected items",
// "Download zip version" => "Download zip version",
// "Reset to default list view settings" => "Reset to default list view settings",
// "Move selected file or gallery" => "Move selected file or gallery",
"Move to" => "Déplacer vers",
// "Assign file gallery permissions to groups" => "Assign file gallery permissions to groups",
"No Additional Sort" => "Pas de Tri Additionnel",
"Other Sorts" => "Autres tris",
// "Locked by-" => "Locked by-",
"No information" => "Pas d'information",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
// "The leader of " => "The leader of ",
// "has added you. To visit it, logon and go to the home page " => "has added you. To visit it, logon and go to the home page ",
// "You have been added" => "You have been added",
// "This is to inform you that your request to join" => "This is to inform you that your request to join",
// " has been accepted" => " has been accepted",
// "To visit it, go to the home page" => "To visit it, go to the home page",
// "Leader approved your request" => "Leader approved your request",
// "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the" => "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the",
// "Leader rejected your request" => "Leader rejected your request",
// "This is to inform you that you have been removed from " => "This is to inform you that you have been removed from ",
// " If you did not request this removal, or have any questions or concerns, please contact" => " If you did not request this removal, or have any questions or concerns, please contact",
// "You have been removed from it" => "You have been removed from it",
// "Upgrade Available" => "Upgrade Available",
// "Upgrades Available" => "Upgrades Available",
// "{\$subject}" => "{\$subject}",
// "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link" => "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link",
"Gift Certificate Information" => "Information certificat-cadeau",
"Description:" => "Description :",
"Percentage Discount" => "Pourcentage de remise",
"Value of Gift Certificate" => "Valeur du certificat-cadeau",
// "Redeem Code" => "Redeem Code",
// "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase" => "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase",
// "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made" => "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made",
"You can review your order at" => "Vous pouvez revoir votre commande à",
// "Your {\$prefs.mail_template_custom_text}cart order" => "Your {\$prefs.mail_template_custom_text}cart order",
// "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site" => "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site",
"To the newsletter" => "à la lettre d'informations",
// "Please access the following URL to confirm your subscription" => "Please access the following URL to confirm your subscription",
"To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link:" => "Pour valider votre compte et vous connecter au site {\$prefs.mail_template_custom_text}, veuillez cliquer sur le lien suivant :",
"The administrator approved your account." => "L'administrateur a validé votre compte.",
// "Confirm your {\$prefs.mail_template_custom_text}email at %s" => "Confirm your {\$prefs.mail_template_custom_text}email at %s",
// "Remove {\$prefs.mail_template_custom_text}file" => "Remove {\$prefs.mail_template_custom_text}file",
"GalleryId" => "Id de la galerie",
"Identifier" => "Identifiant",
// "{\$prefs.mail_template_custom_text}File Gallery quota exceeded" => "{\$prefs.mail_template_custom_text}File Gallery quota exceeded",
"User:" => "Utilisateur :",
// "A new message was posted to {\$prefs.mail_template_custom_text}forum" => "A new message was posted to {\$prefs.mail_template_custom_text}forum",
"New topic" => "Nouveau sujet",
// "An anonymous {\$prefs.mail_template_custom_text}user" => "An anonymous {\$prefs.mail_template_custom_text}user",
"An anonymous user" => "Un utilisateur anonyme",
// "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL",
// "Note that this is an edited post" => "Note that this is an edited post",
// "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL" => "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL",
// "To instantly approve this post without logging in, use the following URL" => "To instantly approve this post without logging in, use the following URL",
// "You have been invited to access %0 by %1" => "You have been invited to access %0 by %1",
// "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0" => "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0",
// "Your access is valid until %0" => "Your access is valid until %0",
// "Your {\$prefs.mail_template_custom_text}temporary access to %0" => "Your {\$prefs.mail_template_custom_text}temporary access to %0",
"You are invited by" => "Vous êtes invité par",
"You join this group" => "Vous rejoignez ce groupe",
"Join me on %s" => "Me rejoindre sur %s",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "{\$prefs.mail_template_custom_text}page not found" => "{\$prefs.mail_template_custom_text}page not found",
// "%0 mentioned you in %1" => "%0 mentioned you in %1",
// "You've been mentioned on %0" => "You've been mentioned on %0",
// "A new {\$prefs.mail_template_custom_text}message was posted to you" => "A new {\$prefs.mail_template_custom_text}message was posted to you",
// "Click here to read the full message and / or reply" => "Click here to read the full message and / or reply",
// "New {\$prefs.mail_template_custom_text}message arrived from %s" => "New {\$prefs.mail_template_custom_text}message arrived from %s",
"Hi" => "Bonjour",
// "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now",
"To login with your username and password, please follow this link" => "Pour vous connecter avec votre nom d'utilisateur et votre mot de passe, suivez le lien",
"Enjoy the site!" => "Bonne visite sur le site!",
"User Account Activated" => "Compte utilisateur activé",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first",
"has requested an account on" => "a demandé un compte sur",
"Group:" => "Groupe :",
"User Tracker" => "Formulaire Utilisateur",
// "To validate that {\$prefs.mail_template_custom_text}account, please follow the link" => "To validate that {\$prefs.mail_template_custom_text}account, please follow the link",
"Assign to a group" => "Assigner à un groupe",
"View user's data" => "Voir les données utilisateur",
"Best regards" => "Salutations",
"User Registration Request" => "Demande d'inscription d'un utilisateur",
// "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request" => "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request",
// "You're invited to join my {\$prefs.mail_template_custom_text}network of friends" => "You're invited to join my {\$prefs.mail_template_custom_text}network of friends",
"The user" => "L'utilisateur",
// "registered at your {\$prefs.mail_template_custom_text}site" => "registered at your {\$prefs.mail_template_custom_text}site",
// "New {\$prefs.mail_template_custom_text}user registration" => "New {\$prefs.mail_template_custom_text}user registration",
// "Start of article" => "Start of article",
"Published" => "Publié",
"By" => "Par",
"Bye bye!" => "Au revoir!",
// "This email address has been removed from the list of subscribers of: " => "This email address has been removed from the list of subscribers of: ",
"Bye bye from %s at %s" => "Désinscription à %s de %s",
// "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link" => "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link",
"Welcome to our newsletter!" => "Bienvenue sur notre lettre d'informations !",
// "This email address has been added to the list of subscribers of: " => "This email address has been added to the list of subscribers of: ",
"You can always cancel your subscription using" => "Vous pouvez toujours annuler votre inscription en utilisant",
"Welcome to %s at %s" => "Bienvenue sur %s de %s",
// "Reply Notification: " => "Reply Notification: ",
// "{\$prefs.mail_template_custom_text}Email Notification" => "{\$prefs.mail_template_custom_text}Email Notification",
// "Someone requested a password reset for your %0account" => "Someone requested a password reset for your %0account",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Veuillez cliquer sur le lien ci-dessous pour confirmer votre intention de réinitialiser votre mot de passe. Vous serez redirigé vers une page où vous devrez saisir un nouveau mot de passe \"permanent\". Veuillez vous en souvenir et ne le partagez pas.",
"Important: Username & password are CaSe SenSitiVe" => "Important : Nom d'utilisateur et mot de passe tiennent compte de la casse (lettres minuscules vs MAJUSCULES)",
"Important: The old password remains active if you don't click the link above." => "Important : L'ancien mot de passe reste actif tant que vous ne cliquez pas sur le lien ci-dessus.",
"Your account information for %s" => "Les informations de votre compte sur %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Report on %0 for %1" => "Report on %0 for %1",
// "Last {\$prefs.mail_template_custom_text}Report sent on %0" => "Last {\$prefs.mail_template_custom_text}Report sent on %0",
"Changes in detail" => "Changements en détail",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Vous recevez des courriels de notification sous forme de résumé périodique. Pour les recevoir individuellement dès qu'ils sont postés, modifiez vos préférences à %0",
// "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at" => "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at",
"Feed" => "Flux RSS",
// "New categories" => "New categories",
// "Configure settings for the new category at" => "Configure settings for the new category at",
// "New {\$prefs.mail_template_custom_text}source category in RSS feed" => "New {\$prefs.mail_template_custom_text}source category in RSS feed",
// "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes",
"Details" => "Détails",
"Site" => "Site",
// "[%0] Scheduler \"%1\" was healed" => "[%0] Scheduler \"%1\" was healed",
// "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes",
// "[%0] Scheduler \"%1\" is stalled" => "[%0] Scheduler \"%1\" is stalled",
// "Look at this {\$prefs.mail_template_custom_text}link" => "Look at this {\$prefs.mail_template_custom_text}link",
// "A friend sends you a {\$prefs.mail_template_custom_text}link from: " => "A friend sends you a {\$prefs.mail_template_custom_text}link from: ",
// "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link" => "Vous pouvez modifier la soumission en suivant ce lien",
"Body" => "Corps",
// "New {\$prefs.mail_template_custom_text}article submitted at %s" => "New {\$prefs.mail_template_custom_text}article submitted at %s",
// "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}" => "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}",
// "{\$mail_user|username}" => "{\$mail_user|username}",
// "{\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "{\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}",
// "View the {\$prefs.mail_template_custom_text}tracker item at" => "View the {\$prefs.mail_template_custom_text}tracker item at",
// "The last content before deletion was as follows" => "The last content before deletion was as follows",
"Download the file at" => "Télécharger le fichier à",
// "{\$mail_trackerName}" => "{\$mail_trackerName}",
"item" => "fiche",
// "was deleted at" => "was deleted at",
"was modified at" => "a été modifié à",
// "Please visit this {\$prefs.mail_template_custom_text}link before logging in again" => "Please visit this {\$prefs.mail_template_custom_text}link before logging in again",
"Last attempt" => "Dernière tentative",
// "Confirm your {\$prefs.mail_template_custom_text}account at %s" => "Confirm your {\$prefs.mail_template_custom_text}account at %s",
// "{\$prefs.mail_template_custom_text}Site" => "{\$prefs.mail_template_custom_text}Site",
// "{\$prefs.mail_template_custom_text}Account suspended" => "{\$prefs.mail_template_custom_text}Account suspended",
// "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user" => "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Si vous voulez confirmer votre adhésion au site, cliquer sur le lien suivant pour votre première connexion",
"Welcome to the site!" => "Bienvenue sur le site",
"Your personal access to" => "Votre accès personnel à",
// "joined" => "joined",
// "User joined" => "User joined",
// "You are getting this email because you are a leader of" => "You are getting this email because you are a leader of",
// "Click here to manage members" => "Click here to manage members",
// "You are getting this email because you are a leader" => "You are getting this email because you are a leader",
// "The user needs to be approved before he is admitted" => "The user needs to be approved before he is admitted",
// "user joined" => "user joined",
// "You are getting this email because you are a group leader" => "You are getting this email because you are a group leader",
// "left" => "left",
// "user left" => "user left",
"You or someone registered this email address at" => "Vous (ou quelqu'un d'autre) a inscrit cette adresse électronique à",
// "If you want to be a registered user in this %0site you will have to use the following link to login for the first time" => "If you want to be a registered user in this %0site you will have to use the following link to login for the first time",
// "Your {\$prefs.mail_template_custom_text}registration confirmation" => "Your {\$prefs.mail_template_custom_text}registration confirmation",
"You will receive an email with the information needed to log into this site the first time" => "Vous allez recevoir un courriel avec les instructions pour vous connecter à ce site la première fois",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Votre demande de compte a été enregistrée et va être traitée dès que possible par un administrateur.",
"You'll receive email notification once your account is activated." => "Vous allez recevoir un courriel dès que votre compte aura été activé.",
"Please do not attempt to login until you receive the email notification." => "Merci de ne pas essayer de vous connecter avant réception du courriel de confirmation.",
// "New {\$prefs.mail_template_custom_text}article post" => "New {\$prefs.mail_template_custom_text}article post",
// "Edit {\$prefs.mail_template_custom_text}article post" => "Edit {\$prefs.mail_template_custom_text}article post",
// "Delete {\$prefs.mail_template_custom_text}article post" => "Delete {\$prefs.mail_template_custom_text}article post",
"{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} de {\$mail_user|username} à",
"View the article at" => "Pour voir cet article",
"Expiration Date" => "Date d'Expiration",
"If you don't want to receive these notifications follow this link" => "Si vous ne voulez plus recevoir ces notifications, suivez le lien",
"The old article follows" => "L'ancien article suit",
// "New {\$prefs.mail_template_custom_text}article post at" => "New {\$prefs.mail_template_custom_text}article post at",
// "Edited {\$prefs.mail_template_custom_text}article post at" => "Edited {\$prefs.mail_template_custom_text}article post at",
// "Deleted {\$prefs.mail_template_custom_text}article post at" => "Deleted {\$prefs.mail_template_custom_text}article post at",
// "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at" => "Le blogue peut être vu à",
// "New {\$prefs.mail_template_custom_text}blog post at %s" => "New {\$prefs.mail_template_custom_text}blog post at %s",
"View item calendar at" => "voir cet évènement de calendrier à",
// "Modified {\$prefs.mail_template_custom_text}calendar item" => "Modified {\$prefs.mail_template_custom_text}calendar item",
// "New {\$prefs.mail_template_custom_text}calendar item" => "New {\$prefs.mail_template_custom_text}calendar item",
"changed" => "modifié",
// "A new {\$prefs.mail_template_custom_text}category was created in" => "A new {\$prefs.mail_template_custom_text}category was created in",
"Created by" => "Créé par",
"created" => "créé",
// "A {\$prefs.mail_template_custom_text}category was removed in" => "A {\$prefs.mail_template_custom_text}category was removed in",
"Removed by" => "Supprimé par",
"removed" => "supprimé",
// "A {\$prefs.mail_template_custom_text}category was updated" => "A {\$prefs.mail_template_custom_text}category was updated",
"Updated by" => "Mise à jour par",
"Old" => "Vieux",
"updated" => "mis à jour",
// "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by",
"an anonymous user" => "un utilisateur anonyme",
// "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by",
"You can view the comment by following this link" => "Vous pouvez voir le commentaire en suivant ce lien",
"File Gallery %s changed" => "La galerie de fichiers %s a été changée",
// "A file was removed from the {\$prefs.mail_template_custom_text}file gallery" => "A file was removed from the {\$prefs.mail_template_custom_text}file gallery",
// "A new file was posted to {\$prefs.mail_template_custom_text}file gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}file gallery",
"File Description" => "Description du fichier",
// "You can download the new file at" => "You can download the new file at",
// "The new file ID is %0 and it is in gallery ID %1" => "The new file ID is %0 and it is in gallery ID %1",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "La galerie d'images {\$galleryName} a changé",
// "A new file was posted to {\$prefs.mail_template_custom_text}image gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}image gallery",
// "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link" => "Vous pouvez voir la carte mise à jour en suivant ce lien",
"You can edit the map following this link" => "Vous pouvez modifier la carte en suivant ce lien",
// "An object was added to {\$prefs.mail_template_custom_text}category" => "An object was added to {\$prefs.mail_template_custom_text}category",
"Added by" => "Ajouté par",
// "An object was removed from {\$prefs.mail_template_custom_text}category" => "An object was removed from {\$prefs.mail_template_custom_text}category",
// "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure" => "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure",
"Structure modified" => "Structure modifiée",
"has consulted your" => "a consulté votre",
"Go to the File Gallery" => "Aller à la Galerie de Fichier",
"Download the file" => "Télécharger le fichier",
// "A new file has been attached to {\$prefs.mail_template_custom_text}page" => "A new file has been attached to {\$prefs.mail_template_custom_text}page",
"File name" => "Nom du fichier",
// "New {\$prefs.mail_template_custom_text}attachment on %s, page" => "New {\$prefs.mail_template_custom_text}attachment on %s, page",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here" => "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here",
"You can view the page by following this link" => "Vous pouvez voir la page en suivant ce lien",
"You can view a diff back to the previous version by following this link" => "Vous pouvez voir les différences avec la version précédente en suivant ce lien",
"The changes in this version follow below, followed after by the current full page text." => "Ci-dessous, les changements de cette version suivis du texte complet de la page.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lignes: {\$oldd} changées en +Lignes: {\$newd}",
"The old page content follows below" => "L'ancien contenu de la page suit ci-dessous",
"The new page content follows below." => "Ci-dessous, le nouveau contenu de la page.",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}",
"Wiki page renamed" => "Page Wiki renommée",
"Old name" => "Ancien nom",
"New name" => "nouveau nom",
// "Your %0account ID" => "Your %0account ID",
// "has been generated" => "has been generated",
"Thank you for your %0registration" => "Merci de vous être enregistré(e) %0",
"You may log in now." => "Vous pouvez vous connecter maintenant.",
// "Operation Completed" => "Operation Completed",
// "Return to Query List" => "Return to Query List",
// "Do you really want to remove the %0 account" => "Do you really want to remove the %0 account",
// "Delete Account" => "Delete Account",
"Active" => "Activé",
"Account name" => "Nom du compte",
// "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND" => "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND",
// "Reply handler requires notifications to be enabled and the reply email pattern to be configured" => "Reply handler requires notifications to be enabled and the reply email pattern to be configured",
"POP server" => "Serveur POP",
// "POP" => "POP",
"IMAP" => "IMAP",
"Admin Topics" => "Administrer les sujets",
"Admin Types" => "Administrer les types",
"Allow anonymous access" => "Permettre un accès anonyme",
// "Warning: Enabling anonymous access will disable all permission checking for mailed-in content" => "Warning: Enabling anonymous access will disable all permission checking for mailed-in content",
// "Allow admin access" => "Allow admin access",
// "Administrators have full access to the system. Disabling admin mail-in is the safest option" => "Administrators have full access to the system. Disabling admin mail-in is the safest option",
"Allow attachments" => "Permettre les fichiers joints",
// "Allow routing" => "Allow routing",
// "Allow per user routing of incoming email to structures" => "Allow per user routing of incoming email to structures",
// "Show inline images" => "Show inline images",
// "For HTML email, attempt to create a WYSIWYG wiki-page" => "For HTML email, attempt to create a WYSIWYG wiki-page",
// "Keep HTML format" => "Keep HTML format",
// "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection" => "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection",
"Discard to the end from" => "Ignorer la fin à partir de",
// "Auto-assign category" => "Auto-assign category",
// "Only affects wiki-put, when creating a new wiki page" => "Only affects wiki-put, when creating a new wiki page",
// "Auto-assign namespace" => "Auto-assign namespace",
// "Email response when no access" => "Email response when no access",
// "Leave email on server on error" => "Leave email on server on error",
// "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki" => "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki",
// "Add Account" => "Add Account",
// "Operation not reversible" => "Operation not reversible",
// "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used" => "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used",
"Event" => "Évènement",
// "Disable rule" => "Disable rule",
// "Enable rule" => "Enable rule",
// "Unknown status" => "Unknown status",
// "Current Type" => "Current Type",
// "New Type" => "New Type",
// "The rule has been removed" => "The rule has been removed",
// "Are you sure you want to delete this rule" => "Are you sure you want to delete this rule",
// "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it" => "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it",
// "Sample Rule" => "Sample Rule",
// "Basic Rule (Record Event)" => "Basic Rule (Record Event)",
// "Tracker Rule" => "Tracker Rule",
// "Advanced Rule" => "Advanced Rule",
// "Community Control Panel" => "Community Control Panel",
// "Event Chain Diagram" => "Event Chain Diagram",
// "Rule Type" => "Rule Type",
// "Allow Notifications" => "Allow Notifications",
// "Recipient" => "Recipient",
// "Cached sample data helps to view available variables for event types" => "Cached sample data helps to view available variables for event types",
// "Sample available" => "Sample available",
// "Sample currently not available" => "Sample currently not available",
// "Source Event" => "Source Event",
// "Target Event" => "Target Event",
// "All event names are required to have at least 3 components" => "All event names are required to have at least 3 components",
// "%0 Copy" => "%0 Copy",
// "Clone of Menu Id" => "Clone of Menu Id",
// "Symbol Information" => "Symbol Information",
// "Profile Source" => "Profile Source",
"Clone" => "Cloner",
"dynamic collapsed" => "sous-menus non vus",
"dynamic extended" => "sous-menus vus",
"fixed" => "fixe",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
"Folder Icon" => "Icône des répertoires",
"Path and filename of closed folder icon" => "Chemin et nom de l'icône d'un répertoire fermé",
"Configure icons for menu entries" => "Configurer les icônes pour les entrées de menu",
"For wiki page, use ((PageName))." => "Pour les pages wiki, utilisez ((NomdePage)).",
"Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Sélection de deux groupes signifie que l'option sera vue si l'utilisateur appartient aux deux groupes. Si vous voulez que les deux groupes voient l'option, créer 2 options, une pour chacun des groupes",
"If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "Si le lien est ((PageName)), vous n'avez pas besoin de mettre les groupes, l'option ne s'affichera que si la page peut être affichée",
"Sections" => "Sections",
"Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Séparer des préférences/fonctionnalités avec une virgule ( , ) pour un ET (AND) ou une barre verticale ( | ) pour un OU (OR)",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Séparer les permissions multiples avec une virgule (,) pour une condition ET ou avec une barre verticale (|) pour un OU",
// "Input an HTML class value for the menu option. Separate with a space for multiple classes" => "Input an HTML class value for the menu option. Separate with a space for multiple classes",
"Tips" => "Astuces",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "Pour ajouter de nouvelles options au menu, positionnez le champ optionId à 0. Pour retirer une option, positionnez le champ suppression à 'y'",
// "Duplicate options will be ignored" => "Duplicate options will be ignored",
"Show Quick URLs" => "Montre l'aide URLs",
"Some useful URLs" => "Adresses Web utiles",
"Hide Quick URLs" => "Cacher l'aide URLs",
"Home" => "Accueil",
"Choose" => "Choisir",
"Home Page" => "Page d'accueil",
"Home Blog" => "Accueil-Blogue",
"Home Image Gal" => "Accueil-Gal. images",
"Home Image Gallery" => "Accueil-Galerie d'images",
"Home File Gal" => "Accueil-Gal. fichiers",
"Home File Gallery" => "Accueil-Galerie de fichiers",
"User preferences" => "Préférences utilisateur",
"User prefs" => "Préf. utilisateur",
"Wiki Home" => "Accueil - Wiki",
"List galleries" => "Liste des galeries",
"List image galleries" => "Liste des galeries d'images",
"Upload image" => "Envoyer une image",
"Gallery Rankings" => "Classements des galeries",
"Browse a gallery" => "Parcourir une galerie",
"Articles home" => "Accueil-articles",
"All articles" => "Tous les articles",
"List Blogs" => "Liste des blogues",
"Create Blog" => "Créer un blogue",
"View a forum" => "Afficher un forum",
"View a thread" => "Afficher un fil de discussion",
"View a FAQ" => "Afficher une FAQ",
"Take a quiz" => "Remplir un QCM",
"Quiz stats" => "Statistiques sur les QCMs",
"Stats for a Quiz" => "Statistiques sur le QCM",
"Message Archive" => "Message archivé",
"Archive is full!" => "L'archive est pleine !",
"Unread" => "Non-lu",
"Flagged" => "Avec drapeau",
"Unflagged" => "Pas de drapeau",
"Containing" => "Contient",
"Sender" => "Expéditeur",
"No messages to display" => "Aucun message à afficher",
"Broadcast message" => "Diffuser un message",
"All users" => "Tous les utilisateurs",
"Lowest" => "Mini",
"Very High" => "Très prioritaire",
"Send" => "Envoyer",
"Compose message" => "Composer un message",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Si vous voulez donner la possibilité aux autres utilisateurs de vous répondre, activez <a href='tiki-user_preferences.php'>Autoriser les messages d'autres utilisateurs</a> dans vos préférences.",
// "To: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "To: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"CC" => "CC",
// "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"Reply-to my email" => "Répondre à mon mail",
"The user will be able to reply to you directly via email" => "L'utilisateur pourra vous répondre directement par courriel",
"Send me a copy" => "M'envoyer une copie",
"You will be sent a copy of this email" => "Vous allez recevoir une copie de ce mail",
"No messages to download" => "Pas de messages à télécharger",
// "full" => "full",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "La boîte à lettre est pleine! Détruisez ou archivez des messages si vous voulez continuer à en recevoir.",
"is reply to" => "Répond à",
"Find replied message" => "trouver les messages répondus",
"Perform action with checked:" => "Action à mener sur les éléments sélectionnés :",
"Mark as read" => "Marquer lu",
"Mark as unread" => "Marquer non-lu",
"Mark as flagged" => "Mettre un drapeau",
"Mark as unflagged" => "Ne pas mettre de drapeau",
"Mark" => "marquer",
"Mailbox" => "Boîte aux lettres",
"Compose" => "Composer",
"Broadcast" => "Envoyer à un groupe",
"Sent" => "Envoyé",
"Auto-archive age for read messages" => "Âge d'auto-archivage pour les messages lus",
"Read message" => "Lire le message",
// "Flagged:Click to unflag" => "Flagged:Click to unflag",
// "Not flagged:Click to flag" => "Not flagged:Click to flag",
"replyall" => "répondre à tous",
// "Reply All" => "Reply All",
"Cc" => "Cc",
// "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>",
// "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>",
"Sent Messages" => "Messages envoyés",
"Replied" => "Répondu",
"Not replied" => "Non répondu",
"Move to archive" => "Mettre en archive",
// "Image Metadata for" => "Image Metadata for",
// "<em>Note: only basic metadata processed for this file type</em>" => "<em>Note: only basic metadata processed for this file type</em>",
// "{\$subtypes@key|escape}" => "{\$subtypes@key|escape}",
// "{\$fields@key|lower|capitalize|escape}" => "{\$fields@key|lower|capitalize|escape}",
// "{\$fieldarray.label|escape}" => "{\$fieldarray.label|escape}",
// "{\$fieldarray@key|escape}" => "{\$fieldarray@key|escape}",
// "{\$fieldarray.suffix|escape}" => "{\$fieldarray.suffix|escape}",
// "No metadata found" => "No metadata found",
// "Read-only metadata extracted from the file" => "Read-only metadata extracted from the file",
// "<em>Only basic metadata processed for this file type.</em>" => "<em>Only basic metadata processed for this file type.</em>",
"Control panels" => "Panneaux de contrôle",
"Turn on interactive translation" => "Activer la traduction interactive",
"Comment moderation" => "Modération des commentaires",
"Clear all caches" => "Effacer toutes les caches",
"Plugin approval" => "Approbation du plugin",
// "Logs" => "Logs",
"Smarty debug window" => "Fenêtre de débogage Smarty",
"Display type unknown, you have to enter the banner type" => "Type de bannière inconnu, Vous devez donner le type de bannière",
"You forgot your Google ad_client number !" => "Vous avez oublié votre numéro de client Google AdSense !",
"Thank you for installing Tiki" => "Merci d'avoir installé Tiki",
"To configure your Tiki" => "Pour configurer votre Tiki",
"from the menu" => "du menu",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Lire la <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Documentation Tiki\" target=\"_blank\">documentation de configuration</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Regarder les <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Démos\" target=\"_blank\">vidéos de démonstration",
"To remove this module" => "Pour supprimer ce module",
"Admin Modules" => "Administrer les modules",
"and remove the assistant module" => "et retirer l'assistant module",
"You can also add other modules" => "Vous pouvez aussi ajouter d'autres modules",
"To customize the menu" => "Pour modifier le menu",
"Admin Menus" => "Administrer les menus",
"and edit menu ID 42" => "et modifier le menu ID 42",
"Or, create your own menu and add it to a module" => "Ou créez votre propre menu et ajoutez-le à un module",
"To begin configuring Tiki, please" => "Pour commencer la configuration de Tiki : ",
"login" => "identification",
"as admin" => "en tant qu'Admin",
"The Tiki Community" => "La communauté Tiki",
"To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "Pour en savoir plus, visiter : <a href=\"http://tiki.org\" title=\"La Communauté Tiki\" target=\"_blank\">http://tiki.org</a>",
"Tiki Documentation" => "Documentation Tiki",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "Pour de l'aide, consultez <a href=\"http://doc.tiki.org\" title=\"Documentation Tiki\" target=\"_blank\">http://doc.tiki.org</a>",
"on" => "le",
"Published on" => "Publié le",
"on blogpost" => "sur l'article de blogue",
"Untitled" => "Sans titre",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add Event" => "Ajouter un évènement",
"Unit cost" => "Coût unitaire",
"Qty" => "Qté",
// "Cart contains <span>%0</span> items" => "Cart contains <span>%0</span> items",
// "Total weight %0 %1" => "Total weight %0 %1",
"Gift Certificate" => "Certificat-Cadeau",
"Remove Gift Certificate" => "Retirer le Certificat-Cadeau",
"Add Gift Certificate" => "Ajouter un certificat-cadeau",
"Total:" => "Total :",
"Check-out" => "Régler",
"Your cart is empty" => "Votre caddie est vide",
"Missing %0 of the following categories" => "%0 manquant des catégories suivantes",
"%0 extra of the following categories" => "%0 supplémentaire des catégories suivantes",
"Unknown comparison" => "Comparaison inconnue",
"Impossible condition, %0 of" => "Condition impossible , %0 de",
"Assign into category" => "Assigner à une catégorie",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
"Unassign category" => "Retirer de la catégorie",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Page d'accueil",
"1 more contributor" => "un contributeur de plus",
"{\$hiddenContributors} more contributors" => "{\$hiddenContributors} contributeurs de plus",
"low" => "bas",
"Sites" => "Sites",
"Sites to validate" => "Sites à valider",
"Categories:" => "Catégories :",
"Visited links" => "Liens visités",
"Pass" => "Mot de passe",
"Add tags" => "Ajouter des mots-clés",
// "No tags yet" => "No tags yet",
"List everything tagged" => "Lister tout ce qui est marqué",
"Last updated" => "Dernière modification",
"All Groups" => "Tous les groupes",
"Your Groups" => "Vos groupes",
"Emulated Groups" => "Les groupes émulés",
"Switch to Groups" => "Passer aux Groupes",
"Simulate" => "Simuler",
// "Add Post" => "Add Post",
"insert original" => "insérer l'original",
"insert thumbnail" => "insérer la miniature",
"more" => "plus",
"Last %0 Podcasts" => "Derniers %0 podcasts",
"This is likely not a podcast file" => "Cela n'est sûrement pas un fichier de podcast",
"The path to a podcast player is required" => "Le chemin vers un lecteur de podcast est requis",
// "{\$link_text}" => "{\$link_text}",
"No profile picture" => "Pas d'avatar",
"You" => "Vous",
// "Never logged in" => "Never logged in",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Ouvrir une console opérateur",
"Execution time" => "Temps d'exécution",
"Memory usage" => "Mémoire utilisée",
// "Queries" => "Queries",
"Server load" => "Charge du serveur",
"Logged in as" => "Connecté comme",
"Log out" => "Déconnexion",
// "Return to Main User" => "Return to Main User",
// "Return to main user" => "Return to main user",
"Switch" => "Échanger",
"Switch User" => "Se connecter comme",
"Email:" => "Adresse courriel :",
// "Email address or " => "Email address or ",
// "User account ID" => "User account ID",
// "Enter a username and click 'Switch'.<br>Useful for testing permissions" => "Enter a username and click 'Switch'.<br>Useful for testing permissions",
"Switch user" => "Se connecter comme",
// "Toggle Dropdown" => "Toggle Dropdown",
"My Account" => "Mon compte",
// "{\$user|username|escape|replace:'&amp;':'&'}" => "{\$user|username|escape|replace:'&amp;':'&'}",
"Log in through CAS" => "Connexion via CAS",
"Log in as admin" => "Connexion en admin",
"Log in through Shibboleth" => "Connexion via Shibboleth",
// "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t" => "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t",
"Password:" => "Mot de passe :",
"CapsLock is on" => "Verouillage Maj. (CapsLock) est actif",
"Click here if you've forgotten your password" => "Cliquer ici si vous avez oublié votre mot de passe",
"I forgot my password" => "J'ai oublié mon mot de passe",
"Click here to register" => "Cliquer ici pour vous inscrire",
"Click here to log in using the default security protocol" => "Cliquer ici pour vous connecter avec le protocole de sécurité par défaut",
"Standard" => "Standard",
"Click here to log in using a secure protocol" => "Cliquer ici pour vos connecter en utilisant un protocole sécurisé",
"Secure" => "Sécurisé",
"Stay in SSL mode" => "Rester dans le mode SSL",
"local account" => "compte local",
// "Log in via Facebook" => "Log in via Facebook",
// "Log in via LinkedIn" => "Log in via LinkedIn",
"OpenID Log in" => "Connexion via OpenID",
// "OpenID Login" => "OpenID Login",
"What is OpenID" => "Qu'est-ce que OpenID",
// "Change the logo" => "Change the logo",
// "Click to change or upload new logo" => "Click to change or upload new logo",
// "{\$module_params.sitetitle|escape}" => "{\$module_params.sitetitle|escape}",
// "{\$module_params.sitesubtitle|escape}" => "{\$module_params.sitesubtitle|escape}",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
// "Edit this menu" => "Edit this menu",
"You have" => "Vous avez",
"new messages" => "nouveaux messages",
"new message" => "nouveau message",
"You have 0 new messages" => "Vous n'avez aucun nouveau message",
"No article found" => "Aucun article trouvé",
"No blog post found" => "Aucun article de blog trouvé",
"We have" => "Il y a",
"submissions waiting to be examined" => "Soumissions en attente d'examen",
// "Permissions applied from" => "Permissions applied from",
// "No permissions to display" => "No permissions to display",
"Stay on this page" => "Rester sur cette page",
"Edit perspectives" => "Modifier les perspectives",
"Within %0" => "Dans %0",
"Search Terms" => "Rechercher des termes",
"Any type" => "N'importe quel type",
"Recent Preferences" => "Préférences récentes",
"Wiki feed" => "Flux RSS des Wiki",
"Blogs feed" => "Flux RSS des blogues",
"Articles feed" => "Flux RSS des articles",
"Image Galleries feed" => "Flux RSS des galeries d'images",
"Image Galleries" => "Galeries d'images",
"File Galleries feed" => "Flux RSS des galeries de fichiers",
"Forums feed" => "Flux RSS des forums",
"Directory feed" => "Flux de répertoire",
"Calendar feed" => "Flux de calendrier",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Tout le site",
"Image Gals" => "Galeries d'images",
"Search for text throughout the site" => "Rechercher du texte dans l'ensemble du site",
"Go directly to a page, or search in page titles if exact match is not found" => "Aller directement à une page, ou rechercher dans les titres de page si une correspondance exacte n'est pas trouvée",
"Edit existing page or create a new one" => "Modifier une page existante ou créer une nouvelle",
"External" => "Externe",
"Exact match" => "Correspondance exacte",
"Page Relations" => "Relations de page",
// "Get short url" => "Get short url",
"Copy" => "Copier",
// "Copied" => "Copied",
"Tweet with Twitter" => "Publier sur Twitter",
"Post on my Facebook wall" => "Poster sur mon mur Facebook",
"Shout date" => "Date de l'annonce",
"Delete this shout" => "Effacer ce \"cri\"",
"Edit this shout" => "Modifier cette annonce",
"Read More" => "En lire plus",
"Since your last visit on" => "Depuis votre dernière visite sur",
"New Images" => "Nouvelle(s) image(s)",
"Wiki Pages Changed" => "Page(s) Wiki modifiée(s)",
"New Files" => "Nouveau(x) fichier(s)",
"New Comments" => "Nouveau(x) commentaire(s)",
"New Tracker Items" => "Nouvelle(s) fiche(s) de formulaire",
"New Calendar Events" => "Nouveaux évènements du calendrier",
"New Users" => "Nouveau(x) utilisateur(s)",
"click to edit" => "cliquer pour modifier",
"Nothing has changed" => "Aucun changement",
"Tracker Items" => "Fiches du formulaire",
"Updated" => "mis à jour",
"Multiple" => "Multiple",
"including" => "incluant",
// "No Subversion checkout or unable to determine last update" => "No Subversion checkout or unable to determine last update",
"Find term" => "Chercher un terme",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
"If not found, you will be given a chance to create it" => "Si le terme n'est pas trouvé, on vous donnera l'occasion de le créer",
"TikiTests Menu" => "Menu TikiTests",
"List Tests" => "Liste de Tests",
"Create Test" => "Créer un Test",
"Top galleries" => "Galeries les plus populaires",
"Posted to" => "Posté pour",
"(Read More)" => "(Lire Plus)",
// "Missing values" => "Missing values",
"Add Marker" => "Ajouter un marqueur",
"Tracker name" => "Nom du formulaire",
"Insert fields in wiki textarea" => "Insérer des champs dans une zone de texte wiki",
"There are no translations of this page." => "Il n'y a pas de traductions de cette page.",
"Up-to-date-ness" => "Actualisation",
"Incoming" => "Entrant",
"To <strong>continue translating</strong>, select the language to translate from" => "Pour <strong>poursuivre la traduction</strong>, choisir la langue d'origine à traduire",
"update from it" => "mettre à jour à partir de",
"None match your" => "Rien ne correspond au vôtre",
"Set your preferred languages." => "Mettre à jour vos langues préférées.",
"preferred languages" => "langues préférées",
"Outgoing" => "Sortant",
"update it" => "mettre à jour",
"click to view" => "cliquer pour voir",
"Bookmarks" => "Signets",
"Cache" => "Antémémoire",
// "Create Bookmark" => "Create Bookmark",
// "New Folder" => "New Folder",
"Done" => "fait",
"Del" => "Effacer",
"select" => "choisissez",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
// "Group information" => "Group information",
"You need to activate user and/or group trackers" => "Vous devez activer les formulaires utilisateur et/ou groupe",
"view" => "afficher",
// "%0 out of %1 users" => "%0 out of %1 users",
"online users" => "utilisateurs connectés",
"online user" => "utilisateur connecté",
"on host" => "sur le serveur",
"User does not accept messages" => "L'utilisateur n'accepte pas les messages",
"Send a message to" => "Envoyer un message à",
"More Videos" => "Plus de vidéos",
"No results were found. Are you sure you searched for a tag" => "Auncun résultat trouvé. Êtes-vous sûr(e) d'avoir cherché un mot-clé",
"We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "Nous ne sommes pas autorisés à accéder au groupe à cet instant. Si vous avez accès au groupe Zotero, vous pouvez donner le droit de lecture à ce site",
// "Mark all as read" => "Mark all as read",
// "You receive this notification because you requested it" => "You receive this notification because you requested it",
// "If you did not request these emails or did so in an error, please use the following link" => "If you did not request these emails or did so in an error, please use the following link",
// "Manage your notifications" => "Manage your notifications",
// "Notification Digest" => "Notification Digest",
// "No notifications available" => "No notifications available",
// "Priorities" => "Priorities",
// "No unread notifications" => "No unread notifications",
// "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped" => "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped",
// "Required Action" => "Required Action",
// "Add all members" => "Add all members",
// "OR Select individuals.." => "OR Select individuals..",
// "Add selected members" => "Add selected members",
"Detail" => "Détail",
// "Respond" => "Respond",
// "Opened" => "Opened",
// "Logged In" => "Logged In",
// "Unopened" => "Unopened",
// "People" => "People",
// "Empty list" => "Empty list",
// "Responses" => "Responses",
// "Entry" => "Entry",
"Request Date" => "Date de demande",
// "Action Req'd" => "Action Req'd",
// "None (Owner)" => "None (Owner)",
// "Nothing to do" => "Nothing to do",
// "Add Item" => "Add Item",
// "On this document" => "On this document",
// "Saving" => "Saving",
// "This window will close automatically in 3 seconds.." => "This window will close automatically in 3 seconds..",
// "An error occurred, please try again" => "An error occurred, please try again",
// "Consent screen" => "Consent screen",
// "Do you really want to proceed" => "Do you really want to proceed",
"No individual permissions, category permissions apply" => "Aucune permission individuelle ne s'applique, les permissions sur les catégories s'appliquent",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "Pas de droit d'accès individuel : les droits globaux s'appliquent",
// "Search and select what you are looking for from the options that appear" => "Search and select what you are looking for from the options that appear",
// "No matching results" => "No matching results",
// "Search and select what you are looking for from the options that appear." => "Search and select what you are looking for from the options that appear.",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparaison de la version {\$old.version} à la version {\$new.version}",
"Current" => "En cours",
"Session" => "Session",
"Old Session" => "Ancienne session",
"Old Version" => "Ancienne version",
"New Session" => "Nouvelle session",
"New Version" => "Nouvelle version",
"Versions are identical" => "Les versions sont identiques",
// "Example wikidiff plugin syntax" => "Example wikidiff plugin syntax",
"Minimum %0 characters long" => "Minimum %0 caractères de long",
// "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + ..",
// "Password is too common" => "Password is too common",
// "Individual permissions" => "Individual permissions",
// "Select image" => "Select image",
// "Pick a file" => "Pick a file",
// "Upload or record media" => "Upload or record media",
// "Convert to List" => "Convert to List",
// "{\$info.title|escape}" => "{\$info.title|escape}",
// "{\$info.description|default:''|escape}" => "{\$info.description|default:''|escape}",
// "Auto generate Biblio Code" => "Auto generate Biblio Code",
// "New reference created" => "New reference created",
// "Problems while creating the reference" => "Problems while creating the reference",
// "[-]" => "[-]",
"vote" => "voter",
// "Use &quot;%0&quot; to separate values" => "Use &quot;%0&quot; to separate values",
// "Reset to default value" => "Reset to default value",
// "Restore current value" => "Restore current value",
// "Change your preference filter settings in order to view advanced preferences by default" => "Change your preference filter settings in order to view advanced preferences by default",
"advanced" => "avancé",
// "Change your preference filter settings in order to view experimental preferences by default" => "Change your preference filter settings in order to view experimental preferences by default",
// "experimental" => "experimental",
"Requires" => "Nécessite",
// "You need apply profile" => "You need apply profile",
"You need to set" => "Vous devez définir",
// "Requires package" => "Requires package",
// "Missing tiki package" => "Missing tiki package",
// "User rating" => "User rating",
"Rate" => "Notation",
// "User rating on thread topic" => "User rating on thread topic",
// "Debug Information" => "Debug Information",
// "Engine does not provide any debug information" => "Engine does not provide any debug information",
"A valid email is mandatory to register" => "Une adresse électronique valide est nécessaire pour s'inscrire",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email address as your log-in name" => "Utilisez votre adresse électronique pour vous connecter",
"Lowercase only" => "Minuscules seulement",
// "New Password" => "New Password",
"Confirm password" => "Encore",
// "Passwords match" => "Passwords match",
"Generate a password" => "Générer un mot de passe",
"Passcode to register" => "Code d'enregistrement",
"Not your password" => "Pas votre mot de passe",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
"The passcode (to block robots from registration) is" => "Le code d'enregistrement à saisir ici est",
// "{\$remarksbox_title|escape}" => "{\$remarksbox_title|escape}",
// "Do you really want to remove the %0 scheduler" => "Do you really want to remove the %0 scheduler",
// "Reset the scheduler, will mark this run as failed, allowing it to be executed again" => "Reset the scheduler, will mark this run as failed, allowing it to be executed again",
// "Back to schedulers list" => "Back to schedulers list",
// "Reversal Event" => "Reversal Event",
// "Unique Name" => "Unique Name",
// "Type (e.g. user)" => "Type (e.g. user)",
// "Field value (e.g. user)" => "Field value (e.g. user)",
// "Pt. value" => "Pt. value",
"The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "Les documents sont retournés sur la pertinence triés en fonction de l'ordre, la proximité, la fréquence des termes. ",
"Default search behavior" => "Comportement par défaut de la recherche",
"By default, all search terms are <em>optional</em>" => "Par défaut, tous les termes de recherche sont <em>optionnels</em>",
"It behaves like an OR logic" => "Il se comporte comme un OU logique",
"Objects that contain the more terms are rated higher in the results and will appear first" => "Les objets qui contiennent le plus de termes sont classés plus haut dans les résultats et apparaitront en première position",
"For example, <strong>wiki forum</strong> will find" => "Par exemple, <strong>wiki forum</strong> retrouvera",
"objects that include both tokenized terms" => "objets qui contiennent tous les termes",
"objects that include the term <strong>wiki</strong>" => "objets qui contiennent le terme <strong>wiki</strong>",
"objects that include the term <strong>forum</strong>" => "objets qui contiennent le term <strong>forum</strong>",
"Boolean operators" => "Opérateurs booléens",
"You can use AND or OR or NOT also to do a boolean search" => "Vous pouvez utiliser AND ou OR ou aussi NOT pour faire une recherche booléenne",
"Example: <strong>wiki and forum</strong> will find objects with both terms" => "Exemple : <strong>wiki and forum</strong> va trouver les objets qui contiennent les deux termes",
"Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Exemple : <strong>wiki or forum</strong> va trouver les objets qui contiennent l'un ou l'autre des termes",
"Grouping terms" => "Groupement de termes",
"Use parenthesis ( ) to group terms into subexpressions" => "Utiliser les parenthèses ( ) pour grouper les termes en sous-expressions",
"Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Exemple : <strong>wiki and (forum blog)</strong> va trouver les objets qui contiennent <strong>wiki</strong> et <strong>forum</strong> ou qui contiennent <strong>wiki</strong> et <strong>blog</strong> dans n'importe quel ordre",
"Finding phrases" => "Recherche de phrases",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other" => "Encadrer la phrase par des guillemets ( <kbd>\" \"</kbd> ) pour trouver les termes en ordre exact, côte à côte",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Exemple : <kbd>\"Alex Bell\"</kbd> ne retournera pas <strong>Bell Alex</strong> ou <strong>Alex G. Bell</strong> mais <strong>Alex Bells</strong>. ",
// "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it" => "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it",
// "media image" => "media image",
// "Expand table" => "Expand table",
// "Restore layout" => "Restore layout",
"Items found" => "Fiches trouvées",
"Indexed" => "Indexed",
// "Queue size" => "Queue size",
// "Batch Size" => "Batch Size",
// "Process %0" => "Process %0",
// "Process Batch" => "Process Batch",
// "Your index was last fully rebuilt on %0" => "Your index was last fully rebuilt on %0",
"version" => "version",
// "Fallback search engine" => "Fallback search engine",
// "Fallback search index was rebuild" => "Fallback search index was rebuild",
// "Fallback search index was not rebuilt" => "Fallback search index was not rebuilt",
// "Execution Statistics" => "Execution Statistics",
// "Current Memory usage" => "Current Memory usage",
// "Memory peak usage before indexing" => "Memory peak usage before indexing",
// "Memory peak usage after indexing" => "Memory peak usage after indexing",
// "Number of queries" => "Number of queries",
// "Rebuilding index.." => "Rebuilding index..",
// "Enable logging" => "Enable logging",
// "Log file is saved as %0" => "Log file is saved as %0",
// "Rebuild" => "Rebuild",
// "Process Queue" => "Process Queue",
// "Indexing Problems" => "Indexing Problems",
// "If the indexing does not complete, check the log file to see where it ended" => "If the indexing does not complete, check the log file to see where it ended",
// "Last line of log file (web)" => "Last line of log file (web)",
// "Last line of log file (console)" => "Last line of log file (console)",
// "Not enough memory" => "Not enough memory",
// "Time limit too short" => "Time limit too short",
// "High resource usage" => "High resource usage",
// "Command Line Utilities" => "Command Line Utilities",
// "Cache Expired" => "Cache Expired",
// "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over" => "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over",
"Index" => "Index",
// "Defined" => "Defined",
"Valid" => "Valide",
// "May not work or corrupt data" => "May not work or corrupt data",
// "Alter" => "Alter",
// "No instances configured" => "No instances configured",
// "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes" => "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes",
// "Create Index" => "Create Index",
// "Return to List of Saved Searches" => "Return to List of Saved Searches",
// "Do you really want to remove the %0 saved search" => "Do you really want to remove the %0 saved search",
// "Other Queries" => "Other Queries",
// "No stored queries" => "No stored queries",
"Create New" => "Créer un nouveau",
// "This will help you recognize your stored queries if ever you want to modify or remove them" => "This will help you recognize your stored queries if ever you want to modify or remove them",
// "Use Existing" => "Use Existing",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "Dernière modification",
// "No pages matched the search criteria test" => "No pages matched the search criteria test",
"Download Log File" => "Télécharger le fichier de log",
// "Resend newsletter" => "Resend newsletter",
"Send Newsletter" => "Envoyer la lettre d'informations",
// "Send newsletter" => "Send newsletter",
// "This content is licensed under the terms of the" => "This content is licensed under the terms of the",
"To edit the copyright notices" => "Pour modifier les notices de copyright",
// "Know the username" => "Know the username",
// "%0 has been accepted" => "%0 has been accepted",
// "Do you really want to approve %0" => "Do you really want to approve %0",
// "Do you really want to remove %0" => "Do you really want to remove %0",
// "No friends have been added" => "No friends have been added",
// "Incoming requests" => "Incoming requests",
// "Accept and add" => "Accept and add",
// "Still waiting for approval" => "Still waiting for approval",
// "Do you really want to cancel request for %0" => "Do you really want to cancel request for %0",
// "%0 has been removed from your friends" => "%0 has been removed from your friends",
// "Page alias.." => "Page alias..",
"Monitor the Sub-Structure" => "Surveiller la sous-structure",
"Stop Monitoring the Sub-Structure" => "Arrêter de surveiller cette sous-structure",
// "locked by %0" => "locked by %0",
"Locked" => "Verrouillé",
"Edit page" => "Édition",
// "Add new child page" => "Add new child page",
// "About &amp; News" => "About &amp; News",
// "Information and introduction portal" => "Information and introduction portal",
"Documentation" => "Documentation",
// "How to use Tiki" => "How to use Tiki",
// "Development" => "Development",
// "How make Tiki" => "How make Tiki",
// "Forums and general community information" => "Forums and general community information",
// "How make Tiki look pretty" => "How make Tiki look pretty",
// "Manage" => "Manage",
// "Initializite this format with the current tracker fields" => "Initializite this format with the current tracker fields",
// "Tracker Name" => "Tracker Name",
// "File Delimiter" => "File Delimiter",
// "Comma (,)" => "Comma (,)",
// "Semicolon (;)" => "Semicolon (;)",
// "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes" => "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes",
"Field Type" => "Type de champ",
// "Primary Key" => "Primary Key",
// "PK" => "PK",
// "Unique Key" => "Unique Key",
// "UK" => "UK",
// "Read-Only" => "Read-Only",
// "RO" => "RO",
// "Export-Only" => "Export-Only",
// "EO" => "EO",
// "Required to import data. Can be any field as long as it is unique" => "Required to import data. Can be any field as long as it is unique",
// "Impose unique value requirement for the target column. This only works with Transactional Import feature" => "Impose unique value requirement for the target column. This only works with Transactional Import feature",
// "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process" => "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process",
// "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict" => "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict",
// "Simple headers" => "Simple headers",
// "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format" => "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format",
// "Import updates" => "Import updates",
// "Import update" => "Import update",
// "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported" => "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported",
// "Ignore blanks" => "Ignore blanks",
// "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way" => "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way",
// "Transactional import" => "Transactional import",
// "Import transaction" => "Import transaction",
// "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved" => "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved",
// "Bulk import" => "Bulk import",
// "Bulk Import" => "Bulk Import",
// "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent" => "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent",
// "Are you sure you want to delete this item" => "Are you sure you want to delete this item",
// "Delete item" => "Delete item",
// "Select a field.." => "Select a field..",
// "Select Mode" => "Select Mode",
// "No primary key" => "No primary key",
// "Side" => "Side",
// "Filters will be available in partial export menus" => "Filters will be available in partial export menus",
// "Skip Unmodified" => "Skip Unmodified",
// "Will not re-import items that have not changed" => "Will not re-import items that have not changed",
// "Import Completed" => "Import Completed",
// "Your import was completed succesfully" => "Your import was completed succesfully",
"CSV File" => "Fichier CSV",
// "Applied filters" => "Applied filters",
// "Create Tracker from File" => "Create Tracker from File",
// "Export Full" => "Export Full",
// "Export Partial" => "Export Partial",
// "Export Custom" => "Export Custom",
// "No tabular formats defined" => "No tabular formats defined",
// "Modes" => "Modes",
"This book" => "Ce livre",
"before" => "avant",
"after" => "après",
"don't display" => "ne pas afficher",
"Decimals" => "Décimales",
"Decimal Point" => "Marque décimale",
"Auto Tax" => "Taxe Auto",
"Tasks" => "Tâches",
"Book new entries" => " Enregistrer de nouvelles opérations",
"Confirm stack entries" => "Confirmer les entrées du brouillard",
"Book into Stack" => "Enregistrer dans le Brouillard",
"Accounts" => "Comptes",
"Journal" => "Journal",
"Fetch all" => "Lire tout",
"Create new account" => "Créer un nouveau compte",
"Edit Account" => "Modifier le Compte",
"Account number" => "Numéro de compte",
"Notes" => "Liste des notes",
"Budget" => "Budget",
"Create account" => "Créer un compte",
"Modify account" => "Modifier le compte",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1",
"Delete this account" => "Supprimer ce compte",
"Back to book page" => "Retour à la page d'enregistrement",
"Account" => "Compte",
"Debit" => "Débit",
"Credit" => "Crédit",
"Tax" => "Taxe",
// "Unlock account" => "Unlock account",
// "Lock account" => "Lock account",
// "Remove account" => "Remove account",
"Create a new account" => "Créer un nouveau compte",
"printable version" => "version imprimable",
"export table" => "exporter la table",
"View account" => "Voir le compte",
"Edit this account" => "Modifier ce compte",
"My books" => "Mes livres",
"Tax automation" => "Automatisation des taxes",
"hide" => "cacher",
"behind" => "derrière",
// "Close book" => "Close book",
// "Close book? (This action cannot be undone)" => "Close book? (This action cannot be undone)",
"Create a book" => "Créer un livre comptable",
"Book properties" => "Propriétés du livre",
"Name of the book" => "Nom du livre",
"First date in journal" => "Première date dans le journal",
"Last date in journal" => "Dernière date dans le journal",
"Currency settings" => "Réglages monétaires",
"Currency (up to 3 letters) " => "Monnaie (jusqu'à 3 lettres) ",
"Position of the currency " => "Position du symbole monétaire ",
"Show no currency" => "Ne pas afficher la monnaie",
"Show currency in front of numbers" => "Afficher la monnaie devant les nombres",
"Show currency behind numbers" => "Afficher la monnaie derrière les nombres",
"Decimal point" => "Point décimal",
"Decimal" => "Décimales",
"Quote strings with" => "Entourer les chaines avec",
"End of Line" => "Fin de la Ligne",
"Carriage return" => "Retour charriot",
"Line feed" => "Saut de ligne",
"Carriage Return/Line feed" => "Retour charriot/Passage à la ligne",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
"Allow automatic tax calculation" => "Permettre le calcul automatique des taxes",
"Create a new book" => "Créer un nouveau livre",
// "Canceled Journal" => "Canceled Journal",
// "Booking Date" => "Booking Date",
"Amount" => "Montant",
"Book a transaction" => "Enregistrer une écriture",
// "\"}Delete account %0" => "\"}Delete account %0",
"Add entry" => "Ajouter une entrée",
"Book" => "Enregistrer",
// "\"}Record entry in book %0" => "\"}Record entry in book %0",
"Export {\$what}" => "Exporter {\$what}",
"Export CSV settings" => "Exporter les réglages CSV",
"Separator between fields" => "Séparateur entre les champs",
"Quote character for text" => "Caractère d'encadrelent du texte",
"Export as CSV" => "Exporter au format CSV",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1",
// "Cancel transaction" => "Cancel transaction",
"Balance" => "Balance",
"Deleted" => "Supprimé",
"Debit Account" => "Compte Débiteur",
"Debit Amount" => "Montant au Débit",
"Debit Text" => "Libellé Débit",
"Credit Account" => "Compte Créditeur",
"Credit Amount" => "Montant au Crédit",
"Credit Text" => "Libellé Crédit",
"Book a transaction into the stack" => "Enregistrer une écriture dans le Brouillard",
// "\"}Record stack entry in book %0" => "\"}Record stack entry in book %0",
// "\"}Modify stack entry in book %0" => "\"}Modify stack entry in book %0",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1",
// "Remove transaction" => "Remove transaction",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1",
// "Confirm transaction" => "Confirm transaction",
"Do not group by item" => "Ne pas grouper par élément",
"Group by item" => "Grouper par élément",
"Calendar View" => "Vue calendrier",
"Tiki Action Calendar" => "Calendrier des actions Tiki",
"Tools Calendars" => "Calendriers des objets Tiki",
"Check / Uncheck All" => "Cocher/décocher tout",
"Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>" => "Votre email d’expédition n'est pas encore configuré. Vous pouvez le configurer <a href=\"tiki-admin.php?page=general&highlight=sender_email\" class=\"alert-link\">le panneau de configuration générale de l'administrateur  .</a>",
"Database Version Problem" => "Il y a un problème avec la version de votre base de données",
// "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "Vendor folder issues" => "Vendor folder issues",
// "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>" => "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>",
// "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded" => "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded",
// "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries" => "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries",
// "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>" => "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>",
// "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file" => "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file",
// "Installer not locked" => "Installer not locked",
// " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. " => " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. ",
// "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder" => "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder",
// "You can also use the following, on the command line, from the root of your Tiki installation" => "You can also use the following, on the command line, from the root of your Tiki installation",
// "Search Index outdated" => "Search Index outdated",
// "The search index might be outdated. It is recommended to rebuild the search index" => "The search index might be outdated. It is recommended to rebuild the search index",
// "File gallery directory web accessable" => "File gallery directory web accessable",
// "This is a potential security risk" => "This is a potential security risk",
// "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database" => "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database",
// "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>" => "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>",
"Please select some actions to be reported" => "Sélectionnez les actions devant être dans le rapport",
"End" => "Fin",
"Users and Groups" => "Utilisateurs et groupes",
"Misc" => "Divers",
"Units" => "Unités",
"kb" => "ko",
// "Contribution Time" => "Contribution Time",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
"Accumulated Bar Plot" => "Diagramme Barres Accumulées",
"Background color" => "Couleur de fond",
// "{\$color}" => "{\$color}",
"Legend background color" => "Couleur de fond des légendes",
"Save graphs to image gallery" => "Enregistrer les graphiques dans la galerie d'image",
"Records" => "Enregistrements",
"See Statistics" => "Voir les statistiques",
"contribution" => "contribution",
"contributor" => "contributeur",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Delete action from log" => "Delete action from log",
"Select action to perform with checked" => " Sélectionnez l'action à effectuer avec cochée",
// "Delete selected actions from log" => "Delete selected actions from log",
"Edit Action" => "Modifier l'action",
"Save Action" => "Sauvegarder l'action",
"Statistics" => "Statistiques",
"Volumes are equally distributed on each contributors/author" => "Les volumes sont distribués équitablement entre chaque contributeur ou auteur",
"connection time" => "durée de connexion",
"connection seconds" => "temps de connexion en secondes",
"mns" => "mins",
"Volume per category" => "Volume par catégorie",
"Volume per category and per user" => "Volume par catégorie et par utilisateur",
"Number of actions per user" => "Nombre d'actions par utilisateur",
"Total number of users" => "Nombre total d'utilisateurs",
"Number of actions per object" => "Nombre d'actions par objet",
"Total number of objects" => "Nombre total d'objets",
// "Bigbluebutton" => "Bigbluebutton",
// "Time in bigbluebutton (in minutes)" => "Time in bigbluebutton (in minutes)",
"Number of actions per category" => "Nombre d'actions par catégorie",
"Number of actions per category and per user" => "Nombre d'actions par catégorie et par utilisateur",
"Volume per the users' group and per contribution" => "Volume par le groupe de l'utilisateur et par contribution",
"Volume per group and per contribution" => "Volume par groupe et par contribution",
"Volume per user and per contribution" => "Volume par utilisateur et par contribution",
"Volume per users' contribution and time" => "Volume par contribution d'utilisateur et heure",
"Volume per contribution and time" => "Volume par contribution et heure",
"Weeks" => "Semaines",
"How" => "Comment",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded." => "Vous devez cocher les cases enregistrement pour chaque type d'action pour lequel nous aimerions avoir un rapport plus tard. Pour visualiser un rapport de quelque type d'action, cocher leur case rapport, aller sur l'onglet rapport et sélectionner des filtres aditionnels. Le rapport contiendra seulement les actions qui se sont produites depuis le moment où l'enregistrement a été demandé.",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Les actions sur les pages Wiki sauf la visualisation seront toujours enregistrées mais peuvent ne pas être affichées.",
"Recorded" => "Enregistrée",
// "{\$actionlog.action}" => "{\$actionlog.action}",
"Import as CSV" => "Importer en CSV",
"Banning rules have been updated" => "Les règles de bannissement ont été mises à jour",
"Add or edit rules" => "Ajouter ou modifier les règles",
"Rule title" => "Titre de la règle",
"Username regex matching" => "Expression régulière sur les noms d'utilisateur",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "Expression régulière sur les IP",
"Banned from sections" => "Interdit des sections",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Règle activée sur des dates",
"Rule active from" => "Règle active depuis",
"Rule active until" => "Règle active jusqu'à",
"Custom message to the user" => "Message personnalisé à l'utilisateur",
// "Import rules as CSV" => "Import rules as CSV",
"Column names on the first line" => "Nom des colonnes de la première ligne",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
"See" => "Voir",
"Import as new rules" => "Importer comme de nouvelles règles",
// "Current rules" => "Current rules",
"x" => "x",
// "Delete selected banning rules" => "Delete selected banning rules",
"User/IP" => "Utilisateur/IP",
// "Delete banning rule" => "Delete banning rule",
// "No rules found" => "No rules found",
"Admin Calendars" => "Administrer les calendriers",
"Create Calendar" => "Créer un calendrier",
"View Calendars" => "Voir les calendriers",
// "Calendar name" => "Calendar name",
"Participants" => "Participants",
// "Personal" => "Personal",
// "Field will show in popup" => "Field will show in popup",
"Custom location" => "Lieux configurables",
"Custom participants" => "Participants configurables",
// "Custom languages" => "Custom languages",
"Add event" => "Ajouter un évènement",
// "Delete calendar" => "Delete calendar",
"Edit Calendar" => "Modifier le calendrier",
"Custom classification" => "Classification personnalisée",
"Custom language" => "Langues configurables",
"Custom subscription list" => "Liste d'inscriptions configurables",
"Custom priority" => "Priorités configurables",
"Personal Calendar" => "Calendrier personnel",
"Start of day" => "Début de la journée",
"End of day" => "Fin de la journée",
"Days to display" => "Jours à afficher",
"Standard color" => "Couleurs standard",
"Green" => "Vert",
"Purple" => "Violet",
"Orange" => "Orange",
"Yellow" => "Jaune",
"Custom foreground color" => "Couleur d'avant-plan particulière",
"Custom background color" => "Couleur du fond personnalisée",
"Default event status" => "État par défaut des évènements",
// "Show in popup view" => "Show in popup view",
"Show in calendar view" => "Afficher dans la vue calendrier",
"Group of users alerted when calendar event is modified" => "Groupe d'utilisateurs alerté quand le calendrier est modifié",
// "Default length of events is all day" => "Default length of events is all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
"Delete events older than" => "Effacer les événements plus vieux que",
// "Delete old events" => "Delete old events",
"Browse the category system" => "Parcourir le système de catégories",
// "Create category" => "Create category",
// "Edit category" => "Edit category",
"Edit this category" => "Editer la catégorie",
"Add new category" => "Ajouter une nouvelle catégorie",
// "Apply parent category permissions" => "Apply parent category permissions",
"Objects in category" => "Objets dans la catégorie",
// "Remove from this category" => "Remove from this category",
// "Remove object from category" => "Remove object from category",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Remove checked" => "Remove checked",
// "Remove objects from category" => "Remove objects from category",
// "Moving objects" => "Moving objects",
"Moving objects between categories" => "Déplacer les objets entre catégories",
"Current category" => "Catégorie courante",
// "Perform an action on all objects in the current category" => "Perform an action on all objects in the current category",
// "Unassign objects from category" => "Unassign objects from category",
// "Move to selected category" => "Move to selected category",
// "Choose destination category" => "Choose destination category",
// "Copy to selected category" => "Copy to selected category",
// "Add objects" => "Add objects",
"Add objects to category" => "Ajouter des objets à la catégorie",
"Objects" => "Objets",
"Quiz" => "QCM",
"Batch upload" => "Chargement par lot",
// "Sample file content" => "Sample file content",
// "Content templates" => "Content templates",
"Templates" => "Gabarits",
"Visible in no sections" => "Visible dans aucune section",
"Remove section" => "Supprimer la section",
// "Uncategorized" => "Uncategorized",
// "{\$catName}" => "{\$catName}",
// "Remove template" => "Remove template",
"Edit template" => "Modifier le gabarit",
// "Create template" => "Create template",
"Use the Administration page of each enabled feature to allow the use of content templates" => "Utilisez la page d'administration de chaque fonction activée pour permettre l'utilisation de modèles de contenu",
"Name field is mandatory" => "Le nom du champ est obligatoire",
"No features are configured to use templates." => "Aucune fonctionnalité n'utilise les gabarits.",
"Template Type" => "Type de modèle",
"Text area" => "Zone de texte",
"Admin Contributions" => "Administrer les contributions",
"Edit the contribution" => "Éditer la contribution",
"Contributions are mandatory in wiki pages" => "Contributions obligatoires dans les pages wiki",
"Contributions are mandatory in forums" => "Contributions obligatoires dans les forums",
"Contributions are mandatory in comments" => "Contributions obligatoires dans les commentaires",
"Contributions are mandatory in blogs" => "Contributions obligatoires dans les blogues",
"Contributions are displayed in the comment/post" => "Contributions affichées avec les commentaires ou les articles",
"Create a new contribution" => "Créer une nouvelle contribution",
"List of contributions" => "Liste des contributions",
// "Remove contribution" => "Remove contribution",
"Admin cookies" => "Administrer les cookies",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Ajouter/modifier un cookie",
"Upload Cookies from textfile" => "Envoyer un fichier texte de citations",
"Upload from disk" => "Envoyer à partir de son disque",
"Remove all cookies" => "Supprimer tous les cookies",
"cookie" => "cookie",
// "Remove cookie" => "Remove cookie",
"Manage Credits" => "Gérer les crédits",
"(YYYY-MM-DD HH:MM:SS)" => "(AAAA-MM-JJ HH:MM:SS)",
"(level credits always 0)" => "(niveau de crédits toujours 0)",
"Delete Checked" => "Effacer la sélection",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
"Expiry" => "Expiration",
"Use User Credits" => "Utiliser les crédits de l'utilisteurs",
"Amount:" => "Somme :",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
"all types" => "tous les types",
"filter" => "filtre",
// "Usage Date" => "Usage Date",
"Amount Used" => "Somme utilisée",
"No such user" => "Pas de tel utilisateur",
"Manage Credit Types" => "Gestion des types de crédit",
"Display Text" => "Afficher du Texte",
"Unit Text" => "Test unitaire",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
"Purge" => "Purger",
"Admin Content Sources" => "Administrer les sources de contenu",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Aller à Administration->DSN pour définir la base de données utilisée dans le plugiciel SQL.",
"Create/edit DSN" => "Créer/modifier un DSN",
"Local (Tiki database)" => "Locale (Tiki database)",
"See db/local.php" => "Voir db/local.php",
// "Remove DSN" => "Remove DSN",
"Content Authentication" => "Authentification du contenu",
"Identification" => "Identification",
"HTTP Basic" => "HTTP Basique",
"HTTP Session / Login" => "Session HTTP / Connexion",
"HTTP Session / Visit" => "Session HTTP / Visite",
"Admin External Wikis" => "Administrer des Wikis externes",
"Create/Edit External Wiki" => "Créer/modifier un Wiki externe",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "Adresse Web ( \$page sera remplacé par le nom de la page dans l'URL - exemple : http://www.example.com/tiki-index.php?page=\$page)",
// "<em>[prefix]</em>main, such as tiki_main" => "<em>[prefix]</em>main, such as tiki_main",
// "Search as" => "Search as",
// "Leave blank to search using currently active groups" => "Leave blank to search using currently active groups",
"ExtWiki" => "Wiki externe",
// "Search As" => "Search As",
// "Remove external wiki" => "Remove external wiki",
"Admin Forums" => "Administrer les forums",
// "Create Forum" => "Create Forum",
"Age" => "Âge",
"PPD" => "Ar/jo",
"Create/Edit Forums" => "Ajouter/Modifier un forum",
"Edit this Forum" => "Éditer ce forum",
"Create New Forum" => "Créer un nouveau forum",
// "Main details" => "Main details",
// "Image symbolizing the forum" => "Image symbolizing the forum",
"Only allow replies to the first message (flat forum)" => "Ne permettre des réponses qu'au dernier message (forum à plat)",
"Moderator user" => "Utilisateur modérateur",
"Moderator group" => "Groupe modérateur",
"Password protected" => "Protéger par un mot de passe",
"Forum password" => "Mot de passe du forum",
"Prevent flooding" => "Empêcher les raz-de-marée",
"Minimum time between posts" => "Temps minimum entre 2 publications",
"Send the posts of this forum to this email address" => "Envoyer les articles de ce forum à cette adresse électronique",
"Prune unreplied-to messages after" => "Éliminer les messages sans réponses après",
"Prune old messages after" => "Éliminer les anciens messages après",
// "Forum-mailing list synchronization" => "Forum-mailing list synchronization",
"Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address" => "Faire suivre les messages de ce forum à cette adresse électronique, dans un format pouvant être renvoyé au forum",
"Send emails even when the post is generated by an inbound email" => "Envoyer un mail, si le commentaire posté est généré par une procédure de mail interne",
"Append a reply link to outbound mails" => "Ajouter un lien de réponse aux messages sortants",
"Originating email address for emails from this forum" => "Adresse électronique de l'expéditeur des messages du forum",
"Add messages from this email to the forum" => "Ajouter les messages venant de cette adresse électronique au forum",
"POP3 server" => "Serveur POP3",
// "Forums list" => "Forums list",
"Display last post titles" => "Afficher les titres des dernières publications",
// "Forum topics (threads) list" => "Forum topics (threads) list",
"Default order of topics" => "Ordre par défaut des sujets",
"Topics per page" => "Nombre de sujets par page",
"Topic list configuration" => "Configuration de la liste des sujets",
"Last post title" => "Titre de la dernière publication",
"Last post profile picture" => "Avatar du dernier post",
"Author profile picture" => "Avatar de l'auteur",
"Use topic smileys" => "Pouvoir mettre un émoticône sur un sujet",
"Show topic summary" => "Afficher le résumé du sujet",
// "Forum threads" => "Forum threads",
// "Default ordering of threads" => "Default ordering of threads",
// "Default style of threads" => "Default style of threads",
"Approval type" => "Type d'approbation",
// "Topic Rating" => "Topic Rating",
"User Level" => "Niveau utilisateur",
"eMail" => "Adresse électronique",
"Online" => "Connecté",
"Permission" => "Droit d'accès",
"Store attachments in" => "Sauver les fichiers joints dans",
// "File system" => "File system",
"Max attachment size (bytes)" => "Taille max. des fichiers joints (octets)",
"Shows number of attachments of the all thread in forum list" => "Indique le nombre de pièces jointes de tout le fil de discussion dans la liste des forums",
"Duplicate Forum" => "Dupliquer un forum",
"Admin Hotwords" => "Administrer les mot/liens automatiques",
"Add Hotword" => "Ajouter un mot/lien automatique",
"Word" => "Mot",
// "Delete hotword" => "Delete hotword",
"Admin HTML Page Dynamic Zones" => "Administrer les zones dynamiques des pages HTML",
"Admin HTML pages" => "Administrer les pages HTML",
"Edit this page" => "Éditer cette page",
"Edit zone" => "Modifier une zone",
"Dynamic zones" => "Zones dynamiques",
"zone" => "zone",
"content" => "contenu",
"Mass update" => "Mise à jour massive",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Utiliser {literal}{ed id=name}{/literal} ou {literal}{ted id=name}{/literal} pour insérer des zones dynamiques",
"Create new HTML page" => "Créer une nouvelle page HTML",
"Edit this HTML page" => "Éditer cette page HTML",
"Apply template" => "Appliquer un gabarit",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "Dynamique",
"Static" => "Statique",
"Refresh rate (if dynamic)" => "Temps de rafraichissement (si dynamique)",
"Last Modif" => "Dernière modif.",
"Admin dynamic zones" => "Administrer les zones dynamiques",
// "Remove HTML page" => "Remove HTML page",
// "IDS Rules" => "IDS Rules",
// "Add a new Rule" => "Add a new Rule",
// "Rule ID" => "Rule ID",
// "Impact" => "Impact",
// "Edit rule settings" => "Edit rule settings",
// "Edit Rule" => "Edit Rule",
// "Add a new rule" => "Add a new rule",
// "Rule Id" => "Rule Id",
// "Rule Id must be numeric" => "Rule Id must be numeric",
// "Rule Regex" => "Rule Regex",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository" => "Modifier un dépôt",
"Create New Repository" => "Créer un nouveau dépôt",
"Human-readable repository name" => "Nom compréhensible du dépôt",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Chemin d'accès au dépôt (si local : relative ou absolu / racine web - sinon: préfixé avec 'http://'",
"File name of start page" => "Nom du fichier pour la première page",
"Start page" => "Première page",
"CSS file to load when browse this repository" => "Fichier CSS à charger pour parcourir ce dépôt",
"CSS File" => "Fichier CSS",
"Is repository visible to users" => "Ce dépôt est-il visible par les utilisateurs",
"Can files from repository be cached" => "Droit de mettre en cache les fichiers d'un dépôt",
"Cacheable" => "Peut être mis en antémémoire",
"Clear all cached pages of this repository" => "Supprimer toutes les pages de ce dépôt qui ont été mis en cache",
"Clear cache" => "Vider l'antémémoire",
"Seconds count 'till cached page will be expired" => "Secondes jusqu'à ce que la page en antémémoire soit supprimé",
"Cache expiration" => "Expiration de l'antémémoire",
"Human-readable text description of repository" => "Description compréhensible du dépôt",
"Available Repositories" => "Répertoires disponibles",
"Edit rules" => "Modifier les règles",
"Edit Rules for Repository" => "Modifier les Règles pour le Dépôt",
"Configure Repositories" => "Configurer les répertoires",
"List Repositories" => "Liste des répertoires",
"Configure this Repository" => "Configurer ce dépôt",
"View this Repository" => "Voir ce répertoire",
"New Rule" => "Nouvelle règle",
"Copy Rules" => "Recopie des règles",
"view/hide copy rules dialog" => "afficher/masquer le dialogue des règles pour copier",
"Source repository" => "Répertoire source",
// "Rules will be applied in this order ('0' or empty = auto)" => "Rules will be applied in this order ('0' or empty = auto)",
"Rule order" => "Ordre des règles",
"Text to search for" => "Texte recherché",
"Text to replace" => "Texte à remplacer",
"Is this regular expression or simple search/replacer" => "Est ce une expression régulière ou un simple chercher/remplacer",
"Regex" => "Expression régulière",
"Is case sensitive (for simple replacer)" => "La casse est-elle prise en compte (pour un simple remplacer)",
"Case sensitive" => "Sensible à la casse",
// "subset of chars: imsxeADSXUu, which are regex modifiers" => "subset of chars: imsxeADSXUu, which are regex modifiers",
"Regex modifiers" => "Modificateurs Regex",
"Human-readable text description of rule" => "Description facilement compréhensible de la règle",
"Check to enable this rule" => "Cocher pour permettre cette règle",
"Preview options" => "Options de l'aperçu",
"Apply all rules or just this to generate preview" => "Appliquer toutes les règles ou seulement celle-là pour générer l'aperçu",
"Apply all rules" => "Appliquer toutes les règles",
"View source code after rules applied" => "Voir le code source après l'application des règles",
"Code preview" => "Aperçu du code",
"Generate HTML preview" => "Générer un aperçu HTML",
"HTML preview" => "Aperçu HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Fichier de test du dépôt pour créer un aperçu (vide = page initiale configurée)",
"Preview Results" => "Aperçu des résultats",
"Rules List" => "Liste des règles",
"Case" => "Casse",
// "Admin Invoices" => "Admin Invoices",
"Admin keywords" => "Administrer les mots-clés",
"Edit page keywords" => "Modifier les mots-clés de la page",
"Current Page Keywords" => "Mots-clés de la page courante",
"Search by page" => "Recherche par page",
"results found" => "résultats trouvés",
// "Remove keywords for this page" => "Remove keywords for this page",
"No pages found" => "Aucun résultat",
// "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Générer les positions par le nombre de visites",
"List of featured links" => "Liste des liens vedette",
// "Remove featured link" => "Remove featured link",
"Add Featured Link" => "Ajouter un lien vedette",
"Edit this Featured Link" => "Modifier ce lien vedette",
"Create new Featured Link" => "Créer un nouveau lien vedette",
"disables the link" => "désactive l'hyper-lien",
"Link type" => "Type de lien",
"replace current page" => "remplacer la page en cours",
"framed" => "encadré",
"open new window" => "ouvrir nouvelle fenêtre",
"Mail-in accounts" => "Comptes mail-in",
// "Allow" => "Allow",
// "Leave" => "Leave",
// "Auto-category" => "Auto-category",
// "Auto-namespace" => "Auto-namespace",
"Administrator" => "Administrateur",
// "Admin Mail-in Routes" => "Admin Mail-in Routes",
"Check Mail-in accounts" => "Vérifier les comptes mail-in",
"Check automatically" => "Vérifier automatiquement",
"Frequency" => "Fréquence",
// "Check Manually Now" => "Check Manually Now",
// "Admin Mail-in routes" => "Admin Mail-in routes",
// "Structure Routing" => "Structure Routing",
// "Wiki structures feature is not enabled" => "Wiki structures feature is not enabled",
// "List Menus" => "List Menus",
"Create menu option" => "Création d'une option de menu",
// "Edit This Menu" => "Edit This Menu",
// "Export menu options" => "Export menu options",
// "Import menu options" => "Import menu options",
"Manage menu" => "Gérer le menu",
"Menu options" => "Options du menu",
// "Save Options" => "Save Options",
// "New option" => "New option",
// "Check this if the option is an alternative to the previous one" => "Check this if the option is an alternative to the previous one",
// "Drag this on to the menu area below" => "Drag this on to the menu area below",
// "URL or ((page name))" => "URL or ((page name))",
// "Test URL" => "Test URL",
// "Remove Option" => "Remove Option",
"Preview menu" => "Aperçu du menu",
// "Deploy" => "Deploy",
// "Menu Options" => "Menu Options",
"RESET" => "Réinitialiser",
"Clear Cache" => "Vider l'antémémoire",
"Show hidden modules" => "Afficher les modules cachés",
"Hide hidden modules" => "Masquer les modules cachés",
"Exit Modules" => "Quitter Modules",
"Modules Parameters" => "Paramètres des Modules",
"The following required parameters are missing" => "Les paramètres suivants, demandés, sont manquants",
"Drag the modules around to re-order then click save when ready" => "Glissez les modules dans l'ordre souhaité puis cliquez sur \"sauvegarder\" lorsque vous avez terminé",
"Double click them to edit" => "Double-cliquez pour éditer",
"Modules with \"position: absolute\" in their style can be dragged in to position" => "Les modules avec la propriété \"position: absolute\" dans la feuille de style peuvent être glissés vers leur position finale",
"New modules can be dragged from the \"All Modules\" tab" => "Vous pouvez glisser de nouveaux modules à partir de l'onglet \"Tous les modules\"",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>",
"More info here" => "Plus d'information ici",
"Assigned modules" => "Modules assignés",
"Assign/Edit modules" => "Assigner/Éditer les modules",
"Assigned Modules" => "Modules assignés",
"Add module" => "Ajouter un module",
// "You will need to go" => "You will need to go",
// "to reorder or move modules in the left or right columns since you have created a custom order for these" => "to reorder or move modules in the left or right columns since you have created a custom order for these",
// "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user" => "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user",
"Edit module" => "Modifier le module",
"Assign new module" => "Attribuer un nouveau module",
"Edit this assigned module" => "Editer ce module assigné",
"Module Options" => "Options de modules",
"Custom Modules" => "Modules personnalisés",
// "Delete custom module" => "Delete custom module",
"Create new custom module" => "Créer un nouveau module personnalisé",
"Edit this custom module" => "Editer ce module personnalisé",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Parse using" => "Parse using",
// "Wiki Markup" => "Wiki Markup",
"Objects that can be included" => "Objets pouvant être inclus",
"Available polls" => "Sondages disponibles",
"Random active poll" => "Sondage actif choisi au hasard",
"Random current poll" => "Sondage courant choisi au hasard",
// "Use gallery" => "Use gallery",
"Random image from" => "Image choisie au hasard de",
"Dynamic content blocks" => "Blocs de contenu dynamique",
// "Use dynamic content" => "Use dynamic content",
"External feeds" => "Flux externes",
// "Use RSS module" => "Use RSS module",
// "Banner zones" => "Banner zones",
// "Use banner zone" => "Use banner zone",
// "Use wiki structure" => "Use wiki structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes",
"To use a default Tiki menu" => "Pour utiliser un menu Tiki par défaut",
"All Modules" => "Tous les modules",
"Show all modules" => "Montrer tous les modules",
"Admin newsletter subscriptions" => "Administrer les abonnements à une lettre d'informations",
"Subscriptions" => "Inscriptions",
"Groups included through inheritance" => "Groupes inclus par héritage",
// "Remove subscription" => "Remove subscription",
"Wiki Page Name" => "Nom de la page Wiki",
"Validate Addresses" => "Valider les adresses",
"Add To List" => "Ajouter à la liste",
"Subscribed" => "inscrit",
// "Mark subscription as valid" => "Mark subscription as valid",
"Unsubscribed" => "Désinscrit",
// "Remove selected subscriptions" => "Remove selected subscriptions",
"Add subscribers" => "Ajouter des souscripteurs",
"You can add several email addresses by separating them with commas." => "Vous pouvez ajouter plusieurs courriels en les séparant par des virgules.",
"Add email" => "Ajouter une adresse mail",
"Add user" => "Ajouter utilisateur",
"Users from group" => "Utilisateurs du groupe",
"Group subscription also subscribes included groups" => "L'inscription d'un groupe inscrit aussi les groupes inclus",
// "Don't send confirmation email" => "Don't send confirmation email",
"The user email will be refreshed at each newsletter sending" => "L'adresse électronique de l'utilisateur sera reconstruite à chaque envoi de lettre d'informations",
"Import emails from file" => "Importer des adresses courriel à partir d'un fichier",
// ".txt file, one email per line" => ".txt file, one email per line",
// "Don't send confirmation emails" => "Don't send confirmation emails",
"Import emails from wiki page" => "Importer des adresses courriel à partir d'une page wiki",
"Wiki page, one email per line" => "Page wiki, une adresse courriel par ligne",
// "Import emails from tracker" => "Import emails from tracker",
"Subscribe group" => "Inscrire un groupe",
// "Including group inheritance" => "Including group inheritance",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
"Wiki page" => "Page wiki",
// "Emails on a wiki page which will be added at each newsletter sending, one email per line" => "Emails on a wiki page which will be added at each newsletter sending, one email per line",
// "Don't subscribe emails" => "Don't subscribe emails",
"Export Subscriber Emails" => "Exporter les adresses électroniques des inscrits",
"Admin newsletters" => "Administrer les lettres d'informations",
"List Newsletters" => "Liste des lettres d'informations",
"Send Newsletters" => "Envoyer des lettres d'informations",
"Editions" => "Éditions",
"Drafts" => "Brouillons",
"Last Sent" => "Dernier envoi",
// "Remove newsletter" => "Remove newsletter",
"Create/Edit Newsletters" => "Ajouter/Modifier une lettre d'informations",
"There are individual permissions set for this newsletter" => "Des droits individuels ont été mis sur cette lettre d'informations",
"Users can subscribe/unsubscribe to this list" => "Les utilisateurs peuvent s'abonner/se désabonner à cette liste",
"Users can subscribe any email address" => "Les utilisateurs peuvent s'abonner avec une adresse électronique différente",
"Add unsubscribe instructions to each newsletter" => "Ajouter les instructions pour se désabonner dans chaque lettre d'informations envoyée",
"Validate email addresses" => "Les inscriptions sont validées après réponse à un email",
"Allow customized text message to be sent with the HTML version" => "Accompagner la version HTML d'une version personnalisable en format texte",
"Allow clipping of articles into newsletter" => "Autoriser les extraits d'articles dans la lettre de nouvelles",
"Automatically clip articles into newsletter" => "Extraire automatiquement les articles dans la lettre de nouvelles",
// "Do not send newsletter if clip is empty" => "Do not send newsletter if clip is empty",
"Clip articles published in the past number of days" => "Extraire les articles publiés dans ce nombre de derniers jours",
"Article types to clip" => "Types d'articles à extraire",
"Mail notifications" => "Notifications par courriel",
// "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "Ajouter une notification",
"Destination" => "Destination",
"Myself" => "Moi-même",
// "Note that a user is not notified for his or her own action" => "Note that a user is not notified for his or her own action",
"User / Group" => "Utilisateur / Groupe",
// "Delete mail notification event" => "Delete mail notification event",
// "Delete selected notification events" => "Delete selected notification events",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "OAuth Server" => "OAuth Server",
// "List of clients" => "List of clients",
// "Client_id" => "Client_id",
// "Client_secret" => "Client_secret",
// "Redirect_uri" => "Redirect_uri",
"Admin Polls" => "Administrer les sondages",
"Preview poll" => "Aperçu du sondage",
"Add poll option" => "Ajouter une option de vote",
"Edit poll option" => "Modifier l'option du sondage",
"Poll options" => "Options de sondage",
"Votes" => "Votes",
"Set last poll as current" => "Mettre le dernier sondage comme courant",
"Close all polls but last" => "Fermer tous les sondages sauf le dernier",
"Activate all polls" => "Activer tous les sondages",
"Create poll" => "Créer un sondage",
"Edit poll" => "Modifier le sondage",
"active" => "activé",
"object" => "objet",
"Toggle Quick Options" => "Activer/désactiver options rapides",
"Add Option" => "Ajouter une Option",
"Leave box empty to delete an option" => "Laisser la boîte vide pour supprimer une option",
// "Votes older than x days are not considered" => "Votes older than x days are not considered",
"0 for no limit" => "0 pour pas de limite",
"Results" => "Résultats",
"Add poll to pages" => "Ajouter un sondage à des pages",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
"This menu shows only Polls with 'status': \"template\"" => "Ce menu montre seulement les sondages en 'statut' : \"gabarit\"",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Verrouiller les pages",
// "Custom Route" => "Custom Route",
// "Add a new Custom Route" => "Add a new Custom Route",
// "Edit route settings" => "Edit route settings",
// "Edit route" => "Edit route",
// "Add a new route" => "Add a new route",
// "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value" => "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value",
// "The users will get redirected to the tracker item that has a field that matches the value found in the URL" => "The users will get redirected to the tracker item that has a field that matches the value found in the URL",
// "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10" => "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10",
// "Router Type" => "Router Type",
// "Check this option to set route as a Short URL" => "Check this option to set route as a Short URL",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Cette page permet de configurer les réglages des flux externes lus/importés par Tiki. Pour générer/exporter des flux, voir \"Flux\" sur le panneau d'administration ou",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed" => "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed",
"Content for the feed" => "Affichage du canal",
// "Refresh All feeds" => "Refresh All feeds",
// "Show Date" => "Show Date",
"Refresh rate" => "Fréquence de réactualisation",
// "Article generator" => "Article generator",
"Edit Feed" => "Modifier le flux",
"Create Feed" => "Créer le flux",
"Create new external feed" => "Créer un nouveau flux externe",
// "Show feed title" => "Show feed title",
"Show publish date" => "Afficher la date de publication",
"Article Generator" => "Générateur d'Article",
// "Article Generator for %0" => "Article Generator for %0",
// "Once you have defined the settings below, each new item in this rss feed will generate a new article" => "Once you have defined the settings below, each new item in this rss feed will generate a new article",
// "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones" => "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones",
// "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content" => "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content",
"Use Article Submission System" => "Utiliser le Système de Soumission d'Article",
"Expiration" => "Expiration",
"Publish in the future" => "Publier plus tard",
"-1 to use original publishing date from the feed" => "-1 pour utiliser la date de première publication du fil RSS",
// "Custom Settings for Source Categories" => "Custom Settings for Source Categories",
// "No source categories detected for this feed" => "No source categories detected for this feed",
// "Source Category" => "Source Category",
// "Priority (10 is highest)" => "Priority (10 is highest)",
// "Categorize Created Articles" => "Categorize Created Articles",
"Configure" => "Configurer",
// "Add a new Scheduler" => "Add a new Scheduler",
"Schedulers" => "Planificateur",
// "Run Time" => "Run Time",
// "Re-Run" => "Re-Run",
// "Edit scheduler settings" => "Edit scheduler settings",
// "Stalled" => "Stalled",
// "Run now" => "Run now",
// "Edit scheduler" => "Edit scheduler",
// "Add a new scheduler" => "Add a new scheduler",
// "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *" => "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *",
// "Run if missed" => "Run if missed",
// "Scheduler logs" => "Scheduler logs",
// "Last {\$numOfLogs} Logs" => "Last {\$numOfLogs} Logs",
// "Running" => "Running",
"Failed" => "Echoué",
// "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>",
"Tiki settings" => "Configuration de Tiki",
"Tiki variable" => "Variable Tiki",
"Setting" => "Configuration",
"Risk Factor" => "Facteur de risque",
"Explanation" => "Explication",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "À propos des plugiciels Wiki et de la sécurité : assurez-vous de n'accorder le droit \"tiki_p_plugin_approve\" qu'à des éditeurs de confiance",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "Vous pouvez désactiver les plugiciels risqués sur la page (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
"You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>." => "Vous pouvez approuver l'usage des plugiciels sur la page <a href=\"tiki-plugins.php\">tiki-plugins.php</a>.",
"Security checks" => "Vérification de sécurité",
"Check all tiki files" => "Vérifier tous les fichiers Tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Remarque : cela peut prendre beaucoup de temps. Vous devez vérifier votre temps maximum d'exécution (réglage max_execution_time) dans php.ini.",
"File checks" => "Fichiers vérifiés",
"Check file permissions" => "Vérifier les permissions des fichiers",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Cette vérification tente de trouver des fichiers avec des permissions problématiques. Certains fichiers qui sont présentés ici comme posant problème peuvent ne pas être problématiques ou inévitables dans certains environnements.",
"See end of table for detailed explanations." => "Voir la fin de la table pour des explications détaillées.",
"owner" => "propriétaire",
"special" => "spécial",
"other" => "autre",
"uid" => "uid",
"gid" => "gid",
"suid" => "suid",
"sgid" => "sgid",
"sticky" => "captivant",
"r" => "r",
"w" => "w",
"Set User ID (suid) files" => "Set User ID (suid) des fichiers",
"World writable files or directories" => "Fichiers ou répertoires modifiables par tout le monde",
"Files or directories the Webserver can write to" => "Fichiers ou répertoires dans lesquels le serveur Web peut écrire",
"Strange Inodes (not file, not link, not directory)" => "Inodes étranges (ni fichier, ni lien, ni répertoire)",
"Executable files" => "Fichiers exécutables",
"What to do with these check results?" => "Que faire de ces résultats ?",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
"Admin Shoutbox Words" => "Administration des mots du mégaphone",
"Add Banned Word" => "Ajouter un mot tabou",
"Are you sure you want to delete this word?" => "Etes-vous sûr(e) de vouloir enlever ce tabou ?",
// "Rebuild sitemap" => "Rebuild sitemap",
// "Submit the Sitemap" => "Submit the Sitemap",
// "You can submit the sitemap for processing in all major search engines using the following URL" => "You can submit the sitemap for processing in all major search engines using the following URL",
// "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap" => "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap",
// "Automate Sitemap generation" => "Automate Sitemap generation",
// "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t" => "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t",
// "Or you can use directly the command line" => "Or you can use directly the command line",
"XML Zip Import" => "Importer un fichier XML Zip",
"Feedback" => "Information",
// "Structure created" => "Structure created",
"View Page" => "Voir la page",
"Please Confirm" => "Confirmer l'envoi",
"You will remove structure" => "Vous allez supprimer la structure",
"Destroy the structure leaving the wiki pages" => "Détruire la structure en laissant les pages Wiki",
"Destroy the structure and remove the pages" => "Détruire la structure et supprimer les pages",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Veuillez noter que les pages suivantes font également partie d'une autre structure. Assurez-vous que les permissions d'accès (le cas échéant) ne rentrent pas en conflit",
"The following pages have automatically been categorized with the same categories as the structure" => "Les pages suivantes ont été automatiquement catégorisées dans la même catégorie que la structure",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "Les pages suivantes sont dans des catégories contrairement à la structure. Pour rester consistant, il faudrait les sortir de ces catégories",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "Les pages suivantes sont dans des catégories dans laquelle ne se trouve pas la structure. Pour assurer la cohérence, vous pourriez vouloir les recatégoriser",
// "Existing Structures" => "Existing Structures",
// "View Structure" => "View Structure",
"View structure" => "Afficher la structure",
// "Export pages" => "Export pages",
// "Dump tree" => "Dump tree",
"Create WebHelp" => "Créer l'aide Web",
"View WebHelp" => "Afficher l'aide-web",
// "XML Zip" => "XML Zip",
"Perform action with selected" => "Réaliser l'action avec le ou les éléments sélectionnés",
".." => "..",
"Delete with the pages" => "Supprimer avec les pages",
// "Create Structure" => "Create Structure",
"Alias" => "Alias",
"Tree" => "Arbre",
"Use single spaces to indent structure levels" => "Utiliser un seul espace pour une mise en retrait",
"Create New Structure" => "Ajouter une nouvelle structure",
"Edit survey questions" => "Éditer les questions de l'enquête",
"Add a New Question" => "Ajouter une nouvelle question",
"List Surveys" => "Liste des enquêtes",
"Survey Stats" => "Statistiques sur les enquêtes",
"This survey stats" => "Statistiques de cette enquête",
"Edit this Survey" => "Modifier cette enquête",
"Admin Surveys" => "Administrer les enquêtes",
"Questions" => "Questions",
"Question" => "Question",
"Answer is mandatory" => "Réponse obligatoire",
// "Required answers" => "Required answers",
// "Single choice using radio buttons" => "Single choice using radio buttons",
// "Example: \"one, two, many, lots\"" => "Example: \"one, two, many, lots\"",
// "(Use \"\\,\" to include a comma" => "(Use \"\\,\" to include a comma",
// "Multiple choice using checkboxes" => "Multiple choice using checkboxes",
"For a rate, you can give the maximum value." => "Pour une notation, vous pouvez utiliser la valeur maximum.",
// "Multiple choices of thumbnail from a file gallery, options contains Gallery ID" => "Multiple choices of thumbnail from a file gallery, options contains Gallery ID",
// "Example: 4" => "Example: 4",
// "Options are: rows,columns,toolbars" => "Options are: rows,columns,toolbars",
// "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)" => "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)",
// "For the 'short text' type, options are: columns" => "For the 'short text' type, options are: columns",
// "Example: 60" => "Example: 60",
// "A heading to go between questions. Options are newpage,tag" => "A heading to go between questions. Options are newpage,tag",
// "Example: y,h4" => "Example: y,h4",
"Options (if apply)" => "Les options (si elles s'appliquent)",
"Admin surveys" => "Administrer les enquêtes",
"Create/Edit Surveys" => "Créer/Éditer enquête",
"Create New Survey" => "Créer une nouvelle enquête",
"There are individual permissions set for this survey" => "Des droits d'accès individuels ont été placés sur cette enquête",
// "Synchronize Dev/Prod Servers" => "Synchronize Dev/Prod Servers",
// "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one" => "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one",
// "Remote Server Address" => "Remote Server Address",
// "Show diff" => "Show diff",
// "Local" => "Local",
// "Remote" => "Remote",
// "System Administration" => "System Administration",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Si votre Tiki se comporte bizarrement, la première chose à faire est de vider vos caches. Il est aussi important de vider les caches après une mise à jour (utiliser FTP/SSH si nécessaire).",
// "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>" => "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>",
"Clear cached content" => "Effacer les contenus en cache",
"Empty" => "Vider",
// "All user preference sessions" => "All user preference sessions",
// "Save directories" => "Save directories",
"Directories to save" => "Répertoires à sauvegarder",
"Directory is not writeable" => "Le répertoire n'est pas accessible en écriture",
"Full Path to the Zip File" => "Chemin complet de l'archive ZIP",
// "ZIP" => "ZIP",
// "Generate zip" => "Generate zip",
"A zip has been written to %0" => "Une archive ZIP a été créée dans %0",
"Groups still used in the database but no more defined" => "Groupes toujours utilisés dans la base de données mais plus définis",
"Admin Tokens" => "Administrer les jetons",
// "List tokens" => "List tokens",
// "Timeout" => "Timeout",
// "Hits left" => "Hits left",
// "Max hits" => "Max hits",
// "Create Temp User" => "Create Temp User",
// "Temp User Prefix" => "Temp User Prefix",
"Add new token" => "Ajouter un nouveau jeton",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
"Groups (separated by comma)" => "Groupes (séparés par une virgule)",
"View mode" => "Mode d'affichage",
"Wiki and WYSIWYG" => "Wiki et WYSIWYG",
"Wiki only" => "Wiki seulement",
// "WYSIWYG (HTML mode)" => "WYSIWYG (HTML mode)",
// "WYSIWYG (wiki mode)" => "WYSIWYG (wiki mode)",
"Reset to Global" => "Réinitialiser comme Global",
"Reset to defaults" => "Réinitialiser",
"Formatting Tools" => "Outils de formattage",
"Plugin Tools" => "Outils pour les Plugiciels",
"Edit tool" => "Outil d'édition",
"Wysiwyg Token" => "Jeton Wysiwyg",
"Custom Tools" => "Outils personnalisés",
"Add a new custom tool" => "Ajouter un nouvel outil personnalisé",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
"If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "Si vous rencontrez des problèmes avec cette page après avoir mis à jour à partir de Tiki 4, merci d'utiliser le lien pour supprimer tous les outils personnalisés",
"Delete all custom tools" => "Effacer tous les outils perso.",
"Warning: There is no undo" => "Attention : impossible d'annuler",
"List Articles" => "Liste des articles",
// "Add topic" => "Add topic",
// "Notification Email" => "Notification Email",
// "You will be able to add a notification email per article topic when you edit the topic after its creation" => "You will be able to add a notification email per article topic when you edit the topic after its creation",
"topic image" => "image du sujet",
"Activate" => "Activer",
// "De-activate" => "De-activate",
"Remove with articles" => "Supprimer avec les articles",
// "Tracker Fields" => "Tracker Fields",
"Admin Tracker" => "Administrer le formulaire",
// "Import Fields" => "Import Fields",
"Mandatory" => "Obligatoire",
"Save All" => "Tout enregistrer",
"Remove Selected" => "Supprimer la sélection",
"Export Selected" => "Exporter la sélection",
"Subset Selection" => "Sélection des sous-ensembles",
"Category Selection" => "Sélection des catégories",
"Group Selection" => "Sélection de groupe",
// "Add Group" => "Add Group",
// "Press Enter for each group" => "Press Enter for each group",
// "At least two elements are required to create transitions. Additional tabs appear once the selection is completed" => "At least two elements are required to create transitions. Additional tabs appear once the selection is completed",
"Draw Transition Diagram" => "Dessiner le diagramme des transitions",
"Guards" => "Sentinelles",
"preserved" => "préservé",
"No transitions" => "Pas de transitions",
"New / Edit" => "Nouveau/Éditer",
"Edit <em>%0</em>" => "Éditer <em>%0</em>",
"New transition" => "Nouvelle transition",
"Upon trigger, preserve the initial state" => "Après déclenchement, préserver l'état initial",
"Members" => "Membres",
"No guards on this transition" => "Pas de sentinelles sur cette transition",
"New Guard" => "Nouvelle Sentinelle",
"Exactly" => "Exactement",
"States" => "États",
// "Body of POST request" => "Body of POST request",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Entrer l'URL de services web retournant soit du JSON ou du YAML. Des paramètres peuvent être spécifiés par leur nom encadrés de signes '%'. Par exemple : %name%. Mais %service% et %template% sont des mots-clés réservés et ne peuvent pas être utilisés",
"Parameters (%name%)" => "Paramètres (%name%)",
"Operation" => "Opération",
// "%0 requires no parameter" => "%0 requires no parameter",
// "Test Input" => "Test Input",
// "Bypass cache" => "Bypass cache",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
"Not supported" => "Non supporté",
"Schema Version" => "Version du schéma",
"Schema Documentation" => "Documentation du schéma",
// "Not specified, default used" => "Not specified, default used",
"Content Type" => "Type de contenu",
"Not specified" => "Non spécifié",
"Returned Data" => "Données renvoyées",
// "tuncated at approx. 1MB" => "tuncated at approx. 1MB",
"Proposed Templates" => "Gabarits proposés",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
"Register Service" => "Enregistrer le Service",
"Registered Templates" => "Gabarits enregistrés",
"Engine" => "Moteur",
"Output" => "Sortie",
// "Toggle template source" => "Toggle template source",
// "Register Template" => "Register Template",
// "Add New Group" => "Add New Group",
"Invitation List" => "Liste d'invitation",
"List of existing groups" => "Liste des groupes existants",
"Inherits Permissions from" => "Hérite les permissions de",
"User Choice" => "Choix de l'utilisateur",
"Edit group" => "Modifier le groupe",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
// "Create group" => "Create group",
"Group is NOT being monitored. Click icon to START monitoring" => "Ce groupe n'est PAS surveillé. Cliquer sur l'icône pour DÉMARRER la surveillance",
"Group IS being monitored. Click icon to STOP monitoring" => "Ce groupe EST sous surveillance. Cliquer sur l'icône pour STOPPER la surveillance",
// "Inheritance" => "Inheritance",
// "Permissions will be inherited from these groups" => "Permissions will be inherited from these groups",
// "Indirectly included groups" => "Indirectly included groups",
// "Group Home" => "Group Home",
"Use wiki page name or full URL" => "Utiliser le nom de la page Wiki ou l'URL complet",
"For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "Pour les autres fonctionnalités Tiki, utiliser des liens relatifs (comme <em>/tiki-forums.php</em>)",
// "Default Category" => "Default Category",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Catégorie associée par défaut aux objects édités par un utilisateur ayant ce groupe par défaut",
"Use site default" => "Utiliser la valeur par défaut du site",
// "Group color" => "Group color",
// "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color" => "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color",
"Group Information Tracker" => "Formulaire d'information sur le groupe",
// "choose a group tracker .." => "choose a group tracker ..",
// "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign" => "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign",
"choose a field ..." => "choisissez un champ ...",
// "Select the user selector field from the above tracker" => "Select the user selector field from the above tracker",
// "Go to trackers list" => "Go to trackers list",
// "User Registration Tracker" => "User Registration Tracker",
// "choose a user tracker .." => "choose a user tracker ..",
// "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign" => "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign",
// "Select user field" => "Select user field",
"Choose a field .." => "Choisissez un champ ..",
// "No fields in tracker .." => "No fields in tracker ..",
// "Select the user selector field from the above tracker to link a tracker item to the user upon registration" => "Select the user selector field from the above tracker to link a tracker item to the user upon registration",
// "No fields in this tracker" => "No fields in this tracker",
// "Go to tracker list" => "Go to tracker list",
// "User Wizard Fields" => "User Wizard Fields",
// "By default, the same fields as in registration are used" => "By default, the same fields as in registration are used",
// "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time" => "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time",
// "Group or User Tracker Registration Fields" => "Group or User Tracker Registration Fields",
// "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete" => "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete",
"User can assign himself or herself to the group" => "Un utilisateur peut se mettre dans ce groupe lui-même",
// "Membership expiry" => "Membership expiry",
// "Anniversary" => "Anniversary",
// "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date" => "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date",
"Or" => "Ou",
// "Number of Days" => "Number of Days",
// "Number of days after which all users will be unassigned from the group" => "Number of days after which all users will be unassigned from the group",
// "Pro-Rate Membership" => "Pro-Rate Membership",
// "Payment for membership extension is prorated at a minimum interval" => "Payment for membership extension is prorated at a minimum interval",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "Les utilsateurs sont automatiquement assignés dès leur enregistrement au groupe si leur adresse mail est de la forme",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Assign Permissions" => "Attribuer des droits d'accès",
"Group tracker item : {\$groupitemid}" => "La fiche du groupe : {\$groupitemid}",
"Edit Item" => "Modifier la fiche",
"Group tracker item not found" => "La fiche du groupe non trouvée",
// "</i>\"}%0 members" => "</i>\"}%0 members",
// "Assigned" => "Assigned",
"Edit user" => "Modifier l'utilisateur",
// "Remove from group" => "Remove from group",
// "No members" => "No members",
// "Add or ban users" => "Add or ban users",
"Add to group" => "Ajouter au groupe",
// "Ban from group" => "Ban from group",
// "</i>\"}Users banned from %0" => "</i>\"}Users banned from %0",
// "Banned members" => "Banned members",
"Unban user" => "Dé-bannir un utilisateur",
// "Unban user %0 from group %1" => "Unban user %0 from group %1",
// "No banned members" => "No banned members",
// "</i>\"}%0 import/export" => "</i>\"}%0 import/export",
// "Export group users (CSV file)" => "Export group users (CSV file)",
"Charset encoding" => "Encodage des caractères",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
// "Import users to group (CSV file)" => "Import users to group (CSV file)",
// "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Ajouter un nouvel utilisateur",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
"Number of displayed rows" => "Nombre de lignes affichées",
"More Criteria" => "Plus de critères",
"Group (direct)" => "Groupe (direct)",
// "Email not confirmed" => "Email not confirmed",
// "User not validated" => "User not validated",
"OpenID" => "OpenID",
// "Edit account settings" => "Edit account settings",
"N" => "N",
"Registered %0 ago" => "Inscrit depuis %0",
"Need to validate email" => "Nécessite une validation par email",
// "Edit this included group" => "Edit this included group",
// "Add or remove from a group" => "Add or remove from a group",
// "Edit group expiry" => "Edit group expiry",
"Change user preferences" => "Changer les préférences utilisateur",
// "Switch to this user" => "Switch to this user",
// "Validate user" => "Validate user",
// "Invalidate user" => "Invalidate user",
// "Remove link with OpenID for this user" => "Remove link with OpenID for this user",
"Remove link with OpenID account" => "Supprimer le lien avec le compte OpenID",
// "Remove users.." => "Remove users..",
// "Ban IPs" => "Ban IPs",
// "Change group assignments" => "Change group assignments",
// "Set default groups" => "Set default groups",
// "Send wiki page content by email" => "Send wiki page content by email",
// "Warning: User Encryption is Active" => "Warning: User Encryption is Active",
// "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted" => "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted",
"Assign user to Groups" => "Assigner l'utilisateur à des groupes",
// "Intertiki Enabled" => "Intertiki Enabled",
// "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"" => "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"",
"Use the email as username" => "Utilisez l'adresse électronique comme nom d'utilisateur",
// "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames" => "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames",
// "Changing username is disabled for Intertiki sites" => "Changing username is disabled for Intertiki sites",
"No password is required" => "Un mot de passe n'est pas obligatoire",
"Tiki is configured to delegate the password managment to LDAP" => "Tiki est configuré pour déléguer la gestion des mots de passe à LDAP",
"New password" => "Nouveau mot de passe",
"Confirm new password" => "Confirmer le nouveau mot de passe",
"User must change password at next login" => "L'utilisateur doit changer son mot de passe à sa prochaine connexion",
"Send an email to the user to enable him or her to validate their account." => "Envoyer un courriel à l'utilisateur pour qu'il valide son compte.",
// "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>",
// "Add a user tracker item for this user" => "Add a user tracker item for this user",
// "User tracker" => "User tracker",
// "View item" => "View item",
// "Modify this user\\'s data" => "Modify this user\\'s data",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
"You do not have permission to edit this user" => "Vous n'avez pas le droit de modifier cet utilisateur",
// "Your file should contain in the first row (first entry) the following fields" => "Your file should contain in the first row (first entry) the following fields",
// "user1,pass1,email1,group1,group1" => "user1,pass1,email1,group1,group1",
// "user2,pass2,email2,\"group1,group2\",group1" => "user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time" => "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time",
// "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any" => "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any",
// "Existing Users" => "Existing Users",
"Don't overwrite" => "Ne pas écraser",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "The user must change his or her password the first time they log in" => "The user must change his or her password the first time they log in",
// "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>" => "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>",
"Temporary Users" => "Utilisateurs temporaires",
"Token Access Feature Dependency" => "Dépendance de la fonctionnalité d'accès aux jetons",
"The token access feature is needed for Temporary Users to login." => "La fonction d'accès aux jetons est requise pour les utilisateurs temporaires pour se connecter.",
"Turn it on here." => "Activez-le ici.",
// "Feature Conflict" => "Feature Conflict",
// "This feature currently is incompatible with the \"Use email as username\" feature" => "This feature currently is incompatible with the \"Use email as username\" feature",
// "Turn it off here" => "Turn it off here",
// "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature" => "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature",
// "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token" => "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token",
// "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself" => "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself",
// "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms" => "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms",
// "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails" => "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails",
// "To revoke access before validity expires or to review who has access, please see" => "To revoke access before validity expires or to review who has access, please see",
// "Email addresses (comma-separated)" => "Email addresses (comma-separated)",
// "Valid for days (use -1 for forever)" => "Valid for days (use -1 for forever)",
// "Username prefix" => "Username prefix",
// "Autologin (non-SEFURL) path" => "Autologin (non-SEFURL) path",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences",
"Add Type" => "Ajouter un type",
"Add article type" => "Ajouter un type d'article",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
"View articles with this type" => "Afficher les articles de ce type",
"Show before publish date" => "Afficher avant la date de publication",
"Show after expire date" => "Afficher après la date d'expiration",
"Heading only" => "En-tête seulement",
// "Comment can rate article" => "Comment can rate article",
"Show image" => "Afficher l'image",
"Show profile picture" => "Afficher l'avatar",
"Show expire date" => "Afficher la date d'expiration",
"Show reads" => "Afficher le nombre de lecture",
"Show size" => "Afficher la taille",
"Show topline" => "Afficher le surtitre",
"Show subtitle" => "Afficher le sous-titre",
"Show source" => "Afficher le code source",
// "Show image caption" => "Show image caption",
"Creator can edit" => "Le créateur peut modifier",
"Custom attribute" => "Attribut personnalisé",
"Assign User %0 to Groups" => "Attribuer un/plusieurs groupe(s) à l'utilisateur %0",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"backlinks to" => "Pages pointant vers",
"No backlinks to this page" => "Aucune page ne pointe vers cette page",
"Directory batch upload" => "Répertoire d'envoi par lot",
"Browse Gallery" => "Parcourir la galerie",
"Upload From Disk" => "Envoyer à partir de son disque",
"available images" => "images disponibles",
"Filesize" => "Taille du fichier",
"Filetype" => "Type du fichier",
"Remove File Extension from Image Name" => "Donner comme nom d'image, le nom du fichier sans son extension",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ex. pour \"digicam0001.jpg\" le nom sera digicam0001",
"Convert the last sub directory to a sub gallery" => "convertir le dernier sous répertoire en une sous galerie",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "exemple : pour une arborescence \"misc/screenshots/digicam0001.jpg\" une galerie nommée \"screenshots\" sera créée",
"Use the last sub directory name as description" => "Utiliser le nom de la dernière sous-catégorie comme description",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "exemple : pour une arborescence comme \"misc/screenshots/digicam0001.jpg\" une description \"screenshots\" sera ajouté aux images",
"Select a Gallery" => "Sélectionner une galerie",
"Process" => "Processus",
"Browse File Gallery" => "Parcourir la galerie de fichiers",
"Please do not use this feature to upload data into the database." => "SVP, n'utilisez pas cette fonctionnalité pour envoyer des données dans la base de données.",
"Available Files" => "Fichiers disponibles",
// "File Permissions" => "File Permissions",
// "File is writable" => "File is writable",
// "File is not writable" => "File is not writable",
"Total: %0" => "Total : %0",
"Select a File Gallery" => "Sélectionner une galerie de fichiers",
"Root" => "Racine",
// "Upload into galleries according to sub-directories" => "Upload into galleries according to sub-directories",
// "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists" => "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists",
// "Create sub-galleries" => "Create sub-galleries",
// "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set" => "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set",
// "Upload into galleries according sub-directory as galleryId" => "Upload into galleries according sub-directory as galleryId",
// "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists" => "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists",
"Process files" => "Traiter les fichiers",
"Edit Post" => "Modifier une publication",
"New Post" => "Nouvelle Publication",
"View post" => "Voir la publication",
"View Blog" => "Afficher le blogue",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Note : Ceci est un aperçu, et n'a pas encore été sauvegardé",
"Excerpt" => "Extrait",
"Admin the Category System" => "Administrer le système de catégories",
"Browse in" => "Parcourir dans",
// "or in" => "or in",
"Image galleries" => "Galeries d'images",
"Trackers Items" => "Fiches de formulaires",
"Sheets" => "Feuillets",
// "Find in" => "Find in",
// " in the current category and its subcategories" => " in the current category and its subcategories",
"Hide subcategories objects" => "Cacher les objets des sous-catégories",
"Show subcategories objects" => "Montrer aussi les objets des sous-catégories",
// "Up one level" => "Up one level",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
// "Clear tags" => "Clear tags",
"With all selected tags" => "Avec tous les mots-clés sélectionnés",
"With one selected tag" => "Avec l'un des mots-clés sélectionnés",
"With last selected tag" => "Avec le dernier mot-clé sélectionné",
"More Popular Tags" => "Mots-clés les plus populaires",
"Alphabetically" => "Alphabétiquement",
"By Size" => "par taille",
"Cloud" => "Nuage",
// "{\$feature_label}" => "{\$feature_label}",
// "Filter in" => "Filter in",
// "All blogs" => "All blogs",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
// "Delete Tag" => "Delete Tag",
"Browsing Gallery:" => "Parcours de la galerie :",
// "Gallery actions" => "Gallery actions",
"List Galleries" => "Liste des galeries",
"Edit Gallery" => "Modifier la galerie",
"Upload Image" => "Envoyer une image",
"Directory Batch" => "Téléchargement serveur",
"List Gallery" => "Contenu de la galerie",
"All Images" => "Toutes les images",
"Rebuild Thumbnails" => "Refaire les vignettes",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "Trier les images par",
"subgallery" => "sous-galerie",
"Subgallery" => "Sous-galerie",
// "Original size" => "Original size",
"rotate right" => "pivoter à droite",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Vous pouvez voir l'image configurée pour cette galerie (première, aléatoire, etc.) dans votre navigateur en utilisant",
"You can include the gallery's image in an HTML page using" => "Vous pouvez inclure une image de la galerie dans une page HTML en utilisant",
"You can include the image in a tiki page using" => "Vous pouvez inclure l'image dans une page tiki en utilisant",
"Browsing Image" => "Parcours des images",
"Return to Gallery" => "Retour à la galerie",
"Edit Image" => "Modifier l'image",
"Bigger" => "Plus grand",
// "Slideshow forward" => "Slideshow forward",
// "Repeat" => "Repeat",
"Click to zoom" => "Cliquer pour zoomer",
"Image Name" => "Nom de l'image",
"Image size" => "pixel image",
"Image Scale" => "échelleImage",
"Original Size" => "Taille originale",
"Move image" => "Déplacer l'image",
"Include the image in a tiki page using the following syntax" => "Inclure l'image dans une page tiki en utilisant la syntaxe suivante",
"To include the image in an HTML page" => "Pour inclure l'image dans une page HTML",
"To link to this page from another tiki page" => "Pour créer un lien vers cette page à partir d'une autre page tiki",
// "Monitoring" => "Monitoring",
"Visible Calendars" => "Calendriers visibles",
"Group Calendars" => "Calendriers de groupe",
"Export calendars" => "Export de calendriers",
"advanced parameters" => "paramètres avancés",
"Export as iCal" => "Exporter au format iCal",
"January" => "janvier",
"February" => "février",
"March" => "mars",
"April" => "avril",
"May" => "mai",
"June" => "juin",
"July" => "juillet",
"August" => "août",
"September" => "septembre",
"October" => "octobre",
"November" => "novembre",
"December" => "décembre",
"Jan." => "janv.",
"Feb." => "févr.",
"Mar" => "mars",
"Apr." => "avr.",
"Aug." => "août",
"Sep." => "sept.",
"Oct." => "oct.",
"Nov." => "nov.",
"Dec." => "déc.",
"Sun" => "dim.",
"Mon" => "lun.",
"Tue" => "mar.",
"Wed" => "mer.",
"Thu" => "jeu.",
"Fri" => "ven.",
"Sat" => "sam.",
"today" => "aujourd'hui",
// "semester" => "semester",
// "quarter" => "quarter",
"all-day" => "journée entière",
"Organized by" => "Organisé par",
"Classification" => "Classification",
"View this Week" => "Afficher cette semaine",
"Change Focus" => "Changer le focus",
"View this Day" => "Afficher ce jour",
"Calendar event : " => "Evénement du calendrier :",
"New event" => "Nouvel évènement",
"View event" => "Voir cet évènement",
"Edit/Delete event" => "Éditer/Supprimer un évènement",
// "Export Event as iCal" => "Export Event as iCal",
"Edit Calendar Item" => "Modifier un évènement de calendrier",
"New Calendar Item" => "Nouvel évènement de calendrier",
"Recurrence" => "Récurrence",
"This event depends on a recurrence rule" => "Cet évènement est récurrent",
"ending by" => "terminant le",
"ending after" => "terminant après",
"events" => "évènements",
// "(%0 events have been manually modified)" => "(%0 events have been manually modified)",
// "(%0 event has been manually modified)" => "(%0 event has been manually modified)",
"This event is not recurrent" => "Cet évènement n'est pas récurrent",
"On a weekly basis" => "Hebdomadaire",
"Each" => "Chaque",
"of the week" => "de la semaine",
"On a monthly basis" => "Mensuel",
"of the month" => "du mois",
"On a yearly basis" => "Annuel",
"of" => "de",
"Starting on" => "Commençant le",
"Start period" => "Début de la période",
// "End Period" => "End Period",
"End after" => "Fin après",
"occurrences" => "occurrences",
// "occurrence" => "occurrence",
"End before" => "Fin avant le",
// "Event occurs once on" => "Event occurs once on",
"Event is repeated" => "L'évènement est répété",
"times" => "fois",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "de chaque mois",
"on each" => "chaque",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
// "starting" => "starting",
// "ending" => "ending",
"Show duration" => "Afficher la durée",
"Events cannot end before they start" => "Un évènement ne peut finir avant son commencement",
"No description" => "Pas de description",
"or new" => "ou nouveau",
"Choose users to alert" => "Choisir les utilisateurs à alerter",
"Withdraw me from the list of participants" => "Me retirer de la liste des participants",
"Add me to the list of participants" => "M'ajouter à la liste des participants",
"Roles" => "Rôles",
"chair" => "président de séance",
"default role" => "rôle par défaut",
"required participant" => "participant requis",
"optional participant" => "participant non obligatoire",
"non-participant" => "non-participant",
"Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in" => "Donner la liste des participants en les séparant par des virgules. Les rôles des participants sont à donner en préfixant par un double-point(:) comme dans l'exemple suivant",
"role:login_or_email,login_or_email" => "rôle:login_ou_email,login_ou_email",
"If no role is provided, default role will be \"Chair participant\"." => "Si aucun rôle n'est défini, le rôle attribué par défaut sera \"président de séance\".",
"Update this event only" => "Ne mettre à jour que cet évènement",
"Update every unchanged event in this recurrence series" => "Mettre à jour tous les évènements inchangés de cette récurrence",
"Update every event in this recurrence series" => "Mettre à jour tous les évènements de cette récurrence",
"Delete event" => "Supprimer cet évènement",
"Delete recurrent events" => "Supprimer tous les évènements liés à cette récurrence",
"Calendar import" => "Import de calendrier",
"Calendar has been updated" => "Le calendrier a été mis à jour",
"%0 column name can be used instead of %1" => "%0 nom de colonne peut être utilisé à la place de %1",
"import" => "importer",
// "Previous {\$viewmode|escape}" => "Previous {\$viewmode|escape}",
"D" => "J",
"W" => "S",
"M" => "M",
// "Next {\$viewmode|escape}" => "Next {\$viewmode|escape}",
// "%d/%m" => "%d/%m",
"%m/%d" => "%d/%m",
"Advanced parameters for iCal export" => "Paramètres avancés pour l'export iCal",
"Calendars to be exported" => "Calendriers à exporter",
"Export calendars iCal" => "Exporter les calendriers en iCal",
"Export calendars CSV" => "Exporter les calendriers en CSV",
"Your account has been validated" => "Votre compte a été validé",
"You have to choose a password to use this account" => "Vous devez choisir un mot de passe pour utiliser ce compte",
// "Change password" => "Change password",
// "Set password" => "Set password",
// "Old Password" => "Old Password",
// "Repeat Password" => "Repeat Password",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Acknowledge (OK)" => "Acknowledge (OK)",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Acknowledge" => "Acknowledge",
// "New database engine" => "New database engine",
// "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki" => "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki",
// "MySQL crashed Tables" => "MySQL crashed Tables",
// "Be careful" => "Be careful",
// "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure" => "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure",
// "Test sending emails" => "Test sending emails",
// "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>" => "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Special directories" => "Special directories",
// "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>" => "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>",
// "Fitness" => "Fitness",
// "Directory is writeable" => "Directory is writeable",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "Change PHP configuration values" => "Change PHP configuration values",
// "{\$php_sapi_info.message}" => "{\$php_sapi_info.message}",
// "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>" => "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>",
// "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>" => "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>",
// "PHP Security properties" => "PHP Security properties",
// "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>" => "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>",
// "Tiki Security" => "Tiki Security",
// "Sensitive Data Exposure" => "Sensitive Data Exposure",
// "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information",
// "Print configurations" => "Print configurations",
// "mPDF Information" => "mPDF Information",
// "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print" => "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print",
// "File Gallery Search Indexing" => "File Gallery Search Indexing",
// "More information %0 here %1" => "More information %0 here %1",
// "Command Missing" => "Command Missing",
// "The command \"shell_exec\" is required for file gallery search indexing" => "The command \"shell_exec\" is required for file gallery search indexing",
// "Mimetype" => "Mimetype",
// "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable" => "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
// "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>" => "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>",
// "Benchmark PHP/MySQL" => "Benchmark PHP/MySQL",
// "Check" => "Check",
// "BOM Detected Files" => "BOM Detected Files",
// "Scanned files" => "Scanned files",
// "BOM files detected" => "BOM files detected",
// "No BOM files detected" => "No BOM files detected",
// "TRIM" => "TRIM",
// "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>" => "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>",
// "Requirements" => "Requirements",
// "OS not supported" => "OS not supported",
// "Apparently tiki is running on a Windows based server. This feature is not supported natively" => "Apparently tiki is running on a Windows based server. This feature is not supported natively",
// "User Data Encryption" => "User Data Encryption",
// "MCrypt encryption found in users data preferences" => "MCrypt encryption found in users data preferences",
// "Found %0 user(s) with data preferences encrypted with MCrypt" => "Found %0 user(s) with data preferences encrypted with MCrypt",
// "No user preferences were found with data encrypted with MCrypt" => "No user preferences were found with data encrypted with MCrypt",
// "Tiki Packages" => "Tiki Packages",
// "OCR Status" => "OCR Status",
"Please choose the language for this page:" => "Veuillez choisir la langue pour cette page :",
"Choose language" => "Choisir cette langue",
"Contact Us" => "Nous contacter",
"Send a message to us" => "Nous envoyer un message",
"Your email" => "Votre adresse email",
"Contact us by email" => "Nous contacter par courriel",
"Click here to send us an email" => "Cliquer ici pour nous envoyer un email",
"Send another message" => "Envoyer un autre message",
"Contacts" => "Contacts",
"Group View" => "Vue par groupe",
"Create/edit contacts" => "Ajouter/modifier un contact",
"First Name" => "Prénom",
"Last Name" => "Nom de famille",
"Nickname" => "Surnom",
"Publish this contact to groups" => "Partager ce contact avec les groupes",
// "Extra Fields" => "Extra Fields",
"Copy page" => "Copier la page",
"Invalid page name" => "Nom de page non valide",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "Le nom de page spécifié contient des caractères non autorisés. Il ne sera pas possible d'enregistrer la page avant que ceux-ci soient retirés : <strong>%0</strong>",
"The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "Le nom de page spécifié contient des caractères qui peuvent rendre l'adressage de cette page difficile. Vous pourriez envisager de les retirer : <strong>%0</strong>",
"Use this name anyway" => "Utiliser ce nom quand même",
// "Duplicate tags" => "Duplicate tags",
"Quick Create Multilanguage Pages" => "Créer rapidement des pages multilingues",
"Following pages were created, as translations of each other" => "Les pages suivantes ont été crées comme traductions de chacunes d'entre-elles",
"Following pages were not created" => "Les pages suivantes n'ont pas été créées",
"page already exists" => "la page existe déjà",
"Enter the names of a new page page in various languages" => "entrer les noms d'une nouvelle page en différentes langues",
"Preferred languages" => "Langues préférées",
"Other languages" => "Autres langues",
"Create pages" => "Créer des pages",
// "View generated WebHelp" => "View generated WebHelp",
"No structure" => "Aucune structure",
"Top page" => "Page du 1ier niveau",
"Add a new site" => "Ajouter un nouveau site",
"You cannot add sites until Directory Categories are setup." => "Vous ne pouvez pas ajouter de sites avant que les catégories de répertoires soient configurées.",
"Please contact the Site Administrator" => "SVP, contacter l'administrateur du site",
"<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Ajouter une catégorie de répertoire maintenant</a>",
"Site added" => "Site ajouté",
"The following site was added, but may require validation by the admin before appearing on the lists" => "Le site suivant a été ajouté, mais peut nécessiter la validation d'un administrateur avant d'apparaître dans les listes",
"Edit a site" => "Éditer un site",
"Add a site" => "Ajouter un site",
"Directory Categories" => "Catégories de l'annuaire",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Admin Directory" => "Administrer l'annuaire",
"There are" => "Il y a",
"invalid sites" => "sites invalides",
"valid sites" => "sites valides",
"Users have visited" => "Les utilisateurs ont visité",
"sites from the directory" => "sites de cet annuaire",
"Users have searched" => "Les utilisateurs ont cherché",
"times from the directory" => "fois de cet annuaire",
"Validate" => "Valider",
"Admin directory categories" => "Administrer les catégories de l'annuaire",
"Parent directory category" => "Catégorie de répertoire parente",
"Add a directory category" => "Ajouter une catégorie à l'annuaire",
"Edit this directory category" => "Modifier les catégories de ce répertoire",
"Add a Directory Category" => "Ajouter une Catégorie à l'Annuaire",
"Child type" => "Type de l'affichage complémentaire",
"Most visited directory sub-categories" => "Sous-catégories de l'annuaire les plus visitées",
"Directory category description" => "Description de la catégorie d'annuaire",
"Random directory sub-categories" => "Sous-catégories aléatoires de l'annuaire",
"Maximum number of child directory categories to show" => "Nombre maximum de sous-catégories à montrer",
"Allow sites in this directory category" => "Permettre les sites dans cette catégorie de répertoire",
"Show number of sites in this directory category" => "Afficher le nombre de sites dans cette catégorie de répertoire",
"Editor group" => "Groupe éditeur",
"Directory Subcategories" => "Sous-catégories de l'annuaire",
"cType" => "Type enfant",
"allow" => "permis",
"count" => "nombre",
"editor" => "éditeur",
// "Relate" => "Relate",
"Admin related directory categories" => "Administrer les catégories de répertoire en relation",
"Add a related directory category" => "Ajouter une catégorie de répertoire liée",
"Directory Category" => "Catégorie de l'Annuaire",
"Mutual" => "Mutuelle",
"Related directory categories" => "Catégories de répertoire en relation",
"Admin sites" => "Administrer les sites",
"Is valid" => "Est valide",
"New Sites" => "Nouveaux sites",
"Popular Sites" => "Sites cools",
"Directory:" => "Annuaire de sites :",
"any" => "quelconque",
"in entire directory" => "dans l'annuaire entier",
"in current directory category" => "dans la catégorie courante de l'annuaire",
"Sort by" => "Trier par",
"Hits (desc)" => "Visites (desc)",
"Hits (asc)" => "Visites (asc)",
"Last updated (desc)" => "Ordre décroissant de dernière mise à jour",
"Last updated (asc)" => "Ordre croissant de dernière mise à jour",
"sort" => "trier",
"No records" => "Aucun résultat",
"Total directory categories" => "Nombre total de catégories de répertoire",
"Total links" => "Nombre total de liens",
"Links to validate" => "Liens à valider",
"Searches performed" => "Recherches faites",
"Total links visited" => "Nombre total de liens visités",
"Directory ranking" => "Classement de l'annuaire",
"Validate sites" => "Sites validés",
"country" => "pays",
"Discounts" => "Remises",
// "{\$prefs.payment_currency|escape}" => "{\$prefs.payment_currency|escape}",
// " or " => " or ",
"Maximum time the discount can be used in the first phase of payment" => "Durée maximale où la remise peut être utilisée dans la première phase de payement",
"-1 for unlimited" => "-1 pour illimité",
"Translation of this page is incomplete." => "La traduction de cette page n'est pas terminée.",
"To add <strong>new content</strong> to the page" => "Pour ajouter du <strong>nouveau contenu</strong> à la page",
"use the editor" => "Utiliser l'éditeur",
"Edit article" => "Modifier un article",
"View Articles" => "Afficher les articles",
"Allow full HTML" => "Autoriser pleinement le HTML",
"Keep any HTML tag" => "Interprète tous les tags HTML",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
"To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language." => "Pour traduire, ne changez pas la langue et le contenu. Au lieu de cela, <a class=\"alert-link\" href=\"tiki-edit_translation.php?no_bl=y&page=HomePage\"> créez une nouvelle traduction </a> dans la nouvelle langue.",
// "{\$typei|escape}" => "{\$typei|escape}",
// "Click \"Preview\" after selecting article type to have appropriate edit form fields" => "Click \"Preview\" after selecting article type to have appropriate edit form fields",
// "Publication" => "Publication",
// "If checked, the article is published" => "If checked, the article is published",
"User (article owner)" => "Utilisateur (propriétaire de l'article)",
"Time" => "Temps",
"Own Image" => "Image associée",
"If not the topic image" => "Si différente de l'image du sujet",
// "Max file size : {\$prefs.article_image_file_size_max/1000} KB" => "Max file size : {\$prefs.article_image_file_size_max/1000} KB",
"Current Image" => "Image en cours",
"Article image" => "Image d'article",
"Image caption" => "Légende de l'image",
// "Default will use the topic name" => "Default will use the topic name",
"Use own image" => "Utiliser l'image associée",
"Float text around image" => "Texte flottant autour de l'image",
// "Read Article" => "Read Article",
// "Maximum dimensions of custom image in view mode" => "Maximum dimensions of custom image in view mode",
// "Maximum dimensions of custom image in list mode" => "Maximum dimensions of custom image in list mode",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Topline" => "Surtitre",
// "http://.." => "http://..",
// "Test your link: " => "Test your link: ",
"Apply content template" => "Appliquer un gabarit de contenu",
// "{\$template.name|escape}" => "{\$template.name|escape}",
"Email addresses to be sent notifications (comma-separated)" => "Adresses mail à notifier (séparées par des virgules)",
"Cancel the edit (changes will be lost)." => "Annuler la modification, vous allez perdre les modifications.",
// "Create or edit banners" => "Create or edit banners",
"List banners" => "Liste des bannières",
"URL to link the banner" => "Adresse web de la bannière publicitaire",
"Client" => "Client",
"Maximum impressions" => "Max. d'impressions",
"Maximum number of impressions for a user" => "Max d'impressions pour un utilisateur",
"Maximum clicks" => "Max de clics",
"URIs where the banner appears only" => "Seuls URLs où la bannière apparait",
"Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Saisir chaque URL entouré par des #. <br/>Exemple :#/cette_page#/tiki-index.php?page=cette_page#",
// "URIs where the banner will not appear" => "URIs where the banner will not appear",
"Or, create a new zone" => "Ou, créer une nouvelle zone",
// "New Zone" => "New Zone",
"Show the banner only between these dates" => "Afficher la bannière seulement entre ces dates",
"From date" => "De cette date",
"To date" => "À cette date",
"Use dates" => "Avec des dates",
// "Show the banner only in these hours" => "Show the banner only in these hours",
"Show the banner only on" => "Afficher la bannière seulement les",
"Select ONE method for the banner" => "Sélectionner UNE méthode pour la bannière",
"Use Image" => "Utiliser images",
// "Use Image from URL" => "Use Image from URL",
// "(the image will be requested at the URL for each impression)" => "(the image will be requested at the URL for each impression)",
"Use Flash" => "Utiliser Flash",
"Movie Size" => "Taille de la vidéo",
// "width in pixels" => "width in pixels",
"Pixels" => "Pixels",
// "height in pixels" => "height in pixels",
"FlashPlugin min version" => "Version minimum du plugiciel Flash",
"ex" => "ex",
// "Use Text" => "Use Text",
"Save the Banner" => "Enregistrer la bannière",
"Remove zones (info entered for any banner in the zones will be lost)" => "Supprimer les zones (vous perdrez toute l'information entrée pour la bannière)",
"Edit Blog" => "Modifier le blogue",
"A category is mandatory" => "Une catégorie est obligatoire",
"Individual permissions are set for this blog" => "Des droits d'accès individuels ont été définis sur ce blogue",
"Allow other users to post in this blog" => "Autoriser d'autres utilisateurs à publier des messages dans ce blogue",
"Even if others post to the blog, the author is always its administrator" => "Si d'autres postent dans le blogue, l'auteur devrait toujours en rester le propriétaire",
"Allow search" => "Permettre les recherches",
"Allow comments" => "Permettre les commentaires",
"Use post excerpt" => "Utiliser les extraits de message",
"Display Options" => "Options d'affichage",
// "Displayed posts" => "Displayed posts",
"Number of posts to show per page" => "Nombre de messages par page",
"Display the blog title on the posts list page" => "Afficher le titre du blogue dans la page du blogue",
"Display the blog title on the post page" => "Afficher le titre du blogue dans le message",
"Display the blog description" => "Afficher la description du blogue",
"Display breadcrumbs" => "Afficher le fil d'Arianne",
"Display the author in blog posts" => "Afficher l'auteur dans le message",
"Display the publish date in blog posts" => "Afficher la date de publication dans le message",
"Show user profile picture" => "Afficher les avatars",
"Show the post's related content" => "Afficher le contenu associé au message",
"The checkbox is disabled because the tags feature is disabled globally" => "La case à cocher est désactivée parce que la fonctionnalité mots-clés est globalement désactivée",
// "Related posts" => "Related posts",
"Maximum number of related posts to display" => "Nombre maximun de message associés à afficher",
"Blog heading" => "En-tête de blogue",
"Heading preview" => "Prévisualisation des en-têtes",
"Blog post heading" => "En-tête de message",
"Organizer" => "Organisateur",
"Move objects between categories" => "Déplacer les objets entre les catégories",
"Click on the category name to display the list of objects in that category." => "Cliquez sur le nom de la catégorie que vous voulez lister. La liste des objets dans cette catégorie deviendra visible.",
"Select the objects to affect. Controls will appear in the category browser." => "Sélectionner les objets voulus. Les contrôles vont apparaître dans le navigateur des catégories.",
"Use the plus and minus signs to add or remove the categories on selected objects." => "Utiliser les signes plus et moins pour ajouter ou enlever les catégories des objets sélectionnés.",
// "Object list result" => "Object list result",
// "Select objects to change categorization" => "Select objects to change categorization",
"More results are available. Please refine the search criteria" => "Plus de résultats disponibles. Merci d'affiner les critères de recherche",
"Select all" => "Tout sélectionner",
"Unselect all" => "Tout désélectionner",
"The file will be saved in" => "Le fichier sera enregistré dans",
// "Currently trying" => "Currently trying",
"Try" => "Essayer",
// "Missing Package" => "Missing Package",
// "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package" => "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package",
// "Please contact the Administrator to install it" => "Please contact the Administrator to install it",
// "Tiki Docs" => "Tiki Docs",
"Save file" => "Enregistrer le fichier",
"Cancel editing file" => "Annuler l'édition du fichier",
"Editing file" => "Edition du fichier",
// "Save and Back" => "Save and Back",
"Rename" => "Renommer",
"Toggle Fullscreen" => "Basculer plein écran",
"More information" => "Plus d'informations",
"Wiki Page Editor" => "Éditeur de page Wiki",
"More help on editing wiki pages" => "Aide supplémentaire pour éditer des pages Wiki",
"The syntax system used for creating pages in Tiki" => "Le système de syntaxe utilisé pour créer des pages dans Tiki",
"Bold text" => "Texte en gras",
"Italic text" => "Texte en italique",
"single quotes" => "apostrophes simples",
"Underlined text" => "Texte souligné",
"Colored text" => "Texte coloré",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Affichera le texte avec la couleur indiquée (code HTML ou nom). Le nom de la couleur peut en contenir deux, séparées par une virgule. Dans ce cas, la première couleur est pour l'avant-plan et la seconde pour l'arrière-plan",
"Deleted text" => "Texte effacé",
"2 dashes" => "2 tirets",
"Headings" => "En-têtes",
"show/hide heading section. + (shown) or - (hidden) by default" => "montre/cache les en-têtes de sections. + (vu) ou - (caché) par défaut",
"Autonumbered Headings" => "En-têtes autonumérotées",
"{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} crée et affiche une table des matières pour la page courante fondée sur les structures (toc) ou les en-têtes ! (maketoc)",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Les paramètres optionnels courants pour maketoc sont : title|maxdepth|levels|nums, et pour toc : order|showdesc|shownum|structId|maxdepth|pagename",
"Horizontal rule" => "Règle horizontale",
"Text box" => "Boîte texte",
"Box content" => "Contenu de la boîte",
"Centered text" => "Texte centré",
"Inserts an editable variable" => "Insérer une variable dynamique",
"External links" => "Liens externes",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "Utiliser les crochets [ ] pour un lien externe : [URL], [URL|description_lien],[URL|description_lien|relation] ou [URL|description_lien|relation|nocache] (cette dernière option empêche le Wiki local de mettre en cache la page liée; relation peut être utilisé pour insérer un attribut rel pour le lien - pratique par exemple pour une shadowbox)",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Pour un Wiki externe, utiliser NomWikiExterne:NomPage ou ((Nom Wiki Externe: Nom Page))",
"Square Brackets" => "Crochets",
"Use [[foo] to show [foo]." => "Utiliser [[toto] pour afficher [toto].",
"JoinCapitalizedWords or use" => "JuxtaposerLesMotsEnMajuscules ou utiliser",
"page|description" => "page|desc",
"for wiki references" => "pour une référence Wiki",
"page|#anchor" => "page|#anchrage",
"page|#anchor|desc" => "page|#anchrage|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
"SomeName" => "UnNom",
"prevents referencing" => "pour empêcher de faire une référence",
"Lists" => "Listes",
"for bullet lists" => "pour une liste à puces",
"for numbered lists" => "pour une liste numérotée",
"definition" => "définition",
"for definiton lists" => "pour une définition",
"Indentation" => "Indentation",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Ajoute un niveau d'indentation pour chaque plus (utile dans une liste pour pouvoir poursuivre au même niveau)",
"Tables" => "Tableaux",
"row" => "rangée",
"col" => "col",
"Monospace font" => "Police à espacement fixe",
"Code sample" => "Echantillon de code",
"(very useful especially in tables)" => "(très utile particulièrement dans les tableaux)",
"Multi-page pages" => "Multi-pages",
"to separate pages" => "pour séparer les pages",
"Non-parsed sections" => "Sections non analysables",
"data" => "données",
"Prevents wiki parsing of the enclosed data." => "Empêche l'analyse Wiki pour les données encadrées.",
"Preformated sections" => "Sections préformatées",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ données ~/pp~ Affiche du texte ou code préformaté ; aucune analyse Wiki n'a lieu à l'intérieur de ces sections (comme avec np), et l'espacement est fixe (aucun saut à la ligne n'est fait).  ~pre~ données ~/pre~ affiche aussi du texte préformaté avec espacement fixe, mais le traitement Wiki est effectué sur le texte",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Commentaire Tiki ~/tc~ crée un commentaire Tiki.  Il sera complètement retiré de l'affichage, mais sauvegardé dans le fichier pour servir de référence ultérieurement.  ~hc~ Commentaire HTML ~/hc~ crée un commentaire HTML.  Il sera inséré en tant que commentaire dans la sortie HTML; ceux-ci ne sont pas normalement affichés par les navigateurs, mais peuvent être vus en utilisant \"Voir le code Source\" ou similaire",
"Block Preformatting" => "Préformatter un bloc de texte",
"Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Indente le texte avec autant de caractères que nécessaire pour suivre les autres instructions Wiki. L'indentation sera la même que celle que vous utilisez. Remarquez que ce mode ne conserve pas exactement le même nombre d'espaces et de retours à la ligne; utiliser ~pp~...~/pp~ pour cela.",
"Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew." => "Insertion de, respectivement, une partie de texte orientée de droite à gauche ou de gauche à droite (jusquà la fin du texte) et des marqueurs pour les langues arabes ou hébraïques.",
"Special characters" => "Caractères spéciaux",
"hard space" => "Espace insécable",
"numeric between ~ for HTML numeric characters entity" => "numérique entre ~ pour l'entité de caractères numériques de HTML",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Notez que les arguments des plugiciels peuvent être encadrés par des guillemets (\") ; Ceci leur permet de comporter des virgules (,), des signes comme \"égal\" (=) ou \"supérieur à\" (>)",
"More help here" => "Plus d'aide ici",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Les plugiciels Wiki étendent la syntaxe wiki avec des commandes plus spécialisées",
"Activate/deactivate plugins" => "Activer/désactiver des plugiciels",
"No description available" => "Aucune description disponible",
"For more information, please see" => "Pour plus d'information, voir",
"WYSIWYG Editor" => "Editeur Wysiwyg",
"More help on WYSIWYG editing" => "Davantage d'aide sur l'édition en wysiwyg",
// "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>" => "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar",
// "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered" => "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered",
// "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around" => "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around",
// "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "Parcourir les images",
"Edit successful!" => "Modification réussie!",
"The following image was successfully edited" => "L'image suivante a été modifiée avec succès",
"Image Description" => "Description de l'image",
"Upload from disk to change the image" => "Charger depuis le disque pour changer l'image",
"Save and Go Next" => "Enregistrer et continuer",
"Edit Invoice" => "Modifier la facture",
"Invoice Number" => "Numéro de facture",
"Date Issued" => "Date d'émission",
"Work Description" => "Description",
"Taxable" => "Taxable",
"New Item" => "Nouvelle ligne",
"Invoice Note" => "Commentaire",
"Save Invoice" => "Enregistrer la facture",
"Customized String Translation" => "Traduction personnalisée",
"Manage local translations in a custom.php file" => "Gérer les traductions locales dans un fichier custom.php",
"Download language.php file for the selected language" => "Télécharger le fichier language.php pour la langue sélectionnée",
"Download Database Translations" => "Télécharger les traductions de base de données",
"Download a file with all the translations in the database for the selected language" => "Télécharger un fichier avec toutes les traductions dans la base de données pour la langue sélectionnée",
"Translations in the database will be merged with the other translations in language.php for the selected language" => "Les traductions dans la base de données seront fusionnées avec les autres traductions dans language.php pour la langue sélectionnée",
"Add a translation" => "Ajouter une traduction",
"Untranslated strings" => "Chaines non traduites",
"Show only database stored untranslated strings" => "afficher seulement les chaînes non traduites enregistrées dans la base de données",
"Edit translations" => "Modifier les traductions",
"Show only database stored translations" => "Montrer uniquement les traductions enregistrées dans la base de données",
"Original string" => "Texte original",
"Last changed by %0 on %1" => "Dernière modification par %0 le %1",
"Contribute:" => "Contribuer :",
"Undecided" => "Non décidé",
"Save translation in the database" => "Enregistrer la traduction dans la base de données",
"Delete translation from the database" => "Supprimer la traduction de la base de données",
"Compare" => "Comparer",
"Compare the original translation with the database translation" => "Comparez la traduction originale avec la traduction de la base de données",
"For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes." => "Pour les traductions spécifiques à cette instance Tiki, choisissez Non. Si cette traduction peut être contribuée à la communauté Tiki, choisissez Oui.",
"Translate all" => "Tout traduire",
"Delete all" => "Tout supprimer",
"Are you sure you want to delete all untranslated strings from database" => "Êtes-vous sûr(e) de vouloir supprimer toutes les chaînes non traduites de la base de données",
"Are you sure you want to delete all translations from database" => "Etes-vous sûr de vouloir supprimer toutes les traductions de la base de données",
"Return to the default perspective" => "Retour à la perspective par défaut",
"Switch to" => "Basculer vers",
// "Preference List" => "Preference List",
// "Search preferences below and drag them into the preference list above" => "Search preferences below and drag them into the preference list above",
"Program dynamic content for block" => "Programmer le contenu dynamique pour le bloc",
"Create New Block" => "Créer un nouveau bloc",
"Return to block listing" => "Retour à la liste de blocs",
"Block description: " => "Description du bloc : ",
"You are editing block" => "Vous êtes en train de modifier un bloc",
// "Publising Date" => "Publising Date",
"Publishing Date" => "Date de publication",
"Edit question options" => "Modifier les options d'une question",
"List Quizzes" => "Liste des QCMs",
"Quiz Stats" => "Statistiques sur les QCMs",
"This Quiz Stats" => "Statistiques de ce QCM",
"Edit this Quiz" => "Modifier ce QCM",
"Admin Quizzes" => "Administrer les QCMs",
"Create/edit options for question" => "Ajouter/modifier une option à la question",
"points" => "points",
"Quiz can be repeated" => "Le QCM peut être rempli plusieurs fois",
// "Time Limit" => "Time Limit",
"Create/edit quizzes" => "Ajouter/modifier un QCM",
"There are individual permissions set for this quiz" => "Des droits d'accès individuels ont été mis sur ce QCM",
"Store quiz results" => "Stocker les résultats du QCM",
"Quiz is time-limited" => "Durée limitée pour remplir le QCM",
"Maximum time" => "Temps maximum",
"Passing Percentage" => "Pourcentage d'accomplissement",
// "%" => "%",
"Edit quiz questions" => "Modifier les questions du QCM",
"Create/edit questions for quiz" => "Ajouter/modifier une question au QCM",
"Question Type" => "Type de la question",
"Import questions from text" => "Importer des questions d'un texte",
// "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct" => "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct",
"Input" => "Saisie",
"Maximum score" => "Score max.",
"Edit quiz results" => "Éditer les résultats du quiz",
"From Points" => "Des points",
"To Points" => "Aux points",
"Reports" => "Rapports",
"Report Builder" => "Constructeur de rapport",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
"Export As CSV" => "Exporter en CSV",
"You will remove" => "Vous allez supprimer",
// "and its subpages from the structure, now you have two options" => "and its subpages from the structure, now you have two options",
"and its subpages from the structure" => "et les sous-pages de la structure",
// "Remove from structure" => "Remove from structure",
// "Remove from structure and remove page too" => "Remove from structure and remove page too",
"The page already exists. The page that has been added to the structure is the existing one." => "La page existe déjà. La page qui a été ajoutée à la structure est celle qui existe.",
"The following pages added have automatically been categorized with the same categories as the structure" => "Les pages suivantes ont été catégorisées automatiquement avec les mêmes catégories que la structure",
"Structure Layout" => "Contenu de la structure",
// "Monitor the structure" => "Monitor the structure",
// "Stop Monitoring the structure" => "Stop Monitoring the structure",
"Add pages" => "Ajouter des pages",
// "Use an existing page by dragging it into the structure above" => "Use an existing page by dragging it into the structure above",
// "{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "Catégoriser toutes les pages dans la structure",
"Remove existing categories from ALL pages before recategorizing" => "Supprimer toutes les catégories de TOUTES les pages avant \"re-catégorisation\"",
"Move to another structure" => "Déplacer dans une autre structure",
"at the beginning" => "au début",
"at the end" => "à la fin",
"Submit article" => "Soumettre un article",
"List submissions" => "Liste des soumissions",
"Use ...page... to separate pages in a multi-page post" => "Utiliser ...page... pour séparer les pages",
// "Fields with <b>*</b> are optional" => "Fields with <b>*</b> are optional",
"<b>Topline</b>=small line above Title" => "<b>Surtitre</b>=petite ligne au-dessus du titre",
"<b>Subtitle</b>=small line below Title" => "<b>Sous_titre</b>=petite ligne en dessous du titre",
"<b>Source</b>=URL to article source" => "<b>Source</b>=URL vers le source de l'article",
"Author Name" => "Nom de l'auteur",
"Own image size x" => "Taille x de l'image associée",
"Own image size y" => "Taille y de l'image associée",
"Auto-Approve Article" => "Auto-approuver l'article",
"View template" => "Afficher le gabarit",
"Template listing" => "Liste des gabarits",
"Available templates" => "Gabarits disponibles",
"Important" => "Important",
// "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme" => "Sauvegarder uniquement dans le thème",
"Delete the copy in the theme" => "Supprimer la copie dans le thème",
// "Admin Article Topics" => "Admin Article Topics",
// "Edit article topic" => "Edit article topic",
"Admin notifications" => "Administrer les notifications",
// "Enter email addresses " => "Enter email addresses ",
"View Article" => "Voir l'article",
"Attach or detach existing translations of this page" => "Attacher ou détacher les traductions existantes de cette page",
"Manage Translations" => "Gérer les traductions",
"You must specify the object language" => "Vous devez spécifier la langue de l'objet",
"The object doesn't exist" => "L'objet n'existe pas",
"The object doesn't have a language" => "L'objet n'a pas d'indication de langue",
"The object already has a translation for this language" => "L'objet a déjà une traduction pour cette langue",
"The object is already in the set of translations" => "L'objet est déjà dans le jeu de traductions",
"Translate this page to a new language" => "Traduire cette page dans une nouvelle langue",
"Select language to translate to" => "Choisir une langue pour la traduction",
"Enter the page title" => "Entrer le titre de la page",
// "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
"Create translation" => "Créer la traduction",
"Change language for this page" => "Changer la langue pour cette page",
"Change Language" => "Changer de langue",
// "You forgot to specify the language of the translation. Please choose a language in the picklist" => "You forgot to specify the language of the translation. Please choose a language in the picklist",
"The page already exists. It was selected in the list below." => "\"Cette page existe déjà. Elle a été sélectionnée dans la liste ci-dessous.\"",
"No language is assigned to this page" => "Aucune langue n'est assignée à cette page",
"Please select a language before translating" => "Merci de sélectionner une langue avant de traduire",
// "Set Page Language" => "Set Page Language",
// "Edit %0" => "Edit %0",
"Update '{\$page}'" => "Mettre à jour '{\$page}'",
// "{\$customTip|escape}" => "{\$customTip|escape}",
// "Preview your changes" => "Preview your changes",
"Draft written on" => "Brouillon écrit sur",
"Warning: new versions of this page have been made after this draft" => "Attention : de nouvelles versions de cette page ont été faites après ce brouillon",
"The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page." => "Le bac à sable est une page où vous pouvez vous entraîner à mettre à jour une page : utiliser la fonction 'Aperçu' pour avoir un aperçu de la page; aucune version de cette page ne sera sauvegardée.",
// "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)" => "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)",
"An edit summary is mandatory" => "Un résumé de l'édition est obligatoire",
"Translate from" => "Traduire à partir de",
"Changes that need to be translated are highlighted below" => "Les changements à traduire sont surlignés ci-dessous",
"No comment" => "Pas de commentaire",
"All Versions" => "Toutes les versions",
"Edit wiki page" => "Édition page Wiki",
"Select the style used to display differences to be translated" => "Choisir le style utilisé pour afficher les différences à traduire",
"text full" => "texte plein",
"Change the style used to display differences to be translated" => "Modifier le style utilisé pour afficher les différences à traduire",
"Change diff styles" => "Changer le style du diff",
"Translate to" => "Traduire vers",
"Reproduce the changes highlighted on the left using the editor below" => "Reproduire les changements surlignés sur la gauche en utilisant l'édietur ci-dessous",
"Describe the change you made" => "Décrivez les changements que vous avez effectués",
"Edit comment: Enter some text to describe the changes you are currently making" => "Commentaire d'édition : Entrez un commentaire décrivant les changements que vous êtes en train de faire",
"Monitor this page" => "Surveiller cette page",
"Upload picture" => "Envoyer une image",
"Add another image" => "Ajouter une image",
"Categorization has been preset for this edit" => "La catégorisation a été activée pour cette modification",
"Categories will be inherited from the structure top page" => "Les catégories seront héritées de la structure supérieure",
// "Leave page and go to..." => "Leave page and go to...",
// "Wiki Preferences" => "Wiki Preferences",
// "Copyright notices" => "Copyright notices",
// "Copyright page" => "Copyright page",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Lock this page" => "Verrouiller cette page",
"Allow comments on this page" => "Autoriser les commentaires sur cette page",
// "HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "HTML tags are used to create elements of the wiki page, instead of being displayed as code",
"Try to convert HTML to wiki" => "Essayer de convertir le HTML en Wiki",
"Import page" => "Importer une page",
// "Export page" => "Export page",
// "Export all versions" => "Export all versions",
// "Attach file" => "Attach file",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
"Site default" => "Réglage par défaut du site",
"as Creator &amp; Last Editor" => "créateur &amp; dernier éditeur",
"no (disabled)" => "non (désactivé)",
"Description (used for metatags)" => "Description (utilisée pour les méta-tags)",
"My Footnotes" => "Mes notes de bas de page personnelles",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "Il n'y a aucun gabarit de sondage.",
"Please ask an administrator to create one." => "Vous devez demander à l'administrateur de les créer.",
// "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Demande de traducation",
"Send urgent translation request." => "Envoyer une demande de traduction urgente.",
// "Geolocation" => "Geolocation",
"Show page title" => "Afficher le titre de la page",
// "Explicit Namespace" => "Explicit Namespace",
// "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace" => "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace",
// "Page layout" => "Page layout",
// "Site Default" => "Site Default",
// "{\$title}" => "{\$title}",
"List Sheets" => "Liste des feuillets",
"Graph" => "Graphe",
"Export to file" => "Exporter dans un fichier",
"Autodetect" => "Détection automatique",
"Admin FAQ" => "Administrer la FAQ",
"List FAQs" => "Liste des FAQs",
"View FAQ" => "Afficher les FAQs",
"Edit this FAQ" => "Modifier cette FAQ",
"New Question" => "Nouvelle question",
"Edit FAQ question" => "Modifier les questions de la FAQ",
"Add FAQ question" => "Ajouter une question à la FAQ",
"Use a question from another FAQ" => "Utiliser une question d'une autre FAQ",
"FAQ questions" => "Questions de la FAQ",
"Suggested questions" => "Questions suggérées",
"No suggested questions" => "Aucune question suggérée",
"File Archive" => "Archive de fichiers",
"Size (width x height)" => "Dimensions (largeur x hauteur)",
"Content waiting for approval" => "Contenu en attente d'approbation",
"You are currently viewing the latest version of the page" => "Vous voyez actuellement la dernière version de la page",
"You can also view the {self_link}latest approved version{/self_link}" => "Vous pouvez aussi voir la {self_link}dernière version approuvée{/self_link}",
"You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "Vous pouvez approuver cette révision et la rendre disponible à une plus grande audience. Assurer vous de revoir toutes les modifications avant d'approuver",
"Show changes since last approved revision" => "Afficher les modifications depuis la dernière version approuvée",
"This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "Cette page n'a pas de version précédente approuvée. <strong>Tout le contenu doit être revu.</strong>",
"Approve current revision" => "Approuver la révision courante",
// "Reject current revision" => "Reject current revision",
"You are currently viewing the approved version of the page" => "Vous voyez actuellement la version approuvée de la page",
"You can also view the {self_link latest=1}latest version{/self_link}" => "Vous pouvez aussi voir la {self_link latest=1}plus récente version{/self_link}",
"View the {self_link latest=1}latest version{/self_link}" => "Voir la {self_link latest=1}dernère version{/self_link}",
"Forum Importer" => "Importateur de Forums",
"Import from a Local SQL File" => "Importer depuis un fichier SQL local",
"Forum Type" => "Type de forum",
"DB Prefix" => "Préfixe de la base de données",
"Local SQL Filename on Server (path will be stripped)" => "Nom du Fichier SQL local sur le serveur (le chemin sera strippé)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Doit être dans tikiroot/{\$tmpdir} ou tikiroot/img/wiki_up",
"Get Forum List" => "Récupérer la liste des forums",
"Verification" => "Vérification",
"File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>." => "Le fichier doit être un fichier SQL et se situer soit dans <i>\$tikiroot/temp</i> ou <i>\$tikiroot/img/wiki_up</i>.",
"File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "Le fichier n'a pas été spécifié ou n'a pas pu être trouvé dans l'un des répertoires. Veuillez placer le fichier dans l'un des répertoires et recommencez l'opération. Si le fichier est à la fois dans les deux répertoires, celui dans \$tikiroot/{\$filecheck} sera préféré.",
"Proceed" => "Poursuivre",
"Go Back" => "Retour",
"Select a Forum You Wish to Move (ONE at a time!)" => "Sélectionnez un Forum que vous voulez déplacer (UN seul à la fois !)",
"Which Forum Do You Wish to Import this Into?" => "Quel Forum voulez-vous importer dans celui-ci ?",
// "Refresh list" => "Refresh list",
"Edit queued message" => "Modifier un message en attente",
// "Make this a thread of" => "Make this a thread of",
"None, this is a thread message" => "Aucun, c'est un message de fil de discussion",
"summary" => "résumé",
"Announce" => "Annonce",
"Hot" => "Populaire",
"no feeling" => "pas de sentiment",
"frown" => "renfrogné",
"exclaim" => "exclamatif",
"idea" => "idée!",
"mad" => "furieux",
"neutral" => "neutre",
"question" => "question",
"sad" => "triste",
"happy" => "heureux",
"wink" => "clin d'oeil",
"Save and Approve" => "Enregistrer et approuver",
// "Convert to topic" => "Convert to topic",
"New Topic" => "Nouveau sujet",
"no summary" => "aucun résumé",
"No messages queued yet" => "Aucun message en attente actuellement",
"Search by name" => "Chercher par nom",
"Search in content" => "Chercher dans le contenu",
"Last Post" => "Dernier article",
// "{\$section|escape}" => "{\$section|escape}",
// "No forums found" => "No forums found",
// "Loading" => "Loading",
"Reported by" => "Signalé par",
"Perfom action with checked" => "Réaliser l'opération sur les éléments cochés",
"Un-report" => "Dé-signaler",
"Tag translation" => "Traduction des mots-clés",
// "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated" => "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated",
// "Show checkboxes" => "Show checkboxes",
"There are no tags on this page in your preferred languages" => "Aucun mot-clé dans cette page dans votre langue préférée",
"Set language" => "Définir la langue",
"Universal" => "Universel",
// "Displayed languages" => "Displayed languages",
"Friendship Network" => "Réseau des amis",
"Galleries" => "Galeries",
"Create New Gallery" => "Créer une nouvelle galerie",
// "Migrate Images to File Gallery" => "Migrate Images to File Gallery",
"Create a gallery" => "Créer une galerie",
"Edit this gallery" => "Éditer cette galerie",
"There are individual permissions set for this gallery" => "Des droits d'accès individuels ont été mis sur cette galerie",
"Gallery is visible to non-admin users?" => "Cette galerie est visible aux utilisateurs autres qu'administrateur?",
"Max Rows per page" => "Nombre maximum de rangées par page",
"Thumbnails size X" => "Taille X des vignettes",
"Thumbnails size Y" => "Taille Y des vignettes",
"Fields to show during browsing the gallery" => "Champs à afficher durant le parcours de la galerie",
"XY-Size" => "Taille-XY",
"Gallery Image" => "Galerie d'images",
"Available scales" => "Échelles disponibles",
"Global default" => "Défaut global",
"Bounding box" => "Boîte maximale",
"default scale" => "échelle par défaut",
// "Default scale" => "Default scale",
"No scales available" => "Aucune échelle disponible",
"Original image is default scale" => "L'échelle par défaut est la taille d'origine de l'image",
"Add scaled images with bounding box of square size" => "Ajouter des images redimensionnées avec la boîte englobante de taille carrée",
"Other users can upload images to this gallery" => "Les autres utilisateurs peuvent envoyer des images vers cette galerie",
"You can access the gallery using the following URL" => "Vous pouvez accéder à cette galerie par l'adresse Web suivante",
"Available Galleries" => "Galeries disponibles",
"Choose a filter" => "Choisir un filtre",
"Imgs" => "Imgs",
// "Make map" => "Make map",
"Select Graphic Type" => "Sélectionner le type de graphique",
"Pie Chart" => "Graphique circulaire",
"Multiline" => "Multi-ligne",
"Multibar" => "Multi-barre",
"Bar Stack" => "Pile des barres",
"Independant Scale" => "Échelle indépendante",
"Horizontal Scale" => "Échelle horizontale",
"Vertical Scale" => "Échelle verticale",
"Series" => "Séries",
"Edit Spreadsheet" => "Modifier la feuille de calcul",
"List Spreadsheets" => "Liste des feuilles de calcul",
"Wiki plug-in" => "Plug-in Wiki",
"Spreadsheet History" => "Historique des feuilles de calcul",
"Roll back" => "Retour en arrière",
"Toggle Full Screen" => "Basculer en plein écran",
"Date Selection" => "Sélection de date",
"Edit Date" => "Modifier la Date",
"View Spreadsheet" => "Voir la feuille de calcul",
"Clone Spreadsheet" => "Cloner la feuille de données",
// "Roll back spreadsheet" => "Roll back spreadsheet",
"Import From File" => "Importer d'un fichier",
// "File to import" => "File to import",
"Grab Wiki Tables" => "Récupérer les tables Wiki",
"Import pages from a Structured Text Dump" => "Importer les pages d'un Dump Texte Structuré",
"Name of the dump file (it has to be in dump/)" => "Nom du fichier-dump (il doit être dans dump/)",
"Overwrite existing pages if the name is the same" => "Écraser les pages existantes si le nom est le même",
// "Remove previously existing page versions" => "Remove previously existing page versions",
"excerpt" => "extrait",
"Result" => "Résultat",
"body" => "corps",
"Name of the zip file on the server" => "Nom du fichier zip sur le serveur",
"Tiki Importer" => "Importer autres Wikis",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "Si vous n'exécutez PAS une nouvelle installation Tiki, faire une sauvegarde de votre base de données avant d'utiliser cet importateur",
// "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature",
"Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Votre PHP s'exécute avec le mode sécurisé activé. Ceci pourrait causer des problèmes au processus d'importation car le mode sécurisé limite la possibilité de changer certains réglages d'exécution de PHP (comme max_execution_time). Il est recommandé d'exécuter ce script sans le mode sécurisé",
"Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)." => "Selon la taille du fichier à partir du logiciel source, le processus d'importation peut prendre un certain temps à s'exécuter. Cela pourrait être un problème en fonction de vos paramètres PHP et ceux du serveur web. Ce script tente de modifier les paramètres pertinents, mais il y a certains paramètres que le script ne peut pas changer. Donc, si vous rencontrez des problèmes avec le script, s'il vous plaît essayer d'augmenter la valeur des paramètres PHP suivants : max_input_time, max_execution_time (ce paramètre est limitée par les paramètres du serveur web, si vous exécutez Apache également modifier son paramètre Timeout), post_max_size , upload_max_filesize, memory_limit. Il est recommandé que vous exécutiez ce script sur un serveur où vous pouvez modifier les valeurs de ces paramètres (si nécessaire).",
"Select the software to import from:" => "Choisir le logiciel à partir duquel importer :",
"Select.." => "Choisir...",
"WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "AVERTISSEMENT : assurez-vous d'avoir une sauvegarde avant de lancer le script. Si vous n'avez pas de sauvegarde, c'est votre dernière chance d'annuler l'importeur en cliquant sur le bouton Annuler",
"Congratulations! You have successful imported your data to Tiki" => "Félicitations ! Vous avez importé avec succès vos données dans Tiki",
"%0 pages imported from a total of %1" => "%0 pages importées sur un total de %1",
"%0 pages imported" => "%0 pages importées",
"(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(vous pouvez voir la liste des pages wiki de votre site <a href=\"tiki-listpages.php\">ici</a>)",
"%0 posts imported" => "%0 publications importées",
"%0 tags imported" => "%0 mots-clés importés",
"%0 categories imported" => "%0 catégories importées",
// "Importer log" => "Importer log",
"Suggested .htaccess rules" => "Règles .htaccess suggérées",
"Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Installation" => "Installation",
"Tiki Icon" => "Icone Tiki",
"Tiki Project Web Site" => "Site Web du projet Tiki",
"Support Forums" => "Forums de support",
"Welcome" => "Bienvenue",
"Welcome to the <strong>Tiki %0</strong> installer." => "Bienvenue dans l'installateur de <strong>Tiki %0</strong>.",
"Use this script to install a new database or upgrade your existing database." => "Utilisez ce script pour installer une nouvelle base de données ou mettre à jour votre base de données actuelle.",
"For the latest information about this release, please read the" => "Pour les dernières informations concernant cette release, veuillez consulter les",
"Release Notes" => "notes de mise à jour",
"For complete documentation, please visit" => "Pour une documentation complète, veuillez consulter",
"For more information about Tiki, please visit" => "Pour plus d'informations concernant Tiki, veuillez consulter",
"Select your language" => "Choisissez votre langue",
// "License" => "License",
"Tiki is software distributed under the LGPL license" => "Tiki est un logiciel distribué sous licence LGPL",
"Review the System Requirements" => "Vérifier les pré-requis systèmes",
// "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements",
"This installer will perform some basic checks automatically" => "Cet installeur va effectuer quelques contrôles simples automatisés",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
"Memory" => "Mémoire",
"Tiki has not detected your PHP memory_limit" => "Tiki n'a pas pu détecter votre limite mémoire PHP (memory_limit)",
"This probably means you have no set limit (all is well)" => "Cela signifie sans doute qu'il n'y a pas de limite (tout va bien)",
"Tiki has detected your PHP memory limit at" => "Tiki a détecté que votre mémoire PHP est limitée à",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
"Allocating too little memory will cause Tiki to display blank pages" => "Allouer trop peu de mémoire va engendrer l'affichage de pages blanches dans Tiki",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
"Tiki has detected your PHP memory_limit at" => "Tiki a détecté que votre limite de mémoire PHP (memory_limit) est fixée à",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki utilise les fonctions Mail de PHP pour envoyer des messages et des notifications",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Pour tester votre configuration, Tiki va essayer de vous envoyer un email de test",
"Test email" => "Email de Test",
// "tiki@example.com" => "tiki@example.com",
"Email address to send test to" => "Adresse mail du destinataire du test",
"Copy test mail to " => "Faire une copie de l'email de test à ",
"Send Test Message" => "Envoyer un message de test",
"Tiki was able to send a test message to" => "Tiki a réussi à envoyer un message à",
"Tiki was not able to send a test message" => "Tiki n'a pas réussi à envoyer un message de test",
"Review your mail log for details" => "Vérifiez vos logs de mail pour plus de détails",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => " Vérifiez la configuration email dans <strong>php.ini</strong> file (par exemple : vérifiez que le chemin d'accès à <strong>sendmail_path</strong> est correct)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si votre serveur nécessite une authentification SMTP, une configuration additionnelle peut s'avérer nécessaire",
"Image Processing" => "Génération d'images",
"Tiki detected" => "Tiki a détecté",
"Tiki can create images" => "Tiki peut créer des images",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki n'a pas pu créer une image exemple. Merci de vérifier la configuration de votre bibliothèque GD",
"Tiki was not able to detect the GD library" => "Tiki n'a pas réussi à détecter de bibliothèque GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki utilise la bibliothèque GD pour le traitement d'images pour les galeries ou la génération de CAPTCHAS (anti-spams)",
"Set the Database Connection" => "Configuration de la connexion à la base de données",
"Tiki requires an active database connection" => "Tiki a besoin d'une connexion à une base de données existante",
// "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them" => "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them",
"Tiki cannot find a database connection" => "Tiki ne peut pas accéder à la base de données",
"This is normal for a new installation" => "Ceci est normal pour une première installation",
"Tiki found an existing database connection in your local.php file" => "Tiki a trouvé des informations de connexion à une base de données existante dans votre fichier local.php",
// "Database name: %0" => "Database name: %0",
// "Tiki found an automatic database connection for your environment" => "Tiki found an automatic database connection for your environment",
"Use Existing Connection" => "Utiliser la connexion existante",
"Modify database connection" => "Modifier la connexion à la base de données",
// "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
"Database information" => "Configuration de la base de données",
"Enter your database connection information" => "Entrez les informations pour se connecter à la base de données",
"DBMS driver" => "Pilote SGBD",
"Select the database driver to use with Tiki" => "Sélectionnez le pilote de base de données à utiliser avec Tiki",
"Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension." => "Les seuls pilotes qui sont listés ici sont ceux acceptés par votre installation PHP. Si votre pilote de base de données ne figure pas dans cette liste, essayez d'installer les bonnes extensions PHP.",
"Host name" => "Nom d'hôte",
"Enter the host name or IP for your database" => "Entrer le nom ou l'adresse IP du serveur de votre base de données",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Utiliser <strong>localhost</strong> si la base de données est sur le même serveur que celui de Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
// "Database name" => "Database name",
// "Name of the database to be used. This database will be created if it does not exist and permissions allow creation" => "Name of the database to be used. This database will be created if it does not exist and permissions allow creation",
// "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created" => "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created",
"If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "Si vous utilisez une base de données partagée avec une autre applications (non recommandé), vérifier db/tiki.sql que les tables utilisées par Tiki ne sont pas déjà utilisées",
"Database user" => "Utilisateur de la base de données",
// "Enter a database user with administrator permission for the Tiki database" => "Enter a database user with administrator permission for the Tiki database",
"User name" => "Nom de l'utilisateur",
// "Database username" => "Database username",
// "Create the above database user just for this Tiki database" => "Create the above database user just for this Tiki database",
// "Administrative database user" => "Administrative database user",
// "Enter database administrator user name and password" => "Enter database administrator user name and password",
// "This is a DB admin user which has permission to create new databases and new users" => "This is a DB admin user which has permission to create new databases and new users",
// "DB admin user name" => "DB admin user name",
// "DB admin password" => "DB admin password",
"Character set" => "Encodage des caractères",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Cette option est fortement recommandée pour les nouvelles installations. Toutefois, si vous mettez à niveau ou si vous migrez à partir d'une base de données tiki précédente, nous vous recommandons de décocher cette case",
"Always force connection to use UTF-8" => "Toujours forcer une connexion à utiliser UTF-8",
// "Install & Upgrade" => "Install & Upgrade",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "A échoué pour définir max_execution_time pour PHP. Vous pouvez rencontrer des problèmes en création/mise à jour de la base de données en utilisant l'installateur sur un système lent. Ceci peut se manifester par une page blanche",
"This install will populate (or upgrade) the database" => "Cette installation va meubler (ou mettre à niveau) la base de données",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>",
"A new install will populate the database" => "Une nouvelle installation va peupler la base de données",
"Encoding Issue" => "Problème d'encodage",
// "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>",
"Character Set Conversion" => "Conversion de Jeu de Caractères",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
"Convert database and tables to UTF-8" => "Convertir base de données et tables en UTF-8",
// "This will destroy your current database: %0" => "This will destroy your current database: %0",
"Reinstall the database" => "Réinstaller la base de données",
"Select database engine" => "Choisir le moteur de bases de données",
"MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "Réinstaller",
"Upgrade" => "Mise à jour",
"Warning: Category Permissions Will Not Be Upgraded" => "Attention : Les permisisons de catégories ne seront pas mises à jour",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to version" => "Automatically upgrade your existing database to version",
"This site has an admin account configured" => "Ce site a déjà un utilisateur admin",
"Please log in with your admin password to continue" => "Merci de vous reconnecter avec le mot de passe administrateur pour poursuivre",
"Review the Upgrade" => "Vérifier la mise à jour",
"Review the Installation" => "Vérifier l'installation",
"Upgrade complete" => "Mise à jour terminée",
"Installation complete" => "Installation terminée",
"Your database has been configured and Tiki is ready to run!" => "Votre base de données a été configurée et Tiki est prêt à fonctionner !",
"If this is your first install, your admin password is <strong>admin</strong>." => "Si ceci est votre première installation, veuillez noter que le nom d’utilisateur de l’administrateur du site est <strong>admin</strong> et que son mot de passe est aussi <strong>admin</strong>.",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application." => "Vous pouvez maintenant vous connecter à Tiki en tant qu'<strong>admin</strong> et débuter la configuration de l'application.",
"Upgrade operations executed successfully" => "Opérations de mise à jour executées avec succès",
"Installation operations executed successfully" => "Opérations d'installation executées avec succès",
"SQL queries" => "Requêtes SQL",
"Database was left unchanged" => "La base de données a été laissée inchangée",
"Operations failed" => "Opérations ayant échouées",
"Display details" => "Afficher les détails",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Durant une mise à jour, il est normal d'avoir des anomalies SQL avec des messages <strong>La table existe déjà</strong>",
"Check all errors" => "Vérifier toutes les erreurs",
"Configure General Settings" => "Configuration générale",
"Complete these fields to configure common, general settings for your site" => "Compléter ces champs pour configurer les paramètres généraux et communs pour votre site",
"The information you enter here can be changed later" => "L'information que vous saisissez ici peut être modifiée ultérieurement",
// "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings",
// "My Tiki" => "My Tiki",
"This will appear in the browser title bar" => "Ceci sera affiché dans la barre de titre du navigateur",
"Email sent by your site will use this address" => "Les courriels envoyés par votre site utiliseront cette adresse",
// "Network Proxy" => "Network Proxy",
// "Toggle section display" => "Toggle section display",
"Secure Log in" => "Authentification sécurisée",
// "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "Connexion HTTPS",
"PHP error reporting level" => "Niveau de rapport d'erreurs PHP",
"Report all errors except notices" => "Rapporter toutes les erreurs sauf les notices",
"Visible to Admin only" => "Visible par Admin seulement",
"Admin email" => "Email de l'administrateur",
// "admin@example.com" => "admin@example.com",
"This is the email address for your administrator account" => "Ceci est l'adresse email de l'administrateur du site",
// "Set up htaccess file" => "Set up htaccess file",
"Method" => "Méthode",
// "Select how to set up your htaccess file" => "Select how to set up your htaccess file",
"Upgrade fix" => "Problème de mise à jour",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will",
"Create the <em>Admins</em> group, if missing" => "Créer le groupe <em>Admins</em>, si manquant",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "Accorder le droit <em>tiki_p_admin</em> au groupe, si manquant",
"Add the administrator account to the group, if missing" => "Ajouter le compte administrateur au groupe, si manquant",
"To do so enter the name of the main admin account in the field below" => "Pour agir ainsi, entrer le nom du compte principal administrateur dans le champ ci-dessous",
// "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>" => "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>",
"Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Cocher cette case si vous avez un grand nombre de comptes désactivés après une mise à jour vers tiki4",
"List of accounts that will be enabled" => "Liste des comptes qui vont être activés",
// "Last Notes" => "Last Notes",
// "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future" => "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future",
// "Subscribe to Tiki Releases newsletter" => "Subscribe to Tiki Releases newsletter",
// "Critical & Security update" => "Critical & Security update",
// "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates" => "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates",
// "We don't share subscribed emails and we send very few of these newsletters per year" => "We don't share subscribed emails and we send very few of these newsletters per year",
// "Please use the following link and subscribe" => "Please use the following link and subscribe",
// "Tiki Releases newsletter" => "Tiki Releases newsletter",
// "First Wizards, then Control Panels with Preference Filter" => "First Wizards, then Control Panels with Preference Filter",
// "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator" => "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator",
// "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})" => "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})",
// "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install" => "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install",
// "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels" => "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels",
// "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided" => "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided",
// "Storing your uploaded files" => "Storing your uploaded files",
// "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database" => "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database",
// "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more" => "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more",
// "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other" => "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other",
// "Tiki Community" => "Tiki Community",
// "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users" => "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users",
// "Get Help with Tiki" => "Get Help with Tiki",
// "Hire a Tiki Service Provider" => "Hire a Tiki Service Provider",
// "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>" => "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>",
"Enter Your Tiki" => "Accéder à votre Tiki",
// "Ready to run" => "Ready to run",
"The installation is complete" => "L'installation est terminée",
"Your database has been configured and Tiki is ready to run" => "Votre connexion à la base de données fonctionne et Tiki est prêt à fonctionner",
".htaccess File" => "Fichier .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Nous recommandons d'activer le fichier <strong>.htaccess</strong> pour votre Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Ceci vous permettra d'utiliser SEFURLs ('Search Engine Friendly URLs' ou 'URLs plus adaptées aux moteurs de recherche') et améliore la sécurité du site",
// "Your .htaccess file has been set up (%0)" => "Your .htaccess file has been set up (%0)",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
"Enter Tiki and Lock Installer" => "Entrer dans Tiki en désactivant l'installateur",
"Recommended" => "Recommandé",
"Enter Tiki Without Locking Installer" => "Entrer dans Tiki sans désactiver l'installateur",
// "Not recommended due to security risk" => "Not recommended due to security risk",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Vous pouvez accéder normalement au site maintenant. Rapporter toute anomalie que vous pourriez rencontrer (si tel est le cas) sur les forums Tiki ou le formulaire des bogues",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Êtes-vous sûr de vouloir tenter de corriger l'encodage de votre base de données entière",
"Upgrading and running into encoding issues" => "Vous avez fait une mise à niveau et vous rencontrez des problèmes d’encodage",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Nous pouvons essayer de la réparer, mais <strong>assurez-vous d’avoir fait une sauvegarde de vos données, et de pouvoir les restaurer.</strong>",
"Previous table encoding" => "Encodage précédent de vos tables",
"Please select" => "Veuillez choisir",
// "Click to fix double encoding (dangerous)" => "Click to fix double encoding (dangerous)",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
"MultiTiki Setup" => "Configuration MultiTiki",
"Default Installation" => "Installation par défaut",
"DB OK" => "BDD OK",
"No DB" => "Pas de BDD",
"Adding a new host" => "Ajouter un nouveau serveur hôte",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Pour ajouter un nouveau serveur virtuel, exécutez le script setup.sh avec le nom de domaine du nouveau site comme dernier paramètre",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Êtes-vous en train de mettre à jour un site Tiki existant",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Allez directement à l'étape <strong>Installer/Mettre à jour</strong>",
"Install/Upgrade" => "Installer/Mettre à jour",
"Powered by" => "Basé sur",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Vider l'antémémoire et la reconstruire",
"configure rules" => "configurer les règles",
"Invitation" => "Invitation",
"Invitations list" => "Liste des invitations",
"The mail has been sent to: " => "Le courriel a été envoyé à : ",
"You are about to send an invitation to theses people, please confirm" => "Vous êtes sur le point d'envoyer une invitation à ces personnes, merci de confirmer",
"Fill this box with the list of emails you want to invite " => "Compléter cette zone avec la liste des adresses courriel que vous voulez inviter",
"Format of the list above " => "Format de la liste ci-dessus",
"CSV Style: One line per invitation, with the format: lastname,firstname,email" => "Style CSV : Une ligne par invitation, avec le format : nom, prénom,email",
"Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Tout ce qui apparaît dans le texte comme un courriel sera détecté et utilisé (dans ce cas, {literal}{firstname} et {lastname}{/literal} seront ignorés dans le contenu du courriel)",
// "Type here the email subject you'll want to be sent to them " => "Type here the email subject you'll want to be sent to them ",
// "Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
"Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special " => "Choisir un groupe ou plus où vous voulez que les inscriptions aillent. N'en choisir aucun si vous ne souhaitez rien de spécial",
"Invoices" => "Factures",
"New Invoice" => "Nouvelle facture",
"Clients" => "Clients",
"New Client" => "Nouveau client",
// "Invoice Reports" => "Invoice Reports",
"Add more media" => "Ajouter plus de médias",
// "Change Details" => "Change Details",
"Video Title" => "Titre de la vidéo",
"Editor" => "Éditeur",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
"No action specified" => "Aucune action specifiée",
// "This file is not expected to be called directly" => "This file is not expected to be called directly",
"Last Changes" => "Dernières modifications",
"Last 2 days" => "2 derniers jours",
"Last 3 days" => "3 derniers jours",
"Last 5 days" => "5 derniers jours",
"Last week" => "Dernière semaine",
"Last 2 weeks" => "2 dernières semaines",
"Last month" => "Dernier mois",
"Search by Date" => "Recherche par date",
"Found" => "Trouvé",
"LastChanges" => "DerniersChangements",
"Ip" => "IP",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
"v" => "v",
"Diff" => "Différences",
"Pages like" => "Pages similaires à",
"New Article" => "Nouvel article",
// "New Submission" => "New Submission",
"View Submissions" => "Liste des soumissions",
// "Expiry Date" => "Expiry Date",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
// "Select Duplicates" => "Select Duplicates",
// "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "Créer une bannière",
"Use Dates?" => "Utiliser des dates ?",
"Max Impressions" => "Max. d'impressions",
"Impressions" => "Impressions",
"Max Clicks" => "Max. de clics",
"Clicks" => "Clics",
// "List Posts" => "List Posts",
"The cache is used by" => "L'antémémoire est utilisée par",
// "{\$headerName}" => "{\$headerName}",
"Approval" => "Approbation",
// "Delete comment" => "Delete comment",
"(no title)" => "(pas de titre)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "Approuvé",
"More Information" => "Plus d'informations",
// "Delete selected comments" => "Delete selected comments",
// "Delete and ban selected comments" => "Delete and ban selected comments",
// "Delete and ban" => "Delete and ban",
"Dynamic Content System" => "Système de contenu dynamique",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "Vous pouvez aussi utiliser {literal}{content label=x}{/literal}, où x est l'étiquette du bloc de contenu",
"Available content blocks" => "Blocs de contenu disponibles",
"Current Value" => "Valeur courante",
"Current ver" => "Version en cours",
"Next ver" => "Prochaine version",
"Future vers" => "Versions futures",
"Program" => "Programmer",
"Create/Edit content block" => "Créer/Editer le bloc de contenu",
"Edit content block" => "Éditer le bloc de contenu",
"Create content block" => "Créer un bloc de contenu",
"Available FAQs" => "FAQs disponibles",
// "Questions / Suggested" => "Questions / Suggested",
"Edit/Create" => "Modifier/Ajouter",
"Create new FAQ" => "Créer une nouvelle FAQ",
"Create New FAQ" => "Créer nouvelle FAQ",
"Users can suggest questions" => "Les utilisateurs peuvent suggérer des questions",
"Create a File Gallery" => "Créer une galerie de fichiers",
// "{\$name}" => "{\$name}",
// "Finder" => "Finder",
"RSS feed" => "Syndication RSS",
// "Hide file information from list view" => "Hide file information from list view",
// "Hide list view information" => "Hide list view information",
// "Show file information from list view" => "Show file information from list view",
// "Show list view information" => "Show list view information",
// "Create Diagram" => "Create Diagram",
// "Batch" => "Batch",
"SlideShow" => "Diaporama",
// "Create H5P" => "Create H5P",
"Be careful to set the right permissions on the files you link to" => "Attention, il faut définir les droits suffisants sur le fichier lié pour qu'il soit lisible",
"Keep gallery window open" => "Maintenir la fenêtre de la galerie ouverte",
"optional" => "facultatif",
"Modifications" => "Modifications",
"Property <b>{\$fgp_name}</b> Changed" => "Propriété <b>{\$fgp_name}</b> Modifiée",
// "Search for text within files in all galleries" => "Search for text within files in all galleries",
"Search by identifier" => "Chercher par identifiant",
"Search for the file with this number, in all galleries" => "Chercher le fichier avec ce numéro, dans toutes les galeries",
// "Maximum width" => "Maximum width",
"You can access the file gallery using the following URL" => "Vous pouvez accéder à cette galerie de fichiers par cette adresse Web",
"Gallery Images" => "Galerie d'images",
"Inviter" => "Inviter",
"Only successful invitations" => "Seulement les invitations réussies",
"Only pending invitations" => "Seulement les invitations en attente",
"Number of invitations" => "Nombre d' invitations",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
"Client Name" => "Nom du client",
// "Remix Entries" => "Remix Entries",
// "Browse Media" => "Browse Media",
// "Browse Remixes" => "Browse Remixes",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Media Id" => "Media Id",
"Wiki plugin code" => "Code du plugiciel Wiki",
"No entries" => "Aucune entrée",
// "No media entries found" => "No media entries found",
"to upload" => "à envoyer",
"Modified By" => "Modifié par",
// "No mix entries found" => "No mix entries found",
"Object Permissions List" => "Liste des droits des objets",
// "Object Permissions" => "Object Permissions",
// "Object permissions" => "Object permissions",
// "Category permissions" => "Category permissions",
// "Perform action with selected permissions" => "Perform action with selected permissions",
// "Assign to this group" => "Assign to this group",
// "Only default global permissions are being used" => "Only default global permissions are being used",
"Reason" => "Raison",
// "No object permissions apply" => "No object permissions apply",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
// "No category permissions apply" => "No category permissions apply",
"Blog: %0" => "Blogue : %0",
"New Blog Post" => "Publier",
"Post Title" => "Titre du message",
"Blog Title" => "Titre du blogue",
// "(bytes)" => "(bytes)",
"Delete Expired Submissions" => "Supprimer les soumissions périmées",
// "Deletes expired submissions 1000 at a time to avoid timeouts" => "Deletes expired submissions 1000 at a time to avoid timeouts",
"Survey stats" => "Statistiques sur les enquêtes",
// "Take survey" => "Take survey",
// "Import Structure" => "Import Structure",
// "Import From Profile/YAML" => "Import From Profile/YAML",
// "Manage Tabular Formats" => "Manage Tabular Formats",
// "Clone remote" => "Clone remote",
"Items" => "Éléments",
// "{\$tracker.name|escape}" => "{\$tracker.name|escape}",
"Do you really remove this tracker" => "Voulez-vous réellement supprimer ce formulaire",
"Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Voulez-vous réellement effacer toutes les fiches de ce formulaire ? (N.B. : Il n'y pas d'annulation et aucune notification ne sera envoyée)",
"users registered" => "utilisateurs enregistrés",
"like" => "comme",
"Distance (km)" => "Distance (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Liste des pages Wiki",
"Page aliases found" => "Alias de page trouvés",
"Create a Wiki Page" => "Créer une page Wiki",
"Insert name of the page you wish to create" => "Saisir le nom de la page que vous souhaitez créer",
// "Create page within %0" => "Create page within %0",
"Page creator" => "Créateur",
"Last author" => "Dernier auteur",
"Last version" => "Dernière version",
"Status of the page" => "Statut de la page",
"Links to other items in page" => "Liens vers d'autres éléments dans la page",
"Links to this page in other pages" => "Liens vers cette page dans d'autres pages",
"Backl" => "Backl",
"Page size" => "Taille de page",
"Lang" => "Langue",
// "No page" => "No page",
"No pages found with" => "Aucune page trouvée avec",
// "Download PDF" => "Download PDF",
"Download zipped file" => "Télécharger le fichier compressé",
"Add page name as page header" => "Ajouter un nom de page comme en-tête de page",
"Open client window" => "Ouvrir une console client",
"Generate HTML" => "Générer en HTML",
"Transcripts" => "Rapports",
"Online operators" => "Opérateur connecté",
"Accepted requests" => "Demandes acceptées",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "rapports",
"offline" => "non connecté",
"Offline operators" => "Opérateurs non connectés",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Ajouter un opérateur au système",
"Operators must be tiki users" => "Les opérateurs doivent être des utilisateurs Tiki",
"Set as Operator" => "Le mettre en opérateur",
"Chat started" => "Discussion commencée",
"Live support:User window" => "Assistance en ligne : Fenêtre utilisateur",
"Request live support" => "Demande d'assistance en ligne",
"Request support" => "Demande d'assistance",
"Your request is being processed" => "Votre demande a été prise en compte",
"cancel request and exit" => "supprimer la demande et sortir",
"cancel request and leave a message" => "supprimer la demande et laisser un message",
"Live support:Console" => "Assistance en ligne : Console",
// "{\$status}" => "{\$status}",
"be online" => "se connecter",
"be offline" => "se déconnecter",
// "You are not an operator" => "You are not an operator",
"Support requests" => "Demandes d'assistance",
"Requested" => "Demandé",
"Accept" => "Accepter",
"Join" => "Joindre",
// "No support requests" => "No support requests",
"Support chat transcripts" => "Rapports des discussions d'assistance",
// "Back to admin" => "Back to admin",
"operator" => "opérateur",
"started" => "commencé",
"reason" => "raison",
// "msgs" => "msgs",
"Transcript" => "Rapport",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Pour des raisons de sécurité, vous devez périodiquement revalider votre adresse électronique pour pouvoir accéder au site.",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "Un courriel de validation vous a été envoyé. SVP ouvrez le et suivez les instructions pour pouvoir réaccéder au site.",
"Thank you" => "Merci",
"Mail-in feature" => "Fonctionnalité mail-in",
"Click here to go to mailin admin" => "Cliquer ici pour aller à l'administration des mails entrants",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Dépendance manquante. Obtenez <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> et téléchargez-le dans 'files/'",
"Mini Calendar" => "Mon calendrier",
// "Prefs" => "Prefs",
"Daily" => "Journalier",
"Weekly" => "Hebdomadaire",
"Remove old events" => "Supprimer les vieux évènements",
"h" => "h",
"mins" => "mins",
"Edit Event" => "Éditer l'évènement",
"Mini Calendar: Preferences" => "Mon Calendrier : Préférences",
"Calendar Interval in daily view" => "Intervalle de temps dans la vue journalière",
"Start hour for days" => "Première heure vue du jour",
"End hour for days" => "Dernière heure des journées",
"Reminders" => "Rappels",
"no reminders" => "Aucun rappel",
"min" => "min",
"Or enter path or URL" => "Ou donner un chemin d'accès ou une adresse Web",
"Add Topic" => "Ajouter le sujet",
"Tiki Mods" => "Mods Tiki",
// "Tiki \"Mods\" are obsolete as of Tiki 19" => "Tiki \"Mods\" are obsolete as of Tiki 19",
// "Tiki now uses \"Packages\" instead" => "Tiki now uses \"Packages\" instead",
// "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>" => "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>",
"y" => "oui",
"User Galleries" => "Mes galeries",
"My Articles" => "Mes articles",
"User Articles" => "Articles de l'utilisateur",
"My User Items" => "Mes fiches",
"User Items" => "Fiches utilisateur",
"Unread Messages" => "Messages non lus",
"User forum topics" => "Sujet de l'utilisateur dans le forum",
// "Forum topic" => "Forum topic",
"Date of post" => "Date de la publication",
"User forum replies" => "Réponses de l'utilisateur dans le forum",
"User Blogs" => "Mes blogues",
// "My blog Posts" => "My blog Posts",
// "User Blog Posts" => "User Blog Posts",
"To display the objects you created or contributed to" => "Pour afficher les objets auxquels vous participez",
// "My Items" => "My Items",
"My Info" => "Mes infos",
"My Watches" => "Mes notifications",
"Contacts Preferences" => "Préférences des contacts",
"Notepad" => "Bloc-note",
"MyFiles" => "Mes Fichiers",
"Sent editions" => "Lettres d'informations envoyées",
"Admin Newsletters" => "Administrer les lettres d'informations",
"HTML version" => "Version HTML",
"Text version" => "Version texte",
"The newsletter was sent to {\$sent} email addresses" => "Cette lettre d'informations a été envoyée à {\$sent} adresses électroniques",
"Delete errors" => "Effacer les erreurs",
"Not sent" => "Non envoyé",
"Subscribe to Newsletter" => "S'abonner à une lettre d'informations",
"Subscribe to this Newsletter" => "S'abonner à cette lettre d'informations",
"Available Newsletters" => "Lettres d'informations disponibles",
"Write a note" => "Écrire une note",
"quota" => "quota",
"No notes yet" => "Aucune note pour l'instant",
"Merge selected notes into" => "fusionner les notes sélectionnées dans",
"Reading note" => "Note lue",
"List notes" => "Liste des notes",
"Write note" => "Écrire une note",
"Wiki Create" => "Créer la page Wiki",
"Wiki Overwrite" => "écraser la page Wiki",
"Object Watches" => "Surveillances d'objets",
"Groups watching" => "Groupes surveillants",
"Changes to groups watching" => "Modifications des surveillances de groupes",
"These changes to group watches" => "Ces changements de surveillances de groupe",
"were made to these descendants" => "ont été fait(e)s à ces descendants",
"This Category" => "Cette catégorie",
"All Descendants" => "Tous les descendants",
"Assign global permissions" => "Attribution des permissions globales",
"Assign permissions to " => "Attribuer des droits d'accès à ",
"Edit Permissions" => "Éditer les permissions",
"Currently editing Global permissions" => "Édition des permissions globales",
"This object's direct permissions override any global permissions or category permissions affecting this object" => "Les droits définis directement pour cet objet surclassent tout droit global ou de catégorie affectant ce même objet",
"This category's direct permissions override any global permissions affecting objects in it" => "Les droits définis pour cette catégorie surclassent tout droit global affecté aux objets lui appertenant",
"To edit global permissions" => "Pour attribuer les droits d'accès globaux",
"No permissions yet applied to this object but category permissions affect this object and are displayed below" => "Aucune permission n'est appliquée à l'objet, mais les permissions des catégories l'affectant sont affichées ci-dessous",
"To edit category permissions" => "Pour modifier les permissions de catégorie",
// "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below" => "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below",
// "To edit parent object's permissions" => "To edit parent object's permissions",
"No direct permissions yet applied to this object. Global permissions apply." => "Il n'y a pas de permissions spécifiques définies pour cet objet. Les permissions globales sont appliquées.",
"Currently inherited permissions displayed" => "Les permissions héritées sont actuellement affichées",
"Show permissions for disabled features" => "Afficher les permissions pour les fonctionnalités désactivées",
"Assign permissions to this category" => "Assigner des droits à cette catégorie",
"Assign permissions to this object" => "Attribuer de nouveaux droits d'accès à cet objet",
"Delete category permissions" => "Supprimer les permissions spécifiques à cette catégorie",
"Delete object permissions" => "Supprimer les permissions spécifiques à cet objet",
// "Reset Perms" => "Reset Perms",
"This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "Ceci va supprimer tous ces réglages et les droits d'accès vont être réinitialisés pour hériter des droits de catégories définis, ou les droits définis au niveau global su site",
"This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "Ceci va supprimer tous ces réglages et les droits d'accès vont être réinitialisés pour hériter des droits définis au niveau global su site",
// "Permissions Clipboard" => "Permissions Clipboard",
"Copy the permissions set here" => "Copier le jeu de permissions ici",
"Paste" => "Coller",
"Paste copied permissions from " => "Coller les permissions copiées à partir de ",
"Assign or remove permissions on <em>all</em> child categories" => "Assigner ou retirer des permissions sur <em>toutes</em> les catégories enfants",
"Are you sure you want to affect all child categories?\\nThere is no undo" => "Êtes-vous sûr(e) de vouloir affecter toutes les catégories enfants ?\\nPas d'annulation possible",
"Assign or remove permissions on all pages of the sub-structure" => "Assigner ou retirer des permissions sur toutes les pages de la sous-structure",
"Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Êtes-vous sûr(e) de vouloir affecter toutes les pages dans cette sous-structure ?\\nPas d'annulation possible",
"You must select at least one feature" => "Vous devez choisir au moins une fonctionnalité",
"View Differences" => "Voir les différences",
"Permissions added" => "Permissions ajoutées",
"Permissions removed" => "Permissions retirées",
"Select groups" => "Sélectionner un/plusieurs groupes",
// "Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "Ces groupes ne sont pas ceux qui ont des droits sur l'objet. Ce sont les groupes que vous pouvez voir dans les colonnes du premier onglet",
"Select only groups that have a perm with the object" => "Choisissez seulement les groupes qui ont droit d'accès avec cet objet",
"Group name" => "Groupe",
"Select features" => "Sélectionner une/plusieurs fonctionnalités",
// "Some of your features have been automatically hidden.<br> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br> Select the features below to assign permissions for",
"Feature name" => "Nom de la Fonctionnalité",
"Quick Permissions" => "Permissions rapides",
"Assign Quick-Permissions to this object" => "Attribuer des permissions rapides pour cet objet",
// "Individual permissions are currently assigned (See tab Assign Permissions)" => "Individual permissions are currently assigned (See tab Assign Permissions)",
"<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Les permissions rapides</em> doivent être considérées comme une fonctionnalité expérimentale",
"Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably." => "Bien que les autorisations seront fixées comme prévu en utilisant ce formulaire, il ne montrent pas nécessairement les permissions en cours de manière fiable.",
"There is also no undo - <strong>Use with care!</strong>" => "Ici aussi, pas de retour en arrière possible - <strong>Utiliser avec précaution !</strong>",
"Your OpenID identity is valid" => "Votre compte OpenID est correct",
"Your identity gives you access to multiple user accounts." => "Votre identité vous donne accès à plusieurs comptes utilisateur.",
"Select account" => "Choisir un compte",
"Orphan Pages" => "Pages orphelines",
"Browser not supported" => "Navigateur non supporté",
"Contributions by author" => "Contributions par auteurs",
"Similar" => "Similaire",
"Make Structure" => "Créer une structure",
"Discuss" => "Discussion",
"Bookmark" => "Signet",
"View latest version before editing" => "Voir la dernière version avant de modifier",
"Contributions to" => "Contributions à",
"current version" => "version courante",
"Words" => "Mots",
"Whitespaces" => "Espaces",
"Characters" => "Caractères",
"Printable characters" => "Caractères imprimables",
"Page changes" => "Changements dans la page",
"Original wiki text" => "Texte Wiki original",
"Parsed Text (HTML)" => "Text analysé (HTML)",
"Output text only (No HTML tags)" => "Sortie texte seulement (Pas de balises HTML)",
"Show statistics" => "Affiche les statistiques",
"Visualize page changes" => "Affiche les changements de pages",
// "Show popups" => "Show popups",
"Escape HTML / Wiki syntax in page changes" => "Echapper HTML / syntaxe Wiki dans les modifications de pages",
"Show contributions" => "Montrer les contributions",
// "Collapse Into Edit Sessions" => "Collapse Into Edit Sessions",
"Show All Versions" => "Montrer toutes les versions",
"Preview of version" => "Aperçu de cette version",
"(current)" => "(courant)",
"Roll back to this version" => "Revenir à cette version",
"Content Approval" => "Approbation du Contenu",
"This revision is currently marked as approved" => "Cette révision est actuellement marquée comme approuvée",
"Remove Approval" => "Retirer l'approbation",
"This revision has not been approved" => "Cette révision n'a pas été approuvée",
"Approve Revision" => "Approuver la Version",
// "History view" => "History view",
// "This revision may not be the latest approved revision" => "This revision may not be the latest approved revision",
// "This revision has been rejected" => "This revision has been rejected",
"Source of version" => "Source de la version",
"Update Translation" => "Mettre à jour la traduction",
"Hide translation history" => "Cacher l'historique des traductions",
"Show translation history" => "Montrer l'historique des traductions",
"Enable pagination" => "Activer la pagination",
// "rows per page" => "rows per page",
// "HTML allowed" => "HTML allowed",
// "HTML syntax is allowed either by page setting or use of the WYSIWIG editor" => "HTML syntax is allowed either by page setting or use of the WYSIWIG editor",
// "from %0" => "from %0",
"approved" => "approuvé",
"Updated from" => "Mis à jour par",
"Used to update" => "Utilisé pour mettre à jour",
// "rejected" => "rejected",
// "Difference" => "Difference",
"Older Version" => "Version plus ancienne",
// "Israel Post" => "Israel Post",
// "Order ID" => "Order ID",
// "Payment authorized (not captured)" => "Payment authorized (not captured)",
// "Payment authorized (captured)" => "Payment authorized (captured)",
// "Unknown state" => "Unknown state",
// "Date Paid" => "Date Paid",
"Payer" => "Payeur",
// "Payer email from %0" => "Payer email from %0",
// "View payment info" => "View payment info",
"Cancel this payment request" => "Annuler cette requête de paiement",
"View payment request" => "Voir la demande de paiement",
"Paypal" => "Paypal",
"Transaction ID" => "ID de la Transaction",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "Payment Request" => "Payment Request",
"{\$wp_member_title}" => "{\$wp_member_title}",
// "For each user: " => "For each user: ",
// "per full period" => "per full period",
// "applicable prorated pricing provided" => "applicable prorated pricing provided",
// "free periods provided" => "free periods provided",
// "full free" => "full free",
// "prorated free" => "prorated free",
// "Payment Status" => "Payment Status",
// "{\$payment_info.state|capitalize|escape}" => "{\$payment_info.state|capitalize|escape}",
// "Capture Payment" => "Capture Payment",
"Paid amount" => "Montant payé",
"Initial amount" => "Montant initial",
"Amount remaining" => "Montant restant",
// "Payment request initiated" => "Payment request initiated",
// "Payment request due" => "Payment request due",
// "Pay with PayPal" => "Pay with PayPal",
"Pay with Paypal" => "Payer avec Paypal",
// "Proceed to Israel Post" => "Proceed to Israel Post",
// "Pay With Cclite" => "Pay With Cclite",
"Refresh page" => "Rafraichir la page",
"Payment info" => "Info de paiement",
// "Trade with Cclite" => "Trade with Cclite",
"Payment problem" => "Problème de paiement",
// "Pay With Tiki Credits" => "Pay With Tiki Credits",
"Pay with Tiki User Credits" => "Payer avec les crédits utilisateur Tiki",
"Credit type" => "Type de crédit",
"Credits left" => "Crédits restants",
"Amount to pay" => "Montant à payer",
"Pay using" => "Payer en utilisant",
// "Payment Details" => "Payment Details",
// "Enter a Manual Payment" => "Enter a Manual Payment",
"Enter payment" => "Entrer le paiement",
// "using" => "using",
"Payment information" => "Information de paiement",
// "No outstanding payments found" => "No outstanding payments found",
// "No paid payments found" => "No paid payments found",
// "<em>No cancelled payments found</em>" => "<em>No cancelled payments found</em>",
"Request" => "Requête",
// "Payable within" => "Payable within",
"Pick your profile picture" => "Choisissez votre avatar",
"Your current profile picture" => "Votre avatar actuel",
// "Full size" => "Full size",
"no profile picture" => "aucun avatar",
// "Pick user profile picture from the library" => "Pick user profile picture from the library",
"Pick user profile picture" => "Choisissez un avatar utilisateur",
"Hide all" => "Masquer tout",
"icons" => "icônes",
"Show all" => "Montrer tout",
"random" => "au hasard",
"Upload your own profile picture" => "Envoyer votre avatar",
// "Select your profile picture" => "Select your profile picture",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Fichier (seulement des images en .gif, .jpg et .png avec une taille approximative de 45px × 45px)",
"File (only .gif, .jpg and .png images)" => "Fichier (seulement  images .gif, .jpg et .png)",
"Plugin execution was denied" => "L'exécution du plugiciel a été refusée",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Après validation des arguments par un éditeur, l'exécution de ce plugiciel a été refusée. Ce plugiciel sera éventuellement retiré ou corrigé",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "Ce plugiciel a été ajouté/modifié récemment. Son exécution ne sera pas possible avant que l'éditeur de site ne valide ces paramètres",
"You are allowed to" => "Vous êtes autorisé à",
"View arguments" => "Voir les arguments",
"Execute the plugin in preview mode (may be dangerous)" => "Exécuter le plugiciel en mode prévisualisation (peut être risqué)",
"Approve the plugin for public execution" => "Autoriser le plugiciel pour une exécution publique",
"View Details" => "Voir les détails",
"This plugin does not contain any arguments" => "Ce plugiciel ne contient aucun argument",
"This plugin's body is empty" => "Le corps de ce plugiciel est vide",
// "Experiment with plugin LIST" => "Experiment with plugin LIST",
// "Test Plugin LIST" => "Test Plugin LIST",
"For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "Pour la sécurité, accordez le droit <strong>tiki_p_plugin_approve</strong> seulement à des groupes d'utilisateurs de confiance",
// "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins",
"This page lists the plugins that require validation, the first time they are encountered" => "Cette page liste les plugiciels qui requièrent une validation, la première fois qu'ils sont rencontrés",
"Each plugin contains a unique <em>signature</em> that is preserved" => "Chaque plugiciel contient une <em>signature</em> unique qui est préservée",
"When you upgrade from an old version, you may need to reparse all the pages" => "Lorsque vous mettez à jour depuis une ancienne version, vous devriez avoir besoin de ré-analyser toutes les pages",
"If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "Si un plugiciel n'est plus actuellement utilisé (par exemple, il a été retiré d'une page wiki), utilisez <strong>Nettoyer</strong> (Clear) pour le retirer de cette liste",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
"Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Les plugiciels peuvent être individuellement prévisualisés, approuvés ou rejetés à partir de l'emplacement particulier qui les contient",
"For security, you should review each plugin to ensure it is safe to approve" => "Par sécurité, vous devriez revoir chaque plugiciel pour vous assurer qu'il est sans risque de l'approuver",
"Added By" => "Ajouté par",
// "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>" => "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>",
// "View this page" => "View this page",
"Approve all pending plugins" => "Approuver tous les plugiciels en attente",
"Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Utiliser cette fonctionnalité <strong>seulement</strong> si vous avez vérifié que tous les plugiciels en attente sont sûrs",
"Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Utiliser cette fonctionnalité <strong>seulement</strong> si vous avez vérifié que tous les plugiciels en attente sont sûrs",
"No plugins pending approval" => "Pas de plugiciel en attente d'approbation",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Voir les résultats",
// "Sorry" => "Sorry",
"Other Polls" => "Autres sondages",
"Poll Results" => "Résultats des sondages",
// "All Polls" => "All Polls",
// "Top-Voted Polls" => "Top-Voted Polls",
"Edit Poll" => "Modifier le sondage",
// "Find the poll" => "Find the poll",
// "{\$what}" => "{\$what}",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Show results in this range" => "Show results in this range",
// "Show all results with no time span consideration" => "Show all results with no time span consideration",
// "Show all results with time span consideration" => "Show all results with time span consideration",
// "Show all results" => "Show all results",
// "Find results" => "Find results",
// "Show detailed results of this poll" => "Show detailed results of this poll",
"List Votes" => "Liste des votes",
// "Preference translation" => "Preference translation",
// "Popup preview" => "Popup preview",
"Close preview" => "Fermer la prévisualisation",
// "Permalink" => "Permalink",
"The original document is available at" => "Le document d'origine est disponible à",
"Print multiple pages" => "Imprimer des pages multiples",
"Selected Structures" => "Structures Sélectionnées",
"Add Structure" => "Ajouter une structure",
"No structures" => "Aucune structure",
"Available Pages" => "Pages disponibles",
"No pages" => "Aucune page",
"All pages selected" => "Toutes les pages sélectionnées",
"Add Page" => "Ajouter des pages",
"Remove Page" => "Effacer la page",
"Selected Pages" => "Pages sélectionnées",
"No pages selected." => "Aucune page n'a été sélectionnée.",
"Add Pages from Structures" => "Ajouter les pages des structures",
"Edit quiz" => "Modifier un QCM",
"Current Version" => "Version courante",
"General Options" => "Options générales",
"Publication Date" => "Date de publication",
"at " => "à ",
"Use " => "Utiliser",
"randomly selected questions." => "questions choisies au hasard.",
"Test-time Options" => "Options sur la période de test",
"Shuffle questions" => "Mélanger les questions",
"Shuffle answers" => "Mélanger les réponses",
"Limit questions displayed per page to " => "Limiter les questions affichées par page à ",
// "question(s)" => "question(s)",
"Impose a time limit of " => "Imposer un temps limite de ",
"Allow students to store partial results and return to quiz." => "Permettre aux étudiants de sauvegarder des réponses partielles et de revenir au QCM.",
"Allow students to retake this quiz " => "Permettre aux étudiants de repasser ce QCM",
"Grading and Feedback" => "Corrections et commentaires",
"Grading method " => "Méthode de correction ",
"Show students their score " => "Montrer aux étudiants leur score",
// "Show students the correct answers" => "Show students the correct answers",
"Publish statistics " => "Publier les statistiques ",
"Extra Options" => "Options supplémentaires",
"Solicit additional questions from students" => "Solliciter des questions supplémentaires aux étudiants",
"Link quiz to forum named: " => "Lié le QCM au forum de nom : ",
"Prologue" => "Prologue",
"Epilogue" => "Epilogue",
"Quiz result stats" => "Statistiques sur les résultats de QCM",
"User answers" => "Réponses de l'utilisateur",
"Stats for quizzes" => "Statistiques sur les QCMs",
"taken" => "Réponses",
"Av score" => "Score moyen",
"Av time" => "Temps moyen",
"Stats for quiz" => "Statistiques sur les QCMs",
"Clear Stats" => "Effacer les statistiques",
"time taken" => "temps utilisé",
// "Pass/Fail" => "Pass/Fail",
"Passed" => "Réussi",
"Stats for this quiz Questions " => "Statistiques sur les questions de ce QCM",
"Top 10" => "10 premiers",
"Top 20" => "20 premiers",
"Top 50" => "50 premiers",
"Top 100" => "100 premiers",
"Rank" => "Rang",
"Not Published" => "Non publié",
"This article is currently unpublished and visible only to editors." => "Cet article n'est actuellement pas publié et est seulement visible par les éditeurs",
"Received articles" => "Articles reçus",
"Topic image" => "image du sujet",
"Edit received article" => "Modifier l'article reçu",
"Image x size" => "Image x pixel",
"Image y size" => "Image y pixel",
"Image name" => "Nom de l'image",
"Publishing date" => "Date de publication",
"Accept Article" => "Accepter l'article",
"Received Pages" => "Pages reçues",
"Edit Received Page" => "Éditer les pages reçues",
"The highlight pages already exist." => "Les pages surlignées existent déjà.",
"Please, change the name if you want the page to be uploaded." => "Veuillez changer le nom si vous désirez pouvoir charger la page.",
"Received Structures" => "Structures reçues",
// "Prefix the checked: " => "Prefix the checked: ",
// " Postfix the checked: " => " Postfix the checked: ",
// "References" => "References",
// "Add a new library reference" => "Add a new library reference",
// "Edit reference settings" => "Edit reference settings",
// "Reference usage" => "Reference usage",
// "Delete reference" => "Delete reference",
// "Edit reference" => "Edit reference",
// "If you change the value of Biblio Code, you might loose the link between references" => "If you change the value of Biblio Code, you might loose the link between references",
// "Pages using reference %0" => "Pages using reference %0",
"Referer stats" => "Statistiques des origines",
"Register as a new user" => "S'inscrire comme nouvel utilisateur",
"Tiki site registered" => "Site Tiki enregistré",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Le site suivant a été ajouté, la validation de l'administrateur est peut être nécessaire",
"You don't have permission to use this feature." => "Vous n'avez pas le droit d'utiliser cette fonctionnalité.",
"Please register." => "Enregistrez-vous.",
"Register this site at Tiki.org" => "Enregistrer ce site sur Tiki.org",
"Read this first!" => "Lisez ceci d'abord!",
"On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "Sur cette page, vous pouvez faire connaître votre site auprès de Tiki.org. Il sera affiché là dans une liste de sites tiki connus",
"Registering is voluntary." => "L'inscription est libre.",
"Registering does not give you any benefits except one more link to your site." => "L'inscription n'apporte rien de plus qu'un lien vers votre site.",
"You don't get any emails, we don't sell the data about your site." => "Vous ne recevrez pas d'emails. Nous ne vendons pas vos informations.",
"Registering is just for us to get an overview of Tiki's usage." => "L'inscription nous sert à avoir une idée de l'utilisation de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si votre site est privé ou sur un intranet, ne l'inscrivez pas!",
"tiki.org" => "tiki.org",
"Information about your site" => "Information sur votre site",
"Enter your username or email." => "Entrer votre compte ou adresse email.",
"Enter your email" => "Entrer votre adresse mail",
"Request Password Reset" => "Demande de réinitialisation de mot de passe",
"Rename page" => "Renommer la page",
// "Redirect original page" => "Redirect original page",
// "301 Redirect - \\\"moved permanently\\\" HTTP response status code" => "301 Redirect - \\\"moved permanently\\\" HTTP response status code",
// "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)" => "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)",
"Roll back page %0 to version %1" => "Retourner la page %0 à la version %1",
// "Describe the reason for roll back" => "Describe the reason for roll back",
// "Enter some text to describe the reason for rolling back" => "Enter some text to describe the reason for rolling back",
"This feature currently searches and replaces within wiki pages only" => "Cette fonction permet de rechercher et remplacer dans les pages wiki seulement pour le moment",
"Case sensitive:" => "Sensible à la casse :",
"Replace:" => "Remplacer :",
"Max number of pages at a time:" => "Nombre maximum de pages à la fois :",
"Number of surrounding chars to preview:" => "Nombre de caractères environnants à prévisualiser :",
"Replace selected" => "Remplacer la sélection",
"Searched" => "Recherché",
// "Search Query" => "Search Query",
"Search in" => "Rechercher dans",
"Date Search" => "Recherche par date",
"All dates" => "Toutes les dates",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "Évènements du calendrier",
"{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}\"" => "{\$where_label|escape}\"",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Recherche simple",
"No pages matched the search criteria" => "Aucune page ne correspond au(x) critère(s) de recherche",
"You can also send newsletters using an external client" => "Vous pouvez aussui envoyer des courriels en utilisant un client externe",
"This newsletter will be sent to {\$subscribers} email addresses." => "Cette lettre d'informations va être envoyée à {\$subscribers} adresses électroniques.",
// "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds" => "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds",
"Reply to" => "Répondre à",
// "Send from" => "Send from",
"Recipients" => "Destinataire(s)",
"Validated" => "Validé",
"Is user" => "Est utilisateur",
"Sending Newsletter" => "Envoi de la lettre de nouvelles",
// "sending to {\$subscribers} addresses" => "sending to {\$subscribers} addresses",
// "with the 'Reply To' email set to: {\$replyto}" => "with the 'Reply To' email set to: {\$replyto}",
// "with the 'Send From' email set to: {\$sendfrom}" => "with the 'Send From' email set to: {\$sendfrom}",
"Prepare a newsletter to be sent" => "Préparer une lettre d'informations pour être envoyée",
"Admin templates" => "Administrer les gabarits",
"Data HTML" => "Données HTML",
"Must be wiki parsed" => "Doit être analysé Wiki",
// "Wiki Parsed" => "Wiki Parsed",
// "Is HTML" => "Is HTML",
"Data Txt" => "Données textuelles",
"Article Clip (read only):" => "Extrait d'article (lecture seulement):",
"Clip Now" => "Extraire maintenant",
"Clip Articles" => "Extraire des articles",
"To include the article clipping into your newsletter, cut and paste it into the contents." => "Pour inclure un extrait d'article dans votre lettre de nouvelles, couper le et coller le dans les contenus.",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending." => "Si l'auto-extraction est activée, vous poyvez aussi entrer \"~~~articleclip~~~\" qui sera remplacé par le dernier extrait au moment de l'envoi.",
"Be careful not to paste articles that must not be seen by the recipients" => "Attention de ne pas coller un article qui ne doit pas être vu par les destinataires",
"Attached Files" => "Fichier(s) attaché(s)",
"remove" => "effacer",
"octets" => "octets",
"To add a file, click here" => "Pour ajouter un fichier, cliquer ici",
"Reply To Email" => "Répondre à l'email",
"if not" => "Si non défini",
"Sender email not set" => "Courriel de l'expéditeur non défini",
// "Send From Email" => "Send From Email",
"Preview your changes." => "Avoir un aperçu de vos modifications.",
"Save as Draft" => "Enregistrer comme brouillon",
"Save your changes" => "Enregister vos modifications",
"Save any changes and send to all subscribers" => "Enregistrer les changements et envoyer à tous les abonnées",
"Drafts (%0)" => "Brouillon (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "Envoyer des objets",
"Transmission results" => "Transmission des résultats",
"Send Wiki Pages" => "Envoyer des pages Wiki",
"Send a structure" => "Envoyer une structure",
"Send Articles" => "Envoyer des articles",
"Add Article" => "Ajouter un article",
"Send objects to this site" => "Envoyer des objets à ce site",
"Ex: http://tiki.org or localhost" => "Exemple : http://tiki.org ou localhost",
"Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Utiliser /commxmlrpc.php si votre site est à la racine, sinon adapter /tiki à votre besoin",
// "Report this page" => "Report this page",
"Page shared" => "Page partagée",
"The link was sent via email to the following addresses" => "Le lien a été envoyé par courriel aux adresses suivantes",
"The link was sent via Twitter" => "Le lien a été envoyé via Twitter",
"The link was posted on your Facebook wall" => "Le lien a été publié sur votre mur Facebook",
"The link was sent as message to" => "Le lien a été envoyé comme message à",
"The link was published in a" => "Le lien a été publié dans un(e)",
"Have a look at this page" => "Jeter un coup d'oeil à cette page",
// "Access rights are granted for the page" => "Access rights are granted for the page",
"Short link" => "Lien court",
// "Send email" => "Send email",
"Recipient(s)" => "Destinataire(s)",
"Separate multiple email addresses with a comma and a space" => "Séparer plusieurs courriels par une virgule et un espace",
"Separate multiple email addresses with a comma." => "Séparer les adresses email par des virgules.",
"Your name" => "Votre nom",
// "Recipients can subscribe to token notifications" => "Recipients can subscribe to token notifications",
// "Token Access Limit" => "Token Access Limit",
// "How many times recipients can access this page" => "How many times recipients can access this page",
"Tweet via Twitter" => "Tweet par Twitter",
"Authorize with Twitter first" => "Autoriser à accéder à Twitter d'abord",
"Have a look at " => "Jeter un coup d'oeil à",
"Put on my Facebook wall" => "Mettre sur mon mur Facebook",
"Authorize with Facebook first" => "Autoriser à accéder à Facebook d'abord",
"Link text" => "Texte du lien",
"This will be the title for the URL" => "Ceci sera le titre pour l'URL",
// "Like this post" => "Like this post",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "Vous n'avez pas les droits pour envoyer des messages ou vous n'avez pas autorisé les autres utilisateurs à vous envoyer des messages",
// "User(s)" => "User(s)",
"Separate multiple recipients with a semicolon" => "Séparer les destintaires multiples avec un point-virgule",
"Post on forum" => "Publier sur un forum",
"There is no forum where you can post a message" => "Il n'y a pas de forum où vous pourriez publier un message",
"password-protected" => "Protégé par mot de passe",
"Share access rights" => "Partager les droits d'accès",
"Return to previous page" => "Retour à la page précédente",
// "Create sheet" => "Create sheet",
// "Configure sheet" => "Configure sheet",
"There are individual permissions set for this sheet" => "Des droits d'accès individuels ont été mis sur ce feuillet",
"Class Name" => "Nom de la classe",
"Header Rows" => "Rangées en-tête",
"Footer Rows" => "Rangées bas-de-page",
"Wiki Parse Values" => "Analyse Wiki des valeurs",
"Parent Spreadsheet" => "Feuille parente",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Fait de cette feuille de calcul une feuille \"enfant\" d'un ensemble multi-feuille",
"You can access the sheet using the following URL" => "Vous pouvez accéder à ce feuillet par l'adresse Web suivante",
"Banned Words" => "Mots bannis",
"Change shoutbox general settings" => "Changer la configuration générale du mégaphone",
"auto-link urls" => "reconnaissance automatique des URLs",
"Post or edit a message" => "Publier ou modifier un message",
"Location : " => "Position : ",
"Content may be out of date" => "Le contenu peut ne plus être à jour",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "Un demande urgente de traduction a été envoyée. Jusqu'à ce que cette page soit mise à jour, vous pouvez visualiser une version corrigée dans les pages suivantes",
// "Update from it" => "Update from it",
"page: %0/%1" => "page : %0/%1",
"This text was automatically translated by Google Translate from the following page: " => "Ce texte a été automatiquement traduit par Google Translate depuis la page suivante : ",
// "Rate this page" => "Rate this page",
"Last edited by" => "Dernièrement modifié par",
"based on work by" => "Basé sur le travail de",
"Contributors to this page" => "Collaborateur(s) de cette page",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
"Twitter authorisation" => "autorisation Twitter",
"to manage your authorisations at Twitter" => "pour gérer vos autorisations à Twitter",
"this site with twitter.com to use Twitter integration of this site" => "ce site avec twitter.com pour utiliser l'intégration Twitter de ce site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
"Facebook authorisation" => "autorisation Facebook",
// "to manage your authorizations at Facebook" => "to manage your authorizations at Facebook",
// "this site within facebook.com to use Facebook integration with this site" => "this site within facebook.com to use Facebook integration with this site",
// "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first" => "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first",
// "LinkedIn authorisation" => "LinkedIn authorisation",
// "this site to link your user to your LinkedIn account" => "this site to link your user to your LinkedIn account",
"The site admin has set up a global account which will be used for this site" => "L'administrateur du site a défini un compte global qui va être utilisé pour ce site",
"bit.ly Login" => "Identifiant bit.ly",
"bit.ly Key" => "Clé bit.ly",
"Save changes" => "Enregister les modifications",
"You will be redirected to the home page shortly" => "Vous allez être redirigé vers la page d'accueil sous peu",
"to go to the home page immediately" => "pour aller à la page d'accueil immédiatement",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site" => "Do you already have a local account for this site",
// "Login to link to it using the following form instead" => "Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
"You will not see the latest queries" => "Vous ne verrez pas les dernières requêtes",
"Query" => "Requête",
"Params" => "Paramètres",
"Most viewed objects" => "Objets les plus vus",
"Most viewed objects in the last 7 days" => "Objets les plus vus ces derniers 7 jours",
"Site Stats" => "Statistiques du site",
"Date of first pageview" => "Date de premère visualisation d'une page",
"Days since first pageview" => "Jours écoulés depuis la première visualisation de la page",
"Total pageviews" => "Total des pages vues",
"Average pageviews per day" => "Nombre moyen de pages vues par jour",
"Wiki Stats" => "Statistiques de Wiki",
"Size of Wiki Pages" => "Taille totale des pages Wiki",
"Average page length" => "Taille moyenne d'une page",
"Average versions per page" => "Nombre moyen de versions par page",
"Visits to wiki pages" => "Nombre de visites aux pages Wiki",
"Average links per page" => "Nombre moyen de liens par page",
"Image galleries Stats" => "Statistiques sur les galeries d'images",
"Average images per gallery" => "Nombre moyen d'images par galerie",
"Total size of images" => "Taille totale des images",
"Average image size" => "Taille moyenne d'une image",
"Visits to image galleries" => "Nombre de visites aux galeries d'images",
"File galleries Stats" => "Statistiques sur les galeries de fichiers",
"Average files per gallery" => "Nombre moyen de fichiers par galerie",
"Total size of files" => "Taille totale des fichiers",
"Average file size" => "Taille moyenne d'un fichier",
"Visits to file galleries" => "Nombre de visites aux galeries de fichiers",
"Articles Stats" => "Stats Articles",
"Total reads" => "Nombre total de lectures",
"Average reads per article" => "Nombre moyen de lectures par article",
"Total articles size" => "Taille totale des articles",
"Average article size" => "Taille moyenne d'un article",
"Forum Stats" => "Statistiques sur les forums",
"Total topics" => "Nombre total de sujets",
"Average topics per forums" => "Nombre moyen de sujets par forum",
"Total replies" => "Nombre total de réponses",
"Average number of replies per topic" => "Nombre moyen de réponses par sujet",
"Visits to forums" => "Visites aux forums",
"Blog Stats" => "Statistiques sur les blogues",
"Weblogs" => "Blogues",
"Total posts" => "Total des articles",
"Average posts per weblog" => "Moyenne d'articles par blogue",
"Total size of blog posts" => "Taille totale des articles du blogue",
"Average posts size" => "Taille moyenne d'un article",
"Visits to weblogs" => "Visites aux blogues",
"Poll Stats" => "Statistiques sur les sondages",
"Total votes" => "Total de votes",
"Average votes per poll" => "Nombre moyen de votes par sondage",
"FAQ Stats" => "Statistiques sur les FAQs",
"Total questions" => "Nombre total de questions",
"Average questions per FAQ" => "Nombre moyen de questions par FAQ",
"User Stats" => "Statistiques sur les utilisateurs",
"Average bookmarks per user" => "Nombre moyen de signets par utilisateur",
"Average questions per quiz" => "Nombre moyen de questions par QCM",
"Quizzes taken" => "QCMs remplis",
"Average quiz score" => "Moyenne des scores de QCM",
"Average time per quiz" => "Temps moyen pour remplir un QCM",
"Most viewed objects in period" => "Objets les plus vus dans la période",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Graphe d'utilisation",
"Usage chart image" => "Image du graphe d'utilisation",
"Daily Usage" => "Usage journalier",
// "Piwik Analytics Dashboard" => "Piwik Analytics Dashboard",
// "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard" => "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard",
"Stats for surveys" => "Statistiques sur les enquêtes",
"Last taken" => "Dernière réponse",
"Stats for survey" => "Statistiques sur les enquêtes",
// "Select a user to preview its answer (marked as" => "Select a user to preview its answer (marked as",
// "User voted" => "User voted",
// "Select User" => "Select User",
// "no answer" => "no answer",
"Tiki Logs" => "Journal système",
"Export through Action Log" => "Exporter à travers le log des actions",
"Clean logs older than" => "Nettoyer les entrées de journal plus vieilles que",
// "Are you sure you want to revert" => "Are you sure you want to revert",
// "Revert" => "Revert",
"Time Left" => "Temps restant",
"Send Answers" => "Envoyer les réponses",
"Thank you for your submission" => "Merci pour votre soumission",
"Send a link to a friend" => "Envoyer ce lien à un ami",
"Your email was sent" => "Votre email a été envoyé",
"The link was sent to the following addresses" => "Le lien a été envoyé à ces adresses",
"Friend's email" => "Adresse mail de votre ami",
"Your comment" => "Votre commentaire",
"I found an interesting page that I thought you would like." => "J'ai trouvé cette page qui pourrait t'intéresser.",
"TikiTests Edit" => "Éditer des TikiTests",
"Summary mode" => "Mode résumé",
"Show Page Differences" => "Montrer les différences de la page",
"Show Tidy Errors and Warnings" => "Afficher les erreurs Tidy et les Avertissements",
"Show POST Data" => "Afficher les données du POST",
"Use Current Session/Log out" => "Utiliser la Seesion Courante/Se Déconnecter",
"Recorded Links" => "Liesn enregsitrés",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
"Tidy Results" => "Résultats Tidy",
"Delete this link" => "Supprimer ce lien",
"TikiTests List" => "Liste des TikiTests",
"Config" => "Config",
"Replay" => "Rejouer",
"Tidy extension not present" => "Extension Tidy non présente",
"PECL HTTP extension present" => "Extension PECL HTTP présente",
"cURL extension present" => "Extension cURL présente",
"PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "Les extensions PECL HTTP et cURL ne sont pas présente. Il sera impossible de rejouer les TikiTest",
"List TikiTests" => "Lister les TikiTests",
"Create a TikiTest" => "Créer un TikiTest",
"Replay the TikiTest" => "Rejouer un TikiTest",
"Edit the TikiTest" => "Éditer un TikiTest",
"TikiTests Record Configuration" => "Configuration de l'enregistrement des TikiTests",
"Start Recording Test" => "Démarrer l'enregistrement du test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
"Failure" => "Échec",
"Reference" => "Référence",
"The pages are different" => "Les pages sont différentes",
"The pages are identical" => "Les pages sont identiques",
"Recording to pause press the pause button" => "Enregistre, pour interrompre appuyer sur le bouton pause",
"Pause the recording" => "Interrompre l'enregistrement",
"Paused to resume press the play button" => "Pause, pour reprendre appuyer sur le bouton lecture",
"Resume the recording" => "Reprendre l'enregistrement",
"Stop the recording" => "Arrêter l'enregistrement",
"Control by Objects" => "Contrôle des thèmes/objets",
"Control by Sections" => "Contrôle des thèmes/sections",
"Assign themes to categories" => "Attribuer un thème à une catégorie",
"Assigned categories" => "Catégories avec thème",
// "Delete selected" => "Delete selected",
"Control by Categories" => "Contrôle des thèmes/catégories",
"Assign themes to objects" => "Attribuer un thème à un objet",
"Assigned objects" => "Objets avec thème",
"Assign themes to sections" => "Attribuer un thème à une section",
"Assigned sections" => "Sections avec thème",
// "Timesheets" => "Timesheets",
"Apply the following profile for enhancements: " => "Appliquer le profil suivant pour des améliorations : ",
"Time Tracker" => "Formulaire des temps",
// "Local Cache (Not Committed)" => "Local Cache (Not Committed)",
// "Saved (Committed)" => "Saved (Committed)",
"New task" => "Nouvelle tâche",
// "Toggle completed" => "Toggle completed",
// "Toggle archived" => "Toggle archived",
// "Task name" => "Task name",
// "Estimate (in min.)" => "Estimate (in min.)",
// "Estimate" => "Estimate",
// "Task is completed" => "Task is completed",
// "Task is archived" => "Task is archived",
// "Created at" => "Created at",
// "Are you sure you want to delete all tasks" => "Are you sure you want to delete all tasks",
// "Commit Time Sheet Items" => "Commit Time Sheet Items",
// "View All" => "View All",
// "View My Items" => "View My Items",
"Summary" => "Résumé",
// "Time Spent" => "Time Spent",
// "Done By" => "Done By",
"Add Tracker" => "Ajouter un formulaire",
"Add Tracker To Tracker Report" => "Ajouter un formulaire au rappport de formulaire",
// "View Tracker Report" => "View Tracker Report",
// "Pick tracker to join" => "Pick tracker to join",
// "Pick fields to join on" => "Pick fields to join on",
// "Join inner" => "Join inner",
// "Join outer" => "Join outer",
// "Tracker - Open" => "Tracker - Open",
// "Tracker - Pending" => "Tracker - Pending",
// "Tracker - Closed" => "Tracker - Closed",
"Tracker Item History" => "Historique de fiche de formulaire",
"View Tracker Item" => "Visualiser la fiche de formulaire",
// "Not logging" => "Not logging",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable",
"Edit File" => "Éditer le fichier",
"Advanced mode" => "Mode avancé",
"Simple mode" => "Mode simple",
"Retry" => "Ré-essayer",
"Additional Info" => "Infos additionnelles",
// "Syntax Tips" => "Syntax Tips",
// "Download link using Tiki syntax" => "Download link using Tiki syntax",
// "Display an image using Tiki syntax" => "Display an image using Tiki syntax",
// "Use as a thumbnail with ShadowBox" => "Use as a thumbnail with ShadowBox",
// "Download link using HTML" => "Download link using HTML",
"You locked the file" => "Vous avez verrouillé le fichier",
"The file has been locked by {\$fileInfo.lockedby}" => "Le fichier est verrouillé par {\$fileInfo.lockedby}",
"File title" => "Nom du fichier",
"required field for podcasts" => "champ obligatoire pour podcasts",
"File description" => "Description",
// "Re-upload from disk" => "Re-upload from disk",
// "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>" => "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>",
// "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
"Unzip zip files" => "Dézipper les fichiers zip",
"File can be deleted after" => "Le fichier peut être supprimé après",
// "OCR files if supported" => "OCR files if supported",
"Creator of file, if different from the 'Uploaded by' user" => "Créateur du fichier, si différent de l'utilisateur qui l'a téléchargé",
// "File Type" => "File Type",
// "No type" => "No type",
"Maximum number of downloads" => "Nombre maximal de téléchargements",
"-1 for no limit" => "-1 pour illimité",
"Upload File(s)" => "Envoyer le(s) fichier(s)",
"Add Another File" => "Ajouter un autre fichier",
"Maximum file size is around" => "La taille maximum d'un fichier est de",
// "Note: You are running IIS" => "Note: You are running IIS",
// "maxAllowedContentLength also limits upload size" => "maxAllowedContentLength also limits upload size",
// "Please check web.config in the Tiki root folder" => "Please check web.config in the Tiki root folder",
"Uploading file..." => "Envoi du fichier...",
"No File to Upload..." => "Pas de fichier à envoyer...",
// "Keeps a reference to the remote file" => "Keeps a reference to the remote file",
// "Video file uploaded" => "Video file uploaded",
"Link to file from a Wiki page" => "Lien vers le fichier à partir d'une page Wiki",
// "For image files" => "For image files",
// "Display full size" => "Display full size",
"Display thumbnail that enlarges" => "Affichage d'une vignette qui s'agrandit",
"Batch Upload Results" => "Résultats de l'envoi par lot",
"Upload successful!" => "Envoi réussi !",
"The following image was successfully uploaded" => "L'image suivante a été envoyée avec succès",
"Image ID thumb" => "Vignette de l'image",
"You can view this image in your browser using" => "Vous pouvez afficher cette page dans votre navigateur en utilisant",
"You can include the image in an Wiki page using" => "Vous pouvez insérer cette image dans une page Wiki en utilisant",
"or use filename" => "ou utiliser le nom du fichier",
"Now enter the image URL" => "Entrer maintenant l'adresse Web",
"or upload a local image from your disk" => "ou envoyer une image à partir de votre disque",
"Batch Upload" => "Envoi par lot",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Vignette (optionnel, annule et remplace la génération automatique de vignettes)",
"No gallery available" => "Pas de galerie disponible",
"You have to create a gallery first!" => "Il faut tout d'abord créer une galerie !",
"User assigned modules" => "Modules utilisateur",
// "to assign modules, which will make them available for creating a custom order on this page" => "to assign modules, which will make them available for creating a custom order on this page",
"Restore defaults" => "Restaurer les valeurs par défaut",
"The column is disabled" => "La colonne est désactivée",
"#" => "N°",
"Move module up" => "Remonter le module",
"Move module down" => "Descendre le module",
// "Move to right side" => "Move to right side",
// "Move to left side" => "Move to left side",
"Assign module" => "Attribuer un module",
"top" => "haut",
"Current folder" => "Répertoire actuel",
"Folders" => "Répertoires",
"Folder in" => "Aller dans le répertoire",
// "Refresh cache" => "Refresh cache",
"Admin folders and bookmarks" => "Administrer les répertoires et les signets",
"a folder" => "un répertoire",
"a bookmark" => "un signet",
"User Contacts Preferences" => "Préférences sur mes contacts",
"Change preferences" => "Modifier les préférences",
"Manage Fields" => "Gérer les champs",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{\$chdata.name}" => "{\$chdata.name}",
"Send me a message" => "Envoyez-moi un message",
"Basic Data" => "Données de base",
// "Assign group" => "Assign group",
"Assign Group" => "Mettre dans un groupe",
"User Icon" => "Icône utilisateur",
// "{\$gender}" => "{\$gender}",
"(non public)" => "(non public)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
"Language:" => "Langue :",
"User's homepage" => "Page d'accueil utilisateur",
"Score:" => "Système d'évaluation :",
"Personal Wiki Page" => "Page Wiki personnelle",
"Last login:" => "Dernière connexion :",
// "Your relationship with other users" => "Your relationship with other users",
// "Relationship of this user to you" => "Relationship of this user to you",
"The user has chosen to make his information private" => "L'utilisateur a choisi de garder ses informations privées",
"Additional Information" => "Information Additionnelle",
// "Change user information" => "Change user information",
"User Contribution" => "Contribution(s)",
"has contributed to the following content" => "a contribué au contenu suivant",
"has not contributed to any content yet" => "n'a contribué à aucun contenu pour le moment",
// "Blogs Posts" => "Blogs Posts",
"Forum comments" => "Commentaires de forum",
"Forum topics" => "Sujets de forum",
"Who Looks at Items" => "Qui regarde les affaires",
"Who Looks at Your Items" => "Qui regarde vos affaires",
"Who Looks at His or Her Items" => "Qui regarde ses affaires",
"Send Me A Message" => "Envoyez moi un message",
"Send me a message !" => "Envoyez-moi un message !",
"The following message will be sent to user" => "Le message suivant sera envoyé à l'utilisateur",
"Message Body" => "Corps du message",
// "My Mail-in" => "My Mail-in",
// "Are you sure you want to delete the routing rule" => "Are you sure you want to delete the routing rule",
// "Configure how your mailed-in wiki pages are to be linked / organized" => "Configure how your mailed-in wiki pages are to be linked / organized",
// "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked" => "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked",
// "Only newly created pages, using the mail-in wiki-put function, are affected" => "Only newly created pages, using the mail-in wiki-put function, are affected",
// "Go to wiki structure setting" => "Go to wiki structure setting",
"Toggle options" => "Afficher/cacher les sous menus",
"Male" => "Homme",
"Female" => "Femme",
// "Your Personal Wiki Page" => "Your Personal Wiki Page",
"User's personal tracker information" => "Information sur le formulaire personnel utilisateur",
"View extra information" => "Voir les informations supplémentaires",
"Your personal tracker information" => "Votre formulaire d'informations personnelles",
// "Is email public" => "Is email public",
"Unavailable - please set your email below" => "Indisponible - donnez votre adresse électronique ci-dessous SVP",
// "Preferred perspective" => "Preferred perspective",
// "Email character set" => "Email character set",
// "Admin Language" => "Admin Language",
"Can you read more languages?" => "Vous pouvez lire plus de langues ?",
// "Other languages you can read" => "Other languages you can read",
"Select language..." => "Choisir une langue...",
// "Select from the dropdown to add automatically to the list below" => "Select from the dropdown to add automatically to the list below",
// "Displayed timezone" => "Displayed timezone",
"Detect user time zone if browser allows, otherwise site default" => "Détecter le fuseau horaire utilisateur (si le navigateur le permet). Sinon, appliquer le fuseau horaire par défaut",
// "Site time zone <strong>%0</strong> is enforced and overrides user preferences" => "Site time zone <strong>%0</strong> is enforced and overrides user preferences",
"Use 12-hour clock in time selectors" => "Utiliser le format 12 heures dans les sélecteurs de temps",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Lors du survol de la souris, afficher les informations utilisateurs pour celles qui sont définies comme public",
"User Messages" => "Messages utilisateur",
"Notify sender when reading his mail" => "Notifier l'emetteur quand son message est lu",
// "Message priority notification" => "Message priority notification",
// "Read message auto-archiving" => "Read message auto-archiving",
"never" => "jamais",
// "Auto-archive read messages after selected days" => "Auto-archive read messages after selected days",
"User Tasks" => "Tâches utilisateur",
// "XMPP account JID" => "XMPP account JID",
// "If empty, Tiki will provide default value" => "If empty, Tiki will provide default value",
// "You have to provide this when using custom XMPP server" => "You have to provide this when using custom XMPP server",
"My user items" => "Mes fiches",
// "My articles" => "My articles",
"My level" => "Mon niveau",
// "Remember which remarksbox (alert box) you have closed and don't show them again" => "Remember which remarksbox (alert box) you have closed and don't show them again",
"Reset remark boxes visibility" => "Réinitialiser la visibilités de boîtes de remarques",
// "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed" => "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed",
"Account Information" => "Informations sur le compte",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Laisser les champs \"Nouveau mot de passe\" et \"Confirmer le nouveau mot de passe\" vides pour garder le mot de passe courant",
"Current password (required)" => "Mot de passe actuel (requis)",
"Account Deletion" => "Suppression du compte",
"Are you really sure you want to delete the account %0" => "Etes-vous sûr de vouloir supprimer le compte %0",
"Check this box if you really want to delete the account" => "Cocher cette case si vous voulez réellement supprimer ce compte",
"Delete the account" => "Supprimer le compte",
"Delete my account" => "Supprimer mon compte",
"Task list" => "Liste des tâches",
"Admin mode off" => "Mode admin inactif",
"Admin mode on" => "Mode admin actif",
"Task help" => "Aide (Tâches)",
"Empty Trash" => "Vider la corbeille",
"Task received" => "Tâche reçue",
"You received this task" => "Vous avez reçu cette tâche",
"Task sent" => "Tâche envoyée",
"You sent this task to another user" => "Vous avez envoyé cette tâche à un autre utilisateur",
"Task shared by a group" => "Tâche partagée par un groupe",
"Task is shared by a group" => "La tâche est partagée par un groupe",
"Accepted by task user and creator" => "Accepté par l'utilisateur de la tâche et le créateur",
"Task has been accepted by user and creator" => "La tâche a été acceptée par l'utilisateur et le créateur",
"Rejected by a user" => "Rejeté par un utilisateur",
"Task has been rejected by a user" => "La tâche a été rejetéé par un utilisateur",
"Waiting for me" => "Attente pour moi",
"Task has not yet been accepted or rejected by you" => "La tâche n'a pas encore été acceptée ou rejetée par vous",
"Waiting for other user" => "En attente d'un autre utilisateur",
"Task has not yet been accepted or rejected by another user" => "La tâche n'a pas encore été acceptée ou rejetée par un autre utilisateur",
"Admin Mode" => "Mode administration",
"Edit Task" => "Modifier une tâche",
"NOT accept" => "Refuser",
"Remove from Trash" => "Retirer de la corbeille",
"Move to trash" => "Mettre à la poubelle",
"Move to Trash" => "Mettre à la Poubelle",
"Task saved" => "Tâche sauvegardée",
"View Task" => "Afficher une tâche",
"Open a new task" => "Ouvrir une nouvelle tâche",
"Last Version" => "Dernière version",
"taskId" => "taskId",
"Task user" => "Utilisateur de la tâche",
"Only the creator can delete this task" => "Seul son créateur peut effacer cette tâche",
"Use start date and time" => "Utiliser date et temps de départ",
"Use end date and time" => "Utiliser date et heure de fin",
"Open / In Process" => "Ouvert / En cours",
"Waiting / Not Started" => "En attente / non démarrée",
"Percentage completed" => "Pourcentage accompli",
"Waiting" => "En attente",
"Shared for Group" => "Partagé par le groupe",
"Accepted by User" => "Accepté par l'utilisateur",
"No / Rejected" => "Non / refusé",
"Accepted by Creator" => "Accepté par le créateur",
"This message will be send to users if you are makeing changes of assigned tasks" => "Ce message va être envoyé aux utilisateurs si vous faites des changements aux tâches attribuées",
"Send a message with changes" => "Envoyer un message avec les changements",
"Modified by" => "Modifié par",
"Marked as deleted" => "Marqué comme supprimé",
"Inform task user by email" => "Informer l'utilisateur de la tâche par email",
"Reload" => "Recharger",
"You can only view this task" => "Vous ne pouvez voir que cette tâche",
"In the trash" => "Dasn la poubelle",
"Not Accepted by One User" => "Non accepté par un utilisateur",
"Not Accepted User" => "Non accepté par utilisateur",
"No tasks entered" => "Aucune tâche entrée",
"Select One" => "Choisir parmi",
"Trash" => "Corbeille",
"Undo Trash" => "Retirer de la corbeille",
"Received" => "Reçu",
"Submitted" => "Soumis",
"Shared" => "Partagé",
"All Shared Tasks" => "Toutes les tâches partagées",
// "Previous version" => "Previous version",
// "Next version" => "Next version",
"completed (100%)" => "fini (100%)",
"Public for group" => "Publique pour le groupe",
// "Wikis" => "Wikis",
// "Forum Threads" => "Forum Threads",
// "{\$userinfo['user_country']|stringfix}" => "{\$userinfo['user_country']|stringfix}",
// "{\$userinfo['user_gender']}" => "{\$userinfo['user_gender']}",
// "This user has contributed to the following wiki pages" => "This user has contributed to the following wiki pages",
// "This user has not contributed to any wiki pages yet" => "This user has not contributed to any wiki pages yet",
// "This user has not contributed any blog posts yet" => "This user has not contributed any blog posts yet",
// "This user has contributed to the following tracker items" => "This user has contributed to the following tracker items",
// "This user has not contributed to any tracker items yet" => "This user has not contributed to any tracker items yet",
// "This user has contributed to the following articles" => "This user has contributed to the following articles",
// "This user has not contributed to any articles yet" => "This user has not contributed to any articles yet",
// "This user has started to the following forum threads" => "This user has started to the following forum threads",
// "This user has not contributed to any forums yet" => "This user has not contributed to any forums yet",
// "Add to Network" => "Add to Network",
// "Remove from Network" => "Remove from Network",
"User Watches and preferences" => "Notifications utilisateur de changement et préférences",
"You need to set your email to receive email notifications" => "Vous devez configurer votre courriel pour pouvoir recevoir des notifications",
"Use reports to summarise notifications about objects you are watching" => "Utiliser les rapports pour résumer les notifications sur les objects que vous surveillez",
"Use reports" => "Utiliser les rapports",
// "Reporting interval" => "Reporting interval",
// "Every minute" => "Every minute",
// "Hourly" => "Hourly",
"Monthly" => "Mensuel",
// "Report length" => "Report length",
"Short report" => "Rapport concis",
"Detailed report" => "Rapport détaillé",
// "Report format" => "Report format",
// "Send report even if no activity" => "Send report even if no activity",
"My watches" => "Mes surveillances",
"Use \"watches\" to monitor wiki pages or other objects" => "Utiliser \"watches\" pour la surveillance des pages Wiki et des autres objets",
// "Watch new items by clicking the {icon name='watch'} button on specific pages" => "Watch new items by clicking the {icon name='watch'} button on specific pages",
"Add Watch" => "Ajouter une notification",
"Select event type" => "Sélectionnez le type d'évènement",
"All watched events" => "Tous les évènements surveillés",
"A user submits a blog post" => "Un utilisateur soumet une publication sur le blogue",
"A user posts a forum thread" => "Un utilisateur publie un fil de discussion sur le forum",
"A user posts a forum topic" => "Nouveau sujet forum",
"A user edited or commented on a wiki page" => "Un utilisateur a modifié ou commenté une page wiki",
"A user edited a wiki page" => "Un utilisateur a modifié une page wiki",
"{\$w.type}" => "{\$w.type}",
"Use this form to control notifications about objects you are watching" => "Utilisez ce formulaire pour contrôler les notifications au sujet des objets que vous surveillez",
"Send notification when I am the editor" => "Envoyez une notification lorsque je suis l'éditeur",
"Used space" => "Volume utilisé",
"up to" => "sur",
"no limit for admin" => "aucune limite pour l'administrateur",
"User Menu" => "Menu utilisateur",
"May need to refresh twice to see changes" => "Vous devrez peut-être réactualiser 2 fois pour voir les modifications",
"Add top level bookmarks to menu" => "Ajouter les signets du niveau supérieur au menu utilisateur",
"Add or edit an item" => "Ajouter/modifier un item",
"New Window" => "Nouvelle fenêtre (n)",
"replace window" => "remplacer la fenêtre (w)",
"Delete Selected" => "Effacer les sélectionnés",
// "Pos" => "Pos",
"User_versions_for" => "Versions pour",
// "Monitor articles" => "Monitor articles",
// "Stop monitoring articles" => "Stop monitoring articles",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
// "\"}Actions for %0" => "\"}Actions for %0",
"No articles yet" => "Aucun article",
// "New article" => "New article",
"Banner stats" => "Statistiques de la bannière",
"Create new banner" => "Créer une nouvelle bannière",
"Banner Information" => "Information sur la bannière",
"Click ratio" => "Proportion de clics",
"Weekdays" => "Jours de semaines",
"mon" => "lun",
"tue" => "mar",
"wed" => "mer",
"thu" => "jeu",
"fri" => "ven",
"sat" => "sam",
"sun" => "dim",
"Banner raw data" => "Données brutes de la bannière",
"Cached" => "Dans l'antémémoire",
"This is a cached version of the page." => "Cette version de la page est dans l'antémémoire.",
"Click here to view the Google cache of the page instead." => "Cliquer ici pour voir à la place le cache Google de la page.",
// "{\$faq_info.title}" => "{\$faq_info.title}",
"There are no questions in this FAQ." => "Il n'y a pas de questions dans cette galerie.",
"Answers" => "Réponses",
"Add Suggestion" => "Ajouter une suggestion",
"Edit Forum" => "Modifier ce forum",
"Forum List" => "Liste des forums",
// "Forum actions" => "Forum actions",
// "Monitor topics" => "Monitor topics",
// "Stop monitoring topics" => "Stop monitoring topics",
// "Monitor topics and threads" => "Monitor topics and threads",
// "Stop monitoring topics and threads" => "Stop monitoring topics and threads",
// "Group monitor topics" => "Group monitor topics",
// "Group monitor topics and threads" => "Group monitor topics and threads",
// "Post New" => "Post New",
// "Deliberation" => "Deliberation",
// "Add Deliberation Item" => "Add Deliberation Item",
"Watch for replies" => "Surveiller les réponses",
"Send me an email when someone replies to my topic" => "M'envoyer un courriel lorsqu'une modification est faite à mon sujet",
"Don't send me any emails" => "Ne pas m'envoyer de courriels",
"Enter your name" => "Saisir votre nom",
"Editing posts" => "Édition des articles",
// "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax" => "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax",
// "Moderator actions on selected topics" => "Moderator actions on selected topics",
"Emot" => "émot",
// "Rating <br/>(avg/max)" => "Rating <br/>(avg/max)",
// "Detailed results <br/>(counts)" => "Detailed results <br/>(counts)",
// "Detailed results <br/>(counts/%)" => "Detailed results <br/>(counts/%)",
"pts" => "pts",
// "Topic locked" => "Topic locked",
// "Forum locked" => "Forum locked",
// "No topics found" => "No topics found",
"posts in this forum" => "articles dans ce forum",
// "Filter Posts" => "Filter Posts",
"Last post date" => "Date du dernier article",
"All posts" => "Tous les articles",
"Last hour" => "De la dernière heure",
"Last 24 hours" => "Des dernières 24h",
"Last 48 hours" => "Des dernières 48h",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "normal",
"announce" => "annonce",
"hot" => "populaire",
"Posts with no replies" => "Articles sans réponses",
"Topic List" => "Liste des sujets",
"The post has been reported and will be reviewed by a moderator." => "La publication a été signalée à un modérateur et sera révisée.",
// "Previous topic" => "Previous topic",
// "Next topic" => "Next topic",
"You are viewing a reply to" => "Vous visualisez une réponse à",
// "Thread actions" => "Thread actions",
// "Print this page" => "Print this page",
"Print all pages" => "Imprimer toutes les pages",
"Show posts" => "Afficher les articles",
"Jump to forum" => "Aller au forum",
"View Invoice" => "Voir la facture",
"Invoice %0" => "Facture %0",
"Date Issued %0" => "Date d'émission %0",
"Amount: %0" => "Montant : %0",
"Payment Terms: %0" => "Conditions de paiement : %0",
// "This sheet is already being edited by %0" => "This sheet is already being edited by %0",
"Back to Page" => "Retour vers la page",
"Tiki Sheet" => "Feuillet Tiki",
"Save current spreadsheet" => "Enregistrer la feuille de calcul en cours",
"Cancel editing current spreadsheet" => "Annuler la modification courante de la feuille de données",
"No parse" => "Pas d'analyse",
"What would you like to add" => "Que voudriez-vous ajouter",
"New spreadsheet" => "Nouvelle feuille de calcul",
"Existing spreadsheet" => "Feuille de calcul existante",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
"Cell" => "Cellule",
"Set Reference" => "Définir un nom",
"Un-Merge" => "Dé-fusionner",
"Adds an additional row to bottom of the spreadsheet" => "Ajoute une ligne additionnelle en haut de la feuille de calcul",
"Add Row" => "Ajouter une ligne",
"Adds an additional rows to bottom of the spreadsheet" => "Ajoute une ligne additionnelle au bas de la feuille de calcul",
"Add Multi-Rows" => "Ajouter plusieurs lignes",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
"Delete Row" => "Supprimer la ligne",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
"Insert Row Before" => "Insérer une ligne avant",
"Insert Row After" => "Insérer une ligne après",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Afficher tout",
"Hides or shows the currently selected row" => "Masque ou affiche la ligne actuellement sélectionnée",
// "Toggle Hide Row" => "Toggle Hide Row",
"Adds an additional column to the right of the spreadsheet" => "Ajoute une colonne additionnelle à la droite de la feuille de calcul",
"Add Column" => "Ajouter une colonne",
"Adds an additional columns to the right of the spreadsheet" => "Ajoute des colonnes additionnelles à la droite de la feuille de calcul",
"Add Multi-Columns" => "Ajouter plusieurs colonnes",
"Deletes the current column thats highlighted" => "Efface la colonne actuellement sélectionnée",
"Delete Column" => "Supprimer la colonne",
"Inserts an additional column after currently selected column" => "Insère une colonne supplémentaire après la colonne actuellement sélectionnée",
"Insert Column Before" => "Insérer une colonne avant",
"Insert Column After" => "Insérer une colonne après",
"Fill down current cell value" => "Remplir vers le bas avec la valeur de la cellule courante",
"Fill Down" => "Remplir vers le bas",
"Fill up current cell value" => "Remplir vers le haut avec la valeur de la cellule actuelle",
"Fill Up" => "Remplir vers le haut",
"Unhides all the hidden columns" => "Révèle toutes les colonnes masquées",
"Hides or shows the currently selected column" => "Affiche ou masque la colonne actuellement sélectionnée",
"Toggle Hide Column" => "Basculer cacher colonne",
"Add new spreadsheet" => "Ajouter une nouvelle feuille de calcul",
"Add Spreadsheet" => "Ajouter une feuille de calcul",
"Delete the current spreadsheet" => "Supprimer la feuille de calcul actuelle",
"Delete Spreadsheet" => "Supprimer une feuille de calcul",
"Recompiles the current sheet" => "Recompile la feuille actuelle",
"Change the title of the sheet" => "Changer le titre de la feuille",
"Wrap Cell Range" => "Traiter une plage de cellules",
"Wrap with SUM" => "Traiter avec SUM",
"Wrap with CEILING" => "Trairer avec CEILING",
"Wrap with COUNT" => "Trairer avec COUNT",
"Wrap with MAX" => "Trairer avec MAX",
"Wrap with MIN" => "Trairer avec MIN",
"Redo" => "Refaire",
// "Toggle State" => "Toggle State",
"Function Reference" => "Référence des fonctions",
"Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Exemple : =SUM(SUM(A1:B1) + SUM(D7))",
"=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
"Returns the absolute value of a number" => "Retourne la valeur absolue d'un nombre",
"Returns a rounded number" => "Retourne un nombre arrondi",
"Returns a number rounded up based on a multiple of significance" => "Retourne un nombre arrondi à la valeur supérieure basé sur un multiple de l'importance",
"Counts the number of cells that contain a value" => "Compte le nombre de cellules qui contiennent une valeur",
"Counts full days from a specific date - format(YYYY,MM,DD)" => "Compte les jours entiers à partir d'une date spécifique - format (AAAA,MM,JJ)",
"Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converit un nombre en texte, selon un format monétaire - options (nombre, décimales, symbole)",
"Returns a logical value of FALSE" => "Retourne une valeur logique FAUX",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
"Returns a number rounded down based on a multiple of significance" => "Retourne un nombre arrondi à la valeur inférieure basé sur un multiple de l'importance",
"Returns the integer portion of a number" => "Retourne la partie entière d'un nombre",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
"Converts a value to a number" => "Convertit une valeur en un nombre",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
"Italics" => "Italique",
"Uppercase" => "Majuscule",
"Capitalize" => "Mettre en majuscule",
"Lowercase" => "Minuscule",
"Font Size +" => "Taille police +",
"Font Size -" => "Taille police -",
// "{\$tracker_info.name}" => "{\$tracker_info.name}",
// "Tracker actions" => "Tracker actions",
// "Group Monitoring" => "Group Monitoring",
// "Stop Watching" => "Stop Watching",
"atts" => "joints",
"List Attachments" => "Liste des fichiers joints",
// "View/Edit" => "View/Edit",
"Insert New Item" => "Insérer une nouvelle fiche",
"View inserted item" => "Voir la fiche insérée",
"Insert new item" => "Ajouter une nouvelle fiche",
// "Synchronization" => "Synchronization",
"This tracker is a remote copy of <a href=\"%0\">%0</a>" => "Ce formulaire est une copie distante de <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
"Reload field definitions" => "Recharger les définitions de champ",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
"Reload data from source" => "Recharger les données depuis la source",
// "Tracker item actions" => "Tracker item actions",
"Move to another tracker" => "Déplacer vers un autre formulaire",
"Save Returning to Item List" => "Enregistrer en revenant à la liste des éléments",
// "Save and Comment" => "Save and Comment",
"Special Operations" => "Opérations spéciales",
"close" => "fermer",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
"Open Tiki WebDAV as WebFolder" => "Ouvrir comme un dossier WebDAV",
"Parent page" => "Page parente",
// "Manage Stucture" => "Manage Stucture",
"Child" => "Enfant",
"page id" => "id page",
// "Please wait" => "Please wait",
// " The PDF is being prepared, please wait.." => " The PDF is being prepared, please wait..",
// "Show structure" => "Show structure",
// "Hide structure bar and any toc" => "Hide structure bar and any toc",
"Hide structure" => "Masquer la structure",
"Page actions" => "actions",
// " PDF" => " PDF",
// "Warning:mPDF Package Missing" => "Warning:mPDF Package Missing",
// "Click to toggle on/off" => "Click to toggle on/off",
// "Edit icons" => "Edit icons",
"Wysiwyg" => "Wysiwyg",
// "Send link" => "Send link",
// "Monitor page" => "Monitor page",
// "Stop monitoring page" => "Stop monitoring page",
// "Monitor sub-structure" => "Monitor sub-structure",
// "Stop monitoring sub-structure" => "Stop monitoring sub-structure",
// "Group monitor structure" => "Group monitor structure",
// "Profiles Wizard" => "Profiles Wizard",
// "Changes Wizard" => "Changes Wizard",
// "Configuration Wizard" => "Configuration Wizard",
// "steps" => "steps",
// "User Wizard" => "User Wizard",
// "Wizard Steps" => "Wizard Steps",
// "Change Theme" => "Change Theme",
// "Change Transition" => "Change Transition",
// "Convex" => "Convex",
// "Concave" => "Concave",
// " Handouts" => " Handouts",
// "Exit Slideshow" => "Exit Slideshow",
"More types available" => "Davantage de types de champ disponibles",
// "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>",
"Description contains wiki syntax" => "La description contient de la syntaxe Wiki",
"Restrict visibility to administrators" => "Restreindre la visibilité aux administrateurs",
"Useful if you are working on a live tracker" => "Utile si vous êtes en train de travailler sur un formulaire en ligne",
"Add Field &amp; Edit Advanced Options" => "Ajouter le champ et modifier les options avancées",
// "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)" => "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)",
// "Clear All" => "Clear All",
"Options for %0" => "Options pour %0",
"Separate multiple with commas" => "Séparer les valeurs multiples par des virgules",
// "Separate multiple with &quot;{\$def.separator}&quot" => "Separate multiple with &quot;{\$def.separator}&quot",
"Error Message" => "Message d'erreur",
"Visible by all" => "Visible par tous",
// "Visible by all but not in RSS feeds" => "Visible by all but not in RSS feeds",
// "Visible after creation by administrators only" => "Visible after creation by administrators only",
"Editable by administrators only" => "Modifiable uniquement par les administrateurs",
// "Editable after creation by administrators only" => "Editable after creation by administrators only",
"Editable by administrators and creator only" => "Modifiable uniquement par les administrateurs ou le créateur",
// "Immutable after creation" => "Immutable after creation",
"Creator requires a user field with auto-assign to creator (1)" => "Le créateur nécessite un champ utilisateur avec une auto-assignation au créateur (1)",
"Visible by" => "Visible par",
"List of Group names with permission to see this field" => "Liste des groupes autorisés à voir ce champ",
"Separated by comma (,)" => "Séparé par une virgule (,)",
"Editable by" => "Éditable par",
"List of Group names with permission to edit this field" => "Liste des groupes autorisés à modifier ce champ",
"Changing the permanent name may have consequences in integrated systems" => "Modifier le nom permanent peut avoir des conséquences dans le système intégré",
// "Changing the field type may cause irretrievable data loss - use with caution" => "Changing the field type may cause irretrievable data loss - use with caution",
"Make sure you rebuild the search index if you change field type" => "Assurez-vous de reconstruire l'index de recherche si vous modifiez le type de champ",
// "Deprecated" => "Deprecated",
// "To export tracker or tracker items please" => "To export tracker or tracker items please",
// "enable" => "enable",
// "and use" => "and use",
// "Tracker Tabular" => "Tracker Tabular",
// "It is easy to use, optimised and far more powerful" => "It is easy to use, optimised and far more powerful",
"Export Tracker Items" => "Exporter les fiches du formulaire",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
"Delimitor (left)" => "Délimiteur (gauche)",
"Delimitor (right)" => "Délimiteur (droit)",
"Carriage return inside field value" => "Retour charriot à l'intérieur d'une valeur de champ",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
// "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
"Parse as wiki text" => "Analyser comme texte wiki",
// "Generic information" => "Generic information",
"Number of records" => "Nombre d'enregistrements",
// "First record" => "First record",
"Quick Export" => "Export rapide",
// "Produce a CSV with basic formatting" => "Produce a CSV with basic formatting",
// "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'" => "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'",
// "Tracker Export" => "Tracker Export",
// "Copy the definition text above and paste into the Import Structure box for a new tracker" => "Copy the definition text above and paste into the Import Structure box for a new tracker",
// "Profile Export" => "Profile Export",
// "Produce YAML for a profile" => "Produce YAML for a profile",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
"For example: \$profileobject:field_ref\$" => "Par exemple : \$profileobject:field_ref\$",
// "Export Profile" => "Export Profile",
"Fields Export" => "Exporter",
// "Copy the definition text above and paste into the Import Fields box on a tracker's fields page" => "Copy the definition text above and paste into the Import Fields box on a tracker's fields page",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
"Raw data" => "Données brutes",
"Preserve tracker ID" => "Préserver l'ID de formulaire",
// "Use \"Tracker -> Export -> Structure\" to produce this data" => "Use \"Tracker -> Export -> Structure\" to produce this data",
// "Tracker import completed" => "Tracker import completed",
// "Return to Trackers" => "Return to Trackers",
"Import fields for this tracker" => "Importer des champs pour ce formulaire",
"Raw Fields" => "Champs bruts",
"Preserve Field IDs" => "Conserver les ids des champs",
"Confirmation" => "Confirmation",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "To import items into a tracker please" => "To import items into a tracker please",
"The order of the fields does not matter, but you need to add a header with the field names" => "L'ordre des champs n'a pas d'importance, mais vous devez ajouter une en-tête avec les noms de champs",
// "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import" => "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import",
"Auto-incremented itemid fields shall be included with no matter what values" => "Les champs avec ID de fiche auto-incrémenté seront inclus sans considération de leurs valeurs",
// "If you are having problems, try a different line ending for your csv file that matches the server operating system" => "If you are having problems, try a different line ending for your csv file that matches the server operating system",
// "UNIX Timestamp" => "UNIX Timestamp",
"Character encoding" => "Codage des caractères",
// "Create as new items" => "Create as new items",
"Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Mettre à jour la date de dernière modification si la ficher est mise à jour (le status et la date de création son mise à jour uniquement si ils sont présent dans le CSV)",
// "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance" => "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance",
// "Please note: This is an experimental new feature - work in progress" => "Please note: This is an experimental new feature - work in progress",
// "YAML" => "YAML",
// "Create another" => "Create another",
// "Do you really want to remove the \"%0\" tracker" => "Do you really want to remove the \"%0\" tracker",
// "Please note" => "Please note",
// "This tracker, its fields and all of its %0 items will be permanently removed from your system" => "This tracker, its fields and all of its %0 items will be permanently removed from your system",
"Are you sure you want to remove the fields? Data will be lost" => "Êtes-vous sûr(e) de vouloir supprimer les champs ? Les données seront perdues",
"Remove Fields" => "Supprimer les champs",
// "Return to field administration" => "Return to field administration",
// "Replacement" => "Replacement",
// "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one" => "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one",
"Description is wiki-parsed" => "La description utilise la syntaxe wiki",
// "Field Prefix" => "Field Prefix",
"Allow ratings (deprecated, use rating field)" => "Permettre les cotations (obsolète, utiliser le champ Cote)",
"Rating options" => "Options de cotation",
"Show ratings in listing" => "Afficher les cotations en mode liste",
"Show comments in listing" => "Afficher les commentaires en mode liste",
"Display last comment author and date" => "Afficher l'auteur du dernier commentaire et la date",
// "Allow attachments (deprecated, use files field)" => "Allow attachments (deprecated, use files field)",
"Display attachments in listing" => "Afficher les pièces jointes en mode liste",
"Attachment attributes (sortable)" => "Attributs pièces jointes (triable)",
// "Recommended size: 64x64px" => "Recommended size: 64x64px",
"Show status to tracker administrator only" => "Afficher le statut uniquement à l'administrateur du formulaire",
"Show creation date when listing items" => "Afficher la date de création dans les listes de fiches",
"Creation date format" => "Format de la date de création",
"Show item creator" => "Afficher le créateur de la fiche",
"Show creation date when viewing items" => "Afficher la date de création en visualisation des fiches",
"Show last modification date when listing items" => "Afficher la date de dernière modification dans les listes de fiches",
"Show item last modifier" => "Afficher le dernier modificateur de la fiche",
"Modification date format" => "Format de la date de modification",
"Show last modification date when viewing items" => "Afficher la date de dernière modification en visualisation des fiches",
"Hide empty fields from item view" => "Ne pas afficher les champs vides en visualisation de fiche",
"List detail popup" => "Affichage popup en survol de liste",
// "Section Format" => "Section Format",
// "Section format" => "Section format",
// "Determines how headers will be rendered when using header fields as form section dividers" => "Determines how headers will be rendered when using header fields as form section dividers",
// "Set to <em>Configured</em> to use the four following fields" => "Set to <em>Configured</em> to use the four following fields",
// "Use Form Classes" => "Use Form Classes",
// "Input Form Classes" => "Input Form Classes",
// "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)" => "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)",
"Template to display an item" => "Gabarit pour afficher une fiche",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:nomdelapage pour une page wiki ou tpl:nomdutemplate pour un modèle",
"Template to edit an item" => "Gabarit pour modifier une fiche",
"New item status" => "Nouveau statut de la fiche",
"Modified item status" => "Statut de la fiche modifié",
"No change" => "Aucun changement",
"Default status displayed in list mode" => "État par défaut affiché en mode liste",
"Copy activity to email" => "Copier l'activité vers un courriel",
"Use simplified email format" => "Utiliser un format email simplifié",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "Le formulaire utilisera le champ de texte nommé 'Subject' si il existe, le courriel de l'utilisateur si il existe, ou pour un anonyme, le champ 'email' de la fiche si il existe",
"Publish RSS feed for this tracker" => "Publier un flux RSS de ce formulaire",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
"Group alerted on item modification" => "Groupe alerté si modification de fiche",
"Allow user selection for small groups" => "Autoriser la sélection d'utilsateur pour les petits groupes",
// "User can see his own items" => "User can see his own items",
// "The tracker needs a user field with the item-owner activated" => "The tracker needs a user field with the item-owner activated",
// "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user" => "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user",
"Item creator can modify his items" => "Le créateur de la fiche a le droit de modifier ses fiches",
"The tracker needs a user field with the auto-assign activated" => "Le formulaire nécessite un champ utilisateur avec l'option auto-assignation activée",
// "Item creator can remove his items" => "Item creator can remove his items",
"User can take ownership of item created by anonymous" => "L'utilisateur peut s'approprier une fiche créée par un anonyme",
"Only one item per user or IP" => "Une seule fiche par utilisateur ou IP",
// "The tracker needs a user or IP address field with the auto-assign set to Creator" => "The tracker needs a user or IP address field with the auto-assign set to Creator",
"Members of the creator group can modify items" => "Les membres du groupe créateur peuvent modifier les fiches",
"The tracker needs a group field with the auto-assign activated" => "Le formulaire nécessite un champ groupe avec l'option auto-assignation activée",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Restrict non admins to wiki page access only" => "Restrict non admins to wiki page access only",
// "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports" => "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports",
"Creation date constraint" => "Contraindre la date de création",
// "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below" => "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below",
"Before" => "Avant",
"Auto-create corresponding categories" => "Auto-créer les catégories correspondantes",
"Create a group for each item" => "Créer un groupe pour chaque fiche",
"Groups will include" => "Les groupes inclueront",
"Creator is assigned to the group" => "Le créateur est assigné au groupe",
"Will become the creator's default group" => "Deviendra le groupe par défaut du créateur",
"Will become the new item's group creator" => "Deviendra le créateur du groupe des nouvelles fiches",
"Copy the default group in the field ID before updating the group" => "Copier le groupe par défaut dans l'ID du champ avant de mettre à jour le groupe",
"Non Advanced Search or Natural Search" => "Recherche non avancée ou 'naturelle'",
"Advanced Search or Boolean Search" => "Recherche Avancée ou Booléenne",
"Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Les objets qui contiennent le plus de termes sont classés plus haut dans les résultats et apparaitront en première position de leurs types",
"objects that include both terms" => "objets qui contiennent tous les termes",
// "Requiring terms" => "Requiring terms",
"Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Ajouter un signe plus ( + ) devant un terme pour indiquer que ce terme <em>doit</em> apparaître dans les résultats",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
"Excluding terms" => "Exclure des termes",
"Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Ajouter un signe moins ( - ) devant un terme pour indiquer que ce terme <em>ne doit pas</em> apparaître dans les résultats",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed" => "Encadrer la phrase par des guillemets ( <kbd>\" \"</kbd> ) pour trouver les termes en ordre exact, exactement comme tapés",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Exemple : <kbd>\"Alex Bell\"</kbd> ne trouvera pas <strong>Bell Alex</strong> ou <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
"Add an asterisk ( * ) after a term to find objects that include the root word" => "Ajouter un astérisque (*) après un terme pour trouver les objets qui incluent la racine du mot",
"For example, <strong>run*</strong> will find" => "Par exemple, <strong>run*</strong> retrouvera",
"objects that include the term <strong>run</strong>" => "objets qui contiennent le terme <strong>run</strong>",
"objects that include the term <strong>runner</strong>" => "objets qui contiennent le terme <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
"Reducing a term's value" => "Réduire l'importance d'un mot",
"Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Ajouter un tilde ( ~ ) devant un terme pour réduire sa valeur à indiquer pour le classement des résultats",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)",
"Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>" => "Exemple : <strong>+wiki ~forum</strong> évaluera un objet avec seulement <strong>wiki</strong> plus qu'un objet avec <strong>wiki</strong> et  <strong>forum</strong>",
"Changing relevance value" => "Changer la valeur de pertinence",
"Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Ajouter un signe inférieur  ( &lt; ) ou supérieur ( &gt; ) avant un terme pour changer la contribution de ce terme à la pertinence globale assignée à un objet",
"Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Exemple : <strong>+wiki +(&gt;forum &lt; blog)</strong> trouvera des objets qui continnent <strong>wiki</strong> et <strong>forum</strong> ou <strong>wiki</strong> et <strong>blog</strong> dans n'importe quel ordre. <strong>wiki forum</strong> sera mieux classé",
// "{\$confirmation_message}" => "{\$confirmation_message}",
// "\"}Are you sure you want to set this %0 to \"open\"" => "\"}Are you sure you want to set this %0 to \"open\"",
// "\"}Are you sure you want to set this %0 to \"pending\"" => "\"}Are you sure you want to set this %0 to \"pending\"",
// "\"}Are you sure you want to set this %0 to \"closed\"" => "\"}Are you sure you want to set this %0 to \"closed\"",
// "{\$field.name|truncate:65|escape}" => "{\$field.name|truncate:65|escape}",
"Hold \"Ctrl\" in order to select multiple values" => "Tenir \"Ctrl\" pour sélectionner des valeurs multiples",
// "{\$field_name}" => "{\$field_name}",
// "{\$description}" => "{\$description}",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
"Admin Fields" => "Administrer les champs",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
"Search for trackers to clone" => "Rechercher des formulaires à dupliquer",
"After" => "Après",
"Do you really want to remove the scheduled event" => "Voulez-vous réellement supprimer l'événement programmé",
// "Remove event" => "Remove event",
// "No events registered" => "No events registered",
// "Reference date" => "Reference date",
"After creation" => "Après création",
"After last modification" => "Après la dernière modification",
// "Delay prior to status change" => "Delay prior to status change",
"Mail subject text" => "Sujet du mail",
"Mail body ressource" => "Ressource pour le corps du mail",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:NomdelaPage pour une page wiki  ou tplName.tpl pour un modèle",
// "Existing Article" => "Existing Article",
// "Article URL" => "Article URL",
"(automatically generated after item creation)" => "(généré automatiquement après la création)",
// "Change Event" => "Change Event",
"Attached files limitation" => "Limitation des pièces jointes",
"The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved" => "Le nombre de fichiers qui peuvent être attachés est limité à <strong>%0</strong>. Les fichiers les plus récents seront conservés",
"Browse files" => "Parcourir la liste des fichiers",
"Browse Files" => "Parcourir la liste des fichiers",
// "Link to existing Vimeo URL" => "Link to existing Vimeo URL",
"Type or paste the URL and press ENTER" => "Saisir l'URL et appuyer sur ENTRÉE",
// "You do not have permission to upload files to this gallery" => "You do not have permission to upload files to this gallery",
// "You do not have permission to add a member to a group" => "You do not have permission to add a member to a group",
"Select Icon" => "Selectionner l'icône",
// "Remove image" => "Remove image",
"Are you sure you want to delete this image" => "Etes-vous sûr de vouloir effacer cette image",
// "{\$field.options_map.addItems|escape}" => "{\$field.options_map.addItems|escape}",
// "Add Media" => "Add Media",
"Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19" => "Format: x,y,zoom où x est la longitude, et y la latitude. Zoom est entre 0 (voir la Terre) et 19",
// "This bug has been demonstrated on {\$field.options_map.domain|escape}" => "This bug has been demonstrated on {\$field.options_map.domain|escape}",
// "Please demonstrate your bug on {\$field.options_map.domain|escape}" => "Please demonstrate your bug on {\$field.options_map.domain|escape}",
// "Bug needs to be created first" => "Bug needs to be created first",
// "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created" => "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created",
// "Show.tiki.org snapshot creation is in progress" => "Show.tiki.org snapshot creation is in progress",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"",
// "Password reset" => "Password reset",
// "Password reset was successful" => "Password reset was successful",
// "Password reset failed" => "Password reset failed",
// "Show.tiki.org instance destruction in progress" => "Show.tiki.org instance destruction in progress",
// "Show.tiki.org instance destruction is in progress... Please wait.." => "Show.tiki.org instance destruction is in progress... Please wait..",
// "Show.tiki.org is not configured properly" => "Show.tiki.org is not configured properly",
// "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks" => "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks",
// "Show.tiki.org is currently unavailable" => "Show.tiki.org is currently unavailable",
// "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Show.tiki.org is under maintenance" => "Show.tiki.org is under maintenance",
// "Show.tiki.org is currently under maintenance. Sorry for the inconvenience" => "Show.tiki.org is currently under maintenance. Sorry for the inconvenience",
// "Unable to get information from {\$field.options_map.domain|escape}" => "Unable to get information from {\$field.options_map.domain|escape}",
// "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Instance is being created" => "Instance is being created",
// "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks" => "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks",
// "About {\$field.options_map.domain|escape}" => "About {\$field.options_map.domain|escape}",
// "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}" => "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}",
// "Create {\$field.options_map.domain|escape} instance" => "Create {\$field.options_map.domain|escape} instance",
// "Accessing the Tiki instance that demonstrates this bug" => "Accessing the Tiki instance that demonstrates this bug",
// "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0" => "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"",
// "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0" => "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0",
// "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload" => "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload",
// "Snapshots" => "Snapshots",
// "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation" => "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0",
// "Create new snapshot" => "Create new snapshot",
// "Destroy this {\$field.options_map.domain|escape} instance" => "Destroy this {\$field.options_map.domain|escape} instance",
// "Reset password to 12345" => "Reset password to 12345",
// "SVN update" => "SVN update",
// "Debug Mode Information" => "Debug Mode Information",
// "Get instance information and refresh cache" => "Get instance information and refresh cache",
// "Filter by group" => "Filter by group",
// "Select user(s)" => "Select user(s)",
// "View stand alone wiki page" => "View stand alone wiki page",
// "Source of wiki page" => "Source of wiki page",
// "History of wiki page" => "History of wiki page",
// "No articles" => "No articles",
"Administrator intervention required" => "Intervention de l'administrateur requise",
// "Tags is not enabled" => "Tags is not enabled",
"LastModif" => "dernière modif.",
"You did not vote yet" => "Vous n'avez pas encore voté",
"My rating" => "Mon classement",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "Cliquer pour voter pour cette valeur",
// "Remove your rating" => "Remove your rating",
// "%0 element(s)" => "%0 element(s)",
// "Language: %0" => "Language: %0",
// "You have subscribed" => "You have subscribed",
"You have not yet subscribed" => "Vous n'êtes pas encore inscrit",
"with" => "avec",
"friends" => "amis",
// "Translation.." => "Translation..",
// "No language assigned" => "No language assigned",
// "Set page language" => "Set page language",
// "Set article language" => "Set article language",
"Current language" => "Langue actuelle",
// "Show all translations of this page on a single page" => "Show all translations of this page on a single page",
"All languages" => "Toutes les langues",
// "Machine translations" => "Machine translations",
// "Translate page" => "Translate page",
// "Manage page translations" => "Manage page translations",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
"Are you sure you want to detach these translations" => "Êtes-vous sûr(e) de vouloir détacher ces traductions",
"Current translation set" => "Jeu de traduction actuel",
// "Detach translation" => "Detach translation",
"Are you sure you want to detach the translation" => "Êtes-vous sûr(e)e de vouloir détacher la traduction",
"No translations available at this time" => "Pas de traduction disponible pour le moment",
"Add a new object to the set" => "Ajouter un nouvel objet à l'ensemble",
"All possible translations exist" => "Toutes les traductions possibles existent",
// "Email this wiki page" => "Email this wiki page",
// "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki" => "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki",
// "Bcc" => "Bcc",
// "Enter a valid email to send a blind copy to (optional)" => "Enter a valid email to send a blind copy to (optional)",
// "%0 away" => "%0 away",
// "Shared groups" => "Shared groups",
// "Friendship" => "Friendship",
// "Add to or remove from" => "Add to or remove from",
// "Add to" => "Add to",
// "Remove from" => "Remove from",
// "These groups" => "These groups",
// "Use Ctrl+Click or Command+Click to select multiple options" => "Use Ctrl+Click or Command+Click to select multiple options",
// "Set default group" => "Set default group",
// "Remove users" => "Remove users",
// "Remove the users' pages" => "Remove the users' pages",
// "Remove the user pages belonging to these users" => "Remove the user pages belonging to these users",
// "Delete user items from these trackers" => "Delete user items from these trackers",
// "Warning: Experimental" => "Warning: Experimental",
// "Select trackers here to have items in them which are \"owned\" by these users deleted" => "Select trackers here to have items in them which are \"owned\" by these users deleted",
// "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically" => "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically",
// "Delete user files" => "Delete user files",
// "Delete the users' file galleries and all the files in them" => "Delete the users' file galleries and all the files in them",
// "Ban users" => "Ban users",
// "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning" => "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning",
// "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided" => "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided",
// "Cancel login process" => "Cancel login process",
// "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login" => "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login",
// "Birth date" => "Birth date",
// "Validate your age and proceed to login" => "Validate your age and proceed to login",
// "I approve the above terms and conditions" => "I approve the above terms and conditions",
// "I Decline, log out" => "I Decline, log out",
"However, no account is associated to the OpenID identifier." => "Cependant, aucun compte n'est associé avec l'identifiant.",
"If you use an email filter, be sure to add %0 to your accepted list" => "Si vous utilisez un filtre de courriel, vérifiez d'avoir ajouté %0 à votre liste d'autorisations",
"Associate OpenID with an existing Tiki account" => "Associer l'OpenID avec un compte Tiki existant",
// "Browse for video file to upload" => "Browse for video file to upload",
// "Upload Progress" => "Upload Progress",
// "Vimeo Setup Error" => "Vimeo Setup Error",
// "{\$errMsg}" => "{\$errMsg}",
// "Available space: %0 megabytes" => "Available space: %0 megabytes",
// "No standard definition uploads available currently" => "No standard definition uploads available currently",
// "No high definition uploads available currently" => "No high definition uploads available currently",
// "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines" => "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines",
// "You will also need to rebuild your caches and search index" => "You will also need to rebuild your caches and search index",
// "Re-generate URLs" => "Re-generate URLs",
// "The following item(s) include page(s) being deleted and will break" => "The following item(s) include page(s) being deleted and will break",
// "Remove {\$idesc}" => "Remove {\$idesc}",
// "Create redirect" => "Create redirect",
// "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)" => "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)",
// "Redirect to" => "Redirect to",
"Use this thread to discuss the page" => "Utilisez ce fil de discussion pour discuter sur la page",
"Missing or incorrect trackerId parameter for the plugin." => "Paramètre incorrect ou manquant pour le plugiciel.",
"List Trackers" => "Liste des formulaires",
"resource day" => "Ressource par jour",
"resource month" => "Ressource par mois",
// "resource year" => "resource year",
"resource week" => "Ressource par semaine",
// "list day" => "list day",
// "list month" => "list month",
// "list year" => "list year",
// "list week" => "list week",
"list" => "liste",
// "agenda month" => "agenda month",
// "agenda week" => "agenda week",
// "agenda day" => "agenda day",
// "{\$params.label|escape}" => "{\$params.label|escape}",
"Subtract" => "Soustraire",
// "Meeting ID" => "Meeting ID",
"Current attendees" => "Participants actuels",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "Current recordings" => "Current recordings",
// "On %0 from %1 to %2" => "On %0 from %1 to %2",
// "This will permanently remove the recording" => "This will permanently remove the recording",
// "(including audio recording & chat log)" => "(including audio recording & chat log)",
// "{\$button_label}" => "{\$button_label}",
// "{\$moretext|escape}" => "{\$moretext|escape}",
// "{\$ftptitle}" => "{\$ftptitle}",
// "No permission to change the following task" => "No permission to change the following task",
// "Project update not possible as you lack rights for updating a parent project" => "Project update not possible as you lack rights for updating a parent project",
// "Start date is a milestone" => "Start date is a milestone",
// "End date is a milestone" => "End date is a milestone",
// "Task has constraints" => "Task has constraints",
// "Error: there is a dependency on an open task" => "Error: there is a dependency on an open task",
// "Error: due to a descendant of a closed task" => "Error: due to a descendant of a closed task",
// "This task has external dependencies" => "This task has external dependencies",
// "GANNT_ERROR_LOADING_DATA_TASK_REMOVED" => "GANNT_ERROR_LOADING_DATA_TASK_REMOVED",
// "Cannot depend on ancestors" => "Cannot depend on ancestors",
// "The data inserted are invalid for the field format" => "The data inserted are invalid for the field format",
// "An error has occurred while loading the data. A task has been trashed" => "An error has occurred while loading the data. A task has been trashed",
// "Cannot close a task with open issues" => "Cannot close a task with open issues",
// "You cannot exchange tasks of different depth" => "You cannot exchange tasks of different depth",
// "Sem" => "Sem",
// "Cannot move task" => "Cannot move task",
// "Please save your project" => "Please save your project",
// "Error: date settings" => "Error: date settings",
// "Cannot depend on descendants" => "Cannot depend on descendants",
// "code/short name" => "code/short name",
// "start" => "start",
// "dur" => "dur",
// "depe" => "depe",
// "assignees" => "assignees",
// "completed" => "completed",
// "suspended" => "suspended",
// "undefined" => "undefined",
// "Task editor" => "Task editor",
// "is milestone" => "is milestone",
// "status" => "status",
// "progress" => "progress",
// "Assignments" => "Assignments",
// "Role" => "Role",
// "est.wklg" => "est.wklg",
"Number of Users" => "Nombre d'utilisateurs",
"Percentage of Total" => "Pourcentage du total",
// "Email address of invitee" => "Email address of invitee",
"Set in these groups" => "Définir dans ces groupes",
// "Number of result" => "Number of result",
"Message sent to" => "Message envoyé à",
"Email sent to" => "Courriel envoyé à",
// "recipients" => "recipients",
// "Message preview" => "Message preview",
// "Number of Recipients" => "Number of Recipients",
"Send Mail" => "Envoyer le courriel",
"Send to users" => "Envoyer aux utilisateurs",
"Send to" => "Envoyer à",
"Email address (if more than one, separated by \",\")" => "Email séparé par des virgules",
"Send to groups" => "Envoyer aux groupes",
"Preview Mail" => "Prévisualiser le courriel",
// "You will receive a copy of the email yourself. Please give it a few minutes" => "You will receive a copy of the email yourself. Please give it a few minutes",
// "Please wait while your email is being sent.." => "Please wait while your email is being sent..",
// "Previous npm-asset/pdfjs-dist package has been deprecated" => "Previous npm-asset/pdfjs-dist package has been deprecated",
// "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package" => "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package",
"Check to remove" => "Cocher pour supprimer",
// "Contents of email to be sent to user" => "Contents of email to be sent to user",
// "Append custom message" => "Append custom message",
// "Approve user" => "Approve user",
// "Reject user" => "Reject user",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
"Join myself" => "Me joindre",
"Leave myself" => "Me retirer",
"Cost for one period" => "Coût pour une période",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
"Prorated cost for first period" => "Coût proratisé pour la prémière période",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 for %2 %3" => "Membership to %0 for %1 for %2 %3",
"separated by |" => "séparé par |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "vs" => "vs",
// "Mine" => "Mine",
// "Save Changes" => "Save Changes",
// "Edit Pivot Table" => "Edit Pivot Table",
// "Click to view interactive SCORM learning object" => "Click to view interactive SCORM learning object",
// "Download original file" => "Download original file",
"Re-Apply" => "Re-Appliquer",
"wrote" => "écrit",
// "{\$wp_emptymsg}" => "{\$wp_emptymsg}",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
"Last Day" => "Le jour passé",
"Last Week" => "La semaine dernière",
// "{\$action}" => "{\$action}",
"Groups you are in" => "Groupes dans lesquels vous êtes",
"(This is an included group)" => "(Ceci est un groupe inclus)",
// "(You are a leader)" => "(You are a leader)",
"Your default group" => "Votre groupe par défaut",
"Leave Group" => "Quitter le groupe",
"Manage Group" => "Gérer le groupe",
"Change default group" => "Changer le groupe par défaut",
"Subscribe to a group" => "S'inscrire dans un groupe",
"Groups you can join" => "Groupes que vous pouvez rejoindre",
"This group requires approval to join" => "Ce groupe nécessite une approbation pour le rejoindre",
// "Subscribe to groups" => "Subscribe to groups",
"Subscription confirmed!" => "Votre inscription est confirmée!",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Mini TimeSheet" => "Mini TimeSheet",
// "Full View" => "Full View",
// "End tour" => "End tour",
// "-- Choose an option --" => "-- Choose an option --",
// "{\$export_action}" => "{\$export_action}",
"Map View" => "Vue Carte",
// "Field error" => "Field error",
"Stop Monitor" => "Arrêter la surveillance",
// "Tracker - " => "Tracker - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
// "Close item" => "Close item",
// "Open item" => "Open item",
// "Pend item" => "Pend item",
// "{\$params.label}" => "{\$params.label}",
"Please login first" => "Merci de vous identifier d'abord",
"Toggle display" => "Afficher/cacher l'affichage",
// "Page approved by %0 on %1" => "Page approved by %0 on %1",
"Page last modified on %0 by %1" => "Page dernièrement modifiée le %0 par %1",
"Created by %0" => "Créé par %0",
"Last Modification: %0 by %1" => "Dernière modification : %0 par %1",
"Save the page as a partial translation." => "Enregistrer la page comme une traduction partielle.",
"Partial Translation" => "Traduction partielle",
"Save the page as a completed translation." => "Enregistrer la page comme une traduction complète.",
"Complete Translation" => "Traduction complète",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Enregistrer la page sans envoi de notification par courrier. Ne pas enregistrer le contenu comme à être traduit.",
"Save Minor Edit" => "Enreg. modif. mineure",
"Save the page." => "Enregistrer la page.",
// "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions" => "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions",
// "Workspaces UI in doc.tiki.org" => "Workspaces UI in doc.tiki.org",
// "Enable using the same wiki page name in different contexts" => "Enable using the same wiki page name in different contexts",
// "E.g. ns1:_:MyPage and ns2:_:MyPage" => "E.g. ns1:_:MyPage and ns2:_:MyPage",
// "Workspaces & Areas admin panel" => "Workspaces & Areas admin panel",
// "Automatic table of contents for a wiki page" => "Automatic table of contents for a wiki page",
// "Auto TOC options" => "Auto TOC options",
// "Auto TOC" => "Auto TOC",
// "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc" => "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc",
// "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu" => "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu",
// "Set up categories here" => "Set up categories here",
// "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages" => "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages",
// "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there" => "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there",
// "Configure general user & community features and settings related to sharing and social networks" => "Configure general user & community features and settings related to sharing and social networks",
// "Add a <b>User and Registration tracker</b>" => "Add a <b>User and Registration tracker</b>",
// "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users" => "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users",
// "Some uses of this type of tracker could be" => "Some uses of this type of tracker could be",
// "To collect user information (such as mailing address or phone number)" => "To collect user information (such as mailing address or phone number)",
// "To require the user to acknowledge a user agreement" => "To require the user to acknowledge a user agreement",
// "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)" => "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)",
// "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually" => "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually",
// "apply profile now" => "apply profile now",
// "new window" => "new window",
// "To set up the <strong>User Watches</strong> and their associated settings, visit the page to " => "To set up the <strong>User Watches</strong> and their associated settings, visit the page to ",
// "Community General Settings" => "Community General Settings",
// "admin panel" => "admin panel",
// "in doc.tiki.org" => "in doc.tiki.org",
// "Sharing & Networking" => "Sharing & Networking",
// "Social Network" => "Social Network",
// "Friendship and Followers" => "Friendship and Followers",
// "Set the site time zone and format for displaying dates and times" => "Set the site time zone and format for displaying dates and times",
// "Date and Time options" => "Date and Time options",
// "Date and Time admin panel" => "Date and Time admin panel",
// "Select editor type" => "Select editor type",
// "Only Plain Text Editor (Disable Wysiwyg)" => "Only Plain Text Editor (Disable Wysiwyg)",
// "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>" => "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>",
// "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page" => "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page",
// "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor" => "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor",
// "Set up the main Tiki features. The wiki and file gallery features are always enabled" => "Set up the main Tiki features. The wiki and file gallery features are always enabled",
// "Main Tiki features" => "Main Tiki features",
// "Tiki has many more features" => "Tiki has many more features",
// "Global Features" => "Global Features",
// "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made" => "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made",
// "Set up the file gallery and attachments" => "Set up the file gallery and attachments",
// "Choose to store them either in the database or in files on disk, among other options" => "Choose to store them either in the database or in files on disk, among other options",
// "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder" => "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder",
// "elFinder" => "elFinder",
// "Wiki admin panel" => "Wiki admin panel",
// "File storage" => "File storage",
// "Set elFinder as the default file gallery viewer" => "Set elFinder as the default file gallery viewer",
// "File Gallery storage" => "File Gallery storage",
// "Attachment storage" => "Attachment storage",
// "Select the site language" => "Select the site language",
// "Language options" => "Language options",
// "Configure the log-in, registration and validation preferences for the new accounts" => "Configure the log-in, registration and validation preferences for the new accounts",
// "Registration and log-in options" => "Registration and log-in options",
// "Login admin panel" => "Login admin panel",
// "Configure the Tiki theme and other look & feel preferences" => "Configure the Tiki theme and other look & feel preferences",
// "Look & Feel options" => "Look & Feel options",
// "Look & Feel admin panel" => "Look & Feel admin panel",
// "Namespace settings" => "Namespace settings",
// "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>" => "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>",
// "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)" => "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)",
// "Basic Search" => "Basic Search",
// "Uses MySQL full-text search" => "Uses MySQL full-text search",
// "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below" => "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below",
// "Advanced Search" => "Advanced Search",
// "Uses Unified Search Index with a specified search engine" => "Uses Unified Search Index with a specified search engine",
// "If you have issues with Advanced Search, simply revert to Basic Search" => "If you have issues with Advanced Search, simply revert to Basic Search",
// "Unified Search is required by a number of other features, e.g. the community friendship network" => "Unified Search is required by a number of other features, e.g. the community friendship network",
// "Other settings" => "Other settings",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "Search admin card" => "Search admin card",
// "Search in doc.tiki.org" => "Search in doc.tiki.org",
// "Hierarchical organization of wiki pages" => "Hierarchical organization of wiki pages",
// "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage" => "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage",
// "Structures options" => "Structures options",
// "Set up the text area environment (Editing and Plugins)" => "Set up the text area environment (Editing and Plugins)",
// "Editing and plugins admin panel" => "Editing and plugins admin panel",
// "Set up the Wiki environment" => "Set up the Wiki environment",
// "Wiki environment" => "Wiki environment",
// "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar" => "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar",
// "Requires Java" => "Requires Java",
// "Verify your Java installation" => "Verify your Java installation",
// "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages" => "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages",
// "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>" => "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>",
// "Get Started" => "Get Started",
// "Congratulations! You now have a working instance of Tiki %0" => "Congratulations! You now have a working instance of Tiki %0",
// "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below" => "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below",
// "Mouse over the icons to know more about the features and preferences that are new for you" => "Mouse over the icons to know more about the features and preferences that are new for you",
"Example: " => "Exemple : ",
// "Help icon" => "Help icon",
// "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it" => "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it",
// "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic" => "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic",
// "Configuration Profiles Wizard" => "Configuration Profiles Wizard",
// "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>" => "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>",
// "They are like the <b>Macros</b> from many computer languages" => "They are like the <b>Macros</b> from many computer languages",
// "It is best to apply them from the start and you can always preview and reverse the process" => "It is best to apply them from the start and you can always preview and reverse the process",
// "Configuration Profiles" => "Configuration Profiles",
// "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you" => "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you",
// "If you are new to Tiki administration, we recommend that you start with this approach" => "If you are new to Tiki administration, we recommend that you start with this approach",
// "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below" => "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below",
// "Start Configuration Profiles Wizard (Macros)" => "Start Configuration Profiles Wizard (Macros)",
// "Configuration Walkthrough" => "Configuration Walkthrough",
// "Alternatively, you may use the <b>Configuration Wizard</b>" => "Alternatively, you may use the <b>Configuration Wizard</b>",
// "This will guide you through the most common preference settings in order to customize your site" => "This will guide you through the most common preference settings in order to customize your site",
// "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc" => "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc",
// "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further" => "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further",
// "Start Configuration Wizard" => "Start Configuration Wizard",
// "Or you may use the <b>Changes Wizard</b>" => "Or you may use the <b>Changes Wizard</b>",
// "This will guide you through the most common new settings and informations in order to upgrade your site" => "This will guide you through the most common new settings and informations in order to upgrade your site",
// "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version" => "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version",
// "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels" => "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels",
// "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site" => "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site",
// "Start Changes Wizard" => "Start Changes Wizard",
// "Use the <b>Control Panels</b> to manually browse through the full list of preferences" => "Use the <b>Control Panels</b> to manually browse through the full list of preferences",
// "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings" => "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings",
// "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with" => "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with",
// "Explore the control panels and configure your Tiki manually" => "Explore the control panels and configure your Tiki manually",
// "Go to the Control Panels" => "Go to the Control Panels",
// "You can check if your server meets the requirements for running Tiki version %0" => "You can check if your server meets the requirements for running Tiki version %0",
// "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly" => "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly",
// "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback" => "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback",
// "Check your server fitness" => "Check your server fitness",
// "Go to the Tiki Server Compatibility Check" => "Go to the Tiki Server Compatibility Check",
// "You are done with the admin wizard" => "You are done with the admin wizard",
// "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin" => "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user",
// "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were" => "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were",
// "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode" => "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode",
// "Wysiwyg editor" => "Wysiwyg editor",
// "Select the Wysiwyg editor mode" => "Select the Wysiwyg editor mode",
// "Compatible Wiki mode" => "Compatible Wiki mode",
// "Use wiki syntax for saved pages" => "Use wiki syntax for saved pages",
// "This is the most compatible with Tiki functionality and the most stable editor mode" => "This is the most compatible with Tiki functionality and the most stable editor mode",
// "Tools and functions in the editor toolbar will be limited" => "Tools and functions in the editor toolbar will be limited",
// "HTML mode" => "HTML mode",
// "Use HTML syntax for saved pages" => "Use HTML syntax for saved pages",
// "Best compatibility with inline editing" => "Best compatibility with inline editing",
// "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL" => "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL",
// "Full editor toolbar" => "Full editor toolbar",
// "Wysiwyg admin panel" => "Wysiwyg admin panel",
// "Documentation site" => "Documentation site",
// "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>" => "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>",
// "To see it in full size out of this frame" => "To see it in full size out of this frame",
// "Main new features and settings in Tiki 13" => "Main new features and settings in Tiki 13",
// "Tiki13" => "Tiki13",
// "Tiki13 is a post-LTS version" => "Tiki13 is a post-LTS version",
// "It will be supported until 14.1 is released" => "It will be supported until 14.1 is released",
// "The requirements increased (IE9, PHP 5.5)" => "The requirements increased (IE9, PHP 5.5)",
// "Major changes have happened, including moving to Bootstrap" => "Major changes have happened, including moving to Bootstrap",
// "New Themes" => "New Themes",
// "Site layouts (based on 'Bootstrap')" => "Site layouts (based on 'Bootstrap')",
// "The changes in this area were refactored in Tiki 14" => "The changes in this area were refactored in Tiki 14",
// "Goal, Recognition and Rewards" => "Goal, Recognition and Rewards",
// "Main new features and settings in Tiki 14" => "Main new features and settings in Tiki 14",
// "Tiki14" => "Tiki14",
// "Tiki14 is a standard non-LTS version" => "Tiki14 is a standard non-LTS version",
// "It will be supported until 15.1 is released" => "It will be supported until 15.1 is released",
// "The requirements are the same as in the previous version (IE9, PHP 5.5)" => "The requirements are the same as in the previous version (IE9, PHP 5.5)",
// "Minor changes have happened, compared to post-LTS versions such as Tiki13" => "Minor changes have happened, compared to post-LTS versions such as Tiki13",
// "New modules" => "New modules",
// "A new module called <strong>Module zone</strong> was added" => "A new module called <strong>Module zone</strong> was added",
// "Module zone" => "Module zone",
// "New module meant to provide a horizontal 'navigation bar' for the website" => "New module meant to provide a horizontal 'navigation bar' for the website",
// "Tiki Addons" => "Tiki Addons",
// "Addons allow a way for developers to add an even broader range of functionality" => "Addons allow a way for developers to add an even broader range of functionality",
// "Addons" => "Addons",
// "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase" => "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase",
// "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki" => "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki",
// "Other new features" => "Other new features",
// "Improved and extended features" => "Improved and extended features",
// "See the full list of changes" => "See the full list of changes",
// "Main new features and settings in Tiki 15" => "Main new features and settings in Tiki 15",
// "Tiki15" => "Tiki15",
// "Tiki15 is an LTS version" => "Tiki15 is an LTS version",
// "As it is a Long-Term Support (LTS) version, it will be supported for 5 years" => "As it is a Long-Term Support (LTS) version, it will be supported for 5 years",
// "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended" => "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended",
// "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki" => "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki",
// "In Tiki 15, an addons repository was added" => "In Tiki 15, an addons repository was added",
// "New Wiki Plugins" => "New Wiki Plugins",
// "Social Networks with Linkedin" => "Social Networks with Linkedin",
// "Temporary User Accounts" => "Temporary User Accounts",
// "Display more information here" => "Display more information here",
// "You can use this feature through: " => "You can use this feature through: ",
// "Admin Users > Temporary Users (tab)" => "Admin Users > Temporary Users (tab)",
// "Statistics Control Panel" => "Statistics Control Panel",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "Console" => "Console",
// "There is a console.php command to set a scheduled batch upload cron task" => "There is a console.php command to set a scheduled batch upload cron task",
// "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)" => "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)",
// "Removed features" => "Removed features",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Main new and improved features and settings in Tiki 16" => "Main new and improved features and settings in Tiki 16",
// "Tiki16" => "Tiki16",
// "Tiki16 is a standard non-LTS version" => "Tiki16 is a standard non-LTS version",
// "It will be supported until 17.1 is released" => "It will be supported until 17.1 is released",
// "New PHP minimum requirement for Tiki 16 is PHP 5.6" => "New PHP minimum requirement for Tiki 16 is PHP 5.6",
// "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others" => "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others",
// "Tracker Force-Fill Feature" => "Tracker Force-Fill Feature",
// "Improved Fields" => "Improved Fields",
// "Improved Plugins and extended features" => "Improved Plugins and extended features",
// "There are a few new console.php commands to set scheduled cron tasks" => "There are a few new console.php commands to set scheduled cron tasks",
// "Filtering to Index-based Plugins" => "Filtering to Index-based Plugins",
// "Filter UI added in any wiki plugin using unified search index" => "Filter UI added in any wiki plugin using unified search index",
// "PDF Settings (Control Panel > Print)" => "PDF Settings (Control Panel > Print)",
// "New method to create PDF: mPDF" => "New method to create PDF: mPDF",
// "New Profiles" => "New Profiles",
// "Bug_Tracker_16" => "Bug_Tracker_16",
// "Execute on list" => "Execute on list",
// "GeoCMS_Maps" => "GeoCMS_Maps",
// "Work_Custom_Pricing" => "Work_Custom_Pricing",
// "Main new and improved features and settings in Tiki 17" => "Main new and improved features and settings in Tiki 17",
// "Tiki17" => "Tiki17",
// "Tiki17 is a standard non-LTS version" => "Tiki17 is a standard non-LTS version",
// "It will be supported until 18.1 is released" => "It will be supported until 18.1 is released",
// "Many libraries have been upgraded" => "Many libraries have been upgraded",
// "Improved Plugins" => "Improved Plugins",
// "HTTP Header Options" => "HTTP Header Options",
// "Intrusion Detection System (IDS) with Expose" => "Intrusion Detection System (IDS) with Expose",
// "Other new or Extended Features" => "Other new or Extended Features",
// "Preferences can be set" => "Preferences can be set",
// "One system cron job can trigger all required actions at their specific scheduled times" => "One system cron job can trigger all required actions at their specific scheduled times",
// "Main new and improved features and settings in Tiki 18" => "Main new and improved features and settings in Tiki 18",
// "Tiki18" => "Tiki18",
// "This is an LTS version" => "This is an LTS version",
// "New Features" => "New Features",
// "Composer Web Install (<b>Packages</b>)" => "Composer Web Install (<b>Packages</b>)",
// "Style guide tool" => "Style guide tool",
// "Look and feel colors can be customized with a style guide tool" => "Look and feel colors can be customized with a style guide tool",
// "PDF from URL: mPDF new settings" => "PDF from URL: mPDF new settings",
// "Other Extended Features" => "Other Extended Features",
// "Real-time collaboration tools (<b>RTC</b>)" => "Real-time collaboration tools (<b>RTC</b>)",
// "New actions can be performed" => "New actions can be performed",
// "Drag and drop added to menu management" => "Drag and drop added to menu management",
"Profiles" => "Profils",
// "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items" => "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items",
// "Calendars and Calendar Items will now appear in search results of the unified search index" => "Calendars and Calendar Items will now appear in search results of the unified search index",
// "Certain tracker fields can be converted keeping options" => "Certain tracker fields can be converted keeping options",
// "New Fields" => "New Fields",
// "Activity_Stream" => "Activity_Stream",
// "Simple_Forum" => "Simple_Forum",
// "Timesheets_Tracker" => "Timesheets_Tracker",
// "User_Profile_Business" => "User_Profile_Business",
// "Main new and improved features and settings in Tiki 19" => "Main new and improved features and settings in Tiki 19",
// "Tiki19" => "Tiki19",
// "It is a Standard Term Support (STS) version" => "It is a Standard Term Support (STS) version",
// "It will be supported until Tiki 20.1 is released" => "It will be supported until Tiki 20.1 is released",
// "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones" => "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones",
// "Federation" => "Federation",
// "Other New Features" => "Other New Features",
// "Added a preview button in tracker field files to enable pdf view in new window without download document" => "Added a preview button in tracker field files to enable pdf view in new window without download document",
// "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item" => "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item",
// "Create tracker from File" => "Create tracker from File",
// "GanttChart" => "GanttChart",
// "Hide Fixed Top Nav Bar on Scroll 19" => "Hide Fixed Top Nav Bar on Scroll 19",
// "Scheduler_Presets" => "Scheduler_Presets",
// "And many more improvements" => "And many more improvements",
// "Main new and improved features and settings in Tiki 20" => "Main new and improved features and settings in Tiki 20",
// "Tiki20" => "Tiki20",
// "It will be supported until Tiki 21.1 is released" => "It will be supported until Tiki 21.1 is released",
// "Groupmail_20" => "Groupmail_20",
// "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability" => "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability",
// "Basic Information about Wizards" => "Basic Information about Wizards",
// "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)" => "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)",
// "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled" => "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled",
// "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site" => "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site",
// "Wizards settings" => "Wizards settings",
// "Here you can see listed other features and settings that were not included in the previous sections" => "Here you can see listed other features and settings that were not included in the previous sections",
// "Ratings in Forums" => "Ratings in Forums",
// "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user" => "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Topic Rating by each user" => "Topic Rating by each user",
// "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply" => "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply",
// "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion" => "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion",
// "Sysadmin Tasks" => "Sysadmin Tasks",
// "Search Index" => "Search Index",
// "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>" => "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>",
// "Cron Job to Rebuild Search Index" => "Cron Job to Rebuild Search Index",
// "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index" => "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index",
// "Starting in Tiki11, the syntax to rebuild the search index changed" => "Starting in Tiki11, the syntax to rebuild the search index changed",
// "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line" => "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line",
// "Console (console.php script)" => "Console (console.php script)",
// "Example: Database update" => "Example: Database update",
// "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>" => "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>",
// "Mail Queue" => "Mail Queue",
"Daily Reports for User Watches" => "Rapports quotidiens pour les surveillances utilisateur",
// "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending" => "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending",
// "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished" => "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished",
// "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button" => "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button",
// "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job" => "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job",
// "Example: Send the Mail Queue" => "Example: Send the Mail Queue",
// "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups" => "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups",
// "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)" => "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)",
// "Example: Send the Daily Report" => "Example: Send the Daily Report",
// "Other Features" => "Other Features",
// "New permissions and action log settings" => "New permissions and action log settings",
// "Wiki Inline Editing" => "Wiki Inline Editing",
// "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4" => "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4",
// "The editor can be quickly turned on/off. All processing is done client side" => "The editor can be quickly turned on/off. All processing is done client side",
// "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown" => "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown",
// "bigbluebutton" => "bigbluebutton",
// "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings" => "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings",
// "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted" => "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted",
// "Switch editor" => "Switch editor",
// "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted" => "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted",
// "Action log settings" => "Action log settings",
// "Joined Room" => "Joined Room",
// "Left Room" => "Left Room",
// "You are reaching the end of the <em>Changes Wizard</em>" => "You are reaching the end of the <em>Changes Wizard</em>",
// "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least" => "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least",
// "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community" => "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community",
// "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above" => "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above",
// "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}" => "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}",
"Connect" => "Connecter",
// "Site title is required" => "Site title is required",
// "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki" => "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki",
// "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site" => "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site",
// "Tracker Field Types" => "Tracker Field Types",
// "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>" => "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>",
// "Former ways to manage ratings in trackers are <b>deprecated</b>" => "Former ways to manage ratings in trackers are <b>deprecated</b>",
// "Deprecated Rating Systems in Trackers" => "Deprecated Rating Systems in Trackers",
// "Tracker field types" => "Tracker field types",
// "edit Tracker" => "edit Tracker",
// "Other options to be set elsewhere" => "Other options to be set elsewhere",
// "Add a <em>User and Registration tracker</em>" => "Add a <em>User and Registration tracker</em>",
// "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins" => "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins",
// "You can set it in" => "You can set it in",
// "tracker edition" => "tracker edition",
// "Some User Interface (UI) improvements which usually come disabled in new Tiki installations" => "Some User Interface (UI) improvements which usually come disabled in new Tiki installations",
// "They are proven to be useful enhancements in some production environments" => "They are proven to be useful enhancements in some production environments",
// "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try" => "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try",
// "Icons and Profile Pictures" => "Icons and Profile Pictures",
// "Text Areas" => "Text Areas",
// "You are done with the Changes Wizard" => "You are done with the Changes Wizard",
// "You are done with the Configuration Profiles Wizard" => "You are done with the Configuration Profiles Wizard",
// "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site" => "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences",
// "Some profiles were created for use cases of project management" => "Some profiles were created for use cases of project management",
// "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly" => "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly",
// "It creates" => "It creates",
// "a sample tracker that will hold the tasks" => "a sample tracker that will hold the tasks",
// "a sample wiki page linked to that tracker to display the tasks" => "a sample wiki page linked to that tracker to display the tasks",
// "Some demo data to help you get started" => "Some demo data to help you get started",
// "Click to expand" => "Click to expand",
// "Work custom pricing" => "Work custom pricing",
// "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one" => "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one",
// "Work Custom Pricing" => "Work Custom Pricing",
// "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile" => "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile",
// "Wildcard items" => "Wildcard items",
// "This profile adds a way to provide reusable items in a tracker coming from another one working as templates" => "This profile adds a way to provide reusable items in a tracker coming from another one working as templates",
// "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are" => "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are",
// "A couple of trackers. One for current items, and another one for the reusable items working ass templates" => "A couple of trackers. One for current items, and another one for the reusable items working ass templates",
// "A few wiki pages to list, view and edit items" => "A few wiki pages to list, view and edit items",
// "Some example items in both trackers to help you get started" => "Some example items in both trackers to help you get started",
// "Check out some commonly used configurations in Tiki sites" => "Check out some commonly used configurations in Tiki sites",
// "User & Registration Tracker" => "User & Registration Tracker",
// "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users" => "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users",
// "It includes" => "It includes",
// "A long list of predefined usual fields, to choose from" => "A long list of predefined usual fields, to choose from",
// "Some fields already prepared to display custom information from your specific site" => "Some fields already prepared to display custom information from your specific site",
// "The chance to easily customize it with the power of Trackers" => "The chance to easily customize it with the power of Trackers",
// "Custom Contact Form" => "Custom Contact Form",
// "This profile eases the task to create a custom contact form adapted to the specific case of that site" => "This profile eases the task to create a custom contact form adapted to the specific case of that site",
// "More details" => "More details",
// "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point" => "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point",
// "New fields can be added asking questions specific for the site" => "New fields can be added asking questions specific for the site",
// "You decide where and when to display the link to the contact us form in your Tiki menus and pages" => "You decide where and when to display the link to the contact us form in your Tiki menus and pages",
// "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields" => "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields",
// "Useful for Geographic data (State, Country/Province, ...)" => "Useful for Geographic data (State, Country/Province, ...)",
// "Useful for Types and Subtypes" => "Useful for Types and Subtypes",
// "Useful for Program Names and Versions" => "Useful for Program Names and Versions",
// "Easily manage the options in the second tracker without editing the dropdown in the first tracker" => "Easily manage the options in the second tracker without editing the dropdown in the first tracker",
// "Sortable Tables" => "Sortable Tables",
// "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature" => "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature",
// "Useful to sort and filter data in real time" => "Useful to sort and filter data in real time",
// "Same approach for FancyTable and TrackerList Plugins" => "Same approach for FancyTable and TrackerList Plugins",
// "Sorting can be server-side or client-side based " => "Sorting can be server-side or client-side based ",
// "Some profiles are highly customized for very specialized use cases, and they are listed in this special category" => "Some profiles are highly customized for very specialized use cases, and they are listed in this special category",
// "Demo Profiles" => "Demo Profiles",
// "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site" => "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site",
// "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on" => "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on",
// "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected" => "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected",
// "See details in the instructions page shown in your site once each profile is applied" => "See details in the instructions page shown in your site once each profile is applied",
// "CartoGraf" => "CartoGraf",
// "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools" => "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools",
// "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application" => "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application",
// "This profile is using Tiki as Framework, with these details" => "This profile is using Tiki as Framework, with these details",
// "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers" => "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers",
// "It uses its own Cartograf style (downloaded aside)" => "It uses its own Cartograf style (downloaded aside)",
// "It allows custom markers for maps (placed in a file gallery)" => "It allows custom markers for maps (placed in a file gallery)",
// "It is used in production at http://cartograf.recitus.qc.ca (in French)" => "It is used in production at http://cartograf.recitus.qc.ca (in French)",
// "R demo" => "R demo",
// "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages" => "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages",
// "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)" => "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)",
// "The profile creates many demo pages, which comprise" => "The profile creates many demo pages, which comprise",
// "Simple R syntax in wiki pages to produce interactive charts" => "Simple R syntax in wiki pages to produce interactive charts",
// "Advanced usage to create full GUI for an R application" => "Advanced usage to create full GUI for an R application",
// "Many other examples of nice charts and reports that you can produce with this system" => "Many other examples of nice charts and reports that you can produce with this system",
// "r.tiki.org site" => "r.tiki.org site",
// "r.tiki.org live site" => "r.tiki.org live site",
// "GeoCMS Maps" => "GeoCMS Maps",
// "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps" => "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps",
// "R Heatmaps" => "R Heatmaps",
// "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)" => "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)",
// "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)" => "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)",
// "This profile creates" => "This profile creates",
// "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you" => "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you",
// "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets" => "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets",
// "Example input files and default values provided as a happy path to produce your first Heatmaps" => "Example input files and default values provided as a happy path to produce your first Heatmaps",
// "Plugin R" => "Plugin R",
// "Plugin R in doc.tiki.org" => "Plugin R in doc.tiki.org",
// "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example" => "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example",
// "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real" => "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real",
// "Bug Tracker" => "Bug Tracker",
// "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below" => "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below",
// "Uses PluginTracker in a wiki page to add items" => "Uses PluginTracker in a wiki page to add items",
// "Create some custom feedback for message to the user after item insertion" => "Create some custom feedback for message to the user after item insertion",
// "Uses PluginTrackerList to display inserted items" => "Uses PluginTrackerList to display inserted items",
// "Timesheet" => "Timesheet",
// "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names" => "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names",
// "Allows to track your time spent on projects" => "Allows to track your time spent on projects",
// "Customize your project categories" => "Customize your project categories",
// "Add or edit your timesheet fields as desired" => "Add or edit your timesheet fields as desired",
// "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker" => "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker",
// "Plugin Timesheet" => "Plugin Timesheet",
// "Plugin Timesheet in doc.tiki.org" => "Plugin Timesheet in doc.tiki.org",
// "Tracker as Calendar" => "Tracker as Calendar",
// "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way" => "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way",
// "Advanced use of Plugin TrackerList" => "Advanced use of Plugin TrackerList",
// "Working example of Plugin TrackerCalendar" => "Working example of Plugin TrackerCalendar",
// "Drag & Drop to resize or move events" => "Drag & Drop to resize or move events",
// "Several display modes, useful for Project & Resource Management" => "Several display modes, useful for Project & Resource Management",
// "Voting System" => "Voting System",
// "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote" => "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote",
// "Group homepage set for the voting group" => "Group homepage set for the voting group",
// "Only one vote per member is allowed" => "Only one vote per member is allowed",
// "Results shown in real time (Plugin TrackerStat)" => "Results shown in real time (Plugin TrackerStat)",
// "Other candidates can be voted beyond the proposed" => "Other candidates can be voted beyond the proposed",
// "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site" => "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site",
// "Shopping Cart" => "Shopping Cart",
// "This profile provides a Shopping Cart and the corresponding basic payment system" => "This profile provides a Shopping Cart and the corresponding basic payment system",
// "It currently uses the PayPal shopping cart rather than the built in Tiki" => "It currently uses the PayPal shopping cart rather than the built in Tiki",
// "A tracker for products including price, weight, image and stock quantity" => "A tracker for products including price, weight, image and stock quantity",
// "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users" => "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users",
// "A small category subtree to classify products" => "A small category subtree to classify products",
// "Wiki pages to display the available products list, one product details page and a search form" => "Wiki pages to display the available products list, one product details page and a search form",
// "Easy GeoBlog" => "Easy GeoBlog",
// "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features" => "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features",
// "Single map with all geolocated blog posts" => "Single map with all geolocated blog posts",
// "Different home page once the user logs in" => "Different home page once the user logs in",
// "Random header image from files included in a file gallery" => "Random header image from files included in a file gallery",
// "WYSIWYG Editor (compatible mode with wiki syntax)" => "WYSIWYG Editor (compatible mode with wiki syntax)",
// "Wiki, Search, Menu & Tags" => "Wiki, Search, Menu & Tags",
// "Comments moderation & Banning (for anonymous comments to your site)" => "Comments moderation & Banning (for anonymous comments to your site)",
// "Profile Conditional_Display_in_Forms" => "Profile Conditional_Display_in_Forms",
// "This profile demonstrates the setup to conditionally hide or display some fields in a form" => "This profile demonstrates the setup to conditionally hide or display some fields in a form",
// "Conditional_Display_in_Forms" => "Conditional_Display_in_Forms",
// "Main features used" => "Main features used",
// "Plugin JQ (jQuery)" => "Plugin JQ (jQuery)",
// "Plugin TrackerIf" => "Plugin TrackerIf",
// "Profile Execute_on_list" => "Profile Execute_on_list",
// "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute" => "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute",
// "Plugin ListExecute" => "Plugin ListExecute",
// "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes" => "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes",
// "Structured Master Documents" => "Structured Master Documents",
// "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more" => "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more",
// "Many pages are pre-created to let you easily set up several wiki structures" => "Many pages are pre-created to let you easily set up several wiki structures",
// "A common navigation menu is created and shown at the top of pages in the structure" => "A common navigation menu is created and shown at the top of pages in the structure",
// "You can easily print (export) them all together in a single html" => "You can easily print (export) them all together in a single html",
// "Permissions or Monitoring can be applied in bulk to the whole structure or substructures" => "Permissions or Monitoring can be applied in bulk to the whole structure or substructures",
// "Consensus Forums" => "Consensus Forums",
// "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held" => "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held",
// "Users ratings in Forums" => "Users ratings in Forums",
// "Topics with less agreement can be easily identified from the topic list" => "Topics with less agreement can be easily identified from the topic list",
// "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus" => "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus",
// "Replies can also be rated, but without affecting the topic rating average" => "Replies can also be rated, but without affecting the topic rating average",
// "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile" => "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile",
// "Barter Market" => "Barter Market",
// "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge" => "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge",
// "minimal number of fields in these trackers, which can be extended" => "minimal number of fields in these trackers, which can be extended",
// "tracker items are categorized" => "tracker items are categorized",
// "a few modules added, including a wiki page menu" => "a few modules added, including a wiki page menu",
// "best display if using just one column (right, for instance)" => "best display if using just one column (right, for instance)",
// "Revision Approval (ISO9001)" => "Revision Approval (ISO9001)",
// "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)" => "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)",
// "Additions: 1 group, 2 users, 2 wiki pages, 3 categories" => "Additions: 1 group, 2 users, 2 wiki pages, 3 categories",
// "Revision approval is set for homepage and 'official document'" => "Revision approval is set for homepage and 'official document'",
// "Wiki Argument Variables are used in the 'official document'" => "Wiki Argument Variables are used in the 'official document'",
// "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles" => "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles",
// "Collaborative Community" => "Collaborative Community",
// "Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Setup to help subject experts and enthusiasts work together to build a Knowledge Base",
// "Uses" => "Uses",
// "Wiki Editing" => "Wiki Editing",
// "Personal Member Spaces" => "Personal Member Spaces",
// "Company Intranet" => "Company Intranet",
// "Setup for a Corporate Intranet of a typical medium-sized business" => "Setup for a Corporate Intranet of a typical medium-sized business",
// "Company News Articles" => "Company News Articles",
// "Executive Blog" => "Executive Blog",
// "File Repository & Management" => "File Repository & Management",
"Collaborative Wiki" => "Wiki collaboratif",
// "Personal Blog and Profile" => "Personal Blog and Profile",
// "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere",
"Blog (Full set of blog related features)" => "Blogue (Jeu complet de fonctionnalités en lien avec le blogue)",
// "RSS Integration" => "RSS Integration",
// "Video Log" => "Video Log",
// "Small Organization Web Presence" => "Small Organization Web Presence",
// "Setup for a Web Presence of a typical small business or non-profit" => "Setup for a Web Presence of a typical small business or non-profit",
// "Company News & Updates" => "Company News & Updates",
// "Highlight Company's Products and Services" => "Highlight Company's Products and Services",
// "File Gallery (great for Media Kit)" => "File Gallery (great for Media Kit)",
// "Contact Form" => "Contact Form",
// "Profiles admin card" => "Profiles admin card",
// "Check out some useful changes in the configuration for site administrators" => "Check out some useful changes in the configuration for site administrators",
// "Debug Mode Enabled" => "Debug Mode Enabled",
// "Debug Mode Disabled" => "Debug Mode Disabled",
// "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise" => "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise",
// "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand" => "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand",
// "Enables/Disables debugging tools" => "Enables/Disables debugging tools",
// "Enables/Disables logging tools" => "Enables/Disables logging tools",
// "Disables/Enables redirections to similar pages" => "Disables/Enables redirections to similar pages",
// "Enables/Disables error and warning display to all users, not only admins" => "Enables/Disables error and warning display to all users, not only admins",
// "This configuration profile enables the Scheduler feature and loads a preset of schedulers" => "This configuration profile enables the Scheduler feature and loads a preset of schedulers",
// "Each scheduler can replace a former cron job action in the server" => "Each scheduler can replace a former cron job action in the server",
// "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need" => "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need",
// "This configuration profile showcases the activity stream feature in Tiki" => "This configuration profile showcases the activity stream feature in Tiki",
// "Activity Stream data can also be reviewed through PluginPivotTable" => "Activity Stream data can also be reviewed through PluginPivotTable",
// "It is somewhat similar to the basic Action log feature in Tiki" => "It is somewhat similar to the basic Action log feature in Tiki",
// "Check out some useful profiles that involve changing the display mode of content in your site" => "Check out some useful profiles that involve changing the display mode of content in your site",
// "Slideshow demo" => "Slideshow demo",
// "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works" => "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works",
// "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper" => "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper",
// "Headers of different levels are used as markers of 'new slide' and used as titles" => "Headers of different levels are used as markers of 'new slide' and used as titles",
// "Many settings can be predefined as parameters of a call to PluginSlideshow" => "Many settings can be predefined as parameters of a call to PluginSlideshow",
// "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to" => "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to",
// "Hide Fixed Top Navigation Bar on scroll" => "Hide Fixed Top Navigation Bar on scroll",
// "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards" => "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards",
// "Hide Fixed Top Navi Bar on Scroll" => "Hide Fixed Top Navi Bar on Scroll",
// "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'" => "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'",
// "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice" => "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice",
// "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky" => "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky",
// "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus" => "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus",
// "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration" => "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration",
// "Menu on Wiki page" => "Menu on Wiki page",
// "This profile sets up a side module with a menu based on a wiki page in the right hand-side column" => "This profile sets up a side module with a menu based on a wiki page in the right hand-side column",
// "With this profile you can" => "With this profile you can",
// "use wiki syntax to edit it" => "use wiki syntax to edit it",
// "delegate its edition with wiki page permissions" => "delegate its edition with wiki page permissions",
// "use plugins to manage conditional display of sections" => "use plugins to manage conditional display of sections",
// "Random header images" => "Random header images",
// "This profile adds a module in the top zone that displays a random image from a File Gallery" => "This profile adds a module in the top zone that displays a random image from a File Gallery",
// "Some sample images to fit the default configuration are also provided as a starting point" => "Some sample images to fit the default configuration are also provided as a starting point",
// "default configuration uses images at 800x150px resized by the top module parameters to match the header default size" => "default configuration uses images at 800x150px resized by the top module parameters to match the header default size",
// "a different random image is shown at each page load" => "a different random image is shown at each page load",
// "elFinder modern file galery manager (with drag & drop capabilities!) is used by default" => "elFinder modern file galery manager (with drag & drop capabilities!) is used by default",
// "you can tweak the module and file gallery defaults as needed for your needs" => "you can tweak the module and file gallery defaults as needed for your needs",
// "Multilingual Wiki" => "Multilingual Wiki",
// "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion" => "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion",
// "The enabled features comprise" => "The enabled features comprise",
// "Multilingual freetags" => "Multilingual freetags",
// "Countries By Region" => "Countries By Region",
// "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions" => "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions",
// "The regions listed with their countries are" => "The regions listed with their countries are",
// "Saharan, Sub-Saharan Africa" => "Saharan, Sub-Saharan Africa",
// "Middle East, North Africa" => "Middle East, North Africa",
// "Asia" => "Asia",
// "North, Central America" => "North, Central America",
// "Oceania" => "Oceania",
// "South America" => "South America",
// "Check out this set of useful configurations that involve using some new technology for your site" => "Check out this set of useful configurations that involve using some new technology for your site",
// "Write Together" => "Write Together",
// "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS" => "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS",
// "Allows cowriting documents in real time" => "Allows cowriting documents in real time",
// "Allows voice communication in real time while editing" => "Allows voice communication in real time while editing",
// "Uses the TogetherJS Mozilla widget" => "Uses the TogetherJS Mozilla widget",
// "Post-it Sticky Note" => "Post-it Sticky Note",
// "This profile allows to display a sticky note (a \"post-it\") in your tiki site" => "This profile allows to display a sticky note (a \"post-it\") in your tiki site",
// "You can move it to another location" => "You can move it to another location",
// "You can customize the contents and which groups of users will see it (by default, only to Admins)" => "You can customize the contents and which groups of users will see it (by default, only to Admins)",
// "It will be shown for each user of that group until manually closed" => "It will be shown for each user of that group until manually closed",
// "Groupmail" => "Groupmail",
// "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages" => "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages",
// "A tracker for email messages received and store addresses in the Contacts feature" => "A tracker for email messages received and store addresses in the Contacts feature",
// "Webmail configuration to use an account for groupmail" => "Webmail configuration to use an account for groupmail",
// "A side module with markers to indicate who took which message" => "A side module with markers to indicate who took which message",
// "A system to review communication logs from that group mail account" => "A system to review communication logs from that group mail account",
// "Profile X" => "Profile X",
// "This profile allows to " => "This profile allows to ",
// "Feature_X in doc.tiki.org" => "Feature_X in doc.tiki.org",
// "User Dummy" => "User Dummy",
// "This is a dummy page" => "This is a dummy page",
// "Set up basic information as a user on this site" => "Set up basic information as a user on this site",
"Your personal Wiki Page" => "Votre page personnelle Wiki",
// "The feature 'User Preferences' is currently disabled in this site" => "The feature 'User Preferences' is currently disabled in this site",
// "Enable the feature" => "Enable the feature",
// "Enable it" => "Enable it",
// "You might ask your site admin to enable it" => "You might ask your site admin to enable it",
// "Use 'watches' to monitor wiki pages or other objects" => "Use 'watches' to monitor wiki pages or other objects",
// "Set up below preferences related to receiving notifications by email about changes in the site" => "Set up below preferences related to receiving notifications by email about changes in the site",
// "The feature user watches is disabled in this site" => "The feature user watches is disabled in this site",
// "Set up the general settings for your account" => "Set up the general settings for your account",
// "User Params" => "User Params",
"Is email public? (uses scrambling to prevent spam)" => "Brouiller l'adresse électronique pour éviter le spam",
"Does your email application need a special character set" => "Votre lecteur de messages a-t-il besoin d'un encodage de caractères particulier",
"Preferred language" => "Langue préférée",
// "Site time zone is enforced and overrides user preferences" => "Site time zone is enforced and overrides user preferences",
// "The feature with the user preferences screen is disabled in this site" => "The feature with the user preferences screen is disabled in this site",
"You are not allowed to remove this notification " => "Vous n'avez pas le droit de retirer cette notification",
"Interval in which you want to get the reports" => "Fréquence des rapports",
"HTML-Email" => "Courriel-HTML",
"Send me an email also if nothing happened" => "Envoyer un email même si il n'y a pas eu de changement",
// "The feature daily reports of user watches is disabled in this site" => "The feature daily reports of user watches is disabled in this site",
// "Use this form to fill in some extra information about you" => "Use this form to fill in some extra information about you",
// "Extra information about you" => "Extra information about you",
// "Tiki User Wizard" => "Tiki User Wizard",
// "This wizard will help you fill in data and main settings for your account on this website" => "This wizard will help you fill in data and main settings for your account on this website",
// "Depending on the features enabled by the site admin, you will be offered more or less options" => "Depending on the features enabled by the site admin, you will be offered more or less options",
// "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature" => "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature",
// "Click at the \"Start\" button above to launch it" => "Click at the \"Start\" button above to launch it",
// "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>" => "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>",
// "You are done with the user wizard" => "You are done with the user wizard",
// "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences" => "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences",
// "Or.." => "Or..",
// "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were" => "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were",
// "Show on admin log-in" => "Show on admin log-in",
// "Finish" => "Finish",
// "Start the Wizardry" => "Start the Wizardry",
// "Save and Continue" => "Save and Continue",
// "No turning back" => "No turning back",
// "Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available" => "Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available",
// "Return to simple interface" => "Return to simple interface",
// "Workspace Name" => "Workspace Name",
// "Wiki Page Source" => "Wiki Page Source",
// "Not enough options" => "Not enough options",
// "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power" => "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power",
// "Advanced Mode" => "Advanced Mode",
// "Bind area" => "Bind area",
// "Is managing group" => "Is managing group",
// "Workspace creator joins this group" => "Workspace creator joins this group",
// "Add group" => "Add group",
// "Select Permissions" => "Select Permissions",
// "Edit content template" => "Edit content template",
// "Add page" => "Add page",
// "Default (Font-awesome)" => "Default (Font-awesome)",
// "The default system icon set using Font-awesome fonts" => "The default system icon set using Font-awesome fonts",
// "Solid" => "Solid",
// "Outline" => "Outline",
// "Font Awesome Regular" => "Font Awesome Regular",
// "Font Awesome Pro Only" => "Font Awesome Pro Only",
// "Brands" => "Brands",
// "Legacy (pre Tiki14) icons" => "Legacy (pre Tiki14) icons",
// "Legacy (pre Tiki14) icons, mainly using famfamfam images" => "Legacy (pre Tiki14) icons, mainly using famfamfam images",
// "Custom icons" => "Custom icons",
// "Custom icons for the theme" => "Custom icons for the theme",
// "Theme icons" => "Theme icons",
// "Icons to be used for this theme" => "Icons to be used for this theme",
// "This field is manadatory" => "This field is manadatory",
"Design by" => "Conçu par",
"Missing book id" => "Id de livre manquant",
"You do not have the right view this page" => "Vous n'avez pas le droit de voir cette page",
// "%0 account in book %1 modified" => "%0 account in book %1 modified",
// "%0 account created for book %1" => "%0 account created for book %1",
// "Account %0 in book %1 unlocked" => "Account %0 in book %1 unlocked",
// "Account %0 in book %1 not unlocked" => "Account %0 in book %1 not unlocked",
// "Account %0 in book %1 locked" => "Account %0 in book %1 locked",
// "Account %0 in book %1 not locked" => "Account %0 in book %1 not locked",
// "Delete account %0 from book %1" => "Delete account %0 from book %1",
// "%0 account deleted from book %1" => "%0 account deleted from book %1",
"Missing account id" => "Id de compte manquant",
"You do not have the rights to view this account" => "Vous n'avez pas les droits pour voir ce compte",
"You do not have the rights to manage accounts" => "Vous n'avez pas les droits pour gérer les comptes",
// "You do not have permission to create a book" => "You do not have permission to create a book",
// "Book %0 successfully created" => "Book %0 successfully created",
// "You do not have permission to close this book" => "You do not have permission to close this book",
// "Close book (this action cannot be undone)" => "Close book (this action cannot be undone)",
// "Book successfully closed" => "Book successfully closed",
// "The attempt to close the book was unsuccessful" => "The attempt to close the book was unsuccessful",
// "Cancel journal %0 in book %1" => "Cancel journal %0 in book %1",
// "Journal shown below successfully canceled" => "Journal shown below successfully canceled",
"Missing journal id" => "Id de journal manquant",
"You do not have the right to cancel transactions" => "Vous n'avez pas le droit d'annuler des transactions",
"Error retrieving data from journal" => "Erreur lors de la recherche de données à partir du journal",
"You do not have the right to book" => "Vous n'avez pas le droit d'enregistrer des opérations",
// "Record entry in book %0" => "Record entry in book %0",
// "Journal %0 successfully recorded in book %1" => "Journal %0 successfully recorded in book %1",
"Don't know what to export" => "Ne sais pas quoi exporter",
"You do not have the right export/view this data" => "Vous n'avez pas les droit d'exporter/voir ces données",
"You do not have the right to book into the stack" => "Vous n'avez pas le droit d'enregistrer des opérations dans le brouillard",
// "Record stack entry in book %0" => "Record stack entry in book %0",
// "Modify stack entry in book %0" => "Modify stack entry in book %0",
// "Delete stack %0 from book %1" => "Delete stack %0 from book %1",
// "Confirm stack %0 for book %0" => "Confirm stack %0 for book %0",
// "Stack %0 successfully modified in book %1" => "Stack %0 successfully modified in book %1",
// "Stack %0 successfully deleted from book %1" => "Stack %0 successfully deleted from book %1",
// "Stack %0 recorded in book %1" => "Stack %0 recorded in book %1",
// "Stack %0 deleted from book %1" => "Stack %0 deleted from book %1",
// "Stack %0 confirmed and recorded as entry in book %1" => "Stack %0 confirmed and recorded as entry in book %1",
"Tiki Calendar" => "Calendrier Tiki",
"%0 enabled" => "%0 activée",
"%0 disabled" => "%0 désactivée",
"%0 set" => "%0 réglé",
"%0 unset" => "%0 non-réglé",
// "item added" => "item added",
// "items added" => "items added",
// "item deleted" => "item deleted",
// "items deleted" => "items deleted",
"Help on Configuration Sections" => "Aide sur les différentes sections de configuration",
// "Default preference filters set" => "Default preference filters set",
// "%0 reset" => "%0 reset",
"Search error" => "Erreur dans la recherche",
// "Global site configuration, date formats, etc" => "Global site configuration, date formats, etc",
"Switches for major features" => "Configuration des fonctionnalités majeures",
"User registration, remember me cookie settings and authentication methods" => "Enregistrement utilisateur, réglages du cookie 'se rappeler de moi' et méthodes d'authentification",
// "User related preferences like info and picture, features, messages and notification, files, etc" => "User related preferences like info and picture, features, messages and notification, files, etc",
"Repository configuration, browse and apply profiles" => "Configuration du dépôt de profil, navigation et application des profils",
"Look & Feel" => "Thèmes & Apparence",
"Theme selection, layout settings and UI effect controls" => "Sélection du thème, mise en page et effets de l'Interface Utilisateur",
"Editing and Plugins" => "Outils d'édition",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Configuration pour l'édition de texte. Activation de Plugiciel et gestion des alias de plugiciel",
"Module appearance settings" => "Configuration de l'apparence des Modules",
"i18n" => "i18n",
"Internationalization and localization - multilingual features" => "Internationalisation et localisation - fonctionnalités multilingues",
"Meta Tags" => "Méta balises",
"Information to include in the header of each page" => "Informations à inclure dans l'en-tête de chaque page",
"Maps" => "Cartes",
"Settings and features for maps" => "Configuration et fonctionnalités des cartes",
"Server performance settings" => "Réglages de performance du serveur",
"Site security settings" => "Réglages de sécurité du site",
// "Outgoing RSS feed setup" => "Outgoing RSS feed setup",
// "Tiki Connect - join in" => "Tiki Connect - join in",
// "Rating settings" => "Rating settings",
"Search configuration" => "Configuration de la recherche",
"Wiki page settings and features" => "Configuration et fonctionnalités des pages Wiki",
"Defaults and configuration for file galleries" => "Configuration des galeries de fichiers",
"Settings for blogs" => "Configuration des blogues",
"Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Configuration des galeries d'images (seront remplacées par les galeries de fichiers)",
"Settings and features for articles" => "Configuration et fonctionnalités des articles",
"Settings and features for forums" => "Configuration et fonctionnalités des forums",
"Settings and features for trackers" => "Configuration et fonctionnalités des formulaires",
"Settings and features for polls" => "Configuration et fonctionnalités des sondages",
"Settings and features for calendars" => "Configuration et fonctionnalités des calendriers",
"Settings and features for categories" => "Configuration et fonctionnalités des catégories",
// "Configure workspace feature" => "Configure workspace feature",
"Values of actions for users rank score" => "Valeurs des actions pour le score du classement utilisateurs",
"Settings and features for tags" => "Configuration et fonctionnalités des mots-clés",
"Settings and features for FAQs" => "Configuration et fonctionnalités des FAQs",
"Settings and features for directory of links" => "Configuration et fonctionnalités de l'Annuaire de liens",
"Site-wide copyright information" => "Information de copyright du site",
"Message settings" => "Configuration des Messages",
// "Webmail settings" => "Webmail settings",
"Options for WYSIWYG editor" => "Options pour l'éditeur WYSIWYG",
// "Site advertisements and notices" => "Site advertisements and notices",
"InterTiki" => "Gestion multisites",
"Set up links between Tiki servers" => "Configurer les liens entre serveurs Tiki",
"Manage semantic wiki links" => "Gérer les liens sémantiques wiki",
"Register and manage web services" => "Enregistrer et gérer les services web",
// "SEF URL" => "SEF URL",
"Video integration configuration" => "Configuration de l'intégration Vidéo",
// "Payment settings" => "Payment settings",
"Configure social networks integration" => "Configure l'intégration des réseaux sociaux",
"User specific features and settings" => "Fonctionnalités et réglages spécifiques de l'utilisateur",
"Configure share feature" => "Configurer la fonctionnalité Partager",
// "Configure statistics reporting for your site usage" => "Configure statistics reporting for your site usage",
"Print Settings" => " Paramètres d'impression",
// "Settings and features for print versions and pdf generation" => "Settings and features for print versions and pdf generation",
// "External packages installation and management" => "External packages installation and management",
// "RTC" => "RTC",
// "Real-time collaboration tools" => "Real-time collaboration tools",
"Help on %0 Config" => "Aide sur la configuration de : %0",
// "Remove selected actions" => "Remove selected actions",
// "The selected action has been deleted from the log" => "The selected action has been deleted from the log",
// "%0 actions have been deleted from the log" => "%0 actions have been deleted from the log",
// "No actions were deleted from the log" => "No actions were deleted from the log",
"Must specify actionId" => "actionId doit être spécifié",
"Users Contributions: Addition" => "Contributions utilisateur: Ajouts",
"%s Contributions: Addition" => "%s Contributions : Ajouts",
"Users Contributions: Suppression" => "Contributions utilisateur : Suppressions",
"%s Contributions: Suppression" => "%s Contributions : Suppressions",
"Total Contributions Addition per Day" => "Total des contributions Ajouts par jour",
"Total Contributions Addition per Week" => "Total des contributions Ajouts par semaine",
"Total Contributions Suppression per Day" => "Total des contributions Suppressions par jour",
"Total Contributions Suppression per Week" => "Total des contributions Suppressions par semaine",
"Total Contributions: Addition" => "Total des contributions : Ajouts",
"Total Contributions: Suppression" => "Total des contributions : Suppressions",
"Groups Contributions: Addition" => "Contributions des groupes : Ajouts",
"Groups Contributions: Suppression" => "Contributions des groupes : Suppressions",
"white" => "blanc",
"gray" => "gris",
"silver" => "argenté",
"ivory" => "ivoire",
"whitesmoke" => "blanc fumée",
"beige" => "beige",
"darkgrey" => "gris fonçé",
// "No rule selected for deletion. No deletions were performed" => "No rule selected for deletion. No deletions were performed",
// "The selected banning rule has been deleted" => "The selected banning rule has been deleted",
// "%0 banning rules have been deleted" => "%0 banning rules have been deleted",
// "The following banning rule has been saved or replaced" => "The following banning rule has been saved or replaced",
// "The following %0 banning rules have been saved or replaced" => "The following %0 banning rules have been saved or replaced",
// "No changes were made to the following selected banning rules" => "No changes were made to the following selected banning rules",
// "Only %0 of the selected banning rules shown below were added or changed" => "Only %0 of the selected banning rules shown below were added or changed",
// "No banning rules were selected" => "No banning rules were selected",
// "Multiple IP Banning" => "Multiple IP Banning",
"Access from your localization was forbidden due to excessive spamming" => "L'accès à partir de votre adresse à été interdit pour cause de spamming excessif",
// "Not saved" => "Not saved",
// "Username pattern empty" => "Username pattern empty",
// "Default IP pattern still set" => "Default IP pattern still set",
// "Calendar %0 deleted" => "Calendar %0 deleted",
// "Calendar %0 not deleted" => "Calendar %0 not deleted",
// "One calendar event deleted" => "One calendar event deleted",
// "No calendar events deleted" => "No calendar events deleted",
// "%0 calendar events deleted" => "%0 calendar events deleted",
// "No such category with parentID %0" => "No such category with parentID %0",
// "One object unassigned from category" => "One object unassigned from category",
// "%0 objects unassigned from category" => "%0 objects unassigned from category",
// "No objects unassigned" => "No objects unassigned",
// "Incorrect category ID %0 - objects not moved" => "Incorrect category ID %0 - objects not moved",
// "One object moved to selected category" => "One object moved to selected category",
// "%0 objects moved to selected category" => "%0 objects moved to selected category",
// "No objects moved" => "No objects moved",
// "Incorrect category ID %0 - objects not copied" => "Incorrect category ID %0 - objects not copied",
// "One object copied to selected category" => "One object copied to selected category",
// "%0 objects copied to selected category" => "%0 objects copied to selected category",
// "No objects copied" => "No objects copied",
// "One page added to category" => "One page added to category",
// "%0 pages added to category" => "%0 pages added to category",
// "No pages added to category" => "No pages added to category",
// "%0 %1 removed from category %2" => "%0 %1 removed from category %2",
// "%0 %1 not removed from category %2" => "%0 %1 not removed from category %2",
// "Delete category" => "Delete category",
// "Category ID %0 and descendants deleted" => "Category ID %0 and descendants deleted",
// "Category ID %0 not deleted" => "Category ID %0 not deleted",
// "Category cannot be parent of itself - no changes made" => "Category cannot be parent of itself - no changes made",
// "Category %0 updated" => "Category %0 updated",
// "Category %0 created" => "Category %0 created",
"The file does not have the required header" => "Le fichier n'a pas les en-têtes nécessaires",
// "Incorrect parameter %0" => "Incorrect parameter %0",
// "Categories imported" => "Categories imported",
"Edit permissions for this category" => "Modifier les permissions pour cette catégorie",
// "Assign permissions" => "Assign permissions",
// "Template removed" => "Template removed",
// "Template not removed" => "Template not removed",
// "Section removed" => "Section removed",
// "Section not removed" => "Section not removed",
// "Template %0 created or modified" => "Template %0 created or modified",
// "Template %0 not created or modified" => "Template %0 not created or modified",
// "Contribution settings saved" => "Contribution settings saved",
// "Contribution settings not saved" => "Contribution settings not saved",
// "Contribution added" => "Contribution added",
// "Contribution not added" => "Contribution not added",
// "Contribution modified" => "Contribution modified",
// "Contribution not modified" => "Contribution not modified",
// "Contribution removed" => "Contribution removed",
// "Contribution not removed" => "Contribution not removed",
// "Cookie removed" => "Cookie removed",
// "Cookie not removed" => "Cookie not removed",
// "All cookies removed" => "All cookies removed",
// "No cookies removed" => "No cookies removed",
// "File uploaded and one cookie created or replaced" => "File uploaded and one cookie created or replaced",
// "File uploaded and %0 cookies created or replaced" => "File uploaded and %0 cookies created or replaced",
// "Upload failed - no cookies created" => "Upload failed - no cookies created",
"Upload failed" => "Échec de l'envoi",
// "Cookie saved" => "Cookie saved",
// "Cookie not saved" => "Cookie not saved",
// "Admin credits" => "Admin credits",
// "DSN removed" => "DSN removed",
// "DSN not removed" => "DSN not removed",
// "DSN created or modified" => "DSN created or modified",
// "DSN not created or modified" => "DSN not created or modified",
// "External wiki removed" => "External wiki removed",
// "External wiki not removed" => "External wiki not removed",
// "External wiki saved" => "External wiki saved",
// "External wiki not saved" => "External wiki not saved",
// "Forum saved" => "Forum saved",
// "Forum not saved" => "Forum not saved",
// "Forum duplicated" => "Forum duplicated",
// "Forum not duplicated" => "Forum not duplicated",
"All posted" => "Tout approuver automatiquement",
"Queue anonymous posts" => "Approuver les non-anonymes automatiquement",
"Queue all posts" => "Ne rien approuver automatiquement",
"No attachments" => "Aucun fichier joint",
"Everybody can attach" => "Tout le monde peut joindre un fichier",
"Only users with attach permission" => "Seuls les utilisateurs, ayant les droits, peuvent joindre un fichier",
"Moderators and admin can attach" => "Modérateur et administrateur peuvent joindre un fichier",
"No display" => "Non affiché",
"Date (desc)" => "Date (desc)",
"Date (asc)" => "Date (asc)",
"Score (desc)" => "Score (desc)",
"Replies (desc)" => "Réponses (desc)",
"Reads (desc)" => "Lectures (desc)",
"You have to provide a hotword and a URL" => "Vous devez fournir un mot/lien automatique ou une adresse Web",
// "Hotword added" => "Hotword added",
// "Hotword not added" => "Hotword not added",
// "Hotword deleted" => "Hotword deleted",
// "Hotword not deleted" => "Hotword not deleted",
// "One dynamic zone updated" => "One dynamic zone updated",
// "%0 dynamic zones updated" => "%0 dynamic zones updated",
// "Dynamic zones not updated" => "Dynamic zones not updated",
// "Hotword saved" => "Hotword saved",
// "Hotword not saved" => "Hotword not saved",
// "HTML page removed" => "HTML page removed",
// "HTML page not removed" => "HTML page not removed",
// "HTML page saved" => "HTML page saved",
// "HTML page not saved" => "HTML page not saved",
// "A custom rule with the same ID already exists" => "A custom rule with the same ID already exists",
// "Tiki IDS is not enabled" => "Tiki IDS is not enabled",
"Requested action is not supported on repository" => "L'action demandée n'est pas supportée sur le répertoire",
"Repository name can't be an empty" => "Un nom de dépôt ne peut pas être vide",
"No repository" => "Aucun dépôt",
"Search is mandatory field" => "Le champ Recherche est obligatoire",
"File not found " => "Fichier non trouvé",
"Requested action in not supported on repository" => "Action demandée non supportée pour le dépôt",
"You need to apply the \"Invoice\" profile" => "Vous devez appliquer le profil \"Facture\" (Invoice)",
// "Remove keywords" => "Remove keywords",
// "Keywords for page \"%0\" saved" => "Keywords for page \"%0\" saved",
// "Keywords for page \"%0\" removed" => "Keywords for page \"%0\" removed",
// "Keywords were not updated" => "Keywords were not updated",
// "Featured link saved" => "Featured link saved",
// "Featured link not saved" => "Featured link not saved",
// "Non-existent link" => "Non-existent link",
// "Featured link removed" => "Featured link removed",
// "Featured link not removed" => "Featured link not removed",
"Frequency should be a positive integer!" => "La fréquence doit être un entier positif !",
"Mail-in accounts set to be checked every %s minutes" => "Les comptes mail-in sont synchronisés toutes les %s minutes",
"Automatic Mail-in accounts checking disabled" => "Les comptes mail-in ne sont pas synchronisés automatiquement",
"No menu indicated" => "Aucun menu indiqué",
// "Delete menu ID %0" => "Delete menu ID %0",
// "Reset the Application Menu to the current system default" => "Reset the Application Menu to the current system default",
// "Module file in use. You need to edit %0 to configure your modules" => "Module file in use. You need to edit %0 to configure your modules",
// "%0 cache files cleared" => "%0 cache files cleared",
// "Module unassigned" => "Module unassigned",
// "Module not unassigned" => "Module not unassigned",
// "Displayed order may not change if other modules now have the same order rank" => "Displayed order may not change if other modules now have the same order rank",
// "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1" => "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1",
// "Standard module display order moved up" => "Standard module display order moved up",
// "Standard module display order not moved up" => "Standard module display order not moved up",
// "Standard module display order moved down" => "Standard module display order moved down",
// "Standard module display order not moved down" => "Standard module display order not moved down",
// "Standard display of modules reordered or moved" => "Standard display of modules reordered or moved",
// "Standard display of modules not reordered or moved" => "Standard display of modules not reordered or moved",
// "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1" => "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1",
"Cannot create or update module: You need to specify a name for the module" => "Impossible de créer ou de mettre à jour le module : vous devez spécifier le nom du module",
"Cannot create or update module: You cannot leave the data field empty" => "Impossible de créer ou de mettre à jour le module : vous ne pouvez pas laisser le champ de données vide",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "Custom module created" => "Custom module created",
// "Custom module modified" => "Custom module modified",
// "Custom not module created" => "Custom not module created",
// "Custom module not modified" => "Custom module not modified",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module",
// "Module assigned" => "Module assigned",
// "Module not assigned" => "Module not assigned",
// "Custom module deleted" => "Custom module deleted",
// "Custom module not deleted" => "Custom module not deleted",
"Appearance" => "Apparence",
"No newsletter indicated" => "Aucune lettre d'informations indiquée",
"Newsletter does not exist" => "La lettre de nouvelles n'existe pas",
// "subscription" => "subscription",
// "subscriptions" => "subscriptions",
// "No subscriptions removed" => "No subscriptions removed",
// "Subscription removed" => "Subscription removed",
// "Subscription not removed" => "Subscription not removed",
// "Subscription marked as valid" => "Subscription marked as valid",
// "Subscription not marked as valid" => "Subscription not marked as valid",
// "Errors encountered when attempting to add subscription" => "Errors encountered when attempting to add subscription",
// "Subscription added" => "Subscription added",
"Error opening uploaded file" => "Erreur lors de l'ouverture du fichier envoyé",
// "Error importing from wiki page \"%0\"" => "Error importing from wiki page \"%0\"",
// "Wiki page \"%0\" imported" => "Wiki page \"%0\" imported",
// "Error importing from tracker ID %0" => "Error importing from tracker ID %0",
// "Tracker ID %0 imported" => "Tracker ID %0 imported",
// "Not all subscriptions created" => "Not all subscriptions created",
// "Subscriptions not created" => "Subscriptions not created",
// "Subscriptions created" => "Subscriptions created",
// "Group \"%0\" subscribed" => "Group \"%0\" subscribed",
// "Group \"%0\" not subscribed" => "Group \"%0\" not subscribed",
// "Subscribers added" => "Subscribers added",
// "Subscribers not added" => "Subscribers not added",
// "Emails from wiki page \"%0\" subscribed" => "Emails from wiki page \"%0\" subscribed",
// "Emails from wiki page \"%0\" not subscribed" => "Emails from wiki page \"%0\" not subscribed",
// "%0 \$word removed" => "%0 \$word removed",
// "Newsletter removed" => "Newsletter removed",
// "Newsletter not removed" => "Newsletter not removed",
// "Newsletter created or modified" => "Newsletter created or modified",
// "Newsletter not created or modified" => "Newsletter not created or modified",
"You need to provide a username or an email" => "Vous devez donner un nom d'utilisateur ou une adresse électronique",
"The user has no email set. No notifications will be sent" => "L'utilisateur n'a pas d'adresse courriel définie. Aucune notification ne sera envoyée",
// "Mail notification event added" => "Mail notification event added",
// "Mail notification event deleted" => "Mail notification event deleted",
// "One mail notification events deleted" => "One mail notification events deleted",
// "%0 mail notifications events deleted" => "%0 mail notifications events deleted",
"No poll indicated" => "Aucun sondage indiqué",
// "Name is required" => "Name is required",
// "Task is required" => "Task is required",
// "Run Time is required" => "Run Time is required",
// "Run Time format is invalid" => "Run Time format is invalid",
// "Status cannot be empty" => "Status cannot be empty",
// "Scheduler %s was updated" => "Scheduler %s was updated",
// "Scheduler %s was created" => "Scheduler %s was created",
// "Inactive" => "Inactive",
"unsafe" => "dangereux",
"The Path to store files in the filegallery should be outside the tiki root directory" => "Le chemin de sauvegarde des fichiers des galeries de fichiers doit être hors du répertoire Tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "Le chemin de sauvegarde des fichiers des galeries d'images doit être hors du répertoire Tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "La fonctionnalité \"Modifier les gabarits\" est activée. Ne laisser personne de peu fiable utiliser cette fonctionnalité. Il est facile d'injecter du code PHP.",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
"The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement" => "Le plugiciel Wiki Regex est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour créer n'importe quel fichier HTML avec des remplacements par expression régulière",
"The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "Le plugiciel Wiki Lsdir est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour afficher le contenu d'un répertoire",
"The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "Le plugiciel Wiki Bloglist est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour divulguer les publications privées des blogues",
"The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "Le plugiciel Wiki iframe est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour les \"cross site scripting attacks\"",
"The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "Le plugiciel Wiki JS est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour utiliser du code javascript vous offrant plein de possibilité",
"The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "Le plugiciel Wiki JQ est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour utiliser du code javascript vous offrant plein de possibilité",
"The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "Le plugiciel Wiki Redirect est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour les \"cross site scripting attacks\"",
"The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "Le plugiciel Wiki Module est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour ajouter des modules permettant l'accès à des informations( voir la liste des modules)",
"The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "Le plugiciel Wiki Userlist est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour afficher la liste des utilisateurs",
"The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "Le plugiciel Wiki Usercount est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour afficher le nombre d'utilisateur",
"The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "Le plugiciel Wiki SQL est activé. Vous pouvez l'utiliser avec l'éditeur Wiki pour exécuter des commandes SQL",
"risky" => "risqué",
// "To the extent secure logins are not required, data transmitted between the browser and server is not private" => "To the extent secure logins are not required, data transmitted between the browser and server is not private",
// "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php",
// "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php",
// "Unlocked" => "Unlocked",
// "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed" => "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed",
"Path disclosure" => "Faille Path disclosure",
"Path disclosure through error message" => "Faille Path disclosure au travers d'un message d'erreur",
"SQL injection" => "Injection SQL",
"SQL injection by authenticated user" => "Injection SQL par un utilisateur authentifié",
"SQL injection by authenticated user with special privileges" => "Injection SQL par un utilisateur authentifié avec des privilèges spéciaux",
"SQL injection without authentication" => "Injection SQL sans authentification",
"PHP command injection" => "Injection de commande PHP",
"PHP command injection by authenticated user" => "Injection de commande PHP par un utilisateur authentifié",
"PHP command injection by authenticated user with special privileges" => "Injection de commande PHP par un utilisateur authentifié avec des privilèges spéciaux",
"PHP command injection without authentication" => "Injection de commande PHP sans authentification",
"File upload" => "Envoi de fichier",
"File is not readable. Unable to check." => "Fichier sans droit de lecture. Impossible de vérifier.",
// "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous" => "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous",
"This is not a Tiki file. Check if this file was uploaded and if it is dangerous." => "Ceci n'est pas un fichier Tiki. Contrôlez si ce fichier a été envoyé par un tiers et si il est dangereux.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "C'est un fichier modifié. Impossible de vérifier la version. Vérifiez si c'est dangereux.",
"This file is from another Tiki version: " => "Ce fichier est d'une autre version de Tiki :",
"Shoutbox Words" => "Tabous du mégaphone",
"You have to provide a word" => "Vous devez indiquer un mot",
"You do not have permission to view this page." => "Vous n'avez pas les droits pour afficher cette page",
"You do not have permission to edit this page." => "Vous n'avez pas les droits pour modifier cette page",
"You must specify a page name, it will be created if it doesn't exist." => "Vous devez donner un nom de page, la page sera créée si elle n'existe pas.",
"page not added (Exists)" => "page non ajoutée (Existe)",
"No survey indicated" => "Aucune enquête indiquée",
"Tiki Cache/Sys Admin" => "Cache Tiki / Administration Système",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
"Are you sure you want to delete all your custom tools" => "Êtes-vous sûr(e) de vouloir supprimer tous vos outils personnels",
"Are you sure you want to delete this custom tool" => "Êtes vous sûr de vouloir supprimer cet outil personnalisé",
"Are you sure you want to remove this topic" => "Êtes-vous sûr(e) de vouloir supprimer ce sujet",
"Are you sure you want to remove this topic AND all the articles related" => "Êtes-vous sûr(e) de vouloir supprimer ce sujet ET tous les articles en relation",
"No tracker indicated" => "Aucun formulaire indiqué",
// "Tracker Fields %0" => "Tracker Fields %0",
"You don't have permission to use this feature" => "Vous n'avez pas le droit d'utiliser cette fonctionnalité",
// "Are you sure you want to delete the webservice \"%0\"" => "Are you sure you want to delete the webservice \"%0\"",
// "Are you sure you want to delete the template \"%0\"" => "Are you sure you want to delete the template \"%0\"",
// "Webservice error \"%0\" not saved (alpha characters only)" => "Webservice error \"%0\" not saved (alpha characters only)",
"User doesn't exist" => "Cet utilisateur n'existe pas",
"No records were found. Check the file please!" => "Pas d'entrée trouvée. Vérifier le fichier SVP !",
"User login or email is required" => "Identifiant ou email requis",
"User does not exist on master" => "L'utilisateur n'existe pas sur le maitre",
"User login is required" => "Nom utilisateur obligatoire",
"Email is required" => "Adresse mail obligatoire",
"User is duplicated" => "L'utilisateur est dupliqué",
"Created account %s <%s>" => "Compte créé %s <%s>",
"Assigned %s in group %s" => "Mettre %s dans le groupe %s",
// "Users added" => "Users added",
// "%0 users not added" => "%0 users not added",
"Email validation requested but email address not set" => "Validation par courriel demandé mais adresse courriel non définie",
"The passwords do not match" => "Les mots de passe ne sont pas identiques",
"Password not set" => "Mot de passe non défini",
"User %s already exists" => "L'utilisateur %s existe déjà",
"User login contains invalid characters" => "Le nom d'utilisateur contient des caractères invalides",
"New user created with username %s." => "Un nouvel utilisateur a été créé avec le nom d'utilisateur %s.",
"Impossible to create new %s with %s %s." => "Impossible de créer un nouveau %s avec %s %s.",
// "User account %0 has been invalidated by the admin" => "User account %0 has been invalidated by the admin",
// "An error occurred - the user account %0 has not been invalidated by the admin" => "An error occurred - the user account %0 has not been invalidated by the admin",
// "Link to OpenID for user %0 has been removed" => "Link to OpenID for user %0 has been removed",
// "An error occurred - the link to OpenID for user %0 has not been removed" => "An error occurred - the link to OpenID for user %0 has not been removed",
// "Modify this user's data" => "Modify this user's data",
"%s changed from %s to %s" => "%s changé de %s en %s",
"%s modified successfully." => "%s modifié avec succès.",
"%s modification failed." => "la modification de %s a échoué.",
"Impossible to change %s from %s to %s" => "Impossible de changer %s de %s à %s",
"email" => "adresse électronique",
// "Unable to change %s from %s to %s" => "Unable to change %s from %s to %s",
"Review" => "Article noté",
"Classified" => "Annonce",
"Failed to add attribute" => "Échec de l'ajout de l'attribut",
"rss feed disabled" => "syndication rss désactivée",
// "Are you sure you want to add user %0 to group %1" => "Are you sure you want to add user %0 to group %1",
"You have to indicate a group" => "Vous devez indiquer un groupe",
"This group is invalid" => "Ce groupe est invalide",
// "Remote system user needs to be configured" => "Remote system user needs to be configured",
// "Remote system group for autologin need to be configured" => "Remote system group for autologin need to be configured",
// "User name needs to be specified" => "User name needs to be specified",
// "Base URL not received from remote system" => "Base URL not received from remote system",
// "Email needs to be specified" => "Email needs to be specified",
"The page cannot be found" => "Cette page n'a pu être trouvée",
// "Image Galleries Configuration Panel" => "Image Galleries Configuration Panel",
"Could not read image %s." => "Ne peut pas lire l'image %s.",
"Image %s upload failed." => "Échec de l'envoi de l'image %s.",
"Image %s uploaded successfully." => "Image %s envoyée avec succès.",
"Image %s removed from Batch directory." => "Image %s supprimée du répertoire de téléchargement par lot.",
"Impossible to remove image %s from Batch directory." => "Impossible de supprimer l'image %s du répertoire Batch.",
"Incorrect directory chosen for batch upload of images." => "Répertoire invalide choisi pour l'envoi des images par lot.",
"Please setup that dir on " => "SVP, positionner ce répertoire sur ",
"Please contact the website administrator." => "SVP, contacter l'administrateur du site.",
"Directory batch" => "Groupe d'annuaire",
// "File Galleries Configuration Panel" => "File Galleries Configuration Panel",
"Incorrect directory chosen for batch upload of files." => "Répertoire invalide choisi pour le téléchargement par lot de fichiers.",
// "It isn't possible to post in any blog" => "It isn't possible to post in any blog",
// "You may need to create a blog first" => "You may need to create a blog first",
"You do not have permission to edit this post" => "Vous n'avez pas les droits pour modifier cet article",
"Top visited blogs" => "Blogues les plus visités",
"Last posts" => "Derniers articles de blogue",
"Top active blogs" => "Blogues les plus actifs",
"No blogId specified" => "Aucun Id de blogue spécifié",
"Stop watching all categories" => "Stopper la surveillance de toutes les catégories",
"Watch all categories" => "Surveiller toutes les catégories",
"Group watches for all categories" => "Surveillance de groupe pour toutes les catégories",
"Stop watching this category and its descendants" => "Stopper la surveillance de cette catégorie et de ses descendants",
"Watch this category and its descendants" => "Surveiller cette catégorie et ses descendants",
"Group watches for this category" => "Surveillance de groupe pour cette catégorie",
"Stop watching this category" => "Stopper la surveillance de cette catégorie",
"Watch this category" => "Surveiller cette catégorie",
"Nothing tagged yet" => "Aucun mot-clé pour le moment",
"You must clear your browser cache." => "Vous devez vider le cache de votre navigateur.",
"You do not have permission to access this gallery" => "Vous n'avez pas les droits pour accéder à cette galerie",
"No gallery indicated" => "Aucune galerie indiquée",
"You do not have permission to remove images from this gallery" => "Vous n'avez pas les droits pour supprimer des images de cette galerie",
"You do not have permission to rebuild thumbnails in this gallery" => "Vous n'avez pas les droits pour reconstruire les vignettes dans cette galerie",
"You do not have permission to rotate images in this gallery" => "Vous n'avez pas les droits pour pivoter les images dans cette galerie",
"No image indicated" => "Aucune image indiquée",
"picture not found" => "image non trouvée",
"You do not have permission to move images from this gallery" => "Vous n'avez pas les droits pour déplacer d'images de cette galerie",
"You do not have permission to view the calendar" => "Vous n'avez pas les droits pour voir le calendrier",
"You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "Vous devez <a href=\"tiki-admin_calendars.php?cookietab=2\">créer un calendrier</a>",
"event without name" => "évènement sans nom",
"You do not have permission to view this page" => "Vous n'avez pas les droits pour voir cette page",
"Invalid date format" => "Format de date invalide",
// "Your PHP installation does not have calendar enabled" => "Your PHP installation does not have calendar enabled",
"%H:%M %Z" => "%Hh%M",
"Invalid username or activation code. Maybe this code has already been used." => "Nom utilisateur ou code d'activation invalide. Peut être ce code a déjà été utilisé.",
"Your email could not be validated; make sure you email is correct" => "Votre e-mail n'a pas pu être validé ; assurez vous qu'il est correct",
"You can not use the same password again" => "Vous ne pouvez pas réutiliser le même mot de passe à nouveau",
"Invalid old password" => "Ancien mot de passe invalide",
"Invalid request. Expecting channels array" => "Demande invalide. Tableau de canaux attendu",
"Missing channel name" => "Nom du canal manquant",
"One of the requested channels cannot be requested. It does not exist or permission is denied" => "Un des canaux demandés ne peut être obtenu. Il n'existe pas ou la permission est refusée",
"One of the install profiles could not be obtained" => "Un des profils d'installation n'a pu être obtenu",
// "info" => "info",
// "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them" => "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them",
// "How to change this value" => "How to change this value",
// "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them" => "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them",
// "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors" => "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors",
// "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information" => "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information",
// "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information" => "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information",
// "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '" => "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '",
// "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring" => "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring",
// "No errors will be reported although the error_reporting level is all the way up at ' . \$e . " => "No errors will be reported although the error_reporting level is all the way up at ' . \$e . ",
// "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information" => "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information",
// "good" => "good",
// "ini_set is used in some places to accommodate special needs of some Tiki features" => "ini_set is used in some places to accommodate special needs of some Tiki features",
// "unsure" => "unsure",
// "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning" => "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning",
// "N/A" => "N/A",
// "Unable to detect" => "Unable to detect",
// "Cannot determine the size of this disk drive" => "Cannot determine the size of this disk drive",
// "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space" => "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space",
// "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files" => "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files",
// "When the disk space is filled, users, including administrators, will not be able to log in to Tiki" => "When the disk space is filled, users, including administrators, will not be able to log in to Tiki",
// "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported" => "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported",
// "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)" => "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)",
// "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for" => "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for",
// "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see" => "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see",
// "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see" => "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see",
// "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes" => "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes",
// "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used",
// "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache" => "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache",
// "It is recommended to use Zend opcode cache as the ByteCode Cache" => "It is recommended to use Zend opcode cache as the ByteCode Cache",
// "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used",
// "The memory_limit is at" => "The memory_limit is at",
// "This is known to support smooth functioning even for bigger sites" => "This is known to support smooth functioning even for bigger sites",
// "This will normally work, but the site might run into problems when it grows" => "This will normally work, but the site might run into problems when it grows",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default" => "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default",
// "The session.save_handler should be set to 'files'" => "The session.save_handler should be set to 'files'",
// "Well set! The default setting of 'files' is recommended for Tiki" => "Well set! The default setting of 'files' is recommended for Tiki",
// "The session.save_path must writable" => "The session.save_path must writable",
// "The session.save_path is writable" => "The session.save_path is writable",
// "If you would be using the recommended session.save_handler setting of 'files\\" => "If you would be using the recommended session.save_handler setting of 'files\\",
// "It doesn't matter though, since your session.save_handler is not set to 'files'" => "It doesn't matter though, since your session.save_handler is not set to 'files'",
// "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started" => "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started",
// "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request" => "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request",
// "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start" => "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start",
// "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup" => "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup",
// "This appears to work" => "This appears to work",
// "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki" => "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki",
// "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki" => "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Correctly set! And this is also future proof as register_globals is deprecated" => "Correctly set! And this is also future proof as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Correctly set! And this is also future proof as safe_mode is deprecated" => "Correctly set! And this is also future proof as safe_mode is deprecated",
// "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior" => "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior",
// "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated" => "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated",
// "Correctly set! Tiki is fully UTF-8 and so should be this installation" => "Correctly set! Tiki is fully UTF-8 and so should be this installation",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file",
// "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a time zone set protects the site from related errors" => "Well done! Having a time zone set protects the site from related errors",
// "Files can be uploaded to Tiki" => "Files can be uploaded to Tiki",
// "Files cannot be uploaded to Tiki" => "Files cannot be uploaded to Tiki",
// "The max_execution_time is at" => "The max_execution_time is at",
// "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless" => "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless",
// "The max_execution_time is unlimited" => "The max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s",
// "The max_input_time is at" => "The max_input_time is at",
// "The max_input_time is unlimited" => "The max_input_time is unlimited",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds",
// "The max_file_uploads is at" => "The max_file_uploads is at",
// "This is the maximum number of files allowed to be uploaded simultaneously" => "This is the maximum number of files allowed to be uploaded simultaneously",
// "The maximum number of files allowed to be uploaded is not available" => "The maximum number of files allowed to be uploaded is not available",
// "The upload_max_filesize is at" => "The upload_max_filesize is at",
// "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly" => "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly",
// "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site" => "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site",
// "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site" => "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site",
// "The post_max_size is at" => "The post_max_size is at",
// "The GD extension is needed for manipulation of images and for CAPTCHA images" => "The GD extension is needed for manipulation of images and for CAPTCHA images",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case GD is not available" => "ImageMagick is used as a fallback in case GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example" => "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example",
// "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file" => "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file",
// "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it" => "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it",
// "mbstring extension is needed for an UTF-8 compatible lower case filter" => "mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "The calendar feature of Tiki will not function without this" => "The calendar feature of Tiki will not function without this",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for the dom extension (see below)" => "This extension is needed for the dom extension (see below)",
// "This extension is needed by Tiki" => "This extension is needed by Tiki",
// "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server" => "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server",
// "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17" => "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17",
// "This extension is required for H5P" => "This extension is required for H5P",
// "This extension is required for many features in Tiki" => "This extension is required for many features in Tiki",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available" => "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available",
// "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries" => "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries",
// "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL" => "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL",
// "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt" => "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt",
// "Ability to generate random numbers, useful for example for CAPTCHA and other security features" => "Ability to generate random numbers, useful for example for CAPTCHA and other security features",
// "This extension is required and used frequently in validation functions invoked within Zend Framework" => "This extension is required and used frequently in validation functions invoked within Zend Framework",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server" => "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "The max_allowed_packet setting is at" => "The max_allowed_packet setting is at",
// "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Your database supports the utf8mb4 character set required in Tiki19 and above" => "Your database supports the utf8mb4 character set required in Tiki19 and above",
// "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation" => "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation",
// "Tiki is fully utf8mb4 and so should be every part of the stack" => "Tiki is fully utf8mb4 and so should be every part of the stack",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified" => "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified",
// "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki" => "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down" => "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down",
// "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down" => "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down",
// "ON" => "ON",
// "OFF" => "OFF",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki",
// "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess" => "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess",
// "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"" => "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"",
// "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again" => "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again",
// "Not Working" => "Not Working",
// "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki" => "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki",
// "Working" => "Working",
// "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs" => "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly",
// "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly",
// "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "Not Installed" => "Not Installed",
// "Tesseract PHP package could not be found. Try installing through Packages" => "Tesseract PHP package could not be found. Try installing through Packages",
// "Tesseract PHP dependency installed" => "Tesseract PHP dependency installed",
// "The installed Tesseract version is lower than the required version" => "The installed Tesseract version is lower than the required version",
// "Tesseract package" => "Tesseract package",
// "languages installed" => "languages installed",
// "Not all languages installed. You may need to install additional languages for multilingual support" => "Not all languages installed. You may need to install additional languages for multilingual support",
// "Tesseract languages" => "Tesseract languages",
// "Tesseract could not be found" => "Tesseract could not be found",
// "Tesseract meets or exceeds the version requirements" => "Tesseract meets or exceeds the version requirements",
// "Tesseract binary" => "Tesseract binary",
// "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path" => "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path",
// "Path setup correctly" => "Path setup correctly",
// "Your path may not be configured correctly. It appears to be located at " => "Your path may not be configured correctly. It appears to be located at ",
// "Your path is configured, but we were unable to tell if it was configured properly or not" => "Your path is configured, but we were unable to tell if it was configured properly or not",
// "Tesseract path" => "Tesseract path",
// "Pdfimages path" => "Pdfimages path",
// "Scheduler has been successfully setup" => "Scheduler has been successfully setup",
// "Scheduler needs to have a console command of \"ocr:all\" set" => "Scheduler needs to have a console command of \"ocr:all\" set",
// "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser" => "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser",
// "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration" => "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration",
"safe" => "sans danger",
// "WebKit is enabled" => "WebKit is enabled",
// "The Blogs feature is enabled" => "The Blogs feature is enabled",
// "Exec can potentially be used to execute arbitrary code on the server" => "Exec can potentially be used to execute arbitrary code on the server",
// "Tiki does not need it; perhaps it should be disabled" => "Tiki does not need it; perhaps it should be disabled",
// "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled" => "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled",
// "Exec can be potentially be used to execute arbitrary code on the server" => "Exec can be potentially be used to execute arbitrary code on the server",
// "Tiki needs it to run the Plugins R/RR" => "Tiki needs it to run the Plugins R/RR",
// "If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "System is similar to exec" => "System is similar to exec",
// "Tiki does not need it; it is good that it is disabled" => "Tiki does not need it; it is good that it is disabled",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "popen is similar to exec" => "popen is similar to exec",
// "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
// "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature" => "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature",
// "session.use_trans_sid should be off by default. See the PHP manual for details" => "session.use_trans_sid should be off by default. See the PHP manual for details",
// "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them" => "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them",
// "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off" => "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off",
// "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information",
// "To manage this instance from a remote server you need SSH or FTP access to this server" => "To manage this instance from a remote server you need SSH or FTP access to this server",
// "Command found" => "Command found",
// "Command not found, check if it is installed and available in one of the paths above" => "Command not found, check if it is installed and available in one of the paths above",
// "Extension loaded in PHP" => "Extension loaded in PHP",
// "Extension not loaded in PHP" => "Extension not loaded in PHP",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered" => "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered",
// "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php" => "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php",
// "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts" => "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
// "The intl extension is required for Tiki 15 and newer" => "The intl extension is required for Tiki 15 and newer",
// "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters" => "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters",
// "Congratulations!\n\nThis server can send emails.\n\n" => "Congratulations!\n\nThis server can send emails.\n\n",
// "The path '%0' on preference '%1' does not exist" => "The path '%0' on preference '%1' does not exist",
// "The lib '%0' on preference '%1', option '%2' does not exist" => "The lib '%0' on preference '%1', option '%2' does not exist",
// "The class '%0' needed for preference '%1', with option '%2' selected, does not exist" => "The class '%0' needed for preference '%1', with option '%2' selected, does not exist",
// "The extension '%0' on preference '%1', with option '%2' selected, is not loaded" => "The extension '%0' on preference '%1', with option '%2' selected, is not loaded",
"Top authors" => "Auteurs les plus actifs",
// "User %0 validated by the admin" => "User %0 validated by the admin",
"Problem. Try to log in again to receive new confirmation instructions." => "Problème. Essayez de vour connecter encore pour recevoir les instructions de confirmation.",
"Invalid" => "Invalide",
"You must include a subject or a message" => "Vous devez inclure un sujet ou un message",
// "You must make sure to have a valid email address in the From field" => "You must make sure to have a valid email address in the From field",
"%0 sent you a message" => "%0 vous a envoyé un message",
"last version" => "dernière version",
"Cannot rename page because the new name begins with reserved prefix" => "Vous ne pouvez pas renommer la page avec un nom qui commence par un préfixe réservé",
"Cannot copy page because maybe new page name already exists" => "Ne peut copier la page peut-être parce que son nouveau nom existe déjà",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
"Eliminating previous files." => "Suppression des anciens fichiers.",
"Index: <strong>%0</strong>" => "Index : <strong>%0</strong>",
// "Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
// "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix" => "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix",
"You need to change chmod 'whelp' manually to 777" => "Vous devez faire manuellement un chmod 777 sur 'whelp'",
"Creating directory structure in <strong>%0</strong>" => "Création en cours d'une structure d'annuaire dans <strong>%0</strong>",
"Submit a new link" => "Soumettre un nouveau lien",
"Must enter a name to add a site. " => "Vous devez donner un nom pour ajouter un site. ",
"Must enter a url to add a site. " => "Vous devez entrer une adresse Web pour ajouter un site. ",
"URL already added to the directory. Duplicate site? " => "Adresse Web déjà présente dans le répertoire. Enregistrer un doublon ? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "L'adresse Web ne peut pas être accédée : mauvaise adresse Web ou site déconnecté. L'adresse Web ne peut pas être ajoutée au répertoire. ",
"Must select a category. " => "Vous devez choisir une catégorie. ",
"Must enter a name to add a site" => "Vous devez donner un nom pour ajouter un site",
"Must enter a url to add a site" => "Vous devez entrer une adresse Web pour ajouter un site",
"URL already added to the directory. Duplicate site?" => "Adresse Web déjà présente dans le répertoire. Enregistrer un doublon ?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "L'URL ne peut pas être accédé (mauvaise URL ou site offline) : l'URL ne peut pas être ajoutée au répertoire",
"Must select a category" => "Vous devez choisir une catégorie",
"Browse Directory" => "Parcourir l'annuaire",
"How to use Directory" => "Comment utiliser l'annuaire",
"No site indicated" => "Aucun site indiqué",
"This feature is disabled: %0" => "La fonctionnalité est désactivée : %0",
"No parent specified" => "aucun parent spécifié",
"Latest sites of directory %0" => "Derniers sites de l'annuaire %0",
"Discount code already exists" => "Ce code remise existe déjà",
// "Invalid fileId. Please provide a valid fileId to preview a specific file" => "Invalid fileId. Please provide a valid fileId to preview a specific file",
// "Unable to display file" => "Unable to display file",
"File has been deleted" => "Le fichier a été supprimé",
"You cannot download this file right now. Your score is low or file limit was reached" => "Vous ne pouvez pas télécharger ce fichier maintenant. Votre score est bas ou la limite du fichier a été atteinte",
// "File locked" => "File locked",
// "File not locked" => "File not locked",
"Error : The file %s doesn't exist." => "Erreur : Le fichier %s n'existe pas.",
"Article not found" => "Article introuvable",
"You do not have permission to edit this article" => "Vous n'avez pas les droits pour modifier cet article",
"The language can't be changed as its set of translations has already this language" => "La langue ne peut pas être changée parce qu'il y a déjà cette langue dans le jeu de traductions",
"Banner not found" => "Bannière introuvable",
"You do not have permission to edit this banner" => "Vous n'avez pas les droits pour modifier cette bannière",
"You do not have permission to edit this blog" => "Vous n'avez pas les droits pour modifier ce blogue",
// "No filters applied" => "No filters applied",
// "You do not have permission to write the css file" => "You do not have permission to write the css file",
// "Wrong file type, expected one of %0" => "Wrong file type, expected one of %0",
"You do not have permission to view/edit this file" => "Vous n'avez pas les droits pour voir/modifier ce fichier",
" drawing" => " dessin",
"Wrong file type, expected %0" => "Type de fichier erroné, attendu %0",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "Demande de modification d'image invalide",
"You have permission to edit images but not in this gallery" => "Droit d'accès refusé : vous pouvez modifier des images mais pas dans cette galerie",
"Failed to edit the image" => "Échec de la modification de l'image",
"Edit or export languages" => "Modifier ou exporter des langues",
"Edit Perspectives" => "Modifier les Perspectives",
"No content id indicated" => "Aucun ID de contenu indiqué",
"No question indicated" => "Aucune question indiquée",
"No quiz indicated" => "Aucun QCM indiqué",
// "View this wiki page" => "View this wiki page",
"No structure indicated" => "Aucune structure indiquée",
"Invalid structure_id or page_ref_id" => "Structure_id ou page_ref_id invalide",
"You do not have permission to edit submissions" => "Vous n'avez pas les droits pour modifier les articles publiés",
"You have to create a topic first" => "Vous devez créer un sujet d'abord",
// "Template directory %0 unknown" => "Template directory %0 unknown",
"You do not have permission to do that" => "Vous n'avez pas les droits pour faire cela",
"You do not have permission to write the template" => "Vous n'avez pas les droits pour écrire le gabarit",
"You do not have permission to read the template" => "Vous n'avez pas les droits pour lire le gabarit",
"No topic id specified" => "Aucun id de sujet spécifié",
"Invalid topic id specified" => "Id de sujet invalide",
"No object indicated" => "Aucun objet indiqué",
"Only wiki pages are supported" => "Seules les pages wiki sont supportées",
// "Forbidden" => "Forbidden",
// "New diagram" => "New diagram",
// "Edit diagram" => "Edit diagram",
"Override lock and carry on with edit" => "Outrepasser le verrou et continuer en mode édition",
"Page is currently being edited" => "La page est en cours d'édition",
"page imported" => "page importée",
"created from import" => "créé de l'importation",
// "To review the changes you have just made %0compare the versions%1 in history of this page" => "To review the changes you have just made %0compare the versions%1 in history of this page",
// "Page %0 saved (version %1)" => "Page %0 saved (version %1)",
// "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later",
"Can't import remote HTML page" => "On ne peut pas importer une page HTML distante",
"The Sandbox is disabled" => "Le bac à sable est désactivé",
"The page cannot be edited because it is locked" => "Cette page ne peut être modifiée : elle est verrouillée",
"That page already exists. Go back and choose a different name." => "La page existe déjà. Revenez en arrière et choisissez un nom différent.",
"The page name is" => "Le nom de la page est",
"The translation set already contains a page in this language" => "Il existe déjà une page dans pour cette traduction",
"The file cannot be opened" => "Ne peut ouvrir le fichier",
"Problem zip initialisation" => "Problème d'initialisation zip",
"Problem zip" => "Problème zip",
"Another user is currently exporting that tracker. Please try again later" => "Un autre utilisateur est en train d'exporter ce formulaire, merci de réessayer plus tard",
"No questions group indicated" => "Aucun groupe de questions indiqué",
"Remove archive: " => "Supprimer l'archive : ",
"Remove file gallery: " => "Supprimer la galerie de fichiers : ",
"You do not have permission to edit this file" => "Vous n'avez pas les droits pour modifier ce fichier",
"Most-visited file galleries" => "Galeries de fichiers les plus visitées",
"Most downloaded files" => "Fichiers les plus téléchargés",
"Last files" => "Derniers fichiers",
"No gallery ID specified" => "Aucun identificateur de galerie spécifié",
"Form error - no import method selected for some reason." => "Erreur de formulaire - aucune méthode d'import n'a été sélectionnée.",
"Form error - no server-side filename entered for selected import method." => "Erreur de formulaire - aucun fichier situé sur le serveur n'a été saisi pour la méthode d'import sélectionnée.",
"No forum indicated" => "Aucun forum indiqué",
"Last forum topics" => "Derniers sujets du forum",
// "Last replied forum topics" => "Last replied forum topics",
"Most-Read Forum Topics" => "Sujets les plus lus",
"Top topics" => "Sujets les plus populaires",
"Forum posts" => "Articles de forums",
"Most-Visited Forums" => "Forums les plus visités",
"No forumId specified" => "Aucun ID de forum indiqué",
"List Forums" => "Liste des forums",
"Not supported yet." => "Pas encore supporté.",
// "All files copied" => "All files copied",
"id" => "id",
"first uploaded image" => "première image envoyée",
"last uploaded image" => "dernière image envoyée",
"first image" => "première image",
"last image" => "dernière image",
"random image" => "image choisie au hasard",
"You do not have permission to create galleries and so you cannot edit them" => "Vous n'avez pas les droits pour créer ou modifier des galeries et donc ne pouvez modifier un élément",
"You do not have permission to edit this gallery" => "Vous n'avez pas les droits pour modifier cette galerie",
"You do not have permission to remove this gallery" => "Vous n'avez pas les droits pour supprimer cette galerie",
"Top images" => "Images les plus populaires",
"Last images" => "Dernières images",
"No valid renderer found. GD or PDFLib required." => "Aucun moteur de rendu trouvé. GD ou PDFLib nécessaire.",
"No sheet specified." => "Aucun feuillet spécifié.",
// "Unknown Graphic" => "Unknown Graphic",
// "Unknown Renderer" => "Unknown Renderer",
"You must select a renderer." => "Vous devez choisir un moteur de rendu",
"Invalid Series for current graphic." => "Séries invalides pour le graphique courant.",
"overwriting old page" => "écrasement de la vieille page",
"updated from structured text import" => "modifié d'un import de Texte Structuré",
"page created" => "page créée",
"created from structured text import" => "créé d'un import de Texte Structuré",
// "Unable to locate import file" => "Unable to locate import file",
// "Pages in zip file %0 successfully imported" => "Pages in zip file %0 successfully imported",
"Invalid software name" => "Nom de logiciel non valide",
// "No wiki page specified" => "No wiki page specified",
"This version does not exist" => "Cette version n'existe pas",
"There is more than one item in the tracker with this title" => "Il y a plus d'une fiche dans ce formulaire avec ce titre",
"There are no items in the tracker with this title" => "Il n'y aucune fiche dans le formulaire avec ce titre",
// "Are you sure you want to undo the last change" => "Are you sure you want to undo the last change",
// "There is nothing to undo" => "There is nothing to undo",
"You have requested that this page be machine translated" => "Vous avez demandé à ce que cette page soit traduite automatiquement",
"However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "De toute façon, la fonctionnalité Traduction Automatique n'est pas activée. Merci de l'activer, ou de demander à un administrateur du site de le faire",
"No repository given" => "Aucun dépôt indiqué",
"This invitation does not exist or is deprecated" => "Cette invitation n'existe pas ou est obsolète",
"Congratulations! You are now part of this invitation group(s)" => "Félicitations ! Vous faites désormais partie de ce(s) groupe(s) d'invitation",
"Communication error" => "Erreur de communication",
"Invalid response provided by the Kaltura server. Please retry" => "Réponse non valide fournie par le serveur Kaltura. Merci d'essayer à nouveau",
"Are you sure you want to permanently remove the article with identifier %0" => "Êtes-vous sûr(e) de vouloir supprimer définitivement l'article dont l'idenficateur est %0",
"Are you sure you want to permanently remove these %0 articles" => "Êtes-vous sûr(e) de vouloir supprimer définitivement ces %0 artciles",
"You do not have permission to remove articles" => "Vous n'avez pas les droits pour supprimer des articles",
"You do not have permission to remove banners" => "Vous n'avez pas les droits pour supprimer des bannières",
"List Blog Posts" => "Liste des publications de blogue",
"You do not have permission to remove this blog" => "Vous n'avez pas les droits pour supprimer ce blogue",
"You do not have permission to view the comments for this blog" => "Vous n'avez pas les droits pour voir les commentaires de ce blogue",
// "The following comment has been deleted" => "The following comment has been deleted",
// "The following comments have been deleted" => "The following comments have been deleted",
// "Delete selected comments and ban" => "Delete selected comments and ban",
// "Users have been pre-selected for banning in the highlighted section of the form below" => "Users have been pre-selected for banning in the highlighted section of the form below",
// "One comment approved" => "One comment approved",
// "%0 comments approved" => "%0 comments approved",
// "No comments approved" => "No comments approved",
// "One comment rejected" => "One comment rejected",
// "%0 comments rejected" => "%0 comments rejected",
// "No comments rejected" => "No comments rejected",
// "Comment archived" => "Comment archived",
// "%0 comments archived" => "%0 comments archived",
// "No comments archived" => "No comments archived",
// "Comment unarchived" => "Comment unarchived",
// "%0 comments unarchived" => "%0 comments unarchived",
// "No comments unarchived" => "No comments unarchived",
// "Action not performed since no comments were selected" => "Action not performed since no comments were selected",
"Approved Status" => "Statut d'approbation",
"This blog has no posts" => "Ce blogue n'a pas de publication",
"Dynamic content" => "Contenu dynamique",
// "Admin FAQs" => "Admin FAQs",
"Non-existent gallery" => "Galerie inexistante",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
// "One item moved" => "One item moved",
// "%0 items moved" => "%0 items moved",
// "No items moved" => "No items moved",
// "One item moved and one item failed to move" => "One item moved and one item failed to move",
// "One item moved and %0 items failed to move" => "One item moved and %0 items failed to move",
// "%0 items moved and one item failed to move" => "%0 items moved and one item failed to move",
// "%0 items moved and %0 items failed to move" => "%0 items moved and %0 items failed to move",
// "One item deleted" => "One item deleted",
// "%0 items deleted" => "%0 items deleted",
// "No items deleted" => "No items deleted",
// "One item deleted and one item failed to delete" => "One item deleted and one item failed to delete",
// "One item deleted and %0 items failed to delete" => "One item deleted and %0 items failed to delete",
// "%0 items deleted and one item failed to delete" => "%0 items deleted and one item failed to delete",
// "%0 items moved and %0 items failed to delete" => "%0 items moved and %0 items failed to delete",
// "List view settings reset for one gallery" => "List view settings reset for one gallery",
// "List view settings reset for %0 galleries" => "List view settings reset for %0 galleries",
// "List view settings not changed for the selected gallery" => "List view settings not changed for the selected gallery",
// "List view settings not changed for the %0 selected galleries" => "List view settings not changed for the %0 selected galleries",
// "List view settings reset for %0 galleries and not changed for one gallery" => "List view settings reset for %0 galleries and not changed for one gallery",
// "List view settings reset for %0 galleries and not changed for %0 galleries" => "List view settings reset for %0 galleries and not changed for %0 galleries",
// "No files selected" => "No files selected",
// "Metadata refreshed for one file" => "Metadata refreshed for one file",
// "Metadata refreshed for %0 files" => "Metadata refreshed for %0 files",
// "Metadata not refreshed" => "Metadata not refreshed",
// "Metadata refreshed for one file and not refreshed for one file" => "Metadata refreshed for one file and not refreshed for one file",
// "Metadata refreshed for one file and not refreshed for %0 files" => "Metadata refreshed for one file and not refreshed for %0 files",
// "Metadata refreshed for %0 files and not refreshed for one file" => "Metadata refreshed for %0 files and not refreshed for one file",
// "Metadata refreshed for %0 files and not refreshed for %0 files" => "Metadata refreshed for %0 files and not refreshed for %0 files",
// "Incorrect file ID" => "Incorrect file ID",
"The file is already locked by %s" => "Le fichier est déjà verrouillé par %s",
// "File unlocked" => "File unlocked",
// "File not unlocked" => "File not unlocked",
// "Files in this gallery are not lockable" => "Files in this gallery are not lockable",
"You don't have permission to validate files from this gallery" => "Permission refusée, vous ne pouvez pas valider de fichiers de cette galerie",
// "Error retrieving file" => "Error retrieving file",
// "Draft validated" => "Draft validated",
// "Validation failed" => "Validation failed",
// "File deleted" => "File deleted",
// "File not deleted" => "File not deleted",
// "Metadata refreshed" => "Metadata refreshed",
// "You need upload permission to edit files" => "You need upload permission to edit files",
// "You need permission to create galleries to edit them" => "You need permission to create galleries to edit them",
// "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode" => "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode",
"Quota too big" => "Quota trop important",
"Quota too small" => "Quota trop restreint",
// "Gallery %0 created or modified" => "Gallery %0 created or modified",
// "Gallery %0 not created or modified" => "Gallery %0 not created or modified",
// "You do not have permission to duplicate this gallery" => "You do not have permission to duplicate this gallery",
// "Gallery duplicated" => "Gallery duplicated",
// "Gallery not duplicated" => "Gallery not duplicated",
// "Remove file gallery %0" => "Remove file gallery %0",
// "Incorrect gallery ID" => "Incorrect gallery ID",
// "Gallery %0 deleted" => "Gallery %0 deleted",
// "Gallery %0 not deleted" => "Gallery %0 not deleted",
"Could not find the file requested" => "Fichier demandé non trouvé",
// "File %0 updated" => "File %0 updated",
// "File %0 not updated" => "File %0 not updated",
// "Invalid %0 parameter" => "Invalid %0 parameter",
// "File %0 not found" => "File %0 not found",
// "User watch added" => "User watch added",
// "User watch not added" => "User watch not added",
// "User watch removed" => "User watch removed",
// "User watch not removed" => "User watch not removed",
// "Not modified for" => "Not modified for",
// "Not downloaded for" => "Not downloaded for",
"This gallery does not exist" => "Cette galerie n'existe pas",
"Error importing" => "Erreur pendant l'importation",
"Error converting" => "Erreur pendant la conversion",
"Importing" => "Importation en cours",
"Processing" => "En cours de traitement",
"Ready" => "Prêt",
// "Pending moderation" => "Pending moderation",
"Blocked" => "Bloqué",
"Invalid action" => "Action non valide",
// "Remove permission %0 from %1" => "Remove permission %0 from %1",
// "Assign permission %0 to %1" => "Assign permission %0 to %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
"Are you sure you want to permanently remove the submitted article with identifier %0" => "Êtes-vous sûr(e) de vouloir supprimer définitivement l'article soumis ayant pour identifiant %0",
"Are you sure you want to permanently remove these %0 submitted articles" => "Êtes-vous sûr(e) de vouloir supprimer définitivement ces %0 articles soumis",
"Are you sure you want to approve these %0 submitted articles" => "Êtes-vous sûr(e) de vouloir approuver ces %0 articles soumis",
// "Are you sure you want to permanently remove all expired submitted articles" => "Are you sure you want to permanently remove all expired submitted articles",
// "Pages not in a structure" => "Pages not in a structure",
// "You are neither an administrator nor an operator of live support" => "You are neither an administrator nor an operator of live support",
"Username field cannot be empty. Please go back and try again" => "Le champ nom d'utilisateur ne peut être vide. Corriger et réessayer",
"Unable to contact remote server." => "Incapable de contacter le serveur distant.",
"XMLRPC Error: " => "Erreur XMLRPC : ",
"Unable to create login" => "Incapable de créer un utilisateur",
// "No groups set on Intertiki client" => "No groups set on Intertiki client",
// "%d or more unsuccessful login attempts have been made" => "%d or more unsuccessful login attempts have been made",
"Your account has been suspended" => "Votre compte a été suspendu",
// "Contact your site administrator to reactivate it" => "Contact your site administrator to reactivate it",
"An email has been sent to you with the instructions to follow." => "Un courriel vous a été envoyé avec les instructions à suivre.",
"Account requires administrator approval" => "Compte désactivé",
"You did not validate your account" => "Vous n'avez pas validé votre compte",
"Resend" => "Envoyer à nouveau",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "Vous devez avoir reçu un e-mail. Vérifiez votre boite à lettres et votre dossier spams. Sinon cliquez sur le bouton pour envoyer à nouveau l'e-mail",
"You must use the right case for your username" => "Vous devez respecter majuscules et minuscules pour votre nom utilisateur",
"You are not yet validated" => "Votre compte n'a pas encore été validé",
"You are already logged in" => "Vous êtes déjà connecté",
// "Authentication error" => "Authentication error",
"The mail can't be sent. Contact the administrator" => "Le courriel ne peut pas être envoyé. Contactez l'administrateur",
// "There is more than one user account with this email. Please contact the administrator" => "There is more than one user account with this email. Please contact the administrator",
"Your default nickname is already in use. A new one has to be selected." => "Votre pseudonyme est déjà utilisé. Veuillez en choisir un autre.",
"Verification cancelled" => "Verification annulée",
"The selected account is not associated with your identity" => "Le compte sélectionné n'est pas associé à votre identité",
"unknown action" => "action inconnue",
"Authentication method is not OpenID" => "La méthode d'authentification n'est pas OpenID",
"Authentication error; probably not a valid OpenID" => "Erreur d'authentification ; probablement l'OpenID n'est pas valide",
"Could not redirect to server: " => "Redirection vers le serveur impossible : ",
"OpenID authentication failed: " => "L'authentification OpenID a échoué : ",
// "You have already validated your account. Please log in" => "You have already validated your account. Please log in",
"No page provided" => "Aucune page fournie",
// "User module unassigned" => "User module unassigned",
// "User module not unassigned" => "User module not unassigned",
// "User module moved up" => "User module moved up",
// "User module not moved up" => "User module not moved up",
// "User module moved down" => "User module moved down",
// "User module not moved down" => "User module not moved down",
// "User module moved to opposite side" => "User module moved to opposite side",
// "User module not moved to opposite side" => "User module not moved to opposite side",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
"You must log in to use this feature" => "Vous devez vous inscrire pour utiliser cette fonctionnalité",
// "\$tikiMonitorRestriction need to be an array" => "\$tikiMonitorRestriction need to be an array",
"My Account Home" => "Accueil - Mon Tiki",
"You do not have permission to view other users data" => "Vous n'avez pas les droits pour afficher les données des autres utilisateurs",
// "Subscription confirmed for newsletter %0 (%1)" => "Subscription confirmed for newsletter %0 (%1)",
// "Subscription request failed" => "Subscription request failed",
// "You have been unsubscribed from newsletter %0" => "You have been unsubscribed from newsletter %0",
// "Your request to unsubscribe failed" => "Your request to unsubscribe failed",
"You must be logged in to subscribe to newsletters" => "Vous devez vous connecter pour vous inscrire à une lettre d'informations",
// "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter" => "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter",
// "Newsletter not subscribed" => "Newsletter not subscribed",
"No note indicated" => "Aucune note indiquée",
"merged note" => "note de fusion",
"The file is too large" => "Fichier trop gros",
"No item indicated" => "Aucune fiche indiquée",
"Are you sure you want to delete this note" => "Etes-vous sûr de vouloir supprimer cette note",
"created from notepad" => "créé à partir du bloc-note",
"Note not found" => "Note non trouvée",
"No name indicated for wiki page" => "Aucun nom indiqué pour la page Wiki",
"Not enough information to display this page" => "Information insuffisante pour afficher cette page",
"You do not have permission to assign permissions for this object" => "Vous n'avez pas les droits pour attribuer des droits d'accès à cet objet",
// "Are you sure you want to modify permissions" => "Are you sure you want to modify permissions",
// "%0 and all the children groups" => "%0 and all the children groups",
"Are you sure you want to remove the direct permissions from this object" => "Etes-vous sûr de vouloir retirer les permissions directes de cet objet",
// "Are you sure you want to paste the copied permissions into this object" => "Are you sure you want to paste the copied permissions into this object",
// "Error while processing payment: " => "Error while processing payment: ",
// "Payment has been confirmed" => "Payment has been confirmed",
// "Payment confirmation has not been received yet" => "Payment confirmation has not been received yet",
"Manual payment entered" => "Paiement manuel saisi",
"You do not have permission to enter payment" => "Vous n'avez pas les droits pour entrer un paiement",
"New payment requested" => "Nouveau paiement requis",
"Cancel payment %0" => "Annuler le paiement %0",
"Payment canceled" => "Paiement annulé",
// "You need permission to edit pages in order to experiment on plugin LIST" => "You need permission to edit pages in order to experiment on plugin LIST",
// "No preference given" => "No preference given",
// "This preference is not translatable" => "This preference is not translatable",
"No article indicated" => "Aucun article indiqué",
"Article is not published yet" => "Cet article n'a pas encore été publié",
"No post indicated" => "Aucun article indiqué",
"Blog not found" => "Blogue introuvable",
// "Missing object list type argument" => "Missing object list type argument",
"Index (%0)" => "Index (%0)",
"No pages indicated" => "Aucune page indiquée",
"Multiple Print" => "Multi-Impression",
"Pageviews" => "Affichage de page",
"No result indicated" => "Aucun résultat indiqué",
"Invalid or unknown username" => "Nom utilisateur invalide ou inconnu",
"Unable to send mail. User has not configured email" => "Impossible d'envoyer le courriel. L'utilisateur n'a pas configuré son adresse électronique",
"Invalid or unknown email address" => "Adresse électronique incorrecte ou inconnue",
"Please provide a username or email address" => "Merci de fournir un nom d'utilisateur ou une adresse mail",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Veuillez contacter l'Administrateur du site si vous ne recevez pas l'e-mail, ou s'il y a un problème avec la réinitialisation du mot de passe",
"An email with a link to reset your password has been sent " => "Un courriel comportant un lien qui permet de réinitialiser votre mot de passe a été envoyé ",
// "to the email" => "to the email",
"to the registered email address for" => "à l'adresse électronique inscrite pour",
// "Rename wiki page" => "Rename wiki page",
// "Page renamed from %0 to %1. Semantic alias redirect created" => "Page renamed from %0 to %1. Semantic alias redirect created",
// "Are you sure you want to roll back \"%0\" to version #%1" => "Are you sure you want to roll back \"%0\" to version #%1",
"Non-existent version" => "Version inexistante",
"Tiki RSS Feed Error Message: %0" => "Message d'erreur du canal de syndication Tiki RSS : %0",
"This match was not case sensitive" => "Cette correspondance n'était pas sensible à la casse",
"No items selected" => "Aucuns éléments selectionnés",
"Page cannot be found: " => "La page est introuvable : ",
"Page has changed since preview: " => "La page a été modifiée depuis la prévisualisation : ",
"Page not updated due to error in replacing: " => "Page non mise à jour dû à une erreur de substitution : ",
"Page updated: " => "Page mise à jour : ",
"Search Stats" => "Statistiques de recherche",
"%0: Results for \"%1\"" => "%0: Résultats pour \"%1\"",
// "Your query was stored" => "Your query was stored",
// "Searchindex" => "Searchindex",
"A problem occurred during file uploading" => "Un problème est survenu pendant le chargement des données",
// "File causing trouble was at rank" => "File causing trouble was at rank",
// "The error was %0" => "The error was %0",
"Error: You can't send the same newsletter by refreshing this frame content" => "Erreur : Vous ne pouvez pas envoyer la même lettre de nouvelles en rafraichissant le contenu de ce cadre",
"No newsletters available." => "Aucune lettre d'informations n'est disponible.",
"Cannot login to server maybe the server is down" => "Impossible de se connecter au serveur, le serveur est peut-être inaccessible",
"successfully sent" => "envoyé avec succès",
"not sent" => "pas envoyé",
"Error: " => "Erreur : ",
"Send Pages" => "Envoyer des pages",
"Notice: this variable may not be empty" => "Remarque : cette variable ne peut pas être vide",
"Notice: invalid variable value" => "Remarque : valeur de variable invalide",
"Report to the webmaster" => "Signaler au webmestre",
"Token called" => "Jeton appelé",
"Error sending tweet" => "Erreur lors de l'envoi du tweet",
"Your link was sent" => "Votre lien a été envoyé",
"One of the email addresses that was input is invalid" => "L'une des adresses email que vous avez saisie est invalide",
"Your email is mandatory" => "Votre e-mail est obligatoire",
"Error sending mail to" => "Erreur lors de l'envoi d'un courriel à",
"Share page" => "Partager la page",
"No text given for tweet" => "Aucun texte fourni pour le tweet",
"You don't have permission to post in this forum" => "Permission de publier dans le forum refusée",
"Spreadsheet - " => "Feuille de calcul - ",
"Are you sure you want to delete this spreadsheet" => "Êtes-vous sûr de vouloir supprimer cette feuille de calcul",
// "URL provided is empty or unsupported" => "URL provided is empty or unsupported",
// "Unable to generate a short url for the requested resource" => "Unable to generate a short url for the requested resource",
// "'%0' short url" => "'%0' short url",
"You do not have permission to edit messages %0" => "Vous n'avez pas le droit d'éditer le message %0",
// "Sitemap file not available" => "Sitemap file not available",
// "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator" => "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator",
// "Exporting slideshow as PDF requires a working installation of mPDF" => "Exporting slideshow as PDF requires a working installation of mPDF",
// "Export to PDF error: %0" => "Export to PDF error: %0",
"Permission denied. You cannot view this page" => "Permission refusée. Vous ne pouvez pas visualiser cette page",
// "Email is mandatory" => "Email is mandatory",
"Username and email are mandatory" => "Nom d'utilisateur et adresse mail sont obligatoires",
"The email address is invalid" => "L'adresse mail est invalide",
"Clean the sql logs" => "Purger les logs SQL",
"Are you sure you want to clear all statistics and data for this survey" => "Êtes-vous certain de vouloir supprimer toutes les statistiques de ce sondage?",
// "The following list of changes has been reverted" => "The following list of changes has been reverted",
// "Log already reverted" => "Log already reverted",
// "Invalid System Log ID" => "Invalid System Log ID",
"You cannot take this quiz twice" => "Vous ne pouvez remplir ce QCM deux fois",
"The quiz time limit was exceeded. The quiz score cannot be computed" => "Limite de temps dépassée : le QCM ne peut pas être traité",
"You cannot take this survey twice" => "Vous ne pouvez pas répondre à cette enquête deux fois",
"Please create a category first" => "SVP, créer d'abord une catégorie",
// "Committing.." => "Committing..",
// "Could not save" => "Could not save",
"No trackerId specified" => "Pas d'identifiant de formulaire spécifié",
"Incorrect file gallery" => "Mauvaise galerie de fichier",
"You must lock the file before editing it" => "Vous devez verrouiller ce fichier avant de le modifier",
"Error processing zipped image package" => "Erreur lors du traitement du fichier zip d'images",
"No permission to upload zipped image packages" => "Aucun droit pour envoyer des paquetages d'images zippées",
"The uploaded file is not recognized as a image" => "Le premier fichier envoyé n'est pas une image",
"You do not have permission to upload images" => "Vous n'avez pas les droits pour envoyer dimages",
"You have permission to upload images but not to this gallery" => "Droit d'accès refusé : vous pouvez envoyer des images, mais pas dans cette galerie",
"Cannot get image from URL" => "Impossible d'obtenir d'image de cette adresse Web",
"That is not an image (or you have php < 4.0.5)" => "Ceci n'est pas une image (ou votre version php < 4.0.5)",
"Usage" => "Utilisation",
// "Default user modules restored" => "Default user modules restored",
// "Default user modules not restored" => "Default user modules not restored",
// "User module assigned" => "User module assigned",
// "User module not assigned" => "User module not assigned",
// "User module display order moved up. Displayed order may not change if other modules now have the same order rank" => "User module display order moved up. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved up" => "User module display order not moved up",
// "User module display order moved down. Displayed order may not change if other modules now have the same order rank" => "User module display order moved down. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved down" => "User module display order not moved down",
// "User module moved to left column" => "User module moved to left column",
// "User module not moved to left column" => "User module not moved to left column",
// "User module moved to right column" => "User module moved to right column",
// "User module not moved to right column" => "User module not moved to right column",
"TOP" => "RACINE",
"No URL indicated" => "Aucune adresse Web indiquée",
"ERROR: Either the subject or body must be non-empty" => "ERREUR : Le sujet et le corps ne peuvent pas être vides en même temps",
"Unknown user" => "Utilisateur inconnu",
// "Added new structure route" => "Added new structure route",
// "Deleted structure route" => "Deleted structure route",
// "Updated structure route" => "Updated structure route",
// "Notification preferences set" => "Notification preferences set",
// "Errors were encountered when setting notification preferences" => "Errors were encountered when setting notification preferences",
"Email is set to %s" => "L'adresse électronique est changée en %s",
"Password has been changed" => "Le mot de passe a été changé",
"Invalid password. Your current password is required to change administrative information" => "Mot de passe invalide. Votre mot de passe actuel est requis pour modifier vos paramètres administratifs",
"The passwords did not match" => "Les mots de passe ne correspondent pas",
"If you really want to delete your account, you must check the checkbox" => "Si vous souhaitez vraiment supprimer votre compte, vous devez cocher la case.",
// "User report preferences saved" => "User report preferences saved",
// "User report preferences not saved" => "User report preferences not saved",
// "User reports disabled" => "User reports disabled",
// "User report not disabled" => "User report not disabled",
"was moved to the trash" => "a été mis à la corbeille",
"was moved to the trash by" => "mis à la corbeille par",
"open / in process" => "ouvert / en cours",
"Rights by creator" => "Droits par créateur",
"END" => "FIN",
"Percentage" => "Pourcentage",
"Task accepted by creator" => "Tâche acceptée par le créateur",
"Task accepted by task user" => "Tâche acceptée par l'utilisateur de la tâche",
"Task NOT accepted by creator" => "Tâche REFUSÉE par le créateur",
"Task NOT accepted by task user" => "Tâche REFUSÉE par l'utilisateur de la tâche",
"Sorry, this task does not exist or you don't have permission to view this task" => "Désolé, cette tâche n'existe pas ou vous n'avez pas les droits de la voir",
"Task entries" => "Description de la tâche",
"Changes" => "Changements",
"Info message" => "Message d'info",
"NEW Task" => "NOUVELLE tâche",
"Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks!" => "Désolé, vous ne pouvez envoyer une tâche à un autre utilisateur, ou l'utilisateur n'a pas les droits de recevoir des tâches",
"Changes on Task" => "Modifications de la tâche",
"You received a new task" => "Vous avez reçu une nouvelle tâche",
"The priority is" => "La priorité est",
"very low" => "très bas",
"high" => "haut",
"very high" => "très haut",
"You must start your work at least on" => "Vous devez commencer le travail au moins le",
"You must finish your work on" => "Vous devez finir le travail pour le",
"Log in and click the link below" => "Connectez-vous et cliquez sur le lien ci-dessous",
"Please read the task and work on it!" => "SVP, lisez la tâche et travaillez dessus !",
"Sorry, there was an error while trying to write data into the database" => "Désolé, il y a une erreur lors de l'enregistrement des données dans la base de données",
// "Unsubscribe from user watch email notifications" => "Unsubscribe from user watch email notifications",
// "Unsubscribed from user watch email notification" => "Unsubscribed from user watch email notification",
// "Unsubscribe failed" => "Unsubscribe failed",
// "Unknown watch type" => "Unknown watch type",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "User watch deleted" => "User watch deleted",
// "User watch not deleted" => "User watch not deleted",
"Cannot upload this file. The storage quota would be exceeded" => "Envoi du fichier impossible, quota insuffisant",
"No user indicated" => "Aucun utilisateur indiqué",
"Non-existent user" => "Utilisateur inexistant",
"No banner indicated" => "Aucune bannière indiquée",
"No blog indicated" => "Aucun blogue indiqué",
"Post not found" => "Publication non trouvée",
"You do not have permission to view this blog post while it is marked as private" => "Vous n'avez pas les droits pour voir ce billet car il est catalogué comme étant privé",
"No cache information available" => "Aucune information sur l'antémémoire disponible",
"You must suggest a question; please try again" => "Vous devez proposer un question, merci de recommencer",
"No FAQ indicated" => "Aucune FAQ indiquée",
// "Are you sure you want to remove that attachment" => "Are you sure you want to remove that attachment",
// "Are you sure you want to remove that topic" => "Are you sure you want to remove that topic",
"You do not have permission to remove someone else's post!" => "Vous n'êtes pas autorisé à effacer les publications de quelqu'un d'autre!",
"Incorrect thread" => "Fil de discussion incorrect",
// "Thread %0 does not exist" => "Thread %0 does not exist",
"No thread indicated" => "Aucun fil de discussion indiqué",
"Files are read only at this time" => "Les fichiers sont en lecture seule à cet instant",
"Are you sure you want to clone this spreadsheet" => "Etes-vous sûr de vouloir dupliquer cette feuille de calcul",
"Clone Error" => "Erreur Clonage",
"Are you sure you want to roll back this spreadsheet" => "Êtes-vous sûr de vouloir revenir à la précédente version de cette feuille de calcul",
"Rollback Error" => "Erreur lors du retour arrière",
// "Tracker Added To Spreadsheet" => "Tracker Added To Spreadsheet",
// "Tracker Removed From Spreadsheet" => "Tracker Removed From Spreadsheet",
// "Spreadsheet added" => "Spreadsheet added",
// "Spreadsheet removed" => "Spreadsheet removed",
"File removed" => "Fichier supprimé",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Create or view tracker" => "Create or view tracker",
// "Admin this tracker" => "Admin this tracker",
// "Are you sure you want to delete the selected items" => "Are you sure you want to delete the selected items",
"Create tracker item" => "Créer une fiche de formulaire",
// "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission" => "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission",
// "Are you sure you want to permanently delete this item" => "Are you sure you want to permanently delete this item",
"Are you sure you want to remove this attachment" => "Êtes-vous sûr de vouloir retirer cette pièce-jointe",
"Edit/Delete" => "Modifier/Supprimer",
"You don't have a personal tracker item yet. Click here to make one" => "Vous n'avez pas encore enregistré de fiche dans votre formulaire personnel. Cliquer ici pour en créer une",
"That tracker does not use extras." => "Ce formulaire n'utilise pas de supplément pour les pièces attachées.",
"Address book" => "Carnet d'adresses",
"Top pages" => "Pages les plus populaires",
"Last pages" => "Dernières pages",
// "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace" => "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace",
);
