<?php
// (c) Copyright by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// The original strings (English) are case-sensitive.

/* Note for translators about translation of text ending with punctuation
 *
 * The current list of concerned punctuation can be found in 'lib/init/tra.php'
 * On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
 * For clarity, we explain here only for colons: ':' but it is the same for the rest
 *
 * Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
 *
 * Technical justification:
 * If a string ending with colon needs translating (like "{tr}Login:{/tr}")
 * then Tiki tries to translate 'Login' and ':' separately.
 * This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
 * and it still allows to translate ":" as " :" for languages that
 * need it (like French)
 * Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
 * This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.
 */
$lang = array(
"Welsh" => "웨일스어",
"Slovene" => "슬로베니아어",
"Arabic" => "아라빅",
"Bulgarian" => "불가리안",
"Catalan" => "카탈루냐",
"Simplified Chinese" => "간체 중국어",
"Czech" => "체코어",
"Danish" => "덴마크어",
"German" => "독일어",
"English" => "영어",
"English British" => "영국 영어",
"Spanish" => "스페인어",
"Greek" => "그리스어",
"Farsi" => "페르시아어",
"Finnish" => "핀란드어",
"Fijian" => "피지어",
"French" => "프랑스어",
"Frisian Netherlands" => "프리지아어 (네덜란드)",
"Galician" => "갈리시아어",
"Hebrew" => "히브리어",
"Croatian" => "크로아티아어",
"Indonesian" => "인도네시아어",
"Icelandic" => "아이슬랜드어",
"Italian" => "이탈리아어",
"Inuktitut" => "이누크티투트어",
"Inuktitut (Roman)" => "이누크티투트어 (Roman)",
// "Iniunnaqtun" => "Iniunnaqtun",
"Japanese" => "일본어",
"Korean" => "한국어",
"Hungarian" => "헝가리어",
"Lithuanian" => "리투아니아어",
"Low German" => "저지 독일어",
"Dutch" => "네덜란드어",
"Norwegian" => "노르웨이어",
"Polish" => "폴란드어",
"Portuguese" => "포르투갈어",
"Brazilian Portuguese" => "브라질 포르투갈어",
"Romanian" => "로마니아어",
"Romansh" => "로망슈어",
"Russian" => "러시아어",
// "Pijin Solomon" => "Pijin Solomon",
"Sinhala" => "스리랑카어",
"Slovak" => "슬로바키아어",
"Albanian" => "알바니안",
"Serbian Latin" => "세르비아어 라틴문자",
"Swedish" => "스웨덴어",
// "Swahili" => "Swahili",
// "Thai" => "Thai",
"Tuvaluan" => "투발루어",
"Turkish" => "터키어",
"Traditional Chinese" => "번체 중국어",
"Ukrainian" => "우크라이나어",
// "Urdu" => "Urdu",
"Vietnamese" => "베트남어",
"Afghanistan" => "아프가니스탄",
"Aland Islands" => "올란드 제도",
"Aland_Islands" => "올란드_제도",
"Albania" => "알바니아",
"Algeria" => "알제리",
"American Samoa" => "미국령 사모아",
"American_Samoa" => "미국령_사모아",
"Andorra" => "안도라",
"Angola" => "앙골라",
"Anguilla" => "앵귈라",
"Antigua" => "안티구아",
"Argentina" => "아르헨티나",
"Armenia" => "아르메니아",
"Aruba" => "아루바",
"Australia" => "오스트렐리아",
"Austria" => "오스트리아",
"Azerbaijan" => "아제르바이잔",
"Bahamas" => "바하마",
"Bahrain" => "바레인",
"Bangladesh" => "방글라데시",
"Barbados" => "바베이도스",
"Belarus" => "벨라루시",
"Belgium" => "벨기에",
"Belize" => "벨리즈",
"Benin" => "베냉",
"Bermuda" => "버뮤다",
"Bhutan" => "부탄",
"Bolivia" => "볼리비아",
"Bosnia and Herzegovina" => "보스니아 헤르체고비나 연방",
"Bosnia_and_Herzegovina" => "보스니아_헤르체고비나_연방",
"Botswana" => "보츠와나",
"Bouvet Island" => "부베 섬",
"Bouvet_Island" => "부베_섬",
"Brazil" => "브라질",
"British Indian Ocean Territory" => "영국령 인도양 식민지",
"British Virgin Islands" => "영국령 버진 아일랜드",
"British_Indian_Ocean_Territory" => "영국령_인도양_식민지",
"British_Virgin_Islands" => "영국령_버진_아일랜드",
"Brunei" => "브루나이",
"Bulgaria" => "불가리아",
"Burkina Faso" => "부르키나파소",
"Burkina_Faso" => "부르키나파소",
"Burundi" => "부룬디",
"Cambodia" => "캄보디아",
"Cameroon" => "카메룬",
"Canada" => "캐나다",
"Cape Verde" => "카보베르데",
"Cape_Verde" => "카보베르데",
"Catalan Countries" => "카탈루냐 국가들",
"Catalan_Countries" => "카탈로니아_국가",
"Cayman Islands" => "케이맨 제도",
"Cayman_Islands" => "케이맨_제도",
"Central African Republic" => "중앙 아프리카 공화국",
"Central_African_Republic" => "중앙_아프리카_공화국",
"Chad" => "차드",
"Chile" => "칠레",
"China" => "중국",
"Christmas Island" => "크리스마스 섬",
"Christmas_Island" => "크리스마스_섬",
"Cocos Islands" => "코코스 군도",
"Cocos_Islands" => "코코스_군도",
"Colombia" => "콜롬비아",
"Comoros" => "코모로",
"Democratic Republic of the Congo" => "콩고 민주 공화국",
"Democratic_Republic_of_the_Congo" => "콩고_민주공화국",
"Congo" => "콩고",
"Cook Islands" => "쿡 제도",
"Cook_Islands" => "쿡_제도",
"Costa Rica" => "코스타리카",
"Costa_Rica" => "코스타_리카",
"Croatia" => "크로아티아",
"Cuba" => "쿠바",
"Cyprus" => "키프로스",
"Czech Republic" => "체코 공화국",
"Czech_Republic" => "체코_공화국",
"Denmark" => "덴마크",
"Djibouti" => "지부티",
"Dominica" => "도미니카",
"Dominican Republic" => "도미니카 공화국",
"Dominican_Republic" => "도미니카_공화국",
"Ecuador" => "에쿠아도르",
"Egypt" => "이집트",
"El Salvador" => "엘살바도르",
"El_Salvador" => "엘_살바도르",
// "England" => "England",
"Equatorial Guinea" => "적도 기니",
"Equatorial_Guinea" => "적도_기니",
"Eritrea" => "에리트리아",
"Estonia" => "에스토니아",
"Ethiopia" => "이디오피아",
"Europe" => "유럽",
"Falkland Islands" => "포클랜드 제도",
"Falkland_Islands" => "포클랜드_제도",
"Faroe Islands" => "페로 제도",
"Faroe_Islands" => "페로_제도",
"Federated States of Micronesia" => "미크로네시아 연방",
"Federated_States_of_Micronesia" => "미크로네시아_연방",
"Fiji" => "피지",
"Finland" => "핀란드",
"France" => "프랑스",
"French Guiana" => "프랑스령 기아나",
"French Polynesia" => "프랑스령 폴리네시아",
"French Southern Territories" => "프랑스령 남부 지역",
// "French_Guiana" => "French_Guiana",
"French_Polynesia" => "프랑스령_폴리네시아",
"French_Southern_Territories" => "프랑스_남부_지방",
"Gabon" => "가봉",
"Gambia" => "감비아",
"Georgia" => "그루지아",
"Germany" => "독일",
"Ghana" => "가나",
"Gibraltar" => "지브랄타",
"Greece" => "그리스",
"Greenland" => "그린랜드",
"Grenada" => "그레나다",
"Guadeloupe" => "과들루프",
"Guam" => "괌",
"Guatemala" => "과테말라",
"Guernsey" => "건지",
"Guinea Bissau" => "기네 비쏘",
"Guinea" => "기니",
"Guinea_Bissau" => "기네_비쏘",
"Guyana" => "가이아나",
"Haiti" => "아이티",
"Heard Island and McDonald Islands" => "허드 섬 및 맥도널드 제도",
"Heard_Island_and_McDonald_Islands" => "허드_섬_및_맥도널드_제도",
"Honduras" => "온두라스",
"Hong Kong" => "홍콩",
"Hong_Kong" => "홍콩",
"Hungary" => "헝가리",
"Iceland" => "아이슬랜드",
"India" => "인도",
"Indonesia" => "인도네시아",
"Iran" => "이란",
"Iraq" => "이라크",
"Ireland" => "아일랜드",
"Isle of Man" => "맨 섬",
"Israel" => "이스라엘",
"Italy" => "이탈리아",
"Ivory Coast" => "아이보리 코스트",
"Ivory_Coast" => "아이보리_코스트",
"Jamaica" => "자메이카",
"Japan" => "일본",
"Jersey" => "저지",
"Jordan" => "조르단",
"Kazakstan" => "카자흐스탄",
"Kenya" => "케냐",
"Kiribati" => "키리바시",
"Kuwait" => "쿠웨이트",
"Kyrgyzstan" => "키르기스스탄",
"Laos" => "라오스",
"Latvia" => "라트비아",
"Lebanon" => "레바논",
"Lesotho" => "레소토",
"Liberia" => "라이베리아",
"Libya" => "리비야",
"Liechtenstein" => "리히텐슈타인",
"Lithuania" => "리투아니아",
"Luxemburg" => "룩셈부르크",
"Macao" => "마카오",
"Macedonia" => "마케도니아",
"Madagascar" => "마다가스카르",
"Malawi" => "말라위",
"Malaysia" => "말레이지아",
"Maldives" => "몰디브",
"Mali" => "말리",
"Malta" => "말타",
"Marshall Islands" => "마샬 군도",
"Marshall_Islands" => "마샬_군도",
"Martinique" => "마르티니크",
"Mauritania" => "모리타니",
"Mauritius" => "모리셔스",
"Mayotte" => "마요트",
"Mexico" => "멕시코",
"Moldova" => "몰도바",
"Monaco" => "모나코",
"Mongolia" => "몽골",
"Montenegro" => "몬테네그로",
"Montserrat" => "몬트세라트",
"Morocco" => "모로코",
"Mozambique" => "모잠비크",
"Myanmar" => "미얀마",
"Namibia" => "나미비아",
"Nauru" => "나우루",
"Nepal" => "네팔",
"Netherlands Antilles" => "네덜란드령 앤틸리스",
"Netherlands" => "네덜란드",
"Netherlands_Antilles" => "네덜란드령_앤틸리스",
"New Caledonia" => "새 달력",
"New Zealand" => "뉴질랜드",
"New_Caledonia" => "뉴칼레도니아 ",
"New_Zealand" => "뉴질랜드",
"Nicaragua" => "니카라과",
"Niger" => "니제르",
"Nigeria" => "나이지리아아",
"Niue" => "니우에",
"None" => "없음",
"Norfolk Island" => "노퍽 섬",
"Norfolk_Island" => "노퍽_섬",
"North Korea" => "북한",
"North_Korea" => "북한",
"Northern Mariana Islands" => "북마리아나 군도",
"Northern_Mariana_Islands" => "북마리아나_군도",
"Norway" => "노르웨이",
"Oman" => "오만",
"Other" => "기타",
"Pakistan" => "파키스탄",
"Palau" => "팔라우",
"Palestine" => "팔레스타인",
"Panama" => "파나마",
"Papua New Guinea" => "파푸아뉴기니",
"Papua_New_Guinea" => "파푸아뉴기니",
"Paraguay" => "파라구아이",
"Peru" => "페루",
"Philippines" => "필리핀",
"Pitcairn" => "핏케언 군도",
"Poland" => "폴란드",
"Portugal" => "포르투갈",
"Puerto Rico" => "푸에토리코",
"Puerto_Rico" => "푸에토리코",
"Quatar" => "카타르",
"Republic of Macedonia" => "마케도니아 공화국",
"Republic_of_Macedonia" => "마케도니아_공화국",
"Reunion" => "재결합",
"Romania" => "로마니아",
"Russia" => "러시아",
"Russian Federation" => "러시아 연합",
"Russian_Federation" => "러시아_연합",
"Rwanda" => "르완다",
"Saint Helena" => "세인트 헬레나",
"Saint Kitts and Nevis" => "세인트 크리스토퍼 네비스",
"Saint Lucia" => "세인트 루시아",
"Saint Pierre and Miquelon" => "세인트 피에르 미켈론",
"Saint_Helena" => "세인트_헬레나",
"Saint_Kitts_and_Nevis" => "세인트_크리스토퍼_네비스",
"Saint_Lucia" => "세이트_루시아",
"Saint_Pierre_and_Miquelon" => "세인트_피에르_미켈론",
"Samoa" => "사모아",
"San Marino" => "산마리노",
"San_Marino" => "산_마리노",
"Sao Tome and Principe" => "상투메 프린시페",
"Sao_Tome_and_Principe" => "상투메_프린시페",
"Saudi Arabia" => "사우디 아라비아",
"Saudi_Arabia" => "사우디_아라비아",
"Senegal" => "세네갈",
"Serbia" => "세르비아",
"Seychelles" => "세이쉘",
"Sierra Leone" => "시에라리온",
"Sierra_Leone" => "시에라리온",
"Singapore" => "싱가폴",
"Slovakia" => "슬로바키아",
"Slovenia" => "슬로베니아",
"Solomon Islands" => "솔로몬 군도",
"Solomon_Islands" => "솔로몬_군도",
"Somalia" => "소말리아",
"South Africa" => "남아프리카",
"South Georgia and South Sandwich Islands" => "사우스조지아 사우스샌드위치 제도",
"South Korea" => "대한민국",
"South_Africa" => "남_아프리카",
"South_Georgia_and_South_Sandwich_Islands" => "사우스조지아_사우스샌드위치_제도",
"South_Korea" => "대한민국",
"Spain" => "스페인",
"Sri Lanka" => "스리랑카",
"Sri_Lanka" => "스리랑카",
"St Vincent Grenadines" => "세인트 빈센트 그레나딘",
"St_Vincent_Grenadines" => "세인트_빈센트_그레나딘",
"Sudan" => "수단",
"Surinam" => "수리남",
"Svalbard and Jan Mayen" => "스발바르드 및 얀마이옌",
"Svalbard_and_Jan_Mayen" => "스발바르드_및_얀마이옌",
"Swaziland" => "스와질랜드",
"Sweden" => "스웨덴",
"Switzerland" => "스위스",
"Syria" => "시리아",
"Taiwan" => "대만",
"Tajikistan" => "타지키스탄",
"Tanzania" => "탄자니아",
"Thailand" => "태국",
"Timor-Leste" => "동티모르",
"Togo" => "토고",
"Tokelau" => "토켈라우",
"Tonga" => "통가",
"Trinidad Tobago" => "트리니다드 토바고",
"Trinidad_Tobago" => "트리니다드_토바고",
"Tunisia" => "튀니지아",
"Turkey" => "터키",
"Turkmenistan" => "투르크메니스탄",
"Turks and Caicos Islands" => "터크스 카이코스 군도",
"Turks_and_Caicos_Islands" => "터크스_타이코스_군도",
"Tuvalu" => "투발루",
"US Virgin Islands" => "미국령 버진아일랜드",
"US_Virgin_Islands" => "미국령_버진_아일랜드",
"Uganda" => "우간다",
"Ukraine" => "우크레인",
"United Arab Emirates" => "아랍에미리트",
"United Kingdom" => "영국",
"United Nations Organization" => "국제 연합 기구",
"United States Minor Outlying Islands" => "미국 소수 외부 제도",
"United States" => "미국",
"United_Arab_Emirates" => "아랍에미리트",
"United_Kingdom" => "영국",
"United_Kingdom_-_England_and_Wales" => "영국_-_잉글랜드_와_웨일즈",
"United_Kingdom_-_Northern_Ireland" => "영국_-_북아일랜드",
"United_Kingdom_-_Scotland" => "영국_-_스코틀랜드",
"United_Nations_Organization" => "국제_연합_기구",
"United_States" => "미국",
"United_States_Minor_Outlying_Islands" => "미국령_군소_제도",
"Uruguay" => "우루과이",
"Uzbekistan" => "우즈베키스탄",
"Vanuatu" => "바누아투",
"Vatican" => "바티칸",
"Venezuela" => "베네주엘라",
"Viet Nam" => "베트남",
"Viet_Nam" => "베트남",
"Wales" => "웨일즈",
"Wallis and Futuna" => "월리스 푸투나",
"Wallis_and_Futuna" => "월리스_푸투나",
"Western Sahara" => "서부 사하라",
"Western_Sahara" => "서부_사하라",
"World" => "세계",
"Yemen" => "예멘",
"Yugoslavia" => "유고슬라비아",
"Zambia" => "잠비아",
"Zimbabwe" => "짐바브웨",
"the former Yugoslav Republic of Macedonia" => "구 유고슬라비아 마케도니아 공화국",
"the_former_Yugoslav_Republic_of_Macedonia" => "구_유고슬라비아_마케도니아_공화국",
// "File %0 succesfully imported" => "File %0 succesfully imported",
// "category defaults" => "category defaults",
"You must specify a directory" => "디렉터리를 반드시 지정해야 합니다",
// "ViewerJS URI not set" => "ViewerJS URI not set",
// "ViewerJS URI not found (local file not readable)" => "ViewerJS URI not found (local file not readable)",
// "ViewerJS URI not found (%0)" => "ViewerJS URI not found (%0)",
// "Tags successfully cleaned up" => "Tags successfully cleaned up",
// "Tag cleanup failed" => "Tag cleanup failed",
// "Remove orphan images" => "Remove orphan images",
// "Orphan images successfully removed" => "Orphan images successfully removed",
"moved %d images, %d errors occurred" => "%d 개의 그림 이동, %d 개의 오류 발생",
"a timeout occurred. Hit the reload button to move the rest" => "타임아웃이 발생했습니다. 나머지를 이동하려면 Reload버튼을 누르십시오",
"Tiki Email Test" => "티키 이메일 테스트",
"Tiki Test email from" => "티키 테스트 이메일 발신",
"Unable to send mail" => "메일 전송을 할 수 없었음",
"Test mail sent to" => "시험용 메일이 다음으로 발송됨",
// "Remove this server" => "Remove this server",
// "Remove this host" => "Remove this host",
// "registration choices" => "registration choices",
// "Assign users to groups based on email patterns" => "Assign users to groups based on email patterns",
// "This method of captcha is not supported by your server, please select another or upgrade" => "This method of captcha is not supported by your server, please select another or upgrade",
// "You need to select a file to upload" => "You need to select a file to upload",
// "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists" => "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists",
// "Unable to Write Password File to Disk" => "Unable to Write Password File to Disk",
// "Delete temporary index" => "Delete temporary index",
// "%d users were assigned to groups based on user emails matching the patterns defined for the groups" => "%d users were assigned to groups based on user emails matching the patterns defined for the groups",
// "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups" => "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups",
// "composer.lock file was removed" => "composer.lock file was removed",
// "composer.lock file is not writable, so it can not be removed" => "composer.lock file is not writable, so it can not be removed",
// "composer.lock file do not exists" => "composer.lock file do not exists",
// "Vendor folder contents was removed" => "Vendor folder contents was removed",
// "Vendor folder is not writable" => "Vendor folder is not writable",
// "Vendor folder do not exists" => "Vendor folder do not exists",
"Used" => "사용됨",
"Available" => "사용 가능",
"Hit" => "방문",
// "Miss" => "Miss",
"An error occurred: " => "오류가 발생했습니다:",
// "profile applied" => "profile applied",
"The following list of changes has been applied:" => "다음 변경 내역이 적용되었습니다:",
// "Profile forgotten" => "Profile forgotten",
// "New rating configuration %0 created" => "New rating configuration %0 created",
// "Rating configuration updated for %0" => "Rating configuration updated for %0",
// "Scoring events replaced with form data" => "Scoring events replaced with form data",
// "Unable to get info from log file" => "Unable to get info from log file",
"You must set a home file gallery" => "홈 파일 갤러리를 반드시 선택해야 합니다",
"Tag already exists" => "태그 이미 존재함",
// "Tag %0 created" => "Tag %0 created",
// "Tag %0 not found" => "Tag %0 not found",
// "Tag %0 restored" => "Tag %0 restored",
// "Tag %0 not restored" => "Tag %0 not restored",
// "Tag %0 removed" => "Tag %0 removed",
// "Tag %0 not removed" => "Tag %0 not removed",
// "Process to remove pictures has completed" => "Process to remove pictures has completed",
// "Dump created at %0" => "Dump created at %0",
// "Dump was not created. Please check permissions for the storage/ directory" => "Dump was not created. Please check permissions for the storage/ directory",
// "Dump file %0 removed" => "Dump file %0 removed",
// "Dump file %0 was not removed" => "Dump file %0 was not removed",
// "No update was made" => "No update was made",
// "Areas were updated" => "Areas were updated",
// "Are you sure you want to remove that post" => "Are you sure you want to remove that post",
// "Re" => "Re",
"This forum is flat and doesn't allow replies to other replies" => "이 게시판은 플랫형이고 다른 답글에 답글을 다는 것을 허용하지 않습니다",
"Copyright management" => "저작권 관리",
"No page indicated" => "페이지 지정되지 않음",
"You must supply all the information, including title and year" => "모든 정보를 반드시 제공해야 합니다, 제목과 연도를 포함하십시오",
// "Sorry, that mail has been taken by another operator" => "Sorry, that mail has been taken by another operator",
"Wiki Page" => "위키 페이지",
// "Tracker item not found" => "Tracker item not found",
// "Put this item back" => "Put this item back",
// "Taken by %0" => "Taken by %0",
// "Take this email" => "Take this email",
// "TAKE" => "TAKE",
"View contact" => "연락처 보기",
// "ID" => "ID",
"Type" => "종류",
"Name" => "이름",
"Description" => "설명",
"Size" => "크기",
"Created" => "작성일",
"Uploaded" => "업로드일",
"Last modified" => "최종변경날짜",
"Uploaded by" => "업로드한 이",
"Creator" => "만든이",
"Last modified by" => "마지막 수정하신 분",
"Comment" => "댓글",
"Files" => "파일",
"Hits" => "방문 수",
"Last download" => "마지막 다운로드",
"Locked by" => "잠금자",
"Backlinks" => "백링크",
// "Delete after" => "Delete after",
"Share" => "공유",
"Source" => "소스",
"Explorer" => "탐색기",
"Path" => "경로",
"Slideshow" => "슬라이드쇼",
// "Gallery icon" => "Gallery icon",
"Register" => "등록",
"Group" => "그룹",
"Tiki Installer" => "티키 설치프로그램",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
"MySQL classic (mysql)" => "MySQL 클래식 (mysql)",
// "Invalid database user" => "Invalid database user",
"No database name specified" => "지정된 데이터베이스 이름 없음",
// "Automatic" => "Automatic",
// "Make a symlink" => "Make a symlink",
// "Make a copy" => "Make a copy",
// "Do nothing" => "Do nothing",
// "symlink created" => "symlink created",
// "copy created" => "copy created",
"Email address not valid, test mail not sent" => "이메일 주소 유효하지 않음, 테스트 메일이 발송되지 않음",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "이메일 주소가 비어있으며 \"복사\" 체크상자가 설정되지 않음, 테스트 메일이 발송되지 않음",
"Test mail from Tiki installer %0" => "티키 설치프로그램에서 온 시험용 메일 %0",
"Tiki version:" => "티키 버전:",
"PHP version" => "PHP 버전",
"Server" => "서버",
"Sent" => "전송 됨",
"Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "일부 유효하지 않은 글자가 데이터베이스명에서 감지되었습니다. 알파멧숫자 혹은 _ 혹은 - 를 사용하십시오",
"Database `%0` was created" => "'%' 데이터베이스가 만들어졌습니다",
"Database `%0` creation failed. You need to create the database" => "'%0' 데이터베이스 만들기 실패함. 데이터베이스를 만들어야 합니다",
// "Database `%0`. Unable to connect to database" => "Database `%0`. Unable to connect to database",
// "User `%0` was created" => "User `%0` was created",
// "User `%0` creation failed" => "User `%0` creation failed",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Failed to convert document into image" => "Failed to convert document into image",
// "Please check Tiki Action Log for more information" => "Please check Tiki Action Log for more information",
"No automated tax" => "자동화된 세금 없음",
"Account name must not be empty" => "계정 이름은 비어있을 수 없습니다",
"Budget is not a valid amount: " => "예산",
"Locked must be either 0 or 1" => "잠금은 0 혹은 1이야만합니다",
"Error creating account" => "계정 만들기 오류",
"AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "계정Id %0 은 이미 사용 중이고 변경되서는 안됩니다. 더 이상 필요없다면 사용 안 함으로 하십시오",
"Error updating account" => "계정 갱신 중 오류",
"Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "계정은 이미 사용 중이고 삭제되서는 안됩니다. 더 이상 필요가 없다면 사용 안 함으로 하십시오",
"Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "롤백 실패함, 일관적이지 않은 데이터베이스: %1 book 내부의 journalId %0 에 대한 클린업 필요함",
"successfully rolled back #" => "# 으로 롤백 성공",
"Booking error creating journal entry" => "저널 입력을 만드는 오류 기록 중",
"Booking error creating debit entry" => "차변 입력을 만드는 오류 기록 중",
"Booking error creating credit entry" => "크레딧 입력을 만드는 오류 기록 중",
"The number of debit entries differs: " => "차변 항목 차이의 수:",
"The number of credit entries differs: " => "신용 항목 차이의 수:",
"Splitting is only allowed on one side" => "분할은 한 쪽에서만 허용됩니다",
"Invalid debit amount " => "유효하지 않은 차변 액수",
"Invalid debit account number " => "유효하지 않은 차변 계정 번호",
"Invalid credit amount " => "유효하지 않은 신용 액수",
"Invalid credit account number " => "유효하지 않은 신용 계정 번호",
"Difference between debit and credit amounts " => "차변과 신용 금액간의 차이",
"Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "롤백 실패함, 일관적이지 않은 데이터베이스: %1 book 내부의 stackId %0 에 대한 클린업 필요함",
"Booking error creating stack entry" => "스택 입력을 만드는 오류 기록 중",
"Booking error creating stack debit entry" => "스택 차변 입력을 만드는 오류 기록 중",
"Booking error creating stack credit entry" => "스택 신용 입력을 만드는 오류 기록 중",
"Error deleting entry from stack" => "스택에서 입력항목 삭제 오류",
"Booking error confirming stack entry" => "스택 입력을 확인하는 오류 기록 중",
"Error while updating statement" => "명세서를 갱신하는 중 오류",
"is not a number" => "은 숫자가 아닙니다",
// "must be greater than 0" => "must be greater than 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
"Error checking" => "오류 검사",
"does not exist" => "존재하지 않습니다",
"already exists" => "이미 존재합니다",
"This book has been closed. You can't create new accounts" => "이 장부는 마감되었습니다. 새 계정을 만들 수 없습니다",
"This book has been closed. You can't modify the account" => "장부는 마감되었습니다. 게정을 수정할 수 없습니다",
"This book has been closed. You can't delete the account" => "이 장부는 마감되었습니다. 계정을 삭제할 수 없습니다",
"The date of the transaction is before the start date of this book" => "거래에 대한 날짜가 이 장부 시작 날짜 이전입니다",
"The date of the transaction is after the end date of this book" => "거래에 대한 날짜가 이 장부의 종료 날짜 이후입니다",
"This book has been closed. Bookings can no longer be made in it" => "이 장부는 이미 마감되었습니다. 더 이상 내용을 기입할 수 없습니다",
"Invalid booking date" => "유효하지 않은 예약 날짜",
"This book has been closed. Transactions can no longer be cancelled in it" => "이 장부는 마감되었습니다. 내부에서 거래를 더 이상 취소할 수 없습니다",
// "APC system, user and opcode caches cleared" => "APC system, user and opcode caches cleared",
// "APC %0 cache cleared" => "APC %0 cache cleared",
// "APC %0 cache not cleared" => "APC %0 cache not cleared",
"New article post" => "새 기사 게시물",
"Edited article post" => "편집된 기사 게시물",
"Deleted article post" => "기사 게시 삭제",
"The file has incorrect syntax or is not a CSV file" => "파일이 CSV형식이 아니거나 올바른 구문을 갖고있지 않습니다",
"Error line: %d" => "오류 줄: %d",
// "Import failed due to data format. Make sure the file has Unix-style line breaks" => "Import failed due to data format. Make sure the file has Unix-style line breaks",
"Spam is not welcome here" => "스팸은 환영하지 않습니다",
"anonymous" => "익명",
"Blog cannot be found" => "블로그가 발견되지 않았습니다",
"Locked by %0" => "%0 님이 잠궜습니다",
"refresh" => "갱신",
"go back to this crumb" => "이 부스러기로 돌아가기",
"Administration" => "관리",
// "Cache file %0 is not writable" => "Cache file %0 is not writable",
"All day" => "종일",
"First day of week: Sunday (its ID is 0) - Translators, you need to localize this string" => "일주일의 첫날: 일요일 (ID는 0) - 번역자들은 이 문자열을 번역해야합니다",
"Sunday" => "일요일",
"Su" => "일",
"Monday" => "월요일",
"Tuesday" => "화요일",
"Wednesday" => "수요일",
"Thursday" => "목요일",
"Friday" => "금요일",
"Saturday" => "토요일",
"Mo" => "월",
"Tu" => "화",
"We" => "수",
"Th" => "목",
"Fr" => "금",
"Sa" => "토",
// "in" => "in",
"continued" => "계속됨",
"New Image Uploaded by" => "새 그림을 업로드 하신 분:",
"New Subscriptions" => "새 구독",
"New Item in Tracker" => "트래커 내부의 새 항목",
"tracker" => "트래커",
// "by" => "by",
"Wiki" => "위키",
"Image Gallery" => "그림갤러리",
"Articles" => "기사",
"Blogs" => "블로그",
"Forums" => "게시판",
"Directory" => "디렉터리",
"File Gallery" => "파일갤러리",
"FAQs" => "FAQ",
"Quizzes" => "퀴즈",
"Trackers" => "트래커",
"Survey" => "설문",
"Newsletter" => "회보",
// "Please type this word backwards" => "Please type this word backwards",
"Empty CAPTCHA value" => "스팸 방지 문자 입력 값 비우기",
"You have mistyped the anti-bot verification code. Please try again" => "봇방지 확인 코드를 잘 못 입력하셨습니다. 다시 시도하여 주십시오",
"Failed to validate CAPTCHA" => "스팸방지문자 유효화 실패함",
"CAPTCHA ID field is missing" => "스팸 방지 문자 입력 ID 필드가 없습니다",
"Get a visual challenge" => "시각적 도전 받기",
"Get an audio challenge" => "음성 도전 받기",
"Get a new challenge" => "새 도전 받기",
"Type the two words" => "두 단어를 입력하십시오",
"Type what you hear" => "듣는 것을 입력하십시오",
"Help" => "도움말",
"Play sound again" => "음성 다시 재생",
"Download audio as an MP3 file" => "음성을 MP3로 다운로드",
"Incorrect. Try again" => "틀립니다. 다시 시도하십시오",
// "Invalid category identifier: \"%0\"" => "Invalid category identifier: \"%0\"",
"Top" => "상단",
"A category named %0 already exists in %1" => "%1 내부에 %0 라는 이름의 범주가 이미 존재합니다",
"article" => "기사",
"blog" => "블로그",
"directory" => "디렉토리",
"faq" => "자주 묻는 질문",
"FAQ" => "자주 묻는 질문",
"file gallery" => "파일 갤러리",
"forum" => "게시판",
"image gallery" => "그림 갤러리",
"newsletter" => "회보",
"poll" => "투표",
"quiz" => "퀴즈",
"survey" => "설문",
"wiki page" => "위키 페이지",
"image" => "그림",
"calendar" => "달력",
"template" => "템플릿",
"Permission denied" => "허가되지 않았습니다",
"Invalid filename (using filters for filenames)" => "유효하지 않은 파일명 (파일명에 대하여 필터 사용)",
"Cannot upload this file - maximum upload size exceeded" => "이 파일 업로드 불가 - 최대 업로드 크기 초과",
"Cannot write to this file" => "이 파일에 쓰기 불가",
"(not registered)" => "(등록되지 않음)",
"Anonymous" => "익명",
"Your comment was rejected" => "귀하의 댓글이 거부되었습니다",
"Cannot perform spam check: %0" => "스팸 확인 수행 불가: %0",
"Please wait %0 seconds between posts" => "게시 사이의 %0 초를 기다려 주십시오",
"Wrong password. Cannot post comment" => "틀린 비밀번호. 댓글 게시 불가",
"A contribution is mandatory" => "기여내역은 필수입니다",
// "Please enter a Title and Message for your new forum topic" => "Please enter a Title and Message for your new forum topic",
// "Please enter a Title and Message for your forum reply" => "Please enter a Title and Message for your forum reply",
// "Please enter a Message for your forum reply" => "Please enter a Message for your forum reply",
"Invalid Email" => "유효하지 않은 이메일",
"Your message has been queued for approval and will be posted after a moderator approves it" => "귀하의 메시지가 승인 대기상태가 되었으며 중재자 승인 후 게시됩니다",
// "Use this thread to discuss the %s page" => "Use this thread to discuss the %s page",
"This forum is locked" => "이 게시판은 잠겨있습니다",
"This thread is locked" => "이 대화목록은 잠겨있습니다",
// "An error occurred; please contact the administrator" => "An error occurred; please contact the administrator",
// "Route was updated" => "Route was updated",
// "Route was created" => "Route was created",
"Page cannot be found" => "페이지가 발견되지 않았음",
// "From is required" => "From is required",
// "There is a route with the same From path already defined" => "There is a route with the same From path already defined",
// "Type is required" => "Type is required",
// "Selected type is not supported" => "Selected type is not supported",
"To" => "끝",
"Article" => "기사",
"Blog" => "블로그",
"Forum" => "게시판",
"Object" => "개체",
"Tracker" => "트래커",
"Field" => "필드드",
"Tracker Item Id" => "트래커 항목 ID",
// "%s is required" => "%s is required",
"Error" => "오류",
"Note" => "주의",
"Success" => "성공",
"Warning" => "경고",
// "Feedback class called with no feedback provided" => "Feedback class called with no feedback provided",
// "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator" => "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator",
// "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Invalid request" => "Invalid request",
// "Failed to convert document %0 to pdf" => "Failed to convert document %0 to pdf",
// "Please check Action Log for more information" => "Please check Action Log for more information",
// "Please contact the administrator" => "Please contact the administrator",
// "H5P requires the CURL extension to be installed in PHP" => "H5P requires the CURL extension to be installed in PHP",
// "Failed to write to temp file %0" => "Failed to write to temp file %0",
// " (code=%0)" => " (code=%0)",
// "Exporting H5P content %0 failed" => "Exporting H5P content %0 failed",
// "Saving H5P content %0 (fileId %1) failed" => "Saving H5P content %0 (fileId %1) failed",
// "H5P directory is not writable: %0" => "H5P directory is not writable: %0",
// "Too many arguments on ceil" => "Too many arguments on ceil",
// "Too many arguments on date" => "Too many arguments on date",
// "Divide by zero on \"%0\"" => "Divide by zero on \"%0\"",
// "Too many arguments on floor" => "Too many arguments on floor",
"Unexpected values: %0" => "예기치 않은 값: %0",
// "Field must be provided and contain one argument: list" => "Field must be provided and contain one argument: list",
// "Field must be provided and contain a function" => "Field must be provided and contain a function",
// "Too many arguments on less than" => "Too many arguments on less than",
// "Too many arguments on more than" => "Too many arguments on more than",
// "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]" => "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]",
// "Too many arguments for pad" => "Too many arguments for pad",
// "Too few arguments for pad" => "Too few arguments for pad",
// "Too many arguments on round" => "Too many arguments on round",
// "Content required" => "Content required",
// "Field must be provided and contain one argument: separator" => "Field must be provided and contain one argument: separator",
// "Field must be provided and contain one or more values: key or keys" => "Field must be provided and contain one or more values: key or keys",
// "Str-replace needs exactly 3 arguments: search, replace and subject" => "Str-replace needs exactly 3 arguments: search, replace and subject",
// "Too many arguments on strtotime" => "Too many arguments on strtotime",
// "Too few arguments on strtotime" => "Too few arguments on strtotime",
// "Field must be provided and contain one argument: group" => "Field must be provided and contain one argument: group",
// "Field must be provided and contain at least one argument: aggregate" => "Field must be provided and contain at least one argument: aggregate",
"%0 near \"%1\"" => "%0 근처 \"%1\"",
"Expecting \"(\"" => "\"(\" 필요",
"Unexpected \"%0\"" => "예기치 않은 \"%0\"",
"Expecting \")\"" => "\")\" 필요",
"No formula provided" => "제공된 공식 없음",
"Variable not found \"%0\"" => "변수 발견되지 않음 \"%0\"",
"Unknown operation \"%0\"" => "알 수 없는 연산자 \"%0\"",
"Articles deleted" => "기사 삭제됨",
"removed the article" => "기사 제거함",
"Edited articles" => "편집된 기사들",
"edited the article" => "기사를 편집",
"New articles submitted" => "새 기사 제출됨",
"created the article" => "기사를 만듬",
"New blog posts" => "새 블로그 게시물",
"replied to the blog" => "블로그에 답글 올라옴",
"New calendar events" => "새 달력 이벤트",
"%0 added or updated event %1" => "%0님이 %1 이벤트를 추가 혹은 갱신하였습니다",
"Changes in categories" => "범주 내 변경내역",
"added the %0 %1 to the category %2" => "범주 %2 에 %0 %1 추가함",
"created the subcategory" => "하위범주를 만듬",
"removed the subcategory" => "하위범주 제거함",
// "from" => "from",
"edited the category" => "범주를 편집",
"removed the %0 %1 from the category %2" => "범주 %2 에서 %0 %1 을 제거함",
"File galleries changed" => "파일 갤러리 변경됨",
"%0 edited the file gallery %1" => "%0님이 %1 파일 갤러리를 편집하였습니다",
"%0 uploaded the file %1" => "%0님이 파일 %1을 업로드하였습니다",
// "onto" => "onto",
"%0 removed the file %1 from %2" => "%0님이 %2에서 파일 %1을 삭제하였습니다",
"New replies in forum topics" => "게시판 토픽에 새 답글",
"%0 <a href=%1>replied</a> to the topic %2" => "%0님이 %2 토픽에 <a href=%1>회신하였습니다</a> ",
"New posts in forums" => "게시판 내부 새 게시물",
"%0 created the topic %1 at forum %2" => "%0님이 %2 게시판에서 %1 토픽을 만들었습니다",
"Image galleries changed" => "그림 갤러리 변경됨",
"changed the picture gallery" => "그림 갤러리를 변경함",
"uploaded the picture" => "그림을 업로드하였습니다",
"removed the picture" => "그림 제거함",
// "Wiki pages added to a structure" => "Wiki pages added to a structure",
// "%0 added %1 wiki page to a structure" => "%0 added %1 wiki page to a structure",
// "Wiki pages moved down in a structure tree" => "Wiki pages moved down in a structure tree",
// "%0 moved a wiki page down in a structure tree" => "%0 moved a wiki page down in a structure tree",
// "Wiki pages moved up in a structure tree" => "Wiki pages moved up in a structure tree",
// "%0 moved a wiki page up in a structure tree" => "%0 moved a wiki page up in a structure tree",
// "Wiki pages removed from structure" => "Wiki pages removed from structure",
// "%0 removed %1 wiki page from a structure" => "%0 removed %1 wiki page from a structure",
"File attached to tracker" => "트래커에 첨부된 파일",
"%0 attached a file (%1) to tracker item %2" => "%0님이 파일 (%1)을 트래커 항목 %2에 첨부하였습니다",
"Comments in tracker items" => "트래커 항목들 내의 댓글들",
"%0 added a new comment to %1 on tracker %2" => "%0님이 %2 트래커의 %1로 새 댓글을 추가했습니다",
"%0 added a new comment to item id %1 on tracker %2" => "%0님이 %2 트래커의 항목 ID %1로 새 댓글을 추가했습니다",
"Tracker items modified" => "트래커 항목 수정됨",
"%0 added or updated tracker item %1 on tracker %2" => "%0님이 %2 트래커의 트래커 항목 %1을 추가 혹은 갱신하였습니다",
"%0 added or updated tracker item id %1 on tracker %2" => "%0님이 %2 트래커의 트래커 항목 ID %1을 추가 혹은 갱신하였습니다",
"New attachments in wiki pages" => "위키 페이지들 내의 새 첨부 파일들",
"%0 uploaded the file %1 onto %2" => "%0님이 파일 %1을 %2로 갱신하였습니다",
"Wiki pages updated" => "위키 페이지 갱신됨",
"%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0님이 위키 페이지 %1를 편집하였습니다 (<a href=%2>이 역사</a>, <a href=%3>모든 역사</a>)",
// "Wiki pages created" => "Wiki pages created",
// "%0 created the wikipage %1" => "%0 created the wikipage %1",
// "Wiki pages deleted" => "Wiki pages deleted",
// "%0 deleted the wikipage %1" => "%0 deleted the wikipage %1",
"and %0 more changes of the same type" => "그리고 동일한 유형의 %0 추가 변경",
"Nothing has happened" => "아무 일도 발생하지 않았습니다",
// "Report on %0 from %1 " => "Report on %0 from %1 ",
// "(no changes)" => "(no changes)",
// "(1 change)" => "(1 change)",
// "(%0 changes)" => "(%0 changes)",
// "Scheduler task is stalled" => "Scheduler task is stalled",
// "Scheduler task is already running" => "Scheduler task is already running",
// "Unable to decode task params" => "Unable to decode task params",
// "***** Running scheduler %s *****" => "***** Running scheduler %s *****",
// "Scheduler %0 (id: %1) is stalled" => "Scheduler %0 (id: %1) is stalled",
// "Skip scheduler %s - %s" => "Skip scheduler %s - %s",
// "***** Scheduler %s - FAILED *****\n%s" => "***** Scheduler %s - FAILED *****\n%s",
// "***** Scheduler %s - OK *****" => "***** Scheduler %s - OK *****",
// "Scheduler with id %0 does not exist or is not active" => "Scheduler with id %0 does not exist or is not active",
// "Scheduler `%0` (id: %1) is stalled" => "Scheduler `%0` (id: %1) is stalled",
// "Scheduler `%0` (id: %1) was healed" => "Scheduler `%0` (id: %1) was healed",
// "Scheduler `%0` (id: %1) was not healed" => "Scheduler `%0` (id: %1) was not healed",
// "Scheduler %0 (id: %1) is not stalled, no need to heal" => "Scheduler %0 (id: %1) is not stalled, no need to heal",
// "Missing parameters to run the command" => "Missing parameters to run the command",
// "Executing console command: %s" => "Executing console command: %s",
// "Console command" => "Console command",
// "Missing the URL to call" => "Missing the URL to call",
// "Missing the file path to where the output should be saved" => "Missing the file path to where the output should be saved",
// "URL to invoke: %s" => "URL to invoke: %s",
// "Save output to: %s" => "Save output to: %s",
// "Using basic authentication" => "Using basic authentication",
// "Including additional headers" => "Including additional headers",
// "Sending request" => "Sending request",
// "Request was successful" => "Request was successful",
// "Failed to open file %s to write" => "Failed to open file %s to write",
// "Request failed" => "Request failed",
"URL" => "URL",
// "Output File" => "Output File",
// "File path to save the output" => "File path to save the output",
// "Additional HTTP Headers" => "Additional HTTP Headers",
// "One HTTP Header per line" => "One HTTP Header per line",
// "Auth Username" => "Auth Username",
// "Auth Password" => "Auth Password",
// "Missing shell command to execute" => "Missing shell command to execute",
// "Executing shell command: %s" => "Executing shell command: %s",
// "Shell command" => "Shell command",
// "Run timeout" => "Run timeout",
// "in seconds" => "in seconds",
// "Checking tiki version" => "Checking tiki version",
// "Sending emails" => "Sending emails",
// "Tiki version email sent to" => "Tiki version email sent to",
// "Tiki Version Updated" => "Tiki Version Updated",
// "Tiki Updates: " => "Tiki Updates: ",
// "Tiki Updates" => "Tiki Updates",
// "Invalid cron time format" => "Invalid cron time format",
// "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1" => "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1",
// "Missing required action parameter or value: %0" => "Missing required action parameter or value: %0",
// "Cannot apply change_status action to an object type %0" => "Cannot apply change_status action to an object type %0",
// "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Tracker item %0 not found" => "Tracker item %0 not found",
// "Tracker item %0 status %1 is different than the \"from\" status %2" => "Tracker item %0 status %1 is different than the \"from\" status %2",
// "Cannot apply delete action to an aggregation type %0" => "Cannot apply delete action to an aggregation type %0",
// "Cannot apply delete action to an object type %0" => "Cannot apply delete action to an object type %0",
// "Tracker field %0 not found" => "Tracker field %0 not found",
// "Cannot find file to delete: %0" => "Cannot find file to delete: %0",
// "Are you sure you want to permanently delete this object" => "Are you sure you want to permanently delete this object",
// "EmailAction - send to %0, subject - %1" => "EmailAction - send to %0, subject - %1",
// "Error sending email: %0" => "Error sending email: %0",
// "Page %s cannot be found" => "Page %s cannot be found",
// "EmailAction - can't send new message" => "EmailAction - can't send new message",
// "Cannot apply filegal_change_filename action to an object type %0" => "Cannot apply filegal_change_filename action to an object type %0",
// "Tracker field %0 not found for tracker %1" => "Tracker field %0 not found for tracker %1",
// "Tracker field %0 is not a Files field type" => "Tracker field %0 is not a Files field type",
// "filegal_change_filename action missing value parameter" => "filegal_change_filename action missing value parameter",
// "Cannot apply filegal_image_overlay action to an object type %0" => "Cannot apply filegal_image_overlay action to an object type %0",
// "filegal_image_overlay action missing value parameter" => "filegal_image_overlay action missing value parameter",
// "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1" => "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1",
// "Cannot apply tracker_item_modify action to an aggregation type %0" => "Cannot apply tracker_item_modify action to an aggregation type %0",
// "Cannot apply tracker_item_modify action to an object type %0" => "Cannot apply tracker_item_modify action to an object type %0",
// "tracker_item_modify action missing value, calc, add or remove parameter" => "tracker_item_modify action missing value, calc, add or remove parameter",
// "Field %0 not found on Action TrackerItemModify" => "Field %0 not found on Action TrackerItemModify",
// "Error applying tracker_item_modify calc formula to item %0: %1" => "Error applying tracker_item_modify calc formula to item %0: %1",
// "Unknown search action step: %0" => "Unknown search action step: %0",
// "Cannot apply wiki_approval action to an object type %0" => "Cannot apply wiki_approval action to an object type %0",
// "Wiki page %0 is not in pending state" => "Wiki page %0 is not in pending state",
// "Wiki page %0 does not require approval" => "Wiki page %0 does not require approval",
"Tentative" => "보류",
"Confirmed" => "확정됨",
"Cancelled" => "취소됨",
"unknown" => "알려지지 않음",
"Unknown" => "알려지지 않은",
// "Tracker Status" => "Tracker Status",
// "Webservice %0 field \"%1\" not found" => "Webservice %0 field \"%1\" not found",
"%0 (latest)" => "%0 (최신)",
// "Elasticsearch does not support optimize" => "Elasticsearch does not support optimize",
// "Federated index %0 not found" => "Federated index %0 not found",
// "Unknown mapping type \"%0\" for field \"%1\"" => "Unknown mapping type \"%0\" for field \"%1\"",
// "Document not found in index %1 (%0)" => "Document not found in index %1 (%0)",
// "String \"%0\" cannot be formatted as a number for field \"%1\"" => "String \"%0\" cannot be formatted as a number for field \"%1\"",
// "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker" => "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker",
// "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0" => "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0",
// "Feature not supported" => "Feature not supported",
// "Parsing search query failed: \"%0\"" => "Parsing search query failed: \"%0\"",
// "Sort field %0 not found in index" => "Sort field %0 not found in index",
"No results for query" => "질의에 대한 결과 없음",
"Missing template \"%0\"" => "템플릿 \"%0\" 누락 ",
// "Template tplwiki page \"%0\" not found" => "Template tplwiki page \"%0\" not found",
// "Template wiki page \"%0\" not found" => "Template wiki page \"%0\" not found",
// "Error evaluating formula %0: %1" => "Error evaluating formula %0: %1",
"No value for '%0'" => "'%0' 에 대한 값 없음",
"Unknown formatting rule '%0' for '%1'" => "알 수 없는 서식 규칙 '%1' 에 대한 '%0'",
// "Category Tree" => "Category Tree",
"Categories" => "범주",
// "%0 (Tree)" => "%0 (Tree)",
"Tags" => "프리태그",
// "Letter" => "Letter",
// "First word" => "First word",
"Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "색인작업이 \"%0\" (%1 유형) 을 처리하는 중 \"%2\" 오류와 함께 실패함",
// "Object %0 type %1 returned null from getDocument function" => "Object %0 type %1 returned null from getDocument function",
// "Could not perform index modification: %0" => "Could not perform index modification: %0",
// "Feature not supported: %0" => "Feature not supported: %0",
"Missing objectype or qualifier for relation filter" => "관계 필터에 대한 개체유형 혹은 한정자 누락",
// "Range filter \"from\" parameter not valid: \"%0\"" => "Range filter \"from\" parameter not valid: \"%0\"",
// "Range filter \"to\" parameter not valid: \"%0\"" => "Range filter \"to\" parameter not valid: \"%0\"",
// "Range filter \"gap\" parameter not valid: \"%0\"" => "Range filter \"gap\" parameter not valid: \"%0\"",
// "The range filter is missing \\\"from\\\" or \\\"to\\\"" => "The range filter is missing \\\"from\\\" or \\\"to\\\"",
// "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"" => "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"",
// "Distance sort: Missing lat or lon arguments" => "Distance sort: Missing lat or lon arguments",
// "Script sort: Missing source argument" => "Script sort: Missing source argument",
// "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled" => "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled",
"filterRange: \"from\" value not parsed" => "필터범위: \"from\" 값은 구문분석되지 않음",
"filterRange: \"to\" value not parsed" => "필터범위: \"to\" 값은 구문분석되지 않음",
// "Malformed search query" => "Malformed search query",
// "%0 (%1)" => "%0 (%1)",
// "Please confirm" => "Please confirm",
"OK" => "확인",
// "Are you sure you want to %0 the following %1" => "Are you sure you want to %0 the following %1",
// "Please confirm your action for the following item" => "Please confirm your action for the following item",
// "Please confirm your action for the following items" => "Please confirm your action for the following items",
// "Activity stream currently unavailable" => "Activity stream currently unavailable",
"Permission Denied" => "권한 거부됨",
// "Activity rule deleted" => "Activity rule deleted",
// "%0 activity rules deleted" => "%0 activity rules deleted",
// "No activity rules deleted" => "No activity rules deleted",
// "Delete Rule" => "Delete Rule",
// "Activity (id:' . (string) \$id . " => "Activity (id:' . (string) \$id . ",
// "No activities deleted" => "No activities deleted",
// "Delete Activity" => "Delete Activity",
// "Sample activity rule %0 updated" => "Sample activity rule %0 updated",
// "Sample activity rule %0 created" => "Sample activity rule %0 created",
// "Sample activity rule %0 unchanged" => "Sample activity rule %0 unchanged",
// "Edit Rule %0" => "Edit Rule %0",
// "Create Sample Rule" => "Create Sample Rule",
// "Basic activity rule %0 updated" => "Basic activity rule %0 updated",
// "Basic activity rule %0 created" => "Basic activity rule %0 created",
// "Basic activity rule %0 unchanged" => "Basic activity rule %0 unchanged",
// "Create Record Rule" => "Create Record Rule",
// "Tracker activity rule %0 updated" => "Tracker activity rule %0 updated",
// "Tracker activity rule %0 created" => "Tracker activity rule %0 created",
// "Tracker activity rule %0 unchanged" => "Tracker activity rule %0 unchanged",
// "Create Tracker Rule" => "Create Tracker Rule",
// "Advanced activity rule %0 updated" => "Advanced activity rule %0 updated",
// "Advanced activity rule %0 created" => "Advanced activity rule %0 created",
// "Advanced activity rule %0 unchanged" => "Advanced activity rule %0 unchanged",
// "Create Advanced Rule" => "Create Advanced Rule",
"Sample" => "샘플",
"Basic" => "기본",
"Advanced" => "고급",
// "Invalid rule type" => "Invalid rule type",
// "Type changed for activity rule %0" => "Type changed for activity rule %0",
// "Change Rule Type" => "Change Rule Type",
// "Status changed for activity rule %0" => "Status changed for activity rule %0",
// "Change Rule Status" => "Change Rule Status",
// "Content could not be loaded" => "Content could not be loaded",
// "Create article from URL" => "Create article from URL",
"Invalid input" => "유효하지 않은 입력",
"Invalid data" => "유효하지 않은 데이터",
// "Authentication added or modified" => "Authentication added or modified",
// "Authentication not added or modified" => "Authentication not added or modified",
// "Authentication deleted" => "Authentication deleted",
// "Authentication not deleted" => "Authentication not deleted",
"Oops" => "이런",
"Action not found (%0 in %1)" => "작업 발견되지 않음 (%1 내부의 %0)",
"Controller not found (%0)" => "제어기 발견되지 않음 (%0)",
// "No change made for one object already in the category" => "No change made for one object already in the category",
// "No change made for %0 objects already in the category" => "No change made for %0 objects already in the category",
// "One object added to category" => "One object added to category",
// "%0 objects added to category" => "%0 objects added to category",
// "No objects added to category" => "No objects added to category",
// "No change made for one object not in the category" => "No change made for one object not in the category",
// "No change made for %0 objects not in the category" => "No change made for %0 objects not in the category",
// "One object removed from category" => "One object removed from category",
// "%0 objects removed from category" => "%0 objects removed from category",
// "No objects removed from category" => "No objects removed from category",
// "Invalid %0 ID: %1" => "Invalid %0 ID: %1",
"Comments not allowed on this page" => "이 페이지에서는 댓글이 허용되지 않습니다",
"Loading.." => "로드 중..",
"Comments" => "댓글",
"Parent is locked" => "부모가 잠겨있음",
"Pseudonym must be specified" => "필명이 반드시 지정되어야 합니다",
"Email must be specified" => "이메일 지정 필수",
"Title is empty" => "제목이 비어있음",
"Content is empty" => "컨텐츠가 비어있습니다",
// "Duplicated comment, there is already another comment with the same text" => "Duplicated comment, there is already another comment with the same text",
"Your comment was posted" => "귀하의 댓글이 게시되었습니다",
"Permissions denied" => "권한 거부됨",
// "Lock comments" => "Lock comments",
// "Unlock comments" => "Unlock comments",
"Comment not found" => "댓글 발견되지 않음",
"Comment already approved" => "댓글이 이미 승인됨",
"Invalid argument" => "유효하지 않은 변수",
"Thread not specified" => "대화목록이 지정되지 않음",
// "Comment permissions: %0 object %1 not found" => "Comment permissions: %0 object %1 not found",
"Feature disabled" => "기능 비활성화됨",
"Reserved for administrators during development" => "개발 중 관리자에게 예약됨",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
"There was an error (Tiki Connect is still experimental). Please try again" => "무엇인가 잘 못되었습니다. 티키 커넥트는 아직 실험적입니다. 다시 시도하여 주십시오",
"registration" => "등록",
"confirmation" => "확인",
"Connect Feature disabled" => "연결 기능 비활성화됨",
"Connect server mode disabled" => "연결 서버 모드 비활성화됨",
"Please confirm that you want to participate in Tiki Connect" => "티키 커넥트에 참여를 원하시는지 확인해 주십시오",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
"There was a problem at the server (Tiki Connect is still experimental)" => "서버에서 무엇인가 잘 못되었습니다. 티키 커넥트는 아직 실험적입니다.",
"CAPTCHA code problem" => "스팸 방지 문자 입력 코드 문제",
"Connect data received, thanks" => "연결 데이터 수신함, 고맙습니다",
"Your Tiki site is not registered here yet. Please try again" => "귀하의 티키는 이곳에 아직 등록되어있지 않습니다, 다시 시도해 주십시오",
// "Remove custom route" => "Remove custom route",
// "Inline editor update" => "Inline editor update",
"Preview" => "미리보기",
// "Syntax Help" => "Syntax Help",
"WYSIWYG Help" => "Wysiwyg 도움말",
"Plugin Help" => "플러그인 도움말",
// "Spreadsheet Help" => "Spreadsheet Help",
// "Edit Help" => "Edit Help",
"Edit" => "편집",
// "Tracker %0 not found" => "Tracker %0 not found",
// "The following parameters could not be converted to plugin list at this stage:\n" => "The following parameters could not be converted to plugin list at this stage:\n",
// "Plugins found containing: %0" => "Plugins found containing: %0",
// "No plugins found containing: %0" => "No plugins found containing: %0",
// "You do not have permission to edit \"%0\"" => "You do not have permission to edit \"%0\"",
// "Undefined parameter" => "Undefined parameter",
"Missing parameters" => "매개 변수 없음",
// "%0 Plugin modified by editor" => "%0 Plugin modified by editor",
// "Page \"%0\" not found" => "Page \"%0\" not found",
// "%0 Plugin converted to list" => "%0 Plugin converted to list",
// "Plugin %0 on page %1 converted" => "Plugin %0 on page %1 converted",
"Authentication required" => "인증 요구됨",
"Feature disabled: %0" => "기능 사용 안 함: %0",
// "Edit conflict" => "Edit conflict",
// "Edit conflict: %0 \"%1\" is being edited already by %2" => "Edit conflict: %0 \"%1\" is being edited already by %2",
"Field Required" => "요구되는 필드",
"Not found" => "발견되지 않음",
// "File Upload" => "File Upload",
// "File could not be uploaded" => "File could not be uploaded",
// "No file arrived" => "No file arrived",
// "File too large" => "File too large",
// "Unknown errors" => "Unknown errors",
// "File empty" => "File empty",
// "Batch file processed: \"%0\"" => "Batch file processed: \"%0\"",
"You don't have permission to upload zipped file packages" => "압축된 파일 패키지를 업로할 권한 없음",
"Browse" => "열람",
// "Gallery List" => "Gallery List",
"Upload from source disabled" => "소스로부터 업로드 비활성화됨",
// "Unable to retrieve file from remote site. Please try a different URL" => "Unable to retrieve file from remote site. Please try a different URL",
"File could not be uploaded. Restrictions apply" => "파일을 업로드 할 수 없었습니다. 제한사항이 적용됩니다",
"Manual refresh disabled" => "수동 다시 고침 비활성화 됨",
// "Gallery ID %0 not found" => "Gallery ID %0 not found",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help" => "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help",
"Requested gallery does not exist" => "요청된 갤러리는 존재하지 않습니다",
// "Vimeo not authenticated" => "Vimeo not authenticated",
// "Upload Video" => "Upload Video",
"Unknown error" => "알 수 없는 오류",
// "No action was selected. Please select an action before clicking OK" => "No action was selected. Please select an action before clicking OK",
// "Merge selected posts with another topic" => "Merge selected posts with another topic",
// "Merge this post" => "Merge this post",
// "Merge these posts" => "Merge these posts",
// "Merge selected topics with another topic" => "Merge selected topics with another topic",
// "Merge this topic" => "Merge this topic",
// "Merge these topics" => "Merge these topics",
"Merge" => "병합",
// "With this topic" => "With this topic",
// "All topics or posts were selected, leaving none to merge with. Please make your selection again" => "All topics or posts were selected, leaving none to merge with. Please make your selection again",
// "No topics were selected. Please select the topics you wish to merge before clicking the merge button" => "No topics were selected. Please select the topics you wish to merge before clicking the merge button",
// "The following post has been merged with the %0 topic" => "The following post has been merged with the %0 topic",
// "The following posts have been merged with the %0 topic" => "The following posts have been merged with the %0 topic",
// "Move this topic" => "Move this topic",
// "Move these topics" => "Move these topics",
// "From the %0 forum to the below forum" => "From the %0 forum to the below forum",
// "Move selected topics to another forum" => "Move selected topics to another forum",
"Move" => "이동",
// "No topics were selected. Please select the topics you wish to move before clicking the move button" => "No topics were selected. Please select the topics you wish to move before clicking the move button",
// "The following topic has been moved to the %0 forum" => "The following topic has been moved to the %0 forum",
// "The following topics have been moved to the %0 forum" => "The following topics have been moved to the %0 forum",
// "Delete the following forum %0" => "Delete the following forum %0",
"Delete" => "삭제",
// "No topics were selected. Please select the topics you wish to delete before clicking the delete button" => "No topics were selected. Please select the topics you wish to delete before clicking the delete button",
// "The following topic has been deleted" => "The following topic has been deleted",
// "The following topics have been deleted" => "The following topics have been deleted",
// "Delete the following attachment" => "Delete the following attachment",
// "No attachments were selected. Please select an attachment to delete" => "No attachments were selected. Please select an attachment to delete",
// "The following attachment has been deleted" => "The following attachment has been deleted",
// "The following attachments have been deleted" => "The following attachments have been deleted",
// "Reserved for forum administrators" => "Reserved for forum administrators",
// "Delete the following forum" => "Delete the following forum",
// "Delete the following forums" => "Delete the following forums",
// "No forums were selected. Please select a forum to delete" => "No forums were selected. Please select a forum to delete",
// "The following forum has been deleted" => "The following forum has been deleted",
// "The following forums have been deleted" => "The following forums have been deleted",
// "Reserved for forum administrators and moderators" => "Reserved for forum administrators and moderators",
// "%0 the following topic" => "%0 the following topic",
// "%0 the following topics" => "%0 the following topics",
// "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button" => "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button",
"locked" => "잠금됨",
"unlocked" => "잠금해제됨",
// "The following topic has been %0" => "The following topic has been %0",
// "The following topics have been %0" => "The following topics have been %0",
// "%0 the following thread" => "%0 the following thread",
// "thread" => "thread",
// "No threads were selected. Please select the threads you wish to %0" => "No threads were selected. Please select the threads you wish to %0",
// "archived" => "archived",
// "unarchived" => "unarchived",
// "The following thread has been %0" => "The following thread has been %0",
// "The following thread have been %0" => "The following thread have been %0",
// "The goal is currently disabled" => "The goal is currently disabled",
// "This goal is not enabled" => "This goal is not enabled",
// "Not eligible for this goal" => "Not eligible for this goal",
// "The goal has not been evaluated, administrator view" => "The goal has not been evaluated, administrator view",
// "Reserved for administrators" => "Reserved for administrators",
// "Manage Goals" => "Manage Goals",
// "Create Goal" => "Create Goal",
// "Edit Goal" => "Edit Goal",
// "Remove Goal" => "Remove Goal",
// "Conditions" => "Conditions",
// "Pages created" => "Pages created",
// "Condition" => "Condition",
// "Rewards" => "Rewards",
// "No available rewards" => "No available rewards",
// "Reward" => "Reward",
// "Restricted access" => "Restricted access",
// "Modify Eligibility for %0" => "Modify Eligibility for %0",
// "Delete the following group" => "Delete the following group",
// "Delete the following groups" => "Delete the following groups",
// "No groups were selected. Please select one or more groups" => "No groups were selected. Please select one or more groups",
// "The following group cannot be deleted" => "The following group cannot be deleted",
// "The following groups cannot be deleted" => "The following groups cannot be deleted",
// "The following group has been deleted" => "The following group has been deleted",
// "The following groups have been deleted" => "The following groups have been deleted",
"Group already exists" => "그룹 이미 존재",
// "Create the group %0" => "Create the group %0",
"Create" => "만들기",
// "Group name cannot be empty" => "Group name cannot be empty",
// "Group %0 (ID %1) successfully created" => "Group %0 (ID %1) successfully created",
// "Group %0 not created" => "Group %0 not created",
// "Modify the group %0" => "Modify the group %0",
// "Modify" => "Modify",
// "Group %0 successfully modified" => "Group %0 successfully modified",
// "Group %0 not modified" => "Group %0 not modified",
// "Add the following user to group %0" => "Add the following user to group %0",
// "Add the following users to group %0" => "Add the following users to group %0",
"Add" => "추가",
// "One or more users must be selected" => "One or more users must be selected",
// "The following user was added to group %0" => "The following user was added to group %0",
// "The following users were added to group %0" => "The following users were added to group %0",
// "Ban the following user from group %0" => "Ban the following user from group %0",
// "Ban the following users from group %0" => "Ban the following users from group %0",
"Ban" => "차단",
// "The following user was banned from group %0" => "The following user was banned from group %0",
// "The following users were banned from group %0" => "The following users were banned from group %0",
// "Unban the following user from group %0" => "Unban the following user from group %0",
// "Unban the following users from group %0" => "Unban the following users from group %0",
// "Unban" => "Unban",
// "The following user was unbanned from group %0" => "The following user was unbanned from group %0",
// "The following users were unbanned from group %0" => "The following users were unbanned from group %0",
// "h5p_enabled" => "h5p_enabled",
// "Create H5P Content" => "Create H5P Content",
// "Create H5P content" => "Create H5P content",
// "H5P Embed" => "H5P Embed",
// "No fileID provided" => "No fileID provided",
// "H5P Plugin" => "H5P Plugin",
// "Cannot find H5P content with fileId: %0" => "Cannot find H5P content with fileId: %0",
// "Edit H5P Content" => "Edit H5P Content",
// "H5P Edit" => "H5P Edit",
// "Waiting for javascript.." => "Waiting for javascript..",
// "H5P Content Libraries" => "H5P Content Libraries",
// "File not found on server. Check file upload settings" => "File not found on server. Check file upload settings",
// "H5P Results" => "H5P Results",
// "No contentId provided" => "No contentId provided",
// "H5P User Data" => "H5P User Data",
// "H5P User Results" => "H5P User Results",
"You have successfully added %0 new media items" => "%0 개의 새 미디어 항목들을 성공적으로 추가하셨습니다",
"You have successfully added one new media item" => "1개의 새 미디어 항목을 성공적으로 추가하셨습니다",
// "No language provided" => "No language provided",
// "lang/\$language directory is not writable" => "lang/\$language directory is not writable",
"Wrote %d new strings and updated %d to lang/%s/language.php" => "%d 개의 새 문자열을 작성하였고 %d 개를 lang/%s/language.php 에 갱신 함.",
"Write to language.php" => "language.php 에 쓰기",
// "Custom Translations" => "Custom Translations",
// "Invalid file type" => "Invalid file type",
// "File does not exist" => "File does not exist",
// "Invalid file type: php not allowed" => "Invalid file type: php not allowed",
// "Upload Translations" => "Upload Translations",
"Feature Disabled" => "기능 비활성화됨",
// "Invalid file parameter supplied" => "Invalid file parameter supplied",
"Translation not supported for the specified object type" => "지정된 개체 유행에 대하여 번역 지원되지 않음",
"No source provided" => "제공된 원문 없음",
"Manage translations" => "번역 관리",
"No source or target provided" => "원문 혹은 목표가 제공된 것이 없음",
// "You do not have permission to attach the selected translations" => "You do not have permission to attach the selected translations",
"Could not attach the translations" => "번역을 첨부할 수 없었음",
// "You do not have permission to detach the selected translations" => "You do not have permission to detach the selected translations",
"The object has no language indicated and cannot be translated" => "개체에는 언어가 없으며 번역될 수 없습니다",
// "The language directory is not readable" => "The language directory is not readable",
// "The language directory is not writeable" => "The language directory is not writeable",
// "String translation set is not an array" => "String translation set is not an array",
// "Can not fopen custom.php" => "Can not fopen custom.php",
// "Can not fwrite custom.php" => "Can not fwrite custom.php",
// "Source string translation set is not an array" => "Source string translation set is not an array",
// "Target string translation set is not an array" => "Target string translation set is not an array",
// "Invalid process type" => "Invalid process type",
// "Add new and update existing" => "Add new and update existing",
// "Add new only" => "Add new only",
// "Update existing only" => "Update existing only",
// "Replace all" => "Replace all",
// "Failed to connect or authenticate with remote host" => "Failed to connect or authenticate with remote host",
// "Account created or modified" => "Account created or modified",
// "Account not created or modified" => "Account not created or modified",
// "Modify Account" => "Modify Account",
// "Create Account" => "Create Account",
// "Account removed" => "Account removed",
// "Account not removed" => "Account not removed",
// "Remove Account" => "Remove Account",
// "Menu %0 not found" => "Menu %0 not found",
// "The %0 menu has been edited" => "The %0 menu has been edited",
// "The %0 menu has been created" => "The %0 menu has been created",
// "An error occurred - the %0 menu may not have been edited" => "An error occurred - the %0 menu may not have been edited",
// "An error occurred - the %0 menu may not have been created" => "An error occurred - the %0 menu may not have been created",
// "Edit Menu" => "Edit Menu",
// "Create Menu" => "Create Menu",
// "Menu %0 cloned as menu %1" => "Menu %0 cloned as menu %1",
"Clone this menu and its options" => "이 메뉴와 선택사항들을 복제",
// "Menu option %0 not found" => "Menu option %0 not found",
// "Menu Option %0" => "Menu Option %0",
// "Create Menu Option" => "Create Menu Option",
// "Your menu options have been imported" => "Your menu options have been imported",
// "Import Menu Options" => "Import Menu Options",
// "Menu Preview" => "Menu Preview",
// "The %0 menu has been removed" => "The %0 menu has been removed",
// "The %0 menu has not been removed" => "The %0 menu has not been removed",
// "Delete the %0 menu" => "Delete the %0 menu",
// "You don't have permission to edit menus (tiki_p_edit_menu)" => "You don't have permission to edit menus (tiki_p_edit_menu)",
// "You don't have permission to edit menu options (tiki_p_edit_menu_option)" => "You don't have permission to edit menu options (tiki_p_edit_menu_option)",
// "You don't have permission to edit menu options (edit_menu_option)" => "You don't have permission to edit menu options (edit_menu_option)",
// "Must Read" => "Must Read",
// "Invalid request method" => "Invalid request method",
// "Cannot circulate" => "Cannot circulate",
// "Circulate" => "Circulate",
// "Group does not exist" => "Group does not exist",
// "Misconfigured feature" => "Misconfigured feature",
// "Target field not found" => "Target field not found",
// "Object not found" => "Object not found",
// "Must Read for %0" => "Must Read for %0",
// "Must Read Item not found" => "Must Read Item not found",
"Read" => "읽음",
// "Respond Privately" => "Respond Privately",
"Completed" => "종료",
"Missing %0 parameter" => "%0 매개변수가 없음",
// "Not Found" => "Not Found",
"No box available for %0" => "%0 에 대하여 제공되는 상자 없음",
// "Invalid attribute name \"%0\"" => "Invalid attribute name \"%0\"",
// "Cannot lock \"%0\"" => "Cannot lock \"%0\"",
// "Reserved for payment administrators" => "Reserved for payment administrators",
// "Recommendations for %0" => "Recommendations for %0",
"Remote service inaccessible (%0)" => "원격 서비스 접근 불가 (%0)",
// "Execution output" => "Execution output",
// "Scheduler %0 - FAILED" => "Scheduler %0 - FAILED",
// "Scheduler %0 - OK" => "Scheduler %0 - OK",
// "Running %0" => "Running %0",
// "Reset scheduler run" => "Reset scheduler run",
"Rebuild Index" => "색인 재빌드",
// "Process Update Queue" => "Process Update Queue",
"empty" => "비어있음",
// "Lookup Result" => "Lookup Result",
// "ManifoldCF Configuration Check" => "ManifoldCF Configuration Check",
// "Create ManifoldCF Index" => "Create ManifoldCF Index",
// "A query could not be created because the name is already in use" => "A query could not be created because the name is already in use",
// "Could not obtain the query" => "Could not obtain the query",
// "Save Search" => "Save Search",
// "Saved Searches" => "Saved Searches",
// "Delete Saved Search" => "Delete Saved Search",
// "Edit Saved Search" => "Edit Saved Search",
// "Search functionality currently unavailable" => "Search functionality currently unavailable",
// "Theme Customizer" => "Theme Customizer",
// "Item not found" => "Item not found",
"Reserved for tracker administrators" => "트래커 관리자에게 예약됨",
"Type does not exist" => "유형이 존재하지 않습니다",
"Add Field" => "필드 추가",
// "Warning: There is a conflict in permanent names, which can cause indexing errors" => "Warning: There is a conflict in permanent names, which can cause indexing errors",
// "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4" => "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4",
// "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen" => "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen",
"Warning: Required field types not enabled: %0" => "경고: 요구된 필드 유형이 활성화 되지 않음: %0",
"Tracker contains no listed field, no meaningful information will be provided in the default list" => "트래커는 나열된 필드를 포함하지 않습니다, 기본 목록에 의미있는 정보가 제공되지 않을 것입니다",
"The tracker contains no field in the title, so no link will be generated" => "트래커가 제목에 필드를 포함하지 않습니다, 링크가 생성되지 않을 것입니다",
// "Field handler not found" => "Field handler not found",
// "%0" => "%0",
"CAPTCHA" => "스팸 방지 문자 입력",
"Distinct" => "고유",
"Page Name" => "페이지명",
"Password" => "비밀번호",
"Regular Expression (Pattern)" => "일반 정규식 (패턴)",
"Username" => "사용자이름",
// "Export Fields" => "Export Fields",
"Invalid data provided" => "유효하지 않은 데이터 제공됨",
"Import Tracker Fields" => "트래커 필드 가져오기",
"No item to clone" => "복제할 항목 없음",
// "Duplicate Item" => "Duplicate Item",
// "Item could not be created. Only one item per user is allowed" => "Item could not be created. Only one item per user is allowed",
// "Item created" => "Item created",
// "New \"%0\" item successfully created" => "New \"%0\" item successfully created",
// "New tracker item %0 successfully created" => "New tracker item %0 successfully created",
// "Tracker item could not be created" => "Tracker item could not be created",
"Create Item" => "항목 만들기",
// "Tracker item %0 has been updated" => "Tracker item %0 has been updated",
// "%0: Updated \"%1\"" => "%0: Updated \"%1\"",
// "Comment for edit #%0" => "Comment for edit #%0",
// "Update Item" => "Update Item",
// "Are you sure you would like to update this item" => "Are you sure you would like to update this item",
"Save" => "저장",
// "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0" => "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0",
// "Tracker item %0 has been successfully deleted" => "Tracker item %0 has been successfully deleted",
"Remove" => "제거",
"Validation error" => "유효성 검사 오류",
// "Create Tracker" => "Create Tracker",
"Duplicate Tracker" => "트래커 복제",
// "Export Items" => "Export Items",
// "Import Tracker Structure" => "Import Tracker Structure",
"File upload failed" => "파일 업로드 실패함",
"Uploaded file could not be read" => "업로드된 파일을 읽을 수 없었습니다",
// "Import Items" => "Import Items",
// "Import Tracker From Profile/YAML" => "Import Tracker From Profile/YAML",
"Last Modification" => "최종 변경",
"Creation Date" => "만든 날짜",
"Item ID" => "항목 ID",
"Filename" => "파일이름",
"Creation date" => "작성일",
"Views" => "보기",
"File size" => "파일 크기",
"Version" => "버전",
"File type" => "파일 유형",
"Long description" => "긴 설명",
"User" => "사용자",
// "Select Tracker" => "Select Tracker",
"You don't have permission to view the tracker" => "트래커를 보기  허용되지 않음",
"The item to clone isn't visible" => "복제할 항목 보이지 않음",
"You don't have permission to create new items" => "새 항목들을 만드는 것 허용되지 않음",
// "Cannot remove item %0 from this tracker" => "Cannot remove item %0 from this tracker",
"You don't have permission to export" => "내보내기 허용되지 않음",
"Remote Source" => "원격 소스",
"Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "동기화된 트래커들에 대하여 자동으로 생성된 필드. 원격 항목의 아이템ID를 포함함",
// "Clone Remote Tracker" => "Clone Remote Tracker",
"Tracker does not exist" => "트래커가 존재하지 않습니다",
"Tracker is not synchronized with a remote source" => "트래커는 원격 소스와 동기화되지 않습니다",
// "Tabular Formats" => "Tabular Formats",
// "Remove Format" => "Remove Format",
// "Create Tabular Format" => "Create Tabular Format",
// "Edit Format: %0" => "Edit Format: %0",
// "Format %0 not found" => "Format %0 not found",
// "Duplicate Format: %0" => "Duplicate Format: %0",
// "%0 copy" => "%0 copy",
// "Fields in %0" => "Fields in %0",
// "No formats available" => "No formats available",
// "Select Format" => "Select Format",
// "Primary Key required" => "Primary Key required",
// "Your import was completed successfully" => "Your import was completed successfully",
"Import" => "가져오기",
// "Filter %0" => "Filter %0",
"Filter" => "필터",
"Export %0" => "%0 내보내기",
"Export" => "내보내기",
// "Create tabular format and tracker from file" => "Create tabular format and tracker from file",
"Operation reserved for tracker administrators" => "트래커 관리자에 대하여 예약된 작동",
"Events" => "이벤트",
"The following mandatory fields are missing: %0" => "다음 필수 필드들이 없습니다: %0",
"Invalid value in %0: %1" => "%0 내부에 유효하지 않은 값: %1",
"Invalid value in %0" => "%0 내부에 유효하지 않은 값",
// "Field %0 does not exist in tracker" => "Field %0 does not exist in tracker",
// "The terms and conditions were modified while you were reading them" => "The terms and conditions were modified while you were reading them",
// "You are required to approve the terms of use to continue" => "You are required to approve the terms of use to continue",
// "Terms and Conditions" => "Terms and Conditions",
// "You must enter your date of birth to continue" => "You must enter your date of birth to continue",
// "Age Validation" => "Age Validation",
// "We were unable to create your account because this email is already in use" => "We were unable to create your account because this email is already in use",
"Friend" => "친구",
// "Remove Friend" => "Remove Friend",
// "Add Friend" => "Add Friend",
// "Following you" => "Following you",
// "Remove Follower" => "Remove Follower",
// "You are following" => "You are following",
// "Stop Following" => "Stop Following",
// "Follow" => "Follow",
// "Awaiting your approval" => "Awaiting your approval",
// "Refuse Request" => "Refuse Request",
// "Accept &amp; Add" => "Accept &amp; Add",
// "Accept Request" => "Accept Request",
// "Waiting for approval" => "Waiting for approval",
// "Cancel Request" => "Cancel Request",
"Hidden" => "숨겨진",
// "km" => "km",
// "You need to set \"Show my information on mouseover\"" => "You need to set \"Show my information on mouseover\"",
"Click here" => "여기를 클릭",
// "You need to log in" => "You need to log in",
// "Delete the following user" => "Delete the following user",
// "Delete the following users" => "Delete the following users",
// "No users were selected. Please select one or more users" => "No users were selected. Please select one or more users",
// "The following user has been deleted" => "The following user has been deleted",
// "Submit form below to ban this user" => "Submit form below to ban this user",
// "The following users have been deleted" => "The following users have been deleted",
// "Submit form below to ban these users" => "Submit form below to ban these users",
// "Ban the following user's IP" => "Ban the following user's IP",
// "Clicking Ban will redirect you to a form where this user's is preselected for IP banning" => "Clicking Ban will redirect you to a form where this user's is preselected for IP banning",
// "Ban the following users' IPs" => "Ban the following users' IPs",
// "Clicking Ban will redirect you to a form where these users' are preselected for IP banning" => "Clicking Ban will redirect you to a form where these users' are preselected for IP banning",
// "See highlighted section in the form below for users you have selected for banning" => "See highlighted section in the form below for users you have selected for banning",
// "Remove the following user from group %0" => "Remove the following user from group %0",
// "For this user" => "For this user",
// "For these selected users" => "For these selected users",
// "Change group assignments for selected users" => "Change group assignments for selected users",
"%s %s assigned to %s %s" => "%s %s이 %s %s로 할당됨",
"user" => "사용자",
"group" => "그룹",
// "An error occurred. The group assignment failed" => "An error occurred. The group assignment failed",
"%s %s removed from %s %s" => "%s %s이 %s %s에서 삭제됨",
// "The following user" => "The following user",
// "The following users" => "The following users",
// "%0 had the following group set as default" => "%0 had the following group set as default",
// "%0 been %1 the following %2" => "%0 been %1 the following %2",
// "Set default group for selected users" => "Set default group for selected users",
// "Make this the default group" => "Make this the default group",
// "group %s set as the default group for user %s" => "group %s set as the default group for user %s",
// "For the following user" => "For the following user",
// "For the following users" => "For the following users",
// "The following group has been set as the default group" => "The following group has been set as the default group",
// "Send wiki page content by email to selected users" => "Send wiki page content by email to selected users",
"Page not found" => "페이지 뱔견되지 않음",
// "The page does not have a description, which is mandatory to perform this action" => "The page does not have a description, which is mandatory to perform this action",
// "Invalid bcc email address" => "Invalid bcc email address",
// "and blind copied (bcc) to %0" => "and blind copied (bcc) to %0",
// "The template page has no text or the text cannot be extracted" => "The template page has no text or the text cannot be extracted",
// "Mail sent to user %s" => "Mail sent to user %s",
// "The page %0 has been emailed to the following user" => "The page %0 has been emailed to the following user",
// "The page %0 has been emailed to the following users" => "The page %0 has been emailed to the following users",
// "And blind copied to %0" => "And blind copied to %0",
// "No user was selected" => "No user was selected",
// "Message not sent - no subject or body" => "Message not sent - no subject or body",
// "Your message was successfully sent to %0" => "Your message was successfully sent to %0",
"An error occurred, please check your mail settings and try again" => "오류가 발생했습니다, 메일 설정을 확인하시고 다시 시도하십시오",
// "Please specify validity period" => "Please specify validity period",
// "The group %0 does not exist" => "The group %0 does not exist",
// "Your invite has been sent" => "Your invite has been sent",
// "You must set a user for whom to set an avatar" => "You must set a user for whom to set an avatar",
// "You do not have the permission to change the avatar" => "You do not have the permission to change the avatar",
// "You must select an avatar to upload" => "You must select an avatar to upload",
// "An error occurred. User page for %0 could not be deleted" => "An error occurred. User page for %0 could not be deleted",
"Deleted account %s" => "삭제된 계정 %s",
// "An error occurred. User %0 could not be deleted" => "An error occurred. User %0 could not be deleted",
"secure connection required" => "안전 연결이 요구됨",
// "You cannot see this user's data" => "You cannot see this user's data",
// "Send Me a Message" => "Send Me a Message",
// "Upload Avatar" => "Upload Avatar",
"Must be authenticated" => "인증받아야만 함",
// "Notifications for %0" => "Notifications for %0",
// "No notifications" => "No notifications",
"Notifications" => "통지",
// "Unread Notifications" => "Unread Notifications",
// "Mark all notifications as read" => "Mark all notifications as read",
// "Must be registered" => "Must be registered",
// "Friend List" => "Friend List",
// "User not found" => "User not found",
// "Approve Friend" => "Approve Friend",
// "Regenerate Wiki URLs" => "Regenerate Wiki URLs",
// "the only version of" => "the only version of",
// "all versions of" => "all versions of",
// "the last version of" => "the last version of",
// "Delete %0 the following %1" => "Delete %0 the following %1",
// "You do not have permission to remove the selected page(s)" => "You do not have permission to remove the selected page(s)",
// "No pages were selected. Please select one or more pages" => "No pages were selected. Please select one or more pages",
// "An error occurred. %0%1 could not be deleted" => "An error occurred. %0%1 could not be deleted",
"All versions" => "모든 버전",
// "The last version" => "The last version",
// "Version %0" => "Version %0",
// "%0 of the following page %1 been deleted" => "%0 of the following page %1 been deleted",
// "%0 of the following pages %1 been deleted" => "%0 of the following pages %1 been deleted",
// "Redirection page not specified. 301 redirect not created" => "Redirection page not specified. 301 redirect not created",
// "Semantic aliases (301 Redirects) to this page were created when other pages were deleted" => "Semantic aliases (301 Redirects) to this page were created when other pages were deleted",
// "A semantic alias (301 Redirect) to this page was created when page %0 was deleted" => "A semantic alias (301 Redirect) to this page was created when page %0 was deleted",
// "301 Redirects to the following page were created" => "301 Redirects to the following page were created",
// "A 301 Redirect to the following page was created" => "A 301 Redirect to the following page was created",
// "The following page and 301 Redirects to it were created" => "The following page and 301 Redirects to it were created",
// "The following page and a 301 Redirect to it were created" => "The following page and a 301 Redirect to it were created",
// "Delete the following %0 of %1" => "Delete the following %0 of %1",
// "No version were selected. Please select one or more versions" => "No version were selected. Please select one or more versions",
// "An error occurred. Version %0 could not be deleted" => "An error occurred. Version %0 could not be deleted",
// "The following version of %0 has been deleted" => "The following version of %0 has been deleted",
// "The following versions of %0 have been deleted" => "The following versions of %0 have been deleted",
// "Print the following page" => "Print the following page",
// "Print the following pages" => "Print the following pages",
"Print" => "인쇄",
// "No page specified" => "No page specified",
// "Export the following page to PDF" => "Export the following page to PDF",
// "Export the following pages to PDF" => "Export the following pages to PDF",
// "PDF" => "PDF",
// "Lock the following page" => "Lock the following page",
// "Lock the following pages" => "Lock the following pages",
"Lock" => "잠금",
// "Excludes selected pages already locked or for which you lack permission to lock" => "Excludes selected pages already locked or for which you lack permission to lock",
// "You do not have permission to lock the selected pages or they have already been locked" => "You do not have permission to lock the selected pages or they have already been locked",
// "The following page was not locked due to an error" => "The following page was not locked due to an error",
// "The following pages were not locked due to an error" => "The following pages were not locked due to an error",
// "The following page has been locked" => "The following page has been locked",
// "The following pages have been locked" => "The following pages have been locked",
// "Unlock the following page" => "Unlock the following page",
// "Unlock the following pages" => "Unlock the following pages",
"Unlock" => "잠금해제",
// "Excludes selected pages already unlocked or for which you lack permission to unlock" => "Excludes selected pages already unlocked or for which you lack permission to unlock",
// "You do not have permission to unlock the selected pages or they have already been unlocked" => "You do not have permission to unlock the selected pages or they have already been unlocked",
// "The following page was not unlocked due to an error" => "The following page was not unlocked due to an error",
// "The following pages were not unlocked due to an error" => "The following pages were not unlocked due to an error",
// "The following page has been unlocked" => "The following page has been unlocked",
// "The following pages have been unlocked" => "The following pages have been unlocked",
// "Download a zipped file of the following page" => "Download a zipped file of the following page",
// "Download a zipped file of the following pages" => "Download a zipped file of the following pages",
// "Zip" => "Zip",
// "Add page name as header of the following page" => "Add page name as header of the following page",
// "Add page name as header of the following pages" => "Add page name as header of the following pages",
// "The following page was not found" => "The following page was not found",
// "The following pages were not found" => "The following pages were not found",
// "The page name was added as header to the following page" => "The page name was added as header to the following page",
// "The page name was added as header to the following pages" => "The page name was added as header to the following pages",
// "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents",
// "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents",
// "Create Workspace" => "Create Workspace",
// "Workspace Templates" => "Workspace Templates",
// "Create Workspace Template" => "Create Workspace Template",
"Edit template %0" => "%0 템플릿 편집",
"Workspaces" => "작업공간",
"Could not create workspace root" => "작업공간 루트를 만들 수 없었습니다",
"Invalid user" => "무효 사용자",
// "Invalid token" => "Invalid token",
// "Empty authorization" => "Empty authorization",
// "Wrong authorization format" => "Wrong authorization format",
// "You don't have enough privileges" => "You don't have enough privileges",
// "Select a filter" => "Select a filter",
// "n/a" => "n/a",
// "Server-side Processing" => "Server-side Processing",
// "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort" => "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort",
// "Overall Sort Settings" => "Overall Sort Settings",
// "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts" => "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts",
"Pre-sorted Columns" => "사전 정렬된 열",
// "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns" => "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns",
// "Sort Settings by Column" => "Sort Settings by Column",
// "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5" => "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5",
// "Set %0 to one of the following" => "Set %0 to one of the following",
// "Also handle strings in numeric columns with" => "Also handle strings in numeric columns with",
// "Handle empty cells with" => "Handle empty cells with",
// "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)" => "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)",
// "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5" => "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5",
// "Column Filters" => "Column Filters",
// "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters" => "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters",
// "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)" => "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)",
// "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>" => "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>",
// "Options generated automatically if not set and the %0server%1 parameter is not %0y%1" => "Options generated automatically if not set and the %0server%1 parameter is not %0y%1",
// "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown" => "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown",
// "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually" => "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually",
// "Date range - " => "Date range - ",
// "(from and to values set defaults for these fields when user clicks on the input field)" => "(from and to values set defaults for these fields when user clicks on the input field)",
// "Beware that items with empty date values will not be shown when default date range filters are applied" => "Beware that items with empty date values will not be shown when default date range filters are applied",
// "Numeric range - " => "Numeric range - ",
// "No filter - " => "No filter - ",
// "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list" => "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list",
// "Filter Options" => "Filter Options",
// "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1" => "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1",
// "Paginate" => "Paginate",
// "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: " => "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: ",
// "Column Select" => "Column Select",
// "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns" => "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns",
// "Totals" => "Totals",
// "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1" => "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1",
// "Setting to %0 will add one column total row set as follows: %1" => "Setting to %0 will add one column total row set as follows: %1",
// "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations" => "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations",
// "Instructions for each total option follows" => "Instructions for each total option follows",
// "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total" => "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total",
// "set what the calculation is. Choices are" => "set what the calculation is. Choices are",
// "Click %0 for a description of these options" => "Click %0 for a description of these options",
// "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)" => "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)",
// "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals" => "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals",
// "Total Format" => "Total Format",
// "Format for table totals (click %0 for patterns). Example" => "Format for table totals (click %0 for patterns). Example",
// "Total Options" => "Total Options",
// "Pipe-separated options for totals for each column which are set in the %0 parameter" => "Pipe-separated options for totals for each column which are set in the %0 parameter",
// "overrides the default number format set in %0" => "overrides the default number format set in %0",
// "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter" => "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter",
"Example:" => "예:",
// "Page totals" => "Page totals",
// "Please install Faker package" => "Please install Faker package",
// "Object \"%0\" of type \"%1\" not found" => "Object \"%0\" of type \"%1\" not found",
// "The value of items is not a number" => "The value of items is not a number",
"Tracker not found" => "트래커 발견되지 않음",
// "Invalid field definition: %0" => "Invalid field definition: %0",
// "Checking for image gallery files skipped" => "Checking for image gallery files skipped",
// "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter" => "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter",
// "Tracker Attachments" => "Tracker Attachments",
// "Wiki Attachments" => "Wiki Attachments",
// "Forum Attachments" => "Forum Attachments",
// "Configured to stores files in Database" => "Configured to stores files in Database",
// "Configured to stores files on Disk: %0" => "Configured to stores files on Disk: %0",
// "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files" => "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files",
// "Files in DB: %0" => "Files in DB: %0",
// "Files on Disk: %0" => "Files on Disk: %0",
// "No Issues found" => "No Issues found",
// "Found %0 Issues, details below" => "Found %0 Issues, details below",
// "The following files are missing" => "The following files are missing",
// "Id" => "Id",
// "The following files have different size that expected" => "The following files have different size that expected",
// "The following files are unknown, exists in the folder, but not in the database" => "The following files are unknown, exists in the folder, but not in the database",
// "Copy files from file galleries to a regular directory on the file system" => "Copy files from file galleries to a regular directory on the file system",
// "Feature Galleries not set up" => "Feature Galleries not set up",
// "File Copy: Gallery #%0 not found" => "File Copy: Gallery #%0 not found",
// "File Copy: Destination path required" => "File Copy: Destination path required",
// "No files to copy" => "No files to copy",
// "File Copy starting.." => "File Copy starting..",
// "File Copy complete" => "File Copy complete",
// "Move files from file galleries to a regular directory on the file system" => "Move files from file galleries to a regular directory on the file system",
// "File Move: Gallery #%0 not found" => "File Move: Gallery #%0 not found",
// "File Move: Destination path required" => "File Move: Destination path required",
// "No files to move" => "No files to move",
// "Use the --confirm option to proceed with the move operation" => "Use the --confirm option to proceed with the move operation",
// "File Move starting.." => "File Move starting..",
// "File Move complete" => "File Move complete",
// "Migrate images from the Image Gallery to the File Gallery" => "Migrate images from the Image Gallery to the File Gallery",
// "All files migrated" => "All files migrated",
// "No files migrated, default file gallery path is not writable" => "No files migrated, default file gallery path is not writable",
// "%0 reached for %1 (%2)" => "%0 reached for %1 (%2)",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
// "Clean Tiki install" => "Clean Tiki install",
// "Force installation. Overwrite any current database" => "Force installation. Overwrite any current database",
// "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM" => "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM",
// "Installation completed" => "Installation completed",
// "Queries executed successfully: %0" => "Queries executed successfully: %0",
// "Error %0 in" => "Error %0 in",
// "Database already exists" => "Database already exists",
// "Dependencies not satisfied. Exiting" => "Dependencies not satisfied. Exiting",
// "Composer could not be executed" => "Composer could not be executed",
// "Extension %0 is now disabled" => "Extension %0 is now disabled",
// "Extension %0 was not disabled" => "Extension %0 was not disabled",
// "Extension %0 was updated" => "Extension %0 was updated",
// "Extension %0 is now enabled" => "Extension %0 is now enabled",
// "Extension %0 was not enabled" => "Extension %0 was not enabled",
// "Installing package: " => "Installing package: ",
// "Invalid Package: " => "Invalid Package: ",
// "No packages available to be installed" => "No packages available to be installed",
// "No packages found in composer.json in the root of the project" => "No packages found in composer.json in the root of the project",
// "No packages installed" => "No packages installed",
// "Packages Installed" => "Packages Installed",
// "Packages Available to Install" => "Packages Available to Install",
// "No packages available to be removed" => "No packages available to be removed",
// "Removing package: " => "Removing package: ",
// "Packages that can be removed" => "Packages that can be removed",
// "No packages available to be updated" => "No packages available to be updated",
// "Updating package: " => "Updating package: ",
// "Packages that can be updated" => "Packages that can be updated",
// "Approve a list of plugin invocations/calls" => "Approve a list of plugin invocations/calls",
// "List fingerprints of the plugin invocations/calls to approve separated by commas" => "List fingerprints of the plugin invocations/calls to approve separated by commas",
// "Approve all plugin invocations/calls" => "Approve all plugin invocations/calls",
// "You must either use the option --all or provide a list of fingerprints to approve" => "You must either use the option --all or provide a list of fingerprints to approve",
// "Approving all pending plugins" => "Approving all pending plugins",
// "Approving a list of plugins" => "Approving a list of plugins",
// "Approving plugin %0" => "Approving plugin %0",
// "Plugins approved with success" => "Plugins approved with success",
// "List all plugin invocations/calls" => "List all plugin invocations/calls",
// "Shows only invocations/calls pending approval" => "Shows only invocations/calls pending approval",
// "Listing plugins in status: %0" => "Listing plugins in status: %0",
// "Found %0 plugins" => "Found %0 plugins",
// "No plugins found" => "No plugins found",
// "Parses all the pages to refresh the list of plugin invocations/calls" => "Parses all the pages to refresh the list of plugin invocations/calls",
// "Plugin list refreshed with success" => "Plugin list refreshed with success",
// "Not enough arguments (missing: \"article\" or \"--all\" options)" => "Not enough arguments (missing: \"article\" or \"--all\" options)",
// "Not enough arguments (missing: \"calendar\" or \"--all\" option)" => "Not enough arguments (missing: \"calendar\" or \"--all\" option)",
// "Not enough arguments (missing: \"category\" or \"--all\" options)" => "Not enough arguments (missing: \"category\" or \"--all\" options)",
// "Not enough arguments (missing: \"forum\" or \"--all\" option)" => "Not enough arguments (missing: \"forum\" or \"--all\" option)",
// "Not enough arguments (missing: \"menu\" or \"--all\" option)" => "Not enough arguments (missing: \"menu\" or \"--all\" option)",
// "Not enough arguments (missing: \"name\" or \"--all\" options)" => "Not enough arguments (missing: \"name\" or \"--all\" options)",
// "Not enough arguments (missing: \"tracker\" or \"--all\" option)" => "Not enough arguments (missing: \"tracker\" or \"--all\" option)",
// "No Items found to export" => "No Items found to export",
// "Tracker item %0 exported" => "Tracker item %0 exported",
// "Tracker item %0 failed to exported" => "Tracker item %0 failed to exported",
// "Tracker items for tracker %0 exported" => "Tracker items for tracker %0 exported",
// "Not enough arguments (missing: \"page\" or \"--all\" option)" => "Not enough arguments (missing: \"page\" or \"--all\" option)",
// "Profile name" => "Profile name",
// "profiles.tiki.org" => "profiles.tiki.org",
// "Re-apply profiles when already applied" => "Re-apply profiles when already applied",
// "Return to the user information about what is going to be applied" => "Return to the user information about what is going to be applied",
// "Some of the named object references in the profile are invalid" => "Some of the named object references in the profile are invalid",
// "Profile applied" => "Profile applied",
// "Installation failed" => "Installation failed",
// "Dry-run for profile: " => "Dry-run for profile: ",
// "Permission removed: " => "Permission removed: ",
// "Permission added: " => "Permission added: ",
// "User modified: " => "User modified: ",
// "User added: " => "User added: ",
// "Group modified: " => "Group modified: ",
// "Group added: " => "Group added: ",
// "Preference set: %0= %1 old value= %2" => "Preference set: %0= %1 old value= %2",
// "Installer added: " => "Installer added: ",
// "Profile was already applied. Nothing happened" => "Profile was already applied. Nothing happened",
// "SCSS Parse Error" => "SCSS Parse Error",
// "SCSS Compiler Error" => "SCSS Compiler Error",
// "SCSS Range Error" => "SCSS Range Error",
// "SCSS Server Error" => "SCSS Server Error",
// "SCSS Error" => "SCSS Error",
// "Preference \"sitemap_enable\" is not enabled" => "Preference \"sitemap_enable\" is not enabled",
// "New sitemap created" => "New sitemap created",
"File not found" => "파일을찾을 수 없음",
// "File is not a .zip file" => "File is not a .zip file",
// "Theme installed" => "Theme installed",
// "Theme not found" => "Theme not found",
// "Theme removed successfully" => "Theme removed successfully",
// "An error occurred while deleting theme" => "An error occurred while deleting theme",
// "CSS folder not found" => "CSS folder not found",
// "Configuration file added" => "Configuration file added",
// "Preference inserted or updated" => "Preference inserted or updated",
// "Menu inserted or update" => "Menu inserted or update",
// "Module inserted or update" => "Module inserted or update",
// "Theme updated" => "Theme updated",
// "Could not open file" => "Could not open file",
// "Displays the Tiki (tiki) or PHP version (php), empty to display both" => "Displays the Tiki (tiki) or PHP version (php), empty to display both",
"Internal error: mandatory parameter field_fetch_url is missing" => "내부 오류: 필수 매개변수 field_fetch_url 가 없습니다 ",
"Internal error: mandatory parameter object_store_url is missing" => "내부 오류: 필수 매개변수 object_store_url 이 없습니다",
// "Problem finding the associated user. %0 is not recognized. See EventNotify.php" => "Problem finding the associated user. %0 is not recognized. See EventNotify.php",
// "Event name may be empty or invalid" => "Event name may be empty or invalid",
// "Arguments are expected to be a value map" => "Arguments are expected to be a value map",
"New File" => "새 파일",
// "Unable to write to destination path: %0" => "Unable to write to destination path: %0",
"Cannot resize the file" => "파일 크기변경 불가",
"Cannot write the file" => "이 파일 쓰기 불가",
"Image was reduced: %s x %s -> %s x %s" => "그림이 축소됨: %s x %s -> %s x %s",
"`%0` does not match acceptable naming patterns" => "`%0` 은 허용가능한 명명 패턴과 일치하지 않습니다",
// "Duplicate file found as `%0`. Upload rejected" => "Duplicate file found as `%0`. Upload rejected",
// "Mail-in auto-reply" => "Mail-in auto-reply",
"Sorry, you can't use this feature" => "죄송합니다, 귀하는 이 기능을 사용할 수 없습니다",
// "The functionality you are trying to access is currently disabled" => "The functionality you are trying to access is currently disabled",
// "No required action found" => "No required action found",
// "Rejected message, user globally denied" => "Rejected message, user globally denied",
// "Rejected message, associated action disabled (%0)" => "Rejected message, associated action disabled (%0)",
// "Performing action (%0)" => "Performing action (%0)",
// "Rejected message, user locally denied (%0)" => "Rejected message, user locally denied (%0)",
// "Rejected message, no associated action" => "Rejected message, no associated action",
"Submit Article" => "기사 투고",
// "Unable to find suitable action" => "Unable to find suitable action",
// "Wiki Append" => "Wiki Append",
// "Wiki Get" => "Wiki Get",
// "Wiki Prepend" => "Wiki Prepend",
// "Wiki Create/Update" => "Wiki Create/Update",
// "created from mail-in" => "created from mail-in",
// "Create or update article" => "Create or update article",
// "Reply Handler" => "Reply Handler",
// "Wiki (multiple actions)" => "Wiki (multiple actions)",
// "Login failed for IMAP account on %0:%1 for user %2" => "Login failed for IMAP account on %0:%1 for user %2",
// "Login failed for POP3 account on %0:%1 for user %2" => "Login failed for POP3 account on %0:%1 for user %2",
// "= New composer.json file content" => "= New composer.json file content",
// "= Composer execution output" => "= Composer execution output",
"Errors" => "오류",
// "Unable to download composer installer from %0" => "Unable to download composer installer from %0",
// "Invalid composer installer signature" => "Invalid composer installer signature",
// "composer.phar installed in temp folder" => "composer.phar installed in temp folder",
// "There was a problem when installing Composer" => "There was a problem when installing Composer",
// "Tiki root directory is not writable, so file \"%0\" can not be created" => "Tiki root directory is not writable, so file \"%0\" can not be created",
// "Tiki root directory is not writable, so directory \"%0\" can not be created" => "Tiki root directory is not writable, so directory \"%0\" can not be created",
// "Tiki can not write to file \"%0\"" => "Tiki can not write to file \"%0\"",
// "Tiki can not write to directory \"%0\"" => "Tiki can not write to directory \"%0\"",
// "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping.." => "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping..",
// "Warning: Profile %0 already installed. Skipping.." => "Warning: Profile %0 already installed. Skipping..",
// "Profile %0 applied" => "Profile %0 applied",
// "Warning: Profile %0 is not installed. Skipping.." => "Warning: Profile %0 is not installed. Skipping..",
// "Profile %0 removed" => "Profile %0 removed",
// "%0 library not found. This may be due to a typo or caused by a recent update" => "%0 library not found. This may be due to a typo or caused by a recent update",
// "Package %0 is not a Tiki Extension" => "Package %0 is not a Tiki Extension",
// "Package %0 is already enabled" => "Package %0 is already enabled",
// "Package %0 is not enabled" => "Package %0 is not enabled",
"Calendar does not exist" => "달력이 존재하지 않습니다",
"Calendar already exists" => "달력이 이미 존재함",
"File gallery does not exist" => "파일 갤러리가 존재하지 않습니다",
"File gallery already exists" => "파일 갤러리가 이미 존재합니다",
// "Untitled - From Profile Import" => "Untitled - From Profile Import",
// "Field \"%0\" in Tracker %1 has no value for itemId %2" => "Field \"%0\" in Tracker %1 has no value for itemId %2",
"Created by profile installer" => "프로필 설치기가 만듬",
"Page updated by profile installer" => "프로필 설치프로그램에 의하여 갱신된 페이지",
// "Tiki (%0) is not satisfiable by profile required Tiki version (%1)" => "Tiki (%0) is not satisfiable by profile required Tiki version (%1)",
"Nothing was changed. Please check the profile for errors" => "변경된 것이 없습니다, 오류에 대하여 프로필을 확인하십시오",
"Applying profile" => "프로필 적용 중",
"Added (or modified)" => "추가됨 (혹은 수정됨)",
"Group changed (or modified)" => "그룹 변경됨 (혹은 수정됨)",
// "Installer reverted" => "Installer reverted",
// "Installer removed" => "Installer removed",
// "Group removed" => "Group removed",
// "Group modified" => "Group modified",
// "Permission removed" => "Permission removed",
// "Permission assign" => "Permission assign",
"Preference set" => "기본 설정 세트",
// "<error>Package %0:  No folder was found. Did you forgot to install?</error>" => "<error>Package %0:  No folder was found. Did you forgot to install?</error>",
// "Package set" => "Package set",
"Modified permission %s for %s" => "%s 권한을 %s 에 대하여 수정함",
"Modified permission %s on %s/%s for %s" => "%s 권한을 %s/%s 상에서 %s 에 대하여 수정함",
"User %0 was added to %1" => "사용자 %0 님이 %1 로 추가되었습니다",
"No name" => "이름 없음",
"Bad object" => "불량 개체",
// "Could not parse YAML in profile: \"%0\"" => "Could not parse YAML in profile: \"%0\"",
// "Profile Path cannot be found" => "Profile Path cannot be found",
"Syntax error: " => "구문 오류:",
"Circular reference" => "순환 참조",
"Permissions' object must have a field 'type' and 'id'" => "권한의 개체는 반드시 '유형'과 'id'를 보유해야만 합니다",
"Needs a 'type' and 'data' field" => "'유형' 및 '데이터' 필드 필요함",
// "Source: %0:%1 (%2)" => "Source: %0:%1 (%2)",
// "Recommendation: %0:%1 (%2)" => "Recommendation: %0:%1 (%2)",
// "The directory with path: ' . \$path_or_id . ' could not be found" => "The directory with path: ' . \$path_or_id . ' could not be found",
// "The file with path: ' . \$path_or_id . ' could not be found" => "The file with path: ' . \$path_or_id . ' could not be found",
// "The wiki page with name: ' . \$name . ' could not be found" => "The wiki page with name: ' . \$name . ' could not be found",
// "Theme already installed" => "Theme already installed",
"Version %0 is no longer supported" => "%0 버전은 더 이상 지원되지 않습니다",
"A minor upgrade to %0 is strongly recommended" => "%0으로 마이너 업그레이드가 요구됩니다",
"A major upgrade to %0 is strongly recommended" => "%0 으로의 메이저 업그레이드가 필요합니다",
// "Version %0 is still supported. However, an upgrade to %1 is available" => "Version %0 is still supported. However, an upgrade to %1 is available",
// "Version %0 is still supported. However, a major upgrade to %1 is available" => "Version %0 is still supported. However, a major upgrade to %1 is available",
// "Replace spaces with dashes" => "Replace spaces with dashes",
// "Replace spaces with underscores" => "Replace spaces with underscores",
// "URL Encode (Tiki Classic)" => "URL Encode (Tiki Classic)",
// "Duplicate entry found (%0)" => "Duplicate entry found (%0)",
// "Filter error: \"%0\"" => "Filter error: \"%0\"",
"Action" => "조작",
"Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site" => "어딘가에 게시될 서식을 만들기, 반드시 트래커 혹은 티키가 아닐 수도 있음",
"The title of the button" => "버튼의 제목",
"Post" => "게시",
"The protocol to use in the form: either get or post" => "형식에서 사용될 프로토콜: get 혹은 post 중 하나",
"Script" => "스크립트",
"The URL of the destination of the form" => "서식의 목적지의 임의의 URL",
"Parameters" => "매개 변수",
"Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form" => "여기서 page:fieldname 은 여러 번 반복될 수 있습니다, 이는 서식 내부에 전달할 변수명을 지정하며, fieldname 란 이름의 필드로부터의 현재 항목으로부터 취한 값을 지정하기도 합니다. highlight=test 는 또한 반복될 수 있으며 서식으로 전달할 매개변수로써 고정된 값으로써 유용합니다",
// "Attach articles to the tracker item" => "Attach articles to the tracker item",
"Topic" => "토픽",
// "Default article topic" => "Default article topic",
"Article Type" => "기사 종류",
// "Default article type" => "Default article type",
"Auto-Increment" => "자동 증분",
"Enable an incrementing value field, or itemId field" => "증분하는 값 필드 혹은 itemid 필드를 허용함",
"Start" => "시작",
"The starting value for the field" => "필드에 대한 시작 값",
"Prepend" => "앞에 붙임",
"Text that will be displayed before the field" => "필드 전에 표시될 텍스트",
"Append" => "추가",
"Text that will be displayed after the field" => "필드 후에 표시될 텍스트",
"If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "\"itemId\" (항목ID)로 설정된 경우, 이 필드를 실제 데이테베이스 itemId 필드 값에 일치하도록 설정될 것입니다",
// "Update Empty" => "Update Empty",
"No" => "아니요",
"Yes" => "예",
// "Note: %0 auto-increment item values updated" => "Note: %0 auto-increment item values updated",
// "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********" => "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********",
// "Date and Time (Calendar Item)" => "Date and Time (Calendar Item)",
// "Associate calendar items with tracker items" => "Associate calendar items with tracker items",
// "Experimental: (work in progress, use with care)" => "Experimental: (work in progress, use with care)",
// "Calendar Id" => "Calendar Id",
// "Calendar to use for associated events" => "Calendar to use for associated events",
// "Show Event Id" => "Show Event Id",
// "Show an input for the event id when editing the field, allow lost events to be reattached" => "Show an input for the event id when editing the field, allow lost events to be reattached",
// "Calendar Item %0 not found" => "Calendar Item %0 not found",
// "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2" => "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2",
"Category" => "범주",
"Enable the tracker item to be categorized in one or more categories under the specified main category" => "지정된 주 범주 하의 하나 혹은 여러 개의 범주가 트래커 항목에 의해 영향받는 것을 허용",
"Parent Category" => "부모 범주",
"Child categories will be provided as options for the field" => "자식 범주들은 필드에 대해서 선택사항으로써 제공될 것입니다",
"Input Type" => "입력 유형",
"User interface control to be used" => "사용될 사용자 인터페이스 제어",
"Dropdown" => "드랍 다운",
"Radio buttons" => "라디오 버튼",
"List box" => "상자 나열",
"Multiple-selection checkboxes" => "다중선택 체크상자",
"Select All" => "전부 선택",
"Includes a control to select all available options for multi-selection controls" => "다항 선택 제어에 대하여 사용가능한 모든 선택사항을 선택하기 위한 제어 포함",
"No controls" => "제어 없음",
"Include controls" => "제어 포함",
"All descendants" => "모든 하위항목들",
"Display all descendants instead of only first-level descendants" => "첫번째 단계 외에도 모든 하위 항목 표시",
"First level only" => "첫 번째 단계만 해당",
"All descendants and display full path" => "모든 하위항목 및 전체 경로 표시",
"Displays the field description in a help tooltip" => "도움말 툴팁 내부에 필드 설명 표시",
"No help" => "도움말 없음",
"Tooltip" => "툴팁",
// "Output Type" => "Output Type",
// "Plain list with items separated by line breaks (default)" => "Plain list with items separated by line breaks (default)",
// "Links separated by line breaks" => "Links separated by line breaks",
// "Unordered list of labels" => "Unordered list of labels",
// "Unordered list of links" => "Unordered list of links",
// "Do not Inherit Categories" => "Do not Inherit Categories",
// "Inherit (default)" => "Inherit (default)",
// "Do not inherit" => "Do not inherit",
// "Recategorization event" => "Recategorization event",
// "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving" => "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving",
// "Indexing" => "Indexing",
// "-Blank (no data)-" => "-Blank (no data)-",
// "%0 (any of)" => "%0 (any of)",
// "%0 (all of)" => "%0 (all of)",
// "Tracker items will inherit their tracker's categories unless this option is set" => "Tracker items will inherit their tracker's categories unless this option is set",
"Checkbox" => "체크상자",
"Provide a checkbox field for yes/no, on/off input" => "예/아니오, 켜짐/꺼짐 입력에 대한 체크상자 필드를 제공합니다",
"Computed Field" => "연산된 필드",
"Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type" => "숫자 필드 값에 기반하여 계산된 값을 제공합니다. 작업을 수행하기 위하여 이러한 유형을 사용하는 대신 웹서비스 혹은 자바스크립트를 사용하는 것을 고려해 보십시오",
"This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field" => "이 기능은 아직 이전 버전과의 호환성을 위하여 남아있습니다. 관련된 문제는 없지만, 많은 피해를 입힐 수 있는 공격에 대하여 벡터로써 사용될 수 있습니다. 이것 대신 웹서비스 필드 혹은 사용자 지정 자바스크립트가 추천됩니다",
"Formula" => "수식",
"The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "다양한 연산자 (+ - * / 및 괄호)를 지원하는 연산될 공식은 # 가 앞에 오는 필드 ID를 사용하여 만들어진 다른 필드를 참조합니다",
"Decimal Places" => "소수 자릿수",
"Number of decimal places to round to" => "반올림 전 보존해야 할 자리 수",
"Decimal separator when displaying data" => "데이터 표시할 때 소수점 구분 기호",
"Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details" => "한 개의 글자, 쉼표에 대하여 c, 점에 대하여 d, 스페이스에 대하여 s 를 사용. 숫자를 입력할 때 유효한 십진 단위 구분자는 사이트 언어와 웹브라우저를 따릅니다. 추가 상세내역은 설명서를 참고합십시오",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
"Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed" => "한 개의 글자, 쉼표에 대하여 c, 점에 대하여 d, 스페이스에 대하여 s 를 사용. 데이터를 입력시 천단위 구분자는 필요하지 않습니다",
"Country Selector" => "국가 선택기",
"Enable a selection from a specified list of countries" => "지정된 국가들의 목록에서 선택을 허용함",
"Display" => "표시",
"Specify the rendering type for the field" => "필드에 대하여 렌더링 유형을 지정",
"Name and flag" => "이름과 플래그",
"Name only" => "이름 만",
"Flag only" => "플래그 만",
"Sort order" => "정렬 순서",
"Determines whether the ordering should be based on the translated name or the English name" => "정렬이 번역된 이름 혹은 영어 이름에 기반할 것인지 여부를 결정함",
"Translated name" => "번역된 이름들",
"English name" => "영문 이름",
"Currency Field" => "통화 필드",
"Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric" => "수치 입력에 대하여서만 한 줄 필드를 제공합니다. 앞 혹은 뒤에 붙는 값은 알파벳과 숫자일 수 있습니다",
"Same Row" => "같은 행",
"Displays the next field on the same line" => "같은 줄에 다음 필드 표시",
"Display Size" => "크기 표시",
"Visible size of the field, in characters. Does not affect the numeric length" => "캐릭터 단위의 필드의 보이는 크기. 숫자로 된 길이는 영향을 미치지 않음",
"Text to be displayed in front of the currency amount" => "통화 양 이전에 표시될 텍스트",
"Text to be displayed after the numeric value" => "수치 값 후에 표시될 텍스트",
"Locale" => "로캘",
"Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "통화 형식에 대한 로케일 설정, 예를 들면 en_US 혹은 en_US.UTF-8 혹은 en_US.ISO-8559-1. 기본값은 en_US 입니다",
"Currency" => "통화",
"A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "맞춤형 영숫자 화폐 코드. 로캘이 설정되어있고 표준 코드를 원한다면 필요 없음. 기본값은 USD",
"Symbol" => "심볼",
"Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "통화 코드 (예를 들면 USD) 혹은 심볼 (예를 들면 \$)이 표시될 것인지를 설정. 기본은 심볼",
"Currency code" => "통화 코드",
"Currency symbol" => "통화 심볼",
"First or all" => "첫 번째 혹은 전체",
"Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "전체 양 혹은 첫 번째 양에서만 대하여 통화 코드 혹은 심볼이 표시될 것인지를 설정.",
"First item only" => "첫 번째 항목만 해당",
"All" => "모두",
// "Currency Tracker" => "Currency Tracker",
// "Tracker containing available currencies and exchange rates" => "Tracker containing available currencies and exchange rates",
"Date and Time" => "날짜와 시간",
"Provide drop-down options to accurately select a date and/or time" => "날짜 및/혹은 시간을 정확히 선택하기 위하여 드롭다운 선택사항을 제공합니다",
"Components to be included" => "포함될 컴포넌트",
"Date only" => "날짜만",
"Start year" => "시작 년도",
"Year to allow selecting from" => "선택할 수 있는 연도",
"End year" => "종료 년도",
"Year to allow selecting to" => "선택하게 할 연도",
"Default selection" => "기본 선택",
"Indicates if blank dates should be allowed" => "비어있는 날짜가 허용되어야할지를 나타냅니다",
"Current Date" => "현재 날짜",
"Blank" => "비움",
// "Time Ago" => "Time Ago",
// "Use timeago.js if the feature is enabled" => "Use timeago.js if the feature is enabled",
// "Item Date Field" => "Item Date Field",
// "Use this date as the item's global date in the search index" => "Use this date as the item's global date in the search index",
"Allow users to select only from a specified set of options" => "사용자가 선택사항의 지정된 세트에서만 선택하는 것을 허용",
"Option" => "옵션",
"If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label" => "선택사항이 등호를 포함하는 경우, 앞 부분이 값으로 사용되며 뒷부분이 레이블로 사용될 것입니다",
"Dropdown selector with \"Other\" field" => "다른 필드를 가진 드롭 다운",
"Allow users to select from a specified set of options or to enter an alternate option" => "사용자가 선택사항의 지정된 세트로부터 선택 혹은 대체 선택사항을 입력하는 것을 허용",
// "To change the label of the \"Other\" option, use \"other=Label\"" => "To change the label of the \"Other\" option, use \"other=Label\"",
"Radio Buttons" => "라디오 버튼",
"Multiselect" => "다중선택",
"Allow a user to select multiple values from a specified set of options" => "사용자로 하여금 선택사항들 중 지정된 세트에서 여러 개의 값들을 선택하는 것을 허용",
"Dynamic Items List" => "유동 항목 목록",
"Dynamically update a selection list based on linked data from another tracker" => "다른 트래커에서 링크된 데이터에 기반한 선택 목록을 유동적으로 갱신합니다",
"Tracker ID" => "트래커 ID",
"Tracker to link with" => "링크할 트래커",
"Field ID (Other tracker)" => "필드 ID (다른 트래커)",
"Field ID to link with in the other tracker" => "다른 트래커의 내부로 링크될 필드 ID",
"Field ID (This tracker)" => "필드 ID (이 트래커)",
"Field ID to link with in the current tracker" => "현재 트래커의 내부에 링크될 필드 ID",
"Listed Field" => "나열된 필드",
"Field ID to be displayed in the dropdown list" => "드롭목록 내부에 표시될 필드 ID",
"Status Filter" => "상태 필터",
"Restrict listed items to specific statuses" => "나열된 항목들을 지정된 상태로 제한",
"all" => "모두",
"open" => "열기",
"pending" => "보류 중",
"closed" => "닫힘",
"open, pending" => "열림, 보류 중",
"pending, closed" => "보류 중, 닫힘",
// "Hide blank" => "Hide blank",
// "Hide first blank option, thus preselecting the first available option" => "Hide first blank option, thus preselecting the first available option",
"Select multiple values" => "다중 값 선택",
"Allow the user to select multiple values" => "사용자가 여러 개의 값 선택 허용",
// "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***" => "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***",
"*** ERROR: Field %0 not found ***" => "*** 오류: %0 필드 발견되지 않음 ***",
// "*** ERROR: No remote tracker selected for DynamicList Field %0 ***" => "*** ERROR: No remote tracker selected for DynamicList Field %0 ***",
// "DynamicList field: Field \"%0\" not found" => "DynamicList field: Field \"%0\" not found",
"Email" => "이메일",
"Enable an email address to be input with the option of making it active" => "이메일 주소 입력을 활성화할 수 있는 선택사항과 함께 허용",
"Link Type" => "링크 유형",
"How the email address will be rendered" => "이메일 주소가 어떻게 렌더될 것인가",
"Plain text" => "일반 텍스트",
"Encoded mailto link" => "인코드 된 mailto 링크",
"Simple mailto link" => "단순 mailto 링크",
"Watch Open" => "열린 항목 주시",
"Notify this address every time the status changes to open" => "상태가 열림으로 변경될 때마다 이 주소로 알림",
"Watch Pending" => "보류 항목 주시",
"Notify this address every time the status changes to pending" => "상태가 보류 중으로 변경될 때마다 이 주소로 알림",
"Watch Closed" => "닫힌 항목 주시",
"Notify this address every time the status changes to closed" => "상태가 닫힘으로 변경될 때마다 이 주소로 알림",
"Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "트래커 필드 Factory 오류: 기본설정 \"%0\" 이 필드 유형 \"%1\"에 대하여 요구됩니다",
"Attachment" => "첨부파일",
// "Deprecated in favor of the Files field" => "Deprecated in favor of the Files field",
"List View" => "목록 보기",
"Defines how attachments will be displayed within the field" => "첨부파일이 필드 내부에서 어떻게 표시될 지 정의",
"name" => "이름",
"type" => "종류",
"name, size" => "이름, 크기",
"name, type, size" => "이름, 유형, 크기",
"uploader" => "업로드한 이",
"mediaplayer" => "미디어재생기",
"Download" => "다운로드",
"Attached and upload files stored in the file galleries to the tracker item" => "파일 갤러리에 저장된 첨부 및 업로드 파일을 트래커 항목으로",
"Gallery ID" => "갤러리 ID",
"File gallery to upload new files into" => "새 파일일 업로드 해 둘 파일 갤러리",
"MIME Type Filter" => "마임 유형 필터",
"Mask for accepted MIME types in the field" => "필드 내부의 허용된 MIME 유형으로 표시",
"File Count" => "파일 수",
"Maximum number of files to be attached on the field" => "필드에 첨부될 파일들의 최대 수",
"Display Mode" => "모드 표시",
// "Show files as object links or via a wiki plugin (img so far)" => "Show files as object links or via a wiki plugin (img so far)",
"Links" => "링크",
// "Bare Links" => "Bare Links",
"Table" => "표",
"Images" => "그림",
// "Vimeo" => "Vimeo",
// "Google Viewer" => "Google Viewer",
// "Moodle Scorm Viewer" => "Moodle Scorm Viewer",
// "Display parameters" => "Display parameters",
"URL-encoded parameters used such as in the {img} plugin, for example,." => "{img} 플러그인에서 사용되는 URL 인코드된 매게 변수. 예",
// "Display parameters for lists" => "Display parameters for lists",
// "Display Order" => "Display Order",
// "Sort order for the files" => "Sort order for the files",
// "Default (order added to tracker item)" => "Default (order added to tracker item)",
// "Name (A - Z)" => "Name (A - Z)",
// "Name (Z - A)" => "Name (Z - A)",
// "Filename (A - Z)" => "Filename (A - Z)",
// "Filename (Z - A)" => "Filename (Z - A)",
// "Created date (old - new)" => "Created date (old - new)",
// "Created date (new - old)" => "Created date (new - old)",
// "Last modified date (old - new)" => "Last modified date (old - new)",
// "Last modified date (new - old)" => "Last modified date (new - old)",
// "File size (small - large)" => "File size (small - large)",
// "File size (large - small)" => "File size (large - small)",
// "Hits (low - high)" => "Hits (low - high)",
// "Hits (high - low)" => "Hits (high - low)",
"Include Child Galleries" => "자식 갤러리 포함",
"Use files from child galleries as well" => "자식 갤러리에서의 파일도 사용",
"Replace Existing File" => "기존 파일 교체",
"Replace the existing file, if any, instead of uploading a new one" => "기존 파일이 있다면, 새 것을 업로드하는 대신, 교체",
"Browse Gallery ID" => "갤러리 ID 탐색",
"File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)" => "파일 갤러리 탐색 파일. 루트 파일 갤러리에 대하여 0을 사용. (elFinder 기능 필요- 실험적)",
// "Restrict permissions to view the file gallery to hide the button" => "Restrict permissions to view the file gallery to hide the button",
// "Duplicate Gallery ID" => "Duplicate Gallery ID",
// "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)" => "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)",
// "Index As Map Layer" => "Index As Map Layer",
// "Index the files in a specific format for use in map searchlayers to display trails and features" => "Index the files in a specific format for use in map searchlayers to display trails and features",
// "GeoJSON" => "GeoJSON",
// "GPX" => "GPX",
// "Upload In Modal" => "Upload In Modal",
// "Upload files in a new modal window" => "Upload files in a new modal window",
// "Maximum image width" => "Maximum image width",
// "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings",
// "Maximum image height" => "Maximum image height",
// "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings",
// "Add Descriptions" => "Add Descriptions",
// "Add descriptions on uploaded files" => "Add descriptions on uploaded files",
// "Show files as object links or via a wiki plugin (img, Vimeo)" => "Show files as object links or via a wiki plugin (img, Vimeo)",
// "Files field: Gallery #%0 not found" => "Files field: Gallery #%0 not found",
// "Token access needs to be enabled for Google viewer to be used" => "Token access needs to be enabled for Google viewer to be used",
// "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")" => "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")",
"Problem with uploaded file: \"%0\"" => "업로드된 파일에 문제: \"%0\"",
"No gallery for uploaded file, galleryId=%0" => "업로드된 파일에 대한 갤러리 없음, galleryId=%0",
"You don't have permission to upload a file to gallery \"%0\"" => "갤러리 \"%0\" 로 파일 업로드할 권한 없음",
"Allow tags to be shown or added for tracker items" => "프리태그가 트래커 항목에 대하여 표시되거나 추가되는 것을 허용함",
"Visible size of the input field" => "입력 필드의 보이는 크기",
"Hide or show the input help" => "입력 도움말을 숨김 혹은 표시",
"Show" => "보기",
"Hide" => "숨김",
"Suggest" => "제안",
"Hide or show the tag suggestions" => "프리태그 제안을 숨김 혹은 표시",
"Geographic Feature" => "지리적 기능",
// "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved" => "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved",
"Feature cannot be set or modified through this interface" => "기능은 이 인터페이스를 통하여 설정 혹은 수정될 수 없음",
"Feature cannot be viewed" => "기능을 볼 수 없음",
"Group Selector" => "그룹 선택기",
"Allow a selection from a specified list of user groups" => "지정된 사용자 그룹의 목록에서 선택을 허용함",
"Auto-Assign" => "자동 할당",
"Determines if any group should be automatically assigned to the field" => "필드에 어떠한 그룹이라도 자동적으로 할당되어져야 하는지를 결정함",
"Modifier" => "수정자",
"Group Filter" => "그룹 필터",
"Limit listed groups to those including the specified group" => "나열된 그룹들을 지징된 그룹을 포함하는 것들로 제한",
"User Groups" => "사용자 그룹",
// "Show groups user belongs to instead of the ones user has permission to see" => "Show groups user belongs to instead of the ones user has permission to see",
"Assign to the group" => "이 그룹으로 할당",
"For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated" => "자동할당된 필드가 없으면, 사용자 (기존의 사용자 선택기 혹은 사용자) 가 그룹으로 할당될 것이며 그리고 이는 그 사람의 기본 그룹이 됩니다. 그룹에서 사용자 선택 설정이 켜짐 필수",
"Assign" => "할당",
// "Unassign from previous selection" => "Unassign from previous selection",
// "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated" => "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated",
"Unassign" => "할당해제",
"Email Notification" => "이메일 알림",
// "Add selected group to group monitor the item. Group watches feature must be enabled" => "Add selected group to group monitor the item. Group watches feature must be enabled",
"Header" => "머리글",
"Display a heading between fields to delimit a section and allow visual folding of the fields" => "섹션을 구분하기 위하여 필드 간에 헤더 표시하고 필드 접기를 허용",
"Heading Level" => "헤더 레벨",
"Level of the heading to use for complex tracker structures needing multiple heading levels" => "다단계의 제목 레벨이 필요한 복잡한 트래커 구조에 대하여 사용할 제목의 단계",
// "Section Toggle" => "Section Toggle",
"Default State" => "기본 상태",
// "No toggle" => "No toggle",
"Open" => "열기",
"Closed" => "닫힘",
"Icon" => "아이콘",
"Provide the ability to select an image as an icon attached to the tracker item from the file galleries" => "그림을 파일 갤러리에서 트래커 항목으로 첨부된 아이콘으로써 선택하는 것을 허용합니다",
"Default image" => "기본 그림",
"Path to the default icon used" => "사용되는 기본 아이콘으로의 경로",
// "Maximum Icons" => "Maximum Icons",
// "Number of icons to display in each gallery (default 120)" => "Number of icons to display in each gallery (default 120)",
// "Update icon event" => "Update icon event",
// "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items" => "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items",
"Image" => "그림",
"List image width" => "그림 너비 나열",
"Display size in pixels" => "픽셀 단위로 크기 표시",
"List image height" => "그림 높이 나열",
"Detail image width" => "상세한 그림 너비",
"Detail image height" => "상세한 그림 높이",
"Maximum image size" => "최대 그림 크기",
"Maximum image width or height in pixels" => "픽셀단위의 최대 그림 크기 혹은 높이",
"Shadowbox" => "음영상자",
"Shadowbox usage on this field" => "이 필드 상의 음영상자 사용예",
"Do not use" => "사용하지 마십시오",
"One box per item" => "한 항목당 한 상자",
"Use the same box for all images" => "모든 그림에 대하여 동일한 상자 사용",
"Missing Icon" => "아이콘 누락",
"Icon to use when no images have been uploaded" => "업로드 된 그림이 없을 때 사용할 아이콘",
"Invalid imagename (using filters for filenames)" => "유효하지 않은 그림명 (파일명에대하여 필터 사용)",
"In Group" => "그룹 내부에",
"Indicate if the user associated with the item is a member of a specified group" => "항목과 연관된 사용자가 지정된 그룹의 멤버인지를 나타냄",
"Group Name" => "그룹 이름",
"Name of the group to verify" => "확인할 그룹명",
"How to display the result" => "결과를 어떻게 표시할 것인가",
"Yes/No" => "예/아니오",
"Join date" => "참여 날짜",
"Expiration date" => "만기 날자",
"IP Selector" => "IP 선택기",
"IP address input field" => "IP 주소 입력 필드",
"Auto-assign" => "자동 할당",
"Automatically assign the value on creation or edit" => "만들거나 편집 때 자동으로 값을 할당",
"Item Link" => "항목 링크",
"Link to another item, similar to a foreign key" => "다른 항목으로 연결, 외부 키에 유사함",
"Tracker to link to" => "연결할 트래커",
"Field ID" => "필드 ID",
"Default field to display" => "표시할 기본 필드",
"How the link to the item should be rendered" => "항목으로의 링크가 어떻게 렌더되어야 하는가",
"Value" => "값",
"Link" => "링크",
"Multiple Fields" => "다중 필드",
// "Display the values from multiple fields instead of a single one" => "Display the values from multiple fields instead of a single one",
// "Format for Customising Multiple Fields" => "Format for Customising Multiple Fields",
// "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"" => "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"",
// "Multiple Fields display type" => "Multiple Fields display type",
// "Display multiple fields as concatenated list in a dropdown or as a table" => "Display multiple fields as concatenated list in a dropdown or as a table",
// "Plugin TrackerList options" => "Plugin TrackerList options",
// "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)" => "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)",
"Limit the available items to a selected set" => "선택된 세트로 사용가능한 항목들을 제한",
"Link Page" => "링크 페이지",
"Link to a wiki page instead of directly to the item" => "항목에 직접 연결 대신 위키 페이지로 연결",
"Add Items" => "항목 추가",
"Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "추가될 새 항목을 허용할 텍스트 표시 - 예. \"항목 추가...\" (jQuery-UI 필요)",
"Add Item Template Page" => "항목 템플릿 페이지 추가",
"Wiki page to use as a Pretty Tracker template" => "프리티 트래커 템플릿으로 사용될 위키 페이지",
"Preselect item based on value in this field" => "이 필드 내부의 값에 기반하여 항목 사전선택",
"Preselect item based on value in specified field ID of item being edited" => "편집되는 항목의 지정된 필드 ID 내부의 값에 기반하여 항목 사전선택",
"Preselect based on the value in this remote field" => "이 원격 필드 내부의 값에 기반하여 사전선택",
"Match preselect item to this field ID in the tracker that is being linked to" => "트래커가 링크되고 있는 이 필드 ID와 같이 사전 선택 항목 일치",
"Preselection matching method" => "사전선택 일치 방식",
"Method to use to match fields for preselection purposes" => "사전선택 목적으로 필드에 일치하기 위해 사용할 방식",
"Exact Match" => "정확히 일치",
"Field here is part of field there" => "여기 필드는 저쪽 필드의 부분입니다",
"Match domain, used for URL fields" => "일치 도메인, URL 필드에 대하여 사용됨",
// "Cross select. Load all matching items in the remote tracker" => "Cross select. Load all matching items in the remote tracker",
// "Cross select. Load all matching items in the remote tracker plus wildcards" => "Cross select. Load all matching items in the remote tracker plus wildcards",
"One item per value" => "값 당 한 항목",
// "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items" => "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items",
"Displays all the items for a same label with a notation value (itemId)" => "표기값으로 동일한 레이블에 대한 모든 항목을 표시 (itemId)",
// "Display only one item for each label" => "Display only one item for each label",
"Index remote fields" => "원격 필드 색인",
"Index one or multiple fields from the master tracker along with the child, separated by |" => "매스터 트래커를 자식과 함께 |로 구분하여 하나 혹은 여러 개의 필드를 색인화함",
"Cascade actions" => "작업 계단식 배열",
"Status" => "상태",
"Categories and status" => "범주 및 상태",
"Categories and delete" => "범주 및 삭제",
"Delete and status" => "삭제 및 상황",
// "ItemLink: Tracker %0 not found for field \"%1\"" => "ItemLink: Tracker %0 not found for field \"%1\"",
// "ItemLink: Field %0 not found for field \"%1\"" => "ItemLink: Field %0 not found for field \"%1\"",
// "ItemLink field \"%0\": Tracker ID #%1 not found" => "ItemLink field \"%0\": Tracker ID #%1 not found",
"Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status" => "마스터가 갱식 혹은 삭제되었을 때 계단식 배열될 요소들. 여러개의 항목 링크들이 다른 항목들에게 동일한 범주들을 관리하는 것을 시도하였을 경우 범주는 충돌할 수 있습니다. 상태에 대하여서도 동일함",
// "Unsupported field conversion type: from %0 to %1" => "Unsupported field conversion type: from %0 to %1",
"Items List" => "항목 목록",
"Display a list of field values from another tracker that has a relation with this tracker" => "이 트래커와 연관이 있는 다른 트래커로부터 필드 값들의 목록을 표기합니다",
"Tracker from which to list items" => "항목을 나열해 올 트래커",
"Link Field ID" => "링크 필드 ID",
"Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "이 트래커 내부의 항목을 가리키는 항목 링크 혹은 일치될 어떤 다른 값을 포함하는 다른 트래커에서의 필드 ID",
"Value Field ID" => "필드 ID 값",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty",
"Fields to display" => "표시할 필드",
"Display alternate fields from the other tracker instead of the item title" => "항목 제목 대신 다른 트래커에서의 대체 필드 표시",
// "Format for customising fields to display" => "Format for customising fields to display",
// "Sort Fields" => "Sort Fields",
// "Order results by one or more fields from the other tracker" => "Order results by one or more fields from the other tracker",
"How the link to the items should be rendered" => "항목으로의 링크가 어떻게 렌더되어야 하는가",
// "Permission denied importing into linked tracker %0" => "Permission denied importing into linked tracker %0",
// "Errors occurred importing into linked tracker %0" => "Errors occurred importing into linked tracker %0",
// "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
"Date and Time (Date Picker)" => "날짜와 시간 (날짜 선택기)",
"Provide a jQuery UI date picker to select a date and, optionally, a time" => "날자와 선택적으로 시간으로 선택하기 위하여 jQuery-UI 날짜 선택기를 제공합니다",
"Default value" => "기본 값",
"Default date and time for new items" => "새 항목들에 대한 기본 날짜와 시간",
"None (undefined)" => "없음 (정의되지 않음)",
"Item creation date and time" => "항목 만들기 날짜와 시간",
// "Not before" => "Not before",
// "Field ID from this tracker to compare the value against and validate it is not before that timestamp" => "Field ID from this tracker to compare the value against and validate it is not before that timestamp",
// "Not after" => "Not after",
// "Field ID from this tracker to compare the value against and validate it is not after that timestamp" => "Field ID from this tracker to compare the value against and validate it is not after that timestamp",
// "Date Picker Field: \"%0\" is not a valid internal date value" => "Date Picker Field: \"%0\" is not a valid internal date value",
// "%0 cannot be before %1" => "%0 cannot be before %1",
// "%0 cannot be after %1" => "%0 cannot be after %1",
"Kaltura Video" => "칼투라 동영상",
"Display a series of attached Kaltura videos" => "첨부된 칼투라 동영상의 시리즈 표시",
// "URL-encoded parameters used in the {kaltura} plugin, for example," => "URL-encoded parameters used in the {kaltura} plugin, for example,",
"Language" => "언어",
"Assign a language to the tracker item to enable multilingual trackers" => "다국어 트래커를 활성화하기 위하여 언어를 트래커 항목에 할당",
"Indicates if the language should be assigned as the item's language" => "언어가 항목의 언어로써 항당되어야하는지 여부를 지정함",
// "LDAP" => "LDAP",
"Display a field value from a specific user in LDAP" => "LDAP 안의 지정된 사용자에게서 필드값을 표시",
"LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP 필터, 현재 필드의 이름으로 교체될 수 있는 %field_name% 자리 표시자를 포함할 수 있음",
"Field name returned by LDAP" => "LDAP 에 의하여 반환된 필드명",
// "DSN" => "DSN",
"Data source name registered in Tiki" => "티키에 등록된 데이터 소스 명",
"Location" => "위치",
"Enable a geographic location to be selected for the item and displayed on a map" => "항목에 대한 지리적 위치를 선택하고 지도에 표시하는 것을 허용합니다",
"Use as item location" => "항목 위치로 사용",
// "List View Width" => "List View Width",
// "Width of map in pixels when tracker items are shown in list view" => "Width of map in pixels when tracker items are shown in list view",
// "List View Height" => "List View Height",
// "Height of map in pixels when tracker items are shown in list view" => "Height of map in pixels when tracker items are shown in list view",
// "Item View Width" => "Item View Width",
// "Width of map in pixels when a single tracker item is shown" => "Width of map in pixels when a single tracker item is shown",
// "Item View Height" => "Item View Height",
// "Height of map in pixels when a single tracker item is shown" => "Height of map in pixels when a single tracker item is shown",
// "Fields To Search" => "Fields To Search",
// "Fields in this tracker to use as a source to search for a location for" => "Fields in this tracker to use as a source to search for a location for",
// "When To Search" => "When To Search",
// "Event to attempt to search for a location" => "Event to attempt to search for a location",
"Never" => "없음",
// "Save (when Location is empty)" => "Save (when Location is empty)",
// "Save (always)" => "Save (always)",
// "Indexing (when Location is empty)" => "Indexing (when Location is empty)",
// "Indexing (always)" => "Indexing (always)",
// "Location: Field %0 not found for field \"%1\"" => "Location: Field %0 not found for field \"%1\"",
// "Could not find a location for \"%0\"" => "Could not find a location for \"%0\"",
"When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps" => "활성화 될 경우, 검색 지점 지도 상에서 표기될 항목의 지리적 위치로써 필드의 값을 기록함",
// "Mathematical Calculation" => "Mathematical Calculation",
// "Perform a calculation upon saving the item based on other fields within the same item" => "Perform a calculation upon saving the item based on other fields within the same item",
// "Calculation" => "Calculation",
// "Calculation in the Rating Language" => "Calculation in the Rating Language",
// "Re-calculation event" => "Re-calculation event",
// "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed" => "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed",
// "Value will be re-calculated on save. Current value: %0" => "Value will be re-calculated on save. Current value: %0",
"Numeric Field" => "숫자 필드",
"Text to be displayed in front of the numeric value" => "수치 값 이전에 표시될 텍스트",
"Thousands separator when displaying data" => "데이터 표기시 천단위 구분자",
"Page Selector" => "페이지 선택기",
"Allow a selection from the list of pages" => "페이지의 목록에서 선택을 허용함",
"Will auto-assign the creator of the item" => "항목의 만든이를 자동할당 함",
"Visible size of the input in characters" => "캐릭터 단위의 입력의 보이는 크기",
"Create Page" => "페이지 만들기",
"Create missing pages using the page name in this file as the template" => "이 파일 내의 페이지명을 사용하여 템플릿으로 없는 페이지들을 만들기",
"Display the value as a link to the page" => "값을 페이지로의 링크로 표기",
"Rating" => "등급",
// "A rating of the tracker item. Permissions involved: %0" => "A rating of the tracker item. Permissions involved: %0",
"The possible options (comma-separated integers) for the rating" => "등급에 대하여 가능한 선택사항 (쉼표로 분리된 정수)",
"Mode" => "모드",
"Display rating options as" => "등급 선택사항을 다음과 같이 표시",
"Stars" => "별",
"Single Option: for example, Like" => "한 개의 선택사항: 예. Like",
"Labels" => "레이블",
"The text labels (comma-separated) for the possible options" => "가능한 선택사항에 대한 텍스트 레이블 (쉼표로 분리됨)",
"Stars (deprecated)" => "별 (사용되지 않음)",
"Display a star rating" => "별 등급 표시",
"A possible option for the rating" => "등급에 대하여 가능한 선택사항",
// "Stars (system - deprecated)" => "Stars (system - deprecated)",
"Average" => "평균",
"Number of votes" => "투표의 수",
"Your rating" => "귀하의 등급",
"Relations" => "관계",
"Allow arbitrary relations to be created between the trackers and other objects in the system" => "트래커들과 시스템 내부의 다른 개체들 사이에 임의의 관계를 만드는 것을 허용",
"Relation" => "관계",
"Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "관계 한정자. 글자플 포함하고 점으로 구분되는 3부분 한정자여야만 함",
"URL-encoded list of filters to be applied on object selection" => "개체 선택 상에 적용될 필터들의 URL-인코드 된 목록",
"Format" => "포맷",
// "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field" => "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field",
"Read-only" => "읽기-전용",
"Only display the incoming relations instead of manipulating them" => "수신되는 관계를 조작하지말고 표시만 함",
"Include Invert" => "반전 포함",
"Include invert relations in the list" => "목록에서 반전 관계 포함",
"Control how the relations are displayed in view mode" => "보기 모드 내부에서 관계가 어떻게 표시되는지를 제어",
"List" => "목록",
"Count" => "개수",
"Count with toggle for list" => "목록에 대한 토글로 세기",
// "Force Refresh" => "Force Refresh",
// "Re-save related tracker items" => "Re-save related tracker items",
// "On Save" => "On Save",
// "Extra Filter Field" => "Extra Filter Field",
// "Filter objects by value of another field. Use a jQuery seletor to target the element in the page" => "Filter objects by value of another field. Use a jQuery seletor to target the element in the page",
// "Extra Filter Key" => "Extra Filter Key",
// "Key to filter objects by using the value from the Extra Filter Field above" => "Key to filter objects by using the value from the Extra Filter Field above",
// "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save" => "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save",
"and" => "및",
// "show.tiki.org" => "show.tiki.org",
// "Create, display or manage show.tiki.org instances" => "Create, display or manage show.tiki.org instances",
// "Domain name of show server" => "Domain name of show server",
// "For example, show.tikiwiki.org" => "For example, show.tikiwiki.org",
// "Supported Versions" => "Supported Versions",
// "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"" => "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"",
// "Shell username on remote server" => "Shell username on remote server",
// "The shell username on the show server" => "The shell username on the show server",
// "Public key file path" => "Public key file path",
// "System path to public key on local server. Only RSA keys are supported" => "System path to public key on local server. Only RSA keys are supported",
// "Private key file path" => "Private key file path",
// "System path to private key on local server. Only RSA keys are supported" => "System path to private key on local server. Only RSA keys are supported",
// "Show debugging information" => "Show debugging information",
// "Show debugging info during testing" => "Show debugging info during testing",
// "Fixed user ID" => "Fixed user ID",
// "Set fixed user ID instead of using the user ID of the creator of the tracker item" => "Set fixed user ID instead of using the user ID of the creator of the tracker item",
"Static Text" => "정적 텍스트",
"Display the field description as static text to present notes or additional instructions" => "메모 혹은 부가적 인프라스트럭쳐를 표시하기 위하여 사용될 수 있는 정적 텍스트로써 필드 설명을 표시",
"Wiki Parse" => "위키 구문 분석",
"Indicates if the description should be parsed as wiki syntax for formatting" => "설명이 서식적용에 대하여 위키 문법으로써 구문분석될 것인지를 지정함",
"Handle line breaks as new lines only" => "줄 바꿈을 새 줄으로만 처리",
// "Wiki Parse with Pretty Tracker replacements" => "Wiki Parse with Pretty Tracker replacements",
"Maximum Length (List)" => "최대 길이 (목록)",
"Maximum number of characters to be displayed in list mode" => "목록 모드에 표시될 문자들의 최대 양",
"Text Field" => "텍스트 필드",
"Single-line text input" => "한 줄 텍스트 입력",
"Display the field name and input on the same row" => "같은 행에 필드 이름과 입력 표시",
"Visible size of the field, in characters" => "캐릭터 단위의 필드의 보이는 크기",
"Text to prepend when displaying the value" => "값을 표시할 때 앞에 추가할 텍스트",
"Text to append when displaying the value" => "값을 표시할 때 뒤에 붙일 텍스트",
"Maximum Length" => "최대 길이",
"Maximum amount of characters to store" => "저장할 문자들의 최대 양",
"Autocomplete" => "자동완성",
"Enable autocompletion while typing in the field" => "필드 내에 타이핑하는 중 자동완성 활성화",
"Index exact value" => "정확한 값 색인",
"In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "필드의 컨텐츠를 색인하는 것에 더불어, 이를 tracker_field_{perm name}_exact 내부의 식별자로써도 색인합니다. 이 선택사항은 다국어 필드에 대하여 제공되지 않습니다. 대부분의 경우, 제품 코드 혹은 ISBN 번호와 같은 식별자 용도입니다",
// "Full-text search of the content of the field" => "Full-text search of the content of the field",
// "Search for a value prefix" => "Search for a value prefix",
// "Search for a precise value" => "Search for a precise value",
// "Full-text search in the current language" => "Full-text search in the current language",
// "Full-text search in a specific language (%0)" => "Full-text search in a specific language (%0)",
// "%0 (any language)" => "%0 (any language)",
// "Full-text search in any language" => "Full-text search in any language",
"Text Area" => "텍스트 영영",
"Multi-line text input" => "여러 줄 텍스트 입력",
"Toolbars" => "툴바",
"Enable the toolbars as syntax helpers" => "도구모음을 문법 도움말로 활성화",
"Disable" => "사용 안 함",
"Enable" => "활성화",
"Width" => "넓이",
"Size of the text area, in characters" => "글자단위의 텍스트 영역의 크기",
"Height" => "높이",
"Size of the text area, in lines" => "줄 단위의 텍스트 영역의 크기",
"Character Limit" => "글자 제한",
"Maximum number of characters to be stored" => "저장될 문자들의 최대양",
"Display Limit (List)" => "한계 (목록) 표시",
"Maximum number of characters to be displayed in list mode before the value gets truncated" => "값이 잘리기 전의 목록 모드에 표시될 문자들의 최대 양",
"Word Count" => "단어 수",
"Limit the length of the text, in number of words" => "텍스트의 길이를 단어 단위로 제한",
"Distinct Values" => "고유 값",
"All values in the field must be different" => "필드의 모든 값은 달라야만 합니다",
"Use WYSIWYG" => "WYSIWYG 사용",
"Use a rich text editor instead of inputting plain text" => "일반 텍스트 상자 대신 서식있는 텍스트 편집기 사용",
"Word Limit Exceeded" => "단어 제한 초과됨",
"Character Limit Exceeded" => "글자 제한 초과함",
"Create a link to a specified URL" => "지정된 URL로 링크 만듬",
"How the URL should be rendered" => "URL이 어떻게 렌더되어야 하는가",
"URL as link" => "링크로써 URL",
"Site title as link" => "링크로써의 사이트 제목",
"URL as link plus site title" => "링크 및 사이트 제목으로서 URL",
// "Text as link (see Other)" => "Text as link (see Other)",
// "Label of the link text. Requires \"Display\" to be set to \"Text as link\"" => "Label of the link text. Requires \"Display\" to be set to \"Text as link\"",
"Display the list of groups for the user associated with the tracker items" => "트래커 항목들과 연관된 사용자에 대한 그룹의 목록 표시",
// "Show direct groups memberships only" => "Show direct groups memberships only",
// "Do not show inherited/included groups" => "Do not show inherited/included groups",
// "Specify Fields" => "Specify Fields",
// "Get the groups for users from these fields, not the \"owner\" user fields" => "Get the groups for users from these fields, not the \"owner\" user fields",
"User Preference" => "사용자 개인설정",
"Allow user preference changes from a tracker" => "트래커에서 사용자 기본설정 변경을 허용",
"Preference Name" => "기본 설정명",
"Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "조작할 기본설정명. 암호와 이메일은 기본설정이 아니지만 사용자의 프로필을 수정할 수도 있는 유효한 값입니다",
"User Selector" => "사용자 선택기",
// "Allow the selection of a user or users from a list" => "Allow the selection of a user or users from a list",
"Assign the value based on the creator or modifier" => "만든이 혹은 수정자에 기반하여 값 할당",
// "Item Owner" => "Item Owner",
// "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker" => "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker",
// "Send an email notification to the user(s) every time the item is modified" => "Send an email notification to the user(s) every time the item is modified",
"Only when other users modify the item" => "다른 사용자가 항목을 수정했을 때만",
// "Notification Template" => "Notification Template",
// "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)" => "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)",
// "Email Format" => "Email Format",
// "Choose between values text or html, depending on the syntax in the template file that will be used" => "Choose between values text or html, depending on the syntax in the template file that will be used",
"text" => "텍스트",
// "html" => "html",
// "Multiple selection" => "Multiple selection",
// "Allow selection of multiple users from the list" => "Allow selection of multiple users from the list",
// "Yes (complete list)" => "Yes (complete list)",
// "Yes (filterable by group)" => "Yes (filterable by group)",
"Group IDs" => "그룹 ID",
"Limit the list of users to members of specific groups" => "사용자들의 목록을 특정 그룹의 구성원들로 제한",
// "Groups that can modify autoassigned values" => "Groups that can modify autoassigned values",
// "List of group IDs who can change this field, even without tracker_admin permission" => "List of group IDs who can change this field, even without tracker_admin permission",
// "Show real name if possible" => "Show real name if possible",
// "User \"%0\" not found" => "User \"%0\" not found",
"User Subscription" => "사용자 구독",
"Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item" => "등록된 사용자들이 트래커 항목에 자신들이 구독하는 것을 허용. 항목은 이상적으로는 만든이 혹은 관라지에 의하여서만 편집 가능해야 합니다. 그러한 제한을 원하는 경우, 필드값에 구독자의 최대수 뒤에 #를 붙이십시오. 예: 50# 는 이 항목에 대하여 50개의 구독이 허용될 것이라는 것을 의미합니다",
"Webservice" => "웹서비스",
"Display the result of a registered webservice call" => "등록된 웹서비스 호출의 결과 표시",
"Service Name" => "서비스명",
"Webservice name as registered in Tiki" => "티키 내에 등록된 웹서비스명",
"Template Name" => "템플릿 이름",
"Template name to use for rendering as registered with the webservice" => "웹서비스와 함께 등록되어 렌더링을 위해 사용될 템플릿 이름",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name",
// "Require parameters" => "Require parameters",
// "Do not execute the request if parameters are missing or empty" => "Do not execute the request if parameters are missing or empty",
// "All required" => "All required",
// "(default)" => "(default)",
// "First only required" => "First only required",
// "No parameters required" => "No parameters required",
// "Cache time" => "Cache time",
// "Time in seconds to cache the result for before trying again" => "Time in seconds to cache the result for before trying again",
"Read only" => "읽기 전용",
// "Webservice %0 not found" => "Webservice %0 not found",
// "Webservice template %0 not found" => "Webservice template %0 not found",
// "Unknown webservice error (code: %0)" => "Unknown webservice error (code: %0)",
// "Unknown webservice error" => "Unknown webservice error",
// "Data too long for Webservice field %0 with %1" => "Data too long for Webservice field %0 with %1",
// "Error updating Webservice field %0" => "Error updating Webservice field %0",
// "Embed an associated wiki page" => "Embed an associated wiki page",
// "Field that is used for Wiki Page Name" => "Field that is used for Wiki Page Name",
// "Field to get page name to create page name with" => "Field to get page name to create page name with",
// "Namespace for Wiki Page" => "Namespace for Wiki Page",
// "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information" => "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information",
// "Default (trackerfield<fieldId>)" => "Default (trackerfield<fieldId>)",
// "No namespace" => "No namespace",
// "Custom namespace" => "Custom namespace",
// "Custom Namespace" => "Custom Namespace",
// "The custom namespace to use if the custom option is selected" => "The custom namespace to use if the custom option is selected",
// "Rename Wiki Page when changed in tracker" => "Rename Wiki Page when changed in tracker",
// "Rename associated wiki page when the field that is used for Wiki Page Name is changed" => "Rename associated wiki page when the field that is used for Wiki Page Name is changed",
// "Delete Wiki Page when tracker item is deleted" => "Delete Wiki Page when tracker item is deleted",
// "Delete associated wiki page when the tracker item is deleted" => "Delete associated wiki page when the tracker item is deleted",
// "Action Buttons" => "Action Buttons",
// "Display wiki page buttons when editing the item" => "Display wiki page buttons when editing the item",
// "Remove Bad Chars" => "Remove Bad Chars",
// "Remove bad characters from the Wiki Page name" => "Remove bad characters from the Wiki Page name",
// "The page name provided already exists. Please choose another" => "The page name provided already exists. Please choose another",
// "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1" => "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1",
// "Missing Page Name field #%0 for Wiki field #%1" => "Missing Page Name field #%0 for Wiki field #%1",
// "Page \"%0\" already exists. Not overwriting" => "Page \"%0\" already exists. Not overwriting",
// "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)" => "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)",
// "Look up a single item by ID" => "Look up a single item by ID",
"Search" => "검색",
// "Full-text search across all of the content" => "Full-text search across all of the content",
// "Modification Date" => "Modification Date",
// "Unknown value" => "Unknown value",
// "Modified Date" => "Modified Date",
"Actions" => "조작",
// "Dynamic Filters" => "Dynamic Filters",
// "From %0 to %1" => "From %0 to %1",
// "Field not found: %0" => "Field not found: %0",
// "Filter mode not found: %0 for %1" => "Filter mode not found: %0 for %1",
// "Field mode not found: %0 for %1" => "Field mode not found: %0 for %1",
// "Primary Key fields cannot be read-only" => "Primary Key fields cannot be read-only",
// "Column \"%0\" cannot co-exist with \"%1\"" => "Column \"%0\" cannot co-exist with \"%1\"",
// "Column \"%0:%1\" found multiple times" => "Column \"%0:%1\" found multiple times",
// "Primary key already defined" => "Primary key already defined",
// "Not enough columns, expecting \"%0\"" => "Not enough columns, expecting \"%0\"",
// "Header \"%0\" found where \"%1\" was expected" => "Header \"%0\" found where \"%1\" was expected",
// "Header \"%0\" found where ignored column was expected" => "Header \"%0\" found where ignored column was expected",
// "new tracker(s) item(s) created" => "new tracker(s) item(s) created",
// "tracker(s) item(s) updated" => "tracker(s) item(s) updated",
// "Line %0" => "Line %0",
// "duplicate entry" => "duplicate entry",
// "duplicate entry for unique column %0" => "duplicate entry for unique column %0",
// "Import file contains errors. Please review and fix before importing" => "Import file contains errors. Please review and fix before importing",
// "Primary Key not defined" => "Primary Key not defined",
"Create page" => "페이지 만들기",
"Plugin execution pending approval" => "플러그인 실행이 승인 대기 중",
// "Edit plugin" => "Edit plugin",
// "Wiki page pagination has not been enabled" => "Wiki page pagination has not been enabled",
// "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"" => "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"",
"Internal error" => "내부 오류",
"User error" => "사용자 오류",
"Plugin argument(s) missing" => "블러그인 인수(들) 누락됨",
"Plugin <strong>%0</strong> cannot be executed" => "<strong>%0</strong> 플러그인은 실행될 수 없음",
"Set" => "설정",
"Plugin disabled" => "플러그인 비활성화 됨",
"Edit Plugin" => "플러그인 편집",
// "Unable to locate cryptphrase" => "Unable to locate cryptphrase",
// "Single Container" => "Single Container",
// "Classic Tiki (3 containers - header, middle, footer)" => "Classic Tiki (3 containers - header, middle, footer)",
// "Classic Bootstrap (fixed top navbar)" => "Classic Bootstrap (fixed top navbar)",
"Line" => "줄",
"Lines" => "줄",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: 라인수 불일치: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: 실패함",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: 편집 시퀀스가 최적이 아닙니다",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "Problem setting user for \"%0\"" => "Problem setting user for \"%0\"",
// "Problem setting group for \"%0\"" => "Problem setting group for \"%0\"",
// "Problem setting mode for \"%0\"" => "Problem setting mode for \"%0\"",
// "Upload was not successful for \"%0\"" => "Upload was not successful for \"%0\"",
// "Subgallery number to galleryId error: Too many subdirs (%0)</span>" => "Subgallery number to galleryId error: Too many subdirs (%0)</span>",
// "Subgallery number to galleryId error: Not an integer (%0)</span>" => "Subgallery number to galleryId error: Not an integer (%0)</span>",
// "Subgallery number to galleryId error: Gallery with ID %0 not found</span>" => "Subgallery number to galleryId error: Gallery with ID %0 not found</span>",
// "Created by batch upload by user \"%0\" on %1" => "Created by batch upload by user \"%0\" on %1",
// "Create gallery \"%0\" failed</span>" => "Create gallery \"%0\" failed</span>",
// "No permsission to create gallery \"%0\"</span>" => "No permsission to create gallery \"%0\"</span>",
// "Gallery \"%0\" not found</span>" => "Gallery \"%0\" not found</span>",
"Upload was successful" => "업로드 성공",
"File %s removed from Batch directory" => "%s 파일이 일괄 디렉터리에서 삭제됨",
"Impossible to remove file %s from Batch directory" => "일괄 디렉터리에서 %s 파일을 삭제하기가 불가능함",
"Invalid directory name" => "유효하지 않은 디렉터리명",
// "Move was not successful for \"%0\"" => "Move was not successful for \"%0\"",
// "Copy was not successful for \"%0\"" => "Copy was not successful for \"%0\"",
// "Move was successful" => "Move was successful",
// "Copy was successful" => "Copy was successful",
// "Cannot write to this path: " => "Cannot write to this path: ",
// "Cannot read this file: " => "Cannot read this file: ",
// "Cannot remove file from gallery" => "Cannot remove file from gallery",
// "Migrated Image Galleries" => "Migrated Image Galleries",
// "Converted from image gallery" => "Converted from image gallery",
"My Files" => "내 파일",
"Files of %0" => "%0의 파일들",
"Cannot open this file" => "이 파일 열기 불가",
" copy" => " 복사",
// "Processing search text from a \"%0\" file in gallery #%1" => "Processing search text from a \"%0\" file in gallery #%1",
"User File Galleries" => "사용자 파일 갤러리",
"Wiki Attachment File Galleries" => "위키 첨부 파일 갤러리",
"File Galleries" => "파일 갤러리",
"The upload was not completed" => "업로드가 이루어지지 않았습니다",
"Reason: The global quota has been reached" => "이유: 전역 할당에 도달했습니다",
"Reason: The quota has been reached in \"%s\"" => "이유: 할당이 \"%s\" 내에서 도달했습니다",
"File gallery quota exceeded" => "파일 갤러리 할당량이 초과됨",
"Number of files transferred to the database" => "데이터베이스로 전송된 파이들의 수",
"Number of files transferred to the file system" => "파일 시스템으로 전성된 파일들의 수",
"Old File deleted" => "기존 파일 삭제됨",
"Incorrect param" => "틀린 변수",
"You do not have permission to remove files from this gallery" => "이 갤러리에서 파일들을 삭제할 권한이 없습니다",
"Warning: The file is used in" => "경고: 파일이 다음에서 사용됨",
"You are trying to edit multiple files in different galleries, which is not supported yet" => "다른 갤러리 안의 여러 개의 파일을 편집하려 시도 중이십니다, 이는 아직 지원되지 않습니다",
"The specified file does not exist" => "지정된 파일이 존재하지 않습니다",
"Upload was not successful" => "업로드가 성공적이지 아니었음",
"An exception occurred" => "예외가 발생했습니다",
"Batch file processed" => "일괄 파일 처리됨",
"Errors detected" => "오류 감지도미",
"Check that these paths exist and are writable by the web server" => "이 경로들이 존재하는지와 웹서버에서 쓰기 가능한 지 검사",
"File added: " => "파일 추가됨:",
"Cannot read the file" => "파일 읽기 불가",
"Warning: Empty file" => "경고: 비어있는 파일",
"Please re-upload the file" => "파일을 다시 업로드하여 주십시오",
"The upload was not successful due to duplicate file content" => "업로드가 성공적이지 아니었음. 파일 내용 복제",
// "Files uploaded" => "Files uploaded",
// "File \"%0\" uploaded" => "File \"%0\" uploaded",
"File update was successful" => "파일 갱신이 성공적이었습니다",
"Automatic revision from source" => "소스에서 자동 수정",
// "Images successfully moved to file gallery %0" => "Images successfully moved to file gallery %0",
// "Images could not be opened or uploaded" => "Images could not be opened or uploaded",
// "No changes were made since no images in wiki_up were found in Wiki pages" => "No changes were made since no images in wiki_up were found in Wiki pages",
// "No images found" => "No images found",
// "%0 on page %1 could not be opened" => "%0 on page %1 could not be opened",
// "%0 on page %1 could not be uploaded into the file gallery" => "%0 on page %1 could not be uploaded into the file gallery",
// "%0 used on page %1 was moved and given the file ID %2" => "%0 used on page %1 was moved and given the file ID %2",
// "Forcing a filetype of image/svg+xml is blocked for security reasons" => "Forcing a filetype of image/svg+xml is blocked for security reasons",
// "SVG files are not safe and cannot be uploaded" => "SVG files are not safe and cannot be uploaded",
// "PHP Zip extension not found, reqiuired for Feature H5P" => "PHP Zip extension not found, reqiuired for Feature H5P",
// "PHP Class \"ZipArchive\" not found" => "PHP Class \"ZipArchive\" not found",
// "Missing content parameters" => "Missing content parameters",
// "Invalid content parameters" => "Invalid content parameters",
// "Missing title" => "Missing title",
// "Title is too long. Must be 256 letters or shorter" => "Title is too long. Must be 256 letters or shorter",
// "Invalid content type" => "Invalid content type",
// "Created by H5P" => "Created by H5P",
// "The chosen content type isn't installed" => "The chosen content type isn't installed",
"This is an approximation based on your server memory limit" => "귀하의 서버 메모리 제한에 기반한 근사치입니다",
"This is the value of your server's PHP '%s' setting" => "서버의 PHP '%s' 설정의 값입니다",
// "Not a git repository" => "Not a git repository",
// "Branch \"%s\" not found" => "Branch \"%s\" not found",
// "Can't get Git object file" => "Can't get Git object file",
// "Goal achieved" => "Goal achieved",
// "Event Count" => "Event Count",
// "Event Count (Forever)" => "Event Count (Forever)",
// "Goal Reached (Periodic)" => "Goal Reached (Periodic)",
// "Goal Reached (Forever)" => "Goal Reached (Forever)",
// "Has Badge" => "Has Badge",
// "Add One-Time Badge" => "Add One-Time Badge",
// "%0 Badge" => "%0 Badge",
// "Remove One-Time Badge" => "Remove One-Time Badge",
// "%0 Badge (Remove)" => "%0 Badge (Remove)",
"Credits" => "크레딧",
// "%0 credit(s) - %1" => "%0 credit(s) - %1",
// "Unknown credit type" => "Unknown credit type",
"You are alerted by the server " => "서버에서 경고를 받았습니다",
"You can check the modifications at: " => "수정을 다음에서 확인할 수 있습니다 :",
"You are alerted of a change on " => "다음의 변경에 대한 경고를 받았습니다",
// "JavaScript file \"%0\" cannot be found so will not be minified" => "JavaScript file \"%0\" cannot be found so will not be minified",
"No image yet, sorry" => "아직 그림이 없습니다, 죄송합니다",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "미확인 목적 디렉터리. <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a> 에 설치하십시오",
"unlink failed" => "링크해제 실패함",
"The uploaded file exceeds the upload_max_filesize directive in php.ini" => "업로드된 파일이 php.ini의 upload_max_filesize 지시문을 초과하였습니다",
"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "업로드 파일이 HTML 형식으로 지정된 MAX_FILE_SIZE 지시어를 초과하였습니다",
"The uploaded file was only partially uploaded. Please try again" => "업로드된 파일은 부분적으로만 업로드되었습니다. 다시 시도하여 주십시오",
"No file was uploaded" => "업로드 된 파일이 없습니다",
"Missing a temporary folder" => "임시 폴더 없음",
"Failed to write file to disk" => "디스크에 파일 쓰기 실패함",
"File upload stopped by extension" => "파일 업로드가 확장기능에 의해 정지됨",
"Set new blog as Tiki homepage" => "새 블로그를 티키 홈페이지로 설정",
"Importation completed" => "가져오기 완료됨",
"<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "가져오기 프로세스를 완료하려면 <a href=\"tiki-importer.php\">여기를 클릭</a>",
"Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "%0개의 게시물, %1개의 페이지, %2개의 태크 및 %3개의 범주 발견됨. 이들을 티키로 삽입 중",
"Item \"%0\" NOT imported (there was already a item with the same name)" => "항목 \"%0\" 가져오기 안됨 (동일한 이름의 항목이 이미 있음)",
"Page \"%0\" sucessfully imported" => "\"%0\" 페이지 성공적으로 가져오기 됨",
"Post \"%0\" sucessfully imported" => "게시물 \"%0\" 이 성공적으로 가져오기 됨",
"Import images and other attachments" => "그림과 다른 첨부파일 가져오기",
"Update internal links (experimental)" => "내부 링크 갱신 (실험적)",
"Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)" => "구 WP URL에서 새 티키 URL로 리디렉션할 .htaccess 규칙들을 제안(실험적)",
"Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "DOMDocument 클래스 제공되지 않음, PHP 설치내역을 확인하십시오.  추가정보는 http://php.net/manual/en/book.dom.php 을 참조하십시오",
"Invalid file MIME type" => "유효하지 않은 파일 mime 유형",
"There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information" => "XML 파일 로딩 중 오류. XML 파일의 서식오류 가능성. 워드프레스의 몇몇 버전은 서식이 잘못된 XML 파일을 생성합니다. 추가 정보는 티키 가져오기 도구 (Tiki Importer) 문서를 참조하십시오",
"Invalid WordPress XML file" => "유효하지 않은 워드프레스 XML 파일",
"No attachments found to import" => "가져오기할 첨부파일 발견되지 않음",
"Importing attachments" => "첨부파일 가져오는 중",
"Attachment %0 successfully imported" => "첨부파일 %0 성공적으로 가져오기 함",
"Unable to download attachment %0. Error message was: %1 %2" => "첨부파일 %0 의 다운로드를 할 수 없었음. 오류 메시지: %1 %2",
"%0 attachments imported and %1 errors" => "%0 첨부파일들이 가져오기되었고 %1 오류",
"Page \"%0\" successfully extracted" => "\"%0\" 페이지가 성공적으로 추출됨",
"Post \"%0\" successfully extracted" => "게시물 \"%0\" 이 성공적으로 추출됨",
"Extracting data from XML file" => "XML 파일에서 데이터 추출 중",
"Number of page revisions to import (0 for all revisions)" => "가져오기할 페이지 수정 수 (모든 수정내역은 0)",
"What to do with page names that already exists in Tiki" => "티키에 이미 존재하는 페이지명에 대한 처리 방법",
"Do not import" => "가져오기 않함",
"Override" => "재정의",
"Prepend software name as a prefix to the page name" => "페이지 이름으로 접두어로써 소프트웨어 이름 추가",
"Page %0 sucessfully imported" => "%0 페이지 성공적으로 가져옴",
"Page %0 NOT imported (there was already a page with the same name)" => "%0 페이지 가져오기 안 됨 (동일한 이름의 페이지가 이미 있습니다)",
"%0 pages parsed. Starting to insert those pages into Tiki" => "%0 페이지들이 구문분석됨. 이 페이지들을 티키로 삽입 시작 중",
"Import images and attachments (see documentation for more information)" => "그림과 첨부파일 가져오기 (추가 정보는 문서를 보십시오)",
"Add a maketoc at the top of each page" => "각 페이지의 상단에 maketoc 추가",
"The XML file does not validate against the MediaWiki XML schema" => "XML 파일은 미디어위키 XML 스키마에 대하여 유효화되지 않음",
"Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments" => "중단하는 중: 첨부파일 (%0) 에 대한 대상 디렉터리가 존재하지 않습니다.  문제를 수정하거나 첨부파일 없이 가져오기를 시도하십시오",
"Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments" => "중단하는 중: 첨부파일 (%0) 에 대한 대상 디렉터리가 쓰기가능하지 않습니다. 문제를 수정하거나 첨부파일 없이 가져오기를 시도하십시오",
"File %0 is not being imported because there is already a file with the same name in the destination directory (%1)" => "파일 %0 은 목표 디렉터리 (%1) 내의 동일한 이름의 파일이 이미 있으므로 가져오기 안함",
"File %0 successfully imported" => "파일 %0 를 성공적으로 가져오기 했습니다",
"Unable to download file %0. File not found" => "파일 %0 의 다운로드를 할 수 없었승. 파일이 발견되지 않음",
"Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer" => "\"%1\" 페이지의 의 %0 수정판을 구문분석 하는 도중 오류 . 혹은 페이지 구문 상 또는 Text_Wiki 구문분석기 (가져오기 프로그램에 의해 사용되는 구문분석기) 상에 오류가 있습니다",
"Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "\"%0\" 페이지가 %1 수정내역과 함께 성공적으로 구문분석됨 (총 %2 개의 수정내역에서)",
"Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "\"%0\" 페이지는 가져오기가 되지 않을 것입니다. 페이지 수정내역 어느 것도 구문분석이 가능하지 않았습니다",
"MediaWiki XML file version %0 is not supported" => "미디어위키 XML 파일 버전 %0은 지원되지 않습니다",
"Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "중단하는 중: 첨부파일 가져오기를 할 수 있으려면 PHP 설정 'allow_url_fopen' 을 활성화 해야합니다. 문제를 수정하거나 첨부파일 없이 가져오기를 시도하십시오",
"Parsing pages" => "페이지 구문분석 중",
"No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments" => "가져오기 할 첨부파일이 발견되지 않음! XML 파일을 dumpDump.php 스크립트와 --uploads 선택사항과 함께 만들었는지 확인하십시오. 첨부파일을 가져오기 할 유일한 방법입니다",
// "Invalid template name: %0" => "Invalid template name: %0",
// "Unnamed file" => "Unnamed file",
"string" => "문자열",
"Unknown language" => "알 수 없는 언어",
"Error: unable to write to lang/%s/language.php" => "오류: lang/%s/language.php 에 쓸 수 없음",
"The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again" => "lang/%0/language.php 파일은 올바르게 서식적용되지 않았습니다. get_strings.php?lang=%0 을 실행하시고 다시 번역 내보내기를 시도하여 주십시오",
"Contributions" => "기여",
// "reverted" => "reverted",
"section level 0" => "부분 단계 0",
"sorted section level 0" => "정렬된 섹션 레벨 0",
"section level 1" => "부분 단계 1",
"section level 2" => "부분 단계 2",
"section level 3" => "부분 단계 3",
"option" => "옵션",
"separator" => "구분 기호",
"You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu" => "새 선택사항을 만들기 위하여 optionid = 0 만을 사용할 수 있습니다 혹은 메뉴에 이미 속해있는 ID를 갱신하기 위하여 동일한 optionId 를 사용할 수 있습니다",
"menu" => "메뉴",
"NONE" => "없음",
"(values not interpreted)" => "(값은 해석되지 않음)",
"Unknown Field: " => "알 수 없는 필드:",
"duplicate fields do not match" => "복제 필드들이 일치하지 않음",
"Description not available" => "설명이 사용가능하지 않습니다",
"Module Title" => "모듈 제목",
"Title to display at the top of the box" => "상자 상단에 표시할 제목",
"No Box" => "상자 없음",
"Show only the content" => "컨텐츠만 표시;",
"Title, background, etcs" => "장식",
"Show module decorations" => "모듈 장식 표시",
"No Title" => "제목 없음",
"Hide module title" => "모듈 제목 감춤",
"Module displayed depending on category. Separate multiple category IDs or names by semi-colons" => "범주에 의존하여 표시되는 모듈. 여러 개의 범주 ID들 혹은 이름들은 세미콜론으로 구분될 수 있습니다",
"No Category" => "범주 없음",
"Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above" => "범주에 의존하여 감춰진 모듈. 여러 개의 범주 ID들 혹은 이름들은 세미콜론으로 구분될 수 있습니다. 이는 위킈 범주 매개변수에 비하여 우선합니다",
"Category subtrees" => "범주 하위트리",
"Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)" => "범주 내부에 나열된 범주들의 자식 범주들과 그 어떤 범주도 그러한 범주들의 일부가 되지 않도록 하는 것을 고려해 보십시오. (0 혹은 1)",
"Perspective" => "퍼스펙티브",
"Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons" => "나열된 퍼스펙티브 ID들 중 하나 안에 있는 경우에만 모듈을 표시합니다. 세미콜론으로 구분됩니다",
"Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons" => "지정된 언어에 대하여서만 적용가능한 모듈. 언어는 2글자 언어코드로 정의되었습니다. 다중값은 세미콜론으로 구분가능합니다",
"Section" => "구역",
// "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page" => "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page",
"Page Filter" => "페이지 필터",
"Module is displayed only on the specified page(s). Separate multiple page names by semi-colons" => "지정된 페이지명 상에서만 적용가능한 모듈. 다중값은 세미콜론으로 구분가능합니다",
"No Page" => "페이지 없음",
"Module is not displayed on the specified page(s). Separate multiple page names by semi-colons" => "지정된 페이지명 상에 적용 가능하지 않은 모듈. 다중 값은 세미콜론으로 구분가능 함",
"Theme" => "테마",
"Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons" => "테마 파일명에 의존하여 활성 혹은 비활성화 되는 모듈 (예 \"thenews.css\"). 지정된 테마들은 포함되거나 예외될 수 있습니다. \"!\" 가 앞에 붙은 테마명들은 예외 목록 내부에 있습니다. 여러 값들은 세미콜론으로 구분될 수 있습니다",
"Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "사용자의 위키 페이지와의 관계에 기반하여서만 제공되는 모듈. 만든이들만 (y) 혹은 만들지 않은 이들만 (n)  중 하나 만이 모듈을 보게 될 것입니다",
"Contributor" => "기여자",
"Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "사용자의 위키 페이지와의 관계에 기반하여서만 제공되는 모듈. 기여자들만 (y) 혹은 비기여자들만 (n)  중 하나 만이 모듈을 보게 될 것입니다",
"Flip" => "뒤집기",
"Users can open and close the module" => "사용자는 모듈에 음영처리를 할 수 있습니다",
"Style" => "스타일",
// "CSS style attribute (for example, to position the module)" => "CSS style attribute (for example, to position the module)",
"Class" => "클래스",
// "Extra class (for CSS or JavaScript)" => "Extra class (for CSS or JavaScript)",
"Containing Class" => "포함하는 클래스",
"Custom CSS class of div around the module" => "사용자 지정 CSS 클래스 around",
"Cookie Consent" => "쿠키 사용 동의",
"Show only if consent to accept cookies has been granted" => "쿠키에 대한 동의가 허용되었을 경우에만 표시",
"No Numbers" => "숫자 없음",
"If set to \"y\", the module will not number list items" => "\"y\" 로 설정될 경우, 모듈이 목록 항목들에 번호를 부여하지 않을 것입니다",
"Rows" => "행",
"Number of rows, or items, to display" => "표기할 행 혹은 항목의 수",
"Default: 10" => "기본: 10",
"Failed to execute \"%0\" module" => "\"%0\" 모듈 실행 실패함",
"Missing dependencies" => "의존성 없음",
"Contact the system administrator" => "시스템 관리자에게 연락하십시오",
// "Module file \"%0\" not found" => "Module file \"%0\" not found",
"Newsletter subscription information at" => "회보 구독 정보",
// "Cannot add subscribers from a newsletter that includes this newsletter's subscribers" => "Cannot add subscribers from a newsletter that includes this newsletter's subscribers",
// " after sending to" => " after sending to",
// " after error in sending to" => " after error in sending to",
// " after failure to send to" => " after failure to send to",
// "Error - potential cross site request forgery detected" => "Error - potential cross site request forgery detected",
// "Potential cross site forgery request detected" => "Potential cross site forgery request detected",
"Limiting the email send rate. Resuming in %0 seconds" => "이메일 발송율 제한 중. %0 초 후에 재개",
"Newsletter successfully sent to %s users" => "회보가 성공적으로 %s 사용자님들께 전송됨",
"Number of errors: %s" => "%s 오류가 있었습니다",
// "End of last article" => "End of last article",
// "potential CSRF" => "potential CSRF",
"invalid email" => "유효하지 않은 이메일",
"A user registers" => "사용자가 등록함",
"A user submits an article" => "사용자가 기사를 제출했음",
"A user edits an article" => "사용자가 기사를 편집했음",
"A user deletes an article" => "사용자가 기사를 삭제했음",
"An article is submitted, edited, deleted or commented on." => "기사가 제출, 편집, 삭제 혹은 댓글추가 됨",
"A new blog post is published" => "새 블로그 게시물이 게재됨",
"A blog post comment is posted or edited" => "플로그 페이지 내부에 댓글이 게시되거나 편집되었습니다",
"A wiki page is created, deleted or edited, except for minor changes." => "위키 페이지가 만들어졌거나, 삭제되었거나 편집 됨, 사소한 변경은 제외됨.",
"A wiki page is created, deleted or edited, even for minor changes." => "위키 페이지가 만들어졌거나, 삭제 혹은 편집 됨, 사소한 변경도 포함.",
"A wiki page comment is posted or edited" => "위키 페이지의 댓글이 게시되거나 편집됨",
"An article comment is posted or edited" => "기사의 댓글이 게시되거나 편집됨",
"Token is called" => "토큰이 호출됨",
"User joins a group" => "사용자가 그룹에 참여함",
// "User's comment is replied" => "User's comment is replied",
"Category change in a language" => "언어 내부의 범주 변경",
"A new page is created in a language" => "새 페이지가 한 언어로 만들어졌습니다",
// "Cannot save invalid client" => "Cannot save invalid client",
// "Name cannot be empty" => "Name cannot be empty",
// "Redirect URI cannot be empty" => "Redirect URI cannot be empty",
// "Invalid URL for redirect URI" => "Invalid URL for redirect URI",
"section edit" => "부분 펴닙",
// "Engine \"%0\" not found" => "Engine \"%0\" not found",
// "Output converter \"%0\" not found" => "Output converter \"%0\" not found",
// "Parsed Data" => "Parsed Data",
"Data" => "데이터",
// "Mapping" => "Mapping",
"Edit Section" => "섹션 편집",
"index" => "색인",
"Table of contents" => "목차",
"Show/Hide" => "표시/감춤",
// "Processing page: %0, is_html: %1" => "Processing page: %0, is_html: %1",
"Payment was sent but verification is not currently available (this feature is a work in progress)" => "지불 전송됨 하지만 확인은 현재 사용할 수 없습니다. (작업 중)",
// "Cart: Product code mismatch" => "Cart: Product code mismatch",
// "Cart: Product exchange mismatch" => "Cart: Product exchange mismatch",
// "Invalid gift certificate: %0" => "Invalid gift certificate: %0",
"Please enter your shopper information first" => "구매자 정보를 먼저 입력하여 주십시오",
// "No email found for gift certificate recipient" => "No email found for gift certificate recipient",
"Gift card is not valid for products in cart" => "선물카드가 카트 내의 제품에 유효하지 않습니다",
// "for" => "for",
"Bundled Product" => "번들된 제품",
"Product" => "제품",
"Quantity" => "양",
"Unit Price" => "단위 가격",
"There is insufficient inventory to meet your request" => "귀하의 요청에 대하여 충분한 재고가 남아있지 않습니다",
// "Advanced Shopping Cart setup error: Orders profile missing" => "Advanced Shopping Cart setup error: Orders profile missing",
"Gift Certificate: " => "선물 상품권",
"Gift Certificate Amount Used: " => "사용된 선물 상품권 양:",
"No registries specified in admin/payment/cclite" => "관리/지불/cclite 내부에 지정된 레지스트리 없음",
"Cclite payment initiated on %0" => "Cclite 지불이 %0 에서 초기화됨",
"Connection to Cclite server %0 failed for %1<br />\"%2\"" => "cclite 서버 %0 로의 연결 실패 for %1<br />\"%2\"",
"Tiki credits payment done on %0 for %1 (using %2)" => "티키 신용 지불이 %0 에 %1 에 대하여 (%2 를 사용하여) 완료되었습니다",
// "PDF webkit path \"%0\" not found" => "PDF webkit path \"%0\" not found",
// "The PDF webkit path has not been set" => "The PDF webkit path has not been set",
// "PDF WeasyPrint path \"%0\" not found" => "PDF WeasyPrint path \"%0\" not found",
// "The PDF WeasyPrint path has not been set" => "The PDF WeasyPrint path has not been set",
// "PDF webservice URL \"%0\" not found" => "PDF webservice URL \"%0\" not found",
// "The PDF webservice URL has not been set" => "The PDF webservice URL has not been set",
// "The package mPDF is not installed. You can install it using packages" => "The package mPDF is not installed. You can install it using packages",
// "PDF generation failed" => "PDF generation failed",
// "This is set by the administrator (search for \"print\" in the control panels to locate the setting)" => "This is set by the administrator (search for \"print\" in the control panels to locate the setting)",
"Required function shell_exec is not enabled" => "필수 함수 shell_exec 가 활성화되지 않음",
"No category jail set in any perspective" => "임의의 Perspective 에 범주 jail 설정된 바 없음",
"Areas root category ID" => "영역 루트 범주 id",
"is invalid" => "은 유효하지 않습니다",
// "Access-Control-Allow-Origin" => "Access-Control-Allow-Origin",
// "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server" => "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server",
// "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site" => "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site",
// "Record basic events" => "Record basic events",
// "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged" => "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged",
// "Record tracker item update" => "Record tracker item update",
// "Enable recording of basic internal Tiki events" => "Enable recording of basic internal Tiki events",
// "Record tracker item creation" => "Record tracker item creation",
// "Record user following users" => "Record user following users",
// "Record user being followed by users" => "Record user being followed by users",
// "Record user adding new friend" => "Record user adding new friend",
// "Custom activities" => "Custom activities",
// "Allow the defining of custom behaviors in addition to internal events" => "Allow the defining of custom behaviors in addition to internal events",
// "Enable notifications through activities" => "Enable notifications through activities",
// "Allow users to create notifications using activities" => "Allow users to create notifications using activities",
"Ajax auto-save" => "Ajax 자동저장",
// "Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing" => "Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing",
"Inline editing" => "인라인 편집",
"Enable inline editing of certain values. Currently limited to tracker item fields" => "특정 값의 인라인 편집을 허용. 현재 트래커 항목 필드으로만 제한되어 있음",
"Tracker list inline editing" => "트래커 목록 인라인 편집하기",
// "Enable inline editing of all fields on the tracker list page" => "Enable inline editing of all fields on the tracker list page",
// "ffmpeg path" => "ffmpeg path",
// "Path to the location of the ffmpeg binary" => "Path to the location of the ffmpeg binary",
// "ffprobe path" => "ffprobe path",
// "Path to the location of the ffprobe binary" => "Path to the location of the ffprobe binary",
// "Alchemy Image library" => "Alchemy Image library",
// "Select either Image Magick or GD Graphics Library" => "Select either Image Magick or GD Graphics Library",
// "Imagemagick" => "Imagemagick",
// "GD" => "GD",
// "unoconv path" => "unoconv path",
// "Path to the location of the unoconv binary" => "Path to the location of the unoconv binary",
// "ghostscript path" => "ghostscript path",
// "Path to the location of the ghostscript binary" => "Path to the location of the ghostscript binary",
// " (Extension not loaded)" => " (Extension not loaded)",
// "Search index rebuild" => "Search index rebuild",
// "Tracker item export" => "Tracker item export",
// "Tracker clear" => "Tracker clear",
// "Printing to PDF" => "Printing to PDF",
// "PHP execution" => "PHP execution",
// "for example 256M, currently is %0" => "for example 256M, currently is %0",
// "for example 30 seconds, currently is %0 seconds" => "for example 30 seconds, currently is %0 seconds",
// "%0 memory limit" => "%0 memory limit",
"Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server" => "%0 동안 사용할 메모리 제한을 임시적으로 조절. 데이터의 크기에 따라, 어떤 대형 작업은 더 많은 메모리를 요구합니다. 작업 당, 이를 지역적으로 증가하는 것은 전역적으로 적은 메모리 제한을 유지하는 것을 허용합니다. 메모리 사용은 여전히 서버에서 사용가능한 것에 국한된다는 점에 유의하십시오",
// "for example: 256M" => "for example: 256M",
// "%0 time limit" => "%0 time limit",
"Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values" => "%0 동안 사용할 시간 제한을 임시적으로 조절. 데이터의 크기에 따라, 어떤 요청은 더 많은 시간을 요구합니다. 시간제한을 지역적으로 증가하여 문제를 해결하십시오. 적절한 값을 사용하십시오",
"seconds" => "초",
"Users accept internal messages by default" => "사용자는 기본으로 내부 메시지를 받게됩니다",
// "Users can opt out of internal messages" => "Users can opt out of internal messages",
"ID of category whose child categories are bound to a perspective by areas" => "자식들이 영역 별로 Perspective에 묶이게 되는 범주의 ID",
"Newest first" => "가장 새 것이 처음",
"ascending" => "오름차순",
"descending" => "내림차순",
// "Article order" => "Article order",
"Default sort mode for the articles on the list-articles page" => "기사 나열에 대한 기사에 대한 기본 정렬 모드",
"Title of articles homepage" => "기사 홈페이지 제목",
// "Select the default title for the page that displays all articles" => "Select the default title for the page that displays all articles",
"Title" => "제목",
"Title length" => "제목 길이",
// "characters" => "characters",
"Publication date" => "게재 날짜",
"Visible" => "표시",
// "Author (owner)" => "Author (owner)",
// "Author name (as displayed)" => "Author name (as displayed)",
"Author rating" => "저자 등급",
// "Users rating" => "Users rating",
"Reads" => "열람수",
// "Is published" => "Is published",
"Trailer position" => "트레일러 위치",
"Between heading and body" => "제목과 본문 사이",
"Header text position" => "헤더 텍스트 위치",
"Requires a smaller image for list view" => "목록 보기에 대하여 더 작은 그림 필요",
"Next to image" => "다음 그림",
"Below image" => "그림 아래",
"Oldest first" => "가장 오랜 것이 처음",
"Points" => "점수",
"Number per page" => "페이지 당 기본 갯수",
"Set the number of comments per page" => "페이지 당 댓글의 수를 설정 (기본 = 10)",
"comments" => "댓글",
"Display order" => "기본 순서",
// "Set the display order of comments" => "Set the display order of comments",
"Paginate articles" => "기사에 페이지 매김",
"Divide articles into multiple pages with pagebreak markers" => "기사들 페이지브레이크 표식기로 여러 페이지로 분리",
// "Article creator remains article owner" => "Article creator remains article owner",
// "Last article editor does not automatically become author (owner)" => "Last article editor does not automatically become author (owner)",
"User ratings on articles" => "기사에 대한 사용자 등급",
"Allow users to rate articles." => "사용자로하여금 기사에 등급을 매기는 것을 허용",
// "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set" => "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set",
"Article rating options" => "기사 등급 선택사항",
"List of options available for the rating of articles" => "기사의 등급에 대하여 사용할 수 있는 선택사항의 목록",
"Default maximum width for custom article images" => "사용자 지정 기사 그림에 대한 기본 최대 넓이",
"Set the default maximum width of the article image" => "기사 그림에 대하여 최대 넓이를 설정함",
"pixels" => "픽셀",
// "\"0\" for no maximum" => "\"0\" for no maximum",
"Default maximum height for custom article images" => "사용자 지정 기사 그림에 대한 기본 최대 높이",
"Set the default maximum height of article images" => "기사 그림에 대하여 최대 높이를 설정함",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
"Sets the default maximum width of custom article images in list mode (on View Articles page)" => "목록 모드에서 사용자 지정 기사 그림 기본 최대 넓이를 설정 (기사 보기에서)",
// "\"0\" to default to the view mode maximum" => "\"0\" to default to the view mode maximum",
"Default maximum height of custom article images in list mode (on View Articles page)" => "목록 모드 내부의 사용자 지정 기사 그림에 대한 기본 최대 높이 (기사 보기에서)",
"Set the default maximum height of custom article images in list mode (on the View Articles page)" => "목록 모드에서 사용자 지정 기사 그림 기본 최대 높이를 설정 (기사 보기에서)",
// "Article image maximum file size" => "Article image maximum file size",
// "Maximum file size for an article image. Article images are stored in the database so it should remain low" => "Maximum file size for an article image. Article images are stored in the database so it should remain low",
// "kilobytes" => "kilobytes",
"Custom attributes for article types" => "기사 유형에 대한 사용자 지정 속성",
"Enable additional custom fields for article types" => "기사 종류에 대한 추가 사용자 지정 필드를 허용",
"Your ShareThis publisher identifier (optional)" => "귀하의 ShareThis 퍼블리셔 식별자 (선택사항)",
// "Set to define your ShareThis publisher identifier" => "Set to define your ShareThis publisher identifier",
"record your ShareThis publisher ID" => "귀하의 Sharethis 퍼블리셔 ID를 기록",
"Related articles" => "관련 기사",
"Display a list of related articles at the bottom of an article page" => "기사 페이지의 하단에 관련 기사의 목록 표시",
// "Use new articles" => "Use new articles",
// "Use the new CustomSearch-based article lists rather than database information" => "Use the new CustomSearch-based article lists rather than database information",
// "Article copyright" => "Article copyright",
// "Apply copyright management preferences to this feature" => "Apply copyright management preferences to this feature",
"Authentication method" => "인증수단",
"Tiki supports several authentication methods. The default method is to use the internal user database" => "티키는 여러 개의 인증 방식을 지원합니다. 기본값은 내부 사용자 데이터베이스르 사용하는 것입니다",
"Tiki" => "티키",
"Tiki and OpenID" => "티키와 OpenID",
"Tiki and PAM" => "티키와 PAM",
"Tiki and LDAP" => "티키와 LDAP",
"CAS (Central Authentication Service)" => "CAS (중앙 인증 서비스)",
// "SAML" => "SAML",
// "Shibboleth" => "Shibboleth",
"Web Server" => "웹서버",
// "phpBB" => "phpBB",
// "Token access" => "Token access",
"With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service" => "토큰 제시와 함가 상위 권한으로 컨텐츠로의 접근을 허용. 이 인증 방식의 주 사용예는 외부 서비스에게 컨텐츠로의 접근을 임시로 허용하는 것임",
// "Token access default timeout" => "Token access default timeout",
// "The default duration for which the generated tokens will be valid" => "The default duration for which the generated tokens will be valid",
// "Token access default maximum hits" => "Token access default maximum hits",
// "The default maximum number of times a token can be used before it expires" => "The default maximum number of times a token can be used before it expires",
"hits" => "방문수",
"Share access rights with friends when using Tell a friend" => "친구에게 알리기를 사용 시 친구와 접근 권한 공유",
"Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site." => "사용자로 하여금 이메일로 링크를 보냈을 때 현재 페이지의 접근 권한을 공유하는 것을 허용. 링크의 수명은 사이트에 의하여 정의됨.",
// "Do not delete temporary users when token is deleted/expired" => "Do not delete temporary users when token is deleted/expired",
// "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms" => "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms",
"Share access rights with friends when using Share" => "공유를 이용 시 친구와 접근권한을 공유",
"Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site." => "사용자가 이메일/트위터/페이스북으로 링크를 보낼 때 친구와 현재 페이지의 접근 권한을 공유하는 것을 허용. 링크의 수명은 사이트에 의하여 정의됨",
"Create user if not registered in Tiki" => "티키에 없다면 사용자 만들기",
"Automatically create a new Tiki user for the PHPbb login" => "PHPbb 로그인에 대한 새 티키 사용자 자동으로 만들기",
"Use Tiki authentication for Admin log-in" => "관리 로그인에 대한 티키 인증 사용",
// "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”" => "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”",
// "Disable Tiki users who don’t have a phpBB login as they could have been deleted" => "Disable Tiki users who don’t have a phpBB login as they could have been deleted",
"phpBB Version" => "phpBB 버전",
// "3" => "3",
"phpBB Database Hostname" => "phpBB 데이터베이스 호스트명",
"phpBB Database Username" => "phpBB 데이터베이스 사용자명",
"phpBB Database Password" => "phpBB 데이터베이스 비밀번호",
"phpBB Database Name" => "phpBB 데이터베이스명",
"phpBB Table Prefix" => "phpBB 테이블 접두어",
"Use Tiki authentication for users created in Tiki" => "티키 내에 만들어진 사용자들에 대하여 티키 인증 사용",
// "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP" => "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP",
"Host" => "호스트",
// "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL" => "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL",
"Port" => "포트",
// "The port number your LDAP server uses (389 is the default, 636 if you check SSL)" => "The port number your LDAP server uses (389 is the default, 636 if you check SSL)",
"Write LDAP debug Information in Tiki Logs" => "티키 기록에 LDAP 디버그 정보 쓰기",
// "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)" => "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)",
// "Do not enable this option for production sites" => "Do not enable this option for production sites",
"Use SSL (ldaps)" => "SSL (LDAPS) 사용",
"Use TLS" => "TLS 사용",
"LDAP Bind Type" => "LDAP 바인드 유형",
// "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>" => "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>",
"Default: Anonymous Bind" => "기본: 익명 Bind",
"Full: userattr=username,UserDN,BaseDN" => "전체: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
"Active Directory (username@domain)" => "액티브 디렉터리 (사용자명@도메인)",
"Plain Username" => "일반 사용자명",
"Search scope" => "검색 범위",
// "Used after authentication for getting user and group information" => "Used after authentication for getting user and group information",
"Subtree" => "하위트리",
"One level" => "한 단계",
"Base object" => "기준 개체",
"Base DN" => "기준 DN",
"User DN" => "사용자 DN",
"User attribute" => "사용자 속성",
"User OC" => "사용자 OC",
"Realname attribute" => "실명 특성",
// "Synchronize Tiki user attributes with the LDAP values" => "Synchronize Tiki user attributes with the LDAP values",
"Country attribute" => "국가 속성",
"Email attribute" => "이메일 특성",
"Group DN" => "그룹 DN",
"Group name attribute" => "그룹 이름 특성",
"Group description attribute" => "그룹 설명 특성",
"Group OC" => "그룹 OC",
"Member attribute" => "멤버 특성",
"Member is DN" => "멤버는 DN입니다",
"Group attribute" => "그룹 속성",
"Group attribute in group entry" => "그룹 입력에 그룹 속성",
"(Leave this empty if the group name is already given in the user attribute)" => "(그룹명이 이미 사용자 속성에 주어졌으면 이를 비어두십시오)",
"Admin user" => "사용자 관리",
"Admin password" => "비밀번호 관리",
"Use an external LDAP server for groups" => "그룹에 외부 LDAP 서버를 사용",
"Anonymous Bind" => "기본: 익명 Bind",
"Corresponding user attribute in 1st directory" => "첫번째 디렉터리에 해당 사용자 속성",
// "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database" => "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database",
// "Disable Tiki users with no phpBB login" => "Disable Tiki users with no phpBB login",
// "Default Bootstrap" => "Default Bootstrap",
"Available languages" => "제공 언어",
"By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset" => "기본으로 티키에서지원하는 모든 언어는 다국어 사이트에서 사용가능합니다. 이 선택사항은 부분집합으로써 언어를 제한하는 것을 허용합니다",
// "Available themes" => "Available themes",
"Restrict available themes" => "사용가능한 테마 제한",
// "BigBlueButton web conferencing" => "BigBlueButton web conferencing",
"Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "웹 컨퍼런싱과 화면 공유를 위하여 빅블루버튼 협업 서버와 통합",
"BigBlueButton server location" => "빅블루버튼 서버 위치",
"Full URL to the BigBlueButton installation" => "빅블루버튼 설치로의 전체 UIRL",
// "http://host.example.com/" => "http://host.example.com/",
"BigBlueButton server salt" => "빅블루버튼 서버 salt",
"A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic" => "빅블루버튼 서버가 요청이 인증된 것인지 알기 위하여 체크섬을 생성하기 위하여 사용한 솔트 키",
"BigBlueButton recording maximum duration" => "빅블루버튼 최대 녹음 길이",
"A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open" => "사용자가 창을 너무 오랫동안 열린 상태로 둘 경우 녹화가 과다하게 길어지는 것을 방지하기 위하여 회의에 대한 최대 기간을 빅블루버튼에 반드시 제공되해야만 합니다",
"minutes" => "분",
// "BigBlueButton dynamic configuration" => "BigBlueButton dynamic configuration",
// "Uses the advanced options of BigBlueButton to configure the XML per room" => "Uses the advanced options of BigBlueButton to configure the XML per room",
"Default ordering" => "기본 순서",
// "Default order" => "Default order",
"Creation Date (desc)" => "만든 일 (내림차순)",
"Last modification date (desc)" => "마지막 변경일 (내림차순)",
"Blog title (asc)" => "블로그 제목 (올림차순)",
"Number of posts (desc)" => "게시 수 (내림차순)",
"Visits (desc)" => "방문 수(내림차순)",
"Activity (desc)" => "활동 (내림차순)",
"Disabled" => "비활성화됨",
"Link to user information" => "사용자정보에 링크",
"User profile picture" => "사용자 아바타",
"Posts" => "게시 수",
"Visits" => "방문 수",
"Activity" => "활동",
// "Blog post copyright" => "Blog post copyright",
"Module (box) shadow start" => "모듈 (상자) 음영 시작",
"Module (box) shadow end" => "모듈 (상자) 음영 끝",
"Days to display in the calendar" => "달력에 표기될 날들",
"Default view mode" => "기본 보기 모드",
"Day" => "일",
"Week" => "주",
"Month" => "월",
"Quarter" => "분기",
"Semester" => "반기",
"Year" => "년",
"View list begins" => "보기 목록 시작",
"Focus date" => "중요 날짜",
"Period beginning" => "기간 시작",
"First day of the week" => "주의 첫 날",
"Depends user language" => "사용자 언어에 따름",
"Split hours in periods of" => "시간을 다음 단위로 분할",
"1" => "es",
// "5" => "5",
// "10" => "10",
// "15" => "15",
// "30" => "30",
// "Minute Interval" => "Minute Interval",
"First year in the dropdown" => "드랍다운의 첫 번째 연도",
"years" => "연도",
// "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled" => "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled",
"Last year in the dropdown" => "드랍다운의 마지막 년도",
"Enter a year or use +/- N to specify a year relative to the current year" => "연도를 기입하기나 +/- N 을 사용하여 현재 연도에 상대적 연도를 지정하십시오",
"Sticky popup" => "고정 팝업",
"Item view tab" => "항목 보기 탭",
"Show \"Add to Google Calendar\" icon" => "구글 캘린더에 추가 아이콘 표기",
"Show \"Export Calendars\" button" => "달력 내보내기 버튼 표시",
// "Show \"Export Calendar Item\" Button" => "Show \"Export Calendar Item\" Button",
// "Allow exporting a single calendar event as an iCal file" => "Allow exporting a single calendar event as an iCal file",
"Use FullCalendar to display calendars" => "FullCalendar 을 사용하여 달력을 표기",
"Treat calendar item descriptions as HTML" => "달력 항목 설명을 HTML 로 취급",
"Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0." => "달력에 대하여 WYSIWYG 편집기를 사용한다면 이 옵션을 사용하십시오. 7.0 이전 버전의 티키로부터의 과거형 데이터를 처리하기 위함입니다.",
"Enable watch events when you are the editor" => "자신이 편집자일 경우 이벤트 주시하는 것을 활성화",
"Check this to receive email notifications of events you changed yourself" => "체크해지된 경우, 자식이 직접 변경한 이벤트에 대하여 이메일 알림을 수신하지 않을 것입니다",
"CAPTCHA image word length" => "CAPTCHA 그림의 단어 길이",
"Number of characters the CAPTCHA will display" => "CAPTCHA 그림의 단어 길이",
// "CAPTCHA image width" => "CAPTCHA image width",
"Width of the CAPTCHA image in pixels" => "CAPTCHA 그림의 픽셀단위 넓이",
// "CAPTCHA image noise" => "CAPTCHA image noise",
"Level of noise of the CAPTCHA image" => "스팸 방지 문자 입력 그림의 노이즈 단계",
"Choose a smaller number for less noise and easier reading" => "잡음이 적고 보다 수월한 읽기를 위해서 더 작은 숫자를 선택하십시오",
// "CAPTCHA questions" => "CAPTCHA questions",
// "Requires anonymous visitors to enter the answer to a question" => "Requires anonymous visitors to enter the answer to a question",
// "CAPTCHA questions and answers" => "CAPTCHA questions and answers",
// "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line" => "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line",
// "One question per line with a colon separating the question and answer" => "One question per line with a colon separating the question and answer",
"Try automatically to connect SSO" => "자동으로 SSO에 연결을 시도",
"Force CAS log-out when the user logs out from Tiki" => "티키에서 사용자가 로그아웃 시, CAS 로그아웃을 강제 적용",
"Show alternate log-in method in header" => "헤더 내부에 대체 로그인 방식 표시",
"CAS server version" => "CAS 서버 버전",
"none" => "없음",
"Version 1.0" => "1.0 버전",
"Version 2.0" => "2.0 버전",
"Hostname" => "호스트명",
"Hostname of the CAS server" => "CAS 서버의 호스트명",
"Port of the CAS server" => "CAS 서버의 포트",
"Path for the CAS server" => "CAS 서버에 대한 경로",
"CAS Extra Parameter" => "CAS 추가 매개 변수",
"Extra Parameter to pass to the CAS Server" => "CAS 서버에 전달할 추가 매개 변수",
"CAS Authentication Verification Timeout" => "CAS 인증 확인 시간초과",
"Verify authentication with the CAS server every N seconds. Null value means never reverify" => "CAS 서버로 매 N 초마다 인증을 확인. 빈 값은 절대 재확인하지 않음을 의미",
"minute" => "분",
"hour" => "시",
// "Provides the current categories to Smarty templates" => "Provides the current categories to Smarty templates",
// "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance" => "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance",
// "Categories to add as CSS classes to <body>" => "Categories to add as CSS classes to <body>",
// "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag" => "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag",
// "Clear cache upon category change" => "Clear cache upon category change",
// "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date" => "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date",
// "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts" => "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts",
"Category jail" => "범주 감옥",
"Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "개체의 표시를 이러한 범주 ID들의 개체로 제한함. 퍼스펙티브에서 작업공간을 만드는데 주로 사용됨",
"This should only be set for perspectives, and not globally" => "이는  전역에 대하여서는 아니고 퍼스펙티브에 대하여서만 설정되어야 합니다",
"Category jail root" => "범주 감옥 루트",
"Always display categories outside of the jail root, which would be for normal categorization" => "일반적 범주화에 대한 것이 될 jail root 의 외부의 범주를 항상 표시",
"Category defaults" => "범주 상세내역",
"Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default" => "특정 범주들이 존재하도록 강제 적용. 주어진 세트내에 범주들이 제공되지 않는다면, 기본으로 한 개의 범주 할당",
"Use *7 to specify all the categories in the subtree of 7 + category 7" => "7 의 하위트리의 모든 범주들과 범주 7 을 지정하기 위하여 *7 을 사용",
"Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "정규식에 일치하는 개체명에 대하여서만 실행 가능 (예제: /^RND_/ = RND_ 로 시작하는 이름)(선택사항)",
"Can do for wiki only (optional)." => "위키에만 할 수 있음 (선택사항).",
"Rename will only reassign the categories for wiki pages" => "이름변경은 위키 페이지에 대한 범주를 재할당만 함",
"One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page" => "한 줄 당 하나. 예:1,4,6,*7/4:/^RND_/:wiki page",
"Synchronize multilingual categories" => "다국어 범주 동기화",
"Make sure that the categories of the translations are synchronized when modified on any version" => "번역의 범주가 어떤 버전에서든지 수정될 때 동기화되는 지 확인하십시오",
"Only those specified" => "지정된 것들만",
"All but those specified" => "지정된 것 외의 모든",
"Synchronized categories" => "동기화된 범주",
"List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)" => "다국어 동기화에 의하여 영향받는 범주의 목록. 부모 기능에 따라. 이 목록은 우량 목록 (허용되는 범주들만) 혹은 불량 목록으로 (지정된 것을 제외한 모든 것) 사용될 수 있음.",
// "Sort categories case insensitively" => "Sort categories case insensitively",
// "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings" => "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings",
// "Automatically geocode items with this category" => "Automatically geocode items with this category",
"Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "이 범주 ID의 하위범주들 내부에 범주화 되었을 때 범주명에 기반하여 항목들을 자동으로 지오코드(geocode) 함",
// "Replace any existing geocode" => "Replace any existing geocode",
"When automatically geocoding items based on category name, replace existing geocode, if any" => "범주명에 기반하여 항목을 자동으로 지리정보코드화 할 때, 기존(가 있다면) 지리코드를 교체",
"Use approximate geocode location" => "대략적인 geocode 위치를 사용",
"When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "범주명에 기반하여 항목을 자동으로 지리정보코드화 할 때, 정확한 위치 대신 랜덤하게 근사 위치를 사용",
"\"More Like This\" algorithm for categories" => "범주에 대한 \"이것과 유사함\" 알고리듬",
"Weighted" => "가중됨",
"Minimum number of categories in common" => "공용인 범주의 최소 수",
// "categories" => "categories",
"2" => "no existe",
// "4" => "4",
// "6" => "6",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "List objects with most categories in common" => "List objects with most categories in common",
// "No minimum is applied" => "No minimum is applied",
// "Maximum number of \"more like this\" objects" => "Maximum number of \"more like this\" objects",
// "The default maximum records setting for the site is used of this is set to 0" => "The default maximum records setting for the site is used of this is set to 0",
// "objects" => "objects",
// "Generate custom facets from categories" => "Generate custom facets from categories",
// "Comma-separated list of category IDs" => "Comma-separated list of category IDs",
// "Show category object count" => "Show category object count",
// "Show object count when browsing categories, complying with search and type filters" => "Show object count when browsing categories, complying with search and type filters",
// "Can slow the loading of the categories page on large sites" => "Can slow the loading of the categories page on large sites",
"Exclude these category IDs" => "다음 범주 ID들을 제외",
"Category path won't appear for these category IDs" => "범주 경로는 다음 범주 ID들에 대하여 나타나지 않음",
"Category path format" => "범주 경로 서식",
"Alter how the category path will be rendered" => "범주 경로가 어떻게 렌더될 것인지를 변경",
"Links to the category when the category is visible" => "범주가 보이면 범주에 연결",
"Text label when the category is visible" => "범주가 보일 때 텍스트 레이블",
"Link when visible, text label otherwise" => "보일 때 연결, 그 외 경우 텍스트 레이블",
"Always display the category path labels" => "범주 경로 라벨을 항상 표시",
"Center shadow start" => "그림자 시작 가운데 정렬",
"Center shadow end" => "그림자 모서리 가운데 정렬",
// "Users can choose the language of their interface" => "Users can choose the language of their interface",
"Allow users to change the language of the menus and labels" => "사용자가 메뉴와 레이블의 언어 변경 허용",
"Users can change theme" => "사용자가 테마를 바꿀 수 있습니다",
// "Users can override the theme with this setting" => "Users can override the theme with this setting",
"Users can change their password" => "사용자가 직접 비밀번호를 변경 가능",
// "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin" => "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin",
"Disable comment titles" => "댓글에 대한 제목 사용 안 함",
"Don't display the title input field on comments and their replies." => "댓글과 응답의 제목 필드를 감춤",
"Email field" => "이메일 필드",
"Email field for comments (only for anonymous users)." => "댓글의 이메일 필드 (anonymous 사용자에게만 적용).",
"Website field" => "웹사이트 필드",
"Website field for comments (only for anonymous users)." => "댓글에 대한 웹사이트 필드 (anonymous 사용자에게만 적용).",
"Use vote system for comments" => "댓글에 대하여 투표 시스템 사용",
// "Allow users with permission to vote on comments" => "Allow users with permission to vote on comments",
// "Permissions involved: %0" => "Permissions involved: %0",
"Archive comments" => "댓글 보관",
"If a comment is archived, only admins can see it" => "댓글이 보관되면, 관리자만이 볼 수 있음",
"Use Akismet to filter comments" => "Akismet 을 사용하여 댓글 필터",
"Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam." => "Akismet 서비스를 사용하여 댓글이 스팸인지 결정하여 댓글 스팸을 방지함. 댓글 중재가 활성화 되어있다면 Akismet 은 댓글이 중재되어야하는 지 여부를 나타낼 것임. 댓글 중재가 없다면, 댓글이 스팸이로 여겨지면, 거절될 것임.",
"Akismet API Key" => "Akismet API 키",
"Key required for the Akismet comment spam prevention" => "Askimet 댓글 스팸 방지가 작동하기 위해 필요한 키",
"Obtain this key by registering your site at [%0]" => "귀하의 사이트를[%0]상에서 등록을 하여 이 키를 얻습니다",
"Filter spam for registered users" => "등록된 사용자에 대해 스팸 필터",
"Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening" => "등록된 사용자에 대하여서도 스팸 필터링을 활성화. 사이트에서 누구에게나 별도의 승인 절차 없이 가입을 허용할 경우 유용함",
"Allow comments to be edited by their author" => "댓글이 저자에 의하여 수정되는 것을 허용",
"Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc" => "댓글이 게시된 후 짧은 시간 내에 저자에 의해 수정되는 것을 허용, 30 분간 깨진 링크 혹은 오타 수정을 허용",
// "Inline comments using Apache Annotator" => "Inline comments using Apache Annotator",
// "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations" => "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations",
// "Anchor links on headings" => "Anchor links on headings",
// "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page" => "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page",
"Number of comments per page" => "페이지당 몇 개의 댓글",
// "Sort mode for comments" => "Sort mode for comments",
// "Automatically present a terms of use page to be accepted by users accessing the site" => "Automatically present a terms of use page to be accepted by users accessing the site",
// "Terms of Use page name" => "Terms of Use page name",
// "Wiki page for Terms of Use content. The page may be translated using the multilingual feature" => "Wiki page for Terms of Use content. The page may be translated using the multilingual feature",
// "Minimum age" => "Minimum age",
// "When presenting the terms of use, request age" => "When presenting the terms of use, request age",
// "0 to ignore age validation" => "0 to ignore age validation",
// "Tiki connect" => "Tiki connect",
"Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "익명화된 통계 데이터를 tiki.org 로 전송하여 귀하의 티키를 커뮤니티에 연결하십시오",
"This feature is still under development" => "실험적. 이 기능은 아직 개발 중입니다.",
// "Send site information" => "Send site information",
"Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you" => "주변의 티키와 연결을 할 수 있도록 추가적으로 키워드, 위치, 등등을 tiki.org 로 전송",
"Site title" => "사이트 제목",
"Name of site to be listed on Tiki Connect" => "티키 커넥트 상의 사이트 이름",
// "Site title is required to send site information" => "Site title is required to send site information",
"Email contact" => "이메일 연락처",
"Email to register" => "등록할 이메일",
"URL to register" => "등록할 URL",
"Key words" => "키워드",
"Key words or tags describing your site" => "사이트를 설명하는 키워드 혹은 태그",
"Site location" => "사이트 위치",
"Site location expressed as longitude, latitude, and zoom" => "경도, 위도, 확대/축소로서의 사이트 위치",
"Send anonymous information" => "익명사용자 정보 보내기",
"Send anonymous usage information" => "익명 사용 현황 정보 전송",
"Connection frequency" => "연결 빈도",
// "How often to send information" => "How often to send information",
"hours" => "시간",
// "Click \"Send Info\" to connect" => "Click \"Send Info\" to connect",
"Currently not in use" => "실험적. 현재 사용되지 않음. 연결하려면 \"정보 전송\"을 클릭하십시오",
// "Tiki connect server URL" => "Tiki connect server URL",
"Where to send the information" => "정보를 보낼 곳",
"Last connection" => "마지막 연결",
"Connect server mode" => "연결 서버 모드",
"For use by mother.tiki.org" => "mother.tiki.org 에서 사용 목적",
"Connect GUID" => "연결 GUID",
"For use by mother.tiki.org. Do not modify" => "mother.tiki.org 에서 사용 목적임. 수정하지 마십시오",
"Allow anonymous visitors to use the \"Contact Us\" feature" => "익명 방문자에게 \"문의하기\" 기능 사용 허용",
"Display contact priority" => "연락처 우선순위도 표시",
"Display contact priority option" => "연락처 우선순위도 선택사항 표시",
"Contact user" => "사용자에게 연락",
"User to contact" => "연락처로 사용자",
"Cookie name" => "쿠키 명",
"Domain" => "도메인",
// "The domain that the cookie is available to" => "The domain that the cookie is available to",
// "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically" => "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically",
"Ask permission of the user before setting any cookies, and comply with the response" => "그 어떤 쿠키도 설정하기 전에 사용자에게 권한을 문의하고 사용자들의 결정을 따름",
"Complies with EU Privacy and Electronic Communications Regulations" => "유럽연합 개인정보 및 전자 통신 규격을 준수",
"Cookie consent name" => "쿠키 사용동의 이름",
"Name of the cookie to record the user's consent if the user agrees" => "동의할 경우, 동의내용을 기록할 쿠키명",
"Cookie consent expiration" => "쿠키 사용동의 만기",
"Expiration date of the cookie to record consent (in days)" => "동의를 기록할 쿠키에 대한 만기 날자 (일 단위)",
"days" => "일",
"Cookie consent text" => "쿠키 사용동의 텍스트",
"Description for the dialog" => "대화상자에 대한 설명",
"Wiki-parsed" => "위키 구문분석 됨",
"This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))" => "이 사이트는 귀하의 컴퓨터에 쿠키를 놓아서 저희가 이를 개선하는데 도움을 얻고자 합니다. 쿠키에 대하여 더 알고싶으시면, 저희의 ((privacy notice|개인정보 알림))을 살펴보십시오",
"Cookie consent question" => "쿠키 사용동의 질문",
// "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox" => "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox",
"I accept cookies from this site" => "이 사이트로부터의 쿠키를 받아들입니다",
"Cookie consent button" => "쿠기 사용동의 버튼",
"Label on the agreement button" => "동의 버튼의 레이블",
"Continue" => "계속",
"Cookie consent alert" => "쿠키 사용동의 경고",
// "Alert displayed when user tries to access or use a feature requiring cookies" => "Alert displayed when user tries to access or use a feature requiring cookies",
"Sorry, cookie consent required" => "죄송합니다, 쿠키 동의가 요구됩니다",
"Cookie consent mode" => "쿠키 사용동의 모드",
"Appearance of consent dialog" => "동의 대화상자의 외형",
"Dialog style requires feature_jquery_ui" => "대화 스타일은 feature_jquery_ui 를 필요로함",
"Plain" => "일반",
"Banner" => "배너",
"Dialog" => "대화",
"Cookie consent dialog ID" => "쿠키 사용동의 대화상자 Id",
"DOM id for the dialog container div" => "대화 컨테이너 div에 대한 DOM id",
// "Cookie consent disabled" => "Cookie consent disabled",
// "Do not give the option to refuse cookies but still inform the user about cookie usage" => "Do not give the option to refuse cookies but still inform the user about cookie usage",
// "Refresh the remember-me cookie expiration" => "Refresh the remember-me cookie expiration",
// "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated" => "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated",
// "Name of the cookie to remember the user's login" => "Name of the cookie to remember the user's login",
"Count admin pageviews" => "페이지열람 세기 관리자",
"Include pageviews by Admin when reporting stats" => "통계를 보고할 때 관리에 의한 페이지보기 포함",
"Enable daily reports for new users" => "새 사용자 용 일일보고 활성화",
"Determines if daily reports will be automatically enabled for new users" => "일일보고서가 새 사용자들에 대하여 자동으로 활성화될 것인지를 결정함. 기본값은 \"아니오\"",
"Default character set for sending mail" => "메일 전송에 대한 기본 charset",
"Specify the character encoding used by Tiki when sending mail notifications" => "메일 전송에 대한 기본 charset",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
"default mapfile" => "기본 지도파일",
"Default diff style" => "기본 diff 스타일",
"Only with last version" => "마지막 버전으로만",
// "HTML diff" => "HTML diff",
"Side-by-side diff" => "나란히 diff",
"Side-by-side diff by characters" => "문자단위의 나란히 diff",
"Inline diff" => "인라인 diff",
"Inline diff by characters" => "문자별 인라인 diff",
"Full side-by-side diff" => "전체 side-by-side diff",
"Full side-by-side diff by characters" => "글자별 전전체 side-by-side diff",
"Full inline diff" => "전체 인라인 diff",
"Full inline diff by characters" => "문자별 전체 인라인 diff",
"Unified diff" => "통합된 diff",
"Side-by-side view" => "나란히 보기",
"rows" => "행",
// "Comment box" => "Comment box",
// "Size (height) of the comment text area" => "Size (height) of the comment text area",
"Forum reply" => "게시판 답글",
// "Select default calendars to display" => "Select default calendars to display",
// "Group transition sets default" => "Group transition sets default",
// "Sets the group transitioned to as the user's default group" => "Sets the group transitioned to as the user's default group",
// "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites" => "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites",
"Disable browser's autocomplete feature for username and password fields" => "사용자명과 비밀번호 필드에 대하여 브라우저의 자동완성 기능을 사용 안함",
"Use direct pagination links" => "직접 페이지 매김 링크 사용",
"Maximum number of links around the current item" => "현재 항목 주위의 링크들의 최대 숫자",
// "links" => "links",
"Maximum number of links after the first or before the last item" => "첫 번째 이후 혹은 최종 항목 직전의 링크들의 최대 숫자",
"Show country flag" => "국가 플래그 보임",
"Show the country flag" => "국기 표시",
"Enable \"popular sites\"" => "쿨사이트 활성화",
"Validate URLs" => "URL 확인",
// "Should Tiki check the URL" => "Should Tiki check the URL",
// "Columns per page" => "Columns per page",
"Number of columns per page when listing directory categories" => "디렉터리 범주 나열 시, 페이지 당 행의 숫자",
// "columns" => "columns",
"Links per page" => "페이지 당 링크",
// "How many links should be displayed per page" => "How many links should be displayed per page",
"Method to open Directory links" => "오픈 디렉터리 링크로 메써드",
"The linked-to website can be opened in various ways" => "디렉토리 링크 여는 방법",
"Replace the current window" => "현재창을 교체",
"Open a new window" => "새 윈도우",
"Open an iframe" => "인라인 프레임",
"Fields display order" => "필드가 주문을 표시합니다",
// "The order date field inputs should be listed in" => "The order date field inputs should be listed in",
// "Year to show first in dropdown lists" => "Year to show first in dropdown lists",
// "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year" => "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year",
// "year(s)" => "year(s)",
// "Year to show last on dropdown lists" => "Year to show last on dropdown lists",
// "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year" => "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year",
"Re-validate user email after" => "이메일로 사용자 재확인 조건",
"The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid" => "사용자의 이메일을 재 유효화하기 전에 대기할 날의 수",
"Use \"-1\" for never" => "사용하지 않을 경우\"-1\"",
"Email footer" => "이메일 꼬리말",
"Text appended to outgoing emails" => "외부로 나가는 이메일에 텍스트 추가됨",
"PHP errors visible to admin only" => "관리자에게만 표시되는 PHP 오류들",
"During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators" => "개발 목적으로는 모든 사용자에 대하여 오류를 표시하는 편이 좋습니다. 하지만, 업무 환경에서는, 관리자에게만 표시되어야 합니다",
// "PHP Errors will be shown to only the Admin user" => "PHP Errors will be shown to only the Admin user",
"PHP Error reporting level" => "PHP 오류 보고 단계",
"Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist" => "어떠한 오류가 보고되어야 하는가에 대한 단계",
"No error reporting" => "오류 보고 없음",
"Report all PHP errors except strict" => "엄격을 제외한 모든 PHP 오류 보고",
"Report all PHP errors" => "모든 PHP 오류 보고",
"Report all PHP errors except notices" => "알림을 제외한 모든 PHP 오류 보고",
"According to the PHP configuration" => "PHP 설정을 따름",
"Default number of comments per page" => "페이지당 코멘트 기본지정 갯수",
// "Maximum number of comments to display on each page. Users may override this number" => "Maximum number of comments to display on each page. Users may override this number",
"Default order of comments" => "코멘트 기본지정 순서",
"In which order to list the comments on the page." => "트래커 목록 페이지 내부에 나열된 모든 필드 상의 인라인 편집 사용",
// "Prefix for answers" => "Prefix for answers",
// "The prefix for that Tiki should display for each FAQ answer" => "The prefix for that Tiki should display for each FAQ answer",
"Q and A" => "질문과 답",
"Question ID" => "질문 ID",
// "FAQ copyright" => "FAQ copyright",
// "Limit blog categories to those under this category" => "Limit blog categories to those under this category",
"If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "블로그 게시물을 편집할 때 필수 범주가 요구된다는 오류 메시지를 받는 경우, 이 선택사항이 문제인 것이빈다. 이를 없음으로 설정하십시오",
"Areas" => "영역",
"Binding categories and perspectives to each other" => "범주와 전망을 서로에 묶음",
// "Pages and collaboratively authored documents with edit history" => "Pages and collaboratively authored documents with edit history",
"Online diaries or journals." => "온라인 일기 혹은 저널.",
"Enable directory batch loading" => "디렉터리 일괄처리 로딩 활성화",
// "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols" => "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols",
"You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory" => "디렉터리 일관 로딩을 활성화한 경우, 웹에서 읽기 가능한 디렉터리를 설정해야 합니다 (귀하의 웹 공간의 외부가 더 좋습니다). 그리고 해당 디렉터리에 scp, ftp 혹은 다른 프로토콜로 그림을 업로드할 방법을 설정합니다",
"Rankings" => "순위",
// "Users can see several charts or rankings about the file" => "Users can see several charts or rankings about the file",
// "Image gallery" => "Image gallery",
"Collections of images for viewing or downloading (photo albums)" => "보기 및 다운로드를 할 수 있는 그래픽 이미지의 모음 (포토 앨범)",
"File galleries can be used instead." => "파일 갤러리를 대신 사용할 수 있음",
// "Image Gallery Comments" => "Image Gallery Comments",
// "Users with permission may post threaded comments. The comments will appear at the bottom of the page" => "Users with permission may post threaded comments. The comments will appear at the bottom of the page",
// "Limit image gallery categories to those under this category" => "Limit image gallery categories to those under this category",
// "Machine translation" => "Machine translation",
"Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service" => "이 사이트의 컨텐츠를 다른 언어로 번역하기 위하여 기계 번역을 사용. 이 기능은 무료가 아닐 수 있는 외부 서비스에 의존한다는 점에 유의. 구글 번역은 유료 서비스입니다",
"Database and form generator" => "데이터베이스 및 서식 생성기",
"Threaded or flat discussions." => "다양한 토픽을 다룬 온라인 토론. 쓰레드 혹은 일반방식으로 나열됨.",
// "File gallery" => "File gallery",
"Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability" => "다운로드 용도의 컴퓨터 파일, 동영상 혹은 소프트웨어. 체크인 및 체크아웃 (잠금) 기능.",
"Save files as drafts" => "파일을 초안으로 저장",
// "Allow saving of files as drafts" => "Allow saving of files as drafts",
"File gallery configuration templates" => "파일 갤러리 설정 템플릿",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "설문",
"Presentation of a set of votable options, typically displayed in a module" => "투표가능 선택사항의 짧은 목록; 모듈에 나타남 (좌측 혹은 우측 컬럼)",
"Newsletters" => "회보",
"Content mailed to registered users or other subscribers." => "컨텐츠가 등록된 사용자들에게 메일로 전송됨.",
"Calendar" => "달력",
"Events calendar with public, private and group channels." => "공용, 개인, 및 그룹 채널의 이벤트 달력.",
"Banners" => "배너",
"Insert, track, and manage advertising banners." => "광고 배너를 삽입, 추적 및 관리",
// "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access" => "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access",
// "Unified user details " => "Unified user details ",
// "Use User Details Page using the Unified Index" => "Use User Details Page using the Unified Index",
"Score" => "점수",
"Score is a game to motivate participants to increase their contribution by comparing to other users." => "점수는 참여자들로 하여금 타 사용자들과 비교함으로써 자신들의 기여도를 상승시키는 것에 대한 동기부여를 하기 위한 게임입니다.",
// "Score expiry" => "Score expiry",
// "Unified search index" => "Unified search index",
// "Enables searching for content at the site using a Tiki-managed index" => "Enables searching for content at the site using a Tiki-managed index",
"Enables tags to be set on pages and other items for freeform categorization." => "웹사이트 내부의 페이지와 다양한 개체에 태그를 설정 및 태크 클라우드 탐색 패턴을 허용",
// "Action log" => "Action log",
"Provides the ability to track the actions of users and produce reports on a per-user or per-category basis." => "사용자가 하는 일을 추적 및 사용자 당 혹은 범주 방에 기반하여 보고서를 제작하는 것을 허용",
"Contribution" => "기여도",
"Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports." => "사용자들로 하여금 개체를 편집하는 동안 제공하는 기여의 종류를 지정할 수 있도록 함. 기여는 색상별로 기록 및 기타 보고서에서 색상으로 구분되어 표기됨",
"Multilingual" => "다국어",
"Enables internationalization features and multilingual support at the site" => "사이트 전체에 대하여 국제화 기능 및 다국어 지원 활성화",
"Frequently asked questions and answers" => "자주 묻는 질문과 응답",
"There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs" => "위키 페이지를 대신 사용할 수 있습니다",
"Surveys" => "설문",
"Create questionnaires with multiple-choice or open-ended questions" => "다항선택 혹은 개방형 질문의 설문",
"User-submitted Web links" => "사용자가 제출한 웹 링크들",
// "Sets of questions that can be presented, with the sessions timed and the scores recorded" => "Sets of questions that can be presented, with the sessions timed and the scores recorded",
// "Featured links" => "Featured links",
"A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc." => "iframe 내부에 외부 웹페이지를 선택적으로 추가할 수 있는 단순 메뉴 시스템",
"Copyright" => "저작권",
"Use the Copyright Management System (or ©MS) to display the license of your content" => "저작권 관리 시스템 (or ©MS) 은 컨텐츠를 보호하는 한 방법입니다",
"Wiki references" => "위키 참조",
"Permits using references and the reference library" => "참조와 참조 라이브러리의 사용을 허용",
// "Library references" => "Library references",
// "Enforce library reference as master" => "Enforce library reference as master",
// "Reference style" => "Reference style",
// "Default style when using references" => "Default style when using references",
// "AMA citation style (default)" => "AMA citation style (default)",
// "MLA citation style" => "MLA citation style",
// "Display reference in a popover" => "Display reference in a popover",
// "Display the details of the reference in a popover" => "Display the details of the reference in a popover",
"Shoutbox" => "외침상자",
"Quick comment (graffiti) box. Like a group chat, but not in real time." => "빠른 댓글 (낙서) 상자. 그룹 채팅과 유사하지만, 실시간이 아님",
"Live support system" => "실시간 지원 시스템",
"One-on-one chatting with customer" => "고객과 1대1 채팅",
// "Tell a friend" => "Tell a friend",
"Add to each page an \"Email this page\" link" => "\"이 페이지를 이메일로 보내기\" 링크를 모든 페이지에 추가",
"Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums" => "모든 페이지에 \"공유\" 버튼을 추가하여 이메일, 트위터, 페이스북, 메시지 혹은 게시판으로 전송하도록 함.",
"Be careful when allowing anonymous users to activate the antibot feature." => "anonymous 에게 허용 시 antibot 기능을 활성화하는 것에 대하여 주의해야 함.",
"HTML pages" => "HTML 페이지",
"Static and dynamic HTML content" => "정적 및 동적 HTML 컨텐츠",
"HTML can be used in wiki pages. This is a separate feature" => "HTML 이 위키 페이지 내에서 사용될 수 있습니다. 이는 별도의 기능입니다",
// "Contact us" => "Contact us",
"A basic contact form a visitor can use to contact the site admin" => "방문객에게서 관리에게로의 기본 형식",
"Minichat" => "미니채팅",
"Real-time group text chatting enabled through a module" => "실시간 그룹 텍스트 채팅",
// "Comments moderation" => "Comments moderation",
"Enables the admin or other authorized group member to validate comments before they are visible" => "댓글이 표시되기 전에 관리자가 반드시 승인해야만 함",
// "Add author name in From email header" => "Add author name in From email header",
// "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"" => "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"",
// "Comments locking" => "Comments locking",
"Comments can be closed (no comments, or no new comments)" => "댓글기능이 닫힐 수 있음 (새 댓글 없음)",
// "Allow logged-in users to post comments anonymously" => "Allow logged-in users to post comments anonymously",
"This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement" => "이는 무기명으로 의견을 말할 기회를 부여하여 참된 피드백을 격려하기 위하여 사용될 수 있습니다. 예를 들면, 내부적으로 무엇이 잘 못되고 있으며 어떤 것이 향상되어야하는 지에 관한 피드백을 요청하는 게시판과 같은 경우",
// "Show the page description" => "Show the page description",
"Display the wiki page description between the page title and the page content" => "페이지 볼 때 제목 아래에 페이지 설명 표시",
"Display page name as page title" => "페이지 명을 페이지 제목으로 표기",
"Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title." => "각 페이지의 상단에 페이지 명을 페이지 제목으로 표기함. 활성화 되지 않으면, 페이지 내용이 헤더를 포함하도록 구조가 이루어져야 함.",
// "Show the page ID" => "Show the page ID",
"Each wiki page has a numeric ID and this can be displayed" => "페이지를 볼 때 내부 페이지 ID 표시",
"Individual wiki cache" => "개별적 위키 캐시",
"Allow users to change the duration of the cache on a per-page basis." => "사용자에게 페이지 당 기반으로 캐시의 기간을 변경하는 것을 허용.",
// "Date picker for date selection" => "Date picker for date selection",
// "JavaScript popup date selector (uses jQuery UI DatePicker)" => "JavaScript popup date selector (uses jQuery UI DatePicker)",
// "Output should be HTML purified" => "Output should be HTML purified",
"This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results" => "이는 XSS와 같은 잠재적 잔여 보안 문제들을 필터하기 위하여 출력상에서 HTML Purifier 를 활성화합니다",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
"Full screen" => "전체 화면",
"Allow users to activate full-screen mode." => "사용자의 전체화면 모드 활성화를 허용",
// "CSS menus" => "CSS menus",
"Use CSS-styled (Suckerfish) vertical and horizontal menus" => "CSS 메뉴 (서커피시)",
"Shadowbox / ColorBox" => "음영상자 / 색상상자",
// "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)" => "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)",
// "Quick permission assignment" => "Quick permission assignment",
"Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object" => "빠른권한은 권한의 클래스를 정의하고 이를 개체상의 역할로 부여하도록 합니다",
// "User encryption" => "User encryption",
// "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored" => "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored",
// "Enable personal, secure storage of sensitive data such as passwords" => "Enable personal, secure storage of sensitive data such as passwords",
// "This is an experimental feature. Using it may cause loss of the encrypted data" => "This is an experimental feature. Using it may cause loss of the encrypted data",
// "Password domains" => "Password domains",
// "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself" => "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself",
// "HTML purifier" => "HTML purifier",
"If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results." => "페이지에 HTML 의 사용을 시도하였으나, 자동 제거가 된다면, HTML 이 유효한 지 확인하거나 이 기능을 비활성화 해야 합니다.",
"Ajax" => "AJAX",
// "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work" => "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work",
// "This feature is required for the interface for many features to work properly" => "This feature is required for the interface for many features to work properly",
"Webmail" => "웹메일",
"Intertiki" => "인터티키",
"Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "여러 개의 티키 사이트들 (슬레이브) 로 하여금 마스터 티키 사이트에서 인증을 받도록 함",
// "Mail-in" => "Mail-in",
"Create and publish wiki pages and articles via email" => "이메일로 위키 페이지 및 기사를 채우기",
"Mindmap" => "마인드맵",
// "Display in a graphical way the connection among wiki pages" => "Display in a graphical way the connection among wiki pages",
"Print indexed" => "인덱싱 인쇄",
"Generate a printable version of the whole wiki or a subset of pages, filtered by category" => "인덱싱 인쇄",
"Spreadsheet" => "스프레드시트",
"Spreadsheets with calculations and charts" => "계산 및 차트가 있는 데이터시트",
// "Slideshow (reveal.js)" => "Slideshow (reveal.js)",
"Create simple presentations via Wiki Syntax" => "웹 기반 슬라이드쇼",
// "Slideshow (reveal.js) PDF export" => "Slideshow (reveal.js) PDF export",
"Wiki-page-based slideshow to pdf export" => "웹 기반 슬라이드쇼를 pdf 로 내보내기",
"Invoice" => "청구서",
"Invoice system" => "청구 시스템",
// "Full WYSIWYG editor" => "Full WYSIWYG editor",
"WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience" => "WYSIWYG 는 보여지는 대로 출력이란 영문구의 축약어입니다. CKEditor 를 사용합니다.",
// "Kaltura video management" => "Kaltura video management",
"Integration with the Kaltura video management platform" => "Kaltura 동영상 관리 플랫폼과 통합",
// "Friendship network" => "Friendship network",
"Users can identify other users as their friends" => "사용자는 다른 사용자를 친구로써 구별할 수 있습니다",
"Banning system" => "차단 시스템",
"Deny access to specific users based on username, IP, and date/time range." => "사용자명, IP, 및 날짜/시간 범위에 기반하여 특정 사용자의 접근을 거부.",
"Stats" => "통계",
"Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "주요 티키 기능에 관한 기본 통계를 기록 (위키 페이지의 수, 파일 갤러리의 크기, 등등)",
// "Action calendar" => "Action calendar",
"Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "시스템 이벤트의 달력 표기 (예: 위키 페이지 수정, 게시판 게시물 및 기사 게제). 이벤트와 함께 날짜가 작업 달력 페이지로의 링크가 보임.",
"Referrer stats" => "Referer 통계",
"Record domain name of sites that send visitors to this Tiki" => "이 티키로 방문자를 보내는 사이트의 도메인명을 기록",
"Redirect on error" => "오류 시 리디렉션",
"On an error, refresh to the homepage as specified on the Admin General page" => "오류 시, 관리->일반에 구성되어있는 대로 홈페이지로 갑니다",
"Communications (send/receive objects)" => "통신 (개체 송/수신)",
"Send/receive wiki pages and articles between Tiki-powered sites" => "티키로 작동되는 사이트 간의 위키 페이지와 기사를 송/수신",
"Display \"My Account\" in the application menu" => "응용프로그램 메뉴에 '마이티키' 표시",
// "Mini calendar" => "Mini calendar",
// "Displays a personal calendar for each user" => "Displays a personal calendar for each user",
// "User preferences screen" => "User preferences screen",
// "User notepad" => "User notepad",
// "My bookmarks" => "My bookmarks",
// "User contacts" => "User contacts",
// "User watches" => "User watches",
// "Receive email notification of changes. Each user can choose to be notified of changes to specific items" => "Receive email notification of changes. Each user can choose to be notified of changes to specific items",
// "Group watches" => "Group watches",
// "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group" => "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group",
// "Daily reports for user watches" => "Daily reports for user watches",
// "Allows you to schedule daily reports of watches to be sent (batched) at specific times" => "Allows you to schedule daily reports of watches to be sent (batched) at specific times",
// "User watches translations" => "User watches translations",
// "User watches languages" => "User watches languages",
"Watch language-specific changes within a category." => "범주 내부에서 특정 언어 관련 변경내역을 주시",
// "User menu" => "User menu",
"Unmaintained feature" => "방치된 기능",
// "User tasks" => "User tasks",
"User messages" => "사용자 메시지",
// "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group)." => "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group).",
// "User files" => "User files",
"Menu user levels" => "메뉴 사용자 등급",
"Enables control of the per-group visibility of menu options" => "사용자에게 표시되는 메뉴 선택사항을 제어하는 것을 허용함",
// "Group alert" => "Group alert",
"Integrator" => "통합기",
// "XMLRPC API" => "XMLRPC API",
"Debugger console" => "디버거 콘솔",
// "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions" => "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions",
// "Only viewable by admins" => "Only viewable by admins",
// "Not suitable for production use" => "Not suitable for production use",
"TikiTests" => "티키세트스",
"Permits recording and playback of functional tests" => "기능적 테스트의 기록과 재생을 허용",
"Check for updates automatically" => "업데이트 자동 확인",
"Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection" => "귀하께서 메인 관리 페이지를 접속하면 업데이트를 확인할 것입니다",
// "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters" => "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters",
// "Require confirmation of an action if a possible CSRF is detected" => "Require confirmation of an action if a possible CSRF is detected",
// "Deprecated. Using may cause false errors" => "Deprecated. Using may cause false errors",
"Detect browser language" => "브라우저 언어 감지",
"Look up the user's preferred language through browser preferences" => "사용자의 선호 언어를 브라우저 기본설정을 통하여 찾아보았습니다",
"Show pages in user's preferred language" => "페이지를 사용자의 선호 언어로 표시",
"When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences" => "사용자의 선호하는 언어와 동일한 것을 담고 있는 페이지를 접근할 때, 번역된 페이지를 선호",
"Synchronize page and site language" => "페이지와 사이트에 대하여 언어 동기화",
"Changing the page language also changes the site language" => "페이지 언어를 변경하면 사이트 언어도 변경됨",
"Translation assistant" => "번역 보조",
"Track translation operations between pages" => "페이지들간의 번역 작업을 추적",
"Urgent translation notifications" => "긴급 번역 통지",
// "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users" => "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users",
"Incomplete translation notice" => "미완 번역 알림",
"When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete" => "페이지가 새 언어로 번역되면, 번역은 아직 완료된 것이 아닙니다 라는 것을 가리키기 위하여 알림이 페이지에 자동적으로 삽입될 것입니다",
"Multilingual structures" => "다국어 구조체",
"Structures search for equivalent pages in other languages" => "구조체가 다른 언어로 된 동등한 페이지를 조회 함. 대형 구조체들에서는 성능 문제가 발생할 수 있습니다",
// "May cause performance problems with larger structures" => "May cause performance problems with larger structures",
"Display all languages in a single page" => "한 개의 페이지 내부에 모든 언어 표시",
"List all languages as options in the page-language dropdown list, to see them all at once" => "모든 언어를 페이지 한꺼번에 보기 위해서 언어 드롭목록 내부의 언어 선택사항으로써 나열",
"GZip output" => "GZip 출력",
"Compress your pages on-the-fly, if the requesting browser supports this" => "실시간으로 즉시 페이지를 압축, 단 요청하는 브라우저에서 기능 지원을 해야 함",
// "Help system" => "Help system",
"Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/" => "티키의 도움말 시스템 사용",
"Smileys" => "이모티콘",
"Also known as emoticons" => "이모티콘이라 알려져있음",
// "Tagging users" => "Tagging users",
// "Add support for @username mentions" => "Add support for @username mentions",
// "User mention notifications" => "User mention notifications",
// "Add support for @username mentions notifications" => "Add support for @username mentions notifications",
// "Draw (SVG edit)" => "Draw (SVG edit)",
"Draw enables creating and editing SVG images in all wiki text areas" => "그리기는 티키 전체를 통하여 SVG 그림을 편집할 수있게 합니다",
// "Draw (SVG edit) hide buttons" => "Draw (SVG edit) hide buttons",
"Hide buttons in Draw, HTML id, comma-separated" => "티키 그리기에서 발견된 버튼 숨기기, HTML id, 쉼표로 구분됨: \"tool_select,tool_fhpath,tools_line_show,tools_rect_show,tools_ellipse_show,tool_path,tools_shapelib_show,tool_text,tool_image,tool_zoom,tool_eyedropper\"",
// "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"" => "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"",
"Separate base image" => "별개의 베이스 그림",
"Leaves the initially edited image as a separate file and stores the drawing separately" => "초기에 편집된 그림을 별도 파일로 두고 그림을 별도로 저장함",
// "Draw in user file gallery" => "Draw in user file gallery",
"Docs (WebODF)" => "문서 (WebODF)",
"Docs enables viewing and editing Open Document Format files" => "Docs 는 Open Document Format 을 보기/편집 할 수 있게 합니다",
// "Dynamic content system" => "Dynamic content system",
"Block of content which can be reused and programmed (timed)" => "재사용 및 프로그램 될 수 있는 컨텐츠 블럭 (시간제한)",
// "Use file galleries to store images" => "Use file galleries to store images",
"If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead." => "비활성화된 경우, 그림은 대신 ../img/wiki_up/.. 에 저장됩니다.",
"External link icon" => "외부 링크 아이콘",
// "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set" => "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set",
// "Add \"rel=nofollow\" to external links" => "Add \"rel=nofollow\" to external links",
"Semantic links" => "시맨틱 링크",
"Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages" => "백링크 너머 이동, 위키 페이지들 간의 어떤 시맨틱 관계를 정의하는 것을 허용합니다",
// "Web services" => "Web services",
"Can receive web services via JSON or YAML" => "JSON 혹은 YAML 내부의 웹서비스 사용 가능",
"Use folder icons for menu section (parent) items" => "메뉴를 폴더로 표시",
"When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)" => "메뉴가 폴더로써 표시되어야 하는가, 기본은 \"y\"",
"Breadcrumbs" => "사이트 이동 경로",
"Indicates the navigation path through parent pages to the current page" => "자신의 위치를 보기를 시도",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "익명 편지바들은 안티봇 코드 (CAPTCHA)를 반드시 입력하여야만 합니다",
"Use CAPTCHA to ensure that anonymous input is from a person" => "익명사용자 입력이 사람에 의한 것이라는 점을 확인하기 위하여 CAPTCHA 를 사용",
"Protect email against spam" => "이메일을 스팸으로부터 보호",
"Protect email against spam submissions." => "이메일을 스팸 제출로부터 보호",
"Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "이메일을 스팸에 대하여 보호하는 기능은 현재 WYSIWYG 모드에서 편집된 페이지에서는 작동하지 않습니다 (티키 6.1)",
// "Site ads" => "Site ads",
// "Enable advertising" => "Enable advertising",
// "Activate will display content for Admin only. Select Publish to display for all users" => "Activate will display content for Admin only. Select Publish to display for all users",
"Anonymous voting" => "무기명 투표",
"Allow anonymous users to participate in voting" => "익명 사용자가 투표에 참여를 허용",
// "This can be overridden by specific permissions" => "This can be overridden by specific permissions",
"Allow re-voting" => "재투표 허용",
// "Visitors can vote mulitiple times in a poll" => "Visitors can vote mulitiple times in a poll",
// "When logged in, Tiki tracks users by username or otherwise IP address" => "When logged in, Tiki tracks users by username or otherwise IP address",
"Comments for polls" => "설문에 대한 댓글",
"Comments for FAQs" => "FAQ에 대한 댓글",
"Search engine friendly URL" => "검색 엔진 친화적 URL",
"If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config" => "아파치를 사용 중이라면, _htaccess 를 .htaccess 로 복사하여 단축 URL 을 구할 수 있음. IIS 에서는, web_config 을 web.config 로 복사",
// "SEFURL postfilter" => "SEFURL postfilter",
// "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead" => "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead",
// "Article title in SEFURL" => "Article title in SEFURL",
// "The article title rather than article number can be displayed in the search engine friendly URL" => "The article title rather than article number can be displayed in the search engine friendly URL",
// "Blog title in SEFURL" => "Blog title in SEFURL",
// "The blog title rather than blog number can be displayed in the search engine friendly URL" => "The blog title rather than blog number can be displayed in the search engine friendly URL",
// "Display forum thread or forum post title in the search engine friendly URL" => "Display forum thread or forum post title in the search engine friendly URL",
// "Tracker title in SEFURL" => "Tracker title in SEFURL",
// "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`" => "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`",
// "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)" => "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)",
// "Limit the number of characters in the tracker item or forum thread title" => "Limit the number of characters in the tracker item or forum thread title",
"Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "tiki-view_tracker.php?itemId=yyy 를 Prefixyyy 페이지로 재작성",
"This redirection uses the wiki prefix alias feature" => "이 리디렉션은 위키 접두어 별칭 기능을 사용합니다",
"Canonical URL tag" => "정식 URL 태그",
"Indicates to search engines which URL to use, to prevent duplicate listings" => "검색엔진에게 중복된 나열을 피하기 위하여 어떤 URL을 사용할 지를 지정함",
// "Canonical URL domain" => "Canonical URL domain",
// "Custom Routes" => "Custom Routes",
// "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL" => "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL",
"Show module controls" => "모듈 제어 보기",
// "Enable controls in modules" => "Enable controls in modules",
"Perspectives" => "퍼스펙티브",
"Permits overriding of preferences." => "개인설정을 재정의를 허용함",
"Search and replace" => "찾기 및 바꾸기",
"Enables finding and replacing of content in the edit box" => "편집 상자의 내용물의 찾기 및 바꾸기 허용",
"Submissions" => "투고",
"Articles can be submitted but need to be approved before they are published." => "제출이 전달되었습니다만, 라이브로 가기전에 승인 받아야만 합니다",
"Users can see several charts or rankings about the item" => "항목의 순위 사용",
"Comments on articles" => "기사에 대한 댓글",
// "Users with permission can post or reply to comments. The comments will appear at the bottom of the page" => "Users with permission can post or reply to comments. The comments will appear at the bottom of the page",
"Article content templates" => "기사 컨텐츠 템플릿",
"Predefined content for an article" => "뉴스 기사에 대하여 사전 정의된 컨텐츠",
"template article news" => "템플릿 기사 뉴스",
// "Print articles" => "Print articles",
"Specify notification emails when creating articles" => "기사를 만들 때 알림 이메일을 지정하십시오",
// "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation" => "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation",
"ShareThis buttons" => "ShareThis 버튼",
"Enable sharing site content via ShareThis" => "ShareThis 를 통한 공유 사용",
"Insert a ShareThis button from [http://www.sharethis.com]" => "ShareThis 버튼을 [http://www.sharethis.com] 에서 삽입",
// "Category path" => "Category path",
"Show the category tree above the wiki page" => "범주 트리 표시, 위키 페이지 상단에",
"Show category objects" => "범주 개체 표시",
"Show, at the bottom of the wiki page, objects in the same category" => "동일한 범주를 공유하는 개체를 표시, 위키 페이지 하단에",
"Ignore category viewing restrictions" => "범주 보기 제한을 무시",
"Display items the user may not be entitled to view in search results" => "검색 결과 내에 금지된 (제한된) 항목 표시 허용",
"Will improve performance, but may show forbidden results" => "성능을 향상하지만 금지된 결과를 표시할 수 있음",
"List pages" => "페이지목록",
"Allow viewing the wiki page list" => "페이지 목록 보기 허용",
// "Latest changes" => "Latest changes",
"Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display." => "최종 변경된 항목들의 목록 표시",
"Orphan pages" => "고아 페이지",
// "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)" => "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)",
"MySQL full-text search" => "MySQL 전체 텍스트 검색",
"Referer search highlighting" => "참조자 검색 하이라이트 중",
// "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility" => "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility",
"Search statistics" => "검색통계",
// "Enables administrators to collect and view statistics on search activity" => "Enables administrators to collect and view statistics on search activity",
"Ignore individual object permissions" => "개별 개체 권한 무시",
"Object filter" => "개체 필터",
"Enables object type filters to be displayed above the search results to further reduce search results by object type" => "개체의 필터링 허용",
"Search box" => "검생 상자",
// "Shows a search box above the search results to do additional searches" => "Shows a search box above the search results to do additional searches",
// "Include the number of visits in the search results" => "Include the number of visits in the search results",
"Relevance" => "연관성",
// "Display Tiki's estimate of the relevance of search matches in the search results" => "Display Tiki's estimate of the relevance of search matches in the search results",
"Object type" => "개체 유형",
// "Shows object type filters above the search results to further reduce search results by object type" => "Shows object type filters above the search results to further reduce search results by object type",
"Last-modified date" => "마지막 수정된 날짜",
// "Show the last-modified date in search results" => "Show the last-modified date in search results",
"Users can see several charts or rankings about the page" => "블로그 항목에 대하여 순위 사용",
"Custom blog headings" => "사용자 지정형 블로그 제목",
"Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead" => "사용자 지정 블로그 제목의 사용은 확실히 더 많은 서버 자원을 사용할 것입니다. 블로그 당 템플릿이 필요하지 않다면, 사용자 지정된 템플릿 파일을 사용하십시오",
"Publish dates can be modified" => "게재날짜는 수정될 수 있음",
// "Blog post Comments" => "Blog post Comments",
// "Users can view the “top” or “most” downloaded files" => "Users can view the “top” or “most” downloaded files",
// "File gallery comments" => "File gallery comments",
// "Store user files in a file gallery" => "Store user files in a file gallery",
// "Use the file gallery admin and the individual file gallery settings to manage file storage preferences" => "Use the file gallery admin and the individual file gallery settings to manage file storage preferences",
"userfiles" => "사용자파일",
"Use file galleries for wiki attachments" => "위키 첨부파일에 대하여 파일 갤러리 사용",
// "Wiki attachments will be stored in the file gallery" => "Wiki attachments will be stored in the file gallery",
"Batch uploading" => "일괄 업로딩",
// "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature" => "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature",
"Accept wiki syntax" => "위키 문법 허용",
"Topic archiving" => "토픽 보관중",
"Quick jumps" => "빠른 이동",
"Replies are empty" => "댓글이 비어있음",
"If disabled, replies will quote the original post" => "비활성화 된 경우, 댓글이 게시물 원본을 인용합니다",
// "Allows quoting in flat forums" => "Allows quoting in flat forums",
// "Allows users to reply" => "Allows users to reply",
"First post of a thread can have an empty body" => "쓰레드의 첫 게시물이 본문이 비어있을 수 있습니다",
"Will be a thread title" => "쓰레드 제목이 됨",
"Forum name search" => "게시판 이름 검색",
"When listing forums" => "게시판을 나열할 때",
"Forum content search" => "게시판 컨텐츠 검색",
"Topic content search" => "토픽 내용 검색",
"Tiki-indexed search" => "티키-색인된 검색",
"Use database (full-text) search" => "데이터베이스 (전체 텍스트) 검색 사용",
// "Index posts on forum section change" => "Index posts on forum section change",
// "Re-indexes forum posts to match the parent section when the section is changed" => "Re-indexes forum posts to match the parent section when the section is changed",
"Edit CSS" => "CSS 편집",
// "Edit CSS files directly in the browser" => "Edit CSS files directly in the browser",
// "May not be functional in Tiki 14+" => "May not be functional in Tiki 14+",
"Theme Control" => "테마 제어",
"Assign different themes to various sections, categories, and objects." => "다른 테마를 다른 부분, 범주, 및 개체들에 할당",
"design themes" => "디자인 테마",
// "Tiki template viewing" => "Tiki template viewing",
"Edit templates" => "템플릿 편집",
// "Custom HTML head content" => "Custom HTML head content",
// "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here" => "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here",
// "Add base tag in the HTML head section" => "Add base tag in the HTML head section",
// "The base tag specifies a default address for all links on a page" => "The base tag specifies a default address for all links on a page",
"Site logo and title" => "사이트 로고 및 제목",
"Display a site logo image and/or title in the page header area" => "사이트 로고와 제목을 사용",
"This setting is expected to be moved from here to the admin-modules page" => "전부 모듈로 이전할 것이며 사용되지 않을 것으로 예상됨",
"Left column" => "좌측 열",
"Controls visibility of the left column of modules" => "모듈의 좌측 열의 표시여부를 제어합니다",
"sidebar" => "사이드바",
"Only if one or more modules are assigned" => "만약 모듈일 경우",
"Always" => "항상",
"User decides" => "사용자가 결정",
"Right column" => "우 열",
"Controls visibility of the right column of modules" => "모듈의 우측 열의 표시여부를 제어합니다",
"Prefix breadcrumbs with \"Location : \"" => "사이트 이동 경로에 \"위치 : \" 접두어 붙이기",
// "Place the term \"Location:\" in the breadcrumbs" => "Place the term \"Location:\" in the breadcrumbs",
"Site location bar" => "사이트 위치 바",
"Use breadcrumbs module" => "사이트 이동 경로 모듈 사용",
"Top of center column" => "중앙 열의 상단",
// "Larger font" => "Larger font",
"Entire location" => "위치를 입력하십시오",
"Page name" => "페이지명",
"Use page description" => "페이지 설명 사용",
"Extreme top of page, above the site logo, etc" => "페이지 상단",
"Custom code just before the closing </body> tag" => "닫기 </body> 태그 직전의 사용자 코드",
// "Enter lines here to be placed near the end of the HTML file" => "Enter lines here to be placed near the end of the HTML file",
"Webmaster report" => "웹마스터 보고서",
// "Activate the feature to report a problematic page to the webmaster." => "Activate the feature to report a problematic page to the webmaster.",
"Webmaster email" => "웹마스터 이메일",
"Leave blank to use the default sender email" => "기본 발신인 이메일을 사용하려면 빈 칸으로 두십시오",
// "A specific email address can be set for receiving the webmaster reports" => "A specific email address can be set for receiving the webmaster reports",
"Email this page" => "이 페이지를 이메일로 발송",
"Adds a link at the bottom if set, otherwise adds a link at the top" => "설정된 경우 하단에 링크 추가, 그 외는 상단에 링크 추가",
// "This enables users to share a page with others, by emailing a short message and link to the page" => "This enables users to share a page with others, by emailing a short message and link to the page",
"Shadow layer" => "음영 레이어",
"Additional div elements for shadows, radiused corners or other decorative styling" => "음영, 둥근 모서리 혹은 다른 장식 스타일링에 대한 추가 레이어들",
"Tooltips" => "툴팁",
// "Enable tooltips such as this to have a custom appearance, styled by CSS" => "Enable tooltips such as this to have a custom appearance, styled by CSS",
"Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc" => "페이지명, 사용자명, 그룹, 태그 등에 대한 많은 텍스트 입력 상자에 다양한 드롭다운 메뉴를 제공합니다",
"Superfish" => "수퍼피시",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
"Reflection" => "반사",
// "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"" => "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"",
// "JQuery UI" => "JQuery UI",
"Include jQuery UI library. Enables a number of interface features" => "jQuery UI 라이브러리 포힘, 많은 사용자 인터페이스 기능 활성화함",
"jQuery UI theme" => "JQuery UI 테마",
"jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc" => "JQuery UI 테마. 스프레드시트에서 사용됨, 예제 ",
"Validation" => "유효성 검사",
"Provides various validation possibilities such as for trackers" => "트래커에서 처럼 다양한 유효화 가능성을 제공합니다",
// "jQuery infinite carousel" => "jQuery infinite carousel",
// "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel" => "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel",
// "jQuery sortable tables" => "jQuery sortable tables",
// "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables" => "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables",
// "jQuery media" => "jQuery media",
// "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used" => "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used",
// "TagCanvas" => "TagCanvas",
// "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud" => "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud",
// "jQuery zoom" => "jQuery zoom",
// "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"" => "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"",
// "Use tabs" => "Use tabs",
"Separates page content into tabbed panels" => "다른 탭들로 컨텐츠를 분리하여 페이지를 짧게 만듭니다",
"Wiki content templates" => "위키 컨텐츠 템플릿",
"Prewritten content (probably partial content) for a wiki page" => "위키 페이지에 대하여 사전정의된 컨텐츠",
"Warn on edit conflict" => "편집 충돌 시 경고",
"When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages" => "티키는 다른 사용자가 현재 편집 중인 페이지를 편집 시도하는 사용자에게 경고할 것입니다",
"Undo" => "복구",
"Footnotes" => "각주",
"Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages." => "저자에게만 보이는 페이지에 대한 개인 메모 만들기",
"Allow HTML" => "HTML사용 허가",
// "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code",
// "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus" => "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus",
"Log bytes changes (+/-) in action logs" => "작업 로그에서 바이트 변경을 기록 (+/-)",
"May impact performance" => "성능에 영향을 미칠 수 있습니다",
"Sandbox" => "모래상자",
// "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved" => "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved",
"Comments below wiki pages" => "댓글 위치를 위키 페이지 하단으로 함",
"Allow users to upload images to a page" => "사용자가 페이지에 그림 (사진) 업로드 허용",
"Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)" => "위키 내보내기 헝요",
"WikiWords" => "위키단어",
// "Automatically convert \\\"CamelCase\\\" words into wiki links" => "Automatically convert \\\"CamelCase\\\" words into wiki links",
"Link plural WikiWords to their singular forms" => "위키단어 복수형을 단수형으로 연결",
"Accept dashes and underscores in WikiWords" => "위키단어에 대시와 밑줄을 허용",
"History" => "기록",
// "Users (with permission) can see the history of each wiki page" => "Users (with permission) can see the history of each wiki page",
"Display IP address" => "IP 주소 표시",
"Wiki full history" => "위키 전체 역사",
"Record all versions, rather than only when page content or description changes or when an edit comment is given" => "페이지 컨텐츠 혹은 설명이 변경될 때 혹은 편집 댓글이 주어질 때뿐만 아니라 모든 버전을 기록합니다.",
"View page contributions by author" => "저자에 의한 페이지 기여내역 보기",
"Visualize the contributions that different authors have made to a wiki page" => "위키 페이지에 다른 저자들이 기여한 바를 시각화",
"Discuss pages on forums" => "페이지를 게시판에서 논의",
// "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page" => "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page",
"View source" => "소스 보기",
// "Users (with permission) can see the wiki and/or HTML syntax of the page" => "Users (with permission) can see the wiki and/or HTML syntax of the page",
// "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”" => "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”",
// "Present a list of pages that link to the current page" => "Present a list of pages that link to the current page",
"Similar pages" => "유사한 페이지들",
// "Display a list of pages named similarly to the current page" => "Display a list of pages named similarly to the current page",
"Structures" => "구조체",
// "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document" => "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document",
"Structures drill down menu" => "구조체 드릴다운 메뉴",
"Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down" => "구조체에 대한 AJAX 스타일의 드릴다운 메뉴",
"Open page as structure" => "구조체로 페이지 열기",
// "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL" => "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL",
"Make structure from page" => "페이지에서 구조체 만들기",
// "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure" => "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure",
"Categorize structure pages together" => "구조체 페이지들을 함께 범주화",
// "Place new pages of a structure in the same category as the structure's root page" => "Place new pages of a structure in the same category as the structure's root page",
"Disable inherited direct object permissions" => "상속된 직접 개체 권한을 사용 안 함",
// "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure" => "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure",
"Create webhelp from structure" => "구조체에서 웹도움말 만들기",
// "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format" => "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format",
"Import HTML" => "HTML 가져오기",
"Enable import of HTML pages." => "HTML 페이지 가져오기 허용",
"Use date parameter" => "날짜 매개변수 사용",
// "Allow wiki page version to be selected from a parameter \"date\" on the url" => "Allow wiki page version to be selected from a parameter \"date\" on the url",
"Report it in wiki links" => "위키 링크 내에 이를 보고",
// "Add the date parameter to wiki links" => "Add the date parameter to wiki links",
"Import pages" => "페이지 가져오기",
"A personal wiki page for each user" => "사용자가 관리하는 개인 페이지",
"Userpage prefix" => "사용자 페이지 접두사",
"All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required." => "모든 사용자 페이지는 공통의 접두사를 공유합니다. 접두사와 사용자명의 연결로 페이지명이 생성됩니다. 접두사는 비어있을 수 없습니다.",
"Users can lock pages" => "사용자는 페이지를 잠글 수 있습니다",
"Enable users to lock pages and so prevent others from editing them" => "사용자가 개별 페이지 잠그는 것 허용",
"MultiPrint" => "다중인쇄",
// "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document" => "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document",
// "Print Wiki" => "Print Wiki",
"Provide a print icon and layout of the wiki page formatted for printing" => "위키의 인쇄 사용",
"Pages not in structure" => "구조체 안에 있지 않은 페이지",
// "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display" => "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display",
"Attachments" => "첨부",
"Allow users to upload (attach) files to a page" => "사용자가 페이지에 파일을 업로드 (첨부) 허용",
// "Limit wiki page categories to those under this category" => "Limit wiki page categories to those under this category",
"If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"" => "위키 페이지를 편집할 때 필수 범주가 요구된다는 오류 메시지를 받는 경우, 이 선택사항이 문제인 것이빈다. 이를 없음으로 설정하십시오",
"Show/hide icon before headings" => "제목 전에 표시/숨김",
// "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below" => "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below",
"Wiki argument variables" => "위기 인수 변수",
"Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "{{paramname}} 혹은 {{paramname|기본}} - 특별한 경우 {{page}} {{user}} 를 사용하여 위키 컨텐츠 내부에 요청 변수를 작성하는 것을 허용",
"Users can choose to stay in SSL mode after an HTTPS login" => "사용자는 HTTPS 로그인 후 SSL 모드로 남기를 선택할 수 있습니다",
"Users can switch between secured or standard mode at login" => "사용자는 로그인 시 보안과 표준 모드 사이에서 변경할 수 있습니다",
"Wiki paragraph formatting" => "위키 문단 서식적용",
"Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "위키 문단 서식적용 기능이 켜져 있다면, 비어있지 않은 줄들의 그룹은 문단으로 모여지게 됨. 줄의 길이는 무관하며, 다음 줄과 함께 둘러쌓여지게 됨. 문단은 빈 줄로 구분이 됨.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "위키 문단 서식적용 기능이 꺼져 있다면, 각 줄은 작성되는 그대로 표시 됨. 이는 문단이 올바르게 둘러싸이길 원한다면, 문단이 한 줄에 함께 있어야 함.",
// "Create line breaks within paragraphs" => "Create line breaks within paragraphs",
// "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs" => "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs",
"Automonospaced text" => "자동고정폭 텍스트",
// "Lines indented with spaces will automatically be converted to monospace font" => "Lines indented with spaces will automatically be converted to monospace font",
"Tables syntax" => "표 문법",
"|| for rows" => "줄에 대하여 || ",
"<return> for rows" => "줄에 대하여 <return>",
"AutoLinks" => "자동링크",
"Web (http://) and email addresses will automatically be converted to links" => "티키는 http:// 와 이메일 주소를 링크로 자동 변환할 것입니다",
"Hotwords" => "핫워드",
"Open hotwords in new window" => "Hotwords 를 새 창에서 열기",
"Characters that limit a hotword" => "hotword 를 제한하는 글자들",
"Use Quote plugin rather than \">\" for quoting" => "인용 시, \">\" 대신 인용 플러그인을 사용",
"Center text using ::: instead of :" => "텍스트를 : 대신 ::: 를 사용하여 가운데 정렬",
"Useful to avoid conflicts with C++ scope operators or default namespace separator" => "C++ 범위 연산자 혹은 기본 네임스페이스 구분자와 충돌을 피할 때 유용함",
"String to use to delimit simplebox" => "simplebox 를 구분 시 사용할 문자열",
"Users can choose to show their gender" => "사용자는 성별 표기를 선택할 수 있습니다",
"Real name" => "실명",
"Gender" => "성별",
// "Profile picture (avatar)" => "Profile picture (avatar)",
"Country" => "국가",
"Last login" => "최종 로그인",
"Distance" => "간격",
"Manual selection of time/date" => "시간/날짜의 수동 선택",
"WebDAV access to Tiki" => "티키로 WebDAV 접근",
"Allow file gallery access with WebDAV" => "파일 갤러리를 WebDAV 로 접근 허용",
"use tiki-webdav.php as the URI of the WebDAV repository" => "tiki-webdav.php 를 WebDAV 리포지토리의 URI 로 사용",
"Fixed width" => "수정된 넓이",
"Restrict the width of the site content area, in contrast to a liquid (full-width) layout" => "사이트 넓이를 제한함",
"Social networks" => "소셜 네트워크",
"Integration with social applications and networks like Twitter and Facebook" => "트위터나 페이스북 같은 다른 소셜네트워크와 통합",
// "Group transition" => "Group transition",
"Enables transitions for users between different groups. Transitions will create a user approval workflow." => "다른 그룹들 간 사용자 전이를 활성화함. 전이는 사용자 승인 작업흐름도를 만듬",
// "Category transition" => "Category transition",
"Enables transitions for objects between different categories. Transitions will create a document workflow" => "다른 범주들 간의 개체 상의 전이를 활성화. 전이는 문서 작업흐름을 만들 것임",
// "Tiki user credits" => "Tiki user credits",
"Invite users" => "사용자 초대",
"Allow users to invite new users to register at this site, by sending an email." => "사용자들이 새 사용자에게 이 티키로 등록하도록 이메일을 보내 초대하는 것을 허용함",
"Alternate registration page" => "대체 등록 페이지",
"Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page" => "tiki-register.php 로의 모든 접근을 등록을 위한 대체 페이지로 리디렉션하게 합니다",
"Load balancer" => "로드 밸런서",
"Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server" => "서버가 부하 분산 (혹은 역방향 프록시) 뒤에 있을 경우에만 이것을 활성화 합니다, 이는 티키로 하여금 프록시 서버의 IP 대신 사용자의 IP를 기록하도록 합니다.",
// "Tiki is behind a frontend-proxy/load-balancer that rewrites ports" => "Tiki is behind a frontend-proxy/load-balancer that rewrites ports",
// "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links" => "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links",
"Accounting" => "회계",
"Double-entry accounting system" => "이중입력 회계 시스템",
// "Code editor (CodeMirror)" => "Code editor (CodeMirror)",
// "CodeMirror code editor, which provides syntax highlighting" => "CodeMirror code editor, which provides syntax highlighting",
"Syntax highlighter (CodeMirror) Theme" => "구문 강조표시 도구 (코드미러) 테마",
"CodeMirror themes (clear cache after changing)" => "코드 미러 테마 (변경 시 캐시를 삭제하십시오)",
"default" => "기본",
// "Off (but switchable)" => "Off (but switchable)",
"Dummy preference" => "Dummy 선호설정",
"This is useful for developers to learn how to create a new preference. HTML may be used" => "개발자들이 새 기본설정을 만드는 방법을 학습하는데 유용합니다",
"This is the detail" => "상세내역입니다",
"This is the warning" => "경고입니다",
"This is the hint. Wiki syntax may be used" => "힌트입니다",
"This is the shorthint. Wiki syntax may be used" => "짧은 힌트입니다",
// "Time sheet" => "Time sheet",
"A project time manager" => "프로젝트 시간 관리자",
// "This feature will be removed after Tiki18 and before Tiki19" => "This feature will be removed after Tiki18 and before Tiki19",
// "HTML feed" => "HTML feed",
"A way to transfer HTML content from one Tiki site to another" => "한 사이트에서 다른 사이트로 HTML 부분을 밀고 당기는 방법",
// "Send an email notification to group leaders when a user joins" => "Send an email notification to group leaders when a user joins",
// "Send an email notification to group leaders when a user leaves" => "Send an email notification to group leaders when a user leaves",
// "Inline comments" => "Inline comments",
// "Contextual comments" => "Contextual comments",
// "Enable JavaScript plugin for equal-height rows" => "Enable JavaScript plugin for equal-height rows",
// "Enable responsive rows, the contained elements of which have the same height" => "Enable responsive rows, the contained elements of which have the same height",
// "Conditional formatting" => "Conditional formatting",
// "Use different coloring for certain system objects. Only groups are supported for now" => "Use different coloring for certain system objects. Only groups are supported for now",
// "Store session variable for current theme" => "Store session variable for current theme",
// "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing" => "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing",
// "Parent category of theme control categories" => "Parent category of theme control categories",
// "Choose the parent category of categories used for theme control" => "Choose the parent category of categories used for theme control",
// "Automatically select the theme-control category of the current theme when categorizing" => "Automatically select the theme-control category of the current theme when categorizing",
// "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme" => "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme",
// "Certain pages redirect to homepage when language is changed" => "Certain pages redirect to homepage when language is changed",
// "List of pages that redirect" => "List of pages that redirect",
// "List of names of pages that always redirect to the homepage when the language is switched" => "List of names of pages that always redirect to the homepage when the language is switched",
// "Separate page names by commas" => "Separate page names by commas",
// "User wizard" => "User wizard",
// "Wizard to help users set up their basic settings and account details" => "Wizard to help users set up their basic settings and account details",
// "Present different input fields in the User Wizard than are in the Registration form" => "Present different input fields in the User Wizard than are in the Registration form",
// "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form" => "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form",
// "Tracker fields presented in the User Wizard as User Details" => "Tracker fields presented in the User Wizard as User Details",
// "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)" => "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)",
// "Enable Typography Features" => "Enable Typography Features",
// "Features to replace normal characters with typographic equivalents" => "Features to replace normal characters with typographic equivalents",
// "Smart “curly” quotes" => "Smart “curly” quotes",
// "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes" => "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes",
// "Convert approximative ASCII quotes" => "Convert approximative ASCII quotes",
// "Convert plain-ASCII quote substitutes `` '\\" => "Convert plain-ASCII quote substitutes `` '\\",
// "Smart em-dash and ellipsis" => "Smart em-dash and ellipsis",
// "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…" => "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…",
// "Smart no-break space" => "Smart no-break space",
// "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it" => "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it",
// "Display only select calendars by default" => "Display only select calendars by default",
// "Master Tiki server" => "Master Tiki server",
// "Master Tiki server that this client will obtain user authorizations from" => "Master Tiki server that this client will obtain user authorizations from",
// "Overrides manually registered local users" => "Overrides manually registered local users",
"Import user preferences" => "사용자 기본설정 가져오기",
// "Client Tiki will copy the user preferences from the master server" => "Client Tiki will copy the user preferences from the master server",
// "This will overwrite local user preferences every time the user logs in" => "This will overwrite local user preferences every time the user logs in",
"Import user groups" => "사용자 그룹 가져오기",
// "Groups the user belongs to on the master server will be imported (along with their security definitions)" => "Groups the user belongs to on the master server will be imported (along with their security definitions)",
// "This will overwrite local groups every time a user logs in" => "This will overwrite local groups every time a user logs in",
// "Limit group import" => "Limit group import",
// "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation" => "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation",
// "This list will limit the group import feature to only those groups listed here" => "This list will limit the group import feature to only those groups listed here",
// "Intertiki shared cookie" => "Intertiki shared cookie",
// "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites" => "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites",
// "This site is a master server" => "This site is a master server",
// "Scheduler" => "Scheduler",
// "Provides the ability to run tasks at a scheduled time" => "Provides the ability to run tasks at a scheduled time",
// "Convert from absolute to relative link" => "Convert from absolute to relative link",
// "Process wiki text and convert internal links from absolute to relative links" => "Process wiki text and convert internal links from absolute to relative links",
// "It's recommended to set a cron job to periodically rebuild the search index" => "It's recommended to set a cron job to periodically rebuild the search index",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results",
"Show user's contribution on the user information page" => "사용자 정보 페이지 상의 사용자의 기여도 표시",
"View user's contribution on the user information page." => "사용자 정보 페이지에서 사용자의 기여내역 보기",
// "Users' drawings are stored in their user files gallery" => "Users' drawings are stored in their user files gallery",
"Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index" => "nofollow 는 검색 엔진에게 링크가 영향을 미쳐야 하지 않다고 알려주기 위해 사용됩니다. 검색 엔진 스팸을 줄일 수 있으며 'spamdexing' 을 방지할 수 있음",
// "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised" => "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised",
// "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated" => "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated",
// "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6" => "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6",
"Require file creator's name for anonymous uploads" => "anonymous 업로드에 대해 파일 저자의 이름을 요구",
"Redirect to similar wiki page" => "유사한 위키 페이지로 리디렉션하기",
"If a requested page doesn't exist, redirect to a similarly named page" => "요청된 페이지가 존재하지 않는다면, 유사한 이름의 페이지로 리디렉션",
"Redirect to page alias, if any" => "페이지 별칭이 있을 경우 리디렉션하기",
"If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "요청된 페이지가 존재하지 않는다면, 별칭 페이지로 리디렉트, 단, 별칭 시맨틱 링크를 사용하여 지정되었을 경우",
"User's information page" => "사용자의 페이지",
"Display a user's gender if permitted by the user." => "사용자가 승인할 경우 사용자의 성별 표시",
// "Allow showing user's information on mouseover" => "Allow showing user's information on mouseover",
// "Show users' information on mouseover" => "Show users' information on mouseover",
"Requires user's information to be public" => "사용자의 정보가 공용이 될 필요",
"Show the user's real name" => "사용자의 실명 표시",
// "Federated search" => "Federated search",
// "Search through alternate site indices" => "Search through alternate site indices",
// "Elasticsearch is required" => "Elasticsearch is required",
// "Elasticsearch tribe node URL" => "Elasticsearch tribe node URL",
// "URL of the tribe client node accessing multiple clusters" => "URL of the tribe client node accessing multiple clusters",
"Default feed format" => "기본 피드 형식",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
"Feed author name" => "저자명 피드",
// "Default author of each item in the feed" => "Default author of each item in the feed",
"This field is mandatory unless both feed author email and homepage are empty" => "이 필드는 피드 저자 이메일과 홈페이지가 비어있는 경우를 제외하고는 필수입니다",
"Feed author email" => "저자 이메일을 피드",
// "Email of the author of each item in the feed" => "Email of the author of each item in the feed",
"Feed author homepage" => "저자 홈페이지를 피드",
// "Homepage URL of the author of each item in the feed" => "Homepage URL of the author of each item in the feed",
"Feed editor email" => "피드 편집자 이메일",
"Email address for person responsible for editorial content" => "편집과 관련된 컨텐츠에 대한 개인의 이메일 주소",
"Feed webmaster email" => "피드 웹마스터 이메일",
"Email address for person responsible for technical issues relating to channel" => "채널과 연관된 기술적 문제를 책임지는 사람에 대한 이메일 주소",
"Feed image path" => "피드 그림 경로",
"Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "피드와 함께 표시될 수 있는 GIF, JPEG 혹은 PNG 그림을 지정",
// "Feed language" => "Feed language",
"The default language for this feed" => "이 피드에 대한 기본 언어",
// "RSS basic authentication" => "RSS basic authentication",
"Propose basic HTTP authentication if the user has no permission to see the feed" => "사용자가 피드를 볼 권한이 없을 경우 기본 http 인증을 제안하십시오",
"Feed caching time" => "피드 캐싱 시간",
// "Cache the feed for this number of seconds" => "Cache the feed for this number of seconds",
"Use 0 for no caching" => "캐싱 없음에는 0을 사용",
"Feed caching is done for anonymous users only" => "피드 캐싱은 익명사용자에 대해서만 이루어집니다",
"RSS for articles" => "기사에 대한 RSS 피드",
"RSS feeds for articles" => "기사에 대한 RSS 피드",
"RSS for blogs" => "블로그에 대한 RSS",
"RSS feeds for blogs" => "블로그에 대한 RSS 피드",
"RSS for individual blogs" => "개별 블로그에 대한 RSS",
"RSS feeds for individual blogs" => "개별 블로그에 대한 RSS 피드",
"RSS for image galleries" => "그림 갤러리에 대한 RSS",
"RSS feed for image galleries" => "그림 갤러리에 대한 RSS 피드",
"RSS for individual image galleries" => "개별 그림 갤러리에 대한 RSS",
"RSS feeds for individual image galleries" => "개별 그림 갤러리에 대한 RSS 피드",
"RSS for file galleries" => "파일 갤러리에 대한 RSS",
"RSS feed for file galleries" => "파일 갤러리에 대한 RSS 피드",
"RSS for individual file galleries" => "파일 갤러리에 대한 RSS",
"RSS feeds for individual file galleries" => "개별 파일 갤러리에 대한 RSS 피드",
"RSS for wiki pages" => "위키 페이지에 대한 RSS",
"RSS feed for wiki pages" => "위키에 대한 RSS 피드",
"RSS for forums" => "게시판에 대한 RSS",
"RSS feed for forums" => "게시판에 대한 RSS 피드",
"RSS for individual forums" => "개별 게시판에 대한 RSS",
"RSS feeds for individual forums" => "개별 게시판에 대한 RSS 피드",
"RSS per tracker" => "트래커 당 RSS",
"RSS feed per tracker" => "트래커에 대한 RSS 피드",
"RSS for calendar events" => "달력 이벤트에 대한 RSS",
"RSS feed for calendar events" => "달력 이벤트에 대한 RSS 피드",
"RSS for directories" => "디렉터리에 대한 RSS",
"RSS feed for directories" => "디렉터리에 대한 RSS 피드",
"RSS for shoutbox" => "외침상자에 대한 RSS",
"RSS feed for shoutbox" => "외침상자에 대한 RSS 피드",
"Maximum number of items to display" => "표시할 항목의 최대 수",
// "items" => "items",
"Show author" => "작성자 표기",
"Homepage URL" => "홈페이지 URL",
"Tiki RSS feed for articles" => "기사에 대한 티키 RSS 피드",
"Tiki RSS feed for blogs" => "웹로그에 대한 티키 RSS 피드",
"Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "모든 블로그에 대한 블로그 제목 앞에 붙을 제목. 이 필드가 비어있을 경우, 블로 제목만이 사용될 것입니다",
"Tiki RSS feed for image galleries" => "그림 갤러리에 대한 대한 티키 RSS 피드",
"Tiki RSS feed for the image gallery: " => "그림 갤러리에 대한 대한 티키 RSS 피드:",
"Tiki RSS feed for file galleries" => "파일 갤러리에 대한 티키 RSS 피드",
"Tiki RSS feed for the file gallery: " => "파일 갤러리에 대한 티키 RSS 피드:",
"Tiki RSS feed for the wiki pages" => "위키 페이지에 대한 티키 RSS 피드",
"Tiki RSS feed for forums" => "게시판들에 대한 티키 RSS 피드",
"Tiki RSS feed for forum: " => "게시판에 대한 티키 RSS 피드:",
"Tiki RSS feed for individual trackers: " => "개별 트래커에 대한 대한 티키 RSS 피드:",
"Tiki RSS feed for calendars" => "달력에 대한 티키 RSS 피드",
"Tiki RSS feed for directory sites" => "디렉터리 사이트에 대한 티키 RSS 피드",
"Tiki RSS feed for shoutbox messages" => "외침상자 메시지에 대한 대한 티키 RSS 피드",
"Article RSS description" => "기사 RSS 설명",
"Description to be published as part of the RSS feed for articles" => "기사에 대하여 RSS 피드의 일부로써 게재될 설명",
"Last articles" => "최근 기사",
"Blogs RSS description" => "블로그 RSS 설명",
"Description to be published as part of the RSS feed for blogs" => "블로그에 대하여 RSS 피드의 일부로써 게재될 설명",
"Last posts to weblogs" => "웹로그로의 최종 게시물",
"Blog RSS Description" => "블로그 RSS 설명",
"Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used" => "블로그 설명에 앞에 추가되고 개별 블로그에 대하여 RSS 피드의 일부로써 게재될 설명. 이 필드가 비어있을 경우, 블로그 설명만이 사용됩니다",
"Image galleries RSS description" => "그림 갤러리 RSS 설명",
"Description to be published as part of the RSS feed for image galleries" => "그림 갤러리에 대한 RSS 피드의 일부로써 게재될 설명",
"Latest images uploaded to the image galleries" => "이미지 갤러리로 업로드된 마지막 그림들",
"Individual image galleries RSS Description" => "개별 그림 갤러리 RSS 설명",
"Description to be published as part of the RSS feeds for individual image galleries" => "개별 그림 갤러리에 대한 RSS 피드의 일부로써 게재될 설명",
"Latest images uploaded to this image gallery." => "이 이미지 갤러리로 업로드된 마지막 그림들.",
"File galleries RSS description" => "파일 갤러리 RSS 설명",
"Description to be published as part of the RSS feed for file galleries" => "파일 갤러리에 대한 RSS 피드의 일부로써 게재될 설명",
"Latest files uploaded to the file galleries" => "파일 갤러리에 업로드된 마지막 파일들",
"Individual file galleries RSS description" => "개별 파일 갤러리 RSS 설명",
"Description to be published as part of the RSS feeds for individual file galleries" => "개별 파일 갤러리에 대한 RSS 피드의 일부로써 게재될 설명",
"Latest files uploaded to this file gallery." => "이 파일 갤러리에 업로드된 마지막 파일들",
"Wiki pages RSS description" => "위키 페이지 RSS 설명",
"Description to be published as part of the RSS feed for wiki pages pages" => "위키 페이지에 대한 RSS 피드의 일부로써 게재될 설명",
"Latest wiki page changes" => "위키로의 마지막 수정",
"Forums RSS description" => "게시판 RSS 설명",
"Description to be published as part of the RSS feed for forums" => "게시판에 대하여 RSS 피드의 일부로써 게재될 설명",
"Latest forum topics" => "게시판의 최근 토픽",
"Individual forums RSS description" => "개별적 게시판 RSS 설명",
"Description to be published as part of the RSS feeds for individual forums" => "개별 개시판에 대하여 RSS 피드의 부분으로 개졔될 설명",
"Latest posts to this form" => "이 게시판의 최종 게시물",
"Individual trackers RSS description" => "개별 트래커 RSS 설명",
"Description to be published as part of the RSS feed for individual trackers" => "개별 트래커에 대하여 RSS 피드의 일부로써 게재될 설명",
"Latest additions to this tracker" => "이 트래커에 게재된 마지막 항목들",
"Calendar events RSS description" => "달력 이벤트 RSS 설명",
"Description to be published as part of the RSS feed for calendar events" => "달력 이벤트에 대하여 RSS 피드의 일부로써 게재될 설명",
"Upcoming Events" => "다가오는 이벤트",
"Directories RSS description" => "디렉터리 RSS 설명",
"Description to be published as part of the RSS feed for directories" => "디렉터리에 대하여 RSS 피드의 일부로써 게재될 설명",
"Latest sites" => "마지막 사이트",
"Shoutbox RSS description" => "외침상자 RSS 설명",
"Description to be published as part of the RSS feed for shoutbox messages" => "외침상자 메시지에 대한 RSS 피드의 일부로써 게재될 설명",
"Latest shoutbox messages" => "마지막 외침상자 메시지",
// "Tracker labels" => "Tracker labels",
// "Include tracker field labels in the RSS output" => "Include tracker field labels in the RSS output",
"Page" => "페이지",
// "Finder view" => "Finder view",
"Show as a column" => "열로 보임",
"Show in popup box" => "팝업상자에서 보기",
"Both" => "둘 다",
"Podcast directory" => "팟캐스트 디렉터리",
// "File system directory for storing podcast files" => "File system directory for storing podcast files",
"The server must be able to read/write the directory." => "서버가 이 디렉터리에 읽기/쓰기가 가능해야만 함",
"Required for podcasts." => "팟캐스트를 위한 필수항목.",
"To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc" => "디렉터리 일괄 로딩 을 활성화하면, 웹으로 읽기가능한 디렉터리를 설정해야 합니다 (귀화의 웹 공간의 외부를 추천해드립니다). 그리고 파일을 해당 디렉토리에 업로드할 방법을 설정하십시오, 방법은 scp, ftp, 및 기타 프로토콜 등이 있습니다",
"The server must be able to read the directory." => "서버가 해당 디렉터리를 읽을 수 있어야만 합니다",
"The directory can be outside the web space." => "디렉터리는 웹 공간의 외부에 있을 수 있습니다",
"Prevent download if score becomes negative" => "점수가 마이너스가 되면 다운로드를 금지",
// "If using Tiki Score system, users with a negative score cannot download files" => "If using Tiki Score system, users with a negative score cannot download files",
"Allow download limit per file" => "파일 당 다운로드 수 제한 허용",
// "Allow file duplicates" => "Allow file duplicates",
"Allow the same file to be uploaded more than once" => "같은 파일이 한 번 이상 업로드 되는 것을 허용",
"Yes, even in the same gallery" => "예, 같은 갤러리에서도",
"Only in different galleries" => "다른 갤러리 일 때만",
"Display ZIP option in gallery" => "갤러리 내부의 zip 선택사항 표기",
"Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery." => "갤러리 내부에 zip 선택사항을 표기 (업로드와 갤러리 파일 내부)",
"Must match" => "다음과 일치해야만 함",
// "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)" => "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)",
"Cannot match" => "다음과 일치할 수 없음",
// "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted" => "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted",
"Quota for all files and archives" => "모든 파일과 보관함에 대한 할당량",
// "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)" => "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)",
"0 for unlimited" => "버 제한 없을 경우 0",
// "megabytes" => "megabytes",
"Quota for each file gallery" => "할당량은 파일 갤러리 각각에 대하여 정의될 수 있음",
// "A different quota can be defined for each file gallery" => "A different quota can be defined for each file gallery",
"Default quota for each new gallery" => "새 갤러리 각각의 기본 할당량",
"Show quota bar in the list page" => "목록 페이지 내부에 인용 바 표시",
"Yes, display bar and detail text" => "예, 바와 상세내역 텍스트를 표기",
"Yes, display only bar" => "예, 바만 표기",
"Yes, display only text" => "예, 텍스트만 표기",
"Storage" => "저장",
// "Specify if uploaded files should be stored in the database or file directory" => "Specify if uploaded files should be stored in the database or file directory",
"Store in database" => "데이터베이스 저장",
"Store in directory" => "디렉터리에 저장",
"Path to the directory to store file gallery files" => "파일 갤러리 내부에 파일을 저정할 경로",
// "Searchable file gallery content" => "Searchable file gallery content",
"Include the search form on the current gallery page just after \"Find\"" => "div 를 찾은 후 현재 갤러리 파일들에 검색 상자 포함",
"Include a search form in file galleries" => "파일 갤러리에 검색상자 포함",
// "Display hits ratio to maximum" => "Display hits ratio to maximum",
"Display hits with a ratio of hits to maximum hits" => "방문수 / 최대 방문수 사이의 비율과 함께 방문수 표시",
"Display properties in the context menu" => "상황에 맞는 메뉴 내부에 속성 표시",
"Display \"Replace\" in the context menu" => "상황에 맞는 메뉴로 교체 메뉴 표시",
"Automatic deletion of old files" => "오래된 파일의 자동 삭제",
"The user will have an option when uploading a file to specify the time after which the file is deleted" => "사용자가 파일을 업로드 할 때 특정시간 후 파일이 삭제되도록 지정할 수 있는 선택사항을 보유하게 됨",
"A cron job must be set up in order to delete the files." => "파일을 삭제하려면 cron job 을 설정해야만 합니다.",
"Allow action on multiple files or galleries" => "여러 개의 파일 혹은 갤러리 상에 작업을 허용",
"Include \"Remove\" as an option for the checkbox action in file galleries" => "파일 갤러리의 체크 버튼은 제거될 수 있습니다",
"Deletion emails notification" => "이메일 알림 삭제",
"Email addresses (comma-separated) to receive a copy of each deleted file" => "이러한 이메일들은 각각의 삭제된 파일의 사본을 받게 될 것입니다. 이메일은 쉼표로 구분됩니다",
"Keep the same fileId for the latest version of a file" => "파일의 최신 버전에 대해 동일한 필드를 유지",
"If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file" => "체크가 되면 파일의 최신 버전의 필드가 동일한 상태 유지. 파일로의 링크가 항상 최신 버전을 향하게 됨. 체크가 안되어 있으면, 파일에 연결된 필드가 영구적이 되어, 파일로의 링크가 파일의 정확한 버전을 향하게 됨",
"Show thumbnail actions" => "축소보기 작업 표시",
"Show the checkbox and wrench icon for file actions menu when not displaying details" => "상세내역을 표시하지 않을 때 파일 작업 메뉴에 대하여 체크상자와 렌치 아이콘을 표시",
"Maximum thumbnail size" => "최대 축소보기 크기",
"Maximum width or height for image thumbnails" => "그림 축소보기에 대한 최대 넓이 혹은 높이",
"Automatic indexing of file content" => "파일 컨텐츠의 자동 색인",
"Uses command line tools to extract the information from the files based on their MIME types." => "파일의 MIME 유형에 따라 정보를 추출하기위하여 명령줄 도구를 사용.",
// "Asynchronous indexing" => "Asynchronous indexing",
"Upload files from remote source" => "원격 소스에서 파일 업로드",
"Enable copying files to file galleries from a URL that will be polled for new revisions." => "파일 갤러리에 새 수정 버전에 대하여 폴링이 될 URL을 사용하여 파일 만들기를 허용.",
"Remote source refresh frequency limit" => "원격 소스 새로 고침 빈도 제한",
"Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests" => "서버를 폭주하는 것을 방지하기 위하여 소스 체크 사이의 흐르게 될 초의 최소 양",
// "Set to zero to disable refresh" => "Set to zero to disable refresh",
"Display controls to attempt a file refresh" => "새로 고침을 시도하기 위한 제어 표기",
"Let users trigger a refresh attempt from the remote host" => "사용자가 원격 호스트에서 새로고침 시도를 트리거하는 것을 허용",
"Allow searching for existing files in the tracker files field" => "트래커 파일 필드 내부의 기존 파일의 검색 허용",
"Search files using the search index." => "검색 인덱스를 사용하여 파일 검색.",
"Set MIME type based on file suffix" => "파일 접미어에 기반한 mime 유형 수정",
"Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream" => "application/octet-stream 으로 잘 못 감지되었을 때 파일 확장자에 기반하여 그림 파일의 mime 유형을 수정함",
// "Clean XML Always" => "Clean XML Always",
// "Sanitize XML based files such as SVG for all users" => "Sanitize XML based files such as SVG for all users",
// "Allow SVG file upload" => "Allow SVG file upload",
// "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files." => "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files.",
"Maximum name length" => "최대 이름 길이",
"Length to which to truncate file names in browse view" => "탐색 보기에서 파일명을 자르기 위한 길이",
// "Maximum width of images" => "Maximum width of images",
// "Default maximum width of images in galleries" => "Default maximum width of images in galleries",
// "Maximum height of images" => "Maximum height of images",
// "Default maximum height of images in galleries" => "Default maximum height of images in galleries",
"Use elFinder UI" => "elFinder UI 사용",
// "Alternative file manager with drag and drop capability" => "Alternative file manager with drag and drop capability",
// "Use Viewer JS" => "Use Viewer JS",
// "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages" => "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages",
// "Viewer JS URI" => "Viewer JS URI",
// "Where ViewerJS is installed" => "Where ViewerJS is installed",
// "Use PDF.js" => "Use PDF.js",
// "Uses PDF.js to display PDF files in web pages" => "Uses PDF.js to display PDF files in web pages",
// "Default view" => "Default view",
// "Default sort field" => "Default sort field",
"Last modification date" => "최종변경일",
"Owner" => "소유자",
"Default sort direction" => "기본 정렬 방향",
"Descending" => "내림차순",
"Ascending" => "오름차순",
"Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "탐색 보기 내부에 이 갤러리에 대하여 아이콘으로 사용될 갤러리내부의 파일의 ID를 입력하십시오",
// "Show explorer" => "Show explorer",
// "Show path" => "Show path",
// "Show slideshow" => "Show slideshow",
"Name-filename" => "이름-파일명",
"Filename only" => "파일명만",
// "Created / Uploaded" => "Created / Uploaded",
// "Show icon in column" => "Show icon in column",
// "OCR Files" => "OCR Files",
// "Extract and index text from supported file types" => "Extract and index text from supported file types",
// "OCR Every File" => "OCR Every File",
// "Attempt to OCR every supported file" => "Attempt to OCR every supported file",
// "View or export office documents as PDF" => "View or export office documents as PDF",
// "If enabled allows to view documents without download or to export documents as PDF files" => "If enabled allows to view documents without download or to export documents as PDF files",
// "Maximum width of file preview in pixels" => "Maximum width of file preview in pixels",
// "The maximum value of width in pixels for the files preview in the popover" => "The maximum value of width in pixels for the files preview in the popover",
// "Export diagram image on save" => "Export diagram image on save",
// "If enabled, diagrams will be cached in PNG format when saved or edited" => "If enabled, diagrams will be cached in PNG format when saved or edited",
// "Use draw.io public services to export images" => "Use draw.io public services to export images",
// "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback" => "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback",
"Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory" => "서버 상에 디렉터리를 설정하십시오. 예.: /var/www/  이 디렉터리는 웹으로 접근이 가능하지 않도록 하는 것을 권장합니다. PHP 는 이 디렉터리에 반드시 쓰기/읽기가 가능해야만 합니다",
"Default order of comments." => "기본 정렬 알고리듬",
// "Use jQuery upload" => "Use jQuery upload",
// "Use the improved Tiki 15+ upload page" => "Use the improved Tiki 15+ upload page",
// "Redirect to file gallery" => "Redirect to file gallery",
// "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery" => "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery",
// "Revision approval" => "Revision approval",
"Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges" => "낮은 권한을 가진 사용자들로부터 미승인 위키 페이지 수정내역을 숨기기 위해서 플래그지정된 수정 기능을 사용",
// "Revision approval categories" => "Revision approval categories",
"List of category IDs for which revision approval is required" => "수정에 대한 승인이 필수 인 범주 ID의 목록",
"Footer shadow div start" => "꼬리말 음영 시작",
"Footer shadow div end" => "꼬리말 음영 끝",
// "Forum image file gallery" => "Forum image file gallery",
// "File gallery used to store images for forums" => "File gallery used to store images for forums",
"Uploaded filenames must match regex" => "업로드된 파일이름이 정규표현식에 일치해야합니다",
"Manage thread defaults per-forum" => "게시판 당 대화목록 기본사항 관리",
"Display thread configuration bar" => "대화목록 구성 바 표기",
"Allows users to override the defaults" => "사용자가 기본사항을 재정의하는 것을 허용",
"Display the thread configuration bar only when the number of posts exceeds" => "게시물의 숫자가 다음을 초과 시 대화목록 구성바 표기",
"posts" => "포스트수",
"Keep settings for all forums during the user session" => "사용자 세션동안 모든 게시판에 대한 설정 유지",
"Default style" => "기본 스타일",
"Threaded" => "계층구조로 보기",
"Headers only" => "헤더만",
"Default sort mode" => "기본 정렬 모드",
"Title (desc)" => "타이틀 (내림차순)",
"Title (asc)" => "타이틀 (역순)",
"Topics" => "토픽",
"Posts per day" => "일 당 게시물",
"Last post" => "최근 게시",
"Description length" => "설명 길이",
"Require reply to have a title" => "댓글에 제목 강요",
"Present an empty title input form and require it to be filled in before the forum post is submitted" => "비어있는 제목 상자를 표시하고 게시판 게시물을 제출하기 전에 채워지도록 요구",
// "Prevent Nesting of Quote wikiplugins when replying" => "Prevent Nesting of Quote wikiplugins when replying",
// "Strips quote plugin in reply in order to prevent nesting of quote plugins" => "Strips quote plugin in reply in order to prevent nesting of quote plugins",
"Forum post categories" => "게시판 게시물 범주들",
"Categories available in the category picker for forum posts" => "게시판 게시물에 대한 범주 선택기 내에 제공되는 범주들",
"Include category selector in forum list" => "게시판 목록에 범주 선택기 포함",
// "Allow inbound email posts from anyone" => "Allow inbound email posts from anyone",
// "Allow posts from non-users in forums using inbound posts from a specified email address" => "Allow posts from non-users in forums using inbound posts from a specified email address",
// "Parse HTML in inbound email posts" => "Parse HTML in inbound email posts",
// "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG" => "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG",
"Experimental" => "실험적",
// "Has problems with some HTML emails, especially those with table-based layouts" => "Has problems with some HTML emails, especially those with table-based layouts",
// "Strip wiki markup from outgoing forum emails" => "Strip wiki markup from outgoing forum emails",
// "Convert outgoing emails from forum posts to plain text" => "Convert outgoing emails from forum posts to plain text",
// "Send moderation email" => "Send moderation email",
// "Send email to forum moderators when post is queued" => "Send email to forum moderators when post is queued",
// "Approve link in moderation email" => "Approve link in moderation email",
// "Include a link for forum moderators to approve queue from email" => "Include a link for forum moderators to approve queue from email",
// "Do not start messages titles with 'Re:'" => "Do not start messages titles with 'Re:'",
"Don't display forum thread titles" => "게시판 대화목록에 대한 제목 숨김",
"Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display" => "대부분의 제목들은 변경되지 않은 상태로 남겨지며 그 이유는 이들이 부모 대화목록에 대한 직접적 댓글이기 때문입니다. 이 기능은 형식들과 표시 모두에서 제목을 숨기게 됩니다",
"Include a dropdown selector in the forum list to choose a category for the post" => "게시물의 범주를 선택하기 위하여 게시판 목록에 드롭목록 포함",
"Creation date (asc)" => "만든 일 (오름차순)",
"Topics (desc)" => "토픽 (내림차순)",
"Threads (desc)" => "쓰레드 (내림차순)",
"Latest post (desc)" => "마지막 게시 (내림차순)",
"Name (desc)" => "이름 (내림차순)",
"Name (asc)" => "이름 (오름차순)",
// "Href" => "Href",
"Object ID" => "개체 ID",
// "Comments locked" => "Comments locked",
"Multilingual tags" => "다국어 태그",
"Permits translation management of tags" => "태그의 번역 관리를 허용",
// "Ordering of tagged objects" => "Ordering of tagged objects",
// "Default sort mode for tagged items" => "Default sort mode for tagged items",
"Show tag cloud" => "태그 클라우드 표시",
// "Show the full tag cloud in the list-tags screen" => "Show the full tag cloud in the list-tags screen",
"Maximum number of tags in cloud" => "클라우드 내부의 태그의 최대 수",
// "tags" => "tags",
"Show tags in middle column" => "중간 열에 프리태그 보기",
// "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page." => "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page.",
"Preload random tag" => "프리태그 무작위 태그 사전로드",
// "A random tag will be selected on the tag search page (if no tag is pre-selected)." => "A random tag will be selected on the tag search page (if no tag is pre-selected).",
// "Tag Suggestions" => "Tag Suggestions",
"Number of tags to show in tag suggestions" => "태그 제안에서 표시할 태그의 수",
"Valid characters pattern" => "유효한 글자 패턴",
// "Click on the links below to set or clear a pattern to limit characters accepted in tags. " => "Click on the links below to set or clear a pattern to limit characters accepted in tags. ",
"Lowercase tags only" => "소문자 태그만 허용",
// "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly." => "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly.",
// "GD %0 detected" => "GD %0 detected",
// "GD not detected" => "GD not detected",
// "Imagick %0 detected" => "Imagick %0 detected",
// "Imagick 0 not detected" => "Imagick 0 not detected",
"Batch loading directory" => "디렉터리 일괄 로딩",
// "Needs to be a web-readable directory" => "Needs to be a web-readable directory",
"Display image information in a mouseover box" => "마우스오버 상자 내부에 그림 정보 표시",
// "Yes, and don't display that information under the image" => "Yes, and don't display that information under the image",
"Parent" => "부모",
"Uploaded image names must match regex" => "업로드된 그림명은 정규표현식에 일치해야만 합니다",
"Uploaded image names cannot match regex" => "업로드된 그림명이 정규표현식에 일치할 수 없었습니다",
"Directory path" => "디렉토리 경로",
// "If you change this directory, move any images to the new directory either manually or using the 'Mover' below" => "If you change this directory, move any images to the new directory either manually or using the 'Mover' below",
// "Image processing library" => "Image processing library",
// "Imagick" => "Imagick",
"Generate password" => "비밀번호 생성",
"Display a button on the registration form to automatically generate a very secure password for the user." => "\"비밀번호 생성\" 선택사항을 등록 서식에 포함",
// "The generated password may not include any restrictions (such as minimum/maximum length" => "The generated password may not include any restrictions (such as minimum/maximum length",
// "Maps & Location Enabled" => "Maps & Location Enabled",
// "Provide controls to load map and location libraries" => "Provide controls to load map and location libraries",
"Geolocate wiki pages" => "위키 페이지를 지리적 위치 지정",
"Provide controls to indicate a geographic location of wiki pages in the edit form" => "기능성을 편집할 위키 페이지를 지리적 지정을 할 제어를 제공합니다",
"Geolocate articles" => "기사를 지리적위치 지정",
"Provide controls to indicate a geographic location in the article edit form" => "기능성을 편집할 기사를 지리적 지정을 할 제어를 제공합니다",
"Geolocate blog posts" => "블로그 게시물을 지리적 위치 지정",
"Provide controls to indicate a geographic location in the blog post edit form" => "기능성을 편집할 블로그 게시물을 지리적 지정을 할 제어를 제공합니다",
"Available tile layers on maps" => "지도 상에 사용가능한 타일 레이어",
"Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing" => "기본 오픈스트리트맵 타일을 구글이나 빙과 같은 다른 지도 서비스의 것으로 교체하는 것을 허용합니다",
// "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1" => "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1",
"Google Street View" => "구글 스트릿뷰",
"Open Google Street View in a new window to see the visible coordinates" => "표기되는 좌표를 보기위하여 구글 스트릿뷰를 창 내에서 열기",
// "Google Street View overlay" => "Google Street View overlay",
"This is not guaranteed to work" => "작동에 대한 보장이 없습니다",
"Always load OpenLayers" => "오픈레이어를 항상 로드",
"Load the OpenLayers library even if no map is explicitly included in the page" => "페이지 내부에 어떤 지도도 명백히 포함되어있지 않은 경우에도 오픈레이어 라이브러리를 로드",
// "Zoom level for the found location" => "Zoom level for the found location",
// "Zoom level when a searched-for location is found" => "Zoom level when a searched-for location is found",
// "Street" => "Street",
// "Town" => "Town",
// "Region" => "Region",
// "Continent" => "Continent",
// "OpenLayers version" => "OpenLayers version",
// "OpenLayers 2.x (for use up to at least 15.x)" => "OpenLayers 2.x (for use up to at least 15.x)",
// "OpenLayers 3+ (experimental)" => "OpenLayers 3+ (experimental)",
// "Bing Maps API Key" => "Bing Maps API Key",
// "Needed for Bing Map Layers" => "Needed for Bing Map Layers",
// "Nextzen Maps API Key" => "Nextzen Maps API Key",
// "Needed for Nextzen Map Layers" => "Needed for Nextzen Map Layers",
"Browser title" => "브라우저 제목",
// "Visible label in the browser's title bar on all pages. Also appears in search engine results" => "Visible label in the browser's title bar on all pages. Also appears in search engine results",
// "Fallback for tiki base URL" => "Fallback for tiki base URL",
// "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line" => "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line",
"Validate new user registrations by email" => "이메일로 새 사용자 등록 확인",
// "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses" => "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses",
"Wiki homepage" => "위키 홈페이지",
"The default home page of the wiki when no other page is specified. The page will be created if it does not already exist" => "지정된 페이지가 없을 때 위키를 위해 사용하게 될 방문 페이지. 이 페이지는 존재하지 않는다면 만들어질 것입니다",
"Use group homepages" => "그룹 홈페이지 사용",
"Users can be directed to different pages upon logging in, depending on their default group" => "사용자는 속한 기본 그룹에 따라 로그인 시 다른 페이지로 보내질 수 있습니다",
"Go to the group homepage only if logging in from the default homepage" => "기본 홈페이지에서 로그인했을 경우에만 그룹 홈페이지로 가기",
"Cache external pages" => "외부 페이지를 캐시",
"Cache external images" => "외부 그림을 캐시",
"Temporary directory" => "임시 디렉터리",
"Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory" => "티키는 이 디렉터리에 완전한 읽기 및 쓰기 접근을 요구합니다",
"Help URL" => "URL 도움말",
"The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki" => "기본 도움말 시스템이 완료되지 않았을 수 있습니다. 티키 문서화에 도움을 주십시오",
"Open external links in new window" => "새 창에서 외부링크 열기",
// "Open links to external sites in a new browser tab or window" => "Open links to external sites in a new browser tab or window",
// "Allow image lazy loading" => "Allow image lazy loading",
// "Allow that images are loaded in a lazy way" => "Allow that images are loaded in a lazy way",
"License page" => "라이센스 페이지",
// "The wiki page where the license information is written" => "The wiki page where the license information is written",
"Submit notice" => "알림 제출",
// "Text to appear when content is being submitted" => "Text to appear when content is being submitted",
"Full path to gdaltindex" => "gdaltindex 로의 전체 경로",
"Full path to ogr2ogr" => "ogr2ogr 로의 전체 경로",
"Map Zone" => "지도 영역",
"Always display modules to all groups" => "항상 모든 그룹에 모듈을 표기",
// "Any setting for the Groups parameter will be ignored and the module will be displayed to all users" => "Any setting for the Groups parameter will be ignored and the module will be displayed to all users",
"Hide anonymous-only modules from registered users" => "등록된 사용자들로부터 anonymous 전용 모듈을 숨깁니다",
// "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module" => "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module",
"Hide anonymous-only modules from Admins" => "관리자들로부터 anonymous 전용 모듈을 숨깁니다.",
"Maximum number of articles on the articles homepage" => "기사 홈페이지에 기사의 최대 크기",
// "The number of articles to show on each page of the Articles homepage" => "The number of articles to show on each page of the Articles homepage",
// "articles" => "articles",
"Site Ads and Banners Content" => "사이트 광고 및 배너 내용",
"Test" => "테스트",
"URL to go to when clicking on a username" => "사용자명을 클릭했을 때 이동해야 할 URL",
"Default" => "기본",
"Use %user% for login name and %userId% for userId)" => "로그인명에 %user% 및 사용자id에 %userId%  를 사용)",
"Forgot password" => "비밀번호 분실",
"Users can request a password reset. They will receive a link by email." => "사용자가 비밀번호 재설정을 요청할 수 있음. 이메일로 링크를 수신하게 됨",
// "Group theme" => "Group theme",
"Enable groups to each have their own visual theme." => "각가의 그룹은 자신만의 테마를 보유할 수 있습니다",
// "The displayed title of the website" => "The displayed title of the website",
"Subtitle" => "부제",
// "A short phrase that, for example, describes the site" => "A short phrase that, for example, describes the site",
"Maximum number of records in listings" => "목록내 레코드 갯수 상한",
// "records" => "records",
"Maximum number of versions" => "버전의 최대 수",
// "versions" => "versions",
"Users can register" => "사용자 등록가능",
"Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page." => "사용자 등록 허용",
// "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option" => "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option",
// "Yes, with \"deep MX\" search" => "Yes, with \"deep MX\" search",
"Require validation by Admin" => "관리자에 의한 확인 필수",
"The administrator will receive an email for each new user registration, and must validate the user before the user can log in." => "관리자가 각각의 새 사용자 등록에 대한 이메일을 받으며, 사용자가 로그인할 수 있기 전에 유효성을 확인해야만 합니다",
"Require passcode to register" => "등록 시 패스코드 필수",
"Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users." => "사용자는 등록하려면 코드를 입력해야만 합니다. 이 코드를 사용자에게 알려줘야만 합니다. 초대된 사용자에게만 등록을 제한할 때 사용하십시오.",
"Passcode" => "패스코드",
"Alphanumeric code required to complete the registration" => "등록을 완료하려면 알파벳숫자 코드가 필요함",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Registration page key" => "Registration page key",
// "Key required to be on included the URL to access the registration page (if not empty)" => "Key required to be on included the URL to access the registration page (if not empty)",
// "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue" => "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue",
"Use a tracker to collect more user information" => "트래커를 사용하여 추가 사용자 정보를 수집합니다",
"Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user." => "등록 절차의 일부로써 사용자가 작성을 마쳐야 할 트래커 (서식)을 표기합니다. 이 트래커를 사용하여 각 사용자에 대하여 추가 정보를 저장하십시오.",
"Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display" => "어떤 트래커와 항목을 표기할 것인지 선택하기 위하여 \"관리 그룹\" 페이지를 사용하십시오",
"Use tracker to collect more group information" => "추가 그룹 정보를 수집하기 위하여 트래커를 사용",
"Create a new group for each user" => "각 사용자에 대하여 새 그룹 만들기",
// "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level" => "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level",
"Synchronize Tiki groups with a directory" => "티키 그룹을 디렉터리와 동기화",
"Define the directory within the \"LDAP\" tab" => "\"LDAP\" 탭 내부의 디렉터리 정의",
"Synchronize Tiki users with a directory" => "티키 사용자를 디렉터리와 동기화",
"Remember me" => "비밀번호 기억",
"Duration" => "기간",
// "The length of time before the user will need to log in again" => "The length of time before the user will need to log in again",
"day" => "일",
"week" => "주",
"month" => "월",
"year" => "연",
// "Homepage Browser title" => "Homepage Browser title",
// "Customize Browser title for the custom homepage" => "Customize Browser title for the custom homepage",
"Use custom homepage" => "사용자 지정 홈페이지 사용",
"Use the top page of a Tiki feature or another homepage" => "티키 기능 홈페이지 혹은 다른 홈페이지를 사용",
// "This option will override the Use Tiki feature as homepage setting" => "This option will override the Use Tiki feature as homepage setting",
"Use the top page of a Tiki feature as the homepage" => "티키 기능을 홈페이지로써 사용",
"Select the Tiki feature to provide the site homepage. Only enabled features are listed" => "사이트 홈페이지로 사용할 티키 기능을 선택하십시오. 활성화된 기능만이 나열됩니다",
"Disable JavaScript" => "자바스크립트 사용 안 함",
"Disable JavaScript for the purpose of testing even if enabled in the browser" => "브라우저에서 허용을 하더라도 실험 목적으로 자바스크립 사용 안 함",
// "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly" => "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly",
// "Maximum rows per page" => "Maximum rows per page",
"Images per row" => "행 당 그림",
// "images" => "images",
// "Thumbnail width" => "Thumbnail width",
// "Thumbnail height" => "Thumbnail height",
// "Default scale size" => "Default scale size",
"Set blogs homepage first" => "블로그 홈페이지를 먼저 설정하십시오",
"Blog:" => "블로그:",
"Set Image gal homepage first" => "그림 갤러리 홈페이지를 먼저 설정하십시오",
"Set Forum homepage first" => "먼저 게시판 홈페이지 설정",
"Forum:" => "게시판:",
"Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "비밀번호가 암호화되어 있어서, 사용자에게 비밀번호가 무엇인지 말해주는 것은 가능하지 않습니다. 변경하는 것만이 가능합니다",
"Validate user's email server" => "사용자의 이메일 서버 확인",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
"The group name will be the same as the user's username" => "그룹은 사용자의 사용자명과 동일한 이름이 주어집니다",
// "After logging in, users will automatically be logged in again when they leave and return to the site" => "After logging in, users will automatically be logged in again when they leave and return to the site",
"User's choice" => "사용자의 선택",
"Google Maps API Key" => "구글 맵 API 키",
// "Needed for Street View or other advanced features" => "Needed for Street View or other advanced features",
"Default x for map center" => "맵 중앙에 대한 기본 x",
"Default y for map center" => "맵 중앙에 대한 기본 y ",
"Default zoom level" => "기본 확대 단계",
"whole earth" => "지구 전체",
"country size" => "국가 크기",
"city size" => "도시 크기",
"max zoom" => "최대 확대",
"Show map mode buttons in articles list" => "기사 목록에 맵 모드 버튼 표기",
"Show map mode buttons in page list" => "페이지 목록에 맵 모드 버튼 표기",
// "Goal, recognition and rewards" => "Goal, recognition and rewards",
// "A tool to set motivational goals to increase engagement on the site" => "A tool to set motivational goals to increase engagement on the site",
// "Reward badge tracker" => "Reward badge tracker",
// "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user" => "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user",
// "0 to disable" => "0 to disable",
// "Groups not eligible for goals" => "Groups not eligible for goals",
// "Groups that will not be on the eligible group list" => "Groups that will not be on the eligible group list",
// "H5P support" => "H5P support",
// "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content" => "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content",
// "Whitelist" => "Whitelist",
// "Allowed filetypes" => "Allowed filetypes",
// "H5P Tracker User" => "H5P Tracker User",
// "Store H5P results" => "Store H5P results",
// "H5P Developer Mode" => "H5P Developer Mode",
// "Use \"patched\" libraries" => "Use \"patched\" libraries",
// "Default Gallery" => "Default Gallery",
// "File gallery to create new H5P content in by default" => "File gallery to create new H5P content in by default",
// "Store user state" => "Store user state",
// "Allows users to resume at the point they last got to" => "Allows users to resume at the point they last got to",
// "Save Frequency" => "Save Frequency",
// "How often to update user data" => "How often to update user data",
// "Allows users to export H5P content" => "Allows users to export H5P content",
// "Hub Is Enabled" => "Hub Is Enabled",
// "Updates libraries from h5p.org" => "Updates libraries from h5p.org",
// "Site Key" => "Site Key",
// "H5P Site Key" => "H5P Site Key",
// "H5P UUID" => "H5P UUID",
// "H5P Unique ID" => "H5P Unique ID",
// "Content Type Updated" => "Content Type Updated",
"Last update" => "최종 갱신",
// "Check Requirements" => "Check Requirements",
// "Unused so far" => "Unused so far",
// "Send Usage Statistics" => "Send Usage Statistics",
// "Request User Consent" => "Request User Consent",
// "LRS Content Types" => "LRS Content Types",
// "Reporting (?)" => "Reporting (?)",
"HHeader shadow div start" => "헤더 그림자 시작",
"Header shadow div end" => "헤더 그림자 끝",
"Custom CSS" => "사용자 지정 CSS",
// "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n" => "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n",
"Custom JavaScript" => "사용자 지정 자바스크립트",
"Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages" => "모든 페이지 내부에 인라인 자바스크립트의 사용자 지정 블럭을 포함합니다",
// "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page" => "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page",
// "Do not include the < script > tags" => "Do not include the < script > tags",
// "Custom Less" => "Custom Less",
// "Compiles a new version of the currently selected theme and option using definitions declared here" => "Compiles a new version of the currently selected theme and option using definitions declared here",
// "Custom Less (CSS precompiler) - no longer used" => "Custom Less (CSS precompiler) - no longer used",
// "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon.." => "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon..",
"Highlight group" => "그룹 강조",
"Home blog (main blog)" => "홈 블로그（주 블로그）",
"Home forum (main forum)" => "홈 게시판（주 게시판）",
"Home file gallery (main file gallery)" => "홈 파일 갤러리 (주 파일 갤러리)",
// "Select the default file gallery" => "Select the default file gallery",
"Home gallery (main gallery)" => "홈 갤러리(주 갤러리)",
"No image gallery available (create one first)" => "제공되는 그림 갤러리 없음 (하나 먼저 만드십시오)",
"No file gallery available (create one first)" => "제공되는 파일 갤러리 없음 (한 개 먼저 만드십시오)",
"No blog available (create one first)" => "제공되는 블로그 없음 (한 개를 먼저 만드십시오)",
"HTTP port" => "HTTP 포트",
"The port used to access this server; if not specified, port 80 will be used" => "이 서버에 접근하기 위해 사용된 포트, 비어있을 경우 80 포트를 사용할 것입니다",
"If not specified, port 80 will be used" => "비어둘 경우, 80 포트가 사용됩니다",
// "HTTP lookup: skip framesets" => "HTTP lookup: skip framesets",
"When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "외부 소스로의 HTTP 요청을 수행할 때, 결과가 프레임셋인지를 확인하고 실제 컨텐츠를 제공하기 위하여 추론(heuristic)을 사용",
"Registration referrer check" => "등록 참조자 확인",
"Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "등록 POST가 동일한 호스트에서 벌송되었는지 확인하기 위하여 HTTP 참조자를 사용 (일부 설정에서 동작하지 않을 수 있음)",
// "HTTP header x-frame options" => "HTTP header x-frame options",
// "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt" => "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt",
// "Header value" => "Header value",
// "DENY" => "DENY",
// "SAMEORIGIN" => "SAMEORIGIN",
// "HTTP header x-xss-protection" => "HTTP header x-xss-protection",
// "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers" => "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers",
"0" => " does not exist",
// "1;mode=block" => "1;mode=block",
// "HTTP header x-content-type-options" => "HTTP header x-content-type-options",
// "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed" => "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed",
// "HTTP header content-security-policy" => "HTTP header content-security-policy",
// "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page" => "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page",
// "HTTP header strict-transport-security" => "HTTP header strict-transport-security",
// "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP" => "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP",
// "HTTP header public-key-pins" => "HTTP header public-key-pins",
// "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it" => "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it",
"HTTPS for user-specific links" => "사용자 특정 링크를 구축할 때 HTTPS 사용",
// "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "HTTPS 포트",
"the HTTPS port for this server" => "이 서버에 대한 HTTPS 포트. 기본=443",
"Use HTTPS login" => "HTTPS 로그인 사용",
"Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server." => "SSL 상에서 자격증명 인증을 전송하는 것을 허용하여 보안을 향상. 자격 증명은 서버에 반드시 설정되어 있어야 함.",
"Allow secure (HTTPS) login" => "안전 로그인 (https)  허용",
"Encourage secure (HTTPS) login" => "보안 (https) 로그인 권장",
"Consider we are always in HTTPS, but do not check" => "저희는 항상 HTTPS 로 되어있지만 확인하지는 않는다는 점을 고려하십시오",
"Require secure (HTTPS) login" => "보안 로그인 (https)을 요청",
"Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible" => "연결을 설정하고 테스트 하기 전까지는 HTTPS 를 요구하지 마십시오, 자칫 사이트로의 접속이 불가능하게 될 수 있습니다",
// "Enable intrusion detection system" => "Enable intrusion detection system",
// "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations" => "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations",
// "Intrusion detection system mode" => "Intrusion detection system mode",
// "Define IDS operation mode, log only, or log and block with impact over a given threshold" => "Define IDS operation mode, log only, or log and block with impact over a given threshold",
// "Log only" => "Log only",
// "Log and block requests" => "Log and block requests",
// "Intrusion detection system threshold" => "Intrusion detection system threshold",
// "Define IDS threshold, when configured in \"Log and block requests\" more" => "Define IDS threshold, when configured in \"Log and block requests\" more",
// "Custom rules file" => "Custom rules file",
// "Log to file" => "Log to file",
// "Log to database" => "Log to database",
// "Default for img-fluid class used in the IMG plugin" => "Default for img-fluid class used in the IMG plugin",
// "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden" => "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden",
// "Errors log file" => "Errors log file",
// "location, from your tiki root dir, where you want the error log file stored" => "location, from your tiki root dir, where you want the error log file stored",
// "Access log file" => "Access log file",
// "location, from your tiki root dir, where you want the access log file stored" => "location, from your tiki root dir, where you want the access log file stored",
"IP can be checked" => "IP 는 확인될 수 있습니다",
"Check anonymous votes by user's IP" => "사용자의 IP로 익명 투표 검사",
"Use CDN for JavaScript" => "자바스크립트에 CDN 사용",
"Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)." => "컨텐츠 전송망을 통하여 jQuery 및 jQuery UI 라이브러리 취득.",
// "Google" => "Google",
// "jQuery" => "jQuery",
// "Assume JavaScript is enabled even if not supported" => "Assume JavaScript is enabled even if not supported",
// "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter" => "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter",
"Slide" => "슬라이드",
"Fade" => "페이드",
"Blind (UI)" => "블라인드 (UI)",
"Clip (UI)" => "클립 (UI)",
"Drop (UI)" => "드롭 (UI)",
"Explode (UI)" => "폭발 (UI)",
"Fold (UI)" => "접기 (UI)",
// "Puff (UI)" => "Puff (UI)",
"Slide (UI)" => "슬라이드 (UI)",
"Effect for modules" => "모듈에 대한 효과",
"Effect for tabs" => "탭에 대한 효과",
"Speed" => "속도",
"Fast" => "빠름",
"Normal" => "보통",
"Slow" => "느림",
"Direction" => "방향",
"Vertical" => "수직",
"Horizontal" => "수평",
"Left" => "좌측",
"Right" => "우측",
"Up" => "위로",
"Down" => "아래로",
// "jQuery-UI Chosen Select Boxes" => "jQuery-UI Chosen Select Boxes",
// "Styled replacement for dropdown select lists and multiple-select inputs" => "Styled replacement for dropdown select lists and multiple-select inputs",
// "Sortable Chosen Multi-selects" => "Sortable Chosen Multi-selects",
// "Enable drag and drop re-ordering of Chosen multi-select options" => "Enable drag and drop re-ordering of Chosen multi-select options",
// "Visual style of Colorbox (a.k.a. \"Shadowbox\")" => "Visual style of Colorbox (a.k.a. \"Shadowbox\")",
"One" => "하나",
"Two" => "둘",
"Three" => "3",
// "Four" => "Four",
// "Five" => "Five",
// "FitVids.js" => "FitVids.js",
// "jQuery plugin for fluid-width (responsive) embedded videos" => "jQuery plugin for fluid-width (responsive) embedded videos",
// "jQuery Timeago" => "jQuery Timeago",
// "jQuery plugin for fuzzy timestamps" => "jQuery plugin for fuzzy timestamps",
// "SmartMenus" => "SmartMenus",
// "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more" => "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more",
// "SmartMenus Mode" => "SmartMenus Mode",
"Blue" => "파랑",
// "Clean" => "Clean",
// "Mint" => "Mint",
"Simple" => "단순",
// "Draggable Modals" => "Draggable Modals",
// "Modal popups can be moved around" => "Modal popups can be moved around",
// "Resizable Modals" => "Resizable Modals",
// "Modal popups can be resized" => "Modal popups can be resized",
// "jQuery Double Scroll" => "jQuery Double Scroll",
// "jQuery plugin which adds an extra horizontal scroll bar at the top" => "jQuery plugin which adds an extra horizontal scroll bar at the top",
"Partner ID" => "파트너 ID",
"Kaltura Partner ID" => "Kaltura 파트너 ID",
"User secret" => "사용자 비밀",
"Kaltura partner-setting user secret" => "칼투라 파트너 설정 사용자 비밀",
"Admin secret" => "비밀 관리",
"Kaltura partner-setting admin secret" => "칼투라 파트너 설정 관리 비밀",
// "Kaltura video player ID" => "Kaltura video player ID",
"Kaltura Dynamic Player (KDP) user interface configuration ID" => "칼투라 유동적 재생기 (KDP) 사용자 인터페이스 구성 ID",
// "Kaltura video player ID (in entry edit mode)" => "Kaltura video player ID (in entry edit mode)",
"Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail" => "편집시 사용될 칼투라 동적 재생기 (Kaltura Dynamic Player, KDP) 사용자 인터페이스 구성 ID. 동영상 축소보기를 선택할 선택사항 또한 보유하는 재생기를 사용할 수 있습니다",
// "KCW UI configuration ID" => "KCW UI configuration ID",
"Kaltura Configuration Wizard (KCW) user interface configuration ID" => "칼투라 구성 마법사 (KCW) 사용자 인터페이스 구성 ID",
// "Kaltura service URL" => "Kaltura service URL",
// "for example, https://www.kaltura.com/" => "for example, https://www.kaltura.com/",
"Show remixes from old versions of Kaltura" => "칼투라의 구 버전에서의 리믹스 표시",
"Show remixes from old versions of Kaltura (remixing is no longer supported)" => "칼투라의 구버전에서의 리믹스 표시 (리믹싱은 더 이상 지원되지 않습니다)",
// "Keep versions for" => "Keep versions for",
"Do not delete versions younger than this number of days" => "절대 (? 일) 보다 어린 버전을 삭제하지 않습니다. 기본=1",
"Use database for translation" => "번역에 데이터베이스 사용",
"Use the database to store the translated strings and allow using interactive translation" => "번역된 문자열을 저장하기 위하여 데이터베이스 사용 및 대화형 번역의 사용을 허용",
// "Edit, export and import languages" => "Edit, export and import languages",
// "Manage contribution of translated strings" => "Manage contribution of translated strings",
// "Offers to set whether each translated string should be contributed to the Tiki community or kept locally" => "Offers to set whether each translated string should be contributed to the Tiki community or kept locally",
"Machine translation implementation" => "기계 번역 구현",
"Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required" => "기계 번역에 대한 대체 구현들 사이에서 선택하십시오. 구현에 따라, 다른 API 키가 필요할 수 있습니다",
"Google Translate" => "구글 번역",
"Bing Translate" => "빙 번역",
"Enable machine translation of wiki pages" => "위키 페이지 상의 기계 번역 사용",
"Makes additional languages available to the list of languages on the page" => "추가 언어를 페이지의 언어의 목록에서 사용가능하도록 만듭니다",
"Google Translate API Key" => "구글 번역 API 키",
"The key must be generated from the Google console. Choose to create a server key" => "키는 반드시 구글 콘솔에서 생성되어야만 합니다. 서버 키를 만들기를 선택하십시오",
"Bing Translate Client ID" => "빙 번역 클라이언트 ID",
"The application must be registered" => "응용프로그램은 반드시 등록되어야 함",
"Bing Translate Client Secret" => "빙 번역 클라이언트 비밀",
// "Display available translations as dropdown" => "Display available translations as dropdown",
// "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list" => "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list",
"Default language" => "기본 언어",
"The site language is used when no other language is specified by the user" => "사용자에 의하여 지정된 다른 언어가 없을 때 사용될 사이트 언어",
// "Default admin language" => "Default admin language",
// "The site language is used in admin section when no other language is specified by the user" => "The site language is used in admin section when no other language is specified by the user",
"Language inclusion threshold" => "언어 포함 임계값",
"When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "언어의 수가 사이트에서 제한되었을 때 이 숫자 미만일 때, 모든 언어는 사용자에 의하여 지정되지 않은 경우에도 선호 언어 목록에 추가될 것입니다, 하지만, 우선 순위는 지정된 언어에 주어질 것입니다",
// "languages" => "languages",
"Layout width" => "레이아웃 너비",
"The width of the content area of the site, centered in the browser window" => "사이트 표시 넓이를 제한함 (기본: 990px)",
"for example, 960px" => "예: 800px",
"Tabs optional" => "탭 선택사항",
"Users can choose not to have tabs. A <b>no tabs</b> button will be displayed" => "사용자는 탭 사용 여부를 선택할 수 있습니다",
"Add group CSS info" => "그룹 CSS 정보 추가",
"Add CSS classes to the page BODY tag based on the user's group membership" => "그룹 멤버십을 나타내기 위하여 페이지 BODY 태그에 클래스 추가",
"Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "grp_Anonymous 혹은 grp_Registered 중 하나 그리고 가능하다면 grp_Admins 역시",
// "If this option is disabled, this user wouldn’t be able to log in" => "If this option is disabled, this user wouldn’t be able to log in",
"Create the user" => "사용자 만들기",
"Deny access" => "접근 거부",
"Create user if not in LDAP" => "LDAP에 없다면 사용자 만들기",
// "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user" => "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user",
// "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”" => "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”",
"Maximum average server load threshold in the last minute" => "마지막 분 안쪽의 최대 평균 서버 로드 임계값",
// "Lock Content Templates" => "Lock Content Templates",
// "Enable users to lock content templates and so prevent others from editing them" => "Enable users to lock content templates and so prevent others from editing them",
// "Lock Wiki Structures" => "Lock Wiki Structures",
// "Enable users to lock wiki structures and so prevent others from editing them" => "Enable users to lock wiki structures and so prevent others from editing them",
"Log mail in Tiki logs" => "티키 로그에 메일 기록",
"A line of type mail will be included in the System Log with the destination address and subject of each email sent" => "티키 로그에 메일 기록",
"Smarty template usage indicator" => "Smarty 템플릿 사용량 표시기",
"Add HTML comment at start and end of each Smarty template (.tpl file)" => "각자 Smarty 템플릿 (TPL) 시작과 끝에 HTML 댓글을 추가",
"Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source." => "개발용으로만 사용, 경고가 이메일에도 추가가 되고, 사용자에게도 보이게 됨으로 업무환경에서는 사용하지 않음",
"You need to clear your Tiki template cache for this change to take effect" => "이 변경내역이 영향을 미치려면 티키 템플릿 캐시를 제거해야합니다",
"Log SQL" => "SQL 로그",
"All SQL queries will be registered in the database in the adodb_logsql table. " => "SQL 질의를 로그",
// "Do not enable this feature all the time. It can be very resource intensive and will impact performance" => "Do not enable this feature all the time. It can be very resource intensive and will impact performance",
"Log queries using more than" => "몇 초 이상 소요되는 질의를 기록",
"Use to log only queries that exceed a specific amount of time" => "이는 성능에 영향을 미칠 수 있습니다",
"Use email as username" => "사용자명으로 이메일 사용",
"Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field" => "새 사용자명을 만드는 대신, 사용자의 이메일 주소를 인증으로 사용합니다",
"Obscure email when using email as username" => "유저명으로 이메일 사용 시 이메일을 모호하게 함 (보호는 완벽하지 않음)",
// "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead" => "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead",
// "Coverage will not be complete" => "Coverage will not be complete",
// "User can login via username or email" => "User can login via username or email",
// "This will allow users to login using their email (as well as their username)" => "This will allow users to login using their email (as well as their username)",
// "Auto-generate 6-digit username on registration" => "Auto-generate 6-digit username on registration",
// "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)" => "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)",
"HTTP Basic Authentication" => "HTTP 기본 인증",
"Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials." => "HTTP 기본 인증의 자격 증명을 확인, 웹서비스로 하여금 자격증명을 사용하는 것을 허용하는데 유용함.",
"SSL Only (Recommended)" => "SSL 만 (추천)",
"Prevent multiple log-ins by the same user" => "동일한 사용자로부터 다중 로그인 금지",
"Users (other than admin) cannot log in simultaneously with multiple browsers" => "사용자는 여러 개의 브라우저에서 동시에 로그인할 수 없습니다. 관리 계정이 여전히 허용됩니다",
// "Grab session if already logged in" => "Grab session if already logged in",
// "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out" => "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out",
// "Enable autologin from remote Tiki" => "Enable autologin from remote Tiki",
// "Used with autologin_remotetiki in the redirect plugin" => "Used with autologin_remotetiki in the redirect plugin",
// "System username to use to initiate autologin from remote Tiki" => "System username to use to initiate autologin from remote Tiki",
// "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin" => "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin",
// "System groupname to use for auto login token" => "System groupname to use for auto login token",
// "For security, please create a group that has no users and no permissions and specify its name here" => "For security, please create a group that has no users and no permissions and specify its name here",
// "Create a new user account if the user that is trying to autologin does not exist on this Tiki" => "Create a new user account if the user that is trying to autologin does not exist on this Tiki",
// "Allowed groups from remote Tiki to autologin" => "Allowed groups from remote Tiki to autologin",
// "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone" => "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone",
// "Sync these groups from remote Tiki on autologin" => "Sync these groups from remote Tiki on autologin",
// "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly" => "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly",
// "Automatically logout remote Tiki after logout" => "Automatically logout remote Tiki after logout",
// "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well" => "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well",
// "Redirect direct logins to this site to remote Tiki" => "Redirect direct logins to this site to remote Tiki",
// "URL of autologin page on remote Tiki to redirect user to login" => "URL of autologin page on remote Tiki to redirect user to login",
// "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin" => "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin",
"Long date format" => "긴 날짜 형식",
// "Specify how Tiki displays the date (longer version)" => "Specify how Tiki displays the date (longer version)",
"Long time format" => "긴 시각 형식",
// "Specify how Tiki displays the time (longer version)" => "Specify how Tiki displays the time (longer version)",
"%A %d of %B, %Y" => "%Y년%m월%d일 %A",
// "%H:%M:%S %Z" => "%H:%M:%S %Z",
"%A %d of %B, %Y %H:%M:%S %Z" => "%Y %B %A %d,  %H:%M:%S %Z",
"Force lowercase" => "소문자 강제 적용",
// "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>" => "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>",
// "Email newline character(s)" => "Email newline character(s)",
// "End-of-line (EOL) character used in outgoing emails" => "End-of-line (EOL) character used in outgoing emails",
"CRLF (standard)" => "CRLF (표준)",
"LF (some Unix MTA)" => "LF (몇몇 Unix MTA)",
// "Text string used to customise mail templates" => "Text string used to customise mail templates",
// "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files" => "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files",
"Main shadow start" => "주 음영 시작",
"Main shadow end" => "주 음영 끝",
"Maximum length" => "최대 길이",
// "The greatest number of characters for a valid username" => "The greatest number of characters for a valid username",
"Memcache" => "멤캐시",
"Enable connection to memcached servers to store temporary information" => "임시 정보를 저장히기 위하여 맴캐시 서버로 연결 활성화",
"Requires the PHP memcache extension" => "PHP 멤캐시 확장기능 필요",
"Memcache servers" => "멤캐시 서버",
"Server list which may be accessed. For each server, the address, port and weight must be specified" => "접근이 될 수 있는 서버 목록. 각각의 서버에 대하여 주소, 포트 및 가중치가 반드시 지정되어야만 합니다",
// "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"" => "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"",
"Memcache key prefix" => "멤캐시 키 접두어",
"When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts" => "맴캐시 클러스터가 여러 개의 응용프로그램에 의하여 사용될 때, 그들의 각각에 대하여 고유 접두어를 사용하는 것이 충돌을 피하는 것을 돕습니다",
"Memcache expiration" => "멤캐시 만기",
"Duration for which the data will be kept" => "데이터가 보관될 기간",
"Cache wiki data in memcache" => "멤캐시 내부에서 위키데이터 캐시",
"Cache wiki output in memcache" => "멤캐시에서 위키 출력물 캐시",
"Cache forum output in memcache" => "멤캐시 내부에서 게시판 출력 캐시",
"Menu icons" => "메뉴 아이콘",
// "Allows icons to be defined for menu entries" => "Allows icons to be defined for menu entries",
"Default path for the icons" => "아이콘에 대한 기본 경로",
// "Edit menu icon" => "Edit menu icon",
// "Adds an icon on the navbar to edit menu entries" => "Adds an icon on the navbar to edit menu entries",
// "Maximum mailbox size" => "Maximum mailbox size",
// "Maximum number of messages allowed in the mailbox" => "Maximum number of messages allowed in the mailbox",
"messages" => "메시지들",
// "Maximum mail archive size" => "Maximum mail archive size",
// "Maximum number of archive messages allowed" => "Maximum number of archive messages allowed",
// "Maximum sent box size" => "Maximum sent box size",
// "Maximum number of sent messages allowed in the mailbox" => "Maximum number of sent messages allowed in the mailbox",
// "Truncate internal message notification" => "Truncate internal message notification",
// "Number of characters to show in the message notification sent through email, with a link to read the full internal message" => "Number of characters to show in the message notification sent through email, with a link to read the full internal message",
"Keywords" => "키워드",
"A list of keywords (separated by commas) that describe this website" => "귀하의 사이트를 설명하는 키워드의 목록 (쉼표로 구분)",
"Include tags" => "프리태그 포함",
"If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags" => "프리태그 기능이 활성화된 경우, 프리태그 세트가 있는 각 페이지에 대한 메타 키워드 안에서 프리태그를 사용합니다. 이는 사이트 상의 개별 페이지가 다른 메타 태그를 지닐 수 있게 합니다",
"Use thread title instead" => "쓰레드 제목을 대신 사용",
"Use the forum thread title in the meta title tag" => "메타 제목 태크 안에서 게시판 대화상자 제목 사용",
"Use the image title instead" => "그림 제목을 대신 사용",
"Use the image title in the meta title tag" => "메타 제목 태그 내부에 그림 제목 사용",
"A short description of the website. Some search engines display this information with the website's listing" => "귀하의 사이트에 대한 간략한 설명. 어떤 검색 엔진은 이 정보를 귀하의사이트 나열시 함께 표시합니다",
"Page description" => "페이지 설명",
"Use each page description as a meta tag for that page" => "개별 페이지 설명을 페이지에 대한 메타 태그로써 사용",
"Author" => "저자",
"The author of this website. Typically this is the Admin or Webmaster" => "귀하의 사이트의 저자. 보통 관리자 혹은 웹마스터가 됩니다.",
// "geo.position" => "geo.position",
"The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "사이트의 물리적 위치의 경도와 위도. 예를 들면, \"38.898748, -77.037684\"",
// "geo.region" => "geo.region",
"The ISO-3166 country and region codes for your location. For example, \"US-NY\"" => "귀하의 위치에 대한 ISO-3166 국가 및 지역 코드. 예를 들면, \"US-NY\"",
// "geo.placename" => "geo.placename",
"A free-text description of your location" => "귀하의 위치의 자유 텍스트 설명",
"Meta robots" => "메타 로봇",
// "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca" => "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca",
// "Should be comma separated eg. noimageindex, nocache" => "Should be comma separated eg. noimageindex, nocache",
"Revisit after" => "다음 이 후 재 방문",
// "Specify how often (in days) Web robots should visit your site" => "Specify how often (in days) Web robots should visit your site",
"Middle shadow div start" => "중간 음영 시작",
"Middle shadow div end" => "중간 음역 끝",
"Minimum length" => "최소 길이",
// "The least possible number of characters for a valid username" => "The least possible number of characters for a valid username",
// "The least possible number of characters for a valid password" => "The least possible number of characters for a valid password",
"Mobile access" => "모바일 접근",
// "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)" => "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)",
// "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)" => "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)",
"Mobile Perspectives" => "모바일 Perspective",
"Top module zone" => "위쪽 모듈 영역",
// "Activate zone for modules such as site logo, log-in form, etc. (page header)" => "Activate zone for modules such as site logo, log-in form, etc. (page header)",
"Topbar module zone" => "Topbar 모듈 영역",
// "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc" => "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc",
"topbar" => "TopBar",
"Page top module zone" => "페이지 상단 모듈 영역",
// "Activate zone for modules such as breadcrumbs, banners, share icons, etc" => "Activate zone for modules such as breadcrumbs, banners, share icons, etc",
"Bottom module zone" => "하단 모듈 영역",
// "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)" => "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)",
"Page bottom module zone" => "페이지 하단 모듈 영역",
// "Activate zone for modules at the bottom of the main column of each page" => "Activate zone for modules at the bottom of the main column of each page",
"Module file" => "모듈 파일",
"Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles" => "유동적 값에 의존하는 대신 정적 모듈 정의 파일을 사용",
"Extra module zones available" => "추가 모듈 구역 사용가능함",
"Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones" => "모듈 관리 인터페이스를 통하여 관리될 추가 모듈 구역. 귀하의 사용자 지정형 테마가 사전정의된 것들 외의 특별 구역을 필요로 하는 경우 유용합니다",
"Comma-separated list, maximum of 20 characters per entry" => "쉼표로 구분된 목록, 항목당 최대 20글자",
// "Allow users to control the notifications they receive based on content changes" => "Allow users to control the notifications they receive based on content changes",
// "Notification digests" => "Notification digests",
// "Enable digest notifications (requires a cron job)" => "Enable digest notifications (requires a cron job)",
// "Clear individual notifications" => "Clear individual notifications",
// "Allow users to selectively clear notifications instead of simply having a clear-all button" => "Allow users to selectively clear notifications instead of simply having a clear-all button",
// "Notification count refresh interval" => "Notification count refresh interval",
// "Show unread notification count and refresh every [x] seconds" => "Show unread notification count and refresh every [x] seconds",
// "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds" => "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds",
// "Notification reply-to email pattern" => "Notification reply-to email pattern",
// "Email model to use for the notification email reply-to address" => "Email model to use for the notification email reply-to address",
// "noreply+PLACEHOLDER@example.com" => "noreply+PLACEHOLDER@example.com",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order" => "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order",
"Minimum number of tags in common" => "공용인 태그의 최소 수",
// "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature" => "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature",
"Multi-domain" => "다중 도메인",
"Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation" => "도메인명을 퍼스펙티브로 매핑하고 동일한 인스턴스 상에 호스트된 멀티도메인을 시뮬레이트하는 것을 허용합니다",
"Multi-domain Configuration" => "멀티 도메인 구성",
"Comma-separated values mapping the domain name to the perspective ID" => "퍼스펙티브 ID의 도메인명을 매핑하는 쉼표로 구분된 값들",
"One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1" => "한 줄 당 한 도메인. 퍼스펙티브ID와 함께 쉼표로 분리됨. 예: tiki.org,1",
"Switch domain when switching perspective" => "perspective 변경 시 도메인 변경",
"Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work" => "다른 도메인은 다른 로그인 세션을 가져야하고, 서브도메인의 경우에도, 이것이 작동하려면 세션 쿠키에 대한 이해를 하고 계셔야 합니다",
// "Must read" => "Must read",
// "Allow assignment of mandatory readings and track progress" => "Allow assignment of mandatory readings and track progress",
// "Must read tracker" => "Must read tracker",
// "Tracker containing the individual read requests" => "Tracker containing the individual read requests",
"Namespace" => "네임스페이스",
"Enable namespaces feature for wiki pages" => "위키 페이지에 대한 네임스페이스 활성화",
"Namespace separator" => "네임스페이스 분리자",
// "Select the character, symbol, or text to use as the namespace separator" => "Select the character, symbol, or text to use as the namespace separator",
"Default namespace" => "기본 네임스페이스",
"Namespace to use when creating wiki pages. Should be defined within perspectives" => "위키 페이지 만들 때 사용할 네임스페이스. Perspective 내부에 정의되어 있어야함",
"Hide namespace indicator in structure path" => "구조체 경로 내부에서 네임스페이스 지정자 감춤",
// "Hide namespace indicator in page title" => "Hide namespace indicator in page title",
// "Force all non-namespace page links to the same namespace" => "Force all non-namespace page links to the same namespace",
// "If the current page is in a namespace, all links without a namespace will have it added automatically" => "If the current page is in a namespace, all links without a namespace will have it added automatically",
"Throttle newsletter send rate" => "회보 송신 속도 제한",
"Pause for a given amount of seconds before each batch to avoid overloading the mail server." => "메일 서버의 과부하를 피하기 위하여 각 일괄작업 전에 주어진 초 만큼 대기",
"Newsletter pause length" => "회보 일시 중지 길이",
"Number of seconds delay before each batch" => "각 일괄작업 전에 대기할 초의 수",
"Newsletter batch size" => "회보 일괄처리 크기",
// "Number of emails to send in each batch" => "Number of emails to send in each batch",
// "emails" => "emails",
"Allow sending newsletters through external clients" => "외부 클라이언트를 통한 회보 전송을 허용",
"Generate mailto links using the recipients as the BCC list" => "수신자를 숨은 참조 목록으로 사용하여 mailto 링크 생성",
"This will expose the list if email addresses to all users allowed to send newsletters" => "이는 만약 모든 사용자의 이메일 주소가 회보를 보내도록 허용되었다면 목록을 노출할 것입니다",
"Use relative (next / previous) pagination links" => "상대적 (다음/이전) 페이지 매김 링크 사용",
// "Encryption key for OAuthServer" => "Encryption key for OAuthServer",
// "A key used to encrypt/decrypt authorization codes" => "A key used to encrypt/decrypt authorization codes",
"PGP/MIME encrypted email messaging" => "PGP/MIME 로 암호화된 이메일 메시징",
"Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses" => "OpenPGP PGP/MIME 에 준하는 암호화 이메일 메시징 사용 (기본은 'n\\",
"Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on" => "gpg, keyring, 및 tikiaccounts 가 PGP/MIME 기능성에 대하여 적절히 구성되었을 경우에만 사용. 주의: 모든 계정이 자신의 공용-키가 gnupg-keyring 안으로 구성됨이 필수이므로 이 기능이 켜져있는 경우 사이트를 향한 관리가 되지 않은 등록은 허용하지 마십시오 (혹은 예를 들어. 회보에 대하여 구성되지 않은 이메일 등등)",
"Path to gnupg keyring" => "gnupg keyring으로의 경로",
"Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\" => "gnupg keyring 으로의 전체 디렉터리 경로 (기본 /home/www/.gnupg/ ). 디렉터리, 관련 하위디렉터리 (예: 하위디렉터리 'signer\\",
"Path to gpg executable" => "gpg 실행파일로의 경로",
"Full path to gpg executable" => "gpg 실행파일로의 전체 경로 (기본 /usr/bin/gpg )",
// "Read signer pass phrase from prefs or from a file" => "Read signer pass phrase from prefs or from a file",
// "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\" => "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\",
"preferences" => "기본설정",
"file" => "파일",
// "Signer pass phrase" => "Signer pass phrase",
// "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file" => "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file",
// "leave empty if read from file" => "leave empty if read from file",
// "Path to signer pass phrase filename" => "Path to signer pass phrase filename",
// "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file" => "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file",
"Wiki buttons" => "위키 버튼",
"Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)" => "페이지 설명, 아이콘, 백링크, ..",
"Top " => "상위",
"Bottom" => "아래쪽",
"Neither" => "둘 다 아님",
// "Pages can reoccur in structure" => "Pages can reoccur in structure",
"A page can be listed multiple times in a structure" => "한 페이지는 한 구조체에서 여러번 발생할 수 있습니다",
// "Fetch page content from incoming feeds" => "Fetch page content from incoming feeds",
// "Page content from the source will be fetched before sending the content to the generators" => "Page content from the source will be fetched before sending the content to the generators",
// "if set, will display 'first' and 'last' links on pages" => "if set, will display 'first' and 'last' links on pages",
"Display \"fast-forward\" links" => "빨리 넘기기 링크 표시",
"Display \"fast-forward\" links (to advance 10 percent of the total number of pages) " => "빨리 넘기기 표시 (총 페이지 수의 10% 씩)",
"Hide pagination when there is only one page" => "한 페이지만 있을 경우 페이지 매김 숨김",
"Don't display pagination on single pages." => "한 개 페이지에서 페이지 매김 감춤",
"Use Icons" => "아이콘 사용",
"Display 'First' and 'Last' links" => "'첫번째'와 '마지막' 링크들을 표시",
"Require characters and numerals" => "알파벳과 숫자를 요구",
"For improved security, require users to include a mix of alphabetical characters and numerals in passwords." => "보안 향상을 위해, 사용자로 하여금 비밀번호에 글자와 숫자의 조합을 포함할 것을 요구함",
// "Password file used" => "Password file used",
// "The automatically selected file is recommended unless you generate your own blacklist file" => "The automatically selected file is recommended unless you generate your own blacklist file",
// "Prevent common passwords" => "Prevent common passwords",
// "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist" => "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist",
"Password expires after" => "다음 기간 후 비밀번호 만료",
// "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in" => "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in",
"Require alphabetical characters in lower and upper case" => "알파벳 대문자와 소문자 요구",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords" => "비밀번호는 a 와 같은 소문자와 A 와 같은 대문자를 반드시 최소 한 개씩 포함해야만 함",
"Require special characters" => "특수 캐릭터 요구",
"Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords" => "비밀번호는 최소 다음과 같은 특수 문자를 포함해야합니다 \" / \$ % ? & * ( ) _ + ...",
"Require no consecutive repetition of the same character" => "동일한 캐릭터의 연속 반복을 금지",
"Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"." => "비밀번호는 111 이나 aab 처럼 동일한 글자가 연속으로 반복되는 것을 포함하지 말아야 함..",
"The password must be different from the user's log-in name" => "비밀번호는 사용자 로그인과 달라야만 함",
"Payment" => "지불",
"Feature for tracking and managing payment requests" => "지불 요청을 관리하고 추척하는 기능",
// "Payment system" => "Payment system",
"Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "현재 페이팔과 Cclite (개발 중) 혹은 티키 사용자 신용간의 선택",
"PayPal: see PayPal.com - Cclite: Community currency" => "페이팔: PayPal.com - Cclite: 커뮤니티 통화를 참조하십시오",
"PayPal" => "페이팔",
// "Israel Post Payment Module" => "Israel Post Payment Module",
// "Cclite" => "Cclite",
"Tiki User Credits" => "티키 사용자 크레딧",
// "PayPal ID" => "PayPal ID",
// "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type" => "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type",
// "Primary email of your PayPal account (Personal or Business)" => "Primary email of your PayPal account (Personal or Business)",
// "PayPal business password" => "PayPal business password",
// "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts" => "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts",
// "Primary password of your PayPal Pro business account - OPTIONAL" => "Primary password of your PayPal Pro business account - OPTIONAL",
// "Paypal business signature" => "Paypal business signature",
// "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts" => "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts",
// "Your API signature associated with your PayPal Pro business account - OPTIONAL" => "Your API signature associated with your PayPal Pro business account - OPTIONAL",
"PayPal environment" => "페이팔 환경",
"Used to switch between the PayPal sandbox, used for testing and development and the live environment" => "페이팔 모래상자 간에 변경하기 위하여 사용됨, 테스트와 개발목적 및 라이브 환경용으로 사용됨 ",
"Production" => "제작",
// "PayPal instant payment notification (IPN)" => "PayPal instant payment notification (IPN)",
"Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server" => "자동 지불 완료에 대한 IPN 활성화. 활성화되었을 때, 지불이 확인되었을 때 페이팔이 사이트로 다시 ping을 할 것임. 그 후 지불이 자동적으로 입력될 것임. 이는 서버가 공용서버 상에 있지 않으면 가능하지 않을 수 있음",
// "Payment data transfer (PDT)" => "Payment data transfer (PDT)",
// "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically" => "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically",
// "Payment data transfer (PDT) token" => "Payment data transfer (PDT) token",
// " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT" => " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT",
// "Redirect after PDT payment" => "Redirect after PDT payment",
// "Optionally, after receiving a successful payment, the user will be redirected to this page" => "Optionally, after receiving a successful payment, the user will be redirected to this page",
"Currency used when entering payments" => "지불내역을 입력할 때 사용되는 통화",
"Default acceptable payment delay" => "기본 수용가능한 지불 연기",
"Number of days before a payment request becomes overdue. This can be changed per payment request" => "지불 요청이 기한이 지나기 전까지의 날짜 수. 지불 요청 당 변경 가능",
// "Cclite registries" => "Cclite registries",
"Registries in Cclite" => "Cclite 안의 레지스트리",
"Registry names in Cclite" => "Cclite 내부의 레지스트리명",
// "Cclite registry currencies" => "Cclite registry currencies",
"Currencies in Cclite" => "Cclite 에서의 통화",
"Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)." => "Cclite 의 각각의 레지스트리는 자신만의 통화를 보유할 수 있습니다. 레지스트리당 하나여야만 합니다. (대소문자 구분)  ",
// "Cclite server URL" => "Cclite server URL",
"Full URL of the repository" => "리포지터리의 전체 UIRL",
"for example, https://cclite.yourdomain.org/cclite/" => "예. https://cclite.귀하의_도메인.org/cclite/",
// "Cclite merchant key" => "Cclite merchant key",
// "Corresponds with merchant key setting in Cclite" => "Corresponds with merchant key setting in Cclite",
// "Cclite merchant user" => "Cclite merchant user",
"Username in Cclite representing \"the management\"" => "Cclite dptj \"관리\"를 대표하는 사용자명. 기본은 \"관리자\"임",
// "Cclite enable payments" => "Cclite enable payments",
"Select Cclite test or live operation." => "테스트 혹은 실황 운영",
"Live" => "라이브",
// "Hashing algorithm" => "Hashing algorithm",
"Encryption type" => "암호화 유형",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite payment notification" => "Cclite payment notification",
"To do" => "할 일",
// "Wiki page with manual payment instructions" => "Wiki page with manual payment instructions",
// "Enter wiki page name" => "Enter wiki page name",
// "Invoice prefix" => "Invoice prefix",
"The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice" => "접두어는 동일한 페이팔 계정이 다른 티키 사이트에 대하여 사용될 경우, 설정되어야만 하며 고유한 것이어여만 합니다, 이는 페이팔이 청구서가 두 번 지불되지 않았는가 확인하기 때문입니다",
"Types of credit to use" => "사용할 신용의 종류",
"This is a list of the types of Tiki user credits that are acceptable for payment" => "이는 지불이 허용되는 티키 사용자 신용의 유형들의 목록입니다",
"Exchange rate for types of credit to use" => "사용할 크렛의 종류에 대한 환율",
"This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency" => "이는 지불 통화의 1과 동일한 신용 양의 상응 목록합니다",
// "User can only see own outstanding payments" => "User can only see own outstanding payments",
"Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments" => "\"n\"으로 설정되어 있지 않다면,범주 이름 보다는 범주 트리 내부의 관련 범주 경로들을 표기",
// "User can only see own past or cancelled payments" => "User can only see own past or cancelled payments",
"Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments" => "관리자 지불 권한이 있지 않은 경우, 사용자는 자신만의 과거 혹은 취소된 지불만을 볼 수 있습니다",
// "Anonymous users can pay outstanding invoices" => "Anonymous users can pay outstanding invoices",
// "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)" => "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)",
"Manage product inventory" => "제품 재고 관리",
"Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "제품 재고 기능 활성화, 제대로 설치되려면 제품 트래커가 필요함, 항목ID(itemId) 는 반드시 제품 코드이어야 함",
// "Products tracker ID" => "Products tracker ID",
"ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code." => "제품 트래커인 트래커의 트래커ID, 고급 카트 기능에 대하여 필요함, 항목ID 는 제품 코드가 될 것임",
// "Products tracker name" => "Products tracker name",
// "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code" => "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code",
// "Inventory type field ID" => "Inventory type field ID",
"In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"" => "재고 유형을 저장할 제품 트래커 내부의 필드 ID, 필드의 값은 \"none\" 혹은 \"internal\"여야만 합니다",
// "Inventory total field ID" => "Inventory total field ID",
"In the products tracker, the ID of the field to store the total inventory of products" => "제품의 전체 재고를 저장할 제품 트래커 내부의 필드 ID",
// "Inventory total less hold field ID" => "Inventory total less hold field ID",
"In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts" => "현재 카트 안에 있기 때문에 대기 상태인 양 만큼을 제외한 제품의 전체 재고를 저장할 제품 트래커 내부의 필드 ID",
// "Inventory hold timeout" => "Inventory hold timeout",
"Minutes to hold inventory before making it available again when there is no user cart action" => "사용자 카드 작업이 없을 때 재고를 다시 사용가능하게 만들기 전까지 보유할 시간(분)",
"Bundled products feature for cart" => "카드 용 번들된 제품 기능",
"Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code." => "내장된 제품 기능을 활성화, 제대로 설치되려면 제품 트래커가 필요함, 항목ID(itemId) 는 반드시 제품 코드이어야 함",
// "Product name field name" => "Product name field name",
"In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle" => "제품의 레이블로써 사용될 제품명의 제품 트래커의 필드명, 예. 번들 내부",
// "Items in bundle field name" => "Items in bundle field name",
"In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)." => "번들 내부의 제품의 제품 ID의 쉼표로 분리된 목록의 제품 트래커 내부의 필드명  (즉, 필드가 무엇인가 포함하는 경우, 이 제품은 번들입니다), 하위 제품의 수를 지정할 수도 있습니다, 예. 23:(\"콜론\")2,24 는 항목 23 (x2) + 항목 24 (x1) 를 의미합니다",
// "Product price field name" => "Product price field name",
"In the products tracker, the name of the field for the product price" => "제품 가격의 제품 트래커 내부의 필드명",
// "Associated event ID field name" => "Associated event ID field name",
// "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with" => "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with",
// "Product class ID field name" => "Product class ID field name",
// "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature",
// "Gift certificate template field name" => "Gift certificate template field name",
// "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature",
// "Record cart orders in trackers" => "Record cart orders in trackers",
// "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording" => "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording",
// "Orders profile" => "Orders profile",
"Wiki page containing the profile for creating orders (page name must not have spaces)" => "주문을 만들기 위한 프로필이 있는 위키 페이지 (페이지명에는 스페이스가 없어야 함)",
// "Order item profile" => "Order item profile",
"Wiki page containing the profile for creating order items (page name must not have spaces)" => "주문 항목 만들기 위한 프로필이 있는 위키 페이지 (페이지명에는 스페이스가 없어야 함)",
// "Allow anonymous shopping" => "Allow anonymous shopping",
// "Allow shopping by anonymous users and record the orders in trackers" => "Allow shopping by anonymous users and record the orders in trackers",
// "Anonymous orders profile" => "Anonymous orders profile",
"Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)" => "익명 사용자를 위한 주문을 만들기 위한 프로필이 있는 위키 페이지 (페이지명에는 스페이스가 없어야 함)",
// "Anonymous order item profile" => "Anonymous order item profile",
"Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)" => "익명 사용자를 위한 주문 항목 만들기 위한 프로필이 있는 위키 페이지 (페이지명에는 스페이스가 없어야 함)",
// "Anonymous shopper info profile" => "Anonymous shopper info profile",
// "Anonymous users order review page" => "Anonymous users order review page",
"Wiki page where anonymous users can review their orders" => "익명 사용자가 자신의 주문을 검토할 위키 페이지)",
// "Temporary shopper group" => "Temporary shopper group",
// "Group name of group with permission to access review page via a token" => "Group name of group with permission to access review page via a token",
// "Enable association of product orders" => "Enable association of product orders",
"Enable association of products with events (or projects, etc.)." => "제품을 이벤트 (혹은 프로젝트 및 기타)로의 연결을 허용",
// "Events tracker ID" => "Events tracker ID",
// "Tracker ID of tracker that is the events tracker" => "Tracker ID of tracker that is the events tracker",
// "Events tracker name" => "Events tracker name",
// "Name of tracker that is the events tracker" => "Name of tracker that is the events tracker",
// "Event start field name" => "Event start field name",
// "Field name in events tracker of start date/time" => "Field name in events tracker of start date/time",
// "Event end field name" => "Event end field name",
// "Field name in events tracker of end date/time" => "Field name in events tracker of end date/time",
"Allow exchange of products" => "제품 교환 허용",
// "Order items tracker ID" => "Order items tracker ID",
// "Tracker ID of tracker that is the order items tracker" => "Tracker ID of tracker that is the order items tracker",
"Gift certificates" => "선물 상품권",
// "Gift certificate tracker ID" => "Gift certificate tracker ID",
// "ID of tracker that is the gift certificate tracker" => "ID of tracker that is the gift certificate tracker",
// "Gift certificate tracker name" => "Gift certificate tracker name",
// "Name of tracker that is the gift certificate tracker" => "Name of tracker that is the gift certificate tracker",
// "Orders tracker name" => "Orders tracker name",
// "Name of tracker that is the orders tracker" => "Name of tracker that is the orders tracker",
// "Order items tracker name" => "Order items tracker name",
// "Name of tracker that is the order items tracker" => "Name of tracker that is the order items tracker",
// "Product classes tracker name" => "Product classes tracker name",
// "Name of tracker that is the product classes tracker" => "Name of tracker that is the product classes tracker",
// "Payment heading" => "Payment heading",
// "Heading displayed on payment form" => "Heading displayed on payment form",
// "Israel Post payment environment" => "Israel Post payment environment",
// "Switch between test transactions and real transactions" => "Switch between test transactions and real transactions",
// "Israel Post use pre-authorization" => "Israel Post use pre-authorization",
// "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post" => "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post",
// "Israel Post business ID" => "Israel Post business ID",
// "Provided by Israel Post, usually the business name" => "Provided by Israel Post, usually the business name",
// "Israel Post API password" => "Israel Post API password",
// "Provided by Israel Post" => "Provided by Israel Post",
"Send to URL" => "URL 로 보내기",
// "URL to redirect to on \"permission denied\"" => "URL to redirect to on \"permission denied\"",
"On permission denied, display login module" => "권한 거부 시, 로그인 모듀을 표시합니다 (익명사용자에 대하여)",
// "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead" => "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead",
"PHP libxml extension" => "PHP libxml 확장기능",
// "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default",
"PHP DateTime" => "PHP 날짜시간",
// "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0" => "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0",
"Number of comments to show on poll pages" => "투표 페이지에 대하여 표시할 댓글의 수",
"The order in which order polls are displayed" => "투표 정렬순서 알고리듬 (기본=점수)",
"Show categories" => "범주 표기",
// "For polls that are categorized, the category is displayed" => "For polls that are categorized, the category is displayed",
"Show objects" => "개체 보기",
// "List wiki pages or other site objects that the poll is attached to" => "List wiki pages or other site objects that the poll is attached to",
"Multiple polls per object" => "개체 당 여러 개의 설문",
"When used with the rating features, allow multiple polls to be attached to a single object." => "등급 기능과 함께 사용되면, 한개의 개체에 복수의 설문이 첨부되는 것을 허용합니다.",
"Disable textarea toolbar" => "텍스트영역 툴바 사용 안 함",
"Don't display the toolbar on text inputs in surveys." => "설문에서 텍스트영역 필드를 위한 툴바 숨기기",
// "Precision of survey results calculation" => "Precision of survey results calculation",
// "Number of decimal places in the percentage figures" => "Number of decimal places in the percentage figures",
// "decimal places" => "decimal places",
// "Set display settings for all galleries" => "Set display settings for all galleries",
"PDF from URL" => "URL에서 PDF",
"Using external tools, generate PDF documents from URLs" => "외부 도구를 사용하여 웹 URL에서 PDF문서를 생성",
"WebKit (wkhtmltopdf)" => "웹킷 (wkhtmltopdf)",
// "WeasyPrint" => "WeasyPrint",
// "mPDF" => "mPDF",
"Webservice URL" => "웹서비스 URL",
"URL to a service that takes a URL as the query string and returns a PDF document" => "URL을 질의문자열로 받고 PDF 문서를 반환하는 서비스로의 URL",
"WebKit path" => "웹킷 경로",
"Full path to the wkhtmltopdf executable to generate the PDF document with" => "PDF 문서를 생성할 wkhtmltopdf 실행파일에 대한 전체 경로",
// "WeasyPrint path" => "WeasyPrint path",
// "Full path to the weasyprint executable to generate the PDF document with" => "Full path to the weasyprint executable to generate the PDF document with",
// "Print Friendly PDF" => "Print Friendly PDF",
// "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file" => "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file",
// "PDF Orientation" => "PDF Orientation",
// "Landscape or portrait" => "Landscape or portrait",
"Portrait" => "세로",
"Landscape" => "가로",
// "PDF page size" => "PDF page size",
// "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)" => "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)",
// "Legal" => "Legal",
// "Tabloid/Ledger" => "Tabloid/Ledger",
// "A0" => "A0",
// "A1" => "A1",
// "A2" => "A2",
// "A3" => "A3",
// "A4" => "A4",
// "A5" => "A5",
// "A6" => "A6",
// "Generate auto table of contents with PDF" => "Generate auto table of contents with PDF",
// "Link TOC with content" => "Link TOC with content",
// "Link table of contents headings with content in the PDF" => "Link table of contents headings with content in the PDF",
// "TOC heading" => "TOC heading",
// "Heading to be displayed above the table of contents" => "Heading to be displayed above the table of contents",
// "PDF TOC levels" => "PDF TOC levels",
// "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3" => "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3",
// "Show Page title" => "Show Page title",
// "Print wiki page title with pdf" => "Print wiki page title with pdf",
// "PDF header text" => "PDF header text",
// "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}" => "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}",
// "HTML / Wiki Syntax / " => "HTML / Wiki Syntax / ",
// "Left text" => "Left text",
// "Center Text" => "Center Text",
// "Right Text" => "Right Text",
// "PDF footer text" => "PDF footer text",
// "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}" => "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}",
// "Left margin" => "Left margin",
// "Numeric value.For example 10" => "Numeric value.For example 10",
// "Right margin" => "Right margin",
// "Numeric value, no need to add px. For example 10" => "Numeric value, no need to add px. For example 10",
// "Top margin" => "Top margin",
// "Bottom margin" => "Bottom margin",
// "Header margin from top of document" => "Header margin from top of document",
// "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Header can overlap text if top margin is not set properly" => "Warning: Header can overlap text if top margin is not set properly",
// "Footer margin from bottom of document" => "Footer margin from bottom of document",
// "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Footer can overlap text if bottom margin is not set properly" => "Warning: Footer can overlap text if bottom margin is not set properly",
// "Hyperlink behaviour in PDF" => "Hyperlink behaviour in PDF",
// "Off (Links will be removed)" => "Off (Links will be removed)",
// "Add as footnote (Links will be listed at end of document" => "Add as footnote (Links will be listed at end of document",
// "PDF Bookmarks" => "PDF Bookmarks",
// "Automatically generate bookmarks" => "Automatically generate bookmarks",
// "H1-H6, separated by |.For example: H1|H2|H3" => "H1-H6, separated by |.For example: H1|H2|H3",
// "Number of columns" => "Number of columns",
// "Default - 1 Column" => "Default - 1 Column",
// "2 Columns" => "2 Columns",
// "3 Columns" => "3 Columns",
// "4 Columns" => "4 Columns",
// "PDF password for viewing" => "PDF password for viewing",
// "Password-protect the generated PDF" => "Password-protect the generated PDF",
// "Watermark text" => "Watermark text",
// "PDF watermark text, if any" => "PDF watermark text, if any",
// "Watermark Image URL" => "Watermark Image URL",
// "The watermark image will appear under the text. Enter the complete image URL" => "The watermark image will appear under the text. Enter the complete image URL",
// "PDF page background color" => "PDF page background color",
// "Enter a valid CSS color code" => "Enter a valid CSS color code",
// "PDF page background image" => "PDF page background image",
// "Enter the full URL" => "Enter the full URL",
// "CoverPage text settings" => "CoverPage text settings",
// "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings" => "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings",
// "Coverpage image URL" => "Coverpage image URL",
// "Print wiki authors" => "Print wiki authors",
// "Include wiki page authors and date in print versions of wiki pages" => "Include wiki page authors and date in print versions of wiki pages",
// "Print original wiki URL" => "Print original wiki URL",
// "Include original wiki page URL in print versions of wiki pages" => "Include original wiki page URL in print versions of wiki pages",
// "Print original tracker item URL" => "Print original tracker item URL",
// "Print original forum post URL" => "Print original forum post URL",
// "Include original forum post URL in print version of forum posts" => "Include original forum post URL in print version of forum posts",
"Repository URLs" => "리포지터리 URL",
"List of URLs for the profile repositories that will be used" => "사용될 프로필 리포지터리에 대한 URL의 목록",
"Enter multiple repository URLs, one per line" => "여러 개의 리포지터리 URL들 입력, 한 줄 당 한 개",
"Data channels" => "데이터 채널들",
"Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "데이터 채널은 post 요청에서 적용될 수 있는 템플릿입니다. 이들은 좀 더 복잡한 설치에 작업을 자동화하기 위하여 사용될 수 있습니다",
"Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "데이터 채널은 사용자 공간으로부터 프로필을 실행하기 위한 명명된 파이프를 만듭니다. 한 줄 당 한 채널. 각 줄은 쉼표로 분리되며 __채널 이름, 도메인, 프로필, 허용된 그룹, (선택사항으로) 그룹들에 일치하는 \$profilerequest:input\$ __ 등을 포합합니다",
"There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "데어티 채널을 사용하는 것과 연관된 보안 고려사항이 없습니다. 프로필 페이지는 관리자만 제어할 수있도록 확인하십시오",
"Developer mode" => "개발자 모드",
"For profiles under an approval workflow, always use the latest version, even if not approved" => "승인 작업흐름 하의 프로필에 대하여, 항상 최신 버전을 사용하십시오, 비록 승인되지 않은 경우도 해당합니다",
"Make sure you review the profiles you install" => "설치한 프로필 검토를 반드시 하십시오",
// "Automatically approve wiki-plugins on pages installed by profiles" => "Automatically approve wiki-plugins on pages installed by profiles",
// "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved" => "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved",
// "Make sure your profiles are not executable or editable by untrusted users" => "Make sure your profiles are not executable or editable by untrusted users",
"Proxy host name" => "프록시 호스트명",
"Proxy host - without http:// or similar, just the host name" => "프록시 호스트 - http:// 혹은 유사한 것 없이, 호스트 명만",
"Proxy port" => "프록시 포트",
"Proxy username" => "프록시 사용자명",
"Proxy password" => "프록시 암호",
"Quantify change size" => "변경 크기 수량화",
"In addition to tracking the changes, track the change size and display approximately how up-to-date the page is" => "변경내역을 추척하는 것에 더불어, 변경 크기를 추적하고 페이지의 대략적인 최신 상태를 표시함",
"Advanced Rating" => "고급 등급",
"In an advanced rating system, the options and calculation method can be configured." => "설정될 선택사항과 계산 방식을 허용하는 등급 시스템",
"Rating recalculation mode" => "등급 재계산 모드",
"Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent." => "등급 집계가 언제 어떻게 재계산되는지 결정함. 사이트 로드에 따라, 어떤 선택사항이 다른 것에 대비 우선될 수 있음. 대용량 사이트에서는 cron job으로 처리되는 것이 좋음. 투표 재계산은 만약 등급 계산이 시간에 의존한다면 부정확할 수 있음.",
"Recalculate on vote" => "투표 시 재계산",
"Randomly recalculate oldest ratings (on load)" => "가장 오래된 등급을 임의로 재계산 (로드 시)",
"Randomly recalculate oldest ratings (on vote)" => "가장 오래된 등급을 임의로 재계산 (투표 시)",
"Cron job (must be set manually)" => "Cron job (수동 설정 필수)",
"Before any attempt to re-index the object" => "개체를 재-색인하기 위한 어떤 시도 이전",
"Recalculation odds (1 in X)" => "재계산 확률 (X 분의 1)",
"Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "매 요청마다 주사위 굴리리가 수행됨. 성공일 경우, 특정 투표의 수를 재 계산할 것임",
"votes" => "투표",
"Recalculation count" => "제계산 수",
"How many ratings should be recalculated when odds strike" => "확률이 낮은 일이 발생했을 때 얼마나 많은 등급들이 재계산되어야 하는가",
// "ratings" => "ratings",
"Smiley Ratings" => "이모티콘 등급",
"Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration" => "단순 등급 시스템에 대하여 웃는 얼굴 표시. 0-11 사이에서만 작동하며 설정된 내용에 따름. 이모티콘처럼 사용 시 더욱 쉬운 사용자 인터페이스",
"Enabled" => "활성화됨",
// "Detailed rating results" => "Detailed rating results",
// "Displays a table with the result count and percentage per rating option" => "Displays a table with the result count and percentage per rating option",
// "Reversed Rating Options" => "Reversed Rating Options",
// "Displays the ratings options in reverse" => "Displays the ratings options in reverse",
// "Include percentages in the detailed rating results" => "Include percentages in the detailed rating results",
// "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown" => "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown",
// "Default rating options" => "Default rating options",
// "List of options available" => "List of options available",
// "Multiple votes per user" => "Multiple votes per user",
// "Allow users to vote multiple times in the same poll" => "Allow users to vote multiple times in the same poll",
"Use reCAPTCHA" => "reCAPTCHA 사용",
"Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA" => "특화된 CAPTCHA 서비스인 reCAPTCHA 를 기본 CAPTCHA 대신 사용",
"You will need to register at [http://www.google.com/recaptcha]" => "[http://www.google.com/recaptcha] 에서 등록해야 합니다",
// "Site key" => "Site key",
// "reCAPTCHA public key obtained after registering" => "reCAPTCHA public key obtained after registering",
// "Secret key" => "Secret key",
// "reCAPTCHA private key obtained after registering" => "reCAPTCHA private key obtained after registering",
// "reCAPTCHA theme" => "reCAPTCHA theme",
// "Choose a theme for the reCAPTCHA widget" => "Choose a theme for the reCAPTCHA widget",
// "Black Glass" => "Black Glass",
// "Red" => "Red",
// "White" => "White",
// "reCAPTCHA version" => "reCAPTCHA version",
// "1.0" => "1.0",
// "2.0" => "2.0",
// "3.0" => "3.0",
"Record untranslated strings" => "미번역 문자열 기록",
"Keep track of the unsuccessful attemps to translate strings" => "문자열 번역의 실패한 시도를 기록",
// "Redis" => "Redis",
// "Enable connection to Redis to store cache" => "Enable connection to Redis to store cache",
// "Requires PHP Redis" => "Requires PHP Redis",
// "Redis Host" => "Redis Host",
// "IP address or domain name for Redis server" => "IP address or domain name for Redis server",
// "Redis Port" => "Redis Port",
// "Port for Redis server" => "Port for Redis server",
// "Redis connection timeout" => "Redis connection timeout",
// "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited" => "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited",
// "Redis Prefix" => "Redis Prefix",
// "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none" => "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none",
// "Redis cache expiry" => "Redis cache expiry",
// "Duration for which the cache will be kept. 0 means unlimited" => "Duration for which the cache will be kept. 0 means unlimited",
// "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern" => "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern",
"Restrict supported languages" => "지원 언어 제한",
"Limit the languages made available on the site" => "사이트에서 사용가능한 언어 제한",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Enable SAML Auth" => "Enable SAML Auth",
// "IdP Entity Id" => "IdP Entity Id",
// "Identifier of the IdP entity (\"Issuer\")" => "Identifier of the IdP entity (\"Issuer\")",
// "Single sign-on service URL" => "Single sign-on service URL",
// "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")" => "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")",
// "Single log-out service URL" => "Single log-out service URL",
// "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")" => "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")",
// "X.509 certificate" => "X.509 certificate",
// "Public x509 certificate of the IdP.  (\"X.509 certificate\")" => "Public x509 certificate of the IdP.  (\"X.509 certificate\")",
// "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section" => "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section",
// "Sync user group with IdP data" => "Sync user group with IdP data",
// "This should be enabled to sync groups with the IdP" => "This should be enabled to sync groups with the IdP",
// "Enable Single Logout Service" => "Enable Single Logout Service",
// "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers" => "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers",
"Default group" => "기본 그룹",
// "When provisioning a new user and not group found, assign that group" => "When provisioning a new user and not group found, assign that group",
// "Account matcher" => "Account matcher",
// "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost" => "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost",
// "Log-in link text" => "Log-in link text",
// "The text that appears on the log-in page" => "The text that appears on the log-in page",
// "SAML attribute that will be mapped to the Tiki username" => "SAML attribute that will be mapped to the Tiki username",
// "The SAML attribute that will be mapped to the Tiki username" => "The SAML attribute that will be mapped to the Tiki username",
// "SAML attribute that will be mapped to the Tiki email" => "SAML attribute that will be mapped to the Tiki email",
// "The SAML attribute that will be mapped to the Tiki email" => "The SAML attribute that will be mapped to the Tiki email",
// "SAML attribute that will be mapped to the Tiki group" => "SAML attribute that will be mapped to the Tiki group",
// "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation" => "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation",
// "Admins" => "Admins",
// "Set here the values of the IdP related to the user group info that will be matched with the Admins group" => "Set here the values of the IdP related to the user group info that will be matched with the Admins group",
"Registered" => "등록됨",
// "Set here the values of the IdP related to the user group info that will be matched with the Registered group" => "Set here the values of the IdP related to the user group info that will be matched with the Registered group",
// "Debug Mode" => "Debug Mode",
// "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed." => "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed.",
// "Strict Mode" => "Strict Mode",
// "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated" => "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated",
// "Service Provider Entity ID" => "Service Provider Entity ID",
// "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID" => "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID",
// "Requested NameIDFormat" => "Requested NameIDFormat",
// "Specifies constraints on the name identifier to be used to represent the requested subject" => "Specifies constraints on the name identifier to be used to represent the requested subject",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified" => "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress" => "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName" => "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:entity" => "urn:oasis:names:tc:SAML:2.0:nameid-format:entity",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:transient" => "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" => "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted" => "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos" => "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos",
// "Requested AuthnContext" => "Requested AuthnContext",
// "Authentication context: unselect all to accept any type, otherwise select the valid contexts" => "Authentication context: unselect all to accept any type, otherwise select the valid contexts",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified" => "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Password" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Password",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" => "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:X509" => "urn:oasis:names:tc:SAML:2.0:ac:classes:X509",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos",
// "urn:federation:authentication:windows" => "urn:federation:authentication:windows",
// "Enable Lowercase URL encoding" => "Enable Lowercase URL encoding",
// "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues." => "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues.",
// "Encrypt nameID" => "Encrypt nameID",
// "Sign AuthnRequest" => "Sign AuthnRequest",
// "The samlp:AuthnRequest messages sent by this SP will be signed" => "The samlp:AuthnRequest messages sent by this SP will be signed",
// "Sign LogoutRequest" => "Sign LogoutRequest",
// "The samlp:logoutRequest messages sent by this SP will be signed" => "The samlp:logoutRequest messages sent by this SP will be signed",
// "Sign LogoutResponse" => "Sign LogoutResponse",
// "The samlp:logoutResponse messages sent by this SP will be signed" => "The samlp:logoutResponse messages sent by this SP will be signed",
// "Sign Metadata" => "Sign Metadata",
// "The Metadata published by this SP will be signed" => "The Metadata published by this SP will be signed",
// "Reject Unsigned Messages" => "Reject Unsigned Messages",
// "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received" => "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received",
// "Reject Unsigned Assertions" => "Reject Unsigned Assertions",
// "Reject unsigned saml:Assertion received" => "Reject unsigned saml:Assertion received",
// "Reject Unencrypted Assertions" => "Reject Unencrypted Assertions",
// "Reject unencrypted saml:Assertion received" => "Reject unencrypted saml:Assertion received",
// "Retrieve Parameters From Server" => "Retrieve Parameters From Server",
// "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters" => "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters",
// "Service Provider X.509 certificate" => "Service Provider X.509 certificate",
// "Public x509 certificate of the SP" => "Public x509 certificate of the SP",
// "Service Provider Private Key" => "Service Provider Private Key",
// "Private key of the SP" => "Private key of the SP",
// "Signature Algorithm" => "Signature Algorithm",
// "Algorithm that the toolkit will use on the signing process" => "Algorithm that the toolkit will use on the signing process",
// "http://www.w3.org/2000/09/xmldsig#rsa-sha1" => "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
// "http://www.w3.org/2000/09/xmldsig#dsa-sha1" => "http://www.w3.org/2000/09/xmldsig#dsa-sha1",
// "Scheduler stalled after (minutes)" => "Scheduler stalled after (minutes)",
// "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection" => "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection",
// "Notify on stalled schedulers" => "Notify on stalled schedulers",
// "Send an email notification when a stalled scheduler is detected" => "Send an email notification when a stalled scheduler is detected",
// "Users to notify on stalled task" => "Users to notify on stalled task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Self healing after (minutes)" => "Self healing after (minutes)",
// "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing" => "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing",
// "Notify on healed schedulers" => "Notify on healed schedulers",
// "Send an email notification when a stalled scheduler is healed" => "Send an email notification when a stalled scheduler is healed",
// "Users to notify on healed task" => "Users to notify on healed task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Number of logs to keep" => "Number of logs to keep",
// "0 will keep all logs" => "0 will keep all logs",
"SCORM support" => "SCORM 지원",
"Handle SCORM package files on upload. SCORM is a standard used in learning management systems." => "업로드에서 SCORM 패키지 파일을 처리합니다. SCORM 은 교육관리시스템에서 사용되는 표준안입니다.",
"SCORM Tracker" => "SCORM 트래커",
"The ID number of the tracker used to store SCORM metadata" => "SCORM 메타데이터에 저장되기 위해 사용되는 트래커 ID.",
"Parse search results" => "결과를 구문분석",
// "When enabled search results are parsed so content formatting is visible in the search results" => "When enabled search results are parsed so content formatting is visible in the search results",
"Default where" => "기본 위치",
"When object filter is not on, limit to search one type of object" => "개체 필터가 켜있지 않으면, 검색을 개체의 한 종류로 제한함",
"Entire site" => "사이트 전체",
"Wiki Pages" => "위키 페이지들",
"Wiki pages" => "위키 페이지",
// "Blog posts" => "Blog posts",
// "Tracker items" => "Tracker items",
"Spreadsheets" => "스프레드시트",
"Restrict search language by default" => "기본으로 검색 언어를 제한",
"Only search content that is in the interface language, otherwise show the language menu" => "활성화된 경우, 인터페이스 언어로 된 컨텐츠만 검색, 그 외의 경우 언어 메뉴 표시",
"Autocomplete page names" => "페이지명에 자동완성",
// "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc" => "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc",
// "deprecated" => "deprecated",
"Category filter" => "범주 필터",
"Tag filter" => "태크 필터",
// "Use facets for default search interface" => "Use facets for default search interface",
// "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines" => "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines",
// "Facet result count" => "Facet result count",
// "Default number of facet results to obtain" => "Default number of facet results to obtain",
// "facet results" => "facet results",
// "Search index outdated" => "Search index outdated",
// "Number of days to consider the search index outdated" => "Number of days to consider the search index outdated",
// "Show error on missing field" => "Show error on missing field",
// "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly" => "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly",
// "File thumbnail preview" => "File thumbnail preview",
// "Have a preview of attachments in search results" => "Have a preview of attachments in search results",
// "Use date histogram aggregations" => "Use date histogram aggregations",
// "Use date histogram aggregations (facets) when indexing, requires Elasticsearch" => "Use date histogram aggregations (facets) when indexing, requires Elasticsearch",
// "Date histogram aggregations interval" => "Date histogram aggregations interval",
// "Default interval for date histogram aggregations" => "Default interval for date histogram aggregations",
// "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0" => "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0",
// "Date range aggregations ranges" => "Date range aggregations ranges",
// "Default ranges for date range aggregations" => "Default ranges for date range aggregations",
// "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0" => "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0",
// "Excluded facets" => "Excluded facets",
// "List of facets (a.k.a. aggregations) to exclude from the default search results" => "List of facets (a.k.a. aggregations) to exclude from the default search results",
// "Avoid Duplicated Facets" => "Avoid Duplicated Facets",
// "Avoid Facets appearing with the same name, usually by appending the Tracker name" => "Avoid Facets appearing with the same name, usually by appending the Tracker name",
// "Parse wiki syntax in comments" => "Parse wiki syntax in comments",
"Parse wiki syntax in comments in all sections apart from Forums" => "게시판을 제외한 모든 부분에 댓글 안에서 위키 문법 구문분석",
"Use \"Accept wiki syntax\" for forums in admin forums page" => "게시판 관리 페이지의 게시판에서 \"위키 문법 허용\" 을 사용",
// "Short URL" => "Short URL",
// "Provides the ability to create a short url, easy to share" => "Provides the ability to create a short url, easy to share",
// "Short URL base URL" => "Short URL base URL",
// "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website" => "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website",
"Sender email" => "발신인 이메일",
"Email address that will be used as the sender for outgoing emails" => "발신용 이메일에 대하여 발신자로 사용될 이메일 주소",
// "Sender full name" => "Sender full name",
// "Real name that will be used as the sender for outgoing emails" => "Real name that will be used as the sender for outgoing emails",
"Time zone" => "시간대",
"Indicates the default time zone to use for the server" => "서버에 대하여 사용할 기본 시간대를 지정",
"Session storage location" => "세션 저장 장소",
"Select where the session information should be stored. Memcache sessions require memcache to be configured" => "세션 정보가 어디에 저장될 것인지를 선택하십시오. 멤캐시 세션은 memcache가 구성될 것을 요구합니다",
"Default (from php.ini)" => "기본 (php.ini 내부에서 지정)",
"Database" => "데이터베이스",
"Session lifetime" => "세션 수명",
"Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance." => "값은 분 단위입니다. 로그인된 최소 시간이 될 것입니다. 정확한 시간을 원한다면, .htaccess 내부의 session.gc_probability와 session.gc_divisor를 1로 조절해야 합니다. probability를 변경하는 것은 서버 성능에 영향을 미칠 수 있다는 점에 유의하십시오",
"Silent session" => "Silent 세션",
"Do not automatically start sessions." => "자동으로 세션을 시작하지 않음",
// "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)" => "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)",
// "Can cause problems when combined with cookie consent and JavaScript-disabled browsers" => "Can cause problems when combined with cookie consent and JavaScript-disabled browsers",
"Session cookie name" => "세션 쿠키 명",
"Session cookie name used instead of the PHP default configuration" => "PHP 기본 구성 대신에 세션 쿠키이름이 사용됨",
"Protect all sessions with HTTPS" => "HTTPS로 모든 세션 보호",
"Always redirect to HTTPS to prevent a session hijack through network sniffing" => "네트워크 스니핑을 통하여 세션 하이재킹을 방지하기 위하여 항상 HTTPS 로 리디렉트",
"Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site" => "SSL을 이미 구성한 경우에만 활서화하십시오, 그렇지 않으면 티키가 잠겨 외부에서 들어갈 수 없게됩니다",
"Display links on the share page" => "공유 페이지에 링크를 표기",
"Token notification" => "토큰 알림",
"Users can subscribe to the notifications of consultation of the token." => "사용자는 토큰의 상담의 알림에 구독할 수 있습니다",
"Add contact" => "연락처 추가",
"If not already in the list, recipients are added to the list of contacts." => "수신자들이 연락처 목록에 기존에 없다면, 추가됨",
"Display name and email" => "이름과 이메일 표기",
"If the user is connected, the name and email will display in the page." => "사용자가 연결한 경우, 페이지에 표시할 이름과 이메일",
// "Number of times accessed" => "Number of times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Maximum number of times accessed" => "Maximum number of times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "page hits" => "page hits",
// "The name of the default group" => "The name of the default group",
"Create with default group" => "기본 그룹으로 만들기",
"Valid affiliations" => "유효한 제휴",
// "A list of affiliations which will allow users to log in to this wiki" => "A list of affiliations which will allow users to log in to this wiki",
"Separate multiple affiliations with commas" => "여러 개의 제휴를 쉼표로 분리",
"Shipping service" => "배송 서비스",
"Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "JSON 배송율 산정 서비스를 노출시키기. 제공자로부터의 계정들이 필요할 수 있음 (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
"Enable shipping rate calculation through FedEx APIs" => "FedEx API 를 통한 운송료 계산 활성화",
"FedEx key" => "FedEx 키",
"Developer key" => "개발자 키",
"FedEx password" => "FedEx 비밀번호",
"FedEx meter number" => "FedEx 미터 번호",
"FedEx account number" => "FedEx 계정 번호",
// "UPS API" => "UPS API",
"Enable shipping rate calculation using the UPS carrier" => "UPS 캐리어를 사용하여 운송료 계산 활성화",
"UPS username" => "UPS 사용자명",
"UPS credentials" => "UPS 인증",
"UPS password" => "UPS 암호",
"UPS access key" => "UPS 접근 키",
"Custom shipping provider" => "사용자 지정 발송 제공자",
"Short date format" => "짧은 날짜 형식",
// "Specify how Tiki displays the date (shorter version)" => "Specify how Tiki displays the date (shorter version)",
"Short time format" => "짧은 시간 형식",
// "Specify how Tiki displays the time (shorter version)" => "Specify how Tiki displays the time (shorter version)",
// "Short JavaScript date format" => "Short JavaScript date format",
// "Used in jQuery-UI date picker fields" => "Used in jQuery-UI date picker fields",
// "Short JavaScript time format" => "Short JavaScript time format",
// "Used in jQuery-UI datetime picker fields" => "Used in jQuery-UI datetime picker fields",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "yy-mm-dd" => "yy-mm-dd",
// "HH:mm" => "HH:mm",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
"Display available translations" => "사용 가능한 번역들 표시",
// "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons" => "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons",
// "Close site" => "Close site",
// "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site" => "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site",
// "Coming soon" => "Coming soon",
"Message" => "메시지",
// "Site is closed for maintenance; please come back later" => "Site is closed for maintenance; please come back later",
// "Server is currently too busy; please come back later" => "Server is currently too busy; please come back later",
"Locations (breadcrumbs)" => "위치 (사이트 이동 경로)",
// "Examples:  » / >  : -> →" => "Examples:  » / >  : -> →",
"Choices" => "선택",
// "Examples: | / ¦  " => "Examples: | / ¦  ",
"Browser title position" => "사이트 제목 위치",
// "Position of the browser title in the full browser bar relative to the current page's descriptor" => "Position of the browser title in the full browser bar relative to the current page's descriptor",
// "After current page's descriptor" => "After current page's descriptor",
// "Before current page's descriptor" => "Before current page's descriptor",
// "No browser title, only current page's descriptor" => "No browser title, only current page's descriptor",
// "Only browser title, no current page's descriptor" => "Only browser title, no current page's descriptor",
"Browser title display mode" => "브라우저 제목 표기 모드",
"When breadcrumbs are used, method to display the browser title" => "사이트 이동 경로가 사용될 경우, 브라우저 제목이 표시될 방식",
"Most-specific first" => "가장 구체적 내용 먼저",
"Least-specific first (site)" => "가장 덜 구체적 내용 먼저 (사이트)",
"Current only" => "현재 만",
// "Favicons" => "Favicons",
// "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used" => "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used",
"Site terminal" => "사이트 터미널",
"Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "사용자를 원천 IP 주소에 따라 특정 퍼스펙티브로 향하게하는 것을 허용. 인트라넷 내부에서 소속 부서에 따라 사용자들에게 다른 구성을 사용하거나 웹 상황에 따라 사람을 차별하기 위하여 사용될 수 있습니다. 지정되지 않은 IP들은 기본 동작상태로 돌아가게되며, 이는 다중 도메인 처리를 포함합니다. 수동으로 선택된 퍼스펙티브가 이에 대한 우선권을 가집니다",
"Site terminal configuration" => "사이트 터미널 구성",
"Provides the mapping from subnets to perspective" => "하부망에서 퍼스펙티브로 매핑을 제공",
"One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "줄 당 한 개. CIDR 표기법에 의한 네트워크 접두어 (address/mask size), 퍼스펙티브 ID 로 쉼표에 의해 구분됨",
// "Google Analytics account number" => "Google Analytics account number",
// "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY" => "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY",
// "Google Analytics Groups Option" => "Google Analytics Groups Option",
// "Define option for Google Analytics groups" => "Define option for Google Analytics groups",
// "Included" => "Included",
// "Excluded" => "Excluded",
// "Google Analytics Available Groups" => "Google Analytics Available Groups",
// "User groups for which Google Analytics will be available" => "User groups for which Google Analytics will be available",
// "Google Global Site Tag Mode" => "Google Global Site Tag Mode",
// "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js" => "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js",
// "Google authentication credentials file" => "Google authentication credentials file",
// "Path to the Google Service Account credentials JSON file" => "Path to the Google Service Account credentials JSON file",
// "Site layout" => "Site layout",
// "Changes the template for the overall site layout" => "Changes the template for the overall site layout",
// "Admin layout" => "Admin layout",
// "Specify which layout template to use for admin pages" => "Specify which layout template to use for admin pages",
// "Enable layout per page, etc" => "Enable layout per page, etc",
// "Specify an alternate layout for a particular wiki page, etc" => "Specify an alternate layout for a particular wiki page, etc",
// "Piwik server URL" => "Piwik server URL",
// "The URL to the Piwik server of this site" => "The URL to the Piwik server of this site",
// "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL" => "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL",
// "Site Id" => "Site Id",
// "The ID of this website in Piwik" => "The ID of this website in Piwik",
// "Piwik JavaScript tracking code" => "Piwik JavaScript tracking code",
// "Piwik Groups Option" => "Piwik Groups Option",
// "Define option for Piwik groups" => "Define option for Piwik groups",
// "Piwik Available Groups" => "Piwik Available Groups",
// "User groups for which piwik will be available" => "User groups for which piwik will be available",
// "Security timeout" => "Security timeout",
// "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case" => "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case",
// "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting" => "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting",
// "Code to be placed on every page of this website just before the </body> tag" => "Code to be placed on every page of this website just before the </body> tag",
"Publish" => "게시",
// "Make the banner visible to all site visitors" => "Make the banner visible to all site visitors",
// "Activate must be turned on for Publish to take effect" => "Activate must be turned on for Publish to take effect",
"Logo source (image path)" => "로고 소스 (그림 경로)",
"Logo background color" => "로고 배경 색상",
// "A legacy option to add a background color to the div that contains the logo image" => "A legacy option to add a background color to the div that contains the logo image",
"Examples" => "예제",
"Logo title (on mouseover)" => "로고 제목 (마우스를 위로 가져올 시)",
// "This appears as tool tip text. The site logo is also a link to the site index (top page)" => "This appears as tool tip text. The site logo is also a link to the site index (top page)",
"HTML \"alt\" tag description" => "Alt. 설명 (예: 텍스트 브라우저 용",
// "Normally a description of the image, such as \"Example.com logo\"" => "Normally a description of the image, such as \"Example.com logo\"",
// "Used by text browsers, screen readers, etc" => "Used by text browsers, screen readers, etc",
// "Site icon" => "Site icon",
// "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space" => "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space",
// "Recommended image height: 32 pixel" => "Recommended image height: 32 pixel",
// "Sitemap protocol" => "Sitemap protocol",
// "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines" => "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines",
"Include Smarty notices in the PHP error report" => "PHP 오류 보고에 스마티 알림 포함",
"In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur" => "대부분의 경우, 스마티 알림은 안전상 무시될 수 있습니다. 하지만, 이상한 문제가 발생할 때 개발 프로세스에서 유용할 수 있습니다",
// "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages" => "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages",
// "Smarty security" => "Smarty security",
"Do not allow PHP code in Smarty templates" => "php 코드를 스마티 템플릿 내부에 허용 안 함",
"You should leave this on unless you know what you are doing" => "정확히 알고계시지 않다면 이를 켜 놓은 상태로 두시는 것이 좋습니다",
"Extra Smarty modifiers" => "추가 스마트 수정자",
"Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates." => "추가 PHP 함수를 스마티 수정자로써 사용가능하게 함. 사용자 지정 템플릿에 대하여 필요할 수 있음",
"There may be security implications. Make sure you know what you are doing" => "보안에 영향을 미칠 수 있습니다. 지금 하는 일이 어떤 것인지 반드시 알고 계셔야 합니다",
// "Extra Smarty functions" => "Extra Smarty functions",
"Make additional PHP functions available as Smarty functions. This may be needed for custom templates" => "추가 PHP 함수를 스마티 함수로써 사용가능하게 함. 사용자 지정 템플릿에 대하여 필요할 수 있음",
// "Extra Smarty directories" => "Extra Smarty directories",
// "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)" => "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)",
"Smarty compilation" => "스마티 컴파일",
"Indicates when the template cache should be refreshed." => "템플릿 캐시가 새로 고침이 필요할 때 표기함",
"Modified" => "수정",
"Never check (performance)" => "확인 안함 (성능용)",
"Always (development, slow)" => "항상 (개발용, 느림)",
// "Smarty cache permissions" => "Smarty cache permissions",
// "Permissions that enable Smarty to write to the templates_c directory" => "Permissions that enable Smarty to write to the templates_c directory",
// "User writable (0644)" => "User writable (0644)",
// "User & group writable (0664)" => "User & group writable (0664)",
// "Social network type" => "Social network type",
// "Select how the friendship relations within the social network should be treated" => "Select how the friendship relations within the social network should be treated",
// "Follow (as in Twitter)" => "Follow (as in Twitter)",
// "Friend (as in Facebook)" => "Friend (as in Facebook)",
// "Followers need approval" => "Followers need approval",
"Consumer key" => "소비자 키",
"Consumer key generated by registering this Tiki site as an application at Twitter" => "트위터에서 귀하의 사이트를 응용프로그램으로 등록 시 생성되는 Consumer key",
"Consumer secret" => "소비자 비밀",
"Consumer secret generated by registering this Tiki site as an application at Twitter" => "트위터에서 귀하의 사이트를 응용프로그램으로써 등록 시 생성되는 Consumer secret",
// "Twitter site name" => "Twitter site name",
// "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title" => "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title",
// "Twitter site image" => "Twitter site image",
// "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL" => "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL",
"Application secret" => "응용프로그램 secret",
"Application secret generated by registering this Tiki site as an application at Facebook" => "페이스북에 응용프로그램으로 사이트를 등록할 시 생성되는 응용프로그램 비밀",
"Application ID" => "응용프로그램 ID",
"Application ID generated by registering this Tiki site as an application at Facebook" => "페이스북에 응용프로그램으로써 사이트 등록함에 따라 생성되는 응용프로그램 id",
// "Facebook site name" => "Facebook site name",
// "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title" => "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title",
// "Facebook site image" => "Facebook site image",
// "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices" => "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices",
"Login using Facebook" => "페이스북 사용하여 로그인",
"Allow users to log in using Facebook" => "사용자가 페이스북을 사용하여 로그인 허용",
"Auto-create Tiki user" => "티키 사용자를 자동 만들기",
"Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "페이스북을 이용하여 로그인 한 사용자 중, 티키 계정이 없다면 자동으로 티키 사용자를 fb_xxxxxxxx 와 같은 사용자명으로 이용하여 만듬. 그렇지 않을 경우 티키 계정으로 링크를 하거나 등록을 하도록 요청될 것임",
// "Require Facebook users to enter local account info on creation" => "Require Facebook users to enter local account info on creation",
"Require Facebook users to enter local account info, specifically email and local log-in name" => "페이스북 사용자로 하여금 로컬 계정 정보를 입력하도록 요청, 특히 이메일과 로컬 로그인명",
// "Tiki can post to the Facebook wall" => "Tiki can post to the Facebook wall",
// "Tiki may post status messages, notes, photos, and videos to the Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to the Facebook Wall",
"Tiki can manage events" => "티키가 이벤트 관리 가능",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
"Tiki can manage pages" => "티키가 페이지 관리 가능",
"Tiki can manage user pages." => "티키는 사용자 페이지를 관리할 수 있습니다",
"Tiki can SMS" => "티키에서 SMS 전송가능",
"Tiki can use SMS functions via Facebook." => "티키는 페이스북을 통하여 SMS 할 수 있습니다",
// "Set user email from Facebook on creation" => "Set user email from Facebook on creation",
// "Create a user tracker item on registration" => "Create a user tracker item on registration",
// "First and last name tracker field IDs to set on creation" => "First and last name tracker field IDs to set on creation",
// "bit.ly login" => "bit.ly login",
"Site-wide log-in name (username) for bit.ly" => "bit.ly에 대한 사이트 전역 로그인 (사용자명)",
// "bit.ly key" => "bit.ly key",
"Site-wide API key for bit.ly" => "bit.ly 에 대한 사이트 전역 API 키",
"Use site-wide account" => "사이트 전역 계정 사용",
// "When set to \"yes\", only the site-wide account will be used for all users" => "When set to \"yes\", only the site-wide account will be used for all users",
// "Client ID" => "Client ID",
// "Client ID generated by registering this site as an application at LinkedIn" => "Client ID generated by registering this site as an application at LinkedIn",
// "Client secret" => "Client secret",
// "Client Secret generated by registering this site as an application at LinkedIn" => "Client Secret generated by registering this site as an application at LinkedIn",
// "Log in using LinkedIn" => "Log in using LinkedIn",
// "Allow users to log in using LinkedIn" => "Allow users to log in using LinkedIn",
// "Auto-create Tiki user from LinkedIn" => "Auto-create Tiki user from LinkedIn",
// "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Set user email from LinkedIn on creation" => "Set user email from LinkedIn on creation",
// "Tiki will set the user's email from Facebook on creation" => "Tiki will set the user's email from Facebook on creation",
// "Sets whether a tracker item should be created for the user upon registration" => "Sets whether a tracker item should be created for the user upon registration",
// "Comma-separated, with first name field followed by last name field; for example, '2,3'" => "Comma-separated, with first name field followed by last name field; for example, '2,3'",
// "Tiki will set the user's email from LinkedIn on creation" => "Tiki will set the user's email from LinkedIn on creation",
// "Stored searches" => "Stored searches",
// "Allow users to store search queries" => "Allow users to store search queries",
// "Expose Jitsi provision URL" => "Expose Jitsi provision URL",
// "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server" => "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server",
// "Jitsi configuration" => "Jitsi configuration",
// "Content of a Jitsi-format Java properties file" => "Content of a Jitsi-format Java properties file",
// "Location where tracker attachment files are stored" => "Location where tracker attachment files are stored",
// "Filesystem" => "Filesystem",
// "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory" => "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory",
// "Site theme" => "Site theme",
// "Icons of the displayed theme" => "Icons of the displayed theme",
// "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com" => "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com",
// "Site theme option" => "Site theme option",
// "Supplemental style sheet for the selected theme" => "Supplemental style sheet for the selected theme",
// "theme option, theme-option, style option, options, css" => "theme option, theme-option, style option, options, css",
// "Custom theme URL" => "Custom theme URL",
// "Local or external URL of the custom Bootstrap-compatible CSS file to use" => "Local or external URL of the custom Bootstrap-compatible CSS file to use",
// "Admin theme" => "Admin theme",
// "Theme for the settings panels and other administration pages" => "Theme for the settings panels and other administration pages",
// "Admin theme option" => "Admin theme option",
// "Option theme includes main theme CSS" => "Option theme includes main theme CSS",
// "Don't include the main theme stylesheet because its contents are included in the option stylesheet" => "Don't include the main theme stylesheet because its contents are included in the option stylesheet",
// "Navbar background color" => "Navbar background color",
// "Dark" => "Dark",
// "Light" => "Light",
// "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme" => "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme",
// "Fixed topbar offset" => "Fixed topbar offset",
// "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content" => "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content",
// "topbar offset, top offset, fixed topbar, top padding, offset" => "topbar offset, top offset, fixed topbar, top padding, offset",
"Icons" => "아이콘",
// "Icon set used by the site" => "Icon set used by the site",
// "Theme Customizer tool" => "Theme Customizer tool",
// "Activate the theme customizer tool to enable easy theme customization" => "Activate the theme customizer tool to enable easy theme customization",
"Check frequency" => "확인 빈도",
// "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. " => "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. ",
// "Click \"Check for Updates Now\" to perform an update check" => "Click \"Check for Updates Now\" to perform an update check",
"Each day" => "매 일",
"Each week" => "매 주",
"Each month" => "매 월",
"Upgrade cycle" => "업그레이드 빈도",
// "Tiki upgrade frequency for this site to check against" => "Tiki upgrade frequency for this site to check against",
"Regular (8 months)" => "일반 (8 개월)",
"Long-Term Support" => "장기 지원형",
"Minify JavaScript" => "자바스크립트 축소",
"Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "페이지 내에서 사용되는 자바스크립트 파일들을 정적으로 배포될 한 개의 파일로 압축. 자바스크립트 파일의 변경은 캐시 삭제가 필요하게 됩니다. http://code.google.com/p/minify/ 을 사용합니다",
// "Minify late JavaScript" => "Minify late JavaScript",
// "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page" => "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page",
"Minify CSS" => "CSS 축소화",
// "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared" => "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared",
// "Uses http://code.google.com/p/minify/" => "Uses http://code.google.com/p/minify/",
"Minify CSS into a single file" => "CSS 를 한 개의 파일로 축소화",
"In addition to reducing the size of the CSS files, reduce the number of files by consolidating them." => "ㅎ",
"This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"" => "이 설정은 모든 유형에 대하여 설치 직후 바로 작동되지 않을 수 있음. 가져오기는 @import \"...\" 이 아닌 @import url(\"...\") 을 사용해야 함",
// "Prefix CSS" => "Prefix CSS",
// "Use -prefix-free JavaScript library to add vendor specific css prefixes" => "Use -prefix-free JavaScript library to add vendor specific css prefixes",
// "May be replaced by a server-side option soon" => "May be replaced by a server-side option soon",
"Skip date for same day" => "동일한 날에 대하여 날짜 누락",
"When displaying short date and time, skip date for today. Only time will be displayed" => "날짜와 시간을 표기할 때, 오늘에 대한 날짜는 누락함. 시간만이 표기됨",
"Cache-control header" => "캐시 제어 머릿글",
"Custom HTTP header to use when a session is active" => "세션이 활성화인 경우 사용할 맞춤혐 HTTP 머릿글.",
"Example: no-cache, pre-check=0, post-check=0" => "예: no-cache, pre-check=0, post-check=0",
"Cache-control header (no session)" => "캐시 제어 머릿글 (세션 없음)",
"Custom HTTP header to use when no session is active" => "활성화된 세션이 없을 때 사용할 사용자 지정 HTTP 머릿글",
// "Content delivery networks" => "Content delivery networks",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance",
// "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com",
// "Content delivery networks in SSL" => "Content delivery networks in SSL",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode",
// "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com",
// "Check CDN files exists" => "Check CDN files exists",
// "Check that minified JS and CSS files exist before including them in the page" => "Check that minified JS and CSS files exist before including them in the page",
"Domain prefix handling" => "도메인 접두사 처리",
"Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "URL을 표준화하기 위하여 도메인명 상에 \"www.\" 접두어를 제거하거나 자동으로 추가",
"Leave as-is" => "그대로 두기",
"Remove the www" => "www 제거",
"Add the www" => "www 추가",
"Domain redirects" => "도메인 리디렉션",
"When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "사이트가 특정 도메인명을 통하여 접근되었을 때, URL을 보존하며 대체 도메인으로 리디렉션합니다. tikiwiki.org를 tiki.org로 하는 것처럼 도메인명 전이에 대하여 유용합니다.",
"One entry per line, with each entry a comma-separated list: old domain, new domain" => "한 줄 당 한 항목. 쉼표로 구분된 목록: old, new",
"Validate uploaded file content" => "업로드된 파일 내용 확인",
"Do not trust user input and open the files to verify their content" => "사용자 입력을 신뢰하지 않고 내용물을 확인하기 위하여 파일을 열어보지 않습니다",
"Allow the tiki_p_trust_input permission" => "tiki_p_trust_input 권한 허용",
"Bypass user input filtering." => "사용자 입력 필터링을 우회",
"Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "주의하십시오, 모든 권한들은 이를 포함한 관리 그룹에 허용됩니다, 그러므로 이를 활성화할 경우 귀하의 사이트를  관리 사용자에 대하여 XSS (교차 사이트 스크립팅) 공격에 노출할 수 있습니다",
// "Object selector threshold" => "Object selector threshold",
// "Number of records after which the object selectors will request searching instead of selecting from a list" => "Number of records after which the object selectors will request searching instead of selecting from a list",
// "Object selector search field" => "Object selector search field",
// "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")" => "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")",
// "Client key for this site" => "Client key for this site",
// "This must match the shared key entered in the Master’s key field" => "This must match the shared key entered in the Master’s key field",
// "Synchronize remote tracker" => "Synchronize remote tracker",
// "Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand" => "Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand",
"Refresh item link items when the master is modified" => "매스터가 수정될 때 항목 링크 항목을 다시 고침",
"To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "항목 링크가 트래커에서 사용될때 사용될 것으로써, 상세내역으로 색인된 매스터의 데이터가 검색을 위하여 수정되고 사용될 때 좋은 상태로 남아있도록 합니다",
// "Refresh items list items when related items are created or modified" => "Refresh items list items when related items are created or modified",
// "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified" => "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified",
"Clone tracker items" => "트래커 항목들 복제",
"Allow copying tracker item information to a new tracker item" => "트래커 항목 정보를 새 트래커 항목으로 복사 허용",
"Trackers available for insertion from wiki pages" => "위키 페이지에서 삽입 용으로 사용가능한 트래커",
"List of tracker IDs made available when attempting to insert" => "삽입을 시도할 때 사용할 수 있도록 된 트래커 ID들의 목록",
// "Change field types" => "Change field types",
// "Allow field type to be changed after creation" => "Allow field type to be changed after creation",
// "Use with care" => "Use with care",
// "Show comments below items" => "Show comments below items",
// "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab" => "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab",
// "Use legacy tracker insertion screen" => "Use legacy tracker insertion screen",
// "Use the legacy tracker insertion screen (a tab) instead of a popup dialog" => "Use the legacy tracker insertion screen (a tab) instead of a popup dialog",
// "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful" => "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful",
// "Show tracker status in objectlink" => "Show tracker status in objectlink",
// "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs" => "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs",
// "Sync wiki page name to linked tracker field" => "Sync wiki page name to linked tracker field",
// "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation" => "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation",
// "Redirect page views to the linked tracker item" => "Redirect page views to the linked tracker item",
// "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL" => "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL",
// "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL" => "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL",
// "Tracker for articles" => "Tracker for articles",
// "Have a tracker to supplement article information" => "Have a tracker to supplement article information",
// "Tracker ID of tracker for articles" => "Tracker ID of tracker for articles",
// "A tracker for articles must contain an \"Articles\" field" => "A tracker for articles must contain an \"Articles\" field",
// "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items" => "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items",
// "Tracker tabular" => "Tracker tabular",
// "Allows management of import/export tracker profiles and management of custom list formats" => "Allows management of import/export tracker profiles and management of custom list formats",
// "Always notify watchers" => "Always notify watchers",
// "Send item updated notifications to watchers even if nothing has changed" => "Send item updated notifications to watchers even if nothing has changed",
// "Require users to fill in tracker information" => "Require users to fill in tracker information",
// "Tracker ID of tracker required to be filled in" => "Tracker ID of tracker required to be filled in",
// "Mandatory tracker field to check for required filling in" => "Mandatory tracker field to check for required filling in",
// "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it" => "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it",
// "Fields that are asked for in the modal for force-filling" => "Fields that are asked for in the modal for force-filling",
// "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested" => "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested",
// "Tracker item links use prefix alias" => "Tracker item links use prefix alias",
// "Links for tracker items will use the prefix alias automatically everywhere" => "Links for tracker items will use the prefix alias automatically everywhere",
// "Tracker report resize button" => "Tracker report resize button",
// "Add a button to resize long tracker reports" => "Add a button to resize long tracker reports",
// "Tracker list order" => "Tracker list order",
// "Default order for the main tracker list" => "Default order for the main tracker list",
// "Id Ascending" => "Id Ascending",
// "Id Descending" => "Id Descending",
"Created Ascending" => "만듬 오름차순",
"Created Descending" => "만듬 내림차순",
"Name Ascending" => "이름 오름차순",
"Name Descending" => "이름 내림차순",
// "Last Modified Ascending" => "Last Modified Ascending",
// "Last Modified Descending" => "Last Modified Descending",
// "Number of Items Ascending" => "Number of Items Ascending",
// "Number of Items Descending" => "Number of Items Descending",
// "Tracker History Diff Style" => "Tracker History Diff Style",
// "Default style for tracker history" => "Default style for tracker history",
// "Original" => "Original",
// "Index article info in tracker item" => "Index article info in tracker item",
// "Require users to fill in a tracker form if not done already by prompting them with a modal dialog" => "Require users to fill in a tracker form if not done already by prompting them with a modal dialog",
// "Storage settings when file galleries are not used" => "Storage settings when file galleries are not used",
"Unified search engine" => "통합 검색 엔진",
"Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server." => "티키의 컨텐츠를 색인화하기 위해 사용되는 검색 엔진. 어떤 검색 엔진은 보다 큰 사이트에 더 적당할 수있으나, 서버 상에 추가 소프트웨어를 요구하기도 함.",
// "Lucene (PHP implementation) - Deprecated" => "Lucene (PHP implementation) - Deprecated",
// "Elasticsearch" => "Elasticsearch",
"Lucene index location" => "Lucene 색인 위치",
"Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database." => "Lucene 검색 색인의 위치 경로. 색인은 데이터베이스 볼륨을 포함하기에 충분한 공간이 있는 로컬 파일시스템에 있어야만 함.",
"Highlight results snippets" => "결과 조각 강조",
"Highlight the result snippet based on the search query to improve user experience" => "검색 질의에 기반한 결과 조각을 강조. 이 선택사항을 활성화하면 성능에 영향을 미치게 될 것입니다만 사용자 경험을 향상할 것입니다.",
"Lucene maximum results" => "Lucene 최대 결과",
"Maximum number of results to produce. Results beyond these will need a more refined query to be reached" => "노출할 결과의 최대양. 이를 초과하는 결과에 도달하려면 좀 더 정제된 질의가 필요합니다",
// "results" => "results",
"Lucene maximum result-set limit" => "Lucene 최대 결과 설정 한계",
"Maximum size of result set to consider" => "고려할 결과 세트의 최대 크기. 기본 1000, 0 = 무제한",
"This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "이는 결과 점수를 계산하고 순서를 정렬하기 위해 사용되며, 대규모 데이터 세트에서 메모리 오류를 불러올 수 있습니다. 기본값 1000 이 128M 으로 설정된 PHP memory_limit 에 안전합니다.",
// "result sets" => "result sets",
"Lucene terms per query limit" => "Lucene 의 질의 당 조건 한계",
"Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "생성될 조건의 최대 수. \" 질의 당 조건 제한에 도달했습니다\" 라는 오류를 얻게 되는 경우, 특별히 와일드카드, 범위 및 퍼지 검색의 경우, 이 값의 증가를 시도해 보십시오",
// "terms" => "terms",
"Lucene maximum number of buffered documents" => "Lucene 최대 버퍼된 문서",
"Number of documents required before the buffered in-memory documents are written into a new segment" => "버퍼된 메모리 안의 문서들이 새 세그먼트로 작성되기 전에 요구되는 문서의 수",
// "documents" => "documents",
"Lucene maximum number of merge documents" => "Lucene 최대 병합 문서",
"Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "adddocument() 에 의하여 병합된 문서의 최대 수. 적은 값 (예. 10,000 미만)은 대화형 색인에 좋습니다, 그 이유는 이것이 색인 중 일시 정지의 길이를 몇 초만으로 제한하기 때문입니다. 큰 값은 일괄처리되는 색인 및 더 빠른 검색에 대하여 좋습니다",
"Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "대화형 색인에 대하여서는 작은 값 (예, 10,000보다 작음)이 최고입니다. 루씬 기본에 대하여서는 0을 사용하십시오, 이는 실직적으로는 무제한입니다",
// "merge documents" => "merge documents",
// "Default Boolean Operator" => "Default Boolean Operator",
"Use OR or AND as the default search operator" => "기본 검색 연산자로써 OR (기본사항) 혹은 AND 을 사용",
// "AND" => "AND",
// "OR" => "OR",
"Lucene merge factor" => "Lucene 병함 요인",
"How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster" => "addDocument() 에 의하여 얼마나 자주 조각 색인들이 병합되어야 하는가 . 값이 적을 수록, 색인 중 적은 RAM 이 사용됩니다, 그리고 최적화되지 않은 색인에서 검색하는 것이 더 빠릅니다, 하지만 색인작업 속도는 더 느립니다. 값이 크면, 더 많은 RAM 이 색인작업 중 사용됩니다, 그리고 최적화되지 않은 색인에서 검색하는 것이 느리지만, 색인작업은 더 빠릅니다. 그러므로 일괄 색인 생성에는 큰 값들 (> 10) 이, 그리고 대화형으로 유지되는 색인에 대한 적은 값들 (< 10) 가장 좋습니다니다, ",
"Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained" => "큰 값들 (> 10) 이 일괄 색인 만들기 용으로 최고입니다, 그리고 적은 값들 (< 10) 은 대화형으로 유지되는 색인용입니다",
"Incremental Index Update" => "증분 색인 갱신",
"Update the index incrementally as the site content is modified" => "색인을 사이트 컨텐츠가 수정됨에 따라 증분적 갱신함. 색인을 주기적 기반으로 처리하는 것에 비하여 성능 및 정확도가 떨어질 수 있음",
// "This may lead to lower performance and accuracy than processing the index on a periodic basis" => "This may lead to lower performance and accuracy than processing the index on a periodic basis",
"Field weights" => "필드 가중치",
"Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results" => "검색 나열을 위하여 페이지에 등급을 부여할 때 적용하는 필드 가중치를 설정하는 것을 허용. 가중치는 필드가 질의 안에 있을 때만 적용합니다. 필드의 값을 무효화하려면, 의미없는 양을 사용하십시오, 0 은 안되며, 0 은 결과를 제거하는 것과 같은 예측하지 못한 동작의 결과를 불러올 수 있습니다.",
// "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search" => "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search",
"One field per line, field_name__:__5.3" => "한 줄 당 한 필드, field_name__:__5.3",
"Default content fields" => "기본 컨텐츠 필드",
"All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search" => "모든 컨텐",
"Tokenize version numbers" => "토큰화된 버전 번호",
"Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "버전 번호 문자열을 토큰화하여 하위버전이 언급될 때 메이저 버전이 발견되도록 함. 예를 들면 2.7에 대한 검색은 2.7.4를 포함하는 문서를 반환하지만 1.2.7은 반환하지 않음",
// "Cache per user and query for Tiki built-in search" => "Cache per user and query for Tiki built-in search",
// "Time in minutes a user has a same query cached applied to Tiki built-in search interface only" => "Time in minutes a user has a same query cached applied to Tiki built-in search interface only",
"Index forum replies together with initial post" => "루트 게시물과 함께 게시판 댓글들 색인",
"Forum replies will be indexed together with the initial post as a single document instead of being indexed separately." => "활성화 될 경우, 게시판 답글들은 별도로 색인되는 대신, 루트 게시와 함께 하나의 문서로써 함께 색인될 것입니다",
// "Relation types to index within object" => "Relation types to index within object",
// "Comma-separated relation types for which objects should be indexed in their related objects" => "Comma-separated relation types for which objects should be indexed in their related objects",
// "Elasticsearch needed" => "Elasticsearch needed",
// "Cache individual search formatters" => "Cache individual search formatters",
// "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache" => "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache",
"Format to use for tracker field keys" => "트래커 필드 키에 대하여 사용할 서식",
"Choose between field IDs and permanent names for the tracker indexing" => "트래커 색인을 위하여 필드 id와 영구적 이름 중 선택",
"Permanent name" => "영구적 이름",
"Field ID (backward compatibility mode with Tiki 7 and 8)" => "필드 ID (티키 7 과 8 과 과거 호환성 모드)",
// "Index Tracker Category names" => "Index Tracker Category names",
// "Index the names and paths of category field values" => "Index the names and paths of category field values",
// "Requires reindexing" => "Requires reindexing",
// "Cache result-specific formatted results" => "Cache result-specific formatted results",
// "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific" => "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific",
// "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature" => "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature",
"Excluded categories" => "제외된 범주들",
"List of category IDs to exclude from the search index" => "검색 색인에서 제외할 범주 ID들의 목록",
// "Excluded plugins" => "Excluded plugins",
// "List of plugin names to exclude while indexing" => "List of plugin names to exclude while indexing",
// "Exclude all plugins" => "Exclude all plugins",
// "Indexing will exclude all plugins" => "Indexing will exclude all plugins",
// "Except included plugins" => "Except included plugins",
// "List of plugin names that are required to be included while indexing, when excluding all" => "List of plugin names that are required to be included while indexing, when excluding all",
// "Example: fancytable,list,trackerlist,trackerfilter" => "Example: fancytable,list,trackerlist,trackerfilter",
// "Elasticsearch URL" => "Elasticsearch URL",
// "URL of any node in the cluster" => "URL of any node in the cluster",
// "Elasticsearch index prefix" => "Elasticsearch index prefix",
// "The prefix that is used for all indexes for this installation in Elasticsearch" => "The prefix that is used for all indexes for this installation in Elasticsearch",
// "Elasticsearch current index" => "Elasticsearch current index",
// "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index" => "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index",
// "Do not change this value unless you know what you are doing" => "Do not change this value unless you know what you are doing",
// "Tokenize CamelCase words" => "Tokenize CamelCase words",
// "Consider the components of camel-case words as separate tokens, allowing them to be searched individually" => "Consider the components of camel-case words as separate tokens, allowing them to be searched individually",
// "Conflicts with Tokenize Version Numbers" => "Conflicts with Tokenize Version Numbers",
// "Elasticsearch field limit per index" => "Elasticsearch field limit per index",
// "fields" => "fields",
// "The maximum number of fields per search index in Elasticsearch version 5.x and above" => "The maximum number of fields per search index in Elasticsearch version 5.x and above",
// "Use MySQL Full-Text Search (fallback)" => "Use MySQL Full-Text Search (fallback)",
// "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback" => "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback",
// "MySQL full-text search current index" => "MySQL full-text search current index",
// "Unified index identifier fields (Internal)" => "Unified index identifier fields (Internal)",
// "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding" => "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding",
// "Use unified search in category admin" => "Use unified search in category admin",
// "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index" => "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index",
// "Stop Word List" => "Stop Word List",
// "Words excluded from the search index, because they can be too frequent and produce unwanted results" => "Words excluded from the search index, because they can be too frequent and produce unwanted results",
// "MySQL full-text search has its own list of stop words configured in the server" => "MySQL full-text search has its own list of stop words configured in the server",
// "Automatically trim Elasticsearch results on date-sorted query" => "Automatically trim Elasticsearch results on date-sorted query",
// "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date" => "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date",
// "Highlight results pages" => "Highlight results pages",
// "Highlight words on the result pages based on the search query" => "Highlight words on the result pages based on the search query",
// "Plugins tab of the textarea control panel loads with an empty list" => "Plugins tab of the textarea control panel loads with an empty list",
// "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially" => "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially",
// "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")" => "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")",
// "Possessive Stemmer" => "Possessive Stemmer",
// "LIST plugin cache default on" => "LIST plugin cache default on",
// "If selected, LIST plugins will be cached by default unless turned off at plugin level" => "If selected, LIST plugins will be cached by default unless turned off at plugin level",
// "LIST plugin cache default expiry" => "LIST plugin cache default expiry",
// "Default number of minutes for LIST plugin cache expiry" => "Default number of minutes for LIST plugin cache expiry",
// "The possessive stemmer removes possessives (trailing \"'s\\" => "The possessive stemmer removes possessives (trailing \"'s\\",
"Re-validate user by email after" => "이메일로 사용자 재확인 조건",
"unsuccessful login attempts" => "로그인 시도 실패",
// "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password" => "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password",
// "brute force, brute-force, login failure, login-failure, failed logins" => "brute force, brute-force, login failure, login-failure, failed logins",
"Suspend account after" => "계정 정지 조건",
// "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again",
"URL the user is redirected to after account validation" => "계정 확인 후 사용자가 보내지는 URL",
// "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"" => "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"",
"Account validated successfully." => "계정이 성공적으로 확인됨",
"The URL that the anonymous user is redirected to when a page is not found" => "페이지가 발견되지 않을 때 익명사용자가 보내질 URL",
// "Use Only ASCII in SEFURLs" => "Use Only ASCII in SEFURLs",
// "Do not use accented characters in short (search engine friendly) URLs" => "Do not use accented characters in short (search engine friendly) URLs",
// "Close site when server load is above the threshold" => "Close site when server load is above the threshold",
"Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site" => "서버 부하가 임계치를 넘었을 때 사이트 닫기 (권한 보유자들은 제외)",
"Use proxy" => "프록시 사용",
"Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified" => "프록시 사용",
"Use context menus for actions (icons)" => "작업에 대한 상황적 메뉴 사용 (아이콘)",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
"Use context menus for actions (text)" => "작업에 대한 상황적 메뉴 사용 (텍스트)",
// "Show user's real name" => "Show user's real name",
"Show the user's real name instead of username (log-in name), when possible." => "로그인 대신 사용자의 실명 표시 (가능할 경우)",
// "User emails must be unique" => "User emails must be unique",
// "The email address of each user must be unique" => "The email address of each user must be unique",
"Display user tracker information on the user information page" => "사용자트래커 정보를 사용자 정보 페이지에 표기",
"Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "표시될 사용자 트래커 ID 를 모두 쉼표로 구분하여 입력하십시오. 예제: 1,1,2,3,4 (사용자 트래커 ID 1 뒤에 필드 ID들 1-4 옵니다)",
"Users can configure modules" => "사용자가 모듈을 설정할 수 있습니다",
// "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user" => "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user",
"Users can open and close the modules" => "사용자가 모듈에 그림자효과를 줄 수 있습니다",
"Allows users to open and close modules using the icon in the module header." => "사용자가 모듈을 숨김/표시를 허용",
"Module decides" => "모듈이 결정",
"Store full-size copy of profile picture in file gallery" => "아바타의 전체크기 사본을 파일 갤러리에 저장",
// "Size of the small profile picture stored for users" => "Size of the small profile picture stored for users",
// "Crop the profile picture thumbnail to a square" => "Crop the profile picture thumbnail to a square",
"File gallery in which to store full-size profile picture" => "아바타의 전체 크기 사본을 저장해 둘 파일 갤러리",
"Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "여기에 갤러리 id 를 입력하십시오. 보안을 위하여 관리자만의 전용 갤러리를 만드시거나 갤러리 권한이 관리자들만이 편집할 수 있다는 것을 확인하여 주십시오",
"File ID of default profile picture" => "기본 아바타 이미지의 파일 ID",
"File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries" => "사용자가 파일 갤러리에 아바타 그림이 없을 경우 아바타로 사용될 파일 갤러리 내부의 그림의 파일 ID",
"Display who has viewed \"my items\" on the user information page" => "사용자 정보 페이지에 내 정보를 본 사람 표기",
"This requires activation of tracking of views for various items in the action log" => "이 것이 동작하려면 작업 로그 내부에서 다양한 항목에 대한 보기의 추적을 활성화해야 합니다",
// "Length of \"who viewed my items\" history" => "Length of \"who viewed my items\" history",
"Number of days before the current day to consider when displaying \"who viewed my items\"" => "누가 내것을 보았나를 표시할 때 고려할 현재 시간 이전의 날의 수",
"Show to others \"who viewed my items\" on the user information page" => "사용자 정보 페이지 상에서 내 것을 본 사람들에게 표시",
"Show to others \"who viewed my items\" on the user information page. Admins can always see this information" => "사용자 정보 페이지에서 내 것을 본 다른 사용자를 표시. 관리자는 이 정보를 항상 볼 수 있습니다",
"Use pretty trackers for registration form" => "등록 양식에 대하여 프리티 트래커 사용",
"Registration pretty tracker template" => "등록 프리티 트래커 템플릿",
"Use a wiki page name or Smarty template file with a .tpl extension." => "위키 페이지명 혹은 tpl 확장자가 있는  템플릿 파일 사용",
// "Hide Mandatory" => "Hide Mandatory",
// "Hide mandatory fields indication with an asterisk (shown by default)" => "Hide mandatory fields indication with an asterisk (shown by default)",
"Output the registration results" => "등록 결과를 출력",
"Use a wiki page as template to output the registration results to" => "등록 결과를 출력하기 위하여 위키 페이지를 템플릿으로 사용",
"Output registration pretty tracker template" => "출력 등록 프리티 트래커 템플릿",
"Wiki page only" => "위키 페이지만",
"Page name field ID" => "페이지명 필드ID",
"User tracker IDs to sync prefs from" => "기본설정을 동기화할 사용자 트래커 ID들",
"Select one or more trackers to sync user preferences from" => "사용자 기본설정을 동기화할 트래커들의 쉼표로 구분된 ID들을 입력하십시오",
"Tracker field IDs to sync the \"real name\" pref from" => "다음으로부터 실명 기본설정을 동기화할 트래커 필드 ID",
"Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"." => "선택되는 우선순위로 쉼표로 구분된 ID들을 입력하십시오, 각 항목은 +를 사용하여 여러개의 필드를 연결할 수 있습니다, 예: 2+3,4",
// "Tracker field IDs to sync user groups" => "Tracker field IDs to sync user groups",
// "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups" => "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups",
"Synchronize long/lat/zoom to location field" => "위치 필드의 위도/경도/확대/축소 동기화",
"Synchronize user geolocation preferences with the main location field." => "사용자 지리적 위치 기본설정을 주 위치 필드에 동기화",
"Change user system language when changing user tracker item language" => "사용자 트래커 항목 언어 변경 시 사용자 시스템 언어 변경",
// "Assign a user tracker item when registering if email equals this field" => "Assign a user tracker item when registering if email equals this field",
// "Maximum users in drop-down lists" => "Maximum users in drop-down lists",
// "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large" => "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large",
"users" => "사용자",
"Use the user's real name instead of log-in name in the autocomplete selector in trackers" => "트래커 기능에서 자동완료 선택기 내부에서 사용자의 실명을 로그인 대신 사용",
"Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature." => "메시징 기능에서 자동완료 선택기 사용자의 실명을 로그인 대신 사용",
// "User favorites" => "User favorites",
"Enable users to flag content as their favorite." => "사용자가 컨텐츠를 자신의 즐겨찾기로 지정하는 것을 허용용",
// "User likes" => "User likes",
// "Enable users to \"like\" content" => "Enable users to \"like\" content",
"Users must choose a group at registration" => "사용자는 등록 시 그룹을 선택하여야만 합니다",
"Users cannot register without choosing one of the groups indicated above" => "사용자는 위에 정의된 그룹들의 하나를 선택하지 않고 등록할 수 없습니다",
"Users available in search results" => "검색 결과 내부에서 제공되는 사용자들",
"Users available within search results. Content related to the user will be included in the index" => "검색 결과 내부에 사용가능한 사용자. 사용자에 관련한 컨텐츠는 색인에 포함될 것입니다",
"Public" => "공용",
// "Use Gravatar for user profile pictures" => "Use Gravatar for user profile pictures",
// "Always request the Gravatar image for the user profile picture" => "Always request the Gravatar image for the user profile picture",
// "Configuration for multilike" => "Configuration for multilike",
// "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)" => "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)",
// "Force users to upload an avatar" => "Force users to upload an avatar",
"Score ascending" => "점수 오름차순",
"Score descending" => "점수 내림차순",
"Name ascending" => "이름 오름차순",
"Name descending" => "이름 내림차순",
"Login ascending" => "로그인 오름차순",
"Login descending" => "로그인 내림차순",
"User the tracker's field ID whose value is used as the output page name." => "사용자 트래커 필드 ID. 이 값은 출력 페이지명으로써 사용됨",
// "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup" => "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup",
"Quota" => "할당량",
"Private" => "비공개",
// "Users cannot see each other's files or galleries" => "Users cannot see each other's files or galleries",
// "Users can see each other's files, but don't see the galleries in listings" => "Users can see each other's files, but don't see the galleries in listings",
"Username pattern" => "사용자명 패턴",
// "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/" => "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/",
"Serve profile pictures statically" => "아바타 이미지를 정적으로 제공",
"When enabled, feature checks and permission checks will be skipped" => "활성화 될 경우, 기능 확인 및 권한 확인을 건너뜀",
"Displayed time zone" => "표시할 시간대",
"Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "사용자 기본설정에서 설정된 시간대 사용, 혹은 자동으로 익명사용자에 대하여 시간대를 감지 (브라우저가 허용하는 경우). 사이트 기본이 대비책으로 사용됨",
"Always the site default time zone" => "항상 사이트 기본 시간대",
"Number of visited pages to remember" => "기억할 방문된 페이지의 갯수",
// "visited pages" => "visited pages",
"User information" => "사용자정보",
// "Specify if the user's information is public or private" => "Specify if the user's information is public or private",
"Use 12-hour clock for time selectors" => "시간 선택기에서 12-시간 시계를 사용",
"Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc" => "일부 편집창에서 신규 혹은 편집된 블로그 게시물, 기사, 등등에 대한 시간을 설정하는 시간 선택기에서 12시간 시계 (오전과 오후)를 사용",
"Use interface that shows differences in any versions" => "어떤 버전 인터페이스 새 diff 사용",
"Tasks per page" => "페이지당작업수",
// "tasks" => "tasks",
// "20" => "20",
// "40" => "40",
// "50" => "50",
"Messages per page" => "페이지당 메시지",
"Allow messages from other users" => "다른 사용자에게서 메시지 허가",
"Notify sender when reading mail" => "이메일을 읽었을 때 발신인에게 알림",
"Send me an email for messages with priority equal to or greater than" => "다음과 동등하거나 높은 우선순위도의 메시지에 대하여 나에게 이메일 전송",
// "priority" => "priority",
"Auto-archive read messages after" => "디음 기간 후 읽은 메시지 자동 보관",
// "The number of days after which Tiki will archive the messages that have been read by the user" => "The number of days after which Tiki will archive the messages that have been read by the user",
// "60" => "60",
"My pages" => "내 페이지",
// "List all wiki pages edited by the user" => "List all wiki pages edited by the user",
"My blogs" => "내 블로그",
// "List all blogs and blog posts edited by the user" => "List all blogs and blog posts edited by the user",
"My galleries" => "내 갤러리",
// "List all galleries edited by the user" => "List all galleries edited by the user",
"My messages" => "내 메시지",
// "List all messages and replies by the user" => "List all messages and replies by the user",
"My tasks" => "내 작업",
// "List all tasks by the user" => "List all tasks by the user",
"My forum topics" => "내 게시판 토픽들",
// "List all forum topics by the user" => "List all forum topics by the user",
"My forum replies" => "내 게시판 답글들",
// "List all forum replies by the user" => "List all forum replies by the user",
"My items" => "내 항목",
// "List all tracker items by the user" => "List all tracker items by the user",
"Character set for mail" => "메일에 대한 캐릭터 세트",
// "Keep closed remarksbox hidden" => "Keep closed remarksbox hidden",
// "XMPP account JID or username" => "XMPP account JID or username",
// "XMPP account password" => "XMPP account password",
// "XMPP http-bind URL" => "XMPP http-bind URL",
// "Full URL to the http-bind" => "Full URL to the http-bind",
// "https://xmpp.example.org/http-bind/" => "https://xmpp.example.org/http-bind/",
// "Pre-set show user's info on mouseover" => "Pre-set show user's info on mouseover",
// "Set new users' info to display in a popup when their name is hovered over" => "Set new users' info to display in a popup when their name is hovered over",
// "Remember the alert boxes that users have closed and don't display them again" => "Remember the alert boxes that users have closed and don't display them again",
"Validator emails (separated by comma) if different than the sender email" => "발신인 이메일과 다를 경우 유효성 검사 이메일 (쉼표로 구분됨)",
// "Vimeo upload" => "Vimeo upload",
// "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API" => "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API",
// "Vimeo delete" => "Vimeo delete",
// "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted" => "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted",
// "Permanently removes videos from the registered vimeo.com account" => "Permanently removes videos from the registered vimeo.com account",
// "Vimeo consumer key" => "Vimeo consumer key",
// "API consumer key" => "API consumer key",
// "Vimeo consumer secret" => "Vimeo consumer secret",
// "API consumer secret" => "API consumer secret",
// "Vimeo access token" => "Vimeo access token",
// "The access token that is automatically generated by Vimeo when API keys are requested" => "The access token that is automatically generated by Vimeo when API keys are requested",
// "Vimeo access token secret" => "Vimeo access token secret",
// "The access token secret automatically generated by Vimeo when API keys are requested" => "The access token secret automatically generated by Vimeo when API keys are requested",
// "Vimeo Default Gallery" => "Vimeo Default Gallery",
// "The The ID of the default file gallery in which to store the Vimeo reference" => "The The ID of the default file gallery in which to store the Vimeo reference",
"Display by default" => "기본적으로 표기",
"Path (if stored in directory)" => "경로 (디렉터리에 저장된 경우)",
"Edit idle timeout" => "대기 타임아웃 편집",
// "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains" => "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains",
// "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually" => "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually",
// "How to trigger Web Cron" => "How to trigger Web Cron",
// "Calling the Web Cron URL" => "Calling the Web Cron URL",
// "Adding JavaScript that calls Web Cron" => "Adding JavaScript that calls Web Cron",
// "URL and JavaScript" => "URL and JavaScript",
// "Run interval" => "Run interval",
// "The amount of time of each run" => "The amount of time of each run",
"Token" => "토큰",
// "The token to use when running the cron manually" => "The token to use when running the cron manually",
// "Default cache" => "Default cache",
// "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response" => "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response",
// "Last Modified" => "Last Modified",
"Last editor" => "최종 편집자",
"Wiki link format" => "위키 링크 서식식",
"Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))" => "페이지명에 대한 위키 링크로서 특수 문자의 어떤 단계까지 허용되는지. 예: ((Page &eacute;&agrave;&icirc;))",
"\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"." => "엄격은 a-z 와 0-9 과 같은 기본 캐릭터만 허용됨. 페이지명에 강조표기나 특수 캐릭터가 있다면, 엄격을 사용하지 마십시오.",
"Complete" => "완전",
"Relaxed" => "느슨",
"Strict" => "엄격",
// "Wiki URL scheme" => "Wiki URL scheme",
// "Alter the SEFURL pattern for page names" => "Alter the SEFURL pattern for page names",
// "Use the \"View\" action to regenerate your URLs after changing this setting" => "Use the \"View\" action to regenerate your URLs after changing this setting",
// "Show the page version" => "Show the page version",
"Display the page version information when viewing the page" => "페이지 볼 때 페이지 버전 정보 표시",
// "Display the page name above the page area" => "Display the page name above the page area",
"Display the page name in small text at the top of each page (above the page's content)." => "페이지 이름을 페이지 내부 대신 페이지 위에 표시",
// "Display the page name inside the page content" => "Display the page name inside the page content",
"Page name display stripper" => "페이지명 표시 stripper",
// "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
"Wiki author list style" => "위키 저자 목록 스타일",
"Change the list format that is used to display the authors of the page." => "페이지의 저자를 표기하기 위해 사용되는 목록 서식을 변경함",
"Creator and Author" => "만든이 & 저자",
"Business style" => "비즈니스 스타일",
"Collaborative style" => "협업 스타일",
"Page last modified on" => "페이지 최종 수정일",
"none (disabled)" => "없음 (비활성화됨)",
"Specify wiki author list style per page" => "페이지 당 위키 저자 목록 스타일을 지정",
"Enable the style in which the author list is displayed to be modified on a per-page basis" => "사용자 목록이 페이지 당 기반으로 표시되는 스타일로 수정하는 것을 허용합니다",
"Wiki page edit buttons location" => "위키 작업 바 위치",
"Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page" => "버튼: 저장, 미리보기, 취소, ..",
"Wiki navigation bar location" => "위키 탐색 바 위치",
"When using the ...page... page break wiki syntax" => "...page... 페이지 브레이크 위키 문법을 사용할 때",
"Wiki top line location" => "위키 상단 줄 위치",
// "Page description, page actions, icons, backlinks..." => "Page description, page actions, icons, backlinks...",
// "Display ShareThis icon prominently" => "Display ShareThis icon prominently",
// "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)" => "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)",
"Cache wiki pages (global)" => "위키 페이지 캐시 (전역)",
"Enable page cache globally for wiki pages." => "위키 페이지에 대하여 전역으로 페이지 캐시를 활성화.",
"no cache" => "캐시 안함 ",
"Allow comments per wiki page" => "위키 페이지 당 댓글 허용",
// "Enable control of comments on wiki pages on a per-page basis" => "Enable control of comments on wiki pages on a per-page basis",
"Enable (default On)" => "활성화 (켜짐 기본)",
"Enable (default Off)" => "활성화 (꺼짐 기본)",
// "Wiki copyright" => "Wiki copyright",
"Prevent special characters in page names" => "페이지 이름에 특수 문자 금지",
"Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters" => "어떤 글자들은 페이지가 URL 혹은 위키 링크를 통하여 쉽게 접근되는 것을 방해합니다. 이 선택사항은 그러한 글자로 페이지를 만드는 것을 방지합니다",
"Page ranking reload probability" => "페이지 순위 리로드 확률",
"Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking." => "페이지 순위를 계산하는 것은 각각의 페이지 로드 때마다 수행될 수 없는 비싼 작업입니다. 주사위 굴리기 식에 기반하여 무작위로 페이지 로드 시 계산될 것입니다. 이 선택사항은 주사위의 표면 수를 지정합니다. 더 큰 수일 수록 더 적은 로드가 일어나지만 덜 정확한 순위가 부여됩니다.",
"Encourage contribution to wiki pages by anonymous" => "익명사용자에 의한 위키 페이지 기여 권장",
"When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page" => "페이지가 편집가능하지 않고 사용자가 익명일지라도 편집 링크를 표시합니다. 방문객은 로그인 스크린으로 이동되고 등록하도록 권장될 것입니다",
"Warn before page lock timeout" => "페이지 잠금 타임아웃 전에 경고",
"Provide a JavaScript alert before the user's lock on a page times out" => "사용자의 페이지에 대한 잠금이 타임아웃되기 전에 자바스크립트 알림을 제공",
"Dynamic variables" => "유동 변수",
"Global snippets of text that can be included in wiki pages and edited in place" => "위키 페이지 내부에 포함될 수 있고 해당 장소에서 편집될 수 있는 전역 텍스트 조각들",
"Single (%varname%)" => "한 개의 (%varname%)",
"Double (%%varname%%)" => "이중 (%%varname%%)",
"Multilingual dynamic variables" => "다국어 유동적 변수",
"Make dynamic variable content language-specific" => "유동 변수를 컨텐츠 언어에 특화",
// "Allow plugin-specific edits" => "Allow plugin-specific edits",
// "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page" => "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page",
// "This feature is unavailable outside wiki pages, whether or not this preference is enabled" => "This feature is unavailable outside wiki pages, whether or not this preference is enabled",
// "Allow section-specific edits" => "Allow section-specific edits",
// "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section" => "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section",
// "Section-specific edits maximum level" => "Section-specific edits maximum level",
// "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections" => "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections",
// "Only display focused edit icons (for sections and/or plugins) on request" => "Only display focused edit icons (for sections and/or plugins) on request",
// "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page" => "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page",
// "Allow minor edits of wiki pages" => "Allow minor edits of wiki pages",
"Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)" => "사소한 편집은 번역이 되어야할 새 컨텐츠로 표시되지 않으며 주시 알림을 보내지 않습니다 (단, \"사소한 편집 주시\" 가 활성화 된 경우는 예외)",
// "Display comment list by default" => "Display comment list by default",
// "Display Post new comment form by default" => "Display Post new comment form by default",
"Simple wiki comment ratings" => "단순 위키 댓글 등급",
"Enable users to rate comments based on a simple numeric scale" => "사용자들이 단순한 수치 배율에 기반하여 댓글을 평가하는 것을 활성화",
"Wiki rating options" => "위키 등급 선택사항",
"List of options available for the rating of wiki comments" => "위키 댓글의 등급에 대하여 사용할 수 있는 선택사항의 목록",
"Add a slideshow button on wiki pages" => "위키 페이지에 슬라이드쇼 버튼 추가",
"Page creators are administrators of their pages" => "페이지 만든이는 자신들의 페이지의 관리자입니다",
"Create watch for author on page creation" => "페이지 만들기 때 저자를 위해 주시 만들기",
"Enable watches on comments" => "댓글 상 주시하기 허용",
"Watch minor edits" => "사소한 편집 주시",
"Page ID" => "페이지 ID",
// "Page name maximum displayed length" => "Page name maximum displayed length",
// "Comment of the latest edit" => "Comment of the latest edit",
// "Description maximum displayed length" => "Description maximum displayed length",
"Versions" => "버전들",
"Categories path" => "범주 경로",
"Default sort order" => "기본 정렬 순서",
"Sort Direction" => "정렬 방향",
// "Visibility of discussion" => "Visibility of discussion",
// "Just a button among others (default), or special section" => "Just a button among others (default), or special section",
// "In the button bar (default)" => "In the button bar (default)",
// "Special section above button bar" => "Special section above button bar",
"Forum for discussion" => "토론을 위한 게시판",
"Allow management of keywords on a per-page basis" => "페이지 당 기반으로 핵심단어 관리 허용",
"Similar pages only listed in same language" => "동일한 언어 안에 나열된 유사한 페이지들만",
"When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page" => "유사 페이지를 나열할 때, 누락된 페이지 404와 같은 경우, 요청과 같은 언어로 된 페이지만 표기",
"Mandatory wiki page edit summary" => "위키 페이지상의 필수 편집 요약",
"Reject save attempts that do not include an edit summary describing the changes made" => "변경되는 내용을 설명할 편집 요약을 제공하지 않는 저장 시도는 거부함",
// "Position of tags selection" => "Position of tags selection",
// "Place the tags selection more prominently than under the \"Properties\" tab" => "Place the tags selection more prominently than under the \"Properties\" tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Tags tab" => "Tags tab",
"Structure navigation bar location" => "구조체 탐색 바 위치",
"Display Next and Back buttons, breadcrumbs, and a form to add a new page" => "다음/뒤로 버튼, 사이트 이동 경로, 및 새 페이지를 추가할 서식을 표시",
// "Backlink page names maximum displayed length" => "Backlink page names maximum displayed length",
// "Show blog posts" => "Show blog posts",
// "Blog posts linking to a wiki page are shown as backlinks" => "Blog posts linking to a wiki page are shown as backlinks",
// "Show forum posts" => "Show forum posts",
// "Forum posts linking to a wiki page are shown as backlinks" => "Forum posts linking to a wiki page are shown as backlinks",
// "Show comments" => "Show comments",
// "Comments linking to a wiki page are shown as backlinks" => "Comments linking to a wiki page are shown as backlinks",
// "Show articles" => "Show articles",
// "Articles linking to a wiki page are shown as backlinks" => "Articles linking to a wiki page are shown as backlinks",
// "Show tracker items" => "Show tracker items",
// "Tracker items linking to a wiki page are shown as backlinks" => "Tracker items linking to a wiki page are shown as backlinks",
"Show trackers" => "트래커 표시",
// "Trackers with a description linking to a wiki page are shown as backlinks" => "Trackers with a description linking to a wiki page are shown as backlinks",
// "Show tracker fields" => "Show tracker fields",
// "Tracker fields with a description linking to a wiki page are shown as backlinks" => "Tracker fields with a description linking to a wiki page are shown as backlinks",
// "Show calendar events" => "Show calendar events",
// "Calendar events with a description linking to a wiki page are shown as backlinks." => "Calendar events with a description linking to a wiki page are shown as backlinks.",
"Simple wiki ratings" => "단순 위키 등급",
// "Enable users to rate wiki pages based on a simple numeric scale" => "Enable users to rate wiki pages based on a simple numeric scale",
"List of options available for the rating of wiki pages" => "위키 페이지의 등급에 대하여 사용할 수 있는 선택사항의 목록",
"Semantic link types to use as page alias markers" => "페이지 별칭 표식기로써 사용될 시맨틱 링크 유형",
"Comma-separated list of semantic links to identify a page as an alias of another" => "페이지를 다른 페이지의 별칭으로써 식별하기 위하여 사용될 시맨틱 링크들의 쉼표로 구분된 목록",
"Redirect pages using these prefix-alias semantic links" => "다음의 접두어 별칭 semantic 링크를 사용하여 페이지 리디렉션하기",
"Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link" => "시맨틱 링크가 있는 페이지로 리디렉트될 페이지들의 접두어들의 쉼표로 구분된 목록",
"Wiki page pagination" => "위키 페이지매김",
"Enable the separation of a wiki page's content into a set of two or more paginated pages" => "위키페이지를 구분자를 사용하여 페이지 매김된 페이지로 분리하는 것을 허용",
"Wiki page separator" => "위키페이지 분리자",
"The separator to use in wiki page content to mark the end of each page section" => "위키 페이지의 컨텐츠 내부에서 컨텐츠를 분할하기 위해서 사용될 분리 기호",
// "Wiki auto-toc" => "Wiki auto-toc",
// "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties" => "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties",
// "Inline auto-toc" => "Inline auto-toc",
// "Change the display of the table of contents for wiki pages to inline" => "Change the display of the table of contents for wiki pages to inline",
// "Table of contents position" => "Table of contents position",
// "Position of the table of contents, either top, left, right (right is the default)" => "Position of the table of contents, either top, left, right (right is the default)",
// "Table of contents offset" => "Table of contents offset",
// "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin" => "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin",
// "Table of contents default" => "Table of contents default",
// "Set the default for the table of contents (default \"on\" and can be toggled per page)" => "Set the default for the table of contents (default \"on\" and can be toggled per page)",
"On" => "켜기",
"Off" => "끄기",
// "Add an option to hide the page title per wiki page" => "Add an option to hide the page title per wiki page",
// "Enable the page title to not be displayed, on a per-page basis" => "Enable the page title to not be displayed, on a per-page basis",
// "Multilevel style numbering for ordered lists" => "Multilevel style numbering for ordered lists",
// "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc" => "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc",
// "Force link to included page" => "Force link to included page",
// "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used" => "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used",
// "Date Field" => "Date Field",
// "The field indexed as the global \"date\" field" => "The field indexed as the global \"date\" field",
// "You will need to rebuild the search index after changing this" => "You will need to rebuild the search index after changing this",
// "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it" => "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it",
// "Maximum displayed length of the latest edit's comment" => "Maximum displayed length of the latest edit's comment",
"Plugin %0" => "%0 플러그인",
// "Global cache time for the plugin snarf" => "Global cache time for the plugin snarf",
"Default cache time for the plugin snarf" => "snarf 플러그인에 대한 기본 캐시 시간",
"0 for no cache" => "캐시 없을 경우 0",
// "GUI for the list plugin" => "GUI for the list plugin",
// "Experimental GUI for the list plugin in popup plugin edit forms" => "Experimental GUI for the list plugin in popup plugin edit forms",
// "(listgui)" => "(listgui)",
// "Plugin trackerlist converter" => "Plugin trackerlist converter",
// "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead" => "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead",
// "Maximum plugin parsing passes" => "Maximum plugin parsing passes",
// "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin" => "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin",
// "passes" => "passes",
// "Setting this to a higher value than the default of 500 may have performance implications" => "Setting this to a higher value than the default of 500 may have performance implications",
"Inline plugin %0" => "인라인 플러그인 %0",
"Plugin pending approval notification" => "플러그인 승인 알림 대기 중",
"Send an email alert to users with permission to approve plugins when a plugin approval is pending" => "플러그인이 승인 보류 중일 때 플러그인을 승인하기 위하여 권한을 보유한 사용자에게 이메일로 알림",
// "Hide admin wizard on log-in when an admin user logs in" => "Hide admin wizard on log-in when an admin user logs in",
"Workspace UI" => "작업공간 UI(",
"Combines multiple site features to create a workspace experience for workgroups" => "티키 내의 여러 기능들을 묶어서 작업그룹에 대하여 작업공간 경험을 형성",
"Workspace root category" => "작업공간 루트 범주",
"ID of the root category containing all workspaces" => "모든 작업공간을 포함하는 루트 범주의 ID",
"This value is automatically managed and should not need to be modified manually" => "이 값은 자동으로 관리되며 수동으로 수정되지 않아야 합니다",
// "Full WYSIWYG editor is optional" => "Full WYSIWYG editor is optional",
// "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used" => "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used",
// "Switching between HTML and wiki formats can cause problems for some pages" => "Switching between HTML and wiki formats can cause problems for some pages",
// "Full WYSIWYG editor is displayed by default" => "Full WYSIWYG editor is displayed by default",
// "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages" => "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages",
"Reopen with the same editor" => "동일한 편집기로 다시 열기",
// "Ensures the editor last used to edit a page or item is used for the next edit as the default" => "Ensures the editor last used to edit a page or item is used for the next edit as the default",
// "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed" => "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed",
"Use Wiki syntax in WYSIWYG" => "WYSIWYG 에서 위키 문법 사용",
// "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"" => "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"",
// "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools" => "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools",
// "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)" => "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)",
// "CKeditor offers possibilities which may not be expressible in Tiki syntax" => "CKeditor offers possibilities which may not be expressible in Tiki syntax",
// "Full WYSIWYG editor skin" => "Full WYSIWYG editor skin",
"Moono (Default)" => "Moono (기본)",
// "Kama" => "Kama",
// "Bootstrap CK" => "Bootstrap CK",
// "Minimalist" => "Minimalist",
// "Office 2013" => "Office 2013",
// "Typefaces" => "Typefaces",
// "List of font names separated by semi-colons (\";\")" => "List of font names separated by semi-colons (\";\")",
// "Inline WYSIWYG editor" => "Inline WYSIWYG editor",
// "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required" => "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required",
// "Extra plugins" => "Extra plugins",
// "List of plugin names (separated by,)" => "List of plugin names (separated by,)",
// "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard" => "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard",
// "Support Tiki's \"wiki syntax\" in HTML pages" => "Support Tiki's \"wiki syntax\" in HTML pages",
// "XMPP client (ConverseJS)" => "XMPP client (ConverseJS)",
// "Integration with Converse.js XMPP client" => "Integration with Converse.js XMPP client",
// "XMPP server domain" => "XMPP server domain",
// "example.org" => "example.org",
// "XMPP MUC Domain" => "XMPP MUC Domain",
// "Required for auto-joining rooms" => "Required for auto-joining rooms",
// "conference.example.org" => "conference.example.org",
// "The authentication method to be used by XMPP client" => "The authentication method to be used by XMPP client",
// "OAuth (uses Tiki as provider)" => "OAuth (uses Tiki as provider)",
// "Openfire TikiToken" => "Openfire TikiToken",
// "Allow anonymous" => "Allow anonymous",
// "Allow anonymous users on Chat" => "Allow anonymous users on Chat",
// "Openfire REST API endpoint" => "Openfire REST API endpoint",
// "Full URL to API endpoint" => "Full URL to API endpoint",
// "https://xmpp.example.org:9091/plugins/restapi/v1/" => "https://xmpp.example.org:9091/plugins/restapi/v1/",
// "Rest API username" => "Rest API username",
// "Username to allow Openfire API usage" => "Username to allow Openfire API usage",
// "Rest API password" => "Rest API password",
// "Password to allow Openfire API usage" => "Password to allow Openfire API usage",
// "ConverseJS Debug Mode" => "ConverseJS Debug Mode",
// "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console" => "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console",
// "ConverseJS Extra Settings" => "ConverseJS Extra Settings",
// "JSON format object defining extra optional settings to initialize ConverseJS" => "JSON format object defining extra optional settings to initialize ConverseJS",
"SMTP server" => "SMTP 서버",
"Security" => "보안",
// "SSL" => "SSL",
// "TLS" => "TLS",
"Mail sender" => "메일 발송기",
// "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications" => "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
"File (debug)" => "파일 (디버그)",
"Authentication" => "인증",
"Mail server authentication" => "메일 서버 인증",
"LOGIN" => "로그인",
"PLAIN" => "일반",
// "CRAM-MD5" => "CRAM-MD5",
"Local server name" => "로컬 서버명",
"Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line" => "로컬서버명. SMTP relay on the HELO/EHLO 라인 상에서 SMTP 릴레이로 보고될 것임",
// "Mail delivery" => "Mail delivery",
// "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail" => "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail",
"Send immediately" => "즉시 전송",
"Queue" => "대기",
// "Verify HTTPS certificates of remote servers" => "Verify HTTPS certificates of remote servers",
// "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)" => "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)",
// "Do not enforce verification" => "Do not enforce verification",
// "Enforce verification" => "Enforce verification",
// "Use CURL for HTTP connections" => "Use CURL for HTTP connections",
// "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available" => "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available",
// "Zotero bibliography" => "Zotero bibliography",
"Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system" => "티키를 Zotero 온라인인 참고문헌 관리 시스템에 연결.",
// "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style" => "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style",
// "Zotero client key" => "Zotero client key",
"Required identification key. Registration required" => "확인 키 필요. 등록 필요",
// "Zotero client secret" => "Zotero client secret",
// "Zotero group ID" => "Zotero group ID",
"Numeric ID of the group, can be found in the URL" => "그룹의 숫자 ID, URL 에서 찾을 수 있음",
// "Zotero reference style" => "Zotero reference style",
"Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "참조내역에 서식을 적용 시 다른 Zotero 참조 스타일을 사용. 그 참조 서식은 반드시 Zotero 서버에 설치되어있어야만 함",
"Unmatched system requirement. Missing PHP extension among %0" => "일치하지 않는 시스템 요구사항. %0 간에 php 확장기능 누락",
"Unmatched system requirement. The database you are using does not support this feature." => "일치하지 않은 시스템 요구사항. 사용하는 데이터베이스가 이 기능을 지원하지 않음.",
"Missing default for preference \"%0\"" => "기본설정 \"%0\"에 대하여 기본 없음",
"Configuration forced by host" => "호스트에 의해 강제로 적용된 구성",
"Disabled by host" => "호스트에 의하여 비활성화됨",
"Settings" => "설정",
"Permissions" => "권한",
"View" => "표시",
"Modules" => "모듈",
"Plugins" => "플러그인들",
"Like" => "좋아요",
// "Missing preference \"%0\" for \"%1\"" => "Missing preference \"%0\" for \"%1\"",
// "%0 set to minimum of %1 instead of submitted value of %2" => "%0 set to minimum of %1 instead of submitted value of %2",
// "%0 set to maximum of %1 instead of submitted value of %2" => "%0 set to maximum of %1 instead of submitted value of %2",
"Don't like" => "좋아하지 않습니다",
"Wiki top pages" => "위키 상위 페이지",
"Most-relevant pages" => "가장 관계있는 페이지",
"Wiki last pages" => "위키 마지막 페이지",
// "Forums last topics" => "Forums last topics",
"Topic date" => "토픽 날짜",
"Forums last posts" => "게시판 최근 게시물",
"Forums most-read topics" => "게시판 가장 많이 읽힌 토픽들",
"Forums best topics" => "게시판 최고 토픽들",
"Most-visited forums" => "게시판 가장 많이 방문된 게시판들",
"Forums with most posts" => "가장 많은 게시물이 있는 게시판",
"Wiki top galleries" => "Wiki 상위 그림갤러리",
"Wiki top file galleries" => "Wiki 상위 파일갤러리",
"Wiki top images" => "Wiki 상위 그림",
"Wiki top files" => "Wiki 상위 파일",
"Downloads" => "내려받기수",
"Wiki most-recent images" => "위키 마지막 이미지",
"Upload date" => "업로드일",
"Wiki most-recent files" => "위키 마지막 파일",
"Top Articles" => "상위 기사",
"Most-visited blogs" => "가장 많이 방문된 블로그",
"Most-active blogs" => "가장 활동적인 블로그",
"Blogs last posts" => "블로그 최종 게시",
"Post date" => "포스트일",
"Wiki top authors" => "Wiki 상위 작성자",
"Pages" => "페이지",
"Top article authors" => "상위 기사 작성자",
"Expecting three arguments for article-info" => "article-info 에 대하여 3개의 인수 필요",
"Unsupported property. Supported properties are: " => "미지원 속성. 지원되는 속성들은:",
"The Articles feature is not activated" => "기사 기능이 활성화되지 않음",
"Object must be provided and contain two arguments: type and object" => "개체는 반드시 2개의 인수를 제공하고 포함해야만 합니다: 종류와 개체",
"Invalid property" => "유효하지 않은 특성",
// "Item must be provided and contain one argument: type, object-id" => "Item must be provided and contain one argument: type, object-id",
// "List must be provided and contain at least one argument: category IDs" => "List must be provided and contain at least one argument: category IDs",
"Invalid range" => "유효하지 않은 범위",
"Invalid revote period" => "유효하지 않은 재투표 기간",
"Expecting \"keep\" to be \"latest\" or \"oldest\"" => "\"keep\" 이 \"latest\" 혹은 \"oldest\" 이 될 필요",
// "Qualifier must be provided and contain one argument: type" => "Qualifier must be provided and contain one argument: type",
// "From must be provided and contain two arguments: type, object-id" => "From must be provided and contain two arguments: type, object-id",
// "To must be provided and contain two arguments: type, object-id" => "To must be provided and contain two arguments: type, object-id",
// "Field must be provided and contain one argument: field permanent name" => "Field must be provided and contain one argument: field permanent name",
"Unknown variables referenced: %0" => "알 수 없는 변수 참조됨: %0",
"Username is required" => "사용자명은 필수입니다",
"Password is required" => "비밀번호 필요",
"User already exists" => "사용자가 이미 존재합니다",
"Invalid username" => "유효하지 않은 사용자명",
"Username is too long" => "사용자이름이 너무 깁니다",
"Username cannot contain uppercase letters" => "사용자명은 대문자를 포함할 수 없습니다",
"Wrong passcode. You need to know the passcode to register at this site" => "틀린 패스코드. 이 사이트에 등록하려면 패스코드를 알아야 합니다",
"You must choose a group" => "그룹을 반드시 선택해야 합니다",
"Email not valid. Should be in the format \"mailbox@example.com\"" => "이메일이 유효하지 않음. \"mailbox@example.com\" 형식으로 되어있어야 함",
"One of these groups is required" => "이 그룹 중 하나가 필요합니다",
"This field is required" => "이 필드는 필수입니다",
"The passwords don't match" => "비밀번호가 일치하지 않습니다",
"Username must be at least %0 characters long" => "사용자명은 반드시 %0 글자 이상이어야만 합니다",
"Username cannot contain more than %0 characters" => "사용자명은 %0 글자 이상을 포함할 수 없습니다",
"This invitation does not exist or is deprecated or wrong email" => "이 초대는 존재하지 않거나 사용되지 않거나 잘 못된 이메일입니다",
"The title and description must be entered, to generate a feed" => "피드를 생성하려면 필드 제목과 설명은 필수입니다",
"To fix this error go to Admin -> Feeds" => "이 오류를 수정하려면, 관리 -> 피드 로 가십시오",
"Please contact the site administrator and request this error to be corrected" => "사이트 관리자에게 연락하시고 이 오류를 수정해달라고 요청해 주십시오",
"If you set feed author email or URL, you must set feed author name" => "피드 저자 이메일 혹은 URL 을 설정한 경우, 피드 저자명을 설정해야만 합니다",
"Feed logo" => "피드 로고",
"Unspecified" => "지정되지 않음",
"Log In" => "로그인",
"See other users' profiles" => "다른 사용자의 프로필 보기",
"Have your profile seen" => "프로필을 보게 하십시오",
"Make friends" => "친구하기",
"Receive a message" => "수신된 메시지",
"Send a message" => "메시지 전송",
"Read an article" => "기사 읽기",
"Publish an article" => "기사 게재",
"Have your article read" => "기사를 읽게 하십시오",
"Create new file gallery" => "새 파일 갤러리 만들기",
"Upload a new file to a gallery" => "새 파일을 갤러리로 업로드",
"Download another user's file" => "다른 사용자의 파일 다운로드",
"Have your file downloaded" => "파일을 다운로드하도록 하십시오",
"Create a new image gallery" => "새 그림 갤러리 만들기",
"Upload a new image to a gallery" => "새 그림을 갤러리로 업로드",
"View another user's gallery" => "다른 사용자의 갤러리 보기",
"View another user's images" => "다른 사용자의 그림 보기",
"Have your gallery viewed by another user" => "갤러리를 다른 사용자가 보게 하십시오",
"Have your image viewed" => "그림을 보게 하십시오",
"Create a new blog" => "새 블로그 만들기",
"Post in a blog" => "블로그에 개시",
"Read another user's blog" => "다른 사용자의 블로그 읽기",
"Have your blog read" => "블로그를 읽게 하십시오",
"Create a new wiki page" => "새 위키 페이지 만들기",
"Edit an existing page" => "기존 페이지 편집",
"Attach a file" => "파일 첨부",
// "Create a new forum topic" => "Create a new forum topic",
// "Reply to a forum topic" => "Reply to a forum topic",
// "Read a forum post" => "Read a forum post",
// "Have your forum post read" => "Have your forum post read",
// "Create a new tracker item" => "Create a new tracker item",
// "Edit a tracker item" => "Edit a tracker item",
// "View a tracker item" => "View a tracker item",
// "Have your tracker item viewed" => "Have your tracker item viewed",
// "Tracker field content added" => "Tracker field content added",
// "Favorite an item" => "Favorite an item",
// "Have your item favorited" => "Have your item favorited",
// "Have your item rated (per rating)" => "Have your item rated (per rating)",
// "Have your item unrated (per rating)" => "Have your item unrated (per rating)",
// "Add a profile photo" => "Add a profile photo",
"Try rebuilding or optimizing the index on the search admin page" => "검색 관리 페이지상의 색인을 재빌드 혹은 최적화 시도",
// "Invalid table name" => "Invalid table name",
// "Invalid column name" => "Invalid column name",
"Wiki Comment" => "위키 댓글",
"Calendar item" => "달력 항목",
"Gallery" => "갤러리",
"Blog post" => "블로그 포스트",
"Tracker item" => "트래커 항목",
"The search index could not be updated. The site is misconfigured. Contact an administrator" => "검색 색인이 갱신될 수 없었습니다. 사이트가 잘 못 구성되어 있습니다. 관리자에게 연락하십시오",
// "Rebuild in progress" => "Rebuild in progress",
// "The search index could not be rebuilt" => "The search index could not be rebuilt",
"The active index could not be removed, probably due to a file permission issue" => "활성 색인을 삭제할 수 없음. 파일 권한 문제일 가능성 큼",
"The new index could not be made active, probably due to a file permission issue" => "새 색인을 활성으로 전송할 수 없음. 파일 권한 문제일 가능성 큼",
// "Failed to delete the old index" => "Failed to delete the old index",
"blog post" => "블로그 게시물",
"forum post" => "게시판 게시물",
"tracker item" => "트래커 항목",
// "tracker field" => "tracker field",
"sheet" => "시트",
"comment" => "댓글",
// "category" => "category",
// "webservice" => "webservice",
// "activity" => "activity",
// "calendar item" => "calendar item",
// "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate" => "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate",
// "Contact the site administrator. The index needs rebuilding" => "Contact the site administrator. The index needs rebuilding",
// "Client Node" => "Client Node",
// "Elasticsearch Version" => "Elasticsearch Version",
// "Lucene Version" => "Lucene Version",
// "Cluster Name" => "Cluster Name",
// "Cluster Status" => "Cluster Status",
// "Cluster Node Count" => "Cluster Node Count",
// "Index %0" => "Index %0",
// "%0 documents, totaling %1" => "%0 documents, totaling %1",
// "Node %0" => "Node %0",
// "Using %0, since %1" => "Using %0, since %1",
// "%0 documents, totaling %1 bytes" => "%0 documents, totaling %1 bytes",
// "Using %0 bytes, since %1" => "Using %0 bytes, since %1",
// "Field Count Tried on Last Rebuild" => "Field Count Tried on Last Rebuild",
// "Field limit setting is lower than Tiki needs to store in the index" => "Field limit setting is lower than Tiki needs to store in the index",
// "Information Missing" => "Information Missing",
"Object Type" => "개체 유형",
// "date_histogram" => "date_histogram",
// "Date Histogram" => "Date Histogram",
// "date_range" => "date_range",
"Date Range" => "날짜 범위",
// "Local Search" => "Local Search",
// "Federated Search" => "Federated Search",
// "Index not found" => "Index not found",
"Rebuild search index" => "검색 색인 다시 빌드",
// "Click here to rebuild index" => "Click here to rebuild index",
// "On Demand" => "On Demand",
// "You can revisit the results of this saved search on demand" => "You can revisit the results of this saved search on demand",
// "Mobile mode: Permission denied, please log in" => "Mobile mode: Permission denied, please log in",
" has accessed your temporary shared content" => "귀하의 임시 공유 컨텐츠에 접속하였습니다",
"has accessed the following shared content" => "다음 공유된 컨텐츠에 접근하였습니다",
"Your access to this page has expired" => "이 페이지로의 접근권한이 만료되었음",
"Handling actions of plugin \"%s\" failed" => "플러그인 \"%s\" 의 작업 처리 실패함",
"You must choose an option" => "선택사항을 반드시 선택해야 합니다",
"For you to vote, cookies must be allowed" => "투표하려면, 쿠키 허용 필수",
"This poll is closed" => "이 투표는 마감되었습니다",
// "Preference %0 failed to unserialize. Value was \"%1\"" => "Preference %0 failed to unserialize. Value was \"%1\"",
// "A tracker with id \"%0\" is required to be filled in, but it was deleted" => "A tracker with id \"%0\" is required to be filled in, but it was deleted",
// "Update the preference \"<b>%0</b>\" on admin panel" => "Update the preference \"<b>%0</b>\" on admin panel",
"Congratulations" => "축하",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "이는 귀하의 티키에 대한 기본 홈페이지입니다. 이 페이지를 보게되는 경우, 설치가 성공한 것입니다",
"You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "로그인 후 이 페이지를 변경할 수 있습니다. 편집하기에 대한 상세내역은 [http://doc.tiki.org/wiki+syntax|위키 문법]을 검토하십시오",
// "Get started" => "Get started",
"To begin configuring your site" => "귀하의 사이트 구성을 시작하려면",
"1) Log in with your newly created password" => "1) 새롭게 만든 비밀번호로 로그인하십시오",
// "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard" => "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard",
// "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running" => "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running",
// "Need help" => "Need help",
"For more information" => "추가 정보는",
// "[https://tiki.org/Introduction|Learn more about Tiki]" => "[https://tiki.org/Introduction|Learn more about Tiki]",
// "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[https://tiki.org/Join|Join the Tiki community]" => "[https://tiki.org/Join|Join the Tiki community]",
"new" => "새",
"Saved" => "저장됨",
"Save failed" => "저장 실패",
"Standard Shipping" => "표준 배송",
"3 to 5 working days" => "3에서 5의 근무일",
"Express Shipping" => "빠른 구매",
"Next day delivery" => "익일 배달",
"Custom Shipping Example" => "사용자 지정 발송 예제",
// "UPS_CODE_%0" => "UPS_CODE_%0",
"Problem reading custom shipping provider \"%0\"" => "사용자 지정 배송 제공자  \"%0\" 읽는 중 문제",
"Modified date" => "수정된 날짜",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq 스마티 플러그인 비활성: feature_jquery 꺼짐 -->",
"No records to display" => "표기할 기록 없음",
// "Please specify the name of the package and the view" => "Please specify the name of the package and the view",
// "Error: Unable to locate view file for the package" => "Error: Unable to locate view file for the package",
// "Error: Unable to locate function name for the view" => "Error: Unable to locate function name for the view",
"Previous" => "전",
"current" => "현재",
"Next" => "다음",
"More results may be available. Refine criteria to access the estimated %0 results" => "더 많은 결과가 제공될 수 있습니다. 추정된 %0 결과에 접근하려면 조건을 정제하십시오",
"Tab View" => "탭 보기",
"No Tabs" => "탭 없음",
"This edit session will expire in" => "이 편집 세션은 다음에 종료됩니다",
// "There is an autosaved draft of your recent edits, to use it instead " => "There is an autosaved draft of your recent edits, to use it instead ",
// "If you want the original instead of the autosaved draft of your edits" => "If you want the original instead of the autosaved draft of your edits",
"click here" => "여기를 클릭하십시오",
"AutoSave" => "자동저장",
"Your edit session has expired" => "귀하의 편집 세션이 마감되었습니다",
"Your edit session will expire in" => "귀하의 편집 세션이 다음 시간 후 종료됩니다:",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "편집내용을 손실하는 것을 피하려면, 지금 반드시 작업내용을 미리보기 혹은 저장 해야 합니다",
// "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page",
// "Help page" => "Help page",
// "View or edit tpl" => "View or edit tpl",
// "View tpl" => "View tpl",
"itemId required" => "항목ID 필수",
// "Plugin name not specified" => "Plugin name not specified",
// "Delete file" => "Delete file",
// "File (ID %0) removed" => "File (ID %0) removed",
// "File (ID %0) not removed" => "File (ID %0) not removed",
// "File uploaded" => "File uploaded",
// "File not uploaded" => "File not uploaded",
// "Missing _id or _type params" => "Missing _id or _type params",
"Wrong attachments gallery" => "틀린 첨부파일 갤러리",
"You are attempting to display a gallery that is not a valid attachment gallery" => "유효하지 않은 첨부 갤러리가 아닌 갤러리를 표기하려 시도했습니다",
// "Missing 'to' or 'from' parameter" => "Missing 'to' or 'from' parameter",
// "at" => "at",
"to" => "수신",
"Favorite" => "즐겨찾기",
"Hour" => "시간",
"Minute" => "분",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "언어 편집으로 가려면 여기를 클릭하십시오",
"The text is" => "텍스트는",
"character(s) too long - please edit it" => "글자수 초과 - 편집하십시오",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Clear filter" => "Clear filter",
// "Type not specified" => "Type not specified",
// "lock perm not found" => "lock perm not found",
// "admin perm not found" => "admin perm not found",
"Missing parameter" => "매개 변수 없음",
// "Multivalue configuration not found" => "Multivalue configuration not found",
"No records found." => "발견된 기록 없음.",
"No object information provided" => "제공된 개체 정보 없음",
"No title specified" => "지정된 제목 없음",
"Relation not found" => "관계 발견되지 않음",
"tags disabled" => "프리태그 비활성화됨",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "%0 list separated with \"%1\"" => "%0 list separated with \"%1\"",
// "Object selector requires Unified Index to be enabled" => "Object selector requires Unified Index to be enabled",
"Currency in payment (%0) does not match the currency for that registry (%1)" => "지불의 통화 (%0) 는 그 레지스트리에에 대한 통화 (%1) 와 일치하지 않습니다",
// "Payment error" => "Payment error",
"This invoice does not exist or access to it is restricted" => "이 청구서는 존재하지 않거나 제한된 접근으로 되어있습니다",
"You do not have the permission that is needed to use this feature" => "이 기능이용이 허가되지 않았습니다",
"(not found in an admin panel)" => "(관리 패널 내에 발견되지 않음)",
"Preference %0 is not defined" => "기본 설정 %0 은 정의되지 않았습니다",
"Drag this out of the perspective and resave the perspective" => "이것을 perspective 에서 드래그하여 다시 저장",
"No object information provided for rating" => "등급을 위하여 제공되는 개체 정보 없음",
"An error occurred" => "오류 발생함",
"Configure Ratings" => "등급 구성",
// "Unavailable" => "Unavailable",
"Invalid fields provided" => "유효하지 않은 필드 제공됨",
"Missing or invalid tracker reference" => "트래커 참조 누락 혹은 유효하지 않음",
// "Configured" => "Configured",
"General" => "일반",
// "Tracker rendering error (section=\"%0\" mode=\"%1\")" => "Tracker rendering error (section=\"%0\" mode=\"%1\")",
"No rows found" => "발견된 행 없음",
"Toggle sections" => "선택사항 토글",
"Show only selected" => "선택된 것만 보기",
"You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "티키 섹션 하의 tiki_p_modify_object_categories 권한 또한 설정을 고려해 보십시오",
// "You are logged in" => "You are logged in",
"Request not from this host" => "이 호스트에서 온 요청 아님",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "유효한 %s 을 입력하여 주십시오.  스페이스 없이, %d 글자 이상으로, %s 를 포함해야 합니다",
"username" => "사용자명",
"password" => "비밀번호",
"Cookies must be enabled to log in to this site" => "이 사이트에 로그인 할 수 있으려면 쿠키를 활성해야 합니다",
// "wikidiff: error - no object_id specified" => "wikidiff: error - no object_id specified",
// "wikidiff: error - no old version specified" => "wikidiff: error - no old version specified",
// "wikidiff: error - page \"%0\" not found" => "wikidiff: error - page \"%0\" not found",
// "wikidiff: Error - only wiki pages supported currently" => "wikidiff: Error - only wiki pages supported currently",
"second" => "초",
"months" => "달",
"weeks" => "주",
"done" => "완료",
"Text cut here" => "여기서 텍스트를 자르시오",
"Task" => "작업",
"Priority" => "중요도",
"Start date" => "시작일",
"End date" => "종료 날짜",
// "in %s days, the %s" => "in %s days, the %s",
"in %s day, the %s" => "%s 일에, %s",
"Today" => "오늘",
// "%0 and %1" => "%0 and %1",
"Permission denied: the specified wiki page cannot be used as Smarty template resource" => "권한 거부됨: 지정된 위키 페이지가 스마티 템플릿 자원으로서 사용될 수 없습니다",
"No WSDL found" => "WSDL 발견되지 않음",
// "Facebook feed data not retrieved" => "Facebook feed data not retrieved",
// "Facebook profile information not retrieved" => "Facebook profile information not retrieved",
// "You need to link your local account to Facebook before you can login using it" => "You need to link your local account to Facebook before you can login using it",
// "We were unable to create a new user with your Facebook account. Please contact the administrator" => "We were unable to create a new user with your Facebook account. Please contact the administrator",
// "We were unable to connect to your LinkedIn account. Please contact the administrator" => "We were unable to connect to your LinkedIn account. Please contact the administrator",
// "We were unable to log you in using your LinkedIn account. Please contact the administrator" => "We were unable to log you in using your LinkedIn account. Please contact the administrator",
// "You need to link your local account to LinkedIn before you can login using it" => "You need to link your local account to LinkedIn before you can login using it",
// "pvs" => "pvs",
"Days with the most pageviews" => "가장 많은 페이지보기의 날",
"Day with the most pageviews" => "가장 많은 페이지보기의 날",
"Days with the fewest pageviews" => "가정 적은 페이지보기의 날",
"Day with the fewest pageviews" => "가장 적은 페이지보기의 날",
"No pageviews yet" => "아직 페이지 보기 없음",
"Use this tree to copy the structure" => "구조체를 복사하기 위하여 이 트리 사용",
// "system" => "system",
"created from structure" => "구조에서 작성된",
"%d choice(s) must be made for the question" => "질문에 대해 %d 개의 답안(들)을 만들어야 합니다",
"At least %d choice(s) must be made for the question" => "질문에 대하여 최소 %d 답안(들)을 선택해야 합니다",
"Fewer than %d choice(s) must be made for the question" => "질문에 대해 %d 개 미만의 답안(들)을 만들어야 합니다",
"One choice" => "한 개 선택",
"Multiple choices" => "다항 선택",
// "Thumbnails" => "Thumbnails",
"Short text" => "짧은 텍스트",
"Wiki textarea" => "위키 텍스트영역",
"Rate (1 to 5)" => "등급 지정 (1..5)",
"Rate (1 to 10)" => "등급 지정 (1..10)",
"Heading" => "제목",
// "Icon not found: %0" => "Icon not found: %0",
// "Icon set: Class not defined for icon %0" => "Icon set: Class not defined for icon %0",
// "Custom theme by specifying URL" => "Custom theme by specifying URL",
"Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator" => "요청된 기능: <b>%0</b>. 이러한 기능들을 활성화할 권한이 없는 경우, 사이트 관리자에게 문의하십시오",
// "CSRF check not performed" => "CSRF check not performed",
// "Required headers are missing" => "Required headers are missing",
// "Requesting site could not be identified because %0 and %1 were empty" => "Requesting site could not be identified because %0 and %1 were empty",
// "Request needs to originate from this site" => "Request needs to originate from this site",
// "The %0 host (%1) does not match this server (%2)" => "The %0 host (%1) does not match this server (%2)",
// "Ticket has expired. Reload the page" => "Ticket has expired. Reload the page",
// "Ticket matches but is expired" => "Ticket matches but is expired",
// "Reloading the page may help" => "Reloading the page may help",
// "Ticket does not match or is missing" => "Ticket does not match or is missing",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked" => "Potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Request to %0 failed CSRF check" => "Request to %0 failed CSRF check",
// "Confirm action" => "Confirm action",
// "Please confirm action" => "Please confirm action",
"unknown error" => "알 수 없는 오류",
"You are not logged in" => "로그인되지 않았습니다",
"You do not have permission to view this section" => "이 부분을 볼 권한이 없습니다",
"For the security of your password, direct access to the feed is only available via HTTPS" => "귀하의 비밀번호의 보안을 위하여, 피드로의 집적 접근은 https 를 통해서만 사용가능합니다",
"Help link" => "도움말 링크",
"You are banned from" => "다음에서 차단되었습니다",
"wiki" => "위키",
// "img-g" => "img-g",
// "file-g" => "file-g",
"quizzes" => "퀴즈",
"arts" => "아트",
"blogs" => "블로그",
"forums" => "게시판",
// "Tiki links converted to relative links" => "Tiki links converted to relative links",
// "TikiLib::create_page: Cannot create page \"%0\", it already exists.)" => "TikiLib::create_page: Cannot create page \"%0\", it already exists.)",
"The file was successfully uploaded" => "파일은 성공적으로 업로드되었습니다",
"The file was only partially uploaded" => "업로드가 시도되는 파일은 부분적으로만 업로드 되었습니다",
"No file was uploaded. Was a file selected " => "업로드 된 파일이 없습니다. 파일이 선택되었습니까",
"A temporary folder is missing" => "임시 폴더가 없습니다",
// "Alias <b>%0</b> link already present in %1 page(s)" => "Alias <b>%0</b> link already present in %1 page(s)",
"%d points" => "%0 점",
"Removed" => "제거됨",
"Plugin %0 pending approval" => "%0 플러그인의 승인 대기 중",
"Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked" => "사이트 간 요청 위조 (CSRF) 감지됨. 동작 블럭됨",
"Bold" => "굵은체",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "기울임꼴",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "밑줄",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "취소선",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Code" => "코드",
// "img/icons/page_white_code.png" => "img/icons/page_white_code.png",
"Non-parsed (wiki syntax does not apply)" => "구문분석 되지 않음 (위키 문법이 적용되지 않음)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "가운데 맞춤",
"Horizontal Bar" => "가로 바",
"Page Break" => "페이지 나누기",
"Box" => "상자",
"Title bar" => "제목 바",
// "Bullet List" => "Bullet List",
// "Numbered List" => "Numbered List",
"Special Characters" => "특수 문자",
"Foreground color" => "전경 색상",
"Background Color" => "배경 색상",
"Wiki Link" => "위키 링크",
// "img/icons/page_link.png" => "img/icons/page_link.png",
"Object Link" => "개체 링크",
"External Link" => "외부 링크",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "표 제작기",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "텍스트 찾기",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "텍스트 교체",
"Full-screen edit" => "전체 화면 편집",
"Wiki Help" => "Wiki 도움말",
"Choose or upload images" => "선택하거나 그림을 업로드",
// "img/icons/pictures.png" => "img/icons/pictures.png",
"Choose or upload files" => "선택하거나 파일을 업로드",
"Switch Editor (wiki or WYSIWYG)" => "편집기 전환 (위키 혹은 WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Admin Toolbars" => "툴바 관리",
// "img/icons/wrench.png" => "img/icons/wrench.png",
"Save Sheet" => "시트 저장",
"Add row after selection or to the end if no selection" => "선택영역 후 혹은 선택영역 없을 시 마지막에 행 추가",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
"Add multiple rows after selection or to the end if no selection" => "선택부분 후 혹은 선택부분 없을 경우 끝에 다중 행 추가",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
"Add row before selection or to end if no selection" => "선택영역 전 혹은 선택영역 없을 시 마지막에 행 추가",
"Delete selected row" => "선택된 행 삭제",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
"Add column after selection or to the end if no selection" => "선택부분 후 혹은 선택부분이 없을 경우 끝에 열 추가 ",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
"Delete selected column" => "선택된 열 삭제",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
"Add multiple columns after selection or to the end if no selection" => "선택부분 후 혹은 선택부분 없을 경우 끝에 다중 열 추가",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
"Add column before selection or to the end if no selection" => "선택부분 전 혹은 선택부분이 없을 경우 끝에 열 추가 ",
"Get Cell Range" => "셀 범위 받기",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "검색",
"Refresh calculations" => "계산 다시 고침",
"Finish editing" => "편집 종료",
"Reset Colors" => "색상 재설정",
"Reset" => "초기화",
// "Show this text" => "Show this text",
// "Link to this page" => "Link to this page",
// "Anchor" => "Anchor",
// "Semantic relation" => "Semantic relation",
"Cancel" => "취소",
"Insert" => "삽입",
// "Types of object" => "Types of object",
// "Link to this object" => "Link to this object",
// "link to this URL" => "link to this URL",
// "No cache" => "No cache",
// "Case Insensitivity" => "Case Insensitivity",
// "Note: Uses regular expressions" => "Note: Uses regular expressions",
"Close" => "닫기",
"Replace" => "교체 ",
// "Replace All" => "Replace All",
// "Flat" => "Flat",
"Tabs" => "탭",
// "No template available for %0 - %1" => "No template available for %0 - %1",
// "Tracker %0 not found for Field %1" => "Tracker %0 not found for Field %1",
"*** ERROR: Tracker ID not set ***" => "*** 오류: 트래커 ID 설정되지 않음 ***",
"*** ERROR: Field ID not set ***" => "*** 오류: 필드 ID 설정되지 않음 ***",
"*** ERROR: Tracker %0 not found ***" => "*** 오류: %0 트래커 발견되지 않음 ***",
// "TrackerLib::get_all_items: No item for itemId %0" => "TrackerLib::get_all_items: No item for itemId %0",
// "Tracker list_items ran out of memory after %0 items" => "Tracker list_items ran out of memory after %0 items",
// "No fields found in header, not a comma-separated values file" => "No fields found in header, not a comma-separated values file",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
// "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"" => "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"",
"Field is not numeric" => "필드는 숫자가 아닙니다",
"Function" => "기능",
"Pending" => "보류 중",
"Tracker field setup error - display field not found: " => "트래커 필드 설치 오류 - 표시 필드 발견되지 않음: ",
// "Item Creation" => "Item Creation",
"Item Modification" => "항목 수정",
"Item" => "항목",
"Subject" => "제목",
"Tracker was modified at %0 by %1" => "트래커는 %0 에 %1 님에 의하여 수정되었습니다",
"View the tracker item at" => "트래커 항목을 다음에서 보기",
// "Missing wiki email template page \"%0\"" => "Missing wiki email template page \"%0\"",
"Tracker field not enabled: fieldId=%0 type=%1" => "트래커 필드 활성되지 않음: 필드ID=%0 유형=%1",
// "Field not specified" => "Field not specified",
"No extra information for that attached file. " => "그 첨부파일에 대한 추가 정보 없음",
// "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list" => "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list",
// "Could not create /storage/pass_blacklists directory" => "Could not create /storage/pass_blacklists directory",
// "Existing password blacklist file was overwritten" => "Existing password blacklist file was overwritten",
// "Existing password blacklist file could not be overwritten" => "Existing password blacklist file could not be overwritten",
// "File Error. Password file not created" => "File Error. Password file not created",
// "File Error. Password file generation interrupted" => "File Error. Password file generation interrupted",
// "Password blacklist file generated" => "Password blacklist file generated",
// "Unable to Populate Blacklist: File dose not exist or is not readable" => "Unable to Populate Blacklist: File dose not exist or is not readable",
// "Critical" => "Critical",
// "Immediate notification by email" => "Immediate notification by email",
"High" => "높음",
// "Will be sent to you with the next periodic digest" => "Will be sent to you with the next periodic digest",
"Low" => "낮음",
// "Included in your personalized recent changes feed" => "Included in your personalized recent changes feed",
// "Anywhere" => "Anywhere",
// "translations of %0" => "translations of %0",
// "%0 in %1" => "%0 in %1",
// "%0 for %1" => "%0 for %1",
// "Any activity" => "Any activity",
// "Page modified" => "Page modified",
// "Page created" => "Page created",
// "Any forum activity" => "Any forum activity",
// "New topics" => "New topics",
// "Any item activity" => "Any item activity",
// "New items" => "New items",
// "Action Required" => "Action Required",
// "Recommendation Received" => "Recommendation Received",
// "%0 (%1 level up, entire structure)" => "%0 (%1 level up, entire structure)",
// "%0 (%1 level up)" => "%0 (%1 level up)",
// "%0 (current subtree)" => "%0 (current subtree)",
// "%0 Reply Handler" => "%0 Reply Handler",
// "The user [ %0 ] is not registered with this wiki and autocreate is disabled" => "The user [ %0 ] is not registered with this wiki and autocreate is disabled",
// "The user [ %0|%1 ] is not registered with this wiki and the creation process failed" => "The user [ %0|%1 ] is not registered with this wiki and the creation process failed",
// "unverified" => "unverified",
// "Your Information" => "Your Information",
"User Information" => "사용자정보",
"Can create/close a book" => "장부 만들기/닫기 가능",
"Can create/edit/lock accounts" => "계정 만들기/편집/잠금 가능",
"Create a new transaction" => "새 거래 만들기",
"Permission to view the journal" => "저널을 볼 권한",
"Can book into the stack where statements can be changed" => "명세서가 변경될 수 있는 스택으로 기록 가능",
"Can import statements from external accounts" => "외부 계정에서 명세서 가져오기 가능",
"Can manage templates for recurring transactions" => "반복되는 거래에 대한 템플릿 관리 가능",
"Can admin the articles" => "기사 관리 가능",
"Can approve submissions" => "투고기사 승인 가능",
"Can admin article topics" => "기사 토픽 관리 가능",
"Can admin article types" => "기사 종류 관리 가능",
"Can read article headings" => "기사 제목 읽기 가능",
"Submitted articles are automatically approved" => "제출된 기사는 자동적으로 승인됨",
"Can edit articles" => "기사 편집 가능",
// "Can edit the user (owner) of articles" => "Can edit the user (owner) of articles",
"Can edit submissions" => "투고기사 편집 가능",
// "Can read articles (applies to article or topic level)" => "Can read articles (applies to article or topic level)",
"Can remove articles" => "기사 삭제 가능",
"Can remove submissions" => "투고기사 삭제 가능",
"Can submit articles" => "기사 제출 가능",
"Can rate articles" => "기사 등급 부여 가능",
"Can view recordings from past meetings" => "과거 미팅의 기록 보기 가능",
"Can join a meeting" => "미팅 참여 가능",
"Can moderate a meeting" => "미팅 중재 가능",
"Can create a meeting" => "미팅 만들기 가능",
// "Can use XMPP chat" => "Can use XMPP chat",
"Can admin blogs" => "블로그 관리 가능",
"Can assign perms to blog" => "블로그에 권한 할당 가능",
"Can post to a blog" => "블로그에 게시 가능",
"Can create a blog" => "블로그 만들기 가능",
"Can read blogs" => "블로그 읽기 가능",
"Can view in module and feed the blog posts" => "모듈에서 보기 및 블로그 게시물 피드 가능",
"Can view in module and feed the blog" => "모듈에서 보기 및 플로그 피드 가능",
"Can create/admin calendars" => "달력 만들기/관리 가능",
"Can add events in the calendar" => "달력에 이벤트 추가 가능",
"Can edit events in the calendar" => "달력 내부의 이벤트 변경 가능",
"Can browse the calendar" => "달력 탐색 가능",
"Can view event details" => "이벤트 상세내역 보기 가능",
"Can add himself or herself to the participants" => "참여자에 자신의 사용자 추가 가능",
"Can add guest to the participants" => "참여자에 손님 추가 가능",
"Can view Tiki tools calendar" => "티키 도구 달력 보기 가능",
"Can admin categories" => "범주 관리 가능",
"Can see the category in a listing" => "목록에 범주 보기 가능",
"Can add objects to the category (tiki_p_modify_object_categories permission required)" => "범주에 개체 추가 가능 ( tiki_p_modify_object_categories 가 필요)",
"Can remove objects from the category (tiki_p_modify_object_categories permission required)" => "범주에서 개체 삭제 가능 (tiki_p_modify_object_categories 필요)",
"Can assign perms to category" => "범주에 권한 할당 가능",
"Administrator can create channels, remove channels, etc" => "관리자는 채널 만들기, 채널 삭제 등등 가능",
"Can use the chat system" => "채팅 시스템 사용 가능",
"Can admin received articles" => "수신된 기사 관리 가능",
"Can admin received pages" => "수신된 페이지 관리 가능",
"Can send articles to other sites" => "다른 사이트로 기사 발송 가능",
"Can send articles to this site" => "이 사이트로 기사 발송 가능",
"Can send pages to this site" => "이 사이트로 페이지 보내기 가능",
"Can send pages to other sites" => "다른 사이트로 페이지 보내기 가능",
"Can post new comments" => "새 댓글 게시 가능",
"Can read comments" => "댓글 읽기 가능",
"Can admin comments" => "댓글 관리 가능",
"Can edit all comments" => "모든 댓글 편집 가능",
"Can delete comments" => "댓글 삭제 가능",
"Can vote on comments" => "댓글 투표 가능",
"Can admin content templates" => "컨텐츠 템플릿 관리 가능",
"Can edit content templates" => "컨텐츠 템플릿 편집 가능",
// "Can lock content templates" => "Can lock content templates",
"Can use content templates" => "컨텐츠 템플릿 사용 가능",
"Can admin contributions" => "기여도 관리 가능",
"Can admin the directory" => "디렉터리 관리 가능",
"Can admin directory categories" => "디렉터리 범주 관리 가능",
"Can admin directory sites" => "디력터리 사이트 관리 가능",
"Submitted links are valid" => "제출된 링크들이 유효합니다",
"Can submit sites to the directory" => "디렉터리에 사이트 제출 가능",
"Can validate submitted links" => "제출된 링크 유효화 가능",
"Can use the directory" => "디렉터리 사용 가능",
"Can execute arbitrary queries on a given DSN" => "주어진 DSN 상에 임의 질의 실행 가능",
"Can admin FAQs" => "FAQ 관리 가능",
"Can suggest FAQ questions" => "FAQ 질문 제안 가능",
"Can view FAQs" => "FAQ 보기 가능",
"Can download files" => "파일 다운로드 가능",
"Can upload files" => "파일 업로드 가능",
"Can list file galleries" => "파일 갤러리 나열 가능",
"Can view file galleries" => "파일 갤러리 보기 가능",
"Can admin file galleries" => "파일 갤러리 관리 가능",
"Can assign permissions to file galleries" => "파일 갤러리에 권한 할당 가능",
"Can use Directory Batch Load" => "디렉터리 일괄 로드 사용 가능",
"Can upload .zip file packages" => "ZIP 파일로 파일 업로드 가능",
"Can create file galleries" => "파일 갤러리 만들기 가능",
"Can edit a gallery file" => "갤러리 파일 편집 가능",
"Can remove files" => "파일 삭제 가능",
"Can view file galleries explorer" => "파일 갤러리 탐색기 보기 가능",
"Can view file galleries path" => "파일 갤러리 경로 보기 가능",
// "Can upload files containing JavaScript" => "Can upload files containing JavaScript",
// "Can upload SVG files" => "Can upload SVG files",
"Can admin forums" => "게시판 관리 가능",
"Can attach files to forum posts" => "게시판 게시물에 첨부 가능",
"Auto approve forum posts" => "게시판 게시물 자동 승인",
"Can post in forums" => "게시판에 게시 가능",
"Can start threads in forums" => "게시판의 대화목록 시작 가능",
"Can read forums" => "게시판 읽기 가능",
"Can report posts to moderator" => "중재자에게 게시물 보고 가능",
"Can vote on comments in forums" => "게시판에 댓글 투표 가능",
"Can browse tags" => "프리태그 탐색 가능",
"Can admin tags" => "프리태그 관리 가능",
"Can tag objects" => "개체 태그 가능",
"Can unassign tags from an object" => "개체에서 태크 할당해지 가능",
"Can subscribe to groups" => "그룹에 구독 가능",
"Can invite user to my groups" => "사용자를 내 그룹에 초대 가능",
"Can view the group" => "그룹 보기 가능",
"Can view the group members" => "그룹 멤버 보기 가능",
"Can add group members" => "그룹 멤버 추가 가능",
"Can remove group members" => "그룹 멤버 삭제 가능",
"Can join or leave the group" => "그룹 참여 및 탈퇴 가능",
// "Can view H5P content" => "Can view H5P content",
// "Can edit H5P content" => "Can edit H5P content",
// "Can administer H5P content" => "Can administer H5P content",
"Can edit HTML pages" => "HTML 페이지 편집 가능",
"Can view HTML pages" => "HTML 페이지 보기 가능",
"Can admin Image Galleries" => "그림 갤러리 관리 가능",
"Can assign permissions to image galleries" => "그림 갤러리에 권한 할당 가능",
"Can upload .zip files of images" => "ZIP 파일로 그림 업로드 가능",
"Can create image galleries" => "그림 갤러리 만들기 가능",
"Can list image galleries" => "이미지 갤러리 나열 가능",
"Can upload images" => "그림 업로드 가능",
"Can view image galleries" => "그림 갤러리 보기 가능",
"Can admin Kaltura video feature" => "칼투라 동영상 기능 관리 가능",
"Can upload video or record from webcam" => "동영상 업로드 혹은 웹캡에서 녹화 가능",
"Can edit media information" => "미디어 정보 편집 가능",
"Can delete media" => "미디어 삭제 가능",
"Can download media" => "미디어 다운로드 가능",
"Can list media" => "미디어 나열 가능",
"Can view media" => "미디어 보기 가능",
"Can broadcast messages to all users" => "모든 사용자에 메시지 브로드캐스트 가능",
"Can broadcast messages to groups" => "그룹에 메시지 브로드캐스트 가능",
"Can use the messaging system" => "메시지 시스템 사용 가능",
"Can admin newsletters" => "회보 관리 가능",
"Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)" => "여러 이메일을 한 번에 구독 가능 (tiki_p_subscribe email 필요)",
"Can send newsletters" => "회보 발송 가능",
"Can subscribe any email address to newsletters" => "회보에 임이의 이메일 구독 가능",
"Can subscribe to newsletters" => "회보에 구독 가능",
"Can view the archive of a newsletters" => "회보 저장물 보기 가능",
"Can list newsletters" => "회보 나열 가능",
"Can administer payments" => "지불 관리 가능",
"Can view payment requests and details" => "지불 요청 및 상세내역 보기 가능",
"Can enter manual payments" => "수동 지불 입력 가능",
"Can request a payment" => "지불 요청 가능",
"Can view the perspective" => "Perspective 보기 가능",
"Can edit the perspective" => "Perspective 편집 가능",
"Can create a perspective" => "퍼스펙티브 만들기 가능",
"Can admin perspectives" => "Perspective 관리 가능",
"Can admin polls" => "투표 관리 가능",
"Can view poll results" => "투표 결과 보기 가능",
"Can view poll user choices" => "투표 사용자 선택 보기 가능",
"Can vote in polls" => "투표에 대한 투표 가능",
"Can view poll voters" => "투표자 보기 가능",
"Can admin quizzes" => "퀴즈 관리 가능",
"Can take quizzes" => "퀴즈 풀이 가능",
"Can view quiz stats" => "퀴스 통계 보기 가능",
"Can view user quiz results" => "사용자 퀴즈 결과 보기 가능",
"Can admin spreadsheets" => "시트 관리 가능",
"Can create and edit spreadsheets" => "시트 만들기 및 편집 가능",
"Can view spreadsheets" => "시트 보기 가능",
"Can view spreadsheets history" => "시트 기록 보기 가능",
"Can admin the shoutbox (edit/remove messages)" => "외침상자 관리 가능 (메시지 편집/삭제)",
"Can post messages in the shoutbox" => "외침상자에 메시지 게시 가능",
"Can view the shoutbox" => "외침상자 보기 가능",
"Can use social network integration" => "사용자는 소셜 네트워크 통합을 사용할 수 있습니다",
"Can register this site with social networks" => "사용자는 이 사이트를 소셜네트워크에 등록할 수 있습니다",
"Admin live support system" => "실시간 지원 시스템 관리",
"Can use live support system" => "실시간 지원 시스템 사용 가능",
"Can admin surveys" => "설문 관리 가능",
"Can take surveys" => "설문 응답 가능",
"Can view survey stats" => "설문 통계 보기 가능",
"Can admin TikiTests" => "티키테스트 관리 가능",
"Can edit TikiTests" => "티키테스트 편집 가능",
"Can replay TikiTests" => "티키테스트 리플레이 가능",
"Can admin trackers" => "트래커 관리 가능",
"Can attach files to tracker items" => "트래커 항목에 파일 첨부 가능",
"Can view tracker item attachments and download them" => "트래커 항목 첨부파일 보기 및 다운로드 가능",
"Can post tracker item comments" => "트래커 항목에 대하여 댓글 삽입 가능",
"Can view tracker item comments" => "트래커 항목 댓글 보기 가능",
"Can create new tracker items" => "트래커에 대한 새 항목 만들기 가능",
"Can list trackers" => "트래커 나열 가능",
"Can change tracker items" => "트래커 항목 변경 가능",
"Can change pending tracker items" => "보류 중인 트래커 항목 변경 가능",
"Can change closed tracker items" => "닫힌 트래커 항목 변경 가능",
"Can remove tracker items" => "트래커 항목 삭제 가능",
"Can remove pending tracker items" => "보류 중인 트래커 항목 삭제 가능",
"Can remove closed tracker items" => "닫힌 트래커 항목 삭제 가능",
"Can view rating result for tracker items" => "트래커 항목에 대한 등급 결과 보기 가능",
"Can rate tracker items" => "트래커 항목에 대한 등급 투표가능",
"Can re-rate tracker items" => "트래커 항목에 대한 등급 재투표 가능",
"Can view trackers" => "트래커 보기 가능",
"Can view closed trackers items" => "닫힌 트래커 항목 보기 가능",
"Can view pending trackers items" => "보류 중인 트래커 항목 보기 가능",
"Can watch a tracker" => "트래커 주시 가능",
"Can export tracker items" => "트래커 항목 내보내기 가능",
"Can save a CSV backup of all trackers" => "트래커 전체를 .CSV 백업으로 저장 가능",
// "Manage tracker views" => "Manage tracker views",
// "View list view of tracker tabular data. Tracker item permissions apply" => "View list view of tracker tabular data. Tracker item permissions apply",
// "Export a tracker tabular view to CSV. Tracker permissions may not apply" => "Export a tracker tabular view to CSV. Tracker permissions may not apply",
// "Import a CSV file into a tabular tracker. Tracker permissions may not apply" => "Import a CSV file into a tabular tracker. Tracker permissions may not apply",
"Can trigger the transition between two states" => "두 상태 간의 전이 작동 가능",
"Can admin users" => "사용자 관리 가능",
"Can cache user bookmarks" => "사용자 책갈피 캐시 가능",
"Can configure modules" => "모듈 구성 가능",
"Can create user bookmarks" => "사용자 책갈피 만들기 가능",
"Can use the mini event calendar" => "미니 이벤트 달력 사용 가능",
"Can use the notepad" => "메모장 사용 가능",
"Can admin public tasks" => "공용 작업 관리 가능",
"Can use tasks" => "작업 사용 가능",
"Can receive tasks from other users" => "타 사용자로부터 작업 수신 가능",
"Can send tasks to other users" => "타 사용자에게 작업 발송 가능",
"Can upload personal files" => "개인 파일 업로드 가능",
"Can create items in personal menu" => "개인 메뉴에 항목 만들기 가능",
"Can list registered users" => "등록된 사용자 나열 가능",
"Can invite users by email, and include them in groups" => "사용자를 이메일로 초대 및 그룹에 포함 가능",
"Can delete his/her own account" => "자신의 계정 삭제 가능",
"Can use webmail" => "웹메일 사용 가능",
"Can use group webmail" => "그룹 웹메일 사용 가능",
"Can admin group webmail accounts" => "그룹 웹메일 계정 관리 가능",
"Can use personal webmail accounts" => "개인 웹메일 계정 사용 가능",
"Can admin personal webmail accounts" => "개인 웹메일 계정 관리 가능",
"Can view page/pages" => "페이지/페이지들 보기 가능",
"Can edit pages" => "페이지 편집 가능",
// "Can inline-edit pages" => "Can inline-edit pages",
"Can view wiki history" => "위키 기록 보기 가능",
"Can admin the wiki" => "위키 관리 가능",
"Can assign permissions to wiki pages" => "위키 페이지에 권한 할당 가능",
"Can edit copyright notices" => "저작권 알림 편집 가능",
"Can edit dynamic variables" => "유동적 변수 편집 가능",
"Can export wiki pages using the export feature" => "내보내기 기능을 사용하여 위키 페이지 내보내기 가능",
"Can lock pages" => "페이지 잠금 가능",
"Can save as a minor edit" => "사소한 편집으로 저장 가능",
"Can remove" => "삭제 가능",
"Can rename pages" => "페이지 이름변경 가능",
"Can roll back pages" => "페이지 롤백 가능",
"Can upload pictures to wiki pages" => "위키 페이지에 그림 업로드 가능",
"Can use the page as a template for a tracker or unified search" => "페이지를 트래커 혹은 통합 검색에 대한 템플릿으로 사용 가능",
"Can view in module and feed the wiki pages reference" => "모듈에서 보기 및 위키 페이지 참조 피드 가능",
"Can admin attachments on wiki pages" => "위키 페이지에 첨부파일 관리 가능",
"Can add and change ratings on wiki pages" => "위키 페이지에 등급 추가 및 변경 가능",
"Can attach files to wiki pages" => "위키 페이지에 파일 첨부 가능",
"Can view and download wiki page attachments" => "위키 첨부파일 보기 및 다운로드 가능",
"Can view wiki comments" => "위키 댓글 보기 가능",
"Can view rating of wiki pages" => "위키 페이지 등급 보기 가능",
"Can view source of wiki pages" => "위키 페이지 소스 보기 가능",
"Can participate in rating of wiki pages" => "위키 페이지의 등급부여에 참여 가능",
"Can view similar wiki pages" => "유사한 위키 페이지 보기 가능",
"View page backlinks" => "페이지 백링크 보기",
"Can view unapproved revisions of pages" => "미승인된 페이지 수정 내역 보기 가능",
"Can approve revisions of pages" => "페이지 수정내역 승인 가능",
"Can view contributions to a page" => "페이지의 기여도 보기 가능",
"Can use reference library items" => "참조 라이브러리 항목 사용 가능",
"Can add to, edit and remove reference library items" => "참조 라이브러리 항목에 추가, 편집, 삭제 가능",
// "Can administer structures" => "Can administer structures",
"Can create and edit structures" => "구조체 만들기 및 편집 가능",
// "Can lock structures" => "Can lock structures",
"Can watch structures" => "그조체 주시 가능",
"Administrator can manage users, groups and permissions and all features" => "관리자는 사용자, 그룹, 및 권한과 모든 기능들을 관리할 수 있습니다",
"Can access site when closed" => "사이트가 닫혀있을 때 접근 가능",
"Administrator can admin banners" => "관리자는 배너 관리 가능",
"Can ban users or IP addresses" => "사용자 혹은 IP 차단 가능",
"Can admin the dynamic content system" => "유동적 컨텐츠 시스템 관리 가능",
"Can admin integrator repositories and rules" => "통합기 리포지터리와 규칙 관리 가능",
// "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n" => "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n",
"Can admin mail-in accounts" => "mail-in 계정 관리 가능",
"Can edit object permissions" => "개체 권한 편집 가능",
"Can admin external feeds" => "외부 피드 관리 가능",
"Can clean cache" => "캐시 소제 가능",
"Can create a new CSS file (style sheet) appended with -user" => "-user 로 접미어가 붙은 새 css 만들기 가능",
"Can remove the association between two pages in a translation set" => "전이 세트 내에서 2 페이지간 연결 삭제 가능",
"Can admin cookies" => "쿠키 관리 가능",
"Can edit translations and create new languages" => "번역 편집 및 새 언어 만들기가능",
"Can edit menus" => "메뉴 편집 가능",
"Can edit menu options" => "메뉴 옵션 편집 가능",
"Can edit site templates" => "사이트 템플릿 편집 가능",
"Can search" => "검색 가능",
"Can report a link to the webmaster" => "웹마스터에 링크 보고 가능",
"Can send a link to a friend" => "친구에게 링크 전송 가능",
"Can share a page (email, Twitter, Facebook, message, forums)" => "페이지 공유 가능 (이메일, 트위터, 페이스북, 메시지, 게시판)",
"Can use HTML in pages" => "페이지에 HTML 사용 가능",
"Can view action log" => "작업 로그 보기 가능",
"Can view the action log for users of his or her groups" => "자신의 그룹에 속한 사용자에 대한 작업 로그 보기 가능",
"Can view integrated repositories" => "통합된 리포지터리 보기 가능",
// "Can view results from user ratings" => "Can view results from user ratings",
"Can view referrer stats" => "참조인 통계 보기 가능",
"Can view site stats" => "사이트 통계 보기 가능",
"Can view site templates" => "사이트 템플릿 보기 가능",
// "Can view results from webservice requests" => "Can view results from webservice requests",
// "Can administer webservices" => "Can administer webservices",
"Can admin toolbars" => "툴바 관리 가능",
"Trust all user inputs including plugins (no security checks)" => "플러그인을 포함한 모든 사용자 입력을 신뢰 (보안 확인 없음)",
"Can view unapproved plugin details" => "미승인된 플러그인 상세내역 보기 가능",
"Can execute unapproved plugin registered" => "등록되었으나 미승인된 플러그인 실행 가능",
"Can approve plugin execution" => "플러그인 실행 승인 가능",
"Can admin mail notifications" => "메일 알림 관리 가능",
"Can use the importer" => "가져오기 도구 사용 가능",
"Can change the categories of an object" => "개체의 범주 변경 가능",
"User can administer modules" => "사용자는 모듈을 관리할 수 있음",
"Can switch between wiki and WYSIWYG modes while editing" => "편집 중 위키모드와 WYSIWYG모드 간 변경 가능",
"Can create a new workspace for a given template" => "주어진 템플릿에 대한 새 작업공간 만들기 가능",
// "Can manage all aspects of a goal" => "Can manage all aspects of a goal",
// "Can manage who is eligible for a goal" => "Can manage who is eligible for a goal",
// "Cannot add user %0 to nonexistent group %1" => "Cannot add user %0 to nonexistent group %1",
// "Cannot add nonexistent user %0 to group %1" => "Cannot add nonexistent user %0 to group %1",
"User \"%0\" is banned from the group \"%1\"" => "사용자 \"%0\" 님이 \"%1\" 그룹에서 차단되었습니다",
"Do you want to unban them and continue" => "이들을 차단해제하고 계속 진행시겠습니까",
// "Email cannot be set because this email is already in use by another user" => "Email cannot be set because this email is already in use by another user",
"Password should be at least %0 characters long" => "비밀번호는 최소 %0 글자 이상이어야만 합니다",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"." => "비밀번호는 a 와 같은 소문자와 A 와 같은 대문자를 반드시 최소 한 개씩 포함해야만 함",
"Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"" => "비밀번호는 111 혹은 aab 처럼 동일한 문자의 연속반복을 포함하지 않아야 합니다",
"Password must contain both letters and numbers" => "비밀번호는 문자와 숫자를 모두 포함해야 합니다",
"Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + ..." => "비밀번호는 최소 다음과 같은 특수 문자를 포함해야합니다 \" / \$ % ? & * ( ) _ + ...",
"The password must be different from the user's log-in name." => "비밀번호는 사용자 로그인과 달라야만 함.",
// "The password is blacklisted because it is too common" => "The password is blacklisted because it is too common",
// "No user tracker found with id #%0" => "No user tracker found with id #%0",
"The administrator has not yet validated your account. Please wait" => "관리자가 아직 귀하의 계정을 유효화하지 않았습니다. 기다려주십시오",
"You must validate your account first. An email has been sent to you" => "귀하의 계정을 먼저 반드시 유효화해야 합니다. 이메일이 귀하게 전송되었습니다",
// "Email address is required" => "Email address is required",
// "Invalid email address \"%0\"" => "Invalid email address \"%0\"",
// "Unable to send mail to invite \"%0\"" => "Unable to send mail to invite \"%0\"",
// "The email could not be retrieved from the IdP and is required" => "The email could not be retrieved from the IdP and is required",
// "The username could not be retrieved from the IdP and is required" => "The username could not be retrieved from the IdP and is required",
// "SAML Login failed. User not authenticated" => "SAML Login failed. User not authenticated",
"Can edit one's own forum posts" => "자신의 게시판 게시물 편집 가능",
"The registration mail can't be sent. Contact the administrator" => "등록메일이 발송될 수 없었습니다. 관리자에게 연락하십시오",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "등록 메일은 서버 이메일 주소가 설정된 것이 없으므로 발송될 수 없었습니다, 그리고 이 기능은 비활성화되었습니다",
"The user email confirmation can't be sent. Contact the administrator" => "사용자 이메일 확인이 발송될 수 없습니다. 관리자에게 연락하십시오",
// "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)",
"Edit field: (Incorrect validation parameter)" => "필드 편집: (옳지않은 승인 매개 변수)",
"Page already exists" => "페이지 이미 존재함",
"Page does not exist" => "페이지가 존재하지 않습니다",
// "Email already in use" => "Email already in use",
"Invalid email" => "유효하지 않은 이메일",
"Invalid character combination for username" => "사용자명에 대하여 유효하지 않은 문자 조합",
// "Username must be all lower case" => "Username must be all lower case",
"Personal Phone" => "개인 전화",
"Personal Mobile" => "개인 모바일",
"Personal Fax" => "개인 팩스",
"Work Phone" => "직장 전화",
"Work Mobile" => "직장 모바일",
"Work Fax" => "직장 팩스",
"Company" => "회사",
"Organization" => "단체",
"Department" => "부서",
// "Division" => "Division",
"Job Title" => "직함",
"Street Address" => "거리 주소",
"City" => "시",
"State" => "주",
"Postal Code" => "우편번호",
// "Mail to: User not found" => "Mail to: User not found",
// "(AT)" => "(AT)",
"(DOT)" => "(점)",
// "Webservice error on %0 request \"%1\"" => "Webservice error on %0 request \"%1\"",
// "You will need to rebuild the search index to see these changes" => "You will need to rebuild the search index to see these changes",
// "Parse To Wiki %0: preg_replace error #%1" => "Parse To Wiki %0: preg_replace error #%1",
"Cannot create aliased page" => "별칭 페이지 만들 수 없음",
"You attempted to create the following page" => "다음 페이지를 만드려 시도하셨습니다",
"That page is an alias for the following pages" => "그 페이지는 다음 페이지들을 위한 별칭입니다",
"If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this" => "페이지를 만드려면, 위의 각 페이지를 먼저 편집해야만 합니다, 그리고 포함되어 있을 수 있는 별칭 링크를 삭제해야만 합니다. 이 링크는 다음과 유사하게 표시되어야 합니다",
"Can't parse HTML data - no grammar file" => "HTML 데이터 구문분석 불가 - 문법 파일 없음",
"Rollback by %0 to version %1" => "롤백 버전",
"Removed version \$version" => "버전 \$version 제거함",
"Changed actual version to \$version" => "실제 버전을 \$version 으로 변경함",
"No version indicated" => "버전 지정되지 않음",
"Plugin " => "플러그인",
"failed" => "실패함",
"Required parameters are in</em> <b>bold</b>" => "필수적 매개 변수들은 </em> <b>굵은체</b>로 되어있음",
"Parameter Info" => "매개 변수 정보",
"There are no approved versions of this page" => "이 페이지의 승인된 버전이 없습니다",
"Semantic token already exists" => "시맨틱 토큰이 이미 존재함",
"Invalid semantic token name" => "유효하지 않은 시맨틱 토큰명",
"Semantic token not found" => "시맨틱 토큰이 발견되지 않음",
"Page locked" => "페이지 잠겨짐",
"Page unlocked" => "페이지 잠금해제됨",
// "Initial content copied from version %0 of page %1" => "Initial content copied from version %0 of page %1",
// "You don't have permission to use category '%0'" => "You don't have permission to use category '%0'",
// "You don't have permission to edit categories" => "You don't have permission to edit categories",
// "You don't have permission to edit tags" => "You don't have permission to edit tags",
"Removed last version" => "제거된 마지막 버전",
// "Activity Stream" => "Activity Stream",
// "Create a social network activity stream" => "Create a social network activity stream",
"List configuration information" => "구성 정보 나열",
// "Auto-Scroll" => "Auto-Scroll",
// "Automatically load next page of results when scrolling down" => "Automatically load next page of results when scrolling down",
"Add Tag" => "태그 추가",
// "Provide an input field for adding a tag to an object" => "Provide an input field for adding a tag to an object",
// "Object type and id, as in %0type:id%1, if unset, will use current object" => "Object type and id, as in %0type:id%1, if unset, will use current object",
"Add Reference" => "참조 추가",
// "Add a bibliography reference" => "Add a bibliography reference",
"Biblio Code" => "도서 목록 정보 코드",
"The code to be added as reference" => "참조로써 추가될 코드",
// "missing bibliography definition" => "missing bibliography definition",
"Add Relation" => "관계 추가",
// "Provide a button to toggle a pre-specified relation" => "Provide a button to toggle a pre-specified relation",
"Qualifier" => "한정자",
"Relation qualifier. Usually a three-part string separated by two periods" => "관계 한정자. 일반적으로 2 마침표로 분리된 3부분의 문자열임",
"Source Object" => "소스 개체",
// "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank",
"Target Object" => "목표 개체",
// "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank",
"Button Text for Add" => "추가에 대한 버튼 텍스트",
"Text to show on the button to add relation" => "관계를 추가하기 위한 버튼 상에 표시될 텍스트",
"Button Text for Already Added State" => "이미 추가된 상태에 대한 버튼 텍스트",
"Text to show on the button when relation is already added" => "관계가 이미 추가되었을 때 버튼 상에 표시될 텍스트",
"Relation Added" => "관계 추가됨",
"Mouseover Button Text for Remove" => "삭제에 대한 마우스오버 버튼 텍스트",
"Text to show on the button to remove relation" => "관계를 삭제하기 위한 버튼 상에 표시될 텍스트",
"Remove Relation" => "관계 제거",
"Button ID" => "버튼 ID",
"A unique ID to distinguish the button from others on the page if there is more than one" => "버튼이 페이지 상에 한 개 이상 있을 경우 다른 버튼들과 구분하기 위한 고유 ID",
// "Set Button Class" => "Set Button Class",
// "Class or classes for the Button" => "Class or classes for the Button",
"Source and target object cannot be the same" => "소스와 타겟 개체는 동일할 수 없습니다",
"Add to cart" => "카트에 추가",
// "PluginAddToCart" => "PluginAddToCart",
// "Add a product to the shopping cart" => "Add a product to the shopping cart",
"Product code" => "제품 코드",
"Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "제품에 대한 고유 식별자. 동일한 코드를 가진 두 제품들은 동일한 것이 될 것이며 사용된 정보는 첫 번째 입력된 것이 될 것입니다",
"Label for the product in the cart" => "카트 내부의 제품에 대한 레이블",
"Product Type" => "제품 유형",
"The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket" => "판매되는 제품 유형, 이는 처리에 영향을 미치게 될 것입니다, 예, 표준 제품, 선물 상품권, 이벤트 티켓",
"Product Class" => "제품 클래스",
"The class the product belongs to. Can be used to limit how gift cards are used" => "제품이 속하는 클래스, 상품 카드가 어떻게 사용되는지를 제한하기 위하여 사용될 수 있습니다",
"Product Bundle" => "제품 번들",
"The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart" => "제품이 속한 번들, 선물카드가 어떻게 사용되는지를 제한하기 위하여 사용될 수 있으며 , 카트에 동일한 클래스 내부에 다른 제품을 추가할 것입니다",
"Bundle Class" => "번들 클래스",
"The class the bundle belongs to. Can be used to limit how gift cards are used" => "번들이 속하는 클래스, 선물카드가 어떻게 사용되는지를 제한하기 위하여 사용될 수 있습니다",
"Price" => "가격",
"The price to charge for the item" => "항목에 대하여 부가될 가격",
// "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)" => "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)",
"Button label" => "버튼 라벨",
// "Text for the submit button. default" => "Text for the submit button. default",
"Associated event code" => "연결된 이벤트 코드",
"Unique identifier for the event that is associated to the product" => "제품에 연관된 이벤트에 대한 고유 식별자",
"Automatically check out" => "자동으로 체크아웃",
"Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)" => "구입에 대하여 자동으로 체크아웃 및 사용자를 지불로 보냄 (이는 카트에 무엇인가 이미 있을 경우 비활성화됨)",
// "Hide Quantity" => "Hide Quantity",
// "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)" => "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)",
"Buy on behalf of" => "구매 의뢰",
"Allows the selection of user to make purchase on behalf of" => "대리 구매할 사용자 선택 허용",
"Shop as anonymous always" => "항상 익명사용자로써 구매",
"Add to cart as anonymous shopper even if logged in" => "로그인되었어도 익명 고객으로 카트에 추가",
"Forward to this URL after free purchase" => "무료 구매 후 이 URL로 전송",
"Gift certificate" => "선물 상품권",
"Allows user to add gift certificate from the product view" => "사용자가 제품 보기에서 상품권을 추가하는 것을 허용",
"Order Item ID to exchange product" => "제품을 교환할 주문 항목 ID",
"Used in conjunction with exchange feature" => "교환 기능과 함께 사용됨",
"Product ID to exchange to" => "교환 후 받을 제품 ID",
"Amount of new product to exchange for" => "교환할 새 제품의 양",
"Should normally be set to the amount of products in the order being exchanged" => "일반적으로는 교환되는 주문에서 제품의 양으로 설정되어야 함",
"Ajax add to cart feature" => "AJAX 바구니 추가 기능",
"Attempts to turn on Ajax for the cart" => "카트에 대하여 ajax 를 켜기 시도",
"Weight" => "가중",
// "The weight of the item" => "The weight of the item",
"The order was recorded and is now awaiting payment. Reference number is %0" => "순서는 기록되었습니다만 지불을 대기 중입니다. 참조번호는 %0 입니다",
"Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "귀하의 %0 (%1) 무료 주문이 처리되었습니다. 이메일 한 통이 귀하의 기록을 위해 발송되었습니다",
"Your free order of %0 (%1) has been processed" => "귀하의 %0 (%1) 무료 주문이 처리되었습니다",
"%0 (%1) was added to your cart" => "%0 (%1) 이 카트에 추가되었습니다",
"Add to Google Calendar" => "구글 캘린더에 추가",
"Add a calendar item to a Google calendar." => "구글 캘린더에 캘린더 아이템 추가",
"Calendar item ID" => "달력 항목 ID",
"The item ID of the calendar to add to Google calendar" => "구글 달력으로 추가할 달력의 항목 ID",
"A calendar item ID number" => "달력 항목 ID 숫자",
"Icon Style" => "아이콘 스타일",
"Choose the icon style" => "아이콘 스타일 선택",
"Either 1, 2 or 3" => "1, 2, 3 중 하나",
"Adjust Inventory" => "재고 조절",
// "PluginAdjustInventory" => "PluginAdjustInventory",
// "Adjust the inventory level of a product" => "Adjust the inventory level of a product",
"Product ID" => "제품 ID",
"Product ID of item in the cart tracker" => "카트 트래커에 있는 항목의 제품 ID",
// "Show Add" => "Show Add",
// "Show option to add to inventory" => "Show option to add to inventory",
// "Show Subtract" => "Show Subtract",
// "Show option to subtract from inventory" => "Show option to subtract from inventory",
"Inventory was adjusted by %0" => "재고가 %0 님에 의하여 조절되었습니다",
"User Agent Info" => "사용자 에이전트 정보",
"Show the user's browser and server information." => "사용자 브라우저 및 서버 정보 표시",
"Info" => "정보",
"Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "방문객의 IP 주소 (IP 혹은 기본), 브라우저 정보 (BROWSER), 혹은 서버 소프트웨어 (SVRSW) 를 표기",
"IP address" => "IP 주소",
"Server software" => "서버 소프트웨어",
"Browser" => "브라우저",
// "Ajax Load" => "Ajax Load",
// "Load data into an HTML div using Ajax or in an iframe" => "Load data into an HTML div using Ajax or in an iframe",
// "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML" => "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML",
// "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1" => "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1",
// "Selector" => "Selector",
// "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1" => "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1",
"Target" => "목표",
// "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page" => "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page",
// "HTML id for the div or iframe" => "HTML id for the div or iframe",
// "Class for the div or iframe" => "Class for the div or iframe",
// "In pixels or percentage. Default value is %0" => "In pixels or percentage. Default value is %0",
// "Make Links Absolute" => "Make Links Absolute",
// "Convert relative links in the incoming data to be absolute. Default value is \"All\"" => "Convert relative links in the incoming data to be absolute. Default value is \"All\"",
// "Images Only" => "Images Only",
// "Links Only" => "Links Only",
// "Parameter URL missing" => "Parameter URL missing",
"Anchor Link" => "기준위치 링크",
"Create a link to an anchor" => "기준위치로 링크 만들기",
"Anchor link label" => "앵커 링크 레이블",
"Anchor Name" => "앵커명",
"The anchor name as defined in the Aname plugin" => "ANAME 페이지 내부에 정의된 앵커명",
"The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "앵커를 포함하는 위키페이지명. 비어있는 경우, 앵커명은 플러그인이 사용된 위키 페이지들을 상대로 검색될 것입니다",
"Create an anchor that can be linked to" => "연결될 수 있는 기준 위치 만들기",
"The name of the anchor" => "앵커명",
"Image Annotation" => "그림 주석",
"Annotate an image" => "그림에 주석달기",
"Autogenerated content. Leave blank initially" => "자동생성된 컨텐츠. 초기에는 빈 상태로 두십시오.",
// "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0" => "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0",
// "Absolute URL to the image or relative path from Tiki site root" => "Absolute URL to the image or relative path from Tiki site root",
"Image width in pixels" => "픽셀단위의 그림 넓이",
"Image height in pixels" => "픽셀 단위의 그림 높이",
"Alignment" => "맞춤",
// "Image alignment" => "Image alignment",
"Center" => "가운데 맞춤",
"CSS Class" => "CSS 클래스",
// "Class of the containing DIV element" => "Class of the containing DIV element",
// "Show List" => "Show List",
// "Show the list of annotations below the image" => "Show the list of annotations below the image",
// "(y/n)" => "(y/n)",
"Show Link" => "링크 보기",
// "Show the link below the label in the popups" => "Show the link below the label in the popups",
"Save changes to annotations" => "주석에 변경내역 저장",
"Image annotations changed" => "그림 주석 변경됨",
"Editable" => "편집가능",
"Label" => "레이블",
"Application Frame" => "응용프로그램 프레임",
// "Create a frame in which to assemble custom applications" => "Create a frame in which to assemble custom applications",
"Application layout" => "응용프로그램 레이아웃",
"Minimum height" => "최소 높이",
"Prevent the frame from becoming any shorter than the specified size" => "프레임이 지정된 크기보다 작아지는 것 방지",
"Maximum height" => "취대 높이",
"Prevent the frame from becoming any higher than the specified size" => "프레임이 지정된 크기보다 커지는 것 방지",
"Hide left column" => "좌측 열 숨김",
"Hide the left column when the application frame is in use to provide more space to the application" => "응용프로그램이 사용 중인 경우, 응용 프로그램에 좀 더 많은 공간을 제공하기 위하여 좌측 열 숨김",
"Hide right column" => "우측 열 숨김",
"Hide the right column when the application frame is in use to provide more space to the application" => "응용프로그램이 사용 중인 경우, 응용 프로그램에 좀 더 많은 공간을 제공하기 위하여 우측 열 숨김",
"Full page" => "페이지 전체",
"Completely fill the content area of the page" => "페이지의 컨텐츠 영역 전체를 차지함",
"Absolute Position" => "절대 위치",
"Use all available space for the application frame (by means of CSS absolute positioning)" => "앱 프레임을 절대 위치와 사용가능한 모든 가능한 공간를 사용하도록 위치",
"When using absolute mode, leave some space for the header at the top" => "절대 모드를 사용할 때, 상단에 헤더에 대하여 일부 공간을 남겨둡니다",
"Fill the complete page" => "페이지 전체를 차지함",
"Template file not found: %0" => "템플릿 파일 발견되지 않음: %0",
"Pan/Zoom" => "이동/확대/축소",
"Select" => "선택",
"Select/Modify" => "선택/수정",
"Draw Polygon" => "폴리곤 그리기",
"Draw Path" => "경로 그리기",
"Reset Zoom" => "확대/축소 재설정",
"Archive Builder" => "보관물 빌더",
// "Define an archive that can be downloaded" => "Define an archive that can be downloaded",
"Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "기록 컨텐츠의 설명. 컨텐츠 유형들에 대하여 여러 개의 핸들러가 사용 가능합니다. 한 줄에 하나씩. 예: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
"Archive Name" => "보관 이름",
"Upon download, the name of the file that will be provided" => "다운로드 시 제공될 파일의 이름",
"Missing \".zip\" file name extension" => "zip 확장기능 누락",
"Incorrect parameter" => "틀린 매개 변수",
"Download archive" => "보관물 다운로드",
"Display a field of an article" => "기사의 필드 표시",
"The article field (component) to display. The default field is \"Heading\"" => "표시할 기사 필드. 기본 필드는 제목",
"Article ID" => "기사 ID",
"The article to display. If no value is provided, the most recent article will be used" => "표시할 기사. 값이 제공되지 않은 경우, 가장 최근 기사가 사용됩니다",
"Article List" => "기사 목록",
"Display multiple articles" => "여러 개의 기사 표시",
"Use Pagination" => "페이지 매김 사용",
// "Activate pagination when the articles list is long. Default is %0" => "Activate pagination when the articles list is long. Default is %0",
"Maximum Displayed" => "최대 표시됨",
// "The number of articles to display in the list (use %0 to show all)" => "The number of articles to display in the list (use %0 to show all)",
"Topic Name Filter" => "토픽 이름 필터",
"Filter the list of articles by topic. Example: " => "토픽에 의해 기사의 목록 필터. 예제:",
"Topic ID Filter" => "토픽 ID 필터",
"Filter the list of articles by topic ID. Example: " => "토픽에 의해 기사의 목록 필터. 예제",
// "Valid topic IDs" => "Valid topic IDs",
"Type Filter" => "유형 필터",
"Filter the list of articles by types. Example: " => "유형에 의한 기사의 목록 필터. 예제:",
// "Valid article types" => "Valid article types",
"Category ID" => "범주 ID",
// "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted" => "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted",
"List only articles in this language" => "이 언어로 된 기사만 나열",
// "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items" => "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items",
// "random or column names to add _asc _desc to: " => "random or column names to add _asc _desc to: ",
"Specific order" => "특정 주문",
"List of ArticleId that must appear in this order if present" => "만약 존재한다면 이 순서대로 반드시 표시될 기사 ID의 목록",
"Only these articles" => "이 기사들만",
// "List of article IDs to display, separated by \"%0\"" => "List of article IDs to display, separated by \"%0\"",
"Not these articles" => "이 기사들 아님",
// "List of article IDs to not display, separated by \"%0\"" => "List of article IDs to not display, separated by \"%0\"",
"Quiet" => "조용함",
"Whether to not report when there are no articles (no reporting by default)" => "기사가 없을 때 보고를 할 지 여부 (기본으로는 보고하지 않음)",
"Title Only" => "제목 만",
"Whether to only show the title of the articles (not set to title only by default)" => "기사의 제목만 표시할 지 여부 (기본으로 제목만으로 설정되지 않음)",
"Show Article Body" => "기사 본문 표시",
// "Whether to show the body of the articles instead of the heading (not set by default)" => "Whether to show the body of the articles instead of the heading (not set by default)",
"Starting Article" => "시작 기사",
// "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)" => "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)",
"This will not work if Pagination is used" => "페이지 매김이 사용되었다면 작동하지 않을 것입니다",
"Start Date" => "시작 날짜",
"Earliest date to select articles from" => "기사를 선택해 올 가장 초반의 날짜",
// " (%0YYYY-MM-DD%1)" => " (%0YYYY-MM-DD%1)",
"Latest date to select articles from" => "기사를 선택해 올 최근 날짜",
"Period quantity" => "기간 양",
// "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored" => "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored",
"Period unit" => "기간 단위",
"Time unit used with \"Period quantity\"" => "\"기간 양\"과 사용될 시간 단위",
"Override Dates" => "날짜 재정의",
// "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)" => "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)",
"Containing class" => "컨테이너 클래스",
// "CSS class to add to the containing \"div.article\" (default: \"%0\")" => "CSS class to add to the containing \"div.article\" (default: \"%0\")",
// "Valid CSS class" => "Valid CSS class",
"Large First Image" => "대형 첫번째 그림",
// "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article" => "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article",
"Additional URL parameter for the link to read the article" => "기사를 읽기 위한 링크로의 추가적 URL 매개변수",
"Show actions (buttons and links)" => "작업 표시 (버튼과 링크)",
// "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do",
"No translation" => "번역 없음",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language",
// "Use Source URL" => "Use Source URL",
// "Use the external source URL as link for articles" => "Use the external source URL as link for articles",
// "Display an attachment or a list of them" => "Display an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment",
"File" => "파일",
"Same as name" => "이름과 동일",
// "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page",
"Show Description" => "설명 보기",
"Shows the description as the link text instead of the file name (not used by default)" => "파일명 대신 링크 텍스트로써 설명 표시 (기본으로 사용되지 않음)",
"Bullets" => "글머리 기호",
"Makes the list of attachments a bulleted list (not set by default)" => "첨부파일의 목록을 글머리 기호 목록으로 만듭니다 (기본으로 설정되지 않음)",
// "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)",
"Custom Label" => "사용자 지정 레이블",
// "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed" => "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)",
"Order Number" => "주문 번호",
// "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment",
// "Attachment name, file, id or num" => "Attachment name, file, id or num",
// "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)",
"File Type Icon" => "파일 유형 아이콘",
// "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)" => "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)",
"Page \"%0\" does not exist" => "\"%0\" 페이지는 존재하지 않음",
"No such attachment on this page" => "이 페이지에 그런 첨부파일 없음",
"Attributes" => "특성",
"Assign generic attributes to the current object" => "일반 속성을 현재 개체에 할당",
// "Add popups and color coding that identifies authors" => "Add popups and color coding that identifies authors",
"Username of the author of the text" => "텍스트를 작성한 사용자의 사용자명",
"Deleted by User" => "사용자에 의하여 삭제",
"Username of the person who deleted the text" => "텍스트를 삭제한 사용자의 사용자명",
"Make Visible" => "표시합니다",
"Show popup with author/deleted by" => "저자/삭제한 이와 함께 팝업 표시",
"Generate a popup with names of author(s) (default: no)" => "저자(들)의 이름과 함께 팝업 생성 (기본: 아니오)",
"deleted by" => "삭제하신 분",
"Should this author's contribution be visible (default: no)" => "이 저자의 기여도가 보이게 하겠습니까 (기본: 아니오)",
// "Auto Query Args" => "Auto Query Args",
// "Automatically propagate arguments when clicking on links" => "Automatically propagate arguments when clicking on links",
// "Arguments for auto query" => "Arguments for auto query",
// "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin" => "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin",
"Profile picture" => "아바타",
"Display a user's profile picture" => "사용자의 아바타 표기",
// "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page" => "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page",
"Float" => "부동",
"Align the profile picture on the page" => "페이지 상의 아바타 맞춤",
// "Full Size" => "Full Size",
// "If full-size images are stored in the file gallery, show the full-size image" => "If full-size images are stored in the file gallery, show the full-size image",
"Back" => "뒤로",
// "Display a link that goes back one page in the browser history" => "Display a link that goes back one page in the browser history",
// "List all pages that link to a particular page" => "List all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "링크가 가리킬 페이지. 기본값은 현재 페이지입니다",
"Displayed Information" => "표기된 정보",
"Pipe separated list of fields to display. ex: hits|user" => "표시할 필드들의 파이프로 구분된 목록. 예: 방문수|사용자",
"Excluded pages" => "제외된 페이지들",
// "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1" => "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1",
"Include Self" => "자신을 포함",
"With or without self-link (default is without)" => "셀프 링크와 함께 혹은 없이 (기본은 없이)",
"With or without header (default is with header)" => "헤더와 함께 혹은 없이 (기본은 헤더와 함께)",
"With header" => "헤더와 함께",
"Without header" => "헤더 없이",
"No pages link to" => "다음으로 페이지 링크 없음",
"One page links to" => "한 페이지가 다음으로 연결됩니다",
"pages link to" => "다음으로의 페이지 링크",
"Add a banner" => "배너 추가",
"Zone" => "구역",
"Name of the zone created in Admin > Banners" => "관리 > 배너 내부에 만들어진 구역의 이름",
"Determines the browser behavior when the banner is clicked" => "배너가 클릭되고 나면 브라우저의 동작을 결정함",
"missing parameter" => "매개 변수 없음",
// "Benchmark" => "Benchmark",
// "Performance-test wiki content (used by developers to optimize plugins)" => "Performance-test wiki content (used by developers to optimize plugins)",
// "Iteration Quantity" => "Iteration Quantity",
// "The number of iterations to process" => "The number of iterations to process",
// "Each Iteration Details" => "Each Iteration Details",
// "Provides time and memory of each iteration" => "Provides time and memory of each iteration",
"BigBlueButton" => "빅블루버튼",
// "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system" => "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system",
"Meeting" => "회의",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1",
// "Anonymous Prefix" => "Anonymous Prefix",
"Unregistered users will get this token prepended to their name" => "미등록 사용자들은 이름 앞에 이 토큰이 붙게 될 것입니다",
"Welcome Message" => "환영 메시지",
"A message to be provided when someone enters the room" => "누군가 방에 입장하였을 때 제공될 메시지",
"Dial Number" => "번호 다이얼",
"The phone-in support number to join from traditional phones" => "일반 전화에서 참여할 전화 지원 번호",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID",
"Log-out URL" => "로그아웃 URL",
"URL to which the user will be redirected after logging out of BigBlueButton" => "빅블루버튼에서 로그 아웃 시 사용자가 보내지게 되는 URL",
"Record" => "기록",
// "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8" => "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8",
// "Display Recordings" => "Display Recordings",
// "Enable or Disable the display of video recordings" => "Enable or Disable the display of video recordings",
// "Display Attendees" => "Display Attendees",
// "Enable or Disable the display of attendees list" => "Enable or Disable the display of attendees list",
"BigBlueButton is misconfigured or inaccessible" => "빅블루버튼이 잘 못 구성되었거나 접근할 수 없음",
"Blog List" => "블로그 목록",
"Display posts from a site blog" => "사이트 블로그에서 게시 표기",
"Blog ID" => "블로그 ID",
// "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown" => "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown",
"Maximum Items" => "최대 항목",
"Maximum number of entries to list (no maximum set by default)" => "나열할 항목들의 최대 수 (기본으로 최대값 설정되지 않음)",
"Only display posts created by this user (all posts listed by default)" => "이 사용자가 마든 게시물만 표시합니다 (기본으로 모든 게시물이 나열됩니다)",
"Simple List" => "단순 목록",
// "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts" => "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts",
"Character Count" => "글자 수",
// "Number of characters to display if not a simple list (defaults to all)" => "Number of characters to display if not a simple list (defaults to all)",
// "Word Boundary" => "Word Boundary",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only",
// "Ellipsis" => "Ellipsis",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)",
"More" => "추가",
// "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)",
// "Show Icons" => "Show Icons",
// "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)" => "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)",
// "Use Excerpt" => "Use Excerpt",
// "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)" => "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)",
"Earliest date to select posts from" => "게시물을 선택해 올 가장 초반의 날짜",
"End Date" => "종료 날짜",
"Latest date to select posts from" => "게시물을 선택해 올 최근 날짜",
"Container Class" => "컨테이너 클래스",
// "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)" => "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)",
"Missing blog ID for Bloglist plugin" => "BLOGLIST 플러그인에 대하여 블로그 ID 없음",
// "Create a formatted box with a title bar" => "Create a formatted box with a title bar",
// "Box Title" => "Box Title",
"Displayed above the content" => "컨텐츠 위에 표기",
"As defined by CSS, name, or color hex code" => "CSS, 이름 혹은 헥스 코드에 의하여 정의된 바, ",
// "Valid CSS color name or code" => "Valid CSS color name or code",
// "Box Width" => "Box Width",
"Text Alignment" => "텍스트 정렬",
"Aligns the text within the box (left-aligned by default)" => "상자 내부의 텍스트를 맞춤 (기본으로 왼쪽 맞춤)",
"Float Position" => "Float 위치",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)",
"Clear" => "비움",
// "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)" => "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)",
"Apply custom CSS class to the box" => "사용자 지정 CSS 클래스를 상자에 적용",
"CSS Style" => "CSS 스타일",
// "Enter CSS styling tags for the div type used e.g. padding: 5px" => "Enter CSS styling tags for the div type used e.g. padding: 5px",
"Button" => "버튼",
"Add a link formatted as a button" => "버튼으로 서식처리된 링크 추가",
// "Label for the button (ignored if the text is defined)" => "Label for the button (ignored if the text is defined)",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it" => "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it",
"Label for the button" => "버튼에 대한 레이블",
// "Icon Name" => "Icon Name",
// "Enter an iconset name to show an icon in the button" => "Enter an iconset name to show an icon in the button",
// "Button Type" => "Button Type",
// "Use a type to style the button. By default btn-primary will be applied" => "Use a type to style the button. By default btn-primary will be applied",
// "Danger" => "Danger",
// "Primary" => "Primary",
// "Button width" => "Button width",
// "In pixels or percentage. (e.g. 200px or 100%)" => "In pixels or percentage. (e.g. 200px or 100%)",
// "Button height" => "Button height",
// "CSS class for the button. Note that the btn class is always applied by default" => "CSS class for the button. Note that the btn class is always applied by default",
// "CSS style attributes" => "CSS style attributes",
// "Link Relation" => "Link Relation",
// "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation" => "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation",
// "Auto Arguments" => "Auto Arguments",
// "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter" => "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter",
// "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL" => "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL",
// "Flip Id" => "Flip Id",
// "HTML id attribute of the element to show/hide content" => "HTML id attribute of the element to show/hide content",
// "Flip Hide Text" => "Flip Hide Text",
// "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown" => "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown",
// "Flip Default Open" => "Flip Default Open",
// "If set to %0, the flip is open by default (if no cookie jar)" => "If set to %0, the flip is open by default (if no cookie jar)",
// "Escape Apostrophes" => "Escape Apostrophes",
// "If set to %0, will escape the apostrophes in onclick" => "If set to %0, will escape the apostrophes in onclick",
// "Disable Button" => "Disable Button",
// "Set to %0 to disable the button" => "Set to %0 to disable the button",
"lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php 이 없거나 읽을 수 없습니다",
"Display a calendar and its events" => "달력과 이벤트 표기",
"Calendar IDs" => "달력 ID들",
// "Comma-separated list of calendar Ids to restrict the events to specified calendars" => "Comma-separated list of calendar Ids to restrict the events to specified calendars",
"Example values" => "예제 값",
"Not set by default" => "기본으로 설정되지 않음",
"View Type" => "유형 보기",
// "Determines how events" => "Determines how events",
// "%0 (default) shows events in a calendar" => "%0 (default) shows events in a calendar",
"View Time Span" => "시간 범위 보기",
// "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar" => "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar",
"Default is month" => "기본은 월입니다",
"Navigation Bar" => "탐색 바",
// "Show or hide the navigation bar (not shown by default)" => "Show or hide the navigation bar (not shown by default)",
"Carousel" => "회전",
"Display images in a self-advancing carousel" => "그림을 자동 회전에 표시",
// "Images Source" => "Images Source",
// "Choose where to get your images from" => "Choose where to get your images from",
"Select an option" => "선택사항 선택",
"All the images in a file gallery" => "파일 갤러리 안의 모든 그림",
// "A list of file IDs" => "A list of file IDs",
"File Gallery ID" => "파일 갤러리 ID",
"ID number of the file gallery that contains the images to be displayed" => "표시될 그림을 포함하는 파일 갤러리의 ID 번호",
// "File IDs" => "File IDs",
// "List of IDs of images from the File Galleries separated by commas" => "List of IDs of images from the File Galleries separated by commas",
"Sort Mode" => "모드 정렬",
// "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2" => "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2",
// "Transition Time" => "Transition Time",
"The time (in milliseconds) for the transition between two images" => "두 개의 그림 사이에 전이하는데 걸리는 시간 (밀리초 단위)",
"number" => "숫자",
// "Display Time" => "Display Time",
"The time (in milliseconds) to display each image" => "각 그림을 표시할 시간 (밀리초 단위)",
// "Caption Height" => "Caption Height",
"The height of the caption. This is a fraction of the height of the images" => "자막 높이. 이는 그림 높의의 분수입니다",
"real between 0 and 1" => "0과 1사이의 실수",
// "Display Progress Bar" => "Display Progress Bar",
// "Display Thumbnails" => "Display Thumbnails",
"Display thumbnails, number, count etc" => "미리보기, 숫자, 개수 등 표기",
"Buttons" => "버튼",
"Numbers" => "수",
// "Thumbnail Box Width" => "Thumbnail Box Width",
// "Width of thumbnail box in CSS units (default %0)" => "Width of thumbnail box in CSS units (default %0)",
// "Thumbnail Box Height" => "Thumbnail Box Height",
// "Height of thumbnail box in CSS units (default %0)" => "Height of thumbnail box in CSS units (default %0)",
// "Start Automatically" => "Start Automatically",
"Start the carousel automatically when the page loads (default: Yes)" => "페이지가 로드될 때 자동으로 회전 (기본 예)",
"Legacy v2 param" => "레거시 v2 변수",
"Display thumbnails" => "미리보기 표기",
// "Thumbnail Numbers" => "Thumbnail Numbers",
"Display place numbers in the thumbnail boxes" => "축소판 그림 상자 내부에 위치 숫자 표시",
// "Thumbnail Background" => "Thumbnail Background",
"Use corresponding image as background for a thumbnail box" => "축소보기 상자에 대한 배경으로 해당 그림 사용",
// "Thumbnail Font Size" => "Thumbnail Font Size",
// "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)" => "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)",
// "CSS units" => "CSS units",
// "Image Size" => "Image Size",
// "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels" => "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels",
// "Real between 0 and 1, or integer over 10" => "Real between 0 and 1, or integer over 10",
// "Makes images clickable" => "Makes images clickable",
// "In case there are URLs in the image description, the image is made clickable and links to the first URL found" => "In case there are URLs in the image description, the image is made clickable and links to the first URL found",
"Cart Missing User Info" => "카트에 사용자 정보 없음",
// "PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check completeness of user input for a shopping cart transaction" => "Check completeness of user input for a shopping cart transaction",
// "Information Type" => "Information Type",
"Post Purchase" => "Post 구매",
"Required before purchase" => "구입 이전에 요구됨",
"Product Class ID" => "제품 클래스 ID",
// "CasperJS" => "CasperJS",
// "Enable running CasperJS scripts from this Tiki site" => "Enable running CasperJS scripts from this Tiki site",
// "CasperJS not available" => "CasperJS not available",
// "Execute CasperJS script" => "Execute CasperJS script",
"List categories and objects assigned to them" => "범주와 그에 할당된 개체 나열",
"Category IDs" => "범주 ID들",
// "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page" => "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page",
"Types" => "종류",
// "List of object types to include in the list, separated by \"+\", for example, " => "List of object types to include in the list, separated by \"+\", for example, ",
// "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)" => "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)",
"Hits Ascending" => "방문수 오름차순",
"Hits Descending" => "방문수 내림차순",
"Item ID Ascending" => "항목 ID 오름차순",
"Item ID Descending" => "항목 ID 내림차순",
"Type Ascending" => "유형 오름차순",
"Type Descending" => "유형 내림차순",
"Random" => "무작위",
"Split" => "분리",
"Whether multiple categories will be listed on different lines (default is to split them)" => "여러 개의 범주들이 다른 줄에 나열될 것인지 여부 (기본은 이들을 분할하는 것임)",
"And" => "및",
// "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)" => "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)",
// "Sub-categories" => "Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)",
"Show descriptions (not shown by default)" => "설명 보기 (기본으로 보이지 않음)",
"Show object names (shown by default)" => "개체명 표시 (기본으로 표시)",
"Show type (shown by default)" => "유형 표시 (기본으로 표시됨)",
"One Per Line" => "줄 당 한 개",
"Show one object per line (multiple per line shown by default)" => "줄 당 하나의 개체 표시 (기본으로 줄 당 여러개 표시)",
// "Child Links" => "Child Links",
"Show children category links (shown by default)" => "자식 범주 링크 표시 (기본으로 표시)",
// "Top Link" => "Top Link",
"Show top category link (shown by default)" => "상위 범주 링크 표시 (기본으로 표시됨)",
"Maximum Records" => "최대 기록",
// "Maximum number of objects to list (default is %0)" => "Maximum number of objects to list (default is %0)",
"Show title text above category object lists (shown by default)" => "제목 텍스트를 범주 개체 목록 위에 표시 (기본으로 표시됨)",
"List only objects in this language" => "이 언어로 된 개체만 나열",
// "Only apply if %0" => "Only apply if %0",
"Categories are disabled" => "범주가 비활성화됨",
// "PluginCategoryTransition" => "PluginCategoryTransition",
"Display controls to trigger category transitions for any object" => "어떤 개체에 대하여 범주 전이를 기동할 제어 표시",
"Redirect URL" => "리디렉션 URL",
"URL the user is sent to after transition is done" => "전이가 완료된 후 사용자가 보내지는 URL",
"Category Orphans" => "범주 고아",
"List objects that are not categorized" => "범주화되지 않은 개체 나열",
// "Determine which type of objects are shown (default is %0)" => "Determine which type of objects are shown (default is %0)",
"Calendars" => "달력",
// "Max" => "Max",
// "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records" => "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records",
"Result Offset" => "결과 오프셋",
"Result number at which the listing should start (default is no offset)" => "목록이 시작되어야 할 결과 숫자 (기본은 오프셋 없음입니다)",
"Category Path" => "범주 경로",
"Show the full category path for a wiki page" => "위키 페이지에 대한 전체 범주 경로 표시",
"Separator" => "구분 기호",
// "String used to separate the categories in the path. Default character is %0" => "String used to separate the categories in the path. Default character is %0",
"Display Top Category" => "상위 범주 표기",
"Show the top category as part of the path name (not shown by default)" => "경로명의 부분으로써 상위 범주 표시 (기본으로 표시안됨)",
// "Access and use a cclite social credit and alternative currency account" => "Access and use a cclite social credit and alternative currency account",
// "Mode of operation - summary or recent. Default: %0" => "Mode of operation - summary or recent. Default: %0",
"Account summary" => "계정 요약",
"Recent transactions" => "최근 거래",
"Registry" => "레지스트리",
"Registry to query. Default: site preference (or first in list when more than one)" => "질의할 레지스트리. 기본: 사이트 기본 설정 (혹은 한 개 이상이 있을 때 목록 내부의 첫번째)",
"You need to be logged in to view this information" => "이 정보를 보려면 로그인해야 합니다",
"Center text" => "텍스트 가운데 맞춤",
"Chart" => "차트",
"Display a chart from TikiSheet." => "티키시트에서 차트를 표시",
"Chart caption" => "차트 설명",
"Spreadsheet ID" => "시트 ID",
"Data sheet ID" => "데이터 시트 ID",
"Chart Type" => "차트 종류",
// "Specify a valid chart type" => "Specify a valid chart type",
"Chart Width" => "차트 너비",
"Width in pixels" => "픽셀단위의 넓이",
"Chart Height" => "차트 높이",
"Height in pixels" => "픽셀단위 높이",
// "Value series" => "Value series",
"Required for pie charts" => "파이차트에 대하여 요청됨",
// "Independent series" => "Independent series",
"Required for types other than pie chart" => "파이차트 외의 유형에 대하여 요청됨",
// "Dependent series" => "Dependent series",
"Description needed" => "설명이 필요함",
"Colors" => "색상",
"List of colors to use" => "사용할 색상들의 목록",
"Styles" => "스타일",
"List of styles to use" => "사용할 스타일들의 목록",
"Labels for the series or values in the legend" => "범례에서 시리즈 혹은 값에 대한 레이블",
"Chart as PDF" => "PDF 로 차트",
"Chart as PostScript" => "포스트스크립트로 차트",
// "Chart JS" => "Chart JS",
// "Create a JS Chart" => "Create a JS Chart",
// "JSON encoded array for data and options" => "JSON encoded array for data and options",
// "Chart Id" => "Chart Id",
// "A custom ID for the chart" => "A custom ID for the chart",
// "The type of chart. Currently works with pie, bar and doughnut" => "The type of chart. Currently works with pie, bar and doughnut",
// "The height of the chart in px" => "The height of the chart in px",
// "The width of the chart in px" => "The width of the chart in px",
// "Chart data values" => "Chart data values",
// "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)" => "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)",
// "Chart data labels" => "Chart data labels",
// "Colon-separated labels for the datasets in the chart. Max 10, if left empty" => "Colon-separated labels for the datasets in the chart. Max 10, if left empty",
// "Chart colors" => "Chart colors",
// "Colon-separated colors for the datasets in the chart. Max 10, if left empty" => "Colon-separated colors for the datasets in the chart. Max 10, if left empty",
// "Chart highlight" => "Chart highlight",
// "Colon-separated color of chart section when highlighted" => "Colon-separated color of chart section when highlighted",
// "Uses the non-minified version of the chart.js library for easier debugging" => "Uses the non-minified version of the chart.js library for easier debugging",
// "Values must be set for chart" => "Values must be set for chart",
// "Check Referer" => "Check Referer",
// "Display content based on the address that originated the request for the current page" => "Display content based on the address that originated the request for the current page",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met",
// "Referer List" => "Referer List",
// "Comma-separated list of domains to check" => "Comma-separated list of domains to check",
// "Display code with syntax highlighting and line numbering" => "Display code with syntax highlighting and line numbering",
"Code to be displayed" => "표기될 코드",
"Caption" => "자막",
"Code snippet label" => "코드 조각 라벨",
"Line Wrapping" => "자동 줄 바꿈",
// "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends" => "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends",
// "Any supported language listed at http://codemirror.net/mode/" => "Any supported language listed at http://codemirror.net/mode/",
"Line Numbers" => "줄 번호",
// "Show line numbers for each line of code" => "Show line numbers for each line of code",
"Right to Left" => "우에서 좌로",
"Switch the text display from left to right, to right to left (left to right by default)" => "텍스트 표시를 좌에서 우 대신 우에서 좌로 전환 (기본으로 좌에서 우)",
"Code Tag" => "코드 태그",
"Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "HTML 코드 태그내에 코드를 넣습니다, 예를 들면: &lt;code&gt;user input&lt;code&gt",
// "Any supported theme listed at https://codemirror.net/demo/theme.html" => "Any supported theme listed at https://codemirror.net/demo/theme.html",
"Colorbox" => "색상상자",
"Display a gallery of images in a popup slideshow" => "팝업 슬라이드쇼에 그림 갤러리 표기",
"Image Gallery ID" => "그림 갤러리 ID",
"ID number of the image gallery that contains the images to be displayed" => "표시될 그림을 포함하는 그림 갤러리의 ID 번호",
"File ID Filter" => "파일 ID 필터",
// "Colon-separated list of fileIds in a file gallery to show" => "Colon-separated list of fileIds in a file gallery to show",
"Thumb" => "축소보기",
// "Display as a thumbnail or full size" => "Display as a thumbnail or full size",
"Show File Title" => "파일 제목 보기",
"Show file title" => "파일 제목 보기",
"Show File Name" => "파일명 보기",
"Show file name" => "파일명 보기",
"Show All Thumbs" => "전체 축소보기 표시",
"Show thumbnails of all the images in the gallery" => "갤러리 내부의 모든 그림들의 축소보기 표시",
"Parse Descriptions" => "설명 구문분석",
"Parse the file descriptions as wiki syntax" => "파일 설명을 위키 문법으로 구문 분석",
"This feature is disabled" => "이 기능이 비활성화되었습니다",
// "Display a comment area for a specified object" => "Display a comment area for a specified object",
// "Object type the comment is associated with" => "Object type the comment is associated with",
"Tracker Item" => "트래커 항목",
"Submission" => "제출",
"Blog Post" => "블로그 포스트",
"The current wiki page to which you have added the plugin" => "플러그인을 추가한 현재 위키 페이지",
"Dynamic Content" => "다이나믹 컨텐츠",
"Display content from dynamic content repository" => "유동적 컨텐츠 리포지터리에서의 컨텐츠 표시",
"Content ID" => "컨텐츠 ID",
"Dynamic content ID. The value can be obtained in the listing" => "유동 컨텐츠 ID. 이 값은 목록에서 구할 수 있음",
"Content Label" => "컨텐츠 레이블",
"Label of the dynamic content to display" => "표시할 유동적 컨텐츠의 레이블",
"Contributions Dashboard" => "기여내역 대시보드",
// "List users' contributions to a page" => "List users' contributions to a page",
"Notice" => "주의",
"Default Beginning Date" => "기본 시작 날짜",
"Default Ending Date" => "기본 종료 날짜",
"Dashboard Types" => "대시보드 유형",
// "The types of charts that will be rendered, separated by commas" => "The types of charts that will be rendered, separated by commas",
"Update" => "갱신",
"Convene" => "소집",
// "Suggest meeting dates and times and vote to select one" => "Suggest meeting dates and times and vote to select one",
"Convene data generated from user input" => "사용자 입력으로부터 생성된 데이터 소집",
// "Title for the event" => "Title for the event",
"Calendar ID" => "달력 ID",
"ID number of the site calendar in which to store the date for the events with the most votes" => "최대 투표를 받은 이벤트에 대한 날짜를 저장할 사이트 달력에 대한 ID 번호",
// "Minimum Votes" => "Minimum Votes",
// "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it" => "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it",
// "Date-Time Format" => "Date-Time Format",
"Display date and time in short or long format, according to the site wide setting" => "날짜와 시간을 약식 혹은 긴 형식으로 표시, 사이트 전역 설정을 따름",
"Short" => "짧음",
"Long" => "장기",
// "Observe Admin Permissions" => "Observe Admin Permissions",
"Show user profile pictures" => "사용자 아바타 표시",
"Delete Date" => "날짜 삭제",
// "UTC date time: %0" => "UTC date time: %0",
"Add Date" => "날짜 추가",
// "Not OK" => "Not OK",
"Unconfirmed" => "확인되지 않음",
"Add User" => "사용자 추가",
"Not ok" => "양호하지 않음",
"Ok" => "확인",
// "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users" => "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users",
// "Show user's profile pictures next to their names" => "Show user's profile pictures next to their names",
"Edit User/Save changes" => "사용자/저장 변경내역 편집",
"Delete User" => "사용자 삭제",
// "Username.." => "Username..",
"Selected Date" => "선택된 날짜",
"Add as Calendar Event" => "달력 이벤트로 추가",
// "This page is being edited by another user. Please reload the page and try again later" => "This page is being edited by another user. Please reload the page and try again later",
// "Delete this date" => "Delete this date",
// "Are you sure you want to remove this user's votes" => "Are you sure you want to remove this user's votes",
// "There is no undo" => "There is no undo",
"Cookie" => "쿠키",
// "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)" => "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)",
// "Display content based on whether cookie consent has been granted by the user" => "Display content based on whether cookie consent has been granted by the user",
"Wiki syntax containing the content that can be hidden or shown" => "보이거나 감출 수 있는 컨텐츠를 포함하는 위키 문법",
"No Cookie Message" => "쿠키 메시지 없음",
"Message displayed if user has not consented to accepting cookies" => "사용자가 쿠키를 허용에 동의하지 않을 경우 표시될 메시지",
"Containing Element" => "포함하는 요소",
// "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container" => "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container",
"Element CSS Class" => "요소 CSS 클래스",
"CSS class for above" => "위에 대한 CSS 클래스",
// "No Consent CSS Class" => "No Consent CSS Class",
// "CSS class for no consent message. Default: %0" => "CSS class for no consent message. Default: %0",
"Insert copyright notices" => "저작권 알림을 삽입",
// "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1" => "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1",
"Countdown" => "카운트다운",
// "Display the time until or after a date and time" => "Display the time until or after a date and time",
"Text to append to the countdown" => "카운트다운에 추가될 텍스트",
"Target date and time. Multiple formats accepted" => "목표 날짜와 시간. 다양한 서식 허용됨",
"Items to Show" => "표시할 항목",
// "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
"Years" => "연도",
"Years, Months" => "연, 월",
"Years, Months, Days" => "연, 월, 일",
"Years, Months, Days, Hours" => "연, 월, 일, 시",
"Years, Months, Days, Hours, Minutes" => "연, 월, 일, 시, 분",
"Years, Months, Days, Hours, Minutes & Seconds" => "연, 월, 일, 시, 분 및 초",
"Months" => "달",
"Months, Days" => "월, 일",
"Months, Days, Hours" => "월, 일, 시",
"Months, Days, Hours, Minutes" => "월, 일, 시, 분",
"Months, Days, Hours, Minutes & Seconds" => "월, 일, 시, 분 & 초",
"Days" => "일",
"Days & Hours" => "날과 시간",
"Days, Hours & Minutes" => "날, 시간 & 분",
"Days, Hours, Minutes & Seconds" => "날, 시간, 분 & 초",
"Hours" => "시간",
"Hours & Minutes" => "시와 분",
"Hours, Minutes & Seconds" => "시, 분 & 초",
"Minutes" => "분",
"Minutes & Seconds" => "분과 초",
"Seconds" => "초",
"Calendar Days" => "달력 날짜",
// "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default" => "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default",
"Handle Past Events" => "과거 이벤트 처리",
// "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text" => "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text",
"Text" => "텍스트",
// "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text" => "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text",
"default, silent, custom: before event|after event|after event when time not shown" => "기본, 무음, 사용자 지정: 이벤트 전|이벤트 후|시간이 보이지 않았을 때 이벤트 후",
"Thousands separator" => "천단위 구분자",
// "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator",
"Comma" => "쉼표",
"Period" => "기간",
"Space" => "스페이스",
"Countdown: Missing \"enddate\" parameter for plugin" => "카운트다운: 플러그인에 대하여 \"최종날자\" (enddate) 매개 변수 없음",
"will happen in less than a year" => "연 내에 발생함",
"will happen in less than a month" => "월 내에 발생함",
"will happen in less than a day" => "하루 내에 발생함",
// "will happen in less than an hour" => "will happen in less than an hour",
"will happen in less than a minute" => "일 분 내에 발생함",
"is happening this second" => "은 지금 이 순간 발생하고 있습니다",
"happened in the last year" => "마지막 년도에 발생함",
"happened in the last month" => "마지막 달에 발생함",
"happened in the last day" => "마지막날에 발생함",
"happened in the last hour" => "마지막 시간에 발생함",
"happened in the last minute" => "마지막 분에 발생함",
"until" => "다음까지",
"since" => "이후",
"is over" => "은 종료되었습니다",
"Custom Search" => "사용자 지정 검색",
// "Create a custom search form for searching or listing items on the site" => "Create a custom search form for searching or listing items on the site",
"LIST plugin configuration information" => "LIST 플러그인 구성 정보",
"Template wiki page" => "템플릿 위키 페이지",
"Wiki page where search user interface template is found" => "검색 사용자 인터페이스 템플릿이 발견되는 위키 페이지",
// "Template file" => "Template file",
// "Smarty template (.tpl) file where search user interface template is found" => "Smarty template (.tpl) file where search user interface template is found",
// "Search Id" => "Search Id",
// "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users",
// "Search Delay" => "Search Delay",
// "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)" => "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)",
// "Fade DIV Id" => "Fade DIV Id",
// "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner",
// "Recall Last Search" => "Recall Last Search",
// "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving" => "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving",
// "Custom JavaScript Page" => "Custom JavaScript Page",
"The wiki page on which custom JavaScript is to be executed on return of Ajax results" => "AJAX 결과의 반환 시 사용자 지정 자바스크립트가 실행될 위키 페이지",
"Destination Div" => "대상 Div",
"The id of an existing div to contain the search results" => "검색 결과를 포함할 기존의 div 의 ID",
"Search On Load" => "로드 상 검색",
"Execute the search when the page loads (default: Yes)" => "페이지를 로드할 때 검색 실행 (기본: 예)",
// "Require Input" => "Require Input",
// "Require first input field to be filled for search to trigger" => "Require first input field to be filled for search to trigger",
// "Force Sort" => "Force Sort",
// "Force the use of specified sort mode in place of search relevance even when there is a text search query" => "Force the use of specified sort mode in place of search relevance even when there is a text search query",
// "Trim Linefeeds" => "Trim Linefeeds",
// "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs" => "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs",
// "Searchable Only Results" => "Searchable Only Results",
// "Only include results marked as searchable in the index" => "Only include results marked as searchable in the index",
// "Use custom search JavaScript file" => "Use custom search JavaScript file",
// "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size" => "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size",
// "JavaScript disabled" => "JavaScript disabled",
// "JavaScript is required for this search feature" => "JavaScript is required for this search feature",
"Template is not specified" => "템플릿이 지정되지 않음",
"Template page not found" => "템플릿 페이지 발견되지 않음",
// "Please enter a search query" => "Please enter a search query",
// "_from parameter not valid: \"%0\"" => "_from parameter not valid: \"%0\"",
// "_to parameter not valid: \"%0\"" => "_to parameter not valid: \"%0\"",
// "_gap parameter not valid: \"%0\"" => "_gap parameter not valid: \"%0\"",
"_group is needed to be set if _style is checkbox or radio" => "만약 _style 이 체크상자 혹은 라디오라면 _group 이 설정되어야 함",
// "Cypht webmail" => "Cypht webmail",
// "Embed Cypht webmail and news reader" => "Embed Cypht webmail and news reader",
// "Mailbox name" => "Mailbox name",
"IMAP server" => "IMAP 서버",
// "IMAP port" => "IMAP port",
// "IMAP use TLS" => "IMAP use TLS",
// "Use secure connection to IMAP server" => "Use secure connection to IMAP server",
// "IMAP username" => "IMAP username",
// "Account mailbox username" => "Account mailbox username",
// "IMAP password" => "IMAP password",
// "Account mailbox password" => "Account mailbox password",
// "SMTP connection name" => "SMTP connection name",
// "SMTP port" => "SMTP port",
// "SMTP use TLS" => "SMTP use TLS",
// "Use secure TLS/SSL connection to SMTP server" => "Use secure TLS/SSL connection to SMTP server",
// "SMTP no authentication" => "SMTP no authentication",
// "Disable SMTP authentication if your server does not support it" => "Disable SMTP authentication if your server does not support it",
// "Use global settings" => "Use global settings",
// "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages" => "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages",
// "Groupmail use" => "Groupmail use",
// "Share this mailbox for Groupmail usage or keep it private" => "Share this mailbox for Groupmail usage or keep it private",
"GroupMail: Group (e.g. \"Help Team\")" => "그룹메일: 그룹 (예: \"지원 팀\")",
"GroupMail: Tracker ID (to store GroupMail activity)" => "그룹메일: 트래커 Id (그룹메일 활동을 저장)",
"From Field ID" => "발신 필드 ID",
"GroupMail: From Field (Id of field in tracker to store email From header)" => "그룹메일: 발신인 필드 (이메일 발신인 헤더를 저장할 트래커 내부의 필드의 Id)",
"Subject Field ID" => "제목 필드 ID",
"GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "그룹메일: 제목 필드 (이메일 제목 헤더를 저장할 트래커 내부의 필드의 Id)",
"Message Field ID" => "메시지 필드 ID",
"GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "그룹 메일: 메시지 필드 (이메일 메시지 식별자를 저장할 트래커 내부의 필드의 Id)",
"Content Field ID" => "컨텐츠 필드 ID",
"GroupMail: Content Field (Id of field in tracker to store email message body content)" => "그룹메일: 컨텐츠 필드 (이메일 메시지 본문 컨텐츠를 저장할 트래커 내부의 필드의 Id)",
"Account Field ID" => "계정 필드 ID",
"GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "그룹메일: 계정 필드 (웹메일 계정 이름을 저장할 트래커 내부의 필드의 Id)",
"DateTime Field Id" => "날짜시간 필드 ID",
"GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "그룹메일: 날짜 시간 필드 (이메일 발송 타임스탬프를 저장할 트래커 내부의 필드의 Id)",
"Operator Field ID" => "운영자 필드 ID",
"GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "그룹 메일: 운영자 필드 (운영자명 (사용자명)을 저장할 트래커 내부의 필드의 Id)",
// "UI display presentational purposes only" => "UI display presentational purposes only",
// "E.g. imap.your-domain.com" => "E.g. imap.your-domain.com",
// "Default is 993" => "Default is 993",
// "E.g. smtp.your-domain.com" => "E.g. smtp.your-domain.com",
// "Default is 587" => "Default is 587",
// "Only one cypht plugin per page can be used" => "Only one cypht plugin per page can be used",
"Data Channel" => "데이터 채널",
"Display a form to access data channels" => "데이터 채널을 접근할 서식 표시",
// "List of fields to display. One field per line. Comma delimited: %0" => "List of fields to display. One field per line. Comma delimited: %0",
// "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag" => "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag",
// "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel" => "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel",
// "To use fixed hidden preset\n\t\t\tvalues use %0" => "To use fixed hidden preset\n\t\t\tvalues use %0",
"Channel Name" => "채널 이름",
"Name of the channel as registered by the administrator" => "관리자에 의하여 등록된 채널의 이름",
"Return URL" => "URL 반환",
// "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object" => "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object",
// "Return URL on error" => "Return URL on error",
// "URL to go to after data channel has run and failed. If not specified, use the success URL" => "URL to go to after data channel has run and failed. If not specified, use the success URL",
"Do not use returnURI but instead return true quietly" => "returnURI 를 사용하지 않고 대신 조용히 true를 반환합니다",
// "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context" => "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context",
"Button Label" => "버튼 라벨",
"Label for the submit button. Default: \"Go\"" => "제출 버튼에 대한 레이블. 기본: \"이동\"",
"CSS class for this form" => "이 서식에 대한 CSS 클래스",
"Template" => "템플릿",
// "Template to be used to render the form, instead of the default template" => "Template to be used to render the form, instead of the default template",
"Empty Caches" => "캐시 비우기",
"Which caches to empty. Default \"Clear all Tiki caches\"" => "비워버릴 캐시. 기본 \"모든 티키 캐시 비우기\"",
"Clear all Tiki caches" => "모든 티키 캐시 삭제",
"All user prefs sessions" => "모든 사용자 prefs 세션",
"Price to execute the data channel (%0)" => "데이터채널을 수행할 가격 (%0)",
"Payment Label" => "지불 레이블",
"Debug" => "디버그",
// "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)",
"Multiple Values" => "다중 변수",
// "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)",
"Data channel" => "데이터채널",
"DB Report" => "DB 보고서",
// "Query an ADOdb database and display results (does not work with PDO)" => "Query an ADOdb database and display results (does not work with PDO)",
"report definition" => "보고 정의",
"Full DSN" => "전체 DSN",
// "A full DSN (Data Source Name) connection string. Example: " => "A full DSN (Data Source Name) connection string. Example: ",
"Wiki DSN Name" => "위키 DSN 이름",
"The name of a DSN connection defined by the Wiki administrator" => "위키 관리자에 의하여 정의된 DNS 연결의 이름",
"Wiki Syntax" => "위키 문법",
"Parse wiki syntax within the report (not parsed by default)" => "보고서 내부의 위키 문법을 구문분석 (기본으로 구문분석 되지 않음)",
"Display the parsed report definition (not displayed by default)" => "구문분석된 보고서 정의 표기 (기본으로 표기되지 않음)",
"Missing db or dsn parameter" => "DB 혹은 DSN 매개 변수 없음",
"AdoDb not found" => "AdoDB 발견되지 않음",
"No DSN connection string found" => "발견된 DSN  연결 문자열 없음",
"Run a database report" => "데이터베이스 보고서 실행",
// "Diagram" => "Diagram",
// "Display mxGraph/Draw.io diagrams" => "Display mxGraph/Draw.io diagrams",
// "fileId" => "fileId",
// "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options" => "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options",
"page" => "페이지",
// "Page of the diagram that should be displayed" => "Page of the diagram that should be displayed",
// "annotate" => "annotate",
// "Id of the file in the file gallery. A image file to include in the diagram" => "Id of the file in the file gallery. A image file to include in the diagram",
// "Image alignment when exporting a PDF" => "Image alignment when exporting a PDF",
// "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"" => "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"",
// "Previous xorti/mxgraph-editor package has been deprecated.<br/>" => "Previous xorti/mxgraph-editor package has been deprecated.<br/>",
// "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator" => "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator",
// "Create New Diagram" => "Create New Diagram",
// "Page (inline)" => "Page (inline)",
// "Tiki wasn't able to find the file with id %0" => "Tiki wasn't able to find the file with id %0",
// "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure" => "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure",
// " in " => " in ",
// "Selected file to annotate must be an image" => "Selected file to annotate must be an image",
// "Can not retrieve size from file %0" => "Can not retrieve size from file %0",
// "Create a custom popup dialog box" => "Create a custom popup dialog box",
"Button labels separated by commas" => "쉼표로 구분 된 버튼 라벨",
// "Button Actions" => "Button Actions",
"JavaScript to perform on first button click" => "첫번째 버튼 클릭 시 수행될 JS",
// "Dialog Width" => "Dialog Width",
"In pixels" => "픽셀단위",
// "HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)" => "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)",
// "Show Animation" => "Show Animation",
// "Hide Animation" => "Hide Animation",
// "Auto Open" => "Auto Open",
// "Open dialog automatically" => "Open dialog automatically",
"Modal" => "모달",
// "Use modal form" => "Use modal form",
"Wiki page to use as dialog body" => "대화 본문으로 사용될 위키 페이지",
"Open Action" => "동작 열기",
"JavaScript to execute when dialog opens" => "대화상자가 열릴 때 실행할 JS",
// "Div" => "Div",
"Define and format sections of a page or text" => "페이지 혹은 텍스트의 부분을 정의하고 서식적용",
// "Indicate the type of HTML tag to use (default is %0)" => "Indicate the type of HTML tag to use (default is %0)",
"Span" => "기간",
// "Pre" => "Pre",
"Teletype" => "텔레타이프",
"Paragraph" => "문단",
"Block quote" => "블록 인용",
// "H1" => "H1",
// "H2" => "H2",
// "H3" => "H3",
// "H4" => "H4",
// "H5" => "H5",
// "H6" => "H6",
// "Valid CSS color name or hex code" => "Valid CSS color name or hex code",
"Box width" => "상자 너비",
"In pixels or percentage. Default is original size" => "픽셀단위 혹은 백분율. 기본은 원본 크기입니다.",
"Aligns the text within the element" => "요소 내부의 텍스트 맞춤",
"Justify" => "맞춤",
// "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set" => "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set",
"Content cannot wrap around this object because of what the parameter is set to" => "이 매개변수가 다음 값으로 설정되어있는 경우, 항목은 측면(들)에 감싸기가 허용되지 않습니다",
"Apply custom CSS class to the div" => "사용자 지정 CSS 클래스를 div 에 적용",
"Title attribute" => "제목 속성",
"Title for the div, usually displayed as a tooltip" => "div에 대한 제목, 일반적으로 툴팁으로서 표시됨",
// "onClick attribute" => "onClick attribute",
// "Enter on onclick event" => "Enter on onclick event",
// "Style attribute" => "Style attribute",
// "Enter CSS styling tags for the div type used" => "Enter CSS styling tags for the div type used",
// "Data attributes" => "Data attributes",
// "URL encoded list or attributes and values" => "URL encoded list or attributes and values",
// "ARIA attributes" => "ARIA attributes",
// "URL encoded list or attributes and values, e.g. label, expanded etc" => "URL encoded list or attributes and values, e.g. label, expanded etc",
// "Role attribute" => "Role attribute",
// "e.g. button, heading, search etc" => "e.g. button, heading, search etc",
"Sets the id attribute of the div, as defined by HTML" => "HTML에 의해 정의된 대로 div의 id 속성을 설정함",
"Definition List" => "정의 목록",
"Create a definition list" => "정의 목록 만들기",
// "One entry per line. Each line is in %0Term: Definition%1 format" => "One entry per line. Each line is in %0Term: Definition%1 format",
"List Type" => "종류 나열",
// "Type of definition list (left-aligned or horizontal)" => "Type of definition list (left-aligned or horizontal)",
// "Standard (left-aligned)" => "Standard (left-aligned)",
// "Horizontal (inline) " => "Horizontal (inline) ",
"Draw" => "그리기",
// "Embed a drawing in a page" => "Embed a drawing in a page",
"Drawing ID" => "그림 ID",
"Internal ID of the file ID" => "필드 ID의 내부 ID",
// "Width in pixels or percentage. Default value is page width, for example, %0 or %1" => "Width in pixels or percentage. Default value is page width, for example, %0 or %1",
"Height in pixels or percentage. Default value is complete drawing height" => "픽셀단위 혹은 백분율의 높이. 기본값은 완전한 그림 높이.",
"Force Display Archive" => "보관을 강제 표시",
// "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision",
"Draw New SVG Image" => "새 SVG 그림 그리기",
"Edit SVG Image" => "SVG 그림 편집",
// "List of dynamic variables" => "List of dynamic variables",
// "Show dynamic variables and their values" => "Show dynamic variables and their values",
"Layout" => "레이아웃",
"Set to table to show results in a table (not shown in a table by default)" => "표 안의 결과를 표시할 표로 설정 (기본으로 표 안에 표시되지 않음)",
"String to use between elements of the list if table layout is not used" => "표형식 레이아웃이 사용되지 않을 경우 목록의 요소들 간에 사용할 문자열",
// "Parsed result" => "Parsed result",
"Syntax" => "구문",
// "Value per database" => "Value per database",
"Equation" => "등식",
"Render an equation written in LaTeX syntax as an image" => "LaTeX 문법으로 쓰여진 등식을 그림으로 렌더",
"equation" => "등식",
// "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator" => "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator",
// "Display events from calendars" => "Display events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)" => "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)",
"Maximum Days" => "최대 일 수",
// "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0" => "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0",
"Maximum Events" => "최대 이벤트",
// "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)" => "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)",
"Show Time" => "시간 표시",
"Show the time along with the date (shown by default)" => "날짜와 함께 시간 표시 (기본으로 표시됨)",
"Show the description of the event (shown by default)" => "이벤트의 설명 표시 (기본으로 표시됨)",
// "Time Span" => "Time Span",
// "Specify the time span" => "Specify the time span",
"Past" => "과거",
// "Future" => "Future",
// "Activate pagination when Events listing are long. Default is %0" => "Activate pagination when Events listing are long. Default is %0",
"Exercise" => "연습",
// "PluginExercise" => "PluginExercise",
// "Create an exercise/test with questions and grade" => "Create an exercise/test with questions and grade",
"Answer" => "답",
"Used inline to specify the right answer to the question and propose an input field" => "질문에 정답을 지정하고 입력 필드를 제안하기 위하여 사용된 인라인",
"Incorrect" => "틀림",
// "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")" => "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")",
"Check your score" => "점수를 확인",
"You scored %0 out of %1" => "%1 점 중 %0 점을 기록했습니다",
"Good" => "좋음",
"Extend Cart Inventory Hold" => "카트 재고 연장 보류",
// "PluginExtendCartHold" => "PluginExtendCartHold",
// "Extend the time that items are held in a shopping cart" => "Extend the time that items are held in a shopping cart",
"Create a link that shows/hides initially hidden content" => "초기에 숨겨진 내용을 표시/숨김 링크 만들기",
// "Content of the hideable zone (in Wiki syntax)" => "Content of the hideable zone (in Wiki syntax)",
"Label for link that shows and hides the content when clicked" => "클릭되었을 때 컨텐츠 표시 및 숨김 링크에 대한 레이블",
"Unspecified label" => "지정되지 않은 라벨",
"Arrow icon showing that content can be hidden or shown" => "컨텐츠가 숨겨지거나 표시될 수 있다는 것을 나타내는 화살표 아이콘",
"Show Speed" => "속도 표시",
// "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or %0 or %1" => "Integer greater than 0 and less than or equal to 1000, or %0 or %1",
"Hide Speed" => "숨기기 속도",
// "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Use Bootstrap" => "Use Bootstrap",
// "Use Bootstrap collapsible box" => "Use Bootstrap collapsible box",
// "Apply custom CSS class" => "Apply custom CSS class",
"Fancy List" => "팬시 목록",
// "Create a formatted numbered list" => "Create a formatted numbered list",
"One item per line starting with anything followed by \")\"" => "한 줄 당 한 항목으로써 아무것으로 시작되고 끝에 \")\" 가 옵니다",
"Use Div" => "Div 사용",
"Use the HTML div tag instead of the HTML ordered list tag (ol)" => "목록에 대한 HTML 태그 대신 HTML 태그 div 사용",
"CSS class for the fancylist" => "팬시 리스트에 대한 CSS 클래스",
"Heading Row" => "제목 열",
// "Header rows of the table. Use %0 to separate multiple rows" => "Header rows of the table. Use %0 to separate multiple rows",
"Heading CSS Class" => "제목 CSS 클래스",
"CSS class to apply to the heading row" => "제목 행에 적용할 CSS 클래스",
"Header Horizontal Alignment" => "헤더 수평 줄맞춤",
// "Horizontal alignments for header cells, separated by %0. Choices: %1" => "Horizontal alignments for header cells, separated by %0. Choices: %1",
"Header Vertical Alignment" => "헤더 수직 정렬",
// "Vertical alignments for header cells, separated by %0\". Choices: %1" => "Vertical alignments for header cells, separated by %0\". Choices: %1",
"Column Widths" => "열 너비",
// "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0" => "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0",
"Cell Horizontal Align" => "셀 가로 맞춤",
// "Table body column horizontal alignments, separated by %0. Choices: %1" => "Table body column horizontal alignments, separated by %0. Choices: %1",
"Cell Vertical Align" => "셀 세로 맞춤",
// "Table body column vertical alignments, separated by %0. Choices: %1" => "Table body column vertical alignments, separated by %0. Choices: %1",
"Fancy Table" => "팬시 테이블",
// "Create a formatted table that can be filtered and sorted" => "Create a formatted table that can be filtered and sorted",
// "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases" => "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases",
// "The jQuery Sortable Tables feature must be activated for the sort feature to work" => "The jQuery Sortable Tables feature must be activated for the sort feature to work",
// "JavaScript must be enabled for the sort feature to work" => "JavaScript must be enabled for the sort feature to work",
// "Unable to load the jQuery Sortable Tables feature" => "Unable to load the jQuery Sortable Tables feature",
// "Display a button for a user to click to make an object a favorite" => "Display a button for a user to click to make an object a favorite",
// "Indicate type of object" => "Indicate type of object",
// "Enter the ID of the object" => "Enter the ID of the object",
// "Link to a file that's attached or in a gallery or archive" => "Link to a file that's attached or in a gallery or archive",
"Label for the link to the file (ignored if the file is a wiki attachment)" => "파일로의 링크에 대한 레이블 (파일이 위키 첨부파일인 경우 무시됨)",
"Indicate whether the file is in a file gallery or is a wiki page attachment" => "파일이 파일갤러리 내부에 있는지 혹은 위키 페이지 첨부파일인지 여부를 표시합니다",
// "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used" => "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used",
"Custom Description" => "사용자 지정 설명",
"Custom text that will be used for the link instead of the file name or file description" => "파일명 혹은 파일 설명 대신에 사용될 링크에 대한 사용자 지정 텍스트",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty",
"Attachment Description" => "첨부파일 설명",
"Show the attachment description as the link label instead of the attachment file name" => "첨부파일명 대신 링크 레이블로써 첨부파일 설명을 표시",
"Indicates that this attachment is an image, and should be displayed inline using the img tag" => "이 첨부파일이 그림이라는 것을 지정함 그리고 img 태그를 사용하여 인라인으로 표시되어야 함",
"File ID" => "파일 ID",
"File ID of a file in a file gallery or an archive" => "파일 갤러리 혹은 보관 내부의 파일의 파일 ID",
"Example value" => "예제 값",
"Date" => "일자",
// "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1" => "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1",
"Show Icon" => "아이콘 보기",
"Show an icon version of the file or file type with the link to the file" => "파일의 아이콘 버전 혹은 파일로의 링크와 함께 파일 유형 표시",
// "Browser Display" => "Browser Display",
// "Display in different browser window or tab instead of downloading" => "Display in different browser window or tab instead of downloading",
"File Gallery File/Archive" => "파일 갤러리 파일/보관",
"Wiki Page Attachment" => "위키 페이지 첨부",
"The date has not been set" => "날짜가 설정되지 않았습니다",
"Incorrect date format" => "틀린 날짜 형식",
"No such file" => "그런 파일 없음",
"Wiki attachments are disabled" => "위키 첨부 기능 비활성화됨",
"List files by ID, gallery or category, or show a slideshow of image files." => "파일을 ID, 갤러리 혹은 범주별로 나열 혹은 그림 파일의 슬라이드쇼 보기",
// "Title for the file listing, or the link text when %0" => "Title for the file listing, or the link text when %0",
"File Galleries IDs" => "파일 갤러리 ID",
// "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)" => "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)",
// "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)" => "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon",
// "Valid category IDs separated by colons" => "Valid category IDs separated by colons",
// "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty" => "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty",
// "Valid file IDs separated by colons" => "Valid file IDs separated by colons",
// "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0" => "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0",
// "Last modified Ascending" => "Last modified Ascending",
// "Last modified Descending" => "Last modified Descending",
"File Name Ascending" => "파일명 오름차순",
"File Name Descending" => "파일명 내림차순",
"File Size Ascending" => "파일 크기 오름차순",
"File Size Descending" => "파일 크기 내림차순",
"File Type Ascending" => "파일 유형 오름차순",
"File Type Descending" => "파일 유형 내림차순",
"Last Download Ascending" => "마지막 다운로드 오름차순",
"Last Download Descending" => "마지막 다운로드 내림차순",
"Show Action" => "작업 표시",
// "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)" => "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)",
"Show Find" => "찾기 보기",
"Show a search box above the list (not shown by default)" => "목록 위에 검색 상자 표시 (기본으로 표시되지 않음)",
// "Show Find is recursive" => "Show Find is recursive",
// "The search box digs recursively in sub-galleries (by default)" => "The search box digs recursively in sub-galleries (by default)",
"Show Title" => "제목 표시",
// "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used",
"Show ID" => "ID 보기",
"Show the ID number of each file (shown by default)" => "각 파일의 ID 번호 표시 (기본으로 표시됨)",
"Show the file-type icon for each file" => "각 파일에 대하여 파일 유형을 설명하는 아이콘 표시",
"Show Name" => "이름 표시",
// "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show",
"Show Filename" => "파일명 보기",
// "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show",
"Show Size" => "크기 표시",
"Show the size of each file in kilobytes (shown by default except in slide show)" => "킬로바이트로 각 파일의 크기 표시 (슬라이드쇼를 제외하고 기본으로 표시됨)",
// "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show",
"Show Creation Date" => "만든 날짜 표시",
"Show the date each file was created (not shown by default)" => "각 파일이 만들어진 날짜 표시 (기본으로 표시 안됨)",
"Show Last Modification Date" => "최종 수정 날짜 보기",
"Show the date each file was last modified (shown by default)" => "각 파일이 최종 수정된 날짜 표시 (기본으로 표시됨)",
// "Show Last Modification Time as well as Date" => "Show Last Modification Time as well as Date",
// "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)" => "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)",
"Show Hits" => "방문수 보기",
"Show the number of hits each file has received (not shown by default)" => "각 파일에 대한 방문 수 표시 (기본으로 표시 안됨)",
"Show Locked By" => "잠근이 표시",
"For locked files, show the username of the user who locked it (not shown by default)" => "잠겨진 파일들에 대하여, 잠근 사용자의 사용자명을 표시 (기본으로 표시 안됨)",
"Show the username of the user who is the author of the file (not shown by default)" => "파일의 저장인 사용자의 사용자명 표시 (기본으로 표시되지 않음)",
"Show Creator" => "만든이 보기",
"Show the username of the user who is the creator of the file (not shown by default)" => "파일의 만든이인 사용자의 사용자명 표시 (기본으로 표시되지 않음)",
"Show Parent Gallery Name" => "부모 갤러리명 표시",
"Show the name of the parent gallery" => "부모 갤러리의 이름 표시",
"Show File Count" => "파일 수 보기",
// "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)",
"Show Source" => "소스 표시",
"Show the source (shown by default)" => "소스 표시 (기본으로 표시됨)",
"Show Slideshow" => "슬라이드쇼 표시",
"Show a link that produces a popup slideshow when clicked (not set by default)" => "클릭되었을 때 팝업 슬라이드쇼를 만들 링크 보기 (기본으로 설정되지 않음)",
"Slideshow Width" => "슬라이드쇼 너비",
"Set width of slideshow popup" => "슬라이드쇼 팝업의 넓이 설정",
"Slideshow Height" => "슬라이드쇼 높이",
"Set height of slideshow popup" => "슬라이드쇼 팝업의 높이 설정",
"Show Comments" => "댓글 표시",
"Show comments for each file (not shown by default)" => "각 파일에 대한 댓글 표시 (기본으로 표시 안됨)",
"Show Last Editor" => "최종 편집자 보기",
"Show the username of the user who last modified the file (shown by default)" => "파일의 최종 수정자인 사용자의 사용자명 표시 (기본으로 표시됨)",
"Show image thumbnail" => "그림 thumb 보기",
"Show Image thumb" => "그림 thumb 보기",
"Show only files created by this user" => "이 사용자가 만든 파일들만 표시",
"Show Upload" => "업로드 표시",
"Show a simple form to upload files to the gallery (not shown by default)" => "갤러리로 간단한 업로드 양식 표시 (기본으로 표시 안됨)",
"Number of rows (default: -1 = all)" => "행의 수 (기본: -1 = 전부)",
"Recursive" => "재귀적",
"With subgalleries" => "하위 갤러리와 함께",
// "Fitnesse Test Suite" => "Fitnesse Test Suite",
// "Create test suites for applications built using Tiki" => "Create test suites for applications built using Tiki",
// "Test execution scenario" => "Test execution scenario",
// "Fixture not found: %0" => "Fixture not found: %0",
// "Tracker Math for [%0|%1]" => "Tracker Math for [%0|%1]",
// "Tracker Field not found: %0" => "Tracker Field not found: %0",
// "Field is not a math field: %0" => "Field is not a math field: %0",
// "Tracker Data for [%0|%1]" => "Tracker Data for [%0|%1]",
// "Table must contain at least one field named itemId" => "Table must contain at least one field named itemId",
// "%0 (expect: %1)" => "%0 (expect: %1)",
"Flash Video" => "플래시 동영상",
"Embed a video or audio file" => "동영상 혹은 음성 파일 임베드",
"Flash Type" => "플래시 유형",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo",
// "Blip.tv" => "Blip.tv",
"File Gallery Podcast" => "파일 갤러리 팟캐스트",
"Movie URL" => "동영상 URL",
"Youtube" => "유튜브",
// "URL to the movie to include, for example, %0" => "URL to the movie to include, for example, %0",
"File Gallery Podcast ID" => "파일 갤러리 팟캐스트 ID",
"ID of a file from a podcast gallery - will work only with podcast gallery" => "팟캐스트 갤러리로부터의 파일의 ID - 팟캐스트 갤러리로만 작동함",
"YouTube URL" => "유튜브 URL",
"Complete URL to the YouTube video" => "유튜브 동영상으로의 URL 전체",
// "Vimeo URL" => "Vimeo URL",
"Complete URL to the Vimeo video" => "Vimeo 동영상으로의 URL 전체",
// "Width of movie in pixels (default is %0)" => "Width of movie in pixels (default is %0)",
// "Height of movie in pixels (default is %0)" => "Height of movie in pixels (default is %0)",
"Quality" => "질",
// "Flash video quality. Default value: %0" => "Flash video quality. Default value: %0",
"Medium" => "중간",
"Alternative image URL" => "대체 그림 URL",
"Image to display if Flash is not available" => "플래시가 사용불가능한 경우 표시할 그림",
"Invalid URL" => "유효하지 않은 URL",
"Missing parameter movie to the plugin flash" => "플래시 플러그인으로의 동영상 매개 변수 없음",
// "Fluid Grid" => "Fluid Grid",
// "Arrange content into rows and columns using a Bootstrap fluid grid" => "Arrange content into rows and columns using a Bootstrap fluid grid",
// "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Join Columns" => "열 병합",
// "Merge empty cells into the cell to their left" => "Merge empty cells into the cell to their left",
// "Device size" => "Device size",
// "Specify the device size below which the cells will be stacked vertically" => "Specify the device size below which the cells will be stacked vertically",
"Small" => "작음",
"Large" => "큼",
// "Extra Large" => "Extra Large",
"Column Sizes" => "열 크기",
// "Specify all column widths in units which add up to 12" => "Specify all column widths in units which add up to 12",
"First" => "첫번째",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "열",
"Custom Class" => "사용자 지정 클래스",
"Add a class to customize the design" => "디자인을 사용자 지정하기 위한 클래스 추가",
"Font" => "폰트",
// "Format the font type and size of text" => "Format the font type and size of text",
"Content" => "내용",
"Font Family" => "폰트 패밀리",
"Select the font family to display the content" => "컨텐츠를 표시할 폰트 패밀리 선택",
"Font Size" => "폰트 크기",
// "Define the size of the font in pixels (enter %0 to get a font of 12px)" => "Define the size of the font in pixels (enter %0 to get a font of 12px)",
"Footnote" => "각주",
"Create automatically numbered footnotes (together with PluginFootnoteArea)" => "번호 매겨진 각주를 자동 만들기 (PluginFootnoteArea 와 함께)",
"The footnote" => "각주",
"Tag" => "태그",
// "Tag footnote with unique identifier" => "Tag footnote with unique identifier",
// "One word made of alphanumeric characters" => "One word made of alphanumeric characters",
// "Same as Tag" => "Same as Tag",
// "Tag to existing footnote by its Tag" => "Tag to existing footnote by its Tag",
// "Same as" => "Same as",
// "Tag to existing footnote number" => "Tag to existing footnote number",
// "tag name (since 17) or footnote number" => "tag name (since 17) or footnote number",
// "Add class to footnotearea" => "Add class to footnotearea",
// "Scheme" => "Scheme",
// "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)" => "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)",
// "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)" => "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)",
// "Error: Tag not found in any previous footnote" => "Error: Tag not found in any previous footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Filter footnotearea by footnote class" => "Filter footnotearea by footnote class",
// "SameAs Style" => "SameAs Style",
// "Numbering style for sameas referencing" => "Numbering style for sameas referencing",
// "Valid Tiki ((Number Style))" => "Valid Tiki ((Number Style))",
"Tagged" => "프래태그 추가됨",
"List similarly tagged objects" => "유사하게 태그된 개체 나열",
"Tags to find similar to" => "유사한 것을 발견할 태그",
"Leave blank to use the object's own tags" => "개체 자체의 태그를 사용하려면 빈 칸으로 두십시오",
"Type of objects to extract. Set to All to find all types" => "추출할 개체의 유형. 모든 유형을 찾으려면 전체로 설정",
"Same" => "동일",
"Blog Posts" => "블로그 게시물",
// "Faqs" => "Faqs",
"Offset" => "오프셋",
"Start record" => "시작 기록",
"Default -1 (all)" => "기본 -1 (전체)",
// "Determine sort order based on various fields (Default: %0)" => "Determine sort order based on various fields (Default: %0)",
"Comments locked Ascending" => "댓글 잠겨짐 오름차순",
"Comments locked Descending" => "댓글 잠겨짐 내림차순",
"Description Ascending" => "설명 오름차순",
"Description Descending" => "설명 내림차순",
"Href Ascending" => "Href 오름차순",
"Href Descending" => "Href 내림차순",
"Object ID Ascending" => "개체 ID 오름차순",
"Object ID Descending" => "개체 ID 내림차순",
"Show objects with names or descriptions similar to the text entered here" => "여기에 입력된 것과 동일하거나 유사한 텍스트 혹은 설명으로된 개체 표시",
// "Choose whether to broaden" => "Choose whether to broaden",
// "n|y" => "n|y",
// "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags" => "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags",
"Show Titles Only" => "제목만 표시",
"Choose whether to show titles only (not shown by default)" => "제목만을 표시 여부를 선택하십시오 (기본으로 표시하지 않음)",
// "Max Image Size" => "Max Image Size",
// "Height or width in pixels. Default: %0 (no maximum)" => "Height or width in pixels. Default: %0 (no maximum)",
// "Show a 'more' link that links to the full list of tagged objects (not shown by default)" => "Show a 'more' link that links to the full list of tagged objects (not shown by default)",
"More URL" => "추가 URL",
// "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects" => "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects",
// "More label" => "More label",
// "Alternate text to display on the \"more\" link (default is \"more\")" => "Alternate text to display on the \"more\" link (default is \"more\")",
// "Friend and unfriend other users" => "Friend and unfriend other users",
// "Add or Remove Friend Button" => "Add or Remove Friend Button",
"Other User" => "다른 사용자",
"Button Text" => "버튼 텍스트",
// "The user you wish to change relations with" => "The user you wish to change relations with",
// "Button text that's displayed when friending a user" => "Button text that's displayed when friending a user",
// "Button text that's displayed when un-friending a user" => "Button text that's displayed when un-friending a user",
// "Add to Friend Network" => "Add to Friend Network",
// "Remove from Friend Network" => "Remove from Friend Network",
// "FTP" => "FTP",
"Create a button for downloading a file from an FTP server" => "FTP 서버에서 파일을 다운로드 하기 위한 버튼 만들기",
// "File name on the server" => "File name on the server",
"Server Name" => "서버명",
"Name of the server for the FTP account. Example: " => "FTP 계정이 놓여진 서버명. 예제: ",
"Username for the FTP account" => "FTP 계정을 접근하기 위하여 필요한 사용자명",
"Password for the FTP account" => "FTP 계정에 접근하기 위하여 필요한 비밀번호",
"Download Button Label" => "다운로드 버튼 라벨",
"Label for the FTP download button" => "FTP 다운로드 버튼에 대한 레이블",
"missing parameters" => "매개 변수 없음",
"Connection failed" => "연결 실패",
// "Set a Full-Width Page Title" => "Set a Full-Width Page Title",
// "Display the page title the full width of the site content container. " => "Display the page title the full width of the site content container. ",
// "PluginFullWidthTitle" => "PluginFullWidthTitle",
// "Page title" => "Page title",
// "If you need to include tpl files" => "If you need to include tpl files",
// "Icon Source" => "Icon Source",
// "Source path of the icon" => "Source path of the icon",
// "Galleriffic" => "Galleriffic",
// "Display a slideshow of images on a page using the Galleriffic script" => "Display a slideshow of images on a page using the Galleriffic script",
// "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual table field name in place of %2" => "%0 or %1 with actual table field name in place of %2",
// "Thumbs Width" => "Thumbs Width",
// "Width in pixels or percentage. (e.g. %0 or %1)" => "Width in pixels or percentage. (e.g. %0 or %1)",
// "Image Slideshow Width" => "Image Slideshow Width",
// "Width in pixels or percentage of the largest image. (e.g. %0 or %1)" => "Width in pixels or percentage of the largest image. (e.g. %0 or %1)",
// "Image Slideshow Height" => "Image Slideshow Height",
// "Height in pixels or percentage of the largest images. (e.g. %0 or %1)" => "Height in pixels or percentage of the largest images. (e.g. %0 or %1)",
"Start Slideshow" => "슬라이드쇼 시작",
"Automatically start the slideshow" => "슬라이드쇼를 자동으로 시작",
"Delay" => "지연",
"Delay in milliseconds between each transition" => "각 전이 간 밀리 초단위의 지연",
"Number of thumbnails" => "축소판 그림의 수",
"The number of thumbnails to show per page" => "페이지당 표시할 축소보기의 수",
// "Show Top Pager" => "Show Top Pager",
"Display thumbnail pager at top" => "상단에 미리보기 pager 표기",
// "Show Bottom Pager" => "Show Bottom Pager",
"Display thumbnail pager at bottom" => "하단에 미리보기 pager 표기",
"Play Slideshow" => "슬라이드쇼 재생",
"Pause Slideshow" => "슬라이드쇼 잠시 멈춤",
"Previous Photo" => "사진 미리보기",
"Next Photo" => "다음 사진",
"Prev" => "전",
// "Gantt Chart" => "Gantt Chart",
// "Create and display a gantt graphic using tracker data" => "Create and display a gantt graphic using tracker data",
"Tracker to search from" => "검색을 할 트래커",
// "Order Field" => "Order Field",
// "Permanent name of the field to use for row number order" => "Permanent name of the field to use for row number order",
// "Level Field" => "Level Field",
// "Permanent name of the field to use for row level" => "Permanent name of the field to use for row level",
// "Status Field" => "Status Field",
// "Permanent name of the field to use for row status" => "Permanent name of the field to use for row status",
// "Dependency Field" => "Dependency Field",
// "Permanent name of the field to use for row dependency" => "Permanent name of the field to use for row dependency",
// "Progress Field" => "Progress Field",
// "Permanent name of the field to use for row progress, values between 0-100" => "Permanent name of the field to use for row progress, values between 0-100",
// "Name Field" => "Name Field",
// "Permanent name of the field to use for row name" => "Permanent name of the field to use for row name",
// "Description Field" => "Description Field",
// "Permanent name of the field to use for row description" => "Permanent name of the field to use for row description",
// "Code Field" => "Code Field",
// "Permanent name of the field to use for row code" => "Permanent name of the field to use for row code",
// "Begin Date Field" => "Begin Date Field",
// "Permanent name of the field to use for event beginning" => "Permanent name of the field to use for event beginning",
// "End Date Field" => "End Date Field",
"Permanent name of the field to use for event ending" => "이벤트 종료에 대하여 사용할 필드의 고정 링크명",
// "Resources Field" => "Resources Field",
// "Permanent name of the field to use for resources ending" => "Permanent name of the field to use for resources ending",
// "Roles Field" => "Roles Field",
// "Permanent name of the field to use for roles ending" => "Permanent name of the field to use for roles ending",
// "Effort Field" => "Effort Field",
// "Permanent name of the field to use for effort ending, values in milliseconds" => "Permanent name of the field to use for effort ending, values in milliseconds",
// "Start Is Milestone" => "Start Is Milestone",
// "Flag field to start is milestone" => "Flag field to start is milestone",
// "End Is Milestone" => "End Is Milestone",
// "Flag field to end is milestone" => "Flag field to end is milestone",
// "Writable" => "Writable",
// "Flag field to write or not in tasks" => "Flag field to write or not in tasks",
// "Deletable" => "Deletable",
// "Flag field that permit to delete or not tasks" => "Flag field that permit to delete or not tasks",
// "Parent Writable" => "Parent Writable",
// "Flag field to write or not in parent tasks" => "Flag field to write or not in parent tasks",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer",
// "Tracker data source not found" => "Tracker data source not found",
// "Order tracker field parameter is mandatory" => "Order tracker field parameter is mandatory",
// "Level tracker field parameter is mandatory" => "Level tracker field parameter is mandatory",
// "Depends tracker field parameter is mandatory" => "Depends tracker field parameter is mandatory",
// "You are trying to update a tracker that is not used by this gantt chart" => "You are trying to update a tracker that is not used by this gantt chart",
// "Gantt chart updated" => "Gantt chart updated",
"Gauge" => "계기",
"Display a horizontal bar gauge" => "가로 바 계기 표시",
"description" => "설명",
"Current value to be represented by the gauge" => "계기에 의하여 표기될 현재 값",
"Maximum Value" => "최대 값",
// "Maximum possible value. Default: %0" => "Maximum possible value. Default: %0",
"Label displayed on the left side of the gauge" => "계기의 좌측에 표시될 레이블",
"Color" => "색",
"Main color of the gauge. Use HTML color codes or names" => "계기의 주 색상. HTML 색상 코드 혹은 이름을 사용",
"Background color of the gauge. Use HTML color codes or names" => "계기의 배경 색상. HTML 색상 코드 혹은 이름을 사용",
"Bar width in pixels" => "픽셀단위의 바 너비",
"Label Width" => "레이블 넓이",
"Label width, in pixels" => "레이블로 할당된 픽셀단위의 넓이",
"Display Percentage" => "백분율 표시",
// "Set to %0 (Yes) to display a percentage of the maximum" => "Set to %0 (Yes) to display a percentage of the maximum",
"Display Value" => "값 표기",
// "Set to %1 (No) to hide the numeric value (shown by default)" => "Set to %1 (No) to hide the numeric value (shown by default)",
"Bar height in pixels" => "픽셀단위의 바 높이",
// "GDGraph" => "GDGraph",
// "Create a simple graph from supplied data" => "Create a simple graph from supplied data",
// "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body" => "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body",
// "14, backported to 12.4" => "14, backported to 12.4",
// "Graph Type" => "Graph Type",
// "Defines what ype of graph or chart is to be generated" => "Defines what ype of graph or chart is to be generated",
// "Vertical Bar" => "Vertical Bar",
// "Graph Title" => "Graph Title",
// "Displayed above the graph" => "Displayed above the graph",
// "Alt Tag" => "Alt Tag",
// "Text for image alt tag" => "Text for image alt tag",
// "Graph Image Width" => "Graph Image Width",
// "Overall width in pixels. Default value is %0" => "Overall width in pixels. Default value is %0",
// "Graph Image Height" => "Graph Image Height",
// "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown" => "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown",
"Get Security Token" => "보안 토큰 받기",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Display a link on a secure page using an access token" => "Display a link on a secure page using an access token",
// "Entry Patg" => "Entry Patg",
// "The path or part of the path that the token is for" => "The path or part of the path that the token is for",
// "Query Keys" => "Query Keys",
// "Query string parameter keys that the token is for, separated by a colon (:)" => "Query string parameter keys that the token is for, separated by a colon (:)",
// "Query Values" => "Query Values",
// "Query string parameter values that the token is for, separated by a colon (:)" => "Query string parameter values that the token is for, separated by a colon (:)",
"Google Analytics" => "구글 웹분석",
"Add the tracking code for Google Analytics" => "구글 웹로그 분석에 대한 트래킹 코드 추가",
"Account Number" => "계정 번호",
// "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1" => "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1",
// "Groups Option" => "Groups Option",
// "Define option for Google Analytics groups, include or exclude" => "Define option for Google Analytics groups, include or exclude",
// "Available Groups" => "Available Groups",
// "Google Analytics Chart" => "Google Analytics Chart",
// "Draw charts from Google Analytics data" => "Draw charts from Google Analytics data",
// "JSON File" => "JSON File",
// "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)" => "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)",
// "Profle IDs" => "Profle IDs",
// "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin" => "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin",
// "Query String" => "Query String",
// "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0" => "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0",
"Metrics" => "메트릭",
// "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"" => "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"",
// "default \"30daysAgo\"" => "default \"30daysAgo\"",
// "default \"yesterday\"" => "default \"yesterday\"",
// "Dimensions" => "Dimensions",
// "default \"ga:date\"" => "default \"ga:date\"",
// "Segment" => "Segment",
// "default \"\"" => "default \"\"",
// "Max Results" => "Max Results",
// "default 50" => "default 50",
"Sort" => "분류",
// "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"" => "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"",
// "Container" => "Container",
// "ID of a DIV to contain the chart (optional)" => "ID of a DIV to contain the chart (optional)",
// "Type of chart, e.g. LINE, PIE etc" => "Type of chart, e.g. LINE, PIE etc",
// "Bar" => "Bar",
// "Pie" => "Pie",
// "Geo" => "Geo",
// "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "googlechart: No credentials file" => "googlechart: No credentials file",
// "googlechart: No query_ids supplied" => "googlechart: No query_ids supplied",
// "googlechart exception: %0" => "googlechart exception: %0",
"Google Doc" => "구글 문서",
"Display a Google document" => "구글 문서 표시",
"Leave this empty" => "빈 채로 두기",
"Type of Google document" => "구글 문서의 유형",
"Document" => "문서",
// "Slides" => "Slides",
// "Forms" => "Forms",
"Key" => "키",
// "Google doc key - for example" => "Google doc key - for example",
"Name of iframe. Default is \"Frame\" + the key" => "iframe명. 기본은 \"Frame\" + 키",
// "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly",
"Width in pixels or %" => "픽셀단위 혹은 %로 된 넓이",
"Height in pixels or %" => "픽셀단위 혹은 % 의 높이",
// "Position of frame on page" => "Position of frame on page",
"Middle" => "중간",
"Frame Border" => "프레임 경계선",
"Choose whether to show a border around the iframe" => "iframe 주변에 테두리의 표시 여부를  선택하십시오",
"Margin Height" => "여백 높이",
"Margin height in pixels" => "픽셀단위의 여백 높이",
"Margin Width" => "여백 넓이",
"Margin width in pixels" => "픽셀단위의 여백 넓이",
"Scrolling" => "스크롤 중",
"Choose whether to add a scroll bar" => "스크롤 바를 추가할 지 선택하십시오",
"Auto" => "자동",
"Edit Link" => "링크 편집",
"Choose whether to show an edit link and set its location" => "편집 링크 표시 및 위치 설정 여부를 선택하십시오",
"Required parameter \"type\" missing" => "필수 매개 변수 \"유형\" 없음",
"Required parameter \"key\" missing" => "필수 매개 변수 \"키\" 없음",
"Display content based on the user's groups or friends" => "사용자의 그룹 및 친구에 기반하여 컨텐츠 표기",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions",
"Allowed User Friends" => "허용된 사용자 친구들",
// "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample",
"Allowed Groups" => "허용된 그룹들",
// "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample",
"Denied Groups" => "거부된 그룹",
// "Pipe-separated list of groups not allowed to view the block" => "Pipe-separated list of groups not allowed to view the block",
// "Allowed Groups Pending Membership" => "Allowed Groups Pending Membership",
// "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding" => "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding",
// "Allowed Groups Full Membership" => "Allowed Groups Full Membership",
// "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending" => "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending",
"Group Expiration" => "그룹 만기",
// "Show the expiration date of a group the user belongs to" => "Show the expiration date of a group the user belongs to",
// "The name of an existing group on the site" => "The name of an existing group on the site",
"not in group" => "그룹에 없음",
"never expires" => "절대 만기되지 않음",
"Group List" => "그룹 목록",
// "Create a complete or filtered list of groups" => "Create a complete or filtered list of groups",
// "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed",
"Group Homepage" => "그룹 홈페이지",
"Link the group name to the group homepage, if there is one (not linked to by default)" => "그룹명을 그룹홈페이지가 존재할 경우 연결, (기본으로는 연결되지 않음)",
"Recursively List Groups" => "그룹을 재귀적으로 나열",
"Recursively list the included groups (the default is to not list them repeatedly)" => "포함된 그룹에 재귀적으로 사용 (기본은 재귀적으로 사용 안함)",
// "List only your own" => "List only your own",
// "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)" => "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)",
"GroupMail Core" => "그룹메일 핵심",
// "Display GroupMail functions on a page" => "Display GroupMail functions on a page",
"From Email" => "발신 이메일",
"Email address to report" => "보고할 이메일 주소",
"ID of GroupMail Logs tracker (set up in alias by profile)" => "그룹메일 기록 트래커 (프로필에 의하여 별칭 내부에 설정됨)의 ID",
"ID of GroupMail Logs tracker field (usually set up in alias by profile)" => "그룹메일 기록 트래커 필드 (일반적으로 프로필에 의하여 별칭 내부에 설정됨)의 ID",
"Datetime Field ID" => "날짜시간 필드 ID",
"Group Stats" => "그룹 통계",
"Show the distribution of users among groups" => "그룹들 간의 사용자 분포 표시",
"Groups" => "그룹",
"Groups, separated by \":\". If empty, all groups will be listed" => "그룹들은 : 로 구분됨. 비어있다면, 모든 그룹들이 나열될 것임.",
"Percentage of" => "다음의 백분율",
// "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter" => "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter",
// "Users in groups" => "Users in groups",
"Site users" => "사이트 사용자",
"Show Percentage" => "백분율 표시",
// "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)" => "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)",
"Show Bar" => "막대기 표시",
// "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)",
// "H5P" => "H5P",
// "Enable the creation, sharing and reuse of interactive HTML5 content" => "Enable the creation, sharing and reuse of interactive HTML5 content",
// "The H5P file in a file gallery" => "The H5P file in a file gallery",
// "H5P is not compatible with the Inline comments (annotations) feature" => "H5P is not compatible with the Inline comments (annotations) feature",
"Has Bought" => "구매함",
// "Check whether a user has bought an item or added it to the shopping cart" => "Check whether a user has bought an item or added it to the shopping cart",
// "PluginHasBought" => "PluginHasBought",
// "Key Name" => "Key Name",
"Key name of passcode to be checked" => "체크될 패스코드의 키 네임",
// "Key Labels" => "Key Labels",
"Label of the key name of passcode to be checked" => "확인될 패스코드의 키 이름의 레이블",
"Tracker from which to get passcode to check against" => "확인할 패스코드를 가져올 트래커",
"Field ID from which to get passcode to check against" => "확인을 하게되는 패스코드를 얻어낼 필드 ID",
"Item ID from which to get passcode to check against" => "확인을 할 패스코드를 얻을 항목 ID",
"Please fill in all fields" => "모든 필드를 먼저 채워 주십시오",
// "HTML" => "HTML",
"Add HTML to a page" => "페이지에 HTML 추가",
"HTML code" => "HTML 코드",
// "Move to HTML head" => "Move to HTML head",
// "Insert the code in the HTML head section rather than in the body" => "Insert the code in the HTML head section rather than in the body",
"Parse wiki syntax within the HTML code" => "HTML 코드 내부의 위키 문법을 구문번석",
"HTML Feed" => "HTML 피드",
// "Add an item to HTML Feed" => "Add an item to HTML Feed",
// "Name of this feed" => "Name of this feed",
"HTML Feed Link" => "HTML 피드 링크",
// "Receive and display content from another site sent using PluginHTMLFeed" => "Receive and display content from another site sent using PluginHTMLFeed",
"Initial Value" => "초기값",
// "Feed Location" => "Feed Location",
// "Content Name" => "Content Name",
// "Content Style" => "Content Style",
"Highlight" => "강조",
"Asterisk" => "별표",
"HTML Feed Link Type" => "HTML 피드 링크 종류",
"Backlink" => "역방향 연결",
"Popup" => "팝업",
"Hover" => "마우스로 가리키기",
// "Moderated" => "Moderated",
"Date of last accepted HTML item, not used if not moderated" => "마지막 수락된 HTML 항목의 날짜, 중재되지 않은 경우 사용되지 않음",
// "Display an icon" => "Display an icon",
// "Name of the icon" => "Name of the icon",
// "Valid icon name" => "Valid icon name",
// "Size of the icon (greater than 0 and less than 10)" => "Size of the icon (greater than 0 and less than 10)",
// "greater than 0 and less than 10" => "greater than 0 and less than 10",
"Rotate" => "회전",
// "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)" => "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)",
// "90, 180, 270, horizontal, vertical" => "90, 180, 270, horizontal, vertical",
// "Style supported by the current icon set" => "Style supported by the current icon set",
// "Iframe" => "Iframe",
// "Include the body of another web page in a scrollable frame within a page" => "Include the body of another web page in a scrollable frame within a page",
"Frame title" => "프레임 제목",
"Pixels or %" => "픽셀 혹은 %",
"Align the iframe on the page" => "페이지 상의 iframe 맞춤",
// "Responsive" => "Responsive",
// "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device" => "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device",
// "16 by 9" => "16 by 9",
// "4 by 3" => "4 by 3",
"no" => "아니오",
// "Display one or more custom-formatted images" => "Display one or more custom-formatted images",
"Image Source" => "그림 소스",
"Choose where to get the image from" => "그림을 얻을 곳 선택",
"An image in the file galleries" => "파일 갤러리 내부의 그림",
"An image attached to a wiki page" => "위키 페이지에 첨부된 그림",
"An image anywhere on the Internet" => "인터넷의 어느 곳의 그림",
"One random image from a file gallery" => "파일 갤러리에서 하나의 무작위 그림",
// "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)",
// "Valid file IDs separated by commas or |" => "Valid file IDs separated by commas or |",
"Image ID" => "그림 ID",
// "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)",
// "Valid image IDs separated by commas or |" => "Valid image IDs separated by commas or |",
"Full URL to the image to display" => "표시할 그림에 대한 전체 URL",
"Numeric ID of a file gallery. Displays a random image from that gallery" => "파일 갤러리의 숫자 ID. 그 개럴리에서 임의의 그림을 표기합니다.",
"Numeric ID of a file gallery. Displays all images from that gallery" => "파일 갤러리의 숫자 ID. 그 갤러리에서 모든 그림들을 표기합니다",
"Attachment ID" => "첨부파일 ID",
// "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)" => "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)",
// "Valid attachment IDs separated by commas or |" => "Valid attachment IDs separated by commas or |",
"Thumbnail" => "섬네일",
// "Makes the image a thumbnail with various options" => "Makes the image a thumbnail with various options",
// "Simple - links to full size image on a new page" => "Simple - links to full size image on a new page",
// "\"Lightbox\" - enlarges in an overlay box when clicked" => "\"Lightbox\" - enlarges in an overlay box when clicked",
// "Mouseover - enlarges in a popup when moused over" => "Mouseover - enlarges in a popup when moused over",
// "Mouseover (sticky)" => "Mouseover (sticky)",
// "Popup - enlarges in a separate window" => "Popup - enlarges in a separate window",
// "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1" => "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1",
// "Image Height" => "Image Height",
// "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Image Width" => "Image Width",
// "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Serve retina images" => "Serve retina images",
// "Serves up retina images to high density screen displays. Width must be set to use this" => "Serves up retina images to high density screen displays. Width must be set to use this",
// "Responsive Image Widths" => "Responsive Image Widths",
// "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"" => "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"",
// "Sizes" => "Sizes",
// "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters" => "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters",
// "Maximum Size" => "Maximum Size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings",
// "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description" => "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description",
// "Alternate Text" => "Alternate Text",
"Alternate text that displays when image does not load. Set to \"Image\" by default" => "그림이 로드되지 않았을 때 표시할 대체 텍스트. 기본으로는 \"그림\"으로 설정됨",
// "Responsive Image" => "Responsive Image",
// "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class" => "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class",
// "Featured Image" => "Featured Image",
// "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose" => "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose",
"Comment Ascending" => "댓글 오름차순",
"Comment Descending" => "댓글 내림차순",
"Max Hits Ascending" => "최대 방문수 오름차순",
"Max Hits Descending" => "최대 방문수 내림차순",
"User Ascending" => "사용자 오름차순",
"User Descending" => "사용자 내림차순",
"Author Ascending" => "저자 오름차순",
"Author Descending" => "저자 내림차순",
"Locked By Ascending" => "오름차순으로 잠금",
"Locked By Descending" => "내림차순으로 잠금",
"Last modified User Ascending" => "마지막 수정된 사용자 오름차순",
"Last modified User Descending" => "최종 수정 사용자 내림차순",
"Last modified Date Ascending" => "마지막 수정된 날짜 오름차순",
"Last modified Date Descending" => "마지막 수정된 날짜 내림차순",
"Delete After Ascending" => "오름차순 후 삭제",
"Delete After Descending" => "내림차순 후 삭제",
"Votes Ascending" => "투표 오름차순",
"Votes Descending" => "투표 내림차순",
"Points Ascending" => "점수 내림차순",
"Points Descending" => "점수 오름차순",
"Archive ID Ascending" => "보관 ID 오름차순",
"Archive ID Descending" => "보관 ID 내림차순",
// "Enlarge Button" => "Enlarge Button",
// "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1" => "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1",
"Browse Popup" => "팝업 탐색",
// "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked" => "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked",
// "Image Map" => "Image Map",
"Name of the image map to use for the image" => "그림에 대하여 사용할 그림 지도명",
// "Horizontal spacing" => "Horizontal spacing",
// "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Vertical spacing" => "Vertical spacing",
// "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Align image using legacy align tag" => "Align image using legacy align tag",
// "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email" => "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email",
// "Align Image" => "Align Image",
// "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page" => "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page",
// "Image Style" => "Image Style",
// "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects" => "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects",
// "Align Image Block" => "Align Image Block",
// "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1" => "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1",
// "Image Block Style" => "Image Block Style",
// "Description Style" => "Description Style",
// "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects" => "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects",
// "Wrapping" => "Wrapping",
"Control how other items wrap around the image" => "다른 항목들이 그림 주위를 어떻게 둘러쌓을 것인지 제어",
// "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows" => "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows",
// "Link Title" => "Link Title",
// "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties" => "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties",
"Metadata" => "메타데이터",
// "Display the image metadata (IPTC, EXIF and XMP information)" => "Display the image metadata (IPTC, EXIF and XMP information)",
// "Compression Quality" => "Compression Quality",
// "0 to 100 (default is 75)" => "0 to 100 (default is 75)",
// "Default Settings" => "Default Settings",
// "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Mandatory Setting" => "Mandatory Setting",
// "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Image Gallery Image" => "Image Gallery Image",
"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "그림에 대한 그림 갤러리 탐색창은 축소보기가 클릭되고 그림이 티키 그림 갤러리 있을 경우 열리게 됩니다",
"Same as \"browse\" except that the page opens in a new window or tab" => "페이지가 새 창 혹은 탭에 열린다는 것을 제외하고는 \"탐색\"과 동일",
"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "그림이 클릭되거나 그 위로 마우스가 왔을 때 축소보기를 전체 사이즈로 확대합니다 (\"링크\" 가 다른 대상으로 설정된 경우 제외). \"탐색\" 과 \"탐색팝업\" 은 그림 갤러리에서 작동하며 \"다운로드\" 는 파일갤러리 혹은 첨부파일에서만 작동합니다",
// "Hide Draw Icon" => "Hide Draw Icon",
// "Do not show draw/edit icon button under image" => "Do not show draw/edit icon button under image",
// "Overlay with zoom" => "Overlay with zoom",
// "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked" => "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked",
// "Zoom" => "Zoom",
// "Adds a magnifying glass icon and zooms the image when hovered over" => "Adds a magnifying glass icon and zooms the image when hovered over",
"PluginImg: User lacks permission to view image" => "PluginImg: 사용자가 그림을 볼 권한이 없습니다",
"File is not an image" => "파일은 그림이 아닙니다",
"Server does not support image manipulation" => "서버는 그림 조작을 지원하지 않습니다",
// "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator" => "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator",
// "SVG Image replace error \"%0\"" => "SVG Image replace error \"%0\"",
"Enlarge" => "확대",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''",
"''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "'다음 매개변수들 중 하나 그리고 단 하나만 사용하십시오: fileId, randomGalleryId, fgalId, attId, id, 혹은 src.''",
"Draw on the Image" => "그림 위에 그리기",
"Include" => "포함",
// "Include a portion of another wiki page" => "Include a portion of another wiki page",
// "Name of the source wiki page (which contains the included portion)" => "Name of the source wiki page (which contains the included portion)",
// "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start",
"Stop" => "멈춤",
// "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end",
// "Read more button" => "Read more button",
// "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)" => "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)",
// "Read more button label" => "Read more button label",
// "Label of the button linking to the source page (if it is displayed)" => "Label of the button linking to the source page (if it is displayed)",
// "Text to show when the page selected to be included is not found anymore" => "Text to show when the page selected to be included is not found anymore",
// "Permission denied message" => "Permission denied message",
// "Text to show when the page exists but the user has insufficient permissions to see it" => "Text to show when the page exists but the user has insufficient permissions to see it",
// "No version approved error message" => "No version approved error message",
// "Text to show when the page exists but no version is approved" => "Text to show when the page exists but no version is approved",
// "Edit Icon" => "Edit Icon",
// "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings" => "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings",
// "Max inclusions" => "Max inclusions",
// "Maximum amount of times the same page can be included. Defaults to 5" => "Maximum amount of times the same page can be included. Defaults to 5",
// "Parse Included Page" => "Parse Included Page",
// "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents" => "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents",
// "Max characters included" => "Max characters included",
// "Limit the length of the included text" => "Limit the length of the included text",
"Read more" => "더 읽기",
// "The text above comes from page \"%s\". Click to go to that page" => "The text above comes from page \"%s\". Click to go to that page",
"Include Plugin" => "플러그인 포함",
"Edit the included page" => "포함된 페이지 편집",
// "Include Template File" => "Include Template File",
// "Include a Smarty template (.tpl) file in a page" => "Include a Smarty template (.tpl) file in a page",
// "TPL file name" => "TPL file name",
// "If you need to include Smarty template files" => "If you need to include Smarty template files",
// "Values passed to the TPL" => "Values passed to the TPL",
// "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1" => "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1",
// "Include URL" => "Include URL",
// "Include the body content from a URL" => "Include the body content from a URL",
// "URL to external file to include" => "URL to external file to include",
// "Missing parameter url for plugin %0" => "Missing parameter url for plugin %0",
"Insert Tracker Item" => "트래커 항목 삽입",
"Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item" => "플러그인이 페이지에 삽입되었을 때 트래커 항목을 만듬. 플러그인이 삭제되고 새롭게 생성된 항목으로의 링크로 교체됨",
"Item not inserted" => "항목 삽입되지 않음",
"Invite" => "초대",
"Invite a user to join your groups" => "사용자를 그룹으로 초대",
"Confirmation message after posting form" => "게시 서식 뒤에 메시지 확인",
"Including Group" => "그룹 포함",
"Will list only the groups that include this group" => "이 그룹을 포함하는 그룹들만 나열함",
"Default Group" => "규정그룹",
"Dropdown list will show this group by default" => "드롭다운 목록은 기본적으로 이 그룹을 표시할 것입니다",
// "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default",
"The following mandatory fields are missing" => "다음 필수 필드들이 없습니다",
"Email address" => "이메일 주소",
// "Add jQuery JavaScript code" => "Add jQuery JavaScript code",
"JavaScript code" => "자바스크립트 코드",
// "Not On Ready" => "Not On Ready",
"Do not execute on document ready (execute inline)" => "문서 준비 상에는 실행하지 않음 (인라인 실행)",
"No JavaScript" => "자바스크립트 없음",
"Optional markup for when JavaScript is off" => "자바스크립트가 꺼져있을 때에 대한 선택적 마크업",
// "Language to apply JQuery to" => "Language to apply JQuery to",
"<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq 플러그인 비활성: 자바스크립트 꺼짐 -->",
"JavaScript" => "자바스크립트",
// "Add JavaScript code or files" => "Add JavaScript code or files",
"JavaScript filename" => "자바스크립트 파일명",
"Late Load" => "늦은 로드",
"Late load, use headerlib" => "늦은 로드, headerlib 사용",
"Display a video created through the Kaltura feature" => "칼투라 기능을 통하여 만들어진 동영상 표기",
"Kaltura Entry ID" => "칼투라 입력 ID",
// "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one" => "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one",
"Kaltura Video Player ID" => "칼투라 동영상 재생기 ID",
// "Width of the player in pixels or percent" => "Width of the player in pixels or percent",
// "Height of the player in pixels or percent" => "Height of the player in pixels or percent",
"Align" => "맞춤",
"Alignment of the player" => "플레리어의 맞춤",
"Not set" => "설정되지 않음",
"Centre" => "중앙",
"Alignment of the player using CSS float" => "CSS float 를 사용하여 플레이어 맞춤",
"Add Media Button Label" => "미디어 버튼 라벨 추가",
"Text to display on button for adding new media" => "새 미디어를 추가하기 위한 버튼에 표시될 텍스트",
"Add media" => "미디어 추가",
// "Player Type" => "Player Type",
// "Set player type" => "Set player type",
// "KDP" => "KDP",
// "HTML5" => "HTML5",
"Upload Media" => "미디어 업로드",
"Media ID or permission to upload video is required" => "동영상을 업로드할 미디어 ID 혹은 권한이 필요합니다",
"Log in to upload video" => "동영상을 업로드하려면 로그인",
"Player not found" => "재생기 발견되지 않음",
// "Kaltura player: unsupported type" => "Kaltura player: unsupported type",
// "Show alternative content based on the page language" => "Show alternative content based on the page language",
// "Content to show" => "Content to show",
// "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Not Language" => "언어 아님",
// "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Show the last modification date for a page" => "페이지에 대한 최종 수정 날짜 표시",
"Page name to display information of. Default value is current page" => "정보를 표시할 페이지명. 기본값은 현재 페이지",
"Date format" => "날짜 형식",
// "Set date and time format according to site settings" => "Set date and time format according to site settings",
// "Long date" => "Long date",
// "Short date" => "Short date",
// "Long datetime" => "Long datetime",
// "Short datetime" => "Short datetime",
// "ISO" => "ISO",
// "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects" => "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects",
// "Display page header" => "Display page header",
// "Set to No, to hide header on the page" => "Set to No, to hide header on the page",
// "Display Page Footer" => "Display Page Footer",
// "Display Page Left Bar" => "Display Page Left Bar",
// "Set to No, to hide left on the page" => "Set to No, to hide left on the page",
// "Display Page Right Bar" => "Display Page Right Bar",
// "Set to No, to hide right on the page" => "Set to No, to hide right on the page",
// "Page Full Width" => "Page Full Width",
// "100% Page width" => "100% Page width",
// "Page Content Width" => "Page Content Width",
// "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)" => "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)",
// "Page Background Image URL" => "Page Background Image URL",
// "Enter image url, in case of single image" => "Enter image url, in case of single image",
// "Background Repear" => "Background Repear",
// "Cover,Repeat,no-repeat" => "Cover,Repeat,no-repeat",
// "Page Background Sliding Images" => "Page Background Sliding Images",
// "Enter file gallery id for fading background" => "Enter file gallery id for fading background",
// "Page Content Top Margin" => "Page Content Top Margin",
// "Enter value in % or px for example 30%, 300px, default will be 0" => "Enter value in % or px for example 30%, 300px, default will be 0",
// "Page Header Width" => "Page Header Width",
// "Enter page header width in px or %, leave blank for same width as page body.)" => "Enter page header width in px or %, leave blank for same width as page body.)",
// "Page Footer Width" => "Page Footer Width",
// "Enter page footer width in px or %, leave blank for same width as page body.)" => "Enter page footer width in px or %, leave blank for same width as page body.)",
// "Page Background Color" => "Page Background Color",
// "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)" => "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)",
// "Content Background Color" => "Content Background Color",
// "Content Text Color" => "Content Text Color",
// "Enter a valid CSS color code, for example #000,#fff,#ccc" => "Enter a valid CSS color code, for example #000,#fff,#ccc",
// "Content Border Radius" => "Content Border Radius",
// "To make content div round cornered, for example 10px" => "To make content div round cornered, for example 10px",
// "Content Border Shadow" => "Content Border Shadow",
// "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)" => "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)",
// "Transition Delay" => "Transition Delay",
// "Time interval to pause before moving to next slide in seconds" => "Time interval to pause before moving to next slide in seconds",
// "Display Page Action Buttons" => "Display Page Action Buttons",
// "Set to No, to hide page action buttons, with and under content" => "Set to No, to hide page action buttons, with and under content",
// "Display top bar(under header)" => "Display top bar(under header)",
// "Set to No, to hide topbar on the page" => "Set to No, to hide topbar on the page",
// "Display page top bar(above page content)" => "Display page top bar(above page content)",
// "Set to No, to hide page topbar module zone" => "Set to No, to hide page topbar module zone",
// "Display page bottom bar(under page content)" => "Display page bottom bar(under page content)",
// "Set to No, to hide page bottom bar module zone" => "Set to No, to hide page bottom bar module zone",
// "Create a \"Like\" button" => "Create a \"Like\" button",
// "Count only" => "Count only",
// "Sets whether to only show the count of likes rather than give the option to vote" => "Sets whether to only show the count of likes rather than give the option to vote",
// "Search for, list, and filter all types of items and display custom-formatted results" => "Search for, list, and filter all types of items and display custom-formatted results",
// "Use List GUI" => "Use List GUI",
// "Use the graphical user interface for editing this list plugin" => "Use the graphical user interface for editing this list plugin",
// "Cache Output" => "Cache Output",
// "Cache output of this list plugin" => "Cache output of this list plugin",
// "Cache Expiry Time" => "Cache Expiry Time",
// "Time before cache is expired in minutes" => "Time before cache is expired in minutes",
// "Cache Purge Rules" => "Cache Purge Rules",
// "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches" => "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches",
// "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block" => "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block",
// "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine" => "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine",
// "Error: {MULTISEARCH(id=x)} needs an ID to be specified" => "Error: {MULTISEARCH(id=x)} needs an ID to be specified",
"List Execute" => "실행 나열",
// "Set custom actions that can be executed on a filtered list of objects" => "Set custom actions that can be executed on a filtered list of objects",
// "Invalid action: %0" => "Invalid action: %0",
// "There are too many search result items to apply %0 action to" => "There are too many search result items to apply %0 action to",
// "Unknown error executing action %0 on item %1" => "Unknown error executing action %0 on item %1",
// "Error executing action %0 on item %1" => "Error executing action %0 on item %1",
// "Action %0 executed successfully on %1 item(s)" => "Action %0 executed successfully on %1 item(s)",
"List Pages" => "페이지 목록",
"List pages based on various criteria" => "다양한 조건에 기반한 페이지 나열",
"Result number at which the listing should start" => "목록이 시작되어야 할 결과 숫자",
"Limit number of items displayed in the list. Default is to display all" => "목록에 표시된 항목들의 수 제한. 기본은 전부 표시",
"Initial" => "초기",
// "Initial page to show" => "Initial page to show",
"Show Name Only" => "이름만 표시",
"Show only the page names" => "페이지명만 표시",
// "Category Filter" => "Category Filter",
// "Filter categories by Id numbers. Use different separators to filter as follows" => "Filter categories by Id numbers. Use different separators to filter as follows",
// "Page is in any of the specified categories. Example" => "Page is in any of the specified categories. Example",
// "Page must be in all of the specified categories. Example" => "Page must be in all of the specified categories. Example",
// "Page is in the first specified category and not in any of the others. Example" => "Page is in the first specified category and not in any of the others. Example",
// "Valid category ID or list separated by :, + or -" => "Valid category ID or list separated by :, + or -",
"Structure Head" => "구조체 헤드",
"Filter by structure head" => "구조체 헤드로 필터하기",
"Show Page Alias" => "페이지 별칭 표시",
"Show page alias in the list" => "목록에 페이지 별칭 표시",
// "Include Tag" => "Include Tag",
// "Only pages with specific tag (separate tags using %0)" => "Only pages with specific tag (separate tags using %0)",
// "Exclude Tag" => "Exclude Tag",
// "Only pages with specific tag excluded (separate tags using %0)" => "Only pages with specific tag excluded (separate tags using %0)",
// "Show Number of Pages" => "Show Number of Pages",
// "Show the number of pages matching criteria" => "Show the number of pages matching criteria",
"Only pages with names similar to the text entered for this parameter will be listed" => "이 매개 변수에 대하여 입력된 텍스트와 유사한 이름들을 가진 페이지들만이 나열됩니다1",
"Two-letter language code to filter pages listed" => "나열된 페이지를 필터링할 2글자 언어코드",
"Orphan Language" => "고아 언어",
// "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed" => "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed",
"Load Translations" => "번역 로드",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter",
"Page name and text entered for the filter parameter must match exactly to be listed" => "필터 매개 변수에 대하여 입력된 페이지명과 텍스트는 나열될 것과 정확히 일치해야 합니다",
"Only Orphan Pages" => "고아 페이지들만",
"Only list orphan pages" => "고아 페이지들만 나열",
"For List Pages" => "목록 페이지 용",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples" => "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples",
// "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start",
// "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end",
"Length" => "길이",
"Number of characters to display" => "표시할 글자 수",
// "Checkboxes" => "Checkboxes",
// "Offset Argument" => "Offset Argument",
"Pagination" => "페이지 매김",
// "Exclude Page(s)" => "Exclude Page(s)",
// "Wiki page names to be excluded from list" => "Wiki page names to be excluded from list",
// "Local Files" => "Local Files",
// "Show a link to local or shared files and directories" => "Show a link to local or shared files and directories",
// "Local file or directory path" => "Local file or directory path",
"List Directory" => "디렉터리 나열",
// "If the path above is a directory then list the contents" => "If the path above is a directory then list the contents",
// "Show MIME file-type icons" => "Show MIME file-type icons",
// "List files in a directory" => "List files in a directory",
"Full path to the server-local directory. Default is the document root" => "서버-로컬 디렉터리로의 전체 경로. 기본은 document 루트 입니다",
"URL Prefix" => "URL 접두어",
// "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example" => "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example",
"Set the sort order of the file list" => "파일 목록의 정렬 순서 설정",
"File Name" => "파일명",
"File Size" => "파일 크기",
"Last Access" => "마지막 접근",
"Last Metadata Change" => "마지막 메타데이터 변경",
// "Only list files with file names that contain this filter. Example" => "Only list files with file names that contain this filter. Example",
"Limit" => "제한",
"Maximum amount of files to display. Default is no limit" => "표시될 파일들의 최대양. 기본은 제한 없음임",
"could not be opened because it doesn't exist or permission was denied" => "열릴 수 없었습니다 이유는 존재하지 않거나 권한이 거부되었기 때문입니다",
"Mail" => "메일",
// "Mail other users or groups" => "Mail other users or groups",
"Limit the list of groups to the groups including each group" => "그룹의 목록을 각 그룹을 포함하는 그룹들로 제한",
// "Group Dropdown" => "Group Dropdown",
"Show a dropdown list of groups (not shown by default)" => "그룹의 드롭다운 목록 보기 (기본으로 보이지 않음)",
// "Recurse Groups" => "Recurse Groups",
// "Show each group and each group included in this group" => "Show each group and each group included in this group",
// "Recurse Group Users" => "Recurse Group Users",
// "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times..." => "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times...",
// "User Dropdown" => "User Dropdown",
"Show a dropdown list of users (not shown by default)" => "사용자의 드롭다운 목록 보기 (기본으로 보이지 않음)",
// "User Emails" => "User Emails",
// "Show a box for user to enter email addresses" => "Show a box for user to enter email addresses",
"Real Name Dropdown" => "실명 드롭다운",
"Show a dropdown list of user real names (not shown by default)" => "사용자 실명의 드롭다운 목록 보기 (기본으로 보이지 않음)",
// "Show in popup instead of inline" => "Show in popup instead of inline",
// "Text to show on the button to send emails (default: %0Send mail%1)" => "Text to show on the button to send emails (default: %0Send mail%1)",
// "Send mail" => "Send mail",
// "Email Subject" => "Email Subject",
// "Present Email subject content" => "Present Email subject content",
// "Bypass Preview" => "Bypass Preview",
// "Send emails without first previewing" => "Send emails without first previewing",
// "Debug mode (admins only)" => "Debug mode (admins only)",
// "Show list of emails that are sent (admins only)" => "Show list of emails that are sent (admins only)",
// "Mail send was unsuccessful" => "Mail send was unsuccessful",
"Map" => "지도",
"Display a map" => "지도 표기",
"Instructions to load content" => "컨텐츠를 로드할 설명",
"Scope" => "범위",
// "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1" => "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1",
"Controls" => "제어",
// "Comma-separated list of map controls will be displayed on the map and around it" => "Comma-separated list of map controls will be displayed on the map and around it",
"Width of the map in pixels" => "지도의 그림 단위 넓이",
"Height of the map in pixels" => "지도의 픽셀단위 높이",
// "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1" => "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1",
// "Popup Style" => "Popup Style",
"Alter the way the information is displayed when objects are loaded on the map" => "개체가 지도 상에 로드되었을 때 정보가 표시되는 방식 변경",
"Bubble" => "거품",
"MapServer File" => "지도서버 파일",
"MapServer file identifier. Only fill this in if you are using MapServer" => "지도서버 파일 식별자. 지도서버를 사용할 경우에만 이를 기입하시오",
"Extents" => "연장",
"Size of the map" => "지도의 크기",
// "Show item name in a tooltip on hover" => "Show item name in a tooltip on hover",
// "Open Layers Version" => "Open Layers Version",
// "OL2 or OL3+ so far (default ol2)" => "OL2 or OL3+ so far (default ol2)",
// "OpenLayers 2.x" => "OpenLayers 2.x",
// "Tileset layers" => "Tileset layers",
// "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)" => "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)",
// "Cluster Distance" => "Cluster Distance",
// "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)" => "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)",
// "Cluster Hover Behavior" => "Cluster Hover Behavior",
// "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)" => "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)",
// "Show Features" => "Show Features",
// "Cluster Fill Color" => "Cluster Fill Color",
// "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)" => "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)",
// "Cluster Text Color" => "Cluster Text Color",
// "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)" => "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)",
"Color Picker" => "색 선택기",
// "Markdown" => "Markdown",
// "Parse the body of the plugin using a Markdown parser" => "Parse the body of the plugin using a Markdown parser",
// "Markdown syntax to be parsed" => "Markdown syntax to be parsed",
"Mayan Calendars" => "마얀 달력",
"Convert a Gregorian date to a Mayan calendar date" => "그레고리언 날짜를 마얀 달력날짜로 변경",
"You must use the variable substitution" => "변수 교체를 반드시 사용해야 합니다",
// "LongCount: " => "LongCount: ",
"Tzolkin: " => "촐킨: ",
// "Haab: " => "Haab: ",
"Misc: " => "기타: ",
"Example: template " => "예제: 템플릿",
// "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
"Default template: " => "기본 템플릿",
"Gregorian date" => "그레고리언 달력",
// "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date" => "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date",
" is not a valid date format. should be dd.mm.yyyy" => " 은 유효한 날짜 서식이 아닙니다. dd.mm.yyyy 형태로 되어있어야 합니다",
"Media Player" => "미디어 재생기",
"Add a media player to a page" => "페이지에 미디어 플레이어 추가",
"Allow full-screen" => "전체화면 허용",
"Allow full-screen mode" => "전체화면 모드 허용",
// "MP3 URL" => "MP3 URL",
// "FLV URL" => "FLV URL",
// "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled" => "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled",
"Player width in px or %" => "픽셀단위 혹은 %로 된 재생기 넓이",
"Player height in px or %" => "픽셀단위 혹은 %의 재생기 높이",
// "Set the style" => "Set the style",
"Media Type" => "미디어 유형",
// "Media type for HTML5" => "Media type for HTML5",
// "Audio" => "Audio",
"Video" => "동영상 스트리밍 통합",
"Flash Window Mode" => "플래시 창 모드",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: ",
"Transparent" => "투평",
"Opaque" => "불투명",
"Window" => "창",
// "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)" => "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)",
// "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)" => "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)",
// "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below" => "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below",
// "Download file" => "Download file",
"Member List" => "구성원 목록",
"List and allow editing of group members" => "그룹 구성원의 목록 및 편집 허용",
// "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated" => "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated",
// "Descriptions" => "Descriptions",
"Display group descriptions below list name" => "목록 이름 하단에 그룹 설명 표시",
"How to show the member lists" => "구성원 목록 보기 방법",
"Maximum" => "최대",
// "Maximum number of users to list in each group (default %0100%1)" => "Maximum number of users to list in each group (default %0100%1)",
"Members Only" => "멤버들만",
// "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user" => "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user",
"Sort mode" => "정렬 모드",
"Sort mode for member listing" => "구성원 나열에 대한 정렬 모드",
"Read only mode. All ability to modify membership is hidden" => "읽기 전용 모드. 멤버십을 수정할 모든 기능이 감춰짐",
"Set as Default Group" => "기본 그룹으로 설정",
// "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group",
"Not suggested" => "제안되지 않음",
"Suggested" => "제안됨",
"Required" => "요청됨",
"Only groups including the group that you specify will be listed" => "지정하신 그룹을 포함하는 그룹들만이 나열될 것입니다",
// "Notify Added User" => "Notify Added User",
// "Notify Removed User" => "Notify Removed User",
// "Email notification to removed user" => "Email notification to removed user",
// "Need Approval" => "Need Approval",
// "Add approve/reject user buttons for private addon groups" => "Add approve/reject user buttons for private addon groups",
"Member Payment" => "구성원 지불",
// "Receive payment from a member to extend membership to a group" => "Receive payment from a member to extend membership to a group",
"Name of the group for which the subscription should be added or extended" => "구독이 추가 혹은 연장되어야할 그룹명",
"Price per period (%0)" => "기간 당 가격 (%0)",
"Current User Member" => "현재 사용자 구성원",
"Membership only for the current user" => "현재 사용자만을 위한 멤버십",
"Input Title" => "입력 제목",
"Title of the initial input form" => "초기 입력 형식의 제목",
// "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years" => "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years",
"Supports wiki syntax" => "위키 문법을 지원합니다",
"Input Title Only" => "입력 제목만",
// "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well" => "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well",
"Initial Payment Form Title" => "초기 지불 양식 제목",
"Add a title to the payment form when initially shown after clicking \"Continue\"" => "\"계속\"을 클릭한 후 초기에 표시되었을 때 지불에 대한 제목을 추가",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years",
"Payment Form Title Only" => "지불 형식 제목만",
// "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well",
"Subsequent Payment Form Title" => "다음 지불 양식 제목",
"Title of the payment form after the initial showing" => "초기 표시 이후 지불 형식의 제목",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years",
"Subsequent Payment Form Title Only" => "다음 지불 양식 제목만",
// "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well",
"Prevent Double Request" => "이중 요청 금지",
"Prevent user from extended if there is already a pending request" => "이미 대기 중인 요청이 있을 경우 사용자에 대하여 기간 확장 방지",
// "Free Periods" => "Free Periods",
// "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought",
"Hide Period" => "기간 감춤",
"Do not allow user to set period - use default of 1" => "사용자가 기간을 설정하는 것을 허용 안 함 - 1 의 기본 사용",
"Periods Label" => "기간 레이블",
// "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)" => "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)",
"Page that payment service returns to after processing" => "프로세싱 이후에 지불 서비스가 복귀하게 되는 페이지",
// "Annual, commencing %0 %1 each year" => "Annual, commencing %0 %1 each year",
// "Monthly, commencing on day %0 each month" => "Monthly, commencing on day %0 each month",
"The user " => "사용자",
" already has a pending extension request payment invoice " => " 이미 지불 청구서에 대한 보류 중인 확장기능 요청이 있습니다",
// "%0 to %1 %2 for %3" => "%0 to %1 %2 for %3",
// "periods" => "periods",
// "period" => "period",
// "Membership to %0 for %1 users for %2 %3" => "Membership to %0 for %1 users for %2 %3",
"The group " => "그룹",
" does not have a membership term" => " 멤버십 기간이 없습니다",
" Go to " => " 다음으로 이동",
"Admin > Groups" => "관리 > 그룹",
" to specify a term for this group by automatically unassigning users after a certain number of days" => " 이 그룹이 특정 일 수 후 사용자들을 자동으로 할당해제할 기간을 지정하기 위함",
" does not exist" => " 존재하지 않습니다",
// "MetaTag" => "MetaTag",
// "Add custom meta tags to the HTML head section of the page where the plugin is used" => "Add custom meta tags to the HTML head section of the page where the plugin is used",
// "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here" => "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here",
// "Name attribute of the meta tag" => "Name attribute of the meta tag",
// "Content attribute of the meta tag" => "Content attribute of the meta tag",
"Mini Quiz" => "미니 퀴즈",
"Create a quiz using a tracker" => "트래커를 사용한 퀴즈 만들기",
"Instructions::Feedback" => "설명::피드백",
"Numeric value representing the miniquiz tracker ID" => "미니퀴즈 트래커 ID를 나타내는 숫자 값",
"Module" => "모듈",
"Display a module" => "모듈 표시",
"Module Name" => "모듈이름",
"Module name as known in Tiki" => "티키 내부에서 알려진 모듈명",
// "Select Yes (%0y%1) to hide the title (default is to show the title)" => "Select Yes (%0y%1) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)" => "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)",
"Align the module to the left or right on the page allowing other elements to align against it" => "모듈을 페이지의 왼쪽 혹은 오른쪽 맞춤으로 하여 타 요소들이 이에 디하여 맞추는 것을 허용",
// "Number of rows (default: %010%1)" => "Number of rows (default: %010%1)",
"Parse" => "구문부넉",
"Parse wiki syntax" => "위키 문법을 구문분석",
"Show only the content with no title or borders, etc. around the content" => "에워싸는 상자 없이 컨텐츠만 표시",
"Title, background, etc" => "장식",
"Show module title (heading) background, etc. (default is to show them)" => "상자 장식 표시 (기본으로 표시됨)",
// "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)" => "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)",
"Title Background" => "제목 배경",
// "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)" => "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)",
"Module Style" => "모듈 스타일",
// "Inline CSS for the containing div element, for example, %0max-width:80%%1" => "Inline CSS for the containing div element, for example, %0max-width:80%%1",
// "Valid CSS styling" => "Valid CSS styling",
"CSS styling for the module data itself" => "모듈 데이터 자체에 대한 CSS 스타일링",
"Custom CSS class" => "사용자 지정 CSS 클래스",
// "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons",
// "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above",
// "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated" => "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated",
// "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module",
"Please choose a module" => "모듈을 선택하십시오",
"to be used as argument" => "변수로서 사용될 것",
"Sorry, no such module" => "죄송합니다, 그러한 모듈이 없습니다",
"Module List" => "모듈 목록",
// "Display the modules assigned to a zone" => "Display the modules assigned to a zone",
"Zone Name" => "구역명",
"The name of the module zone to include. Can be a custom zone name" => "포함할 모듈 구역의 이름. 구역명이 될 수 있음",
// "Top bar" => "Top bar",
// "Page top" => "Page top",
// "Page bottom" => "Page bottom",
"Monospace" => "고정 폭",
"Display text in a monospace font" => "고정 폭 폰트로 텍스트 표시",
// "Text that the font will be applied to" => "Text that the font will be applied to",
"Font name as recognized by browsers" => "브라우저내에 알려진 폰트명들",
"Mouseover" => "마우스오버",
// "Display hidden content by mousing over text" => "Display hidden content by mousing over text",
"Hidden content, unless the label parameter is undefined, in which case this is the label" => "숨겨진 컨텐츠, 라벨 매개 변수가 미정의 되어있지 않는 한, 이것이 라벨입니다",
"Text displayed on the page. The body is the hidden content" => "페이지에 표시될 텍스트. 본문은 감춰진 컨텐츠입니다.",
"Destination link when mouseover text is clicked. Use http:// for external links" => "마우스오버 텍스트가 클릭되었을 때의 대상 링크. 외부링크에 대하여 http:// 를 사용하십시오",
"DEPRECATED" => "사용되지 않음",
"Hidden content. The body contains the label" => "숨겨진 컨텐츠. 본문이 라벨을 포함합니다",
// "Mouseover box width. Default: %0400px%1" => "Mouseover box width. Default: %0400px%1",
// "Mouseover box height. Default: %0200px%1" => "Mouseover box height. Default: %0200px%1",
"Offset X" => "오프셋 X",
// "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1" => "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1",
"Offset Y" => "오프셋 Y",
// "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1" => "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1",
"Parse Body" => "본문 구문분석",
"Parse the body of the plugin as wiki content (parsed by default)" => "위키 컨텐츠로써 플러그인의 본문 구문분석 (기본으로 구문분석 됨)",
"Parse Label" => "레이블 구문분석",
"Parse the label as wiki content (parsed by default)" => "레이블을 위키 컨텐츠로써 구문분석 (기본으로 구문분석됨)",
"CSS class to apply" => "적용할 CSS 클래스",
"Background color to apply to the popup" => "팝업에 적용할 배경 색상",
"Text Color" => "텍스트 색상",
"Color to apply to the text in the popup" => "팝업 내에 텍스트에 적용될 색상",
"Sticky" => "고정",
"When enabled, popup stays visible until it is clicked" => "활성화 될 경우, 팝업이 클릭될 때까지 표기된 상태로 머뭄",
"Padding" => "안쪽 여백",
"Padding size in pixels" => "픽셀단위의 안쪽여백 크기",
"Effect" => "효과",
"Set the type of show/hide animation that will be used" => "사용될 애니메이션의 표시/숨김 종류 설정",
"Effect Speed" => "스피드 효과",
"Set the speed of the animation" => "애니메이션의 속도 설정",
"Close Delay" => "지연 닫기",
"Number of seconds before popup closes" => "팝업이 접기 전의 초 수",
// "HTML tag to use for the label. Default %0a%1" => "HTML tag to use for the label. Default %0a%1",
"No label specified" => "지정된 라벨 없음",
"MediaWiki Table" => "미디어위키 표",
// "Display a table using MediaWiki syntax" => "Display a table using MediaWiki syntax",
"Fancy" => "팬시",
// "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter" => "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter",
"True" => "참",
"False" => "거짓",
"Wiki Classes" => "위키 클래스",
// "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)" => "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)",
"MySpace" => "마이스페이스",
"Display a MySpace Flash mp3 playlist" => "마이스페이스 플래시 mp3 재생목록 표시",
"MySpace Page" => "마이스페이스 페이지",
"MySpace page name" => "마이스페이스 페이지명",
"Network condition" => "네트워크 상태",
// "Display content based on the user's IP address" => "Display content based on the user's IP address",
"Content to display conditionally" => "조건적으로 표기할 컨텐츠",
"IPv4 List" => "IPv4 목록",
"Comma-separated list of IPv4 addresses to match against the visitor's address" => "방문객의 주소를 비교해 볼 IPv4 주소들의 쉼표로 구분된 목록",
"Now" => "지금",
// "Show the current date and time" => "Show the current date and time",
// "Time format using the PHP format described here: %0" => "Time format using the PHP format described here: %0",
// "Based site long date and time setting" => "Based site long date and time setting",
// "Date to display" => "Date to display",
// "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0" => "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0",
// "Allow Invalid Dates" => "Allow Invalid Dates",
// "Allow return values that are not a valid date, such as the day of the month" => "Allow return values that are not a valid date, such as the day of the month",
// "Plugin now when parameter not valid. %0" => "Plugin now when parameter not valid. %0",
"Object Hits" => "개체 방문수",
"Display the number of hits for certain objects" => "특정 개체에 대한 방문 수 표시",
// "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title" => "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1" => "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1",
// "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits" => "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits",
"Since a date" => "날짜 이후",
"Date since the hits are collected in a format supported by strtotime" => "strtotime 에 의하여 지원되는 형식으로 방문수가 수집된 후 날짜",
// "Display a link to an object" => "Display a link to an object",
"The object type" => "개체 유형",
"The item to display" => "표시할 항목",
// "Tiki Package View" => "Tiki Package View",
// "Display the output of a Tiki Package View" => "Display the output of a Tiki Package View",
// "Package Name" => "Package Name",
// "Name of package in the form %0vendor/name%1" => "Name of package in the form %0vendor/name%1",
// "Name of the view" => "Name of the view",
// "Name of the view file without the %0.php%1" => "Name of the view file without the %0.php%1",
"Page Tabs" => "페이지 탭",
// "PluginPageTabs" => "PluginPageTabs",
// "Display the content of a wiki page in a set of tabs" => "Display the content of a wiki page in a set of tabs",
"Wiki page names" => "위키 페이지 이름들",
// "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent",
"Parameter" => "매개 변수",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met",
// "Names of parameters required to display text, separated by %0|%1" => "Names of parameters required to display text, separated by %0|%1",
// "Source where the parameter is checked" => "Source where the parameter is checked",
// "REQUEST" => "REQUEST",
// "GET" => "GET",
// "POST" => "POST",
// "COOKIE" => "COOKIE",
// "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"" => "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"",
"Show the details of a payment request or invoice." => "지불요청 혹은 청구서의 상세내역 보기",
"Payment Request Number" => "지불 요청 번호",
"Unique identifier of the payment request" => "지불 요청의 고유 식별자",
// "Payment List" => "Payment List",
// "Show details of payments. The payments considered may be restrained by user or date" => "Show details of payments. The payments considered may be restrained by user or date",
// "Payment type" => "Payment type",
"Outstanding" => "뛰어남",
"Overdue" => "연체",
// "Authorized" => "Authorized",
// "Output format" => "Output format",
"Total" => "총",
// "JSON (for advanced custom usage)" => "JSON (for advanced custom usage)",
// "Payments by a particular user" => "Payments by a particular user",
// "Payer email" => "Payer email",
// "Date range start, accepts most date formats" => "Date range start, accepts most date formats",
// "Date range end" => "Date range end",
// "Advanced filter" => "Advanced filter",
// "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)" => "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)",
// "List offset" => "List offset",
// "For pagination" => "For pagination",
// "Payments per page" => "Payments per page",
// "Automatic (newest first)" => "Automatic (newest first)",
// "User A to Z" => "User A to Z",
// "User Z to A" => "User Z to A",
// "Amount low to high" => "Amount low to high",
// "Amount high to low" => "Amount high to low",
// "Payment: oldest first" => "Payment: oldest first",
// "Payment: newest first" => "Payment: newest first",
// "Request: oldest first" => "Request: oldest first",
// "Request: newest first" => "Request: newest first",
// "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter" => "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter",
// "Plugin paymentlist: Unrecognised type \"%0\"" => "Plugin paymentlist: Unrecognised type \"%0\"",
// "No payments found" => "No payments found",
// "Payments by anonymous where the payer's email is recorded" => "Payments by anonymous where the payer's email is recorded",
// "PayPal Button" => "PayPal Button",
// "Embed a PayPal button" => "Embed a PayPal button",
// "Type of PayPal button" => "Type of PayPal button",
// "Shopping cart" => "Shopping cart",
// "Buy Now" => "Buy Now",
// "Donations" => "Donations",
// "Cart Action" => "Cart Action",
// "Action if Shopping Cart selected for type" => "Action if Shopping Cart selected for type",
// "Add to Cart" => "Add to Cart",
// "View Cart" => "View Cart",
// "Item Name" => "Item Name",
// "Item name or description. Required for Shopping cart" => "Item name or description. Required for Shopping cart",
// "Item price" => "Item price",
// "Button appearance" => "Button appearance",
"Smaller" => "더 작게",
"Custom" => "사용자 지정",
// "Custom Button" => "Custom Button",
// "Custom button image URL" => "Custom button image URL",
// "Optional item identifier, often a tracker itemId" => "Optional item identifier, often a tracker itemId",
// "Number of items, empty or 0 to have an input the user can fill in" => "Number of items, empty or 0 to have an input the user can fill in",
// "Shipping Cost" => "Shipping Cost",
// "The cost of shipping this item" => "The cost of shipping this item",
// "Additional Shipping Cost" => "Additional Shipping Cost",
// "The cost of shipping each additional unit of this item" => "The cost of shipping each additional unit of this item",
// "Weight of item" => "Weight of item",
// "Weight Unit" => "Weight Unit",
// "The unit of measure if weight is specified" => "The unit of measure if weight is specified",
// "Kilos" => "Kilos",
// "Pounds" => "Pounds",
// "Business ID" => "Business ID",
// "PayPal business name/ID" => "PayPal business name/ID",
// "(Uses value in admin/payment if not set here)" => "(Uses value in admin/payment if not set here)",
// "Use MiniCart" => "Use MiniCart",
// "See https://github.com/jeffharrell/MiniCart" => "See https://github.com/jeffharrell/MiniCart",
// "Shipping Address Prompt" => "Shipping Address Prompt",
// "Indicate whether to prompt for and require an address" => "Indicate whether to prompt for and require an address",
// "Prompt for address" => "Prompt for address",
// "Do not prompt for address" => "Do not prompt for address",
// "Prompt for and require address" => "Prompt for and require address",
// "Completed payment return URL" => "Completed payment return URL",
// "Empty for current page, %0n%1 to disable" => "Empty for current page, %0n%1 to disable",
// "Continue Shopping URL" => "Continue Shopping URL",
// "Cancel payment URL" => "Cancel payment URL",
// "Form title" => "Form title",
// "Tooltip for the form and alt attribute for the image" => "Tooltip for the form and alt attribute for the image",
// "PayPal — The safer, easier way to pay online" => "PayPal — The safer, easier way to pay online",
// "Button text" => "Button text",
// "The checkout button text" => "The checkout button text",
// "Subtotal text" => "Subtotal text",
// "The subtotal text" => "The subtotal text",
// "Discount text" => "Discount text",
// "The discount text" => "The discount text",
// "Shipping text" => "Shipping text",
// "The shipping text" => "The shipping text",
// "Processing text" => "Processing text",
// "The processing text" => "The processing text",
// "PayPal button" => "PayPal button",
// "Item name (item_name) required" => "Item name (item_name) required",
// "Price (amount) required" => "Price (amount) required",
// "For customized PDF generation, to override global PDF settings" => "For customized PDF generation, to override global PDF settings",
// "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\" => "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\",
// "Generate table of contents" => "Generate table of contents",
// "Set if table of contents will be autogenerated before PDF content" => "Set if table of contents will be autogenerated before PDF content",
// "Link TOC headings with content on PDF document" => "Link TOC headings with content on PDF document",
// "Heading to be appeared before table of content is printed" => "Heading to be appeared before table of content is printed",
// "TOC levels" => "TOC levels",
// "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>" => "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>",
// "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page" => "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page",
// "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page" => "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page",
// "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly" => "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly",
// "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly" => "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly",
// "Generate PDF Bookmarks" => "Generate PDF Bookmarks",
// "Values H1-H6,separated by | <code>For example H1|H2|H3</code>" => "Values H1-H6,separated by | <code>For example H1|H2|H3</code>",
// "Secure confidential PDF with password, leave blank if password protected is not needed" => "Secure confidential PDF with password, leave blank if password protected is not needed",
// "Watermark text value, for example: Confidential, Draft etc. " => "Watermark text value, for example: Confidential, Draft etc. ",
// "Watermark image, enter full URL" => "Watermark image, enter full URL",
// "Full URL of watermark image" => "Full URL of watermark image",
// "Page background color" => "Page background color",
// "Page background image" => "Page background image",
// "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>" => "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>",
// "For pluginPDF, please select mpdf as default PDF engine from Print Settings" => "For pluginPDF, please select mpdf as default PDF engine from Print Settings",
// "Manual bookmark entry for a PDF file" => "Manual bookmark entry for a PDF file",
// "Bookmark Label" => "Bookmark Label",
// "Bookmark level" => "Bookmark level",
// "Insert page with new settings in PDF" => "Insert page with new settings in PDF",
// "Page Content" => "Page Content",
// "PDF page header text" => "PDF page header text",
// "PDF page footer text" => "PDF page footer text",
// "Watermark text for this page. Set value as \"off\", to turn off watermark of the page" => "Watermark text for this page. Set value as \"off\", to turn off watermark of the page",
// "Watermark text value, for example: Confidential, Draft etc" => "Watermark text value, for example: Confidential, Draft etc",
// "Watermark image, enter full url" => "Watermark image, enter full url",
// "To turn off watermark image on the page, set value as <code>off</code>" => "To turn off watermark image on the page, set value as <code>off</code>",
// "PluginPDF Page Break" => "PluginPDF Page Break",
// "Helpful to format PDF files created, plugin adds page break in PDF file generated" => "Helpful to format PDF files created, plugin adds page break in PDF file generated",
"Display content based on permission settings" => "권한 설정에 의거하여 컨텐츠를 표기",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions",
"Possible Permissions" => "가능한 권한",
// "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext" => "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext",
"Forbidden Permissions" => "금지된 권한",
// "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show" => "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show",
"Global" => "전역",
// "Indicate whether the permissions are global or local to the object" => "Indicate whether the permissions are global or local to the object",
// "Display content based on the user's current perspective" => "Display content based on the user's current perspective",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition",
"Allowed Perspectives" => "허용된 Perspectives",
"Pipe-separated list of identifiers of perspectives in which the block is shown" => "블럭이 표시되는 퍼스펙티브의 식별자들의 파이프로 구분된 목록",
"Denied Perspectives" => "거부된 Perspective",
// "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown" => "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown",
// "Pivot table" => "Pivot table",
// "Create and display data in pivot table for reporting" => "Create and display data in pivot table for reporting",
// "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on" => "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on",
// "Data source" => "Data source",
// "Override item permissions" => "Override item permissions",
// "Return all tracker items ignoring permissions to view the corresponding items" => "Return all tracker items ignoring permissions to view the corresponding items",
// "Width of pivot table. Units: % or px" => "Width of pivot table. Units: % or px",
// "Height of pivot table. Units: px" => "Height of pivot table. Units: px",
// "Pivot table Rows" => "Pivot table Rows",
// "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. " => "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. ",
// "Use permanentNames in case of tracker fields" => "Use permanentNames in case of tracker fields",
// "Separated by colon (:) if more than one" => "Separated by colon (:) if more than one",
// "Pivot table Columns" => "Pivot table Columns",
// "Which field or fields to use as table columns. Leaving blank will use the first available field" => "Which field or fields to use as table columns. Leaving blank will use the first available field",
// "Values used to decide what heatmapColors to use" => "Values used to decide what heatmapColors to use",
// "Color for each heatmapDomain value" => "Color for each heatmapDomain value",
// "Renderer Name" => "Renderer Name",
// "Display format of data" => "Display format of data",
// "Table Barchart" => "Table Barchart",
// "Heatmap" => "Heatmap",
// "Row Heatmap" => "Row Heatmap",
// "Col Heatmap" => "Col Heatmap",
// "Line Chart" => "Line Chart",
// "Bar Chart" => "Bar Chart",
// "Overlay Bar Chart" => "Overlay Bar Chart",
// "Stacked Bar Chart" => "Stacked Bar Chart",
// "Relative Bar Chart" => "Relative Bar Chart",
// "Boxplot Chart" => "Boxplot Chart",
// "Horizontal Boxplot Chart" => "Horizontal Boxplot Chart",
// "Area Chart" => "Area Chart",
// "Histogram" => "Histogram",
// "Density Histogram" => "Density Histogram",
// "Percent Histogram" => "Percent Histogram",
// "Probability Histogram" => "Probability Histogram",
// "Density Histogram Horizontal" => "Density Histogram Horizontal",
// "Percent Histogram Horizontal" => "Percent Histogram Horizontal",
// "Probability Histogram Horizontal" => "Probability Histogram Horizontal",
// "Horizontal Histogram" => "Horizontal Histogram",
// "Histogram2D" => "Histogram2D",
// "Density Histogram2D" => "Density Histogram2D",
// "Percent Histogram2D" => "Percent Histogram2D",
// "Probability Histogram2D" => "Probability Histogram2D",
// "Density Histogram2D Horizontal" => "Density Histogram2D Horizontal",
// "Percent Histogram2D Horizontal" => "Percent Histogram2D Horizontal",
// "Probability Histogram2D Horizontal" => "Probability Histogram2D Horizontal",
// "Horizontal Histogram2D" => "Horizontal Histogram2D",
// "Scatter Chart" => "Scatter Chart",
// "Treemap" => "Treemap",
// "Aggregator Name" => "Aggregator Name",
// "Function to apply on the numeric values from the variables selected" => "Function to apply on the numeric values from the variables selected",
// "Count Unique Values" => "Count Unique Values",
// "List Unique Values" => "List Unique Values",
// "Sum" => "Sum",
// "Integer Sum" => "Integer Sum",
// "Minimum" => "Minimum",
// "Sum over Sum" => "Sum over Sum",
// "80% Upper Bound" => "80% Upper Bound",
// "80% Lower Bound" => "80% Lower Bound",
// "Sum as Fraction of Total" => "Sum as Fraction of Total",
// "Sum as Fraction of Rows" => "Sum as Fraction of Rows",
// "Sum as Fraction of Columns" => "Sum as Fraction of Columns",
// "Count as Fraction of Total" => "Count as Fraction of Total",
// "Count as Fraction of Rows" => "Count as Fraction of Rows",
// "Count as Fraction of Columns" => "Count as Fraction of Columns",
"Values" => "값들",
// "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts" => "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts",
// "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function" => "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function",
// "Inclusions" => "Inclusions",
// "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings" => "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings",
// "Filter list limit" => "Filter list limit",
// "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row" => "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row",
// "Aggregate details" => "Aggregate details",
// "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string" => "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string",
// "Highlight my items" => "Highlight my items",
// "Highlight owned items' values in Charts" => "Highlight owned items' values in Charts",
// "Highlight my group items" => "Highlight my group items",
// "Highlight items' values belonging to one of my groups in Charts" => "Highlight items' values belonging to one of my groups in Charts",
// "Color for each highlighted group items" => "Color for each highlighted group items",
// "xAxis label" => "xAxis label",
// "Override label of horizontal axis when using Chart renderers" => "Override label of horizontal axis when using Chart renderers",
// "yAxis label" => "yAxis label",
// "Override label of vertical axis when using Chart renderers" => "Override label of vertical axis when using Chart renderers",
// "Chart title" => "Chart title",
// "Override title when using Chart renderers" => "Override title when using Chart renderers",
// "Chart hover bar" => "Chart hover bar",
// "Display the Chart hover bar or not" => "Display the Chart hover bar or not",
// "Translate displayed data" => "Translate displayed data",
// "Use translated data values for calculations and display" => "Use translated data values for calculations and display",
// "Default value: No" => "Default value: No",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>",
// "Missing data parameter with format: source:ID, e.g. tracker:1" => "Missing data parameter with format: source:ID, e.g. tracker:1",
// "Error data parameter" => "Error data parameter",
// "You do not have rights to view tracker data" => "You do not have rights to view tracker data",
// "Unified search index not found" => "Unified search index not found",
// "Split wiki modifier should specify a field" => "Split wiki modifier should specify a field",
// "For example 'tracker:1' or 'activitystream'" => "For example 'tracker:1' or 'activitystream'",
// "Piwik" => "Piwik",
// "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter" => "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter",
// "Piwik server url" => "Piwik server url",
// "The url to your Piwik Server, where data for the report are collected and available" => "The url to your Piwik Server, where data for the report are collected and available",
// "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users" => "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users",
// "The ID of this website in Piwik To be improved" => "The ID of this website in Piwik To be improved",
// "Module and Action To Widgetize" => "Module and Action To Widgetize",
// "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma" => "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma",
// "Actions - Pages" => "Actions - Pages",
// "Actions - Entry pages" => "Actions - Entry pages",
// "Actions - Exit pages" => "Actions - Exit pages",
// "Actions - Outlinks" => "Actions - Outlinks",
// "Dashboard" => "Dashboard",
// "Live - Visitor in real time" => "Live - Visitor in real time",
// "Live - Simple Last Visit Count" => "Live - Simple Last Visit Count",
// "Live - Visitor Profile Popup" => "Live - Visitor Profile Popup",
// "Referrers - All referrers" => "Referrers - All referrers",
// "Referrers - Search engines" => "Referrers - Search engines",
// "Resolution - Screen Resolution" => "Resolution - Screen Resolution",
// "SEO - SEO Ranking (slow)" => "SEO - SEO Ranking (slow)",
// "User Country Map - RealTime Map" => "User Country Map - RealTime Map",
// "User Country Map - Visitor Map" => "User Country Map - Visitor Map",
// "User Country Map - Country" => "User Country Map - Country",
// "User Country Map - Continent" => "User Country Map - Continent",
// "User Language - Language" => "User Language - Language",
// "User Language - Language Code" => "User Language - Language Code",
// "Visits Time - By day of the week" => "Visits Time - By day of the week",
// "Visits Time - Visit Information Per Local Time" => "Visits Time - Visit Information Per Local Time",
// "Visits Time - Visit Information Per Server Time" => "Visits Time - Visit Information Per Server Time",
// "Visits Summary - by day of the week" => "Visits Summary - by day of the week",
// "Visits Summary - over time" => "Visits Summary - over time",
// "Visits Summary - overview with graph" => "Visits Summary - overview with graph",
// "Visitors - Visitor map" => "Visitors - Visitor map",
// "Visitors - Pages per visit" => "Visitors - Pages per visit",
// "Visitors - Frequency overview" => "Visitors - Frequency overview",
// "Visitors - Returning visits over time" => "Visitors - Returning visits over time",
// "Visitor Devices - Device type" => "Visitor Devices - Device type",
// "Visitor Devices - browser" => "Visitor Devices - browser",
// "Visitor Devices - Browser Versions" => "Visitor Devices - Browser Versions",
// "Visitor Devices - OS Families" => "Visitor Devices - OS Families",
// "Visitor Devices - OS Versions" => "Visitor Devices - OS Versions",
// "Visitor Interest - Number Of Visits Per Visit Duration" => "Visitor Interest - Number Of Visits Per Visit Duration",
// "Visitor Interest - Number Of Visits Per Page" => "Visitor Interest - Number Of Visits Per Page",
// "Visitor Interest - Number Of Visits By Visit Count" => "Visitor Interest - Number Of Visits By Visit Count",
// "Visitor Interest - Number Of Visits By Days Since Last" => "Visitor Interest - Number Of Visits By Days Since Last",
// "Visitor Setting - Screen resolution" => "Visitor Setting - Screen resolution",
// "Statistics period" => "Statistics period",
// "Data display duration. If range is selected you must enter the start and end the date" => "Data display duration. If range is selected you must enter the start and end the date",
"Range" => "범위",
// "Date or Start date" => "Date or Start date",
// "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd" => "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd",
// "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)" => "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)",
// "Module width" => "Module width",
// "Optional, width of the module in px or % (100% by default)" => "Optional, width of the module in px or % (100% by default)",
// "Module height" => "Module height",
// "Optional, height of the module in px" => "Optional, height of the module in px",
// "Iframe Scrolling" => "Iframe Scrolling",
// "Optional, scrolling of the iframe that contain the module (no by default)" => "Optional, scrolling of the iframe that contain the module (no by default)",
// "Piwik javascript code" => "Piwik javascript code",
// "Define option for Piwik groups, include or exclude" => "Define option for Piwik groups, include or exclude",
// "Plugin Piwik error" => "Plugin Piwik error",
// "Piwik server url is required" => "Piwik server url is required",
// "Site Id is required" => "Site Id is required",
// "moduleToWidgetize is required" => "moduleToWidgetize is required",
// "Period set to range but no end date provided" => "Period set to range but no end date provided",
// "PlayScorm" => "PlayScorm",
// "Play a SCORM learning object in an iframe using Moodle" => "Play a SCORM learning object in an iframe using Moodle",
// "Numeric ID of a SCORM zip file in a File Gallery" => "Numeric ID of a SCORM zip file in a File Gallery",
// "Moodle URL" => "Moodle URL",
// "Web address of the Moodle instance" => "Web address of the Moodle instance",
// "Moodle Course ID" => "Moodle Course ID",
// "Course ID in Moodle to upload SCORM objects to" => "Course ID in Moodle to upload SCORM objects to",
// "Frame Width" => "Frame Width",
// "Frame Height" => "Frame Height",
// "Numeric ID" => "Numeric ID",
// "Numeric ID to distinguish multiple plugins of there is more than one" => "Numeric ID to distinguish multiple plugins of there is more than one",
"Either the module or plugin parameter must be set, but not both" => "모듈의 혹은 플러그인의 매개변수가 반드시 설정되어야만 합니다, 하지만 둘 다는 아닙니다",
"Plugin Manager error: %0%1 not found" => "플러그인 관리자 오류: %0%1 발견되지 않음",
"Plugin Manager error: %0%1%2%3%4 not found" => "플러그인 관리자 오류: %0%1%2%3%4 발견되지 않음",
"Plugin Manager error:  %0%1 not found" => "플러그인 관리자 오류: %0%1 발견되지 않음",
"Options" => "선택사항",
"Accepted Values" => "수락된 값",
"(body of plugin)" => "(플러그인의 본문)",
// "%0separator:%1 " => "%0separator:%1 ",
"(blank)" => "(비어있음)",
"any string except for HTML and PHP tags" => "HTML 과 PHP 태그에 제외한 어떤 문자열",
"Since" => "이후",
"no parameters" => "매개 변수 없음",
"Preferences required" => "기본 설정이 필요합니다",
// "Introduced in %0" => "Introduced in %0",
"Required parameters are in%0 %1bold%2" => "필수 매개 변수는 다음 내부의 %0 %1굵은체%2",
"Plugin Manager" => "플러그인 관리자",
"List wiki plugin or module information for the site" => "위키 플러그인 혹은 사이트에 대한 모듈 정보 나열",
"Information" => "정보",
// "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1" => "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1",
"One or more of: description | parameters | paraminfo" => "하나 혹은 그 이상: 설명 | 매개 변수 |매개  변수정보",
"Description and Parameters" => "설명과 매개 변수",
"Description & Parameter Info" => "설명과 매개 변수 정보",
"Parameters & Parameter Info" => "매개 변수 & 매개 변수 정보",
"Plugin" => "플러그인",
// "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter" => "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter",
// "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter" => "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter",
"Single Title" => "한 개의 제목",
"Set placement of plugin name and description when displaying information for only one plugin" => "한 플러그인에 대한 정보를 표시할 때 플러그인명과 설명의 위치를 설정하십시오",
"Title Heading" => "타이틀 제목",
// "Sets the heading size for the title, e.g., %0h2%1" => "Sets the heading size for the title, e.g., %0h2%1",
"Start with this plugin record number (must be an integer 1 or greater)" => "이 플러그인 숫자로 시작 (정수 1 혹은 그 이상이어야만 함)",
// "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater",
// "Parameter Type" => "Parameter Type",
// "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions" => "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions",
// "Show Parameter Type" => "Show Parameter Type",
// "Show the parameter %0doctype%1 value" => "Show the parameter %0doctype%1 value",
// "Show Top Info" => "Show Top Info",
// "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default" => "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default",
"Poll" => "설문",
// "Embed a poll" => "Embed a poll",
// "Title of the poll" => "Title of the poll",
"Numeric value representing the poll ID" => "투표 ID를 나타내는 숫자 값",
"Show poll title (shown by default)" => "투표 제목 표시 (기본으로 표시됨)",
"Show result" => "결과 표시",
// "Set how results of the poll will be shown (default is %0link%1)" => "Set how results of the poll will be shown (default is %0link%1)",
// "Voted" => "Voted",
"Show total votes" => "전체 투표 표시",
// "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)" => "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)",
"Preference" => "기본설정",
// "Display content based on global preference settings" => "Display content based on global preference settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions",
// "Document Preferences" => "Document Preferences",
// "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)" => "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)",
// "Preference-Tab" => "Preference-Tab",
// "The name of the preference tab to display, or a list of available tabs upon invalid" => "The name of the preference tab to display, or a list of available tabs upon invalid",
// "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2" => "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2",
"Pretty Tracker View Tracking" => "프리티 트래커 보기 트래킹",
// "PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Store tiki.tracker.pretty.views attribute for a trackeritem" => "Store tiki.tracker.pretty.views attribute for a trackeritem",
// "Set to %0y%1 to record view each time this is loaded" => "Set to %0y%1 to record view each time this is loaded",
// "Set to %0n%1 to hide showing of attribute" => "Set to %0n%1 to hide showing of attribute",
"Set to ID of tracker item" => "트래커항목의 ID로 설정",
// "Preview Files" => "Preview Files",
// "Enabled to generate preview of images or video files" => "Enabled to generate preview of images or video files",
// "Id of the file in the file gallery" => "Id of the file in the file gallery",
// "Animation" => "Animation",
// "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)" => "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)",
// "Width of the result in pixels" => "Width of the result in pixels",
// "Height of the result in pixels" => "Height of the result in pixels",
// "Show download link to the original file" => "Show download link to the original file",
"Profile Application" => "프로필 응용프로그램",
"Add a button for applying a profile" => "프로필을 적용하기 위한 버튼 추가",
// "Profile repository domain. Default value is %0profiles.tiki.org%1" => "Profile repository domain. Default value is %0profiles.tiki.org%1",
"Profile Name" => "프로필명",
"Name of the profile to be applied" => "적용될 프로필명",
"Profile plugin only available to administrators" => "관리자에게만 제공되는 프로필 플러그인",
"Profile %0/%1 not found" => "%0/%1 프로필 발견되지 않음",
// "Profile Symbol Value" => "Profile Symbol Value",
// "Display the profile symbol related with profile and a reference and optionally with domain or package" => "Display the profile symbol related with profile and a reference and optionally with domain or package",
// "Reference key" => "Reference key",
// "Reference name" => "Reference name",
// "Package" => "Package",
// "Package extension name" => "Package extension name",
"Proposal" => "제안",
"Allow users to vote on a proposal and view the results" => "사용자가 제안에 투표하고 결과를 보는 것을 허용",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "진행된 투표의 목록. 한 줄 당 한 표. 0, +1 혹은 -1 중 하나이며 뒤에 사용자명이 옴",
// "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable" => "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable",
"Weights" => "무게",
// "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example" => "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example",
"Accept proposal" => "제안 승인",
"Still undecided" => "아직 결정 안됨",
"Reject proposal" => "제안 거부",
"Quote" => "인용",
"Format text as a quote" => "인용으로써 텍스트 서식 적용",
"Quoted text" => "인용된 텍스트",
"Reply To" => "다음으로 회신",
"Name of the quoted person" => "인용된 사람의 이름",
// "Thread Id for Forum replies" => "Thread Id for Forum replies",
// "The thread Id of the comment being replied to in forums. Overwrites replyto" => "The thread Id of the comment being replied to in forums. Overwrites replyto",
// "Source URL" => "Source URL",
// "The URL to the source quoted" => "The URL to the source quoted",
// "Date when the statement quoted was made" => "Date when the statement quoted was made",
// "YYYY-MM-DD" => "YYYY-MM-DD",
// "R syntax" => "R syntax",
// "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms" => "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms",
"Random Include" => "무작위 포함",
"Include a random page's content" => "임의의 페이지의 컨텐츠를 포함",
"Random Dynamic Content" => "무작위 유동 컨텐츠",
"Display pre-programmed changing content" => "사전 프로그램된 변화하는 컨텐츠 표시",
"Numeric value representing the content ID" => "컨텐츠 ID를 나타내는 숫자 값",
"User List with Real Names" => "실명으로된 사용자 목록",
"Show user real names for members of a group" => "그룹의 구성원에 대하여 사용자 실명을 표기",
// "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included",
"Result limit" => "결과 한도",
"Set to sort in ascending or descending order (unsorted by default" => "정렬을 오름차순 혹은 내림차순으로 설정 (기본으로는 정렬되지 않음",
"Make the listed names links to various types of user information" => "나열된 이름들을 사용자 정보의 다양한 유형으로의 링크로 만듭니다",
"User Page" => "사용자 페이지",
"User Preferences" => "사용자 선호설정",
"Exclude" => "제외",
"Exclude certain test or admin names from the list" => "목록에서 특정 테스트 혹은 관리자 이름 제외",
"admin" => "관리",
"admin-test" => "관리-테스트",
"test" => "테스트",
"test-admin" => "테스트-관리",
"Preferences" => "선호설정",
"Redirect" => "리디렉션",
"Redirect to another page." => "다른 페이지로 리디렉션",
"Wiki page name to redirect to" => "다음으로 넘겨질 위키 페이지 이름",
"Complete URL, internal or external" => "전체 URL, 내부 혹은 외부",
"The ID of a perspective to switch to (requires feature_perspective)" => "변경할 퍼스펙티브의 ID (feature_perspective 이 필요)",
// "Auto login remote Tiki and redirect to page there" => "Auto login remote Tiki and redirect to page there",
// "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com" => "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com",
"perspective " => "퍼스펙티브",
// "nowhere" => "nowhere",
// "Remote system error" => "Remote system error",
"REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT 플러그인: 페이지를 저장한 직후에는 '%s' 로 리디렉션이 비활성화되어 있습니다is disabled just after saving the page",
"REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT 플러그인: '%s' 로 리디렉션은 미리 보기 모드에서 비활성화되어 있습니다.",
"REDIRECT plugin: redirect loop detected" => "REDIRECT 플러그인: 리디렉션 루프 감지됨",
"Regular Expression" => "일반 정규식",
"Perform a regular expression search and replace" => "일반 표현 검색과 교체 수행",
"Each line of content is evaluated separately" => "내용물의 각 줄은 구분되어 평가됩니다",
// "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page" => "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page",
"Register Member Payment" => "구성원 지불 등록",
// "Register and make a member payment at the same time" => "Register and make a member payment at the same time",
// "NA" => "NA",
"Fixed Periods" => "수정된 기간",
// "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample" => "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample",
"Insufficient Privileges" => "불충분한 권한",
"Submit" => "제출",
"You will be redirected in 5 seconds" => "5초 내에 리다이렉트 됩니다",
// "Display the relation of an object to the rest of the site" => "Display the relation of an object to the rest of the site",
"Qualifiers" => "한정자",
"Comma-separated list of relation qualifiers" => "연관 한정자의 쉼표로 구분된 목록",
// "Object identifier as %0type:itemId%1" => "Object identifier as %0type:itemId%1",
"Single List" => "한 개의 목록",
"Render all qualifiers into a single list without displaying the qualifier name" => "모든 한정자를 한정자명을 표시하지 않고 한 개의 목록으로 렌더",
// "Empty Message" => "Empty Message",
// "Message to give if result is empty and no relations are found" => "Message to give if result is empty and no relations are found",
"Remarks Box" => "설명 상자",
// "Display a comment, tip, note or warning box" => "Display a comment, tip, note or warning box",
"remarks text" => "설명 텍스트",
"Select type of remarksbox, which determines what icon and style will be displayed" => "알림상자의 유형을 선택하십시오, 이는 어떤 아이콘과 스타일이 표시될 것인지를 결정합니다",
"Confirm" => "확인",
"Tip" => "팁",
"Label displayed above the remark" => "설명 위에 표시될 레이블",
"Use the highlight class for formatting (not used by default)" => "서식적용을 위한 강조보기 클래스 사용 (기본으로 사용되지 않음)",
"Custom Icon" => "사용자 지정 아이콘",
"Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)" => "사용자 지정 아이콘을 표시할 티키 아이콘 파일명 (확장자와 함께 혹은 없이) 혹은 경로를 입력하십시오",
"Show a close button (not shown by default)" => "닫기 버튼 표시 (기본으로 보이지 않음)",
// "Width (e.g. %0100%%1 or %0250px%1 - default \"\")" => "Width (e.g. %0100%%1 or %0250px%1 - default \"\")",
// "Remember Dismiss" => "Remember Dismiss",
// "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set" => "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set",
// "Sets an HTML id for the account" => "Sets an HTML id for the account",
// "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter" => "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter",
// "RR (R syntax also)" => "RR (R syntax also)",
// "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call" => "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call",
// "R Code" => "R Code",
// "echo" => "echo",
// "Show a code block with the R commands to be run before running them (similarly to the echo command)" => "Show a code block with the R commands to be run before running them (similarly to the echo command)",
// "echo debug" => "echo debug",
// "Show a code block with the R commands to be run even if the R program fails to execute" => "Show a code block with the R commands to be run even if the R program fails to execute",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "wikisyntax" => "wikisyntax",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
"width" => "넓이",
// "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio" => "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio",
"height" => "높이",
// "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio" => "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio",
// "units" => "units",
// "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm" => "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm",
// "pointsize" => "pointsize",
// "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger" => "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger",
// "bg" => "bg",
// "The initial background colour (optional). Options: white, yellow, grey, ... and transparent" => "The initial background colour (optional). Options: white, yellow, grey, ... and transparent",
// "parse_body" => "parse_body",
// "parses the body content to allow data to be generated from other plugins" => "parses the body content to allow data to be generated from other plugins",
// "res" => "res",
// "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much" => "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much",
// "svg" => "svg",
// "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "pdf" => "pdf",
// "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "onefile" => "onefile",
// "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file" => "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file",
// "LoadAndSave" => "LoadAndSave",
// "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages" => "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages",
// "Caching strategy" => "Caching strategy",
// "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin" => "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin",
// "Limit cache duration" => "Limit cache duration",
// "Force cache recalculation after time limit. Default: No limit" => "Force cache recalculation after time limit. Default: No limit",
// "CacheBy" => "CacheBy",
// "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)" => "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)",
// "Page Name (pagename)" => "Page Name (pagename)",
// "Page Id (pageid)" => "Page Id (pageid)",
// "Cache age" => "Cache age",
// "Display cache last modification date below the graph (default option: do not display)" => "Display cache last modification date below the graph (default option: do not display)",
// "attId" => "attId",
// "AttId from a tracker Item attachment. ex: 1. (Optional)" => "AttId from a tracker Item attachment. ex: 1. (Optional)",
// "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required" => "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required",
// "csv" => "csv",
// "xml" => "xml",
// "x11" => "x11",
// "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()" => "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()",
// "removen" => "removen",
// "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)" => "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)",
// "Custom output" => "Custom output",
// "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file" => "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file",
// "security" => "security",
// "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)" => "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)",
// "Cache was last modified: %0" => "Cache was last modified: %0",
// "One cache per plugin" => "One cache per plugin",
// "One cache per plugin per user" => "One cache per plugin per user",
// "No caching: Ignore and replace existing cache, if any" => "No caching: Ignore and replace existing cache, if any",
// "No limit" => "No limit",
// "1 hour" => "1 hour",
// "1 day" => "1 day",
// "7 days" => "7 days",
// "30 days" => "30 days",
// "365 days" => "365 days",
// "Don't display cache creation date" => "Don't display cache creation date",
// "Display cache creation date" => "Display cache creation date",
// "Blocked commands found: " => "Blocked commands found: ",
// "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you" => "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you",
// "command unavailable" => "command unavailable",
// "The __R__ package needs to be installed on the server" => "The __R__ package needs to be installed on the server",
// "See requirements on [https://doc.tiki.org/PluginR]" => "See requirements on [https://doc.tiki.org/PluginR]",
// "The path to the __R__ command could not be found on your system" => "The path to the __R__ command could not be found on your system",
// "Maybe this file is inaccessible due to safe mode restrictions" => "Maybe this file is inaccessible due to safe mode restrictions",
// "The path to the __convert__ command could not be found on your system" => "The path to the __convert__ command could not be found on your system",
// "You need to ensure that you have __imagemagick__ installed successfully on the server" => "You need to ensure that you have __imagemagick__ installed successfully on the server",
// "Cached R output from %0. If you click, you will re-run all R scripts in this page" => "Cached R output from %0. If you click, you will re-run all R scripts in this page",
// "Save Image as SVG" => "Save Image as SVG",
// "Save Image as PDF" => "Save Image as PDF",
// "plot" => "plot",
"RSS Feed" => "RSS 피드",
// "Display items from one or more RSS feeds" => "Display items from one or more RSS feeds",
"IDs" => "ID들",
// "List of feed IDs separated by colons. ex: %0" => "List of feed IDs separated by colons. ex: %0",
"Result Count" => "결과 수",
"Number of results displayed" => "표기될 결과의 수",
"Show date of each item (not shown by default)" => "각 항목의 날짜 보기 (기본으로 보이지 않음)",
"Show feed descriptions (not shown by default)" => "피드 설명 보기 (기본으로 보이지 않음)",
"Show authors (not shown by default)" => "저자 표시 (기본으로 표시되지 않음)",
"URL to a favicon to put before each entry" => "각 입력 전에 둘 favicon 으로의 URL",
"Show the title of the feed (shown by default)" => "피드의 제목 표시 (기본으로 표시됨)",
// "Ticker" => "Ticker",
"Turn static feed display into ticker news like" => "정적 피드 표시를 다음과 같은 티커 뉴스로 변환",
"Description Length" => "설명 길이",
"Max characters/length, truncates text to fit design" => "최대 문자/길이, 디자인에 맞게 텍스트 자름",
"Scroll" => "스크롤",
"Show animated text that scrolls up or down" => "위나 아래로 스크롤하는 움직이는 텍스트 표시",
// "Width in pixels. Example: %0" => "Width in pixels. Example: %0",
// "Number of pixels followed by \"px\"" => "Number of pixels followed by \"px\"",
// "Height in pixels. Example: %0" => "Height in pixels. Example: %0",
// "Scroll speed in number of seconds (default is %0)" => "Scroll speed in number of seconds (default is %0)",
"SourceForge" => "소스포지",
"Creates a link to SourceForge tracker items" => "소스포지 트래커 항목으로 링크 만듬",
"Group ID" => "그룹 ID",
"SourceForge project ID (shows as group_id in the URL of a tracker item" => "소스포지 프로젝트 ID (트래커 항목의 URL 내부에 group_id 로 표시",
"SourceForge tracker ID (shows as atid in the URL of a tracker item" => "소스포지 트래커 ID (트래커 항목의 URL 내부에 atid로 표시됨",
"SourceForge item ID (shows as aid in the URL of a tracker item" => "소스포지 항목 ID (트래커 항목의 URL 내부에 aid로 표시",
"Link title" => "링크 제목",
// "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)",
"ShareThis" => "이것공유",
"Add a ShareThis button" => "이것공유 버튼을 추가",
"Send Services" => "서비스 전송",
// "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services" => "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services",
"AIM" => "목표",
// "AIM and Email" => "AIM and Email",
// "AIM and SMS" => "AIM and SMS",
// "Email and SMS" => "Email and SMS",
"Button Style" => "버튼 스타일",
// "Set button style" => "Set button style",
"Rotate Image" => "그림 회전",
// "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping" => "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping",
"Multiple Icons" => "다중 아이콘",
// "Enter pipe-separated list of services, e.g., %0" => "Enter pipe-separated list of services, e.g., %0",
"First Services Shown" => "첫 서비스 보임",
// "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget",
"Custom link text for the button" => "버튼에 대한 사용자 지정 링크 텍스트",
"Header Title" => "헤더 제목",
"Optional header title text for the widget" => "위젯에 대한 선택적 헤더 제목 텍스트",
"Header Background" => "헤더 배경",
// "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used" => "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used",
"Header Text Color" => "헤더 텍스트 색상",
"HTML color code (not color name) for the header text if an optional header title is used" => "선택적 헤더 제목이 사용되었을 때, 헤더 텍스트에 대한 HTML 색상 코드 (색상명이 아님)",
"Link text color for services" => "서비스 용 링크 텍스트 색상",
"HTML color code (not color name) for the link text for all send and post services shown in the widget" => "선택적 헤더 제목이 사용되었을 때, 모든 전송 및 게시물에 대한 링크 텍스트에 대한 HTML 색상 코드 (색상명이 아님)",
// "Set whether the widget will show in a popup window" => "Set whether the widget will show in a popup window",
"Embedded Elements" => "임베드된 요소",
// "Allow embedded elements (like flash) to be seen while iframe is loading" => "Allow embedded elements (like flash) to be seen while iframe is loading",
"Sheet" => "시트",
"Display data from a TikiSheet" => "티키시트에서의 데이터 표시",
"Spreadsheet Heading" => "시트 제목",
// "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required" => "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required",
"Sheet Url Location" => "시트 URL 위치",
// "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired" => "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired",
// "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)" => "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1" => "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1",
"Height in pixels or percentage. Default value is complete spreadsheet height" => "픽셀단위 혹은 백분율의 높이. 기본값은 완전한 스프레드시트 높이",
// "Show edit button. Default is to show depending on user's permissions" => "Show edit button. Default is to show depending on user's permissions",
"Show subsheets" => "서브시트 표시",
// "Show multi-sheets (default is to show)" => "Show multi-sheets (default is to show)",
// "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1" => "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1",
"Apply custom CSS class to the containing div" => "사용자 지정 CSS 클래스를 포함하는 div에 적용",
"New sheet in page: " => "페이지에 새 시트",
"Create New Sheet" => "새 시트 만들기",
"Error loading spreadsheet" => "스프레드시트 로딩 오류",
"Edit Sheet" => "시트 편집",
"Collect Anonymous Shopper Info" => "익명 쇼핑교객 정보 수집",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect shopper information for the shopping cart" => "Collect shopper information for the shopping cart",
"Values to be collected" => "수집될 값",
"Names of values to be collected separated by : as defined in shopper profile" => "구매자 프로필에 정의된 바 수집될 값들의 이름은 : 로 구분됨",
"Labels for the values to be collected" => "수집될 값들에 대한 레이블",
// "Labels of the values to be collected separated by a colon" => "Labels of the values to be collected separated by a colon",
"Show even if logged in" => "르그인되었어도 보기",
"Normally this is used for anonymous users but sometimes may be used when logged in also" => "보통 이는 익명사용자에 대하여 사용됩니다만 종종 로그인된 사용자에게도 사용됩니다",
// "Shorten" => "Shorten",
// "Show/hide a portion of text" => "Show/hide a portion of text",
// "Char length of always visible portion of text" => "Char length of always visible portion of text",
// "More text" => "More text",
// "A label indicating the text is expandable" => "A label indicating the text is expandable",
// "Less text" => "Less text",
// "A label for collapse text action" => "A label for collapse text action",
"Show Pages" => "표이지 표시",
"Find pages by searching within page names" => "페이지명 내부를 검색함으로써 페이지 찾기",
"Search criteria" => "검색 조건",
"Maximum amount of results displayed" => "표시될 결과의 최대양",
"Display page name and/or description. Both displayed by default" => "페이지 이름 및 설명 표시. 기본으로 두 개 다 표시됨",
"Name & Description" => "이름과 설명",
// "Show Preference" => "Show Preference",
// "Display the value of public global preferences" => "Display the value of public global preferences",
// "Name of preference to be displayed" => "Name of preference to be displayed",
"Add Bibliography" => "참고 문헌 추가",
// "Add bibliography listing in the footer of a wiki page" => "Add bibliography listing in the footer of a wiki page",
// "Title to be displayed in the bibliography listing. Default is %0Bibliography%1" => "Title to be displayed in the bibliography listing. Default is %0Bibliography%1",
"Show bibliography title. Title is shown by default" => "참고 문헌 제목 표시. 제목은 기본으로 표시됨",
"Header Tag" => "헤더 태그",
// "The HTML header tag level of the title. Default: %01%1" => "The HTML header tag level of the title. Default: %01%1",
// "Remove the lines around the list of references" => "Remove the lines around the list of references",
// "Remove the horizontal lines displayed above and below the list of references" => "Remove the horizontal lines displayed above and below the list of references",
// "Page identifier" => "Page identifier",
// "Provide the page id" => "Provide the page id",
"Bibliography" => "참고문헌",
"Signature" => "서명",
// "Sign and date your contribution to a page" => "Sign and date your contribution to a page",
"Auto-generated, the username" => "자동 생성된, 사용자명",
"Date and time" => "날짜와 시간",
"Auto-generated, the timestamp" => "자동 생성된, 타임스탬프",
"Skype" => "스카이프",
// "Add a link for calling or chating with a Skype user" => "Add a link for calling or chating with a Skype user",
"Name or number to call or chat with" => "통화하거나 채팅을 할 이름 혹은 숫자",
"Set whether to call or chat. Default is chat" => "통화 혹은 채팅할 것인지를 설정. 기본은 채팅",
"Call" => "호출",
"Chat" => "대화",
"Show status" => "상태 표시",
// "Show a status icon or not i.e. if online/offline/etc. Default is to not show status" => "Show a status icon or not i.e. if online/offline/etc. Default is to not show status",
"yes" => "예",
// "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web" => "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web",
"click to" => "다음을 하려면 클릭",
"Slider" => "슬라이더",
// "Embed a mini-slideshow of content on a page" => "Embed a mini-slideshow of content on a page",
"Content separated by \"/////\"" => "컨텐츠는 ///// 로 구분됩니다",
"Slider Titles" => "슬라이더 제목",
// "Pipe-separated list of slider titles. Example" => "Pipe-separated list of slider titles. Example",
// "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels" => "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels",
"The theme to use in slider" => "슬라이더에 사용될 테마",
"Expand" => "확장",
// "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set" => "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set",
// "Resize" => "Resize",
// "Set whether solitary images/objects in the panel will be expanded to fit the viewport" => "Set whether solitary images/objects in the panel will be expanded to fit the viewport",
"Show Multiple" => "다중 표시",
"Set this value to a number and it will show that many slides at once" => "이 값을 한 숫자에 설정하면 그 만큼 동시에 보이게 됨",
// "Arrows" => "Arrows",
// "Set whether to show forward and backward buttons" => "Set whether to show forward and backward buttons",
"Navigation" => "탐색",
// "Set whether to show a list of anchor links to link to each panel" => "Set whether to show a list of anchor links to link to each panel",
// "Start / Stop" => "Start / Stop",
// "Set whether to show a start/stop button and add slideshow functionality" => "Set whether to show a start/stop button and add slideshow functionality",
"Toggle Arrows" => "토글 화살표",
// "Set whether side navigation arrows slide out on hovering and hide at other times" => "Set whether side navigation arrows slide out on hovering and hide at other times",
"Toggle Controls" => "제어 토글",
// "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times" => "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times",
"Enable Arrows" => "화살표 활성화",
// "Set whether arrows are clickable" => "Set whether arrows are clickable",
"Enable Navigation" => "탐색 활성화",
// "Set whether navigation links are clickable" => "Set whether navigation links are clickable",
"Enable Start Stop" => "시작 정지 활성화",
// "Set whether the play/stop button is clickable. Previously %0" => "Set whether the play/stop button is clickable. Previously %0",
"Enable Keyboard" => "키보드 활성화",
// "Set whether keyboard arrow keys will work for this slider" => "Set whether keyboard arrow keys will work for this slider",
"Auto Play" => "자동 재생",
// "Set whether the slideshow will start running automatically; replaces %0 option" => "Set whether the slideshow will start running automatically; replaces %0 option",
"Auto Play Locked" => "자동 재생 잠금",
// "Keep playing the slideshow even if the user changes slides" => "Keep playing the slideshow even if the user changes slides",
"Auto Play Delayed" => "자동 재생 지연됨",
// "Set whether there will be a delay in advancing slides" => "Set whether there will be a delay in advancing slides",
"Pause On Hover" => "Hover 상에 일시정지",
// "Set whether the slideshow will pause on hover while the slideshow is active" => "Set whether the slideshow will pause on hover while the slideshow is active",
"Stop At End" => "마지막에 중지",
// "Set whether the slideshow stops on the last page" => "Set whether the slideshow stops on the last page",
"Delay between slides" => "슬라이드 간 지연",
"Time in milliseconds between slideshow transitions (in AutoPlay mode)" => "슬라이드쇼 전이 사이의 초단위 시간 (자동재생 모드 내부)",
// "Right To Left" => "Right To Left",
// "Set whether the slideshow moves right-to-left" => "Set whether the slideshow moves right-to-left",
"Resume On Video End" => "동영상 끝에서 재시작",
// "Set whether auto play stops until the video is complete (for supported video types)" => "Set whether auto play stops until the video is complete (for supported video types)",
"Animation Time" => "애니메이션 시간",
"Milliseconds between slides" => "슬라이드 사이의 밀리초",
// "Panel Hashtags" => "Panel Hashtags",
// "Set whether to include a hashtag in the page URL, allowing links to specific panels" => "Set whether to include a hashtag in the page URL, allowing links to specific panels",
// "Create a slideshow from the content of a wiki page" => "Create a slideshow from the content of a wiki page",
// "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI",
// "Parallax Background Image" => "Parallax Background Image",
// "URL of the background image to use in your slideshow, overrides %0" => "URL of the background image to use in your slideshow, overrides %0",
"Valid URL" => "유효한 url",
// "Parallax Background Size" => "Parallax Background Size",
// "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)" => "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)",
// "Parallax Background Horizontal" => "Parallax Background Horizontal",
// "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis" => "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis",
// "Parallax Background Vertical" => "Parallax Background Vertical",
// "Transition" => "Transition",
// " Transition style" => " Transition style",
// "Transition Speed" => "Transition Speed",
// "Background Transition" => "Background Transition",
// "Transition style for full page slide backgrounds" => "Transition style for full page slide backgrounds",
// "Display presentation control arrows" => "Display presentation control arrows",
// "Controls Layout" => "Controls Layout",
// "Determines where controls appear, \"edges\" or \"bottom-right\"" => "Determines where controls appear, \"edges\" or \"bottom-right\"",
// "Controls Back Arrows" => "Controls Back Arrows",
// "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"" => "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"",
// "Progress" => "Progress",
// "Display a presentation progress bar" => "Display a presentation progress bar",
// "Slide Number" => "Slide Number",
// "Display the page number of the current slide" => "Display the page number of the current slide",
// "Fragments" => "Fragments",
// "Turns fragments on and off globally" => "Turns fragments on and off globally",
// "Fragment Effects" => "Fragment Effects",
// "Fragment Highlight Color" => "Fragment Highlight Color",
// "Auto Slide" => "Auto Slide",
// "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides" => "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides",
// "Auto Slide Stoppable" => "Auto Slide Stoppable",
// "Stop auto-sliding after user input" => "Stop auto-sliding after user input",
// "Auto-align Images" => "Auto-align Images",
// "Automatically move images to left hand side of slide text, will only align images greater than 200px in width" => "Automatically move images to left hand side of slide text, will only align images greater than 200px in width",
// "Start Slideshow Presentation" => "Start Slideshow Presentation",
// "SlideshowSlide" => "SlideshowSlide",
// "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings" => "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings",
// "Enter content of slide" => "Enter content of slide",
// "Slide Background color" => "Slide Background color",
// "Set background color for slide" => "Set background color for slide",
// "Slide Text color" => "Slide Text color",
// "Set Text color for slide" => "Set Text color for slide",
// "Background Video URL" => "Background Video URL",
// "Automatically plays a full size video behind the slide" => "Automatically plays a full size video behind the slide",
// "Mute Background Video" => "Mute Background Video",
// "Flags if the audio should be muted for background video" => "Flags if the audio should be muted for background video",
// "Loop Background Video" => "Loop Background Video",
// "Flags if the background video played in loop" => "Flags if the background video played in loop",
// "Transition In" => "Transition In",
// "Select entry transition effect for slide" => "Select entry transition effect for slide",
// "Transition Out" => "Transition Out",
// "Select exit transition effect for slide" => "Select exit transition effect for slide",
"Smarty function" => "스마티 함수",
// "Insert a Smarty function or variable" => "Insert a Smarty function or variable",
// "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1" => "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1",
// "Snarf" => "Snarf",
"Display the contents of another web page" => "다른 웹페이지의 컨텐츠 표시",
"Full URL to the page to include" => "포함할 페이지로의 전체 URL",
"Regular Expression Pattern" => "일반 정규식 패턴",
"PCRE-compliant regular expression pattern to find the parts you want changed" => "변경을 원하는 부분을 찾기 위한  PCRE-규격 정규 표현식 패턴",
"Regular Expression Replacement" => "일반 정규식 교체",
"PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "어떤 컨텐츠가 변경되어야를 표시하는 PCRE-규격 정규 표현식 교체 문법",
"Enable/disable word wrapping of snippets of code (enabled by default)" => "코드 조각의 자동 줄바꿈을 사용/사용 안 함 (기본으로 사용함)",
// "Syntax highlighting to use for code snippets (Plugin Code is used for this)" => "Syntax highlighting to use for code snippets (Plugin Code is used for this)",
// "Set to Yes (%0) to add line numbers to code snippets (not shown by default)" => "Set to Yes (%0) to add line numbers to code snippets (not shown by default)",
"Parse wiki syntax within the code snippet (not parsed by default)" => "코드 조각 내부의 위키 문법을 구문분석 (기본으로 구문분석되지 않음)",
"Switch the text display from left to right to right to left" => "텍스트 표시를 좌에서 우 대신 우에서 좌로 전환",
"HTML Content" => "HTML 컨텐츠",
// "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)" => "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)",
"Cache URL" => "URL 캐시",
// "Cache time in minutes. Default is to use site preference, Set to %0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to %0 for no cache",
"Text to click on to fetch the URL via Ajax" => "AJAX 를 통하여 URL 을 가져오기 위해 클릭될 텍스트",
"Sort lines of text" => "텍스트 줄 정렬",
"Data to sort, one entry per line" => "정렬할 데이터, 한 줄 당 한 개의 입력",
"Order" => "순서",
"Set the sort order of lines of content (default is ascending)" => "컨텐츠의 줄의 정렬 순서 설정 (기본은 오름차순)",
"Reverse" => "역",
"Shuffle" => "섞기",
// "Arrange content on a page into rows and columns" => "Arrange content on a page into rows and columns",
// "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Generate the colspan attribute if columns are missing" => "열이 없는 경우 colspan 속성을 생성",
"Fixed Size" => "수정된 크기",
"Generate the width attribute for the columns" => "열에 대한 넓이 속성을 생성",
// "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)" => "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)",
// "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns",
// "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1" => "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1",
// "SQL" => "SQL",
"Query a MySQL database and display the results" => "MySQL 데이터베이스를 질의하고 결과를 표시",
// "The SQL query goes in the body. Example: " => "The SQL query goes in the body. Example: ",
"DSN Name" => "DSN 이름",
// "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0" => "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0",
"Raw return" => "원형 반환",
// "Return with table formatting (default) or raw data with no table formatting" => "Return with table formatting (default) or raw data with no table formatting",
// "Raw" => "Raw",
// "Delim" => "Delim",
// "The delimiter to be used between data elements (sets %0)" => "The delimiter to be used between data elements (sets %0)",
// "Turn wiki parsing of select results on and off (default is on)" => "Turn wiki parsing of select results on and off (default is on)",
"Missing db param" => "없는 DB 매개변수",
"Could not obtain valid DSN connection" => "유효한 DSN 연결을 얻을 수 없었습니다",
"Stat" => "시작",
"Show various statistics for an object" => "개체에 대한 다양한 통계 표시",
// "Colon-separated list of object type to show stats for" => "Colon-separated list of object type to show stats for",
"Article & Tracker Item" => "기사 및 트래커 항목",
"Article & Tracker Item & Wiki" => "기사 및 트래커 항목 및 위키",
"Article & Wiki" => "기사 및 위키",
"Article & Wiki & Tracker Item" => "기사 및 위키 및 트래커 항목",
"Tracker Item & Article" => "트래커 항목과 기사",
"Tracker Item & Article & Wiki" => "트래커 항목과 기사와 위키",
"Tracker Item & Wiki" => "트래커 항목과 위키",
"Tracker Item & Wiki & Article" => "트래커 황목과 위키와 기사",
"Wiki & Article" => "위키와 기사",
"Wiki & Article & Tracker Item" => "위키와 기사와 트래커 항목",
"Wiki & Tracker Item" => "위키와 트래커 항목",
"Wiki & Tracker Item & Article" => "위키와 트래커 항목과 기사",
"Parent ID" => "부모 ID",
"Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "해당 트래커로의 통계를 제한할 트래커 ID 입력하십시오 (trackeritems 하고만 사용에 해당)",
"Last 24 Hours" => "마지막 24시간",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"" => "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"",
"Added" => "추가됨",
"Added and Viewed" => "추가되었고 방문됨",
"Viewed" => "봄",
"Viewed & Added" => "봄 & 추가됨",
// "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last 7 Days" => "마지막 7일",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Week" => "이번 주",
// "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Month" => "지난 달",
// "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Month" => "이번 달",
// "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Year" => "작년",
// "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Year" => "올 해",
// "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Incorrect parameter: " => "틀린 매개 변수:",
"Subscript" => "아래 첨자",
"Apply subscript font to text" => "텍스트에 아래 첨자 폰트를 적용",
"Subscribe Group" => "그룹 구독",
"Allow users to subscribe to a group" => "사용자가 그룹에 구독하는 것 허용",
"text displayed before the button" => "버튼 앞에 표기될 텍스트",
"Group name to subscribe to or unsubscribe from" => "구독 혹은 구독해지를 할 그룹명",
"Subscribe Text" => "텍스트 구독",
// "Subscribe text, containing %0 as the placeholder for the group name" => "Subscribe text, containing %0 as the placeholder for the group name",
"Subscribe" => "구독",
"Unsubscribe Text" => "텍스트 구독 해제",
// "Unsubscribe text, containing %0 as the placeholder for the group name" => "Unsubscribe text, containing %0 as the placeholder for the group name",
"Unsubscribe" => "구독해제",
"Subscribe Action" => "구독 작업",
// "Subscribe button label, containing %0 as the placeholder for the group name" => "Subscribe button label, containing %0 as the placeholder for the group name",
"Unsubscribe Action" => "작업 구독해제",
// "Unsubscribe button label, containing %0 as the placeholder for the group name" => "Unsubscribe button label, containing %0 as the placeholder for the group name",
"Post-subscribe URL" => "URL 사후구독",
"URL to send the user to after subscribing, if required" => "구독 후 사용자가 이동하게될 URL, 요구될 경우에만 해당",
"Post-unsubscribe URL" => "URL 사후 구독 취소",
"URL to send the user to after unsubscribing, if required" => "구독해지 후 사용자가 이동하게 될 URL, 요구될 경우에만 해당",
// "Make this the default group text, containing %0 as the placeholder for the group name" => "Make this the default group text, containing %0 as the placeholder for the group name",
"Not Default Group" => "기본 그룹 아님",
// "Stop this being default group text, containing %0 as the placeholder for the group name" => "Stop this being default group text, containing %0 as the placeholder for the group name",
"Default Group Action" => "기본 그룹 작업",
"Default group button label. Will subscribe to the group first if not already a member" => "기본 그룹 버튼 레이블. 이미 구성원이 아닐 경우 먼저 그룹에 구독을 할 것임",
"Not Default Group Action" => "그본 그룹 작업 아님",
"Stop this being default group button label. Does not unsubscribe from the group" => "이것이 기본 그룹 버튼 라벨이 되는 것을 중지. 그룹에서 구독해지 하지 않음",
// "Second Default" => "Second Default",
"Group name to set as default when user stops this group being it" => "사용자가 이 그룹을 기본값으로 사용을 중지하였을 때 기본으로 설정할 그룹명",
// "Redirect to new home page after default group change. (default is to redirect)" => "Redirect to new home page after default group change. (default is to redirect)",
// "Can Always Leave" => "Can Always Leave",
// "Always allow leaving a group even if the group settings do not allow user choice" => "Always allow leaving a group even if the group settings do not allow user choice",
"Subscribe Groups" => "그룹들 구독",
"Allow users to subscribe to a list of groups" => "사용자가 다수의 그룹들을 구독하는 것 허용",
// "Text shown in the dropdown box. Default: %0Subscribe to a group%1" => "Text shown in the dropdown box. Default: %0Subscribe to a group%1",
"Show Subscribe Box" => "구독 상자 표시",
// "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for",
"Subscribe Box Style" => "구독 상자 스타일",
// "Style to show the subscribe box" => "Style to show the subscribe box",
"Show Default" => "보기 기본",
// "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group" => "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group",
"Group Description" => "그룹 설명",
"Show the description of the group (not shown by default)" => "그룹의 설명 표시 (기본으로 표시 안됨)",
"Colon-separated list of groups. By default the list of groups available to the user" => "콜론으로 구분된 그룹들 목록. 기본으로 그룹의 목록은 사용자들에게 제공됩니다",
"Only list groups that include the group being specified here" => "이곳에 지정된 그룹을 포함하는 그룹들만 나열",
"Default URL" => "기본 URL",
"Page user will be directed to after clicking on icon to change default group" => "기본 그룹을 변경할 아이콘에 클릭한 후 사용자가 보내지게 될 페이지",
"Leader Group Name" => "리더 그룹명",
// "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name" => "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name",
"Pending Users Group Name" => "보류 중인 사용자 그룹명",
// "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name",
"Group Management Page Name" => "그룹 관리 페이지 이름",
// "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name" => "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name",
"Hide link for groups including" => "다음을 포함하는 그룹에 대한 링크 감춤",
"Hide link to group home page for groups that include the group being specified here" => "여기에 지정되는 그룹을 포함하는 그룹들에 대한 그룹 홈페이지로의 링크 감춤",
"Always allow leaving group" => "그룹 떠나기를 항상 허용",
// "Always allow leaving group even if the group settings do not allow user choice" => "Always allow leaving group even if the group settings do not allow user choice",
"You do not have permission to subscribe to groups" => "그룹으로 구독할 권한이 없습니다",
"Subscribe to newsletter" => "회보 구독",
"Allow users to subscribe to a newsletter" => "사용자가 회보에 구독 허용",
"Invitation message" => "초대 메시지",
"Newsletter ID" => "회보 ID",
// "Identification number of the Newsletter that you want to allow the users to subscribe to" => "Identification number of the Newsletter that you want to allow the users to subscribe to",
"Confirmation Message" => "메시지 확인",
"Confirmation message after posting form. The plugin body is then the button label" => "게시 서식 뒤에 메시지 확인. 그렇다면 플러그인 본문은 버튼 레이블입니다",
"Button label. The plugin body is then the confirmation message" => "버튼 라벨. 그렇다면 플러그인 본문은 확인 메시지입니다.",
// "Choose whether the output should be parsed as wiki syntax" => "Choose whether the output should be parsed as wiki syntax",
// "In Module" => "In Module",
// "Display the newsletter subscription form in module view (if included in a Tiki module)" => "Display the newsletter subscription form in module view (if included in a Tiki module)",
"Already subscribed" => "이미 구독했습니다",
"Superscript" => "위 첨자",
"Apply superscript font to text" => "위 첨자 폰트를 텍스트에 적용",
// "Embed a survey" => "Embed a survey",
// "Id of the survey set up by the administrator" => "Id of the survey set up by the administrator",
"Wiki Page to redirect the user after his vote" => "투표 후 사용자가 보내지는 위키 페이지",
// "Language for the survey" => "Language for the survey",
// "Swiper" => "Swiper",
// "Embed swiper in content, support file galleries, files id and custom content" => "Embed swiper in content, support file galleries, files id and custom content",
// "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> " => "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> ",
// "Enter file gallery id for slider" => "Enter file gallery id for slider",
// "Transition Effect" => "Transition Effect",
// "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"" => "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"",
// "Slider Placement on Page" => "Slider Placement on Page",
// "Placement of slider, above topbar, below topbar, above menus and content or inside content" => "Placement of slider, above topbar, below topbar, above menus and content or inside content",
// "Inside Content" => "Inside Content",
// "Above top bar / Top of page" => "Above top bar / Top of page",
// "Above Content/Under top bar" => "Above Content/Under top bar",
// "Slider pagination, default bullets" => "Slider pagination, default bullets",
// "Fraction" => "Fraction",
// "Progress bar" => "Progress bar",
// "Display navigation arrows" => "Display navigation arrows",
// "Slider Background Color" => "Slider Background Color",
// "Slider background color, enter color code for example #000" => "Slider background color, enter color code for example #000",
// "Slider Parallax Background Image" => "Slider Parallax Background Image",
// "Enter image url for parallax background behind swiper" => "Enter image url for parallax background behind swiper",
// "Enter width of slider in px, default 100%" => "Enter width of slider in px, default 100%",
// "Enter height of slider in px, default min height 100px, max height will adjust with content" => "Enter height of slider in px, default min height 100px, max height will adjust with content",
// "Slide title color" => "Slide title color",
// "Enter text color code of slide title, for example #ccc" => "Enter text color code of slide title, for example #ccc",
// "Title font size" => "Title font size",
// "For example 42px, default 32 px" => "For example 42px, default 32 px",
// "Slide description color" => "Slide description color",
// "Enter text color code of slide description, for example #ccc" => "Enter text color code of slide description, for example #ccc",
// "Description font size" => "Description font size",
// "For example 24px, default 16 px" => "For example 24px, default 16 px",
// "Slide content background" => "Slide content background",
// "Slide content position" => "Slide content position",
// "Enter position for example top:20%;left:20% or bottom:20%;right:10%" => "Enter position for example top:20%;left:20% or bottom:20%;right:10%",
// "Autoplay slider, on by default" => "Autoplay slider, on by default",
// "Auto Play Delay" => "Auto Play Delay",
// "Show thumbnails under main slider" => "Show thumbnails under main slider",
// "Duration of transition between slides (in seconds)" => "Duration of transition between slides (in seconds)",
// "Auto Height" => "Auto Height",
// "Set to true and slider wrapper will adopt its height to the height of the currently active slide" => "Set to true and slider wrapper will adopt its height to the height of the currently active slide",
// "Space Between" => "Space Between",
// "Distance between slides in px" => "Distance between slides in px",
// "Slides Per View" => "Slides Per View",
// "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view" => "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view",
// "Slides Per View Mobile Screen" => "Slides Per View Mobile Screen",
// "Slides visible at the same time on small screens" => "Slides visible at the same time on small screens",
// "Slides Per View Tablet" => "Slides Per View Tablet",
// "Slides visible at the same time on low resolution tablets" => "Slides visible at the same time on low resolution tablets",
// "Slides Per Column" => "Slides Per Column",
// "Number of slides per column, for multirow layout" => "Number of slides per column, for multirow layout",
// "Slides Per Column Fill" => "Slides Per Column Fill",
// "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row" => "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row",
// "Centered Slides" => "Centered Slides",
// "If true, then active slide will be centered, not always on the left side" => "If true, then active slide will be centered, not always on the left side",
// "Slides Offset Before" => "Slides Offset Before",
// "Add (in px) additional slide offset in the beginning of the container (before all slides)" => "Add (in px) additional slide offset in the beginning of the container (before all slides)",
// "Slides Offset After" => "Slides Offset After",
// "Add (in px) additional slide offset in the end of the container (after all slides)" => "Add (in px) additional slide offset in the end of the container (after all slides)",
// "Slide To Clicked Slide" => "Slide To Clicked Slide",
// "Set to true and click on any slide will produce transition to this slide" => "Set to true and click on any slide will produce transition to this slide",
// "Free Mode" => "Free Mode",
// "If true then slides will not have fixed positions" => "If true then slides will not have fixed positions",
// "Preload Images" => "Preload Images",
// "When enabled Swiper will force to load all images" => "When enabled Swiper will force to load all images",
// "Update On Images Ready" => "Update On Images Ready",
// "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true" => "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true",
// "Loop Slider" => "Loop Slider",
// "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))" => "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))",
// " Please update composer to install required files" => " Please update composer to install required files",
// "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body" => "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body",
"Arrange content in tabs" => "탭 내부에 컨텐츠 배열",
"Tabs content, separated by \"/////\"" => " ///// 로 구분된 탭 내용물",
"Tabset Name" => "탭셋 이름",
// "Unique tabset name (if you want the last state to be remembered). Example" => "Unique tabset name (if you want the last state to be remembered). Example",
"Tab Titles" => "탭 제목",
// "Pipe-separated list of tab titles. Example" => "Pipe-separated list of tab titles. Example",
"Toggle Tabs" => "탭 토글",
"Allow toggling between tabs and no-tabs view" => "탭에서 탭 없음 보기로 토글하는 것을 허용",
"Inside Pretty Tracker" => "프리티 트래커 내부",
"Parse pretty tracker variables within tabs" => "탭 내부의 프리티 트래커 변수 구문분석",
"No tab title specified. At least one must be specified in order for the tabs to appear" => "탬 제목 지정되지 않음. 탭이 나타나게 만드려면 최소 하나는 설정되어야만 합니다",
"Apply an HTML tag to content" => "컨텐츠에 HTML 태그 적용",
"Tag Name" => "태그이름",
// "Any valid HTML tag, 0% by default" => "Any valid HTML tag, 0% by default",
"Equivalent to the style attribute of an HTML tag" => "HTML 태그의 스타일 특성과 동등함",
"Timeline" => "시간표시줄",
"Display a timeline" => "시간 표시줄 표시",
// "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)" => "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)",
// "Width of the timeline as CSS units (default: %0)" => "Width of the timeline as CSS units (default: %0)",
// "Height of the timeline as CSS units (default: %0)" => "Height of the timeline as CSS units (default: %0)",
"Primary Scale Unit" => "주 배율 단위",
// "Unit of time to use for the primary scale (default is Month)" => "Unit of time to use for the primary scale (default is Month)",
"Decade" => "10년",
"Century" => "세기",
"Secondary Scale Unit" => "2차 배율 단위",
// "Unit of time to use for the secondary scale" => "Unit of time to use for the secondary scale",
"TimeSheet" => "작업표",
// "Embed a timesheet into a page" => "Embed a timesheet into a page",
"Title Search" => "제목 검색",
// "Search page titles" => "Search page titles",
"Search Criteria" => "검색 조건",
"Portion of a page name" => "페이지명의 부분",
"Also show page hits or user" => "또한 페이지 방문수 혹은 사용자를 봅니다",
// "Hits and user" => "Hits and user",
// "User and hits" => "User and hits",
"Pipe-separated list of page names to exclude from results" => "결과로부터 제외될 페이지명들의 파이프로 구분된 목록",
"No Header" => "헤더 없음",
// "Set to Yes (%0) to have no header for the search results" => "Set to Yes (%0) to have no header for the search results",
"No pages found for title search" => "타이틀 검색으로 페이지 찾아지지 않음",
"One page found for title search" => "타이틀 검색으로 한 페이지 찾았음",
"pages found for title search" => "개의 페이지를 타이틀 검색으로 찾았음",
"Table of Contents (Structure)" => "목차 (구조체)",
// "Display a table of contents of pages in a structure" => "Display a table of contents of pages in a structure",
"Structure ID" => "구조체 ID",
// "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided" => "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided",
// "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided" => "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided",
"Order items in ascending or descending order (default is ascending)" => "항목을 오름차순 혹은 내림차순으로 정렬 (기본은 오름차순)",
// "Sort Order" => "Sort Order",
// "Order for the first Level of pages that will be displayed. Order by structure is the default" => "Order for the first Level of pages that will be displayed. Order by structure is the default",
// "Structure Order" => "Structure Order",
// "Alphabetic Order" => "Alphabetic Order",
// "Display the page description in front of the page name" => "Display the page description in front of the page name",
"Show Numbering" => "번호매김 표시",
"Display the section numbers or not" => "섹션 번호 표기 여부",
"Style to apply" => "적용할 스타일",
"Admin" => "관리",
// "Start Level" => "Start Level",
// "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)" => "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)",
// "Maximum Level Depth" => "Maximum Level Depth",
// "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)" => "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)",
// "Together" => "Together",
// "Collaborate in real time" => "Collaborate in real time",
// "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience" => "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience",
// "Button Name" => "Button Name",
// "Set the button name. Default is CoWrite with TogetherJS" => "Set the button name. Default is CoWrite with TogetherJS",
// "CoWrite with TogetherJS" => "CoWrite with TogetherJS",
// "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time" => "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time",
// "Tour" => "Tour",
// "Quick and easy way to build your product tours with Bootstrap popovers" => "Quick and easy way to build your product tours with Bootstrap popovers",
// "Content of the step" => "Content of the step",
// "Element" => "Element",
// "Element to show the popup on; if empty, use the plugin location itself" => "Element to show the popup on; if empty, use the plugin location itself",
// "Title of the step" => "Title of the step",
// "Index of the step to show after this one, starting from 0, -1 for the last one" => "Index of the step to show after this one, starting from 0, -1 for the last one",
// "Index of the step to show before this one, starting from 0, -1 not to show" => "Index of the step to show before this one, starting from 0, -1 not to show",
// "Path to the page on which the step should be shown" => "Path to the page on which the step should be shown",
// "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below" => "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below",
// "Placement" => "Placement",
// "The placement of the popup" => "The placement of the popup",
// "Orphan" => "Orphan",
// "Setting to true removes the pointer on the popup and centers it on the page" => "Setting to true removes the pointer on the popup and centers it on the page",
// "Backdrop" => "Backdrop",
// "Show a dark backdrop behind the popover and its element, highlighting the current step" => "Show a dark backdrop behind the popover and its element, highlighting the current step",
// "Only Show Once" => "Only Show Once",
// "Show automatically only once. tour_id should also be set if there are multiple tours" => "Show automatically only once. tour_id should also be set if there are multiple tours",
// "Show Until Dismissed" => "Show Until Dismissed",
// "Show automatically only until dismissed. tour_id should also be set if there are multiple tours" => "Show automatically only until dismissed. tour_id should also be set if there are multiple tours",
// "Tour ID" => "Tour ID",
// "Set a tour ID to be able to only show the tour once" => "Set a tour ID to be able to only show the tour once",
// "Restart Button" => "Restart Button",
// "Display a button to restart the tour. Enter the text to appear on the button" => "Display a button to restart the tour. Enter the text to appear on the button",
"Translate" => "번역",
"Translate text to the user language" => "사용자 언어로 텍스트 번역",
// "Embed a form to populate a tracker" => "Embed a form to populate a tracker",
"Numeric value representing the tracker ID" => "트래커 ID를 나타내는 숫자 값",
"Fields" => "필드",
// "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0" => "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0",
// "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters" => "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters",
// "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically" => "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically",
// "Action Style" => "Action Style",
// "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example" => "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example",
// "Display the title of the tracker at the top of the form (not shown by default)" => "Display the title of the tracker at the top of the form (not shown by default)",
"Show the tracker's description (not shown by default)" => "트래커의 설명 표시 (기본으로 표시 안됨)",
// "Show Fields Descriptions" => "Show Fields Descriptions",
// "Show the tracker's field descriptions (shown by default)" => "Show the tracker's field descriptions (shown by default)",
"Mark Mandatory" => "필수 표시",
"Indicate mandatory fields with an asterisk (shown by default)" => "필수 필드를 별표로 표시 (기본으로 표시됨)",
"Show Status" => "상태 표시",
"Show the status of the items (not shown by default)" => "항목 상태 표시 (기본으로 표시되지 않음)",
"Embedded" => "임베드됨",
// "To send an email once the tracker item has been created. Format: %0from" => "To send an email once the tracker item has been created. Format: %0from",
// "template%0" => "template%0",
// "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)" => "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)",
// "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used" => "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used",
// "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)" => "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)",
// "Keep params in URL" => "Keep params in URL",
// "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL" => "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL",
"URL Target" => "URL 대상",
// "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)" => "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)",
"Self" => "자신",
"Overwrite" => "덮어쓰기",
// "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)" => "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)",
// "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)" => "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)",
// "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item" => "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item",
"Label for the reset button, to return all fields to their default values" => "모든 필드를 기본값으로 복귀하는 재설정 버튼을 위한 레이블",
"reset" => "재설정",
// "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)" => "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)",
// "User&field" => "User&field",
// "User field to filter" => "User field to filter",
// "User field to filter user tracker items to" => "User field to filter user tracker items to",
// "Field to filter" => "Field to filter",
// "Field to filter user tracker items to" => "Field to filter user tracker items to",
// "Field to filter Value" => "Field to filter Value",
// "Value to filter user tracker items to" => "Value to filter user tracker items to",
// "Criteria" => "Criteria",
// "If more than one item found, will choose under this criteria. Used in combination with" => "If more than one item found, will choose under this criteria. Used in combination with",
// "creationDate - Ascending" => "creationDate - Ascending",
// "creationDate - Descending" => "creationDate - Descending",
"Status of the item used in combination with" => "다음과 혼합되어 사용될 항목의 상태",
"or" => "혹은",
// "Transaction name" => "Transaction name",
// "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name" => "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name",
// "Transaction Step" => "Transaction Step",
// "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0" => "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0",
// "Final Transaction Step" => "Final Transaction Step",
// "Indicate whether this is the final transaction step" => "Indicate whether this is the final transaction step",
// "Transaction previous URL" => "Transaction previous URL",
// "The page to go back to when the \"previous\" button is clicked" => "The page to go back to when the \"previous\" button is clicked",
// "Transaction previous button label" => "Transaction previous button label",
// "Text for the \"previous\" button label" => "Text for the \"previous\" button label",
"ItemId" => "항목ID",
// "ItemId identifying the item to be edited" => "ItemId identifying the item to be edited",
"Ignore ItemId" => "항목ID (ItemId) 무시",
// "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)" => "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)",
"Template File" => "템플릿 파일",
// "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template" => "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template",
// "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template" => "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template",
"New Status" => "새 상태",
// "Default status applied to newly created or saved items" => "Default status applied to newly created or saved items",
// "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form",
// "Autosave Fields" => "Autosave Fields",
// "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave" => "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave",
// "Autosave Values" => "Autosave Values",
// "Colon-separated values corresponding to %0. Special syntax cases" => "Colon-separated values corresponding to %0. Special syntax cases",
// "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field" => "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field",
// "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name" => "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name",
// "Increase-only Fields" => "Increase-only Fields",
// "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field" => "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field",
"Registration Fields" => "등록 필드",
// "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers" => "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers",
// "Register to group" => "Register to group",
// "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)" => "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)",
// "Validate users" => "Validate users",
// "Here one can overrule the default validate users by e-mail preference" => "Here one can overrule the default validate users by e-mail preference",
"Output To Wiki" => "위키로 출력",
// "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId" => "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId",
"Discard After Output" => "출력 후 버리기",
// "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages" => "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages",
"Template Page" => "템플릿 페이지",
// "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5" => "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5",
// "Output Wiki Namespace" => "Output Wiki Namespace",
// "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page" => "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page",
// "Store Relation" => "Store Relation",
// "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)" => "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)",
"Multiple Fill Fields" => "다중 fill 필드",
// "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0" => "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0",
// "Fill Fields Separator" => "Fill Fields Separator",
// "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)" => "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)",
// "Fill Fields Defaults" => "Fill Fields Defaults",
"Colon-separated list of default values for Multiple Fill Fields" => "다중 채우기 필드에 대한 기본값들의 콜론으로 구분된 목록",
"Embed the tracker in a form tag" => "트래커를 형식 태그 내부에 임베드",
// "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons" => "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons",
// "Use ajax to create/update tracker items" => "Use ajax to create/update tracker items",
// "Use ajax to create and update tracker items instead of form submission via request variables" => "Use ajax to create and update tracker items instead of form submission via request variables",
// "Transactions" => "Transactions",
// "You need to define both transaction name and transaction step, or none of the two" => "You need to define both transaction name and transaction step, or none of the two",
// "You need to choose transactionFinalStep (y/n)" => "You need to choose transactionFinalStep (y/n)",
// "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button" => "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button",
// "Tracker: Field #%0 not found in fields parameter or template" => "Tracker: Field #%0 not found in fields parameter or template",
"The page to output the results to already exists. Try another name" => "결과를 출력할 페이지가 이미 존재합니다. 다른 이름으로 시도하십시오",
// "Tracker Transaction: Field #%0 not found in fields parameter or template" => "Tracker Transaction: Field #%0 not found in fields parameter or template",
"Tracker was modified at " => "트래커가 수정됨",
// "Form saved successfully" => "Form saved successfully",
"Incorrect fieldId" => "틀린 필드ID",
"Following fields are incorrect" => "다음 필드들은 틀린 것입니다.",
// "Error: Read only field \"%0\"" => "Error: Read only field \"%0\"",
// "This field is mandatory" => "This field is mandatory",
"Missing wiki template page \"%0\"" => "위키 템플릿 페이지 \"%0\" 누락",
"Each line is a list of %d field values separated with: %s" => "각각의 줄은 %d 필드 값들의 목록으로 다음으로 구분됩니다: %s",
"You do not have permission to insert an item" => "항목을 삽입할 권한이 없습니다",
"Incorrect item" => "틀린 항목",
"You do not have permission to modify an item" => "항목을 수정할 권한이 없습니다",
"The page to output the results to contains the following prohibited characters: %0. Try another name" => "결과가 출력될 페이지가 다음의 금지된 글자를 포함합니다: %0. 다른 이름으로 시도하십시오",
// "Please ensure you are using the correct field ID and that it is properly included in the template, if any" => "Please ensure you are using the correct field ID and that it is properly included in the template, if any",
"Passwords do not match" => "비밀번호가 일치하지 않습니다",
"Insert one item per line" => "한 줄 당 한 항목 삽입",
"Fields marked with an * are mandatory." => "* 표시된 필드는 필수",
"Tracker Calendar" => "트래커 달력",
// "Create and display a calendar using tracker data" => "Create and display a calendar using tracker data",
// "Resource Descriptor Field" => "Resource Descriptor Field",
"Permanent name of the field to use as the resource indicator" => "자원 지정자로 사용될 필드의 영구적 이름",
// "Coloring Discriminator Field" => "Coloring Discriminator Field",
"Permanent name of the field to use to segment the information into color schemes" => "색 구성표 안으로 정보를 나누기 위하여 사용될 필드의 고정 링크명",
// "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages" => "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages",
// "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)" => "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)",
// "Add All Fields" => "Add All Fields",
// "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId" => "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId",
// "Use Session Storage" => "Use Session Storage",
// "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript" => "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript",
// "Agenda by Months" => "Agenda by Months",
// "Display the option to change the view to agenda by months" => "Display the option to change the view to agenda by months",
// "Agenda by Weeks" => "Agenda by Weeks",
// "Display the option to change the view to agenda by weeks" => "Display the option to change the view to agenda by weeks",
// "Agenda by Days" => "Agenda by Days",
// "Display the option to change the view to agenda by days" => "Display the option to change the view to agenda by days",
// "List by Years" => "List by Years",
// "Display the option to change the view to list by years" => "Display the option to change the view to list by years",
// "List by Months" => "List by Months",
// "Display the option to change the view to list by months" => "Display the option to change the view to list by months",
// "List by Weeks" => "List by Weeks",
// "Display the option to change the view to list by weeks" => "Display the option to change the view to list by weeks",
// "List by Days" => "List by Days",
// "Display the option to change the view to list by days" => "Display the option to change the view to list by days",
// "Resources by Years" => "Resources by Years",
// "Display the option to change the view to resources by years" => "Display the option to change the view to resources by years",
// "Resources by Months" => "Resources by Months",
// "Display the option to change the view to resources by months" => "Display the option to change the view to resources by months",
// "Resources by Weeks" => "Resources by Weeks",
// "Display the option to change the view to resources by weeks" => "Display the option to change the view to resources by weeks",
// "Resources by Days" => "Resources by Days",
// "Display the option to change the view to resources by days" => "Display the option to change the view to resources by days",
"Default View" => "기본 보기",
// "Choose the default view for the Tracker Calendar" => "Choose the default view for the Tracker Calendar",
// "Default Year" => "Default Year",
// "Choose the default year (yyyy) to use for the display" => "Choose the default year (yyyy) to use for the display",
// "Default Month" => "Default Month",
// "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc" => "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc",
// "Default Day" => "Default Day",
// "Choose the default day (dd) to use for the display" => "Choose the default day (dd) to use for the display",
// "Colormap for coloring" => "Colormap for coloring",
// "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0" => "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0",
// "First day of the Week" => "First day of the Week",
// "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)" => "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)",
// "Show Weekends" => "Show Weekends",
// "Display Saturdays and Sundays (shown by default)" => "Display Saturdays and Sundays (shown by default)",
// "Day Start" => "Day Start",
// "First time slot that will be displayed for each day, e.g. %0" => "First time slot that will be displayed for each day, e.g. %0",
// "Day End" => "Day End",
// "Last time slot that will be displayed for each day, e.g. %0" => "Last time slot that will be displayed for each day, e.g. %0",
// "Slot Duration" => "Slot Duration",
// "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)" => "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)",
// "Overlapping allowed" => "Overlapping allowed",
// "Allow resources to overlap in time" => "Allow resources to overlap in time",
// "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator" => "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator",
"Fields not found" => "필드 발견되지 않음",
"Tracker Comments" => "트래커 댓글",
// "Display the number of comments for a tracker" => "Display the number of comments for a tracker",
"Item Count" => "항목 개수",
"Determines whether the number of items will be shown (not shown by default)" => "항목의 수가 표시 여부를 결정함 (기본으로 표시되지 않음)",
"Enter a username to select the items of the current user" => "현재 사용자의 항목을 선택할 사용자명 입력",
"a user name" => "사용자명",
"Comments found" => "댓글 발견됨",
"Filters" => "필터",
// "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1" => "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1",
// "Format choices are" => "Format choices are",
// "dropdown" => "dropdown",
// "radio buttons" => "radio buttons",
// "multiple choice dropdown" => "multiple choice dropdown",
// "checkbox" => "checkbox",
// "text with wild characters" => "text with wild characters",
// "exact text match" => "exact text match",
// "initials" => "initials",
// "advanced search" => "advanced search",
// "range search (from/to)" => "range search (from/to)",
// "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal" => "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal",
// "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)" => "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)",
"Display List" => "목록 표시",
"Show the full list (before filtering) initially (filtered list shown by default)" => "초기에는 (필터링 이전의) 전체 목록 표시. (기본으로 필터된 목록 표시됨)",
"Displays all the filters on the same line (not shown on same line by default)" => "같은 줄 상에 모든 필터를 표시 (기본으로 같은 줄에서는 보이지 않음)",
"Yes with field label in dropdown" => "드롭다운 내의 필드 라벨과 함께 예",
"No Toggle" => "토글 없음",
// "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)" => "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)",
"Export CSV" => "CSV 내보내기",
"Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "내보내기 버튼에 대한 레이블. 일반 \"필터\" 버튼을 대신 표시하려면 비어둠",
// "Export Status Field" => "Export Status Field",
// "Export the status field if the Export CSV option is used" => "Export the status field if the Export CSV option is used",
// "Export Created Date Field" => "Export Created Date Field",
// "Export the created date field if the Export CSV option is used" => "Export the created date field if the Export CSV option is used",
// "Export Modified Date Field" => "Export Modified Date Field",
// "Export the modified date field if the Export CSV option is used" => "Export the modified date field if the Export CSV option is used",
// "Export Character Set" => "Export Character Set",
// "Character set to be used if the Export CSV option is used" => "Character set to be used if the Export CSV option is used",
// "Map View Buttons" => "Map View Buttons",
"Display Mapview and Listview buttons" => "지도보기와 목록보기 버튼 표시",
// " - was %0 until 12.0" => " - was %0 until 12.0",
"Tracker Filter" => "트래커 필터",
"Create a form to filter tracker fields" => "트래커 필드를 필터링할 서식 만들기",
"notice" => "알림",
// "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set" => "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set",
// "TrackerFields: Unknown tracker field used in the parameter \"filters\"" => "TrackerFields: Unknown tracker field used in the parameter \"filters\"",
"tracker field type not processed yet" => "트래커 필드 유형 아직 처리되지 않음",
"Tracker If" => "트래커 If",
"Display content based on results of a tracker field test" => "트래커 필드 테스트의 결과에 기반한 내용 표기",
"Ignore" => "무시",
"Ignore test in edit mode" => "편집 모드에서 테스트 무시",
"Copy Tracker Item" => "트래커 항목 복사",
// "PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Copy a tracker item" => "Copy a tracker item",
// "Tracker from which to copy item, joined tracker ids separated by %0:%1" => "Tracker from which to copy item, joined tracker ids separated by %0:%1",
// "Link Field IDs" => "Link Field IDs",
// "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1" => "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1",
// "Copy Field IDs" => "Copy Field IDs",
// "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1" => "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1",
// "Update Field IDs" => "Update Field IDs",
// "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1" => "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1",
"New Values" => "새 값들",
// "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId" => "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId",
"ID of item to make copy of, otherwise input is asked for" => "사본을 만들 항목의 ID, 그 외의 경우 입력이 요청됩니다",
"Make this number of copies on load" => "로드 시 이 숫자만큼의 사본을 만듭니다",
"Set the number of copies to make on load of plugin automatically" => "플러그인의 로드 시 자동으로 만들 사본의 수를 설정",
"Returns array non-interactively" => "배열을 비-대화형으로 반환",
// "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode" => "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode",
"Missing mandatory parameters" => "누락된 필수 매개 변수",
"Number of update fields do not match new values" => "업데이트 필드의 수가 새 값과 일치하지 않음",
"Tracker Item Field" => "트래커 항목 필드",
"Display or test the value of a tracker item field" => "트래커 항목 필드의 값을 표기 혹은 테스트",
// "Wiki text containing an %0{ELSE}%1 marker" => "Wiki text containing an %0{ELSE}%1 marker",
// "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user" => "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user",
"Numeric value representing the field ID displayed or tested" => "표기된 혹은 테스트 된 필드 ID를 나타내는 숫자 값",
"Colon-separated list of field IDs. Default is all fields" => "콜론으로 구분된 필드 ID들의 목록. 기본은 필드 전체입니다.",
"Status of the tracker item" => "트래커 항목의 상태",
"Open & Pending" => "열림 및 보류 중",
"Open & Closed" => "열림 및 닫힘",
"Pending & Closed" => "보류 및 닫힘",
"Open, Pending & Closed" => "열림, 보류 & 닫힘",
// "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter" => "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter",
"Value to compare against" => "비교대상 값",
"You are not allowed to view this item" => "이 항목을 보는 것이 허용되지 않습니다",
"You don't have permission to view this field" => "이 필드를 보는 것이 허용되지 않습니다",
// "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1" => "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1",
// "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default" => "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default",
// "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param" => "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param",
"Sticky Popup" => "고정형 팝업",
// "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)",
"Display the title of the tracker (not shown by default)" => "트래커의 제목 표기 (기본으로 보이지 않음)",
"Show Links" => "링크 보기",
// "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work" => "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work",
"Row" => "행",
"Show Item Count" => "항목 수 보기",
"Show the number of items found (not shown by default)" => "발견된 항목 수 표시 (기본으로 표시 안됨)",
"Show Initials" => "두문자 보기",
// "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)" => "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)",
// "Creation date display is based on tracker settings unless overridden here" => "Creation date display is based on tracker settings unless overridden here",
"Last Modification Date" => "마지막 수정 날짜",
// "Last modification date display is based on tracker settings unless overridden here" => "Last modification date display is based on tracker settings unless overridden here",
// "Last modified by user display is based on tracker settings unless overridden here" => "Last modified by user display is based on tracker settings unless overridden here",
"Show Field Name" => "필드명 보기",
"Use the field names as column titles (used by default)" => "열 제목으로 필드명 사용 (기본으로 사용됨)",
"Show Item Rank" => "항목 순위 보기",
"Show item ranks (not shown by default)" => "항목 순위 보기 (기본으로 보이지 않음)",
// "Show comments count or last comment date and user depending on tracker preferences" => "Show comments count or last comment date and user depending on tracker preferences",
"Only show items matching certain status filters (only items with open status shown by default)" => "특정 상태 필터에 일치하는 항목들만 보기 (기본으로 열린 상태를 가진 항목들만이 보임)",
// "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified" => "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified",
// "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)" => "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)",
"Sort Choice" => "선택 정렬",
// "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1" => "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1",
// "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1" => "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1",
"Offset of first item. Default is no offset" => "첫 항목의 오프셋. 기본은 오프셋 없음입니다",
"Fix offset always (no pagination)" => "항상 오프셋 수정 (페이지 구분 없음)",
// "Fix offset to that specified. This will disallow pagination" => "Fix offset to that specified. This will disallow pagination",
"Show Pagination" => "페이지 매김 표시",
"Determines whether pagination will be shown (shown by default)" => "페이지 나눔 표시 여부를 결정함 (기본으로 표시됨)",
// "Show button to make entire width of tables visible" => "Show button to make entire width of tables visible",
// "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)" => "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)",
"Filter Field" => "필드 필터",
"Colon-separated list of fields to allow filtering on" => "필터링 켜는 것을 허용할 필드들의 콜론으로 구분된 목록",
"Filter Value" => "필터 값",
// "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match" => "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match",
// "text that ends in \"value\"" => "text that ends in \"value\"",
// "text that begins with \"value\"" => "text that begins with \"value\"",
// "the current user's login name" => "the current user's login name",
// "the current user's default group" => "the current user's default group",
// "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead" => "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead",
// "any text" => "any text",
"Exact Value" => "정확한 값",
// "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by" => "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by",
// "tracker item is in category with ID x or one its descendants" => "tracker item is in category with ID x or one its descendants",
// "tracker item is not in category with ID x or one of its descendants" => "tracker item is not in category with ID x or one of its descendants",
// "match against the value of a Tiki preference" => "match against the value of a Tiki preference",
// "match if value does not equal a Tiki preference value" => "match if value does not equal a Tiki preference value",
// "match if the field does not equal \"value\"" => "match if the field does not equal \"value\"",
// "match for non empty values (opposite with %0exactvalue%1=\"\")" => "match for non empty values (opposite with %0exactvalue%1=\"\")",
// "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)" => "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)",
// "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )" => "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )",
// "match if less than \"value\"" => "match if less than \"value\"",
// "match if greater than \"value\"" => "match if greater than \"value\"",
// "match if less than or equal to \"value\"" => "match if less than or equal to \"value\"",
// "match if greater than or equal to \"value\"" => "match if greater than or equal to \"value\"",
// "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are" => "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are",
// "the value of this field will be posted to the action" => "the value of this field will be posted to the action",
// "the name of the post" => "the name of the post",
// "the title of the submit button" => "the title of the submit button",
// "the name of the submit button" => "the name of the submit button",
// "the file that will be called upon submit" => "the file that will be called upon submit",
// "optional template inserted before the submit button and returned" => "optional template inserted before the submit button and returned",
// "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1" => "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1",
// "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case" => "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case",
// "comma-separated list of pre-checked items" => "comma-separated list of pre-checked items",
// "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1" => "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1",
// "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1" => "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1",
// "goIfOne" => "goIfOne",
// "Display the item rather than list if only one item is found" => "Display the item rather than list if only one item is found",
// "Show a 'more' button that links to the tracker item (not shown by default)" => "Show a 'more' button that links to the tracker item (not shown by default)",
"More link pointing to specified URL instead of default tracker item link" => "기본 트래커 항목 링크 대신에 지정된 URL로 \"추가\" 링크를 향하게 함",
// "Display only the items of the following" => "Display only the items of the following",
// "the current user" => "the current user",
// "the current page name" => "the current page name",
// "the current IP address" => "the current IP address",
// "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1" => "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1",
// "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins" => "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins",
// "Template Wiki Page" => "Template Wiki Page",
// "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins" => "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins",
"View User" => "사용자 보기",
"Will display the items of the specified user" => "지정된 사용자의 항목을 표시함",
// "Colon-separated list of item IDs to restrict the listing to" => "Colon-separated list of item IDs to restrict the listing to",
"Ignore the itemId url parameter when filtering list (not ignored by default)" => "목록을 필터할 때 항목ID URL 매개변수를 무시 (기본으로 무시되지 않음)",
// "The link that will be on each main field when %0showlinks=\"y\"%1. Special values" => "The link that will be on each main field when %0showlinks=\"y\"%1. Special values",
// "will link to the item based on its item ID" => "will link to the item based on its item ID",
// "will link to the item based on its offset value" => "will link to the item based on its offset value",
// "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused" => "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused",
// "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example" => "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example",
// "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties" => "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties",
// "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1" => "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1",
// "Left Delimiter" => "Left Delimiter",
// "Smarty left delimiter for Latex generation. Example" => "Smarty left delimiter for Latex generation. Example",
// "Right Delimiter" => "Right Delimiter",
// "Smarty right delimiter for Latex generation Example" => "Smarty right delimiter for Latex generation Example",
"List Mode" => "모드 나열",
// "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting",
"Comma Separated Values" => "쉼표로 구분된 값들",
"Export Button" => "내보내기 버튼",
"Show an export button (not shown by default)" => "내보내기 버튼 표시 (기본으로 표시되지 않음)",
"Compute" => "계산",
// "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable" => "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable",
"fieldId" => "필드ID",
// "%0, separated by %1" => "%0, separated by %1",
"Silent" => "침묵",
// "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)",
"Show Delete" => "삭제 보기",
// "Show a delete icon for each item (not shown by default)" => "Show a delete icon for each item (not shown by default)",
"Url to redirect to after delete" => "삭제 후 리디렉션될 URL",
"Show Open Item" => "열린 항목 표시",
"Show an open item  option (not shown by default)" => "열린 항목 선택사항 표시 (기본으로 표시되지 않음)",
"Show Close Item" => "항목 닫기 표시",
"Show a close item option (not shown by default)" => "항목 닫기 선택사항 보기 (기본으로 보이지 않음)",
"Show Pending Item" => "대기 중 항목 표시",
"Show a pending item option (not shown by default)" => "보류 항목 선택사항 표시 (기본으로 표시 안됨)",
"Show Watch Button" => "주시 버튼 표시",
"Show a watch button (not shown by default)" => "시계 버튼을 표시 (기본으로 표시되지 않음)",
"Show Feed Button" => "피드 버튼 보기",
"Show an RSS feed button (not shown by default)" => "RSS 피드 버튼 표시 (기본으로 표시되지 않음)",
// "Show Results Map" => "Show Results Map",
// "Show Map of results (not shown by default)" => "Show Map of results (not shown by default)",
"Calendar Field IDs" => "달력 필드 ID들",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1",
"Calendar View Mode" => "달력 보기 모드",
"Calendar view type time span (default is month)" => "달력 보기 종류 시간 범위 (기본은 월 단위)",
"Two months" => "2개월",
"Trimester" => "삼분기",
"Calendar Popup" => "달력 팝업",
// "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)" => "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)",
// "Calendar item popups will stay open if set to y (Yes). Not sticky by default" => "Calendar item popups will stay open if set to y (Yes). Not sticky by default",
"Beginning of Month" => "달의 시작",
"Set whether calendar will begin at the beginning of the month (does by default)" => "달력이 달의 시작에 시작할 것인지를 설정 (기본으로 그렇게 함)",
"Show calendar navigation bar (shown by default)" => "달력 탐색 바 표시 (기본으로 표시됨)",
"Partial" => "부분적",
"Calendar Title" => "달력 제목",
"Enter a title to display a calendar title (not set by default)" => "달력 제목을 표시할 제목을 입력하십시오 (기본은 설정되지 않음)",
"Calendar Delta" => "달력 델타",
"Set the calendar delta that will be shown (not set by default)" => "표시될 달력 delta를 설정 (기본으로 설정되지 않음)",
"Plus Month" => "플러스 달",
"Minus Month" => "마이너스 달",
"Plus Two months" => "플러스 2개월",
"Minus Two months" => "마이너스 2개월",
"Display Spreadsheet" => "스프레드시트 표시",
"Display tracker as a spreadsheet (not used by default)" => "트래커를 스프레드시트로 표기 (기본으로 사용되지 않음)",
"Force Compile" => "완료를 강제 적용",
// "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)" => "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)",
"Period type" => "기간 유형",
"Time period after creation or after modification" => "만들기 이후 혹은 수정 이후 시간 기간",
"Creation" => "만들기",
"Modification" => "수정",
// "Inline edit" => "Inline edit",
// "Colon-separated list of fields for which inline editing will be enabled" => "Colon-separated list of fields for which inline editing will be enabled",
// "Inline edit All" => "Inline edit All",
// "Allow all displayed fields to be editable" => "Allow all displayed fields to be editable",
// "Compile Each Item" => "Compile Each Item",
// "Compile each item separately instead of compiling the entire template" => "Compile each item separately instead of compiling the entire template",
"Tracker List" => "트래커 목록",
"List, filter and sort the items in a tracker" => "트래커 내부의 항목을 나열, 필터, 및 분류",
// "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y" => "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y",
// "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly" => "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly",
// "For best results the date filter should only be applied to date field types" => "For best results the date filter should only be applied to date field types",
// "To filter the category field type, the exact category name or id needs to be entered" => "To filter the category field type, the exact category name or id needs to be entered",
"incorrect filterfield" => "틀린 필터필드",
// "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field" => "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field",
"Error in tracker ID" => "트래커 ID 내 오류",
"No field indicated" => "지정된 필드 없음",
"Check Tracker Passcodes" => "트래커 패스코드 확인",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Verify a tracker passcode" => "Verify a tracker passcode",
// "Session Key Names" => "Session Key Names",
"Tracker Prefill" => "트래커 사전작성",
"Create a button to prefill tracker fields" => "트래커 필드를 사전작성할 버튼 만들기",
// "Tracker page name" => "Tracker page name",
"URL Parameters" => "URL 매개 변수",
// "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1" => "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1",
"Field 1" => "필드 1",
"Field ID for the first field" => "1번재 필드에 대한 필드 ID",
"Value 1" => "값 1",
"Content that should be used to prefill the field" => "필드를 사전에 채워놓기 위해 사용되어야 하는 컨텐츠",
"Field 2" => "필드 2",
"Field ID for the second field" => "2번재 필드에 대한 필드 ID",
"Value 2" => "값 2",
"Field 3" => "필드 3",
"Field ID for the third field" => "번재 필드에 대한 필드 ID",
"Value 3" => "값 3",
"Field 4" => "필드 4",
"Field ID for the fourth field" => "4번재 필드에 대한 필드 ID",
"Value 4" => "값 4",
"Field 5" => "필드 5",
"Field ID for the fifth field" => "5번재 필드에 대한 필드 ID",
"Value 5" => "값 5",
"Field 6" => "필드 6",
"Field ID for the sixth field" => "6번재 필드에 대한 필드 ID",
"Value 6" => "값 6",
"Field 7" => "필드 7",
"Field ID for the seventh field" => "7번재 필드에 대한 필드 ID",
"Value 7" => "값 7",
"Field 8" => "필드 8",
"Field ID for the eighth field" => "8번재 필드에 대한 필드 ID",
"Value 8" => "값 8",
"Tracker Query Template" => "트래커 질의 템플릿",
// "Generate a form from tracker data" => "Generate a form from tracker data",
"Wiki Syntax, with variables from tracker query" => "위키 문법, 트래커 질의에서 변수 포함됨",
// "The name of the tracker to be queried, or if %0, the tracker ID" => "The name of the tracker to be queried, or if %0, the tracker ID",
// "Turn tracker query debug on (off by default)" => "Turn tracker query debug on (off by default)",
// "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs" => "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs",
"Render" => "렌더",
// "Render as needed for trackers (default)" => "Render as needed for trackers (default)",
"Item id of tracker item" => "트래커 항목의 항목 ID",
"Tracker Item Ids" => "트래커 필드 ID",
"Item id of tracker items, separated with comma" => "트래커 항목의 항목 ID, 쉼표로 분리됨",
"Like Filters" => "좋아요 필터",
// "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
"And Filters" => "그리고 필터들",
// "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
"Or Filters" => "혹은 필터들",
// "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
"Get Last" => "마지막 받기",
// "Retrieve only the last item from the tracker" => "Retrieve only the last item from the tracker",
"Tracker Stats" => "트래커 통계",
"Display statistics about a tracker." => "트래커에 관한 통계 표기",
// "Colon-separated list of field IDs to be displayed. Example" => "Colon-separated list of field IDs to be displayed. Example",
// ". " => ". ",
// "Leave it empty to display all fields from this tracker" => "Leave it empty to display all fields from this tracker",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)" => "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)",
// "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)" => "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)",
"Only show items matching certain status filters" => "특정 상태 필터에 일치하는 항목들만 보기",
// "Add a link to the tracker" => "Add a link to the tracker",
// "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example" => "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example",
"invalid status" => "유효하지 않은 상태",
"incorrect fieldId" => "틀린 필드ID",
"Tracker Timeline" => "트래커 시간표시줄",
"Show a timeline view of a tracker" => "트래커의 시간표시줄 보기를 표기",
"Title Field" => "제목 필드",
"Tracker Field ID containing the item title" => "항목 제목을 포함하는 트래커 필드 ID",
"Summary Field" => "요약 필드",
// "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
"Element Group" => "요소 그룹",
// "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row",
"Lower Bound" => "하위 경계",
// "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Upper Bound" => "상위 제한",
// "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "주 배율에 대하여 사용될 시간단위 (시간을 기본으로 함 - * SIMILE 만 해당)",
"Decade *" => "10년 *",
"Century *" => "세기 *",
"Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "2차 배율에 대하여 사용될 시간 단위 (비어있음을 기본으로 - * SIMILE 만 해당)",
"Timeline height" => "시간표시줄 높이",
// "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)",
"Lower band height" => "하위 대역 높이",
// "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)",
"Link Group Name" => "링그 그룹 이름",
"Convert the group name to a link" => "그룹 이름을 링크로 변환",
"Page Link Field" => "페이지 링크 필드",
"Tracker Field ID containing the page name for item details" => "항목 상세내역에 대한 페이지를 포함하는 트래커 필드 ID",
"SIMILE Timeline" => "SIMILE 타임라인",
"Use the SIMILE Timeline Widget" => "SIMILIE 타밈라인 위젯 사용",
"Image Field" => "그림 필드",
"Tracker Field ID containing in image" => "그림을 포함하는 트래커 필드 ID",
"Missing parameter: %0" => "매개 변수 없음: %0",
"Start date after end date" => "종료 날짜 이후 시작 날짜",
"Tracker Toggle" => "트래커 토글",
"Numeric value representing the field ID tested" => "테스트된 필드 ID를 나타내는 숫자 값",
// "Element Visibility" => "Element Visibility",
// "Set whether visible when the field has the value" => "Set whether visible when the field has the value",
"HTML id of the element that is toggled" => "토글된 요소의 HTML ID",
// "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set" => "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set",
"trackertoggle: Param fieldId is required" => "트래커토글: 매개변수 필드ID 가 필요함",
"trackertoggle: Param fieldId field %0 does not exsist" => "트래커토글: 매개변수 필드ID 필드 %0 가 존재하지 않음",
"trackertoggle: Param value is required" => "트래커토글: 매개변수 값이 필요함",
"trackertoggle: Param id is required" => "트래커토글: 매개변수 ID가 필요함",
// "Adjust the visibility of content based on a tracker field's value, possibly dynamically" => "Adjust the visibility of content based on a tracker field's value, possibly dynamically",
"Trade" => "교환",
// "Send payments between members using cclite" => "Send payments between members using cclite",
"Currency depends on the selected registry" => "통화는 선택된 레지스트리에 의거함",
"Registry to trade in. Default: site preference (or first in list when more than one)" => "교환할 레지스트리. 기본: 사이트 기본 설정 (혹은 한 개 이상이 있을 때 목록 내부의 첫번째)",
"Currency to trade in. Default: Cclite currency preference for registry set above" => "교환활 통화. 기본: 위에 설정된 레지스트리에 대한 Cclite 통화 기본설정",
// "Name of the user to receive or send the payment" => "Name of the user to receive or send the payment",
"Leave empty to display an input box" => "입력 상자를 표시하려면 빈 채로 두십시오",
"Offered or wanted item" => "제겅되거나 원하는 항목",
// "%0Offered%1" => "%0Offered%1",
"Offered" => "제공됨",
"Wanted" => "구함",
// "%0Continue%1" => "%0Continue%1",
"Title of the input form" => "입력 양식의 제목",
// "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted",
"Please log in" => "로그인해 주십시오",
" needs to validate their account" => " 은 자신의 계정을 유효화 하여야 합니다",
"Transclude" => "트랜스클루드",
// "PluginTransclude" => "PluginTransclude",
"Include the content of another page with certain changes" => "특정 변경내역을 가진 다른 페이지의 컨텐츠 포함",
"Name of the wiki page to use as a template for the values" => "값들에 대한 템플릿으로서 사용될 위키 페이지명",
"Attempt to include a page that cannot be viewed" => "볼 수 없는 페이지의 포함을 시도",
"Page named \"%0\" does not exist at this time" => "\"%0\" 라는 제목의 페이지는 현재 존재하지 않습니다",
"Translated" => "번역됨",
// "Create multilingual links" => "Create multilingual links",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, example" => "Two letter language code of the language, example",
"Flag" => "깃발",
// "Country name, example" => "Country name, example",
// "Translate a link from one language to another" => "Translate a link from one language to another",
// "TranslationOf" => "TranslationOf",
// "Original Page" => "Original Page",
// "Name of the page from which this link will be translated" => "Name of the page from which this link will be translated",
// "Translation Language" => "Translation Language",
// "Two letter language code of the language in which you want to translate this\n                    link. Example" => "Two letter language code of the language in which you want to translate this\n                    link. Example",
// "Translation Name" => "Translation Name",
// "Name of the page that will become the translation of the \"Original Page\"" => "Name of the page that will become the translation of the \"Original Page\"",
// "Translate this link" => "Translate this link",
"Twitter" => "트위터",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Twitter Path" => "Twitter Path",
// "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. " => "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. ",
// "Widget Id" => "Widget Id",
// "Numeric identifier of the widget" => "Numeric identifier of the widget",
// "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1" => "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1",
// "light" => "light",
// "dark" => "dark",
// "Link Color" => "Link Color",
// "Text color for individual tweets. Default is theme default" => "Text color for individual tweets. Default is theme default",
"Valid HTML color codes (with beginning #) or names" => "유효한 HTML 색상 코드 (#로 시작함) 혹은 이름",
// "Border Color" => "Border Color",
// "Change the border color used by the widget. Default is theme default" => "Change the border color used by the widget. Default is theme default",
// "Height of widget in pixels. Default is %0" => "Height of widget in pixels. Default is %0",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is %0" => "Width of widget in pixels or 'auto' to fit to width of page. Default is %0",
"Number of pixels or the word 'auto'" => "펙셀 수 혹은 단어 'auto'",
// "Default is with Header" => "Default is with Header",
// "No Footer" => "No Footer",
// "Default is with Footer" => "Default is with Footer",
// "Footer" => "Footer",
// "Layout Option: No Borders" => "Layout Option: No Borders",
// "Default is with Borders" => "Default is with Borders",
"Borders" => "테두리",
// "No Borders" => "No Borders",
// "No Scrollbar" => "No Scrollbar",
// "Default is with Scrollbar" => "Default is with Scrollbar",
// "Scrollbar" => "Scrollbar",
// "Transparent Background" => "Transparent Background",
// "Transparent Shell Background. Default is theme default" => "Transparent Shell Background. Default is theme default",
// "Theme default" => "Theme default",
"User Count" => "사용자 수",
// "Display number of users for a site or one or more groups" => "Display number of users for a site or one or more groups",
// "Group name. If left blank, the total number of users for the site will be shown" => "Group name. If left blank, the total number of users for the site will be shown",
// "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings" => "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings",
// "UserInGroup" => "UserInGroup",
// "checks if an individual user is in a particular Group and simply return a string set to either true or false" => "checks if an individual user is in a particular Group and simply return a string set to either true or false",
// "userId" => "userId",
// "the userId to be checked" => "the userId to be checked",
// "test group" => "test group",
// "the Group that the userId check is made against" => "the Group that the userId check is made against",
// "text for true result" => "text for true result",
// "The text that is displayed if the test result is true" => "The text that is displayed if the test result is true",
// "text for false result" => "text for false result",
// "The text that is displayed if the test result is false" => "The text that is displayed if the test result is false",
// "Last Login information" => "Last Login information",
// "PluginUserLastLogged" => "PluginUserLastLogged",
// "Show the last login information for a given or current user" => "Show the last login information for a given or current user",
// "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank" => "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank",
// "DateFormat" => "DateFormat",
// "Date format setting. Short_datetime used by default" => "Date format setting. Short_datetime used by default",
"User Link" => "사용자 링크",
"Display a link to a user's information page" => "사용자의 정보 페이지로 링크 표기",
"User account name (which can be an email address)" => "사용자 계정명 (이메일 주소가 될 수 있음)",
"User List" => "사용자 목록",
"Display a list of registered users" => "등록된 사용자 목록 표기",
"Login Filter" => "로그인 필터",
"Separator to use between users in the list. Default: comma" => "목록 내부의 사용자간에 사용할 구분 기호. 기본: 쉼표",
// "Set to sort in ascending or descending order" => "Set to sort in ascending or descending order",
// "Set to table to display results in a table" => "Set to table to display results in a table",
// "Make the user names listed links to different types of user information" => "Make the user names listed links to different types of user information",
"User info" => "사용자 정보",
"User page" => "사용자 페이지",
"User pref" => "사용자 기본설정",
"Real Name" => "실제 이름",
"Display the user's real name (when available) instead of login name" => "로그인명 대신 사용자의 실명을 표기 (제공될 경우에 한함)",
"Filter on a group" => "그룹에 필터",
"Display contents based on user preference settings" => "사용자 개인설정에 의거하여 컨텐츠 표기",
"Create tabs for showing alternate versions of content" => "컨텐츠의 다른 버전들을 표시하는 탭 만들기",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault",
// "Display a navigation box that allows users to select a specific version to display" => "Display a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default" => "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default",
"Default Label" => "기본 레이블",
// "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'" => "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'",
// "Embed a Vimeo video" => "Embed a Vimeo video",
// "Complete URL to the Vimeo video. Example" => "Complete URL to the Vimeo video. Example",
// "or leave blank to upload one" => "or leave blank to upload one",
"Quality of the video" => "동영상의 품질",
"Expand to full screen" => "전체 화면으로 확장",
// "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)" => "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)",
// "Numeric ID of a Tracker Files field, using Vimeo displayMode" => "Numeric ID of a Tracker Files field, using Vimeo displayMode",
// "Numeric ID of a Tracker item, using Vimeo displayMode" => "Numeric ID of a Tracker item, using Vimeo displayMode",
// "Gallery ID to upload to" => "Gallery ID to upload to",
// "Froogaloop API" => "Froogaloop API",
// "Use Vimeo Froogaloop API" => "Use Vimeo Froogaloop API",
// "Show the Video Title" => "Show the Video Title",
// "(default is to show)" => "(default is to show)",
// "Show Byline" => "Show Byline",
// "Show Portrait" => "Show Portrait",
// "Vimeo video not found for file #%0" => "Vimeo video not found for file #%0",
// "Feature required" => "Feature required",
// "Feature \"vimeo_upload\" is required to be able to add videos here" => "Feature \"vimeo_upload\" is required to be able to add videos here",
// "You do not have permsission to add files here" => "You do not have permsission to add files here",
// "You do not have permsission modify this tracker item" => "You do not have permsission modify this tracker item",
// "You do not have permsission modify this page" => "You do not have permsission modify this page",
// "Show the creator's byline" => "Show the creator's byline",
// "Show the creator's profile picture" => "Show the creator's profile picture",
"Vote" => "투표",
"Create a tracker for voting" => "투표를 위한 트래커 만들기",
// "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example" => "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example",
// "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)" => "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)",
// "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)" => "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)",
"Show Stats" => "통계 표시",
"Choose whether to show the voting results (shown by default)" => "투표 결과의 표시 여부를 선택하십시오 (기본으로 표시)",
"Show Stats After" => "다음 이후 통계 표시",
// "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)",
"Show Toggle" => "토글 표시",
"Show toggle or not to display the form and the results" => "토글 표시 혹은 형식과 결과를 표시하지 않음",
"Votings" => "투표",
"Saves voting information in Smarty variables for display" => "투표 정보를 표시를 위해 스마티 변수로 저장",
"Object Key" => "개체 키",
"Object key that is used to record votes" => "투표를 기록하기 위해 사용되는 개체 키",
"Return value" => "반환값",
"Value to display as output of plugin" => "플러그인의 출력으로써 표기될 값",
"Wanted Pages" => "원하는 페이지",
"Show location of links to pages not yet created" => "아직 만들어지지 않은 페이지로의 링크의 위치 표시",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
"Split By" => "다음으로 분할됨",
"The character by which ignored patterns are separated" => "무시되는 패턴이 분리될 문자",
// "Skip Alias" => "Skip Alias",
// "Whether to skip wanted pages that have a defined alias (not skipped by default)" => "Whether to skip wanted pages that have a defined alias (not skipped by default)",
"Skip Extension" => "확장자 누락",
"Whether to include external wikis in the list (not included by default)" => "외부 위키를 목록에 포함할지 여부 (기본으로 포함되지 않음)",
"Collect" => "수집",
// "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column",
"From" => "시작",
"Switch on debug output with details about the items (debug not on by default)" => "항목들에 관한 상세내역과 함께 디버크 출력 켜기 (기본으로 디버그는 켜져 있지 않음)",
"Memory Saver" => "메모리 저장기",
// "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell",
"Line break" => "줄 바꿈",
"Separate Row" => "별개의 행",
"Level" => "등급",
// "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex",
"Full" => "전체",
"non-valid custom regex" => "유효하지 않은 사용자 지정 정규식",
// ", " => ", ",
"ignored" => "무시됨",
"External Wiki" => "외부 Wiki",
// "dash-WikiWord" => "dash-WikiWord",
"WikiWord" => "위키단어",
"not in level" => "레벨에 없음",
"valid" => "유효함",
"End of debug output" => "디버그 출력의 끝",
"Wanted Page" => "원하는 페이지",
"Referenced By Page" => "페이지에 의하여 참조됨",
// "Web Document Viewer" => "Web Document Viewer",
// "View a document in a page" => "View a document in a page",
// "File Id" => "File Id",
// "The FileId of a file in a File Gallery of the file you wish to embed in the viewer" => "The FileId of a file in a File Gallery of the file you wish to embed in the viewer",
// "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter" => "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter",
// "No FileId or URL has been set" => "No FileId or URL has been set",
"Web Service" => "웹 서비스",
// "Display remote information exposed in JSON or YAML or SOAP XML" => "Display remote information exposed in JSON or YAML or SOAP XML",
// "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter",
"Complete service URL" => "완전한 서비스 URL",
"Registered service name" => "등록된 서비스명",
// "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided",
"Body as Parameter" => "매개 변수로써의 본문",
// "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful" => "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful",
// "Parameters formatted like a query" => "Parameters formatted like a query",
"Unknown Template" => "알 수 없는 템플릿",
"Unknown Service" => "알 수 없는 서비스",
// "Wiki Diff" => "Wiki Diff",
// "Display the differences between two wiki objects" => "Display the differences between two wiki objects",
// "Object Id" => "Object Id",
// "Object to do a diff on (page name for wiki pages)" => "Object to do a diff on (page name for wiki pages)",
// "Object type (wiki pages only)" => "Object type (wiki pages only)",
// "Old version" => "Old version",
// "Integer for old version number, or date" => "Integer for old version number, or date",
// "New version" => "New version",
// "Leave empty for current version" => "Leave empty for current version",
// "Diff Style" => "Diff Style",
// "Defaults to \"diff style\" preference if empty" => "Defaults to \"diff style\" preference if empty",
// "Show version info" => "Show version info",
// "Show the heading \"Comparing version X with version Y\"" => "Show the heading \"Comparing version X with version Y\"",
// "Use a WYSIWYG editor to edit a section of content" => "Use a WYSIWYG editor to edit a section of content",
// "Minimum width for DIV. Default" => "Minimum width for DIV. Default",
// "Minimum height for DIV. Default" => "Minimum height for DIV. Default",
"Use HTML" => "HTML 사용",
// "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed" => "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed",
// "XMLupdate" => "XMLupdate",
// "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory" => "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory",
// "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file " => "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file ",
// "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory" => "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory",
// "XML node attribute name" => "XML node attribute name",
// "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space" => "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space",
// "XML node listed in output" => "XML node listed in output",
// "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set" => "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set",
// "Xmpp" => "Xmpp",
// "Chat using Xmpp" => "Chat using Xmpp",
// "Room Name" => "Room Name",
// "Room to auto-join" => "Room to auto-join",
// "View Mode" => "View Mode",
// "Fullscreen" => "Fullscreen",
// "Overlayed" => "Overlayed",
// "Chat room width in CSS units" => "Chat room width in CSS units",
// "Chat room height in CSS units" => "Chat room height in CSS units",
"Visibility" => "표시 여부",
// "This room is visible to anyone or only for members" => "This room is visible to anyone or only for members",
// "Members only" => "Members only",
// "Show Real JIDs of Occupants to" => "Show Real JIDs of Occupants to",
// "If just moderator or anyone else can fetch information about an occupant" => "If just moderator or anyone else can fetch information about an occupant",
// "If just \"moderator\", anonymous user will not be able to change their nicknames" => "If just \"moderator\", anonymous user will not be able to change their nicknames",
// "Anyone" => "Anyone",
// "Moderator" => "Moderator",
// "Show controlbox on load" => "Show controlbox on load",
// "If controlbox should be shown after page load" => "If controlbox should be shown after page load",
// "This preference only works when view mode is overlayed" => "This preference only works when view mode is overlayed",
// "Show occupants" => "Show occupants",
// "If occupants window should be visible by default" => "If occupants window should be visible by default",
// "This preference only works when view mode is embedded" => "This preference only works when view mode is embedded",
// "Groups (comma-separated)" => "Groups (comma-separated)",
// "Allowed groups to use this resource" => "Allowed groups to use this resource",
// "Is secret" => "Is secret",
// "If the room will be listed on public chat room list" => "If the room will be listed on public chat room list",
// "Archiving" => "Archiving",
// "If room messages will be stored" => "If room messages will be stored",
// "Persistent" => "Persistent",
// "If room will continue to exist after last user leaves" => "If room will continue to exist after last user leaves",
// "If room is moderated" => "If room is moderated",
// "PluginXMPP Error: No room specified" => "PluginXMPP Error: No room specified",
// "Add a group to room" => "Add a group to room",
// "Add users to room" => "Add users to room",
"YouTube" => "유튜브",
// "Embed a YouTube video in a page" => "Embed a YouTube video in a page",
"Movie" => "동영상",
// "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)" => "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)",
// "Privacy-Enhanced" => "Privacy-Enhanced",
// "Enable privacy-enhanced mode" => "Enable privacy-enhanced mode",
// "Start time" => "Start time",
// "Start time offset in seconds" => "Start time offset in seconds",
// "Quality of the video. Default is %0high%1" => "Quality of the video. Default is %0high%1",
"Enlarge video to full screen size" => "동영상을 전체 화면 크기로 확대",
"Related" => "연관",
"Show related videos (shown by default)" => "관련 동영상 표시 (기본으로 표시됨)",
"Background" => "배경",
// "Toolbar background color. Use an HTML color code" => "Toolbar background color. Use an HTML color code",
// "Example" => "Example",
"HTML color code, e.g. ffffff" => "HTML 색상 코드. 예: ffffff",
// "Toolbar border colors. Use an HTML color code" => "Toolbar border colors. Use an HTML color code",
"Plugin YouTube error: the movie parameter is empty" => "유튜브 플러그인 오류: 동영상 매개 변수가 비어있음",
// "Invalid YouTube URL provided" => "Invalid YouTube URL provided",
"Zotero Citation" => "Zotero 인용",
"Retrieves and includes a Zotero reference in the page" => "페이지에 조테로 참조를 검색하고 포함",
"Reference Key" => "참조 키",
// "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module",
"Reference Tag" => "참조 태그",
// "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references" => "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references",
"Zotero Reference List" => "Zotero 참조 목록",
// "Display the complete reference list from a Zotero server" => "Display the complete reference list from a Zotero server",
"Provide the list of references with a given tag" => "주어진 태그로 참조 목록을 제공",
"No results obtained. The Zotero citation server may be down" => "획득한 결과 없음. 조테로 인용 서버가 다운되어 있을 수 있습니다",
// "Set up some advanced options" => "Set up some advanced options",
// "Set up Auto TOC" => "Set up Auto TOC",
// "Define Categories" => "Define Categories",
// "Set up User & Community features" => "Set up User & Community features",
// "Set up Date and Time" => "Set up Date and Time",
// "Select Editor type" => "Select Editor type",
// "Set up Main features" => "Set up Main features",
// "Set up File Gallery & Attachments" => "Set up File Gallery & Attachments",
// "Set up File storage" => "Set up File storage",
// "Set up Language" => "Set up Language",
// "Set up Login" => "Set up Login",
// "Set up Look & Feel" => "Set up Look & Feel",
// "Set up Namespace" => "Set up Namespace",
// "Set up Search" => "Set up Search",
// "Set up Structures" => "Set up Structures",
// "Set up Text Area" => "Set up Text Area",
// "Set up Wiki environment" => "Set up Wiki environment",
// "Tiki Setup" => "Tiki Setup",
// "Configuration Wizard Completed" => "Configuration Wizard Completed",
// "Set up Wysiwyg editor" => "Set up Wysiwyg editor",
// "Related doc.tiki.org pages" => "Related doc.tiki.org pages",
// "New in Tiki 13" => "New in Tiki 13",
// "New in Tiki 14" => "New in Tiki 14",
// "New in Tiki 15 (LTS)" => "New in Tiki 15 (LTS)",
// "New in Tiki 16" => "New in Tiki 16",
// "New in Tiki 17" => "New in Tiki 17",
// "New in Tiki 18 (LTS)" => "New in Tiki 18 (LTS)",
// "New in Tiki 19" => "New in Tiki 19",
// "New in Tiki 20" => "New in Tiki 20",
// "Novice Admin Assistance" => "Novice Admin Assistance",
// "Other features and settings" => "Other features and settings",
// "Permissions & Logs" => "Permissions & Logs",
// "Send feedback & Connect" => "Send feedback & Connect",
"User Interface" => "사용자 인터페이스",
// "Changes Wizard Completed" => "Changes Wizard Completed",
// "Configuration Profiles Wizard Completed" => "Configuration Profiles Wizard Completed",
// "Demo of Cases in Project Management" => "Demo of Cases in Project Management",
// "Demo of Commonly Used Configurations" => "Demo of Commonly Used Configurations",
// "Demo of Highly Specialized Configurations" => "Demo of Highly Specialized Configurations",
// "Demo of Interesting Use Cases" => "Demo of Interesting Use Cases",
// "Demo of More Advanced Configurations" => "Demo of More Advanced Configurations",
// "Demo of Other Interesting Use Cases" => "Demo of Other Interesting Use Cases",
// "Featured Site Configurations" => "Featured Site Configurations",
// "Useful Administration Configurations" => "Useful Administration Configurations",
// "Useful Changes in Display Mode" => "Useful Changes in Display Mode",
// "Useful Micro Configurations" => "Useful Micro Configurations",
// "Useful New Technology Configurations" => "Useful New Technology Configurations",
"Personal Information" => "개인 정보",
"User Watches" => "사용자 주시",
"Notification Preferences" => "알림 기본설정",
"unicode" => "유니코드",
"Report Preferences" => "보고서 기본설정",
// "User Details" => "User Details",
// "You cannot access this page directly" => "You cannot access this page directly",
// "Welcome to the User Wizard" => "Welcome to the User Wizard",
// "User Wizard Completed" => "User Wizard Completed",
// "Invalid wizard stepNr specified" => "Invalid wizard stepNr specified",
"Articles Home" => "기사 홈",
// "Delete selected messages" => "Delete selected messages",
// "%0 archived message was deleted" => "%0 archived message was deleted",
// "%0 archived messages were deleted" => "%0 archived messages were deleted",
// "No messages were deleted" => "No messages were deleted",
// "No messages were selected to delete" => "No messages were selected to delete",
// "The message must have either a subject or a body" => "The message must have either a subject or a body",
"User %s does not have the permission" => "사용자 %님은 권한이 없습니다",
"The message has been sent to" => "메시지가 다음 분에게 발송되었습니다",
"The message will be sent to" => "메시지가 다음 분께 발송될 것입니다",
// "See below for how the broadcast message will be handled upon confirmation" => "See below for how the broadcast message will be handled upon confirmation",
// "No valid users to send the message to" => "No valid users to send the message to",
"User %s does not want to receive messages" => "사용자 %님은 메시지를 받는 것을 원하지 않습니다",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages" => "보낸 편지함이 가득 차 있습니다. 추가 메시지 발송을 원하시는 경우, 우선, 보낸 메시지의 일부를 보관하거나 삭제하십시오",
// "See below for how message will be handled upon confirmation" => "See below for how message will be handled upon confirmation",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "메시지를 보내려면 받을 수 있어야 합니다. 사용자 선호설정으로 가서 '다른 사용자로부터 메시지 허용'을 활성화 하십시오",
"User %s can not receive messages, mailbox is full" => "사용자 %s 님은 메시지를 받을 수 없습니다. 우편함이 가득 차 있습니다",
"User %s can not receive messages" => "사용자 %s 님은 메시지를 수신할 수없습니다",
"Invalid user: %s" => "유효하지 않은 사용자: %s",
// "%0 message was marked" => "%0 message was marked",
// "%0 messages were marked" => "%0 messages were marked",
// "No messages were marked" => "No messages were marked",
// "No messages were selected to mark" => "No messages were selected to mark",
// "%0 message was deleted" => "%0 message was deleted",
// "%0 messages were deleted" => "%0 messages were deleted",
// "%0 message was archived" => "%0 message was archived",
// "%0 messages were archived" => "%0 messages were archived",
// "No messages were archived" => "No messages were archived",
// "No messages were selected to archive" => "No messages were selected to archive",
"Archive is full. Delete some messages from archive first" => "보관이 가득 차있씁니다. 먼저 보관에서 메시지를 일부 삭제하십시오",
// "Delete message" => "Delete message",
// "Message deleted" => "Message deleted",
// "Message not deleted" => "Message not deleted",
"No more messages" => "메시지 더 이상 없음",
// "Delete archive message" => "Delete archive message",
// "Archive message deleted" => "Archive message deleted",
// "Archive message not deleted" => "Archive message not deleted",
// "Delete sent message" => "Delete sent message",
// "Sent message deleted" => "Sent message deleted",
// "Sent message not deleted" => "Sent message not deleted",
// "%0 sent message was deleted" => "%0 sent message was deleted",
// "%0 sent messages were deleted" => "%0 sent messages were deleted",
"Action Calendar" => "작업 달력",
"Item types filter" => "항목 종류 필터",
"If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "항목 유형의 목록으로 설정된 경우, 표시되는 항목들을 이러한 유형들 중 하나의 것들로 제한. 각 세트는 항목 유형 코드의 쉼표로 구분된 목록입니다",
"Possible item type values" => "가능한 항목 유형 값들",
"Similar Content" => "유사한 컨텐츠",
"Find similar content based on tags" => "프리태그에 기반한 유사한 컨텐츠 찾기",
"Similar Content Filter" => "유사한 컨텐츠 필터",
"Display only similar content of type specified" => "지정된 유형의 유사한 컨텐츠만 표시",
"Default: \"All Content Type\"" => "기본: \"모든 컨텐츠 유형\"",
"Options: \"article, wiki page, blog post\"" => "선택사항: \"기사, 위키 페이지, 블로그 포스트\"",
"Broaden FreeTag Search" => "프리태그 검색 확대",
"Find similar content that contains one of the Tags or All of the Tags" => "태그 중 하나 혹은 태그 전부를 포함하는 유사한 컨텐츠 찾기",
"Default: \"n - needs to contain all of the Tags\"" => "기본: \"n - 태그 전부를 포함해야 함\"",
"Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "선택사항: \"n - 모든 태크를 포함해야 함 / y - 태그들 중 하나를 포함해야 함\"",
// "Quick Admin Bar" => "Quick Admin Bar",
// "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features" => "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features",
"Display mode: module or header. Leave empty for module mode" => "표시 모드: 모듈 혹은 헤더. 모듈 모드에 대해서 빈 상태로 두십시오",
"Google AdSense" => "구글 애드센스",
"Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "텍스트/그림 구글 애드센스 광고 표시. 이 모듈은 새 구글 코드를 지원하기 위하여 갱신되어야 합니다",
// "ad_channel" => "ad_channel",
"Advertisement channel, as optionally provided by Google" => "광고 채널, 이는 구글에 의하여 선택적으로 제공됨.",
"client" => "고객",
"As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "구글에 의하여 제공된 바. 서식: \"pub-xxxxxxxxxxxxxxxx\"",
"display" => "표시",
"Global banner format as provided by Google. For example: \"display=468*60_as\"" => "구글에 의해 제공되는 전역 배너 형식. 예를 들면: \"display=468*60_as\"",
// "color_bg" => "color_bg",
"Background color, as optionally provided by Google" => "배경 색상, 선택사항으로 구글에 의해 제공됨",
// "color_border" => "color_border",
"Border color, as optionally provided by Google" => "테두리 색상, 구글이 선택사항으로 제공하는 상태",
// "color_link" => "color_link",
"Link color, as optionally provided by Google" => "링크 색상, 구글에 의해 선택적으로 제공됨",
// "color_text" => "color_text",
"Text color, as optionally provided by Google" => "텍스트 색상, 구글에 의하여 선택적으로 제공됨",
// "color_url" => "color_url",
"URL color, as optionally provided by Google" => "URL 색상, 구글에서 선택적으로 제공됨",
"Article Archives" => "기사 보관물",
"Shows links to the published articles for each month" => "각 월에 대한 게시된 기사로의 링크 표시",
"If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "\"y\" 로 설정된 경우, 선택된 기사의 페이지 분리된 보기로 연결된 \"추가...\"라는 라벨이 붙은 버튼을 표시",
"Default: \"n\"" => "기본: \"n\"",
"If set to a category identifier, only consider the articles in the specified category" => "범주 식별자로 설정된 경우, 지정된 범주 안의 기사만 고려함",
"Example value: 13" => "예제 값: 13",
"Topic filter (by names)" => "토픽 필터 (이름으로)",
"If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "더하기 표시로 구분된 기사 토픽 식별자의 목록으로 설정된 경우, 지정된 기사 토픽 안의 기사들만 고려합니다. 문자열 앞에 느낌표 (\"!\")가 오는 경우, 그 효과는 역방향이 됩니다, 즉, 지정된 기사 토픽 내의 기사가 고려되지 않습니다",
"Topic filter (by identifiers)" => "토픽 필터 (식별자로)",
"If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "더하기 표시로 구분된 기사 토픽 식별자의 목록으로 설정된 경우, 지정된 기사 토픽 안의 기사들만 고려합니다. 문자열 앞에 느낌표 (\"!\")가 오는 경우, 그 효과는 역방향이 됩니다, 즉, 지정된 기사 토픽 내의 기사가 고려되지 않습니다",
"Example values: 13, !13, 1+3, !1+5+7" => "예제 값: 13, !13, 1+3, !1+5+7",
"Types filter" => "유형 필터",
"If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "더하기 표시로 분리된 기사 유형 이름의 목록으로 설정된 경우, 지정된 유형의 기사들만 고려됩니다. 문자열앞에 느낌표 (\"!\")가 오는 경우, 효과는 역방향이 됩니다, 즉, 지정된 기사 유혀으이 기사는 고려되지 않습니다",
"Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "예제 값: Event, !Event, Event+Review, !Event+Classified+Article",
"Language filter" => "언어 필터",
"If set to a language code, only consider the articles in the specified language" => "언어 코드로 설정된 경우, 지정된 언어로 된 기사들만 고려",
"Article Topics" => "기사 토픽",
"Lists all article topics with links to their articles" => "모든 기사 토픽을 기사로의 링크와 함께 나열",
"Lists the specified number of published articles in the specified order" => "개제된 기사의 지정된 수만큼 지정된 순서대로 나열함",
"Show publication time" => "개제 시간 표시",
"If set to \"y\", article publication times are shown" => "\"y\" 로 설정된 경우, 기사 개제 시간이 표시합니다",
"Show creation time" => "만든 시간 보기",
"If set to \"y\", article creation times are shown" => "\"y\" 로 설정된 경우, 기사 만든 시간이 표시합니다",
"Show rating selector" => "등급 선택기 표시",
"If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "\"y\" 로 설정될 경우, 최저 및 최대 등급에 기반하여 기사의 필터링을 사용자에게 제공합니다",
"Image width" => "그림 넓이",
"If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "설정되면, 적용할 경우 주어진 넓이 (픽셀 단위)로 각 기사에 대하여 그림을 표시합니다. 기사 자체 그림이 사용되며, 없을 경우 기사의 토픽 그림으로 대체됩니다.",
"If set to a category identifier, only lists the articles in the specified category" => "범주 식별자로 설정된 경우, 지정된 범주 안의 기사들만 나열합니다",
"If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "더하기 표시로 분리된 기사 토픽명들의 목록으로 설정된 경우, 지정된 기사 토픽들 내부에만 기사들을 나열합니다. 문자열 앞에 느낌표 (\"!\")가 오는 경우, 효과는 역방향이 됩니다, 즉. 지정된 기사 토픽들 내부의 기사들이 나열되지 않습니다",
"If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "더하기 표시로 구분된 기사 토픽 식별자의 목록으로 설정된 경우, 지정된 기사 토픽 안의 기사들만 나열합니다. 문자열 앞에 느낌표 (\"!\")가 오는 경우, 그 효과는 역방향이 됩니다, 즉, 지정된 기사 토픽 내의 기사가 나열하지 않습니다",
"If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "더하기 기호에 의하여 구분된 기사유형명의 목록으로 설정된 경우, 지정된 유형의 기사만 나열합니다. 문자열의 앞에 느낌표 (\"!\")가 오는 경우, 그 효과는 반대가 됩니다, 즉, 지정된 기사 유형의 기사들이 나열되지 않습니다",
"If set to a language code, only lists the articles in the specified language" => "언어 코드로 설정된 경우, 지정된 언어로만 되어있는 기사만 나열",
"Specifies how the articles should be sorted" => "기사가 어떻게 정렬될 것인지를 지정함",
"Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "가능한 값은 created 과 created_asc (동일함), created_desc, author, rating, topicId, lang 및 title 을 포함합니다. \"_desc\" 가 지정되지 않는 경우라면, 정렬은 오름차순입니다. \"created\"는 기사 만들기 날짜로 정렬합니다",
"If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "정수로 설정된 경우, 주어진 숫자에 의하여 기소 목록을 오프세트합니다. 예를 들면, 가장 최근 개제된 10개의 기사를 나열하기로 설정된 모듈은, 오프셋을 10으로 설정하면, 모듈은 대신 개제 시간의 내림차순 순서로 11번째에서 20번째 기사를 나열합니다",
"If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "\"y\" 로 설정된 경우, 선택된 기사의 페이지 분리된 보기로 연결된 \"추가\" 라는 라벨이 붙은 버튼을 표시",
"Absolute URL" => "절대 URL",
"If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "\"y\" 로 설정될 경우, 몇몇 링크들은 상대적 URL 대신 절대적 URL 을 사용합니다. 예를 들면, 모듈이 회보 안에 담겨 발송될 경우 깨진 링크를 피할 수 있게됩니다",
"If set to 0, will take the topicId of the article if in an article" => "0으로 설정된 경우, 기사 안에 있을 경우, 기사의 토픽ID 를 취할 것입니다.",
"Tiki Assistant" => "티키 보조도구",
"Display an assistant to guide new Tiki admins" => "새 티키 관리자를 안내할 보조 표시",
"Newest Blog Post Comments" => "최신 블로그 게시물 댓글들",
"Displays the specified number of the blog post comments most recently added" => "블로그 게시물 댓글 중 가장 최근에 추가된 것들을 지정된 수만큼 표시",
"No date" => "날짜 없음",
"If set to \"y\", the date of comments is not displayed in the module box" => "\"y\" 로 설정될 경우, 댓글의 날짜는 모듈 상자에 표시되지 않습니다",
"Verbose tooltips" => "자세한 정보 표시 툴팁",
"If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "\"y\" 로 설정된 경우, 블로그 게시물 제목이 툴팁으로써만 보이고, 표시되지는 않습니다",
"Options: \"y,n\"" => "선택사항: \"y,n\"",
"Last-Visited Pages" => "최근-방문된 페이지",
"Displays the last Wiki pages visited by the user" => "사용자에 의하여 마지막으로 방문된 위키 페이지 표시",
"Maximum number of characters in page names allowed before truncating" => "줄이기 전에 허용된 페이지명 내부의 문자 최대 수",
"Show Namespace" => "네임스페이스 표시",
"Show namespace prefix in page names" => "페이지명에 네임스페이스 접두어 표시",
"A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "귀하의 위치의 계층. 예: 홈 > 구역1 > 하위구역 C",
"Label preceding the crumbs" => "Crumb 앞에 오는 레이블",
"Menu Id" => "메뉴 ID",
"Menu to take the crumb trail from" => "Crumb 흔적을 취할 메뉴",
"Menu Start Level" => "메뉴 시작 단계",
"Lowest level of the menu to display" => "표기할 메뉴의 최저 단계",
"Menu Stop Level" => "메뉴 정지 단계",
"Highest level of the menu to display" => "표기할 메뉴의 최고 단계",
"Show Site Crumb" => "사이트 Crumb 표시",
"Display the first crumb, usually the site, when using menu crumbs" => "메뉴 crumb 사용 시, 첫 번째 crumb 표시, 일반적으로 사이트,",
"Show Page Crumb" => "페이지 Crumb 표시",
"Display the last crumb, usually the page, when using menu crumbs" => "메뉴 crumb 사용 시, 마지막 crumb 표시, 일반적으로 페이지.",
"Show Crumb Links" => "Crumb 링크 표시",
"Display links on the crumbs" => "crumb 에 링크 표시",
"Includes a calendar or a list of calendar events" => "달력 혹은 달력 이벤트의 목록 포함",
"Calendars filter" => "달력 필터",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "달력 식별자의 목록으로 설정된 경우, 식별된 달력 내부의 것들로 이벤트를 제한합니다. 식별자는 수직 막대기 (\"|\"), 쉼표 (\",\") 혹은 콜론(\":\")으로 구분됩니다. 예제: \"13\", \"4,7\", \"31:49\". 기본으로 설정되지 않음",
"Displayed month (relative)" => "표기된 월 (상대적)",
"Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "표기될 달과 달 사이의 간격. -1 의 간격은 이전 달을 표기하게 됩니다. 이 선택사항을 설정한다는 것은 달력 보기 종류를 달별 보기로 한다는 것을 의미합니다. 예제 값: 2, 0, -2, -12",
"View type" => "보기 유형",
"Determines how to show events. Possible values: %0, %1" => "이벤트를 어떻게 표시할 지 결정함. 가능한 값들: %0, %1",
"Calendar view type time span" => "달력 보기 종류 시간 범위",
"If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "달력 (혹은 \"표\") 보기 유형 내부인 경우, 달력에 의하여 표시되는 시간 범위를 결정함. 가능한 값:  %0, %1, %2, %3 ,%4, %5. 달력 내부에서 이 시간 범위를 변경하는 사용자는 모듈이 자신에게 표시하는 시간 범위를 변경할 수 있음",
"Show action" => "작업 표시",
"Viewmode when clicking on a day" => "날짜를 클릭했을 때 보기 모드",
"Put a link on all the days , not only those with event" => "이벤트를 지닌 날짜들을 포함 모든 날짜에 링크 넣기, ",
"View navigation bar" => "탐색 바 보기",
"Cart" => "카트",
"Displays the content of the cart, allows quantities to be modified and proceeds to payment" => "카트의 컨텐츠를 표시, 양의 수정을 허용 및 지불로 진행",
// "Use AJAX" => "Use AJAX",
// "Use AJAX services for managing the cart" => "Use AJAX services for managing the cart",
// "Show Items" => "Show Items",
// "Shows the items in the cart as they are added" => "Shows the items in the cart as they are added",
// "Shows the number of items in the cart" => "Shows the number of items in the cart",
// "Checkout URL" => "Checkout URL",
// "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated" => "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated",
// "(Default empty: Goes to tiki-payment.php)" => "(Default empty: Goes to tiki-payment.php)",
// "Post-Payment URL" => "Post-Payment URL",
// "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc" => "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc",
// "Show Total Weight" => "Show Total Weight",
// "Shows the weight of the items in the cart" => "Shows the weight of the items in the cart",
// "Shown after the weight" => "Shown after the weight",
// "Show Item Buttons" => "Show Item Buttons",
// "Shows add, remove and delete buttons on items" => "Shows add, remove and delete buttons on items",
"The quantities in your cart were updated" => "카트 내부의 양이 갱신되었습니다",
"Gift card added" => "선물카드 추가됨",
"Gift card not found" => "선물 카드 발견되지 않음",
"Gift card removed" => "선물 카드 제거됨",
"Displays links to categories as a tree" => "트리로써 범주로의 링크를 표시",
"Object type filter" => "개체 종류 필터",
"Object type filter to apply when accessing a linked category. Example values" => "연결된 범주에 접근할 때 적용할 개체 유형 필터. 예제 값",
"Deep" => "깊음",
"Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "연결된 범주에 접근할 때 하위범주 개체들 표시. 가능한 값: on (기본), off",
"Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "표시된 범주를 주어진 ID로 된 범주로 시작하는 범주의 하위트리로 제한함. 예제: 11. 기본: 0 (표시를 제한하지 않음)",
"Show these categories and their children" => "이 범주들과 그들의 자식들 표시",
"Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "이 범주들과 이들의 직계 자식 범주들만을 매개변수가 지정하는 순서로 표시. 예제: 3,5,6",
"Category links to a page named as the category" => "페이지로의 범주 링크가 범주로 명명됨",
"If y, category links to a page named as the category" => "y 인 경우, 범주는 범주로 명명된 페이지로 연결됩니다",
// "Hide Empty" => "Hide Empty",
// "If y, only categories with child objects will be shown" => "If y, only categories with child objects will be shown",
// "Only Children" => "Only Children",
// "If y, only direct child categories will be shown. Default: n" => "If y, only direct child categories will be shown. Default: n",
// "Custom URL" => "Custom URL",
// "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" " => "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" ",
"Category Transitions" => "범주 전이들",
"Displays controls to trigger category transitions and change the page's state according to predefined rules" => "범주 전이를 기동할 제어 표시 그리고 페이지의 상태를 사전정의된 규칙에 따라 변경",
"Example Transition" => "전이 예제",
"Change Category" => "범주 변경",
"Enables to categorize an object" => "개체를 범주화 가능",
// "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
"Category identifier" => "범주 식별자",
"Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "표기되는 범주의 루트를 기본 \"TOP\" 에서 주어진 식별자를 지닌 범주로 변경",
"Note that the root category is not displayed" => "루트 범주가 표기되지 않는다는 점에 유의하십시오",
"Defaults to 0 (root)" => "기본값을 0 (루트)로",
"No top" => "상단 없음",
"In non-detailed view, disallow uncategorizing. Example value: 1" => "상세하지 않은 보기에서, 범주해제의 허용 해제함. 예제 값: 1",
"Display path" => "경로 표시",
"Unless set to \"n\", display relative category paths in the category tree rather than category names" => "\"n\"으로 설정되어 있지 않다면,범주 이름 보다는 범주 트리 내부의 관련 범주 경로들을 표기",
"Paths are relative to the root category, which is not displayed" => "경로는, 표시되지 않는, 루트 범주에 상대적입니다.",
"Multiple categories" => "다중 범주",
"If set to \"n\", only allows categorizing in one category (from those displayed)" => "\"n\" 으로 설정된 경우, (표시된 것들  중에서) 한 범주으로만 범주화를 허용합니다 ",
"Categorize" => "범주화",
"String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "여러 개의 범주가 활성화되었일 때, 새 범주를 제출할 버튼 상에 표시될 문자열. 기본값: 범주화",
"Shy" => "부끄러움",
"If set to \"y\", the module is not shown on pages which are not already categorized" => "\"y\" 로 설정될 경우, 모듈이 이미 범주화되지 않은 페이지 상에서는 보이지 않습니다",
"Detailed" => "자세히",
"If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "\"y\" 로 설정될 경우, 개체가 들어있는 범주의 목록을 표시합니다. 삭제가 비활성화 되지 않은 경우, 목록으로 실행됩니다",
"If set to \"n\", the detailed list of categories will not offer to unassign a category" => "\"n\"으로 설정된 경우, 범주의 상세 목록 범주를 할당해지할 기회를 제공하지 않을 것입니다",
"If set to \"y\", allow to assign new categories" => "\"y\" 로 설정된 경우, 새 범주 할당을 허용합니다",
"Example values: y, n" => "예제 값: y, n",
"Default value: y" => "기본값: y",
"Group filter" => "그룹 필터",
"Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "매우 특정적 필터 선택사항. \"y\"로 설정된 경우, 사용자 그룹 중 하나에 일치하는 이름을 지닌 범주와 이러한 일치하는 범주의 자손들만 표시됨",
"Default value: n" => "기본값: n",
"Image URL not in category" => "범주안에 있지 않은 그림 URL",
"Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "매우 특정적 매개변수. 이것과 \"범주 내의 그림 URL\"이 둘 다 설정되고 루트 범주가 한 개의 자식 범주를 포함하는 경우, 모듈은 해당 개체가 범주 안에 있지 않은 경우 이 URL로 된 그림만 표시합니다",
"Image URL in category" => "범주 내의 그림 URL",
"Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "매우 특정적 매개변수. 이것과 \"범주 안에 있지 않은 그림 URL\"이 둘 다 설정되고 루트 범주가 한 개의 자식 범주를 포함하는 경우, 모듈은 해당 개체가 범주 안에 있는 경우에만 이 URL로 된 그림만 표시합니다",
"Categorize %s" => "%s 을 범주화",
"Categorize %s in %s" => "%s 을 %s 내부에서 범주화",
// "Collapse Button" => "Collapse Button",
// "Bootstrap collapse button" => "Bootstrap collapse button",
// "CSS selector defining which objects get collapsed" => "CSS selector defining which objects get collapsed",
// "CSS class for containing DIV element" => "CSS class for containing DIV element",
// "CSS selector defining the collapsing objects' container" => "CSS selector defining the collapsing objects' container",
"Received Objects" => "수신된 개체들",
"Displays the number of pages received (via Communications)" => "(통신을 통하여) 수신받은 페이지의 수 표시",
"Contributors" => "기여자",
"Lists the contributors to the wiki page being viewed and some information on them" => "보고있는 위키 페이지에 기여내역과 추가 정보를 나열",
"Shows the credits a user has" => "사용자가 보유한 신용 표시",
"Newest Directory Sites" => "최신 디렉터리 사이트",
"Displays the specified number of the directory sites most recently added" => "가장 최근에 추가된 디렉터리 사이트를 지정된 수만큼 표시",
"Directory category identifier" => "디렉터리 범주 식별자",
"If set to a directory category identifier, only displays the sites in the specified directory category" => "디렉터리 범주 식별자로 설정된 경우, 지정된 디렉터리 범주 내의 사이트들만 표시",
"If set to \"y\", displays a button labelled \"More\" that links to the directory" => "\"y\" 로 설정된 경우, 디렉터리로 연결된 \"추가\" 라는 라벨이 붙은 버튼을 표시",
"Show description" => "설명 표시",
"If set to \"y\", the description of the directory site appears" => "\"y\" 로 설정될 경우, 디렉터리 사이트의 설명이 나타납니다",
"Maximum length of description" => "설명의 최대 길이",
"If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "desc = \"y\" 경우,  디렉터리 사이트의 최대길이를 설정하기 위하여 maxdesc 를 (문자 단위) 사용하십시오 . 최대값 없음으로 설정하려면 비어두십시오 (설명전체를 표시함)",
"Default: blank" => "기본: 비어있음",
"Directory Statistics" => "디렉터리 통계",
"Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "디렉터리에 관한 통계를 확인된 및 확인해야 할  사이트의 수와 범주, 검색, 방문된 링크의 의 수 등등을 포함하여 표시",
"Top Directory Sites" => "상위 디렉터리 사이트들",
"Displays the specified number of the directory sites from most visited to least visited" => "디렉터리 사이트를 가장 최근에 많이 방문된 것부터 가장 적게 방문된 순서로 지정된 수만큼 표시",
// "Domain Password" => "Domain Password",
// "Store personal passwords for other domains securely in Tiki" => "Store personal passwords for other domains securely in Tiki",
// "System the credentials apply for. The name must match a defined Password Domain" => "System the credentials apply for. The name must match a defined Password Domain",
// "Use current user" => "Use current user",
// "Use the currently logged-in user. The username is not editable. (y/n) Default: y" => "Use the currently logged-in user. The username is not editable. (y/n) Default: y",
// "Can Update" => "Can Update",
// "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n" => "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n",
// "Show domain prompt" => "Show domain prompt",
// "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y" => "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y",
// "No Password Domains found" => "No Password Domains found",
// "Domain is not valid" => "Domain is not valid",
// "No domain specified" => "No domain specified",
// "No user defined" => "No user defined",
// "No password saved" => "No password saved",
// "Read error" => "Read error",
// "No password specified" => "No password specified",
// "No username specified" => "No username specified",
// "Failed to save password" => "Failed to save password",
// "Failed to save user" => "Failed to save user",
// "Saved OK" => "Saved OK",
"Facebook" => "페이스북",
"Shows the Wall of a user" => "사용자의 담벼락 표시",
"Tiki user to show Facebook wall of" => "해당 페이즈북 담벼락을 표시할 티키 사용자",
"Show username in timeline. y|n" => "시간표시줄에 유저명 표시. y|n",
"user not registered with facebook" => "사용자가 페이스북에 등록하지 않음",
"No username given" => "주어진 사용자명 없음",
"Featured Links" => "추천 링크",
"Displays the site's first featured links" => "사이트의 첫 번째 추천 링크 표시",
"Displays links to file galleries" => "파일 갤러리로의 링크를 표시",
"Top-Rated Topics" => "최고 등급 토픽들",
"Displays the specified number of the forum topics with the best ratings" => "최상 등급의 게시판 게시물의 지정된 숫자만큼 표기",
"Newest Forum Posts" => "최신 게시판 게시물",
"Displays the latest forum posts" => "최근 게시판 게시물을 표기",
"Topics only" => "토픽만",
"If set to \"y\", only displays topics" => "\"y\" 로 설정될 경우, 토픽만을 표시합니다",
"List of forum identifiers" => "게시판 식별자의 목록",
"If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "게시판 식별자의 목록으로 설정된 경우, 게시물을 식별된 게시판 안의 것들로 제한합니다. 식별자는 콜론 (\":\") 으로 구분됩니다",
"Show date" => "날짜 보기",
"If set to \"y\", show post date directly instead of as tooltip" => "\"y\" 로 설정될 경우, 툴팁 대신으로써 게시 날짜를 직접 표시합니다",
"Show time" => "시간 표시",
"Show times after dates" => "날짜 뒤에 시간 표시",
"If set to \"y\", show post author directly instead of as tooltip" => "\"y\" 로 설정될 경우, 툴팁 대신으로써 게시물 저자를 직접 표시합니다",
"Most Commented Forums" => "가장 댓글 많은 게시판",
"Display the specified number of the forums with the most comments" => "지정된 수의 가장 댓글이 많은 게시판을 표기",
"Top Visited Forum Topics" => "가장 많이 방문된 게시판 토픽들",
"Display the specified number of the forum topics with the most reads" => "지정된 수의 가장 많이 읽힌 게시판 토픽을 표기",
"Top Visited Forums" => "가장 많이 방문된 게시판들",
"Display the specified number of the forums with the most visits" => "지정된 수의 가장 많이 방문된 게시판 표기",
"Tags Editor" => "태그 편집기",
"Shows current tags and enables adding and removing some if permissions allow" => "현재 프리태그를 표시하고 권한이 허용하는 경우 일부를 추가 혹은 삭제를 활성화함",
"Wiki Page Tags" => "위키 페이지 태그",
"Displays current tags on wiki pages and enables adding tags if permissions allow" => "위키 페이지 상에 현재 프리태그들을 표시하고 권한이 허용할 경우 태그를 더하기 위하여 사용함",
"Similar-Tag Items" => "유사-태그 항목",
"Shows content with multiple tags in common" => "공통인 여러 개의 프리태르고된 컨텐츠 표시",
"Type of objects to extract" => "추출할 개체의 유형",
"Most Popular Tags" => "가장 인기있는 태그",
"Shows the most popular tags. More popularity is indicated by a larger font" => "가장 인기있는 프리태그를 표시. 인기가 높을 수록 더 큰 폰트로 표시됨",
"Display type" => "표기 유형",
"If set to \"cloud\", links are displayed as a cloud" => "\"cloud\" 로 설정된 경우, 링크는 구름으로 표시 됨",
"Default: \"list\"" => "기본: \"목록\"",
"Maximum elements" => "최대 요소",
"If set to a number, limits the number of tags displayed" => "숫자로 지정된 경우, 표시될 태그의 숫자를 제한",
"BlogId" => "블로그ID",
// "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5" => "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5",
"My Preferred Tags" => "내 선호 태그",
"Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size" => "등록한 사용자가 태그를 추가한 개체의 숫자에 기반하여 사용자가 선호하는 프리태그를 표시, 크기가 더 큰 폰트가 더 높은 선호도를 의미함",
"My preferred tags" => "내 선호 태그",
// "Displays a list of friends" => "Displays a list of friends",
// "GIT detail" => "GIT detail",
// "GIT commit and last update information" => "GIT commit and last update information",
"Google Search" => "Google 검색",
"Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "구글로 검색하는 간단한 형식 표시. 기본으로 검색 결과는 티키 사이트 상의 결과로 제한되어 있습니다",
"Groups Emulation" => "그룹 이뮬레이션",
"Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "더 적은 그룹들의 사용자들이 사이트를 어떻게 경험하는지를 보기 위하여 개인의 그룹 멤버십을 임시로 변경 사용",
// "Show All Groups" => "Show All Groups",
// "If set to \"n\", the list is not shown" => "If set to \"n\", the list is not shown",
// "Show Your Groups" => "Show Your Groups",
"Emulate Groups" => "그룹 에뮬레이트",
"Last Actions" => "마지막 작업",
"Displays the specified number of last actions" => "마지막 작업을 지정된 수만큼 표시",
"Show user" => "사용자 표시",
"If set to \"y\", user names are displayed in the module box" => "\"y\" 로 설정될 경우, 사용자명은 모듈 상자 안에서 표시됩니다",
"If set to \"y\", action dates are displayed in the module box" => "\"y\" 로 설정된 경우, 작업 날짜가 모듈 상자 내부에 표시됩니다",
"Maximum number of characters in action descriptions before truncating" => "작업 설명 내부의 줄이기 전의 문자 최대 수",
"Newest Blog Posts" => "최근 블로그 포스트",
"Lists the specified number of blogs posts from newest to oldest" => "블로그 게시물의 지정된 수만큼 새것에서 오래된 것 순으로 나열함",
"If set to \"y\", the date of posts is not displayed in the module box" => "\"y\" 로 설정될 경우, 게시의 날짜는 모듈 상자에 표시되지 않습니다",
"Blog identifier" => "블로그 식별자",
"If set to a blog identifier, restricts the blog posts to those in the identified blog" => "블로그 식별자로 설정된 경우, 블로그 게시물을 식별된 블로그 안의 것들로 제한함",
"Newest Category Items" => "최신 범주 항목",
"Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "주어진 범주 내의 주어진 유형의 개체의 지정된 수만큼 나열, 가장 최근 만들어짐부터 시작",
"Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "개체가 나열될 범주의 식별자. 자식 범주안에만 있는 개체들은 표시되지 않을 것입니다",
"Maximum number of characters in object names allowed before truncating" => "줄이기 전에 허용된 개체명 내부의 문자 최대 수",
"Type of the objects to list. Example values" => "나열할 개체의 유형. 예제 값",
"no object here yet" => "아직 여기에 개체 없음",
"Newest Blogs" => "최근 작성된 블로그",
"Displays the specified number of blogs from newest to oldest" => "블로그를 가장 새 것부터 가장 오래된 것으로 지정된 수만큼 표시",
"Newest FAQs" => "최근 작성된 FAQ",
"Displays the specified number of FAQs from newest to oldest" => "FAQ 를 가장 새것에서 가장 오래된 것으로 지정된 수만큼 표시",
"Newest Quizzes" => "최근 작성된 퀴즈",
"Displays the specified number of quizzes from newest to oldest" => "퀴즈를 지정된 수만큼 가장 새것부터 오래된 것을 표시",
"Last-Modified File Galleries" => "최근-수정된 파일 갤러리",
"Display the specified number of file galleries, starting from the most recently modified" => "지정된 수의 파일 갤러리 표기, 가장 최근에 수정된 것부터 시작",
"Newest Files" => "최근 파일",
"List the specified number of files, starting from the most recently added" => "파일을 가장 최근 추가된 것부터 시작하여 지정된 수만큼 나열",
"Gallery identifiers" => "갤러리 식별자",
"If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "파일 갤러리 식별자으 세트로 설정된 경우, 파일을 식별된 갤러리의 내부의 것들로만 제한합니다. 이 값은 정수의 콜론으로 구분된 시퀀스입니다",
"Example value: 13, 2:13, 1:2:3:5:6" => "예제 값: 13, 2:13, 1:2:3:5:6",
"Last-Modified Image Galleries" => "최근-수정된 그림 갤러리",
"Displays the specified number of image galleries, starting from the most recently modified" => "그림 갤러리를 지정된 수만큼 표시, 가장 최근에 수정된 것부터 시작",
"Newest Images" => "최신 그림",
"List the specified number of images, starting from the most recently added" => "그림을 지정된 수만큼 가장 최근 추가된 것부터 나열",
"Gallery identifier" => "갤러리 식별자",
"If set to an image gallery identifier, restricts the images to those in the identified gallery" => "그림 갤러리 식별자로 설정된 경우, 그림을 식별된 갤러리 내부의 것들로 제한합니다",
"Link content" => "링크 컨텐츠",
"Display the links as image names or thumbnails" => "그림 이름 혹은 축소 그림판으로써 링크 표시",
"Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "가능한 값: \"names\" 혹은 \"thumbnails\". 기본값: \"names\"",
"Last-Modified Events" => "최근-수정된 이벤트",
"Display the specified number of calendar events, starting from the most recently modified" => "지정된 수의 달력 이벤트 표기, 가장 최근에 수정된 것부터 시작",
"Calendar Identifier" => "달력 식별자",
"If set to a calendar identifier, restricts the events to those in the identified calendar" => "달력 식별자로 설정된 경우, 이벤트를 식별된 달력 안의 것들로 제한함",
"Maximum number of characters in event names allowed before truncating" => "줄이기 전에 허용된 이벤트명 내부의 문자 최대 수",
"Hide Date" => "날짜 감춤",
"If set to \"y\", it will hide date" => "\"y\" 로 설정된 경우, 날짜를 감춥니다.",
"Latest Changes" => "마지막변경",
"List the specified number of pages, starting from the most recently modified" => "페이지를 지정된 수만큼 가장 최근 수정된 것부터 나열",
"Link Target" => "링크 대상",
"Target URL of the \"...more\" link at the bottom of the module" => "모듈의 하단에 \"...추가\" 링크의 목표 URL",
"Last-Modified Blogs" => "최근 변경된 블로그",
"Displays the specified number of blogs, starting from the most recently modified" => "블로그를 링크와 함게 지정된 수만큼 표시, 가장 최근에 수정된 것부터 시작",
"Newest Podcasts" => "최신 팟캐스트",
"Displays Podcasts" => "팟캐스트를 표시",
"File galleries IDs" => "퍄일 갤러리 ID",
"List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "\"팟캐스트 (음성)\" 유형의 파일 갤러리의 ID의 목록. 식별자는 콜론 (\":\")으로 구분됨. 없는 경우, 모든 파일 갤러리가 스캔될 것입니다",
"Width of mediaplayer in pixels" => "픽셀단위로 된 미디어재생기의 넓이",
"Height of mediaplayer in pixels" => "미디어플레이어의 픽셀단위 높이",
"Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "mp3 재생기로의 경로. 일 예로, player_mp3_maxi.swf 를 http://flash-mp3-player.net/players/maxi/download/ 에서 media/ 디렉터리로 다운로드한 경우  media/player_mp3_maxi.swf (해당 디렉터리가 만들어지거나 다른 위치를 선택할 수 있습니다)",
"Bottom Link URL" => "맨 아래 링크 URL",
"URL for a link at bottom of module" => "모듈의 하단의 링크에 대한 URL",
"Bottom Link URL Text" => "맨 아래 링크 URL 텍스트",
"Text for link if Bottom Link URL is set" => "하단 링크 URL 이 설정된 경우 링크에 대한 텍스트",
"More Podcasts" => "추가 팟캐스트",
"Verbose" => "자세한 정보 표시",
"Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "\"y\" 일 경우재생기 하단에 팟캐스트의 설명 표시, 그리고 \"n\" 일 경우 제목에 마우스오버 일 때 표시",
"Newest Article Submissions" => "최신 기사 투고",
"Lists the specified number of article submissions from newest to oldest" => "기사 제출의 지정된 수만큼 새것에서 오래된 것 순으로 나열함",
"Newest Tracker Comments" => "최신 트래커 댓글",
"Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "트래커 댓글의 지정된 수만큼 (선택적으로 지정된 트래커 혹은 트래커 항목 내부의 것들로 제한 가능) 최근 게제된 것부터 시작하여 나열함",
"Tracker identifier" => "트래커 식별자",
"If set to a tracker identifier, only displays the comments on the given tracker" => "트래커 식별자로 설정된 경우, 주어진 트래커 상의 댓글만 표기합니다",
"Item identifier" => "항목 식별자",
"If set to an item identifier, only displays the comments on the given item" => "항목 식별자로 설정된 경우, 주어진 항목에 댓글을 표시합니다",
"Newest Tracker Items" => "최신 트래커 항목",
"Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "트래커 항목의 지정된 수의 필드의 값을 표시. 지징된 트래커가 주 필드가 없다면, 필드명 혹은 필드 식별자가 필수임",
"Identifier of the tracker from which items are listed" => "항목들이 나열될 트래커의 식별자",
"Field identifier" => "필드 식별자",
"Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "값들이 나열될 필드의 식별자. 필드명이 설정된 경우, 이 매개 변수는 무시됩니다",
"Field name" => "필드명",
"Name of the field from which values are listed" => "값들이 나열된 필드의 이름",
"Example value: age" => "예제 값: 나이",
"Specifies how the items should be sorted" => "항목이 어떻게 정렬될 것인지를 지정함",
"Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "가능한 값은 created 과 created_asc (동일함), created_desc, status, lastModif, createdBy 및 lastModifBy 을 포함합니다. \"_desc\" 가 지정되지 않는 경우라면, 정렬은 오름차순입니다. \"created\"는 기사 만들기 날짜로 정렬합니다. \"lastModif\"는 항목의 최종 수정 날짜로 정렬합니다. \"lastModif_desc\"는 최종 수정 날짜의 내림차순으로 정렬합니다",
"Status filter" => "상태 필터",
"If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "설정되면, 나열된 항목을 주어진 상태의 것으로 제한합니다. 값은 \"o\" (열림), \"p\" (보류) 및 \"c\" (닫힘)의 조합입니다. 가능한 값",
"Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "표시할 필드 결정 불가능. 트래커 식별자가 유효하지 않을 수 있음, 혹은 트래커가 주 필드가 없음 그리고 필드 식별자 및 필드명이 둘 다 설정되지 않음",
"You do not have permission to view this tracker" => "이 트래커를 볼 권한이 없습니다",
"Last Items" => "최근 아이템",
"Last modified Items" => "최근 변경된 아이템",
"Newest Validated FAQ Questions" => "최신 유효화된 FAQ 질문",
"Displays the specified number of validated questions FAQs from newest to oldest" => "확인된 질문 FAQ를 최신에서 오래된 순으로 지정된 수만큼 표시",
"FAQ identifier" => "FAQ 식별자",
"If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ" => "FAQ 식별자로 설정된 경우, 식별된 FAQ 안에서만 선택된 질문을 제한",
"Last Visitors" => "마지막 방문객",
"Displays information about the specified number of users in decreasing order of last login time" => "마지막 로그인 시간의 내림 차순으로 지정된 수의 사용자에 관한 정보를 표시",
"Show profile pictures" => "아바타 표시",
"If set to \"y\", show user profile pictures" => "\"y\" 로 설정될 경우, 사용자 아바타를 표시합니다",
"Maximum number of characters in user names allowed before truncating" => "줄이기 전에 허용된 사용자명 내부의 문자 최대 수",
"Don't show date" => "날짜를 표기 안합니다",
"YouTube Playlist" => "유튜브 재생목록",
"Display a YouTube playlist" => "유튜브 재생목록 표시",
"Playlist ID" => "재생목록 ID",
"ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "표시할 유튜브 재생목록의 ID (전체 URL이 아님). 예:  id=4DE69387D46DA2F6",
// "Google YouTube API Key" => "Google YouTube API Key",
"Width of each video in pixels" => "픽셀단위로 된 각각의 동영상 넓이",
"Height of each video in pixels" => "각 동영상의 픽셀단위 높이",
// "Allow FullScreen" => "Allow FullScreen",
"Bottom Link" => "맨 아래 링크",
"Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "모듈의 하단의 링크에 대한 URL. 예: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
"Bottom Link Text" => "맨 아래 링크 텍스트",
"Text for link if link_url is set, otherwise 'More Videos'" => "link_url 가 설정된 경우 링크에 대한 텍스트, 그 외의 경우 '추가 동영상'",
"Video Descriptions" => "동영상 설명",
"Display description of video on title mouseover if 'y'. Default is 'y'" => "'y' 일 경우 제목에 마우스오버일 때 동영상의 설명 표시. 기본값은 'y'",
"Order by" => "다음 조건으로 정렬됨",
"Criteria to order by the videos in the list. Default is 'position'" => "목록 내부의 동영상에 의한 순서를 정할 조건. 기본은 '위치'",
"position" => "위치",
"commentCount" => "댓글수",
"duration" => "기간",
"published" => "게시됨",
// "reversedPosition" => "reversedPosition",
"title" => "제목",
"viewCount" => "보기회수",
// "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
"No Playlist found" => "재생목록 발견되지 않음",
"No Playlist ID was provided" => "재생목록 ID가 제공되지 않음",
"Live Support" => "실시간 지원",
"Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "사용자에게 실시간 지원 운영자가 있는지를 말하고 가능할 경우, 사용자에게 지원요청을 하는 것을 허용. 사용자가 운영자일 경우, 운영자 콘솔로 연결함",
"Server Load" => "서버 로드",
"Report of server resources used" => "사용된 서버 자원의 보고",
// "Locator" => "Locator",
"Presents a map with the geolocated content within the page" => "페이지 내부에서 지도를 지리적 위치 지정된 컨텐츠와 함께 제공",
// "Preference \"%0\" is disabled" => "Preference \"%0\" is disabled",
"Log-in box" => "로그인 상자",
"Input size" => "입력 크기",
"Number of characters for username and password input fields" => "사용자명과 암호 입력 필드에 대한 글자 수",
"Display mode: module, header or popup. Leave empty for module mode" => "표시 모드: 모듈, 헤더 혹은 팝업. 모듈 모드에 대해서 빈 상태로 두십시오",
"Show Register" => "등록 표시",
"Show the register link" => "등록 링크 표시",
"Show I Forgot" => "분실했습니다 보기",
"Show the \"I forgot my password\" link" => "\"암호를 분실했습니다\" 링크 표시",
"Show Remember me" => "기억하기 표시",
"Show the \"Remember me\" checkbox" => "\"기억하기\" 체크상자 표시",
// "Show user avatar" => "Show user avatar",
// "Show the user avatar when in popup mode" => "Show the user avatar when in popup mode",
// "Show user name" => "Show user name",
// "Show the user name when in popup mode" => "Show the user name when in popup mode",
// "Groups for switch user listing" => "Groups for switch user listing",
// "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")" => "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")",
// "Menu ID" => "Menu ID",
// "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"" => "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"",
"Logo" => "로고",
"Site logo, title and subtitle" => "사이트 로고, 제목, 및 부제",
// "Image URL" => "Image URL",
// "Image to use. Defaults to sitelogo_src preference" => "Image to use. Defaults to sitelogo_src preference",
// "CSS colour to use as background. Defaults to sitelogo_bgcolor preference" => "CSS colour to use as background. Defaults to sitelogo_bgcolor preference",
// "Image title attribute. Defaults to sitelogo_title preference" => "Image title attribute. Defaults to sitelogo_title preference",
// "Alt" => "Alt",
// "Image alt attribute. Defaults to sitelogo_alt preference" => "Image alt attribute. Defaults to sitelogo_alt preference",
// "URL for the image and titles link. Defaults to \"./\"" => "URL for the image and titles link. Defaults to \"./\"",
// "Logo Title" => "Logo Title",
// "Large text to go next to image. Defaults to sitetitle preference" => "Large text to go next to image. Defaults to sitetitle preference",
// "Logo Subtitle" => "Logo Subtitle",
// "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference" => "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference",
// "Logo Class" => "Logo Class",
// "CSS class for the image container div. Defaults to sitelogo" => "CSS class for the image container div. Defaults to sitelogo",
// "Title Class" => "Title Class",
// "CSS class title text container div. Defaults to sitetitles" => "CSS class title text container div. Defaults to sitetitles",
"Map Feature Editor" => "지도 기능 편집기",
"Allows shapes to be drawn over the map" => "지도 상에 도형 그리기 허용",
"Tracker to store the feature in" => "기능을 안에 저장할 트래커",
"Hidden Input" => "숨겨진 입력",
"Hidden values to be sent over to the dialog. fieldName(value)" => "대화상자 너머로 전송될 감춰진 값. fieldName(값)",
"Standard controls" => "표준 제어",
"Dispay the standard draw controls" => "표준 그리기 제어를 표시",
// "Mode change on insert" => "Mode change on insert",
// "Target mode to enter after successfully inserting an item" => "Target mode to enter after successfully inserting an item",
// "Edit details" => "Edit details",
// "Edit the tracker item's details through a dialog after the initial item creation" => "Edit the tracker item's details through a dialog after the initial item creation",
"Layer Selector" => "레이어 선택기",
"Include base layer" => "베이스 레이어 포함",
"Include the drop list for the base layers" => "베이스 레이어에 대한 드롭 목록 포함",
"Include optional layers" => "선택적 레이어 포함",
"Include the checkboxes for the optional layers" => "선택적 레이어에 대한 체크상자 포함",
"Replace the map's built-in layer controls" => "지도의 내장된 레이어 제어를 교체",
"Mode Selector" => "모드 선택기",
"Toggle input modes for the map" => "지도에 대한 입력 모드 토글",
"Map location search" => "지도 위치 검색",
"Simple search controls for the map" => "지도에 대한 단순 검색 제어",
"Menu" => "메뉴",
"Displays a menu or a structure as a menu" => "메뉴 혹은 구조체를 메뉴로 표기합니다",
"Identifier of a menu (from tiki-admin_menus.php)" => "메뉴의 식별자 (tiki-admin_menus.php 에서)",
"Structure" => "구조체",
"Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "위키 페이지의 구조체의 식별자 (tiki-admin_structures.php 에서의 이름 혹은 번호)",
"Direction for menu: horiz or vert (default vert)" => "메뉴의 방향: horiz(가로) 혹은 vert(세로) (기본값 vert)",
"CSS/Superfish" => "CSS/수퍼피시",
// "Use CSS Superfish menu (if bootstrap = n). y|n (default y)" => "Use CSS Superfish menu (if bootstrap = n). y|n (default y)",
// "Use Bootstrap menus" => "Use Bootstrap menus",
// "Show Navbar Toggle Button" => "Show Navbar Toggle Button",
// "Used in Bootstrap navbar menus when viewport is too narrow for menu items" => "Used in Bootstrap navbar menus when viewport is too narrow for menu items",
// "The URL of the navbar brand (logo)" => "The URL of the navbar brand (logo)",
// "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu" => "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu",
// "CSS class(es) for the menu nav element" => "CSS class(es) for the menu nav element",
// "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar" => "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar",
// "DOM #id" => "DOM #id",
"Id of the menu in the DOM" => "DOM 내부의 메뉴의 ID",
"CSS class" => "CSS 클래스",
"Class of the menu container" => "메뉴 컨테이너의 클래스",
"Limit low visibles levels" => "하위 표시 단계 제한",
"All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "이 레벨에서 시작하는 모든 서브메뉴는 만약 URL이 이 레벨 혹은 상위 혹은 하위의 선택사항과 일치하면 표기될 것입니다",
"Limit top visible levels" => "상위 표시 단계 제한",
"Do not display options higher than this level" => "이 단계보다 높은 선택사항 표시 안 함",
"Link on Section" => "섹센에 링크",
"Create links on menu sections" => "메뉴 섹션에 링크 만들기",
"(y/n default y)" => "(y/n 기본값 y)",
"Translate labels" => "레이블 번역",
"Menu Cookie" => "메뉴 쿠키",
"Open the menu to show current option if possible" => "가능하면 현재 선택사항을 볼 메뉴 열기",
// "Set Selected" => "Set Selected",
// "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue" => "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue",
"One of these parameters has to be set" => "이 매개 변수 중 하나가 설정되어야 합니다",
"Menu Page" => "메뉴 페이지",
"Displays a Wiki page" => "위키 페이지 표시",
"Page to display in the menu. Example value: HomePage" => "메뉴에 표시될 페이지. 예: HomePage",
"Use default namespace" => "기본 네임스페이스 사용",
"Prepend the default namespace to the page name for localized menus per workspace (1/0)" => "작업공간 당 로컬라이즈된 메뉴에 대한 페이지명으로 기본 네임스페이스 앞에 붙임 (1/0)",
"Menu style" => "메뉴 스타일",
"Display the page as a menu (horiz / vert)" => "페이지를 메뉴로 표시 (horiz(가로) / vert(세로))",
"Wiki Structure Menu" => "위키 구조체 메뉴",
"Displays a structure" => "구조체 표시",
"N.B. Deprecated, use the Menu module instead" => "주의: 사용되지 않음, 메뉴 모듈을 대신 사용",
"Structure to display in the menu" => "메뉴 내부에 표시될 구조체",
"Unread Inter-User Messages" => "사용자간 메시지 읽지않음",
"Displays to users their number of new inter-user messages and a link to their message box" => "사용자에게 신규 사용자간 메시지의 수와 자신의 메시지상자로의 링크를 표시",
"Show If Empty" => "비어있을 경우 보기",
"Show the module when there are no messages waiting. y|n " => "대기 중인 메시지가 없을 때 모듈 표시 y|n",
"Default=y" => "기본=y",
"Messages" => "메시지",
"Small live chat box" => "작은 라이브 채팅 상자",
"Channels" => "채널들",
"List of chat channels. Channel names are separated by a comma (\",\")" => "채팅 채널의 목록. 채널명은 쉼표 (\",\")로 분리됨",
"By default, a single channel named \"default\" exists" => "기본으로, \"기본\"이란 이름의 한 개의 채널이 존재합니다",
"Mobile" => "모바일",
"Currently only shows switch to and from mobile mode" => "현재 모바일 모드 전환만 보임 ",
"To Label" => "수신 레이블",
"Switch to normal site label" => "일반 사이트 라벨로 전환",
"From Label" => "발신 레이블",
"Switch to mobile site label" => "모바일 사이트 라벨로 전환",
"Switch Perspective" => "Perspective 전환",
"Also switch perspective back to this one when leaving mobile mode" => "또한 모바일 모드에서 나올 때 Perspective를 이것으로 다시 돌려놓습니다",
"Stay" => "유지",
"Stay on same page" => "동일한 페이지에 남아있기",
"Switch to mobile site" => "모바일 사이트로 전환",
"Switch to normal site" => "일반 사이트로 전환",
"Months Links" => "월 링크",
"Link to articles or blog posts for the current month and those preceding it" => "이번 달에 대한 기사 혹은 블로그 게시물과 그 앞선 것들에 대한 링크",
"Type of objects to link to" => "링크할 개체의 유형",
"Possible values" => "가능한 값",
"\"blogs\" for blog posts, \"cms\" for published articles." => "블로그 게시물은 \"블로그\", 게시된 기사는 \"cms\".",
"Object Identifier" => "개체 식별자",
"Identifier of an object with children to link to" => "자식들을 가지고 있고 링크가 될 개체의 식별자",
"This is required for the blog Object type" => "블로그 개체 유형에 대하여 필수입니다",
"For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "예를 들면, 식별자 3과 블로그 개체 유형은 식별자 3을 보유한 블로그의 블로그 게시물들로의 링크를 표시합니다",
"List by month" => "달 별로 나열",
"Most Commented" => "가장 많이 댓글 달림",
"Display the most commented objects of a certain type" => "특정 유형의 가장 많이 댓글이 단 개체 표시",
"Type of objects to consider" => "고려할 개체의 유형",
"Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "가능한 값: wiki (위키페이지), blog (블로그 게시물), article (기사)",
"Language Filter" => "언터 필터",
"If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "RFC1766 언어 태그로 설정된 경우, 지정된 언어로 고려된 것들로만 개체를 제한합니다",
// "Request the creation of a mustread item based on the current object" => "Request the creation of a mustread item based on the current object",
// "Object Field" => "Object Field",
// "Permanent name of the field containing the object reference" => "Permanent name of the field containing the object reference",
// "Notifications Link" => "Notifications Link",
// "Shows an icon with the number of and a link to user notifications" => "Shows an icon with the number of and a link to user notifications",
"Pending Article Submissions" => "보류 중인 투고 기사",
"Displays the number of article submissions waiting examination and a link to the list" => "검토를 대기 중인 기사 제출의 수와 목록으로의 링크 표시",
"Old Articles" => "기존 기사",
"Displays the specified number of old articles (which do not show on articles home page anymore)" => "(기사 홈페이지에 더이상 보이지 않는) 오래된 기사를 지정된 수만큼 표시",
// "Package Module" => "Package Module",
// "A module that shows content from a Tiki Package View" => "A module that shows content from a Tiki Package View",
// "Name of package (vendor/name)" => "Name of package (vendor/name)",
// "Name of package in the form vendor/name" => "Name of package in the form vendor/name",
// "Name of the view file without the .php" => "Name of the view file without the .php",
// "Other parameters" => "Other parameters",
// "URL encoded string of other parameters (will not replace standard parameters)" => "URL encoded string of other parameters (will not replace standard parameters)",
"Payments Outstanding" => "미결 지불",
"Displays the payments outstanding for the current user" => "현재 사용자에 대하여 미결 금액을 표시",
// "List of active permissions for current object" => "List of active permissions for current object",
"Enables to change current perspective" => "현재 Perspective 변경 가능",
"Powered By" => "제공: ",
"Powered by Tiki, and others" => "티키와 기타 제공",
"Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "\"Tiki Wiki CMS 그룹웨어으로 구동됨\" 메시지를 표시",
"Tiki version info" => "티키 버전 정보",
"Shows theme credits (contents of credits.tpl)" => "테마 크레딧 표시 (credits.tpl 의 내용)",
"Shows various \"powered by\" icons" => "다양한 \"powered by\" 아이콘 표시",
"Quick Edit" => "빠른 편집",
"Enables to quickly create or edit Wiki pages" => "빠른 위키 페이지를 만들기 혹은 편집을 활성화",
"Deprecated - use the Search module instead" => "사용되지 않음 - 검색 모듈을 대신 사용하십시오",
"Template identifier" => "템플릿 식별자",
"If set to a template identifier, the specified template is used for creating new Wiki pages" => "템플릿 식별자로 설정된 경우, 지정된 템플릿은 새 위키 페이지를 만들 때 사용됩니다",
"If set, send the form to the given location (relative to Tiki's root) for processing" => "설정되면, 처리를 위하여 (티키의 루트에 상대적인) 주어진 위치 로 형식을 보냅니다",
"SUBMIT label" => "라벨 제출",
"The label on the button to submit the form" => "서식을 제출할 버튼 상의 레이블",
"Create/Edit" => "만들기/편집",
"INPUT SIZE" => "입력 크기",
"Size attribute (horizontal, in characters) of the text input field for page names" => "페이지명의 텍스트 입력 필드의 크기 특성 (가로, 글자단위)",
"Optional heading to display at the top of the module's content" => "모듈의 컨텐츠의 상단에 표시할 선택적 제목",
"Category to preselect" => "사전선택 할 범주",
"If set, pages created through the module have this category prechecked to be categorized in" => "설정된 경우, 모듈을 통해서 만들어진 페이지들은 범주화가 될 이 범주로 사전에 체크가 됩니다",
"Tip to be shown" => "표시될 팁",
"Custom text to be shown as a tip at the top of the edit page" => "편집 페이지의 상단에 팁으로 표시하는 사용자 지정 텍스트",
"Title of tip to be shown" => "표시될 팁의 제목",
"Custom title to be shown for the tip at the top of the edit page" => "편집 페이지의 상단에 팁에 대하여 표시하는 사용자 지정 제목",
"Custom header template" => "사용자 지정 헤더 템플릿",
"Wiki page to be used as a template to show content on top of edit page" => "편집 페이지 상단에 컨텐츠를 표시할 템플릿으로 사용될 위키 페이지",
"Quick Edit a Wiki Page" => "위키 페이지 빠른 편집",
"Quick Search" => "빠른 검색",
"Performs a search query and persists the results in the module for quick navigation access" => "검색 질의를 수행하고 빠른 탐색 접근을 위하여 결과를 모듈 내부에 유지",
"Filter object type" => "개체 유형 필터",
"Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "특정 개체 유형으로 검색 결과를 제한. 정적 필터로 사용하려면 개체 유형을 입력하거나, 입력을 제공하려면 \"selector\" 를 기입하십시오",
"Filter category" => "범주 필터",
"Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls" => "특정 갤러리로 검색 결과르 제한. 범주 ID 들의 쉼표로 분리된 목록을 입력하여 선택기 내부에 포함시키도록 하십시오. 한 개의 범주는 제어를 표시하지 않을 것입니다",
// "Quick Administration" => "Quick Administration",
// "Some helpful tools for administrators" => "Some helpful tools for administrators",
"Random Image" => "무작위 그림",
"Displays a random image" => "임의의 그림을 표기합니다",
"If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "그림 갤러리 식별자로 설정된 경우, 선택된 그림을 식별된 갤러리 내부의 것들로 제한합니다",
"Show link" => "링크 보기",
"If set to \"n\", the image thumbnail does not link to the image" => "\"n\" 으로 설정된 경우, 그림 축소보기가 그림에 연결되지 않습니다",
"Default: \"y\"" => "기본: \"y\"",
"Show name" => "이름 표시",
"If set to \"y\", the name of the image is displayed" => "\"y\" 로 설정될 경우, 그림의 이름이 표시됩니다",
"If set to \"y\", the description of the image is displayed" => "\"y\" 로 설정될 경우, 그림의 설명이 표시됩니다",
"Random Pages" => "무작위 페이지",
"Displays the specified number of random wiki pages" => "무작위 위키 페이지를 지정된 수만큼 표시",
"New User Registration" => "새 사용자 등록",
"Permit anonymous visitors to create an account on the site" => "익명 방문자들이 사이트에서 계정 만드는 것을 허용함",
"News Feeds" => "뉴스 피드",
"List of feeds available on this site" => "이 사이트에서 사용할 수 있는 피드의 목록",
"Multi-purpose search module (go or edit page by name and/or search site)" => "다목적 검색 모듈 (이름 및/혹은 검색 사이트에 의하여 페이지로 이동 혹은 편집)",
"Legacy Mode" => "레거시 모드",
"Setting to emulate previous behaviour" => "이전 작동을 에뮬레이트학 위한 설정",
"If set to \"y\" the search performed is a \"Tiki search\"" => "'y\" 로 설정된 경우, 수행된 검색은 \"티키 검색\"입니다",
" (full text search)" => "(전체 텍스트 검색)",
"Show Object Type Filter" => "개체 유형 필터 표시",
"If set to \"y\" shows a dropdown of sections to search" => "\"y\" 로 설정된 경우, 검색할 부분의 드롭다운을 표시합니다",
" (no object filter)" => "(개체 필터 없음)",
"Use autocomplete" => "자동완료 사용",
"If set to \"y\" input uses autocomplete for pagenames if applicable" => "\"y\"로 설정된 경우, 적용가능한 경우에 따라 입력이 페이지명에 대하여 자동완성을 사용합니다",
" (use autocomplete)" => "(자동완성 사용)",
"Advanced search" => "고급 검색",
"Use advanced (boolean) search (full text search only)" => "고급 (불리언) 검색 사용 (전체 텍스 검색에만 적용)",
" (use advanced search)" => "(고급 검색 사용)",
"Advanced search checkbox" => "고급 검색 체크상자",
"Show advanced search checkbox (full text search only)" => "고급 검색 체크상자 표시 (전체 텍스트 검색만)",
" (advanced search checkbox off)" => "(고급 검색 체크상자 꺼짐)",
"Advanced search help" => "고급 검색 도움말",
"Show advanced search help icon (full text search only)" => "고급 검색 도움말 아이콘 표시 (전체 텍스트 검색만)",
" (advanced search help off)" => "(고급 검색 도움말 꺼짐)",
"Show Search Button" => "검색 버튼 표시",
"Show search button" => "검색 버튼 표시",
" (do show search button)" => "(검색 버튼 보기)",
"Show Go Button" => "이동 버튼 보기",
"Show go to page button" => "페이지로 이동 버튼 보기",
" (do show go button)" => "(이동 버튼 보기)",
"Show Edit Button" => "편집 버튼 보기",
"Show edit button" => "편집 버튼 보기",
" (do show edit button)" => " (편집 버튼 표기)",
"Default Button" => "기본 버튼",
"Action to perform on entering <return>" => "진입 시 수행될 작업<return>",
" (search|go|edit)" => "(검색|이동|편집)",
"Search Form Action" => "검색 형식 작업",
" tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php 혹은 tiki-searchindex.php (티키 검색에 대하여)",
// "Search Submit Label" => "Search Submit Label",
"Go Form Action" => "이동 형식 작업",
// "Go Submit Label" => "Go Submit Label",
"Go" => "진행",
"Edit Form Action" => "서식 작업 편집",
"Edit Submit Label" => "제출 라벨 편집",
"Input field width" => "입력 필드 넓이",
"Width of the text input field (in characters)" => "텍스트 입력 필드의 넓이 (문자 단위)",
" 0 (leave automatic width)" => "0 (자동 폭 그대로 두기)",
"Select size" => "크기 선택",
"Size of the Search Filter dropdown list" => "검색 필터 드롭다운 목록의 크기",
"Edit Template identifier" => "템플릿 식별자 편집",
"If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "범주 식별자에게 설정되었을 경우, 모듈을 통해서 만들어진 페이지들은 지정된 범주 안으로 자동적으로 범주화됩니다",
"Compact mode" => "최소 모드",
"Makes the three buttons only appear on mouse-over" => "3 버튼들을 마우스가 위로 왔을 때에만 나타나게 합니다",
// "Additional filters" => "Additional filters",
// "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test" => "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test",
"Search is disabled" => "검색이 비활성화 되었습니다",
"Search for Wiki Page" => "위키 페이지에 대하여 검색",
// "More Like This" => "More Like This",
// "Uses the unified search to provide similar documents" => "Uses the unified search to provide similar documents",
// "Object Type Filters" => "Object Type Filters",
// "Comma-separated types to allow" => "Comma-separated types to allow",
// "Text Search Filters" => "Text Search Filters",
// "Comma-separated text search filters to use. Use \"=\" to separate field and value" => "Comma-separated text search filters to use. Use \"=\" to separate field and value",
// "Object id of item you want to get similar items to" => "Object id of item you want to get similar items to",
// "The object id of the item. If none is provided, Tiki will attempt to resolve the current object" => "The object id of the item. If none is provided, Tiki will attempt to resolve the current object",
// "Object type of item you want to get similar items to" => "Object type of item you want to get similar items to",
// "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object" => "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object",
"Search For a Wiki Page" => "위키 페이지에 대하여 검색",
"Search for a wiki page by name" => "위키 페이지에 대하여 이름으로 검색",
"Exact match checkbox checked by default if set to \"y\"" => "\"y\" 로 설정된 경우 기본으로 정확히 일치 체크상자가 체크됨",
"Semantic Links" => "시맨틱 링크",
"List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "표시되는 위키 페이지에 대하여 알려진 관계를 나열. 페이지 내부에 포함된 각 관계 유형에 대하여, 링크하는 혹은 링크되는 모든 페이지를 나열합니다",
"Links for sharing, reporting etc" => "공유, 보고, 및 기타를 위한 링크",
"Report" => "보고",
"Report to Webmaster" => "웹마스터에게 보고",
"Share this page" => "이 페이지 공유",
"Use icons for report, share and email links" => "보고, 공유, 및 이메일 링크에 아이콘 사용",
"Show Facebook \"Like\" button on the current page" => "현재 페이지 상에 페이스북 \"좋아요\" 버튼 표시",
// "Facebook: URL" => "Facebook: URL",
"URL to \"Like\" (leave blank for current URL)" => "\"좋아요\" 로의 URL (현재 URL 로 두려면 공란으로)",
"Facebook: Send" => "페이스북: 전송",
"Show Facebook \"Send\" button" => "페이스북 \"보내기\" 버튼 보기",
"Facebook: Layout" => "페이스북: 레이아웃",
"Size, layout and amount of social context" => "소셜 컨텐츠의 사이즈, 레이아웃, 및 양",
"Facebook: Width" => "페이스북: 넓이",
"Facebook: Height" => "페이스북: 높이",
"Container height in CSS units (e.g. \"120px\" or \"2em\")" => "CSS 단위 내의 컨테이너 높이 (예. '120px\" 혹은 \"2em\")",
"Facebook: Show Faces" => "페이스북: 얼굴 보기",
"Show pictures of others who like this" => "이것을 좋아하는 다른 이들의 그림 표시",
"Facebook: Verb" => "페이스북: 동사",
"Verb to display in button" => "버튼에 표기할 동사",
"Facebook: Colors" => "페이스북: 색상",
"Color scheme" => "색 구성표 ",
"Facebook: Font" => "페이스북: 폰트",
"Font to display" => "표시할 폰트",
"Facebook: Locale" => "페이스북: 지역",
"Locale in the format ll_CC (default \"en_US\")" => "ll_CC 형식으로된 로캘 (기본 \"en_US\")",
"Facebook: Referrals" => "페이스북: 참조",
"Label for tracking referrals (optional)" => "참조를 트래킹하기 위한 레이블 (선택사항)",
"Facebook: App Id" => "페이스북: 앱 ID",
"ID of your Facebook app (optional)" => "페이즈북 앱의 ID (선택사항)",
"Show Twitter Follow Button on the current page" => "현재 페이지에 트위터 팔로우 버튼 표시",
"Twitter: User Name" => "트위터: 사용자명",
"Twitter user name to quote as \"via\"" => "\"via\"로 인용될 트위터 사용자명",
"Twitter: Label" => "트위터: 라벨",
"Text to display. Default \"Tweet\"" => "표시될 텍스트. 기본 \"트윗\"",
// "Twitter: URL" => "Twitter: URL",
"URL to \"Tweet\" (leave blank for current URL)" => "\"트윗\" 할 URL (현재 URL 로 두려면 공란으로)",
"Twitter: Show Count" => "트위터: 갯수 보기",
"Position of Tweet count" => "트윗 수의 위치",
"Twitter: Language" => "트위터: 언어",
"Two letter language code" => "두개 문자 언어 코드",
"Twitter: Width" => "트위터; 너비",
"Width in pixels or percentage (e.g. 300px)" => "픽셀단위 혹은 백분율로 된 넓이 (예: 300px)",
"Twitter: Height" => "트위터: 높이",
"Twitter: Text" => "트위터: 텍스트",
"Tweet text (leave empty to use page title" => "트윗 제목 (페이지 제목에 사용하려면 빈 상태로 둠",
"LinkedIn" => "링크드인",
"Linked in share button" => "공유 버튼 안에 링크 됨",
// "LinkedIn: URL" => "LinkedIn: URL",
"URL to share (leave blank for current URL)" => "공유할 URL (현재 URL 은 공란)",
"LinkedIn: Count Mode" => "LinkedIn: 개수 모드",
"Position of count" => "갯수의 위치",
"Google +1" => "구글 +1",
"Google +1 button" => "구글 +1 버튼",
"Google: Size" => "구글: 크기",
"Google button size" => "구글 버튼 크기",
"Google: Annotation" => "구글: 주석",
"Google annotation" => "구글 annotation",
"Google: Language" => "구글: 언어",
"Google language" => "구글 언어",
// "Google: URL" => "Google: URL",
// "Creates or shows a short url for the visiting page" => "Creates or shows a short url for the visiting page",
"The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent." => "외침상자는 빠른 메시지 도구입니다. 메시지는 페이지가 변경될 때마다 다시 로드됩니다. 바른 권한을 보유한 사람은 누구든지 모든 메시지를 볼 수 있습니다. 메시지를 발송을 허용할 다른 권한",
"If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "\"1\"로 설정된 경우, 메시지 게시 날자와 시간을 모듈 컨텐츠 안에 직접 표시하는 대신 툴팁으로써 표시합니다",
"Label on the button to post a message" => "메시지를 게시할 버튼 상의 레이블",
"Wait label" => "대기 레이블",
"Label on the button to post a message when the message is being posted if AJAX is enabled" => "AJAX 가 활성화 된 경우, 메시지가 게시될 때 메시지를 게시할 버튼 상의 레이블",
"Please wait.." => "기다려 주십시오..",
"Maximum messages shown" => "표시된 최대 메시지 ",
"Number of messages to display" => "표사힐 메시지 수",
"Tweet" => "트윗",
"If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "\"1\"으로 설정되었고 사용자가 트위터로 메시지를 트윗하도록 승인한 경우, 사용자는 트위터를 통하여 외침을 할 것인지를 결정할 수 있습니다",
"If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "\"1\"으로 설정되었고 사용자가 페이스북으로 승인한 경우, 사용자는 페이스북 담벼락에 외침을 추가할지를 결정할 수 있습니다",
"Since Last Visit (Simple)" => "마지막 방문 이후 (단순)",
"Displays to logged-in users the number of new or updated objects since their last login date and time" => "로그인한 사용자에게 마지막 로그인 날짜와 시간 이후의 신규 혹은 갱신된 개체의 숫자를 표시",
"Since your last visit" => "마지막 방문 이후",
"Since Last Visit" => "마지막 방문 이후",
"Displays to logged-in users new or updated objects since a point in time, by default their last login date and time" => "로그인한 사용자에게 특정 시간 (기본으로 마지막 로그인 날짜와 시간) 이후의 신규 혹은 갱신된 개체를 표시",
"Show users" => "사용자 표시",
"If set to \"n\", do not show new users" => "\"n\" 으로 설정된 경우, 새 사용자를 표시하지 않습니다",
"If set to \"n\", do not show tracker changes" => "\"n\"으로 설정된 경우, 트래커 변경 내역을 표시주지 않습니다",
"Calendar focus" => "달력 포커스",
"Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "\"무시\"로 설정되지 않았다면, 모듈이 사용자의 마지막 로그인 날짜와 시간부터 사용자들이 달력을 사용하여 탐색을 한 곳까지 시간으로 된 참조 포인트를 변경합니다",
"Show date as a calendar link" => "달력 링크로서 날짜 보기",
"If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "\"n\" 로 설정된 경우, 티키 캘린더의 헤더에 있는 날짜 상에 링크를 추가하지 않음 (추천 달력이 설정된 경우에도 동일함)",
"Fold sections by default" => "기본으로 섹션 접기",
"If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "\"y\"로 설정된 경우, 섹션을 자동으로 접고 제목만 표시합니다 (사용자는 수정의 상세내역을 보려면 각 섹션을 클릭하여야만 합니다)",
// "Use tabbed presentation" => "Use tabbed presentation",
// "If set to \"y\", use Bootstrap tabs to show the result" => "If set to \"y\", use Bootstrap tabs to show the result",
"Minimum timespan" => "최소 기간",
"Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "마지막 로그인 시간이 더 최근인 경우, 마지막 로그인 시간 대신, 날짜로 지정되어 있는 이 최소 시간 뒤로 돌아갑니다,",
"Maximum comment length" => "최대 댓글 길이",
"Changes since" => "다음 이후 변경 내역",
"Since your last visit.." => "마지막 방문 이후..",
"In the last %0 days.." => "지난 %0 일간..",
"new comments" => "새 댓글",
" (archived)" => " (보관됨)",
"new posts" => "새 게시물",
"wiki pages changed" => "위키 페이지 변경됨",
"new articles" => "새 기사",
"new FAQs" => "새 FAQ",
"new blogs" => "새 블로그",
"new blog posts" => "새 블로그 게시물",
"new image galleries" => "새 그림 갤러리",
"new images" => "새 그림",
"new file galleries" => "새 파일 갤러리",
"new files" => "새 파일",
"new polls" => "새 투표",
"new users" => "새 사용자들",
"new tracker items" => "새 트래커 항목",
"updated tracker items" => "트러캐 항목 갱신됨",
// "new calendars" => "new calendars",
// "new events" => "new events",
// "starting on" => "starting on",
"If comments don't use titles this sets the maximum length for the comment snippet" => "댓글이 제목을 사용하지 않는 경우, 이는 댓글 조각에 대하여 최대 길이를 설정합니다",
"SVN Up Info" => "SVN Up 정보",
"SVN Version and last update information" => "SVN 버전 및 최종 갱신 정보",
"Switch Language" => "언어 변경",
"Displays a language picker to change the language of the site" => "사이트의 언어를 변경하기 위하여 언어 선택기를 표기합니다",
"Display mode" => "모드 표시",
"Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "언어의 목록이 어떻게 표기되는를 변경함. 가능한 값들은 droplist, flags 및 words. 기본은 droplist",
// "Switch Admin Language" => "Switch Admin Language",
// "Displays a language picker to change the language of admin site" => "Displays a language picker to change the language of admin site",
"Switch Theme" => "테마 전환",
// "Enables to quickly change the theme for the user" => "Enables to quickly change the theme for the user",
// "Not allowed here" => "Not allowed here",
// "Displayed theme" => "Displayed theme",
"Admin Theme" => "테마 관리",
"Terminology" => "용어",
"Support for multilingual terminology" => "다국어 용어에 대한 지원",
"Root category" => "루트 범주",
"All terms will automatically be put in that category. " => "모든 조건들이 그 범주에 자동적으로 놓여질 것입니다",
"Note that the category must already exist. " => "범주가 이미 존재해야만 한다는 점에 유의하십시오",
"Defaults to 'Term'" => "기본값을 '조건' 으로",
"Tiki Tests" => "티키 테스트",
"Tiki test suite helper" => "티키 테스트 수트 도우미",
"Most Active blogs" => "가장 활발한 블로그들",
"Displays the specified number of blogs with links to them, from the most active one to the least" => "블로그를 링크와 함게 지정된 수만큼 표시, 가장 활동적에서 기장 비활동적인 순서로",
"Blog activity measurement can be more or less accurate" => "블로그 활동 측정은 정확도가 명확하지는 않습니다",
"Lists the specified number of articles with links to them, from the most visited one to the least" => "기사를 링크와 함게 지정된 수만큼 가장 많이 본 것에서 가장 적게 본 순으로 나열함",
"Top Blog Posters" => "최다 블로그 게시자",
"Displays the specified number of users who posted to blogs, starting with the one having most posts" => "블로그에 게시한 사용자를 지정된 수만큼 표시, 가장 많이 게시한 사람부터 시작",
"Limit to a blog" => "블로그에 제한",
"Top File Galleries" => "상위 파일 갤러리",
"Displays the specified number of file galleries with links to them, starting with the one with most hits" => "파일 갤러리를 링크와 함게 지정된 수만큼 표시, 가장 방문이 많은 것부터 시작",
"Top Files" => "상위 파일들",
"Displays the specified number of files with links to them, starting with the one with most hits" => "파일을 링크와 함께 지정된 수만큼 표시, 가장 많은 방문부터 시작",
"Top Forum Posters" => "상위 게시판 게시자들",
"Displays the specified number of users who posted to forums, starting with the one having most posts" => "게시판에 게시한 사용자의 지정된 숫자만큼 표기, 가장 많은 게시물을 보유한자부터 시작",
"Top Image Galleries" => "상위 그림 갤러리들",
"Displays the specified number of image galleries with links to them, starting with the one with most hits" => "그림 갤러리를 링크와 함께 지정된 수만큼 표시, 가장 많은 방문부터 시작",
"Top Images" => "상위 그림",
"Displays the specified number of images with links to them, from the most visited one to the least" => "그림을 링크와 함께 지정된 수만큼 표시, 가장 많이 방문된 것부터 가정 적게 방문된 것 순서",
"Top Objects" => "상위 개체들",
"Displays the specified number of objects, starting with the one having the most hits" => "개체를 지정된 수만큼 표시, 가장 많이 방문된 것부터 시작",
"Top Pages" => "상위 페이지",
"Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "위키 페이지를 링크와 함께 지정된 수만큼 표시, 가장 많은 방문된 것부터 시작",
"Top Quizzes" => "상위 퀴즈",
"Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "퀴즈를 링크와 함께 지정된 수만큼 표시, 가장 많이 방문된 것부터 시작",
"Top Visited Blogs" => "가장 많이 방문된 블로그들",
"Display the specified number of blogs with links to them, from the most visited one to the least" => "지정된 수의 블로그를 링크와 함게 표기, 가장 많은 방문 수에서 가장 적은 수 순서",
"Show Last Post" => "최종 게시물 보기",
"Top Visited FAQs" => "가장 많이 방문된 FAQ들",
"Display the specified number of FAQs with links to them, from the most visited one to the least" => "지정된 수의 FAQ를 링크와 함게 표기, 가장 많은 방문 수에서 가장 적은 순서",
"Tracker Input" => "트래커 입력",
"Allows a dialog to be opened to create new tracker items" => "새 트래커 항목들을 만들기 위하여 대화상자를 여는 것을 허용",
"Tracker ID to render" => "렌더할 트래커 ID",
"Text Input" => "텍스트 입력",
"Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "레이블과 함께 메인 형식의 일부로써 표시될 다중 텍스트 필드들. 필드명들은 트래커 필드 정의 내부에 영구적 이름에 매핑됩니다. 예: groupName(Group Name) relatedTask(Task)",
"Location Field" => "위치 필드",
"Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "근처 지도에서 좌표를 얻고 이를 위치 필드로 전송합니다. 필드명에 추가적으로 :marker 혹은 :viewport 가 어미로써 사용될 수 있습니다. 기본은 :marker 입니다",
"Capture StreetView" => "거리보기 캡쳐",
"Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "위치에서 트래커 항목을 만들기 위하여 스트릿뷰 상에 버튼을 포함. ur<x>l 에서의 업로드 그림과 위치 매개 변수가 필요",
"Alter the submit button label" => "제출 버튼 라벨을 변경",
"Operation to perform on success" => "성공 시 실행될 작동",
"Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "다음 형식으로 수행할 작업: 작업명(인수). 현재 작업은 URL 템플릿을 인수로써 리디렉트합니다. @valueName@ 은 값명이 항목ID, 상태 혹은 영구이름인 적절한 값에 의해 교체될 것입니다",
"Mode change on complete" => "완료 시 모드 변경",
"Target mode to enter after dialog closes" => "대화상자가 닫힌 후 진입할 대상 모드",
"Tracker Help" => "트래커 도움말",
"Display the fields of a tracker (name and identifier)" => "트래커의 필드 표시 (이름과 식별자)",
"Text field height" => "텍스트 필드 높이",
"Number of lines" => "줄 수",
"Text field width" => "텍스트 필드 너비",
"Number of characters" => "글자 수",
"Translate Updates" => "번역 업데이트",
"Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "다른 언어로 표시되는 위키 페이지의 버전으로 연결하고, 더 좋은, 동일한, 더 나쁜 번역을 구분함. 표시되는 번역의 최신상태를 선택적으로 표시함",
"Reference language" => "참조 언어",
"If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "언어 코드로 설정된 경우, 로컬화 된 페이지가 표시되지 않는 한, 참조 페이지로 표시되는 로컬화된 페이지를 제한합니다",
"Show language" => "언어 보기",
"If \"y\" the page language will be shown instead of the page name" => "\"y\" 라면 페이지 언어가 페이지명 대신 표시 됨",
"Default = \"y\"" => "기본 = \"y\"",
"Tweets" => "트윗",
"Shows the tweets from the Twitter timeline of a user" => "사용자의 트위터 타임라인에서 트윗 표시",
"Tiki user to show Twitter timeline of" => "해당 트위터 타임라인을 표시할 티키 사용자",
"Show public|friends timeline. " => "공용/친구 타임라인 표시",
// "Search string" => "Search string",
"user not registered with twitter" => "사용자가 트위터에 등록하지 않음",
"Lists the specified number of calendar events, ordered by their start date" => "달력 이벤트의 지정된 수만큼 시작날짜로 정렬하여 나열함",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "달력 식별자의 목록으로 설정된 경우, 식별된 달력 내부의 것들로 이벤트를 제한합니다. 식별자는 수직 막대기 (\"|\"), 쉼표 (\",\") 혹은 콜론(\":\")으로 구분됩니다",
"Maximum days in the future" => "미래의 최대 일 수",
"Maximum distance to event start dates in days (looking forward)" => "이벤트 시작 날짜까지의 일 단위의 최대 거리 (앞으로 봄)",
"Maximum days in the past" => "과거의 최대 일 수",
"Maximum distance to event end dates in days (looking backward)" => "이벤트 종료일까지의 일 단위의 최대 거리 (뒤로 봄)",
"cellpadding" => "셀 안쪽 여백",
"If set to an integer, apply this cellpadding to the HTML table generated" => "정수로 설정된 경우, 이 셀패딩을 생성된 HTML 표에 적용합니다",
"cellspacing" => "셀 간격",
"If set to an integer, apply this cellspacing to the HTML table generated" => "정수로 설정된 경우, 이 셀스페이싱을 생성된 HTML 표에 적용합니다",
"If set to \"y\", event descriptions are displayed" => "\"y\" 로 설정된 경우, 이벤트 설명이 표시됩니다",
"Show end date and time" => "마침 날짜와 시간 보기",
"If set to \"y\", event end dates and times are displayed, when appropriate" => "\"y\" 로 설정된 경우, 이벤트 종료 날짜와 시간이, 적절한 경우, 표시됩니다",
"Use custom calendar background colors" => "사용자 지정 달력 배경 색상 사용",
"If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "\"y\" 로 설정된 경우, 이벤트가 달력의 사용자 지정 배경 색상과 함께 표시됩니다 (설정이 되어있을 경우)",
"Show information in tooltips" => "툴팁에 정보 보기",
"If set to \"n\", event tooltips will not display event information" => "\"n\" 으로 설정된 경우, 이벤트 툴팁이 이벤트 정보를 표시하지 않을 것입니다",
"Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "대부분의 날짜에 대하여 사용할 형식. <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() 설명서</a>를 참고하십시오",
"site preference for short date format followed by site preference for short time format" => "짧은 날짜 형식에 대한 사이트 기본설정과 그 뒤에 짧은 시간 형식에 대한 사이트 기본설정",
"If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "정수로 설정된 경우, 이 숫자는 잘려지기 전에 최대로 문자수로 허용되는 이벤트명입니다",
"My Blogs" => "내 블로그",
"Displays to registered users their blogs" => "등록한 사용자에게 자신의블로그 표시",
"My Bookmarks" => "사용자 책갈피",
"Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "사용자 책갈피로의 경량급 인터페이스, 간략하게 보고, 몇몇 작업을 수행하고, 보고있는 페이지를 책갈피에 넣으려면 활성화합니다",
"My Image Galleries" => "내 그림 갤러리",
"Displays to registered users their image galleries" => "등록한 사용자에게 자신의 그림 갤러리 표시",
"User Pages" => "사용자 페이지",
"Displays to registered users the specified number of wiki pages which they were the last to edit" => "등록한 사용자에게 자신이 마지막으로 편집한 위키 페이지들을 지정된 수만큼 표시",
"My Pages" => "내 페이지",
"My Tasks" => "내 작업",
"Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "사용자 작업에 대한 경량급 인터페이스, 간략 보기와 모종의 작업을 하기 위하여 활성화함",
"The task title must have at least 3 characters" => "작업 제목은 최소 3글자여야 합니다",
"Public Tasks" => "공용 작업",
"Lists the public user tasks of a chosen group, with links to tasks" => "선택된 그룹의 공용 사용자 작업을 작업으로의 링크와 함께 나열함",
"User-Group Tracker" => "사용자-그룹 트래커",
"User and Group tracker links" => "사용자 및 그룹 트래커 링크",
// "Users List" => "Users List",
// "Display a list of users with optional extra information from each" => "Display a list of users with optional extra information from each",
"Login" => "로그인",
// "Show the user name" => "Show the user name",
// "y|n" => "y|n",
// "Show the user real name" => "Show the user real name",
// "Last Login" => "Last Login",
// "Show the last login date" => "Show the last login date",
// "Show the direct and included groups a user belongs to" => "Show the direct and included groups a user belongs to",
// "Show the user profile picture" => "Show the user profile picture",
// "Show a link to the userPage" => "Show a link to the userPage",
// "Log" => "Log",
// "Show a link to the user logs(feature actionlog must be activated)" => "Show a link to the user logs(feature actionlog must be activated)",
// "Show only the users of the group" => "Show only the users of the group",
// "Groupname" => "Groupname",
// "Included Groups" => "Included Groups",
// "Show only the users of the group group and of a group including group" => "Show only the users of the group group and of a group including group",
// "initial" => "initial",
// "Show only the users whose name begins with the letter" => "Show only the users whose name begins with the letter",
// "a letter" => "a letter",
// "heading" => "heading",
// "Show the table heading" => "Show the table heading",
// "Sort users in ascending or descending order using these values: " => "Sort users in ascending or descending order using these values: ",
"My Score" => "내 점수",
"Display the logged user's rank and score" => "로그인된 사용자의 순위와 점수 표시",
"Most Active Users" => "가장 활동적 사용자들",
"Display the specified number of users and their score, starting from the one with the highest score" => "지정된 수의 사용자와 그들의 점수 표기, 최고 점수 득점자부터 시작",
// "websearch" => "websearch",
// "Displays a simple form to perform a web search with choice on multiple search engines" => "Displays a simple form to perform a web search with choice on multiple search engines",
"Related Items" => "관련 항목",
"Lists objects which share a category with the viewed object" => "본 개체들과 범주를 공유하는 개체를 나열함",
"Online Users" => "온라인 사용자",
"Display information about users currently logged in" => "현재 로그인 된 사용자에 관한 정보 표시",
"Display the number of users logged in, the list of users logged in, or both" => "로그인된 사용자 수, 로그인 된 사용자의 목록, 혹은 둘 다 표시",
"Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "가능한 값: \"count\", \"list\" 혹은 \"both\". 기본값: \"both\"",
"Cluster Mode" => "클러스터 모드",
"If set to \"1\", separate users based on which host/server they logged on" => "\"1\" 으로 설정된 경우, 사용자들을 각자 로그인 한 호스트/서버에 기반하여 분리",
// "Silent Mode" => "Silent Mode",
// "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it" => "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it",
"Newest Comments" => "최신 댓글",
"Lists the specified number of comments starting from the most recently posted" => "댓글을 지정된 수만큼 가장 최근 게시된 것부터 나열",
"More in tooltips" => "툴팁 내부에 추가",
"If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "\"y\" 로 설정될 경우, 댓글이 만들어진 개체명이 모듈 상자에서 표시되지 않습니다 하지만 대신 항목의 툴팁으로 이동됩니다",
"Type of the objects from which comments will be listed. Possible values" => "댓글이 나열될 개체의 유형. 가능한 값",
"Display user profile pictures instead of numbers" => "숫자 대신 사용자 아바타 표시",
// "Comments about objects in this language only" => "Comments about objects in this language only",
"Last article comments" => "마지막 기사 댓글",
"Last wiki comments" => "최근 위키 댓글",
// "Hold a chat session using XMPP (uses the ConverseJS client)" => "Hold a chat session using XMPP (uses the ConverseJS client)",
// "XMPP" => "XMPP",
"Displays YouTube videos and/or a link to a YouTube user's page" => "유튜브 동영상 및/혹은 유튜브 사용자의 페이지로의 링크 표시",
"Video identifiers" => "동영상 식별자",
"List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "표시할 유튜브 동영상 식별자의 목록. 식별자는 쉼표(\",\")로 구분됩니다.",
"YouTube user identifier" => "유튜브 사용자 식별자",
"If set to a YouTube user identifier, display a link to the videos of this user" => "유튜부 사용자 식별자로 설정된 경우, 이 사용자의 동영상의 링크를 표시합니다",
"Videos on YouTube" => "유튜브의 동영상",
// "Module Zone" => "Module Zone",
// "Can contain other modules so can be used as a Bootstrap navbar object, for example" => "Can contain other modules so can be used as a Bootstrap navbar object, for example",
// "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel" => "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel",
// "Example for a Bootstrap \"social\" navbar" => "Example for a Bootstrap \"social\" navbar",
"Bibliography Search" => "참고문헌 검색",
"Search the group's Zotero library for entries with the specified tags" => "지정된 태그로 입력항목에 대하여 그룹의 조테로 라이브러리 검색",
"failure" => "실패",
"You do not have sufficient permissions to perform this action" => "이 작업을 수행할 권한이 없습니다",
"Please enter Biblio Code" => "도서관 목록 정보 코드를 입력하여 주십시오",
"Biblio code must not exceed 50 characters" => "도서 목록 정보 코드는 50 글자를 초과할 수 없습니다",
"success" => "성공",
"Page not found. Please save the page first" => "페이지 발견되지 않음. 우선 페이지를 저장하십시오",
"This reference already exists in the library" => "이 참조는 이미 라이브러리 내부에 존재합니다",
"Reference added to library" => "참조가 라이브러리에 추가됨",
"This biblio code already exists" => "이 도서목록 정보 코드는 이미 존재합니다",
"Bibliography saved" => "참고문헌 저장됨",
"Reference already exists" => "참조가 이미 존재함",
"Reference added" => "참조 추가됨",
"Invalid server key" => "유효하지 않은 서버 키",
"Invalid username or password" => "유효하지 않은 사용자명 혹은 암호",
"Cookie not found" => "쿠키 발견되지 않음",
// "This user is your friend" => "This user is your friend",
// "You share the following groups with this user" => "You share the following groups with this user",
// "Unlike" => "Unlike",
// "There is no activity to display in this stream" => "There is no activity to display in this stream",
// "%0 %1" => "%0 %1",
// "%0 posted a comment to" => "%0 posted a comment to",
// "%0 started a new discussion" => "%0 started a new discussion",
// "Join the discussion" => "Join the discussion",
// "%0 replied to a thread" => "%0 replied to a thread",
// "%0 corrected a message" => "%0 corrected a message",
// "%0 requested an action from you" => "%0 requested an action from you",
// "%0 triggered your %1 priority saved filter" => "%0 triggered your %1 priority saved filter",
// "Critical Priority" => "Critical Priority",
// "See your saved filter" => "See your saved filter",
// "High Priority" => "High Priority",
// "Low Priority" => "Low Priority",
// "Recommended Reading" => "Recommended Reading",
// "Based on your previous activity, we believe you might find this useful" => "Based on your previous activity, we believe you might find this useful",
// "Was this useful" => "Was this useful",
// "Help us improve" => "Help us improve",
// "%0 created a tracker" => "%0 created a tracker",
// "%0 created a tracker item" => "%0 created a tracker item",
// "%0 modified a tracker item" => "%0 modified a tracker item",
// "%0 has added %1 to his stream" => "%0 has added %1 to his stream",
// "%0 is now followed by %1" => "%0 is now followed by %1",
// "%0 and %1 became friends" => "%0 and %1 became friends",
// "%0 created a page" => "%0 created a page",
// "%0 modified a page" => "%0 modified a page",
// "View changes" => "View changes",
// "history" => "history",
// "Show More" => "Show More",
"Saving..." => "저장 중..",
"Adding.." => "추가 중..",
"References Available" => "참조 사용가능함",
"Add to library" => "라이브러리에 추가",
"Library References" => "라이브러리 참조",
"Use" => "사용하십시오",
"Edit Library References" => "라이브러리 참조 편집",
"Part" => "부분",
// "URI" => "URI",
"Publisher" => "게재자",
"Enter the CSS class name to be added in the 'li' tag for listing this reference" => "이 참조를 나열함에 대하여 \"li\" 태그에 추가될 CSS 클래스명을 입력하십시오",
"Enter template format in which you want to display the reference details in the bibliography listing. For example" => "참고문헌 목록에 원하는 바대로 참조 상세내역을 표시할 템플릿 형식을 입력하십시오. 예를 들면",
"All the codes must be in lower case letters separated with spaces" => "모든 코드는 스페이스로 구분되고 소문자여야 합니다",
"Please save the page before creating the bibliography" => "참고문헌목록을 만들기 전에 페이를 저장해 주십시오",
"Preference Filters" => "기본설정 필터",
// "basic" => "basic",
"Set as my default" => "내 기본으로 설정",
// "Provide Feedback" => "Provide Feedback",
// "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them" => "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them",
// "Icon for 'Like'" => "Icon for 'Like'",
// "Icon for 'Fix me'" => "Icon for 'Fix me'",
// "Icon for 'What is this for?'" => "Icon for 'What is this for?'",
// "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)" => "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)",
// "Click to read more" => "Click to read more",
// "Rebuild Admin Index" => "Rebuild Admin Index",
// "Control Panels" => "Control Panels",
// "Search preferences" => "Search preferences",
"Configuration search" => "구성 검색",
"Note: The search index needs rebuilding, this will take a few minutes." => "주의: 검색 색인을 리빌딩해야합니다, 몇 분 정도 걸릴 수 있습니다.",
// "Preference Search Results" => "Preference Search Results",
// "Apply Changes" => "Apply Changes",
"Apply" => "적용",
"No results" => "결과 없음",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Not what you expected? Try %0rebuilding%1 the preferences search index" => "Not what you expected? Try %0rebuilding%1 the preferences search index",
// "Access" => "Access",
"Users" => "사용자",
// "Banning" => "Banning",
"Directories" => "디렉터리",
"External Feeds" => "외부 피드",
"HTML Pages" => "HTML 페이지",
// "Wiki Structures" => "Wiki Structures",
"System" => "시스템",
// "Activity Rules" => "Activity Rules",
"Content Templates" => "컨텐츠 템플릿",
// "Languages" => "Languages",
"Mail Notifications" => "메일 알림",
"Menus" => "메뉴",
// "User Credits" => "User Credits",
"Transitions" => "전이",
"Plugin Approval" => "플러그인 승인",
// "Mods" => "Mods",
"Tools" => "도구",
"Action Log" => "작업 로그",
"Cookies" => "쿠키",
// "DSN/Content Authentication" => "DSN/Content Authentication",
// "Edit TPL" => "Edit TPL",
"External Pages Cache" => "외부 페이지 캐시",
"External Wikis" => "외부 위키",
// "Importer" => "Importer",
// "PhpInfo" => "PhpInfo",
// "Referer Statistics" => "Referer Statistics",
// "Search Statistics" => "Search Statistics",
"Security Admin" => "보안 관리",
"Server Check" => "서버 검사",
// "Synchronize Dev" => "Synchronize Dev",
// "System Cache" => "System Cache",
// "System Logs" => "System Logs",
// "Sitemap" => "Sitemap",
// "Wizards" => "Wizards",
"Cancel Edit" => "편집 취소",
// "Banners listing" => "Banners listing",
"Activate the feature" => "기능 활성화",
// "Site ads and banners" => "Site ads and banners",
// "Apply changes" => "Apply changes",
// "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>" => "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>",
// "List of articles" => "List of articles",
// "List of article types" => "List of article types",
"Article Types" => "기사 종류",
// "List of article topics" => "List of article topics",
"General Settings" => "일반 설정",
"Features" => "기능",
// "Custom (Article Own) images setting" => "Custom (Article Own) images setting",
"Sharing on social networks" => "소셜 네트워크 상에서 공유",
"Import CSV file" => "CVS파일 가져오기",
"Batch upload (CSV file)" => "Batch 업로드 (CSV 파일)",
"File format: title,authorName,heading,body,lang,user" => "파일 형식: 타이틀,저자명,제목,본문,언어,사용자",
// "Articles Listing and View" => "Articles Listing and View",
"List articles" => "기사목록",
// "Article view" => "Article view",
// "Blogs listing" => "Blogs listing",
"Blogs Listings" => "블로그 목록",
// "Items to display" => "Items to display",
// "Calendars listing" => "Calendars listing",
"General settings" => "일반 설정",
// "Categories listing" => "Categories listing",
// "Browse Categories" => "Browse Categories",
// "Administer Categories" => "Administer Categories",
// "Organize objects" => "Organize objects",
"Organize Objects" => "개체 정리",
"Category objects" => "범주 개체",
// "Re-apply last saved category defaults to wiki pages" => "Re-apply last saved category defaults to wiki pages",
"Performance" => "성능",
// "Comments listing" => "Comments listing",
"Site-wide features" => "사이트 전역 기능",
"Display options" => "표기 선택사항",
// "Annotations" => "Annotations",
"Using comments in various features" => "다양항 기능에서 댓글 사용",
// "Group Administration" => "Group Administration",
// "User Administration" => "User Administration",
// "Community Features" => "Community Features",
"Community" => "커뮤니티",
// "Additional options" => "Additional options",
// "Social Interaction" => "Social Interaction",
// "Friendship and followers" => "Friendship and followers",
"Select which items to display when listing users" => "사용자 나열 시 표기할 항목 선택",
// "Activity stream" => "Activity stream",
"Tiki Connect" => "티키 커넥트",
"Join the community" => "커뮤니티에 참여하십시오",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "티키 위키 CMS 그룹웨어는 자유 및 오픈 소스 소프트웨어 (FOSS)입니다. 이는 커뮤니티가 주도하는 프로젝트로써, 귀하와 같은 분들의 감사드려야 할 참여에 의하여 존재하고 향상됩니다",
"Join the Community" => "커뮤니티에 참여하십시오",
"Tiki news" => "티키 뉴스",
"Embedded RSS feed from info.tiki.org TODO, meanwhile" => "info.tiki.org 에서 임베드된 RSS 피드 TODO, 그 동안",
"Tiki Newsletter" => "티키 회보",
"Promote your site" => "귀하의 사이트를 널리 알리십시오",
"Add your site to the Tiki directory." => "티키 디렉터리에 이 사이트 추가",
"Submit your site" => "귀하의 사이트를 제출하십시오",
"Spread the word" => "소식을 전파하십시오",
"Add the \"Powered by\" module to your site. " => "사이트에 \"제공:\" 모듈 추가",
"Manage Modules" => "모듈 관리",
"Help improve Tiki" => "티키를 개선에 도움을 주십시오",
"Submit a feature request or bug report" => "기능 요청 혹은 버그 보고서 제출",
// "Visit Tiki development site" => "Visit Tiki development site",
"Make a financial contribution to the Tiki Association" => "티키 연합에 금융 기여를 부탁 드립니다",
"Contribute to Tiki" => "티키에 기여하십시오",
"New Feature" => "새 기능",
"Please note: Experimental - work in progress" => "주의하십시오: 실험적 - 진행 중인 작업",
"Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "티키 커넥트는 티키 프로젝트로 하여금 티키가 어떻게 사용되는가를 알게해며 어떤 부분을 사람들이 좋아하고 어떤 부분에 수리가 필요한지 (혹은 설명이 필요한지)를 알려주는 방법입니다",
// "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)" => "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)",
// "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'" => "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'",
// "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)" => "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)",
"Send Info" => "정보 전송",
"Send the data" => "데이터 전송",
"Preview info" => "정보 미리보기",
"See what is going to be sent" => "전송될 것 보기",
"Fill form" => "양식 채우기",
"Fill this form in based on other preferences" => "다른 기본설정에 기반하여 이 양식을 채우십시오",
"Advanced settings" => "고급 설정",
"Exposed to assist testing and development" => "보조 테스팅 및 개발에 노출됨",
// "Connections Received" => "Connections Received",
"Rebuild received connections index" => "수신된 연결 색인 다시 빌드",
"<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>서버 통계:</strong> %1 티키들로부터 %0 보고서 수신됨",
// "Jitsi" => "Jitsi",
// "Provision URL" => "Provision URL",
// "Allows a copyright to be determined for various objects" => "Allows a copyright to be determined for various objects",
// "Directories listing" => "Directories listing",
// "Extention package error" => "Extention package error",
// "Cannot show page because the extension package is not installed or activated" => "Cannot show page because the extension package is not installed or activated",
// "Extension package admin template page is missing" => "Extension package admin template page is missing",
// "FAQ listing" => "FAQ listing",
// "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
"Global features" => "전역 기능",
// "Main features" => "Main features",
// "Secondary features" => "Secondary features",
// "Administrative features" => "Administrative features",
"Watches" => "주시",
// "Additional features" => "Additional features",
// "Payment and Accounting" => "Payment and Accounting",
// "Mail and Sharing" => "Mail and Sharing",
"Interaction with online services or other software" => "온라인 서비스 및 타 소프트웨어와 상호작용",
"Configuration completed" => "구성 완료",
"Authenticate with Zotero" => "조테로로 인증",
"Interface" => "인터페이스",
"jQuery plugins and add-ons" => "jQuery 플러그인 및 애드온",
"Programmer" => "프로그래머",
"Logging and Reporting" => "기록과 보고",
"Visible to admin only" => "관리자에게만 보임",
"Include Smarty notices" => "Smarty 알림을 포함",
"Custom Code" => "사용자 지정 코드",
"To create or remove file galleries, select" => "파일 갤러리를 만들거나 삭제하려면, 선택을",
"from the application menu" => "응용프로그램에서 하십시오",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "파일들을 디렉터리에 저장하기로 결정하였다면, 사용자가 그 디렉터리에 직접적으로 접근할 수 없도록 확실히 해야 합니다",
"You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "이를 달성하려면 두 개의 선택사항이 있습니다:<br><ul><li>루트의 바깥에 있는 디렉터리를 사용, 해당 디렉터리에 PHP 스크립트가 읽기 및 쓰기가 가능하다는 점을 확인하십시오</li><li>Use a directory inside the document 루트 내부의 디렉터리를 사용하고 사용자가 디렉터리 컨텐츠를 나열하는 것을 막기 위하여 .htaccess 사용</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "디렉터리 경로를 설정하려면 유닉스 같은 경로를 사용하십시오. 예를 들면 files/ 혹은 c:/foo/files 혹은 /www/files/",
// "File galleries listing" => "File galleries listing",
"Move files from database to directory" => "데이터베이스에서 디렉터리로 파일 이동",
"Move files from directory to database" => "디렉터리에서 데이터베이스로 파일 이동",
"Manage comment settings" => "댓글 설정 관리",
"Update mime of all non archived octet-stream files" => "모든 보관되지 않은 octet-stream 파일의 mime 갱신",
"Used:" => "사용됨:",
"Upload Regex" => "Regex 업로드",
// "Settings for Media Alchemyst" => "Settings for Media Alchemyst",
// "Settings for Diagrams" => "Settings for Diagrams",
// "Listings" => "Listings",
// "Configuration for gallery listings" => "Configuration for gallery listings",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "이 설정들을 변경하는 것은 기존 파일 갤러리에 영향을 미치지 <em>않습니다</em>. 이러한 변경들은 새 파일갤러리에 <em>만</em> 적용됩니다.",
// "Admin Listings" => "Admin Listings",
// "Configuration for gallery administration listings" => "Configuration for gallery administration listings",
"Search Indexing" => "인덱싱 검색",
"Handlers" => "처리기",
"Add custom handlers to make your files &quot;searchable&quot; content" => "파일들을 \"검색가능\" 컨텐츠로 만들려면 사용자 지정 처리기를 추가하십시오",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "<strong>%1</strong> 을 내부 파일명으로 사용합니다. 예를 들면, 문서를 텍스트로 변환하기 위하여 유닉스 <strong>strings</strong> 명령어를 사용하는 <strong>strings %1</strong> 을 사용합니다.",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "처리기를 삭제하려면, <strong>시스템 명령어</strong> 필드를 빈칸으로 남겨둡니다",
"Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable." => "티키는 많은 공통적 유형을 처리하기 위해서 사전설정되어 있습니다. 만약, 그 중 일부가 이곳에 나열되었다면, 명령줄 도구가 제공되지 않기 때문입니다.",
"Missing Handlers" => "없는 처리기",
// "Mime Types" => "Mime Types",
// "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly" => "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly",
// "Fix vnd.ms-* mime type files" => "Fix vnd.ms-* mime type files",
"MIME Type" => "MIME 유형",
"System Command" => "시스템 명령어",
"Reindex all files for search" => "검색을 위해 모든 파일 재색인",
// "Enhancements" => "Enhancements",
// "H5P Info" => "H5P Info",
// "Service URL to purge unused libraries can be found here. Can be used in a cron task" => "Service URL to purge unused libraries can be found here. Can be used in a cron task",
// "SCORM" => "SCORM",
// "OCR Indexing" => "OCR Indexing",
// "Forums listing" => "Forums listing",
// "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums" => "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums",
"Threads" => "쓰레드",
"Searches" => "검색",
// "Forum Listing" => "Forum Listing",
// "Tags listing" => "Tags listing",
// "Browse Tags" => "Browse Tags",
"Translate tags" => "태그 번역",
// "Translate Tags" => "Translate Tags",
// "Remove tags not applied to any objects" => "Remove tags not applied to any objects",
// "Clean Up Unused Tags" => "Clean Up Unused Tags",
"Random tag cloud colors" => "무작위 태그 클라우드 색상",
"Separate colors with a comma (,)" => "색상을 쉼표 (,) 로 분리",
"Alphanumeric ASCII characters only" => "알파벳과 숫자로 된 ASCII 글자만 해당",
"No accents or special characters" => "악센트나 특별 문자 없음",
"Accept all characters" => "모든 캐릭터 허용",
// "Tag search page" => "Tag search page",
// "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "그림 갤러리를 추가/삭제하려면 응용프로그램 메뉴에서 \"그림 갤러리\"로 이동하십시오 혹은",
"Click Here" => "여기를 클릭하십시오",
"You can upload images of a size of " => "다음 크기의 그림을 업로드할 수 있습니다",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "php.ini 변수 file_uploads, upload_max_filesize, post_max_size 와 데이터베이스 변수 (MySQL 에서 max_allowed_packet) 를 이 값으로 변경",
"Galleries features" => "갤러리 기능",
"Gallery listing configuration" => "갤러리목록 설정",
"Comments settings" => "댓글 설정",
// "Manage images" => "Manage images",
// "Remove unused images" => "Remove unused images",
// "Remove unused images in the system gallery" => "Remove unused images in the system gallery",
// "Remove images not being used in wiki pages, articles or blog posts" => "Remove images not being used in wiki pages, articles or blog posts",
"Move images from database storage to filesystem storage" => "그림을 데이터베이스 저장공관에서 파일시스템 저장공간으로 이동",
"Move images from filesystem storage to database storage" => "그림을 파일시스템 저장공간에서 데이터베이스 저장공간으로 이동",
// "Move images" => "Move images",
"All galleries" => "모든 갤러리",
"System Gallery" => "시스템 갤러리",
"Reset or upgrade your database" => "데이터베이스를 초기화 혹은 업그레이드",
// "Create and edit menus" => "Create and edit menus",
"Server Fitness" => "서버 적합도",
// "Check if your server meets the requirements for running Tiki" => "Check if your server meets the requirements for running Tiki",
// "Check for Updates Now" => "Check for Updates Now",
// "Check if a new Tiki version is available" => "Check if a new Tiki version is available",
"General Preferences" => "전역 설정",
// "Release check" => "Release check",
// "Tiki version" => "Tiki version",
"Last update from SVN" => "SVN 에서 최종 업데이트",
// "Site identity" => "Site identity",
// "Themes" => "Themes",
// "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences" => "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences",
"These values will be stored in plain text in the database" => "이 값들은 데이터베이스 내부에 일반 텍스트로 저장될 것입니다",
"Email to send a test mail" => "테스트 메일을 보낼 이메일주소",
// "Logging and reporting" => "Logging and reporting",
// "Web Cron" => "Web Cron",
// "Call Web Cron URL" => "Call Web Cron URL",
// "Scheduler Settings" => "Scheduler Settings",
"Sessions" => "세션",
// "Advanced configuration" => "Advanced configuration",
"Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects." => "세션 데이터를 데이터베이스에 저장하는 것은 고급 시스템 관리 선택사항이라는 점과 예기치 못한 효과에 대하여 대처하기 위하여 데이터베이스의 충분한 접근권한과 이해를 가진 관리자를 위한 것이라는 점에 유의하십시오.",
"Changing this feature will immediately log you out when you save this preference." => "이 기능을 변경하면 이 설정을 저장할 때 바로 로그아웃이 됩니다",
"Enable now" => "지금 활성화",
"Contact" => "연락처",
// "Terms and conditions" => "Terms and conditions",
// "Home page" => "Home page",
"Redirects" => "리디렉션하기",
// "Site access" => "Site access",
// "Test site closed message" => "Test site closed message",
"The namespace separator should not" => "네임스페이스 구분자는 다음을 해서는 안됩니다",
"contain any of the characters not allowed in wiki page names, typically" => "일반적으로 위키 페이지명 내부에 허용되지 않는 글자를 포함하고 있습니다",
"conflict with wiki syntax tagging" => "위키 문법 태그 기능과 충돌",
"To use :: as a separator, you should also use ::: as the wiki center tag syntax" => "구분자로 :: 를 사용하려면, 위키 중앙 태그 문법으로는 ::: 를 사용해야 합니다",
"Note: a conversion of :: to ::: for existing pages must be done manually" => "주의: 기존 페이지들에 대하여  :: 를 ::: 로 교체는 수작업으로 진행되어야만 합니다",
"If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "페이지명 표기 스트리퍼가 네임스페이스 구분기와 충돌하는 경우, 네임스페이스가 사용되며 페이지명표기는 스트립되지 않습니다",
// "php.net" => "php.net",
"Date and Time Format Help" => "날짜와 시간 형식 도움말",
// "Time zone and format" => "Time zone and format",
// "Date/time selectors" => "Date/time selectors",
// "Manage customized local string translations" => "Manage customized local string translations",
// "Upload a file with translations for the selected language" => "Upload a file with translations for the selected language",
"Edit languages" => "언어 편집",
// "Intertiki Client" => "Intertiki Client",
// "Set up this Tiki site as the Intertiki client" => "Set up this Tiki site as the Intertiki client",
// "Client server settings" => "Client server settings",
// "Currently linked master server" => "Currently linked master server",
// "Add an available master server" => "Add an available master server",
// "The InterTiki Server fields are for defining for every master server you want to have access to from this client" => "The InterTiki Server fields are for defining for every master server you want to have access to from this client",
// "Server name" => "Server name",
// "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value" => "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value",
// "Server host" => "Server host",
// "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above" => "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above",
// "Server port" => "Server port",
// "The port number the master tiki responds to HTTP on (usually 80)" => "The port number the master tiki responds to HTTP on (usually 80)",
// "Server path" => "Server path",
// "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field" => "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field",
// "Server groups" => "Server groups",
// "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)" => "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)",
// "Available master Tiki servers" => "Available master Tiki servers",
// "Delete master server" => "Delete master server",
// "Intertiki Master Server" => "Intertiki Master Server",
// "Set up this Tiki site as the InterTiki master server" => "Set up this Tiki site as the InterTiki master server",
// "Master server settings" => "Master server settings",
// "Allowed client servers" => "Allowed client servers",
// "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)" => "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)",
// "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key" => "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key",
// "IP" => "IP",
// "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1" => "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1",
// "Username of primary contact on client machine. Useful for adminstration" => "Username of primary contact on client machine. Useful for adminstration",
"Can register" => "등록 가능",
// "To change the host key you need to remove and add it as a new one" => "To change the host key you need to remove and add it as a new one",
"New" => "새",
"Enable/disable Tiki features in " => "티키 기능의 사용/사용 안 함은 ",
", but configure them elsewhere" => ", 하지만 세부설정은 다른 곳으로.",
// "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})" => "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})",
// "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples" => "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples",
"Registration" => "등록",
"Log in" => "로그인",
"Generate a passcode" => "암호 생성",
"Requires PHP GD library" => "PHP GD 필수",
// "Group and tracker login settings" => "Group and tracker login settings",
"Users can select a group to join at registration:" => "사용자는 등록 시, 참가할 그룹을 선택할 수 있습니다:",
"By default, new users automatically join the Registered group" => "기본으로 새 사용자는 Registered 그룹에 자동으로 참여됩니다",
// "Other login settings" => "Other login settings",
// "Cookie consent" => "Cookie consent",
// "Assign users to groups by matching email patterns" => "Assign users to groups by matching email patterns",
// "An email pattern must be defined in the settings for at least one group for this to produce any results" => "An email pattern must be defined in the settings for at least one group for this to produce any results",
// "Remote Tiki Autologin" => "Remote Tiki Autologin",
// "You must install PHP extension LDAP" => "You must install PHP extension LDAP",
"You must change the Authentication Method to LDAP for these changes to take effect" => "이 변경내역들이 시행되려면 인증 방식을 반드시 LDAP 로 변경해야 합니다",
// "LDAP bind settings" => "LDAP bind settings",
// "LDAP user" => "LDAP user",
// "LDAP admin" => "LDAP admin",
"LDAP external groups" => "LDAP 외부 그룹",
// "LDAP group" => "LDAP group",
// "LDAP group member - if group membership can be found in group attributes" => "LDAP group member - if group membership can be found in group attributes",
// "LDAP user group - if group membership can be found in user attributes" => "LDAP user group - if group membership can be found in user attributes",
// "PAM" => "PAM",
"You must change the Authentication Method to PAM for these changes to take effect" => "이 변경내역들이 시행되려면 인증 방식을 반드시 PAM 으로 변경해야 합니다",
"Shibboleth Authentication " => "Shibboleth 인증",
"You must change the Authentication Method to Shibboleth for these changes to take effect" => "이 변경내역들이 시행되려면 인증 방식을 반드시 Shibboleth 로 변경해야 합니다",
// "SAML2" => "SAML2",
// "based on Onelogin's php-saml " => "based on Onelogin's php-saml ",
// "You must change the Authentication Method to SAML for these changes to take effect" => "You must change the Authentication Method to SAML for these changes to take effect",
// "Identity provider settings" => "Identity provider settings",
// "Attribute mapping" => "Attribute mapping",
// "Group mapping" => "Group mapping",
// "CAS" => "CAS",
// "CAS (central authentication service)" => "CAS (central authentication service)",
"You must change the Authentication Method to CAS for these changes to take effect" => "이 변경내역들이 시행되려면 인증 방식을 반드시 CAS로 변경해야 합니다",
// "CAS server" => "CAS server",
"CAS Server Name" => "CAS 서버명",
"CAS Server Port" => "CAS 서버 포트",
"CAS Server Path" => "CAS 서버 경로",
"phpBB User Database Authentication " => "phpBB 사용자 데이터베이스 인증",
"You must change the Authentication Method to phpBB for these changes to take effect" => "이 변경내역들이 시행되려면 인증 방식을 반드시 phpBB 로 변경해야 합니다",
"You must turn Users can register off for phpBB Authentication to function properly" => "제대로 작동하려면 phpBB 인증에 대하여 사용자가 등록 가능 을 반드시 꺼야 합니다",
"MySql only (for now)" => "MySql 만 (현재 상황)",
// "Web server" => "Web server",
"Web Server Authentication " => "웹 서버 인증",
"You must change the Authentication Method to Web Server for these changes to take effect" => "이 변경내역들이 시행되려면 반드시 인증 방식을 웹 서버로 변경해야 합니다",
// "Password Blacklist" => "Password Blacklist",
// "Password blacklist tools" => "Password blacklist tools",
// "Upload Word List for Processing" => "Upload Word List for Processing",
// "Words currently indexed" => "Words currently indexed",
// "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below" => "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below",
// "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file" => "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file",
// "Use 'LOAD DATA INFILE'" => "Use 'LOAD DATA INFILE'",
// "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions" => "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions",
// "Create or Replace Word Index" => "Create or Replace Word Index",
// "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first" => "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first",
// "Delete Temporary Index" => "Delete Temporary Index",
// "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete" => "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete",
// "Blacklist Currently Using" => "Blacklist Currently Using",
// "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future" => "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future",
// "Number of passwords (limit)" => "Number of passwords (limit)",
// "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396" => "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396",
// "Minimum Password Length" => "Minimum Password Length",
// "The minimum password length for your password. This will filter out any password that has an illegal length" => "The minimum password length for your password. This will filter out any password that has an illegal length",
// "Require Numbers &amp; Letters" => "Require Numbers &amp; Letters",
// "If checked, will filter out any password that does not have both upper and lower case letters" => "If checked, will filter out any password that does not have both upper and lower case letters",
// "Require Special Characters" => "Require Special Characters",
// "If checked, will filter out any passwords that do not have special characters" => "If checked, will filter out any passwords that do not have special characters",
// "Save & Set as Default" => "Save & Set as Default",
// "View Password List" => "View Password List",
// "OAuth Server Settings" => "OAuth Server Settings",
// "Main theme" => "Main theme",
"Theme Screenshot" => "테마 스크린샷",
// "Theme Preferences" => "Theme Preferences",
// "{{\$theme|escape|ucfirst}}" => "{{\$theme|escape|ucfirst}}",
// "No theme preferences found" => "No theme preferences found",
// "General layout" => "General layout",
// "Admin pages layout" => "Admin pages layout",
// "Admin theme must be selected first" => "Admin theme must be selected first",
// "Fixed vs full width layout" => "Fixed vs full width layout",
// "Logo and Title" => "Logo and Title",
"Module zone visibility" => "모듈 영역 가시성",
// "Site report bar" => "Site report bar",
// "Limits" => "Limits",
"UI Effects" => "UI 효과",
"Standard UI effects" => "표준 UI 효과",
"Tab UI effects" => "탭 UI 효과",
"Customization" => "사용자 지정",
// "Custom codes" => "Custom codes",
"Editing" => "편집 중",
"View Templates" => "템플릿 보기",
"Edit Templates" => "템플릿 편집",
"Miscellaneous" => "기타",
// "Responsive images" => "Responsive images",
// "Context menus" => "Context menus",
// "currently used in file galleries only" => "currently used in file galleries only",
"Separators" => "분리 기호들",
// "Smarty templates (TPL files)" => "Smarty templates (TPL files)",
"Defaults" => "기본",
"See also" => "다음 내용도 참고하십시오",
"Search Engine Friendly URLs" => "검색 엔진 친화적 URL",
// "Also" => "Also",
// "here" => "here",
// "for more information on geo tagging" => "for more information on geo tagging",
"Meta tags" => "메타-태그",
// "Geo Metatags" => "Geo Metatags",
"Robots" => "로봇",
"&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site." => "\"모듈\" 은 사이트의 상단과 하단 및 우측과 좌측 컬럼의 내용물의 항목들입니다.",
"Admin &gt; Modules" => "관리 > 모듈",
"from the menu to create and edit modules" => "메뉴에서 하여 모듈을 만들고 편집합니다",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
"Hint" => "힌트",
"If you lose your login module, use tiki-login_scr.php to be able to login!" => "로그인 모듈을 손실하였다면, tiki-login_scr.php 를 사용하여 로그인하십시오!",
// "Composer not found" => "Composer not found",
// "Composer could not be executed, so the automated check on the packages cannot be performed" => "Composer could not be executed, so the automated check on the packages cannot be performed",
// "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer" => "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer",
// "Result of executing the changes to the packages" => "Result of executing the changes to the packages",
// "Composer errors" => "Composer errors",
// "Composer returned some errors" => "Composer returned some errors",
// "Issues with composer environment" => "Issues with composer environment",
// "Run %0 from a shell to try to fix this, see %1 for more info" => "Run %0 from a shell to try to fix this, see %1 for more info",
// "Packages" => "Packages",
// "Packages check could not be performed at the moment due to missing" => "Packages check could not be performed at the moment due to missing",
// "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow" => "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow",
// "Installed Packages" => "Installed Packages",
// "Status of the packages registered in the composer.json file" => "Status of the packages registered in the composer.json file",
// "Version Required" => "Version Required",
// "Version Installed" => "Version Installed",
// "Installed" => "Installed",
// "Missing" => "Missing",
// "Enable extension" => "Enable extension",
// "Update extension" => "Update extension",
// "Disable extension" => "Disable extension",
// "Removal not available" => "Removal not available",
// "This package is not managed by Tiki and likely was installed manually" => "This package is not managed by Tiki and likely was installed manually",
// "One or more packages appear to be missing" => "One or more packages appear to be missing",
// "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed" => "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed",
// "Could not validate the status of one or more packages" => "Could not validate the status of one or more packages",
// "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually" => "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually",
// "Install packages from the administrator interface" => "Install packages from the administrator interface",
// "The administrator interface can be used to install the packages marked as missing in the list above" => "The administrator interface can be used to install the packages marked as missing in the list above",
// "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them" => "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them",
// "Fix Missing Packages" => "Fix Missing Packages",
// "Install packages manually" => "Install packages manually",
// "Make sure <code>composer</code> is installed" => "Make sure <code>composer</code> is installed",
// "Composer can be installed manually, in the host machine, by following the instructions from the" => "Composer can be installed manually, in the host machine, by following the instructions from the",
// "website" => "website",
// "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>" => "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>",
// "Below is an example of how to do this in a Linux-like operating system" => "Below is an example of how to do this in a Linux-like operating system",
// "Install the missing packages" => "Install the missing packages",
// "You can install the missing packages by issuing the command" => "You can install the missing packages by issuing the command",
// "Available Packages" => "Available Packages",
// "These packages have been identified as required by one or more features" => "These packages have been identified as required by one or more features",
// "Licence" => "Licence",
// "Required by" => "Required by",
// "Not Available" => "Not Available",
"Install" => "설치",
// "There appear to be some optional packages that can be installed" => "There appear to be some optional packages that can be installed",
// "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package" => "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package",
// "The administrator interface can be used to install the optional packages in the list above" => "The administrator interface can be used to install the optional packages in the list above",
// "Click the \"Install Package\" button, and Tiki will try to install them" => "Click the \"Install Package\" button, and Tiki will try to install them",
// "Make sure there is a <code>composer.json</code> file in the root of the website" => "Make sure there is a <code>composer.json</code> file in the root of the website",
// "If there is not already a <code>composer.json</code> file, then create one" => "If there is not already a <code>composer.json</code> file, then create one",
// "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point" => "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point",
// "Install the package" => "Install the package",
// "Packages can be installed by issuing a command" => "Packages can be installed by issuing a command",
// "for each package that is to be installed" => "for each package that is to be installed",
// "Packages Custom" => "Packages Custom",
// "There are no manual managed packages installed in the folder vendor_custom" => "There are no manual managed packages installed in the folder vendor_custom",
// "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages" => "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages",
// "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab" => "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab",
// "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>" => "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>",
// "For information only" => "For information only",
// "These packages are managed manually and displayed here for informational purposes" => "These packages are managed manually and displayed here for informational purposes",
// "Packages Bundled" => "Packages Bundled",
// "These packages are bundled with Tiki, and displayed here for informational purposes" => "These packages are bundled with Tiki, and displayed here for informational purposes",
// "Composer Packages Bundled" => "Composer Packages Bundled",
// "status of the packages registered in the vendor_bundled/composer.json file" => "status of the packages registered in the vendor_bundled/composer.json file",
// "Diagnose" => "Diagnose",
// "Diagnose Composer Installation" => "Diagnose Composer Installation",
// "Use the button below to test your composer installation" => "Use the button below to test your composer installation",
// "Diagnose Composer" => "Diagnose Composer",
// "Composer management" => "Composer management",
// "Install Composer" => "Install Composer",
// "Update Composer" => "Update Composer",
// "Remove composer.lock" => "Remove composer.lock",
// "Clean vendor folder" => "Clean vendor folder",
// "{\$diagnostic_composer_location}" => "{\$diagnostic_composer_location}",
// "Extensions Preferences" => "Extensions Preferences",
// "Activate Extension Package" => "Activate Extension Package",
// "Extension Package Groups API" => "Extension Package Groups API",
"Payments" => "지불",
"Choose payment system" => "지불 시스템 선택",
"You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "지불 방식은 단 한 개만 사용할 수 있습니다: 페이팔 혹은 Cclite 혹은 티키 사용자 크레딧",
"PayPal is working at the moment. See PayPal.com" => "페이팔이 현재 작업 중입니다. PayPal.com 을 방문하십시오",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: 지역 교환 거래 시스템 (LET)에 대한 커뮤니티 통화 회계. 다음을 참조",
// "sourceforge.net" => "sourceforge.net",
"Tiki User Credits: Requires this other feature to be configured" => "티키 사용자 신용: 이 다른 기능이 구성되는 것을 요구함",
// "Israel Post payment module" => "Israel Post payment module",
"Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite 는 대안 혹은 보안 거래 화폐 혹은 그룹을 만들기 및 관리를 위한 것입니다.",
"Work in progress since Tiki 6" => "티키 6 이후 진행 중인 작업",
"Advanced Shopping Cart" => "고급 장바구니",
// "Cart settings" => "Cart settings",
// "Advanced cart tracker names setup" => "Advanced cart tracker names setup",
// "Products tracker setup" => "Products tracker setup",
"Depending on which feature you are using, you may need some or all of the following fields to be setup" => "사용하는 기능에 따라, 다음 필드들의 일부 혹은 전부가 설정되어야할 수 있습니다",
"Shipping" => "배송",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
"Output compression is active" => "출력 압축이 활성화 상태임",
"Compression is handled by" => "압축은 다음을 이용하여 처리됩니다",
// "PHP settings" => "PHP settings",
// "Some PHP.INI settings that can increase performance" => "Some PHP.INI settings that can increase performance",
// "'realpath_cache_size setting': %0" => "'realpath_cache_size setting': %0",
// "(percentage used %0 %" => "(percentage used %0 %",
// "Determines the size of the realpath cache to be used by PHP" => "Determines the size of the realpath cache to be used by PHP",
// "'realpath_cache_ttl setting': %0 seconds" => "'realpath_cache_ttl setting': %0 seconds",
// "Duration of time (in seconds) for which to cache realpath information for a given file or directory" => "Duration of time (in seconds) for which to cache realpath information for a given file or directory",
"Bytecode Cache" => "바이트코드 캐시",
// "Using <strong>%0</strong>. These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>. These stats affect all PHP applications running on the server",
"Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "<em>xcache.admin.enable_auth</em> 구성 설정은 통계자료를 접근하는 것을 금지합니다. 이는 또한 템플릿 캐시를 삭제할 때 캐시가 삭제되는 것을 방지합니다",
"Memory Used" => "메모리 사용됨",
"Cache Hits" => "캐시 Hits",
// "Misses" => "Misses",
"Few hits recorded. Statistics may not be representative" => "몇 안되는 방문만 기록됨. 통계는 대표성이 없을 수 있음",
"Low hit ratio. %0 may be misconfigured and not used" => "방문 비율 낮음. %0 는 잘못구성되었으며 사용되지 않을 수 있음",
"Little memory available. Thrashing likely to occur" => "적은 메모리 사용가능. Thrashing 발생 가능성 큼",
// "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)" => "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)",
"Small amount of memory allocated to %0. Verify the configuration" => "작은 양의 메모리가 %로 할당됨. 구성을 확인하십시오",
"Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "<em>%0</em> 구성이 사용됨. 수정 확인을 사용 안 함을 하는 것은 성능을 향상할 수 있지만, 파일 업데이트 시 수동으로 삭제가 필요하게 됩니다",
"<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> 은 XCache 상의 인증때문에 비활성화 상태가 되지 않아야 함",
// "Clear all APC caches" => "Clear all APC caches",
// "Clear APC caches" => "Clear APC caches",
// "Clear Caches" => "Clear Caches",
// "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments",
// "Major Slowdown" => "Major Slowdown",
"Major slowdown" => "주요 느려짐 현상",
"These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "다음은 티키를 느려지게 한다고 알려진 것들입니다. 고 용량의 사이트를 운영하신다면, 다음을 사용 안 함을 고려해 보십시오.",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>",
// "Time and Memory Limits" => "Time and Memory Limits",
// "PDF settings" => "PDF settings",
// "Wiki print version" => "Wiki print version",
// "Other features" => "Other features",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "프로필 리포지터리의 일부가 연결되지 않습니다. 이는 특정 프로필을 적용하는 것을 방해할 수 있습니다",
// "Find profiles" => "Find profiles",
// "Search by name, types and repository" => "Search by name, types and repository",
// "Profile types" => "Profile types",
"Profile repository" => "프로필 리포지터리",
// "Suggested Profiles" => "Suggested Profiles",
// "Featured Site Profiles" => "Featured Site Profiles",
// "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
"Full Profiles" => "전체 프로필",
"Full Profiles are full featured out of the box solutions" => "전체 프로필은 모든 기능이 즉시 사용 가능한 솔루션입니다",
"Mini Profiles" => "미니 프로필",
"Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "미니 프로필은 특정 기능을 구성할 것이며 기존 구성에 추가 기능성을 더할 수 있는 훌륭한 방법입니다",
"Learning Profiles" => "학습용 프로필",
"Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "학습용 프로필은 티키 안의 특정 기능에 대하여 빠르게 평가할 수 있게 합니다",
// "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>" => "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>",
"Repository" => "리포지터리",
// "Profile type" => "Profile type",
// "See profile info below (may take a few seconds to load)" => "See profile info below (may take a few seconds to load)",
"applied" => "적용됨",
"JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "프로필을 적용하려면 자바스크립트는 반드시 <strong>켜져</strong> 있어야만 합니다. 자바스크립트를 활성화한 후 다시 시도하십시오",
"Export YAML" => "YAML 내보내기",
"Export modified preferences as YAML" => "수정된 기본설정을 YAML로 내보내기",
"Toggle Visible" => "표시됨 토글",
"Show added preferences" => "추가된 기본설정 표시",
"no default" => "기본값 없음",
// "Repository status" => "Repository status",
// "status of the registered profile repositories" => "status of the registered profile repositories",
"Refresh" => "갱신",
"Profile tester" => "프로필 테스터",
"Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "아래의 텍스트 영역으로 위키 마크업 및 YAML ({literal}{CODE}{/literal} 태크를 포함하거나 포함하징낳거나) 를 붙여넣거나 입력",
"This will run the profile and make potentially unrecoverable changes in your database" => "이는 프로필을 실행할 것이며 귀하의 데이터베이스에 잠정적으로 복구불가능한 변경을 가할 것입니다",
// "Test profile name" => "Test profile name",
// "Permission added" => "Permission added",
// "User added" => "User added",
// "User modified" => "User modified",
// "Group added" => "Group added",
// "old value" => "old value",
// "Installer added" => "Installer added",
// "Profile without changes" => "Profile without changes",
"Global configuration" => "전역 설정",
// "This preference needs to be disabled" => "This preference needs to be disabled",
// "Enabling ratings for forums" => "Enabling ratings for forums",
// "You need to" => "You need to",
// "Create or edit a forum and enable" => "Create or edit a forum and enable",
"Posts can be rated" => "게시물은 등급이 부여될 수 없음",
// "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user" => "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Set the rating options at" => "Set the rating options at",
"Ratings" => "등급",
// "see above" => "see above",
// "Permissions involved" => "Permissions involved",
// "tiki" => "tiki",
// "Default Options" => "Default Options",
"Cache duration" => "캐시 기간",
"Create new" => "새로 만들기",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds",
"Feeds" => "피드",
"Feed for articles" => "기사에 대한 피드",
"Feed for blogs" => "블로그에 대한 피드",
"Feed for individual blogs" => "개별 블로그에 대한 피드",
"Feed for image galleries" => "그림 갤러리에 대한 피드",
"Feed for individual image galleries" => "개별 그림 갤러리에 대한 피드",
"Feed for file galleries" => "파일 갤러리에 대한 피드",
"Feed for individual file galleries" => "개별 파일 갤러리에 대한 피드",
"Feed for wiki pages (with diff)" => "위키 페이지에 대한 피드 (diff 있음)",
// "with diff" => "with diff",
"Feed for wiki pages (no diff)" => "위키 페이지에 대한 피드 (diff 없음)",
// "no diff" => "no diff",
"Feed for forums" => "게시판에 대한 피드",
"Feed for individual forums" => "개별 게시판에 대한 피드",
"Feed for trackers" => "트래커에 대한 피드",
"Feed for calendars" => "달력에 대한 피드",
"Feed for directories" => "디렉터리에 대한 피드",
"Feed for shoutbox" => "외침상자에 대한 피드",
// "Incoming Feeds" => "Incoming Feeds",
"You can see users rank by score in the module users_rank, for that go to" => "users_rank 모듈 안에서 점수에 의한 사용자 순위를 볼 수 있습니다, 이에 대하여 다음으로 이동하십시오",
"Admin modules" => "모듈 관리",
// "Cause scores older than a certain number of days to expire" => "Cause scores older than a certain number of days to expire",
// "Scoring rules" => "Scoring rules",
// "Unique rule ID" => "Unique rule ID",
// "Rule" => "Rule",
// "A label or ID to help identify which event was triggered to get points" => "A label or ID to help identify which event was triggered to get points",
// "Pts recipient type" => "Pts recipient type",
// "Recipient Type" => "Recipient Type",
// "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event" => "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event",
// "Pts recipient" => "Pts recipient",
// "The ID of the points recipient" => "The ID of the points recipient",
// "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered" => "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered",
// "Points Given" => "Points Given",
// "This is the numerical value of the points being given" => "This is the numerical value of the points being given",
// "Triggering event" => "Triggering event",
// "Reversal event" => "Reversal event",
// "Valid Triggering Object IDs" => "Valid Triggering Object IDs",
// "Valid Object Ids" => "Valid Object Ids",
// "This is a comma-separated list of object ids for which the event is valid" => "This is a comma-separated list of object ids for which the event is valid",
// "Min. Time Between Scoring" => "Min. Time Between Scoring",
// "Time between scoring" => "Time between scoring",
// "This is the amount of time in seconds that a user must wait before again being able to get points for this event" => "This is the amount of time in seconds that a user must wait before again being able to get points for this event",
"can be seen on page" => "페이지에 표기 가능",
"in Admin menu" => "관리 메뉴 내부에",
// "Also see the Search Indexing tab" => "Also see the Search Indexing tab",
"File Gallery admin panel" => "파일 갤러리 관리 패널",
// "About the Unified Index" => "About the Unified Index",
// "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things" => "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things",
// "Disabling this will cause some parts of Tiki to be unavailable" => "Disabling this will cause some parts of Tiki to be unavailable",
// "Find out more about it here" => "Find out more about it here",
// "Search engine settings" => "Search engine settings",
// "About Unified search engines" => "About Unified search engines",
// "Advantages" => "Advantages",
// "Fast performance. Works out of the box with Tiki and even on most basic server setups" => "Fast performance. Works out of the box with Tiki and even on most basic server setups",
// "Disadvantages" => "Disadvantages",
// "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable" => "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable",
// "link" => "link",
// " for full list) " => " for full list) ",
"Lucene (PHP implementation)" => "Lucene (PHP 구현)",
// "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki" => "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki",
// "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues" => "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues",
// "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki" => "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki",
// "Needs to be separately installed from Tiki and requires more configuration" => "Needs to be separately installed from Tiki and requires more configuration",
// "for more information) " => "for more information) ",
// "About Use MySQL Full-Text Search as fallback" => "About Use MySQL Full-Text Search as fallback",
// "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability" => "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability",
// "Elastic search only" => "Elastic search only",
// "Experiment with LIST plugin syntax" => "Experiment with LIST plugin syntax",
// "After you have found the correct contents, you may copy-paste them in a LIST plugin" => "After you have found the correct contents, you may copy-paste them in a LIST plugin",
// "Legacy search" => "Legacy search",
"Forum searches" => "게시판 검색",
"Search Results" => "검색 결과",
// "Items to display in search results" => "Items to display in search results",
// "Information to display for each result" => "Information to display for each result",
// "Stored Search" => "Stored Search",
"Configuration" => "구성",
// "ManifoldCF Configuration Checker" => "ManifoldCF Configuration Checker",
// "Occurrences of string in database" => "Occurrences of string in database",
// "Set default table" => "Set default table",
// "Text to search" => "Text to search",
// "Results for " => "Results for ",
// "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}" => "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}",
// "Occurrences" => "Occurrences",
// "View occurrences" => "View occurrences",
// "in table " => "in table ",
// "column" => "column",
// "Page preview" => "Page preview",
"View page" => "페이지 보기",
// "View blog post" => "View blog post",
// "View file" => "View file",
// "View gallery" => "View gallery",
// "View category" => "View category",
// "View article" => "View article",
// "View forum" => "View forum",
// "View calendar" => "View calendar",
// "View calendar item" => "View calendar item",
// "View tracker" => "View tracker",
// "View tracker item" => "View tracker item",
// "View forum comment" => "View forum comment",
// "Back to first level results" => "Back to first level results",
"Admin groups" => "그룹관리",
"Admin Groups" => "그룹 관리",
"Admin users" => "사용자 관리",
"Admin Users" => "사용자 관리",
"Manage permissions" => "권한 관리",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings" => "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings",
"General Security" => "일반 보안",
// "MySQL SSL connection" => "MySQL SSL connection",
// "MySQL SSL connection is active" => "MySQL SSL connection is active",
// "MySQL connection is not encrypted" => "MySQL connection is not encrypted",
// "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"" => "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"",
// "MySQL Server does not have SSL activated" => "MySQL Server does not have SSL activated",
// "Smarty and Features Security" => "Smarty and Features Security",
"Please also see" => "여기를 봐주세요",
"HTTPS (SSL) and other login preferences" => "HTTPS (SSL) 및 기타 로그인 기본설정",
// "User Encryption" => "User Encryption",
// "Requires the OpenSSL PHP extension for encryption" => "Requires the OpenSSL PHP extension for encryption",
// "You have OpenSSL installed" => "You have OpenSSL installed",
// "OpenSSL is not loaded" => "OpenSSL is not loaded",
// "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption" => "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption",
// "You may also want to add the Domain Password module somewhere" => "You may also want to add the Domain Password module somewhere",
// "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ" => "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ",
// "The user can add passwords for a registered password domain" => "The user can add passwords for a registered password domain",
// "Statistics for existing data" => "Statistics for existing data",
// "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension" => "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension",
// "CSRF security" => "CSRF security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "HTTP Headers" => "HTTP Headers",
// "Use these options to add options related with security to the HTTP Headers" => "Use these options to add options related with security to the HTTP Headers",
// "Spam Protection" => "Spam Protection",
// "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself" => "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself",
"Search results" => "검색결과",
"Site Access" => "사이트 접근",
// "Admin IDS custom rules" => "Admin IDS custom rules",
"Tokens" => "토큰",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)",
// "OpenPGP" => "OpenPGP",
// "OpenPGP functionality for PGP/MIME encrypted email messaging" => "OpenPGP functionality for PGP/MIME encrypted email messaging",
"Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging" => "PGP/MIME 암호화 된 이메일 메시징에 대한 실험적 OpenPGP 기능성",
"All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses" => "모든 이메일-메시징/알림/회보는 PGP/MIME-암호화된 메시지로써 전송되며, signer-key 로 서명되고,외부인들에게 완전히 100% 불투명합니다. 모든 사용자 계정은 티키 계정과 연결된 이메일 주소에 연계된 공용-키와 함께 gnupg keyring 로 적절히 구성되어야 합니다",
"If you use preferences option for the signer passphrase, clear the file option just for security" => "서명자 패스문구에 대하여 기본설정 선택사항을 사용하는 경우, 단순히 보안만 위하여 파일 선택사항을 삭제하십시오",
"If you use file for the signer passphrase, clear the preferences option just for security" => "서명자 패스문구에 대한 파일을 사용하는 경우, 단순히 보안을 위하여 기본설정 선택사항을 삭제하십시오",
// "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring" => "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring",
"SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL 은 IIS 에 대하여 <strong>URL Rewrite 모듈</strong> 을 필요로 합니다. 이 모듈이 설치되지 않은 것으로 보입니다",
// "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
"SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL 은 티키 특정 지시어가 %0 파일 내부에 배포되어있지 않은 경우 작동하지 않을 것입니다",
"To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "이 파일을 활성화하려면, 단순히 %0 파일(귀하의 티키 설치의 주 디렉터리에 위치함)을 %1 로 복사하십시오",
"If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "기존 (티키가 아닌) %0 파일을 유지해야할 경우, 간단히 여기에 티키 지시문을 추가하십시오",
"When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "티키를 업그레이드 할 때 (예: 버전 7에서 버전 8), 새 URL rewriting 구성 파일을 사용한다는 점을 확인하십시오",
"%0 file is missing" => "%0 파일이 없습니다",
"Unable to verify that your URL rewriting configuration is up to date" => "URL rewriting 구성이 최신상태인지 확인할 수 없었음",
"SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL 은 티키 URL rewriting 구성이 최근 내용이 아니라면 완전히 제대로 작동하지 않을 수 있습니다",
"%0 is not in the expected format" => "%0은 예상된 형식이 아닙니다",
"%0 may simply be outdated" => "%0은 단순히 오래된 것일 수 있습니다",
"To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "이 파일을 갱신하려면, 사용자 지정되지 않은 경우, %0 파일 (티키 설치 주 디렉터리에 위치함) 을 %1 으로 복사하여, 후자를 덮어쓰십시오",
"%0 file is out of date" => "%0 파일이 오래되었습니다",
"The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "RewriteBase 지시문이 제대로 설정되지 않은 것으로 보입니다. 이는 sefurl 가 제대로 작동하려면 필요합니다",
"The current value in %0 is %1 but the base url for this site is %2" => "%0 내부의 현재값은 %1 이지만 이 사이트의 베이스 URL은 %2 입니다",
// "For example, if the field is left blank, the canonical URL domain is" => "For example, if the field is left blank, the canonical URL domain is",
// "URL parameters" => "URL parameters",
"List of Url Parameters that should go in the path" => "경로 안으로 들어가야할 URL 매개 변수들의 목록",
// "Known types" => "Known types",
"Invert" => "반전",
"Show Usage" => "사용 표시",
"Delete &amp; Unreference" => "삭제 &amp; 참조해제",
"Invert Relation" => "관계 반전",
// "New types" => "New types",
"Fix" => "수정",
"No occurences found" => "발견된 발생사례 없음",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Social network integration" => "Social network integration",
"To use Twitter integration, you must register this site as an application at" => "트위터 통합을 사용하려면, 먼저 이 사이트를 응용프로그램으로써 다음 주소에서 등록해야하며, ",
"and allow write access for the application" => "그리고 응용프로그램에 대한 쓰기 접근을 허용해야 합니다",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "입력하십시오 &lt;귀하의 사이트 URL&gt;tiki-socialnetworks.php 를 콜백 URL 으로써",
"To use Facebook integration, you must register this site as an application at" => "페이스북 통합을 이용하려면, 먼저 다음 장소에서 이 사이트를 등록해야만 합니다",
"and allow extended access for the application" => "그리고 응용프로그램에 대한 확장된 접근을 허용",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "&lt;귀하의 사이트 URL&gt;tiki-socialnetworks.php?request_facebook 을 사이트 URL로 &lt;귀하의 사이트&gt; 를 사이트 도메인으로 입력하십시오",
"The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it." => "다음 기본설정은 승인 시, 페이스북으로 하여금, 사용자들이 티키에게 어떤 권한을 허용할 것인지에 대한 질문을 묻는 것에 영향을 미치게 됩니다.",
// "bit.ly" => "bit.ly",
"There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "사이트 전역에 걸친 bit.ly 계정을 설정할 필요는 없습니다; 사용자 각각 개인의 계정을 가질 수 있습니다, 하지만 사이트 전체의 통계를 확인할 수 있게 됩니다.",
"Go to" => "다음 장소로 가서 ",
"to sign up for an account" => "계정 등록을 하십시오",
"to retrieve the API key" => "API 키를 찾아오십시오",
// "To use LinkedIn integration, you must register this site as an application at" => "To use LinkedIn integration, you must register this site as an application at",
// "and allow necessary permissions for the application" => "and allow necessary permissions for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs" => "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs",
// "Share This" => "Share This",
// "This is a new control panel on Tiki and work is still in progress" => "This is a new control panel on Tiki and work is still in progress",
// "Tiki Statistics" => "Tiki Statistics",
// "Piwik Analytics" => "Piwik Analytics",
"Text area (that apply throughout many features)" => "텍스트 영영 (많은 기능을 통해 적용됨)",
"Wiki syntax" => "위키 문법",
// "Typography" => "Typography",
"Default size" => "기본 크기",
"External links and images" => "외부 링크 및 그림",
"External links will be identified with:" => "외부 링크는 다음 기호와 함꼐 표기됩니다:",
"About plugins" => "플러그인 정보",
"Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "티키 플러그인은 위키 페이지, 기사, 블로그 등에 기능성을 추가합니다. 아래에서 이들을 활성 및 비활성할 수 있습니다",
// "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>",
"The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "편집-플러그인 아이콘은 사용자들이 위키 페이지 내부에 각 플러그인의 매개변수를 편집할 수 있는 쉬운 방법입니다. 아래에서 개별 플러그인에 대하여 비활성화 될 수 있습니다",
"Check disabled plugins used in wiki pages" => "위키 페이지에 사용된 비활성화 상태의 플러그인들 검사",
"Disabled used plugins" => "비활성화된 사용된 플러그인",
"Plugin preferences" => "플러그인 기본설정",
"Edit plugin icons" => "플러그인 아이콘 편집",
// "Plugin List" => "Plugin List",
// "Use the filter input above to find plugins, or enter return to see the whole list" => "Use the filter input above to find plugins, or enter return to see the whole list",
"Search Help" => "검색 도움말",
"Disable edit plugin icon (make plugin inline)" => "편집 플러그인 아이콘 사용 안 함 (플러인을 인라인으로 만듬)",
"Plugin Aliases" => "플러그인 별칭",
"About plugin aliases" => "플러그인 별칭 정보",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins",
// "Find out more here" => "Find out more here",
// "This page is designed to work with JavaScript" => "This page is designed to work with JavaScript",
// "Available alias" => "Available alias",
// "Plugin Alias" => "Plugin Alias",
// "Enable Checked Plugins" => "Enable Checked Plugins",
// "General information" => "General information",
"Plugin name" => "플러그인명",
// "Base plugin" => "Base plugin",
// "Body label" => "Body label",
"Dependencies" => "의존도",
// "Inline (no plugin edit UI)" => "Inline (no plugin edit UI)",
// "Simple plugin arguments" => "Simple plugin arguments",
// "Add parameter" => "Add parameter",
"Argument" => "인수",
// "Delete this parameter" => "Delete this parameter",
// "Default Value" => "Default Value",
// "Plugin parameter documentation" => "Plugin parameter documentation",
// "Add parameter documentation" => "Add parameter documentation",
// "Delete this parameter's documentation" => "Delete this parameter's documentation",
"Safe" => "안전",
"Plugin body" => "블러그인 본문",
// "Ignore user input" => "Ignore user input",
// "Default content" => "Default content",
// "Body Parameters" => "Body Parameters",
// "Add body parameter" => "Add body parameter",
// "Delete this body parameter" => "Delete this body parameter",
"Encoding" => "인코딩",
// "Argument source (if different)" => "Argument source (if different)",
// "Composed plugin arguments" => "Composed plugin arguments",
// "Add composed parameter" => "Add composed parameter",
// "Delete this composed argument" => "Delete this composed argument",
"Pattern" => "패턴",
// "Composed parameters" => "Composed parameters",
// "Delete this composed parameter" => "Delete this composed parameter",
"Tracker settings" => "트래커 설정",
// "Field settings" => "Field settings",
// "Linked wiki pages" => "Linked wiki pages",
// "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features" => "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features",
"Tracker attachment preferences" => "트래커 첨부파일 기본설정",
// "Tracker force-fill feature" => "Tracker force-fill feature",
"Field Types" => "필드 종류",
// "Field types" => "Field types",
"Tracker attachments" => "트래커 첨부파일",
// "dls" => "dls",
"Switch storage" => "저장공간 변경",
"Change all to db" => "모두 db로 변경",
"Change all to file" => "모두 파일로 변경",
// "User Settings" => "User Settings",
"Default user preferences" => "기본 사용자 기본 설정",
"Users Default Preferences" => "사용자 기본 선호설정",
// "My Account Items" => "My Account Items",
// "User Features" => "User Features",
// "User Account Features" => "User Account Features",
// "User Info and Picture" => "User Info and Picture",
"User information display" => "사용자 정보 표시",
// "Messaging and Notifications" => "Messaging and Notifications",
// "User notifications" => "User notifications",
// "For the digest emails to be sent out, you will need to set-up a cron job" => "For the digest emails to be sent out, you will need to set-up a cron job",
// "Adjust the command parameters for your digest frequency. Default frequency is 7 days" => "Adjust the command parameters for your digest frequency. Default frequency is 7 days",
// "Sample command" => "Sample command",
"User Files" => "사용자 파일",
"Kaltura" => "칼투라",
"Kaltura Registration" => "Kaltura 등록",
"To get a Kaltura Partner ID:" => "Kaltura 파트너 ID 를 얻으려면:",
"Setup your own instance of Kaltura Community Edition (CE)" => "Kaltura 커뮤니티 에디션 (CE) 을 설치하십시오",
"get an account via Kaltura.com" => "Kaltura.com 에서 계정을 구하십시오",
"List Media" => "미디어 나열",
"List Remix Entries" => "재혼합 입력 나열",
"Add New Media" => "새 미디어 추가",
"Plugin to embed in pages" => "페이지 내부에 임베드될 플러그인",
// "Enable related tracker field types" => "Enable related tracker field types",
"Kaltura / Tiki config" => "칼투라 / 티키 구성",
// "Kaltura partner settings" => "Kaltura partner settings",
// "Kaltura dynamic player" => "Kaltura dynamic player",
// "Kaltura contribution wizard" => "Kaltura contribution wizard",
"You can manually edit these values in lib/videogals/standardTikiKcw.xml" => "lib/videogals/standardTikiKcw.xml 내부에서 이 값들을 수동으로 편집할 수 있습니다",
// "Recreate KCW \"uiConf\"" => "Recreate KCW \"uiConf\"",
"Legacy support" => "레거시 지원",
"Webservices" => "웹서비스",
"Use the 'Quick Edit' module to easily create or edit wiki pages." => "'빠른 편집' 모듈을 사용하여 위키 페이지를 쉽게 만들고 편집하십시오.",
// "List wiki pages" => "List wiki pages",
// "List structures" => "List structures",
"Page display" => "페이지 표기",
// "Automatic table of contents" => "Automatic table of contents",
// "General features" => "General features",
"Export Wiki Pages" => "Wiki페이지 내보내기",
// "Redirect and Similar" => "Redirect and Similar",
// "Wikiwords Features" => "Wikiwords Features",
"If you change storage, it is better to move all the files for easy backup.." => "저장공간을 변경한 경우, 손쉬운 백업을 위하여 모든 파일을 이동하는 것이 좋습니다",
// "Move all attachments to database" => "Move all attachments to database",
// "Move all attachments to file system" => "Move all attachments to file system",
"Remove unused pictures" => "사용되지 않는 그림 제거",
"Move images from wiki_up to the home file gallery" => "그림을 wiki_up 에서 홈 파일 갤러리로 이동",
// "Move images to home gallery" => "Move images to home gallery",
"If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "이 버튼을 사용하는 경우, 데이터베이스와 wiki_up 디렉터리의 백업을 보유하고 있다는 점을 확인하십시오",
"Wiki watch" => "위키 주시",
// "Namespaces" => "Namespaces",
"Settings that may be affected by the namespace separator" => "네임스페이스 분리자에 의하여 영향을 받을 수 있는 설정",
"Flagged Revision" => "플래그 지정된 수정",
"Page Listings" => "페이지 나열",
"Select which items to display when listing pages:" => "페이지 나열 시 표기될 항목 선택:",
// "Database dumps and restores" => "Database dumps and restores",
// "Name for dump" => "Name for dump",
// "Create Database Dump" => "Create Database Dump",
// "Wiki database" => "Wiki database",
"Restore" => "복원",
// "Dump files" => "Dump files",
// "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks" => "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks",
// "The HTML files generated may refer to files not included in the dump" => "The HTML files generated may refer to files not included in the dump",
// "Dumps do not include files attached to wiki pages" => "Dumps do not include files attached to wiki pages",
// "Dumping will overwrite the preexisting dump" => "Dumping will overwrite the preexisting dump",
// "Create Dump File" => "Create Dump File",
// "Download Dump File" => "Download Dump File",
// "Remove Dump File" => "Remove Dump File",
// "Mass replace and page permissions report" => "Mass replace and page permissions report",
"Mass search and replace" => "대량 검색 및 교체",
"Report wiki pages with direct object permissions" => "직접 개체 권한으로된 위키 페이지 보고",
"Wiki attachments" => "Wiki첨부파일",
// "Move attachment to database" => "Move attachment to database",
// "Move to database" => "Move to database",
// "Move attachment to file system" => "Move attachment to file system",
// "Move to file system" => "Move to file system",
"Exclusive" => "독점",
// "Share Common" => "Share Common",
"Edit perspective" => "perspective 편집",
// "No areas found. Click \"Update Areas\" to populate this list" => "No areas found. Click \"Update Areas\" to populate this list",
// "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> " => "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> ",
"Update areas" => "영역 갱신",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>",
"Page links" => "페이지 링크",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature",
// "WYSIWYG editor features" => "WYSIWYG editor features",
"Related features" => "관련 기능",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "위치",
"Cache Time" => "캐시 시간",
"secs" => "초",
"Use Ctrl+Click to select multiple options" => "Ctrl+Click 을 사용하여 여러 개의 선택사항을 선택",
// "The" => "The",
"Display Modules to All Groups" => "모든 그룹에 모듈 표시",
"setting will override your selection of specific groups" => "설정은 귀하의 특정 그룹의 선택을 재정의할 것입니다",
"Displayed now for all eligible users even with personal assigned modules" => "개인 할당 모듈이 있는 모든 적합한 사용자에게도 이제 표기됨",
"Displayed for the eligible users with no personal assigned modules" => "개인 할당 모듈이 없는 적합한 사용자를 위해 표기됨",
"Displayed now, can't be unassigned" => "지금 표기됨, 할당해제 될 수 없음",
"Not displayed until a user chooses it" => "사용자가 선택하기 전까지 표시되지 않음",
"Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "<a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">사용자는 모듈 구성이 가능 </a> 하기 때문에, 어떤 것이든지 선택하십시오",
"to make sure users will notice any newly assigned modules" => "사용자들이 새롭게 할당된 모듈들에 대하여 알고 있도록 확인하려면",
"required" => "필수",
"Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "매개변수: 모듈 및/혹은 일반 매개변수로의 특정 매개변수 ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. 예: maxlen=15&amp;nonums=y",
"Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "매개 변수를 URL 형식으로 입력하시오, 예: 'nobox=y&class=rbox-data'",
"Edit custom module" => "사용자 지정 모듈 편집",
// "Enter the code below" => "Enter the code below",
"Anti-Bot verification code image" => "안티봇 확인 코드 그림",
"Try another code" => "다른 코드 사용",
// "Your article has been added" => "Your article has been added",
// "Create Article" => "Create Article",
// "Expires" => "Expires",
// "Users rating: " => "Users rating: ",
// "{\$topicName}" => "{\$topicName}",
// "List all articles of the same topic" => "List all articles of the same topic",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
"You do not have permission to read complete articles" => "완성된 기사들을 읽을 권한이 없습니다",
"First page" => "첫 페이지",
"Previous page" => "페이지 미리보기",
"Next page" => "다음 페이지",
"Last page" => "마지막 페이지",
"Related content" => "관련 컨텐츠",
"bytes" => "바이트",
// "Article actions" => "Article actions",
"Send a link" => "링크 전송",
// "Get a short URL" => "Get a short URL",
"Attached files" => "첨부된 파일",
"Upload file" => "파일 업로드",
// "File upload comment" => "File upload comment",
"Attach" => "첨부",
"Attach a file to this item" => "이 아이템으로 파일 첨부하",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "추가 정보",
"No attachments for this item" => "이 아이템에 대한 첨부 없음",
// "Blog actions" => "Blog actions",
// "Blog Actions" => "Blog Actions",
"Monitor" => "주시",
// "Stop monitoring" => "Stop monitoring",
"Group Monitor" => "그룹 주시",
// "RSS" => "RSS",
"Watched by categories" => "범주로 주시됨",
// "Blog post actions" => "Blog post actions",
"Save to notepad" => "메모장에 저장",
// "Published By" => "Published By",
"Publish Date" => "펴낸 날짜",
"Previous post" => "게시물 미리보기",
"Next post" => "다음 게시물",
"More.." => "추가..",
"pages" => "페이지",
"Last" => "이전",
"private" => "비공개",
"permanent link" => "고정 링크",
"Leave a comment" => "댓글 남기기",
"%0 comment" => "%0 댓글",
"%0 comments" => "%0 댓글들",
// "{\$item.name}" => "{\$item.name}",
// "{\$sub.name}" => "{\$sub.name}",
"Parent Gallery" => "부모 갤러리",
"No records found" => "발견된 기록 없음",
"Select Categories" => "범주 선택",
"Admin Categories" => "범주 관리",
"Select/deselect all categories" => "모든 범주 선택/선택해제",
"No categories defined" => "카테고리 작성되지 않음",
"Browse Category" => "범주 탐색",
"Are you sure you want to archive this comment" => "이 댓글을 보관하시겠습니까?",
"Are you sure you want to unarchive this comment" => "이 댓글을 보관 해제하시겠습니까",
// "Edit Comment" => "Edit Comment",
// "Comments unlocked" => "Comments unlocked",
"Post new comment" => "새 코멘트 추가",
"There are no comments at this time" => "현재 댓글이 없습니다",
"Add Comment" => "댓글 추가",
"Reply" => "댓글",
"Archived" => "보관됨",
"Unarchive" => "보관해제",
"Archive" => "보관",
"Rejected" => "거부됨",
"Approve" => "승인",
"Reject" => "거부",
"Are you sure you want to lock comments on this object" => "이 개체 상의 댓글을 잠그시겠습니까",
"Are you sure you want to approve this comment" => "이 댓글을 승인하시겠습니까?",
"Are you sure you want to reject this comment" => "이 댓글을 거부하시겠습니까",
// "Go back to" => "Go back to",
"You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity" => "귀하는 현재 본 사이트에 등록되어 있습니다. 이 섹션은 선택사항입니다. 작성을 하면, 이 게시물을 귀하의 계정에 연결하지 않고 익명성을 보존하게 됩니다",
"Website" => "웹사이트",
"Send me an email when someone replies" => "누군가 댓글을 올리면 나에게 이메일 전송",
// "Are you sure you want to delete this comment" => "Are you sure you want to delete this comment",
"Are you sure you want to unlock comments on this object" => "이 개체의 댓글 잠금을 해제하시겠습니까",
"Posted by" => "게시자",
// "Private message" => "Private message",
"private message" => "개인 메시지",
// "Send eMail to user" => "Send eMail to user",
// "User online" => "User online",
// "User offline" => "User offline",
// "Download attachment" => "Download attachment",
// "Remove attachment" => "Remove attachment",
"Deliberation Items" => "심의 항목",
"top of page" => "페이지 상단",
"Notification" => "알림",
// "Delete post" => "Delete post",
"Report this post" => "이 게시물을 보고",
"Group monitor" => "그룹 모니터",
// "Moderator actions for selected topics" => "Moderator actions for selected topics",
// "Reported messages" => "Reported messages",
"Reported" => "보고됨",
// "Queued messages" => "Queued messages",
"Queued" => "대기상태",
"Threshold" => "임계값",
"Replies" => "답신",
"below your current threshold" => "현재 임계값 아래",
"Page:" => "페이지:",
"New Reply" => "새 회신",
"Editing reply" => "댓글 편집 중",
"Reply to the selected post" => "선택된 게시물에 답글 달기",
"Post new message" => "새 메시지 게시",
"If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address" => "누군가 이 토픽에 답글을 올릴 때 알림을 받기를 원하는 경우<br>저희에게 귀하의 이메일을 말하여 주십시오",
"Maximum size" => "쵀대 크기",
"Reply to parent post" => "부모 게시물에 답글달기",
"Post new reply" => "새 댓글 게시",
"Post as Anonymous" => "익명으로 게시",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "미리보기는 첨부파일을 유지하지 않는 다는 점에 유의하시고, 그 작업은 게시하기 전에 선택해야 합니다",
"Posting replies" => "댓글 게시 중",
"Please enter a title" => "제목을 입력하여 주십시오",
"1 comment" => "1 댓글",
"Go back" => "돌아가기",
"Return to home page" => "홈페이지로 돌아가기",
"Type of contribution" => "기여의 유혇",
// "No contribution records found" => "No contribution records found",
// "{\$prefs.cookie_consent_description}" => "{\$prefs.cookie_consent_description}",
// "{\$prefs.cookie_consent_question}" => "{\$prefs.cookie_consent_question}",
// "{\$prefs.cookie_consent_button}" => "{\$prefs.cookie_consent_button}",
"Copyrights" => "저작권",
// "Authors" => "Authors",
"Copyright Holder" => "저작권 보유자",
// "Do you really want to remove the %0 route" => "Do you really want to remove the %0 route",
"Back to tracker list" => "트래커 목록으로 복귀",
"System error" => "시스템 오류",
"The following error message was returned" => "다음의 오류 메시지가 반환되었습니다",
"Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "데이터베이스가 현재 최신이 아닙니다!  <a href=\"tiki-install.php\">티키 설치프로그램</a> 을 방문하시어 이 문제를 해결하십시오",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "쉘 (SSH) 접근이 가능하다면, 다음 또한 사용이 가능합니다, 티키가 설치된 루트의 명령줄에서, ",
"The query was" => "질의는",
"The built query was likely" => "빌드된 질의는 다음과 같을 가능성이 큽니다",
"Stacktrace" => "스택트레이스",
"Tiki is unable to connect to the database" => "티키는 데이터베이스에 연결할 수 없습니다",
"An error occurred while performing the request" => "요청을 수행하는 동안 오류가 발생했습니다",
"Current URL" => "현재 URL",
"Command" => "명령어",
// "exec" => "exec",
"Type <code>help</code> to get list of available commands" => "사용가능한 명령어의 목록을 얻으려면  <code>help</code>를 시도해보십시오",
"Page generation debugging log" => "페이지 생성 디버깅 기록",
"Features state" => "기능 상태",
"features matched" => "기능 일치됨",
"Watchlist" => "주시목록",
// "Page discussion" => "Page discussion",
// "This page has been discussed once" => "This page has been discussed once",
// "Access discussion" => "Access discussion",
// "This page has been discussed %0 times" => "This page has been discussed %0 times",
// "Access discussion (%0 replies)" => "Access discussion (%0 replies)",
// "There are no discussions currently on this page" => "There are no discussions currently on this page",
// "Start discussion" => "Start discussion",
"Duplicate File Gallery" => "파일 갤러리 복제",
"Duplicate categories" => "범부 복제",
"Duplicate permissions" => "권한 복제",
"Duplicate" => "복제",
"There are individual permissions set for this file gallery" => "이 파일갤러리에는 개별 권한들이 설정되어 있습니다",
// "Manage Permissions" => "Manage Permissions",
"Properties" => "속성",
// "{\$gal_info.name}" => "{\$gal_info.name}",
"Required for podcasts" => "팟캐스트를 위한 필수항목",
"Other (%0)" => "기타 (%0)",
"Any file" => "임의 파일",
"Podcast (audio)" => "팟캐스트 (음성)",
"Podcast (video)" => "팟캐스트 (동영상)",
"Gallery is visible to non-admin users" => "갤러리가 관리자가 아닌 사용자에게 보입니다",
// "Gallery is unlocked" => "Gallery is unlocked",
// "Users with upload permission can add files to the gallery (not just the gallery owner)" => "Users with upload permission can add files to the gallery (not just the gallery owner)",
// "Respect permissions for backlinks to view a file" => "Respect permissions for backlinks to view a file",
"Files can be locked at download" => "파일이 다운로드 시 잠금상태로 전환가능",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
"unlimited" => "무제한",
"Parent gallery" => "부모 갤러리",
// "Owner of the gallery" => "Owner of the gallery",
// "Mb" => "Mb",
"Min" => "분",
"Group of users alerted when file gallery is modified" => "파일갤러리 변경 시 사용자 그룹에 알림",
"Allows each user to be selected for small groups" => "작은 그룹들의 각각의 사용자를 선택하는 것을 허용",
// "Maximum width of images in gallery" => "Maximum width of images in gallery",
"If an image is wider than this, it will be resized." => "만약 그림이 이것보다 넓을 경우, 크기가 조절됩니다.",
"Attention: In this case, the original image will be lost." => "주의: 이 경우, 그림 원본이 손실됩니다.",
// "Maximum height of images in gallery" => "Maximum height of images in gallery",
"If an image is higher than this, it will be resized." => "만약 그림이 이것보다 높으면, 사이즈가 조절됩니다.",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
"The default is " => "기본값은  ",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "항목 이름은 % 문자들로 에워쌓였을 때 변경됩니다. 예:  %fileId%, %name%, %filename%, %description%",
// "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs" => "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs",
// "Display Settings" => "Display Settings",
"Finder View" => "파인더 보기",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Max description display size" => "Max description display size",
// "Max rows per page" => "Max rows per page",
// "View inserted gallery after save" => "View inserted gallery after save",
"File error" => "파일 오류",
"Perhaps you are looking for" => "다음을 찾고 계신가요",
"There are no wiki pages similar to '{\$page|escape}'" => "'{\$page|escape}' 와 유사한 위키 페이지가 없습니다",
"Token Error" => "토큰 오류",
"Go to Log in Page" => "로그인 페이지로 가기",
"Create this page" => "이페이지 작성",
"(page will be orphaned)" => "(페이지가 고아페이지가 됩니다)",
"Close Window" => "윈도우 닫기",
// "Redirecting in %0 seconds" => "Redirecting in %0 seconds",
// "Permission successfully changed" => "Permission successfully changed",
// "Global permission" => "Global permission",
// "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)",
// "</em>\"}Object permission for the %0 %1" => "</em>\"}Object permission for the %0 %1",
// "Permissions successfully changed" => "Permissions successfully changed",
// "Global permissions" => "Global permissions",
// "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)",
// "</em>\"}Object permissions for the %0 %1" => "</em>\"}Object permissions for the %0 %1",
// "" => "",
// "No permissions were changed" => "No permissions were changed",
// "The following change has been applied" => "The following change has been applied",
// "The following changes have been applied" => "The following changes have been applied",
// "{\$item.mes[0]|stringfix}" => "{\$item.mes[0]|stringfix}",
"Preference name:" => "기본설정 이름",
"Upload" => "업로드",
"Open as WebFolder" => "웹폴더로 열기",
// "Delete gallery" => "Delete gallery",
"Edit: " => "편집:",
// "Display as PDF" => "Display as PDF",
"Download current version" => "현재 버전 다운로드",
// "Browser display" => "Browser display",
"Archives" => "보관물",
// "Upload new version" => "Upload new version",
// "Replace draft" => "Replace draft",
// "Upload draft" => "Upload draft",
// "Validate draft" => "Validate draft",
"Validate your draft" => "귀하의 초안을 확인하십시오",
// "Delete draft" => "Delete draft",
"Delete your draft" => "초안 삭제",
// "Edit properties" => "Edit properties",
// "Refresh metadata" => "Refresh metadata",
// "Page view" => "Page view",
// "File already locked by %0" => "File already locked by %0",
// "Lock file" => "Lock file",
"Download and lock" => "다운로드 및 잠그기",
"Open your draft in WebDAV" => "초안을 WebDAV 내에서 열기",
"Open in WebDAV" => "WebDAV 내에서 열기",
"Share a link to this file" => "이 파일로의 링크 공유",
"Email a link to this file" => "이 파일로 링크 이메일 보내기",
"Click here to use the file" => "위키 문법을 삽입하려면 여기를 클릭",
"The checkbox is disabled because this preference is disabled globally." => "이 기본설정이 전역적으로 비활성화 되어있으므로 체크상자가 비활성화 상태가 됨.",
"Please enable the preference globally first." => "먼저 전역 기본설정을 활성화 부탁 드립니다.",
// "Site administrators can enable the preference" => "Site administrators can enable the preference",
"Show an icon in a column" => "열에서 아이콘 보임",
// "Search.." => "Search..",
// "Select files" => "Select files",
// "Too many files selected. De-select some files before adding more" => "Too many files selected. De-select some files before adding more",
// "Current Selection" => "Current Selection",
"Click to remove" => "삭제하려면 클릭",
"Upload Files" => "파일 업로드",
// "Drop files or " => "Drop files or ",
// "Choose files" => "Choose files",
// "Automatic upload" => "Automatic upload",
// "Last modification: %0" => "Last modification: %0",
// "No files found" => "No files found",
"Upload from URL" => "URL에서 업로드",
"File added" => "파일 추가됨",
// "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} " => "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} ",
// "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section" => "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section",
"Upload File" => "파일 업로드",
// "Or drop files here from your file manager" => "Or drop files here from your file manager",
// "Or drop file here from your file manager" => "Or drop file here from your file manager",
// "Export PDF" => "Export PDF",
"Start the Slideshow" => "슬라이드쇼 시작",
"Pause the Slideshow" => "슬라이드쇼 잠시 멈춤",
"There are no images to display" => "표시할 그림이 없습니다",
// "Select Files (%0)" => "Select Files (%0)",
"Sort By" => "다음으로 정렬",
"Sort direction" => "정렬 방향",
"Any" => "아무거나",
"Lookup" => "조회",
"Deep search" => "Deep 검색",
"Select Tags" => "태그 선택",
"Include objects without a specified language" => "지정된 언어가 없는 개체 포함",
// "View Saved Searches" => "View Saved Searches",
"Add to filter" => "필터에 추가",
// "{\$whatlabel}" => "{\$whatlabel}",
"Clear Filter" => "필터 제거",
"any type" => "아무 유형이나",
"Article Topic" => "기사 토픽",
"any topic" => "임의 토픽",
"any language" => "아무 언어나",
"not in" => "다음에 없음",
// "Date From" => "Date From",
// "Date To" => "Date To",
"any category" => "모든 범주",
"Multiple select" => "다항 선택",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
"Orphans" => "고아",
// "{\$find_other}" => "{\$find_other}",
// "Displayed rows" => "Displayed rows",
// "Hide Map" => "Hide Map",
// "Show Map" => "Show Map",
"Module errors" => "모듈 오류",
"The following modules could not be loaded" => "다음 모듈은 로드될 수 없었습니다",
"Change" => "변경",
// "Show PHP error messages" => "Show PHP error messages",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes." => "태그를 스페이스로 구분하여 기입하십시오. 한 단어가 넘는 태그는, 스페이스를 사이에 두지않거나, 따옴표로 둘러싸십시오",
"Untag" => "태그 해제",
// "Goal" => "Goal",
// "Eligible Groups" => "Eligible Groups",
// "No eligible groups" => "No eligible groups",
// "No goals configured yet" => "No goals configured yet",
// "Goal Administration" => "Goal Administration",
// "%0 was removed" => "%0 was removed",
// "Are you sure you want to delete %0" => "Are you sure you want to delete %0",
// "View Goal" => "View Goal",
// "Eligibility" => "Eligibility",
// "Goal Attribution" => "Goal Attribution",
// "Individual Goal" => "Individual Goal",
// "Group Goal" => "Group Goal",
// "Range Type" => "Range Type",
// "Rolling" => "Rolling",
// "Fixed" => "Fixed",
// "Time span" => "Time span",
// "In days" => "In days",
// "YYYY-MM-DD HH:MM:SS" => "YYYY-MM-DD HH:MM:SS",
// "Rewards are given to individuals achieving the goal or group members for group goals" => "Rewards are given to individuals achieving the goal or group members for group goals",
// "Changes will not be saved" => "Changes will not be saved",
// "Your changes to conditions are not saved until you save the goal" => "Your changes to conditions are not saved until you save the goal",
"Operator" => "운영자",
"At Least" => "최소",
"At Most" => "최대",
// "Metric" => "Metric",
// "Event Type" => "Event Type",
// "Badge" => "Badge",
// "Hide condition from users" => "Hide condition from users",
// "Members of" => "Members of",
// "Your changes to rewards are not saved until you save the goal" => "Your changes to rewards are not saved until you save the goal",
// "Credit Type" => "Credit Type",
// "Credit Quantity" => "Credit Quantity",
// "Hide reward from users" => "Hide reward from users",
// "No conditions yet" => "No conditions yet",
// "Add Condition" => "Add Condition",
// "No rewards yet" => "No rewards yet",
// "Add Reward" => "Add Reward",
// "Modify Eligibility" => "Modify Eligibility",
// "No groups are eligible to this goal" => "No groups are eligible to this goal",
// "Major Version" => "Major Version",
// "Minor Version" => "Minor Version",
// "Tutorial URL" => "Tutorial URL",
// "Restricted" => "Restricted",
// "Return to list" => "Return to list",
"Images Galleries" => "그림 갤러리",
"Edit this page" => "이 페이지 편집",
"RSS Wiki" => "RSS 위키",
"RSS Blogs" => "RSS 블로그",
"RSS Articles" => "RSS 기사",
"RSS Image Galleries" => "RSS 이미지 갤러리",
"RSS File Galleries" => "RSS 파일 갤러리",
"RSS Forums" => "RSS 게시판",
"RSS Directories" => "RSS 디렉터리",
"RSS Calendars" => "RSS 달력",
"RSS Tracker" => "RSS 트래커",
// "Use Selected Icon" => "Use Selected Icon",
// "Do you really want to remove the custom IDS rule with Id %0" => "Do you really want to remove the custom IDS rule with Id %0",
// "Back to IDS Rules list" => "Back to IDS Rules list",
// "Toggle interactive translation" => "Toggle interactive translation",
"Once checked, click on any string to translate it." => "체크를 한 후, 번역할 문자열을 클릭 하십시오.",
// "Turn off interactive translation" => "Turn off interactive translation",
"Interactive Translation" => "대화형 번역",
"Translation" => "번역",
"Couldn't find any translatable string." => "번역가능한 문자열을 찾지 못하였습니다",
"Save translations" => "번역 저장",
"Changes will be applied on next page load only." => "변경내역은 페이지의 다음 번 로드 시에만 적용될 것입니다.",
"Upload Successful" => "업로드 성공",
// "custom.php" => "custom.php",
// "Download custom.php file for the selected language" => "Download custom.php file for the selected language",
// "custom.json" => "custom.json",
// "Download custom.json file for the selected language" => "Download custom.json file for the selected language",
// "Custom translation file does not exist. Save a custom translation to create the file" => "Custom translation file does not exist. Save a custom translation to create the file",
"Translations" => "번역",
// "Translation text" => "Translation text",
// "Add a new row" => "Add a new row",
// "Add row" => "Add row",
// "Customized String Translations" => "Customized String Translations",
// "Manage custom translations" => "Manage custom translations",
// "Process Type" => "Process Type",
// "Select how the uploaded translations should be processed" => "Select how the uploaded translations should be processed",
"Note:" => "주의:",
// "No translations in the database available to export" => "No translations in the database available to export",
// "Translations in the database" => "Translations in the database",
// "Merge all translations, whether or not they are marked as general (for contribution)" => "Merge all translations, whether or not they are marked as general (for contribution)",
// "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database" => "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database",
"To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory." => "번역을 language.php에 쓰려면, lang/ 디렉터리 내부에 웹서버가 쓰기 원한을 보유하고 있다는 것을 확인하십시오..",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Toggle right modules" => "Toggle right modules",
// "Toggle left modules" => "Toggle left modules",
"Toggle module contents" => "모듈 컨텐츠 토글",
"Toggle" => "토글",
// "Move up" => "Move up",
// "Move down" => "Move down",
// "Move to opposite side" => "Move to opposite side",
// "{\$count_label}" => "{\$count_label}",
"Show Tree" => "트리 표시",
"Hide Tree" => "트리 숨김",
// "Select action to perform with checked.." => "Select action to perform with checked..",
"Assign permissions to file galleries" => "파일 갤러리로 권한 할당",
// "Delete selected items" => "Delete selected items",
// "Download zip version" => "Download zip version",
// "Reset to default list view settings" => "Reset to default list view settings",
// "Move selected file or gallery" => "Move selected file or gallery",
"Move to" => "다음으로 이동",
// "Assign file gallery permissions to groups" => "Assign file gallery permissions to groups",
"No Additional Sort" => "추가 정렬 없음",
"Other Sorts" => "다른 정렬",
// "Locked by-" => "Locked by-",
"No information" => "정보 없음",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
// "The leader of " => "The leader of ",
// "has added you. To visit it, logon and go to the home page " => "has added you. To visit it, logon and go to the home page ",
// "You have been added" => "You have been added",
// "This is to inform you that your request to join" => "This is to inform you that your request to join",
// " has been accepted" => " has been accepted",
// "To visit it, go to the home page" => "To visit it, go to the home page",
// "Leader approved your request" => "Leader approved your request",
// "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the" => "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the",
// "Leader rejected your request" => "Leader rejected your request",
// "This is to inform you that you have been removed from " => "This is to inform you that you have been removed from ",
// " If you did not request this removal, or have any questions or concerns, please contact" => " If you did not request this removal, or have any questions or concerns, please contact",
// "You have been removed from it" => "You have been removed from it",
// "Upgrade Available" => "Upgrade Available",
// "Upgrades Available" => "Upgrades Available",
// "{\$subject}" => "{\$subject}",
// "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link" => "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link",
"Blog post:" => "블로그 포스트:",
"Gift Certificate Information" => "선물 상품권 정보",
"Name:" => "이름:",
"Description:" => "설명:",
"Percentage Discount" => "할인 백분율",
"Value of Gift Certificate" => "상품권의 가치",
"Redeem Code" => "코드 사용",
// "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase" => "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase",
// "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made" => "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made",
"You can review your order at" => "주문을 다음에서 검토 할 수 있습니다",
// "Your {\$prefs.mail_template_custom_text}cart order" => "Your {\$prefs.mail_template_custom_text}cart order",
// "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site" => "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site",
"To the newsletter" => "회보로",
// "Please access the following URL to confirm your subscription" => "Please access the following URL to confirm your subscription",
// "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link" => "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link",
"The administrator approved your account" => "관리자가 귀하의 계정을 승인하였습니다",
// "Confirm your {\$prefs.mail_template_custom_text}email at %s" => "Confirm your {\$prefs.mail_template_custom_text}email at %s",
// "Remove {\$prefs.mail_template_custom_text}file" => "Remove {\$prefs.mail_template_custom_text}file",
"GalleryId" => "갤러리Id",
"Identifier" => "식별자",
// "{\$prefs.mail_template_custom_text}File Gallery quota exceeded" => "{\$prefs.mail_template_custom_text}File Gallery quota exceeded",
"File gallery:" => "파일 갤러리:",
// "A new message was posted to {\$prefs.mail_template_custom_text}forum" => "A new message was posted to {\$prefs.mail_template_custom_text}forum",
"New topic" => "새 토픽",
// "An anonymous {\$prefs.mail_template_custom_text}user" => "An anonymous {\$prefs.mail_template_custom_text}user",
"An anonymous user" => "익명사용자",
// "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL",
// "Note that this is an edited post" => "Note that this is an edited post",
// "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL" => "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL",
// "To instantly approve this post without logging in, use the following URL" => "To instantly approve this post without logging in, use the following URL",
// "You have been invited to access %0 by %1" => "You have been invited to access %0 by %1",
// "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0" => "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0",
// "Your access is valid until %0" => "Your access is valid until %0",
// "Your {\$prefs.mail_template_custom_text}temporary access to %0" => "Your {\$prefs.mail_template_custom_text}temporary access to %0",
"You are invited by" => "다음 분이 초대하셨습니다",
"You join this group" => "이 그룹에 참여합니다",
"Join me on %s" => "%s 에 자신을 참여",
"Tiki mail-in auto-reply" => "티키 메일인 자동응답",
// "{\$prefs.mail_template_custom_text}page not found" => "{\$prefs.mail_template_custom_text}page not found",
// "%0 mentioned you in %1" => "%0 mentioned you in %1",
// "You've been mentioned on %0" => "You've been mentioned on %0",
// "A new {\$prefs.mail_template_custom_text}message was posted to you" => "A new {\$prefs.mail_template_custom_text}message was posted to you",
// "Click here to read the full message and / or reply" => "Click here to read the full message and / or reply",
// "New {\$prefs.mail_template_custom_text}message arrived from %s" => "New {\$prefs.mail_template_custom_text}message arrived from %s",
"Hi" => "안녕하십니까",
// "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now",
"To login with your username and password, please follow this link" => "사용자명과 비밀번호로 로그인하려면, 다음 링크를 따라가십시오",
"Enjoy the site" => "이 사이트를 즐겨주십시오",
"User Account Activated" => "사용자 계정 활성화 됨",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first",
"has requested an account on" => "님이 다음에서 계정을 요청하였습니다",
"User Tracker" => "사용자 트래커",
// "To validate that {\$prefs.mail_template_custom_text}account, please follow the link" => "To validate that {\$prefs.mail_template_custom_text}account, please follow the link",
"Assign to a group" => "그룹으로 할당",
"View user's data" => "사용자의 데이터 보기",
"Best regards" => "감사합니다",
"User Registration Request" => "사용자 등록 요청",
// "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request" => "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request",
// "You're invited to join my {\$prefs.mail_template_custom_text}network of friends" => "You're invited to join my {\$prefs.mail_template_custom_text}network of friends",
"The user" => "사용자",
// "registered at your {\$prefs.mail_template_custom_text}site" => "registered at your {\$prefs.mail_template_custom_text}site",
// "New {\$prefs.mail_template_custom_text}user registration" => "New {\$prefs.mail_template_custom_text}user registration",
// "Start of article" => "Start of article",
"Published" => "게재됨",
"By:" => "작성자:",
"Bye bye" => "안녕 인사",
// "This email address has been removed from the list of subscribers of: " => "This email address has been removed from the list of subscribers of: ",
"Bye bye from %s at %s" => "%s 에서 %s 에 안녕 인사",
// "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link" => "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link",
"Welcome to our newsletter" => "저희 회보에서 환영합니다",
// "This email address has been added to the list of subscribers of: " => "This email address has been added to the list of subscribers of: ",
"You can always cancel your subscription using" => "다음을 사용하여 언제든지 귀하의 구독을 취소할 수 있습니다",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Reply Notification: " => "Reply Notification: ",
// "{\$prefs.mail_template_custom_text}Email Notification" => "{\$prefs.mail_template_custom_text}Email Notification",
// "Someone requested a password reset for your %0account" => "Someone requested a password reset for your %0account",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "비밀번호를 재설정을 원하는 지 여부를 확인하기 위하여 다음 링크를 클릭하십시오 그리고 새 \"영구적\" 비밀번호를 입력해야만 하는 화면으로 가십시오. 귀하께서만이 알고 있을 비밀번호를 선택하시고 다른 사람과 공유하지 마십시오",
"Important: Username & password are CaSe SenSitiVe" => "중요: 사용자명 & 암호는 대소문자를 구분합니다",
"Important: The old password remains active if you don't click the link above" => "중요: 과거 암호는 위의 링크를 클릭하지 않으면 활성화 상태로 남게됩니다",
"Your account information for %s" => "%s 에 대한 계정 정보",
"}Plugin %0 is pending approval on %1" => "} %0 플러그인이 %1 에서 승인 대기 중입니다",
// "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>",
"Plugin arguments" => "플러그인 인수",
// "Report on %0 for %1" => "Report on %0 for %1",
// "Last {\$prefs.mail_template_custom_text}Report sent on %0" => "Last {\$prefs.mail_template_custom_text}Report sent on %0",
"Changes in detail" => "상세한 변경내역",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "귀하는 정기적 다이제스트로 그룹화된 알림 이메일을 수신 중입니다. 그대신 게시되었을 때 개별적으로 수신하려면, %0 에서 기본설정을 변경하십시오",
// "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at" => "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at",
"Feed" => "피드",
// "New categories" => "New categories",
// "Configure settings for the new category at" => "Configure settings for the new category at",
// "New {\$prefs.mail_template_custom_text}source category in RSS feed" => "New {\$prefs.mail_template_custom_text}source category in RSS feed",
// "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes",
"Details" => "상세",
"Site" => "사이트",
// "[%0] Scheduler \"%1\" was healed" => "[%0] Scheduler \"%1\" was healed",
// "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes",
// "[%0] Scheduler \"%1\" is stalled" => "[%0] Scheduler \"%1\" is stalled",
// "Look at this {\$prefs.mail_template_custom_text}link" => "Look at this {\$prefs.mail_template_custom_text}link",
// "A friend sends you a {\$prefs.mail_template_custom_text}link from: " => "A friend sends you a {\$prefs.mail_template_custom_text}link from: ",
// "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link" => "이 링크를 따라 제출을 편집할 수 있습니다",
"Heading:" => "제목:",
"Body" => "본문",
// "New {\$prefs.mail_template_custom_text}article submitted at %s" => "New {\$prefs.mail_template_custom_text}article submitted at %s",
// "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}" => "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}",
// "{\$mail_user|username}" => "{\$mail_user|username}",
// "{\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "{\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}",
// "View the {\$prefs.mail_template_custom_text}tracker item at" => "View the {\$prefs.mail_template_custom_text}tracker item at",
// "The last content before deletion was as follows" => "The last content before deletion was as follows",
"Download the file at" => "파일을 다음에서 다운로드",
// "{\$mail_trackerName}" => "{\$mail_trackerName}",
"item" => "항목",
// "was deleted at" => "was deleted at",
"was modified at" => "의 수정 날짜 ",
// "Please visit this {\$prefs.mail_template_custom_text}link before logging in again" => "Please visit this {\$prefs.mail_template_custom_text}link before logging in again",
"Last attempt" => "마지막 시도",
// "Confirm your {\$prefs.mail_template_custom_text}account at %s" => "Confirm your {\$prefs.mail_template_custom_text}account at %s",
// "{\$prefs.mail_template_custom_text}Site" => "{\$prefs.mail_template_custom_text}Site",
// "{\$prefs.mail_template_custom_text}Account suspended" => "{\$prefs.mail_template_custom_text}Account suspended",
// "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user" => "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "이 사이트의 멤버십을 확인하기를 원하는 경우, 처음으로 로그인하기 위하여 다음 링크를 클릭하십시오",
"Welcome to the site" => "사이트에 오신 것을 환영합니다",
"Your personal access to" => "다음으로의 귀하의 개인적 접근:",
// "joined" => "joined",
// "User joined" => "User joined",
// "You are getting this email because you are a leader of" => "You are getting this email because you are a leader of",
// "Click here to manage members" => "Click here to manage members",
// "You are getting this email because you are a leader" => "You are getting this email because you are a leader",
// "The user needs to be approved before he is admitted" => "The user needs to be approved before he is admitted",
// "user joined" => "user joined",
// "You are getting this email because you are a group leader" => "You are getting this email because you are a group leader",
// "left" => "left",
// "user left" => "user left",
"You or someone registered this email address at" => "귀하 혹은 타인이 이 이메일 주소를 등록했습니다",
// "If you want to be a registered user in this %0site you will have to use the following link to login for the first time" => "If you want to be a registered user in this %0site you will have to use the following link to login for the first time",
// "Your {\$prefs.mail_template_custom_text}registration confirmation" => "Your {\$prefs.mail_template_custom_text}registration confirmation",
"You will receive an email with the information needed to log into this site the first time" => "이 사이트에 처음 로그인 하는데 필요한 정보가 담긴 이메일을 받으실 것입니다",
"Your account request has been stored and will be activated by the admin as soon as possible" => "계정 요청이 저장되었고 관리자에 의하여 활성화 될 것입니다",
"You'll receive email notification once your account is activated" => "계정이 활성화되면 이메일 알림을 받으실 것입니다",
"Please do not attempt to login until you receive the email notification" => "이메일 알림을 수신하실 때까지 로그인을 시도하지 말아주십시오",
// "New {\$prefs.mail_template_custom_text}article post" => "New {\$prefs.mail_template_custom_text}article post",
// "Edit {\$prefs.mail_template_custom_text}article post" => "Edit {\$prefs.mail_template_custom_text}article post",
// "Delete {\$prefs.mail_template_custom_text}article post" => "Delete {\$prefs.mail_template_custom_text}article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
"View the article at" => "기사를 다음에서 보기",
"Expiration Date" => "만기 일자",
"If you don't want to receive these notifications follow this link" => "이러한 알림을 수신하지 않기를 원하는 경우, 이 링크를 따라 가십시오",
"The old article follows" => "구 기사 follows",
// "New {\$prefs.mail_template_custom_text}article post at" => "New {\$prefs.mail_template_custom_text}article post at",
// "Edited {\$prefs.mail_template_custom_text}article post at" => "Edited {\$prefs.mail_template_custom_text}article post at",
// "Deleted {\$prefs.mail_template_custom_text}article post at" => "Deleted {\$prefs.mail_template_custom_text}article post at",
// "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at" => "블로그를 다음에서 보기",
// "New {\$prefs.mail_template_custom_text}blog post at %s" => "New {\$prefs.mail_template_custom_text}blog post at %s",
"View item calendar at" => "항목 달력을 다음에서 보기",
// "Modified {\$prefs.mail_template_custom_text}calendar item" => "Modified {\$prefs.mail_template_custom_text}calendar item",
// "New {\$prefs.mail_template_custom_text}calendar item" => "New {\$prefs.mail_template_custom_text}calendar item",
"changed" => "변경됨",
// "A new {\$prefs.mail_template_custom_text}category was created in" => "A new {\$prefs.mail_template_custom_text}category was created in",
"Created by" => "만든이",
"Path:" => "경로:",
"created" => "만듬",
// "A {\$prefs.mail_template_custom_text}category was removed in" => "A {\$prefs.mail_template_custom_text}category was removed in",
"Removed by" => "제거하신 분",
"removed" => "제거됨",
// "A {\$prefs.mail_template_custom_text}category was updated" => "A {\$prefs.mail_template_custom_text}category was updated",
"Updated by" => "갱신하신 분",
"Old" => "기존",
"updated" => "갱신됨",
// "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by",
"an anonymous user" => "익명사용자",
// "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by",
"You can view the comment by following this link" => "이 링크를 따라가서 댓글을 볼 수 있습니다",
"File Gallery %s changed" => "파일 갤러리 %s 가 변경됨",
// "A file was removed from the {\$prefs.mail_template_custom_text}file gallery" => "A file was removed from the {\$prefs.mail_template_custom_text}file gallery",
// "A new file was posted to {\$prefs.mail_template_custom_text}file gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}file gallery",
"File Description" => "파일 설명",
// "You can download the new file at" => "You can download the new file at",
// "The new file ID is %0 and it is in gallery ID %1" => "The new file ID is %0 and it is in gallery ID %1",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "그림 갤러리 {\$galleryName} 변경됨",
// "A new file was posted to {\$prefs.mail_template_custom_text}image gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}image gallery",
// "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link" => "이 링크를 따라가서 갱신된 지도를 볼 수 있습니다",
"You can edit the map following this link" => "이 링크를 따라 지도를 편집할 수 있습니다",
// "An object was added to {\$prefs.mail_template_custom_text}category" => "An object was added to {\$prefs.mail_template_custom_text}category",
"Added by" => "추가하신 분",
// "An object was removed from {\$prefs.mail_template_custom_text}category" => "An object was removed from {\$prefs.mail_template_custom_text}category",
// "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure" => "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure",
"Structure modified" => "구조체 수정됨",
// "has consulted your" => "has consulted your",
"Go to the File Gallery" => "파일 갤러리로 가기",
"Download the file" => "파일 다운로드",
// "A new file has been attached to {\$prefs.mail_template_custom_text}page" => "A new file has been attached to {\$prefs.mail_template_custom_text}page",
"File name" => "파일명",
"Type:" => "종류:",
// "New {\$prefs.mail_template_custom_text}attachment on %s, page" => "New {\$prefs.mail_template_custom_text}attachment on %s, page",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here" => "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here",
"You can view the page by following this link" => "이 링크를 따라가서 페이지를 볼 수 있습니다",
"You can view a diff back to the previous version by following this link" => "이 링크를 따라가서 이전 버전으로 차이점을 볼 수 있습니다",
"The changes in this version follow below, followed after by the current full page text" => "이 버전 내부의 변경이 아래에 따라옵니다, 그 뒤에 현재 페이지 텍스트 전체가 따라옵니다",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} 은 +Lines: {\$newd} 으로 변경됨",
"The old page content follows below" => "과거 페이지 내용은 아래에 나옵니다",
"The new page content follows below" => "새 페이지 컨텐츠는 아래에서 따라옵니다",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}",
"Wiki page renamed" => "위키 페이지 이름변경됨",
"Old name" => "기존 이름",
"New name:" => "새 이름:",
// "Your %0account ID" => "Your %0account ID",
// "has been generated" => "has been generated",
// "Thank you for your %0registration" => "Thank you for your %0registration",
"You may log in now" => "이제 로그인할 수 있습니다",
// "Operation Completed" => "Operation Completed",
// "Return to Query List" => "Return to Query List",
// "Do you really want to remove the %0 account" => "Do you really want to remove the %0 account",
// "Delete Account" => "Delete Account",
"Active" => "활성",
"Account name" => "계정이름",
// "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND" => "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND",
// "Reply handler requires notifications to be enabled and the reply email pattern to be configured" => "Reply handler requires notifications to be enabled and the reply email pattern to be configured",
"POP server" => "POP 서버",
// "POP" => "POP",
// "IMAP" => "IMAP",
"Admin Topics" => "토픽 관리",
"Admin Types" => "종류 관리",
"Allow anonymous access" => "익명사용자 접근 허용",
// "Warning: Enabling anonymous access will disable all permission checking for mailed-in content" => "Warning: Enabling anonymous access will disable all permission checking for mailed-in content",
// "Allow admin access" => "Allow admin access",
// "Administrators have full access to the system. Disabling admin mail-in is the safest option" => "Administrators have full access to the system. Disabling admin mail-in is the safest option",
"Allow attachments" => "첨부파일 허용",
// "Allow routing" => "Allow routing",
// "Allow per user routing of incoming email to structures" => "Allow per user routing of incoming email to structures",
// "Show inline images" => "Show inline images",
// "For HTML email, attempt to create a WYSIWYG wiki-page" => "For HTML email, attempt to create a WYSIWYG wiki-page",
// "Keep HTML format" => "Keep HTML format",
// "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection" => "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection",
"Discard to the end from" => "내용물 중 다음부터 끝까지는 무시",
// "Auto-assign category" => "Auto-assign category",
// "Only affects wiki-put, when creating a new wiki page" => "Only affects wiki-put, when creating a new wiki page",
// "Auto-assign namespace" => "Auto-assign namespace",
// "Email response when no access" => "Email response when no access",
// "Leave email on server on error" => "Leave email on server on error",
// "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki" => "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki",
// "Add Account" => "Add Account",
// "Operation not reversible" => "Operation not reversible",
// "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used" => "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used",
"Event" => "이벤트",
// "Disable rule" => "Disable rule",
// "Enable rule" => "Enable rule",
// "Unknown status" => "Unknown status",
// "Current Type" => "Current Type",
// "New Type" => "New Type",
// "The rule has been removed" => "The rule has been removed",
// "Are you sure you want to delete this rule" => "Are you sure you want to delete this rule",
// "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it" => "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it",
// "Sample Rule" => "Sample Rule",
// "Basic Rule (Record Event)" => "Basic Rule (Record Event)",
// "Tracker Rule" => "Tracker Rule",
// "Advanced Rule" => "Advanced Rule",
// "Community Control Panel" => "Community Control Panel",
// "Event Chain Diagram" => "Event Chain Diagram",
// "Rule Type" => "Rule Type",
// "Allow Notifications" => "Allow Notifications",
// "Recipient" => "Recipient",
// "Cached sample data helps to view available variables for event types" => "Cached sample data helps to view available variables for event types",
// "Sample available" => "Sample available",
// "Sample currently not available" => "Sample currently not available",
// "Source Event" => "Source Event",
// "Target Event" => "Target Event",
// "All event names are required to have at least 3 components" => "All event names are required to have at least 3 components",
// "%0 Copy" => "%0 Copy",
// "Clone of Menu Id" => "Clone of Menu Id",
// "Symbol Information" => "Symbol Information",
// "Profile Source" => "Profile Source",
"Clone" => "복제",
"dynamic collapsed" => "동적 펼쳐짐",
"dynamic extended" => "동적 확장됨",
"fixed" => "고정됨",
"Labels of all options will be wiki parsed" => "모든 선택사항의 레이블이 위키 구문분석될 것입니다",
"Folder Icon" => "폴더 아이콘",
"Path and filename of closed folder icon" => "닫힌 폴더 아이콘의 경로와 파일명",
"Configure icons for menu entries" => "메뉴 항목들에 대한 아이콘 구성",
"For wiki page, use ((PageName))" => "위키 페이지에 대하여 ((PageName)) 을 사용합니다",
"Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "2 그룹을 선택하는 것은 사용자가 2 그룹에 속한 경우 선택사항이 표시될 것이라는 것을 의미합니다. 2 그룹이 선택사항을 보기를 원하는 경우, 한 그룹 각각에 2 개의 선택사항을 만드십시오",
"If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "URL이 ((PageName)) 인 경우, 그룹을 적을 필요가 없습니다, 선택사항은 페이지가 표시될 수 있을 경우에만 표시될 것입니다",
"Sections" => "구역",
"Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "여러 개의 기능/선호설정을 AND 조건에 대하여서는 쉼표 ( , ) 를, OR 조건에 대하여서는 수직 막대기 ( | ) 로 분리하십시오",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "여러 개의 권한을 AND 조건에 대하여서는 쉼표 ( , ) 를, OR 조건에 대하여서는 수직 막대기 ( | ) 로 분리하십시오",
// "Input an HTML class value for the menu option. Separate with a space for multiple classes" => "Input an HTML class value for the menu option. Separate with a space for multiple classes",
"Tips" => "팁",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "메뉴 세트에 새 선택사항을 추가하려면 선택사항ID를 0으로 설정하십시오. 선택사항을 삭제하려면 삭제 필드를 'y'로 설정하십시오",
// "Duplicate options will be ignored" => "Duplicate options will be ignored",
"Show Quick URLs" => "퀵 URL 표시",
"Some useful URLs" => "몇몇 유용한 URL들",
"Hide Quick URLs" => "빠른 URL 숨김",
"Home" => "홈",
"Choose" => "선택",
"Home Page" => "홈페이지",
"Home Blog" => "홈 블로그",
"Home Image Gal" => "홈 그림 갤",
"Home Image Gallery" => "홈 그림 갤러리",
"Home File Gal" => "홍 파일 갤",
"Home File Gallery" => "홈 파일 갤러리",
"User preferences" => "사용자 기본설정",
"User prefs" => "사용자 기본설정",
"Wiki:" => "위키:",
"Wiki Home" => "위키 홈",
"List galleries" => "갤러리 나열",
"List image galleries" => "그림 갤러리 나열",
"Upload image" => "그림 업로드",
"Gallery Rankings" => "갤러리 순위",
"Browse a gallery" => "갤러리 탐색",
"Articles home" => "기사 홈",
"All articles" => "모든 기사",
"List Blogs" => "블로그 목록",
"Create Blog" => "블로그 만들기",
"View a forum" => "게시판 보기",
"View a thread" => "대화목록 보기",
"View a FAQ" => "FAQ 보기",
"Take a quiz" => "퀴즈 풀기",
"Quiz stats" => "퀴즈 통계",
"Stats for a Quiz" => "퀴즈에 대한 통계",
"Message Archive" => "메시지 보관",
"Archive is full" => "보관이 가득 차 있습니다",
"Unread" => "읽지않음",
"Flagged" => "플래그 지정됨",
"Unflagged" => "플래그 지정 해지 됨",
"Containing" => "포함",
"Sender" => "보낸이",
"No messages to display" => "표시할 메시지 없음",
"Broadcast message" => "메시지 전파",
"All users" => "모든 사용자",
"Lowest" => "최저",
"Very High" => "매우 높음",
"Send" => "보내기",
"Compose message" => "메시지 작성",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "사람들이 귀하에게 답글을 올릴 수 있게되기를 원하는 경우, 기본설정에서 <a href='tiki-user_preferences.php'>다른 사용자로부터 메시지 허용</a> 을 활성화하십시오",
// "To: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "To: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"CC" => "참조",
// "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"BCC" => "숨은참조",
// "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"Reply-to my email" => "내 이메일로 답변주십시오",
"The user will be able to reply to you directly via email" => "사용자가 귀하께 이메일로 직접 회신할 수 있을 것입니다",
"Send me a copy" => "본인에게 사본 전송",
"You will be sent a copy of this email" => "이 이메일의 사본이 귀하께 발송될 것입니다",
"No messages to download" => "다운로드할 메시지 없음",
// "full" => "full",
"Mailbox is full! Delete or archive some messages if you want to receive more messages" => "메일상자가 가득 차 있습니다. 추가 메시지를 받고 싶은 경우, 메시지 일부를 삭제하거나 보관하십시오",
"is reply to" => "은 다음에 대한 응답입니다",
"Find replied message" => "댓글이 달린 메시지 찾기",
"Perform action with checked:" => "체크된 항목에 수행할 명령:",
"Mark as read" => "읽음으로 표시",
"Mark as unread" => "읽지않음으로 표시",
"Mark as flagged" => "플래그 지정됨으로 표시",
"Mark as unflagged" => "플래그 지정 해지로 표시",
"Mark" => "표식",
"Mailbox" => "메일상자",
"Compose" => "메시지작성",
"Broadcast" => "전파",
"Auto-archive age for read messages" => "읽은 메시지에 대하여 자동 보관 기간",
"Read message" => "메시지 읽기",
// "Flagged:Click to unflag" => "Flagged:Click to unflag",
// "Not flagged:Click to flag" => "Not flagged:Click to flag",
"replyall" => "모든 이에게 답신",
// "Reply All" => "Reply All",
"Cc" => "참조",
// "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>",
// "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>",
"Sent Messages" => "전송된 메시지",
"Replied" => "응답됨",
"Not replied" => "답변되지 않음",
// "Move to archive" => "Move to archive",
"Image Metadata for" => "다음에 대한 그림 메타데이터",
"<em>Note: only basic metadata processed for this file type</em>" => "<em>주의: 이 파일 유형에 대하여 기본 메타데이터 만 처리됨</em>",
// "{\$subtypes@key|escape}" => "{\$subtypes@key|escape}",
// "{\$fields@key|lower|capitalize|escape}" => "{\$fields@key|lower|capitalize|escape}",
// "{\$fieldarray.label|escape}" => "{\$fieldarray.label|escape}",
// "{\$fieldarray@key|escape}" => "{\$fieldarray@key|escape}",
// "{\$fieldarray.suffix|escape}" => "{\$fieldarray.suffix|escape}",
"No metadata found" => "발견된 메타데이터 없음",
"Read-only metadata extracted from the file" => "파일에서 추출된 읽기-전용 메타데이터",
"<em>Only basic metadata processed for this file type.</em>" => "<em>이 파일 유형에 대하여 기본 메타데이터 만 처리됨</em>",
// "Control panels" => "Control panels",
// "Turn on interactive translation" => "Turn on interactive translation",
// "Comment moderation" => "Comment moderation",
// "Clear all caches" => "Clear all caches",
// "Plugin approval" => "Plugin approval",
"Logs" => "로그",
// "Smarty debug window" => "Smarty debug window",
"Display type unknown, you have to enter the banner type" => "표기 유형 알 수 없음, 배너 유형을 입력해야만 합니다",
"You forgot your Google ad_client number " => "구글 광고_클라이언트_숫자 를 누락하셨습니다",
"Thank you for installing Tiki" => "티키를 설치해 주셔서 고맙습니다",
"To configure your Tiki" => "귀하의 티키를 구성하려면",
"from the menu" => "메뉴에서",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "<a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">구성 설명서</a>를 읽어보십시오",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "<a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">데모 동영상 보기",
"To remove this module" => "이 모듈을 삭제하려면",
"Admin Modules" => "모듈관리",
"and remove the assistant module" => "그리고 보조 모듈을 삭제",
"You can also add other modules" => "다른 모듈을 추가할 수도 있습니다",
"To customize the menu" => "메뉴를 사용자 지정하려면",
"Admin Menus" => "메뉴 관리",
"and edit menu ID 42" => "그리고 메뉴 ID 42를 편집",
"Or, create your own menu and add it to a module" => "혹은, 자신만의 메뉴를 만들고 모듈에 추가합니다",
"To begin configuring Tiki, please" => "티키 구성을 시작하려면,",
"login" => "로그인",
"as admin" => "관리자로써",
"The Tiki Community" => "티키 커뮤니티",
"To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "더 알고 싶으시면, 다음을 방문하여 주십시오: : <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
"Tiki Documentation" => "티키 문서",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "도움이 필요하시면 <a href=\"http://doc.tiki.org\" title=\"티키 설명서\" target=\"_blank\">http://doc.tiki.org</a> 를 방문하십시오",
// "on" => "on",
"Published on" => "다음에 개제됨",
"on blogpost" => "블로그게시물 상",
"Untitled" => "통함됨",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add Event" => "이벤트 추가",
"Unit cost" => "단가",
"Qty" => "수",
// "Cart contains <span>%0</span> items" => "Cart contains <span>%0</span> items",
// "Total weight %0 %1" => "Total weight %0 %1",
"Gift Certificate" => "선물 상품권",
"Remove Gift Certificate" => "선물 상품권 제거",
"Add Gift Certificate" => "상품권 추가",
"Check-out" => "체크아웃",
"Your cart is empty" => "장바구니가 비어있음",
"Missing %0 of the following categories" => "다음 범주의 없는 %0",
"%0 extra of the following categories" => "다음 범주들의 추가 %0",
"Unknown comparison" => "알 수 없는 비교",
"Impossible condition, %0 of" => "불가능한 상태, %0 of",
"Assign into category" => "범주로 할당",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
"Unassign category" => "범주 할당해제",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "홈페이지",
"1 more contributor" => "추가 1 기여자",
// "{\$hiddenContributors} more contributors" => "{\$hiddenContributors} more contributors",
"low" => "낮음",
"Sites" => "사이트",
"Sites to validate" => "승인할 사이트",
"Visited links" => "방문된 링크들",
"Pass" => "비밀번호",
// "By" => "By",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "스페이스로 구분된 태그를 놓습니다. 한 단어 이상으로 된 태그는, 스페이스를 사용하지 않고 단어들을 붙여쓰거나 단어들을 따옴표 안으로 묶습니다",
"Add tags" => "태그 추가",
// "No tags yet" => "No tags yet",
"List everything tagged" => "태그된 모든 것 나열",
"Last updated" => "최종 갱신됨",
"All Groups" => "모든 그룹",
"Your Groups" => "귀하의 그룹",
"Emulated Groups" => "그룹 에뮬레이트",
"Switch to Groups" => "그룹으로 변경",
"Simulate" => "시뮬레이트",
"Add Post" => "게시물 추가",
"insert original" => "원본 삽입",
"insert thumbnail" => "축소보기 삽입",
"more" => "추가",
"Last %0 Podcasts" => "마지막 %0 팟캐스트",
"This is likely not a podcast file" => "팟캐스트 파일이 아닐 확률이 큽니다",
"The path to a podcast player is required" => "팟캐스트의 경로가 필요합니다",
// "{\$link_text}" => "{\$link_text}",
"No profile picture" => "아바타 없음",
"You" => "귀하",
"Never logged in" => "한 번도 로그인 하지 않음",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "운영자 콘솔 열기",
// "Execution time" => "Execution time",
"Memory usage" => "메모리 사용량",
// "Queries" => "Queries",
"Server load" => "서버부하",
"Logged in as:" => "로그인 된 계정:",
"Log out" => "로그아웃",
// "Return to Main User" => "Return to Main User",
// "Return to main user" => "Return to main user",
"Switch" => "변경",
"Switch User" => "사용자 변경",
"Email:" => "전자우편:",
// "Email address or " => "Email address or ",
// "User account ID" => "User account ID",
"Enter a username and click 'Switch'.<br>Useful for testing permissions" => "사용자명을 입력하고 '전환'을 클릭하십시오.<br>권한 테스트용으로 유용합니다",
"Switch user" => "사용자 전환",
// "Toggle Dropdown" => "Toggle Dropdown",
"My Account" => "마이티키",
// "{\$user|username|escape|replace:'&amp;':'&'}" => "{\$user|username|escape|replace:'&amp;':'&'}",
"Log in through CAS" => "CAS 를 통하여 로그인",
"Log in as admin" => "관리자로 로그인",
"Log in through Shibboleth" => "Shibboleth 를 통한 로그인",
// "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t" => "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t",
"CapsLock is on." => "CapsLock 이 눌려있음.",
"Click here if you've forgotten your password" => "비밀번호 잊으셨으면 여기를 클릭",
"I forgot my password" => "비밀번호 찾기",
"Click here to register" => "등록하려면 여기를 클릭하십시오",
"Click here to log in using the default security protocol" => "기본 보안 프로토콜을 사용하여 로그인하려면 여기를 클릭하십시오",
"Standard" => "표준",
"Click here to log in using a secure protocol" => "보안 프로토콜을 사용하여 로그인하려면 여기를 클릭하십시오",
"Secure" => "보안",
"Stay in SSL mode" => "SSL 모드에 머뭄",
"local account" => "로컬 계정",
// "Log in via Facebook" => "Log in via Facebook",
// "Log in via LinkedIn" => "Log in via LinkedIn",
"OpenID Log in" => "OpenID 로그인",
// "OpenID Login" => "OpenID Login",
"What is OpenID?" => "OpenID 란 무엇인가?",
// "Change the logo" => "Change the logo",
// "Click to change or upload new logo" => "Click to change or upload new logo",
// "{\$module_params.sitetitle|escape}" => "{\$module_params.sitetitle|escape}",
// "{\$module_params.sitesubtitle|escape}" => "{\$module_params.sitesubtitle|escape}",
"No acceptable field to store the feature was found in the specified tracker" => "기능을 저장할 허용될 수 있는 필드가 지정된 트래커에서 발견되지 않음",
// "Edit this menu" => "Edit this menu",
"You have" => "다음을 보유하고 계십니다",
"new messages" => "새 메시지",
"new message" => "새 메시지",
"You have 0 new messages" => "0개의 새 메시지가 있습니다",
"No article found" => "기사 발견되지 않음",
"No blog post found" => "발견된 블로그 게시물 없음",
// "We have" => "We have",
"submissions waiting to be examined" => "검토를 대기 중인 제출",
// "Permissions applied from" => "Permissions applied from",
// "No permissions to display" => "No permissions to display",
"Stay on this page" => "이 페이지에 남아있기",
"Edit perspectives" => "perspectives 편집",
"Within %0" => "%0 안에",
"Search Terms" => "검색 조건",
"Any type" => "어떤 종류",
// "Recent Preferences" => "Recent Preferences",
"Wiki feed" => "위키 피드",
"Blogs feed" => "블로그 피드",
"Articles feed" => "기사 피드",
"Image Galleries feed" => "그림 갤러리 피드",
"Image Galleries" => "그림 갤러리",
"File Galleries feed" => "파일 갤러리 피드",
"Forums feed" => "게시판 피드",
// "Directory feed" => "Directory feed",
// "Calendar feed" => "Calendar feed",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "사이트 전체",
"Image Gals" => "그림갤러리",
"Search for text throughout the site" => "사이트를 통하여 텍스트에 대하여 검색",
"Go directly to a page, or search in page titles if exact match is not found" => "페이지로 직접 이동하거나 정확한 일치가 발견되지 않는 경우 페이지 내부에서 찾습니다",
"Edit existing page or create a new one" => "기존 페이지 편집 혹은 새 페이지 만들기",
// "External" => "External",
"Exact match" => "정확히 일치",
"Page Relations" => "페이지 관계",
// "Get short url" => "Get short url",
"Copy" => "복제",
// "Copied" => "Copied",
"Tweet with Twitter" => "트위터로 트윗 보내기",
"Post on my Facebook wall" => "내 페이스북 담벼락에 게시",
"Shout date" => "외침 날짜",
"Delete this shout" => "이 외침 삭제",
"Edit this shout" => "이 외침 편집",
"Read More" => "더 읽기",
"Since your last visit on" => "다음 날의 마지막 방문 이후",
"New Images" => "새 그림",
"Wiki Pages Changed" => "위키 페이지 변경됨",
"New Files" => "새 파일",
"New Comments" => "새 댓글",
"New Tracker Items" => "새 트래커 항목",
"New Calendar Events" => "새 달력 이벤트",
"New Users" => "새 사용자들",
"click to edit" => "편집하려면 클릭",
"Nothing has changed" => "변경된 것이 없습니다",
"Tracker Items" => "트래커 항목",
// "Updated" => "Updated",
"Multiple" => "다중",
"including" => "포함",
// "No Subversion checkout or unable to determine last update" => "No Subversion checkout or unable to determine last update",
"Find term" => "찾기 조건",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
"If not found, you will be given a chance to create it" => "발견되지 않는다면, 만들 기회가 주어질 것입니다",
"TikiTests Menu" => "티키테스트 메뉴",
"List Tests" => "테스트 나열",
"Create Test" => "테스트 만들기",
"Top galleries" => "상위 갤러리들",
"Posted to" => "게시된 곳",
"(Read More)" => "(더 읽기)",
"Missing values" => "값 누락",
"Add Marker" => "표시기 추가",
"Tracker name" => "트래커명",
"Insert fields in wiki textarea" => "위키 텍스트영역에 필드 삽입",
"There are no translations of this page" => "이 페이지의 번역이 없습니다",
"Up-to-date-ness" => "최신",
"Incoming" => "수신",
"To <strong>continue translating</strong>, select the language to translate from" => "<strong>번역을 계속</strong>하려면, 번역을 할 언어를 선택하십시오",
"update from it" => "여기로부터 갱신",
// "None match your" => "None match your",
"Set your preferred languages" => "선호 언어 설정",
"preferred languages" => "선호 언어",
"Outgoing" => "발신",
"update it" => "이것을 갱신",
"click to view" => "보려면 클릭",
"Bookmarks" => "책갈피",
"Cache" => "캐시",
"Create Bookmark" => "즐겨찾기 만들기",
"New Folder" => "새 폴더",
"Done" => "종료",
"Del" => "제거",
"select" => "선택",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
"Group information" => "그룹 정보",
"You need to activate user and/or group trackers" => "사용자 및/혹은 그룹 트래커를 활성화해야 합니다",
"view" => "보기",
"%0 out of %1 users" => "%1 사용자들 중 %0",
"online users" => "접속중인 사용자",
"online user" => "온라인 사용자",
"on host" => "호스트 상",
"User does not accept messages" => "사용자는 메시지를 받지 않습니다",
"Send a message to" => "다음에게 메시지 전송",
"More Videos" => "추가 동영상",
"No results were found. Are you sure you searched for a tag" => "결과가 발견되지 않았습니다. 태그에 대하여 검색을 하시는 것이 확실합니까",
"We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "현재 그룹에 접근을 승인할 수 없습니다. Zotero 그룹에 접근할 수 있다면, 이 사이트에 읽기 권한을 부여하십시오",
// "Mark all as read" => "Mark all as read",
// "You receive this notification because you requested it" => "You receive this notification because you requested it",
// "If you did not request these emails or did so in an error, please use the following link" => "If you did not request these emails or did so in an error, please use the following link",
// "Manage your notifications" => "Manage your notifications",
// "Notification Digest" => "Notification Digest",
// "No notifications available" => "No notifications available",
// "Priorities" => "Priorities",
// "No unread notifications" => "No unread notifications",
// "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped" => "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped",
// "Required Action" => "Required Action",
// "Add all members" => "Add all members",
// "OR Select individuals.." => "OR Select individuals..",
// "Add selected members" => "Add selected members",
"Detail" => "상세내역",
// "Respond" => "Respond",
// "Opened" => "Opened",
// "Logged In" => "Logged In",
// "Unopened" => "Unopened",
// "People" => "People",
// "Empty list" => "Empty list",
// "Responses" => "Responses",
"Entry" => "항목",
"Request Date" => "요청 날짜",
// "Action Req'd" => "Action Req'd",
// "None (Owner)" => "None (Owner)",
// "Nothing to do" => "Nothing to do",
// "Add Item" => "Add Item",
// "On this document" => "On this document",
// "Saving" => "Saving",
// "This window will close automatically in 3 seconds.." => "This window will close automatically in 3 seconds..",
// "An error occurred, please try again" => "An error occurred, please try again",
// "Consent screen" => "Consent screen",
// "Do you really want to proceed" => "Do you really want to proceed",
"No individual permissions, category permissions apply" => "개별 권한 없음, 범주 권한이 적용됨",
"There are individual permissions set for this object" => "이 개체에는 개별 권한들이 설정되어 있습니다",
"No individual permissions. Global permissions apply" => "개별 권한 없음. 전역 권한이 적용됨",
// "Search and select what you are looking for from the options that appear" => "Search and select what you are looking for from the options that appear",
// "No matching results" => "No matching results",
// "Search and select what you are looking for from the options that appear." => "Search and select what you are looking for from the options that appear.",
"Comparing version {\$old.version} with version {\$new.version}" => "{\$old.version} 버전을 {\$new.version} 버전과 비교",
"Current" => "현재",
"Session" => "세션",
"Old Session" => "기존 세션",
"Old Version" => "기존 버전",
"New Session" => "새 세션",
"New Version" => "새 버전",
"Versions are identical" => "버전은 동일함",
// "Example wikidiff plugin syntax" => "Example wikidiff plugin syntax",
"Minimum %0 characters long" => "최소 %0 글자",
// "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + ..",
// "Password is too common" => "Password is too common",
// "Individual permissions" => "Individual permissions",
// "Select image" => "Select image",
// "Pick a file" => "Pick a file",
// "Upload or record media" => "Upload or record media",
// "Convert to List" => "Convert to List",
// "{\$info.title|escape}" => "{\$info.title|escape}",
// "{\$info.description|default:''|escape}" => "{\$info.description|default:''|escape}",
// "Auto generate Biblio Code" => "Auto generate Biblio Code",
// "New reference created" => "New reference created",
// "Problems while creating the reference" => "Problems while creating the reference",
// "[-]" => "[-]",
"vote" => "투표",
// "Use &quot;%0&quot; to separate values" => "Use &quot;%0&quot; to separate values",
// "Reset to default value" => "Reset to default value",
// "Restore current value" => "Restore current value",
// "Change your preference filter settings in order to view advanced preferences by default" => "Change your preference filter settings in order to view advanced preferences by default",
// "advanced" => "advanced",
// "Change your preference filter settings in order to view experimental preferences by default" => "Change your preference filter settings in order to view experimental preferences by default",
"experimental" => "실험적",
"Requires:" => "필수:",
"You need apply profile" => "프로필을 적용해야 합니다",
"You need to set" => "다음을 설정해야 합니다",
// "Requires package" => "Requires package",
// "Missing tiki package" => "Missing tiki package",
// "User rating" => "User rating",
"Rate" => "평가",
// "User rating on thread topic" => "User rating on thread topic",
// "Debug Information" => "Debug Information",
// "Engine does not provide any debug information" => "Engine does not provide any debug information",
"A valid email is mandatory to register" => "등록하기 위해서 유효한 메일주소를 입력해 주세요.",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email address as your log-in name" => "로그인으로 이메일 사용",
"Lowercase only" => "소문자만 허용",
// "New Password" => "New Password",
"Confirm password" => "비밀번호(재입력)",
// "Passwords match" => "Passwords match",
"Generate a password" => "비밀번호 생성",
"Passcode to register" => "등록할 패스코드",
"Not your password" => "귀하의 암호는 불가",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_title|escape}" => "{\$remarksbox_title|escape}",
// "Do you really want to remove the %0 scheduler" => "Do you really want to remove the %0 scheduler",
// "Reset the scheduler, will mark this run as failed, allowing it to be executed again" => "Reset the scheduler, will mark this run as failed, allowing it to be executed again",
// "Back to schedulers list" => "Back to schedulers list",
// "Reversal Event" => "Reversal Event",
// "Unique Name" => "Unique Name",
// "Type (e.g. user)" => "Type (e.g. user)",
// "Field value (e.g. user)" => "Field value (e.g. user)",
// "Pt. value" => "Pt. value",
"The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "문서는 순서, 근접도, 조건의 빈도에 따라 연관성 상에 정렬되여 반환됩니다",
"Default search behavior" => "기본 검색 동작",
"By default, all search terms are <em>optional</em>" => "기본으로 모든 검색 조건은 <em>선택사항</em> 입니다",
"It behaves like an OR logic" => "OR 논리자처럼 작동합니다",
"Objects that contain the more terms are rated higher in the results and will appear first" => "더 많은 조건을 포함하는 개체들이 결과 안에서 더 높게 평가되며 처음으로 표시될 것입니다",
"For example, <strong>wiki forum</strong> will find" => "예를 들면, <strong>wiki forum</strong> 은 다음을 찾게 됩니다",
"objects that include both tokenized terms" => "토큰화된 조건을 둘 다 포함하는 개체",
"objects that include the term <strong>wiki</strong>" => "<strong>위키</strong> 조건을 포함할 개체들",
"objects that include the term <strong>forum</strong>" => "<strong>게시판</strong> 조건을 포함할 개체들",
"Boolean operators" => "부울 연산자",
"You can use AND or OR or NOT also to do a boolean search" => "불린 검색을 할 때 AND 혹은 OR 혹은 NOT 도 사용할 수 있습니다",
"Example: <strong>wiki and forum</strong> will find objects with both terms" => "예: <strong>wiki and forum</strong> 는 두 개의 조건을 지는 개체들을 찾을 것입니다",
"Example: <strong>wiki or forum</strong> will find objects with one of the term" => "예: <strong>wiki or forum</strong> 는 조건 중 한 개를 지닌 개체들을 찾을 것입니다",
"Grouping terms" => "조건 그룹화",
"Use parenthesis ( ) to group terms into subexpressions" => "조건들을 subexpressions 로 묶으려면 괄호 ( ) 를 사용",
"Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "예제: <strong>위키 and (게시판 블로그)</strong>는  <strong>위키</strong> 와 <strong>게시판</strong> 를 포함 혹은 <strong>위키</strong> 와 <strong>블로그</strong> 를 포함하는 개체를 어떤 순서와 상관없이 찾을 것입니다",
"Finding phrases" => "찾을 구절",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other" => "정확한 순서대로 조건을 찾기 위하여 나란히 놓여진 문구의 주위에 따옴표 사용",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "예: <kbd>\"Alex Bell\"</kbd> 은 <strong>Bell Alex</strong> 혹은 <strong>Alex G. Bell</strong> 을 찾지 못하지만, <strong>Alex Bells</strong> 은 찾을 것입니다. ",
// "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it" => "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it",
// "media image" => "media image",
// "Expand table" => "Expand table",
// "Restore layout" => "Restore layout",
"Items found" => "항목 발견됨",
"Indexed" => "들여쓰기",
"Queue size" => "대기 크기",
// "Batch Size" => "Batch Size",
// "Process %0" => "Process %0",
// "Process Batch" => "Process Batch",
// "Your index was last fully rebuilt on %0" => "Your index was last fully rebuilt on %0",
"version" => "버전",
// "Fallback search engine" => "Fallback search engine",
// "Fallback search index was rebuild" => "Fallback search index was rebuild",
// "Fallback search index was not rebuilt" => "Fallback search index was not rebuilt",
// "Execution Statistics" => "Execution Statistics",
// "Current Memory usage" => "Current Memory usage",
// "Memory peak usage before indexing" => "Memory peak usage before indexing",
// "Memory peak usage after indexing" => "Memory peak usage after indexing",
// "Number of queries" => "Number of queries",
// "Rebuilding index.." => "Rebuilding index..",
// "Enable logging" => "Enable logging",
// "Log file is saved as %0" => "Log file is saved as %0",
// "Rebuild" => "Rebuild",
// "Process Queue" => "Process Queue",
// "Indexing Problems" => "Indexing Problems",
// "If the indexing does not complete, check the log file to see where it ended" => "If the indexing does not complete, check the log file to see where it ended",
// "Last line of log file (web)" => "Last line of log file (web)",
// "Last line of log file (console)" => "Last line of log file (console)",
// "Not enough memory" => "Not enough memory",
// "Time limit too short" => "Time limit too short",
// "High resource usage" => "High resource usage",
// "Command Line Utilities" => "Command Line Utilities",
// "Cache Expired" => "Cache Expired",
// "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over" => "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over",
"Index" => "색인",
// "Defined" => "Defined",
"Valid" => "유효함",
// "May not work or corrupt data" => "May not work or corrupt data",
// "Alter" => "Alter",
// "No instances configured" => "No instances configured",
// "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes" => "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes",
// "Create Index" => "Create Index",
// "Return to List of Saved Searches" => "Return to List of Saved Searches",
// "Do you really want to remove the %0 saved search" => "Do you really want to remove the %0 saved search",
// "Other Queries" => "Other Queries",
// "No stored queries" => "No stored queries",
"Create New" => "새로 만들기",
// "This will help you recognize your stored queries if ever you want to modify or remove them" => "This will help you recognize your stored queries if ever you want to modify or remove them",
// "Use Existing" => "Use Existing",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => "최종 수정",
// "No pages matched the search criteria test" => "No pages matched the search criteria test",
"Download Log File" => "로그파일 다운로드",
// "Resend newsletter" => "Resend newsletter",
"Send Newsletter" => "회보 전송",
// "Send newsletter" => "Send newsletter",
// "This content is licensed under the terms of the" => "This content is licensed under the terms of the",
"To edit the copyright notices" => "저작권 알림을 편집하려면",
// "Know the username" => "Know the username",
// "%0 has been accepted" => "%0 has been accepted",
// "Do you really want to approve %0" => "Do you really want to approve %0",
// "Do you really want to remove %0" => "Do you really want to remove %0",
// "No friends have been added" => "No friends have been added",
// "Incoming requests" => "Incoming requests",
// "Accept and add" => "Accept and add",
// "Still waiting for approval" => "Still waiting for approval",
// "Do you really want to cancel request for %0" => "Do you really want to cancel request for %0",
// "%0 has been removed from your friends" => "%0 has been removed from your friends",
"Page alias.." => "페이지 별칭..",
"Monitor the Sub-Structure" => "하위 구조체를 주시",
"Stop Monitoring the Sub-Structure" => "하위구조체 모니터링 중지",
"locked by %0" => "%0 님이 잠궜습니다",
"Locked" => "잠금됨",
"Edit page" => "페이지 편집",
"Add new child page" => "새 자식 페이지 추가",
// "About &amp; News" => "About &amp; News",
// "Information and introduction portal" => "Information and introduction portal",
"Documentation" => "문서화",
// "How to use Tiki" => "How to use Tiki",
// "Development" => "Development",
// "How make Tiki" => "How make Tiki",
// "Forums and general community information" => "Forums and general community information",
// "How make Tiki look pretty" => "How make Tiki look pretty",
// "Manage" => "Manage",
// "Initializite this format with the current tracker fields" => "Initializite this format with the current tracker fields",
// "Tracker Name" => "Tracker Name",
// "File Delimiter" => "File Delimiter",
// "Comma (,)" => "Comma (,)",
// "Semicolon (;)" => "Semicolon (;)",
// "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes" => "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes",
// "Field Type" => "Field Type",
// "Primary Key" => "Primary Key",
// "PK" => "PK",
// "Unique Key" => "Unique Key",
// "UK" => "UK",
// "Read-Only" => "Read-Only",
// "RO" => "RO",
// "Export-Only" => "Export-Only",
// "EO" => "EO",
// "Required to import data. Can be any field as long as it is unique" => "Required to import data. Can be any field as long as it is unique",
// "Impose unique value requirement for the target column. This only works with Transactional Import feature" => "Impose unique value requirement for the target column. This only works with Transactional Import feature",
// "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process" => "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process",
// "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict" => "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict",
// "Simple headers" => "Simple headers",
// "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format" => "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format",
// "Import updates" => "Import updates",
// "Import update" => "Import update",
// "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported" => "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported",
// "Ignore blanks" => "Ignore blanks",
// "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way" => "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way",
// "Transactional import" => "Transactional import",
// "Import transaction" => "Import transaction",
// "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved" => "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved",
// "Bulk import" => "Bulk import",
// "Bulk Import" => "Bulk Import",
// "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent" => "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent",
"Are you sure you want to delete this item" => "이 항목을 삭제하시겠습니까",
"Delete item" => "항목 삭제",
// "Select a field.." => "Select a field..",
// "Select Mode" => "Select Mode",
// "No primary key" => "No primary key",
// "Side" => "Side",
// "Filters will be available in partial export menus" => "Filters will be available in partial export menus",
// "Skip Unmodified" => "Skip Unmodified",
// "Will not re-import items that have not changed" => "Will not re-import items that have not changed",
// "Import Completed" => "Import Completed",
// "Your import was completed succesfully" => "Your import was completed succesfully",
"CSV File" => "CSV 파일",
// "Applied filters" => "Applied filters",
// "Create Tracker from File" => "Create Tracker from File",
// "Export Full" => "Export Full",
// "Export Partial" => "Export Partial",
// "Export Custom" => "Export Custom",
// "No tabular formats defined" => "No tabular formats defined",
// "Modes" => "Modes",
"This book" => "이 장부",
"before" => "이전",
"after" => "이후",
"don't display" => "표기하지 않습니다",
"Decimals" => "10진수",
"Decimal Point" => "소수점",
"Auto Tax" => "자동 세금",
"Tasks" => "작업",
"Book new entries" => "새 항목 기록",
"Confirm stack entries" => "스택 엔트리 확인",
"Book into Stack" => "스택으로 기록",
"Accounts" => "계정들",
"Journal" => "저널",
"Fetch all" => "전부 가져오기",
"Create new account" => "새 계정 만들기",
"Edit Account" => "계정 편지",
"Account number" => "계정 번호",
"Notes" => "노트",
"Budget" => "예산",
"Create account" => "계정 만들기",
"Modify account" => "계정 수정",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1",
"Delete this account" => "이 계정 삭제",
"Back to book page" => "장부 페이지로 복귀",
"Account" => "계정",
"Debit" => "차변",
"Credit" => "크레딧",
"Tax" => "세금",
// "Unlock account" => "Unlock account",
// "Lock account" => "Lock account",
// "Remove account" => "Remove account",
"Create a new account" => "새 계정 만들기",
"printable version" => "인쇄가능한 버전",
"export table" => "표 내보내기",
"View account" => "계정 보기",
"Edit this account" => "이 계정 편집",
"My books" => "내 책",
"Tax automation" => "세금 자동화",
"hide" => "감춤",
"behind" => "뒤",
// "Close book" => "Close book",
// "Close book? (This action cannot be undone)" => "Close book? (This action cannot be undone)",
"Create a book" => "장부 만들기",
"Book properties" => "장부 속성",
"Name of the book" => "장부명",
"First date in journal" => "저널의 첫 날짜",
"Last date in journal" => "저널 내부의 마지막 날짜",
"Currency settings" => "통화 설정",
"Currency (up to 3 letters) " => "통화 (3글자까지)",
"Position of the currency " => "통화의 위치",
"Show no currency" => "통화 없음 표시",
"Show currency in front of numbers" => "숫자 앞에 통화 표시",
"Show currency behind numbers" => "숫자 뒤에 통화 표시",
"Decimal point" => "소수점",
"Decimal" => "10진",
"Quote strings with" => "문자열을 다음으로 인용",
"End of Line" => "줄의 끝",
"Carriage return" => "캐리지 리턴",
"Line feed" => "줄 바꿈",
"Carriage Return/Line feed" => "캐리지 리턴/줄 바꿈",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
"Allow automatic tax calculation" => "자동 세금 계산 허용",
"Create a new book" => "새 장부 만들기",
// "Canceled Journal" => "Canceled Journal",
// "Booking Date" => "Booking Date",
"Amount" => "양",
"Book a transaction" => "거래를 기록",
// "\"}Delete account %0" => "\"}Delete account %0",
"Add entry" => "엔트리 추가",
"Book" => "장부",
// "\"}Record entry in book %0" => "\"}Record entry in book %0",
"Export {\$what}" => "내보니기  {\$what}",
"Export CSV settings" => "CSV 내보내기 설정",
"Separator between fields" => "필드간의 구분 기호",
"Quote character for text" => "텍스트에 대한 인용 문자",
"Export as CSV" => "CSV 로 내보내기",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1",
// "Cancel transaction" => "Cancel transaction",
"Balance" => "균형",
"Deleted" => "삭제됨",
"Debit Account" => "차변 계정",
"Debit Amount" => "차변 양",
"Debit Text" => "차변 텍스트",
"Credit Account" => "크레딧 계정",
"Credit Amount" => "크레딧 양",
"Credit Text" => "크레딧 텍스트",
"Book a transaction into the stack" => "거래를 스택으로 기록",
// "\"}Record stack entry in book %0" => "\"}Record stack entry in book %0",
// "\"}Modify stack entry in book %0" => "\"}Modify stack entry in book %0",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1",
// "Remove transaction" => "Remove transaction",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1",
// "Confirm transaction" => "Confirm transaction",
"Do not group by item" => "항목별 그룹화 해지",
"Group by item" => "항목별 그룹",
"Calendar View" => "달력 보기",
"Tiki Action Calendar" => "티키 작업 달력",
"Tools Calendars" => "도구 달력",
"Check / Uncheck All" => "전부 체크/체크 취소",
// "Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>" => "Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>",
"Database Version Problem" => "데이터베이스 버전 문제",
// "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "Vendor folder issues" => "Vendor folder issues",
// "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>" => "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>",
// "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded" => "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded",
// "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries" => "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries",
// "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>" => "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>",
// "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file" => "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file",
// "Installer not locked" => "Installer not locked",
// " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. " => " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. ",
// "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder" => "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder",
// "You can also use the following, on the command line, from the root of your Tiki installation" => "You can also use the following, on the command line, from the root of your Tiki installation",
// "Search Index outdated" => "Search Index outdated",
// "The search index might be outdated. It is recommended to rebuild the search index" => "The search index might be outdated. It is recommended to rebuild the search index",
// "File gallery directory web accessable" => "File gallery directory web accessable",
// "This is a potential security risk" => "This is a potential security risk",
// "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database" => "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database",
// "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>" => "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>",
"Please select some actions to be reported." => "보고될 작업을 선택하여 주십시오.",
"End" => "종료",
"Users and Groups" => "사용자와 그룹",
"Misc" => "기타",
"Units" => "단위",
// "kb" => "kb",
// "Contribution Time" => "Contribution Time",
"Graph Contributions" => "그래프 기여내역",
"Group Bar Plot" => "그룹 Bar 플롯",
"Accumulated Bar Plot" => "누계 바 플롯",
"Background color" => "배경 색상",
// "{\$color}" => "{\$color}",
"Legend background color" => "범례 배경 색상",
"Save graphs to image gallery" => "그래프를 그림 갤러러에 저장",
"Records" => "기록",
"See Statistics" => "통계 보기",
"contribution" => "기여",
"contributor" => "기여자",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Delete action from log" => "Delete action from log",
// "Select action to perform with checked" => "Select action to perform with checked",
// "Delete selected actions from log" => "Delete selected actions from log",
"Edit Action" => "작업 편집",
"Save Action" => "작업 저장",
"Statistics" => "통계",
"Volumes are equally distributed on each contributors/author" => "볼륨은 각 기여자/저자에게 동일하게 배표됩니다",
"connection time" => "연결 시간",
"connection seconds" => "연결 초",
// "mns" => "mns",
"Volume per category" => "범주당 볼륨",
"Volume per category and per user" => "범주 및 사용자당 볼륨",
"Number of actions per user" => "사용자 당 작업의 수",
"Total number of users" => "사용자 전체 수",
"Number of actions per object" => "개체 당 작업의 주",
"Total number of objects" => "개체 전체 수",
// "Bigbluebutton" => "Bigbluebutton",
// "Time in bigbluebutton (in minutes)" => "Time in bigbluebutton (in minutes)",
"Number of actions per category" => "범주 당 작업의 수",
"Number of actions per category and per user" => "범주 당 및 사용자 당 작업의 수",
"Volume per the users' group and per contribution" => "사용자의 그룹 및 기여도 당 볼륨",
"Volume per group and per contribution" => "그룹 및 기여도 당 볼륨",
"Volume per user and per contribution" => "사용자 및 기여도 당 볼륨",
"Volume per users' contribution and time" => "사용자의 기여도 및 시간 당 볼륨",
"Volume per contribution and time" => "기여도 및 시간 당 볼륨",
"Weeks" => "주간",
"How" => "어떻게",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "저희가 추후에 관심을 가질 수도 있는 보고서를 받아볼 수 있게하려면 각각의 작업 유형에 대하여 기록된 상자를 체크아웃해야 합니다. 일부 작업 유형으 보고서를 보려면, 이러한 작업 유형의 보고된 체크상자를 선택하고 보고 탭으로 이동하여 추가 필터를 선택합니다. 보고서는 해당 작업 유형이 기록되도록 설정된 이후에 발생한 작업만 포함할 것입니다",
"Wiki page actions except viewed will always be recorded but can be not reported." => "보기를 제외한 위키 페이지 행동들은 항상 저장되지만 보고될 수는 없습니다",
"Recorded" => "기록됨",
// "{\$actionlog.action}" => "{\$actionlog.action}",
"Import as CSV" => "CSV 로 가져오기",
"Banning rules have been updated" => "차단 규칙이 갱신되었습니다",
"Add or edit rules" => "규칙 추가 혹은 편집",
"Rule title" => "규칙 제목",
// "Username regex matching" => "Username regex matching",
"Multiple IP regex matching" => "다중 IP 정규식 일치",
// "IP regex matching" => "IP regex matching",
// "Banned from sections" => "Banned from sections",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "날짜에 의해 활성화되는 규칙",
"Rule active from" => "다음부터 규칙 활성",
"Rule active until" => "다음까지 규칙 활성",
"Custom message to the user" => "사용자에게 사용자 지정 메시지",
"Import rules as CSV" => "CSV 로 규칙 가져오기",
"Column names on the first line" => "첫 줄에 열 이름",
"Sections format" => "센션 형식",
"section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "섹션명은 파이프 (세로 막대기)로 나뉩니다. 예제를 보고 템플릿으로 사용하려면, 수동으로 규칙 하나를 추가하시고 CSV로 내보내기하십시오",
"See" => "보기",
"Import as new rules" => "새 규칙으로 가져오기",
"Find:" => "검색:",
// "Current rules" => "Current rules",
// "x" => "x",
// "Delete selected banning rules" => "Delete selected banning rules",
"User/IP" => "사용자/IP",
// "Delete banning rule" => "Delete banning rule",
// "No rules found" => "No rules found",
"Admin Calendars" => "달력 관리",
"Create Calendar" => "달력 만들기",
"View Calendars" => "달력 보기",
"Calendar name" => "달력 이름",
"Participants" => "참여자",
// "Personal" => "Personal",
// "Field will show in popup" => "Field will show in popup",
// "Custom location" => "Custom location",
// "Custom participants" => "Custom participants",
// "Custom languages" => "Custom languages",
"Add event" => "이벤트 추가",
// "Delete calendar" => "Delete calendar",
"Edit Calendar" => "달력 편집",
// "Custom classification" => "Custom classification",
// "Custom language" => "Custom language",
// "Custom subscription list" => "Custom subscription list",
// "Custom priority" => "Custom priority",
// "Personal Calendar" => "Personal Calendar",
// "Start of day" => "Start of day",
// "End of day" => "End of day",
// "Days to display" => "Days to display",
// "Standard color" => "Standard color",
"Green" => "초록",
"Purple" => "보라",
"Orange" => "주황",
"Yellow" => "노량",
// "Custom foreground color" => "Custom foreground color",
// "Custom background color" => "Custom background color",
"Default event status:" => "기본 이벤트 상태:",
// "Show in popup view" => "Show in popup view",
"Show in calendar view" => "달력 보기에 표시",
"Group of users alerted when calendar event is modified" => "달력 이벤트가 수정되었을 때 알림이 전달되는 사용자의 그룹",
"Default length of events is all day" => "하루 종일로의 기본 이벤트",
"Event name on each day in calendar view" => "달력 보기에서 각 날의 이벤트명",
"Delete events older than:" => "다음보다 오래된 이벤트 삭제:",
// "Delete old events" => "Delete old events",
"Browse the category system" => "범주 시스템 탐색",
// "Create category" => "Create category",
// "Edit category" => "Edit category",
"Edit this category:" => "이 카테고리 편집:",
"Add new category" => "새 범주 추가",
"Apply parent category permissions" => "부모 범주 권한을 적용",
"Objects in category" => "범주 내 개체",
"Objects in category:" => "범주 내 개체:",
// "Remove from this category" => "Remove from this category",
// "Remove object from category" => "Remove object from category",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Remove checked" => "Remove checked",
// "Remove objects from category" => "Remove objects from category",
// "Moving objects" => "Moving objects",
"Moving objects between categories" => "범주 간 개체 이동",
"Current category" => "현재카테고리",
// "Perform an action on all objects in the current category" => "Perform an action on all objects in the current category",
// "Unassign objects from category" => "Unassign objects from category",
// "Move to selected category" => "Move to selected category",
// "Choose destination category" => "Choose destination category",
// "Copy to selected category" => "Copy to selected category",
// "Add objects" => "Add objects",
"Add objects to category:" => "범주에 개체 추가:",
"Objects" => "오브젝트",
"Quiz" => "퀴즈",
"Batch upload" => "Batch 업로드",
// "Sample file content" => "Sample file content",
// "Content templates" => "Content templates",
"Templates" => "템플릿",
"Visible in no sections" => "보이는 섹션 없음",
"Remove section" => "섹션 제거",
// "Uncategorized" => "Uncategorized",
// "{\$catName}" => "{\$catName}",
// "Remove template" => "Remove template",
"Edit template" => "템플릿 변경",
// "Create template" => "Create template",
"Use the Administration page of each enabled feature to allow the use of content templates" => "컨텐츠 템플릿의 사용을 허용하기 위하여 각각의 활성화된 기능의 관리자 페이지 사용",
"Name field is mandatory" => "이름 필드는 필수적임",
"No features are configured to use templates" => "템플릿을 사용하기 위해 구성된 기능 없음",
"Template Type" => "템플릿 종류",
"Text area" => "텍스트 영역",
"Admin Contributions" => "기여도 관리",
"Edit the contribution" => "기여도 편집",
"Contributions are mandatory in wiki pages" => "위키 페이지에 기여도가 필수임",
"Contributions are mandatory in forums" => "기여는 게시판에서 필수임",
"Contributions are mandatory in comments" => "댓글에 기여도가 필수임",
"Contributions are mandatory in blogs" => "블로그에 기여도가 필수임",
"Contributions are displayed in the comment/post" => "댓글/게시에 기여자가 표기됨",
"Create a new contribution" => "새 기여 만들기",
"List of contributions" => "기여자의 목록",
// "Remove contribution" => "Remove contribution",
"Admin cookies" => "쿠키 관리",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "쿠키 추가/변경",
"Upload Cookies from textfile" => "텍스트파일에서 쿠키 업로드",
// "Upload from disk" => "Upload from disk",
"Remove all cookies" => "모두 쿠키 제거",
"cookie" => "쿠키",
// "Remove cookie" => "Remove cookie",
"Manage Credits" => "신용 관리",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
"(level credits always 0)" => "(레벨 크레딧은 항상 0)",
"Delete Checked" => "체크된 것 삭제",
"User Credits Expiry Summary (Plans)" => "사용자 신용 만기 요약 (계획)",
"User Plan" => "사용자 계획",
"Start of Latest Plan" => "최신 계획의 시작",
"Start of Next Plan" => "다음 계획으 시작",
"Expiry" => "만기",
"Use User Credits" => "사용자 신용 사용",
"Restore User Level Credits" => "사용자 등급 크레딧 복원",
"Historical Usage Report" => "가록 사용내역 보고",
"all types" => "모든 종류",
"filter" => "필터",
"Usage Date" => "사용 날짜",
"Amount Used" => "사용된 양",
"No such user" => "그런 사용자 없음",
"Manage Credit Types" => "신용 유형을 관리",
"Display Text" => "텍스트 표시",
"Unit Text" => "단위 텍스트",
"Is Static Level Credit" => "은 정적 레벨 크레딧입니다",
"Display Bar Length Scaling Divisor" => "바 길이 크기 조정 분리자 표시",
"Purge Expired and Used Credits (All Users)" => "만기되고 사용된 크레딧 제거 (모든 사용자)",
"Purge" => "제거",
"Admin Content Sources" => "컨텐츠 소스 관리",
"Use Admin DSN to define the database to be used by the SQL plugin" => "SQL 플러그인에 사용될 데이터베이스를 정의하기 위하여 DSN 관리를 사용",
"Create/edit DSN" => "DSN 만들기/편집",
"Local (Tiki database)" => "로컬 (티키 데이터베이스)",
"See db/local.php" => "db/local.php 보기",
// "Remove DSN" => "Remove DSN",
"Content Authentication" => "컨텐츠 인증",
"Identification" => "확인",
"HTTP Basic" => "HTTP 기본",
"HTTP Session / Login" => "HTTP 세션 /로그인",
"HTTP Session / Visit" => "HTTP 세션 / 방문",
"Admin External Wikis" => "외부 위키 관리",
"Create/Edit External Wiki" => "외부Wiki 새 작성/변경",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (ur<x>l 내부에서 페이지명으로 교체될 \$page 를 사용. 예: http://www.example.com/tiki-index.php?page=\$page)",
// "<em>[prefix]</em>main, such as tiki_main" => "<em>[prefix]</em>main, such as tiki_main",
// "Search as" => "Search as",
// "Leave blank to search using currently active groups" => "Leave blank to search using currently active groups",
"ExtWiki" => "외부위키",
// "Search As" => "Search As",
// "Remove external wiki" => "Remove external wiki",
"Admin Forums" => "게시판 관리",
// "Create Forum" => "Create Forum",
"Age" => "나이",
// "PPD" => "PPD",
"Create/Edit Forums" => "게시판 만들기/편집",
"Edit this Forum:" => "이 게시판 편집:",
"Create New Forum" => "새 게시판 만들기",
// "Main details" => "Main details",
// "Image symbolizing the forum" => "Image symbolizing the forum",
"Only allow replies to the first message (flat forum)" => "첫 메시지에만 댓글 허용 (플랫형 게시판)",
"Moderator user" => "편집자",
"Moderator group" => "편집그룹",
"Password protected" => "비밀번호 보호됨",
"Forum password" => "게시판 비밀번호",
"Prevent flooding" => "연속투고 방지",
"Minimum time between posts" => "투고간 최소시간",
"Send the posts of this forum to this email address" => "이 게시판 게시물를 이 이메일로 전송",
"Prune unreplied-to messages after" => "답신 없는 메시지를 다음 이후로 가지치기",
"Prune old messages after" => "오래된 메시지를 다음 이후로 가지치기",
// "Forum-mailing list synchronization" => "Forum-mailing list synchronization",
"Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address" => "이 게시판으로 메시지들을 이 이메일 주소를 사용하여 전송하십시오, 형식은 인바운드 게시판 이메일 주소로 돌려보내기 위하여 사용될 수 있는 것이여야 합니다",
"Send emails even when the post is generated by an inbound email" => "게시물이 인바운드 메일에 의해 생성될 경우에도 메일 전송",
"Append a reply link to outbound mails" => "아웃바운드 메일로 회신 링크 추가",
"Originating email address for emails from this forum" => "이 게시판에서의 메일에 대한 원래 이메일 주소",
"Add messages from this email to the forum" => "이 메일으로부터 메시지를 게시판에 추가",
"POP3 server" => "POP3 서버",
// "Forums list" => "Forums list",
"Display last post titles" => "최근 포스트 타이틀을 표시하기",
// "Forum topics (threads) list" => "Forum topics (threads) list",
"Default order of topics" => "기본 토픽 순서",
"Topics per page" => "페이지당 토픽",
"Topic list configuration" => "토픽 목록표시 설정",
"Last post title" => "마지막 게시 제목",
"Last post profile picture" => "마지막 게시 아바타",
"Author profile picture" => "저자 아바타",
"Use topic smileys" => "토픽 이모티콘 사용",
"Show topic summary" => "토픽 개요 표시",
// "Forum threads" => "Forum threads",
// "Default ordering of threads" => "Default ordering of threads",
// "Default style of threads" => "Default style of threads",
"Approval type" => "승인 유형",
// "Topic Rating" => "Topic Rating",
"User Level" => "사용자 레벨",
"eMail" => "메일주소",
"Online" => "온라인",
"Permission" => "권한",
"Store attachments in" => "첨부파일을 다음 안에 저장",
// "File system" => "File system",
"Max attachment size (bytes)" => "최대 첨부 크기(바이트)",
"Shows number of attachments of the all thread in forum list" => "게시판 목록의 모든 대화목록의 첨부파일의 숫자 보기",
"Duplicate Forum" => "게시판 복제",
"Admin Hotwords" => "Hotwords 관리",
"Add Hotword" => "Hotword 추가",
"Word" => "단어",
// "Delete hotword" => "Delete hotword",
"Admin HTML Page Dynamic Zones" => "HTML 페이지 유동 영역 관리",
"Admin HTML pages" => "HTML 페이지 관리",
"Edit zone" => "Zone 편집",
"Content:" => "내용:",
"Dynamic zones" => "유동 영역",
"zone" => "영역",
"content" => "내용물",
"Mass update" => "대량 업데이트",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "유동 구역을 삽입하려면 {literal}{ed id=name}{/literal} 혹은 {literal}{ted id=name}{/literal} 을 사용",
"Create new HTML page" => "새 HTML 페이지 만들기",
"Edit this HTML page" => "이 HTML 페이지 편집",
"Apply template" => "템플릿 적용",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "동적",
"Static" => "정적",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
"Last Modif" => "최종 변경",
"Admin dynamic zones" => "유동적 구역 관리",
// "Remove HTML page" => "Remove HTML page",
// "IDS Rules" => "IDS Rules",
// "Add a new Rule" => "Add a new Rule",
// "Rule ID" => "Rule ID",
// "Impact" => "Impact",
// "Edit rule settings" => "Edit rule settings",
// "Edit Rule" => "Edit Rule",
// "Add a new rule" => "Add a new rule",
// "Rule Id" => "Rule Id",
// "Rule Id must be numeric" => "Rule Id must be numeric",
// "Rule Regex" => "Rule Regex",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository" => "리포지터리 편집",
"Create New Repository" => "새 리포지터리 만들기",
"Human-readable repository name" => "사람이 읽을 수 있는 리포지터리명",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "리포지터리로의 경로 (로컬 파일시스템: 상대적/절대적 웹 루트, 원격: 'http://'가 앞에 붙어야함)",
"File name of start page" => "시작 페이지의 파일명",
"Start page" => "시작 페이지",
"CSS file to load when browse this repository" => "이 리포지터리를 탐색할 때 로드할 CSS 파일",
"CSS File" => "CSS 파일",
"Is repository visible to users" => "은 사용자에게 표시되는 리포지터리입니다",
"Can files from repository be cached" => "리포지터리에서의 파일을 캐시 가능",
"Cacheable" => "캐기가능",
"Clear all cached pages of this repository" => "이 리포지터리의 모든 캐시된 페이지들 제거",
"Clear cache" => "캐시 삭제",
"Seconds count 'till cached page will be expired" => "캐시된 페이지가 만기될 때까지 초 수 ",
"Cache expiration" => "캐시 만기",
"Human-readable text description of repository" => "사람이 읽을 수 있는 리포지터리의 텍스트 설명",
"Available Repositories" => "사용가능한 리포지터리",
"Edit rules" => "규칙 편집",
"Edit Rules for Repository" => "리포지터리에 대한 규칙 편집",
"Configure Repositories" => "리포지터리 구성",
"List Repositories" => "리포지터리 목록",
"Configure this Repository" => "이 리포지터리 구성",
"View this Repository" => "이 리포지터리 보기",
"New Rule" => "새 규칙",
"Copy Rules" => "규칙 복사",
"view/hide copy rules dialog" => "복사 규칙 대화상자 표시/숨김",
"Source repository" => "소스 리포지터리",
// "Rules will be applied in this order ('0' or empty = auto)" => "Rules will be applied in this order ('0' or empty = auto)",
"Rule order" => "규칙 순서",
"Text to search for" => "검색할 텍스트",
"Text to replace" => "교체할 텍스트",
"Is this regular expression or simple search/replacer" => "은 이 정규표현식 혹은 간단한 검색/교체입니다",
"Regex" => "정규식",
"Is case sensitive (for simple replacer)" => "은 대소문자를 구분합니다 (간단한 교체에 대함)",
"Case sensitive" => "대/소문자 구분",
// "subset of chars: imsxeADSXUu, which are regex modifiers" => "subset of chars: imsxeADSXUu, which are regex modifiers",
"Regex modifiers" => "정규식 수정자",
"Human-readable text description of rule" => "사람이 읽을 수 있는 규칙의 텍스트 설명",
"Check to enable this rule" => "이 규칠을 활성화하려면 체크",
"Preview options" => "미리보기 선택사항",
"Apply all rules or just this to generate preview" => "미리보기 생성할 모든 규칙 혹은 이 규칙만 적용",
"Apply all rules" => "모든 규칙 적용",
"View source code after rules applied" => "규칙이 적용된 후 소스코드 보기",
"Code preview" => "코드 미리보기",
"Generate HTML preview" => "HTML 미리보기 생성",
"HTML preview" => "HTML 미리보기",
"Test file from repository to generate preview for (empty = configured start page)" => "미리보기를 생성하기 위한 리포지터리에서의 파일로 시험 (비어있음 = 구성된 시작 페이지)",
"Preview Results" => "결과 미리보기",
"Rules List" => "규칙 목록",
"Case" => "대/소문자",
"Admin Invoices" => "청구서 관리",
"Admin keywords" => "키워드 관리",
"Edit page keywords" => "페이지 키워드 편집",
"Current Page Keywords" => "현재 페이지 키워드",
"Search by page:" => "페이지로 검색:",
"results found" => "결과 발견됨",
// "Remove keywords for this page" => "Remove keywords for this page",
"No pages found" => "페이지 발견되지 않음",
// "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "방문수에 의하여 위치 생성",
"List of featured links" => "추천 링크들의 목록",
// "Remove featured link" => "Remove featured link",
"Add Featured Link" => "추천 링크 추가",
"Edit this Featured Link" => "이 추천 링크 편집",
"Create new Featured Link" => "새 추천 링크 만들기",
"disables the link" => "링크 사용 안 함",
"Link type" => "링크 유형",
"replace current page" => "현재 페이지 교체",
// "framed" => "framed",
"open new window" => "새 창 열기",
"Mail-in accounts" => "Mail-in 계정",
// "Allow" => "Allow",
// "Leave" => "Leave",
// "Auto-category" => "Auto-category",
// "Auto-namespace" => "Auto-namespace",
"Administrator" => "관리자",
// "Admin Mail-in Routes" => "Admin Mail-in Routes",
"Check Mail-in accounts" => "Mail-in 계정 확인",
"Check automatically" => "자동 확인",
"Frequency" => "빈도",
// "Check Manually Now" => "Check Manually Now",
// "Admin Mail-in routes" => "Admin Mail-in routes",
// "Structure Routing" => "Structure Routing",
// "Wiki structures feature is not enabled" => "Wiki structures feature is not enabled",
// "List Menus" => "List Menus",
"Create menu option" => "메뉴 선택사항 만들기",
// "Edit This Menu" => "Edit This Menu",
// "Export menu options" => "Export menu options",
// "Import menu options" => "Import menu options",
"Manage menu" => "메뉴 관리",
"Menu options" => "메뉴 선택사항",
// "Save Options" => "Save Options",
// "New option" => "New option",
// "Check this if the option is an alternative to the previous one" => "Check this if the option is an alternative to the previous one",
// "Drag this on to the menu area below" => "Drag this on to the menu area below",
// "URL or ((page name))" => "URL or ((page name))",
// "Test URL" => "Test URL",
// "Remove Option" => "Remove Option",
"Preview menu" => "메뉴 미리보기",
// "Deploy" => "Deploy",
// "Menu Options" => "Menu Options",
"RESET" => "재설정",
"Clear Cache" => "캐시 비움",
"Show hidden modules" => "숨겨진 모듈 보기",
"Hide hidden modules" => "비어있는 모듈 감춤",
"Exit Modules" => "모듈 나가기",
"Modules Parameters" => "모듈 매개 변수",
"The following required parameters are missing" => "다음의 요청된 매개변수들이 없습니다",
"Drag the modules around to re-order then click save when ready" => "모듈들을 이리저리 움직여서 위치를 정하신 후, 준비되면 저장을 클릭하십시오",
"Double click them to edit" => "편집하시려면 더블클릭하십시오",
"Modules with \"position: absolute\" in their style can be dragged in to position" => "스타일에 \"position: absolute\" 있는 모듈은 위치로 끌어올 수 있습니다",
"New modules can be dragged from the \"All Modules\" tab" => "새 모듈은 \"모든 모듈\" 탭에서 끌어올 수 있습니다",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>",
"More info here" => "다음에 추가 정보가 있습니다",
"Assigned modules" => "할당된 모듈",
"Assign/Edit modules" => "모듈 할당/편집",
"Assigned Modules" => "할당된 모듈",
"Add module" => "모듈 추가",
// "You will need to go" => "You will need to go",
// "to reorder or move modules in the left or right columns since you have created a custom order for these" => "to reorder or move modules in the left or right columns since you have created a custom order for these",
// "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user" => "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user",
"Edit module" => "모듈 편집",
"Assign new module" => "새 모듈 할당",
"Edit this assigned module:" => "이 할당된 모듈 편집:",
"Module Options" => "모듈 선택사항",
"Custom Modules" => "사용자 지정 모듈",
// "Delete custom module" => "Delete custom module",
"Create new custom module" => "새 사용자 지정 모듈 만들기",
"Edit this custom module" => "이 사용자 지정 모듈 편집",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Parse using" => "Parse using",
// "Wiki Markup" => "Wiki Markup",
"Objects that can be included" => "포함될 수 있는 개체",
"Available polls" => "사용가능한 투표",
"Random active poll" => "무작위 활성 투표",
"Random current poll" => "무작위 현재 투표",
// "Use gallery" => "Use gallery",
"Random image from" => "다음에서 무작위 그림",
"Dynamic content blocks" => "유동 컨텐츠 블럭",
// "Use dynamic content" => "Use dynamic content",
"External feeds" => "외부 피드",
// "Use RSS module" => "Use RSS module",
"Banner zones" => "배너 구역",
// "Use banner zone" => "Use banner zone",
// "Use wiki structure" => "Use wiki structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes",
"To use a default Tiki menu" => "기본 티키 메뉴를 사용하려면",
"All Modules" => "모든 모듈",
"Show all modules" => "모든 모듈 보기",
"Requires" => "필수",
"Admin newsletter subscriptions" => "소식지구독 관리",
"Subscriptions" => "구독",
"Groups included through inheritance" => "상속을 통해 포함된 그룹들",
// "Remove subscription" => "Remove subscription",
"Wiki Page Name" => "위키 페이지 이름",
"Validate Addresses" => "주소 확인",
"Add To List" => "목록에 추가",
"Subscribed" => "구독된",
// "Mark subscription as valid" => "Mark subscription as valid",
"Unsubscribed" => "구독 해제 됨",
// "Remove selected subscriptions" => "Remove selected subscriptions",
"Add subscribers" => "구독자 추가",
"You can add several email addresses by separating them with commas" => "여러 개의 이메일을 쉼표로 구분하여 추가할 수 있습니다",
"Add email" => "이메일 추가",
"Add user" => "사용자 추가",
"Users from group" => "다음 그룹에서의 사용자",
"Group subscription also subscribes included groups" => "그룹 구독은 포함된 그룹들도 구독함",
// "Don't send confirmation email" => "Don't send confirmation email",
"The user email will be refreshed at each newsletter sending" => "사용자 이메일이 회보의 매 발송 시에 새로 고침될 것입니다",
"Import emails from file" => "파일에서 이메일 가져오기",
// ".txt file, one email per line" => ".txt file, one email per line",
// "Don't send confirmation emails" => "Don't send confirmation emails",
"Import emails from wiki page" => "위키 페이지에서 이메일 가져오기",
"Wiki page, one email per line" => "위키 페이지, 한 줄 당 한 개의 이메일",
// "Import emails from tracker" => "Import emails from tracker",
"Tracker:" => "트래커:",
"Subscribe group" => "그룹 구독",
"Including group inheritance" => "그룹 상속 포함",
"Including group, group users and emails will be refreshed at each newsletter sending" => "그룹, 그룹 사용자 및 이메일을 포함하는 것은 각 회보 전송시에 자동고침될 것입니다",
"Use subscribers of another newsletter" => "다른 회보를 구독자를 사용",
"Use emails from wiki page" => "위키 페이지에서 이메일 사용",
"Wiki page" => "Wiki페이지",
"Emails on a wiki page which will be added at each newsletter sending, one email per line" => "각 회보 발송 시에 추가될 위키 페이지 상의 이메일, 한 줄 당 한 개의 이메일",
"Don't subscribe emails" => "이메일을 구독하지 않습니다",
"Export Subscriber Emails" => "구독자 이메일 내보내기",
"Admin newsletters" => "회보 관리",
"List Newsletters" => "회보 목록",
"Send Newsletters" => "회보 보내기",
"Editions" => "판",
"Drafts" => "초안들",
"Last Sent" => "최종 발송",
// "Remove newsletter" => "Remove newsletter",
"Create/Edit Newsletters" => "회보 추가/변경",
"There are individual permissions set for this newsletter" => "이 회보에는 개별 권한들이 설정되어 있습니다",
"Users can subscribe/unsubscribe to this list" => "사용자가 이 목록에 구독/구독해지를 할 수 있음",
"Users can subscribe any email address" => "사용자는 어떠한 이메일주소라도 사용하여 구독할 수 있음",
"Add unsubscribe instructions to each newsletter" => "각 회보에 구독해지 방법설명 추가",
"Validate email addresses" => "이메일 주소 확인절차",
"Allow customized text message to be sent with the HTML version" => "사용자 지정 텍스트 메시지가 HTML 버전과 함께 전송되는 것을 허용",
"Allow clipping of articles into newsletter" => "회보로 기사의 클리핑을 허용",
"Automatically clip articles into newsletter" => "기사를 자동으로 회보로 클립",
// "Do not send newsletter if clip is empty" => "Do not send newsletter if clip is empty",
"Clip articles published in the past number of days" => "게재된 기사를 보관할 과거 날짜 수",
"Article types to clip" => "클리핑할 기사 종류",
"Mail notifications" => "메일 알림",
// "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => " 통지 추가",
// "Destination" => "Destination",
"Myself" => "내자신",
"Note that a user is not notified for his or her own action" => "사용자가 자신의 작업에 대하여서는 알림이 보내지지 않는다는 점에 주의하십시오",
"User / Group" => "사용자 / 그룹",
// "Delete mail notification event" => "Delete mail notification event",
// "Delete selected notification events" => "Delete selected notification events",
"Trackers Outbound Emails" => "트래커 아웃바운드 이메일",
"Forums Outbound Emails" => "게시판 아웃바운드 이메일",
// "OAuth Server" => "OAuth Server",
// "List of clients" => "List of clients",
// "Client_id" => "Client_id",
// "Client_secret" => "Client_secret",
// "Redirect_uri" => "Redirect_uri",
"Admin Polls" => "투표 관리",
"Preview poll" => "투표 미리 보기",
"Add poll option" => "투표 선택사항 추가",
"Edit poll option" => "투표 선택사항 편집",
"Poll options" => "투표 선택사항",
"Votes" => "투표",
"Set last poll as current" => "마지막 투표를 현재로 설정",
"Close all polls but last" => "마지막을 제외한 모든 투표 닫기",
"Activate all polls" => "모든 투표 활성화",
"Create poll" => "투표 만들기",
"Edit poll" => "투표 편집",
"active" => "활성",
"object" => "오브젝트",
"Toggle Quick Options" => "빠른 선택사항 토글",
"Add Option" => "새 선택사항 추가",
"Leave box empty to delete an option" => "선택사항을 삭제하려면 상자를 빈 채로 두십시오",
// "Votes older than x days are not considered" => "Votes older than x days are not considered",
"0 for no limit" => "제한 없음에 대하여 0",
"Results" => "결과",
"Add poll to pages" => "페이지에 투표 추가",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
"This menu shows only Polls with 'status': \"template\"" => "이 메뉴는 '상태': \"템플릿\"으로된 투표만 표시합니다",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "페이지 잠금",
// "Custom Route" => "Custom Route",
// "Add a new Custom Route" => "Add a new Custom Route",
// "Edit route settings" => "Edit route settings",
// "Edit route" => "Edit route",
// "Add a new route" => "Add a new route",
// "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value" => "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value",
// "The users will get redirected to the tracker item that has a field that matches the value found in the URL" => "The users will get redirected to the tracker item that has a field that matches the value found in the URL",
// "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10" => "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10",
// "Router Type" => "Router Type",
// "Check this option to set route as a Short URL" => "Check this option to set route as a Short URL",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "이 페이지는 티키에 의해 읽기/가져오기가 될 외부 피드의 설정을 구성하기 위한 페이지입니다. 피드를 생성/내보내기를 하려면, 관리 패널에서 \"피드\" 를 찾아보십시오, 혹은",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed" => "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed",
"Content for the feed" => "피드에 대한 컨텐츠",
// "Refresh All feeds" => "Refresh All feeds",
"Show Date" => "날짜 보기",
"Refresh rate" => "갱신 간격",
// "Article generator" => "Article generator",
"Edit Feed" => "피드 편집",
"Create Feed" => "피드 만들기",
"Create new external feed" => "새 외부 피드 만들기",
// "Show feed title" => "Show feed title",
"Show publish date" => "공개일 표기",
"Article Generator" => "기사 생성기",
// "Article Generator for %0" => "Article Generator for %0",
// "Once you have defined the settings below, each new item in this rss feed will generate a new article" => "Once you have defined the settings below, each new item in this rss feed will generate a new article",
// "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones" => "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones",
// "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content" => "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content",
"Use Article Submission System" => "기사 제출 시스템 사용",
"Expiration" => "만기",
"Publish in the future" => "미래에 게재",
"-1 to use original publishing date from the feed" => "피드에서 원 게시 날짜를 사용하려면 -1",
// "Custom Settings for Source Categories" => "Custom Settings for Source Categories",
// "No source categories detected for this feed" => "No source categories detected for this feed",
// "Source Category" => "Source Category",
// "Priority (10 is highest)" => "Priority (10 is highest)",
// "Categorize Created Articles" => "Categorize Created Articles",
"Configure" => "구성",
// "Add a new Scheduler" => "Add a new Scheduler",
// "Schedulers" => "Schedulers",
// "Run Time" => "Run Time",
// "Re-Run" => "Re-Run",
// "Edit scheduler settings" => "Edit scheduler settings",
// "Stalled" => "Stalled",
// "Run now" => "Run now",
// "Edit scheduler" => "Edit scheduler",
// "Add a new scheduler" => "Add a new scheduler",
// "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *" => "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *",
// "Run if missed" => "Run if missed",
// "Scheduler logs" => "Scheduler logs",
// "Last {\$numOfLogs} Logs" => "Last {\$numOfLogs} Logs",
// "Running" => "Running",
"Failed" => "실패함",
// "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>",
"Tiki settings" => "티키 설정",
"Tiki variable" => "티키 변수",
"Setting" => "설정",
"Risk Factor" => "위험 요소",
"Explanation" => "설명",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "위키 플러그인과 보안 정보: 신뢰할 수 있는 편집자들에게만 \"tiki_p_plugin_approve\" 권한을 허락한다는 것을 확인하십시오",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "(<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>) 에서 위험한 플러그인을 비활성화할 수 있습니다",
"You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "<a href=\"tiki-plugins.php\">tiki-plugins.php</a>에서 플러그인 사용을 승인할 수 있습니다",
"Security checks" => "보안 확인",
"Check all tiki files" => "모든 티키 파일 확인",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "주의할 점은 아주 오랜 시간이 걸린다는 것입니다. php.ini 의 max_execution_time 설정을 확인하십시오",
"File checks" => "파일 체크",
"Check file permissions" => "파일 권한 확인",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "이 확인과정은 문제가 있는 파일 권한을 가진 파일을 찾으려고 시도합니다. 여기에 문제가 있음으로 표시되는 어떤 파일 권한은 특정 환경에서 문제가 없거나 불가피한 것일 수도 있습니다.",
"See end of table for detailed explanations." => "상세한 설명에 대하여서는 테이블 끝 부분을 봐주십시오.",
"owner" => "소유자",
"special" => "특별",
"other" => "기타",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
"sticky" => "고정형",
// "r" => "r",
// "w" => "w",
"Set User ID (suid) files" => "사용자 ID (suid) 파일 설정",
"World writable files or directories" => "world 쓰기 가능한 파일 혹은 디렉터리",
"Files or directories the Webserver can write to" => "파일 혹은 웹서버가 쓸 수 있는 디렉터리들",
"Strange Inodes (not file, not link, not directory)" => "이상한 Inodes (파일 아님, 링크 아님, 디렉터리 아님)",
"Executable files" => "실행가능 파일",
"What to do with these check results" => "체크 결과에 대한 처리 방법",
"Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "suid 파일들은 티키의 일부가 아니며 웹스페이스 내부에서 suid 파일들에 대한 필요가 없습니다. 가끔 승강된 권한을 얻은 침입자들이 \"문을 열어두기\" 위하여 suid 파일들을 남겨둡니다",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information",
"Inodes that are not files or directories are not part of tiki. Review these Inodes" => "파일 혹은 디렉터리가 아닌 Inode들은 티키의 부분이 아닙니다. Inodes 다음의 Inode 들을 검토하십시오",
"Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "그 디렉토리들로부터 CGI 스크립트를 실행하도록 웹서버가 구성된 경우, executable bit를 설정하는 것은 위함할 수 있습니다. 일반 php 모듈 (아파치 용)을 사용하는 경우라면, php 스크립트와 티키 내부의 다른 파일들은 executable bit를 보유할 필요가 없습니다. chmod로 executable bit를 안전하게 제거할 수 있습니다",
"Admin Shoutbox Words" => "외침상자 단어 관리",
"Add Banned Word" => "차단 단어 추가",
"Are you sure you want to delete this word" => "이 단어를 삭제하시겠습니까",
// "Rebuild sitemap" => "Rebuild sitemap",
// "Submit the Sitemap" => "Submit the Sitemap",
// "You can submit the sitemap for processing in all major search engines using the following URL" => "You can submit the sitemap for processing in all major search engines using the following URL",
// "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap" => "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap",
// "Automate Sitemap generation" => "Automate Sitemap generation",
// "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t" => "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t",
// "Or you can use directly the command line" => "Or you can use directly the command line",
"XML Zip Import" => "XML Zip 가져오기",
"Feedback" => "피드백",
// "Structure created" => "Structure created",
"View Page" => "페이지 보기",
"Please Confirm" => "확인하십시오",
"You will remove structure" => "구조체를 삭제하게 됩니다",
"Destroy the structure leaving the wiki pages" => "구조체를 제거하지만 위키 페이지는 남겨둠",
"Destroy the structure and remove the pages" => "구조체를 제거하고 페이지를 삭제",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "다음 페이지들은 또한 다른 구조체의 일부라는 점에 유의하십시오. 접근 권한들이 (이 있다면) 충돌하지 않도록 확인하여 주십시오",
"The following pages have automatically been categorized with the same categories as the structure" => "다음 페이지들은 구조체와 동일한 범주로 자동으로 범주화 되었습니다",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "다음 페이지들은 범주가 있지만 구조체는 범주가 없습니다. 일관성을 위하여 페이지들을 범주화 해제하는 것을 고려해보십시오",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "다음 페이지들은 구조체가 속해있지 않은 범주에 속해있습니다. 일관성을 위하여 그들을 재범주화하는 것을 고려해보십시오",
// "Existing Structures" => "Existing Structures",
// "View Structure" => "View Structure",
"View structure" => "구조체 보기",
// "Export pages" => "Export pages",
// "Dump tree" => "Dump tree",
"Create WebHelp" => "웹도움말 만들기",
"View WebHelp" => "웹도움말 보기",
// "XML Zip" => "XML Zip",
"Perform action with selected" => "선택된 것으로 작업 수행",
// ".." => "..",
"Delete with the pages" => "페이지와 함께 삭제",
// "Create Structure" => "Create Structure",
"Alias" => "별칭",
"Tree" => "트리",
"Use single spaces to indent structure levels" => "구조체 레벨을 들여쓰기 하려면 한 개의 스페이스를 사용",
"Create New Structure" => "새 구조체 작성",
"Edit survey questions" => "설문질문 편집",
"Add a New Question" => "새 질문 추가",
"List Surveys" => "설문 나열",
"Survey Stats" => "설문 통계",
"This survey stats" => "이 설문 통계",
"Edit this Survey" => "이 설문 편집",
"Admin Surveys" => "설문 관리",
"Questions" => "질문",
"Question" => "질문",
"Answer is mandatory" => "답변은 필수사항입니다",
// "Required answers" => "Required answers",
// "Single choice using radio buttons" => "Single choice using radio buttons",
// "Example: \"one, two, many, lots\"" => "Example: \"one, two, many, lots\"",
// "(Use \"\\,\" to include a comma" => "(Use \"\\,\" to include a comma",
// "Multiple choice using checkboxes" => "Multiple choice using checkboxes",
"For a rate, you can give the maximum value" => "배율에 대하여, 최대값을 줄 수 있습니다",
// "Multiple choices of thumbnail from a file gallery, options contains Gallery ID" => "Multiple choices of thumbnail from a file gallery, options contains Gallery ID",
// "Example: 4" => "Example: 4",
// "Options are: rows,columns,toolbars" => "Options are: rows,columns,toolbars",
// "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)" => "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)",
// "For the 'short text' type, options are: columns" => "For the 'short text' type, options are: columns",
// "Example: 60" => "Example: 60",
// "A heading to go between questions. Options are newpage,tag" => "A heading to go between questions. Options are newpage,tag",
// "Example: y,h4" => "Example: y,h4",
"Options (if apply)" => "선택사항 (적용 경우)",
"Admin surveys" => "설문 관리",
"Create/Edit Surveys" => "설문 만들기/편집",
"Edit this Survey:" => "이 조사 변경:",
"Create New Survey" => "새 설문 만들기",
"There are individual permissions set for this survey" => "이 설문에는 개별 권한들이 설정되어 있습니다",
// "Synchronize Dev/Prod Servers" => "Synchronize Dev/Prod Servers",
// "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one" => "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one",
// "Remote Server Address" => "Remote Server Address",
// "Show diff" => "Show diff",
"Local" => "현지시간대",
"Remote" => "원격",
// "System Administration" => "System Administration",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "티키가 이상하게 작동한다면, 가장 먼서 시도해야 하는 것은 아래의 캐시를 삭제하는 것입니다. 또안 매우 중요한 것은 업그레이드 이후 캐시를 삭제하는 것입니다 (필요에 의하여 FTP/SSH 를 통하였을 경우).",
// "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>" => "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>",
"Clear cached content" => "캐시된 컨텐츠 삭제",
"Empty" => "비우기",
// "All user preference sessions" => "All user preference sessions",
// "Save directories" => "Save directories",
"Directories to save" => "저장할 디렉터리",
"Directory is not writeable" => "디렉터리가 쓰기 불가능입니다",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "ZIP" => "ZIP",
// "Generate zip" => "Generate zip",
"A zip has been written to %0" => "Zip 이 %0 에 작성되었습니다",
"Groups still used in the database but no more defined" => "데이터베이스 내에서 아직 사용되지만 더 이상 정의되지 않은 그룹들.",
"Admin Tokens" => "토큰 관리",
"List tokens" => "토큰 나열",
"Timeout" => "시간 제한",
// "Hits left" => "Hits left",
"Max hits" => "최대 방문수",
// "Create Temp User" => "Create Temp User",
// "Temp User Prefix" => "Temp User Prefix",
"Add new token" => "새 토큰 추가",
"Token successfully created" => "토큰이 성공적으로 만들어졌습니다",
"Full URL" => "전체 UIRL",
"Timeout in seconds (-1 for unlimited)" => "초단위의 시간제한 (무제한은 -1)",
"Maximum number of hits (-1 for unlimited)" => "방문의 최대 수 (무제한은 -1)",
"Groups (separated by comma)" => "그룹들 (쉼표로 구분)",
"View mode" => "보기 모드",
"Wiki and WYSIWYG" => "위키와 위지위그",
"Wiki only" => "위키만",
// "WYSIWYG (HTML mode)" => "WYSIWYG (HTML mode)",
// "WYSIWYG (wiki mode)" => "WYSIWYG (wiki mode)",
"Reset to Global" => "전역으로 재설정",
"Reset to defaults" => "기본으로 재설정",
"Formatting Tools" => "서식적용 도구",
"Plugin Tools" => "플러그인 도구",
"Edit tool" => "도구 편집",
"Wysiwyg Token" => "WYSIWYG 토큰",
"Custom Tools" => "사용자 지정 도구",
"Add a new custom tool" => "새 사용자 지정 도구 추가",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
"If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "티키 4로부터 업그레이드 한 후 이 페이지에 문제를 경험한 경우, 사용자 지정 도구 전체를 삭제하기 위하여 이 링크를 사용하십시오",
"Delete all custom tools" => "모든 사용자 지정 도구 삭제",
"Warning: There is no undo" => "경고: 실행 취소 안됨",
"List Articles" => "목록 표시",
"Add topic" => "토픽 추가",
"Notification Email" => "알림 이메일",
// "You will be able to add a notification email per article topic when you edit the topic after its creation" => "You will be able to add a notification email per article topic when you edit the topic after its creation",
"topic image" => "토픽 그림",
"Activate" => "활성화",
// "De-activate" => "De-activate",
"Remove with articles" => "기사들과 함께 제거",
// "Tracker Fields" => "Tracker Fields",
"Admin Tracker" => "트래커 관리",
// "Import Fields" => "Import Fields",
"Mandatory" => "필수",
"Save All" => "전체 저장",
"Remove Selected" => "선택항목 삭제",
"Export Selected" => "선택항목 내보내기",
"Subset Selection" => "하위집합 선택",
"Category Selection" => "범주 선택",
"Group Selection" => "그룹 선택",
// "Add Group" => "Add Group",
// "Press Enter for each group" => "Press Enter for each group",
// "At least two elements are required to create transitions. Additional tabs appear once the selection is completed" => "At least two elements are required to create transitions. Additional tabs appear once the selection is completed",
"Draw Transition Diagram" => "전이 다이어그램 그리기",
"Guards" => "가드",
"preserved" => "보관됨",
"No transitions" => "전이 없음",
"New / Edit" => "신규 / 편집",
"Edit <em>%0</em>" => "<em>%0</em> 편집",
"New transition" => "새 전이",
"Upon trigger, preserve the initial state" => "트리거가 되면, 기존 상태를 보존",
"Members" => "구성원",
"No guards on this transition" => "이 전에 상의 가드 없음",
"New Guard" => "새 가드",
"Exactly" => "정확히",
"States" => "주",
// "Body of POST request" => "Body of POST request",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "JSON 혹은 YAML 을 반환하는 웹서비스의 URL 을 입력하시오. 매개 변수는 백분율 표시 사이에 이름을 기입함으로써 지정될 수 있습니다. 예를 들면: %name%. %service% 및 %template% 은 예약된 키워드이며 사용될 수 없습니다.",
"Parameters (%name%)" => "매개 변수 (%name%)",
"Operation" => "작동",
// "%0 requires no parameter" => "%0 requires no parameter",
"Test Input" => "입력 테스트",
// "Bypass cache" => "Bypass cache",
"Response Information" => "응답 정보",
// "OIntegrate Version" => "OIntegrate Version",
"Not supported" => "지원되지 않음",
"Schema Version" => "스키마 버전",
"Schema Documentation" => "스키마 문서",
"Not specified, default used" => "지정되지 않음, 기본값 사용됨",
"Content Type" => "컨텐츠 종류",
"Not specified" => "지정되지 않음",
"Returned Data" => "반환된 데이터",
// "tuncated at approx. 1MB" => "tuncated at approx. 1MB",
"Proposed Templates" => "제안된 템플릿",
"Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "이 웹서비스에 등록합니다. 추후에 템플릿을 등록하는 것이 가능할 것입니다. 서비스명은 문자만 포함해야만 합니다",
"Register Service" => "등록 서비스",
"Registered Templates" => "등록된 템플릿",
"Engine" => "엔진",
"Output" => "출력",
// "Toggle template source" => "Toggle template source",
"Register Template" => "템플릿 등록",
// "Add New Group" => "Add New Group",
"Invitation List" => "초대 목록",
"List of existing groups" => "기존 그룹 목록",
"Inherits Permissions from" => "권한 상속을 받은 곳",
"User Choice" => "사용자 선택",
"Edit group" => "그룹 편집",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
// "Create group" => "Create group",
"Group is NOT being monitored. Click icon to START monitoring" => "그룹이 모니터 되고 있지 않습니다. 모니터링을 시작하려면 아이콘을 클릭하십시오",
"Group IS being monitored. Click icon to STOP monitoring" => "그룹이 모니터 되고 있습니다. 모니터링을 중지하려면 아이콘을 클릭하십시오",
// "Inheritance" => "Inheritance",
// "Permissions will be inherited from these groups" => "Permissions will be inherited from these groups",
// "Indirectly included groups" => "Indirectly included groups",
// "Group Home" => "Group Home",
"Use wiki page name or full URL" => "위키 페이지명 혹은 전체 URL 을 사용하십시오",
"For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "다른 티키 기능들은 티키 루트에 상대적 링크를 사용하십시오 (예를 들면 <em>/tiki-forums.php</em>)",
// "Default Category" => "Default Category",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
"Use site default" => "사이트 기본 사용",
// "Group color" => "Group color",
// "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color" => "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color",
"Group Information Tracker" => "그룹 정보 트래커",
// "choose a group tracker .." => "choose a group tracker ..",
// "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign" => "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign",
"choose a field .." => "필드를 선택하시오..",
// "Select the user selector field from the above tracker" => "Select the user selector field from the above tracker",
// "Go to trackers list" => "Go to trackers list",
// "User Registration Tracker" => "User Registration Tracker",
// "choose a user tracker .." => "choose a user tracker ..",
// "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign" => "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign",
// "Select user field" => "Select user field",
"Choose a field .." => "필드를 선택하시오..",
// "No fields in tracker .." => "No fields in tracker ..",
// "Select the user selector field from the above tracker to link a tracker item to the user upon registration" => "Select the user selector field from the above tracker to link a tracker item to the user upon registration",
// "No fields in this tracker" => "No fields in this tracker",
// "Go to tracker list" => "Go to tracker list",
// "User Wizard Fields" => "User Wizard Fields",
// "By default, the same fields as in registration are used" => "By default, the same fields as in registration are used",
// "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time" => "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time",
// "Group or User Tracker Registration Fields" => "Group or User Tracker Registration Fields",
// "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete" => "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete",
"User can assign himself or herself to the group" => "사용자는 그룹에 자신을 할당할 수 있음",
// "Membership expiry" => "Membership expiry",
// "Anniversary" => "Anniversary",
// "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date" => "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date",
// "Or" => "Or",
// "Number of Days" => "Number of Days",
// "Number of days after which all users will be unassigned from the group" => "Number of days after which all users will be unassigned from the group",
// "Pro-Rate Membership" => "Pro-Rate Membership",
// "Payment for membership extension is prorated at a minimum interval" => "Payment for membership extension is prorated at a minimum interval",
"Users are automatically assigned at registration in the group if their emails match the pattern" => "사용자들의 이메일이 다음 패턴에 일치하면 등록 시, 자동적으로 할당이 됨",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Assign Permissions" => "권한 할당",
"Group tracker item : {\$groupitemid}" => "그룹 트래커 항목 : {\$groupitemid} ",
"Edit Item" => "항목 편집",
"Group tracker item not found" => "그룹 트래커 항목 발견되지 않음",
// "</i>\"}%0 members" => "</i>\"}%0 members",
// "Assigned" => "Assigned",
"Edit user" => "사용자 편집",
// "Remove from group" => "Remove from group",
// "No members" => "No members",
// "Add or ban users" => "Add or ban users",
"Add to group" => "그룹에 추가",
// "Ban from group" => "Ban from group",
// "</i>\"}Users banned from %0" => "</i>\"}Users banned from %0",
// "Banned members" => "Banned members",
"Unban user" => "사용자 차단 해제",
// "Unban user %0 from group %1" => "Unban user %0 from group %1",
// "No banned members" => "No banned members",
// "</i>\"}%0 import/export" => "</i>\"}%0 import/export",
// "Export group users (CSV file)" => "Export group users (CSV file)",
"Charset encoding" => "문자집합 인코딩",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Import users to group (CSV file)" => "Import users to group (CSV file)",
// "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "새 사용자 추가",
"Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "이 티키사이트가 슬레이브 모드에 있으며 그룹들을 가져오기 때문에, 매스터 그룹들은 매 로그인시 자동적으로 다시 가져오기 됩니다",
"Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "이 티키 사이트가 슬레이브 모드에 있고 선호설정을 가져오기 때문에, 각 로그인 시 마스터 사용자 선호설정이 자동으로 다시 가져오기 됨",
"Number of displayed rows" => "표기될 행 수",
"More Criteria" => "추가 조건",
"Group (direct)" => "그룹 (직접)",
"Email not confirmed" => "이메일이 확인되지 않음",
"User not validated" => "사용자 인증되지 않음",
// "OpenID" => "OpenID",
// "Edit account settings" => "Edit account settings",
// "N" => "N",
"Registered %0 ago" => "%0 일 전 등록됨",
"Need to validate email" => "이메일을 유효화할 필요있음",
// "Edit this included group" => "Edit this included group",
// "Add or remove from a group" => "Add or remove from a group",
// "Edit group expiry" => "Edit group expiry",
"Change user preferences" => "사용자 선호설정 변경",
// "Switch to this user" => "Switch to this user",
// "Validate user" => "Validate user",
// "Invalidate user" => "Invalidate user",
// "Remove link with OpenID for this user" => "Remove link with OpenID for this user",
"Remove link with OpenID account" => "OpenID 계정과 함께 링크 제거",
// "Remove users.." => "Remove users..",
// "Ban IPs" => "Ban IPs",
// "Change group assignments" => "Change group assignments",
// "Set default groups" => "Set default groups",
// "Send wiki page content by email" => "Send wiki page content by email",
// "Warning: User Encryption is Active" => "Warning: User Encryption is Active",
// "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted" => "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted",
"Assign user to Groups" => "사용자를 그룹에 할당",
// "Intertiki Enabled" => "Intertiki Enabled",
// "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"" => "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"",
"Use the email as username" => "이메일을 사용자명으로 사용합니다",
// "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames" => "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames",
// "Changing username is disabled for Intertiki sites" => "Changing username is disabled for Intertiki sites",
"No password is required" => "비밀번호가 요구되지 않음",
"Tiki is configured to delegate the password managment to LDAP" => "티키는 LDAP로 비밀번호 관리를 위임하도록 구성되었습니다",
"New password" => "새비밀번호",
// "Confirm new password" => "Confirm new password",
"User must change password at next login" => "사용자는 다음 로그인 시 반드시 비밀번호를 변경해야만 합니다",
"Send an email to the user to enable him or her to validate their account." => "사용자 계정을 유효화 하기 위하여 사용자에게 이메일을 보냅니다",
// "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>",
// "Add a user tracker item for this user" => "Add a user tracker item for this user",
// "User tracker" => "User tracker",
// "View item" => "View item",
// "Modify this user\\'s data" => "Modify this user\\'s data",
"Pass confirmed" => "통과 확인됨",
"Email confirmed" => "이메일 확인됨",
"%0 days ago" => "%0 일 전",
"Current Login" => "현재 로그인",
"You do not have permission to edit this user" => "이 사용자를 편집할 권한이 없습니다",
// "Your file should contain in the first row (first entry) the following fields" => "Your file should contain in the first row (first entry) the following fields",
// "user1,pass1,email1,group1,group1" => "user1,pass1,email1,group1,group1",
// "user2,pass2,email2,\"group1,group2\",group1" => "user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time" => "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time",
// "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any" => "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any",
// "Existing Users" => "Existing Users",
"Don't overwrite" => "덮어쓰지 않음",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "The user must change his or her password the first time they log in" => "The user must change his or her password the first time they log in",
// "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>" => "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>",
// "Temporary Users" => "Temporary Users",
// "Token Access Feature Dependency" => "Token Access Feature Dependency",
// "The token access feature is needed for Temporary Users to login" => "The token access feature is needed for Temporary Users to login",
// "Turn it on here" => "Turn it on here",
// "Feature Conflict" => "Feature Conflict",
// "This feature currently is incompatible with the \"Use email as username\" feature" => "This feature currently is incompatible with the \"Use email as username\" feature",
// "Turn it off here" => "Turn it off here",
// "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature" => "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature",
// "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token" => "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token",
// "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself" => "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself",
// "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms" => "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms",
// "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails" => "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails",
// "To revoke access before validity expires or to review who has access, please see" => "To revoke access before validity expires or to review who has access, please see",
// "Email addresses (comma-separated)" => "Email addresses (comma-separated)",
// "Valid for days (use -1 for forever)" => "Valid for days (use -1 for forever)",
// "Username prefix" => "Username prefix",
// "Autologin (non-SEFURL) path" => "Autologin (non-SEFURL) path",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences",
"Add Type" => "유형 추가",
"Add article type" => "기사 유형 추가",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
"View articles with this type" => "이 유형의 기사 보기",
"Show before publish date" => "출판 일자 이전에 표기",
"Show after expire date" => "만료 일자 이후 표기",
"Heading only" => "제목만",
"Comment can rate article" => "댓글이 기사에 등급을 부여 가능",
"Show image" => "그림 표시",
"Show profile picture" => "아바타 표기",
"Show expire date" => "만료 일자 표기",
"Show reads" => "열람수 표기",
"Show size" => "크기 표시",
"Show topline" => "최상단줄 표기",
"Show subtitle" => "부제목 표기",
"Show source" => "소스 표기",
"Show image caption" => "그림 캡션 보기",
"Creator can edit" => "만든이는 편집할 수 있습니다",
"Custom attribute" => "사용자 지정 속성",
"Assign User %0 to Groups" => "%0 님을 그룹으로 할당",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"backlinks to" => "다음으로의 역방향 연결",
"No backlinks to this page" => "이 페이지에 백링크 없음",
"Directory batch upload" => "디렉터리 일괄 업로드",
"Browse Gallery" => "갤러리 열람",
"Upload From Disk" => "디스크에서 업로드",
"available images" => "사용가능한 그림",
"Filesize" => "파일 크기",
"Filetype" => "파일유형",
"Remove File Extension from Image Name" => "그림 이름에서 파일 확장자 제거",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "예. \"digicam0001.jpg\" 에서 이름 digicam0001 이 이름 필드에 대하여 사용될 것입니다",
"Convert the last sub directory to a sub gallery" => "마지막 하위 디렉터리를 하위 갤러리로 변환",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "예. \"misc/screenshots/digicam0001.jpg\" 에서 \"screenshots\" 라는 이름의 갤러리가 만들어질 것임",
"Use the last sub directory name as description" => "설명으로써 마지막 하위 디렉터리명 사용",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "예. \"misc/screenshots/digicam0001.jpg\" 에서 \"screenshots\" 이란 설명이 만들어 질 것임",
"Select a Gallery" => "갤러리 선택",
"Process" => "절차",
"Browse File Gallery" => "파일 갤러리 탐색",
"Please do not use this feature to upload data into the database" => "데이터베이스로 데이터를 업로드하기 위하여 이 기능을 사용하지 말아 주십시오",
"Available Files" => "사용가능한 파일",
// "File Permissions" => "File Permissions",
// "File is writable" => "File is writable",
// "File is not writable" => "File is not writable",
"Total: %0" => "전체: %0",
"Select a File Gallery" => "파일 갤러리 선택",
"Root" => "루트",
// "Upload into galleries according to sub-directories" => "Upload into galleries according to sub-directories",
// "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists" => "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists",
// "Create sub-galleries" => "Create sub-galleries",
// "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set" => "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set",
// "Upload into galleries according sub-directory as galleryId" => "Upload into galleries according sub-directory as galleryId",
// "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists" => "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists",
"Process files" => "파일 처리",
"Edit Post" => "포스트 편집",
"New Post" => "새 게시물",
"View post" => "게시물 보기",
"View Blog" => "블로그 열람",
"Note: Remember that this is only a preview, and has not yet been saved" => "주의: 이는 단지 미리보기라는 점과 아직 저장되지 않았다는 점을 기억하십시오,",
"Excerpt" => "출처",
"Admin the Category System" => "범주 시스템 관리",
"Browse in:" => "다음에서 탐색:",
// "or in" => "or in",
"Image galleries" => "그림 갤러리",
"Trackers Items" => "트래커 항목",
"Sheets" => "시트",
"Find in" => "다음 안에서 찾기",
// " in the current category and its subcategories" => " in the current category and its subcategories",
"Hide subcategories objects" => "하위범주 개체들 숨기기",
"Show subcategories objects" => "하위범주 개체 보기",
// "Up one level" => "Up one level",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
// "Clear tags" => "Clear tags",
"With all selected tags" => "모든 선택된 태그들과 함께",
"With one selected tag" => "선택된 태그만 함께",
"With last selected tag" => "최종 선택된 태그와 함게",
"More Popular Tags" => "추가 인기 태그",
"Alphabetically" => "알파벳순으로",
"By Size" => "크기로",
"Cloud" => "클라우드",
// "{\$feature_label}" => "{\$feature_label}",
// "Filter in" => "Filter in",
"All blogs" => "모든 블로그",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
// "Delete Tag" => "Delete Tag",
"Browsing Gallery:" => "갤러리 둘러보기:",
// "Gallery actions" => "Gallery actions",
"List Galleries" => "갤러리 목록",
"Edit Gallery" => "갤러리 편집",
"Upload Image" => "그림 업로드",
"Directory Batch" => "디렉터리 일괄",
"List Gallery" => "갤러리 목록",
"All Images" => "모든 그림",
"Rebuild Thumbnails" => "미리보기 rebuild",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "그림 분류 방식",
"subgallery" => "하위갤러리",
"Subgallery" => "하위갤러리",
// "Original size" => "Original size",
"rotate right" => "오른쪽으로 회전",
"You can view this gallery's configured image (first, random, etc.) in your browser using:" => "다음을 이용하여 브라우저에서 이 갤러리의 설정에 의한 그림을 (첫 번째, 임의, 등등) 볼 수 있습니다:",
"You can include the gallery's image in an HTML page using:" => "다음을 이용하여 HTML 페이지에서 갤러리의 그림을 포함할 수 있습니다:",
"You can include the image in a tiki page using:" => "다음을 이용하여 티키 페이지에서 그림을 포함할 수 있습니다:",
"Browsing Image" => "그림 열람",
"Return to Gallery" => "갤러리로 돌아가기",
"Edit Image" => "그림 편집",
"Bigger" => "더 크게",
// "Slideshow forward" => "Slideshow forward",
// "Repeat" => "Repeat",
"Click to zoom" => "확대/축소하려면 클릭",
"Image Name" => "그림이름",
"Image size" => "그림 크기",
"Image Scale" => "그림 배율",
"Original Size" => "원래 크기",
"Move image" => "그림이동",
"Include the image in a tiki page using the following syntax" => "다음 구문을 사용하는 티키 페이지 내부에 그림 포함",
"To include the image in an HTML page" => "HTML 페이지 내부에 그림을 포함하려면",
"To link to this page from another tiki page" => "다른 티키 페이지에서 이 페이지로 링크를 하려면",
// "Monitoring" => "Monitoring",
"Visible Calendars" => "보기 허용된 달력",
"Group Calendars" => "그룹 달력",
"Export calendars" => "달력 내보내기",
"advanced parameters" => "고급 매개 변수",
"Export as iCal" => "iCal로 내보내기",
"January" => "1월",
"February" => "2월",
"March" => "3월",
"April" => "4월",
"May" => "5월",
"June" => "6월",
"July" => "7월",
"August" => "8월",
"September" => "9월",
"October" => "10월",
"November" => "11월",
"December" => "12월",
"Jan." => "1월",
"Feb." => "2월",
"Mar" => "3월",
"Apr." => "4월",
"Aug." => "8월",
"Sep." => "9월",
"Oct." => "10월",
"Nov." => "11월",
"Dec." => "12월",
"Sun" => "일",
"Mon" => "월",
"Tue" => "화",
"Wed" => "수",
"Thu" => "목",
"Fri" => "금",
"Sat" => "토",
"today" => "오늘",
// "semester" => "semester",
// "quarter" => "quarter",
"all-day" => "종일",
"Organized by" => "이끌이",
"Classification" => "분류",
"View this Week" => "이 주 보기",
"Change Focus" => "촛점 변경",
"View this Day" => "이 날 보기",
"Calendar event : " => "달력 이벤트",
"New event" => "새 이벤트",
"View event" => "이벤트 보기",
"Edit/Delete event" => "이벤트 편집/만들기",
// "Export Event as iCal" => "Export Event as iCal",
"Edit Calendar Item" => "달력 아이템편집",
"New Calendar Item" => "달력 아이템새작성",
"Recurrence" => "재발생",
"This event depends on a recurrence rule" => "이 이벤트는 반복 규칙의 의존합니다",
"ending by" => "다음까지 종료",
"ending after" => "다음 이후 종료",
"events" => "이벤트",
// "(%0 events have been manually modified)" => "(%0 events have been manually modified)",
// "(%0 event has been manually modified)" => "(%0 event has been manually modified)",
"This event is not recurrent" => "이 이벤트는 반복적이지 않습니다",
"On a weekly basis" => "주 기반",
"Each" => "각각",
"of the week" => "주",
"On a monthly basis" => "월 기반",
"of the month" => "달",
"On a yearly basis" => "연 기반",
// "of" => "of",
"Starting on" => "시작일",
"Start period" => "시작 기간",
// "End Period" => "End Period",
"End after" => "다음 이후 종료",
"occurrences" => "발행수",
"occurrence" => "발행수",
"End before" => "다음 이전 종료",
"Event occurs once on" => "이벤트는 다음에 한 번 발생합니다",
"Event is repeated" => "이벤트는 반복됩니다",
"times" => "번",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "매달",
"on each" => "각각에 대하여",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
"starting" => "시작 중",
"ending" => "종료 중",
"Show duration" => "기간 보기",
"Events cannot end before they start" => "이벤트는 그들이 시작하기 전에 종료할 수 없습니다",
"No description" => "설명 없음",
"or new" => "혹은 신규",
"Choose users to alert" => "알림을 보낼 사용자 선택",
"Withdraw me from the list of participants" => "참여자 목록으로부터 나를 제외",
"Add me to the list of participants" => "참여자의 목록에 본인 추가",
"Roles" => "역할",
"chair" => "의석",
"default role" => "기본 역할",
"required participant" => "필수 참석자",
"optional participant" => "선택적 참여자",
"non-participant" => "비 참여자",
"Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in" => "쉼표로 구분된느 참여자 목록을 주십시오. 역할은 다음에서처럼 열에 의해 구분되는 접두어가 주어져야만 합니다",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
"If no role is provided, default role will be \"Chair participant\"" => "역할이 제공되지 않은 경우, 기본 역할은 \"Chair particpant\"가 될 것입니다",
"Update this event only" => "이 이벤트만 갱신",
"Update every unchanged event in this recurrence series" => "이 반복 규칙의 변경되니 않은 모든 이벤트 갱신",
"Update every event in this recurrence series" => "이 반복 규칙의 모든 이벤트 갱신",
"Delete event" => "이벤트 삭제",
"Delete recurrent events" => "반복 이벤트 삭제",
"Calendar import" => "달력 가져오기",
"Calendar has been updated" => "달력이 갱신되었습니다",
"%0 column name can be used instead of %1" => "%0 열 이름이 %1 대신 사용될 수 있습니다",
"import" => "가져오기",
// "Previous {\$viewmode|escape}" => "Previous {\$viewmode|escape}",
// "D" => "D",
"W" => "주",
"M" => "월",
// "Next {\$viewmode|escape}" => "Next {\$viewmode|escape}",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
"Advanced parameters for iCal export" => "iCal 내보내기를 위한 고급 매개 변수",
"Calendars to be exported" => "내보내기 될 달력",
"Export calendars iCal" => "달력 iCal 내보내기",
"Export calendars CSV" => "달력 CSV 내보내기",
"Your account has been validated" => "계정이 유효화 됨",
"You have to choose a password to use this account" => "이 계정을 사용하려면 비밀번호를 선택해야 합니다",
// "Change password" => "Change password",
// "Set password" => "Set password",
// "Old Password" => "Old Password",
// "Repeat Password" => "Repeat Password",
"MySQL or MariaDB Database Properties" => "MySQL 혹은 MariaDB 데이터베이스 속성",
// "Acknowledge (OK)" => "Acknowledge (OK)",
"Property" => "속성",
"Tiki Fitness" => "티키 적합도",
// "Acknowledge" => "Acknowledge",
// "New database engine" => "New database engine",
// "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki" => "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki",
// "MySQL crashed Tables" => "MySQL crashed Tables",
"Be careful" => "조심하십시오",
// "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure" => "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure",
// "Test sending emails" => "Test sending emails",
// "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>" => "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>",
"Server Information" => "서버 정보",
"Server Properties" => "서버 속성",
// "Special directories" => "Special directories",
// "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>" => "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>",
"Fitness" => "적합성",
// "Directory is writeable" => "Directory is writeable",
"Apache properties" => "아파치 속성",
"IIS properties" => "IIS 속성",
"PHP scripting language properties" => "PHP 스크립팅 언어 속성",
// "Change PHP configuration values" => "Change PHP configuration values",
// "{\$php_sapi_info.message}" => "{\$php_sapi_info.message}",
// "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>" => "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>",
// "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>" => "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>",
"PHP Security properties" => "PHP 보안 속성",
// "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>" => "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>",
// "Tiki Security" => "Tiki Security",
// "Sensitive Data Exposure" => "Sensitive Data Exposure",
// "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information",
// "Print configurations" => "Print configurations",
// "mPDF Information" => "mPDF Information",
// "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print" => "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print",
// "File Gallery Search Indexing" => "File Gallery Search Indexing",
// "More information %0 here %1" => "More information %0 here %1",
// "Command Missing" => "Command Missing",
// "The command \"shell_exec\" is required for file gallery search indexing" => "The command \"shell_exec\" is required for file gallery search indexing",
// "Mimetype" => "Mimetype",
// "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable" => "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable",
"MySQL Variable Information" => "MySQL 변수 정보",
"PHP Info" => "PHP 정보",
// "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>" => "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>",
// "Benchmark PHP/MySQL" => "Benchmark PHP/MySQL",
// "Check" => "Check",
// "BOM Detected Files" => "BOM Detected Files",
// "Scanned files" => "Scanned files",
// "BOM files detected" => "BOM files detected",
// "No BOM files detected" => "No BOM files detected",
// "TRIM" => "TRIM",
// "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>" => "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>",
// "Requirements" => "Requirements",
// "OS not supported" => "OS not supported",
// "Apparently tiki is running on a Windows based server. This feature is not supported natively" => "Apparently tiki is running on a Windows based server. This feature is not supported natively",
// "User Data Encryption" => "User Data Encryption",
// "MCrypt encryption found in users data preferences" => "MCrypt encryption found in users data preferences",
// "Found %0 user(s) with data preferences encrypted with MCrypt" => "Found %0 user(s) with data preferences encrypted with MCrypt",
// "No user preferences were found with data encrypted with MCrypt" => "No user preferences were found with data encrypted with MCrypt",
// "Tiki Packages" => "Tiki Packages",
// "OCR Status" => "OCR Status",
"Please choose the language for this page:" => "이 페이지의 언어를 선택하여 주십시오:",
"Choose language" => "언어 선택",
"Contact Us" => "문의하기",
"Send a message to us" => "저희에게 메시지를 보내주십시오",
"Your email" => "귀하의 이메일",
"Contact us by email" => "이메일로 문의",
"Click here to send us an email" => "저희에게 이메일을 보내시려면 여기를 클릭",
"Send another message" => "다른 메시지 전송",
"Contacts" => "연락처",
"Group View" => "그룹 보기",
"Create/edit contacts" => "연락처추가/변경",
"First Name" => "이름",
"Last Name" => "성",
"Nickname" => "별명",
"Publish this contact to groups" => "이 연락처를 그룹에 게재",
// "Extra Fields" => "Extra Fields",
"Copy page" => "페이지 복사",
"Invalid page name" => "유효하지 않은 페이지 제목",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "지정된 페이지명이 허용되지 않은 캐릭터를 포함합니다. 다음 캐릭터들이 삭제되지 않으면 페이지를 저장하는 것이 불가능합니다: <strong>/?#[]@\$&+;=<></strong>",
"The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "지정하신 페이지 제목에 포함된 캐릭터로하여금 페이지로의 접근이 어려워지도록 만들 수 있습니다. 다음의 캐릭터를 삭제하는 것을 고려해 보십시오: <strong>/?#[]@\$&+;=<></strong>",
"Use this name anyway" => "이 이름 사용을 강행",
// "New name" => "New name",
// "Duplicate tags" => "Duplicate tags",
"Quick Create Multilanguage Pages" => "다국어 페이지를 빠르게 만들기",
"Following pages were created, as translations of each other" => "다음 페이지들은 각자 서로의 번역물로써 만들어졌습니다",
"Following pages were not created" => "다음 페이지들은 만들어지지 않았습니다",
"page already exists" => "펴이지 이미 존재함",
"Enter the names of a new page page in various languages" => "새 페이지의 이름을 다양한 언어로 입력하십시오",
"Preferred languages" => "선호 언어",
"Other languages" => "다른 언어",
"Create pages" => "페이지 만들기",
"View generated WebHelp" => "생성된 웹도움말 보기",
"No structure" => "구조체 없음",
"Top page" => "상위 페이지",
"Add a new site" => "새 사이트 추가",
"You cannot add sites until Directory Categories are setup" => "디렉터리 범주가 설정되기 전까지 사이트를 추가할 수 없습니다",
"Please contact the Site Administrator" => "사이트 관리자에게 연락해 주십시오",
"<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">지금 디렉터리 범주 추가</a>",
"Site added" => "사이트 추가됨",
"The following site was added, but may require validation by the admin before appearing on the lists." => "다음 사이트가 추가되었습니다, 하지만 목록에 나타나기 전에 관리자 승인이 요구될 수도 있습니다.",
"Edit a site" => "사이트 편집",
"Add a site" => "사이트 추가",
"Directory Categories" => "디렉터리 범주",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Admin Directory" => "디렉터리 관리",
// "There are" => "There are",
"invalid sites" => "유효하지 않은 사이트",
"valid sites" => "유효한 사이트",
"Users have visited" => "사용자들이 다음을 방문했습니다",
"sites from the directory" => "디렉터리에서의 사이트",
"Users have searched" => "사용자가 검색했습니다",
"times from the directory" => "디렉터리에서 번",
"Validate" => "활성화확인",
"Admin directory categories" => "디렉터리 범주 관리",
"Parent directory category:" => "부모 디렉터리 범주:",
// "Parent directory category" => "Parent directory category",
"Add a directory category" => "디렉터리 범주 추가",
"Edit this directory category:" => "이 디렉토리 범주 변경:",
"Add a Directory Category" => "디렉터리 범주 추가",
"Child type" => "자식종류",
"Most visited directory sub-categories" => "가장 방문이 많은 디렉터리 하위범주",
"Directory category description" => "디렉터리 범주 설명",
"Random directory sub-categories" => "랜덤 디렉터리 하위 범주",
// "Maximum number of child directory categories to show" => "Maximum number of child directory categories to show",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Editor group" => "Editor group",
"Directory Subcategories" => "디렉터리 하위범주",
// "cType" => "cType",
"allow" => "허가",
"count" => "수",
"editor" => "편집자",
// "Relate" => "Relate",
"Admin related directory categories" => "연관 디렉터리 범주 관리",
"Add a related directory category" => "관련 디렉터리 범주 추가",
"Directory Category" => "디렉터리 범주",
"Mutual" => "상호",
"Related directory categories" => "관련 디렉터리 범주",
"Admin sites" => "사이트관리",
"Is valid" => "유효함",
"New Sites" => "신규등록된 사이트",
"Popular Sites" => "근사한 사이트",
"Directory:" => "디렉터리:",
"any" => "또는",
"in entire directory" => "모든 디렉토리에서",
"in current directory category" => "현재의 디렉토리 카테고리에서",
"Sort by" => "분류항목",
"Hits (desc)" => "방문수 (내림차순)",
"Hits (asc)" => "방문수 (오름차순)",
"Last updated (desc)" => "최종 갱신됨 (내림)",
"Last updated (asc)" => "최종 갱신됨 (오름)",
"sort" => "정렬",
"No records" => "기록 없음",
"Total directory categories:" => "총 디렉토리 범주 수:",
"Total links" => "모든링크수",
"Links to validate" => "유효확인할 링크",
"Searches performed:" => "수행된 검색 수:",
"Total links visited:" => "방문된 링크의 총합:",
"Directory ranking" => "디렉토리 등급",
"Validate sites" => "사이트들 확인",
"country" => "국가",
"Discounts" => "할인",
// "{\$prefs.payment_currency|escape}" => "{\$prefs.payment_currency|escape}",
// " or " => " or ",
"Maximum time the discount can be used in the first phase of payment" => "지불의 첫 단계에 사용될 수 있는 할인의 최대 회수",
"-1 for unlimited" => "무제한에 대하여 -1",
"Translation of this page is incomplete" => "이 페이지의 번역은 완료되지 않았습니다",
"To add <strong>new content</strong> to the page" => "페이지에 <strong>새 컨텐츠</strong>를 추가하려면",
"use the editor" => "편집기 사용",
"Edit article" => "기사 편집",
"View Articles" => "기사 읽기",
"Allow full HTML" => "full HTML 을 헝용",
"Keep any HTML tag" => "어떤 HTML 태그도 유지",
"If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "활성화되지 않은 경우, 티키는 HTML 태그들의 일부 (a, p, pre, img, hr, b, i) 를 유지할 것입니다",
// "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
// "{\$typei|escape}" => "{\$typei|escape}",
// "Click \"Preview\" after selecting article type to have appropriate edit form fields" => "Click \"Preview\" after selecting article type to have appropriate edit form fields",
// "Publication" => "Publication",
// "If checked, the article is published" => "If checked, the article is published",
// "User (article owner)" => "User (article owner)",
"Time" => "시간",
"Own Image" => "자체 그림",
"If not the topic image" => "토픽 그림이 아닌 경우",
// "Max file size : {\$prefs.article_image_file_size_max/1000} KB" => "Max file size : {\$prefs.article_image_file_size_max/1000} KB",
"Current Image" => "현재 그림",
"Article image" => "기사 그림",
"Image caption" => "그림 캡션",
// "Default will use the topic name" => "Default will use the topic name",
"Use own image" => "자체 그림 사용",
"Float text around image" => "텍스트를 그림 주위에 배치",
// "Read Article" => "Read Article",
// "Maximum dimensions of custom image in view mode" => "Maximum dimensions of custom image in view mode",
// "Maximum dimensions of custom image in list mode" => "Maximum dimensions of custom image in list mode",
"Attach existing article ID as translation" => "기존 기사 ID 를 번역으로 첨부",
"Topline" => "톱라인",
// "http://.." => "http://..",
// "Test your link: " => "Test your link: ",
"Apply content template" => "컨텐츠 템플릿 적용",
// "{\$template.name|escape}" => "{\$template.name|escape}",
"Email addresses to be sent notifications (comma-separated)" => "알림이 보내질 이메일 (쉼표로 분리)",
"Cancel the edit (changes will be lost)" => "편집 취소하면 변경 내역을 잃어버리게 됩니다",
// "Create or edit banners" => "Create or edit banners",
"List banners" => "배너 나열",
"URL to link the banner" => "배너를 링크할 URL",
"Client" => "클라이언트",
"Maximum impressions" => "최대 광고 노출",
"Maximum number of impressions for a user" => "사용자에 대한 최대 광고 노출",
"Maximum clicks" => "최대 클릭",
"URIs where the banner appears only" => "배너만 나타나는 URI",
"Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "각각의 URI를 # 문자로 둘러쌓아 입력하십시오. 예:#/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear" => "URIs where the banner will not appear",
"Or, create a new zone" => "혹은, 새 구역을 만듭니다",
// "New Zone" => "New Zone",
"Show the banner only between these dates" => "이 날짜들 사이에서만 배너 표시",
"From date" => "시작일",
"To date" => "종료일",
"Use dates" => "날짜 사용",
// "Show the banner only in these hours" => "Show the banner only in these hours",
"Show the banner only on" => "배너를 다음에서만 표시",
"Select ONE method for the banner" => "배너에 대한 한 방식을 선택하십시오",
"Use Image" => "그림 사용",
// "Use Image from URL" => "Use Image from URL",
// "(the image will be requested at the URL for each impression)" => "(the image will be requested at the URL for each impression)",
"Use Flash" => "플래시 사용",
"Movie Size" => "동영상 크기",
// "width in pixels" => "width in pixels",
"Pixels" => "픽셀",
// "height in pixels" => "height in pixels",
"FlashPlugin min version" => "플래시플러그인 최소 버전",
"ex" => "예",
// "Use Text" => "Use Text",
"Save the Banner" => "배너 저장",
"Remove zones (info entered for any banner in the zones will be lost)" => "확대/축소 제거 (배너에 대한 입력된 정보를 손실합니다)",
"Edit Blog" => "블로그 편집",
"A category is mandatory" => "범주는 필수적입니다",
"Individual permissions are set for this blog" => "이 블로그에는 개별 권한들이 설정되어 있습니다",
"Allow other users to post in this blog" => "이 블로그에 다른 사용자가 게시하는 것을 허용",
"Even if others post to the blog, the author is always its administrator" => "만약 다른 사용자가 블로그에 게시하면, 저자를 항상 소유자로 한다",
"Allow search" => "검색 허용",
"Allow comments" => "댓글 허용",
"Use post excerpt" => "게시 발췌물 표기",
"Display Options" => "표기 선택사항",
// "Displayed posts" => "Displayed posts",
"Number of posts to show per page" => "페이지 당 표기될 게시 수",
"Display the blog title on the posts list page" => "게시 목록 페이지에 블로그 제목 표기",
"Display the blog title on the post page" => "게시 페이지 내부에 블로그 제목 표기",
"Display the blog description" => "블로그 설명 표기",
"Display breadcrumbs" => "사이트 이동경로 표기",
"Display the author in blog posts" => "블로그 게시에 저자 표기",
"Display the publish date in blog posts" => "블로그 게시에 출판된 날짜 표기",
"Show user profile picture" => "사용자 아바타 표기",
"Show the post's related content" => "게시 관련 내용물 표기",
"The checkbox is disabled because the tags feature is disabled globally" => "feature_freetags 가 전역적으로 비활성화 되어있어서 체크상자가 비활성화 되었습니다",
// "Related posts" => "Related posts",
"Maximum number of related posts to display" => "표기될 관련 게시의 최대 숫자",
"Blog heading" => "블로그 제목",
"Heading preview" => "제목 미리보기",
"Blog post heading" => "블로그 게시물 제목",
"Organizer" => "이끌이",
"Move objects between categories" => "개체를 범주들간 이동",
"Click on the category name to display the list of objects in that category" => "나열하려는 범주 이름에 클릭하십시오. 해당 범주 안의 개체의 목록 보이게 됩니다",
"Select the objects to affect. Controls will appear in the category browser" => "영향을 미치기를 원하는 개체를 선택하십시오. 제어는 범주 브라우저내에 표시될 것입니다",
"Use the plus and minus signs to add or remove the categories on selected objects" => "선택된 개체에 범주를 추가 혹은 삭제를 위하여 더하기와 빼기 표시를 사용",
// "Object list result" => "Object list result",
// "Select objects to change categorization" => "Select objects to change categorization",
"More results are available. Please refine the search criteria" => "추가 결과 사용가능. 검색 조건을 세밀화 하십시오",
"Select all" => "전부 선택",
"Unselect all" => "모두 선택해제",
"The file will be saved in" => "파일은 다음 안에 저장될 것입니다",
// "Currently trying" => "Currently trying",
"Try" => "시도",
// "Missing Package" => "Missing Package",
// "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package" => "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package",
// "Please contact the Administrator to install it" => "Please contact the Administrator to install it",
"Tiki Docs" => "티키 문서",
"Save file" => "파일 저장",
"Cancel editing file" => "파일 편집 취소",
"Editing file" => "파일 편집 중",
"Save and Back" => "저장 및 뒤로",
"Rename" => "이름변경",
"Toggle Fullscreen" => "전체화면 토글",
"More information" => "추가 정보",
"Wiki Page Editor" => "위키 페이지 편집기",
"More help on editing wiki pages" => "위키 페이지를 편집하는데 추가 도움",
"The syntax system used for creating pages in Tiki" => "티키 내부에 페이지를 만드는 데 사용되는 구문분석 시스템",
"Bold text" => "굵은체 텍스트",
"Italic text" => "기울임꼴 텍스트",
"single quotes" => "한 개의 인용구",
"Underlined text" => "밑줄쳐진 텍스트",
"Colored text" => "색깔있는 텍스트",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "지정된 HTML 색상 혹은 색상명을 사용하여 표시할 것임. 색상명은 쉼표로 구분된 두 색상을 포함할 수 있음. 이 경우, 첫 색상은 전면이고 두 번째는 배경임",
"Deleted text" => "삭제된 텍스트",
"2 dashes" => "대시 2개",
"Headings" => "제목",
"show/hide heading section. + (shown) or - (hidden) by default" => "제목 섹션 표시/숨김 + (표시) 혹은 - (숨김) 이 기본",
"Autonumbered Headings" => "일련번호 추가된 제목들",
"{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} 은 구조체 (toc) 혹은or ! headings (maketoc) 에 기반하여 현재 페이지의 목차를 인쇄합니다",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "maketoc에 대한 공용 선택적 매개변수는: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename",
"Horizontal rule" => "가로 눈금자",
"Text box" => "텍스트 상자",
"Box content" => "상자 내용",
"Centered text" => "가운데 정렬된 텍스트",
"Inserts an editable variable" => "편집가능한 변수를 삽입합니다",
"External links" => "외부 링크",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "외부 위키에 대하여, ExternalWikiName:PageName 혹은 ((External Wiki Name: Page Name)) 을 사용하십시오",
"Square Brackets" => "대괄호",
"Use [[foo] to show [foo]" => "[foo] 라고 표기하려면 [[foo] 를 사용",
"JoinCapitalizedWords or use" => "첫글자가 대문자인 단어를 여백없이 묶거나 다음을 사용",
// "page|description" => "page|description",
"for wiki references" => "위키 참조 용",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
"for wiki heading/anchor references" => "위키 제목/앵커 참조 용",
"SomeName" => "어떤이름",
"prevents referencing" => "참조 방지",
"Lists" => "목록",
"for bullet lists" => "글머리 기호 목록용",
"for numbered lists" => "번호매겨진 목록용",
"definition" => "정의",
"for definiton lists" => "정의 목록 용",
"Indentation" => "들여쓰기",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "각 더하기에 대하여 들여쓰기를 만듬 (목록 안에서 동급 상에서 계속할 시 유용함)",
"Tables" => "표",
"row" => "행",
"col" => "열",
"Monospace font" => "고정 폭 폰트",
"Code sample" => "코드 샘플",
"(very useful especially in tables)" => "(표에서 특히 매우 유용함)",
"Multi-page pages" => "여러 페이지",
"to separate pages" => "페이지를 구분하려면",
"Non-parsed sections" => "구문 분석되지 않은 부분",
"data" => "데이터",
"Prevents wiki parsing of the enclosed data" => "밀폐된 데이터의 위키 구문분석 금지",
"Preformated sections" => "사전서식 적용된 부분",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ 사전 서식적용된 텍스트/코드를 표기합니다; 이 부분 내부에서는 위키 처리가 되지 않습니다 (np 와 마찬가지입니다), 그리고 간격은 고정되어 있습니다 (자동 줄바꿈이 되지 않습니다). ~pre~ data ~/pre~ 는 또한 고정 간격으로 사전 서식 적용된 텍스트를 표기합니다, 하지만 텍스트 상에서 위키 처리가 여전히 이루어집니다",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ 티키 댓글 ~/tc~ 은 티키 댓글을 만듭니다.  표시에서 완전히 삭제될 것입니다, 하지만 추후 참조를 위하여 파일에 저장됩니다.  ~hc~ HTML 댓글 ~/hc~ 은 HTML 댓글을 만듭니다.  출력 HTML 안에 주석으로 삽입됩니다; 이들은 일반적으로 브라우저에서 표기되지 않습니다만 \"소스 보기\" 혹은 유사한 기능을 통하여 볼 수 있습니다",
"Block Preformatting" => "블록 사전서식적용",
"Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "텍스트를 다른 위키 서식적용 지침을 여전히 따르는 고정폭 블럭으로 변환하기 위하여 어떤 수의 스페이스만큼 들여쓰기합니다. 귀하가 사용한 스페이스와 동일한 수 만큼 들여쓰기 될 것입니다. 이 모드는 간격과 줄 바꿈을 정확히 유지하지 않는다는 점에 유의하십시오; 그에 대하여서는 ~pp~...~/pp~ 를 사용하십시오",
"Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew" => "우에서 좌 및 좌에서 우 텍스트 방향 DIV (텍스트의 끝까지)와 언어에 대한 표식자를 아랍어인지 히브리어로 입력합니다",
"Special characters" => "특수 문자",
"hard space" => "하드 공간",
"numeric between ~ for HTML numeric characters entity" => "HTML 숫자 문자 엔터티에 대한 ~ 사이의 숫자",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "플러그인 인수는 따옴표로 (&quot;) 둘러쌓여질 수 있다는 점에 주의하십시오; 이는 그 안에 , 혹은 = 혹은 &gt 를 안에 포함하는 것을 허용합니다",
"More help here" => "여기에 추가 도움말이 있습니다",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "위키 플러그인은 위키 문법의 기능을 좀 더 특화된 명령어들로 확장합니다",
"Activate/deactivate plugins" => "플러그인 활성화/비활성화",
"No description available" => "제공되는 설명 없음",
"For more information, please see" => "추가 정보는 다음을 살펴보십시오",
"WYSIWYG Editor" => "Wysiwyg 편집기",
"More help on WYSIWYG editing" => "WYSIWYG 편집에 추가 도움",
// "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>" => "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar",
// "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered" => "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered",
// "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around" => "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around",
// "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "이미지 탐색",
"Edit successful" => "편집 성공",
"The following image was successfully edited" => "다음의 그림이 성공적으로 편집되었습니다",
"Image Description" => "그림 설명",
"Upload from disk to change the image" => "그림을 변경하기 위하여 디스크에서 업로드",
"Save and Go Next" => "저장 및 다음으로 이동",
"Edit Invoice" => "청구서 편집",
"Invoice Number" => "청구 번호",
"Date Issued" => "발행된 날자",
"Work Description" => "작업 설명",
"Taxable" => "세금 부과가능",
"New Item" => "새 항목",
"Invoice Note" => "청구 메모",
"Save Invoice" => "청구서 저장",
"Customized String Translation" => "사용자 지정된 문자열 번역",
// "Manage local translations in a custom.php file" => "Manage local translations in a custom.php file",
// "Download language.php file for the selected language" => "Download language.php file for the selected language",
// "Download Database Translations" => "Download Database Translations",
// "Download a file with all the translations in the database for the selected language" => "Download a file with all the translations in the database for the selected language",
// "Translations in the database will be merged with the other translations in language.php for the selected language" => "Translations in the database will be merged with the other translations in language.php for the selected language",
"Add a translation" => "번역 추가",
"Untranslated strings" => "번역안된 문자열",
"Show only database stored untranslated strings" => "데이터베이스에 저장된 번역안된 문자열만 보기",
"Edit translations" => "번역 편집",
"Show only database stored translations" => "데이터베이스에 저장된 번역만 보기",
"Original:" => "원본:",
"Translation:" => "번역:",
// "Original string" => "Original string",
"Last changed by %0 on %1" => "%0 님께서 %1 에 마지막으로 변경함",
// "Contribute" => "Contribute",
"Undecided" => "결정되지 않음",
// "Save translation in the database" => "Save translation in the database",
// "Delete translation from the database" => "Delete translation from the database",
"Compare" => " 비교",
// "Compare the original translation with the database translation" => "Compare the original translation with the database translation",
// "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes" => "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes",
"Translate all" => "전체 번역",
"Delete all" => "전체 삭제",
"Are you sure you want to delete all untranslated strings from database?" => "데이터베이스에서 모든 번역되지 않은 문자열을 삭제하시려는 것이 맞습니까?",
"Are you sure you want to delete all translations from database?" => "데이터베이스에서 모든 번역을 삭제를 하시려는 것이 맞습니까?",
"Return to the default perspective" => "기본 perspective 로 돌아가기",
"Switch to" => "다음으로 전환",
// "Preference List" => "Preference List",
// "Search preferences below and drag them into the preference list above" => "Search preferences below and drag them into the preference list above",
"Program dynamic content for block" => "블럭에 대한 프로그램 유동 컨텐츠",
"Create New Block" => "새 블럭 만들기",
"Return to block listing" => "차단 나열로 복귀",
"Block description: " => "블럭 설명",
"You are editing block" => "블럭을 편집 중입니다",
// "Publising Date" => "Publising Date",
"Publishing Date" => "게재될 날짜",
"Edit question options" => "질문 옵션 편집",
"List Quizzes" => "퀴즈 목록",
"Quiz Stats" => "퀴즈 통계",
"This Quiz Stats" => "이 퀴즈 통계",
"Edit this Quiz" => "이 퀴즈 편집",
"Admin Quizzes" => "퀴즈 관리",
"Create/edit options for question" => "질문에 대한 선택사항 만들기/편집",
"points" => "점수",
"Quiz can be repeated" => "퀴즈는 반복될 수 있습니다",
// "Time Limit" => "Time Limit",
"Create/edit quizzes" => "퀴즈 작성/변경",
"There are individual permissions set for this quiz" => "이 퀴즈에는 개별 권한들이 설정되어 있습니다",
"Store quiz results" => "퀴즈 결과 저장",
"Quiz is time-limited" => "퀴즈는 시간 제한되어 있습니다",
"Maximum time" => "최대 시간",
"Passing Percentage" => "통과 백분율",
// "%" => "%",
"Edit quiz questions" => "퀴즈 질문 편집",
"Create/edit questions for quiz" => "퀴즈에 대한 질문 만들기/편집",
"Question Type" => "질문 유형",
"Import questions from text" => "텍스트에서 질문 가져오기",
// "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct" => "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct",
"Input" => "입력",
"Maximum score" => "최고점수",
"Edit quiz results" => "퀴즈 결과 편집",
"From Points" => "발신 점수",
"To Points" => "점수로",
"Reports" => "보고서",
"Report Builder" => "보고서 작성기",
"Report Type" => "보고서 종류",
"Select Report Type" => "보고서 종류 선택",
"Wiki Data" => "위키 데이터",
"Export As CSV" => "CSV 로 내보내기",
"You will remove" => "다음을 삭제하게 됩니다",
"and its subpages from the structure, now you have two options" => "그리고 구조체로부터의 이것의 하위페이지들, 이제 2개의 선택사항이 있습니다",
"and its subpages from the structure" => "그리고 구조체로부터의 이것의 하위페이지들",
// "Remove from structure" => "Remove from structure",
// "Remove from structure and remove page too" => "Remove from structure and remove page too",
"The page already exists. The page that has been added to the structure is the existing one" => "페이지가 이미 존재합니다. 구조체에 추가된 페이지가 기존 페이지입니다.",
"The following pages added have automatically been categorized with the same categories as the structure" => "다음의 추가된 페이지들은 구조체와 동일한 범주로 자동적으로 범주화되었습니다",
"Structure Layout" => "구조체 레이아웃",
// "Monitor the structure" => "Monitor the structure",
// "Stop Monitoring the structure" => "Stop Monitoring the structure",
"Add pages" => "페이지 추가",
"Use an existing page by dragging it into the structure above" => "기존페이지를 위의 구조체로 드래깅함으로써 사용",
// "{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "구조체의 모든 페이지들을 같이 범주화",
"Remove existing categories from ALL pages before recategorizing" => "재범주화 이전에 모든 페이지에서 기존 범주들 제거",
"Move to another structure" => "다른 구조체로 이동",
"at the beginning" => "시작에서",
"at the end" => "마지막에서",
"Submit article" => "기사 투고",
"List submissions" => "투고기사 목록",
"Use ...page... to separate pages in a multi-page post" => "여러 페이지에 걸친 포스팅에서 페이지를 구분하려면 ...page... 를 사용하십시오",
// "Fields with <b>*</b> are optional" => "Fields with <b>*</b> are optional",
"<b>Topline</b>=small line above Title" => "<b>Topline</b>=제목 위의 작은 줄",
"<b>Subtitle</b>=small line below Title" => "<b>부제목</b>=제목 및의 작은 줄",
"<b>Source</b>=URL to article source" => "<b>소스</b>=기사 소스로의 URL",
"Author Name" => "작성자",
"Own image size x" => "자체 그림 크기 x",
"Own image size y" => "자체 그림 크기 y",
"Auto-Approve Article" => "기사 자동 승인",
"View template" => "템플릿 보기",
"Template listing" => "템플릿 표시",
"Available templates" => "사용가능한 템플릿",
"Important" => "중요",
// "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme" => "테마 내부에만 저장",
"Delete the copy in the theme" => "테마 내부의 사본 삭제",
"Admin Article Topics" => "기사 토픽 관리",
// "Edit article topic" => "Edit article topic",
"Admin notifications" => "알림 관리",
// "Enter email addresses " => "Enter email addresses ",
"View Article" => "기사 보기",
"Attach or detach existing translations of this page" => "이 페이지의 기존 번역을 첨부 혹은 분리",
// "Manage Translations" => "Manage Translations",
"You must specify the object language" => "개체 언어를 반드시 지정해야 합니다",
"The object doesn't exist" => "그 개체는 존재하지 않습니다",
"The object doesn't have a language" => "그 개체는 언어가 없습니다",
"The object already has a translation for this language" => "그 개체는 이 언어에 대하여 이미 번역을 보유하고 있습니다",
"The object is already in the set of translations" => "그 개체는 이미 번역 세트 내부에 있습니다",
"Translate this page to a new language" => "새 언어로 이 페이지 번역",
"Select language to translate to" => "번역될 언어 선택",
"Enter the page title" => "페이지 제목을 입력하시오",
// "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
"Create translation" => "번역 만들기",
"Change language for this page" => "이 페이지에 대한 언어 변경",
"Change Language" => "언어 변경",
// "You forgot to specify the language of the translation. Please choose a language in the picklist" => "You forgot to specify the language of the translation. Please choose a language in the picklist",
"The page already exists. It was selected in the list below." => "\"페이지가 이미 존재합니다. 아래의 목록에서 선택되었습니다\"",
"No language is assigned to this page" => "이 페이지에 할당된 언어 없음",
"Please select a language before translating" => "번역을 수행하기 전에 언어를 선택하여 주십시오",
// "Set Page Language" => "Set Page Language",
// "Edit %0" => "Edit %0",
"Update '{\$page}'" => "'{\$page}' 갱신",
// "{\$customTip|escape}" => "{\$customTip|escape}",
"Preview your changes" => "변경내역 미리보기",
"Draft written on" => "초안 작성일",
"Warning: new versions of this page have been made after this draft" => "경고: 이 페이지의 새 버전이 이 드래프트 버전 이후 만들어졌습니다",
"The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page" => "모래상자는 편집 스킬 연습용 페이지 입니다. 페이지의 외형을 미리보기하려면 미리보기 기능을 사용하십시오. 이 페이지의 어떤 버전도 저장되지 않습니다",
// "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)" => "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)",
"An edit summary is mandatory" => "편집 요약은 필수사항입니다",
"Translate from" => "번역 원문",
"Changes that need to be translated are highlighted below" => "번역되어야할 변경내역이 아래 하이라이트 표기됨",
"No comment" => "댓글 없음",
"All Versions" => "모든 버전",
"Edit wiki page" => "위키 페이지 편집",
"Select the style used to display differences to be translated" => "번역될 차이점을 표시하기 위하여 사용될 스타일을 선택하십시오",
"text full" => "텍스트 가득참",
"Change the style used to display differences to be translated" => "번역될 차이점들을 표기하기 위해 사용될 스타일 변경",
"Change diff styles" => "diff 스타일 변경",
"Page name:" => "페이지명:",
"Translate to" => "다음으로 번역",
"Reproduce the changes highlighted on the left using the editor below" => "아래의 편집기를 사용하여 좌측에 하이라이트 된 변경을 재생",
"Describe the change you made" => "변경 내역을 설명해 주십시오",
"Edit comment: Enter some text to describe the changes you are currently making" => "댓글 편집: 현재 작업 중인 변경사항을 설명할 텍스트를 약간 입력하십시오",
// "Monitor this page" => "Monitor this page",
"Upload picture" => "그림 업로드",
"Add another image" => "다른 그림 추가",
"Categorization has been preset for this edit" => "범주가 이 편집에 대해서 사전설정됨",
"Categories will be inherited from the structure top page" => "범주가 구조체 상위 페이지에서 상속될 것임",
// "Leave page and go to..." => "Leave page and go to...",
// "Wiki Preferences" => "Wiki Preferences",
// "Copyright notices" => "Copyright notices",
// "Copyright page" => "Copyright page",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Lock this page" => "이 페이지 잠금",
"Allow comments on this page" => "이 페이지에 댓글 허용",
// "HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "HTML tags are used to create elements of the wiki page, instead of being displayed as code",
"Try to convert HTML to wiki" => "HTML을 위키로 변환 시도",
"Import page" => "페이지 가져오기",
// "Export page" => "Export page",
// "Export all versions" => "Export all versions",
// "Attach file" => "Attach file",
"Only cache a page if it should look the same to all groups authorized to see it" => "페이지를 보도록 승인된 모든 그룹에 동일하게 보여야하는 경우에만 페이지를 캐시합니다",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
"Site default" => "사이트 기본",
"as Creator &amp; Last Editor" => "만든이 &amp; 마지막 편집자로써",
"no (disabled)" => "아니오 (비활성화됨)",
"Description (used for metatags)" => "설명 (메타태그에 대하여 사용됨)",
"My Footnotes" => "내 각주",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template" => "사용가능한 투표 템플릿이 없습니다",
// "Please ask an administrator to create one" => "Please ask an administrator to create one",
// "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "번역 요청",
"Send urgent translation request" => "긴급 번역 요청 전송",
// "Geolocation" => "Geolocation",
// "Show page title" => "Show page title",
"Explicit Namespace" => "분명한 네임스페이스",
"The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace" => "페이지에 대한 네임스페이스는 페이지명에서 자동적으로 추측되어집니다. 하지만, 몇몇 예외사항이 발생할 수 있습니다. 이 선택사항은 네임스페이스를 재정의하는 것을 허용합니다",
// "Page layout" => "Page layout",
// "Site Default" => "Site Default",
// "{\$title}" => "{\$title}",
"List Sheets" => "시트 목록",
"Graph" => "그래프",
"Export to file" => "파일로 내보내기",
"Autodetect" => "자동감지",
"Admin FAQ" => "FAQ 관리",
"List FAQs" => "FAQ 목록",
"View FAQ" => "FAQ 표시",
"Edit this FAQ" => "이 FAQ 편집",
"New Question" => "새 질문",
"Edit FAQ question" => "FAQ 질문 편집",
"Add FAQ question" => "FAQ 질문 추가",
"Use a question from another FAQ" => "다른 FAQ 의 질문을 사용",
"FAQ questions" => "FAQ 질문모음",
"Suggested questions" => "제안된 질문",
"No suggested questions" => "질문된 제안 없음",
"File Archive" => "파일 보관",
"Size (width x height)" => "크기 (넓이 x 높이)",
"Content waiting for approval" => "승인을 위해 대기 중인 컨텐츠",
"You are currently viewing the latest version of the page" => "현재 페이지의 최신 버전을 보고 계십니다",
"You can also view the {self_link}latest approved version{/self_link}" => "{self_link}최신 승인된 버전{/self_link}을 볼 수도 있습니다",
"You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "이 수정버전을 승인하고 더 광범위한 청중에게 사용가능하도록 만들 수 있습니다. 승인 전에 모든 변경을 반드시 검토하십시오",
"Show changes since last approved revision" => "최종 승인된 수정 버전 이후 변경 표시",
"This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "이 페이지는 사전 승인된 수정버전이 없습니다. <strong>모든 컨텐츠가 검토되어야만 합니다.</strong>",
"Approve current revision" => "현재 수정내역 승인",
// "Reject current revision" => "Reject current revision",
"You are currently viewing the approved version of the page" => "현재 페이지의 승인된 버전을 보고 계십니다",
"You can also view the {self_link latest=1}latest version{/self_link}" => "{self_link latest=1}최신 버전{/self_link}을 볼 수도 있습니다",
"View the {self_link latest=1}latest version{/self_link}" => "{self_link latest=1}최신 버전{/self_link} 보기",
"Forum Importer" => "게시판 가져오기 도구",
"Import from a Local SQL File" => "로컬 SQL 파일에서 가져오기",
"Forum Type" => "게시판 유형",
"DB Prefix" => "DB 접두어",
"Local SQL Filename on Server (path will be stripped)" => "서버의 로컬 SQL 파일명 (경로는 제거됨)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "반드시 tikiroot/{\$tmpdir} 혹은 tikiroot/img/wiki_up 내부에 있어야 함",
"Get Forum List" => "게시판 목록 얻기",
"Verification" => "인증",
"File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "파일은 반드시 SQL 파일이어야 하며 <i>\$tikiroot/temp</i> 혹은 <i>\$tikiroot/img/wiki_up</i> 중에 존재해야만 합니다",
"File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "파일이 지정되지 않았거나 어느 위치에서도 발견될 수 없었습니다. 파일을 그 중 하나의 디렉터리에 넣고 돌아가십시오. 파일이 양 위치에 존재하는 경우, \$tikiroot/{\$filecheck} 위치가 선호될 것입니다",
"Proceed" => "진행",
"Go Back" => "뒤로 가기",
"Select a Forum You Wish to Move (ONE at a time!)" => "이동을 원하는 게시판 선택 (한 번에 하나씩!)",
"Which Forum Do You Wish to Import this Into" => "이것을 어느 게시판으로 가져오기를 할까요",
// "Refresh list" => "Refresh list",
"Edit queued message" => "대기중 메시지 편집",
// "Make this a thread of" => "Make this a thread of",
"None, this is a thread message" => "없음. 이것은 대화목록 메시지입니다",
"summary" => "요약",
"Announce" => "발표",
"Hot" => "뜨거움",
"no feeling" => "느낌 없음",
"frown" => "찌푸림",
"exclaim" => "감탄사",
"idea" => "아이디어",
"mad" => "미친",
"neutral" => "중립",
"question" => "질문",
"sad" => "슬픔",
"happy" => "행복",
"wink" => "윙크",
"Save and Approve" => "저장 및 승인",
// "Convert to topic" => "Convert to topic",
"New Topic" => "새 토픽",
"no summary" => "요약 없음",
"No messages queued yet" => "아직 대기상태 메시지 없음",
"Search by name" => "이름으로 검색",
"Search in content" => "컨텐츠 내에서 검색",
"Last Post" => "마지막 게시",
// "{\$section|escape}" => "{\$section|escape}",
// "No forums found" => "No forums found",
// "Loading" => "Loading",
"Reported by" => "보고자",
"Perfom action with checked" => "체크된 것으로 작업 수행",
"Un-report" => "보고 취소",
"Tag translation" => "태그 번역",
// "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated" => "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated",
// "Show checkboxes" => "Show checkboxes",
"There are no tags on this page in your preferred languages" => "이 페이지에는 귀하의 선호 언어로 된 태그가 없습니다",
"Set language" => "언어 설정",
"Universal" => "유니버설",
// "Displayed languages" => "Displayed languages",
"Friendship Network" => "친구 네트워크",
"Galleries" => "갤러리",
"Create New Gallery" => "새 갤러리 만들기",
// "Migrate Images to File Gallery" => "Migrate Images to File Gallery",
"Create a gallery" => "갤러리 만들기",
"Edit this gallery:" => "이 갤러리 변경：",
"There are individual permissions set for this gallery" => "이 갤러리에는  개별 권한들이 설정되어 있습니다",
"Gallery is visible to non-admin users?" => "갤러리가 관리자 아닌 사용자에게 보이도록 합니까?",
"Max Rows per page:" => "페이지당 최고 줄 수:",
"Thumbnails size X" => "축소보기 크기 X",
"Thumbnails size Y" => "축소보기 크기 Y",
"Default sort order:" => "기본 분류 순서:",
"Fields to show during browsing the gallery:" => "갤러리 탐색 중 보이는 항목:",
"XY-Size" => "XY-크기",
"Gallery Image" => "갤러리 그림",
"Available scales" => "사용가능한 배율",
"Global default" => "전역 기본",
"Bounding box" => "경계 상자",
"default scale" => "기본 배율",
// "Default scale" => "Default scale",
"No scales available" => "제공되는 배율 없음",
"Original image is default scale" => "그림 원본은 기본 배율입니다",
"Add scaled images with bounding box of square size" => "외각 상자와 함께 정사각형 크기로 조절된 그림 추가",
"Other users can upload images to this gallery" => "다른 사용자가 이 갤러리에 그림을 업로드할 수 있습니다",
"You can access the gallery using the following URL" => "다음 URL을 사용하여 갤러리에 접근할 수 있습니다",
"Available Galleries" => "갤러리 목록",
"Choose a filter" => "필터를 선택",
"Imgs" => "그림",
// "Make map" => "Make map",
"Select Graphic Type" => "그래픽 유형 선택",
"Pie Chart" => "파이 차트",
"Multiline" => "여러 줄",
"Multibar" => "여러 바",
"Bar Stack" => "바 스택",
"Independant Scale" => "들여쓰기 배율",
"Horizontal Scale" => "가로 배율",
"Vertical Scale" => "세로 배율",
"Series" => "시리즈",
"Edit Spreadsheet" => "스프레드시트 편집",
"List Spreadsheets" => "스프레드시트 나열",
"Wiki plug-in" => "위키 플러그인",
"Spreadsheet History" => "스프레드시트 역사",
"Roll back" => "롤백",
"Toggle Full Screen" => "전체화면 토글",
"Date Selection" => "날짜 선택",
"Edit Date" => "날짜 편집",
"View Spreadsheet" => "스프레드시트 보기",
"Clone Spreadsheet" => "스프레드시트 복제",
"Roll back spreadsheet" => "스프레드시트 롤백",
"Import From File" => "파일에서 가져오기",
// "File to import" => "File to import",
"Grab Wiki Tables" => "위키 테이블 가져오기",
"Import pages from a Structured Text Dump" => "구조체화된 텍스트 덤프에서 페이지 가져오기",
"Name of the dump file (it has to be in dump/)" => "덤프 파일의 이름 (dump/ 내에 있어야 함)",
"Overwrite existing pages if the name is the same" => "이름이 동일할 경우 기존 페이지 덮어쓰기",
// "Remove previously existing page versions" => "Remove previously existing page versions",
"excerpt" => "출처",
"Result" => "결과",
"body" => "본문",
"Name of the zip file on the server" => "서버 상의 ZIP 파일명",
"Tiki Importer" => "티키 가져오기 도구",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer!" => "새 티키 설치를 실행 중이 아니라면, 가져오기 도구를 사용하기 전에 데이터베이스의 백업을 만드십시오!",
"If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature." => "페이지가 XML 코드를 포함하고 있다면, HTML purifier 가 삭제할 것입니다. 이 기능을 비활성화 하십시오.",
"Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "귀하의 PHP는 안전모드가 활성화된 상태로 실행중입니다. 이는 어떤 PHP 설정에서는 안전모드가 실행 시간을 변경할 가능성을 제한하기 때문에 가져오기 프로세스에 문제를 야기할 수도 있습니다 (예 max_execution_time). 이 스크립트를 안전 모드 없이 실행하는 것을 추천합니다",
"Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)." => "소스 소프트웨어로부터의 파일 크기에 따라, 가져오기 절차는 완료하는 데 시간이 다량 소요될 수 있습니다. 이는 귀하의 PHP 및 웹 서버 설정과 관련되어 있을 수도 있습니다. 이 스크립트는 관련 설정을 변경하려 시도하지만 스크립트가 변경할 수 없는 설정도 있습니다. 그래서, 스크립트와 문제가 발생한다면, 다음 PHP 설정값을 증가하는 것을 시도해 보십시오: max_input_time, max_execution_time (이 설정은 웹서버 설정에 의하여 제한됩니다, 만약 아파치를 실행 중이라면 Timeout 설정도 변경하십시오), post_max_size, upload_max_filesize, memory_limit. 이 설정 값들을 (필요하다면) 변경할 수 있는 서버에서 이 스크립트를 실행하는 것을 추천합니다.",
"Select the software to import from:" => "가져오기를 할 소트프웨어 선택:",
"Select.." => "선택..",
"WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "경고: 스크립트를 실행하기 전에 백업여부를 확인하십시오. 백업이 없다면, 지금이 취소 버튼을 클릭함으로써 가져오기를 취소할 마지막 기회입니다",
"Congratulations! You have successful imported your data to Tiki" => "축하합니다! 데이터를 성공적으로 티키로 가져오기 하였습니다",
"%0 pages imported from a total of %1" => "%0 페이지들이 총 %1에서 가져옴",
"%0 pages imported" => "%0 페이지들이 가져오기됨",
"(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(<a href=\"tiki-listpages.php\">여기</a> 에서 사이트의 위키 페이지들의 목록을 볼 수 있습니다)",
"%0 posts imported" => "%0 게시물들이 가져옴",
"%0 tags imported" => "%0 태그들 가져옴",
"%0 categories imported" => "%0 범주들이 가져옴",
"Importer log" => "가져오기 기록",
"Suggested .htaccess rules" => "제안된 .htaccess 규칙",
"Tiki Wiki CMS Groupware" => "티키 위키 CMS 그룹웨어",
"Installation" => "설치",
"Tiki Icon" => "티키 아이콘",
"Tiki Project Web Site" => "티키 프로젝트 웹사이트",
"Support Forums" => "지원 게시판",
"Welcome" => "환영합니다",
// "Welcome to the <strong>Tiki %0</strong> installer" => "Welcome to the <strong>Tiki %0</strong> installer",
// "Use this script to install a new database or upgrade your existing database" => "Use this script to install a new database or upgrade your existing database",
"For the latest information about this release, please read the" => "이 출시판에 대한 최신 정보는 다음을 읽어보십시오",
"Release Notes" => "출시 메모",
"For complete documentation, please visit" => "전체 설명서에 대하여서 다음을 방문하십시오",
"For more information about Tiki, please visit" => "티키에 대한 추가 정보는, 다음을 방문하십시오",
"Select your language" => "언어를 선택하시오",
// "License" => "License",
"Tiki is software distributed under the LGPL license" => "티키는 LGPL 라이센스로 배포되는 소프트웨어입니다",
"Review the System Requirements" => "시스템 요구사항을 검토하십시오",
// "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements",
"This installer will perform some basic checks automatically" => "이 설치기는 자동으로 몇몇 기본 검사를 실행합니다",
"Please see: " => "다음을 살펴보십시오:",
"a detailed report about your server" => "서버에 관한 상세 보고서",
"Memory" => "메모리",
"Tiki has not detected your PHP memory_limit" => "티키는 귀하의 PHP memory_limit을 감지하지 못하였습니다",
"This probably means you have no set limit (all is well)" => "이는 아마도 제한이 설정하지 않았다는 것 (전부 허용된다) 을 의미합니다 ",
"Tiki has detected your PHP memory limit at" => "티키가 발견한 귀하의 PHP 메모리 한도",
"Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "티키는 스크립트 실행을 위하여 PHP 메모리 <strong>최소</strong> 128MB 를 요구합니다",
"Allocating too little memory will cause Tiki to display blank pages" => "너무 작은 메모리를 할당하면 티키가 빈화면을 표기하게 될 것입니다",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "메모리 제한을 변경하려면 <strong>php.ini </strong> 파일 내부의 <strong>memory_limit</strong> 키를 사용하십시오 (예를 들면: memory_limit = 128M) 그리고 웹서버를 재시작하십시오",
"Tiki has detected your PHP memory_limit at" => "티키가 감지한 귀하의 PHP memory_limit",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "티키는 메일 알림 및 메시지를 발송하기 위하여 PHP <strong>메일</strong> 기능을 사용합니다",
"To test your system configuration, Tiki will attempt to send a test message to you" => "시스템 구성을 테스트하기 위하여 티키가 귀하께 테스트 메시지 발송을 시도할 것입니다",
"Test email" => "이메일 테스트",
// "tiki@example.com" => "tiki@example.com",
"Email address to send test to" => "테스트를 보낼 이메일 주소",
"Copy test mail to " => "테스트 메일을 다음으로 복사",
"Send Test Message" => "테스트 메시지 전송",
"Tiki was able to send a test message to" => "티키가 다음으로 테스트 메시지를 발송할 수 있었습니다",
"Tiki was not able to send a test message" => "티키가 테스트 메시지를 발송할 수 없었습니다",
"Review your mail log for details" => "상세내역을 위하여 메일 로그를 검토하십시오",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "귀하의 <strong>php.ini</strong> 파일내부의 메일설정을 검토하십시오 (예를 들면: <strong>sendmail_path</strong> 이 올바른지 확인하십시오)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "귀하의 호스트가 SMTP 인증을 요구하는 경우, 추가 구성이 필요할 수 있습니다",
"Image Processing" => "그림 프로세싱",
"Tiki detected" => "티키가 감지함",
"Tiki can create images" => "티키는 그림을 만들 수 있습니다",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "티키는 샘플 그림을 만들 수 없었습니다. GD 라이브러리 구성을 확인하십시오",
"Tiki was not able to detect the GD library" => "티키가 GD 라이브러리를 감지할 수 없었습니다",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "티키는 그림 갤러리에 대한 그림의 처리와 CAPTCHA 지원을 위하여 GD 라이브러리를 사용합니다",
"Set the Database Connection" => "데이터베이스 연결 설정",
"Tiki requires an active database connection" => "티키는 활성 데이터베이스 연결을 요구합니다",
// "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them" => "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them",
"Tiki cannot find a database connection" => "티키는 데이터베이스 연결을 찾을 수 없습니다",
"This is normal for a new installation" => "새 설치에 대하여 정상적입니다",
"Tiki found an existing database connection in your local.php file" => "티키는 귀하의 local.php 파일에서 기존의 데이터베이스 연결을 발견하였습니다",
// "Database name: %0" => "Database name: %0",
// "Tiki found an automatic database connection for your environment" => "Tiki found an automatic database connection for your environment",
"Use Existing Connection" => "기존 연결 사용",
"Modify database connection" => "데이터베이스 연결 수정",
// "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
"Database information" => "데이터베이스 정보",
"Enter your database connection information" => "데이터베이스 연결 정보를 입력하십시오",
// "DBMS driver" => "DBMS driver",
// "Select the database driver to use with Tiki" => "Select the database driver to use with Tiki",
// "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension" => "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension",
"Host name" => "호스트명",
"Enter the host name or IP for your database" => "데이터베이스에 대한 호스트명 혹은 IP 를 입력하십시오",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "만약 데이터베이스가 티키와 동일한 기계에서 실행 중이라면 <strong>로컬호스트</strong> 를 사용",
"For non-default port number use <strong>example.com;port=3307</strong>" => "비 기본 포트 번호에 대하여 <strong>example.com;port=3307</strong>을 사용합니다",
"Database name" => "데이터베이스명",
// "Name of the database to be used. This database will be created if it does not exist and permissions allow creation" => "Name of the database to be used. This database will be created if it does not exist and permissions allow creation",
// "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created" => "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created",
"If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "이미 다른 용도로 사용되는 데이터베이스를 사용 중인 경우 (추천되지 않음), db/tiki.sql을 검사하여 티키에서 사용하는 테이블명이 이미 사용되고 있지 않다는 점을 확인하십시오",
"Database user" => "데이트베이스 사용자",
// "Enter a database user with administrator permission for the Tiki database" => "Enter a database user with administrator permission for the Tiki database",
"User name" => "사용자명",
// "Database username" => "Database username",
// "Create the above database user just for this Tiki database" => "Create the above database user just for this Tiki database",
// "Administrative database user" => "Administrative database user",
// "Enter database administrator user name and password" => "Enter database administrator user name and password",
// "This is a DB admin user which has permission to create new databases and new users" => "This is a DB admin user which has permission to create new databases and new users",
// "DB admin user name" => "DB admin user name",
// "DB admin password" => "DB admin password",
"Character set" => "캐릭터 세트",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "새 설치를 위하여 강력 추천됨. 하지만, 이전 티키 데이터베이스를 업그레이드 혹은 마이그레이션 할 경우, 이 상자를 체크 해지하는 것을 추천합니다",
"Always force connection to use UTF-8" => "UTF-8 을 사용하도록 연결을 항상 강요",
// "Install & Upgrade" => "Install & Upgrade",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "PHP에 대한 max_execution_time 설정 실패. 느린 시스템 상에서 이 설치프로그램을 이용하여  데이터베이스를 만들기/업그레이드 할 때 문제를 경험할 수 있습니다. 이는 비어있는 페이지로 드러나게 됩니다",
"This install will populate (or upgrade) the database" => "이 설치는 데이터베이스를 채울 것입니다 (혹은 업그레이드 합니다)",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>",
"A new install will populate the database" => "새 설치는 데이터베이스를 채울 것입니다",
"Encoding Issue" => "인코딩 문제",
// "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>",
"Character Set Conversion" => "캐릭터 세트 변환",
"Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "위험도를 직접 판단하시고 사용하십시오. 데이터베이스 내부의 데이터가 현재 적절치 못하게 변환된 데이터를 포함하는 경우, 이는 문제를 악화시킬 수 있습니다. 새 설치용으로 적합합니다. 데이터베이스 상의 ALTER 권한을 요구합니다",
"Convert database and tables to UTF-8" => "데이터베이스와 테이블을 UTF-8 으로 변환",
// "This will destroy your current database: %0" => "This will destroy your current database: %0",
"Reinstall the database" => "데이터베이스 재설치",
"Select database engine" => "데이터베이스 엔진 선택",
// "MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "재설치",
"Upgrade" => "업그레이드",
"Warning: Category Permissions Will Not Be Upgraded" => "경고: 범주 권한이 업그레이드되지 않을 것임",
"Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "범주 권한이 버전3 이후 개량되었습니다. 범주 권한을 사용해오셨다면, 버전 4 이후로 업그레이드 한 후 제대로 작동하지 않을 수 있다는 점에 유의하십시고, 재구성이 필요할 것입니다.",
// "Automatically upgrade your existing database to version" => "Automatically upgrade your existing database to version",
"This site has an admin account configured" => "이 사이트는 관리 계정이 구성되어 있습니다",
"Please log in with your admin password to continue" => "계속하려면 관리자 비밀번호로 로그인해주십시오",
"Review the Upgrade" => "업그레이드 검토하십시오",
"Review the Installation" => "설치 검토",
"Upgrade complete" => "업그레이드 완료",
"Installation complete" => "설치 완료",
"Your database has been configured and Tiki is ready to run" => "귀하의 데이터베이스가 구성되었고 티키가 실행 준비되었습니다",
"If this is your first install, your admin password is <strong>admin</strong>" => "이것이 귀하의 첫 설치라면, 귀하의 관리 비밀번호는 <strong>admin</strong> 입니다",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "귀하는 이제 티키에 <strong>admin</strong> 사용자로써 로그인 할 수 있으며 이 응용프로그램의 구성을 시작할 수 있습니다",
"Upgrade operations executed successfully" => "업그레이드 동작이 성공적으로 실행됨",
"Installation operations executed successfully" => "설치 작업이 성공적으로 실행되었습니다",
"SQL queries" => "SQL 질의",
"Database was left unchanged" => "데이터베이스가 변경되지 않은 상태로 남겨졌습니다",
"Operations failed" => "작동 실패함",
"Display details" => "상세내역 표시",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "업그레이드 도중, <strong>테이블이 이미 존재함</strong> 이란 메시지와 함께 SQL 실패의 결과가 발생하는 것은 일반적입니다",
"Check all errors" => "모든 오류 검사",
"Configure General Settings" => "일반 설정 구성",
"Complete these fields to configure common, general settings for your site" => "사이트에 대하여 범용적이로 일반적인 설정을 구성하기 위하여 다음 필드들을 작성 완료해주십시오",
"The information you enter here can be changed later" => "여기에 입력한 정보는 추후에 변경이 가능합니다",
// "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings",
// "My Tiki" => "My Tiki",
"This will appear in the browser title bar" => "이것은 브라우저 제목 표시줄에 나타날 것입니다",
"Email sent by your site will use this address" => "귀하의 사이트에서 발송한 이메일은 이 주소를 사용할 것입니다",
// "Network Proxy" => "Network Proxy",
// "Toggle section display" => "Toggle section display",
"Secure Log in" => "안전 로그인",
// "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "HTTPS 로그인",
"PHP error reporting level" => "PHP 오류 보고 단계",
"Report all errors except notices" => "알림을 제외한 모든 오류 보고",
"Visible to Admin only" => "관리자에게만 보임",
"Admin email" => "이메일 관리",
// "admin@example.com" => "admin@example.com",
"This is the email address for your administrator account" => "관리자 계정에 대한 이메일 주소입니다",
// "Set up htaccess file" => "Set up htaccess file",
"Method" => "방식",
// "Select how to set up your htaccess file" => "Select how to set up your htaccess file",
"Upgrade fix" => "업그레이드 수정",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will",
"Create the <em>Admins</em> group, if missing" => "<em>Admins</em> 그룹 만들기, 없을 경우에만 해당",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "만약 누락되어있다면, 그룹에 <em>tiki_p_admin</em> 부여",
"Add the administrator account to the group, if missing" => "그룹에 관리자 계정이 없다면 추가",
"To do so enter the name of the main admin account in the field below" => "그렇게 하려면 아래의 필드에 주 관리 계정의 이름을 입력하십시오",
// "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>" => "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>",
"Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "티키4로 업그레이드한 후 비활성화 상태의 계정이 많을 경우 이 상자를 체크하시오",
"List of accounts that will be enabled" => "활성화 될 계정의 목록",
// "Last Notes" => "Last Notes",
// "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future" => "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future",
// "Subscribe to Tiki Releases newsletter" => "Subscribe to Tiki Releases newsletter",
// "Critical & Security update" => "Critical & Security update",
// "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates" => "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates",
// "We don't share subscribed emails and we send very few of these newsletters per year" => "We don't share subscribed emails and we send very few of these newsletters per year",
// "Please use the following link and subscribe" => "Please use the following link and subscribe",
// "Tiki Releases newsletter" => "Tiki Releases newsletter",
// "First Wizards, then Control Panels with Preference Filter" => "First Wizards, then Control Panels with Preference Filter",
// "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator" => "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator",
// "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})" => "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})",
// "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install" => "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install",
// "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels" => "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels",
// "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided" => "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided",
// "Storing your uploaded files" => "Storing your uploaded files",
// "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database" => "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database",
// "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more" => "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more",
// "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other" => "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other",
// "Tiki Community" => "Tiki Community",
// "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users" => "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users",
// "Get Help with Tiki" => "Get Help with Tiki",
// "Hire a Tiki Service Provider" => "Hire a Tiki Service Provider",
// "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>" => "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>",
"Enter Your Tiki" => "티키에 입장하십시오",
// "Ready to run" => "Ready to run",
"The installation is complete" => "설치가 완료되었습니다",
".htaccess File" => ".htaccess 파일",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "귀하의 티키에 대하여 <strong>.htaccess</strong> 파일을 활성화하는 것을 추천합니다",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "이는 SEFURL (검색엔진 친화적 URL) 사용을 활성화할 것이며 사이트 보안을 향상에 도움을 주게 될 것입니다",
// "Your .htaccess file has been set up (%0)" => "Your .htaccess file has been set up (%0)",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
"Enter Tiki and Lock Installer" => "설치 프로그램을 잠그고 티키에 입장",
"Recommended" => "추천됨",
"Enter Tiki Without Locking Installer" => "설치 프로그램을 잠그지 않고 티키에 입장",
// "Not recommended due to security risk" => "Not recommended due to security risk",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "이제 사이트에 평소와 같이 접근할 수 있습니다. 문제를 발견하게 되면 티키 게시판 혹은 버그 트래커로 알려주십시오",
"Are you sure you want to attempt to fix the encoding of your entire database" => "데이터베이스 전체의 인코딩의 수정을 시도하시겠습니까?",
"Upgrading and running into encoding issues" => "업그레이드 및 인코딩 문제 직면",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "수정을 시도해 볼 수 있습니다만 <strong>백업여부를 확인하십시오, 그것을 복구할 수도 있습니다</strong>",
"Previous table encoding" => "테이블 인코딩 미리보기",
"Please select" => "선택하여 주십시오",
// "Click to fix double encoding (dangerous)" => "Click to fix double encoding (dangerous)",
"Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "이런. 클라이언트 charset 이 UTF-8으로 강제 조정되었나 확인하여 주십시오. 계속하려면 데이터베이스 연결을 재설정하십시오",
"MultiTiki Setup" => "다중티키 설치",
"Default Installation" => "기본 설치",
"DB OK" => "DB 확인",
"No DB" => "DB 없음",
"Adding a new host" => "새 호스트 추가 중",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "새 가상호스트를 추가하려면, 도메인명을 마지막 매개변수로 setup.sh를 실행하십시오",
"MultiTiki" => "다중티키",
"Are you upgrading an existing Tiki site" => "기존 티키 사이트를 업그레이드 하십니까?",
"Go directly to the <strong>Install/Upgrade</strong> step" => "<strong>설치/업그레이드</strong> 단계로 바로 이동하십시오",
"Install/Upgrade" => "설치/업그레이드",
"Powered by" => "제공: ",
"Powered by Tiki Wiki CMS Groupware" => "티키 위키 CMS 그룹웨어를 구동 중",
"Clear cached version and refresh cache" => "캐시된 버전 제거 및 캐시 새로 고침",
"configure rules" => "규칙 구성",
"Invitation" => "초대",
"Invitations list" => "초대 목록",
"The mail has been sent to: " => "메일이 다음으로 발송되었습니다:",
"You are about to send an invitation to theses people, please confirm" => "초대를 이 사람들에게 보내려고 합니다. 확인해주십시오",
"Fill this box with the list of emails you want to invite " => "초대하려는 이메일의 목록으로 이 상자를 채우십시오",
"Format of the list above " => "위의 목록의 서식",
"CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV 스타일: 다음 포맷으로 된 초대 당 한 줄: 성,이름,이메일",
"Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "텍스트 내부에 이메일로써 나타나는 모든 것이 감지되고 사용될 것입니다 (그 경우, 이메일 내용에서 {literal}{firstname} 및 {lastname}{/literal} 이 무시됩니다)",
"Type here the email subject you'll want to be sent to them " => "그들에게 보내기를 원하는 이메일 제목을 여기에 입력하십시오",
"Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "그들에게 보내고 싶은 이메일 컨텐츠를 여기에 입력 (그리고 {literal}{link}{/literal 단어를 두면, 등록 시 좋은 링크로 교체될 것입니다)",
"Type here the content that the user will see when he'll click on the link from the mail " => "사용자가 메일로부터의 링크를 클릭했을 때 보게될 컨텐츠를 여기에 입력하십시오",
"Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special " => "다음의 구독내역들이 속할 그룹을 한 개 이상 선택하십시오. 특이한 것을 원하지 않으시면 아무것도 선택하지 마십시오",
"Invoices" => "청구서",
"New Invoice" => "새 청구서",
"Clients" => "고객들",
"New Client" => "새 클라이언트",
"Invoice Reports" => "청구 보고서",
"Add more media" => "더 많은 미디어 추가",
"Change Details" => "상세내역 변경",
"Video Title" => "동영상 제목",
"Editor" => "편집자",
"Embed code" => "코드 임베드",
"Plays" => "재생",
"No action specified" => "작업이 지정되지 않음",
"This file is not expected to be called directly" => "이 파일은 직접 호출되는 것으로 예측되지 않습니다",
"Last Changes" => "마지막 변경",
"Last 2 days" => "마지막 2일",
"Last 3 days" => "마지막 3일",
"Last 5 days" => "마지막 5일",
"Last week" => "지난 주",
"Last 2 weeks" => "마지막 2주",
"Last month" => "지난 달",
"Search by Date" => "날짜로 검색",
"Found" => "발견됨",
"LastChanges" => "마지막 변경",
// "Ip" => "Ip",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
// "v" => "v",
"Diff" => "차이",
"Pages like" => "유사 페이지",
"New Article" => "새 기사",
"New Submission" => "새 투고기사",
"View Submissions" => "제출 보기",
"Expiry Date" => "만기 날자",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
"Select Duplicates" => "중복된 항목 선택",
// "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "배너 작성",
"Use Dates?" => "기간 사용?",
"Max Impressions" => "최대 광고 노출",
// "Impressions" => "Impressions",
"Max Clicks" => "최다 클릭 수",
"Clicks" => "클릭 수",
// "List Posts" => "List Posts",
"The cache is used by" => "캐시 사용",
// "{\$headerName}" => "{\$headerName}",
"Approval" => "승인",
// "Delete comment" => "Delete comment",
"(no title)" => "(제목 없음)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "승인됨",
"More Information" => "추가 정보",
// "Delete selected comments" => "Delete selected comments",
// "Delete and ban selected comments" => "Delete and ban selected comments",
// "Delete and ban" => "Delete and ban",
"Dynamic Content System" => "유동 컨텐츠 시스템",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "{literal}{content label=x}{/literal} 을 사용할 수도 있습니다, 여기서 x 는 컨텐츠 블럭의 레이블입니다",
"Available content blocks" => "제공되는 컨텐츠 블럭",
"Current Value" => "현재 값",
"Current ver" => "현재 버전",
"Next ver" => "다음 버전",
"Future vers" => "미래 버전",
"Program" => "프로그램",
"Create/Edit content block" => "컨텐츠 블럭 만들기/편집",
"Edit content block" => "컨텐츠 블럭 편집",
"Create content block" => "컨텐츠 블럭 만들기",
"Available FAQs" => "사용가능한 FAQ",
// "Questions / Suggested" => "Questions / Suggested",
"Edit/Create" => "편집/만들기",
"Edit this FAQ:" => "이 FAQ을 편집하기:",
"Create new FAQ" => "새 FAQ 작성",
"Create New FAQ:" => "새 FAQ 작성:",
"Users can suggest questions" => "사용자가 질문 제안 가능",
"Create a File Gallery" => "파일 갤러리 만들기",
// "{\$name}" => "{\$name}",
// "Finder" => "Finder",
"RSS feed" => "RSS 피드",
"Hide file information from list view" => "목록 보기에서 파일 정보 감춤",
// "Hide list view information" => "Hide list view information",
"Show file information from list view" => "목록 보기에서 파일 정보 보기",
// "Show list view information" => "Show list view information",
// "Create Diagram" => "Create Diagram",
// "Batch" => "Batch",
"SlideShow" => "슬라이드쇼",
// "Create H5P" => "Create H5P",
"Be careful to set the right permissions on the files you link to" => "링크를 할 파일들에 올바른 권한을 설정하도록 조심하십시오",
"Keep gallery window open" => "갤러리\\창 열린 상태로 유지",
"optional" => "선택적",
"Modifications" => "수정",
"Property <b>{\$fgp_name}</b> Changed" => "<b>{\$fgp_name}</b> 속성이 변경되었습니다",
// "Search for text within files in all galleries" => "Search for text within files in all galleries",
// "Search by identifier" => "Search by identifier",
// "Search for the file with this number, in all galleries" => "Search for the file with this number, in all galleries",
// "Maximum width" => "Maximum width",
"You can access the file gallery using the following URL" => "다음 URL을 사용하여 파일 갤러리에 접근할 수 있습니다",
"Gallery Images" => "갤러리 그림",
"Inviter" => "초대자",
"Only successful invitations" => "성공적인 초대만",
"Only pending invitations" => "보류 중인 초대만",
"Number of invitations" => "초청 수",
"Invoice Clients" => "청구 고객",
"Tax Status" => "세금 상태",
"New Contact" => "새 연락처",
"Client Name" => "고객 이름",
"Remix Entries" => "항목 재 혼합",
"Browse Media" => "미디어 탐색",
"Browse Remixes" => "재 믹스된 내용 탐색",
"Please select some media entries to use" => "사용할 어떤 미디어 항목을 선택하여 주십시오",
"Media Id" => "미디어 ID",
"Wiki plugin code" => "위키 플러그인 코드",
"No entries" => "입력 없음",
"No media entries found" => "발견된 미디어 없음",
"to upload" => "업로드하려면",
"Modified By" => "수정하신 분",
"No mix entries found" => "발견된 mix 엔트리 없음",
"Object Permissions List" => "개체 권한 목록",
"Object Permissions" => "개체 권한",
// "Object permissions" => "Object permissions",
// "Category permissions" => "Category permissions",
// "Perform action with selected permissions" => "Perform action with selected permissions",
// "Assign to this group" => "Assign to this group",
// "Only default global permissions are being used" => "Only default global permissions are being used",
"Reason" => "이유",
// "No object permissions apply" => "No object permissions apply",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
// "No category permissions apply" => "No category permissions apply",
"Blog: %0" => "블로그: %0",
"New Blog Post" => "새 블로그 게시물",
"Post Title" => "Post 제목",
"Blog Title" => "블로그 타이틀",
// "(bytes)" => "(bytes)",
// "Delete Expired Submissions" => "Delete Expired Submissions",
// "Deletes expired submissions 1000 at a time to avoid timeouts" => "Deletes expired submissions 1000 at a time to avoid timeouts",
"Survey stats" => "설문 통계",
// "Take survey" => "Take survey",
"Import Structure" => "구조체 가져오기",
"Import From Profile/YAML" => "프로필/YAML 에서 가져오기",
// "Manage Tabular Formats" => "Manage Tabular Formats",
// "Clone remote" => "Clone remote",
"Items" => "항목",
// "{\$tracker.name|escape}" => "{\$tracker.name|escape}",
"Do you really remove this tracker" => "이 트래커를 정말 삭제하시겠습니까",
"Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "이 트래커에서 모든 항목들을 정말로 삭제하시길 원하십니까? (주의: 실행취소를 할 수 없으며 내역 알림이 발송되지 않을 것입니다)",
"users registered" => "사용자 등록됨",
"like" => "좋아요",
"Distance (km)" => "간격 (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "위키 페이지 나열",
"Page aliases found" => "페이지 별징 발견됨",
"Create a Wiki Page" => "위키페이지 만들기",
"Insert name of the page you wish to create" => "만드려는 페이지의 이름을 삽입하십시오",
"Create page within %0" => "%0 내부에 페이지 만들기",
"Page creator" => "페이지 만든이",
"Last author" => "마지막작성자",
"Last version" => "마지막버전",
"Status of the page" => "페이지의 상태",
"Links to other items in page" => "페이지 내부의 다른 항목들에 연결",
"Links to this page in other pages" => "이 페이지를 다른 페이지에 연결",
"Backl" => "뒤로|",
"Page size" => "페이지 크기",
"Lang" => "언어",
"No page" => "페이지 없음",
"No pages found with" => "다음으로 페이지 발견되지 않음",
// "Download PDF" => "Download PDF",
// "Download zipped file" => "Download zipped file",
// "Add page name as page header" => "Add page name as page header",
"Open client window" => "클라이언트 윈도우로 열기",
"Generate HTML" => "HTML 생성",
"Transcripts" => "트랜스크립트",
"Online operators" => "온라인 운영자",
"Accepted requests" => "수락된 요청",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "트랜스크립트",
"offline" => "오프라인",
"Offline operators" => "오프라인 운영자",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "시스템에 연산자 추가",
"Operators must be tiki users" => "운영자는 티키 사용자여야만 합니다",
"Set as Operator" => "운영자로 설정",
"Chat started" => "채팅 시작됨",
"Live support:User window" => "라이브 지원:사용자 창",
"Request live support" => "라이브 지원 요청",
"Request support" => "지원 요청",
"Your request is being processed" => "귀하의 요청은 진행 중입니다",
"cancel request and exit" => "요청 취소 및 나가기",
"cancel request and leave a message" => "요청을 취소하고 메시지를 남김",
"Live support:Console" => "라이브 지원:콘솔",
// "{\$status}" => "{\$status}",
"be online" => "온라인 되기",
"be offline" => "오프라인 되기",
"You are not an operator" => "운영자가 아닙니다",
"Support requests" => "요청 지원",
"Requested" => "요청됨",
"Accept" => "허용",
"Join" => "병합",
"No support requests" => "지원 요청 없음",
"Support chat transcripts" => "채팅 대화내용 지원",
"Back to admin" => "관리로 복귀",
"operator" => "운영자",
"started" => "시작함",
"reason" => "이유",
"msgs" => "메시지",
"Transcript" => "트랜스크립트",
"For security purposes we must periodically validate your email address to allow continued access to this site" => "보안 목적으로, 이 사이트로 지속적인 접근을 허용하기 위하여 귀하의 이메일 주소를 정기적으로 확인하여야만 합니다",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "확인 이메일이 귀하께 발송되었습니다. 사이트에 접근권한을 다시 얻으려면 그 이메일을 열고 설명을 따르십시오",
"Thank you" => "고맙습니다",
"Mail-in feature" => "Mail-in 기능",
"Click here to go to mailin admin" => "mailin 관리로 가려면 여기를 클릭",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "종속성 누락. <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> 를 받고 files/ 내부에 업로드 하십시오",
"Mini Calendar" => "미니 달력",
"Prefs" => "설정",
"Daily" => "일간",
"Weekly" => "주간",
"Remove old events" => "오래된 이벤트 제거",
// "h" => "h",
"mins" => "분",
"Edit Event" => "이벤트 편집",
"Mini Calendar: Preferences" => "미니 달력: 기본설정",
"Calendar Interval in daily view" => "일일 보기로 된 달력 간격",
"Start hour for days" => "일일 시작시간",
"End hour for days" => "일일 종료시간",
"Reminders" => "미리 알림",
"no reminders" => "미리 알림 없음",
"min" => "분",
"Or enter path or URL" => "혹은 경로 혹은 URL을 입력하십시오",
"Add Topic" => "토픽 추가",
"Tiki Mods" => "티키 Mods",
// "Tiki \"Mods\" are obsolete as of Tiki 19" => "Tiki \"Mods\" are obsolete as of Tiki 19",
// "Tiki now uses \"Packages\" instead" => "Tiki now uses \"Packages\" instead",
// "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>" => "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>",
// "y" => "y",
"User Galleries" => "사용자 갤러리",
"My Articles" => "내 기사",
"User Articles" => "사용자 기사",
"My User Items" => "내 사용자 항목",
"User Items" => "사용자 항목",
"Unread Messages" => "읽지 않은 메시지",
"User forum topics" => "사용자 게시판 토픽들",
// "Forum topic" => "Forum topic",
"Date of post" => "게시 날짜",
"User forum replies" => "사용자 게시판 답글들",
"User Blogs" => "사용자 블로그",
"My blog Posts" => "내 블로그 게시물",
"User Blog Posts" => "사용자 블로그 게시물",
"To display the objects you created or contributed to" => "만들었거나 기여한 개체를 표시하려면",
// "My Items" => "My Items",
"My Info" => "내정보",
"My Watches" => "내 주시목록",
"Contacts Preferences" => "연락처 설정",
"Notepad" => "메모장",
"MyFiles" => "내파일",
"Sent editions" => "전송된 버전",
"Admin Newsletters" => "회보 관리",
"HTML version" => "HTML 버전",
"Text version" => "텍스트 버전",
"The newsletter was sent to {\$sent} email addresses" => "íšŒë³´ëŠ” {\$sent} ì´ë©”ì¼ ì£¼ì†Œë¡œ ë°œì†¡ë˜ì—ˆìŠµë‹ˆë‹¤",
"Delete errors" => "오류 삭제",
"Not sent" => "발송되지 않음",
"Subscribe to Newsletter" => "회보 구독하기",
"Subscribe to this Newsletter" => "이 회보를 구독",
"Available Newsletters" => "제공되는 회보들",
"Write a note" => "메모작성",
"quota" => "할당",
"No notes yet" => "아직 메모 없음",
"Merge selected notes into" => "선택된 메모들을 다음으로 병함",
"Reading note" => "메모 읽는 중",
"List notes" => "메모 나열",
"Write note" => "메모 쓰기",
"Wiki Create" => "위키 만들기",
"Wiki Overwrite" => "위키 덮어쓰기",
"Object Watches" => "개체 주시",
"Groups watching" => "그룹 주시",
"Changes to groups watching" => "그룹 주시로 변경",
"These changes to group watches" => "그룹 주시에 이러한 변경들",
"were made to these descendants" => "이 다음 후손들에게 가해짐",
"This Category" => "이 범주",
"All Descendants" => "모든 하위항목",
"Assign global permissions" => "전역 권한 할당",
"Assign permissions to " => "권한을 할당 ",
"Edit Permissions" => "권한 편집",
"Currently editing Global permissions." => "현재 전역 권한을 편집 중입니다.",
"This object's direct permissions override any global permissions or category permissions affecting this object" => "이 개체의 직접 권한은 그 어떠한 전역 권한 혹은 이 개체에 영향을 미치는 범주 권한을 재정의합니다",
"This category's direct permissions override any global permissions affecting objects in it" => "이 범주의 직접 권한은 내부의 개체들에 영향을 미치는 그 어떠한 전역 권한도 재정의 합니다",
"To edit global permissions" => "전역 권한을 편집하시려면",
"No permissions yet applied to this object but category permissions affect this object and are displayed below" => "이 개체에는 아직 권한이 적용되지 않았지만 범주 권한은은 이 개체에 영향을 미치며 아래에 표시됩니다",
"To edit category permissions" => "범주 권한을 편집하려면",
// "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below" => "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below",
// "To edit parent object's permissions" => "To edit parent object's permissions",
"No direct permissions yet applied to this object. Global permissions apply." => "이 개체에 직접적 권한이 아직 적용된 바 없습니다. 전역 권한이 적용됩니다.",
"Currently inherited permissions displayed." => "현재 상속받은 권한이 표기되고 있습니다",
"Show permissions for disabled features" => "비활성화 상태가된 기능에 대한 권한 보기",
"Assign permissions to this category" => "이 범주로 권한 할당",
"Assign permissions to this object" => "이 개체로 권한 할당",
"Delete category permissions" => "범주 권한 삭제",
"Delete object permissions" => "개체 권한 삭제",
"Reset Perms" => "권한 재설정",
"This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "이는 여기 설정을 모두 삭제할 것이며 권한이 설정된 그 어떤 범주 권한 혹은 전역 범사이트 권한을 상속하도록 재설정될 것입니다 ",
"This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "이는 여기의 모든 설정을 제거할 것이며 권한은 전역 범사이트 권한을 상속하도록 재설정될 것입니다",
"Permissions Clipboard" => "클립보드 권한",
"Copy the permissions set here" => "여기에 권한 세트 복사",
"Paste" => "붙여넣기",
"Paste copied permissions from " => "다음에서 복사된 권한을 붙여넣기",
"Assign or remove permissions on <em>all</em> child categories" => "<em>모든</em> 자식 범주들에게 권한을 할당 혹은 삭제",
"Are you sure you want to affect all child categories?\\nThere is no undo" => "모든 자식 범주에 영향을 반영되게 하시겠습니까?\\n실행 취소할 수 없습니다",
"Assign or remove permissions on all pages of the sub-structure" => "하위구조체의 모든 페이지들 상에서 권한들 할당 혹은 삭제",
"Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "이 하위구조체 내부의 모든 페이지에 영향을 반영되게 하시겠습니까?\\n실행 취소할 수 없습니다",
"You must select at least one feature" => "최소한 한 개의 기능을 반드시 선택해야 합니다",
"View Differences" => "차이점 보기",
"Permissions added:" => "권한 추가됨:",
"Permissions removed" => "권한 삭제됨",
"Select groups" => "그룹 선택",
"Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for" => "그룹의 일부는 자동으로 감춰져 있습니다.<br>아래에서 권한을 할당할 그룹을 선택하십시오",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab." => "이 그룹들은 개체에 권한을 보유한 그룹이 아닙니다. 단지, 첫번째 탭의 열에서 볼 수 있는 그룹입니다.",
"Select only groups that have a perm with the object" => "개체에 대한 권한을 가지고 있는 그룹만 선택하십시오",
"Group name" => "그룹명",
"Select features" => "기능 선택",
"Some of your features have been automatically hidden.<br> Select the features below to assign permissions for" => "기능의 일부는 자동으로 감춰져 있습니다.<br>아래에서 권한을 할당할 기능을 선택하십시오",
"Feature name" => "기능 이름",
"Quick Permissions" => "빠른 권한설정",
"Assign Quick-Permissions to this object" => "이 개체에 빠른 권한설정으로 할당",
// "Individual permissions are currently assigned (See tab Assign Permissions)" => "Individual permissions are currently assigned (See tab Assign Permissions)",
"<em>Quick permissions</em> should be considered as an experimental feature." => "<em>빠른 권한설정</em> 은 실험적 기능으로 여겨져야 합니다.",
"Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably." => "비록 권한이 본 양식을 사용하여 예측하는 대로 설정될 것이지만, 현재 부여된 권한을 신뢰할 수있게 표시한다고는 할 수 없습니다.",
"There is also no undo - <strong>Use with care!</strong>" => "실행취소가 업습니다 - <strong>조심해서 사용하세요!</strong>",
"Your OpenID identity is valid" => "귀하의 OpenID 신분은 유효합니다",
"Your identity gives you access to multiple user accounts" => "귀하의 신원은 여러 개의 사용자 계정으로 접근성을 부여합니다",
"Select account" => "계정 선택",
"Orphan Pages" => "고아 페이지",
"Browser not supported" => "지원되지 않는 브라우저",
"Contributions by author" => "저자에 의한 기여내역",
"Similar" => "유사",
"Make Structure" => "구조체 만들기",
"Discuss" => "토론",
"Bookmark" => "북마크",
"View latest version before editing" => "편집 전에 가장 최근 버전 보고",
"Contributions to" => "다음으로의 기여내역",
"current version" => "현재 버전",
"Words" => "단어",
"Whitespaces" => "공백",
"Characters" => "글자",
"Printable characters" => "인쇄가능한 문자",
"Page changes" => "페이지 변경내역",
"Original wiki text" => "위키 텍스트 원본",
"Parsed Text (HTML)" => "구문분석된 텍스트 (HTML)",
"Output text only (No HTML tags)" => "출력 테스트만 (HTML 태그 없음)",
"Show statistics" => "통계 표시",
"Visualize page changes" => "페이지 변경내역 시각화",
"Show popups" => "팝업 표시",
"Escape HTML / Wiki syntax in page changes" => "페이지 변경 내역 안에서 Escape HTML / 위키 문법",
"Show contributions" => "기여내역 표시",
// "Collapse Into Edit Sessions" => "Collapse Into Edit Sessions",
"Show All Versions" => "모든 버전 표시",
"Preview of version" => "버전 미리보기",
"(current)" => "(현재)",
"Roll back to this version" => "이 버전으로 롤백",
"Content Approval" => "컨텐츠 승인",
"This revision is currently marked as approved" => "이 수정버전은 현재 승인됨 으로 표시되어 있습니다",
"Remove Approval" => "승인 제거",
"This revision has not been approved" => "이 수정버전은 승인되지 않았습니다",
"Approve Revision" => "수정내역 승인",
// "History view" => "History view",
// "This revision may not be the latest approved revision" => "This revision may not be the latest approved revision",
// "This revision has been rejected" => "This revision has been rejected",
"Source of version" => "버전의 소스",
"Update Translation" => "번역 갱신",
"Hide translation history" => "번역 기록 숨김",
"Show translation history" => "번역 기록 표시",
"Enable pagination" => "페이지매김 활성화",
// "rows per page" => "rows per page",
// "HTML allowed" => "HTML allowed",
// "HTML syntax is allowed either by page setting or use of the WYSIWIG editor" => "HTML syntax is allowed either by page setting or use of the WYSIWIG editor",
"from %0" => "%0 으로부터",
"approved" => "승인됨",
"Updated from" => "다음에서 갱신",
"Used to update" => "업데이트하기 위하여 사용됨",
// "rejected" => "rejected",
// "Difference" => "Difference",
"Older Version" => "기존 버전",
// "Israel Post" => "Israel Post",
// "Order ID" => "Order ID",
// "Payment authorized (not captured)" => "Payment authorized (not captured)",
// "Payment authorized (captured)" => "Payment authorized (captured)",
// "Unknown state" => "Unknown state",
// "Date Paid" => "Date Paid",
"Payer" => "지불자",
// "Payer email from %0" => "Payer email from %0",
"View payment info" => "지불 정보 보기",
"Cancel this payment request" => "이 지불 요청 취소",
"View payment request" => "지불 요청 보기",
"Paypal" => "페이팔",
"Transaction ID" => "거래 ID",
"Payment made by <em>%0, %1</em> (%2)" => "<em>%0, %1</em> 에 의한 지불 (%2)",
"Payment Request" => "지불 요청",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "For each user: " => "For each user: ",
// "per full period" => "per full period",
// "applicable prorated pricing provided" => "applicable prorated pricing provided",
// "free periods provided" => "free periods provided",
// "full free" => "full free",
// "prorated free" => "prorated free",
"Payment Status" => "지불 상태",
// "{\$payment_info.state|capitalize|escape}" => "{\$payment_info.state|capitalize|escape}",
// "Capture Payment" => "Capture Payment",
"Paid amount" => "지불 금액",
"Initial amount" => "초기 양",
"Amount remaining" => "잔량",
"Payment request initiated" => "지불 요청 초기화됨",
"Payment request due" => "지불 요청 기한",
"Pay with PayPal" => "페이팔로 지불",
"Pay with Paypal" => "페이팔로 지불",
// "Proceed to Israel Post" => "Proceed to Israel Post",
"Pay With Cclite" => "Cclite로 지불",
"Refresh page" => "페이지 다시 고침",
"Payment info" => "지불 정보",
"Trade with Cclite" => "Cclite로 교환",
"Payment problem" => "지불 문제",
"Pay With Tiki Credits" => "티키 크레딧으로 지불",
"Pay with Tiki User Credits" => "티키 사용자 크레딧으로 지불",
"Credit type" => "크레딧 종류",
"Credits left" => "잔여 크레딧",
"Amount to pay" => "지불할 금액",
"Pay using" => "다음으로 지불",
"Payment Details" => "지불 상세내역",
"Enter a Manual Payment" => "수동 지불 입력",
"Enter payment" => "지불 입력",
// "using" => "using",
"Payment information" => "지불 정보",
// "No outstanding payments found" => "No outstanding payments found",
// "No paid payments found" => "No paid payments found",
// "<em>No cancelled payments found</em>" => "<em>No cancelled payments found</em>",
"Request" => "요청",
"Payable within" => "다음 내에 지불가능",
"Pick your profile picture" => "아바타 선택",
"Your current profile picture" => "현재 아바타",
"Full size" => "전체 크기",
"no profile picture" => "아바타 없음",
// "Pick user profile picture from the library" => "Pick user profile picture from the library",
"Pick user profile picture" => "사용자 아바타 선택",
"Hide all" => "모두 감춤",
"icons" => "아이콘",
"Show all" => "모두 표시",
"random" => "무작위",
"Upload your own profile picture" => "자신의 아바타를 업로드 하세요",
// "Select your profile picture" => "Select your profile picture",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "파일 (.gif, .jpg 및 .png 이미지만 허용. 대략크기 45px × 45px)",
"File (only .gif, .jpg and .png images)" => "파일 (.gif, .jpg 및 .png 그림들만)",
"Plugin execution was denied" => "플러그인 실행이 거부됨",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "편집자에 의하여 변수 유효화가 된 후, 이 플러그인의 실행이 거부되었습니다. 이 플러그인은 추후에 삭제되거나 수정될 것입니다",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "이 플러그인은 최근에 추가되었거나 수정되었습니다. 사이트의 편집자가 매개변수를 유효화할 때까지, 실행은 가능하지 않을 것입니다",
"You are allowed to" => "다음이 허용됩니다",
"View arguments" => "변수 보기",
"Execute the plugin in preview mode (may be dangerous)" => "미리보기 모드에서 플러그인 실행 (위험할 수 있음)",
"Approve the plugin for public execution" => "공용 실행에 대하여 플러그인 승인",
"View Details" => "상세내역 보기",
"This plugin does not contain any arguments" => "이 플러그인은 그 어떤 인수도 포함하고 있지 않습니다",
"This plugin's body is empty" => "이 플러그인의 본문이 비어있습니다",
// "Experiment with plugin LIST" => "Experiment with plugin LIST",
// "Test Plugin LIST" => "Test Plugin LIST",
"For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "보안을 위하여, <strong>tiki_p_plugin_approve</strong> 권한을 신뢰할 수 있는 사용자 그룹에게만 허용하십시오",
// "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins",
"This page lists the plugins that require validation, the first time they are encountered" => "이 페이지는 처음 사용될 때 인증을 요구하는 플러그인을 나열합니다",
"Each plugin contains a unique <em>signature</em> that is preserved" => "각각의 플러그인은 보존이 되는 고유 <em>서명(signature)</em> 을 담고있습니다",
"When you upgrade from an old version, you may need to reparse all the pages" => "과거 버전에서 업그레이드할 때, 모든 페이지들을 재구문분석 해야할 수도 있습니다",
"If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "플러그인이 더 이상 사용되지 않는다면 (예를 들면, 위키 페이지에서 제거되었을 경우), 이 목록에서 삭제하기 위하여 <strong>Clear</strong> 를 사용하십시오",
"The plugin will automatically be added if it is encountered" => "플러그인은 발생될 경우 자동으로 추가될 것입니다",
"Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "플러그인은 이를 포함하는 특정 위치에서 개별적으로 미리보기, 승인, 혹은 거부될 수 있습니다",
"For security, you should review each plugin to ensure it is safe to approve" => "보안을 위하여, 플러그인이 승인에 안전한지를 확인하기 위하여 각각 검토하여야 합니다",
"Added By" => "추가하신 분",
// "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>" => "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>",
// "View this page" => "View this page",
"Approve all pending plugins" => "모든 보류 중인 플러그인을 승인",
"Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "<strong>승인</strong> 혹은 <strong>모두 승인</strong> 을 사용하는 것은 대기 중인 플러그인을 승인하고 활성화시킬 것입니다",
"Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "대기 중인 플러그인이 안전하다는 것을 확인했을 경우에 <strong>한하여</strong> 이 기능을 사용",
"No plugins pending approval" => "승인 보류 중인 플러그인 없음",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "결과 보기",
// "Sorry" => "Sorry",
"Other Polls" => "다른 투표",
"Poll Results" => "투표 결과",
// "All Polls" => "All Polls",
// "Top-Voted Polls" => "Top-Voted Polls",
"Edit Poll" => "투표 편집",
"Find the poll" => "투표 찾기",
// "{\$what}" => "{\$what}",
"Number of top voted polls to show" => "표시할 최고 참여 투표의 수",
// "Show results in this range" => "Show results in this range",
// "Show all results with no time span consideration" => "Show all results with no time span consideration",
// "Show all results with time span consideration" => "Show all results with time span consideration",
// "Show all results" => "Show all results",
// "Find results" => "Find results",
// "Show detailed results of this poll" => "Show detailed results of this poll",
"List Votes" => "투표 나열",
// "Preference translation" => "Preference translation",
"Popup preview" => "팝업 미리보기",
"Close preview" => "미리보기 닫기",
// "Permalink" => "Permalink",
"The original document is available at" => "문서 원본은 다음 장소에서 제공됩니다",
"Print multiple pages" => "여러 페이지 인쇄",
"Selected Structures" => "선택된 구조체",
"Add Structure" => "구조체 추가",
"No structures" => "구조체 없음",
"Available Pages" => "사용가능한 페이지",
"No pages" => "페이지 없음",
"All pages selected" => "모든 페이지가 선택됨",
"Add Page" => "페이지 추가",
"Remove Page" => "페이지 제거",
"Selected Pages" => "선택된 페이지",
"No pages selected" => "선택된 페이지 없음",
"Add Pages from Structures" => "구조체에서 페이지 추가",
"Edit quiz" => "퀴즈 편집 ",
"Current Version" => "현재 버전",
"General Options" => "일반 선택사항",
"Publication Date" => "게재 날짜",
// "at " => "at ",
"Use " => "사용",
"randomly selected questions" => "무작위로 선택된 질문들",
"Test-time Options" => "테스트 시 선택사항",
"Shuffle questions" => "질문 섞기",
"Shuffle answers" => "답 섞기",
"Limit questions displayed per page to " => "페이지 당 표시된 질문을 다음으로 제한",
// "question(s)" => "question(s)",
"Impose a time limit of " => "다음의 시간 제한 적용",
"Allow students to store partial results and return to quiz" => "학생들이 일부 결과를 저장한 후 다시 퀴즈로 복귀 허용",
"Allow students to retake this quiz " => "학생들이 이 시험 다시 보는 것 허용",
"Grading and Feedback" => "채점 및 반응",
"Grading method " => "채첨 방식",
"Show students their score " => "학생에게 자신 점수 표시",
// "Show students the correct answers" => "Show students the correct answers",
"Publish statistics " => "통계 게재",
"Extra Options" => "추가 선택사항",
"Solicit additional questions from students" => "학생들로부터 추가 질문 간청",
"Link quiz to forum named: " => "다음 게시판으로 퀴즈 링크:",
"Prologue" => "프롤로그",
"Epilogue" => "에필로그",
"Quiz result stats" => "퀴즈 결과 통계",
"User answers" => "사용자 답",
"Stats for quizzes" => "퀴즈에 대한 통계",
// "taken" => "taken",
"Av score" => "평균 점수",
"Av time" => "평균 시간",
"Stats for quiz" => "퀴즈통계",
"Clear Stats" => "통계비움",
"time taken" => "취한 시간",
// "Pass/Fail" => "Pass/Fail",
"Passed" => "통과됨",
"Stats for this quiz Questions " => "이 퀴즈질문 통계",
"Top 10" => "톱 10",
"Top 20" => "탑 20",
"Top 50" => "상위 50",
"Top 100" => "톱 100",
"Rank" => "순위",
"Not Published" => "게재되지 않음",
"This article is currently unpublished and visible only to editors." => "이 기사는 현재 개제되지 않았고 편집자만 볼 수 있습니다",
"Received articles" => "수신기사",
"Topic image" => "토픽 그림",
"Edit received article" => "수신기사 편집",
"Image x size" => "그림 x 크기",
"Image y size" => "그림 y 크기",
"Image name" => "그림명",
"Publishing date" => "게재될 날짜",
"Accept Article" => "승인된 기사",
"Received Pages" => "수신페이지",
"Edit Received Page" => "수신된 페이지 편집",
"The highlight pages already exist" => "하이라이트 페이지가 이미 존재합니다",
"Please, change the name if you want the page to be uploaded" => "페이지가 업로드되는 것을 원하는 경우 이름을 변경하여 주십시오",
"Received Structures" => "수신된 구조체들",
// "Prefix the checked: " => "Prefix the checked: ",
// " Postfix the checked: " => " Postfix the checked: ",
// "References" => "References",
// "Add a new library reference" => "Add a new library reference",
// "Edit reference settings" => "Edit reference settings",
// "Reference usage" => "Reference usage",
// "Delete reference" => "Delete reference",
// "Edit reference" => "Edit reference",
// "If you change the value of Biblio Code, you might loose the link between references" => "If you change the value of Biblio Code, you might loose the link between references",
// "Pages using reference %0" => "Pages using reference %0",
"Referer stats" => "Referer 통계",
"Register as a new user" => "새 사용자로 등록",
"Tiki site registered" => "티키 사이트 등록됨",
"The following site was added and validation by admin may be needed before appearing on the lists" => "다음 사이트가 추가되었으며 목록에 표시되기 전에 관리자에 의한 유효화가 필요할 수 있습니다",
"Country:" => "국가:",
"You don't have permission to use this feature" => "이 기능을 사용할 권한이 없습니다",
"Please register" => "등록해 주십시오",
"Register this site at Tiki.org" => "이 사이트를 Tiki.org 에 등록",
"Read this first" => "이 첫 읽기",
"On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "이 페이지에서, 귀하의 티키 사이트를 Tiki.org 에 알려지게 할 수 있습니다. 알려진 티키 사이트들의 목록 내부에 보이게 됩니다",
"Registering is voluntary" => "등록은 자발적으로 이루어집니다.",
"Registering does not give you any benefits except one more link to your site" => "등록은 귀하의 사이트로 링크를 한 개 더하게 되는 것 외에 추가 이득을 드리지는 않습니다",
"You don't get any emails, we don't sell the data about your site" => "어떤 이메일도 받지 않으실 것입니다. 저희는 귀하의 사이트에 관한 데이터를 판매하거나 하지 않습니다",
"Registering is just for us to get an overview of Tiki's usage" => "등록은 단지 저희로 하여금 티키의 사용에 대한 개요를 얻기 위함입니다.",
"If your site is private or inside your intranet, you should not register" => "귀하의 사이트가 개인용이거나 인트라넷 안에 있는 경우, 등록하지 않는 것이 좋습니다",
// "tiki.org" => "tiki.org",
"Information about your site" => "귀하의 사이트에 관한 정보",
"Enter your username or email" => "사용자명 혹은 이메일을 입력하십시오",
"Enter your email" => "이메일을 입력하십시오",
// "Request Password Reset" => "Request Password Reset",
"Rename page" => "이름변경",
// "Redirect original page" => "Redirect original page",
// "301 Redirect - \\\"moved permanently\\\" HTTP response status code" => "301 Redirect - \\\"moved permanently\\\" HTTP response status code",
// "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)" => "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)",
// "Roll back page %0 to version %1" => "Roll back page %0 to version %1",
// "Describe the reason for roll back" => "Describe the reason for roll back",
// "Enter some text to describe the reason for rolling back" => "Enter some text to describe the reason for rolling back",
"This feature currently searches and replaces within wiki pages only" => "이 기능은 현재 위키 페이지 내부에서만 검색 및 교체를 함",
"Max number of pages at a time" => "한 번에 페이지들의 최대 숫자",
"Number of surrounding chars to preview" => "미리보기할 둘러싸는 글자의 수",
"Replace selected" => "선택된 것들 교체",
"Searched" => "검색됨",
// "Search Query" => "Search Query",
"Search in" => "다음 내부를 검색",
"Date Search" => "날짜 검색",
"All dates" => "모든 날짜",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "달력 항목들",
// "{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}\"" => "{\$where_label|escape}\"",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "단순 검색",
"No pages matched the search criteria" => "검색조건으로 일치한 페이지 없음",
"You can also send newsletters using an external client" => "외부 클라이언트를 사용하여 회보를 보낼 수도 있습니다",
"This newsletter will be sent to {\$subscribers} email addresses" => "이 회보는 {\$subscribers} 이메일 주소로 발송될 것입니다",
// "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds" => "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds",
"Reply to" => "다음으로 회신",
// "Send from" => "Send from",
"Recipients" => "수신자",
"Validated" => "확인됨",
"Is user" => "은 사용자입니다",
"Sending Newsletter" => "회보 전송 중",
// "sending to {\$subscribers} addresses" => "sending to {\$subscribers} addresses",
// "with the 'Reply To' email set to: {\$replyto}" => "with the 'Reply To' email set to: {\$replyto}",
// "with the 'Send From' email set to: {\$sendfrom}" => "with the 'Send From' email set to: {\$sendfrom}",
"Prepare a newsletter to be sent" => "전송될 회보 준비",
"Admin templates" => "템플릿 관리",
"Data HTML" => "데이터 HTML",
"Must be wiki parsed" => "반드시 위키 구문분석되어야 함",
// "Wiki Parsed" => "Wiki Parsed",
"Is HTML" => "은 HTML 입니다",
"Data Txt" => "데이터 텍스트",
"Article Clip (read only)" => "기사 클립 (읽기 전용)",
"Clip Now" => "지금 클립",
"Clip Articles" => "기사 클립",
"To include the article clipping into your newsletter, cut and paste it into the contents" => "회보에 기사 클리핑을 포함하려면, 컨텐츠로 자르기 및 붙여넣기를 하십시오",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "자동클리핑이 활성화된 경우, \"~~~articleclip~~~\" 을 입력할 수도 있습니다 이는 발송시 최신 클립으로 교체될 것입니다",
"Be careful not to paste articles that must not be seen by the recipients" => "수신자에게 표시되어서는 안되는 기사를 붙여넣지 않도록 조심하십시오",
"Attached Files" => "첨부된 파일",
"remove" => "제거",
"octets" => "8진수",
"To add a file, click here" => "파일을 추가하려면, 여기를 클릭하시오",
"Reply To Email" => "이메일에 회신",
"if not" => "아닌 경우",
"Sender email not set" => "전송자 이메일이 설정되지 않음",
// "Send From Email" => "Send From Email",
"Save as Draft" => "초안으로 저장",
"Save your changes" => "변경내역 저장",
"Save any changes and send to all subscribers" => "변경 내역 저장 및 모든 구독자에게 전송",
"Drafts (%0)" => "초안들 (%0)",
"Sent Editions (%0)" => "전송된 버전 (%0)",
"Send objects" => "오브젝트 보내기",
"Transmission results" => "보내기결과",
"Send Wiki Pages" => "Wiki페이지 전송",
"Send a structure" => "구조체 보내기",
"Send Articles" => "기사 전송",
"Add Article" => "기사 추가",
"Send objects to this site" => "이 사이트로 오브젝트 보내기",
"Ex: http://tiki.org or localhost" => "예: http://tiki.org 혹은 localhost",
"Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "티키 사이트가 루트에 설치되어 있다면 /commxmlrpc.php 을 사용, 그 외의 경우 /tiki 를 필요에 맞게 변경",
"Report this page" => "이 페이지 보고",
"Page shared" => "페이지 공유됨",
"The link was sent via email to the following addresses" => "링크는 이메일을 통하여 다음 주소들로 보내졌습니다",
"The link was sent via Twitter" => "링크는 트위터를 통하여 보내졌습니다",
"The link was posted on your Facebook wall" => "링크가 귀하의 페이스북 담벼락에 게시되었습니다",
"The link was sent as message to" => "링크는 다음 분께 메시지로써 발송되었습니다",
"The link was published in a" => "링크는 다음 내부에 개제되었습니다",
"Have a look at this page" => "이 페이지를 살펴봐 주십시오",
// "Access rights are granted for the page" => "Access rights are granted for the page",
"Short link" => "단축 링크",
// "Send email" => "Send email",
"Recipient(s)" => "수신자(들)",
"Separate multiple email addresses with a comma and a space" => "여러 개의 이메일 주소들을 쉼표와 스페이스로 구분하십시오",
"Separate multiple email addresses with a comma" => "여러 개의 이메일 주소들을 쉼표 (,) 로 분리",
"Your name" => "귀하의 이름",
// "Recipients can subscribe to token notifications" => "Recipients can subscribe to token notifications",
// "Token Access Limit" => "Token Access Limit",
// "How many times recipients can access this page" => "How many times recipients can access this page",
"Tweet via Twitter" => "트위터를 통해 트윗 보내기",
"Authorize with Twitter first" => "트위터로 먼저 인증",
"Have a look at " => "살펴보십시오",
"Put on my Facebook wall" => "내 페이스북 담벼락에 올리기",
"Authorize with Facebook first" => "페이스북으로 먼저 인증",
"Link text" => "링크 텍스트",
"This will be the title for the URL" => "이것은 URL에 대한 제목이 될 것입니다",
"Like this post" => "이 게시물이 좋아요",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "메시지를 전송할 권한이 없거나 다른 사용자들이 귀하에게 메시지를 전송하는 것을 허용하지 않았습니다",
// "User(s)" => "User(s)",
"Separate multiple recipients with a semicolon." => "여러 명의 수신자들을 세미콜론으로 분리하십시오.",
"Post on forum" => "게시판에 게시",
"There is no forum where you can post a message" => "메시지를 게시할 게시판이 없습니다",
"password-protected" => "비밀번호로 보호됨",
"Share access rights" => "접근 권한 공유",
"Return to previous page" => "이전 페이지로 돌아가기",
// "Create sheet" => "Create sheet",
// "Configure sheet" => "Configure sheet",
"There are individual permissions set for this sheet" => "이 시트에는 개별 권한들이 설정되어 있습니다",
"Class Name" => "클래스 이름",
"Header Rows" => "헤더 행",
"Footer Rows" => "꼬리말 열",
"Wiki Parse Values" => "위키 구문 분석 값",
"Parent Spreadsheet" => "부모 스프레드시트",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "이 시트를 다중 시트 세트의 \"자식\" 시트로 만듭니다",
"You can access the sheet using the following URL" => "다음 URL을 사용하여 시트에 접근할 수 있습니다",
"Banned Words" => "차단된 단어들",
"Change shoutbox general settings" => "외침상자 일반 설정 변경",
// "auto-link urls" => "auto-link urls",
"Post or edit a message" => "메시지 게시 혹은 편집",
"Location : " => "위치 : ",
"Content may be out of date" => "컨텐츠가 오래 된 것일 수 있습니다",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "번역에 대한 긴급 요청이 발송되었습니다. 이 페이지가 갱신될 때까지, 다음 페이지에서 수정된 버전을 볼 수 있습니다",
// "Update from it" => "Update from it",
"page: %0/%1" => "페이지: %0/%1",
"This text was automatically translated by Google Translate from the following page: " => "이 텍스트는 다음 페이지에서 구글 번역에 의하여 자동으로 번역되었습니다:",
"Rate this page" => "이 페이지 등급 지정",
"Last edited by" => "마지막 수정하신 분",
"based on work by" => "기준한 작업물 만든이",
"Contributors to this page:" => "본 페이지에 기여하신 분:",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
"Twitter authorisation" => "트위터 인증",
"to manage your authorisations at Twitter" => "트위터에서 귀하의 인증을 관리하려면",
"this site with twitter.com to use Twitter integration of this site" => "이 사이트의 트위터 통합을 사용하기 위하여 twitter.com과 이 사이트",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
"Facebook authorisation" => "페이스북 인증",
// "to manage your authorizations at Facebook" => "to manage your authorizations at Facebook",
// "this site within facebook.com to use Facebook integration with this site" => "this site within facebook.com to use Facebook integration with this site",
// "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first" => "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first",
// "LinkedIn authorisation" => "LinkedIn authorisation",
// "this site to link your user to your LinkedIn account" => "this site to link your user to your LinkedIn account",
"The site admin has set up a global account which will be used for this site" => "사이트 관리자가 이 사이트에서 사용될 전역 계정을 설정하였습니다",
"bit.ly Login" => "bit.ly 로그인",
"bit.ly Key" => "bit.ly 키",
"Save changes" => "변경사항 저장",
"You will be redirected to the home page shortly" => "곧 홈페이지로 리디렉션될 것입니다",
"to go to the home page immediately" => "홈페이지로 즉시 이동하려면",
"Please provide local account information" => "지역 계정 정보를 제공하여 주십시오",
// "Do you already have a local account for this site" => "Do you already have a local account for this site",
// "Login to link to it using the following form instead" => "Login to link to it using the following form instead",
"Link to Existing Account" => "기존 계정으로 연결",
"You will not see the latest queries" => "최근 질의를 보지 못 할 것입니다",
"Query" => "질의",
"Params" => "매개변수",
"Most viewed objects" => "가장 많이 본 개체",
"Most viewed objects in the last 7 days" => "지난 7일간 가장 많이 본 개체",
"Site Stats" => "사이트통계",
"Date of first pageview" => "첫 번재 페이지보기 날짜",
"Days since first pageview" => "첫 페이지보기 이후 날",
"Total pageviews" => "총 페이지보기",
"Average pageviews per day" => "일 당 평균 페이지 방문 수",
"Wiki Stats" => "Wiki통계",
"Size of Wiki Pages" => "위키 페이지의 크기",
"Average page length" => "페이지길이  평균",
"Average versions per page" => "페이지 버전수 평균",
"Visits to wiki pages" => "위키 페이지 방문",
"Average links per page" => "페이지당 링크수 평균",
"Image galleries Stats" => "그림갤러리 통계",
"Average images per gallery" => "갤러리당 그림수 평균",
"Total size of images" => "그림 크기 합계",
"Average image size" => "그림크기 평균",
"Visits to image galleries" => "그림 갤러리 방문",
"File galleries Stats" => "파일 갤러리 통계",
"Average files per gallery" => "그림갤러리당 파일수 평균",
"Total size of files" => "파일 크기 합계",
"Average file size" => "파일 크기 평균",
"Visits to file galleries" => "파일 갤러리 방문",
"Articles Stats" => "기사 통계",
"Total reads" => "총 읽은 수",
"Average reads per article" => "기사당 열람수 평균",
"Total articles size" => "기사크기 합계",
"Average article size" => "기사크기 평균",
"Forum Stats" => "게시판 통계",
"Total topics" => "토픽수 합계",
"Average topics per forums" => "게시판 당 평균 토픽 수",
"Total replies" => "총 댓글 수",
"Average number of replies per topic" => "토픽 당 답글의 평균 수",
"Visits to forums" => "게시판 방문수",
"Blog Stats" => "블로그통계",
"Weblogs" => "웹로그",
"Total posts" => "전체 포스트",
"Average posts per weblog" => "웹로그 당 평균 게시물",
"Total size of blog posts" => "블로그 포스트 전체 크기",
"Average posts size" => "평균 포스트 크기",
"Visits to weblogs" => "웹로그 방문",
"Poll Stats" => "투표 통계",
"Total votes" => "전체 투표수",
"Average votes per poll" => "투표 당 평균 표",
"FAQ Stats" => "FAQ 통계",
"Total questions" => "질문수 합계",
"Average questions per FAQ" => "FAQ당 질문 평균",
"User Stats" => "사용자 통계",
"Average bookmarks per user" => "사용자 당 평균 책갈피",
"Average questions per quiz" => "퀴즈 당 평균 질문",
"Quizzes taken" => "치뤄진 퀴즈",
"Average quiz score" => "퀴즈 점수 평균",
"Average time per quiz" => "퀴즈당 평균 시간",
"Most viewed objects in period" => "기간내에 가장 많이 본 개체",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "사용 차트",
"Usage chart image" => "사용 차트 이미지",
"Daily Usage" => "일일 사용량",
// "Piwik Analytics Dashboard" => "Piwik Analytics Dashboard",
// "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard" => "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard",
"Stats for surveys" => "설문에 대한 통계",
"Last taken" => "최종 치룸",
"Stats for survey" => "설문에 대한 통계",
// "Select a user to preview its answer (marked as" => "Select a user to preview its answer (marked as",
// "User voted" => "User voted",
// "Select User" => "Select User",
// "no answer" => "no answer",
"Tiki Logs" => "티키 로그",
"Export through Action Log" => "작업 로그를 통하여 내보내기",
"Clean logs older than" => "다음 기간보다 오래 된 로그 삭제",
// "Are you sure you want to revert" => "Are you sure you want to revert",
// "Revert" => "Revert",
"Time Left" => "잔여 시간",
"Send Answers" => "정답 전송",
"Thank you for your submission" => "제출해 주셔서 고맙습니다",
"Send a link to a friend" => "친구에게 링크 전송",
"Your email was sent" => "귀하의 이메일이 발송되었습니다",
"The link was sent to the following addresses" => "링크는 다음 주소로 발송되었습니다",
"Friend's email" => "친구의 이메일",
"Your comment" => "댓글",
"I found an interesting page that I thought you would like" => "귀하가 좋아할 만한 흥미있는 페이지를 발견하였습니다",
"TikiTests Edit" => "티키테스트 편집",
"Summary mode" => "요약 모드",
"Show Page Differences" => "페이지 차이점 표시",
"Show Tidy Errors and Warnings" => "작은 오류와 경고 표시",
"Show POST Data" => "POST 데이터 표시",
"Use Current Session/Log out" => "현재 세션/로그아웃 사용",
"Recorded Links" => "기록된 링크",
"Element to compare (Xpath expression)" => "비교할 요소 (Xpath 표현)",
"Test Xpath Expression" => "Xpath Expression 테스트",
"Post Variables" => "Post 변수",
"Tidy Results" => "Tidy 결과",
"Delete this link" => "이 링크 삭제",
"TikiTests List" => "티키테스트 목록",
"Config" => "구성",
"Replay" => "재생",
"Tidy extension not present" => "Tidy 확장기능 없음",
"PECL HTTP extension present" => "PECL HTTP 확장기능 존재함",
"cURL extension present" => "cURL 확장기능 존재함",
"PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP 및 cURL 확장기능 존재하지 않음. 티키테스트의 재생이 가능하지 않을 것입니다",
"List TikiTests" => "티키테스트 나열",
"Create a TikiTest" => "티키테스트 만들기",
"Replay the TikiTest" => "티키테스트 재생",
"Edit the TikiTest" => "티키테스트 편집",
"TikiTests Record Configuration" => "티키테스트 기록 구성",
"Start Recording Test" => "녹음 테스트 시작",
"TikiTests Replay Configuration" => "티키테스트 재생 구성",
"Failure" => "실패",
"Reference" => "참조",
"The pages are different" => "그 페이지들은 다릅니다",
"The pages are identical" => "그 페이즈들은 동일합니다",
"Recording to pause press the pause button" => "일시 정지할 녹음 일시 정지 버튼을 누릅니다",
"Pause the recording" => "기록 잠시 멈춤",
"Paused to resume press the play button" => "중단됨 재생 버튼을 눌러 계속",
"Resume the recording" => "기록 재시작",
"Stop the recording" => "녹음 중지",
"Control by Objects" => "개체에 의한 제어",
"Control by Sections" => "구역에 의한 제어",
"Assign themes to categories" => "범주에 테마를 할당",
"Assigned categories" => "할당된 범주",
// "Delete selected" => "Delete selected",
"Control by Categories" => "범주에 의한 제어",
"Assign themes to objects" => "개체로 테마 할당",
"Assigned objects" => "할당된 개체들",
"Assign themes to sections" => "구역으로 테마 할당",
"Assigned sections" => "할당된 구역",
// "Timesheets" => "Timesheets",
"Apply the following profile for enhancements: " => "향샹을 위해서 다음 프로필을 적용",
"Time Tracker" => "시간 트래커",
"Local Cache (Not Committed)" => "로컬 캐시 (커밋되지 않음)",
"Saved (Committed)" => "저장됨 (커밋됨)",
"New task" => "새 작업",
"Toggle completed" => "완료됨 토글",
"Toggle archived" => "보관됨 토글",
"Task name" => "작업명",
"Estimate (in min.)" => "추정 (분 단위)",
"Estimate" => "추정",
"Task is completed" => "작업이 완료되었습니다",
"Task is archived" => "작업이 보관되었습다",
"Created at" => "만든 시기",
"Are you sure you want to delete all tasks" => "모든 작업을 삭제하시겠습니까?",
"Commit Time Sheet Items" => "커밋 시간 시트 항목",
"View All" => "전체 보기",
"View My Items" => "내 항목 보기",
"Summary" => "요약",
"Time Spent" => "소요 시간",
"Done By" => "작업자",
"Add Tracker" => "트래커 추가",
"Add Tracker To Tracker Report" => "트래커 보고서에 트래커 추가",
"View Tracker Report" => "트래커 보고서 보기",
"Pick tracker to join" => "참여할 트래커 선택",
"Pick fields to join on" => "참여할 필드 선택",
"Join inner" => "내부 이음",
"Join outer" => "외부 이음",
"Tracker - Open" => "트래커 - 열림",
"Tracker - Pending" => "트래커 - 보유중",
"Tracker - Closed" => "트래커 - 닫힘",
"Tracker Item History" => "트래커 항목 기록",
"View Tracker Item" => "트래커 항목 보기",
"Not logging" => "기록 안 함",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable",
"Edit File" => "파일 편집",
"Advanced mode" => "고급 모드",
"Simple mode" => "단순 모드",
"Retry" => "재시도",
"Additional Info" => "부가 정보",
"Syntax Tips" => "구문 팁",
// "Download link using Tiki syntax" => "Download link using Tiki syntax",
// "Display an image using Tiki syntax" => "Display an image using Tiki syntax",
// "Use as a thumbnail with ShadowBox" => "Use as a thumbnail with ShadowBox",
// "Download link using HTML" => "Download link using HTML",
"You locked the file" => "이 파일을 잠그셨습니다",
"The file has been locked by {\$fileInfo.lockedby}" => "파일은  {\$fileInfo.lockedby}님이 잠궜습니다",
// "File title" => "File title",
"required field for podcasts" => "팟캐스트에 대한 요청된 필드",
// "File description" => "File description",
// "Re-upload from disk" => "Re-upload from disk",
// "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>" => "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>",
// "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "Unzip zip files" => "Unzip zip files",
"File can be deleted after" => "파일은 다음 기간 후 삭제될 수 있음",
// "OCR files if supported" => "OCR files if supported",
"Creator of file, if different from the 'Uploaded by' user" => "파일 만든이, 만약 '업로드 하신 분' 사용자와 다를 경우에 해당",
// "File Type" => "File Type",
// "No type" => "No type",
"Maximum number of downloads" => "다운로드이 최대 수",
"-1 for no limit" => "제한 없음에 대하여 -1",
"Upload File(s)" => "파일(들) 업로드",
"Add Another File" => "다른 파일 추가",
"Maximum file size is around:" => "파일 대략적 최대 크기:",
"Note: You are running IIS" => "주의: IIS 를 실행 중입니다",
"maxAllowedContentLength also limits upload size" => "maxAllowedContentLength 는 업로드 크기도 제한합니다",
"Please check web.config in the Tiki root folder" => "티키 루트 폴더 내의 웹 구성을 확인하십시오",
"Uploading file.." => "파일 업로드 중",
"No File to Upload..." => "업로드 할 파일 없음...",
// "Keeps a reference to the remote file" => "Keeps a reference to the remote file",
// "Video file uploaded" => "Video file uploaded",
"Link to file from a Wiki page" => "위키 페이지에서의 파일로 연결",
"For image files" => "그림 파일 용",
"Display full size" => "전체 크기 표시",
"Display thumbnail that enlarges" => "확대되는 미리보기 표기",
"Batch Upload Results" => "배치 업로드 결과",
"Upload successful" => "업로드 성공",
"The following image was successfully uploaded" => "다음의 그림이 성공적으로 업로드 되었습니다",
"Image ID thumb" => "그림 ID 축소보기",
"You can view this image in your browser using" => "다음을 사용해서 브라우저에서 그림을 볼 수 있습니다",
"You can include the image in an Wiki page using" => "다음을 사용하여 위키 페이지 내부에 그림을 포함할 수 있습니다",
"or use filename" => "혹은 파일명을 사용합니다",
"Now enter the image URL" => "그림 URL 입력",
"or upload a local image from your disk" => "혹은 디스크에서 로컬 이미지를 업로드합니다",
"Batch Upload" => "일괄 업로드",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "미리보기 (선택적, 자동 미리보기 생성을 재정의함)",
"No gallery available" => "제공되는 갤러리 없음",
"You have to create a gallery first" => "갤러리부터 먼저 만들어야 합니다",
"User assigned modules" => "사용자 할당 모듈",
// "to assign modules, which will make them available for creating a custom order on this page" => "to assign modules, which will make them available for creating a custom order on this page",
"Restore defaults" => "기본설정으로 복구",
"The column is disabled" => "열이 비활성화 되었습니다",
// "#" => "#",
"Move module up" => "모듈을 위로 이동",
"Move module down" => "모듈을 아래로 이동",
// "Move to right side" => "Move to right side",
// "Move to left side" => "Move to left side",
"Assign module" => "모듈 할당",
"top" => "상위",
"Current folder" => "현재폴더",
"Folders" => "폴더",
"Folder in" => "다음의 안의 폴더",
// "Refresh cache" => "Refresh cache",
"Admin folders and bookmarks" => "폴더와 책갈피 관리",
"a folder" => "폴더",
"a bookmark" => "책갈피",
"User Contacts Preferences" => "사용자 연락처 기본설정",
"Change preferences" => "선호설정 변경",
"Manage Fields" => "필드 관리",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{\$chdata.name}" => "{\$chdata.name}",
"Send me a message" => "나에게 메시지 전송",
"Basic Data" => "기본 데이터",
// "Assign group" => "Assign group",
"Assign Group" => "그룹 할당",
"User Icon" => "사용자 아이콘",
// "{\$gender}" => "{\$gender}",
"(non public)" => "(공용 아님)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
"User's homepage" => "사용자의 홈페이지",
"Personal Wiki Page" => "개인 Wiki 페이지",
// "Your relationship with other users" => "Your relationship with other users",
// "Relationship of this user to you" => "Relationship of this user to you",
"The user has chosen to make his information private" => "사용자가 자신의 정보를 개인적으로 할 것을 선택했습니다",
"Additional Information" => "부가 정보",
"Change user information" => "사용자 정보 변경",
"User Contribution" => "사용자 기여내역",
"has contributed to the following content" => "다음 컨텐츠에 기여하였습니다 ",
"has not contributed to any content yet" => "그 어떠한 컨텐츠에도 아직 기여하지 않았습니다",
"Blogs Posts" => "블로그 게시물",
"Forum comments" => "게시판 댓글들",
"Forum topics" => "게시판 토픽들",
"Who Looks at Items" => "누가 보았나",
"Who Looks at Your Items" => "귀하의 것을 누가 보았나",
"Who Looks at His or Her Items" => "이 사람의 것을 누가 보았나",
"Send Me A Message" => "나에게 메시지 전송",
"Send me a message " => "나에게 메시지 전송",
"The following message will be sent to user" => "다음의 메시지가 사용자에게 발송될 것입니다",
"Message Body" => "메시지 본문",
// "My Mail-in" => "My Mail-in",
// "Are you sure you want to delete the routing rule" => "Are you sure you want to delete the routing rule",
// "Configure how your mailed-in wiki pages are to be linked / organized" => "Configure how your mailed-in wiki pages are to be linked / organized",
// "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked" => "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked",
// "Only newly created pages, using the mail-in wiki-put function, are affected" => "Only newly created pages, using the mail-in wiki-put function, are affected",
// "Go to wiki structure setting" => "Go to wiki structure setting",
"Toggle options" => "선택사항 토글",
"Male" => "남성",
"Female" => "여성",
// "Your Personal Wiki Page" => "Your Personal Wiki Page",
"User's personal tracker information" => "사용자의 개인 트래커 정보",
"View extra information" => "추가 정보 보기",
"Your personal tracker information" => "귀하의 개인 트래커 정보",
// "Is email public" => "Is email public",
"Unavailable - please set your email below" => "사용할 수 없음 - 아래에 이메일을 설정하십시오",
// "Preferred perspective" => "Preferred perspective",
// "Email character set" => "Email character set",
// "Admin Language" => "Admin Language",
"Can you read more languages?" => "다른 언어를 읽을 수 있습니까?",
// "Other languages you can read" => "Other languages you can read",
"Select language..." => "언어 선택...",
// "Select from the dropdown to add automatically to the list below" => "Select from the dropdown to add automatically to the list below",
// "Displayed timezone" => "Displayed timezone",
"Detect user time zone if browser allows, otherwise site default" => "브라우저가 허용하는 경우 사용자 시간대 감지, 그외 사이트 기본값 사용",
// "Site time zone <strong>%0</strong> is enforced and overrides user preferences" => "Site time zone <strong>%0</strong> is enforced and overrides user preferences",
// "Use 12-hour clock in time selectors" => "Use 12-hour clock in time selectors",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "자신의 정보 공개를 허용한 모든 사용자에 대하여 마우스를 가져가면 정보 툴팁을 표기",
"User Messages" => "사용자 메시지",
"Notify sender when reading his mail" => "메일을 읽을 때 보낸이에게 알림",
// "Message priority notification" => "Message priority notification",
// "Read message auto-archiving" => "Read message auto-archiving",
"never" => "하지 않음",
// "Auto-archive read messages after selected days" => "Auto-archive read messages after selected days",
"User Tasks" => "사용자 작업",
// "XMPP account JID" => "XMPP account JID",
// "If empty, Tiki will provide default value" => "If empty, Tiki will provide default value",
// "You have to provide this when using custom XMPP server" => "You have to provide this when using custom XMPP server",
"My user items" => "내 사용자 항목",
// "My articles" => "My articles",
"My level" => "내 등급",
// "Remember which remarksbox (alert box) you have closed and don't show them again" => "Remember which remarksbox (alert box) you have closed and don't show them again",
// "Reset remark boxes visibility" => "Reset remark boxes visibility",
// "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed" => "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed",
"Account Information" => "계정 정보",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "현재 암호를 유지하려면 \"새 암호\" 와 \"새 암호 확인\"을 빈 칸으로 두십시오",
"Confirm new password:" => "새 비밀번호 확인:",
"Current password (required)" => "현재 비밀번호 (필수)",
"Account Deletion" => "계정 삭제",
"Are you really sure you want to delete the account %0" => "%0 계정을 정말 삭제하시겠습니까",
"Check this box if you really want to delete the account" => "계정 삭제가 확실할 경우에만 이 상자를 체크하십시오",
"Delete the account:" => "계정 삭제:",
"Delete my account" => "내 계정 삭제",
"Task list" => "작업 목록",
"Admin mode off" => "관리 모드 꺼짐",
"Admin mode on" => "관리 모드 켜짐",
"Task help" => "작업 도움말",
"Empty Trash" => "휴지통 비우기",
"Task received" => "수신된 작업",
"You received this task" => "이 작업을 받았습니다",
"Task sent" => "발송된 작업",
"You sent this task to another user" => "다른 사용자에게 이 작업을 보냈습니다",
"Task shared by a group" => "그룹에 의해 공유된 작업",
"Task is shared by a group" => "작업은 그룹에 의해 공유됩니다",
"Accepted by task user and creator" => "작업 사용자와 만든이에 의해 승인됨",
"Task has been accepted by user and creator" => "작업이 사용자와 만든이에 의하여 승인되었습니다",
"Rejected by a user" => "사용자에 의하여 거부됨",
"Task has been rejected by a user" => "작업이 사용자에 의하여 거부되었습니다",
"Waiting for me" => "나를 위하여 대기 중",
"Task has not yet been accepted or rejected by you" => "작업이 귀하에 의하여 승인되거나 거부되지 않았습니다",
"Waiting for other user" => "다른 사용자를 위하여 대기 중",
"Task has not yet been accepted or rejected by another user" => "작업이 아직 다른 사용자에 의하여 승인되거나 거부되지 않았습니다",
"Admin Mode" => "모드 관리",
"Edit Task" => "작업 편집",
"NOT accept" => "허용 안됨",
"Remove from Trash" => "휴지통에서 제거",
"Move to trash" => "휴지통으로 이동",
"Move to Trash" => "휴지통으로 이동",
"Task saved" => "저장된 작업",
"View Task" => "작업 보기",
"Open a new task" => "새 작업 열기",
"Last Version" => "마지막 버전",
"taskId" => "작업ID",
"Task user" => "작업 사용자",
"Only the creator can delete this task" => "만든이만이 이 작업을 삭제할 수 있습니다",
"Use start date and time" => "시작 날짜와 시간 사용",
"Use end date and time" => "종료 날짜와 시간 사용",
"Open / In Process" => "열림 / 처리 중",
"Waiting / Not Started" => "대기 중 / 시작하지 않음",
"Percentage completed" => "완료된 백분율",
"Waiting" => "대기 중",
"Shared for Group" => "그룹에 대하여 공유됨",
"Accepted by User" => "사용자에 의하여 수락됨",
"No / Rejected" => "아니오 / 거절됨",
"Accepted by Creator" => "만든이에 의해 승인됨",
"This message will be send to users if you are makeing changes of assigned tasks" => "이 메시지는 할당된 작업에 변경을 가하는 경우 사용자아게 발송될 것입니다",
"Send a message with changes" => "변경내역과 함께 메시지 전송",
"Modified by" => "수정하신 분",
"Marked as deleted" => "삭제로 표시",
"Inform task user by email" => "작업 사용자에게 이메일로 알림",
"Reload" => "재 로드",
"You can only view this task" => "이 작업 만 볼 수 있습니다",
"In the trash" => "휴지통 안에",
"Not Accepted by One User" => "한 사용자에 의하여 허용되지 않음",
"Not Accepted User" => "승인되지 사용자 아님",
"No tasks entered" => "입력된 작업 없음",
"Select One" => "하나를 선택하십시오",
"Trash" => "휴지통",
"Undo Trash" => "휴지통 실행 취소",
"Received" => "수신됨",
"Submitted" => "제출됨",
"Shared" => "공유됨",
"All Shared Tasks" => "모든 공유된 작업들",
// "Previous version" => "Previous version",
// "Next version" => "Next version",
"completed (100%)" => "완료됨 (100%)",
"Public for group" => "그룹에 대하여 공용",
// "Wikis" => "Wikis",
// "Forum Threads" => "Forum Threads",
// "{\$userinfo['user_country']|stringfix}" => "{\$userinfo['user_country']|stringfix}",
// "{\$userinfo['user_gender']}" => "{\$userinfo['user_gender']}",
// "This user has contributed to the following wiki pages" => "This user has contributed to the following wiki pages",
// "This user has not contributed to any wiki pages yet" => "This user has not contributed to any wiki pages yet",
// "This user has not contributed any blog posts yet" => "This user has not contributed any blog posts yet",
// "This user has contributed to the following tracker items" => "This user has contributed to the following tracker items",
// "This user has not contributed to any tracker items yet" => "This user has not contributed to any tracker items yet",
// "This user has contributed to the following articles" => "This user has contributed to the following articles",
// "This user has not contributed to any articles yet" => "This user has not contributed to any articles yet",
// "This user has started to the following forum threads" => "This user has started to the following forum threads",
// "This user has not contributed to any forums yet" => "This user has not contributed to any forums yet",
// "Add to Network" => "Add to Network",
// "Remove from Network" => "Remove from Network",
"User Watches and preferences" => "사용자 주시 및 기본설정",
"You need to set your email to receive email notifications" => "이메일 알림을 받을 귀하의 이메일을 설정해야 합니다",
"Use reports to summarise notifications about objects you are watching" => "주시하는 개체에 관한 알림을 요약하기 위하여 보고서 사용",
"Use reports" => "보고서 사용",
// "Reporting interval" => "Reporting interval",
"Every minute" => "매 분",
"Hourly" => "시간당",
"Monthly" => "월간",
// "Report length" => "Report length",
"Short report" => "짧은 보고서",
"Detailed report" => "세부 보고서",
// "Report format" => "Report format",
// "Send report even if no activity" => "Send report even if no activity",
"My watches" => "내 주시",
"Use \"watches\" to monitor wiki pages or other objects" => "위키 페이지 혹은 다른 개체를 감시하려면 \"주시\"를 사용",
// "Watch new items by clicking the {icon name='watch'} button on specific pages" => "Watch new items by clicking the {icon name='watch'} button on specific pages",
"Add Watch" => "주시 추가",
"Select event type" => "이벤트 유형 선택",
"All watched events" => "모든 주시 이벤트",
"A user submits a blog post" => "사용자가 블로그 게시물을 제출하였습니다",
"A user posts a forum thread" => "사용자가 게시판 대화목록에 게시하였습니다",
"A user posts a forum topic" => "사용자가 게시판 토픽에 게시하였습니다",
"A user edited or commented on a wiki page" => "사용자가 위키페이지를 편집하거나 댓글을 달았습니다",
"A user edited a wiki page" => "사용자가 위키 페이지를 편집하였습니다",
// "{\$w.type}" => "{\$w.type}",
"Use this form to control notifications about objects you are watching" => "주시하는 개체에 대한 알림을 제어하기 위하여 이 양식 사용",
// "Send notification when I am the editor" => "Send notification when I am the editor",
"Used space" => "사용된 공간",
"up to" => "다음까지",
"no limit for admin" => "권리자에 대한 제한 없음",
"User Menu" => "사용자 메뉴",
"May need to refresh twice to see changes" => "변경 내역을 보려면 새로 고침을 두 번해야할 수 있습니다",
"Add top level bookmarks to menu" => "메뉴에 상단 레벨 즐겨찾기 추가",
"Add or edit an item" => "항목을 추가 혹은 편집",
"New Window" => "새 윈도우",
"replace window" => "창 교체",
"Delete Selected" => "선택된 것 제거",
// "Pos" => "Pos",
// "User_versions_for" => "User_versions_for",
// "Monitor articles" => "Monitor articles",
// "Stop monitoring articles" => "Stop monitoring articles",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
// "\"}Actions for %0" => "\"}Actions for %0",
"No articles yet." => "아직 기사 없음.",
// "New article" => "New article",
"Banner stats" => "배너통계",
"Create new banner" => "새 배너 만들기",
"Banner Information" => "배너 정보",
"Click ratio" => "클릭 비율",
"Weekdays" => "주중",
"mon" => "월",
"tue" => "화",
"wed" => "수",
"thu" => "목",
"fri" => "금",
"sat" => "토",
"sun" => "일",
"Banner raw data" => "배너 원형 데이터",
"Cached" => "캐시됨",
"This is a cached version of the page" => "이는 페이지의 캐시된 버전입니다",
"Click here to view the Google cache of the page instead" => "페이지의 구글 캐시 내용을 대신 보려면 여기를 클릭",
// "{\$faq_info.title}" => "{\$faq_info.title}",
"There are no questions in this FAQ" => "이 FAQ에는 질문이 없습니다",
"Answers" => "답변",
"Add Suggestion" => "제안 추가",
"Edit Forum" => "게시판 편집",
"Forum List" => "게시판 목록",
// "Forum actions" => "Forum actions",
// "Monitor topics" => "Monitor topics",
// "Stop monitoring topics" => "Stop monitoring topics",
// "Monitor topics and threads" => "Monitor topics and threads",
// "Stop monitoring topics and threads" => "Stop monitoring topics and threads",
// "Group monitor topics" => "Group monitor topics",
// "Group monitor topics and threads" => "Group monitor topics and threads",
"Post New" => "새 게시",
"Deliberation" => "심의",
"Add Deliberation Item" => "Deliberation 항목 추가",
"Watch for replies" => "댓글을 주시",
"Send me an email when someone replies to my topic" => "내 토픽에 누군가 댓글을 올리면 이메일을 나에게 보냄",
"Don't send me any emails" => "나에게 이메일 보내지 않음",
"Enter your name" => "이름을 입력하십시오",
// "Editing posts" => "Editing posts",
// "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax" => "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax",
// "Moderator actions on selected topics" => "Moderator actions on selected topics",
// "Emot" => "Emot",
// "Rating <br/>(avg/max)" => "Rating <br/>(avg/max)",
// "Detailed results <br/>(counts)" => "Detailed results <br/>(counts)",
// "Detailed results <br/>(counts/%)" => "Detailed results <br/>(counts/%)",
"pts" => "점",
// "Topic locked" => "Topic locked",
// "Forum locked" => "Forum locked",
// "No topics found" => "No topics found",
"posts in this forum" => "이 게시판의 게시물",
// "Filter Posts" => "Filter Posts",
"Last post date" => "마지막 게시 날짜",
"All posts" => "모든 포스트",
"Last hour" => "마지막 시간",
"Last 24 hours" => "마지막 24 시간",
"Last 48 hours" => "마지막 48 시간",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "일반",
"announce" => "발표",
"hot" => "뜨거움",
"Posts with no replies" => "답글이 없는 게시물",
"Topic List" => "토픽 목록",
"The post has been reported and will be reviewed by a moderator" => "게시물이 보고되었으며 중재자에 의하여 검토될 것입니다",
// "Previous topic" => "Previous topic",
// "Next topic" => "Next topic",
"You are viewing a reply to" => "다음에 대한 답글을 보고 계십니다",
// "Thread actions" => "Thread actions",
// "Print this page" => "Print this page",
"Print all pages" => "모든 페이지 인쇄",
"Show posts:" => "게시물 보기:",
"Jump to forum" => "게시판으로 이동",
"View Invoice" => "청구서 보기",
"Invoice %0" => "청구서 %0",
"Date Issued %0" => "발행된 날짜 %0",
"Amount: %0" => "양: %0",
"Payment Terms: %0" => "지불 조건: %0",
// "This sheet is already being edited by %0" => "This sheet is already being edited by %0",
"Back to Page" => "페이지로 복귀",
"Tiki Sheet" => "티키 시트",
"Save current spreadsheet" => "현재 스프레드시트 저장",
"Cancel editing current spreadsheet" => "현재 스프레드시트 편집 취소",
"No parse" => "구문문석 없음",
"What would you like to add" => "추가하고 싶은 항목",
"New spreadsheet" => "새 스프레드시트",
"Existing spreadsheet" => "기존 스프레드시트",
"Tracker as a spreadsheet" => "스프레드시트로써 트래커",
"Spreadsheet from file gallery" => "파일 갤러리에서의 스프레드시트",
"Cell" => "셀",
"Set Reference" => "참조 설정",
"Un-Merge" => "병함 해제",
"Adds an additional row to bottom of the spreadsheet" => "스프레드시트의 하단에 행 추가",
"Add Row" => "행 추가",
"Adds an additional rows to bottom of the spreadsheet" => "스프레드시트의 하단에 행 추가",
"Add Multi-Rows" => "다중 행 추가",
"Delets the current row thats highlighted" => "하이라이트된 현재 행 삭제",
"Delete Row" => "행 삭제",
"Inserts an additional row after currently selected row" => "현재 선택된 행 뒤에 추가 행을 삽입합니다",
"Insert Row Before" => "전에 행을 삽입",
"Insert Row After" => "뒤에 행을 삽입",
"Unhides all the hidden rows" => "모든 숨겨진 행 숨기기 취소",
"Show All" => "전체 표시",
"Hides or shows the currently selected row" => "현재 선택된 행 표시 혹은 숨김",
"Toggle Hide Row" => "행 감춤 토글",
"Adds an additional column to the right of the spreadsheet" => "스프레드시트의 우측에 열 추가",
"Add Column" => "열 추가",
"Adds an additional columns to the right of the spreadsheet" => "스프레드시트의 우측에 열 추가",
"Add Multi-Columns" => "다중 열 추가",
"Deletes the current column thats highlighted" => "하이라이트된 현재 열 삭제",
"Delete Column" => "열 삭제",
"Inserts an additional column after currently selected column" => "현재 선택된 열 뒤에 추가 열을 삽입합니다",
"Insert Column Before" => "열을 이전에 삽입",
"Insert Column After" => "열을 이후에 삽입",
"Fill down current cell value" => "현재 셀 값을 아래로 채우기",
"Fill Down" => "아래로 채우기",
"Fill up current cell value" => "현재 셀 값 채우기",
"Fill Up" => "위로 채우기",
"Unhides all the hidden columns" => "모든 숨겨진 열 숨기기 취소",
"Hides or shows the currently selected column" => "현재 선택된 열 숨김 혹은 표시",
"Toggle Hide Column" => "열 감춤 토글",
"Add new spreadsheet" => "새 스프레드시트 추가",
"Add Spreadsheet" => "스프레드시트 추가",
"Delete the current spreadsheet" => "현재 스프레드시트 삭제",
"Delete Spreadsheet" => "스프레드시트 삭제",
"Recompiles the current sheet" => "현재 시트 재 컴파일",
"Change the title of the sheet" => "시트의 제목 변경",
"Wrap Cell Range" => "Wrap 셀 범위",
"Wrap with SUM" => "SUM으로 Wrap",
"Wrap with CEILING" => "CEILING으로 Wrap",
"Wrap with COUNT" => "COUNT로 Wrap",
"Wrap with MAX" => "MAX로Wrap",
"Wrap with MIN" => "MIN으로 Wrap",
"Redo" => "다시 하기",
"Toggle State" => "상태 토글",
"Function Reference" => "기능 참조",
"Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "사용예: =SUM(SUM(A1:B1) + SUM(D7))",
// "=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
"Returns the absolute value of a number" => "숫자의 절대값 반환",
"Returns a rounded number" => "반올림한 숫자 반환",
"Returns a number rounded up based on a multiple of significance" => "중요성의 복수에 기반하여 반올림한 숫자 반환",
"Counts the number of cells that contain a value" => "한 값을 포함하는 셀들의 수",
"Counts full days from a specific date - format(YYYY,MM,DD)" => "특정 날짜에서 날짜 전체 세기 - 서식(YYYY.MM.DD)",
"Converts a number to text, using a currency format - options(number, decimals, symbol)" => "숫자를 텍스트로 변환, 통화 서식을 사용 - 선택사항 (숫자, 소숫점, 심볼)",
"Returns a logical value of FALSE" => "FALSE 의 논리값 반환",
"Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "소수자리의 지정된 수로 반올림된 수의 텍스트 표기를 반환 - 선택사항 (숫자, 소수자리, 쉼표사용)",
"Returns a number rounded down based on a multiple of significance" => "중요성의 복수에 기반하여 반내림한 수 반환",
"Returns the integer portion of a number" => "숫자의 정수 부분 반환",
"Returns the largest value from the numbers provided" => "제공된 숫자들에서 가장 큰 값 반환",
"Returns the smallest value from the numbers provided" => "주어진 숫자들에서 가장 작은 값 반환",
"Converts a value to a number" => "숫자로의 값으로 변환",
"Gets full date of today" => "오늘의 전체 날짜 받기",
"Returns the mathematical constant called pi, which is 3.14159265358979" => "파이라고 불리는 수학적 상수를 반환, 이는 3.14159265358979",
"Returns the result of a number raised to a given power" => "주어진 거듭제곱으로 올려진 숫자의 결과 반환",
"Returns a random number that is greater than or equal to 0 and less than 1" => "0보다 같거나 크고 1보다 작은 임의의 수를 반환",
"Returns a number rounded to a specified number of digits" => "지정된 숫자의 수로 반올림된 숫자 반환",
"Returns all of the values in each of the specified cells and added together" => "지정된 셀의 각각의 값의 전부와 과 함께 더해진 값을 반환",
"Returns a logical value of TRUE" => "TRUE 의 논리값 반환",
"Converts a text value that represents a number to a number" => "숫자를 나타내는 텍스트 값을 숫자로 변환",
"Italics" => "기울임꼴",
"Uppercase" => "대문자",
"Capitalize" => "첫글자를 대문자로",
"Lowercase" => "소문자",
"Font Size +" => "폰트 크기 +",
"Font Size -" => "폰트 크기 -",
// "{\$tracker_info.name}" => "{\$tracker_info.name}",
// "Tracker actions" => "Tracker actions",
// "Group Monitoring" => "Group Monitoring",
// "Stop Watching" => "Stop Watching",
"atts" => "특성",
"List Attachments" => "첨부파일 나열",
"View/Edit" => "보기/편집",
"Insert New Item" => "새 아이템 삽입",
"View inserted item" => "삽입된 항목 보기",
"Insert new item" => "새 아이템",
"Synchronization" => "동기화",
"This tracker is a remote copy of <a href=\"%0\">%0</a>" => "이 트래커는 <a href=\"%0\">%0</a> 의 원격 사본입니다",
"It was last updated on %0" => "%0 에 갱신되었습니다",
"Reload field definitions" => "필드 정의 다시 로드",
"Items added locally" => "항목이 지역적으로 추가됨",
"Push new items" => "새 항목 푸시",
"Safe modifications (no remote conflict)" => "안전 수정 (원격 충돌 없음)",
"Dangerous modifications (remote conflict)" => "위험한 수정 (원격 충돌)",
"On push, local items will be removed until data reload" => "푸시할 때 로컬 항목들이 데이터가 다시 로드 될때까지 삭제될 것입니다",
"Push local changes" => "로컬 변경 푸시",
"Local changes will be lost" => "로컬 변경내역은 손실될 것입니다",
"When reloading the data from the source, all local changes will be lost" => "데이터를 소스에서 다시 로드할 때, 모든 로컬 변경사항은 손실될 것입니다",
"New items that must be preserved should be pushed using the above controls" => "보관되어야만 하는 새 항목들은 위의 제어를 사용하여 푸시되어야합니다",
"Modifications that must be preserved should be replicated" => "보존되어야만 하는 수정은 복제되는 것이 좋습니다",
"Without conflicts: Using the above controls" => "충돌 없음: 위 제어 사용",
"With conflicts: Manually on the source" => "충돌 있음: 소스 상에 수작업으로",
"Using the above controls will cause information loss" => "위의 제어를 사용하는 것은 정보 손실을 야기할 것입니다",
"Reload data from source" => "소스에서 데이터 다시 로드",
// "Tracker item actions" => "Tracker item actions",
"Move to another tracker" => "다른 트래커로 이동",
// "Save Returning to Item List" => "Save Returning to Item List",
// "Save and Comment" => "Save and Comment",
"Special Operations" => "특별 작업",
"close" => "닫기",
"Open Tiki WebDAV (Wiki pages) as WebFolder" => "티키 WebDAV (위키페이지)를 웹폴더로 열기",
"Open Tiki WebDAV as WebFolder" => "티키 WebDAV를 웹폴더로 열기",
"Parent page" => "부모 페이지",
// "Manage Stucture" => "Manage Stucture",
"Child" => "자식",
"page id:" => "페이지 id:",
// "Please wait" => "Please wait",
// " The PDF is being prepared, please wait.." => " The PDF is being prepared, please wait..",
// "Show structure" => "Show structure",
// "Hide structure bar and any toc" => "Hide structure bar and any toc",
"Hide structure" => "구조체 숨기기",
// "Page actions" => "Page actions",
// " PDF" => " PDF",
// "Warning:mPDF Package Missing" => "Warning:mPDF Package Missing",
// "Click to toggle on/off" => "Click to toggle on/off",
// "Edit icons" => "Edit icons",
"Wysiwyg" => "WYSIWYG",
// "Send link" => "Send link",
// "Monitor page" => "Monitor page",
// "Stop monitoring page" => "Stop monitoring page",
// "Monitor sub-structure" => "Monitor sub-structure",
// "Stop monitoring sub-structure" => "Stop monitoring sub-structure",
// "Group monitor structure" => "Group monitor structure",
// "Profiles Wizard" => "Profiles Wizard",
// "Changes Wizard" => "Changes Wizard",
// "Configuration Wizard" => "Configuration Wizard",
// "steps" => "steps",
// "User Wizard" => "User Wizard",
// "Wizard Steps" => "Wizard Steps",
// "Change Theme" => "Change Theme",
// "Change Transition" => "Change Transition",
// "Convex" => "Convex",
// "Concave" => "Concave",
// " Handouts" => " Handouts",
// "Exit Slideshow" => "Exit Slideshow",
"More types available" => "추가 유형 사용가능",
// "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>",
"Description contains wiki syntax" => "설명은 위키 문법을 포함합니다",
"Restrict visibility to administrators" => "표시가능여부를 관리자에게만 제한",
"Useful if you are working on a live tracker" => "라이브 트래커 상에서 작업 시 유용함",
"Add Field &amp; Edit Advanced Options" => "필드 추가 &amp; 고급 선택사항 편집",
// "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)" => "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)",
// "Clear All" => "Clear All",
"Options for %0" => "%0 에 대한 선택사항",
"Separate multiple with commas" => "여러 개를 쉼표로 분리",
// "Separate multiple with &quot;{\$def.separator}&quot" => "Separate multiple with &quot;{\$def.separator}&quot",
"Error Message" => "오류 메시지",
"Visible by all" => "전체에게 보임",
"Visible by all but not in RSS feeds" => "모두에게 표시되지만 RSS 피드에서는 표시되지 않음",
// "Visible after creation by administrators only" => "Visible after creation by administrators only",
"Editable by administrators only" => "관리자만 편집 가능",
// "Editable after creation by administrators only" => "Editable after creation by administrators only",
"Editable by administrators and creator only" => "관리자와 만든이만 편집 가능",
"Immutable after creation" => "만들기 후 변경 불가능함",
"Creator requires a user field with auto-assign to creator (1)" => "만든이는 만든이 (1) 에게 자동할당되는 사용자 필드가 필요합니다",
"Visible by" => "다음에게 보임",
// "List of Group names with permission to see this field" => "List of Group names with permission to see this field",
// "Separated by comma (,)" => "Separated by comma (,)",
"Editable by" => "편집가능하신 분",
// "List of Group names with permission to edit this field" => "List of Group names with permission to edit this field",
"Changing the permanent name may have consequences in integrated systems" => "영구적 이름을 변경하면 통합 시스템 내부에서 여파가 있을 수 있음",
// "Changing the field type may cause irretrievable data loss - use with caution" => "Changing the field type may cause irretrievable data loss - use with caution",
// "Make sure you rebuild the search index if you change field type" => "Make sure you rebuild the search index if you change field type",
// "Deprecated" => "Deprecated",
// "To export tracker or tracker items please" => "To export tracker or tracker items please",
// "enable" => "enable",
// "and use" => "and use",
// "Tracker Tabular" => "Tracker Tabular",
// "It is easy to use, optimised and far more powerful" => "It is easy to use, optimised and far more powerful",
"Export Tracker Items" => "트래커 항목들 내보내기",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
"Delimitor (left)" => "구분기호 (좌측)",
"Delimitor (right)" => "구분기호 (우측)",
"Carriage return inside field value" => "필드 값 내부의 캐리지 리턴",
"Export dates as UNIX Timestamps to facilitate importing" => "가져오기를 용이하게 하기 위하여 날짜를 유닉스 타임스탬프로 내보내기",
"Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "ItemLink 유형 필드들을 링크된 항목의 항목ID로 내보내기 (가져오기를 용이하게 하기 위함)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
"Parse as wiki text" => "위키 텍스트로 구문분석",
"Generic information" => "일반 정보",
"Number of records" => "기록물의 수",
"First record" => "첫 기록",
"Quick Export" => "빠른 내보내기",
"Produce a CSV with basic formatting" => "CSV 를 기본 서식적용으로 작성",
// "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'" => "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'",
"Tracker Export" => "트래커 내보내기",
// "Copy the definition text above and paste into the Import Structure box for a new tracker" => "Copy the definition text above and paste into the Import Structure box for a new tracker",
"Profile Export" => "프로필 내보내기",
"Produce YAML for a profile" => "프로필에 대하여 YAML 작성",
"Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "링크된 트래커와 필드 ID (예를 들면ItemLink, ItemsList 필드 선택사항 안에 참조된 것과 같음) 는 현재 프로필 개체 참조로 변환되지 않으므로 수동으로 교체가 필요합니다",
"For example: \$profileobject:field_ref\$" => "예를 들면: \$profileobject:field_ref\$",
"Export Profile" => "프로필 내보내기",
"Fields Export" => "내보내기",
// "Copy the definition text above and paste into the Import Fields box on a tracker's fields page" => "Copy the definition text above and paste into the Import Fields box on a tracker's fields page",
"YAML Export" => "YAML 내보내기",
"Profile for trackerId %0" => "트래커ID %0 에 대한 프로필",
"Raw data" => "원형 데이터",
"Preserve tracker ID" => "트래커 ID 유지",
"Use \"Tracker -> Export -> Structure\" to produce this data" => "이 데이터를 생산하려면 \"트래커 -> 내보내기 -> 구조체\" 를 사용",
// "Tracker import completed" => "Tracker import completed",
"Return to Trackers" => "트래커로 돌아가기",
"Import fields for this tracker" => "이 트래커에서 필드 가져오기",
"Raw Fields" => "Raw 필드",
"Preserve Field IDs" => "필드 ID 유지",
"Confirmation" => "확인",
"Imported file '%0'" => "파일 '%0' 가져옴",
"Import completed with '%0'" => "가져오기가 '%0' 로 완료됨",
// "To import items into a tracker please" => "To import items into a tracker please",
"The order of the fields does not matter, but you need to add a header with the field names" => "필드의 순서는 상관없지만, 필드명과 함께 헤더를 추가해야 합니다",
// "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import" => "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import",
"Auto-incremented itemid fields shall be included with no matter what values" => "자동 증분되는 항목ID 필드들은 값에 상관없이 포함될 것입니다",
// "If you are having problems, try a different line ending for your csv file that matches the server operating system" => "If you are having problems, try a different line ending for your csv file that matches the server operating system",
"UNIX Timestamp" => "유닉스 타임스탬프",
"Character encoding" => "캐릭터 인코딩",
"Create as new items" => "새 항목으로 만들기",
"Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "만약 항목을 갱신한다면, lastModif (마지막 수정) 날짜 갱신 (상태와 만듬은 필드가 csv 내부에 지정되어 있을 경우에만 갱신)",
// "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance" => "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance",
// "Please note: This is an experimental new feature - work in progress" => "Please note: This is an experimental new feature - work in progress",
// "YAML" => "YAML",
// "Create another" => "Create another",
// "Do you really want to remove the \"%0\" tracker" => "Do you really want to remove the \"%0\" tracker",
// "Please note" => "Please note",
// "This tracker, its fields and all of its %0 items will be permanently removed from your system" => "This tracker, its fields and all of its %0 items will be permanently removed from your system",
"Are you sure you want to remove the fields? Data will be lost" => "필드를 삭제하시겠습니까? 데이터가 손실될 것입니다",
"Remove Fields" => "필드 제거",
"Return to field administration" => "필드 관리로 돌아가기",
// "Replacement" => "Replacement",
// "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one" => "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one",
"Description is wiki-parsed" => "설명은 위키 구문분석되어 있습니다",
// "Field Prefix" => "Field Prefix",
"Allow ratings (deprecated, use rating field)" => "등급 허용 (사용되지 않음, 등급 필드 사용)",
"Rating options" => "범위 선택사항",
"Show ratings in listing" => "목록에 등급 표시",
"Show comments in listing" => "목록에 댓글 표시",
"Display last comment author and date" => "마지막 댓글 저자와 날짜 표시",
// "Allow attachments (deprecated, use files field)" => "Allow attachments (deprecated, use files field)",
"Display attachments in listing" => "나열 내부에 첨부파일 표시",
"Attachment attributes (sortable)" => "첨부파일 속성 (정렬가능)",
// "Recommended size: 64x64px" => "Recommended size: 64x64px",
"Show status to tracker administrator only" => "상태를 트래커 관리자에게만 표시",
"Show creation date when listing items" => "항목 나열 시 만든 날짜 표시",
"Creation date format" => "만든 날짜 서식",
"Show item creator" => "항목 만든이 보기",
"Show creation date when viewing items" => "항목을 볼 때 만든 날짜 보기",
"Show last modification date when listing items" => "항목 나열 시 최종 수정 날짜 보기",
"Show item last modifier" => "항목 최종 수정자 보기",
"Modification date format" => "수정 날짜 형식",
"Show last modification date when viewing items" => "항목 볼 때 최종 날짜 보기",
"Hide empty fields from item view" => "항목 보기에서 비어있는 필드 감춤",
"List detail popup" => "상세내역 팝업 나열",
// "Section Format" => "Section Format",
"Section format" => "부분 서식",
"Determines how headers will be rendered when using header fields as form section dividers" => "서식 구역 분리자로써 헤더 필드를 사용할 때 헤더들이 어떻게 렌더될 것인지를 결정함",
// "Set to <em>Configured</em> to use the four following fields" => "Set to <em>Configured</em> to use the four following fields",
// "Use Form Classes" => "Use Form Classes",
// "Input Form Classes" => "Input Form Classes",
// "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)" => "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)",
"Template to display an item" => "항목을 표기할 템플릿",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "위키 페이지에 대하여 wiki:pageName 혹은 템플릿에 대하여 tpl:tplName",
"Template to edit an item" => "항목을 편집할 템플릿",
"New item status" => "새 항목 상태",
"Modified item status" => "수정된 항목 상태",
"No change" => "변경 없음",
"Default status displayed in list mode" => "나열 모드 내부에 표시될 기본 상태",
"Copy activity to email" => "활동을 이메일로 복사",
"Use simplified email format" => "단순화된 이메일 양식 사용",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "트래커는 제목으로써 Subject(제목)이란 이름의 텍스트 필드를 사용합니다. 그리고 발신인으로써는 사용자 이메일 혹은 익명사용자에 대하여 이메일 필드를 사용할 것입니다",
"Publish RSS feed for this tracker" => "이 트래커애 대하여 RSS 피드 게재",
"Requires \"RSS per tracker\" to be set in Admin/RSS" => "\"트래커 당 RSS\" 가 관리/RSS 에 설정되는 것이 필수임",
"(Currently set)" => "(현재 설정)",
"(Currently not set)" => "(현재 설정되지 않음)",
"Group alerted on item modification" => "항목 수정 시 그룹 알림",
"Allow user selection for small groups" => "작은 그룹에 대한 사용자 선택 허용",
// "User can see his own items" => "User can see his own items",
// "The tracker needs a user field with the item-owner activated" => "The tracker needs a user field with the item-owner activated",
// "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user" => "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user",
"Item creator can modify his items" => "항목 만든이는 자신의 항목을 수정 가능",
"The tracker needs a user field with the auto-assign activated" => "트래커는 자동할당이 활성화된 사용자 필드가 필요합니다",
"Item creator can remove his items" => "항목 만든이는 자신의 항목을 삭제 가능",
"User can take ownership of item created by anonymous" => "사용자는 익명사용자가 만든 항목의 소유권을 가질 수 있습니다",
"Only one item per user or IP" => "사용자 혹은 IP 당 한 항목만",
"The tracker needs a user or IP address field with the auto-assign set to Creator" => "트래커는 사용자 혹은 만든이에게 자동할당된 IP 주소 필드가 필요합니다",
"Members of the creator group can modify items" => "만든이 그룹의 멤버들은 항목들을 수정할 수 있습니다",
"The tracker needs a group field with the auto-assign activated" => "트래커는 자동할당이 활성화된 그룹 필드가 필요합니다",
"Members of the creator group can remove items" => "만든이 그룹의 멤버들은 항목들을 삭제할 수 있습니다",
"Restrict non admins to wiki page access only" => "비관리자를 위키 페이지 접근으로만 제한",
"Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports" => "트래커 권한 관리 (tiki_p_admin_trackers)를 보유한 사용자들만이 내장 트래커 인터페이스(tiki-view_tracker.php 와 tiki-view_tracker_item.php)를 사용할 수 있습니다. 이는 서식과 보고서를 입베드 할 다양한 트래커 플러그인을 사용할 수 있는 위키 페이지를 통해서만 이러한 트래커로의 접근하는 것을 원할 때 유용합니다",
"Creation date constraint" => "만든 날짜 제약 조건",
// "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below" => "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below",
"Before" => "앞",
"Auto-create corresponding categories" => "상응하는 범주들을 자동 만들기",
"Create a group for each item" => "각 항목에 대하여 그룹 만들기",
"Groups will include" => "그룹은 다음을 포함합니다",
"Creator is assigned to the group" => "만든이가 그룹에 할당되었습니다",
"Will become the creator's default group" => "만든이의 기본그룹이 됨",
"Will become the new item's group creator" => "새 항목의 그룹 만든이가 됨",
"Copy the default group in the field ID before updating the group" => "그룹을 업데이트하기 전에 필드 ID 내에 기본 그룹 복사",
"Non Advanced Search or Natural Search" => "비 고급 검색 혹은 자연 검색",
"Advanced Search or Boolean Search" => "고급 검색 혹은 불린 검색",
"Objects that contain the more terms are rated higher in the results and will appear first in their type" => "더 많은 조건을 포함하는 개체들이 결과 안에서 더 높게 평가되며 그들의 유형안에서 처음으로 표시될 것입니다",
"objects that include both terms" => "두 조건을 포함하는 개체",
"Requiring terms" => "요구 조건",
"Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => " <em>반드시</em> 라는 용어가 결과에 나타나야한다는 것을 지정하기 위하여, 용어 앞에 더하기 부호 ( + ) 를 추가합니다",
"Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "예제: <strong>+wiki forum</strong> 은 최소한 <strong>위키i</strong> 를 포함하는 개체를 찾을 것입니다. 두 조건 보유하고 조건의 많은 발생 수를 보유한 개체들이 먼저 나타날 것입니다",
"Excluding terms" => "제외된 조항들",
"Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => " <em>절대 불가</em> 라는 용어가 결과에 나타나야한다는 것을 지정하기 위하여, 용어 앞에 빼기 부호 ( - ) 를 추가합니다",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>",
"Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "예제: <strong>-wiki forum</strong> 은 <strong>위키</strong> 는 포함하지 않지만 <strong>게시판</strong> 은 포함하는 개체들을 찾을 것입니다",
"Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "예제: <strong>+wiki +(forum blog)</strong> 는 순서에 상관없이 <strong>위키</strong> 와 <strong>블로그</strong> 를 포함하는 개체를 찾을 것입니다",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed" => "정확한 순서대로 조건을 찾기 위한, 입력된 것과 일치하는, 문구 주위에 따옴표 사용",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "예: <kbd>\"Alex Bell\"</kbd> 은 <strong>Bell Alex</strong> 혹은 <strong>Alex G. Bell</strong> 을 찾지 못할 것입니다. ",
"Using wildcards" => "와일드카드를 사용",
"Add an asterisk ( * ) after a term to find objects that include the root word" => "루트 단어를 포함하는 개체들을 찾기 위하여 용어에 별표 ( * ) 를 추가하시오",
"For example, <strong>run*</strong> will find" => "예를 들면, <strong>run*</strong> 은 다음을 찾을 것입니다",
"objects that include the term <strong>run</strong>" => "<strong>실행</strong> 조건을 포함할 개체들",
"objects that include the term <strong>runner</strong>" => "<strong>실행자</strong> 조건을 포함할 개체들",
"objects that include the term <strong>running</strong>" => "<strong>실행 중</strong> 조건을 포함할 개체들",
"Reducing a term's value" => "조항의 값 축소 중",
"Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "결과의 순위로의지정용어의 가치를 줄이기 위하여 물결 표시 ( ~ ) 를 용어 앞에 추가합니다",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)",
"Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>" => "예제: <strong>+wiki ~forum</strong> 은 <strong>위키</strong> 만 보유한 개체를 <strong>위키</strong> 와  <strong>게시판</strong>를 보유한 개체보다 높게 등급을 부여할 것입니다",
"Changing relevance value" => "관련 값을 변경함",
"Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "개체에 할당된  전체적 관련 값에 조항의 기여도를 변경하기 위하여 미만 ( &lt; ) 혹은 초과 ( &gt; ) 표시를 기간 앞에 추가",
"Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "예: <strong>+wiki +(&gt;forum &lt; blog)</strong> 는 <strong>wiki</strong> 및 <strong>forum</strong> 혹은 <strong>wiki</strong> 및 <strong>blog</strong> 를 담는 개체를 순서 여부 상관없이 찾을 것입니다. <strong>wiki forum</strong> 은 더 높게 등급이 주어질 것입니다",
// "{\$confirmation_message}" => "{\$confirmation_message}",
// "\"}Are you sure you want to set this %0 to \"open\"" => "\"}Are you sure you want to set this %0 to \"open\"",
// "\"}Are you sure you want to set this %0 to \"pending\"" => "\"}Are you sure you want to set this %0 to \"pending\"",
// "\"}Are you sure you want to set this %0 to \"closed\"" => "\"}Are you sure you want to set this %0 to \"closed\"",
// "{\$field.name|truncate:65|escape}" => "{\$field.name|truncate:65|escape}",
"Hold \"Ctrl\" in order to select multiple values" => "여러 값을 선택하려면 \"컨트롤\"키를 누르고 계십시오",
// "{\$field_name}" => "{\$field_name}",
// "{\$description}" => "{\$description}",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
"Admin Fields" => "필드 관리",
"It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "원격 사이트 상에서 이 데이터를 접근하기 위해서는 인증이 필요하게 될 가능성이 큽니다. DSN 관리에서 인증 소스를 구성하십시오",
"Search for trackers to clone" => "복제할 트래커에 대하여 검색",
"After" => "뒤",
"Do you really want to remove the scheduled event" => "스케줄된 이벤트를 정말로 삭제하길 원하십니까?",
// "Remove event" => "Remove event",
"No events registered" => "등록된 이벤트 없음",
"Reference date" => "참조 날짜",
"After creation" => "만든 이후",
"After last modification" => "최종 수정 이후",
"Delay prior to status change" => "상태 변경 이전의 변경",
"Mail subject text" => "메일 제목 텍스트",
"Mail body ressource" => "메일 본문 자원",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "위키 페이지에 대하여 wiki:pageName 혹은 템플릿에 대하여 tplName.tpl",
// "Existing Article" => "Existing Article",
// "Article URL" => "Article URL",
"(automatically generated after item creation)" => "(항목 만들어진 후 자동으로 생성됨)",
// "Change Event" => "Change Event",
"Attached files limitation" => "첨부된 파일 제한",
"The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved" => "첨부될 수 있는 파일들의 수는 <strong>%0</strong>으로 제한되었습니다. 최신 파일들이 보과될 것입니다",
"Browse files" => "파일 탐색",
// "Browse Files" => "Browse Files",
// "Link to existing Vimeo URL" => "Link to existing Vimeo URL",
"Type or paste the URL and press ENTER" => "URL을 입력 혹은 붙여넣기하고 엔터를 누르십시오",
// "You do not have permission to upload files to this gallery" => "You do not have permission to upload files to this gallery",
// "You do not have permission to add a member to a group" => "You do not have permission to add a member to a group",
"Select Icon" => "아이콘 선택",
// "Remove image" => "Remove image",
"Are you sure you want to delete this image" => "이 그림을 삭제하시겠습니까",
// "{\$field.options_map.addItems|escape}" => "{\$field.options_map.addItems|escape}",
"Add Media" => "미디어 추가",
"Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19" => "형식: x,y,zoom 에서 x 경도, y 는 위도. Zoom 은 0 (지구 보기) 와 19 사이",
// "This bug has been demonstrated on {\$field.options_map.domain|escape}" => "This bug has been demonstrated on {\$field.options_map.domain|escape}",
// "Please demonstrate your bug on {\$field.options_map.domain|escape}" => "Please demonstrate your bug on {\$field.options_map.domain|escape}",
// "Bug needs to be created first" => "Bug needs to be created first",
// "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created" => "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created",
// "Show.tiki.org snapshot creation is in progress" => "Show.tiki.org snapshot creation is in progress",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"",
// "Password reset" => "Password reset",
// "Password reset was successful" => "Password reset was successful",
// "Password reset failed" => "Password reset failed",
// "Show.tiki.org instance destruction in progress" => "Show.tiki.org instance destruction in progress",
// "Show.tiki.org instance destruction is in progress... Please wait.." => "Show.tiki.org instance destruction is in progress... Please wait..",
// "Show.tiki.org is not configured properly" => "Show.tiki.org is not configured properly",
// "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks" => "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks",
// "Show.tiki.org is currently unavailable" => "Show.tiki.org is currently unavailable",
// "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Show.tiki.org is under maintenance" => "Show.tiki.org is under maintenance",
// "Show.tiki.org is currently under maintenance. Sorry for the inconvenience" => "Show.tiki.org is currently under maintenance. Sorry for the inconvenience",
// "Unable to get information from {\$field.options_map.domain|escape}" => "Unable to get information from {\$field.options_map.domain|escape}",
// "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Instance is being created" => "Instance is being created",
// "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks" => "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks",
// "About {\$field.options_map.domain|escape}" => "About {\$field.options_map.domain|escape}",
// "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}" => "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}",
// "Create {\$field.options_map.domain|escape} instance" => "Create {\$field.options_map.domain|escape} instance",
// "Accessing the Tiki instance that demonstrates this bug" => "Accessing the Tiki instance that demonstrates this bug",
// "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0" => "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"",
// "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0" => "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0",
// "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload" => "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload",
// "Snapshots" => "Snapshots",
// "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation" => "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0",
// "Create new snapshot" => "Create new snapshot",
// "Destroy this {\$field.options_map.domain|escape} instance" => "Destroy this {\$field.options_map.domain|escape} instance",
// "Reset password to 12345" => "Reset password to 12345",
// "SVN update" => "SVN update",
// "Debug Mode Information" => "Debug Mode Information",
// "Get instance information and refresh cache" => "Get instance information and refresh cache",
// "Filter by group" => "Filter by group",
// "Select user(s)" => "Select user(s)",
// "View stand alone wiki page" => "View stand alone wiki page",
// "Source of wiki page" => "Source of wiki page",
// "History of wiki page" => "History of wiki page",
// "No articles" => "No articles",
"Administrator intervention required" => "관리자 개입 요구됨",
// "Tags is not enabled" => "Tags is not enabled",
"LastModif" => "최종변경",
"You did not vote yet" => "아직 투표하지 않았습니다",
"My rating" => "내 등급",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "이 값에 대하여 투표하려면 클릭",
// "Remove your rating" => "Remove your rating",
// "%0 element(s)" => "%0 element(s)",
"Language: %0" => "언어: %0",
// "You have subscribed" => "You have subscribed",
"You have not yet subscribed" => "아직 구독하지 않았습니다",
// "with" => "with",
"friends" => "친구",
// "Translation.." => "Translation..",
// "No language assigned" => "No language assigned",
// "Set page language" => "Set page language",
// "Set article language" => "Set article language",
"Current language" => "현재 언어",
"Show all translations of this page on a single page" => "한 페이지에 이 페이지의 모든 번역을 표시",
"All languages" => "모든 언어",
"Machine translations" => "기계 번역",
"Translate page" => "페이지 번역",
"Manage page translations" => "페이지 번역 관리",
"Translate article" => "기사 번ㅌ역",
"Manage article translations" => "기사 번역 관리",
"Are you sure you want to detach these translations" => "이 번역들을 분리하시겠습니까",
"Current translation set" => "현재 번역 설정",
// "Detach translation" => "Detach translation",
"Are you sure you want to detach the translation" => "이 번역을 분리하시겠습니까",
"No translations available at this time" => "현재 제공되는 번역 없음",
"Add a new object to the set" => "세트에 새 개체 추가",
"All possible translations exist" => "모든 가능한 번역이 존재함",
// "Email this wiki page" => "Email this wiki page",
// "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki" => "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki",
// "Bcc" => "Bcc",
// "Enter a valid email to send a blind copy to (optional)" => "Enter a valid email to send a blind copy to (optional)",
// "%0 away" => "%0 away",
// "Shared groups" => "Shared groups",
// "Friendship" => "Friendship",
// "Add to or remove from" => "Add to or remove from",
// "Add to" => "Add to",
// "Remove from" => "Remove from",
// "These groups" => "These groups",
// "Use Ctrl+Click or Command+Click to select multiple options" => "Use Ctrl+Click or Command+Click to select multiple options",
// "Set default group" => "Set default group",
// "Remove users" => "Remove users",
// "Remove the users' pages" => "Remove the users' pages",
// "Remove the user pages belonging to these users" => "Remove the user pages belonging to these users",
// "Delete user items from these trackers" => "Delete user items from these trackers",
// "Warning: Experimental" => "Warning: Experimental",
// "Select trackers here to have items in them which are \"owned\" by these users deleted" => "Select trackers here to have items in them which are \"owned\" by these users deleted",
// "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically" => "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically",
// "Delete user files" => "Delete user files",
// "Delete the users' file galleries and all the files in them" => "Delete the users' file galleries and all the files in them",
// "Ban users" => "Ban users",
// "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning" => "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning",
// "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided" => "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided",
// "Cancel login process" => "Cancel login process",
// "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login" => "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login",
// "Birth date" => "Birth date",
// "Validate your age and proceed to login" => "Validate your age and proceed to login",
// "I approve the above terms and conditions" => "I approve the above terms and conditions",
// "I Decline, log out" => "I Decline, log out",
"However, no account is associated to the OpenID identifier" => "하지만, OpenID 식별자와 연결된 계정이 없습니다",
"If you use an email filter, be sure to add %0 to your accepted list" => "이메일 필터를 사용하시면, %0 를 승인된 목록에 추가하여 주십시오",
"Associate OpenID with an existing Tiki account" => "OpenID 를 기존의 티키 계정에 연결",
// "Browse for video file to upload" => "Browse for video file to upload",
// "Upload Progress" => "Upload Progress",
// "Vimeo Setup Error" => "Vimeo Setup Error",
// "{\$errMsg}" => "{\$errMsg}",
// "Available space: %0 megabytes" => "Available space: %0 megabytes",
// "No standard definition uploads available currently" => "No standard definition uploads available currently",
// "No high definition uploads available currently" => "No high definition uploads available currently",
// "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines" => "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines",
// "You will also need to rebuild your caches and search index" => "You will also need to rebuild your caches and search index",
// "Re-generate URLs" => "Re-generate URLs",
// "The following item(s) include page(s) being deleted and will break" => "The following item(s) include page(s) being deleted and will break",
// "Remove {\$idesc}" => "Remove {\$idesc}",
// "Create redirect" => "Create redirect",
// "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)" => "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)",
// "Redirect to" => "Redirect to",
"Use this thread to discuss the page" => "페이지를 논의하기 위하여 이 대화상자를 사용",
"Missing or incorrect trackerId parameter for the plugin" => "플러그인에 대한 트래커ID 매개 변수 없거나 틀림",
"List Trackers" => "트래커 목록",
// "resource day" => "resource day",
// "resource month" => "resource month",
// "resource year" => "resource year",
// "resource week" => "resource week",
// "list day" => "list day",
// "list month" => "list month",
// "list year" => "list year",
// "list week" => "list week",
"list" => "목록",
// "agenda month" => "agenda month",
// "agenda week" => "agenda week",
// "agenda day" => "agenda day",
// "{\$params.label|escape}" => "{\$params.label|escape}",
"Subtract" => "빼기",
"Meeting ID" => "회의 ID",
"Current attendees" => "현재 참석자",
"No attendees at this time" => "현재 참석자 없음",
"Last time we checked, the room you requested did not exist" => "저희가 최근 학인한 바, 요청하신 방은 존재하지 않았습니다",
"Current recordings" => "현재 기록물",
"On %0 from %1 to %2" => "%0상 %1에서 %2까지",
"This will permanently remove the recording" => "기록을 영구 삭제할 것입니다",
"(including audio recording & chat log)" => "(음성 녹음과 채팅 기록을 포함)",
// "{\$button_label}" => "{\$button_label}",
// "{\$moretext|escape}" => "{\$moretext|escape}",
// "{\$ftptitle}" => "{\$ftptitle}",
// "No permission to change the following task" => "No permission to change the following task",
// "Project update not possible as you lack rights for updating a parent project" => "Project update not possible as you lack rights for updating a parent project",
// "Start date is a milestone" => "Start date is a milestone",
// "End date is a milestone" => "End date is a milestone",
// "Task has constraints" => "Task has constraints",
// "Error: there is a dependency on an open task" => "Error: there is a dependency on an open task",
// "Error: due to a descendant of a closed task" => "Error: due to a descendant of a closed task",
// "This task has external dependencies" => "This task has external dependencies",
// "GANNT_ERROR_LOADING_DATA_TASK_REMOVED" => "GANNT_ERROR_LOADING_DATA_TASK_REMOVED",
// "Cannot depend on ancestors" => "Cannot depend on ancestors",
// "The data inserted are invalid for the field format" => "The data inserted are invalid for the field format",
// "An error has occurred while loading the data. A task has been trashed" => "An error has occurred while loading the data. A task has been trashed",
// "Cannot close a task with open issues" => "Cannot close a task with open issues",
// "You cannot exchange tasks of different depth" => "You cannot exchange tasks of different depth",
// "Sem" => "Sem",
// "Cannot move task" => "Cannot move task",
// "Please save your project" => "Please save your project",
// "Error: date settings" => "Error: date settings",
// "Cannot depend on descendants" => "Cannot depend on descendants",
// "code/short name" => "code/short name",
// "start" => "start",
// "dur" => "dur",
// "depe" => "depe",
// "assignees" => "assignees",
// "completed" => "completed",
// "suspended" => "suspended",
// "undefined" => "undefined",
// "Task editor" => "Task editor",
// "is milestone" => "is milestone",
// "status" => "status",
// "progress" => "progress",
// "Assignments" => "Assignments",
// "Role" => "Role",
// "est.wklg" => "est.wklg",
"Number of Users" => "사용자의 수",
"Percentage of Total" => "전체의 백분율",
// "Email address of invitee" => "Email address of invitee",
"Set in these groups" => "이 그룹 내부에 설정",
// "Number of result" => "Number of result",
"Message sent to" => "메시지가 다음 분께 발송",
"Email sent to" => "이메일이 다음으로 발송되었습니다",
// "recipients" => "recipients",
// "Message preview" => "Message preview",
// "Number of Recipients" => "Number of Recipients",
"Send Mail" => "메일 전송",
"Send to users" => "사용자에게 보내기",
"Send to" => "다음으로 전송",
"Email address (if more than one, separated by \",\")" => "쉼표로 구분된 이메일",
"Send to groups" => "그룹으로 전송",
"Preview Mail" => "메일 미리보기",
// "You will receive a copy of the email yourself. Please give it a few minutes" => "You will receive a copy of the email yourself. Please give it a few minutes",
// "Please wait while your email is being sent.." => "Please wait while your email is being sent..",
// "Previous npm-asset/pdfjs-dist package has been deprecated" => "Previous npm-asset/pdfjs-dist package has been deprecated",
// "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package" => "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package",
"Check to remove" => "삭제하려면 체크",
// "Contents of email to be sent to user" => "Contents of email to be sent to user",
// "Append custom message" => "Append custom message",
// "Approve user" => "Approve user",
// "Reject user" => "Reject user",
"Add in group" => "그룹 내에 추가",
"Set as default group for users" => "사용자에 대하여 기본 그룹으로 설정",
"Join myself" => "자신을 참여",
"Leave myself" => "자신 나가기",
"Cost for one period" => "한 기간에 대한 가격",
"Free for the rest of the current period, a prorated value of" => "현재 기간의 잔여에 대하여 무료, 비례배분 값",
"Prorated cost for first period" => "첫 기간에 대한 배율적용된 가격",
"Special offer! Free additional periods" => "특가 판매! 추가 무료 기간",
// "Membership to %0 for %1 for %2 %3" => "Membership to %0 for %1 for %2 %3",
"separated by |" => "| 로 분리됨",
// "{\$periodslabel}" => "{\$periodslabel}",
// "vs" => "vs",
// "Mine" => "Mine",
// "Save Changes" => "Save Changes",
// "Edit Pivot Table" => "Edit Pivot Table",
// "Click to view interactive SCORM learning object" => "Click to view interactive SCORM learning object",
// "Download original file" => "Download original file",
"Re-Apply" => "재적용",
"wrote" => "작성함",
// "{\$wp_emptymsg}" => "{\$wp_emptymsg}",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
"Last Day" => "마지막 날",
"Last Week" => "지난 주",
// "{\$action}" => "{\$action}",
"Groups you are in" => "귀하가 속한 그룹",
"(This is an included group)" => "(포함된 그룹입니다)",
"(You are a leader)" => "(당신이 지도자입니다)",
"Your default group" => "귀하의 기본 그룹",
"Leave Group" => "그룹 나가기",
"Manage Group" => "그룹 관리",
"Change default group" => "기본 그룹 변경",
"Subscribe to a group" => "그룹에 구독",
"Groups you can join" => "귀하가 참여할 수 있는 그룹",
"This group requires approval to join" => "이 그룹에서는 참가하려면 승인을 요구합니다",
"Subscribe to groups" => "그룹에 구독",
"Subscription confirmed" => "구독 확인됨",
"Subscribe to the newsletter" => "회보에 구독",
"Mini TimeSheet" => "미니 시간작업표",
"Full View" => "전체 보기",
// "End tour" => "End tour",
// "-- Choose an option --" => "-- Choose an option --",
// "{\$export_action}" => "{\$export_action}",
"Map View" => "맵 뷰",
// "Field error" => "Field error",
"Stop Monitor" => "모니터 중지",
"Tracker - " => "트래커 - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
"Close item" => "항목 닫기",
"Open item" => "항목 열기",
"Pend item" => "항목 보류",
// "{\$params.label}" => "{\$params.label}",
"Please login first" => "먼저 로그인하십시오",
"Toggle display" => "표시 토글",
"Page approved by %0 on %1" => "페이지가 %0님에 의하여 %1에 승인되었습니다",
"Page last modified on %0 by %1" => "페이지는 %0 에 %1 님에 의하여 최종 수정되었습니다",
"Created by %0" => "%0 님이 만듬",
"Last Modification: %0 by %1" => "마지막 수어: %1 님에 의한 %0",
"Save the page as a partial translation" => "페이지를 일부만 번역으로 저장",
"Partial Translation" => "부분 번역",
"Save the page as a completed translation" => "페이지를 완료된 번역으로 저장",
"Complete Translation" => "번역 완료",
"Save the page, but do not count it as new content to be translated" => "페이지 저장 하지만 번역될 새 컨텐츠로 인정하지 않음",
"Save the page, but do not send notifications and do not count it as new content to be translated" => "페이지 저장 하지만 알림을 전송하지 않으며 번역될 새 컨텐츠로 인정하지 않음",
"Save Minor Edit" => "사소한 편집 저장",
"Save the page" => "페이지 저장",
// "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions" => "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions",
// "Workspaces UI in doc.tiki.org" => "Workspaces UI in doc.tiki.org",
// "Enable using the same wiki page name in different contexts" => "Enable using the same wiki page name in different contexts",
// "E.g. ns1:_:MyPage and ns2:_:MyPage" => "E.g. ns1:_:MyPage and ns2:_:MyPage",
// "Workspaces & Areas admin panel" => "Workspaces & Areas admin panel",
// "Automatic table of contents for a wiki page" => "Automatic table of contents for a wiki page",
// "Auto TOC options" => "Auto TOC options",
// "Auto TOC" => "Auto TOC",
// "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc" => "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc",
// "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu" => "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu",
// "Set up categories here" => "Set up categories here",
// "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages" => "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages",
// "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there" => "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there",
// "Configure general user & community features and settings related to sharing and social networks" => "Configure general user & community features and settings related to sharing and social networks",
// "Add a <b>User and Registration tracker</b>" => "Add a <b>User and Registration tracker</b>",
// "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users" => "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users",
// "Some uses of this type of tracker could be" => "Some uses of this type of tracker could be",
// "To collect user information (such as mailing address or phone number)" => "To collect user information (such as mailing address or phone number)",
// "To require the user to acknowledge a user agreement" => "To require the user to acknowledge a user agreement",
// "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)" => "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)",
// "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually" => "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually",
// "apply profile now" => "apply profile now",
// "new window" => "new window",
// "To set up the <strong>User Watches</strong> and their associated settings, visit the page to " => "To set up the <strong>User Watches</strong> and their associated settings, visit the page to ",
// "Community General Settings" => "Community General Settings",
// "admin panel" => "admin panel",
// "in doc.tiki.org" => "in doc.tiki.org",
// "Sharing & Networking" => "Sharing & Networking",
// "Social Network" => "Social Network",
// "Friendship and Followers" => "Friendship and Followers",
// "Set the site time zone and format for displaying dates and times" => "Set the site time zone and format for displaying dates and times",
// "Date and Time options" => "Date and Time options",
// "Date and Time admin panel" => "Date and Time admin panel",
// "Select editor type" => "Select editor type",
// "Only Plain Text Editor (Disable Wysiwyg)" => "Only Plain Text Editor (Disable Wysiwyg)",
// "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>" => "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>",
// "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page" => "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page",
// "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor" => "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor",
// "Set up the main Tiki features. The wiki and file gallery features are always enabled" => "Set up the main Tiki features. The wiki and file gallery features are always enabled",
// "Main Tiki features" => "Main Tiki features",
// "Tiki has many more features" => "Tiki has many more features",
// "Global Features" => "Global Features",
// "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made" => "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made",
// "Set up the file gallery and attachments" => "Set up the file gallery and attachments",
// "Choose to store them either in the database or in files on disk, among other options" => "Choose to store them either in the database or in files on disk, among other options",
// "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder" => "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder",
// "elFinder" => "elFinder",
// "Wiki admin panel" => "Wiki admin panel",
// "File storage" => "File storage",
// "Set elFinder as the default file gallery viewer" => "Set elFinder as the default file gallery viewer",
// "File Gallery storage" => "File Gallery storage",
// "Attachment storage" => "Attachment storage",
// "Select the site language" => "Select the site language",
// "Language options" => "Language options",
// "Configure the log-in, registration and validation preferences for the new accounts" => "Configure the log-in, registration and validation preferences for the new accounts",
// "Registration and log-in options" => "Registration and log-in options",
// "Login admin panel" => "Login admin panel",
// "Configure the Tiki theme and other look & feel preferences" => "Configure the Tiki theme and other look & feel preferences",
// "Look & Feel options" => "Look & Feel options",
// "Look & Feel admin panel" => "Look & Feel admin panel",
// "Namespace settings" => "Namespace settings",
// "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>" => "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>",
// "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)" => "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)",
// "Basic Search" => "Basic Search",
// "Uses MySQL full-text search" => "Uses MySQL full-text search",
// "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below" => "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below",
// "Advanced Search" => "Advanced Search",
// "Uses Unified Search Index with a specified search engine" => "Uses Unified Search Index with a specified search engine",
// "If you have issues with Advanced Search, simply revert to Basic Search" => "If you have issues with Advanced Search, simply revert to Basic Search",
// "Unified Search is required by a number of other features, e.g. the community friendship network" => "Unified Search is required by a number of other features, e.g. the community friendship network",
// "Other settings" => "Other settings",
"Also see the Search Indexing tab here" => "또한 여기의 검색 색인 탭을 보십시오",
// "Search admin card" => "Search admin card",
// "Search in doc.tiki.org" => "Search in doc.tiki.org",
// "Hierarchical organization of wiki pages" => "Hierarchical organization of wiki pages",
// "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage" => "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage",
// "Structures options" => "Structures options",
// "Set up the text area environment (Editing and Plugins)" => "Set up the text area environment (Editing and Plugins)",
// "Editing and plugins admin panel" => "Editing and plugins admin panel",
// "Set up the Wiki environment" => "Set up the Wiki environment",
// "Wiki environment" => "Wiki environment",
// "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar" => "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar",
// "Requires Java" => "Requires Java",
// "Verify your Java installation" => "Verify your Java installation",
// "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages" => "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages",
// "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>" => "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>",
// "Get Started" => "Get Started",
// "Congratulations! You now have a working instance of Tiki %0" => "Congratulations! You now have a working instance of Tiki %0",
// "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below" => "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below",
// "Mouse over the icons to know more about the features and preferences that are new for you" => "Mouse over the icons to know more about the features and preferences that are new for you",
"Example: " => "예: ",
// "Help icon" => "Help icon",
// "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it" => "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it",
// "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic" => "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic",
// "Configuration Profiles Wizard" => "Configuration Profiles Wizard",
// "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>" => "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>",
// "They are like the <b>Macros</b> from many computer languages" => "They are like the <b>Macros</b> from many computer languages",
// "It is best to apply them from the start and you can always preview and reverse the process" => "It is best to apply them from the start and you can always preview and reverse the process",
// "Configuration Profiles" => "Configuration Profiles",
// "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you" => "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you",
// "If you are new to Tiki administration, we recommend that you start with this approach" => "If you are new to Tiki administration, we recommend that you start with this approach",
// "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below" => "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below",
// "Start Configuration Profiles Wizard (Macros)" => "Start Configuration Profiles Wizard (Macros)",
// "Configuration Walkthrough" => "Configuration Walkthrough",
// "Alternatively, you may use the <b>Configuration Wizard</b>" => "Alternatively, you may use the <b>Configuration Wizard</b>",
// "This will guide you through the most common preference settings in order to customize your site" => "This will guide you through the most common preference settings in order to customize your site",
// "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc" => "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc",
// "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further" => "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further",
// "Start Configuration Wizard" => "Start Configuration Wizard",
// "Or you may use the <b>Changes Wizard</b>" => "Or you may use the <b>Changes Wizard</b>",
// "This will guide you through the most common new settings and informations in order to upgrade your site" => "This will guide you through the most common new settings and informations in order to upgrade your site",
// "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version" => "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version",
// "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels" => "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels",
// "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site" => "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site",
// "Start Changes Wizard" => "Start Changes Wizard",
// "Use the <b>Control Panels</b> to manually browse through the full list of preferences" => "Use the <b>Control Panels</b> to manually browse through the full list of preferences",
// "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings" => "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings",
// "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with" => "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with",
// "Explore the control panels and configure your Tiki manually" => "Explore the control panels and configure your Tiki manually",
// "Go to the Control Panels" => "Go to the Control Panels",
// "You can check if your server meets the requirements for running Tiki version %0" => "You can check if your server meets the requirements for running Tiki version %0",
// "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly" => "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly",
// "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback" => "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback",
// "Check your server fitness" => "Check your server fitness",
// "Go to the Tiki Server Compatibility Check" => "Go to the Tiki Server Compatibility Check",
// "You are done with the admin wizard" => "You are done with the admin wizard",
// "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin" => "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user",
// "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were" => "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were",
// "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode" => "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode",
// "Wysiwyg editor" => "Wysiwyg editor",
// "Select the Wysiwyg editor mode" => "Select the Wysiwyg editor mode",
// "Compatible Wiki mode" => "Compatible Wiki mode",
// "Use wiki syntax for saved pages" => "Use wiki syntax for saved pages",
// "This is the most compatible with Tiki functionality and the most stable editor mode" => "This is the most compatible with Tiki functionality and the most stable editor mode",
// "Tools and functions in the editor toolbar will be limited" => "Tools and functions in the editor toolbar will be limited",
// "HTML mode" => "HTML mode",
// "Use HTML syntax for saved pages" => "Use HTML syntax for saved pages",
// "Best compatibility with inline editing" => "Best compatibility with inline editing",
// "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL" => "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL",
// "Full editor toolbar" => "Full editor toolbar",
// "Wysiwyg admin panel" => "Wysiwyg admin panel",
// "Documentation site" => "Documentation site",
// "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>" => "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>",
// "To see it in full size out of this frame" => "To see it in full size out of this frame",
// "Main new features and settings in Tiki 13" => "Main new features and settings in Tiki 13",
// "Tiki13" => "Tiki13",
// "Tiki13 is a post-LTS version" => "Tiki13 is a post-LTS version",
// "It will be supported until 14.1 is released" => "It will be supported until 14.1 is released",
// "The requirements increased (IE9, PHP 5.5)" => "The requirements increased (IE9, PHP 5.5)",
// "Major changes have happened, including moving to Bootstrap" => "Major changes have happened, including moving to Bootstrap",
// "New Themes" => "New Themes",
// "Site layouts (based on 'Bootstrap')" => "Site layouts (based on 'Bootstrap')",
// "The changes in this area were refactored in Tiki 14" => "The changes in this area were refactored in Tiki 14",
// "Goal, Recognition and Rewards" => "Goal, Recognition and Rewards",
// "Main new features and settings in Tiki 14" => "Main new features and settings in Tiki 14",
// "Tiki14" => "Tiki14",
// "Tiki14 is a standard non-LTS version" => "Tiki14 is a standard non-LTS version",
// "It will be supported until 15.1 is released" => "It will be supported until 15.1 is released",
// "The requirements are the same as in the previous version (IE9, PHP 5.5)" => "The requirements are the same as in the previous version (IE9, PHP 5.5)",
// "Minor changes have happened, compared to post-LTS versions such as Tiki13" => "Minor changes have happened, compared to post-LTS versions such as Tiki13",
// "New modules" => "New modules",
// "A new module called <strong>Module zone</strong> was added" => "A new module called <strong>Module zone</strong> was added",
// "Module zone" => "Module zone",
// "New module meant to provide a horizontal 'navigation bar' for the website" => "New module meant to provide a horizontal 'navigation bar' for the website",
// "Tiki Addons" => "Tiki Addons",
// "Addons allow a way for developers to add an even broader range of functionality" => "Addons allow a way for developers to add an even broader range of functionality",
// "Addons" => "Addons",
// "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase" => "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase",
// "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki" => "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki",
// "Other new features" => "Other new features",
// "Improved and extended features" => "Improved and extended features",
// "See the full list of changes" => "See the full list of changes",
// "Main new features and settings in Tiki 15" => "Main new features and settings in Tiki 15",
// "Tiki15" => "Tiki15",
// "Tiki15 is an LTS version" => "Tiki15 is an LTS version",
// "As it is a Long-Term Support (LTS) version, it will be supported for 5 years" => "As it is a Long-Term Support (LTS) version, it will be supported for 5 years",
// "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended" => "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended",
// "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki" => "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki",
// "In Tiki 15, an addons repository was added" => "In Tiki 15, an addons repository was added",
// "New Wiki Plugins" => "New Wiki Plugins",
// "Social Networks with Linkedin" => "Social Networks with Linkedin",
// "Temporary User Accounts" => "Temporary User Accounts",
// "Display more information here" => "Display more information here",
// "You can use this feature through: " => "You can use this feature through: ",
// "Admin Users > Temporary Users (tab)" => "Admin Users > Temporary Users (tab)",
// "Statistics Control Panel" => "Statistics Control Panel",
"You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "이 기능을 사용할 때, 파일 갤러리 저장공간으로로써 파일 디렉터리를 사용할 것을 적극 권장합니다",
// "Console" => "Console",
// "There is a console.php command to set a scheduled batch upload cron task" => "There is a console.php command to set a scheduled batch upload cron task",
// "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)" => "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)",
// "Removed features" => "Removed features",
"Synchronize categories of user tracker item to user groups" => "사용자 트래커 항목의 범주를 사용자 그룹으로 동기화",
// "Main new and improved features and settings in Tiki 16" => "Main new and improved features and settings in Tiki 16",
// "Tiki16" => "Tiki16",
// "Tiki16 is a standard non-LTS version" => "Tiki16 is a standard non-LTS version",
// "It will be supported until 17.1 is released" => "It will be supported until 17.1 is released",
// "New PHP minimum requirement for Tiki 16 is PHP 5.6" => "New PHP minimum requirement for Tiki 16 is PHP 5.6",
// "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others" => "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others",
// "Tracker Force-Fill Feature" => "Tracker Force-Fill Feature",
// "Improved Fields" => "Improved Fields",
// "Improved Plugins and extended features" => "Improved Plugins and extended features",
// "There are a few new console.php commands to set scheduled cron tasks" => "There are a few new console.php commands to set scheduled cron tasks",
// "Filtering to Index-based Plugins" => "Filtering to Index-based Plugins",
// "Filter UI added in any wiki plugin using unified search index" => "Filter UI added in any wiki plugin using unified search index",
// "PDF Settings (Control Panel > Print)" => "PDF Settings (Control Panel > Print)",
// "New method to create PDF: mPDF" => "New method to create PDF: mPDF",
// "New Profiles" => "New Profiles",
// "Bug_Tracker_16" => "Bug_Tracker_16",
// "Execute on list" => "Execute on list",
// "GeoCMS_Maps" => "GeoCMS_Maps",
// "Work_Custom_Pricing" => "Work_Custom_Pricing",
// "Main new and improved features and settings in Tiki 17" => "Main new and improved features and settings in Tiki 17",
// "Tiki17" => "Tiki17",
// "Tiki17 is a standard non-LTS version" => "Tiki17 is a standard non-LTS version",
// "It will be supported until 18.1 is released" => "It will be supported until 18.1 is released",
// "Many libraries have been upgraded" => "Many libraries have been upgraded",
// "Improved Plugins" => "Improved Plugins",
// "HTTP Header Options" => "HTTP Header Options",
// "Intrusion Detection System (IDS) with Expose" => "Intrusion Detection System (IDS) with Expose",
// "Other new or Extended Features" => "Other new or Extended Features",
// "Preferences can be set" => "Preferences can be set",
// "One system cron job can trigger all required actions at their specific scheduled times" => "One system cron job can trigger all required actions at their specific scheduled times",
// "Main new and improved features and settings in Tiki 18" => "Main new and improved features and settings in Tiki 18",
// "Tiki18" => "Tiki18",
// "This is an LTS version" => "This is an LTS version",
// "New Features" => "New Features",
// "Composer Web Install (<b>Packages</b>)" => "Composer Web Install (<b>Packages</b>)",
// "Style guide tool" => "Style guide tool",
// "Look and feel colors can be customized with a style guide tool" => "Look and feel colors can be customized with a style guide tool",
// "PDF from URL: mPDF new settings" => "PDF from URL: mPDF new settings",
// "Other Extended Features" => "Other Extended Features",
// "Real-time collaboration tools (<b>RTC</b>)" => "Real-time collaboration tools (<b>RTC</b>)",
// "New actions can be performed" => "New actions can be performed",
// "Drag and drop added to menu management" => "Drag and drop added to menu management",
"Profiles" => "프로필",
// "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items" => "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items",
// "Calendars and Calendar Items will now appear in search results of the unified search index" => "Calendars and Calendar Items will now appear in search results of the unified search index",
// "Certain tracker fields can be converted keeping options" => "Certain tracker fields can be converted keeping options",
// "New Fields" => "New Fields",
// "Activity_Stream" => "Activity_Stream",
// "Simple_Forum" => "Simple_Forum",
// "Timesheets_Tracker" => "Timesheets_Tracker",
// "User_Profile_Business" => "User_Profile_Business",
// "Main new and improved features and settings in Tiki 19" => "Main new and improved features and settings in Tiki 19",
// "Tiki19" => "Tiki19",
// "It is a Standard Term Support (STS) version" => "It is a Standard Term Support (STS) version",
// "It will be supported until Tiki 20.1 is released" => "It will be supported until Tiki 20.1 is released",
// "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones" => "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones",
// "Federation" => "Federation",
// "Other New Features" => "Other New Features",
// "Added a preview button in tracker field files to enable pdf view in new window without download document" => "Added a preview button in tracker field files to enable pdf view in new window without download document",
// "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item" => "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item",
// "Create tracker from File" => "Create tracker from File",
// "GanttChart" => "GanttChart",
// "Hide Fixed Top Nav Bar on Scroll 19" => "Hide Fixed Top Nav Bar on Scroll 19",
// "Scheduler_Presets" => "Scheduler_Presets",
// "And many more improvements" => "And many more improvements",
// "Main new and improved features and settings in Tiki 20" => "Main new and improved features and settings in Tiki 20",
// "Tiki20" => "Tiki20",
// "It will be supported until Tiki 21.1 is released" => "It will be supported until Tiki 21.1 is released",
// "Groupmail_20" => "Groupmail_20",
// "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability" => "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability",
// "Basic Information about Wizards" => "Basic Information about Wizards",
// "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)" => "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)",
// "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled" => "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled",
// "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site" => "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site",
// "Wizards settings" => "Wizards settings",
// "Here you can see listed other features and settings that were not included in the previous sections" => "Here you can see listed other features and settings that were not included in the previous sections",
// "Ratings in Forums" => "Ratings in Forums",
// "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user" => "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Topic Rating by each user" => "Topic Rating by each user",
// "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply" => "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply",
// "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion" => "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion",
// "Sysadmin Tasks" => "Sysadmin Tasks",
// "Search Index" => "Search Index",
// "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>" => "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>",
// "Cron Job to Rebuild Search Index" => "Cron Job to Rebuild Search Index",
// "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index" => "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index",
// "Starting in Tiki11, the syntax to rebuild the search index changed" => "Starting in Tiki11, the syntax to rebuild the search index changed",
// "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line" => "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line",
// "Console (console.php script)" => "Console (console.php script)",
// "Example: Database update" => "Example: Database update",
// "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>" => "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>",
// "Mail Queue" => "Mail Queue",
"Daily Reports for User Watches" => "사용자 주시 용 일일 보고",
// "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending" => "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending",
// "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished" => "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished",
// "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button" => "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button",
// "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job" => "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job",
// "Example: Send the Mail Queue" => "Example: Send the Mail Queue",
// "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups" => "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups",
// "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)" => "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)",
// "Example: Send the Daily Report" => "Example: Send the Daily Report",
// "Other Features" => "Other Features",
// "New permissions and action log settings" => "New permissions and action log settings",
// "Wiki Inline Editing" => "Wiki Inline Editing",
// "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4" => "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4",
// "The editor can be quickly turned on/off. All processing is done client side" => "The editor can be quickly turned on/off. All processing is done client side",
// "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown" => "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown",
// "bigbluebutton" => "bigbluebutton",
// "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings" => "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings",
// "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted" => "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted",
// "Switch editor" => "Switch editor",
// "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted" => "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted",
// "Action log settings" => "Action log settings",
// "Joined Room" => "Joined Room",
// "Left Room" => "Left Room",
// "You are reaching the end of the <em>Changes Wizard</em>" => "You are reaching the end of the <em>Changes Wizard</em>",
// "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least" => "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least",
// "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community" => "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community",
// "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above" => "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above",
// "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}" => "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}",
"Connect" => "연결",
"Site title is required" => "사이트 제목은 필수임",
// "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki" => "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki",
// "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site" => "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site",
// "Tracker Field Types" => "Tracker Field Types",
// "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>" => "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>",
// "Former ways to manage ratings in trackers are <b>deprecated</b>" => "Former ways to manage ratings in trackers are <b>deprecated</b>",
// "Deprecated Rating Systems in Trackers" => "Deprecated Rating Systems in Trackers",
// "Tracker field types" => "Tracker field types",
// "edit Tracker" => "edit Tracker",
// "Other options to be set elsewhere" => "Other options to be set elsewhere",
// "Add a <em>User and Registration tracker</em>" => "Add a <em>User and Registration tracker</em>",
// "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins" => "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins",
// "You can set it in" => "You can set it in",
// "tracker edition" => "tracker edition",
// "Some User Interface (UI) improvements which usually come disabled in new Tiki installations" => "Some User Interface (UI) improvements which usually come disabled in new Tiki installations",
// "They are proven to be useful enhancements in some production environments" => "They are proven to be useful enhancements in some production environments",
// "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try" => "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try",
// "Icons and Profile Pictures" => "Icons and Profile Pictures",
// "Text Areas" => "Text Areas",
// "You are done with the Changes Wizard" => "You are done with the Changes Wizard",
// "You are done with the Configuration Profiles Wizard" => "You are done with the Configuration Profiles Wizard",
// "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site" => "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences",
// "Some profiles were created for use cases of project management" => "Some profiles were created for use cases of project management",
// "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly" => "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly",
// "It creates" => "It creates",
// "a sample tracker that will hold the tasks" => "a sample tracker that will hold the tasks",
// "a sample wiki page linked to that tracker to display the tasks" => "a sample wiki page linked to that tracker to display the tasks",
// "Some demo data to help you get started" => "Some demo data to help you get started",
// "Click to expand" => "Click to expand",
// "Work custom pricing" => "Work custom pricing",
// "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one" => "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one",
// "Work Custom Pricing" => "Work Custom Pricing",
// "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile" => "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile",
// "Wildcard items" => "Wildcard items",
// "This profile adds a way to provide reusable items in a tracker coming from another one working as templates" => "This profile adds a way to provide reusable items in a tracker coming from another one working as templates",
// "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are" => "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are",
// "A couple of trackers. One for current items, and another one for the reusable items working ass templates" => "A couple of trackers. One for current items, and another one for the reusable items working ass templates",
// "A few wiki pages to list, view and edit items" => "A few wiki pages to list, view and edit items",
// "Some example items in both trackers to help you get started" => "Some example items in both trackers to help you get started",
// "Check out some commonly used configurations in Tiki sites" => "Check out some commonly used configurations in Tiki sites",
// "User & Registration Tracker" => "User & Registration Tracker",
// "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users" => "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users",
// "It includes" => "It includes",
// "A long list of predefined usual fields, to choose from" => "A long list of predefined usual fields, to choose from",
// "Some fields already prepared to display custom information from your specific site" => "Some fields already prepared to display custom information from your specific site",
// "The chance to easily customize it with the power of Trackers" => "The chance to easily customize it with the power of Trackers",
// "Custom Contact Form" => "Custom Contact Form",
// "This profile eases the task to create a custom contact form adapted to the specific case of that site" => "This profile eases the task to create a custom contact form adapted to the specific case of that site",
// "More details" => "More details",
// "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point" => "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point",
// "New fields can be added asking questions specific for the site" => "New fields can be added asking questions specific for the site",
// "You decide where and when to display the link to the contact us form in your Tiki menus and pages" => "You decide where and when to display the link to the contact us form in your Tiki menus and pages",
// "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields" => "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields",
// "Useful for Geographic data (State, Country/Province, ...)" => "Useful for Geographic data (State, Country/Province, ...)",
// "Useful for Types and Subtypes" => "Useful for Types and Subtypes",
// "Useful for Program Names and Versions" => "Useful for Program Names and Versions",
// "Easily manage the options in the second tracker without editing the dropdown in the first tracker" => "Easily manage the options in the second tracker without editing the dropdown in the first tracker",
// "Sortable Tables" => "Sortable Tables",
// "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature" => "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature",
// "Useful to sort and filter data in real time" => "Useful to sort and filter data in real time",
// "Same approach for FancyTable and TrackerList Plugins" => "Same approach for FancyTable and TrackerList Plugins",
// "Sorting can be server-side or client-side based " => "Sorting can be server-side or client-side based ",
// "Some profiles are highly customized for very specialized use cases, and they are listed in this special category" => "Some profiles are highly customized for very specialized use cases, and they are listed in this special category",
// "Demo Profiles" => "Demo Profiles",
// "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site" => "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site",
// "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on" => "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on",
// "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected" => "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected",
// "See details in the instructions page shown in your site once each profile is applied" => "See details in the instructions page shown in your site once each profile is applied",
// "CartoGraf" => "CartoGraf",
// "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools" => "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools",
// "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application" => "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application",
// "This profile is using Tiki as Framework, with these details" => "This profile is using Tiki as Framework, with these details",
// "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers" => "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers",
// "It uses its own Cartograf style (downloaded aside)" => "It uses its own Cartograf style (downloaded aside)",
// "It allows custom markers for maps (placed in a file gallery)" => "It allows custom markers for maps (placed in a file gallery)",
// "It is used in production at http://cartograf.recitus.qc.ca (in French)" => "It is used in production at http://cartograf.recitus.qc.ca (in French)",
// "R demo" => "R demo",
// "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages" => "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages",
// "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)" => "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)",
// "The profile creates many demo pages, which comprise" => "The profile creates many demo pages, which comprise",
// "Simple R syntax in wiki pages to produce interactive charts" => "Simple R syntax in wiki pages to produce interactive charts",
// "Advanced usage to create full GUI for an R application" => "Advanced usage to create full GUI for an R application",
// "Many other examples of nice charts and reports that you can produce with this system" => "Many other examples of nice charts and reports that you can produce with this system",
// "r.tiki.org site" => "r.tiki.org site",
// "r.tiki.org live site" => "r.tiki.org live site",
// "GeoCMS Maps" => "GeoCMS Maps",
// "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps" => "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps",
// "R Heatmaps" => "R Heatmaps",
// "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)" => "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)",
// "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)" => "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)",
// "This profile creates" => "This profile creates",
// "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you" => "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you",
// "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets" => "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets",
// "Example input files and default values provided as a happy path to produce your first Heatmaps" => "Example input files and default values provided as a happy path to produce your first Heatmaps",
// "Plugin R" => "Plugin R",
// "Plugin R in doc.tiki.org" => "Plugin R in doc.tiki.org",
// "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example" => "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example",
// "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real" => "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real",
// "Bug Tracker" => "Bug Tracker",
// "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below" => "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below",
// "Uses PluginTracker in a wiki page to add items" => "Uses PluginTracker in a wiki page to add items",
// "Create some custom feedback for message to the user after item insertion" => "Create some custom feedback for message to the user after item insertion",
// "Uses PluginTrackerList to display inserted items" => "Uses PluginTrackerList to display inserted items",
// "Timesheet" => "Timesheet",
// "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names" => "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names",
// "Allows to track your time spent on projects" => "Allows to track your time spent on projects",
// "Customize your project categories" => "Customize your project categories",
// "Add or edit your timesheet fields as desired" => "Add or edit your timesheet fields as desired",
// "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker" => "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker",
// "Plugin Timesheet" => "Plugin Timesheet",
// "Plugin Timesheet in doc.tiki.org" => "Plugin Timesheet in doc.tiki.org",
// "Tracker as Calendar" => "Tracker as Calendar",
// "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way" => "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way",
// "Advanced use of Plugin TrackerList" => "Advanced use of Plugin TrackerList",
// "Working example of Plugin TrackerCalendar" => "Working example of Plugin TrackerCalendar",
// "Drag & Drop to resize or move events" => "Drag & Drop to resize or move events",
// "Several display modes, useful for Project & Resource Management" => "Several display modes, useful for Project & Resource Management",
// "Voting System" => "Voting System",
// "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote" => "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote",
// "Group homepage set for the voting group" => "Group homepage set for the voting group",
// "Only one vote per member is allowed" => "Only one vote per member is allowed",
// "Results shown in real time (Plugin TrackerStat)" => "Results shown in real time (Plugin TrackerStat)",
// "Other candidates can be voted beyond the proposed" => "Other candidates can be voted beyond the proposed",
// "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site" => "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site",
// "Shopping Cart" => "Shopping Cart",
// "This profile provides a Shopping Cart and the corresponding basic payment system" => "This profile provides a Shopping Cart and the corresponding basic payment system",
// "It currently uses the PayPal shopping cart rather than the built in Tiki" => "It currently uses the PayPal shopping cart rather than the built in Tiki",
// "A tracker for products including price, weight, image and stock quantity" => "A tracker for products including price, weight, image and stock quantity",
// "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users" => "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users",
// "A small category subtree to classify products" => "A small category subtree to classify products",
// "Wiki pages to display the available products list, one product details page and a search form" => "Wiki pages to display the available products list, one product details page and a search form",
// "Easy GeoBlog" => "Easy GeoBlog",
// "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features" => "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features",
// "Single map with all geolocated blog posts" => "Single map with all geolocated blog posts",
// "Different home page once the user logs in" => "Different home page once the user logs in",
// "Random header image from files included in a file gallery" => "Random header image from files included in a file gallery",
// "WYSIWYG Editor (compatible mode with wiki syntax)" => "WYSIWYG Editor (compatible mode with wiki syntax)",
// "Wiki, Search, Menu & Tags" => "Wiki, Search, Menu & Tags",
// "Comments moderation & Banning (for anonymous comments to your site)" => "Comments moderation & Banning (for anonymous comments to your site)",
// "Profile Conditional_Display_in_Forms" => "Profile Conditional_Display_in_Forms",
// "This profile demonstrates the setup to conditionally hide or display some fields in a form" => "This profile demonstrates the setup to conditionally hide or display some fields in a form",
// "Conditional_Display_in_Forms" => "Conditional_Display_in_Forms",
// "Main features used" => "Main features used",
// "Plugin JQ (jQuery)" => "Plugin JQ (jQuery)",
// "Plugin TrackerIf" => "Plugin TrackerIf",
// "Profile Execute_on_list" => "Profile Execute_on_list",
// "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute" => "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute",
// "Plugin ListExecute" => "Plugin ListExecute",
// "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes" => "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes",
// "Structured Master Documents" => "Structured Master Documents",
// "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more" => "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more",
// "Many pages are pre-created to let you easily set up several wiki structures" => "Many pages are pre-created to let you easily set up several wiki structures",
// "A common navigation menu is created and shown at the top of pages in the structure" => "A common navigation menu is created and shown at the top of pages in the structure",
// "You can easily print (export) them all together in a single html" => "You can easily print (export) them all together in a single html",
// "Permissions or Monitoring can be applied in bulk to the whole structure or substructures" => "Permissions or Monitoring can be applied in bulk to the whole structure or substructures",
// "Consensus Forums" => "Consensus Forums",
// "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held" => "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held",
// "Users ratings in Forums" => "Users ratings in Forums",
// "Topics with less agreement can be easily identified from the topic list" => "Topics with less agreement can be easily identified from the topic list",
// "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus" => "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus",
// "Replies can also be rated, but without affecting the topic rating average" => "Replies can also be rated, but without affecting the topic rating average",
// "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile" => "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile",
// "Barter Market" => "Barter Market",
// "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge" => "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge",
// "minimal number of fields in these trackers, which can be extended" => "minimal number of fields in these trackers, which can be extended",
// "tracker items are categorized" => "tracker items are categorized",
// "a few modules added, including a wiki page menu" => "a few modules added, including a wiki page menu",
// "best display if using just one column (right, for instance)" => "best display if using just one column (right, for instance)",
// "Revision Approval (ISO9001)" => "Revision Approval (ISO9001)",
// "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)" => "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)",
// "Additions: 1 group, 2 users, 2 wiki pages, 3 categories" => "Additions: 1 group, 2 users, 2 wiki pages, 3 categories",
// "Revision approval is set for homepage and 'official document'" => "Revision approval is set for homepage and 'official document'",
// "Wiki Argument Variables are used in the 'official document'" => "Wiki Argument Variables are used in the 'official document'",
// "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles" => "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles",
// "Collaborative Community" => "Collaborative Community",
"Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "지식 기반을 제작하기 위하여 토픽에 대한 전문가와 열성가들을 돕기 위한 설정",
// "Uses" => "Uses",
"Wiki Editing" => "위키 편집",
"Personal Member Spaces" => "개인 멤버 공간",
// "Company Intranet" => "Company Intranet",
"Setup for a Corporate Intranet of a typical medium-sized business" => "일반적인 중소규모 사업의 회사 인트라넷에 대하여 설정",
"Company News Articles" => "회사 뉴스 기사",
"Executive Blog" => "경영진 블로그",
"File Repository & Management" => "파일 리포지터리 & 관리",
"Collaborative Wiki" => "협엽적 위키",
// "Personal Blog and Profile" => "Personal Blog and Profile",
"Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "소셜 웹을 통합하는 것과 블로그공간에 강한 존재감을 심는 것을 돕기 위한 많은 멋진 기능으로 설정",
"Blog (Full set of blog related features)" => "블로그 (블로고 관련 기능의 전체 세트)",
"RSS Integration" => "RSS 통합",
"Video Log" => "동영상 기록",
// "Small Organization Web Presence" => "Small Organization Web Presence",
"Setup for a Web Presence of a typical small business or non-profit" => "일반적인 소규모 사업 혹은 비영리단체를 위한 웹 서비스에 대하여 설정",
"Company News & Updates" => "회사 소식과 갱신내역",
"Highlight Company's Products and Services" => "회사의 제품과 서비스 강조",
"File Gallery (great for Media Kit)" => "파일 갤러리 (미디어 킷에 유용)",
"Contact Form" => "연락처 서식",
// "Profiles admin card" => "Profiles admin card",
// "Check out some useful changes in the configuration for site administrators" => "Check out some useful changes in the configuration for site administrators",
// "Debug Mode Enabled" => "Debug Mode Enabled",
// "Debug Mode Disabled" => "Debug Mode Disabled",
// "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise" => "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise",
// "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand" => "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand",
// "Enables/Disables debugging tools" => "Enables/Disables debugging tools",
// "Enables/Disables logging tools" => "Enables/Disables logging tools",
// "Disables/Enables redirections to similar pages" => "Disables/Enables redirections to similar pages",
// "Enables/Disables error and warning display to all users, not only admins" => "Enables/Disables error and warning display to all users, not only admins",
// "This configuration profile enables the Scheduler feature and loads a preset of schedulers" => "This configuration profile enables the Scheduler feature and loads a preset of schedulers",
// "Each scheduler can replace a former cron job action in the server" => "Each scheduler can replace a former cron job action in the server",
// "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need" => "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need",
// "This configuration profile showcases the activity stream feature in Tiki" => "This configuration profile showcases the activity stream feature in Tiki",
// "Activity Stream data can also be reviewed through PluginPivotTable" => "Activity Stream data can also be reviewed through PluginPivotTable",
// "It is somewhat similar to the basic Action log feature in Tiki" => "It is somewhat similar to the basic Action log feature in Tiki",
// "Check out some useful profiles that involve changing the display mode of content in your site" => "Check out some useful profiles that involve changing the display mode of content in your site",
// "Slideshow demo" => "Slideshow demo",
// "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works" => "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works",
// "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper" => "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper",
// "Headers of different levels are used as markers of 'new slide' and used as titles" => "Headers of different levels are used as markers of 'new slide' and used as titles",
// "Many settings can be predefined as parameters of a call to PluginSlideshow" => "Many settings can be predefined as parameters of a call to PluginSlideshow",
// "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to" => "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to",
// "Hide Fixed Top Navigation Bar on scroll" => "Hide Fixed Top Navigation Bar on scroll",
// "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards" => "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards",
// "Hide Fixed Top Navi Bar on Scroll" => "Hide Fixed Top Navi Bar on Scroll",
// "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'" => "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'",
// "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice" => "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice",
// "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky" => "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky",
// "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus" => "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus",
// "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration" => "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration",
// "Menu on Wiki page" => "Menu on Wiki page",
// "This profile sets up a side module with a menu based on a wiki page in the right hand-side column" => "This profile sets up a side module with a menu based on a wiki page in the right hand-side column",
// "With this profile you can" => "With this profile you can",
// "use wiki syntax to edit it" => "use wiki syntax to edit it",
// "delegate its edition with wiki page permissions" => "delegate its edition with wiki page permissions",
// "use plugins to manage conditional display of sections" => "use plugins to manage conditional display of sections",
// "Random header images" => "Random header images",
// "This profile adds a module in the top zone that displays a random image from a File Gallery" => "This profile adds a module in the top zone that displays a random image from a File Gallery",
// "Some sample images to fit the default configuration are also provided as a starting point" => "Some sample images to fit the default configuration are also provided as a starting point",
// "default configuration uses images at 800x150px resized by the top module parameters to match the header default size" => "default configuration uses images at 800x150px resized by the top module parameters to match the header default size",
// "a different random image is shown at each page load" => "a different random image is shown at each page load",
// "elFinder modern file galery manager (with drag & drop capabilities!) is used by default" => "elFinder modern file galery manager (with drag & drop capabilities!) is used by default",
// "you can tweak the module and file gallery defaults as needed for your needs" => "you can tweak the module and file gallery defaults as needed for your needs",
// "Multilingual Wiki" => "Multilingual Wiki",
// "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion" => "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion",
// "The enabled features comprise" => "The enabled features comprise",
// "Multilingual freetags" => "Multilingual freetags",
// "Countries By Region" => "Countries By Region",
// "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions" => "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions",
// "The regions listed with their countries are" => "The regions listed with their countries are",
// "Saharan, Sub-Saharan Africa" => "Saharan, Sub-Saharan Africa",
// "Middle East, North Africa" => "Middle East, North Africa",
// "Asia" => "Asia",
// "North, Central America" => "North, Central America",
// "Oceania" => "Oceania",
// "South America" => "South America",
// "Check out this set of useful configurations that involve using some new technology for your site" => "Check out this set of useful configurations that involve using some new technology for your site",
// "Write Together" => "Write Together",
// "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS" => "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS",
// "Allows cowriting documents in real time" => "Allows cowriting documents in real time",
// "Allows voice communication in real time while editing" => "Allows voice communication in real time while editing",
// "Uses the TogetherJS Mozilla widget" => "Uses the TogetherJS Mozilla widget",
// "Post-it Sticky Note" => "Post-it Sticky Note",
// "This profile allows to display a sticky note (a \"post-it\") in your tiki site" => "This profile allows to display a sticky note (a \"post-it\") in your tiki site",
// "You can move it to another location" => "You can move it to another location",
// "You can customize the contents and which groups of users will see it (by default, only to Admins)" => "You can customize the contents and which groups of users will see it (by default, only to Admins)",
// "It will be shown for each user of that group until manually closed" => "It will be shown for each user of that group until manually closed",
// "Groupmail" => "Groupmail",
// "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages" => "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages",
// "A tracker for email messages received and store addresses in the Contacts feature" => "A tracker for email messages received and store addresses in the Contacts feature",
// "Webmail configuration to use an account for groupmail" => "Webmail configuration to use an account for groupmail",
// "A side module with markers to indicate who took which message" => "A side module with markers to indicate who took which message",
// "A system to review communication logs from that group mail account" => "A system to review communication logs from that group mail account",
// "Profile X" => "Profile X",
// "This profile allows to " => "This profile allows to ",
// "Feature_X in doc.tiki.org" => "Feature_X in doc.tiki.org",
// "User Dummy" => "User Dummy",
// "This is a dummy page" => "This is a dummy page",
// "Set up basic information as a user on this site" => "Set up basic information as a user on this site",
"Your personal Wiki Page" => "귀하의 개인 Wiki페이지",
// "The feature 'User Preferences' is currently disabled in this site" => "The feature 'User Preferences' is currently disabled in this site",
// "Enable the feature" => "Enable the feature",
// "Enable it" => "Enable it",
// "You might ask your site admin to enable it" => "You might ask your site admin to enable it",
// "Use 'watches' to monitor wiki pages or other objects" => "Use 'watches' to monitor wiki pages or other objects",
// "Set up below preferences related to receiving notifications by email about changes in the site" => "Set up below preferences related to receiving notifications by email about changes in the site",
// "The feature user watches is disabled in this site" => "The feature user watches is disabled in this site",
// "Set up the general settings for your account" => "Set up the general settings for your account",
// "User Params" => "User Params",
"Is email public? (uses scrambling to prevent spam)" => "이메일을 공개합니까? (스팸 방지를 위하여 스크램블링 사용)",
"Does your email application need a special character set" => "메일을 보는 프로그램에서 특수 캐릭터세트가 필요합니까",
"Preferred language:" => "선호 언어:",
// "Site time zone is enforced and overrides user preferences" => "Site time zone is enforced and overrides user preferences",
"Use 12-hour clock in time selectors:" => "시간 선택기에서 12시간 시계를 사용:",
"Send me an email for messages with priority equal to or greater than:" => "우선순위가 다음보다 같거나 높은 메시지에 대하여 이메일을 나에게 보냄:",
// "The feature with the user preferences screen is disabled in this site" => "The feature with the user preferences screen is disabled in this site",
"You are not allowed to remove this notification " => "이 알림을 삭제하도록 허용되어 있지 않습니다",
"Interval in which you want to get the reports" => "보고를 받기 원하는 간격",
"HTML-Email" => "HTML-이메일",
"Send me an email also if nothing happened" => "아무 일도 일어나지 않은 경우에도 나에게 메일 전송",
// "The feature daily reports of user watches is disabled in this site" => "The feature daily reports of user watches is disabled in this site",
// "Use this form to fill in some extra information about you" => "Use this form to fill in some extra information about you",
// "Extra information about you" => "Extra information about you",
// "Tiki User Wizard" => "Tiki User Wizard",
// "This wizard will help you fill in data and main settings for your account on this website" => "This wizard will help you fill in data and main settings for your account on this website",
// "Depending on the features enabled by the site admin, you will be offered more or less options" => "Depending on the features enabled by the site admin, you will be offered more or less options",
// "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature" => "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature",
// "Click at the \"Start\" button above to launch it" => "Click at the \"Start\" button above to launch it",
// "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>" => "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>",
// "You are done with the user wizard" => "You are done with the user wizard",
// "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences" => "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences",
// "Or.." => "Or..",
// "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were" => "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were",
// "Show on admin log-in" => "Show on admin log-in",
// "Finish" => "Finish",
// "Start the Wizardry" => "Start the Wizardry",
// "Save and Continue" => "Save and Continue",
"No turning back" => "복구 불가",
"Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available" => "템플릿을 고급 모드로 전환하게되면, 돌아갈 수 없습니다. 간단한 인터페이스는 더 이상 사용할 수 없습니다",
"Return to simple interface" => "간단한 인터페이스로 돌아가기",
// "Workspace Name" => "Workspace Name",
"Wiki Page Source" => "위키 페이지 소스",
"Not enough options" => "선택사항 충분하지 않음",
"This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power" => "이는 사용가능한 기능의 부분집합을 제공하는 간단한 에디션 인터페이스입니다. 고급 모드로 전환하여 더 강력한 기능을 얻을 수 있습니다",
"Advanced Mode" => "고급 모드",
"Bind area" => "영역 묶기",
"Is managing group" => "은 관리하는 그룹입니다",
"Workspace creator joins this group" => "작업공간 만든이가 이 그룹에 참여했습니다",
"Add group" => "그룹 추가",
"Select Permissions" => "권한 선택",
"Edit content template" => "컨텐츠 템플릿 편집",
"Add page" => "페이지 추가",
// "Default (Font-awesome)" => "Default (Font-awesome)",
// "The default system icon set using Font-awesome fonts" => "The default system icon set using Font-awesome fonts",
// "Solid" => "Solid",
// "Outline" => "Outline",
// "Font Awesome Regular" => "Font Awesome Regular",
// "Font Awesome Pro Only" => "Font Awesome Pro Only",
// "Brands" => "Brands",
// "Legacy (pre Tiki14) icons" => "Legacy (pre Tiki14) icons",
// "Legacy (pre Tiki14) icons, mainly using famfamfam images" => "Legacy (pre Tiki14) icons, mainly using famfamfam images",
// "Custom icons" => "Custom icons",
// "Custom icons for the theme" => "Custom icons for the theme",
// "Theme icons" => "Theme icons",
// "Icons to be used for this theme" => "Icons to be used for this theme",
// "This field is manadatory" => "This field is manadatory",
"Design by" => "설계자",
"Missing book id" => "없는 장부 ID",
"You do not have the right view this page" => "이 페이지를 볼 권한이 없습니다",
// "%0 account in book %1 modified" => "%0 account in book %1 modified",
// "%0 account created for book %1" => "%0 account created for book %1",
// "Account %0 in book %1 unlocked" => "Account %0 in book %1 unlocked",
// "Account %0 in book %1 not unlocked" => "Account %0 in book %1 not unlocked",
// "Account %0 in book %1 locked" => "Account %0 in book %1 locked",
// "Account %0 in book %1 not locked" => "Account %0 in book %1 not locked",
// "Delete account %0 from book %1" => "Delete account %0 from book %1",
// "%0 account deleted from book %1" => "%0 account deleted from book %1",
"Missing account id" => "없는 계정 ID",
"You do not have the rights to view this account" => "이 계정을 볼 권한이 없습니다",
"You do not have the rights to manage accounts" => "계정을 관리할 권한이 없습니다",
// "You do not have permission to create a book" => "You do not have permission to create a book",
// "Book %0 successfully created" => "Book %0 successfully created",
// "You do not have permission to close this book" => "You do not have permission to close this book",
// "Close book (this action cannot be undone)" => "Close book (this action cannot be undone)",
// "Book successfully closed" => "Book successfully closed",
// "The attempt to close the book was unsuccessful" => "The attempt to close the book was unsuccessful",
// "Cancel journal %0 in book %1" => "Cancel journal %0 in book %1",
// "Journal shown below successfully canceled" => "Journal shown below successfully canceled",
"Missing journal id" => "저널 ID 누락",
"You do not have the right to cancel transactions" => "거래를 취소할 권한이 없습니다",
"Error retrieving data from journal" => "저널에서 데이터 가져오기 오류",
"You do not have the right to book" => "이 책에 대한 권한이 없습니다",
// "Record entry in book %0" => "Record entry in book %0",
// "Journal %0 successfully recorded in book %1" => "Journal %0 successfully recorded in book %1",
"Don't know what to export" => "어떤 것을 내보내기 해야할지 모르겠습니다",
"You do not have the right export/view this data" => "이 데이터를 내보내기/보기 권한이 없습니다",
"You do not have the right to book into the stack" => "스택에 book 할 권한이 없습니다",
// "Record stack entry in book %0" => "Record stack entry in book %0",
// "Modify stack entry in book %0" => "Modify stack entry in book %0",
// "Delete stack %0 from book %1" => "Delete stack %0 from book %1",
// "Confirm stack %0 for book %0" => "Confirm stack %0 for book %0",
// "Stack %0 successfully modified in book %1" => "Stack %0 successfully modified in book %1",
// "Stack %0 successfully deleted from book %1" => "Stack %0 successfully deleted from book %1",
// "Stack %0 recorded in book %1" => "Stack %0 recorded in book %1",
// "Stack %0 deleted from book %1" => "Stack %0 deleted from book %1",
// "Stack %0 confirmed and recorded as entry in book %1" => "Stack %0 confirmed and recorded as entry in book %1",
"Tiki Calendar" => "티키 달력",
"%0 enabled" => "%0 활성화됨",
"%0 disabled" => "%0 비활성화됨",
"%0 set" => "%0 설정",
"%0 unset" => "%0 설정해제",
// "item added" => "item added",
// "items added" => "items added",
// "item deleted" => "item deleted",
// "items deleted" => "items deleted",
"Help on Configuration Sections" => "섹선 구성에 대한 도움말",
// "Default preference filters set" => "Default preference filters set",
"%0 reset" => "%0 재설정",
"Search error" => "검색 오류",
// "Global site configuration, date formats, etc" => "Global site configuration, date formats, etc",
"Switches for major features" => "주 기능에 대한 스위치",
"User registration, remember me cookie settings and authentication methods" => "사용자 등록, 사용자 저장 쿠키 설정 및 인증 방식",
// "User related preferences like info and picture, features, messages and notification, files, etc" => "User related preferences like info and picture, features, messages and notification, files, etc",
"Repository configuration, browse and apply profiles" => "리포지터리 설정, 프로필 탐색 및 적용",
"Look & Feel" => "외형과 느낌",
"Theme selection, layout settings and UI effect controls" => "테마 선택, 레이아웃 설정 및 UI 효과 제어",
"Editing and Plugins" => "편집 및 플러그인",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "다양한 영역에 적용가능한 텍스트 편집 설정.플러그인 활성화 및 플러그인 별칭 관리",
"Module appearance settings" => "모듈 모양 설정",
// "i18n" => "i18n",
"Internationalization and localization - multilingual features" => "국제화 및 로컬라이제이션 - 다국어 기능",
"Meta Tags" => "메타 태그",
"Information to include in the header of each page" => "각 페이지의 헤더 내부에 포함될 정보",
"Maps" => "지도",
"Settings and features for maps" => "지도에 대한 설정과 기능",
"Server performance settings" => "서버 성능 설정",
"Site security settings" => "사이트 보안 설정",
"Outgoing RSS feed setup" => "발신 RSS 피드 설정",
"Tiki Connect - join in!" => "티키 커넥트 - 참여해주십시오!",
// "Rating settings" => "Rating settings",
"Search configuration" => "검색 설정",
"Wiki page settings and features" => "위키 페이지 설정과 기능",
"Defaults and configuration for file galleries" => "파일 갤러리에 대한 기본사항과 설정",
"Settings for blogs" => "블로그에 대한 설정",
"Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "이미지 갤러리에 대한 기본사항과 설정 (파일 갤러리 선호도에 의하여 차차 퇴출 될 것입니다)",
"Settings and features for articles" => "기사에 대한 설정과 기능",
"Settings and features for forums" => "게시판에 대한 설정과 기능",
"Settings and features for trackers" => "트래커에 대한 설정과 기능",
"Settings and features for polls" => "설문에 대한 설정과 기능",
"Settings and features for calendars" => "달력에 대한 설정과 기능",
"Settings and features for categories" => "범주에 대한 설정과 기능",
"Configure workspace feature" => "작업공간 기능 구성",
"Values of actions for users rank score" => "사용자 순위 점수에 대한 행동 값",
"Settings and features for tags" => "프리태그에 대한 설정과 기능",
"Settings and features for FAQs" => "FAQ 에 대한 설정과 기능",
"Settings and features for directory of links" => "링크의 디렉터리에 대한 설정과 기능",
"Site-wide copyright information" => "사이트 전역 저작권 정보",
"Message settings" => "메시지 설정",
// "Webmail settings" => "Webmail settings",
"Options for WYSIWYG editor" => "WYSIWYG 편집기에 대한 선택사항",
// "Site advertisements and notices" => "Site advertisements and notices",
"InterTiki" => "인터티키",
"Set up links between Tiki servers" => "티키 서버들간의 연결 설치",
"Manage semantic wiki links" => "시맨틱 위키 링크 관리",
"Register and manage web services" => "웹서비스 등록 및 관리",
// "SEF URL" => "SEF URL",
"Video integration configuration" => "동영상 통합 설정",
// "Payment settings" => "Payment settings",
"Configure social networks integration" => "소셜 네트워크 통합 설정",
"User specific features and settings" => "사용자 지정 기능 및 설정",
"Configure share feature" => "공유 기능 설정",
// "Configure statistics reporting for your site usage" => "Configure statistics reporting for your site usage",
// "Print Settings" => "Print Settings",
// "Settings and features for print versions and pdf generation" => "Settings and features for print versions and pdf generation",
// "External packages installation and management" => "External packages installation and management",
// "RTC" => "RTC",
// "Real-time collaboration tools" => "Real-time collaboration tools",
"Help on %0 Config" => "%0 구성에 대한 도움말",
// "Remove selected actions" => "Remove selected actions",
// "The selected action has been deleted from the log" => "The selected action has been deleted from the log",
// "%0 actions have been deleted from the log" => "%0 actions have been deleted from the log",
// "No actions were deleted from the log" => "No actions were deleted from the log",
"Must specify actionId" => "actionId 를 반드시 지정해야 함",
"Users Contributions: Addition" => "사용자 기여도: 추가",
"%s Contributions: Addition" => "%s 기여: 추가",
"Users Contributions: Suppression" => "사용자 기여도: 비표시",
"%s Contributions: Suppression" => "%s 기여: 추가: 억제",
"Total Contributions Addition per Day" => "일 당 총 기여 추가내역",
"Total Contributions Addition per Week" => "주 당 총 기여 추가 내역",
"Total Contributions Suppression per Day" => "일 당 총 기여 Suppression",
"Total Contributions Suppression per Week" => "주 당 총 기여 Suppression",
"Total Contributions: Addition" => "총 기여내역: 추가",
"Total Contributions: Suppression" => "총 기여내역: Suppression",
"Groups Contributions: Addition" => "그룹 기여내역: 추가",
"Groups Contributions: Suppression" => "그룹 기여내역: 비표시 오류(Suppression)",
"white" => "하양",
"gray" => "회색",
"silver" => "은",
"ivory" => "아이보리",
"whitesmoke" => "하얀연기",
"beige" => "베이지",
"darkgrey" => "짙은 회색",
// "No rule selected for deletion. No deletions were performed" => "No rule selected for deletion. No deletions were performed",
// "The selected banning rule has been deleted" => "The selected banning rule has been deleted",
// "%0 banning rules have been deleted" => "%0 banning rules have been deleted",
// "The following banning rule has been saved or replaced" => "The following banning rule has been saved or replaced",
// "The following %0 banning rules have been saved or replaced" => "The following %0 banning rules have been saved or replaced",
// "No changes were made to the following selected banning rules" => "No changes were made to the following selected banning rules",
// "Only %0 of the selected banning rules shown below were added or changed" => "Only %0 of the selected banning rules shown below were added or changed",
// "No banning rules were selected" => "No banning rules were selected",
"Multiple IP Banning" => "다중 IP 차단",
"Access from your localization was forbidden due to excessive spamming" => "귀하의 지역화부터의 접근이 과다한 스패밍으로 인하여 금지되었습니다",
// "Not saved" => "Not saved",
// "Username pattern empty" => "Username pattern empty",
// "Default IP pattern still set" => "Default IP pattern still set",
// "Calendar %0 deleted" => "Calendar %0 deleted",
// "Calendar %0 not deleted" => "Calendar %0 not deleted",
// "One calendar event deleted" => "One calendar event deleted",
// "No calendar events deleted" => "No calendar events deleted",
// "%0 calendar events deleted" => "%0 calendar events deleted",
// "No such category with parentID %0" => "No such category with parentID %0",
// "One object unassigned from category" => "One object unassigned from category",
// "%0 objects unassigned from category" => "%0 objects unassigned from category",
// "No objects unassigned" => "No objects unassigned",
// "Incorrect category ID %0 - objects not moved" => "Incorrect category ID %0 - objects not moved",
// "One object moved to selected category" => "One object moved to selected category",
// "%0 objects moved to selected category" => "%0 objects moved to selected category",
// "No objects moved" => "No objects moved",
// "Incorrect category ID %0 - objects not copied" => "Incorrect category ID %0 - objects not copied",
// "One object copied to selected category" => "One object copied to selected category",
// "%0 objects copied to selected category" => "%0 objects copied to selected category",
// "No objects copied" => "No objects copied",
// "One page added to category" => "One page added to category",
// "%0 pages added to category" => "%0 pages added to category",
// "No pages added to category" => "No pages added to category",
// "%0 %1 removed from category %2" => "%0 %1 removed from category %2",
// "%0 %1 not removed from category %2" => "%0 %1 not removed from category %2",
// "Delete category" => "Delete category",
// "Category ID %0 and descendants deleted" => "Category ID %0 and descendants deleted",
// "Category ID %0 not deleted" => "Category ID %0 not deleted",
// "Category cannot be parent of itself - no changes made" => "Category cannot be parent of itself - no changes made",
// "Category %0 updated" => "Category %0 updated",
// "Category %0 created" => "Category %0 created",
"The file does not have the required header" => "파일은 요구된 헤더가 없습니다",
// "Incorrect parameter %0" => "Incorrect parameter %0",
// "Categories imported" => "Categories imported",
"Edit permissions for this category" => "이 범주에 대한 권한 편집",
// "Assign permissions" => "Assign permissions",
// "Template removed" => "Template removed",
// "Template not removed" => "Template not removed",
// "Section removed" => "Section removed",
// "Section not removed" => "Section not removed",
// "Template %0 created or modified" => "Template %0 created or modified",
// "Template %0 not created or modified" => "Template %0 not created or modified",
// "Contribution settings saved" => "Contribution settings saved",
// "Contribution settings not saved" => "Contribution settings not saved",
// "Contribution added" => "Contribution added",
// "Contribution not added" => "Contribution not added",
// "Contribution modified" => "Contribution modified",
// "Contribution not modified" => "Contribution not modified",
// "Contribution removed" => "Contribution removed",
// "Contribution not removed" => "Contribution not removed",
// "Cookie removed" => "Cookie removed",
// "Cookie not removed" => "Cookie not removed",
// "All cookies removed" => "All cookies removed",
// "No cookies removed" => "No cookies removed",
// "File uploaded and one cookie created or replaced" => "File uploaded and one cookie created or replaced",
// "File uploaded and %0 cookies created or replaced" => "File uploaded and %0 cookies created or replaced",
// "Upload failed - no cookies created" => "Upload failed - no cookies created",
"Upload failed" => "업로드 실패",
// "Cookie saved" => "Cookie saved",
// "Cookie not saved" => "Cookie not saved",
"Admin credits" => "크레딧 관리",
// "DSN removed" => "DSN removed",
// "DSN not removed" => "DSN not removed",
// "DSN created or modified" => "DSN created or modified",
// "DSN not created or modified" => "DSN not created or modified",
// "External wiki removed" => "External wiki removed",
// "External wiki not removed" => "External wiki not removed",
// "External wiki saved" => "External wiki saved",
// "External wiki not saved" => "External wiki not saved",
// "Forum saved" => "Forum saved",
// "Forum not saved" => "Forum not saved",
// "Forum duplicated" => "Forum duplicated",
// "Forum not duplicated" => "Forum not duplicated",
"All posted" => "모든 게시물",
"Queue anonymous posts" => "익명사용자 게시물 대기",
"Queue all posts" => "모든 게시물 대기",
"No attachments" => "첨부파일 없음",
"Everybody can attach" => "모든 이가 첨부할 수 있음",
"Only users with attach permission" => "첨부 권한을 보유한 사용자들만",
"Moderators and admin can attach" => "중재자와 관리자가 첨부할 수 있습니다",
"No display" => "표기 없음",
"Date (desc)" => "일자 (올림차순)",
"Date (asc)" => "일자 (내림차순)",
"Score (desc)" => "점수 (내림차순)",
"Replies (desc)" => "답신수 (내림차순)",
"Reads (desc)" => "열람수 (내림차순)",
"You have to provide a hotword and a URL" => "hotword 와 URL 을 제공해야 합니다",
// "Hotword added" => "Hotword added",
// "Hotword not added" => "Hotword not added",
// "Hotword deleted" => "Hotword deleted",
// "Hotword not deleted" => "Hotword not deleted",
// "One dynamic zone updated" => "One dynamic zone updated",
// "%0 dynamic zones updated" => "%0 dynamic zones updated",
// "Dynamic zones not updated" => "Dynamic zones not updated",
// "Hotword saved" => "Hotword saved",
// "Hotword not saved" => "Hotword not saved",
// "HTML page removed" => "HTML page removed",
// "HTML page not removed" => "HTML page not removed",
// "HTML page saved" => "HTML page saved",
// "HTML page not saved" => "HTML page not saved",
// "A custom rule with the same ID already exists" => "A custom rule with the same ID already exists",
// "Tiki IDS is not enabled" => "Tiki IDS is not enabled",
"Requested action is not supported on repository" => "요청 작업은 리포지터리에서 지원되지 않습니다",
"Repository name can't be an empty" => "리포지터리명은 비어있을 수 없습니다",
"No repository" => "리포지터리 없음",
"Search is mandatory field" => "검색은 필수 필드입니다",
"File not found " => "파일 찾을 수 없음",
"Requested action in not supported on repository" => "리포지터리에 지원되지 않은 요청 작업",
"You need to apply the \"Invoice\" profile" => "\"청구서\" 프로필을 적용해야 합니다",
// "Remove keywords" => "Remove keywords",
// "Keywords for page \"%0\" saved" => "Keywords for page \"%0\" saved",
// "Keywords for page \"%0\" removed" => "Keywords for page \"%0\" removed",
// "Keywords were not updated" => "Keywords were not updated",
// "Featured link saved" => "Featured link saved",
// "Featured link not saved" => "Featured link not saved",
// "Non-existent link" => "Non-existent link",
// "Featured link removed" => "Featured link removed",
// "Featured link not removed" => "Featured link not removed",
"Frequency should be a positive integer" => "빈도는 양수 정수여야 합니다",
"Mail-in accounts set to be checked every %s minutes" => "Mail-in 계정이 매 %s 분마다 확인되도록 설정됨",
"Automatic Mail-in accounts checking disabled" => "자동 Mail-in 계정 확인 비활성화됨",
"No menu indicated" => "메뉴 지정되지 않음",
// "Delete menu ID %0" => "Delete menu ID %0",
// "Reset the Application Menu to the current system default" => "Reset the Application Menu to the current system default",
// "Module file in use. You need to edit %0 to configure your modules" => "Module file in use. You need to edit %0 to configure your modules",
// "%0 cache files cleared" => "%0 cache files cleared",
// "Module unassigned" => "Module unassigned",
// "Module not unassigned" => "Module not unassigned",
// "Displayed order may not change if other modules now have the same order rank" => "Displayed order may not change if other modules now have the same order rank",
// "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1" => "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1",
// "Standard module display order moved up" => "Standard module display order moved up",
// "Standard module display order not moved up" => "Standard module display order not moved up",
// "Standard module display order moved down" => "Standard module display order moved down",
// "Standard module display order not moved down" => "Standard module display order not moved down",
// "Standard display of modules reordered or moved" => "Standard display of modules reordered or moved",
// "Standard display of modules not reordered or moved" => "Standard display of modules not reordered or moved",
// "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1" => "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1",
"Cannot create or update module: You need to specify a name for the module" => "모듈 만들기 혹은 갱신 불가: 모듈에 대한 이름 지정 필요",
"Cannot create or update module: You cannot leave the data field empty" => "모듈 만들기 혹은 갱신 불가: 데이터 필드를 빈 공간으로 남겨둘 수 없음",
"A module with that \"name\" already exists, please choose another" => "해당 \"이름\"을 가진 모듈이 이미 존재하오니 다른 것을 선택하여 주십시오",
// "Custom module created" => "Custom module created",
// "Custom module modified" => "Custom module modified",
// "Custom not module created" => "Custom not module created",
// "Custom module not modified" => "Custom module not modified",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module",
// "Module assigned" => "Module assigned",
// "Module not assigned" => "Module not assigned",
// "Custom module deleted" => "Custom module deleted",
// "Custom module not deleted" => "Custom module not deleted",
"Appearance" => "외형",
"No newsletter indicated" => "소식지 지정되지 않음",
"Newsletter does not exist" => "회보가 존재하지 않습니다",
// "subscription" => "subscription",
// "subscriptions" => "subscriptions",
// "No subscriptions removed" => "No subscriptions removed",
// "Subscription removed" => "Subscription removed",
// "Subscription not removed" => "Subscription not removed",
// "Subscription marked as valid" => "Subscription marked as valid",
// "Subscription not marked as valid" => "Subscription not marked as valid",
// "Errors encountered when attempting to add subscription" => "Errors encountered when attempting to add subscription",
// "Subscription added" => "Subscription added",
"Error opening uploaded file" => "업로드된 파일 열기 오류",
// "Error importing from wiki page \"%0\"" => "Error importing from wiki page \"%0\"",
// "Wiki page \"%0\" imported" => "Wiki page \"%0\" imported",
// "Error importing from tracker ID %0" => "Error importing from tracker ID %0",
// "Tracker ID %0 imported" => "Tracker ID %0 imported",
// "Not all subscriptions created" => "Not all subscriptions created",
// "Subscriptions not created" => "Subscriptions not created",
// "Subscriptions created" => "Subscriptions created",
// "Group \"%0\" subscribed" => "Group \"%0\" subscribed",
// "Group \"%0\" not subscribed" => "Group \"%0\" not subscribed",
// "Subscribers added" => "Subscribers added",
// "Subscribers not added" => "Subscribers not added",
// "Emails from wiki page \"%0\" subscribed" => "Emails from wiki page \"%0\" subscribed",
// "Emails from wiki page \"%0\" not subscribed" => "Emails from wiki page \"%0\" not subscribed",
// "%0 \$word removed" => "%0 \$word removed",
// "Newsletter removed" => "Newsletter removed",
// "Newsletter not removed" => "Newsletter not removed",
// "Newsletter created or modified" => "Newsletter created or modified",
// "Newsletter not created or modified" => "Newsletter not created or modified",
"You need to provide a username or an email" => "사용자명과 이메일을 제공해야 합니다.",
"The user has no email set. No notifications will be sent" => "사용자가 이메일을 사용하지 않았습니다. 알림 메일이 발송되지 않을 것입니다",
// "Mail notification event added" => "Mail notification event added",
// "Mail notification event deleted" => "Mail notification event deleted",
// "One mail notification events deleted" => "One mail notification events deleted",
// "%0 mail notifications events deleted" => "%0 mail notifications events deleted",
"No poll indicated" => "지정된 투표 없음",
// "Name is required" => "Name is required",
// "Task is required" => "Task is required",
// "Run Time is required" => "Run Time is required",
// "Run Time format is invalid" => "Run Time format is invalid",
// "Status cannot be empty" => "Status cannot be empty",
// "Scheduler %s was updated" => "Scheduler %s was updated",
// "Scheduler %s was created" => "Scheduler %s was created",
// "Inactive" => "Inactive",
"unsafe" => "안전하지 않음",
"The Path to store files in the filegallery should be outside the tiki root directory" => "파일갤러리에 파일을 저장할 경로는 티키 루트 디렉터리의 외부에 있어야 합니다",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "그림갤러리 내부에 파일을 저장할 경로는 티키 루트 디렉터리 외부에 있어야 합니다",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "\"템플릿 편집\" 기능이 켜졌습니다. 신뢰할 수 없는 이는 이 기능을 사용하지 못하도록 하십시오. PHP 코드를 넣기 위하여 손쉽게 사용될 수 있습니다",
"The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "\"Snarf 위키플러그인\" 이 활성화되었습니다. 이는 위키 편집기에서 로컬 네트워크에서 페이지를 포함하고 정규표현식 교체를 통하여 어떤 HTML도 만들기 위하여 사용될 수 있습니다",
"The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement" => "\"Regex 위키플러그인\" 이 활성화되었습니다. 이는 위키 편집기에서 정규표현식 교체를 통하여 어떤 HTML도 만들기 위하여 사용될 수 있습니다",
"The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "\"Lsdir 위키플러그인\" 이 활성화되었습니다. 위키 편집기에서 어떠한 디렉터리의 내용물을 보는 데 쓰일 수 있습니다",
"The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts." => "The \"Bloglist Wikiplugin\" 이 활성화되어 있습니다. 위키 편집자들이 다른 개인 블로그 게시물들을 드러내도록 하는데 사용될 수 있습니다.",
"The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks." => "\"iframe Wikiplugin\" 이 활성화 되어있습니다. 위키 편집자들에 의하여 사이트 전역에 걸친 스크립팅 공격을 위해 사용될 수 있습니다.",
"The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "\"js 위키플러그인\" 이 활성화되었습니다. 위키 편집기에서 자바 스크립트를 사용하는데 쓰일 수 있으며, 이는 사이트 교차 스크립팅 공격과 같은 많은 지저분한 경우에 약용될 수 있습니다",
"The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "\"JQ 위키플러그인\" 이 활성화되었습니다. 위키 편집기에서 자바 스크립트를 사용하는데 쓰일 수 있으며, 이는 사이트 교차 스크립팅 공격과 같은 많은 지저분한 경우에 약용될 수 있습니다",
"The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "\"Redirect 위키플러그인\" 이 활성화되었습니다. 이는 위키 편집기에서 교차 사이트 스크립팅 공격용으로 사용될 수 있습니다",
"The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)." => "\"Module Wikiplugin\" 이 활성화되어 있습니다. 위키 편집자들에 의하여 정보에 접근을 허용하는 모듈을 추가하는 데 사용될 수 있습니다 (모듈 목록을 참조 하십시오).",
"The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users." => "\"Userlist Wikiplugin\" 이 활성화되어 있습니다. 위키 편집자에 의하여 사용자 목록을 표기하도록 사용될 수 있습니다.",
"The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users." => "\"Usercount Wikiplugin\" 이 활성화되어 있습니다. 위키 편집자들에 의하여 사용자 수를 표기하도록 사용될 수 있습니다.",
"The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "\"SQL 위키플러그인\" 이 활성화되었습니다. 위키 편집기에서 SQL 명령어를 실행하도록 사용될 수 있습니다",
"risky" => "위험함",
// "To the extent secure logins are not required, data transmitted between the browser and server is not private" => "To the extent secure logins are not required, data transmitted between the browser and server is not private",
// "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php",
// "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php",
// "Unlocked" => "Unlocked",
// "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed" => "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed",
"Path disclosure" => "경로 공개",
"Path disclosure through error message" => "오류 메시지를 통한 경로 공개",
"SQL injection" => "SQL 삽입",
"SQL injection by authenticated user" => "인증된 사용자에 의한 SQL 삽입",
"SQL injection by authenticated user with special privileges" => "특별 권한을 보유한 인증된 사용자에 의한 SQL 삽입",
"SQL injection without authentication" => "인증 없이 SQL 삽입",
"PHP command injection" => "PHP 명령어 삽입",
"PHP command injection by authenticated user" => "인증받은 사용자에 의한 PHP 명령어 삽입",
"PHP command injection by authenticated user with special privileges" => "특별 권한을 지닌 인증받은 상요자에 의한 PHP 명령어 삽입",
"PHP command injection without authentication" => "인증없는 PHP 명령어 삽입",
"File upload" => "파일 업로드",
"File is not readable. Unable to check" => "파일을 읽을 수 없습니다. 확인 불가능",
// "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous" => "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous",
"This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "티키 파일이 아닙니다. 파일이 업로드된 경우와 위험한 경우를 확인합니다",
"This is a modified File. Cannot check version. Check if it is dangerous" => "이는 수정된 파일입니다. 버전을 확인할 수 없습니다. 위험한지 확인하십시오",
"This file is from another Tiki version: " => "이 파일은 다른 티키 버전으로부터 온 것입니다: ",
"Shoutbox Words" => "외침상자 문구",
"You have to provide a word" => "단어를 제공해야 합니다",
"You do not have permission to view this page" => "이 페이지를 볼 권한이 없습니다",
"You do not have permission to edit this page" => "이 페이지를 편집할 권한이 없습니다",
"You must specify a page name, it will be created if it doesn't exist." => "페이지 제목을 지정하여야 합니다. 제목이 없으면 페이지가 만들어지지 않습니다.",
"page not added (Exists)" => "페이지 추가 안됨 (존재함)",
"No survey indicated" => "지정된 설문 없음",
"Tiki Cache/Sys Admin" => "티키 캐시/시스템 관리",
"WYSIWYG Plugin" => "WYSIWYG 플러그인",
"Are you sure you want to delete all your custom tools" => "사용자 지정 도구 전체를 삭제하시겠습니까?",
"Are you sure you want to delete this custom tool" => "이 사용자 지정 도구를 삭제하시겠습니까",
"Are you sure you want to remove this topic" => "이 토픽을 삭제하시겠습니까",
"Are you sure you want to remove this topic AND all the articles related" => "이 토픽 및 모든 관련된 기사들을 삭제하시겠습니까",
"No tracker indicated" => "지정된 트래커 없음",
// "Tracker Fields %0" => "Tracker Fields %0",
// "Are you sure you want to delete the webservice \"%0\"" => "Are you sure you want to delete the webservice \"%0\"",
// "Are you sure you want to delete the template \"%0\"" => "Are you sure you want to delete the template \"%0\"",
// "Webservice error \"%0\" not saved (alpha characters only)" => "Webservice error \"%0\" not saved (alpha characters only)",
"User doesn't exist" => "사용자 존재하지 않음",
"No records were found. Check the file please" => "기록이 발견되지 않음. 파일을 확인해 주십시오",
"User login or email is required" => "사용자 로그인 혹은 이메일이 필요합니다",
"User does not exist on master" => "사용자는 마스터에 존재하지 않습니다",
"User login is required" => "사용자 로그인은 필수입니다",
"Email is required" => "이메일은 필수입니다",
"User is duplicated" => "사용자가 중복되었습니다",
"Created account %s <%s>" => "%s <%s> 계정 만듬",
"Assigned %s in group %s" => "%s 를 %s 그룹 안으로 할당함",
// "Users added" => "Users added",
// "%0 users not added" => "%0 users not added",
"Email validation requested but email address not set" => "이메일 확인이 요청되었으나 이메일 주소가 설정되지 않음",
"The passwords do not match" => "비밀번호가 일치하지 않습니다",
"Password not set" => "비밀번호 설정되지 않음",
"User %s already exists" => "사용자 %s 님은 이미 존재합니다",
"User login contains invalid characters" => "사용자 로그인이 유효하지않은 문자를 포함합니다",
"New user created with username %s" => "새 사용자가 사용자명 %s 로 만들어짐",
"Impossible to create new %s with %s %s" => "새 %s 를 %s %s 과 함께 만드는 것은 불가능합니다",
// "User account %0 has been invalidated by the admin" => "User account %0 has been invalidated by the admin",
// "An error occurred - the user account %0 has not been invalidated by the admin" => "An error occurred - the user account %0 has not been invalidated by the admin",
// "Link to OpenID for user %0 has been removed" => "Link to OpenID for user %0 has been removed",
// "An error occurred - the link to OpenID for user %0 has not been removed" => "An error occurred - the link to OpenID for user %0 has not been removed",
// "Modify this user's data" => "Modify this user's data",
"%s changed from %s to %s" => "%s가 %s에서 %s로 변경됨",
"%s modified successfully" => "%s 수정이 성공적이었습니다",
"%s modification failed" => "%s 수정이 실패하였습니다",
"Impossible to change %s from %s to %s" => "%s 를 %s 에서 %s 로의 변경은 불가능함",
"email" => "메일주소",
// "Unable to change %s from %s to %s" => "Unable to change %s from %s to %s",
"Review" => "검토",
"Classified" => "별도 분류됨",
"Failed to add attribute" => "속성 추가 실패",
"rss feed disabled" => "RSS 피드 비활성화됨",
// "Are you sure you want to add user %0 to group %1" => "Are you sure you want to add user %0 to group %1",
"You have to indicate a group" => "그룹을 지정해야 합니다",
"This group is invalid" => "이 그룹은 유효하지 않습니다",
// "Remote system user needs to be configured" => "Remote system user needs to be configured",
// "Remote system group for autologin need to be configured" => "Remote system group for autologin need to be configured",
// "User name needs to be specified" => "User name needs to be specified",
// "Base URL not received from remote system" => "Base URL not received from remote system",
// "Email needs to be specified" => "Email needs to be specified",
"The page cannot be found" => "페이지 없음",
// "Image Galleries Configuration Panel" => "Image Galleries Configuration Panel",
"Could not read image %s" => "그림 %s 를 읽을 수 없었습니다",
"Image %s upload failed" => "%s 그림 업로드가 실패함",
"Image %s uploaded successfully" => "%s 그림이 성공적으로 업로드됨",
"Image %s removed from Batch directory" => "%s 그림이 일괄 디렉터리에서 삭제됨",
"Impossible to remove image %s from Batch directory" => "일괄 디렉터리에서 %s 그림을 삭제하기가 불가능함",
"Incorrect directory chosen for batch upload of images" => "그림의 일괄 업로드에 대하여 틀릭 디렉터리 선택됨",
"Please setup that dir on " => "그 dir 를 다음으로 설정하여 주십시오",
"Please contact the website administrator" => "웹사이트 관리자에게 연락해 주십시오",
"Directory batch" => "디렉터리 일괄",
// "File Galleries Configuration Panel" => "File Galleries Configuration Panel",
"Incorrect directory chosen for batch upload of files" => "파일의 일괄 업로드에 대하여 틀린 디렉터리 선택됨",
// "It isn't possible to post in any blog" => "It isn't possible to post in any blog",
// "You may need to create a blog first" => "You may need to create a blog first",
"You do not have permission to edit this post" => "이 게시물을 편집할 권한이 없습니다",
"Top visited blogs" => "가장 많이 방문된 블로그들",
"Last posts" => "마지막 게시",
"Top active blogs" => "상위 활동적 블로그들",
"No blogId specified" => "지정된 로그ID (blogId) 없음",
"Stop watching all categories" => "모든 범주 주시하기 중지",
"Watch all categories" => "모든 범주 주시",
"Group watches for all categories" => "모든 범주에 대하여 그룹 주시",
"Stop watching this category and its descendants" => "이 범주와 그 하위항목들 주시하기 중지",
"Watch this category and its descendants" => "이 범주와 그 하위범주 주시",
"Group watches for this category" => "이 범주에 대하여 그룹 주시",
"Stop watching this category" => "이 범주 주시하기 중지",
"Watch this category" => "이 범주 주시",
"Nothing tagged yet" => "아직 태그된 것이 없음",
"You must clear your browser cache" => "브라우저 캐시를 반드시 제거해야 합니다",
"You do not have permission to access this gallery" => "이 갤러리에 접근할 권한이 없습니다",
"No gallery indicated" => "갤러리 지정되지 않음",
"You do not have permission to remove images from this gallery" => "이 갤러리에서 그림들을 삭제할 권한이 없습니다",
"You do not have permission to rebuild thumbnails in this gallery" => "이 갤러리의 미리보기를 재빌드할 권한이 없습니다",
"You do not have permission to rotate images in this gallery" => "이 갤러리에서 그림을 회전할 권한이 없습니다",
"No image indicated" => "그림 지정되지 않음",
"picture not found" => "그림 발견되지 않음",
"You do not have permission to move images from this gallery" => "이 갤러리에서 그림들을 이동할 권한이 없습니다",
"You do not have permission to view the calendar" => "달력을 볼 권한이 없습니다",
"You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "<a href=\"tiki-admin_calendars.php?cookietab=2\">달력 만들기</a> 를 해야할 필요가 있습니다",
"event without name" => "이름없는 이벤트",
"Invalid date format" => "유효하지 않은 날짜 형식",
"Your PHP installation does not have calendar enabled" => "귀하의 PHP 설치는 달력이 활성화되어있지 않습니다",
// "%H:%M %Z" => "%H:%M %Z",
"Invalid username or activation code. Maybe this code has already been used" => "유효하지 않은 사용자명 혹은 활성화 코드. 이 코드는 이미 사용되었을 수 있읍니다",
"Your email could not be validated; make sure you email is correct" => "귀하의 이메일을 유효화할 수 없었습니다: 이메일 주소를 확인하여 주십시오",
"You can not use the same password again" => "동일한 암호를 다시 사용할 수 없습니다",
"Invalid old password" => "오래된 무효 비밀번호",
"Invalid request. Expecting channels array" => "유효하지 않은 요청. 채널 배열이 필요합니다",
"Missing channel name" => "없는 채널명",
"One of the requested channels cannot be requested. It does not exist or permission is denied" => "요청된 채널 중 하나가 요청될 수 없습니다. 존재하지 않거나 권한이 거부되었습니다",
"One of the install profiles could not be obtained" => "설치 프로필 중 하나를 받을 수 없었습니다",
"info" => "정보",
// "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them" => "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them",
// "How to change this value" => "How to change this value",
// "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them" => "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them",
// "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors" => "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors",
// "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information" => "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information",
// "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information" => "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information",
// "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '" => "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '",
// "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring" => "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring",
// "No errors will be reported although the error_reporting level is all the way up at ' . \$e . " => "No errors will be reported although the error_reporting level is all the way up at ' . \$e . ",
// "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information" => "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information",
"good" => "좋음",
// "ini_set is used in some places to accommodate special needs of some Tiki features" => "ini_set is used in some places to accommodate special needs of some Tiki features",
// "unsure" => "unsure",
// "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini",
"The PDO extension is the suggested database driver/abstraction layer" => "PDO 확장기능은 권장 데이터베이스 드라이버/추상화 레이어입니다",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
"bad" => "불량",
// "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning" => "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning",
// "N/A" => "N/A",
// "Unable to detect" => "Unable to detect",
// "Cannot determine the size of this disk drive" => "Cannot determine the size of this disk drive",
// "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space" => "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space",
// "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files" => "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files",
// "When the disk space is filled, users, including administrators, will not be able to log in to Tiki" => "When the disk space is filled, users, including administrators, will not be able to log in to Tiki",
// "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported" => "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported",
// "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)" => "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)",
// "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for" => "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for",
// "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see" => "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see",
// "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see" => "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see",
// "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes" => "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes",
// "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used",
// "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache" => "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache",
// "It is recommended to use Zend opcode cache as the ByteCode Cache" => "It is recommended to use Zend opcode cache as the ByteCode Cache",
// "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used",
// "The memory_limit is at" => "The memory_limit is at",
// "This is known to support smooth functioning even for bigger sites" => "This is known to support smooth functioning even for bigger sites",
// "This will normally work, but the site might run into problems when it grows" => "This will normally work, but the site might run into problems when it grows",
"Your memory_limit is at" => "귀하의 메모리 제한(memory_limit)은 다음 위치에 있습니다:",
// "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default" => "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default",
// "The session.save_handler should be set to 'files'" => "The session.save_handler should be set to 'files'",
// "Well set! The default setting of 'files' is recommended for Tiki" => "Well set! The default setting of 'files' is recommended for Tiki",
// "The session.save_path must writable" => "The session.save_path must writable",
// "The session.save_path is writable" => "The session.save_path is writable",
// "If you would be using the recommended session.save_handler setting of 'files\\" => "If you would be using the recommended session.save_handler setting of 'files\\",
// "It doesn't matter though, since your session.save_handler is not set to 'files'" => "It doesn't matter though, since your session.save_handler is not set to 'files'",
// "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started" => "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started",
// "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request" => "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request",
// "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start" => "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start",
// "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup" => "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup",
// "This appears to work" => "This appears to work",
// "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki" => "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki",
// "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki" => "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki",
"register_globals should be off by default. See the PHP manual for details" => "register_globals 은 기본으로 꺼져 있어야 합니다. 상세내역은 PHP 설명서를 참조하십시오",
// "Correctly set! And this is also future proof as register_globals is deprecated" => "Correctly set! And this is also future proof as register_globals is deprecated",
"safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "안전모듬(safe_mode) 는 사용되지 않으며 기본으로 꺼져있어야 합니다. 상세내역은 <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP 설명서</a> 를 살펴보십시오",
// "Correctly set! And this is also future proof as safe_mode is deprecated" => "Correctly set! And this is also future proof as safe_mode is deprecated",
// "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior" => "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior",
// "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated" => "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated",
// "Correctly set! Tiki is fully UTF-8 and so should be this installation" => "Correctly set! Tiki is fully UTF-8 and so should be this installation",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file",
// "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a time zone set protects the site from related errors" => "Well done! Having a time zone set protects the site from related errors",
// "Files can be uploaded to Tiki" => "Files can be uploaded to Tiki",
// "Files cannot be uploaded to Tiki" => "Files cannot be uploaded to Tiki",
// "The max_execution_time is at" => "The max_execution_time is at",
// "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless" => "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless",
// "The max_execution_time is unlimited" => "The max_execution_time is unlimited",
"This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "반드시 나쁜 것은 아닙니다만, 업무용 서버에서는 에측되지 않은 장기 실행 스크립트를 제거하기 위하여 이를 제한하는 것이 좋은 아이디어입니다",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s",
// "The max_input_time is at" => "The max_input_time is at",
// "The max_input_time is unlimited" => "The max_input_time is unlimited",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds",
// "The max_file_uploads is at" => "The max_file_uploads is at",
// "This is the maximum number of files allowed to be uploaded simultaneously" => "This is the maximum number of files allowed to be uploaded simultaneously",
// "The maximum number of files allowed to be uploaded is not available" => "The maximum number of files allowed to be uploaded is not available",
// "The upload_max_filesize is at" => "The upload_max_filesize is at",
// "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly" => "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly",
// "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site" => "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site",
// "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site" => "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site",
// "The post_max_size is at" => "The post_max_size is at",
// "The GD extension is needed for manipulation of images and for CAPTCHA images" => "The GD extension is needed for manipulation of images and for CAPTCHA images",
"The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "GD 확장기능이 로드되었습니다, 그리고 티키는 그림을 만들 수 있습니다, 하지만 CAPTCHA 텍스트 생성에 대하여 FreeType 확장기능이 필요합니다",
"The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "GD 확장기능이 로드되었습니다, 하지만 티키는 그림을 만들 수 없습니다. GD 라이브러리 구성을 확인하십시오",
// "ImageMagick is used as a fallback in case GD is not available" => "ImageMagick is used as a fallback in case GD is not available",
"ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick 이 사용 가능합니다만 그림을 만들 수 없었습니다. ImageMagick 구성을 확인하여 주십시오",
// "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example" => "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example",
// "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file" => "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file",
// "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it" => "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it",
// "mbstring extension is needed for an UTF-8 compatible lower case filter" => "mbstring extension is needed for an UTF-8 compatible lower case filter",
"calendar extension is needed by Tiki" => "티키에서 달력 확장기능이 필요합니다",
// "The calendar feature of Tiki will not function without this" => "The calendar feature of Tiki will not function without this",
"ctype extension is needed by Tiki" => "cType 확장기능이 티키에서 필요합니다",
// "This extension is needed for the dom extension (see below)" => "This extension is needed for the dom extension (see below)",
// "This extension is needed by Tiki" => "This extension is needed by Tiki",
// "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server" => "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server",
// "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17" => "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17",
// "This extension is required for H5P" => "This extension is required for H5P",
// "This extension is required for many features in Tiki" => "This extension is required for many features in Tiki",
"This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "이 확장기능은 TortoiseSVN 1.7 혹은 그 이후 버전에 대하여 SVN 정보를 해석하기 위하여 사용됩니다",
// "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available" => "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available",
// "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries" => "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries",
// "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL" => "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL",
// "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt" => "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt",
// "Ability to generate random numbers, useful for example for CAPTCHA and other security features" => "Ability to generate random numbers, useful for example for CAPTCHA and other security features",
// "This extension is required and used frequently in validation functions invoked within Zend Framework" => "This extension is required and used frequently in validation functions invoked within Zend Framework",
"The eval() function is required by the Smarty templating engine" => "eval() 함수가 스마티 템플릿 엔진에서 요구됩니다",
"You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "모듈 대신 \"관련 지원으로 연락하십시오\" 메시지를 받게 될 것입니다. eval() 은 Suhosin을 통하여 비활성화되었을 가능성이 큽니다",
"The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "ZipArchive 클래스는 XML 위키 가져오기/내보내기 및 PluginArchiveBuilder 와 같은 기능에 대하여 필요합니다",
"The DateTime class is needed for the WebDAV feature" => "날짜시간 클래스가 WebDAV 기능에 대하여 필요합니다",
// "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server" => "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server",
"Tiki requires MySQL >= 5.x" => "티키는 MySQL >= 5.x 을 요구합니다",
// "The max_allowed_packet setting is at" => "The max_allowed_packet setting is at",
// "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Your database supports the utf8mb4 character set required in Tiki19 and above" => "Your database supports the utf8mb4 character set required in Tiki19 and above",
// "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation" => "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation",
// "Tiki is fully utf8mb4 and so should be every part of the stack" => "Tiki is fully utf8mb4 and so should be every part of the stack",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified" => "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified",
// "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki" => "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down" => "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down",
// "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down" => "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down",
// "ON" => "ON",
// "OFF" => "OFF",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki",
// "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess" => "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess",
// "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"" => "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"",
// "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again" => "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again",
// "Not Working" => "Not Working",
// "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki" => "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki",
// "Working" => "Working",
// "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs" => "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly",
// "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly",
// "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
"The URL Rewrite Module is required to use SEFURL on IIS" => "URL Rewrite 모듈은 IIS 에서 SEFURL을 사용하는 것을 필요로 합니다",
// "Not Installed" => "Not Installed",
// "Tesseract PHP package could not be found. Try installing through Packages" => "Tesseract PHP package could not be found. Try installing through Packages",
// "Tesseract PHP dependency installed" => "Tesseract PHP dependency installed",
// "The installed Tesseract version is lower than the required version" => "The installed Tesseract version is lower than the required version",
// "Tesseract package" => "Tesseract package",
// "languages installed" => "languages installed",
// "Not all languages installed. You may need to install additional languages for multilingual support" => "Not all languages installed. You may need to install additional languages for multilingual support",
// "Tesseract languages" => "Tesseract languages",
// "Tesseract could not be found" => "Tesseract could not be found",
// "Tesseract meets or exceeds the version requirements" => "Tesseract meets or exceeds the version requirements",
// "Tesseract binary" => "Tesseract binary",
// "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path" => "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path",
// "Path setup correctly" => "Path setup correctly",
// "Your path may not be configured correctly. It appears to be located at " => "Your path may not be configured correctly. It appears to be located at ",
// "Your path is configured, but we were unable to tell if it was configured properly or not" => "Your path is configured, but we were unable to tell if it was configured properly or not",
// "Tesseract path" => "Tesseract path",
// "Pdfimages path" => "Pdfimages path",
// "Scheduler has been successfully setup" => "Scheduler has been successfully setup",
// "Scheduler needs to have a console command of \"ocr:all\" set" => "Scheduler needs to have a console command of \"ocr:all\" set",
// "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser" => "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser",
// "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration" => "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration",
"safe" => "안전함",
"WebKit is enabled" => "웹킷이 활성화되었습니다",
// "The Blogs feature is enabled" => "The Blogs feature is enabled",
// "Exec can potentially be used to execute arbitrary code on the server" => "Exec can potentially be used to execute arbitrary code on the server",
// "Tiki does not need it; perhaps it should be disabled" => "Tiki does not need it; perhaps it should be disabled",
// "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled" => "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled",
// "Exec can be potentially be used to execute arbitrary code on the server" => "Exec can be potentially be used to execute arbitrary code on the server",
// "Tiki needs it to run the Plugins R/RR" => "Tiki needs it to run the Plugins R/RR",
// "If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "If this is needed and the other PHP software on the server can be trusted, this should be enabled",
"Passthru is similar to exec" => "Passthru는 exec과 유사합니다",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
"Shell_exec is similar to exec" => "Shell_exec 은 exec 과 유사합니다",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled",
"System is similar to exec" => "시스템은 exec 와 유사합니다",
// "Tiki does not need it; it is good that it is disabled" => "Tiki does not need it; it is good that it is disabled",
"Proc_open is similar to exec" => "Proc_open 은 exec 와 유사합니다",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "popen is similar to exec" => "popen is similar to exec",
// "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled",
"Curl_exec can potentially be abused to write malicious code" => "Curl_exec 은 잠재적으로 악성 코드를 작성하도록 부당하게 이용될 수 있습니다",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled",
"Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec 은 잠재적으로 악성 코들르 작성하도록 부당하게 이용될 수 있습니다",
"It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "이것이 위험하다는 것은 아마 근거없는 내용일 것입니다. 티키 팀은 이 체크된 내용을 재검토하겠지만, 본 내용을 숙지 부탁 드립니다",
// "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature" => "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature",
// "session.use_trans_sid should be off by default. See the PHP manual for details" => "session.use_trans_sid should be off by default. See the PHP manual for details",
// "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them" => "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them",
// "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off" => "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off",
// "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information",
// "To manage this instance from a remote server you need SSH or FTP access to this server" => "To manage this instance from a remote server you need SSH or FTP access to this server",
// "Command found" => "Command found",
// "Command not found, check if it is installed and available in one of the paths above" => "Command not found, check if it is installed and available in one of the paths above",
// "Extension loaded in PHP" => "Extension loaded in PHP",
// "Extension not loaded in PHP" => "Extension not loaded in PHP",
"Test mail from Tiki Server Compatibility Test" => "티키 서버 호환성 테스트에서 온 시험용 메일",
// "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered" => "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered",
// "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php" => "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php",
// "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts" => "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts",
"The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "fileinfo 확장기능이 '업로드된 파일 컨텐츠 유효화' 기본설정에 대하여 필요합니다",
// "The intl extension is required for Tiki 15 and newer" => "The intl extension is required for Tiki 15 and newer",
// "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters" => "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters",
// "Congratulations!\n\nThis server can send emails.\n\n" => "Congratulations!\n\nThis server can send emails.\n\n",
// "The path '%0' on preference '%1' does not exist" => "The path '%0' on preference '%1' does not exist",
// "The lib '%0' on preference '%1', option '%2' does not exist" => "The lib '%0' on preference '%1', option '%2' does not exist",
// "The class '%0' needed for preference '%1', with option '%2' selected, does not exist" => "The class '%0' needed for preference '%1', with option '%2' selected, does not exist",
// "The extension '%0' on preference '%1', with option '%2' selected, is not loaded" => "The extension '%0' on preference '%1', with option '%2' selected, is not loaded",
"Top authors" => "상위 저자들",
// "User %0 validated by the admin" => "User %0 validated by the admin",
"Problem. Try to log in again to receive new confirmation instructions" => "문제. 새로 확인 방법을 받으려면 다시 로그인 해 보십시오",
"Invalid" => "유효하지 않음",
"You must include a subject or a message" => "제목 혹은 메시지를 반드시 포함해야 합니다",
"You must make sure to have a valid email address in the From field" => "From 필드 내에 유효한 이메일 주소가 적혀있음을 반드시 확인해야 합니다",
"%0 sent you a message" => "%0님이 귀하께 메시지를 보냈습니다",
"last version" => "최종 버전",
"Cannot rename page because the new name begins with reserved prefix" => "새 페이지가 예약된 접두어로 시작되어서 페이지 이름 변경 불가",
"Cannot copy page because maybe new page name already exists" => "페이지 복사 불가 이유는 새 페이지 이름이 이미 존재할 있음",
"TikiHelp WebHelp generation engine. Generating WebHelp using" => "티키도움말 웹도움말 생성 엔진. 다음을 사용하여 웹도움말 생성 중",
"Eliminating previous files" => "기존 파일들 삭제 중",
"Index: <strong>%0</strong>" => "색인: <strong>%0</strong>",
"Directory: <strong>%0</strong>" => "디렉터리: <strong>%0</strong>",
// "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix" => "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix",
"You need to change chmod 'whelp' manually to 777" => "chmod 'whelp' 를 수동으로 777 로 변경해야 합니다",
"Creating directory structure in <strong>%0</strong>" => "<strong>%0</strong> 내부에 디렉터리 구조체 만드는 중",
"Submit a new link" => "새 링크 제출",
"Must enter a name to add a site. " => "사이트를 추가하려면 반드시 이름을 입력해야 함",
"Must enter a url to add a site. " => "사이트를 추가하려면 URL을 반드시 입력해야 함",
"URL already added to the directory. Duplicate site? " => "디렉터리에 URL 이미 추가됨. 사이트를 복제할까요?",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL 에 접근될 수 없습니다. 틀린 URL 혹은 오프라인이며 디렉터리로 추가될 수 없습니다",
"Must select a category. " => "카테고리 선택하여 주세요.",
"Must enter a name to add a site" => "사이트를 추가 위해 이름이 필요",
"Must enter a url to add a site" => "사이트를 추가하려면 URL을 반드시 입력해야 함",
"URL already added to the directory. Duplicate site" => "디렉터리에 URL 이미 추가됨. 사이트를 복제할까요?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL 에 접근 불가: 틀린 URL 혹은 사이트가 오프라인이고 디렉터리에 추가 할 수 없음",
"Must select a category" => "카테고리 선택필요",
"Browse Directory" => "디렉터리 열람",
"How to use Directory" => "디렉터리 사용 방법",
"No site indicated" => "사이트 지정되지 않음",
"This feature is disabled: %0" => "이 기능은 비활성화되었습니다: %0",
"No parent specified" => "지정된 부모 없음",
"Latest sites of directory %0" => "디렉토리 %0 의 마지막 사이트",
"Discount code already exists" => "할인 코드가 이미 존재합니다",
// "Invalid fileId. Please provide a valid fileId to preview a specific file" => "Invalid fileId. Please provide a valid fileId to preview a specific file",
// "Unable to display file" => "Unable to display file",
"File has been deleted" => "파일이 삭제 되었습니다",
"You cannot download this file right now. Your score is low or file limit was reached" => "이 파일을 지금 다운로드 할 수 없습니다. 점수가 낮거나 파일 제한에 도달했습니다",
// "File locked" => "File locked",
// "File not locked" => "File not locked",
"Error : The file %s doesn't exist" => "오류: %s 파일은 존재하지 않음",
"Article not found" => "기사 찾을 수 없음",
"You do not have permission to edit this article" => "이 기사를 편집할 권한이 없습니다",
"The language can't be changed as its set of translations has already this language" => "언어는 변경될 수 없습니다, 그 이유는 번역 세트가 이 언어를 이미 보유하고 있기 때문입니다",
"Banner not found" => "배너 찾을 수 없음",
"You do not have permission to edit this banner" => "이 배너를 편집할 권한이 없습니다",
"You do not have permission to edit this blog" => "이 블로그를 편집할 권한이 없습니다",
// "No filters applied" => "No filters applied",
// "You do not have permission to write the css file" => "You do not have permission to write the css file",
// "Wrong file type, expected one of %0" => "Wrong file type, expected one of %0",
"You do not have permission to view/edit this file" => "이 파일을 보기/편집 할 권한이 없습니다",
" drawing" => " 드로잉",
"Wrong file type, expected %0" => "잘 못된 파일 종류, %0 필요",
"New Svg Image" => "새 SVG 그림",
"Invalid request to edit an image" => "그림 편집의 유효하지 않은 요청",
"You have permission to edit images but not in this gallery" => "그림을 편집할 권한이 있습니다만 이 갤러리내부에서는 아닙니다",
"Failed to edit the image" => "그림 편집 실패함",
"Edit or export languages" => "언어 편집 혹은 내보내기",
"Edit Perspectives" => "Perspectives 편집",
"No content id indicated" => "컨텐츠ID 지정되지 않음",
"No question indicated" => "질문 지정되지 않음",
"No quiz indicated" => "퀴즈 지정되지 않음",
// "View this wiki page" => "View this wiki page",
"No structure indicated" => "구조 지정되지 않음",
"Invalid structure_id or page_ref_id" => "유효하지 않은 structure_id 혹은 page_ref_id",
"You do not have permission to edit submissions" => "투고기사 편집 권한이 없습니다",
"You have to create a topic first" => "토픽부터 먼저 만들어야 합니다",
"Template directory %0 unknown" => "템플릿 디렉터리 %0 알려지지 않음",
"You do not have permission to do that" => "그것에 대한 권한이 없습니다",
"You do not have permission to write the template" => "템플릿을 쓰기 권한이 없습니다",
"You do not have permission to read the template" => "템플릿을 읽을 권한이 없습니다",
"No topic id specified" => "지정된 토픽 id 없음",
"Invalid topic id specified" => "유효하지 않은 토픽 ID 지정됨",
"No object indicated" => "지정된 개체 없음",
"Only wiki pages are supported" => "위키 페이지들만 지원됩니다",
// "Forbidden" => "Forbidden",
// "New diagram" => "New diagram",
// "Edit diagram" => "Edit diagram",
"Override lock and carry on with edit" => "잠금 재정의 및 편집 진행",
"Page is currently being edited" => "페이지가 현재 편집되고 있습니다",
"page imported" => "페이지 가져옴",
"created from import" => "가져오기에서 만들어짐",
// "To review the changes you have just made %0compare the versions%1 in history of this page" => "To review the changes you have just made %0compare the versions%1 in history of this page",
// "Page %0 saved (version %1)" => "Page %0 saved (version %1)",
"This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "이 페이지는 %0 님이 편집하고 있습니다. 페이지를 편집하기 전에 그 사용자와 확인하십시오, 그렇지 않은 경우, 변경내역은 기록에 두 개의 별도의 버전으로 저장될 것이며 후에 이들을 수동으로 병합해야할 것입니다",
"Can't import remote HTML page" => "원격 HTML 페이지 가져오기 불가",
"The Sandbox is disabled" => "모래상자가 비활성화되었습니다",
"The page cannot be edited because it is locked" => "페이지가 잠겨있기 때문에 편집 불가",
"That page already exists. Go back and choose a different name" => "페이지 이미 존재함. 돌아가서 다른 이름을 선택하시오",
"The page name is" => "페이지명은 ",
"The translation set already contains a page in this language" => "번역 세트는 이미 이 언어로된 페이지를 포합하고 있습니다",
"The file cannot be opened" => "파일 열 수 없음",
"Problem zip initialisation" => "ZIP 초기화 문제",
"Problem zip" => "ZIP 문제",
"Another user is currently exporting that tracker. Please try again later" => "다른 사용자가 현재 그 트래커를 내보내기 중입니다, 나중에 다시 시도해 주십시오",
"No questions group indicated" => "지정된 질문 그룹 없음",
"Remove archive: " => "보관 제거:",
"Remove file gallery: " => "파일 갤러리 제거:",
"You do not have permission to edit this file" => "이 파일을 편집할 권한이 없습니다",
"Most-visited file galleries" => "가장 많이 방문된 파일 갤러리들",
"Most downloaded files" => "가장 많이 다운르도된 파일들",
"Last files" => "마지막 파일들",
"No gallery ID specified" => "지징된 갤러리ID(galleryId) 없음",
"Form error - no import method selected for some reason" => "형식 오류 - 어떤 이유에서인지 가져오기 방식이 선택된 것이 없음",
"Form error - no server-side filename entered for selected import method" => "형식 오류 - 선택된 가져오기 방식에 대하여 서버측 파일명이 입력되지 않음",
"No forum indicated" => "지정된 게시판 없음",
"Last forum topics" => "최근 게시판 토픽",
"Last replied forum topics" => "최종 답글이 달린 게시판 토픽",
"Most-Read Forum Topics" => "가장 많이 읽은 게시판 토픽",
"Top topics" => "상위 토픽",
"Forum posts" => "게시판 게시물들",
"Most-Visited Forums" => "가장 많이 방문된 게시판들",
"No forumId specified" => "지정된 게시판ID (forumId) 없음",
"List Forums" => "게시판 목록",
"Not supported yet" => "아직 지원되지 않음",
// "All files copied" => "All files copied",
// "id" => "id",
"first uploaded image" => "첫 업로드된 그림",
"last uploaded image" => "최종 업로드된 그림",
"first image" => "첫번째 그림",
"last image" => "마지막그림",
"random image" => "무작위 그림",
"You do not have permission to create galleries and so you cannot edit them" => "갤러리를 만들 권한이 없습니다 그래서 편집할 수 없습니다",
"You do not have permission to edit this gallery" => "이 갤러리를 편집할 권한이 없습니다",
"You do not have permission to remove this gallery" => "이 갤러리를 삭제할 권한이 없습니다",
"Top images" => "상위 그림들",
"Last images" => "마지막 그림",
"No valid renderer found. GD or PDFLib required" => "유효한 렌더러 발견되지 않음: GD 혹은 PDFLib 필요함",
"No sheet specified" => "지정된 시트 없음",
// "Unknown Graphic" => "Unknown Graphic",
// "Unknown Renderer" => "Unknown Renderer",
"You must select a renderer" => "렌더러를 반드시 선택해야 합니다",
"Invalid Series for current graphic" => "현재 그래픽에 하여 유효하지 않은 시리즈",
"overwriting old page" => "구 페이지 덮어쓰는 중",
"updated from structured text import" => "구조화된 텍스트 가져오기에서 갱신됨",
"page created" => "페이지 만들어짐",
"created from structured text import" => "구조체화 된 텍스트 가져오기에서 만들어짐",
// "Unable to locate import file" => "Unable to locate import file",
// "Pages in zip file %0 successfully imported" => "Pages in zip file %0 successfully imported",
"Invalid software name" => "유효하지 않은 소프트웨어명",
// "No wiki page specified" => "No wiki page specified",
"This version does not exist" => "이 버전은 존재하지 않습니다",
"There is more than one item in the tracker with this title" => "트래커 내부에는 이 제목으로 된 항목이 한 개 이상있습니다",
"There are no items in the tracker with this title" => "트래커 내부에 이 제목으로된 항목이 없습니다",
// "Are you sure you want to undo the last change" => "Are you sure you want to undo the last change",
// "There is nothing to undo" => "There is nothing to undo",
"You have requested that this page be machine translated" => "이 페이지의 기계 번역을 요청하셨습니다",
"However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "하지만, 기계 번역 기능이 활성화되지 않았습니다. 이 기능을 활성화 하시거나 , 사이트 관리자에게 요청을 하십시오",
"No repository given" => "주어진 리포지터리 없음",
"This invitation does not exist or is deprecated" => "이 초대는 존재하지 않거나 사용되지 않습니다",
"Congratulations! You are now part of this invitation group(s)" => "축하합니다! 귀하는 이제 이 초청 그룹(들)의 일원입니다",
"Communication error" => "커뮤니케이션 오류",
"Invalid response provided by the Kaltura server. Please retry" => "칼투라 서버가 유효하지 않은 응답을 제공햇습니다. 다시 시도하십시오",
"Are you sure you want to permanently remove the article with identifier %0" => "식별자 %0 의 기사를 영구 삭제하시겠습니까",
"Are you sure you want to permanently remove these %0 articles" => "다음 %0개 기사를 영구 삭제하시겠습니까",
"You do not have permission to remove articles" => "기사를 삭제할 권한이 없습니다",
"You do not have permission to remove banners" => "배너를 삭제할 권한이 없습니다",
"List Blog Posts" => "블로그 게시물 목록",
"You do not have permission to remove this blog" => "이 블로그를 삭제할 권한이 없습니다 ",
"You do not have permission to view the comments for this blog" => "이 블로그에 대한 댓글을 볼 권한이 없습니다",
// "The following comment has been deleted" => "The following comment has been deleted",
// "The following comments have been deleted" => "The following comments have been deleted",
// "Delete selected comments and ban" => "Delete selected comments and ban",
// "Users have been pre-selected for banning in the highlighted section of the form below" => "Users have been pre-selected for banning in the highlighted section of the form below",
// "One comment approved" => "One comment approved",
// "%0 comments approved" => "%0 comments approved",
// "No comments approved" => "No comments approved",
// "One comment rejected" => "One comment rejected",
// "%0 comments rejected" => "%0 comments rejected",
// "No comments rejected" => "No comments rejected",
// "Comment archived" => "Comment archived",
// "%0 comments archived" => "%0 comments archived",
// "No comments archived" => "No comments archived",
// "Comment unarchived" => "Comment unarchived",
// "%0 comments unarchived" => "%0 comments unarchived",
// "No comments unarchived" => "No comments unarchived",
// "Action not performed since no comments were selected" => "Action not performed since no comments were selected",
"Approved Status" => "승인됨 상태",
"This blog has no posts" => "이 블로그는 게시물이 없습니다",
"Dynamic content" => "유동 컨텐츠",
"Admin FAQs" => "FAQ 관리",
"Non-existent gallery" => "존재하지 않는 갤러리",
"You do not have permission to view this gallery" => "이 갤러리를 볼 권한이 없습니다",
// "One item moved" => "One item moved",
// "%0 items moved" => "%0 items moved",
// "No items moved" => "No items moved",
// "One item moved and one item failed to move" => "One item moved and one item failed to move",
// "One item moved and %0 items failed to move" => "One item moved and %0 items failed to move",
// "%0 items moved and one item failed to move" => "%0 items moved and one item failed to move",
// "%0 items moved and %0 items failed to move" => "%0 items moved and %0 items failed to move",
// "One item deleted" => "One item deleted",
// "%0 items deleted" => "%0 items deleted",
// "No items deleted" => "No items deleted",
// "One item deleted and one item failed to delete" => "One item deleted and one item failed to delete",
// "One item deleted and %0 items failed to delete" => "One item deleted and %0 items failed to delete",
// "%0 items deleted and one item failed to delete" => "%0 items deleted and one item failed to delete",
// "%0 items moved and %0 items failed to delete" => "%0 items moved and %0 items failed to delete",
// "List view settings reset for one gallery" => "List view settings reset for one gallery",
// "List view settings reset for %0 galleries" => "List view settings reset for %0 galleries",
// "List view settings not changed for the selected gallery" => "List view settings not changed for the selected gallery",
// "List view settings not changed for the %0 selected galleries" => "List view settings not changed for the %0 selected galleries",
// "List view settings reset for %0 galleries and not changed for one gallery" => "List view settings reset for %0 galleries and not changed for one gallery",
// "List view settings reset for %0 galleries and not changed for %0 galleries" => "List view settings reset for %0 galleries and not changed for %0 galleries",
// "No files selected" => "No files selected",
// "Metadata refreshed for one file" => "Metadata refreshed for one file",
// "Metadata refreshed for %0 files" => "Metadata refreshed for %0 files",
// "Metadata not refreshed" => "Metadata not refreshed",
// "Metadata refreshed for one file and not refreshed for one file" => "Metadata refreshed for one file and not refreshed for one file",
// "Metadata refreshed for one file and not refreshed for %0 files" => "Metadata refreshed for one file and not refreshed for %0 files",
// "Metadata refreshed for %0 files and not refreshed for one file" => "Metadata refreshed for %0 files and not refreshed for one file",
// "Metadata refreshed for %0 files and not refreshed for %0 files" => "Metadata refreshed for %0 files and not refreshed for %0 files",
// "Incorrect file ID" => "Incorrect file ID",
"The file is already locked by %s" => "파일은 이미 %s 님에 의하여 잠겨있습니다",
// "File unlocked" => "File unlocked",
// "File not unlocked" => "File not unlocked",
// "Files in this gallery are not lockable" => "Files in this gallery are not lockable",
"You don't have permission to validate files from this gallery" => "권한 거부됨. 이 갤러리에서 파일을 유효화할 수 없습니다",
// "Error retrieving file" => "Error retrieving file",
// "Draft validated" => "Draft validated",
// "Validation failed" => "Validation failed",
// "File deleted" => "File deleted",
// "File not deleted" => "File not deleted",
// "Metadata refreshed" => "Metadata refreshed",
// "You need upload permission to edit files" => "You need upload permission to edit files",
// "You need permission to create galleries to edit them" => "You need permission to create galleries to edit them",
// "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode" => "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode",
"Quota too big" => "할당이 너무 큼",
"Quota too small" => "할당이 너무 작음",
// "Gallery %0 created or modified" => "Gallery %0 created or modified",
// "Gallery %0 not created or modified" => "Gallery %0 not created or modified",
"You do not have permission to duplicate this gallery" => "귀하는 이 갤러리를 복제할 권한을 보유하고 있지 않습니다",
// "Gallery duplicated" => "Gallery duplicated",
// "Gallery not duplicated" => "Gallery not duplicated",
// "Remove file gallery %0" => "Remove file gallery %0",
// "Incorrect gallery ID" => "Incorrect gallery ID",
// "Gallery %0 deleted" => "Gallery %0 deleted",
// "Gallery %0 not deleted" => "Gallery %0 not deleted",
"Could not find the file requested" => "요청된 파일을 찾을 수 없었습니다",
// "File %0 updated" => "File %0 updated",
// "File %0 not updated" => "File %0 not updated",
// "Invalid %0 parameter" => "Invalid %0 parameter",
// "File %0 not found" => "File %0 not found",
// "User watch added" => "User watch added",
// "User watch not added" => "User watch not added",
// "User watch removed" => "User watch removed",
// "User watch not removed" => "User watch not removed",
// "Not modified for" => "Not modified for",
// "Not downloaded for" => "Not downloaded for",
"This gallery does not exist" => "이 갤러리는 존재하지 않습니다",
"Error importing" => "가져오기 오류",
"Error converting" => "변환 오류",
"Importing" => "가져오는 중",
"Processing" => "처리 중",
"Ready" => "준비",
"Pending moderation" => "중재 보류 중",
"Blocked" => "차단됨",
"Invalid action" => "유효하지 않은 작업",
"Remove permission %0 from %1" => "권한 %0 을 %1 에서 제거",
"Assign permission %0 to %1" => "%0 권한을 %1 으로 할당",
"Delete posts" => "게시물 삭제",
"View submissions" => "투고기사 보기",
"Are you sure you want to permanently remove the submitted article with identifier %0" => "%0 식별자로된 제출된 기사를 영구 삭제하시겠습니까",
"Are you sure you want to permanently remove these %0 submitted articles" => "다음의 %0 제출된 기사들을 영구삭제하시겠습니까",
"Are you sure you want to approve these %0 submitted articles" => "%0 제출된 기사들을 승인하시겠습니까?",
// "Are you sure you want to permanently remove all expired submitted articles" => "Are you sure you want to permanently remove all expired submitted articles",
// "Pages not in a structure" => "Pages not in a structure",
"You are neither an administrator nor an operator of live support" => "귀하는 관라지나 라이브 지원의 운영자가 아닙니다",
"Username field cannot be empty. Please go back and try again" => "사용자명 필드는 비어있을 수 없습니다. 돌아가셔서 다시 시도하십시오.",
"Unable to contact remote server" => "원격 서버 연결 불가능",
"XMLRPC Error: " => "XMLRPC 오류",
"Unable to create login" => "로그인을 만들 수 없습니다",
// "No groups set on Intertiki client" => "No groups set on Intertiki client",
// "%d or more unsuccessful login attempts have been made" => "%d or more unsuccessful login attempts have been made",
"Your account has been suspended" => "계정이 일시 중단 됨",
// "Contact your site administrator to reactivate it" => "Contact your site administrator to reactivate it",
"An email has been sent to you with the instructions to follow" => "이메일이 설명과 함께 귀하께 발송되었습니다",
"Account requires administrator approval" => "계정은 관리자 승인이 필요합니다",
"You did not validate your account" => "계정을 유효화 하지 않으셨습니다",
"Resend" => "재전송",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "이메일을 받으셨을 것입니다. 메일상자 및 스팸 상자를 확인하십시오. 이메일을 다시 보내시려면 버튼을 클릭하십시오",
"You must use the right case for your username" => "사용자명에 대하여 올바른 케이스르 반드시 사용해야 합니다",
"You are not yet validated" => "아직 확인되지 않았습니다",
"You are already logged in" => "이미 로그인되어 있습니다",
// "Authentication error" => "Authentication error",
"The mail can't be sent. Contact the administrator" => "메일이 발송될 수 없습니다. 관리자에게 연락하십시오",
// "There is more than one user account with this email. Please contact the administrator" => "There is more than one user account with this email. Please contact the administrator",
"Your default nickname is already in use. A new one has to be selected" => "귀하의 기본 별명은 이미 사용 중입니다. 새 것을 선택하여 주십시오",
"Verification cancelled" => "인증 취소",
"The selected account is not associated with your identity" => "선택된 계정은 귀하의 신분과 연관되어있지 않습니다",
"unknown action" => "알 수 없는 작업",
"Authentication method is not OpenID" => "인증 방식이 OpenID 가 아님",
"Authentication error; probably not a valid OpenID" => "인증 오류, 유효한 OpenID 가 아닐 가능성",
"Could not redirect to server: " => "서버에 리다이렉트 할 수 없었습니다:",
"OpenID authentication failed: " => "OpenID 인증 실패: ",
"You have already validated your account. Please log in" => "이미 유효화된 계정을 보유하고 계십니다. 로그인 하십시오",
"No page provided" => "제공된 페이지 없음",
// "User module unassigned" => "User module unassigned",
// "User module not unassigned" => "User module not unassigned",
// "User module moved up" => "User module moved up",
// "User module not moved up" => "User module not moved up",
// "User module moved down" => "User module moved down",
// "User module not moved down" => "User module not moved down",
// "User module moved to opposite side" => "User module moved to opposite side",
// "User module not moved to opposite side" => "User module not moved to opposite side",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
"You must log in to use this feature" => "이 기능을 사용하려면 반드시 로그인 해야 합니다",
// "\$tikiMonitorRestriction need to be an array" => "\$tikiMonitorRestriction need to be an array",
"My Account Home" => "마이티키 홈",
"You do not have permission to view other users data" => "다른 사용자 데이터를 볼 권한이 없습니다",
// "Subscription confirmed for newsletter %0 (%1)" => "Subscription confirmed for newsletter %0 (%1)",
// "Subscription request failed" => "Subscription request failed",
// "You have been unsubscribed from newsletter %0" => "You have been unsubscribed from newsletter %0",
// "Your request to unsubscribe failed" => "Your request to unsubscribe failed",
"You must be logged in to subscribe to newsletters" => "회보를 구독하려면 반드시 로그인 되어있어야 합니다",
// "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter" => "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter",
// "Newsletter not subscribed" => "Newsletter not subscribed",
"No note indicated" => "노트 지정되지 않음",
"merged note" => "병합된 메모",
"The file is too large" => "파일이 너무 큽니다",
"No item indicated" => "아이템 지정되지 않음",
"Are you sure you want to delete this note" => "이 메모를 삭제하시겠습니까",
"created from notepad" => "메모장에서 만들어짐",
"Note not found" => "발견되지 않음",
"No name indicated for wiki page" => "위키 페이지에 대한 이름 지정되지 않음",
"Not enough information to display this page" => "이 페이지를 표시할 정보 충분하지 않음",
"You do not have permission to assign permissions for this object" => "이 개체에 대하여 권한을 할당할 권한이 없습니다",
// "Are you sure you want to modify permissions" => "Are you sure you want to modify permissions",
// "%0 and all the children groups" => "%0 and all the children groups",
"Are you sure you want to remove the direct permissions from this object" => "이 개체로부터 직접 권한을 삭제하시겠습니까",
"Are you sure you want to paste the copied permissions into this object" => "복사된 권한을 이 개체로 붙이넣기하시겠습니까",
// "Error while processing payment: " => "Error while processing payment: ",
// "Payment has been confirmed" => "Payment has been confirmed",
// "Payment confirmation has not been received yet" => "Payment confirmation has not been received yet",
"Manual payment entered" => "수동 지불 입력됨",
"You do not have permission to enter payment" => "지불을 입력할 권한이 없습니다",
"New payment requested" => "새 지불 요청됨",
"Cancel payment %0" => "지불 %0 취소",
"Payment canceled" => "지불 취소됨",
// "You need permission to edit pages in order to experiment on plugin LIST" => "You need permission to edit pages in order to experiment on plugin LIST",
// "No preference given" => "No preference given",
// "This preference is not translatable" => "This preference is not translatable",
"No article indicated" => "기사 지정되지 않음",
"Article is not published yet" => "기사가 아직 게시되지 않았습니다",
"No post indicated" => "포스트 지정되지 않음",
"Blog not found" => "블로그 찾을 수 없음",
"Missing object list type argument" => "누락된 개체 목록 유형 인수",
"Index (%0)" => "색인 (%0)",
"No pages indicated" => "페이지 지정되지 않음",
"Multiple Print" => "다중 인쇄",
"Pageviews" => "페이지보기",
"No result indicated" => "지정된 결과 없음",
"Invalid or unknown username" => "유효하지 않거나 알려지지 않은 사용자명",
"Unable to send mail. User has not configured email" => "메일 전송을 할 수 없었음. 사용자가 이메일을 구성하지 않았음",
"Invalid or unknown email address" => "유효하지 않거나 알려지지 않은 이메일",
"Please provide a username or email address" => "사용자명 혹은 이메일을 제공하여 주십시오",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "이메일을 받지 못한 경우 혹은 비밀번호 재설정에 문제가 있는 경우, 관리자에게 연락을 하십시오",
"An email with a link to reset your password has been sent " => "귀하의 비밀번호를 재설정할 이메일이 발송되었습니다",
"to the email" => "이메일로",
"to the registered email address for" => "다음에 대하여 등록된 이메일 주소로",
// "Rename wiki page" => "Rename wiki page",
// "Page renamed from %0 to %1. Semantic alias redirect created" => "Page renamed from %0 to %1. Semantic alias redirect created",
// "Are you sure you want to roll back \"%0\" to version #%1" => "Are you sure you want to roll back \"%0\" to version #%1",
"Non-existent version" => "버전 존재하지 않음",
"Tiki RSS Feed Error Message: %0" => "티키 RSS 피드 오류 메시지: %0",
"This match was not case sensitive" => "이 일치는 대소문자 구분을 하지 않았습니다",
"No items selected" => "선택된 항목 없음",
"Page cannot be found: " => "페이지가 발견되지 않았음:",
"Page has changed since preview: " => "페이지는 미리보기 후 변경되었습니다:",
"Page not updated due to error in replacing: " => "교체에 오류로 인하여 페이지 갱신되지 않음",
"Page updated: " => "페이지 갱신됨:",
"Search Stats" => "검색 통계",
"%0: Results for \"%1\"" => "%0: \"%1\"에 대한 결과",
// "Your query was stored" => "Your query was stored",
"Searchindex" => "검색색인",
"A problem occurred during file uploading" => "파일 업로딩 중 문제가 발생하였습니다",
// "File causing trouble was at rank" => "File causing trouble was at rank",
// "The error was %0" => "The error was %0",
"Error: You can't send the same newsletter by refreshing this frame content" => "오류: 동일한 회보를 이 프레임 내용물을 새로 고침함으로써 전송할 수 없습니다",
"No newsletters available" => "제공되는 회보 없음",
"Cannot login to server maybe the server is down" => "서버에 로그인 불가, 서버 다운 가능성있음",
"successfully sent" => "발송 성공",
"not sent" => "발송되지 않음",
"Error: " => "오류: ",
"Article:" => "기사:",
"Send Pages" => "페이지 전송",
"Notice: this variable may not be empty" => "주의: 이 변수는 비어있을 수 없습니다",
"Notice: invalid variable value" => "주의: 유효하지 않은 변수 값",
"Report to the webmaster" => "웹마스터에게 보고",
"Token called" => "토큰 호출됨",
"Error sending tweet" => "트윈 전송 중 오류",
"Your link was sent" => "귀하의 링크가 발송되었습니다",
"One of the email addresses that was input is invalid" => "입력한 이메일 주소 중 하나가 유효하지 않습니다",
"Your email is mandatory" => "귀하의 이메일 주소가 반드시 필요합니다",
"Error sending mail to" => "다음으로 메일 전송 중 오류",
"Share page" => "페이지 공유",
"No text given for tweet" => "트윗에 대한 주어진 텍스트 없음",
"You don't have permission to post in this forum" => "게시판에 게시할 권한 거부됨",
"Spreadsheet - " => "스프레드시트 -",
"Are you sure you want to delete this spreadsheet" => "이 스프레드시트를 삭제하시겠습니까",
// "URL provided is empty or unsupported" => "URL provided is empty or unsupported",
// "Unable to generate a short url for the requested resource" => "Unable to generate a short url for the requested resource",
// "'%0' short url" => "'%0' short url",
"You do not have permission to edit messages %0" => "메시지 %0 를 편집할 권한이 없습니다",
// "Sitemap file not available" => "Sitemap file not available",
// "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator" => "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator",
// "Exporting slideshow as PDF requires a working installation of mPDF" => "Exporting slideshow as PDF requires a working installation of mPDF",
// "Export to PDF error: %0" => "Export to PDF error: %0",
"Permission denied. You cannot view this page" => "권한 거부됨. 이 페이지를 볼 수 없습니다",
// "Email is mandatory" => "Email is mandatory",
"Username and email are mandatory" => "사용자명과 이메일은 필수항목입니다",
"The email address is invalid" => "이메일이 유효하지 않습니다",
"Clean the sql logs" => "SQL 로그 제거",
"Are you sure you want to clear all statistics and data for this survey" => "이 설문에 대한 통계와 데이터를 삭제하시겠습니까?",
// "The following list of changes has been reverted" => "The following list of changes has been reverted",
// "Log already reverted" => "Log already reverted",
// "Invalid System Log ID" => "Invalid System Log ID",
"You cannot take this quiz twice" => "이 퀴즈를 두 번 풀 수 없습니다",
"The quiz time limit was exceeded. The quiz score cannot be computed" => "퀴즈 시간 제한 초과됨 퀴즈가 연산될 수 없음",
"You cannot take this survey twice" => "이 설문을 두 번 할 수 없습니다",
"Please create a category first" => "범주를 먼저 만들어주십시오",
"Committing.." => "커밋 중...",
"Could not save" => "저장할 수 없었습니다",
"No trackerId specified" => "지정된 트래커ID 없음",
"Incorrect file gallery" => "틀린 파일 갤러리",
"You must lock the file before editing it" => "파일을 편집하기 전에 반드시 잠궈야 합니다",
"Error processing zipped image package" => "압축된 그림 패키지 처리 오류",
"No permission to upload zipped image packages" => "압축된 그림 패키지를 업로드할 권한 없음",
"The uploaded file is not recognized as a image" => "업로드된 파일은 그림으로써 인식되지 않았습니다",
"You do not have permission to upload images" => "그림을 업로드할 권한이 없습니다",
"You have permission to upload images but not to this gallery" => "그림을 업로드 할 권한은 보유하고 계십니다만 이 갤러리에는 권한이 없습니다",
"Cannot get image from URL" => "URL 에서 그림 가져오기 불가",
"That is not an image (or you have php < 4.0.5)" => "그것은 그림이 아닙니다 (혹은 PHP 버전이 4.0.5 전입니다)",
"Usage" => "사용",
// "Default user modules restored" => "Default user modules restored",
// "Default user modules not restored" => "Default user modules not restored",
// "User module assigned" => "User module assigned",
// "User module not assigned" => "User module not assigned",
// "User module display order moved up. Displayed order may not change if other modules now have the same order rank" => "User module display order moved up. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved up" => "User module display order not moved up",
// "User module display order moved down. Displayed order may not change if other modules now have the same order rank" => "User module display order moved down. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved down" => "User module display order not moved down",
// "User module moved to left column" => "User module moved to left column",
// "User module not moved to left column" => "User module not moved to left column",
// "User module moved to right column" => "User module moved to right column",
// "User module not moved to right column" => "User module not moved to right column",
"TOP" => "상위",
"No URL indicated" => "지정된 URL 없음",
"ERROR: Either the subject or body must be non-empty" => "오류: 제목 혹은 본문 중 하나는 비어있자 않아야만 함",
"Unknown user" => "알 수 없는 사용자",
// "Added new structure route" => "Added new structure route",
// "Deleted structure route" => "Deleted structure route",
// "Updated structure route" => "Updated structure route",
// "Notification preferences set" => "Notification preferences set",
// "Errors were encountered when setting notification preferences" => "Errors were encountered when setting notification preferences",
"Email is set to %s" => "이메일이 % 로 설정되었습니다",
"Password has been changed" => "비밀번호가 변경되었습니다",
"Invalid password. Your current password is required to change administrative information" => "유효하지 않은 비밀번호. 관리 정보를 변경하려면 귀하의 현재 비밀번호가 요구됩니다",
"The passwords did not match" => "비밀번호가 일치하지 않습니다",
"If you really want to delete your account, you must check the checkbox" => "귀하의 계정 삭제를 진심으로 원하는 경우, 체크상자를 반드시 체크해야만 합니다",
// "User report preferences saved" => "User report preferences saved",
// "User report preferences not saved" => "User report preferences not saved",
// "User reports disabled" => "User reports disabled",
// "User report not disabled" => "User report not disabled",
"was moved to the trash" => "은(는) 휴지통으로 이동됨",
"was moved to the trash by" => "휴지통으로 삭제하신 분",
"open / in process" => "열림 / 처리 중",
"Rights by creator" => "만든이의 권한",
"END" => "종료",
"Percentage" => "백분율",
"Task accepted by creator" => "만든이에 의해 승인된 작업",
"Task accepted by task user" => "작업 사용자에 의해 승인된 작업",
"Task NOT accepted by creator" => "만든이에 의하여 받아들여지지 않은 작업",
"Task NOT accepted by task user" => "작업 사용자에 의하여 받아들여지지 않은 작업",
"Sorry, this task does not exist or you don't have permission to view this task" => "죄송합니다. 이 작업은 존재하지 않거나 이 작업을 볼 권한이 없습니다",
"Task entries" => "작업 입력",
"Changes" => "변경내역",
"Info message" => "정보 메시지",
"NEW Task" => "새 작업",
"Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks" => "죄송하지만 귀하가 다른 사용자에게 작업을 보내는 것 혹은 그 사용자가 작업을 받는 것이 허용되어 있지 않습니다.",
"Changes on Task" => "작업 상 변경내역",
"You received a new task" => "새 작업을 받았습니다",
"The priority is" => "우선순위는",
"very low" => "매우 낮음",
"high" => "높음",
"very high" => "매우 높음",
"You must start your work at least on" => "작업을 착수해야만 되는 마지막 날짜",
"You must finish your work on" => "작업 완료 일정",
"Log in and click the link below" => "로그인 및 아래 링크 클릭",
"Please read the task and work on it" => "작업을 읽고 관련 업무를 진행하여 주십시오",
"Sorry, there was an error while trying to write data into the database" => "죄송합니다, 데이터를 데이터베이스로 작성 시도 중 오류가 있었습니다",
// "Unsubscribe from user watch email notifications" => "Unsubscribe from user watch email notifications",
// "Unsubscribed from user watch email notification" => "Unsubscribed from user watch email notification",
// "Unsubscribe failed" => "Unsubscribe failed",
// "Unknown watch type" => "Unknown watch type",
"Language watch" => "언어 주시",
"Category watch: %0, Language: %1" => "범주 주시: %0, 언어: %1",
// "User watch deleted" => "User watch deleted",
// "User watch not deleted" => "User watch not deleted",
"Cannot upload this file. The storage quota would be exceeded" => "이 파일 업로드 불가, 할당량 부족",
"No user indicated" => "사용자 지정되지 않음",
"Non-existent user" => "사용자 존재하지 않음",
"No banner indicated" => "배너 지정되지 않음",
"No blog indicated" => "블로그 지정되지 않음",
"Post not found" => "게시물 발견되지 않음",
"You do not have permission to view this blog post while it is marked as private" => "이 블로그는 사적용도로 분류되어 있기때문에 볼 권한이 없습니다",
"No cache information available" => "제공되는 캐시 정보 없음",
"You must suggest a question; please try again" => "질문을 반드시 제안해야 합니다; 다시 시도하십시오",
"No FAQ indicated" => "FAQ 지정되지 않음",
// "Are you sure you want to remove that attachment" => "Are you sure you want to remove that attachment",
// "Are you sure you want to remove that topic" => "Are you sure you want to remove that topic",
"You do not have permission to remove someone else's post!" => "타인의 포스트를  제거하기도록 허가되지 않았습니다!",
"Incorrect thread" => "틀린 대화목록",
// "Thread %0 does not exist" => "Thread %0 does not exist",
"No thread indicated" => "스레드 지정 없음",
"Files are read only at this time" => "파일은 지금 읽기 전용입니다",
"Are you sure you want to clone this spreadsheet" => "이 스프레드시트를 복제하시겠습니까?",
"Clone Error" => "복제 오류",
"Are you sure you want to roll back this spreadsheet" => "이 스프레드시트를 롤백하시겠습니까",
"Rollback Error" => "롤백 올휴",
"Tracker Added To Spreadsheet" => "트래커가 스프레드시트에 추가됨",
"Tracker Removed From Spreadsheet" => "스프레드시트에서 제거된 트래커",
"Spreadsheet added" => "스프레드시트 추가됨",
"Spreadsheet removed" => "스프레드시트 제거됨",
"File removed" => "파일 제거됨",
"Spreadsheet truncated" => "스프레드시트 잘림",
// "Create or view tracker" => "Create or view tracker",
"Admin this tracker" => "이 트래커 관리",
// "Are you sure you want to delete the selected items" => "Are you sure you want to delete the selected items",
"Create tracker item" => "트래커 항목 만들기",
// "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission" => "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission",
// "Are you sure you want to permanently delete this item" => "Are you sure you want to permanently delete this item",
"Are you sure you want to remove this attachment" => "이 첨부파일을 삭제하시겠습니까",
"Edit/Delete" => "편집/삭제",
"You don't have a personal tracker item yet. Click here to make one" => "개인 트래커 항목이 아직 없습니다. 여기를 클릭하여 하나 만드십시오",
"That tracker does not use extras" => "그 트래커는 추가를 사용하지 않습니다",
"Address book" => "주소록",
"Top pages" => "상위 페이지",
"Last pages" => "최근 페이지",
// "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace" => "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace",
);
