<?php
// (c) Copyright by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// The original strings (English) are case-sensitive.

/* Note for translators about translation of text ending with punctuation
 *
 * The current list of concerned punctuation can be found in 'lib/init/tra.php'
 * On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
 * For clarity, we explain here only for colons: ':' but it is the same for the rest
 *
 * Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
 *
 * Technical justification:
 * If a string ending with colon needs translating (like "{tr}Login:{/tr}")
 * then Tiki tries to translate 'Login' and ':' separately.
 * This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
 * and it still allows to translate ":" as " :" for languages that
 * need it (like French)
 * Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
 * This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.
 */
$lang = array(
"Welsh" => "Kiwelisi",
"Slovene" => "Kislovenia",
"Arabic" => "Kiarabu",
"Bulgarian" => "Kibulgaria",
"Catalan" => "Kikatalani",
"Simplified Chinese" => "Kichina kilichorahisishwa",
"Czech" => "Kicheki",
"Danish" => "Kidenmaki",
"German" => "Kijerumani",
"English" => "Kiingereza",
"English British" => "Kiingereza",
"Spanish" => "Kihispania",
"Greek" => "Kigiriki",
"Farsi" => "Kifarsi",
"Finnish" => "Kifini",
"Fijian" => "Fijian",
"French" => "Kifaransa",
"Frisian Netherlands" => "Uholanzi Kifaransa",
"Galician" => "Kigalisia",
"Hebrew" => "Kiebrania",
"Croatian" => "Kikroeshia",
"Indonesian" => "Kiindonesia",
"Icelandic" => "Kiaislandi",
"Italian" => "Kiitaliano",
"Inuktitut" => "Inuktitut",
// "Inuktitut (Roman)" => "Inuktitut (Roman)",
// "Iniunnaqtun" => "Iniunnaqtun",
"Japanese" => "Kijapani",
"Korean" => "Kikorea",
"Hungarian" => "Kihungari",
"Lithuanian" => "Kilithuania",
"Low German" => "Kijerumani cha chini",
"Dutch" => "Kiholanzi",
"Norwegian" => "Kinorwe",
"Polish" => "Kipolishi",
"Portuguese" => "Kireno",
"Brazilian Portuguese" => "Kireno cha Brazil",
"Romanian" => "Kiromania",
"Romansh" => "Waromah",
"Russian" => "Kirusi",
"Pijin Solomon" => "Pijin Sulemani",
"Sinhala" => "Sinhala",
"Slovak" => "Kislovakia",
"Albanian" => "Kialbania",
"Serbian Latin" => "Kilatini Kilatini",
"Swedish" => "Kiswidi",
"Swahili" => "Swahili",
// "Thai" => "Thai",
"Tuvaluan" => "Tuvaluan",
"Turkish" => "Kituruki",
"Traditional Chinese" => "Kichina cha jadi",
"Ukrainian" => "Kiukreni",
// "Urdu" => "Urdu",
"Vietnamese" => "Kivietinamu",
"Afghanistan" => "Afghanistan",
"Aland Islands" => "Visiwa vya Aland",
"Aland_Islands" => "Aland",
"Albania" => "Albania",
"Algeria" => "Algeria",
"American Samoa" => "Samoa ya Marekani",
"American_Samoa" => "Samoa_ya_Marekani",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Armenia" => "Armenia",
"Aruba" => "Aruba",
"Australia" => "Australia",
"Austria" => "Austria",
"Azerbaijan" => "Azerbaijan",
"Bahamas" => "Bahamas",
"Bahrain" => "Bahrain",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbados",
"Belarus" => "Belarus",
"Belgium" => "Ubelgiji",
"Belize" => "Belize",
"Benin" => "Benin",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Bolivia" => "Bolivia",
"Bosnia and Herzegovina" => "Bosnia na Herzegovina",
"Bosnia_and_Herzegovina" => "Bosnia_na_Herzegovina",
"Botswana" => "Botswana",
"Bouvet Island" => "Kisiwa cha Bouvet",
"Bouvet_Island" => "Kisiwa_cha_Bouvet",
"Brazil" => "Brazil",
"British Indian Ocean Territory" => "Sehemu ya Bahari ya Hindi ya Bahari ya Hindi",
"British Virgin Islands" => "Visiwa vya Virgin vya Uingereza",
"British_Indian_Ocean_Territory" => "Sehemu_ya_Bahari_ya_Hindi_ya_Bahari_ya_Hindi",
"British_Virgin_Islands" => "Visiwa_vya_Virgin_vya_Uingereza",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgaria",
"Burkina Faso" => "Burkina Faso",
"Burkina_Faso" => "Burkina_Faso",
"Burundi" => "Burundi",
"Cambodia" => "Cambodia",
"Cameroon" => "Cameroon",
"Canada" => "Canada",
"Cape Verde" => "Cape-Verde",
"Cape_Verde" => "Cape-Verde",
"Catalan Countries" => "Nchi za Kikatalani",
"Catalan_Countries" => "Nchi_za_Kikatalani",
"Cayman Islands" => "Visiwa vya Cayman",
"Cayman_Islands" => "Visiwa_vya_Cayman",
"Central African Republic" => "Jamhuri ya Afrika ya Kati",
"Central_African_Republic" => "Jamhuri_ya_Afrika_ya_Kati",
"Chad" => "Chadi",
"Chile" => "Chile",
"China" => "China",
"Christmas Island" => "Kisiwa cha Krismasi",
"Christmas_Island" => "Kisiwa_cha_Krismasi",
"Cocos Islands" => "Visiwa vya ÎleCocos",
"Cocos_Islands" => "Visiwa_vya_ÎleCocos",
"Colombia" => "Kolombia",
"Comoros" => "Comores",
"Democratic Republic of the Congo" => "Jamhuri_ya_Kidemokrasia_ya_Kongo",
// "Democratic_Republic_of_the_Congo" => "Democratic_Republic_of_the_Congo",
"Congo" => "Congo",
"Cook Islands" => "Visiwa vya Cook",
"Cook_Islands" => "Visiwa_vya_Cook",
"Costa Rica" => "Costa Rica",
"Costa_Rica" => "Costa_Rica",
"Croatia" => "Kroatia",
"Cuba" => "Cuba",
"Cyprus" => "Kupro",
"Czech Republic" => "Jamhuri ya Czech",
"Czech_Republic" => "Jamhuri_ya_Czech",
"Denmark" => "Danemark",
"Djibouti" => "Djibouti",
"Dominica" => "Dominica",
"Dominican Republic" => "Jamhuri_ya_Dominika",
"Dominican_Republic" => "Jamhuri_ya_Dominika",
"Ecuador" => "Ecuador",
"Egypt" => "Misri",
"El Salvador" => "El Salvador",
"El_Salvador" => "El_Salvador",
// "England" => "England",
"Equatorial Guinea" => "Guinea ya Equatoria",
"Equatorial_Guinea" => "Guinea_ya_Equatoria",
"Eritrea" => "Eritrea",
"Estonia" => "Estonia",
"Ethiopia" => "Ethiopia",
"Europe" => "Ulaya",
"Falkland Islands" => "Visiwa vya Falkland",
"Falkland_Islands" => "Visiwa_vya_Falkland",
"Faroe Islands" => "Visiwa_vya_Faroe",
"Faroe_Islands" => "Visiwa_vya_Faroe",
"Federated States of Micronesia" => "Nchi za Fedha za Micronesia",
"Federated_States_of_Micronesia" => "Nchi_za_Fedha_za_Micronesia",
"Fiji" => "Fiji",
"Finland" => "Finland",
"France" => "Ufaransa",
"French Guiana" => "Guyana ya Kifaransa",
"French Polynesia" => "Polynesia ya Kifaransa",
"French Southern Territories" => "Majimbo ya Kusini mwa Kifaransa",
"French_Guiana" => "Guyana_ya_Kifaransa",
"French_Polynesia" => "Polynesia_ya_Kifaransa",
"French_Southern_Territories" => "Majimbo_ya_Kusini_mwa_Kifaransa",
"Gabon" => "Gabon",
"Gambia" => "Gambia",
"Georgia" => "Georgia",
"Germany" => "Ujerumani",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Greece" => "Ugiriki",
"Greenland" => "Greenland",
"Grenada" => "Grenada",
"Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea Bissau" => "Guinea-Bissau",
"Guinea" => "Guinea",
"Guinea_Bissau" => "Guinea_Bissau",
"Guyana" => "Guyan",
"Haiti" => "Haiti",
"Heard Island and McDonald Islands" => "Kisiwa cha Heard na Visiwa vya McDonald",
"Heard_Island_and_McDonald_Islands" => "Kisiwa_cha_Heard_na_Visiwa_vya_McDonald",
"Honduras" => "Honduras",
"Hong Kong" => "Hong Kong",
"Hong_Kong" => "Hong_Kong",
"Hungary" => "Hungary",
"Iceland" => "Iceland",
"India" => "Uhindi",
"Indonesia" => "Indonesia",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Ireland" => "Ireland",
"Isle of Man" => "Isle of Man",
"Israel" => "Israeli",
"Italy" => "Italia",
"Ivory Coast" => "Pwani ya Pwani",
"Ivory_Coast" => "Pwani_ya_Pwani",
"Jamaica" => "Jamaika",
"Japan" => "Japani",
"Jersey" => "Jersey",
"Jordan" => "Yordani",
"Kazakstan" => "Kazakhstan",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Kyrgyzstan" => "Kyrgyzstan",
"Laos" => "Laos",
"Latvia" => "Lettonie",
"Lebanon" => "Liban",
"Lesotho" => "Lesotho",
"Liberia" => "Liberia",
"Libya" => "Libya",
"Liechtenstein" => "Liechtenstein",
"Lithuania" => "Lithuania",
"Luxemburg" => "Luxemburg",
"Macao" => "Macao",
"Macedonia" => "Makedonia",
"Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Maldives" => "Maldives",
"Mali" => "Mali",
"Malta" => "Malta",
"Marshall Islands" => "Visiwa vya Marshall",
"Marshall_Islands" => "Visiwa_vya_Marshall",
"Martinique" => "Martinique",
"Mauritania" => "Mauritania",
"Mauritius" => "Mauritius",
"Mayotte" => "Mayotte",
"Mexico" => "Mexico",
"Moldova" => "Moldova",
"Monaco" => "Monaco",
"Mongolia" => "Mongolia",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Morocco" => "Morocco",
"Mozambique" => "Msumbiji",
"Myanmar" => "Myanmar",
"Namibia" => "Namibia",
"Nauru" => "Nauru",
"Nepal" => "Nepali",
"Netherlands Antilles" => "Antilles ya Uholanzi",
"Netherlands" => "Uholanzi",
"Netherlands_Antilles" => "Antilles_ya_Uholanzi",
"New Caledonia" => "Kaledonia_Mpya",
"New Zealand" => "New_Zealand",
"New_Caledonia" => "Kaledonia_Mpya",
"New_Zealand" => "New-Zealand",
"Nicaragua" => "Nikaragua",
"Niger" => "Niger",
"Nigeria" => "Nigeria",
"Niue" => "Niue",
"None" => "Hakuna",
"Norfolk Island" => "Kisiwa cha Norfolk",
"Norfolk_Island" => "Kisiwa_cha_Norfolk",
"North Korea" => "Korea Kaskazini",
"North_Korea" => "Korea_Kaskazini",
"Northern Mariana Islands" => "Visiwa vya Mariana ya Kaskazini",
"Northern_Mariana_Islands" => "Visiwa_vya_Mariana_ya_Kaskazini",
"Norway" => "NorwayNorway",
"Oman" => "Oman",
"Other" => "Nyingine",
"Pakistan" => "Pakistan",
"Palau" => "Palaos",
"Palestine" => "Palestina",
"Panama" => "Panama",
"Papua New Guinea" => "Papua-Mpya-Guinea",
"Papua_New_Guinea" => "Papua-Mpya-Guinea",
"Paraguay" => "Paraguay",
"Peru" => "Peru",
"Philippines" => "Philippines",
"Pitcairn" => "Pitcairn",
"Poland" => "Poland",
"Portugal" => "Ureno",
"Puerto Rico" => "Puerto Rico",
"Puerto_Rico" => "Puerto_Rico",
"Quatar" => "Qatar",
"Republic of Macedonia" => "Jamhuri ya Makedonia",
"Republic_of_Macedonia" => "Jamhuri_ya_Makedonia",
"Reunion" => "Reunion",
"Romania" => "Romania",
"Russia" => "Urusi",
"Russian Federation" => "Shirikisho la Urusi",
"Russian_Federation" => "Shirikisho_la_Urusi",
"Rwanda" => "Rwanda",
"Saint Helena" => "Saint-Helena",
"Saint Kitts and Nevis" => "Mtakatifu-Kitts-na-Nevis",
"Saint Lucia" => "Saint-Lucia",
"Saint Pierre and Miquelon" => "St. Peter na Miquelon",
"Saint_Helena" => "St. Helena",
"Saint_Kitts_and_Nevis" => "Saint-Kitts-na-Nevis",
"Saint_Lucia" => "St. Lucia",
"Saint_Pierre_and_Miquelon" => "Saint-Pierre-na-Miquelon",
"Samoa" => "Samoa",
"San Marino" => "San-Marino",
"San_Marino" => "San-Marino",
"Sao Tome and Principe" => "Sao Tome na Principe",
"Sao_Tome_and_Principe" => "Sao_Tome_na_Principe",
"Saudi Arabia" => "Arabia ya Saudi",
"Saudi_Arabia" => "Arabia_ya_Saudi",
"Senegal" => "senegal",
"Serbia" => "Serbia",
"Seychelles" => "Shelisheli",
"Sierra Leone" => "Sierra Leone",
"Sierra_Leone" => "Sierra_Leone",
"Singapore" => "Singapore",
"Slovakia" => "Slovakia",
"Slovenia" => "Slovenia",
"Solomon Islands" => "Visiwa vya Sulemani",
"Solomon_Islands" => "Visiwa_vya_Sulemani",
"Somalia" => "Somalia",
"South Africa" => "Afrika Kusini",
"South Georgia and South Sandwich Islands" => "Georgia ya Kusini na Visiwa vya Sandwich vya Kusini",
"South Korea" => "Korea ya Kusini",
"South_Africa" => "Afrika_Kusini",
"South_Georgia_and_South_Sandwich_Islands" => "Georgia_ya_Kusini_na_Visiwa_vya_Sandwich_vya_Kusini",
"South_Korea" => "Korea_ya_Kusini",
"Spain" => "Hispania",
"Sri Lanka" => "Sri Lanka",
"Sri_Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "Visiwa vya Grenadines za St Vincent",
"St_Vincent_Grenadines" => "Visiwa_vya_Grenadines_za_St_Vincent",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Svalbard and Jan Mayen" => "Svalbard et Jan Mayen",
"Svalbard_and_Jan_Mayen" => "Svalbard_et_Jan_Mayen",
"Swaziland" => "Swaziland",
"Sweden" => "Uswidi",
"Switzerland" => "Uswisi",
"Syria" => "Syria",
"Taiwan" => "Taiwan",
"Tajikistan" => "Tajikistan",
"Tanzania" => "Tanzania",
"Thailand" => "Thailand",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Trinidad Tobago" => "Trinidad-Tobago",
"Trinidad_Tobago" => "Trinidad_Tobago",
"Tunisia" => "Tunisia",
"Turkey" => "Uturuki",
"Turkmenistan" => "Turkmenistan",
"Turks and Caicos Islands" => "Turuki na Visiwa vya Caicos",
"Turks_and_Caicos_Islands" => "Turuki_na_Visiwa_vya_Caicos",
"Tuvalu" => "Tuvalu",
"US Virgin Islands" => "Visiwa vya Virgin vya Marekani",
"US_Virgin_Islands" => "Visiwa_vya_Virgin_vya_Marekani",
"Uganda" => "Uganda",
"Ukraine" => "Ukraine",
"United Arab Emirates" => "Falme za Kiarabu",
"United Kingdom" => "Uingereza",
"United Nations Organization" => "Shirika la Umoja wa Mataifa",
"United States Minor Outlying Islands" => "Muungano wa Kidogo Wilaya za Kati",
"United States" => "Marekani",
"United_Arab_Emirates" => "Falme_za_Kiarabu",
"United_Kingdom" => "Uingereza",
"United_Kingdom_-_England_and_Wales" => "Uingereza_na_England_Na_Nchi_di_zoga",
"United_Kingdom_-_Northern_Ireland" => "Uingereza_Northern_Ireland",
"United_Kingdom_-_Scotland" => "Uingereza-Scotland",
"United_Nations_Organization" => "Shirika_la_Umoja_wa_Mataifa",
"United_States" => "Marekani",
"United_States_Minor_Outlying_Islands" => "Muungano_wa_Kidogo_Wilaya_za_Kati",
"Uruguay" => "Uruguay",
"Uzbekistan" => "Uzbekistan",
"Vanuatu" => "Vanuatu",
"Vatican" => "Vatican",
"Venezuela" => "Venezuela",
"Viet Nam" => "Viet Nam",
"Viet_Nam" => "Viet_Nam",
"Wales" => "Wales",
"Wallis and Futuna" => "Wallis na Futuna",
"Wallis_and_Futuna" => "Wallis-na-Futuna",
"Western Sahara" => "Sahara ya Magharibi",
"Western_Sahara" => "Sahara_ya_Magharibi",
"World" => "Dunia",
"Yemen" => "Yemen",
"Yugoslavia" => "Yugoslavia",
"Zambia" => "Zambia",
"Zimbabwe" => "Zimbabwe",
"the former Yugoslav Republic of Macedonia" => "Jamhuri ya zamani ya Yugoslavia ya Makedonia",
"the_former_Yugoslav_Republic_of_Macedonia" => "Jamhuri_ya_zamani_ya_Yugoslavia_ya_Makedonia",
// "File %0 succesfully imported" => "File %0 succesfully imported",
// "category defaults" => "category defaults",
"You must specify a directory" => "Lazima ueleze saraka",
// "ViewerJS URI not set" => "ViewerJS URI not set",
// "ViewerJS URI not found (local file not readable)" => "ViewerJS URI not found (local file not readable)",
// "ViewerJS URI not found (%0)" => "ViewerJS URI not found (%0)",
// "Tags successfully cleaned up" => "Tags successfully cleaned up",
// "Tag cleanup failed" => "Tag cleanup failed",
// "Remove orphan images" => "Remove orphan images",
// "Orphan images successfully removed" => "Orphan images successfully removed",
"moved %d images, %d errors occurred." => "picha %d zilizohamishwa, makosa %d yaliyopatikana.",
"a timeout occurred. Hit the reload button to move the rest" => "Saa imetokea. Hitisha kifungo cha upakiaji ili kuhamisha wengine",
"Tiki Email Test" => "Mjarabu la barua pepe ya Tiki",
"Tiki Test email from" => "Mjarabu la barua pepe ya Tiki kutoka",
"Unable to send mail" => "Haiwezi kutuma barua",
"Test mail sent to" => "Barua ya mtihani imetumwa na",
// "Remove this server" => "Remove this server",
// "Remove this host" => "Remove this host",
// "registration choices" => "registration choices",
// "Assign users to groups based on email patterns" => "Assign users to groups based on email patterns",
// "This method of captcha is not supported by your server, please select another or upgrade" => "This method of captcha is not supported by your server, please select another or upgrade",
// "You need to select a file to upload" => "You need to select a file to upload",
// "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists" => "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists",
// "Unable to Write Password File to Disk" => "Unable to Write Password File to Disk",
// "Delete temporary index" => "Delete temporary index",
// "%d users were assigned to groups based on user emails matching the patterns defined for the groups" => "%d users were assigned to groups based on user emails matching the patterns defined for the groups",
// "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups" => "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups",
// "composer.lock file was removed" => "composer.lock file was removed",
// "composer.lock file is not writable, so it can not be removed" => "composer.lock file is not writable, so it can not be removed",
// "composer.lock file do not exists" => "composer.lock file do not exists",
// "Vendor folder contents was removed" => "Vendor folder contents was removed",
// "Vendor folder is not writable" => "Vendor folder is not writable",
// "Vendor folder do not exists" => "Vendor folder do not exists",
"Used" => "Imetumiwa",
"Available" => "Inapatikana",
"Hit" => "Pigo",
"Miss" => "Imekosa",
"An error occurred: " => "Hitilafu imetokea: ",
// "profile applied" => "profile applied",
"The following list of changes has been applied" => "Orodha zifuatazo za mabadiliko imetumika",
// "Profile forgotten" => "Profile forgotten",
// "New rating configuration %0 created" => "New rating configuration %0 created",
// "Rating configuration updated for %0" => "Rating configuration updated for %0",
// "Scoring events replaced with form data" => "Scoring events replaced with form data",
"Unable to get info from log file" => "Haiwezi kupata maelezo ya faili ya logi",
"You must set a home file gallery" => "Lazima uweka nyumba ya sanaa ya faili",
"Tag already exists" => "Lebo tayari iko",
// "Tag %0 created" => "Tag %0 created",
// "Tag %0 not found" => "Tag %0 not found",
// "Tag %0 restored" => "Tag %0 restored",
// "Tag %0 not restored" => "Tag %0 not restored",
// "Tag %0 removed" => "Tag %0 removed",
// "Tag %0 not removed" => "Tag %0 not removed",
// "Process to remove pictures has completed" => "Process to remove pictures has completed",
// "Dump created at %0" => "Dump created at %0",
// "Dump was not created. Please check permissions for the storage/ directory" => "Dump was not created. Please check permissions for the storage/ directory",
// "Dump file %0 removed" => "Dump file %0 removed",
// "Dump file %0 was not removed" => "Dump file %0 was not removed",
// "No update was made" => "No update was made",
// "Areas were updated" => "Areas were updated",
"Are you sure you want to remove that post?" => "Una uhakika unataka kuondoa chapisho hilo?",
"Re" => "Re",
"This forum is flat and doesn't allow replies to other replies" => "Jumuiya hii ni gorofa na hairuhusu jibu kwa majibu mengine.",
"Copyright management" => "Usimamizi wa hati miliki",
"No page indicated" => "Hakuna ukurasa unaonyeshwa",
"You must supply all the information, including title and year." => "Lazima utoe maelezo yote, ikiwa ni pamoja na kichwa na mwaka.",
// "Sorry, that mail has been taken by another operator" => "Sorry, that mail has been taken by another operator",
"Wiki Page" => "Ukurasa wa Wiki",
// "Tracker item not found" => "Tracker item not found",
// "Put this item back" => "Put this item back",
// "Taken by %0" => "Taken by %0",
// "Take this email" => "Take this email",
// "TAKE" => "TAKE",
"View contact" => "Angalia kuwasiliana",
"ID" => "ID",
"Type" => "Aina",
"Name" => "Jina",
"Description" => "Maelezo",
"Size" => "Kipimo",
"Created" => "Imeundwa",
"Uploaded" => "Imetumwa",
"Last modified" => "Ilibadilishwa mwisho",
"Uploaded by" => "Imetumwa na",
"Creator" => "Muumba",
"Last modified by" => "Ilibadilishwa mwisho na",
"Comment" => "Maoni",
"Files" => "Mafaili",
"Hits" => "Mapigo",
"Last download" => "Mwisho kupakuliwa",
"Locked by" => "Imefungwa na",
"Backlinks" => "Kurasa zinazoonyesha ukurasa huu",
// "Delete after" => "Delete after",
"Share" => "Kushiriki",
"Source" => "Chanzo",
"Explorer" => "Mchunguzi",
"Path" => "Njia",
"Slideshow" => "Slideshow",
// "Gallery icon" => "Gallery icon",
"Register" => "Kujiandikisha",
"Group" => "Kundi",
"Tiki Installer" => "Mfungaji Tiki",
"MySQL Improved (mysqli)" => "MySQL imeboreshwa (mysqli)",
"MySQL classic (mysql)" => "MySQL classic (mysql)",
// "Invalid database user" => "Invalid database user",
"No database name specified" => "Hakuna jina la database linalotajwa",
// "Automatic" => "Automatic",
// "Make a symlink" => "Make a symlink",
// "Make a copy" => "Make a copy",
// "Do nothing" => "Do nothing",
// "symlink created" => "symlink created",
// "copy created" => "copy created",
"Email address not valid, test mail not sent" => "Anwani ya barua pepe isiyo sahihi, barua pepe ya mtihani haikutumwa",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Hakuna anwani ya barua pepe na \"sanduku\" la nakala hazifuatikani, barua pepe ya mtihani haikutumwa",
// "Test mail from Tiki installer %0" => "Test mail from Tiki installer %0",
"Tiki version:" => "Toleo la Tiki:",
"PHP version:" => "Toleo PHP:",
"Server:" => "Seva:",
"Sent:" => "Imepelekwa:",
// "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -",
"Database `%0` was created" => "Database `%0` iliundwa",
"Database `%0` creation failed. You need to create the database" => "Uumbaji wa database `%0` imeshindwa. Lazima uunda database mwenyewe",
// "Database `%0`. Unable to connect to database" => "Database `%0`. Unable to connect to database",
"User `%0` was created" => "Mtumiaji `%0` iliundwa",
// "User `%0` creation failed" => "User `%0` creation failed",
"Congratulations!\n\nYour server can send emails.\n\n" => "Hongera!\n\nSeva yako inaweza kutuma barua pepe.\n\n",
// "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Failed to convert document into image" => "Failed to convert document into image",
// "Please check Tiki Action Log for more information" => "Please check Tiki Action Log for more information",
"No automated tax" => "Hakuna kodi ya automatiska",
"Account name must not be empty" => "Jina la akaunti haipaswi kuwa tupu",
"Budget is not a valid amount: " => "Kiwango cha Bajeti ni batili",
"Locked must be either 0 or 1" => "Imefungwa lazima iwe 0 au 1",
"Error creating account" => "Hitilafu ya kuunda akaunti",
"AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "Number ya akaunti %0 iko tayari kutumika na haiwezi kubadilishwa. Asante kuizima ikiwa haifai tena",
"Error updating account" => "Hitilafu wakati wa kusasisha akaunti",
"Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Akaunti iko tayari kutumika na haipaswi kufutwa. Asante kuizima ikiwa haifai tena",
"Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Kuondolewa kwa manunuzi imeshindwa, database haifai: Usafishaji unahitajika kwa number ya logi %0 katika kitabu %1",
"successfully rolled back #" => "kufuta manunuzi mafanikio #",
"Booking error creating journal entry" => "Hitilafu ya usajili wakati wa kuingia kwa gazeti",
"Booking error creating debit entry" => "Hitilafu ya usajili wakati wa kuingia kwa debit",
"Booking error creating credit entry" => "Hitilafu ya usajili wakati wa kuingia kwa mkopo",
"The number of debit entries differs: " => "Idadi ya kuingia kwa debit hutofautiana: ",
"The number of credit entries differs: " => "Idadi ya entries za mkopo hutofautiana: ",
"Splitting is only allowed on one side" => "Kupunja kunaruhusiwa tu upande mmoja",
"Invalid debit amount " => "Kiwango cha batili cha debit ",
"Invalid debit account number " => "Nambari ya akaunti ya benki isiyo sahihi ",
"Invalid credit amount " => "Kiasi cha mikopo ya batili ",
"Invalid credit account number " => "Nambari ya akaunti ya mikopo isiyo sahihi",
"Difference between debit and credit amounts " => "Tofauti kati ya kiasi cha debit na mikopo",
"Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Kuondolewa kwa manunuzi imeshindwa, orodha haijapatikani: Usafishaji unahitajika kwa Hitilafu ID %0 katika kitabu %1",
"Booking error creating stack entry" => "Hitilafu ya uhifadhi wakati wa kuingiza uingizaji wa stack",
"Booking error creating stack debit entry" => "Hitilafu ya uhifadhi wakati wa kuunda uingizaji wa debit",
"Booking error creating stack credit entry" => "Hitilafu ya kusajili wakati wa kuingia kwa kuingia kwa mkopo",
"Error deleting entry from stack" => "Hitilafu wakati wa kufuta kuingia kwenye stack",
"Booking error confirming stack entry" => "Hitilafu ya uhifadhi wakati wa kuthibitisha kuingizwa kwa stack",
"Error while updating statement" => "Hitilafu wakati wa kuboresha taarifa",
"is not a number" => "si nambari",
// "must be greater than 0" => "must be greater than 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
"Error checking" => "Hitilafu ya kuangalia",
"does not exist" => "haipo",
"already exists" => "tayari ipo",
"This book has been closed. You can't create new accounts" => "Kitabu hiki kimefungwa. Huwezi kuunda akaunti mpya",
"This book has been closed. You can't modify the account" => "Kitabu hiki kimefungwa. Huwezi kurekebisha akaunti",
"This book has been closed. You can't delete the account" => "Kitabu hiki kimefungwa. Huwezi kufuta akaunti",
"The date of the transaction is before the start date of this book" => "Tarehe ya manunuzi ni kabla ya tarehe ya kuanza ya kitabu hiki",
"The date of the transaction is after the end date of this book" => "Tarehe ya manunuzi ni baada ya tarehe ya mwisho ya kitabu hiki",
"This book has been closed. Bookings can no longer be made in it" => "Kitabu hiki kimefungwa. Vitabu haviwezi kufanywa ndani yake",
"Invalid booking date" => "Tarehe ya usajili isiyo sahihi",
"This book has been closed. Transactions can no longer be cancelled in it" => "Kitabu hiki kimefungwa. Shughuli haiwezi kufutwa tena ndani yake",
// "APC system, user and opcode caches cleared" => "APC system, user and opcode caches cleared",
// "APC %0 cache cleared" => "APC %0 cache cleared",
// "APC %0 cache not cleared" => "APC %0 cache not cleared",
"New article post" => "Nakala mpya iliyochapishwa",
"Edited article post" => "Badilisha chapisho la makala",
"Deleted article post" => "Kuchapishwa kwa makala ya kufutwa",
"The file has incorrect syntax or is not a CSV file" => "Faili ina syntax isiyo sahihi au si faili ya CSV",
"Error line: %d" => "Hitilafu kwenye mstari: %d",
// "Import failed due to data format. Make sure the file has Unix-style line breaks" => "Import failed due to data format. Make sure the file has Unix-style line breaks",
"Spam is not welcome here" => "Spam haipatikani hapa",
"anonymous" => "bila majina",
"Blog cannot be found" => "Blog haipatikani",
"Locked by %0" => "Imefungwa na %0",
"refresh" => "pata upya",
"go back to this crumb" => "Rudi nyuma kwenye hii",
"Administration" => "Utawala",
// "Cache file %0 is not writable" => "Cache file %0 is not writable",
"All day" => "Siku nzima",
"First day of week: Sunday (its ID is 0) - Translators, you need to localize this string!" => "Siku ya kwanza ya juma: Jumapili (ID yake ni 0) ",
"Sunday" => "Jumapili",
"Su" => "Ju",
"Monday" => "Jumatatu",
"Tuesday" => "Jumanne",
"Wednesday" => "Jumatano",
"Thursday" => "Alhamisi",
"Friday" => "Ijumaa",
"Saturday" => "Jumamosi",
"Mo" => "Jut",
"Tu" => "Jum",
"We" => "Juo",
"Th" => "Alh",
"Fr" => "Iju",
"Sa" => "Jus",
"in" => "katika",
"continued" => "iliendelea",
"New Image Uploaded by" => "Image Mpya Imepakiwa na",
"New Subscriptions" => "Usajili mpya",
"New Item in Tracker" => "Ncha mpya katika Tracker",
"tracker" => "tracker",
"by" => "na",
"Wiki" => "Wiki",
"Image Gallery" => "Nyumba ya sanaa",
"Articles" => "Makala",
"Blogs" => "Blogs",
"Forums" => "Vikao",
"Directory" => "Directory",
"File Gallery" => "Faili ya Nyumba ya sanaa",
"FAQs" => "FAQs",
"Quizzes" => "QCMs",
"Trackers" => "Trackers",
"Survey" => "Utafiti",
"Newsletter" => "Jarida",
"Please type this word backwards" => "Tafadhali weka neno hili nyuma",
"Empty CAPTCHA value" => "Weka thamani ya CAPTCHA",
"You have mistyped the anti-bot verification code. Please try again" => "Umekosea code ya kuthibitisha ya bot. Tafadhali jaribu tena",
"Failed to validate CAPTCHA" => "Imeshindwa kuthibitisha CAPTCHA",
"CAPTCHA ID field is missing" => "Nambari ya ID ya CAPTCHA haipo",
"Get a visual challenge" => "Pata changamoto ya kuona",
"Get an audio challenge" => "Pata changamoto ya sauti",
"Get a new challenge" => "Pata changamoto mpya",
"Type the two words" => "Andika maneno mawili",
"Type what you hear" => "Weka kile unachosikia",
"Help" => "Msaada",
"Play sound again" => "Jaribu tena sauti",
"Download audio as an MP3 file" => "Pakua sauti katika MP3",
"Incorrect. Try again" => "Si sahihi. Jaribu tena",
// "Invalid category identifier: \"%0\"" => "Invalid category identifier: \"%0\"",
"Top" => "Juu",
"A category named %0 already exists in %1" => "Jamii inayoitwa %0 tayari ipo katika %1",
"article" => "makala",
"blog" => "blogu",
"directory" => "saraka",
"faq" => "FAQ",
"FAQ" => "FAQ",
"file gallery" => "faili ya sanaa",
"forum" => "vikao",
"image gallery" => "picha ya sanaa",
"newsletter" => "jarida",
"poll" => "uchaguzi",
"quiz" => "jaribio",
"survey" => "utafiti",
"wiki page" => "ukurasa wa wiki",
"image" => "picha",
"calendar" => "kalenda",
"template" => "template",
"Permission denied" => "Ruhusa imekataliwa",
"Invalid filename (using filters for filenames)" => "Jina la faili batili (kutumia filters kwa majina ya faili)",
"Cannot upload this file - maximum upload size exceeded" => "Haiwezi kupakia faili hii - ukubwa wa kupakia kupakia ulizidi",
"Cannot write to this file" => "Haiwezi kuandika kwenye faili hii",
"(not registered)" => "(haijasajiliwa)",
"Anonymous" => "Haijulikani",
"Your comment was rejected" => "Maoni yako yalikataliwa",
"Cannot perform spam check: %0" => "Haiwezi kufanya ukaguzi wa spam: %0",
"Please wait %0 seconds between posts" => "Tafadhali subiri sekunde% 0 kati ya machapisho",
"Wrong password. Cannot post comment" => "Nywila isiyo sahihi. Haiwezi kuchapisha maoni",
"A contribution is mandatory" => "Mchango ni lazima",
"Please enter a Title and Message for your new forum topic" => "Tafadhali ingiza Title na Ujumbe kwa mada yako mpya ya mada",
"Please enter a Title and Message for your forum reply" => "Tafadhali ingiza Title na Ujumbe kwa jibu lako la kujibu",
"Please enter a Message for your forum reply" => "Tafadhali ingiza Ujumbe wa jibu lako la kujibu",
"Invalid Email" => "Barua batili",
"Your message has been queued for approval and will be posted after a moderator approves it." => "Ujumbe wako umefungwa kwa idhini na utawekwa baada ya msimamizi aidhibitishe.",
"Use this thread to discuss the %s page" => "Tumia thread hii kujadili ukurasa wa% s",
"This forum is locked" => "Jumuiya hii imefungwa",
"This thread is locked" => "Faili hii imefungwa",
"An error occurred; please contact the administrator" => "Hitilafu ilitokea; tafadhali wasiliana na msimamizi",
"Route was updated" => "Njia imesasishwa",
"Route was created" => "Njia iliundwa",
"Page cannot be found" => "Ukurasa hauwezi kupatikana",
"From is required" => "Kutoka inahitajika",
"There is a route with the same From path already defined" => "Kuna njia iliyo sawa Kutoka njia tayari imefafanuliwa",
"Type is required" => "Aina inahitajika",
"Selected type is not supported" => "Aina iliyochaguliwa haijaungwa mkono",
"To" => "Kwa",
"Article" => "Makala",
"Blog" => "Blogu",
"Forum" => "Vikao",
"Object" => "Kitu",
"Tracker" => "Tracker",
"Field" => "Shamba",
"Tracker Item Id" => "Kitu cha Tracker Id",
"%s is required" => "%s inahitajika",
"Error" => "Hitilafu",
"Note" => "Kumbuka",
"Success" => "Mafanikio",
"Warning" => "Onyo",
"Feedback class called with no feedback provided" => "Darasa la maoni linaloitwa bila maoni yaliyotolewa",
// "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator" => "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator",
// "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Invalid request" => "Invalid request",
// "Failed to convert document %0 to pdf" => "Failed to convert document %0 to pdf",
// "Please check Action Log for more information" => "Please check Action Log for more information",
// "Please contact the administrator" => "Please contact the administrator",
"H5P requires the CURL extension to be installed in PHP" => "H5P inahitaji ugani wa CURL uwe imewekwa PHP",
// "Failed to write to temp file %0" => "Failed to write to temp file %0",
// " (code=%0)" => " (code=%0)",
"Exporting H5P content %0 failed" => "Kuleta maudhui ya H5P% 0 imeshindwa",
// "Saving H5P content %0 (fileId %1) failed" => "Saving H5P content %0 (fileId %1) failed",
// "H5P directory is not writable: %0" => "H5P directory is not writable: %0",
"Too many arguments on ceil" => "Majadiliano mengi sana juu ceil",
"Too many arguments on date" => "Vitu vingi sana juu ya tarehe",
// "Divide by zero on \"%0\"" => "Divide by zero on \"%0\"",
"Too many arguments on floor" => "Vitu vingi sana kwenye sakafu",
"Unexpected values: %0" => "Maadili yasiyotarajiwa: %0",
"Field must be provided and contain one argument: list" => "Shamba lazima itoewe na iwe na hoja moja: orodha",
"Field must be provided and contain a function" => "Shamba lazima itoewe na iwe na kazi",
"Too many arguments on less than" => "Masuala mengi sana chini ya",
"Too many arguments on more than" => "Majadiliano mengi sana zaidi ya",
// "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]" => "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]",
"Too many arguments for pad" => "Vitu vingi vingi vya pedi",
"Too few arguments for pad" => "Vitu vichache vidogo vya pedi",
"Too many arguments on round" => "Majadiliano mengi sana kwa pande zote",
"Content required" => "Maudhui yaliyotakiwa",
"Field must be provided and contain one argument: separator" => "Shamba lazima itoewe na iwe na hoja moja: separator",
"Field must be provided and contain one or more values: key or keys" => "Shamba lazima itoewe na iwe na maadili moja au zaidi: ufunguo au funguo",
// "Str-replace needs exactly 3 arguments: search, replace and subject" => "Str-replace needs exactly 3 arguments: search, replace and subject",
"Too many arguments on strtotime" => "Vitu vingi vingi juu ya strtotime",
"Too few arguments on strtotime" => "Vikomo vichache sana juu ya strtotime",
// "Field must be provided and contain one argument: group" => "Field must be provided and contain one argument: group",
// "Field must be provided and contain at least one argument: aggregate" => "Field must be provided and contain at least one argument: aggregate",
"%0 near \"%1\"" => "%0 karibu \"%1\"",
"Expecting \"(\"" => "Inatarajiwa \"(\"",
"Unexpected \"%0\"" => "Isiyotarajiwa \"%0\"",
"Expecting \")\"" => "Inatarajiwa \")\"",
"No formula provided" => "Hakuna formula iliyotolewa",
"Variable not found \"%0\"" => "Tofauti haipatikani \"%0\"",
"Unknown operation \"%0\"" => "Uendeshaji usiojulikana \"%0\"",
// "Articles deleted" => "Articles deleted",
"removed the article" => "aliondoa makala hiyo",
// "Edited articles" => "Edited articles",
"edited the article" => "alibadilisha makala hiyo",
// "New articles submitted" => "New articles submitted",
"created the article" => "aliumba makala hiyo",
// "New blog posts" => "New blog posts",
"replied to the blog" => "alijibu blog",
// "New calendar events" => "New calendar events",
"%0 added or updated event %1" => "%0 aliongeza au alibadilisha tukio %1",
// "Changes in categories" => "Changes in categories",
// "added the %0 %1 to the category %2" => "added the %0 %1 to the category %2",
"created the subcategory" => "aliumba vikundi",
"removed the subcategory" => "aliondoa vijamii",
"from" => "kutoka",
"edited the category" => "alihariri kikundi",
// "removed the %0 %1 from the category %2" => "removed the %0 %1 from the category %2",
// "File galleries changed" => "File galleries changed",
// "%0 edited the file gallery %1" => "%0 edited the file gallery %1",
// "%0 uploaded the file %1" => "%0 uploaded the file %1",
"onto" => "kuingia",
// "%0 removed the file %1 from %2" => "%0 removed the file %1 from %2",
// "New replies in forum topics" => "New replies in forum topics",
"%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>alijibu</a> kwa mada %2",
// "New posts in forums" => "New posts in forums",
// "%0 created the topic %1 at forum %2" => "%0 created the topic %1 at forum %2",
// "Image galleries changed" => "Image galleries changed",
"changed the picture gallery" => "alibadilisha nyumba ya picha",
"uploaded the picture" => "alipakia picha",
"removed the picture" => "aliondoa picha",
// "Wiki pages added to a structure" => "Wiki pages added to a structure",
// "%0 added %1 wiki page to a structure" => "%0 added %1 wiki page to a structure",
// "Wiki pages moved down in a structure tree" => "Wiki pages moved down in a structure tree",
// "%0 moved a wiki page down in a structure tree" => "%0 moved a wiki page down in a structure tree",
// "Wiki pages moved up in a structure tree" => "Wiki pages moved up in a structure tree",
// "%0 moved a wiki page up in a structure tree" => "%0 moved a wiki page up in a structure tree",
// "Wiki pages removed from structure" => "Wiki pages removed from structure",
// "%0 removed %1 wiki page from a structure" => "%0 removed %1 wiki page from a structure",
// "File attached to tracker" => "File attached to tracker",
// "%0 attached a file (%1) to tracker item %2" => "%0 attached a file (%1) to tracker item %2",
// "Comments in tracker items" => "Comments in tracker items",
"%0 added a new comment to %1 on tracker %2" => "%0 aliongeza maoni mapya kwa %1 kwenye tracker %2",
"%0 added a new comment to item id %1 on tracker %2" => "%0 aliongeza maoni mapya kwenye number ya item %1 kwenye tracker %2",
// "Tracker items modified" => "Tracker items modified",
"%0 added or updated tracker item %1 on tracker %2" => "%0 kipengee cha tracker kilichoongezwa au kilichopangwa %1 kwenye tracker %2",
"%0 added or updated tracker item id %1 on tracker %2" => "%0 aliongeza au alisisha number ya bidhaa ya tracker %1 kwenye tracker %2",
// "New attachments in wiki pages" => "New attachments in wiki pages",
// "%0 uploaded the file %1 onto %2" => "%0 uploaded the file %1 onto %2",
// "Wiki pages updated" => "Wiki pages updated",
// "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)",
"Wiki pages created" => "Kurasa za Wiki ziliundwa",
// "%0 created the wikipage %1" => "%0 created the wikipage %1",
// "Wiki pages deleted" => "Wiki pages deleted",
// "%0 deleted the wikipage %1" => "%0 deleted the wikipage %1",
// "and %0 more changes of the same type" => "and %0 more changes of the same type",
"Nothing has happened" => "Hakuna kilichotokea",
// "Report on %0 from %1 " => "Report on %0 from %1 ",
"(no changes)" => "(hakuna mabadiliko)",
// "(1 change)" => "(1 change)",
"(%0 changes)" => "(%0 mabadiliko)",
// "Scheduler task is stalled" => "Scheduler task is stalled",
// "Scheduler task is already running" => "Scheduler task is already running",
// "Unable to decode task params" => "Unable to decode task params",
// "***** Running scheduler %s *****" => "***** Running scheduler %s *****",
// "Scheduler %0 (id: %1) is stalled" => "Scheduler %0 (id: %1) is stalled",
// "Skip scheduler %s - %s" => "Skip scheduler %s - %s",
// "***** Scheduler %s - FAILED *****\n%s" => "***** Scheduler %s - FAILED *****\n%s",
// "***** Scheduler %s - OK *****" => "***** Scheduler %s - OK *****",
// "Scheduler with id %0 does not exist or is not active" => "Scheduler with id %0 does not exist or is not active",
// "Scheduler `%0` (id: %1) is stalled" => "Scheduler `%0` (id: %1) is stalled",
// "Scheduler `%0` (id: %1) was healed" => "Scheduler `%0` (id: %1) was healed",
// "Scheduler `%0` (id: %1) was not healed" => "Scheduler `%0` (id: %1) was not healed",
// "Scheduler %0 (id: %1) is not stalled, no need to heal" => "Scheduler %0 (id: %1) is not stalled, no need to heal",
// "Missing parameters to run the command" => "Missing parameters to run the command",
// "Executing console command: %s" => "Executing console command: %s",
"Console command" => "Amri ya Console",
"Missing the URL to call" => "Inakosa URL ya kupiga simu",
// "Missing the file path to where the output should be saved" => "Missing the file path to where the output should be saved",
// "URL to invoke: %s" => "URL to invoke: %s",
"Save output to: %s" => "Hifadhi pato kwa: %s",
// "Using basic authentication" => "Using basic authentication",
// "Including additional headers" => "Including additional headers",
// "Sending request" => "Sending request",
// "Request was successful" => "Request was successful",
// "Failed to open file %s to write" => "Failed to open file %s to write",
"Request failed" => "Ombi lilishindwa",
"URL" => "Anwani ya wavuti",
// "Output File" => "Output File",
// "File path to save the output" => "File path to save the output",
// "Additional HTTP Headers" => "Additional HTTP Headers",
// "One HTTP Header per line" => "One HTTP Header per line",
// "Auth Username" => "Auth Username",
// "Auth Password" => "Auth Password",
// "Missing shell command to execute" => "Missing shell command to execute",
// "Executing shell command: %s" => "Executing shell command: %s",
// "Shell command" => "Shell command",
// "Run timeout" => "Run timeout",
// "in seconds" => "in seconds",
// "Checking tiki version" => "Checking tiki version",
// "Sending emails" => "Sending emails",
// "Tiki version email sent to" => "Tiki version email sent to",
// "Tiki Version Updated" => "Tiki Version Updated",
// "Tiki Updates: " => "Tiki Updates: ",
// "Tiki Updates" => "Tiki Updates",
// "Invalid cron time format" => "Invalid cron time format",
// "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1" => "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1",
// "Missing required action parameter or value: %0" => "Missing required action parameter or value: %0",
// "Cannot apply change_status action to an object type %0" => "Cannot apply change_status action to an object type %0",
// "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Tracker item %0 not found" => "Tracker item %0 not found",
// "Tracker item %0 status %1 is different than the \"from\" status %2" => "Tracker item %0 status %1 is different than the \"from\" status %2",
// "Cannot apply delete action to an aggregation type %0" => "Cannot apply delete action to an aggregation type %0",
// "Cannot apply delete action to an object type %0" => "Cannot apply delete action to an object type %0",
// "Tracker field %0 not found" => "Tracker field %0 not found",
// "Cannot find file to delete: %0" => "Cannot find file to delete: %0",
// "Are you sure you want to permanently delete this object" => "Are you sure you want to permanently delete this object",
// "EmailAction - send to %0, subject - %1" => "EmailAction - send to %0, subject - %1",
// "Error sending email: %0" => "Error sending email: %0",
// "Page %s cannot be found" => "Page %s cannot be found",
// "EmailAction - can't send new message" => "EmailAction - can't send new message",
// "Cannot apply filegal_change_filename action to an object type %0" => "Cannot apply filegal_change_filename action to an object type %0",
// "Tracker field %0 not found for tracker %1" => "Tracker field %0 not found for tracker %1",
// "Tracker field %0 is not a Files field type" => "Tracker field %0 is not a Files field type",
// "filegal_change_filename action missing value parameter" => "filegal_change_filename action missing value parameter",
// "Cannot apply filegal_image_overlay action to an object type %0" => "Cannot apply filegal_image_overlay action to an object type %0",
// "filegal_image_overlay action missing value parameter" => "filegal_image_overlay action missing value parameter",
// "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1" => "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1",
// "Cannot apply tracker_item_modify action to an aggregation type %0" => "Cannot apply tracker_item_modify action to an aggregation type %0",
// "Cannot apply tracker_item_modify action to an object type %0" => "Cannot apply tracker_item_modify action to an object type %0",
// "tracker_item_modify action missing value, calc, add or remove parameter" => "tracker_item_modify action missing value, calc, add or remove parameter",
// "Field %0 not found on Action TrackerItemModify" => "Field %0 not found on Action TrackerItemModify",
// "Error applying tracker_item_modify calc formula to item %0: %1" => "Error applying tracker_item_modify calc formula to item %0: %1",
// "Unknown search action step: %0" => "Unknown search action step: %0",
// "Cannot apply wiki_approval action to an object type %0" => "Cannot apply wiki_approval action to an object type %0",
// "Wiki page %0 is not in pending state" => "Wiki page %0 is not in pending state",
// "Wiki page %0 does not require approval" => "Wiki page %0 does not require approval",
"Tentative" => "Jaribio",
"Confirmed" => "Imethibitishwa",
"Cancelled" => "Imefunguliwa",
"unknown" => "haijulikani",
"Unknown" => "Haijulikani",
// "Tracker Status" => "Tracker Status",
// "Webservice %0 field \"%1\" not found" => "Webservice %0 field \"%1\" not found",
"%0 (latest)" => "%0 (ya hivi karibuni)",
// "Elasticsearch does not support optimize" => "Elasticsearch does not support optimize",
// "Federated index %0 not found" => "Federated index %0 not found",
// "Unknown mapping type \"%0\" for field \"%1\"" => "Unknown mapping type \"%0\" for field \"%1\"",
// "Document not found in index %1 (%0)" => "Document not found in index %1 (%0)",
// "String \"%0\" cannot be formatted as a number for field \"%1\"" => "String \"%0\" cannot be formatted as a number for field \"%1\"",
// "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker" => "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker",
// "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0" => "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0",
// "Feature not supported" => "Feature not supported",
// "Parsing search query failed: \"%0\"" => "Parsing search query failed: \"%0\"",
// "Sort field %0 not found in index" => "Sort field %0 not found in index",
"No results for query" => "Hakuna matokeo ya swala",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "Template tplwiki page \"%0\" not found" => "Template tplwiki page \"%0\" not found",
// "Template wiki page \"%0\" not found" => "Template wiki page \"%0\" not found",
// "Error evaluating formula %0: %1" => "Error evaluating formula %0: %1",
"No value for '%0'" => "Hakuna thamani kwa '%0'",
"Unknown formatting rule '%0' for '%1'" => "Sheria isiyojulikana ya utawala '%0' kwa '%1'",
// "Category Tree" => "Category Tree",
"Categories" => "Jamii",
// "%0 (Tree)" => "%0 (Tree)",
"Tags" => "Vitambulisho",
// "Letter" => "Letter",
// "First word" => "First word",
"Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Ufafanuzi umeshindwa wakati usindikaji \"%0\" (aina% 1) na hitilafu \"%2\"",
// "Object %0 type %1 returned null from getDocument function" => "Object %0 type %1 returned null from getDocument function",
// "Could not perform index modification: %0" => "Could not perform index modification: %0",
// "Feature not supported: %0" => "Feature not supported: %0",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Range filter \"from\" parameter not valid: \"%0\"" => "Range filter \"from\" parameter not valid: \"%0\"",
// "Range filter \"to\" parameter not valid: \"%0\"" => "Range filter \"to\" parameter not valid: \"%0\"",
// "Range filter \"gap\" parameter not valid: \"%0\"" => "Range filter \"gap\" parameter not valid: \"%0\"",
// "The range filter is missing \\\"from\\\" or \\\"to\\\"" => "The range filter is missing \\\"from\\\" or \\\"to\\\"",
// "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"" => "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"",
// "Distance sort: Missing lat or lon arguments" => "Distance sort: Missing lat or lon arguments",
// "Script sort: Missing source argument" => "Script sort: Missing source argument",
// "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled" => "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
"Malformed search query" => "Swali la utafutaji usiofaa",
// "%0 (%1)" => "%0 (%1)",
// "Please confirm" => "Please confirm",
"OK" => "SAWA",
// "Are you sure you want to %0 the following %1" => "Are you sure you want to %0 the following %1",
// "Please confirm your action for the following item" => "Please confirm your action for the following item",
// "Please confirm your action for the following items" => "Please confirm your action for the following items",
// "Activity stream currently unavailable" => "Activity stream currently unavailable",
"Permission Denied" => "Ruhusa imekataliwa",
// "Activity rule deleted" => "Activity rule deleted",
// "%0 activity rules deleted" => "%0 activity rules deleted",
// "No activity rules deleted" => "No activity rules deleted",
// "Delete Rule" => "Delete Rule",
// "Activity (id:' . (string) \$id . " => "Activity (id:' . (string) \$id . ",
// "No activities deleted" => "No activities deleted",
// "Delete Activity" => "Delete Activity",
// "Sample activity rule %0 updated" => "Sample activity rule %0 updated",
// "Sample activity rule %0 created" => "Sample activity rule %0 created",
// "Sample activity rule %0 unchanged" => "Sample activity rule %0 unchanged",
// "Edit Rule %0" => "Edit Rule %0",
// "Create Sample Rule" => "Create Sample Rule",
// "Basic activity rule %0 updated" => "Basic activity rule %0 updated",
// "Basic activity rule %0 created" => "Basic activity rule %0 created",
// "Basic activity rule %0 unchanged" => "Basic activity rule %0 unchanged",
// "Create Record Rule" => "Create Record Rule",
// "Tracker activity rule %0 updated" => "Tracker activity rule %0 updated",
// "Tracker activity rule %0 created" => "Tracker activity rule %0 created",
// "Tracker activity rule %0 unchanged" => "Tracker activity rule %0 unchanged",
// "Create Tracker Rule" => "Create Tracker Rule",
// "Advanced activity rule %0 updated" => "Advanced activity rule %0 updated",
// "Advanced activity rule %0 created" => "Advanced activity rule %0 created",
// "Advanced activity rule %0 unchanged" => "Advanced activity rule %0 unchanged",
// "Create Advanced Rule" => "Create Advanced Rule",
"Sample" => "Mfano",
"Basic" => "Msingi",
"Advanced" => "Kikubwa",
// "Invalid rule type" => "Invalid rule type",
// "Type changed for activity rule %0" => "Type changed for activity rule %0",
// "Change Rule Type" => "Change Rule Type",
// "Status changed for activity rule %0" => "Status changed for activity rule %0",
// "Change Rule Status" => "Change Rule Status",
// "Content could not be loaded" => "Content could not be loaded",
// "Create article from URL" => "Create article from URL",
"Invalid input" => "Pembejeo batili",
"Invalid data" => "Takwimu baliti",
// "Authentication added or modified" => "Authentication added or modified",
// "Authentication not added or modified" => "Authentication not added or modified",
// "Authentication deleted" => "Authentication deleted",
// "Authentication not deleted" => "Authentication not deleted",
"Oops" => "Oups",
"Action not found (%0 in %1)" => "Hatua haipatikani (%0 dans %1)",
"Controller not found (%0)" => "Mdhibiti haipatikani (%0)",
// "No change made for one object already in the category" => "No change made for one object already in the category",
// "No change made for %0 objects already in the category" => "No change made for %0 objects already in the category",
// "One object added to category" => "One object added to category",
// "%0 objects added to category" => "%0 objects added to category",
// "No objects added to category" => "No objects added to category",
// "No change made for one object not in the category" => "No change made for one object not in the category",
// "No change made for %0 objects not in the category" => "No change made for %0 objects not in the category",
// "One object removed from category" => "One object removed from category",
// "%0 objects removed from category" => "%0 objects removed from category",
// "No objects removed from category" => "No objects removed from category",
// "Invalid %0 ID: %1" => "Invalid %0 ID: %1",
"Comments not allowed on this page" => "Maoni hayaruhusiwi kwenye ukurasa huu",
"Loading..." => "Inapakia...",
"Comments" => "Maoni",
"Parent is locked" => "Mzazi amefungwa",
"Pseudonym must be specified" => "Pseudonym lazima ielezwe",
"Email must be specified" => "Barua lazima iwe maalum",
"Title is empty" => "Kichwa ni tupu",
"Content is empty" => "Maudhui haipo",
// "Duplicated comment, there is already another comment with the same text" => "Duplicated comment, there is already another comment with the same text",
"Your comment was posted" => "Maoni yako yalitumwa",
"Permissions denied" => "Ruhusa imekataliwa",
"Lock comments" => "Funga maoni",
"Unlock comments" => "Fungua maoni",
"Comment not found" => "Maoni haipatikani",
"Comment already approved" => "Maoni yalikubaliwa",
"Invalid argument" => "Hoja isiyo sahihi",
"Thread not specified" => "Faili haijainishwa",
// "Comment permissions: %0 object %1 not found" => "Comment permissions: %0 object %1 not found",
"Feature disabled" => "Kipengele kinazimwa",
"Reserved for administrators during development" => "Imehifadhiwa kwa watendaji wakati wa maendeleo",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
"There was an error (Tiki Connect is still experimental). Please try again" => "Kulikuwa na hitilafu (Tiki Connect bado ni jaribio). Tafadhali jaribu tena",
"registration" => "usajili",
"confirmation" => "uthibitisho",
"Connect Feature disabled" => "'Connect' Kipengele kilichomazwa",
"Connect server mode disabled" => "'Connect' hali ya seva imezimwa",
"Please confirm that you want to participate in Tiki Connect" => "Tafadhali hakikisha kwamba unataka kushiriki katika 'Tiki Connect'",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
"There was a problem at the server (Tiki Connect is still experimental)" => "Kulikuwa na tatizo kwenye seva ('Tiki Connect' bado ni jaribio)",
"CAPTCHA code problem" => "Tatizo la msimbo wa CAPTCHA",
"Connect data received, thanks" => "'Connect' data iliyopokelewa, shukrani",
"Your Tiki site is not registered here yet. Please try again" => "Tovuti yako ya Tiki haijasajiliwa hapa bado. Tafadhali jaribu tena",
// "Remove custom route" => "Remove custom route",
// "Inline editor update" => "Inline editor update",
"Preview" => "Angalia",
"Syntax Help" => "Msaada wa Syntax",
"WYSIWYG Help" => "Msaada wa WYSIWYG",
"Plugin Help" => "Msaada wa Plugin",
// "Spreadsheet Help" => "Spreadsheet Help",
"Edit Help" => "Hariri Misaada",
"Edit" => "Hariri",
// "Tracker %0 not found" => "Tracker %0 not found",
// "The following parameters could not be converted to plugin list at this stage:\n" => "The following parameters could not be converted to plugin list at this stage:\n",
// "Plugins found containing: %0" => "Plugins found containing: %0",
// "No plugins found containing: %0" => "No plugins found containing: %0",
// "You do not have permission to edit \"%0\"" => "You do not have permission to edit \"%0\"",
// "Undefined parameter" => "Undefined parameter",
"Missing parameters" => "Vigezo vya kupoteza",
// "%0 Plugin modified by editor" => "%0 Plugin modified by editor",
"Page \"%0\" not found" => "Ukurasa \"%0\" haukupatikana",
// "%0 Plugin converted to list" => "%0 Plugin converted to list",
// "Plugin %0 on page %1 converted" => "Plugin %0 on page %1 converted",
"Authentication required" => "Uthibitishaji unahitajika",
"Feature disabled: %0" => "Kazi imefungwa : %0",
// "Edit conflict" => "Edit conflict",
// "Edit conflict: %0 \"%1\" is being edited already by %2" => "Edit conflict: %0 \"%1\" is being edited already by %2",
"Field Required" => "Shamba Inahitajika",
"Not found" => "Haipatikani",
"File Upload" => "Faili kupakia ",
"File could not be uploaded" => "Faili haikuweza kupakuliwa",
"No file arrived" => "Hakuna faili iliyofika",
"File too large" => "Faili kubwa sana",
"Unknown errors" => "Makosa isiyojulikana",
"File empty" => "Faili tupu",
// "Batch file processed: \"%0\"" => "Batch file processed: \"%0\"",
"You don't have permission to upload zipped file packages" => "Huna ruhusa ya kupakia paket za faili zipped",
"Browse" => "usafiri",
// "Gallery List" => "Gallery List",
"Upload from source disabled" => "Pakia kutoka kwa chanzo imezimwa",
// "Unable to retrieve file from remote site. Please try a different URL" => "Unable to retrieve file from remote site. Please try a different URL",
"File could not be uploaded. Restrictions apply" => "Faili haikuweza kupakuliwa. Vikwazo vinatumika",
"Manual refresh disabled" => "Mwongozo wa Mwongozo umezima",
// "Gallery ID %0 not found" => "Gallery ID %0 not found",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help" => "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help",
"Requested gallery does not exist" => "Nyumba ya sanaa iliyoombwa haipo",
// "Vimeo not authenticated" => "Vimeo not authenticated",
// "Upload Video" => "Upload Video",
"Unknown error" => "Hitilafu isiyojulikana",
// "No action was selected. Please select an action before clicking OK" => "No action was selected. Please select an action before clicking OK",
// "Merge selected posts with another topic" => "Merge selected posts with another topic",
// "Merge this post" => "Merge this post",
// "Merge these posts" => "Merge these posts",
// "Merge selected topics with another topic" => "Merge selected topics with another topic",
// "Merge this topic" => "Merge this topic",
// "Merge these topics" => "Merge these topics",
"Merge" => "Unganisha",
// "With this topic" => "With this topic",
// "All topics or posts were selected, leaving none to merge with. Please make your selection again" => "All topics or posts were selected, leaving none to merge with. Please make your selection again",
// "No topics were selected. Please select the topics you wish to merge before clicking the merge button" => "No topics were selected. Please select the topics you wish to merge before clicking the merge button",
// "The following post has been merged with the %0 topic" => "The following post has been merged with the %0 topic",
// "The following posts have been merged with the %0 topic" => "The following posts have been merged with the %0 topic",
"Move this topic" => "Hoja mada hii",
"Move these topics" => "Hoja mada haya",
// "From the %0 forum to the below forum" => "From the %0 forum to the below forum",
// "Move selected topics to another forum" => "Move selected topics to another forum",
"Move" => "hoja",
// "No topics were selected. Please select the topics you wish to move before clicking the move button" => "No topics were selected. Please select the topics you wish to move before clicking the move button",
"The following topic has been moved to the %0 forum" => "Mada lifuatalo limehamishwa kwenye %0 jukwaa",
"The following topics have been moved to the %0 forum" => "Mada zifuatazo zimehamishwa kwenye %0 jukwaa",
// "Delete the following forum %0" => "Delete the following forum %0",
"Delete" => "Kuondoa",
"No topics were selected. Please select the topics you wish to delete before clicking the delete button" => "Hakuna mada yaliyochaguliwa. Tafadhali chagua mandhari unayofuta kufuta kabla ya kubonyeza kitufe cha Futa",
"The following topic has been deleted" => "Mada inayofuata imefutwa",
"The following topics have been deleted" => "Mada zifuatazo zimefutwa",
// "Delete the following attachment" => "Delete the following attachment",
// "No attachments were selected. Please select an attachment to delete" => "No attachments were selected. Please select an attachment to delete",
// "The following attachment has been deleted" => "The following attachment has been deleted",
// "The following attachments have been deleted" => "The following attachments have been deleted",
// "Reserved for forum administrators" => "Reserved for forum administrators",
// "Delete the following forum" => "Delete the following forum",
// "Delete the following forums" => "Delete the following forums",
// "No forums were selected. Please select a forum to delete" => "No forums were selected. Please select a forum to delete",
"The following forum has been deleted" => "Jukwaa linalofuata limefutwa",
// "The following forums have been deleted" => "The following forums have been deleted",
// "Reserved for forum administrators and moderators" => "Reserved for forum administrators and moderators",
// "%0 the following topic" => "%0 the following topic",
// "%0 the following topics" => "%0 the following topics",
// "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button" => "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button",
"locked" => "imefungwa",
"unlocked" => "imefunguliwa",
"The following topic has been %0" => "Mada inayofuata imekuwa %0",
"The following topics have been %0" => "Mada zifuatazo zimekuwa %0",
// "%0 the following thread" => "%0 the following thread",
// "thread" => "thread",
// "No threads were selected. Please select the threads you wish to %0" => "No threads were selected. Please select the threads you wish to %0",
// "archived" => "archived",
// "unarchived" => "unarchived",
// "The following thread has been %0" => "The following thread has been %0",
// "The following thread have been %0" => "The following thread have been %0",
// "The goal is currently disabled" => "The goal is currently disabled",
// "This goal is not enabled" => "This goal is not enabled",
// "Not eligible for this goal" => "Not eligible for this goal",
// "The goal has not been evaluated, administrator view" => "The goal has not been evaluated, administrator view",
// "Reserved for administrators" => "Reserved for administrators",
"Manage Goals" => "Dhibiti Malengo",
"Create Goal" => "Unda Lengo",
"Edit Goal" => "Badilisha lengo",
// "Remove Goal" => "Remove Goal",
// "Conditions" => "Conditions",
"Pages created" => "Kurasa zilizoundwa",
// "Condition" => "Condition",
// "Rewards" => "Rewards",
// "No available rewards" => "No available rewards",
// "Reward" => "Reward",
// "Restricted access" => "Restricted access",
// "Modify Eligibility for %0" => "Modify Eligibility for %0",
"Delete the following group" => "Futa kikundi kinachofuata",
"Delete the following groups" => "Futa makundi yafuatayo",
// "No groups were selected. Please select one or more groups" => "No groups were selected. Please select one or more groups",
"The following group cannot be deleted" => "Kikundi kinachofuata hawezi kufutwa",
"The following groups cannot be deleted" => "Makundi yafuatayo hayawezi kufutwa",
"The following group has been deleted" => "Kundi lifuatalo limefutwa",
"The following groups have been deleted" => "Makundi yafuatayo yamefutwa",
"Group already exists" => "Kundi tayari lipo",
"Create the group %0" => "Unda kikundi %0",
"Create" => "Unda",
"Group name cannot be empty" => "Jina la kikundi hawezi kuwa tupu",
// "Group %0 (ID %1) successfully created" => "Group %0 (ID %1) successfully created",
"Group %0 not created" => "Kikundi %0 hajaundwa",
"Modify the group %0" => "Badilisha kikundi %0",
"Modify" => "Badilisha",
// "Group %0 successfully modified" => "Group %0 successfully modified",
// "Group %0 not modified" => "Group %0 not modified",
"Add the following user to group %0" => "Ongeza mtumiaji wafuatayo kwenye kikundi %0",
"Add the following users to group %0" => "Ongeza watumiaji wafuatayo kwa kikundi %0",
"Add" => "Ongeza",
"One or more users must be selected" => "Watumiaji mmoja au zaidi wanapaswa kuchaguliwa",
"The following user was added to group %0" => "Mtumiaji anayefuata aliongezwa kwenye kikundi %0",
"The following users were added to group %0" => "Watumiaji wafuatayo waliongezwa kwenye kikundi %0",
// "Ban the following user from group %0" => "Ban the following user from group %0",
// "Ban the following users from group %0" => "Ban the following users from group %0",
// "Ban" => "Ban",
// "The following user was banned from group %0" => "The following user was banned from group %0",
// "The following users were banned from group %0" => "The following users were banned from group %0",
// "Unban the following user from group %0" => "Unban the following user from group %0",
// "Unban the following users from group %0" => "Unban the following users from group %0",
// "Unban" => "Unban",
// "The following user was unbanned from group %0" => "The following user was unbanned from group %0",
// "The following users were unbanned from group %0" => "The following users were unbanned from group %0",
// "h5p_enabled" => "h5p_enabled",
// "Create H5P Content" => "Create H5P Content",
// "Create H5P content" => "Create H5P content",
// "H5P Embed" => "H5P Embed",
// "No fileID provided" => "No fileID provided",
// "H5P Plugin" => "H5P Plugin",
// "Cannot find H5P content with fileId: %0" => "Cannot find H5P content with fileId: %0",
// "Edit H5P Content" => "Edit H5P Content",
// "H5P Edit" => "H5P Edit",
// "Waiting for javascript.." => "Waiting for javascript..",
// "H5P Content Libraries" => "H5P Content Libraries",
// "File not found on server. Check file upload settings" => "File not found on server. Check file upload settings",
// "H5P Results" => "H5P Results",
// "No contentId provided" => "No contentId provided",
// "H5P User Data" => "H5P User Data",
// "H5P User Results" => "H5P User Results",
// "You have successfully added %0 new media items" => "You have successfully added %0 new media items",
// "You have successfully added one new media item" => "You have successfully added one new media item",
// "No language provided" => "No language provided",
// "lang/\$language directory is not writable" => "lang/\$language directory is not writable",
"Wrote %d new strings and updated %d to lang/%s/language.php" => "Kuandikisha %d njia mpya na %d imewekwa ndani ya lang/%s/language.php",
"Write to language.php" => "Andika ndani language.php",
"Custom Translations" => "tafsiri ya desturi",
"Invalid file type" => "Aina ya faili batili",
// "File does not exist" => "File does not exist",
// "Invalid file type: php not allowed" => "Invalid file type: php not allowed",
"Upload Translations" => "Pakia tafsiri",
"Feature Disabled" => "Kazi imefungwa",
// "Invalid file parameter supplied" => "Invalid file parameter supplied",
"Translation not supported for the specified object type" => "Tafsiri haijasaidiwa kwa aina maalum ya kitu",
"No source provided" => "Hakuna chanzo kilichotolewa",
"Manage translations" => "Dhibiti tafsiri",
"No source or target provided" => "Hakuna chanzo au lengo linalotolewa",
// "You do not have permission to attach the selected translations" => "You do not have permission to attach the selected translations",
"Could not attach the translations" => "Haikuweza kuunganisha tafsiri",
// "You do not have permission to detach the selected translations" => "You do not have permission to detach the selected translations",
"The object has no language indicated and cannot be translated" => "Kitu hachina lugha kilichoonyeshwa na hawezi kutafsiriwa",
// "The language directory is not readable" => "The language directory is not readable",
// "The language directory is not writeable" => "The language directory is not writeable",
// "String translation set is not an array" => "String translation set is not an array",
// "Can not fopen custom.php" => "Can not fopen custom.php",
// "Can not fwrite custom.php" => "Can not fwrite custom.php",
// "Source string translation set is not an array" => "Source string translation set is not an array",
// "Target string translation set is not an array" => "Target string translation set is not an array",
// "Invalid process type" => "Invalid process type",
"Add new and update existing" => "Ongeza mpya na kusasisha iliyopo",
"Add new only" => "Ongeza mpya tu",
"Update existing only" => "Sasisha iliyopo tu",
"Replace all" => "Badilisha yote",
// "Failed to connect or authenticate with remote host" => "Failed to connect or authenticate with remote host",
// "Account created or modified" => "Account created or modified",
// "Account not created or modified" => "Account not created or modified",
"Modify Account" => "Badilisha Akaunti",
"Create Account" => "Unda Akaunti",
// "Account removed" => "Account removed",
// "Account not removed" => "Account not removed",
"Remove Account" => "Ondoa Akaunti",
// "Menu %0 not found" => "Menu %0 not found",
// "The %0 menu has been edited" => "The %0 menu has been edited",
// "The %0 menu has been created" => "The %0 menu has been created",
// "An error occurred - the %0 menu may not have been edited" => "An error occurred - the %0 menu may not have been edited",
// "An error occurred - the %0 menu may not have been created" => "An error occurred - the %0 menu may not have been created",
"Edit Menu" => "Badilisha menyu",
"Create Menu" => "Unda menyu",
// "Menu %0 cloned as menu %1" => "Menu %0 cloned as menu %1",
"Clone this menu and its options" => "Unganisha orodha hii na chaguzi zake",
"Menu option %0 not found" => "Chaguo la Menyu %0 halikupatikana",
"Menu Option %0" => "Chaguo la Menyu %0",
"Create Menu Option" => "Unda chaguo la Menyu",
// "Your menu options have been imported" => "Your menu options have been imported",
// "Import Menu Options" => "Import Menu Options",
// "Menu Preview" => "Menu Preview",
// "The %0 menu has been removed" => "The %0 menu has been removed",
// "The %0 menu has not been removed" => "The %0 menu has not been removed",
// "Delete the %0 menu" => "Delete the %0 menu",
"You don't have permission to edit menus (tiki_p_edit_menu)" => "Huna idhini ya kuhariri menyu (tiki_p_edit_menu)",
"You don't have permission to edit menu options (tiki_p_edit_menu_option)" => "Huna idhini ya kuhariri chaguzi za menyu (tiki_p_edit_menu_option)",
"You don't have permission to edit menu options (edit_menu_option)" => "Huna idhini ya kuhariri chaguzi za menyu (edit_menu_option)",
"Must Read" => "Lazima Soma",
"Invalid request method" => "Njia ya swala isiyo sahihi",
// "Cannot circulate" => "Cannot circulate",
// "Circulate" => "Circulate",
// "Group does not exist" => "Group does not exist",
// "Misconfigured feature" => "Misconfigured feature",
// "Target field not found" => "Target field not found",
// "Object not found" => "Object not found",
// "Must Read for %0" => "Must Read for %0",
// "Must Read Item not found" => "Must Read Item not found",
"Read" => "Inasoma",
// "Respond Privately" => "Respond Privately",
"Completed" => "Imekamilishwa",
// "Missing %0 parameter" => "Missing %0 parameter",
// "Not Found" => "Not Found",
// "No box available for %0" => "No box available for %0",
// "Invalid attribute name \"%0\"" => "Invalid attribute name \"%0\"",
// "Cannot lock \"%0\"" => "Cannot lock \"%0\"",
// "Reserved for payment administrators" => "Reserved for payment administrators",
// "Recommendations for %0" => "Recommendations for %0",
"Remote service inaccessible (%0)" => "Service distant inaccessible (%0)",
// "Execution output" => "Execution output",
// "Scheduler %0 - FAILED" => "Scheduler %0 - FAILED",
// "Scheduler %0 - OK" => "Scheduler %0 - OK",
// "Running %0" => "Running %0",
// "Reset scheduler run" => "Reset scheduler run",
"Rebuild Index" => "Jenga Ripoti",
// "Process Update Queue" => "Process Update Queue",
"empty" => "utupu",
// "Lookup Result" => "Lookup Result",
// "ManifoldCF Configuration Check" => "ManifoldCF Configuration Check",
// "Create ManifoldCF Index" => "Create ManifoldCF Index",
// "A query could not be created because the name is already in use" => "A query could not be created because the name is already in use",
// "Could not obtain the query" => "Could not obtain the query",
"Save Search" => "Hifadhi Utafutaji",
"Saved Searches" => "Utafutaji uliokolewa",
"Delete Saved Search" => "Futa  umehifadhiwa Utafutaji",
"Edit Saved Search" => "Badilisha Utafutaji uliohifadhiwa",
// "Search functionality currently unavailable" => "Search functionality currently unavailable",
// "Theme Customizer" => "Theme Customizer",
// "Item not found" => "Item not found",
"Reserved for tracker administrators" => "Imehifadhiwa kwa wasimamizi wa fomu",
"Type does not exist" => "Aina haipo",
"Add Field" => "Ongeza shamba",
// "Warning: There is a conflict in permanent names, which can cause indexing errors" => "Warning: There is a conflict in permanent names, which can cause indexing errors",
// "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4" => "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4",
// "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen" => "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
"Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker haina uwanja ulioorodheshwa, hakuna maelezo yenye maana yatatolewa katika orodha ya default",
"The tracker contains no field in the title, so no link will be generated" => "Tracker haina shamba katika kichwa, hivyo hakuna kiungo kitazalishwa",
// "Field handler not found" => "Field handler not found",
// "%0" => "%0",
"CAPTCHA" => "CAPTCHA",
"Distinct" => "Tofauti",
"Page Name" => "Jina la Ukurasa",
"Password" => "Nenosiri",
"Regular Expression (Pattern)" => "Ufafanuzi wa kawaida (Mfano)",
"Username" => "Jina la mtumiaji",
// "Export Fields" => "Export Fields",
"Invalid data provided" => "Data batili zinazotolewa",
"Import Tracker Fields" => "Weka Mashamba ya Tracker",
// "No item to clone" => "No item to clone",
// "Duplicate Item" => "Duplicate Item",
// "Item could not be created. Only one item per user is allowed" => "Item could not be created. Only one item per user is allowed",
"Item created" => "Kipengee kiliundwa",
// "New \"%0\" item successfully created" => "New \"%0\" item successfully created",
// "New tracker item %0 successfully created" => "New tracker item %0 successfully created",
// "Tracker item could not be created" => "Tracker item could not be created",
"Create Item" => "Unda Item",
// "Tracker item %0 has been updated" => "Tracker item %0 has been updated",
// "%0: Updated \"%1\"" => "%0: Updated \"%1\"",
"Comment for edit #%0" => "Maoni juu ya hariri #%0",
"Update Item" => "Sasisha kipengee",
"Are you sure you would like to update this item" => "Una uhakika ungependa kusasisha kipengee hiki",
"Save" => "Kujiandikisha",
// "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0" => "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0",
// "Tracker item %0 has been successfully deleted" => "Tracker item %0 has been successfully deleted",
"Remove" => "Ondoa",
// "Validation error" => "Validation error",
"Create Tracker" => "Unda Tracker",
"Duplicate Tracker" => "Tracker ya Duplicate",
// "Export Items" => "Export Items",
// "Import Tracker Structure" => "Import Tracker Structure",
"File upload failed" => "Kutuma faili imeshindwa",
"Uploaded file could not be read" => "Faili iliyopakiwa haikuweza kusoma",
// "Import Items" => "Import Items",
// "Import Tracker From Profile/YAML" => "Import Tracker From Profile/YAML",
"Last Modification" => "Marekebisho ya Mwisho",
"Creation Date" => "Tarehe ya uumbaji",
"Item ID" => "Andika Kitambulisho",
"Filename" => "Jina la faili",
"Creation date" => "Tarehe ya uumbaji",
"Views" => "maoni",
"File size" => "Ukubwa wa faili",
"Version" => "Toleo",
"File type" => "Aina ya faili",
"Long description" => "Maelezo marefu",
"User" => "Mtumiaji",
// "Select Tracker" => "Select Tracker",
"You don't have permission to view the tracker" => "Huna idhini ya kuona mtazamaji",
// "The item to clone isn't visible" => "The item to clone isn't visible",
// "You don't have permission to create new items" => "You don't have permission to create new items",
// "Cannot remove item %0 from this tracker" => "Cannot remove item %0 from this tracker",
"You don't have permission to export" => "Huna idhini ya kuuza nje",
"Remote Source" => "Chanzo cha mbali",
"Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "shamba la kuzalisha kwa moja kwa moja kwa wachezaji wanaoingiliana. Inayo itemId ya kipengee kijijini",
// "Clone Remote Tracker" => "Clone Remote Tracker",
"Tracker does not exist" => "Le formulaire n'existe pas",
"Tracker is not synchronized with a remote source" => "Le formulaire n'est pas synchronisé avec la source distante",
// "Tabular Formats" => "Tabular Formats",
// "Remove Format" => "Remove Format",
// "Create Tabular Format" => "Create Tabular Format",
// "Edit Format: %0" => "Edit Format: %0",
// "Format %0 not found" => "Format %0 not found",
// "Duplicate Format: %0" => "Duplicate Format: %0",
// "%0 copy" => "%0 copy",
// "Fields in %0" => "Fields in %0",
// "No formats available" => "No formats available",
// "Select Format" => "Select Format",
// "Primary Key required" => "Primary Key required",
// "Your import was completed successfully" => "Your import was completed successfully",
"Import" => "Ingiza",
// "Filter %0" => "Filter %0",
"Filter" => "Futa",
"Export %0" => "Tuma nje %0",
"Export" => "Tuma nje",
// "Create tabular format and tracker from file" => "Create tabular format and tracker from file",
"Operation reserved for tracker administrators" => "Uendeshaji umehifadhiwa kwa wasimamizi wa fomu",
"Events" => "Matukio",
"The following mandatory fields are missing: %0" => "Mashamba yafuatayo yanahitajika : %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
// "Field %0 does not exist in tracker" => "Field %0 does not exist in tracker",
// "The terms and conditions were modified while you were reading them" => "The terms and conditions were modified while you were reading them",
// "You are required to approve the terms of use to continue" => "You are required to approve the terms of use to continue",
// "Terms and Conditions" => "Terms and Conditions",
// "You must enter your date of birth to continue" => "You must enter your date of birth to continue",
// "Age Validation" => "Age Validation",
// "We were unable to create your account because this email is already in use" => "We were unable to create your account because this email is already in use",
"Friend" => "Rafiki",
// "Remove Friend" => "Remove Friend",
"Add Friend" => "Ongeza Rafiki",
"Following you" => "Kukufuata",
// "Remove Follower" => "Remove Follower",
// "You are following" => "You are following",
// "Stop Following" => "Stop Following",
"Follow" => "Fuata",
// "Awaiting your approval" => "Awaiting your approval",
// "Refuse Request" => "Refuse Request",
// "Accept &amp; Add" => "Accept &amp; Add",
// "Accept Request" => "Accept Request",
// "Waiting for approval" => "Waiting for approval",
// "Cancel Request" => "Cancel Request",
"Hidden" => "siri",
"km" => "km",
// "You need to set \"Show my information on mouseover\"" => "You need to set \"Show my information on mouseover\"",
"Click here" => "Bonyeza hapa",
// "You need to log in" => "You need to log in",
// "Delete the following user" => "Delete the following user",
// "Delete the following users" => "Delete the following users",
// "No users were selected. Please select one or more users" => "No users were selected. Please select one or more users",
// "The following user has been deleted" => "The following user has been deleted",
// "Submit form below to ban this user" => "Submit form below to ban this user",
// "The following users have been deleted" => "The following users have been deleted",
// "Submit form below to ban these users" => "Submit form below to ban these users",
// "Ban the following user's IP" => "Ban the following user's IP",
// "Clicking Ban will redirect you to a form where this user's is preselected for IP banning" => "Clicking Ban will redirect you to a form where this user's is preselected for IP banning",
// "Ban the following users' IPs" => "Ban the following users' IPs",
// "Clicking Ban will redirect you to a form where these users' are preselected for IP banning" => "Clicking Ban will redirect you to a form where these users' are preselected for IP banning",
// "See highlighted section in the form below for users you have selected for banning" => "See highlighted section in the form below for users you have selected for banning",
// "Remove the following user from group %0" => "Remove the following user from group %0",
// "For this user" => "For this user",
// "For these selected users" => "For these selected users",
// "Change group assignments for selected users" => "Change group assignments for selected users",
"%s %s assigned to %s %s" => "%s %s alipewa %s %s",
"user" => "mtumiaji",
"group" => "kikundi",
// "An error occurred. The group assignment failed" => "An error occurred. The group assignment failed",
"%s %s removed from %s %s." => "%s %s imeondolewa %s %s.",
// "The following user" => "The following user",
// "The following users" => "The following users",
// "%0 had the following group set as default" => "%0 had the following group set as default",
// "%0 been %1 the following %2" => "%0 been %1 the following %2",
// "Set default group for selected users" => "Set default group for selected users",
// "Make this the default group" => "Make this the default group",
// "group %s set as the default group for user %s" => "group %s set as the default group for user %s",
// "For the following user" => "For the following user",
// "For the following users" => "For the following users",
// "The following group has been set as the default group" => "The following group has been set as the default group",
// "Send wiki page content by email to selected users" => "Send wiki page content by email to selected users",
"Page not found" => "Page not found",
// "The page does not have a description, which is mandatory to perform this action" => "The page does not have a description, which is mandatory to perform this action",
// "Invalid bcc email address" => "Invalid bcc email address",
// "and blind copied (bcc) to %0" => "and blind copied (bcc) to %0",
// "The template page has no text or the text cannot be extracted" => "The template page has no text or the text cannot be extracted",
"Mail sent to user %s" => "Barua imetumwa kwa mtumiaji %s",
// "The page %0 has been emailed to the following user" => "The page %0 has been emailed to the following user",
// "The page %0 has been emailed to the following users" => "The page %0 has been emailed to the following users",
// "And blind copied to %0" => "And blind copied to %0",
"No user was selected" => "Hakuna mtumiaji aliyechaguliwa",
// "Message not sent - no subject or body" => "Message not sent - no subject or body",
"Your message was successfully sent to %0" => "Ujumbe wako ulipelekwa kwa ufanisi kwa %0",
"An error occurred, please check your mail settings and try again" => "Hitilafu ilitokea, tafadhali angalia mipangilio yako ya barua na jaribu tena",
"Please specify validity period" => "Tafadhali taja kipindi cha uhalali",
// "The group %0 does not exist" => "The group %0 does not exist",
"Your invite has been sent" => "Mwaliko wako umetumwa",
// "You must set a user for whom to set an avatar" => "You must set a user for whom to set an avatar",
// "You do not have the permission to change the avatar" => "You do not have the permission to change the avatar",
// "You must select an avatar to upload" => "You must select an avatar to upload",
// "An error occurred. User page for %0 could not be deleted" => "An error occurred. User page for %0 could not be deleted",
"Deleted account %s" => "Akaunti iliyofutwa %s",
// "An error occurred. User %0 could not be deleted" => "An error occurred. User %0 could not be deleted",
// "secure connection required" => "secure connection required",
"You cannot see this user's data" => "Huwezi kuona data ya mtumiaji huu",
"Send Me a Message" => "Nitumie ujumbe",
// "Upload Avatar" => "Upload Avatar",
"Must be authenticated" => "Lazima kuthibitishwa",
"Notifications for %0" => "Arifa kwa %0",
"No notifications" => "Hakuna arifa",
"Notifications" => "Inapaswa kuarifiwa Arifa",
// "Unread Notifications" => "Unread Notifications",
// "Mark all notifications as read" => "Mark all notifications as read",
// "Must be registered" => "Must be registered",
"Friend List" => "Orodha ya Rafiki",
// "User not found" => "User not found",
// "Approve Friend" => "Approve Friend",
// "Regenerate Wiki URLs" => "Regenerate Wiki URLs",
// "the only version of" => "the only version of",
"all versions of" => "matoleo yote ya",
"the last version of" => "the last version of",
// "Delete %0 the following %1" => "Delete %0 the following %1",
"You do not have permission to remove the selected page(s)" => "Huna ruhusa ya kuondoa ukurasa uliochaguliwa (s)",
"No pages were selected. Please select one or more pages" => "Hakuna kurasa zilizochaguliwa. Tafadhali chagua ukurasa mmoja au zaidi",
// "An error occurred. %0%1 could not be deleted" => "An error occurred. %0%1 could not be deleted",
"All versions" => "Matoleo yote",
"The last version" => "Toleo la mwisho",
"Version %0" => "Toleo %0",
// "%0 of the following page %1 been deleted" => "%0 of the following page %1 been deleted",
// "%0 of the following pages %1 been deleted" => "%0 of the following pages %1 been deleted",
// "Redirection page not specified. 301 redirect not created" => "Redirection page not specified. 301 redirect not created",
// "Semantic aliases (301 Redirects) to this page were created when other pages were deleted" => "Semantic aliases (301 Redirects) to this page were created when other pages were deleted",
// "A semantic alias (301 Redirect) to this page was created when page %0 was deleted" => "A semantic alias (301 Redirect) to this page was created when page %0 was deleted",
// "301 Redirects to the following page were created" => "301 Redirects to the following page were created",
// "A 301 Redirect to the following page was created" => "A 301 Redirect to the following page was created",
// "The following page and 301 Redirects to it were created" => "The following page and 301 Redirects to it were created",
// "The following page and a 301 Redirect to it were created" => "The following page and a 301 Redirect to it were created",
// "Delete the following %0 of %1" => "Delete the following %0 of %1",
// "No version were selected. Please select one or more versions" => "No version were selected. Please select one or more versions",
// "An error occurred. Version %0 could not be deleted" => "An error occurred. Version %0 could not be deleted",
// "The following version of %0 has been deleted" => "The following version of %0 has been deleted",
// "The following versions of %0 have been deleted" => "The following versions of %0 have been deleted",
// "Print the following page" => "Print the following page",
// "Print the following pages" => "Print the following pages",
"Print" => "magazeti",
"No page specified" => "Hakuna ukurasa ulioinishwa",
// "Export the following page to PDF" => "Export the following page to PDF",
// "Export the following pages to PDF" => "Export the following pages to PDF",
"PDF" => "PDF",
// "Lock the following page" => "Lock the following page",
// "Lock the following pages" => "Lock the following pages",
"Lock" => "Funga",
// "Excludes selected pages already locked or for which you lack permission to lock" => "Excludes selected pages already locked or for which you lack permission to lock",
// "You do not have permission to lock the selected pages or they have already been locked" => "You do not have permission to lock the selected pages or they have already been locked",
// "The following page was not locked due to an error" => "The following page was not locked due to an error",
// "The following pages were not locked due to an error" => "The following pages were not locked due to an error",
// "The following page has been locked" => "The following page has been locked",
// "The following pages have been locked" => "The following pages have been locked",
// "Unlock the following page" => "Unlock the following page",
// "Unlock the following pages" => "Unlock the following pages",
"Unlock" => "Fungua",
// "Excludes selected pages already unlocked or for which you lack permission to unlock" => "Excludes selected pages already unlocked or for which you lack permission to unlock",
// "You do not have permission to unlock the selected pages or they have already been unlocked" => "You do not have permission to unlock the selected pages or they have already been unlocked",
// "The following page was not unlocked due to an error" => "The following page was not unlocked due to an error",
// "The following pages were not unlocked due to an error" => "The following pages were not unlocked due to an error",
// "The following page has been unlocked" => "The following page has been unlocked",
// "The following pages have been unlocked" => "The following pages have been unlocked",
// "Download a zipped file of the following page" => "Download a zipped file of the following page",
// "Download a zipped file of the following pages" => "Download a zipped file of the following pages",
// "Zip" => "Zip",
// "Add page name as header of the following page" => "Add page name as header of the following page",
// "Add page name as header of the following pages" => "Add page name as header of the following pages",
// "The following page was not found" => "The following page was not found",
// "The following pages were not found" => "The following pages were not found",
// "The page name was added as header to the following page" => "The page name was added as header to the following page",
// "The page name was added as header to the following pages" => "The page name was added as header to the following pages",
// "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents",
// "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents",
// "Create Workspace" => "Create Workspace",
// "Workspace Templates" => "Workspace Templates",
// "Create Workspace Template" => "Create Workspace Template",
// "Edit template %0" => "Edit template %0",
// "Workspaces" => "Workspaces",
// "Could not create workspace root" => "Could not create workspace root",
"Invalid user" => "Mtumiaji batili",
// "Invalid token" => "Invalid token",
// "Empty authorization" => "Empty authorization",
// "Wrong authorization format" => "Wrong authorization format",
// "You don't have enough privileges" => "You don't have enough privileges",
// "Select a filter" => "Select a filter",
"n/a" => "n/d",
// "Server-side Processing" => "Server-side Processing",
// "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort" => "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort",
// "Overall Sort Settings" => "Overall Sort Settings",
// "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts" => "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts",
"Pre-sorted Columns" => "Nguzo zilizopangwa kabla",
// "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns" => "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns",
// "Sort Settings by Column" => "Sort Settings by Column",
// "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5" => "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5",
// "Set %0 to one of the following" => "Set %0 to one of the following",
// "Also handle strings in numeric columns with" => "Also handle strings in numeric columns with",
// "Handle empty cells with" => "Handle empty cells with",
// "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)" => "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)",
// "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5" => "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5",
// "Column Filters" => "Column Filters",
// "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters" => "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters",
// "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)" => "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)",
// "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>" => "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>",
// "Options generated automatically if not set and the %0server%1 parameter is not %0y%1" => "Options generated automatically if not set and the %0server%1 parameter is not %0y%1",
// "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown" => "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown",
// "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually" => "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually",
// "Date range - " => "Date range - ",
// "(from and to values set defaults for these fields when user clicks on the input field)" => "(from and to values set defaults for these fields when user clicks on the input field)",
// "Beware that items with empty date values will not be shown when default date range filters are applied" => "Beware that items with empty date values will not be shown when default date range filters are applied",
// "Numeric range - " => "Numeric range - ",
// "No filter - " => "No filter - ",
// "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list" => "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list",
// "Filter Options" => "Filter Options",
// "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1" => "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1",
// "Paginate" => "Paginate",
// "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: " => "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: ",
// "Column Select" => "Column Select",
// "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns" => "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns",
// "Totals" => "Totals",
// "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1" => "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1",
// "Setting to %0 will add one column total row set as follows: %1" => "Setting to %0 will add one column total row set as follows: %1",
// "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations" => "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations",
// "Instructions for each total option follows" => "Instructions for each total option follows",
// "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total" => "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total",
// "set what the calculation is. Choices are" => "set what the calculation is. Choices are",
// "Click %0 for a description of these options" => "Click %0 for a description of these options",
// "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)" => "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)",
// "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals" => "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals",
// "Total Format" => "Total Format",
// "Format for table totals (click %0 for patterns). Example" => "Format for table totals (click %0 for patterns). Example",
// "Total Options" => "Total Options",
// "Pipe-separated options for totals for each column which are set in the %0 parameter" => "Pipe-separated options for totals for each column which are set in the %0 parameter",
// "overrides the default number format set in %0" => "overrides the default number format set in %0",
// "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter" => "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter",
"Example:" => "Mfano:",
// "Page totals" => "Page totals",
// "Please install Faker package" => "Please install Faker package",
// "Object \"%0\" of type \"%1\" not found" => "Object \"%0\" of type \"%1\" not found",
// "The value of items is not a number" => "The value of items is not a number",
// "Tracker not found" => "Tracker not found",
// "Invalid field definition: %0" => "Invalid field definition: %0",
// "Checking for image gallery files skipped" => "Checking for image gallery files skipped",
// "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter" => "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter",
// "Tracker Attachments" => "Tracker Attachments",
// "Wiki Attachments" => "Wiki Attachments",
// "Forum Attachments" => "Forum Attachments",
// "Configured to stores files in Database" => "Configured to stores files in Database",
// "Configured to stores files on Disk: %0" => "Configured to stores files on Disk: %0",
// "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files" => "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files",
// "Files in DB: %0" => "Files in DB: %0",
// "Files on Disk: %0" => "Files on Disk: %0",
// "No Issues found" => "No Issues found",
// "Found %0 Issues, details below" => "Found %0 Issues, details below",
// "The following files are missing" => "The following files are missing",
"Id" => "ID",
// "The following files have different size that expected" => "The following files have different size that expected",
// "The following files are unknown, exists in the folder, but not in the database" => "The following files are unknown, exists in the folder, but not in the database",
// "Copy files from file galleries to a regular directory on the file system" => "Copy files from file galleries to a regular directory on the file system",
// "Feature Galleries not set up" => "Feature Galleries not set up",
// "File Copy: Gallery #%0 not found" => "File Copy: Gallery #%0 not found",
// "File Copy: Destination path required" => "File Copy: Destination path required",
// "No files to copy" => "No files to copy",
// "File Copy starting.." => "File Copy starting..",
// "File Copy complete" => "File Copy complete",
// "Move files from file galleries to a regular directory on the file system" => "Move files from file galleries to a regular directory on the file system",
// "File Move: Gallery #%0 not found" => "File Move: Gallery #%0 not found",
// "File Move: Destination path required" => "File Move: Destination path required",
// "No files to move" => "No files to move",
// "Use the --confirm option to proceed with the move operation" => "Use the --confirm option to proceed with the move operation",
// "File Move starting.." => "File Move starting..",
// "File Move complete" => "File Move complete",
// "Migrate images from the Image Gallery to the File Gallery" => "Migrate images from the Image Gallery to the File Gallery",
// "All files migrated" => "All files migrated",
// "No files migrated, default file gallery path is not writable" => "No files migrated, default file gallery path is not writable",
// "%0 reached for %1 (%2)" => "%0 reached for %1 (%2)",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
// "Clean Tiki install" => "Clean Tiki install",
// "Force installation. Overwrite any current database" => "Force installation. Overwrite any current database",
// "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM" => "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM",
// "Installation completed" => "Installation completed",
// "Queries executed successfully: %0" => "Queries executed successfully: %0",
// "Error %0 in" => "Error %0 in",
// "Database already exists" => "Database already exists",
// "Dependencies not satisfied. Exiting" => "Dependencies not satisfied. Exiting",
// "Composer could not be executed" => "Composer could not be executed",
// "Extension %0 is now disabled" => "Extension %0 is now disabled",
// "Extension %0 was not disabled" => "Extension %0 was not disabled",
// "Extension %0 was updated" => "Extension %0 was updated",
// "Extension %0 is now enabled" => "Extension %0 is now enabled",
// "Extension %0 was not enabled" => "Extension %0 was not enabled",
// "Installing package: " => "Installing package: ",
// "Invalid Package: " => "Invalid Package: ",
// "No packages available to be installed" => "No packages available to be installed",
// "No packages found in composer.json in the root of the project" => "No packages found in composer.json in the root of the project",
// "No packages installed" => "No packages installed",
// "Packages Installed" => "Packages Installed",
// "Packages Available to Install" => "Packages Available to Install",
// "No packages available to be removed" => "No packages available to be removed",
// "Removing package: " => "Removing package: ",
// "Packages that can be removed" => "Packages that can be removed",
// "No packages available to be updated" => "No packages available to be updated",
// "Updating package: " => "Updating package: ",
// "Packages that can be updated" => "Packages that can be updated",
// "Approve a list of plugin invocations/calls" => "Approve a list of plugin invocations/calls",
// "List fingerprints of the plugin invocations/calls to approve separated by commas" => "List fingerprints of the plugin invocations/calls to approve separated by commas",
// "Approve all plugin invocations/calls" => "Approve all plugin invocations/calls",
// "You must either use the option --all or provide a list of fingerprints to approve" => "You must either use the option --all or provide a list of fingerprints to approve",
// "Approving all pending plugins" => "Approving all pending plugins",
// "Approving a list of plugins" => "Approving a list of plugins",
// "Approving plugin %0" => "Approving plugin %0",
// "Plugins approved with success" => "Plugins approved with success",
// "List all plugin invocations/calls" => "List all plugin invocations/calls",
// "Shows only invocations/calls pending approval" => "Shows only invocations/calls pending approval",
// "Listing plugins in status: %0" => "Listing plugins in status: %0",
// "Found %0 plugins" => "Found %0 plugins",
// "No plugins found" => "No plugins found",
// "Parses all the pages to refresh the list of plugin invocations/calls" => "Parses all the pages to refresh the list of plugin invocations/calls",
// "Plugin list refreshed with success" => "Plugin list refreshed with success",
// "Not enough arguments (missing: \"article\" or \"--all\" options)" => "Not enough arguments (missing: \"article\" or \"--all\" options)",
// "Not enough arguments (missing: \"calendar\" or \"--all\" option)" => "Not enough arguments (missing: \"calendar\" or \"--all\" option)",
// "Not enough arguments (missing: \"category\" or \"--all\" options)" => "Not enough arguments (missing: \"category\" or \"--all\" options)",
// "Not enough arguments (missing: \"forum\" or \"--all\" option)" => "Not enough arguments (missing: \"forum\" or \"--all\" option)",
// "Not enough arguments (missing: \"menu\" or \"--all\" option)" => "Not enough arguments (missing: \"menu\" or \"--all\" option)",
// "Not enough arguments (missing: \"name\" or \"--all\" options)" => "Not enough arguments (missing: \"name\" or \"--all\" options)",
// "Not enough arguments (missing: \"tracker\" or \"--all\" option)" => "Not enough arguments (missing: \"tracker\" or \"--all\" option)",
// "No Items found to export" => "No Items found to export",
// "Tracker item %0 exported" => "Tracker item %0 exported",
// "Tracker item %0 failed to exported" => "Tracker item %0 failed to exported",
// "Tracker items for tracker %0 exported" => "Tracker items for tracker %0 exported",
// "Not enough arguments (missing: \"page\" or \"--all\" option)" => "Not enough arguments (missing: \"page\" or \"--all\" option)",
"Profile name" => "Jina la wasifu",
// "profiles.tiki.org" => "profiles.tiki.org",
// "Re-apply profiles when already applied" => "Re-apply profiles when already applied",
// "Return to the user information about what is going to be applied" => "Return to the user information about what is going to be applied",
// "Some of the named object references in the profile are invalid" => "Some of the named object references in the profile are invalid",
// "Profile applied" => "Profile applied",
// "Installation failed" => "Installation failed",
// "Dry-run for profile: " => "Dry-run for profile: ",
// "Permission removed: " => "Permission removed: ",
// "Permission added: " => "Permission added: ",
"User modified: " => "Mtumiaji amebadilishwa:",
"User added: " => "Mtumiaji aliongeza: ",
"Group modified: " => "Kundi limebadilisha: ",
"Group added: " => "Kundi liliongeza: ",
// "Preference set: %0= %1 old value= %2" => "Preference set: %0= %1 old value= %2",
// "Installer added: " => "Installer added: ",
// "Profile was already applied. Nothing happened" => "Profile was already applied. Nothing happened",
// "SCSS Parse Error" => "SCSS Parse Error",
// "SCSS Compiler Error" => "SCSS Compiler Error",
// "SCSS Range Error" => "SCSS Range Error",
// "SCSS Server Error" => "SCSS Server Error",
// "SCSS Error" => "SCSS Error",
// "Preference \"sitemap_enable\" is not enabled" => "Preference \"sitemap_enable\" is not enabled",
// "New sitemap created" => "New sitemap created",
"File not found" => "Faili halijapatikana",
// "File is not a .zip file" => "File is not a .zip file",
// "Theme installed" => "Theme installed",
// "Theme not found" => "Theme not found",
// "Theme removed successfully" => "Theme removed successfully",
// "An error occurred while deleting theme" => "An error occurred while deleting theme",
// "CSS folder not found" => "CSS folder not found",
// "Configuration file added" => "Configuration file added",
// "Preference inserted or updated" => "Preference inserted or updated",
// "Menu inserted or update" => "Menu inserted or update",
// "Module inserted or update" => "Module inserted or update",
// "Theme updated" => "Theme updated",
// "Could not open file" => "Could not open file",
// "Displays the Tiki (tiki) or PHP version (php), empty to display both" => "Displays the Tiki (tiki) or PHP version (php), empty to display both",
// "Internal error: mandatory parameter field_fetch_url is missing" => "Internal error: mandatory parameter field_fetch_url is missing",
// "Internal error: mandatory parameter object_store_url is missing" => "Internal error: mandatory parameter object_store_url is missing",
// "Problem finding the associated user. %0 is not recognized. See EventNotify.php" => "Problem finding the associated user. %0 is not recognized. See EventNotify.php",
// "Event name may be empty or invalid" => "Event name may be empty or invalid",
// "Arguments are expected to be a value map" => "Arguments are expected to be a value map",
"New File" => "Faili mpya",
// "Unable to write to destination path: %0" => "Unable to write to destination path: %0",
"Cannot resize the file" => "Haiwezi kubadilisha ukubwa wa faili",
"Cannot write the file" => "Haiwezi kuandika faili",
"Image was reduced: %s x %s -> %s x %s" => "Picha imepungua: %s x %s -> %s x %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
// "Duplicate file found as `%0`. Upload rejected" => "Duplicate file found as `%0`. Upload rejected",
// "Mail-in auto-reply" => "Mail-in auto-reply",
"Sorry, you can't use this feature." => "Samahani, huwezi kutumia kipengele hiki.",
// "The functionality you are trying to access is currently disabled" => "The functionality you are trying to access is currently disabled",
// "No required action found" => "No required action found",
// "Rejected message, user globally denied" => "Rejected message, user globally denied",
// "Rejected message, associated action disabled (%0)" => "Rejected message, associated action disabled (%0)",
// "Performing action (%0)" => "Performing action (%0)",
// "Rejected message, user locally denied (%0)" => "Rejected message, user locally denied (%0)",
// "Rejected message, no associated action" => "Rejected message, no associated action",
"Submit Article" => "Weka Makala",
// "Unable to find suitable action" => "Unable to find suitable action",
// "Wiki Append" => "Wiki Append",
// "Wiki Get" => "Wiki Get",
// "Wiki Prepend" => "Wiki Prepend",
// "Wiki Create/Update" => "Wiki Create/Update",
// "created from mail-in" => "created from mail-in",
// "Create or update article" => "Create or update article",
// "Reply Handler" => "Reply Handler",
// "Wiki (multiple actions)" => "Wiki (multiple actions)",
// "Login failed for IMAP account on %0:%1 for user %2" => "Login failed for IMAP account on %0:%1 for user %2",
// "Login failed for POP3 account on %0:%1 for user %2" => "Login failed for POP3 account on %0:%1 for user %2",
// "= New composer.json file content" => "= New composer.json file content",
// "= Composer execution output" => "= Composer execution output",
"Errors" => "Hitilafu",
// "Unable to download composer installer from %0" => "Unable to download composer installer from %0",
// "Invalid composer installer signature" => "Invalid composer installer signature",
// "composer.phar installed in temp folder" => "composer.phar installed in temp folder",
// "There was a problem when installing Composer" => "There was a problem when installing Composer",
// "Tiki root directory is not writable, so file \"%0\" can not be created" => "Tiki root directory is not writable, so file \"%0\" can not be created",
// "Tiki root directory is not writable, so directory \"%0\" can not be created" => "Tiki root directory is not writable, so directory \"%0\" can not be created",
// "Tiki can not write to file \"%0\"" => "Tiki can not write to file \"%0\"",
// "Tiki can not write to directory \"%0\"" => "Tiki can not write to directory \"%0\"",
// "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping.." => "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping..",
// "Warning: Profile %0 already installed. Skipping.." => "Warning: Profile %0 already installed. Skipping..",
// "Profile %0 applied" => "Profile %0 applied",
// "Warning: Profile %0 is not installed. Skipping.." => "Warning: Profile %0 is not installed. Skipping..",
// "Profile %0 removed" => "Profile %0 removed",
// "%0 library not found. This may be due to a typo or caused by a recent update" => "%0 library not found. This may be due to a typo or caused by a recent update",
// "Package %0 is not a Tiki Extension" => "Package %0 is not a Tiki Extension",
// "Package %0 is already enabled" => "Package %0 is already enabled",
// "Package %0 is not enabled" => "Package %0 is not enabled",
"Calendar does not exist" => "Kalenda haipo",
"Calendar already exists" => "Kalenda tayari iko",
"File gallery does not exist" => "Picha ya sanaa haipo",
"File gallery already exists" => "Picha ya sanaa iko tayari",
// "Untitled - From Profile Import" => "Untitled - From Profile Import",
// "Field \"%0\" in Tracker %1 has no value for itemId %2" => "Field \"%0\" in Tracker %1 has no value for itemId %2",
"Created by profile installer" => "Imeundwa na mtungaji wa wasifu",
"Page updated by profile installer" => "Ukurasa umewekwa na mtayarishaji wa wasifu",
// "Tiki (%0) is not satisfiable by profile required Tiki version (%1)" => "Tiki (%0) is not satisfiable by profile required Tiki version (%1)",
"Nothing was changed. Please check the profile for errors" => "Hakuna kilichobadilishwa. Tafadhali angalia profile kwa makosa",
"Applying profile" => "Inatumia maelezo ya wasifu",
"Added (or modified)" => "Hiliongezwa (au iliyopita)",
"Group changed (or modified)" => "Kikundi kilibadilika (au kilibadilishwa)",
// "Installer reverted" => "Installer reverted",
// "Installer removed" => "Installer removed",
// "Group removed" => "Group removed",
// "Group modified" => "Group modified",
// "Permission removed" => "Permission removed",
// "Permission assign" => "Permission assign",
"Preference set" => "Upendeleo umewezeshwa",
// "<error>Package %0:  No folder was found. Did you forgot to install?</error>" => "<error>Package %0:  No folder was found. Did you forgot to install?</error>",
// "Package set" => "Package set",
"Modified permission %s for %s" => "Imesababishwa ruhusa %s kwa %s",
"Modified permission %s on %s/%s for %s" => "Ilibadilishwa ruhusa %s kwenye %s/%s kwa %s",
"User %0 was added to %1" => "Mtumiaji %0 aliongezwa kwa %1",
"No name" => "Hakuna jina",
"Bad object" => "Kitu kibaya",
// "Could not parse YAML in profile: \"%0\"" => "Could not parse YAML in profile: \"%0\"",
// "Profile Path cannot be found" => "Profile Path cannot be found",
"Syntax error: " => "Hitilafu ya Syntax: ",
"Circular reference" => "Rejea ya mzunguko",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
"Needs a 'type' and 'data' field" => "Inahitaji uwanja wa 'type' na 'data'",
// "Source: %0:%1 (%2)" => "Source: %0:%1 (%2)",
// "Recommendation: %0:%1 (%2)" => "Recommendation: %0:%1 (%2)",
// "The directory with path: ' . \$path_or_id . ' could not be found" => "The directory with path: ' . \$path_or_id . ' could not be found",
// "The file with path: ' . \$path_or_id . ' could not be found" => "The file with path: ' . \$path_or_id . ' could not be found",
// "The wiki page with name: ' . \$name . ' could not be found" => "The wiki page with name: ' . \$name . ' could not be found",
// "Theme already installed" => "Theme already installed",
// "Version %0 is no longer supported" => "Version %0 is no longer supported",
// "A minor upgrade to %0 is strongly recommended" => "A minor upgrade to %0 is strongly recommended",
// "A major upgrade to %0 is strongly recommended" => "A major upgrade to %0 is strongly recommended",
// "Version %0 is still supported. However, an upgrade to %1 is available" => "Version %0 is still supported. However, an upgrade to %1 is available",
// "Version %0 is still supported. However, a major upgrade to %1 is available" => "Version %0 is still supported. However, a major upgrade to %1 is available",
"Replace spaces with dashes" => "Badilisha mahali na dashes",
"Replace spaces with underscores" => "Badilisha mahali na underscores \"_\"",
// "URL Encode (Tiki Classic)" => "URL Encode (Tiki Classic)",
// "Duplicate entry found (%0)" => "Duplicate entry found (%0)",
// "Filter error: \"%0\"" => "Filter error: \"%0\"",
"Action" => "Hatua",
"Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site" => "Unda fomu ya kuchapishwa mahali fulani, sio lazima katika tracker au hata kwenye tovuti hii ya Tiki",
// "The title of the button" => "The title of the button",
"Post" => "Kuchapisha",
// "The protocol to use in the form: either get or post" => "The protocol to use in the form: either get or post",
"Script" => "Script",
// "The URL of the destination of the form" => "The URL of the destination of the form",
"Parameters" => "Vizego",
// "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form" => "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form",
// "Attach articles to the tracker item" => "Attach articles to the tracker item",
"Topic" => "Somo",
// "Default article topic" => "Default article topic",
"Article Type" => "Aina ya makala",
// "Default article type" => "Default article type",
"Auto-Increment" => "Uingizaji wa peke",
// "Enable an incrementing value field, or itemId field" => "Enable an incrementing value field, or itemId field",
"Start" => "Anza",
"The starting value for the field" => "Thamani ya kuanza kwa shamba",
"Prepend" => "Weka",
"Text that will be displayed before the field" => "Nakala ambayo itaonyeshwa kabla ya shamba",
"Append" => "Pendekeza",
"Text that will be displayed after the field" => "Nakala ambayo itaonyeshwa baada ya shamba",
"If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "Ikiwa imewekwa kwenye \"itemId\", itaweka uwanja huu ili kufanana na thamani ya bidhaa halisi ya dataId thamani ya shamba",
// "Update Empty" => "Update Empty",
"No" => "Hapana",
"Yes" => "Ndiyo",
// "Note: %0 auto-increment item values updated" => "Note: %0 auto-increment item values updated",
// "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********" => "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********",
// "Date and Time (Calendar Item)" => "Date and Time (Calendar Item)",
// "Associate calendar items with tracker items" => "Associate calendar items with tracker items",
// "Experimental: (work in progress, use with care)" => "Experimental: (work in progress, use with care)",
// "Calendar Id" => "Calendar Id",
"Calendar to use for associated events" => "Kalenda ya kutumia kwa matukio yanayohusiana",
// "Show Event Id" => "Show Event Id",
// "Show an input for the event id when editing the field, allow lost events to be reattached" => "Show an input for the event id when editing the field, allow lost events to be reattached",
// "Calendar Item %0 not found" => "Calendar Item %0 not found",
// "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2" => "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2",
"Category" => "Jamii",
// "Enable the tracker item to be categorized in one or more categories under the specified main category" => "Enable the tracker item to be categorized in one or more categories under the specified main category",
"Parent Category" => "Jamii ya Mzazi",
"Child categories will be provided as options for the field" => "Makundi ya watoto yatatolewa kama chaguzi za shamba",
"Input Type" => "Aina ya Kuingiza",
"User interface control to be used" => "Udhibiti wa interface wa mtumiaji utumiwe",
"Dropdown" => "Orodha ya kushuka",
"Radio buttons" => "Vifungo vya redio",
"List box" => "Orodha",
"Multiple-selection checkboxes" => "Majina ya Checkbox na uteuzi mingi",
"Select All" => "Chagua Wote",
"Includes a control to select all available options for multi-selection controls" => "Inajumuisha udhibiti wa kuchagua chaguo zote zinazopatikana kwa udhibiti wa uteuzi mbalimbali",
"No controls" => "Hakuna udhibiti",
"Include controls" => "Jumuisha udhibiti",
"All descendants" => "Wote wazao",
"Display all descendants instead of only first-level descendants" => "Onyesha wazao wote badala ya uzao wa kwanza tu",
"First level only" => "Ngazi ya kwanza tu",
// "All descendants and display full path" => "All descendants and display full path",
"Displays the field description in a help tooltip" => "Inaonyesha maelezo ya shamba katika msaada wa tooltip",
"No help" => "Hakuna msaada",
"Tooltip" => "Tooltip",
// "Output Type" => "Output Type",
// "Plain list with items separated by line breaks (default)" => "Plain list with items separated by line breaks (default)",
// "Links separated by line breaks" => "Links separated by line breaks",
// "Unordered list of labels" => "Unordered list of labels",
// "Unordered list of links" => "Unordered list of links",
// "Do not Inherit Categories" => "Do not Inherit Categories",
// "Inherit (default)" => "Inherit (default)",
// "Do not inherit" => "Do not inherit",
// "Recategorization event" => "Recategorization event",
// "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving" => "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving",
// "Indexing" => "Indexing",
// "-Blank (no data)-" => "-Blank (no data)-",
// "%0 (any of)" => "%0 (any of)",
// "%0 (all of)" => "%0 (all of)",
// "Tracker items will inherit their tracker's categories unless this option is set" => "Tracker items will inherit their tracker's categories unless this option is set",
"Checkbox" => "Checkbox",
// "Provide a checkbox field for yes/no, on/off input" => "Provide a checkbox field for yes/no, on/off input",
"Computed Field" => "Nambari iliyohesabiwa",
// "Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type" => "Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type",
"This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field" => "Kipengele hiki bado kinachukua nafasi kwa usawa wa nyuma. Ingawa haina makosa yaliyojulikana, inaweza kutumika kama vector ya mashambulizi mabaya. Shamba au desturi ya webservice JavaScript inapendekezwa badala ya shamba hili",
"Formula" => "Mfumo",
"The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "Fomu ya kuhesabiwa kuunga mkono waendeshaji mbalimbali (+ - * / na wazazi), kumbukumbu kwenye uwanja mwingine uliotumiwa kwa kutumia id ya shamba iliyoandaliwa na #",
"Decimal Places" => "Eneo la mahali ya decimal",
"Number of decimal places to round to" => "Idadi ya maeneo ya decimal hadi pande zote",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details" => "Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed" => "Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed",
"Country Selector" => "Mchezaji wa nchi",
// "Enable a selection from a specified list of countries" => "Enable a selection from a specified list of countries",
"Display" => "Onyesha",
"Specify the rendering type for the field" => "Taja aina ya utoaji wa shamba",
"Name and flag" => "Jina na bendera",
"Name only" => "Jina tu",
"Flag only" => "Bendera tu",
"Sort order" => "Panga utaratibu",
"Determines whether the ordering should be based on the translated name or the English name" => "Inataa ikiwa utaratibu unapaswa kutegemea jina la kutafsiriwa au jina la Kiingereza",
"Translated name" => "Jina lililotafsiriwa",
"English name" => "Jina la Kiingereza",
"Currency Field" => "Sehemu ya Fedha",
// "Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric" => "Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric",
"Same Row" => "Mstari sawa",
"Displays the next field on the same line" => "Inaonyesha shamba inayofuata kwenye mstari huo",
"Display Size" => "Ukubwa wa Kuonyesha",
"Visible size of the field, in characters. Does not affect the numeric length" => "Ukubwa unaoonekana wa shamba, kwa wahusika. Haiathiri urefu wa nambari",
"Text to be displayed in front of the currency amount" => "Nakala ya kuonyeshwa mbele ya kiasi cha sarafu",
"Text to be displayed after the numeric value" => "Nakala ya kuonyeshwa baada ya thamani ya nambari",
"Locale" => "Maeneo",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
"Currency" => "Fedha",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
"Currency symbol" => "Ishara ya fedha",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
"All" => "Wote",
// "Currency Tracker" => "Currency Tracker",
// "Tracker containing available currencies and exchange rates" => "Tracker containing available currencies and exchange rates",
"Date and Time" => "Tarehe na Wakati",
// "Provide drop-down options to accurately select a date and/or time" => "Provide drop-down options to accurately select a date and/or time",
"Components to be included" => "Vipengele vinajumuishwa",
"Date only" => "Tarehe tu",
"Start year" => "Mwaka wa mwanzo",
"Year to allow selecting from" => "Mwaka kuruhusu kuchagua kutoka",
"End year" => "Mwaka wa mwisho",
"Year to allow selecting to" => "Mwaka kuruhusu kuchagua kwa",
"Default selection" => "Uteuzi wa chaguo-msingi",
"Indicates if blank dates should be allowed" => "Inaonyesha kama tarehe tupu zinaweza kuruhusiwa",
"Current Date" => "Tarehe ya sasa",
"Blank" => "Tupu",
// "Time Ago" => "Time Ago",
// "Use timeago.js if the feature is enabled" => "Use timeago.js if the feature is enabled",
// "Item Date Field" => "Item Date Field",
// "Use this date as the item's global date in the search index" => "Use this date as the item's global date in the search index",
// "Allow users to select only from a specified set of options" => "Allow users to select only from a specified set of options",
"Option" => "Chaguo",
"If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label" => "Ikiwa chaguo ina ishara sawa, sehemu kabla ya ishara sawa itatumiwa kama thamani, na sehemu ya pili kama lebo",
"Dropdown selector with \"Other\" field" => "Mchaguzi wa kushuka chini na \"Nyingine\" shamba",
// "Allow users to select from a specified set of options or to enter an alternate option" => "Allow users to select from a specified set of options or to enter an alternate option",
// "To change the label of the \"Other\" option, use \"other=Label\"" => "To change the label of the \"Other\" option, use \"other=Label\"",
"Radio Buttons" => "Vifungo vya redio",
"Multiselect" => "Uchaguzi Mingi",
// "Allow a user to select multiple values from a specified set of options" => "Allow a user to select multiple values from a specified set of options",
"Dynamic Items List" => "Orodha ya Vitu vya Nguvu",
// "Dynamically update a selection list based on linked data from another tracker" => "Dynamically update a selection list based on linked data from another tracker",
"Tracker ID" => "Kitambulisho cha Tracker",
"Tracker to link with" => "Tracker kuunganisha na",
"Field ID (Other tracker)" => "Kitambulisho cha shamba (tracker nyingine)",
"Field ID to link with in the other tracker" => "Kitambulisho cha Shamba ili kuunganisha na kwenye tracker nyingine",
"Field ID (This tracker)" => "Kitambulisho cha shamba (Hii tracker)",
"Field ID to link with in the current tracker" => "Kitambulisho cha Shamba ili kuunganisha na tracker ya sasa",
"Listed Field" => "Uwanja waliotajwa",
"Field ID to be displayed in the dropdown list" => "Kitambulisho cha shamba kinaonyeshwa katika orodha ya kushuka",
"Status Filter" => "Filamu ya Hali",
"Restrict listed items to specific statuses" => "Weka vitu vilivyoorodheshwa kwenye hali maalum",
"all" => "wote",
"open" => "kufungua",
// "pending" => "pending",
"closed" => "imefungwa",
"open, pending" => "kufungua, inasubiri",
"pending, closed" => "inasubiri, imefungwa",
// "Hide blank" => "Hide blank",
// "Hide first blank option, thus preselecting the first available option" => "Hide first blank option, thus preselecting the first available option",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***" => "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***",
"*** ERROR: Field %0 not found ***" => "*** KOSA: Uwanja %0 haipatikani ***",
// "*** ERROR: No remote tracker selected for DynamicList Field %0 ***" => "*** ERROR: No remote tracker selected for DynamicList Field %0 ***",
// "DynamicList field: Field \"%0\" not found" => "DynamicList field: Field \"%0\" not found",
"Email" => "Barua pepe",
// "Enable an email address to be input with the option of making it active" => "Enable an email address to be input with the option of making it active",
"Link Type" => "Aina ya Kiungo",
"How the email address will be rendered" => "Jinsi anwani ya barua pepe itafanywaée",
"Plain text" => "Nakala ya wazi",
"Encoded mailto link" => "Imeunganishwa kwa barua pepe iliyounganishwa",
"Simple mailto link" => "Kiungo cha barua pepe rahisi",
"Watch Open" => "Tazama Fungua",
"Notify this address every time the status changes to open" => "Arifaza anwani hii kila wakati hali inabadilika kufungua",
"Watch Pending" => "Angalia Inasubiri",
"Notify this address every time the status changes to pending" => "Arifaza anwani hii kila wakati hali inabadilika kusubiri",
"Watch Closed" => "Tazama Ilifungwa",
"Notify this address every time the status changes to closed" => "Arifaza anwani hii kila wakati hali inabadilika kufungwa",
"Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Hitilafu ya Kiwanda cha Tracker: Mapendekezo \"%0\" inahitajika kwa aina ya shamba \"%1\"",
"Attachment" => "Kiambatisho",
// "Deprecated in favor of the Files field" => "Deprecated in favor of the Files field",
"List View" => "Ona Orodha",
"Defines how attachments will be displayed within the field" => "Inafafanua jinsi vifungo vinavyoonyeshwa ndani ya shamba",
"name" => "jina",
"type" => "aina",
"name, size" => "jina, kipimo",
"name, type, size" => "jina, aina, kipimo",
"uploader" => "mwenye kupakia",
"mediaplayer" => "mchezaji wa vyombo vya habari",
"Download" => "Kupakua",
"Attached and upload files stored in the file galleries to the tracker item" => "Zilizosambazwa na kupakia faili zilizohifadhiwa kwenye nyumba za faili kwenye kipengee cha tracker",
"Gallery ID" => "Kitambulisho kya nyumba ya sanaa",
"File gallery to upload new files into" => "Weka faili ya nyumba ya sanaa ili usanie faili mpya",
"MIME Type Filter" => "Chujio ya aina MIME",
"Mask for accepted MIME types in the field" => "Mask kwa aina za MIME zinazokubaliwa katika shamba",
"File Count" => "Idadi ya faili",
"Maximum number of files to be attached on the field" => "Idadi kubwa ya faili zilizowekwa kwenye shamba",
"Display Mode" => "Njia ya Kuonyesha",
// "Show files as object links or via a wiki plugin (img so far)" => "Show files as object links or via a wiki plugin (img so far)",
"Links" => "Viungo",
// "Bare Links" => "Bare Links",
"Table" => "Meza",
"Images" => "Picha",
"Vimeo" => "Vimeo",
// "Google Viewer" => "Google Viewer",
// "Moodle Scorm Viewer" => "Moodle Scorm Viewer",
// "Display parameters" => "Display parameters",
"URL-encoded parameters used such as in the {img} plugin, for example,." => "Vigezo vinavyosajiliwa na URL vinazotumiwa kama vile {img} plugin, kwa mfano.",
// "Display parameters for lists" => "Display parameters for lists",
// "Display Order" => "Display Order",
// "Sort order for the files" => "Sort order for the files",
// "Default (order added to tracker item)" => "Default (order added to tracker item)",
"Name (A - Z)" => "Jina (A - Z)",
"Name (Z - A)" => "Jina (Z - A)",
"Filename (A - Z)" => "Jina la faili (A - Z)",
"Filename (Z - A)" => "Jina la faili (Z - A)",
// "Created date (old - new)" => "Created date (old - new)",
// "Created date (new - old)" => "Created date (new - old)",
// "Last modified date (old - new)" => "Last modified date (old - new)",
// "Last modified date (new - old)" => "Last modified date (new - old)",
"File size (small - large)" => "Ukubwa wa faili (ndogo - kubwa)",
"File size (large - small)" => "Ukubwa wa faili (kubwa - ndogo)",
// "Hits (low - high)" => "Hits (low - high)",
// "Hits (high - low)" => "Hits (high - low)",
"Include Child Galleries" => "Jumuisha nyumba ya sanaa ya Watoto",
"Use files from child galleries as well" => "Tumia faili kutoka kwenye nyumba ya sanaa za watoto pia",
// "Replace Existing File" => "Replace Existing File",
// "Replace the existing file, if any, instead of uploading a new one" => "Replace the existing file, if any, instead of uploading a new one",
// "Browse Gallery ID" => "Browse Gallery ID",
// "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)" => "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)",
// "Restrict permissions to view the file gallery to hide the button" => "Restrict permissions to view the file gallery to hide the button",
// "Duplicate Gallery ID" => "Duplicate Gallery ID",
// "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)" => "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)",
// "Index As Map Layer" => "Index As Map Layer",
// "Index the files in a specific format for use in map searchlayers to display trails and features" => "Index the files in a specific format for use in map searchlayers to display trails and features",
// "GeoJSON" => "GeoJSON",
// "GPX" => "GPX",
// "Upload In Modal" => "Upload In Modal",
// "Upload files in a new modal window" => "Upload files in a new modal window",
// "Maximum image width" => "Maximum image width",
// "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings",
// "Maximum image height" => "Maximum image height",
// "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings",
// "Add Descriptions" => "Add Descriptions",
// "Add descriptions on uploaded files" => "Add descriptions on uploaded files",
// "Show files as object links or via a wiki plugin (img, Vimeo)" => "Show files as object links or via a wiki plugin (img, Vimeo)",
// "Files field: Gallery #%0 not found" => "Files field: Gallery #%0 not found",
// "Token access needs to be enabled for Google viewer to be used" => "Token access needs to be enabled for Google viewer to be used",
// "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")" => "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")",
"Problem with uploaded file: \"%0\"" => "Tatizo na faili iliyopakiwa: \"%0\"",
"No gallery for uploaded file, galleryId=%0" => "Hakuna ghala la faili iliyopakiwa, Kitambulisho=%0",
"You don't have permission to upload a file to gallery \"%0\"" => "Huna ruhusa ya kupakia faili kwenye nyumba ya sanaa \"%0\"",
// "Allow tags to be shown or added for tracker items" => "Allow tags to be shown or added for tracker items",
"Visible size of the input field" => "Ukubwa unaoonekana wa shamba la pembejeo",
"Hide or show the input help" => "Ficha au kuonyesha msaada wa pembejeo",
"Show" => "Onyesha",
"Hide" => "Ficha",
"Suggest" => "Kupendekeza",
"Hide or show the tag suggestions" => "Ficha au kuonyesha mapendekezo ya lebo",
// "Geographic Feature" => "Geographic Feature",
// "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved" => "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved",
"Feature cannot be set or modified through this interface" => "Kipengele hawezi kuweka au kubadilisha kupitia interface hii",
"Feature cannot be viewed" => "Kipengele hawezi kutazamwa",
"Group Selector" => "Mchezaji wa Kundi",
// "Allow a selection from a specified list of user groups" => "Allow a selection from a specified list of user groups",
"Auto-Assign" => "Kuweka kwa peke",
"Determines if any group should be automatically assigned to the field" => "Inatafuta ikiwa kundi lolote linapaswa kuwekwa moja kwa moja kwenye shamba",
"Modifier" => "Mwenye kubadilisha",
"Group Filter" => "Chujio ya kundi",
"Limit listed groups to those including the specified group" => "Makundi yaliyoorodheshwa yaliyoorodheshwa kwa wale wanaojumuisha kikundi maalum",
"User Groups" => "Vikundi vya Watumiaji",
// "Show groups user belongs to instead of the ones user has permission to see" => "Show groups user belongs to instead of the ones user has permission to see",
// "Assign to the group" => "Assign to the group",
// "For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated" => "For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated",
"Assign" => "Weka",
// "Unassign from previous selection" => "Unassign from previous selection",
// "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated" => "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated",
"Unassign" => "Désattribuer",
"Email Notification" => "Arifa ya barua pepe",
// "Add selected group to group monitor the item. Group watches feature must be enabled" => "Add selected group to group monitor the item. Group watches feature must be enabled",
"Header" => "Kichwa",
// "Display a heading between fields to delimit a section and allow visual folding of the fields" => "Display a heading between fields to delimit a section and allow visual folding of the fields",
"Heading Level" => "Ngazi ya kichwa",
"Level of the heading to use for complex tracker structures needing multiple heading levels" => "Kiwango cha kichwa cha kutumia kwa miundo tata ya tracker inayohitaji ngazi nyingi za kichwa",
// "Section Toggle" => "Section Toggle",
"Default State" => "Hali ya Hitilafu",
// "No toggle" => "No toggle",
"Open" => "Inafungua",
"Closed" => "Ilifungwa",
"Icon" => "Icon",
// "Provide the ability to select an image as an icon attached to the tracker item from the file galleries" => "Provide the ability to select an image as an icon attached to the tracker item from the file galleries",
"Default image" => "Picha ya pekee",
"Path to the default icon used" => "Njia ya Icon ya pekee inayotumiwa",
// "Maximum Icons" => "Maximum Icons",
// "Number of icons to display in each gallery (default 120)" => "Number of icons to display in each gallery (default 120)",
// "Update icon event" => "Update icon event",
// "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items" => "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items",
"Image" => "Picha",
"List image width" => "Upana ya orodha ya picha",
"Display size in pixels" => "Kuonyesha ukubwa katika pixels",
"List image height" => "Urefu ya orodha ya picha",
"Detail image width" => "Upana wa picha ya pekee",
"Detail image height" => "Urefu wa picha ya pekee",
"Maximum image size" => "Upeo wa ukubwa wa picha",
"Maximum image width or height in pixels" => "Upeo wa picha ya upana au urefu katika saizi",
"Shadowbox" => "Shadowbox",
"Shadowbox usage on this field" => "Matumizi ya shadowbox kwenye uwanja huu",
"Do not use" => "Usitumie",
"One box per item" => "Sanduku moja kwa kila kitu",
"Use the same box for all images" => "Tumia sanduku moja kwa picha zote",
"Missing Icon" => "Icon hukosekana",
"Icon to use when no images have been uploaded" => "Icon ya kutumia wakati hakuna picha zilizopakiwa",
"Invalid imagename (using filters for filenames)" => "'Imagename' isiyo sahihi (kwa kutumia chujio kwa majina ya faili)",
"In Group" => "Ndani ya Kundi",
// "Indicate if the user associated with the item is a member of a specified group" => "Indicate if the user associated with the item is a member of a specified group",
"Group Name" => "Jina la kundi",
"Name of the group to verify" => "Jina la kikundi ili kuthibitisha",
"How to display the result" => "Jinsi ya kuonyesha matokeo",
"Yes/No" => "Ndiyo/Hapana",
"Join date" => "Tarehe ya usajili",
"Expiration date" => "Tarehe ya kumalizika",
"IP Selector" => "Uchaguzi wa IP",
"IP address input field" => "Sehemu ya anwani ya IP",
"Auto-assign" => "Weka kwa pekee",
"Automatically assign the value on creation or edit" => "Weka moja kwa moja thamani kwenye uumbaji au uhariri",
"Item Link" => "Kiungo cha kipengee",
"Link to another item, similar to a foreign key" => "Unganisha kipengee kingine, sawa na ufunguo wa kigeni",
"Tracker to link to" => "Tracker kuunganisha na",
"Field ID" => "Kitambulisho cha shamba",
"Default field to display" => "Kipengee cha msingi cha kuonyesha",
"How the link to the item should be rendered" => "Jinsi kiungo kwa kipengee kinapaswa kutolewa",
"Value" => "Thamani",
"Link" => "Kiungo",
"Multiple Fields" => "Mashamba mengi",
// "Display the values from multiple fields instead of a single one" => "Display the values from multiple fields instead of a single one",
// "Format for Customising Multiple Fields" => "Format for Customising Multiple Fields",
// "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"" => "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"",
// "Multiple Fields display type" => "Multiple Fields display type",
// "Display multiple fields as concatenated list in a dropdown or as a table" => "Display multiple fields as concatenated list in a dropdown or as a table",
// "Plugin TrackerList options" => "Plugin TrackerList options",
// "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)" => "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)",
"Limit the available items to a selected set" => "Weka vitu vipatikana kwenye seti iliyochaguliwa",
"Link Page" => "Unganisha Ukurasa",
"Link to a wiki page instead of directly to the item" => "Kiungo kwenye ukurasa wa wiki badala ya moja kwa moja kwenye kipengee",
"Add Items" => "Ongeza Vitu",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
"Add Item Template Page" => "Ongeza Ukurasa wa Kigezo cha Kipengee",
// "Wiki page to use as a Pretty Tracker template" => "Wiki page to use as a Pretty Tracker template",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on the value in this remote field" => "Preselect based on the value in this remote field",
// "Match preselect item to this field ID in the tracker that is being linked to" => "Match preselect item to this field ID in the tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
"Exact Match" => "Mechi sawa",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "Cross select. Load all matching items in the remote tracker" => "Cross select. Load all matching items in the remote tracker",
// "Cross select. Load all matching items in the remote tracker plus wildcards" => "Cross select. Load all matching items in the remote tracker plus wildcards",
// "One item per value" => "One item per value",
// "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items" => "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items",
// "Displays all the items for a same label with a notation value (itemId)" => "Displays all the items for a same label with a notation value (itemId)",
// "Display only one item for each label" => "Display only one item for each label",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Cascade actions" => "Cascade actions",
"Status" => "Hali",
// "Categories and status" => "Categories and status",
"Categories and delete" => "Jamii na kufuta",
// "Delete and status" => "Delete and status",
// "ItemLink: Tracker %0 not found for field \"%1\"" => "ItemLink: Tracker %0 not found for field \"%1\"",
// "ItemLink: Field %0 not found for field \"%1\"" => "ItemLink: Field %0 not found for field \"%1\"",
// "ItemLink field \"%0\": Tracker ID #%1 not found" => "ItemLink field \"%0\": Tracker ID #%1 not found",
// "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status" => "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status",
// "Unsupported field conversion type: from %0 to %1" => "Unsupported field conversion type: from %0 to %1",
"Items List" => "Orodha ya Vitu",
// "Display a list of field values from another tracker that has a relation with this tracker" => "Display a list of field values from another tracker that has a relation with this tracker",
"Tracker from which to list items" => "Tracker kutoka kwa orodha ya vitu",
"Link Field ID" => "Kitambulisho cha Sehemu ya Kiungo",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
"Value Field ID" => "Kitambulisho cha Sehemu ya Thamani",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty",
"Fields to display" => "Mashamba ya kuonyesha",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "Format for customising fields to display" => "Format for customising fields to display",
// "Sort Fields" => "Sort Fields",
// "Order results by one or more fields from the other tracker" => "Order results by one or more fields from the other tracker",
"How the link to the items should be rendered" => "Jinsi kiungo kwa vitu kinapaswa kutolewa",
// "Permission denied importing into linked tracker %0" => "Permission denied importing into linked tracker %0",
// "Errors occurred importing into linked tracker %0" => "Errors occurred importing into linked tracker %0",
// "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
"Date and Time (Date Picker)" => "Tarehe na Muda (Kuchukua ya Tarehe)",
// "Provide a jQuery UI date picker to select a date and, optionally, a time" => "Provide a jQuery UI date picker to select a date and, optionally, a time",
"Default value" => "Thamani ya msingi",
"Default date and time for new items" => "Tarehe ya kutosha na wakati wa vitu vipya",
// "None (undefined)" => "None (undefined)",
// "Item creation date and time" => "Item creation date and time",
"Not before" => "Sio kabla",
// "Field ID from this tracker to compare the value against and validate it is not before that timestamp" => "Field ID from this tracker to compare the value against and validate it is not before that timestamp",
// "Not after" => "Not after",
// "Field ID from this tracker to compare the value against and validate it is not after that timestamp" => "Field ID from this tracker to compare the value against and validate it is not after that timestamp",
// "Date Picker Field: \"%0\" is not a valid internal date value" => "Date Picker Field: \"%0\" is not a valid internal date value",
"%0 cannot be before %1" => "%0 haiwezi kuwa kabla %1",
// "%0 cannot be after %1" => "%0 cannot be after %1",
"Kaltura Video" => "Kaltura Video",
// "Display a series of attached Kaltura videos" => "Display a series of attached Kaltura videos",
// "URL-encoded parameters used in the {kaltura} plugin, for example," => "URL-encoded parameters used in the {kaltura} plugin, for example,",
"Language" => "Lugha",
"Assign a language to the tracker item to enable multilingual trackers" => "Weka lugha kwenye kipengee cha tracker ili kuwawezesha watendaji wa lugha mbalimbali",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
"LDAP" => "LDAP",
"Display a field value from a specific user in LDAP" => "Onyesha thamani ya shamba kutoka kwa mtumiaji maalum katika LDAP",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
"Field name returned by LDAP" => "Jina la shamba limerejeshwa na LDAP",
"DSN" => "DSN",
"Data source name registered in Tiki" => "Jina la chanzo cha data lililosajiliwa katika Tiki",
"Location" => "Eneo",
"Enable a geographic location to be selected for the item and displayed on a map" => "Wezesha eneo la kijiografia kuwachaguliwa kwa kipengee na kuonyeshwa kwenye ramani",
"Use as item location" => "Tumia kama eneo la kipengee",
// "List View Width" => "List View Width",
// "Width of map in pixels when tracker items are shown in list view" => "Width of map in pixels when tracker items are shown in list view",
// "List View Height" => "List View Height",
// "Height of map in pixels when tracker items are shown in list view" => "Height of map in pixels when tracker items are shown in list view",
// "Item View Width" => "Item View Width",
// "Width of map in pixels when a single tracker item is shown" => "Width of map in pixels when a single tracker item is shown",
// "Item View Height" => "Item View Height",
// "Height of map in pixels when a single tracker item is shown" => "Height of map in pixels when a single tracker item is shown",
// "Fields To Search" => "Fields To Search",
// "Fields in this tracker to use as a source to search for a location for" => "Fields in this tracker to use as a source to search for a location for",
// "When To Search" => "When To Search",
// "Event to attempt to search for a location" => "Event to attempt to search for a location",
"Never" => "Kamwe",
"Save (when Location is empty)" => "Hifadhi (wakati Eneo hali tupu)",
"Save (always)" => "Hifadhi (daima)",
// "Indexing (when Location is empty)" => "Indexing (when Location is empty)",
// "Indexing (always)" => "Indexing (always)",
// "Location: Field %0 not found for field \"%1\"" => "Location: Field %0 not found for field \"%1\"",
// "Could not find a location for \"%0\"" => "Could not find a location for \"%0\"",
"When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps" => "Ikiwa imewezeshwa, thamani ya shamba imerekebishwa kama geolocation ya kipengee ili kuonyeshwa kwenye ramani za locator",
"Mathematical Calculation" => "Hesabu ya hisabati",
// "Perform a calculation upon saving the item based on other fields within the same item" => "Perform a calculation upon saving the item based on other fields within the same item",
"Calculation" => "Hesabu",
// "Calculation in the Rating Language" => "Calculation in the Rating Language",
"Re-calculation event" => "Tukio la hesabu",
"Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed" => "Ruhusu kutaja utunzaji maalum wa hesabu. Uteuzi wa indexing ni muhimu kwa maeneo ya alama yenye nguvu ambayo hayaonyeshwa",
"Value will be re-calculated on save. Current value: %0" => "Thamani itarekebishwa tena kwenye salama. Thamani ya sasa: %0",
"Numeric Field" => "Shamba la Hesabu",
"Text to be displayed in front of the numeric value" => "Nakala ya kuonyeshwa mbele ya thamani ya namba",
"Thousands separator when displaying data" => "Maelfu ya separator wakati wa kuonyesha data",
"Page Selector" => "Chagua cha Ukurasa",
// "Allow a selection from the list of pages" => "Allow a selection from the list of pages",
"Will auto-assign the creator of the item" => "itaagiza moja kwa moja Muumba wa kipengee",
"Visible size of the input in characters" => "Ukubwa unaoonekana wa pembejeo kwa wahusika",
"Create Page" => "Unda Ukurasa",
"Create missing pages using the page name in this file as the template" => "Unda kurasa zilizopo kwa kutumia jina la ukurasa katika faili hii kama mfano",
"Display the value as a link to the page" => "Onyesha thamani kama kiungo kwenye ukurasa",
"Rating" => "Upimaji",
// "A rating of the tracker item. Permissions involved: %0" => "A rating of the tracker item. Permissions involved: %0",
"The possible options (comma-separated integers) for the rating" => "Chaguo linalowezekana (namba zilizoteuliwa kwa comma) kwa kupima",
"Mode" => "Njia",
// "Display rating options as" => "Display rating options as",
"Stars" => "Ma nyota",
"Single Option: for example, Like" => "Chaguo moja: kwa mfano, Kama",
"Labels" => "Maandiko",
// "The text labels (comma-separated) for the possible options" => "The text labels (comma-separated) for the possible options",
"Stars (deprecated)" => "Nyota (zilizopunguzwa)",
// "Display a star rating" => "Display a star rating",
"A possible option for the rating" => "Chaguo linalowezekana kwa kupima",
// "Stars (system - deprecated)" => "Stars (system - deprecated)",
"Average" => "Wastani",
"Number of votes" => "Idadi ya kura",
"Your rating" => "Kupiga kura kwako",
"Relations" => "Uhusiano",
// "Allow arbitrary relations to be created between the trackers and other objects in the system" => "Allow arbitrary relations to be created between the trackers and other objects in the system",
"Relation" => "Uhusiano",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
"Format" => "Muundo",
// "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field" => "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field",
"Read-only" => "Soma tu",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
// "Control how the relations are displayed in view mode" => "Control how the relations are displayed in view mode",
"List" => "Orodha",
"Count" => "Hesabu",
// "Count with toggle for list" => "Count with toggle for list",
// "Force Refresh" => "Force Refresh",
// "Re-save related tracker items" => "Re-save related tracker items",
// "On Save" => "On Save",
// "Extra Filter Field" => "Extra Filter Field",
// "Filter objects by value of another field. Use a jQuery seletor to target the element in the page" => "Filter objects by value of another field. Use a jQuery seletor to target the element in the page",
// "Extra Filter Key" => "Extra Filter Key",
// "Key to filter objects by using the value from the Extra Filter Field above" => "Key to filter objects by using the value from the Extra Filter Field above",
// "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save" => "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save",
"and" => "na",
// "show.tiki.org" => "show.tiki.org",
// "Create, display or manage show.tiki.org instances" => "Create, display or manage show.tiki.org instances",
// "Domain name of show server" => "Domain name of show server",
// "For example, show.tikiwiki.org" => "For example, show.tikiwiki.org",
// "Supported Versions" => "Supported Versions",
// "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"" => "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"",
// "Shell username on remote server" => "Shell username on remote server",
// "The shell username on the show server" => "The shell username on the show server",
// "Public key file path" => "Public key file path",
// "System path to public key on local server. Only RSA keys are supported" => "System path to public key on local server. Only RSA keys are supported",
// "Private key file path" => "Private key file path",
// "System path to private key on local server. Only RSA keys are supported" => "System path to private key on local server. Only RSA keys are supported",
// "Show debugging information" => "Show debugging information",
// "Show debugging info during testing" => "Show debugging info during testing",
"Fixed user ID" => "Kitambulisho cha mtumiaji zisizohamishika",
// "Set fixed user ID instead of using the user ID of the creator of the tracker item" => "Set fixed user ID instead of using the user ID of the creator of the tracker item",
"Static Text" => "Nakala imara",
// "Display the field description as static text to present notes or additional instructions" => "Display the field description as static text to present notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
"Indicates if the description should be parsed as wiki syntax for formatting" => "Inabainisha ikiwa maelezo yanapaswa kufutwa kama syntax ya wiki ya kupangilia",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Wiki Parse with Pretty Tracker replacements" => "Wiki Parse with Pretty Tracker replacements",
"Maximum Length (List)" => "Urefu ya mwisho (Orodha)",
"Maximum number of characters to be displayed in list mode" => "Idadi kubwa ya wahusika ilionyeshwa katika orodha ya orodha",
"Text Field" => "Nakala ya maandishi",
"Single-line text input" => "Uingizaji wa maandishi ya moja kwa moja",
// "Display the field name and input on the same row" => "Display the field name and input on the same row",
"Visible size of the field, in characters" => "Ukubwa unaoonekana wa shamba, kwa wahusika",
"Text to prepend when displaying the value" => "Nakala ya kujiunga wakati wa kuonyesha thamani",
// "Text to append when displaying the value" => "Text to append when displaying the value",
"Maximum Length" => "Urefu ya mwisho",
"Maximum amount of characters to store" => "Upeo wa wahusika wa kuhifadhi",
"Autocomplete" => "Kuingia kwa moja kwa moja",
"Enable autocompletion while typing in the field" => "Wezesha kujitegemea wakati wa kuandika kwenye shamba",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
// "Full-text search of the content of the field" => "Full-text search of the content of the field",
// "Search for a value prefix" => "Search for a value prefix",
// "Search for a precise value" => "Search for a precise value",
// "Full-text search in the current language" => "Full-text search in the current language",
// "Full-text search in a specific language (%0)" => "Full-text search in a specific language (%0)",
// "%0 (any language)" => "%0 (any language)",
// "Full-text search in any language" => "Full-text search in any language",
"Text Area" => "Sanduku la maandishi",
"Multi-line text input" => "Uingizaji wa maandishi mengi",
"Toolbars" => "Vyombo vya zana",
"Enable the toolbars as syntax helpers" => "Wezesha toolbars kama wasaidizi wa syntax",
"Disable" => "Kuzima",
"Enable" => "Kuwawezesha",
"Width" => "Upana",
"Size of the text area, in characters" => "Ukubwa wa eneo la maandishi, kwa wahusika",
"Height" => "Urefu",
"Size of the text area, in lines" => "Ukubwa wa eneo la maandishi, katika mistari",
"Character Limit" => "Idadi ya wahusika",
"Maximum number of characters to be stored" => "Idadi kubwa ya wahusika kuhifadhiwa",
"Display Limit (List)" => "Onyesha Kupunguza (Orodha)",
"Maximum number of characters to be displayed in list mode before the value gets truncated" => "Idadi kubwa ya wahusika ili kuonyeshwa katika orodha ya orodha kabla ya thamani inapatikana",
"Word Count" => "Idadi ya maneno",
"Limit the length of the text, in number of words" => "Weka urefu wa maandishi, kwa idadi ya maneno",
"Distinct Values" => "Maadili ya tofauti",
"All values in the field must be different" => "Maadili yote katika shamba lazima iwe tofauti",
"Use WYSIWYG" => "Tumia WYSIWYG",
"Use a rich text editor instead of inputting plain text" => "Tumia mhariri wa maandishi tajiri badala ya kuingiza maandiko wazi",
"Word Limit Exceeded" => "Ukomo wa Neno ulizidi",
"Character Limit Exceeded" => "Idadi ya wahusika imezidi",
// "Create a link to a specified URL" => "Create a link to a specified URL",
"How the URL should be rendered" => "Jinsi URL inapaswa kutolewa",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "Text as link (see Other)" => "Text as link (see Other)",
// "Label of the link text. Requires \"Display\" to be set to \"Text as link\"" => "Label of the link text. Requires \"Display\" to be set to \"Text as link\"",
// "Display the list of groups for the user associated with the tracker items" => "Display the list of groups for the user associated with the tracker items",
// "Show direct groups memberships only" => "Show direct groups memberships only",
// "Do not show inherited/included groups" => "Do not show inherited/included groups",
// "Specify Fields" => "Specify Fields",
// "Get the groups for users from these fields, not the \"owner\" user fields" => "Get the groups for users from these fields, not the \"owner\" user fields",
"User Preference" => "Upendeleo wa Mtumiaji",
// "Allow user preference changes from a tracker" => "Allow user preference changes from a tracker",
// "Preference Name" => "Preference Name",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
"User Selector" => "Chagua mtumiaji",
// "Allow the selection of a user or users from a list" => "Allow the selection of a user or users from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Item Owner" => "Item Owner",
// "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker" => "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker",
// "Send an email notification to the user(s) every time the item is modified" => "Send an email notification to the user(s) every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Notification Template" => "Notification Template",
// "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)" => "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)",
// "Email Format" => "Email Format",
// "Choose between values text or html, depending on the syntax in the template file that will be used" => "Choose between values text or html, depending on the syntax in the template file that will be used",
"text" => "maandishi",
"html" => "html",
// "Multiple selection" => "Multiple selection",
// "Allow selection of multiple users from the list" => "Allow selection of multiple users from the list",
// "Yes (complete list)" => "Yes (complete list)",
// "Yes (filterable by group)" => "Yes (filterable by group)",
"Group IDs" => "Vitambulisho vya Kikundi",
"Limit the list of users to members of specific groups" => "Weka orodha ya watumiaji kwa wanachama wa vikundi maalum",
// "Groups that can modify autoassigned values" => "Groups that can modify autoassigned values",
// "List of group IDs who can change this field, even without tracker_admin permission" => "List of group IDs who can change this field, even without tracker_admin permission",
// "Show real name if possible" => "Show real name if possible",
// "User \"%0\" not found" => "User \"%0\" not found",
"User Subscription" => "Usajili wa Mtumiaji",
// "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item" => "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item",
"Webservice" => "Webservice",
// "Display the result of a registered webservice call" => "Display the result of a registered webservice call",
"Service Name" => "Jina la Huduma",
"Webservice name as registered in Tiki" => "Jina la webservice limeandikishwa katika Tiki",
"Template Name" => "Jina la Mfano",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name",
// "Require parameters" => "Require parameters",
// "Do not execute the request if parameters are missing or empty" => "Do not execute the request if parameters are missing or empty",
// "All required" => "All required",
// "(default)" => "(default)",
// "First only required" => "First only required",
// "No parameters required" => "No parameters required",
// "Cache time" => "Cache time",
// "Time in seconds to cache the result for before trying again" => "Time in seconds to cache the result for before trying again",
"Read only" => "Soma tu",
// "Webservice %0 not found" => "Webservice %0 not found",
// "Webservice template %0 not found" => "Webservice template %0 not found",
// "Unknown webservice error (code: %0)" => "Unknown webservice error (code: %0)",
// "Unknown webservice error" => "Unknown webservice error",
// "Data too long for Webservice field %0 with %1" => "Data too long for Webservice field %0 with %1",
// "Error updating Webservice field %0" => "Error updating Webservice field %0",
// "Embed an associated wiki page" => "Embed an associated wiki page",
// "Field that is used for Wiki Page Name" => "Field that is used for Wiki Page Name",
// "Field to get page name to create page name with" => "Field to get page name to create page name with",
// "Namespace for Wiki Page" => "Namespace for Wiki Page",
// "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information" => "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information",
// "Default (trackerfield<fieldId>)" => "Default (trackerfield<fieldId>)",
// "No namespace" => "No namespace",
// "Custom namespace" => "Custom namespace",
// "Custom Namespace" => "Custom Namespace",
// "The custom namespace to use if the custom option is selected" => "The custom namespace to use if the custom option is selected",
// "Rename Wiki Page when changed in tracker" => "Rename Wiki Page when changed in tracker",
// "Rename associated wiki page when the field that is used for Wiki Page Name is changed" => "Rename associated wiki page when the field that is used for Wiki Page Name is changed",
// "Delete Wiki Page when tracker item is deleted" => "Delete Wiki Page when tracker item is deleted",
// "Delete associated wiki page when the tracker item is deleted" => "Delete associated wiki page when the tracker item is deleted",
"Action Buttons" => "Vifungo vya Hatua",
"Display wiki page buttons when editing the item" => "Tazama vifungo kwenye ukurasa wa Wiki wakati uhariri kipengee",
"Remove Bad Chars" => "Ondoa Bad Chars",
"Remove bad characters from the Wiki Page name" => "Ondoa wahusika mbaya kutoka kwa Jina la Wiki ukurasa",
// "The page name provided already exists. Please choose another" => "The page name provided already exists. Please choose another",
// "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1" => "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1",
// "Missing Page Name field #%0 for Wiki field #%1" => "Missing Page Name field #%0 for Wiki field #%1",
// "Page \"%0\" already exists. Not overwriting" => "Page \"%0\" already exists. Not overwriting",
// "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)" => "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)",
// "Look up a single item by ID" => "Look up a single item by ID",
"Search" => "Tafuta",
// "Full-text search across all of the content" => "Full-text search across all of the content",
// "Modification Date" => "Modification Date",
"Unknown value" => "Thamani isiyojulikana",
// "Modified Date" => "Modified Date",
"Actions" => "Vitendo",
"Dynamic Filters" => "Filters Dynamic",
"From %0 to %1" => "Kutoka %0 kwa %1",
// "Field not found: %0" => "Field not found: %0",
// "Filter mode not found: %0 for %1" => "Filter mode not found: %0 for %1",
// "Field mode not found: %0 for %1" => "Field mode not found: %0 for %1",
// "Primary Key fields cannot be read-only" => "Primary Key fields cannot be read-only",
// "Column \"%0\" cannot co-exist with \"%1\"" => "Column \"%0\" cannot co-exist with \"%1\"",
// "Column \"%0:%1\" found multiple times" => "Column \"%0:%1\" found multiple times",
// "Primary key already defined" => "Primary key already defined",
// "Not enough columns, expecting \"%0\"" => "Not enough columns, expecting \"%0\"",
// "Header \"%0\" found where \"%1\" was expected" => "Header \"%0\" found where \"%1\" was expected",
// "Header \"%0\" found where ignored column was expected" => "Header \"%0\" found where ignored column was expected",
// "new tracker(s) item(s) created" => "new tracker(s) item(s) created",
// "tracker(s) item(s) updated" => "tracker(s) item(s) updated",
"Line %0" => "Mstari %0",
// "duplicate entry" => "duplicate entry",
// "duplicate entry for unique column %0" => "duplicate entry for unique column %0",
// "Import file contains errors. Please review and fix before importing" => "Import file contains errors. Please review and fix before importing",
// "Primary Key not defined" => "Primary Key not defined",
"Create page" => "Unda ukurasa",
"Plugin execution pending approval" => "Plugiciel en attente d'approbation",
"Edit plugin" => "Badilisha Plugin",
// "Wiki page pagination has not been enabled" => "Wiki page pagination has not been enabled",
// "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"" => "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"",
"Internal error" => "Hitilafu ya ndani",
"User error" => "Hitilafu ya mtumiaji",
"Plugin argument(s) missing" => "Funguo la Plugin haipo",
"Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> haiwezi kutekelezwa",
"Set" => "Kuchagua",
"Plugin disabled" => "Plugin imezimwa",
"Edit Plugin" => "Badilisha Plugin",
// "Unable to locate cryptphrase" => "Unable to locate cryptphrase",
"Single Container" => "Bootstrap ya Msingi",
// "Classic Tiki (3 containers - header, middle, footer)" => "Classic Tiki (3 containers - header, middle, footer)",
// "Classic Bootstrap (fixed top navbar)" => "Classic Bootstrap (fixed top navbar)",
"Line" => "Mstari",
"Lines" => "Mistari",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: idadi tofauti ya mistari: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check : imeshindwa",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check : hariri mlolongo sio mojawapo",
"WikiDiff Okay: LCS = %s" => "WikiDiff Sawa : LCS = %s",
// "Problem setting user for \"%0\"" => "Problem setting user for \"%0\"",
// "Problem setting group for \"%0\"" => "Problem setting group for \"%0\"",
// "Problem setting mode for \"%0\"" => "Problem setting mode for \"%0\"",
// "Upload was not successful for \"%0\"" => "Upload was not successful for \"%0\"",
// "Subgallery number to galleryId error: Too many subdirs (%0)</span>" => "Subgallery number to galleryId error: Too many subdirs (%0)</span>",
// "Subgallery number to galleryId error: Not an integer (%0)</span>" => "Subgallery number to galleryId error: Not an integer (%0)</span>",
// "Subgallery number to galleryId error: Gallery with ID %0 not found</span>" => "Subgallery number to galleryId error: Gallery with ID %0 not found</span>",
// "Created by batch upload by user \"%0\" on %1" => "Created by batch upload by user \"%0\" on %1",
// "Create gallery \"%0\" failed</span>" => "Create gallery \"%0\" failed</span>",
// "No permsission to create gallery \"%0\"</span>" => "No permsission to create gallery \"%0\"</span>",
// "Gallery \"%0\" not found</span>" => "Gallery \"%0\" not found</span>",
"Upload was successful" => "Upakiaji ulifanikiwa",
"File %s removed from Batch directory." => "Faili %s yeye ameondolewa kwenye saraka ya Batch.",
"Impossible to remove file %s from Batch directory." => "Haiwezekani kuondoa faili %s kutoka kwenye saraka ya Batch.",
"Invalid directory name" => "Jina la saraka batili",
// "Move was not successful for \"%0\"" => "Move was not successful for \"%0\"",
// "Copy was not successful for \"%0\"" => "Copy was not successful for \"%0\"",
// "Move was successful" => "Move was successful",
// "Copy was successful" => "Copy was successful",
// "Cannot write to this path: " => "Cannot write to this path: ",
// "Cannot read this file: " => "Cannot read this file: ",
// "Cannot remove file from gallery" => "Cannot remove file from gallery",
// "Migrated Image Galleries" => "Migrated Image Galleries",
// "Converted from image gallery" => "Converted from image gallery",
"My Files" => "Faili zangu",
// "Files of %0" => "Files of %0",
"Cannot open this file" => "Haiwezi kufungua faili hii",
" copy" => " nakala",
// "Processing search text from a \"%0\" file in gallery #%1" => "Processing search text from a \"%0\" file in gallery #%1",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "Nyumba ya sanaa ya mafaili",
"The upload was not completed" => "Upakiaji haujakamilishwa",
"Reason: The global quota has been reached" => "Sababu: Kiwango cha kimataifa kilifikia",
"Reason: The quota has been reached in \"%s\"" => "Sababu: Upendeleo umefikia kwenye \"%s\"",
"File gallery quota exceeded" => "Faili ya nyumba ya sanaa imepita",
"Number of files transferred to the database" => "Idadi ya faili zilizohamishiwa kwenye database",
"Number of files transferred to the file system" => "Idadi ya faili zilizohamishwa kwenye mfumo wa faili",
"Old File deleted" => "Faili ya Kale imefutwa",
"Incorrect param" => "Kipimo cha batili",
"You do not have permission to remove files from this gallery" => "Huna idhini ya kuondoa faili kutoka kwenye nyumba hii ya sanaa",
"Warning: The file is used in" => "Kionyo: faili inatumiwa",
"You are trying to edit multiple files in different galleries, which is not supported yet" => "Unajaribu kuhariri faili nyingi katika nyumba tofauti, ambazo hazijasaidiwa bado",
"The specified file does not exist" => "Faili maalum haipo",
"Upload was not successful" => "Upakiaji haukufanikiwa",
"An exception occurred" => "Tofauti ilitokea",
"Batch file processed" => "Faili ya Batch ilichukuliwa",
"Errors detected" => "Hitilafu zimegunduliwa",
"Check that these paths exist and are writable by the web server" => "Angalia kwamba njia hizi zipo na zinaandikwa na seva ya wavuti",
"File added: " => "Faili imeongezwa: ",
"Cannot read the file" => "Haiwezi kusoma faili",
"Warning: Empty file" => "Kionyo: Faili tupu",
"Please re-upload the file" => "Tafadhali rejesha tena faili",
"The upload was not successful due to duplicate file content" => "Upakiaji haukufanikiwa kutokana na maudhui faili mara mbili",
// "Files uploaded" => "Files uploaded",
// "File \"%0\" uploaded" => "File \"%0\" uploaded",
"File update was successful" => "Mafanikio ya sasisho la faili",
"Automatic revision from source" => "Marekebisho ya moja kwa moja kutoka chanzo",
// "Images successfully moved to file gallery %0" => "Images successfully moved to file gallery %0",
// "Images could not be opened or uploaded" => "Images could not be opened or uploaded",
// "No changes were made since no images in wiki_up were found in Wiki pages" => "No changes were made since no images in wiki_up were found in Wiki pages",
// "No images found" => "No images found",
// "%0 on page %1 could not be opened" => "%0 on page %1 could not be opened",
// "%0 on page %1 could not be uploaded into the file gallery" => "%0 on page %1 could not be uploaded into the file gallery",
// "%0 used on page %1 was moved and given the file ID %2" => "%0 used on page %1 was moved and given the file ID %2",
// "Forcing a filetype of image/svg+xml is blocked for security reasons" => "Forcing a filetype of image/svg+xml is blocked for security reasons",
// "SVG files are not safe and cannot be uploaded" => "SVG files are not safe and cannot be uploaded",
// "PHP Zip extension not found, reqiuired for Feature H5P" => "PHP Zip extension not found, reqiuired for Feature H5P",
// "PHP Class \"ZipArchive\" not found" => "PHP Class \"ZipArchive\" not found",
// "Missing content parameters" => "Missing content parameters",
// "Invalid content parameters" => "Invalid content parameters",
// "Missing title" => "Missing title",
// "Title is too long. Must be 256 letters or shorter" => "Title is too long. Must be 256 letters or shorter",
// "Invalid content type" => "Invalid content type",
"Created by H5P" => "Imeundwa na H5P",
// "The chosen content type isn't installed" => "The chosen content type isn't installed",
"This is an approximation based on your server memory limit" => "Hii ni takriban kulingana na kikomo chako cha kumbukumbu ya seva",
"This is the value of your server's PHP '%s' setting" => "Hii ni thamani ya mpangilio wa PHP '%s' ya seva yako",
// "Not a git repository" => "Not a git repository",
// "Branch \"%s\" not found" => "Branch \"%s\" not found",
// "Can't get Git object file" => "Can't get Git object file",
// "Goal achieved" => "Goal achieved",
// "Event Count" => "Event Count",
// "Event Count (Forever)" => "Event Count (Forever)",
// "Goal Reached (Periodic)" => "Goal Reached (Periodic)",
// "Goal Reached (Forever)" => "Goal Reached (Forever)",
// "Has Badge" => "Has Badge",
// "Add One-Time Badge" => "Add One-Time Badge",
// "%0 Badge" => "%0 Badge",
// "Remove One-Time Badge" => "Remove One-Time Badge",
// "%0 Badge (Remove)" => "%0 Badge (Remove)",
"Credits" => "Mikopo",
// "%0 credit(s) - %1" => "%0 credit(s) - %1",
// "Unknown credit type" => "Unknown credit type",
"You are alerted by the server " => "Unaelezwa na seva ",
"You can check the modifications at: " => "Unaweza kuangalia marekebisho:",
"You are alerted of a change on " => "Unatambuliwa kuhusu mabadiliko ",
// "JavaScript file \"%0\" cannot be found so will not be minified" => "JavaScript file \"%0\" cannot be found so will not be minified",
"No image yet, sorry." => "Hakuna picha bado, pole.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directory isiyojulikana ya marudio. Tafadhali ingia ndani <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "unlink imeshindwa",
"The uploaded file exceeds the upload_max_filesize directive in php.ini" => "Faili iliyopakiwa inazidi maelekezo ya upload_max_filesize katika php.ini",
"The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "Faili iliyopakiwa imezidi maagizo MAX_FILE_SIZE yaliyowekwa katika form ya HTML",
"The uploaded file was only partially uploaded. Please try again" => "Faili iliyopakiwa ilipakiwa kwa sehemu tu. Tafadhali jaribu tena",
"No file was uploaded" => "Hakuna faili iliyopakiwa",
"Missing a temporary folder" => "Inakosa folda ya muda mfupi",
"Failed to write file to disk" => "Imeshindwa kuandika faili kwenye diski",
"File upload stopped by extension" => "Faili ya kupakia imesimama kwa ugani",
"Set new blog as Tiki homepage" => "Weka blog mpya kama Tiki homepage",
"Importation completed" => "Uagizaji umekamilika",
"<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Bonyeza hapa</a> ili kumaliza mchakato wa kuagiza",
"Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Ilipatikana: %0 machapisho, %1 kurasa, %2 vitambulisho na %3 makundi. Kuwaingiza katika Tiki",
"Item \"%0\" NOT imported (there was already a item with the same name)" => "Kipengee \"%0\" haijaagizwa (tayari kulikuwa na kitu ambacho kina jina moja)",
"Page \"%0\" sucessfully imported" => "Ukurasa \"%0\" umeagizwa kwa bidii",
"Post \"%0\" sucessfully imported" => "Chapisha \"%0\" imeagizwa kwa bidii",
"Import images and other attachments" => "Ingiza picha na vifungo vingine",
"Update internal links (experimental)" => "Sasisha viungo vya ndani (majaribio)",
"Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)" => "Pendekeza .htaccess sheria kurekebisha kutoka URL ya zamani WordPress kwa Tiki URLs mpya (majaribio)",
"Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Darasa la DOMDocument haipatikani, angalia ufungaji wako wa PHP. Kwa maelezo zaidi ona http://php.net/manual/en/book.dom.php",
"Invalid file MIME type" => "Aina ya faili ya MIME isiyo sahihi",
"There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information" => "Kulikuwa na hitilafu wakati wa kupakia faili ya XML. Pengine faili ya XML haifai. Baadhi ya matoleo ya WordPress yanazalisha fomu ya XML iliyosababishwa. Angalia nyaraka za kuingiza Tiki kwa habari zaidi",
"Invalid WordPress XML file" => "Faili isiyo ya kawaida ya WordPress XML",
"No attachments found to import" => "Hakuna viambatisho vilivyopatikana kuingizwa",
"Importing attachments" => "Kuagiza viambatisho",
"Attachment %0 successfully imported" => "Kiambatisho %0 imeingizwa kwa mafanikio",
"Unable to download attachment %0. Error message was: %1 %2" => "Imeshindwa kupakua kiambatisho %0. Ujumbe wa hitilafu ulikuwa: %1 %2",
"%0 attachments imported and %1 errors" => "Viambatisho %0 vinavyoingizwa na %1 makosa",
"Page \"%0\" successfully extracted" => "Ukurasa \"%0\" imefutwa kwa ufanisi",
"Post \"%0\" successfully extracted" => "Chapisha \"%0\" kwa ufanisi kufutwa",
"Extracting data from XML file" => "Kuchukua data kutoka faili ya XML",
"Number of page revisions to import (0 for all revisions):" => "Idadi ya marekebisho ya ukurasa kuagiza (0 kwa marekebisho yote): ",
"What to do with page names that already exists in Tiki?" => "Nini cha kufanya na majina ya ukurasa ambayo tayari yamepo katika Tiki?",
"Do not import" => "Usiingize",
"Override" => "Undeshe",
"Prepend software name as a prefix to the page name" => "Weka jina la programu kama kiambishi kwa jina la ukurasa",
"Page %0 sucessfully imported" => "Ukurasa %0 umeagizwa kwa urahisi",
"Page %0 NOT imported (there was already a page with the same name)" => "Ukurasa wa %0 haukuingizwa (tayari kulikuwa na ukurasa unao jina)",
"%0 pages parsed. Starting to insert those pages into Tiki" => "Kurasa %0 zimefutwa. Kuanza kuingiza kurasa hizo katika Tiki",
"Import images and attachments (see documentation for more information)" => "Ingiza picha na vifungo (angalia nyaraka za maelezo zaidi)",
"Add a maketoc at the top of each page" => "Ongeza maketoc juu ya kila ukurasa",
"The XML file does not validate against the MediaWiki XML schema" => "Faili ya XML haina kuthibitisha dhidi ya schema MediaWiki XML",
"Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments" => "Kuondoka: saraka ya marudio kwa viambatisho (%0) haipo. Sawa tatizo hili au jaribu kuagiza bila viambatisho.",
"Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments" => "Kuondoka: saraka ya marudio kwa viambatisho (%0) sio kuandika. Sawa tatizo hili au jaribu kuagiza bila viambatisho.",
"File %0 is not being imported because there is already a file with the same name in the destination directory (%1)" => "Uingizaji usiowezekana wa faili %0 kwa sababu tayari kuna faili ya jina moja katika saraka ya marudio (%1)",
"File %0 successfully imported" => "Faili %0 imeingizwa kwa mafanikio",
"Unable to download file %0. File not found" => "Haiwezi kupakua faili %0. Faili halijapatikana",
"Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer" => "Erreur lors de l'analyse de la révision %0 de la page \"%1\". Ou il y a un problème dans la syntaxe de la page ou dans l'analyseur Text_Wiki (l'analyseur utilisé par l'importateur)",
"Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" analysée avec succès avec %1 révisions (sur un total de %2 révisions)",
"Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" ne sera PAS importée. Il n'a pas été possible d'analyser n'importe laquelle de ses révision.",
"MediaWiki XML file version %0 is not supported" => "Le fichier XML Médiawiki version %0 n'est pas supporté",
"Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "Échec; Vous devez activer le réglage PHP 'allow_url_fopen' pour pouvoir importer les pièces jointes. Réglez le problème ou essayez d'importer sans les pièces jointes",
"Parsing pages" => "Analyse des pages",
"No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments" => "Aucune pièce jointe à importer ! Vérifiez quevous avez créé votre fichier XML avec le script dumpDump.php et avec l'option --uploads. C'est la seule façon d'importer des pièces jointes",
// "Invalid template name: %0" => "Invalid template name: %0",
// "Unnamed file" => "Unnamed file",
"string" => "mlolongo",
"Unknown language" => "Lugha isiyojulikana",
"Error: unable to write to lang/%s/language.php" => "Hitilafu: hawezi kuandikalang/%s/language.php",
"The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again" => "Faili lang/%0/language.php haipangiliwa kwa usahihi. kufanya get_strings.php?lang=%0 na kisha jaribu kuuza nje tafsiri tena",
"Contributions" => "michango",
// "reverted" => "reverted",
"section level 0" => "ngazi ya sehemu ya 0",
"sorted section level 0" => "ngazi ya sehemu iliyopangwa 0",
"section level 1" => "ngazi ya sehemu ya 1",
"section level 2" => "ngazi ya sehemu ya 2",
"section level 3" => "ngazi ya sehemu ya 3",
"option" => "chaguo",
"separator" => "unaojiingiza",
"You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu" => "Unaweza kutumia chaguoId = 0 ili kuunda chaguo jipya; au, ili kuboresha menyu, tumia chaguoKiyo ni sawa na chaguoId ambayo tayari imetumiwa kwenye menyu",
"menu" => "rodha",
"NONE" => "Wenye",
// "(values not interpreted)" => "(values not interpreted)",
// "Unknown Field: " => "Unknown Field: ",
// "duplicate fields do not match" => "duplicate fields do not match",
"Description not available" => "Maelezo haipatikani",
"Module Title" => "Kichwa cha moduli",
"Title to display at the top of the box" => "Kichwa cha kuonyesha juu ya sanduku",
"No Box" => "Hakuna sanduku",
"Show only the content" => "Onyesha maudhui tu",
"Title, background, etcs" => "mapambo",
"Show module decorations" => "Onyesha mapambo ya moduli",
"No Title" => "Hakuna Title",
// "Hide module title" => "Hide module title",
"Module displayed depending on category. Separate multiple category IDs or names by semi-colons" => "Moduli inayoonyeshwa kulingana na jamii. Vidokezo vingi au majina ya kikundi vinaweza kutenganishwa na ':'",
"No Category" => "Hakuna Jamii",
"Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above" => "Moduli inayoonyeshwa kulingana na jamii. Vidokezo vingi au majina ya kikundi vinaweza kutenganishwa na ':'. Hii inakaribia parameter ya 'Jamii' hapo juu",
// "Category subtrees" => "Category subtrees",
// "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)" => "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)",
"Perspective" => "mtazamo",
"Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons" => "Onyesha moduli tu katika moja ya mitazamo zilizoonyeshwa na ID yao. Kinachotenganishwa na semicolons",
"Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons" => "Moduli inatumika tu kwa lugha maalum. Lugha zinaelezwa na msimbo wa barua mbili. Maadili mengi hutenganishwa na semicolons",
"Section" => "sehemu",
// "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page" => "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page",
"Page Filter" => "Ficha ya Ukurasa",
"Module is displayed only on the specified page(s). Separate multiple page names by semi-colons" => "Moduli inatumika tu kwa majina maalum ya ukurasa wa sehemu. Maadili mengi yanaweza kutengwa na semicolons",
"No Page" => "Hakuna Ukurasa",
"Module is not displayed on the specified page(s). Separate multiple page names by semi-colons" => "Moduli haipatikani kwa majina ya ukurasa maalum. Maadili mengi yanaweza kutengwa na semicolons",
"Theme" => "Mandhari",
"Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons" => "Mfumo ulioamilishwa au la kutegemea jina la faili ya mandhari (Ex. : \"thenews.css\").Mandhari maalum zinaweza kuingizwa au kutengwa. Mandhari hutafakari prefixed na \"!\" hutolewa. Maadili mengi yanaweza kutengwa na semicolons",
"Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Moduli inapatikana tu kulingana na uhusiano wa mtumiaji na ukurasa wa wiki. Washiriki tu (y) au wasio wachangiaji tu (n) wataona moduli",
"Contributor" => "Mchangiaji",
"Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Moduli inapatikana tu kulingana na uhusiano wa mtumiaji na ukurasa wa wiki. Washiriki tu (y) au wasio wachangiaji tu (n) wataona moduli",
"Flip" => "kujificha",
"Users can open and close the module" => "Watumiaji wanaweza kufungua na kufunga moduli",
"Style" => "Sinema",
"CSS style attribute (for example, to position the module)" => "Tabia ya mtindo wa CSS (kwa mfano, kuweka nafasi ya moduli)",
"Class" => "Darasa",
// "Extra class (for CSS or JavaScript)" => "Extra class (for CSS or JavaScript)",
// "Containing Class" => "Containing Class",
// "Custom CSS class of div around the module" => "Custom CSS class of div around the module",
// "Cookie Consent" => "Cookie Consent",
// "Show only if consent to accept cookies has been granted" => "Show only if consent to accept cookies has been granted",
"No Numbers" => "Hakuna Hesabu",
"If set to \"y\", the module will not number list items" => "Ikiwa imewekwa \"y\", moduli haitahesabu idadi ya orodha",
"Rows" => "Max. ya safu \n(ikiwa inafaa kwa moduli)",
"Number of rows, or items, to display" => "Idadi ya safu, au vitu, ili kuonyesha",
"Default: 10" => "Mchapishaji: 10",
"Failed to execute \"%0\" module" => "Imeshindwa kuendesha moduli \"%0\"",
// "Missing dependencies" => "Missing dependencies",
"Contact the system administrator" => "Wasiliana na msimamizi wa mfumo",
// "Module file \"%0\" not found" => "Module file \"%0\" not found",
"Newsletter subscription information at" => " Habari juu ya jarida inapatikana ",
// "Cannot add subscribers from a newsletter that includes this newsletter's subscribers" => "Cannot add subscribers from a newsletter that includes this newsletter's subscribers",
// " after sending to" => " after sending to",
// " after error in sending to" => " after error in sending to",
// " after failure to send to" => " after failure to send to",
// "Error - potential cross site request forgery detected" => "Error - potential cross site request forgery detected",
// "Potential cross site forgery request detected" => "Potential cross site forgery request detected",
"Limiting the email send rate. Resuming in %0 seconds" => "Inapunguza kiwango cha kutuma barua pepe. Inarudi kwa %0 sekunde",
"Newsletter successfully sent to %s users" => "Barua ya habari imetumwa kwa watumiaji %s kwa ufanisi ",
"Number of errors: %s" => "Kulikuwa na makosa ya %s",
// "End of last article" => "End of last article",
// "potential CSRF" => "potential CSRF",
"invalid email" => "email batili",
"A user registers" => "Mtumiaji amesajiliwa",
"A user submits an article" => "Mtumiaji anawasilisha makala",
"A user edits an article" => "Mtumiaji anabadilisha makala",
"A user deletes an article" => "Mtumiaji huondoa makala",
"An article is submitted, edited, deleted or commented on." => "Makala yamewasilishwa, yamebadilishwa, imefutwa au ilitiwa maoni.",
"A new blog post is published" => "Chapisho jipya la blogu ni mtandaoni",
// "A blog post comment is posted or edited" => "A blog post comment is posted or edited",
"A wiki page is created, deleted or edited, except for minor changes." => "Ukurasa wa wiki umeundwa, umebadilishwa, au kufutwa ila kwa mabadiliko madogo.",
"A wiki page is created, deleted or edited, even for minor changes." => "Ukurasa wa wiki umeundwa, umebadilishwa au kufutwa, hata kwa mabadiliko madogo.",
"A wiki page comment is posted or edited" => "Maoni katika ukurasa wa Wiki yamepelekwa au kubadilishwa",
"An article comment is posted or edited" => "Maoni juu ya makala yamechapishwa au kubadilishwa",
"Token is called" => "Ishara imeitwa",
"User joins a group" => " Mtumiaji anajiunga na kikundi",
// "User's comment is replied" => "User's comment is replied",
"Category change in a language" => "Un changement de catégorie dans une langue",
"A new page is created in a language" => "Ukurasa mpya umeundwa kwa lugha moja",
// "Cannot save invalid client" => "Cannot save invalid client",
// "Name cannot be empty" => "Name cannot be empty",
// "Redirect URI cannot be empty" => "Redirect URI cannot be empty",
// "Invalid URL for redirect URI" => "Invalid URL for redirect URI",
"section edit" => "toleo la sehemu",
// "Engine \"%0\" not found" => "Engine \"%0\" not found",
// "Output converter \"%0\" not found" => "Output converter \"%0\" not found",
// "Parsed Data" => "Parsed Data",
"Data" => "yaliyomo",
// "Mapping" => "Mapping",
"Edit Section" => "Badilisha sehemu hii",
"index" => "index",
"Table of contents" => "Jedwali la yaliyomo",
"Show/Hide" => "Onyesha / Ficha",
// "Processing page: %0, is_html: %1" => "Processing page: %0, is_html: %1",
"Payment was sent but verification is not currently available (this feature is a work in progress)" => "Malipo imetumwa lakini uthibitishaji haupatikani (kazi inafanyika)",
// "Cart: Product code mismatch" => "Cart: Product code mismatch",
// "Cart: Product exchange mismatch" => "Cart: Product exchange mismatch",
// "Invalid gift certificate: %0" => "Invalid gift certificate: %0",
"Please enter your shopper information first" => "Asante kwa kuanza kwa kuingia maelezo ya mnunuzi wako",
// "No email found for gift certificate recipient" => "No email found for gift certificate recipient",
"Gift card is not valid for products in cart" => "Kadi ya Kipawa ya Kipawa ya Bidhaa katika Cart",
"for" => "kwa",
"Bundled Product" => "Bidhaa ya Bundled",
"Product" => "Bidhaa",
"Quantity" => "Wingi",
"Unit Price" => "Bei ya Kitengo",
"There is insufficient inventory to meet your request" => "Hakuna hesabu ya kutosha ili kukidhi ombi lako",
// "Advanced Shopping Cart setup error: Orders profile missing" => "Advanced Shopping Cart setup error: Orders profile missing",
"Gift Certificate: " => "Hati ya Kipawa:",
"Gift Certificate Amount Used: " => "Cheti cha Kipawa Kiasi kilichotumika:",
"No registries specified in admin/payment/cclite" => "Hakuna usajili uliowekwa katika admin / malipo / cclite",
"Cclite payment initiated on %0" => "Malipo ya Cclite yameanzishwa %0",
"Connection to Cclite server %0 failed for %1<br />\"%2\"" => "Uunganisho kwa seva ya cclite %0 imeshindwa %1<br />\"%2\"",
"Tiki credits payment done on %0 for %1 (using %2)" => "Malipo ya sifa za Tiki zinafanywa %0r kwa %1 (kutumia %2)",
// "PDF webkit path \"%0\" not found" => "PDF webkit path \"%0\" not found",
// "The PDF webkit path has not been set" => "The PDF webkit path has not been set",
// "PDF WeasyPrint path \"%0\" not found" => "PDF WeasyPrint path \"%0\" not found",
// "The PDF WeasyPrint path has not been set" => "The PDF WeasyPrint path has not been set",
// "PDF webservice URL \"%0\" not found" => "PDF webservice URL \"%0\" not found",
// "The PDF webservice URL has not been set" => "The PDF webservice URL has not been set",
// "The package mPDF is not installed. You can install it using packages" => "The package mPDF is not installed. You can install it using packages",
// "PDF generation failed" => "PDF generation failed",
// "This is set by the administrator (search for \"print\" in the control panels to locate the setting)" => "This is set by the administrator (search for \"print\" in the control panels to locate the setting)",
// "Required function shell_exec is not enabled" => "Required function shell_exec is not enabled",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category ID" => "Areas root category ID",
// "is invalid" => "is invalid",
// "Access-Control-Allow-Origin" => "Access-Control-Allow-Origin",
// "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server" => "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server",
// "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site" => "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site",
// "Record basic events" => "Record basic events",
// "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged" => "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged",
// "Record tracker item update" => "Record tracker item update",
// "Enable recording of basic internal Tiki events" => "Enable recording of basic internal Tiki events",
// "Record tracker item creation" => "Record tracker item creation",
// "Record user following users" => "Record user following users",
// "Record user being followed by users" => "Record user being followed by users",
// "Record user adding new friend" => "Record user adding new friend",
// "Custom activities" => "Custom activities",
// "Allow the defining of custom behaviors in addition to internal events" => "Allow the defining of custom behaviors in addition to internal events",
// "Enable notifications through activities" => "Enable notifications through activities",
// "Allow users to create notifications using activities" => "Allow users to create notifications using activities",
"Ajax auto-save" => "Ajax Usajili wa moja kwa moja",
// "Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing" => "Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing",
// "Inline editing" => "Inline editing",
// "Enable inline editing of certain values. Currently limited to tracker item fields" => "Enable inline editing of certain values. Currently limited to tracker item fields",
// "Tracker list inline editing" => "Tracker list inline editing",
// "Enable inline editing of all fields on the tracker list page" => "Enable inline editing of all fields on the tracker list page",
// "ffmpeg path" => "ffmpeg path",
// "Path to the location of the ffmpeg binary" => "Path to the location of the ffmpeg binary",
// "ffprobe path" => "ffprobe path",
// "Path to the location of the ffprobe binary" => "Path to the location of the ffprobe binary",
// "Alchemy Image library" => "Alchemy Image library",
// "Select either Image Magick or GD Graphics Library" => "Select either Image Magick or GD Graphics Library",
// "Imagemagick" => "Imagemagick",
// "GD" => "GD",
// "unoconv path" => "unoconv path",
// "Path to the location of the unoconv binary" => "Path to the location of the unoconv binary",
// "ghostscript path" => "ghostscript path",
// "Path to the location of the ghostscript binary" => "Path to the location of the ghostscript binary",
// " (Extension not loaded)" => " (Extension not loaded)",
"Search index rebuild" => "Utafakari index upya",
"Tracker item export" => "Bidhaa ya Tracker ya nje",
// "Tracker clear" => "Tracker clear",
"Printing to PDF" => "Kuchapisha kwa PDF",
// "PHP execution" => "PHP execution",
// "for example 256M, currently is %0" => "for example 256M, currently is %0",
// "for example 30 seconds, currently is %0 seconds" => "for example 30 seconds, currently is %0 seconds",
"%0 memory limit" => "Kikomo cha memory ya %0",
// "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server" => "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server",
"for example: 256M" => "kwa mfano: 256M",
"%0 time limit" => "Kikomo cha wakati %0",
// "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values" => "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values",
"seconds" => "sekunde",
"Users accept internal messages by default" => "Watumiaji wanakubali ujumbe wa ndani kwa default",
// "Users can opt out of internal messages" => "Users can opt out of internal messages",
// "ID of category whose child categories are bound to a perspective by areas" => "ID of category whose child categories are bound to a perspective by areas",
"Newest first" => "Ya hivi karibuni ya kwanza",
"ascending" => "kuongeza",
"descending" => "kushuka",
// "Article order" => "Article order",
"Default sort mode for the articles on the list-articles page" => "Chagua chaguo-msingi cha vitu kwenye orodha ya vitu",
"Title of articles homepage" => "Kichwa cha ukurasa wa nyumbani",
// "Select the default title for the page that displays all articles" => "Select the default title for the page that displays all articles",
"Title" => "Kichwa",
"Title length" => "Urefu wa kichwa",
"characters" => "wahusika",
"Publication date" => "Tarehe ya kuchapishwa",
"Visible" => "inayoonekana",
// "Author (owner)" => "Author (owner)",
"Author name (as displayed)" => "Jina la mwandishi (kama ilivyoonyeshwa)",
"Author rating" => "Mwandishi Rating",
// "Users rating" => "Users rating",
"Reads" => "Inasoma",
"Is published" => "Imechapishwa",
"Trailer position" => "Msimamo wa trailer",
"Between heading and body" => "Kati ya kichwa na mwili",
"Header text position" => "Nafasi ya maandiko ya kichwa",
"Requires a smaller image for list view" => "Inahitaji picha ndogo kwa mtazamo wa orodha",
"Next to image" => "Picha inayofuata",
"Below image" => "Chini ya picha",
"Oldest first" => "Kongwe kabisa",
"Points" => "pointi",
"Number per page" => "Nambari ya msingi kwa kila ukurasa",
// "Set the number of comments per page" => "Set the number of comments per page",
"comments" => "maoni",
"Display order" => "Kuagiza kwa Hifadhi",
// "Set the display order of comments" => "Set the display order of comments",
"Paginate articles" => "Vipengee vyema",
"Divide articles into multiple pages with pagebreak markers" => "Gawanya makala katika kurasa nyingi na mapumziko ya ukurasa",
// "Article creator remains article owner" => "Article creator remains article owner",
// "Last article editor does not automatically become author (owner)" => "Last article editor does not automatically become author (owner)",
"User ratings on articles" => "Maoni ya mtumiaji kwenye Vitu",
"Allow users to rate articles" => "Inaruhusu watumiaji kupima makala",
// "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set" => "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set",
"Article rating options" => "Chaguo za maoni ya kipengee",
"List of options available for the rating of articles" => "Orodha ya chaguo iwezekanavyo kwa makala ya rating",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Set the default maximum width of the article image" => "Set the default maximum width of the article image",
"pixels" => "pixels",
// "\"0\" for no maximum" => "\"0\" for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Set the default maximum height of article images" => "Set the default maximum height of article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Sets the default maximum width of custom article images in list mode (on View Articles page)" => "Sets the default maximum width of custom article images in list mode (on View Articles page)",
// "\"0\" to default to the view mode maximum" => "\"0\" to default to the view mode maximum",
// "Default maximum height of custom article images in list mode (on View Articles page)" => "Default maximum height of custom article images in list mode (on View Articles page)",
// "Set the default maximum height of custom article images in list mode (on the View Articles page)" => "Set the default maximum height of custom article images in list mode (on the View Articles page)",
// "Article image maximum file size" => "Article image maximum file size",
// "Maximum file size for an article image. Article images are stored in the database so it should remain low" => "Maximum file size for an article image. Article images are stored in the database so it should remain low",
// "kilobytes" => "kilobytes",
"Custom attributes for article types" => "Sifa za Desturi kwa Aina ya Ibara",
"Enable additional custom fields for article types" => "Ruhusu mashamba ya desturi ya ziada kwa aina za makala",
"Your ShareThis publisher identifier (optional)" => "Kitambulisho chako cha mchapishaji kwenye www.sharethis.com (hiari)",
// "Set to define your ShareThis publisher identifier" => "Set to define your ShareThis publisher identifier",
// "record your ShareThis publisher ID" => "record your ShareThis publisher ID",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of an article page" => "Display a list of related articles at the bottom of an article page",
// "Use new articles" => "Use new articles",
// "Use the new CustomSearch-based article lists rather than database information" => "Use the new CustomSearch-based article lists rather than database information",
// "Article copyright" => "Article copyright",
// "Apply copyright management preferences to this feature" => "Apply copyright management preferences to this feature",
"Authentication method" => "Njia ya uthibitishaji",
"Tiki supports several authentication methods. The default method is to use the internal user database" => "Tiki inasaidia mbinu kadhaa za kuthibitisha. Kichapishaji ni kutumia database ya mtumiaji wa ndani",
"Tiki" => "Tiki",
"Tiki and OpenID" => "Tiki na OpenID",
"Tiki and PAM" => "Tiki na uthibitishaji PAM",
"Tiki and LDAP" => "Tiki na LDAP",
"CAS (Central Authentication Service)" => "HKK (Huduma Kuu ya Kuthibitisha)",
// "SAML" => "SAML",
"Shibboleth" => "Shibboleth",
"Web Server" => "Mtandao wa Wavuti",
"phpBB" => "phpBB",
"Token access" => "Token ya Upatikanaji",
"With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service" => "Kwa uwasilishaji wa ishara, kuruhusu upatikanaji wa maudhui na haki zilizoinuliwa. Matumizi ya msingi ya njia hii ya kuthibitisha ni kutoa ufikiaji wa muda kwa maudhui kwa huduma ya nje",
"Token access default timeout" => "muda wa kuisha wa chaguo-msingi wa Token ya Upatikanaji",
// "The default duration for which the generated tokens will be valid" => "The default duration for which the generated tokens will be valid",
"Token access default maximum hits" => "Upiga ya juu ya chaguo-msingi wa Token ya Upatikanaji",
// "The default maximum number of times a token can be used before it expires" => "The default maximum number of times a token can be used before it expires",
"hits" => "Upiga",
"Share access rights with friends when using Tell a friend" => "Shiriki haki za upatikanaji na marafiki unapotumia Mwambie rafiki",
"Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site" => "Ruhusu watumiaji kushiriki haki zao za upatikanaji wa ukurasa wa sasa na rafiki wakati wa kutuma kiungo kwa barua pepe. Maisha ya kiungo huelezwa na tovuti",
"Do not delete temporary users when token is deleted/expired" => "Usiondoe watumiaji wa muda wakati ishara inafutwa / imekamilika",
// "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms" => "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms",
"Share access rights with friends when using Share" => "Shiriki haki za upatikanaji na marafiki wakati wa kutumia \"Shiriki\" kifungo",
"Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site" => "Ruhusu watumiaji kushiriki haki zao za kufikia ukurasa wa sasa na rafiki wakati wa kutuma kiungo kwa barua pepe, Twitter, au Facebook. Maisha ya kiungo huelezwa na tovuti",
"Create user if not registered in Tiki" => "Unda mtumiaji ikiwa haijasajiliwa katika Tiki",
// "Automatically create a new Tiki user for the PHPbb login" => "Automatically create a new Tiki user for the PHPbb login",
// "Use Tiki authentication for Admin log-in" => "Use Tiki authentication for Admin log-in",
// "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”" => "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”",
// "Disable Tiki users who don’t have a phpBB login as they could have been deleted" => "Disable Tiki users who don’t have a phpBB login as they could have been deleted",
"phpBB Version" => "Toleo la phpBB",
"3" => "3",
"phpBB Database Hostname" => "Jina la mwenyeji wa database phpBB",
"phpBB Database Username" => "Jina la mtumiaji wa database phpBB",
"phpBB Database Password" => "Nenosiri ya database phpBB",
"phpBB Database Name" => "Jina ya database phpBB",
"phpBB Table Prefix" => "phpBB Kiambatisho cha Jedwali",
"Use Tiki authentication for users created in Tiki" => "Tumia uthibitishaji wa Tiki kwa watumiaji walioundwa katika Tiki",
// "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP" => "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP",
"Host" => "Mwenyeji",
// "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL" => "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL",
"Port" => "Port",
// "The port number your LDAP server uses (389 is the default, 636 if you check SSL)" => "The port number your LDAP server uses (389 is the default, 636 if you check SSL)",
"Write LDAP debug Information in Tiki Logs" => "Andika uchafuzi wa LDAP Taarifa katika Tiki Logs",
// "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)" => "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)",
// "Do not enable this option for production sites" => "Do not enable this option for production sites",
"Use SSL (ldaps)" => "Tumia SSL (ldaps)",
"Use TLS" => "Tumi TLS",
"LDAP Bind Type" => "Aina ya uunganisho LDAP",
// "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>" => "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>",
"Default: Anonymous Bind" => "Default: Bindani isiyojulikana",
"Full: userattr=username,UserDN,BaseDN" => "Kamili: userattr = jina la mtumiaji, mtumiaji DN, msingi DN",
"OpenLDAP: cn=username,BaseDN" => "Fungua LDAP: cn = jina la mtumiaji, BaseDN",
"Active Directory (username@domain)" => "Active Directory (username@domain)",
"Plain Username" => "Jina ya wazi la mtumiaji",
"Search scope" => "Punguza utafutaji",
// "Used after authentication for getting user and group information" => "Used after authentication for getting user and group information",
"Subtree" => "Subtree",
"One level" => "Ngazi moja",
"Base object" => "Kitu cha msingi",
"Base DN" => "Msingi DN ",
"User DN" => "Mtumiaji DN",
"User attribute" => "Tabia ya mtumiaji",
"User OC" => "Mtumiaji OC",
"Realname attribute" => "Jina la kweli la jina",
// "Synchronize Tiki user attributes with the LDAP values" => "Synchronize Tiki user attributes with the LDAP values",
"Country attribute" => "Nchi ya sifa",
"Email attribute" => "Email attribute",
"Group DN" => "Kikundi DN",
"Group name attribute" => "Kikundi cha jina la kikundi",
"Group description attribute" => "Maelezo ya kikundi maelezo",
"Group OC" => "Kikundi OC",
"Member attribute" => "Tabia ya wanachama",
"Member is DN" => "Mwanachama ni DN",
"Group attribute" => "Tabia ya kikundi",
"Group attribute in group entry" => "Tabia ya kikundi katika kuingiza kikundi",
"(Leave this empty if the group name is already given in the user attribute)" => "(Acha hii tupu ikiwa jina la kikundi tayari limetolewa katika sifa ya mtumiaji)",
"Admin user" => "Msimamizi wa Admin",
"Admin password" => "Nambari ya nenosiri",
"Use an external LDAP server for groups" => "Tumia seva ya nje ya LDAP kwa vikundi",
"Anonymous Bind" => "Bindani isiyojulikana",
"Corresponding user attribute in 1st directory" => "Kina sifa ya mtumiaji katika saraka ya 1",
// "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database" => "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database",
// "Disable Tiki users with no phpBB login" => "Disable Tiki users with no phpBB login",
// "Default Bootstrap" => "Default Bootstrap",
"Available languages" => "Lugha zilizopo",
// "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset" => "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset",
"Available themes" => "Inapatikana mandhari",
"Restrict available themes" => "Weka mandhari zilizopo",
// "BigBlueButton web conferencing" => "BigBlueButton web conferencing",
"Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Ushirikiano na seva ya kushirikiana ya BigBlueButton kwa ushirikiano wa wavuti na ushiriki wa skrini",
"BigBlueButton server location" => "Eneo la mtumishi BigBlueButton",
"Full URL to the BigBlueButton installation" => "Jumuisha URL kwa ufungaji BigBlueButton",
"http://host.example.com/" => "http://serveur.exemple.com/",
"BigBlueButton server salt" => "Kitufe cha uthibitishaji wa Server BigBlueButton",
"A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic" => "Fungu la chumvi lilitumiwa kuzalisha checksums kwa seva ya BigBlueButton ili kuhakikishia kwamba maombi ni ya kweli",
"BigBlueButton recording maximum duration" => "BigBlueButton kurekodi muda mrefu",
// "A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open" => "A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open",
"minutes" => "dakika",
// "BigBlueButton dynamic configuration" => "BigBlueButton dynamic configuration",
// "Uses the advanced options of BigBlueButton to configure the XML per room" => "Uses the advanced options of BigBlueButton to configure the XML per room",
"Default ordering" => "Kuagiza kwa hiari",
// "Default order" => "Default order",
"Creation Date (desc)" => "Tarehe ya Uumbaji (chini)",
"Last modification date (desc)" => "Tarehe ya mwisho ya tarehe (chini)",
"Blog title (asc)" => "Kitabu cha blogu (asc)",
"Number of posts (desc)" => "Idadi ya machapisho (kushuka)",
"Visits (desc)" => "Ziara (chini)",
"Activity (desc)" => "Shughuli (chini)",
"Disabled" => "Walemavu",
"Link to user information" => "Unganisha habari kwa mtumiaji",
"User profile picture" => "Picha ya wasifu wa mtumiaji",
"Posts" => "Ujumbe",
"Visits" => "Ziara",
"Activity" => "Shughuli",
// "Blog post copyright" => "Blog post copyright",
"Module (box) shadow start" => "Moduli (sanduku) kivuli kuanza",
"Module (box) shadow end" => "Kipengee (sanduku) mwisho wa kivuli",
"Days to display in the calendar" => "Siku za kuonyeshwa kwenye kalenda",
"Default view mode" => "Mfumo wa mtazamo wa default",
"Day" => "Siku",
"Week" => "Wiki",
"Month" => "Mwezi",
"Quarter" => "Quarter",
"Semester" => "Semester",
"Year" => "Mwaka",
"View list begins" => "Tazama orodha inapoanza",
"Focus date" => "Tarehe ya kuzingatia",
"Period beginning" => "Kipindi cha mwanzo",
"First day of the week" => "Siku ya kwanza ya juma",
"Depends user language" => "Inategemea lugha ya mtumiaji",
"Split hours in periods of" => "Piga masaa katika kipindi cha",
"1" => "1",
"5" => "5",
"10" => "10",
"15" => "15",
"30" => "30",
// "Minute Interval" => "Minute Interval",
"First year in the dropdown" => "Mwaka wa kwanza katika kushuka",
"years" => "miaka",
// "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled" => "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled",
"Last year in the dropdown" => "Last year in the dropdown",
"Enter a year or use +/- N to specify a year relative to the current year" => "Ingiza mwaka au kutumia +/- N kutaja mwaka kuhusiana na mwaka uliopo",
"Sticky popup" => "Inajumuisha popup",
"Item view tab" => "Kitabu cha maoni ya kipengee",
"Show \"Add to Google Calendar\" icon" => "Onyesha \"Ongeza kwenye Kalenda ya Google\" icon",
"Show \"Export Calendars\" button" => "Onyesha \"Tuma Kalenda\" kifungo ",
// "Show \"Export Calendar Item\" Button" => "Show \"Export Calendar Item\" Button",
// "Allow exporting a single calendar event as an iCal file" => "Allow exporting a single calendar event as an iCal file",
"Use FullCalendar to display calendars" => "Tumia FullCalendar kuonyesha kalenda",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
"Enable watch events when you are the editor" => "Wezesha matukio ya kuangalia wakati wewe ni mhariri",
// "Check this to receive email notifications of events you changed yourself" => "Check this to receive email notifications of events you changed yourself",
"CAPTCHA image word length" => "Jina la picha ya CAPTCHA urefu",
"Number of characters the CAPTCHA will display" => "Idadi ya wahusika CAPTCHA itaonyesha",
"CAPTCHA image width" => "Upana wa picha ya CAPTCHA",
"Width of the CAPTCHA image in pixels" => "Upana wa picha ya CAPTCHA katika saizi",
"CAPTCHA image noise" => "Kelele ya picha ya CAPTCHA",
"Level of noise of the CAPTCHA image" => "Ngazi ya kelele ya picha ya CAPTCHA",
"Choose a smaller number for less noise and easier reading." => "Chagua namba ndogo kwa kelele kidogo na kusoma rahisi.",
"CAPTCHA questions" => "Maswali ya CAPTCHA",
// "Requires anonymous visitors to enter the answer to a question" => "Requires anonymous visitors to enter the answer to a question",
"CAPTCHA questions and answers" => "Maswali na majibu ya CAPTCHA",
// "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line" => "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line",
"One question per line with a colon separating the question and answer" => "Swali moja kwa kila mstari na nukta pacha kutenganisha swali na jibu",
"Try automatically to connect SSO" => "Jaribu moja kwa moja kuunganisha SSO",
"Force CAS log-out when the user logs out from Tiki." => "Weka kuingia HKK wakati mtumiaji akiondoka kutoka Tiki.",
"Show alternate log-in method in header" => "Onyesha njia mbadala ya kuingia kwenye kichwa",
"CAS server version" => "Toleo la seva ya HKK",
"none" => "hakuna",
"Version 1.0" => "Toleo 1.0",
"Version 2.0" => "Toleo 2.0",
"Hostname" => "Jina la majina",
"Hostname of the CAS server" => "ina la majina ya seva ya HKK",
"Port of the CAS server" => "Bandari ya seva ya HKK",
"Path for the CAS server" => "Njia ya seva ya HKK",
"CAS Extra Parameter" => "Kipimo cha ziada cha HKK",
"Extra Parameter to pass to the CAS Server" => "Parameter ya ziada ya kupita kwa Seva ya HKK",
"CAS Authentication Verification Timeout" => "Uthibitisho wa Uthibitishaji wa HKK Muda wa Uthibitishaji",
"Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Thibitisha uthibitisho na seva ya HKK kila sekunde N. Thamani ya null inamaanisha kamwe kurejesha",
"minute" => "dakika",
"hour" => "saa",
"Provides the current categories to Smarty templates" => "Hutoa makundi ya sasa kwa template za Smarty",
// "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance" => "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance",
"Categories to add as CSS classes to <body>" => "Jamii za kuongeza kama madarasa CSS kwa <body>",
// "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag" => "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag",
"Clear cache upon category change" => "Futa cache juu ya mabadiliko ya jamii",
// "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date" => "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date",
// "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts" => "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts",
"Category jail" => "Jamii ya jela",
"Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Inapunguza uonekano wa vitu kwa wale walio katika vitambulisho vya kikundi hiki. Inatumiwa hasa kwa ajili ya kujenga nafasi za kazi kutoka kwa mitazamo",
// "This should only be set for perspectives, and not globally" => "This should only be set for perspectives, and not globally",
// "Category jail root" => "Category jail root",
// "Always display categories outside of the jail root, which would be for normal categorization" => "Always display categories outside of the jail root, which would be for normal categorization",
"Category defaults" => "Jamii haifafanuliwa",
"Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default" => "Inahitaji makundi fulani kuwapo. Ikiwa hakuna makundi katika seti iliyotolewa, toa kikundi kwa chaguo-msingi",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page" => "One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page",
"Synchronize multilingual categories" => "Unganisha makundi ya lugha mbalimbali",
"Make sure that the categories of the translations are synchronized when modified on any version." => "Hakikisha kwamba makundi ya tafsiri yanalinganishwa wakati umebadilishwa kwenye toleo lolote.",
"Only those specified" => "Ni wale tu walioelezwa",
"All but those specified" => "Yote isipokuwa yale yaliyotajwa",
"Synchronized categories" => "Makundi yaliyoingiliana",
"List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)" => "Orodha ya makundi yaliyoathirika na maingiliano ya lugha mbalimbali. Kulingana na kipengele cha mzazi, orodha hii itatumiwa kama orodha nyeupe (makundi pekee yanayoruhusiwa) au kama orodha nyeusi (makundi yote yaruhusiwa isipokuwa yale yaliyotajwa)",
// "Sort categories case insensitively" => "Sort categories case insensitively",
// "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings" => "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings",
// "Automatically geocode items with this category" => "Automatically geocode items with this category",
"Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Vipengee vya geocode moja kwa moja kulingana na jina la kikundi wakati umewekwa katika makundi madogo ya kitambulisho hiki",
// "Replace any existing geocode" => "Replace any existing geocode",
"When automatically geocoding items based on category name, replace existing geocode, if any" => "Wakati wa vitu vya geocoding moja kwa moja kulingana na jina la kikundi, nafasi ya geocode iliyopo, ikiwa iko.",
"Use approximate geocode location" => "Tumia eneo la geocode karibu",
"When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "Wakati wa vitu vya geocoding moja kwa moja kulingana na jina la kikundi, tumia eneo la nasibu karibu na mahali sahihi",
"\"More Like This\" algorithm for categories" => "\"Zaidi kama hii\" algorithm kwa makundi",
"Weighted" => "Kupimwa",
"Minimum number of categories in common" => "Idadi ndogo ya makundi ya kawaida",
"categories" => "makundi",
"2" => "2",
"4" => "4",
"6" => "6",
"7" => "7",
"8" => "8",
"9" => "9",
// "List objects with most categories in common" => "List objects with most categories in common",
// "No minimum is applied" => "No minimum is applied",
// "Maximum number of \"more like this\" objects" => "Maximum number of \"more like this\" objects",
// "The default maximum records setting for the site is used of this is set to 0" => "The default maximum records setting for the site is used of this is set to 0",
// "objects" => "objects",
"Generate custom facets from categories" => "Kuzalisha vipengee vya desturi kutoka kwa makundi",
// "Comma-separated list of category IDs" => "Comma-separated list of category IDs",
"Show category object count" => "Onyesha uhesabu wa kitu cha kikundi",
// "Show object count when browsing categories, complying with search and type filters" => "Show object count when browsing categories, complying with search and type filters",
// "Can slow the loading of the categories page on large sites" => "Can slow the loading of the categories page on large sites",
"Exclude these category IDs" => "Wala Vitambulisho vya vikundi hivi",
"Category path won't appear for these category IDs" => "Njia ya kikundi haitaonekana kwa vitambulisho vya kikundi hiki",
// "Category path format" => "Category path format",
// "Alter how the category path will be rendered" => "Alter how the category path will be rendered",
// "Links to the category when the category is visible" => "Links to the category when the category is visible",
// "Text label when the category is visible" => "Text label when the category is visible",
// "Link when visible, text label otherwise" => "Link when visible, text label otherwise",
// "Always display the category path labels" => "Always display the category path labels",
"Center shadow start" => "Kituo cha kivuli cha kuanza",
"Center shadow end" => "Mwisho wa kivuli cha kituo",
"Users can choose the language of their interface" => "Watumiaji wanaweza kuchagua lugha ya interface yao",
"Allow users to change the language of the menus and labels" => "Ruhusu watumiaji kubadili lugha ya menus na maandiko",
"Users can change theme" => "Watumiaji wanaweza kubadilisha mandhari",
// "Users can override the theme with this setting" => "Users can override the theme with this setting",
"Users can change their password" => "Watumiaji wanaweza kubadilisha nenosiri yao",
// "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin" => "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin",
"Disable comment titles" => "Zima vyeo vya maoni",
"Don't display the title input field on comments and their replies" => "Usionyeshe uwanja la uingizaji wa kichwa kwenye maoni na majibu yao",
"Email field" => "Uwanja wa barua pepe",
"Email field for comments (only for anonymous users)" => "Uwanja ya barua pepe kwa maoni (tu kwa watumiaji wasiojulikana)",
"Website field" => "Uwanja wa tovuti",
"Website field for comments (only for anonymous users)" => "Uwanja ya tovuti kwa maoni (tu kwa watumiaji wasiojulikana)",
"Use vote system for comments" => "Tumia mfumo wa kura kwa maoni",
// "Allow users with permission to vote on comments" => "Allow users with permission to vote on comments",
"Permissions involved: %0" => "Ruhusa zinazohusika: %0",
"Archive comments" => "Weka maoni haya",
"If a comment is archived, only admins can see it" => "Ikiwa maoni yamehifadhiwa, wasaidizi pekee wanaweza kuiona",
"Use Akismet to filter comments" => "Tumia Akismet ili kuchuja maoni",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam",
"Akismet API Key" => "Ufunguo wa API ya Akismet",
// "Key required for the Akismet comment spam prevention" => "Key required for the Akismet comment spam prevention",
"Obtain this key by registering your site at [%0]" => "Pata ufunguo huu kwa kusajili tovuti yako kwenye [%0]",
"Filter spam for registered users" => "Chuja barua taka kwa watumiaji waliojiandikisha",
// "Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening" => "Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening",
"Allow comments to be edited by their author" => "Kuruhusu maoni na kuhaririwa na mwandishi wao",
// "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc" => "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc",
// "Inline comments using Apache Annotator" => "Inline comments using Apache Annotator",
// "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations" => "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations",
"Anchor links on headings" => "Weka viungo kwenye vichwa",
// "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page" => "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page",
// "Number of comments per page" => "Number of comments per page",
// "Sort mode for comments" => "Sort mode for comments",
// "Automatically present a terms of use page to be accepted by users accessing the site" => "Automatically present a terms of use page to be accepted by users accessing the site",
// "Terms of Use page name" => "Terms of Use page name",
// "Wiki page for Terms of Use content. The page may be translated using the multilingual feature" => "Wiki page for Terms of Use content. The page may be translated using the multilingual feature",
// "Minimum age" => "Minimum age",
// "When presenting the terms of use, request age" => "When presenting the terms of use, request age",
// "0 to ignore age validation" => "0 to ignore age validation",
// "Tiki connect" => "Tiki connect",
"Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Unganisha Tiki yako na jamii kwa kutuma takwimu isiyojulikana ya takwimu kwenye tiki.org",
"This feature is still under development" => "Kipengele hiki bado kina chini ya maendeleo",
"Send site information" => "Tuma maelezo ya tovuti",
"Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you" => "Kwa kuongeza kutuma maneno, mahali, nk kwa tiki.org ili uweze kuunganisha na maeneo mengine ya Tiki karibu na wewe",
"Site title" => "Jina la tovuti",
"Name of site to be listed on Tiki Connect" => "Jina la tovuti limeorodheshwa kwenye Tiki Connect",
// "Site title is required to send site information" => "Site title is required to send site information",
"Email contact" => "Mawasiliano ya barua pepe",
"Email to register" => "Barua pepe ya kujiandikisha",
"URL to register" => "URL ya kujiandikisha",
"Key words" => "Maneno muhimu",
"Key words or tags describing your site" => "Maneno muhimu au vitambulisho vinavyoelezea tovuti yako",
"Site location" => "Eneo la tovuti",
"Site location expressed as longitude, latitude, and zoom" => "Eneo la tovuti limeonyeshwa kama longitude, latitude, na zoom",
"Send anonymous information" => "Tuma habari isiyojulikana",
// "Send anonymous usage information" => "Send anonymous usage information",
"Connection frequency" => "Mzunguko wa uhusiano",
// "How often to send information" => "How often to send information",
"hours" => "masaa",
"Click \"Send Info\" to connect." => "Bonyeza \"Tuma Info\" kuunganisha.",
"Currently not in use" => "Hivi sasa haitumiwi",
"Tiki connect server URL" => "URL ya seva ya Tiki Connect",
"Where to send the information" => "Ambapo kutuma habari",
"Last connection" => "Uunganisho wa mwisho",
"Connect server mode" => "Unganisha hali ya seva",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
"Connect GUID" => "Unganisha GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
"Allow anonymous visitors to use the \"Contact Us\" feature" => "Ruhusu wageni wasiojulikana kutumia kipengele cha \"Wasiliana Nasi\"",
"Display contact priority" => "Onyesha kipaumbele cha mawasiliano",
// "Display contact priority option" => "Display contact priority option",
"Contact user" => "Wasiliana na mtumiaji",
// "User to contact" => "User to contact",
"Cookie name" => "Jina la kuki",
"Domain" => "Uwanja",
// "The domain that the cookie is available to" => "The domain that the cookie is available to",
// "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically" => "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically",
// "Ask permission of the user before setting any cookies, and comply with the response" => "Ask permission of the user before setting any cookies, and comply with the response",
// "Complies with EU Privacy and Electronic Communications Regulations" => "Complies with EU Privacy and Electronic Communications Regulations",
// "Cookie consent name" => "Cookie consent name",
// "Name of the cookie to record the user's consent if the user agrees" => "Name of the cookie to record the user's consent if the user agrees",
// "Cookie consent expiration" => "Cookie consent expiration",
// "Expiration date of the cookie to record consent (in days)" => "Expiration date of the cookie to record consent (in days)",
"days" => "siku",
// "Cookie consent text" => "Cookie consent text",
// "Description for the dialog" => "Description for the dialog",
// "Wiki-parsed" => "Wiki-parsed",
// "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))" => "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))",
// "Cookie consent question" => "Cookie consent question",
// "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox" => "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox",
// "I accept cookies from this site" => "I accept cookies from this site",
"Cookie consent button" => "Kifungo cha kuruhusu vidakuzi",
// "Label on the agreement button" => "Label on the agreement button",
"Continue" => "Endelea",
// "Cookie consent alert" => "Cookie consent alert",
// "Alert displayed when user tries to access or use a feature requiring cookies" => "Alert displayed when user tries to access or use a feature requiring cookies",
// "Sorry, cookie consent required" => "Sorry, cookie consent required",
// "Cookie consent mode" => "Cookie consent mode",
// "Appearance of consent dialog" => "Appearance of consent dialog",
// "Dialog style requires feature_jquery_ui" => "Dialog style requires feature_jquery_ui",
"Plain" => "Wazi",
"Banner" => "Bendera",
"Dialog" => "Majadiliano",
// "Cookie consent dialog ID" => "Cookie consent dialog ID",
// "DOM id for the dialog container div" => "DOM id for the dialog container div",
// "Cookie consent disabled" => "Cookie consent disabled",
// "Do not give the option to refuse cookies but still inform the user about cookie usage" => "Do not give the option to refuse cookies but still inform the user about cookie usage",
// "Refresh the remember-me cookie expiration" => "Refresh the remember-me cookie expiration",
// "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated" => "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated",
// "Name of the cookie to remember the user's login" => "Name of the cookie to remember the user's login",
"Count admin pageviews" => "Kuhesabu maoni ya ukurasa wa admin",
"Include pageviews by Admin when reporting stats" => "Weka kurasa zilizotazamwa na Admin katika ripoti za takwimu",
"Enable daily reports for new users" => "Wezesha ripoti ya kila siku kwa watumiaji wapya",
// "Determines if daily reports will be automatically enabled for new users" => "Determines if daily reports will be automatically enabled for new users",
"Default character set for sending mail" => "Ufafanuzi wa tabia ya barua pepe zinazotoka",
"Specify the character encoding used by Tiki when sending mail notifications" => "Taja utambulisho wa tabia unaotumiwa na Tiki wakati wa kutuma arifa za barua pepe",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"default mapfile" => "default mapfile",
"Default diff style" => "Kielelezo cha tofauti cha kawaida",
"Only with last version" => "Tu kwa toleo la mwisho",
"HTML diff" => "HTML diff",
"Side-by-side diff" => "Upande kwa upande hutofautiana",
"Side-by-side diff by characters" => "Kando kwa upande hutofautiana na wahusika",
"Inline diff" => "Diff katika mstari",
"Inline diff by characters" => "Diff katika mstari na wahusika",
"Full side-by-side diff" => "Kamili kwa upande hutofautiana",
"Full side-by-side diff by characters" => "Kamili kwa upande unafanana na wahusika",
"Full inline diff" => "Tofauti kamili katika mstari",
"Full inline diff by characters" => "Tofauti kamili katika mstari na wahusika",
"Unified diff" => "Tofauti iliyounganishwa",
"Side-by-side view" => "Mtazamo wa upande kwa upande",
"rows" => "mistari",
"Comment box" => "Sanduku la maoni",
// "Size (height) of the comment text area" => "Size (height) of the comment text area",
"Forum reply" => "Jibu kwa jukwaa",
// "Select default calendars to display" => "Select default calendars to display",
// "Group transition sets default" => "Group transition sets default",
// "Sets the group transitioned to as the user's default group" => "Sets the group transitioned to as the user's default group",
// "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites" => "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites",
"Disable browser's autocomplete feature for username and password fields" => "Zima kipengele cha kujitegemea cha kivinjari kwa uwanja wa mtumiaji na password",
"Use direct pagination links" => "Tumia viungo vya pagination moja kwa moja",
"Maximum number of links around the current item" => "Idadi ya viungo karibu na kipengee cha sasa",
"links" => "viungo",
"Maximum number of links after the first or before the last item" => "Idadi ya viungo baada ya kwanza au kabla ya kipengee cha mwisho",
"Show country flag" => "Onyesha bendera ya nchi",
"Show the country flag" => "Onyesha bendera ya nchi",
"Enable \"popular sites\"" => "Wezesha \"maeneo maarufu\"",
"Validate URLs" => "Thibitisha URL",
// "Should Tiki check the URL" => "Should Tiki check the URL",
// "Columns per page" => "Columns per page",
"Number of columns per page when listing directory categories" => "Idadi ya nguzo kwa kila ukurasa wakati wa orodha ya orodha za saraka",
// "columns" => "columns",
"Links per page" => "Viungo kwa kila ukurasa",
// "How many links should be displayed per page" => "How many links should be displayed per page",
"Method to open Directory links" => "Njia ya kufungua viungo vya Directory",
"The linked-to website can be opened in various ways" => "Tovuti inayounganishwa inaweza kufunguliwa kwa njia mbalimbali",
"Replace the current window" => "Weka dirisha la sasa",
"Open a new window" => "Fungua dirisha jipya",
"Open an iframe" => "kufungua sura",
"Fields display order" => "Mashamba yanaonyesha utaratibu",
// "The order date field inputs should be listed in" => "The order date field inputs should be listed in",
// "Year to show first in dropdown lists" => "Year to show first in dropdown lists",
// "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year" => "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year",
// "year(s)" => "year(s)",
// "Year to show last on dropdown lists" => "Year to show last on dropdown lists",
// "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year" => "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year",
"Re-validate user email after" => "Thibitisha tena barua pepe ya mtumiaji",
// "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid" => "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid",
"Use \"-1\" for never" => "Tumia \"-1\" kwa kamwe",
"Email footer" => "Chini ya barua pepe",
"Text appended to outgoing emails" => "Nakala imetumiwa kwa barua pepe zinazoondoka",
"PHP errors visible to admin only" => "Hitilafu za PHP zinaonekana kwa admin tu",
"During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators" => "Wakati wa maendeleo ya tovuti, ni bora kuonyesha makosa kwa watumiaji wote. Hata hivyo, katika mipangilio ya uzalishaji, makosa yanapaswa kuonyeshwa kwa watendaji",
// "PHP Errors will be shown to only the Admin user" => "PHP Errors will be shown to only the Admin user",
"PHP Error reporting level" => "Kiwango cha taarifa ya hitilafu ya PHP",
"Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist" => "Kiwango cha makosa ili kuripotiwa. Hitilafu zinaweza kuonekana katika sanduku linaloweza kuanguka chini ya ukurasa, ikiwa kunapo",
"No error reporting" => "Hakuna ripoti ya kosa",
"Report all PHP errors except strict" => "Ripoti makosa yote ya PHP isipokuwa kali",
"Report all PHP errors" => "Ripoti makosa yote ya PHP",
"Report all PHP errors except notices" => "Ripoti makosa yote ya PHP ila matangazo",
"According to the PHP configuration" => "Kulingana na usanidi wa PHP",
"Default number of comments per page" => "Idadi ya maoni ya kila ukurasa",
// "Maximum number of comments to display on each page. Users may override this number" => "Maximum number of comments to display on each page. Users may override this number",
"Default order of comments" => "Utaratibu wa maoni ya kawaida",
// "In which order to list the comments on the page" => "In which order to list the comments on the page",
// "Prefix for answers" => "Prefix for answers",
// "The prefix for that Tiki should display for each FAQ answer" => "The prefix for that Tiki should display for each FAQ answer",
"Q and A" => "S na J",
"Question ID" => "Kitambulisho cha Swala",
// "FAQ copyright" => "FAQ copyright",
// "Limit blog categories to those under this category" => "Limit blog categories to those under this category",
"If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "Ikiwa unapata ujumbe wa hitilafu unaonyesha jamii ya lazima inahitajika wakati wa kuhariri chapisho la blogu, hii ndiyo chaguo la kulaumiwa. Weka kwa 'None'",
"Areas" => "Maeneo",
"Binding categories and perspectives to each other" => "Makundi ya kushirikisha na mtazamo kwa kila mmoja",
// "Pages and collaboratively authored documents with edit history" => "Pages and collaboratively authored documents with edit history",
"Online diaries or journals." => "Machapisho ya mtandaoni au majarida.",
"Enable directory batch loading" => "Wezesha upakiaji wa 'directory batch'",
// "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols" => "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols",
"You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory" => "Ikiwa unawezesha Upakiaji wa Batch Directory, unahitaji kuanzisha saraka inayoonekana kwenye mtandao (nje ya nafasi yako ya mtandao ni bora). Kisha kuanzisha njia ya kupakia picha katika dirisha hiyo, ama kwa scp, ftp, au protocols nyingine",
"Rankings" => "Misimamo",
// "Users can see several charts or rankings about the file" => "Users can see several charts or rankings about the file",
// "Image gallery" => "Image gallery",
"Collections of images for viewing or downloading (photo albums)" => "Mikusanyiko ya picha kwa kutazama au kupakua (albamu za picha)",
"File galleries can be used instead" => "Majumba ya faili yanaweza kutumika badala yake",
// "Image Gallery Comments" => "Image Gallery Comments",
// "Users with permission may post threaded comments. The comments will appear at the bottom of the page" => "Users with permission may post threaded comments. The comments will appear at the bottom of the page",
// "Limit image gallery categories to those under this category" => "Limit image gallery categories to those under this category",
// "Machine translation" => "Machine translation",
// "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service" => "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service",
"Database and form generator" => "Database na jenereta ya fomu",
"Threaded or flat discussions" => "Majadiliano ya mtandaoni juu ya mada mbalimbali ambayo majibu yao yameonyeshwa kulingana na thread (mchoro wa ujumbe) au gorofa",
"File gallery" => "Faili ya sanaa",
"Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability" => "Uhifadhi wa faili za muundo tofauti ili kuonyesha au kupakua... Kwa uwezo wa kuingia na kuangalia (lock)",
"Save files as drafts" => "Hifadhi faili kama rasimu",
// "Allow saving of files as drafts" => "Allow saving of files as drafts",
"File gallery configuration templates" => "Nyaraka za usanidi wa nyumba za faili",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "Uchaguzi",
"Presentation of a set of votable options, typically displayed in a module" => "Orodha fupi ya uchaguzi wa kupiga kura; inaonekana kwenye moduli (safu ya kushoto au kulia).",
"Newsletters" => "Majarida",
"Content mailed to registered users or other subscribers" => "Maudhui yaliyopelekwa kwa watumiaji waliosajiliwa au washiriki wengine",
"Calendar" => "Kalenda",
"Events calendar with public, private and group channels." => "Kalenda ya Matukio na njia za umma, za kibinafsi na za kikundi.",
"Banners" => "Mabango",
"Insert, track, and manage advertising banners." => "Ingiza, kufuatilia, na udhibiti mabango ya matangazo.",
// "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access" => "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access",
"Unified user details " => "Maelezo ya mtumiaji wa umoja ",
// "Use User Details Page using the Unified Index" => "Use User Details Page using the Unified Index",
"Score" => "Mfumo wa tathmini",
"Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score ni mchezo kuwahamasisha washiriki kuongeza mchango wao kwa kulinganisha na watumiaji wengine",
// "Score expiry" => "Score expiry",
"Unified search index" => "Orodha ya tafuta ya umoja",
// "Enables searching for content at the site using a Tiki-managed index" => "Enables searching for content at the site using a Tiki-managed index",
"Enables tags to be set on pages and other items for freeform categorization." => "Inaruhusu lebo ziwekwe kwenye kurasa na vitu vingine kwa ajili ya kugawa jumuiya bure.",
"Action log" => "Logi ya hatua",
"Provides the ability to track the actions of users and produce reports on a per-user or per-category basis" => "Inatoa uwezo wa kufuatilia vitendo vya watumiaji na kutoa taarifa kwa kila mtumiaji au kwa kila kikundi",
"Contribution" => "Mchango",
"Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports" => "Inaruhusu watumiaji kutaja aina ya mchango wanayofanya wakati wa kuhariri vitu kwenye tovuti. Michango ni kisha kuonyeshwa 'color-coded' katika historia na taarifa nyingine",
"Multilingual" => "Lugha nyingi",
"Enables internationalization features and multilingual support at the site" => "Inawezesha vipengele vya kimataifa na msaada wa lugha mbalimbali kwenye tovuti",
"Frequently asked questions and answers" => "Maswali na majibu ya mara kwa mara",
"There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs" => "Kumekuwa na majadiliano juu ya kipengele hiki kuwa mstaafu, hivyo kukumbuka kwamba kurasa za kawaida za wiki zinaweza kutumiwa kuunda na kuonyesha Maswali",
"Surveys" => "Utafiti",
"Create questionnaires with multiple-choice or open-ended questions" => "Unda swali kwa maswali mengi au maswali yaliyokamilika",
"User-submitted Web links" => "Viungo vya Mtandao vinavyowasilishwa",
// "Sets of questions that can be presented, with the sessions timed and the scores recorded" => "Sets of questions that can be presented, with the sessions timed and the scores recorded",
// "Featured links" => "Featured links",
"A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc." => "Mfumo wa menyu rahisi ili kuonyesha kurasa za wavuti za nje kwenye kichupo kipya cha kivinjari au iframe ndani ya tovuti...",
"Copyright" => "Copyright",
"Use the Copyright Management System (or ©MS) to display the license of your content" => "Tumia Mfumo wa Usimamizi wa Hati miliki (au ©MS) ili kuonyesha leseni ya maudhui yako",
"Wiki references" => "Marejeo ya Wiki",
// "Permits using references and the reference library" => "Permits using references and the reference library",
// "Library references" => "Library references",
// "Enforce library reference as master" => "Enforce library reference as master",
// "Reference style" => "Reference style",
// "Default style when using references" => "Default style when using references",
// "AMA citation style (default)" => "AMA citation style (default)",
// "MLA citation style" => "MLA citation style",
// "Display reference in a popover" => "Display reference in a popover",
// "Display the details of the reference in a popover" => "Display the details of the reference in a popover",
"Shoutbox" => "Shoutbox",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
"Live support system" => "Mfumo wa usaidizi wa kuishi",
"One-on-one chatting with customer" => "Moja kwa moja anazungumza na mteja.",
"Tell a friend" => "Mwambie rafiki",
"Add to each page an \"Email this page\" link" => "Ongeza kwenye kila ukurasa \"kiungo cha ukurasa huu wa barua pepe\"",
"Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums" => "Ongeza kiungo \"Share\" katika kurasa zote ili kutuma kupitia barua pepe, Twitter, Facebook, ujumbe au vikao.",
"Be careful when allowing anonymous users to activate the antibot feature." => "Kuwa makini wakati wa kuruhusu watumiaji wasiojulikana kuamsha kipengele cha 'antibot'.",
"HTML pages" => "Kurasa za HTML",
"Static and dynamic HTML content" => "Maudhui yaliyomo na ya nguvu ya HTML",
"HTML can be used in wiki pages. This is a separate feature" => "HTML inaweza kutumika katika kurasa za wiki. Hii ni kipengele tofauti",
"Contact us" => "Wasiliana nasi",
"A basic contact form a visitor can use to contact the site admin" => "Fomu ya mawasiliano ya msingi mgeni anaweza kutumia kuwasiliana na msimamizi wa tovuti",
"Minichat" => "Minichat",
"Real-time group text chatting enabled through a module" => "Mjadala wa kikundi cha muda halisi.",
"Comments moderation" => "Maoni ya ufanisi",
"Enables the admin or other authorized group member to validate comments before they are visible" => "Inawezesha msimamizi au mshiriki mwingine wa mamlaka ya kuthibitisha maoni kabla ya kuonekana",
"Add author name in From email header" => "Ongeza jina la mwandishi kutoka Kwa kichwa cha barua pepe",
// "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"" => "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"",
"Comments locking" => "Maoni kufunga",
"Comments can be closed (no comments, or no new comments)" => "Maoni yanaweza kufungwa (hakuna maoni, au hakuna maoni mapya)",
// "Allow logged-in users to post comments anonymously" => "Allow logged-in users to post comments anonymously",
// "This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement" => "This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement",
// "Show the page description" => "Show the page description",
"Display the wiki page description between the page title and the page content" => "Onyesha maelezo ya ukurasa wa wiki kati ya kichwa cha ukurasa na maudhui ya ukurasa",
"Display page name as page title" => "Onyesha jina la ukurasa kama cheo cha ukurasa",
"Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title" => "Onyesha jina la ukurasa juu ya kila ukurasa kama cheo cha ukurasa. Ikiwa haijawezeshwa, maudhui ya ukurasa yanapaswa kuwa na kichwa cha h1 cha kufanya kazi kama cheo cha ukurasa, au maelezo ya ukurasa yanaweza kutumika kama kichwa",
// "Show the page ID" => "Show the page ID",
"Each wiki page has a numeric ID and this can be displayed" => "Kila ukurasa wa wiki una ID ya nambari na hii inaweza kuonyeshwa",
"Individual wiki cache" => "Cache ya kila wiki",
"Allow users to change the duration of the cache on a per-page basis" => "Ruhusu watumiaji kubadilisha muda wa cache kwa misingi ya kila ukurasa",
"Date picker for date selection" => "Kichukuaji cha tarehe kwa uteuzi wa tarehe",
// "JavaScript popup date selector (uses jQuery UI DatePicker)" => "JavaScript popup date selector (uses jQuery UI DatePicker)",
"Output should be HTML purified" => "Pato inapaswa kuwa iliyosafishwa kwa HTML",
"This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results" => "Hii inachukua Hifadhi ya HTML kwenye maudhui ya wiki na matokeo mengine, ili kufuta matatizo ya usalama kama uwezo wa XSS. Kumbuka kwamba Hifadhi ya HTML si HTML5 sambamba na inaweza kuandika upya HTML5 syntax, kutoa matokeo zisizohitajika",
"If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature." => "Ikiwa unatafuta kutumia HTML katika kurasa zako na inafutwa, unapaswa kuhakikisha kuwa HTML yako ni sahihi au haifunguzi kipengele hiki.",
"Full screen" => "Skrini kamili",
"Allow users to activate full-screen mode" => "Ruhusu watumiaji kuamsha mode kamili ya skrini",
// "CSS menus" => "CSS menus",
"Use CSS-styled (Suckerfish) vertical and horizontal menus" => "Tiki itatumia maonyesho ya CSS (Suckerfish) ya wima au ya usawa.",
"Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)" => "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)",
"Quick permission assignment" => "Kazi ya ruhusa ya haraka",
"Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object." => "Quickperms ni interface kwa kuongeza urekebishaji wa kawaida wa ruhusa, kwa ajili ya kazi ya haraka ya ruhusa ya ukurasa au kitu kingine.",
"User encryption" => "Ufichi wa Mtumiaji",
// "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored" => "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored",
"Enable personal, secure storage of sensitive data such as passwords" => "Wezesha Uhifadhi binafsi, salama wa data nyeti kama vile ya nywila",
// "This is an experimental feature. Using it may cause loss of the encrypted data" => "This is an experimental feature. Using it may cause loss of the encrypted data",
// "Password domains" => "Password domains",
// "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself" => "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself",
// "HTML purifier" => "HTML purifier",
"If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results." => "Ikiwa unatumia HTML katika ukurasa wako wa wiki na inafutwa au kuandikwa upya, hakikisha HTML yako ni sahihi, au kuacha kipengele hiki. Kumbuka kwamba Hifadhi ya HTML si HTML5 sambamba na inaweza kurejesha tena HTML5 syntax na kutoa matokeo zisizohitajika.",
"Ajax" => "Ajax",
// "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work" => "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work",
// "This feature is required for the interface for many features to work properly" => "This feature is required for the interface for many features to work properly",
"Webmail" => "Webmail",
"Intertiki" => "Intertiki",
"Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Inaruhusu maeneo kadhaa ya Tiki (watumwa) kupata uthibitisho kutoka kwa Tiki tovuti ya bwana",
"Mail-in" => "Maudhui ya barua zinazoingia",
"Create and publish wiki pages and articles via email" => "Unda na kuchapisha kurasa za wiki na makala kupitia barua pepe",
"Mindmap" => "Mindmap",
// "Display in a graphical way the connection among wiki pages" => "Display in a graphical way the connection among wiki pages",
"Print indexed" => "Chapisha kwa ujumla",
"Generate a printable version of the whole wiki or a subset of pages, filtered by category" => "Chapisha kwa ujumla",
"Spreadsheet" => "Spreadsheet",
"Spreadsheets with calculations and charts" => "Spreadsheets na mahesabu na chati.",
// "Slideshow (reveal.js)" => "Slideshow (reveal.js)",
"Create simple presentations via Wiki Syntax" => "Slideshow msingi wa wavuti",
// "Slideshow (reveal.js) PDF export" => "Slideshow (reveal.js) PDF export",
// "Wiki-page-based slideshow to pdf export" => "Wiki-page-based slideshow to pdf export",
"Invoice" => "Muswada",
"Invoice system" => "Mfumo wa muswada",
"Full WYSIWYG editor" => "Mhariri kamili wa WYSIWYG",
"WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience" => "WYSIWYG ni kifupi cha \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> hutumiwa kutoa uzoefu wa kubadilisha-neno kama mchakato.",
"Kaltura video management" => "Usimamizi wa video wa Kaltura",
// "Integration with the Kaltura video management platform" => "Integration with the Kaltura video management platform",
// "Friendship network" => "Friendship network",
"Users can identify other users as their friends" => "Watumiaji wanaweza kutambua watumiaji wengine kama marafiki zao",
"Banning system" => "Mfumo wa kuzuia",
"Deny access to specific users based on username, IP, and date/time range" => "Pata ufikiaji wa watumiaji maalum kulingana na jina la mtumiaji, IP, na upeo wa tarehe/wakati",
"Stats" => "Takwimu",
"Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Andika takwimu za msingi kuhusu vipengele vingi vya Tiki (idadi ya kurasa za wiki, ukubwa wa nyumba za faili, ...)",
// "Action calendar" => "Action calendar",
"Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page." => "Affiche un calendrier des événements reliés au système comme les modifications de pages wiki et les publications sur les forums ou sur les articles. Les jours contenant des événements affichent des liens vers la page du calendrier des actions.",
"Referrer stats" => "Takwimu za asili",
"Record domain name of sites that send visitors to this Tiki" => "Tuma jina la uwanja wa maeneo ambayo hutuma wageni kwenye Tiki hii",
"Redirect on error" => "Inaruhusiwa kwa kosa",
"On an error, refresh to the homepage as specified on the Admin General page" => "Kwa kosa, furahisha kwenye ukurasa wa nyumbani kama ilivyoelezwa kwenye ukurasa wa 'Admin General'",
"Communications (send/receive objects)" => "Mawasiliano (kutuma/kupokea vitu)",
"Send/receive wiki pages and articles between Tiki-powered sites" => "Tuma / kupokea kurasa za wiki na makala kati ya maeneo za Tiki",
"Display \"My Account\" in the application menu" => "Onyesha \"Akaunti Yangu\" katika orodha ya programu",
"Mini calendar" => "Kalenda ya kidogo",
// "Displays a personal calendar for each user" => "Displays a personal calendar for each user",
"User preferences screen" => "Mapendekezo ya skrini ya mtumiaji",
"User notepad" => "Kipeperushi ya Mtumiaji",
"My bookmarks" => "Vitambulisho vyangu",
"User contacts" => "Mawasiliano ya mtumiaji",
"User watches" => "Ufuatiliaji ya watumiaji",
// "Receive email notification of changes. Each user can choose to be notified of changes to specific items" => "Receive email notification of changes. Each user can choose to be notified of changes to specific items",
"Group watches" => "Ufuatiliaji ya makundi",
// "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group" => "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group",
"Daily reports for user watches" => " Ripoti ya kila siku ya ufuatiliaji ya watumiaji",
// "Allows you to schedule daily reports of watches to be sent (batched) at specific times" => "Allows you to schedule daily reports of watches to be sent (batched) at specific times",
"User watches translations" => "Tafsiri za ufuatiliaji ya watumiaji",
"User watches languages" => "Lugha ya ufuatiliaji ya watumiaji",
"Watch language-specific changes within a category" => "Tazama mabadiliko maalum ya lugha ndani ya kikundi",
// "User menu" => "User menu",
"Unmaintained feature" => "Kipengele ambacho hakitumiki",
"User tasks" => "Kazi za mtumiaji",
"User messages" => "Ujumbe wa mtumiaji",
// "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group)." => "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group).",
"User files" => "Faili za Mtumiaji",
"Menu user levels" => "Viwango vya mtumiaji wa menyu",
"Enables control of the per-group visibility of menu options" => "Inawezesha udhibiti wa kikundi cha kila kikundi cha chaguzi.",
"Group alert" => "Tahadhari ya kikundi",
"Integrator" => "Integrator",
"XMLRPC API" => "XMLRPC API",
"Debugger console" => "Debugger console",
// "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions" => "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions",
"Only viewable by admins" => "Inaonekana tu kwa admins",
// "Not suitable for production use" => "Not suitable for production use",
"TikiTests" => "TikiTests",
"Permits recording and playback of functional tests" => "Inaruhusu kurekodi na uchezaji wa vipimo vya kazi",
"Check for updates automatically" => "Angalia kwa sasisho moja kwa moja",
"Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection" => "Tiki itafuta moja kwa moja sasisho mpya kila wakati unapofikia ukurasa wa Mwanzo wa Msimamizi, kulingana na uteuzi wako wa mzunguko wa Angalia",
"Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters" => "Kujiunga na jarida la Tiki kuambiwa habari. https://doc.tiki.org/Newsletters",
// "Require confirmation of an action if a possible CSRF is detected" => "Require confirmation of an action if a possible CSRF is detected",
// "Deprecated. Using may cause false errors" => "Deprecated. Using may cause false errors",
"Detect browser language" => "Tambua lugha ya kivinjari",
"Look up the user's preferred language through browser preferences" => "Angalia lugha ya mtumiaji iliyopendekezwa kupitia upendeleo wa kivinjari",
"Show pages in user's preferred language" => "Onyesha kurasa katika lugha iliyopendekezwa na mtumiaji",
"When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences" => "Unapopata ukurasa unao sawa na lugha iliyopendekezwa na mtumiaji, fanya ukurasa uliotafsiriwa. Kulingana na mapendekezo ya Tiki ya mtumiaji",
// "Synchronize page and site language" => "Synchronize page and site language",
"Changing the page language also changes the site language" => "Kubadilisha lugha ya ukurasa pia kunabadilisha lugha ya tovuti",
"Translation assistant" => "Tafsiri msaidizi",
"Track translation operations between pages" => "Fuatilia shughuli za kutafsiri kati ya kurasa",
"Urgent translation notifications" => "Arifa za tafsiri za haraka",
// "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users" => "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users",
"Incomplete translation notice" => "Ilani ya kutafsiri isiyo kamili",
"When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete" => "Wakati ukurasa utafsiriwa kwa lugha mpya, taarifa itaingizwa moja kwa moja kwenye ukurasa ili kuonyesha kwamba tafsiri bado haijahitimishwa",
"Multilingual structures" => "Miundo ya lugha nyingi",
// "Structures search for equivalent pages in other languages" => "Structures search for equivalent pages in other languages",
// "May cause performance problems with larger structures" => "May cause performance problems with larger structures",
"Display all languages in a single page" => "Onyesha lugha zote katika ukurasa mmoja",
// "List all languages as options in the page-language dropdown list, to see them all at once" => "List all languages as options in the page-language dropdown list, to see them all at once",
"GZip output" => "Wezesha compression za GZip za kurasa",
"Compress your pages on-the-fly, if the requesting browser supports this" => "Compress kurasa zako sasa, kama kivinjari cha kuomba kinasaidia hili",
// "Help system" => "Help system",
// "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/" => "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/",
"Smileys" => "Smileys",
"Also known as emoticons" => "Pia inajulikana kama emoticons",
// "Tagging users" => "Tagging users",
// "Add support for @username mentions" => "Add support for @username mentions",
// "User mention notifications" => "User mention notifications",
// "Add support for @username mentions notifications" => "Add support for @username mentions notifications",
"Draw (SVG edit)" => "Chora (hariri SVG)",
"Draw enables creating and editing SVG images in all wiki text areas" => "Chora itawezesha kuunda na kuhariri picha za SVG katika maeneo yote ya maandishi ya wiki",
// "Draw (SVG edit) hide buttons" => "Draw (SVG edit) hide buttons",
// "Hide buttons in Draw, HTML id, comma-separated" => "Hide buttons in Draw, HTML id, comma-separated",
// "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"" => "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"",
// "Separate base image" => "Separate base image",
// "Leaves the initially edited image as a separate file and stores the drawing separately" => "Leaves the initially edited image as a separate file and stores the drawing separately",
// "Draw in user file gallery" => "Draw in user file gallery",
"Docs (WebODF)" => "Docs (WebODF)",
// "Docs enables viewing and editing Open Document Format files" => "Docs enables viewing and editing Open Document Format files",
"Dynamic content system" => "Mfumo wa maudhui ya nguvu",
// "Block of content which can be reused and programmed (timed)" => "Block of content which can be reused and programmed (timed)",
"Use file galleries to store images" => "Tumia nyumba za faili kuhifadhi picha",
"If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead" => "Ikiwa haijawezeshwa, picha zitahifadhiwa kwenye mfumo wa faili, katika saraka ya /img/wiki_up, badala yake",
"External link icon" => "Picha ndogo ya kiungo cha nje",
// "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set" => "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set",
"Add \"rel=nofollow\" to external links" => "Ongeza \"rel=nofollow\" kwenye viungo vya nje",
"Semantic links" => "Viungo vya Semantic",
"Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages" => "Kwenda zaidi ya kazi za Backlinks, hii inaruhusu mahusiano fulani ya semantic kuelezea kati ya kurasa za wiki",
// "Web services" => "Web services",
"Can receive web services via JSON or YAML" => "Inaweza kupokea huduma za wavuti kupitia JSON au YAML",
"Use folder icons for menu section (parent) items" => "Tumia icons za folda kwa vitu vya sehemu (mzazi) vitu",
// "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)" => "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)",
"Breadcrumbs" => "Breadcrumbs",
"Indicates the navigation path through parent pages to the current page" => "Inaonyesha njia ya urambazaji kupitia kurasa za mzazi kwenye ukurasa wa sasa",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Wahariri wasiojulikana lazima waingie msimbo wa kupambana na bot (CAPTCHA)",
// "Use CAPTCHA to ensure that anonymous input is from a person" => "Use CAPTCHA to ensure that anonymous input is from a person",
"Protect email against spam" => "Tetea barua pepe dhidi ya barua taka",
// "Protect email against spam submissions" => "Protect email against spam submissions",
"Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Jilinde barua pepe dhidi ya barua taka sasa haifanyi kazi katika kurasa zilizopangwa katika hali ya WYSIWYG (Tiki 6.1)",
// "Site ads" => "Site ads",
// "Enable advertising" => "Enable advertising",
// "Activate will display content for Admin only. Select Publish to display for all users" => "Activate will display content for Admin only. Select Publish to display for all users",
"Anonymous voting" => "Uchaguzi usiojulikana",
// "Allow anonymous users to participate in voting" => "Allow anonymous users to participate in voting",
// "This can be overridden by specific permissions" => "This can be overridden by specific permissions",
"Allow re-voting" => "Ruhusu kupiga kura tena",
// "Visitors can vote mulitiple times in a poll" => "Visitors can vote mulitiple times in a poll",
// "When logged in, Tiki tracks users by username or otherwise IP address" => "When logged in, Tiki tracks users by username or otherwise IP address",
"Comments for polls" => "Maoni ya uchaguzi",
"Comments for FAQs" => "Maoni kwa Maswali",
"Search engine friendly URL" => "URL fupi (SEFURL)",
"If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config" => "Ikiwa tovuti iko kutumia Apache, unaweza kutaja tena _htaccess kama .htaccess kutumia URL fupi. On IIS, rename tena web_config kama web.config",
// "SEFURL postfilter" => "SEFURL postfilter",
// "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead" => "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead",
// "Article title in SEFURL" => "Article title in SEFURL",
// "The article title rather than article number can be displayed in the search engine friendly URL" => "The article title rather than article number can be displayed in the search engine friendly URL",
// "Blog title in SEFURL" => "Blog title in SEFURL",
// "The blog title rather than blog number can be displayed in the search engine friendly URL" => "The blog title rather than blog number can be displayed in the search engine friendly URL",
// "Display forum thread or forum post title in the search engine friendly URL" => "Display forum thread or forum post title in the search engine friendly URL",
// "Tracker title in SEFURL" => "Tracker title in SEFURL",
// "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`" => "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`",
// "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)" => "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)",
// "Limit the number of characters in the tracker item or forum thread title" => "Limit the number of characters in the tracker item or forum thread title",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
"This redirection uses the wiki prefix alias feature" => "Urejesho huu hutumia kipengele 'wiki prefix alias'",
"Canonical URL tag" => "Kitambulisho cha URL cha Kikannoni",
"Indicates to search engines which URL to use, to prevent duplicate listings" => "Inasema injini za utafutaji ambazo URL hutumia ambayo inepuka marudio kwenye orodha",
// "Canonical URL domain" => "Canonical URL domain",
// "Custom Routes" => "Custom Routes",
// "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL" => "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL",
"Show module controls" => "Onyesha udhibiti wa moduli",
// "Enable controls in modules" => "Enable controls in modules",
"Perspectives" => "Mtazamo",
"Permits overriding of preferences" => "Inakuwezesha kupendeza upendeleo",
"Search and replace" => "Utafute na uweke nafasi",
"Enables finding and replacing of content in the edit box" => "Inawezesha kutafuta na kubadilisha maudhui katika sanduku la hariri",
"Submissions" => "Mawasilisho",
// "Articles can be submitted but need to be approved before they are published" => "Articles can be submitted but need to be approved before they are published",
// "Users can see several charts or rankings about the item" => "Users can see several charts or rankings about the item",
"Comments on articles" => "Maoni kwenye makala",
// "Users with permission can post or reply to comments. The comments will appear at the bottom of the page" => "Users with permission can post or reply to comments. The comments will appear at the bottom of the page",
"Article content templates" => "Nyaraka za maudhui ya makala",
// "Predefined content for an article" => "Predefined content for an article",
// "template article news" => "template article news",
// "Print articles" => "Print articles",
"Specify notification emails when creating articles" => "Taja barua pepe za arifa wakati wa kuunda makala",
// "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation" => "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation",
"ShareThis buttons" => "Vifungo 'ShareThis'",
// "Enable sharing site content via ShareThis" => "Enable sharing site content via ShareThis",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
// "Category path" => "Category path",
"Show the category tree above the wiki page" => "Onyesha mti wa jamii juu ya ukurasa wa wiki",
"Show category objects" => "Onyesha vitu vya jamii",
"Show, at the bottom of the wiki page, objects in the same category" => "Onyesha, chini ya ukurasa wa wiki, vitu katika jamii sawa",
"Ignore category viewing restrictions" => "Puuza vikwazo vya kutazama jamii",
// "Display items the user may not be entitled to view in search results" => "Display items the user may not be entitled to view in search results",
"Will improve performance, but may show forbidden results" => "Utaboresha utendaji, lakini inaweza kuonyesha matokeo yaliyokatazwa",
"List pages" => "Orodha ya kurasa",
// "Allow viewing the wiki page list" => "Allow viewing the wiki page list",
"Latest changes" => "Mabadiliko ya hivi karibuni",
// "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display." => "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display.",
"Orphan pages" => "Ukurasa yatima",
// "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)" => "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)",
"MySQL full-text search" => "Utafutaji wa maandishi kamili wa MySQL",
"Referer search highlighting" => "Kuonyesha kituo cha taka",
// "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility" => "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility",
"Search statistics" => "Takwimu za Utafiti",
// "Enables administrators to collect and view statistics on search activity" => "Enables administrators to collect and view statistics on search activity",
"Ignore individual object permissions" => "Puuza ruhusa za kibinafsi",
"Object filter" => "Chujio cha kitu",
// "Enables object type filters to be displayed above the search results to further reduce search results by object type" => "Enables object type filters to be displayed above the search results to further reduce search results by object type",
"Search box" => "Sanduku la Utafutaji",
// "Shows a search box above the search results to do additional searches" => "Shows a search box above the search results to do additional searches",
// "Include the number of visits in the search results" => "Include the number of visits in the search results",
"Relevance" => "Umuhimu",
// "Display Tiki's estimate of the relevance of search matches in the search results" => "Display Tiki's estimate of the relevance of search matches in the search results",
"Object type" => "Aina ya kitu",
// "Shows object type filters above the search results to further reduce search results by object type" => "Shows object type filters above the search results to further reduce search results by object type",
"Last-modified date" => "Tarehe ya mwisho iliyopita",
// "Show the last-modified date in search results" => "Show the last-modified date in search results",
// "Users can see several charts or rankings about the page" => "Users can see several charts or rankings about the page",
"Custom blog headings" => "Mandhari ya kichwa cha blogu",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead",
"Publish dates can be modified" => "Kuchapisha tarehe inaweza kubadilishwa",
"Blog post Comments" => "Maoni katika post ya blogu",
// "Users can view the “top” or “most” downloaded files" => "Users can view the “top” or “most” downloaded files",
"File gallery comments" => "Maoni ya nyumba ya faili",
// "Store user files in a file gallery" => "Store user files in a file gallery",
// "Use the file gallery admin and the individual file gallery settings to manage file storage preferences" => "Use the file gallery admin and the individual file gallery settings to manage file storage preferences",
// "userfiles" => "userfiles",
"Use file galleries for wiki attachments" => "Tumia nyumba za faili kwa vifungo vya wiki",
// "Wiki attachments will be stored in the file gallery" => "Wiki attachments will be stored in the file gallery",
"Batch uploading" => "Pakia kipande",
// "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature" => "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature",
"Accept wiki syntax" => "Pata syntax ya wiki",
"Topic archiving" => "Nyaraka za kumbukumbu",
"Quick jumps" => "Kuruka haraka",
"Replies are empty" => "Jibu ni tupu",
"If disabled, replies will quote the original post" => "Ikiwa imezimwa, majibu yatapiga chapisho la awali.",
// "Allows quoting in flat forums" => "Allows quoting in flat forums",
// "Allows users to reply" => "Allows users to reply",
"First post of a thread can have an empty body" => "Chapisho la kwanza la thread linaweza kuwa na mwili usio na kitu.",
"Will be a thread title" => "Itakuwa kichwa cha thread",
"Forum name search" => "Utafutaji jina la jukwaa",
"When listing forums" => "Wakati wa orodha ya vikao",
"Forum content search" => "Utafutaji wa maudhui ya kikao",
"Topic content search" => "Utafutaji wa maudhui ya sura",
"Tiki-indexed search" => "Tafuta kwa haraka ya Tiki",
"Use database (full-text) search" => "Tumia utafutaji wa database (full-text)",
// "Index posts on forum section change" => "Index posts on forum section change",
// "Re-indexes forum posts to match the parent section when the section is changed" => "Re-indexes forum posts to match the parent section when the section is changed",
"Edit CSS" => "Badilisha CSS",
// "Edit CSS files directly in the browser" => "Edit CSS files directly in the browser",
// "May not be functional in Tiki 14+" => "May not be functional in Tiki 14+",
"Theme Control" => "Udhibiti wa Mandhari",
// "Assign different themes to various sections, categories, and objects" => "Assign different themes to various sections, categories, and objects",
"design themes" => "Kubuni mandhari",
"Tiki template viewing" => "Kuangalia template ya Tiki",
"Edit templates" => "Badilisha mifano",
// "Custom HTML head content" => "Custom HTML head content",
// "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here" => "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here",
// "Add base tag in the HTML head section" => "Add base tag in the HTML head section",
// "The base tag specifies a default address for all links on a page" => "The base tag specifies a default address for all links on a page",
"Site logo and title" => "Kichwa na alama ya tovuti",
// "Display a site logo image and/or title in the page header area" => "Display a site logo image and/or title in the page header area",
// "This setting is expected to be moved from here to the admin-modules page" => "This setting is expected to be moved from here to the admin-modules page",
"Left column" => "Safu ya kushoto",
"Controls visibility of the left column of modules" => "Inadhibiti uonekano wa safu ya kushoto ya modules",
"sidebar" => "sidebar",
"Only if one or more modules are assigned" => "Ni tu ikiwa moduli moja au zaidi hutolewa",
"Always" => "Kila mara",
"User decides" => "Mtumiaji anaamua",
"Right column" => "Safu ya kuume",
"Controls visibility of the right column of modules" => "Inadhibiti uonekano wa safu ya kuume ya modules",
"Prefix breadcrumbs with \"Location : \"" => "Tangulia jina ya breadcrumbs na \"Mahali: \"",
// "Place the term \"Location:\" in the breadcrumbs" => "Place the term \"Location:\" in the breadcrumbs",
"Site location bar" => "Breadcrumbs ya tovuti",
// "Use breadcrumbs module" => "Use breadcrumbs module",
"Top of center column" => "Juu ya safu ya kituo",
// "Larger font" => "Larger font",
"Entire location" => "Eneo lote",
"Page name" => "Jina la ukurasa",
"Use page description" => "Tumia maelezo ya ukurasa",
"Extreme top of page, above the site logo, etc" => "Juu ya ukurasa",
// "Custom code just before the closing </body> tag" => "Custom code just before the closing </body> tag",
// "Enter lines here to be placed near the end of the HTML file" => "Enter lines here to be placed near the end of the HTML file",
"Webmaster report" => "Ripoti kwa msimamizi wa wavuti",
// "Activate the feature to report a problematic page to the webmaster." => "Activate the feature to report a problematic page to the webmaster.",
"Webmaster email" => "Barua pepe ya msimamizi wa wavuti",
"Leave blank to use the default sender email" => "Acha tupu ili kutumia barua pepe ya mtumaji",
// "A specific email address can be set for receiving the webmaster reports" => "A specific email address can be set for receiving the webmaster reports",
"Email this page" => "Tuma barua pepe hii",
"Adds a link at the bottom if set, otherwise adds a link at the top" => "Ongeza kiungo chini ikiwa imewekwa, vinginevyo inaongeza kiungo hapo juu",
// "This enables users to share a page with others, by emailing a short message and link to the page" => "This enables users to share a page with others, by emailing a short message and link to the page",
"Shadow layer" => "Safu ya kivuli",
"Additional div elements for shadows, radiused corners or other decorative styling" => "Vifungo vingine vya vivuli, masanduku ya mviringo au mtindo mwingine wa mapambo",
"Tooltips" => "Vifaa",
// "Enable tooltips such as this to have a custom appearance, styled by CSS" => "Enable tooltips such as this to have a custom appearance, styled by CSS",
"Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc" => "Inatoa menus mbalimbali za kushuka kwenye masanduku mengi ya maandishi ya maandishi ya majina ya ukurasa, majina ya watumiaji, vikundi, vitambulisho, na zingine...",
"Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
"Reflection" => "Reflection",
// "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"" => "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"",
"JQuery UI" => "JQuery UI",
"Include jQuery UI library. Enables a number of interface features" => "Jumuisha maktaba ya UI ya jQuery. Inawezesha vipengele vya interface",
"jQuery UI theme" => "jQuery UI theme",
"jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc" => "jQuery UI theme. Inatumika katika popups fulani za modal na katika kipengele cha TikiSheet",
"Validation" => "Uthibitishaji",
"Provides various validation possibilities such as for trackers" => "Hutoa uwezekano wa kuthibitisha mbalimbali kama vile trackers",
// "jQuery infinite carousel" => "jQuery infinite carousel",
// "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel" => "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel",
// "jQuery sortable tables" => "jQuery sortable tables",
// "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables" => "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables",
// "jQuery media" => "jQuery media",
// "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used" => "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used",
// "TagCanvas" => "TagCanvas",
// "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud" => "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud",
// "jQuery zoom" => "jQuery zoom",
// "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"" => "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"",
"Use tabs" => "Tumia tabs",
// "Separates page content into tabbed panels" => "Separates page content into tabbed panels",
"Wiki content templates" => "Nyaraka za maudhui ya Wiki",
// "Prewritten content (probably partial content) for a wiki page" => "Prewritten content (probably partial content) for a wiki page",
"Warn on edit conflict" => "Onyesha ikiwa kuna mgogoro wa mabadiliko",
// "When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages" => "When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages",
"Undo" => "Futa",
"Footnotes" => "Maelezo ya chini",
// "Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages." => "Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages.",
"Allow HTML" => "Ruhusu HTML",
// "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code",
// "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus" => "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus",
"Log bytes changes (+/-) in action logs" => "Ingia mabadiliko ya tote (+/-) katika logi ya kitendo",
"May impact performance" => "Inaweza kuathiri utendaji",
"Sandbox" => "Sandbox",
// "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved" => "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved",
"Comments below wiki pages" => "Maoni hapa chini ya kurasa za wiki",
"Allow users to upload images to a page" => "Ruhusu watumiaji kupakia picha kwenye ukurasa",
// "Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)" => "Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)",
"WikiWords" => "WikiWords",
// "Automatically convert \\\"CamelCase\\\" words into wiki links" => "Automatically convert \\\"CamelCase\\\" words into wiki links",
"Link plural WikiWords to their singular forms" => "Unganisha WikiWords kwa aina zao za umoja",
"Accept dashes and underscores in WikiWords" => "Kubali '...' na '_' katika WikiWords",
"History" => "Historia",
// "Users (with permission) can see the history of each wiki page" => "Users (with permission) can see the history of each wiki page",
"Display IP address" => "Onyesha anwani ya IP",
"Wiki full history" => "Historia kamili ya Wiki",
"Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Rekodi matoleo yote, badala ya tu maudhui ya ukurasa au maelezo ya mabadiliko au wakati maoni ya hariri yanapotolewa",
"View page contributions by author" => "Tazama michango ya ukurasa na mwandishi",
"Visualize the contributions that different authors have made to a wiki page" => "Tazama michango ambayo waandishi tofauti wamefanya kwenye ukurasa wa wiki",
"Discuss pages on forums" => "Jadili kurasa kwenye vikao",
// "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page" => "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page",
"View source" => "Tazama chanzo",
// "Users (with permission) can see the wiki and/or HTML syntax of the page" => "Users (with permission) can see the wiki and/or HTML syntax of the page",
// "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”" => "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”",
// "Present a list of pages that link to the current page" => "Present a list of pages that link to the current page",
"Similar pages" => "Kurasa zinazofanana",
// "Display a list of pages named similarly to the current page" => "Display a list of pages named similarly to the current page",
"Structures" => "Miundo",
// "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document" => "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document",
// "Structures drill down menu" => "Structures drill down menu",
// "Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down" => "Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down",
"Open page as structure" => "Fungua ukurasa kama muundo",
// "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL" => "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL",
"Make structure from page" => "Fanya muundo kutoka kwa ukurasa",
// "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure" => "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure",
"Categorize structure pages together" => "Panga kurasa za muundo pamoja",
// "Place new pages of a structure in the same category as the structure's root page" => "Place new pages of a structure in the same category as the structure's root page",
// "Disable inherited direct object permissions" => "Disable inherited direct object permissions",
// "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure" => "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure",
"Create webhelp from structure" => "Unda webhelp kutoka kwa muundo",
// "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format" => "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format",
"Import HTML" => "Ingiza HTML",
// "Enable import of HTML pages" => "Enable import of HTML pages",
"Use date parameter" => "Tumia parameter ya tarehe",
// "Allow wiki page version to be selected from a parameter \"date\" on the url" => "Allow wiki page version to be selected from a parameter \"date\" on the url",
"Report it in wiki links" => "Ripoti kwa viungo vya wiki",
// "Add the date parameter to wiki links" => "Add the date parameter to wiki links",
"Import pages" => "Weka kurasa",
"A personal wiki page for each user" => "Ukurasa wa wiki binafsi kwa kila mtumiaji",
"Userpage prefix" => "Kiambatisho cha ukurasa wa mtumiaji",
"All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required" => "Kurasa zote za mtumiaji hushiriki kiambishi cha kawaida. Uwasilishaji wa kiambishi awali na jina la mtumiaji utazalisha jina la ukurasa. Kiambishi awali hawezi kuwa tupu",
"Users can lock pages" => "Watumiaji wanaweza kufunga kurasa",
// "Enable users to lock pages and so prevent others from editing them" => "Enable users to lock pages and so prevent others from editing them",
"MultiPrint" => "Machapisho mengi",
// "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document" => "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document",
// "Print Wiki" => "Print Wiki",
// "Provide a print icon and layout of the wiki page formatted for printing" => "Provide a print icon and layout of the wiki page formatted for printing",
"Pages not in structure" => "Kurasa si katika muundo",
// "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display" => "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display",
"Attachments" => "Viambatisho",
"Allow users to upload (attach) files to a page" => "Ruhusu watumiaji kupakia faili kwenye ukurasa",
"Limit wiki page categories to those under this category" => "Weka makundi ya ukurasa wa wiki kwa wale walio chini ya jamii hii",
"If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"" => "Ikiwa ujumbe wa hitilafu unaonyesha jamii inayohitajika inahitajika wakati wa kuhariri ukurasa wa wiki, chagua chaguo hili kwa \"None\"",
"Show/hide icon before headings" => "Onyesha/Ficha icon kabla ya vichwa",
// "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below" => "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below",
"Wiki argument variables" => "Vigezo vya hoja za Wiki",
"Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Ruhusu vigezo vya kuandika kwa maudhui ya wiki kwa {{paramname}} au {{paramname|default}} - kesi maalum {{page}} {{user}}",
"Users can choose to stay in SSL mode after an HTTPS login" => "Watumiaji wanaweza kuchagua kukaa katika mfumo wa SSL baada ya kuingia kwa HTTPS",
"Users can switch between secured or standard mode at login" => "Watumiaji wanaweza kubadili kati ya hali ya salama au ya kawaida wakati wa kuingia",
"Wiki paragraph formatting" => "Kuweka vifungu katika Wiki",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Kwa sababu kipengele cha formatting ya Wiki kinachozimwa, kila mstari utawasilishwa unapoandika. Hii ina maana kwamba ikiwa unataka vifungu vifuniwe vyema, kifungu kinapaswa kuwa pamoja kwenye mstari mmoja.",
"Create line breaks within paragraphs" => "Unda mapumziko ya mstari ndani ya aya",
// "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs" => "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs",
"Automonospaced text" => "Nakala ya kawaida iliyowekwa",
// "Lines indented with spaces will automatically be converted to monospace font" => "Lines indented with spaces will automatically be converted to monospace font",
"Tables syntax" => "syntax ya meza",
"|| for rows" => "|| kwa safu",
"<return> for rows" => "<return> kwa safu",
"AutoLinks" => "Viungo vya moja kwa moja",
"Web (http://) and email addresses will automatically be converted to links" => "Mtandao (http://) na anwani za barua pepe utajibadilisha kwa viungo",
"Hotwords" => "Hotwords",
"Open hotwords in new window" => "Fungua hotwords katika dirisha jipya",
"Characters that limit a hotword" => "Maandiko kutumia kutangaza hotword",
"Use Quote plugin rather than \">\" for quoting" => "Tumia Plugin ya Quote kuliko \">\" kwa kunukuu",
"Center text using ::: instead of ::" => "kwa Maandishi ya Kituo kwa kutumia ::: badala ya ::",
// "Useful to avoid conflicts with C++ scope operators or default namespace separator" => "Useful to avoid conflicts with C++ scope operators or default namespace separator",
"String to use to delimit simplebox" => "Maandiko kutumia kutangaza simplebox",
"Users can choose to show their gender" => "Watumiaji wanaweza kuchagua kuonyesha jinsia yao",
"Real name" => "Jina halisi",
"Gender" => "Jinsia",
// "Profile picture (avatar)" => "Profile picture (avatar)",
"Country" => "Nchi",
"Last login" => "Kuingia kwa mwisho",
"Distance" => "Umbali",
"Manual selection of time/date" => "Uchaguzi wa mwongozo wa muda/tarehe",
"WebDAV access to Tiki" => "Ufikiaji wa WebDAV kwa Tiki",
"Allow file gallery access with WebDAV" => "Ruhusu ufikiaji wa faili na WebDAV",
"use tiki-webdav.php as the URI of the WebDAV repository" => "tumia tiki-webdav.php kama URI ya hifadhi ya WebDAV",
"Fixed width" => "Upana usiohamishika",
"Restrict the width of the site content area, in contrast to a liquid (full-width) layout" => "Inaweka upana wa maonyesho yaliyomo ya tovuti",
"Social networks" => "Mitandao ya kijamii",
"Integration with social applications and networks like Twitter and Facebook" => "Ushirikiano na matumizi ya kijamii na mitandao kama Twitter na Facebook",
// "Group transition" => "Group transition",
"Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Inawezesha mabadiliko kwa watumiaji kati ya makundi tofauti. Mabadiliko yatatengeneza kazi ya kupitishwa kwa mtumiaji",
// "Category transition" => "Category transition",
"Enables transitions for objects between different categories. Transitions will create a document workflow" => "Inawezesha mabadiliko ya vitu kati ya makundi tofauti. Mabadiliko yataunda uendeshaji wa hati",
"Tiki user credits" => "Mkopo wa mtumiaji wa Tiki",
"Invite users" => "Paribisha watumiaji",
// "Allow users to invite new users to register at this site, by sending an email" => "Allow users to invite new users to register at this site, by sending an email",
// "Alternate registration page" => "Alternate registration page",
// "Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page" => "Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page",
"Load balancer" => "Mzigo wa balancer",
"Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server" => "Fanya hii tu ikiwa seva ni nyuma ya balancer ya mzigo (au 'reverse proxy'). Hii inawezesha kuingia IP ya mtumiaji badala ya IP ya seva ya proxy",
// "Tiki is behind a frontend-proxy/load-balancer that rewrites ports" => "Tiki is behind a frontend-proxy/load-balancer that rewrites ports",
// "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links" => "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links",
"Accounting" => "Uhasibu",
"Double-entry accounting system" => "Mfumo wa uhasibu wa kuingia mara mbili",
"Code editor (CodeMirror)" => "Mhariri wa Code (CodeMirror)",
// "CodeMirror code editor, which provides syntax highlighting" => "CodeMirror code editor, which provides syntax highlighting",
// "Syntax highlighter (CodeMirror) Theme" => "Syntax highlighter (CodeMirror) Theme",
// "CodeMirror themes (clear cache after changing)" => "CodeMirror themes (clear cache after changing)",
"default" => "chaguo-msingi",
"Off (but switchable)" => "Off (lakini inaweza kubadilika)",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference. HTML may be used" => "This is useful for developers to learn how to create a new preference. HTML may be used",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint. Wiki syntax may be used" => "This is the hint. Wiki syntax may be used",
// "This is the shorthint. Wiki syntax may be used" => "This is the shorthint. Wiki syntax may be used",
// "Time sheet" => "Time sheet",
"A project time manager" => "Meneja wa wakati wa mradi",
// "This feature will be removed after Tiki18 and before Tiki19" => "This feature will be removed after Tiki18 and before Tiki19",
// "HTML feed" => "HTML feed",
"A way to transfer HTML content from one Tiki site to another" => "Njia ya kuhamisha maudhui ya HTML kwenye tovuti moja ya Tiki hadi nyingine",
"Send an email notification to group leaders when a user joins" => "Tuma taarifa ya barua pepe kwa viongozi wa kikundi wakati mtumiaji anajiunga",
"Send an email notification to group leaders when a user leaves" => "Tuma taarifa ya barua pepe kwa viongozi wa kikundi wakati mtumiaji anaondoka",
"Inline comments" => "Maoni katika mstari moja",
// "Contextual comments" => "Contextual comments",
"Enable JavaScript plugin for equal-height rows" => "Wezesha programu ya JavaScript kwa safu za urefu sawa",
// "Enable responsive rows, the contained elements of which have the same height" => "Enable responsive rows, the contained elements of which have the same height",
"Conditional formatting" => "Kufungia masharti",
// "Use different coloring for certain system objects. Only groups are supported for now" => "Use different coloring for certain system objects. Only groups are supported for now",
// "Store session variable for current theme" => "Store session variable for current theme",
// "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing" => "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing",
// "Parent category of theme control categories" => "Parent category of theme control categories",
// "Choose the parent category of categories used for theme control" => "Choose the parent category of categories used for theme control",
// "Automatically select the theme-control category of the current theme when categorizing" => "Automatically select the theme-control category of the current theme when categorizing",
// "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme" => "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme",
// "Certain pages redirect to homepage when language is changed" => "Certain pages redirect to homepage when language is changed",
// "List of pages that redirect" => "List of pages that redirect",
// "List of names of pages that always redirect to the homepage when the language is switched" => "List of names of pages that always redirect to the homepage when the language is switched",
// "Separate page names by commas" => "Separate page names by commas",
"User wizard" => "Msaidizi wa mtumiaji",
// "Wizard to help users set up their basic settings and account details" => "Wizard to help users set up their basic settings and account details",
// "Present different input fields in the User Wizard than are in the Registration form" => "Present different input fields in the User Wizard than are in the Registration form",
// "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form" => "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form",
// "Tracker fields presented in the User Wizard as User Details" => "Tracker fields presented in the User Wizard as User Details",
// "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)" => "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)",
"Enable Typography Features" => "Wezesha vipengele vya uchapaji",
// "Features to replace normal characters with typographic equivalents" => "Features to replace normal characters with typographic equivalents",
"Smart “curly” quotes" => "Quotes za \"kinga\" za alama za nukuu",
"Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes" => "Inabadilisha alama za nukuu \\\"moja kwa moja\\\" katika \"quotes\", pia hugeuka apostrophe na quotes moja",
"Convert approximative ASCII quotes" => "Badilisha alama za quotation za ASCII",
// "Convert plain-ASCII quote substitutes `` '\\" => "Convert plain-ASCII quote substitutes `` '\\",
"Smart em-dash and ellipsis" => "'-' na '...'",
"Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…" => "Badilisha '--' ku '—' na '…' kwa tabia ya uchapishaji wa ellipsis",
"Smart no-break space" => "Njia isiyo na kuvunja ya Smart",
"Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it." => "Inaleta mapumziko ya mstari kutoka kwenye nafasi za bahati mbaya katika maandiko kwa kuchukua nafasi ya tabia ya kawaida ya nafasi na nafasi za kuvunja hakuna ambapo inafaa: karibu na punctuation fulani, wakati unatumiwa kama separator elfu, na kati ya kitambulisho cha kitengo na namba iliyopita kabla yake.",
// "Display only select calendars by default" => "Display only select calendars by default",
// "Master Tiki server" => "Master Tiki server",
// "Master Tiki server that this client will obtain user authorizations from" => "Master Tiki server that this client will obtain user authorizations from",
// "Overrides manually registered local users" => "Overrides manually registered local users",
"Import user preferences" => "Weka mapendekezo ya mtumiaji",
// "Client Tiki will copy the user preferences from the master server" => "Client Tiki will copy the user preferences from the master server",
// "This will overwrite local user preferences every time the user logs in" => "This will overwrite local user preferences every time the user logs in",
"Import user groups" => "Ingiza makundi ya watumiaji",
// "Groups the user belongs to on the master server will be imported (along with their security definitions)" => "Groups the user belongs to on the master server will be imported (along with their security definitions)",
// "This will overwrite local groups every time a user logs in" => "This will overwrite local groups every time a user logs in",
// "Limit group import" => "Limit group import",
// "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation" => "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation",
// "This list will limit the group import feature to only those groups listed here" => "This list will limit the group import feature to only those groups listed here",
// "Intertiki shared cookie" => "Intertiki shared cookie",
// "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites" => "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites",
// "This site is a master server" => "This site is a master server",
"Scheduler" => " Mpangaji",
// "Provides the ability to run tasks at a scheduled time" => "Provides the ability to run tasks at a scheduled time",
"Convert from absolute to relative link" => "Badilisha kutoka kabisa hadi kiungo cha jamaa",
// "Process wiki text and convert internal links from absolute to relative links" => "Process wiki text and convert internal links from absolute to relative links",
// "It's recommended to set a cron job to periodically rebuild the search index" => "It's recommended to set a cron job to periodically rebuild the search index",
"HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "Hifadhi ya HTML ni maktaba ya kuzingatia viwango vya HTML vilivyoandikwa kwenye PHP na kuunganishwa katika Tiki. Msafishaji wa HTML hautaondoa tu msimbo wa malicious (unaojulikana zaidi kama XSS) na whitelist iliyohakikiwa kabisa, iliyo salama lakini inaruhusu, pia itahakikisha kuwa nyaraka zako ni viwango vinavyolingana. Kumbuka kwamba Hifadhi ya HTML si HTML5 sambamba na inaweza kurejesha tena HTML5 syntax na kutoa matokeo zisizohitajika",
"Show user's contribution on the user information page" => "Onyesha mchango wa mtumiaji kwenye ukurasa wa habari wa mtumiaji",
// "View user's contribution on the user information page" => "View user's contribution on the user information page",
// "Users' drawings are stored in their user files gallery" => "Users' drawings are stored in their user files gallery",
"Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index" => "'Nofollow' inatumiwa kufundisha injini za utafutaji ambazo kiunganisho haipaswi kuathiri cheo cha kiungo cha kiungo katika index ya injini ya utafutaji",
// "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised" => "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised",
// "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated" => "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated",
// "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6" => "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6",
"Require file creator's name for anonymous uploads" => "Inahitaji jina la mtunzi wa faili kwa kupakia bila kujulikana",
"Redirect to similar wiki page" => "Rejea kwenye ukurasa sawa wa wiki",
"If a requested page doesn't exist, redirect to a similarly named page" => "Ikiwa ukurasa uliotakiwa haipo, rejea kwenye ukurasa ulioitwa sawa",
"Redirect to page alias, if any" => "Rejea kwenye ukurasa wa bandia, ikiwa kuna",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
"User's information page" => "Ukurasa wa habari wa mtumiaji",
// "Display a user's gender if permitted by the user" => "Display a user's gender if permitted by the user",
// "Allow showing user's information on mouseover" => "Allow showing user's information on mouseover",
// "Show users' information on mouseover" => "Show users' information on mouseover",
"Requires user's information to be public" => "Inahitaji maelezo ya mtumiaji kuwa ya umma",
// "Show the user's real name" => "Show the user's real name",
"Federated search" => "Utafutaji wa shirikisho",
// "Search through alternate site indices" => "Search through alternate site indices",
"Elasticsearch is required" => "Elasticsearch inahitajika",
// "Elasticsearch tribe node URL" => "Elasticsearch tribe node URL",
// "URL of the tribe client node accessing multiple clusters" => "URL of the tribe client node accessing multiple clusters",
"Default feed format" => "Mpangilio wa mtiririko ya asili",
"ATOM 1.0" => "ATOM 1.0",
"RSS 2.0" => "RSS 2.0",
"Feed author name" => "jina la mwandishi wa mtiririko",
// "Default author of each item in the feed" => "Default author of each item in the feed",
"This field is mandatory unless both feed author email and homepage are empty." => "Uwanja huu ni lazima isipokuwa barua pepe zote za mwandishi na ukurasa wa nyumbani hazipo.",
"Feed author email" => "Barua pepe la mwandishi wa mtiririko",
// "Email of the author of each item in the feed" => "Email of the author of each item in the feed",
"Feed author homepage" => "Ukurasa wa mwanzo wa mwandishi wa mtiririko",
// "Homepage URL of the author of each item in the feed" => "Homepage URL of the author of each item in the feed",
"Feed editor email" => "Barua ya mhariri wa mtiririko",
"Email address for person responsible for editorial content" => "Anwani ya barua pepe kwa mtu anayehusika na maudhui ya uhariri",
"Feed webmaster email" => "Barua pepe la msimamizi wa wavuti wa mtiririko",
"Email address for person responsible for technical issues relating to channel" => "Anwani ya barua pepe kwa mtu anayehusika na masuala ya kiufundi yanayohusiana na kituo",
"Feed image path" => "Njia ya picha ya feed",
"Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Inabainisha picha ya GIF, JPEG au PNG ambayo inaweza kuonyeshwa na mtiririko",
"Feed language" => "Lugha ya feed",
// "The default language for this feed" => "The default language for this feed",
"RSS basic authentication" => "Usahihi wa msingi wa RSS",
"Propose basic HTTP authentication if the user has no permission to see the feed" => "Kuweka uthibitisho wa msingi wa HTTP ikiwa mtumiaji hana idhini ya kuona mtiririko",
"Feed caching time" => "Wakati wa caching ya feed",
// "Cache the feed for this number of seconds" => "Cache the feed for this number of seconds",
"Use 0 for no caching" => "Tumia 0 ili usitumie 'cache'",
"Feed caching is done for anonymous users only." => "Caching ya feed hufanyika kwa watumiaji wasiojulikana tu.",
"RSS for articles" => "RSS kwa makala",
"RSS feeds for articles" => "RSS inapatikana kwa makala",
"RSS for blogs" => "RSS kwa blogu",
"RSS feeds for blogs" => "Faili RSS kwa blogu",
"RSS for individual blogs" => "RSS kwa blogu za kibinafsi",
"RSS feeds for individual blogs" => "RSS hupatia blogu za kibinafsi",
"RSS for image galleries" => "RSS kwa nyumba za picha",
"RSS feed for image galleries" => "Faili RSS kwa ajili ya nyumba za picha",
"RSS for individual image galleries" => "RSS kwa nyumba za picha za kibinafsi",
"RSS feeds for individual image galleries" => "RSS hupatia nyumba za picha za kibinafsi",
"RSS for file galleries" => "RSS ya nyumba za faili",
"RSS feed for file galleries" => "Faili RSS kwa ajili ya nyumba za faili",
"RSS for individual file galleries" => "RSS kwa nyumba za faili za kibinafsi",
"RSS feeds for individual file galleries" => "Faili RSS kwa ajili ya nyumba za faili",
"RSS for wiki pages" => "RSS kwa kurasa za wiki",
"RSS feed for wiki pages" => "Faili RSS kwa kurasa za wiki",
"RSS for forums" => "RSS kwa vikao",
"RSS feed for forums" => "RSS kwa ajili ya vikao",
"RSS for individual forums" => "RSS kwa vikao vya kibinafsi",
"RSS feeds for individual forums" => "RSS inapatikana kwa vikao vya kibinafsi",
"RSS per tracker" => "RSS kwa kila tracker",
"RSS feed per tracker" => "Faili RSS kwa kila tracker",
"RSS for calendar events" => "RSS kwa matukio ya kalenda",
"RSS feed for calendar events" => "Faili RSS kwa matukio ya kalenda",
"RSS for directories" => "Folda ya RSS",
"RSS feed for directories" => "Faili RSS kwa folda",
"RSS for shoutbox" => "RSS kwa shoutbox",
"RSS feed for shoutbox" => "Faili RSS kwa shoutbox",
"Maximum number of items to display" => "Idadi kubwa ya vitu vinavyoonyeshwa",
"items" => "vipengee",
"Show author" => "Onyesha mwandishi",
"Homepage URL" => "URL ya ukurasa wa nyumbani",
"Tiki RSS feed for articles" => "Faili RSS ya Tiki kwa makala",
"Tiki RSS feed for blogs" => "Faili RSS ya Tiki kwa blogu",
"Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Kichwa cha kutayarishwa kwa kichwa cha blogu kwa blogu zote. Ikiwa uwanja huu hauna tupu tu kichwa cha blogu kitatumika",
"Tiki RSS feed for image galleries" => "Faili RSS ya Tiki kwa nyumba za picha",
"Tiki RSS feed for the image gallery: " => "Faili RSS ya Tiki kwa nyumba ya sanaa ya picha : ",
"Tiki RSS feed for file galleries" => "Faili RSS ya Tiki kwa ajili ya nyumba za faili",
"Tiki RSS feed for the file gallery: " => "Faili RSS ya Tiki kwa faili ya sanaa : ",
"Tiki RSS feed for the wiki pages" => "Faili RSS ya Tiki kwa kurasa za wiki",
"Tiki RSS feed for forums" => "Faili RSS ya Tiki kwa vikao",
"Tiki RSS feed for forum: " => "Faili RSS ya Tiki kwa vikao : ",
"Tiki RSS feed for individual trackers: " => "Faili RSS ya Tiki kwa trackers za kibinafsi: ",
"Tiki RSS feed for calendars" => "Faili RSS ya Tiki kwa kalenda",
"Tiki RSS feed for directory sites" => "Faili RSS ya Tiki kwa maeneo ya saraka",
"Tiki RSS feed for shoutbox messages" => "Faili RSS ya Tiki kwa ujumbe wa shoutbox",
"Article RSS description" => "Maelezo ya RSS ya makala",
"Description to be published as part of the RSS feed for articles" => "Maelezo ya kuchapishwa kama sehemu ya kulisha RSS kwa makala",
"Last articles." => "Nyaraka za mwisho.",
"Blogs RSS description" => "Maelezo ya RSS ya blogu",
"Description to be published as part of the RSS feed for blogs" => "Maelezo ya kuchapishwa kama sehemu ya kulisha RSS kwa blogi",
"Last posts to weblogs." => "Nyaraka za mwisho ya blogu.",
"Blog RSS Description" => "Maelezo ya RSS ya blogu moja",
"Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used" => "Maelezo yanapendekezwa kwenye maelezo ya blogu na kuchapishwa kama sehemu ya feeds RSS kwa blogu ya mtu binafsi. Ikiwa shamba hili halipungukani, maelezo ya blog tu yatatumika",
"Image galleries RSS description" => "Maelezo ya RSS za Nyumba za picha",
"Description to be published as part of the RSS feed for image galleries" => "Maelezo ya kuchapishwa kama sehemu ya kulisha RSS kwa nyumba za picha",
"Latest images uploaded to the image galleries." => "Picha za hivi karibuni zilizopakiwa kwenye nyumba za picha.",
"Individual image galleries RSS Description" => "Maelezo RSS za Nyumba za picha za kibinafsi",
"Description to be published as part of the RSS feeds for individual image galleries" => "Description à publier dans le flux RSS individuel des galeries d'images",
"Latest images uploaded to this image gallery." => "Picha za hivi karibuni zilizopakiwa kwenye nyumba ya sanaa ya picha hii. ",
"File galleries RSS description" => "Maelezo ya nyumba za sanaa maelezo za RSS",
"Description to be published as part of the RSS feed for file galleries" => "Maelezo ya kuchapishwa kwa kibinafsi cha RSS cha nyumba za faili",
"Latest files uploaded to the file galleries." => "Faili za hivi karibuni zilizopakiwa kwenye nyumba za faili.",
"Individual file galleries RSS description" => "Maelezo ya kibinafsi ya RSS hupatikana kwa nyumba za faili",
"Description to be published as part of the RSS feeds for individual file galleries" => "Maelezo ya kuchapishwa kwa kibinafsi cha RSS cha nyumba za faili",
"Latest files uploaded to this file gallery." => "Faili za hivi karibuni zilizopakiwa kwenye nyumba ya sanaa hii ya faili. ",
"Wiki pages RSS description" => "Ufafanuzi wa RSS kwa kurasa za wiki",
"Description to be published as part of the RSS feed for wiki pages pages" => "Maelezo ya kuchapisha kwenye ukurasa wa RSS za wiki",
"Latest wiki page changes." => "Mabadiliko za mwisho za ukurasa ya wiki.",
"Forums RSS description" => "Ufafanuzi wa RSS za vikao",
"Description to be published as part of the RSS feed for forums" => "Maelezo ya kuchapishwa kwenye misaada ya RSS ya vikao",
"Latest forum topics." => "Mada ya jukwaa ya hivi karibuni.",
"Individual forums RSS description" => "Maelezo ya kibinafsi ya RSS ya vikao",
"Description to be published as part of the RSS feeds for individual forums" => "Maelezo ya kuchapishwa kama sehemu ya feeds RSS kwa ajili ya vikao binafsi",
"Latest posts to this form" => "Ujumbe wa hivi karibuni kutoka kwenye jukwaa hili. ",
"Individual trackers RSS description" => "Maelezo ya RSS ya aina ya mtu binafsi",
"Description to be published as part of the RSS feed for individual trackers" => "Maelezo ya kuchapisha kama sehemu ya RSS kwa fomu za mtu binafsi",
"Latest additions to this tracker" => "Vitu vya mwisho vya kuchapishwa kwa tracker hii",
"Calendar events RSS description" => "Ufafanuzi wa RSS matukio ya kalenda",
"Description to be published as part of the RSS feed for calendar events" => "Maelezo ya kuchapisha kama sehemu ya kulisha RSS kwa matukio ya kalenda",
"Upcoming Events." => "Matukio ya ujao.",
"Directories RSS description" => "Kundi ya Maelezo ya RSS",
"Description to be published as part of the RSS feed for directories" => "Maelezo ya kuchapishwa kama sehemu ya malisho ya RSS kwa waandishi wa habari",
"Latest sites." => "Tovuti ya hivi karibuni.",
"Shoutbox RSS description" => "Maelezo ya Shoutbox RSS",
"Description to be published as part of the RSS feed for shoutbox messages" => "Maelezo ya kuchapishwa kama sehemu ya RSS kwa ujumbe wa shoutbox",
"Latest shoutbox messages" => "Ujumbe wa hivi karibuni wa shoutbox",
// "Tracker labels" => "Tracker labels",
// "Include tracker field labels in the RSS output" => "Include tracker field labels in the RSS output",
"Page" => "Ukurasa",
// "Finder view" => "Finder view",
"Show as a column" => "Onyesha kama safu",
"Show in popup box" => "Onyesha katika popup",
"Both" => "Wote",
"Podcast directory" => "Sura ya Podcast",
// "File system directory for storing podcast files" => "File system directory for storing podcast files",
"The server must be able to read/write the directory." => "Seva inapaswa kuwa na uwezo wa kusoma/kuandika saraka.",
"Required for podcasts" => "Inahitajika kwa podcasts",
"To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc" => "Ili kuwezesha na kutumia upakiaji wa kundi la saraka, fungua saraka inayoweza kusoma mtandao (ikiwezekana nje ya nafasi ya wavuti). Kisha pakia faili kwenye saraka hiyo, kama vile SCP, FTP, ao zingine",
"The server must be able to read the directory." => "Seva lazima iweze kusoma saraka.",
"The directory can be outside the web space." => "Saraka inaweza kuwa nje ya nafasi ya wavuti",
"Prevent download if score becomes negative" => "Jaribu kupakua ikiwa alama inakuwa hasi",
// "If using Tiki Score system, users with a negative score cannot download files" => "If using Tiki Score system, users with a negative score cannot download files",
"Allow download limit per file" => "Kuruhusu kikomo cha kupakua kwa kila faili",
// "Allow file duplicates" => "Allow file duplicates",
"Allow the same file to be uploaded more than once" => "Kuruhusu faili sawa kupakiwa mara moja",
"Yes, even in the same gallery" => "Ndiyo, hata katika nyumba hiyo ya sanaa",
"Only in different galleries" => "Tu katika nyumba tofauti",
"Display ZIP option in gallery" => "Onyesha chaguo ZIP katika picha ya sanaa",
// "Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery." => "Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery.",
"Must match" => "Lazima ufanane",
// "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)" => "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)",
"Cannot match" => "Haiwezi kufanana",
// "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted" => "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted",
"Quota for all files and archives" => "Kipengee cha faili na kumbukumbu zote",
// "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)" => "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)",
"0 for unlimited" => "0 kwa ukomo",
// "megabytes" => "megabytes",
"Quota for each file gallery" => "Kipengee kwa kila nyumba ya sanaa ya faili",
// "A different quota can be defined for each file gallery" => "A different quota can be defined for each file gallery",
"Default quota for each new gallery" => "Vigezo vya msingi kwa kila nyumba mpya ya sanaa",
"Show quota bar in the list page" => "Onyesha bar ya upendeleo katika ukurasa wa orodha",
"Yes, display bar and detail text" => "Ndiyo, onyesha bar na maelezo ya kina",
"Yes, display only bar" => "Ndiyo, onyesha bar tu",
"Yes, display only text" => "Ndio, onyesha maandiko tu",
"Storage" => "Uhifadhi",
// "Specify if uploaded files should be stored in the database or file directory" => "Specify if uploaded files should be stored in the database or file directory",
"Store in database" => "Kuhifadhi katika database",
"Store in directory" => "Hifadhi katika saraka",
// "Path to the directory to store file gallery files" => "Path to the directory to store file gallery files",
// "Searchable file gallery content" => "Searchable file gallery content",
"Include the search form on the current gallery page just after \"Find\"" => "Weka fomu ya utafutaji kwenye ukurasa wa sasa wa nyumba ya sanaa baada ya \"Tafuta\"",
"Include a search form in file galleries" => "Jumuisha fomu ya utafutaji katika nyumba za faili",
// "Display hits ratio to maximum" => "Display hits ratio to maximum",
"Display hits with a ratio of hits to maximum hits" => "Kuonyesha kupigwa kwa uwiano wa kupigwa hadi kupigwa ya juu",
"Display properties in the context menu" => "Onyesha mali katika orodha ya mazingira",
"Display \"Replace\" in the context menu" => "Onyesha \"Badilisha\" katika orodha ya mazingira",
"Automatic deletion of old files" => "Uondoaji wa moja kwa moja wa faili za zamani",
"The user will have an option when uploading a file to specify the time after which the file is deleted" => "Mtumiaji atakuwa na chaguo wakati wa kupakia faili ili kutaja muda baada ya faili kufutwa",
"A cron job must be set up in order to delete the files" => "Kazi ya 'cron' lazima ianzishwe ili kufuta faili",
"Allow action on multiple files or galleries" => "Ruhusu hatua kwenye faili nyingi au majumba",
"Include \"Remove\" as an option for the checkbox action in file galleries" => "Le bouton de contrôle sur la galerie de fichier peut être retiré",
"Deletion emails notification" => "Kufuta taarifa za barua pepe",
"Email addresses (comma-separated) to receive a copy of each deleted file" => "Ces boîtes de courriel recevront une copie de chaque fichier supprimé. Les adresses sont séparées par des virgules",
"Keep the same fileId for the latest version of a file" => "Garder le même Id de fichier pour la dernière version du fichier",
"If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file" => "Si activé, l'Id restera identique avec la dernière version. Un lien vers ce fichier fournira toujours la version la plus à jour. Si désactivé, l'Id sera associé à un fichier pour toujours, un lien vers ce fichier restera toujours lié à cette version",
"Show thumbnail actions" => "Montrer les actions pour vignette",
"Show the checkbox and wrench icon for file actions menu when not displaying details" => "Montrer la case à cocher et l'icône clé pour les actions sur un fichier en l'absence d'affichage des détails",
"Maximum thumbnail size" => "Taille maximum de vignette",
"Maximum width or height for image thumbnails" => "Largeur ou hauteur maximum pour les vignettes d'image",
"Automatic indexing of file content" => "Indexer automatiquement le contenu des fichiers",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Asynchronous indexing" => "Asynchronous indexing",
"Upload files from remote source" => "Pakia faili kutoka chanzo kijijini",
"Enable copying files to file galleries from a URL that will be polled for new revisions" => "Wezesha kuiga faili kufungua nyumba kutoka kwenye URL ambayo itafuatiliwa kwa marekebisho mapya",
"Remote source refresh frequency limit" => "Chanzo cha mbali cha kurejesha kikomo cha mzunguko",
// "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests" => "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests",
// "Set to zero to disable refresh" => "Set to zero to disable refresh",
// "Display controls to attempt a file refresh" => "Display controls to attempt a file refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
"Allow searching for existing files in the tracker files field" => "Ruhusu kutafuta files zilizopo kwenye uwanja wa faili za tracker",
"Search files using the search index" => "Futa faili kwa kutumia ripoti ya utafutaji",
// "Set MIME type based on file suffix" => "Set MIME type based on file suffix",
// "Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream" => "Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream",
// "Clean XML Always" => "Clean XML Always",
// "Sanitize XML based files such as SVG for all users" => "Sanitize XML based files such as SVG for all users",
// "Allow SVG file upload" => "Allow SVG file upload",
// "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files." => "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files.",
// "Maximum name length" => "Maximum name length",
// "Length to which to truncate file names in browse view" => "Length to which to truncate file names in browse view",
// "Maximum width of images" => "Maximum width of images",
// "Default maximum width of images in galleries" => "Default maximum width of images in galleries",
// "Maximum height of images" => "Maximum height of images",
// "Default maximum height of images in galleries" => "Default maximum height of images in galleries",
// "Use elFinder UI" => "Use elFinder UI",
// "Alternative file manager with drag and drop capability" => "Alternative file manager with drag and drop capability",
// "Use Viewer JS" => "Use Viewer JS",
// "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages" => "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages",
// "Viewer JS URI" => "Viewer JS URI",
// "Where ViewerJS is installed" => "Where ViewerJS is installed",
// "Use PDF.js" => "Use PDF.js",
// "Uses PDF.js to display PDF files in web pages" => "Uses PDF.js to display PDF files in web pages",
// "Default view" => "Default view",
// "Default sort field" => "Default sort field",
"Last modification date" => "Tarehe ya marekebisho ya mwisho",
"Owner" => "Mmiliki",
"Default sort direction" => "Mwelekeo wa aina tofauti",
"Descending" => "Inashuka",
"Ascending" => "Inapanda",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
// "Show explorer" => "Show explorer",
// "Show path" => "Show path",
// "Show slideshow" => "Show slideshow",
"Name-filename" => "Jina la faili",
"Filename only" => "Faili ya faili tu",
// "Created / Uploaded" => "Created / Uploaded",
// "Show icon in column" => "Show icon in column",
// "OCR Files" => "OCR Files",
// "Extract and index text from supported file types" => "Extract and index text from supported file types",
// "OCR Every File" => "OCR Every File",
// "Attempt to OCR every supported file" => "Attempt to OCR every supported file",
// "View or export office documents as PDF" => "View or export office documents as PDF",
// "If enabled allows to view documents without download or to export documents as PDF files" => "If enabled allows to view documents without download or to export documents as PDF files",
// "Maximum width of file preview in pixels" => "Maximum width of file preview in pixels",
// "The maximum value of width in pixels for the files preview in the popover" => "The maximum value of width in pixels for the files preview in the popover",
// "Export diagram image on save" => "Export diagram image on save",
// "If enabled, diagrams will be cached in PNG format when saved or edited" => "If enabled, diagrams will be cached in PNG format when saved or edited",
// "Use draw.io public services to export images" => "Use draw.io public services to export images",
// "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback" => "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback",
// "Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory" => "Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory",
// "Use jQuery upload" => "Use jQuery upload",
// "Use the improved Tiki 15+ upload page" => "Use the improved Tiki 15+ upload page",
// "Redirect to file gallery" => "Redirect to file gallery",
// "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery" => "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery",
"Revision approval" => "Idhini ya masahihisho",
"Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges" => "Matumizi yaliyotafsiriwa kuficha marekebisho ya ukurasa wa wiki usiyothibitishwa kutoka kwa watumiaji bila marupurupu muhimu",
// "Revision approval categories" => "Revision approval categories",
"List of category IDs for which revision approval is required" => "Orodha ya vitambulisho vya jamii ambayo idhini ya marekebisho inahitajika",
"Footer shadow div start" => "Sehemu ya kivuli cha kivuli kuanza",
"Footer shadow div end" => "Mwisho wa kivuli cha kivuli",
// "Forum image file gallery" => "Forum image file gallery",
// "File gallery used to store images for forums" => "File gallery used to store images for forums",
"Uploaded filenames must match regex" => "Majina ya faili yaliyopakiwa yanapaswa kufanana na regex",
"Manage thread defaults per-forum" => "Dhibiti uharibifu wa thread kwa kila jukwaa",
"Display thread configuration bar" => "Onyesha bar ya usanidi wa thread",
"Allows users to override the defaults" => "Inaruhusu watumiaji kuzidi vifunguko",
"Display the thread configuration bar only when the number of posts exceeds" => "Onyesha bar ya usanidi wa thread tu wakati idadi ya posts inapozidi",
"posts" => "",
"Keep settings for all forums during the user session" => "Weka mipangilio ya vikao vyote wakati wa kipindi cha mtumiaji",
"Default style" => "Mchapishaji wa mtindo",
"Threaded" => "Ilifungwa",
"Headers only" => "Vichwa tu",
"Default sort mode" => "Njia ya kuchagua chaguo-msingi",
"Title (desc)" => "Kichwa (chini)",
"Title (asc)" => "Kichwa (asc)",
"Topics" => "Mada",
"Posts per day" => "Ujumbe kwa siku",
"Last post" => "Mwisho wa mwisho",
// "Description length" => "Description length",
"Require reply to have a title" => "Inahitaji jibu kuwa na kichwa",
"Present an empty title input form and require it to be filled in before the forum post is submitted" => "Weka fomu ya uingizaji wa kichwa tupu na uhitaji ili ijazwe kabla ya chapisho la jukwaa limewasilishwa",
// "Prevent Nesting of Quote wikiplugins when replying" => "Prevent Nesting of Quote wikiplugins when replying",
// "Strips quote plugin in reply in order to prevent nesting of quote plugins" => "Strips quote plugin in reply in order to prevent nesting of quote plugins",
// "Forum post categories" => "Forum post categories",
// "Categories available in the category picker for forum posts" => "Categories available in the category picker for forum posts",
// "Include category selector in forum list" => "Include category selector in forum list",
// "Allow inbound email posts from anyone" => "Allow inbound email posts from anyone",
// "Allow posts from non-users in forums using inbound posts from a specified email address" => "Allow posts from non-users in forums using inbound posts from a specified email address",
// "Parse HTML in inbound email posts" => "Parse HTML in inbound email posts",
// "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG" => "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG",
"Experimental" => "Majaribio",
// "Has problems with some HTML emails, especially those with table-based layouts" => "Has problems with some HTML emails, especially those with table-based layouts",
// "Strip wiki markup from outgoing forum emails" => "Strip wiki markup from outgoing forum emails",
// "Convert outgoing emails from forum posts to plain text" => "Convert outgoing emails from forum posts to plain text",
// "Send moderation email" => "Send moderation email",
// "Send email to forum moderators when post is queued" => "Send email to forum moderators when post is queued",
// "Approve link in moderation email" => "Approve link in moderation email",
// "Include a link for forum moderators to approve queue from email" => "Include a link for forum moderators to approve queue from email",
// "Do not start messages titles with 'Re:'" => "Do not start messages titles with 'Re:'",
"Don't display forum thread titles" => "Usionyeshe majina ya thread ya jukwaa",
"Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display" => "Majina ya machapisho mara nyingi hayabadilishwi kwa sababu ni jibu moja kwa moja kwa post ya mzazi. Kipengele hiki kinazima maonyesho ya majina katika fomu za hariri na maonyesho ya jukwaa",
// "Include a dropdown selector in the forum list to choose a category for the post" => "Include a dropdown selector in the forum list to choose a category for the post",
"Creation date (asc)" => "Tarehe ya uumbaji (asc)",
"Topics (desc)" => "Mada (chini)",
"Threads (desc)" => "Threads (desc)",
"Latest post (desc)" => "Ujumbe wa mwisho (chini)",
"Name (desc)" => "Jina (desc)",
"Name (asc)" => "Jina (asc)",
// "Href" => "Href",
"Object ID" => "Kitambulisho cha Kitu",
// "Comments locked" => "Comments locked",
"Multilingual tags" => "Vitambulisho vya lugha nyingi",
"Permits translation management of tags" => "Inaruhusu usimamizi wa tafsiri wa vitambulisho",
// "Ordering of tagged objects" => "Ordering of tagged objects",
// "Default sort mode for tagged items" => "Default sort mode for tagged items",
"Show tag cloud" => "Onyesha wingu la wingu",
// "Show the full tag cloud in the list-tags screen" => "Show the full tag cloud in the list-tags screen",
"Maximum number of tags in cloud" => "Idadi kubwa ya vitambulisho katika wingu",
// "tags" => "tags",
"Show tags in middle column" => "Onyesha lebo katika safu ya kati",
// "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page." => "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page.",
"Preload random tag" => "Weka upya lebo ya random",
// "A random tag will be selected on the tag search page (if no tag is pre-selected)." => "A random tag will be selected on the tag search page (if no tag is pre-selected).",
// "Tag Suggestions" => "Tag Suggestions",
"Number of tags to show in tag suggestions" => "Idadi ya vitambulisho ili kuonyesha katika mapendekezo ya lebo",
"Valid characters pattern" => "Muundo wa herufi sahihi",
// "Click on the links below to set or clear a pattern to limit characters accepted in tags. " => "Click on the links below to set or clear a pattern to limit characters accepted in tags. ",
"Lowercase tags only" => "Tangazo la chini ya chini",
// "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly." => "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly.",
// "GD %0 detected" => "GD %0 detected",
// "GD not detected" => "GD not detected",
// "Imagick %0 detected" => "Imagick %0 detected",
// "Imagick 0 not detected" => "Imagick 0 not detected",
"Batch loading directory" => "Kitabu cha upakiaji wa Batch",
// "Needs to be a web-readable directory" => "Needs to be a web-readable directory",
"Display image information in a mouseover box" => "Onyesha maelezo ya picha katika sanduku la mouseover",
// "Yes, and don't display that information under the image" => "Yes, and don't display that information under the image",
"Parent" => "Mzazi",
"Uploaded image names must match regex" => "Majina ya picha yaliyopakiwa yanapaswa kufanana na regex",
"Uploaded image names cannot match regex" => "Majina ya picha yaliyopakiwa haiwezi kufanana na regex",
"Directory path" => "Njia ya njia",
// "If you change this directory, move any images to the new directory either manually or using the 'Mover' below" => "If you change this directory, move any images to the new directory either manually or using the 'Mover' below",
// "Image processing library" => "Image processing library",
// "Imagick" => "Imagick",
// "Generate password" => "Generate password",
// "Display a button on the registration form to automatically generate a very secure password for the user" => "Display a button on the registration form to automatically generate a very secure password for the user",
// "The generated password may not include any restrictions (such as minimum/maximum length" => "The generated password may not include any restrictions (such as minimum/maximum length",
"Maps & Location Enabled" => "Ramani na Eneo limewezeshwa",
// "Provide controls to load map and location libraries" => "Provide controls to load map and location libraries",
"Geolocate wiki pages" => "Geolocate kurasa za wiki",
"Provide controls to indicate a geographic location of wiki pages in the edit form" => "Kutoa udhibiti ili kuonyesha eneo la kijiografia cha kurasa za wiki katika fomu ya hariri",
"Geolocate articles" => "Makala ya kijiolojia",
"Provide controls to indicate a geographic location in the article edit form" => "Kutoa udhibiti ili kuonyesha eneo la kijiografia katika fomu ya hariri ya makala",
"Geolocate blog posts" => "Machapisho ya blog ya Geolocate",
"Provide controls to indicate a geographic location in the blog post edit form" => "Kutoa udhibiti ili kuonyesha eneo la kijiografia katika fomu ya hariri ya post ya blog",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing" => "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing",
// "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1" => "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1",
// "Google Street View" => "Google Street View",
// "Open Google Street View in a new window to see the visible coordinates" => "Open Google Street View in a new window to see the visible coordinates",
// "Google Street View overlay" => "Google Street View overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Zoom level for the found location" => "Zoom level for the found location",
// "Zoom level when a searched-for location is found" => "Zoom level when a searched-for location is found",
// "Street" => "Street",
// "Town" => "Town",
// "Region" => "Region",
// "Continent" => "Continent",
// "OpenLayers version" => "OpenLayers version",
// "OpenLayers 2.x (for use up to at least 15.x)" => "OpenLayers 2.x (for use up to at least 15.x)",
// "OpenLayers 3+ (experimental)" => "OpenLayers 3+ (experimental)",
// "Bing Maps API Key" => "Bing Maps API Key",
// "Needed for Bing Map Layers" => "Needed for Bing Map Layers",
// "Nextzen Maps API Key" => "Nextzen Maps API Key",
// "Needed for Nextzen Map Layers" => "Needed for Nextzen Map Layers",
"Browser title" => "Kichwa cha kivinjari",
"Visible label in the browser's title bar on all pages. Also appears in search engine results" => "Lebo iliyoonekana kwenye kichwa cha kivinjari cha kivinjari kwenye kurasa zote. Pia inaonekana katika matokeo ya injini ya utafutaji",
// "Fallback for tiki base URL" => "Fallback for tiki base URL",
// "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line" => "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line",
"Validate new user registrations by email" => "Thibitisha usajili mpya wa mtumiaji kwa barua pepe",
// "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses" => "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses",
"Wiki homepage" => "Ukurasa wa nyumbani wa Wiki",
"The default home page of the wiki when no other page is specified. The page will be created if it does not already exist" => "Ukurasa wa nyumbani wa mwisho wa wiki wakati hakuna ukurasa mwingine uliowekwa. Ukurasa utaundwa ikiwa haupo tayari",
"Use group homepages" => "Tumia nyumba za nyumbani",
"Users can be directed to different pages upon logging in, depending on their default group." => "Watumiaji wanaweza kuelekezwa kwenye kurasa tofauti juu ya kuingia kwenye akaunti, kulingana na kikundi chao chaguo.",
"Go to the group homepage only if logging in from the default homepage" => "Nenda kwenye ukurasa wa kikundi tu ikiwa unapoingia kutoka kwenye ukurasa wa nyumbani",
"Cache external pages" => "Kurasa za nje za Cache",
"Cache external images" => "Cache picha za nje",
"Temporary directory" => "Sura ya muda",
"Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory" => "Kitabu kwenye seva yako, kuhusiana na ufungaji wako wa Tiki, kwa kuhifadhi faili za muda. Tiki lazima iwe na upatikanaji kamili wa kusoma na kuandika kwenye saraka hii",
"Help URL" => "Msaada URL",
"The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki" => "Mfumo wa msaada wa default hauwezi kukamilika. Unaweza kuchangia nyaraka za Tiki, ambayo ni wiki iliyopangwa kwa jamii",
"Open external links in new window" => "Fungua viungo vya nje kwenye dirisha jipya",
// "Open links to external sites in a new browser tab or window" => "Open links to external sites in a new browser tab or window",
// "Allow image lazy loading" => "Allow image lazy loading",
// "Allow that images are loaded in a lazy way" => "Allow that images are loaded in a lazy way",
"License page" => "Ukurasa wa leseni",
// "The wiki page where the license information is written" => "The wiki page where the license information is written",
"Submit notice" => "Tuma taarifa",
// "Text to appear when content is being submitted" => "Text to appear when content is being submitted",
"Full path to gdaltindex" => "Njia kamili kwa gdaltindex",
"Full path to ogr2ogr" => "Njia kamili ya ogr2ogr",
"Map Zone" => "Eneo la Ramani",
"Always display modules to all groups" => "Daima kuonyesha moduli kwa makundi yote",
// "Any setting for the Groups parameter will be ignored and the module will be displayed to all users" => "Any setting for the Groups parameter will be ignored and the module will be displayed to all users",
"Hide anonymous-only modules from registered users" => "Ficha modules zisizojulikana tu kutoka kwa watumiaji waliosajiliwa",
// "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module" => "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module",
"Hide anonymous-only modules from Admins" => "Ficha modules zisizojulikana tu kutoka kwa Admins",
"Maximum number of articles on the articles homepage" => "Idadi kubwa ya makala kwenye ukurasa wa ukurasa",
// "The number of articles to show on each page of the Articles homepage" => "The number of articles to show on each page of the Articles homepage",
"articles" => "makala",
"Site Ads and Banners Content" => "Matangazo ya Matangazo na Mabango",
"Test" => "Mtihani",
"URL to go to when clicking on a username" => "URL kwenda wakati unapofya jina la mtumiaji",
"Default" => "Kwa kawaida",
"Use %user% for login name and %userId% for userId)" => "Tumia %user% kwa jina login na %userId% kwa userId))",
"Forgot password" => "Umesahau nenosiri",
"Users can request a password reset. They will receive a link by email" => "Watumiaji wanaweza kuomba upya nenosiri. Watapokea kiungo kwa barua pepe",
"Group theme" => "Mandhari ya kikundi",
// "Enable groups to each have their own visual theme" => "Enable groups to each have their own visual theme",
// "The displayed title of the website" => "The displayed title of the website",
"Subtitle" => "Mada",
// "A short phrase that, for example, describes the site" => "A short phrase that, for example, describes the site",
"Maximum number of records in listings" => "Idadi kubwa ya kumbukumbu katika orodha",
// "records" => "records",
"Maximum number of versions" => "Idadi kubwa ya matoleo",
"versions" => "matoleo",
"Users can register" => "Watumiaji wanaweza kujiandikisha",
// "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page" => "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page",
// "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option" => "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option",
// "Yes, with \"deep MX\" search" => "Yes, with \"deep MX\" search",
"Require validation by Admin" => "Inahitaji uthibitishaji na Admin",
"The administrator will receive an email for each new user registration, and must validate the user before the user can log in" => "Msimamizi atapokea barua pepe kwa usajili mpya wa mtumiaji, na lazima athibitishe mtumiaji kabla ya mtumiaji anaweza kuingia",
"Require passcode to register" => "Inahitaji msimbo wa kupitisha kujiandikisha",
"Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users" => "Watumiaji wanapaswa kuingia msimbo wa kuandika kujiandikisha. Msimamizi wa tovuti lazima awajulishe watumiaji wa msimbo huu. Hii ni kuzuia usajili kwa watumiaji walioalikwa",
"Passcode" => "Nambari ya usajilit",
"Alphanumeric code required to complete the registration" => "sMsimbo wa alphanumeric unahitajika kukamilisha usajili",
// "Show passcode on registration form" => "Show passcode on registration form",
"Registration page key" => "Muhimu ya ukurasa ya usajili",
"Key required to be on included the URL to access the registration page (if not empty)." => "Muhimu zinazohitajika ili kuwa kwa pamoja URL ili kufikia ukurasa wa usajili (kama si tupu).",
// "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue" => "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue",
"Use a tracker to collect more user information" => "Tumia tracker kukusanya maelezo zaidi ya mtumiaji",
// "Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user" => "Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user",
"Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display" => "Nenda kwenye ukurasa wa \"Vikundi vya Admin\" ili upee tracker na maeneo ambayo utaonyeshwa",
"Use tracker to collect more group information" => "Tumia tracker kukusanya maelezo zaidi ya kikundi",
"Create a new group for each user" => "Unda kikundi kipya kwa kila mtumiaji",
// "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level" => "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level",
"Synchronize Tiki groups with a directory" => "Unganisha vikundi vya Tiki na saraka",
"Define the directory within the \"LDAP\" tab" => "Eleza saraka ndani ya kichupo cha \"LDAP",
"Synchronize Tiki users with a directory" => "Unganisha watumiaji wa Tiki na saraka",
"Remember me" => "Nikumbuke",
"Duration" => "Muda",
// "The length of time before the user will need to log in again" => "The length of time before the user will need to log in again",
"day" => "siku",
"week" => "wiki",
"month" => "mwezi",
"year" => "mwaka",
// "Homepage Browser title" => "Homepage Browser title",
// "Customize Browser title for the custom homepage" => "Customize Browser title for the custom homepage",
"Use custom homepage" => "Tumia ukurasa wa nyumbani wa desturi",
"Use the top page of a Tiki feature or another homepage" => "Tumia ukurasa wa juu wa kipengele cha Tiki au ukurasa mwingine wa nyumbani",
// "This option will override the Use Tiki feature as homepage setting" => "This option will override the Use Tiki feature as homepage setting",
"Use the top page of a Tiki feature as the homepage" => "Tumia ukurasa wa juu wa kipengele cha Tiki kama ukurasa wa nyumbani",
"Select the Tiki feature to provide the site homepage. Only enabled features are listed" => "Chagua kipengele cha Tiki ili kutoa homepage ya tovuti. Vipengele vinavyowezeshwa tu vinadhihirishwa",
"Disable JavaScript" => "Zima JavaScript",
"Disable JavaScript for the purpose of testing even if enabled in the browser" => "Disable JavaScript for the purpose of testing even if enabled in the browser",
// "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly" => "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly",
// "Maximum rows per page" => "Maximum rows per page",
"Images per row" => "Picha kwa mstari",
"images" => "Picha",
// "Thumbnail width" => "Thumbnail width",
// "Thumbnail height" => "Thumbnail height",
// "Default scale size" => "Default scale size",
"Set blogs homepage first" => "Weka ukurasa wa kwanza wa blogi",
"Set Image gal homepage first" => "Weka ukurasa wa kwanza wa nyumba ya sanaa ya picha",
"Set Forum homepage first" => "Set Forum homepage first",
"Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it." => "Kwa kuwa nenosiri ni encrypted, haiwezekani kumwambia mtumiaji nenosiri. Inawezekana tu kubadili.",
"Validate user's email server" => "Thibitisha seva ya barua pepe ya mtumiaji",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
"The group name will be the same as the user's username" => "Jina la kikundi litakuwa sawa na jina la mtumiaji",
// "After logging in, users will automatically be logged in again when they leave and return to the site" => "After logging in, users will automatically be logged in again when they leave and return to the site",
"User's choice" => "Uchaguzi wa mtumiaji",
"Google Maps API Key" => "Kitufe cha Google Maps API",
// "Needed for Street View or other advanced features" => "Needed for Street View or other advanced features",
"Default x for map center" => "Default x kwa kituo cha ramani",
"Default y for map center" => "Default y kwa kituo cha ramani",
"Default zoom level" => "Kiwango cha kupima chaguo-msingi",
"whole earth" => "dunia nzima",
"country size" => "ukubwa wa nchi",
"city size" => "ukubwa wa jiji",
"max zoom" => "zoom kubwa",
"Show map mode buttons in articles list" => "Onyesha vifungo vya mode katika orodha ya makala",
"Show map mode buttons in page list" => "Onyesha vifungo vya mode ya ramani katika orodha ya ukurasa",
// "Goal, recognition and rewards" => "Goal, recognition and rewards",
// "A tool to set motivational goals to increase engagement on the site" => "A tool to set motivational goals to increase engagement on the site",
// "Reward badge tracker" => "Reward badge tracker",
// "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user" => "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user",
// "0 to disable" => "0 to disable",
// "Groups not eligible for goals" => "Groups not eligible for goals",
// "Groups that will not be on the eligible group list" => "Groups that will not be on the eligible group list",
// "H5P support" => "H5P support",
// "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content" => "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content",
// "Whitelist" => "Whitelist",
// "Allowed filetypes" => "Allowed filetypes",
// "H5P Tracker User" => "H5P Tracker User",
// "Store H5P results" => "Store H5P results",
// "H5P Developer Mode" => "H5P Developer Mode",
// "Use \"patched\" libraries" => "Use \"patched\" libraries",
// "Default Gallery" => "Default Gallery",
// "File gallery to create new H5P content in by default" => "File gallery to create new H5P content in by default",
// "Store user state" => "Store user state",
// "Allows users to resume at the point they last got to" => "Allows users to resume at the point they last got to",
// "Save Frequency" => "Save Frequency",
// "How often to update user data" => "How often to update user data",
// "Allows users to export H5P content" => "Allows users to export H5P content",
// "Hub Is Enabled" => "Hub Is Enabled",
// "Updates libraries from h5p.org" => "Updates libraries from h5p.org",
// "Site Key" => "Site Key",
// "H5P Site Key" => "H5P Site Key",
// "H5P UUID" => "H5P UUID",
// "H5P Unique ID" => "H5P Unique ID",
// "Content Type Updated" => "Content Type Updated",
"Last update" => "Mabadiliko la mwisho",
// "Check Requirements" => "Check Requirements",
// "Unused so far" => "Unused so far",
// "Send Usage Statistics" => "Send Usage Statistics",
// "Request User Consent" => "Request User Consent",
// "LRS Content Types" => "LRS Content Types",
// "Reporting (?)" => "Reporting (?)",
"HHeader shadow div start" => "Kichwa cha kivuli cha kichwa cha kuanza",
"Header shadow div end" => "Kichwa cha kichwa kivuli cha kichwa",
"Custom CSS" => "Desturi CSS",
// "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n" => "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n",
"Custom JavaScript" => "Ufafanuzi JavaScript",
"Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages" => "Inajumuisha kizuizi cha JavaScript ya ndani baada ya kuingizwa kwa jQuery na vifungo vingine vya JavaScript katika kila kurasa",
// "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page" => "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page",
"Do not include the < script > tags" => "Usijumuishe vitambulisho <script>",
// "Custom Less" => "Custom Less",
// "Compiles a new version of the currently selected theme and option using definitions declared here" => "Compiles a new version of the currently selected theme and option using definitions declared here",
// "Custom Less (CSS precompiler) - no longer used" => "Custom Less (CSS precompiler) - no longer used",
// "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon.." => "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon..",
"Highlight group" => "Eleza kikundi",
"Home blog (main blog)" => "Blogu ya nyumbani (blogu kuu)",
"Home forum (main forum)" => "Hifadhi ya nyumbani (jukwaa kuu)",
"Home file gallery (main file gallery)" => "Nyumba ya sanaa ya faili (kuu ya faili ya faili)",
// "Select the default file gallery" => "Select the default file gallery",
"Home gallery (main gallery)" => "Nyumbani nyumba ya sanaa (nyumba kuu ya sanaa)",
"No image gallery available (create one first)" => "Hakuna nyumba ya sanaa ya picha inapatikana (unda moja kwanza)",
"No file gallery available (create one first)" => "Hakuna nyumba ya sanaa iliyopo inapatikana (fanya moja kwanza)",
"No blog available (create one first)" => "Hakuna blogu inapatikana (tengeneza moja kwanza)",
"HTTP port" => "HTTP bandari",
// "The port used to access this server; if not specified, port 80 will be used" => "The port used to access this server; if not specified, port 80 will be used",
"If not specified, port 80 will be used" => "Ikiwa si maalum, bandari 80 itatumika",
// "HTTP lookup: skip framesets" => "HTTP lookup: skip framesets",
// "When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
"HTTP header x-frame options" => "Chaguo ya kichwa kya HTTP: x-frame",
// "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt" => "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt",
// "Header value" => "Header value",
// "DENY" => "DENY",
// "SAMEORIGIN" => "SAMEORIGIN",
"HTTP header x-xss-protection" => "Kichwa kya HTTP: x-xss-protection",
// "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers" => "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers",
// "0" => "0",
// "1;mode=block" => "1;mode=block",
"HTTP header x-content-type-options" => "Kichwa kya HTTP: x-content-type-options",
// "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed" => "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed",
"HTTP header content-security-policy" => "Kichwa kya HTTP: content-security-policy",
// "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page" => "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page",
"HTTP header strict-transport-security" => "Kichwa kya HTTP: strict-transport-security",
// "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP" => "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP",
"HTTP header public-key-pins" => "Kichwa kya HTTP: public-key-pins",
// "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it" => "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it",
"HTTPS for user-specific links" => "HTTPS kwa viungo maalum vya mtumiaji",
// "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "HTTPS bandari",
// "the HTTPS port for this server" => "the HTTPS port for this server",
"Use HTTPS login" => "Tumia kuingia kwa HTTPS",
"Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Ongeza usalama kwa kuruhusu kuhamisha sifa za uthibitisho juu ya SSL. Vyeti lazima zimeundwa kwenye seva",
"Allow secure (HTTPS) login" => "Ruhusu kuingia saini (HTTPS) kuingia",
"Encourage secure (HTTPS) login" => "Thibitisha kuingia salama (HTTPS)",
"Consider we are always in HTTPS, but do not check" => "Fikiria sisi daima ni katika HTTPS, lakini usiangalie",
"Require secure (HTTPS) login" => "Inahitaji kuingia saini (HTTPS) kuingia",
"Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible" => "Usihitaji HTTPS mpaka uhusiano umewekwa na kupimwa; Vinginevyo, tovuti hiyo haitatikani",
"Enable intrusion detection system" => "Wezesha mfumo wa kugundua intrusion",
// "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations" => "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations",
// "Intrusion detection system mode" => "Intrusion detection system mode",
// "Define IDS operation mode, log only, or log and block with impact over a given threshold" => "Define IDS operation mode, log only, or log and block with impact over a given threshold",
// "Log only" => "Log only",
// "Log and block requests" => "Log and block requests",
// "Intrusion detection system threshold" => "Intrusion detection system threshold",
// "Define IDS threshold, when configured in \"Log and block requests\" more" => "Define IDS threshold, when configured in \"Log and block requests\" more",
// "Custom rules file" => "Custom rules file",
// "Log to file" => "Log to file",
// "Log to database" => "Log to database",
"Default for img-fluid class used in the IMG plugin" => "Kipengee cha darasa la img-fluid kutumika katika Plugin IMG",
// "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden" => "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden",
// "Errors log file" => "Errors log file",
// "location, from your tiki root dir, where you want the error log file stored" => "location, from your tiki root dir, where you want the error log file stored",
// "Access log file" => "Access log file",
// "location, from your tiki root dir, where you want the access log file stored" => "location, from your tiki root dir, where you want the access log file stored",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
"Use CDN for JavaScript" => "Tumia CDN kwa JavaScript",
"Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)." => "Pata maktaba ya jQuery na jQuery UI kupitia mtandao wa utoaji wa maudhui (CDN).",
// "Google" => "Google",
"jQuery" => "jQuery",
// "Assume JavaScript is enabled even if not supported" => "Assume JavaScript is enabled even if not supported",
// "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter" => "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter",
"Slide" => "Slide",
"Fade" => "Fade",
"Blind (UI)" => "Kipofu (UI)",
"Clip (UI)" => "Kipande cha picha (UI)",
"Drop (UI)" => "Tone (UI)",
"Explode (UI)" => "Vumbua (UI)",
"Fold (UI)" => "Fold (UI)",
"Puff (UI)" => "Puff (UI)",
"Slide (UI)" => "Slider (UI)",
"Effect for modules" => "Madhara ya moduli",
"Effect for tabs" => "Madhara kwa tabo",
"Speed" => "kasi",
"Fast" => "Haraka",
"Normal" => "Kawaida",
"Slow" => "Punguza",
"Direction" => "Mwelekeo",
"Vertical" => "Wima",
"Horizontal" => "Uwiano",
"Left" => "Kushoto",
"Right" => "Haki",
"Up" => "Hadi",
"Down" => "Chini",
// "jQuery-UI Chosen Select Boxes" => "jQuery-UI Chosen Select Boxes",
// "Styled replacement for dropdown select lists and multiple-select inputs" => "Styled replacement for dropdown select lists and multiple-select inputs",
// "Sortable Chosen Multi-selects" => "Sortable Chosen Multi-selects",
// "Enable drag and drop re-ordering of Chosen multi-select options" => "Enable drag and drop re-ordering of Chosen multi-select options",
"Visual style of Colorbox (a.k.a. \"Shadowbox\")" => "Mtindo wa maonyesho ya Colorbox (a.k.a. \"Shadowbox\")",
"One" => "Moja",
"Two" => "Mbili",
"Three" => "Tatu",
"Four" => "Nne",
"Five" => "Tano",
// "FitVids.js" => "FitVids.js",
// "jQuery plugin for fluid-width (responsive) embedded videos" => "jQuery plugin for fluid-width (responsive) embedded videos",
// "jQuery Timeago" => "jQuery Timeago",
// "jQuery plugin for fuzzy timestamps" => "jQuery plugin for fuzzy timestamps",
// "SmartMenus" => "SmartMenus",
// "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more" => "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more",
// "SmartMenus Mode" => "SmartMenus Mode",
"Blue" => "Bleu",
"Clean" => "Safisha",
// "Mint" => "Mint",
"Simple" => "Rahisi",
// "Draggable Modals" => "Draggable Modals",
// "Modal popups can be moved around" => "Modal popups can be moved around",
// "Resizable Modals" => "Resizable Modals",
// "Modal popups can be resized" => "Modal popups can be resized",
// "jQuery Double Scroll" => "jQuery Double Scroll",
// "jQuery plugin which adds an extra horizontal scroll bar at the top" => "jQuery plugin which adds an extra horizontal scroll bar at the top",
"Partner ID" => "Kitambulisho cha Washirika",
"Kaltura Partner ID" => "Kitambulisho cha Mshirika wa Kaltura",
"User secret" => "Siri ya mtumiaji",
"Kaltura partner-setting user secret" => "Kaltura mpangilio wa mpangilio wa mtumiaji",
"Admin secret" => "Siri ya Admin",
"Kaltura partner-setting admin secret" => "Kaltura mpangilio wa mpangilio wa admin",
// "Kaltura video player ID" => "Kaltura video player ID",
"Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) ID ya usanidi wa interface wa mtumiaji",
// "Kaltura video player ID (in entry edit mode)" => "Kaltura video player ID (in entry edit mode)",
// "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail" => "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail",
// "KCW UI configuration ID" => "KCW UI configuration ID",
"Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) ID ya usanidi wa interface wa mtumiaji",
// "Kaltura service URL" => "Kaltura service URL",
// "for example, https://www.kaltura.com/" => "for example, https://www.kaltura.com/",
// "Show remixes from old versions of Kaltura" => "Show remixes from old versions of Kaltura",
// "Show remixes from old versions of Kaltura (remixing is no longer supported)" => "Show remixes from old versions of Kaltura (remixing is no longer supported)",
"Keep versions for" => "Weka matoleo kwa",
// "Do not delete versions younger than this number of days" => "Do not delete versions younger than this number of days",
"Use database for translation" => "Tumia database kwa kutafsiri",
"Use the database to store the translated strings and allow using interactive translation" => "Tumia database ili kuhifadhi safu zilizotafsiriwa na kuruhusu kutumia tafsiri inayoingiliana",
"Edit, export and import languages" => "Hariri, kusafirisha na kuagiza lugha",
// "Manage contribution of translated strings" => "Manage contribution of translated strings",
// "Offers to set whether each translated string should be contributed to the Tiki community or kept locally" => "Offers to set whether each translated string should be contributed to the Tiki community or kept locally",
// "Machine translation implementation" => "Machine translation implementation",
// "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required" => "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required",
// "Google Translate" => "Google Translate",
// "Bing Translate" => "Bing Translate",
// "Enable machine translation of wiki pages" => "Enable machine translation of wiki pages",
// "Makes additional languages available to the list of languages on the page" => "Makes additional languages available to the list of languages on the page",
// "Google Translate API Key" => "Google Translate API Key",
// "The key must be generated from the Google console. Choose to create a server key" => "The key must be generated from the Google console. Choose to create a server key",
// "Bing Translate Client ID" => "Bing Translate Client ID",
// "The application must be registered" => "The application must be registered",
// "Bing Translate Client Secret" => "Bing Translate Client Secret",
// "Display available translations as dropdown" => "Display available translations as dropdown",
// "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list" => "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list",
"Default language" => "Lugha ya msingi",
"The site language is used when no other language is specified by the user" => "Lugha ya tovuti hutumika wakati hakuna lugha nyingine iliyoelezwa na mtumiaji",
// "Default admin language" => "Default admin language",
// "The site language is used in admin section when no other language is specified by the user" => "The site language is used in admin section when no other language is specified by the user",
"Language inclusion threshold" => "Kizingiti cha kuingizwa kwa lugha",
"When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "Wakati idadi ya lugha zimezuiwa kwenye tovuti, na iko chini ya namba hii, lugha zote zitaongezwa kwenye orodha ya lugha iliyopendekezwa, hata ikiwa haijulikani na mtumiaji. Hata hivyo, kipaumbele kitapewa kwa lugha maalum",
"languages" => "lugha",
"Layout width" => "Onyesha upana",
"The width of the content area of the site, centered in the browser window" => "Inazuia upana wa eneo la maudhui ya tovuti",
"for example, 960px" => "kwa mfano, 960px",
"Tabs optional" => "Tabs kama hiari",
"Users can choose not to have tabs. A <b>no tabs</b> button will be displayed" => "Watumiaji wanaweza kuchagua kuwa na tabo. Kitufe <b> hakuna tabo </b> kitaonyeshwa",
"Add group CSS info" => "Ongeza maelezo ya kikundi CSS",
"Add CSS classes to the page BODY tag based on the user's group membership" => "Ongeza madarasa CSS kwenye lebo ya BODY ya ukurasa kulingana na uanachama wa kikundi cha mtumiaji",
"Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Aidha grp_Anonymous au grp_Registered na labda grp_Admins pia",
// "If this option is disabled, this user wouldn’t be able to log in" => "If this option is disabled, this user wouldn’t be able to log in",
"Create the user" => "Unda mtumiaji",
"Deny access" => "Pata upatikanaji",
"Create user if not in LDAP" => "Unda mtumiaji ikiwa sio katika LDAP",
// "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user" => "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user",
// "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”" => "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”",
"Maximum average server load threshold in the last minute" => "Upeo wa kiwango cha mzigo wa seva ya wastani katika dakika ya mwisho",
// "Lock Content Templates" => "Lock Content Templates",
// "Enable users to lock content templates and so prevent others from editing them" => "Enable users to lock content templates and so prevent others from editing them",
// "Lock Wiki Structures" => "Lock Wiki Structures",
// "Enable users to lock wiki structures and so prevent others from editing them" => "Enable users to lock wiki structures and so prevent others from editing them",
"Log mail in Tiki logs" => "Ingia barua katika kumbukumbu za Tiki",
"A line of type mail will be included in the System Log with the destination address and subject of each email sent" => "Mstari wa barua ya aina utaingizwa kwenye Mfumo wa Usajili na anwani ya marudio na somo la kila barua pepe iliyotumwa",
"Smarty template usage indicator" => "Kiashiria cha matumizi ya template ya Smarty",
"Add HTML comment at start and end of each Smarty template (.tpl file)" => "Ongeza maoni ya HTML katika mwanzo na mwisho wa kila template ya Smarty (.tpl file) \"=>\" Ongeza maelezo au format HTML au début na mwisho wa kila template Smarty (TPL)",
"Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source." => "Tumia tu kwa maendeleo, si kwa uzalishaji kwa sababu maonyo haya yanaongezwa kwa barua pepe pia, na yanaonekana kwa watumiaji",
"You need to clear your Tiki template cache for this change to take effect" => "Unahitaji kufuta cache yako ya template ya Tiki kwa mabadiliko haya ya kuchukua athari",
"Log SQL" => "Kumbukumbu za SQL",
"All SQL queries will be registered in the database in the adodb_logsql table. " => "Swali zote za SQL zitasajiliwa kwenye darasani kwenye meza ya adodb_logsql.",
// "Do not enable this feature all the time. It can be very resource intensive and will impact performance" => "Do not enable this feature all the time. It can be very resource intensive and will impact performance",
"Log queries using more than" => "Maswali ya kuingia kwa kutumia zaidi",
"Use to log only queries that exceed a specific amount of time" => "Tumia kwa kuandika maswali pekee ambayo huzidi kiasi fulani cha wakati",
"Use email as username" => "Tumia barua pepe kama jina la mtumiaji",
"Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field" => "Badala ya kujenga majina ya watumiaji wapya, tumia anwani ya barua pepe ya mtumiaji kwa uthibitishaji. Kwa fomu ya usajili, hakutakuwa na uwanja wa jina la mtumiaji",
"Obscure email when using email as username" => "Barua pepe isiyoficha wakati unatumia barua pepe kama jina la mtumiaji",
// "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead" => "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead",
// "Coverage will not be complete" => "Coverage will not be complete",
"User can login via username or email." => "Mtumiaji anaweza kuingia kupitia jina la mtumiaji au barua pepe.",
// "This will allow users to login using their email (as well as their username)" => "This will allow users to login using their email (as well as their username)",
"Auto-generate 6-digit username on registration" => "Jitambulisha kwa urahisi jina la mtumiaji wa tarakimu 6 kwenye usajili",
// "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)" => "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)",
"HTTP Basic Authentication" => "Uthibitisho Msingi wa HTTP",
"Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials" => "Angalia sifa kutoka kwa Uthibitishaji Msingi wa HTTP, ambayo ni muhimu kuruhusu huduma za wavuti kutumia utambulisho",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
"Prevent multiple log-ins by the same user" => "Zuia kuingia nyingi kwa mtumiaji sawa",
// "Users (other than admin) cannot log in simultaneously with multiple browsers" => "Users (other than admin) cannot log in simultaneously with multiple browsers",
// "Grab session if already logged in" => "Grab session if already logged in",
// "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out" => "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out",
// "Enable autologin from remote Tiki" => "Enable autologin from remote Tiki",
// "Used with autologin_remotetiki in the redirect plugin" => "Used with autologin_remotetiki in the redirect plugin",
// "System username to use to initiate autologin from remote Tiki" => "System username to use to initiate autologin from remote Tiki",
// "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin" => "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin",
// "System groupname to use for auto login token" => "System groupname to use for auto login token",
// "For security, please create a group that has no users and no permissions and specify its name here" => "For security, please create a group that has no users and no permissions and specify its name here",
// "Create a new user account if the user that is trying to autologin does not exist on this Tiki" => "Create a new user account if the user that is trying to autologin does not exist on this Tiki",
// "Allowed groups from remote Tiki to autologin" => "Allowed groups from remote Tiki to autologin",
// "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone" => "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone",
// "Sync these groups from remote Tiki on autologin" => "Sync these groups from remote Tiki on autologin",
// "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly" => "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly",
// "Automatically logout remote Tiki after logout" => "Automatically logout remote Tiki after logout",
// "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well" => "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well",
// "Redirect direct logins to this site to remote Tiki" => "Redirect direct logins to this site to remote Tiki",
// "URL of autologin page on remote Tiki to redirect user to login" => "URL of autologin page on remote Tiki to redirect user to login",
// "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin" => "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin",
"Long date format" => "Muda mrefu wa tarehe",
// "Specify how Tiki displays the date (longer version)" => "Specify how Tiki displays the date (longer version)",
"Long time format" => "Muda wa muda mrefu ",
// "Specify how Tiki displays the time (longer version)" => "Specify how Tiki displays the time (longer version)",
"%A %d of %B, %Y" => "%A %d %B %Y",
"%H:%M:%S %Z" => "%Hh%M",
"%A %d of %B, %Y %H:%M:%S %Z" => "%A %d %B %Y %H:%M:%S %Z",
"Force lowercase" => "Weka chini",
// "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>" => "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>",
"Email newline character(s)" => "Tuma barua pepe mpya (s)",
"End-of-line (EOL) character used in outgoing emails" => "Tabia ya mwisho ya mstari (EOL) inayotumika kwa barua pepe zinazotoka",
"CRLF (standard)" => "CRLF (kiwango)",
"LF (some Unix MTA)" => "LF (baadhi ya MTA Unix)",
"Text string used to customise mail templates" => "Kamba ya maandishi inayotumiwa kutengeneza templates za barua pepe",
// "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files" => "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files",
"Main shadow start" => "Kivuli kikuu kuanza",
"Main shadow end" => "Mwisho wa mwisho wa kivuli",
"Maximum length" => "Urefu wa urefu",
// "The greatest number of characters for a valid username" => "The greatest number of characters for a valid username",
"Memcache" => "Memcache",
"Enable connection to memcached servers to store temporary information" => "Wezesha uunganisho kwa seva za memcached kuhifadhi habari za muda",
"Requires the PHP memcache extension" => "Inahitaji ugani wa memcache ya PHP",
"Memcache servers" => "Seva za Memcache",
"Server list which may be accessed. For each server, the address, port and weight must be specified." => "Orodha ya seva ambayo inaweza kupatikana. Kwa kila seva, anwani, bandari na uzito lazima zielezwe",
// "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"" => "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"",
"Memcache key prefix" => "Kiambatisho cha ufunguo wa Memcache",
"When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts" => "Wakati kikundi cha memcache kinatumiwa na matumizi mengi, kutumia prefixes ya kipekee kwa kila mmoja husaidia kuzuia migogoro",
"Memcache expiration" => "Mwisho wa Memcache",
"Duration for which the data will be kept" => "Muda ambao data itahifadhiwa",
"Cache wiki data in memcache" => "Cache data ya wiki katika memcache",
"Cache wiki output in memcache" => "Cache wiki pato katika memcache",
"Cache forum output in memcache" => "Jukwaa la Cache la pato katika memcache",
"Menu icons" => "Icons za menyu",
// "Allows icons to be defined for menu entries" => "Allows icons to be defined for menu entries",
"Default path for the icons" => "Njia ya pekee ya icons",
// "Edit menu icon" => "Edit menu icon",
// "Adds an icon on the navbar to edit menu entries" => "Adds an icon on the navbar to edit menu entries",
// "Maximum mailbox size" => "Maximum mailbox size",
// "Maximum number of messages allowed in the mailbox" => "Maximum number of messages allowed in the mailbox",
"messages" => "ujumbe",
// "Maximum mail archive size" => "Maximum mail archive size",
// "Maximum number of archive messages allowed" => "Maximum number of archive messages allowed",
// "Maximum sent box size" => "Maximum sent box size",
// "Maximum number of sent messages allowed in the mailbox" => "Maximum number of sent messages allowed in the mailbox",
// "Truncate internal message notification" => "Truncate internal message notification",
// "Number of characters to show in the message notification sent through email, with a link to read the full internal message" => "Number of characters to show in the message notification sent through email, with a link to read the full internal message",
"Keywords" => "Maneno muhimu",
"A list of keywords (separated by commas) that describe this website." => "Orodha ya maneno muhimu (yaliyotenganishwa na commas) ambayo yanaelezea tovuti hii.",
"Include tags" => "Weka lebo",
// "If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags" => "If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags",
"Use thread title instead" => "Tumia kichwa cha thread badala yake",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
"Use the image title instead" => "Tumia cheo cha picha badala yake",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of the website. Some search engines display this information with the website's listing" => "A short description of the website. Some search engines display this information with the website's listing",
"Page description" => "Maelezo ya ukurasa",
// "Use each page description as a meta tag for that page" => "Use each page description as a meta tag for that page",
"Author" => "Mwandishi",
// "The author of this website. Typically this is the Admin or Webmaster" => "The author of this website. Typically this is the Admin or Webmaster",
"geo.position" => "geo.position",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
"geo.region" => "geo.region",
// "The ISO-3166 country and region codes for your location. For example, \"US-NY\"" => "The ISO-3166 country and region codes for your location. For example, \"US-NY\"",
"geo.placename" => "geo.placename",
// "A free-text description of your location" => "A free-text description of your location",
"Meta robots" => "Robots ya Meta",
// "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca" => "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca",
// "Should be comma separated eg. noimageindex, nocache" => "Should be comma separated eg. noimageindex, nocache",
"Revisit after" => "Pitia tena",
// "Specify how often (in days) Web robots should visit your site" => "Specify how often (in days) Web robots should visit your site",
"Middle shadow div start" => "Mgawanyiko wa kivuli wa katikati kuanza",
"Middle shadow div end" => "Ufikiaji wa kivuli wa katikati",
"Minimum length" => "Urefu wa chini",
// "The least possible number of characters for a valid username" => "The least possible number of characters for a valid username",
// "The least possible number of characters for a valid password" => "The least possible number of characters for a valid password",
"Mobile access" => "Ufikiaji wa simu",
// "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)" => "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)",
// "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)" => "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)",
"Mobile Perspectives" => "Mtazamo wa Simu ya Mkono",
"Top module zone" => "Eneo la moduli la juu",
// "Activate zone for modules such as site logo, log-in form, etc. (page header)" => "Activate zone for modules such as site logo, log-in form, etc. (page header)",
"Topbar module zone" => "Sehemu ya moduli ya moduli",
// "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc" => "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc",
"topbar" => "bar ya juu",
"Page top module zone" => "Ukurasa wa sehemu ya moduli ya juu",
// "Activate zone for modules such as breadcrumbs, banners, share icons, etc" => "Activate zone for modules such as breadcrumbs, banners, share icons, etc",
"Bottom module zone" => "Sehemu ya chini ya moduli",
// "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)" => "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)",
"Page bottom module zone" => "Eneo la chini la moduli",
// "Activate zone for modules at the bottom of the main column of each page" => "Activate zone for modules at the bottom of the main column of each page",
"Module file" => "Faili ya moduli",
// "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles" => "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles",
"Extra module zones available" => "Sehemu za ziada za moduli zinapatikana",
// "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones" => "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones",
"Comma-separated list, maximum of 20 characters per entry." => "Orodha ya kutenganishwa kwa Comma, upeo wa wahusika 20 kwa kuingia.",
// "Allow users to control the notifications they receive based on content changes" => "Allow users to control the notifications they receive based on content changes",
// "Notification digests" => "Notification digests",
// "Enable digest notifications (requires a cron job)" => "Enable digest notifications (requires a cron job)",
// "Clear individual notifications" => "Clear individual notifications",
// "Allow users to selectively clear notifications instead of simply having a clear-all button" => "Allow users to selectively clear notifications instead of simply having a clear-all button",
// "Notification count refresh interval" => "Notification count refresh interval",
// "Show unread notification count and refresh every [x] seconds" => "Show unread notification count and refresh every [x] seconds",
// "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds" => "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds",
// "Notification reply-to email pattern" => "Notification reply-to email pattern",
// "Email model to use for the notification email reply-to address" => "Email model to use for the notification email reply-to address",
// "noreply+PLACEHOLDER@example.com" => "noreply+PLACEHOLDER@example.com",
"\"More Like This\" algorithm" => "\"Zaidi Kama Hii\" algorithm",
// "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order" => "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order",
"Minimum number of tags in common" => "Idadi ndogo ya vitambulisho kwa kawaida",
// "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature" => "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature",
"Multi-domain" => "Multi-domain",
"Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation" => "Inaruhusu majina ya kikoa kuwa ramani kwa mitazamo na kuiga domains nyingi mwenyeji na Tiki ufungaji huo",
"Multi-domain Configuration" => "Configuration Multi-domain",
"Comma-separated values mapping the domain name to the perspective ID" => "Maadili yaliyotenganishwa na Comma jina la kikoa kwenye Kitambulisho cha mtazamo",
"One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1" => "Mkoa mmoja kwa kila mstari na comma kutenganisha kutoka ID mtazamo. Kwa mfano: tiki.org, 1",
"Switch domain when switching perspective" => "Badilisha kikoa wakati wa kubadili mtazamo",
"Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work" => "Kumbuka kwamba vikoa tofauti vina vikao tofauti vya kuingia na hata katika kesi ya subdomains unahitaji kuwa na ufahamu wa vidakuzi vya kikao ili uifanye kazi",
// "Must read" => "Must read",
// "Allow assignment of mandatory readings and track progress" => "Allow assignment of mandatory readings and track progress",
// "Must read tracker" => "Must read tracker",
// "Tracker containing the individual read requests" => "Tracker containing the individual read requests",
// "Namespace" => "Namespace",
// "Enable namespaces feature for wiki pages" => "Enable namespaces feature for wiki pages",
// "Namespace separator" => "Namespace separator",
// "Select the character, symbol, or text to use as the namespace separator" => "Select the character, symbol, or text to use as the namespace separator",
// "Default namespace" => "Default namespace",
// "Namespace to use when creating wiki pages. Should be defined within perspectives" => "Namespace to use when creating wiki pages. Should be defined within perspectives",
// "Hide namespace indicator in structure path" => "Hide namespace indicator in structure path",
// "Hide namespace indicator in page title" => "Hide namespace indicator in page title",
// "Force all non-namespace page links to the same namespace" => "Force all non-namespace page links to the same namespace",
// "If the current page is in a namespace, all links without a namespace will have it added automatically" => "If the current page is in a namespace, all links without a namespace will have it added automatically",
"Throttle newsletter send rate" => "Jarida la chupa la kutuma kiwango",
"Pause for a given amount of seconds before each batch to avoid overloading the mail server." => "Pumzika kwa kiasi fulani cha sekunde kabla ya kila kundi ili kuepuka kuzidi juu ya salama ya barua.",
"Newsletter pause length" => "Jarida la pause urefu",
"Number of seconds delay before each batch" => "Idadi ya sekunde kuchelewa kabla ya kila kundi",
"Newsletter batch size" => "Ukubwa wa kundi la jarida",
"Number of emails to send in each batch" => "Kiasi cha barua pepe kutuma katika kila kundi.",
// "emails" => "emails",
"Allow sending newsletters through external clients" => "Ruhusu kutuma majarida kupitia wateja wa nje",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
"Use relative (next / previous) pagination links" => "Tumia viungo vya kipagani (ijayo / ya awali)",
// "Encryption key for OAuthServer" => "Encryption key for OAuthServer",
// "A key used to encrypt/decrypt authorization codes" => "A key used to encrypt/decrypt authorization codes",
"PGP/MIME encrypted email messaging" => "Ujumbe wa barua pepe wa PGP / MIME",
// "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses" => "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses",
// "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on" => "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on",
// "Path to gnupg keyring" => "Path to gnupg keyring",
// "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\" => "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\",
// "Path to gpg executable" => "Path to gpg executable",
// "Full path to gpg executable" => "Full path to gpg executable",
// "Read signer pass phrase from prefs or from a file" => "Read signer pass phrase from prefs or from a file",
// "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\" => "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\",
// "preferences" => "preferences",
"file" => "faili",
// "Signer pass phrase" => "Signer pass phrase",
// "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file" => "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file",
// "leave empty if read from file" => "leave empty if read from file",
// "Path to signer pass phrase filename" => "Path to signer pass phrase filename",
// "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file" => "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file",
"Wiki buttons" => "Vifungo vya Wiki",
"Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)" => "Taja eneo la chaguo maalum za wiki (kama vile Backlinks, Maelezo ya Ukurasa, na kadhalika)",
"Top " => "Juu",
"Bottom" => "Chini",
"Neither" => "Wala",
// "Pages can reoccur in structure" => "Pages can reoccur in structure",
"A page can be listed multiple times in a structure" => "Ukurasa unaweza kutajwa mara nyingi kwa muundo",
"Fetch page content from incoming feeds" => "Pata maudhui ya ukurasa kutoka kwa feeds zinazoingia",
// "Page content from the source will be fetched before sending the content to the generators" => "Page content from the source will be fetched before sending the content to the generators",
// "if set, will display 'first' and 'last' links on pages" => "if set, will display 'first' and 'last' links on pages",
"Display \"fast-forward\" links" => "Onyesha viungo vya \"haraka-mbele\"",
"Display \"fast-forward\" links (to advance 10 percent of the total number of pages) " => "Onyesha viungo vya \"haraka-mbele\" (ili kuongeza asilimia 10 ya jumla ya kurasa)",
"Hide pagination when there is only one page" => "Ficha pagination wakati kuna ukurasa mmoja tu",
// "Don't display pagination on single pages" => "Don't display pagination on single pages",
"Use Icons" => "Tumia Icons",
"Display 'First' and 'Last' links" => "Kuonyesha 'Kwanza' na 'Mwisho' viungo",
"Require characters and numerals" => "Inahitaji herufi na namba",
"For improved security, require users to include a mix of alphabetical characters and numerals in passwords" => "Kwa usalama bora, zinahitaji watumiaji kuingiza mchanganyiko wa wahusika wa alfabeti na namba katika nywila",
"Password file used" => "Faili ya nenosiri imetumiwa",
// "The automatically selected file is recommended unless you generate your own blacklist file" => "The automatically selected file is recommended unless you generate your own blacklist file",
"Prevent common passwords" => "Zuia nenosiri za kawaida",
// "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist" => "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist",
"Password expires after" => "Nenosiri huisha baadae",
// "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in" => "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in",
"Require alphabetical characters in lower and upper case" => "Inahitaji wahusika wa alfabeti katika kesi ya chini na ya juu",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords" => "Neno la siri linapaswa kuwa na angalau tabia ndogo ya alfabeti kama \"a\" na tabia moja ya uhuishaji kama \"A\". Tumia chaguo hili kulazimisha watumiaji kuchagua nywila zenye nguvu",
"Require special characters" => "Inahitaji wahusika maalum",
"Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords" => "Neno la siri linapaswa kuwa na angalau tabia moja maalum katika kesi ndogo kama <b> \"/ \$%? & * () _ +. </B> Tumia chaguo hili kulazimisha watumiaji kuchagua nywila zenye nguvu",
"Require no consecutive repetition of the same character" => "Huna haja ya kurudia mfululizo wa tabia sawa",
"Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"" => "Nenosiri haipaswi kuwa na marudio mfululizo ya tabia sawa na \"111\" au \"aab\"",
"The password must be different from the user's log-in name" => "Nenosiri lazima iwe tofauti na jina la logi la mtumiaji",
"Payment" => "Malipo",
"Feature for tracking and managing payment requests" => "Kipengele cha kufuatilia na kusimamia maombi ya malipo",
// "Payment system" => "Payment system",
"Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Hivi sasa ni chaguo kati ya PayPal, na Cclite (katika maendeleo), au Credits ya Mtumiaji wa Tiki",
"PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: angalia PayPal.com - Cclite: Fedha ya Jumuiya",
"PayPal" => "PayPal",
// "Israel Post Payment Module" => "Israel Post Payment Module",
"Cclite" => "Cclite",
"Tiki User Credits" => "Mikopo ya Watumiaji wa Tiki \"",
// "PayPal ID" => "PayPal ID",
// "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type" => "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type",
// "Primary email of your PayPal account (Personal or Business)" => "Primary email of your PayPal account (Personal or Business)",
// "PayPal business password" => "PayPal business password",
// "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts" => "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts",
// "Primary password of your PayPal Pro business account - OPTIONAL" => "Primary password of your PayPal Pro business account - OPTIONAL",
// "Paypal business signature" => "Paypal business signature",
// "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts" => "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts",
// "Your API signature associated with your PayPal Pro business account - OPTIONAL" => "Your API signature associated with your PayPal Pro business account - OPTIONAL",
"PayPal environment" => "Hali ya PayPal",
"Used to switch between the PayPal sandbox, used for testing and development and the live environment" => "Ilibadilishana kati ya sandbox ya PayPal, iliyotumiwa kupima na maendeleo na mazingira ya kuishi",
"Production" => "Uzalishaji",
// "PayPal instant payment notification (IPN)" => "PayPal instant payment notification (IPN)",
"Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server" => "Wezesha IPN kwa kukamilisha malipo ya moja kwa moja. Ikiwa imewezeshwa, PayPal itasimamia tovuti wakati malipo yamehakikishwa. Malipo yatakapoingia moja kwa moja. Huenda hii haiwezekani ikiwa tovuti haipo kwenye seva ya umma",
// "Payment data transfer (PDT)" => "Payment data transfer (PDT)",
// "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically" => "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically",
// "Payment data transfer (PDT) token" => "Payment data transfer (PDT) token",
// " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT" => " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT",
// "Redirect after PDT payment" => "Redirect after PDT payment",
// "Optionally, after receiving a successful payment, the user will be redirected to this page" => "Optionally, after receiving a successful payment, the user will be redirected to this page",
"Currency used when entering payments" => "Fedha inayotumiwa wakati wa kuingia malipo",
"Default acceptable payment delay" => "Ucheleweshaji wa malipo ya kukubalika",
"Number of days before a payment request becomes overdue. This can be changed per payment request" => "Idadi ya siku kabla ya maombi ya malipo yanapungua. Hii inaweza kubadilishwa kwa ombi la malipo",
// "Cclite registries" => "Cclite registries",
// "Registries in Cclite" => "Registries in Cclite",
"Registry names in Cclite" => "Majina ya Msajili katika Cclite",
// "Cclite registry currencies" => "Cclite registry currencies",
// "Currencies in Cclite" => "Currencies in Cclite",
"Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)." => "Kila Usajili katika Cclite unaweza kuwa na sarafu yake mwenyewe. Lazima kuwa moja kwa Usajili. (kesi nyeti)",
// "Cclite server URL" => "Cclite server URL",
"Full URL of the repository" => "URL kamili ya hifadhi",
"for example, https://cclite.yourdomain.org/cclite/" => "kwa mfano, https://cclite.yourdomain.org/cclite/",
// "Cclite merchant key" => "Cclite merchant key",
// "Corresponds with merchant key setting in Cclite" => "Corresponds with merchant key setting in Cclite",
// "Cclite merchant user" => "Cclite merchant user",
"Username in Cclite representing \"the management\"" => "Jina la mtumiaji katika Cclite anayewakilisha \"usimamizi\"",
// "Cclite enable payments" => "Cclite enable payments",
"Select Cclite test or live operation." => "Mtihani au Uendeshaji wa Kuishi",
"Live" => "Kuishi",
// "Hashing algorithm" => "Hashing algorithm",
"Encryption type" => "Aina ya ficha",
"SHA1" => "SHA1",
"SHA256" => "SHA256",
"SHA512" => "SHA512",
// "Cclite payment notification" => "Cclite payment notification",
"To do" => "Kufanya",
// "Wiki page with manual payment instructions" => "Wiki page with manual payment instructions",
// "Enter wiki page name" => "Enter wiki page name",
// "Invoice prefix" => "Invoice prefix",
"The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice" => "Kiambatisho lazima kiweke na cha pekee ikiwa akaunti sawa ya PayPal inatumiwa kwa maeneo tofauti ya Tiki, kwa sababu PayPal hundi kwamba ankara haipatikani mara mbili",
"Types of credit to use" => "Aina ya mikopo ya kutumia",
// "This is a list of the types of Tiki user credits that are acceptable for payment" => "This is a list of the types of Tiki user credits that are acceptable for payment",
"Exchange rate for types of credit to use" => "Kiwango cha ubadilishaji kwa aina ya mikopo ya kutumia",
// "This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency" => "This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency",
// "User can only see own outstanding payments" => "User can only see own outstanding payments",
"Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments" => "Isipokuwa mtumiaji ametoa ruhusa ya malipo, mtumiaji anaweza kuona tu malipo yake mwenyewe",
// "User can only see own past or cancelled payments" => "User can only see own past or cancelled payments",
"Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments" => "Isipokuwa mtumiaji ametoa ruhusa ya malipo, mtumiaji anaweza kuona tu malipo yake ya awali au ya kufutwa",
// "Anonymous users can pay outstanding invoices" => "Anonymous users can pay outstanding invoices",
// "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)" => "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)",
"Manage product inventory" => "Dhibiti hesabu ya bidhaa",
"Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code" => "Tumia kipengele cha hesabu ya bidhaa. Hii inahitaji tracker ya bidhaa ili kuundwa vizuri, na Kitambulisho cha bidhaa lazima kiwe kifaa cha bidhaa",
// "Products tracker ID" => "Products tracker ID",
// "ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code" => "ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code",
// "Products tracker name" => "Products tracker name",
// "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code" => "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code",
// "Inventory type field ID" => "Inventory type field ID",
"In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"" => "Katika tracker bidhaa, ID ya shamba kuhifadhi aina ya hesabu; thamani ya shamba lazima iwe \"hakuna\" au \"ndani\"",
// "Inventory total field ID" => "Inventory total field ID",
// "In the products tracker, the ID of the field to store the total inventory of products" => "In the products tracker, the ID of the field to store the total inventory of products",
// "Inventory total less hold field ID" => "Inventory total less hold field ID",
// "In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts" => "In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts",
// "Inventory hold timeout" => "Inventory hold timeout",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
"Bundled products feature for cart" => "Vipande vya bidhaa vilivyoandikwa kwa gari",
// "Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code" => "Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code",
// "Product name field name" => "Product name field name",
// "In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle" => "In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle",
// "Items in bundle field name" => "Items in bundle field name",
// "In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product price field name" => "Product price field name",
"In the products tracker, the name of the field for the product price" => "Katika tracker ya bidhaa, jina la shamba kwa bei ya bidhaa",
// "Associated event ID field name" => "Associated event ID field name",
// "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with" => "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with",
// "Product class ID field name" => "Product class ID field name",
// "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature",
// "Gift certificate template field name" => "Gift certificate template field name",
// "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature",
// "Record cart orders in trackers" => "Record cart orders in trackers",
// "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording" => "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording",
// "Orders profile" => "Orders profile",
// "Wiki page containing the profile for creating orders (page name must not have spaces)" => "Wiki page containing the profile for creating orders (page name must not have spaces)",
// "Order item profile" => "Order item profile",
// "Wiki page containing the profile for creating order items (page name must not have spaces)" => "Wiki page containing the profile for creating order items (page name must not have spaces)",
// "Allow anonymous shopping" => "Allow anonymous shopping",
// "Allow shopping by anonymous users and record the orders in trackers" => "Allow shopping by anonymous users and record the orders in trackers",
// "Anonymous orders profile" => "Anonymous orders profile",
// "Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)" => "Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)",
// "Anonymous order item profile" => "Anonymous order item profile",
// "Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)" => "Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)",
// "Anonymous shopper info profile" => "Anonymous shopper info profile",
// "Anonymous users order review page" => "Anonymous users order review page",
// "Wiki page where anonymous users can review their orders" => "Wiki page where anonymous users can review their orders",
// "Temporary shopper group" => "Temporary shopper group",
// "Group name of group with permission to access review page via a token" => "Group name of group with permission to access review page via a token",
// "Enable association of product orders" => "Enable association of product orders",
"Enable association of products with events (or projects, etc.)." => "Ruhusu chama cha bidhaa na matukio (au miradi, nk)",
// "Events tracker ID" => "Events tracker ID",
// "Tracker ID of tracker that is the events tracker" => "Tracker ID of tracker that is the events tracker",
// "Events tracker name" => "Events tracker name",
// "Name of tracker that is the events tracker" => "Name of tracker that is the events tracker",
// "Event start field name" => "Event start field name",
// "Field name in events tracker of start date/time" => "Field name in events tracker of start date/time",
// "Event end field name" => "Event end field name",
// "Field name in events tracker of end date/time" => "Field name in events tracker of end date/time",
"Allow exchange of products" => "Ruhusu kubadilishana bidhaa",
// "Order items tracker ID" => "Order items tracker ID",
// "Tracker ID of tracker that is the order items tracker" => "Tracker ID of tracker that is the order items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift certificate tracker ID" => "Gift certificate tracker ID",
// "ID of tracker that is the gift certificate tracker" => "ID of tracker that is the gift certificate tracker",
// "Gift certificate tracker name" => "Gift certificate tracker name",
// "Name of tracker that is the gift certificate tracker" => "Name of tracker that is the gift certificate tracker",
// "Orders tracker name" => "Orders tracker name",
// "Name of tracker that is the orders tracker" => "Name of tracker that is the orders tracker",
// "Order items tracker name" => "Order items tracker name",
// "Name of tracker that is the order items tracker" => "Name of tracker that is the order items tracker",
// "Product classes tracker name" => "Product classes tracker name",
// "Name of tracker that is the product classes tracker" => "Name of tracker that is the product classes tracker",
// "Payment heading" => "Payment heading",
// "Heading displayed on payment form" => "Heading displayed on payment form",
// "Israel Post payment environment" => "Israel Post payment environment",
// "Switch between test transactions and real transactions" => "Switch between test transactions and real transactions",
// "Israel Post use pre-authorization" => "Israel Post use pre-authorization",
// "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post" => "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post",
// "Israel Post business ID" => "Israel Post business ID",
// "Provided by Israel Post, usually the business name" => "Provided by Israel Post, usually the business name",
// "Israel Post API password" => "Israel Post API password",
// "Provided by Israel Post" => "Provided by Israel Post",
"Send to URL" => "Tuma URL",
// "URL to redirect to on \"permission denied\"" => "URL to redirect to on \"permission denied\"",
"On permission denied, display login module" => "Juu ya ruhusa alikanusha, onyesha moduli ya kuingia",
// "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead" => "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead",
"PHP libxml extension" => "Ugani wa PHP libxml",
// "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default",
"PHP DateTime" => "Tarehe ya Tarehe ya PHPs",
// "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0" => "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0",
// "Number of comments to show on poll pages" => "Number of comments to show on poll pages",
// "The order in which order polls are displayed" => "The order in which order polls are displayed",
"Show categories" => "Onyesha makundi",
// "For polls that are categorized, the category is displayed" => "For polls that are categorized, the category is displayed",
"Show objects" => "Onyesha vitu",
// "List wiki pages or other site objects that the poll is attached to" => "List wiki pages or other site objects that the poll is attached to",
"Multiple polls per object" => "Uchaguzi mara nyingi kwa kitu",
"When used with the rating features, allow multiple polls to be attached to a single object" => "Ikiwa hutumiwa na vipengele vya rating, kuruhusu uchaguzi nyingi ziunganishwe kwenye kitu kimoja",
// "Disable textarea toolbar" => "Disable textarea toolbar",
// "Don't display the toolbar on text inputs in surveys" => "Don't display the toolbar on text inputs in surveys",
// "Precision of survey results calculation" => "Precision of survey results calculation",
// "Number of decimal places in the percentage figures" => "Number of decimal places in the percentage figures",
// "decimal places" => "decimal places",
// "Set display settings for all galleries" => "Set display settings for all galleries",
"PDF from URL" => "PDF kutoka URL",
"Using external tools, generate PDF documents from URLs" => "Kutumia zana za nje za kuzalisha nyaraka za PDF kutoka kwa URL",
"WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "WeasyPrint" => "WeasyPrint",
// "mPDF" => "mPDF",
"Webservice URL" => "URL ya Huduma ya Wavuti",
"URL to a service that takes a URL as the query string and returns a PDF document" => "Kiungo au URL kwa huduma inayochukua URL kama kamba ya swala na kurudi hati katika muundo wa PDF",
"WebKit path" => "Chemin du WebKit",
"Full path to the wkhtmltopdf executable to generate the PDF document with" => "Njia kamili ya kutekeleza inayozalisha hati ya PDF",
// "WeasyPrint path" => "WeasyPrint path",
// "Full path to the weasyprint executable to generate the PDF document with" => "Full path to the weasyprint executable to generate the PDF document with",
// "Print Friendly PDF" => "Print Friendly PDF",
// "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file" => "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file",
// "PDF Orientation" => "PDF Orientation",
// "Landscape or portrait" => "Landscape or portrait",
"Portrait" => "picha",
"Landscape" => "mazingira",
// "PDF page size" => "PDF page size",
// "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)" => "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)",
// "Legal" => "Legal",
// "Tabloid/Ledger" => "Tabloid/Ledger",
// "A0" => "A0",
// "A1" => "A1",
// "A2" => "A2",
// "A3" => "A3",
// "A4" => "A4",
// "A5" => "A5",
// "A6" => "A6",
// "Generate auto table of contents with PDF" => "Generate auto table of contents with PDF",
// "Link TOC with content" => "Link TOC with content",
// "Link table of contents headings with content in the PDF" => "Link table of contents headings with content in the PDF",
// "TOC heading" => "TOC heading",
// "Heading to be displayed above the table of contents" => "Heading to be displayed above the table of contents",
// "PDF TOC levels" => "PDF TOC levels",
// "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3" => "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3",
// "Show Page title" => "Show Page title",
// "Print wiki page title with pdf" => "Print wiki page title with pdf",
// "PDF header text" => "PDF header text",
// "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}" => "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}",
// "HTML / Wiki Syntax / " => "HTML / Wiki Syntax / ",
// "Left text" => "Left text",
// "Center Text" => "Center Text",
// "Right Text" => "Right Text",
// "PDF footer text" => "PDF footer text",
// "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}" => "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}",
// "Left margin" => "Left margin",
// "Numeric value.For example 10" => "Numeric value.For example 10",
// "Right margin" => "Right margin",
// "Numeric value, no need to add px. For example 10" => "Numeric value, no need to add px. For example 10",
// "Top margin" => "Top margin",
// "Bottom margin" => "Bottom margin",
// "Header margin from top of document" => "Header margin from top of document",
// "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Header can overlap text if top margin is not set properly" => "Warning: Header can overlap text if top margin is not set properly",
// "Footer margin from bottom of document" => "Footer margin from bottom of document",
// "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Footer can overlap text if bottom margin is not set properly" => "Warning: Footer can overlap text if bottom margin is not set properly",
// "Hyperlink behaviour in PDF" => "Hyperlink behaviour in PDF",
// "Off (Links will be removed)" => "Off (Links will be removed)",
// "Add as footnote (Links will be listed at end of document" => "Add as footnote (Links will be listed at end of document",
// "PDF Bookmarks" => "PDF Bookmarks",
// "Automatically generate bookmarks" => "Automatically generate bookmarks",
// "H1-H6, separated by |.For example: H1|H2|H3" => "H1-H6, separated by |.For example: H1|H2|H3",
// "Number of columns" => "Number of columns",
// "Default - 1 Column" => "Default - 1 Column",
// "2 Columns" => "2 Columns",
// "3 Columns" => "3 Columns",
// "4 Columns" => "4 Columns",
// "PDF password for viewing" => "PDF password for viewing",
// "Password-protect the generated PDF" => "Password-protect the generated PDF",
// "Watermark text" => "Watermark text",
// "PDF watermark text, if any" => "PDF watermark text, if any",
// "Watermark Image URL" => "Watermark Image URL",
// "The watermark image will appear under the text. Enter the complete image URL" => "The watermark image will appear under the text. Enter the complete image URL",
// "PDF page background color" => "PDF page background color",
// "Enter a valid CSS color code" => "Enter a valid CSS color code",
// "PDF page background image" => "PDF page background image",
// "Enter the full URL" => "Enter the full URL",
// "CoverPage text settings" => "CoverPage text settings",
// "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings" => "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings",
// "Coverpage image URL" => "Coverpage image URL",
// "Print wiki authors" => "Print wiki authors",
// "Include wiki page authors and date in print versions of wiki pages" => "Include wiki page authors and date in print versions of wiki pages",
// "Print original wiki URL" => "Print original wiki URL",
// "Include original wiki page URL in print versions of wiki pages" => "Include original wiki page URL in print versions of wiki pages",
// "Print original tracker item URL" => "Print original tracker item URL",
// "Print original forum post URL" => "Print original forum post URL",
// "Include original forum post URL in print version of forum posts" => "Include original forum post URL in print version of forum posts",
"Repository URLs" => "URL za hifadhi",
"List of URLs for the profile repositories that will be used" => "Orodha ya URL ya amana ya maelezo ambayo yatatumika.",
"Enter multiple repository URLs, one per line." => "Ingiza URL nyingi za amana, kwa kila mstari.",
"Data channels" => "Njia za data",
"Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Njia za data ni templates ambazo zinaweza kutumiwa kutoka kwa ombi la posta. Wanaweza kutumika kutengeneza kazi kwenye mitambo ngumu zaidi",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
"There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "Kuna masuala ya usalama kuhusiana na kutumia vituo vya data. Hakikisha ukurasa wa wasifu unadhibitiwa na watendaji tu",
"Developer mode" => "Mfumo wa Wasanidi programu",
"For profiles under an approval workflow, always use the latest version, even if not approved." => "Kwa maelezo chini ya kazi ya kuruhusu kazi, daima utumie toleo la hivi karibuni, hata kama halijaidhinishwa",
"Make sure you review the profiles you install." => "Hakikisha uhakiki maelezo uliyoweka.",
// "Automatically approve wiki-plugins on pages installed by profiles" => "Automatically approve wiki-plugins on pages installed by profiles",
// "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved" => "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved",
// "Make sure your profiles are not executable or editable by untrusted users" => "Make sure your profiles are not executable or editable by untrusted users",
"Proxy host name" => "Seva ya Wakala",
"Proxy host - without http:// or similar, just the host name" => "Seva ya Wakala - bila http:// au sawa, jina la mwenyeji tu",
"Proxy port" => "Hifadhi ya seva ya wakala",
"Proxy username" => "Mtumiaji wa Wakala",
"Proxy password" => "Password wa Wakala",
"Quantify change size" => "Fanya ukubwa wa mabadiliko",
"In addition to tracking the changes, track the change size and display approximately how up-to-date the page is" => "Mbali na kufuatilia mabadiliko, kufuatilia ukubwa wa mabadiliko na uonyeshe takriban jinsi hadi sasa ukurasa iko",
"Advanced Rating" => "Tathmini ya Juu",
// "In an advanced rating system, the options and calculation method can be configured" => "In an advanced rating system, the options and calculation method can be configured",
"Rating recalculation mode" => "Jinsi ya kurejesha maelezo",
"Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent" => "Tambua wakati na jinsi vikundi vya daraja vinavyorekebishwa. Kulingana na mzigo wa tovuti, baadhi ya chaguzi zinaweza kupendekezwa kwa wengine. Katika tovuti kubwa, zinapaswa kufanyika kama kazi ya 'cron'. Katika upiga kura wa kura, kunaweza kuwa na usahihi ikiwa hesabu ni tegemezi ya wakati",
"Recalculate on vote" => "Kuhesabu mara zingine wakati wa kura",
"Randomly recalculate oldest ratings (on load)" => "Kuhesabu nasibu maelezo ya zamani zaidi (upakiaji)",
"Randomly recalculate oldest ratings (on vote)" => "Kuhesabu nasibu maelezo ya zamani zaidi (juu ya kura)",
"Cron job (must be set manually)" => "Kazi iliyopangwa ('Cron', inapaswa kuweka kwa mikono)",
// "Before any attempt to re-index the object" => "Before any attempt to re-index the object",
"Recalculation odds (1 in X)" => "Uwezekano wa kurejesha (1 juu ya X)",
"Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Operesheni nasibu hufanyika kila ombi. Iwapo itafanikiwa, itajumuisha idadi fulani ya kura",
"votes" => "kura",
"Recalculation count" => "Kuhesabu upya",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "ratings" => "ratings",
// "Smiley Ratings" => "Smiley Ratings",
// "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration" => "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration",
"Enabled" => "Imewezeshwa",
// "Detailed rating results" => "Detailed rating results",
// "Displays a table with the result count and percentage per rating option" => "Displays a table with the result count and percentage per rating option",
// "Reversed Rating Options" => "Reversed Rating Options",
// "Displays the ratings options in reverse" => "Displays the ratings options in reverse",
// "Include percentages in the detailed rating results" => "Include percentages in the detailed rating results",
// "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown" => "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown",
// "Default rating options" => "Default rating options",
// "List of options available" => "List of options available",
// "Multiple votes per user" => "Multiple votes per user",
// "Allow users to vote multiple times in the same poll" => "Allow users to vote multiple times in the same poll",
"Use reCAPTCHA" => "Tumia reCAPTCHA",
"Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA" => "Tumia ReCaptcha, huduma maalum ya captcha, badala ya CAPTCHA yenyewe",
"You will need to register at [http://www.google.com/recaptcha]" => "Utahitaji kujiandikisha kwenye [http://www.google.com/recaptcha]",
"Site key" => "Ufunguo wa tovuti",
// "reCAPTCHA public key obtained after registering" => "reCAPTCHA public key obtained after registering",
"Secret key" => "Ufunguo wa siri",
// "reCAPTCHA private key obtained after registering" => "reCAPTCHA private key obtained after registering",
// "reCAPTCHA theme" => "reCAPTCHA theme",
// "Choose a theme for the reCAPTCHA widget" => "Choose a theme for the reCAPTCHA widget",
"Black Glass" => "Kioo cha Nyeusi",
"Red" => "Nyekundu",
"White" => "Nyeupe",
// "reCAPTCHA version" => "reCAPTCHA version",
// "1.0" => "1.0",
// "2.0" => "2.0",
// "3.0" => "3.0",
"Record untranslated strings" => "Ongeza maandiko zisizotafsiriwa",
"Keep track of the unsuccessful attemps to translate strings" => "Weka wimbo wa majaribio yasiyofanikiwa ya kutafsiri masharti",
// "Redis" => "Redis",
// "Enable connection to Redis to store cache" => "Enable connection to Redis to store cache",
// "Requires PHP Redis" => "Requires PHP Redis",
// "Redis Host" => "Redis Host",
// "IP address or domain name for Redis server" => "IP address or domain name for Redis server",
// "Redis Port" => "Redis Port",
// "Port for Redis server" => "Port for Redis server",
// "Redis connection timeout" => "Redis connection timeout",
// "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited" => "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited",
// "Redis Prefix" => "Redis Prefix",
// "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none" => "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none",
// "Redis cache expiry" => "Redis cache expiry",
// "Duration for which the cache will be kept. 0 means unlimited" => "Duration for which the cache will be kept. 0 means unlimited",
// "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern" => "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern",
"Restrict supported languages" => "Weka orodha ya lugha zilizopo",
"Limit the languages made available on the site" => "Punguza lugha zilizopatikana kwenye tovuti",
"Use Ctrl+Click to select multiple languages." => "Tumia Ctrl + Bofya ili kuchagua lugha nyingi.",
"Enable SAML Auth" => "Wezesha uthibitishaji wa SAML",
// "IdP Entity Id" => "IdP Entity Id",
// "Identifier of the IdP entity (\"Issuer\")" => "Identifier of the IdP entity (\"Issuer\")",
// "Single sign-on service URL" => "Single sign-on service URL",
// "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")" => "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")",
// "Single log-out service URL" => "Single log-out service URL",
// "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")" => "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")",
"X.509 certificate" => "Cheti X.509",
// "Public x509 certificate of the IdP.  (\"X.509 certificate\")" => "Public x509 certificate of the IdP.  (\"X.509 certificate\")",
// "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section" => "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section",
"Sync user group with IdP data" => "Unganisha kikundi cha watumiaji na data ya IdP",
// "This should be enabled to sync groups with the IdP" => "This should be enabled to sync groups with the IdP",
"Enable Single Logout Service" => "Wezesha Huduma ya kuondoka ya mara moja",
// "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers" => "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers",
"Default group" => "Kikundi cha msingi",
// "When provisioning a new user and not group found, assign that group" => "When provisioning a new user and not group found, assign that group",
"Account matcher" => "Chombo cha kufanana wa Akaunti",
// "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost" => "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost",
// "Log-in link text" => "Log-in link text",
// "The text that appears on the log-in page" => "The text that appears on the log-in page",
"SAML attribute that will be mapped to the Tiki username" => "Thamani ya SAML ambayo itaanganishwa kwa jina la mtumiaji Tiki",
// "The SAML attribute that will be mapped to the Tiki username" => "The SAML attribute that will be mapped to the Tiki username",
"SAML attribute that will be mapped to the Tiki email" => "Thamani ya SAML ambayo itaanganishwa kwa barua pepe ya Tiki",
// "The SAML attribute that will be mapped to the Tiki email" => "The SAML attribute that will be mapped to the Tiki email",
"SAML attribute that will be mapped to the Tiki group" => "Thamani ya SAML ambayo itaanganishwa kwa kikundi cha Tiki",
// "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation" => "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation",
"Admins" => "Wasimamizi",
// "Set here the values of the IdP related to the user group info that will be matched with the Admins group" => "Set here the values of the IdP related to the user group info that will be matched with the Admins group",
"Registered" => "Imeandikishwa",
// "Set here the values of the IdP related to the user group info that will be matched with the Registered group" => "Set here the values of the IdP related to the user group info that will be matched with the Registered group",
"Debug Mode" => "Njia ya Dhibiti",
// "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed." => "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed.",
"Strict Mode" => "Njia ya madhubuti",
// "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated" => "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated",
// "Service Provider Entity ID" => "Service Provider Entity ID",
// "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID" => "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID",
"Requested NameIDFormat" => "NameIDFormat kilichoombwa",
// "Specifies constraints on the name identifier to be used to represent the requested subject" => "Specifies constraints on the name identifier to be used to represent the requested subject",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified" => "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress" => "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName" => "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:entity" => "urn:oasis:names:tc:SAML:2.0:nameid-format:entity",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:transient" => "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" => "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted" => "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos" => "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos",
"Requested AuthnContext" => "AuthnContext kilichoombwa",
// "Authentication context: unselect all to accept any type, otherwise select the valid contexts" => "Authentication context: unselect all to accept any type, otherwise select the valid contexts",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified" => "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Password" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Password",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" => "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:X509" => "urn:oasis:names:tc:SAML:2.0:ac:classes:X509",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos",
// "urn:federation:authentication:windows" => "urn:federation:authentication:windows",
// "Enable Lowercase URL encoding" => "Enable Lowercase URL encoding",
// "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues." => "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues.",
// "Encrypt nameID" => "Encrypt nameID",
"Sign AuthnRequest" => "Tia saini AuthnRequest",
// "The samlp:AuthnRequest messages sent by this SP will be signed" => "The samlp:AuthnRequest messages sent by this SP will be signed",
"Sign LogoutRequest" => "Tia saini LogoutRequest",
// "The samlp:logoutRequest messages sent by this SP will be signed" => "The samlp:logoutRequest messages sent by this SP will be signed",
"Sign LogoutResponse" => "Tia saini LogoutResponse",
// "The samlp:logoutResponse messages sent by this SP will be signed" => "The samlp:logoutResponse messages sent by this SP will be signed",
"Sign Metadata" => "Tia saini Metadata",
// "The Metadata published by this SP will be signed" => "The Metadata published by this SP will be signed",
"Reject Unsigned Messages" => "Kataa Ujumbe haliyosainiwa",
// "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received" => "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received",
"Reject Unsigned Assertions" => "Kataa madai haliyosainiwa",
// "Reject unsigned saml:Assertion received" => "Reject unsigned saml:Assertion received",
"Reject Unencrypted Assertions" => "Kataa madai yasiyo ya kufungwa",
// "Reject unencrypted saml:Assertion received" => "Reject unencrypted saml:Assertion received",
"Retrieve Parameters From Server" => "Rudisha Vigezo Kutoka Server",
// "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters" => "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters",
"Service Provider X.509 certificate" => "Cheti X.509 ya Mtoa Huduma",
// "Public x509 certificate of the SP" => "Public x509 certificate of the SP",
"Service Provider Private Key" => "Ufunguo wa kibinafsi ya Mtoa huduma",
// "Private key of the SP" => "Private key of the SP",
"Signature Algorithm" => "Algorithm ya saini",
// "Algorithm that the toolkit will use on the signing process" => "Algorithm that the toolkit will use on the signing process",
// "http://www.w3.org/2000/09/xmldsig#rsa-sha1" => "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
// "http://www.w3.org/2000/09/xmldsig#dsa-sha1" => "http://www.w3.org/2000/09/xmldsig#dsa-sha1",
// "Scheduler stalled after (minutes)" => "Scheduler stalled after (minutes)",
// "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection" => "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection",
// "Notify on stalled schedulers" => "Notify on stalled schedulers",
// "Send an email notification when a stalled scheduler is detected" => "Send an email notification when a stalled scheduler is detected",
// "Users to notify on stalled task" => "Users to notify on stalled task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Self healing after (minutes)" => "Self healing after (minutes)",
// "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing" => "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing",
// "Notify on healed schedulers" => "Notify on healed schedulers",
// "Send an email notification when a stalled scheduler is healed" => "Send an email notification when a stalled scheduler is healed",
// "Users to notify on healed task" => "Users to notify on healed task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Number of logs to keep" => "Number of logs to keep",
// "0 will keep all logs" => "0 will keep all logs",
// "SCORM support" => "SCORM support",
// "Handle SCORM package files on upload. SCORM is a standard used in learning management systems" => "Handle SCORM package files on upload. SCORM is a standard used in learning management systems",
// "SCORM Tracker" => "SCORM Tracker",
// "The ID number of the tracker used to store SCORM metadata" => "The ID number of the tracker used to store SCORM metadata",
"Parse search results" => "Kuchambua matokeo",
// "When enabled search results are parsed so content formatting is visible in the search results" => "When enabled search results are parsed so content formatting is visible in the search results",
"Default where" => "Msimamo kama msingi",
"When object filter is not on, limit to search one type of object" => "Wakati kichujio cha kitu kisichopo juu, chunguza kutafuta aina moja ya kitu",
"Entire site" => "Tovuti nzima",
"Wiki Pages" => "Kurasa za Wiki",
"Wiki pages" => "Kurasa za Wiki",
"Blog posts" => "Machapisho ya blogu",
"Tracker items" => "Vipengee vya tracker",
"Spreadsheets" => "Majedwali",
"Restrict search language by default" => "Punguza lugha ya utafutaji kwa kawaida",
// "Only search content that is in the interface language, otherwise show the language menu" => "Only search content that is in the interface language, otherwise show the language menu",
"Autocomplete page names" => "Kukamilisha kwa pekee kwa majina ya ukurasa",
// "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc" => "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc",
// "deprecated" => "deprecated",
"Category filter" => "Faili ya chujio",
// "Tag filter" => "Tag filter",
// "Use facets for default search interface" => "Use facets for default search interface",
// "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines" => "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines",
"Facet result count" => "Hesabu ya matokeo ya vipengee",
// "Default number of facet results to obtain" => "Default number of facet results to obtain",
"facet results" => "matokeo ya vipengee",
// "Search index outdated" => "Search index outdated",
// "Number of days to consider the search index outdated" => "Number of days to consider the search index outdated",
"Show error on missing field" => "Onyesha hitilafu kwenye uwanja lisilopo",
// "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly" => "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly",
// "File thumbnail preview" => "File thumbnail preview",
// "Have a preview of attachments in search results" => "Have a preview of attachments in search results",
// "Use date histogram aggregations" => "Use date histogram aggregations",
// "Use date histogram aggregations (facets) when indexing, requires Elasticsearch" => "Use date histogram aggregations (facets) when indexing, requires Elasticsearch",
// "Date histogram aggregations interval" => "Date histogram aggregations interval",
// "Default interval for date histogram aggregations" => "Default interval for date histogram aggregations",
// "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0" => "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0",
// "Date range aggregations ranges" => "Date range aggregations ranges",
// "Default ranges for date range aggregations" => "Default ranges for date range aggregations",
// "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0" => "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0",
// "Excluded facets" => "Excluded facets",
// "List of facets (a.k.a. aggregations) to exclude from the default search results" => "List of facets (a.k.a. aggregations) to exclude from the default search results",
// "Avoid Duplicated Facets" => "Avoid Duplicated Facets",
// "Avoid Facets appearing with the same name, usually by appending the Tracker name" => "Avoid Facets appearing with the same name, usually by appending the Tracker name",
"Parse wiki syntax in comments" => "Piga syntax ya Wiki katika maoni",
"Parse wiki syntax in comments in all sections apart from Forums" => "Eleza syntax ya wiki katika maoni ya sehemu zote isipokuwa vikao",
"Use \"Accept wiki syntax\" for forums in admin forums page" => "Tumia \"Kukubali Syntax Wiki\" kwa vikao kwenye ukurasa wa vikao vya admin",
// "Short URL" => "Short URL",
// "Provides the ability to create a short url, easy to share" => "Provides the ability to create a short url, easy to share",
// "Short URL base URL" => "Short URL base URL",
// "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website" => "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website",
"Sender email" => "Barua pepe ya mtumaji",
"Email address that will be used as the sender for outgoing emails" => "Anwani ya barua pepe iliyotumiwa kama mtumaji kwa barua pepe zinazoondoka",
// "Sender full name" => "Sender full name",
// "Real name that will be used as the sender for outgoing emails" => "Real name that will be used as the sender for outgoing emails",
"Time zone" => "Eneo la wakati",
"Indicates the default time zone to use for the server" => "Inabainisha eneo la wakati wa kutosha la kutumia kwa seva",
"Session storage location" => "Eneo la kuhifadhi sehemu",
"Select where the session information should be stored. Memcache sessions require memcache to be configured." => "Chagua ambapo taarifa ya kikao inapaswa kuhifadhiwa. Vikao vya Memcache vinahitaji memcache kupangiliwa.",
"Default (from php.ini)" => "Thamani ya msingi (kutoka php.ini)",
"Database" => "Database",
"Session lifetime" => "Muda wa kikao",
"Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance." => "Imeonyesha kama dakika. Hii ni wakati mdogo ulioingia. Ili kuwa wakati halisi, marekebisho lazima yamefanywa katika .htaccess session.gc_probability na session.gc_divisor kwa 1. Kuwa makini - kubadilisha uwezekano unaweza kuathiri utendaji wa seva.",
"Silent session" => "Samu ya kimya",
"Do not automatically start sessions" => "Je, si kuanza vikao moja kwa moja",
"Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)" => "Watumiaji watakuwa na kikao tu ikiwa wakiingia. Watumiaji wasiojulikana hawataweza kuwa na vipengele kama lugha ya kubadili au kubadili mandhari (ambayo inahitaji kikao)",
// "Can cause problems when combined with cookie consent and JavaScript-disabled browsers" => "Can cause problems when combined with cookie consent and JavaScript-disabled browsers",
"Session cookie name" => "Jina la kuki la kikao",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
"Protect all sessions with HTTPS" => "Kulinda vikao vyote na HTTPS",
"Always redirect to HTTPS to prevent a session hijack through network sniffing" => "Daima kuelekeza HTTPS ili kuzuia wizi wa kikao kwa njia ya kusikiliza mtandao",
// "Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site" => "Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site",
"Display links on the share page" => "Onyesha viungo kwenye ukurasa wa kushiriki",
"Token notification" => "Arifa ya Ishara",
"Users can subscribe to the notifications of consultation of the token" => "Watumiaji wanaweza kujiunga na arifa za ushauri wa ishara",
"Add contact" => "Ongeza anwani",
"If not already in the list, recipients are added to the list of contacts" => "Ikiwa si tayari kwenye orodha, wapokeaji wanaongezwa kwenye orodha ya anwani",
"Display name and email" => "Onyesha jina na barua pepe",
"If the user is connected, the name and email will display in the page" => "Ikiwa mtumiaji anaunganishwa, jina na barua pepe zitaonyeshwa kwenye ukurasa",
// "Number of times accessed" => "Number of times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Maximum number of times accessed" => "Maximum number of times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "page hits" => "page hits",
// "The name of the default group" => "The name of the default group",
"Create with default group" => "Unda na kikundi kama msingi",
"Valid affiliations" => "Uhusiano unaofaa",
// "A list of affiliations which will allow users to log in to this wiki" => "A list of affiliations which will allow users to log in to this wiki",
"Separate multiple affiliations with commas" => "Tofautiana na ushirikiano wa aina nyingi na vitambaa",
// "Shipping service" => "Shipping service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
"FedEx API" => "API ya FedEx",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx key" => "FedEx key",
// "Developer key" => "Developer key",
// "FedEx password" => "FedEx password",
// "FedEx meter number" => "FedEx meter number",
// "FedEx account number" => "FedEx account number",
"UPS API" => "API ya UPS",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS username" => "UPS username",
"UPS credentials" => "Vitambulisho vya UPS",
// "UPS password" => "UPS password",
// "UPS access key" => "UPS access key",
// "Custom shipping provider" => "Custom shipping provider",
"Short date format" => "Aina fupi ya tarehe",
// "Specify how Tiki displays the date (shorter version)" => "Specify how Tiki displays the date (shorter version)",
"Short time format" => "Aina fupi ya saa",
// "Specify how Tiki displays the time (shorter version)" => "Specify how Tiki displays the time (shorter version)",
// "Short JavaScript date format" => "Short JavaScript date format",
// "Used in jQuery-UI date picker fields" => "Used in jQuery-UI date picker fields",
// "Short JavaScript time format" => "Short JavaScript time format",
// "Used in jQuery-UI datetime picker fields" => "Used in jQuery-UI datetime picker fields",
"%Y-%m-%d" => "%Y-%m-%d",
"%H:%M" => "%H:%M",
// "yy-mm-dd" => "yy-mm-dd",
// "HH:mm" => "HH:mm",
"%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
"Display available translations" => "Onyesha tafsiri zilizopo",
// "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons" => "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons",
"Close site" => "Funga tovuti",
// "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site" => "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site",
// "Coming soon" => "Coming soon",
"Message" => "Ujumbe",
// "Site is closed for maintenance; please come back later" => "Site is closed for maintenance; please come back later",
// "Server is currently too busy; please come back later" => "Server is currently too busy; please come back later",
"Locations (breadcrumbs)" => "Mahali",
"Examples:  » / >  : -> →" => "Mfano:  » / >  : -> →",
"Choices" => "Uchaguzi",
"Examples: | / ¦  :" => "Mfano: | / ¦  :",
"Browser title position" => "Msimamo wa kichwa cha kivinjari",
// "Position of the browser title in the full browser bar relative to the current page's descriptor" => "Position of the browser title in the full browser bar relative to the current page's descriptor",
"After current page's descriptor" => "Baada ya descriptor ya ukurasa wa sasa ",
"Before current page's descriptor" => "Kabla ya descriptor ya ukurasa wa sasa",
// "No browser title, only current page's descriptor" => "No browser title, only current page's descriptor",
// "Only browser title, no current page's descriptor" => "Only browser title, no current page's descriptor",
"Browser title display mode" => "Mfumo wa kuonyesha kichwa cha kivinjari",
"When breadcrumbs are used, method to display the browser title" => "Wakati mahali inatumiwa, njia ya kuonyesha kichwa cha kivinjari",
"Most-specific first" => "maalum zaidi ya kwanza",
"Least-specific first (site)" => "angalau maalum ya kwanza (tovuti)",
"Current only" => "Tu ya sasa",
// "Favicons" => "Favicons",
// "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used" => "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used",
"Site terminal" => "Tovuti ya Terminal",
// "Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
"Site terminal configuration" => "Usanidi ya Tovuti ya Terminal",
"Provides the mapping from subnets to perspective." => "Hutoa ramani kutoka kwenye vituo vya chini ili kutazama.",
"One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID." => "Moja kwa kila mstari. Kiambatisho cha Mtandao katika uthibitishaji wa CIDR (ukubwa ya anwani/maski), ikitenganishwa na comma na Kitambulisho cha mtazamo.",
"Google Analytics account number" => "Nambari ya akaunti ya Google Analytics",
// "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY" => "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY",
// "Google Analytics Groups Option" => "Google Analytics Groups Option",
// "Define option for Google Analytics groups" => "Define option for Google Analytics groups",
// "Included" => "Included",
// "Excluded" => "Excluded",
// "Google Analytics Available Groups" => "Google Analytics Available Groups",
// "User groups for which Google Analytics will be available" => "User groups for which Google Analytics will be available",
// "Google Global Site Tag Mode" => "Google Global Site Tag Mode",
// "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js" => "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js",
// "Google authentication credentials file" => "Google authentication credentials file",
// "Path to the Google Service Account credentials JSON file" => "Path to the Google Service Account credentials JSON file",
"Site layout" => "Usanifu wa tovuti",
// "Changes the template for the overall site layout" => "Changes the template for the overall site layout",
"Admin layout" => "Usanifu wa Admin",
// "Specify which layout template to use for admin pages" => "Specify which layout template to use for admin pages",
// "Enable layout per page, etc" => "Enable layout per page, etc",
// "Specify an alternate layout for a particular wiki page, etc" => "Specify an alternate layout for a particular wiki page, etc",
// "Piwik server URL" => "Piwik server URL",
// "The URL to the Piwik server of this site" => "The URL to the Piwik server of this site",
// "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL" => "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL",
// "Site Id" => "Site Id",
// "The ID of this website in Piwik" => "The ID of this website in Piwik",
// "Piwik JavaScript tracking code" => "Piwik JavaScript tracking code",
// "Piwik Groups Option" => "Piwik Groups Option",
// "Define option for Piwik groups" => "Define option for Piwik groups",
// "Piwik Available Groups" => "Piwik Available Groups",
// "User groups for which piwik will be available" => "User groups for which piwik will be available",
// "Security timeout" => "Security timeout",
// "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case" => "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case",
// "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting" => "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting",
// "Code to be placed on every page of this website just before the </body> tag" => "Code to be placed on every page of this website just before the </body> tag",
"Publish" => "Kuchapisha",
// "Make the banner visible to all site visitors" => "Make the banner visible to all site visitors",
// "Activate must be turned on for Publish to take effect" => "Activate must be turned on for Publish to take effect",
"Logo source (image path)" => "Njia ya alama ya tovuti",
"Logo background color" => "Rangi ya asili ya alama",
// "A legacy option to add a background color to the div that contains the logo image" => "A legacy option to add a background color to the div that contains the logo image",
"Examples:" => "Mifano:",
"Logo title (on mouseover)" => "Jina la alama (wakati mouse iko juu yake)",
// "This appears as tool tip text. The site logo is also a link to the site index (top page)" => "This appears as tool tip text. The site logo is also a link to the site index (top page)",
"HTML \"alt\" tag description" => "Maelezo ya lebo \"alt\" ya HTML",
// "Normally a description of the image, such as \"Example.com logo\"" => "Normally a description of the image, such as \"Example.com logo\"",
"Used by text browsers, screen readers, etc." => "Inatumiwa na wavinjari wa maandishi, wasomaji wa skrini, nk.",
"Site icon" => "Icon cha tovuti",
// "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space" => "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space",
"Recommended image height: 32 pixel" => "Imependekezwa urefu wa picha: 32 pixel",
// "Sitemap protocol" => "Sitemap protocol",
// "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines" => "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines",
"Include Smarty notices in the PHP error report" => "Weka matangazo ya Smarty katika ripoti ya hitilafu ya PHP",
"In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur" => "Mara nyingi, matangazo ya Smarty yanaweza kupuuzwa kwa usalama. Hata hivyo, inaweza kuwa na manufaa katika mchakato wa maendeleo wakati masuala yasiyotarajiwa yanatokea",
// "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages" => "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages",
"Smarty security" => "Usalama wa Smarty",
"Do not allow PHP code in Smarty templates" => "Usiruhusu msimbo wa PHP katika templates za Smarty",
"You should leave this on unless you know what you are doing" => "Unapaswa kuondoka hii isipokuwa unapotambua unachofanya",
"Extra Smarty modifiers" => "Modifiers vya ziada vya Smarty",
// "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates" => "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates",
// "There may be security implications. Make sure you know what you are doing" => "There may be security implications. Make sure you know what you are doing",
"Extra Smarty functions" => "Functions ya ziada ya Smarty",
// "Make additional PHP functions available as Smarty functions. This may be needed for custom templates" => "Make additional PHP functions available as Smarty functions. This may be needed for custom templates",
"Extra Smarty directories" => "Directories vya ziada vya Smarty",
// "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)" => "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)",
"Smarty compilation" => "Mkusanyiko wa Smarty",
"Indicates when the template cache should be refreshed." => "Inaonyesha wakati cache ya template inapaswa kurejeshwa.",
"Modified" => "Ilibadilishwa",
"Never check (performance)" => "Kamwe uangalie (utendaji)",
"Always (development, slow)" => "Daima (maendeleo, polepole)",
"Smarty cache permissions" => "Ruhusa vya cache za Smarty",
// "Permissions that enable Smarty to write to the templates_c directory" => "Permissions that enable Smarty to write to the templates_c directory",
"User writable (0644)" => "Mtumiaji anayeandika (0644)",
"User & group writable (0664)" => "Mtumiaji na kikundi kilichoandikwa (0664)",
// "Social network type" => "Social network type",
// "Select how the friendship relations within the social network should be treated" => "Select how the friendship relations within the social network should be treated",
// "Follow (as in Twitter)" => "Follow (as in Twitter)",
// "Friend (as in Facebook)" => "Friend (as in Facebook)",
// "Followers need approval" => "Followers need approval",
"Consumer key" => "Fungulo wa mteja",
"Consumer key generated by registering this Tiki site as an application at Twitter" => "Fungulo wa mteja yanayotokana na kusajili tovuti hii ya Tiki kama maombi kwenye Twitter",
"Consumer secret" => "Nambari ya siri ya mteja",
// "Consumer secret generated by registering this Tiki site as an application at Twitter" => "Consumer secret generated by registering this Tiki site as an application at Twitter",
// "Twitter site name" => "Twitter site name",
// "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title" => "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title",
// "Twitter site image" => "Twitter site image",
// "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL" => "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL",
"Application secret" => "Nambari ya siri ya programu",
"Application secret generated by registering this Tiki site as an application at Facebook" => "Nambari ya siri ya programu yanayotokana na kusajili tovuti hii ya Tiki kama maombi kwenye Facebook",
"Application ID" => "Kitambulisho cha programu",
"Application ID generated by registering this Tiki site as an application at Facebook" => "Kitambulisho cha programu yanayotokana na kusajili tovuti hii ya Tiki kama maombi kwenye Facebook",
// "Facebook site name" => "Facebook site name",
// "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title" => "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title",
// "Facebook site image" => "Facebook site image",
// "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices" => "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices",
"Login using Facebook" => "Ingia kupitia Facebook",
"Allow users to log in using Facebook" => "Ruhusu watumiaji kuingia katika kutumia Facebook",
"Auto-create Tiki user" => "Unda watumiaji wa Tiki kwa moja kwa moja",
"Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Tengeneza moja kwa moja mtumiaji wa Tiki kwa jina la mtumiaji wa fb_xxxxxxxx kwa watumiaji wanaingia kwenye Facebook ikiwa hawana akaunti ya Tiki. Ikiwa sio, wataombwa kuunganisha au kusajili akaunti ya Tiki",
// "Require Facebook users to enter local account info on creation" => "Require Facebook users to enter local account info on creation",
"Require Facebook users to enter local account info, specifically email and local log-in name" => "Inahitaji watumiaji wa Facebook kuingia maelezo ya akaunti ya ndani, hasa barua pepe na jina login la ndani",
// "Tiki can post to the Facebook wall" => "Tiki can post to the Facebook wall",
"Tiki may post status messages, notes, photos, and videos to the Facebook Wall" => "Tiki inaweza kutuma ujumbe wa hali, maelezo, picha, na video kwenye Ukuta wa Facebook",
"Tiki can manage events" => "Tiki inaweza kusimamia matukio",
"Tiki may create and RSVP to Facebook events" => "Tiki inaweza kuunda na RSVP kwenye matukio ya Facebook",
"Tiki can manage pages" => "Tiki inaweza kusimamia kurasa",
"Tiki can manage user pages" => "Tiki inaweza kusimamia kurasa za mtumiaji",
"Tiki can SMS" => "Tiki inaweza kutumia SMS",
// "Tiki can use SMS functions via Facebook" => "Tiki can use SMS functions via Facebook",
// "Set user email from Facebook on creation" => "Set user email from Facebook on creation",
// "Create a user tracker item on registration" => "Create a user tracker item on registration",
// "First and last name tracker field IDs to set on creation" => "First and last name tracker field IDs to set on creation",
// "bit.ly login" => "bit.ly login",
"Site-wide log-in name (username) for bit.ly" => "Jina ya login la tovuti (mtumiaji) ulioongezwa kwa bit.ly",
// "bit.ly key" => "bit.ly key",
"Site-wide API key for bit.ly" => "Kitufe cha API kwa bit.ly ya kupanuliwa kwa tovuti",
"Use site-wide account" => "Tumia akaunti ya tovuti kwa kila mtu",
"When set to \"yes\", only the site-wide account will be used for all users" => "Kuweka chaguo hili 'ndiyo' kitatumia tu akaunti iliyopanuliwa ya tovuti kwa watumiaji wote",
// "Client ID" => "Client ID",
// "Client ID generated by registering this site as an application at LinkedIn" => "Client ID generated by registering this site as an application at LinkedIn",
// "Client secret" => "Client secret",
// "Client Secret generated by registering this site as an application at LinkedIn" => "Client Secret generated by registering this site as an application at LinkedIn",
// "Log in using LinkedIn" => "Log in using LinkedIn",
// "Allow users to log in using LinkedIn" => "Allow users to log in using LinkedIn",
// "Auto-create Tiki user from LinkedIn" => "Auto-create Tiki user from LinkedIn",
// "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Set user email from LinkedIn on creation" => "Set user email from LinkedIn on creation",
// "Tiki will set the user's email from Facebook on creation" => "Tiki will set the user's email from Facebook on creation",
// "Sets whether a tracker item should be created for the user upon registration" => "Sets whether a tracker item should be created for the user upon registration",
// "Comma-separated, with first name field followed by last name field; for example, '2,3'" => "Comma-separated, with first name field followed by last name field; for example, '2,3'",
// "Tiki will set the user's email from LinkedIn on creation" => "Tiki will set the user's email from LinkedIn on creation",
"Stored searches" => "Utafutaji uliohifadhiwa",
// "Allow users to store search queries" => "Allow users to store search queries",
"Expose Jitsi provision URL" => "Onyesha URL ya utowaji ya Jitsi",
// "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server" => "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server",
"Jitsi configuration" => "Usanidi wa Jitsi",
// "Content of a Jitsi-format Java properties file" => "Content of a Jitsi-format Java properties file",
// "Location where tracker attachment files are stored" => "Location where tracker attachment files are stored",
// "Filesystem" => "Filesystem",
// "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory" => "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory",
"Site theme" => "Mandhari ya tovuti",
// "Icons of the displayed theme" => "Icons of the displayed theme",
// "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com" => "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com",
"Site theme option" => "Chaguo cha mandhari ya tovuti",
// "Supplemental style sheet for the selected theme" => "Supplemental style sheet for the selected theme",
// "theme option, theme-option, style option, options, css" => "theme option, theme-option, style option, options, css",
// "Custom theme URL" => "Custom theme URL",
// "Local or external URL of the custom Bootstrap-compatible CSS file to use" => "Local or external URL of the custom Bootstrap-compatible CSS file to use",
"Admin theme" => "Mandhari ya Admin",
// "Theme for the settings panels and other administration pages" => "Theme for the settings panels and other administration pages",
"Admin theme option" => "Chaguo cha mandhari cha Admin",
// "Option theme includes main theme CSS" => "Option theme includes main theme CSS",
// "Don't include the main theme stylesheet because its contents are included in the option stylesheet" => "Don't include the main theme stylesheet because its contents are included in the option stylesheet",
// "Navbar background color" => "Navbar background color",
// "Dark" => "Dark",
// "Light" => "Light",
// "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme" => "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme",
// "Fixed topbar offset" => "Fixed topbar offset",
// "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content" => "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content",
// "topbar offset, top offset, fixed topbar, top padding, offset" => "topbar offset, top offset, fixed topbar, top padding, offset",
"Icons" => "Icons",
// "Icon set used by the site" => "Icon set used by the site",
// "Theme Customizer tool" => "Theme Customizer tool",
// "Activate the theme customizer tool to enable easy theme customization" => "Activate the theme customizer tool to enable easy theme customization",
"Check frequency" => "Upepo wa hundi",
// "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. " => "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. ",
// "Click \"Check for Updates Now\" to perform an update check" => "Click \"Check for Updates Now\" to perform an update check",
"Each day" => "Kila siku",
"Each week" => "Kila wiki",
"Each month" => "Kila mwezi",
// "Upgrade cycle" => "Upgrade cycle",
// "Tiki upgrade frequency for this site to check against" => "Tiki upgrade frequency for this site to check against",
// "Regular (8 months)" => "Regular (8 months)",
// "Long-Term Support" => "Long-Term Support",
"Minify JavaScript" => "Fupisha JavaScript",
"Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Fupisha faili za Javascript zilizotumiwa kwenye ukurasa kwenye faili moja ili kusambazwa kwa usawa. Mabadiliko kwa faili za JavaScript zitahitaji cache ili kufutwa. Inatumia http://code.google.com/p/minify/",
// "Minify late JavaScript" => "Minify late JavaScript",
// "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page" => "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page",
"Minify CSS" => "Fupisha CSS",
// "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared" => "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared",
// "Uses http://code.google.com/p/minify/" => "Uses http://code.google.com/p/minify/",
"Minify CSS into a single file" => "Weka CSS katika faili moja",
// "In addition to reducing the size of the CSS files, reduce the number of files by consolidating them" => "In addition to reducing the size of the CSS files, reduce the number of files by consolidating them",
"This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"" => "Mpangilio huu hauwezi kufanya kazi nje ya sanduku kwa mitindo yote. Kuagiza inahitaji kutumia @import url(\"...\") na si @import \"...\"",
// "Prefix CSS" => "Prefix CSS",
// "Use -prefix-free JavaScript library to add vendor specific css prefixes" => "Use -prefix-free JavaScript library to add vendor specific css prefixes",
// "May be replaced by a server-side option soon" => "May be replaced by a server-side option soon",
"Skip date for same day" => "Usionyeshe tarehe ya siku ile ile",
"When displaying short date and time, skip date for today. Only time will be displayed" => "Wakati wa kuonyesha tarehe fupi na wakati, ruka tarehe ya leo. Wakati tu utaonyeshwa",
"Cache-control header" => "Kichwa cha Udhibiti wa Cache",
"Custom HTTP header to use when a session is active" => "Kichwa cha HTTP cha kawaida cha kutumia wakati kikao kinachotumika",
"Example: no-cache, pre-check=0, post-check=0" => "Mfano: no-cache, pre-check=0, post-check=0",
"Cache-control header (no session)" => "Kichwa cha Udhibiti wa Cache (hakuna kikao)",
"Custom HTTP header to use when no session is active" => "Kichwa cha HTTP cha kawaida cha kutumia wakati hakuna kikao kinachotumika",
"Content delivery networks" => "Mitandao ya utoaji wa maudhui",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance",
"List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com" => "Orodha ya prefixes ya URI kuingiza kabla ya faili zilizopo (moja kwa mstari), kwa mfano: http://cdn1.example.com",
"Content delivery networks in SSL" => "Mitandao ya utoaji wa maudhui katika SSL",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode",
"List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com" => "Orodha ya prefixes ya URI kuingiza kabla ya faili zilizopo (moja kwa mstari), kwa mfano: https://sslcdn1.example.com",
// "Check CDN files exists" => "Check CDN files exists",
// "Check that minified JS and CSS files exist before including them in the page" => "Check that minified JS and CSS files exist before including them in the page",
"Domain prefix handling" => "Utawala wa kiambishi wa kikoa",
"Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Futa moja kwa moja au kuongeza kiambishi awali \"www.\" kwa majina ya kikoa kuimarisha URL",
"Leave as-is" => "Acha kama ilivyo",
"Remove the www" => "Futa www",
"Add the www" => "Ongeza www",
"Domain redirects" => "Urekebisho wa Domain",
"When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org." => "Wakati tovuti inapatikana kupitia majina maalum ya kikoa, mgeni huelekezwa kwenye jina lingine la kikoa na URL imehifadhiwa. Hii ni muhimu hasa wakati wa kubadilisha majina ya kikoa kama tikiwiki.org kwa tiki.org.",
"One entry per line, with each entry a comma-separated list: old domain, new domain" => "Kuingia moja kwa kila mstari, na kila kuingia orodha iliyojitenga comma: domain wa zamani, domain mpya",
"Validate uploaded file content" => "Thibitisha maudhui ya faili iliyopakiwa",
"Do not trust user input and open the files to verify their content" => "Usitegemee pembejeo ya mtumiaji na kufungua faili ili uhakikishe maudhui yao",
"Allow the tiki_p_trust_input permission." => "Ruhusu idhini ya tiki_p_trust_input.",
// "Bypass user input filtering" => "Bypass user input filtering",
// "Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
"Object selector threshold" => "Kizuizi cha chombo cha kitu",
// "Number of records after which the object selectors will request searching instead of selecting from a list" => "Number of records after which the object selectors will request searching instead of selecting from a list",
// "Object selector search field" => "Object selector search field",
// "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")" => "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")",
// "Client key for this site" => "Client key for this site",
// "This must match the shared key entered in the Master’s key field" => "This must match the shared key entered in the Master’s key field",
// "Synchronize remote tracker" => "Synchronize remote tracker",
// "Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand" => "Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand",
// "Refresh item link items when the master is modified" => "Refresh item link items when the master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Refresh items list items when related items are created or modified" => "Refresh items list items when related items are created or modified",
// "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified" => "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified",
// "Clone tracker items" => "Clone tracker items",
// "Allow copying tracker item information to a new tracker item" => "Allow copying tracker item information to a new tracker item",
// "Trackers available for insertion from wiki pages" => "Trackers available for insertion from wiki pages",
// "List of tracker IDs made available when attempting to insert" => "List of tracker IDs made available when attempting to insert",
// "Change field types" => "Change field types",
// "Allow field type to be changed after creation" => "Allow field type to be changed after creation",
// "Use with care" => "Use with care",
// "Show comments below items" => "Show comments below items",
// "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab" => "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab",
// "Use legacy tracker insertion screen" => "Use legacy tracker insertion screen",
// "Use the legacy tracker insertion screen (a tab) instead of a popup dialog" => "Use the legacy tracker insertion screen (a tab) instead of a popup dialog",
// "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful" => "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful",
// "Show tracker status in objectlink" => "Show tracker status in objectlink",
// "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs" => "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs",
// "Sync wiki page name to linked tracker field" => "Sync wiki page name to linked tracker field",
// "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation" => "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation",
// "Redirect page views to the linked tracker item" => "Redirect page views to the linked tracker item",
// "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL" => "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL",
// "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL" => "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL",
"Tracker for articles" => "Tracker kwa makala",
// "Have a tracker to supplement article information" => "Have a tracker to supplement article information",
"Tracker ID of tracker for articles" => "ID ya Tracker ya tracker kwa makala",
// "A tracker for articles must contain an \"Articles\" field" => "A tracker for articles must contain an \"Articles\" field",
// "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items" => "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items",
// "Tracker tabular" => "Tracker tabular",
// "Allows management of import/export tracker profiles and management of custom list formats" => "Allows management of import/export tracker profiles and management of custom list formats",
// "Always notify watchers" => "Always notify watchers",
// "Send item updated notifications to watchers even if nothing has changed" => "Send item updated notifications to watchers even if nothing has changed",
// "Require users to fill in tracker information" => "Require users to fill in tracker information",
// "Tracker ID of tracker required to be filled in" => "Tracker ID of tracker required to be filled in",
// "Mandatory tracker field to check for required filling in" => "Mandatory tracker field to check for required filling in",
// "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it" => "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it",
// "Fields that are asked for in the modal for force-filling" => "Fields that are asked for in the modal for force-filling",
// "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested" => "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested",
// "Tracker item links use prefix alias" => "Tracker item links use prefix alias",
// "Links for tracker items will use the prefix alias automatically everywhere" => "Links for tracker items will use the prefix alias automatically everywhere",
// "Tracker report resize button" => "Tracker report resize button",
// "Add a button to resize long tracker reports" => "Add a button to resize long tracker reports",
// "Tracker list order" => "Tracker list order",
// "Default order for the main tracker list" => "Default order for the main tracker list",
// "Id Ascending" => "Id Ascending",
// "Id Descending" => "Id Descending",
"Created Ascending" => "Imeundwa Kupungua",
"Created Descending" => "Imeundwa Kupungua",
"Name Ascending" => "Jina linashuka",
"Name Descending" => "Jina linashuka",
// "Last Modified Ascending" => "Last Modified Ascending",
// "Last Modified Descending" => "Last Modified Descending",
// "Number of Items Ascending" => "Number of Items Ascending",
// "Number of Items Descending" => "Number of Items Descending",
// "Tracker History Diff Style" => "Tracker History Diff Style",
// "Default style for tracker history" => "Default style for tracker history",
"Original" => "awali",
"Index article info in tracker item" => "Weka maelezo ya habari kwenye kipengee cha tracker",
// "Require users to fill in a tracker form if not done already by prompting them with a modal dialog" => "Require users to fill in a tracker form if not done already by prompting them with a modal dialog",
// "Storage settings when file galleries are not used" => "Storage settings when file galleries are not used",
"Unified search engine" => "Injini ya utafutaji ya umoja",
// "Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP implementation) - Deprecated" => "Lucene (PHP implementation) - Deprecated",
// "Elasticsearch" => "Elasticsearch",
"Lucene index location" => "Eneo la index ya Lucene",
"Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Njia kwa eneo la tafuta ya utafutaji wa Lucene. Index lazima iwe kwenye mfumo wa faili wa eneo na nafasi ya kutosha ili iwe na kiasi cha database",
"Highlight results snippets" => "Tazama utafutaji katika matokeo",
"Highlight the result snippet based on the search query to improve user experience" => "Tazama utafutaji katika matokeo ya swala. Kuwawezesha chaguo hili kutaathiri utendaji, lakini itaimarisha uzoefu wa mtumiaji",
// "Lucene maximum results" => "Lucene maximum results",
// "Maximum number of results to produce. Results beyond these will need a more refined query to be reached" => "Maximum number of results to produce. Results beyond these will need a more refined query to be reached",
"results" => "matokeo",
// "Lucene maximum result-set limit" => "Lucene maximum result-set limit",
// "Maximum size of result set to consider" => "Maximum size of result set to consider",
// "This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "result sets" => "result sets",
// "Lucene terms per query limit" => "Lucene terms per query limit",
// "Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "terms" => "terms",
// "Lucene maximum number of buffered documents" => "Lucene maximum number of buffered documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "documents" => "documents",
// "Lucene maximum number of merge documents" => "Lucene maximum number of merge documents",
// "Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "merge documents" => "merge documents",
"Default Boolean Operator" => "Boolean Operator kama msingi",
// "Use OR or AND as the default search operator" => "Use OR or AND as the default search operator",
// "AND" => "AND",
// "OR" => "OR",
// "Lucene merge factor" => "Lucene merge factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster",
// "Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained" => "Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained",
"Incremental Index Update" => "Sasisho la ziada la index",
"Update the index incrementally as the site content is modified" => "Sasisha index kwa kiasi kikubwa kama maudhui ya tovuti yamebadilishwa",
// "This may lead to lower performance and accuracy than processing the index on a periodic basis" => "This may lead to lower performance and accuracy than processing the index on a periodic basis",
"Field weights" => "Uzito wa shamba",
// "Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results" => "Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results",
// "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search" => "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search",
"One field per line, field_name__:__5.3" => "Shamba moja kwa kila mstari, jina_la_shamba__:__5.3",
"Default content fields" => "Mashamba ya maudhui yaliyomo",
"All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search" => "Yote yaliyomo yanajumuishwa kwenye uwanja wa yaliyomo. Kwa uzito wa desturi kuomba, mashamba lazima yawekwe ndani ya swala. Chaguo hili inaruhusu maeneo mengine kuingizwa katika utafutaji wa maudhui ya default",
"Tokenize version numbers" => "Kagua syntax ya namba za toleo",
// "Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7",
// "Cache per user and query for Tiki built-in search" => "Cache per user and query for Tiki built-in search",
// "Time in minutes a user has a same query cached applied to Tiki built-in search interface only" => "Time in minutes a user has a same query cached applied to Tiki built-in search interface only",
"Index forum replies together with initial post" => "Jumuiya ya maoni hujibu pamoja na chapisho la awali",
// "Forum replies will be indexed together with the initial post as a single document instead of being indexed separately" => "Forum replies will be indexed together with the initial post as a single document instead of being indexed separately",
// "Relation types to index within object" => "Relation types to index within object",
// "Comma-separated relation types for which objects should be indexed in their related objects" => "Comma-separated relation types for which objects should be indexed in their related objects",
// "Elasticsearch needed" => "Elasticsearch needed",
// "Cache individual search formatters" => "Cache individual search formatters",
// "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache" => "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache",
"Format to use for tracker field keys" => "Fomu ya kutumia kwa funguo za uwanja la tracker",
// "Choose between field IDs and permanent names for the tracker indexing" => "Choose between field IDs and permanent names for the tracker indexing",
"Permanent name" => "Jina la kudumu",
// "Field ID (backward compatibility mode with Tiki 7 and 8)" => "Field ID (backward compatibility mode with Tiki 7 and 8)",
// "Index Tracker Category names" => "Index Tracker Category names",
// "Index the names and paths of category field values" => "Index the names and paths of category field values",
// "Requires reindexing" => "Requires reindexing",
// "Cache result-specific formatted results" => "Cache result-specific formatted results",
// "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific" => "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific",
// "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature" => "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature",
"Excluded categories" => "Makundi yasiyotengwa",
// "List of category IDs to exclude from the search index" => "List of category IDs to exclude from the search index",
"Excluded plugins" => "Plugins yasiyotengwa",
// "List of plugin names to exclude while indexing" => "List of plugin names to exclude while indexing",
"Exclude all plugins" => "Wala Plugins zote",
// "Indexing will exclude all plugins" => "Indexing will exclude all plugins",
"Except included plugins" => "Isipokuwa plugins hii",
// "List of plugin names that are required to be included while indexing, when excluding all" => "List of plugin names that are required to be included while indexing, when excluding all",
// "Example: fancytable,list,trackerlist,trackerfilter" => "Example: fancytable,list,trackerlist,trackerfilter",
// "Elasticsearch URL" => "Elasticsearch URL",
// "URL of any node in the cluster" => "URL of any node in the cluster",
// "Elasticsearch index prefix" => "Elasticsearch index prefix",
// "The prefix that is used for all indexes for this installation in Elasticsearch" => "The prefix that is used for all indexes for this installation in Elasticsearch",
// "Elasticsearch current index" => "Elasticsearch current index",
// "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index" => "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index",
// "Do not change this value unless you know what you are doing" => "Do not change this value unless you know what you are doing",
// "Tokenize CamelCase words" => "Tokenize CamelCase words",
// "Consider the components of camel-case words as separate tokens, allowing them to be searched individually" => "Consider the components of camel-case words as separate tokens, allowing them to be searched individually",
// "Conflicts with Tokenize Version Numbers" => "Conflicts with Tokenize Version Numbers",
// "Elasticsearch field limit per index" => "Elasticsearch field limit per index",
// "fields" => "fields",
// "The maximum number of fields per search index in Elasticsearch version 5.x and above" => "The maximum number of fields per search index in Elasticsearch version 5.x and above",
// "Use MySQL Full-Text Search (fallback)" => "Use MySQL Full-Text Search (fallback)",
// "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback" => "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback",
// "MySQL full-text search current index" => "MySQL full-text search current index",
// "Unified index identifier fields (Internal)" => "Unified index identifier fields (Internal)",
// "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding" => "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding",
// "Use unified search in category admin" => "Use unified search in category admin",
// "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index" => "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index",
// "Stop Word List" => "Stop Word List",
// "Words excluded from the search index, because they can be too frequent and produce unwanted results" => "Words excluded from the search index, because they can be too frequent and produce unwanted results",
"MySQL full-text search has its own list of stop words configured in the server." => "Utafutaji wa maandishi kamili wa MySQL una orodha yake ya maneno ya kuacha yaliyowekwa kwenye seva.",
"Automatically trim Elasticsearch results on date-sorted query" => "Punguza matokeo ya Elasticsearch moja kwa moja kwenye swala la tarehe iliyopangwa",
// "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date" => "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date",
"Highlight results pages" => "Onyesha kurasa za matokeo",
// "Highlight words on the result pages based on the search query" => "Highlight words on the result pages based on the search query",
// "Plugins tab of the textarea control panel loads with an empty list" => "Plugins tab of the textarea control panel loads with an empty list",
// "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially" => "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially",
// "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")" => "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")",
// "Possessive Stemmer" => "Possessive Stemmer",
// "LIST plugin cache default on" => "LIST plugin cache default on",
// "If selected, LIST plugins will be cached by default unless turned off at plugin level" => "If selected, LIST plugins will be cached by default unless turned off at plugin level",
// "LIST plugin cache default expiry" => "LIST plugin cache default expiry",
// "Default number of minutes for LIST plugin cache expiry" => "Default number of minutes for LIST plugin cache expiry",
// "The possessive stemmer removes possessives (trailing \"'s\\" => "The possessive stemmer removes possessives (trailing \"'s\\",
"Re-validate user by email after" => "Thibitisha tena mtumiaji kwa barua pepe baada ya",
"unsuccessful login attempts" => "Majaribio ya kuingiliana yasiyofanikiwa",
// "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password" => "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password",
// "brute force, brute-force, login failure, login-failure, failed logins" => "brute force, brute-force, login failure, login-failure, failed logins",
"Suspend account after" => "Susisha akaunti baada",
// "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again",
"URL the user is redirected to after account validation" => "URL mtumiaji anaelekezwa baada ya kuthibitishwa kwa akaunti",
// "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"" => "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"",
"Account validated successfully." => "Akaunti imethibitishwa kwa mafanikio.",
"The URL that the anonymous user is redirected to when a page is not found" => "URL ambayo mtumiaji asiyejulikana inaelekezwa wakati ukurasa haupatikana",
// "Use Only ASCII in SEFURLs" => "Use Only ASCII in SEFURLs",
// "Do not use accented characters in short (search engine friendly) URLs" => "Do not use accented characters in short (search engine friendly) URLs",
"Close site when server load is above the threshold" => "Funga tovuti wakati mzigo wa seva iko juu ya kizingiti",
// "Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site" => "Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site",
"Use proxy" => "Tumia wakala",
// "Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified" => "Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified",
"Use context menus for actions (icons)" => "Tumia menyu ya matukio ya vitendo (icons)",
"Currently used in File Galleries only." => "Hivi sasa hutumiwa kwenye Galleries ya Picha tu.",
"Use context menus for actions (text)" => "Tumia menyu ya matukio ya matendo (maandishi)",
"Show user's real name" => "Onyesha jina halisi la mtumiaji",
// "Show the user's real name instead of username (log-in name), when possible" => "Show the user's real name instead of username (log-in name), when possible",
"User emails must be unique" => "Barua pepe za mtumiaji lazima ziwe za kipekee",
// "The email address of each user must be unique" => "The email address of each user must be unique",
"Display user tracker information on the user information page" => "Onyesha maelezo ya mtumiaji wa tracker kwenye ukurasa wa habari wa mtumiaji",
"Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Ingiza ID ya tracker ya mtumiaji kisha vitambulisho vya shamba vinaonyeshwa, vyote vilivyotenganishwa na vito. Mfano: 1,1,2,3,4 (ID tracker ID 1 ikifuatiwa na ID za shamba 1-4)",
"Users can configure modules" => "Watumiaji wanaweza kusanidi moduli",
// "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user" => "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user",
"Users can open and close the modules" => "Watumiaji wanaweza kufungua na kufunga moduli",
"Allows users to open and close modules using the icon in the module header" => "Inaruhusu watumiaji kufungua na kufungia moduli kwa kutumia ishara katika kichwa cha moduli",
"Module decides" => "Moduli huamua",
"Store full-size copy of profile picture in file gallery" => "Hifadhi nakala ya ukubwa kamili ya picha ya wasifu kwenye nyumba ya sanaa ya faili",
"Size of the small profile picture stored for users" => "Ukubwa wa picha ndogo ya profile iliyohifadhiwa kwa watumiaji",
"Crop the profile picture thumbnail to a square" => "Panda thumbnail ya picha ya wasifu kwa mraba",
"File gallery in which to store full-size profile picture" => "Faili ya sanaa ambayo unaweza kuhifadhi picha kamili ya wasifu",
// "Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
"File ID of default profile picture" => "Kitambulisho kya faili ya picha ya wasifu (msingi)",
// "File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries" => "File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries",
"Display who has viewed \"my items\" on the user information page" => "Onyesha ambaye amemtazama \"vitu vyangu\" kwenye ukurasa wa habari wa mtumiaji",
// "This requires activation of tracking of views for various items in the action log" => "This requires activation of tracking of views for various items in the action log",
"Length of \"who viewed my items\" history" => "Urefu wa \"ambaye aliangalia vitu vyangu\" historia",
// "Number of days before the current day to consider when displaying \"who viewed my items\"" => "Number of days before the current day to consider when displaying \"who viewed my items\"",
"Show to others \"who viewed my items\" on the user information page" => "Onyesha wengine \"ambao walitazama vitu vyangu\" kwenye ukurasa wa habari wa mtumiaji",
"Show to others \"who viewed my items\" on the user information page. Admins can always see this information" => "Onyesha wengine \"ambao walitazama vitu vyangu\" kwenye ukurasa wa habari wa mtumiaji. Watawala wanaweza daima kuona habari hii",
"Use pretty trackers for registration form" => "Tumia wapiga picha nzuri kwa fomu ya usajili",
"Registration pretty tracker template" => "Kigezo cha fomu bora ya usajili",
// "Use a wiki page name or Smarty template file with a .tpl extension" => "Use a wiki page name or Smarty template file with a .tpl extension",
// "Hide Mandatory" => "Hide Mandatory",
// "Hide mandatory fields indication with an asterisk (shown by default)" => "Hide mandatory fields indication with an asterisk (shown by default)",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name field ID" => "Page name field ID",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Select one or more trackers to sync user preferences from" => "Select one or more trackers to sync user preferences from",
// "Tracker field IDs to sync the \"real name\" pref from" => "Tracker field IDs to sync the \"real name\" pref from",
// "Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"" => "Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"",
// "Tracker field IDs to sync user groups" => "Tracker field IDs to sync user groups",
// "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups" => "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation preferences with the main location field" => "Synchronize user geolocation preferences with the main location field",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Assign a user tracker item when registering if email equals this field" => "Assign a user tracker item when registering if email equals this field",
"Maximum users in drop-down lists" => "Watumiaji wa juu katika orodha ya kushuka",
// "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large" => "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large",
"users" => "watumiaji",
// "Use the user's real name instead of log-in name in the autocomplete selector in trackers" => "Use the user's real name instead of log-in name in the autocomplete selector in trackers",
// "Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature" => "Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature",
"User favorites" => "Vipendwa vya mtumiaji",
// "Enable users to flag content as their favorite" => "Enable users to flag content as their favorite",
// "User likes" => "User likes",
// "Enable users to \"like\" content" => "Enable users to \"like\" content",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups indicated above" => "Users cannot register without choosing one of the groups indicated above",
"Users available in search results" => "Watumiaji hupatikana katika matokeo ya utafutaji",
// "Users available within search results. Content related to the user will be included in the index" => "Users available within search results. Content related to the user will be included in the index",
"Public" => "Umma",
"Use Gravatar for user profile pictures" => "Tumia Gravatar kwa picha za profile wa mtumiaji",
// "Always request the Gravatar image for the user profile picture" => "Always request the Gravatar image for the user profile picture",
// "Configuration for multilike" => "Configuration for multilike",
// "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)" => "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)",
"Force users to upload an avatar." => "Lazimisha watumiaji kupakia avatar.",
"Score ascending" => "Mabao inaongezeka",
"Score descending" => "mabao inashuka",
"Name ascending" => "Kupanda kwa majina",
"Name descending" => "Kupungua kwa majina",
"Login ascending" => "Ingia kuinua",
"Login descending" => "Ingia kuingia",
// "User the tracker's field ID whose value is used as the output page name" => "User the tracker's field ID whose value is used as the output page name",
// "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup" => "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup",
"Quota" => "Fungu",
"Private" => "kibinafsi",
// "Users cannot see each other's files or galleries" => "Users cannot see each other's files or galleries",
// "Users can see each other's files, but don't see the galleries in listings" => "Users can see each other's files, but don't see the galleries in listings",
"Username pattern" => "Mfano wa jina la mtumiaji",
// "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/" => "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/",
"Serve profile pictures statically" => "Tumikia picha za wasifu kwa mfano ya takwimu",
"When enabled, feature checks and permission checks will be skipped" => "Ikiwashwa, kipengele cha hundi na hundi za ruhusa zitavunjwa",
"Displayed time zone" => "Inaonyesha eneo la wakati",
"Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback." => "Tumia seti ya eneo la wakati kutoka kwa mapendekezo ya mtumiaji, au eneo la wakati unaojulikana kwa mtu asiyejulikana (kama kivinjari inaruhusu). Chanzo cha msingi kinatumiwa kama kuanguka.",
"Always the site default time zone." => "Daima eneo la wakati kama msingi.",
"Number of visited pages to remember" => "Idadi ya kurasa zilizotembelewa kukumbuka",
"visited pages" => "kurasa zilizotembelewa",
"User information" => "Maelezo ya mtumiaji",
// "Specify if the user's information is public or private" => "Specify if the user's information is public or private",
"Use 12-hour clock for time selectors" => "Tumia muundo wa saa 12 kwa wateuzi wa wakati",
// "Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc",
"Use interface that shows differences in any versions" => "Tumia interface inayoonyesha tofauti katika matoleo yoyote",
"Tasks per page" => "Kazi kwa kila ukurasa",
"tasks" => "kazi",
"20" => "20",
"40" => "40",
"50" => "50",
"Messages per page" => "Ujumbe kwa kila ukurasa",
"Allow messages from other users" => "Ruhusu ujumbe kutoka kwa watumiaji wengine",
"Notify sender when reading mail" => "Mjulishe mtumaji wakati wa kusoma barua",
"Send me an email for messages with priority equal to or greater than" => "Nitumie barua pepe kwa ujumbe ulio na kipaumbele sawa au zaidi kuliko",
// "priority" => "priority",
"Auto-archive read messages after" => "Hifadhi ya faragha imesoma ujumbe baada ya",
// "The number of days after which Tiki will archive the messages that have been read by the user" => "The number of days after which Tiki will archive the messages that have been read by the user",
"60" => "60",
"My pages" => "Kurasa zangu",
// "List all wiki pages edited by the user" => "List all wiki pages edited by the user",
"My blogs" => "Blogu zangu",
// "List all blogs and blog posts edited by the user" => "List all blogs and blog posts edited by the user",
"My galleries" => "Nyumba zangu",
// "List all galleries edited by the user" => "List all galleries edited by the user",
"My messages" => "Ujumbe wangu",
// "List all messages and replies by the user" => "List all messages and replies by the user",
"My tasks" => "Kazi zangu",
// "List all tasks by the user" => "List all tasks by the user",
"My forum topics" => "Masuala yangu ya jukwaa",
// "List all forum topics by the user" => "List all forum topics by the user",
"My forum replies" => "Majibu yangu katika jukwaa",
// "List all forum replies by the user" => "List all forum replies by the user",
"My items" => "Vipengee vyangu",
// "List all tracker items by the user" => "List all tracker items by the user",
"Character set for mail" => "Encoding",
"Keep closed remarksbox hidden" => "Weka remarksbox iliyofichwa",
// "XMPP account JID or username" => "XMPP account JID or username",
// "XMPP account password" => "XMPP account password",
// "XMPP http-bind URL" => "XMPP http-bind URL",
// "Full URL to the http-bind" => "Full URL to the http-bind",
// "https://xmpp.example.org/http-bind/" => "https://xmpp.example.org/http-bind/",
"Pre-set show user's info on mouseover" => "Kuweka kabla ya kuonyesha maelezo ya mtumiaji kwenye mouseover",
// "Set new users' info to display in a popup when their name is hovered over" => "Set new users' info to display in a popup when their name is hovered over",
// "Remember the alert boxes that users have closed and don't display them again" => "Remember the alert boxes that users have closed and don't display them again",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Vimeo upload" => "Vimeo upload",
// "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API" => "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API",
// "Vimeo delete" => "Vimeo delete",
// "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted" => "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted",
// "Permanently removes videos from the registered vimeo.com account" => "Permanently removes videos from the registered vimeo.com account",
// "Vimeo consumer key" => "Vimeo consumer key",
// "API consumer key" => "API consumer key",
// "Vimeo consumer secret" => "Vimeo consumer secret",
// "API consumer secret" => "API consumer secret",
// "Vimeo access token" => "Vimeo access token",
// "The access token that is automatically generated by Vimeo when API keys are requested" => "The access token that is automatically generated by Vimeo when API keys are requested",
// "Vimeo access token secret" => "Vimeo access token secret",
// "The access token secret automatically generated by Vimeo when API keys are requested" => "The access token secret automatically generated by Vimeo when API keys are requested",
// "Vimeo Default Gallery" => "Vimeo Default Gallery",
// "The The ID of the default file gallery in which to store the Vimeo reference" => "The The ID of the default file gallery in which to store the Vimeo reference",
"Display by default" => "Onyesha kama ilivyo",
"Path (if stored in directory)" => "Njia (ikiwa imehifadhiwa katika saraka)",
"Edit idle timeout" => "Badilisha muda usioingia",
// "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains" => "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains",
// "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually" => "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually",
// "How to trigger Web Cron" => "How to trigger Web Cron",
// "Calling the Web Cron URL" => "Calling the Web Cron URL",
// "Adding JavaScript that calls Web Cron" => "Adding JavaScript that calls Web Cron",
// "URL and JavaScript" => "URL and JavaScript",
// "Run interval" => "Run interval",
// "The amount of time of each run" => "The amount of time of each run",
"Token" => "Ishara",
// "The token to use when running the cron manually" => "The token to use when running the cron manually",
// "Default cache" => "Default cache",
// "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response" => "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response",
"Last Modified" => "Ilibadilishwa mwisho",
"Last editor" => "Mhariri wa mwisho",
"Wiki link format" => "Aina ya Kiungo cha Wiki",
"Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))" => "Kiwango cha wahusika maalum wanaokubalika katika viungo vya wiki kwa majina ya ukurasa. Kwa mfano: ((Ukurasa &eacute;&agrave;&icirc;))",
"\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"" => "\"Strict\" hujumuisha wahusika tu ya msingi kama a-z na 0-9. Tovuti ambayo inatumia vibali maalum au maalum katika majina ya ukurasa haipaswi kutumia \"kali\"",
"Complete" => "Kamili",
"Relaxed" => "Walipumzika",
"Strict" => "Strict",
// "Wiki URL scheme" => "Wiki URL scheme",
// "Alter the SEFURL pattern for page names" => "Alter the SEFURL pattern for page names",
"Use the \"View\" action to regenerate your URLs after changing this setting." => "Tumia hatua ya \"Tazama\" ili kurekebisha URL zako baada ya kubadilisha mpangilio huu.",
// "Show the page version" => "Show the page version",
"Display the page version information when viewing the page" => "Onyesha maelezo ya toleo la ukurasa wakati ukiangalia ukurasa",
// "Display the page name above the page area" => "Display the page name above the page area",
// "Display the page name in small text at the top of each page (above the page's content)" => "Display the page name in small text at the top of each page (above the page's content)",
// "Display the page name inside the page content" => "Display the page name inside the page content",
"Page name display stripper" => "Mwisho wa maonyesho ya maandishi ya majina ya ukurasa",
// "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
"Wiki author list style" => "Mtindo wa orodha ya mwandishi wa Wiki",
// "Change the list format that is used to display the authors of the page" => "Change the list format that is used to display the authors of the page",
"Creator and Author" => "Muumba na Mwandishi",
"Business style" => "Mtindo wa biashara",
"Collaborative style" => "Mtindo wa ushirikiano",
"Page last modified on" => "Marekebisho ya mwisho ya ukurasa: ",
"none (disabled)" => "hakuna (haiwezekani)",
"Specify wiki author list style per page" => "Eleza orodha ya mwandishi wa wiki kwa kila ukurasa",
// "Enable the style in which the author list is displayed to be modified on a per-page basis" => "Enable the style in which the author list is displayed to be modified on a per-page basis",
// "Wiki page edit buttons location" => "Wiki page edit buttons location",
// "Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page" => "Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page",
"Wiki navigation bar location" => "Eneo la urambazaji wa Wiki",
"When using the ...page... page break wiki syntax" => "Inafaa wakati wa kutumia mapumziko ya ukurasa (\"... ukurasa ...\" katika syntax ya wiki)",
"Wiki top line location" => "Eneo la mstari wa juu wa Wiki",
// "Page description, page actions, icons, backlinks..." => "Page description, page actions, icons, backlinks...",
"Display ShareThis icon prominently" => "Onyesha icon hii ya ShareThis kwa uwazi",
// "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)" => "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)",
"Cache wiki pages (global)" => "kurasa za wiki (global cache)",
"Enable page cache globally for wiki pages" => "Wezesha 'cache' kwa kurasa za wiki zote",
"no cache" => "hakuna 'cache",
"Allow comments per wiki page" => "Ruhusu maoni kwa kila wiki",
// "Enable control of comments on wiki pages on a per-page basis" => "Enable control of comments on wiki pages on a per-page basis",
"Enable (default On)" => "Wezesha (imeanzishwa mwanzo)",
"Enable (default Off)" => "Wezesha (imefungwa mwanzo)",
// "Wiki copyright" => "Wiki copyright",
"Prevent special characters in page names" => "Zuia wahusika maalum katika majina ya ukurasa",
// "Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters" => "Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters",
"Page ranking reload probability" => "Ukurasa wa cheo uwezekano wa kurejesha tena",
"Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking" => "Uhesabu wa cheo cha ukurasa ni kazi ya nguvu sana ambayo haiwezi kufanywa kila mzigo wa ukurasa. Itahesabiwa kwenye mizigo ya ukurasa wa random kulingana na roll ya kete. Chaguo hili linaonyesha idadi ya nyuso kwenye kete. Nambari kubwa zinaongoza kupunguza matumizi ya rasilimali, lakini cheo cha chini cha sahihi",
"Encourage contribution to wiki pages by anonymous" => "Kuhimiza mchango kwa kurasa za wiki kwa wasiojulikana",
// "When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page" => "When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page",
"Warn before page lock timeout" => "Tahadhari kabla ya kufuli ukurasa kukamilika",
"Provide a JavaScript alert before the user's lock on a page times out" => "Kutoa tahadhari ya Javascript kabla ya kufungwa kwa mtumiaji kwenye nyakati za ukurasa",
"Dynamic variables" => "Vigezo vya nguvu",
"Global snippets of text that can be included in wiki pages and edited in place" => "Maandishi ya kimataifa ya maandiko ambayo yanaweza kuingizwa katika kurasa za wiki na kisha kuhaririwa kwenye tovuti",
"Single (%varname%)" => "Mmoja (%varname%)",
"Double (%%varname%%)" => "Mara mbili (%%varname%%)",
"Multilingual dynamic variables" => "Vigezo vya lugha nyingi",
"Make dynamic variable content language-specific." => "Fanya maalum lugha ya maudhui ya kutofautiana",
"Allow plugin-specific edits" => "Ruhusu uhariri maalum wa 'plugin'",
// "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page" => "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page",
// "This feature is unavailable outside wiki pages, whether or not this preference is enabled" => "This feature is unavailable outside wiki pages, whether or not this preference is enabled",
"Allow section-specific edits" => "Ruhusu mipangilio maalum ya sehemu",
// "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section" => "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section",
"Section-specific edits maximum level" => "Mipangilio maalum ya sehemu ya kiwango cha juu",
// "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections" => "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections",
"Only display focused edit icons (for sections and/or plugins) on request" => "Weka tu icons za hariri zilizolenga (kwa sehemu na/au 'plugin') kwa ombi",
// "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page" => "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page",
"Allow minor edits of wiki pages" => "Ruhusu uhariri mdogo wa kurasa za wiki",
// "Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)" => "Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)",
// "Display comment list by default" => "Display comment list by default",
// "Display Post new comment form by default" => "Display Post new comment form by default",
// "Simple wiki comment ratings" => "Simple wiki comment ratings",
// "Enable users to rate comments based on a simple numeric scale" => "Enable users to rate comments based on a simple numeric scale",
"Wiki rating options" => "Chaguzi za Tathmini za Wiki",
// "List of options available for the rating of wiki comments" => "List of options available for the rating of wiki comments",
"Add a slideshow button on wiki pages" => "Ongeza kifungo cha slideshow kwenye kurasa za wiki",
"Page creators are administrators of their pages" => "Waumbaji wa ukurasa ni wasimamizi wa kurasa zao",
"Create watch for author on page creation" => "Unda kuangalia kwa mwandishi kwenye uumbaji wa ukurasa",
"Enable watches on comments" => "Wezesha kuona kwenye maoni",
"Watch minor edits" => "Angalia marekebisho madogo",
"Page ID" => "Kitambulisho cha Ukurasa",
"Page name maximum displayed length" => "Urefu unaonyeshwa kwa jina la ukurasa",
"Comment of the latest edit" => "Maoni ya hariri ya hivi karibuni",
"Description maximum displayed length" => "Urefu umeonyesha maelezo",
"Versions" => "Matoleo",
"Categories path" => "Njia ya Jamii",
"Default sort order" => "Mpangilio wa aina kama msingi",
"Sort Direction" => "Mwelekeo wa Aina",
// "Visibility of discussion" => "Visibility of discussion",
// "Just a button among others (default), or special section" => "Just a button among others (default), or special section",
// "In the button bar (default)" => "In the button bar (default)",
// "Special section above button bar" => "Special section above button bar",
"Forum for discussion" => "Baraza la majadiliano",
"Allow management of keywords on a per-page basis" => "Ruhusu usimamizi wa maneno muhimu kwa kila ukurasa msingi",
"Similar pages only listed in same language" => "Kurasa zinazofanana zimeorodheshwa kwa lugha moja",
// "When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page" => "When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page",
"Mandatory wiki page edit summary" => "Muhtasari wa toleo la lazima wiki",
// "Reject save attempts that do not include an edit summary describing the changes made" => "Reject save attempts that do not include an edit summary describing the changes made",
"Position of tags selection" => "Nafasi ya uteuzi wa vitambulisho",
// "Place the tags selection more prominently than under the \"Properties\" tab" => "Place the tags selection more prominently than under the \"Properties\" tab",
"Properties tab" => "Sifa za kichupo",
"Edit tab" => "Kuhariri kichupo",
"Tags tab" => "Kichupo cha vitambulisho",
"Structure navigation bar location" => "Eneo la bar urambazaji katika muundo",
// "Display Next and Back buttons, breadcrumbs, and a form to add a new page" => "Display Next and Back buttons, breadcrumbs, and a form to add a new page",
"Backlink page names maximum displayed length" => "Urefu wa majina ya ukurasa unaoelezea ukurasa huu",
// "Show blog posts" => "Show blog posts",
// "Blog posts linking to a wiki page are shown as backlinks" => "Blog posts linking to a wiki page are shown as backlinks",
// "Show forum posts" => "Show forum posts",
// "Forum posts linking to a wiki page are shown as backlinks" => "Forum posts linking to a wiki page are shown as backlinks",
// "Show comments" => "Show comments",
// "Comments linking to a wiki page are shown as backlinks" => "Comments linking to a wiki page are shown as backlinks",
// "Show articles" => "Show articles",
// "Articles linking to a wiki page are shown as backlinks" => "Articles linking to a wiki page are shown as backlinks",
// "Show tracker items" => "Show tracker items",
// "Tracker items linking to a wiki page are shown as backlinks" => "Tracker items linking to a wiki page are shown as backlinks",
"Show trackers" => "Onyesha ma trackers",
// "Trackers with a description linking to a wiki page are shown as backlinks" => "Trackers with a description linking to a wiki page are shown as backlinks",
// "Show tracker fields" => "Show tracker fields",
// "Tracker fields with a description linking to a wiki page are shown as backlinks" => "Tracker fields with a description linking to a wiki page are shown as backlinks",
// "Show calendar events" => "Show calendar events",
// "Calendar events with a description linking to a wiki page are shown as backlinks." => "Calendar events with a description linking to a wiki page are shown as backlinks.",
"Simple wiki ratings" => "Tathmini rahisi ya wiki",
// "Enable users to rate wiki pages based on a simple numeric scale" => "Enable users to rate wiki pages based on a simple numeric scale",
"List of options available for the rating of wiki pages" => "Orodha ya chaguzi zinazopatikana kwa upimaji wa kurasa za wiki",
"Semantic link types to use as page alias markers" => "Aina za kiungo za ki-Semantic ambazo hutumia alama za ukurasa wa bandia",
// "Comma-separated list of semantic links to identify a page as an alias of another" => "Comma-separated list of semantic links to identify a page as an alias of another",
"Redirect pages using these prefix-alias semantic links" => "Kurasa zinazoelekeza kwa kutumia viungo hivi vya kiambishi awali vya semantic",
// "Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link" => "Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link",
"Wiki page pagination" => "Fungu la ukurasa wa Wiki",
// "Enable the separation of a wiki page's content into a set of two or more paginated pages" => "Enable the separation of a wiki page's content into a set of two or more paginated pages",
// "Wiki page separator" => "Wiki page separator",
// "The separator to use in wiki page content to mark the end of each page section" => "The separator to use in wiki page content to mark the end of each page section",
// "Wiki auto-toc" => "Wiki auto-toc",
// "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties" => "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties",
// "Inline auto-toc" => "Inline auto-toc",
// "Change the display of the table of contents for wiki pages to inline" => "Change the display of the table of contents for wiki pages to inline",
// "Table of contents position" => "Table of contents position",
// "Position of the table of contents, either top, left, right (right is the default)" => "Position of the table of contents, either top, left, right (right is the default)",
// "Table of contents offset" => "Table of contents offset",
// "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin" => "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin",
// "Table of contents default" => "Table of contents default",
// "Set the default for the table of contents (default \"on\" and can be toggled per page)" => "Set the default for the table of contents (default \"on\" and can be toggled per page)",
"On" => "On",
"Off" => "Off",
// "Add an option to hide the page title per wiki page" => "Add an option to hide the page title per wiki page",
// "Enable the page title to not be displayed, on a per-page basis" => "Enable the page title to not be displayed, on a per-page basis",
"Multilevel style numbering for ordered lists" => "Nambari ya mtindo wa Multilevel kwa orodha zilizoamriwa",
// "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc" => "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc",
"Force link to included page" => "Weka kiungo kwa ukurasa uliojumuisha",
// "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used" => "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used",
// "Date Field" => "Date Field",
// "The field indexed as the global \"date\" field" => "The field indexed as the global \"date\" field",
// "You will need to rebuild the search index after changing this" => "You will need to rebuild the search index after changing this",
// "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it" => "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it",
"Maximum displayed length of the latest edit's comment" => "Urefu wa urefu wa maoni ya marekebisho ya mwisho",
"Plugin %0" => "Plugin ya %0",
"Global cache time for the plugin snarf" => "Muda wa cache wa Global kwa snarf ya Plugin",
"Default cache time for the plugin snarf" => "Muda wa kusitisha muda kwa ajili ya plugin 'snarf'",
"0 for no cache" => "0 kwa 'cache' hakuna",
// "GUI for the list plugin" => "GUI for the list plugin",
// "Experimental GUI for the list plugin in popup plugin edit forms" => "Experimental GUI for the list plugin in popup plugin edit forms",
// "(listgui)" => "(listgui)",
// "Plugin trackerlist converter" => "Plugin trackerlist converter",
// "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead" => "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead",
// "Maximum plugin parsing passes" => "Maximum plugin parsing passes",
// "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin" => "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin",
// "passes" => "passes",
// "Setting this to a higher value than the default of 500 may have performance implications" => "Setting this to a higher value than the default of 500 may have performance implications",
"Inline plugin %0" => "Plugin ya mstari moja %0",
"Plugin pending approval notification" => "Arifa ya Plugins inasubiri kuthibitishwa",
"Send an email alert to users with permission to approve plugins when a plugin approval is pending" => "Tuma tahadhari ya barua pepe kwa watumiaji wenye ruhusa ya kuidhinisha Plugin wakati idhini ya kuziba inasubiri",
// "Hide admin wizard on log-in when an admin user logs in" => "Hide admin wizard on log-in when an admin user logs in",
// "Workspace UI" => "Workspace UI",
// "Combines multiple site features to create a workspace experience for workgroups" => "Combines multiple site features to create a workspace experience for workgroups",
// "Workspace root category" => "Workspace root category",
// "ID of the root category containing all workspaces" => "ID of the root category containing all workspaces",
// "This value is automatically managed and should not need to be modified manually" => "This value is automatically managed and should not need to be modified manually",
// "Full WYSIWYG editor is optional" => "Full WYSIWYG editor is optional",
// "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used" => "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used",
// "Switching between HTML and wiki formats can cause problems for some pages" => "Switching between HTML and wiki formats can cause problems for some pages",
// "Full WYSIWYG editor is displayed by default" => "Full WYSIWYG editor is displayed by default",
// "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages" => "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages",
"Reopen with the same editor" => "Fungua upya na mhariri huo",
// "Ensures the editor last used to edit a page or item is used for the next edit as the default" => "Ensures the editor last used to edit a page or item is used for the next edit as the default",
// "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed" => "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed",
"Use Wiki syntax in WYSIWYG" => "Tumia syntax ya Wiki katika WYSIWYG",
// "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"" => "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"",
// "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools" => "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools",
// "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)" => "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)",
// "CKeditor offers possibilities which may not be expressible in Tiki syntax" => "CKeditor offers possibilities which may not be expressible in Tiki syntax",
// "Full WYSIWYG editor skin" => "Full WYSIWYG editor skin",
// "Moono (Default)" => "Moono (Default)",
// "Kama" => "Kama",
// "Bootstrap CK" => "Bootstrap CK",
// "Minimalist" => "Minimalist",
// "Office 2013" => "Office 2013",
// "Typefaces" => "Typefaces",
// "List of font names separated by semi-colons (\";\")" => "List of font names separated by semi-colons (\";\")",
// "Inline WYSIWYG editor" => "Inline WYSIWYG editor",
// "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required" => "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required",
// "Extra plugins" => "Extra plugins",
// "List of plugin names (separated by,)" => "List of plugin names (separated by,)",
// "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard" => "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard",
// "Support Tiki's \"wiki syntax\" in HTML pages" => "Support Tiki's \"wiki syntax\" in HTML pages",
// "XMPP client (ConverseJS)" => "XMPP client (ConverseJS)",
// "Integration with Converse.js XMPP client" => "Integration with Converse.js XMPP client",
// "XMPP server domain" => "XMPP server domain",
// "example.org" => "example.org",
// "XMPP MUC Domain" => "XMPP MUC Domain",
// "Required for auto-joining rooms" => "Required for auto-joining rooms",
// "conference.example.org" => "conference.example.org",
// "The authentication method to be used by XMPP client" => "The authentication method to be used by XMPP client",
// "OAuth (uses Tiki as provider)" => "OAuth (uses Tiki as provider)",
// "Openfire TikiToken" => "Openfire TikiToken",
// "Allow anonymous" => "Allow anonymous",
// "Allow anonymous users on Chat" => "Allow anonymous users on Chat",
// "Openfire REST API endpoint" => "Openfire REST API endpoint",
// "Full URL to API endpoint" => "Full URL to API endpoint",
// "https://xmpp.example.org:9091/plugins/restapi/v1/" => "https://xmpp.example.org:9091/plugins/restapi/v1/",
// "Rest API username" => "Rest API username",
// "Username to allow Openfire API usage" => "Username to allow Openfire API usage",
// "Rest API password" => "Rest API password",
// "Password to allow Openfire API usage" => "Password to allow Openfire API usage",
// "ConverseJS Debug Mode" => "ConverseJS Debug Mode",
// "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console" => "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console",
// "ConverseJS Extra Settings" => "ConverseJS Extra Settings",
// "JSON format object defining extra optional settings to initialize ConverseJS" => "JSON format object defining extra optional settings to initialize ConverseJS",
"SMTP server" => "Seva SMTP",
"Security" => "Usalama",
"SSL" => "SSL",
"TLS" => "TLS",
"Mail sender" => "Mtumaji wa barua pepe",
// "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications" => "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications",
"Sendmail" => "Tuma barua",
"SMTP" => "SMTP",
// "File (debug)" => "File (debug)",
"Authentication" => "Uthibitisho",
"Mail server authentication" => "Uthibitishaji wa seva ya barua pepe",
"LOGIN" => "LOGIN",
"PLAIN" => "PLAIN",
"CRAM-MD5" => "CRAM-MD5",
// "Local server name" => "Local server name",
// "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line" => "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line",
// "Mail delivery" => "Mail delivery",
// "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail" => "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail",
// "Send immediately" => "Send immediately",
// "Queue" => "Queue",
"Verify HTTPS certificates of remote servers" => "Thibitisha vyeti vya HTTPS ya seva za mbali",
// "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)" => "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)",
"Do not enforce verification" => "Usitii ukaguzi",
"Enforce verification" => "Thibitisha ukaguzi",
// "Use CURL for HTTP connections" => "Use CURL for HTTP connections",
// "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available" => "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available",
"Zotero bibliography" => "Bibliografia ya Zotero",
"Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system" => "Unganisha Tiki kwenye <a href=\"https://www.zotero.org\">Zotero</a>",
"You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style." => "Lazima utoe vitu vifuatavyo: Zotero Client Key, Zotero Client Secret, Zotero Group, na Zotero Reference Style.",
// "Zotero client key" => "Zotero client key",
"Required identification key. Registration required." => "Kipimo kinachohitajika. Usajili unahitajika.",
// "Zotero client secret" => "Zotero client secret",
// "Zotero group ID" => "Zotero group ID",
"Numeric ID of the group, can be found in the URL." => "Kitambulisho cha Nambari ya kikundi, kinaweza kupatikana kwenye URL.",
// "Zotero reference style" => "Zotero reference style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
"Unmatched system requirement. Missing PHP extension among %0" => "Mahitaji ya mfumo usiofanana. Inapoteza ugani wa PHP kati ya %0",
"Unmatched system requirement. The database you are using does not support this feature." => "Mahitaji ya mfumo usiofanana. Database unayotumia haitoi kipengele hiki.",
"Missing default for preference \"%0\"" => "Inapoteza chaguo-msingi kwa upendeleo \"%0\"",
"Configuration forced by host" => "Usanidi wa kulazimishwa na mwenyeji",
"Disabled by host" => "Imelemazwa na mwenyeji",
"Settings" => "Mipangilio",
"Permissions" => "Ruhusa",
"View" => "Kuangalia",
"Modules" => "Moduli",
"Plugins" => "Plugins",
// "Like" => "Like",
// "Missing preference \"%0\" for \"%1\"" => "Missing preference \"%0\" for \"%1\"",
// "%0 set to minimum of %1 instead of submitted value of %2" => "%0 set to minimum of %1 instead of submitted value of %2",
// "%0 set to maximum of %1 instead of submitted value of %2" => "%0 set to maximum of %1 instead of submitted value of %2",
// "Don't like" => "Don't like",
"Wiki top pages" => "Kurasa za juu za Wiki",
"Most-relevant pages" => "Kurasa zinazofaa zaidi",
"Wiki last pages" => "Kurasa za mwisho za Wiki",
// "Forums last topics" => "Forums last topics",
"Topic date" => "Tarehe ya masuala",
"Forums last posts" => "Ujumbe wa jukwaa wa hivi karibuni",
"Forums most-read topics" => "Masuala ya Vikao zimesomwa sana",
"Forums best topics" => "Masuala ya Vikao za juu",
"Most-visited forums" => "Vikao vilivyotembelewa zaidi",
"Forums with most posts" => "Vikao vilivyo na machapisho mengi",
"Wiki top galleries" => "Nyumba za juu za Wiki",
"Wiki top file galleries" => "Majumba ya faili ya juu ya Wiki",
"Wiki top images" => "Picha za juu za Wiki",
"Wiki top files" => "Faili za juu za Wiki",
"Downloads" => "Vipakuliwa",
"Wiki most-recent images" => "Picha za hivi karibuni za Wiki",
"Upload date" => "Tarehe ya kupakia",
"Wiki most-recent files" => "Faili za hivi karibuni za Wiki",
"Top Articles" => "Makala ya Juu",
"Most-visited blogs" => "Blogu zilitembelewa sana",
"Most-active blogs" => "Blogu za kazi sana",
"Blogs last posts" => "Machapisho za blogu za mwisho",
"Post date" => "Tarehe ya machapisho",
"Wiki top authors" => "Waandishi wa juu wa Wiki",
"Pages" => "Kurasa",
"Top article authors" => "Waandishi wa makala ya juu",
"Expecting three arguments for article-info" => "Inatarajia hoja tatu za maelezo ya makala",
"Unsupported property. Supported properties are: " => "Mali isiyohamishika. Programu zilizosaidiwa ni: ",
"The Articles feature is not activated" => "Vipengele vya makala havifunguliwa",
"Object must be provided and contain two arguments: type and object" => "Kitu kinapaswa kutolewa na vyenye hoja mbili: aina na kitu",
"Invalid property" => "Property isiyo sahihi",
// "Item must be provided and contain one argument: type, object-id" => "Item must be provided and contain one argument: type, object-id",
// "List must be provided and contain at least one argument: category IDs" => "List must be provided and contain at least one argument: category IDs",
"Invalid range" => "Muda usio sahihi",
"Invalid revote period" => "Kipindi cha kutengeneza kisicho sahihi",
"Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Inatarajia \"keep\" kuwa \"lasted\" au \"oldest\"",
// "Qualifier must be provided and contain one argument: type" => "Qualifier must be provided and contain one argument: type",
// "From must be provided and contain two arguments: type, object-id" => "From must be provided and contain two arguments: type, object-id",
// "To must be provided and contain two arguments: type, object-id" => "To must be provided and contain two arguments: type, object-id",
// "Field must be provided and contain one argument: field permanent name" => "Field must be provided and contain one argument: field permanent name",
"Unknown variables referenced: %0" => "Vigezo visivyojulikana vinatajwa: %0",
"Username is required" => "Jina la mtumiaji linahitajika",
"Password is required" => "Nenosiri linahitajika",
"User already exists" => "Mtumiaji huu tayari yupo",
"Invalid username" => "Jina la mtumiaji batili",
"Username is too long" => "Jina la mtumiaji ni mrefu sana",
"Username cannot contain uppercase letters" => "Jina la mtumiaji haliwezi kuwa na herufi kubwa",
"Wrong passcode. You need to know the passcode to register at this site" => "Passcode isiyo sahihi. Unahitaji kujua passcode kujiandikisha kwenye tovuti hii",
"You must choose a group" => "Lazima uchague kikundi",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
// "One of these groups is required" => "One of these groups is required",
"This field is required" => "Thamani hii inahitajika",
"The passwords don't match" => "Ma nenosiri mbili hazilingani",
// "Username must be at least %0 characters long" => "Username must be at least %0 characters long",
"Username cannot contain more than %0 characters" => "Jina la mtumiaji hauwezi kuwa na wahusika zaidi ya %0",
"This invitation does not exist or is deprecated or wrong email" => "Mwaliko huu haipo au ni barua pepe iliyosababishwa au isiyo sahihi",
"The title and description must be entered, to generate a feed" => "Kichwa na maelezo lazima ziingizwe, ili kuzalisha 'RSS feed'",
"To fix this error go to Admin -> Feeds" => "Ili kurekebisha hitilafu hii uende kwenye Admin -> Feeds",
"Please contact the site administrator and request this error to be corrected" => "Tafadhali wasiliana na msimamizi wa tovuti na uomba kosa hili lirekebishwe",
"If you set feed author email or URL, you must set feed author name" => "Ikiwa utaweka barua pepe ya mwandishi au URL, unapaswa kuweka jina la mwandishi wa 'feed RSS'",
"Feed logo" => "Alama ya 'feed",
"Unspecified" => "Haijajulikana",
"Log In" => "Uhusiano",
"See other users' profiles" => "Angalia maelezo ya watumiaji wengine",
"Have your profile seen" => "Kuwa na wasifu wako umeonekana",
"Make friends" => "Tengeneza Marafiki",
"Receive a message" => "Pata ujumbe",
"Send a message" => "Tuma ujumbe",
"Read an article" => "Soma makala",
"Publish an article" => "Chapisha makala",
"Have your article read" => "Kuwa na makala yako isome",
"Create new file gallery" => "Unda nyumba ya sanaa mpya ya faili",
"Upload a new file to a gallery" => "Pakia faili mpya kwenye nyumba ya sanaa",
"Download another user's file" => "Pakua faili ya mtumiaji mwingine",
"Have your file downloaded" => "Kuwa na faili yako imepakuliwa",
"Create a new image gallery" => "Unda nyumba ya sanaa mpya ya picha",
"Upload a new image to a gallery" => "Pakia picha mpya kwenye nyumba ya sanaa",
"View another user's gallery" => "Angalia nyumba ya sanaa ya mtumiaji mwingine",
"View another user's images" => "Tazama picha za mtumiaji mwingine",
"Have your gallery viewed by another user" => "Kuwa na nyumba yako ya sanaa inaonekana na mtumiaji mwingine",
"Have your image viewed" => "Kuwa na picha yako kutazamwa",
"Create a new blog" => "Unda blogu mpya",
"Post in a blog" => "Chapisha kwenye blogu",
"Read another user's blog" => "Soma blogu ya mtumiaji mwingine",
"Have your blog read" => "Kuwa na blogu yako isome",
"Create a new wiki page" => "Unda ukurasa mpya wa wiki",
"Edit an existing page" => "Badilisha ukurasa uliopo",
"Attach a file" => "Weka faili",
// "Create a new forum topic" => "Create a new forum topic",
// "Reply to a forum topic" => "Reply to a forum topic",
// "Read a forum post" => "Read a forum post",
// "Have your forum post read" => "Have your forum post read",
// "Create a new tracker item" => "Create a new tracker item",
// "Edit a tracker item" => "Edit a tracker item",
// "View a tracker item" => "View a tracker item",
// "Have your tracker item viewed" => "Have your tracker item viewed",
// "Tracker field content added" => "Tracker field content added",
// "Favorite an item" => "Favorite an item",
// "Have your item favorited" => "Have your item favorited",
// "Have your item rated (per rating)" => "Have your item rated (per rating)",
// "Have your item unrated (per rating)" => "Have your item unrated (per rating)",
// "Add a profile photo" => "Add a profile photo",
// "Try rebuilding or optimizing the index on the search admin page" => "Try rebuilding or optimizing the index on the search admin page",
// "Invalid table name" => "Invalid table name",
// "Invalid column name" => "Invalid column name",
"Wiki Comment" => "Maoni ya Wiki",
"Calendar item" => "Tukio la kalenda",
"Gallery" => "Nyumba ya sanaa",
"Blog post" => "Chapisho la blogu",
"Tracker item" => "Bidhaa ya Tracker",
"The search index could not be updated. The site is misconfigured. Contact an administrator" => "Orodha ya utafutaji haijasasishwa. Tovuti haijasimamishwa. Wasiliana na msimamizi",
// "Rebuild in progress" => "Rebuild in progress",
// "The search index could not be rebuilt" => "The search index could not be rebuilt",
// "The active index could not be removed, probably due to a file permission issue" => "The active index could not be removed, probably due to a file permission issue",
// "The new index could not be made active, probably due to a file permission issue" => "The new index could not be made active, probably due to a file permission issue",
// "Failed to delete the old index" => "Failed to delete the old index",
"blog post" => "chapisho la blogu",
"forum post" => "chapisho la jukwaa",
"tracker item" => "bidhaa ya tracker",
// "tracker field" => "tracker field",
"sheet" => "karatasi",
"comment" => "maoni",
// "category" => "category",
// "webservice" => "webservice",
// "activity" => "activity",
// "calendar item" => "calendar item",
// "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate" => "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate",
// "Contact the site administrator. The index needs rebuilding" => "Contact the site administrator. The index needs rebuilding",
// "Client Node" => "Client Node",
// "Elasticsearch Version" => "Elasticsearch Version",
// "Lucene Version" => "Lucene Version",
// "Cluster Name" => "Cluster Name",
// "Cluster Status" => "Cluster Status",
// "Cluster Node Count" => "Cluster Node Count",
// "Index %0" => "Index %0",
// "%0 documents, totaling %1" => "%0 documents, totaling %1",
// "Node %0" => "Node %0",
// "Using %0, since %1" => "Using %0, since %1",
// "%0 documents, totaling %1 bytes" => "%0 documents, totaling %1 bytes",
// "Using %0 bytes, since %1" => "Using %0 bytes, since %1",
// "Field Count Tried on Last Rebuild" => "Field Count Tried on Last Rebuild",
// "Field limit setting is lower than Tiki needs to store in the index" => "Field limit setting is lower than Tiki needs to store in the index",
// "Information Missing" => "Information Missing",
"Object Type" => "Aina ya Kitu",
// "date_histogram" => "date_histogram",
// "Date Histogram" => "Date Histogram",
// "date_range" => "date_range",
"Date Range" => "Muda wa Tarehe",
// "Local Search" => "Local Search",
"Federated Search" => "Utafutaji wa shirikisho",
// "Index not found" => "Index not found",
// "Rebuild search index" => "Rebuild search index",
// "Click here to rebuild index" => "Click here to rebuild index",
// "On Demand" => "On Demand",
// "You can revisit the results of this saved search on demand" => "You can revisit the results of this saved search on demand",
// "Mobile mode: Permission denied, please log in" => "Mobile mode: Permission denied, please log in",
" has accessed your temporary shared content" => " imepata maudhui yako ya muda mfupi",
"has accessed the following shared content" => "imepata maudhui yaliyoshirikiwa yafuatayo",
"Your access to this page has expired" => "Ufikiaji wako kwenye ukurasa huu umekamilika",
"Handling actions of plugin \"%s\" failed" => "Kushughulikia hatua za Plugin \"%s\" imeshindwa",
"You must choose an option" => "Lazima uchague chaguo",
"For you to vote, cookies must be allowed" => "Kwa kupiga kura, kuki lazima kuruhusiwe",
"This poll is closed." => "Uchaguzi huu umefungwa.",
// "Preference %0 failed to unserialize. Value was \"%1\"" => "Preference %0 failed to unserialize. Value was \"%1\"",
// "A tracker with id \"%0\" is required to be filled in, but it was deleted" => "A tracker with id \"%0\" is required to be filled in, but it was deleted",
// "Update the preference \"<b>%0</b>\" on admin panel" => "Update the preference \"<b>%0</b>\" on admin panel",
"Congratulations" => "Hongera",
"This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "Hii ni ukurasa wa msingi wa Tiki yako. Ikiwa unaona ukurasa huu, ufungaji wako ulifanikiwa",
// "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details",
// "Get started" => "Get started",
"To begin configuring your site" => "Kuanza kusanidi tovuti yako",
"1) Log in with your newly created password" => "1) Ingia na nenosiri lako jipya",
// "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard" => "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard",
// "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running" => "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running",
// "Need help" => "Need help",
"For more information" => "Kwa habari zaidi",
// "[https://tiki.org/Introduction|Learn more about Tiki]" => "[https://tiki.org/Introduction|Learn more about Tiki]",
// "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[https://tiki.org/Join|Join the Tiki community]" => "[https://tiki.org/Join|Join the Tiki community]",
"new" => "mpya",
"Saved" => "Imehifadhiwa",
"Save failed" => "Hifadhi imeshindwa",
// "Standard Shipping" => "Standard Shipping",
"3 to 5 working days" => "Siku 3 hadi 5 za kazi",
"Express Shipping" => "Express Shipping",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
// "Modified date" => "Modified date",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
"No records to display" => "Hakuna kumbukumbu za kuonyesha",
// "Please specify the name of the package and the view" => "Please specify the name of the package and the view",
// "Error: Unable to locate view file for the package" => "Error: Unable to locate view file for the package",
// "Error: Unable to locate function name for the view" => "Error: Unable to locate function name for the view",
"Previous" => "uliopita",
"current" => "inaendelea",
"Next" => "Ijayo",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
"Tab View" => "na tabo",
"No Tabs" => "bila tabo",
"This edit session will expire in" => "Kipindi hiki cha uhariri kitakamilika",
"There is an autosaved draft of your recent edits, to use it instead " => "Kuna rasimu iliyohifadhiwa ya mipangilio yako ya hivi karibuni, ili kuitumia badala yake ",
// "If you want the original instead of the autosaved draft of your edits" => "If you want the original instead of the autosaved draft of your edits",
"click here" => "Bonyeza hapa",
"AutoSave" => "Kulinda moja kwa moja",
"Your edit session has expired" => "Kipindi hiki cha uhariri imekamilika",
"Your edit session will expire in" => "Samu yako ya uhariri itapungua kwa muda",
"You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Lazima uendelee PREVIEW au SAVE kazi yako sasa, ili kuepuka kupoteza mipangilio yako",
// "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page",
"Help page" => "Ukurasa wa usaidizi",
// "View or edit tpl" => "View or edit tpl",
// "View tpl" => "View tpl",
// "itemId required" => "itemId required",
// "Plugin name not specified" => "Plugin name not specified",
// "Delete file" => "Delete file",
// "File (ID %0) removed" => "File (ID %0) removed",
// "File (ID %0) not removed" => "File (ID %0) not removed",
// "File uploaded" => "File uploaded",
// "File not uploaded" => "File not uploaded",
// "Missing _id or _type params" => "Missing _id or _type params",
"Wrong attachments gallery" => "Viambatisho vibaya vya nyumba hii ya sanaa",
"You are attempting to display a gallery that is not a valid attachment gallery" => "Unajaribu kuonyesha nyumba ya sanaa ambayo sio halali ya sanaa ya viambatisho",
// "Missing 'to' or 'from' parameter" => "Missing 'to' or 'from' parameter",
"at" => "katika",
"to" => "kwenye",
"Favorite" => "Mapenzi",
"Hour" => "Saa",
"Minute" => "Dakika",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
"Click here to go to Edit Languages" => "Bonyeza hapa ili uende kwenye lugha za uhariri",
"The text is" => "Nakala ni",
"character(s) too long - please edit it." => "Nakala ndefu sana - tafadhali uhariri.",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Clear filter" => "Clear filter",
"Filter:" => "Chujio:",
// "Type not specified" => "Type not specified",
// "lock perm not found" => "lock perm not found",
// "admin perm not found" => "admin perm not found",
"Missing parameter" => "Thamani ya kupoteza",
// "Multivalue configuration not found" => "Multivalue configuration not found",
"No records found." => "Hakuna matokeo.",
"No object information provided" => "Hakuna taarifa ya kitu iliyotolewa",
"No title specified" => "Hakuna jina maalum",
"Relation not found" => "Uhusiano haukupatikana",
"tags disabled" => "vitambulisho vimezimwa",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "%0 list separated with \"%1\"" => "%0 list separated with \"%1\"",
// "Object selector requires Unified Index to be enabled" => "Object selector requires Unified Index to be enabled",
"Currency in payment (%0) does not match the currency for that registry (%1)" => "Fedha ya malipo (%0) haifani na sarafu ya Usajili huo (%1)",
// "Payment error" => "Payment error",
"This invoice does not exist or access to it is restricted" => "Muswada huu haipo au una upatikanaji mdogo",
// "You do not have the permission that is needed to use this feature" => "You do not have the permission that is needed to use this feature",
"(not found in an admin panel)" => "(haipatikani kwenye jopo la admin)",
"Preference %0 is not defined" => "Upendeleo %0 haujafafanuliwa",
"Drag this out of the perspective and resave the perspective" => "Hoja hii nje ya mtazamo na uhakikishe mtazamo",
"No object information provided for rating" => "Hakuna habari ya kitu iliyotolewa kwa tathmini",
"An error occurred" => "Hitilafu ilitokea",
// "Configure Ratings" => "Configure Ratings",
"Unavailable" => "Haipatikani",
// "Invalid fields provided" => "Invalid fields provided",
// "Missing or invalid tracker reference" => "Missing or invalid tracker reference",
// "Configured" => "Configured",
"General" => "Jenerali",
// "Tracker rendering error (section=\"%0\" mode=\"%1\")" => "Tracker rendering error (section=\"%0\" mode=\"%1\")",
"No rows found" => "Hakuna safu zilizopatikana",
"Toggle sections" => "Badilisha sehemu",
"Show only selected" => "Onyesha vitu tu vilivyochaguliwa",
"You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "Unaweza kutaka kutoa tiki_p_modify_object_categories sahihi katika sehemu ya Tiki",
// "You are logged in" => "You are logged in",
// "Request not from this host" => "Request not from this host",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Tafadhali ingiza %s halali. Hakuna nafasi, zaidi ya wahusika wa %d na yenye %s",
"username" => "jina la mtumiaji",
"password" => "nenosiri",
"Cookies must be enabled to log in to this site" => "Vidakuzi lazima kuwezeshwa kuingia kwenye tovuti hii",
// "wikidiff: error - no object_id specified" => "wikidiff: error - no object_id specified",
// "wikidiff: error - no old version specified" => "wikidiff: error - no old version specified",
// "wikidiff: error - page \"%0\" not found" => "wikidiff: error - page \"%0\" not found",
// "wikidiff: Error - only wiki pages supported currently" => "wikidiff: Error - only wiki pages supported currently",
"second" => "nukta",
"months" => "miezi",
"weeks" => "wiki",
"done" => "kufanyika",
"Text cut here" => "Nakala imekatwa hapa",
"Task" => "Kazi",
"Priority" => "Kipaumbele",
"Start date" => "Tarehe ya kuanza",
"End date" => "Tarehe ya mwisho",
"in %s days, the %s" => "katika siku %s, %s",
"in %s day, the %s" => "katika siku ya %s, %s",
"Today" => "Leo",
// "%0 and %1" => "%0 and %1",
"Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Ruhusa imekataliwa: ukurasa maalum wa wiki hauwezi kutumika kama rasilimali ya template ya Smarty",
"No WSDL found" => "Hakuna WSDL iliyopatikana",
// "Facebook feed data not retrieved" => "Facebook feed data not retrieved",
// "Facebook profile information not retrieved" => "Facebook profile information not retrieved",
// "You need to link your local account to Facebook before you can login using it" => "You need to link your local account to Facebook before you can login using it",
// "We were unable to create a new user with your Facebook account. Please contact the administrator" => "We were unable to create a new user with your Facebook account. Please contact the administrator",
// "We were unable to connect to your LinkedIn account. Please contact the administrator" => "We were unable to connect to your LinkedIn account. Please contact the administrator",
// "We were unable to log you in using your LinkedIn account. Please contact the administrator" => "We were unable to log you in using your LinkedIn account. Please contact the administrator",
// "You need to link your local account to LinkedIn before you can login using it" => "You need to link your local account to LinkedIn before you can login using it",
"pvs" => "kurasa zinazoonekana",
"Days with the most pageviews" => "Siku zilizo na maoni zaidi ya ukurasa",
"Day with the most pageviews" => "Siku yenye maoni zaidi ya ukurasa",
"Days with the fewest pageviews" => "Siku na maoni chache zaidi ya ukurasa",
"Day with the fewest pageviews" => "Siku yenye maoni chache zaidi ya ukurasa",
"No pageviews yet" => "Hakuna maoni ya ukurasa bado",
"Use this tree to copy the structure" => "Tumia mti huu kuiga muundo",
"system" => "mfumo",
"created from structure" => "imeundwa kutoka kwa muundo",
"%d choice(s) must be made for the question" => "Uchaguzi unapaswa kufanywa kwa swali",
"At least %d choice(s) must be made for the question" => "Angalau %d uchaguzi lazima ufanyike kwa swali",
"Fewer than %d choice(s) must be made for the question" => "Chache kuliko %d uchaguzi lazima zifanywe kwa swali",
"One choice" => "Chaguo moja",
"Multiple choices" => "Uchaguzi nyingi",
// "Thumbnails" => "Thumbnails",
"Short text" => "Nakala fupi",
"Wiki textarea" => "Eneo la maandishi ya Wiki",
"Rate (1 to 5)" => "Kiwango (1 hadi 5)",
"Rate (1 to 10)" => "Kiwango (1 hadi 10)",
"Heading" => "Kichwa",
// "Icon not found: %0" => "Icon not found: %0",
// "Icon set: Class not defined for icon %0" => "Icon set: Class not defined for icon %0",
// "Custom theme by specifying URL" => "Custom theme by specifying URL",
"Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator" => "Vipengele vinavyotakiwa: <b>%0</b>. Ikiwa huna idhini ya kuamsha vipengele hivi, waulize msimamizi wa tovuti",
// "CSRF check not performed" => "CSRF check not performed",
// "Required headers are missing" => "Required headers are missing",
// "Requesting site could not be identified because %0 and %1 were empty" => "Requesting site could not be identified because %0 and %1 were empty",
// "Request needs to originate from this site" => "Request needs to originate from this site",
// "The %0 host (%1) does not match this server (%2)" => "The %0 host (%1) does not match this server (%2)",
// "Ticket has expired. Reload the page" => "Ticket has expired. Reload the page",
// "Ticket matches but is expired" => "Ticket matches but is expired",
// "Reloading the page may help" => "Reloading the page may help",
// "Ticket does not match or is missing" => "Ticket does not match or is missing",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked" => "Potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Request to %0 failed CSRF check" => "Request to %0 failed CSRF check",
"Confirm action" => "Thibitisha hatua",
// "Please confirm action" => "Please confirm action",
"unknown error" => "kosa haijulikani",
"You are not logged in" => "Hujaingia",
"You do not have permission to view this section" => "Huna ruhusa ya kutazama sehemu hii",
"For the security of your password, direct access to the feed is only available via HTTPS" => "Kwa usalama wa nenosiri lako, upatikanaji wa moja kwa moja kwa malisho inapatikana tu kupitia HTTPS",
"Help link" => "Kiungo kwa kupata msaada",
"You are banned from" => "You are banned from",
"wiki" => "wiki",
"img-g" => "picha-g",
"file-g" => "faili-g",
"quizzes" => "majaribio",
"arts" => "makala",
"blogs" => "blogu",
"forums" => "vikao",
// "Tiki links converted to relative links" => "Tiki links converted to relative links",
// "TikiLib::create_page: Cannot create page \"%0\", it already exists.)" => "TikiLib::create_page: Cannot create page \"%0\", it already exists.)",
"The file was successfully uploaded" => "Faili imepakiwa kwa ufanisi",
"The file was only partially uploaded." => "Faili ilikuwa iliyopakiwa kwa sehemu tu.",
"No file was uploaded. Was a file selected " => "Hakuna faili iliyopakiwa. Ilikuwa faili iliyochaguliwa ",
"A temporary folder is missing" => "Faili ya muda mfupi haipo",
// "Alias <b>%0</b> link already present in %1 page(s)" => "Alias <b>%0</b> link already present in %1 page(s)",
"%d points" => "pointi %d",
"Removed" => "Imeondolewa",
"Plugin %0 pending approval" => "Plugin %0 inasubiri idhini",
"Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked." => "Uwezekano wa kufuta ombi la tovuti (CSRF, au \"sea surfing\") umegunduliwa. Uendeshaji umezuiwa.",
"Bold" => "Kubwa",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
"Italic" => "italiki",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
"Underline" => "Piga mstari chini",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
"Strikethrough" => "kuzuiliwa",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Code" => "Kanuni",
// "img/icons/page_white_code.png" => "img/icons/page_white_code.png",
"Non-parsed (wiki syntax does not apply)" => "Haijahamishwa (syntax ya wiki haitumiki)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
"Align Center" => "Imekaa katikati ya usawa",
"Horizontal Bar" => "Bar ya usawa",
"Page Break" => "Kuvunja ukurasa",
"Box" => "Sanduku",
"Title bar" => "Bar ya kichwa",
// "Bullet List" => "Bullet List",
// "Numbered List" => "Numbered List",
"Special Characters" => "Wahusika maalum",
"Foreground color" => "Rangi ya font",
"Background Color" => "Rangi ya Ukuta",
"Wiki Link" => "Kiungo cha Wiki",
// "img/icons/page_link.png" => "img/icons/page_link.png",
// "Object Link" => "Object Link",
"External Link" => "Kiungo cha nje",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
"Table Builder" => "Mjenzi wa Jedwali",
// "img/icons/find.png" => "img/icons/find.png",
"Find Text" => "Pata Nakala",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
"Text Replace" => "Badilisha",
"Full-screen edit" => "Toleo la skrini kamili",
"Wiki Help" => "Misaada ya Wiki",
"Choose or upload images" => "Chagua au kupakia picha",
// "img/icons/pictures.png" => "img/icons/pictures.png",
// "Choose or upload files" => "Choose or upload files",
"Switch Editor (wiki or WYSIWYG)" => "Badilisha Mhariri (wiki au WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
"Admin Toolbars" => "Usimamizi wa Barabara",
// "img/icons/wrench.png" => "img/icons/wrench.png",
"Save Sheet" => "Hifadhi Karatasi",
"Add row after selection or to the end if no selection" => "Ongeza mstari baada ya uteuzi au mwisho ikiwa hakuna uteuzi",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
"Add multiple rows after selection or to the end if no selection" => "Ongeza safu nyingi baada ya uteuzi au mwisho ikiwa hakuna uteuzi",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
"Add row before selection or to end if no selection" => "Ongeza mstari kabla ya uteuzi au kumalizika ikiwa hakuna uteuzi",
"Delete selected row" => "Futa safu iliyochaguliwa",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
"Add column after selection or to the end if no selection" => "Ongeza safu baada ya uteuzi au mwisho ikiwa hakuna uteuzi",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
"Delete selected column" => "Futa safu iliyochaguliwa",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
"Add multiple columns after selection or to the end if no selection" => "Ongeza safu nyingi baada ya uteuzi au mwisho ikiwa hakuna uteuzi",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
"Add column before selection or to the end if no selection" => "Ongeza safu kabla ya uteuzi au mwisho ikiwa hakuna uteuzi",
"Get Cell Range" => "Pata eneo la viini",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "Tafuta",
"Refresh calculations" => "Hesabu ya upya",
"Finish editing" => "Mwisho wa toleo",
"Reset Colors" => "Rudisha Rangi",
"Reset" => "Rudisha",
// "Show this text" => "Show this text",
// "Link to this page" => "Link to this page",
// "Anchor" => "Anchor",
// "Semantic relation" => "Semantic relation",
"Cancel" => "Kufuta",
"Insert" => "Ingiza",
// "Types of object" => "Types of object",
// "Link to this object" => "Link to this object",
// "link to this URL" => "link to this URL",
// "No cache" => "No cache",
// "Case Insensitivity" => "Case Insensitivity",
// "Note: Uses regular expressions" => "Note: Uses regular expressions",
"Close" => "Funga",
"Replace" => "Badilisha",
// "Replace All" => "Replace All",
// "Flat" => "Flat",
"Tabs" => "Tabo",
// "No template available for %0 - %1" => "No template available for %0 - %1",
// "Tracker %0 not found for Field %1" => "Tracker %0 not found for Field %1",
"*** ERROR: Tracker ID not set ***" => "*** KOSA: Kitambulisho cha Tracker haijawekwa ***",
"*** ERROR: Field ID not set ***" => "*** KOSA: Kitambulisho cha shamba si kuweka ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "TrackerLib::get_all_items: No item for itemId %0" => "TrackerLib::get_all_items: No item for itemId %0",
// "Tracker list_items ran out of memory after %0 items" => "Tracker list_items ran out of memory after %0 items",
// "No fields found in header, not a comma-separated values file" => "No fields found in header, not a comma-separated values file",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
// "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"" => "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"",
"Field is not numeric" => "Uwanja sio nambari",
"Function" => "Kazi",
"Pending" => "Inasubiri",
"Tracker field setup error - display field not found: " => "Hitilafu ya usanidi wa uwanja wa Tracker - uwanja usioonekana: ",
// "Item Creation" => "Item Creation",
"Item Modification" => "Marekebisho ya kadi",
"Item" => "Kadi",
"Subject" => "Somo",
"Tracker was modified at %0 by %1" => "Tracker ilibadilishwa kwa %0 na %1",
"View the tracker item at" => "Tazama kipengee cha tracker katika",
// "Missing wiki email template page \"%0\"" => "Missing wiki email template page \"%0\"",
// "Tracker field not enabled: fieldId=%0 type=%1" => "Tracker field not enabled: fieldId=%0 type=%1",
// "Field not specified" => "Field not specified",
"No extra information for that attached file. " => "Hakuna maelezo ya ziada ya faili hiyo iliyoambatanishwa. ",
// "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list" => "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list",
// "Could not create /storage/pass_blacklists directory" => "Could not create /storage/pass_blacklists directory",
// "Existing password blacklist file was overwritten" => "Existing password blacklist file was overwritten",
// "Existing password blacklist file could not be overwritten" => "Existing password blacklist file could not be overwritten",
// "File Error. Password file not created" => "File Error. Password file not created",
// "File Error. Password file generation interrupted" => "File Error. Password file generation interrupted",
// "Password blacklist file generated" => "Password blacklist file generated",
// "Unable to Populate Blacklist: File dose not exist or is not readable" => "Unable to Populate Blacklist: File dose not exist or is not readable",
// "Critical" => "Critical",
// "Immediate notification by email" => "Immediate notification by email",
"High" => "Juu",
// "Will be sent to you with the next periodic digest" => "Will be sent to you with the next periodic digest",
"Low" => "Chini",
// "Included in your personalized recent changes feed" => "Included in your personalized recent changes feed",
// "Anywhere" => "Anywhere",
// "translations of %0" => "translations of %0",
// "%0 in %1" => "%0 in %1",
// "%0 for %1" => "%0 for %1",
// "Any activity" => "Any activity",
// "Page modified" => "Page modified",
// "Page created" => "Page created",
// "Any forum activity" => "Any forum activity",
// "New topics" => "New topics",
// "Any item activity" => "Any item activity",
// "New items" => "New items",
// "Action Required" => "Action Required",
// "Recommendation Received" => "Recommendation Received",
// "%0 (%1 level up, entire structure)" => "%0 (%1 level up, entire structure)",
// "%0 (%1 level up)" => "%0 (%1 level up)",
// "%0 (current subtree)" => "%0 (current subtree)",
// "%0 Reply Handler" => "%0 Reply Handler",
// "The user [ %0 ] is not registered with this wiki and autocreate is disabled" => "The user [ %0 ] is not registered with this wiki and autocreate is disabled",
// "The user [ %0|%1 ] is not registered with this wiki and the creation process failed" => "The user [ %0|%1 ] is not registered with this wiki and the creation process failed",
// "unverified" => "unverified",
"Your Information" => "Maelezo yako",
"User Information" => "Maelezo ya mtumiaji",
"Can create/close a book" => "Anaweza kuunda/kufunga kitabu",
"Can create/edit/lock accounts" => "Anaweza kuunda/hariri/kufungua akaunti",
"Create a new transaction" => "Unda shughuli mpya",
// "Permission to view the journal" => "Permission to view the journal",
"Can book into the stack where statements can be changed" => "Anaweza kuingia kwenye stack ambapo maelezo yanaweza kubadilishwa",
"Can import statements from external accounts" => "Anaweza kuagiza taarifa kutoka kwa akaunti za nje",
"Can manage templates for recurring transactions" => "Anaweza kudhibiti templates kwa shughuli za mara kwa mara",
"Can admin the articles" => "Anaweza kusimamia makala",
"Can approve submissions" => "Anaweza kupitisha maoni",
"Can admin article topics" => "Anaweza kusimamia mada ya makala",
"Can admin article types" => "Anaweza kusimamia aina za makala",
"Can read article headings" => "Anaweza kusoma vichwa vya makala",
"Submitted articles are automatically approved" => "Makala yaliyowasilishwa yanaidhinishwa moja kwa moja",
"Can edit articles" => "Anaweza kuhariri makala",
// "Can edit the user (owner) of articles" => "Can edit the user (owner) of articles",
"Can edit submissions" => "Anaweza kuhariri maoni",
// "Can read articles (applies to article or topic level)" => "Can read articles (applies to article or topic level)",
"Can remove articles" => "Anaweza kuondoa makala",
"Can remove submissions" => "Anaweza kuondoa maoni",
"Can submit articles" => "Anaweza kuwasilisha makala",
"Can rate articles" => "Anaweza kupima makala",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
"Can join a meeting" => "Anaweza kujiunga na mkutano",
"Can moderate a meeting" => "Anaweza kuongoza mkutano",
"Can create a meeting" => "Anaweza kuunda mkutano",
// "Can use XMPP chat" => "Can use XMPP chat",
"Can admin blogs" => "Inaweza kusimamia blogu",
"Can assign perms to blog" => "Anaweza kutoa ruhusa kwa blogu",
"Can post to a blog" => "Anaweza kuchapisha kwenye blogu",
"Can create a blog" => "Anaweza kuunda blogu",
"Can read blogs" => "Anaweza kusoma blogu",
"Can view in module and feed the blog posts" => "Anaweza kuona katika moduli na kulisha machapisho ya blogu",
"Can view in module and feed the blog" => "Haki ya kuona blogu kwenye moduli na mito",
// "Can create/admin calendars" => "Can create/admin calendars",
"Can add events in the calendar" => "Haki ya kuongeza matukio kwenye kalenda",
"Can edit events in the calendar" => "Haki ya kuhariri matukio katika kalenda",
"Can browse the calendar" => "Haki ya kuvinjari kalenda",
"Can view event details" => "Haki ya kuona maelezo ya matukio",
"Can add himself or herself to the participants" => "Haki ya kuongeza mtumiaji kwa washiriki",
"Can add guest to the participants" => "Haki ya kuongeza mgeni kwa washiriki",
"Can view Tiki tools calendar" => "Haki ya kuvinjari ratiba ya vitendo vya Tiki",
"Can admin categories" => "Haki ya kusimamia makundi",
"Can see the category in a listing" => "Haki ya kuona kikundi katika orodha",
"Can add objects to the category (tiki_p_modify_object_categories permission required)" => "Haki ya kuongeza vitu kwa kikundi (inahitaji tiki_p_modify_object_categories)",
"Can remove objects from the category (tiki_p_modify_object_categories permission required)" => "Haki ya kuondoa vitu kutoka kwa kikundi (inahitaji tiki_p_modify_object_categories)",
// "Can assign perms to category" => "Can assign perms to category",
"Administrator can create channels, remove channels, etc" => "Msimamizi anaweza kuunda vituo, kufuta, na kadhalika.",
"Can use the chat system" => "Haki ya kutumia mfumo wa kuzungumza",
"Can admin received articles" => "Haki ya kuagiza makala zilizopokelewa",
"Can admin received pages" => "Haki ya kusimamia kurasa zilizopokelewa",
"Can send articles to other sites" => "Haki ya kutuma makala kwenye tovuti zingine",
"Can send articles to this site" => "Haki ya kutuma makala kwenye tovuti hii",
"Can send pages to this site" => "Haki ya kutuma kurasa kwenye tovuti hii",
"Can send pages to other sites" => "Haki ya kutuma kurasa kwenye tovuti zingine",
"Can post new comments" => "Haki ya kuchapisha maoni mapya",
"Can read comments" => "Haki ya kusoma maoni",
"Can admin comments" => "Haki ya kusimamia maoni",
"Can edit all comments" => "Haki ya kuhariri maoni yote",
"Can delete comments" => "Haki ya kufuta maoni",
"Can vote on comments" => "Haki ya kupiga maoni",
"Can admin content templates" => "Haki ya kuongoza templates maudhui",
"Can edit content templates" => "Haki ya kuhariri templates maudhui",
// "Can lock content templates" => "Can lock content templates",
"Can use content templates" => "Haki ya kutumia templates maudhui",
"Can admin contributions" => "Haki ya kusimamia michango",
"Can admin the directory" => "Haki ya kusimamia directory ya viungo",
"Can admin directory categories" => "Haki ya kusimamia makundi ya saraka",
"Can admin directory sites" => "Haki ya kusimamia orodha ya tovuti",
"Submitted links are valid" => "Viungo vilivyosilishwa halali",
"Can submit sites to the directory" => "Haki ya kuwasilisha tovuti kwenye saraka za viungo",
"Can validate submitted links" => "Anaweza kuthibitisha viungo vilivyotumwa",
"Can use the directory" => "Haki ya kutumia saraka ya viungo",
"Can execute arbitrary queries on a given DSN" => "Haki ya kutekeleza jitihada yoyote kwenye DSN iliyotolewa",
"Can admin FAQs" => "Haki ya kusimamia FAQs",
"Can suggest FAQ questions" => "Haki ya kupendekeza maswali katika FAQs",
"Can view FAQs" => "Haki ya kuona FAQs",
"Can download files" => "Haki ya kupakua faili",
"Can upload files" => "Haki ya kutuma (kupakia) faili",
"Can list file galleries" => "Haki ya kuona orodha ya nyumba za faili",
"Can view file galleries" => "Haki ya kuona nyumba za faili",
"Can admin file galleries" => "Haki ya kusimamia nyumba za faili",
"Can assign permissions to file galleries" => "Haki ya kupewa ruhusa kwenye nyumba za faili",
"Can use Directory Batch Load" => "Haki ya upakiaji wa kundi katika saraka za viungo",
"Can upload .zip file packages" => "Haki ya kutuma faili za zip na faili",
"Can create file galleries" => "Haki ya kuunda nyumba za faili",
"Can edit a gallery file" => "Haki ya kuhariri faili ya sanaa",
"Can remove files" => "Uwezo wa kufuta faili",
"Can view file galleries explorer" => "Haki ya kuona mtafiti wa nyumba za faili",
"Can view file galleries path" => "Haki ya kuona njia ya nyumba za faili",
"Can upload files containing JavaScript" => "Inaweza kupakia faili zenye JavaScript",
// "Can upload SVG files" => "Can upload SVG files",
"Can admin forums" => "Haki ya kusimamia vikao",
"Can attach files to forum posts" => "Haki ya kuunganisha faili kwenye makala za jukwaa",
"Auto approve forum posts" => "Uthibitishaji wa moja kwa moja wa makala ya jukwaa",
"Can post in forums" => "Haki ya kuchapisha kwenye jukwaa",
"Can start threads in forums" => "Haki ya kuanza thread katika jukwaa",
"Can read forums" => "Haki ya kusoma vikao",
"Can report posts to moderator" => "Haki ya kuripoti kwa msimamizi",
"Can vote on comments in forums" => "Haki ya kupiga maoni kwa vikao",
"Can browse tags" => "Haki ya kuvinjari keywords",
"Can admin tags" => "Haki ya kusimamia keywords",
"Can tag objects" => "Inaweza kutambulisha vitu",
"Can unassign tags from an object" => "Haki ya kufuta lebo zinazohusiana na kitu",
"Can subscribe to groups" => "Haki ya kujiandikisha kwa makundi",
"Can invite user to my groups" => "haki ya kukaribisha mtumiaji kwenye makundi yangu",
"Can view the group" => "Haki ya kuona vikundi",
"Can view the group members" => "Haki ya kuona wanachama wa kikundi",
"Can add group members" => "Haki ya kuongeza wanachama kwenye makundi",
"Can remove group members" => "Haki ya kuwaondoa wanachama wa kikundi",
"Can join or leave the group" => "Haki ya kujiunga au kuacha kikundi",
// "Can view H5P content" => "Can view H5P content",
// "Can edit H5P content" => "Can edit H5P content",
// "Can administer H5P content" => "Can administer H5P content",
"Can edit HTML pages" => "Anaweza kurekebisha kurasa za HTML",
"Can view HTML pages" => "Haki ya kuona kurasa za HTML",
"Can admin Image Galleries" => "Haki ya kusimamia nyumba za picha",
"Can assign permissions to image galleries" => "Haki ya kuwapa haki za kufikia kwenye nyumba za picha",
"Can upload .zip files of images" => "Haki ya kutuma faili za ZIP na picha",
"Can create image galleries" => "Haki ya kujenga nyumba za picha",
"Can list image galleries" => "Haki ya kuorodhesha maudhui ya nyumba za picha",
"Can upload images" => "Haki ya kupakia picha",
"Can view image galleries" => "Haki ya kuona nyumba za picha",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
"Can broadcast messages to all users" => "Haki ya kutangaza ujumbe kwa watumiaji wote",
"Can broadcast messages to groups" => "Haki ya kutangaza ujumbe kwa vikundi",
"Can use the messaging system" => "Haki ya kutumia mfumo wa ujumbe",
"Can admin newsletters" => "Haki ya kusimamia majarida",
"Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)" => "Haki ya kuwasilisha anwani za barua pepe kwa kila kundi (inahitaji email ya tiki_p_subscribe)",
"Can send newsletters" => "Haki ya kutuma majarida",
"Can subscribe any email address to newsletters" => "Haki ya kujiandikisha anwani yoyote ya barua pepe kwenye majarida",
"Can subscribe to newsletters" => "Haki ya kujiunga na majarida",
"Can view the archive of a newsletters" => "Haki ya kuona kumbukumbu za jarida",
"Can list newsletters" => "Haki ya kuorodhesha majarida",
"Can administer payments" => "Haki za kusimamia malipo",
"Can view payment requests and details" => "Haki ya kuona maombi ya malipo na maelezo",
"Can enter manual payments" => "Haki ya kuingia malipo ya mwongozo",
"Can request a payment" => "Haki ya kuomba malipo",
"Can view the perspective" => "Haki ya kuona mtazamo",
"Can edit the perspective" => "Haki ya kuhariri mtazamo",
"Can create a perspective" => "Haki ya kujenga mtazamo",
"Can admin perspectives" => "Haki za kusimamia mtazamo",
"Can admin polls" => "Haki ya kusimamia uchaguzi",
"Can view poll results" => "Haki ya kuona matokeo ya uchaguzi",
// "Can view poll user choices" => "Can view poll user choices",
"Can vote in polls" => "Haki ya kupiga kura kwenye uchaguzi",
"Can view poll voters" => "Haki ya kuona wapiga kura wa uchaguzi",
"Can admin quizzes" => "Haki ya kusimamia dodoso",
"Can take quizzes" => "Haki ya kujaza maswali katika dodoso",
"Can view quiz stats" => "Haki ya kuona takwimu za dodoso",
"Can view user quiz results" => "Haki ya kuona matokeo ya dodoso",
"Can admin spreadsheets" => "Haki ya kusimamia ma spreadsheets",
"Can create and edit spreadsheets" => "Haki ya kuunda na kuhariri ma spreadsheets",
"Can view spreadsheets" => "Haki ya kuona ma spreadsheets",
"Can view spreadsheets history" => "Haki ya kuona historia za spreadsheets",
"Can admin the shoutbox (edit/remove messages)" => "Haki ya kusimamia shoutbox (Hariri/Kufuta ujumbe)",
"Can post messages in the shoutbox" => "Haki ya kuchapisha ujumbe kwenye shoutbox",
"Can view the shoutbox" => "Haki ya kuona shoutbox",
"Can use social network integration" => "mtumiaji anaweza kutumia ushirikiano wa mitandao ya kijamii",
// "Can register this site with social networks" => "Can register this site with social networks",
"Admin live support system" => "Haki ya kusimamia Mfumo wa Usaidizi (Online)",
"Can use live support system" => "Haki ya kutumia mfumo wa usaidizi (Online)",
"Can admin surveys" => "Haki ya kusimamia uchunguzi",
"Can take surveys" => "Haki ya kufanya uchunguzi",
"Can view survey stats" => "Haki ya kuona takwimu za uchunguzi",
"Can admin TikiTests" => "Haki ya kusimamia TikiTests",
"Can edit TikiTests" => "Haki ya kuhariri TikiTests",
"Can replay TikiTests" => "Haki ya kurejesha TikiTests",
"Can admin trackers" => "Haki ya kuongoza trackers",
"Can attach files to tracker items" => "Haki ya kuunganisha faili kwenye vitu vya tracker",
"Can view tracker item attachments and download them" => "Haki ya kuona vifungo vya kipengee cha tracker na kuzipakua",
"Can post tracker item comments" => "Haki ya kuchapisha maoni ya vitu vya tracker",
"Can view tracker item comments" => "Haki ya kuona maoni ya vitu vya tracker",
"Can create new tracker items" => "Haki ya kuunda vitu vipya vya tracker",
"Can list trackers" => "Haki ya kuorodhesha ya trackers",
"Can change tracker items" => "Haki ya kubadilisha vitu vya tracker",
"Can change pending tracker items" => "Haki ya kubadilisha vitu vinavyotumiwa kwa tracker",
"Can change closed tracker items" => "Haki ya kubadilisha vitu vya tracker vilivyofungwa",
"Can remove tracker items" => "Haki ya kuondoa vitu vya tracker",
"Can remove pending tracker items" => "Haki ya kuondoa vipengee vya tracker vinavyotumiwa",
"Can remove closed tracker items" => "Haki ya kuondoa vitu vya tracker vilivyofungwa",
"Can view rating result for tracker items" => "Haki ya kuona matokeo ya usawa kwa vitu vya tracker",
"Can rate tracker items" => "Haki ya kuandika karatasi za tracker",
"Can re-rate tracker items" => "Haki ya kupiga kura tena kwa kipengele cha tracker",
"Can view trackers" => "Haki ya kuona tracker",
"Can view closed trackers items" => "Haki ya kuona vitu vya tracker vilivyofungwa",
"Can view pending trackers items" => "Haki ya kuona vipengele vya tracker vinavyotumiwa",
"Can watch a tracker" => "Haki ya kuona tracker",
"Can export tracker items" => "Haki ya kuuza nje vitu vya tracker",
"Can save a CSV backup of all trackers" => "Haki ya kuhifadhi trackers zote kwenye muundo wa CSV",
// "Manage tracker views" => "Manage tracker views",
// "View list view of tracker tabular data. Tracker item permissions apply" => "View list view of tracker tabular data. Tracker item permissions apply",
// "Export a tracker tabular view to CSV. Tracker permissions may not apply" => "Export a tracker tabular view to CSV. Tracker permissions may not apply",
// "Import a CSV file into a tabular tracker. Tracker permissions may not apply" => "Import a CSV file into a tabular tracker. Tracker permissions may not apply",
"Can trigger the transition between two states" => "Haki ya kusababisha mabadiliko kati ya hali mbili",
"Can admin users" => "Haki ya kusimamia watumiaji",
"Can cache user bookmarks" => "Haki ya kuongeza vifungo katika cache",
"Can configure modules" => "Haki ya kusanidi moduli",
"Can create user bookmarks" => "Haki ya kuunda bookmarks za mtumiaji",
"Can use the mini event calendar" => "Haki ya kutumia kalenda ya tukio za kidogo",
"Can use the notepad" => "Haki ya kutumia kitovu",
"Can admin public tasks" => "Haki ya kusimamia kazi za umma",
"Can use tasks" => "Haki ya kutumia kazi",
"Can receive tasks from other users" => "Haki ya kupokea kazi kutoka kwa watumiaji wengine",
"Can send tasks to other users" => "Haki ya kutuma kazi kwa watumiaji wengine",
"Can upload personal files" => "Haki ya kupakia faili za kibinafsi",
"Can create items in personal menu" => "Haki ya kuunda vitu vya orodha vya kibinafsi",
"Can list registered users" => "Haki ya kuorodhesha watumiaji waliosajiliwa",
"Can invite users by email, and include them in groups" => "Haki ya kukaribisha watumiaji kwa barua pepe, na kuifanya kwa vikundi",
"Can delete his/her own account" => "Haki ya kufuta akaunti ya mtu mwenyewe",
"Can use webmail" => "Haki ya kutumia webmail",
"Can use group webmail" => "Haki ya kutumia kikundi cha webmail",
"Can admin group webmail accounts" => "Haki ya kusimamia akaunti ya kikundi cha webmail",
"Can use personal webmail accounts" => "Haki ya kutumia akaunti binafsi za webmail",
"Can admin personal webmail accounts" => "Haki ya kusimamia akaunti za kibinafsi za webmail",
"Can view page/pages" => "Haki ya kuona ukurasa ya Wiki",
"Can edit pages" => "Haki ya kurekebisha za kurasa za Wiki",
// "Can inline-edit pages" => "Can inline-edit pages",
"Can view wiki history" => "Haki ya kuona historia ya kurasa za Wiki",
"Can admin the wiki" => "Haki ya kusimamia Wiki",
"Can assign permissions to wiki pages" => "Haki ya kupewa ruhusa kwa kurasa za Wiki",
"Can edit copyright notices" => "Haki ya kuhariri ujumbe wa copyright",
"Can edit dynamic variables" => "Haki ya kubadilisha vigezo vya kubadilisha",
"Can export wiki pages using the export feature" => "Haki ya kutuma mahali pengine kurasa za wiki na utendaji wa kutuma mahali pengine",
"Can lock pages" => "Haki ya kufunga kurasa",
"Can save as a minor edit" => "Haki ya kujiandikisha kama toleo la madogo",
"Can remove" => "Haki ya kufuta kurasa za Wiki",
"Can rename pages" => "Haki ya kubadilisha jina za kurasa",
"Can roll back pages" => "Haki ya kurudi kwenye matoleo ya awali",
"Can upload pictures to wiki pages" => "Haki ya kutuma picha kwenye kurasa za Wiki",
// "Can use the page as a template for a tracker or unified search" => "Can use the page as a template for a tracker or unified search",
"Can view in module and feed the wiki pages reference" => "Haki ya kutazama ukurasa wa Wiki katika modules na feeds",
"Can admin attachments on wiki pages" => "Haki ya kuagiza vifungo kwenye kurasa za Wiki",
"Can add and change ratings on wiki pages" => "Haki ya kuongeza na hariri maelezo yanayohusiana na kurasa za Wiki",
"Can attach files to wiki pages" => "Haki ya kuunganisha faili kwenye kurasa za Wiki",
"Can view and download wiki page attachments" => "Haki ya kuona viambatanisho kwenye kurasa za Wiki na kuzipakua",
"Can view wiki comments" => "Haki ya kuona maoni yanayohusiana na kurasa za Wiki",
"Can view rating of wiki pages" => "Haki ya kuona vyeo vya kurasa za Wiki",
"Can view source of wiki pages" => "Haki ya kuona chanzo cha kurasa za Wiki",
"Can participate in rating of wiki pages" => "Haki ya kushiriki katika kurasa za kuingia kwenye Wiki",
"Can view similar wiki pages" => "Haki ya kuona kurasa za wiki ambayo ni sawa",
"View page backlinks" => "Haki ya kuona backlinks",
"Can view unapproved revisions of pages" => "Haki ya kuona mabadiliko yasiyothibitishwa kwenye kurasa",
"Can approve revisions of pages" => "Haki ya kupitisha mabadiliko ya ukurasa",
"Can view contributions to a page" => "Haki ya kuona michango kwenye ukurasa",
// "Can use reference library items" => "Can use reference library items",
// "Can add to, edit and remove reference library items" => "Can add to, edit and remove reference library items",
// "Can administer structures" => "Can administer structures",
"Can create and edit structures" => "Haki ya kuunda na kuhariri miundo",
// "Can lock structures" => "Can lock structures",
"Can watch structures" => "Haki ya kuona miundo",
"Administrator can manage users, groups and permissions and all features" => "Msimamizi anaweza kusimamia watumiaji, makundi, haki na vipengele vyote",
"Can access site when closed" => "Haki ya kufikia tovuti wakati imefungwa",
"Administrator can admin banners" => "Msimamizi anaweza kusimamia mabango",
"Can ban users or IP addresses" => "Haki ya kupiga marufuku watumiaji au anwani za IP",
"Can admin the dynamic content system" => "Haki ya kusimamia mfumo wa maudhui ya kubadilika pekee",
"Can admin integrator repositories and rules" => "Haki ya kusimamia ushirikiano wa Tiki na sheria",
// "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n" => "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n",
"Can admin mail-in accounts" => "Haki ya kusimamia akaunti za mail-in",
"Can edit object permissions" => "Haki ya kubadilisha idhini ya vitu",
"Can admin external feeds" => "Haki ya kusimamia feeds za nje",
"Can clean cache" => "Haki ya kufuta cache",
"Can create a new CSS file (style sheet) appended with -user" => "Haki ya kuunda css ikifuatwa na -user",
"Can remove the association between two pages in a translation set" => "Haki ya kufuta chama kati ya kurasa za mchezo wa kutafsiri",
"Can admin cookies" => "Haki ya kuendesha kuki",
"Can edit translations and create new languages" => "Haki ya kubadilisha tafsiri na kuongeza lugha mpya",
"Can edit menus" => "Haki ya kurekebisha menyu",
"Can edit menu options" => "Haki ya kubadilisha chaguzi za menyu",
"Can edit site templates" => "Haki ya kurekebisha templates za tovuti",
"Can search" => "Haki ya kutafuta",
"Can report a link to the webmaster" => "Haki ya kuripoti kiungo kwa msimamizi wa tovuti",
"Can send a link to a friend" => "Haki ya kutuma kiungo kwa rafiki",
"Can share a page (email, Twitter, Facebook, message, forums)" => "Haki ya kushiriki ukurasa (barua pepe, Twitter, Facebook, ujumbe, vikao)",
"Can use HTML in pages" => "Haki ya kutumia HTML code katika kurasa",
"Can view action log" => "Haki ya kuona jarida la vitendo",
"Can view the action log for users of his or her groups" => "Haki ya kuona gazeti la hatua kwa makundi yake",
"Can view integrated repositories" => "Haki ya kusoma kwenye repositories vya ushirikiano",
// "Can view results from user ratings" => "Can view results from user ratings",
"Can view referrer stats" => "Haki ya kuona takwimu za kurasa za kutaja",
"Can view site stats" => "Haki ya kuona takwimu za tovuti",
"Can view site templates" => "Haki ya kuona mifano ya tovuti",
// "Can view results from webservice requests" => "Can view results from webservice requests",
// "Can administer webservices" => "Can administer webservices",
"Can admin toolbars" => "Haki ya kusimamia toolbars",
"Trust all user inputs including plugins (no security checks)" => "Tuma pembejeo la mtumiaji ikiwa ni pamoja na plugins (hakuna hundi ya usalama)",
"Can view unapproved plugin details" => "Haki ya kuona maelezo ya plugins zisizoidhinishwa",
"Can execute unapproved plugin registered" => "Haki ya kuendesha plugins zisizoidhinishwa zimehifadhiwa",
"Can approve plugin execution" => "Haki ya kuidhinisha utekelezaji wa plugins",
"Can admin mail notifications" => "Haki ya kusimamia arifa za barua pepe",
"Can use the importer" => "Haki ya kutumia muingizaji",
"Can change the categories of an object" => "Haki ya kubadili kikundi cha kitu",
"User can administer modules" => "Haki ya kusimamia modules",
"Can switch between wiki and WYSIWYG modes while editing" => "Haki ya kubadili kati ya wiki na njia za WYSIWYG wakati wa kuhariri",
// "Can create a new workspace for a given template" => "Can create a new workspace for a given template",
// "Can manage all aspects of a goal" => "Can manage all aspects of a goal",
// "Can manage who is eligible for a goal" => "Can manage who is eligible for a goal",
// "Cannot add user %0 to nonexistent group %1" => "Cannot add user %0 to nonexistent group %1",
// "Cannot add nonexistent user %0 to group %1" => "Cannot add nonexistent user %0 to group %1",
"User \"%0\" is banned from the group \"%1\"" => "Mtumiaji \"%0\" ni marufuku kutoka kikundi \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
// "Email cannot be set because this email is already in use by another user" => "Email cannot be set because this email is already in use by another user",
// "Password should be at least %0 characters long" => "Password should be at least %0 characters long",
"Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"" => "Neno la siri lazima liwe na angalau moja ya alama ya chini ya alpha kama vile 'a' na upeo mmoja kama 'A'",
"Password must contain both letters and numbers" => "Nywila lazima iwe na maandiko na namba",
"Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Neno la siri lazima liwe na angalau tabia moja maalum katika chini kama \" / \$ % ? & * ( ) _ + ..",
// "The password is blacklisted because it is too common" => "The password is blacklisted because it is too common",
// "No user tracker found with id #%0" => "No user tracker found with id #%0",
"The administrator has not yet validated your account. Please wait." => "Msimamizi bado hajahakikishia akaunti yako. Tafadhali subiri.",
"You must validate your account first. An email has been sent to you" => "Lazima uhakikishe kwanza akaunti yako. Barua pepe ilipelekwa kwako",
// "Email address is required" => "Email address is required",
// "Invalid email address \"%0\"" => "Invalid email address \"%0\"",
// "Unable to send mail to invite \"%0\"" => "Unable to send mail to invite \"%0\"",
// "The email could not be retrieved from the IdP and is required" => "The email could not be retrieved from the IdP and is required",
// "The username could not be retrieved from the IdP and is required" => "The username could not be retrieved from the IdP and is required",
// "SAML Login failed. User not authenticated" => "SAML Login failed. User not authenticated",
"Can edit one's own forum posts" => "Haki ya kuunda makala yako ya jukwaa",
"The registration mail can't be sent. Contact the administrator" => "Ujumbe wa kuthibitisha hauwezi kutumwa. Wasiliana na msimamizi",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "Ujumbe wa usajili haikuweza kutumwa tangu hakuna salama ya barua imewekwa, na kipengele hiki kimezimwa",
"The user email confirmation can't be sent. Contact the administrator" => "Barua pepe ya kuthibitisha haiwezi kutumwa. Tafadhali wasiliana na msimamizi",
// "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)",
"Edit field: (Incorrect validation parameter)" => "Badilisha field: (Kipimo cha uthibitishaji si sahihi)",
"Page already exists" => "Ukurasa tayari upo",
"Page does not exist" => "Ukurasa haupo",
// "Email already in use" => "Email already in use",
"Invalid email" => "Anwani ya barua pepe isiyo sahihi",
"Invalid character combination for username" => "Mchanganyiko wa maandishi batili kwa jina la mtumiaji",
// "Username must be all lower case" => "Username must be all lower case",
"Personal Phone" => "Simu ya kibinafsi",
"Personal Mobile" => "Simu ya Mkono ya kibinafsi",
"Personal Fax" => "Fax ya kibinafsi",
"Work Phone" => "Simu ya Kazi",
"Work Mobile" => "Simu ya Mkono ya Kazi",
"Work Fax" => "Fax ya Kazi",
"Company" => "Kampuni",
"Organization" => "Shirika",
"Department" => "Idara",
"Division" => "Idara",
"Job Title" => "Jina la kazi",
"Street Address" => "Anuani ya mtaa",
"City" => "Mji",
"State" => "Nchi",
"Postal Code" => "msimbo wa posta",
// "Mail to: User not found" => "Mail to: User not found",
"(AT)" => "(KATIKA)",
"(DOT)" => "(DOT)",
// "Webservice error on %0 request \"%1\"" => "Webservice error on %0 request \"%1\"",
// "You will need to rebuild the search index to see these changes" => "You will need to rebuild the search index to see these changes",
// "Parse To Wiki %0: preg_replace error #%1" => "Parse To Wiki %0: preg_replace error #%1",
"Cannot create aliased page" => "Haiwezi kuunda alias ya ukurasa",
"You attempted to create the following page" => "Ulijaribu kuunda ukurasa unaofuata",
"That page is an alias for the following pages" => "Ukurasa huu ni alias ​​kwa kurasa zifuatazo",
"If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this" => "Ikiwa unataka kuunda ukurasa, lazima kwanza uhariri kila kurasa zilizo hapo juu, na uondoe viungo vya kila kitu ambavyo kila mmoja anaweza kuwa nacho. Kiungo hiki kinapaswa kuangalia kitu kama hiki",
"Can't parse HTML data - no grammar file" => "Haiwezi kubadilisha data ya HTML - hakuna faili ya sarufi",
"Rollback by %0 to version %1" => "Rudi kwenye toleo %1 na %0",
"Removed version \$version" => "Toleo \$version ilifutwa",
"Changed actual version to \$version" => "Toleo la sasa limebadilishwa hadi \$version",
"No version indicated" => "Hakuna matoleo yaliyoonyeshwa",
"Plugin " => "Plugin ",
"failed" => "imeshindwa",
"Required parameters are in</em> <b>bold</b>" => "Parameters vinavyohitajika viko </em> <b>bold</b>",
"Parameter Info" => "Maelezo ya parameters",
"There are no approved versions of this page" => "Hakuna matoleo yaliyothibitishwa ya ukurasa huu",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
"Page locked" => "Ukurasa uliofungwa",
"Page unlocked" => "Ukurasa uliopunguliwa",
// "Initial content copied from version %0 of page %1" => "Initial content copied from version %0 of page %1",
// "You don't have permission to use category '%0'" => "You don't have permission to use category '%0'",
// "You don't have permission to edit categories" => "You don't have permission to edit categories",
// "You don't have permission to edit tags" => "You don't have permission to edit tags",
"Removed last version" => "Toleo la hivi karibuni limeondolewa",
// "Activity Stream" => "Activity Stream",
// "Create a social network activity stream" => "Create a social network activity stream",
// "List configuration information" => "List configuration information",
// "Auto-Scroll" => "Auto-Scroll",
// "Automatically load next page of results when scrolling down" => "Automatically load next page of results when scrolling down",
"Add Tag" => "Ongeza Tag",
// "Provide an input field for adding a tag to an object" => "Provide an input field for adding a tag to an object",
// "Object type and id, as in %0type:id%1, if unset, will use current object" => "Object type and id, as in %0type:id%1, if unset, will use current object",
// "Add Reference" => "Add Reference",
// "Add a bibliography reference" => "Add a bibliography reference",
// "Biblio Code" => "Biblio Code",
// "The code to be added as reference" => "The code to be added as reference",
// "missing bibliography definition" => "missing bibliography definition",
"Add Relation" => "Ongeza Uhusiano",
// "Provide a button to toggle a pre-specified relation" => "Provide a button to toggle a pre-specified relation",
"Qualifier" => "Msingi",
"Relation qualifier. Usually a three-part string separated by two periods" => "Msingi wa uhusiano. Kwa kawaida kamba ya sehemu tatu iliyotengwa na pointi viwili",
"Source Object" => "Chanzo ya kitu",
// "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank",
"Target Object" => "Kitu kama lengo",
// "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank",
"Button Text for Add" => "Maandishi ya kifungo ya kuongeza",
"Text to show on the button to add relation" => "Maandishi ya kuonyesha kwenye kifungo ili kuongeza uhusiano",
"Button Text for Already Added State" => "Maandishi ya kifungo ya uhusiano tayari imeongezwa",
"Text to show on the button when relation is already added" => "Maandishi ya kuonyesha kwenye kifungo wakati uhusiano umeongezwa tayari",
"Relation Added" => "Uhusiano uliongezwa",
"Mouseover Button Text for Remove" => "Maandishi wakati ya mouseover ya kifungo ya kufuta",
"Text to show on the button to remove relation" => "Maandishi ya kuonyesha kwenye kifungo ili kuondoa uhusiano",
"Remove Relation" => "Ondoa Uhusiano",
"Button ID" => "Kitambulisho cha kifungo",
"A unique ID to distinguish the button from others on the page if there is more than one" => "Kitambulisho cha kipekee cha kutofautisha kifungo kama wengine walipo kwenye ukurasa",
// "Set Button Class" => "Set Button Class",
// "Class or classes for the Button" => "Class or classes for the Button",
"Source and target object cannot be the same" => "Chanzo na lengo haliwezi kufanana",
"Add to cart" => "Ongeza kwenye gari",
"PluginAddToCart" => "PluginAddToCart",
// "Add a product to the shopping cart" => "Add a product to the shopping cart",
"Product code" => "Msimbo wa Bidhaa",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
"Product Type" => "Aina ya Bidhaa",
// "The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to. Can be used to limit how gift cards are used" => "The class the product belongs to. Can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart" => "The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to. Can be used to limit how gift cards are used" => "The class the bundle belongs to. Can be used to limit how gift cards are used",
"Price" => "Bei",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)" => "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)",
"Button label" => "Jina la kifungo",
// "Text for the submit button. default" => "Text for the submit button. default",
"Associated event code" => "Kanuni ya tukio lililohusishwa",
"Unique identifier for the event that is associated to the product" => "Kitambulisho cha kipekee cha tukio linalohusishwa na bidhaa",
"Automatically check out" => "Badilisha moja kwa moja",
"Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)" => "Badilisha moja kwa moja ununuzi na uelekeze mtumiaji kulipa (hii imezimwa ikiwa kuna kitu tayari katika gari)",
// "Hide Quantity" => "Hide Quantity",
// "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)" => "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)",
"Buy on behalf of" => "Nunua kwa niaba ya",
"Allows the selection of user to make purchase on behalf of" => "Inaruhsu uteuzi wa mtumiaji kufanya ununuzi kwa niaba ya",
// "Shop as anonymous always" => "Shop as anonymous always",
"Add to cart as anonymous shopper even if logged in" => "Ongeza kwenye gari kama shopper isiyojulikana hata ikiwa umeingia",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
"Gift certificate" => "Cheti chawadi",
"Allows user to add gift certificate from the product view" => "Inaruhusu mtumiaji kuongeza cheti chawadi kutokana na mtazamo wa bidhaa",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
"Amount of new product to exchange for" => "Kiasi cha bidhaa mpya ya kubadilishana",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
"Ajax add to cart feature" => "Ajax inaongeza kipengele cha gari",
"Attempts to turn on Ajax for the cart" => "Majaribio ya kurejea Ajax kwa gari",
"Weight" => "Uzito",
// "The weight of the item" => "The weight of the item",
"The order was recorded and is now awaiting payment. Reference number is %0" => "Utaratibu umeandikwa na sasa unasubiri malipo. Nambari ya kumbukumbu ni %0",
"Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Utaratibu wako wa bure wa %0 (%1) umechukuliwa. Barua pepe imetumwa kwako kwa rekodi zako",
"Your free order of %0 (%1) has been processed" => "Utaratibu wako wa bure wa %0 (%1) umechukuliwa",
"%0 (%1) was added to your cart" => "%0 (%1) iliongezwa kwenye gari lako",
"Add to Google Calendar" => "Ongeza kwenye Kalenda ya Google",
"Add a calendar item to a Google calendar" => "Ongeza kipengee cha kalenda kwenye kalenda ya Google",
"Calendar item ID" => "Nambari ya kipengee cha Kalenda",
"The item ID of the calendar to add to Google calendar" => "Kitambulisho cha kipengee cha kalenda ili kuongeza kalenda ya Google",
"A calendar item ID number" => "Nambari ya ID ya kipengee cha kalenda",
"Icon Style" => "Icon Sinema",
"Choose the icon style" => "Chagua mtindo wa ishara",
"Either 1, 2 or 3" => "Ingawa 1, 2 au 3",
"Adjust Inventory" => "Badilisha Marekebisho",
"PluginAdjustInventory" => "PluginAdjustInventory",
// "Adjust the inventory level of a product" => "Adjust the inventory level of a product",
"Product ID" => "Kitambulisho cha Bidhaa",
"Product ID of item in the cart tracker" => "Kitambulisho cha bidhaa cha kipengee kwenye tracker ya gari",
// "Show Add" => "Show Add",
// "Show option to add to inventory" => "Show option to add to inventory",
// "Show Subtract" => "Show Subtract",
// "Show option to subtract from inventory" => "Show option to subtract from inventory",
"Inventory was adjusted by %0" => "Malipo yalibadilishwa na %0",
"User Agent Info" => "Info Agent ya Mtumiaji",
// "Show the user's browser and server information" => "Show the user's browser and server information",
"Info" => "Maelezo",
"Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Kuonyesha anwani ya IP ya mgeni (IP au default), habari ya kivinjari (BROWSER), au programu ya seva (SVRSW)",
"IP address" => "IP address",
"Server software" => "Programu ya seva",
"Browser" => "Kivinjari",
// "Ajax Load" => "Ajax Load",
// "Load data into an HTML div using Ajax or in an iframe" => "Load data into an HTML div using Ajax or in an iframe",
// "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML" => "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML",
// "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1" => "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1",
// "Selector" => "Selector",
// "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1" => "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1",
"Target" => "Lengo",
// "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page" => "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page",
// "HTML id for the div or iframe" => "HTML id for the div or iframe",
// "Class for the div or iframe" => "Class for the div or iframe",
// "In pixels or percentage. Default value is %0" => "In pixels or percentage. Default value is %0",
// "Make Links Absolute" => "Make Links Absolute",
// "Convert relative links in the incoming data to be absolute. Default value is \"All\"" => "Convert relative links in the incoming data to be absolute. Default value is \"All\"",
// "Images Only" => "Images Only",
// "Links Only" => "Links Only",
// "Parameter URL missing" => "Parameter URL missing",
"Anchor Link" => "Kiungo cha Anchor",
"Create a link to an anchor" => "Unda kiungo kwa nanga",
"Anchor link label" => "Weka alama ya kiungo ya nanga",
"Anchor Name" => "Jina la Anchor",
"The anchor name as defined in the Aname plugin" => "Jina la nanga kama ilivyoelezwa kwenye Plugin ya Aname",
"The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "Jina la ukurasa wa wiki unao nanga. Ikiwa tupu, jina la nanga hutafutwa kwenye ukurasa wa wiki ambako Plugin hutumiwa",
"Create an anchor that can be linked to" => "Unda nanga ambayo inaweza kuunganishwa na",
"The name of the anchor" => "Jina la nanga",
"Image Annotation" => "Annotation ya picha",
"Annotate an image" => "Annotate picha",
"Autogenerated content. Leave blank initially" => "Maudhui yaliyothibitishwa. Acha tupu awali",
// "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0" => "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0",
// "Absolute URL to the image or relative path from Tiki site root" => "Absolute URL to the image or relative path from Tiki site root",
"Image width in pixels" => "Upana wa picha katika saizi",
"Image height in pixels" => "Urefu wa picha katika saizi",
"Alignment" => "Mpangilio",
// "Image alignment" => "Image alignment",
"Center" => "Kituo",
"CSS Class" => "CSS Hatari",
// "Class of the containing DIV element" => "Class of the containing DIV element",
// "Show List" => "Show List",
// "Show the list of annotations below the image" => "Show the list of annotations below the image",
// "(y/n)" => "(y/n)",
"Show Link" => "Onyesha Kiungo",
// "Show the link below the label in the popups" => "Show the link below the label in the popups",
"Save changes to annotations" => "Hifadhi mabadiliko kwenye maelezo",
"Image annotations changed" => "Maelezo ya picha yamebadilishwa",
"Editable" => "Badilisha",
"Label" => "Lebo",
// "Application Frame" => "Application Frame",
// "Create a frame in which to assemble custom applications" => "Create a frame in which to assemble custom applications",
// "Application layout" => "Application layout",
// "Minimum height" => "Minimum height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Maximum height" => "Maximum height",
// "Prevent the frame from becoming any higher than the specified size" => "Prevent the frame from becoming any higher than the specified size",
"Hide left column" => "Ficha safu ya kushoto",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
"Hide right column" => "Ficha safu ya kulia",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Completely fill the content area of the page" => "Completely fill the content area of the page",
// "Absolute Position" => "Absolute Position",
// "Use all available space for the application frame (by means of CSS absolute positioning)" => "Use all available space for the application frame (by means of CSS absolute positioning)",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Fill the complete page" => "Fill the complete page",
// "Template file not found: %0" => "Template file not found: %0",
"Pan/Zoom" => "Piga/Zoom",
"Select" => "Chagua",
"Select/Modify" => "Chagua/Kurekebisha",
"Draw Polygon" => "Chora Pigoni",
"Draw Path" => "Chora Njia",
"Reset Zoom" => "Weka upya Zoom",
"Archive Builder" => "Mjenzi wa Kumbukumbu",
// "Define an archive that can be downloaded" => "Define an archive that can be downloaded",
"Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Maelezo ya maudhui ya kumbukumbu. Wafanyakazi wengi hupatikana kwa aina ya maudhui. Moja kwa kila mstari. Ex: ukurasa-as-pdf: baadhi ya folda / foo.pdf: HomePage, attachments-attachments: lengo-folder /: 3435",
"Archive Name" => "Jina la Kumbukumbu",
"Upon download, the name of the file that will be provided" => "Baada ya kupakuliwa, jina la faili ambayo itatolewa",
"Missing \".zip\" file name extension" => "Inapoteza \".zip\" ugani wa jina la faili",
"Incorrect parameter" => "Kipimo kisicho sahihi",
"Download archive" => "Pakua kumbukumbu",
"Display a field of an article" => "Onyesha uwanja wa makala",
"The article field (component) to display. The default field is \"Heading\"" => "Sehemu ya makala (sehemu) ya kuonyesha. Eneo la msingi ni \"kichwa\"",
"Article ID" => "Kitambulisho cha Makala",
"The article to display. If no value is provided, the most recent article will be used" => "Makala ya kuonyesha. Ikiwa hakuna thamani inayotolewa, makala ya hivi karibuni itatumika",
"Article List" => "Orodha ya Makala",
"Display multiple articles" => "Onyesha makala nyingi",
"Use Pagination" => "Tumia Pagination",
// "Activate pagination when the articles list is long. Default is %0" => "Activate pagination when the articles list is long. Default is %0",
"Maximum Displayed" => "Upeo umeonyeshwa",
// "The number of articles to display in the list (use %0 to show all)" => "The number of articles to display in the list (use %0 to show all)",
"Topic Name Filter" => "Jina la kichwa cha Filter",
"Filter the list of articles by topic. Example: " => "Futa orodha ya makala kwa mada. Mfano:",
"Topic ID Filter" => "Ficha ya Kitambulisho cha Mada",
"Filter the list of articles by topic ID. Example: " => "Futa orodha ya makala na ID ya mada. Mfano:",
// "Valid topic IDs" => "Valid topic IDs",
"Type Filter" => "Fanya Filter",
"Filter the list of articles by types. Example: " => "Futa orodha ya makala kwa aina. Mfano: ",
// "Valid article types" => "Valid article types",
"Category ID" => "Kitambulisho cha Jamii",
// "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted" => "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted",
"List only articles in this language" => "Andika orodha tu katika lugha hii",
// "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items" => "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items",
// "random or column names to add _asc _desc to: " => "random or column names to add _asc _desc to: ",
"Specific order" => "Utaratibu maalum",
"List of ArticleId that must appear in this order if present" => "Orodha ya MakalaId ambayo inapaswa kuonekana kwa utaratibu huu ikiwa iko",
"Only these articles" => "Nyaraka hizi tu",
// "List of article IDs to display, separated by \"%0\"" => "List of article IDs to display, separated by \"%0\"",
"Not these articles" => "Si makala hizi",
// "List of article IDs to not display, separated by \"%0\"" => "List of article IDs to not display, separated by \"%0\"",
"Quiet" => "Sala",
"Whether to not report when there are no articles (no reporting by default)" => "Usipotiri wakati hakuna makala (hakuna taarifa kwa default)",
"Title Only" => "Kichwa tu",
"Whether to only show the title of the articles (not set to title only by default)" => "Ikiwa inaonyesha tu kichwa cha makala (sio kuweka kichwa tu kwa chaguo-msingi)",
"Show Article Body" => "Onyesha Kifungu Mwili",
// "Whether to show the body of the articles instead of the heading (not set by default)" => "Whether to show the body of the articles instead of the heading (not set by default)",
"Starting Article" => "Ibara ya Kuanzia",
// "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)" => "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)",
"This will not work if Pagination is used" => "Hii haiwezi kufanya kazi ikiwa Pagination inatumiwa",
"Start Date" => "Tarehe ya Mwanzo",
"Earliest date to select articles from" => "Tarehe ya mwanzo ili kuchagua makala kutoka",
// " (%0YYYY-MM-DD%1)" => " (%0YYYY-MM-DD%1)",
"Latest date to select articles from" => "Tarehe ya mwisho ya kuchagua makala kutoka",
"Period quantity" => "Kipindi cha muda",
// "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored" => "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored",
"Period unit" => "Kitengo cha muda",
"Time unit used with \"Period quantity\"" => "Kitengo cha wakati kilichotumiwa na \"Kipindi cha muda\"",
"Override Dates" => "Dhairi za Tarehe",
// "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)" => "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)",
"Containing class" => "Ina darasa",
// "CSS class to add to the containing \"div.article\" (default: \"%0\")" => "CSS class to add to the containing \"div.article\" (default: \"%0\")",
// "Valid CSS class" => "Valid CSS class",
"Large First Image" => "Picha ya kwanza ya kwanza",
// "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article" => "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article",
"Additional URL parameter for the link to read the article" => "Kipimo cha ziada cha URL cha kiungo ili kusoma makala",
"Show actions (buttons and links)" => "Onyesha vitendo (vifungo na viungo)",
// "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do",
"No translation" => "Hakuna tafsiri",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language",
// "Use Source URL" => "Use Source URL",
// "Use the external source URL as link for articles" => "Use the external source URL as link for articles",
// "Display an attachment or a list of them" => "Display an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment",
"File" => "Faili",
"Same as name" => "Jina sawa",
// "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page",
"Show Description" => "Onyesha Maelezo",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
"Bullets" => "Vipande",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)",
"Custom Label" => "Lebo maalum",
// "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed" => "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)",
"Order Number" => "Idadi ya Nambari",
// "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment",
// "Attachment name, file, id or num" => "Attachment name, file, id or num",
// "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)",
"File Type Icon" => "Icon ya Aina ya faili",
// "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)" => "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)",
"Page \"%0\" does not exist" => "Ukurasa \"%0\" haipo",
"No such attachment on this page" => "Hakuna attachment kama hiyo kwenye ukurasa huuHakuna attachment kama hiyo kwenye ukurasa huu",
"Attributes" => "Sifa",
"Assign generic attributes to the current object" => "Weka sifa za kawaida kwa kitu cha sasa",
// "Add popups and color coding that identifies authors" => "Add popups and color coding that identifies authors",
"Username of the author of the text" => "Jina la mtumiaji wa mwandishi wa maandiko",
"Deleted by User" => "Imefutwa na Mtumiaji",
"Username of the person who deleted the text" => "Username of the person who deleted the text",
"Make Visible" => "Fanya wazi",
"Show popup with author/deleted by" => "Onyesha popup na mwandishi / kufutwa na",
"Generate a popup with names of author(s) (default: no)" => "Tengeneza popup na majina ya mwandishi (default) hapana)",
"deleted by" => "ilifutwa na",
"Should this author's contribution be visible (default: no)" => "Je, mchango wa mwandishi huyu lazima uwe wazi (default: hapana)",
// "Auto Query Args" => "Auto Query Args",
// "Automatically propagate arguments when clicking on links" => "Automatically propagate arguments when clicking on links",
// "Arguments for auto query" => "Arguments for auto query",
// "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin" => "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin",
"Profile picture" => "Picha ya Profile",
"Display a user's profile picture" => "Onyesha picha ya wasifu wa mtumiaji",
// "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page" => "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page",
"Float" => "Fungua",
"Align the profile picture on the page" => "Weka picha ya wasifu kwenye ukurasa",
// "Full Size" => "Full Size",
// "If full-size images are stored in the file gallery, show the full-size image" => "If full-size images are stored in the file gallery, show the full-size image",
"Back" => "Rudi",
// "Display a link that goes back one page in the browser history" => "Display a link that goes back one page in the browser history",
// "List all pages that link to a particular page" => "List all pages that link to a particular page",
"The page links will point to. Default value is the current page" => "Viungo vya ukurasa vitaonyesha. Thamani ya msingi ni ukurasa wa sasa",
"Displayed Information" => "Habari iliyoonyeshwa",
"Pipe separated list of fields to display. ex: hits|user" => "Pipe iliyojitenga orodha ya maeneo ya kuonyesha. ex: hits | mtumiaji",
"Excluded pages" => "Kurasa zisizochapishwa",
// "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1" => "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1",
"Include Self" => "Jumuisha Mwenyewe",
"With or without self-link (default is without)" => "Kwa au bila kiungo cha kibinafsi (chaguo-msingi haipo)",
"With or without header (default is with header)" => "Kwa au bila kichwa (default iko na kichwa)",
"With header" => "Kwa kichwa",
"Without header" => "Bila kichwa",
"No pages link to" => "Hakuna kurasa zilizounganishwa na",
"One page links to" => "Ukurasa mmoja unaunganisha",
"pages link to" => "kurasa zilizounganishwa na",
"Add a banner" => "Ongeza bendera",
"Zone" => "Eneo",
"Name of the zone created in Admin > Banners" => "Jina la eneo linaloundwa katika Admin> Mabango",
"Determines the browser behavior when the banner is clicked" => "Inatafuta tabia ya kivinjari wakati bendera imefungwa",
"missing parameter" => "kupoteza parameter",
// "Benchmark" => "Benchmark",
// "Performance-test wiki content (used by developers to optimize plugins)" => "Performance-test wiki content (used by developers to optimize plugins)",
// "Iteration Quantity" => "Iteration Quantity",
// "The number of iterations to process" => "The number of iterations to process",
// "Each Iteration Details" => "Each Iteration Details",
// "Provides time and memory of each iteration" => "Provides time and memory of each iteration",
"BigBlueButton" => "BigBlueButton",
// "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system" => "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system",
"Meeting" => "Mkutano",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1",
// "Anonymous Prefix" => "Anonymous Prefix",
"Unregistered users will get this token prepended to their name" => "Watumiaji wasiojiandikishwa watapata ishara hii iliyotayarishwa kwa jina lao",
"Welcome Message" => "Karibu Ujumbe",
"A message to be provided when someone enters the room" => "Ujumbe unapaswa kutolewa wakati mtu anaingia kwenye chumba",
"Dial Number" => "Nambari ya kupiga simu",
"The phone-in support number to join from traditional phones" => "Nambari ya usaidizi ya simu ili kujiunga na simu za jadi",
"Voice Bridge" => "Daraja la sauti",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID",
"Log-out URL" => "Ingiza URL",
"URL to which the user will be redirected after logging out of BigBlueButton" => "URL ambayo mtumiaji ataelekezwa baada ya kuingia nje ya BigBlueButton",
"Record" => "Rekodi",
// "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8" => "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8",
// "Display Recordings" => "Display Recordings",
// "Enable or Disable the display of video recordings" => "Enable or Disable the display of video recordings",
// "Display Attendees" => "Display Attendees",
// "Enable or Disable the display of attendees list" => "Enable or Disable the display of attendees list",
"BigBlueButton is misconfigured or inaccessible" => "BigBlueButton haijatikani au haipatikani",
"Blog List" => "Orodha ya Blog",
"Display posts from a site blog" => "Onyesha posts kutoka kwenye blogu ya tovuti",
"Blog ID" => "Kitambulisho cha blogu",
// "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown" => "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown",
"Maximum Items" => "Vipimo vingi",
"Maximum number of entries to list (no maximum set by default)" => "Idadi kubwa ya kuingia kwenye orodha (hakuna upeo uliowekwa na default)",
"Only display posts created by this user (all posts listed by default)" => "Tu kuonyesha machapisho yaliyoundwa na mtumiaji huyu (machapisho yote yameorodheshwa na default)",
"Simple List" => "Orodha rahisi",
// "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts" => "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts",
"Character Count" => "Hesabu ya Tabia",
// "Number of characters to display if not a simple list (defaults to all)" => "Number of characters to display if not a simple list (defaults to all)",
// "Word Boundary" => "Word Boundary",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only",
// "Ellipsis" => "Ellipsis",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)",
"More" => "chaguo zaidi",
// "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)",
// "Show Icons" => "Show Icons",
// "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)" => "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)",
// "Use Excerpt" => "Use Excerpt",
// "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)" => "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)",
"Earliest date to select posts from" => "Tarehe ya awali ili kuchagua machapisho kutoka",
"End Date" => "Tarehe ya mwisho",
"Latest date to select posts from" => "Tarehe ya mwisho ya kuchagua machapisho kutoka",
"Container Class" => "Darasa la Vyombo",
// "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)" => "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)",
// "Missing blog ID for Bloglist plugin" => "Missing blog ID for Bloglist plugin",
// "Create a formatted box with a title bar" => "Create a formatted box with a title bar",
// "Box Title" => "Box Title",
"Displayed above the content" => "Imeonyeshwa juu ya maudhui",
"As defined by CSS, name, or color hex code" => "Kama ilivyoelezwa na CSS, jina, au rangi ya hex code",
// "Valid CSS color name or code" => "Valid CSS color name or code",
// "Box Width" => "Box Width",
"Text Alignment" => "Nambari ya Alignment",
"Aligns the text within the box (left-aligned by default)" => "Inajumuisha maandishi ndani ya sanduku (kushoto iliyokaa na default)",
"Float Position" => "Hali ya Mafuriko",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)",
"Clear" => "Futa",
// "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)" => "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)",
"Apply custom CSS class to the box" => "Tumia darasa la CSS desturi kwenye sanduku",
"CSS Style" => "Sinema ya CSS",
// "Enter CSS styling tags for the div type used e.g. padding: 5px" => "Enter CSS styling tags for the div type used e.g. padding: 5px",
"Button" => "Button",
"Add a link formatted as a button" => "Ongeza kiungo kilichoboreshwa kama kifungo",
// "Label for the button (ignored if the text is defined)" => "Label for the button (ignored if the text is defined)",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it" => "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it",
"Label for the button" => "Andika alama kwa kifungo",
// "Icon Name" => "Icon Name",
// "Enter an iconset name to show an icon in the button" => "Enter an iconset name to show an icon in the button",
// "Button Type" => "Button Type",
// "Use a type to style the button. By default btn-primary will be applied" => "Use a type to style the button. By default btn-primary will be applied",
// "Danger" => "Danger",
// "Primary" => "Primary",
// "Button width" => "Button width",
// "In pixels or percentage. (e.g. 200px or 100%)" => "In pixels or percentage. (e.g. 200px or 100%)",
// "Button height" => "Button height",
// "CSS class for the button. Note that the btn class is always applied by default" => "CSS class for the button. Note that the btn class is always applied by default",
// "CSS style attributes" => "CSS style attributes",
// "Link Relation" => "Link Relation",
// "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation" => "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation",
// "Auto Arguments" => "Auto Arguments",
// "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter" => "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter",
// "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL" => "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL",
// "Flip Id" => "Flip Id",
// "HTML id attribute of the element to show/hide content" => "HTML id attribute of the element to show/hide content",
// "Flip Hide Text" => "Flip Hide Text",
// "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown" => "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown",
// "Flip Default Open" => "Flip Default Open",
// "If set to %0, the flip is open by default (if no cookie jar)" => "If set to %0, the flip is open by default (if no cookie jar)",
// "Escape Apostrophes" => "Escape Apostrophes",
// "If set to %0, will escape the apostrophes in onclick" => "If set to %0, will escape the apostrophes in onclick",
// "Disable Button" => "Disable Button",
// "Set to %0 to disable the button" => "Set to %0 to disable the button",
"lib/smarty_tiki/function.button.php is missing or unreadable" => "lib / smarty_tiki / function.button.php haipo au haijasomwa",
"Display a calendar and its events" => "Onyesha kalenda na matukio yake",
"Calendar IDs" => "Vitambulisho vya kalenda",
// "Comma-separated list of calendar Ids to restrict the events to specified calendars" => "Comma-separated list of calendar Ids to restrict the events to specified calendars",
"Example values" => "Mfano maadili",
"Not set by default" => "Haijawekwa na default",
"View Type" => "Tazama Aina",
// "Determines how events" => "Determines how events",
// "%0 (default) shows events in a calendar" => "%0 (default) shows events in a calendar",
"View Time Span" => "Angalia muda wa Span",
// "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar" => "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar",
"Default is month" => "Kipengee ni mwezi",
"Navigation Bar" => "Bar Navigation",
// "Show or hide the navigation bar (not shown by default)" => "Show or hide the navigation bar (not shown by default)",
"Carousel" => "Carousel",
"Display images in a self-advancing carousel" => "Onyesha picha katika jukwaa la kujitegemea",
// "Images Source" => "Images Source",
// "Choose where to get your images from" => "Choose where to get your images from",
"Select an option" => "Chagua chaguo",
// "All the images in a file gallery" => "All the images in a file gallery",
// "A list of file IDs" => "A list of file IDs",
"File Gallery ID" => "Faili ya Nyumba ya sanaa",
"ID number of the file gallery that contains the images to be displayed" => "Nambari ya ID ya nyumba ya sanaa iliyo na picha zinazoonyeshwa",
// "File IDs" => "File IDs",
// "List of IDs of images from the File Galleries separated by commas" => "List of IDs of images from the File Galleries separated by commas",
"Sort Mode" => "Sort Mode",
// "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2" => "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2",
// "Transition Time" => "Transition Time",
"The time (in milliseconds) for the transition between two images" => "Wakati (Katika milliseconds) kwa mpito kati picha mbili",
"number" => "nambari",
// "Display Time" => "Display Time",
"The time (in milliseconds) to display each image" => "Wakati (katika milliseconds) kuonyesha kila picha",
// "Caption Height" => "Caption Height",
"The height of the caption. This is a fraction of the height of the images" => "Urefu wa maelezo. Hii ni sehemu ya urefu wa picha",
"real between 0 and 1" => "halisi kati ya 0 na 1",
// "Display Progress Bar" => "Display Progress Bar",
// "Display Thumbnails" => "Display Thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
"Buttons" => "Buttons",
// "Numbers" => "Numbers",
// "Thumbnail Box Width" => "Thumbnail Box Width",
// "Width of thumbnail box in CSS units (default %0)" => "Width of thumbnail box in CSS units (default %0)",
// "Thumbnail Box Height" => "Thumbnail Box Height",
// "Height of thumbnail box in CSS units (default %0)" => "Height of thumbnail box in CSS units (default %0)",
// "Start Automatically" => "Start Automatically",
// "Start the carousel automatically when the page loads (default: Yes)" => "Start the carousel automatically when the page loads (default: Yes)",
// "Legacy v2 param" => "Legacy v2 param",
"Display thumbnails" => "Onyesha vidole",
// "Thumbnail Numbers" => "Thumbnail Numbers",
"Display place numbers in the thumbnail boxes" => "Onyesha nambari za mahali kwenye masanduku ya thumbnail",
// "Thumbnail Background" => "Thumbnail Background",
"Use corresponding image as background for a thumbnail box" => "Tumia picha sambamba kama historia ya sanduku la thumbnail",
// "Thumbnail Font Size" => "Thumbnail Font Size",
// "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)" => "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)",
// "CSS units" => "CSS units",
// "Image Size" => "Image Size",
// "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels" => "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels",
// "Real between 0 and 1, or integer over 10" => "Real between 0 and 1, or integer over 10",
// "Makes images clickable" => "Makes images clickable",
// "In case there are URLs in the image description, the image is made clickable and links to the first URL found" => "In case there are URLs in the image description, the image is made clickable and links to the first URL found",
"Cart Missing User Info" => "Hifadhi ya Wafanyabiashara ya Hifadhi",
"PluginCartMissingUserInfo" => "Plugin ya Cart Missing User Info",
// "Check completeness of user input for a shopping cart transaction" => "Check completeness of user input for a shopping cart transaction",
// "Information Type" => "Information Type",
"Post Purchase" => "Ununuzi wa Chapisho",
"Required before purchase" => "Inahitajika kabla ya kununua",
"Product Class ID" => "ID ya Hatari ya Bidhaa",
// "CasperJS" => "CasperJS",
// "Enable running CasperJS scripts from this Tiki site" => "Enable running CasperJS scripts from this Tiki site",
// "CasperJS not available" => "CasperJS not available",
// "Execute CasperJS script" => "Execute CasperJS script",
"List categories and objects assigned to them" => "Weka makundi na vitu ambazo zimepewa",
"Category IDs" => "Vitambulisho vya Jamii",
// "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page" => "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page",
"Types" => "Aina",
// "List of object types to include in the list, separated by \"+\", for example, " => "List of object types to include in the list, separated by \"+\", for example, ",
// "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)" => "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)",
"Hits Ascending" => "Inakaribia Kushuka",
"Hits Descending" => "Hits Inashuka",
"Item ID Ascending" => "Kitambulisho cha Injili kinaongezeka",
"Item ID Descending" => "Kitambulisho cha Nambari kinachopungua",
"Type Ascending" => "Weka Kupanda",
"Type Descending" => "Weka Kupungua",
"Random" => "Random",
"Split" => "Split",
"Whether multiple categories will be listed on different lines (default is to split them)" => "Ikiwa makundi mengi yataorodheshwa kwenye mistari tofauti (default ni kugawanya)",
"And" => "Na",
// "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)" => "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)",
// "Sub-categories" => "Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)",
"Show descriptions (not shown by default)" => "Onyesha maelezo (yasionyeshwa kwa default)",
"Show object names (shown by default)" => "Onyesha majina ya kitu (umeonyeshwa kwa default)",
"Show type (shown by default)" => "Onyesha aina (imeonyeshwa kwa default)",
"One Per Line" => "Moja kwa Mstari",
"Show one object per line (multiple per line shown by default)" => "Onyesha kitu kimoja kwa kila mstari (mstari kwa kila mmoja umeonyeshwa kwa default)",
// "Child Links" => "Child Links",
"Show children category links (shown by default)" => "Onyesha viungo vya kikundi cha watoto (umeonyeshwa kwa default)",
// "Top Link" => "Top Link",
"Show top category link (shown by default)" => "Onyesha kiungo cha juu cha kiungo (imeonyeshwa kwa default)",
"Maximum Records" => "Kumbukumbu za Maximum",
// "Maximum number of objects to list (default is %0)" => "Maximum number of objects to list (default is %0)",
"Show title text above category object lists (shown by default)" => "Onyesha kichwa cha kichwa juu ya orodha ya vitu vya kipengee (inavyoonekana kwa default)",
"List only objects in this language" => "Weka vitu pekee katika lugha hii",
// "Only apply if %0" => "Only apply if %0",
"Categories are disabled" => "Jamii zimezimwa",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Display controls to trigger category transitions for any object" => "Display controls to trigger category transitions for any object",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
"Category Orphans" => "Jamii yatima",
"List objects that are not categorized" => "Weka vitu ambavyo hazigawiwa",
// "Determine which type of objects are shown (default is %0)" => "Determine which type of objects are shown (default is %0)",
"Calendars" => "Kalenda",
// "Max" => "Max",
// "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records" => "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records",
"Result Offset" => "Matokeo yamepunguzwa",
"Result number at which the listing should start (default is no offset)" => "Nambari ya matokeo ambayo orodha inapaswa kuanza (default si ya kukabiliana)",
"Category Path" => "Jamii ya Njia",
"Show the full category path for a wiki page" => "Onyesha njia kamili ya kikundi cha ukurasa wa wiki",
"Separator" => "Separator",
// "String used to separate the categories in the path. Default character is %0" => "String used to separate the categories in the path. Default character is %0",
"Display Top Category" => "Onyesha Jamii Juu",
"Show the top category as part of the path name (not shown by default)" => "Onyesha kikundi cha juu kama sehemu ya jina la njia (sioonyeshwa kwa default)",
// "Access and use a cclite social credit and alternative currency account" => "Access and use a cclite social credit and alternative currency account",
// "Mode of operation - summary or recent. Default: %0" => "Mode of operation - summary or recent. Default: %0",
"Account summary" => "Muhtasari wa Akaunti",
"Recent transactions" => "Shughuli za hivi karibuni",
"Registry" => "Msajili",
"Registry to query. Default: site preference (or first in list when more than one)" => "Msajili wa swala. Mchapishaji: upendeleo wa tovuti (au kwanza kwenye orodha wakati zaidi ya moja)",
"You need to be logged in to view this information" => "Unahitaji kuingia ili uone habari hii",
"Center text" => "Nakala ya kituo",
"Chart" => "Chati",
"Display a chart from TikiSheet" => "Onyesha chati kutoka TikiSheet",
"Chart caption" => "Maelezo ya chati",
"Spreadsheet ID" => "ID ya lahajedwali",
"Data sheet ID" => "Kitambulisho cha karatasi ya data",
"Chart Type" => "Aina ya Chati",
// "Specify a valid chart type" => "Specify a valid chart type",
"Chart Width" => "Upana wa chati",
"Width in pixels" => "Upana kwa saizi",
"Chart Height" => "Urefu wa Chati",
"Height in pixels" => "Urefu katika saizi",
"Value series" => "Mfululizo wa thamani",
"Required for pie charts" => "Inahitajika kwa chati za pie",
// "Independent series" => "Independent series",
"Required for types other than pie chart" => "Inahitajika kwa aina nyingine isipokuwa chati ya pie",
// "Dependent series" => "Dependent series",
"Description needed" => "Maelezo yanahitajika",
"Colors" => "Rangi",
"List of colors to use" => "Orodha ya rangi ya kutumia",
"Styles" => "Mitindo",
"List of styles to use" => "Orodha ya mitindo ya kutumia",
"Labels for the series or values in the legend" => "Maandiko kwa mfululizo au maadili katika hadithi",
"Chart as PDF" => "Chati kama PDF",
"Chart as PostScript" => "Chati kama PostScript",
// "Chart JS" => "Chart JS",
// "Create a JS Chart" => "Create a JS Chart",
// "JSON encoded array for data and options" => "JSON encoded array for data and options",
// "Chart Id" => "Chart Id",
// "A custom ID for the chart" => "A custom ID for the chart",
// "The type of chart. Currently works with pie, bar and doughnut" => "The type of chart. Currently works with pie, bar and doughnut",
// "The height of the chart in px" => "The height of the chart in px",
// "The width of the chart in px" => "The width of the chart in px",
// "Chart data values" => "Chart data values",
// "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)" => "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)",
// "Chart data labels" => "Chart data labels",
// "Colon-separated labels for the datasets in the chart. Max 10, if left empty" => "Colon-separated labels for the datasets in the chart. Max 10, if left empty",
// "Chart colors" => "Chart colors",
// "Colon-separated colors for the datasets in the chart. Max 10, if left empty" => "Colon-separated colors for the datasets in the chart. Max 10, if left empty",
// "Chart highlight" => "Chart highlight",
// "Colon-separated color of chart section when highlighted" => "Colon-separated color of chart section when highlighted",
// "Uses the non-minified version of the chart.js library for easier debugging" => "Uses the non-minified version of the chart.js library for easier debugging",
// "Values must be set for chart" => "Values must be set for chart",
// "Check Referer" => "Check Referer",
// "Display content based on the address that originated the request for the current page" => "Display content based on the address that originated the request for the current page",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met",
// "Referer List" => "Referer List",
// "Comma-separated list of domains to check" => "Comma-separated list of domains to check",
// "Display code with syntax highlighting and line numbering" => "Display code with syntax highlighting and line numbering",
"Code to be displayed" => "Kanuni ya kuonyeshwa",
"Caption" => "Maelezo",
"Code snippet label" => "Lebo ya snippet studio",
"Line Wrapping" => "Ufungashaji wa Mstari",
"Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends." => "Weka mstari wa msimbo usiofaa katika upana wa sanduku la kuonyesha. Kuwawezesha kuepuka kuvuka au mstari wa siri unaisha.",
// "Any supported language listed at http://codemirror.net/mode/" => "Any supported language listed at http://codemirror.net/mode/",
"Line Numbers" => "Hesabu za Nambari",
// "Show line numbers for each line of code" => "Show line numbers for each line of code",
"Right to Left" => "Haki ya kushoto",
"Switch the text display from left to right, to right to left (left to right by default)" => "Badilisha ubaguzi wa maandiko kutoka kushoto kwenda kulia, kwenda kulia kwenda kushoto (kushoto kwenda kulia kwa default)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Any supported theme listed at https://codemirror.net/demo/theme.html" => "Any supported theme listed at https://codemirror.net/demo/theme.html",
"Colorbox" => "Colorbox",
"Display a gallery of images in a popup slideshow" => "Onyesha nyumba ya picha katika picha ya slideshow",
"Image Gallery ID" => "ID ya Hifadhi ya Picha",
"ID number of the image gallery that contains the images to be displayed" => "Nambari ya kitambulisho cha picha ya sanaa ambayo ina picha zinazoonyeshwa",
"File ID Filter" => "Ficha Filter ID",
// "Colon-separated list of fileIds in a file gallery to show" => "Colon-separated list of fileIds in a file gallery to show",
"Thumb" => "Thumb",
// "Display as a thumbnail or full size" => "Display as a thumbnail or full size",
"Show File Title" => "Onyesha kichwa cha Picha",
"Show file title" => "Onyesha cheo cha faili",
"Show File Name" => "Onyesha Jina la Picha",
"Show file name" => "Onyesha jina la faili",
"Show All Thumbs" => "Onyesha Thumbs zote",
"Show thumbnails of all the images in the gallery" => "Onyesha picha za picha zote kwenye nyumba ya sanaa",
"Parse Descriptions" => "Maelezo ya Parse",
"Parse the file descriptions as wiki syntax" => "Piga maelezo ya faili kama syntax ya wiki",
"This feature is disabled" => "Kipengele hiki kimezimwa",
// "Display a comment area for a specified object" => "Display a comment area for a specified object",
// "Object type the comment is associated with" => "Object type the comment is associated with",
"Tracker Item" => "Kitu cha Tracker",
// "Submission" => "Submission",
// "Blog Post" => "Blog Post",
// "The current wiki page to which you have added the plugin" => "The current wiki page to which you have added the plugin",
"Dynamic Content" => "Maudhui ya Nguvu",
"Display content from dynamic content repository" => "Onyesha maudhui kutoka kwenye orodha ya maudhui yenye nguvu",
"Content ID" => "Kitambulisho cha Maudhui",
"Dynamic content ID. The value can be obtained in the listing" => "Kitambulisho cha maudhui ya nguvu. Thamani inaweza kupatikana katika orodha",
"Content Label" => "Lebo ya Maudhui",
"Label of the dynamic content to display" => "Lebo ya maudhui yenye nguvu ya kuonyesha",
"Contributions Dashboard" => "Dashibodi ya Mchango",
// "List users' contributions to a page" => "List users' contributions to a page",
"Notice" => "Angalia",
"Default Beginning Date" => "Tarehe ya Kuanzia ya Kuanzia",
"Default Ending Date" => "Tarehe ya Kumalizika ya Default",
"Dashboard Types" => "Aina za Dashibodi",
// "The types of charts that will be rendered, separated by commas" => "The types of charts that will be rendered, separated by commas",
"Update" => "Sasisha",
// "Convene" => "Convene",
// "Suggest meeting dates and times and vote to select one" => "Suggest meeting dates and times and vote to select one",
// "Convene data generated from user input" => "Convene data generated from user input",
// "Title for the event" => "Title for the event",
// "Calendar ID" => "Calendar ID",
// "ID number of the site calendar in which to store the date for the events with the most votes" => "ID number of the site calendar in which to store the date for the events with the most votes",
// "Minimum Votes" => "Minimum Votes",
// "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it" => "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it",
// "Date-Time Format" => "Date-Time Format",
// "Display date and time in short or long format, according to the site wide setting" => "Display date and time in short or long format, according to the site wide setting",
// "Short" => "Short",
// "Long" => "Long",
// "Observe Admin Permissions" => "Observe Admin Permissions",
// "Show user profile pictures" => "Show user profile pictures",
// "Delete Date" => "Delete Date",
// "UTC date time: %0" => "UTC date time: %0",
"Add Date" => "Tarehe ya Ongeza",
// "Not OK" => "Not OK",
// "Unconfirmed" => "Unconfirmed",
"Add User" => "Ongeza Mtumiaji",
// "Not ok" => "Not ok",
"Ok" => "Sawa",
// "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users" => "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users",
// "Show user's profile pictures next to their names" => "Show user's profile pictures next to their names",
"Edit User/Save changes" => "Hariri Mtumiaji / Hifadhi mabadiliko",
"Delete User" => "Futa Mtumiaji",
// "Username.." => "Username..",
// "Selected Date" => "Selected Date",
"Add as Calendar Event" => "Ongeza kama Tukio la Kalenda",
// "This page is being edited by another user. Please reload the page and try again later" => "This page is being edited by another user. Please reload the page and try again later",
// "Delete this date" => "Delete this date",
// "Are you sure you want to remove this user's votes" => "Are you sure you want to remove this user's votes",
// "There is no undo" => "There is no undo",
"Cookie" => "Cookie",
// "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)" => "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)",
// "Display content based on whether cookie consent has been granted by the user" => "Display content based on whether cookie consent has been granted by the user",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "No Cookie Message" => "No Cookie Message",
// "Message displayed if user has not consented to accepting cookies" => "Message displayed if user has not consented to accepting cookies",
// "Containing Element" => "Containing Element",
// "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container" => "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container",
// "Element CSS Class" => "Element CSS Class",
// "CSS class for above" => "CSS class for above",
// "No Consent CSS Class" => "No Consent CSS Class",
// "CSS class for no consent message. Default: %0" => "CSS class for no consent message. Default: %0",
"Insert copyright notices" => "Weka matangazo ya hakimiliki",
// "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1" => "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1",
"Countdown" => "Kuhesabu",
// "Display the time until or after a date and time" => "Display the time until or after a date and time",
"Text to append to the countdown" => "Nakala ya kuingiza kwenye hesabu",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
"Items to Show" => "Vipengee vya Kuonyesha",
// "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "Siku",
"Days & Hours" => "Siku & Masaa",
"Days, Hours & Minutes" => "Siku, Masaa & Dakika",
"Days, Hours, Minutes & Seconds" => "Siku, Masaa, Dakika & Pili",
"Hours" => "Masaa",
"Hours & Minutes" => "Masaa & Dakika",
"Hours, Minutes & Seconds" => "Masaa, Dakika & Pili",
"Minutes" => "Dakika",
"Minutes & Seconds" => "Dakika & Pili",
"Seconds" => "Pili",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default" => "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text" => "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text",
"Text" => "Nakala",
// "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text" => "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
"Thousands separator" => "Maelfu ya mgawanyiko",
// "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator",
"Comma" => "Comma",
"Period" => "Kipindi",
// "Space" => "Space",
// "Countdown: Missing \"enddate\" parameter for plugin" => "Countdown: Missing \"enddate\" parameter for plugin",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "tangu",
// "is over" => "is over",
"Custom Search" => "Utafutaji wa Custom",
// "Create a custom search form for searching or listing items on the site" => "Create a custom search form for searching or listing items on the site",
"LIST plugin configuration information" => "Maelezo ya usanidi wa programu ya LIST",
"Template wiki page" => "Kigezo ukurasa wa wiki",
"Wiki page where search user interface template is found" => "Ukurasa wa Wiki ambapo template ya user interface template inapatikana",
// "Template file" => "Template file",
// "Smarty template (.tpl) file where search user interface template is found" => "Smarty template (.tpl) file where search user interface template is found",
// "Search Id" => "Search Id",
// "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users",
// "Search Delay" => "Search Delay",
// "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)" => "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)",
// "Fade DIV Id" => "Fade DIV Id",
// "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner",
// "Recall Last Search" => "Recall Last Search",
// "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving" => "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving",
// "Custom JavaScript Page" => "Custom JavaScript Page",
"The wiki page on which custom JavaScript is to be executed on return of Ajax results" => "Ukurasa wa wiki ambayo Javascript ya desturi itafanywa kwa kurudi matokeo ya Ajax",
"Destination Div" => "Mahali ya Div",
"The id of an existing div to contain the search results" => "Id ya div iliyopo kuwa na matokeo ya utafutaji",
// "Search On Load" => "Search On Load",
"Execute the search when the page loads (default: Yes)" => "Fanya utafutaji wakati ukurasa unapozidi (default: Ndio)",
// "Require Input" => "Require Input",
// "Require first input field to be filled for search to trigger" => "Require first input field to be filled for search to trigger",
// "Force Sort" => "Force Sort",
// "Force the use of specified sort mode in place of search relevance even when there is a text search query" => "Force the use of specified sort mode in place of search relevance even when there is a text search query",
// "Trim Linefeeds" => "Trim Linefeeds",
// "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs" => "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs",
// "Searchable Only Results" => "Searchable Only Results",
// "Only include results marked as searchable in the index" => "Only include results marked as searchable in the index",
// "Use custom search JavaScript file" => "Use custom search JavaScript file",
// "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size" => "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size",
// "JavaScript disabled" => "JavaScript disabled",
// "JavaScript is required for this search feature" => "JavaScript is required for this search feature",
"Template is not specified" => "Kigezo si maalum",
"Template page not found" => "Ukurasa wa Kigezo haukupatikana",
// "Please enter a search query" => "Please enter a search query",
// "_from parameter not valid: \"%0\"" => "_from parameter not valid: \"%0\"",
// "_to parameter not valid: \"%0\"" => "_to parameter not valid: \"%0\"",
// "_gap parameter not valid: \"%0\"" => "_gap parameter not valid: \"%0\"",
"_group is needed to be set if _style is checkbox or radio" => "_group inahitajika kuweka ikiwa _style ni checkbox au redio",
// "Cypht webmail" => "Cypht webmail",
// "Embed Cypht webmail and news reader" => "Embed Cypht webmail and news reader",
// "Mailbox name" => "Mailbox name",
"IMAP server" => "Serveur IMAP",
// "IMAP port" => "IMAP port",
// "IMAP use TLS" => "IMAP use TLS",
// "Use secure connection to IMAP server" => "Use secure connection to IMAP server",
// "IMAP username" => "IMAP username",
// "Account mailbox username" => "Account mailbox username",
// "IMAP password" => "IMAP password",
// "Account mailbox password" => "Account mailbox password",
// "SMTP connection name" => "SMTP connection name",
// "SMTP port" => "SMTP port",
// "SMTP use TLS" => "SMTP use TLS",
// "Use secure TLS/SSL connection to SMTP server" => "Use secure TLS/SSL connection to SMTP server",
// "SMTP no authentication" => "SMTP no authentication",
// "Disable SMTP authentication if your server does not support it" => "Disable SMTP authentication if your server does not support it",
// "Use global settings" => "Use global settings",
// "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages" => "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages",
// "Groupmail use" => "Groupmail use",
// "Share this mailbox for Groupmail usage or keep it private" => "Share this mailbox for Groupmail usage or keep it private",
"GroupMail: Group (e.g. \"Help Team\")" => "GroupMail : Groupe (par e.g \"Timu ya Usaidizi\")",
"GroupMail: Tracker ID (to store GroupMail activity)" => "Kundi la Vikundi: Fomu Id (kujiandikisha shughuli za GroupMail)",
"From Field ID" => "Kitambulisho cha field 'Kutoka'",
"GroupMail: From Field (Id of field in tracker to store email From header)" => "Kundi la Kundi: Field 'De' (Kitambulisho cha shamba kwa fomu ya kusajili mtumaji wa barua pepe kwenye kichwa)",
"Subject Field ID" => "Kitambulisho cha field 'Subject'",
"GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "Kikundi cha Kundi: Swala 'Swala' (Kitambulisho cha shamba kwa fomu ili kuhifadhi somo la barua pepe kwenye kichwa)",
"Message Field ID" => "Kitambulisho cha field 'Message'",
"GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "Kundi la Kundi: Swali la 'Swali' (Kitambulisho cha Shamba kwa fomu ya kurekodi kitambulisho cha ujumbe wa barua pepe)",
"Content Field ID" => "Kitambulisho cha field 'Content'",
"GroupMail: Content Field (Id of field in tracker to store email message body content)" => "Kundi la Kundi: Field 'Content' (Kitambulisho cha Shamba kwa fomu ya kurekodi maudhui ya mwili wa ujumbe wa barua pepe)",
"Account Field ID" => "Kitambulisho cha field 'Account'",
"GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "Kundi la Kundi: Shamba la 'Shamba' (ID ya shamba kwa fomu ili kuhifadhi jina la akaunti ya Webmail)",
"DateTime Field Id" => "Kitambulisho cha tarehe na wakati wa shamba",
"GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "Kikundi cha Kundi: Shamba 'Tarehe na Muda' (Jina la Shamba kwa fomu ya kurekodi timestamp ya barua pepe iliyotumwa)",
"Operator Field ID" => "Kitambulisho cha field 'Operator'",
"GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "Kundi la Kundi: Field 'Operator' (Kitambulisho cha Shamba kwa fomu ya kusajili jina la mtumiaji (jina la mtumiaji))",
// "UI display presentational purposes only" => "UI display presentational purposes only",
// "E.g. imap.your-domain.com" => "E.g. imap.your-domain.com",
// "Default is 993" => "Default is 993",
// "E.g. smtp.your-domain.com" => "E.g. smtp.your-domain.com",
// "Default is 587" => "Default is 587",
// "Only one cypht plugin per page can be used" => "Only one cypht plugin per page can be used",
"Data Channel" => "Kituo cha Takwimu",
"Display a form to access data channels" => "Onyesha fomu ya kufikia vituo vya data",
// "List of fields to display. One field per line. Comma delimited: %0" => "List of fields to display. One field per line. Comma delimited: %0",
// "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag" => "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag",
// "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel" => "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel",
// "To use fixed hidden preset\n\t\t\tvalues use %0" => "To use fixed hidden preset\n\t\t\tvalues use %0",
"Channel Name" => "Jina la Channel",
"Name of the channel as registered by the administrator" => "Jina la kituo kilichosajiliwa na msimamizi",
"Return URL" => "URL ya kurudi",
// "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object" => "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object",
// "Return URL on error" => "Return URL on error",
// "URL to go to after data channel has run and failed. If not specified, use the success URL" => "URL to go to after data channel has run and failed. If not specified, use the success URL",
"Do not use returnURI but instead return true quietly" => "Usitumie kurudiURI lakini badala yake kurudi kimya kimya",
// "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context" => "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context",
"Button Label" => "Lebo ya kifungo",
"Label for the submit button. Default: \"Go\"" => "Weka kwa kifungo cha kuwasilisha. Mchapishaji: \"Nenda\"",
"CSS class for this form" => "CSS darasa la fomu hii",
"Template" => "Kigezo",
// "Template to be used to render the form, instead of the default template" => "Template to be used to render the form, instead of the default template",
"Empty Caches" => "Cached tupu",
"Which caches to empty. Default \"Clear all Tiki caches\"" => "Ambayo ya cache ya tupu. Default \"Futa caches zote za Tiki\"",
"Clear all Tiki caches" => "Futa caches zote za Tiki",
"All user prefs sessions" => "Vitu vyote vinavyotumiwa na mtumiaji",
"Price to execute the data channel (%0)" => "Bei ya kutekeleza kituo cha data (%0)",
"Payment Label" => "Lebo ya Malipo",
"Debug" => "Dhibiti",
// "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)",
"Multiple Values" => "Vipimo Vingi",
// "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)",
"Data channel" => "Kituo cha data",
"DB Report" => "Ripoti ya DB",
// "Query an ADOdb database and display results (does not work with PDO)" => "Query an ADOdb database and display results (does not work with PDO)",
"report definition" => "ufafanuzi wa ripoti",
"Full DSN" => "DSN kamili",
// "A full DSN (Data Source Name) connection string. Example: " => "A full DSN (Data Source Name) connection string. Example: ",
"Wiki DSN Name" => "Wiki DSN Jina",
"The name of a DSN connection defined by the Wiki administrator" => "Jina la uunganisho wa DSN unaotafsiriwa na msimamizi wa Wiki",
"Wiki Syntax" => "Syntax ya Wiki",
"Parse wiki syntax within the report (not parsed by default)" => "Sura ya wiki ya syntax ndani ya ripoti (isiyochaguliwa na default)",
"Display the parsed report definition (not displayed by default)" => "Onyesha ufafanuzi wa ripoti iliyochapishwa (sioonyeshwa na default)",
"Missing db or dsn parameter" => "Db kukosa au parameter dsn",
// "AdoDb not found" => "AdoDb not found",
"No DSN connection string found" => "Hakuna kamba ya uunganisho ya DSN iliyopatikana",
"Run a database report" => "Tumia ripoti ya database",
// "Diagram" => "Diagram",
// "Display mxGraph/Draw.io diagrams" => "Display mxGraph/Draw.io diagrams",
// "fileId" => "fileId",
// "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options" => "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options",
"page" => "ukurasa",
// "Page of the diagram that should be displayed" => "Page of the diagram that should be displayed",
// "annotate" => "annotate",
// "Id of the file in the file gallery. A image file to include in the diagram" => "Id of the file in the file gallery. A image file to include in the diagram",
// "Image alignment when exporting a PDF" => "Image alignment when exporting a PDF",
// "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"" => "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"",
// "Previous xorti/mxgraph-editor package has been deprecated.<br/>" => "Previous xorti/mxgraph-editor package has been deprecated.<br/>",
// "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator" => "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator",
// "Create New Diagram" => "Create New Diagram",
// "Page (inline)" => "Page (inline)",
// "Tiki wasn't able to find the file with id %0" => "Tiki wasn't able to find the file with id %0",
// "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure" => "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure",
" in " => " mu ",
// "Selected file to annotate must be an image" => "Selected file to annotate must be an image",
// "Can not retrieve size from file %0" => "Can not retrieve size from file %0",
// "Create a custom popup dialog box" => "Create a custom popup dialog box",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button Actions" => "Button Actions",
"JavaScript to perform on first button click" => "Javascript kufanya juu ya bonyeza kifungo kwanza",
// "Dialog Width" => "Dialog Width",
"In pixels" => "Katika saizi",
"HTML ID" => "Kitambulisho cha HTML",
// "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)" => "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)",
// "Show Animation" => "Show Animation",
// "Hide Animation" => "Hide Animation",
// "Auto Open" => "Auto Open",
// "Open dialog automatically" => "Open dialog automatically",
// "Modal" => "Modal",
// "Use modal form" => "Use modal form",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JavaScript to execute when dialog opens" => "JavaScript to execute when dialog opens",
"Div" => "Div",
"Define and format sections of a page or text" => "Eleza na kuunda sehemu za ukurasa au maandishi",
// "Indicate the type of HTML tag to use (default is %0)" => "Indicate the type of HTML tag to use (default is %0)",
"Span" => "Span",
"Pre" => "Kabla",
"Teletype" => "Teletype",
"Paragraph" => "Kifungu",
"Block quote" => "Piga quote",
// "H1" => "H1",
// "H2" => "H2",
// "H3" => "H3",
// "H4" => "H4",
// "H5" => "H5",
// "H6" => "H6",
// "Valid CSS color name or hex code" => "Valid CSS color name or hex code",
"Box width" => "Upana wa sanduku",
"In pixels or percentage. Default is original size" => "Katika saizi au asilimia. Kwa kawaida ni ukubwa wa awali",
"Aligns the text within the element" => "Hatua ya maandishi ndani ya kipengele",
"Justify" => "Thibitisha",
// "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set" => "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set",
"Content cannot wrap around this object because of what the parameter is set to" => "Maudhui haipatikani kifaa hiki kwa sababu ya parameter iliyowekwa",
"Apply custom CSS class to the div" => "Tumia darasa la CSS desturi kwa div",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
// "onClick attribute" => "onClick attribute",
// "Enter on onclick event" => "Enter on onclick event",
// "Style attribute" => "Style attribute",
// "Enter CSS styling tags for the div type used" => "Enter CSS styling tags for the div type used",
// "Data attributes" => "Data attributes",
// "URL encoded list or attributes and values" => "URL encoded list or attributes and values",
// "ARIA attributes" => "ARIA attributes",
// "URL encoded list or attributes and values, e.g. label, expanded etc" => "URL encoded list or attributes and values, e.g. label, expanded etc",
// "Role attribute" => "Role attribute",
// "e.g. button, heading, search etc" => "e.g. button, heading, search etc",
"Sets the id attribute of the div, as defined by HTML" => "Inaweka sifa ya id ya div, kama ilivyoelezwa na HTML",
"Definition List" => "Orodha ya ufafanuzi",
"Create a definition list" => "Unda orodha ya ufafanuzi",
// "One entry per line. Each line is in %0Term: Definition%1 format" => "One entry per line. Each line is in %0Term: Definition%1 format",
// "List Type" => "List Type",
// "Type of definition list (left-aligned or horizontal)" => "Type of definition list (left-aligned or horizontal)",
// "Standard (left-aligned)" => "Standard (left-aligned)",
// "Horizontal (inline) " => "Horizontal (inline) ",
"Draw" => "Chora",
// "Embed a drawing in a page" => "Embed a drawing in a page",
"Drawing ID" => "ID ya Kuchora",
"Internal ID of the file ID" => "ID ya ndani ya ID ya faili",
// "Width in pixels or percentage. Default value is page width, for example, %0 or %1" => "Width in pixels or percentage. Default value is page width, for example, %0 or %1",
"Height in pixels or percentage. Default value is complete drawing height" => "Urefu katika saizi au asilimia. Thamani ya msingi ni urefu kamili wa kuchora",
"Force Display Archive" => "Weka Archive ya Kuonyesha Nguvu",
// "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision",
"Draw New SVG Image" => "Chora Picha Mpya ya SVG",
"Edit SVG Image" => "Hariri picha ya SVG",
// "List of dynamic variables" => "List of dynamic variables",
// "Show dynamic variables and their values" => "Show dynamic variables and their values",
"Layout" => "Usanifu wa jumla",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
"String to use between elements of the list if table layout is not used" => "Kamba ya kutumia kati ya vipengele vya orodha ikiwa mpangilio wa meza hautumiwi",
// "Parsed result" => "Parsed result",
"Syntax" => "Syntax",
// "Value per database" => "Value per database",
"Equation" => "Ulinganifu",
"Render an equation written in LaTeX syntax as an image" => "Tumia usawa ulioandikwa katika syntax ya LaTeX kama picha",
"equation" => "usawa",
// "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator" => "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator",
// "Display events from calendars" => "Display events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)" => "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)",
"Maximum Days" => "Siku nyingi",
// "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0" => "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0",
"Maximum Events" => "Matukio nyingi",
// "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)" => "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)",
"Show Time" => "Onyesha Muda",
"Show the time along with the date (shown by default)" => "Onyesha wakati pamoja na tarehe (imeonyeshwa kwa default)",
"Show the description of the event (shown by default)" => "Onyesha maelezo ya tukio (limeonyeshwa kwa default)",
// "Time Span" => "Time Span",
// "Specify the time span" => "Specify the time span",
// "Past" => "Past",
// "Future" => "Future",
// "Activate pagination when Events listing are long. Default is %0" => "Activate pagination when Events listing are long. Default is %0",
"Upcoming Events" => "Matukio ya ujao",
"Exercise" => "Zoezi",
"PluginExercise" => "ZoeziPlugin",
// "Create an exercise/test with questions and grade" => "Create an exercise/test with questions and grade",
"Answer" => "Jibu",
"Used inline to specify the right answer to the question and propose an input field" => "Inline kutumika kwa kutaja jibu sahihi kwa swali na kupendekeza shamba pembejeo",
"Incorrect" => "Si sahihi",
// "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")" => "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")",
"Check your score" => "Angalia alama yako",
"You scored %0 out of %1" => "Ulifunga %0 nje ya %1",
"Good" => "Nzuri",
"Extend Cart Inventory Hold" => "Kupanua Hifadhi ya Kifaa Kushikilia",
"PluginExtendCartHold" => "Plug-in Panua Cart Support",
// "Extend the time that items are held in a shopping cart" => "Extend the time that items are held in a shopping cart",
"Create a link that shows/hides initially hidden content" => "Unda kiungo kinachoonyesha / kinachoficha maudhui yaliyofichwa awali",
"Content of the hideable zone (in Wiki syntax)" => "Maudhui ya eneo lililofichwa (katika mkato wa Wiki)",
"Label for link that shows and hides the content when clicked" => "Lebo kwa kiungo kinachoonyesha na kujificha maudhui wakati unapobofya",
"Unspecified label" => "Lebo isiyojulikana",
"Arrow icon showing that content can be hidden or shown" => "Mshale wa icon unaonyesha kwamba maudhui yanaweza kuficha au kuonyeshwa",
"Show Speed" => "Onyesha kasi",
// "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or %0 or %1" => "Integer greater than 0 and less than or equal to 1000, or %0 or %1",
"Hide Speed" => "Ficha Kasi",
// "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Use Bootstrap" => "Use Bootstrap",
// "Use Bootstrap collapsible box" => "Use Bootstrap collapsible box",
// "Apply custom CSS class" => "Apply custom CSS class",
"Fancy List" => "Orodha ya dhana",
// "Create a formatted numbered list" => "Create a formatted numbered list",
"One item per line starting with anything followed by \")\"" => "Kipengee kimoja kwa mstari kuanzia na chochote kinachofuata na \")\"",
"Use Div" => "Tumia Div",
"Use the HTML div tag instead of the HTML ordered list tag (ol)" => "Tumia tag ya div div badala ya HTML ya kuagiza lebo ya tangazo (ol)",
"CSS class for the fancylist" => "CSS darasa la fancylist",
"Heading Row" => "Upeo wa Upeo",
// "Header rows of the table. Use %0 to separate multiple rows" => "Header rows of the table. Use %0 to separate multiple rows",
"Heading CSS Class" => "Hatua ya CSS Hatari",
"CSS class to apply to the heading row" => "CSS darasa kuomba mstari wa vichwa",
"Header Horizontal Alignment" => "Upeo wa Upeo wa Kichwa",
// "Horizontal alignments for header cells, separated by %0. Choices: %1" => "Horizontal alignments for header cells, separated by %0. Choices: %1",
"Header Vertical Alignment" => "Mgongano wa Vertical Header",
// "Vertical alignments for header cells, separated by %0\". Choices: %1" => "Vertical alignments for header cells, separated by %0\". Choices: %1",
"Column Widths" => "Vipindi vya Column",
// "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0" => "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0",
"Cell Horizontal Align" => "Weka Kiini Hifadhi",
// "Table body column horizontal alignments, separated by %0. Choices: %1" => "Table body column horizontal alignments, separated by %0. Choices: %1",
"Cell Vertical Align" => "Weka Kiini cha Wima",
// "Table body column vertical alignments, separated by %0. Choices: %1" => "Table body column vertical alignments, separated by %0. Choices: %1",
"Fancy Table" => "Jedwali la dhana",
// "Create a formatted table that can be filtered and sorted" => "Create a formatted table that can be filtered and sorted",
// "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases" => "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases",
// "The jQuery Sortable Tables feature must be activated for the sort feature to work" => "The jQuery Sortable Tables feature must be activated for the sort feature to work",
// "JavaScript must be enabled for the sort feature to work" => "JavaScript must be enabled for the sort feature to work",
// "Unable to load the jQuery Sortable Tables feature" => "Unable to load the jQuery Sortable Tables feature",
// "Display a button for a user to click to make an object a favorite" => "Display a button for a user to click to make an object a favorite",
// "Indicate type of object" => "Indicate type of object",
// "Enter the ID of the object" => "Enter the ID of the object",
// "Link to a file that's attached or in a gallery or archive" => "Link to a file that's attached or in a gallery or archive",
"Label for the link to the file (ignored if the file is a wiki attachment)" => "Weka alama kwa kiungo kwa faili (haijatilishwa ikiwa faili ni safu ya wiki)",
"Indicate whether the file is in a file gallery or is a wiki page attachment" => "Eleza kama faili iko kwenye nyumba ya sanaa au faili ya ukurasa wa wiki",
// "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used" => "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used",
"Custom Description" => "Maelezo ya Desturi",
"Custom text that will be used for the link instead of the file name or file description" => "Nakala maalum ambayo itatumiwa kwa kiungo badala ya jina la faili au maelezo ya faili",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty",
"Attachment Description" => "Maelezo ya kifungo",
"Show the attachment description as the link label instead of the attachment file name" => "Onyesha maelezo ya kiambatanisho kama lebo ya kiungo badala ya jina la faili la attachment",
"Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Inaonyesha kwamba kifungo hiki ni picha, na kinapaswa kuonyeshwa kwa njia ndogo kwa kutumia kitambulisho cha img",
"File ID" => "Faili ID",
"File ID of a file in a file gallery or an archive" => "Faili Kitambulisho cha faili kwenye nyumba ya sanaa au faili",
"Example value" => "Thamani ya mfano",
"Date" => "Tarehe",
// "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1" => "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1",
"Show Icon" => "Onyesha Icon",
"Show an icon version of the file or file type with the link to the file" => "Onyesha toleo la faili la faili au aina ya faili na kiungo kwenye faili",
// "Browser Display" => "Browser Display",
// "Display in different browser window or tab instead of downloading" => "Display in different browser window or tab instead of downloading",
"File Gallery File/Archive" => "Faili ya Picha ya Nyumba ya sanaa / Archive",
"Wiki Page Attachment" => "Kiambatisho cha Ukurasa wa Wiki",
"The date has not been set" => "Tarehe haijawekwa",
"Incorrect date format" => "Aina ya tarehe isiyo sahihi",
"No such file" => "Hakuna faili kama hiyo",
"Wiki attachments are disabled" => "Vifungo vya Wiki vimezimwa",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when %0" => "Title for the file listing, or the link text when %0",
"File Galleries IDs" => "Funga Vitambulisho vya Galleries",
// "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)" => "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)",
// "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)" => "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon",
// "Valid category IDs separated by colons" => "Valid category IDs separated by colons",
// "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty" => "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty",
// "Valid file IDs separated by colons" => "Valid file IDs separated by colons",
// "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0" => "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0",
// "Last modified Ascending" => "Last modified Ascending",
// "Last modified Descending" => "Last modified Descending",
"File Name Ascending" => "Amri ya faili ya faili",
"File Name Descending" => "Jina la faili Inashuka",
"File Size Ascending" => "Ukubwa wa faili unashuka",
"File Size Descending" => "Ukubwa wa faili Unashuka",
"File Type Ascending" => "Aina ya Faili Inakua",
"File Type Descending" => "Aina ya Faili Inashuka",
"Last Download Ascending" => "Mwisho Shusha Kupanda",
"Last Download Descending" => "Mwisho Shusha Kushuka",
"Show Action" => "Onyesha Hatua",
// "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)" => "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)",
"Show Find" => "Onyesha Tafuta",
"Show a search box above the list (not shown by default)" => "Onyesha sanduku la utafutaji juu ya orodha (isiyoonyeshwa kwa default)",
// "Show Find is recursive" => "Show Find is recursive",
// "The search box digs recursively in sub-galleries (by default)" => "The search box digs recursively in sub-galleries (by default)",
"Show Title" => "Onyesha Kichwa",
// "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used",
"Show ID" => "Onyesha Kitambulisho",
"Show the ID number of each file (shown by default)" => "Onyesha namba ya ID ya kila faili (imeonyeshwa kwa default)",
"Show the file-type icon for each file" => "Onyesha icon ya aina ya faili kwa kila faili",
"Show Name" => "Onyesha Jina",
// "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show",
"Show Filename" => "Onyesha faili",
// "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show",
"Show Size" => "Onyesha Ukubwa",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show",
"Show Creation Date" => "Onyesha Tarehe ya Uumbaji",
"Show the date each file was created (not shown by default)" => "Onyesha tarehe kila faili iliundwa (haionyeshwa kwa default)",
"Show Last Modification Date" => "Onyesha tarehe ya mwisho ya marekebisho",
"Show the date each file was last modified (shown by default)" => "Onyesha tarehe kila faili ilibadilishwa mwisho (imeonyeshwa kwa default)",
// "Show Last Modification Time as well as Date" => "Show Last Modification Time as well as Date",
// "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)" => "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)",
"Show Hits" => "Onyesha Hits",
"Show the number of hits each file has received (not shown by default)" => "Onyesha idadi ya hits kila faili imepokea (sioonyeshwa kwa default)",
"Show Locked By" => "Onyesha Imefungwa",
"For locked files, show the username of the user who locked it (not shown by default)" => "Kwa faili imefungwa, onyesha jina la mtumiaji la mtumiaji aliyelifunga (halionyeshwa kwa default)",
"Show the username of the user who is the author of the file (not shown by default)" => "Onyesha mtumiaji wa mtumiaji ambaye ni mwandishi wa faili (sioonyeshwa kwa default)",
"Show Creator" => "Onyesha Muumba",
"Show the username of the user who is the creator of the file (not shown by default)" => "Onyesha jina la mtumiaji la mtumiaji ambaye ni muumba wa faili (hazionyeshwa kwa default)",
"Show Parent Gallery Name" => "Onyesha Jina la Nyumba ya Mzazi",
"Show the name of the parent gallery" => "Onyesha jina la nyumba ya sanaa ya mzazi",
"Show File Count" => "Onyesha Hesabu ya Picha",
// "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)",
// "Show Source" => "Show Source",
// "Show the source (shown by default)" => "Show the source (shown by default)",
"Show Slideshow" => "Onyesha Slideshow",
"Show a link that produces a popup slideshow when clicked (not set by default)" => "Onyesha kiungo kinachozalisha slideshow popup wakati clicked (si kuweka kwa default)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
"Show Comments" => "Onyesha maoni",
"Show comments for each file (not shown by default)" => "Onyesha maoni kwa kila faili (isiyoonyeshwa kwa default)",
"Show Last Editor" => "Onyesha Mhariri wa Mwisho",
"Show the username of the user who last modified the file (shown by default)" => "Onyesha jina la mtumiaji wa mwisho aliyebadilisha faili (imeonyeshwa kwa default)",
"Show image thumbnail" => "Onyesha thumbnail ya picha",
"Show Image thumb" => "Onyesha kidole cha picha",
"Show only files created by this user" => "Onyesha faili tu zilizotengenezwa na mtumiaji huyu",
"Show Upload" => "Onyesha Pakia",
"Show a simple form to upload files to the gallery (not shown by default)" => "Onyesha fomu rahisi ya kupakia faili kwenye nyumba ya sanaa (isiyoonyeshwa na default)",
"Number of rows (default: -1 = all)" => "Idadi ya safu (default: -1 = yote)",
"Recursive" => "Inasababishwa",
"With subgalleries" => "Kwa vifungu vidogo",
// "Fitnesse Test Suite" => "Fitnesse Test Suite",
// "Create test suites for applications built using Tiki" => "Create test suites for applications built using Tiki",
// "Test execution scenario" => "Test execution scenario",
// "Fixture not found: %0" => "Fixture not found: %0",
// "Tracker Math for [%0|%1]" => "Tracker Math for [%0|%1]",
// "Tracker Field not found: %0" => "Tracker Field not found: %0",
// "Field is not a math field: %0" => "Field is not a math field: %0",
// "Tracker Data for [%0|%1]" => "Tracker Data for [%0|%1]",
// "Table must contain at least one field named itemId" => "Table must contain at least one field named itemId",
// "%0 (expect: %1)" => "%0 (expect: %1)",
"Flash Video" => "Flash Video",
"Embed a video or audio file" => "Ingiza video au faili ya sauti",
"Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo",
"Blip.tv" => "Blip.tv",
"File Gallery Podcast" => "Podcast ya nyumba ya sanaa ya faili",
"Movie URL" => "URL ya Movie",
"Youtube" => "Youtube",
// "URL to the movie to include, for example, %0" => "URL to the movie to include, for example, %0",
"File Gallery Podcast ID" => "Kitambulisho cha faili katika nyumba ya sanaa ya podcast",
"ID of a file from a podcast gallery - will work only with podcast gallery" => "Id ya faili kwenye nyumba ya sanaa ya faili ya podcast - itafanya kazi tu na nyumba ya sanaa ya podcast",
"YouTube URL" => "URL ya YouTube",
"Complete URL to the YouTube video" => "URL kamili ya video ya YouTube",
"Vimeo URL" => "URL ya Vimeo",
"Complete URL to the Vimeo video" => "URL kamili ya video ya Vimeo",
// "Width of movie in pixels (default is %0)" => "Width of movie in pixels (default is %0)",
// "Height of movie in pixels (default is %0)" => "Height of movie in pixels (default is %0)",
"Quality" => "Ubora",
// "Flash video quality. Default value: %0" => "Flash video quality. Default value: %0",
"Medium" => "Kati",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
"Invalid URL" => "URL isiyo sahihi",
"Missing parameter movie to the plugin flash" => "Inapoteza filamu ya kipangilio kwenye flash ya plugin",
// "Fluid Grid" => "Fluid Grid",
// "Arrange content into rows and columns using a Bootstrap fluid grid" => "Arrange content into rows and columns using a Bootstrap fluid grid",
// "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Join Columns" => "Jiunge safu",
// "Merge empty cells into the cell to their left" => "Merge empty cells into the cell to their left",
// "Device size" => "Device size",
// "Specify the device size below which the cells will be stacked vertically" => "Specify the device size below which the cells will be stacked vertically",
"Small" => "Ndogo",
"Large" => "Kubwa",
// "Extra Large" => "Extra Large",
"Column Sizes" => "Ukubwa wa safu",
// "Specify all column widths in units which add up to 12" => "Specify all column widths in units which add up to 12",
"First" => "Kwanza",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "Safu",
"Custom Class" => "Darasa la kawaida",
"Add a class to customize the design" => "Ongeza darasa ili usanidi kubuni",
"Font" => "Font",
// "Format the font type and size of text" => "Format the font type and size of text",
"Content" => "Maudhui",
"Font Family" => "Font Family",
"Select the font family to display the content" => "Chagua Font Family ili kuonyesha maudhui",
"Font Size" => "Ukubwa wa Font",
// "Define the size of the font in pixels (enter %0 to get a font of 12px)" => "Define the size of the font in pixels (enter %0 to get a font of 12px)",
"Footnote" => "Maandiko chini ya ukurasa",
"Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Unda maelezo ya chini ya kuhesabiwa (pamoja na PluginFootnoteArea)",
"The footnote" => "Maandiko chini ya ukurasa",
"Tag" => "Kitambulisho",
// "Tag footnote with unique identifier" => "Tag footnote with unique identifier",
// "One word made of alphanumeric characters" => "One word made of alphanumeric characters",
// "Same as Tag" => "Same as Tag",
// "Tag to existing footnote by its Tag" => "Tag to existing footnote by its Tag",
// "Same as" => "Same as",
// "Tag to existing footnote number" => "Tag to existing footnote number",
// "tag name (since 17) or footnote number" => "tag name (since 17) or footnote number",
// "Add class to footnotearea" => "Add class to footnotearea",
// "Scheme" => "Scheme",
// "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)" => "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)",
// "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)" => "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)",
// "Error: Tag not found in any previous footnote" => "Error: Tag not found in any previous footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Filter footnotearea by footnote class" => "Filter footnotearea by footnote class",
// "SameAs Style" => "SameAs Style",
// "Numbering style for sameas referencing" => "Numbering style for sameas referencing",
// "Valid Tiki ((Number Style))" => "Valid Tiki ((Number Style))",
"Tagged" => "Vitambulisho ya pamoja",
"List similarly tagged objects" => "Weka vitu na vitambulisho muhimu sawa",
"Tags to find similar to" => "Vitambulisho ya kupata sawa",
"Leave blank to use the object's own tags" => "Acha tupu kutumia vitambulisho vya kitu mwenyewe",
"Type of objects to extract. Set to All to find all types" => "Aina ya vitu ili kuondoa. Weka kwa Wote kupata aina zote",
"Same" => "Yakufanana",
"Blog Posts" => "Machapisho ya blogu",
// "Faqs" => "Faqs",
"Offset" => "Offset",
"Start record" => "Usajili wa kwanza",
"Default -1 (all)" => "Default -1 (yote)",
// "Determine sort order based on various fields (Default: %0)" => "Determine sort order based on various fields (Default: %0)",
"Comments locked Ascending" => "Maoni yaliyofungwa katika utaratibu wa kuinuka",
"Comments locked Descending" => "Maoni yalifungwa kwenye utaratibu wa kushuka",
"Description Ascending" => "Maelezo ya utaratibu wa kuinuka",
"Description Descending" => "Maelezo ya utaratibu wa kushuka",
"Href Ascending" => "Katika utaratibu wa kupandisha wa URL ya lengo (href)",
"Href Descending" => "Katika utaratibu wa kushuka kwa URL ya lengo (href)",
"Object ID Ascending" => "Katika utaratibu wa kupanda kwa kitambulisho cha kitu",
"Object ID Descending" => "Katika utaratibu wa kushuka kwa kitambulisho cha kitu",
"Show objects with names or descriptions similar to the text entered here" => "Onyesha vitu ambavyo majina na maelezo yao ni sawa na maandiko yaliyoingia hapa",
// "Choose whether to broaden" => "Choose whether to broaden",
"n|y" => "h|n (hapana|ndiyo)",
// "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags" => "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags",
"Show Titles Only" => "Onyesha majina tu",
"Choose whether to show titles only (not shown by default)" => "Chagua ikiwa unataka kuonyesha majina tu (yasionyeshwa na default)",
// "Max Image Size" => "Max Image Size",
// "Height or width in pixels. Default: %0 (no maximum)" => "Height or width in pixels. Default: %0 (no maximum)",
// "Show a 'more' link that links to the full list of tagged objects (not shown by default)" => "Show a 'more' link that links to the full list of tagged objects (not shown by default)",
"More URL" => "URL ya kiungo 'Zaidi'",
// "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects" => "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects",
// "More label" => "More label",
// "Alternate text to display on the \"more\" link (default is \"more\")" => "Alternate text to display on the \"more\" link (default is \"more\")",
// "Friend and unfriend other users" => "Friend and unfriend other users",
// "Add or Remove Friend Button" => "Add or Remove Friend Button",
"Other User" => "Mtumiaji mwingine",
"Button Text" => "Maandiko ya kifungo",
// "The user you wish to change relations with" => "The user you wish to change relations with",
// "Button text that's displayed when friending a user" => "Button text that's displayed when friending a user",
// "Button text that's displayed when un-friending a user" => "Button text that's displayed when un-friending a user",
// "Add to Friend Network" => "Add to Friend Network",
// "Remove from Friend Network" => "Remove from Friend Network",
"FTP" => "FTP",
"Create a button for downloading a file from an FTP server" => "Unda kifungo cha kupakua faili kutoka kwa seva ya FTP",
// "File name on the server" => "File name on the server",
"Server Name" => "Jina la Seva",
"Name of the server for the FTP account. Example: " => "Mfano ya jina la seva ambalo akaunti ya FTP inadhibitiwa: ",
"Username for the FTP account" => "Jina la mtumiaji lilihitajika kufikia akaunti ya FTP",
"Password for the FTP account" => "Nenosiri linahitajika kufikia akaunti ya FTP",
"Download Button Label" => "Lebo ya kifungo cha kupakua",
"Label for the FTP download button" => "Lebo kwa kifungo cha kupakua cha FTP",
"missing parameters" => "parameters vya kukosa",
"Connection failed" => "Imeshindwa kuunganisha",
// "Set a Full-Width Page Title" => "Set a Full-Width Page Title",
// "Display the page title the full width of the site content container. " => "Display the page title the full width of the site content container. ",
// "PluginFullWidthTitle" => "PluginFullWidthTitle",
// "Page title" => "Page title",
// "If you need to include tpl files" => "If you need to include tpl files",
// "Icon Source" => "Icon Source",
// "Source path of the icon" => "Source path of the icon",
"Galleriffic" => "Galleriffic",
// "Display a slideshow of images on a page using the Galleriffic script" => "Display a slideshow of images on a page using the Galleriffic script",
// "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual table field name in place of %2" => "%0 or %1 with actual table field name in place of %2",
// "Thumbs Width" => "Thumbs Width",
// "Width in pixels or percentage. (e.g. %0 or %1)" => "Width in pixels or percentage. (e.g. %0 or %1)",
// "Image Slideshow Width" => "Image Slideshow Width",
// "Width in pixels or percentage of the largest image. (e.g. %0 or %1)" => "Width in pixels or percentage of the largest image. (e.g. %0 or %1)",
// "Image Slideshow Height" => "Image Slideshow Height",
// "Height in pixels or percentage of the largest images. (e.g. %0 or %1)" => "Height in pixels or percentage of the largest images. (e.g. %0 or %1)",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
"Delay" => "Kuchelewa",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of thumbnails" => "Number of thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show Top Pager" => "Show Top Pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show Bottom Pager" => "Show Bottom Pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
"Play Slideshow" => "Anza slideshow",
"Pause Slideshow" => "Acha slideshow",
"Previous Photo" => "Picha iliyopita",
"Next Photo" => "Picha inayofuata",
"Prev" => "Kabla",
// "Gantt Chart" => "Gantt Chart",
// "Create and display a gantt graphic using tracker data" => "Create and display a gantt graphic using tracker data",
// "Tracker to search from" => "Tracker to search from",
// "Order Field" => "Order Field",
// "Permanent name of the field to use for row number order" => "Permanent name of the field to use for row number order",
// "Level Field" => "Level Field",
// "Permanent name of the field to use for row level" => "Permanent name of the field to use for row level",
// "Status Field" => "Status Field",
// "Permanent name of the field to use for row status" => "Permanent name of the field to use for row status",
// "Dependency Field" => "Dependency Field",
// "Permanent name of the field to use for row dependency" => "Permanent name of the field to use for row dependency",
// "Progress Field" => "Progress Field",
// "Permanent name of the field to use for row progress, values between 0-100" => "Permanent name of the field to use for row progress, values between 0-100",
// "Name Field" => "Name Field",
// "Permanent name of the field to use for row name" => "Permanent name of the field to use for row name",
// "Description Field" => "Description Field",
// "Permanent name of the field to use for row description" => "Permanent name of the field to use for row description",
// "Code Field" => "Code Field",
// "Permanent name of the field to use for row code" => "Permanent name of the field to use for row code",
// "Begin Date Field" => "Begin Date Field",
// "Permanent name of the field to use for event beginning" => "Permanent name of the field to use for event beginning",
// "End Date Field" => "End Date Field",
// "Permanent name of the field to use for event ending" => "Permanent name of the field to use for event ending",
// "Resources Field" => "Resources Field",
// "Permanent name of the field to use for resources ending" => "Permanent name of the field to use for resources ending",
// "Roles Field" => "Roles Field",
// "Permanent name of the field to use for roles ending" => "Permanent name of the field to use for roles ending",
// "Effort Field" => "Effort Field",
// "Permanent name of the field to use for effort ending, values in milliseconds" => "Permanent name of the field to use for effort ending, values in milliseconds",
// "Start Is Milestone" => "Start Is Milestone",
// "Flag field to start is milestone" => "Flag field to start is milestone",
// "End Is Milestone" => "End Is Milestone",
// "Flag field to end is milestone" => "Flag field to end is milestone",
// "Writable" => "Writable",
// "Flag field to write or not in tasks" => "Flag field to write or not in tasks",
// "Deletable" => "Deletable",
// "Flag field that permit to delete or not tasks" => "Flag field that permit to delete or not tasks",
// "Parent Writable" => "Parent Writable",
// "Flag field to write or not in parent tasks" => "Flag field to write or not in parent tasks",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer",
// "Tracker data source not found" => "Tracker data source not found",
// "Order tracker field parameter is mandatory" => "Order tracker field parameter is mandatory",
// "Level tracker field parameter is mandatory" => "Level tracker field parameter is mandatory",
// "Depends tracker field parameter is mandatory" => "Depends tracker field parameter is mandatory",
// "You are trying to update a tracker that is not used by this gantt chart" => "You are trying to update a tracker that is not used by this gantt chart",
// "Gantt chart updated" => "Gantt chart updated",
"Gauge" => "Jauge",
"Display a horizontal bar gauge" => "Onyesha bar ya usawa",
"description" => "maelezo",
"Current value to be represented by the gauge" => "Thamani ya sasa ili kuonyeshwa na bar ya maendeleo",
"Maximum Value" => "Thamani ya juu",
// "Maximum possible value. Default: %0" => "Maximum possible value. Default: %0",
"Label displayed on the left side of the gauge" => "Lebo iliyoonyeshwa upande wa kushoto wa Kipimo",
"Color" => "Rangi",
"Main color of the gauge. Use HTML color codes or names" => "Rangi kuu ya bar ya maendeleo. Tumia codes za HTML au majina ya rangi",
"Background color of the gauge. Use HTML color codes or names." => "Background ya bar ya maendeleo. Tumia codes za HTML au majina ya rangi",
"Bar width in pixels." => "Upana wa bar ya maendeleo katika pixels.",
"Label Width" => "Upana wa lebo",
"Label width, in pixels" => "Upana kwa pixels zilizotengwa kwa lebo",
"Display Percentage" => "Onyesha asilimia",
// "Set to %0 (Yes) to display a percentage of the maximum" => "Set to %0 (Yes) to display a percentage of the maximum",
"Display Value" => "Onyesha thamani",
// "Set to %1 (No) to hide the numeric value (shown by default)" => "Set to %1 (No) to hide the numeric value (shown by default)",
"Bar height in pixels." => "Urefu wa bar ya maendeleo katika pixels.",
// "GDGraph" => "GDGraph",
// "Create a simple graph from supplied data" => "Create a simple graph from supplied data",
// "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body" => "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body",
// "14, backported to 12.4" => "14, backported to 12.4",
// "Graph Type" => "Graph Type",
// "Defines what ype of graph or chart is to be generated" => "Defines what ype of graph or chart is to be generated",
// "Vertical Bar" => "Vertical Bar",
// "Graph Title" => "Graph Title",
// "Displayed above the graph" => "Displayed above the graph",
// "Alt Tag" => "Alt Tag",
// "Text for image alt tag" => "Text for image alt tag",
// "Graph Image Width" => "Graph Image Width",
// "Overall width in pixels. Default value is %0" => "Overall width in pixels. Default value is %0",
// "Graph Image Height" => "Graph Image Height",
// "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown" => "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Display a link on a secure page using an access token" => "Display a link on a secure page using an access token",
// "Entry Patg" => "Entry Patg",
// "The path or part of the path that the token is for" => "The path or part of the path that the token is for",
// "Query Keys" => "Query Keys",
// "Query string parameter keys that the token is for, separated by a colon (:)" => "Query string parameter keys that the token is for, separated by a colon (:)",
// "Query Values" => "Query Values",
// "Query string parameter values that the token is for, separated by a colon (:)" => "Query string parameter values that the token is for, separated by a colon (:)",
"Google Analytics" => "Google Analytics",
"Add the tracking code for Google Analytics" => "Ongeza code wa kufuatilia kwa Google Analytics",
"Account Number" => "Nambari ya Akaunti",
// "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1" => "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1",
// "Groups Option" => "Groups Option",
// "Define option for Google Analytics groups, include or exclude" => "Define option for Google Analytics groups, include or exclude",
// "Available Groups" => "Available Groups",
// "Google Analytics Chart" => "Google Analytics Chart",
// "Draw charts from Google Analytics data" => "Draw charts from Google Analytics data",
// "JSON File" => "JSON File",
// "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)" => "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)",
// "Profle IDs" => "Profle IDs",
// "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin" => "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin",
// "Query String" => "Query String",
// "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0" => "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0",
// "Metrics" => "Metrics",
// "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"" => "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"",
// "default \"30daysAgo\"" => "default \"30daysAgo\"",
// "default \"yesterday\"" => "default \"yesterday\"",
// "Dimensions" => "Dimensions",
// "default \"ga:date\"" => "default \"ga:date\"",
// "Segment" => "Segment",
// "default \"\"" => "default \"\"",
// "Max Results" => "Max Results",
// "default 50" => "default 50",
"Sort" => "Aina",
// "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"" => "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"",
// "Container" => "Container",
// "ID of a DIV to contain the chart (optional)" => "ID of a DIV to contain the chart (optional)",
// "Type of chart, e.g. LINE, PIE etc" => "Type of chart, e.g. LINE, PIE etc",
// "Bar" => "Bar",
// "Pie" => "Pie",
// "Geo" => "Geo",
// "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "googlechart: No credentials file" => "googlechart: No credentials file",
// "googlechart: No query_ids supplied" => "googlechart: No query_ids supplied",
// "googlechart exception: %0" => "googlechart exception: %0",
"Google Doc" => "Google Doc",
"Display a Google document" => "Tazama Hati ya Google",
"Leave this empty" => "Acha tupu",
"Type of Google document" => "Aina ya hati ya Google",
"Document" => "Hati",
// "Slides" => "Slides",
// "Forms" => "Forms",
"Key" => "Ufunguo",
// "Google doc key - for example" => "Google doc key - for example",
"Name of iframe. Default is \"Frame\" + the key" => "Jina la sura (iframe). Kwa default, ni \"Frame\" + ufunguo",
// "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly",
"Width in pixels or %" => "Upana kwa pixels au %",
"Height in pixels or %" => "Urefu katika pixels au %",
// "Position of frame on page" => "Position of frame on page",
"Middle" => "Katikati",
"Frame Border" => "Mpaka wa sura",
"Choose whether to show a border around the iframe" => "Chagua kuonyesha au usiozunguka sura ya nje ya ukurasa",
"Margin Height" => "Urefu wa margin",
"Margin height in pixels" => "Urefu wa margin katika pixels",
"Margin Width" => "Upana wa margin",
"Margin width in pixels" => "Upana wa margin katika pixels",
"Scrolling" => "Scrolling",
"Choose whether to add a scroll bar" => "Chagua kuongeza scrollbar au la",
"Auto" => "Auto",
"Edit Link" => "Badilisha kiungo",
"Choose whether to show an edit link and set its location" => "Chagua ikiwa au kuonyesha kiungo cha hariri na uweka mahali pake",
"Required parameter \"type\" missing" => "Kipimo \"type\" inahitajika haipo",
"Required parameter \"key\" missing" => "Kipimo \"key\" inahitajika haipo",
"Display content based on the user's groups or friends" => "Tazama maudhui yaliyotegemea makundi ya watumiaji au marafiki",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions",
"Allowed User Friends" => "Marafiki wa watumiaji walioidhinishwa",
// "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample",
"Allowed Groups" => "Makundi yaliyoidhinishwa",
// "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample",
"Denied Groups" => "Makundi yaliyokataliwa",
// "Pipe-separated list of groups not allowed to view the block" => "Pipe-separated list of groups not allowed to view the block",
// "Allowed Groups Pending Membership" => "Allowed Groups Pending Membership",
// "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding" => "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding",
// "Allowed Groups Full Membership" => "Allowed Groups Full Membership",
// "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending" => "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending",
"Group Expiration" => "Mwisho wa uanachama wa kikundi",
// "Show the expiration date of a group the user belongs to" => "Show the expiration date of a group the user belongs to",
// "The name of an existing group on the site" => "The name of an existing group on the site",
"not in group" => "si katika kikundi",
"never expires" => "kamwe huisha",
"Group List" => "Orodha ya vikundi",
// "Create a complete or filtered list of groups" => "Create a complete or filtered list of groups",
// "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed",
"Group Homepage" => "Ukurasa wa Mwanzo wa Kikundi",
"Link the group name to the group homepage, if there is one (not linked to by default)" => "Unganisha jina la kikundi kwenye ukurasa wa nyumbani wa kikundi, ikiwa kuna moja (isiyohusishwa na default)",
"Recursively List Groups" => "Orodha ya makundi ya kurudia",
"Recursively list the included groups (the default is to not list them repeatedly)" => "Rejesha orodha ya vikundi vilivyounganishwa (chaguo-msingi ni kuwasajili mara kwa mara)",
// "List only your own" => "List only your own",
// "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)" => "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)",
"GroupMail Core" => "Msingi wa GroupMail",
// "Display GroupMail functions on a page" => "Display GroupMail functions on a page",
"From Email" => "Kutoka barua pepe",
"Email address to report" => "Anwani ya barua pepe ili kuripoti",
"ID of GroupMail Logs tracker (set up in alias by profile)" => "Kitambulisho cha Fomu ya Fungu la GroupMail (kilichowekwa kwenye maelezo kwa wasifu)",
"ID of GroupMail Logs tracker field (usually set up in alias by profile)" => "Kitambulisho cha Maandishi ya GroupMail field wa tracker (kawaida hufafanuliwa katika vidokezo na wasifu)",
"Datetime Field ID" => "Kitambulisho cha field 'Datetime'",
"Group Stats" => "Takwimu za kikundi",
"Show the distribution of users among groups" => "Angalia usambazaji wa watumiaji katika vikundi",
"Groups" => "Makundi",
"Groups, separated by \":\". If empty, all groups will be listed" => "Makundi yaliyotengwa na \":\". Ikiwa tupu, makundi yote yataorodheshwa",
"Percentage of" => "Asilimia ya",
// "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter" => "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter",
// "Users in groups" => "Users in groups",
"Site users" => "Watumiaji wa tovuti",
"Show Percentage" => "Onyesha asilimia",
// "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)" => "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)",
"Show Bar" => "Onyesha Bar",
// "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)",
// "H5P" => "H5P",
// "Enable the creation, sharing and reuse of interactive HTML5 content" => "Enable the creation, sharing and reuse of interactive HTML5 content",
// "The H5P file in a file gallery" => "The H5P file in a file gallery",
// "H5P is not compatible with the Inline comments (annotations) feature" => "H5P is not compatible with the Inline comments (annotations) feature",
// "Has Bought" => "Has Bought",
// "Check whether a user has bought an item or added it to the shopping cart" => "Check whether a user has bought an item or added it to the shopping cart",
// "PluginHasBought" => "PluginHasBought",
// "Key Name" => "Key Name",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Key Labels" => "Key Labels",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
// "Tracker from which to get passcode to check against" => "Tracker from which to get passcode to check against",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
"Please fill in all fields" => "Asante kujaza fields yote",
"HTML" => "HTML",
"Add HTML to a page" => "Ongeza HTML kwenye ukurasa",
"HTML code" => "Code ya HTML",
// "Move to HTML head" => "Move to HTML head",
// "Insert the code in the HTML head section rather than in the body" => "Insert the code in the HTML head section rather than in the body",
"Parse wiki syntax within the HTML code" => "Kufafanua syntax ya wiki ndani ya kanuni ya HTML",
// "HTML Feed" => "HTML Feed",
// "Add an item to HTML Feed" => "Add an item to HTML Feed",
// "Name of this feed" => "Name of this feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Receive and display content from another site sent using PluginHTMLFeed" => "Receive and display content from another site sent using PluginHTMLFeed",
"Initial Value" => "Thamani ya awali",
// "Feed Location" => "Feed Location",
// "Content Name" => "Content Name",
// "Content Style" => "Content Style",
"Highlight" => "Kuonyesha",
"Asterisk" => "Asteriski",
// "HTML Feed Link Type" => "HTML Feed Link Type",
// "Backlink" => "Backlink",
"Popup" => "Popup",
// "Hover" => "Hover",
// "Moderated" => "Moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
// "Display an icon" => "Display an icon",
// "Name of the icon" => "Name of the icon",
// "Valid icon name" => "Valid icon name",
// "Size of the icon (greater than 0 and less than 10)" => "Size of the icon (greater than 0 and less than 10)",
// "greater than 0 and less than 10" => "greater than 0 and less than 10",
"Rotate" => "Zunguka",
// "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)" => "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)",
// "90, 180, 270, horizontal, vertical" => "90, 180, 270, horizontal, vertical",
// "Style supported by the current icon set" => "Style supported by the current icon set",
"Iframe" => "Iframe",
// "Include the body of another web page in a scrollable frame within a page" => "Include the body of another web page in a scrollable frame within a page",
"Frame title" => "Kichwa cha Frame",
"Pixels or %" => "Pixels au %",
"Align the iframe on the page" => "Weka 'iframe' kwenye ukurasa",
// "Responsive" => "Responsive",
// "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device" => "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device",
// "16 by 9" => "16 by 9",
// "4 by 3" => "4 by 3",
"no" => "hapana",
// "Display one or more custom-formatted images" => "Display one or more custom-formatted images",
// "Image Source" => "Image Source",
// "Choose where to get the image from" => "Choose where to get the image from",
// "An image in the file galleries" => "An image in the file galleries",
// "An image attached to a wiki page" => "An image attached to a wiki page",
// "An image anywhere on the Internet" => "An image anywhere on the Internet",
// "One random image from a file gallery" => "One random image from a file gallery",
// "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)",
// "Valid file IDs separated by commas or |" => "Valid file IDs separated by commas or |",
"Image ID" => "Kitambulisho cha picha",
// "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)",
// "Valid image IDs separated by commas or |" => "Valid image IDs separated by commas or |",
// "Full URL to the image to display" => "Full URL to the image to display",
"Numeric ID of a file gallery. Displays a random image from that gallery" => "Kitambulisho cha Nambari ya nyumba ya sanaa ya faili. Inaonyesha picha ya random kutoka kwenye nyumba ya sanaa hii",
"Numeric ID of a file gallery. Displays all images from that gallery" => "Kitambulisho cha Nambari ya nyumba ya sanaa ya faili. Tazama picha zote kutoka kwenye nyumba hii ya sanaa",
"Attachment ID" => "Kitambulisho cha kiambatisho",
// "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)" => "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)",
// "Valid attachment IDs separated by commas or |" => "Valid attachment IDs separated by commas or |",
"Thumbnail" => "Picha ndogo",
// "Makes the image a thumbnail with various options" => "Makes the image a thumbnail with various options",
// "Simple - links to full size image on a new page" => "Simple - links to full size image on a new page",
// "\"Lightbox\" - enlarges in an overlay box when clicked" => "\"Lightbox\" - enlarges in an overlay box when clicked",
// "Mouseover - enlarges in a popup when moused over" => "Mouseover - enlarges in a popup when moused over",
// "Mouseover (sticky)" => "Mouseover (sticky)",
// "Popup - enlarges in a separate window" => "Popup - enlarges in a separate window",
// "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1" => "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1",
// "Image Height" => "Image Height",
// "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Image Width" => "Image Width",
// "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Serve retina images" => "Serve retina images",
// "Serves up retina images to high density screen displays. Width must be set to use this" => "Serves up retina images to high density screen displays. Width must be set to use this",
// "Responsive Image Widths" => "Responsive Image Widths",
// "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"" => "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"",
// "Sizes" => "Sizes",
// "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters" => "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters",
// "Maximum Size" => "Maximum Size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings",
// "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description" => "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description",
// "Alternate Text" => "Alternate Text",
"Alternate text that displays when image does not load. Set to \"Image\" by default" => "Maandiko mbadala inayoonyeshwa wakati picha haiwezi kubeba. Weka kwa default \"Image\"",
// "Responsive Image" => "Responsive Image",
// "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class" => "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class",
// "Featured Image" => "Featured Image",
// "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose" => "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose",
"Comment Ascending" => "Maoni katika utaratibu wa unaoongezeka",
"Comment Descending" => "Maoni katika utaratibu wa kushuka",
"Max Hits Ascending" => "Max Hits katika utaratibu wa unaoongezeka",
"Max Hits Descending" => "Max Hits katika utaratibu wa kushuka",
"User Ascending" => "Mtumiaji katika utaratibu wa unaoongezeka",
"User Descending" => "Mtumiaji katika utaratibu wa kushuka",
"Author Ascending" => "Mwandishi katika utaratibu wa unaoongezeka",
"Author Descending" => "Mwandishi katika utaratibu wa kushuka",
"Locked By Ascending" => "'Imefungwa na' katika utaratibu wa unaoongezeka",
"Locked By Descending" => "'Imefungwa na' katika utaratibu wa kushuka",
"Last modified User Ascending" => "Mabadiliko ya mwisho katika utaratibu wa unaoongezeka",
"Last modified User Descending" => "Mabadiliko ya mwisho katika utaratibu wa kushuka",
"Last modified Date Ascending" => "Tarehe ya mabadiliko ya mwisho katika utaratibu wa unaoongezeka",
"Last modified Date Descending" => "Tarehe ya mabadiliko ya mwisho katika utaratibu wa kushuka",
"Delete After Ascending" => "'Futa Baada' katika utaratibu wa unaoongezeka",
"Delete After Descending" => "'Futa Baada' katika utaratibu wa kushuka",
"Votes Ascending" => "Kura katika utaratibu wa unaoongezeka",
"Votes Descending" => "Kura katika utaratibu wa kushuka",
"Points Ascending" => "Pointi katika utaratibu wa unaoongezeka",
"Points Descending" => "Pointi katika utaratibu wa kushuka",
"Archive ID Ascending" => "Kitambulisho cha Kumbukumbu katika utaratibu wa unaoongezeka",
"Archive ID Descending" => "Kitambulisho cha Kumbukumbu katika utaratibu wa kushuka",
// "Enlarge Button" => "Enlarge Button",
// "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1" => "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1",
"Browse Popup" => "Vinjari katika Popup",
// "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked" => "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked",
// "Image Map" => "Image Map",
"Name of the image map to use for the image" => "Jina la picha 'map' ya kutumia na picha",
// "Horizontal spacing" => "Horizontal spacing",
// "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Vertical spacing" => "Vertical spacing",
// "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Align image using legacy align tag" => "Align image using legacy align tag",
// "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email" => "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email",
// "Align Image" => "Align Image",
// "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page" => "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page",
// "Image Style" => "Image Style",
// "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects" => "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects",
// "Align Image Block" => "Align Image Block",
// "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1" => "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1",
// "Image Block Style" => "Image Block Style",
// "Description Style" => "Description Style",
// "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects" => "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects",
// "Wrapping" => "Wrapping",
"Control how other items wrap around the image" => "Dhibiti jinsi vipengele vingine vimewekwa karibu na picha",
// "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows" => "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows",
// "Link Title" => "Link Title",
// "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties" => "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties",
"Metadata" => "Metadata",
// "Display the image metadata (IPTC, EXIF and XMP information)" => "Display the image metadata (IPTC, EXIF and XMP information)",
// "Compression Quality" => "Compression Quality",
// "0 to 100 (default is 75)" => "0 to 100 (default is 75)",
// "Default Settings" => "Default Settings",
// "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Mandatory Setting" => "Mandatory Setting",
// "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Image Gallery Image" => "Image Gallery Image",
"Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Nyumba ya sanaa ya picha ya kuvinjari dirisha kwa picha itafunguliwa wakati thumbnail imefungwa ikiwa picha iko kwenye nyumba ya sanaa ya Tiki",
"Same as \"browse\" except that the page opens in a new window or tab" => "Sawa na \"browse\" isipokuwa kwamba ukurasa unafungua kwenye dirisha mpya au tab",
"Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Inafanya picha thumbnail ambayo inenea kwa ukubwa kamili wakati unapobofya au moused juu (isipokuwa \"link\" imewekwa kwenye lengo lingine). \"browse\" na \"browsepopup\" zimetumika tu na nyumba ya picha na \"download\" imetumika na nyumba ya faili au viambatisho",
// "Hide Draw Icon" => "Hide Draw Icon",
// "Do not show draw/edit icon button under image" => "Do not show draw/edit icon button under image",
// "Overlay with zoom" => "Overlay with zoom",
// "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked" => "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked",
// "Zoom" => "Zoom",
// "Adds a magnifying glass icon and zooms the image when hovered over" => "Adds a magnifying glass icon and zooms the image when hovered over",
"PluginImg: User lacks permission to view image" => "PluginImg: Mtumiaji hana ruhusa ya kuona picha",
"File is not an image" => "Faili sio picha",
"Server does not support image manipulation" => "Seva hairuhusu uharibifu wa picha",
// "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator" => "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator",
// "SVG Image replace error \"%0\"" => "SVG Image replace error \"%0\"",
"Enlarge" => "Ongeza",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''",
"''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Tumia moja na moja tu ya vigezo vifuatavyo: fileId, randomGalleryId, fgalId, attId, id, ou src.''",
"Draw on the Image" => "Chora kwenye picha",
"Include" => "Weka",
// "Include a portion of another wiki page" => "Include a portion of another wiki page",
// "Name of the source wiki page (which contains the included portion)" => "Name of the source wiki page (which contains the included portion)",
// "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start",
"Stop" => "Mwisho",
// "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end",
// "Read more button" => "Read more button",
// "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)" => "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)",
// "Read more button label" => "Read more button label",
// "Label of the button linking to the source page (if it is displayed)" => "Label of the button linking to the source page (if it is displayed)",
// "Text to show when the page selected to be included is not found anymore" => "Text to show when the page selected to be included is not found anymore",
// "Permission denied message" => "Permission denied message",
// "Text to show when the page exists but the user has insufficient permissions to see it" => "Text to show when the page exists but the user has insufficient permissions to see it",
// "No version approved error message" => "No version approved error message",
// "Text to show when the page exists but no version is approved" => "Text to show when the page exists but no version is approved",
// "Edit Icon" => "Edit Icon",
// "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings" => "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings",
// "Max inclusions" => "Max inclusions",
// "Maximum amount of times the same page can be included. Defaults to 5" => "Maximum amount of times the same page can be included. Defaults to 5",
// "Parse Included Page" => "Parse Included Page",
// "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents" => "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents",
// "Max characters included" => "Max characters included",
// "Limit the length of the included text" => "Limit the length of the included text",
"Read more" => "Lire plus",
// "The text above comes from page \"%s\". Click to go to that page" => "The text above comes from page \"%s\". Click to go to that page",
"Include Plugin" => "Weka Plugin",
"Edit the included page" => "Badilisha ukurasa uliohusishwa",
// "Include Template File" => "Include Template File",
// "Include a Smarty template (.tpl) file in a page" => "Include a Smarty template (.tpl) file in a page",
// "TPL file name" => "TPL file name",
// "If you need to include Smarty template files" => "If you need to include Smarty template files",
// "Values passed to the TPL" => "Values passed to the TPL",
// "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1" => "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1",
// "Include URL" => "Include URL",
// "Include the body content from a URL" => "Include the body content from a URL",
// "URL to external file to include" => "URL to external file to include",
// "Missing parameter url for plugin %0" => "Missing parameter url for plugin %0",
// "Insert Tracker Item" => "Insert Tracker Item",
// "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item" => "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item",
// "Item not inserted" => "Item not inserted",
"Invite" => "Kukaribisha",
"Invite a user to join your groups" => "Karibisha mtumiaji kujiunga na vikundi vyako",
"Confirmation message after posting form" => "Ujumbe wa uthibitisho baada ya kutuma fomu",
"Including Group" => "Kikundi kilicho na",
"Will list only the groups that include this group" => "Utaweka orodha ya vikundi ambavyo vinajumuisha kikundi hiki",
"Default Group" => "Kikundi cha chaguo-msingi",
"Dropdown list will show this group by default" => "Orodha ya kushuka chini itaonyesha kikundi hiki cha msingi",
// "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default",
"The following mandatory fields are missing" => "Fields yanayotakiwa yafuatayo yanahitajika",
"Email address" => "Anwani ya barua pepe",
// "Add jQuery JavaScript code" => "Add jQuery JavaScript code",
"JavaScript code" => "JavaScript code",
"Not On Ready" => "Hapana 'On Ready'",
"Do not execute on document ready (execute inline)" => "Usitekeleze kwenye waraka tayari (fanya inline)",
"No JavaScript" => "Hakuna JavaScript",
"Optional markup for when JavaScript is off" => "Markup kwa hiari wakati Javascript imezimwa",
// "Language to apply JQuery to" => "Language to apply JQuery to",
"<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq Plugin haifanyi kazi: JavaScript imeondolewa -->",
"JavaScript" => "Javascript",
// "Add JavaScript code or files" => "Add JavaScript code or files",
"JavaScript filename" => "Jina la faili la JavaScript",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
"Display a video created through the Kaltura feature" => "Tazama video iliyoundwa na kipengele cha Kaltura",
"Kaltura Entry ID" => "Kitambulisho cha kuingia Kaltura",
// "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one" => "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one",
// "Kaltura Video Player ID" => "Kaltura Video Player ID",
// "Width of the player in pixels or percent" => "Width of the player in pixels or percent",
// "Height of the player in pixels or percent" => "Height of the player in pixels or percent",
// "Align" => "Align",
// "Alignment of the player" => "Alignment of the player",
// "Not set" => "Not set",
// "Centre" => "Centre",
// "Alignment of the player using CSS float" => "Alignment of the player using CSS float",
// "Add Media Button Label" => "Add Media Button Label",
// "Text to display on button for adding new media" => "Text to display on button for adding new media",
// "Add media" => "Add media",
// "Player Type" => "Player Type",
// "Set player type" => "Set player type",
// "KDP" => "KDP",
// "HTML5" => "HTML5",
// "Upload Media" => "Upload Media",
// "Media ID or permission to upload video is required" => "Media ID or permission to upload video is required",
// "Log in to upload video" => "Log in to upload video",
// "Player not found" => "Player not found",
// "Kaltura player: unsupported type" => "Kaltura player: unsupported type",
// "Show alternative content based on the page language" => "Show alternative content based on the page language",
// "Content to show" => "Content to show",
// "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Not Language" => "Lugha zilizokataliwa",
// "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
"Show the last modification date for a page" => "Angalia tarehe ya mwisho ya mabadiliko ya mwisho ya ukurasa",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
"Date format" => "Format ya tarehe",
// "Set date and time format according to site settings" => "Set date and time format according to site settings",
// "Long date" => "Long date",
// "Short date" => "Short date",
// "Long datetime" => "Long datetime",
// "Short datetime" => "Short datetime",
// "ISO" => "ISO",
// "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects" => "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects",
// "Display page header" => "Display page header",
// "Set to No, to hide header on the page" => "Set to No, to hide header on the page",
// "Display Page Footer" => "Display Page Footer",
// "Display Page Left Bar" => "Display Page Left Bar",
// "Set to No, to hide left on the page" => "Set to No, to hide left on the page",
// "Display Page Right Bar" => "Display Page Right Bar",
// "Set to No, to hide right on the page" => "Set to No, to hide right on the page",
// "Page Full Width" => "Page Full Width",
// "100% Page width" => "100% Page width",
// "Page Content Width" => "Page Content Width",
// "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)" => "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)",
// "Page Background Image URL" => "Page Background Image URL",
// "Enter image url, in case of single image" => "Enter image url, in case of single image",
// "Background Repear" => "Background Repear",
// "Cover,Repeat,no-repeat" => "Cover,Repeat,no-repeat",
// "Page Background Sliding Images" => "Page Background Sliding Images",
// "Enter file gallery id for fading background" => "Enter file gallery id for fading background",
// "Page Content Top Margin" => "Page Content Top Margin",
// "Enter value in % or px for example 30%, 300px, default will be 0" => "Enter value in % or px for example 30%, 300px, default will be 0",
// "Page Header Width" => "Page Header Width",
// "Enter page header width in px or %, leave blank for same width as page body.)" => "Enter page header width in px or %, leave blank for same width as page body.)",
// "Page Footer Width" => "Page Footer Width",
// "Enter page footer width in px or %, leave blank for same width as page body.)" => "Enter page footer width in px or %, leave blank for same width as page body.)",
// "Page Background Color" => "Page Background Color",
// "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)" => "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)",
// "Content Background Color" => "Content Background Color",
// "Content Text Color" => "Content Text Color",
// "Enter a valid CSS color code, for example #000,#fff,#ccc" => "Enter a valid CSS color code, for example #000,#fff,#ccc",
// "Content Border Radius" => "Content Border Radius",
// "To make content div round cornered, for example 10px" => "To make content div round cornered, for example 10px",
// "Content Border Shadow" => "Content Border Shadow",
// "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)" => "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)",
// "Transition Delay" => "Transition Delay",
// "Time interval to pause before moving to next slide in seconds" => "Time interval to pause before moving to next slide in seconds",
// "Display Page Action Buttons" => "Display Page Action Buttons",
// "Set to No, to hide page action buttons, with and under content" => "Set to No, to hide page action buttons, with and under content",
// "Display top bar(under header)" => "Display top bar(under header)",
// "Set to No, to hide topbar on the page" => "Set to No, to hide topbar on the page",
// "Display page top bar(above page content)" => "Display page top bar(above page content)",
// "Set to No, to hide page topbar module zone" => "Set to No, to hide page topbar module zone",
// "Display page bottom bar(under page content)" => "Display page bottom bar(under page content)",
// "Set to No, to hide page bottom bar module zone" => "Set to No, to hide page bottom bar module zone",
// "Create a \"Like\" button" => "Create a \"Like\" button",
// "Count only" => "Count only",
// "Sets whether to only show the count of likes rather than give the option to vote" => "Sets whether to only show the count of likes rather than give the option to vote",
// "Search for, list, and filter all types of items and display custom-formatted results" => "Search for, list, and filter all types of items and display custom-formatted results",
// "Use List GUI" => "Use List GUI",
// "Use the graphical user interface for editing this list plugin" => "Use the graphical user interface for editing this list plugin",
// "Cache Output" => "Cache Output",
// "Cache output of this list plugin" => "Cache output of this list plugin",
// "Cache Expiry Time" => "Cache Expiry Time",
// "Time before cache is expired in minutes" => "Time before cache is expired in minutes",
// "Cache Purge Rules" => "Cache Purge Rules",
// "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches" => "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches",
// "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block" => "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block",
// "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine" => "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine",
// "Error: {MULTISEARCH(id=x)} needs an ID to be specified" => "Error: {MULTISEARCH(id=x)} needs an ID to be specified",
// "List Execute" => "List Execute",
// "Set custom actions that can be executed on a filtered list of objects" => "Set custom actions that can be executed on a filtered list of objects",
// "Invalid action: %0" => "Invalid action: %0",
// "There are too many search result items to apply %0 action to" => "There are too many search result items to apply %0 action to",
// "Unknown error executing action %0 on item %1" => "Unknown error executing action %0 on item %1",
// "Error executing action %0 on item %1" => "Error executing action %0 on item %1",
// "Action %0 executed successfully on %1 item(s)" => "Action %0 executed successfully on %1 item(s)",
"List Pages" => "Orodha ya kurasa",
"List pages based on various criteria" => "Andika orodha kulingana na vigezo mbalimbali",
"Result number at which the listing should start" => "Idadi ya matokeo ambayo orodha inapaswa kuanza",
"Limit number of items displayed in the list. Default is to display all" => "Weka idadi ya vitu vilivyoonyeshwa kwenye orodha. Default: Onyesha yote",
"Initial" => "Mwanzo wa jina",
// "Initial page to show" => "Initial page to show",
"Show Name Only" => "Onyesha jina tu",
"Show only the page names" => "Onyesha majina ya ukurasa tu",
// "Category Filter" => "Category Filter",
// "Filter categories by Id numbers. Use different separators to filter as follows" => "Filter categories by Id numbers. Use different separators to filter as follows",
// "Page is in any of the specified categories. Example" => "Page is in any of the specified categories. Example",
// "Page must be in all of the specified categories. Example" => "Page must be in all of the specified categories. Example",
// "Page is in the first specified category and not in any of the others. Example" => "Page is in the first specified category and not in any of the others. Example",
// "Valid category ID or list separated by :, + or -" => "Valid category ID or list separated by :, + or -",
"Structure Head" => "kichwa cha muundo",
"Filter by structure head" => "Futa kwa kichwa cha muundo",
"Show Page Alias" => "Onyesha Alias ​​ya Ukurasa",
"Show page alias in the list" => "Onyesha Alias ​​ya Ukurasa katika orodha",
// "Include Tag" => "Include Tag",
// "Only pages with specific tag (separate tags using %0)" => "Only pages with specific tag (separate tags using %0)",
// "Exclude Tag" => "Exclude Tag",
// "Only pages with specific tag excluded (separate tags using %0)" => "Only pages with specific tag excluded (separate tags using %0)",
// "Show Number of Pages" => "Show Number of Pages",
// "Show the number of pages matching criteria" => "Show the number of pages matching criteria",
"Only pages with names similar to the text entered for this parameter will be listed" => "Kurasa tu na majina sawa na maandiko yaliyoingia kwa parameter hii yataorodheshwa",
"Two-letter language code to filter pages listed" => "Msimbo wa lugha mbili za kufuta orodha ya kurasa",
"Orphan Language" => "Lugha yatima",
// "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed" => "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed",
"Load Translations" => "Fungua tafsiri",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter",
"Page name and text entered for the filter parameter must match exactly to be listed" => "Jina la ukurasa na maandishi yaliyoingia kama parameter ya kichujio lazima inalingane hasa kwa ukurasa unaoorodheshwa",
"Only Orphan Pages" => "Kurasa yatima tu",
"Only list orphan pages" => "Weka tu kurasa za yatima",
"For List Pages" => "Kwa orodha ya kurasa",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples" => "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples",
// "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start",
// "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end",
"Length" => "Urefu",
"Number of characters to display" => "Idadi ya maandishi zilizoonyeshwa",
// "Checkboxes" => "Checkboxes",
// "Offset Argument" => "Offset Argument",
"Pagination" => "Pagination",
// "Exclude Page(s)" => "Exclude Page(s)",
// "Wiki page names to be excluded from list" => "Wiki page names to be excluded from list",
// "Local Files" => "Local Files",
// "Show a link to local or shared files and directories" => "Show a link to local or shared files and directories",
// "Local file or directory path" => "Local file or directory path",
"List Directory" => "Orodha ya directory",
// "If the path above is a directory then list the contents" => "If the path above is a directory then list the contents",
// "Show MIME file-type icons" => "Show MIME file-type icons",
// "List files in a directory" => "List files in a directory",
"Full path to the server-local directory. Default is the document root" => "Njia kamili kwenye directory ya ndani ya seva. Mchapishaji ni mizizi ya hati",
"URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example" => "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example",
"Set the sort order of the file list" => "Weka utaratibu wa orodha ya faili",
"File Name" => "Jina la faili",
"File Size" => "Urefu za faili",
"Last Access" => "Ufikiaji wa mwisho",
"Last Metadata Change" => "Mabadiliko ya mwisho ya Metadata",
// "Only list files with file names that contain this filter. Example" => "Only list files with file names that contain this filter. Example",
"Limit" => "Mpaka",
"Maximum amount of files to display. Default is no limit" => "Idadi kubwa ya faili za kuonyesha. Mchapishaji: hakuna kikomo",
"could not be opened because it doesn't exist or permission was denied" => "haiwezi kufunguliwa kwa sababu haipo au huna haki",
"Mail" => "Barua",
// "Mail other users or groups" => "Mail other users or groups",
"Limit the list of groups to the groups including each group" => "Punguza orodha ya makundi kwa wale wanaojumuisha kila kikundi",
// "Group Dropdown" => "Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse Groups" => "Recurse Groups",
// "Show each group and each group included in this group" => "Show each group and each group included in this group",
// "Recurse Group Users" => "Recurse Group Users",
// "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times..." => "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times...",
// "User Dropdown" => "User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Emails" => "User Emails",
// "Show a box for user to enter email addresses" => "Show a box for user to enter email addresses",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "Show in popup instead of inline" => "Show in popup instead of inline",
// "Text to show on the button to send emails (default: %0Send mail%1)" => "Text to show on the button to send emails (default: %0Send mail%1)",
// "Send mail" => "Send mail",
// "Email Subject" => "Email Subject",
// "Present Email subject content" => "Present Email subject content",
// "Bypass Preview" => "Bypass Preview",
// "Send emails without first previewing" => "Send emails without first previewing",
// "Debug mode (admins only)" => "Debug mode (admins only)",
// "Show list of emails that are sent (admins only)" => "Show list of emails that are sent (admins only)",
// "Mail send was unsuccessful" => "Mail send was unsuccessful",
"Map" => "Map",
"Display a map" => "Onyesha map",
// "Instructions to load content" => "Instructions to load content",
"Scope" => "Upeo",
// "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1" => "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1",
// "Controls" => "Controls",
// "Comma-separated list of map controls will be displayed on the map and around it" => "Comma-separated list of map controls will be displayed on the map and around it",
"Width of the map in pixels" => "Upana wa map katika pixels",
"Height of the map in pixels" => "Urefu wa map katika pixels",
// "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1" => "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1",
// "Popup Style" => "Popup Style",
// "Alter the way the information is displayed when objects are loaded on the map" => "Alter the way the information is displayed when objects are loaded on the map",
// "Bubble" => "Bubble",
"MapServer File" => "Faili ya MapServer",
"MapServer file identifier. Only fill this in if you are using MapServer" => "Kitambulisho cha faili ya MapServer. Ili kujazwa tu ikiwa unatumia MapServer",
"Extents" => "Extents",
"Size of the map" => "Urefu wa map",
// "Show item name in a tooltip on hover" => "Show item name in a tooltip on hover",
// "Open Layers Version" => "Open Layers Version",
// "OL2 or OL3+ so far (default ol2)" => "OL2 or OL3+ so far (default ol2)",
// "OpenLayers 2.x" => "OpenLayers 2.x",
// "Tileset layers" => "Tileset layers",
// "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)" => "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)",
// "Cluster Distance" => "Cluster Distance",
// "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)" => "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)",
// "Cluster Hover Behavior" => "Cluster Hover Behavior",
// "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)" => "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)",
// "Show Features" => "Show Features",
// "Cluster Fill Color" => "Cluster Fill Color",
// "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)" => "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)",
// "Cluster Text Color" => "Cluster Text Color",
// "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)" => "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)",
// "Color Picker" => "Color Picker",
// "Markdown" => "Markdown",
// "Parse the body of the plugin using a Markdown parser" => "Parse the body of the plugin using a Markdown parser",
// "Markdown syntax to be parsed" => "Markdown syntax to be parsed",
"Mayan Calendars" => "Kalenda ya ba Maya",
"Convert a Gregorian date to a Mayan calendar date" => "Badilisha tarehe ya Gregorian hadi tarehe ya kalenda ya Maya",
"You must use the variable substitution" => "Lazima utumie thamani ya kubadilisha",
"LongCount: " => "LongCount: ",
"Tzolkin: " => "Tzolkin: ",
"Haab: " => "Haab: ",
"Misc: " => "Misc: ",
"Example: template " => "Mfano: template ",
// "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
"Default template: " => "Template ya msingi: ",
"Gregorian date" => "Tarehe ya Gregorian",
// "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date" => "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date",
" is not a valid date format. should be dd.mm.yyyy" => " sio tarehe ya halali. lazima iwe dd.mm.yyyy",
"Media Player" => "Media Player",
"Add a media player to a page" => "Ongeza Media Player kwa ukurasa",
"Allow full-screen" => "Ruhusu skrini kamili",
"Allow full-screen mode" => "Ruhusu hali ya skrini kamili",
"MP3 URL" => "URL ya faili ya MP3",
"FLV URL" => "URL ya faili ya FLV",
// "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled" => "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled",
// "Player width in px or %" => "Player width in px or %",
// "Player height in px or %" => "Player height in px or %",
// "Set the style" => "Set the style",
"Media Type" => "Aina ya Vyombo vya Habari (media)",
// "Media type for HTML5" => "Media type for HTML5",
// "Audio" => "Audio",
// "Video" => "Video",
"Flash Window Mode" => "Aina ya 'Flash Window'",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: ",
"Transparent" => "Uwazi",
"Opaque" => "Opaque",
"Window" => "Window",
// "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)" => "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)",
// "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)" => "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)",
// "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below" => "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below",
// "Download file" => "Download file",
"Member List" => "Orodha ya wanachama",
"List and allow editing of group members" => "Kuorodhesha na kuruhusu uhariri wa wanachama wa kikundi",
// "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated" => "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated",
// "Descriptions" => "Descriptions",
"Display group descriptions below list name" => "Onyesha maelezo ya kikundi chini ya jina la orodha",
"How to show the member lists" => "Jinsi ya kuonyesha orodha ya wanachama",
"Maximum" => "Maximum",
// "Maximum number of users to list in each group (default %0100%1)" => "Maximum number of users to list in each group (default %0100%1)",
"Members Only" => "Wanachama Tu",
// "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user" => "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user",
"Sort mode" => "Aina la kuchagua",
"Sort mode for member listing" => "Aina la kuchagua kwa orodha ya wanachama",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
"Suggested" => "Imependekezwa",
"Required" => "Inahitajika",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
// "Notify Added User" => "Notify Added User",
// "Notify Removed User" => "Notify Removed User",
// "Email notification to removed user" => "Email notification to removed user",
// "Need Approval" => "Need Approval",
// "Add approve/reject user buttons for private addon groups" => "Add approve/reject user buttons for private addon groups",
"Member Payment" => "Malipo ya mwanachama",
// "Receive payment from a member to extend membership to a group" => "Receive payment from a member to extend membership to a group",
"Name of the group for which the subscription should be added or extended" => "Jina la kikundi ambacho usajili unapaswa kuongezwa au kupanuliwa",
"Price per period (%0)" => "Bei kwa kipindi (%0)",
"Current User Member" => "Mtumiaji wa sasa",
"Membership only for the current user" => "Uanachama tu kwa mtumiaji wa sasa",
"Input Title" => "Kichwa cha Input",
// "Title of the initial input form" => "Title of the initial input form",
// "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years" => "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years",
"Supports wiki syntax" => "Inasaidia syntax ya wiki",
// "Input Title Only" => "Input Title Only",
// "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well" => "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well",
// "Initial Payment Form Title" => "Initial Payment Form Title",
// "Add a title to the payment form when initially shown after clicking \"Continue\"" => "Add a title to the payment form when initially shown after clicking \"Continue\"",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years",
// "Payment Form Title Only" => "Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well",
// "Subsequent Payment Form Title" => "Subsequent Payment Form Title",
// "Title of the payment form after the initial showing" => "Title of the payment form after the initial showing",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years",
// "Subsequent Payment Form Title Only" => "Subsequent Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well",
// "Prevent Double Request" => "Prevent Double Request",
"Prevent user from extended if there is already a pending request" => "Weka mtumiaji wa ugani ikiwa ombi inasubiri",
// "Free Periods" => "Free Periods",
// "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought",
// "Hide Period" => "Hide Period",
// "Do not allow user to set period - use default of 1" => "Do not allow user to set period - use default of 1",
// "Periods Label" => "Periods Label",
// "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)" => "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)",
// "Page that payment service returns to after processing" => "Page that payment service returns to after processing",
// "Annual, commencing %0 %1 each year" => "Annual, commencing %0 %1 each year",
// "Monthly, commencing on day %0 each month" => "Monthly, commencing on day %0 each month",
"The user " => "Mtumiaji ",
" already has a pending extension request payment invoice " => " tayari ina idhini ya malipo ya ombi ya ugani ",
// "%0 to %1 %2 for %3" => "%0 to %1 %2 for %3",
// "periods" => "periods",
// "period" => "period",
// "Membership to %0 for %1 users for %2 %3" => "Membership to %0 for %1 users for %2 %3",
"The group " => "Kundi ",
" does not have a membership term" => " hauna muda wa uanachama",
" Go to " => " Enda kwa",
"Admin > Groups" => "Admin > Vikundi",
" to specify a term for this group by automatically unassigning users after a certain number of days" => " kutaja neno kwa kikundi hiki kwa kusitisha kwa urahisi watumiaji baada ya idadi fulani ya siku",
" does not exist" => " haipo",
// "MetaTag" => "MetaTag",
// "Add custom meta tags to the HTML head section of the page where the plugin is used" => "Add custom meta tags to the HTML head section of the page where the plugin is used",
// "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here" => "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here",
// "Name attribute of the meta tag" => "Name attribute of the meta tag",
// "Content attribute of the meta tag" => "Content attribute of the meta tag",
"Mini Quiz" => "Jaribio ya kidogo",
"Create a quiz using a tracker" => "Unda jaribio kwa kutumia tracker",
"Instructions::Feedback" => "Maelekezo::Maoni",
"Numeric value representing the miniquiz tracker ID" => "Thamani ya namba inayowakilisha ID ya tracker ya jaribio ya kidogo",
"Module" => "Moduli",
"Display a module" => "Onyesha moduli",
"Module Name" => "Jina la moduli",
"Module name as known in Tiki" => "Jina la moduli kama linajulikana katika Tiki",
// "Select Yes (%0y%1) to hide the title (default is to show the title)" => "Select Yes (%0y%1) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)" => "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)",
"Align the module to the left or right on the page allowing other elements to align against it" => "Weka moduli kwenye upande wa kushoto au wa kulia wa ukurasa kuruhusu vitu vingine kuzingatia",
// "Number of rows (default: %010%1)" => "Number of rows (default: %010%1)",
"Parse" => "Kuchambua",
"Parse wiki syntax" => "Kuchambua syntax ya Wiki",
// "Show only the content with no title or borders, etc. around the content" => "Show only the content with no title or borders, etc. around the content",
"Title, background, etc" => "Kichwa, background, etc",
"Show module title (heading) background, etc. (default is to show them)" => "Onyesha kichwa cha moduli (heading), background, nk. (Kuwaonyesha iko kama msingi)",
// "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)" => "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)" => "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing div element, for example, %0max-width:80%%1" => "Inline CSS for the containing div element, for example, %0max-width:80%%1",
// "Valid CSS styling" => "Valid CSS styling",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
"Custom CSS class" => "Darasa la CSS la kawaida",
// "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons",
// "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above",
// "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated" => "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated",
// "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module",
"Please choose a module" => "Tafadhali chagua moduli",
"to be used as argument" => "kutumiwa kama parameter",
"Sorry, no such module" => "Samahani moduli haipo",
// "Module List" => "Module List",
// "Display the modules assigned to a zone" => "Display the modules assigned to a zone",
// "Zone Name" => "Zone Name",
// "The name of the module zone to include. Can be a custom zone name" => "The name of the module zone to include. Can be a custom zone name",
// "Top bar" => "Top bar",
// "Page top" => "Page top",
// "Page bottom" => "Page bottom",
"Monospace" => "Monospace",
"Display text in a monospace font" => "Onyesha maandiko katika Font ya Monospace",
// "Text that the font will be applied to" => "Text that the font will be applied to",
"Font name as recognized by browsers" => "Jina la Font kama kutambuliwa na web browsers",
"Mouseover" => "Mouseover",
// "Display hidden content by mousing over text" => "Display hidden content by mousing over text",
"Hidden content, unless the label parameter is undefined, in which case this is the label" => "Vidokezo vilivyofichwa, isipokuwa mpangilio wa lebo haujafafanuliwa, katika hali hiyo hii ni lebo",
"Text displayed on the page. The body is the hidden content" => "Nakala iliyoonyeshwa kwenye ukurasa. Mwili ni maudhui yaliyofichwa",
"Destination link when mouseover text is clicked. Use http:// for external links" => "Kiungo cha kwenda mahali wakati maandishi ya mouseover yamebofya. Tumia http:// kwa viungo vya nje",
"DEPRECATED" => "IMESHINDWA",
"Hidden content. The body contains the label" => "Maudhui yaliyofichwa. Mwili una lebo",
// "Mouseover box width. Default: %0400px%1" => "Mouseover box width. Default: %0400px%1",
// "Mouseover box height. Default: %0200px%1" => "Mouseover box height. Default: %0200px%1",
"Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1" => "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1",
"Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1" => "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1",
"Parse Body" => "Chambua mwili (body)",
"Parse the body of the plugin as wiki content (parsed by default)" => "Kuchambua mwili wa Plugin kama maudhui ya wiki (kuchambuliwa kwa msingi)",
"Parse Label" => "Chambua lebo",
"Parse the label as wiki content (parsed by default)" => "Kuchambua lebo kama maudhui ya wiki (kuchambuliwa kwa msingi)",
"CSS class to apply" => "CSS darasa la kuomba",
"Background color to apply to the popup" => "Rangi ya background kuomba kwa popup",
"Text Color" => "Rnadi ya maandiko",
"Color to apply to the text in the popup" => "Rangi ya kuomba kwa maandiko kwenye dirisha la popup",
"Sticky" => "Enye mnato",
"When enabled, popup stays visible until it is clicked" => "Ikiwa imewezeshwa, popup inakaa inayoonekana mpaka inapobofya",
"Padding" => "Padding",
"Padding size in pixels" => "Urefu wa Padding katika pixels",
"Effect" => "Madhara",
"Set the type of show/hide animation that will be used" => "Ili kuweka aina ya uonyesho/kujificha uhuishaji ambayo itatumika",
"Effect Speed" => "Kasi ya Athari",
"Set the speed of the animation" => "Ili kuweka kasi ya uhuishaji",
"Close Delay" => "Funga Kuchelewa",
"Number of seconds before popup closes" => "Idadi ya sekunde kabla ya kufunga popup",
// "HTML tag to use for the label. Default %0a%1" => "HTML tag to use for the label. Default %0a%1",
"No label specified" => "Hakuna lebo maalum",
"MediaWiki Table" => "Jedwali la MediaWiki",
// "Display a table using MediaWiki syntax" => "Display a table using MediaWiki syntax",
"Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter" => "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter",
"True" => "Kweli",
"False" => "Uongo",
"Wiki Classes" => "Darasa la Wiki",
// "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)" => "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)",
"MySpace" => "MySpace",
"Display a MySpace Flash mp3 playlist" => "Angalia orodha ya Flash MySpace ya mp3",
"MySpace Page" => "Ukurasa la MySpace",
"MySpace page name" => "Jina la ukurasa MySpace",
// "Network condition" => "Network condition",
// "Display content based on the user's IP address" => "Display content based on the user's IP address",
// "Content to display conditionally" => "Content to display conditionally",
// "IPv4 List" => "IPv4 List",
// "Comma-separated list of IPv4 addresses to match against the visitor's address" => "Comma-separated list of IPv4 addresses to match against the visitor's address",
// "Now" => "Now",
// "Show the current date and time" => "Show the current date and time",
// "Time format using the PHP format described here: %0" => "Time format using the PHP format described here: %0",
// "Based site long date and time setting" => "Based site long date and time setting",
// "Date to display" => "Date to display",
// "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0" => "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0",
// "Allow Invalid Dates" => "Allow Invalid Dates",
// "Allow return values that are not a valid date, such as the day of the month" => "Allow return values that are not a valid date, such as the day of the month",
// "Plugin now when parameter not valid. %0" => "Plugin now when parameter not valid. %0",
// "Object Hits" => "Object Hits",
"Display the number of hits for certain objects" => "Onyesha idadi ya hits kwa vitu fulani",
// "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title" => "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1" => "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1",
// "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits" => "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits",
// "Since a date" => "Since a date",
// "Date since the hits are collected in a format supported by strtotime" => "Date since the hits are collected in a format supported by strtotime",
// "Display a link to an object" => "Display a link to an object",
// "The object type" => "The object type",
// "The item to display" => "The item to display",
// "Tiki Package View" => "Tiki Package View",
// "Display the output of a Tiki Package View" => "Display the output of a Tiki Package View",
// "Package Name" => "Package Name",
// "Name of package in the form %0vendor/name%1" => "Name of package in the form %0vendor/name%1",
// "Name of the view" => "Name of the view",
// "Name of the view file without the %0.php%1" => "Name of the view file without the %0.php%1",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display the content of a wiki page in a set of tabs" => "Display the content of a wiki page in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent",
// "Parameter" => "Parameter",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met",
// "Names of parameters required to display text, separated by %0|%1" => "Names of parameters required to display text, separated by %0|%1",
// "Source where the parameter is checked" => "Source where the parameter is checked",
// "REQUEST" => "REQUEST",
// "GET" => "GET",
// "POST" => "POST",
// "COOKIE" => "COOKIE",
// "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"" => "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"",
// "Show the details of a payment request or invoice" => "Show the details of a payment request or invoice",
"Payment Request Number" => "Nambari ya Ombi la Malipo",
"Unique identifier of the payment request" => "Kitambulisho cha kipekee cha ombi la malipo",
// "Payment List" => "Payment List",
// "Show details of payments. The payments considered may be restrained by user or date" => "Show details of payments. The payments considered may be restrained by user or date",
// "Payment type" => "Payment type",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Authorized" => "Authorized",
// "Output format" => "Output format",
"Total" => "Ote",
// "JSON (for advanced custom usage)" => "JSON (for advanced custom usage)",
// "Payments by a particular user" => "Payments by a particular user",
// "Payer email" => "Payer email",
// "Date range start, accepts most date formats" => "Date range start, accepts most date formats",
// "Date range end" => "Date range end",
// "Advanced filter" => "Advanced filter",
// "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)" => "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)",
// "List offset" => "List offset",
// "For pagination" => "For pagination",
// "Payments per page" => "Payments per page",
// "Automatic (newest first)" => "Automatic (newest first)",
// "User A to Z" => "User A to Z",
// "User Z to A" => "User Z to A",
// "Amount low to high" => "Amount low to high",
// "Amount high to low" => "Amount high to low",
// "Payment: oldest first" => "Payment: oldest first",
// "Payment: newest first" => "Payment: newest first",
// "Request: oldest first" => "Request: oldest first",
// "Request: newest first" => "Request: newest first",
// "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter" => "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter",
// "Plugin paymentlist: Unrecognised type \"%0\"" => "Plugin paymentlist: Unrecognised type \"%0\"",
// "No payments found" => "No payments found",
// "Payments by anonymous where the payer's email is recorded" => "Payments by anonymous where the payer's email is recorded",
// "PayPal Button" => "PayPal Button",
// "Embed a PayPal button" => "Embed a PayPal button",
// "Type of PayPal button" => "Type of PayPal button",
// "Shopping cart" => "Shopping cart",
// "Buy Now" => "Buy Now",
// "Donations" => "Donations",
// "Cart Action" => "Cart Action",
// "Action if Shopping Cart selected for type" => "Action if Shopping Cart selected for type",
// "Add to Cart" => "Add to Cart",
// "View Cart" => "View Cart",
// "Item Name" => "Item Name",
// "Item name or description. Required for Shopping cart" => "Item name or description. Required for Shopping cart",
// "Item price" => "Item price",
// "Button appearance" => "Button appearance",
"Smaller" => "Ndogo sana",
"Custom" => "Desturi",
// "Custom Button" => "Custom Button",
// "Custom button image URL" => "Custom button image URL",
// "Optional item identifier, often a tracker itemId" => "Optional item identifier, often a tracker itemId",
// "Number of items, empty or 0 to have an input the user can fill in" => "Number of items, empty or 0 to have an input the user can fill in",
// "Shipping Cost" => "Shipping Cost",
// "The cost of shipping this item" => "The cost of shipping this item",
// "Additional Shipping Cost" => "Additional Shipping Cost",
// "The cost of shipping each additional unit of this item" => "The cost of shipping each additional unit of this item",
// "Weight of item" => "Weight of item",
// "Weight Unit" => "Weight Unit",
// "The unit of measure if weight is specified" => "The unit of measure if weight is specified",
// "Kilos" => "Kilos",
// "Pounds" => "Pounds",
// "Business ID" => "Business ID",
// "PayPal business name/ID" => "PayPal business name/ID",
// "(Uses value in admin/payment if not set here)" => "(Uses value in admin/payment if not set here)",
// "Use MiniCart" => "Use MiniCart",
// "See https://github.com/jeffharrell/MiniCart" => "See https://github.com/jeffharrell/MiniCart",
// "Shipping Address Prompt" => "Shipping Address Prompt",
// "Indicate whether to prompt for and require an address" => "Indicate whether to prompt for and require an address",
// "Prompt for address" => "Prompt for address",
// "Do not prompt for address" => "Do not prompt for address",
// "Prompt for and require address" => "Prompt for and require address",
// "Completed payment return URL" => "Completed payment return URL",
// "Empty for current page, %0n%1 to disable" => "Empty for current page, %0n%1 to disable",
// "Continue Shopping URL" => "Continue Shopping URL",
// "Cancel payment URL" => "Cancel payment URL",
// "Form title" => "Form title",
// "Tooltip for the form and alt attribute for the image" => "Tooltip for the form and alt attribute for the image",
// "PayPal — The safer, easier way to pay online" => "PayPal — The safer, easier way to pay online",
// "Button text" => "Button text",
// "The checkout button text" => "The checkout button text",
// "Subtotal text" => "Subtotal text",
// "The subtotal text" => "The subtotal text",
// "Discount text" => "Discount text",
// "The discount text" => "The discount text",
// "Shipping text" => "Shipping text",
// "The shipping text" => "The shipping text",
// "Processing text" => "Processing text",
// "The processing text" => "The processing text",
// "PayPal button" => "PayPal button",
// "Item name (item_name) required" => "Item name (item_name) required",
// "Price (amount) required" => "Price (amount) required",
// "For customized PDF generation, to override global PDF settings" => "For customized PDF generation, to override global PDF settings",
// "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\" => "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\",
// "Generate table of contents" => "Generate table of contents",
// "Set if table of contents will be autogenerated before PDF content" => "Set if table of contents will be autogenerated before PDF content",
// "Link TOC headings with content on PDF document" => "Link TOC headings with content on PDF document",
// "Heading to be appeared before table of content is printed" => "Heading to be appeared before table of content is printed",
// "TOC levels" => "TOC levels",
// "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>" => "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>",
// "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page" => "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page",
// "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page" => "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page",
// "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly" => "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly",
// "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly" => "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly",
// "Generate PDF Bookmarks" => "Generate PDF Bookmarks",
// "Values H1-H6,separated by | <code>For example H1|H2|H3</code>" => "Values H1-H6,separated by | <code>For example H1|H2|H3</code>",
// "Secure confidential PDF with password, leave blank if password protected is not needed" => "Secure confidential PDF with password, leave blank if password protected is not needed",
// "Watermark text value, for example: Confidential, Draft etc. " => "Watermark text value, for example: Confidential, Draft etc. ",
// "Watermark image, enter full URL" => "Watermark image, enter full URL",
// "Full URL of watermark image" => "Full URL of watermark image",
// "Page background color" => "Page background color",
// "Page background image" => "Page background image",
// "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>" => "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>",
// "For pluginPDF, please select mpdf as default PDF engine from Print Settings" => "For pluginPDF, please select mpdf as default PDF engine from Print Settings",
// "Manual bookmark entry for a PDF file" => "Manual bookmark entry for a PDF file",
// "Bookmark Label" => "Bookmark Label",
// "Bookmark level" => "Bookmark level",
// "Insert page with new settings in PDF" => "Insert page with new settings in PDF",
// "Page Content" => "Page Content",
// "PDF page header text" => "PDF page header text",
// "PDF page footer text" => "PDF page footer text",
// "Watermark text for this page. Set value as \"off\", to turn off watermark of the page" => "Watermark text for this page. Set value as \"off\", to turn off watermark of the page",
// "Watermark text value, for example: Confidential, Draft etc" => "Watermark text value, for example: Confidential, Draft etc",
// "Watermark image, enter full url" => "Watermark image, enter full url",
// "To turn off watermark image on the page, set value as <code>off</code>" => "To turn off watermark image on the page, set value as <code>off</code>",
// "PluginPDF Page Break" => "PluginPDF Page Break",
// "Helpful to format PDF files created, plugin adds page break in PDF file generated" => "Helpful to format PDF files created, plugin adds page break in PDF file generated",
"Display content based on permission settings" => "Onyesha maudhui kulingana na mipangilio ya ruhusa",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions",
// "Possible Permissions" => "Possible Permissions",
// "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext" => "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show" => "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show",
"Global" => "Jumla",
// "Indicate whether the permissions are global or local to the object" => "Indicate whether the permissions are global or local to the object",
// "Display content based on the user's current perspective" => "Display content based on the user's current perspective",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition",
"Allowed Perspectives" => "Mtazamo unaoruhusiwa",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown" => "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown",
// "Pivot table" => "Pivot table",
// "Create and display data in pivot table for reporting" => "Create and display data in pivot table for reporting",
// "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on" => "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on",
// "Data source" => "Data source",
// "Override item permissions" => "Override item permissions",
// "Return all tracker items ignoring permissions to view the corresponding items" => "Return all tracker items ignoring permissions to view the corresponding items",
// "Width of pivot table. Units: % or px" => "Width of pivot table. Units: % or px",
// "Height of pivot table. Units: px" => "Height of pivot table. Units: px",
// "Pivot table Rows" => "Pivot table Rows",
// "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. " => "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. ",
// "Use permanentNames in case of tracker fields" => "Use permanentNames in case of tracker fields",
// "Separated by colon (:) if more than one" => "Separated by colon (:) if more than one",
// "Pivot table Columns" => "Pivot table Columns",
// "Which field or fields to use as table columns. Leaving blank will use the first available field" => "Which field or fields to use as table columns. Leaving blank will use the first available field",
// "Values used to decide what heatmapColors to use" => "Values used to decide what heatmapColors to use",
// "Color for each heatmapDomain value" => "Color for each heatmapDomain value",
// "Renderer Name" => "Renderer Name",
// "Display format of data" => "Display format of data",
// "Table Barchart" => "Table Barchart",
// "Heatmap" => "Heatmap",
// "Row Heatmap" => "Row Heatmap",
// "Col Heatmap" => "Col Heatmap",
// "Line Chart" => "Line Chart",
// "Bar Chart" => "Bar Chart",
// "Overlay Bar Chart" => "Overlay Bar Chart",
// "Stacked Bar Chart" => "Stacked Bar Chart",
// "Relative Bar Chart" => "Relative Bar Chart",
// "Boxplot Chart" => "Boxplot Chart",
// "Horizontal Boxplot Chart" => "Horizontal Boxplot Chart",
// "Area Chart" => "Area Chart",
// "Histogram" => "Histogram",
// "Density Histogram" => "Density Histogram",
// "Percent Histogram" => "Percent Histogram",
// "Probability Histogram" => "Probability Histogram",
// "Density Histogram Horizontal" => "Density Histogram Horizontal",
// "Percent Histogram Horizontal" => "Percent Histogram Horizontal",
// "Probability Histogram Horizontal" => "Probability Histogram Horizontal",
// "Horizontal Histogram" => "Horizontal Histogram",
// "Histogram2D" => "Histogram2D",
// "Density Histogram2D" => "Density Histogram2D",
// "Percent Histogram2D" => "Percent Histogram2D",
// "Probability Histogram2D" => "Probability Histogram2D",
// "Density Histogram2D Horizontal" => "Density Histogram2D Horizontal",
// "Percent Histogram2D Horizontal" => "Percent Histogram2D Horizontal",
// "Probability Histogram2D Horizontal" => "Probability Histogram2D Horizontal",
// "Horizontal Histogram2D" => "Horizontal Histogram2D",
// "Scatter Chart" => "Scatter Chart",
// "Treemap" => "Treemap",
// "Aggregator Name" => "Aggregator Name",
// "Function to apply on the numeric values from the variables selected" => "Function to apply on the numeric values from the variables selected",
// "Count Unique Values" => "Count Unique Values",
// "List Unique Values" => "List Unique Values",
// "Sum" => "Sum",
// "Integer Sum" => "Integer Sum",
// "Minimum" => "Minimum",
// "Sum over Sum" => "Sum over Sum",
// "80% Upper Bound" => "80% Upper Bound",
// "80% Lower Bound" => "80% Lower Bound",
// "Sum as Fraction of Total" => "Sum as Fraction of Total",
// "Sum as Fraction of Rows" => "Sum as Fraction of Rows",
// "Sum as Fraction of Columns" => "Sum as Fraction of Columns",
// "Count as Fraction of Total" => "Count as Fraction of Total",
// "Count as Fraction of Rows" => "Count as Fraction of Rows",
// "Count as Fraction of Columns" => "Count as Fraction of Columns",
"Values" => "Maadili",
// "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts" => "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts",
// "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function" => "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function",
// "Inclusions" => "Inclusions",
// "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings" => "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings",
// "Filter list limit" => "Filter list limit",
// "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row" => "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row",
// "Aggregate details" => "Aggregate details",
// "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string" => "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string",
// "Highlight my items" => "Highlight my items",
// "Highlight owned items' values in Charts" => "Highlight owned items' values in Charts",
// "Highlight my group items" => "Highlight my group items",
// "Highlight items' values belonging to one of my groups in Charts" => "Highlight items' values belonging to one of my groups in Charts",
// "Color for each highlighted group items" => "Color for each highlighted group items",
// "xAxis label" => "xAxis label",
// "Override label of horizontal axis when using Chart renderers" => "Override label of horizontal axis when using Chart renderers",
// "yAxis label" => "yAxis label",
// "Override label of vertical axis when using Chart renderers" => "Override label of vertical axis when using Chart renderers",
// "Chart title" => "Chart title",
// "Override title when using Chart renderers" => "Override title when using Chart renderers",
// "Chart hover bar" => "Chart hover bar",
// "Display the Chart hover bar or not" => "Display the Chart hover bar or not",
// "Translate displayed data" => "Translate displayed data",
// "Use translated data values for calculations and display" => "Use translated data values for calculations and display",
// "Default value: No" => "Default value: No",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>",
// "Missing data parameter with format: source:ID, e.g. tracker:1" => "Missing data parameter with format: source:ID, e.g. tracker:1",
// "Error data parameter" => "Error data parameter",
// "You do not have rights to view tracker data" => "You do not have rights to view tracker data",
// "Unified search index not found" => "Unified search index not found",
// "Split wiki modifier should specify a field" => "Split wiki modifier should specify a field",
// "For example 'tracker:1' or 'activitystream'" => "For example 'tracker:1' or 'activitystream'",
// "Piwik" => "Piwik",
// "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter" => "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter",
// "Piwik server url" => "Piwik server url",
// "The url to your Piwik Server, where data for the report are collected and available" => "The url to your Piwik Server, where data for the report are collected and available",
// "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users" => "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users",
// "The ID of this website in Piwik To be improved" => "The ID of this website in Piwik To be improved",
// "Module and Action To Widgetize" => "Module and Action To Widgetize",
// "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma" => "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma",
// "Actions - Pages" => "Actions - Pages",
// "Actions - Entry pages" => "Actions - Entry pages",
// "Actions - Exit pages" => "Actions - Exit pages",
// "Actions - Outlinks" => "Actions - Outlinks",
// "Dashboard" => "Dashboard",
// "Live - Visitor in real time" => "Live - Visitor in real time",
// "Live - Simple Last Visit Count" => "Live - Simple Last Visit Count",
// "Live - Visitor Profile Popup" => "Live - Visitor Profile Popup",
// "Referrers - All referrers" => "Referrers - All referrers",
// "Referrers - Search engines" => "Referrers - Search engines",
// "Resolution - Screen Resolution" => "Resolution - Screen Resolution",
// "SEO - SEO Ranking (slow)" => "SEO - SEO Ranking (slow)",
// "User Country Map - RealTime Map" => "User Country Map - RealTime Map",
// "User Country Map - Visitor Map" => "User Country Map - Visitor Map",
// "User Country Map - Country" => "User Country Map - Country",
// "User Country Map - Continent" => "User Country Map - Continent",
// "User Language - Language" => "User Language - Language",
// "User Language - Language Code" => "User Language - Language Code",
// "Visits Time - By day of the week" => "Visits Time - By day of the week",
// "Visits Time - Visit Information Per Local Time" => "Visits Time - Visit Information Per Local Time",
// "Visits Time - Visit Information Per Server Time" => "Visits Time - Visit Information Per Server Time",
// "Visits Summary - by day of the week" => "Visits Summary - by day of the week",
// "Visits Summary - over time" => "Visits Summary - over time",
// "Visits Summary - overview with graph" => "Visits Summary - overview with graph",
// "Visitors - Visitor map" => "Visitors - Visitor map",
// "Visitors - Pages per visit" => "Visitors - Pages per visit",
// "Visitors - Frequency overview" => "Visitors - Frequency overview",
// "Visitors - Returning visits over time" => "Visitors - Returning visits over time",
// "Visitor Devices - Device type" => "Visitor Devices - Device type",
// "Visitor Devices - browser" => "Visitor Devices - browser",
// "Visitor Devices - Browser Versions" => "Visitor Devices - Browser Versions",
// "Visitor Devices - OS Families" => "Visitor Devices - OS Families",
// "Visitor Devices - OS Versions" => "Visitor Devices - OS Versions",
// "Visitor Interest - Number Of Visits Per Visit Duration" => "Visitor Interest - Number Of Visits Per Visit Duration",
// "Visitor Interest - Number Of Visits Per Page" => "Visitor Interest - Number Of Visits Per Page",
// "Visitor Interest - Number Of Visits By Visit Count" => "Visitor Interest - Number Of Visits By Visit Count",
// "Visitor Interest - Number Of Visits By Days Since Last" => "Visitor Interest - Number Of Visits By Days Since Last",
// "Visitor Setting - Screen resolution" => "Visitor Setting - Screen resolution",
// "Statistics period" => "Statistics period",
// "Data display duration. If range is selected you must enter the start and end the date" => "Data display duration. If range is selected you must enter the start and end the date",
"Range" => "Rangi",
// "Date or Start date" => "Date or Start date",
// "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd" => "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd",
// "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)" => "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)",
// "Module width" => "Module width",
// "Optional, width of the module in px or % (100% by default)" => "Optional, width of the module in px or % (100% by default)",
// "Module height" => "Module height",
// "Optional, height of the module in px" => "Optional, height of the module in px",
// "Iframe Scrolling" => "Iframe Scrolling",
// "Optional, scrolling of the iframe that contain the module (no by default)" => "Optional, scrolling of the iframe that contain the module (no by default)",
// "Piwik javascript code" => "Piwik javascript code",
// "Define option for Piwik groups, include or exclude" => "Define option for Piwik groups, include or exclude",
// "Plugin Piwik error" => "Plugin Piwik error",
// "Piwik server url is required" => "Piwik server url is required",
// "Site Id is required" => "Site Id is required",
// "moduleToWidgetize is required" => "moduleToWidgetize is required",
// "Period set to range but no end date provided" => "Period set to range but no end date provided",
// "PlayScorm" => "PlayScorm",
// "Play a SCORM learning object in an iframe using Moodle" => "Play a SCORM learning object in an iframe using Moodle",
// "Numeric ID of a SCORM zip file in a File Gallery" => "Numeric ID of a SCORM zip file in a File Gallery",
// "Moodle URL" => "Moodle URL",
// "Web address of the Moodle instance" => "Web address of the Moodle instance",
// "Moodle Course ID" => "Moodle Course ID",
// "Course ID in Moodle to upload SCORM objects to" => "Course ID in Moodle to upload SCORM objects to",
// "Frame Width" => "Frame Width",
// "Frame Height" => "Frame Height",
// "Numeric ID" => "Numeric ID",
// "Numeric ID to distinguish multiple plugins of there is more than one" => "Numeric ID to distinguish multiple plugins of there is more than one",
"Either the module or plugin parameter must be set, but not both" => "Aidha parameter ya moduli au Plugin inapaswa kuweka, lakini sio wote",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "Chaguo",
"Accepted Values" => "Vipimo Vipokee",
"(body of plugin)" => "(mwili wa Plugin)",
// "%0separator:%1 " => "%0separator:%1 ",
"(blank)" => "(tupu)",
"any string except for HTML and PHP tags" => "kamba yoyote isipokuwa kwa vitambulisho vya HTML na PHP",
"Since" => "Tangu",
"no parameters" => "hakuna vigezo",
"Preferences required" => "Mapendekezo yanahitajika",
// "Introduced in %0" => "Introduced in %0",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
"Plugin Manager" => "Meneja wa Plugin",
"List wiki plugin or module information for the site" => "Weka habari ya nenosiri la wiki au moduli kwa tovuti",
"Information" => "Taarifa",
// "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1" => "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1",
"One or more of: description | parameters | paraminfo" => "Moja au zaidi ya: maelezo | vigezo | paraminfo",
"Description and Parameters" => "Maelezo na Parameter",
"Description & Parameter Info" => "Maelezo & Maelezo ya Parameter",
"Parameters & Parameter Info" => "Vigezo & Maelezo ya Parameter",
"Plugin" => "Chomeka",
// "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter" => "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter",
// "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter" => "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter",
"Single Title" => "jina moja",
"Set placement of plugin name and description when displaying information for only one plugin" => "Weka uwekaji wa jina la majina na maelezo wakati unapoonyesha habari kwa Plugin moja tu",
"Title Heading" => "Kiwango cha kichwa cha kichwa",
// "Sets the heading size for the title, e.g., %0h2%1" => "Sets the heading size for the title, e.g., %0h2%1",
"Start with this plugin record number (must be an integer 1 or greater)" => "Anza na nambari hii ya rekodi ya kuziba (lazima iwe nambari 1 au zaidi)",
// "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater",
// "Parameter Type" => "Parameter Type",
// "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions" => "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions",
// "Show Parameter Type" => "Show Parameter Type",
// "Show the parameter %0doctype%1 value" => "Show the parameter %0doctype%1 value",
// "Show Top Info" => "Show Top Info",
// "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default" => "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default",
"Poll" => "Uchaguzi",
// "Embed a poll" => "Embed a poll",
// "Title of the poll" => "Title of the poll",
"Numeric value representing the poll ID" => "Thamani ya namba inayowakilisha ID ya uchaguzi",
"Show poll title (shown by default)" => "Onyesha kichwa cha uchaguzi (umeonyeshwa kwa default)",
"Show result" => "Onyesha matokeo",
// "Set how results of the poll will be shown (default is %0link%1)" => "Set how results of the poll will be shown (default is %0link%1)",
// "Voted" => "Voted",
"Show total votes" => "Onyesha kura zote",
// "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)" => "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)",
"Preference" => "Upendeleo",
// "Display content based on global preference settings" => "Display content based on global preference settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions",
// "Document Preferences" => "Document Preferences",
// "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)" => "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)",
// "Preference-Tab" => "Preference-Tab",
// "The name of the preference tab to display, or a list of available tabs upon invalid" => "The name of the preference tab to display, or a list of available tabs upon invalid",
// "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2" => "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2",
"Pretty Tracker View Tracking" => "Ufuatiliaji wa maoni ya fomu iliyoboreshwa",
"PluginPrettyTrackerViews" => "Plugiciel PrettyTrackerViews",
// "Store tiki.tracker.pretty.views attribute for a trackeritem" => "Store tiki.tracker.pretty.views attribute for a trackeritem",
// "Set to %0y%1 to record view each time this is loaded" => "Set to %0y%1 to record view each time this is loaded",
// "Set to %0n%1 to hide showing of attribute" => "Set to %0n%1 to hide showing of attribute",
"Set to ID of tracker item" => "Weka ID ya fomu ya fomu",
// "Preview Files" => "Preview Files",
// "Enabled to generate preview of images or video files" => "Enabled to generate preview of images or video files",
// "Id of the file in the file gallery" => "Id of the file in the file gallery",
// "Animation" => "Animation",
// "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)" => "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)",
// "Width of the result in pixels" => "Width of the result in pixels",
// "Height of the result in pixels" => "Height of the result in pixels",
// "Show download link to the original file" => "Show download link to the original file",
"Profile Application" => "Inatumia maelezo mafupi",
"Add a button for applying a profile" => "Ongeza kifungo kuomba wasifu",
// "Profile repository domain. Default value is %0profiles.tiki.org%1" => "Profile repository domain. Default value is %0profiles.tiki.org%1",
"Profile Name" => "Jina la wasifu",
"Name of the profile to be applied" => "Jina la wasifu kuomba",
"Profile plugin only available to administrators" => "Programu ya kuziba inapatikana tu kwa wasimamiz",
"Profile %0/%1 not found" => "Profaili %0/%1 haipatikani",
// "Profile Symbol Value" => "Profile Symbol Value",
// "Display the profile symbol related with profile and a reference and optionally with domain or package" => "Display the profile symbol related with profile and a reference and optionally with domain or package",
// "Reference key" => "Reference key",
// "Reference name" => "Reference name",
// "Package" => "Package",
// "Package extension name" => "Package extension name",
"Proposal" => "pendekezo",
"Allow users to vote on a proposal and view the results" => "Ruhusu watumiaji kupiga kura kwenye pendekezo na kuona matokeo",
"The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "Orodha ya kura zilizopigwa. Kupiga kura moja kwa kila mstari. Ingawa 0, +1 au -1 ifuatiwa na jina la mtumiaji",
// "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable" => "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable",
// "Weights" => "Weights",
// "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example" => "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example",
"Accept proposal" => "Pata pendekezo",
"Still undecided" => "Bado haijatikani",
"Reject proposal" => "Kataa pendekezo",
"Quote" => "Quote",
"Format text as a quote" => "Weka maandishi kama quote",
"Quoted text" => "Maandishi yaliyotajwa",
"Reply To" => "Jibu kwa",
"Name of the quoted person" => "Jina la mtu alinukuliwa",
// "Thread Id for Forum replies" => "Thread Id for Forum replies",
// "The thread Id of the comment being replied to in forums. Overwrites replyto" => "The thread Id of the comment being replied to in forums. Overwrites replyto",
// "Source URL" => "Source URL",
// "The URL to the source quoted" => "The URL to the source quoted",
// "Date when the statement quoted was made" => "Date when the statement quoted was made",
// "YYYY-MM-DD" => "YYYY-MM-DD",
// "R syntax" => "R syntax",
// "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms" => "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms",
"Random Include" => "Random Ni pamoja na",
"Include a random page's content" => "Jumuisha maudhui ya ukurasa wa random",
"Random Dynamic Content" => "Maudhui ya Dynamic Random",
"Display pre-programmed changing content" => "Onyesha maudhui yaliyopangwa yaliyopangwa kabla",
"Numeric value representing the content ID" => "Thamani ya namba inayowakilisha ID ya maudhui",
"User List with Real Names" => "Orodha ya Mtumiaji na Majina ya Kweli",
"Show user real names for members of a group" => "Onyesha majina halisi ya mtumiaji kwa wanachama wa kikundi",
// "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
"User Page" => "Ukurasa wa Mtumiaji",
"User Preferences" => "Mapendekezo ya Mtumiaji",
"Exclude" => "Wala",
"Exclude certain test or admin names from the list" => "Wala majaribio fulani au majina ya admin kutoka kwenye orodha",
"admin" => "msimamizi",
"admin-test" => "msimamizi-mtihani",
"test" => "mtihani",
"test-admin" => "mtihani-msimamizi",
"Preferences" => "Mapendekezo",
"Redirect" => "Kuelekeza tena",
"Redirect to another page" => "Rejea kwenye ukurasa mwingine",
"Wiki page name to redirect to" => "Jina la ukurasa wa Wiki ili uelekeze tena",
"Complete URL, internal or external" => "Kamili URL, ndani au nje",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "Auto login remote Tiki and redirect to page there" => "Auto login remote Tiki and redirect to page there",
// "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com" => "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com",
"perspective " => "mtazamo ",
"nowhere" => "mahali popote",
// "Remote system error" => "Remote system error",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
"Regular Expression" => "Ufafanuzi wa Mara kwa mara",
"Perform a regular expression search and replace" => "Fanya utafutaji wa kujieleza mara kwa mara na uweke nafasi",
"Each line of content is evaluated separately" => "Kila mstari wa maudhui huhesabiwa tofauti",
// "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page" => "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page",
// "Register Member Payment" => "Register Member Payment",
// "Register and make a member payment at the same time" => "Register and make a member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample" => "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "Tuma",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Display the relation of an object to the rest of the site" => "Display the relation of an object to the rest of the site",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as %0type:itemId%1" => "Object identifier as %0type:itemId%1",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
// "Empty Message" => "Empty Message",
// "Message to give if result is empty and no relations are found" => "Message to give if result is empty and no relations are found",
"Remarks Box" => "Maelezo ya Sanduku",
// "Display a comment, tip, note or warning box" => "Display a comment, tip, note or warning box",
"remarks text" => "anasema maandishi",
"Select type of remarksbox, which determines what icon and style will be displayed" => "Chagua aina ya lebo, ambayo huamua icon na mtindo gani utaonyeshwa",
"Confirm" => "Thibitisha",
"Tip" => "Ushauri",
"Label displayed above the remark" => "Lebo iliyoonyeshwa hapo juu ya maneno",
"Use the highlight class for formatting (not used by default)" => "Tumia darasa la kukuza utayarishaji (hauotumiwa na default)",
"Custom Icon" => "Icon ya Custom",
"Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)" => "Ingiza jina la faili ya Tiki ya faili (au bila ugani) au njia ya kuonyesha icon ya desturi",
"Show a close button (not shown by default)" => "Onyesha kifungo cha karibu (kisichoonyeshwa kwa default)",
// "Width (e.g. %0100%%1 or %0250px%1 - default \"\")" => "Width (e.g. %0100%%1 or %0250px%1 - default \"\")",
// "Remember Dismiss" => "Remember Dismiss",
// "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set" => "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set",
// "Sets an HTML id for the account" => "Sets an HTML id for the account",
// "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter" => "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter",
// "RR (R syntax also)" => "RR (R syntax also)",
// "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call" => "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call",
// "R Code" => "R Code",
// "echo" => "echo",
// "Show a code block with the R commands to be run before running them (similarly to the echo command)" => "Show a code block with the R commands to be run before running them (similarly to the echo command)",
// "echo debug" => "echo debug",
// "Show a code block with the R commands to be run even if the R program fails to execute" => "Show a code block with the R commands to be run even if the R program fails to execute",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "wikisyntax" => "wikisyntax",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
"width" => "upana",
// "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio" => "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio",
"height" => "urefu",
// "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio" => "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio",
// "units" => "units",
// "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm" => "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm",
// "pointsize" => "pointsize",
// "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger" => "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger",
// "bg" => "bg",
// "The initial background colour (optional). Options: white, yellow, grey, ... and transparent" => "The initial background colour (optional). Options: white, yellow, grey, ... and transparent",
// "parse_body" => "parse_body",
// "parses the body content to allow data to be generated from other plugins" => "parses the body content to allow data to be generated from other plugins",
// "res" => "res",
// "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much" => "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much",
// "svg" => "svg",
// "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "pdf" => "pdf",
// "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "onefile" => "onefile",
// "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file" => "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file",
// "LoadAndSave" => "LoadAndSave",
// "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages" => "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages",
// "Caching strategy" => "Caching strategy",
// "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin" => "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin",
// "Limit cache duration" => "Limit cache duration",
// "Force cache recalculation after time limit. Default: No limit" => "Force cache recalculation after time limit. Default: No limit",
// "CacheBy" => "CacheBy",
// "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)" => "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)",
// "Page Name (pagename)" => "Page Name (pagename)",
// "Page Id (pageid)" => "Page Id (pageid)",
// "Cache age" => "Cache age",
// "Display cache last modification date below the graph (default option: do not display)" => "Display cache last modification date below the graph (default option: do not display)",
// "attId" => "attId",
// "AttId from a tracker Item attachment. ex: 1. (Optional)" => "AttId from a tracker Item attachment. ex: 1. (Optional)",
// "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required" => "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required",
// "csv" => "csv",
// "xml" => "xml",
// "x11" => "x11",
// "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()" => "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()",
// "removen" => "removen",
// "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)" => "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)",
// "Custom output" => "Custom output",
// "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file" => "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file",
// "security" => "security",
// "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)" => "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)",
// "Cache was last modified: %0" => "Cache was last modified: %0",
// "One cache per plugin" => "One cache per plugin",
// "One cache per plugin per user" => "One cache per plugin per user",
// "No caching: Ignore and replace existing cache, if any" => "No caching: Ignore and replace existing cache, if any",
// "No limit" => "No limit",
// "1 hour" => "1 hour",
// "1 day" => "1 day",
// "7 days" => "7 days",
// "30 days" => "30 days",
// "365 days" => "365 days",
// "Don't display cache creation date" => "Don't display cache creation date",
// "Display cache creation date" => "Display cache creation date",
// "Blocked commands found: " => "Blocked commands found: ",
// "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you" => "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you",
// "command unavailable" => "command unavailable",
// "The __R__ package needs to be installed on the server" => "The __R__ package needs to be installed on the server",
// "See requirements on [https://doc.tiki.org/PluginR]" => "See requirements on [https://doc.tiki.org/PluginR]",
// "The path to the __R__ command could not be found on your system" => "The path to the __R__ command could not be found on your system",
// "Maybe this file is inaccessible due to safe mode restrictions" => "Maybe this file is inaccessible due to safe mode restrictions",
// "The path to the __convert__ command could not be found on your system" => "The path to the __convert__ command could not be found on your system",
// "You need to ensure that you have __imagemagick__ installed successfully on the server" => "You need to ensure that you have __imagemagick__ installed successfully on the server",
// "Cached R output from %0. If you click, you will re-run all R scripts in this page" => "Cached R output from %0. If you click, you will re-run all R scripts in this page",
// "Save Image as SVG" => "Save Image as SVG",
// "Save Image as PDF" => "Save Image as PDF",
// "plot" => "plot",
"RSS Feed" => "RSS Feed",
// "Display items from one or more RSS feeds" => "Display items from one or more RSS feeds",
"IDs" => "Vitambulisho",
// "List of feed IDs separated by colons. ex: %0" => "List of feed IDs separated by colons. ex: %0",
"Result Count" => "Hesabu ya matokeo",
"Number of results displayed." => "Idadi ya matokeo yalionyeshwa.",
"Show date of each item (not shown by default)" => "Onyesha tarehe ya kila kitu (kisichoonyeshwa kwa default)",
"Show feed descriptions (not shown by default)" => "Onyesha maelezo ya malisho (sioonyeshwa kwa default)",
"Show authors (not shown by default)" => "Onyesha waandishi (sioonyeshwa kwa default)",
"URL to a favicon to put before each entry" => "URL kwa favicon kuweka kabla ya kila kuingia",
"Show the title of the feed (shown by default)" => "Onyesha kichwa cha malisho (imeonyeshwa kwa default)",
// "Ticker" => "Ticker",
// "Turn static feed display into ticker news like" => "Turn static feed display into ticker news like",
// "Description Length" => "Description Length",
// "Max characters/length, truncates text to fit design" => "Max characters/length, truncates text to fit design",
"Scroll" => "Futa",
"Show animated text that scrolls up or down" => "Onyesha maandishi ya uhuishaji ambayo yanaendelea juu au chini",
// "Width in pixels. Example: %0" => "Width in pixels. Example: %0",
// "Number of pixels followed by \"px\"" => "Number of pixels followed by \"px\"",
// "Height in pixels. Example: %0" => "Height in pixels. Example: %0",
// "Scroll speed in number of seconds (default is %0)" => "Scroll speed in number of seconds (default is %0)",
"SourceForge" => "SourceForge",
"Creates a link to SourceForge tracker items" => "Inaunda kiungo kwa vitu vya tracker vya SourceForge",
"Group ID" => "Kitambulisho cha Kikundi",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
"Link title" => "Kiungo cha kiungo",
// "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)",
"ShareThis" => "ShareThis",
"Add a ShareThis button" => "Ongeza kifungo cha ShareThis",
"Send Services" => "Tuma Huduma",
// "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services" => "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services",
"AIM" => "AIM",
// "AIM and Email" => "AIM and Email",
// "AIM and SMS" => "AIM and SMS",
// "Email and SMS" => "Email and SMS",
"Button Style" => "Mtindo wa kifungo",
// "Set button style" => "Set button style",
"Rotate Image" => "Picha mbadala",
// "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping" => "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping",
"Multiple Icons" => "Icons nyingi",
// "Enter pipe-separated list of services, e.g., %0" => "Enter pipe-separated list of services, e.g., %0",
"First Services Shown" => "Huduma za kwanza zilizoonyeshwa",
// "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget",
"Custom link text for the button" => "Nakala ya kiungo ya kiungo kwa kifungo",
"Header Title" => "Title Header",
"Optional header title text for the widget" => "Nakala ya kichwa cha kichwa cha hiari cha widget",
"Header Background" => "Background ya kichwa",
// "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used" => "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used",
"Header Text Color" => "Nakala ya Nakala ya kichwa",
"HTML color code (not color name) for the header text if an optional header title is used" => "Msimbo wa rangi ya HTML (si jina la rangi) kwa maandiko ya kichwa ikiwa kichwa cha kichwa hiari kinatumika",
"Link text color for services" => "Unganisha rangi ya maandishi kwa huduma",
"HTML color code (not color name) for the link text for all send and post services shown in the widget" => "Msimbo wa rangi ya HTML (si jina la rangi) kwa maandishi ya kiungo kwa wote kutuma na huduma za posta zilizoonyeshwa kwenye widget",
// "Set whether the widget will show in a popup window" => "Set whether the widget will show in a popup window",
"Embedded Elements" => "Vipengele vilivyounganishwa",
// "Allow embedded elements (like flash) to be seen while iframe is loading" => "Allow embedded elements (like flash) to be seen while iframe is loading",
"Sheet" => "Karatasi",
"Display data from a TikiSheet" => "Onyesha data kutoka kwa TikiSheet",
"Spreadsheet Heading" => "jedwali la Fasta",
// "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required" => "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required",
"Sheet Url Location" => "Eneo la Uhuishaji wa Karatasi",
// "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired" => "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired",
// "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)" => "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1" => "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1",
"Height in pixels or percentage. Default value is complete spreadsheet height" => "Urefu katika saizi au asilimia. Thamani ya msingi ni urefu kamili wa lahajedwali",
// "Show edit button. Default is to show depending on user's permissions" => "Show edit button. Default is to show depending on user's permissions",
"Show subsheets" => "Onyesha majedwali",
// "Show multi-sheets (default is to show)" => "Show multi-sheets (default is to show)",
// "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1" => "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1",
"Apply custom CSS class to the containing div" => "Tumia darasa la CSS desturi kwa div iliyo na",
"New sheet in page: " => "Karatasi mpya katika ukurasa: ",
"Create New Sheet" => "Unda Karatasi Mpya",
"Error loading spreadsheet" => "Hitilafu kupakia lahajedwali",
"Edit Sheet" => "Badilisha Karatasi",
"Collect Anonymous Shopper Info" => "Unganisha Info isiyojulikana ya Shopper",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect shopper information for the shopping cart" => "Collect shopper information for the shopping cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
"Labels for the values to be collected" => "Lebo ya maadili ya kukusanywa",
// "Labels of the values to be collected separated by a colon" => "Labels of the values to be collected separated by a colon",
"Show even if logged in" => "Onyesha hata ikiwa umeingia",
"Normally this is used for anonymous users but sometimes may be used when logged in also" => "Kwa kawaida hii hutumiwa kwa watumiaji wasiojulikana lakini wakati mwingine inaweza kutumika wakati unapoingia pia",
// "Shorten" => "Shorten",
// "Show/hide a portion of text" => "Show/hide a portion of text",
// "Char length of always visible portion of text" => "Char length of always visible portion of text",
// "More text" => "More text",
// "A label indicating the text is expandable" => "A label indicating the text is expandable",
// "Less text" => "Less text",
// "A label for collapse text action" => "A label for collapse text action",
"Show Pages" => "Onyesha Kurasa",
"Find pages by searching within page names" => "Pata kurasa kwa kutafuta ndani ya majina ya ukurasa",
"Search criteria" => "Vigezo vya Utafutaji",
"Maximum amount of results displayed" => "Upeo wa matokeo ulionyeshwa",
"Display page name and/or description. Both displayed by default" => "Onyesha jina la ukurasa na / au maelezo. Wote walionyeshwa kwa default",
"Name & Description" => "Jina & Maelezo",
// "Show Preference" => "Show Preference",
// "Display the value of public global preferences" => "Display the value of public global preferences",
// "Name of preference to be displayed" => "Name of preference to be displayed",
// "Add Bibliography" => "Add Bibliography",
// "Add bibliography listing in the footer of a wiki page" => "Add bibliography listing in the footer of a wiki page",
// "Title to be displayed in the bibliography listing. Default is %0Bibliography%1" => "Title to be displayed in the bibliography listing. Default is %0Bibliography%1",
// "Show bibliography title. Title is shown by default" => "Show bibliography title. Title is shown by default",
// "Header Tag" => "Header Tag",
// "The HTML header tag level of the title. Default: %01%1" => "The HTML header tag level of the title. Default: %01%1",
// "Remove the lines around the list of references" => "Remove the lines around the list of references",
// "Remove the horizontal lines displayed above and below the list of references" => "Remove the horizontal lines displayed above and below the list of references",
// "Page identifier" => "Page identifier",
// "Provide the page id" => "Provide the page id",
// "Bibliography" => "Bibliography",
"Signature" => "Sahihi",
// "Sign and date your contribution to a page" => "Sign and date your contribution to a page",
// "Auto-generated, the username" => "Auto-generated, the username",
// "Date and time" => "Date and time",
// "Auto-generated, the timestamp" => "Auto-generated, the timestamp",
"Skype" => "Skype",
// "Add a link for calling or chating with a Skype user" => "Add a link for calling or chating with a Skype user",
"Name or number to call or chat with" => "Jina au nambari ya kupiga simu au kuzungumza na",
"Set whether to call or chat. Default is chat" => "Weka ikiwa wito au wasiliana. Kipengee ni mazungumzo",
"Call" => "Wito",
"Chat" => "Ongea",
"Show status" => "Onyesha hali",
// "Show a status icon or not i.e. if online/offline/etc. Default is to not show status" => "Show a status icon or not i.e. if online/offline/etc. Default is to not show status",
"yes" => "ndiyo",
// "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web" => "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web",
"click to" => "bonyeza",
// "Slider" => "Slider",
// "Embed a mini-slideshow of content on a page" => "Embed a mini-slideshow of content on a page",
"Content separated by \"/////\"" => "Maudhui yaliyotengwa na \"/////\"",
"Slider Titles" => "Sirider Titles",
// "Pipe-separated list of slider titles. Example" => "Pipe-separated list of slider titles. Example",
// "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels" => "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels",
"The theme to use in slider" => "Mandhari ya kutumia katika slider",
"Expand" => "Panua",
// "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set" => "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set",
// "Resize" => "Resize",
// "Set whether solitary images/objects in the panel will be expanded to fit the viewport" => "Set whether solitary images/objects in the panel will be expanded to fit the viewport",
"Show Multiple" => "Onyesha Multiple",
"Set this value to a number and it will show that many slides at once" => "Weka thamani hii kwa nambari na itaonyesha kwamba slides nyingi mara moja",
// "Arrows" => "Arrows",
// "Set whether to show forward and backward buttons" => "Set whether to show forward and backward buttons",
"Navigation" => "Urambazaji",
// "Set whether to show a list of anchor links to link to each panel" => "Set whether to show a list of anchor links to link to each panel",
// "Start / Stop" => "Start / Stop",
// "Set whether to show a start/stop button and add slideshow functionality" => "Set whether to show a start/stop button and add slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "Set whether side navigation arrows slide out on hovering and hide at other times" => "Set whether side navigation arrows slide out on hovering and hide at other times",
// "Toggle Controls" => "Toggle Controls",
// "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times" => "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times",
"Enable Arrows" => "Wezesha Mishale",
// "Set whether arrows are clickable" => "Set whether arrows are clickable",
"Enable Navigation" => "Wezesha Navigation",
// "Set whether navigation links are clickable" => "Set whether navigation links are clickable",
"Enable Start Stop" => "Wezesha Kuanza Kuanza",
// "Set whether the play/stop button is clickable. Previously %0" => "Set whether the play/stop button is clickable. Previously %0",
"Enable Keyboard" => "Wezesha Kinanda",
// "Set whether keyboard arrow keys will work for this slider" => "Set whether keyboard arrow keys will work for this slider",
"Auto Play" => "Cheza yenyewe",
// "Set whether the slideshow will start running automatically; replaces %0 option" => "Set whether the slideshow will start running automatically; replaces %0 option",
"Auto Play Locked" => "Auto Play Imefungwa",
// "Keep playing the slideshow even if the user changes slides" => "Keep playing the slideshow even if the user changes slides",
"Auto Play Delayed" => "Auto Play Ilipungua",
// "Set whether there will be a delay in advancing slides" => "Set whether there will be a delay in advancing slides",
// "Pause On Hover" => "Pause On Hover",
// "Set whether the slideshow will pause on hover while the slideshow is active" => "Set whether the slideshow will pause on hover while the slideshow is active",
"Stop At End" => "Acha Wakati Mwisho",
// "Set whether the slideshow stops on the last page" => "Set whether the slideshow stops on the last page",
// "Delay between slides" => "Delay between slides",
// "Time in milliseconds between slideshow transitions (in AutoPlay mode)" => "Time in milliseconds between slideshow transitions (in AutoPlay mode)",
// "Right To Left" => "Right To Left",
// "Set whether the slideshow moves right-to-left" => "Set whether the slideshow moves right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "Set whether auto play stops until the video is complete (for supported video types)" => "Set whether auto play stops until the video is complete (for supported video types)",
// "Animation Time" => "Animation Time",
// "Milliseconds between slides" => "Milliseconds between slides",
// "Panel Hashtags" => "Panel Hashtags",
// "Set whether to include a hashtag in the page URL, allowing links to specific panels" => "Set whether to include a hashtag in the page URL, allowing links to specific panels",
// "Create a slideshow from the content of a wiki page" => "Create a slideshow from the content of a wiki page",
// "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI",
// "Parallax Background Image" => "Parallax Background Image",
// "URL of the background image to use in your slideshow, overrides %0" => "URL of the background image to use in your slideshow, overrides %0",
// "Valid URL" => "Valid URL",
// "Parallax Background Size" => "Parallax Background Size",
// "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)" => "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)",
// "Parallax Background Horizontal" => "Parallax Background Horizontal",
// "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis" => "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis",
// "Parallax Background Vertical" => "Parallax Background Vertical",
// "Transition" => "Transition",
// " Transition style" => " Transition style",
// "Transition Speed" => "Transition Speed",
// "Background Transition" => "Background Transition",
// "Transition style for full page slide backgrounds" => "Transition style for full page slide backgrounds",
// "Display presentation control arrows" => "Display presentation control arrows",
// "Controls Layout" => "Controls Layout",
// "Determines where controls appear, \"edges\" or \"bottom-right\"" => "Determines where controls appear, \"edges\" or \"bottom-right\"",
// "Controls Back Arrows" => "Controls Back Arrows",
// "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"" => "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"",
// "Progress" => "Progress",
// "Display a presentation progress bar" => "Display a presentation progress bar",
// "Slide Number" => "Slide Number",
// "Display the page number of the current slide" => "Display the page number of the current slide",
// "Fragments" => "Fragments",
// "Turns fragments on and off globally" => "Turns fragments on and off globally",
// "Fragment Effects" => "Fragment Effects",
// "Fragment Highlight Color" => "Fragment Highlight Color",
// "Auto Slide" => "Auto Slide",
// "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides" => "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides",
// "Auto Slide Stoppable" => "Auto Slide Stoppable",
// "Stop auto-sliding after user input" => "Stop auto-sliding after user input",
// "Auto-align Images" => "Auto-align Images",
// "Automatically move images to left hand side of slide text, will only align images greater than 200px in width" => "Automatically move images to left hand side of slide text, will only align images greater than 200px in width",
// "Start Slideshow Presentation" => "Start Slideshow Presentation",
// "SlideshowSlide" => "SlideshowSlide",
// "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings" => "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings",
// "Enter content of slide" => "Enter content of slide",
// "Slide Background color" => "Slide Background color",
// "Set background color for slide" => "Set background color for slide",
// "Slide Text color" => "Slide Text color",
// "Set Text color for slide" => "Set Text color for slide",
// "Background Video URL" => "Background Video URL",
// "Automatically plays a full size video behind the slide" => "Automatically plays a full size video behind the slide",
// "Mute Background Video" => "Mute Background Video",
// "Flags if the audio should be muted for background video" => "Flags if the audio should be muted for background video",
// "Loop Background Video" => "Loop Background Video",
// "Flags if the background video played in loop" => "Flags if the background video played in loop",
// "Transition In" => "Transition In",
// "Select entry transition effect for slide" => "Select entry transition effect for slide",
// "Transition Out" => "Transition Out",
// "Select exit transition effect for slide" => "Select exit transition effect for slide",
"Smarty function" => "Kazi ya Smarty",
// "Insert a Smarty function or variable" => "Insert a Smarty function or variable",
// "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1" => "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1",
"Snarf" => "Snarf",
"Display the contents of another web page" => "Onyesha yaliyomo kwenye ukurasa mwingine wa wavuti",
"Full URL to the page to include" => "URL kamili kwenye ukurasa ili kuingiza",
"Regular Expression Pattern" => "Mara kwa mara Sifa ya Ufafanuzi",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
"Regular Expression Replacement" => "Ufafanuzi wa Mara kwa mara Ufafanuzi",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets (Plugin Code is used for this)" => "Syntax highlighting to use for code snippets (Plugin Code is used for this)",
// "Set to Yes (%0) to add line numbers to code snippets (not shown by default)" => "Set to Yes (%0) to add line numbers to code snippets (not shown by default)",
"Parse wiki syntax within the code snippet (not parsed by default)" => "Sura ya syntax ya wiki ndani ya snippet ya kificho (si inayochaguliwa na default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
"HTML Content" => "Maudhui ya HTML",
// "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)" => "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)",
// "Cache URL" => "Cache URL",
// "Cache time in minutes. Default is to use site preference, Set to %0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to %0 for no cache",
// "Text to click on to fetch the URL via Ajax" => "Text to click on to fetch the URL via Ajax",
"Sort lines of text" => "Weka mistari ya maandishi",
"Data to sort, one entry per line" => "Takwimu za kutatua, kuingia moja kwa kila mstari",
"Order" => "Amri",
"Set the sort order of lines of content (default is ascending)" => "Weka utaratibu wa mstari wa maudhui (default inakua)",
"Reverse" => "Rejea",
"Shuffle" => "Piga",
// "Arrange content on a page into rows and columns" => "Arrange content on a page into rows and columns",
// "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows",
"Generate the colspan attribute if columns are missing" => "Tengeneza sifa ya colspan ikiwa nguzo hazipo",
"Fixed Size" => "Ukubwa wa Fasta",
"Generate the width attribute for the columns" => "Fanya sifa ya upana kwa nguzo",
// "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)" => "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)",
// "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns",
// "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1" => "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1",
"SQL" => "SQL",
"Query a MySQL database and display the results" => "Make a reputation for width for columns",
// "The SQL query goes in the body. Example: " => "The SQL query goes in the body. Example: ",
"DSN Name" => "Jina la DSN",
// "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0" => "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0",
// "Raw return" => "Raw return",
// "Return with table formatting (default) or raw data with no table formatting" => "Return with table formatting (default) or raw data with no table formatting",
// "Raw" => "Raw",
// "Delim" => "Delim",
// "The delimiter to be used between data elements (sets %0)" => "The delimiter to be used between data elements (sets %0)",
// "Turn wiki parsing of select results on and off (default is on)" => "Turn wiki parsing of select results on and off (default is on)",
"Missing db param" => "Kipengee cha db kikosefu",
"Could not obtain valid DSN connection" => "Ne peut obtenir une connection DSN valide",
"Stat" => "Stat.",
"Show various statistics for an object" => "Afficher des statistiques diverses pour un objet",
// "Colon-separated list of object type to show stats for" => "Colon-separated list of object type to show stats for",
"Article & Tracker Item" => "Article & Fiche de formulaire",
"Article & Tracker Item & Wiki" => "Article & Fiche de formulaire & Wiki",
"Article & Wiki" => "Article & Wiki",
"Article & Wiki & Tracker Item" => "Article & Wiki & Fiche de formulaire",
"Tracker Item & Article" => "Fiche de formulaire & Article",
"Tracker Item & Article & Wiki" => "Fiche de formulaire & Article & Wiki",
"Tracker Item & Wiki" => "Fiche de formulaire & Wiki",
"Tracker Item & Wiki & Article" => "Fiche de formulaire & Wiki & Article",
"Wiki & Article" => "Wiki & Article",
"Wiki & Article & Tracker Item" => "Wiki & Article & Fiche de formulaire",
"Wiki & Tracker Item" => "Wiki & Fiche de formulaire",
"Wiki & Tracker Item & Article" => "Wiki & Fiche de formulaire & Article",
"Parent ID" => "ID du Parent",
"Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Entrer une ID de formulaire pour restreindre les statistiques à ce formulaire (pour usage avec fiches de formulaire seulement)",
"Last 24 Hours" => "Dernières 24 heures",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"" => "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"",
"Added" => "Ajouté",
"Added and Viewed" => "Ajouté et Vu",
"Viewed" => "Vu",
"Viewed & Added" => "Vu & Ajouté",
// "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last 7 Days" => "7 derniers jours",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Week" => "Cette semaine",
// "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Month" => "Le mois dernier",
// "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Month" => "Ce Mois",
// "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Last Year" => "L'année dernière",
// "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"This Year" => "Cette année",
// "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
"Incorrect parameter: " => "Paramètre incorrect : ",
"Subscript" => "Souscrit",
"Apply subscript font to text" => "Appliquer une police indice au texte",
"Subscribe Group" => "Inscrire un groupe",
"Allow users to subscribe to a group" => "Autoriser les utilisateurs à s'inscrire à un groupe",
"text displayed before the button" => "texte affiché avant le bouton",
"Group name to subscribe to or unsubscribe from" => "Nom du groupe pour s'y inscire ou désinscrire",
"Subscribe Text" => "Texte d'inscription",
// "Subscribe text, containing %0 as the placeholder for the group name" => "Subscribe text, containing %0 as the placeholder for the group name",
"Subscribe" => "Kujiunga",
"Unsubscribe Text" => "Texte de désinscription",
// "Unsubscribe text, containing %0 as the placeholder for the group name" => "Unsubscribe text, containing %0 as the placeholder for the group name",
"Unsubscribe" => "Se désabonner",
"Subscribe Action" => "Action d'inscription",
// "Subscribe button label, containing %0 as the placeholder for the group name" => "Subscribe button label, containing %0 as the placeholder for the group name",
"Unsubscribe Action" => "Action de désinscription",
// "Unsubscribe button label, containing %0 as the placeholder for the group name" => "Unsubscribe button label, containing %0 as the placeholder for the group name",
"Post-subscribe URL" => "URL post-inscription",
"URL to send the user to after subscribing, if required" => "URL vers laquelle envoyer l'utilisateur après son inscription, si nécessaire",
"Post-unsubscribe URL" => "URL post-désincription",
"URL to send the user to after unsubscribing, if required" => "URL vers laquelle envoyer l'utilisateur après sa désinscription, si nécessaire",
// "Make this the default group text, containing %0 as the placeholder for the group name" => "Make this the default group text, containing %0 as the placeholder for the group name",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %0 as the placeholder for the group name" => "Stop this being default group text, containing %0 as the placeholder for the group name",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Second Default" => "Second Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Redirect to new home page after default group change. (default is to redirect)" => "Redirect to new home page after default group change. (default is to redirect)",
// "Can Always Leave" => "Can Always Leave",
// "Always allow leaving a group even if the group settings do not allow user choice" => "Always allow leaving a group even if the group settings do not allow user choice",
"Subscribe Groups" => "S'inscrire à des groupes",
"Allow users to subscribe to a list of groups" => "Autoriser les utilisateurs à s'inscrire à une liste de groupes",
// "Text shown in the dropdown box. Default: %0Subscribe to a group%1" => "Text shown in the dropdown box. Default: %0Subscribe to a group%1",
"Show Subscribe Box" => "Afficher la boîte d'inscription",
// "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box" => "Style to show the subscribe box",
"Show Default" => "Afficher le groupe par défaut",
// "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group" => "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group",
"Group Description" => "Description du groupe",
"Show the description of the group (not shown by default)" => "Afficher la description du groupe (non affichée par défaut)",
"Colon-separated list of groups. By default the list of groups available to the user" => "Liste de groupes séparés par ':'. Par défaut, la liste des groupes accessibles à l'utilisateur",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
"Default URL" => "URL par défaut",
"Page user will be directed to after clicking on icon to change default group" => "Page vers laquelle l'utilisateur sera dirigé après avoir cliqué sur l'icône pour changer le groupe par défaut",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name" => "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name" => "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
"Always allow leaving group" => "Toujours permettre de quitter un groupe",
// "Always allow leaving group even if the group settings do not allow user choice" => "Always allow leaving group even if the group settings do not allow user choice",
"You do not have permission to subscribe to groups" => "Vous n'avez pas les droits pour vous inscrire à des groupes",
"Subscribe to newsletter" => "S'inscrire à la lettre de nouvelles",
"Allow users to subscribe to a newsletter" => "Autoriser les utilisateurs à s'inscrire à une lettre de nouvelles",
"Invitation message" => "Message d'invitation",
"Newsletter ID" => "ID de la lettre de nouvelles",
// "Identification number of the Newsletter that you want to allow the users to subscribe to" => "Identification number of the Newsletter that you want to allow the users to subscribe to",
"Confirmation Message" => "Message de Confirmation",
"Confirmation message after posting form. The plugin body is then the button label" => "Message de confirmation après le formulaire de publication. Le corps du plugiciel est ensuite l'étiquette du bouton",
"Button label. The plugin body is then the confirmation message" => "Label de bouton. Le corps du plugiciel est alors le message de confirmation",
// "Choose whether the output should be parsed as wiki syntax" => "Choose whether the output should be parsed as wiki syntax",
// "In Module" => "In Module",
// "Display the newsletter subscription form in module view (if included in a Tiki module)" => "Display the newsletter subscription form in module view (if included in a Tiki module)",
"Already subscribed" => "Déjà inscrit",
"Superscript" => "Exposant",
"Apply superscript font to text" => "Appliquer une police exposant au texte",
// "Embed a survey" => "Embed a survey",
// "Id of the survey set up by the administrator" => "Id of the survey set up by the administrator",
"Wiki Page to redirect the user after his vote" => "Page Wiki vers laquelle rediriger l'utilisateur après son vote",
// "Language for the survey" => "Language for the survey",
// "Swiper" => "Swiper",
// "Embed swiper in content, support file galleries, files id and custom content" => "Embed swiper in content, support file galleries, files id and custom content",
// "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> " => "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> ",
// "Enter file gallery id for slider" => "Enter file gallery id for slider",
// "Transition Effect" => "Transition Effect",
// "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"" => "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"",
// "Slider Placement on Page" => "Slider Placement on Page",
// "Placement of slider, above topbar, below topbar, above menus and content or inside content" => "Placement of slider, above topbar, below topbar, above menus and content or inside content",
// "Inside Content" => "Inside Content",
// "Above top bar / Top of page" => "Above top bar / Top of page",
// "Above Content/Under top bar" => "Above Content/Under top bar",
// "Slider pagination, default bullets" => "Slider pagination, default bullets",
// "Fraction" => "Fraction",
// "Progress bar" => "Progress bar",
// "Display navigation arrows" => "Display navigation arrows",
// "Slider Background Color" => "Slider Background Color",
// "Slider background color, enter color code for example #000" => "Slider background color, enter color code for example #000",
// "Slider Parallax Background Image" => "Slider Parallax Background Image",
// "Enter image url for parallax background behind swiper" => "Enter image url for parallax background behind swiper",
// "Enter width of slider in px, default 100%" => "Enter width of slider in px, default 100%",
// "Enter height of slider in px, default min height 100px, max height will adjust with content" => "Enter height of slider in px, default min height 100px, max height will adjust with content",
// "Slide title color" => "Slide title color",
// "Enter text color code of slide title, for example #ccc" => "Enter text color code of slide title, for example #ccc",
// "Title font size" => "Title font size",
// "For example 42px, default 32 px" => "For example 42px, default 32 px",
// "Slide description color" => "Slide description color",
// "Enter text color code of slide description, for example #ccc" => "Enter text color code of slide description, for example #ccc",
// "Description font size" => "Description font size",
// "For example 24px, default 16 px" => "For example 24px, default 16 px",
// "Slide content background" => "Slide content background",
// "Slide content position" => "Slide content position",
// "Enter position for example top:20%;left:20% or bottom:20%;right:10%" => "Enter position for example top:20%;left:20% or bottom:20%;right:10%",
// "Autoplay slider, on by default" => "Autoplay slider, on by default",
// "Auto Play Delay" => "Auto Play Delay",
// "Show thumbnails under main slider" => "Show thumbnails under main slider",
// "Duration of transition between slides (in seconds)" => "Duration of transition between slides (in seconds)",
// "Auto Height" => "Auto Height",
// "Set to true and slider wrapper will adopt its height to the height of the currently active slide" => "Set to true and slider wrapper will adopt its height to the height of the currently active slide",
// "Space Between" => "Space Between",
// "Distance between slides in px" => "Distance between slides in px",
// "Slides Per View" => "Slides Per View",
// "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view" => "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view",
// "Slides Per View Mobile Screen" => "Slides Per View Mobile Screen",
// "Slides visible at the same time on small screens" => "Slides visible at the same time on small screens",
// "Slides Per View Tablet" => "Slides Per View Tablet",
// "Slides visible at the same time on low resolution tablets" => "Slides visible at the same time on low resolution tablets",
// "Slides Per Column" => "Slides Per Column",
// "Number of slides per column, for multirow layout" => "Number of slides per column, for multirow layout",
// "Slides Per Column Fill" => "Slides Per Column Fill",
// "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row" => "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row",
// "Centered Slides" => "Centered Slides",
// "If true, then active slide will be centered, not always on the left side" => "If true, then active slide will be centered, not always on the left side",
// "Slides Offset Before" => "Slides Offset Before",
// "Add (in px) additional slide offset in the beginning of the container (before all slides)" => "Add (in px) additional slide offset in the beginning of the container (before all slides)",
// "Slides Offset After" => "Slides Offset After",
// "Add (in px) additional slide offset in the end of the container (after all slides)" => "Add (in px) additional slide offset in the end of the container (after all slides)",
// "Slide To Clicked Slide" => "Slide To Clicked Slide",
// "Set to true and click on any slide will produce transition to this slide" => "Set to true and click on any slide will produce transition to this slide",
// "Free Mode" => "Free Mode",
// "If true then slides will not have fixed positions" => "If true then slides will not have fixed positions",
// "Preload Images" => "Preload Images",
// "When enabled Swiper will force to load all images" => "When enabled Swiper will force to load all images",
// "Update On Images Ready" => "Update On Images Ready",
// "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true" => "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true",
// "Loop Slider" => "Loop Slider",
// "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))" => "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))",
// " Please update composer to install required files" => " Please update composer to install required files",
// "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body" => "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body",
"Arrange content in tabs" => "Disposer un contenu en onglets",
"Tabs content, separated by \"/////\"" => "Contenu des onglets séparés par /////",
"Tabset Name" => "Nom du jeu d'onglets",
// "Unique tabset name (if you want the last state to be remembered). Example" => "Unique tabset name (if you want the last state to be remembered). Example",
"Tab Titles" => "Titres d'onglet",
// "Pipe-separated list of tab titles. Example" => "Pipe-separated list of tab titles. Example",
// "Toggle Tabs" => "Toggle Tabs",
"Allow toggling between tabs and no-tabs view" => "Permet de basculer de l'affichage avec onglets/sans onglets",
// "Inside Pretty Tracker" => "Inside Pretty Tracker",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
"No tab title specified. At least one must be specified in order for the tabs to appear" => "Aucun titre d'onglet n'est spécifié. Il en faut un pour que les onglets apparaissent",
"Apply an HTML tag to content" => "Appliquer une balise HTML au contenu",
"Tag Name" => "Nom de la balise",
// "Any valid HTML tag, 0% by default" => "Any valid HTML tag, 0% by default",
"Equivalent to the style attribute of an HTML tag" => "Equivaut à la balise de style HTML",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)" => "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)",
// "Width of the timeline as CSS units (default: %0)" => "Width of the timeline as CSS units (default: %0)",
// "Height of the timeline as CSS units (default: %0)" => "Height of the timeline as CSS units (default: %0)",
"Primary Scale Unit" => "Unité d'échelle primaire",
// "Unit of time to use for the primary scale (default is Month)" => "Unit of time to use for the primary scale (default is Month)",
"Decade" => "Décade",
"Century" => "Siècle",
"Secondary Scale Unit" => "Unité d'échelle secondaire",
// "Unit of time to use for the secondary scale" => "Unit of time to use for the secondary scale",
"TimeSheet" => "Feuille de temps",
// "Embed a timesheet into a page" => "Embed a timesheet into a page",
"Title Search" => "Utafutaji wa Kichwa",
// "Search page titles" => "Search page titles",
"Search Criteria" => "Critère de recherche",
"Portion of a page name" => "Partie d'un nom de page",
"Also show page hits or user" => "Montrer aussi les scores de la page ou l'utilisateur",
// "Hits and user" => "Hits and user",
// "User and hits" => "User and hits",
"Pipe-separated list of page names to exclude from results" => "Liste séparée par '|' des noms de page à exclure des résultats",
"No Header" => "Pas d'en-tête",
// "Set to Yes (%0) to have no header for the search results" => "Set to Yes (%0) to have no header for the search results",
"No pages found for title search" => "Aucune page trouvée avec la recherche par titre",
"One page found for title search" => "Une page trouvée avec la recherche par titre",
"pages found for title search" => "pages trouvées avec la recherche par titre",
"Table of Contents (Structure)" => "Table des matières (Structure)",
// "Display a table of contents of pages in a structure" => "Display a table of contents of pages in a structure",
"Structure ID" => "ID de la structure",
// "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided" => "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided",
// "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided" => "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided",
"Order items in ascending or descending order (default is ascending)" => "Ordonner les fiches en ordre croissant ou décroissant (croissant par défaut)",
// "Sort Order" => "Sort Order",
// "Order for the first Level of pages that will be displayed. Order by structure is the default" => "Order for the first Level of pages that will be displayed. Order by structure is the default",
// "Structure Order" => "Structure Order",
// "Alphabetic Order" => "Alphabetic Order",
// "Display the page description in front of the page name" => "Display the page description in front of the page name",
"Show Numbering" => "Afficher la numérotation",
"Display the section numbers or not" => "Afficher les numéros de section ou pas",
"Style to apply" => "Style à appliquer",
"Admin" => "Dhibiti",
// "Start Level" => "Start Level",
// "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)" => "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)",
// "Maximum Level Depth" => "Maximum Level Depth",
// "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)" => "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)",
// "Together" => "Together",
// "Collaborate in real time" => "Collaborate in real time",
// "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience" => "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience",
// "Button Name" => "Button Name",
// "Set the button name. Default is CoWrite with TogetherJS" => "Set the button name. Default is CoWrite with TogetherJS",
// "CoWrite with TogetherJS" => "CoWrite with TogetherJS",
// "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time" => "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time",
// "Tour" => "Tour",
// "Quick and easy way to build your product tours with Bootstrap popovers" => "Quick and easy way to build your product tours with Bootstrap popovers",
// "Content of the step" => "Content of the step",
// "Element" => "Element",
// "Element to show the popup on; if empty, use the plugin location itself" => "Element to show the popup on; if empty, use the plugin location itself",
// "Title of the step" => "Title of the step",
// "Index of the step to show after this one, starting from 0, -1 for the last one" => "Index of the step to show after this one, starting from 0, -1 for the last one",
// "Index of the step to show before this one, starting from 0, -1 not to show" => "Index of the step to show before this one, starting from 0, -1 not to show",
// "Path to the page on which the step should be shown" => "Path to the page on which the step should be shown",
// "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below" => "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below",
// "Placement" => "Placement",
// "The placement of the popup" => "The placement of the popup",
// "Orphan" => "Orphan",
// "Setting to true removes the pointer on the popup and centers it on the page" => "Setting to true removes the pointer on the popup and centers it on the page",
// "Backdrop" => "Backdrop",
// "Show a dark backdrop behind the popover and its element, highlighting the current step" => "Show a dark backdrop behind the popover and its element, highlighting the current step",
// "Only Show Once" => "Only Show Once",
// "Show automatically only once. tour_id should also be set if there are multiple tours" => "Show automatically only once. tour_id should also be set if there are multiple tours",
// "Show Until Dismissed" => "Show Until Dismissed",
// "Show automatically only until dismissed. tour_id should also be set if there are multiple tours" => "Show automatically only until dismissed. tour_id should also be set if there are multiple tours",
// "Tour ID" => "Tour ID",
// "Set a tour ID to be able to only show the tour once" => "Set a tour ID to be able to only show the tour once",
// "Restart Button" => "Restart Button",
// "Display a button to restart the tour. Enter the text to appear on the button" => "Display a button to restart the tour. Enter the text to appear on the button",
"Translate" => "kutafsiri",
"Translate text to the user language" => "Traduire le texte dans la langue de l'utilisateur",
// "Embed a form to populate a tracker" => "Embed a form to populate a tracker",
"Numeric value representing the tracker ID" => "Valeur numérique représentant l'ID du formulaire",
"Fields" => "Uwanja",
// "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0" => "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0",
// "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters" => "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters",
// "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically" => "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically",
// "Action Style" => "Action Style",
// "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example" => "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example",
// "Display the title of the tracker at the top of the form (not shown by default)" => "Display the title of the tracker at the top of the form (not shown by default)",
"Show the tracker's description (not shown by default)" => "Afficher la description du formulaire (non affichée par défaut)",
// "Show Fields Descriptions" => "Show Fields Descriptions",
// "Show the tracker's field descriptions (shown by default)" => "Show the tracker's field descriptions (shown by default)",
"Mark Mandatory" => "Marquer comme obligatoire",
"Indicate mandatory fields with an asterisk (shown by default)" => "Indiquer les champs obligatoires avec une astérisque (valeur par défaut)",
"Show Status" => "Afficher le statut",
"Show the status of the items (not shown by default)" => "Afficher le statut des fiches (non affiché par défaut)",
"Embedded" => "Enchâssé",
// "To send an email once the tracker item has been created. Format: %0from" => "To send an email once the tracker item has been created. Format: %0from",
"template%0" => "template</code> ",
// "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)" => "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)",
// "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used" => "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used",
// "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)" => "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)",
// "Keep params in URL" => "Keep params in URL",
// "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL" => "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL",
"URL Target" => "URL cible",
// "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)" => "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)",
"Self" => "Self",
"Overwrite" => " Andika tena",
// "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)" => "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)",
// "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)" => "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)",
// "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item" => "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item",
"Label for the reset button, to return all fields to their default values" => "Tia alama ya kifungo cha 'upya', kurejesha mashamba kwa maadili yao ya msingi",
"reset" => "réinitialiser",
// "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)" => "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)",
// "User&field" => "User&field",
// "User field to filter" => "User field to filter",
// "User field to filter user tracker items to" => "User field to filter user tracker items to",
// "Field to filter" => "Field to filter",
// "Field to filter user tracker items to" => "Field to filter user tracker items to",
// "Field to filter Value" => "Field to filter Value",
// "Value to filter user tracker items to" => "Value to filter user tracker items to",
// "Criteria" => "Criteria",
// "If more than one item found, will choose under this criteria. Used in combination with" => "If more than one item found, will choose under this criteria. Used in combination with",
// "creationDate - Ascending" => "creationDate - Ascending",
// "creationDate - Descending" => "creationDate - Descending",
"Status of the item used in combination with" => "Hali ya fomu inayotumiwa kwa kuunganishwa na",
"or" => "ao",
// "Transaction name" => "Transaction name",
// "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name" => "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name",
// "Transaction Step" => "Transaction Step",
// "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0" => "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0",
// "Final Transaction Step" => "Final Transaction Step",
// "Indicate whether this is the final transaction step" => "Indicate whether this is the final transaction step",
// "Transaction previous URL" => "Transaction previous URL",
// "The page to go back to when the \"previous\" button is clicked" => "The page to go back to when the \"previous\" button is clicked",
// "Transaction previous button label" => "Transaction previous button label",
// "Text for the \"previous\" button label" => "Text for the \"previous\" button label",
"ItemId" => "Kadi ya Id",
// "ItemId identifying the item to be edited" => "ItemId identifying the item to be edited",
"Ignore ItemId" => "Puuza Kadi ya Id",
// "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)" => "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)",
"Template File" => "Faili ya Kigezo",
// "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template" => "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template",
// "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template" => "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template",
"New Status" => "Hali mpya",
// "Default status applied to newly created or saved items" => "Default status applied to newly created or saved items",
// "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form",
// "Autosave Fields" => "Autosave Fields",
// "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave" => "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave",
// "Autosave Values" => "Autosave Values",
// "Colon-separated values corresponding to %0. Special syntax cases" => "Colon-separated values corresponding to %0. Special syntax cases",
// "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field" => "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field",
// "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name" => "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name",
// "Increase-only Fields" => "Increase-only Fields",
// "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field" => "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field",
"Registration Fields" => "Field ya Usajili",
// "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers" => "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers",
// "Register to group" => "Register to group",
// "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)" => "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)",
// "Validate users" => "Validate users",
// "Here one can overrule the default validate users by e-mail preference" => "Here one can overrule the default validate users by e-mail preference",
"Output To Wiki" => "Tuma kwa Wiki",
// "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId" => "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId",
"Discard After Output" => "Lazima Baada ya kutuma",
// "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages" => "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages",
"Template Page" => "Ukurasa kama template",
// "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5" => "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5",
// "Output Wiki Namespace" => "Output Wiki Namespace",
// "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page" => "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page",
// "Store Relation" => "Store Relation",
// "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)" => "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0" => "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0",
// "Fill Fields Separator" => "Fill Fields Separator",
// "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)" => "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)",
// "Fill Fields Defaults" => "Fill Fields Defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
"Embed the tracker in a form tag" => "Ingiza tracker katika tag 'form'",
// "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons" => "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons",
// "Use ajax to create/update tracker items" => "Use ajax to create/update tracker items",
// "Use ajax to create and update tracker items instead of form submission via request variables" => "Use ajax to create and update tracker items instead of form submission via request variables",
// "Transactions" => "Transactions",
// "You need to define both transaction name and transaction step, or none of the two" => "You need to define both transaction name and transaction step, or none of the two",
// "You need to choose transactionFinalStep (y/n)" => "You need to choose transactionFinalStep (y/n)",
// "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button" => "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button",
// "Tracker: Field #%0 not found in fields parameter or template" => "Tracker: Field #%0 not found in fields parameter or template",
"The page to output the results to already exists. Try another name" => "Ukurasa wa kutuma matokeo tayari kuwapo. Jaribu jina lingine",
// "Tracker Transaction: Field #%0 not found in fields parameter or template" => "Tracker Transaction: Field #%0 not found in fields parameter or template",
"Tracker was modified at " => "Tracker ilibadilishwa saa ",
// "Form saved successfully" => "Form saved successfully",
"Incorrect fieldId" => "fieldId isiyo sahihi",
"Following fields are incorrect" => "Fields yafuatayo si sahihi",
// "Error: Read only field \"%0\"" => "Error: Read only field \"%0\"",
// "This field is mandatory" => "This field is mandatory",
"Missing wiki template page \"%0\"" => "Ukurasa wa template \"%0\" usiopotea",
"Each line is a list of %d field values separated with: %s" => "Kila mstari ni orodha ya maadili ya field d% yaliyotengwa na: %s",
"You do not have permission to insert an item" => "Huna ruhusa ya kuingiza kipengee",
"Incorrect item" => "Kipengee isiyo sahihi",
"You do not have permission to modify an item" => "Huna ruhusa ya kurekebisha kipengee",
"The page to output the results to contains the following prohibited characters: %0. Try another name" => "Ukurasa wa kuzalisha matokeo kuwa na wahusika wafuatayo maandiko: %0. Jaribu jina lingine",
// "Please ensure you are using the correct field ID and that it is properly included in the template, if any" => "Please ensure you are using the correct field ID and that it is properly included in the template, if any",
"Passwords do not match" => "Nenosiri hazilingani",
"Insert one item per line:" => "Weka kipengee kimoja kwa kila mstari",
"Fields marked with an * are mandatory." => "Fields yenye alama (*) yanahitajika.",
// "Tracker Calendar" => "Tracker Calendar",
// "Create and display a calendar using tracker data" => "Create and display a calendar using tracker data",
// "Resource Descriptor Field" => "Resource Descriptor Field",
// "Permanent name of the field to use as the resource indicator" => "Permanent name of the field to use as the resource indicator",
// "Coloring Discriminator Field" => "Coloring Discriminator Field",
// "Permanent name of the field to use to segment the information into color schemes" => "Permanent name of the field to use to segment the information into color schemes",
// "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages" => "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages",
// "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)" => "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)",
// "Add All Fields" => "Add All Fields",
// "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId" => "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId",
// "Use Session Storage" => "Use Session Storage",
// "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript" => "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript",
// "Agenda by Months" => "Agenda by Months",
// "Display the option to change the view to agenda by months" => "Display the option to change the view to agenda by months",
// "Agenda by Weeks" => "Agenda by Weeks",
// "Display the option to change the view to agenda by weeks" => "Display the option to change the view to agenda by weeks",
// "Agenda by Days" => "Agenda by Days",
// "Display the option to change the view to agenda by days" => "Display the option to change the view to agenda by days",
// "List by Years" => "List by Years",
// "Display the option to change the view to list by years" => "Display the option to change the view to list by years",
// "List by Months" => "List by Months",
// "Display the option to change the view to list by months" => "Display the option to change the view to list by months",
// "List by Weeks" => "List by Weeks",
// "Display the option to change the view to list by weeks" => "Display the option to change the view to list by weeks",
// "List by Days" => "List by Days",
// "Display the option to change the view to list by days" => "Display the option to change the view to list by days",
// "Resources by Years" => "Resources by Years",
// "Display the option to change the view to resources by years" => "Display the option to change the view to resources by years",
// "Resources by Months" => "Resources by Months",
// "Display the option to change the view to resources by months" => "Display the option to change the view to resources by months",
// "Resources by Weeks" => "Resources by Weeks",
// "Display the option to change the view to resources by weeks" => "Display the option to change the view to resources by weeks",
// "Resources by Days" => "Resources by Days",
// "Display the option to change the view to resources by days" => "Display the option to change the view to resources by days",
"Default View" => "Mtazamo kama msingi",
// "Choose the default view for the Tracker Calendar" => "Choose the default view for the Tracker Calendar",
// "Default Year" => "Default Year",
// "Choose the default year (yyyy) to use for the display" => "Choose the default year (yyyy) to use for the display",
// "Default Month" => "Default Month",
// "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc" => "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc",
// "Default Day" => "Default Day",
// "Choose the default day (dd) to use for the display" => "Choose the default day (dd) to use for the display",
// "Colormap for coloring" => "Colormap for coloring",
// "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0" => "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0",
// "First day of the Week" => "First day of the Week",
// "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)" => "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)",
// "Show Weekends" => "Show Weekends",
// "Display Saturdays and Sundays (shown by default)" => "Display Saturdays and Sundays (shown by default)",
// "Day Start" => "Day Start",
// "First time slot that will be displayed for each day, e.g. %0" => "First time slot that will be displayed for each day, e.g. %0",
// "Day End" => "Day End",
// "Last time slot that will be displayed for each day, e.g. %0" => "Last time slot that will be displayed for each day, e.g. %0",
// "Slot Duration" => "Slot Duration",
// "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)" => "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)",
// "Overlapping allowed" => "Overlapping allowed",
// "Allow resources to overlap in time" => "Allow resources to overlap in time",
// "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator" => "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator",
// "Fields not found" => "Fields not found",
"Tracker Comments" => "Maoni ya Tracker",
// "Display the number of comments for a tracker" => "Display the number of comments for a tracker",
"Item Count" => "Hesabu ya Vipengee",
"Determines whether the number of items will be shown (not shown by default)" => "Inataa kama namba ya vitu itaonyeshwa (haionyeshwa kwa default)",
"Enter a username to select the items of the current user" => "Ingiza jina la mtumiaji kuchagua vipengee vya mtumiaji wa sasa",
"a user name" => "jina la mtumiaji",
"Comments found" => "Maoni yaliyopatikana",
"Filters" => "Filters",
// "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1" => "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1",
// "Format choices are" => "Format choices are",
// "dropdown" => "dropdown",
// "radio buttons" => "radio buttons",
// "multiple choice dropdown" => "multiple choice dropdown",
// "checkbox" => "checkbox",
// "text with wild characters" => "text with wild characters",
// "exact text match" => "exact text match",
// "initials" => "initials",
// "advanced search" => "advanced search",
// "range search (from/to)" => "range search (from/to)",
// "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal" => "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal",
// "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)" => "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)",
"Display List" => "Onyesha Orodha",
"Show the full list (before filtering) initially (filtered list shown by default)" => "Onyesha orodha kamili (kabla ya kuchuja) awali (orodha iliyochujwa iliyoonyeshwa na default)",
"Displays all the filters on the same line (not shown on same line by default)" => "Onyesha vichujio vyote kwenye mstari huo (hauonyeshwa kwenye mstari wa moja kwa moja)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
"No Toggle" => "Hakuna Toggle",
// "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)" => "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)",
"Export CSV" => "Tuma faili ya CSV",
"Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Lebo kwa kifungo cha nje. Acha tupu ili kuonyesha badala ya kawaida \"Chujio\"",
// "Export Status Field" => "Export Status Field",
// "Export the status field if the Export CSV option is used" => "Export the status field if the Export CSV option is used",
// "Export Created Date Field" => "Export Created Date Field",
// "Export the created date field if the Export CSV option is used" => "Export the created date field if the Export CSV option is used",
// "Export Modified Date Field" => "Export Modified Date Field",
// "Export the modified date field if the Export CSV option is used" => "Export the modified date field if the Export CSV option is used",
// "Export Character Set" => "Export Character Set",
// "Character set to be used if the Export CSV option is used" => "Character set to be used if the Export CSV option is used",
// "Map View Buttons" => "Map View Buttons",
"Display Mapview and Listview buttons" => "Onyesha vifungo vya Mapview na Listview",
// " - was %0 until 12.0" => " - was %0 until 12.0",
"Tracker Filter" => "Chujio cha fomu",
"Create a form to filter tracker fields" => "Unda fomu ya kuchuja fields ya fomu",
// "notice" => "notice",
// "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set" => "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set",
// "TrackerFields: Unknown tracker field used in the parameter \"filters\"" => "TrackerFields: Unknown tracker field used in the parameter \"filters\"",
"tracker field type not processed yet" => "field ya fomu usiotibiwa kwa sasa",
"Tracker If" => "Fomu ya mtihani",
"Display content based on results of a tracker field test" => "Onyesha maudhui kulingana na matokeo ya maandiko kwenye field wa fomu",
"Ignore" => "Kupuuza",
"Ignore test in edit mode" => "Puuza mtihani katika hali ya hariri",
"Copy Tracker Item" => "Nakili Kitu cha Tracker",
"PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Copy a tracker item" => "Copy a tracker item",
// "Tracker from which to copy item, joined tracker ids separated by %0:%1" => "Tracker from which to copy item, joined tracker ids separated by %0:%1",
// "Link Field IDs" => "Link Field IDs",
// "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1" => "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1",
// "Copy Field IDs" => "Copy Field IDs",
// "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1" => "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1",
// "Update Field IDs" => "Update Field IDs",
// "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1" => "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1",
"New Values" => "Maadili mapya",
// "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId" => "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId",
"ID of item to make copy of, otherwise input is asked for" => "Kitambulisho cha kipengee cha kufanya nakala, vinginevyo pembejeo huulizwa",
"Make this number of copies on load" => "Fanya idadi hii ya nakala wakati wa kupakia",
"Set the number of copies to make on load of plugin automatically" => "Weka idadi ya nakala zinazopaswa kupakia wakati wa kuziba pembejeo, kwa moja kwa moja",
"Returns array non-interactively" => "Inarudi safu isiyo ya maingiliano",
// "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode" => "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode",
"Missing mandatory parameters" => "Vigezo vinavyohitajika havipo",
"Number of update fields do not match new values" => "Idadi ya fields ya kusasisha haifanani na idadi ya maadili mapya",
"Tracker Item Field" => "Field la Kipengee cha Tracker",
"Display or test the value of a tracker item field" => "Kuonyesha au kupima thamani ya shamba la bidhaa za tracker",
// "Wiki text containing an %0{ELSE}%1 marker" => "Wiki text containing an %0{ELSE}%1 marker",
// "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user" => "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user",
"Numeric value representing the field ID displayed or tested" => "Thamani ya namba inayowakilisha ID ya field iliyoonyeshwa au iliyojaribiwa",
"Colon-separated list of field IDs. Default is all fields" => "Orodha ya watambuzi wa field waliojitenga na ':'. Mchapishaji: Fields yote",
"Status of the tracker item" => "Hali ya kipengee cha tracker",
"Open & Pending" => "Kufungua & Kusubiri",
"Open & Closed" => "Kufungua & Imefungwa",
"Pending & Closed" => "Kusubiri & Imefungwa",
"Open, Pending & Closed" => "Kufungua, Kusubiri & Imefungwa",
// "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter" => "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter",
"Value to compare against" => "Thamani ya kulinganisha dhidi",
"You are not allowed to view this item" => "Huruhusiwi kuona kipengee hiki",
"You don't have permission to view this field" => "Huna ruhusa ya kutazama uwanja huu",
// "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1" => "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1",
// "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default" => "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default",
// "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param" => "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param",
"Sticky Popup" => "Sticky Popup",
// "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)",
"Display the title of the tracker (not shown by default)" => "Onyesha kichwa cha tracker (kisichoonyeshwa kwa default)",
"Show Links" => "Onyesha Viungo",
// "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work" => "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work",
"Row" => "Mstari",
"Show Item Count" => "Onyesha Hesabu ya Kipengee",
"Show the number of items found (not shown by default)" => "Onyesha idadi ya vitu vilivyopatikana (hazionyeshwa kwa default)",
"Show Initials" => "Onyesha Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)" => "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)",
// "Creation date display is based on tracker settings unless overridden here" => "Creation date display is based on tracker settings unless overridden here",
"Last Modification Date" => "Tarehe ya Marekebisho ya Mwisho",
// "Last modification date display is based on tracker settings unless overridden here" => "Last modification date display is based on tracker settings unless overridden here",
// "Last modified by user display is based on tracker settings unless overridden here" => "Last modified by user display is based on tracker settings unless overridden here",
"Show Field Name" => "Onyesha Jina la field",
"Use the field names as column titles (used by default)" => "Tumia majina ya field kama vyeo vya safu (zinazotumiwa na default)",
"Show Item Rank" => "Onyesha Rank ya Kipengee",
"Show item ranks (not shown by default)" => "Onyesha rank za vipengee (hazionyeshwa kwa default)",
// "Show comments count or last comment date and user depending on tracker preferences" => "Show comments count or last comment date and user depending on tracker preferences",
"Only show items matching certain status filters (only items with open status shown by default)" => "Onyesha vitu vinavyolingana na vichujio fulani vya hali (vitu pekee na hali ya wazi inayoonyeshwa na default)",
// "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified" => "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified",
// "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)" => "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)",
"Sort Choice" => "Penga Chaguo",
// "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1" => "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1",
// "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1" => "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1",
"Offset of first item. Default is no offset" => "Kutolewa kwa fomu ya kwanza. Hakuna chaguo-msingi cha kushindwa",
"Fix offset always (no pagination)" => "Daima kurekebisha upungufu (hakuna pagination)",
// "Fix offset to that specified. This will disallow pagination" => "Fix offset to that specified. This will disallow pagination",
"Show Pagination" => "Onyesha Pagination",
"Determines whether pagination will be shown (shown by default)" => "Inataa kama pagination itaonyeshwa (imeonyeshwa kwa default)",
// "Show button to make entire width of tables visible" => "Show button to make entire width of tables visible",
// "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)" => "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)",
"Filter Field" => "Sehemu ya Filter",
"Colon-separated list of fields to allow filtering on" => "Orodha iliyogawanyika ya Colon ya mashamba kuruhusu kuchuja",
"Filter Value" => "Thamani ya Filter",
// "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match" => "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match",
// "text that ends in \"value\"" => "text that ends in \"value\"",
// "text that begins with \"value\"" => "text that begins with \"value\"",
// "the current user's login name" => "the current user's login name",
// "the current user's default group" => "the current user's default group",
// "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead" => "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead",
// "any text" => "any text",
"Exact Value" => "Thamani halisi",
// "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by" => "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by",
// "tracker item is in category with ID x or one its descendants" => "tracker item is in category with ID x or one its descendants",
// "tracker item is not in category with ID x or one of its descendants" => "tracker item is not in category with ID x or one of its descendants",
// "match against the value of a Tiki preference" => "match against the value of a Tiki preference",
// "match if value does not equal a Tiki preference value" => "match if value does not equal a Tiki preference value",
// "match if the field does not equal \"value\"" => "match if the field does not equal \"value\"",
// "match for non empty values (opposite with %0exactvalue%1=\"\")" => "match for non empty values (opposite with %0exactvalue%1=\"\")",
// "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)" => "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)",
// "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )" => "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )",
// "match if less than \"value\"" => "match if less than \"value\"",
// "match if greater than \"value\"" => "match if greater than \"value\"",
// "match if less than or equal to \"value\"" => "match if less than or equal to \"value\"",
// "match if greater than or equal to \"value\"" => "match if greater than or equal to \"value\"",
// "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are" => "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are",
// "the value of this field will be posted to the action" => "the value of this field will be posted to the action",
// "the name of the post" => "the name of the post",
// "the title of the submit button" => "the title of the submit button",
// "the name of the submit button" => "the name of the submit button",
// "the file that will be called upon submit" => "the file that will be called upon submit",
// "optional template inserted before the submit button and returned" => "optional template inserted before the submit button and returned",
// "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1" => "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1",
// "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case" => "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case",
// "comma-separated list of pre-checked items" => "comma-separated list of pre-checked items",
// "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1" => "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1",
// "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1" => "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1",
"goIfOne" => "Nenda Kama Mmoja",
// "Display the item rather than list if only one item is found" => "Display the item rather than list if only one item is found",
// "Show a 'more' button that links to the tracker item (not shown by default)" => "Show a 'more' button that links to the tracker item (not shown by default)",
"More link pointing to specified URL instead of default tracker item link" => "Kiungo kikubwa kinachozungumzia URL maalum badala ya kiungo cha kipengee chenye chaguo-msingi",
// "Display only the items of the following" => "Display only the items of the following",
// "the current user" => "the current user",
// "the current page name" => "the current page name",
// "the current IP address" => "the current IP address",
// "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1" => "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1",
// "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins" => "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins",
// "Template Wiki Page" => "Template Wiki Page",
// "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins" => "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins",
"View User" => "Tazama mtumiaji",
"Will display the items of the specified user" => "Utaonyesha vitu vya mtumiaji maalum",
// "Colon-separated list of item IDs to restrict the listing to" => "Colon-separated list of item IDs to restrict the listing to",
"Ignore the itemId url parameter when filtering list (not ignored by default)" => "Puuza kipengee cha kipengee cha url wakati wa kuchuja orodha (haijapuuzwa na default)",
// "The link that will be on each main field when %0showlinks=\"y\"%1. Special values" => "The link that will be on each main field when %0showlinks=\"y\"%1. Special values",
// "will link to the item based on its item ID" => "will link to the item based on its item ID",
// "will link to the item based on its offset value" => "will link to the item based on its offset value",
// "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused" => "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused",
// "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example" => "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example",
// "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties" => "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties",
// "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1" => "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1",
// "Left Delimiter" => "Left Delimiter",
// "Smarty left delimiter for Latex generation. Example" => "Smarty left delimiter for Latex generation. Example",
// "Right Delimiter" => "Right Delimiter",
// "Smarty right delimiter for Latex generation Example" => "Smarty right delimiter for Latex generation Example",
"List Mode" => "Orodha ya Orodha",
// "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting",
"Comma Separated Values" => "Vipimo vya Comma Kinachotenganishwa",
"Export Button" => "Button ya kuuza nje",
"Show an export button (not shown by default)" => "Onyesha kifungo cha nje (hazionyeshwa kwa default)",
"Compute" => "Thibitisha",
// "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable" => "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable",
"fieldId" => "Id ya shamba",
// "%0, separated by %1" => "%0, separated by %1",
"Silent" => "kimya",
// "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)",
"Show Delete" => "Onyesha Futa",
// "Show a delete icon for each item (not shown by default)" => "Show a delete icon for each item (not shown by default)",
// "Url to redirect to after delete" => "Url to redirect to after delete",
"Show Open Item" => "Onyesha kipengele cha wazi",
"Show an open item  option (not shown by default)" => "Onyesha kipengee cha kipengee cha wazi (hazionyeshwa kwa default)",
"Show Close Item" => "Onyesha Kipengee cha Karibu",
"Show a close item option (not shown by default)" => "Onyesha chaguo la kipengee cha karibu (halionyeshwa kwa default)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
"Show Watch Button" => "Onyesha Button ya Kuangalia",
"Show a watch button (not shown by default)" => "Onyesha kifungo cha kutazama (kisichoonyeshwa kwa default)",
"Show Feed Button" => "Onyesha Button ya Chakula",
"Show an RSS feed button (not shown by default)" => "Onyesha kifungo cha RSS (kisichoonyeshwa kwa default)",
// "Show Results Map" => "Show Results Map",
// "Show Map of results (not shown by default)" => "Show Map of results (not shown by default)",
"Calendar Field IDs" => "Vitambulisho vya Shamba za Kalenda",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1",
"Calendar View Mode" => "Njia ya Kuangalia Kalenda",
"Calendar view type time span (default is month)" => "Aina ya mtazamo wa kalenda (default ni mwezi)",
"Two months" => "Miezi miwili",
"Trimester" => "Trimester",
"Calendar Popup" => "Kalenda ya Kiingilizi",
// "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)" => "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)",
// "Calendar item popups will stay open if set to y (Yes). Not sticky by default" => "Calendar item popups will stay open if set to y (Yes). Not sticky by default",
"Beginning of Month" => "Mwanzo wa Mwezi",
"Set whether calendar will begin at the beginning of the month (does by default)" => "Weka kama kalenda itaanza mwanzoni mwa mwezi (inafanya kwa default)",
"Show calendar navigation bar (shown by default)" => "Onyesha bar ya urambazaji ya kalenda (iliyoonyeshwa na default)",
"Partial" => "sehemu",
"Calendar Title" => "Kichwa cha kalenda",
"Enter a title to display a calendar title (not set by default)" => "Ingiza kichwa cha kuonyesha kichwa katika kalenda (isiyoelezwa na default)",
"Calendar Delta" => "Intervalle calendrier",
"Set the calendar delta that will be shown (not set by default)" => "Weka muda wa kalenda ambao utaonyeshwa (haujawekwa na default)",
"Plus Month" => "Miezi zaidi",
"Minus Month" => "Miezi kidogo",
"Plus Two months" => "Bimestre zaidi",
"Minus Two months" => "Bimestre chini",
"Display Spreadsheet" => "Tazama kwenye lahajedwali",
"Display tracker as a spreadsheet (not used by default)" => "Tazama fomu kama sahajedwali (haitumiwi na default)",
"Force Compile" => "Weka ushiriki",
// "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)" => "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
"Creation" => "viumbe",
// "Modification" => "Modification",
// "Inline edit" => "Inline edit",
// "Colon-separated list of fields for which inline editing will be enabled" => "Colon-separated list of fields for which inline editing will be enabled",
// "Inline edit All" => "Inline edit All",
// "Allow all displayed fields to be editable" => "Allow all displayed fields to be editable",
// "Compile Each Item" => "Compile Each Item",
// "Compile each item separately instead of compiling the entire template" => "Compile each item separately instead of compiling the entire template",
"Tracker List" => "Orodha ya Karatasi za Fomu",
"List, filter and sort the items in a tracker" => "Orodha, futa, na fomu fomu kwenye fomu",
// "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y" => "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y",
// "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly" => "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly",
// "For best results the date filter should only be applied to date field types" => "For best results the date filter should only be applied to date field types",
// "To filter the category field type, the exact category name or id needs to be entered" => "To filter the category field type, the exact category name or id needs to be entered",
"incorrect filterfield" => "kichujio kisicho sahihi",
// "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field" => "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field",
"Error in tracker ID" => "Hitilafu kwenye Kitambulisho cha fomu",
"No field indicated" => "Hakuna mashamba yaliyoonyeshwa",
// "Check Tracker Passcodes" => "Check Tracker Passcodes",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Verify a tracker passcode" => "Verify a tracker passcode",
// "Session Key Names" => "Session Key Names",
"Tracker Prefill" => "Fomu ya Kujaza Kabla",
"Create a button to prefill tracker fields" => "Unda kifungo kabla ya kujaza mashamba ya fomu",
// "Tracker page name" => "Tracker page name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1" => "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1",
"Field 1" => "Shamba ya 1",
"Field ID for the first field" => "Kitambulisho cha shamba kwa uwanja wa kwanza",
"Value 1" => "Thamani 1",
"Content that should be used to prefill the field" => "Maudhui ya kutumia kabla ya kujaza shamba",
"Field 2" => "Shamba ya 2",
"Field ID for the second field" => "Kitambulisho cha shamba kwa uwanja wa pili",
"Value 2" => "Thamani 2",
"Field 3" => "Shamba 3",
"Field ID for the third field" => "Kitambulisho cha shamba kwa uwanja wa tatu",
"Value 3" => "Thamani 3",
"Field 4" => "Shamba 4",
"Field ID for the fourth field" => "Kitambulisho cha shamba kwa uwanja wa nne",
"Value 4" => "Thamani 4",
"Field 5" => "Shamba ya 5",
"Field ID for the fifth field" => "Kitambulisho cha shamba kwa uwanja wa tano",
"Value 5" => "Thamani 5",
"Field 6" => "Shamba ya 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
"Field 7" => "Shamba ya 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
"Field 8" => "Shamba ya 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
// "Tracker Query Template" => "Tracker Query Template",
// "Generate a form from tracker data" => "Generate a form from tracker data",
// "Wiki Syntax, with variables from tracker query" => "Wiki Syntax, with variables from tracker query",
// "The name of the tracker to be queried, or if %0, the tracker ID" => "The name of the tracker to be queried, or if %0, the tracker ID",
// "Turn tracker query debug on (off by default)" => "Turn tracker query debug on (off by default)",
// "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs" => "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs",
// "Render" => "Render",
// "Render as needed for trackers (default)" => "Render as needed for trackers (default)",
// "Item id of tracker item" => "Item id of tracker item",
// "Tracker Item Ids" => "Tracker Item Ids",
// "Item id of tracker items, separated with comma" => "Item id of tracker items, separated with comma",
// "Like Filters" => "Like Filters",
// "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "And Filters" => "And Filters",
// "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Or Filters" => "Or Filters",
// "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Get Last" => "Get Last",
// "Retrieve only the last item from the tracker" => "Retrieve only the last item from the tracker",
"Tracker Stats" => "Stats ya Tracker",
"Display statistics about a tracker" => "Onyesha takwimu kuhusu tracker",
// "Colon-separated list of field IDs to be displayed. Example" => "Colon-separated list of field IDs to be displayed. Example",
// ". " => ". ",
// "Leave it empty to display all fields from this tracker" => "Leave it empty to display all fields from this tracker",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)" => "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)",
// "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)" => "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)",
"Only show items matching certain status filters" => "Onyesha tu vitu vinavyolingana na vichujio fulani vya hali",
// "Add a link to the tracker" => "Add a link to the tracker",
// "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example" => "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example",
"invalid status" => "hali batili",
"incorrect fieldId" => "shamba sahihi Id",
"Tracker Timeline" => "Wakati wa Tracker",
"Show a timeline view of a tracker" => "Onyesha mtazamo wa ratiba ya tracker",
"Title Field" => "Siri ya Kichwa",
"Tracker Field ID containing the item title" => "Kitambulisho cha Shamba cha Tracker kilicho na kichwa cha kipengee",
"Summary Field" => "Sehemu ya Muhtasari",
// "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
"Element Group" => "Kundi la Element",
// "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row",
"Lower Bound" => "Bonde la Chini",
// "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
"Upper Bound" => "Bound Up",
// "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
"Decade *" => "Muongo *",
"Century *" => "Karne *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)",
// "Link Group Name" => "Link Group Name",
"Convert the group name to a link" => "Badilisha jina la kikundi kwa kiungo",
// "Page Link Field" => "Page Link Field",
"Tracker Field ID containing the page name for item details" => "Kitambulisho cha Shamba ya Tracker kilicho na jina la ukurasa kwa maelezo ya bidhaa",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
"Image Field" => "Sehemu ya Picha",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
"Missing parameter: %0" => "Kipimo cha kupoteza: %0",
"Start date after end date" => "Tarehe ya kuanza baada ya tarehe ya mwisho",
"Tracker Toggle" => "Tracker Kubadilisha",
"Numeric value representing the field ID tested" => "Thamani ya namba inayowakilisha ID ya shamba iliyojaribiwa",
// "Element Visibility" => "Element Visibility",
// "Set whether visible when the field has the value" => "Set whether visible when the field has the value",
"HTML id of the element that is toggled" => "Kitambulisho cha HTML cha kipengele kinachochaguliwa",
// "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set" => "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set",
// "trackertoggle: Param fieldId is required" => "trackertoggle: Param fieldId is required",
// "trackertoggle: Param fieldId field %0 does not exsist" => "trackertoggle: Param fieldId field %0 does not exsist",
// "trackertoggle: Param value is required" => "trackertoggle: Param value is required",
// "trackertoggle: Param id is required" => "trackertoggle: Param id is required",
// "Adjust the visibility of content based on a tracker field's value, possibly dynamically" => "Adjust the visibility of content based on a tracker field's value, possibly dynamically",
"Trade" => "Biashara",
// "Send payments between members using cclite" => "Send payments between members using cclite",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Name of the user to receive or send the payment" => "Name of the user to receive or send the payment",
"Leave empty to display an input box" => "Acha tupu ili kuonyesha sanduku la kuingiza",
// "Offered or wanted item" => "Offered or wanted item",
// "%0Offered%1" => "%0Offered%1",
// "Offered" => "Offered",
"Wanted" => "Unataka",
// "%0Continue%1" => "%0Continue%1",
"Title of the input form" => "Kichwa cha fomu ya kuingia",
// "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted",
"Please log in" => "Tafadhali ingia",
" needs to validate their account" => "inahitaji kuthibitisha akaunti yao",
"Transclude" => "Transclude",
"PluginTransclude" => "Plugin Transclude",
"Include the content of another page with certain changes" => "Jumuisha maudhui ya ukurasa mwingine na mabadiliko fulani",
"Name of the wiki page to use as a template for the values" => "Jina la ukurasa wa wiki kutumia kama template kwa maadili",
"Attempt to include a page that cannot be viewed" => "Jaribu kuingiza ukurasa ambao hauwezi kutazamwa",
"Page named \"%0\" does not exist at this time" => "La page nommée \"%0\" n'existe pas à l'heure actuelle",
"Translated" => "Ilitafsiriwa",
// "Create multilingual links" => "Create multilingual links",
"[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((nom de la page wiki)) or ((inter:interwiki)) (utiliser la wiki syntax)",
// "Two letter language code of the language, example" => "Two letter language code of the language, example",
"Flag" => "Bendera",
// "Country name, example" => "Country name, example",
// "Translate a link from one language to another" => "Translate a link from one language to another",
// "TranslationOf" => "TranslationOf",
// "Original Page" => "Original Page",
// "Name of the page from which this link will be translated" => "Name of the page from which this link will be translated",
// "Translation Language" => "Translation Language",
// "Two letter language code of the language in which you want to translate this\n                    link. Example" => "Two letter language code of the language in which you want to translate this\n                    link. Example",
// "Translation Name" => "Translation Name",
// "Name of the page that will become the translation of the \"Original Page\"" => "Name of the page that will become the translation of the \"Original Page\"",
// "Translate this link" => "Translate this link",
"Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Twitter Path" => "Twitter Path",
// "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. " => "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. ",
// "Widget Id" => "Widget Id",
// "Numeric identifier of the widget" => "Numeric identifier of the widget",
// "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1" => "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1",
// "light" => "light",
"dark" => "nyeusi",
// "Link Color" => "Link Color",
// "Text color for individual tweets. Default is theme default" => "Text color for individual tweets. Default is theme default",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Border Color" => "Border Color",
// "Change the border color used by the widget. Default is theme default" => "Change the border color used by the widget. Default is theme default",
// "Height of widget in pixels. Default is %0" => "Height of widget in pixels. Default is %0",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is %0" => "Width of widget in pixels or 'auto' to fit to width of page. Default is %0",
"Number of pixels or the word 'auto'" => "Idadi ya saizi au neno 'auto'",
// "Default is with Header" => "Default is with Header",
// "No Footer" => "No Footer",
// "Default is with Footer" => "Default is with Footer",
// "Footer" => "Footer",
// "Layout Option: No Borders" => "Layout Option: No Borders",
// "Default is with Borders" => "Default is with Borders",
"Borders" => "Bordures",
// "No Borders" => "No Borders",
// "No Scrollbar" => "No Scrollbar",
// "Default is with Scrollbar" => "Default is with Scrollbar",
// "Scrollbar" => "Scrollbar",
// "Transparent Background" => "Transparent Background",
// "Transparent Shell Background. Default is theme default" => "Transparent Shell Background. Default is theme default",
// "Theme default" => "Theme default",
"User Count" => "Idadi ya watumiaji",
// "Display number of users for a site or one or more groups" => "Display number of users for a site or one or more groups",
// "Group name. If left blank, the total number of users for the site will be shown" => "Group name. If left blank, the total number of users for the site will be shown",
// "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings" => "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings",
// "UserInGroup" => "UserInGroup",
// "checks if an individual user is in a particular Group and simply return a string set to either true or false" => "checks if an individual user is in a particular Group and simply return a string set to either true or false",
// "userId" => "userId",
// "the userId to be checked" => "the userId to be checked",
// "test group" => "test group",
// "the Group that the userId check is made against" => "the Group that the userId check is made against",
// "text for true result" => "text for true result",
// "The text that is displayed if the test result is true" => "The text that is displayed if the test result is true",
// "text for false result" => "text for false result",
// "The text that is displayed if the test result is false" => "The text that is displayed if the test result is false",
// "Last Login information" => "Last Login information",
// "PluginUserLastLogged" => "PluginUserLastLogged",
// "Show the last login information for a given or current user" => "Show the last login information for a given or current user",
// "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank" => "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank",
// "DateFormat" => "DateFormat",
// "Date format setting. Short_datetime used by default" => "Date format setting. Short_datetime used by default",
"User Link" => "Kiungo cha mtumiaji",
"Display a link to a user's information page" => "Angalia kiungo kwenye ukurasa wa habari wa mtumiaji",
"User account name (which can be an email address)" => "Jina la akaunti ya mtumiaji (ambayo inaweza kuwa anwani ya barua pepe)",
"User List" => "Orodha ya Watumiaji",
"Display a list of registered users" => "Angalia orodha ya watumiaji waliosajiliwa",
"Login Filter" => "Chujio cha ID",
"Separator to use between users in the list. Default: comma" => "Separator kutumia kati ya watumiaji katika orodha. Vifunguo: comma",
// "Set to sort in ascending or descending order" => "Set to sort in ascending or descending order",
// "Set to table to display results in a table" => "Set to table to display results in a table",
// "Make the user names listed links to different types of user information" => "Make the user names listed links to different types of user information",
"User info" => "Maelezo ya Mtumiaji",
"User page" => "Ukurasa wa mtumiaji",
"User pref" => "Pref. user",
"Real Name" => "Jina halisi",
"Display the user's real name (when available) instead of login name" => "Tazama jina halisi la mtumiaji (wakati inapatikana) badala ya Kitambulisho cha kuingia",
"Filter on a group" => "Futa kwenye kikundi",
"Display contents based on user preference settings" => "tazama maudhui kulingana na mipangilio ya upendeleo wa mtumiaji",
"Create tabs for showing alternate versions of content" => "Unda tabo ili uone matoleo tofauti ya maudhui",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault",
// "Display a navigation box that allows users to select a specific version to display" => "Display a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default" => "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default",
"Default Label" => "Lebo ya pekee",
// "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'" => "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'",
// "Embed a Vimeo video" => "Embed a Vimeo video",
// "Complete URL to the Vimeo video. Example" => "Complete URL to the Vimeo video. Example",
// "or leave blank to upload one" => "or leave blank to upload one",
"Quality of the video" => "Ubora wa video",
"Expand to full screen" => "Badilisha kwenye hali kamili ya skrini",
// "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)" => "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)",
// "Numeric ID of a Tracker Files field, using Vimeo displayMode" => "Numeric ID of a Tracker Files field, using Vimeo displayMode",
// "Numeric ID of a Tracker item, using Vimeo displayMode" => "Numeric ID of a Tracker item, using Vimeo displayMode",
// "Gallery ID to upload to" => "Gallery ID to upload to",
// "Froogaloop API" => "Froogaloop API",
// "Use Vimeo Froogaloop API" => "Use Vimeo Froogaloop API",
// "Show the Video Title" => "Show the Video Title",
// "(default is to show)" => "(default is to show)",
// "Show Byline" => "Show Byline",
// "Show Portrait" => "Show Portrait",
// "Vimeo video not found for file #%0" => "Vimeo video not found for file #%0",
// "Feature required" => "Feature required",
// "Feature \"vimeo_upload\" is required to be able to add videos here" => "Feature \"vimeo_upload\" is required to be able to add videos here",
// "You do not have permsission to add files here" => "You do not have permsission to add files here",
// "You do not have permsission modify this tracker item" => "You do not have permsission modify this tracker item",
// "You do not have permsission modify this page" => "You do not have permsission modify this page",
// "Show the creator's byline" => "Show the creator's byline",
// "Show the creator's profile picture" => "Show the creator's profile picture",
"Vote" => "kura",
"Create a tracker for voting" => "Unda fomu ya kupiga kura",
// "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example" => "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example",
// "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)" => "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)",
// "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)" => "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)",
"Show Stats" => "Onyesha Takwimu",
"Choose whether to show the voting results (shown by default)" => "Chagua kuonyesha au si matokeo ya kupiga kura (ndiyo kwa default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)",
// "Show Toggle" => "Show Toggle",
// "Show toggle or not to display the form and the results" => "Show toggle or not to display the form and the results",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
"Wanted Pages" => "Kurasa zinazohitajika",
"Show location of links to pages not yet created" => "Onyesha eneo la viungo kwa kurasa ambazo hazijaundwa",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)",
"a valid regex-expression (PCRE)" => "kujieleza halali ya regex (PCRE)",
"Split By" => "Kugawanya",
"The character by which ignored patterns are separated" => "Tabia ambayo imepuuzwa mifumo imetengwa",
// "Skip Alias" => "Skip Alias",
// "Whether to skip wanted pages that have a defined alias (not skipped by default)" => "Whether to skip wanted pages that have a defined alias (not skipped by default)",
"Skip Extension" => "Ruka Ugani",
"Whether to include external wikis in the list (not included by default)" => "Ikiwa ni pamoja na wikis ya nje katika orodha (isiyojumuishwa na default)",
"Collect" => "Kusanya",
// "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column",
"From" => "Kutoka",
"Switch on debug output with details about the items (debug not on by default)" => "Badilisha juu ya pato la kufuta na maelezo juu ya vipengee (usulubu sio kwa default)",
"Memory Saver" => "Msaidizi wa Kumbukumbu",
// "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell",
"Line break" => "Kupumzika kwa mstari",
"Separate Row" => "Tofauti Row",
"Level" => "Kiwango",
// "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex",
"Full" => "Kamili",
"non-valid custom regex" => "expression régulière regex invalide",
", " => ", ",
"ignored" => "kupuuzwa",
"External Wiki" => "Wiki ya nje",
"dash-WikiWord" => "WikiWord-tiret",
"WikiWord" => "Mot Wiki",
"not in level" => "si katika ngazi",
"valid" => "si katika ngazi",
"End of debug output." => "Mwisho wa pato la kufuta.",
"Wanted Page" => "Ukurasa uliotakiwa",
"Referenced By Page" => "Inaelezwa na Ukurasa",
// "Web Document Viewer" => "Web Document Viewer",
// "View a document in a page" => "View a document in a page",
// "File Id" => "File Id",
// "The FileId of a file in a File Gallery of the file you wish to embed in the viewer" => "The FileId of a file in a File Gallery of the file you wish to embed in the viewer",
// "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter" => "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter",
// "No FileId or URL has been set" => "No FileId or URL has been set",
"Web Service" => "Huduma ya Wavuti",
// "Display remote information exposed in JSON or YAML or SOAP XML" => "Display remote information exposed in JSON or YAML or SOAP XML",
// "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter",
"Complete service URL" => "Huduma kamili ya URL",
"Registered service name" => "Jina la huduma ya usajili",
// "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided",
"Body as Parameter" => "Mwili kama Kipimo",
// "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful" => "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful",
// "Parameters formatted like a query" => "Parameters formatted like a query",
"Unknown Template" => "Kigezo Haijulikani",
"Unknown Service" => "Huduma isiyojulikana",
// "Wiki Diff" => "Wiki Diff",
// "Display the differences between two wiki objects" => "Display the differences between two wiki objects",
// "Object Id" => "Object Id",
// "Object to do a diff on (page name for wiki pages)" => "Object to do a diff on (page name for wiki pages)",
// "Object type (wiki pages only)" => "Object type (wiki pages only)",
// "Old version" => "Old version",
// "Integer for old version number, or date" => "Integer for old version number, or date",
// "New version" => "New version",
// "Leave empty for current version" => "Leave empty for current version",
// "Diff Style" => "Diff Style",
// "Defaults to \"diff style\" preference if empty" => "Defaults to \"diff style\" preference if empty",
// "Show version info" => "Show version info",
// "Show the heading \"Comparing version X with version Y\"" => "Show the heading \"Comparing version X with version Y\"",
// "Use a WYSIWYG editor to edit a section of content" => "Use a WYSIWYG editor to edit a section of content",
// "Minimum width for DIV. Default" => "Minimum width for DIV. Default",
// "Minimum height for DIV. Default" => "Minimum height for DIV. Default",
"Use HTML" => "Tumia le HTML",
// "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed" => "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed",
// "XMLupdate" => "XMLupdate",
// "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory" => "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory",
// "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file " => "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file ",
// "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory" => "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory",
// "XML node attribute name" => "XML node attribute name",
// "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space" => "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space",
// "XML node listed in output" => "XML node listed in output",
// "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set" => "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set",
// "Xmpp" => "Xmpp",
// "Chat using Xmpp" => "Chat using Xmpp",
// "Room Name" => "Room Name",
// "Room to auto-join" => "Room to auto-join",
// "View Mode" => "View Mode",
// "Fullscreen" => "Fullscreen",
// "Overlayed" => "Overlayed",
// "Chat room width in CSS units" => "Chat room width in CSS units",
// "Chat room height in CSS units" => "Chat room height in CSS units",
"Visibility" => "Kuonekana",
// "This room is visible to anyone or only for members" => "This room is visible to anyone or only for members",
// "Members only" => "Members only",
// "Show Real JIDs of Occupants to" => "Show Real JIDs of Occupants to",
// "If just moderator or anyone else can fetch information about an occupant" => "If just moderator or anyone else can fetch information about an occupant",
// "If just \"moderator\", anonymous user will not be able to change their nicknames" => "If just \"moderator\", anonymous user will not be able to change their nicknames",
// "Anyone" => "Anyone",
// "Moderator" => "Moderator",
// "Show controlbox on load" => "Show controlbox on load",
// "If controlbox should be shown after page load" => "If controlbox should be shown after page load",
// "This preference only works when view mode is overlayed" => "This preference only works when view mode is overlayed",
// "Show occupants" => "Show occupants",
// "If occupants window should be visible by default" => "If occupants window should be visible by default",
// "This preference only works when view mode is embedded" => "This preference only works when view mode is embedded",
// "Groups (comma-separated)" => "Groups (comma-separated)",
// "Allowed groups to use this resource" => "Allowed groups to use this resource",
// "Is secret" => "Is secret",
// "If the room will be listed on public chat room list" => "If the room will be listed on public chat room list",
// "Archiving" => "Archiving",
// "If room messages will be stored" => "If room messages will be stored",
// "Persistent" => "Persistent",
// "If room will continue to exist after last user leaves" => "If room will continue to exist after last user leaves",
// "If room is moderated" => "If room is moderated",
// "PluginXMPP Error: No room specified" => "PluginXMPP Error: No room specified",
// "Add a group to room" => "Add a group to room",
// "Add users to room" => "Add users to room",
"YouTube" => "YouTube",
// "Embed a YouTube video in a page" => "Embed a YouTube video in a page",
"Movie" => "Movie",
// "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)" => "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)",
// "Privacy-Enhanced" => "Privacy-Enhanced",
// "Enable privacy-enhanced mode" => "Enable privacy-enhanced mode",
// "Start time" => "Start time",
// "Start time offset in seconds" => "Start time offset in seconds",
// "Quality of the video. Default is %0high%1" => "Quality of the video. Default is %0high%1",
"Enlarge video to full screen size" => "Ongeza video kwenye ukubwa kamili wa skrini",
"Related" => "Kuhusiana",
"Show related videos (shown by default)" => "Onyesha video zinazohusiana (iliyoonyeshwa kwa default)",
"Background" => "Background",
// "Toolbar background color. Use an HTML color code" => "Toolbar background color. Use an HTML color code",
"Example" => "Mfano",
"HTML color code, e.g. ffffff" => "Msimbo wa rangi ya HTML, kwa mfano ffffff",
// "Toolbar border colors. Use an HTML color code" => "Toolbar border colors. Use an HTML color code",
"Plugin YouTube error: the movie parameter is empty" => "Plugin ya YouTube ya hitilafu: parameter ya filamu ni tupu",
// "Invalid YouTube URL provided" => "Invalid YouTube URL provided",
"Zotero Citation" => "Citation Zotero",
"Retrieves and includes a Zotero reference in the page." => "Inapatikana na inatia kumbukumbu ya Zotero kwenye ukurasa.",
"Reference Key" => "Kitufe cha Kumbukumbu",
// "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module",
"Reference Tag" => "Tag Reference",
// "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references" => "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references",
"Zotero Reference List" => "Orodha ya Kumbukumbu ya Zotero",
// "Display the complete reference list from a Zotero server" => "Display the complete reference list from a Zotero server",
"Provide the list of references with a given tag" => "Kutoa orodha ya marejeleo na lebo iliyotolewa",
"No results obtained. The Zotero citation server may be down" => "Hakuna matokeo yaliyopatikana. Seti ya kutaja Zotero inaweza kuwa chini",
// "Set up some advanced options" => "Set up some advanced options",
// "Set up Auto TOC" => "Set up Auto TOC",
// "Define Categories" => "Define Categories",
// "Set up User & Community features" => "Set up User & Community features",
// "Set up Date and Time" => "Set up Date and Time",
// "Select Editor type" => "Select Editor type",
// "Set up Main features" => "Set up Main features",
// "Set up File Gallery & Attachments" => "Set up File Gallery & Attachments",
// "Set up File storage" => "Set up File storage",
// "Set up Language" => "Set up Language",
// "Set up Login" => "Set up Login",
// "Set up Look & Feel" => "Set up Look & Feel",
// "Set up Namespace" => "Set up Namespace",
// "Set up Search" => "Set up Search",
// "Set up Structures" => "Set up Structures",
// "Set up Text Area" => "Set up Text Area",
// "Set up Wiki environment" => "Set up Wiki environment",
"Tiki Setup" => "Kuweka Tiki",
// "Configuration Wizard Completed" => "Configuration Wizard Completed",
// "Set up Wysiwyg editor" => "Set up Wysiwyg editor",
// "Related doc.tiki.org pages" => "Related doc.tiki.org pages",
// "New in Tiki 13" => "New in Tiki 13",
// "New in Tiki 14" => "New in Tiki 14",
// "New in Tiki 15 (LTS)" => "New in Tiki 15 (LTS)",
// "New in Tiki 16" => "New in Tiki 16",
// "New in Tiki 17" => "New in Tiki 17",
// "New in Tiki 18 (LTS)" => "New in Tiki 18 (LTS)",
// "New in Tiki 19" => "New in Tiki 19",
// "New in Tiki 20" => "New in Tiki 20",
// "Novice Admin Assistance" => "Novice Admin Assistance",
// "Other features and settings" => "Other features and settings",
// "Permissions & Logs" => "Permissions & Logs",
// "Send feedback & Connect" => "Send feedback & Connect",
// "User Interface" => "User Interface",
// "Changes Wizard Completed" => "Changes Wizard Completed",
// "Configuration Profiles Wizard Completed" => "Configuration Profiles Wizard Completed",
// "Demo of Cases in Project Management" => "Demo of Cases in Project Management",
// "Demo of Commonly Used Configurations" => "Demo of Commonly Used Configurations",
// "Demo of Highly Specialized Configurations" => "Demo of Highly Specialized Configurations",
// "Demo of Interesting Use Cases" => "Demo of Interesting Use Cases",
// "Demo of More Advanced Configurations" => "Demo of More Advanced Configurations",
// "Demo of Other Interesting Use Cases" => "Demo of Other Interesting Use Cases",
// "Featured Site Configurations" => "Featured Site Configurations",
// "Useful Administration Configurations" => "Useful Administration Configurations",
// "Useful Changes in Display Mode" => "Useful Changes in Display Mode",
// "Useful Micro Configurations" => "Useful Micro Configurations",
// "Useful New Technology Configurations" => "Useful New Technology Configurations",
"Personal Information" => "Maelezo ya kibinafsi",
"User Watches" => "Watumiaji Watches",
// "Notification Preferences" => "Notification Preferences",
"unicode" => "unicode",
"Report Preferences" => "Mapendekezo ya Ripoti",
// "User Details" => "User Details",
// "You cannot access this page directly" => "You cannot access this page directly",
// "Welcome to the User Wizard" => "Welcome to the User Wizard",
// "User Wizard Completed" => "User Wizard Completed",
// "Invalid wizard stepNr specified" => "Invalid wizard stepNr specified",
"Articles Home" => "Makala ya Nyumbani",
// "Delete selected messages" => "Delete selected messages",
// "%0 archived message was deleted" => "%0 archived message was deleted",
// "%0 archived messages were deleted" => "%0 archived messages were deleted",
// "No messages were deleted" => "No messages were deleted",
// "No messages were selected to delete" => "No messages were selected to delete",
// "The message must have either a subject or a body" => "The message must have either a subject or a body",
"User %s does not have the permission" => "Mtumiaji %s hana ruhusa ",
"The message has been sent to" => "Ujumbe umetumwa",
"The message will be sent to" => "Ujumbe utatumwa",
// "See below for how the broadcast message will be handled upon confirmation" => "See below for how the broadcast message will be handled upon confirmation",
// "No valid users to send the message to" => "No valid users to send the message to",
"User %s does not want to receive messages" => "Mtumiaji% s hawataki kupokea ujumbe",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Sanduku la kutumwa limejaa. Sakinisha au kufuta ujumbe uliotumwa kwanza ikiwa unataka kutuma ujumbe zaidi.",
// "See below for how message will be handled upon confirmation" => "See below for how message will be handled upon confirmation",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Una uwezo wa kupokea ujumbe ili uwatume. Nenda kwa mapendekezo ya mtumiaji wako na uwezesha 'Kuruhusu ujumbe kutoka kwa watumiaji wengine'",
"User %s can not receive messages, mailbox is full" => "Mtumiaji %s hawezi kupokea ujumbe, boti la barua pepe ni kamili",
"User %s can not receive messages" => "Mtumiaji %s hawezi kupokea ujumbe",
"Invalid user: %s" => "Mtumiaji batili: %s",
// "%0 message was marked" => "%0 message was marked",
// "%0 messages were marked" => "%0 messages were marked",
// "No messages were marked" => "No messages were marked",
// "No messages were selected to mark" => "No messages were selected to mark",
// "%0 message was deleted" => "%0 message was deleted",
// "%0 messages were deleted" => "%0 messages were deleted",
// "%0 message was archived" => "%0 message was archived",
// "%0 messages were archived" => "%0 messages were archived",
// "No messages were archived" => "No messages were archived",
// "No messages were selected to archive" => "No messages were selected to archive",
"Archive is full. Delete some messages from archive first." => "Nyaraka ni kamili. Futa ujumbe fulani kutoka kwenye kumbukumbu ya kwanza.",
// "Delete message" => "Delete message",
// "Message deleted" => "Message deleted",
// "Message not deleted" => "Message not deleted",
"No more messages" => "Hakuna ujumbe zaidi",
// "Delete archive message" => "Delete archive message",
// "Archive message deleted" => "Archive message deleted",
// "Archive message not deleted" => "Archive message not deleted",
// "Delete sent message" => "Delete sent message",
// "Sent message deleted" => "Sent message deleted",
// "Sent message not deleted" => "Sent message not deleted",
// "%0 sent message was deleted" => "%0 sent message was deleted",
// "%0 sent messages were deleted" => "%0 sent messages were deleted",
"Action Calendar" => "Kalenda ya Hatua",
"Item types filter" => "Faili ya kichujio cha vitu",
"If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "Ikiwa imewekwa kwenye orodha ya aina ya bidhaa, inaruhusu vitu vinavyoonyeshwa kwa moja ya aina hizi. Kila seti ni orodha ya kutolewa kwa comma ya nambari za aina ya bidhaa",
"Possible item type values" => "Maadili ya aina ya bidhaa zinawezekana",
"Similar Content" => "Maudhui sawa",
"Find similar content based on tags." => "Pata maudhui sawa kulingana na lebo.",
"Similar Content Filter" => "Filamu ya Maudhui Yanayofanana",
"Display only similar content of type specified" => "Onyesha maudhui sawa ya aina ya maalum",
"Default: \"All Content Type\"" => "Mchapishaji: : \"Aina Yote ya Maudhui\"",
"Options: \"article, wiki page, blog post\"" => "Chaguo : \"makala, ukurasa wa wiki, post blog\"",
"Broaden FreeTag Search" => "Ongeza BroadTag Search",
"Find similar content that contains one of the Tags or All of the Tags" => "Pata maudhui kama hayo ambayo yana moja ya Vitambulisho au Vitambulisho vyote.",
"Default: \"n - needs to contain all of the Tags\"" => "Mchapishaji: \"n - inahitaji kuwa na Vitambulisho vyote",
"Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Chaguo: \"n - Inahitajika kuwa na Vitambulisho vyote / y - Inahitaji kuwa na lebo moja\"",
// "Quick Admin Bar" => "Quick Admin Bar",
// "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features" => "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features",
"Display mode: module or header. Leave empty for module mode" => "Mfumo wa kuonyesha: moduli au kichwa. Acha tupu kwa mode moduli",
"Google AdSense" => "Matangazo ya Google AdSense",
"Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Angalia tangazo la Google AdSense kama maandishi / picha. Moduli hii inahitaji kusasishwa ili kuunga mkono msimbo mpya wa Google",
"ad_channel" => "mlolongo",
"Advertisement channel, as optionally provided by Google" => "Kituo cha matangazo, hiari iliyotolewa na Google",
"client" => "mteja",
"As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "Kama ilivyoandaliwa na Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
"display" => "kuangalia",
"Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Bendera ya kimataifa kama ilivyotolewa na Google. Kwa mfano: \"kuonyesha = 468 * 60_as \"",
"color_bg" => "background",
"Background color, as optionally provided by Google" => "Rangi ya background, hiari iliyotolewa na Google",
"color_border" => "mpaka",
"Border color, as optionally provided by Google" => "Rangi ya mpaka, kwa hiari iliyotolewa na Google",
"color_link" => "kiungo",
"Link color, as optionally provided by Google" => "Weka rangi, kama ilivyoandaliwa na Google",
"color_text" => "Nakala",
"Text color, as optionally provided by Google" => "Nakala ya rangi kama ilivyoandaliwa na Google",
"color_url" => "URL",
"URL color, as optionally provided by Google" => "Weka rangi (URL), kama hiari iliyotolewa na Google",
"Article Archives" => "Archives ya makala",
"Shows links to the published articles for each month." => "Inaonyesha viungo kwenye makala zilizochapishwa kwa kila mwezi.",
"If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "Ikiwa imewekwa kwenye \"y \", onyesha kifungo \"Plus \", kiungo kwenye mtazamo wa paginated wa sanaa za kuchaguliwa",
"Default: \"n\"" => "Thamani ya msingi: \"n \"",
"If set to a category identifier, only consider the articles in the specified category" => "Ikiwa imewekwa kwenye kitambulisho cha kikundi, tu makala za jamii iliyochaguliwa zinachukuliwa.",
"Example value: 13" => "Thamani ya mfano: 13",
"Topic filter (by names)" => "Chujio cha kichwa (kwa jina)",
"If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Ikiwa imefafanuliwa kama orodha ya vitambulisho vya kitu kilichotenganishwa na \"+ \", fikiria vitu tu vya mada hizo. Ikiwa kamba imechukuliwa na \"! \", Athari inabadilishwa, yaani vitu hivi hazitazingatiwa",
"Topic filter (by identifiers)" => "Filtre de sujet (par identifiants)",
"If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "Ikiwa imefafanuliwa kama orodha ya vitambulisho vya kitu kilichotenganishwa na \"+ \", fikiria vitu tu vya mada hizo. Ikiwa kamba imechukuliwa na \"! \", Athari inabadilishwa, yaani vitu hivi hazitazingatiwa",
"Example values: 13, !13, 1+3, !1+5+7" => "Mfano wa maadili: 13, !13, 1+3, !1+5+7",
"Types filter" => "Weka chujio",
"If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "Ikiwa hufafanuliwa kama orodha ya majina ya aina ya bidhaa yaliyotengwa na \"+ \", fikiria vitu tu vya aina maalum. Ikiwa kamba imechukuliwa na \"! \", Athari inabadilishwa, yaani, vitu vya aina maalum zimepuuzwa",
"Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Sampuli za maonyesho: Tukio, Tukio, Tukio + Tathmini, Tukio + Tangaza + Kifungu",
"Language filter" => "Chujio cha lugha",
"If set to a language code, only consider the articles in the specified language" => "Ikiwa imewekwa kwenye msimbo wa lugha, fikiria tu makala katika lugha maalum",
"Article Topics" => "Mada ya makala",
"Lists all article topics with links to their articles" => "Weka mada yote ya makala na viungo kwa makala zao",
"Lists the specified number of published articles in the specified order." => "Weka nambari ya makala zilizochapishwa katika utaratibu uliochaguliwa.",
"Show publication time" => "Angalia tarehe ya kuchapishwa",
"If set to \"y\", article publication times are shown" => "Ikiwa imewekwa kwa \"y \", tarehe na wakati wa kuchapishwa vinaonyeshwa",
"Show creation time" => "Angalia tarehe ya uumbaji",
"If set to \"y\", article creation times are shown" => "Ikiwa imewekwa kwa \"y \", tarehe na wakati makala yaliumbwa yanaonyeshwa",
"Show rating selector" => "Tazama mchezaji wa bao",
"If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "Ikiwa imewekwa kwenye \"y \", inatoa mtumiaji kuchuja vitu ambavyo alama yake iko kati ya kiwango cha chini na kiwango cha juu",
"Image width" => "Upana wa Picha",
"If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "Ikiwa imewekwa, inaonyesha picha kwa kila kitu ikiwa picha inatumika, na upana uliopatikana (kwa saizi). Picha maalum kwa makala hiyo hutumiwa ikiwa inafafanuliwa, vinginevyo hiyo ya somo la makala hiyo",
"If set to a category identifier, only lists the articles in the specified category" => "Ikiwa imewekwa kwenye kitambulisho cha kikundi, inaonyesha vitu pekee katika jamii iliyochaguliwa",
"If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Ikiwa imewekwa kama orodha ya vitambulisho vya mada ya makala iliyotengwa na \"+ \", weka vitu tu vya vipengele hivi. Ikiwa kamba imechukuliwa na \"! \", Athari inabadilishwa, yaani vitu hivi hazitaorodheshwa",
"If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "Ikiwa imewekwa kama orodha ya vitambulisho vya mada ya makala iliyotengwa na \"+ \", weka vitu tu vya vipengele hivi. Ikiwa kamba imechukuliwa na \"! \", Athari inabadilishwa, yaani vitu hivi hazitaorodheshwa",
"If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "Ikiwa imewekwa kama orodha ya majina ya aina ya vitu yaliyotengwa na \"+ \", inaonyesha vitu pekee vya aina maalum. Ikiwa kamba imechukuliwa na \"! \", Athari inabadilishwa, yaani, vitu vyenye aina maalum havionyeshwa",
"If set to a language code, only lists the articles in the specified language" => "Ikiwa imewekwa kwenye msimbo wa lugha, huonyesha tu vitu katika lugha iliyochaguliwa",
"Specifies how the articles should be sorted" => "Inabainisha jinsi vitu vinavyopaswa kutatuliwa",
"Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Maadili yaliyowezekana ni pamoja na kuundwa na kuundwa_asc (sawa), yaliyoundwa_desc, mwandishi, rating, topicId, lang na kichwa. Isipokuwa \"_desc \" ni maalum, kuchagua huongezeka. \"umba \" aina juu ya tarehe ya uumbaji wa makala hiyo",
"If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "Ikiwa imewekwa kama integer, hubadili vitu katika orodha kwa namba iliyochaguliwa. Kwa mfano, kama moduli imewekwa mahali pengine ili kuonyesha makala 10 zilizochapishwa hivi hivi karibuni, kuweka upungufu hadi 10 utaonyesha vipengee 11 hadi 20 katika utaratibu wa kushuka kwa kuchapishwa badala yake",
"If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "Ikiwa imewekwa kwenye \"y \", onyesha kifungo \"Plus \", kiungo kwenye mtazamo wa paginated wa sanaa za kuchaguliwa",
"Absolute URL" => "URL isiyo sahihi",
"If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "Ikiwa imewekwa kwenye \"y \", viungo vingine vinatumia anwani kamili (URL) badala ya jamaa moja. Hii inaweza kuzuia viungo vya wafu kama moduli inapaswa kutumwa kwenye jarida, kwa mfano",
"If set to 0, will take the topicId of the article if in an article" => "Ikiwa imewekwa kwenye 0, itachukua kitambulisho cha somo cha makala kama katika makala",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
"Newest Blog Post Comments" => "Maoni ya hivi karibuni kwenye machapisho ya blogu",
"Displays the specified number of the blog post comments most recently added" => "Inaonyesha idadi maalum ya maoni ya hivi karibuni yaliyoongezwa kwenye blogu",
"No date" => "Hakuna tarehe",
"If set to \"y\", the date of comments is not displayed in the module box" => "Ikiwa imewekwa kwenye \"y \", tarehe ya maoni haionyeshwa kwenye chombo cha moduli",
"Verbose tooltips" => "Vidokezo vya kuzungumza",
"If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "Ikiwa imewekwa kwenye \"y \", jina la chapisho la blogu linaonekana tu kama kitambulisho na haonyeshe",
"Options: \"y,n\"" => "Options : \"y,n\"",
"Last-Visited Pages" => "Mwisho uliotembelea kurasa",
"Displays the last Wiki pages visited by the user." => "Inaonyesha kurasa za hivi karibuni za Wiki zilizotembelewa na mtumiaji.",
"Maximum number of characters in page names allowed before truncating" => "Idadi kubwa ya wahusika katika majina ya ukurasa kabla ya truncation",
// "Show Namespace" => "Show Namespace",
// "Show namespace prefix in page names" => "Show namespace prefix in page names",
"A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "Uongozi wa wapi. Ex: Nyumbani> Sehemu ya 1> Sehemu ya C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
"Includes a calendar or a list of calendar events." => "Inajumuisha kalenda au orodha ya matukio.",
"Calendars filter" => "Faili ya kalenda",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "Ikiwa imewekwa kama orodha ya vitambulisho vya kalenda, inaruhusu matukio kwa wale wa kalenda zilizojulikana. Vidokezo vinatenganishwa na baa wima (\"| \"), commas (\",\") au madaraja madogo (\": \"). Mifano ya maadili: \"13 \", \"4,7 \", \"31: 49 \". Haifafanuliwa na default",
"Displayed month (relative)" => "Mwezi ulionyeshwa (jamaa)",
"Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Umbali wa miezi hadi mwezi utaonyeshwa. Umbali wa -1 utaonyesha mwezi uliopita. Kufafanua chaguo hili lina maana ya aina ya kalenda na kipindi changu. Mifano ya thamani: 2, 0, -2, -12",
"View type" => "Aina ya mtazamo",
"Determines how to show events. Possible values: %0, %1" => "Tambua jinsi ya kuonyesha matukio. Maadili inayowezekana:% 0,% 1",
"Calendar view type time span" => "Muda wa kipindi cha mtazamo wa kalenda",
"If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "Katika aina ya mtazamo wa kalenda(au \"table\"), huamua muda wa kuonyeshwa na kalenda. Maadili inayowezekana:% 0,% 1,% 2,% 3,% 4,% 5. Mtumiaji kubadilisha kipindi hiki katika kalenda anaweza kubadilisha kipindi ambacho moduli inaonyesha kwake",
"Show action" => "Onyesha hatua",
"Viewmode when clicking on a day" => "Angalia mode ikiwa unabonyeza siku",
"Put a link on all the days , not only those with event" => "Weka kiungo kila siku, si tu wale walio na tukio",
"View navigation bar" => "Onyesha bar ya urambazaji",
"Cart" => "kikapu",
// "Displays the content of the cart, allows quantities to be modified and proceeds to payment" => "Displays the content of the cart, allows quantities to be modified and proceeds to payment",
// "Use AJAX" => "Use AJAX",
// "Use AJAX services for managing the cart" => "Use AJAX services for managing the cart",
// "Show Items" => "Show Items",
// "Shows the items in the cart as they are added" => "Shows the items in the cart as they are added",
// "Shows the number of items in the cart" => "Shows the number of items in the cart",
// "Checkout URL" => "Checkout URL",
// "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated" => "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated",
// "(Default empty: Goes to tiki-payment.php)" => "(Default empty: Goes to tiki-payment.php)",
// "Post-Payment URL" => "Post-Payment URL",
// "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc" => "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc",
// "Show Total Weight" => "Show Total Weight",
// "Shows the weight of the items in the cart" => "Shows the weight of the items in the cart",
// "Shown after the weight" => "Shown after the weight",
// "Show Item Buttons" => "Show Item Buttons",
// "Shows add, remove and delete buttons on items" => "Shows add, remove and delete buttons on items",
"The quantities in your cart were updated" => "Wengi katika gari yako yamebadilishwa",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
"Displays links to categories as a tree." => "Maonyesho huunganisha makundi kama mti.",
"Object type filter" => "Chujio cha aina ya kitu",
"Object type filter to apply when accessing a linked category. Example values" => "Chujio cha aina ya kitu ambacho kinafaa wakati wa kufikia kiungo kilichounganishwa. Mfano wa maadili",
"Deep" => "kina",
"Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Angalia vitu vya vijamii wakati wa kufikia kiungo kilichohusishwa. Maadili iwezekanavyo: juu ya (default), mbali",
"Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Inapunguza makundi yaliyoonyeshwa kwa subtree ambao mizizi ni kikundi na ID iliyopewa. Thamani ya Mfano: 11. Hitilafu: 0 (usipunguze maonyesho)",
"Show these categories and their children" => "Tazama makundi haya na vikundi vyao vyote",
"Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Onyesha makundi haya tu na makundi ya watoto wa kwanza ya haya ili mpangilio uweze. Mifano ya thamani: 3,5,6",
"Category links to a page named as the category" => "Jamii inaonyesha ukurasa unaoitwa kama kikundi",
"If y, category links to a page named as the category" => "Ikiwa y, kikundi kinaonyesha ukurasa wa jina moja kama hii",
// "Hide Empty" => "Hide Empty",
// "If y, only categories with child objects will be shown" => "If y, only categories with child objects will be shown",
// "Only Children" => "Only Children",
// "If y, only direct child categories will be shown. Default: n" => "If y, only direct child categories will be shown. Default: n",
"Custom URL" => "URL zinazopangwa",
// "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" " => "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" ",
"Category Transitions" => "Mabadiliko ya jamii",
"Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Udhibiti wa maonyesho husababisha mabadiliko ya kikundi na kubadilisha hali ya ukurasa kulingana na sheria zilizopangwa",
"Example Transition" => "Mfano wa mabadiliko",
"Change Category" => "Badilisha Jamii",
"Enables to categorize an object." => "Inaweka kitu.",
// "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
"Category identifier" => "Kitambulisho cha Jamii",
"Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Badilisha mzizi wa makundi yaliyoonyeshwa ya \"TOP \" kwa default kwa kikundi kilichoonyeshwa na kitambulisho chake",
"Note that the root category is not displayed" => "Tafadhali kumbuka kuwa jamii ya mizizi haionyeshe",
"Defaults to 0 (root)" => "Default 0 (mizizi)",
"No top" => "Angalia si ya kina",
"In non-detailed view, disallow uncategorizing. Example value: 1" => "Kwa maoni yasiyo ya kina, afya ya decategorization. Thamani mfano: 1",
"Display path" => "Onyesha njia",
"Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Isipokuwa kuweka kwa \"n \", onyesha njia za jamaa katika mti wa jamii badala ya majina ya jamii",
"Paths are relative to the root category, which is not displayed" => "Njia zinahusiana na jamii ya mizizi, ambayo haionyeshe",
"Multiple categories" => "Makundi kadhaa",
"If set to \"n\", only allows categorizing in one category (from those displayed)" => "Ikiwa imewekwa kwenye \"n \", inaruhusu tu kugawa kikundi kimoja (kati ya wale walioonyeshwa)",
"Categorize" => "Panga",
"String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "Kamba ya kuonyesha kwenye kifungo kuwasilisha makundi mapya, wakati makundi mengi yanaruhusiwa. Thamani ya msingi: Chagua",
"Shy" => "aibu",
"If set to \"y\", the module is not shown on pages which are not already categorized" => "Ikiwa imewekwa kwenye \"y \", moduli haionyeshwa kwenye kurasa ambazo bado haijawekwa",
"Detailed" => "Détaillé",
"If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "Ikiwa imewekwa kwenye \"y \", inaonyesha orodha ya makundi ambayo kitu iko. Ikiwa kufuta haukuzimwa, inaweza kufanywa na orodha",
"If set to \"n\", the detailed list of categories will not offer to unassign a category" => "Ikiwa imewekwa kwa \"n \", orodha ya maelezo ya jamii haitatoa kuacha jamii",
"If set to \"y\", allow to assign new categories" => "Ikiwa imewekwa kwa \"y \", inachukua makundi mapya",
"Example values: y, n" => "Mfano wa maadili: y, n",
"Default value: y" => "Thamani ya msingi: y",
"Group filter" => "Futa ya kikundi",
"Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Chaguo maalum cha chujio. Ikiwa imewekwa kwa \"y \", ni makundi tu yenye jina linalolingana na moja ya makundi ya mtumiaji yanaonyeshwa, pamoja na watoto wa makundi haya yanayolingana",
"Default value: n" => "Thamani ya msingi: n",
"Image URL not in category" => "Anwani ya picha isiyo katika kikundi",
"Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Kipimo maalum sana. Ikiwa hii na 'Anwani ya Image katika Jamii' huwekwa, na ikiwa jamii ya mizizi ina jamii moja tu ya mtoto, moduli inaonyesha picha moja tu na anwani hiyo ikiwa kitu haipo katika kikundi.",
"Image URL in category" => "Anwani ya picha katika kikundi",
"Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Kipimo maalum sana. Ikiwa hii na 'Anwani ya Image sio kwenye Jamii' huwekwa, na kikundi cha mizizi kina jamii ya mtoto mmoja tu, moduli inaonyesha tu picha na anwani hiyo ikiwa kitu kilicho katika kikundi.",
"Categorize %s" => "Panga %s",
"Categorize %s in %s" => "Panga% s katika% s",
// "Collapse Button" => "Collapse Button",
// "Bootstrap collapse button" => "Bootstrap collapse button",
// "CSS selector defining which objects get collapsed" => "CSS selector defining which objects get collapsed",
// "CSS class for containing DIV element" => "CSS class for containing DIV element",
// "CSS selector defining the collapsing objects' container" => "CSS selector defining the collapsing objects' container",
"Received Objects" => "Vitu Vipokee",
"Displays the number of pages received (via Communications)" => "Inaonyesha idadi ya kurasa zilizopokelewa (kupitia Mawasiliano)",
"Contributors" => "wachangiaji",
"Lists the contributors to the wiki page being viewed and some information on them." => "Andika orodha ya majina ya wachangiaji kwenye ukurasa wa Wiki ulionyeshwa na habari kuhusu wao.",
"Shows the credits a user has" => "Angalia sifa ambazo mtumiaji anazo",
"Newest Directory Sites" => "Sites Mwisho za Kitabu cha Mwaka",
"Displays the specified number of the directory sites most recently added." => "Inaonyesha idadi maalum ya maeneo ya hivi karibuni yaliyoongezwa.",
"Directory category identifier" => "Kitambulisho cha Jamii cha Directory",
"If set to a directory category identifier, only displays the sites in the specified directory category" => "Ikiwa imewekwa kama Kitambulisho cha Jamii ya Directory, huonyesha maeneo tu katika jamii iliyochaguliwa",
"If set to \"y\", displays a button labelled \"More\" that links to the directory" => "Ikiwa imewekwa kwenye \"y \", onyesha kitufe cha \"Plus \", kiungo kwenye Directory",
"Show description" => "Onyesha maelezo",
"If set to \"y\", the description of the directory site appears" => "Ikiwa imewekwa kwenye \"y \", maelezo ya tovuti ya directory yanaonyeshwa",
"Maximum length of description" => "Urefu wa maelezo zaidi",
"If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "Ikiwa 'Onyesha maelezo' = \"y \", tumia uwanja huu ili kufafanua ukubwa wa juu wa maelezo (kwa wahusika). Acha tupu usiweke kiwango cha juu (onyesha maelezo kamili)",
"Default: blank" => "Mchapishaji: haipo",
"Directory Statistics" => "Takwimu za Directory",
"Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links." => "Inaonyesha takwimu za saraka ya tovuti, ikiwa ni pamoja na idadi ya maeneo yaliyothibitishwa na kuthibitishwa, idadi ya makundi, utafutaji na viungo vilivyotembelewa.",
"Top Directory Sites" => "Sehemu za Juu za Directory",
"Displays the specified number of the directory sites from most visited to least visited." => "Inaonyesha nambari maalum ya maeneo ya saraka kutoka kwa wengi waliotembelea hadi kutembelea angalau.",
// "Domain Password" => "Domain Password",
// "Store personal passwords for other domains securely in Tiki" => "Store personal passwords for other domains securely in Tiki",
// "System the credentials apply for. The name must match a defined Password Domain" => "System the credentials apply for. The name must match a defined Password Domain",
// "Use current user" => "Use current user",
// "Use the currently logged-in user. The username is not editable. (y/n) Default: y" => "Use the currently logged-in user. The username is not editable. (y/n) Default: y",
// "Can Update" => "Can Update",
// "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n" => "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n",
// "Show domain prompt" => "Show domain prompt",
// "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y" => "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y",
// "No Password Domains found" => "No Password Domains found",
// "Domain is not valid" => "Domain is not valid",
// "No domain specified" => "No domain specified",
// "No user defined" => "No user defined",
// "No password saved" => "No password saved",
// "Read error" => "Read error",
// "No password specified" => "No password specified",
// "No username specified" => "No username specified",
// "Failed to save password" => "Failed to save password",
// "Failed to save user" => "Failed to save user",
// "Saved OK" => "Saved OK",
"Facebook" => "Facebook",
// "Shows the Wall of a user" => "Shows the Wall of a user",
// "Tiki user to show Facebook wall of" => "Tiki user to show Facebook wall of",
// "Show username in timeline. y|n" => "Show username in timeline. y|n",
// "user not registered with facebook" => "user not registered with facebook",
// "No username given" => "No username given",
"Featured Links" => "Viungo vyema",
"Displays the site's first featured links" => "Inaonyesha viungo vya kwanza vya tovuti",
"Displays links to file galleries." => "Inaonyesha viungo vya faili za faili.",
"Top-Rated Topics" => "Mada ya Mipango ya Juu",
"Displays the specified number of the forum topics with the best ratings." => "Inaonyesha nambari maalum ya mada ya jukwaa na viwango vyema.",
"Newest Forum Posts" => "Machapisho mapya ya Forum",
"Displays the latest forum posts." => "Inaonyesha machapisho ya hivi karibuni ya jukwaa.",
"Topics only" => "Mada tu",
"If set to \"y\", only displays topics" => "Ikiwa imewekwa kwenye \"y\", inaonyesha tu mada",
"List of forum identifiers" => "Orodha ya vitambulisho vya jukwaa",
"If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "Ikiwa imewekwa kwenye orodha ya vitambulisho vya jukwaa, huzuia machapisho kwa wale walio kwenye vikao vilivyotambuliwa. Watambuzi hutenganishwa na koloni (\":\")",
"Show date" => "Onyesha tarehe",
"If set to \"y\", show post date directly instead of as tooltip" => "Ikiwa imewekwa kwenye \"y\", onyesha tarehe ya posta moja kwa moja badala ya tooltip",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
"If set to \"y\", show post author directly instead of as tooltip" => "Ikiwa imewekwa \"y\", onyesha mwandishi wa post moja kwa moja badala ya tooltip",
"Most Commented Forums" => "Vikao vingi vya maoni",
"Display the specified number of the forums with the most comments." => "Onyesha idadi maalum ya vikao na maoni zaidi.",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
"Tags Editor" => "Mhariri wa Makala",
"Shows current tags and enables adding and removing some if permissions allow" => "Inaonyesha vitambulisho vya sasa na inawezesha kuongeza na kuondosha baadhi ikiwa idhini inaruhusu",
"Wiki Page Tags" => "Lebo ya Ukurasa wa Wiki",
"Displays current tags on wiki pages and enables adding tags if permissions allow." => "Inaonyesha vitambulisho vya sasa kwenye kurasa za wiki na inawezesha kuongeza vitambulisho ikiwa idhini inaruhusu.",
"Similar-Tag Items" => "Vitu vinavyofanana na Tag",
"Shows content with multiple tags in common." => "Inaonyesha maudhui na vitambulisho vingi vya kawaida.",
"Type of objects to extract" => "Aina ya vitu ili kuondoa",
"Most Popular Tags" => "Wengi maarufu Tags",
"Shows the most popular tags. More popularity is indicated by a larger font." => "Inaonyesha vitambulisho maarufu zaidi. Umaarufu zaidi unaonyeshwa na font kubwa.",
"Display type" => "Aina ya kuonyesha",
"If set to \"cloud\", links are displayed as a cloud" => "Ikiwa imewekwa kwenye \"cloud \", viungo vinaonyeshwa kama wingu",
"Default: \"list\"" => "Default: \"orodha \"",
"Maximum elements" => "Vipimo vingi",
"If set to a number, limits the number of tags displayed" => "Ikiwa imewekwa kwenye nambari, hupunguza idadi ya lebo zilizoonyeshwa",
// "BlogId" => "BlogId",
// "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5" => "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5",
"My Preferred Tags" => "Lebo zangu zilizopendekezwa",
"Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size" => "Inaonyesha kwa watumiaji waliosajiliwa vitambulisho wanayopendelea, kulingana na idadi ya vitu walizoweka. Upendeleo mkubwa unaonyeshwa kwa ukubwa wa maandishi",
"My preferred tags" => "Lebo zangu zilizopendekezwa",
// "Displays a list of friends" => "Displays a list of friends",
// "GIT detail" => "GIT detail",
// "GIT commit and last update information" => "GIT commit and last update information",
"Google Search" => "Utafutaji wa Google",
"Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Inaonyesha fomu rahisi ya kutafuta kwenye Google. Kwa default, matokeo ya utafutaji yamepunguzwa kwa wale walio kwenye tovuti ya Tiki",
"Groups Emulation" => "Uhamishaji wa Vikundi",
"Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Inawezesha kubadilisha muda wa uanachama wa kikundi ili kuona jinsi watumiaji katika vikundi vidogo wanavyopata tovuti",
// "Show All Groups" => "Show All Groups",
// "If set to \"n\", the list is not shown" => "If set to \"n\", the list is not shown",
// "Show Your Groups" => "Show Your Groups",
"Emulate Groups" => "Kuagiza Vikundi",
"Last Actions" => "Hatua ya Mwisho",
"Displays the specified number of last actions." => "Inaonyesha idadi maalum ya vitendo vya mwisho.",
"Show user" => "Onyesha mtumiaji",
"If set to \"y\", user names are displayed in the module box" => "Ikiwa imewekwa kwa \"y\", majina ya watumiaji yanaonyeshwa kwenye sanduku la moduli",
"If set to \"y\", action dates are displayed in the module box" => "Ikiwa imewekwa kwenye \"y\", tarehe za utekelezaji zinaonyeshwa kwenye sanduku la moduli",
"Maximum number of characters in action descriptions before truncating" => "Upeo wa idadi ya wahusika katika maelezo ya hatua kabla ya kutembea",
"Newest Blog Posts" => "Machapisho zaidi ya blogu",
"Lists the specified number of blogs posts from newest to oldest." => "Inaandika nambari maalum ya machapisho ya blogi kutoka kwa mapya hadi ya zamani zaidi.",
"If set to \"y\", the date of posts is not displayed in the module box" => "Ikiwa imewekwa kwenye \"y\", tarehe ya machapisho haionyeshwa kwenye sanduku la moduli",
"Blog identifier" => "Kitambulisho cha blog",
"If set to a blog identifier, restricts the blog posts to those in the identified blog" => "Ikiwa imewekwa kwenye kitambulisho cha blogu, huzuia machapisho ya blogu kwa wale walio kwenye blogu iliyojulikana.",
"Newest Category Items" => "Vipengee vya vipengee vipya zaidi",
"Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Inaandika nambari maalum ya vitu vya aina iliyotolewa katika kikundi kilichopewa, kuanzia kwa viumbe hivi karibuni",
"Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Kitambulisho cha kikundi ambacho vitu vimeorodheshwa. Vitu tu katika makundi ya watoto hazitaonyeshwa",
"Maximum number of characters in object names allowed before truncating" => "Upeo wa idadi ya wahusika katika majina ya kitu huruhusiwa kabla ya kutembea",
"Type of the objects to list. Example values" => "Aina ya vitu ili kuorodhesha. Mfano wa maadili",
"no object here yet" => "hakuna kitu hapa bado",
"Newest Blogs" => "Blogu Zipya",
"Displays the specified number of blogs from newest to oldest." => "Inaonyesha nambari maalum ya blogu kutoka mpya zaidi hadi zamani zaidi.",
"Newest FAQs" => "Maswali mapya zaidi",
"Displays the specified number of FAQs from newest to oldest." => "Inaonyesha nambari maalum ya Maswali kutoka kwa mapya hadi ya zamani zaidi.",
"Newest Quizzes" => "Majaribio mapya zaidi",
"Displays the specified number of quizzes from newest to oldest." => "Inaonyesha nambari maalum ya majaribio kutoka mpya zaidi hadi zamani zaidi.",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
"Newest Files" => "Faili zilizopya zaidi",
"List the specified number of files, starting from the most recently added." => "Weka namba ya faili maalum, kuanzia hivi karibuni zilizoongezwa.",
"Gallery identifiers" => "Vidokezo vya sanaa",
"If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "Ikiwa imewekwa kwenye seti ya vitambulisho vya nyumba ya sanaa, inaruhusu faili kwa wale walio kwenye nyumba zilizojulikana. Thamani ni mlolongo uliojitenga na koloni wa integers",
"Example value: 13, 2:13, 1:2:3:5:6" => "Thamani ya mfano: 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
"Displays the specified number of image galleries, starting from the most recently modified" => "Inaonyesha idadi maalum ya nyumba za picha, kuanzia kwa marekebisho ya hivi karibuni",
"Newest Images" => "Picha Zipya zaidi",
"List the specified number of images, starting from the most recently added" => "Andika orodha ya picha, kuanzia hivi karibuni zilizoongezwa",
"Gallery identifier" => "Kitambulisho cha sanaa",
"If set to an image gallery identifier, restricts the images to those in the identified gallery" => "Ikiwa imewekwa kwenye kitambulisho cha sanaa cha picha, inaruhusu picha kwa wale walio kwenye nyumba ya sanaa iliyojulikana",
"Link content" => "Unganisha maudhui",
"Display the links as image names or thumbnails" => "Onyesha viungo kama majina ya picha au vidole",
"Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Valeurs possibles : \"names\" ou \"thumbnails\". Par défaut : \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
"If set to a calendar identifier, restricts the events to those in the identified calendar" => "Ikiwa imewekwa kwenye kitambulisho cha kalenda, inaruhusu matukio kwa wale walio kwenye kalenda iliyojulikana",
"Maximum number of characters in event names allowed before truncating" => "Upeo wa idadi ya wahusika katika majina ya tukio huruhusiwa kabla ya kutembea",
// "Hide Date" => "Hide Date",
"If set to \"y\", it will hide date" => "Ikiwa imewekwa kwenye \"y\", itaficha tarehe",
"Latest Changes" => "Mabadiliko ya hivi karibuni",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
"Target URL of the \"...more\" link at the bottom of the module" => "URL muhimu ya kiungo \"... zaidi\" chini ya moduli",
"Last-Modified Blogs" => "Blogu za mwisho zilizobadilishwa",
"Displays the specified number of blogs, starting from the most recently modified." => "Inaonyesha idadi maalum ya blogu, kuanzia kwa marekebisho ya hivi karibuni.",
"Newest Podcasts" => "Podcasts zuri zaidi",
"Displays Podcasts." => "Maonyesho ya Podcasts.",
"File galleries IDs" => "Fanya vitambulisho vya picha",
"List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "Orodha ya vitambulisho vya faili za aina ya \"Podcast (Audio)\". Watambuzi hutenganishwa na koloni (\":\"). Ikiwa hakuna, nyumba zote za faili zitatambuliwa",
"Width of mediaplayer in pixels." => "Upana wa mediaplayer katika saizi.",
"Height of mediaplayer in pixels." => "Urefu wa mediaplayer katika saizi.",
"Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Chemin vers le lecteur mp3. Par exemple media/player_mp3_maxi.swf si vous avez téléchargé 'player_mp3_maxi.swf' depuis http://flash-mp3-player.net/players/maxi/download/ vers le répertoire media/ (répertoire à créer ou vous pouvez choisir un autre emplacement)",
"Bottom Link URL" => "URL ya chini ya kiungo",
"URL for a link at bottom of module" => "URL ya kiungo chini ya moduli",
"Bottom Link URL Text" => "Nakala ya URL ya Kiungo cha chini",
"Text for link if Bottom Link URL is set." => "Nakala ya kiungo kama URL ya Kiungo cha Chini imewekwa.",
"More Podcasts" => "Zaidi ya Podcasts",
"Verbose" => "Verbose",
"Display description of podcast below player if \"y\", and on title mouseover if \"n\"." => "Onyesha maelezo ya podcast chini ya mchezaji kama \"y\", na juu ya kichwa mouseover kama \"n\".",
"Newest Article Submissions" => "Maagizo ya makala ya hivi karibuni",
"Lists the specified number of article submissions from newest to oldest." => "Inaandika nambari maalum ya maoni ya makala kutoka mpya zaidi hadi zamani zaidi.",
"Newest Tracker Comments" => "Maoni Mapya zaidi",
"Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Inaandika nambari maalum ya maoni ya tracker (kwa hiari kuzuia wale walio kwenye tracker maalum au kipengee cha tracker) kuanzia kuchapishwa hivi karibuni",
"Tracker identifier" => "Kitambulisho cha Tracker",
"If set to a tracker identifier, only displays the comments on the given tracker" => "Ikiwa imewekwa kwenye kitambulisho cha tracker, inaonyesha tu maoni kwenye tracker iliyotolewa",
"Item identifier" => "Kitambulisho cha kipengee",
"If set to an item identifier, only displays the comments on the given item" => "Ikiwa imewekwa kwenye kitambulisho cha kipengee, huonyesha tu maoni kwenye kipengee kilichotolewa",
"Newest Tracker Items" => "Vitu vya Tracker vyema zaidi",
"Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required." => "Inaonyesha thamani ya shamba la nambari maalum ya vitu vya tracker. Ikiwa tracker maalum haina shamba kuu, ama jina la shamba au kitambulisho cha shamba kinahitajika.",
"Identifier of the tracker from which items are listed" => "Kitambulisho cha tracker kutoka kwa vitu ambavyo vimeorodheshwa",
"Field identifier" => "Kitambulisho cha shamba",
"Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Kitambulisho cha shamba ambalo viwango vimeorodheshwa. Ikiwa jina la Shamba limewekwa, parameter hii inapuuzwa",
"Field name" => "Jina la shamba",
"Name of the field from which values are listed" => "Jina la shamba ambalo viwango vimeorodheshwa",
"Example value: age" => "Thamani ya mfano: umri",
"Specifies how the items should be sorted" => "Inabainisha jinsi vitu vinapaswa kutatuliwa",
"Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Les valeurs possibles incluent 'created' et 'created_asc' (équivalent), 'created_desc', 'status', 'lastModif', 'createdBy' et 'lastModifBy'. A moins que \"_desc\" soit spécifié, le tri est croissant. \"created\" trie sur la date de création des fiches. \"lastModif\" trie sur la date de dernière modification des fiches. \"lastModif_desc\" trie en ordre décroissant sur la date de dernière modification",
"Status filter" => "Chujio cha hali",
"If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "Si défini, limite les fiches affichées à celles ayant les statuts indiqués. Les valeurs sont des combinaisons de \"o\" (ouverte), \"p\" (en attente) et \"c\" (fermées). Valeurs possibles",
"Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Haiwezi kuamua shamba ambalo linaonyesha. Kitambulisho cha Tracker kinaweza kuwa batili, au tracker haina shamba kuu na hakuna kitambulisho cha Shamba au jina la Shamba liliwekwa",
"You do not have permission to view this tracker" => "Huna ruhusa ya kuona tracker hii",
"Last Items" => "Vitu vya mwisho",
"Last modified Items" => "Ilibadilishwa Vitu",
"Newest Validated FAQ Questions" => "Maswali yaliyothibitishwa zaidi zaidi ya Maswali",
"Displays the specified number of validated questions FAQs from newest to oldest" => "Inaonyesha idadi maalum ya maswali yaliyothibitishwa FAQs kutoka mpya zaidi hadi zamani zaidi",
"FAQ identifier" => "Kitambulisho cha Maswali",
"If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ" => "Ikiwa imewekwa kwenye kitambulisho cha Maswali, inaruhusu maswali yaliyochaguliwa kwa wale walio kwenye Maswali yaliyotambuliwa",
"Last Visitors" => "Wageni wa mwisho",
"Displays information about the specified number of users in decreasing order of last login time." => "Inaonyesha maelezo kuhusu idadi maalum ya watumiaji katika utaratibu wa kupungua wa wakati wa mwisho wa kuingia.",
"Show profile pictures" => "Onyesha picha za wasifu",
"If set to \"y\", show user profile pictures" => "Ikiwa imewekwa kwenye \"y\", onyesha picha za wasifu wa mtumiaji",
"Maximum number of characters in user names allowed before truncating" => "Idadi kubwa ya wahusika katika majina ya watumiaji kuruhusiwa kabla ya kupungua",
"Don't show date" => "Usionyeshe tarehe",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Google YouTube API Key" => "Google YouTube API Key",
"Width of each video in pixels" => "Upana wa kila video katika saizi",
"Height of each video in pixels" => "Urefu wa kila video katika saizi",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "muda",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
"No Playlist found" => "Hakuna orodha ya kucheza iliyopatikana",
"No Playlist ID was provided" => "Hakuna ID ya Orodha ya kucheza iliyotolewa",
"Live Support" => "Msaada wa Kuishi",
"Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console." => "Inaueleza watumiaji kama mtumiaji wa msaada wa sasa yukopo na anawawezesha kuomba msaada ikiwa inawezekana. Ikiwa mtumiaji ni operator, viungo kwenye console ya operator.",
"Server Load" => "Mzigo wa Serikali",
"Report of server resources used" => "Ripoti ya rasilimali za seva zitumiwa",
"Locator" => "Locator",
"Presents a map with the geolocated content within the page" => "Inatoa ramani na maudhui ya kijiografia ndani ya ukurasa",
// "Preference \"%0\" is disabled" => "Preference \"%0\" is disabled",
"Log-in box" => "Ingia kwenye sanduku",
"Input size" => "Ukubwa wa kuingiza",
"Number of characters for username and password input fields" => "Idadi ya wahusika kwa ajili ya majina ya jina la mtumiaji na nenosiri",
"Display mode: module, header or popup. Leave empty for module mode" => "Hali ya kuonyesha: moduli, kichwa au popup. Omba tupu kwa mode ya moduli",
"Show Register" => "Onyesha Daftari",
"Show the register link" => "Onyesha kiungo cha kujiandikisha",
"Show I Forgot" => "Onyesha Nimehau",
"Show the \"I forgot my password\" link" => "Onyesha \"Nimesahau nenosiri langu\" kiungo",
// "Show Remember me" => "Show Remember me",
"Show the \"Remember me\" checkbox" => "Onyesha \"Nikumbuke\" checkbox",
// "Show user avatar" => "Show user avatar",
// "Show the user avatar when in popup mode" => "Show the user avatar when in popup mode",
// "Show user name" => "Show user name",
// "Show the user name when in popup mode" => "Show the user name when in popup mode",
// "Groups for switch user listing" => "Groups for switch user listing",
// "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")" => "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")",
// "Menu ID" => "Menu ID",
// "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"" => "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"",
"Logo" => "Alama",
"Site logo, title and subtitle" => "Site ya alama, cheo na kichwa",
// "Image URL" => "Image URL",
// "Image to use. Defaults to sitelogo_src preference" => "Image to use. Defaults to sitelogo_src preference",
// "CSS colour to use as background. Defaults to sitelogo_bgcolor preference" => "CSS colour to use as background. Defaults to sitelogo_bgcolor preference",
// "Image title attribute. Defaults to sitelogo_title preference" => "Image title attribute. Defaults to sitelogo_title preference",
// "Alt" => "Alt",
// "Image alt attribute. Defaults to sitelogo_alt preference" => "Image alt attribute. Defaults to sitelogo_alt preference",
// "URL for the image and titles link. Defaults to \"./\"" => "URL for the image and titles link. Defaults to \"./\"",
// "Logo Title" => "Logo Title",
// "Large text to go next to image. Defaults to sitetitle preference" => "Large text to go next to image. Defaults to sitetitle preference",
// "Logo Subtitle" => "Logo Subtitle",
// "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference" => "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference",
// "Logo Class" => "Logo Class",
// "CSS class for the image container div. Defaults to sitelogo" => "CSS class for the image container div. Defaults to sitelogo",
// "Title Class" => "Title Class",
// "CSS class title text container div. Defaults to sitetitles" => "CSS class title text container div. Defaults to sitetitles",
// "Map Feature Editor" => "Map Feature Editor",
"Allows shapes to be drawn over the map" => "Inaruhusu maumbo kuvutia kwenye ramani",
// "Tracker to store the feature in" => "Tracker to store the feature in",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Mode change on insert" => "Mode change on insert",
// "Target mode to enter after successfully inserting an item" => "Target mode to enter after successfully inserting an item",
// "Edit details" => "Edit details",
// "Edit the tracker item's details through a dialog after the initial item creation" => "Edit the tracker item's details through a dialog after the initial item creation",
// "Layer Selector" => "Layer Selector",
// "Include base layer" => "Include base layer",
// "Include the drop list for the base layers" => "Include the drop list for the base layers",
// "Include optional layers" => "Include optional layers",
// "Include the checkboxes for the optional layers" => "Include the checkboxes for the optional layers",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "Orodha",
"Displays a menu or a structure as a menu" => "Inaonyesha orodha au muundo kama orodha",
"Identifier of a menu (from tiki-admin_menus.php)" => "Kitambulisho cha menyu(kutoka tiki-admin_menus.php)",
"Structure" => "Structure",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
"Direction for menu: horiz or vert (default vert)" => "Mwelekeo wa menyu: hori au kijani (vert default)",
"CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu (if bootstrap = n). y|n (default y)" => "Use CSS Superfish menu (if bootstrap = n). y|n (default y)",
// "Use Bootstrap menus" => "Use Bootstrap menus",
// "Show Navbar Toggle Button" => "Show Navbar Toggle Button",
// "Used in Bootstrap navbar menus when viewport is too narrow for menu items" => "Used in Bootstrap navbar menus when viewport is too narrow for menu items",
// "The URL of the navbar brand (logo)" => "The URL of the navbar brand (logo)",
// "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu" => "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu",
// "CSS class(es) for the menu nav element" => "CSS class(es) for the menu nav element",
// "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar" => "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar",
"DOM #id" => "DOM #id",
"Id of the menu in the DOM" => "Id ya orodha katika DOM",
"CSS class" => "Class CSS",
"Class of the menu container" => "Hatari ya chombo cha menyu",
"Limit low visibles levels" => "Weka viwango vya chini visivyoonekana",
"All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "Submenus zote zinazoanza katika ngazi hii zitaonyeshwa ikiwa url inalingana na chaguo moja ya ngazi hii au juu au chini",
"Limit top visible levels" => "Weka kiwango cha juu kinachoonekana",
"Do not display options higher than this level" => "Usionyeshe chaguo kubwa kuliko ngazi hii",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
"(y/n default y)" => "(o/n -défaut o)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "Set Selected" => "Set Selected",
// "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue" => "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue",
"One of these parameters has to be set" => "Moja ya vigezo hivi inapaswa kuweka",
"Menu Page" => "Ukurasa wa Menyu",
"Displays a Wiki page" => "Inaonyesha ukurasa wa Wiki",
"Page to display in the menu. Example value: HomePage" => "Ukurasa wa kuonyeshwa kwenye menyu. Mfano wa thamani: HomePage",
// "Use default namespace" => "Use default namespace",
// "Prepend the default namespace to the page name for localized menus per workspace (1/0)" => "Prepend the default namespace to the page name for localized menus per workspace (1/0)",
// "Menu style" => "Menu style",
// "Display the page as a menu (horiz / vert)" => "Display the page as a menu (horiz / vert)",
"Wiki Structure Menu" => "Menyu ya Uundo wa Wiki",
"Displays a structure" => "Inaonyesha muundo",
"N.B. Deprecated, use the Menu module instead" => "N.B. Imeondolewa, tumia moduli ya Menyu badala yake",
"Structure to display in the menu" => "Muundo ulioonyeshwa kwenye menyu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
"Displays to users their number of new inter-user messages and a link to their message box" => "Inaonyesha watumiaji idadi yao ya ujumbe mpya wa mtumiaji na kiungo kwa sanduku la ujumbe wao",
"Show If Empty" => "Onyesha ikiwa ni tupu",
"Show the module when there are no messages waiting. y|n " => "Onyesha moduli wakati hakuna ujumbe unasubiri. y | n ",
"Default=y" => "Default=y",
"Messages" => "Ujumbe",
"Small live chat box" => "Boti ndogo ya kuzungumza ya kuishi",
"Channels" => "Njia",
"List of chat channels. Channel names are separated by a comma (\",\")" => "Orodha ya vituo vya mazungumzo. Majina ya kituo yanatenganishwa na comma (\",\")",
"By default, a single channel named \"default\" exists" => "Kwa chaguo-msingi, kituo kimoja kinachoitwa \"default\" ipo",
"Mobile" => "Mobile",
"Currently only shows switch to and from mobile mode" => "Hivi sasa inaonyesha tu kubadili na kutoka kwa simu ya simu",
"To Label" => "Andika",
"Switch to normal site label" => "Badilisha kwenye studio ya kawaida ya tovuti",
"From Label" => "Kutoka kwa Lebo",
"Switch to mobile site label" => "Badilisha kwenye studio ya simu ya mkononi",
// "Switch Perspective" => "Switch Perspective",
"Also switch perspective back to this one when leaving mobile mode" => "Pia ubadili mtazamo nyuma ya hii wakati ukiacha hali ya simu",
"Stay" => "kaa",
"Stay on same page" => "Kaa kwenye ukurasa huo",
"Switch to mobile site" => "Badilisha kwenye tovuti ya simu",
"Switch to normal site" => "Badilisha kwenye tovuti ya kawaida",
"Months Links" => "Miezi Viungo",
"Link to articles or blog posts for the current month and those preceding it." => "Unganisha kwenye makala au machapisho ya blogu kwa mwezi uliopo na wale wanaotangulia.",
"Type of objects to link to" => "Aina ya vitu ili kuunganisha",
"Possible values" => "Maadili inayowezekana",
"\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogu\" kwa blogu, \"cms\" kwa makala zilizochapishwa",
// "Object Identifier" => "Object Identifier",
"Identifier of an object with children to link to" => "Kitambulisho cha kitu na watoto kuunganisha",
"This is required for the blog Object type" => "Hii inahitajika kwa aina ya Kitu cha blogu",
"For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "Kwa mfano, kitambulisho cha aina ya 3 na blogu ya Object itaonyesha viungo kwenye machapisho ya blog kwenye blogu yenye kitambulisho 3",
"List by month" => "Weka kwa mwezi",
"Most Commented" => "Wengi Maoni",
// "Display the most commented objects of a certain type" => "Display the most commented objects of a certain type",
"Type of objects to consider" => "Aina ya vitu kuzingatia",
"Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Valeurs possibles : wiki (pages Wiki), blog (publications de blogue), article (articles)",
"Language Filter" => "Filter ya lugha",
"If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "Ikiwa imewekwa kwenye lebo ya lugha ya RFC1766, inaruhusu vitu vinavyozingatiwa kwa wale walio katika lugha maalum",
// "Request the creation of a mustread item based on the current object" => "Request the creation of a mustread item based on the current object",
// "Object Field" => "Object Field",
// "Permanent name of the field containing the object reference" => "Permanent name of the field containing the object reference",
// "Notifications Link" => "Notifications Link",
// "Shows an icon with the number of and a link to user notifications" => "Shows an icon with the number of and a link to user notifications",
"Pending Article Submissions" => "Masuala ya Kichwa kinasubiri",
"Displays the number of article submissions waiting examination and a link to the list" => "Inaonyesha namba ya maoni ya makala kusubiri uchunguzi na kiungo kwenye orodha",
"Old Articles" => "Makala ya Kale",
"Displays the specified number of old articles (which do not show on articles home page anymore)." => "Inaonyesha idadi maalum ya makala za zamani (ambazo hazionyeshe kwenye ukurasa wa ukurasa wa nyumbani tena).",
// "Package Module" => "Package Module",
// "A module that shows content from a Tiki Package View" => "A module that shows content from a Tiki Package View",
// "Name of package (vendor/name)" => "Name of package (vendor/name)",
// "Name of package in the form vendor/name" => "Name of package in the form vendor/name",
// "Name of the view file without the .php" => "Name of the view file without the .php",
// "Other parameters" => "Other parameters",
// "URL encoded string of other parameters (will not replace standard parameters)" => "URL encoded string of other parameters (will not replace standard parameters)",
"Payments Outstanding" => "Malipo Bora",
"Displays the payments outstanding for the current user" => "Inaonyesha malipo bora kwa mtumiaji wa sasa",
// "List of active permissions for current object" => "List of active permissions for current object",
"Enables to change current perspective." => "Inawezesha kubadilisha mtazamo wa sasa.",
// "Powered By" => "Powered By",
"Powered by Tiki, and others" => "Inaendeshwa na Tiki, na wengine",
"Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Inaonyeshwa \"Inayotumiwa na ujumbe wa Tiki Wiki CMS Groupware\"",
"Tiki version info" => "Tiki version info",
"Shows theme credits (contents of credits.tpl)" => "Affiche les crédits de thème (contenus de credits.tpl)",
"Shows various \"powered by\" icons" => "Inaonyesha vifungu mbalimbali \"vinavyotumiwa na \"",
"Quick Edit" => "Haraka Hariri",
"Enables to quickly create or edit Wiki pages" => "Inawezesha kuunda haraka au kuhariri kurasa za Wiki",
"Deprecated - use the Search module instead" => "Imeondolewa - kutumia moduli ya Tafuta badala",
"Template identifier" => "Kitambulisho cha Kigezo",
"If set to a template identifier, the specified template is used for creating new Wiki pages" => "Ikiwa imewekwa kwenye kitambulisho cha template, template maalum hutumiwa kuunda kurasa mpya za Wiki",
"If set, send the form to the given location (relative to Tiki's root) for processing" => "Ikiwa imewekwa, tuma fomu kwenye mahali uliyopewa (kuhusiana na mizizi ya Tiki) kwa ajili ya usindikaji",
"SUBMIT label" => "Tumia lebo",
"The label on the button to submit the form" => "Lebo kwenye kifungo ili kuwasilisha fomu",
"Create/Edit" => "Unda / Hariri",
"INPUT SIZE" => "INPUT SIZE",
"Size attribute (horizontal, in characters) of the text input field for page names" => "Ishara ya ukubwa (usawa, katika wahusika) ya uwanja wa maandishi ya majina ya majina ya ukurasa",
"Optional heading to display at the top of the module's content" => "Kichwa cha hiari cha kuonyesha juu ya maudhui ya moduli",
"Category to preselect" => "Jamii ya kuchagua",
"If set, pages created through the module have this category prechecked to be categorized in" => "Ikiwa imewekwa, kurasa zilizotengenezwa kwa njia ya moduli zina kiwanja hiki kilichochezwa kuwa kikundi",
"Tip to be shown" => "Kidokezo cha kuonyeshwa",
"Custom text to be shown as a tip at the top of the edit page" => "Maandishi maalum yanaonyeshwa kama ncha juu ya ukurasa wa hariri",
"Title of tip to be shown" => "Kichwa cha ncha inayoonyeshwa",
"Custom title to be shown for the tip at the top of the edit page" => "Kichwa cha desturi kinachoonyeshwa kwa ncha ya juu ya ukurasa wa hariri",
"Custom header template" => "Template ya kichwa maalum",
"Wiki page to be used as a template to show content on top of edit page" => "Ukurasa wa Wiki utumike kama template ili kuonyesha maudhui juu ya ukurasa wa hariri",
"Quick Edit a Wiki Page" => "Haraka Hariri wa Wiki",
"Quick Search" => "Utafutaji wa haraka",
"Performs a search query and persists the results in the module for quick navigation access" => "Inafanya swala la utafutaji na inaendelea matokeo katika moduli ya upatikanaji wa haraka wa urambazaji",
"Filter object type" => "Futa aina ya kitu",
"Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limiter les résultats de recherche à un type spécifique d'objet. Entrer un type d'objet pour utiliser un filtre statique ou écrire \"selector\" pour permettre une saisie",
"Filter category" => "Chuo cha jamii",
"Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls" => "Weka matokeo ya utafutaji kwenye jamii maalum. Ingiza orodha ya vitambulisho vya kikundi ili vijumuishe katika chagua. Jamii moja haitaonyesha yoyote ya kuchagua",
"Quick Administration" => "utawala wa haraka",
// "Some helpful tools for administrators" => "Some helpful tools for administrators",
"Random Image" => "Picha iliyochaguliwa kwa nasibu",
"Displays a random image." => "Inaonyesha picha ya random.",
"If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "Ikiwa imewekwa kama kitambulisho cha nyumba ya sanaa, inaruhusu picha zilizochaguliwa kwa wale wa nyumba ya sanaa iliyojulikana",
"Show link" => "Afficher le lien",
"If set to \"n\", the image thumbnail does not link to the image" => "Si défini à \"n\", la vignette d'image ne pointe pas vers l'image",
"Default: \"y\"" => "Valeur par défaut : \"y\"",
"Show name" => "Afficher le nom",
"If set to \"y\", the name of the image is displayed" => "Si réglé sur \"y\", le nom de l'image est affiché",
"If set to \"y\", the description of the image is displayed" => "Si réglé sur \"y\", la description de l'image est affichée",
"Random Pages" => "Pages choisies au hasard",
"Displays the specified number of random wiki pages" => "Affiche le nombre spécifié de pages wiki aléatoirement choisies",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
"News Feeds" => "Inapatikana mito",
"List of feeds available on this site." => "Orodha ya mtiririko unaopatikana kwenye tovuti hii.",
"Multi-purpose search module (go or edit page by name and/or search site)" => "Moduli ya utafutaji ya kusudi nyingi (kwenda au kurekebisha ukurasa kwa jina na / au utafutaji kwenye tovuti)",
"Legacy Mode" => "Hali ya urithi",
"Setting to emulate previous behaviour" => "Kuweka kuiga tabia ya awali",
"If set to \"y\" the search performed is a \"Tiki search\"" => "Ikiwa imewekwa kwa \"y\" utafutaji uliofanywa ni \"Utafutaji wa Tiki \"",
" (full text search)" => " (tafuta kamili ya maandishi)",
"Show Object Type Filter" => "Onyesha kichujio cha aina ya kitu",
"If set to \"y\" shows a dropdown of sections to search" => "Ikiwa imewekwa kwenye \"y\" inaonyesha orodha ya kushuka chini ya sehemu za kutafuta",
" (no object filter)" => " (hakuna kichujio cha kitu)",
"Use autocomplete" => "Tumia kukamilika kwa auto",
"If set to \"y\" input uses autocomplete for pagenames if applicable" => "Ikiwa imewekwa kwa \"y\" matumizi ya pembejeo ya kukamilika kwa majina ya ukurasa ikiwa yanafaa",
" (use autocomplete)" => " (tumia kukamilika kwa auto)",
"Advanced search" => "Utafutaji wa juu",
"Use advanced (boolean) search (full text search only)" => "Utiliser les fonctions avancées (booléen) de recherche (recherche en texte intégral seulement)",
" (use advanced search)" => " (hutumia utafutaji wa juu)",
"Advanced search checkbox" => "Angalia sanduku la utafutaji juu",
"Show advanced search checkbox (full text search only)" => "Onyesha lebo ya utafutaji wa 'Advanced Search' (utafutaji kamili wa maandishi tu)",
" (advanced search checkbox off)" => "(sanduku la utafutaji la juu limezimwa)",
"Advanced search help" => "Usaidizi wa utafutaji wa juu",
"Show advanced search help icon (full text search only)" => "Onyesha icon ya usaidizi wa utafutaji wa juu (utafutaji kamili wa maandishi tu)",
" (advanced search help off)" => " (usaidizi wa utafutaji wa juu umezimwa)",
"Show Search Button" => "Onyesha kitufe cha 'Tafuta'",
"Show search button" => "Onyesha kitufe cha 'Tafuta'",
" (do show search button)" => " (inaonyesha kitufe cha 'tafuta')",
"Show Go Button" => "Onyesha kitufe cha 'Nenda'",
"Show go to page button" => "Onyesha kitufe cha 'Nenda kwenye ukurasa'",
" (do show go button)" => " (onyesha kitufe cha kwenda)",
"Show Edit Button" => "Onyesha Kitufe cha Hariri",
"Show edit button" => "Onyesha kifungo cha Hariri",
" (do show edit button)" => " (inaonyesha kifungo 'hariri')",
"Default Button" => "Kitufe cha chaguo-msingi",
"Action to perform on entering <return>" => "Nini cha kufanya wakati <input> imewekwa",
" (search|go|edit)" => "(Search | kutekeleza | hariri)",
"Search Form Action" => "Fomu ya utafutaji ya hatua",
" tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php ou tiki-searchindex.php (kwa Utafutaji wa Tiki)",
// "Search Submit Label" => "Search Submit Label",
"Go Form Action" => "Inatuma fomu",
// "Go Submit Label" => "Go Submit Label",
"Go" => "OK",
"Edit Form Action" => "Hatua ya fomu ya hariri",
"Edit Submit Label" => "Badilisha lebo 'Tuma'",
"Input field width" => "Upana wa uwanja wa pembejeo",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
" 0 (leave automatic width)" => "0 (shika upana kwa moja kwa moja)",
"Select size" => "Ukubwa wa kipangilio",
"Size of the Search Filter dropdown list" => "Ukubwa wa orodha ya kushuka chini ya kichujio cha utafutaji",
"Edit Template identifier" => "Badilisha kitambulisho cha template",
"If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "Ikifafanuliwa kama kitambulisho cha kikundi, kurasa zilizoundwa kupitia moduli hii zinaunganishwa moja kwa moja na jamii hii",
"Compact mode" => "Hali ya kuingiliana",
"Makes the three buttons only appear on mouse-over" => "Hufanya vifungo vyote vitatu vinavyoonekana tu wakati wa kutembea juu ya panya",
// "Additional filters" => "Additional filters",
// "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test" => "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test",
"Search is disabled" => "Utafutaji umezimwa",
"Search for Wiki Page" => "Tafuta Kurasa za Wiki",
// "More Like This" => "More Like This",
// "Uses the unified search to provide similar documents" => "Uses the unified search to provide similar documents",
// "Object Type Filters" => "Object Type Filters",
// "Comma-separated types to allow" => "Comma-separated types to allow",
// "Text Search Filters" => "Text Search Filters",
// "Comma-separated text search filters to use. Use \"=\" to separate field and value" => "Comma-separated text search filters to use. Use \"=\" to separate field and value",
// "Object id of item you want to get similar items to" => "Object id of item you want to get similar items to",
// "The object id of the item. If none is provided, Tiki will attempt to resolve the current object" => "The object id of the item. If none is provided, Tiki will attempt to resolve the current object",
// "Object type of item you want to get similar items to" => "Object type of item you want to get similar items to",
// "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object" => "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object",
// "Search For a Wiki Page" => "Search For a Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
"Exact match checkbox checked by default if set to \"y\"" => "Kichunguzi chenye 'mechi halisi' kinachunguliwa na default ikiwa imewekwa kwenye \"y \"",
// "Semantic Links" => "Semantic Links",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
"Links for sharing, reporting etc" => "Viungo vya kushiriki, ripoti nk",
"Report" => "Ripoti",
"Report to Webmaster" => "Ripoti kwa wavuti wa wavuti",
"Share this page" => "Shiriki ukurasa huu",
"Use icons for report, share and email links" => "Tumia icons kutoa taarifa, kushiriki na kutuma kwa barua pepe",
"Show Facebook \"Like\" button on the current page" => "Onyesha kifungo cha Facebook \"Kama \" kwenye ukurasa wa sasa",
"Facebook: URL" => "Facebook : URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
"Facebook: Height" => "Facebook : urefu",
"Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Urefu wa chombo katika vitengo vya CSS (yaani \"120px \" au \"2em \")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
"Facebook: Colors" => "Facebook : rangi",
// "Color scheme" => "Color scheme",
"Facebook: Font" => "Facebook : Police",
"Font to display" => "Onyesha font",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
"Facebook: App Id" => "Facebook : Id ya maombi",
"ID of your Facebook app (optional)" => "ID Programu yako ya Facebook (hiari)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
"Google +1 button" => "Kitufe cha Google +1",
// "Google: Size" => "Google: Size",
"Google button size" => "Ukubwa wa kifungo cha Google",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "Creates or shows a short url for the visiting page" => "Creates or shows a short url for the visiting page",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent." => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent.",
"If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "Ikiwa imewekwa kwenye \"1\", inaonyesha tarehe na muda wa ujumbe kama kitambulisho badala ya kuionyesha moja kwa moja katika maudhui ya moduli",
"Label on the button to post a message" => "Andika kwenye kifungo ili upe ujumbe",
"Wait label" => "'Mgonjwa' lebo",
"Label on the button to post a message when the message is being posted if AJAX is enabled" => "Weka kwenye kitufe cha 'Chapisha' wakati ujumbe unapofishwa ikiwa AJAX imewezeshwa",
"Please wait.." => "Kusubiri, tafadhali",
"Maximum messages shown" => "Idadi kubwa ya ujumbe ulionyeshwa",
"Number of messages to display" => "Idadi ya ujumbe unaoonyeshwa",
"Tweet" => "Tweet",
"If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "Ikiwa imewekwa kwenye \"1 \" na mtumiaji ameturuhusu sisi kutuma tweets na Twitter, mtumiaji anaweza kuamua kama anataka kutumia megaphone kupitia Twiter",
"If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "Ikiwa imewekwa kwenye \"1 \" na mtumiaji ameturuhusu sisi kutumia Facebook, mtumiaji anaweza kuamua kama anataka kuongeza ad ya megaphone kwenye ukuta wa Facebook",
"Since Last Visit (Simple)" => "Depuis la dernière visite (simple)",
"Displays to logged-in users the number of new or updated objects since their last login date and time" => "Inaonyesha watumiaji wa kuthibitishwa idadi ya vitu vipya au vilivyobadilika tangu kuunganishwa kwao mwisho",
"Since your last visit" => "Tangu ziara yako ya mwisho",
"Since Last Visit" => "Tangu ziara ya mwisho",
"Displays to logged-in users new or updated objects since a point in time, by default their last login date and time" => "Inaonyesha watumiaji wa kuthibitishwa vitu vipya au vimebadilishwa kwa wakati fulani, kwa wakati usiowekwa wa uhusiano wao wa mwisho",
"Show users" => "Onyesha watumiaji",
"If set to \"n\", do not show new users" => "Ikiwa imewekwa kwenye \"n\", usionyeshe watumiaji wapya",
"If set to \"n\", do not show tracker changes" => "Ikiwa imewekwa kwenye \"n\", usionyeshe mabadiliko ya fomu",
"Calendar focus" => "Nambari ya kumbukumbu ya kalenda",
"Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar." => "Isipokuwa kuweka kwa \"kupuuzia\", moduli inabadilisha hatua ya kumbukumbu ya muda kutoka kwa tarehe ya mwisho ya kuingia ya mtumiaji na wakati hadi siku ambayo mtumiaji hupiga kalenda.",
"Show date as a calendar link" => "Onyesha tarehe kama kiungo cha kalenda",
"If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)." => "Ikiwa imewekwa kwenye \"n \", usiongeze kiungo kwenye kalenda ya tiki kwenye kichwa (hata ikiwa kazi ya kalenda imewezeshwa).",
"Fold sections by default" => "Pindisha tena sehemu za msingi",
"If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "Ikiwa imewekwa kwenye \"y \", fungua sehemu moja kwa moja na uonyeshe tu kichwa (mtumiaji atabidi ague kila sehemu ili kuona maelezo au marekebisho)",
// "Use tabbed presentation" => "Use tabbed presentation",
// "If set to \"y\", use Bootstrap tabs to show the result" => "If set to \"y\", use Bootstrap tabs to show the result",
"Minimum timespan" => "Kiwango cha chini cha muda",
"Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Badala ya wakati wa uunganisho wa mwisho, kurudi wakati huu wa chini, uliowekwa katika siku, ikiwa uunganisho wa mwisho unapatikana hivi karibuni",
// "Maximum comment length" => "Maximum comment length",
"Changes since" => "Mabadiliko tangu",
"Since your last visit..." => "Tangu ziara yako ya mwisho ...",
"In the last %0 days.." => "Katika mwisho% 0 siku ...",
"new comments" => "maoni mapya",
" (archived)" => "(Kumbumkumbu)",
"new posts" => "makala mpya ya jukwaa",
"wiki pages changed" => "Ilibadilishwa ukurasa wa wiki",
"new articles" => "makala mpya",
"new FAQs" => "FAQ mpya",
"new blogs" => "blogu mpya",
"new blog posts" => "chapisho jipya la blogu",
"new image galleries" => "nyumba ya sanaa mpya ya picha",
"new images" => "picha mpya",
"new file galleries" => "faili mpya ya faili",
"new files" => "faili mpya",
"new polls" => "uchaguzi mpya",
"new users" => "Mtumiaji mpya",
"new tracker items" => "fomu mpya ya fomu",
"updated tracker items" => "Karatasi za fomu zilizopangwa",
// "new calendars" => "new calendars",
// "new events" => "new events",
// "starting on" => "starting on",
// "If comments don't use titles this sets the maximum length for the comment snippet" => "If comments don't use titles this sets the maximum length for the comment snippet",
// "SVN Up Info" => "SVN Up Info",
"SVN Version and last update information" => "Toleo la SVN na taarifa ya mwisho ya update",
"Switch Language" => "Badilisha lugha",
"Displays a language picker to change the language of the site" => "Onyesha mchezaji wa lugha kubadilisha lugha ya tovuti",
"Display mode" => "Mode d'affichage",
"Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Badilisha jinsi orodha ya lugha inavyoonyeshwa. Maadili iwezekanavyo ni orodha ya kushuka, bendera (bendera) na majina (maneno). Orodha ya kushuka kwa chaguo-msingi",
// "Switch Admin Language" => "Switch Admin Language",
// "Displays a language picker to change the language of admin site" => "Displays a language picker to change the language of admin site",
"Switch Theme" => "Badilisha mandhari",
// "Enables to quickly change the theme for the user" => "Enables to quickly change the theme for the user",
// "Not allowed here" => "Not allowed here",
// "Displayed theme" => "Displayed theme",
// "Admin Theme" => "Admin Theme",
"Terminology" => "istilahi",
"Support for multilingual terminology" => "Msaada kwa istilahi ya lugha nyingi",
"Root category" => "Jamii ya Mizizi",
"All terms will automatically be put in that category. " => "Sheria zote zitawekwa moja kwa moja kwa jamii hii.",
"Note that the category must already exist. " => "Kumbuka kwamba kikundi lazima kiwepo tayari.",
"Defaults to 'Term'" => "Muda wa 'Muda'",
"Tiki Tests" => "Uchunguzi wa Tiki",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "Blogu nyingi za kazi",
"Displays the specified number of blogs with links to them, from the most active one to the least." => "Inaonyesha idadi iliyobaki ya blogu zilizochanganywa, kutoka kwa kazi nyingi hadi angalau kazi.",
"Blog activity measurement can be more or less accurate." => "Kipimo cha shughuli za blogu kinaweza kuwa sahihi zaidi au chini.",
"Lists the specified number of articles with links to them, from the most visited one to the least." => "Weka namba ya ombi ya makala na viungo kwao, kutoka kwa waliotembelewa zaidi hadi kutembelewa zaidi.",
// "Top Blog Posters" => "Top Blog Posters",
// "Displays the specified number of users who posted to blogs, starting with the one having most posts" => "Displays the specified number of users who posted to blogs, starting with the one having most posts",
// "Limit to a blog" => "Limit to a blog",
"Top File Galleries" => "Maarufu ya Picha za Galleries",
"Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Inaonyesha idadi ya fasta ya faili za faili kama viungo, kuanzia na moja yenye hits zaidi",
// "Top Files" => "Top Files",
"Displays the specified number of files with links to them, starting with the one with most hits." => "Inaonyesha idadi ya fasta ya faili zilizounganishwa, kuanzia na moja na upatikanaji zaidi.",
"Top Forum Posters" => "Publieurs de forum les plus actifs",
"Displays the specified number of users who posted to forums, starting with the one having most posts" => "Inaonyesha idadi maalum ya watumiaji ambao wamesajili kwenye jukwaa, kuanzia na mtu aliyeweka zaidi",
// "Top Image Galleries" => "Top Image Galleries",
"Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Inaonyesha idadi maalum ya nyumba za picha zilizo na viungo kwao, kuanzia na moja na ziara nyingi",
"Top Images" => "Picha maarufu zaidi",
"Displays the specified number of images with links to them, from the most visited one to the least" => "Inaonyesha idadi maalum ya nyumba za picha zilizo na viungo kwao, kuanzia na ile iliyopokea ziara nyingi",
"Top Objects" => "Vitu vingi vinavyoonekana",
"Displays the specified number of objects, starting with the one having the most hits" => "Inaonyesha idadi maalum ya vitu, kuanzia na moja na ziara nyingi",
"Top Pages" => "Kurasa maarufu zaidi",
"Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Inaonyesha idadi maalum ya kurasa zilizounganishwa, kuanzia na wale walio na hits zaidi",
"Top Quizzes" => "Maswali maarufu zaidi ya uchaguzi wengi (MCQs)",
"Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Inaonyesha nambari maalum ya maswali kwa kiungo, kuanzia na wale ambao wana hits zaidi",
"Top Visited Blogs" => "Blogu nyingi zilitembelewa",
"Display the specified number of blogs with links to them, from the most visited one to the least." => "Inaonyesha idadi iliyobaki ya blogu zilizochanganywa, kutoka kwa waliotembelewa zaidi hadi kutembelea kidogo.",
"Show Last Post" => "Angalia chapisho cha hivi karibuni",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
// "Tracker Input" => "Tracker Input",
"Allows a dialog to be opened to create new tracker items" => "Inafungua mazungumzo ili kuunda karatasi mpya za fomu",
// "Tracker ID to render" => "Tracker ID to render",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
// "Mode change on complete" => "Mode change on complete",
// "Target mode to enter after dialog closes" => "Target mode to enter after dialog closes",
"Tracker Help" => "Msaidizi wa Fomu",
"Display the fields of a tracker (name and identifier)" => "Onyesha mashamba ya fomu (jina na kitambulisho)",
"Text field height" => "Urefu wa shamba wa maandishi",
"Number of lines" => "Idadi ya mistari",
"Text field width" => "Upana wa shamba la maandishi",
"Number of characters" => "Idadi ya wahusika",
"Translate Updates" => "Tafsiri updates",
"Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed." => "Hyperlie kwa matoleo ya ukurasa wa wiki kutazamwa kwa lugha zingine, kutoa ripoti bora zaidi, sawa au duni. Kwa hiari, huonyesha kiwango cha upya wa tafsiri iliyoonyeshwa.",
"Reference language" => "Lugha ya kumbukumbu",
"If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "Ikiwa imewekwa kwenye msimbo wa lugha, inaruhusu kurasa za ndani zilizoonyeshwa kwenye ukurasa wa kumbukumbu, isipokuwa ikiwa inavyoonyeshwa",
"Show language" => "Onyesha lugha",
"If \"y\" the page language will be shown instead of the page name" => "Ikiwa \"y \" lugha ya ukurasa itaonyeshwa badala ya jina la ukurasa",
"Default = \"y\"" => "Default = \"y\"",
// "Tweets" => "Tweets",
// "Shows the tweets from the Twitter timeline of a user" => "Shows the tweets from the Twitter timeline of a user",
// "Tiki user to show Twitter timeline of" => "Tiki user to show Twitter timeline of",
// "Show public|friends timeline. " => "Show public|friends timeline. ",
// "Search string" => "Search string",
// "user not registered with twitter" => "user not registered with twitter",
"Lists the specified number of calendar events, ordered by their start date" => "Andika orodha maalum ya matukio ya kalenda, iliyopangwa na tarehe zao za kuanza",
"If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "Ikiwa imewekwa kama orodha ya vitambulisho vya kalenda, weka mipaka kwa wale walio kwenye kalenda zilizojulikana. Vidokezo vinatenganishwa na baa wima (\"|\"), commas (\",\")  colons (\":\")",
"Maximum days in the future" => "Upeo wa siku kadhaa baadaye",
"Maximum distance to event start dates in days (looking forward)" => "Upeo umbali katika siku kutoka mwanzo wa tukio (kutafuta mbele)",
"Maximum days in the past" => "Idadi ya siku siku za nyuma",
"Maximum distance to event end dates in days (looking backward)" => "Upeo umbali katika siku kutoka tarehe ya mwisho ya tukio (tafuta nyuma)",
"cellpadding" => "Kiini cha ndani cha seli",
"If set to an integer, apply this cellpadding to the HTML table generated" => "Ikiwa imewekwa kama integer, tumia margin hii ya ndani ya seli kwenye meza ya HTML iliyozalishwa",
"cellspacing" => "Upeo wa kiini",
"If set to an integer, apply this cellspacing to the HTML table generated" => "Ikiwa imewekwa kama integer, tumia nafasi hii ya kiini kwenye meza ya HTML inayozalishwa",
"If set to \"y\", event descriptions are displayed" => "Ikiwa imewekwa kwenye \"y \", maelezo ya tukio yanaonyeshwa",
"Show end date and time" => "Onyesha tarehe na wakati wa mwisho",
"If set to \"y\", event end dates and times are displayed, when appropriate" => "Ikiwa imewekwa kwenye \"y \", tarehe za mwisho za tukio na nyakati zinaonyeshwa, wakati unafaa",
"Use custom calendar background colors" => "Tumia rangi ya asili ya kalenda ya desturi",
"If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "Ikiwa imewekwa kwenye \"y \", matukio yanaonyeshwa na rangi ya asili ya desturi ya kalenda (ikiwa mtu amechaguliwa)",
"Show information in tooltips" => "Onyesha habari katika zana za zana",
"If set to \"n\", event tooltips will not display event information" => "Ikiwa imewekwa kwenye \"n \", vifaa vya tukio havionyeshe habari kuhusu hilo",
"Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Fomu ya kutumia kwa tarehe nyingi. Angalia <a href=\"http://www.php.net/manual/en/function.strftime.php\"> nyaraka za nyaraka () nyaraka </a>.",
"site preference for short date format followed by site preference for short time format" => "upendeleo wa tovuti kwa muundo mfupi wa tarehe ikifuatiwa na upendeleo wa tovuti kwa muundo mfupi wa muda mfupi",
"If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "Ikiwa thamani ya integer imedhamiriwa, majina ya tukio yatapelekwa zaidi ya idadi hii ya wahusika",
"My Blogs" => "Blogu Zangu",
"Displays to registered users their blogs" => "Inaonyesha watumiaji waliojiandikisha blogu zao",
"My Bookmarks" => "Vifungo vya mtumiaji",
"Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Kiolesura kilichorahisishwa kwa alama za mtumiaji, kuruhusu uweze kuzionyesha kwa ufupi, kufanya vidokezo vichache na alama alama inayoonyeshwa",
"My Image Galleries" => "Wafanyabiashara wa Picha ya Picha",
"Displays to registered users their image galleries" => "Inaonyesha watumiaji nyumba zao za picha",
"User Pages" => "Kurasa zangu",
"Displays to registered users the specified number of wiki pages which they were the last to edit" => "Maonyesho kwa watumiaji waliosajiliwa idadi maalum ya kurasa za wiki ambapo walikuwa mwisho kufanya mabadiliko",
"My Pages" => "Kurasa Zangu",
"My Tasks" => "Kazi ya mtumiaji",
"Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Kielelezo cha nuru kwa kazi za mtumiaji, kuruhusu kuziona kwa njia halisi na kufanya baadhi ya matendo",
"The task title must have at least 3 characters" => "Kichwa cha kazi lazima iwe angalau wahusika 3",
"Public Tasks" => "Kazi za umma",
"Lists the public user tasks of a chosen group, with links to tasks" => "Andika orodha ya kazi ya umma ya kikundi kilichochaguliwa, ikiwa na viungo kwa kazi hizi",
"User-Group Tracker" => "Fomu ya Kikundi cha Watumiaji",
"User and Group tracker links" => "Viungo vya fomu ya mtumiaji na kikundi",
// "Users List" => "Users List",
// "Display a list of users with optional extra information from each" => "Display a list of users with optional extra information from each",
"Login" => "Login",
// "Show the user name" => "Show the user name",
"y|n" => "y|n",
// "Show the user real name" => "Show the user real name",
"Last Login" => "Uthibitishaji wa mwisho",
// "Show the last login date" => "Show the last login date",
// "Show the direct and included groups a user belongs to" => "Show the direct and included groups a user belongs to",
// "Show the user profile picture" => "Show the user profile picture",
// "Show a link to the userPage" => "Show a link to the userPage",
// "Log" => "Log",
// "Show a link to the user logs(feature actionlog must be activated)" => "Show a link to the user logs(feature actionlog must be activated)",
// "Show only the users of the group" => "Show only the users of the group",
// "Groupname" => "Groupname",
// "Included Groups" => "Included Groups",
// "Show only the users of the group group and of a group including group" => "Show only the users of the group group and of a group including group",
// "initial" => "initial",
// "Show only the users whose name begins with the letter" => "Show only the users whose name begins with the letter",
// "a letter" => "a letter",
// "heading" => "heading",
// "Show the table heading" => "Show the table heading",
// "Sort users in ascending or descending order using these values: " => "Sort users in ascending or descending order using these values: ",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
"Most Active Users" => "Watumiaji wengi wa kazi",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "websearch" => "websearch",
// "Displays a simple form to perform a web search with choice on multiple search engines" => "Displays a simple form to perform a web search with choice on multiple search engines",
"Related Items" => "Vitu katika jamii sawa",
"Lists objects which share a category with the viewed object" => "Andika orodha ya vitu vilivyofanana na vilivyoonyeshwa",
// "Online Users" => "Online Users",
// "Display information about users currently logged in" => "Display information about users currently logged in",
"Display the number of users logged in, the list of users logged in, or both" => "Tazama idadi ya watumiaji waliounganishwa, orodha yao, au zote mbili",
"Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Maadili inayowezekana: \"kuhesabu \", \"orodha \" au \"wote \". Thamani ya msingi: \"zote mbili \"",
// "Cluster Mode" => "Cluster Mode",
"If set to \"1\", separate users based on which host/server they logged on" => "Ikiwa imewekwa kwa \"1 \", watumiaji tofauti na seva waliyounganishwa nayo",
// "Silent Mode" => "Silent Mode",
// "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it" => "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it",
"Newest Comments" => "Maoni ya hivi karibuni",
"Lists the specified number of comments starting from the most recently posted" => "Weka nambari ya maoni maalum inayoanzia na kuchapishwa hivi karibuni",
"More in tooltips" => "Zaidi katika vifaa vya tooltips",
"If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "Ikiwa imewekwa kwenye \"y \", jina la kitu ambacho kilipokea maoni sionyeshwa kwenye sanduku la moduli, lakini badala yake limehamia kwenye kitambulisho cha kipengee",
"Type of the objects from which comments will be listed. Possible values" => "Aina ya vitu ambavyo maoni yao yataorodheshwa. Maadili inayowezekana",
// "Display user profile pictures instead of numbers" => "Display user profile pictures instead of numbers",
// "Comments about objects in this language only" => "Comments about objects in this language only",
"Last article comments" => "Maelezo ya makala ya hivi karibuni",
"Last wiki comments" => "Maoni ya hivi karibuni Wiki",
// "Hold a chat session using XMPP (uses the ConverseJS client)" => "Hold a chat session using XMPP (uses the ConverseJS client)",
// "XMPP" => "XMPP",
"Displays YouTube videos and/or a link to a YouTube user's page" => "Inaonyesha video za YouTube na / au kiungo kwa ukurasa wa YouTube wa mtumiaji",
"Video identifiers" => "Vidokezo vya Video",
"List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "Orodha ya watambulisho wa video ya YouTube ili kuonyesha. Vidokezo vinatenganishwa na comma (\",\")",
"YouTube user identifier" => "Kitambulisho cha mtumiaji wa YouTube",
"If set to a YouTube user identifier, display a link to the videos of this user" => "Ikiwa imewekwa kama Kitambulisho cha mtumiaji wa YouTube, onyesha kiungo kwa video za mtumiaji huu",
"Videos on YouTube" => "Video kwenye YouTube",
// "Module Zone" => "Module Zone",
// "Can contain other modules so can be used as a Bootstrap navbar object, for example" => "Can contain other modules so can be used as a Bootstrap navbar object, for example",
// "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel" => "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel",
// "Example for a Bootstrap \"social\" navbar" => "Example for a Bootstrap \"social\" navbar",
"Bibliography Search" => "Utafiti wa hati",
"Search the group's Zotero library for entries with the specified tags" => "Tafuta maktaba ya Zotero kwa ajili ya vitu na maneno muhimu",
// "failure" => "failure",
// "You do not have sufficient permissions to perform this action" => "You do not have sufficient permissions to perform this action",
// "Please enter Biblio Code" => "Please enter Biblio Code",
// "Biblio code must not exceed 50 characters" => "Biblio code must not exceed 50 characters",
// "success" => "success",
// "Page not found. Please save the page first" => "Page not found. Please save the page first",
// "This reference already exists in the library" => "This reference already exists in the library",
// "Reference added to library" => "Reference added to library",
// "This biblio code already exists" => "This biblio code already exists",
// "Bibliography saved" => "Bibliography saved",
// "Reference already exists" => "Reference already exists",
// "Reference added" => "Reference added",
"Invalid server key" => "Kitufe cha seva batili",
"Invalid username or password" => "Jina la mtumiaji batili au nenosiri",
"Cookie not found" => "Cookie haipatikani",
// "This user is your friend" => "This user is your friend",
// "You share the following groups with this user" => "You share the following groups with this user",
// "Unlike" => "Unlike",
// "There is no activity to display in this stream" => "There is no activity to display in this stream",
// "%0 %1" => "%0 %1",
// "%0 posted a comment to" => "%0 posted a comment to",
// "%0 started a new discussion" => "%0 started a new discussion",
// "Join the discussion" => "Join the discussion",
// "%0 replied to a thread" => "%0 replied to a thread",
// "%0 corrected a message" => "%0 corrected a message",
// "%0 requested an action from you" => "%0 requested an action from you",
// "%0 triggered your %1 priority saved filter" => "%0 triggered your %1 priority saved filter",
// "Critical Priority" => "Critical Priority",
// "See your saved filter" => "See your saved filter",
// "High Priority" => "High Priority",
// "Low Priority" => "Low Priority",
// "Recommended Reading" => "Recommended Reading",
// "Based on your previous activity, we believe you might find this useful" => "Based on your previous activity, we believe you might find this useful",
// "Was this useful" => "Was this useful",
// "Help us improve" => "Help us improve",
// "%0 created a tracker" => "%0 created a tracker",
// "%0 created a tracker item" => "%0 created a tracker item",
// "%0 modified a tracker item" => "%0 modified a tracker item",
// "%0 has added %1 to his stream" => "%0 has added %1 to his stream",
// "%0 is now followed by %1" => "%0 is now followed by %1",
// "%0 and %1 became friends" => "%0 and %1 became friends",
// "%0 created a page" => "%0 created a page",
// "%0 modified a page" => "%0 modified a page",
// "View changes" => "View changes",
// "history" => "history",
// "Show More" => "Show More",
"Saving..." => "Usajili unaendelea..",
// "Adding.." => "Adding..",
// "References Available" => "References Available",
// "Add to library" => "Add to library",
// "Library References" => "Library References",
"Use" => "matumizi",
// "Edit Library References" => "Edit Library References",
"Part" => "sehemu",
// "URI" => "URI",
// "Publisher" => "Publisher",
// "Enter the CSS class name to be added in the 'li' tag for listing this reference" => "Enter the CSS class name to be added in the 'li' tag for listing this reference",
// "Enter template format in which you want to display the reference details in the bibliography listing. For example" => "Enter template format in which you want to display the reference details in the bibliography listing. For example",
// "All the codes must be in lower case letters separated with spaces" => "All the codes must be in lower case letters separated with spaces",
// "Please save the page before creating the bibliography" => "Please save the page before creating the bibliography",
"Preference Filters" => "Vipicha vya upendeleo",
"basic" => "msingi",
"Set as my default" => "Weka kama maadili yangu ya msingi",
// "Provide Feedback" => "Provide Feedback",
// "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them" => "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them",
// "Icon for 'Like'" => "Icon for 'Like'",
// "Icon for 'Fix me'" => "Icon for 'Fix me'",
// "Icon for 'What is this for?'" => "Icon for 'What is this for?'",
// "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)" => "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)",
// "Click to read more" => "Click to read more",
// "Rebuild Admin Index" => "Rebuild Admin Index",
"Control Panels" => " Paneli za usanidi",
// "Search preferences" => "Search preferences",
"Configuration search" => "Inatafuta chaguzi za usanidi",
"Note: The search index needs rebuilding, this will take a few minutes" => "Kumbuka: Ripoti ya utafutaji inahitaji kujengwa tena. Itachukua dakika chache",
// "Preference Search Results" => "Preference Search Results",
// "Apply Changes" => "Apply Changes",
"Apply" => "Tumia",
"No results" => "Hakuna matokeo",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Not what you expected? Try %0rebuilding%1 the preferences search index" => "Not what you expected? Try %0rebuilding%1 the preferences search index",
"Access" => "Upatikanaji",
"Users" => "Watumiaji",
// "Banning" => "Banning",
"Directories" => "Saraka",
"External Feeds" => "RSS ya nje",
"HTML Pages" => "Pages HTML",
// "Wiki Structures" => "Wiki Structures",
"System" => "Mfumo",
"Activity Rules" => "Kanuni za Shughuli",
"Content Templates" => "Gabarits de contenu",
"Languages" => "Lugha",
"Mail Notifications" => "Arifa za Barua",
"Menus" => "Orodha",
// "User Credits" => "User Credits",
"Transitions" => "Mpito",
"Plugin Approval" => "Uidhinishaji wa Plugin",
"Mods" => "Mods",
"Tools" => "Chombo",
"Action Log" => "Logi ya hatua",
"Cookies" => "Vidakuzi",
// "DSN/Content Authentication" => "DSN/Content Authentication",
// "Edit TPL" => "Edit TPL",
"External Pages Cache" => "Cache de pages externes",
"External Wikis" => "Wiki za nje",
// "Importer" => "Importer",
// "PhpInfo" => "PhpInfo",
// "Referer Statistics" => "Referer Statistics",
// "Search Statistics" => "Search Statistics",
"Security Admin" => "Dhibiti Usalama",
// "Server Check" => "Server Check",
// "Synchronize Dev" => "Synchronize Dev",
// "System Cache" => "System Cache",
// "System Logs" => "System Logs",
// "Sitemap" => "Sitemap",
// "Wizards" => "Wizards",
"Cancel Edit" => "Futa mabadiliko",
// "Banners listing" => "Banners listing",
"Activate the feature" => "Tumia kipengele",
// "Site ads and banners" => "Site ads and banners",
// "Apply changes" => "Apply changes",
// "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>" => "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>",
// "List of articles" => "List of articles",
// "List of article types" => "List of article types",
"Article Types" => "Aina ya makala",
// "List of article topics" => "List of article topics",
"General Settings" => "Mipangilio ya Jumla",
"Features" => "Vipengele",
// "Custom (Article Own) images setting" => "Custom (Article Own) images setting",
"Sharing on social networks" => "Kushiriki katika mitandao ya kijamii",
"Import CSV file" => "Ingiza faili ya CSV",
"Batch upload (CSV file)" => " Pakia kipande (faili ya CSV)",
"File format: title,authorName,heading,body,lang,user" => "Format du fichier : titre,NomAuteur,en-tête,corps,langue,utilisateur",
// "Articles Listing and View" => "Articles Listing and View",
"List articles" => "Orodha ya makala",
// "Article view" => "Article view",
// "Blogs listing" => "Blogs listing",
"Blogs Listings" => "Orodha ya Blogu",
// "Items to display" => "Items to display",
// "Calendars listing" => "Calendars listing",
"General settings" => "Mipangilio ya jumla",
// "Categories listing" => "Categories listing",
// "Browse Categories" => "Browse Categories",
// "Administer Categories" => "Administer Categories",
// "Organize objects" => "Organize objects",
"Organize Objects" => "Panga vitu",
"Category objects" => "Vitu katika kikundi",
// "Re-apply last saved category defaults to wiki pages" => "Re-apply last saved category defaults to wiki pages",
"Performance" => "Utendaji",
// "Comments listing" => "Comments listing",
"Site-wide features" => "Vipengele vyote vya tovuti",
"Display options" => "Machaguo ya onyesho",
"Annotations" => "Maelezo",
"Using comments in various features" => "Kutumia maoni katika vipengele mbalimbali",
// "Group Administration" => "Group Administration",
// "User Administration" => "User Administration",
// "Community Features" => "Community Features",
"Community" => "Jamii",
// "Additional options" => "Additional options",
// "Social Interaction" => "Social Interaction",
// "Friendship and followers" => "Friendship and followers",
"Select which items to display when listing users" => "Chagua maelezo ya mtumiaji kuonyesha wakati wa orodha",
// "Activity stream" => "Activity stream",
"Tiki Connect" => "Tiki Connect",
"Join the community!" => "Jiunge na jumuiya!",
"Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU." => "Tiki Wiki CMS Groupware ni huru na wazi chanzo programu (FOSS). Ni mradi wa habari inayotokana na jamii ambayo ipo na inaboresha shukrani kwa ushiriki wa watu kama WEWE tu.",
"Join the Community" => "Jiunge na jumuiya",
"Tiki news" => "Habari ya tiki",
"Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Pachikwa RSS kutoka info.tiki.org TODO, wakati huo huo",
"Tiki Newsletter" => "Jarida la tiki",
"Promote your site" => "Kukuza tovuti yako",
"Add your site to the Tiki directory." => "Ongeza tovuti yako ya saraka ya Tiki.",
"Submit your site" => "Tuma tovuti yako",
"Spread the word" => "Kueneza neno",
"Add the \"Powered by\" module to your site. " => "Ongeza \"Powered by\" moduli kwa tovuti yako.",
"Manage Modules" => "Dhibiti moduli",
"Help improve Tiki" => "Kusaidia kuboresha Tiki",
"Submit a feature request or bug report." => "Tuma ombi la kipengele au ripoti ya mdudu.",
"Visit Tiki development site" => "Tembelea tovuti ya maendeleo ya Tiki",
"Make a financial contribution to the Tiki Association" => "Fanya mchango wa kifedha kwa chama cha Tiki",
"Contribute to Tiki" => "Contribuer à Tiki",
"New Feature" => "Kipengele kipya",
"Please note: Experimental - work in progress" => "Tafadhali kumbuka: Uchunguzi - kazi inaendelea",
"Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)." => "Tiki Connect ni njia ya kuruhusu mradi wa Tiki kujua jinsi unatumiwa, na ni sehemu gani ambazo watu hupenda au wangependa kurekebisha (au kuelezea).",
"Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected." => "Mara moja kuwezeshwa, unapobofya '<strong>Tuma Taarifa</strong>' kitufe hapa chini unaweza wataunganishwa na ya <em>mother.tiki.org</em>, ambayo ni wapi data itakusanywa.",
"You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)." => "Unaweza pia kutuma maoni kuhusu Tiki kwa kukagua kikasha hakikishi 'Maoni' (mara Tiki kuunganisha umewezeshwa, karibu na bar ya 'Upendeleo Vichujio' hapo juu).",
"Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'" => "Icons itaonekana karibu na mapendekezo yote ambapo unaweza 'kupenda', uomba 'kurekebisha' au uulize 'ni nini hii?'",
"Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)" => "Vipengee vyako vinatumwa unapounganisha na mother.tiki.org (kwa sasa tu kwa kubonyeza '<strong>Send Info</strong>')",
"Send Info" => "Tuma Taarifa",
// "Send the data" => "Send the data",
"Preview info" => "Angalia maelezo",
// "See what is going to be sent" => "See what is going to be sent",
"Fill form" => "Kujaza fomu",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
"Advanced settings" => "Mipangilio ya juu",
"Exposed to assist testing and development" => "Imeonyeshwa ili kusaidia kupima na maendeleo",
// "Connections Received" => "Connections Received",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Jitsi" => "Jitsi",
"Provision URL" => "URL ya utoaji",
// "Allows a copyright to be determined for various objects" => "Allows a copyright to be determined for various objects",
// "Directories listing" => "Directories listing",
// "Extention package error" => "Extention package error",
// "Cannot show page because the extension package is not installed or activated" => "Cannot show page because the extension package is not installed or activated",
// "Extension package admin template page is missing" => "Extension package admin template page is missing",
// "FAQ listing" => "FAQ listing",
"Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Tafadhali angalia <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>tathmini ya kila kipengele</a> kwenye tovuti ya msanidi wa Tiki.",
"Global features" => "Vipengele ya jumla",
"Main features" => "Vipengele vikuu",
"Secondary features" => "Vipengele vya sekondari",
"Administrative features" => "Vipengele vya utawala",
"Watches" => "Ufuatiliaji",
"Additional features" => "Vipengele vingine",
"Payment and Accounting" => "Malipo na Uhasibu",
"Mail and Sharing" => "Barua na Kushiriki",
"Interaction with online services or other software" => "Ushirikiano na huduma za mtandaoni au programu nyingine",
"Configuration completed" => "Configuration achevée",
"Authenticate with Zotero" => "Authentifier avec Zotero",
"Interface" => "Interface",
"jQuery plugins and add-ons" => "Plugins na ugani ya jQuery",
"Programmer" => "Msanidi programu",
"Logging and Reporting" => "Magazeti na Ripoti",
"Visible to admin only" => "Inaonekana tu kwa admins",
"Include Smarty notices" => "Jumuisha matangazo ya Smarty",
"Custom Code" => "Msimbo maalum",
"To create or remove file galleries, select" => "Kuunda au kuondoa nyumba za faili, chagua",
"from the application menu" => "dans le menu des applications",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Ukiamua kuhifadhi faili katika saraka lazima uhakikishe kwamba watumiaji hawawezi kufikia saraka moja kwa moja.",
// "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Ili kusanidi njia ya saraka, tumia syntax ya Umoja wa Mataifa, kwa mfano: files / au c: / foo / files au / www / files /",
// "File galleries listing" => "File galleries listing",
"Move files from database to directory" => "Hamisha faili kutoka kwa databana hadi kwenye mfumo wa faili",
"Move files from directory to database" => "Hamisha faili kutoka kwa mfumo wa faili kwenye databana",
"Manage comment settings" => "Inasanidi maoni",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
"Upload Regex" => "Pakua template",
// "Settings for Media Alchemyst" => "Settings for Media Alchemyst",
// "Settings for Diagrams" => "Settings for Diagrams",
// "Listings" => "Listings",
// "Configuration for gallery listings" => "Configuration for gallery listings",
"Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Kutumia mabadiliko haya <em> haitaathiri </ em> nyumba zilizopo. Wao huathiri tu nyumba mpya",
// "Admin Listings" => "Admin Listings",
// "Configuration for gallery administration listings" => "Configuration for gallery administration listings",
"Search Indexing" => "Utafutaji uliowekwa",
"Handlers" => "mameneja",
"Add custom handlers to make your files &quot;searchable&quot; content" => "Ongeza mameneja wa desturi kufanya faili zako 'kutafutwa' na maudhui",
"Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Tumia% 1 kutaja jina la faili la ndani katika amri (mfano: \"masharti% 1 \" kubadilisha faili kwa maandishi kwa kutumia amri za UNIX)",
"To delete a handler, leave the <strong>System Command</strong> field blank" => "Ili kuondoa meneja, fungua <amri> amri ya mfumo </ strong> tupu",
"Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki imeandaliwa kabla ya kushughulikia aina nyingi. Ikiwa moja ya haya yameorodheshwa, huduma haipatikani",
"Missing Handlers" => "Wafanyabiashara wasiopotea",
// "Mime Types" => "Mime Types",
// "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly" => "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly",
// "Fix vnd.ms-* mime type files" => "Fix vnd.ms-* mime type files",
"MIME Type" => "Aina ya Mime",
"System Command" => "Amri ya mfumo",
"Reindex all files for search" => "Rejesha tena faili zote za utafutaji",
// "Enhancements" => "Enhancements",
// "H5P Info" => "H5P Info",
// "Service URL to purge unused libraries can be found here. Can be used in a cron task" => "Service URL to purge unused libraries can be found here. Can be used in a cron task",
// "SCORM" => "SCORM",
// "OCR Indexing" => "OCR Indexing",
// "Forums listing" => "Forums listing",
// "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums" => "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums",
"Threads" => "Threads",
"Searches" => "utafiti",
// "Forum Listing" => "Forum Listing",
// "Tags listing" => "Tags listing",
// "Browse Tags" => "Browse Tags",
"Translate tags" => "Tafsiri maneno muhimu",
// "Translate Tags" => "Translate Tags",
// "Remove tags not applied to any objects" => "Remove tags not applied to any objects",
// "Clean Up Unused Tags" => "Clean Up Unused Tags",
"Random tag cloud colors:" => "Rangi ya maneno ya wingu kwa nasibu waliochaguliwa:",
"Separate colors with a comma (,)" => "Tofauti na rangi na comma (,)",
"Alphanumeric ASCII characters only" => "Wahusika wa ASCII alphanumeric tu",
"No accents or special characters" => "Hakuna vibali au wahusika maalum",
"Accept all characters" => "Kukubali wahusika wote",
// "Tag search page" => "Tag search page",
// "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Kuunda / kufuta nyumba ya sanaa ya picha, nenda kwenye \"Picha Galleries \" katika orodha ya programu, au",
"Click Here" => "Bofya hapa",
"You can upload images of a size of " => "Unaweza kutuma picha za ukubwa wa",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Badilisha vigezo katika php.ini: file_uploads, upload_max_filesize, post_max_size na vigezo vya database (max_allowed_packet kwa mysql) ili kubadilisha thamani hii",
"Galleries features" => "Vipengele vya sanaa",
"Gallery listing configuration" => "Inasanidi Maonyesho ya Nyumba ya sanaa",
"Comments settings" => "Mipangilio ya maoni",
// "Manage images" => "Manage images",
// "Remove unused images" => "Remove unused images",
// "Remove unused images in the system gallery" => "Remove unused images in the system gallery",
// "Remove images not being used in wiki pages, articles or blog posts" => "Remove images not being used in wiki pages, articles or blog posts",
"Move images from database storage to filesystem storage" => "Hamisha picha kutoka database hadi mfumo wa faili",
"Move images from filesystem storage to database storage" => "Hamisha picha kutoka kwa mfumo wa faili kwenye databana",
// "Move images" => "Move images",
"All galleries" => "Nyumba zote",
"System Gallery" => "Mfumo wa Mfumo",
"Reset or upgrade your database" => "Réinitialiser ou mettre à jour votre base de données",
// "Create and edit menus" => "Create and edit menus",
// "Server Fitness" => "Server Fitness",
// "Check if your server meets the requirements for running Tiki" => "Check if your server meets the requirements for running Tiki",
// "Check for Updates Now" => "Check for Updates Now",
// "Check if a new Tiki version is available" => "Check if a new Tiki version is available",
"General Preferences" => "Mapendekezo ya jumla",
"Release check" => "Angalia kutolewa",
"Tiki version" => "Toleo ya Tiki",
"Last update from SVN" => "Sasisho la mwisho kutoka kwa SVN",
"Site identity" => "Kitambulisho cha Site",
"Themes" => "Mandhari",
// "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences" => "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences",
"These values will be stored in plain text in the database" => "Maadili haya yatahifadhiwa kwenye maandishi wazi kwenye databana",
"Email to send a test mail" => " Barua pepe ili kutuma  mtihani ",
// "Logging and reporting" => "Logging and reporting",
// "Web Cron" => "Web Cron",
// "Call Web Cron URL" => "Call Web Cron URL",
// "Scheduler Settings" => "Scheduler Settings",
"Server" => "Serveur",
"Sessions" => "Vikao",
// "Advanced configuration" => "Advanced configuration",
"Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Kushika vikao vya database ni chaguo cha juu cha utawala na ni kwa watendaji wenye upatikanaji kamili na uelewa wa database ili kushughulikia masuala yanayoweza",
"Changing this feature will immediately log you out when you save this preference" => "Kubadilisha kipengele hiki kitakuondoa mara baada ya usajili",
"Enable now" => "Activisha sasa",
"Contact" => "Wasiliana",
// "Terms and conditions" => "Terms and conditions",
// "Home page" => "Home page",
"Redirects" => "maelekezo",
// "Site access" => "Site access",
// "Test site closed message" => "Test site closed message",
// "The namespace separator should not" => "The namespace separator should not",
// "contain any of the characters not allowed in wiki page names, typically" => "contain any of the characters not allowed in wiki page names, typically",
// "conflict with wiki syntax tagging" => "conflict with wiki syntax tagging",
// "To use :: as a separator, you should also use ::: as the wiki center tag syntax" => "To use :: as a separator, you should also use ::: as the wiki center tag syntax",
// "Note: a conversion of :: to ::: for existing pages must be done manually" => "Note: a conversion of :: to ::: for existing pages must be done manually",
// "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
// "php.net" => "php.net",
"Date and Time Format Help" => "Msaada kwenye muundo wa tarehe na nyakati",
// "Time zone and format" => "Time zone and format",
// "Date/time selectors" => "Date/time selectors",
// "Manage customized local string translations" => "Manage customized local string translations",
// "Upload a file with translations for the selected language" => "Upload a file with translations for the selected language",
"Edit languages" => "Hariri lugha",
// "Intertiki Client" => "Intertiki Client",
// "Set up this Tiki site as the Intertiki client" => "Set up this Tiki site as the Intertiki client",
// "Client server settings" => "Client server settings",
// "Currently linked master server" => "Currently linked master server",
// "Add an available master server" => "Add an available master server",
// "The InterTiki Server fields are for defining for every master server you want to have access to from this client" => "The InterTiki Server fields are for defining for every master server you want to have access to from this client",
// "Server name" => "Server name",
// "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value" => "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value",
// "Server host" => "Server host",
// "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above" => "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above",
// "Server port" => "Server port",
// "The port number the master tiki responds to HTTP on (usually 80)" => "The port number the master tiki responds to HTTP on (usually 80)",
// "Server path" => "Server path",
// "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field" => "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field",
// "Server groups" => "Server groups",
// "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)" => "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)",
// "Available master Tiki servers" => "Available master Tiki servers",
// "Delete master server" => "Delete master server",
// "Intertiki Master Server" => "Intertiki Master Server",
// "Set up this Tiki site as the InterTiki master server" => "Set up this Tiki site as the InterTiki master server",
// "Master server settings" => "Master server settings",
// "Allowed client servers" => "Allowed client servers",
// "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)" => "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)",
// "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key" => "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key",
"IP" => "I.P.",
// "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1" => "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1",
// "Username of primary contact on client machine. Useful for adminstration" => "Username of primary contact on client machine. Useful for adminstration",
// "Can register" => "Can register",
// "To change the host key you need to remove and add it as a new one" => "To change the host key you need to remove and add it as a new one",
"New" => "Mpya",
"Enable/disable Tiki features in " => "Wezesha / afya vipengele vya Tiki",
", but configure them elsewhere" => ", lakini sanidi mahali pengine",
// "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})" => "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})",
// "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples" => "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples",
"Registration" => "Usajili",
"Log in" => "Uhusiano",
"Generate a passcode" => "Tengeneza msimbo wa usajili",
"Requires PHP GD library" => "Inahitaji maktaba ya PHP GD",
// "Group and tracker login settings" => "Group and tracker login settings",
"Users can select a group to join at registration" => "Watumiaji wanaweza kuchagua kikundi kujiunga na usajili",
"By default, new users automatically join the Registered group" => "Kwa default, watumiaji wapya hujiunga na kikundi cha usajili",
"Other login settings" => "Mipangilio mengine ya kuingia",
"Cookie consent" => "Ruhusa ya vidakuzi",
"Assign users to groups by matching email patterns" => "Ongeza watumiaji kwa makundi kwa kupatanisha mifumo ya barua pepe",
"An email pattern must be defined in the settings for at least one group for this to produce any results." => "Mfumo wa barua pepe unapaswa kuelezwa katika mipangilio ya angalau kundi moja ili kuzalisha matokeo yoyote.",
// "Remote Tiki Autologin" => "Remote Tiki Autologin",
// "You must install PHP extension LDAP" => "You must install PHP extension LDAP",
"You must change the Authentication Method to LDAP for these changes to take effect" => "Lazima ubadilishe Njia ya Uthibitisho kwa LDAP kwa mabadiliko haya yanayotumika",
// "LDAP bind settings" => "LDAP bind settings",
// "LDAP user" => "LDAP user",
// "LDAP admin" => "LDAP admin",
"LDAP external groups" => "Makundi ya nje ya LDAP",
// "LDAP group" => "LDAP group",
// "LDAP group member - if group membership can be found in group attributes" => "LDAP group member - if group membership can be found in group attributes",
// "LDAP user group - if group membership can be found in user attributes" => "LDAP user group - if group membership can be found in user attributes",
"PAM" => "PAM",
"You must change the Authentication Method to PAM for these changes to take effect" => "Lazima ubadilishe Njia ya Uthibitishaji kwa PAM kwa mabadiliko haya yanayotumika",
"Shibboleth Authentication " => " Authentification Shibboleth ",
"You must change the Authentication Method to Shibboleth for these changes to take effect" => "Lazima ubadilishe Njia ya Uthibitishaji kwa Shibboleth kwa mabadiliko haya yanayotumika",
// "SAML2" => "SAML2",
// "based on Onelogin's php-saml " => "based on Onelogin's php-saml ",
// "You must change the Authentication Method to SAML for these changes to take effect" => "You must change the Authentication Method to SAML for these changes to take effect",
"Identity provider settings" => "Mipangilio ya mtoa utambulisho",
"Attribute mapping" => "Kuuanganisha thamani",
"Group mapping" => "Kuuanganisha kundi",
"CAS" => "HKK",
"CAS (central authentication service)" => "HKK (huduma kuu ya kuthibitisha)",
"You must change the Authentication Method to CAS for these changes to take effect" => "Lazima ubadilishe Njia ya Uthibitishaji kwa HKK kwa mabadiliko haya yatakayoanza",
"CAS server" => "Seva la HKK",
"CAS Server Name" => "Jina la seva HKK",
"CAS Server Port" => "Bandari ya seva HKK",
"CAS Server Path" => "Njia ya seva HKK",
"phpBB User Database Authentication " => "Authentification utilisateur base de données phpBB ",
"You must change the Authentication Method to phpBB for these changes to take effect" => "Lazima ubadilishe Njia ya Uthibitishaji kwa phpBB kwa mabadiliko haya yatachukua",
"You must turn Users can register off for phpBB Authentication to function properly" => "Vous devez désactiver 'Les utilisateurs peuvent s'enregistrer' pour que l'authentification phpBB fonctionne correctement",
"MySql only (for now)" => "MySql tu (kwa sasa)",
"Web server" => "Mtandao wa Wavuti",
"Web Server Authentication " => "Authentification du serveur Web ",
"You must change the Authentication Method to Web Server for these changes to take effect" => "Lazima ubadili Njia ya Uthibitisho kwa Mtandao wa Wavuti kwa mabadiliko haya yanayotumika",
"Password Blacklist" => "Orodha ya ufuatiliaji ya nenosiri",
"Password blacklist tools" => "Chombo cha orodha ya ufuatiliaji ya nenosiri",
// "Upload Word List for Processing" => "Upload Word List for Processing",
// "Words currently indexed" => "Words currently indexed",
// "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below" => "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below",
// "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file" => "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file",
// "Use 'LOAD DATA INFILE'" => "Use 'LOAD DATA INFILE'",
// "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions" => "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions",
// "Create or Replace Word Index" => "Create or Replace Word Index",
// "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first" => "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first",
// "Delete Temporary Index" => "Delete Temporary Index",
// "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete" => "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete",
// "Blacklist Currently Using" => "Blacklist Currently Using",
// "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future" => "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future",
// "Number of passwords (limit)" => "Number of passwords (limit)",
// "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396" => "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396",
// "Minimum Password Length" => "Minimum Password Length",
// "The minimum password length for your password. This will filter out any password that has an illegal length" => "The minimum password length for your password. This will filter out any password that has an illegal length",
// "Require Numbers &amp; Letters" => "Require Numbers &amp; Letters",
// "If checked, will filter out any password that does not have both upper and lower case letters" => "If checked, will filter out any password that does not have both upper and lower case letters",
// "Require Special Characters" => "Require Special Characters",
// "If checked, will filter out any passwords that do not have special characters" => "If checked, will filter out any passwords that do not have special characters",
// "Save & Set as Default" => "Save & Set as Default",
// "View Password List" => "View Password List",
// "OAuth Server Settings" => "OAuth Server Settings",
// "Main theme" => "Main theme",
"Theme Screenshot" => "Mchapishaji maelezo",
// "Theme Preferences" => "Theme Preferences",
// "{{\$theme|escape|ucfirst}}" => "{{\$theme|escape|ucfirst}}",
// "No theme preferences found" => "No theme preferences found",
// "General layout" => "General layout",
// "Admin pages layout" => "Admin pages layout",
// "Admin theme must be selected first" => "Admin theme must be selected first",
// "Fixed vs full width layout" => "Fixed vs full width layout",
"Logo and Title" => "Alama na Kichwa",
"Module zone visibility" => "Uonekano wa eneo la moduli",
"Site report bar" => "Ripoti ya bar ya tovuti",
// "Limits" => "Limits",
"UI Effects" => "Madhara za UI",
"Standard UI effects" => "Madhara ya UI ya kawaida",
"Tab UI effects" => "Tabo za Madhara",
"Customization" => "Kubinafsisha",
"Custom codes" => "Tengeneza code",
"Editing" => "Uhariri",
"View Templates" => "Tazama Matukio",
"Edit Templates" => "Badilisha Matukio",
"Miscellaneous" => "Kumba",
// "Responsive images" => "Responsive images",
"Context menus" => "Orodha ya muktadha",
"currently used in file galleries only" => "hivi sasa hutumiwa kwenye galleries ya picha tu.",
"Separators" => "Wasambazaji",
// "Smarty templates (TPL files)" => "Smarty templates (TPL files)",
"Defaults" => "Defauts",
"See also" => "Ona pia",
"Search Engine Friendly URLs" => "URL za fupi",
"Also" => "Pia",
"here" => "hapa",
"for more information on geo tagging." => "kwa maelezo zaidi kuhusu \"geo tagging.\"",
"Meta tags" => "Lebo za Meta",
// "Geo Metatags" => "Geo Metatags",
"Robots" => "Robots",
"&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site." => "&quot;Moduli&quot; ni vipengee vya maudhui chini ya juu na katika kulia kushoto safuwima ya tovuti. de gauche du site.",
"Admin &gt; Modules" => "Usimamizi > Moduli",
"from the menu to create and edit modules" => "kutoka kwenye menyu ya kuunda na kuhariri moduli",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
"Hint" => "Kidokezo",
"If you lose your login module, use tiki-login_scr.php to be able to login!" => "Ikiwa unapoteza moduli yako ya kuingilia, tumia tiki-login_scr.php ili uweze kuingia!",
// "Composer not found" => "Composer not found",
// "Composer could not be executed, so the automated check on the packages cannot be performed" => "Composer could not be executed, so the automated check on the packages cannot be performed",
// "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer" => "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer",
// "Result of executing the changes to the packages" => "Result of executing the changes to the packages",
// "Composer errors" => "Composer errors",
// "Composer returned some errors" => "Composer returned some errors",
// "Issues with composer environment" => "Issues with composer environment",
// "Run %0 from a shell to try to fix this, see %1 for more info" => "Run %0 from a shell to try to fix this, see %1 for more info",
"Packages" => " Packages",
// "Packages check could not be performed at the moment due to missing" => "Packages check could not be performed at the moment due to missing",
// "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow" => "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow",
// "Installed Packages" => "Installed Packages",
// "Status of the packages registered in the composer.json file" => "Status of the packages registered in the composer.json file",
// "Version Required" => "Version Required",
// "Version Installed" => "Version Installed",
// "Installed" => "Installed",
// "Missing" => "Missing",
// "Enable extension" => "Enable extension",
// "Update extension" => "Update extension",
// "Disable extension" => "Disable extension",
// "Removal not available" => "Removal not available",
// "This package is not managed by Tiki and likely was installed manually" => "This package is not managed by Tiki and likely was installed manually",
// "One or more packages appear to be missing" => "One or more packages appear to be missing",
// "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed" => "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed",
// "Could not validate the status of one or more packages" => "Could not validate the status of one or more packages",
// "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually" => "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually",
// "Install packages from the administrator interface" => "Install packages from the administrator interface",
// "The administrator interface can be used to install the packages marked as missing in the list above" => "The administrator interface can be used to install the packages marked as missing in the list above",
// "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them" => "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them",
// "Fix Missing Packages" => "Fix Missing Packages",
// "Install packages manually" => "Install packages manually",
// "Make sure <code>composer</code> is installed" => "Make sure <code>composer</code> is installed",
// "Composer can be installed manually, in the host machine, by following the instructions from the" => "Composer can be installed manually, in the host machine, by following the instructions from the",
// "website" => "website",
// "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>" => "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>",
// "Below is an example of how to do this in a Linux-like operating system" => "Below is an example of how to do this in a Linux-like operating system",
// "Install the missing packages" => "Install the missing packages",
// "You can install the missing packages by issuing the command" => "You can install the missing packages by issuing the command",
// "Available Packages" => "Available Packages",
// "These packages have been identified as required by one or more features" => "These packages have been identified as required by one or more features",
// "Licence" => "Licence",
// "Required by" => "Required by",
// "Not Available" => "Not Available",
"Install" => "Install",
// "There appear to be some optional packages that can be installed" => "There appear to be some optional packages that can be installed",
// "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package" => "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package",
// "The administrator interface can be used to install the optional packages in the list above" => "The administrator interface can be used to install the optional packages in the list above",
// "Click the \"Install Package\" button, and Tiki will try to install them" => "Click the \"Install Package\" button, and Tiki will try to install them",
// "Make sure there is a <code>composer.json</code> file in the root of the website" => "Make sure there is a <code>composer.json</code> file in the root of the website",
// "If there is not already a <code>composer.json</code> file, then create one" => "If there is not already a <code>composer.json</code> file, then create one",
// "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point" => "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point",
// "Install the package" => "Install the package",
// "Packages can be installed by issuing a command" => "Packages can be installed by issuing a command",
// "for each package that is to be installed" => "for each package that is to be installed",
// "Packages Custom" => "Packages Custom",
// "There are no manual managed packages installed in the folder vendor_custom" => "There are no manual managed packages installed in the folder vendor_custom",
// "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages" => "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages",
// "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab" => "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab",
// "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>" => "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>",
// "For information only" => "For information only",
// "These packages are managed manually and displayed here for informational purposes" => "These packages are managed manually and displayed here for informational purposes",
// "Packages Bundled" => "Packages Bundled",
// "These packages are bundled with Tiki, and displayed here for informational purposes" => "These packages are bundled with Tiki, and displayed here for informational purposes",
// "Composer Packages Bundled" => "Composer Packages Bundled",
// "status of the packages registered in the vendor_bundled/composer.json file" => "status of the packages registered in the vendor_bundled/composer.json file",
// "Diagnose" => "Diagnose",
// "Diagnose Composer Installation" => "Diagnose Composer Installation",
// "Use the button below to test your composer installation" => "Use the button below to test your composer installation",
// "Diagnose Composer" => "Diagnose Composer",
// "Composer management" => "Composer management",
// "Install Composer" => "Install Composer",
// "Update Composer" => "Update Composer",
// "Remove composer.lock" => "Remove composer.lock",
// "Clean vendor folder" => "Clean vendor folder",
// "{\$diagnostic_composer_location}" => "{\$diagnostic_composer_location}",
// "Extensions Preferences" => "Extensions Preferences",
// "Activate Extension Package" => "Activate Extension Package",
// "Extension Package Groups API" => "Extension Package Groups API",
"Payments" => "Malipo",
"Choose payment system" => "Chagua mfumo wa malipo",
"You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "Unaweza kutumia njia moja tu ya malipo: PayPal au Cclite au Tiki User Credits",
"PayPal is working at the moment. See PayPal.com" => "PayPal inafanya kazi kwa wakati huu. Angalia PayPal.com",
"Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Uhasibu wa fedha za jumuiya kwa mifumo ya biashara ya kubadilishana (LETS). Angalia",
// "sourceforge.net" => "sourceforge.net",
"Tiki User Credits: Requires this other feature to be configured" => "Credits ya Mtumiaji wa Tiki: Inahitaji kipengele hiki kimeundwa",
// "Israel Post payment module" => "Israel Post payment module",
"Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite ni kwa ajili ya kujenga na kusimamia fedha mbadala au za ziada za biashara na makundi",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
"Advanced Shopping Cart" => "Duka la ununuzi wa juu",
// "Cart settings" => "Cart settings",
// "Advanced cart tracker names setup" => "Advanced cart tracker names setup",
// "Products tracker setup" => "Products tracker setup",
"Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Kulingana na kipengele gani unachotumia, unaweza kuhitaji baadhi au mashamba yote ya kuanzisha",
// "Shipping" => "Shipping",
"Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site." => "Tafadhali angalia <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Ukurasa wa utendaji</a> kwenye tovuti ya developer ya Tiki.",
"Output compression is active" => "Upunguzaji wa Pato ni kazi",
"Compression is handled by" => "Ukandamizaji unashughulikiwa na",
"PHP settings" => "Mipangilio ya PHP",
"Some PHP.INI settings that can increase performance" => "Mipangilio ya PHP.INI ambayo inaweza kuongeza utendaji",
"'realpath_cache_size setting': %0" => "'realpath_cache_size setting': 4096K",
"(percentage used %0 %" => "(asilimia kutumika %0%",
// "Determines the size of the realpath cache to be used by PHP" => "Determines the size of the realpath cache to be used by PHP",
"'realpath_cache_ttl setting': %0 seconds" => "'realpath_cache_ttl setting': 120 sekunde",
// "Duration of time (in seconds) for which to cache realpath information for a given file or directory" => "Duration of time (in seconds) for which to cache realpath information for a given file or directory",
"Bytecode Cache" => "Cache ya Bytecode",
"Using <strong>%0</strong>. These stats affect all PHP applications running on the server." => "Kutumia <strong>%0</strong>. Ajabu haya kuathiri programu zote za PHP kwenye seva.",
"Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Chaguo la usanidi <em> xcache.admin.enable_auth </ em> linazuia upatikanaji wa takwimu. Hii pia kuzuia cache kutoka upya tena wakati wa kuweka upya templates",
"Memory Used" => "Kumbukumbu Inatumika",
"Cache Hits" => "Fikia kwenye cache",
"Misses" => "Inapotea",
"Few hits recorded. Statistics may not be representative" => "Ufikiaji machache wa kumbukumbu iliyohifadhiwa, takwimu haziwezi kuwa mwakilishi",
"Low hit ratio. %0 may be misconfigured and not used" => "Uwiano wa kufikia cache ni wa chini. % 0 inaweza kuwa haijasimamishwa au walemavu",
"Little memory available. Thrashing likely to occur" => "Kumbukumbu machache inapatikana. Kuondolewa kwa haraka kwa cache kunawezekana kutokea",
// "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)" => "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)",
"Small amount of memory allocated to %0. Verify the configuration" => "Kumbukumbu chache ni zilizotengwa kwa% 0. Angalia usanidi wake",
"Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration ya <em>% 0 </ em> inafanya kazi. Kuleta mabadiliko ya hundi inaweza kuboresha utendaji, lakini itakuwa muhimu kufuta caches manually wakati uppdatering files",
"<em>%0</em> should not be disabled due to authentication on XCache" => "<em>% 0 </ em> haipaswi kuzima kwa sababu ya uthibitisho",
// "Clear all APC caches" => "Clear all APC caches",
// "Clear APC caches" => "Clear APC caches",
// "Clear Caches" => "Clear Caches",
// "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments",
"Major Slowdown" => "Kushuka kubwa",
"Major slowdown" => "Kushuka kubwa",
"These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "Hizi zinaripotiwa kupunguza kasi Tiki. Ikiwa una tovuti yenye kiasi kikubwa, unataka kuwazuia",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>",
"Time and Memory Limits" => "Wakati na mipaka ya kumbukumbu",
// "PDF settings" => "PDF settings",
// "Wiki print version" => "Wiki print version",
// "Other features" => "Other features",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
"Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Baadhi ya vituo vya wasifu wako hawajibu. Hii inaweza kuzuia maelezo fulani yasiyotumika",
"Find profiles" => "Pata wasifu",
"Search by name, types and repository" => "Tafuta kwa jina, aina na hifadhi",
// "Profile types" => "Profile types",
"Profile repository" => "Hifadhi ya wasifu",
"Suggested Profiles" => "Wasifu zilizopendekezwa",
"Featured Site Profiles" => "Wasifu ya tovuti iliyojulikana",
"Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started." => "Wasifu ya tovuti iliyojulikana ni orodha ya maombi ambayo huhifadhiwa na jamii ya Tiki na ni njia nzuri ya kuanza.",
"Full Profiles" => "Wasifu kamili",
"Full Profiles are full featured out of the box solutions." => "Wasifu kamili imejaa nje ya ufumbuzi wa sanduku.",
"Mini Profiles" => "Wasifu ya kidogo",
"Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration." => "Wasifu ya kidogo zitasanidi vipengele maalum na ni njia nzuri ya kuongeza utendaji zaidi kwa usanidi uliopo.",
"Learning Profiles" => "Wasifu za Kujifunza",
"Learning Profiles will allow you to quickly evaluate specific features in Tiki." => "Wasifu za Kujifunza zitakuwezesha kupima haraka vipengele maalum katika Tiki.",
// "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>" => "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>",
"Repository" => "hifadhi",
// "Profile type" => "Profile type",
// "See profile info below (may take a few seconds to load)" => "See profile info below (may take a few seconds to load)",
"applied" => "appliquer",
"JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "Javascript inapaswa kuweka <b> ON </ b> ili kuomba Profaili. Tafadhali ingiza Javascript na jaribu tena baadaye",
"Export YAML" => "Tuma kwa YAML",
"Export modified preferences as YAML" => "Tuma mapendekezo yaliyobadilishwa kama YAML",
"Toggle Visible" => "Chaguo inayoonekana",
"Show added preferences" => "Onyesha mapendekezo yaliyoongezwa",
"no default" => "pas de valeur par défaut",
"Repository status" => "Hali ya hifadhi",
"status of the registered profile repositories" => "hali ya hifadhi za wasifu zilizosajiliwa",
"Refresh" => "Furahisha",
"Profile tester" => "Mtazamaji wa wasifu",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
"This will run the profile and make potentially unrecoverable changes in your database!" => "Hii itaendesha wasifu na kutengeneza uwezekano wa mabadiliko yasiyo na upatikanaji katika database yako!",
"Test profile name" => "Jina la Mtazamaji wa wasifu",
// "Permission added" => "Permission added",
// "User added" => "User added",
// "User modified" => "User modified",
// "Group added" => "Group added",
// "old value" => "old value",
// "Installer added" => "Installer added",
// "Profile without changes" => "Profile without changes",
"Global configuration" => "Configuration ya Global",
// "This preference needs to be disabled" => "This preference needs to be disabled",
// "Enabling ratings for forums" => "Enabling ratings for forums",
// "You need to" => "You need to",
// "Create or edit a forum and enable" => "Create or edit a forum and enable",
"Posts can be rated" => "Machapisho yanaweza kutambuliwa",
// "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user" => "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Set the rating options at" => "Set the rating options at",
"Ratings" => "quotes",
// "see above" => "see above",
// "Permissions involved" => "Permissions involved",
// "tiki" => "tiki",
// "Default Options" => "Default Options",
"Cache duration" => "Muda wa Cache",
"Create new" => "Créer une nouvelle",
"Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds" => "Tumia ukurasa huu ili usanidi feeds zinazozalishwa na Tiki. Ili kuunganisha ugavi kutoka kwenye maeneo mengine, tumia <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}Feeds ya Nje",
"Feeds" => "mtiririko",
"Feed for articles" => "Njia za ushirikiano za makala",
"Feed for blogs" => "Chakula kwa blogu",
"Feed for individual blogs" => "Chakula binafsi kwa blogu",
"Feed for image galleries" => "Ushirikiano wa kituo cha picha za picha",
// "Feed for individual image galleries" => "Feed for individual image galleries",
"Feed for file galleries" => "Njia za uunganisho wa nyumba za faili",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "with diff" => "with diff",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "no diff" => "no diff",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
// "Feed for directories" => "Feed for directories",
"Feed for shoutbox" => "Megaphone inapita",
"Incoming Feeds" => "Feeds zinazoingia",
"You can see users rank by score in the module users_rank, for that go to" => "Unaweza kuona cheo cha watumiaji katika moduli ya watumiaji_rank, kwa kuwa huenda",
"Admin modules" => "Dhibiti modules",
// "Cause scores older than a certain number of days to expire" => "Cause scores older than a certain number of days to expire",
// "Scoring rules" => "Scoring rules",
// "Unique rule ID" => "Unique rule ID",
// "Rule" => "Rule",
// "A label or ID to help identify which event was triggered to get points" => "A label or ID to help identify which event was triggered to get points",
// "Pts recipient type" => "Pts recipient type",
// "Recipient Type" => "Recipient Type",
// "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event" => "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event",
// "Pts recipient" => "Pts recipient",
// "The ID of the points recipient" => "The ID of the points recipient",
// "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered" => "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered",
// "Points Given" => "Points Given",
// "This is the numerical value of the points being given" => "This is the numerical value of the points being given",
// "Triggering event" => "Triggering event",
// "Reversal event" => "Reversal event",
// "Valid Triggering Object IDs" => "Valid Triggering Object IDs",
// "Valid Object Ids" => "Valid Object Ids",
// "This is a comma-separated list of object ids for which the event is valid" => "This is a comma-separated list of object ids for which the event is valid",
// "Min. Time Between Scoring" => "Min. Time Between Scoring",
// "Time between scoring" => "Time between scoring",
// "This is the amount of time in seconds that a user must wait before again being able to get points for this event" => "This is the amount of time in seconds that a user must wait before again being able to get points for this event",
"can be seen on page" => "inaweza kuonekana kwenye ukurasa",
"in Admin menu" => "katika orodha ya Msimamizi",
"Also see the Search Indexing tab:" => "Pia angalia kichupo cha kielezo utafutaji:",
"File Gallery admin panel" => "Kichanja cha faili admin Paneli",
"About the Unified Index" => "Kuhusu Unified Index",
"The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things." => "The Unified Index inatoa makala nyingi msingi kwa Tiki, ikiwa ni pamoja na vitu selectors kwa tafsiri kati ya mambo mengine.",
"Disabling this will cause some parts of Tiki to be unavailable." => "Kuzuia hii itasababisha baadhi ya sehemu za Tiki kuwa hazipatikani.",
"Find out more about it here." => "Pata maelezo zaidi juu yake hapa.",
// "Search engine settings" => "Search engine settings",
"About Unified search engines" => "Kuhusu injini za utafutaji zilizounganishwa",
"Advantages" => "Faida",
"Fast performance. Works out of the box with Tiki and even on most basic server setups" => "Utendaji haraka. Hufanya kazi nje ya sanduku na Tiki na hata kwenye seti za msingi za server",
"Disadvantages" => "Hasara",
"Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable" => "Maneno mengi ya kawaida (kama \"kwanza\", \"pili\", na \"ya tatu\" hayatafutwa isipokuwa muundo wa MySQL umebadilishwa). Ni wahusika wa kwanza 65,535 (kuhusu 8000 maneno) ya vipande vya muda mrefu vya maudhui yanaweza kutafutwa",
"link" => "kiungo",
" for full list) " => "kwa orodha kamili)",
"Lucene (PHP implementation)" => "Lucene (utekelezaji wa PHP)",
"Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki" => "Inashinda mapungufu ya utafutaji wa MySQL uliotajwa hapo juu. Anakuja kujengwa na Tiki",
"Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues" => "Utendaji mdogo. Je, si kazi vizuri na seti za seva za msingi na kwa sababu index ni kuhifadhiwa kwenye disk ni zaidi ya kukabiliwa na matatizo ya ruhusa ya faili na masuala mengine ya usanidi wa seva",
"Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki" => "Kifaa cha juu zaidi, cha haraka na kinachoweza kutafakari. Inawezesha baadhi ya vipengele vya juu / vipya vya Tiki",
"Needs to be separately installed from Tiki and requires more configuration" => "Inahitajika kujitenga tofauti kutoka Tiki na inahitaji usanidi zaidi",
"for more information) " => "kwa habari zaidi)",
// "About Use MySQL Full-Text Search as fallback" => "About Use MySQL Full-Text Search as fallback",
// "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability" => "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability",
// "Elastic search only" => "Elastic search only",
// "Experiment with LIST plugin syntax" => "Experiment with LIST plugin syntax",
// "After you have found the correct contents, you may copy-paste them in a LIST plugin" => "After you have found the correct contents, you may copy-paste them in a LIST plugin",
// "Legacy search" => "Legacy search",
// "Forum searches" => "Forum searches",
"Search Results" => "Matokeo ya Utafutaji",
"Items to display in search results" => "Vitu vinavyoonyeshwa katika matokeo ya utafutaji",
"Information to display for each result" => "Maelezo ya kuonyesha kwa kila matokeo",
"Stored Search" => "Utafutaji uliohifadhiwa",
"Configuration" => "Usanidi",
// "ManifoldCF Configuration Checker" => "ManifoldCF Configuration Checker",
"Occurrences of string in database" => "Matukio ya kamba katika database",
// "Set default table" => "Set default table",
// "Text to search" => "Text to search",
// "Results for " => "Results for ",
// "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}" => "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}",
"Occurrences" => "Matukio",
// "View occurrences" => "View occurrences",
// "in table " => "in table ",
// "column" => "column",
// "Page preview" => "Page preview",
"View page" => "Tazama ukurasa",
// "View blog post" => "View blog post",
// "View file" => "View file",
// "View gallery" => "View gallery",
// "View category" => "View category",
// "View article" => "View article",
// "View forum" => "View forum",
// "View calendar" => "View calendar",
// "View calendar item" => "View calendar item",
// "View tracker" => "View tracker",
// "View tracker item" => "View tracker item",
// "View forum comment" => "View forum comment",
// "Back to first level results" => "Back to first level results",
"Admin groups" => "Dhibiti vikundi",
"Admin Groups" => "Dhibiti vikundi",
"Admin users" => "Dhibiti watumiaji",
"Admin Users" => "Dhibiti watumiaji",
"Manage permissions" => "Dhibiti haki",
"Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site." => "Tafadhali angalia <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'> ukurasa wa Usalama </a> kwenye tovuti ya msanidi wa Tiki.",
"See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings" => "Angalia <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Usalama Admin</strong></a> kwa mipangilio ya ziada ya usalama",
"General Security" => "Usalama Mkuu",
"MySQL SSL connection" => "Uunganisho wa MySQL SSL",
// "MySQL SSL connection is active" => "MySQL SSL connection is active",
// "MySQL connection is not encrypted" => "MySQL connection is not encrypted",
// "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"" => "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"",
"MySQL Server does not have SSL activated" => "Server MySQL haina SSL iliyoanzishwa",
"Smarty and Features Security" => "Smarty na Usalama wa vipengele",
"Please also see" => "Merci de voir aussi",
"HTTPS (SSL) and other login preferences" => "HTTPS (SSL) na mapendekezo mengine ya kuingia",
"User Encryption" => "Ufichi wa Mtumiaji",
// "Requires the OpenSSL PHP extension for encryption" => "Requires the OpenSSL PHP extension for encryption",
// "You have OpenSSL installed" => "You have OpenSSL installed",
// "OpenSSL is not loaded" => "OpenSSL is not loaded",
// "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption" => "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption",
// "You may also want to add the Domain Password module somewhere" => "You may also want to add the Domain Password module somewhere",
// "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ" => "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ",
// "The user can add passwords for a registered password domain" => "The user can add passwords for a registered password domain",
// "Statistics for existing data" => "Statistics for existing data",
// "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension" => "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension",
// "CSRF security" => "CSRF security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
"HTTP Headers" => "Vichwa vya HTTP",
"Use these options to add options related with security to the HTTP Headers" => "Tumia chaguo hizi kuongeza chaguo zinazohusiana na usalama kwa vichwa vya HTTP",
"Spam Protection" => "Ulinzi wa Spam",
// "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself" => "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself",
"Search results" => "Matokeo ya Utafutaji",
"Site Access" => "Ufikiaji wa tovuti",
// "Admin IDS custom rules" => "Admin IDS custom rules",
"Tokens" => "Ishara",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)",
// "OpenPGP" => "OpenPGP",
// "OpenPGP functionality for PGP/MIME encrypted email messaging" => "OpenPGP functionality for PGP/MIME encrypted email messaging",
"Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging." => "Fuctionality ya majaribio ya OpenPGP kwa ujumbe wa barua pepe wa PGP / MIME.",
"All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses." => "Ujumbe wote wa barua pepe / arifa / majarida hutumwa kama ujumbe wa encrypted PGP / MIME, iliyosainiwa na key-signer, na ni 100% kabisa opaque kwa nje. Akaunti zote za watumiaji zinahitajika kufanywa vizuri katika kichapishaji cha gnupg na funguo za umma zinazohusiana na anwani zao za barua pepe zinazohusiana na akaunti ya tiki.",
// "If you use preferences option for the signer passphrase, clear the file option just for security" => "If you use preferences option for the signer passphrase, clear the file option just for security",
// "If you use file for the signer passphrase, clear the preferences option just for security" => "If you use file for the signer passphrase, clear the preferences option just for security",
// "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring" => "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
"To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "Ili kuwezesha faili hii, tu nakala faili %0 (iko katika saraka kuu ya ufungaji wako wa Tiki) hadi %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
"%0 file is missing" => "Faili %0 haipo",
"Unable to verify that your URL rewriting configuration is up to date" => "Haiwezi kuthibitisha kuwa urekebishaji wako wa URL umeandikwa tena",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
"%0 is not in the expected format" => "%0 si muundo uliotarajiwa",
"%0 may simply be outdated" => "%0 inaweza kuwa nje ya tarehe",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
"%0 file is out of date" => "%0 hayatolewa",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "For example, if the field is left blank, the canonical URL domain is" => "For example, if the field is left blank, the canonical URL domain is",
// "URL parameters" => "URL parameters",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known types" => "Known types",
"Invert" => "kubadili",
"Show Usage" => "Onyesha matumizi",
"Delete &amp; Unreference" => "Futa & upungufu",
"Invert Relation" => "Pindua uhusiano",
// "New types" => "New types",
// "Fix" => "Fix",
"No occurences found" => "Hakuna matukio yaliyopatikana",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Social network integration" => "Social network integration",
"To use Twitter integration, you must register this site as an application at" => "Kutumia ushirikiano wa Twitter, unahitaji kujiandikisha tovuti hii kama programu hapa:",
"and allow write access for the application" => "na ruhusu ruhusa ya kuandika kwa programu hii",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Ingiza <anwani yako ya tovuti> tiki-socialnetworks.php kama URL yako ya kurudi",
"To use Facebook integration, you must register this site as an application at" => "Ili kutumia ushirikiano wa Facebook, unahitaji kujiandikisha tovuti hii kama programu hapa:",
"and allow extended access for the application" => "na kuruhusu upatikanaji kupanuliwa kwa programu hii",
"Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Ingiza <anwani ya tovuti yako> tiki-socialnetworks.php? Request_facebook kama anwani ya tovuti na & lt; jina lako la kikoa & gt; kama 'Site Domain'",
"The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it." => "Mapendekezo yafuatayo yanaamua ambayo ruhusa itatakiwa kutoka kwa mtumiaji kumwambia Tiki nini cha kuruhusu Facebook kufanya wakati aliidhinishwa.",
// "bit.ly" => "bit.ly",
"There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "Akaunti ya tovuti ya bit.ly haihitajiki; kila mtumiaji anaweza kutumia mwenyewe, lakini akaunti ya tovuti inaruhusu takwimu zaidi.",
"Go to" => "Ingia",
"to sign up for an account" => "ili kuunda akaunti",
"to retrieve the API key" => "ili kupata ufunguo wa API",
// "To use LinkedIn integration, you must register this site as an application at" => "To use LinkedIn integration, you must register this site as an application at",
// "and allow necessary permissions for the application" => "and allow necessary permissions for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs" => "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs",
// "Share This" => "Share This",
"This is a new control panel on Tiki and work is still in progress." => "Hii ni jopo jipya la kudhibiti juu ya Tiki na kazi bado inaendelea.",
// "Tiki Statistics" => "Tiki Statistics",
// "Piwik Analytics" => "Piwik Analytics",
"Text area (that apply throughout many features)" => "Eneo la maandishi (ambalo linatumika katika vipengele vingi)",
"Wiki syntax" => "Syntax ya Wiki",
"Typography" => "Uchapaji",
"Default size" => "Ukubwa wa kawaida",
"External links and images" => "Viungo vya nje na picha",
"External links will be identified with:" => "Viungo vya nje vitatambuliwa na:",
"About plugins" => "Kuhusu Plugins",
"Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below." => "Plugin za Tiki zinaongeza utendaji kwa kurasa za wiki, makala, blogi, na kadhalika. Unaweza kuwawezesha na kuwazuia chini.",
// "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>",
"The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below." => "Ishara ya hariri Plugin ni njia rahisi kwa watumiaji kuhariri vigezo vya kila Plugin katika kurasa za wiki. Inaweza kuzima kwa Plugins binafsi.",
"Check disabled plugins used in wiki pages" => "Angalia Plugin za walemavu kutumika katika kurasa za wiki",
"Disabled used plugins" => "Inalemaza programu",
// "Plugin preferences" => "Plugin preferences",
"Edit plugin icons" => "Icone d'édition de plugiciel",
// "Plugin List" => "Plugin List",
// "Use the filter input above to find plugins, or enter return to see the whole list" => "Use the filter input above to find plugins, or enter return to see the whole list",
"Search Help" => "Msaada wa Utafutaji",
"Disable edit plugin icon (make plugin inline)" => "Désactiver l'icone d'édition du plugiciel (plugiciel en ligne)",
"Plugin Aliases" => "Alias de plugiciel",
"About plugin aliases" => "Kuhusu 'plugin aliases'",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins",
// "Find out more here" => "Find out more here",
// "This page is designed to work with JavaScript" => "This page is designed to work with JavaScript",
// "Available alias" => "Available alias",
// "Plugin Alias" => "Plugin Alias",
// "Enable Checked Plugins" => "Enable Checked Plugins",
// "General information" => "General information",
"Plugin name" => "Jina la Plugin",
// "Base plugin" => "Base plugin",
// "Body label" => "Body label",
"Dependencies" => "outbuildings",
// "Inline (no plugin edit UI)" => "Inline (no plugin edit UI)",
// "Simple plugin arguments" => "Simple plugin arguments",
// "Add parameter" => "Add parameter",
"Argument" => "hoja",
// "Delete this parameter" => "Delete this parameter",
// "Default Value" => "Default Value",
// "Plugin parameter documentation" => "Plugin parameter documentation",
// "Add parameter documentation" => "Add parameter documentation",
// "Delete this parameter's documentation" => "Delete this parameter's documentation",
"Safe" => "tahadhari",
// "Plugin body" => "Plugin body",
// "Ignore user input" => "Ignore user input",
// "Default content" => "Default content",
// "Body Parameters" => "Body Parameters",
// "Add body parameter" => "Add body parameter",
// "Delete this body parameter" => "Delete this body parameter",
"Encoding" => "encoding",
// "Argument source (if different)" => "Argument source (if different)",
// "Composed plugin arguments" => "Composed plugin arguments",
// "Add composed parameter" => "Add composed parameter",
// "Delete this composed argument" => "Delete this composed argument",
"Pattern" => "mfano",
// "Composed parameters" => "Composed parameters",
// "Delete this composed parameter" => "Delete this composed parameter",
"Tracker settings" => "Mpangilio wa fomu",
// "Field settings" => "Field settings",
// "Linked wiki pages" => "Linked wiki pages",
// "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features" => "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features",
"Tracker attachment preferences" => "Mapendeleo kwa viambatisho vya fomu",
// "Tracker force-fill feature" => "Tracker force-fill feature",
"Field Types" => "Aina za shamba",
// "Field types" => "Field types",
"Tracker attachments" => "Viambatisho vya fomu",
"dls" => "dls",
"Switch storage" => "Badilisha kuhifadhi",
"Change all to db" => "Weka wote kwenye databana",
"Change all to file" => "Weka wote kwenye faili",
"User Settings" => "Mipangilio ya Mtumiaji",
"Default user preferences" => "Mapendekezo ya mtumiaji wa kawaida",
"Users Default Preferences" => "Mapendeleo ya mtumiaji wa kawaida",
// "My Account Items" => "My Account Items",
"User Features" => "Vipengele vya mtumiaji",
"User Account Features" => "Vipengele vya Akaunti ya Mtumiaji",
"User Info and Picture" => "Maelezo na Picha ya Mtumiaji",
"User information display" => "Uonyesho wa habari wa mtumiaji",
"Messaging and Notifications" => "Ujumbe na Arifa",
"User notifications" => "Arifa ya mtumiaji",
// "For the digest emails to be sent out, you will need to set-up a cron job" => "For the digest emails to be sent out, you will need to set-up a cron job",
// "Adjust the command parameters for your digest frequency. Default frequency is 7 days" => "Adjust the command parameters for your digest frequency. Default frequency is 7 days",
// "Sample command" => "Sample command",
"User Files" => "Faili za Mtumiaji",
"Kaltura" => "Kaltura",
"Kaltura Registration" => "Enregistrement Kaltura",
"To get a Kaltura Partner ID:" => "Pour obtenir un ID Partenaire Kaltura :",
"Setup your own instance of Kaltura Community Edition (CE)" => "Jenga mfano wako wa jumuiya ya Kaltura Publishing",
"get an account via Kaltura.com" => "pata akaunti kupitia Kaltura.com",
// "List Media" => "List Media",
"List Remix Entries" => "Orodha ya Remixes",
"Add New Media" => "Ongeza vyombo vya habari mpya",
// "Plugin to embed in pages" => "Plugin to embed in pages",
// "Enable related tracker field types" => "Enable related tracker field types",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura partner settings" => "Kaltura partner settings",
// "Kaltura dynamic player" => "Kaltura dynamic player",
// "Kaltura contribution wizard" => "Kaltura contribution wizard",
// "You can manually edit these values in lib/videogals/standardTikiKcw.xml" => "You can manually edit these values in lib/videogals/standardTikiKcw.xml",
// "Recreate KCW \"uiConf\"" => "Recreate KCW \"uiConf\"",
// "Legacy support" => "Legacy support",
"Webservices" => "Huduma za Mtandao",
"Use the 'Quick Edit' module to easily create or edit wiki pages." => "Tumia moduli ya 'Quick Edit' ili kuunda au kubadilisha hariri za wiki.",
// "List wiki pages" => "List wiki pages",
// "List structures" => "List structures",
"Page display" => "Kuonyesha ukurasa",
"Automatic table of contents" => "Jedwali la moja kwa moja la yaliyomo",
// "General features" => "General features",
"Export Wiki Pages" => "Kutayarisha Kurasa za Wiki kwenye Duru ya PhpWiki",
// "Redirect and Similar" => "Redirect and Similar",
// "Wikiwords Features" => "Wikiwords Features",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Move all attachments to database" => "Move all attachments to database",
// "Move all attachments to file system" => "Move all attachments to file system",
"Remove unused pictures" => "Futa picha zisizotumika",
"Move images from wiki_up to the home file gallery" => "Hamisha picha kutoka wiki_up kwenye nyumba ya sanaa ya faili",
// "Move images to home gallery" => "Move images to home gallery",
"If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "Ikiwa unatumia vifungo hivi tafadhali hakikisha kuwa na hifadhi ya database na directory ya wiki_up",
"Wiki watch" => "Tazama Wiki",
// "Namespaces" => "Namespaces",
// "Settings that may be affected by the namespace separator" => "Settings that may be affected by the namespace separator",
"Flagged Revision" => "Masahihisho uliowekwa alama",
"Page Listings" => "Orodha ya Ukurasa",
"Select which items to display when listing pages:" => "Chagua vipi ambavyo vinaonyesha wakati wa kurasa za orodha:",
// "Database dumps and restores" => "Database dumps and restores",
"Name for dump" => "Jina la dump",
"Create Database Dump" => "Unda Database Dump",
"Wiki database" => "Database la wiki",
"Restore" => "Restaurer",
"Dump files" => "Faili za dump",
"Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks." => "Futa faili za kumbukumbu za kurasa za wiki kwa matumizi mbalimbali kama kuvinjari-au-usambazaji wa mstari wa mbali kwenye disks za macho.",
"The HTML files generated may refer to files not included in the dump." => "Faili za HTML zinazozalishwa zinaweza kutaja faili ambazo hazijumuishwa katika dampo.",
"Dumps do not include files attached to wiki pages." => "Dumps hazijumuisha faili zilizounganishwa na kurasa za wiki.",
// "Dumping will overwrite the preexisting dump" => "Dumping will overwrite the preexisting dump",
// "Create Dump File" => "Create Dump File",
// "Download Dump File" => "Download Dump File",
// "Remove Dump File" => "Remove Dump File",
// "Mass replace and page permissions report" => "Mass replace and page permissions report",
"Mass search and replace" => "Tafutaji kwa wingi na Badilisha",
"Report wiki pages with direct object permissions" => "Ripoti kurasa za wiki na vibali vya moja kwa moja",
"Wiki attachments" => "Vifungo vya Wiki",
// "Move attachment to database" => "Move attachment to database",
// "Move to database" => "Move to database",
// "Move attachment to file system" => "Move attachment to file system",
// "Move to file system" => "Move to file system",
// "Exclusive" => "Exclusive",
// "Share Common" => "Share Common",
"Edit perspective" => "Badilisha mtazamo",
// "No areas found. Click \"Update Areas\" to populate this list" => "No areas found. Click \"Update Areas\" to populate this list",
// "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> " => "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> ",
// "Update areas" => "Update areas",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>",
"Page links" => "Viungo vya Ukurasa",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature",
// "WYSIWYG editor features" => "WYSIWYG editor features",
"Related features" => "Vipengele vinavyohusiana",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "Nafasi",
"Cache Time" => "Muda wa Cache",
"secs" => "secs",
"Use Ctrl+Click to select multiple options" => " Tumia Ctrl + Bofya ili kuchagua chaguzi nyingi",
"The" => "Ya",
"Display Modules to All Groups" => "Kuonyesha Modules kwa Vikundi Vyose",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
"Displayed now for all eligible users even with personal assigned modules" => "Imeonyeshwa sasa kwa watumiaji wote wanaostahili hata kwa modules za kibinafsi",
"Displayed for the eligible users with no personal assigned modules" => "Imeonyeshwa kwa watumiaji wanaostahili ambao hawana modules binafsi",
"Displayed now, can't be unassigned" => "Imeonyeshwa sasa, haiwezi kugawa",
"Not displayed until a user chooses it" => "Haionyeshwa mpaka mtumiaji anachagua",
"Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Parce que <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">les utilisateurs peuvent configurer les modules</a>, faire un autre choix",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
"required" => "inahitajika",
"Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Paramètres: paramètres spécfiques au module et/ou généraux ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Séparateur entre les paramètres : '&amp;'. Ex : maxlen=15&amp;nonums=y",
"Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Entrer les paramètres en format URL, exemple : 'nobox=y&class=rbox-data'",
"Edit custom module" => "Badilisha moduli ya desturi",
// "Enter the code below" => "Enter the code below",
"Anti-Bot verification code image" => "Kitambulisho cha msimbo wa kupambana na Bot",
"Try another code" => "Jaribu msimbo mwingine",
// "Your article has been added" => "Your article has been added",
// "Create Article" => "Create Article",
// "Expires" => "Expires",
// "Users rating: " => "Users rating: ",
// "{\$topicName}" => "{\$topicName}",
// "List all articles of the same topic" => "List all articles of the same topic",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
"You do not have permission to read complete articles." => "Huna ruhusa ya kusoma makala kamili.",
"First page" => "Ukurasa wa kwanza",
"Previous page" => "Ukurasa uliopita",
"Next page" => "Ukurasa unaofuata",
"Last page" => "Ukurasa wa mwisho",
"Related content" => "Maudhui yaliyohusiana",
"bytes" => "bytes",
// "Article actions" => "Article actions",
"Send a link" => "Tuma kiungo",
// "Get a short URL" => "Get a short URL",
"Attached files" => "Faili zilizounganishwa",
"Upload file" => "Tuma faili",
// "File upload comment" => "File upload comment",
"Attach" => "kujiunga",
"Attach a file to this item" => "Weka faili kwenye fomu hii",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
"more info" => "habari zaidi",
"No attachments for this item" => "Hakuna faili iliyoambatana na fomu hii",
// "Blog actions" => "Blog actions",
// "Blog Actions" => "Blog Actions",
"Monitor" => "kufuatilia",
// "Stop monitoring" => "Stop monitoring",
"Group Monitor" => "Usimamizi wa kikundi",
"RSS" => "RSS",
"Watched by categories" => "Fuatilia kupitia kikundi",
// "Blog post actions" => "Blog post actions",
"Save to notepad" => "Hifadhi katika kidokezo",
// "Published By" => "Published By",
"Publish Date" => "Tarehe ya kuchapishwa",
"Previous post" => "Kuchapishwa hapo awali",
"Next post" => "Ujumbe uliofuata",
"More..." => "Zaidi ...",
"pages" => "ukurasa",
"Last" => "karibuni",
"private" => "binafsi",
"permanent link" => "URL ya Uhuishaji (vibali)",
"Leave a comment" => "Acha maoni",
"%0 comment" => "%0 maoni",
"%0 comments" => "%0 maoni",
// "{\$item.name}" => "{\$item.name}",
// "{\$sub.name}" => "{\$sub.name}",
"Parent Gallery" => "Nyumba ya sanaa",
"No records found" => "Hakuna matokeo",
"Select Categories" => "Chagua kipengele moja au zaidi (s)",
"Admin Categories" => "Dhibiti Jamii",
"Select/deselect all categories" => "Angalia / usifute makundi yote",
"No categories defined" => "Hakuna kiwanja kilichofafanuliwa",
"Browse Category" => "Vinjari Jamii",
"Are you sure you want to archive this comment" => "Una uhakika unataka kuhifadhi maelezo haya?",
"Are you sure you want to unarchive this comment" => "Una uhakika unataka kufuta maoni haya?",
// "Edit Comment" => "Edit Comment",
// "Comments unlocked" => "Comments unlocked",
"Post new comment" => "Chapisha maoni mapya",
"There are no comments at this time" => "Hakuna maoni kwa wakati huu",
"Add Comment" => "Ongeza Maoni",
"Reply" => "jibu",
"Archived" => "archive",
"Unarchive" => "unpack",
"Archive" => "Archive",
"Rejected" => "kukataliwa",
"Approve" => "kupitisha",
"Reject" => "kukataa",
"Are you sure you want to lock comments on this object" => "Una uhakika unataka kufunga maoni juu ya kipengee hiki?",
"Are you sure you want to approve this comment" => "Una uhakika unataka kupitisha maoni haya?",
"Are you sure you want to reject this comment" => "Una uhakika unataka kukataa maoni haya?",
// "Go back to" => "Go back to",
// "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity",
"Website" => "Website",
"Send me an email when someone replies" => "Nitumie barua pepe wakati mtu anajibu",
// "Are you sure you want to delete this comment" => "Are you sure you want to delete this comment",
"Are you sure you want to unlock comments on this object" => "Una uhakika unataka kufungua maoni kwenye kipengee hiki?",
"Posted by" => "Imetumwa na",
// "Private message" => "Private message",
"private message" => "Imetumwa na",
// "Send eMail to user" => "Send eMail to user",
// "User online" => "User online",
// "User offline" => "User offline",
// "Download attachment" => "Download attachment",
// "Remove attachment" => "Remove attachment",
// "Deliberation Items" => "Deliberation Items",
"top of page" => "kurudi juu",
"Notification" => "taarifa",
// "Delete post" => "Delete post",
"Report this post" => "Ripoti chapisho hili",
// "Group monitor" => "Group monitor",
// "Moderator actions for selected topics" => "Moderator actions for selected topics",
// "Reported messages" => "Reported messages",
"Reported" => "Iliripotiwa",
// "Queued messages" => "Queued messages",
"Queued" => "Mis en attente",
"Threshold" => "kizingiti",
"Search:" => "search:",
"Replies" => "majibu",
"below your current threshold" => "chini ya kizingiti chako cha sasa",
"New Reply" => "Jibu jipya",
"Editing reply" => "Badilisha jibu",
"Reply to the selected post" => "Jibu kwa ujumbe uliochaguliwa",
"Post new message" => "Chapisha ujumbe mpya",
// "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address",
"Maximum size" => "Ukubwa wa ukubwa",
"Reply to parent post" => "Jibu kwa ujumbe wa mzazi",
"Post new reply" => "Chapisha ujumbe mpya",
"Post as Anonymous" => "Chapisha kama haijulikani",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Tafadhali kumbuka kuwa hakikisho haifai faili iliyoambatanishwa ambayo utahitaji kutaja na Kuchapisha",
"Posting replies" => "Chapisha majibu",
"Please enter a title" => "Tafadhali ingiza kichwa",
"1 comment" => "1 comment",
"Go back" => "Rudi kwenye ukurasa uliopita",
"Return to home page" => "Rudi kwenye ukurasa wa nyumbani",
"Type of contribution" => "Aina ya mchango",
// "No contribution records found" => "No contribution records found",
// "{\$prefs.cookie_consent_description}" => "{\$prefs.cookie_consent_description}",
// "{\$prefs.cookie_consent_question}" => "{\$prefs.cookie_consent_question}",
// "{\$prefs.cookie_consent_button}" => "{\$prefs.cookie_consent_button}",
"Copyrights" => "Haki za Hakili",
"Authors" => "waandishi",
// "Copyright Holder" => "Copyright Holder",
"Theme:" => "mandhari :",
// "Do you really want to remove the %0 route" => "Do you really want to remove the %0 route",
"Back to tracker list" => "Rudi kwenye orodha ya fomu",
"System error" => "Hitilafu ya mfumo",
"The following error message was returned" => "Ujumbe wa hitilafu yafuatayo imerejeshwa",
"Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database sasa haijitokewa! Angalia <a href=\"tiki-install.php\"> Tiki Installer </a> ili kutatua tatizo hili",
"If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation:" => "Ikiwa una ufikiaji wa amri (SSH), unaweza pia kutumia amri hii, kutoka kwenye mizizi ya ufungaji wako wa Tiki:",
"The query was" => "Ombi lilikuwa",
"The built query was likely" => "Swali lilijengwa labda",
"Stacktrace" => "Stacktrace",
"Tiki is unable to connect to the database" => "Tiki haiwezi kuunganisha kwenye orodha",
"An error occurred while performing the request" => "Hitilafu ilitokea wakati wa kutekeleza ombi",
"Current URL" => "URL courante",
"Command" => "Commande",
"exec" => "kufanya",
"Type <code>help</code> to get list of available commands" => "Andika <code> msaada </ code> kwa orodha ya amri zilizopo",
"Page generation debugging log" => "Tambua kizazi cha uharibifu wa ukurasa",
"Features state" => "Hali ya hali",
"features matched" => "Hali ya hali",
"Watchlist" => "Orodha ya vigezo vinavyofuatiliwa",
// "Page discussion" => "Page discussion",
// "This page has been discussed once" => "This page has been discussed once",
// "Access discussion" => "Access discussion",
// "This page has been discussed %0 times" => "This page has been discussed %0 times",
// "Access discussion (%0 replies)" => "Access discussion (%0 replies)",
// "There are no discussions currently on this page" => "There are no discussions currently on this page",
// "Start discussion" => "Start discussion",
"Duplicate File Gallery" => "Dupisha nyumba ya sanaa",
"Duplicate categories" => "Makundi ya Duplicate",
"Duplicate permissions" => "Duplicate haki za upatikanaji",
"Duplicate" => "duplicate",
"There are individual permissions set for this file gallery" => "Haki za upatikanaji wa kibinafsi zimetumiwa kwenye nyumba ya sanaa hii ya faili",
// "Manage Permissions" => "Manage Permissions",
"Properties" => "Mali",
// "{\$gal_info.name}" => "{\$gal_info.name}",
// "Other (%0)" => "Other (%0)",
"Any file" => "Faili zote",
"Podcast (audio)" => "Podcast (audio)",
"Podcast (video)" => "Podcast (vidéo)",
"Gallery is visible to non-admin users" => "Nyumba hii ya sanaa inaonekana kwa watumiaji wasio wa admin",
// "Gallery is unlocked" => "Gallery is unlocked",
// "Users with upload permission can add files to the gallery (not just the gallery owner)" => "Users with upload permission can add files to the gallery (not just the gallery owner)",
// "Respect permissions for backlinks to view a file" => "Respect permissions for backlinks to view a file",
"Files can be locked at download" => "Faili zinaweza kufungwa kwa kupakuliwa",
"Maximum number of archives for each file" => "Idadi kubwa ya kumbukumbu za kila faili",
"unlimited" => "ukomo",
"Parent gallery" => "Nyumba za Mzazi",
"Owner of the gallery" => "Mmiliki wa nyumba ya sanaa",
"Mb" => "Mo",
"Min" => "Min",
"Group of users alerted when file gallery is modified" => "Kikundi cha watumiaji kiligunduliwa wakati kipengee kinachobadilishwa katika nyumba ya sanaa",
"Allows each user to be selected for small groups" => "Ruhusu kuchagua kila mtumiaji peke yake",
"Maximum width of images in gallery" => "Upeo wa picha katika nyumba ya sanaa",
"If an image is wider than this, it will be resized" => "Ikiwa picha ni kubwa, itapunguzwa",
"Attention: In this case, the original image will be lost" => "Onyo: Katika kesi hii, picha ya awali itapotea",
"Maximum height of images in gallery" => "Urefu wa picha katika nyumba ya sanaa",
"If an image is higher than this, it will be resized" => "Ikiwa picha ni ya juu, itapunguzwa",
"Wiki markup to enter when image selected from \"file gallery manager\"" => "Msimbo wa Wiki ili kuingia wakati picha imechaguliwa kutoka kwa \"faili ya meneja wa faili \"",
"The default is " => "La valeur par défaut est ",
"Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Majina ya faili yatabadilishwa wakati wao wamezungukwa na '%'. Kwa mfano% filedd%,% jina%,% filename%,% maelezo%",
// "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs" => "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs",
// "Display Settings" => "Display Settings",
// "Finder View" => "Finder View",
"Select which items to display when listing galleries" => "Chagua habari unayotaka kuonekana wakati wa kutazama nyumba",
"Max description display size" => "Upeo wa ukubwa wa maonyesho ya maelezo",
"Max rows per page" => "Upeo wa safu ya safu",
// "View inserted gallery after save" => "View inserted gallery after save",
"File error" => "Futa kosa",
"Perhaps you are looking for" => "Labda unatafuta",
"There are no wiki pages similar to '{\$page|escape}'" => "Hakuna ukurasa wa wiki unaofanana na '{\$page|escape}'",
"Token Error" => "Hitilafu ya ishara",
"You are not logged in." => "Hujaingia.",
"Go to Log in Page" => "Nenda kwenye ukurasa wa uthibitishaji",
"Create this page" => "Unda ukurasa huu",
"(page will be orphaned)" => "(ukurasa utakuwa yatima)",
"Close Window" => "Funga dirisha",
// "Redirecting in %0 seconds" => "Redirecting in %0 seconds",
// "Permission successfully changed" => "Permission successfully changed",
// "Global permission" => "Global permission",
// "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)",
// "</em>\"}Object permission for the %0 %1" => "</em>\"}Object permission for the %0 %1",
// "Permissions successfully changed" => "Permissions successfully changed",
// "Global permissions" => "Global permissions",
// "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)",
// "</em>\"}Object permissions for the %0 %1" => "</em>\"}Object permissions for the %0 %1",
// "" => "",
// "No permissions were changed" => "No permissions were changed",
// "The following change has been applied" => "The following change has been applied",
// "The following changes have been applied" => "The following changes have been applied",
// "{\$item.mes[0]|stringfix}" => "{\$item.mes[0]|stringfix}",
"Preference name" => "Jina la upendeleo",
"Upload" => "Pakia",
"Open as WebFolder" => "Fungua kwenye folda ya wavuti",
// "Delete gallery" => "Delete gallery",
"Edit: " => "mabadiliko",
// "Display as PDF" => "Display as PDF",
"Download current version" => "Pakua toleo la kuthibitishwa",
// "Browser display" => "Browser display",
"Archives" => "nyaraka",
// "Upload new version" => "Upload new version",
// "Replace draft" => "Replace draft",
// "Upload draft" => "Upload draft",
// "Validate draft" => "Validate draft",
"Validate your draft" => "Thibitisha rasimu yako",
// "Delete draft" => "Delete draft",
"Delete your draft" => "Futa rasimu yako",
// "Edit properties" => "Edit properties",
// "Refresh metadata" => "Refresh metadata",
// "Page view" => "Page view",
// "File already locked by %0" => "File already locked by %0",
// "Lock file" => "Lock file",
"Download and lock" => "Pakua na ufunge",
"Open your draft in WebDAV" => "Fungua rasimu yako kwenye WebDAV",
"Open in WebDAV" => "Fungua kwenye WebDAV",
"Share a link to this file" => "Shiriki kiungo kwa faili hii",
"Email a link to this file" => "Tuma barua pepe kwenye kiungo hiki",
"Click here to use the file" => "Cliquer Ici pour Insérer en Syntaxe Wiki",
"The checkbox is disabled because this preference is disabled globally" => "Sanduku hilo limefutwa nje kwa sababu kipengele kinazimwa kote duniani",
// "Please enable the preference globally first" => "Please enable the preference globally first",
// "Site administrators can enable the preference" => "Site administrators can enable the preference",
"Show an icon in a column" => "Onyesha icon katika safu",
// "Search.." => "Search..",
// "Select files" => "Select files",
// "Too many files selected. De-select some files before adding more" => "Too many files selected. De-select some files before adding more",
// "Current Selection" => "Current Selection",
"Click to remove" => "Bonyeza ili uondoe",
"Upload Files" => "Tuma faili",
"Drop files or " => "Tone faili au",
"Choose files" => "Chagua faili",
"Automatic upload" => "Pakia moja kwa moja",
// "Last modification: %0" => "Last modification: %0",
// "No files found" => "No files found",
"Upload from URL" => "Pakua kutoka URL",
"File added" => "Faili iliyoongeza",
// "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} " => "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} ",
// "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section" => "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section",
"Upload File" => "tuma faili",
// "Or drop files here from your file manager" => "Or drop files here from your file manager",
// "Or drop file here from your file manager" => "Or drop file here from your file manager",
// "Export PDF" => "Export PDF",
"Start the Slideshow" => "Anza slideshow",
"Pause the Slideshow" => "Punguza slideshow",
"There are no images to display" => "Hakuna picha zinazoonyesha",
// "Select Files (%0)" => "Select Files (%0)",
// "Sort By" => "Sort By",
// "Sort direction" => "Sort direction",
"Any" => "Yoyote",
"Lookup" => "search",
"Deep search" => "Utafutaji wa juu",
"Select Tags" => "Choisir un/des mot(s)-clé(s)",
"Include objects without a specified language" => "Weka vitu bila lugha maalum",
// "View Saved Searches" => "View Saved Searches",
"Add to filter" => "Ongeza kichujio",
// "{\$whatlabel}" => "{\$whatlabel}",
"Clear Filter" => "Futa Kichujio",
"any type" => "aina yoyote",
"Article Topic" => "Somo la makala",
"any topic" => "somo lolote",
"any language" => "lugha yoyote",
"not in" => "sio",
// "Date From" => "Date From",
// "Date To" => "Date To",
"any category" => "makundi yote",
"Multiple select" => "Uchaguzi mara nyingi",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
"Orphans" => "yatima",
// "{\$find_other}" => "{\$find_other}",
"Displayed rows" => "Safu iliyoonyeshwa",
// "Hide Map" => "Hide Map",
// "Show Map" => "Show Map",
"Module errors" => "Hitilafu katika moduli",
"The following modules could not be loaded" => "Modules zifuatazo haikuweza kubeba",
"Change" => "Badilisha",
// "Show PHP error messages" => "Show PHP error messages",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Séparer les mots-clés par des espaces. Les mots-clés formés par des mots composés sont à saisir sans espaces entre les différents mots ou entourer de doubles quotes",
// "Untag" => "Untag",
// "Goal" => "Goal",
// "Eligible Groups" => "Eligible Groups",
// "No eligible groups" => "No eligible groups",
// "No goals configured yet" => "No goals configured yet",
// "Goal Administration" => "Goal Administration",
// "%0 was removed" => "%0 was removed",
// "Are you sure you want to delete %0" => "Are you sure you want to delete %0",
// "View Goal" => "View Goal",
// "Eligibility" => "Eligibility",
// "Goal Attribution" => "Goal Attribution",
// "Individual Goal" => "Individual Goal",
// "Group Goal" => "Group Goal",
// "Range Type" => "Range Type",
// "Rolling" => "Rolling",
// "Fixed" => "Fixed",
// "Time span" => "Time span",
// "In days" => "In days",
// "YYYY-MM-DD HH:MM:SS" => "YYYY-MM-DD HH:MM:SS",
// "Rewards are given to individuals achieving the goal or group members for group goals" => "Rewards are given to individuals achieving the goal or group members for group goals",
// "Changes will not be saved" => "Changes will not be saved",
// "Your changes to conditions are not saved until you save the goal" => "Your changes to conditions are not saved until you save the goal",
"Operator" => "operator",
"At Least" => "Angalau",
"At Most" => "Kwa zaidi",
// "Metric" => "Metric",
// "Event Type" => "Event Type",
// "Badge" => "Badge",
// "Hide condition from users" => "Hide condition from users",
// "Members of" => "Members of",
// "Your changes to rewards are not saved until you save the goal" => "Your changes to rewards are not saved until you save the goal",
// "Credit Type" => "Credit Type",
// "Credit Quantity" => "Credit Quantity",
// "Hide reward from users" => "Hide reward from users",
// "No conditions yet" => "No conditions yet",
// "Add Condition" => "Add Condition",
// "No rewards yet" => "No rewards yet",
// "Add Reward" => "Add Reward",
// "Modify Eligibility" => "Modify Eligibility",
// "No groups are eligible to this goal" => "No groups are eligible to this goal",
// "Major Version" => "Major Version",
// "Minor Version" => "Minor Version",
// "Tutorial URL" => "Tutorial URL",
// "Restricted" => "Restricted",
// "Return to list" => "Return to list",
"Images Galleries" => "Galleries ya picha",
"Edit this page!" => "Badilisha ukurasa huu!",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blog",
"RSS Articles" => "RSS Articles",
"RSS Image Galleries" => "RSS Galleries ya picha",
"RSS File Galleries" => "Flux RSS Faili za picha",
"RSS Forums" => "RSS Forums",
"RSS Directories" => "RSS Saraka",
"RSS Calendars" => "Calendars RSS",
// "RSS Tracker" => "RSS Tracker",
// "Use Selected Icon" => "Use Selected Icon",
// "Do you really want to remove the custom IDS rule with Id %0" => "Do you really want to remove the custom IDS rule with Id %0",
// "Back to IDS Rules list" => "Back to IDS Rules list",
// "Toggle interactive translation" => "Toggle interactive translation",
"Once checked, click on any string to translate it." => "Kwa kuangalia sanduku hili, unaweza kutafsiri kamba ya maandishi kwa click moja.",
"Turn off interactive translation" => "Zima kutafsiri mwingiliano",
"Interactive Translation" => "Tafsiri ya ushirikiano",
"Translation" => "Tafsiri",
"Couldn't find any translatable string" => "Haikuweza kupata kituo cha kutafsiri",
"Save translations" => "Hifadhi tafsiri",
"Changes will be applied on next page load only" => "Mabadiliko yatatumika tu wakati ukurasa unapowekwa",
"Upload Successful" => "Kufanikiwa kurudia tena",
// "custom.php" => "custom.php",
// "Download custom.php file for the selected language" => "Download custom.php file for the selected language",
// "custom.json" => "custom.json",
// "Download custom.json file for the selected language" => "Download custom.json file for the selected language",
"Custom translation file does not exist. Save a custom translation to create the file." => "Faili ya tafsiri ya desturi haipo. Hifadhi tafsiri ya desturi ili kuunda faili.",
"Translations" => "Tafsiri",
// "Translation text" => "Translation text",
// "Add a new row" => "Add a new row",
"Add row" => "Ongeza mstari",
// "Customized String Translations" => "Customized String Translations",
// "Manage custom translations" => "Manage custom translations",
"Process Type" => "Aina ya mchakato",
"Select how the uploaded translations should be processed" => "Chagua jinsi tafsiri zilizopakiwa zinapaswa kusindika",
"Note:" => "Kumbuka:",
// "No translations in the database available to export" => "No translations in the database available to export",
"Translations in the database" => " Tafsiri katika database",
// "Merge all translations, whether or not they are marked as general (for contribution)" => "Merge all translations, whether or not they are marked as general (for contribution)",
// "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database" => "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database",
"To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "Ili uweze kuandika tafsiri zako nyuma katika lugha.php, hakikisha kwamba seva ya wavuti ina haki ya kuandika kwenye directory ya lang/",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Toggle right modules" => "Toggle right modules",
// "Toggle left modules" => "Toggle left modules",
"Toggle module contents" => "Onyesha / ficha maudhui ya moduli",
"Toggle" => "Onyesha / ficha",
// "Move up" => "Move up",
// "Move down" => "Move down",
// "Move to opposite side" => "Move to opposite side",
// "{\$count_label}" => "{\$count_label}",
"Show Tree" => "Onyesha Mti",
"Hide Tree" => "Ficha Mti",
// "Select action to perform with checked.." => "Select action to perform with checked..",
"Assign permissions to file galleries" => "Weka ruhusa ya faili za faili",
// "Delete selected items" => "Delete selected items",
// "Download zip version" => "Download zip version",
// "Reset to default list view settings" => "Reset to default list view settings",
// "Move selected file or gallery" => "Move selected file or gallery",
"Move to" => "Nenda kwa",
// "Assign file gallery permissions to groups" => "Assign file gallery permissions to groups",
"No Additional Sort" => "Hakuna upangilio wa ziada",
"Other Sorts" => "Aina nyingine",
// "Locked by-" => "Locked by-",
"No information" => "Hakuna taarifa",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
// "The leader of " => "The leader of ",
// "has added you. To visit it, logon and go to the home page " => "has added you. To visit it, logon and go to the home page ",
// "You have been added" => "You have been added",
// "This is to inform you that your request to join" => "This is to inform you that your request to join",
// " has been accepted" => " has been accepted",
// "To visit it, go to the home page" => "To visit it, go to the home page",
// "Leader approved your request" => "Leader approved your request",
// "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the" => "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the",
// "Leader rejected your request" => "Leader rejected your request",
// "This is to inform you that you have been removed from " => "This is to inform you that you have been removed from ",
// " If you did not request this removal, or have any questions or concerns, please contact" => " If you did not request this removal, or have any questions or concerns, please contact",
// "You have been removed from it" => "You have been removed from it",
// "Upgrade Available" => "Upgrade Available",
// "Upgrades Available" => "Upgrades Available",
// "{\$subject}" => "{\$subject}",
// "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link" => "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link",
"Gift Certificate Information" => "Taarifa ya cheti chawadi",
"Description:" => "maelezo :",
"Percentage Discount" => "Asilimia ya kupunguzwa",
"Value of Gift Certificate" => "Thamani ya hati ya zawadi",
// "Redeem Code" => "Redeem Code",
// "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase" => "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase",
// "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made" => "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made",
"You can review your order at" => "Unaweza kupokea amri yako",
// "Your {\$prefs.mail_template_custom_text}cart order" => "Your {\$prefs.mail_template_custom_text}cart order",
// "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site" => "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site",
"To the newsletter" => "kwa jarida",
// "Please access the following URL to confirm your subscription" => "Please access the following URL to confirm your subscription",
"To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link:" => "Ili kuthibitisha akaunti yako na kuingia kwa {\\ \$ prefs.mail_template_custom_text}, tafadhali bonyeza kiungo kinachofuata:",
"The administrator approved your account." => "Msimamizi amethibitisha akaunti yako.",
// "Confirm your {\$prefs.mail_template_custom_text}email at %s" => "Confirm your {\$prefs.mail_template_custom_text}email at %s",
// "Remove {\$prefs.mail_template_custom_text}file" => "Remove {\$prefs.mail_template_custom_text}file",
"GalleryId" => "Id ya nyumba ya sanaa",
"Identifier" => "Identifier",
// "{\$prefs.mail_template_custom_text}File Gallery quota exceeded" => "{\$prefs.mail_template_custom_text}File Gallery quota exceeded",
"User:" => "Mtumiaji:",
// "A new message was posted to {\$prefs.mail_template_custom_text}forum" => "A new message was posted to {\$prefs.mail_template_custom_text}forum",
"New topic" => "Somo jipya",
// "An anonymous {\$prefs.mail_template_custom_text}user" => "An anonymous {\$prefs.mail_template_custom_text}user",
"An anonymous user" => "Mtumiaji asiyejulikana",
// "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL",
// "Note that this is an edited post" => "Note that this is an edited post",
// "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL" => "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL",
// "To instantly approve this post without logging in, use the following URL" => "To instantly approve this post without logging in, use the following URL",
// "You have been invited to access %0 by %1" => "You have been invited to access %0 by %1",
// "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0" => "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0",
// "Your access is valid until %0" => "Your access is valid until %0",
// "Your {\$prefs.mail_template_custom_text}temporary access to %0" => "Your {\$prefs.mail_template_custom_text}temporary access to %0",
"You are invited by" => "Unaalikwa na",
"You join this group" => "Unashiriki kikundi hiki",
"Join me on %s" => "Jiunge nami %s",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "{\$prefs.mail_template_custom_text}page not found" => "{\$prefs.mail_template_custom_text}page not found",
// "%0 mentioned you in %1" => "%0 mentioned you in %1",
// "You've been mentioned on %0" => "You've been mentioned on %0",
// "A new {\$prefs.mail_template_custom_text}message was posted to you" => "A new {\$prefs.mail_template_custom_text}message was posted to you",
// "Click here to read the full message and / or reply" => "Click here to read the full message and / or reply",
// "New {\$prefs.mail_template_custom_text}message arrived from %s" => "New {\$prefs.mail_template_custom_text}message arrived from %s",
"Hi" => "Habari",
// "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now",
"To login with your username and password, please follow this link" => "Kuingia na jina lako la mtumiaji na nenosiri, fuata kiungo",
"Enjoy the site!" => "Pata ziara nzuri kwenye tovuti!",
"User Account Activated" => "Akaunti ya mtumiaji imeanzishwa",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first",
"has requested an account on" => "Aliomba akaunti",
"Group:" => "kundi :",
"User Tracker" => "Fomu ya Mtumiaji",
// "To validate that {\$prefs.mail_template_custom_text}account, please follow the link" => "To validate that {\$prefs.mail_template_custom_text}account, please follow the link",
"Assign to a group" => "Shirikisha kikundi",
"View user's data" => "Angalia data ya mtumiaji",
"Best regards" => "salamu",
"User Registration Request" => "Ombi la usajili wa mtumiaji",
// "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request" => "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request",
// "You're invited to join my {\$prefs.mail_template_custom_text}network of friends" => "You're invited to join my {\$prefs.mail_template_custom_text}network of friends",
"The user" => "user",
// "registered at your {\$prefs.mail_template_custom_text}site" => "registered at your {\$prefs.mail_template_custom_text}site",
// "New {\$prefs.mail_template_custom_text}user registration" => "New {\$prefs.mail_template_custom_text}user registration",
// "Start of article" => "Start of article",
"Published" => "kuchapishwa",
"By" => "na",
"Bye bye!" => "Kwaheri!",
// "This email address has been removed from the list of subscribers of: " => "This email address has been removed from the list of subscribers of: ",
"Bye bye from %s at %s" => "Unsubscription kwa %s ya %s",
// "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link" => "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link",
"Welcome to our newsletter!" => "Karibu kwenye jarida letu !",
// "This email address has been added to the list of subscribers of: " => "This email address has been added to the list of subscribers of: ",
"You can always cancel your subscription using" => "Unaweza daima kufuta usajili wako kwa kutumia",
"Welcome to %s at %s" => "Karibu %s ya %s",
// "Reply Notification: " => "Reply Notification: ",
// "{\$prefs.mail_template_custom_text}Email Notification" => "{\$prefs.mail_template_custom_text}Email Notification",
// "Someone requested a password reset for your %0account" => "Someone requested a password reset for your %0account",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Tafadhali bofya kwenye kiungo hapa chini ili kuthibitisha nia yako ya kuweka upya nenosiri lako. Utachukuliwa kwenye ukurasa ambapo unahitaji kuingia nenosiri la \"ya kudumu \". Tafadhali kumbuka na usishiriki.",
"Important: Username & password are CaSe SenSitiVe" => "Muhimu: Jina la mtumiaji na nenosiri ni vyeti vya kesi (barua za chini dhidi ya MAJUMU YA CAPITAL)",
"Important: The old password remains active if you don't click the link above." => "Muhimu: Nenosiri la zamani linabaki kazi mpaka bonyeza kiungo hapo juu.",
"Your account information for %s" => "Maelezo ya akaunti yako %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Report on %0 for %1" => "Report on %0 for %1",
// "Last {\$prefs.mail_template_custom_text}Report sent on %0" => "Last {\$prefs.mail_template_custom_text}Report sent on %0",
"Changes in detail" => "Mabadiliko kwa undani",
"You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "Unapokea barua pepe za arifa kama muhtasari wa mara kwa mara. Ili kuwapokea kila mmoja haraka baada ya kufungwa, toa mapendeleo yako %0",
// "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at" => "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at",
"Feed" => "Flux RSS",
// "New categories" => "New categories",
// "Configure settings for the new category at" => "Configure settings for the new category at",
// "New {\$prefs.mail_template_custom_text}source category in RSS feed" => "New {\$prefs.mail_template_custom_text}source category in RSS feed",
// "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes",
"Details" => "maelezo",
"Site" => "tovuti",
// "[%0] Scheduler \"%1\" was healed" => "[%0] Scheduler \"%1\" was healed",
// "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes",
// "[%0] Scheduler \"%1\" is stalled" => "[%0] Scheduler \"%1\" is stalled",
// "Look at this {\$prefs.mail_template_custom_text}link" => "Look at this {\$prefs.mail_template_custom_text}link",
// "A friend sends you a {\$prefs.mail_template_custom_text}link from: " => "A friend sends you a {\$prefs.mail_template_custom_text}link from: ",
// "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link" => "Unaweza kubadilisha uwasilishaji kwa kufuata kiungo hiki",
"Body" => "mwili",
// "New {\$prefs.mail_template_custom_text}article submitted at %s" => "New {\$prefs.mail_template_custom_text}article submitted at %s",
// "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}" => "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}",
// "{\$mail_user|username}" => "{\$mail_user|username}",
// "{\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "{\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}",
// "View the {\$prefs.mail_template_custom_text}tracker item at" => "View the {\$prefs.mail_template_custom_text}tracker item at",
// "The last content before deletion was as follows" => "The last content before deletion was as follows",
"Download the file at" => "Pakua faili",
// "{\$mail_trackerName}" => "{\$mail_trackerName}",
"item" => "kuziba",
// "was deleted at" => "was deleted at",
"was modified at" => "imebadilishwa kuwa",
// "Please visit this {\$prefs.mail_template_custom_text}link before logging in again" => "Please visit this {\$prefs.mail_template_custom_text}link before logging in again",
"Last attempt" => "Jaribio la mwisho",
// "Confirm your {\$prefs.mail_template_custom_text}account at %s" => "Confirm your {\$prefs.mail_template_custom_text}account at %s",
// "{\$prefs.mail_template_custom_text}Site" => "{\$prefs.mail_template_custom_text}Site",
// "{\$prefs.mail_template_custom_text}Account suspended" => "{\$prefs.mail_template_custom_text}Account suspended",
// "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user" => "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user",
"If you want to confirm your membership in this site, click on the following link to login for the first time" => "Ikiwa unataka kuthibitisha uanachama wako kwenye tovuti, bofya kiungo kinachofuata kwa uhusiano wako wa kwanza",
"Welcome to the site!" => "Karibu kwenye tovuti",
"Your personal access to" => "Ufikiaji wako binafsi",
// "joined" => "joined",
// "User joined" => "User joined",
// "You are getting this email because you are a leader of" => "You are getting this email because you are a leader of",
// "Click here to manage members" => "Click here to manage members",
// "You are getting this email because you are a leader" => "You are getting this email because you are a leader",
// "The user needs to be approved before he is admitted" => "The user needs to be approved before he is admitted",
// "user joined" => "user joined",
// "You are getting this email because you are a group leader" => "You are getting this email because you are a group leader",
// "left" => "left",
// "user left" => "user left",
"You or someone registered this email address at" => "Wewe au mtu aliyesajili anwani hii ya barua pepe",
// "If you want to be a registered user in this %0site you will have to use the following link to login for the first time" => "If you want to be a registered user in this %0site you will have to use the following link to login for the first time",
// "Your {\$prefs.mail_template_custom_text}registration confirmation" => "Your {\$prefs.mail_template_custom_text}registration confirmation",
"You will receive an email with the information needed to log into this site the first time" => "Utapokea barua pepe na taarifa zinazohitajika kuingia kwenye tovuti hii mara ya kwanza",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Ombi lako la akaunti limehifadhiwa na litaanzishwa na admin haraka iwezekanavyo.",
"You'll receive email notification once your account is activated." => "Utapokea arifa ya barua pepe mara akaunti yako itaanzishwa.",
"Please do not attempt to login until you receive the email notification." => "Tafadhali usijaribu kuingia mpaka upokea taarifa ya barua pepe.",
// "New {\$prefs.mail_template_custom_text}article post" => "New {\$prefs.mail_template_custom_text}article post",
// "Edit {\$prefs.mail_template_custom_text}article post" => "Edit {\$prefs.mail_template_custom_text}article post",
// "Delete {\$prefs.mail_template_custom_text}article post" => "Delete {\$prefs.mail_template_custom_text}article post",
"{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} ya {\$mail_user|username} na",
"View the article at" => "Angalia makala ya",
"Expiration Date" => "Tarehe ya Kumalizika",
"If you don't want to receive these notifications follow this link" => "Ikiwa hutaki kupokea arifa hizi kufuata kiungo hiki",
"The old article follows" => "Makala ya zamani ifuatavyo",
// "New {\$prefs.mail_template_custom_text}article post at" => "New {\$prefs.mail_template_custom_text}article post at",
// "Edited {\$prefs.mail_template_custom_text}article post at" => "Edited {\$prefs.mail_template_custom_text}article post at",
// "Deleted {\$prefs.mail_template_custom_text}article post at" => "Deleted {\$prefs.mail_template_custom_text}article post at",
// "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at" => "Tazama blogu hiyo",
// "New {\$prefs.mail_template_custom_text}blog post at %s" => "New {\$prefs.mail_template_custom_text}blog post at %s",
"View item calendar at" => "Tazama kalenda ya vitu kwenye",
// "Modified {\$prefs.mail_template_custom_text}calendar item" => "Modified {\$prefs.mail_template_custom_text}calendar item",
// "New {\$prefs.mail_template_custom_text}calendar item" => "New {\$prefs.mail_template_custom_text}calendar item",
"changed" => "iliyopita",
// "A new {\$prefs.mail_template_custom_text}category was created in" => "A new {\$prefs.mail_template_custom_text}category was created in",
"Created by" => "Imetengenezwa na",
"created" => "umba",
// "A {\$prefs.mail_template_custom_text}category was removed in" => "A {\$prefs.mail_template_custom_text}category was removed in",
"Removed by" => "Imeondolewa na",
"removed" => "imeondolewa",
// "A {\$prefs.mail_template_custom_text}category was updated" => "A {\$prefs.mail_template_custom_text}category was updated",
"Updated by" => "Imeongezwa na",
// "Old" => "Old",
"updated" => "iliyosasishwa",
// "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by",
"an anonymous user" => "mtumiaji asiyejulikana",
// "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by",
"You can view the comment by following this link" => "Unaweza kuona maoni kwa kufuata kiungo hiki",
"File Gallery %s changed" => "Faili ya Nyumba ya sanaa% s imebadilishwa",
// "A file was removed from the {\$prefs.mail_template_custom_text}file gallery" => "A file was removed from the {\$prefs.mail_template_custom_text}file gallery",
// "A new file was posted to {\$prefs.mail_template_custom_text}file gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}file gallery",
"File Description" => "Maelezo ya Picha",
// "You can download the new file at" => "You can download the new file at",
// "The new file ID is %0 and it is in gallery ID %1" => "The new file ID is %0 and it is in gallery ID %1",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
"Image Gallery {\$galleryName} changed" => "Nyumba ya sanaa ya {\\ \$ galleryName} imebadilika",
// "A new file was posted to {\$prefs.mail_template_custom_text}image gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}image gallery",
// "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can view the updated map following this link" => "Unaweza kuona ramani iliyofuatishwa ifuatayo kiungo hiki",
"You can edit the map following this link" => "Unaweza kubadilisha ramani kufuatia kiungo hiki",
// "An object was added to {\$prefs.mail_template_custom_text}category" => "An object was added to {\$prefs.mail_template_custom_text}category",
"Added by" => "Imeongezwa na",
// "An object was removed from {\$prefs.mail_template_custom_text}category" => "An object was removed from {\$prefs.mail_template_custom_text}category",
// "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure" => "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure",
"Structure modified" => "Uundo umebadilishwa",
"has consulted your" => "ameshauriana na yako",
"Go to the File Gallery" => "Nenda kwenye Nyumba ya sanaa",
"Download the file" => "Pakua faili",
// "A new file has been attached to {\$prefs.mail_template_custom_text}page" => "A new file has been attached to {\$prefs.mail_template_custom_text}page",
"File name" => "Jina la faili",
// "New {\$prefs.mail_template_custom_text}attachment on %s, page" => "New {\$prefs.mail_template_custom_text}attachment on %s, page",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here" => "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here",
"You can view the page by following this link" => "Unaweza kuona ukurasa kwa kufuata kiungo hiki",
"You can view a diff back to the previous version by following this link" => "Unaweza kutazama tofauti kwenye toleo la awali kwa kufuata kiungo hiki",
"The changes in this version follow below, followed after by the current full page text." => "Ci-dessous, les changements de cette version suivis du texte complet de la page.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lignes: {\$oldd} changées en +Lignes: {\$newd}",
"The old page content follows below" => "L'ancien contenu de la page suit ci-dessous",
"The new page content follows below." => "Ci-dessous, le nouveau contenu de la page.",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}",
"Wiki page renamed" => "Ilibadilisha ukurasa wa Wiki",
"Old name" => "Jina la kale",
"New name" => "Jina jipya",
// "Your %0account ID" => "Your %0account ID",
// "has been generated" => "has been generated",
"Thank you for your %0registration" => "Asante kwa kusajili % 0",
"You may log in now." => "Unaweza kuingia sasa.",
// "Operation Completed" => "Operation Completed",
// "Return to Query List" => "Return to Query List",
// "Do you really want to remove the %0 account" => "Do you really want to remove the %0 account",
// "Delete Account" => "Delete Account",
"Active" => "ulioamilishwa",
"Account name" => "Jina la akaunti",
// "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND" => "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND",
// "Reply handler requires notifications to be enabled and the reply email pattern to be configured" => "Reply handler requires notifications to be enabled and the reply email pattern to be configured",
"POP server" => "Serveur POP",
// "POP" => "POP",
"IMAP" => "IMAP",
"Admin Topics" => "Dhibiti mada",
"Admin Types" => "Kudhibiti aina",
"Allow anonymous access" => "Ruhusu upatikanaji usiojulikana",
// "Warning: Enabling anonymous access will disable all permission checking for mailed-in content" => "Warning: Enabling anonymous access will disable all permission checking for mailed-in content",
// "Allow admin access" => "Allow admin access",
// "Administrators have full access to the system. Disabling admin mail-in is the safest option" => "Administrators have full access to the system. Disabling admin mail-in is the safest option",
"Allow attachments" => "Ruhusu faili zilizounganishwa",
// "Allow routing" => "Allow routing",
// "Allow per user routing of incoming email to structures" => "Allow per user routing of incoming email to structures",
// "Show inline images" => "Show inline images",
// "For HTML email, attempt to create a WYSIWYG wiki-page" => "For HTML email, attempt to create a WYSIWYG wiki-page",
// "Keep HTML format" => "Keep HTML format",
// "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection" => "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection",
"Discard to the end from" => "Puuza mwisho",
// "Auto-assign category" => "Auto-assign category",
// "Only affects wiki-put, when creating a new wiki page" => "Only affects wiki-put, when creating a new wiki page",
// "Auto-assign namespace" => "Auto-assign namespace",
// "Email response when no access" => "Email response when no access",
// "Leave email on server on error" => "Leave email on server on error",
// "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki" => "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki",
// "Add Account" => "Add Account",
// "Operation not reversible" => "Operation not reversible",
// "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used" => "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used",
"Event" => "Tukio",
// "Disable rule" => "Disable rule",
// "Enable rule" => "Enable rule",
// "Unknown status" => "Unknown status",
// "Current Type" => "Current Type",
// "New Type" => "New Type",
// "The rule has been removed" => "The rule has been removed",
// "Are you sure you want to delete this rule" => "Are you sure you want to delete this rule",
// "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it" => "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it",
// "Sample Rule" => "Sample Rule",
// "Basic Rule (Record Event)" => "Basic Rule (Record Event)",
// "Tracker Rule" => "Tracker Rule",
// "Advanced Rule" => "Advanced Rule",
// "Community Control Panel" => "Community Control Panel",
// "Event Chain Diagram" => "Event Chain Diagram",
// "Rule Type" => "Rule Type",
// "Allow Notifications" => "Allow Notifications",
// "Recipient" => "Recipient",
// "Cached sample data helps to view available variables for event types" => "Cached sample data helps to view available variables for event types",
// "Sample available" => "Sample available",
// "Sample currently not available" => "Sample currently not available",
// "Source Event" => "Source Event",
// "Target Event" => "Target Event",
// "All event names are required to have at least 3 components" => "All event names are required to have at least 3 components",
// "%0 Copy" => "%0 Copy",
// "Clone of Menu Id" => "Clone of Menu Id",
// "Symbol Information" => "Symbol Information",
// "Profile Source" => "Profile Source",
"Clone" => "clone",
"dynamic collapsed" => "submenus haijaonekana",
"dynamic extended" => "menus ndogo inayoonekana",
"fixed" => "kudumu",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
"Folder Icon" => "Ingia ya maelezo",
"Path and filename of closed folder icon" => "Njia na jina la ishara ya saraka iliyofungwa",
"Configure icons for menu entries" => "Sanidi icons kwa vituo vya menyu",
"For wiki page, use ((PageName))." => "Kwa kurasa za wiki, matumizi ((PageName)).",
"Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Kuchagua makundi mawili inamaanisha kwamba chaguo itaonekana kama mtumiaji ni wa makundi mawili. Ikiwa unataka vikundi vyote viwili kuona chaguo, panga chaguo 2, moja kwa kila kikundi",
"If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "Ikiwa kiungo ni ((PageName)), huna haja ya kuweka vikundi, chaguo itaonekana tu ikiwa ukurasa unaweza kuonyeshwa",
"Sections" => "sehemu",
"Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Mapendeleo / vipengele tofauti na comma (,) kwa AND (NA) au bar wima (|) kwa OR (OR)",
"Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Toa ruhusa nyingi kwa comma (,) kwa hali ya NA, au kwa bar wima (|) kwa OR",
// "Input an HTML class value for the menu option. Separate with a space for multiple classes" => "Input an HTML class value for the menu option. Separate with a space for multiple classes",
"Tips" => "ushauri",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "Ili kuongeza chaguo mpya kwenye orodha ya kuweka chaguo chaguoNi shamba kwa 0. Ili kuondoa chaguo kuweka shamba la kuondoa kwa 'y'",
"Duplicate options will be ignored" => "Chaguo za Duplicate zitapuuzwa",
"Show Quick URLs" => "Montre l'aide URLs",
"Some useful URLs" => "Baadhi ya URL muhimu",
"Hide Quick URLs" => "Ficha URL za haraka",
"Home" => "Nyumbani",
"Choose" => "Chagua",
"Home Page" => "Ukurasa wa Mwanzo",
"Home Blog" => "Nyumbani-Blogu",
"Home Image Gal" => "Picha ya Nyumbani Gal",
"Home Image Gallery" => "Nyumba ya sanaa ya picha",
"Home File Gal" => "Nyumbani faili Gal",
"Home File Gallery" => "Nyumbani faili ya Nyumba ya sanaa",
"User preferences" => "Mapendeleo ya mtumiaji",
"User prefs" => "Prefs mtumiaji",
"Wiki Home" => "Nyumbani - Wiki",
"List galleries" => "Orodha ya nyumba",
"List image galleries" => "Orodha ya nyumba za picha",
"Upload image" => "Tuma picha",
"Gallery Rankings" => "Ubora wa sanaa",
"Browse a gallery" => "Vinjari nyumba ya sanaa",
"Articles home" => "Nyumbani vitu",
"All articles" => "Nyaraka zote",
"List Blogs" => "Orodha ya blogu",
"Create Blog" => "Unda blogu",
"View a forum" => "Angalia jukwaa",
"View a thread" => "Angalia thread ya mazungumzo",
"View a FAQ" => "Angalia a FAQ",
"Take a quiz" => "Jaza QCM",
"Quiz stats" => "Takwimu za QCM",
"Stats for a Quiz" => "Takwimu za QCM",
"Message Archive" => "Ujumbe uliohifadhiwa",
"Archive is full!" => "Nyaraka imejaa!",
"Unread" => "Ambao haujasomwa",
"Flagged" => "Na bendera",
"Unflagged" => "Hakuna bendera",
"Containing" => "ina",
"Sender" => "mtumaji",
"No messages to display" => "Hakuna ujumbe ulioonyeshwa",
"Broadcast message" => "Kueneza ujumbe",
"All users" => "Watumiaji wote",
"Lowest" => "Mini",
"Very High" => "Kipaumbele cha juu",
"Send" => "kutuma",
"Compose message" => "Tunga ujumbe",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Ikiwa unataka kutoa watumiaji wengine fursa ya kujibu, wezesha <a href='tiki-user_preferences.php'> Ruhusu ujumbe wa watumiaji wengine </a> katika mapendekezo yako.",
// "To: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "To: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"CC" => "CC",
// "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"Reply-to my email" => "Jibu kwa barua pepe yangu",
"The user will be able to reply to you directly via email" => "Mtumiaji anaweza kukujibu moja kwa moja kwa barua pepe",
"Send me a copy" => "Nitumie nakala",
"You will be sent a copy of this email" => "Utapokea nakala ya barua pepe hii",
"No messages to download" => "Hakuna ujumbe wa kupakuliwa",
// "full" => "full",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "Bodi la barua ni kamili! Kuangamiza ujumbe au kumbukumbu kama unataka kuendelea kupokea ujumbe.",
"is reply to" => "Jibu",
"Find replied message" => "Pata ujumbe uliojibu",
"Perform action with checked:" => "Hatua kuchukua juu ya vipengele kuchaguliwa :",
"Mark as read" => "Mark isoma",
"Mark as unread" => "Andika alama isiyofundishwa",
"Mark as flagged" => "Weka bendera",
"Mark as unflagged" => "Usiweke bendera",
"Mark" => "alama",
"Mailbox" => "Bodi la Kikasha",
"Compose" => "Composer",
"Broadcast" => "Tuma kwa kikundi",
"Sent" => "Envoyé",
"Auto-archive age for read messages" => "Hifadhi ya kumbukumbu ya kujifungua kwa ujumbe uliosoma",
"Read message" => "Soma ujumbe",
// "Flagged:Click to unflag" => "Flagged:Click to unflag",
// "Not flagged:Click to flag" => "Not flagged:Click to flag",
"replyall" => "jibu zote",
// "Reply All" => "Reply All",
"Cc" => "Cc",
// "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>",
// "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>",
"Sent Messages" => "Messages envoyés",
"Replied" => "Répondu",
"Not replied" => "Non répondu",
"Move to archive" => "Mettre en archive",
// "Image Metadata for" => "Image Metadata for",
// "<em>Note: only basic metadata processed for this file type</em>" => "<em>Note: only basic metadata processed for this file type</em>",
// "{\$subtypes@key|escape}" => "{\$subtypes@key|escape}",
// "{\$fields@key|lower|capitalize|escape}" => "{\$fields@key|lower|capitalize|escape}",
// "{\$fieldarray.label|escape}" => "{\$fieldarray.label|escape}",
// "{\$fieldarray@key|escape}" => "{\$fieldarray@key|escape}",
// "{\$fieldarray.suffix|escape}" => "{\$fieldarray.suffix|escape}",
// "No metadata found" => "No metadata found",
// "Read-only metadata extracted from the file" => "Read-only metadata extracted from the file",
// "<em>Only basic metadata processed for this file type.</em>" => "<em>Only basic metadata processed for this file type.</em>",
"Control panels" => "Paneli za usanidi",
// "Turn on interactive translation" => "Turn on interactive translation",
// "Comment moderation" => "Comment moderation",
"Clear all caches" => "Futa caches zote",
// "Plugin approval" => "Plugin approval",
// "Logs" => "Logs",
// "Smarty debug window" => "Smarty debug window",
"Display type unknown, you have to enter the banner type" => "Aina ya bendera isiyojulikana, Lazima utoe aina ya bendera",
"You forgot your Google ad_client number !" => "Umehau namba yako ya mteja wa Google AdSense!",
"Thank you for installing Tiki" => "Asante kwa kufunga Tiki",
"To configure your Tiki" => "Sanidi Tiki yako",
"from the menu" => "kutoka kwenye menyu",
"Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Lire la <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Documentation Tiki\" target=\"_blank\">documentation de configuration</a>",
"Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Regarder les <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Démos\" target=\"_blank\">vidéos de démonstration",
"To remove this module" => "Ili kuondoa moduli hii",
"Admin Modules" => " Dhibiti moduli",
"and remove the assistant module" => "na uondoe msaidizi wa moduli",
"You can also add other modules" => "Unaweza pia kuongeza modules nyingine",
"To customize the menu" => "Ili kubadilisha menu",
"Admin Menus" => "Dhibiti menyu",
"and edit menu ID 42" => "na kubadilisha ID ya menyu 42",
"Or, create your own menu and add it to a module" => "Au kuunda orodha yako na uongeze kwenye moduli",
"To begin configuring Tiki, please" => "Kuanza usanidi wa Tiki: ",
"login" => "Ingia",
"as admin" => "kama admin",
"The Tiki Community" => "Jamii ya Tiki",
"To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "Ili kujifunza zaidi, tembelea: <a href=\"http://tiki.org\" title=\"La Communauté Tiki\" target=\"_blank\">http://tiki.org</a>",
"Tiki Documentation" => "Documentation Tiki",
"For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "Kwa msaada, angalia <a href=\"http://doc.tiki.org\" title=\"Documentation Tiki\" target=\"_blank\">http://doc.tiki.org</a>",
"on" => "juu",
"Published on" => "iliyochapishwa juu",
"on blogpost" => "kwenye chapisho la blogu",
"Untitled" => "Haijui",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
"Add Event" => "Ongeza tukio",
"Unit cost" => "Gharama ya kitengo",
"Qty" => "Qty",
// "Cart contains <span>%0</span> items" => "Cart contains <span>%0</span> items",
// "Total weight %0 %1" => "Total weight %0 %1",
"Gift Certificate" => "kipawa Cheti",
"Remove Gift Certificate" => "Ondoa Cheti cha Kipawa",
"Add Gift Certificate" => "Ongeza hati ya zawadi",
"Total:" => "Total :",
"Check-out" => "Angalia",
"Your cart is empty" => "Kadi yako ya ununuzi ni tupu",
"Missing %0 of the following categories" => "%0 kukosa kutoka kwa makundi yafuatayo",
"%0 extra of the following categories" => "Ziada %0 ya makundi yafuatayo",
"Unknown comparison" => "Ulinganisho usiojulikana",
"Impossible condition, %0 of" => "Hali haiwezekani, %0 ya",
"Assign into category" => "Wasilisha kikundi",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
"Unassign category" => "Ondoa kutoka kwa kikundi",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
"Homepage" => "Ukurasa wa nyumbani",
"1 more contributor" => "mchangiaji mmoja zaidi",
"{\$hiddenContributors} more contributors" => "{\$hiddenContributors} washiriki zaidi",
"low" => "chini",
"Sites" => "Sites",
"Sites to validate" => "Maeneo ili kuthibitisha",
"Categories:" => "Jamii:",
"Visited links" => "Viungo vilikutembelewa",
"Pass" => "Nenosiri",
"Add tags" => "Ongeza maneno",
// "No tags yet" => "No tags yet",
"List everything tagged" => "Andika kila kitu kilichowekwa alama",
"Last updated" => "Marekebisho ya mwisho",
"All Groups" => "Makundi yote",
"Your Groups" => "Vikundi vyako",
"Emulated Groups" => "Makundi yaliyotokana",
"Switch to Groups" => "Ruka kwa Vikundi",
"Simulate" => "kuiga",
// "Add Post" => "Add Post",
"insert original" => "ingiza asili",
"insert thumbnail" => "weka thumbnail",
"more" => "zaidi",
"Last %0 Podcasts" => "Last %0 podcasts",
"This is likely not a podcast file" => "Hii hakika si faili ya podcast",
"The path to a podcast player is required" => "Njia ya mchezaji wa podcast inahitajika",
// "{\$link_text}" => "{\$link_text}",
"No profile picture" => "Hakuna picha ya wasifu",
"You" => "wewe",
// "Never logged in" => "Never logged in",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "Fungua console ya operator",
"Execution time" => "Wakati wa kutekeleza",
"Memory usage" => "Kumbukumbu inatumiwa",
// "Queries" => "Queries",
"Server load" => "Mzigo wa seva",
"Logged in as" => "Imeunganishwa kama",
"Log out" => "Ondoka",
// "Return to Main User" => "Return to Main User",
// "Return to main user" => "Return to main user",
"Switch" => "kubadilishana",
"Switch User" => "Ingia kama",
"Email:" => " Anwani ya barua pepe:",
// "Email address or " => "Email address or ",
// "User account ID" => "User account ID",
// "Enter a username and click 'Switch'.<br>Useful for testing permissions" => "Enter a username and click 'Switch'.<br>Useful for testing permissions",
"Switch user" => "Ingia kama",
// "Toggle Dropdown" => "Toggle Dropdown",
"My Account" => "Akaunti yangu",
// "{\$user|username|escape|replace:'&amp;':'&'}" => "{\$user|username|escape|replace:'&amp;':'&'}",
"Log in through CAS" => "Ingia kupitia HKK",
"Log in as admin" => "Ingia kwenye admin",
"Log in through Shibboleth" => "Uunganisho kupitia Shibboleth",
// "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t" => "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t",
"Password:" => "Nenosiri:",
"CapsLock is on" => "Funga Shift. (Caps Lock) inafanya kazi",
"Click here if you've forgotten your password" => "Bofya hapa ikiwa umesahau nenosiri lako",
"I forgot my password" => "Nimesahau nenosiri langu",
"Click here to register" => "Bofya hapa kujiandikisha",
"Click here to log in using the default security protocol" => "Bofya hapa kuingia na itifaki ya usalama ya default",
"Standard" => "kiwango",
"Click here to log in using a secure protocol" => "Bonyeza hapa ili uingie kwa kutumia itifaki salama",
"Secure" => "salama",
"Stay in SSL mode" => "Kaa katika mfumo wa SSL",
"local account" => "akaunti ya ndani",
// "Log in via Facebook" => "Log in via Facebook",
// "Log in via LinkedIn" => "Log in via LinkedIn",
"OpenID Log in" => "Ingia kupitia OpenID",
// "OpenID Login" => "OpenID Login",
"What is OpenID" => "OpenID ni nini",
// "Change the logo" => "Change the logo",
// "Click to change or upload new logo" => "Click to change or upload new logo",
// "{\$module_params.sitetitle|escape}" => "{\$module_params.sitetitle|escape}",
// "{\$module_params.sitesubtitle|escape}" => "{\$module_params.sitesubtitle|escape}",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
// "Edit this menu" => "Edit this menu",
"You have" => "Una",
"new messages" => "ujumbe mpya",
"new message" => "ujumbe mpya",
"You have 0 new messages" => "Huna ujumbe mpya",
// "No article found" => "No article found",
// "No blog post found" => "No blog post found",
"We have" => "Kuna",
"submissions waiting to be examined" => "Mawasilisho yanasubiri ukaguzi",
// "Permissions applied from" => "Permissions applied from",
// "No permissions to display" => "No permissions to display",
"Stay on this page" => "Kaa kwenye ukurasa huu",
"Edit perspectives" => "Badilisha mtazamo",
// "Within %0" => "Within %0",
"Search Terms" => "Tafuta maneno",
"Any type" => "Aina yoyote",
// "Recent Preferences" => "Recent Preferences",
"Wiki feed" => "RSS ya Wiki",
"Blogs feed" => "RSS ya blogu",
"Articles feed" => "RSS ya makala",
"Image Galleries feed" => "RSS ya makala",
"Image Galleries" => "Galleries ya picha",
"File Galleries feed" => "Faili RSS ya faili za faili",
"Forums feed" => "Hifadhi ya RSS ya vikao",
// "Directory feed" => "Directory feed",
// "Calendar feed" => "Calendar feed",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "Tovuti yote",
"Image Gals" => "Galleries ya picha",
"Search for text throughout the site" => "Tafuta maandishi kwenye tovuti yote",
"Go directly to a page, or search in page titles if exact match is not found" => "Nenda moja kwa moja kwenye ukurasa, au tafuta majina ya ukurasa ikiwa mechi halisi haipatikani",
"Edit existing page or create a new one" => "Badilisha ukurasa uliopo au uunda mpya",
// "External" => "External",
"Exact match" => "Mechi halisi",
"Page Relations" => "Uhusiano wa ukurasa",
// "Get short url" => "Get short url",
"Copy" => "Nakala",
// "Copied" => "Copied",
"Tweet with Twitter" => "Chapisha kwenye Twitter",
"Post on my Facebook wall" => "Chapisha kwenye Ukuta wangu wa Facebook",
"Shout date" => "Tarehe ya tangazo",
"Delete this shout" => "Futa hii \"kilio \"",
"Edit this shout" => "Badilisha tangazo hili",
"Read More" => "Soma zaidi",
"Since your last visit on" => "Tangu ziara yako ya mwisho",
"New Images" => "Picha mpya",
"Wiki Pages Changed" => "Ilibadilishwa ukurasa wa wiki",
"New Files" => "Faili mpya",
"New Comments" => "Maoni mapya",
"New Tracker Items" => "Fomu mpya ya fomu",
"New Calendar Events" => "Matukio mapya ya kalenda",
"New Users" => "Mtumiaji mpya",
"click to edit" => "bonyeza ili uhariri",
"Nothing has changed" => "Hakuna mabadiliko",
"Tracker Items" => "Fomu za Fomu",
// "Updated" => "Updated",
"Multiple" => "nyingi",
"including" => "Ikiwa ni pamoja na",
// "No Subversion checkout or unable to determine last update" => "No Subversion checkout or unable to determine last update",
"Find term" => "Tafuta muda",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
"If not found, you will be given a chance to create it" => "Ikiwa neno halipatikani, utapewa fursa ya kuiunda",
"TikiTests Menu" => "Menyu ya TikiTests",
"List Tests" => "Orodha ya Majaribio",
"Create Test" => "Unda Mtihani",
"Top galleries" => "Nyumba maarufu sana",
"Posted to" => "Imetumwa kwa",
"(Read More)" => "(Soma Zaidi)",
// "Missing values" => "Missing values",
"Add Marker" => "Ongeza alama",
"Tracker name" => "Jina la fomu",
"Insert fields in wiki textarea" => "Weka mashamba katika sanduku la maandishi ya wiki",
"There are no translations of this page." => "Hakuna tafsiri za ukurasa huu.",
"Up-to-date-ness" => "Mwisho",
"Incoming" => "zinazoingia",
"To <strong>continue translating</strong>, select the language to translate from" => "Ili <strong> uendelee kutafsiri </ strong>, chagua lugha ya awali kutafsiri",
"update from it" => "sasisha kutoka",
"None match your" => "Hakuna kitu kinachofaa",
"Set your preferred languages." => "Sasisha lugha zako zinazopenda.",
"preferred languages" => "lugha zinazopendwa",
"Outgoing" => "zinazotoka",
"update it" => "sasisha",
"click to view" => "bonyeza ili uone",
"Bookmarks" => "bookmarks",
"Cache" => "Cache",
// "Create Bookmark" => "Create Bookmark",
// "New Folder" => "New Folder",
"Done" => "ukweli",
"Del" => "kufutwa",
"select" => "chagua",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
// "Group information" => "Group information",
"You need to activate user and/or group trackers" => "Lazima uwezesha fomu ya mtumiaji na / au kikundi",
"view" => "kuonyesha",
// "%0 out of %1 users" => "%0 out of %1 users",
"online users" => "watumiaji waliounganishwa",
"online user" => "mtumiaji aliyeunganishwa",
"on host" => "kwenye seva",
"User does not accept messages" => "Mtumiaji hakubali ujumbe",
"Send a message to" => "Tuma ujumbe kwa",
"More Videos" => "Video zaidi",
"No results were found. Are you sure you searched for a tag" => "Hakuna matokeo yaliyopatikana. Una uhakika umetafuta neno muhimu",
"We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "Haturuhusiwi kufikia kikundi kwa wakati huu. Ikiwa una upatikanaji wa kikundi cha Zotero, unaweza kutoa haki ya kusoma tovuti hii",
// "Mark all as read" => "Mark all as read",
// "You receive this notification because you requested it" => "You receive this notification because you requested it",
// "If you did not request these emails or did so in an error, please use the following link" => "If you did not request these emails or did so in an error, please use the following link",
// "Manage your notifications" => "Manage your notifications",
// "Notification Digest" => "Notification Digest",
// "No notifications available" => "No notifications available",
// "Priorities" => "Priorities",
// "No unread notifications" => "No unread notifications",
// "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped" => "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped",
// "Required Action" => "Required Action",
// "Add all members" => "Add all members",
// "OR Select individuals.." => "OR Select individuals..",
// "Add selected members" => "Add selected members",
"Detail" => "undani",
// "Respond" => "Respond",
// "Opened" => "Opened",
// "Logged In" => "Logged In",
// "Unopened" => "Unopened",
// "People" => "People",
// "Empty list" => "Empty list",
// "Responses" => "Responses",
// "Entry" => "Entry",
"Request Date" => "Tarehe ya maombi",
// "Action Req'd" => "Action Req'd",
// "None (Owner)" => "None (Owner)",
// "Nothing to do" => "Nothing to do",
// "Add Item" => "Add Item",
// "On this document" => "On this document",
// "Saving" => "Saving",
// "This window will close automatically in 3 seconds.." => "This window will close automatically in 3 seconds..",
// "An error occurred, please try again" => "An error occurred, please try again",
// "Consent screen" => "Consent screen",
// "Do you really want to proceed" => "Do you really want to proceed",
"No individual permissions, category permissions apply" => "Hakuna kibali cha kibinafsi kinachotumika, vibali kwenye makundi yanayotumika",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "Hakuna haki ya mtu binafsi: haki za kimataifa zinatumika",
"Search and select what you are looking for from the options that appear." => "Tafuta na uchague unachotafuta kutoka kwa chaguo zinazoonekana.",
"No matching results." => "Hakuna matokeo yanayofanana.",
"Search and select what you are looking for from the options that appear.." => "Tafuta na uchague unachotafuta kutoka kwa chaguo zinazoonekana..",
"Comparing version {\$old.version} with version {\$new.version}" => "Kulinganisha toleo {\$ old.version} kwa toleo {\$ new.version}",
"Current" => "Inayoendelea",
"Session" => "kikao",
"Old Session" => "Kipindi cha zamani",
"Old Version" => "Toleo la zamani",
"New Session" => "Sura mpya",
"New Version" => "Toleo jipya",
"Versions are identical" => "Matoleo yanafanana",
// "Example wikidiff plugin syntax" => "Example wikidiff plugin syntax",
"Minimum %0 characters long" => "Wahusika wa chini %0 sana",
// "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + ..",
// "Password is too common" => "Password is too common",
// "Individual permissions" => "Individual permissions",
// "Select image" => "Select image",
// "Pick a file" => "Pick a file",
// "Upload or record media" => "Upload or record media",
// "Convert to List" => "Convert to List",
// "{\$info.title|escape}" => "{\$info.title|escape}",
// "{\$info.description|default:''|escape}" => "{\$info.description|default:''|escape}",
// "Auto generate Biblio Code" => "Auto generate Biblio Code",
// "New reference created" => "New reference created",
// "Problems while creating the reference" => "Problems while creating the reference",
// "[-]" => "[-]",
"vote" => "kura",
// "Use &quot;%0&quot; to separate values" => "Use &quot;%0&quot; to separate values",
"Warning:" => "Onyo:",
// "Reset to default value" => "Reset to default value",
// "Restore current value" => "Restore current value",
// "Change your preference filter settings in order to view advanced preferences by default" => "Change your preference filter settings in order to view advanced preferences by default",
"advanced" => "ya juu",
// "Change your preference filter settings in order to view experimental preferences by default" => "Change your preference filter settings in order to view experimental preferences by default",
"experimental" => "Majaribio",
"Requires" => "inahitaji",
// "You need apply profile" => "You need apply profile",
"You need to set" => "Unahitaji kuweka",
// "Requires package" => "Requires package",
// "Missing tiki package" => "Missing tiki package",
// "User rating" => "User rating",
"Rate" => "nukuu",
// "User rating on thread topic" => "User rating on thread topic",
// "Debug Information" => "Debug Information",
// "Engine does not provide any debug information" => "Engine does not provide any debug information",
"A valid email is mandatory to register" => "Anwani ya barua pepe halali inahitajika kujiandikisha",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
"Use your email address as your log-in name" => "Tumia anwani yako ya barua pepe kuingia",
"Lowercase only" => "Chini ya chini",
// "New Password" => "New Password",
"Confirm password" => "Tena",
// "Passwords match" => "Passwords match",
"Generate a password" => "Tengeneza nenosiri",
"Passcode to register" => "Nambari ya usajili",
"Not your password" => "Sio nenosiri lako",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
"The passcode (to block robots from registration) is" => "Nambari ya usajili kuingia hapa ni",
// "{\$remarksbox_title|escape}" => "{\$remarksbox_title|escape}",
// "Do you really want to remove the %0 scheduler" => "Do you really want to remove the %0 scheduler",
// "Reset the scheduler, will mark this run as failed, allowing it to be executed again" => "Reset the scheduler, will mark this run as failed, allowing it to be executed again",
// "Back to schedulers list" => "Back to schedulers list",
// "Reversal Event" => "Reversal Event",
// "Unique Name" => "Unique Name",
// "Type (e.g. user)" => "Type (e.g. user)",
// "Field value (e.g. user)" => "Field value (e.g. user)",
// "Pt. value" => "Pt. value",
"The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "Nyaraka zinarejeshwa juu ya upendeleo uliowekwa na utaratibu, ukaribu, mzunguko wa suala.",
"Default search behavior" => "Tabia ya ufuatiliaji wa utafutaji",
"By default, all search terms are <em>optional</em>" => "Kwa default, maneno yote ya utafutaji ni <em> hiari </ em>",
"It behaves like an OR logic" => "Inafanana kama AU ya mantiki",
"Objects that contain the more terms are rated higher in the results and will appear first" => "Vipengele vyenye masharti mengi huwekwa nafasi ya juu katika matokeo na itaonekana kwenye nafasi ya juu",
"For example, <strong>wiki forum</strong> will find" => "Kwa mfano, <strong> jukwaa la wiki </ strong> litapata",
"objects that include both tokenized terms" => "vitu vyenye maneno yote",
"objects that include the term <strong>wiki</strong>" => "vitu vyenye neno <strong> wiki </ strong>",
"objects that include the term <strong>forum</strong>" => "vitu vyenye neno <strong> jukwaa </ strong>",
"Boolean operators" => "Waendeshaji wa Boolean",
"You can use AND or OR or NOT also to do a boolean search" => "Unaweza kutumia AND au OR au kufanya utafutaji wa Boolean",
"Example: <strong>wiki and forum</strong> will find objects with both terms" => "Mfano: <strong> wiki na jukwaa </ strong> utapata vitu vina vigezo vyote viwili",
"Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Mfano: <strong> wiki au jukwaa </ strong> utapata vitu vina vyenye moja au nyingine",
"Grouping terms" => "Kundi la maneno",
"Use parenthesis ( ) to group terms into subexpressions" => "Tumia maadili () kwa maneno ya kikundi katika subexpressions",
"Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Mfano: <strong> wiki na (blogu ya jukwaa) </ strong> utapata vitu vyenye <strong> wiki </ strong> na <strong> vikao </ strong> au vyenye <strong> wiki </ strong> na <strong> blogu </ strong> kwa utaratibu wowote",
"Finding phrases" => "Utafutaji wa Phrase",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other" => "Piga herufi kwa alama za nukuu (<kbd> \\ '\\' </ kbd>) ili kupata maneno kwa utaratibu halisi, kwa upande mmoja",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Mfano: <kbd> \"Alex Bell \" </ kbd> haitarudi <strong> Bell Alex </ strong> au <strong> Alex G. Bell </ strong> lakini <strong> Alex Bell </ strong>.",
// "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it" => "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it",
// "media image" => "media image",
// "Expand table" => "Expand table",
// "Restore layout" => "Restore layout",
"Items found" => "Kadi zilizopatikana",
"Indexed" => "Indexed",
// "Queue size" => "Queue size",
// "Batch Size" => "Batch Size",
// "Process %0" => "Process %0",
// "Process Batch" => "Process Batch",
// "Your index was last fully rebuilt on %0" => "Your index was last fully rebuilt on %0",
"version" => "version",
// "Fallback search engine" => "Fallback search engine",
// "Fallback search index was rebuild" => "Fallback search index was rebuild",
// "Fallback search index was not rebuilt" => "Fallback search index was not rebuilt",
// "Execution Statistics" => "Execution Statistics",
// "Current Memory usage" => "Current Memory usage",
// "Memory peak usage before indexing" => "Memory peak usage before indexing",
// "Memory peak usage after indexing" => "Memory peak usage after indexing",
// "Number of queries" => "Number of queries",
// "Rebuilding index.." => "Rebuilding index..",
// "Enable logging" => "Enable logging",
// "Log file is saved as %0" => "Log file is saved as %0",
// "Rebuild" => "Rebuild",
// "Process Queue" => "Process Queue",
// "Indexing Problems" => "Indexing Problems",
// "If the indexing does not complete, check the log file to see where it ended" => "If the indexing does not complete, check the log file to see where it ended",
// "Last line of log file (web)" => "Last line of log file (web)",
// "Last line of log file (console)" => "Last line of log file (console)",
// "Not enough memory" => "Not enough memory",
// "Time limit too short" => "Time limit too short",
// "High resource usage" => "High resource usage",
// "Command Line Utilities" => "Command Line Utilities",
// "Cache Expired" => "Cache Expired",
// "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over" => "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over",
"Index" => "Index",
// "Defined" => "Defined",
"Valid" => "Valid",
// "May not work or corrupt data" => "May not work or corrupt data",
// "Alter" => "Alter",
// "No instances configured" => "No instances configured",
// "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes" => "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes",
// "Create Index" => "Create Index",
// "Return to List of Saved Searches" => "Return to List of Saved Searches",
// "Do you really want to remove the %0 saved search" => "Do you really want to remove the %0 saved search",
// "Other Queries" => "Other Queries",
// "No stored queries" => "No stored queries",
"Create New" => "Unda mpya",
// "This will help you recognize your stored queries if ever you want to modify or remove them" => "This will help you recognize your stored queries if ever you want to modify or remove them",
// "Use Existing" => "Use Existing",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
"Last modification" => " Marekebisho ya mwisho",
// "No pages matched the search criteria test" => "No pages matched the search criteria test",
"Download Log File" => "Pakua faili ya logi",
// "Resend newsletter" => "Resend newsletter",
"Send Newsletter" => "Tuma jarida",
// "Send newsletter" => "Send newsletter",
// "This content is licensed under the terms of the" => "This content is licensed under the terms of the",
"To edit the copyright notices" => "Ili kubadilisha matangazo ya hakimiliki",
// "Know the username" => "Know the username",
// "%0 has been accepted" => "%0 has been accepted",
// "Do you really want to approve %0" => "Do you really want to approve %0",
// "Do you really want to remove %0" => "Do you really want to remove %0",
// "No friends have been added" => "No friends have been added",
// "Incoming requests" => "Incoming requests",
// "Accept and add" => "Accept and add",
// "Still waiting for approval" => "Still waiting for approval",
// "Do you really want to cancel request for %0" => "Do you really want to cancel request for %0",
// "%0 has been removed from your friends" => "%0 has been removed from your friends",
// "Page alias.." => "Page alias..",
"Monitor the Sub-Structure" => "Fuatilia sehemu",
"Stop Monitoring the Sub-Structure" => "Simama ufuatilie sehemu hii",
// "locked by %0" => "locked by %0",
"Locked" => "Locked",
"Edit page" => "Uhariri",
// "Add new child page" => "Add new child page",
// "About &amp; News" => "About &amp; News",
// "Information and introduction portal" => "Information and introduction portal",
"Documentation" => "nyaraka",
// "How to use Tiki" => "How to use Tiki",
// "Development" => "Development",
// "How make Tiki" => "How make Tiki",
// "Forums and general community information" => "Forums and general community information",
// "How make Tiki look pretty" => "How make Tiki look pretty",
// "Manage" => "Manage",
// "Initializite this format with the current tracker fields" => "Initializite this format with the current tracker fields",
// "Tracker Name" => "Tracker Name",
// "File Delimiter" => "File Delimiter",
// "Comma (,)" => "Comma (,)",
// "Semicolon (;)" => "Semicolon (;)",
// "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes" => "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes",
// "Field Type" => "Field Type",
// "Primary Key" => "Primary Key",
// "PK" => "PK",
// "Unique Key" => "Unique Key",
// "UK" => "UK",
// "Read-Only" => "Read-Only",
// "RO" => "RO",
// "Export-Only" => "Export-Only",
// "EO" => "EO",
// "Required to import data. Can be any field as long as it is unique" => "Required to import data. Can be any field as long as it is unique",
// "Impose unique value requirement for the target column. This only works with Transactional Import feature" => "Impose unique value requirement for the target column. This only works with Transactional Import feature",
// "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process" => "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process",
// "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict" => "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict",
// "Simple headers" => "Simple headers",
// "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format" => "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format",
// "Import updates" => "Import updates",
// "Import update" => "Import update",
// "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported" => "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported",
// "Ignore blanks" => "Ignore blanks",
// "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way" => "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way",
// "Transactional import" => "Transactional import",
// "Import transaction" => "Import transaction",
// "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved" => "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved",
// "Bulk import" => "Bulk import",
// "Bulk Import" => "Bulk Import",
// "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent" => "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent",
// "Are you sure you want to delete this item" => "Are you sure you want to delete this item",
// "Delete item" => "Delete item",
// "Select a field.." => "Select a field..",
// "Select Mode" => "Select Mode",
// "No primary key" => "No primary key",
// "Side" => "Side",
// "Filters will be available in partial export menus" => "Filters will be available in partial export menus",
// "Skip Unmodified" => "Skip Unmodified",
// "Will not re-import items that have not changed" => "Will not re-import items that have not changed",
// "Import Completed" => "Import Completed",
// "Your import was completed succesfully" => "Your import was completed succesfully",
"CSV File" => " Faili CSV",
// "Applied filters" => "Applied filters",
// "Create Tracker from File" => "Create Tracker from File",
// "Export Full" => "Export Full",
// "Export Partial" => "Export Partial",
// "Export Custom" => "Export Custom",
// "No tabular formats defined" => "No tabular formats defined",
// "Modes" => "Modes",
"This book" => "Kitabu hiki",
"before" => "kabla",
"after" => "baada",
"don't display" => "usionyeshe",
"Decimals" => "Mapungufu",
"Decimal Point" => "Point ya Nambari",
"Auto Tax" => "Kodi ya Auto",
"Tasks" => "Kazi",
"Book new entries" => "Weka safu mpya",
"Confirm stack entries" => "Thibitisha kuingizwa kwa stack",
"Book into Stack" => "Kitabu katika Hifadhi",
"Accounts" => "Akaunti",
"Journal" => "Journal",
"Fetch all" => "Pata kila kitu",
"Create new account" => "Unda akaunti mpya",
"Edit Account" => "Hariri Akaunti",
"Account number" => "Nambari ya Akaunti",
"Notes" => "Vidokezo",
"Budget" => "Budget",
"Create account" => "Tengeneza akaunti",
"Modify account" => "Badilisha akaunti",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1",
"Delete this account" => "Futa akaunti hii",
"Back to book page" => "Rudi kwenye ukurasa wa usajili",
"Account" => "akaunti",
"Debit" => "debit",
"Credit" => "mikopo",
"Tax" => "Tax",
// "Unlock account" => "Unlock account",
// "Lock account" => "Lock account",
// "Remove account" => "Remove account",
"Create a new account" => "Unda akaunti mpya",
"printable version" => "toleo la kuchapishwa",
"export table" => "ongeza meza",
"View account" => "Tazama Akaunti",
"Edit this account" => "Hariri akaunti hii",
"My books" => "Vitabu vyangu",
"Tax automation" => "Ushuru wa ushuru",
"hide" => "kujificha",
"behind" => "nyuma ya",
// "Close book" => "Close book",
// "Close book? (This action cannot be undone)" => "Close book? (This action cannot be undone)",
"Create a book" => "Unda kitabu cha uhasibu",
"Book properties" => "Mali ya Kitabu",
"Name of the book" => "Jina la kitabu",
"First date in journal" => "Tarehe ya kwanza katika gazeti",
"Last date in journal" => "Tarehe ya mwisho katika gazeti",
"Currency settings" => "Mipangilio ya fedha",
"Currency (up to 3 letters) " => "Fedha (hadi barua 3)",
"Position of the currency " => "Nafasi ya ishara ya sarafu",
"Show no currency" => "Usionyeshe fedha",
"Show currency in front of numbers" => "Onyesha sarafu mbele ya namba",
"Show currency behind numbers" => "Onyesha sarafu nyuma ya namba",
"Decimal point" => "Kipengee cha maadili",
"Decimal" => "decimal",
"Quote strings with" => "Zunguka minyororo na...",
"End of Line" => "Mwisho wa Mstari",
"Carriage return" => "Rejea ya kurudi",
"Line feed" => "Kuweka kwa mstari",
"Carriage Return/Line feed" => "Mtoaji wa Kurudi / Mstari",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
"Allow automatic tax calculation" => "Ruhusu hesabu ya kodi ya moja kwa moja",
"Create a new book" => "Unda kitabu kipya",
// "Canceled Journal" => "Canceled Journal",
// "Booking Date" => "Booking Date",
"Amount" => "kiasi",
"Book a transaction" => "Hifadhi kuandika",
// "\"}Delete account %0" => "\"}Delete account %0",
"Add entry" => "Ongeza kuingia",
"Book" => "rekodi",
// "\"}Record entry in book %0" => "\"}Record entry in book %0",
"Export {\$what}" => "Tuma nje {\\ \$ nini}",
"Export CSV settings" => "Export mipangilio ya CSV",
"Separator between fields" => "Separator kati ya mashamba",
"Quote character for text" => "Nakala ya kutengeneza tabia",
"Export as CSV" => "Tuma kwa CSV",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1",
// "Cancel transaction" => "Cancel transaction",
"Balance" => "Balance",
"Deleted" => "Deleted",
"Debit Account" => "Akaunti inapatikana",
"Debit Amount" => "Kiasi kwenye Mto",
"Debit Text" => "Lebo ya mtiririko",
"Credit Account" => "Akaunti ya kulipwa",
"Credit Amount" => "Montant au Crédit",
"Credit Text" => "Lebo ya Mikopo",
"Book a transaction into the stack" => "Hifadhi kuandika kwenye ukungu",
// "\"}Record stack entry in book %0" => "\"}Record stack entry in book %0",
// "\"}Modify stack entry in book %0" => "\"}Modify stack entry in book %0",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1",
// "Remove transaction" => "Remove transaction",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1",
// "Confirm transaction" => "Confirm transaction",
"Do not group by item" => "Usifanye kikundi kwa kipengele",
"Group by item" => "Gundi kwa kipengele",
"Calendar View" => "Mtazamo wa kalenda",
"Tiki Action Calendar" => "Calendrier des actions Tiki",
"Tools Calendars" => "Kalenda ya vitu vya Tiki",
"Check / Uncheck All" => "Angalia / usifute yote",
"Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>" => "Barua pepe yako ya mtumaji haijawekwa. Unaweza kuiweka <a href=\"%0\" class=\"alert-link\">katika jopo la jumla la admin.</a>",
"Database Version Problem" => "Kuna tatizo na toleo la database yako",
// "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "Vendor folder issues" => "Vendor folder issues",
// "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>" => "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>",
// "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded" => "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded",
// "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries" => "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries",
// "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>" => "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>",
// "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file" => "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file",
// "Installer not locked" => "Installer not locked",
// " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. " => " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. ",
// "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder" => "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder",
// "You can also use the following, on the command line, from the root of your Tiki installation" => "You can also use the following, on the command line, from the root of your Tiki installation",
// "Search Index outdated" => "Search Index outdated",
// "The search index might be outdated. It is recommended to rebuild the search index" => "The search index might be outdated. It is recommended to rebuild the search index",
// "File gallery directory web accessable" => "File gallery directory web accessable",
// "This is a potential security risk" => "This is a potential security risk",
// "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database" => "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database",
// "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>" => "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>",
"Please select some actions to be reported." => "Tafadhali teua baadhi ya vitendo kuripotiwa.",
"End" => "Mwisho",
"Users and Groups" => "Watumiaji na vikundi",
"Misc" => "mbalimbali",
"Units" => "vitengo",
"kb" => "ko",
// "Contribution Time" => "Contribution Time",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
"Accumulated Bar Plot" => "Mchoro wa baa uliokusanywa",
"Background color" => "Rangi ya asili",
// "{\$color}" => "{\$color}",
"Legend background color" => "Background ya rangi ya hadithi",
"Save graphs to image gallery" => "Hifadhi graphics katika nyumba ya sanaa ya picha",
"Records" => "rekodi",
"See Statistics" => "Tazama takwimu",
"contribution" => "mchango",
"contributor" => "mchangiaji",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Delete action from log" => "Delete action from log",
"Select action to perform with checked" => "Chagua hatua ya kufanya na kuchunguza",
// "Delete selected actions from log" => "Delete selected actions from log",
"Edit Action" => "Badilisha hatua",
"Save Action" => "Hifadhi kitendo",
"Statistics" => "Takwimu",
"Volumes are equally distributed on each contributors/author" => "Vipengee vinasambazwa usawa kati ya kila mchangiaji au mwandishi",
"connection time" => "wakati wa kuunganisha",
"connection seconds" => "muda wa kuunganisha kwa sekunde",
"mns" => "mns",
"Volume per category" => "Kitabu kwa jamii",
"Volume per category and per user" => "Kitabu kwa jamii na kwa mtumiaji",
"Number of actions per user" => "Idadi ya vitendo kwa mtumiaji",
"Total number of users" => "Idadi ya watumiaji",
"Number of actions per object" => "Idadi ya vitendo kwa kitu",
"Total number of objects" => "Jumla ya vitu",
// "Bigbluebutton" => "Bigbluebutton",
// "Time in bigbluebutton (in minutes)" => "Time in bigbluebutton (in minutes)",
"Number of actions per category" => "kwa makala zilizochapishwa",
"Number of actions per category and per user" => "Idadi ya vitendo kwa kikundi na kwa mtumiaji",
"Volume per the users' group and per contribution" => "Kitabu na kikundi cha watumiaji na kwa mchango",
"Volume per group and per contribution" => "Kitabu kwa kundi na kwa mchango",
"Volume per user and per contribution" => "Kitabu kwa mtumiaji na kila mchango",
"Volume per users' contribution and time" => "Kitabu kwa mchango wa mtumiaji na wakati",
"Volume per contribution and time" => "Kitabu kwa mchango na wakati",
"Weeks" => "wiki",
"How" => "Jinsi",
"You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded." => "Unahitaji kuangalia sanduku la kumbukumbu kwa kila aina ya hatua tunaweza kuwa na hamu ya kuwa na ripoti fulani baadaye. Ili kuona ripoti ya aina fulani za vitendo, chagua vipengee vya hundi vinavyoripotiwa vya aina hizi za hatua, goto Taboti ya Ripoti na uchague vichujio vya ziada. Ripoti hiyo inao tu matendo yaliyotokea tangu aina ya hatua imewekwa kwenye kumbukumbu.",
"Wiki page actions except viewed will always be recorded but can be not reported." => "Matendo ya ukurasa ya wiki isipokuwa mapenzi Zilizoangaliwa daima kuwa kumbukumbu lakini inaweza kuwa si iliripoti.",
"Recorded" => "Iliyoandikwa",
// "{\$actionlog.action}" => "{\$actionlog.action}",
"Import as CSV" => "Ingiza CSV",
"Banning rules have been updated" => "Sheria za kupiga marufuku zimesasishwa",
"Add or edit rules" => "Ongeza au hariri sheria",
"Rule title" => "Kichwa cha utawala",
"Username regex matching" => "Maneno ya mara kwa mara kwenye majina ya watumiaji",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "Maneno ya mara kwa mara kwenye IP",
"Banned from sections" => "Sehemu zisizoachwa",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "Utawala umewezeshwa kwenye tarehe",
"Rule active from" => "Rule kazi tangu",
"Rule active until" => "Utawala wa kazi juu",
"Custom message to the user" => "Ujumbe maalum kwa mtumiaji",
// "Import rules as CSV" => "Import rules as CSV",
"Column names on the first line" => "Jina la nguzo katika mstari wa kwanza",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
"See" => "mtazamo",
"Import as new rules" => "Ingiza kama sheria mpya",
// "Current rules" => "Current rules",
"x" => "x",
// "Delete selected banning rules" => "Delete selected banning rules",
"User/IP" => "mutumiaji/IP",
// "Delete banning rule" => "Delete banning rule",
// "No rules found" => "No rules found",
"Admin Calendars" => "Dhibiti kalenda",
"Create Calendar" => "Unda kalenda",
"View Calendars" => "Angalia kalenda",
// "Calendar name" => "Calendar name",
"Participants" => "washiriki",
// "Personal" => "Personal",
// "Field will show in popup" => "Field will show in popup",
"Custom location" => "Maeneo yanayopangwa",
"Custom participants" => "Washiriki wa kusanidi",
// "Custom languages" => "Custom languages",
"Add event" => "Ongeza tukio",
// "Delete calendar" => "Delete calendar",
"Edit Calendar" => "Badilisha kalenda",
"Custom classification" => "Uainishaji wa desturi",
"Custom language" => "Lugha zinazofaa",
"Custom subscription list" => "Orodha ya usajili unaowekwa",
"Custom priority" => "Vipaumbele vinavyolingana",
"Personal Calendar" => "Kalenda ya kibinafsi",
"Start of day" => "Anza ya siku",
"End of day" => "Mwisho wa siku",
"Days to display" => "Siku za kuonyeshwa",
"Standard color" => "Rangi ya kawaida",
"Green" => "kijani",
"Purple" => "zambarau",
"Orange" => "machungwa",
"Yellow" => "njano",
"Custom foreground color" => "Maalum ya rangi ya mbele",
"Custom background color" => "Rangi ya asili ya desturi",
"Default event status" => "Hitilafu ya matukio",
// "Show in popup view" => "Show in popup view",
"Show in calendar view" => "Onyesha katika mtazamo wa kalenda",
"Group of users alerted when calendar event is modified" => "Kikundi cha watumiaji kinaelewa wakati ratiba inabadilishwa",
// "Default length of events is all day" => "Default length of events is all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
"Delete events older than" => "Futa matukio ya zamani kuliko",
// "Delete old events" => "Delete old events",
"Browse the category system" => "Vinjari mfumo wa kikundi",
// "Create category" => "Create category",
// "Edit category" => "Edit category",
"Edit this category" => "Badilisha jamii",
"Add new category" => "Ongeza kikundi kipya",
// "Apply parent category permissions" => "Apply parent category permissions",
"Objects in category" => "Vitu katika kikundi",
// "Remove from this category" => "Remove from this category",
// "Remove object from category" => "Remove object from category",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Remove checked" => "Remove checked",
// "Remove objects from category" => "Remove objects from category",
// "Moving objects" => "Moving objects",
"Moving objects between categories" => "Hamisha vitu kati ya makundi",
"Current category" => "Jamii ya sasa",
// "Perform an action on all objects in the current category" => "Perform an action on all objects in the current category",
// "Unassign objects from category" => "Unassign objects from category",
// "Move to selected category" => "Move to selected category",
// "Choose destination category" => "Choose destination category",
// "Copy to selected category" => "Copy to selected category",
// "Add objects" => "Add objects",
"Add objects to category" => "Ongeza vitu kwenye kikundi",
"Objects" => "vitu",
"Quiz" => "jaribio",
"Batch upload" => "Kundi la upakiaji",
// "Sample file content" => "Sample file content",
// "Content templates" => "Content templates",
"Templates" => "templates",
"Visible in no sections" => "Inaonekana katika sehemu yoyote",
"Remove section" => "Futa sehemu",
"Uncategorized" => "Haijajamii",
// "{\$catName}" => "{\$catName}",
// "Remove template" => "Remove template",
"Edit template" => "Badilisha template",
// "Create template" => "Create template",
"Use the Administration page of each enabled feature to allow the use of content templates" => "Tumia ukurasa wa admin wa kipengele kila kuwezeshwa ili kuruhusu matumizi ya templates maudhui",
"Name field is mandatory" => "Jina la shamba linahitajika",
"No features are configured to use templates." => "Hakuna kipengele kinachotumia templates.",
"Template Type" => "Aina ya mfano",
"Text area" => "Sanduku la maandishi",
"Admin Contributions" => "Dhibiti michango",
"Edit the contribution" => "Badilisha mchango",
"Contributions are mandatory in wiki pages" => "Michango ya lazima katika kurasa za wiki",
"Contributions are mandatory in forums" => "Michango inahitajika katika vikao",
"Contributions are mandatory in comments" => "Michango ya lazima katika maoni",
"Contributions are mandatory in blogs" => "Michango ya lazima katika blogu",
"Contributions are displayed in the comment/post" => "Michango iliyochapishwa kwa maoni au makala",
"Create a new contribution" => "Unda mchango mpya",
"List of contributions" => "Orodha ya michango",
// "Remove contribution" => "Remove contribution",
"Admin cookies" => "Kudhibiti kuki",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "Ongeza/hariri kuki",
"Upload Cookies from textfile" => "Tuma faili ya maandishi ya quotes",
"Upload from disk" => "Tuma kutoka kwenye diski",
"Remove all cookies" => "Futa vidakuzi vyote",
"cookie" => "cookie",
// "Remove cookie" => "Remove cookie",
"Manage Credits" => "Dhibiti mikopo",
"(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
"(level credits always 0)" => "(kiwango cha mkopo daima 0)",
"Delete Checked" => "Futa uteuzi",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
"Expiry" => "kumalizika muda",
"Use User Credits" => "Tumia mikopo ya watumiaji",
"Amount:" => "Jumla :",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
"all types" => "aina zote",
"filter" => "filter",
// "Usage Date" => "Usage Date",
"Amount Used" => "Sum kutumika",
"No such user" => "Hakuna mtumiaji kama huyo",
"Manage Credit Types" => "Usimamizi wa aina za mikopo",
"Display Text" => "Onyesha Nakala",
"Unit Text" => "Jaribio la Kitengo",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
"Purge" => "Purger",
"Admin Content Sources" => "Dhibiti vyanzo vya maudhui",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Nenda Utawala->DSN kufafanua darasani inayotumiwa kwenye programu ya kuziba SQL.",
"Create/edit DSN" => "Unda/urekebishe DSN",
"Local (Tiki database)" => "Locale (Tiki database)",
"See db/local.php" => "Angalia db/local.php",
// "Remove DSN" => "Remove DSN",
"Content Authentication" => "Uthibitisho wa Maudhui",
"Identification" => "kitambulisho",
"HTTP Basic" => "Msingi HTTP",
"HTTP Session / Login" => "Saa ya HTTP / Ingia",
"HTTP Session / Visit" => "Sura ya HTTP / Ziara",
"Admin External Wikis" => "Usimamizi za Wiki ya Nje",
"Create/Edit External Wiki" => " Unda / hariri wiki ya nje",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page):" => "URL (tumia \$page ili kubadilishwa na jina la ukurasa katika mfano wa URL: http://www.example.com/tiki-index.php?page=\$page):",
// "<em>[prefix]</em>main, such as tiki_main" => "<em>[prefix]</em>main, such as tiki_main",
"Search as" => "Tafuta kama",
"Leave blank to search using currently active groups." => "Acha tupu kutafuta kutumia vikundi vya sasa vya kazi.",
"ExtWiki" => "Wiki ya nje",
// "Search As" => "Search As",
// "Remove external wiki" => "Remove external wiki",
"Admin Forums" => "Dhibiti vikao",
// "Create Forum" => "Create Forum",
"Age" => "umri",
"PPD" => "PPD",
"Create/Edit Forums" => "Ongeza / Hariri jukwaa",
"Edit this Forum" => "Badilisha jukwaa hili",
"Create New Forum" => "Unda jukwaa jipya",
// "Main details" => "Main details",
// "Image symbolizing the forum" => "Image symbolizing the forum",
"Only allow replies to the first message (flat forum)" => "Ruhusu tu kujibu ujumbe wa mwisho (jukwaa la gorofa)",
"Moderator user" => "Msimamizi wa mtumiaji",
"Moderator group" => "Kikundi cha Moderator",
"Password protected" => "Jilinda na nenosiri",
"Forum password" => "Nenosiri la jukwaa",
"Prevent flooding" => "Zuia mawimbi ya tidal",
"Minimum time between posts" => "Kiwango cha chini kati ya machapisho 2",
// "Send the posts of this forum to this email address" => "Send the posts of this forum to this email address",
// "Prune unreplied-to messages after" => "Prune unreplied-to messages after",
"Prune old messages after" => "Ondoa ujumbe wa zamani baada ya",
// "Forum-mailing list synchronization" => "Forum-mailing list synchronization",
"Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address" => "Ujumbe wa mbele kutoka kwa jukwaa hili hadi anwani hii ya barua pepe, kwa muundo ambao unaweza kurudi kwenye jukwaa",
// "Send emails even when the post is generated by an inbound email" => "Send emails even when the post is generated by an inbound email",
"Append a reply link to outbound mails" => "Ongeza kiungo cha jibu kwa ujumbe unaojitokeza",
// "Originating email address for emails from this forum" => "Originating email address for emails from this forum",
"Add messages from this email to the forum" => "Ongeza ujumbe kutoka kwa anwani hii ya barua pepe kwenye jukwaa",
"POP3 server" => "server POP3",
// "Forums list" => "Forums list",
"Display last post titles" => "Angalia majina ya machapisho ya hivi karibuni",
// "Forum topics (threads) list" => "Forum topics (threads) list",
// "Default order of topics" => "Default order of topics",
"Topics per page" => "Idadi ya mada kwa kila ukurasa",
"Topic list configuration" => "Utekelezaji wa orodha ya masomo",
"Last post title" => "Kichwa cha kuchapishwa mwisho",
"Last post profile picture" => "Avatar ya chapisho la mwisho",
"Author profile picture" => "Avatar ya mwandishi",
"Use topic smileys" => "Kuwa na uwezo wa kuweka kihisia kwenye somo",
"Show topic summary" => "Angalia muhtasari wa mada",
// "Forum threads" => "Forum threads",
// "Default ordering of threads" => "Default ordering of threads",
// "Default style of threads" => "Default style of threads",
"Approval type" => "Aina ya idhini",
// "Topic Rating" => "Topic Rating",
"User Level" => "Kiwango cha mtumiaji",
"eMail" => "Anwani ya barua pepe",
"Online" => "watumiaji",
"Permission" => "Ruhusa",
"Store attachments in" => "Hifadhi faili zilizounganishwa ndani",
// "File system" => "File system",
"Max attachment size (bytes)" => "Ukubwa wa Max mafaili yaliyounganishwa (bytes)",
"Shows number of attachments of the all thread in forum list" => "Inaonyesha idadi ya viambatisho kwenye thread nzima katika orodha ya vikao",
"Duplicate Forum" => "Rudia jukwaa",
"Admin Hotwords" => "Dhibiti maneno/viungo vya moja kwa moja",
"Add Hotword" => "Ongeza neno/kiungo cha moja kwa moja",
"Word" => "neno",
// "Delete hotword" => "Delete hotword",
"Admin HTML Page Dynamic Zones" => "Dhibiti maeneo yenye nguvu ya kurasa za HTML",
"Admin HTML pages" => "Dhibiti kurasa za HTML",
"Edit this page" => "Badilisha ukurasa huu",
"Edit zone" => "Badilisha eneo",
"Dynamic zones" => "Sehemu za nguvu",
"zone" => "ukanda",
"content" => "yaliyomo",
"Mass update" => "Sasisho kubwa",
"Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Utiliser {literal}{ed id=name}{/literal} ou {literal}{ted id=name}{/literal} pour insérer des zones dynamiques",
"Create new HTML page" => "Unda ukurasa mpya wa HTML",
"Edit this HTML page" => "Badilisha ukurasa huu wa HTML",
"Apply template" => "Tumia template",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "nguvu",
"Static" => "tuli",
"Refresh rate (if dynamic)" => "Rejea wakati (ikiwa ni wa nguvu)",
"Last Modif" => "Ilibadilishwa mwisho",
"Admin dynamic zones" => "Dhibiti maeneo ya nguvu",
// "Remove HTML page" => "Remove HTML page",
// "IDS Rules" => "IDS Rules",
// "Add a new Rule" => "Add a new Rule",
// "Rule ID" => "Rule ID",
// "Impact" => "Impact",
// "Edit rule settings" => "Edit rule settings",
// "Edit Rule" => "Edit Rule",
// "Add a new rule" => "Add a new rule",
// "Rule Id" => "Rule Id",
// "Rule Id must be numeric" => "Rule Id must be numeric",
// "Rule Regex" => "Rule Regex",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
"Edit Repository" => "Badilisha amana",
"Create New Repository" => "Unda amana mpya",
"Human-readable repository name" => "Jina linalojulikana la amana",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Chemin d'accès au dépôt (si local : relative ou absolu / racine web - sinon: préfixé avec 'http://'",
"File name of start page" => "Jina la faili kwa ukurasa wa kwanza",
"Start page" => "Ukurasa wa kwanza",
"CSS file to load when browse this repository" => "Faili ya CSS kupakia kuvinjari hifadhi hii",
"CSS File" => "Faili ya CSS",
"Is repository visible to users" => "Je, hifadhi hii inaonekana kwa watumiaji",
"Can files from repository be cached" => "Haki ya faili za cache kutoka kwenye hifadhi",
"Cacheable" => "Inaweza kufungwa",
"Clear all cached pages of this repository" => "Futa kurasa zote za hifadhi hii iliyohifadhiwa",
"Clear cache" => "Futa cache",
"Seconds count 'till cached page will be expired" => "Pili mpaka ukurasa uliohifadhiwa unafutwa",
"Cache expiration" => "Mwisho wa Cache",
"Human-readable text description of repository" => "Maelezo ya kueleweka ya amana",
"Available Repositories" => "Hoteli zinapatikana",
"Edit rules" => "Badilisha sheria",
"Edit Rules for Repository" => "Badilisha Sheria kwa Amana",
"Configure Repositories" => "Sanidi maelekezo",
"List Repositories" => "Orodha ya rejea",
"Configure this Repository" => "Sanidi amana hii",
"View this Repository" => "Tazama saraka hii",
"New Rule" => "Sheria mpya",
"Copy Rules" => "Nakala ya sheria",
"view/hide copy rules dialog" => "onyesha/kujificha mazungumzo ya sheria ili kuiga",
"Source repository" => "Sura ya Chanzo",
// "Rules will be applied in this order ('0' or empty = auto)" => "Rules will be applied in this order ('0' or empty = auto)",
"Rule order" => "Amri ya amri",
"Text to search for" => "Imetafuta maandishi",
"Text to replace" => "Nakala ya kuchukua nafasi",
"Is this regular expression or simple search/replacer" => "Je! Hii ni kujieleza mara kwa mara au kutafuta rahisi/kuchukua nafasi",
"Regex" => "Maneno ya kawaida",
"Is case sensitive (for simple replacer)" => "Je! Kesi hiyo imechukuliwa (kwa ajili ya uingizaji rahisi)",
"Case sensitive" => "Kesi nyeti",
// "subset of chars: imsxeADSXUu, which are regex modifiers" => "subset of chars: imsxeADSXUu, which are regex modifiers",
"Regex modifiers" => "Mabadiliko ya Regex",
"Human-readable text description of rule" => "Maelezo rahisi ya kuelewa ya utawala",
"Check to enable this rule" => "Angalia kuruhusu sheria hii",
"Preview options" => "Chaguo Preview",
"Apply all rules or just this to generate preview" => "Tumia sheria zote au tu kwamba moja kuzalisha hakikisho",
"Apply all rules" => "Tumia sheria zote",
"View source code after rules applied" => "Tazama msimbo wa chanzo baada ya kutumia sheria",
"Code preview" => "Uhakikisho wa Kanuni",
"Generate HTML preview" => "Tengeneza hakikisho la HTML",
"HTML preview" => "Preview ya HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Faili ya mtihani wa Amana ili kuunda hakikisho (tupu = ukurasa wa awali umewekwa)",
"Preview Results" => "Maelezo ya jumla ya matokeo",
"Rules List" => "Orodha ya sheria",
"Case" => "kuvunjika",
// "Admin Invoices" => "Admin Invoices",
"Admin keywords" => "Dhibiti maneno",
"Edit page keywords" => "Badilisha maneno muhimu ya ukurasa",
"Current Page Keywords" => "Maneno ya ukurasa wa sasa",
"Search by page" => "Utafute kwa ukurasa",
"results found" => "matokeo yaliyopatikana",
// "Remove keywords for this page" => "Remove keywords for this page",
"No pages found" => "Hakuna matokeo",
// "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "Kuzalisha nafasi kwa idadi ya ziara",
"List of featured links" => "Orodha ya viungo vilivyowekwa",
// "Remove featured link" => "Remove featured link",
"Add Featured Link" => "Ongeza kiungo kilichojulikana",
"Edit this Featured Link" => "Badilisha kiungo hiki kilichojulikana",
"Create new Featured Link" => "Unda kiungo kipya cha nyota",
"disables the link" => "afya ya hyperlink",
"Link type" => "Aina ya kiungo",
"replace current page" => "Badilisha nafasi ya sasa",
"framed" => "fremu",
"open new window" => "fungua dirisha jipya",
"Mail-in accounts" => "Akaunti za barua pepe",
// "Allow" => "Allow",
// "Leave" => "Leave",
// "Auto-category" => "Auto-category",
// "Auto-namespace" => "Auto-namespace",
"Administrator" => "msimamizi",
// "Admin Mail-in Routes" => "Admin Mail-in Routes",
"Check Mail-in accounts" => "Angalia akaunti za barua pepe",
"Check automatically" => "Angalia kwa moja kwa moja",
"Frequency" => "frequency",
// "Check Manually Now" => "Check Manually Now",
// "Admin Mail-in routes" => "Admin Mail-in routes",
// "Structure Routing" => "Structure Routing",
// "Wiki structures feature is not enabled" => "Wiki structures feature is not enabled",
// "List Menus" => "List Menus",
"Create menu option" => "Kuunda chaguo la menu",
// "Edit This Menu" => "Edit This Menu",
// "Export menu options" => "Export menu options",
// "Import menu options" => "Import menu options",
"Manage menu" => "Dhibiti orodha",
"Menu options" => "Chaguo za Menyu",
// "Save Options" => "Save Options",
// "New option" => "New option",
// "Check this if the option is an alternative to the previous one" => "Check this if the option is an alternative to the previous one",
// "Drag this on to the menu area below" => "Drag this on to the menu area below",
// "URL or ((page name))" => "URL or ((page name))",
// "Test URL" => "Test URL",
// "Remove Option" => "Remove Option",
"Preview menu" => "Aperçu du menu",
// "Deploy" => "Deploy",
// "Menu Options" => "Menu Options",
"RESET" => "upya",
"Clear Cache" => "Futa Cache",
"Show hidden modules" => "Onyesha modules zilizofichwa",
"Hide hidden modules" => "Ficha moduli zilizofichwa",
"Exit Modules" => "Quit Modules",
"Modules Parameters" => "Vigezo vya moduli",
"The following required parameters are missing" => "Vigezo vifuatavyo, ombi, havipo",
"Drag the modules around to re-order then click save when ready" => " Drag modules katika amri taka na bonyeza \"kuokoa\" wakati kufanyika",
"Double click them to edit" => " bonyeza mara mbili ili uhariri",
"Modules with \"position: absolute\" in their style can be dragged in to position" => "Moduli na \"nafasi: kabisa\" mali kwenye safu ya mtindo yanaweza kuburushwa kwenye nafasi yao ya mwisho",
"New modules can be dragged from the \"All Modules\" tab" => "Unaweza ku drag modules mpya kutoka kwenye  tab \"Timu zote za moduli\"",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>",
"More info here" => "Maelezo zaidi hapa",
"Assigned modules" => "Mipangilio iliyowekwa",
"Assign/Edit modules" => "Weka/Hariri modules",
"Assigned Modules" => "Mipangilio iliyowekwa",
"Add module" => "Ongeza moduli",
// "You will need to go" => "You will need to go",
// "to reorder or move modules in the left or right columns since you have created a custom order for these" => "to reorder or move modules in the left or right columns since you have created a custom order for these",
// "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user" => "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user",
"Edit module" => "Badilisha moduli",
"Assign new module" => "Weka moduli mpya",
"Edit this assigned module" => "Badilisha moduli hii iliyopewa",
"Module Options" => "Chaguzi za moduli",
"Custom Modules" => "moduli ya desturi",
// "Delete custom module" => "Delete custom module",
"Create new custom module" => "Unda moduli mpya ya desturi",
"Edit this custom module" => "Editer ce module personnalisé",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Parse using" => "Parse using",
// "Wiki Markup" => "Wiki Markup",
"Objects that can be included" => " Vitu vinavyoweza kuingizwa",
"Available polls" => "Uchaguzi unapatikana",
"Random active poll" => "Kazi ya utafiti iliyochaguliwa kwa nasibu",
"Random current poll" => "Uchaguzi wa sasa ulichaguliwa kwa random",
// "Use gallery" => "Use gallery",
"Random image from" => "Picha iliyochaguliwa kwa random kutoka",
"Dynamic content blocks" => "Maudhui yenye nguvu huzuia",
// "Use dynamic content" => "Use dynamic content",
"External feeds" => "Inapita nje",
// "Use RSS module" => "Use RSS module",
// "Banner zones" => "Banner zones",
// "Use banner zone" => "Use banner zone",
// "Use wiki structure" => "Use wiki structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes",
"To use a default Tiki menu" => "Kutumia orodha ya Tiki ya default",
"All Modules" => " Modules zote",
"Show all modules" => "Onyesha moduli zote",
"Admin newsletter subscriptions" => "Dhibiti usajili kwenye jarida",
"Subscriptions" => "maandishi",
"Groups included through inheritance" => "Vikundi vinajumuishwa na urithi",
// "Remove subscription" => "Remove subscription",
"Wiki Page Name" => "Jina la Ukurasa wa Wiki",
"Validate Addresses" => "Thibitisha anwani",
"Add To List" => "Ongeza kwenye orodha",
"Subscribed" => "amesajiliwa",
// "Mark subscription as valid" => "Mark subscription as valid",
"Unsubscribed" => "kujiondoa",
// "Remove selected subscriptions" => "Remove selected subscriptions",
"Add subscribers" => "Ongeza wasajili",
"You can add several email addresses by separating them with commas." => "Unaweza kuongeza barua pepe nyingi zilizoteuliwa na vitambaa.",
"Add email" => "Ongeza anwani ya barua pepe",
"Add user" => "Ongeza mtumiaji",
"Users from group" => "Watumiaji wa Kikundi",
"Group subscription also subscribes included groups" => "Uandikishaji wa kikundi pia unajumuisha makundi yaliyojumuisha",
// "Don't send confirmation email" => "Don't send confirmation email",
"The user email will be refreshed at each newsletter sending" => "Anwani ya barua pepe ya mtumiaji itajengwa tena kila wakati jarida limepelekwa",
"Import emails from file" => "Ingiza anwani za barua pepe kutoka faili",
// ".txt file, one email per line" => ".txt file, one email per line",
// "Don't send confirmation emails" => "Don't send confirmation emails",
"Import emails from wiki page" => "Ingiza anwani za barua pepe kutoka ukurasa wa wiki",
"Wiki page, one email per line" => "Ukurasa wa Wiki, anwani moja ya barua pepe kwa kila mstari",
// "Import emails from tracker" => "Import emails from tracker",
"Subscribe group" => "Jisajili kikundi",
// "Including group inheritance" => "Including group inheritance",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
"Wiki page" => "Ukurasa wa Wiki",
// "Emails on a wiki page which will be added at each newsletter sending, one email per line" => "Emails on a wiki page which will be added at each newsletter sending, one email per line",
// "Don't subscribe emails" => "Don't subscribe emails",
"Export Subscriber Emails" => "Tuma anwani za barua pepe zilizosajiliwa",
"Admin newsletters" => "Dhibiti majarida",
"List Newsletters" => "Orodha ya majarida",
"Send Newsletters" => "Tuma majarida",
"Editions" => "matoleo",
"Drafts" => "rasimu",
"Last Sent" => "Utoaji wa mwisho",
// "Remove newsletter" => "Remove newsletter",
"Create/Edit Newsletters" => "Ongeza / Hariri jarida",
"There are individual permissions set for this newsletter" => "Haki za kibinafsi zimewekwa kwenye jarida hili",
"Users can subscribe/unsubscribe to this list" => "Watumiaji wanaweza kujiandikisha / kujiandikisha kwenye orodha hii",
"Users can subscribe any email address" => "Watumiaji wanaweza kujiunga na anwani tofauti ya barua pepe",
"Add unsubscribe instructions to each newsletter" => "Ongeza maagizo ya kujiondoa katika kila jarida la kutumwa",
"Validate email addresses" => "Usajili imethibitishwa baada ya kujibu barua pepe",
"Allow customized text message to be sent with the HTML version" => "Fuatilia toleo la HTML la toleo la customizable katika muundo wa maandishi",
"Allow clipping of articles into newsletter" => "Ruhusu snippets makala katika jarida",
"Automatically clip articles into newsletter" => "Ondoa kwa moja kwa moja makala katika jarida",
// "Do not send newsletter if clip is empty" => "Do not send newsletter if clip is empty",
"Clip articles published in the past number of days" => "Futa makala zilizochapishwa katika idadi hii ya siku za mwisho",
"Article types to clip" => "Aina ya vitu ili kuondoa",
"Mail notifications" => "Arifa za barua pepe",
// "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "Ongeza arifa",
"Destination" => "Marudio",
"Myself" => "mimi mwenyewe",
// "Note that a user is not notified for his or her own action" => "Note that a user is not notified for his or her own action",
"User / Group" => "Mtumiaji / Kikundi",
// "Delete mail notification event" => "Delete mail notification event",
// "Delete selected notification events" => "Delete selected notification events",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "OAuth Server" => "OAuth Server",
// "List of clients" => "List of clients",
// "Client_id" => "Client_id",
// "Client_secret" => "Client_secret",
// "Redirect_uri" => "Redirect_uri",
"Admin Polls" => "Dhibiti uchaguzi",
"Preview poll" => "Maelezo ya Uchunguzi",
"Add poll option" => "Ongeza chaguo la kupiga kura",
"Edit poll option" => "Badilisha chaguo la uchaguzi",
"Poll options" => "Chaguzi za Uchaguzi",
"Votes" => "kura",
"Set last poll as current" => "Weka utafiti wa mwisho kama sasa",
"Close all polls but last" => "Funga uchaguzi wote isipokuwa moja ya mwisho",
"Activate all polls" => "Wezesha uchaguzi wote",
"Create poll" => "Unda uchaguzi",
"Edit poll" => "Badilisha utafiti",
"active" => "ulioamilishwa",
"object" => "kitu",
"Toggle Quick Options" => "Wezesha / afya vituo vya haraka",
"Add Option" => "Ongeza Chaguo",
"Leave box empty to delete an option" => "Acha sanduku tupu ili kuondoa chaguo",
// "Votes older than x days are not considered" => "Votes older than x days are not considered",
"0 for no limit" => "0 kwa kikomo",
"Results" => "matokeo",
"Add poll to pages" => "Ongeza utafiti kwenye kurasa",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
"This menu shows only Polls with 'status': \"template\"" => "Orodha hii inaonyesha tu uchaguzi katika 'hali': \"template \"",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
"Lock the pages" => "Zima kurasa",
// "Custom Route" => "Custom Route",
// "Add a new Custom Route" => "Add a new Custom Route",
// "Edit route settings" => "Edit route settings",
// "Edit route" => "Edit route",
// "Add a new route" => "Add a new route",
// "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value" => "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value",
// "The users will get redirected to the tracker item that has a field that matches the value found in the URL" => "The users will get redirected to the tracker item that has a field that matches the value found in the URL",
// "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10" => "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10",
// "Router Type" => "Router Type",
// "Check this option to set route as a Short URL" => "Check this option to set route as a Short URL",
"This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "Ukurasa huu ni kusanidi mipangilio ya feeds za nje zilizosoma/zilizoagizwa na Tiki. Kuzalisha/kuuza nje, angalia \"Feeds\" kwenye jopo la admin, au...",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
"To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed" => "Ili kuzitumia kuzalisha makala, tumia <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Jenereta ya makala <img src=\"img/icons/newspaper_go.png\"></a> kwa ajili ya feed maalum",
"Content for the feed" => "Maonyesho ya kituo",
// "Refresh All feeds" => "Refresh All feeds",
"Show Date" => " Onyesha tarehe",
"Refresh rate" => "Marudio ya kuonyesha upya",
"Article generator" => "jenereta ya makala",
"Edit Feed" => "Badilisha chakula",
"Create Feed" => "Unda RSS Feed",
"Create new external feed" => "Unda mtiririko mpya wa nje",
"Show feed title" => "Onyesha kichwa cha feed",
"Show publish date" => "Onyesha tarehe ya chapisho",
"Article Generator" => "Kigezo cha Makala",
// "Article Generator for %0" => "Article Generator for %0",
// "Once you have defined the settings below, each new item in this rss feed will generate a new article" => "Once you have defined the settings below, each new item in this rss feed will generate a new article",
// "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones" => "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones",
// "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content" => "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content",
"Use Article Submission System" => "Tumia Mfumo wa Uwasilishaji wa Ibara",
"Expiration" => "kumalizika muda",
"Publish in the future" => "Chapisha baadaye",
"-1 to use original publishing date from the feed" => "-1 kutumia tarehe ya kuchapishwa kwanza kwa RSS",
// "Custom Settings for Source Categories" => "Custom Settings for Source Categories",
// "No source categories detected for this feed" => "No source categories detected for this feed",
// "Source Category" => "Source Category",
// "Priority (10 is highest)" => "Priority (10 is highest)",
// "Categorize Created Articles" => "Categorize Created Articles",
"Configure" => "Configure",
"Add a new Scheduler" => "Ongeza Mhariri mpya",
"Schedulers" => "Wachunguzi",
// "Run Time" => "Run Time",
// "Re-Run" => "Re-Run",
// "Edit scheduler settings" => "Edit scheduler settings",
// "Stalled" => "Stalled",
// "Run now" => "Run now",
// "Edit scheduler" => "Edit scheduler",
"Add a new scheduler" => "Ongeza Mpangaji mpya",
// "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *" => "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *",
// "Run if missed" => "Run if missed",
// "Scheduler logs" => "Scheduler logs",
// "Last {\$numOfLogs} Logs" => "Last {\$numOfLogs} Logs",
// "Running" => "Running",
"Failed" => "shindwa",
// "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>",
"Tiki settings" => "Mipangilio ya Tiki",
"Tiki variable" => "Thamani la Tiki",
"Setting" => "Mpangilio",
"Risk Factor" => "Kiwango cha Hatari",
"Explanation" => "Maelezo",
"About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "Kuhusu Wiki Plugins na usalama: Hakikisha utoa \"tiki_p_plugin_approve \" tu kwa wahubiri walioaminiwa",
"You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "Unaweza kuzuia Plugins hatari kwenye ukurasa (<a href=\"tiki-admin.php?page=textarea\"> tiki-admin.php = = textarea </a>)",
"You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>." => "Unaweza kuidhinisha matumizi ya Plugin kwenye <a href=\"tiki-plugins.php\">tiki-plugins.php</a>.",
"Security checks" => "Upekuzi wa usalama",
"Check all tiki files" => "Angalia faili zote za tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Kumbuka, hii inaweza kuchukua muda mrefu sana. Unapaswa kuangalia max_execution_time yako kuweka katika php.ini.",
"File checks" => "Fichiers vérifiés",
"Check file permissions" => "Kagua vibali vya faili",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Ukaguzi huu hujaribu kupata faili na vibali vya faili matatizo. Vibali baadhi ya faili ambazo zinaonyeshwa hapa kama shida inaweza kuwa isiyo na maana au kuepukika katika mazingira fulani.",
"See end of table for detailed explanations." => "Angalia mwisho wa Jedwali kwa maelezo ya kina.",
"owner" => "mmiliki",
"special" => "maalum",
"other" => "nyingine",
"uid" => "uid",
"gid" => "gid",
"suid" => "suid",
"sgid" => "sgid",
"sticky" => "sticky",
"r" => "r",
"w" => "w",
"Set User ID (suid) files" => "Weka faili za Mtumiaji ID (suid)",
"World writable files or directories" => "Files au directories ambazo zinaweza kuhaririwa na mtu yeyote",
"Files or directories the Webserver can write to" => "Files au directories ambayo seva ya Mtandao inaweza kuandika",
"Strange Inodes (not file, not link, not directory)" => "Inodes ajabu (hakuna faili, hakuna kiungo, hakuna saraka)",
"Executable files" => "Faili zilizoweza kutekelezwa",
"What to do with these check results?" => "Nini cha kufanya na matokeo haya?",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
"Admin Shoutbox Words" => "Utawala wa maneno ya megaphone",
"Add Banned Word" => "Ongeza neno la taboo",
"Are you sure you want to delete this word?" => "Una uhakika unataka kuondoa taboo hii?",
// "Rebuild sitemap" => "Rebuild sitemap",
// "Submit the Sitemap" => "Submit the Sitemap",
// "You can submit the sitemap for processing in all major search engines using the following URL" => "You can submit the sitemap for processing in all major search engines using the following URL",
// "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap" => "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap",
// "Automate Sitemap generation" => "Automate Sitemap generation",
// "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t" => "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t",
// "Or you can use directly the command line" => "Or you can use directly the command line",
"XML Zip Import" => "Ingiza faili ya Zip ya XML",
"Feedback" => "habari",
// "Structure created" => "Structure created",
"View Page" => "Tazama ukurasa",
"Please Confirm" => "Thibitisha kutuma",
"You will remove structure" => "Utaifuta muundo",
"Destroy the structure leaving the wiki pages" => "Kuharibu muundo unaoacha kurasa Wiki",
"Destroy the structure and remove the pages" => "Kuharibu muundo na kufuta kurasa",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Tafadhali kumbuka kwamba kurasa zifuatazo pia ni sehemu ya muundo mwingine. Fanya ruhusa za upatikanaji wa uhakika (ikiwa ipo) hazipambano",
"The following pages have automatically been categorized with the same categories as the structure" => "Kurasa zifuatazo zimewekwa moja kwa moja katika jamii sawa na muundo",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "Kurasa zifuatazo ziko katika makundi tofauti na muundo. Ili kukaa thabiti, wanapaswa kuchukuliwa nje ya makundi haya",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "Kurasa zifuatazo ziko katika makundi ambayo muundo haupo. Ili kuhakikisha uwiano, huenda unataka kuwatayarisha",
// "Existing Structures" => "Existing Structures",
// "View Structure" => "View Structure",
"View structure" => "Onyesha muundo",
// "Export pages" => "Export pages",
// "Dump tree" => "Dump tree",
"Create WebHelp" => "Unda Msaada wa Wavuti",
"View WebHelp" => "Angalia msaada wa wavuti",
// "XML Zip" => "XML Zip",
"Perform action with selected" => "Fanya hatua na kipengele cha kuchaguliwa",
".." => "..",
"Delete with the pages" => "Futa na kurasa",
// "Create Structure" => "Create Structure",
"Alias" => "Alias",
"Tree" => "mti",
"Use single spaces to indent structure levels" => "Tumia nafasi moja ya uingizaji",
"Create New Structure" => "Ongeza muundo mpya",
"Edit survey questions" => "Badilisha maswali ya utafiti",
"Add a New Question" => "Ongeza swali jipya",
"List Surveys" => "Liste des enquêtes",
"Survey Stats" => "Takwimu za Utafiti",
"This survey stats" => "Takwimu za utafiti huu",
"Edit this Survey" => "Badilisha utafiti huu",
"Admin Surveys" => "Dhibiti uchunguzi",
"Questions" => "Maswali",
"Question" => "swali",
"Answer is mandatory" => "Jibu la lazima",
// "Required answers" => "Required answers",
// "Single choice using radio buttons" => "Single choice using radio buttons",
// "Example: \"one, two, many, lots\"" => "Example: \"one, two, many, lots\"",
// "(Use \"\\,\" to include a comma" => "(Use \"\\,\" to include a comma",
// "Multiple choice using checkboxes" => "Multiple choice using checkboxes",
"For a rate, you can give the maximum value." => "Kwa notation, unaweza kutumia thamani ya juu.",
// "Multiple choices of thumbnail from a file gallery, options contains Gallery ID" => "Multiple choices of thumbnail from a file gallery, options contains Gallery ID",
// "Example: 4" => "Example: 4",
// "Options are: rows,columns,toolbars" => "Options are: rows,columns,toolbars",
// "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)" => "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)",
// "For the 'short text' type, options are: columns" => "For the 'short text' type, options are: columns",
// "Example: 60" => "Example: 60",
// "A heading to go between questions. Options are newpage,tag" => "A heading to go between questions. Options are newpage,tag",
// "Example: y,h4" => "Example: y,h4",
"Options (if apply)" => "Chaguzi (ikiwa inafaa)",
"Admin surveys" => "Dhibiti uchunguzi",
"Create/Edit Surveys" => "Unda / Badilisha tafiti",
"Create New Survey" => "Unda utafiti mpya",
"There are individual permissions set for this survey" => "Haki za upatikanaji wa kibinafsi zimewekwa kwenye utafiti huu",
// "Synchronize Dev/Prod Servers" => "Synchronize Dev/Prod Servers",
// "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one" => "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one",
// "Remote Server Address" => "Remote Server Address",
// "Show diff" => "Show diff",
// "Local" => "Local",
// "Remote" => "Remote",
"System Administration" => " Utawala wa Mfumo",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Ikiwa Tiki yako haifanyi kazi vizuri, jambo la kwanza kujaribu ni kufuta cache yako chini. Pia muhimu ni kufuta cache yako baada ya kuboresha (kwa FTP / SSH inapohitajika).",
"Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>" => "Pia angalia \"Rebuild Index\" katika <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Jopo la Udhibiti wa Utafutaji</a>",
"Clear cached content" => "Futa maudhui ya cache",
"Empty" => "Vider",
"All user preference sessions" => "Vitu vyote vya upendeleo vya mtumiaji",
"Save directories" => "Hifadhi directories",
"Directories to save" => "Directories ya kuhifadhi",
"Directory is not writeable" => "Saraka haijaandikwa",
"Full Path to the Zip File" => "Njia kamili ya kumbukumbu ya ZIP",
// "ZIP" => "ZIP",
// "Generate zip" => "Generate zip",
"A zip has been written to %0" => "Akaunti ya ZIP imeundwa kwa %0",
"Groups still used in the database but no more defined" => "Vikundi bado vinatumiwa kwenye databana lakini hazifafanuliwa tena",
"Admin Tokens" => "Dhibiti ishara",
// "List tokens" => "List tokens",
// "Timeout" => "Timeout",
// "Hits left" => "Hits left",
// "Max hits" => "Max hits",
// "Create Temp User" => "Create Temp User",
// "Temp User Prefix" => "Temp User Prefix",
"Add new token" => "Ongeza ishara mpya",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
"Groups (separated by comma)" => "Vikundi (kutengwa na comma)",
"View mode" => "Hali ya Mwoneko",
"Wiki and WYSIWYG" => "Wiki et WYSIWYG",
"Wiki only" => "Wiki tu",
// "WYSIWYG (HTML mode)" => "WYSIWYG (HTML mode)",
// "WYSIWYG (wiki mode)" => "WYSIWYG (wiki mode)",
"Reset to Global" => "Rudisha tena kama Global",
"Reset to defaults" => "upya",
"Formatting Tools" => "Vyombo vya kuunda",
"Plugin Tools" => "Vyombo vya Plugin",
"Edit tool" => "Chombo cha kuhariri",
"Wysiwyg Token" => "Jeton Wysiwyg",
"Custom Tools" => "Vyombo maalum",
"Add a new custom tool" => "Ongeza chombo kipya cha desturi",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
"If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools:" => "Ikiwa una matatizo na ukurasa huu baada ya uppdatering kutoka Tiki 4, tafadhali tumia kiungo ili uondoe zana zote za desturi:",
"Delete all custom tools" => "Futa zana zote za binafsi. ",
"Warning: There is no undo!" => "Onyo: hawezi kufuta",
"List Articles" => "Orodha ya makala",
// "Add topic" => "Add topic",
// "Notification Email" => "Notification Email",
// "You will be able to add a notification email per article topic when you edit the topic after its creation" => "You will be able to add a notification email per article topic when you edit the topic after its creation",
"topic image" => "picha ya somo",
"Activate" => "kuamsha",
// "De-activate" => "De-activate",
"Remove with articles" => "Futa kwa makala",
// "Tracker Fields" => "Tracker Fields",
"Admin Tracker" => "Dhibiti fomu",
// "Import Fields" => "Import Fields",
"Mandatory" => "lazima",
"Save All" => "Jisajili kila kitu",
"Remove Selected" => "Futa uteuzi",
"Export Selected" => "Chagua uteuzi",
"Subset Selection" => " Uchaguzi wa subsets",
"Category Selection" => "Sélection des catégories",
"Group Selection" => " Uchaguzi wa kikundi",
"Add Group" => "Ongeza Kikundi",
// "Press Enter for each group" => "Press Enter for each group",
// "At least two elements are required to create transitions. Additional tabs appear once the selection is completed" => "At least two elements are required to create transitions. Additional tabs appear once the selection is completed",
"Draw Transition Diagram" => "Chora mchoro wa mpito",
"Guards" => "Guards",
"preserved" => "hifadhi",
"No transitions" => "Hakuna mabadiliko",
"New / Edit" => "New / Hariri",
"Edit <em>%0</em>" => "hariri <em>%0</em>",
"New transition" => "Mpito mpya",
"Upon trigger, preserve the initial state" => "Baada ya kuchochea ,hifadhi hali ya awali",
"Members" => "wanachama",
"No guards on this transition" => "Hakuna sentinels juu ya mpito huu",
"New Guard" => "Sentinel mpya",
"Exactly" => "hasa",
"States" => "Amerika",
// "Body of POST request" => "Body of POST request",
"Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Ingiza URL ya huduma za wavuti zinazorejea JSON au YAML. Vigezo vinaweza kutajwa kwa majina yao yaliyotengenezwa na ishara '%'. Kwa mfano:% jina%. Lakini% huduma% na% template% ni maneno yaliyohifadhiwa na hayawezi kutumika",
"Parameters (%name%)" => "Vigezo (% jina%)",
"Operation" => "operesheni",
// "%0 requires no parameter" => "%0 requires no parameter",
// "Test Input" => "Test Input",
// "Bypass cache" => "Bypass cache",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
"Not supported" => "Haijaungwa mkono",
"Schema Version" => "Toleo la Schema",
"Schema Documentation" => "Nyaraka za Schema",
// "Not specified, default used" => "Not specified, default used",
"Content Type" => "Aina ya maudhui",
"Not specified" => "Haijajulikana",
"Returned Data" => "Takwimu zimerejea",
// "tuncated at approx. 1MB" => "tuncated at approx. 1MB",
"Proposed Templates" => "Nyaraka zilizopendekezwa",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
"Register Service" => "Jisajili Huduma",
"Registered Templates" => "Nyaraka zilizosajiliwa",
"Engine" => "Moteur",
"Output" => "Sortie",
// "Toggle template source" => "Toggle template source",
// "Register Template" => "Register Template",
// "Add New Group" => "Add New Group",
"Invitation List" => "Liste d'invitation",
"List of existing groups" => " Orodha ya vikundi vilivyopo",
"Inherits Permissions from" => "Urithi idhini kutoka",
"User Choice" => " Uchaguzi wa mtumiaji",
"Edit group" => "Badilisha kundi",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
"Create group" => "kuunda kikundi",
"Group is NOT being monitored. Click icon to START monitoring" => "Kundi hili halifuatikani. Bonyeza kwenye icon ili ufuatiliaji START",
"Group IS being monitored. Click icon to STOP monitoring" => "Kikundi hiki ni chini ya ufuatiliaji. Bofya kwenye ishara ili uzuie ufuatiliaji",
"Inheritance" => "Urithi",
"Permissions will be inherited from these groups." => "Ruhusa zitatokana na vikundi hivi.",
// "Indirectly included groups" => "Indirectly included groups",
// "Group Home" => "Group Home",
"Use wiki page name or full URL" => "Tumia jina la ukurasa wa Wiki au URL kamili",
"For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "Kwa vipengele vingine vya Tiki, tumia viungo vya jamaa (kama <em> /tiki-forums.php </ em>)",
// "Default Category" => "Default Category",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Kundi la kuhusishwa lililohusishwa kwa vitu vilivyotengenezwa na mtumiaji na kundi hili la default",
"Use site default" => "Tumia thamani ya default ya tovuti",
// "Group color" => "Group color",
// "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color" => "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color",
"Group Information Tracker" => "Fomu ya Taarifa ya Kikundi",
// "choose a group tracker .." => "choose a group tracker ..",
// "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign" => "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign",
"choose a field ..." => "chagua shamba...",
// "Select the user selector field from the above tracker" => "Select the user selector field from the above tracker",
// "Go to trackers list" => "Go to trackers list",
// "User Registration Tracker" => "User Registration Tracker",
// "choose a user tracker .." => "choose a user tracker ..",
// "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign" => "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign",
// "Select user field" => "Select user field",
"Choose a field .." => "Chagua shamba ..",
// "No fields in tracker .." => "No fields in tracker ..",
// "Select the user selector field from the above tracker to link a tracker item to the user upon registration" => "Select the user selector field from the above tracker to link a tracker item to the user upon registration",
// "No fields in this tracker" => "No fields in this tracker",
// "Go to tracker list" => "Go to tracker list",
// "User Wizard Fields" => "User Wizard Fields",
// "By default, the same fields as in registration are used" => "By default, the same fields as in registration are used",
// "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time" => "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time",
// "Group or User Tracker Registration Fields" => "Group or User Tracker Registration Fields",
// "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete" => "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete",
"User can assign himself or herself to the group" => " Mtumiaji anaweza kujiweka katika kundi hili mwenyewe",
"Membership expiry" => "Mwisho wa uanachama",
"Anniversary" => "siku ya kuzaliwa",
"Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date." => "Tumia MMDD kutaja tarehe ya kila mwaka ambayo watumiaji wote hawatathiriwa mu kikundi, au DD kutaja tarehe ya kila mwezi.",
"Or" => "Ou",
"Number of Days" => "Idadi ya Siku",
"Number of days after which all users will be unassigned from the group." => "Idadi ya siku baada ya watumiaji wote hawatashirikiwa kutoka kikundi.",
// "Pro-Rate Membership" => "Pro-Rate Membership",
"Payment for membership extension is prorated at a minimum interval." => "Malipo ya ugani wa uanachama hutolewa kwa muda mdogo.",
"Users are automatically assigned at registration in the group if their emails match the pattern." => "Watumiaji hutolewa moja kwa moja kwa haraka kama wanajiandikisha kwa kikundi kama anwani yao ya barua pepe iko katika fomu.",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
"Assign Permissions" => "kutoa ruhusa ",
"Group tracker item : {\$groupitemid}" => "Kadi ya kikundi: {\$groupitemid}",
"Edit Item" => "Badilisha kadi",
"Group tracker item not found" => "Karatasi ya kikundi haipatikani",
// "</i>\"}%0 members" => "</i>\"}%0 members",
// "Assigned" => "Assigned",
"Edit user" => "Badilisha mtumiaji",
// "Remove from group" => "Remove from group",
// "No members" => "No members",
// "Add or ban users" => "Add or ban users",
"Add to group" => "Ongeza kwenye kikundi",
// "Ban from group" => "Ban from group",
// "</i>\"}Users banned from %0" => "</i>\"}Users banned from %0",
// "Banned members" => "Banned members",
"Unban user" => "Piga marufuku mtumiaji",
// "Unban user %0 from group %1" => "Unban user %0 from group %1",
// "No banned members" => "No banned members",
// "</i>\"}%0 import/export" => "</i>\"}%0 import/export",
// "Export group users (CSV file)" => "Export group users (CSV file)",
"Charset encoding" => "Waandishi wa kuandika",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
// "Import users to group (CSV file)" => "Import users to group (CSV file)",
// "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "Ongeza mtumiaji mpya",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
"Number of displayed rows" => "Idadi ya mistari iliyoonyeshwa",
"More Criteria" => "Vigezo zaidi",
"Group (direct)" => "Kikundi (moja kwa moja)",
// "Email not confirmed" => "Email not confirmed",
// "User not validated" => "User not validated",
"OpenID" => "OpenID",
// "Edit account settings" => "Edit account settings",
"N" => "N",
"Registered %0 ago" => "Imejiunga tangu %0",
"Need to validate email" => "Inahitaji uthibitishaji wa barua pepe",
// "Edit this included group" => "Edit this included group",
// "Add or remove from a group" => "Add or remove from a group",
// "Edit group expiry" => "Edit group expiry",
"Change user preferences" => "Badilisha mapendekezo ya mtumiaji",
// "Switch to this user" => "Switch to this user",
// "Validate user" => "Validate user",
// "Invalidate user" => "Invalidate user",
// "Remove link with OpenID for this user" => "Remove link with OpenID for this user",
"Remove link with OpenID account" => "Futa kiungo na akaunti ya OpenID",
"Remove users..." => "Ondoa watumiaji...",
// "Ban IPs" => "Ban IPs",
"Change group assignments" => "Badilisha kazi za kikundi",
"Set default groups" => "Weka makundi ya kwanza",
"Send wiki page content by email" => "Tuma maudhui ya ukurasa wa wiki kwa barua pepe",
// "Warning: User Encryption is Active" => "Warning: User Encryption is Active",
// "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted" => "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted",
"Assign user to Groups" => "Weka mtumiaji kwa vikundi",
// "Intertiki Enabled" => "Intertiki Enabled",
// "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"" => "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"",
"Use the email as username" => "Tumia anwani ya barua pepe kama jina la mtumiaji",
// "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames" => "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames",
// "Changing username is disabled for Intertiki sites" => "Changing username is disabled for Intertiki sites",
"No password is required" => "Nenosiri halihitajiki",
"Tiki is configured to delegate the password managment to LDAP" => "Tiki imeandaliwa kugawa usimamizi wa nenosiri kwa LDAP",
"New password" => "Nenosiri mpya",
"Confirm new password" => "Thibitisha nenosiri mpya",
"User must change password at next login" => "Mtumiaji lazima kubadilisha password yake katika kuingia kwake ijayo",
"Send an email to the user to enable him or her to validate their account." => " Tuma barua pepe kwa mtumiaji kuangalia akaunti yake.",
// "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>",
// "Add a user tracker item for this user" => "Add a user tracker item for this user",
// "User tracker" => "User tracker",
// "View item" => "View item",
// "Modify this user\\'s data" => "Modify this user\\'s data",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
"You do not have permission to edit this user" => "Huna haki ya kurekebisha mtumiaji huyu",
// "Your file should contain in the first row (first entry) the following fields" => "Your file should contain in the first row (first entry) the following fields",
// "user1,pass1,email1,group1,group1" => "user1,pass1,email1,group1,group1",
// "user2,pass2,email2,\"group1,group2\",group1" => "user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time" => "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time",
// "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any" => "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any",
"Existing Users" => " Watumiaji wanaoishi",
"Don't overwrite" => " Usiondoe",
"Overwrite groups" => "Weka vikundi",
"Create groups" => "Unda vikundi",
"The user must change his or her password the first time they log in" => "Mtumiaji lazima kubadilisha password yake mara ya kwanza anaingia",
// "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>" => "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>",
"Temporary Users" => "mtumiaji wa muda mfupi",
"Token Access Feature Dependency" => "Kipengele cha Upatikanaji wa Kitambulisho",
"The token access feature is needed for Temporary Users to login." => "Kipengele cha upatikanaji wa ishara kinahitajika kwa watumiaji wa muda wa kuingia. ",
"Turn it on here." => "kugeuka hapa",
// "Feature Conflict" => "Feature Conflict",
// "This feature currently is incompatible with the \"Use email as username\" feature" => "This feature currently is incompatible with the \"Use email as username\" feature",
// "Turn it off here" => "Turn it off here",
// "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature" => "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature",
// "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token" => "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token",
// "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself" => "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself",
// "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms" => "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms",
// "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails" => "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails",
// "To revoke access before validity expires or to review who has access, please see" => "To revoke access before validity expires or to review who has access, please see",
// "Email addresses (comma-separated)" => "Email addresses (comma-separated)",
// "Valid for days (use -1 for forever)" => "Valid for days (use -1 for forever)",
// "Username prefix" => "Username prefix",
// "Autologin (non-SEFURL) path" => "Autologin (non-SEFURL) path",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences",
"Add Type" => "Ongeza aina",
"Add article type" => "Ongeza aina ya kipengee",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
"View articles with this type" => "Onyesha makala ya aina hii",
"Show before publish date" => "Angalia kabla ya tarehe ya kuchapishwa",
"Show after expire date" => "Onyesha baada ya tarehe ya kumalizika",
"Heading only" => "Kichwa tu",
// "Comment can rate article" => "Comment can rate article",
"Show image" => "Tazama picha",
"Show profile picture" => "Tazama avatar",
"Show expire date" => "Onyesha tarehe ya kumalizika muda",
"Show reads" => "Onyesha idadi ya kusoma",
"Show size" => "Tazama ukubwa",
"Show topline" => "Onyesha kichwa cha juu",
"Show subtitle" => "Onyesha kichwa",
"Show source" => "Tazama msimbo wa chanzo",
// "Show image caption" => "Show image caption",
"Creator can edit" => "Muumba anaweza kuhariri",
"Custom attribute" => "Tabia maalum",
"Assign User %0 to Groups" => "Weka kikundi moja au zaidi kwa mtumiaji %0",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"backlinks to" => "Kurasa zinazozungumzia",
"No backlinks to this page" => "Hakuna ukurasa unaoelezea ukurasa huu",
"Directory batch upload" => "Kitabu cha barua cha kundi",
"Browse Gallery" => "Vinjari nyumba ya sanaa",
"Upload From Disk" => "Tuma kutoka kwa diski",
"available images" => "picha zinapatikana",
"Filesize" => "Weka faili",
"Filetype" => "Aina ya faili",
"Remove File Extension from Image Name" => "Toa kama jina la picha jina la faili bila ugani wake",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ex. kwa \"digicam0001.jpg \" jina litakuwa digicam0001",
"Convert the last sub directory to a sub gallery" => "kubadilisha subdirectory ya mwisho kwenye nyumba ndogo ya sanaa",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "mfano: kwa mti \"misc / viwambo / digicam0001.jpg \" nyumba ya sanaa inayoitwa \"viwambo \" itaundwa",
"Use the last sub directory name as description" => "Tumia jina la mwisho la vijamii kama maelezo",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "mfano: kwa mti kama \"misc / viwambo / digicam0001.jpg \" maelezo \"skrini \" itaongezwa kwenye picha",
"Select a Gallery" => "Chagua nyumba ya sanaa",
"Process" => "mchakato",
"Browse File Gallery" => "Vinjari nyumba ya sanaa ya faili",
"Please do not use this feature to upload data into the database." => "Tafadhali usitumie kipengele hiki kutuma data kwenye databana.",
"Available Files" => "Faili zilizopatikana",
// "File Permissions" => "File Permissions",
// "File is writable" => "File is writable",
// "File is not writable" => "File is not writable",
"Total: %0" => "Total : %0",
"Select a File Gallery" => "Chagua nyumba ya sanaa",
"Root" => "mizizi",
// "Upload into galleries according to sub-directories" => "Upload into galleries according to sub-directories",
// "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists" => "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists",
// "Create sub-galleries" => "Create sub-galleries",
// "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set" => "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set",
// "Upload into galleries according sub-directory as galleryId" => "Upload into galleries according sub-directory as galleryId",
// "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists" => "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists",
"Process files" => "Faili za mchakato",
"Edit Post" => "Badilisha uchapishaji",
"New Post" => "Publication mpya",
"View post" => "Tazama uchapishaji",
"View Blog" => "Angalia blogi",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Kumbuka: Hii ni hakikisho, na haijahifadhiwa bado",
"Excerpt" => "dondoo",
"Admin the Category System" => "Dhibiti mfumo wa kikundi",
"Browse in" => "Pitia kwenye",
// "or in" => "or in",
"Image galleries" => "Galleries ya picha",
"Trackers Items" => "Fomu za fomu",
"Sheets" => "karatasi",
// "Find in" => "Find in",
// " in the current category and its subcategories" => " in the current category and its subcategories",
"Hide subcategories objects" => "Ficha vitu vijamii",
"Show subcategories objects" => "Onyesha pia vitu vya vijamii",
// "Up one level" => "Up one level",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
// "Clear tags" => "Clear tags",
"With all selected tags" => "Kwa maneno yote yaliyochaguliwa",
"With one selected tag" => "Kwa moja ya maneno yaliyochaguliwa",
"With last selected tag" => "Na nenosiri la mwisho lililochaguliwa",
"More Popular Tags" => "Maneno muhimu zaidi",
"Alphabetically" => "kialfabeti",
"By Size" => "kwa ukubwa",
"Cloud" => "wingu",
// "{\$feature_label}" => "{\$feature_label}",
// "Filter in" => "Filter in",
// "All blogs" => "All blogs",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
// "Delete Tag" => "Delete Tag",
"Browsing Gallery:" => "Kozi ya nyumba ya sanaa:",
// "Gallery actions" => "Gallery actions",
"List Galleries" => "Orodha ya nyumba ya sanaa",
"Edit Gallery" => "Hariri nyumba ya sanaa",
"Upload Image" => "Tuma picha",
"Directory Batch" => "Kushusha kwa seva",
"List Gallery" => "Maudhui ya nyumba ya sanaa",
"All Images" => "Picha zote",
"Rebuild Thumbnails" => "Punguza vifungo",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "Weka picha na",
"subgallery" => "subgallery",
"Subgallery" => "Subgallery",
// "Original size" => "Original size",
"rotate right" => "mzunguko wa kulia",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Unaweza kuona picha imefungwa kwa nyumba hii ya sanaa (kwanza, random, nk) katika kivinjari chako ukitumia",
"You can include the gallery's image in an HTML page using" => "Unaweza kuingiza picha ya nyumba ya sanaa kwenye ukurasa wa HTML kwa kutumia",
"You can include the image in a tiki page using" => "Unaweza kuingiza picha kwenye ukurasa wa tiki ukitumia",
"Browsing Image" => "Kozi ya picha",
"Return to Gallery" => "Rudi kwenye nyumba ya sanaa",
"Edit Image" => "Badilisha picha",
"Bigger" => "Kubwa",
// "Slideshow forward" => "Slideshow forward",
// "Repeat" => "Repeat",
"Click to zoom" => "Bofya ili upeze",
"Image Name" => "Jina la picha",
"Image size" => "picha ya pixel",
"Image Scale" => "Kiwango cha picha",
"Original Size" => "Ukubwa wa awali",
"Move image" => "Hamisha picha",
"Include the image in a tiki page using the following syntax" => "Weka picha katika ukurasa wa tiki kwa kutumia syntax ifuatayo",
"To include the image in an HTML page" => "Ili ni pamoja na picha katika ukurasa wa HTML",
"To link to this page from another tiki page" => "Kuunganisha na ukurasa huu kutoka kwenye ukurasa mwingine wa tiki",
// "Monitoring" => "Monitoring",
"Visible Calendars" => "Kalenda zinazoonekana",
"Group Calendars" => "Kalenda za kikundi",
"Export calendars" => "Kalenda ya kuuza nje",
"advanced parameters" => "mipangilio ya juu",
"Export as iCal" => "Tuma kwa muundo wa iCal",
"January" => "Januari",
"February" => "Februari",
"March" => "Machi",
"April" => "Aprili",
"May" => "mei",
"June" => "Juni",
"July" => "Julai",
"August" => "Agosti",
"September" => "Septemba",
"October" => "Oktoba",
"November" => "Novemba",
"December" => "Desemba",
"Jan." => "jan.",
"Feb." => "feb.",
"Mar" => "mar",
"Apr." => "apr.",
"Aug." => "aug",
"Sep." => "sept.",
"Oct." => "oct.",
"Nov." => "nov.",
"Dec." => "dec.",
"Sun" => "dim.",
"Mon" => "lun.",
"Tue" => "tue.",
"Wed" => "wed.",
"Thu" => "Thu.",
"Fri" => "fri.",
"Sat" => "sat.",
"today" => "leo",
// "semester" => "semester",
// "quarter" => "quarter",
"all-day" => "siku nzima",
"Organized by" => "Iliyoandaliwa na",
"Classification" => "uainishaji",
"View this Week" => "Onyesha wiki hii",
"Change Focus" => "Badilisha mtazamo",
"View this Day" => "Onyesha siku hii",
"Calendar event : " => "Tukio la kalenda :",
"New event" => "Tukio jipya",
"View event" => "Tazama tukio hili",
"Edit/Delete event" => "Badilisha / Futa tukio",
// "Export Event as iCal" => "Export Event as iCal",
"Edit Calendar Item" => "Badilisha tukio la kalenda",
"New Calendar Item" => "Tukio la kalenda mpya",
"Recurrence" => "kujirudia",
"This event depends on a recurrence rule" => "Tukio hili ni la kawaida",
"ending by" => "kumaliza",
"ending after" => "kuishia baada",
"events" => "matukio",
// "(%0 events have been manually modified)" => "(%0 events have been manually modified)",
// "(%0 event has been manually modified)" => "(%0 event has been manually modified)",
"This event is not recurrent" => "Tukio hili sio la kawaida",
"On a weekly basis" => "kila wiki",
"Each" => "kila",
"of the week" => "ya wiki",
"On a monthly basis" => "Mensuel",
"of the month" => "ya mwezi",
"On a yearly basis" => "mwaka",
"of" => "ya",
"Starting on" => "Kuanzia",
"Start period" => "Mwanzo wa kipindi hicho",
// "End Period" => "End Period",
"End after" => "Mwisho baada",
"occurrences" => "matukio",
// "occurrence" => "occurrence",
"End before" => "Mwisho kabla",
// "Event occurs once on" => "Event occurs once on",
"Event is repeated" => "Tukio hilo ni mara kwa mara",
"times" => "wakati",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
"of every month" => "kila mwezi",
"on each" => "kila",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
// "starting" => "starting",
// "ending" => "ending",
"Show duration" => "Onyesha muda",
"Events cannot end before they start" => "Tukio haliwezi kumaliza kabla ya kuanza kwake",
"No description" => "Hakuna maelezo",
"or new" => "au mpya",
"Choose users to alert" => "Chagua watumiaji kuwa macho",
"Withdraw me from the list of participants" => "Kuondoka kwenye orodha ya washiriki",
"Add me to the list of participants" => "Nipeze kwenye orodha ya washiriki",
"Roles" => "majukumu",
"chair" => "mwenyekiti",
"default role" => "jukumu la msingi",
"required participant" => "required mshiriki",
"optional participant" => "mshiriki asiye lazima",
"non-participant" => "Mashirika yasiyo ya kushiriki",
"Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in" => "Kutoa orodha ya washiriki waliojitenga na mazao. Majukumu ya washiriki wanapaswa kutolewa kwa kuanzisha kwa hatua mbili (:) kama ilivyo katika mfano wafuatayo",
"role:login_or_email,login_or_email" => "jukumu login_ou_email, login_ou_email",
"If no role is provided, default role will be \"Chair participant\"." => "Ikiwa hakuna jukumu linalofafanuliwa, jukumu linalowekwa na default litakuwa \"mwenyekiti\".",
"Update this event only" => "Sasisha tu tukio hili",
"Update every unchanged event in this recurrence series" => "Sasisha matukio yote yasiyobadilishwa ya urejesho huu",
"Update every event in this recurrence series" => "Sasisha matukio yote ya urejesho huu",
"Delete event" => "Futa tukio hili",
"Delete recurrent events" => "Futa matukio ya mara kwa mara",
"Calendar import" => "Kuagiza kalenda",
"Calendar has been updated" => "Kalenda imesasishwa",
"%0 column name can be used instead of %1" => "%0 Jina la safu inaweza kutumika badala ya %1",
"import" => "kuagiza",
// "Previous {\$viewmode|escape}" => "Previous {\$viewmode|escape}",
"D" => "D",
"W" => "W",
"M" => "M",
// "Next {\$viewmode|escape}" => "Next {\$viewmode|escape}",
// "%d/%m" => "%d/%m",
"%m/%d" => "%d/%m",
"Advanced parameters for iCal export" => "Mipangilio ya juu kwa mauzo ya ICal",
"Calendars to be exported" => "Kalenda za kuuza nje",
"Export calendars iCal" => "Tuma kalenda kwa iCal",
"Export calendars CSV" => "Tuma kalenda kwa CSV",
"Your account has been validated" => "Akaunti yako imethibitishwa",
"You have to choose a password to use this account" => "Lazima upee nenosiri ili utumie akaunti hii",
// "Change password" => "Change password",
// "Set password" => "Set password",
// "Old Password" => "Old Password",
// "Repeat Password" => "Repeat Password",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Acknowledge (OK)" => "Acknowledge (OK)",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Acknowledge" => "Acknowledge",
// "New database engine" => "New database engine",
// "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki" => "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki",
// "MySQL crashed Tables" => "MySQL crashed Tables",
// "Be careful" => "Be careful",
// "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure" => "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure",
// "Test sending emails" => "Test sending emails",
// "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>" => "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Special directories" => "Special directories",
// "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>" => "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>",
// "Fitness" => "Fitness",
// "Directory is writeable" => "Directory is writeable",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "Change PHP configuration values" => "Change PHP configuration values",
// "{\$php_sapi_info.message}" => "{\$php_sapi_info.message}",
// "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>" => "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>",
// "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>" => "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>",
// "PHP Security properties" => "PHP Security properties",
// "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>" => "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>",
// "Tiki Security" => "Tiki Security",
// "Sensitive Data Exposure" => "Sensitive Data Exposure",
// "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information",
// "Print configurations" => "Print configurations",
// "mPDF Information" => "mPDF Information",
// "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print" => "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print",
// "File Gallery Search Indexing" => "File Gallery Search Indexing",
// "More information %0 here %1" => "More information %0 here %1",
// "Command Missing" => "Command Missing",
// "The command \"shell_exec\" is required for file gallery search indexing" => "The command \"shell_exec\" is required for file gallery search indexing",
// "Mimetype" => "Mimetype",
// "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable" => "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
// "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>" => "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>",
// "Benchmark PHP/MySQL" => "Benchmark PHP/MySQL",
// "Check" => "Check",
// "BOM Detected Files" => "BOM Detected Files",
// "Scanned files" => "Scanned files",
// "BOM files detected" => "BOM files detected",
// "No BOM files detected" => "No BOM files detected",
// "TRIM" => "TRIM",
// "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>" => "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>",
// "Requirements" => "Requirements",
// "OS not supported" => "OS not supported",
// "Apparently tiki is running on a Windows based server. This feature is not supported natively" => "Apparently tiki is running on a Windows based server. This feature is not supported natively",
// "User Data Encryption" => "User Data Encryption",
// "MCrypt encryption found in users data preferences" => "MCrypt encryption found in users data preferences",
// "Found %0 user(s) with data preferences encrypted with MCrypt" => "Found %0 user(s) with data preferences encrypted with MCrypt",
// "No user preferences were found with data encrypted with MCrypt" => "No user preferences were found with data encrypted with MCrypt",
// "Tiki Packages" => "Tiki Packages",
// "OCR Status" => "OCR Status",
"Please choose the language for this page:" => "Tafadhali chagua lugha ya ukurasa huu:",
"Choose language" => "Chagua lugha hii",
"Contact Us" => "Wasiliana nasi",
"Send a message to us" => "Tutumie ujumbe",
"Your email" => "Anwani yako ya barua pepe",
"Contact us by email" => "Wasiliana nasi kwa barua pepe",
"Click here to send us an email" => "Bofya hapa kututumia barua pepe",
"Send another message" => "Tuma ujumbe mwingine",
"Contacts" => "mawasiliano",
"Group View" => "Vue par groupe",
"Create/edit contacts" => "Ongeza / hariri kuwasiliana",
"First Name" => "jina la kwanza",
"Last Name" => "Jina la mwisho",
"Nickname" => "jina la utani",
"Publish this contact to groups" => "Shiriki kuwasiliana na vikundi hivi",
// "Extra Fields" => "Extra Fields",
"Copy page" => "Nakala ukurasa",
"Invalid page name" => "Jina la ukurasa batili",
"The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "Jina la ukurasa maalum lina wahusika halali. Haitawezekana kuokoa ukurasa mpaka watakapoondolewa: <strong>% 0 </strong>",
"The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "Jina la ukurasa maalum lina vyenye ambavyo vinaweza kuondokana na ukurasa huu. Unaweza kufikiria kuondoa: <strong>% 0 </strong>",
"Use this name anyway" => "Tumia jina hili hata hivyo",
// "Duplicate tags" => "Duplicate tags",
"Quick Create Multilanguage Pages" => "Haraka kurasa za lugha nyingi",
"Following pages were created, as translations of each other" => "Kurasa zifuatazo zimeundwa kama tafsiri za kila mmoja wao",
"Following pages were not created" => "Kurasa zifuatazo hazijaundwa",
"page already exists" => "ukurasa tayari upo",
"Enter the names of a new page page in various languages" => "ingiza majina ya ukurasa mpya kwa lugha tofauti",
"Preferred languages" => "Langues préférées",
"Other languages" => "Lugha zingine",
"Create pages" => "Unda kurasa",
// "View generated WebHelp" => "View generated WebHelp",
"No structure" => "Hakuna muundo",
"Top page" => "Ukurasa wa ngazi ya kwanza",
"Add a new site" => "Ongeza tovuti mpya",
"You cannot add sites until Directory Categories are setup." => "Huwezi kuongeza tovuti kabla makundi ya saraka yameandaliwa.",
"Please contact the Site Administrator" => "Tafadhali wasiliana na Msimamizi wa Site",
"<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Ongeza kiwanja cha saraka sasa</a>",
"Site added" => "Tovuti iliyoongezwa",
"The following site was added, but may require validation by the admin before appearing on the lists" => "Tovuti zifuatazo zimeongezwa, lakini zinahitaji kuidhinishwa kwa msimamizi kabla ya kuonekana kwenye orodha",
"Edit a site" => "Badilisha tovuti",
"Add a site" => "Ongeza tovuti",
"Directory Categories" => "Makundi ya Directory",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Admin Directory" => "Dhibiti saraka",
"There are" => "Kuna",
"invalid sites" => "maeneo batili",
"valid sites" => "maeneo yaliyothibitishwa",
"Users have visited" => "Watumiaji wametembelea",
"sites from the directory" => "maeneo ya saraka hii",
"Users have searched" => "Watumiaji walitafuta",
"times from the directory" => "nyakati kutoka kwenye saraka hii",
"Validate" => "kuhalalisha",
"Admin directory categories" => "Dhibiti makundi ya saraka",
"Parent directory category" => "Msaada wa Jamii ya Mzazi",
"Add a directory category" => "Ongeza kikundi kwenye saraka",
"Edit this directory category" => "Badilisha makundi katika saraka hii",
"Add a Directory Category" => "Ongeza Jamii kwenye Directory",
"Child type" => "Aina ya maonyesho ya ziada",
"Most visited directory sub-categories" => "Subcategories ya saraka ya kutembelewa zaidi",
"Directory category description" => "Maelezo ya kikundi cha saraka",
"Random directory sub-categories" => "Makundi ya chini ya rasimu ya saraka",
"Maximum number of child directory categories to show" => "Idadi kubwa ya vijamii ili kuonyesha",
"Allow sites in this directory category" => "Ruhusu maeneo katika kiwanja hiki cha saraka",
"Show number of sites in this directory category" => "Tazama idadi ya maeneo katika saraka hii ya saraka",
"Editor group" => "Kikundi cha Mchapishaji",
"Directory Subcategories" => "Subcategories ya saraka",
"cType" => "Aina ya watoto",
"allow" => "kuruhusiwa",
"count" => "idadi",
"editor" => "mchapishaji",
// "Relate" => "Relate",
"Admin related directory categories" => "Dhibiti makundi ya nyaraka kuhusiana",
"Add a related directory category" => "Ongeza jamii ya saraka iliyohusishwa",
"Directory Category" => "Jamii ya Directory",
"Mutual" => "pamoja",
"Related directory categories" => "Makundi ya saraka zinazohusiana",
"Admin sites" => "Dhibiti maeneo",
"Is valid" => "Ni halali",
"New Sites" => "Sehemu mpya",
"Popular Sites" => "Sehemu za baridi",
"Directory:" => "Annuaire de sites :",
"any" => "yoyote",
"in entire directory" => "katika saraka nzima",
"in current directory category" => "katika jamii ya sasa ya saraka",
"Sort by" => "Panga kwa",
"Hits (desc)" => "ziara (desc)",
"Hits (asc)" => "ziara (asc)",
"Last updated (desc)" => "Utaratibu wa kushuka kwa sasisho la mwisho",
"Last updated (asc)" => "Njia ya kupungua ya sasisho la mwisho",
"sort" => "aina",
"No records" => "Hakuna matokeo",
"Total directory categories" => "Jumla ya idadi ya saraka za saraka",
"Total links" => "Jumla ya viungo",
"Links to validate" => "Liens à valider",
"Searches performed" => "Utafutaji ulifanywa",
"Total links visited" => "Jumla ya viungo vilivyotembelewa",
"Directory ranking" => "Uwekaji wa orodha",
"Validate sites" => "Tovuti zilizohakikishiwa",
"country" => "nchi",
"Discounts" => "rebates",
// "{\$prefs.payment_currency|escape}" => "{\$prefs.payment_currency|escape}",
// " or " => " or ",
"Maximum time the discount can be used in the first phase of payment" => "Upeo wa muda unaweza kupunguzwa katika awamu ya kwanza ya malipo",
"-1 for unlimited" => "-1 kwa ukomo",
"Translation of this page is incomplete." => "Tafsiri ya ukurasa huu haijafanywa.",
"To add <strong>new content</strong> to the page" => "Ili kuongeza <strong> maudhui mpya </ strong> kwenye ukurasa",
"use the editor" => "Tumia mhariri",
"Edit article" => "Badilisha makala",
"View Articles" => "Onyesha makala",
"Allow full HTML" => "Ruhusu HTML kamili",
"Keep any HTML tag" => "Inatafsiri vitambulisho vyote vya HTML",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
"To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language." => "Ili kutafsiri, usibadilishe lugha na maudhui. Badala yake, <a class=\"alert-link\" href=\"tiki-edit_translation.php?no_bl=y&page=HomePage\"> uunda tafsiri mpya </a> katika lugha mpya.",
// "{\$typei|escape}" => "{\$typei|escape}",
// "Click \"Preview\" after selecting article type to have appropriate edit form fields" => "Click \"Preview\" after selecting article type to have appropriate edit form fields",
// "Publication" => "Publication",
// "If checked, the article is published" => "If checked, the article is published",
"User (article owner)" => "Mtumiaji (mmiliki wa makala)",
"Time" => "Wakati",
"Own Image" => "Picha inayohusiana",
"If not the topic image" => "Ikiwa tofauti na picha ya somo",
// "Max file size : {\$prefs.article_image_file_size_max/1000} KB" => "Max file size : {\$prefs.article_image_file_size_max/1000} KB",
"Current Image" => "Picha inaendelea",
"Article image" => "Kifungu cha picha",
"Image caption" => "Maelezo ya picha",
// "Default will use the topic name" => "Default will use the topic name",
"Use own image" => "Tumia picha inayohusiana",
"Float text around image" => "Nakala inayozunguka picha",
// "Read Article" => "Read Article",
// "Maximum dimensions of custom image in view mode" => "Maximum dimensions of custom image in view mode",
// "Maximum dimensions of custom image in list mode" => "Maximum dimensions of custom image in list mode",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
"Topline" => "Topline",
// "http://.." => "http://..",
// "Test your link: " => "Test your link: ",
"Apply content template" => "Tumia template ya maudhui",
// "{\$template.name|escape}" => "{\$template.name|escape}",
"Email addresses to be sent notifications (comma-separated)" => "Anwani za barua pepe ili kuwajulisha (kutengwa na vitu)",
"Cancel the edit (changes will be lost)." => "Futa mabadiliko, utapoteza mabadiliko.",
// "Create or edit banners" => "Create or edit banners",
"List banners" => "Orodha ya mabango",
"URL to link the banner" => "Anwani ya wavuti ya tangazo la bendera",
"Client" => "mteja",
"Maximum impressions" => "Max. hisia",
"Maximum number of impressions for a user" => "Hisia nyingi kwa mtumiaji",
"Maximum clicks" => "Max ya Clicks",
"URIs where the banner appears only" => "URL tu ambapo bendera inaonekana",
"Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Ingiza kila URL iliyozungukwa na #. <br /> Mfano: # / hii_page_page # / tiki-index.php? ukurasa = hii_page #",
// "URIs where the banner will not appear" => "URIs where the banner will not appear",
"Or, create a new zone" => "Au, uunda eneo jipya",
// "New Zone" => "New Zone",
"Show the banner only between these dates" => "Onyesha bendera pekee kati ya tarehe hizi",
"From date" => "Kutoka tarehe hii",
"To date" => "Tarehe hii",
"Use dates" => "Na tarehe",
// "Show the banner only in these hours" => "Show the banner only in these hours",
"Show the banner only on" => "Onyesha bendera tu",
"Select ONE method for the banner" => "Chagua njia ONE ya bendera",
"Use Image" => "Tumia picha",
// "Use Image from URL" => "Use Image from URL",
// "(the image will be requested at the URL for each impression)" => "(the image will be requested at the URL for each impression)",
"Use Flash" => "Tumia Kiwango",
"Movie Size" => "Ukubwa wa video",
// "width in pixels" => "width in pixels",
"Pixels" => "saizi",
// "height in pixels" => "height in pixels",
"FlashPlugin min version" => "Toleo la kiwango cha chini cha kuziba",
"ex" => "ex",
// "Use Text" => "Use Text",
"Save the Banner" => "Hifadhi bendera",
"Remove zones (info entered for any banner in the zones will be lost)" => "Futa maeneo (utapoteza habari zote zilizoingia kwa bendera)...",
"Edit Blog" => "Hariri blogi",
"A category is mandatory" => "Jamii inahitajika",
"Individual permissions are set for this blog" => "Haki za upatikanaji wa kibinafsi zimefafanuliwa kwenye blogi hii",
"Allow other users to post in this blog" => "Ruhusu wengine kuandika kwenye blogu hii",
"Even if others post to the blog, the author is always its administrator" => "Ikiwa machapisho mengine kwenye blogu, mwandishi lazima daima awe mmiliki",
"Allow search" => "Ruhusu utafutaji",
"Allow comments" => "Ruhusu maoni",
"Use post excerpt" => "Tumia snippets za ujumbe",
"Display Options" => "Chaguo za kuonyesha",
// "Displayed posts" => "Displayed posts",
"Number of posts to show per page" => "Idadi ya ujumbe kwa kila ukurasa",
"Display the blog title on the posts list page" => "Tazama kichwa cha blogu kwenye ukurasa wa blogu",
"Display the blog title on the post page" => "Tazama kichwa cha blogu katika ujumbe",
"Display the blog description" => "Angalia maelezo ya blogu",
"Display breadcrumbs" => "Angalia Breadcrumb",
"Display the author in blog posts" => "Tazama mwandishi katika ujumbe",
"Display the publish date in blog posts" => "Angalia tarehe ya kuchapishwa katika ujumbe",
"Show user profile picture" => "Onyesha avatari",
"Show the post's related content" => "Angalia maudhui yanayohusiana na ujumbe",
"The checkbox is disabled because the tags feature is disabled globally" => "Bodi ya hundi imezimwa kwa sababu kipengele cha maneno ni kizima kimezimwa",
// "Related posts" => "Related posts",
"Maximum number of related posts to display" => "Idadi kubwa ya ujumbe unaohusishwa na kuonyesha",
"Blog heading" => "Kichwa cha blogu",
"Heading preview" => "Angalia kichwa",
"Blog post heading" => "Kichwa cha ujumbe",
"Organizer" => "mratibu",
"Move objects between categories" => "Hamisha vitu kati ya makundi",
"Click on the category name to display the list of objects in that category." => "Bofya kwenye jina la kikundi unayotaka kuorodhesha. Orodha ya vitu katika jamii hii itaonekana.",
"Select the objects to affect. Controls will appear in the category browser." => "Chagua vitu vinavyohitajika. Udhibiti utaonekana katika kivinjari cha kikundi.",
"Use the plus and minus signs to add or remove the categories on selected objects." => "Tumia pamoja na kupitisha ishara ili kuongeza au kuondoa makundi kutoka kwa vitu vichaguliwa.",
// "Object list result" => "Object list result",
// "Select objects to change categorization" => "Select objects to change categorization",
"More results are available. Please refine the search criteria" => "Matokeo zaidi yanapatikana. Asante kuboresha vigezo vya utafutaji",
"Select all" => "chagua zote",
"Unselect all" => "Chagua yote",
"The file will be saved in" => "Faili itahifadhiwa",
// "Currently trying" => "Currently trying",
"Try" => "kujaribu",
// "Missing Package" => "Missing Package",
// "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package" => "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package",
// "Please contact the Administrator to install it" => "Please contact the Administrator to install it",
// "Tiki Docs" => "Tiki Docs",
"Save file" => "Hifadhi faili",
"Cancel editing file" => "Futa uhariri wa faili",
"Editing file" => "Inahariri faili",
// "Save and Back" => "Save and Back",
"Rename" => "reappoint",
"Toggle Fullscreen" => "Basculer plein écran",
"More information" => "Maelezo zaidi",
"Wiki Page Editor" => "Mhariri wa ukurasa wa Wiki",
"More help on editing wiki pages" => "Usaidizi wa ziada wa kurasa za kurasa za Wiki",
"The syntax system used for creating pages in Tiki" => "Mfumo wa syntax kutumika kutengeneza kurasa katika Tiki",
"Bold text" => "Nakala ya Bold",
"Italic text" => "Nakala ya Italiki",
"single quotes" => "apostrophes moja",
"Underlined text" => "Nakala iliyosafishwa",
"Colored text" => "Nakala yenye rangi",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Onyesha maandishi kwa rangi maalum (msimbo wa HTML au jina). Jina la rangi linaweza kuwa na mbili, linalotengwa na comma. Katika kesi hiyo, rangi ya kwanza ni ya mbele na ya pili kwa historia",
"Deleted text" => "Nakala iliyofutwa",
"2 dashes" => "2 dashes",
"Headings" => "vichwa",
"show/hide heading section. + (shown) or - (hidden) by default" => "inaonyesha / inaficha vichwa vya sehemu. + (imeonekana) au - (imefichwa) kwa default",
"Autonumbered Headings" => "Vichwa vya kujitegemea",
"{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal} {toc} {/ literal}, {literal} {maketoc} {/ literal} hujenga na kuonyesha meza ya yaliyomo kwenye ukurasa wa sasa kulingana na miundo (toc) au vichwa vya habari! (Maketoc)",
"Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Vigezo vya sasa vya maketoc ni: cheo | maxdepth | viwango | namba, na toc: amri | showdesc | shownum | structId | maxdepth | pagename",
"Horizontal rule" => "Utawala wa usawa",
"Text box" => "Sanduku la maandishi",
"Box content" => "Masanduku ya Sanduku",
"Centered text" => "Maandishi yaliyomo",
"Inserts an editable variable" => "Weka kutofautiana kwa nguvu",
"External links" => "Viungo vya nje",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "Tumia [] mabaki kwa kiungo cha nje: [URL], [URL | link description], [URL | link maelezo] au [URL | link maelezo | uhusiano | nocache] (chaguo la mwisho huzuia Wiki ya ndani kuacha caching ukurasa unaohusishwa; uhusiano unaweza kutumika kuingiza sifa ya kiungo kwa kiungo - rahisi kwa mfano kwa sanduku la kivuli)",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Kwa Wiki ya nje, tumia ExternalWikiName: PageName au ((Nje WikiName: PageName))",
"Square Brackets" => "kulabu",
"Use [[foo] to show [foo]." => "Tumia [[foo] kuonyesha [foo].",
"JoinCapitalizedWords or use" => "Kukusanya Maneno ya Capitalized au kutumia",
"page|description" => "page|desc",
"for wiki references" => "kwa kumbukumbu ya Wiki",
"page|#anchor" => "page|#anchor",
"page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
"SomeName" => "jina moja",
"prevents referencing" => "ili kuzuia kufanya kumbukumbu",
"Lists" => "orodha",
"for bullet lists" => "kwa orodha ya fujo",
"for numbered lists" => "kwa orodha iliyohesabiwa",
"definition" => "ufafanuzi",
"for definiton lists" => "kwa ufafanuzi",
"Indentation" => "jongezo",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Ongeza kiwango cha indentation kwa kila pamoja (muhimu katika orodha ili kuendelea na kiwango sawa)",
"Tables" => "Tableaux",
"row" => "mstari",
"col" => "col",
"Monospace font" => "Faili iliyowekwa salama",
"Code sample" => "Sampuli ya Kanuni",
"(very useful especially in tables)" => "(muhimu hasa katika meza)",
"Multi-page pages" => "Multi-Page",
"to separate pages" => "kutenganisha kurasa",
"Non-parsed sections" => "Sehemu zisizozingatiwa",
"data" => "data",
"Prevents wiki parsing of the enclosed data." => "Inazuia uchambuzi wa Wiki kwa data iliyoandaliwa.",
"Preformated sections" => "Sehemu zilizopangwa kabla",
"~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~ pp ~ data ~ / pp ~ Inaonyesha maandishi au kanuni iliyopangwa; Uchambuzi wa Wiki haufanyike ndani ya sehemu hizi (kama na np), na nafasi ni fasta (hakuna mapumziko ya mstari hufanywa). ~ pre ~ data ~ / pre ~ pia inaonyesha maandishi yaliyotangulizwa na nafasi ya kudumu, lakini usindikaji wa Wiki unafanywa kwenye maandiko",
"~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~ tc ~ Maoni Tiki ~ / tc ~ tengeneze maoni ya Tiki. Itaondolewa kabisa kutoka kwenye maonyesho, lakini imehifadhiwa kwenye faili kwa kutaja baadaye. ~ hc ~ Maoni HTML ~ / hc ~ kuunda maoni ya HTML. Itaingizwa kama maoni katika pato la HTML; hizi si kawaida zinaonyeshwa na vivinjari, lakini zinaweza kuonekana kwa kutumia 'Tazama Chanzo Kanuni' au sawa",
"Block Preformatting" => "Préformatter un bloc de texte",
"Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Inatoa maandiko kwa wahusika wengi kama inahitajika kufuata maelekezo mengine ya Wiki. Indentation itakuwa sawa na ile unayoyotumia. Kumbuka kuwa hali hii haifai idadi sawa ya nafasi na mapumziko ya mstari; tumia ~ pp ~ ... ~ / pp ~ kwa hiyo.",
"Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew." => "Kuingizwa kwa, kwa mtiririko huo, kipande cha maandishi yaliyoelekezwa kutoka kulia kwenda kushoto au kutoka kushoto kwenda kulia (hadi mwisho wa maandishi) na alama kwa lugha za Kiarabu au Kiebrania.",
"Special characters" => "Wahusika maalum",
"hard space" => "Eneo lisilovunja",
"numeric between ~ for HTML numeric characters entity" => "kati ya ~ kwa HTML ya kiungo cha tabia ya tabia",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Kumbuka kuwa hoja za kuziba zinaweza kufungwa katika alama za nukuu (\"); hii inaruhusu kuingiza vifungo (,), ishara kama \" sawa \"(=) au \" kubwa kuliko \"(>)",
"More help here" => "Usaidizi zaidi hapa",
"Wiki plugins extend the function of wiki syntax with more specialized commands" => "Plugins ya Wiki huongeza mstari wa wiki na amri zaidi maalumu",
"Activate/deactivate plugins" => "Wezesha / afya programu",
"No description available" => "Hakuna maelezo yaliyopatikana",
"For more information, please see" => "Kwa habari zaidi, angalia",
"WYSIWYG Editor" => "Editor Wysiwyg",
"More help on WYSIWYG editing" => "Usaidizi zaidi na uhariri katika wysiwyg",
// "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>" => "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar",
// "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered" => "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered",
// "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around" => "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around",
// "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
"Browse Images" => "Vinjari picha",
"Edit successful!" => "Marekebisho mafanikio!",
"The following image was successfully edited" => "Picha iliyofuata imefanywa kwa ufanisi",
"Image Description" => "Maelezo ya picha",
"Upload from disk to change the image" => "Weka kutoka kwenye diski ili kubadilisha picha",
"Save and Go Next" => "Hifadhi na uendelee",
"Edit Invoice" => "Badilisha ankara",
"Invoice Number" => "Nambari ya ankara",
"Date Issued" => "Tarehe ya suala",
"Work Description" => "maelezo",
"Taxable" => "hazitozwi ushuru",
"New Item" => "Mstari mpya",
"Invoice Note" => "maoni",
"Save Invoice" => "Hifadhi ankara",
"Customized String Translation" => "Tafsiri ya Desturi",
// "Manage local translations in a custom.php file" => "Manage local translations in a custom.php file",
// "Download language.php file for the selected language" => "Download language.php file for the selected language",
// "Download Database Translations" => "Download Database Translations",
// "Download a file with all the translations in the database for the selected language" => "Download a file with all the translations in the database for the selected language",
// "Translations in the database will be merged with the other translations in language.php for the selected language" => "Translations in the database will be merged with the other translations in language.php for the selected language",
"Add a translation" => "Ongeza tafsiri",
"Untranslated strings" => "Maandiko isiyotafsiriwa",
"Show only database stored untranslated strings" => "onyesha safu zisizoingizwa kwenye kumbukumbu",
"Edit translations" => "Hariri Tafsiri",
"Show only database stored translations" => "Onyesha tafsiri zilizohifadhiwa tu za database",
"Original string" => "Maandiko ya awali",
"Last changed by %0 on %1" => "Ilibadilishwa mwisho na %0 kwenye %1",
"Contribute:" => "kuchangia:",
"Undecided" => "Haijaamuliwa",
// "Save translation in the database" => "Save translation in the database",
// "Delete translation from the database" => "Delete translation from the database",
"Compare" => "linganisha",
// "Compare the original translation with the database translation" => "Compare the original translation with the database translation",
"For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes." => "Kwa tafsiri maalum kwa mfano huu wa Tiki, chagua Cha. Ikiwa tafsiri hii inaweza kuchangia jumuiya ya Tiki, chagua Ndio.",
"Translate all" => "Tafsiri wote",
"Delete all" => "Futa yote",
"Are you sure you want to delete all untranslated strings from database" => "Je! Una uhakika unataka kuondoa masharti yote yasiyotafsiriwa kutoka kwenye databana",
"Are you sure you want to delete all translations from database" => "Una uhakika unataka kufuta tafsiri zote kutoka kwenye databana?",
"Return to the default perspective" => "Rudi kwenye mtazamo wa default",
"Switch to" => "Badilisha kwa",
// "Preference List" => "Preference List",
// "Search preferences below and drag them into the preference list above" => "Search preferences below and drag them into the preference list above",
"Program dynamic content for block" => "Programu ya nguvu ya programu kwa kuzuia",
"Create New Block" => "Unda block mpya",
"Return to block listing" => "Rudi kwenye orodha ya kuzuia",
"Block description: " => "Piga maelezo: ",
"You are editing block" => "Unahariri block",
// "Publising Date" => "Publising Date",
"Publishing Date" => "Tarehe ya kuchapishwa",
"Edit question options" => "Badilisha chaguo la swali",
"List Quizzes" => "Orodha ya MCQs",
"Quiz Stats" => "Takwimu za QCM",
"This Quiz Stats" => "Takwimu za QCM hii",
"Edit this Quiz" => "Badilisha uchaguzi huu nyingi",
"Admin Quizzes" => "Kudhibiti QCMs",
"Create/edit options for question" => "Ongeza / hariri chaguo la swali",
"points" => "pointi",
"Quiz can be repeated" => "MCQ inaweza kujazwa mara kadhaa",
// "Time Limit" => "Time Limit",
"Create/edit quizzes" => "Ongeza / kurekebisha uchaguzi nyingi",
"There are individual permissions set for this quiz" => "Haki za upatikanaji wa kibinafsi zimewekwa kwenye uchaguzi huu nyingi",
"Store quiz results" => "Weka matokeo ya dodoso la uchaguzi nyingi",
"Quiz is time-limited" => "Muda mdogo wa kukamilisha chaguzi nyingi",
"Maximum time" => "Upeo wa muda",
"Passing Percentage" => "Asilimia ya mafanikio",
// "%" => "%",
"Edit quiz questions" => "Badilisha maswali ya MCQ",
"Create/edit questions for quiz" => "Ongeza / hariri swali kwa MCQ",
"Question Type" => "Aina ya swali",
"Import questions from text" => "Weka maswali kutoka kwa maandiko",
// "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct" => "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct",
"Input" => "adhabu",
"Maximum score" => "Max alama",
"Edit quiz results" => "Badilisha matokeo ya jaribio",
"From Points" => "Pointi",
"To Points" => "Katika pointi",
"Reports" => "Ripoti",
"Report Builder" => "Mjenzi wa Ripoti",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
"Export As CSV" => "Tuma nje kama CSV",
"You will remove" => "Utafuta",
// "and its subpages from the structure, now you have two options" => "and its subpages from the structure, now you have two options",
"and its subpages from the structure" => "na ukurasa wa chini wa muundo",
// "Remove from structure" => "Remove from structure",
// "Remove from structure and remove page too" => "Remove from structure and remove page too",
"The page already exists. The page that has been added to the structure is the existing one." => "Ukurasa umepo tayari Ukurasa ambao umeongezwa kwa muundo ni moja ambayo iko.",
"The following pages added have automatically been categorized with the same categories as the structure" => "Kurasa zifuatazo zimewekwa kikundi moja kwa moja na makundi sawa na muundo",
"Structure Layout" => "Maudhui ya muundo",
// "Monitor the structure" => "Monitor the structure",
// "Stop Monitoring the structure" => "Stop Monitoring the structure",
"Add pages" => "Ongeza kurasa",
// "Use an existing page by dragging it into the structure above" => "Use an existing page by dragging it into the structure above",
// "{\$catix.categpath}" => "{\$catix.categpath}",
"Categorize all pages in structure together" => "Panga kila kurasa katika muundo",
"Remove existing categories from ALL pages before recategorizing" => "Futa makundi yote kutoka kwa kurasa zote kabla ya \"upya upya \"",
"Move to another structure" => "Nenda kwenye muundo mwingine",
"at the beginning" => "mapema",
"at the end" => "mwisho",
"Submit article" => "Wasilisha makala",
"List submissions" => "Orodha ya maoni",
"Use ...page... to separate pages in a multi-page post" => "Tumia ... ukurasa ... ili kurasa tofauti",
// "Fields with <b>*</b> are optional" => "Fields with <b>*</b> are optional",
"<b>Topline</b>=small line above Title" => "<b>Subtitle</b> = mstari mdogo juu ya kichwa",
"<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b> = mstari mdogo chini ya kichwa",
"<b>Source</b>=URL to article source" => "<b>Chanzo</ b> = URL kwa chanzo cha makala",
"Author Name" => "Jina la mwandishi",
"Own image size x" => "Ukubwa x wa picha inayohusiana",
"Own image size y" => "Ukubwa y wa picha inayohusishwa",
"Auto-Approve Article" => "Auto-approuver l'article",
"View template" => "Tazama template",
"Template listing" => "Orodha ya templates",
"Available templates" => "Nyaraka zilizopo",
"Important" => "muhimu",
// "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
"Save Only in the Theme" => "Hifadhi tu katika mandhari",
"Delete the copy in the theme" => "Futa nakala katika mandhari",
// "Admin Article Topics" => "Admin Article Topics",
// "Edit article topic" => "Edit article topic",
"Admin notifications" => "Dhibiti arifa",
// "Enter email addresses " => "Enter email addresses ",
"View Article" => "Tazama makala",
"Attach or detach existing translations of this page" => "Ambatanisha au futa tafsiri zilizopo kutoka ukurasa huu",
// "Manage Translations" => "Manage Translations",
"You must specify the object language" => "Lazima ueleze lugha ya kitu",
"The object doesn't exist" => "Kitu haipo",
"The object doesn't have a language" => "Kitu hicho hakina dalili ya lugha",
"The object already has a translation for this language" => "Kitu tayari kina tafsiri ya lugha hiyo",
"The object is already in the set of translations" => "Kitu tayari kilichowekwa katika tafsiri",
"Translate this page to a new language" => "Tafsiri ukurasa huu kuwa lugha mpya",
"Select language to translate to:" => "Chagua lugha ya tafsiri:",
"Enter the page title:" => "Ingiza kichwa cha ukurasa:",
// "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
"Create translation" => "Unda tafsiri",
"Change language for this page" => "Badilisha lugha ya ukurasa huu",
"Change Language" => "Badilisha lugha",
// "You forgot to specify the language of the translation. Please choose a language in the picklist" => "You forgot to specify the language of the translation. Please choose a language in the picklist",
"The page already exists. It was selected in the list below." => "\"Ukurasa huu tayari upo na umechaguliwa kutoka kwenye orodha iliyo chini.\"",
"No language is assigned to this page" => "Hakuna lugha iliyopewa ukurasa huu",
"Please select a language before translating" => "Tafadhali chagua lugha kabla ya kutafsiri",
// "Set Page Language" => "Set Page Language",
"Edit %0" => " Badilisha <a class=\"edit_pagetitle\" href=\"tiki-index.php?page=HomePage\"> HomePage </a>",
"Update '{\$page}'" => "Sasisha '{\$ukurasa'}",
// "{\$customTip|escape}" => "{\$customTip|escape}",
// "Preview your changes" => "Preview your changes",
"Draft written on" => "Rasimu iliyoandikwa juu",
"Warning: new versions of this page have been made after this draft" => "Onyo: matoleo mapya ya ukurasa huu yamefanywa baada ya rasimu hii",
"The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page." => "Sandbox ni ukurasa ambapo unaweza kufanya mazoezi ya kuhariri ukurasa: tumia kipengele cha 'Preview' ili uone ukurasa; hakuna toleo la ukurasa huu utahifadhiwa.",
// "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)" => "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)",
"An edit summary is mandatory" => "Muhtasari wa toleo inahitajika",
"Translate from" => "Tafsiri kutoka",
"Changes that need to be translated are highlighted below" => "Mabadiliko ya kutafsiri yanaonyesha chini",
"No comment" => "Hakuna maoni",
"All Versions" => "Matoleo yote",
"Edit wiki page" => "Toleo la ukurasa wa Wiki",
"Select the style used to display differences to be translated" => "Chagua mtindo unaotumiwa kuonyesha tofauti ili kutafsiri",
"text full" => "texte plein",
"Change the style used to display differences to be translated" => "Badilisha mtindo unaotumiwa kuonyesha tofauti ili kutafsiri",
"Change diff styles" => "Badilisha mtindo wa tofauti",
"Translate to" => "Tafsiri hadi",
"Reproduce the changes highlighted on the left using the editor below" => "Fanya mabadiliko yaliyochaguliwa upande wa kushoto ukitumia mhariri hapa chini",
"Describe the change you made" => "Eleza mabadiliko uliyoifanya",
"Edit comment: Enter some text to describe the changes you are currently making" => "Hariri Maoni: Ingiza maoni kuelezea mabadiliko unayofanya",
"Monitor this page" => "Tazama ukurasa huu",
"Upload picture" => "Tuma picha",
"Add another image" => "Ongeza picha",
"Categorization has been preset for this edit" => "Kategori imewezeshwa kwa mabadiliko haya",
"Categories will be inherited from the structure top page" => "Jamii zitatokana na muundo wa juu",
// "Leave page and go to..." => "Leave page and go to...",
// "Wiki Preferences" => "Wiki Preferences",
// "Copyright notices" => "Copyright notices",
// "Copyright page" => "Copyright page",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
"Lock this page" => "Funga ukurasa huu",
"Allow comments on this page" => "Ruhusu maoni kwenye ukurasa huu",
// "HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "HTML tags are used to create elements of the wiki page, instead of being displayed as code",
"Try to convert HTML to wiki" => "Kujaribu kubadilisha HTML hadi Wiki",
"Import page" => "Ingiza ukurasa",
// "Export page" => "Export page",
// "Export all versions" => "Export all versions",
// "Attach file" => "Attach file",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
"Site default" => "Chanzo cha msingi",
"as Creator &amp; Last Editor" => "Muumba &amp; mhariri wa mwisho",
"no (disabled)" => "hapana (walemavu)",
"Description (used for metatags)" => "Maelezo (kutumika kwa vitambulisho vya meta)",
"My Footnotes" => "Maelezo ya chini yangu",
// "{\$template.title|escape}" => "{\$template.title|escape}",
"There is no available poll template." => "Hakuna template ya utafiti.",
"Please ask an administrator to create one." => "Lazima uulize msimamizi kuunda.",
// "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
"Translation request" => "Ombi la tafsiri",
"Send urgent translation request." => "Tuma ombi la tafsiri ya haraka.",
// "Geolocation" => "Geolocation",
"Show page title" => " Onyesha kichwa cha ukurasa",
// "Explicit Namespace" => "Explicit Namespace",
// "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace" => "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace",
// "Page layout" => "Page layout",
// "Site Default" => "Site Default",
// "{\$title}" => "{\$title}",
"List Sheets" => "Orodha ya vipeperushi",
"Graph" => "graph",
"Export to file" => "Tuma kwa faili",
"Autodetect" => "Kugundua moja kwa moja",
"Admin FAQ" => "Dhibiti FAQs",
"List FAQs" => "Orodha ya FAQs",
"View FAQ" => "Waonyeshe FAQs",
"Edit this FAQ" => "Badilisha hii FAQ",
"New Question" => "Swali jipya",
"Edit FAQ question" => "Badilisha maswali ya FAQ",
"Add FAQ question" => "Ongeza swali kwa FAQ",
"Use a question from another FAQ" => "Tumia swali kutoka kwa mwingine FAQ",
"FAQ questions" => "Maswali kutoka FAQ",
"Suggested questions" => "Maswali yaliyopendekezwa",
"No suggested questions" => "Hakuna maswali yaliyopendekezwa",
"File Archive" => "Hifadhi ya faili",
"Size (width x height)" => "Vipimo (upana x urefu)",
"Content waiting for approval" => "Maudhui inasubiri idhini",
"You are currently viewing the latest version of the page" => "Kwa sasa unatazama toleo la karibuni la ukurasa",
"You can also view the {self_link}latest approved version{/self_link}" => "Unaweza pia kuona {self_link} toleo la karibuni la kupitishwa {/self_link}",
"You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "Unaweza kupitisha mapitio haya na kuifanya inapatikana kwa watazamaji wengi. Hakikisha uhakiki mabadiliko yote kabla ya kuidhinisha",
"Show changes since last approved revision" => "Angalia mabadiliko tangu toleo la mwisho la kupitishwa",
"This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "Ukurasa huu hauna toleo la awali la kupitishwa. <strong> Maudhui yote yanapaswa kupitiwa </ strong>",
"Approve current revision" => "Thibitisha marekebisho ya sasa",
// "Reject current revision" => "Reject current revision",
"You are currently viewing the approved version of the page" => "Sasa unaona toleo la kupitishwa la ukurasa",
"You can also view the {self_link latest=1}latest version{/self_link}" => "Unaweza pia kuona {latest_link latest = 1} toleo {/self_link}",
"View the {self_link latest=1}latest version{/self_link}" => "Angalia {self_link latest = 1} toleo la hivi karibuni {/self_link}",
"Forum Importer" => "Forum Kuingiza",
"Import from a Local SQL File" => "Ingiza kutoka faili ya SQL ya ndani",
"Forum Type" => "Aina ya jukwaa",
"DB Prefix" => "Kiambatisho cha database",
"Local SQL Filename on Server (path will be stripped)" => "Jina la faili ya SQL ya ndani kwenye seva (njia itaondolewa)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Inapaswa kuwa katika tikiroot / {\$tmpdir} au tikiroot/img/wiki_up",
"Get Forum List" => "Pata orodha ya vikao",
"Verification" => "uhakiki",
"File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>." => "Faili lazima iwe faili ya SQL na iwe iko kwenye <i> \$tikiroot/temp </i> au <i> \$tikiroot/img/wiki_up </i>.",
"File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "Faili haijatambulishwa au haikuweza kupatikana kwenye mojawapo ya kumbukumbu. Tafadhali weka faili katika moja ya kumbukumbu na jaribu operesheni tena. Ikiwa faili iko katika kumbukumbu zote mbili, moja katika \$tikiroot/{\$filecheck} atapendelea.",
"Proceed" => "kuendelea",
"Go Back" => "kurudi",
"Select a Forum You Wish to Move (ONE at a time!)" => "Chagua Forum ambayo unataka kusonga (ONE kwa wakati!)",
"Which Forum Do You Wish to Import this Into?" => "Je, ni Forum gani unayotaka kuingiza ndani hii?",
// "Refresh list" => "Refresh list",
"Edit queued message" => "Badilisha ujumbe unasubiri",
// "Make this a thread of" => "Make this a thread of",
"None, this is a thread message" => "Hakuna, ni ujumbe wa thread",
"summary" => "muhtasari",
"Announce" => "tangazo",
"Hot" => "maarufu",
"no feeling" => "hakuna hisia",
"frown" => "finya uso",
"exclaim" => "exclamatory",
"idea" => "wazo!",
"mad" => "hasira",
"neutral" => "upande wowote",
"question" => "swali",
"sad" => "kusikitisha",
"happy" => "furaha",
"wink" => "wink",
"Save and Approve" => "Hifadhi na uidhinishe",
// "Convert to topic" => "Convert to topic",
"New Topic" => "Somo jipya",
"no summary" => "hakuna muhtasari",
"No messages queued yet" => "Aucun message en attente actuellement",
"Search by name" => "Tafuta kwa jina",
"Search in content" => "Tafuta katika maudhui",
"Last Post" => "Makala ya mwisho",
// "{\$section|escape}" => "{\$section|escape}",
// "No forums found" => "No forums found",
// "Loading" => "Loading",
"Reported by" => "Imetumwa na",
"Perfom action with checked" => "Fanya operesheni kwenye vitu vyeta",
"Un-report" => "De ripoti",
"Tag translation" => "Tafsiri ya maneno muhimu",
// "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated" => "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated",
// "Show checkboxes" => "Show checkboxes",
"There are no tags on this page in your preferred languages" => "Hakuna maneno katika ukurasa huu katika lugha yako iliyopendekezwa",
"Set language" => "Eleza lugha",
"Universal" => "Universel",
// "Displayed languages" => "Displayed languages",
"Friendship Network" => "Mtandao wa marafiki",
"Galleries" => "nyumba",
"Create New Gallery" => "Unda nyumba ya sanaa mpya",
// "Migrate Images to File Gallery" => "Migrate Images to File Gallery",
"Create a gallery" => "Unda nyumba ya sanaa",
"Edit this gallery" => "Hariri nyumba hii ya sanaa",
"There are individual permissions set for this gallery" => "Haki za upatikanaji wa kibinafsi zimewekwa kwenye nyumba hii ya sanaa",
"Gallery is visible to non-admin users?" => "Nyumba hii ya sanaa inaonekana kwa watumiaji wasio na admin?",
"Max Rows per page" => "Upeo wa safu ya safu kwa kila ukurasa",
"Thumbnails size X" => "Ukubwa X wa vidole",
"Thumbnails size Y" => "Ukubwa wa Y wa vidole",
"Fields to show during browsing the gallery" => "Mashamba ya kuonyesha wakati wa njia ya sanaa",
"XY-Size" => "Size-XY",
"Gallery Image" => "Nyumba ya sanaa ya picha",
"Available scales" => "Mizani inapatikana",
"Global default" => "Kikamilifu default",
"Bounding box" => "Bodi ya juu",
"default scale" => "kiwango cha msingi",
// "Default scale" => "Default scale",
"No scales available" => "Hakuna ngazi iliyopo",
"Original image is default scale" => "Kiwango cha default ni ukubwa wa awali wa picha",
"Add scaled images with bounding box of square size" => "Ongeza picha iliyobadilishwa na sanduku la kawaida la mraba",
"Other users can upload images to this gallery" => "Watumiaji wengine wanaweza kutuma picha kwenye nyumba ya sanaa hii",
"You can access the gallery using the following URL" => "Unaweza kufikia nyumba ya sanaa hii kwa anwani yafuatayo ya wavuti",
"Available Galleries" => "Nyumba zinazopatikana",
"Choose a filter" => "Chagua kichujio",
"Imgs" => "Imgs",
// "Make map" => "Make map",
"Select Graphic Type" => "Chagua aina ya chati",
"Pie Chart" => "Chati ya pie",
"Multiline" => "Yenye mistari mingi",
"Multibar" => "Multi-bar",
"Bar Stack" => "Hifadhi ya baa",
"Independant Scale" => "Kiwango cha kujitegemea",
"Horizontal Scale" => "Kiwango cha usawa",
"Vertical Scale" => "Kiwango cha wima",
"Series" => "mfululizo",
"Edit Spreadsheet" => "Badilisha karatasi",
"List Spreadsheets" => "Orodha ya karatasi",
"Wiki plug-in" => "Pembejeo ya Wiki",
"Spreadsheet History" => "Historia ya karatasi za kazi",
"Roll back" => "Rudi nyuma",
"Toggle Full Screen" => "Badilisha kwenye skrini kamili",
"Date Selection" => "Uchaguzi wa tarehe",
"Edit Date" => "Tarehe ya Hariri",
"View Spreadsheet" => "Tazama lahajedwali",
"Clone Spreadsheet" => "Fanya karatasi ya data",
// "Roll back spreadsheet" => "Roll back spreadsheet",
"Import From File" => "Ingiza kutoka faili",
// "File to import" => "File to import",
"Grab Wiki Tables" => "Pata meza za Wiki",
"Import pages from a Structured Text Dump" => "Ingiza kurasa za Ruhusa ya Maandishi yaliyotengenezwa",
"Name of the dump file (it has to be in dump/)" => "Jina la faili ya dampo (lazima iwe katika dampo /)",
"Overwrite existing pages if the name is the same" => "Weka kurasa zilizopo ikiwa jina ni sawa",
// "Remove previously existing page versions" => "Remove previously existing page versions",
"excerpt" => "dondoo",
"Result" => "matokeo yake",
"body" => "mwili",
"Name of the zip file on the server" => "Jina la faili ya zip kwenye seva",
"Tiki Importer" => "Kuagiza Wiki zingine",
"If you are NOT running a new Tiki installation, make a backup of your database before using this importer!" => "Ikiwa sio kuendesha ufungaji mpya wa Tiki, fanya nakala ya salama yako kabla ya kutumia muingizaji huyu!",
"If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature." => "Ikiwa kurasa zako zina msimbo wa XML, 'HTML purifier' itaifuta. Ondoa kipengele hiki.",
"Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Votre PHP s'exécute avec le mode sécurisé activé. Ceci pourrait causer des problèmes au processus d'importation car le mode sécurisé limite la possibilité de changer certains réglages d'exécution de PHP (comme max_execution_time). Il est recommandé d'exécuter ce script sans le mode sécurisé",
"Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)." => "Kulingana na ukubwa wa faili kutoka kwa programu ya chanzo, mchakato wa kuagiza unaweza kuchukua muda kukamilisha. Hii inaweza kuwa tatizo kulingana na mipangilio yako ya PHP na seva ya wavuti. Script hii inajaribu kubadili mipangilio husika lakini kuna baadhi ya mipangilio ambayo script haiwezi kubadilisha. Kwa hivyo, ikiwa una matatizo na script, tafadhali jaribu kuongeza thamani ya mipangilio ya PHP ifuatayo: max_input_time, max_execution_time (mpangilio huu umepunguzwa na mipangilio ya seva ya wavuti, ikiwa unaendesha Apache pia hubadilisha mipangilio ya muda wake), post_max_size , upload_max_filesize, kumbukumbu_limit. Inashauriwa kukimbia script hii kwenye seva ambapo unaweza kubadilisha maadili ya mipangilio hiyo (ikiwa inahitajika).",
"Select the software to import from:" => "Chagua programu ya kuagiza kutoka:",
"Select..." => "kuchagua....",
"WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "ATHARI: Hakikisha una salama kabla ya kuanza script. Ikiwa huna salama, hii ndiyo nafasi yako ya mwisho ya kufuta muingizaji kwa kubonyeza kifungo cha kufuta",
"Congratulations! You have successful imported your data to Tiki" => "Hongera! Umeingiza data yako kwa mafanikio kwenye Tiki",
"%0 pages imported from a total of %1" => "%0 kurasa zinazoagizwa nje ya jumla ya %1",
"%0 pages imported" => "%0 kurasa zilizoagizwa",
"(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(unaweza kuona orodha ya kurasa za wiki za tovuti yako<a href=\"tiki-listpages.php\">hapa</a>)",
"%0 posts imported" => "%0 machapisho ya nje",
"%0 tags imported" => "%0 maneno muhimu",
"%0 categories imported" => "%0 makundi ya nje",
// "Importer log" => "Importer log",
"Suggested .htaccess rules" => "Iliyotakiwa .htaccess sheria",
"Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
"Installation" => "ufungaji",
"Tiki Icon" => "Iki Icon",
"Tiki Project Web Site" => "Tovuti ya mradi wa Tiki",
"Support Forums" => "Forums Support",
"Welcome" => "karibu",
"Welcome to the <strong>Tiki %0</strong> installer." => "Karibu kwenye mtengenezaji <strong> Tiki% 0 </strong>.",
"Use this script to install a new database or upgrade your existing database." => "Tumia script hii kufunga database mpya au sasisha database yako ya sasa.",
"For the latest information about this release, please read the" => "Kwa maelezo ya hivi karibuni kuhusu kutolewa hili, tafadhali angalia",
"Release Notes" => "maelezo ya kutolewa",
"For complete documentation, please visit" => "Kwa nyaraka kamili, tafadhali wasiliana",
"For more information about Tiki, please visit" => "Kwa habari zaidi kuhusu Tiki, tafadhali wasiliana",
"Select your language" => "Chagua lugha yako",
// "License" => "License",
"Tiki is software distributed under the LGPL license" => "Tiki ni programu iliyosambazwa chini ya leseni ya LGPL",
"Review the System Requirements" => "Angalia mahitaji ya mfumo",
// "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements",
"This installer will perform some basic checks automatically" => "Msanidi huyu atafanya ukaguzi wa automatiska rahisi",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
"Memory" => "Kumbukumbu",
"Tiki has not detected your PHP memory_limit" => "Tiki haikuweza kuchunguza kikomo chako cha kumbukumbu ya PHP (kumbukumbu_limit)",
"This probably means you have no set limit (all is well)" => "Labda ina maana hakuna kikomo (kila kitu ni nzuri)",
"Tiki has detected your PHP memory limit at" => "Tiki imegundua kuwa kumbukumbu yako ya PHP imepungua",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
"Allocating too little memory will cause Tiki to display blank pages" => "Ili kutenga kumbukumbu ndogo sana itasababisha kurasa za kurasa tupu katika Tiki",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
"Tiki has detected your PHP memory_limit at" => "Tiki imegundua kuwa kikomo chako cha kumbukumbu ya PHP (kumbukumbu_limit) imewekwa",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki Inatumia PHP Mail Features Kutuma Ujumbe na Arifa",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Ili kupima usanidi wako, Tiki atajaribu kutuma barua pepe ya mtihani",
"Test email" => "Barua ya mtihani",
// "tiki@example.com" => "tiki@example.com",
"Email address to send test to" => "Anwani ya barua pepe ya mpokeaji wa mtihani",
"Copy test mail to " => "Fanya nakala ya barua pepe ya mtihani",
"Send Test Message" => "Fanya nakala ya barua pepe ya mtihani",
"Tiki was able to send a test message to" => "Tiki imeweza kutuma ujumbe",
"Tiki was not able to send a test message" => "Tiki alishindwa kutuma ujumbe wa mtihani",
"Review your mail log for details" => "Angalia kumbukumbu zako za barua pepe kwa maelezo zaidi",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Angalia usanidi wa barua pepe katika <strong> php.ini </strong> faili (kwa mfano: angalia kwamba njia ya <strong> sendmail_path </strong> ni sahihi)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Ikiwa seva yako inahitaji uthibitishaji wa SMTP, usanidi wa ziada unaweza kuhitajika",
"Image Processing" => "Inazalisha picha",
"Tiki detected" => "Tiki imegunduliwa",
"Tiki can create images" => "Tiki inaweza kuunda picha",
"Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki haikuweza kuunda picha mfano. Tafadhali angalia usanidi wa maktaba yako ya GD",
"Tiki was not able to detect the GD library" => "Tiki imeshindwa kuchunguza maktaba ya GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki inatumia maktaba ya GD kwa usindikaji wa picha kwa nyumba au kizazi cha CAPTCHAS (kupambana na spam)",
"Set the Database Connection" => "Inasanidi uunganisho kwenye orodha",
"Tiki requires an active database connection" => "Tiki inahitaji uunganisho kwenye database zilizopo",
// "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them" => "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them",
"Tiki cannot find a database connection" => "Tiki haiwezi kufikia database",
"This is normal for a new installation" => "Hii ni ya kawaida kwa ufungaji wa kwanza",
"Tiki found an existing database connection in your local.php file" => "Tiki imepata habari ya uunganisho kwa databana iliyopo katika faili yako ya ndani",
// "Database name: %0" => "Database name: %0",
// "Tiki found an automatic database connection for your environment" => "Tiki found an automatic database connection for your environment",
"Use Existing Connection" => "Tumia uunganisho uliopo",
"Modify database connection" => "Badilisha uhusiano kwenye database",
// "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
"Database information" => "Utekelezaji wa database",
"Enter your database connection information" => "Ingiza habari ili uunganishe kwenye orodha",
"DBMS driver" => "DBMS dereva",
"Select the database driver to use with Tiki" => "Chagua dereva wa database kutumia na Tiki",
"Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension." => "Madereva pekee yaliyoorodheshwa hapa ni yale yanayokubaliwa na ufungaji wako wa PHP. Ikiwa dereva wako wa database haipo katika orodha hii, jaribu kuanzisha upanuzi sahihi wa PHP.",
"Host name" => "Jina la majina",
"Enter the host name or IP for your database" => "Ingiza jina au anwani ya IP ya seva katika database yako",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Tumia <strong> localhost </strong> ikiwa database iko kwenye seva sawa na Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
// "Database name" => "Database name",
// "Name of the database to be used. This database will be created if it does not exist and permissions allow creation" => "Name of the database to be used. This database will be created if it does not exist and permissions allow creation",
// "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created" => "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created",
"If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "Ikiwa unatumia database iliyoshirikiwa na programu nyingine (haipendekezi), angalia db/tiki.sql kwamba meza zilizotumiwa na Tiki hazitumiwa tayari",
"Database user" => "Mtumiaji wa data",
// "Enter a database user with administrator permission for the Tiki database" => "Enter a database user with administrator permission for the Tiki database",
"User name" => "Jina la Mtumiaji",
// "Database username" => "Database username",
// "Create the above database user just for this Tiki database" => "Create the above database user just for this Tiki database",
// "Administrative database user" => "Administrative database user",
// "Enter database administrator user name and password" => "Enter database administrator user name and password",
// "This is a DB admin user which has permission to create new databases and new users" => "This is a DB admin user which has permission to create new databases and new users",
// "DB admin user name" => "DB admin user name",
// "DB admin password" => "DB admin password",
"Character set" => "Waandishi wa kuandika",
"Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Chaguo hili linapendekezwa sana kwa mitambo mpya. Hata hivyo, kama wewe ni kuboresha au kuhama kutoka database ya zamani ya tiki, tunapendekeza kufurahia sanduku hili",
"Always force connection to use UTF-8" => "Daima uimarishe uhusiano ili utumie UTF-8",
// "Install & Upgrade" => "Install & Upgrade",
"Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Imeshindwa kuweka max_execution_time kwa PHP. Unaweza kuwa na matatizo ya kuunda/uppdatering database kwa kutumia installer kwa mfumo mdogo. Hii inaweza kuonyeshwa kwa ukurasa usio wazi",
"This install will populate (or upgrade) the database" => "Ufungaji huu utatoa (au kuboresha) database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>",
"A new install will populate the database" => "Ufungaji mpya utaongeza database",
"Encoding Issue" => "Tatizo la kuandika",
// "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>",
"Character Set Conversion" => "Tabia Kuweka Uongofu",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
"Convert database and tables to UTF-8" => "Badilisha database na meza kwa UTF-8",
// "This will destroy your current database: %0" => "This will destroy your current database: %0",
"Reinstall the database" => "Rejesha database",
"Select database engine" => "Kuchagua injini ya database",
"MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
"Reinstall" => "kurejesha",
"Upgrade" => "Sasisha",
"Warning: Category Permissions Will Not Be Upgraded" => "Onyo: Ruhusa ya jamii haitasasishwa",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to version" => "Automatically upgrade your existing database to version",
"This site has an admin account configured" => "Tovuti hii tayari ina mtumiaji wa admin",
"Please log in with your admin password to continue" => "Asante kwa kuunganisha nenosiri na msimamizi ili kuendelea",
"Review the Upgrade" => "Angalia sasisho",
"Review the Installation" => "Angalia ufungaji",
"Upgrade complete" => "Mwisho umekamilika",
"Installation complete" => "Ufungaji umekamilishwa",
"Your database has been configured and Tiki is ready to run!" => "Database yako imefungwa na Tiki yuko tayari kufanya kazi!",
"If this is your first install, your admin password is <strong>admin</strong>." => "Ikiwa hii ni ufungaji wako wa kwanza, tafadhali angalia kwamba jina la mtumiaji wa msimamizi wa tovuti ni <strong> admin </strong> na nenosiri lake pia <strong> admin </strong>.",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application." => "Sasa unaweza kuingia kwa Tiki kama <strong> admin </strong> na uanze kusanidi programu.",
"Upgrade operations executed successfully" => "Sasisha shughuli zimefanyika kwa ufanisi",
"Installation operations executed successfully" => "Uendeshaji wa Uendeshaji Ulikamilishwa kwa Ufanisi",
"SQL queries" => "SQL maswali",
"Database was left unchanged" => "Database imesalia bila kubadilika",
"Operations failed" => "Uendeshaji ulioshindwa",
"Display details" => "Angalia maelezo",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Wakati wa update, ni kawaida kuwa na makosa ya SQL na ujumbe <strong> Jedwali tayari lipo </strong>",
"Check all errors" => "Angalia makosa yote",
"Configure General Settings" => "Usanidi wa jumla",
"Complete these fields to configure common, general settings for your site" => "Jaza mashamba haya ili usanidi mipangilio ya kawaida na ya kawaida ya tovuti yako",
"The information you enter here can be changed later" => "Maelezo unayoingia hapa yanaweza kubadilishwa baadaye",
// "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings",
// "My Tiki" => "My Tiki",
"This will appear in the browser title bar" => "Hii itaonyeshwa kwenye bar ya kichwa cha kivinjari",
"Email sent by your site will use this address" => "Barua pepe zilizotumwa na tovuti yako zitatumia anwani hii",
// "Network Proxy" => "Network Proxy",
// "Toggle section display" => "Toggle section display",
"Secure Log in" => "Uthibitisho salama",
// "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
"HTTPS login" => "Uunganisho wa HTTPS",
"PHP error reporting level" => "Kiwango cha ripoti ya hitilafu ya PHP",
"Report all errors except notices" => "Ripoti makosa yote isipokuwa matangazo",
"Visible to Admin only" => "Inaonekana kwa Admin tu",
"Admin email" => "Barua ya Msimamizi",
// "admin@example.com" => "admin@example.com",
"This is the email address for your administrator account" => "Hii ni anwani ya barua pepe ya msimamizi wa tovuti",
// "Set up htaccess file" => "Set up htaccess file",
"Method" => "Mbinu",
// "Select how to set up your htaccess file" => "Select how to set up your htaccess file",
"Upgrade fix" => "Sasisha tatizo",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will",
"Create the <em>Admins</em> group, if missing" => "Créer le groupe <em>Admins</em>, si manquant",
"Grant <em>tiki_p_admin</em> to the group, if missing" => "Accorder le droit <em>tiki_p_admin</em> au groupe, si manquant",
"Add the administrator account to the group, if missing" => "Ajouter le compte administrateur au groupe, si manquant",
"To do so enter the name of the main admin account in the field below" => "Pour agir ainsi, entrer le nom du compte principal administrateur dans le champ ci-dessous",
// "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>" => "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>",
"Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Cocher cette case si vous avez un grand nombre de comptes désactivés après une mise à jour vers tiki4",
"List of accounts that will be enabled" => "Liste des comptes qui vont être activés",
// "Last Notes" => "Last Notes",
// "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future" => "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future",
// "Subscribe to Tiki Releases newsletter" => "Subscribe to Tiki Releases newsletter",
// "Critical & Security update" => "Critical & Security update",
// "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates" => "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates",
// "We don't share subscribed emails and we send very few of these newsletters per year" => "We don't share subscribed emails and we send very few of these newsletters per year",
// "Please use the following link and subscribe" => "Please use the following link and subscribe",
// "Tiki Releases newsletter" => "Tiki Releases newsletter",
// "First Wizards, then Control Panels with Preference Filter" => "First Wizards, then Control Panels with Preference Filter",
// "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator" => "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator",
// "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})" => "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})",
// "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install" => "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install",
// "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels" => "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels",
// "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided" => "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided",
// "Storing your uploaded files" => "Storing your uploaded files",
// "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database" => "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database",
// "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more" => "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more",
// "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other" => "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other",
// "Tiki Community" => "Tiki Community",
// "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users" => "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users",
// "Get Help with Tiki" => "Get Help with Tiki",
// "Hire a Tiki Service Provider" => "Hire a Tiki Service Provider",
// "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>" => "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>",
"Enter Your Tiki" => "Fikia Tiki yako",
// "Ready to run" => "Ready to run",
"The installation is complete" => "Ufungaji umekamilika",
"Your database has been configured and Tiki is ready to run" => "Uunganisho wako kwenye kazi ya database na Tiki ni tayari kufanya kazi",
".htaccess File" => ".htaccess File",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Tunapendekeza kuwezesha faili ya <strong> .htaccess </strong> kwa Tiki yako",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Hii itawawezesha kutumia SEFURLs ('URL za Utafutaji wa Rafiki za Kutafuta' au 'URL za Rafiki za Kutafuta') na kuboresha usalama wa tovuti",
// "Your .htaccess file has been set up (%0)" => "Your .htaccess file has been set up (%0)",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
"Enter Tiki and Lock Installer" => "Ingiza Tiki kwa kuzima mfungaji",
"Recommended" => "ilipendekeza",
"Enter Tiki Without Locking Installer" => "Ingiza Tiki bila kuzuia ufungaji",
// "Not recommended due to security risk" => "Not recommended due to security risk",
"You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "Unaweza kufikia tovuti kwa kawaida sasa. Ripoti shida yoyote ambayo unaweza kukutana (kama ipo) kwenye vikao vya Tiki au fomu ya mdudu",
"Are you sure you want to attempt to fix the encoding of your entire database" => "Una uhakika unataka kujaribu kurekebisha encoding ya database yako yote?",
"Upgrading and running into encoding issues" => "Umeboreshwa na unakabiliwa na masuala ya encoding",
"We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "Tunaweza kujaribu kurekebisha, lakini <strong> hakikisha kuimarisha data yako na kurejesha. </strong>",
"Previous table encoding" => "Ukodishaji wa awali wa meza zako",
"Please select" => "Tafadhali chagua",
// "Click to fix double encoding (dangerous)" => "Click to fix double encoding (dangerous)",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
"MultiTiki Setup" => "Upangiaji Multi Tiki",
"Default Installation" => "Usanidi wa kiutomatiki",
"DB OK" => "DB OK",
"No DB" => "Hapana BDD",
"Adding a new host" => "Ongeza server mpya ya jeshi",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Ili kuongeza seva mpya ya virusi, tumia script ya setup.sh na jina la uwanja wa tovuti mpya kama parameter ya mwisho",
"MultiTiki" => "MultiTiki",
"Are you upgrading an existing Tiki site" => "Je! Unasasisha tovuti ya Tiki iliyopo?",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Nenda moja kwa moja kwenye <strong>Sakinisha/Mwisho </strong>",
"Install/Upgrade" => "Sakinisha / Mwisho",
"Powered by" => "Kulingana na",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
"Clear cached version and refresh cache" => "Weka cache na uijenge tena",
"configure rules" => "sani sheria",
"Invitation" => "mwaliko",
"Invitations list" => "Orodha ya mwaliko",
"The mail has been sent to: " => "Barua pepe ilipelekwa : ",
"You are about to send an invitation to theses people, please confirm" => "Wewe ni karibu kutuma mwaliko kwa watu hawa, tafadhali thibitisha",
"Fill this box with the list of emails you want to invite " => "Jaza uwanja huu na orodha ya anwani za barua pepe unayotaka",
"Format of the list above " => "Aina ya orodha hapo juu",
"CSV Style: One line per invitation, with the format: lastname,firstname,email" => "Style CSV: Mstari mmoja kwa kila mwaliko, na muundo: Jina la mwisho, jina la kwanza, barua pepe",
"Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Kitu chochote kinachoonekana katika maandishi kama barua pepe kitatambuliwa na kutumika (katika kesi hii, {literal} {firstname} na {lastname} {/literal} itachukuliwa katika maudhui ya barua pepe)",
// "Type here the email subject you'll want to be sent to them " => "Type here the email subject you'll want to be sent to them ",
// "Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
"Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special " => "Chagua kikundi au zaidi ambapo unataka usajili uende. Usichague chochote ikiwa hutaki chochote maalum",
"Invoices" => "ankara",
"New Invoice" => "Invoice mpya",
"Clients" => "wateja",
"New Client" => "Mteja mpya",
// "Invoice Reports" => "Invoice Reports",
"Add more media" => "Ongeza vyombo vya habari zaidi",
// "Change Details" => "Change Details",
"Video Title" => "Kichwa cha video",
"Editor" => "mchapishaji",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
"No action specified" => "Hakuna hatua maalum",
// "This file is not expected to be called directly" => "This file is not expected to be called directly",
"Last Changes" => "Mabadiliko ya Mwisho",
"Last 2 days" => "Siku mbili zilizopita",
"Last 3 days" => "Siku tatu zilizopita",
"Last 5 days" => "Siku tano zilizopita",
"Last week" => "Wiki iliyopita",
"Last 2 weeks" => "Wiki mbili zilizopita",
"Last month" => "Mwezi uliopita",
"Search by Date" => "Utafute kwa tarehe",
"Found" => "kupatikana",
"LastChanges" => "Mabadiliko ya hivi karibuni",
"Ip" => "IP",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
"v" => "v",
"Diff" => "tofauti",
"Pages like" => "Kurasa zinazofanana na",
"New Article" => "Kurasa zinazofanana na",
// "New Submission" => "New Submission",
"View Submissions" => "Orodha ya maoni",
// "Expiry Date" => "Expiry Date",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
// "Select Duplicates" => "Select Duplicates",
// "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "Unda bendera",
"Use Dates?" => "Tumia tarehe?",
"Max Impressions" => "Max. hisia",
"Impressions" => "hisia",
"Max Clicks" => "Max. inakabiliwa",
"Clicks" => "Clicks",
// "List Posts" => "List Posts",
"The cache is used by" => "Cache hutumiwa na",
// "{\$headerName}" => "{\$headerName}",
"Approval" => "idhini",
// "Delete comment" => "Delete comment",
"(no title)" => "(hakuna kichwa)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
"Approved" => "kupitishwa",
"More Information" => "Maelezo zaidi",
// "Delete selected comments" => "Delete selected comments",
// "Delete and ban selected comments" => "Delete and ban selected comments",
// "Delete and ban" => "Delete and ban",
"Dynamic Content System" => "Mfumo wa maudhui ya nguvu",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "Vous pouvez aussi utiliser {literal}{content label=x}{/literal}, où x est l'étiquette du bloc de contenu",
"Available content blocks" => "Vitalu vya maudhui vinapatikana",
"Current Value" => "Thamani ya sasa",
"Current ver" => "Version en cours",
"Next ver" => "Toleo la pili",
"Future vers" => "Matoleo ya baadaye",
"Program" => "mpango",
"Create/Edit content block" => "Unda/Badilisha kitu cha kuzuia maudhui",
"Edit content block" => "Badilisha maudhui ya kuzuia",
"Create content block" => "Unda kuzuia maudhui",
"Available FAQs" => "FAQs inapatikana",
// "Questions / Suggested" => "Questions / Suggested",
"Edit/Create" => "Edit/Ongeza",
"Create new FAQ" => "Unda FAQ mpya",
"Create New FAQ" => "Unda FAQs mpya",
"Users can suggest questions" => "Watumiaji wanaweza kupendekeza maswali",
"Create a File Gallery" => "Unda nyumba ya sanaa ya faili",
// "{\$name}" => "{\$name}",
// "Finder" => "Finder",
"RSS feed" => "Ushirikiano wa RSS",
// "Hide file information from list view" => "Hide file information from list view",
// "Hide list view information" => "Hide list view information",
// "Show file information from list view" => "Show file information from list view",
// "Show list view information" => "Show list view information",
// "Create Diagram" => "Create Diagram",
// "Batch" => "Batch",
"SlideShow" => "slideshow",
// "Create H5P" => "Create H5P",
"Be careful to set the right permissions on the files you link to" => "Tahadhari, ni muhimu kufafanua haki za kutosha kwenye faili iliyounganishwa ili iwezekanavyo",
"Keep gallery window open" => "Weka dirisha la nyumba ya sanaa lifunguliwe",
"optional" => "hiari",
"Modifications" => "marekebisho",
"Property <b>{\$fgp_name}</b> Changed" => "mali <b>{\$fgp_name}</b> iliyopita",
// "Search for text within files in all galleries" => "Search for text within files in all galleries",
"Search by identifier" => "Tafuta kwa kitambulisho",
"Search for the file with this number, in all galleries" => "Chercher le fichier avec ce numéro, dans toutes les galeries",
// "Maximum width" => "Maximum width",
"You can access the file gallery using the following URL" => "Unaweza kufikia sanaa hii ya faili na anwani hii ya wavuti",
"Gallery Images" => "Nyumba ya sanaa ya picha",
"Inviter" => "kukaribisha",
"Only successful invitations" => "Mialiko tu ya mafanikio",
"Only pending invitations" => "Mialiko tu inasubiri",
"Number of invitations" => "Idadi ya mwaliko",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
"Client Name" => "Jina la Wateja",
// "Remix Entries" => "Remix Entries",
// "Browse Media" => "Browse Media",
// "Browse Remixes" => "Browse Remixes",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Media Id" => "Media Id",
"Wiki plugin code" => "Kanuni ya Plugin Wiki",
"No entries" => "Hakuna kuingia",
// "No media entries found" => "No media entries found",
"to upload" => "kutuma",
"Modified By" => "Ilibadilishwa na",
// "No mix entries found" => "No mix entries found",
"Object Permissions List" => "Orodha ya haki za kitu",
"Object Permissions" => "Ruhusa ya Kitu",
// "Object permissions" => "Object permissions",
// "Category permissions" => "Category permissions",
// "Perform action with selected permissions" => "Perform action with selected permissions",
// "Assign to this group" => "Assign to this group",
// "Only default global permissions are being used" => "Only default global permissions are being used",
"Reason" => "sababu",
// "No object permissions apply" => "No object permissions apply",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
// "No category permissions apply" => "No category permissions apply",
"Blog: %0" => "Blog: %0",
"New Blog Post" => "kuchapisha",
"Post Title" => "Jina la ujumbe",
"Blog Title" => "Kichwa cha blogu",
// "(bytes)" => "(bytes)",
"Delete Expired Submissions" => "Futa maoni ya nje",
// "Deletes expired submissions 1000 at a time to avoid timeouts" => "Deletes expired submissions 1000 at a time to avoid timeouts",
"Survey stats" => "Takwimu za Utafiti",
// "Take survey" => "Take survey",
// "Import Structure" => "Import Structure",
// "Import From Profile/YAML" => "Import From Profile/YAML",
// "Manage Tabular Formats" => "Manage Tabular Formats",
// "Clone remote" => "Clone remote",
"Items" => "mambo",
// "{\$tracker.name|escape}" => "{\$tracker.name|escape}",
"Do you really remove this tracker" => "Je! Unataka kufuta fomu hii",
"Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Je! Unataka kufuta fomu zote kwenye fomu hii? (NB: Hakuna kufuta na hakuna taarifa itatumwa)",
"users registered" => "watumiaji waliosajiliwa",
"like" => "kama",
"Distance (km)" => "Umbali (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
"List Wiki Pages" => "Orodha ya ukurasa Wiki",
"Page aliases found" => "Alias de page trouvés",
"Create a Wiki Page" => "Unda ukurasa wa Wiki",
"Insert name of the page you wish to create" => "Ingiza jina la ukurasa unayotaka kuunda",
// "Create page within %0" => "Create page within %0",
"Page creator" => "muumba",
"Last author" => "Mwandishi wa mwisho",
"Last version" => "Toleo la hivi karibuni",
"Status of the page" => "Hali ya ukurasa",
"Links to other items in page" => "Viungo kwa vitu vingine kwenye ukurasa",
"Links to this page in other pages" => "Viungo kwa ukurasa huu katika kurasa nyingine",
"Backl" => "Backl",
"Page size" => "Ukubwa wa ukurasa",
"Lang" => "lugha",
// "No page" => "No page",
"No pages found with" => "Hakuna kurasa zilizopatikana na",
// "Download PDF" => "Download PDF",
// "Download zipped file" => "Download zipped file",
// "Add page name as page header" => "Add page name as page header",
"Open client window" => "Fungua console ya mteja",
"Generate HTML" => "Kuzalisha katika HTML",
"Transcripts" => "mahusiano",
"Online operators" => "Mteja aliyeunganishwa",
"Accepted requests" => "Maombi ya kukubalika",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "mahusiano",
"offline" => "haijaunganishwa",
"Offline operators" => "Wafanyakazi wasiounganishwa",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "Ongeza operator kwa mfumo",
"Operators must be tiki users" => "Waendeshaji lazima wawe watumiaji wa Tiki",
"Set as Operator" => "Majadiliano yalianza",
"Chat started" => "Majadiliano yalianza",
"Live support:User window" => "Msaidizi wa mtandaoni: Dirisha la mtumiaji",
"Request live support" => "Ombi la usaidizi",
"Request support" => "Ombi la usaidizi",
"Your request is being processed" => "Ombi lako limezingatiwa",
"cancel request and exit" => "Futa ombi na uondoke",
"cancel request and leave a message" => "Futa ombi na uacha ujumbe",
"Live support:Console" => "Msaada wa mtandaoni: Console",
// "{\$status}" => "{\$status}",
"be online" => "kuungana",
"be offline" => "kukata",
// "You are not an operator" => "You are not an operator",
"Support requests" => "Maombi ya usaidizi",
"Requested" => "maombi",
"Accept" => "kukubali",
"Join" => "kujiunga",
// "No support requests" => "No support requests",
"Support chat transcripts" => "Ripoti ya majadiliano ya msaada",
// "Back to admin" => "Back to admin",
"operator" => "operator",
"started" => "kuanza",
"reason" => "sababu",
// "msgs" => "msgs",
"Transcript" => "ripoti",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Kwa sababu za usalama, lazima uhakikishe mara kwa mara anwani yako ya barua pepe ili uweze kufikia tovuti.",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "Barua ya kuthibitisha imetumwa kwako. Tafadhali fungua na ufuate maelekezo ya kufikia tovuti.",
"Thank you" => "asante",
"Mail-in feature" => "Kazi ya barua pepe",
"Click here to go to mailin admin" => "Bofya hapa kwenda kwenye uongozi wa barua zinazoingia",
"Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Dépendance manquante. Obtenez <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> et téléchargez-le dans 'files/'",
"Mini Calendar" => "Kalenda yangu",
// "Prefs" => "Prefs",
"Daily" => "siku",
"Weekly" => "kila wiki",
"Remove old events" => "Futa matukio ya zamani",
"h" => "h",
"mins" => "mins",
"Edit Event" => "Badilisha tukio",
"Mini Calendar: Preferences" => "Kalenda yangu: Mapendekezo",
"Calendar Interval in daily view" => "Muda wa muda katika mtazamo wa siku",
"Start hour for days" => "Saa ya kwanza ya siku",
"End hour for days" => "Saa ya mwisho ya siku",
"Reminders" => "kuwakumbusha",
"no reminders" => "Hakuna kumbukumbu",
"min" => "min",
"Or enter path or URL" => "Au kutoa njia au anwani ya wavuti",
"Add Topic" => "Ongeza kichwa",
"Tiki Mods" => "Mods Tiki",
// "Tiki \"Mods\" are obsolete as of Tiki 19" => "Tiki \"Mods\" are obsolete as of Tiki 19",
// "Tiki now uses \"Packages\" instead" => "Tiki now uses \"Packages\" instead",
// "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>" => "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>",
"y" => "oui",
"User Galleries" => "Nyumba zangu",
"My Articles" => "Mes articles",
"User Articles" => "Makala ya Mtumiaji",
"My User Items" => "Kadi zangu",
"User Items" => "Faili za mtumiaji",
"Unread Messages" => "Ujumbe usiojifunza",
"User forum topics" => "Mada ya mtumiaji katika jukwaa",
// "Forum topic" => "Forum topic",
"Date of post" => "Tarehe ya kuchapishwa",
"User forum replies" => "Majibu ya mtumiaji kwenye jukwaa",
"User Blogs" => "Blogu zangu",
// "My blog Posts" => "My blog Posts",
// "User Blog Posts" => "User Blog Posts",
"To display the objects you created or contributed to" => "Ili kuona vitu ambavyo unashiriki",
// "My Items" => "My Items",
"My Info" => "",
"My Watches" => "Arifa zangu",
"Contacts Preferences" => "Mapendekezo ya mawasiliano",
"Notepad" => "Pad",
"MyFiles" => "Faili Zangu",
"Sent editions" => "Majarida ya kutumwa",
"Admin Newsletters" => "Dhibiti majarida",
"HTML version" => "Toleo la HTML",
"Text version" => "Toleo la maandishi",
"The newsletter was sent to {\$sent} email addresses" => "Jarida hili limetumwa kwa {\$ sent} anwani za barua pepe",
"Delete errors" => "Futa makosa",
"Not sent" => "Haikutumwa",
"Subscribe to Newsletter" => "Kujiunga na jarida",
"Subscribe to this Newsletter" => "Jiunga na jarida hili",
"Available Newsletters" => "Inapatikana Habari",
"Write a note" => "Andika alama",
"quota" => "quota",
"No notes yet" => "Hakuna maelezo bado",
"Merge selected notes into" => "Unganisha maelezo yaliyochaguliwa",
"Reading note" => "Kusoma note",
"List notes" => "Orodha maelezo",
"Write note" => "Andika maelezo",
"Wiki Create" => "Unda Wiki",
"Wiki Overwrite" => "kuponda Wiki page ",
"Object Watches" => "Vipimo vya Kitu",
"Groups watching" => "Kuangalia vikundi",
"Changes to groups watching" => "Mabadiliko kwa makundi ya kuangalia",
"These changes to group watches" => "Mabadiliko haya kwa kuangalia kundi",
"were made to these descendants" => "zilifanywa kwa wazazi hawa",
"This Category" => "Jamii hii",
"All Descendants" => "Wazazi wote",
"Assign global permissions" => " Inaruhusu ruhusa ya jumla",
"Assign permissions to " => "Shirikisha ruhusa ",
"Edit Permissions" => "Badilisha vibali",
"Currently editing Global permissions." => " uhariri za ruhusa ujumla",
"This object's direct permissions override any global permissions or category permissions affecting this object" => "Ruhusa ya moja kwa moja ya kitu hiki hupunguza ruhusa yoyote ya kimataifa au ruhusa ya kikundi inayoathiri kitu hiki",
"This category's direct permissions override any global permissions affecting objects in it" => "Kundi hili ni ruhusa za moja kwa moja zinapunguza ruhusa yoyote ya kimataifa inayoathiri vitu ndani yake",
"To edit global permissions" => "Ili kubadilisha ruhusa ya kimataifa",
"No permissions yet applied to this object but category permissions affect this object and are displayed below" => "Hakuna ruhusa bado kutumika kwa kitu hiki lakini vibali vya kikundi vinaathiri kitu hiki na vinaonyeshwa hapa chini",
"To edit category permissions" => "Ili kubadilisha vibali vya jamii",
"No permissions yet applied to this object but parent object's permissions affect this object and are displayed below" => "Hakuna ruhusa bado kutumika kwa kitu hiki lakini ruhusa ya kitu cha mzazi huathiri kitu hiki na huonyeshwa hapa chini",
"To edit parent object's permissions" => "Ili kubadilisha vibali vya mzazi",
"No direct permissions yet applied to this object. Global permissions apply." => "Hakuna ruhusa moja kwa moja bado kutumika kwa kitu hiki. Ruhusa ya kimataifa hutumika.",
"Currently inherited permissions displayed" => "Hivi sasa vibali vya urithi vimeonyeshwa",
"Show permissions for disabled features" => " Onyesha ruhusa  kwa functionnalities walemavu",
"Assign permissions to this category" => "Shirikisha ruhusa kwa jamii hii",
"Assign permissions to this object" => "Weka vibali kwa kitu hiki",
"Delete category permissions" => "Futa vibali vya jamii",
"Delete object permissions" => "Futa ruhusa ya kitu",
"Reset Perms" => "Weka Ruhusa",
"This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "Hii itaondoa mipangilio yote hapa na ruhusa zitarejeshwa ili kurithi ruhusa yoyote ya kikoa ambayo imewekwa, au ruhusa za kimataifa duniani",
"This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "Hii itasaidia mipangilio yote hapa na ruhusa zitarejeshwa ili kurithi vibali vya kimataifa duniani",
"Permissions Clipboard" => "Ruhusa ya Clipboard",
"Copy the permissions set here" => "Nakili ruhusa zilizowekwa hapa",
"Paste" => "Weka",
"Paste copied permissions from " => "Weka ruhusa zilizokopishwa kutoka ",
"Assign or remove permissions on <em>all</em> child categories" => "Weka au kuondoa ruhusa kwenye makundi ya watoto <em> yote </ em>",
"Are you sure you want to affect all child categories?\\nThere is no undo" => "Je! Una uhakika unataka kuathiri makundi yote ya watoto? \\ Hakuna uharibifu",
"Assign or remove permissions on all pages of the sub-structure" => "Shirikisha au kuondoa ruhusa kwenye kurasa zote za muundo",
"Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Una uhakika unataka kuathiri kurasa zote katika sehemu hii? \\ Hakuna kufuta",
"You must select at least one feature" => "Lazima uchague angalau kipengele kimoja",
"View Differences" => "Angalia Tofauti",
"Permissions added" => "Vidokezo vimeongezwa",
"Permissions removed" => "Vidokezo viliondolewa",
"Select groups" => "chagua moja / zaidi",
"Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for" => "Baadhi ya vikundi vyako vimefichwa moja kwa moja. <br> Chagua vikundi chini ili ugawa vibali",
"These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab." => " Makundi haya sio ambao wana haki ya kufanya kitu. Hizi ni makundi ambayo unaweza kuona kwenye tabo za kwanza.",
"Select only groups that have a perm with the object" => "Chagua vikundi pekee vina vibali na kitu",
"Group name" => "jina la kikundi",
// "Select features" => "Select features",
"Some of your features have been automatically hidden.<br> Select the features below to assign permissions for" => "Baadhi ya vipengele vyako vimefichwa kwa moja kwa moja. <br> Chagua vipengele hapa chini ili ugawa ruhusa",
"Feature name" => "Jina la kipengele",
"Quick Permissions" => "Ruhusa Ruhusa",
"Assign Quick-Permissions to this object" => "Weka Ruhusa-Ruhusa kwa kitu hiki",
"Individual permissions are currently assigned (See tab Assign Permissions)" => "Ruhusa ya mtu binafsi kwa sasa imewekwa (Tazama kichupo Chagua Ruhusa)",
"<em>Quick permissions</em> should be considered as an experimental feature" => "<em> ruhusa ya haraka </ em> inapaswa kuchukuliwa kama kipengele cha majaribio",
"Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably." => "Ingawa ruhusa zitawekwa kama inavyotarajiwa kutumia fomu hii, haimaanishi ruhusa ya sasa kwa uhakika.",
"There is also no undo - <strong>Use with care!</strong>" => "Hakuna pia kutengeneza - <strong> Tumia kwa uangalifu! </ Strong>",
"Your OpenID identity is valid" => "Utambulisho wako wa OpenID halali",
"Your identity gives you access to multiple user accounts." => "Utambulisho wako unakupa upatikanaji wa akaunti nyingi za mtumiaji.",
"Select account" => "Chagua akaunti",
"Orphan Pages" => "Kurasa za Orphan",
"Browser not supported" => " Chagua vipengele moja au zaidi",
"Contributions by author" => "Michango na mwandishi",
"Similar" => "Sawa",
"Make Structure" => "Fanya Mundo",
"Discuss" => "Majadiliano",
"Bookmark" => "Bookmark",
"View latest version before editing" => "Tazama toleo la hivi karibuni kabla ya kuhariri",
"Contributions to" => "Mchango kwa",
"current version" => "toleo la sasa",
"Words" => "Maneno",
"Whitespaces" => "Mipaka",
"Characters" => "mhusika",
"Printable characters" => "Wahusika wa kuchapishwa",
"Page changes" => "Mabadiliko ya ukurasa",
"Original wiki text" => "Nakala ya awali ya wiki",
"Parsed Text (HTML)" => "Nakala iliyopigwa (HTML)",
"Output text only (No HTML tags)" => "Nakala ya kuchapisha tu (Hakuna lebo ya HTML)",
"Show statistics" => "Onyesha takwimu",
"Visualize page changes" => "Onyesha mabadiliko ya ukurasa",
"Show popups" => "Onyesha popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
"Collapse Into Edit Sessions" => "Kuondoka katika Vipindi vya Hariri",
"Show All Versions" => "Onyesha matoleo yote",
"Preview of version" => "Aperçu de cette version",
"(current)" => "(Kwa sasa)",
"Roll back to this version" => "Rudi nyuma kwenye toleo hili",
"Content Approval" => "Idhini ya Maudhui",
"This revision is currently marked as approved" => "Urejesho huu umewekwa alama kama kupitishwa",
"Remove Approval" => "Ondoa kibali",
"This revision has not been approved" => "Marekebisho haya haijaidhinishwa",
"Approve Revision" => "Thibitisha Marekebisho",
"History view" => "Mtazamo wa Historia",
"This revision may not be the latest approved revision" => "Marekebisho haya inaweza kuwa marekebisho ya hivi karibuni yaliyothibitishwa",
"This revision has been rejected" => "Marekebisho haya yamekataliwa",
"Source of version:" => "Chanzo cha toleo :",
"Update Translation" => "Sasisha Tafsiri",
"Hide translation history" => "Ficha historia ya kutafsiri",
"Show translation history" => "Onyesha matoleo yote",
"Enable pagination" => "Wezesha pagination",
"rows per page" => "safu kwa kila ukurasa",
"HTML allowed" => "HTML inaruhusiwa",
"HTML syntax is allowed either by page setting or use of the WYSIWIG editor" => "Hifadhi ya HTML inaruhusiwa ama kwa kuweka ukurasa au matumizi ya mhariri wa WYSIWYG",
"from %0" => "kutoka %0",
"approved" => "imeidhinishwa",
"Updated from" => "Imeongezwa kutoka",
"Used to update" => "tumia kusasisha",
"rejected" => "kataa",
"Difference" => "Tofauti",
"Older Version" => "Toleo la Kale",
"Israel Post" => "Chapisho Israel ",
"Order ID" => "Amri ID",
"Payment authorized (not captured)" => "Mamlaka ya Kulipa kwa malipo (haijatumwa)",
"Payment authorized (captured)" => "Malipo yameidhinishwa (alitekwa)",
"Unknown state" => "Hali isiyojulikana",
"Date Paid" => "Tarehe Ilipwa",
"Payer" => "Mlipaji",
"Payer email from %0" => "Barua pepe ya kulipa kutoka% 0",
"View payment info" => "Tazama maelezo ya malipo",
"Cancel this payment request" => "Futa ombi hili la malipo",
"View payment request" => "Tazama ombi la malipo",
"Paypal" => "Paypal",
"Transaction ID" => "Shughuli ID",
"Payment made by <em>%0, %1</em> (%2)" => "Malipo yaliyotolewa na <em>% 0,% 1 </ em> (% 2)",
"Payment Request" => "Ombi la Malipo",
"{\$wp_member_title}" => "{\$wp_cheo cha mwanachama}",
"For each user: " => "Kwa kila mtumiaji: ",
"per full period" => "kwa muda kamili",
"applicable prorated pricing provided" => "bei inayotumika kwa bei iliyozotolewa",
"free periods provided" => "vipindi bure hutolewa",
"full free" => "kamili bure",
"prorated free" => "ilitengenezwa bure",
"Payment Status" => "Hali ya Malipo",
// "{\$payment_info.state|capitalize|escape}" => "{\$payment_info.state|capitalize|escape}",
"Capture Payment" => "Pata Malipo",
"Paid amount" => "Kiwango kilicholipwa",
"Initial amount" => "Kiasi cha awali",
"Amount remaining" => "Kiasi kilichobaki",
"Payment request initiated" => "Ombi la kulipa limeanzishwa",
"Payment request due" => "Ombi la malipo ni kutokana",
"Pay with PayPal" => "Ulipa na PayPal",
// "Pay with Paypal" => "Pay with Paypal",
"Proceed to Israel Post" => "Endelea kwenye Chapisho la Israel",
"Pay With Cclite" => "Ulipa na Cclite",
"Refresh page" => "Furahisha ukurasa",
"Payment info" => "Maelezo ya malipo",
"Trade with Cclite" => "Biashara na Cclite",
"Payment problem" => "Tatizo la kulipa",
"Pay With Tiki Credits" => "Kulipa Kwa Mikopo ya Tiki",
"Pay with Tiki User Credits" => "Kulipa na Mikopo ya Watumiaji wa Tiki",
"Credit type" => "Credit type",
"Credits left" => "Mikopo iliyoachwa",
"Amount to pay" => "Kiasi cha kulipa",
"Pay using" => "Kulipa kwa kutumia",
"Payment Details" => "Maelezo ya Malipo",
"Enter a Manual Payment" => "Ingiza Malipo ya Mwongozo",
"Enter payment" => "Ingiza malipo",
"using" => "kutumia",
"Payment information" => "kwa kutumia maelezo ya Malipo",
"No outstanding payments found" => "Hakuna malipo bora yaliyopatikana",
"No paid payments found" => "Hakuna malipo yaliyopatikana",
// "<em>No cancelled payments found</em>" => "<em>No cancelled payments found</em>",
"Request" => "Omba",
"Payable within" => "Kulipa ndani",
"Pick your profile picture" => "Chagua picha yako ya wasifu",
"Your current profile picture" => "Picha yako ya sasa ya wasifu",
"Full size" => "Ukubwa kamili",
"no profile picture" => "Hakuna picha ya wasifu",
"Pick user profile picture from the library" => "Chagua picha ya wasifu wa mtumiaji kutoka kwa maktaba",
"Pick user profile picture" => "Chagua picha ya wasifu wa mtumiaji",
"Hide all" => "Ficha yote",
"icons" => "icons",
"Show all" => "Onyesha yote",
"random" => "ovyoovyo",
"Upload your own profile picture" => "Pakia picha yako ya wasifu",
"Select your profile picture" => "Chagua picha yako ya wasifu",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Fichier (seulement des images en .gif, .jpg et .png avec une taille approximative de 45px × 45px)",
"File (only .gif, .jpg and .png images)" => "Fichier (seulement  images .gif, .jpg et .png)",
"Plugin execution was denied" => "L'exécution du plugiciel a été refusée",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Après validation des arguments par un éditeur, l'exécution de ce plugiciel a été refusée. Ce plugiciel sera éventuellement retiré ou corrigé",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "Ce plugiciel a été ajouté/modifié récemment. Son exécution ne sera pas possible avant que l'éditeur de site ne valide ces paramètres",
"You are allowed to" => "Vous êtes autorisé à",
"View arguments" => "Voir les arguments",
"Execute the plugin in preview mode (may be dangerous)" => "Exécuter le plugiciel en mode prévisualisation (peut être risqué)",
"Approve the plugin for public execution" => "Autoriser le plugiciel pour une exécution publique",
"View Details" => "Angalia Maelezo",
"This plugin does not contain any arguments" => "Plugin hii haina vikwazo vyovyote",
"This plugin's body is empty" => "Mwili huu wa Plugin hauna tupu",
// "Experiment with plugin LIST" => "Experiment with plugin LIST",
// "Test Plugin LIST" => "Test Plugin LIST",
"For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "Kwa usalama, ruhusu <strong> tiki_p_plugin_approve </ strong> idhini tu kwa vikundi vya mtumiaji waaminifu",
// "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins",
"This page lists the plugins that require validation, the first time they are encountered" => "Ukurasa huu unaorodhesha mipangilio ambayo inahitaji uthibitishaji, mara ya kwanza wanayokutana",
"Each plugin contains a unique <em>signature</em> that is preserved" => "Kila Plugin ina saini ya <em> saini </ em> iliyohifadhiwa",
"When you upgrade from an old version, you may need to reparse all the pages" => "Unapoboresha kutoka toleo la zamani, huenda ukahitaji kurasa tena kurasa zote",
"If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "Ikiwa Plugin haitumiki tena (kwa mfano, imeondolewa kwenye ukurasa wa wiki), tumia <strong> Futa </ ​​strong> ili kuiondoa kwenye orodha hii",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
"Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins inaweza kuwa moja kwa moja ilionyeshwa, kupitishwa, au kukataliwa kutoka eneo fulani ambalo lina Plugin",
"For security, you should review each plugin to ensure it is safe to approve" => "Kwa usalama, unapaswa kuchunguza kila Plugin ili kuhakikisha kuwa salama kuidhinisha",
"Added By" => "Imeongezwa",
// "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>" => "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>",
// "View this page" => "View this page",
"Approve all pending plugins" => "Thibitisha programu zote zinazopendwa",
"Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Kutumia <strong> Kuidhinisha </ strong> au <strong> Kuidhinisha Wote </ strong> itaidhinisha na kuamsha plugins inasubiri",
"Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Tumia kipengele hiki <strong> tu </ strong> tu ikiwa umehakikishia kuwa plugins yote inasubiri ni salama",
"No plugins pending approval" => "Hakuna mipangilio inasubiri idhini",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
"View Results" => "Angalia Matokeo",
// "Sorry" => "Sorry",
"Other Polls" => "Vipengele vingine",
"Poll Results" => "Matokeo ya Uchaguzi",
// "All Polls" => "All Polls",
// "Top-Voted Polls" => "Top-Voted Polls",
"Edit Poll" => "Badilisha Poll",
// "Find the poll" => "Find the poll",
// "{\$what}" => "{\$what}",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Show results in this range" => "Show results in this range",
// "Show all results with no time span consideration" => "Show all results with no time span consideration",
// "Show all results with time span consideration" => "Show all results with time span consideration",
// "Show all results" => "Show all results",
// "Find results" => "Find results",
// "Show detailed results of this poll" => "Show detailed results of this poll",
"List Votes" => "Orodha ya Votes",
// "Preference translation" => "Preference translation",
// "Popup preview" => "Popup preview",
"Close preview" => "Futa hakikisho",
// "Permalink" => "Permalink",
"The original document is available at" => "Hati ya awali inapatikana",
"Print multiple pages" => "Chapisha kurasa nyingi",
"Selected Structures" => "Miundo iliyochaguliwa",
"Add Structure" => "Ongeza muundo",
"No structures" => "Hakuna miundo",
"Available Pages" => "Kurasa zinazopatikana",
"No pages" => "Hakuna kurasa",
"All pages selected" => "Kurasa zote zilichaguliwa",
"Add Page" => "Ongeza Ukurasa",
"Remove Page" => "Ondoa Ukurasa",
"Selected Pages" => "Kurasa zilizochaguliwa",
"No pages selected." => "Hakuna kurasa zilizochaguliwa.",
"Add Pages from Structures" => "Ongeza Kurasa kutoka kwa Miundo",
"Edit quiz" => "Badilisha jaribio",
"Current Version" => "Toleo la sasa",
"General Options" => "Chaguzi Zingi",
"Publication Date" => "Tarehe ya Kuchapishwa",
"at " => "katika ",
"Use " => "matumizi",
"randomly selected questions." => "maswali yaliyochaguliwa kwa hiari.",
"Test-time Options" => "Chaguzi za wakati wa mtihani",
"Shuffle questions" => "Futa maswali",
"Shuffle answers" => "Jibu majibu",
"Limit questions displayed per page to " => "Punguza maswali yaliyoonyeshwa kwa kila ukurasa",
// "question(s)" => "question(s)",
"Impose a time limit of " => "Weka kikomo cha wakati",
"Allow students to store partial results and return to quiz." => "Ruhusu wanafunzi kuhifadhi matokeo ya sehemu na kurudi kwenye jaribio.",
"Allow students to retake this quiz " => "Ruhusu wanafunzi kurudia jaribio hili",
"Grading and Feedback" => "Kujiunga na Maoni",
"Grading method " => "Njia ya kusonga",
"Show students their score " => "onyesha wanafunzi alama zao",
// "Show students the correct answers" => "Show students the correct answers",
"Publish statistics " => "Chapisha takwimu ",
"Extra Options" => "Chaguo za ziada",
"Solicit additional questions from students" => "Pendekeza maswali ya ziada kutoka kwa wanafunzi",
"Link quiz to forum named: " => "Weka jaribio kwenye jukwaa lililoitwa:",
"Prologue" => "Prologue",
"Epilogue" => "Epilogue",
"Quiz result stats" => "Takwimu za matokeo ya matokeo",
"User answers" => "Majibu ya mtumiaji",
"Stats for quizzes" => "Takwimu za maswali",
"taken" => "kuchukuliwa",
"Av score" => "Wastani wa alama",
"Av time" => "Wakati wa wastani",
"Stats for quiz" => "Takwimu za jaribio",
"Clear Stats" => "Futa Stats",
"time taken" => "muda ulichukuliwa",
// "Pass/Fail" => "Pass/Fail",
"Passed" => "Imepita",
"Stats for this quiz Questions " => "Takwimu za Maswali haya",
"Top 10" => "Juu ya 10",
"Top 20" => "Juu ya 20",
"Top 50" => "Juu ya 50",
"Top 100" => "Juu ya 100",
"Rank" => "Kiwango",
"Not Published" => "Haijachapishwa",
"This article is currently unpublished and visible only to editors." => "Makala hii haifai kuchapishwa na inaonekana tu kwa wahariri.",
"Received articles" => "Vipokezo vipokea",
"Topic image" => "Picha ya sura",
"Edit received article" => "Badilisha makala iliyopokea",
"Image x size" => "Ukubwa wa picha ya x",
"Image y size" => "Ukubwa wa picha ya y",
"Image name" => "Jina la picha",
"Publishing date" => "Tarehe ya kuchapisha",
"Accept Article" => "Pata Makala",
"Received Pages" => "Kurasa zilizopokea",
"Edit Received Page" => "Badilisha Ukurasa uliopokea",
"The highlight pages already exist." => "Kurasa za kurasa zilizo tayari zipo.",
"Please, change the name if you want the page to be uploaded." => "Tafadhali, tengeneza jina ikiwa unataka ukurasa upakishwe.",
"Received Structures" => "Miundo iliyopokea",
// "Prefix the checked: " => "Prefix the checked: ",
// " Postfix the checked: " => " Postfix the checked: ",
// "References" => "References",
// "Add a new library reference" => "Add a new library reference",
// "Edit reference settings" => "Edit reference settings",
// "Reference usage" => "Reference usage",
// "Delete reference" => "Delete reference",
// "Edit reference" => "Edit reference",
// "If you change the value of Biblio Code, you might loose the link between references" => "If you change the value of Biblio Code, you might loose the link between references",
// "Pages using reference %0" => "Pages using reference %0",
"Referer stats" => "Referer Takwimu",
"Register as a new user" => "Jisajili kama mtumiaji mpya",
"Tiki site registered" => "Tiki tovuti iliyosajiliwa",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Tovuti iliyofuata iliongezwa na kuthibitishwa na admin inaweza kuhitajika kabla ya kuonekana kwenye orodha",
"You don't have permission to use this feature." => "Huna idhini ya kutumia kipengele hiki.",
"Please register." => "Tafadhali kujiandikisha.",
"Register this site at Tiki.org" => "Jisajili tovuti hii kwenye Tiki.org",
"Read this first!" => "Soma hii kwanza!",
"On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "Kwenye ukurasa huu unaweza kufanya tovuti yako ya tiki inayojulikana kwa Tiki.org. Itaonekana kuonyeshwa pale kwenye orodha ya maeneo ya tiki inayojulikana",
"Registering is voluntary." => "Kujiandikisha ni kwa hiari.",
"Registering does not give you any benefits except one more link to your site." => "Kuandikisha hakukupa faida yoyote isipokuwa kiungo kimoja zaidi kwenye tovuti yako.",
"You don't get any emails, we don't sell the data about your site." => "Huna kupata barua pepe yoyote, hatuuza data kuhusu tovuti yako.",
"Registering is just for us to get an overview of Tiki's usage." => "Kuandikisha ni tu kwetu kupata maelezo ya jumla ya matumizi ya Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Ikiwa tovuti yako ni ya kibinafsi au ndani ya intranet yako, unapaswa kujiandikisha!",
"tiki.org" => "tiki.org",
"Information about your site" => "Maelezo kuhusu tovuti yako",
"Enter your username or email." => "Ingiza jina lako la mtumiaji au barua pepe.",
"Enter your email" => "Ingiza barua pepe yako",
// "Request Password Reset" => "Request Password Reset",
"Rename page" => "Badilisha tena ukurasa",
// "Redirect original page" => "Redirect original page",
// "301 Redirect - \\\"moved permanently\\\" HTTP response status code" => "301 Redirect - \\\"moved permanently\\\" HTTP response status code",
// "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)" => "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)",
"Roll back page %0 to version %1" => "Weka ukurasa wa nyuma% 0 hadi toleo% 1",
// "Describe the reason for roll back" => "Describe the reason for roll back",
// "Enter some text to describe the reason for rolling back" => "Enter some text to describe the reason for rolling back",
"This feature currently searches and replaces within wiki pages only" => "Kipengele hiki sasa kinatafuta na kinaingia ndani ya kurasa za wiki tu",
"Case sensitive:" => "Kesi nyeti:",
"Replace:" => "Badilisha:",
"Max number of pages at a time:" => "Idadi kubwa ya kurasa kwa wakati:",
"Number of surrounding chars to preview:" => "Idadi ya viti vinavyozunguka kwa hakikisho:",
"Replace selected" => "Badilisha nafasi iliyochaguliwa",
"Searched" => "Imetafutwa",
// "Search Query" => "Search Query",
"Search in" => "Tafuta ndani",
"Date Search" => "Utafutaji wa tarehe",
"All dates" => "Tarehe zote",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
"Calendar Items" => "Vipengele vya kalenda",
"{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}\"" => "{\$where_label|escape}\"",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
"Simple search" => "Utafutaji rahisi",
"No pages matched the search criteria" => "Hakuna kurasa zinazofanana na vigezo vya utafutaji",
"You can also send newsletters using an external client" => "Unaweza pia kutuma majarida kwa kutumia mteja wa nje",
"This newsletter will be sent to {\$subscribers} email addresses." => "Cette lettre d'informations va être envoyée à {\$subscribers} adresses électroniques.",
// "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds" => "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds",
"Reply to" => "Jibu kwa",
// "Send from" => "Send from",
"Recipients" => "Wapokeaji",
"Validated" => "Imethibitishwa",
"Is user" => "Ni mtumiaji",
"Sending Newsletter" => "Kutuma jarida",
// "sending to {\$subscribers} addresses" => "sending to {\$subscribers} addresses",
// "with the 'Reply To' email set to: {\$replyto}" => "with the 'Reply To' email set to: {\$replyto}",
// "with the 'Send From' email set to: {\$sendfrom}" => "with the 'Send From' email set to: {\$sendfrom}",
"Prepare a newsletter to be sent" => "Panga jarida kutumwa",
"Admin templates" => "Majarida ya Admin",
"Data HTML" => "HTML Data",
"Must be wiki parsed" => "Inapaswa kuwa wiki ikitenganishwa",
// "Wiki Parsed" => "Wiki Parsed",
// "Is HTML" => "Is HTML",
"Data Txt" => "Txt Data",
"Article Clip (read only):" => "Kipande cha Makala (kusoma tu):",
"Clip Now" => "Kipengee Sasa",
"Clip Articles" => "Makala ya Vipande",
"To include the article clipping into your newsletter, cut and paste it into the contents." => "Pour inclure un extrait d'article dans votre lettre de nouvelles, couper le et coller le dans les contenus.",
"If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending." => "Si l'auto-extraction est activée, vous poyvez aussi entrer \"~~~articleclip~~~\" qui sera remplacé par le dernier extrait au moment de l'envoi.",
"Be careful not to paste articles that must not be seen by the recipients" => "Attention de ne pas coller un article qui ne doit pas être vu par les destinataires",
"Attached Files" => "Faili zilizounganishwa",
"remove" => "ondoa",
"octets" => "octets",
"To add a file, click here" => "Ili kuongeza faili, bofya hapa",
"Reply To Email" => "Jibu Kwa Barua pepe",
"if not" => "ikiwa sio",
"Sender email not set" => "Sender barua pepe haijawekwa",
// "Send From Email" => "Send From Email",
"Preview your changes." => "Angalia mabadiliko yako.",
"Save as Draft" => "Hifadhi kama Rasimu",
"Save your changes" => "Enregister vos modifications",
"Save any changes and send to all subscribers" => "Hifadhi mabadiliko na utumie kwa wanachama wote",
// "Drafts (%0)" => "Drafts (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "Tuma vitu",
"Transmission results" => "Uhamisho wa matokeo",
"Send Wiki Pages" => "Tuma Kurasa za Wiki",
"Send a structure" => "Tuma muundo",
"Send Articles" => "Tuma makala",
"Add Article" => "Ongeza makala",
"Send objects to this site" => "Tuma vitu kwenye tovuti hii",
"Ex: http://tiki.org or localhost" => "Mfano: http://tiki.org au localhost",
"Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Tumia /commxmlrpc.php ikiwa tovuti yako ni mizizi, vinginevyo ukebishe / tiki kwa mahitaji yako",
// "Report this page" => "Report this page",
"Page shared" => "Ukurasa ulioshirikiwa",
// "The link was sent via email to the following addresses" => "The link was sent via email to the following addresses",
"The link was sent via Twitter" => "Kiungo kilipelekwa kupitia Twitter",
"The link was posted on your Facebook wall" => "Kiungo kimechapishwa kwenye ukuta wako wa Facebook",
"The link was sent as message to" => "Kiungo kilipelekwa kama ujumbe",
"The link was published in a" => "Kiungo kimechapishwa katika",
"Have a look at this page" => "Angalia ukurasa huu",
// "Access rights are granted for the page" => "Access rights are granted for the page",
"Short link" => "Kiungo fupi",
// "Send email" => "Send email",
"Recipient(s)" => "mpokeaji",
"Separate multiple email addresses with a comma and a space" => "Tofauti barua pepe nyingi na comma na nafasi",
"Separate multiple email addresses with a comma." => "Séparer les adresses email par des virgules.",
"Your name" => "Jina lako",
// "Recipients can subscribe to token notifications" => "Recipients can subscribe to token notifications",
// "Token Access Limit" => "Token Access Limit",
// "How many times recipients can access this page" => "How many times recipients can access this page",
"Tweet via Twitter" => "Tweet via Twitter",
"Authorize with Twitter first" => "Ruhusu kufikia Twitter kwanza",
"Have a look at " => "Angalia",
"Put on my Facebook wall" => "Weka kwenye ukuta wangu wa Facebook",
"Authorize with Facebook first" => "Ruhusu upatikanaji wa Facebook kwanza",
"Link text" => "Unganisha maandishi",
"This will be the title for the URL" => "Hii itakuwa jina la URL",
// "Like this post" => "Like this post",
"You do not have the permission to send messages or you did not allow other users to send you messages" => "Huna haki za kutuma ujumbe au haukuruhusu watumiaji wengine kutuma ujumbe",
// "User(s)" => "User(s)",
"Separate multiple recipients with a semicolon" => "Toa wapokeaji wengi na semicoloni",
"Post on forum" => "Chapisha kwenye jukwaa",
"There is no forum where you can post a message" => "Hakuna mkutano ambapo unaweza kutuma ujumbe",
"password-protected" => "Neno la Ulinzi limehifadhiwa",
"Share access rights" => "Shiriki haki za upatikanaji",
"Return to previous page" => "Rudi kwenye ukurasa uliopita",
// "Create sheet" => "Create sheet",
// "Configure sheet" => "Configure sheet",
"There are individual permissions set for this sheet" => "Haki za upatikanaji wa kibinafsi zimewekwa kwenye kipeperushi hiki",
"Class Name" => "Jina la darasa",
"Header Rows" => "Safu za kichwa",
"Footer Rows" => "Safu za chini",
"Wiki Parse Values" => "Uchambuzi wa Wiki wa Maadili",
"Parent Spreadsheet" => "Jani la wazazi",
"Makes this sheet a \"child\" sheet of a multi-sheet set" => "Imefanywa na lahajedwali hili karatasi ya \"mtoto \" ya kuweka karatasi mbalimbali",
"You can access the sheet using the following URL" => "Unaweza kufikia kipeperushi hiki kwa anwani ya wavuti iliyofuata",
"Banned Words" => "Maneno yaliyotengwa",
"Change shoutbox general settings" => "Badilisha mabadiliko ya jumla ya megaphone",
"auto-link urls" => "kutambua URL moja kwa moja",
"Post or edit a message" => "Publier ou modifier un message",
"Location : " => "Position : ",
"Content may be out of date" => "Maudhui inaweza kuwa nje ya tarehe",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "Ombi la haraka la tafsiri limepelekwa. Mpaka ukurasa huu utasasishwa, unaweza kuona toleo la usahihi kwenye kurasa zifuatazo",
// "Update from it" => "Update from it",
"page: %0/%1" => "page : %0/%1",
"This text was automatically translated by Google Translate from the following page: " => "Nakala hii imetafsiriwa kwa moja kwa moja na Tafsiri ya Google kutoka ukurasa uliofuata: ",
// "Rate this page" => "Rate this page",
"Last edited by" => "Ilibadilishwa mwisho na",
"based on work by" => "Kulingana na kazi ya",
"Contributors to this page" => "Mshiriki (s) wa ukurasa huu",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
"Twitter authorisation" => "Uidhinishaji wa Twitter",
"to manage your authorisations at Twitter" => "kusimamia ruhusa zako za Twitter",
"this site with twitter.com to use Twitter integration of this site" => "Tovuti hii na twitter.com kutumia ushirikiano wa Twitter wa tovuti hii",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
"Facebook authorisation" => "Uidhinishaji wa Facebook",
// "to manage your authorizations at Facebook" => "to manage your authorizations at Facebook",
// "this site within facebook.com to use Facebook integration with this site" => "this site within facebook.com to use Facebook integration with this site",
// "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first" => "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first",
// "LinkedIn authorisation" => "LinkedIn authorisation",
// "this site to link your user to your LinkedIn account" => "this site to link your user to your LinkedIn account",
"The site admin has set up a global account which will be used for this site" => "Msimamizi wa tovuti ameelezea akaunti ya kimataifa ambayo itatumiwa kwenye tovuti hii",
"bit.ly Login" => "login bit.ly",
"bit.ly Key" => "ufunguo bit.ly",
"Save changes" => "Hifadhi mabadiliko",
"You will be redirected to the home page shortly" => "Utakuwa umeelekezwa kwenye ukurasa wa mwanzo hivi karibuni",
"to go to the home page immediately" => "kwenda kwenye ukurasa wa nyumbani mara moja",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site" => "Do you already have a local account for this site",
// "Login to link to it using the following form instead" => "Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
"You will not see the latest queries" => "Huwezi kuona maswali ya hivi karibuni",
"Query" => "ombi",
"Params" => "mazingira",
"Most viewed objects" => "Vitu vingi vinavyoonekana",
"Most viewed objects in the last 7 days" => "Vitu vingi vinavyotazamwa katika siku 7 zilizopita",
"Site Stats" => "Takwimu za tovuti",
"Date of first pageview" => "Tarehe ya kutazama kwanza ya ukurasa",
"Days since first pageview" => "Siku tangu kwanza kutazama ukurasa",
"Total pageviews" => "Jumla ya maoni ya ukurasa",
"Average pageviews per day" => "Wastani idadi ya maoni ya ukurasa kwa siku",
"Wiki Stats" => "Takwimu za Wiki",
"Size of Wiki Pages" => "Jumla ya ukubwa wa kurasa za Wiki",
"Average page length" => "Ukubwa wa wastani wa ukurasa",
"Average versions per page" => "Idadi ya ziara za kurasa za Wiki",
"Visits to wiki pages" => "Idadi ya ziara za kurasa za Wiki",
"Average links per page" => "Wastani wa viungo kwa kila ukurasa",
"Image galleries Stats" => "Takwimu kwenye nyumba za picha",
"Average images per gallery" => "Wastani wa idadi ya picha kwa kila nyumba ya sanaa",
"Total size of images" => "Jumla ya ukubwa wa picha",
"Average image size" => "Ukubwa wa wastani wa picha",
"Visits to image galleries" => "Idadi ya ziara ya nyumba za picha",
"File galleries Stats" => "Takwimu kwenye nyumba za faili",
"Average files per gallery" => "Wastani wa idadi ya faili kwa kila nyumba ya sanaa",
"Total size of files" => "Jumla ya faili ya faili",
"Average file size" => "Ukubwa wa wastani wa faili",
"Visits to file galleries" => "Idadi ya ziara kwenye nyumba za faili",
"Articles Stats" => "Hatua za Makala",
"Total reads" => "Jumla ya usomaji",
"Average reads per article" => "Wastani idadi ya masomo kwa kila makala",
"Total articles size" => "Jumla ya ukubwa wa makala",
"Average article size" => "Wastani wa ukubwa wa makala",
"Forum Stats" => "Takwimu kwenye vikao",
"Total topics" => "Jumla ya masomo",
"Average topics per forums" => "Wastani idadi ya mada kwa kila jukwaa",
"Total replies" => "Idadi ya majibu",
"Average number of replies per topic" => "Wastani idadi ya majibu kwa kila somo",
"Visits to forums" => "Ziara ya vikao",
"Blog Stats" => "Takwimu za blogi",
"Weblogs" => "blogs",
"Total posts" => "Jumla ya vitu",
"Average posts per weblog" => "Wastani wa makala na blogu",
"Total size of blog posts" => "Jumla ya ukubwa wa machapisho ya blogu",
"Average posts size" => "Wastani wa ukubwa wa makala",
"Visits to weblogs" => "Ziara za blogu",
"Poll Stats" => "Takwimu za uchaguzi",
"Total votes" => "Jumla ya kura",
"Average votes per poll" => "Wastani wa kura ya kura kwa kila uchaguzi",
"FAQ Stats" => "Takwimu za Maswali",
"Total questions" => "Idadi ya maswali",
"Average questions per FAQ" => "Wastani idadi ya maswali kwa Maswali",
"User Stats" => "Takwimu za mtumiaji",
"Average bookmarks per user" => "Wastani wa alama ya alama kwa mtumiaji",
"Average questions per quiz" => "Wastani idadi ya maswali kwa maswali mengi ya kuchagua",
"Quizzes taken" => "Quizzes kuchukuliwa",
"Average quiz score" => "Wastani alama za MCQ",
"Average time per quiz" => "Wastani wa muda wa kukamilisha chaguo nyingi",
"Most viewed objects in period" => "Vitu vinavyoonekana zaidi wakati huo",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "Matumizi ya grafu",
"Usage chart image" => "Image du graphe d'utilisation",
"Daily Usage" => "Matumizi ya kila siku",
// "Piwik Analytics Dashboard" => "Piwik Analytics Dashboard",
// "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard" => "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard",
"Stats for surveys" => "Takwimu za Utafiti",
"Last taken" => "Jibu la mwisho",
"Stats for survey" => "Takwimu za Utafiti",
// "Select a user to preview its answer (marked as" => "Select a user to preview its answer (marked as",
// "User voted" => "User voted",
// "Select User" => "Select User",
// "no answer" => "no answer",
"Tiki Logs" => "Logi ya mfumo",
"Export through Action Log" => "Tuma nje kupitia magogo ya vitendo",
"Clean logs older than" => "Fungua viingilio vya logi zaidi kuliko",
// "Are you sure you want to revert" => "Are you sure you want to revert",
// "Revert" => "Revert",
"Time Left" => "Muda uliobaki",
"Send Answers" => "Tuma majibu",
"Thank you for your submission" => "Asante kwa kuwasilisha kwako",
"Send a link to a friend" => "Tuma kiungo hiki kwa rafiki",
"Your email was sent" => "Barua yako imepelekwa",
"The link was sent to the following addresses" => "Kiungo kimetumwa kwa anwani hizi",
"Friend's email" => "Anwani ya barua pepe ya rafiki yako",
"Your comment" => "Maoni yako",
"I found an interesting page that I thought you would like." => "Nimepata ukurasa huu ambao unaweza kukuvutia.",
"TikiTests Edit" => "Badilisha TikiTests",
"Summary mode" => "Muhtasari wa mode",
"Show Page Differences" => "Onyesha tofauti kwenye ukurasa",
"Show Tidy Errors and Warnings" => "Angalia Makosa Tidy na Tahadhari",
"Show POST Data" => "Angalia data ya POST",
"Use Current Session/Log out" => "Tumia Kipindi cha sasa / kuacha",
"Recorded Links" => "Viungo vilivyohifadhiwa",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
"Tidy Results" => "Matokeo ya Tidy",
"Delete this link" => "Futa kiungo hiki",
"TikiTests List" => "Orodha ya TikiTests",
"Config" => "usanidi",
"Replay" => "mechi ya marudiano",
"Tidy extension not present" => "Ugani wa Tidy hauwasilisha",
"PECL HTTP extension present" => "Ugani wa PECL wa HTTP",
"cURL extension present" => "Zawadi za cURL za upanuzi",
"PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "Upanuzi wa PECL HTTP na cURL hazipo. Haiwezekani kurejesha TikiTest",
"List TikiTests" => "Orodha ya TikiTests",
"Create a TikiTest" => "Unda TikiTest",
"Replay the TikiTest" => "Rejesha TikiTest",
"Edit the TikiTest" => "Badilisha TikiTest",
"TikiTests Record Configuration" => "Inasanidi usajili wa TikiTests",
"Start Recording Test" => "Anza kurekodi mtihani",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
"Failure" => "kushindwa",
"Reference" => "kumbukumbu",
"The pages are different" => "Kurasa hizi ni tofauti",
"The pages are identical" => "Kurasa hizi zinafanana",
"Recording to pause press the pause button" => "Rekodi, pumzika waandishi wa habari kifungo cha pause",
"Pause the recording" => "Pumzika kurekodi",
"Paused to resume press the play button" => "Pumzika, uendelee kubonyeza kifungo cha kucheza",
"Resume the recording" => "Rejesha kurekodi",
"Stop the recording" => "Acha kurekodi",
"Control by Objects" => "Udhibiti wa mandhari / vitu",
"Control by Sections" => "Udhibiti wa mandhari / sehemu",
"Assign themes to categories" => "Weka mandhari kwenye kikundi",
"Assigned categories" => "Jamii na mandhari",
// "Delete selected" => "Delete selected",
"Control by Categories" => "Udhibiti wa mandhari / makundi",
"Assign themes to objects" => "Weka mandhari kwa kitu",
"Assigned objects" => "Vitu vinavyo na mandhari",
"Assign themes to sections" => "Weka mandhari kwenye sehemu",
"Assigned sections" => "Sehemu na mandhari",
// "Timesheets" => "Timesheets",
"Apply the following profile for enhancements: " => "Tumia maelezo yafuatayo kwa uboreshaji: ",
"Time Tracker" => "Fomu ya muda",
// "Local Cache (Not Committed)" => "Local Cache (Not Committed)",
// "Saved (Committed)" => "Saved (Committed)",
"New task" => "Kazi mpya",
// "Toggle completed" => "Toggle completed",
// "Toggle archived" => "Toggle archived",
// "Task name" => "Task name",
// "Estimate (in min.)" => "Estimate (in min.)",
// "Estimate" => "Estimate",
// "Task is completed" => "Task is completed",
// "Task is archived" => "Task is archived",
// "Created at" => "Created at",
// "Are you sure you want to delete all tasks" => "Are you sure you want to delete all tasks",
// "Commit Time Sheet Items" => "Commit Time Sheet Items",
// "View All" => "View All",
// "View My Items" => "View My Items",
"Summary" => "muhtasari",
// "Time Spent" => "Time Spent",
// "Done By" => "Done By",
"Add Tracker" => "Ongeza fomu",
"Add Tracker To Tracker Report" => "Ongeza fomu kwa ripoti ya fomu",
// "View Tracker Report" => "View Tracker Report",
// "Pick tracker to join" => "Pick tracker to join",
// "Pick fields to join on" => "Pick fields to join on",
// "Join inner" => "Join inner",
// "Join outer" => "Join outer",
// "Tracker - Open" => "Tracker - Open",
// "Tracker - Pending" => "Tracker - Pending",
// "Tracker - Closed" => "Tracker - Closed",
"Tracker Item History" => "Historia ya rekodi ya fomu",
"View Tracker Item" => "Tazama fomu ya fomu",
// "Not logging" => "Not logging",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable",
"Edit File" => "Badilisha faili",
"Advanced mode" => "Hali ya juu",
"Simple mode" => "Njia rahisi",
"Retry" => "Jaribu tena",
"Additional Info" => "Maelezo ya ziada",
// "Syntax Tips" => "Syntax Tips",
// "Download link using Tiki syntax" => "Download link using Tiki syntax",
// "Display an image using Tiki syntax" => "Display an image using Tiki syntax",
// "Use as a thumbnail with ShadowBox" => "Use as a thumbnail with ShadowBox",
// "Download link using HTML" => "Download link using HTML",
"You locked the file" => "Umefunga faili",
"The file has been locked by {\$fileInfo.lockedby}" => "Faili imefungwa na {\\ \$ fileInfo.lockedby}",
"File title" => "Jina la faili",
"required field for podcasts" => "shamba la lazima kwa podcasts",
"File description" => "maelezo",
// "Re-upload from disk" => "Re-upload from disk",
// "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>" => "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>",
// "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
"Unzip zip files" => "Fungua faili za zip",
"File can be deleted after" => "Faili inaweza kufutwa baada",
// "OCR files if supported" => "OCR files if supported",
"Creator of file, if different from the 'Uploaded by' user" => "Muumba wa faili, ikiwa ni tofauti na mtumiaji aliyeihifadhi",
// "File Type" => "File Type",
// "No type" => "No type",
"Maximum number of downloads" => "Upeo wa idadi ya downloads",
"-1 for no limit" => "-1 kwa ukomo",
"Upload File(s)" => "Tuma faili",
"Add Another File" => "Ongeza faili nyingine",
"Maximum file size is around:" => "Upeo wa ukubwa wa faili ni:",
// "Note: You are running IIS" => "Note: You are running IIS",
// "maxAllowedContentLength also limits upload size" => "maxAllowedContentLength also limits upload size",
// "Please check web.config in the Tiki root folder" => "Please check web.config in the Tiki root folder",
"Uploading file..." => "Inatuma faili...",
"No File to Upload..." => "Hakuna faili kutuma...",
// "Keeps a reference to the remote file" => "Keeps a reference to the remote file",
// "Video file uploaded" => "Video file uploaded",
"Link to file from a Wiki page" => "Lien vers le fichier à partir d'une page Wiki",
// "For image files" => "For image files",
// "Display full size" => "Display full size",
"Display thumbnail that enlarges" => "Maonyesho ya thumbnail ambayo huongeza",
"Batch Upload Results" => "Matokeo ya Batch",
"Upload successful!" => "Kutuma kwa mafanikio!",
"The following image was successfully uploaded" => "Picha iliyofuata imetumwa kwa ufanisi",
"Image ID thumb" => "Vignette ya picha",
"You can view this image in your browser using" => "Unaweza kuona ukurasa huu katika kivinjari chako ukitumia",
"You can include the image in an Wiki page using" => "Unaweza kuingiza picha hii kwenye ukurasa wa wiki ukitumia",
"or use filename" => "au kutumia jina la faili",
"Now enter the image URL" => "Ingiza anwani ya wavuti sasa",
"or upload a local image from your disk" => "au tuma picha kutoka kwenye diski yako",
"Batch Upload" => "Usafirishaji wa Batch",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Picha ndogo (hiari, cancel na nafasi kizazi moja kwa moja ya vidole)",
"No gallery available" => "Hakuna nyumba zilizopo",
"You have to create a gallery first!" => "Kwanza, tengeneza nyumba ya sanaa !",
"User assigned modules" => "Moduli za mtumiaji",
// "to assign modules, which will make them available for creating a custom order on this page" => "to assign modules, which will make them available for creating a custom order on this page",
"Restore defaults" => "Rudisha desfaults",
"The column is disabled" => "Safu imefungwa",
"#" => "N°",
"Move module up" => "Reassemble moduli",
"Move module down" => "Ondoa moduli",
// "Move to right side" => "Move to right side",
// "Move to left side" => "Move to left side",
"Assign module" => "Weka moduli",
"top" => "juu",
"Current folder" => "Sura ya sasa",
"Folders" => "Saraka",
"Folder in" => "Nenda kwenye saraka",
// "Refresh cache" => "Refresh cache",
"Admin folders and bookmarks" => "Dhibiti nyaraka na alama",
"a folder" => "saraka",
"a bookmark" => "alama",
"User Contacts Preferences" => "Mapendeleo juu ya anwani zangu",
"Change preferences" => "Badilisha mapendekezo",
"Manage Fields" => "Dhibiti mashamba",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{\$chdata.name}" => "{\$chdata.name}",
"Send me a message" => "Nitumie ujumbe",
"Basic Data" => "Data ya msingi",
// "Assign group" => "Assign group",
"Assign Group" => "Mettre dans un groupe",
"User Icon" => "Picha ya mtumiaji",
// "{\$gender}" => "{\$gender}",
"(non public)" => "(non public)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
"Language:" => "Lugha :",
"User's homepage" => "Ukurasa wa nyumbani wa mtumiaji",
"Score:" => "Mfumo wa tathmini :",
"Personal Wiki Page" => "Ukurasa wa wiki ya kibinafsi",
"Last login:" => "Kuingia kwa mwisho:",
// "Your relationship with other users" => "Your relationship with other users",
// "Relationship of this user to you" => "Relationship of this user to you",
"The user has chosen to make his information private" => "Mtumiaji amechagua kufanya maelezo yake binafsi",
"Additional Information" => "Taarifa za ziada",
// "Change user information" => "Change user information",
"User Contribution" => "Uchangiaji wa Mtumiaji",
"has contributed to the following content" => "imechangia maudhui yaliyofuata",
"has not contributed to any content yet" => "haijachangia maudhui yoyote bado",
// "Blogs Posts" => "Blogs Posts",
"Forum comments" => "Maoni ya Vikao",
"Forum topics" => "Masuala ya Vikao",
"Who Looks at Items" => "Ambao anaangalia biashara",
"Who Looks at Your Items" => "Ni nani anayeangalia mambo yako",
"Who Looks at His or Her Items" => "Ambao anaangalia biashara yake",
"Send Me A Message" => "Nitumie ujumbe",
"Send me a message !" => "Nitumie ujumbe!...",
"The following message will be sent to user" => "Ujumbe ufuatayo utatumwa kwa mtumiaji",
"Message Body" => "Mwili wa ujumbe",
// "My Mail-in" => "My Mail-in",
// "Are you sure you want to delete the routing rule" => "Are you sure you want to delete the routing rule",
// "Configure how your mailed-in wiki pages are to be linked / organized" => "Configure how your mailed-in wiki pages are to be linked / organized",
// "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked" => "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked",
// "Only newly created pages, using the mail-in wiki-put function, are affected" => "Only newly created pages, using the mail-in wiki-put function, are affected",
// "Go to wiki structure setting" => "Go to wiki structure setting",
"Toggle options" => "Onyesha / kujificha submenus",
"Male" => "mtu",
"Female" => "mwanamke",
// "Your Personal Wiki Page" => "Your Personal Wiki Page",
"User's personal tracker information" => "Maelezo juu ya fomu ya mtumiaji binafsi",
"View extra information" => "Tazama maelezo ya ziada",
"Your personal tracker information" => "Fomu yako ya habari ya kibinafsi",
// "Is email public" => "Is email public",
"Unavailable - please set your email below" => "Haipatikani - tafadhali fungua anwani yako ya barua pepe hapa chini",
// "Preferred perspective" => "Preferred perspective",
// "Email character set" => "Email character set",
// "Admin Language" => "Admin Language",
"Can you read more languages?" => "Unaweza kusoma lugha zaidi?",
// "Other languages you can read" => "Other languages you can read",
"Select language..." => "Chagua lugha...",
// "Select from the dropdown to add automatically to the list below" => "Select from the dropdown to add automatically to the list below",
// "Displayed timezone" => "Displayed timezone",
"Detect user time zone if browser allows, otherwise site default" => "Tambua eneo la wakati wa mtumiaji (kama kivinjari inaruhusu). Vinginevyo, tumia eneo la wakati wa default",
// "Site time zone <strong>%0</strong> is enforced and overrides user preferences" => "Site time zone <strong>%0</strong> is enforced and overrides user preferences",
"Use 12-hour clock in time selectors" => "Tumia muundo wa saa 12 wakati wa kuchagua",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Wakati unapopiga panya, onyesha maelezo ya mtumiaji kwa wale wanaofafanuliwa kuwa ya umma",
"User Messages" => "Ujumbe wa mtumiaji",
"Notify sender when reading his mail" => "Mjulishe mtumaji wakati ujumbe wake unasoma",
// "Message priority notification" => "Message priority notification",
// "Read message auto-archiving" => "Read message auto-archiving",
"never" => "milele",
// "Auto-archive read messages after selected days" => "Auto-archive read messages after selected days",
"User Tasks" => "Kazi ya mtumiaji",
// "XMPP account JID" => "XMPP account JID",
// "If empty, Tiki will provide default value" => "If empty, Tiki will provide default value",
// "You have to provide this when using custom XMPP server" => "You have to provide this when using custom XMPP server",
"My user items" => "Kadi zangu",
// "My articles" => "My articles",
"My level" => "Ngazi yangu",
// "Remember which remarksbox (alert box) you have closed and don't show them again" => "Remember which remarksbox (alert box) you have closed and don't show them again",
"Reset remark boxes visibility" => "Weka upya uonekano wa masanduku ya kumbuka",
// "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed" => "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed",
"Account Information" => "Maelezo ya Akaunti",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Acha mashamba \"Neno la siri \" na \"Hakikisha nenosiri mpya \" tupu ili kuweka nenosiri la sasa",
"Current password (required)" => "Neno la sasa (inahitajika)",
"Account Deletion" => "Kufuta akaunti",
"Are you really sure you want to delete the account %0" => "Una uhakika unataka kufuta akaunti %0",
"Check this box if you really want to delete the account" => "Angalia sanduku hili ikiwa unataka kufuta akaunti hii",
"Delete the account" => "Futa akaunti",
"Delete my account" => "Futa akaunti yangu",
"Task list" => "Orodha ya kazi",
"Admin mode off" => "Hali ya admin isiyoweza",
"Admin mode on" => "Hali ya admin ya kazi",
"Task help" => "Msaada (Kazi)",
"Empty Trash" => "Weka takataka",
"Task received" => "Kazi imepokea",
"You received this task" => "Umepokea kazi hii",
"Task sent" => "Kazi imetumwa",
"You sent this task to another user" => "Ulituma kazi hii kwa mtumiaji mwingine",
"Task shared by a group" => "Kazi iliyoshirikiwa na kikundi",
"Task is shared by a group" => "Kazi hiyo inashirikiwa na kundi",
"Accepted by task user and creator" => "Imekubaliwa na mtumiaji wa kazi na muumbaji",
"Task has been accepted by user and creator" => "Kazi ilikubaliwa na mtumiaji na muumbaji",
"Rejected by a user" => "Imekataliwa na mtumiaji",
"Task has been rejected by a user" => "Kazi ilikataliwa na mtumiaji",
"Waiting for me" => "Kusubiri kwangu",
"Task has not yet been accepted or rejected by you" => "Kazi bado haikubaliwa au kukataliwa na wewe",
"Waiting for other user" => "Inasubiri mtumiaji mwingine",
"Task has not yet been accepted or rejected by another user" => "Kazi bado haikubaliwa au kukataliwa na mtumiaji mwingine",
"Admin Mode" => "Mfumo wa Utawala",
"Edit Task" => "Badilisha kazi",
"NOT accept" => "kukataa",
"Remove from Trash" => "Ondoa kwenye takataka",
"Move to trash" => "Weka kwenye takataka",
"Move to Trash" => "Weka kwenye takataka",
"Task saved" => "Kazi iliyohifadhiwa",
"View Task" => "Angalia kazi",
"Open a new task" => "Fungua kazi mpya",
"Last Version" => "Toleo la hivi karibuni",
"taskId" => "taskId",
"Task user" => "Mtumiaji wa Task",
"Only the creator can delete this task" => "Muumba wake pekee anaweza kufuta kazi hii",
"Use start date and time" => "Tumia tarehe na wakati wa kuondoka",
"Use end date and time" => "Tumia tarehe ya mwisho na wakati",
"Open / In Process" => "Fungua / Inayoendelea",
"Waiting / Not Started" => "Inasubiri / haijaanza",
"Percentage completed" => "Asilimia imepata",
"Waiting" => "Kusubiri",
"Shared for Group" => "Iligawanywa na kikundi",
"Accepted by User" => "Imekubaliwa na mtumiaji",
"No / Rejected" => "Hapana / kukataliwa",
"Accepted by Creator" => "Imekubaliwa na Muumba",
"This message will be send to users if you are makeing changes of assigned tasks" => "Ujumbe huu utatumwa kwa watumiaji ikiwa unafanya mabadiliko kwenye kazi zilizopewa",
"Send a message with changes" => "Tuma ujumbe na mabadiliko",
"Modified by" => "Ilibadilishwa na",
"Marked as deleted" => "Imeonekana kama imefutwa",
"Inform task user by email" => "Mjulishe mtumiaji wa kazi kwa barua pepe",
"Reload" => "Pakia tena",
"You can only view this task" => "Unaweza kuona tu kazi hii",
"In the trash" => "Katika takataka",
"Not Accepted by One User" => "Haikubaliki na mtumiaji",
"Not Accepted User" => "Haikubaliki na mtumiaji",
"No tasks entered" => "Hakuna kazi iliyoingia",
"Select One" => "Chagua kutoka",
"Trash" => "kikapu",
"Undo Trash" => "Tengeneza Trash",
"Received" => "kupokea",
"Submitted" => "somo",
"Shared" => "pamoja",
"All Shared Tasks" => "Kazi zote zilizoshirikiwa",
// "Previous version" => "Previous version",
// "Next version" => "Next version",
"completed (100%)" => "kumaliza(100%)",
"Public for group" => "Umma kwa kikundi",
// "Wikis" => "Wikis",
// "Forum Threads" => "Forum Threads",
// "{\$userinfo['user_country']|stringfix}" => "{\$userinfo['user_country']|stringfix}",
// "{\$userinfo['user_gender']}" => "{\$userinfo['user_gender']}",
// "This user has contributed to the following wiki pages" => "This user has contributed to the following wiki pages",
// "This user has not contributed to any wiki pages yet" => "This user has not contributed to any wiki pages yet",
// "This user has not contributed any blog posts yet" => "This user has not contributed any blog posts yet",
// "This user has contributed to the following tracker items" => "This user has contributed to the following tracker items",
// "This user has not contributed to any tracker items yet" => "This user has not contributed to any tracker items yet",
// "This user has contributed to the following articles" => "This user has contributed to the following articles",
// "This user has not contributed to any articles yet" => "This user has not contributed to any articles yet",
// "This user has started to the following forum threads" => "This user has started to the following forum threads",
// "This user has not contributed to any forums yet" => "This user has not contributed to any forums yet",
// "Add to Network" => "Add to Network",
// "Remove from Network" => "Remove from Network",
"User Watches and preferences" => "Badilisha arifa za mtumiaji na mapendekezo",
"You need to set your email to receive email notifications" => "Lazima usanidi barua pepe yako ili upokea arifa",
"Use reports to summarise notifications about objects you are watching" => "Tumia ripoti kwa muhtasari wa arifa kuhusu vitu unayotambua",
"Use reports" => "Tumia ripoti",
// "Reporting interval" => "Reporting interval",
// "Every minute" => "Every minute",
// "Hourly" => "Hourly",
"Monthly" => "Mensuel",
// "Report length" => "Report length",
"Short report" => "Ripoti ya mkataba",
"Detailed report" => "Ripoti ya kina",
// "Report format" => "Report format",
// "Send report even if no activity" => "Send report even if no activity",
"My watches" => "Saa yangu",
"Use \"watches\" to monitor wiki pages or other objects" => "Tumia \"kuona\" kwa ufuatiliaji kurasa za Wiki na vitu vingine",
// "Watch new items by clicking the {icon name='watch'} button on specific pages" => "Watch new items by clicking the {icon name='watch'} button on specific pages",
"Add Watch" => "Ongeza taarifa",
"Select event type" => "Chagua aina ya tukio",
"All watched events" => "Matukio yote ya kufuatiliwa",
"A user submits a blog post" => "Mtumiaji anawasilisha chapisho kwenye blogu",
"A user posts a forum thread" => "Mtumiaji anaandika fungu kwenye jukwaa",
"A user posts a forum topic" => "Jumuiya mpya ya mada",
"A user edited or commented on a wiki page" => "Mtumiaji amehariri au alitoa maoni kwenye ukurasa wa wiki",
"A user edited a wiki page" => "Mtumiaji amebadilisha ukurasa wa wiki",
"{\$w.type}" => "{\$w.type}",
"Use this form to control notifications about objects you are watching" => "Tumia fomu hii ili kudhibiti arifa kuhusu vitu unayotambua",
"Send notification when I am the editor" => "Tuma arifa wakati mimi ni mhariri",
"Used space" => "Volume kutumika",
"up to" => "juu ya",
"no limit for admin" => "hakuna kikomo kwa msimamizi",
"User Menu" => "Menyu ya mtumiaji",
"May need to refresh twice to see changes" => "Huenda unahitaji kupurudisha mara mbili ili uone mabadiliko",
"Add top level bookmarks to menu" => "Ongeza alama kutoka kwa kiwango cha juu hadi kwenye orodha ya mtumiaji",
"Add or edit an item" => "Ongeza / hariri kipengee",
"New Window" => "Dirisha mpya (n)",
"replace window" => "Badilisha dirisha (w)",
"Delete Selected" => "Futa kuchaguliwa",
// "Pos" => "Pos",
"User_versions_for" => "Matoleo ya",
// "Monitor articles" => "Monitor articles",
// "Stop monitoring articles" => "Stop monitoring articles",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
// "\"}Actions for %0" => "\"}Actions for %0",
"No articles yet" => "Hakuna makala",
// "New article" => "New article",
"Banner stats" => "Takwimu za Banner",
"Create new banner" => "Unda bendera mpya",
"Banner Information" => "Taarifa juu ya bendera",
"Click ratio" => "Uingizaji wa clicks",
"Weekdays" => "Siku za wiki",
"mon" => "mon",
"tue" => "tue",
"wed" => "wed",
"thu" => "thu",
"fri" => "fri",
"sat" => "sat",
"sun" => "sun",
"Banner raw data" => "Maelezo mafupi ya bendera",
"Cached" => "Katika cache",
"This is a cached version of the page." => "Toleo hili la ukurasa ni katika cache.",
"Click here to view the Google cache of the page instead." => "Bofya hapa ili kuona cache ya Google ya ukurasa badala yake.",
// "{\$faq_info.title}" => "{\$faq_info.title}",
"There are no questions in this FAQ." => "Hakuna maswali katika nyumba hii ya sanaa.",
"Answers" => "majibu",
"Add Suggestion" => "Ongeza maoni",
"Edit Forum" => "Badilisha jukwaa hili",
"Forum List" => "Orodha ya vikao",
// "Forum actions" => "Forum actions",
// "Monitor topics" => "Monitor topics",
// "Stop monitoring topics" => "Stop monitoring topics",
// "Monitor topics and threads" => "Monitor topics and threads",
// "Stop monitoring topics and threads" => "Stop monitoring topics and threads",
// "Group monitor topics" => "Group monitor topics",
// "Group monitor topics and threads" => "Group monitor topics and threads",
// "Post New" => "Post New",
// "Deliberation" => "Deliberation",
// "Add Deliberation Item" => "Add Deliberation Item",
"Watch for replies" => "Surveiller les réponses",
"Send me an email when someone replies to my topic" => "M'envoyer un courriel lorsqu'une modification est faite à mon sujet",
"Don't send me any emails" => "Ne pas m'envoyer de courriels",
"Enter your name" => "Saisir votre nom",
"Editing posts" => "Édition des articles",
// "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax" => "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax",
// "Moderator actions on selected topics" => "Moderator actions on selected topics",
"Emot" => "émot",
// "Rating <br/>(avg/max)" => "Rating <br/>(avg/max)",
// "Detailed results <br/>(counts)" => "Detailed results <br/>(counts)",
// "Detailed results <br/>(counts/%)" => "Detailed results <br/>(counts/%)",
"pts" => "pts",
// "Topic locked" => "Topic locked",
// "Forum locked" => "Forum locked",
// "No topics found" => "No topics found",
"posts in this forum" => "articles dans ce forum",
// "Filter Posts" => "Filter Posts",
"Last post date" => "Date du dernier article",
"All posts" => "Tous les articles",
"Last hour" => "De la dernière heure",
"Last 24 hours" => "Des dernières 24h",
"Last 48 hours" => "Des dernières 48h",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "normal",
"announce" => "annonce",
"hot" => "populaire",
"Posts with no replies" => "Articles sans réponses",
"Topic List" => "Liste des sujets",
"The post has been reported and will be reviewed by a moderator." => "La publication a été signalée à un modérateur et sera révisée.",
// "Previous topic" => "Previous topic",
// "Next topic" => "Next topic",
"You are viewing a reply to" => "Vous visualisez une réponse à",
// "Thread actions" => "Thread actions",
// "Print this page" => "Print this page",
"Print all pages" => "Imprimer toutes les pages",
"Show posts" => "Afficher les articles",
"Jump to forum" => "Aller au forum",
"View Invoice" => "Voir la facture",
"Invoice %0" => "Facture %0",
"Date Issued %0" => "Date d'émission %0",
"Amount: %0" => "Montant : %0",
"Payment Terms: %0" => "Conditions de paiement : %0",
// "This sheet is already being edited by %0" => "This sheet is already being edited by %0",
"Back to Page" => "Retour vers la page",
"Tiki Sheet" => "Feuillet Tiki",
"Save current spreadsheet" => "Enregistrer la feuille de calcul en cours",
"Cancel editing current spreadsheet" => "Annuler la modification courante de la feuille de données",
"No parse" => "Pas d'analyse",
"What would you like to add" => "Que voudriez-vous ajouter",
"New spreadsheet" => "Nouvelle feuille de calcul",
"Existing spreadsheet" => "Feuille de calcul existante",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
"Cell" => "Cellule",
"Set Reference" => "Définir un nom",
"Un-Merge" => "Dé-fusionner",
"Adds an additional row to bottom of the spreadsheet" => "Ajoute une ligne additionnelle en haut de la feuille de calcul",
"Add Row" => "Ajouter une ligne",
"Adds an additional rows to bottom of the spreadsheet" => "Ajoute une ligne additionnelle au bas de la feuille de calcul",
"Add Multi-Rows" => "Ajouter plusieurs lignes",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
"Delete Row" => "Supprimer la ligne",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
"Insert Row Before" => "Insérer une ligne avant",
"Insert Row After" => "Insérer une ligne après",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
"Show All" => "Afficher tout",
"Hides or shows the currently selected row" => "Masque ou affiche la ligne actuellement sélectionnée",
// "Toggle Hide Row" => "Toggle Hide Row",
"Adds an additional column to the right of the spreadsheet" => "Ajoute une colonne additionnelle à la droite de la feuille de calcul",
"Add Column" => "Ajouter une colonne",
"Adds an additional columns to the right of the spreadsheet" => "Ajoute des colonnes additionnelles à la droite de la feuille de calcul",
"Add Multi-Columns" => "Ajouter plusieurs colonnes",
"Deletes the current column thats highlighted" => "Efface la colonne actuellement sélectionnée",
"Delete Column" => "Supprimer la colonne",
"Inserts an additional column after currently selected column" => "Insère une colonne supplémentaire après la colonne actuellement sélectionnée",
"Insert Column Before" => "Insérer une colonne avant",
"Insert Column After" => "Insérer une colonne après",
"Fill down current cell value" => "Remplir vers le bas avec la valeur de la cellule courante",
"Fill Down" => "Remplir vers le bas",
"Fill up current cell value" => "Remplir vers le haut avec la valeur de la cellule actuelle",
"Fill Up" => "Remplir vers le haut",
"Unhides all the hidden columns" => "Révèle toutes les colonnes masquées",
"Hides or shows the currently selected column" => "Affiche ou masque la colonne actuellement sélectionnée",
"Toggle Hide Column" => "Basculer cacher colonne",
"Add new spreadsheet" => "Ajouter une nouvelle feuille de calcul",
"Add Spreadsheet" => "Ajouter une feuille de calcul",
"Delete the current spreadsheet" => "Supprimer la feuille de calcul actuelle",
"Delete Spreadsheet" => "Supprimer une feuille de calcul",
"Recompiles the current sheet" => "Recompile la feuille actuelle",
"Change the title of the sheet" => "Changer le titre de la feuille",
"Wrap Cell Range" => "Traiter une plage de cellules",
"Wrap with SUM" => "Traiter avec SUM",
"Wrap with CEILING" => "Trairer avec CEILING",
"Wrap with COUNT" => "Trairer avec COUNT",
"Wrap with MAX" => "Trairer avec MAX",
"Wrap with MIN" => "Trairer avec MIN",
"Redo" => "Refaire",
// "Toggle State" => "Toggle State",
"Function Reference" => "Référence des fonctions",
"Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Exemple : =SUM(SUM(A1:B1) + SUM(D7))",
"=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
"Returns the absolute value of a number" => "Retourne la valeur absolue d'un nombre",
"Returns a rounded number" => "Retourne un nombre arrondi",
"Returns a number rounded up based on a multiple of significance" => "Retourne un nombre arrondi à la valeur supérieure basé sur un multiple de l'importance",
"Counts the number of cells that contain a value" => "Compte le nombre de cellules qui contiennent une valeur",
"Counts full days from a specific date - format(YYYY,MM,DD)" => "Compte les jours entiers à partir d'une date spécifique - format (AAAA,MM,JJ)",
"Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converit un nombre en texte, selon un format monétaire - options (nombre, décimales, symbole)",
"Returns a logical value of FALSE" => "Retourne une valeur logique FAUX",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
"Returns a number rounded down based on a multiple of significance" => "Retourne un nombre arrondi à la valeur inférieure basé sur un multiple de l'importance",
"Returns the integer portion of a number" => "Retourne la partie entière d'un nombre",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
"Converts a value to a number" => "Convertit une valeur en un nombre",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
"Italics" => "Italique",
"Uppercase" => "Majuscule",
"Capitalize" => "Mettre en majuscule",
"Lowercase" => "Minuscule",
"Font Size +" => "Taille police +",
"Font Size -" => "Taille police -",
// "{\$tracker_info.name}" => "{\$tracker_info.name}",
// "Tracker actions" => "Tracker actions",
// "Group Monitoring" => "Group Monitoring",
// "Stop Watching" => "Stop Watching",
"atts" => "joints",
"List Attachments" => "Liste des fichiers joints",
// "View/Edit" => "View/Edit",
"Insert New Item" => "Insérer une nouvelle fiche",
"View inserted item" => "Voir la fiche insérée",
"Insert new item" => "Ajouter une nouvelle fiche",
// "Synchronization" => "Synchronization",
"This tracker is a remote copy of <a href=\"%0\">%0</a>" => "Ce formulaire est une copie distante de <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
"Reload field definitions" => "Recharger les définitions de champ",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
"Reload data from source" => "Rejesha data kutoka kwa chanzo",
// "Tracker item actions" => "Tracker item actions",
"Move to another tracker" => "Nenda kwenye fomu nyingine",
"Save Returning to Item List" => "Hifadhi kwa kurudi kwenye orodha ya mambo",
// "Save and Comment" => "Save and Comment",
"Special Operations" => "Shughuli maalum",
"close" => "karibu",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
"Open Tiki WebDAV as WebFolder" => "Fungua kama folda ya WebDAV",
"Parent page" => "Page parente",
// "Manage Stucture" => "Manage Stucture",
"Child" => "mtoto",
"page id" => "ukurasa wa id",
// "Please wait" => "Please wait",
// " The PDF is being prepared, please wait.." => " The PDF is being prepared, please wait..",
// "Show structure" => "Show structure",
// "Hide structure bar and any toc" => "Hide structure bar and any toc",
"Hide structure" => "Ficha muundo",
// "Page actions" => "Page actions",
// " PDF" => " PDF",
// "Warning:mPDF Package Missing" => "Warning:mPDF Package Missing",
// "Click to toggle on/off" => "Click to toggle on/off",
// "Edit icons" => "Edit icons",
"Wysiwyg" => "Wysiwyg",
// "Send link" => "Send link",
// "Monitor page" => "Monitor page",
// "Stop monitoring page" => "Stop monitoring page",
// "Monitor sub-structure" => "Monitor sub-structure",
// "Stop monitoring sub-structure" => "Stop monitoring sub-structure",
// "Group monitor structure" => "Group monitor structure",
"Profiles Wizard" => " Profaili Wizard",
"Changes Wizard" => " Mchapishaji wa Upgrade",
"Configuration Wizard" => "Mchawi wa Upangiaji",
// "steps" => "steps",
// "User Wizard" => "User Wizard",
// "Wizard Steps" => "Wizard Steps",
"Change Theme" => "Badilisha mandhari",
// "Change Transition" => "Change Transition",
// "Convex" => "Convex",
// "Concave" => "Concave",
// " Handouts" => " Handouts",
// "Exit Slideshow" => "Exit Slideshow",
"More types available" => "Aina za shamba zaidi zinapatikana",
// "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>",
"Description contains wiki syntax" => "Maelezo ina mwandishi wa Wiki",
"Restrict visibility to administrators" => "Weka kuonekana kwa watendaji",
"Useful if you are working on a live tracker" => "Muhimu kama unafanya kazi kwenye fomu ya mtandaoni",
"Add Field &amp; Edit Advanced Options" => "Ongeza shamba na ubadilishe chaguzi za juu",
// "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)" => "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)",
// "Clear All" => "Clear All",
"Options for %0" => "Chaguo kwa% 0",
"Separate multiple with commas" => "Tofauti maadili mbalimbali na vitambaa",
// "Separate multiple with &quot;{\$def.separator}&quot" => "Separate multiple with &quot;{\$def.separator}&quot",
"Error Message" => "Ujumbe wa hitilafu",
"Visible by all" => "Inaonekana kwa wote",
// "Visible by all but not in RSS feeds" => "Visible by all but not in RSS feeds",
// "Visible after creation by administrators only" => "Visible after creation by administrators only",
"Editable by administrators only" => "Badilisha tu kwa watendaji",
// "Editable after creation by administrators only" => "Editable after creation by administrators only",
"Editable by administrators and creator only" => "Badilisha tu kwa watendaji au muumbaji",
// "Immutable after creation" => "Immutable after creation",
"Creator requires a user field with auto-assign to creator (1)" => "Muumba inahitaji shamba la mtumiaji kwa kujishughulisha na mwumbaji (1)",
"Visible by" => "Inaonekana na",
// "List of Group names with permission to see this field" => "List of Group names with permission to see this field",
// "Separated by comma (,)" => "Separated by comma (,)",
"Editable by" => "Haririwa na",
// "List of Group names with permission to edit this field" => "List of Group names with permission to edit this field",
"Changing the permanent name may have consequences in integrated systems" => "Kubadilisha jina la kudumu kunaweza kuwa na matokeo katika mfumo jumuishi",
// "Changing the field type may cause irretrievable data loss - use with caution" => "Changing the field type may cause irretrievable data loss - use with caution",
// "Make sure you rebuild the search index if you change field type" => "Make sure you rebuild the search index if you change field type",
// "Deprecated" => "Deprecated",
// "To export tracker or tracker items please" => "To export tracker or tracker items please",
// "enable" => "enable",
// "and use" => "and use",
// "Tracker Tabular" => "Tracker Tabular",
// "It is easy to use, optimised and far more powerful" => "It is easy to use, optimised and far more powerful",
"Export Tracker Items" => "Fungua kadi za fomu",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
"Delimitor (left)" => "Delimiter (kushoto)",
"Delimitor (right)" => "Delimiter (kulia)",
"Carriage return inside field value" => "Urejeshaji kurudi ndani ya thamani ya shamba",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
// "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
"Parse as wiki text" => "Kuchambua kama maandishi ya wiki",
// "Generic information" => "Generic information",
"Number of records" => "Idadi ya rekodi",
// "First record" => "First record",
"Quick Export" => "Safari ya nje",
// "Produce a CSV with basic formatting" => "Produce a CSV with basic formatting",
// "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'" => "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'",
// "Tracker Export" => "Tracker Export",
// "Copy the definition text above and paste into the Import Structure box for a new tracker" => "Copy the definition text above and paste into the Import Structure box for a new tracker",
// "Profile Export" => "Profile Export",
// "Produce YAML for a profile" => "Produce YAML for a profile",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
"For example: \$profileobject:field_ref\$" => "Kwa mfano: \\ \$ profileobject: field_ref \\ \$",
// "Export Profile" => "Export Profile",
"Fields Export" => "Tuma nje",
// "Copy the definition text above and paste into the Import Fields box on a tracker's fields page" => "Copy the definition text above and paste into the Import Fields box on a tracker's fields page",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
"Raw data" => "Damu ya data",
"Preserve tracker ID" => "Weka ID ya fomu",
// "Use \"Tracker -> Export -> Structure\" to produce this data" => "Use \"Tracker -> Export -> Structure\" to produce this data",
// "Tracker import completed" => "Tracker import completed",
// "Return to Trackers" => "Return to Trackers",
"Import fields for this tracker" => "Ingiza mashamba kwa fomu hii",
"Raw Fields" => "Mashamba makubwa",
"Preserve Field IDs" => "Weka vitambulisho vya mashamba",
"Confirmation" => "uthibitisho",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "To import items into a tracker please" => "To import items into a tracker please",
"The order of the fields does not matter, but you need to add a header with the field names" => "Utaratibu wa mashamba haujalishi, lakini lazima uongeze kichwa na majina ya shamba",
// "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import" => "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import",
"Auto-incremented itemid fields shall be included with no matter what values" => "Mashamba yenye kitambulisho cha fomu ya kujitegemea yatajumuishwa bila kujali maadili yao",
// "If you are having problems, try a different line ending for your csv file that matches the server operating system" => "If you are having problems, try a different line ending for your csv file that matches the server operating system",
// "UNIX Timestamp" => "UNIX Timestamp",
"Character encoding" => "Tabia ya kuandika",
// "Create as new items" => "Create as new items",
"Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Sasisha tarehe ya marekebisho ya mwisho ikiwa faili inasasishwa (hali na tarehe ya uumbaji zinasasishwa tu ikiwa zipo kwenye CSV)",
// "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance" => "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance",
// "Please note: This is an experimental new feature - work in progress" => "Please note: This is an experimental new feature - work in progress",
// "YAML" => "YAML",
// "Create another" => "Create another",
// "Do you really want to remove the \"%0\" tracker" => "Do you really want to remove the \"%0\" tracker",
// "Please note" => "Please note",
// "This tracker, its fields and all of its %0 items will be permanently removed from your system" => "This tracker, its fields and all of its %0 items will be permanently removed from your system",
"Are you sure you want to remove the fields? Data will be lost" => "Una uhakika unataka kufuta mashamba? Data itapotea",
"Remove Fields" => "Futa mashamba",
// "Return to field administration" => "Return to field administration",
// "Replacement" => "Replacement",
// "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one" => "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one",
"Description is wiki-parsed" => "Maelezo hutumia wiki ya syntax",
// "Field Prefix" => "Field Prefix",
"Allow ratings (deprecated, use rating field)" => "Ruhusu quotes (kizamani, tumia alama ya shamba)",
"Rating options" => "Chaguzi za kupima",
"Show ratings in listing" => "Angalia orodha katika mtazamo wa orodha",
"Show comments in listing" => "Tazama maoni katika orodha ya orodha",
"Display last comment author and date" => "Tazama mwandishi wa maoni ya mwisho na tarehe",
// "Allow attachments (deprecated, use files field)" => "Allow attachments (deprecated, use files field)",
"Display attachments in listing" => "Angalia viambatanisho kwenye orodha ya orodha",
"Attachment attributes (sortable)" => "Inashirikisha viambatisho (vinavyoweza kutolewa)",
// "Recommended size: 64x64px" => "Recommended size: 64x64px",
"Show status to tracker administrator only" => "Onyesha hali tu kwa msimamizi wa fomu",
"Show creation date when listing items" => "Onyesha tarehe ya uumbaji kwenye orodha ya kadi",
"Creation date format" => "Faili ya tarehe ya uumbaji",
"Show item creator" => "Tazama muumba wa fomu",
"Show creation date when viewing items" => "Onyesha tarehe ya uumbaji katika taswira ya kadi",
"Show last modification date when listing items" => "Angalia tarehe ya mwisho iliyopita katika orodha",
"Show item last modifier" => "Aina ya tarehe ya marekebisho",
"Modification date format" => "Aina ya tarehe ya marekebisho",
"Show last modification date when viewing items" => "Onyesha tarehe ya mwisho ya marekebisho wakati wa kutazama kadi",
"Hide empty fields from item view" => "Usionyeshe mashamba yasiyo na kitu katika mtazamo wa fomu",
"List detail popup" => "Mtazamo wa popup katika rollover ya orodha",
// "Section Format" => "Section Format",
// "Section format" => "Section format",
// "Determines how headers will be rendered when using header fields as form section dividers" => "Determines how headers will be rendered when using header fields as form section dividers",
// "Set to <em>Configured</em> to use the four following fields" => "Set to <em>Configured</em> to use the four following fields",
// "Use Form Classes" => "Use Form Classes",
// "Input Form Classes" => "Input Form Classes",
// "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)" => "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)",
"Template to display an item" => "Kigezo cha kuonyesha fomu",
"wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:nomdelapage pour une page wiki ou tpl:nomdutemplate pour un modèle",
"Template to edit an item" => "Gabarit pour modifier une fiche",
"New item status" => "Nouveau statut de la fiche",
"Modified item status" => "Hali ya hali iliyobadilishwa",
"No change" => "Hakuna mabadiliko",
"Default status displayed in list mode" => "Hali ya msingi imeonyeshwa katika orodha ya orodha",
"Copy activity to email" => "Nakala shughuli kwa barua pepe",
"Use simplified email format" => "Tumia muundo wa barua pepe rahisi",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "Fomu itatumia uwanja wa maandishi unaoitwa 'Somo' ikiwa iko, barua pepe ya mtumiaji ikiwa iko, au kwa mtu asiyejulikana, uwanja wa 'barua pepe' wa fomu ikiwa ipo",
"Publish RSS feed for this tracker" => "Shirikisha feed RSS ya fomu hii",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
"Group alerted on item modification" => "Kundi limefahamishwa ikiwa muundo wa faili",
"Allow user selection for small groups" => "Ruhusu uteuzi wa mtumiaji kwa makundi madogo",
// "User can see his own items" => "User can see his own items",
// "The tracker needs a user field with the item-owner activated" => "The tracker needs a user field with the item-owner activated",
// "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user" => "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user",
"Item creator can modify his items" => "Muumbaji wa kadi ana haki ya kurekebisha kadi zake",
"The tracker needs a user field with the auto-assign activated" => "Mtumiaji anaweza kufaa fomu iliyoundwa na mtu asiyejulikana",
// "Item creator can remove his items" => "Item creator can remove his items",
"User can take ownership of item created by anonymous" => "Mtumiaji anaweza kufaa fomu iliyoundwa na mtu asiyejulikana",
"Only one item per user or IP" => "Kadi moja kwa mtumiaji au IP",
// "The tracker needs a user or IP address field with the auto-assign set to Creator" => "The tracker needs a user or IP address field with the auto-assign set to Creator",
"Members of the creator group can modify items" => "Wanachama wa kikundi cha waumbaji wanaweza kubadilisha rekodi",
"The tracker needs a group field with the auto-assign activated" => "Fomu inahitaji shamba la kikundi na chaguo la hiari la kibinafsi linalowezeshwa",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Restrict non admins to wiki page access only" => "Restrict non admins to wiki page access only",
// "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports" => "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports",
"Creation date constraint" => "Uzuia tarehe ya uumbaji",
// "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below" => "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below",
"Before" => "kabla",
"Auto-create corresponding categories" => "Jenga kwa makundi makundi sawa",
"Create a group for each item" => "Unda kikundi kwa kila fomu",
"Groups will include" => "Vikundi zitajumuisha",
"Creator is assigned to the group" => "Muumba hupewa kikundi",
"Will become the creator's default group" => "Itakuwa kikundi cha default cha muumba",
"Will become the new item's group creator" => "Atakuwa muumba wa kikundi cha karatasi",
"Copy the default group in the field ID before updating the group" => "Nakala kikundi chaguo-msingi katika Kitambulisho cha shamba kabla ya kuboresha kikundi",
"Non Advanced Search or Natural Search" => "Utafutaji haujapandishwa au 'asili'",
"Advanced Search or Boolean Search" => "Utafutaji wa juu au wa Boolean",
"Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Vipengele vyenye masharti mengi huwekwa nafasi ya juu katika matokeo na itaonekana katika nafasi ya kwanza ya aina zao.",
"objects that include both terms" => "vitu vyenye maneno yote",
// "Requiring terms" => "Requiring terms",
"Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Ongeza ishara zaidi (+) mbele ya muda ili kuonyesha kwamba neno <em> linapaswa </ em> kuonekana katika matokeo",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
"Excluding terms" => "Exclure des termes",
"Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Ongeza ishara ndogo (-) mbele ya muda ili kuonyesha kwamba neno <em> haipaswi </ em> kuonekana katika matokeo",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
"Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed" => "Piga herufi kwa alama za nukuu (<kbd> \"\" </ kbd>) ili upate maneno kulingana na utaratibu halisi",
"Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Mfano: <kbd> \"Alex Bell \" </ kbd> hatapata <strong> Bell Alex </ strong> au <strong> Alex G. Bell </ strong>. ",
// "Using wildcards" => "Using wildcards",
"Add an asterisk ( * ) after a term to find objects that include the root word" => "Ongeza asterisk (*) baada ya muda kupata vitu vinavyojumuisha neno la mizizi",
"For example, <strong>run*</strong> will find" => "Kwa mfano, <strong> kukimbia * </ strong> utapata",
"objects that include the term <strong>run</strong>" => "vitu vyenye neno <strong> kukimbia </ strong>",
"objects that include the term <strong>runner</strong>" => "vitu vyenye neno <strong> mkimbiaji </ strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
"Reducing a term's value" => "Kupunguza umuhimu wa neno",
"Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Ongeza kichwa (~) mbele ya muda ili kupunguza thamani yake ili kuonyesha matokeo ya cheo",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)",
"Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>" => "Exemple : <strong>+wiki ~forum</strong> évaluera un objet avec seulement <strong>wiki</strong> plus qu'un objet avec <strong>wiki</strong> et  <strong>forum</strong>",
"Changing relevance value" => "Badilisha thamani ya umuhimu",
"Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Ongeza ishara ya chini (<) au zaidi (>) kabla ya muda ili kubadilisha mchango wa muda huo kwa umuhimu wa kimataifa uliopewa kitu",
"Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Mfano: <strong> + wiki + (& gt; forum & lt; blog) </ strong> utapata vitu vinavyoweka <strong> wiki </ strong> na <strong> wiki </ strong> au <strong> wiki </ strong > na <strong> blogu </ strong> kwa utaratibu wowote. <strong> jukwaa la wiki </ strong> litakuwa bora zaidi",
// "{\$confirmation_message}" => "{\$confirmation_message}",
// "\"}Are you sure you want to set this %0 to \"open\"" => "\"}Are you sure you want to set this %0 to \"open\"",
// "\"}Are you sure you want to set this %0 to \"pending\"" => "\"}Are you sure you want to set this %0 to \"pending\"",
// "\"}Are you sure you want to set this %0 to \"closed\"" => "\"}Are you sure you want to set this %0 to \"closed\"",
// "{\$field.name|truncate:65|escape}" => "{\$field.name|truncate:65|escape}",
"Hold \"Ctrl\" in order to select multiple values" => "Shika \"Ctrl \" kuchagua maadili nyingi",
// "{\$field_name}" => "{\$field_name}",
// "{\$description}" => "{\$description}",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
"Admin Fields" => "Dhibiti mashamba",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
"Search for trackers to clone" => "Pata fomu za duplicate",
"After" => "baada",
"Do you really want to remove the scheduled event" => "Je! Unataka kufuta tukio lililopangwa",
// "Remove event" => "Remove event",
// "No events registered" => "No events registered",
// "Reference date" => "Reference date",
"After creation" => "Baada ya uumbaji",
"After last modification" => "Baada ya mabadiliko ya mwisho",
// "Delay prior to status change" => "Delay prior to status change",
"Mail subject text" => "Suala la barua",
"Mail body ressource" => "Rasilimali kwa mwili wa barua",
"wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki: ukurasa wa ukurasa wa wiki au tplName.tpl kwa template",
// "Existing Article" => "Existing Article",
// "Article URL" => "Article URL",
"(automatically generated after item creation)" => "(huzalishwa moja kwa moja baada ya uumbaji)",
// "Change Event" => "Change Event",
"Attached files limitation" => "Ukomo wa vifungo",
"The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved" => "Idadi ya faili ambazo zinaweza kushikamana ni mdogo kwa <strong> %0 </ strong>. Faili za hivi karibuni zitahifadhiwa",
"Browse files" => "Parcourir la liste des fichiers",
// "Browse Files" => "Browse Files",
// "Link to existing Vimeo URL" => "Link to existing Vimeo URL",
"Type or paste the URL and press ENTER" => "Ingiza URL na ubofye kuingia",
// "You do not have permission to upload files to this gallery" => "You do not have permission to upload files to this gallery",
// "You do not have permission to add a member to a group" => "You do not have permission to add a member to a group",
"Select Icon" => "Chagua icon",
// "Remove image" => "Remove image",
"Are you sure you want to delete this image" => "Una uhakika unataka kufuta picha hii",
// "{\$field.options_map.addItems|escape}" => "{\$field.options_map.addItems|escape}",
// "Add Media" => "Add Media",
"Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19" => "Format: x, y, zoom ambapo x ni longitude, na y ni latitude. Zoom ni kati ya 0 (angalia Dunia) na 19",
// "This bug has been demonstrated on {\$field.options_map.domain|escape}" => "This bug has been demonstrated on {\$field.options_map.domain|escape}",
// "Please demonstrate your bug on {\$field.options_map.domain|escape}" => "Please demonstrate your bug on {\$field.options_map.domain|escape}",
// "Bug needs to be created first" => "Bug needs to be created first",
// "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created" => "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created",
// "Show.tiki.org snapshot creation is in progress" => "Show.tiki.org snapshot creation is in progress",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"",
// "Password reset" => "Password reset",
// "Password reset was successful" => "Password reset was successful",
// "Password reset failed" => "Password reset failed",
// "Show.tiki.org instance destruction in progress" => "Show.tiki.org instance destruction in progress",
// "Show.tiki.org instance destruction is in progress... Please wait.." => "Show.tiki.org instance destruction is in progress... Please wait..",
// "Show.tiki.org is not configured properly" => "Show.tiki.org is not configured properly",
// "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks" => "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks",
// "Show.tiki.org is currently unavailable" => "Show.tiki.org is currently unavailable",
// "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Show.tiki.org is under maintenance" => "Show.tiki.org is under maintenance",
// "Show.tiki.org is currently under maintenance. Sorry for the inconvenience" => "Show.tiki.org is currently under maintenance. Sorry for the inconvenience",
// "Unable to get information from {\$field.options_map.domain|escape}" => "Unable to get information from {\$field.options_map.domain|escape}",
// "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Instance is being created" => "Instance is being created",
// "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks" => "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks",
// "About {\$field.options_map.domain|escape}" => "About {\$field.options_map.domain|escape}",
// "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}" => "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}",
// "Create {\$field.options_map.domain|escape} instance" => "Create {\$field.options_map.domain|escape} instance",
// "Accessing the Tiki instance that demonstrates this bug" => "Accessing the Tiki instance that demonstrates this bug",
// "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0" => "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"",
// "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0" => "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0",
// "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload" => "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload",
// "Snapshots" => "Snapshots",
// "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation" => "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0",
// "Create new snapshot" => "Create new snapshot",
// "Destroy this {\$field.options_map.domain|escape} instance" => "Destroy this {\$field.options_map.domain|escape} instance",
// "Reset password to 12345" => "Reset password to 12345",
// "SVN update" => "SVN update",
// "Debug Mode Information" => "Debug Mode Information",
// "Get instance information and refresh cache" => "Get instance information and refresh cache",
// "Filter by group" => "Filter by group",
// "Select user(s)" => "Select user(s)",
// "View stand alone wiki page" => "View stand alone wiki page",
// "Source of wiki page" => "Source of wiki page",
// "History of wiki page" => "History of wiki page",
// "No articles" => "No articles",
"Administrator intervention required" => "Msimamizi wa kuomba kuingilia kati",
// "Tags is not enabled" => "Tags is not enabled",
"LastModif" => "ilibadilishwa mwisho.",
"You did not vote yet" => "Hukuja kura bado",
"My rating" => "Aina yangu",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
"Click to vote for this value" => "Bofya ili kupiga kura kwa thamani hii",
// "Remove your rating" => "Remove your rating",
// "%0 element(s)" => "%0 element(s)",
// "Language: %0" => "Language: %0",
// "You have subscribed" => "You have subscribed",
"You have not yet subscribed" => "Huna usajili bado",
"with" => "kwa",
"friends" => "rafiki",
// "Translation.." => "Translation..",
// "No language assigned" => "No language assigned",
// "Set page language" => "Set page language",
// "Set article language" => "Set article language",
"Current language" => "Lugha ya sasa",
// "Show all translations of this page on a single page" => "Show all translations of this page on a single page",
"All languages" => "Lugha zote",
// "Machine translations" => "Machine translations",
// "Translate page" => "Translate page",
// "Manage page translations" => "Manage page translations",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
"Are you sure you want to detach these translations" => "Una uhakika unataka kufuta tafsiri hizi?",
"Current translation set" => "Mchezo wa sasa wa kutafsiri",
// "Detach translation" => "Detach translation",
"Are you sure you want to detach the translation" => "Una uhakika unataka kufuta tafsiri?",
"No translations available at this time" => "Hakuna kutafsiri kwa sasa",
"Add a new object to the set" => "Ongeza kitu kipya kwenye kuweka",
"All possible translations exist" => "Tafsiri zote iwezekanavyo zipo",
// "Email this wiki page" => "Email this wiki page",
// "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki" => "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki",
// "Bcc" => "Bcc",
// "Enter a valid email to send a blind copy to (optional)" => "Enter a valid email to send a blind copy to (optional)",
// "%0 away" => "%0 away",
// "Shared groups" => "Shared groups",
// "Friendship" => "Friendship",
// "Add to or remove from" => "Add to or remove from",
// "Add to" => "Add to",
// "Remove from" => "Remove from",
// "These groups" => "These groups",
// "Use Ctrl+Click or Command+Click to select multiple options" => "Use Ctrl+Click or Command+Click to select multiple options",
// "Set default group" => "Set default group",
// "Remove users" => "Remove users",
// "Remove the users' pages" => "Remove the users' pages",
// "Remove the user pages belonging to these users" => "Remove the user pages belonging to these users",
// "Delete user items from these trackers" => "Delete user items from these trackers",
// "Warning: Experimental" => "Warning: Experimental",
// "Select trackers here to have items in them which are \"owned\" by these users deleted" => "Select trackers here to have items in them which are \"owned\" by these users deleted",
// "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically" => "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically",
// "Delete user files" => "Delete user files",
// "Delete the users' file galleries and all the files in them" => "Delete the users' file galleries and all the files in them",
// "Ban users" => "Ban users",
// "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning" => "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning",
// "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided" => "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided",
// "Cancel login process" => "Cancel login process",
// "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login" => "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login",
// "Birth date" => "Birth date",
// "Validate your age and proceed to login" => "Validate your age and proceed to login",
// "I approve the above terms and conditions" => "I approve the above terms and conditions",
// "I Decline, log out" => "I Decline, log out",
"However, no account is associated to the OpenID identifier." => "Hata hivyo, hakuna akaunti inayohusishwa na kitambulisho.",
"If you use an email filter, be sure to add %0 to your accepted list" => "Ikiwa unatumia chujio cha barua pepe, hakikisha umeongeza %0 kwenye orodha yako ya vibali",
"Associate OpenID with an existing Tiki account" => "Shiriki OpenID na akaunti ya Tiki iliyopo",
// "Browse for video file to upload" => "Browse for video file to upload",
// "Upload Progress" => "Upload Progress",
// "Vimeo Setup Error" => "Vimeo Setup Error",
// "{\$errMsg}" => "{\$errMsg}",
// "Available space: %0 megabytes" => "Available space: %0 megabytes",
// "No standard definition uploads available currently" => "No standard definition uploads available currently",
// "No high definition uploads available currently" => "No high definition uploads available currently",
// "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines" => "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines",
// "You will also need to rebuild your caches and search index" => "You will also need to rebuild your caches and search index",
// "Re-generate URLs" => "Re-generate URLs",
// "The following item(s) include page(s) being deleted and will break" => "The following item(s) include page(s) being deleted and will break",
// "Remove {\$idesc}" => "Remove {\$idesc}",
// "Create redirect" => "Create redirect",
// "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)" => "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)",
// "Redirect to" => "Redirect to",
"Use this thread to discuss the page" => "Tumia thread hii kujadili kwenye ukurasa",
"Missing or incorrect trackerId parameter for the plugin." => "Kipimo cha batili au cha kukosa kwa pembejeo.",
"List Trackers" => "Orodha ya fomu",
"resource day" => "Rasilimali kwa siku",
"resource month" => "Rasilimali kwa mwezi",
// "resource year" => "resource year",
"resource week" => "Rasilimali kwa wiki",
// "list day" => "list day",
// "list month" => "list month",
// "list year" => "list year",
// "list week" => "list week",
"list" => "orodha",
// "agenda month" => "agenda month",
// "agenda week" => "agenda week",
// "agenda day" => "agenda day",
// "{\$params.label|escape}" => "{\$params.label|escape}",
"Subtract" => "Ondoa",
// "Meeting ID" => "Meeting ID",
"Current attendees" => "Washiriki wa sasa",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "Current recordings" => "Current recordings",
// "On %0 from %1 to %2" => "On %0 from %1 to %2",
// "This will permanently remove the recording" => "This will permanently remove the recording",
// "(including audio recording & chat log)" => "(including audio recording & chat log)",
// "{\$button_label}" => "{\$button_label}",
// "{\$moretext|escape}" => "{\$moretext|escape}",
// "{\$ftptitle}" => "{\$ftptitle}",
// "No permission to change the following task" => "No permission to change the following task",
// "Project update not possible as you lack rights for updating a parent project" => "Project update not possible as you lack rights for updating a parent project",
// "Start date is a milestone" => "Start date is a milestone",
// "End date is a milestone" => "End date is a milestone",
// "Task has constraints" => "Task has constraints",
// "Error: there is a dependency on an open task" => "Error: there is a dependency on an open task",
// "Error: due to a descendant of a closed task" => "Error: due to a descendant of a closed task",
// "This task has external dependencies" => "This task has external dependencies",
// "GANNT_ERROR_LOADING_DATA_TASK_REMOVED" => "GANNT_ERROR_LOADING_DATA_TASK_REMOVED",
// "Cannot depend on ancestors" => "Cannot depend on ancestors",
// "The data inserted are invalid for the field format" => "The data inserted are invalid for the field format",
// "An error has occurred while loading the data. A task has been trashed" => "An error has occurred while loading the data. A task has been trashed",
// "Cannot close a task with open issues" => "Cannot close a task with open issues",
// "You cannot exchange tasks of different depth" => "You cannot exchange tasks of different depth",
// "Sem" => "Sem",
// "Cannot move task" => "Cannot move task",
// "Please save your project" => "Please save your project",
// "Error: date settings" => "Error: date settings",
// "Cannot depend on descendants" => "Cannot depend on descendants",
// "code/short name" => "code/short name",
// "start" => "start",
// "dur" => "dur",
// "depe" => "depe",
// "assignees" => "assignees",
// "completed" => "completed",
// "suspended" => "suspended",
// "undefined" => "undefined",
// "Task editor" => "Task editor",
// "is milestone" => "is milestone",
// "status" => "status",
// "progress" => "progress",
// "Assignments" => "Assignments",
// "Role" => "Role",
// "est.wklg" => "est.wklg",
"Number of Users" => "Idadi ya Watumiaji",
"Percentage of Total" => "Asilimia ya Jumla",
// "Email address of invitee" => "Email address of invitee",
"Set in these groups" => "Weka katika vikundi hivi",
// "Number of result" => "Number of result",
"Message sent to" => "Ujumbe uliotumwa",
"Email sent to" => "Barua pepe imetumwa",
// "recipients" => "recipients",
// "Message preview" => "Message preview",
// "Number of Recipients" => "Number of Recipients",
"Send Mail" => "Tuma Barua",
"Send to users" => "Tuma kwa watumiaji",
"Send to" => "Tuma kwa",
"Email address (if more than one, separated by \",\")" => "Barua pepe ikiwa zaidi ya moja, ikitenganishwa na",
"Send to groups" => "Tuma kwa vikundi",
"Preview Mail" => "Angalia Barua",
// "You will receive a copy of the email yourself. Please give it a few minutes" => "You will receive a copy of the email yourself. Please give it a few minutes",
// "Please wait while your email is being sent.." => "Please wait while your email is being sent..",
// "Previous npm-asset/pdfjs-dist package has been deprecated" => "Previous npm-asset/pdfjs-dist package has been deprecated",
// "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package" => "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package",
"Check to remove" => "Angalia ili uondoe",
// "Contents of email to be sent to user" => "Contents of email to be sent to user",
// "Append custom message" => "Append custom message",
// "Approve user" => "Approve user",
// "Reject user" => "Reject user",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
"Join myself" => "Jiunge na mimi mwenyewe",
"Leave myself" => "Acha mwenyewe",
"Cost for one period" => "Gharama kwa kipindi kimoja",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
"Prorated cost for first period" => "Kutoa gharama kwa kipindi cha kwanza",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 for %2 %3" => "Membership to %0 for %1 for %2 %3",
"separated by |" => "kutengwa na |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "vs" => "vs",
// "Mine" => "Mine",
// "Save Changes" => "Save Changes",
// "Edit Pivot Table" => "Edit Pivot Table",
// "Click to view interactive SCORM learning object" => "Click to view interactive SCORM learning object",
// "Download original file" => "Download original file",
"Re-Apply" => "Re-Appliquer",
"wrote" => "imeandikwa",
// "{\$wp_emptymsg}" => "{\$wp_emptymsg}",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
"Last Day" => "Siku iliyopita",
"Last Week" => "Wiki iliyopita",
// "{\$action}" => "{\$action}",
"Groups you are in" => "Makundi ambayo wewe ni",
"(This is an included group)" => "(Hii ni kundi linajumuisha)",
// "(You are a leader)" => "(You are a leader)",
"Your default group" => "Acha kikundi",
"Leave Group" => "Acha kikundi",
"Manage Group" => "Dhibiti kikundi",
"Change default group" => "Badilisha kikundi cha default",
"Subscribe to a group" => "Jiunge na kikundi",
"Groups you can join" => "Makundi unaweza kujiunga",
"This group requires approval to join" => "Kundi hili linahitaji kibali kujiunga",
// "Subscribe to groups" => "Subscribe to groups",
"Subscription confirmed!" => "Usajili umehakikishiwa!",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Mini TimeSheet" => "Mini TimeSheet",
// "Full View" => "Full View",
// "End tour" => "End tour",
// "-- Choose an option --" => "-- Choose an option --",
// "{\$export_action}" => "{\$export_action}",
"Map View" => "Tazama Ramani",
// "Field error" => "Field error",
"Stop Monitor" => "Acha ufuatiliaji",
// "Tracker - " => "Tracker - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
// "Close item" => "Close item",
// "Open item" => "Open item",
// "Pend item" => "Pend item",
// "{\$params.label}" => "{\$params.label}",
"Please login first" => "Tafadhali ingia kwanza",
"Toggle display" => "Badilisha mabadiliko",
// "Page approved by %0 on %1" => "Page approved by %0 on %1",
"Page last modified on %0 by %1" => "Mwisho wa mwisho umebadilishwa kwenye% 0 na% 1",
"Created by %0" => "Imetengenezwa na %0",
"Last Modification: %0 by %1" => "Marekebisho ya Mwisho: : %0 par %1",
"Save the page as a partial translation." => "Hifadhi ukurasa kama tafsiri ya sehemu.",
"Partial Translation" => "Tafsiri ya pekee",
"Save the page as a completed translation." => "Hifadhi ukurasa kama tafsiri iliyokamilishwa.",
"Complete Translation" => "Tafsiri kamili",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Hifadhi ukurasa, lakini usitumie arifa na usiihesabu kama maudhui mapya ya kutafsiriwa.",
"Save Minor Edit" => "Weka Hifadhi Machache",
"Save the page." => "Hifadhi ukurasa.",
// "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions" => "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions",
// "Workspaces UI in doc.tiki.org" => "Workspaces UI in doc.tiki.org",
// "Enable using the same wiki page name in different contexts" => "Enable using the same wiki page name in different contexts",
// "E.g. ns1:_:MyPage and ns2:_:MyPage" => "E.g. ns1:_:MyPage and ns2:_:MyPage",
// "Workspaces & Areas admin panel" => "Workspaces & Areas admin panel",
// "Automatic table of contents for a wiki page" => "Automatic table of contents for a wiki page",
// "Auto TOC options" => "Auto TOC options",
// "Auto TOC" => "Auto TOC",
// "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc" => "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc",
// "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu" => "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu",
// "Set up categories here" => "Set up categories here",
// "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages" => "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages",
// "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there" => "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there",
// "Configure general user & community features and settings related to sharing and social networks" => "Configure general user & community features and settings related to sharing and social networks",
// "Add a <b>User and Registration tracker</b>" => "Add a <b>User and Registration tracker</b>",
// "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users" => "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users",
// "Some uses of this type of tracker could be" => "Some uses of this type of tracker could be",
// "To collect user information (such as mailing address or phone number)" => "To collect user information (such as mailing address or phone number)",
// "To require the user to acknowledge a user agreement" => "To require the user to acknowledge a user agreement",
// "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)" => "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)",
// "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually" => "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually",
// "apply profile now" => "apply profile now",
// "new window" => "new window",
// "To set up the <strong>User Watches</strong> and their associated settings, visit the page to " => "To set up the <strong>User Watches</strong> and their associated settings, visit the page to ",
// "Community General Settings" => "Community General Settings",
// "admin panel" => "admin panel",
// "in doc.tiki.org" => "in doc.tiki.org",
// "Sharing & Networking" => "Sharing & Networking",
// "Social Network" => "Social Network",
// "Friendship and Followers" => "Friendship and Followers",
// "Set the site time zone and format for displaying dates and times" => "Set the site time zone and format for displaying dates and times",
// "Date and Time options" => "Date and Time options",
// "Date and Time admin panel" => "Date and Time admin panel",
// "Select editor type" => "Select editor type",
// "Only Plain Text Editor (Disable Wysiwyg)" => "Only Plain Text Editor (Disable Wysiwyg)",
// "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>" => "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>",
// "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page" => "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page",
// "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor" => "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor",
// "Set up the main Tiki features. The wiki and file gallery features are always enabled" => "Set up the main Tiki features. The wiki and file gallery features are always enabled",
// "Main Tiki features" => "Main Tiki features",
// "Tiki has many more features" => "Tiki has many more features",
// "Global Features" => "Global Features",
// "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made" => "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made",
// "Set up the file gallery and attachments" => "Set up the file gallery and attachments",
// "Choose to store them either in the database or in files on disk, among other options" => "Choose to store them either in the database or in files on disk, among other options",
// "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder" => "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder",
// "elFinder" => "elFinder",
// "Wiki admin panel" => "Wiki admin panel",
// "File storage" => "File storage",
// "Set elFinder as the default file gallery viewer" => "Set elFinder as the default file gallery viewer",
// "File Gallery storage" => "File Gallery storage",
// "Attachment storage" => "Attachment storage",
// "Select the site language" => "Select the site language",
// "Language options" => "Language options",
// "Configure the log-in, registration and validation preferences for the new accounts" => "Configure the log-in, registration and validation preferences for the new accounts",
// "Registration and log-in options" => "Registration and log-in options",
// "Login admin panel" => "Login admin panel",
// "Configure the Tiki theme and other look & feel preferences" => "Configure the Tiki theme and other look & feel preferences",
// "Look & Feel options" => "Look & Feel options",
// "Look & Feel admin panel" => "Look & Feel admin panel",
// "Namespace settings" => "Namespace settings",
// "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>" => "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>",
// "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)" => "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)",
// "Basic Search" => "Basic Search",
// "Uses MySQL full-text search" => "Uses MySQL full-text search",
// "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below" => "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below",
// "Advanced Search" => "Advanced Search",
// "Uses Unified Search Index with a specified search engine" => "Uses Unified Search Index with a specified search engine",
// "If you have issues with Advanced Search, simply revert to Basic Search" => "If you have issues with Advanced Search, simply revert to Basic Search",
// "Unified Search is required by a number of other features, e.g. the community friendship network" => "Unified Search is required by a number of other features, e.g. the community friendship network",
// "Other settings" => "Other settings",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "Search admin card" => "Search admin card",
// "Search in doc.tiki.org" => "Search in doc.tiki.org",
// "Hierarchical organization of wiki pages" => "Hierarchical organization of wiki pages",
// "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage" => "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage",
// "Structures options" => "Structures options",
// "Set up the text area environment (Editing and Plugins)" => "Set up the text area environment (Editing and Plugins)",
// "Editing and plugins admin panel" => "Editing and plugins admin panel",
// "Set up the Wiki environment" => "Set up the Wiki environment",
// "Wiki environment" => "Wiki environment",
// "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar" => "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar",
// "Requires Java" => "Requires Java",
// "Verify your Java installation" => "Verify your Java installation",
// "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages" => "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages",
// "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>" => "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>",
"Get Started" => " Anza",
"Congratulations! You now have a working instance of Tiki %0" => " Hongera! Sasa una mfano wa kazi wa Tiki 19.0svn",
"You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below." => " Unaweza <a href=\"tiki-index.php\"> kuanza kuitumia mara moja </a>, au unaweza kuiweka ili ufanane na mahitaji yako, ukitumia mmoja wa wasaidizi wa usanifu hapa chini.",
"Mouse over the icons to know more about the features and preferences that are new for you" => " Piga picha juu ya icons kujua zaidi kuhusu vipengele na mapendekezo ambayo ni mpya kwako",
"Example: " => "Mfano:",
// "Help icon" => "Help icon",
// "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it" => "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it",
// "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic" => "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic",
"Configuration Profiles Wizard" => "Mpangilio wa Profaili mchawi",
"You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>" => "Unaweza kuanza kwa kutumia baadhi ya templates yetu ya usanidi kupitia <b> Msaidizi wa Wasanidi wa Upangiaji </ b>",
"They are like the <b>Macros</b> from many computer languages" => " Wao ni kama <b> Macros </ b> kutoka kwa lugha nyingi za kompyuta",
// "It is best to apply them from the start and you can always preview and reverse the process" => "It is best to apply them from the start and you can always preview and reverse the process",
// "Configuration Profiles" => "Configuration Profiles",
// "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you" => "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you",
// "If you are new to Tiki administration, we recommend that you start with this approach" => "If you are new to Tiki administration, we recommend that you start with this approach",
// "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below" => "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below",
"Start Configuration Profiles Wizard (Macros)" => " Anza Mipangilio ya Profaili ya Usanidi (Macros)",
// "Configuration Walkthrough" => "Configuration Walkthrough",
"Alternatively, you may use the <b>Configuration Wizard</b>" => " Vinginevyo, unaweza kutumia <b> Mpangilio wa Msajili </ b>",
"This will guide you through the most common preference settings in order to customize your site" => " Hii itakuongoza kupitia mipangilio ya kawaida ya upendeleo ili uboze tovuti yako",
// "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc" => "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc",
// "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further" => "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further",
// "Start Configuration Wizard" => "Start Configuration Wizard",
// "Or you may use the <b>Changes Wizard</b>" => "Or you may use the <b>Changes Wizard</b>",
"This will guide you through the most common new settings and informations in order to upgrade your site" => " Hii itawaongoza kupitia mipangilio na habari mpya za kawaida ili kuboresha tovuti yako",
// "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version" => "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version",
// "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels" => "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels",
// "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site" => "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site",
"Start Changes Wizard" => "Nenda kwenye Udhibiti wa Jopo",
"Use the <b>Control Panels</b> to manually browse through the full list of preferences" => " Tumia <b> Jopo la Kudhibiti </ b> ili kuvinjari kupitia orodha kamili ya mapendekezo",
// "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings" => "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings",
// "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with" => "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with",
// "Explore the control panels and configure your Tiki manually" => "Explore the control panels and configure your Tiki manually",
"Go to the Control Panels" => " Nenda kwenye Jopo la Kudhibiti",
// "You can check if your server meets the requirements for running Tiki version %0" => "You can check if your server meets the requirements for running Tiki version %0",
// "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly" => "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly",
// "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback" => "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback",
// "Check your server fitness" => "Check your server fitness",
// "Go to the Tiki Server Compatibility Check" => "Go to the Tiki Server Compatibility Check",
// "You are done with the admin wizard" => "You are done with the admin wizard",
// "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin" => "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user",
// "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were" => "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were",
// "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode" => "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode",
// "Wysiwyg editor" => "Wysiwyg editor",
// "Select the Wysiwyg editor mode" => "Select the Wysiwyg editor mode",
// "Compatible Wiki mode" => "Compatible Wiki mode",
// "Use wiki syntax for saved pages" => "Use wiki syntax for saved pages",
// "This is the most compatible with Tiki functionality and the most stable editor mode" => "This is the most compatible with Tiki functionality and the most stable editor mode",
// "Tools and functions in the editor toolbar will be limited" => "Tools and functions in the editor toolbar will be limited",
// "HTML mode" => "HTML mode",
// "Use HTML syntax for saved pages" => "Use HTML syntax for saved pages",
// "Best compatibility with inline editing" => "Best compatibility with inline editing",
// "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL" => "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL",
// "Full editor toolbar" => "Full editor toolbar",
// "Wysiwyg admin panel" => "Wysiwyg admin panel",
// "Documentation site" => "Documentation site",
// "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>" => "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>",
// "To see it in full size out of this frame" => "To see it in full size out of this frame",
// "Main new features and settings in Tiki 13" => "Main new features and settings in Tiki 13",
// "Tiki13" => "Tiki13",
// "Tiki13 is a post-LTS version" => "Tiki13 is a post-LTS version",
// "It will be supported until 14.1 is released" => "It will be supported until 14.1 is released",
// "The requirements increased (IE9, PHP 5.5)" => "The requirements increased (IE9, PHP 5.5)",
// "Major changes have happened, including moving to Bootstrap" => "Major changes have happened, including moving to Bootstrap",
// "New Themes" => "New Themes",
// "Site layouts (based on 'Bootstrap')" => "Site layouts (based on 'Bootstrap')",
// "The changes in this area were refactored in Tiki 14" => "The changes in this area were refactored in Tiki 14",
// "Goal, Recognition and Rewards" => "Goal, Recognition and Rewards",
// "Main new features and settings in Tiki 14" => "Main new features and settings in Tiki 14",
// "Tiki14" => "Tiki14",
// "Tiki14 is a standard non-LTS version" => "Tiki14 is a standard non-LTS version",
// "It will be supported until 15.1 is released" => "It will be supported until 15.1 is released",
// "The requirements are the same as in the previous version (IE9, PHP 5.5)" => "The requirements are the same as in the previous version (IE9, PHP 5.5)",
// "Minor changes have happened, compared to post-LTS versions such as Tiki13" => "Minor changes have happened, compared to post-LTS versions such as Tiki13",
// "New modules" => "New modules",
// "A new module called <strong>Module zone</strong> was added" => "A new module called <strong>Module zone</strong> was added",
// "Module zone" => "Module zone",
// "New module meant to provide a horizontal 'navigation bar' for the website" => "New module meant to provide a horizontal 'navigation bar' for the website",
// "Tiki Addons" => "Tiki Addons",
// "Addons allow a way for developers to add an even broader range of functionality" => "Addons allow a way for developers to add an even broader range of functionality",
// "Addons" => "Addons",
// "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase" => "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase",
// "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki" => "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki",
// "Other new features" => "Other new features",
// "Improved and extended features" => "Improved and extended features",
// "See the full list of changes" => "See the full list of changes",
// "Main new features and settings in Tiki 15" => "Main new features and settings in Tiki 15",
// "Tiki15" => "Tiki15",
// "Tiki15 is an LTS version" => "Tiki15 is an LTS version",
// "As it is a Long-Term Support (LTS) version, it will be supported for 5 years" => "As it is a Long-Term Support (LTS) version, it will be supported for 5 years",
// "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended" => "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended",
// "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki" => "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki",
// "In Tiki 15, an addons repository was added" => "In Tiki 15, an addons repository was added",
// "New Wiki Plugins" => "New Wiki Plugins",
// "Social Networks with Linkedin" => "Social Networks with Linkedin",
// "Temporary User Accounts" => "Temporary User Accounts",
// "Display more information here" => "Display more information here",
// "You can use this feature through: " => "You can use this feature through: ",
// "Admin Users > Temporary Users (tab)" => "Admin Users > Temporary Users (tab)",
// "Statistics Control Panel" => "Statistics Control Panel",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "Console" => "Console",
// "There is a console.php command to set a scheduled batch upload cron task" => "There is a console.php command to set a scheduled batch upload cron task",
// "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)" => "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)",
// "Removed features" => "Removed features",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Main new and improved features and settings in Tiki 16" => "Main new and improved features and settings in Tiki 16",
// "Tiki16" => "Tiki16",
// "Tiki16 is a standard non-LTS version" => "Tiki16 is a standard non-LTS version",
// "It will be supported until 17.1 is released" => "It will be supported until 17.1 is released",
// "New PHP minimum requirement for Tiki 16 is PHP 5.6" => "New PHP minimum requirement for Tiki 16 is PHP 5.6",
// "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others" => "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others",
// "Tracker Force-Fill Feature" => "Tracker Force-Fill Feature",
// "Improved Fields" => "Improved Fields",
// "Improved Plugins and extended features" => "Improved Plugins and extended features",
// "There are a few new console.php commands to set scheduled cron tasks" => "There are a few new console.php commands to set scheduled cron tasks",
// "Filtering to Index-based Plugins" => "Filtering to Index-based Plugins",
// "Filter UI added in any wiki plugin using unified search index" => "Filter UI added in any wiki plugin using unified search index",
// "PDF Settings (Control Panel > Print)" => "PDF Settings (Control Panel > Print)",
// "New method to create PDF: mPDF" => "New method to create PDF: mPDF",
// "New Profiles" => "New Profiles",
// "Bug_Tracker_16" => "Bug_Tracker_16",
// "Execute on list" => "Execute on list",
// "GeoCMS_Maps" => "GeoCMS_Maps",
// "Work_Custom_Pricing" => "Work_Custom_Pricing",
// "Main new and improved features and settings in Tiki 17" => "Main new and improved features and settings in Tiki 17",
// "Tiki17" => "Tiki17",
// "Tiki17 is a standard non-LTS version" => "Tiki17 is a standard non-LTS version",
// "It will be supported until 18.1 is released" => "It will be supported until 18.1 is released",
// "Many libraries have been upgraded" => "Many libraries have been upgraded",
// "Improved Plugins" => "Improved Plugins",
// "HTTP Header Options" => "HTTP Header Options",
// "Intrusion Detection System (IDS) with Expose" => "Intrusion Detection System (IDS) with Expose",
// "Other new or Extended Features" => "Other new or Extended Features",
// "Preferences can be set" => "Preferences can be set",
// "One system cron job can trigger all required actions at their specific scheduled times" => "One system cron job can trigger all required actions at their specific scheduled times",
// "Main new and improved features and settings in Tiki 18" => "Main new and improved features and settings in Tiki 18",
// "Tiki18" => "Tiki18",
// "This is an LTS version" => "This is an LTS version",
// "New Features" => "New Features",
// "Composer Web Install (<b>Packages</b>)" => "Composer Web Install (<b>Packages</b>)",
// "Style guide tool" => "Style guide tool",
// "Look and feel colors can be customized with a style guide tool" => "Look and feel colors can be customized with a style guide tool",
// "PDF from URL: mPDF new settings" => "PDF from URL: mPDF new settings",
// "Other Extended Features" => "Other Extended Features",
// "Real-time collaboration tools (<b>RTC</b>)" => "Real-time collaboration tools (<b>RTC</b>)",
// "New actions can be performed" => "New actions can be performed",
// "Drag and drop added to menu management" => "Drag and drop added to menu management",
"Profiles" => "Wasifu",
// "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items" => "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items",
// "Calendars and Calendar Items will now appear in search results of the unified search index" => "Calendars and Calendar Items will now appear in search results of the unified search index",
// "Certain tracker fields can be converted keeping options" => "Certain tracker fields can be converted keeping options",
// "New Fields" => "New Fields",
// "Activity_Stream" => "Activity_Stream",
// "Simple_Forum" => "Simple_Forum",
// "Timesheets_Tracker" => "Timesheets_Tracker",
// "User_Profile_Business" => "User_Profile_Business",
// "Main new and improved features and settings in Tiki 19" => "Main new and improved features and settings in Tiki 19",
// "Tiki19" => "Tiki19",
// "It is a Standard Term Support (STS) version" => "It is a Standard Term Support (STS) version",
// "It will be supported until Tiki 20.1 is released" => "It will be supported until Tiki 20.1 is released",
// "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones" => "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones",
// "Federation" => "Federation",
// "Other New Features" => "Other New Features",
// "Added a preview button in tracker field files to enable pdf view in new window without download document" => "Added a preview button in tracker field files to enable pdf view in new window without download document",
// "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item" => "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item",
// "Create tracker from File" => "Create tracker from File",
// "GanttChart" => "GanttChart",
// "Hide Fixed Top Nav Bar on Scroll 19" => "Hide Fixed Top Nav Bar on Scroll 19",
// "Scheduler_Presets" => "Scheduler_Presets",
// "And many more improvements" => "And many more improvements",
// "Main new and improved features and settings in Tiki 20" => "Main new and improved features and settings in Tiki 20",
// "Tiki20" => "Tiki20",
// "It will be supported until Tiki 21.1 is released" => "It will be supported until Tiki 21.1 is released",
// "Groupmail_20" => "Groupmail_20",
// "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability" => "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability",
// "Basic Information about Wizards" => "Basic Information about Wizards",
// "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)" => "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)",
// "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled" => "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled",
// "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site" => "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site",
// "Wizards settings" => "Wizards settings",
// "Here you can see listed other features and settings that were not included in the previous sections" => "Here you can see listed other features and settings that were not included in the previous sections",
// "Ratings in Forums" => "Ratings in Forums",
// "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user" => "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Topic Rating by each user" => "Topic Rating by each user",
// "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply" => "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply",
// "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion" => "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion",
// "Sysadmin Tasks" => "Sysadmin Tasks",
// "Search Index" => "Search Index",
// "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>" => "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>",
// "Cron Job to Rebuild Search Index" => "Cron Job to Rebuild Search Index",
// "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index" => "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index",
// "Starting in Tiki11, the syntax to rebuild the search index changed" => "Starting in Tiki11, the syntax to rebuild the search index changed",
// "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line" => "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line",
// "Console (console.php script)" => "Console (console.php script)",
"Example: Database update" => "Mfano: Update database",
// "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>" => "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>",
"Mail Queue" => "Foleni ya Barua",
"Daily Reports for User Watches" => "Ripoti za kila siku za Watumiaji wa Watumiaji",
// "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending" => "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending",
// "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished" => "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished",
// "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button" => "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button",
// "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job" => "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job",
"Example: Send the Mail Queue" => "Mfano: Tuma foleni ya Barua",
// "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups" => "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups",
// "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)" => "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)",
"Example: Send the Daily Report" => "Mfano: Tuma Ripoti ya Kila siku",
"Other Features" => "Vipengele vingine",
"New permissions and action log settings" => "Ruhusa mpya na mipangilio ya logi ya hatua",
// "Wiki Inline Editing" => "Wiki Inline Editing",
// "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4" => "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4",
"The editor can be quickly turned on/off. All processing is done client side" => "Mhariri unaweza haraka kuwezeshwa / imezima. Usindikaji wote unafanyika upande wa mteja",
// "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown" => "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown",
// "bigbluebutton" => "bigbluebutton",
// "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings" => "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings",
// "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted" => "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted",
"Switch editor" => "Badilisha mchapishaji",
// "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted" => "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted",
// "Action log settings" => "Action log settings",
"Joined Room" => " Chumba cha Kuunganishwa",
"Left Room" => "Chumba cha kushoto",
// "You are reaching the end of the <em>Changes Wizard</em>" => "You are reaching the end of the <em>Changes Wizard</em>",
// "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least" => "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least",
// "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community" => "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community",
// "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above" => "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above",
// "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}" => "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}",
"Connect" => "Unganisha",
"Site title is required" => "Jina la tovuti linahitajika",
// "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki" => "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki",
// "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site" => "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site",
// "Tracker Field Types" => "Tracker Field Types",
// "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>" => "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>",
// "Former ways to manage ratings in trackers are <b>deprecated</b>" => "Former ways to manage ratings in trackers are <b>deprecated</b>",
// "Deprecated Rating Systems in Trackers" => "Deprecated Rating Systems in Trackers",
// "Tracker field types" => "Tracker field types",
// "edit Tracker" => "edit Tracker",
"Other options to be set elsewhere" => "Chaguzi nyingine za kufafanua mahali pengine",
// "Add a <em>User and Registration tracker</em>" => "Add a <em>User and Registration tracker</em>",
// "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins" => "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins",
"You can set it in" => "Unaweza kufafanua mu",
// "tracker edition" => "tracker edition",
// "Some User Interface (UI) improvements which usually come disabled in new Tiki installations" => "Some User Interface (UI) improvements which usually come disabled in new Tiki installations",
// "They are proven to be useful enhancements in some production environments" => "They are proven to be useful enhancements in some production environments",
// "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try" => "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try",
"Icons and Profile Pictures" => "Ikoni na picha za wasifu",
"Text Areas" => "Masanduku ya maandishi",
"You are done with the Changes Wizard" => "Umefanya na mchawi wa kuboresha",
// "You are done with the Configuration Profiles Wizard" => "You are done with the Configuration Profiles Wizard",
// "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site" => "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences",
// "Some profiles were created for use cases of project management" => "Some profiles were created for use cases of project management",
// "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly" => "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly",
// "It creates" => "It creates",
// "a sample tracker that will hold the tasks" => "a sample tracker that will hold the tasks",
// "a sample wiki page linked to that tracker to display the tasks" => "a sample wiki page linked to that tracker to display the tasks",
// "Some demo data to help you get started" => "Some demo data to help you get started",
// "Click to expand" => "Click to expand",
// "Work custom pricing" => "Work custom pricing",
// "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one" => "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one",
// "Work Custom Pricing" => "Work Custom Pricing",
// "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile" => "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile",
// "Wildcard items" => "Wildcard items",
// "This profile adds a way to provide reusable items in a tracker coming from another one working as templates" => "This profile adds a way to provide reusable items in a tracker coming from another one working as templates",
// "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are" => "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are",
// "A couple of trackers. One for current items, and another one for the reusable items working ass templates" => "A couple of trackers. One for current items, and another one for the reusable items working ass templates",
// "A few wiki pages to list, view and edit items" => "A few wiki pages to list, view and edit items",
// "Some example items in both trackers to help you get started" => "Some example items in both trackers to help you get started",
// "Check out some commonly used configurations in Tiki sites" => "Check out some commonly used configurations in Tiki sites",
// "User & Registration Tracker" => "User & Registration Tracker",
// "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users" => "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users",
// "It includes" => "It includes",
// "A long list of predefined usual fields, to choose from" => "A long list of predefined usual fields, to choose from",
// "Some fields already prepared to display custom information from your specific site" => "Some fields already prepared to display custom information from your specific site",
// "The chance to easily customize it with the power of Trackers" => "The chance to easily customize it with the power of Trackers",
// "Custom Contact Form" => "Custom Contact Form",
// "This profile eases the task to create a custom contact form adapted to the specific case of that site" => "This profile eases the task to create a custom contact form adapted to the specific case of that site",
// "More details" => "More details",
// "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point" => "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point",
// "New fields can be added asking questions specific for the site" => "New fields can be added asking questions specific for the site",
// "You decide where and when to display the link to the contact us form in your Tiki menus and pages" => "You decide where and when to display the link to the contact us form in your Tiki menus and pages",
// "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields" => "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields",
// "Useful for Geographic data (State, Country/Province, ...)" => "Useful for Geographic data (State, Country/Province, ...)",
// "Useful for Types and Subtypes" => "Useful for Types and Subtypes",
// "Useful for Program Names and Versions" => "Useful for Program Names and Versions",
// "Easily manage the options in the second tracker without editing the dropdown in the first tracker" => "Easily manage the options in the second tracker without editing the dropdown in the first tracker",
// "Sortable Tables" => "Sortable Tables",
// "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature" => "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature",
// "Useful to sort and filter data in real time" => "Useful to sort and filter data in real time",
// "Same approach for FancyTable and TrackerList Plugins" => "Same approach for FancyTable and TrackerList Plugins",
// "Sorting can be server-side or client-side based " => "Sorting can be server-side or client-side based ",
// "Some profiles are highly customized for very specialized use cases, and they are listed in this special category" => "Some profiles are highly customized for very specialized use cases, and they are listed in this special category",
// "Demo Profiles" => "Demo Profiles",
// "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site" => "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site",
// "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on" => "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on",
// "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected" => "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected",
// "See details in the instructions page shown in your site once each profile is applied" => "See details in the instructions page shown in your site once each profile is applied",
// "CartoGraf" => "CartoGraf",
// "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools" => "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools",
// "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application" => "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application",
// "This profile is using Tiki as Framework, with these details" => "This profile is using Tiki as Framework, with these details",
// "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers" => "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers",
// "It uses its own Cartograf style (downloaded aside)" => "It uses its own Cartograf style (downloaded aside)",
// "It allows custom markers for maps (placed in a file gallery)" => "It allows custom markers for maps (placed in a file gallery)",
// "It is used in production at http://cartograf.recitus.qc.ca (in French)" => "It is used in production at http://cartograf.recitus.qc.ca (in French)",
// "R demo" => "R demo",
// "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages" => "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages",
// "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)" => "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)",
// "The profile creates many demo pages, which comprise" => "The profile creates many demo pages, which comprise",
// "Simple R syntax in wiki pages to produce interactive charts" => "Simple R syntax in wiki pages to produce interactive charts",
// "Advanced usage to create full GUI for an R application" => "Advanced usage to create full GUI for an R application",
// "Many other examples of nice charts and reports that you can produce with this system" => "Many other examples of nice charts and reports that you can produce with this system",
// "r.tiki.org site" => "r.tiki.org site",
// "r.tiki.org live site" => "r.tiki.org live site",
// "GeoCMS Maps" => "GeoCMS Maps",
// "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps" => "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps",
// "R Heatmaps" => "R Heatmaps",
// "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)" => "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)",
// "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)" => "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)",
// "This profile creates" => "This profile creates",
// "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you" => "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you",
// "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets" => "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets",
// "Example input files and default values provided as a happy path to produce your first Heatmaps" => "Example input files and default values provided as a happy path to produce your first Heatmaps",
// "Plugin R" => "Plugin R",
// "Plugin R in doc.tiki.org" => "Plugin R in doc.tiki.org",
// "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example" => "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example",
// "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real" => "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real",
// "Bug Tracker" => "Bug Tracker",
// "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below" => "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below",
// "Uses PluginTracker in a wiki page to add items" => "Uses PluginTracker in a wiki page to add items",
// "Create some custom feedback for message to the user after item insertion" => "Create some custom feedback for message to the user after item insertion",
// "Uses PluginTrackerList to display inserted items" => "Uses PluginTrackerList to display inserted items",
// "Timesheet" => "Timesheet",
// "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names" => "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names",
// "Allows to track your time spent on projects" => "Allows to track your time spent on projects",
// "Customize your project categories" => "Customize your project categories",
// "Add or edit your timesheet fields as desired" => "Add or edit your timesheet fields as desired",
// "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker" => "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker",
// "Plugin Timesheet" => "Plugin Timesheet",
// "Plugin Timesheet in doc.tiki.org" => "Plugin Timesheet in doc.tiki.org",
// "Tracker as Calendar" => "Tracker as Calendar",
// "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way" => "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way",
// "Advanced use of Plugin TrackerList" => "Advanced use of Plugin TrackerList",
// "Working example of Plugin TrackerCalendar" => "Working example of Plugin TrackerCalendar",
// "Drag & Drop to resize or move events" => "Drag & Drop to resize or move events",
// "Several display modes, useful for Project & Resource Management" => "Several display modes, useful for Project & Resource Management",
// "Voting System" => "Voting System",
// "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote" => "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote",
// "Group homepage set for the voting group" => "Group homepage set for the voting group",
// "Only one vote per member is allowed" => "Only one vote per member is allowed",
// "Results shown in real time (Plugin TrackerStat)" => "Results shown in real time (Plugin TrackerStat)",
// "Other candidates can be voted beyond the proposed" => "Other candidates can be voted beyond the proposed",
// "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site" => "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site",
// "Shopping Cart" => "Shopping Cart",
// "This profile provides a Shopping Cart and the corresponding basic payment system" => "This profile provides a Shopping Cart and the corresponding basic payment system",
// "It currently uses the PayPal shopping cart rather than the built in Tiki" => "It currently uses the PayPal shopping cart rather than the built in Tiki",
// "A tracker for products including price, weight, image and stock quantity" => "A tracker for products including price, weight, image and stock quantity",
// "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users" => "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users",
// "A small category subtree to classify products" => "A small category subtree to classify products",
// "Wiki pages to display the available products list, one product details page and a search form" => "Wiki pages to display the available products list, one product details page and a search form",
// "Easy GeoBlog" => "Easy GeoBlog",
// "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features" => "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features",
// "Single map with all geolocated blog posts" => "Single map with all geolocated blog posts",
// "Different home page once the user logs in" => "Different home page once the user logs in",
// "Random header image from files included in a file gallery" => "Random header image from files included in a file gallery",
// "WYSIWYG Editor (compatible mode with wiki syntax)" => "WYSIWYG Editor (compatible mode with wiki syntax)",
// "Wiki, Search, Menu & Tags" => "Wiki, Search, Menu & Tags",
// "Comments moderation & Banning (for anonymous comments to your site)" => "Comments moderation & Banning (for anonymous comments to your site)",
// "Profile Conditional_Display_in_Forms" => "Profile Conditional_Display_in_Forms",
// "This profile demonstrates the setup to conditionally hide or display some fields in a form" => "This profile demonstrates the setup to conditionally hide or display some fields in a form",
// "Conditional_Display_in_Forms" => "Conditional_Display_in_Forms",
// "Main features used" => "Main features used",
// "Plugin JQ (jQuery)" => "Plugin JQ (jQuery)",
// "Plugin TrackerIf" => "Plugin TrackerIf",
// "Profile Execute_on_list" => "Profile Execute_on_list",
// "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute" => "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute",
// "Plugin ListExecute" => "Plugin ListExecute",
// "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes" => "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes",
// "Structured Master Documents" => "Structured Master Documents",
// "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more" => "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more",
// "Many pages are pre-created to let you easily set up several wiki structures" => "Many pages are pre-created to let you easily set up several wiki structures",
// "A common navigation menu is created and shown at the top of pages in the structure" => "A common navigation menu is created and shown at the top of pages in the structure",
// "You can easily print (export) them all together in a single html" => "You can easily print (export) them all together in a single html",
// "Permissions or Monitoring can be applied in bulk to the whole structure or substructures" => "Permissions or Monitoring can be applied in bulk to the whole structure or substructures",
// "Consensus Forums" => "Consensus Forums",
// "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held" => "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held",
// "Users ratings in Forums" => "Users ratings in Forums",
// "Topics with less agreement can be easily identified from the topic list" => "Topics with less agreement can be easily identified from the topic list",
// "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus" => "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus",
// "Replies can also be rated, but without affecting the topic rating average" => "Replies can also be rated, but without affecting the topic rating average",
// "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile" => "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile",
// "Barter Market" => "Barter Market",
// "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge" => "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge",
// "minimal number of fields in these trackers, which can be extended" => "minimal number of fields in these trackers, which can be extended",
// "tracker items are categorized" => "tracker items are categorized",
// "a few modules added, including a wiki page menu" => "a few modules added, including a wiki page menu",
// "best display if using just one column (right, for instance)" => "best display if using just one column (right, for instance)",
// "Revision Approval (ISO9001)" => "Revision Approval (ISO9001)",
// "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)" => "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)",
// "Additions: 1 group, 2 users, 2 wiki pages, 3 categories" => "Additions: 1 group, 2 users, 2 wiki pages, 3 categories",
// "Revision approval is set for homepage and 'official document'" => "Revision approval is set for homepage and 'official document'",
// "Wiki Argument Variables are used in the 'official document'" => "Wiki Argument Variables are used in the 'official document'",
// "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles" => "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles",
// "Collaborative Community" => "Collaborative Community",
// "Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Setup to help subject experts and enthusiasts work together to build a Knowledge Base",
// "Uses" => "Uses",
// "Wiki Editing" => "Wiki Editing",
// "Personal Member Spaces" => "Personal Member Spaces",
// "Company Intranet" => "Company Intranet",
// "Setup for a Corporate Intranet of a typical medium-sized business" => "Setup for a Corporate Intranet of a typical medium-sized business",
// "Company News Articles" => "Company News Articles",
// "Executive Blog" => "Executive Blog",
// "File Repository & Management" => "File Repository & Management",
"Collaborative Wiki" => "Wiki Ushirikiano",
// "Personal Blog and Profile" => "Personal Blog and Profile",
// "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere",
"Blog (Full set of blog related features)" => "Blog (Seti kamili ya makala zinazohusiana na blogu)",
// "RSS Integration" => "RSS Integration",
// "Video Log" => "Video Log",
// "Small Organization Web Presence" => "Small Organization Web Presence",
// "Setup for a Web Presence of a typical small business or non-profit" => "Setup for a Web Presence of a typical small business or non-profit",
// "Company News & Updates" => "Company News & Updates",
// "Highlight Company's Products and Services" => "Highlight Company's Products and Services",
// "File Gallery (great for Media Kit)" => "File Gallery (great for Media Kit)",
// "Contact Form" => "Contact Form",
// "Profiles admin card" => "Profiles admin card",
// "Check out some useful changes in the configuration for site administrators" => "Check out some useful changes in the configuration for site administrators",
// "Debug Mode Enabled" => "Debug Mode Enabled",
// "Debug Mode Disabled" => "Debug Mode Disabled",
// "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise" => "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise",
// "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand" => "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand",
// "Enables/Disables debugging tools" => "Enables/Disables debugging tools",
// "Enables/Disables logging tools" => "Enables/Disables logging tools",
// "Disables/Enables redirections to similar pages" => "Disables/Enables redirections to similar pages",
// "Enables/Disables error and warning display to all users, not only admins" => "Enables/Disables error and warning display to all users, not only admins",
// "This configuration profile enables the Scheduler feature and loads a preset of schedulers" => "This configuration profile enables the Scheduler feature and loads a preset of schedulers",
// "Each scheduler can replace a former cron job action in the server" => "Each scheduler can replace a former cron job action in the server",
// "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need" => "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need",
// "This configuration profile showcases the activity stream feature in Tiki" => "This configuration profile showcases the activity stream feature in Tiki",
// "Activity Stream data can also be reviewed through PluginPivotTable" => "Activity Stream data can also be reviewed through PluginPivotTable",
// "It is somewhat similar to the basic Action log feature in Tiki" => "It is somewhat similar to the basic Action log feature in Tiki",
// "Check out some useful profiles that involve changing the display mode of content in your site" => "Check out some useful profiles that involve changing the display mode of content in your site",
// "Slideshow demo" => "Slideshow demo",
// "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works" => "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works",
// "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper" => "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper",
// "Headers of different levels are used as markers of 'new slide' and used as titles" => "Headers of different levels are used as markers of 'new slide' and used as titles",
// "Many settings can be predefined as parameters of a call to PluginSlideshow" => "Many settings can be predefined as parameters of a call to PluginSlideshow",
// "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to" => "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to",
// "Hide Fixed Top Navigation Bar on scroll" => "Hide Fixed Top Navigation Bar on scroll",
// "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards" => "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards",
// "Hide Fixed Top Navi Bar on Scroll" => "Hide Fixed Top Navi Bar on Scroll",
// "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'" => "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'",
// "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice" => "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice",
// "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky" => "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky",
// "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus" => "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus",
// "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration" => "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration",
// "Menu on Wiki page" => "Menu on Wiki page",
// "This profile sets up a side module with a menu based on a wiki page in the right hand-side column" => "This profile sets up a side module with a menu based on a wiki page in the right hand-side column",
// "With this profile you can" => "With this profile you can",
// "use wiki syntax to edit it" => "use wiki syntax to edit it",
// "delegate its edition with wiki page permissions" => "delegate its edition with wiki page permissions",
// "use plugins to manage conditional display of sections" => "use plugins to manage conditional display of sections",
// "Random header images" => "Random header images",
// "This profile adds a module in the top zone that displays a random image from a File Gallery" => "This profile adds a module in the top zone that displays a random image from a File Gallery",
// "Some sample images to fit the default configuration are also provided as a starting point" => "Some sample images to fit the default configuration are also provided as a starting point",
// "default configuration uses images at 800x150px resized by the top module parameters to match the header default size" => "default configuration uses images at 800x150px resized by the top module parameters to match the header default size",
// "a different random image is shown at each page load" => "a different random image is shown at each page load",
// "elFinder modern file galery manager (with drag & drop capabilities!) is used by default" => "elFinder modern file galery manager (with drag & drop capabilities!) is used by default",
// "you can tweak the module and file gallery defaults as needed for your needs" => "you can tweak the module and file gallery defaults as needed for your needs",
// "Multilingual Wiki" => "Multilingual Wiki",
// "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion" => "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion",
// "The enabled features comprise" => "The enabled features comprise",
// "Multilingual freetags" => "Multilingual freetags",
// "Countries By Region" => "Countries By Region",
// "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions" => "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions",
// "The regions listed with their countries are" => "The regions listed with their countries are",
// "Saharan, Sub-Saharan Africa" => "Saharan, Sub-Saharan Africa",
// "Middle East, North Africa" => "Middle East, North Africa",
// "Asia" => "Asia",
// "North, Central America" => "North, Central America",
// "Oceania" => "Oceania",
// "South America" => "South America",
// "Check out this set of useful configurations that involve using some new technology for your site" => "Check out this set of useful configurations that involve using some new technology for your site",
// "Write Together" => "Write Together",
// "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS" => "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS",
// "Allows cowriting documents in real time" => "Allows cowriting documents in real time",
// "Allows voice communication in real time while editing" => "Allows voice communication in real time while editing",
// "Uses the TogetherJS Mozilla widget" => "Uses the TogetherJS Mozilla widget",
// "Post-it Sticky Note" => "Post-it Sticky Note",
// "This profile allows to display a sticky note (a \"post-it\") in your tiki site" => "This profile allows to display a sticky note (a \"post-it\") in your tiki site",
// "You can move it to another location" => "You can move it to another location",
// "You can customize the contents and which groups of users will see it (by default, only to Admins)" => "You can customize the contents and which groups of users will see it (by default, only to Admins)",
// "It will be shown for each user of that group until manually closed" => "It will be shown for each user of that group until manually closed",
// "Groupmail" => "Groupmail",
// "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages" => "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages",
// "A tracker for email messages received and store addresses in the Contacts feature" => "A tracker for email messages received and store addresses in the Contacts feature",
// "Webmail configuration to use an account for groupmail" => "Webmail configuration to use an account for groupmail",
// "A side module with markers to indicate who took which message" => "A side module with markers to indicate who took which message",
// "A system to review communication logs from that group mail account" => "A system to review communication logs from that group mail account",
// "Profile X" => "Profile X",
// "This profile allows to " => "This profile allows to ",
// "Feature_X in doc.tiki.org" => "Feature_X in doc.tiki.org",
// "User Dummy" => "User Dummy",
// "This is a dummy page" => "This is a dummy page",
"Set up basic information as a user on this site" => "Weka habari ya msingi kama mtumiaji kwenye tovuti hii",
"Your personal Wiki Page" => "Votre page personnelle Wiki",
"The feature 'User Preferences' is currently disabled in this site" => "Kipengele cha 'Mapendeleo ya Watumiaji' sasa walemavu kwenye tovuti hii.",
"Enable the feature" => "Wezesha kipengele",
"Enable it" => "Wezesha iyo",
"You might ask your site admin to enable it" => "Unaweza kuuliza msimamizi yako tovuti ili kuiwezesha",
"Use 'watches' to monitor wiki pages or other objects" => "Matumizi 'saa ' kufuatilia kurasa za wiki au vitu vingine",
// "Set up below preferences related to receiving notifications by email about changes in the site" => "Set up below preferences related to receiving notifications by email about changes in the site",
// "The feature user watches is disabled in this site" => "The feature user watches is disabled in this site",
"Set up the general settings for your account" => "Sanidi mipangilio ya jumla ya akaunti yako",
"User Params" => "Mtumiaji vigezo",
"Is email public? (uses scrambling to prevent spam)" => "Anwani ya barua pepe ya kinyang'anyiro ili kuzuia spam",
"Does your email application need a special character set" => "Je! Msomaji wa ujumbe wako anahitaji encoding ya tabia maalum",
"Preferred language" => "Lugha iliyopendekezwa",
// "Site time zone is enforced and overrides user preferences" => "Site time zone is enforced and overrides user preferences",
"The feature with the user preferences screen is disabled in this site" => "Kipengele la skrini ya upendeleo wa mtumiaji imezimwa kwenye tovuti hii",
"You are not allowed to remove this notification " => "Huna haki ya kuondoa taarifa hii",
"Interval in which you want to get the reports" => "Upepo wa ripoti",
"HTML-Email" => "Barua pepe-HTML",
"Send me an email also if nothing happened" => "Tuma barua pepe hata kama hakuwa na mabadiliko",
"The feature daily reports of user watches is disabled in this site" => "Vipengele kila siku taarifa la saa ya watumiaji linafungwa katika tovuti hii",
"Use this form to fill in some extra information about you" => "Tumia fomu hii ili ujaze maelezo ya ziada kuhusu wewe",
"Extra information about you" => "Maelezo ya ziada kuhusu wewe",
"Tiki User Wizard" => "Tiki mtumiaji mchawi",
"This wizard will help you fill in data and main settings for your account on this website" => "Msaidizi huu atakusaidia kujaza data na mipangilio kuu ya akaunti yako kwenye tovuti hii",
"Depending on the features enabled by the site admin, you will be offered more or less options" => "Kulingana na vipengele vinavyowezeshwa na msimamizi wa tovuti,  utatolewa chaguo zaidi au chini",
"If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature" => "Ikiwa huwezi kusanidi mapendekezo ya mtumiaji wako (Jina halisi, kuweka maelezo yako ya umma au ya faragha, mipangilio ya wakati, ...), unaweza kuuliza msimamizi wa tovuti ili kuwezesha kipengele cha mapendekezo ya mtumiaji",
"Click at the \"Start\" button above to launch it" => "Bofya kwenye kifungo cha \"Anza\" hapo juu ili kuifungua",
// "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>" => "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>",
"You are done with the user wizard" => "Umefanya na mchawi wa mtumiaji",
"Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences" => "Tembelea ukurasa kamili <a href=\"%0\"> Mapendeleo ya Mtumiaji </a> ili kuweka mapendeleo ya mtumiaji wako",
"Or.." => "Au..",
"Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were" => "Bofya kwenye kifungo <strong> Kumaliza </strong> ili kumaliza msaidizi wa mtumiaji na kurudi mahali ulipo",
// "Show on admin log-in" => "Show on admin log-in",
// "Finish" => "Finish",
// "Start the Wizardry" => "Start the Wizardry",
"Save and Continue" => "Hifadhi na Endelea",
"No turning back" => "Hakuna kurudi nyuma",
"Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available" => "Mara baada ya kubadili mfano wako kwa Hali ya juu, huwezi kurudi nyuma. Interface rahisi haitapatikana tena",
"Return to simple interface" => "Rudi kwenye interface rahisi",
"Workspace Name" => "Jina la nafasi ya kazi",
"Wiki Page Source" => "Wiki Ukurasa wa Chanzo",
"Not enough options" => "Sio chaguzi za kutosha",
// "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power" => "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power",
// "Advanced Mode" => "Advanced Mode",
// "Bind area" => "Bind area",
"Is managing group" => "ni kusimamia kikundi",
"Workspace creator joins this group" => "Muumba wa nafasi ya kazi anajiunga na kikundi hiki",
"Add group" => "Ongeza kikundi",
"Select Permissions" => "Chagua Ruhusa",
"Edit content template" => "Badilisha kiolezo ya maudhui",
"Add page" => "Ongeza ukurasa",
"Default (Font-awesome)" => "Chaguo-msingi(Font-awesome)",
// "The default system icon set using Font-awesome fonts" => "The default system icon set using Font-awesome fonts",
// "Solid" => "Solid",
// "Outline" => "Outline",
// "Font Awesome Regular" => "Font Awesome Regular",
// "Font Awesome Pro Only" => "Font Awesome Pro Only",
// "Brands" => "Brands",
// "Legacy (pre Tiki14) icons" => "Legacy (pre Tiki14) icons",
// "Legacy (pre Tiki14) icons, mainly using famfamfam images" => "Legacy (pre Tiki14) icons, mainly using famfamfam images",
"Custom icons" => "icons desturi",
"Custom icons for the theme" => "Icons desturi kwa mandhari",
"Theme icons" => "Icons za mandhari",
"Icons to be used for this theme" => "Icons ya kutumia kwa mada hii",
"This field is manadatory" => "Shamba hili ni la lazima",
"Design by" => "Iliyoundwa na",
"Missing book id" => "kukosa kitabu id",
"You do not have the right view this page" => "Huruhusiwi kuona ukurasa huu",
// "%0 account in book %1 modified" => "%0 account in book %1 modified",
// "%0 account created for book %1" => "%0 account created for book %1",
// "Account %0 in book %1 unlocked" => "Account %0 in book %1 unlocked",
// "Account %0 in book %1 not unlocked" => "Account %0 in book %1 not unlocked",
// "Account %0 in book %1 locked" => "Account %0 in book %1 locked",
// "Account %0 in book %1 not locked" => "Account %0 in book %1 not locked",
// "Delete account %0 from book %1" => "Delete account %0 from book %1",
// "%0 account deleted from book %1" => "%0 account deleted from book %1",
"Missing account id" => "kukosa id akaunti",
"You do not have the rights to view this account" => "Huna haki za kutazama akaunti hii",
"You do not have the rights to manage accounts" => "Huna haki za kusimamia akaunti",
// "You do not have permission to create a book" => "You do not have permission to create a book",
// "Book %0 successfully created" => "Book %0 successfully created",
// "You do not have permission to close this book" => "You do not have permission to close this book",
// "Close book (this action cannot be undone)" => "Close book (this action cannot be undone)",
// "Book successfully closed" => "Book successfully closed",
// "The attempt to close the book was unsuccessful" => "The attempt to close the book was unsuccessful",
// "Cancel journal %0 in book %1" => "Cancel journal %0 in book %1",
// "Journal shown below successfully canceled" => "Journal shown below successfully canceled",
"Missing journal id" => "kukosa jarida id ",
"You do not have the right to cancel transactions" => "Huna haki ya kufuta shughuli",
"Error retrieving data from journal" => "Hitilafu ya kutafuta data kutoka kwa logi",
"You do not have the right to book" => "Huna haki ya kurekodi shughuli",
// "Record entry in book %0" => "Record entry in book %0",
// "Journal %0 successfully recorded in book %1" => "Journal %0 successfully recorded in book %1",
"Don't know what to export" => "Hajui nini cha kuuza nje",
"You do not have the right export/view this data" => "Huna haki ya kuuza nje / kuona data hii",
"You do not have the right to book into the stack" => "Huruhusiwi kurekodi shughuli katika ukungu",
// "Record stack entry in book %0" => "Record stack entry in book %0",
// "Modify stack entry in book %0" => "Modify stack entry in book %0",
// "Delete stack %0 from book %1" => "Delete stack %0 from book %1",
// "Confirm stack %0 for book %0" => "Confirm stack %0 for book %0",
// "Stack %0 successfully modified in book %1" => "Stack %0 successfully modified in book %1",
// "Stack %0 successfully deleted from book %1" => "Stack %0 successfully deleted from book %1",
// "Stack %0 recorded in book %1" => "Stack %0 recorded in book %1",
// "Stack %0 deleted from book %1" => "Stack %0 deleted from book %1",
// "Stack %0 confirmed and recorded as entry in book %1" => "Stack %0 confirmed and recorded as entry in book %1",
"Tiki Calendar" => "Calendrier Tiki",
"%0 enabled" => "%0 ulioamilishwa",
"%0 disabled" => "%0 désactivée",
"%0 set" => "%0 réglé",
"%0 unset" => "%0 non-réglé",
// "item added" => "item added",
// "items added" => "items added",
// "item deleted" => "item deleted",
// "items deleted" => "items deleted",
"Help on Configuration Sections" => "Msaada kwenye Sehemu za Upangiaji",
// "Default preference filters set" => "Default preference filters set",
// "%0 reset" => "%0 reset",
"Search error" => "Kosa la utafutaji",
"Global site configuration, date formats, etc." => "Usanidi wa tovuti kwa jumla, muundo wa tarehe, ...",
"Switches for major features" => "Utekelezaji wa vipengele vikuu",
"User registration, remember me cookie settings and authentication methods" => "Usajili wa mtumiaji, unakumbuka mipangilio ya cookie na mbinu za uthibitisho",
"User related preferences like info and picture, features, messages and notification, files, etc" => "Mapendekezo yanayohusiana na mtumiaji kama habari na picha, vipengele, ujumbe na taarifa, faili, nk",
"Repository configuration, browse and apply profiles" => "Usanidi ya hifadhi, kuvinjari na kutumia maelezo",
"Look & Feel" => "Mandhari & Uonekanaji",
"Theme selection, layout settings and UI effect controls" => "Uchaguzi wa mandhari, mipangilio ya mpangilio na udhibiti wa athari za UI",
"Editing and Plugins" => "Uhariri na Plugins",
"Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Mipangilio ya uhariri wa maandishi inayotumika kwa maeneo mengi. Utekelezaji wa Plugin na usimamizi wa viungo vya programu",
"Module appearance settings" => "Mipangilio ya mwonekano ya Moduli",
"i18n" => "i18n",
"Internationalization and localization - multilingual features" => "Ujisishaji na ujanibishaji - vipengele vya lugha nyingi",
"Meta Tags" => "Lebo za Meta",
"Information to include in the header of each page" => "Taarifa ya kujumuisha katika kichwa cha kila ukurasa",
"Maps" => "Ramani",
"Settings and features for maps" => "Mipangilio na vipengee vya ramani",
"Server performance settings" => "Mipangilio ya seva ya utendaji",
"Site security settings" => "Vipimo vya usalama wa tovuti",
"Outgoing RSS feed setup" => "Mapangilio yanayomalizwa muda na RSS feeds",
"Tiki Connect - join in!" => "Tiki Connect - Jiunge!",
// "Rating settings" => "Rating settings",
"Search configuration" => "Usanidi wa utafutaji",
"Wiki page settings and features" => "Usanidi na vipengele ya kurasa za Wiki",
"Defaults and configuration for file galleries" => "Chaguo-msingi na Usanidi wa nyumba za faili",
"Settings for blogs" => "Mipangilio ya blogu",
"Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Chaguo-msingi na usanidi wa nyumba za picha (zitasimamishwa kwa neema ya nyumba za faili)",
"Settings and features for articles" => "Mipangilio na vipengele vya makala",
"Settings and features for forums" => "Mipangilio na vipengele vya Mabaraza",
"Settings and features for trackers" => "Mipangilio na vipengele vya trackers",
"Settings and features for polls" => "Mipangilio na vipengele vya Uchaguzi",
"Settings and features for calendars" => "Mipangilio na vipengele vya kalenda",
"Settings and features for categories" => "Mipangilio na vipengele vya makundi",
// "Configure workspace feature" => "Configure workspace feature",
"Values of actions for users rank score" => "Thamani ya matendo kwa watumiaji cheo alama",
"Settings and features for tags" => "Mipangilio na vipengele vya vitambulisho",
"Settings and features for FAQs" => "Mipangilio na vipengele vya Maswali yanayoulizwa sana (FAQs)",
"Settings and features for directory of links" => "Mipangilio na vipengele vya directory ya viungo",
"Site-wide copyright information" => "Maelezo ya hakimiliki ya tovuti",
"Message settings" => "Mipangilio ya ujumbe",
// "Webmail settings" => "Webmail settings",
"Options for WYSIWYG editor" => "Machaguo ya Kihariri cha WYSIWYG",
// "Site advertisements and notices" => "Site advertisements and notices",
"InterTiki" => "InterTiki",
"Set up links between Tiki servers" => "Sanidi viungo kati ya seva za Tiki",
"Manage semantic wiki links" => "Dhibiti viungo vya wiki",
"Register and manage web services" => "Jisajili na udhibiti huduma za wavuti",
// "SEF URL" => "SEF URL",
"Video integration configuration" => "Usanidi wa ushirikiano wa video",
// "Payment settings" => "Payment settings",
"Configure social networks integration" => "Sanidi mitandao ya ushirikiano wa kijamii",
"User specific features and settings" => "Vipengele maalum na mipangilio ya mtumiaji",
"Configure share feature" => "Sanidi kipengele cha kushiriki",
"Configure statistics reporting for your site usage" => "Sanidi ripoti za takwimu kwa matumizi ya tovuti yako",
"Print Settings" => "Mipangilio ya Magazeti",
"Settings and features for print versions and pdf generation" => "Mipangilio na vipengele vya matoleo ya magazeti na kizazi cha pdf",
"External packages installation and management" => "Ufungashaji wa nje na usimamizi wa nje",
// "RTC" => "RTC",
"Real-time collaboration tools" => "Vifaa vya kushirikiana wakati halisi",
"Help on %0 Config" => "Msaada kwenye Configuration %0",
// "Remove selected actions" => "Remove selected actions",
// "The selected action has been deleted from the log" => "The selected action has been deleted from the log",
// "%0 actions have been deleted from the log" => "%0 actions have been deleted from the log",
// "No actions were deleted from the log" => "No actions were deleted from the log",
"Must specify actionId" => "Lazima kutaja actionId",
"Users Contributions: Addition" => "Mchango wa Watumiaji: Kuongeza",
"%s Contributions: Addition" => "Michango ya %s: Kuongeza",
"Users Contributions: Suppression" => "Mchango wa Watumiaji: Kuondoa",
"%s Contributions: Suppression" => "Michango ya %s: Kuondoa",
"Total Contributions Addition per Day" => "Mchango wa Jumla ya Kuongeza kwa Siku",
"Total Contributions Addition per Week" => "Mchango wa Jumla ya Kuongeza kwa wiki",
"Total Contributions Suppression per Day" => "Mchango wa Jumla ya Kuondoa kwa Siku",
"Total Contributions Suppression per Week" => "Mchango wa Jumla ya Kuondoa kwa wiki",
"Total Contributions: Addition" => "Mchango wa Jumla: Kuongeza",
"Total Contributions: Suppression" => "Mchango wa Jumla: Kuondoa",
"Groups Contributions: Addition" => "Michango ya Vikundi: Kuongeza",
"Groups Contributions: Suppression" => "Michango ya Vikundi: Kuondoa",
"white" => "nyeupe",
"gray" => "kijivu",
"silver" => "fedha",
"ivory" => "pembe",
"whitesmoke" => "nyeupe (nyeusi ndogo)",
"beige" => "rangi ya mchanga",
"darkgrey" => "kijivu giza",
// "No rule selected for deletion. No deletions were performed" => "No rule selected for deletion. No deletions were performed",
// "The selected banning rule has been deleted" => "The selected banning rule has been deleted",
// "%0 banning rules have been deleted" => "%0 banning rules have been deleted",
// "The following banning rule has been saved or replaced" => "The following banning rule has been saved or replaced",
// "The following %0 banning rules have been saved or replaced" => "The following %0 banning rules have been saved or replaced",
// "No changes were made to the following selected banning rules" => "No changes were made to the following selected banning rules",
// "Only %0 of the selected banning rules shown below were added or changed" => "Only %0 of the selected banning rules shown below were added or changed",
// "No banning rules were selected" => "No banning rules were selected",
// "Multiple IP Banning" => "Multiple IP Banning",
"Access from your localization was forbidden due to excessive spamming" => "Ufikivu kutoka kwa ujanibishaji wako kuwa ilikuwa marufuku kutokana na kupita kiasi unatuma barua taka",
// "Not saved" => "Not saved",
// "Username pattern empty" => "Username pattern empty",
// "Default IP pattern still set" => "Default IP pattern still set",
// "Calendar %0 deleted" => "Calendar %0 deleted",
// "Calendar %0 not deleted" => "Calendar %0 not deleted",
// "One calendar event deleted" => "One calendar event deleted",
// "No calendar events deleted" => "No calendar events deleted",
// "%0 calendar events deleted" => "%0 calendar events deleted",
// "No such category with parentID %0" => "No such category with parentID %0",
// "One object unassigned from category" => "One object unassigned from category",
// "%0 objects unassigned from category" => "%0 objects unassigned from category",
// "No objects unassigned" => "No objects unassigned",
// "Incorrect category ID %0 - objects not moved" => "Incorrect category ID %0 - objects not moved",
// "One object moved to selected category" => "One object moved to selected category",
// "%0 objects moved to selected category" => "%0 objects moved to selected category",
// "No objects moved" => "No objects moved",
// "Incorrect category ID %0 - objects not copied" => "Incorrect category ID %0 - objects not copied",
// "One object copied to selected category" => "One object copied to selected category",
// "%0 objects copied to selected category" => "%0 objects copied to selected category",
// "No objects copied" => "No objects copied",
// "One page added to category" => "One page added to category",
// "%0 pages added to category" => "%0 pages added to category",
// "No pages added to category" => "No pages added to category",
// "%0 %1 removed from category %2" => "%0 %1 removed from category %2",
// "%0 %1 not removed from category %2" => "%0 %1 not removed from category %2",
// "Delete category" => "Delete category",
// "Category ID %0 and descendants deleted" => "Category ID %0 and descendants deleted",
// "Category ID %0 not deleted" => "Category ID %0 not deleted",
// "Category cannot be parent of itself - no changes made" => "Category cannot be parent of itself - no changes made",
// "Category %0 updated" => "Category %0 updated",
// "Category %0 created" => "Category %0 created",
"The file does not have the required header" => "Faili haina kichwa kinachohitajika",
// "Incorrect parameter %0" => "Incorrect parameter %0",
// "Categories imported" => "Categories imported",
"Edit permissions for this category" => "Badilisha ruhusa kwa kundi hii",
// "Assign permissions" => "Assign permissions",
// "Template removed" => "Template removed",
// "Template not removed" => "Template not removed",
// "Section removed" => "Section removed",
// "Section not removed" => "Section not removed",
// "Template %0 created or modified" => "Template %0 created or modified",
// "Template %0 not created or modified" => "Template %0 not created or modified",
// "Contribution settings saved" => "Contribution settings saved",
// "Contribution settings not saved" => "Contribution settings not saved",
// "Contribution added" => "Contribution added",
// "Contribution not added" => "Contribution not added",
// "Contribution modified" => "Contribution modified",
// "Contribution not modified" => "Contribution not modified",
// "Contribution removed" => "Contribution removed",
// "Contribution not removed" => "Contribution not removed",
// "Cookie removed" => "Cookie removed",
// "Cookie not removed" => "Cookie not removed",
// "All cookies removed" => "All cookies removed",
// "No cookies removed" => "No cookies removed",
// "File uploaded and one cookie created or replaced" => "File uploaded and one cookie created or replaced",
// "File uploaded and %0 cookies created or replaced" => "File uploaded and %0 cookies created or replaced",
// "Upload failed - no cookies created" => "Upload failed - no cookies created",
"Upload failed" => "Pakia imeshindwa",
// "Cookie saved" => "Cookie saved",
// "Cookie not saved" => "Cookie not saved",
// "Admin credits" => "Admin credits",
// "DSN removed" => "DSN removed",
// "DSN not removed" => "DSN not removed",
// "DSN created or modified" => "DSN created or modified",
// "DSN not created or modified" => "DSN not created or modified",
// "External wiki removed" => "External wiki removed",
// "External wiki not removed" => "External wiki not removed",
// "External wiki saved" => "External wiki saved",
// "External wiki not saved" => "External wiki not saved",
// "Forum saved" => "Forum saved",
// "Forum not saved" => "Forum not saved",
// "Forum duplicated" => "Forum duplicated",
// "Forum not duplicated" => "Forum not duplicated",
"All posted" => "Yote imewekwa",
"Queue anonymous posts" => "Foleni machapisho bila majina",
"Queue all posts" => "Foleni machapisho yote",
"No attachments" => "Hakuna viambatisho",
"Everybody can attach" => "Kila mtu ambatisha",
"Only users with attach permission" => "Watumiaji tu wenye idhini ya ambatisha",
"Moderators and admin can attach" => "Wasimamizi na admin wanaweza kuambatisha",
"No display" => "Hakuna maonyesho",
"Date (desc)" => "Tarehe (utaratibu wa kushuka)",
"Date (asc)" => "Tarehe (utaratibu wa kuongezeka)",
"Score (desc)" => "Mabao (utaratibu wa kushuka)",
"Replies (desc)" => "Majibu (utaratibu wa kushuka)",
"Reads (desc)" => "Kusoma (utaratibu wa kushuka)",
"You have to provide a hotword and a URL" => "Lazima utoe neno/kiungo moja kwa moja au anwani ya wavuti",
// "Hotword added" => "Hotword added",
// "Hotword not added" => "Hotword not added",
// "Hotword deleted" => "Hotword deleted",
// "Hotword not deleted" => "Hotword not deleted",
// "One dynamic zone updated" => "One dynamic zone updated",
// "%0 dynamic zones updated" => "%0 dynamic zones updated",
// "Dynamic zones not updated" => "Dynamic zones not updated",
// "Hotword saved" => "Hotword saved",
// "Hotword not saved" => "Hotword not saved",
// "HTML page removed" => "HTML page removed",
// "HTML page not removed" => "HTML page not removed",
// "HTML page saved" => "HTML page saved",
// "HTML page not saved" => "HTML page not saved",
// "A custom rule with the same ID already exists" => "A custom rule with the same ID already exists",
// "Tiki IDS is not enabled" => "Tiki IDS is not enabled",
"Requested action is not supported on repository" => "Hatua iliyoombwa haijatumiwa kwenye hifadhi",
"Repository name can't be an empty" => "Jina la hifadhi hawezi kuwa tupu",
"No repository" => "Hakuna hifadhi",
"Search is mandatory field" => "Utafutaji ni uwanja la lazima",
"File not found " => "Faili halijapatikana",
"Requested action in not supported on repository" => "Hatua iliyoombwa haijatumiwa kwenye hifadhi",
"You need to apply the \"Invoice\" profile" => "Unahitaji kutumia maelezo ya \"ankara\"",
// "Remove keywords" => "Remove keywords",
// "Keywords for page \"%0\" saved" => "Keywords for page \"%0\" saved",
// "Keywords for page \"%0\" removed" => "Keywords for page \"%0\" removed",
// "Keywords were not updated" => "Keywords were not updated",
// "Featured link saved" => "Featured link saved",
// "Featured link not saved" => "Featured link not saved",
// "Non-existent link" => "Non-existent link",
// "Featured link removed" => "Featured link removed",
// "Featured link not removed" => "Featured link not removed",
"Frequency should be a positive integer!" => "Marudio lazima iwe thamani chanya!",
"Mail-in accounts set to be checked every %s minutes" => "Barua katika akaunti kuweka kukaguliwa kila dakika ya %s",
"Automatic Mail-in accounts checking disabled" => "Akaunti za barua pepe haziingiliani moja kwa moja",
"No menu indicated" => "Hakuna menyu iliyoonyeshwa",
// "Delete menu ID %0" => "Delete menu ID %0",
// "Reset the Application Menu to the current system default" => "Reset the Application Menu to the current system default",
// "Module file in use. You need to edit %0 to configure your modules" => "Module file in use. You need to edit %0 to configure your modules",
// "%0 cache files cleared" => "%0 cache files cleared",
// "Module unassigned" => "Module unassigned",
// "Module not unassigned" => "Module not unassigned",
// "Displayed order may not change if other modules now have the same order rank" => "Displayed order may not change if other modules now have the same order rank",
// "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1" => "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1",
// "Standard module display order moved up" => "Standard module display order moved up",
// "Standard module display order not moved up" => "Standard module display order not moved up",
// "Standard module display order moved down" => "Standard module display order moved down",
// "Standard module display order not moved down" => "Standard module display order not moved down",
// "Standard display of modules reordered or moved" => "Standard display of modules reordered or moved",
// "Standard display of modules not reordered or moved" => "Standard display of modules not reordered or moved",
// "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1" => "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1",
"Cannot create or update module: You need to specify a name for the module" => "Haiwezi kuunda au kusasisha moduli: Unahitaji kutaja jina la moduli",
"Cannot create or update module: You cannot leave the data field empty" => "Haiwezi kuunda au kuboresha moduli: Huwezi kuondoka kwenye uwanja la data tupu",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "Custom module created" => "Custom module created",
// "Custom module modified" => "Custom module modified",
// "Custom not module created" => "Custom not module created",
// "Custom module not modified" => "Custom module not modified",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module",
// "Module assigned" => "Module assigned",
// "Module not assigned" => "Module not assigned",
// "Custom module deleted" => "Custom module deleted",
// "Custom module not deleted" => "Custom module not deleted",
"Appearance" => "Mwonekano",
"No newsletter indicated" => "Hakuna jarida unahitajika",
"Newsletter does not exist" => "Jarida haipo",
// "subscription" => "subscription",
// "subscriptions" => "subscriptions",
// "No subscriptions removed" => "No subscriptions removed",
// "Subscription removed" => "Subscription removed",
// "Subscription not removed" => "Subscription not removed",
// "Subscription marked as valid" => "Subscription marked as valid",
// "Subscription not marked as valid" => "Subscription not marked as valid",
// "Errors encountered when attempting to add subscription" => "Errors encountered when attempting to add subscription",
// "Subscription added" => "Subscription added",
"Error opening uploaded file" => "Hitilafu kufungua faili iliyopakiwa",
// "Error importing from wiki page \"%0\"" => "Error importing from wiki page \"%0\"",
// "Wiki page \"%0\" imported" => "Wiki page \"%0\" imported",
// "Error importing from tracker ID %0" => "Error importing from tracker ID %0",
// "Tracker ID %0 imported" => "Tracker ID %0 imported",
// "Not all subscriptions created" => "Not all subscriptions created",
// "Subscriptions not created" => "Subscriptions not created",
// "Subscriptions created" => "Subscriptions created",
// "Group \"%0\" subscribed" => "Group \"%0\" subscribed",
// "Group \"%0\" not subscribed" => "Group \"%0\" not subscribed",
// "Subscribers added" => "Subscribers added",
// "Subscribers not added" => "Subscribers not added",
// "Emails from wiki page \"%0\" subscribed" => "Emails from wiki page \"%0\" subscribed",
// "Emails from wiki page \"%0\" not subscribed" => "Emails from wiki page \"%0\" not subscribed",
// "%0 \$word removed" => "%0 \$word removed",
// "Newsletter removed" => "Newsletter removed",
// "Newsletter not removed" => "Newsletter not removed",
// "Newsletter created or modified" => "Newsletter created or modified",
// "Newsletter not created or modified" => "Newsletter not created or modified",
"You need to provide a username or an email" => "Unahitaji kutoa jina la mtumiaji au barua pepe",
"The user has no email set. No notifications will be sent" => "Mtumiaji ina hakuna barua pepe kuweka. Hakuna taarifa itatumwa",
// "Mail notification event added" => "Mail notification event added",
// "Mail notification event deleted" => "Mail notification event deleted",
// "One mail notification events deleted" => "One mail notification events deleted",
// "%0 mail notifications events deleted" => "%0 mail notifications events deleted",
"No poll indicated" => "Hakuna kura ya maoni zilionyesha",
// "Name is required" => "Name is required",
// "Task is required" => "Task is required",
// "Run Time is required" => "Run Time is required",
// "Run Time format is invalid" => "Run Time format is invalid",
// "Status cannot be empty" => "Status cannot be empty",
// "Scheduler %s was updated" => "Scheduler %s was updated",
// "Scheduler %s was created" => "Scheduler %s was created",
// "Inactive" => "Inactive",
"unsafe" => "hatari",
"The Path to store files in the filegallery should be outside the tiki root directory" => "Njia ya kuhifadhi faili katika filegallery inapaswa kuwa nje ya directory kuu ya tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "Njia ya kuhifadhi faili katika imagegallery inapaswa kuwa nje ya directory kuu ya tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "Kipengele \"Hariri kiolezo\" kinazimwa. Usiruhusu mtu yeyote ambaye huwezi kuamini kutumia kipengele hiki. Inaweza kutumika kwa urahisi kuingiza msimbo wa php.",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
"The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement" => "\"Regex Wikiplugin\" imeanzishwa. Inaweza kutumika na wahariri wa wiki kuunda HTML yoyote kupitia uingizaji wa regex",
"The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "\"Lsdir Wikiplugin\" imeanzishwa. Inaweza kutumika na wahariri wa wiki kutazama yaliyomo ya saraka yoyote",
"The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "\"Bloglist Wikiplugin\" imeanzishwa. Inaweza kutumiwa na wahariri wa wiki kufungua posts binafsi za blogu",
"The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "\"iframe Wikiplugin\" imeanzishwa. Inaweza kutumika kwa wahariri wa wiki kwa \"cross site scripting attacks\"",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
"The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "\"Redirect Wikiplugin \" imeanzishwa. Inaweza kutumika kwa wahariri wa wiki kwa \"cross site scripting attacks\"",
"The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)." => "\"Module Wikiplugin\" imeanzishwa. Inaweza kutumiwa na wahariri wa wiki kuongeza modules ambazo zinaruhusu kupata habari (tazama orodha ya moduli).",
"The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "\"Userlist Wikiplugin\" imeanzishwa. Inaweza kutumika na wahariri wa wiki kuonyesha orodha ya watumiaji",
"The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "\"Usercount Wikiplugin \" imeanzishwa. Inaweza kutumika na wahariri wa wiki kuonyesha hesabu ya idadi ya watumiaji",
"The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "\"SQL Wikiplugin\" imeanzishwa. Inaweza kutumika na wahariri wa wiki kutekeleza amri za SQL",
"risky" => "enye hatari",
"To the extent secure logins are not required, data transmitted between the browser and server is not private." => "Kwa kiasi kikubwa kuingia kwa salama hazihitajiki, data zinaa kati ya kivinjari na server si binafsi.",
// "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php",
// "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php",
// "Unlocked" => "Unlocked",
// "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed" => "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed",
"Path disclosure" => "Faille Path disclosure",
"Path disclosure through error message" => "Njia ya kutoa taarifa kupitia ujumbe wa kosa",
"SQL injection" => "injection SQL",
"SQL injection by authenticated user" => "SqL sindano na mtumiaji aliyehakikishiwa",
"SQL injection by authenticated user with special privileges" => "SqL sindano na mtumiaji aliyehakikishwa na marupurupu maalum",
"SQL injection without authentication" => "SqL sindano bila uthibitishaji",
"PHP command injection" => "Kipindi cha amri ya PHP",
"PHP command injection by authenticated user" => "Kipindi cha amri ya PHP na mtumiaji aliyehakikishiwa",
"PHP command injection by authenticated user with special privileges" => "Kipindi cha amri ya PHP na mtumiaji aliyehakikishwa na marupurupu maalum",
"PHP command injection without authentication" => "Kipindi cha amri ya PHP bila uthibitishaji",
"File upload" => "Faili ya kupakia",
"File is not readable. Unable to check." => "Faili haipatikani. Haiwezi kuangalia.",
// "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous" => "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous",
"This is not a Tiki file. Check if this file was uploaded and if it is dangerous." => "Hii si faili ya Tiki. Angalia kama faili hii imepakiwa na ikiwa ni hatari.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Hii ni Faili iliyobadilishwa. Haiwezi kuangalia toleo. Angalia ikiwa ni hatari.",
"This file is from another Tiki version: " => "Faili hii inatoka kwenye toleo jingine la Tiki:",
"Shoutbox Words" => "Maneno ya Shoutbox",
"You have to provide a word" => "Una kutoa neno",
"You do not have permission to view this page." => "Huna ruhusa ya kutazama ukurasa huu.",
"You do not have permission to edit this page." => "Huna idhini ya kuhariri ukurasa huu.",
"You must specify a page name, it will be created if it doesn't exist." => "Lazima ueleze jina la ukurasa, litaundwa kama halipo.",
"page not added (Exists)" => "ukurasa haujaongezwa (humo)",
"No survey indicated" => "Hakuna uchunguzi ulionyeshwa",
"Tiki Cache/Sys Admin" => "Cache Tiki / Mfumo wa utawala",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
"Are you sure you want to delete all your custom tools" => "Una uhakika unataka kufuta zana zako zote za desturi",
"Are you sure you want to delete this custom tool" => "Êtes vous sûr de vouloir supprimer cet outil personnalisé",
"Are you sure you want to remove this topic" => "Êtes-vous sûr(e) de vouloir supprimer ce sujet",
"Are you sure you want to remove this topic AND all the articles related" => "Una uhakika unataka kuondoa mada hii na makala zote zinazohusiana",
"No tracker indicated" => "Hakuna tracker iliyoonyeshwa",
// "Tracker Fields %0" => "Tracker Fields %0",
"You don't have permission to use this feature" => "Huna haki ya kutumia kipengele hiki",
"Are you sure you want to delete the webservice \"%0\"" => "Una uhakika unataka kufuta webservice \"%0\"",
"Are you sure you want to delete the template \"%0\"" => "Una uhakika unataka kufuta template \"%0\"",
"Webservice error \"%0\" not saved (alpha characters only)" => "Hitilafu ya webservice \"%0\" haijahifadhiwa (wahusika wa alpha tu)",
"User doesn't exist" => "Mtumiaji huyu haipo",
"No records were found. Check the file please!" => "Hakuna kuingia kupatikana. Angalia faili tafadhali!",
"User login or email is required" => "Jina la mtumiaji au barua pepe inahitajika",
"User does not exist on master" => "Mtumiaji haipo juu ya bwana",
"User login is required" => "Jina la mtumiaji linahitajika",
"Email is required" => "Anwani ya barua pepe ya lazima",
// "User is duplicated" => "User is duplicated",
"Created account %s <%s>" => "akaunti iliyoundwa %s <%s>",
"Assigned %s in group %s" => "Weka %s katika kikundi cha %s",
"Users added" => "Watumiaji waliongeza",
// "%0 users not added" => "%0 users not added",
"Email validation requested but email address not set" => "Uthibitishaji wa barua pepe uliombwa lakini anwani ya barua pepe isiyojulikana",
"The passwords do not match" => "Nywila si sawa",
"Password not set" => "Nywila kisichojulikana",
"User %s already exists" => "Mtumiaji %s tayari yupo",
"User login contains invalid characters" => "Jina la mtumiaji lina wahusika batili",
"New user created with username %s." => "Mtumiaji mpya ameumbwa kwa jina la mtumiaji  %s.",
"Impossible to create new %s with %s %s." => "Haiwezi kuunda %s mpya na %s %s.",
// "User account %0 has been invalidated by the admin" => "User account %0 has been invalidated by the admin",
// "An error occurred - the user account %0 has not been invalidated by the admin" => "An error occurred - the user account %0 has not been invalidated by the admin",
// "Link to OpenID for user %0 has been removed" => "Link to OpenID for user %0 has been removed",
// "An error occurred - the link to OpenID for user %0 has not been removed" => "An error occurred - the link to OpenID for user %0 has not been removed",
// "Modify this user's data" => "Modify this user's data",
"%s changed from %s to %s" => "%s imebadilika kutoka %s hadi %s",
"%s modified successfully." => "%s imebadilishwa kwa ufanisi.",
"%s modification failed." => "badiliko ya %s imeshindwa.",
"Impossible to change %s from %s to %s" => "Haiwezi kubadilisha %s kutoka %s hadi %s",
"email" => "anwani ya barua pepe",
// "Unable to change %s from %s to %s" => "Unable to change %s from %s to %s",
"Review" => "Kifungu kilibainisha",
"Classified" => "Tangaza",
"Failed to add attribute" => "Imeshindwa kuongeza sifa",
"rss feed disabled" => "rss kulisha walemavu",
"Are you sure you want to add user %0 to group %1" => "Una uhakika unataka kuongeza mtumiaji %0 kwa kikundi %1",
"You have to indicate a group" => "Lazima ubainishe kundi",
"This group is invalid" => "Kundi hili ni batili",
"Remote system user needs to be configured" => "Mtumiaji wa mfumo wa kijijini lazima awe kusanidiwa",
"Remote system group for autologin need to be configured" => "Kikundi cha mfumo wa mbali wa autologin kinahitajika kufanywa",
"User name needs to be specified" => "Jina la mtumiaji linahitaji kutajwa",
"Base URL not received from remote system" => "URL ya msingi haikupokea kutoka kwa mfumo wa mbali",
"Email needs to be specified" => "Barua pepe zinahitajika",
"The page cannot be found" => "Ukurasa huu haukuweza kupatikana",
// "Image Galleries Configuration Panel" => "Image Galleries Configuration Panel",
"Could not read image %s." => "Haiwezi kusoma picha %s.",
"Image %s upload failed." => "Imeshindwa kutuma picha %s.",
"Image %s uploaded successfully." => "Picha %s imetumwa kwa ufanisi.",
"Image %s removed from Batch directory." => "picha %s imeondolewa kwenye saraka ya kupakia kundi.",
"Impossible to remove image %s from Batch directory." => "Haiwezekani kuondoa picha %s kutoka saraka ya Batch.",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
"Please setup that dir on " => "Tafadhali, msimamo saraka hii pa ",
"Please contact the website administrator." => "Tafadhali wasiliana na msimamizi wa tovuti.",
"Directory batch" => "Saraka Group",
// "File Galleries Configuration Panel" => "File Galleries Configuration Panel",
"Incorrect directory chosen for batch upload of files." => "Saraka isiyo sahihi iliyochaguliwa kwa kupakia faili ya kundi.",
// "It isn't possible to post in any blog" => "It isn't possible to post in any blog",
// "You may need to create a blog first" => "You may need to create a blog first",
"You do not have permission to edit this post" => "Huna haki za kuhariri makala hii",
// "Top visited blogs" => "Top visited blogs",
"Last posts" => "Makala wa blogu za hivi ",
"Top active blogs" => "Blogu nyingi za kazi",
// "No blogId specified" => "No blogId specified",
"Stop watching all categories" => "Simama kutazama makundi yote",
// "Watch all categories" => "Watch all categories",
// "Group watches for all categories" => "Group watches for all categories",
// "Stop watching this category and its descendants" => "Stop watching this category and its descendants",
// "Watch this category and its descendants" => "Watch this category and its descendants",
// "Group watches for this category" => "Group watches for this category",
// "Stop watching this category" => "Stop watching this category",
"Watch this category" => "Fuatilia jamii hii",
"Nothing tagged yet" => "Hakuna Keyword wakati huu ",
"You must clear your browser cache." => "Lazima tupu cache ya kivinjari chako.",
"You do not have permission to access this gallery" => "Huna haki za kufikia nyumba ya sanaa hii",
"No gallery indicated" => "Hakuna nyumba ya sanaa unahitajika",
"You do not have permission to remove images from this gallery" => "Huna haki za kufuta picha kutoka kwenye nyumba hii ya sanaa",
"You do not have permission to rebuild thumbnails in this gallery" => "Huna haki ya kujenga tena thumbnails katika nyumba hii ya sanaa",
"You do not have permission to rotate images in this gallery" => "Huna haki ya mzunguko picha katika nyumba hii ya sanaa",
"No image indicated" => "Hakuna picha iliyoonyeshwa",
"picture not found" => "picha halikupatikana",
"You do not have permission to move images from this gallery" => "Huna haki za kusonga picha kutoka kwenye nyumba hii ya sanaa",
"You do not have permission to view the calendar" => "Huna haki za kuona kalenda",
"You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "Vous devez <a href=\"tiki-admin_calendars.php?cookietab=2\">créer un calendrier</a>",
"event without name" => "tukio bila jina",
"You do not have permission to view this page" => "Huna haki za kutazama ukurasa huu",
// "Invalid date format" => "Invalid date format",
"Your PHP installation does not have calendar enabled" => "Ufungaji wako wa PHP hauna kalenda imewezeshwa",
"%H:%M %Z" => "%Hh%M",
"Invalid username or activation code. Maybe this code has already been used." => "Jina la mtumiaji batili au msimbo wa uanzishaji. Labda kanuni hii tayari imetumiwa.",
"Your email could not be validated; make sure you email is correct" => "Barua  pepe yako haikuweza kuthibitishwa ; hakikisha ni sahihi",
"You can not use the same password again" => "Huwezi tena kutumia nenosiri sawa",
"Invalid old password" => "Nywila ya zamani ya batili",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
"info" => "habari",
// "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them" => "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them",
"How to change this value" => "Jinsi ya kubadilisha thamani hii",
// "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them" => "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them",
"Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors" => "Hitilafu hazitaingia kwa sababu log_errors haijawezeshwa. Mazoea mazuri, hasa kwenye tovuti ya uzalishaji, ni kurekodi makosa yote.",
// "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information" => "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information",
// "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information" => "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information",
// "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '" => "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '",
// "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring" => "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring",
// "No errors will be reported although the error_reporting level is all the way up at ' . \$e . " => "No errors will be reported although the error_reporting level is all the way up at ' . \$e . ",
// "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information" => "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information",
"good" => "nzuri",
// "ini_set is used in some places to accommodate special needs of some Tiki features" => "ini_set is used in some places to accommodate special needs of some Tiki features",
// "unsure" => "unsure",
// "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
"bad" => "mbaya",
// "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning" => "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning",
"N/A" => "N/A",
"Unable to detect" => "Haiwezi kuchunguza",
"Cannot determine the size of this disk drive" => "Haiwezi kuamua ukubwa wa gari hili la disk",
// "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space" => "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space",
// "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files" => "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files",
"When the disk space is filled, users, including administrators, will not be able to log in to Tiki" => "Wakati nafasi ya disk imejaa, watumiaji, ikiwa ni pamoja na wasimamizi, hawataweza kuingia kwenye Tiki",
// "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported" => "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported",
"More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)" => "Zaidi ya 251MB ya nafasi ya bure ya disk inapatikana. Tiki itaendesha vizuri, lakini kunaweza kuwa na masuala wakati tovuti inakua (kwa sababu ya kupakia faili, kwa mfano)",
// "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for" => "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for",
"PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance" => "PHP inaendesha kama CGI. Jisikie huru kutumia minyororo MPM Apache kuongeza utendaji",
"Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see" => "Inaonekana kama unaendesha PHP kama FPM / CGI / FastCGI, unaweza kuwa na uwezo wa kufuta baadhi za usanidi za PHP na kuwaongeza  ku .faili za user.ini, angalia",
// "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
"Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see" => "Inaonekana kama unaendesha PHP kama moduli katika Apache, unaweza kuwa na uwezo wa kufuta baadhi za usanidi za PHP na kuwaongeza  ku .faili htaccess, angalia",
// "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
"APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "APC inatumiwa kama Cache ya ByteCode, ambayo huongeza utendaji ikiwa imeusanidi vizuri. Angalia Admin-> Utendaji katika Tiki kwa maelezo zaidi",
"xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "xCache inatumiwa kama Cache ya ByteCode, ambayo huongeza utendaji ikiwa imeusanidi vizuri. Angalia Admin-> Utendaji katika Tiki kwa maelezo zaidi",
"OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "OPCache inatumiwa kama Cache ya ByteCode, ambayo huongeza utendaji ikiwa imeusanidi vizuri. Angalia Admin-> Utendaji katika Tiki kwa maelezo zaidi",
// "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes" => "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes",
"WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "WinCache inatumiwa kama Cache ya ByteCode, ambayo huongeza utendaji ikiwa imeusanidi vizuri. Angalia Admin-> Utendaji katika Tiki kwa maelezo zaidi",
"WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache inatumiwa kama Cache ya ByteCode, lakini inahitajika CGI / FastCGI server API inaonekana haitumiki",
"WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache" => "WinCache version 2 au juu ni kutumika kama FileCache. Haiunga mkono Cache ya ByteCode",
"It is recommended to use Zend opcode cache as the ByteCode Cache" => "Inashauriwa kutumia cache ya opcode ya Zend kama Cache ya ByteCode",
"WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache version 2 au juu ni kutumika kama FileCache, lakini inahitajika CGI / FastCGI server API inaonekana haitumiki",
// "The memory_limit is at" => "The memory_limit is at",
// "This is known to support smooth functioning even for bigger sites" => "This is known to support smooth functioning even for bigger sites",
// "This will normally work, but the site might run into problems when it grows" => "This will normally work, but the site might run into problems when it grows",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default" => "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default",
// "The session.save_handler should be set to 'files'" => "The session.save_handler should be set to 'files'",
// "Well set! The default setting of 'files' is recommended for Tiki" => "Well set! The default setting of 'files' is recommended for Tiki",
"The session.save_path must writable" => "session.save_path lazima kinachoweza kuandikwa",
// "The session.save_path is writable" => "The session.save_path is writable",
// "If you would be using the recommended session.save_handler setting of 'files\\" => "If you would be using the recommended session.save_handler setting of 'files\\",
// "It doesn't matter though, since your session.save_handler is not set to 'files'" => "It doesn't matter though, since your session.save_handler is not set to 'files'",
// "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started" => "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started",
// "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request" => "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request",
// "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start" => "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start",
// "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup" => "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup",
// "This appears to work" => "This appears to work",
// "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki" => "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki",
// "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki" => "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Correctly set! And this is also future proof as register_globals is deprecated" => "Correctly set! And this is also future proof as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Correctly set! And this is also future proof as safe_mode is deprecated" => "Correctly set! And this is also future proof as safe_mode is deprecated",
// "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior" => "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior",
// "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated" => "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated",
// "Correctly set! Tiki is fully UTF-8 and so should be this installation" => "Correctly set! Tiki is fully UTF-8 and so should be this installation",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file",
// "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a time zone set protects the site from related errors" => "Well done! Having a time zone set protects the site from related errors",
"Files can be uploaded to Tiki" => "Faili zinaweza kupakiwa kwenye Tiii",
"Files cannot be uploaded to Tiki" => "Faili haziwezi kupakiwa kwa Tiki",
// "The max_execution_time is at" => "The max_execution_time is at",
// "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless" => "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless",
// "The max_execution_time is unlimited" => "The max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s",
// "The max_input_time is at" => "The max_input_time is at",
"The max_input_time is unlimited" => "Max_input_time haina ukomo",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds",
// "The max_file_uploads is at" => "The max_file_uploads is at",
// "This is the maximum number of files allowed to be uploaded simultaneously" => "This is the maximum number of files allowed to be uploaded simultaneously",
// "The maximum number of files allowed to be uploaded is not available" => "The maximum number of files allowed to be uploaded is not available",
// "The upload_max_filesize is at" => "The upload_max_filesize is at",
// "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly" => "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly",
// "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site" => "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site",
// "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site" => "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site",
// "The post_max_size is at" => "The post_max_size is at",
// "The GD extension is needed for manipulation of images and for CAPTCHA images" => "The GD extension is needed for manipulation of images and for CAPTCHA images",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case GD is not available" => "ImageMagick is used as a fallback in case GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example" => "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example",
// "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file" => "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file",
// "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it" => "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it",
// "mbstring extension is needed for an UTF-8 compatible lower case filter" => "mbstring extension is needed for an UTF-8 compatible lower case filter",
"calendar extension is needed by Tiki" => "Ugani wa kalenda unahitajika na Tiki",
// "The calendar feature of Tiki will not function without this" => "The calendar feature of Tiki will not function without this",
"ctype extension is needed by Tiki" => "Ugani wa ctype unahitajika na Tiki",
"This extension is needed for the dom extension (see below)" => "Ugani huu unahitajika kwa ugani wa kikoa (tazama hapa chini)",
"This extension is needed by Tiki" => "Ugani huu unahitajika naTiki",
"This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "Ugani huu unahitajika kuunganisha Tiki kwa seva ya LDAP. Maelezo zaidi katika: http://doc.tiki.org/LDAP ",
"Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "Tiki haiwezi kuunganishwa kwenye LDAP server kama inavyotakiwa PHP ugani ni kukosa. Maelezo zaidi katika: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server" => "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server",
// "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17" => "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17",
"This extension is required for H5P" => "Ugani huu unahitajika kwa H5P",
"This extension is required for many features in Tiki" => "Ugani huu unahitajika kwa vipengele vingi muTiki",
"This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "Ugani huu hutumiwa kutafsiri maelezo ya SVN kwa TortoiseSVN 1.7 au zaidi",
// "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available" => "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available",
// "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries" => "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries",
// "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL" => "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL",
// "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt" => "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt",
// "Ability to generate random numbers, useful for example for CAPTCHA and other security features" => "Ability to generate random numbers, useful for example for CAPTCHA and other security features",
// "This extension is required and used frequently in validation functions invoked within Zend Framework" => "This extension is required and used frequently in validation functions invoked within Zend Framework",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server" => "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server",
"Tiki requires MySQL >= 5.x" => "Tiki inahitaji MySQL >= 5.x",
// "The max_allowed_packet setting is at" => "The max_allowed_packet setting is at",
// "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Your database supports the utf8mb4 character set required in Tiki19 and above" => "Your database supports the utf8mb4 character set required in Tiki19 and above",
// "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation" => "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation",
// "Tiki is fully utf8mb4 and so should be every part of the stack" => "Tiki is fully utf8mb4 and so should be every part of the stack",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified" => "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified",
// "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki" => "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down" => "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down",
// "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down" => "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down",
"ON" => "ON",
"OFF" => "OFF",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki",
// "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess" => "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess",
// "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"" => "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"",
// "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again" => "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again",
"Not Working" => "Haifanyi kazi",
// "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki" => "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki",
"Working" => "Kufanya kazi",
// "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs" => "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly",
// "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly",
// "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "Not Installed" => "Not Installed",
// "Tesseract PHP package could not be found. Try installing through Packages" => "Tesseract PHP package could not be found. Try installing through Packages",
// "Tesseract PHP dependency installed" => "Tesseract PHP dependency installed",
// "The installed Tesseract version is lower than the required version" => "The installed Tesseract version is lower than the required version",
// "Tesseract package" => "Tesseract package",
// "languages installed" => "languages installed",
// "Not all languages installed. You may need to install additional languages for multilingual support" => "Not all languages installed. You may need to install additional languages for multilingual support",
// "Tesseract languages" => "Tesseract languages",
// "Tesseract could not be found" => "Tesseract could not be found",
// "Tesseract meets or exceeds the version requirements" => "Tesseract meets or exceeds the version requirements",
// "Tesseract binary" => "Tesseract binary",
// "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path" => "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path",
// "Path setup correctly" => "Path setup correctly",
// "Your path may not be configured correctly. It appears to be located at " => "Your path may not be configured correctly. It appears to be located at ",
// "Your path is configured, but we were unable to tell if it was configured properly or not" => "Your path is configured, but we were unable to tell if it was configured properly or not",
// "Tesseract path" => "Tesseract path",
// "Pdfimages path" => "Pdfimages path",
// "Scheduler has been successfully setup" => "Scheduler has been successfully setup",
// "Scheduler needs to have a console command of \"ocr:all\" set" => "Scheduler needs to have a console command of \"ocr:all\" set",
// "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser" => "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser",
// "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration" => "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration",
"safe" => "sans danger",
"WebKit is enabled" => "WebKit kinawezeshwa",
"The Blogs feature is enabled" => "Kipengele cha Blogu kinawezeshwa",
// "Exec can potentially be used to execute arbitrary code on the server" => "Exec can potentially be used to execute arbitrary code on the server",
"Tiki does not need it; perhaps it should be disabled" => "Tiki hana haja yake; labda inapaswa kuwa walemavu",
// "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled" => "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled",
// "Exec can be potentially be used to execute arbitrary code on the server" => "Exec can be potentially be used to execute arbitrary code on the server",
// "Tiki needs it to run the Plugins R/RR" => "Tiki needs it to run the Plugins R/RR",
// "If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
"Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki haina haja yake; labda inapaswa kuwa walemavu. Hata hivyo, meneja wa mfuko wa Composer kutumika kwa ajili ya mitambo katika Checkouts Subversion inaweza haja yake",
"Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "TIKI hana haja yake; ni vizuri kwamba ni walemavu. Hata hivyo, meneja wa mfuko wa Composer kutumika kwa ajili ya mitambo katika Checkouts Subversion inaweza haja yake",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "System is similar to exec" => "System is similar to exec",
"Tiki does not need it; it is good that it is disabled" => "Tiki haina haja yake; ni vizuri kwamba ni walemavu",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "popen is similar to exec" => "popen is similar to exec",
// "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
// "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature" => "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature",
// "session.use_trans_sid should be off by default. See the PHP manual for details" => "session.use_trans_sid should be off by default. See the PHP manual for details",
// "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them" => "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them",
// "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off" => "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off",
// "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information",
// "To manage this instance from a remote server you need SSH or FTP access to this server" => "To manage this instance from a remote server you need SSH or FTP access to this server",
"Command found" => "Amri imepatikana",
"Command not found, check if it is installed and available in one of the paths above" => "Amri haipatikani, angalia ikiwa imewekwa na inapatikana katika mojawapo ya njia ",
// "Extension loaded in PHP" => "Extension loaded in PHP",
// "Extension not loaded in PHP" => "Extension not loaded in PHP",
"Test mail from Tiki Server Compatibility Test" => "mtihani barua pepe kutoka kwa mtihani wa utangamano wa Tiki Server",
// "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered" => "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered",
// "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php" => "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php",
// "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts" => "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
// "The intl extension is required for Tiki 15 and newer" => "The intl extension is required for Tiki 15 and newer",
// "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters" => "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters",
"Congratulations!\n\nThis server can send emails.\n\n" => "Hongera!\n\nSeva hii inaweza kutuma barua pepe.\n\n",
// "The path '%0' on preference '%1' does not exist" => "The path '%0' on preference '%1' does not exist",
// "The lib '%0' on preference '%1', option '%2' does not exist" => "The lib '%0' on preference '%1', option '%2' does not exist",
// "The class '%0' needed for preference '%1', with option '%2' selected, does not exist" => "The class '%0' needed for preference '%1', with option '%2' selected, does not exist",
// "The extension '%0' on preference '%1', with option '%2' selected, is not loaded" => "The extension '%0' on preference '%1', with option '%2' selected, is not loaded",
"Top authors" => "Wengi Active Waandishi",
// "User %0 validated by the admin" => "User %0 validated by the admin",
"Problem. Try to log in again to receive new confirmation instructions." => "Tatizo. Jaribu kuunganisha tena ili kupokea uthibitisho maelekezo.",
"Invalid" => "Invalide",
"You must include a subject or a message" => "Lazima kujumuisha na mada au ujumbe",
// "You must make sure to have a valid email address in the From field" => "You must make sure to have a valid email address in the From field",
"%0 sent you a message" => "%0 alikutuma ujumbe",
"last version" => "toleo la hivi karibuni",
"Cannot rename page because the new name begins with reserved prefix" => "Huwezi kutaja tena ukurasa na jina ambalo linaanza na kiambishi kilichohifadhiwa zimehifadhiwa",
// "Cannot copy page because maybe new page name already exists" => "Cannot copy page because maybe new page name already exists",
"TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp kizazi injini. Kuzalisha WebHelp kutumia",
"Eliminating previous files." => "Inafuta faili za zamani.",
"Index: <strong>%0</strong>" => "Index : <strong>%0</strong>",
"Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
// "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix" => "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix",
"You need to change chmod 'whelp' manually to 777" => "Unahitaji kufanya manually chmod 777 juu ya 'whelp'",
"Creating directory structure in <strong>%0</strong>" => "Kujenga muundo wa saraka katika <strong>%0</strong>",
"Submit a new link" => "Tuma kiungo kipya",
"Must enter a name to add a site. " => "Lazima upe jina ili kuongeza tovuti. ",
"Must enter a url to add a site. " => "Lazima uingie anwani ya wavuti ili kuongeza tovuti. ",
"URL already added to the directory. Duplicate site? " => "Anwani ya wavuti tayari iko kwenye saraka. Hifadhi duplicate ? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL haiwezi kupatikana kupitia URL au tovuti iko nje ya mtandao na haiwezi kuongezwa kwenye saraka. ",
"Must select a category. " => "Vous devez choisir une catégorie. ",
"Must enter a name to add a site" => "Vous devez donner un nom pour ajouter un site",
"Must enter a url to add a site" => "Vous devez entrer une adresse Web pour ajouter un site",
"URL already added to the directory. Duplicate site?" => "Anwani ya wavuti tayari iko kwenye saraka. Hifadhi duplicate ?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL haiwezi kupatikana (URL isiyo sahihi au tovuti ya nje ya mtandao): URL haiwezi kuongezwa kwenye saraka",
// "Must select a category" => "Must select a category",
"Browse Directory" => "Vinjari saraka",
"How to use Directory" => "Jinsi ya kutumia saraka",
"No site indicated" => "Hakuna tovuti unahitajika",
"This feature is disabled: %0" => "Kipengele kinazimwa : %0",
// "No parent specified" => "No parent specified",
// "Latest sites of directory %0" => "Latest sites of directory %0",
// "Discount code already exists" => "Discount code already exists",
// "Invalid fileId. Please provide a valid fileId to preview a specific file" => "Invalid fileId. Please provide a valid fileId to preview a specific file",
// "Unable to display file" => "Unable to display file",
"File has been deleted" => "Faili imefutwa",
"You cannot download this file right now. Your score is low or file limit was reached" => "Huwezi kupakua faili hii sasa. Alama yako ni ya chini au kikomo cha faili ilifikia",
// "File locked" => "File locked",
// "File not locked" => "File not locked",
"Error : The file %s doesn't exist." => "Hitilafu: faili %s haipo.",
"Article not found" => "Kifungu haipatikani",
"You do not have permission to edit this article" => "Huna haki za kuhariri makala hii",
"The language can't be changed as its set of translations has already this language" => "Lugha haiwezi kubadilishwa kwa sababu tayari kuna hii lugha hii already katika ",
"Banner not found" => "Bannera haipatikani",
"You do not have permission to edit this banner" => "Una haki hakuna kubadilisha bannera hii",
"You do not have permission to edit this blog" => "Huna haki za kuhariri blogi hii",
// "No filters applied" => "No filters applied",
"You do not have permission to write the css file" => "Huna ruhusa ya kuandika faili ya css",
// "Wrong file type, expected one of %0" => "Wrong file type, expected one of %0",
"You do not have permission to view/edit this file" => "Huna ruhusa ya kuona / hariri faili hii",
" drawing" => " kuchora",
"Wrong file type, expected %0" => "Aina ya faili batili, inatarajiwa %0",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "Ombi la mabadiliko ya picha isiyo sahihi",
"You have permission to edit images but not in this gallery" => "Haki ya kufikia imekataliwa: unaweza kubadilisha picha lakini sio kwenye nyumba hii ya sanaa",
"Failed to edit the image" => "Imeshindwa kuhariri picha",
"Edit or export languages" => "Badilisha au kusafirisha lugha",
"Edit Perspectives" => "Badilisha Outlook",
"No content id indicated" => "Hakuna kitambulisho cha maudhui kilichosema",
"No question indicated" => "Hakuna maswali yaliyoonyeshwa",
// "No quiz indicated" => "No quiz indicated",
"View this wiki page" => "Tazama ukurasa huu wa Wiki",
"No structure indicated" => "Hakuna muundo unaonyeshwa",
"Invalid structure_id or page_ref_id" => "Structure_id au page_ref_id batili",
"You do not have permission to edit submissions" => "Huna idhini ya kuhariri maoni",
"You have to create a topic first" => "Una kuunda mada kwanza",
"Template directory %0 unknown" => "Kigezo Saraka ya %0 haijulikani",
"You do not have permission to do that" => "Huna haki za kufanya hivyo",
"You do not have permission to write the template" => "Huna idhini ya kuandika template",
"You do not have permission to read the template" => "Huna idhini ya kusoma template",
// "No topic id specified" => "No topic id specified",
"Invalid topic id specified" => "Kitambulisho cha mada batili",
"No object indicated" => "Hakuna vitu vilivyoonyeshwa",
"Only wiki pages are supported" => "Kurasa za Wiki tu zinasaidiwa",
// "Forbidden" => "Forbidden",
// "New diagram" => "New diagram",
// "Edit diagram" => "Edit diagram",
"Override lock and carry on with edit" => "Pindua lock na uendelee katika hali ya hariri",
// "Page is currently being edited" => "Page is currently being edited",
// "page imported" => "page imported",
// "created from import" => "created from import",
// "To review the changes you have just made %0compare the versions%1 in history of this page" => "To review the changes you have just made %0compare the versions%1 in history of this page",
"Page %0 saved (version %1)" => "Ukurasa %0 imehifadhiwa (toleo %1)",
"This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "Ukurasa huu umebadilishwa na %0. Tafadhali angalia na mtumiaji kabla ya kuhariri ukurasa,\\Kadhalika mabadiliko yatahifadhiwa kama matoleo mawili tofauti katika historia na utahitaji kuunganisha manually baadaye",
// "Can't import remote HTML page" => "Can't import remote HTML page",
"The Sandbox is disabled" => "Sandbox imezimwa",
"The page cannot be edited because it is locked" => "Ukurasa huu hauwezi kubadilishwa: umefungwa",
"That page already exists. Go back and choose a different name." => "ukurasa tayari upo. Kurudi nyuma na chagua jina lingine.",
"The page name is" => "Jina la ukurasa ni",
"The translation set already contains a page in this language" => "Tafsiri imewekwa tayari ina ukurasa katika lugha hii",
"The file cannot be opened" => "Haiwezi kufungua faili",
"Problem zip initialisation" => "Tatizo la initialization Zip",
"Problem zip" => "Tatizo Zip",
// "Another user is currently exporting that tracker. Please try again later" => "Another user is currently exporting that tracker. Please try again later",
"No questions group indicated" => "Hakuna kikundi cha maswali yaliyoonyeshwa",
// "Remove archive: " => "Remove archive: ",
"Remove file gallery: " => "Futa nyumba ya sanaa ya faili : ",
"You do not have permission to edit this file" => "Huna haki za kuhariri faili hii",
"Most-visited file galleries" => "Nyumba ya sanaa zilizotembelea nyingi za faili  ",
"Most downloaded files" => "Faili zilizopakuliwa nyingi",
"Last files" => "Faili za mwisho",
// "No gallery ID specified" => "No gallery ID specified",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "No forum indicated" => "No forum indicated",
"Last forum topics" => "Mada ya mwisho ya jukwaa",
"Last replied forum topics" => "Mwisho jibu kwenye jukwaa",
// "Most-Read Forum Topics" => "Most-Read Forum Topics",
"Top topics" => "Mada maarufu zaidi",
"Forum posts" => "Makala ya Vikao",
"Most-Visited Forums" => "jukwaa vilivyotembelewa zaidi",
// "No forumId specified" => "No forumId specified",
"List Forums" => "Orodha ya Vikao",
"Not supported yet." => "Haijaungwa mkono bado.",
// "All files copied" => "All files copied",
"id" => "id",
"first uploaded image" => "picha ya kwanza iliyopakiwa",
"last uploaded image" => "picha ya mwisho iliyopakiwa",
"first image" => "picha ya kwanza",
"last image" => "picha ya mwisho",
"random image" => "picha ya random",
"You do not have permission to create galleries and so you cannot edit them" => "Huna haki za kuunda au kubadilisha nyumba ya sanaa na kwa hiyo hawezi kuhariri kipengee ",
"You do not have permission to edit this gallery" => "Huna haki za kuhariri nyumba hii ya sanaa",
"You do not have permission to remove this gallery" => "Huna haki za kufuta nyumba hii ya sanaa",
"Top images" => "Picha maarufu zaidi",
// "Last images" => "Last images",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
"Unknown Graphic" => "grafu haijulikani",
// "Unknown Renderer" => "Unknown Renderer",
// "You must select a renderer" => "You must select a renderer",
"Invalid Series for current graphic." => "Mfululizo batili kwa graphic sasa. ",
"overwriting old page" => "overwriting ukurasa wa zamani",
// "updated from structured text import" => "updated from structured text import",
"page created" => "ukurasa umeundwa",
// "created from structured text import" => "created from structured text import",
"Unable to locate import file" => "Haiwezi kupata faili yenye kuagiza",
// "Pages in zip file %0 successfully imported" => "Pages in zip file %0 successfully imported",
"Invalid software name" => "Jina la programu isiyo sahihi",
// "No wiki page specified" => "No wiki page specified",
"This version does not exist" => "Toleo hili haipo",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
"Are you sure you want to undo the last change" => "Una uhakika unataka kufuta mabadiliko ya mwisho",
"There is nothing to undo" => "Hakuna kitu cha kufuta",
"You have requested that this page be machine translated" => "Umeomba ukurasa huu kutafsiriwa moja kwa moja",
"However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "Hata hivyo, kipengele cha Tafsiri ya Machine hajawezeshwa. Tafadhali wezesha kipengele hiki, au uombe admin ya tovuti ili uifanye",
// "No repository given" => "No repository given",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
"Congratulations! You are now part of this invitation group(s)" => "Hongera! Wewe sasa ni sehemu ya kikundi hiki cha mwaliko",
"Communication error" => "Hitilafu ya mawasiliano",
"Invalid response provided by the Kaltura server. Please retry" => "Jibu batili zinazotolewa na seva ya Kaltura. Asante kwa kujaribu tena",
"Are you sure you want to permanently remove the article with identifier %0" => "Una uhakika unataka kufuta kabisa kipengee ambacho kitambulisho chako ni %0",
"Are you sure you want to permanently remove these %0 articles" => "Una uhakika unataka kufuta haya ya %0  makala",
"You do not have permission to remove articles" => "Huna haki za kufuta makala",
"You do not have permission to remove banners" => "Huna haki za kuondoa mabango",
// "List Blog Posts" => "List Blog Posts",
"You do not have permission to remove this blog" => "Huna haki za kufuta blogu hii",
"You do not have permission to view the comments for this blog" => "Huna haki za kuona maoni ya blogi hii",
// "The following comment has been deleted" => "The following comment has been deleted",
// "The following comments have been deleted" => "The following comments have been deleted",
// "Delete selected comments and ban" => "Delete selected comments and ban",
// "Users have been pre-selected for banning in the highlighted section of the form below" => "Users have been pre-selected for banning in the highlighted section of the form below",
// "One comment approved" => "One comment approved",
// "%0 comments approved" => "%0 comments approved",
// "No comments approved" => "No comments approved",
// "One comment rejected" => "One comment rejected",
// "%0 comments rejected" => "%0 comments rejected",
// "No comments rejected" => "No comments rejected",
// "Comment archived" => "Comment archived",
// "%0 comments archived" => "%0 comments archived",
// "No comments archived" => "No comments archived",
// "Comment unarchived" => "Comment unarchived",
// "%0 comments unarchived" => "%0 comments unarchived",
// "No comments unarchived" => "No comments unarchived",
// "Action not performed since no comments were selected" => "Action not performed since no comments were selected",
"Approved Status" => "Hali ya kibali",
// "This blog has no posts" => "This blog has no posts",
"Dynamic content" => "Maudhui yenye dynamic ",
"Admin FAQs" => "FAQs za Admin",
// "Non-existent gallery" => "Non-existent gallery",
"You do not have permission to view this gallery" => "Huna idhini ya kuona nyumba hii ya sanaa",
// "One item moved" => "One item moved",
// "%0 items moved" => "%0 items moved",
// "No items moved" => "No items moved",
// "One item moved and one item failed to move" => "One item moved and one item failed to move",
// "One item moved and %0 items failed to move" => "One item moved and %0 items failed to move",
// "%0 items moved and one item failed to move" => "%0 items moved and one item failed to move",
// "%0 items moved and %0 items failed to move" => "%0 items moved and %0 items failed to move",
// "One item deleted" => "One item deleted",
// "%0 items deleted" => "%0 items deleted",
// "No items deleted" => "No items deleted",
// "One item deleted and one item failed to delete" => "One item deleted and one item failed to delete",
// "One item deleted and %0 items failed to delete" => "One item deleted and %0 items failed to delete",
// "%0 items deleted and one item failed to delete" => "%0 items deleted and one item failed to delete",
// "%0 items moved and %0 items failed to delete" => "%0 items moved and %0 items failed to delete",
// "List view settings reset for one gallery" => "List view settings reset for one gallery",
// "List view settings reset for %0 galleries" => "List view settings reset for %0 galleries",
// "List view settings not changed for the selected gallery" => "List view settings not changed for the selected gallery",
// "List view settings not changed for the %0 selected galleries" => "List view settings not changed for the %0 selected galleries",
// "List view settings reset for %0 galleries and not changed for one gallery" => "List view settings reset for %0 galleries and not changed for one gallery",
// "List view settings reset for %0 galleries and not changed for %0 galleries" => "List view settings reset for %0 galleries and not changed for %0 galleries",
// "No files selected" => "No files selected",
// "Metadata refreshed for one file" => "Metadata refreshed for one file",
// "Metadata refreshed for %0 files" => "Metadata refreshed for %0 files",
// "Metadata not refreshed" => "Metadata not refreshed",
// "Metadata refreshed for one file and not refreshed for one file" => "Metadata refreshed for one file and not refreshed for one file",
// "Metadata refreshed for one file and not refreshed for %0 files" => "Metadata refreshed for one file and not refreshed for %0 files",
// "Metadata refreshed for %0 files and not refreshed for one file" => "Metadata refreshed for %0 files and not refreshed for one file",
// "Metadata refreshed for %0 files and not refreshed for %0 files" => "Metadata refreshed for %0 files and not refreshed for %0 files",
// "Incorrect file ID" => "Incorrect file ID",
"The file is already locked by %s" => "Faili tayari imefungwa na %s",
// "File unlocked" => "File unlocked",
// "File not unlocked" => "File not unlocked",
// "Files in this gallery are not lockable" => "Files in this gallery are not lockable",
"You don't have permission to validate files from this gallery" => "Ruhusa lilikataliwa, huwezi kuhalalisha faili kutoka nyumba ya sanaa hii",
// "Error retrieving file" => "Error retrieving file",
// "Draft validated" => "Draft validated",
// "Validation failed" => "Validation failed",
// "File deleted" => "File deleted",
// "File not deleted" => "File not deleted",
// "Metadata refreshed" => "Metadata refreshed",
// "You need upload permission to edit files" => "You need upload permission to edit files",
// "You need permission to create galleries to edit them" => "You need permission to create galleries to edit them",
// "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode" => "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Gallery %0 created or modified" => "Gallery %0 created or modified",
// "Gallery %0 not created or modified" => "Gallery %0 not created or modified",
"You do not have permission to duplicate this gallery" => "Huna ruhusa ya duplicate nyumba hii ya sanaa",
// "Gallery duplicated" => "Gallery duplicated",
// "Gallery not duplicated" => "Gallery not duplicated",
// "Remove file gallery %0" => "Remove file gallery %0",
// "Incorrect gallery ID" => "Incorrect gallery ID",
// "Gallery %0 deleted" => "Gallery %0 deleted",
// "Gallery %0 not deleted" => "Gallery %0 not deleted",
"Could not find the file requested" => "Haikuweza kupata faili iliyoombwa",
// "File %0 updated" => "File %0 updated",
// "File %0 not updated" => "File %0 not updated",
// "Invalid %0 parameter" => "Invalid %0 parameter",
"File %0 not found" => "Faili %0 halikupatikana",
// "User watch added" => "User watch added",
// "User watch not added" => "User watch not added",
// "User watch removed" => "User watch removed",
// "User watch not removed" => "User watch not removed",
"Not modified for" => "Haijabadilishwa kwa",
"Not downloaded for" => "Haikupakuliwa kwa",
// "This gallery does not exist" => "This gallery does not exist",
// "Error importing" => "Error importing",
"Error converting" => "Hitilafu wakati wa uongofu",
// "Importing" => "Importing",
"Processing" => "Usindikaji",
"Ready" => "Tayari",
// "Pending moderation" => "Pending moderation",
"Blocked" => "Bloqué",
"Invalid action" => "Hatua isiyo sahihi",
"Remove permission %0 from %1" => "Ondoa kibali %0 kutoka %1",
"Assign permission %0 to %1" => "Weka ruhusa %0 kwa %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
"Are you sure you want to permanently remove the submitted article with identifier %0" => "Una uhakika unataka kuondoa kabisa makala iliyowasilishwa na kitambulisho %0",
// "Are you sure you want to permanently remove these %0 submitted articles" => "Are you sure you want to permanently remove these %0 submitted articles",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to permanently remove all expired submitted articles" => "Are you sure you want to permanently remove all expired submitted articles",
// "Pages not in a structure" => "Pages not in a structure",
"You are neither an administrator nor an operator of live support" => "Wewe si msimamizi wala mtumiaji wa msaada wa kuishi",
"Username field cannot be empty. Please go back and try again" => "Eneo la mtumiaji haliwezi kuwa tupu. Tafadhali kurudi nyuma na jaribu tena",
"Unable to contact remote server." => "Haiwezi kuwasiliana na seva ya mbali.",
"XMLRPC Error: " => "Hitilafu ya XMLRPC: ",
"Unable to create login" => "Haiwezi kuunda mtumiaji",
"No groups set on Intertiki client" => "Hakuna vikundi vinavyowekwa kwenye mteja wa Intertiki",
"%d or more unsuccessful login attempts have been made" => "%d au majaribio mengi ya kufungua kuingia yamefanywa",
"Your account has been suspended" => "Akaunti yako imesimamishwa",
"Contact your site administrator to reactivate it" => "Wasiliana na tovuti msimamizi wako ili kuianzisha tena",
"An email has been sent to you with the instructions to follow." => "Barua pepe imetumwa kwako kwa maelekezo ya kufuata.",
"Account requires administrator approval" => "Akaunti walemavu",
"You did not validate your account" => "Huna kuthibitisha akaunti yako",
"Resend" => "Tuma tena",
"You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "Unapaswa kupokea barua pepe. Angalia kikasha cha barua na barua taka sanduku yako. Vinginevyo bonyeza kifungo kutuma tena barua pepe",
"You must use the right case for your username" => "Lazima uheshimu barua kubwa na za chini kwa jina lako la mtumiaji",
"You are not yet validated" => "Akaunti yako haijahalaliwa bado",
"You are already logged in" => "Tayari umeshikamana",
"Authentication error" => "Hitilafu ya uthibitishaji",
"The mail can't be sent. Contact the administrator" => "Barua haiwezi kutumwa. Wasiliana na msimamizi",
"There is more than one user account with this email. Please contact the administrator" => "Kuna akaunti zaidi ya moja ya mtumiaji na barua pepe hii. Tafadhali wasiliana na msimamizi",
"Your default nickname is already in use. A new one has to be selected." => "Jina lako la utani  tayari limetumika. Tafadhali chagua mwingine",
"Verification cancelled" => "Uhakiki kufutwa",
"The selected account is not associated with your identity" => "Akaunti iliyochaguliwa haihusiani na utambulisho wako",
// "unknown action" => "unknown action",
"Authentication method is not OpenID" => "Njia ya kuthibitisha sio OpenID",
"Authentication error; probably not a valid OpenID" => "Hitilafu ya uthibitishaji; pengine OpenID haihalali",
"Could not redirect to server: " => "Haikuweza kuelekeza kwenye seva: ",
"OpenID authentication failed: " => "Uthibitisho wa OpenID umeshindwa: ",
"You have already validated your account. Please log in" => "Tayari umehakikishia akaunti yako. Tafadhali ingia",
"No page provided" => "Hakuna ukurasa uliotolewa",
// "User module unassigned" => "User module unassigned",
// "User module not unassigned" => "User module not unassigned",
// "User module moved up" => "User module moved up",
// "User module not moved up" => "User module not moved up",
// "User module moved down" => "User module moved down",
// "User module not moved down" => "User module not moved down",
// "User module moved to opposite side" => "User module moved to opposite side",
// "User module not moved to opposite side" => "User module not moved to opposite side",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
"You must log in to use this feature" => "Lazima uandikishe kutumia kipengele hiki",
// "\$tikiMonitorRestriction need to be an array" => "\$tikiMonitorRestriction need to be an array",
"My Account Home" => "Nyumbani - Tiki yangu",
"You do not have permission to view other users data" => "Huna haki za kutazama data ya watumiaji wengine",
// "Subscription confirmed for newsletter %0 (%1)" => "Subscription confirmed for newsletter %0 (%1)",
// "Subscription request failed" => "Subscription request failed",
// "You have been unsubscribed from newsletter %0" => "You have been unsubscribed from newsletter %0",
// "Your request to unsubscribe failed" => "Your request to unsubscribe failed",
"You must be logged in to subscribe to newsletters" => "Lazima uingie ili uweze kujiunga na majarida",
// "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter" => "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter",
// "Newsletter not subscribed" => "Newsletter not subscribed",
"No note indicated" => "Hakuna maelezo yaliyoonyeshwa",
// "merged note" => "merged note",
"The file is too large" => "Faili ni kubwa mno",
"No item indicated" => "Hakuna kumbukumbu zilizoonyeshwa",
"Are you sure you want to delete this note" => "Una uhakika unataka kufuta kumbuka hii",
"created from notepad" => "iliundwa kutoka notepad",
// "Note not found" => "Note not found",
"No name indicated for wiki page" => "Hakuna jina lililoonyeshwa kwa ukurasa wa Wiki",
"Not enough information to display this page" => "Hakuna habari za kutosha za kuonyesha ukurasa huu",
"You do not have permission to assign permissions for this object" => "Huna haki za kugawa haki za kufikia kitu hiki",
"Are you sure you want to modify permissions" => "Una uhakika unataka kurekebisha ruhusa",
"%0 and all the children groups" => "%0 na makundi yote watoto",
"Are you sure you want to remove the direct permissions from this object" => "Una uhakika unataka kuondoa ruhusa za moja kwa moja za kitu hiki",
// "Are you sure you want to paste the copied permissions into this object" => "Are you sure you want to paste the copied permissions into this object",
"Error while processing payment: " => "Hitilafu wakati wa usindikaji malipo: ",
"Payment has been confirmed" => "Malipo alithibitisha",
"Payment confirmation has not been received yet" => "Uthibitisho wa malipo bado haujapokelewa",
"Manual payment entered" => "Malipo ya Mwongozo imeingia",
"You do not have permission to enter payment" => "Huna haki za kuingia malipo",
"New payment requested" => "Malipo mapya yanahitajika",
"Cancel payment %0" => "Futa malipo %0",
"Payment canceled" => "Malipo yamefutwa",
"You need permission to edit pages in order to experiment on plugin LIST" => "Unahitaji ruhusa ya kuhariri kurasa ili ujaribu kwenye orodha ya Plugins",
"No preference given" => "Hakuna upendeleo uliotolewa",
"This preference is not translatable" => "Upendeleo huu hauwezi kutafsiriwa",
// "No article indicated" => "No article indicated",
"Article is not published yet" => "Makala hii haijachapishwa bado",
"No post indicated" => "Hakuna chapisho kilichoonyeshwa",
"Blog not found" => "Blogu haipatikani",
// "Missing object list type argument" => "Missing object list type argument",
"Index (%0)" => "Index (%0)",
"No pages indicated" => "Hakuna ukurasa unaonyeshwa",
"Multiple Print" => "Chapisha Nyingi",
"Pageviews" => "Kuonyesha ukurasa",
"No result indicated" => "Hakuna matokeo yaliyoonyeshwa",
"Invalid or unknown username" => "Jina la mtumiaji batili au haijulikani",
"Unable to send mail. User has not configured email" => "Haikuweza kutuma barua pepe Mtumiaji hajasanidi anwani yao ya barua pepe",
"Invalid or unknown email address" => "Anwani isiyo sahihi au isiyojulikana ya barua pepe",
"Please provide a username or email address" => "Tafadhali toa jina la mtumiaji au anwani ya barua pepe",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Tafadhali wasiliana na Msimamizi wa Site kama huna kupata barua pepe, au ikiwa kuna tatizo la kuweka upya nenosiri",
"An email with a link to reset your password has been sent " => "Barua pepe yenye kiungo ili kuweka upya nenosiri lako imetumwa ",
"to the email" => "kwa barua pepe",
"to the registered email address for" => "kwa barua pepe iliyosajiliwa ya",
"Rename wiki page" => "Badilisha jina Wiki ukurasa",
// "Page renamed from %0 to %1. Semantic alias redirect created" => "Page renamed from %0 to %1. Semantic alias redirect created",
// "Are you sure you want to roll back \"%0\" to version #%1" => "Are you sure you want to roll back \"%0\" to version #%1",
// "Non-existent version" => "Non-existent version",
// "Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Error Message: %0",
"This match was not case sensitive" => "Mechi hii haikuwa nyeti ya kesi",
"No items selected" => "Hakuna vitu vichaguliwa",
"Page cannot be found: " => "Ukurasa haupatikani: ",
"Page has changed since preview: " => "Ukurasa umebadilishwa tangu hakikisho: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
"Search Stats" => "Takwimu za Utafiti",
"%0: Results for \"%1\"" => "%0: Matokeo kwa \"%1\"",
"Your query was stored" => "Swali lako lilihifadhiwa",
// "Searchindex" => "Searchindex",
"A problem occurred during file uploading" => "Kulikuwa na tatizo kupakia data",
// "File causing trouble was at rank" => "File causing trouble was at rank",
"The error was %0" => "Hitilafu ilikuwa %0",
// "Error: You can't send the same newsletter by refreshing this frame content" => "Error: You can't send the same newsletter by refreshing this frame content",
"No newsletters available." => "Hakuna majarida ya kutosha.",
"Cannot login to server maybe the server is down" => "Haiwezi kuunganisha kwenye seva, Labda seva haipatikani",
// "successfully sent" => "successfully sent",
"not sent" => "hakutumwa",
"Error: " => "Hitilafu : ",
"Send Pages" => "Tuma kurasa",
"Notice: this variable may not be empty" => "Angalia: hii variable aiwezi kuwa tupu",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Token called" => "Token called",
"Error sending tweet" => "Hitilafu ya kutuma tweet",
"Your link was sent" => "Kiungo chako kilipelekwa",
"One of the email addresses that was input is invalid" => "Moja ya anwani za barua pepe zilizotolewa ni batili",
"Your email is mandatory" => "Barua yako inahitajika",
"Error sending mail to" => "Hitilafu kutuma barua pepe kwa",
"Share page" => "Shiriki ukurasa",
// "No text given for tweet" => "No text given for tweet",
"You don't have permission to post in this forum" => "Huna ruhusa ya kuchapisha kwenye jukwaa hili",
"Spreadsheet - " => "Lahajedwali - ",
"Are you sure you want to delete this spreadsheet" => "Una uhakika unataka kufuta sahajedwali hii",
// "URL provided is empty or unsupported" => "URL provided is empty or unsupported",
"Unable to generate a short url for the requested resource" => "Haiwezi kuzalisha url fupi kwa rasilimali iliyoombwa",
// "'%0' short url" => "'%0' short url",
"You do not have permission to edit messages %0" => "Huna ruhusa ya kuhariri ujumbe %0",
// "Sitemap file not available" => "Sitemap file not available",
// "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator" => "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator",
// "Exporting slideshow as PDF requires a working installation of mPDF" => "Exporting slideshow as PDF requires a working installation of mPDF",
"Export to PDF error: %0" => "Tuma kwa kosa la PDF: %0",
"Permission denied. You cannot view this page" => "Ruhusa imekataliwa. Huwezi kuona ukurasa huu",
"Email is mandatory" => "Barua pepe ni lazima",
"Username and email are mandatory" => "Jina la mtumiaji na anwani ya barua pepe zinahitajika",
"The email address is invalid" => "Anwani ya barua pepe ni batili",
"Clean the sql logs" => "Safi magogo ya SQL",
"Are you sure you want to clear all statistics and data for this survey" => "Una uhakika unataka kufuta takwimu zote kutoka kwenye utafiti huu?",
// "The following list of changes has been reverted" => "The following list of changes has been reverted",
// "Log already reverted" => "Log already reverted",
// "Invalid System Log ID" => "Invalid System Log ID",
// "You cannot take this quiz twice" => "You cannot take this quiz twice",
// "The quiz time limit was exceeded. The quiz score cannot be computed" => "The quiz time limit was exceeded. The quiz score cannot be computed",
"You cannot take this survey twice" => "Huwezi kujibu utafiti huu mara mbili",
// "Please create a category first" => "Please create a category first",
// "Committing.." => "Committing..",
// "Could not save" => "Could not save",
// "No trackerId specified" => "No trackerId specified",
// "Incorrect file gallery" => "Incorrect file gallery",
"You must lock the file before editing it" => "Lazima ufunge faili kabla ya kuhariri",
// "Error processing zipped image package" => "Error processing zipped image package",
// "No permission to upload zipped image packages" => "No permission to upload zipped image packages",
"The uploaded file is not recognized as a image" => "Faili ya kwanza tumwa siyo picha",
"You do not have permission to upload images" => "Huna haki za kutuma picha",
"You have permission to upload images but not to this gallery" => "Haki ya kufikia imekataliwa: unaweza kutuma picha, lakini sio kwenye nyumba hii ya sanaa",
"Cannot get image from URL" => "Haiwezi kupata picha kutoka kwenye anwani hii ya wavuti",
"That is not an image (or you have php < 4.0.5)" => "Hii sio picha (au toleo lako php < 4.0.5)",
"Usage" => "matumizi",
// "Default user modules restored" => "Default user modules restored",
// "Default user modules not restored" => "Default user modules not restored",
// "User module assigned" => "User module assigned",
// "User module not assigned" => "User module not assigned",
// "User module display order moved up. Displayed order may not change if other modules now have the same order rank" => "User module display order moved up. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved up" => "User module display order not moved up",
// "User module display order moved down. Displayed order may not change if other modules now have the same order rank" => "User module display order moved down. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved down" => "User module display order not moved down",
// "User module moved to left column" => "User module moved to left column",
// "User module not moved to left column" => "User module not moved to left column",
// "User module moved to right column" => "User module moved to right column",
// "User module not moved to right column" => "User module not moved to right column",
// "TOP" => "TOP",
"No URL indicated" => "Hakuna URL iliyoonyeshwa",
"ERROR: Either the subject or body must be non-empty" => "ERROR: Somo na mwili hauwezi kuwa tupu wakati mmoja",
// "Unknown user" => "Unknown user",
// "Added new structure route" => "Added new structure route",
// "Deleted structure route" => "Deleted structure route",
// "Updated structure route" => "Updated structure route",
// "Notification preferences set" => "Notification preferences set",
// "Errors were encountered when setting notification preferences" => "Errors were encountered when setting notification preferences",
"Email is set to %s" => "Anwani ya barua pepe imebadilishwa %s",
"Password has been changed" => "Nenosiri limebadilishwa",
"Invalid password. Your current password is required to change administrative information" => "Nywila isiyo sahihi. Nywila yako ya sasa inahitajika ili kubadilisha mipangilio yako ya utawala",
"The passwords did not match" => "Nywila hazilingani",
"If you really want to delete your account, you must check the checkbox" => "Ikiwa unataka kufuta akaunti yako, lazima uangalie sanduku.",
// "User report preferences saved" => "User report preferences saved",
// "User report preferences not saved" => "User report preferences not saved",
// "User reports disabled" => "User reports disabled",
// "User report not disabled" => "User report not disabled",
"was moved to the trash" => "ilihamishwa kwenye takataka",
"was moved to the trash by" => "kuweka katika takataka na",
// "open / in process" => "open / in process",
"Rights by creator" => "Haki za muumbaji",
"END" => "MWISHO",
"Percentage" => "Asilimia",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
"Sorry, this task does not exist or you don't have permission to view this task" => "Samahani, kazi hii haipo au huna haki za kuiangalia",
"Task entries" => "Maelezo ya kazi",
"Changes" => "mabadiliko",
"Info message" => "Ujumbe wa habari",
"NEW Task" => "Kazi mpya",
"Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks!" => "Samahani, huwezi kutuma kazi kwa mtumiaji mwingine, au mtumiaji hawana haki za kupokea kazi",
"Changes on Task" => "Mabadiliko kwenye Kazi",
"You received a new task" => "Umepokea kazi mpya",
"The priority is" => "Kipaumbele ni",
"very low" => "chini sana",
"high" => "juu",
"very high" => "juu sana",
"You must start your work at least on" => "Lazima uanze kazi yako angalau juu",
"You must finish your work on" => "Lazima kumaliza kazi yako",
"Log in and click the link below" => "Ingia na bonyeza kiungo chini",
"Please read the task and work on it!" => "Tafadhali soma kazi hiyo na uifanye kazi!",
"Sorry, there was an error while trying to write data into the database" => "Samahani, kuna hitilafu kuhifadhi data katika database",
// "Unsubscribe from user watch email notifications" => "Unsubscribe from user watch email notifications",
// "Unsubscribed from user watch email notification" => "Unsubscribed from user watch email notification",
// "Unsubscribe failed" => "Unsubscribe failed",
// "Unknown watch type" => "Unknown watch type",
"Language watch" => "Tazama lugha",
"Category watch: %0, Language: %1" => "Tazama Jamii : %0, Lugha: %1",
// "User watch deleted" => "User watch deleted",
// "User watch not deleted" => "User watch not deleted",
"Cannot upload this file. The storage quota would be exceeded" => "Haiwezi kupakia faili hii. mgao wa kuhifadhi itakuwa ulizidi",
"No user indicated" => "Hakuna mtumiaji aliyeonyeshwa",
"Non-existent user" => "Utilisateur inexistant",
"No banner indicated" => "Aucune bannière indiquée",
"No blog indicated" => "Hakuna blogu iliyoonyeshwa",
"Post not found" => "Publication non trouvée",
"You do not have permission to view this blog post while it is marked as private" => "Huna haki za kuona chapisho hili kwa sababu linawekwa kama faragha",
"No cache information available" => "Hakuna habari ya cache inapatikana",
"You must suggest a question; please try again" => "Lazima uwasilishe swali Tafadhali jaribu tena",
"No FAQ indicated" => "Hakuna Maswali yaliyoonyeshwa",
"Are you sure you want to remove that attachment" => "Una uhakika unataka kuondoa kiambatisho hicho",
"Are you sure you want to remove that topic" => "Una uhakika unataka kuondoa mada hiyo",
"You do not have permission to remove someone else's post!" => "Huruhusiwi kufuta posts za mtu mwingine!",
"Incorrect thread" => "Fimbo isiyo sahihi",
// "Thread %0 does not exist" => "Thread %0 does not exist",
"No thread indicated" => "Aucun fil de discussion indiqué",
"Files are read only at this time" => "Faili zinasoma peke yake wakati huu",
"Are you sure you want to clone this spreadsheet" => "Je! Una uhakika unataka kurudia lahajedwali hili",
"Clone Error" => "Hitilafu ya Clone",
"Are you sure you want to roll back this spreadsheet" => "Una uhakika unataka kurejesha lahajedwali hili",
"Rollback Error" => "Erreur lors du retour arrière",
"Tracker Added To Spreadsheet" => "Tracker Aliongeza kwenye Lahajedwali",
"Tracker Removed From Spreadsheet" => "Tracker Iliondolewa Kutoka Lahajedwali",
"Spreadsheet added" => "Lahajedwali imeongezwa",
"Spreadsheet removed" => "Lahajedwali limeondolewa",
"File removed" => "Faili iliyofutwa ",
// "Spreadsheet truncated" => "Spreadsheet truncated",
"Create or view tracker" => "Unda au utazama tracker ",
// "Admin this tracker" => "Admin this tracker",
"Are you sure you want to delete the selected items" => "Una uhakika unataka kufuta vitu vichaguliwa",
// "Create tracker item" => "Create tracker item",
// "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission" => "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission",
"Are you sure you want to permanently delete this item" => "Una uhakika unataka kufuta kabisa kipengee hiki",
"Are you sure you want to remove this attachment" => "Una uhakika unataka kuondoa kiambatisho hiki?",
"Edit/Delete" => "Badilisha / Ondoa",
"You don't have a personal tracker item yet. Click here to make one" => "Hujahifadhi kadi katika fomu yako binafsi. Bofya hapa ili kuunda moja",
// "That tracker does not use extras" => "That tracker does not use extras",
"Address book" => "Kitabu cha anwani",
"Top pages" => "Kurasa maarufu zaidi",
"Last pages" => "Kurasa za mwisho",
// "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace" => "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace",
);
